         TITLE 'AHLMCER - MONITOR CALL EVENT ROUTER                    *
                       '
MCACTIV  EQU   X'80'                   /* BIT MCHACT IN MCHEAD MAP   */
NOTACTIV EQU   8                       /* CC IF ROUTING IS NOT ACTIV */
MCREG    EQU   8                       /* CONTROL REGISTER 8         */
MCINT    EQU   X'40'                   /* MONITOR CALL PI CODE       */
MCINCNTL EQU   X'80'                   /* RECURSION INDICATOR        */
INCTL    EQU   X'40'                   /* APPLICATION IN CTL INDIC.  */
BRNCHENT EQU   X'10'                   /* AHLMCIH WAS ENTERED VIA THE
*                                       NON-PFLIH ENTRY PT, AHLMCIHB */
*   DO;                             /* SETEVENT                    0055
*                                      MF(L,SETLST,DEFINED(MCAWORK)) */
*                                                                  0055
*     /***************************************************************/
*     /*                                                             */
*     /* THE FOLLOWING SECTION OF CODE IS GENERATED BY THE SETEVENT  */
*     /* MACRO. THIS CODE WILL BE EITHER AN INITIALIZED PARAMETER    */
*     /* LIST, OR IF IT IS THE RESULT OF STANDARD OR EXECUTE FORM IT */
*     /* WILL FILL in the list, GENERATE ALL LINKAGES AND CALL THE   */
*     /* PROPER sERVICE, EITHER AHLSETEV OR AHLSETD                  */
*     /*                                                             */
*     /***************************************************************/
*                                                                  0056
*     DCL                                                          0056
*       1 SETLST DEFINED(MCAWORK),  /* PLIST FOR SETEVENT            */
*        2 SETLST01 PTR(8),         /* ACTION FLAGS                  */
*        2 * PTR(8),                                               0056
*        2 SETLST02 PTR(8),         /* EID COUNT                     */
*        2 SETLST03 PTR(8),         /* CLASS COUNT                   */
*        2 SETLST04 CHAR(8),        /* APPLICATION NAME              */
*        2 SETLST05 PTR(31),        /* EID LIST ADDRESS              */
*        2 SETLST06 PTR(31),        /* CLASS LIST ADDRESS            */
*        2 SETLST07 PTR(31);        /* MCQE ADDRESS                  */
*   END;                                                           0057
*   GEN(EJECT);                                                    0058
*                                                                  0058
         EJECT
*   /*****************************************************************/
*   /*                                                               */
*   /* THE FOLLOWING ADCONS ARE USED BY IEAVNP17 TO INITIALIZE THE   */
*   /* MCHEAD.                                                       */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0059
*   GENERATE;                                                      0059
AHLMCER  CSECT
         DC    A(AHLMCER1)
         DC    A(AHLMCFRR)
***********************************************************************
*                                                                     *
*     THE REGISTER CONTENTS FROM AHLMCIH ARE AS FOLLOWS:              *
*          MCERBASE (R12) CONTAINS THE ENTRY POINT ADDRESS, AHLMCER1  *
*          HEADREG (R11) CONTAINS THE ADDRESS OF THE MCHEAD           *
*          MCRWSAPT R(13) CONTAINS THE ADDRESS OF THE MCRWSA          *
*                                                                     *
***********************************************************************
         USING AHLMCER1,MCERBASE
***********************************************************************
*                                                                     *
*   CONTROL IS RECEIVED AT THE FOLLOWING EP FROM AHLMCIH.  THE        *
*   CURRENT EVENT IDENTIFIER (EID) IS GATHERED FROM THE HDWR          *
*   LOCATIONS INTO THE MCRWSA AND THE USE COUNT IN THE MCHEAD IS      *
*   INCREMENTED BY CDS LOGIC.  THE CDS ALSO VERIFIES                  *
*   THE CURRENT MCCE ADDRESS FOR USE BY AHLMCER.                      *
*                                                                     *
***********************************************************************
AHLMCER1 PACK  MCREID(1,MCRWSAPT),FLCMCNUM  /* GET CLASS FROM FLC    */
         MVN   MCREID(1,MCRWSAPT),FLCMTRCD+1    MOVE 2ND DIGIT OF CXXX
         MVC   MCREID+1(1,MCRWSAPT),FLCMTRCD+2  MOVE 3RD AND 4TH DIGIT
         LM    WORK1,WORK2,MCHCUR(HEADREG) /* LOAD THE CURRENT MCCE
*                                         ADDRESS AND USE COUNT      */
AHLCSD1  LR    MCCEAD,WORK1            /* MOVE FOR COMPARE AND SWAP  */
         LR    USECOUNT,WORK2          /* DITTO                      */
         LA    USECOUNT,1(USECOUNT)    /* INCREMENT USE COUNT        */
         CDS   WORK1,MCCEAD,MCHCUR(HEADREG) /* STORE NEW USE COUNT   */
         BC    7,AHLCSD1               /* IF EITHER ADDRESS OR USE
*                                         COUNT HAS CHANGED, REDO
*                                         ARITHMETIC                 */
         LTR   MCCEAD,MCCEAD           /* Q. IS MCCE ADDR = ZERO     */
         BE    AHLXIT1                 /* IF SO, NOTHING TO DO - EXIT*/
***********************************************************************
*                                                                     *
*   SAVE MCCE ADDRESS FOR USE DURING ERROR RECOVERY            @YM03668
*                                                                     *
***********************************************************************
         ST    MCCEAD,MCCESAV(0,MCRWSAPT) SAVE ADDR IN MCRWSA  @YM03368
***********************************************************************
*                                                                     *
*   CHECK FOR THE EXISTENCE OF AN EVENT DIRECTORY, THEN USE THE       *
*   PBINT SRCH FACILITY TO LOCATE THE APPLICABLE MCEE FOR THIS        *
*   EVENT.  IF THE EID IN THE LOCATED MCEE MATCHES THE CURRENT        *
*   EID, CALL CALLFGBR TO ROUTE THE EVENT TO THE APPLICABLE           *
*   ROUTINES.                                                         *
*                                                                     *
***********************************************************************
         L      MCDA,MCCEEDA(MCCEAD)   /* LOAD EVENT DIRECTORY ADDR  */
         LTR   MCDA,MCDA               /* Q. IS THERE ONE            */
         BE    AHLCLASS                /* IF NOT, PROCESS CLASSES    */
         SRCH (MCDA),SARG=MCREID(MCRWSAPT),TYPE=5,KEYL=2  USE SRCH TO
*                                      LOCATE APPLICABLE EVENT ELEMENT,
*                                      THE ADDRESS OF WHICH WILL BE
*                                      RETURNED IN REGISTER 15       */
         LTR   TEMPPTR,TEMPPTR         /* IS MCED EMPTY              */
         BNP   AHLCLASS                /* IF SO, GO PROCESS CLASSES  */
         CLC   MCEEEID(2,TEMPPTR),MCREID(MCRWSAPT) /* Q. DOES EID IN
*                                                  FOUND MCEE MATCH
*                                                  CURRENT EVENT     */
         BNE   AHLCLASS                /* IF NOT, PROCESS CLASSES    */
         LR    ELEMAD,TEMPPTR          /* MOVE MCEE ADDR TO PERMANENT
*                                         LOCATION                   */
         BAL   RETURNER,CALLFGBR       /* GO TO SUBROUTINE TO CALL
*                                         APPLICATION REQUESTING EVENT
***********************************************************************
*                                                                     *
*   CHECK FOR THE EXISTENCE OF A CLASS DIRECTORY, THEN CONVERT THE    *
*   CURRENT CLASS INTO AN INDEX TO SEE IF THERE ARE ANY MCCLES TO     *
*   RECEIVE THIS CLASS.  IF SO, CALL CALLFGBR TO PASS CONTROL TO      *
*   ALL ROUTINES REFLECTED IN ALL MCCLES ON THE CHAIN.                *
*                                                                     *
***********************************************************************
AHLCLASS L     MCDA,MCCECDA(MCCEAD)    /* LOAD CLASS DIRECTORY ADDR  */
         LTR   MCDA,MCDA               /* Q. IS MCCD ADDR ZERO       */
         BE    AHLXIT1                 /* IF SO, EXIT FROM AHLMCIH   */
         SR    WORK2,WORK2             /* CLEAR BEFORE INSERT        */
         IC    WORK2,FLCMCNUM          /* PICK UP CLASS OF MC        */
         SLL   WORK2,2                 /* USE AS INDEX INTO MCCD     */
         L     ELEMAD,MCCDCLE(WORK2,MCDA) /* LOAD MCCLE ADDR        */
         LTR   ELEMAD,ELEMAD           /* Q. DOES MCCD EXIST         */
         BE    AHLXIT1                 /* IF NOT, EXIT FROM AHLMCIH  */
         BAL   RETURNER,CALLFGBR       /* GO TO CALL APPLICATION(S)  */
*   GENERATE;                                                      0060
***********************************************************************
*                                                                     *
* /*EXIT CODE.  THE USE COUNT IN THE MCHEAD IS DECREMENTED BY ONE TO  *
*   INDICATE THAT WE ARE DONE USING IT.  IF THE MCCE ADDRESS IN THE   *
*   MCHEAD HAS CHANGED FROM THE ONE THAT WAS USED DURING AHLMCER      *
*   THE USE COUNT IN THE OLD MCCE (THE ONE THAT AHLMCER USED) IS      *
*   DECREMENTED BY ONE.  IF THIS USE COUNT GOES TO ZERO, THE SRB IN   *
*   THE OLD MCCE IS SCHEDULED SO THAT TABLES MAY BE FREED.  ALL       *
*   DECREMENTING IS DONE VIA CDS AND CS LOGIC.                        *
*                                                                     *
*   THE FRR IS THEN REMOVED, THE RECURSION FLAG RESET, THE REGISTERS  *
*   RELOADED, AND CONTROL IS RETURNED TO THE CALLER.  NOTE THAT THE   *
*   RETURN IS MADE TO THE CALLER OF AHLMCIH, AND NOT TO AHLMCIH.*/    *
*                                                                     *
***********************************************************************
AHLXIT1  L     WORK2,MCHCNT(HEADREG)   /* LOAD USE COUNT FROM MCHEAD */
         LR    WORK1,MCCEAD            /* CREATE BACKUP FOR MCCE @   */
AHLCSD2  LR    USECOUNT,WORK2          /* CREATE COPY OF USE COUNT   */
         BCTR  USECOUNT,0              /* DECREMENT USE COUNT BY 1   */
         CDS   WORK1,MCCEAD,MCHCUR(HEADREG) /* DECREMENT COUNT AND
*                                         VERIFY MCCE ADDRESS        */
         BC    8,AHLXIT2               /* IF SUCCESSFUL, EXIT        */
         CR    WORK1,MCCEAD            /* Q. DID TABLE ADDR CHANGE   */
         BE    AHLCSD2                 /* IF NOT, REDO TO SET CORRECT
*                                         COUNT                      */
         LTR   MCCEAD,MCCEAD           /* Q. WAS OLD ONE ZERO        */
         BE    AHLXIT2                 /* IF SO, EXIT                */
         L     WORK2,MCCECNT(MCCEAD)   /* LOAD USE COUNT FROM MCCE   */
AHLCSD3  LR    USECOUNT,WORK2          /* CREATE COPY OF COUNT       */
         BCTR  USECOUNT,0              /* DECREMENT BY 1             */
         CS    WORK2,USECOUNT,MCCECNT(MCCEAD) /* PLACE IN MCCE       */
         BC    7,AHLCSD3               /* IF DIDNT GO, REDO UNTIL OK */
         LTR   USECOUNT,USECOUNT       /* Q. DID COUNT BECOME ZERO   */
         BNE   AHLXIT2                 /* IF NOT, EXIT               */
         LA    SRBREG,MCCESRB(MCCEAD)  /* SRB ADDR TO REG 1          */
         SCHEDULE SRB=(1)         /* SCHEDULE SRB TO FREE TABLES*/
AHLXIT2  SETFRR D,WRKREGS=(WORK1,WORK2) REMOVE ERROR RECOVERY
AHLXIT3  NI    MCRWSAF(MCRWSAPT),X'FF'-MCINCNTL-BRNCHENT /*RESET FLGS*/
AHLXIT4  LM    MCQEAD,RETURNAD,MCRMCIH(MCRWSAPT) /* RESTORE REGS     */
         BR    RETURNAD                /* RETURN TO CALLER           */
         EJECT
*   GENERATE;                                                      0061
***********************************************************************
*                                                                     *
* /*THE FOLLOWING SUBROUTINE PASSES CONTROL TO EACH ROUTINE REFLECTED *
*   IN THE MCEE/MCCLES ASSOCIATED WITH THE EVENT UNDER CONSIDERATION. *
*   IT IS PASSED (IN ELEMAD) THE ADDRESS OF THE FIRST MCEE/MCCLE ON   *
*   THE CHAIN ASSOCIATED WITH THE CURRENT EVENT.  IT LOADS THE        *
*   REQUIRED DATA INTO THE REGISTERS, THEN SAVES ALL REGISTERS IN     *
*   MCROUTSA BEFORE BRANCHING TO THE PROPER ROUTINE.  ON RETURN       *
*   FROM THE ROUTINES, THE REGISTERS ARE RELOADED, AND THE NEXT       *
*   MCEE/MCCLE ON THE CHAIN IS USED TO ROUTE THE EVENT.  THIS         *
*   PROCESSING CONTINUES UNTIL THE END OF THE MCEE/MCCLE CHAIN        *
*   IS REACHED, AT WHICH TIME RETURN IS MADE TO THE MAINLINE. */      *
*                                                                     *
***********************************************************************
CALLFGBR L     MCAPTR,MCRMCA(MCRWSAPT) /* LOAD PTR TO APPLICATION WORK
*                                         SAVE AREA                  */
AHLCALNX LM    APPLCRTN,MCQEAD,MCEERTN(ELEMAD) /* LOAD ROUTINE AND
*                                         MCQE ADDRESS FROM ELEMENT  */
         LR    TMPMCQE,MCQEAD          /* MOVE MCQE TO USABLE REG    */
         L     APPTAB,MCQEAT(TMPMCQE)  /* LOAD APPLICATION TABLE
*                                         ADDRESS FROM MCQE          */
         STM   MCQEAD,APPLCRTN,MCROUTSA(MCRWSAPT) /* SAVE ALL REGS   */
         OI    MCRWSAF(MCRWSAPT),INCTL /* INDICATE APPLICATION IN
*                                         CONTROL - THIS FLAG IS USED
*                                         FOR ERROR RECOVERY         */
         BALR  RETURNAD,APPLCRTN       /* CALL INDICATED APPLICATION */
***********************************************************************
*                                                                     *
* /* RETURN FROM THE CALLED ROUTINE IS MADE TO THE FOLLOWING          *
*    INSTRUCTION.  THE REGISTER SAVE AREA IS RELOCATED, AND           *
*    THE REGISTERS ARE RELOADED BEFORE CALLING THE NEXT ROUTINE.*/    *
*                                                                     *
***********************************************************************
AHLRELOD L     MCRWSAPT,PSALCCAV       /* LOAD LCCA ADDR             */
         L     MCRWSAPT,LCCACPUS(MCRWSAPT) /* LOAD WSAVT ADDR        */
         L     MCRWSAPT,WSACGTF(MCRWSAPT) /* LOAD MCRWSA ADDR        */
         LM    MCQEAD,APPLCRTN,MCROUTSA(MCRWSAPT) /* RELOAD REGS     */
         NI    MCRWSAF(MCRWSAPT),X'FF'-INCTL /* TURN OFF IN-APPLICATION
*                                             INDICATOR              */
         L     ELEMAD,MCEEEIDL(ELEMAD) /* LOAD NEXT ELEMENT TO GET
*                                         CONTROL ON THIS EVENT      */
         LTR   ELEMAD,ELEMAD           /* Q. ANY MORE FOR THIS EVENT */
         BNZ   AHLCALNX                /* IF SO, CALL NEXT APPLICATION
*                                         ROUTINE                    */
         BR    RETURNER                /* IF NOT, RETURN FROM SUBROUT*/
         EJECT
*AHLMCFRR:                                                         0062
*                                                                  0062
*   /*****************************************************************/
*   /*                                                               */
*   /* ERROR RECOVERY CODE, ENTERED FROM RTM. ADDRESSIBILITY IS SET  */
*   /* UP, AND THE RTCA AND RETURN ADDRESSES ARE SAVED IN            */
*   /* NON-VOLATILE REGISTERS                                        */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0062
*   GENERATE;                                                      0062
AHLMCFRR DS    0H                                                  0062
         USING AHLMCFRR,TEMPPTR        /* TEMPORARY ADDRESSIBILITY   */
         DROP  MCERBASE
         L     MCERBASE,MCERORG        /* LOAD BASE FROM DC          */
         USING AHLMCER1,MCERBASE       /* TELL ASSEMBLER             */
         DROP  TEMPPTR
*   RESPECIFY                                                      0063
*    (SDWAPTR,                                                     0063
*     SDWAAD,                                                      0063
*     RETURNAD,                                                    0063
*     RTMADDR,                                                     0063
*     RETRYAD,                                                     0063
*     MCRWSAPT)RSTD;                                               0063
*   SDWAPTR=SDWAAD;                 /* SAVE RTCA ADDRESS             */
         LR    SDWAPTR,SDWAAD                                      0064
*   RTMADDR=RETURNAD;               /* SAVE RETURN ADDRESS           */
         LR    RTMADDR,RETURNAD                                    0065
*   DO;                             /* SETRP DUMP(NO) WKAREA(SDWAPTR)
*                                      RECPARM(MCERID)               */
*     RESPECIFY                                                    0067
*      (GPR00P,                                                    0067
*       GPR01P,                                                    0067
*       GPR14P,                                                    0067
*       GPR15P)RSTD;                                               0067
*     GPR01P=SDWAPTR;                                              0068
         LR    GPR01P,SDWAPTR                                      0068
*     GPR01P->SDWARCDE=0;           /* SAVE RC VALUE                 */
         MVI   SDWARCDE(GPR01P),X'00'                              0069
*     GPR15P=ADDR(MCERID);          /* ACCESS RECORD PARAMETER LIST  */
         LA    GPR15P,MCERID                                       0070
*     GPR01P->SDWARECP=GPR15P->I256C(1:24);/* COPY RECORD PARAMETERS */
         MVC   SDWARECP(24,GPR01P),I256C(GPR15P)                   0071
*     GPR01P->SDWAREQ='0'B;         /* TURN OFF DUMP INDICATOR       */
         NI    SDWAREQ(GPR01P),B'01111111'                         0072
*     RESPECIFY                                                    0073
*      (GPR00P,                                                    0073
*       GPR01P,                                                    0073
*       GPR14P,                                                    0073
*       GPR15P)UNRSTD;                                             0073
*   END;                                                           0074
*                                                                  0075
*   /*****************************************************************/
*   /*                                                               */
*   /* THE FOLLOWING CODE CHECKS FOR AND HANDLES IF APPLICABLE ENTRY */
*   /* DUE TO ACR. IF THIS IS THE CASE, A RETRY IS SCHEDULED TO THE  */
*   /* INTERRUPTED ADDRESS, IGNORING THE ERROR                       */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0075
*   IF SDWAINSF='1'B&SDWAREGU='0'B&SDWAPSWU='0'B THEN              0075
         TM    SDWAINSF(SDWAPTR),B'00000100'                       0075
         BNO   @RF00075                                            0075
         TM    SDWAREGU(SDWAPTR),B'01100000'                       0075
         BNZ   @RF00075                                            0075
*     DO;                                                          0076
*       RETRYAD=SDWANXTP;           /* SET RETRY TO INTER. ADDR      */
         SR    RETRYAD,RETRYAD                                     0077
         ICM   RETRYAD,7,SDWANXTP(SDWAPTR)                         0077
*       DO;                         /* SETRP RETADDR(RETRYADR)     0078
*                                      RC(SDWARETY) RETREGS(YES)   0078
*                                      WKAREA(SDWAPTR)               */
*         RESPECIFY                                                0079
*          (GPR00P,                                                0079
*           GPR01P,                                                0079
*           GPR14P,                                                0079
*           GPR15P)RSTD;                                           0079
*         GPR01P=SDWAPTR;                                          0080
         LR    GPR01P,SDWAPTR                                      0080
*         GPR01P->SDWARCDE=SDWARETY;/* STORE RC INTO SDWA            */
         MVI   SDWARCDE(GPR01P),X'04'                              0081
*         GPR01P->SDWARTYA=ADDR(RETRYADR);/* SAVE RETRY ADDRESS      */
         ST    RETRYAD,SDWARTYA(,GPR01P)                           0082
*         GPR01P->SDWAUPRG='1'B;    /* TURN ON RETREGS INDICATOR     */
         OI    SDWAUPRG(GPR01P),B'00001000'                        0083
*         RESPECIFY                                                0084
*          (GPR00P,                                                0084
*           GPR01P,                                                0084
*           GPR14P,                                                0084
*           GPR15P)UNRSTD;                                         0084
*       END;                        /* SET UP FOR RETRY              */
*       GO TO RTM;                  /* RETURN TO RTM - CONTINE       */
         BR    RTMADDR                                             0086
*     END;                                                         0087
*                                                                  0088
*   /*****************************************************************/
*   /*                                                               */
*   /* SETUP FOR RETRY ROUTINES BY REFRESHING THE BASE REGISTER, THE */
*   /* POINTER TO MCRWSA, AND THE MCHEAD ADDRESS, IN THE REGISTERS IN*/
*   /* THE RTCA THAT ARE PASSED TO THE RETRY ROUTINE                 */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0088
*   SDWASR12=MCERORG;               /* RESET BASE REG FOR RETRIES    */
@RF00075 MVC   SDWASR12(4,SDWAPTR),MCERORG                         0088
*   MCRWSAPT=ADDR(MCRWSA);          /* ESTABLISH MCRWSA ADDR         */
         L     @15,LCCAPTR                                         0089
         L     @15,LCCACPUS(,@15)                                  0089
         L     MCRWSAPT,WSACGTF(,@15)                              0089
*   RESPECIFY                                                      0090
*     MCRWSA BASED(MCRWSAPT);                                      0090
*   SDWASR13=MCRWSAPT;              /* REFRESH SAVEAREA PTR          */
         ST    MCRWSAPT,SDWASR13(,SDWAPTR)                         0091
*   SDWASR11=CVTGTF;                /* REFRESH MCHEAD ADDRESS        */
         L     @15,CVTPTR                                          0092
         MVC   SDWASR11(4,SDWAPTR),CVTGTF(@15)                     0092
*   SDWASR04=MCCESAV;               /* REFRESH MCCE ADDR     @YM03668*/
         MVC   SDWASR04(4,SDWAPTR),MCCESAV(MCRWSAPT)               0093
*                                                                  0094
*   /*****************************************************************/
*   /*                                                               */
*   /* IF THE MCERROR BIT IS ON, A RECURSIVE ERROR HAS OCCURRED. ALL */
*   /* FLAGS ARE RESET, THE FRR IS DELETED, AND A RETRY IS SCHEDULED */
*   /* FOR THE SECONDARY EXIT ROUTINE (LABEL AHLXITA). NO MORE       */
*   /* ENTRIES INTO AHLMCER WILL BE MADE UNTIL APPLICATIONS HAVE BEEN*/
*   /* RESTARTED.                                                    */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0094
*   IF MCERROR='1'B THEN                                           0094
         TM    MCERROR(MCRWSAPT),B'00100000'                       0094
         BNO   @RF00094                                            0094
*     DO;                                                          0095
*       MCERROR='0'B;               /* RESET ERROR FLAG              */
*       MCINCTL='0'B;               /* RESET RECURSION FLAG          */
         NI    MCERROR(MCRWSAPT),B'01011111'                       0097
*       GEN(SETFRR D,WRKREGS=(WORK1,WORK2));/* REMOVE FRR            */
         SETFRR D,WRKREGS=(WORK1,WORK2)
*       DO;                         /* SETRP RETADDR(AHLXITA)      0099
*                                      RC(SDWARETY) RETREGS(YES)   0099
*                                      WKAREA(SDWAPTR)               */
*         RESPECIFY                                                0100
*          (GPR00P,                                                0100
*           GPR01P,                                                0100
*           GPR14P,                                                0100
*           GPR15P)RSTD;                                           0100
*         GPR01P=SDWAPTR;                                          0101
         LR    GPR01P,SDWAPTR                                      0101
*         GPR01P->SDWARCDE=SDWARETY;/* STORE RC INTO SDWA            */
         MVI   SDWARCDE(GPR01P),X'04'                              0102
*         GPR01P->SDWARTYA=ADDR(AHLXITA);/* SAVE RETRY ADDRESS       */
         LA    @07,AHLXITA                                         0103
         ST    @07,SDWARTYA(,GPR01P)                               0103
*         GPR01P->SDWAUPRG='1'B;    /* TURN ON RETREGS INDICATOR     */
         OI    SDWAUPRG(GPR01P),B'00001000'                        0104
*         RESPECIFY                                                0105
*          (GPR00P,                                                0105
*           GPR01P,                                                0105
*           GPR14P,                                                0105
*           GPR15P)UNRSTD;                                         0105
*       END;                                                       0106
*       GO TO RTM;                  /* RETURN TO RTM TO RETRY        */
         BR    RTMADDR                                             0107
*     END;                                                         0108
*                                                                  0109
*   /*****************************************************************/
*   /*                                                               */
*   /* IF THE MCINFGBR BIT IS ON, AN APPLICATION WAS IN CONTROL WHEN */
*   /* THE ERROR OCCURRED. RETRY ROUTINE AHLTFGBR IS SCHEDULED TO    */
*   /* TERMINATE THAT APPLICATION.                                   */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0109
*   IF MCINFGBR='1'B THEN                                          0109
@RF00094 TM    MCINFGBR(MCRWSAPT),B'01000000'                      0109
         BNO   @RF00109                                            0109
*     DO;                                                          0110
*       MCINFGBR='0'B;              /* RESET FLAG - ERROR IN RETRY 0111
*                                      WILL BE CONSIDERED A BAD    0111
*                                      ERROR, RESULTING IN THE     0111
*                                      TERMINATION OF ALL FGBRS      */
         NI    MCINFGBR(MCRWSAPT),B'10111111'                      0111
*       IF SDWAPERC='0'B THEN                                      0112
         TM    SDWAPERC(SDWAPTR),B'00010000'                       0112
         BNZ   @RF00112                                            0112
*         CALL AHLSDUMP;            /* IF AHLMCIH WAS NOT PECOLATED
*                                      TO, TAKE SDUMP IF POSSIBLE. IF
*                                      IT HAS BEEN PERCOLATED TO, PD
*                                      IS ASSUMED DONE               */
         BAL   @14,AHLSDUMP                                        0113
*       DO;                         /* SETRP RETADDR(AHLTFGBR)     0114
*                                      RC(SDWARETY) RETREGS(YES)   0114
*                                      WKAREA(SDWAPTR)               */
@RF00112 DS    0H                                                  0115
*         RESPECIFY                                                0115
*          (GPR00P,                                                0115
*           GPR01P,                                                0115
*           GPR14P,                                                0115
*           GPR15P)RSTD;                                           0115
*         GPR01P=SDWAPTR;                                          0116
         LR    GPR01P,SDWAPTR                                      0116
*         GPR01P->SDWARCDE=SDWARETY;/* STORE RC INTO SDWA            */
         MVI   SDWARCDE(GPR01P),X'04'                              0117
*         GPR01P->SDWARTYA=ADDR(AHLTFGBR);/* SAVE RETRY ADDRESS      */
         LA    @07,AHLTFGBR                                        0118
         ST    @07,SDWARTYA(,GPR01P)                               0118
*         GPR01P->SDWAUPRG='1'B;    /* TURN ON RETREGS INDICATOR     */
         OI    SDWAUPRG(GPR01P),B'00001000'                        0119
*         RESPECIFY                                                0120
*          (GPR00P,                                                0120
*           GPR01P,                                                0120
*           GPR14P,                                                0120
*           GPR15P)UNRSTD;                                         0120
*       END;                                                       0121
*       GO TO RTM;                  /* RETURN TO RTM - RTRY          */
         BR    RTMADDR                                             0122
*     END;                                                         0123
*                                                                  0124
*   /*****************************************************************/
*   /*                                                               */
*   /* FALL THROUGH TO HERE INDICATES ERROR IN AHLMCER. PD ACTION IS */
*   /* TAKEN AND A RETRY TO AHLTALL IS SCHEDULED TO TERMINATE ROUTING*/
*   /* AND ALL APPLICATIONS                                          */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0124
*   CALL AHLSDUMP;                  /* ATTEMP SDUMP FOR PD           */
@RF00109 BAL   @14,AHLSDUMP                                        0124
*   DO;                             /* SETRP RETADDR(AHLTALL)      0125
*                                      RC(SDWARETY) RETREGS(YES)   0125
*                                      WKAREA(SDWAPTR)               */
*     RESPECIFY                                                    0126
*      (GPR00P,                                                    0126
*       GPR01P,                                                    0126
*       GPR14P,                                                    0126
*       GPR15P)RSTD;                                               0126
*     GPR01P=SDWAPTR;                                              0127
         LR    GPR01P,SDWAPTR                                      0127
*     GPR01P->SDWARCDE=SDWARETY;    /* STORE RC INTO SDWA            */
         MVI   SDWARCDE(GPR01P),X'04'                              0128
*     GPR01P->SDWARTYA=ADDR(AHLTALL);/* SAVE RETRY ADDRESS           */
         LA    @07,AHLTALL                                         0129
         ST    @07,SDWARTYA(,GPR01P)                               0129
*     GPR01P->SDWAUPRG='1'B;        /* TURN ON RETREGS INDICATOR     */
         OI    SDWAUPRG(GPR01P),B'00001000'                        0130
*     RESPECIFY                                                    0131
*      (GPR00P,                                                    0131
*       GPR01P,                                                    0131
*       GPR14P,                                                    0131
*       GPR15P)UNRSTD;                                             0131
*   END;                                                           0132
*   GO TO RTM;                                                     0133
         BR    RTMADDR                                             0133
*                                                                  0134
*   /*****************************************************************/
*   /*                                                               */
*   /* THIS ROUTINE IS CALLED TO TAKE AN SVC DUMP IF AN ERROR        */
*   /* OCCURRED DURING AHLMCER PROCESSING                            */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0134
*   RFY                                                            0134
*    (SDUMPSAV,                                                    0134
*     SDUMPBUF)RSTD;                                               0134
*                                                                  0134
*   /*****************************************************************/
*   /*                                                               */
*   /* RESERVE THE SDUMP BUFFER                                      */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0135
*AHLSDUMP:                                                         0135
*   SDUMPSAV=RETURNAD;              /* SAVE RETURN ADDRESS           */
AHLSDUMP LR    SDUMPSAV,RETURNAD                                   0135
*   SDUMPBUF=CVTSDBF;               /* FIND THE SVCDUMP BUFFER       */
         L     @15,CVTPTR                                          0136
         L     SDUMPBUF,CVTSDBF(,@15)                              0136
*   IF SDUMPBUF>0 THEN                                             0137
         LTR   SDUMPBUF,SDUMPBUF                                   0137
         BNP   @RF00137                                            0137
*     DO;                           /* Q. IS THE BUFFER AVAILABLE    */
*       RFY                                                        0139
*         FRRWORK RSTD;                                            0139
*       FRRWORK=SDUMPMSK|SDUMPBUF;  /* IF SO, TURN ON HI-ORDER BIT TO
*                                      RESERVE IT                    */
         L     FRRWORK,SDUMPMSK                                    0140
         OR    FRRWORK,SDUMPBUF                                    0140
*       CS(SDUMPMSK,FRRWORK,CVTSDBF);/* USE CS LOGIC TO RESERVE IT   */
         L     @15,SDUMPMSK                                        0141
         L     @08,CVTPTR                                          0141
         CS    @15,FRRWORK,CVTSDBF(@08)                            0141
         BZ    @BC00141                                            0141
         ST    @15,SDUMPMSK                                        0141
@BC00141 DS    0H                                                  0142
*       BC(7,SDUMPSAV);             /* RETURN WITHOUT A DUMP IF CANT
*                                      GET BUFFER                    */
         BCR   7,SDUMPSAV                                          0142
*       RFY                                                        0143
*         FRRWORK UNRSTD;                                          0143
*                                                                  0143
*       /*************************************************************/
*       /*                                                           */
*       /* WE HAVE THE BUFFER -- MOVE THE MCRWSA AND THE RTCA INTO   */
*       /* IT. EACH OF THESE TWO CONTROL BLOCKS MUST BE PRECEDED BY A*/
*       /* 6-BYTE DESCRIPTOR CONTAINING (A) THE ADDRESS FROM WHICH   */
*       /* THE DATA WAS MOVED AND (B) THE 2-BYTE LENGTH OF THE DATA. */
*       /* THE LAST TABLE MUST BE FOLLOWED BY 6 BYTES OF ZEROES.     */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0144
*       MCRADD=ADDR(MCRWSA);        /* PUT MCRWSA ADDRESS INTO BUFFER*/
         ST    MCRWSAPT,MCRADD(,DUMPBUF)                           0144
*       MCRLEN=LENGTH(MCRWSA);      /* LENGTH TO BUFFER              */
         MVC   MCRLEN(2,DUMPBUF),@CH01941                          0145
*       MCRDATA=MCRWSA;             /* MOVE THE MCRWSA INTO THE    0146
*                                      BUFFER                        */
         MVC   MCRDATA(136,DUMPBUF),MCRWSA(MCRWSAPT)               0146
*       SDWADD=ADDR(SDWA);          /* ADDRESS OF RTCA (SDWA) INTO 0147
*                                      THE BUFF                      */
         ST    SDWAPTR,SDWADD(,DUMPBUF)                            0147
*       SDWLEN=LENGTH(SDWA);        /* MOVE LENGTH TO THE BUFFER     */
         LA    @15,512                                             0148
         STH   @15,SDWLEN(,DUMPBUF)                                0148
*       RFY                                                        0149
*        (MV1,                                                     0149
*         MV2,                                                     0149
*         MV3,                                                     0149
*         MV4)RSTD;                                                0149
*       MV1=ADDR(SDWDATA);          /* TARGET FOR MVCL               */
         LA    MV1,SDWDATA(,DUMPBUF)                               0150
*       MV2=LENGTH(SDWA);           /* NUMBER OF BYTES TO MOVE       */
         LR    MV2,@15                                             0151
*       MV3=ADDR(SDWA);             /* SOURCE OF MVCL                */
*       MV4=MV2;                    /* SAME AS MV2                   */
         LR    MV4,MV2                                             0153
*       MVCL(MV1,MV3);              /* MOVE THE RTCA INTO THE SVCDUMP
*                                      BUFFER                        */
         MVCL  MV1,MV3                                             0154
*       ENDOFBUF='000000000000'X;   /* END OF DATA INDICATOR         */
         MVC   ENDOFBUF(6,DUMPBUF),@CB01913                        0155
*       RFY                                                        0156
*        (MV1,                                                     0156
*         MV2,                                                     0156
*         MV3,                                                     0156
*         MV4)UNRSTD;                                              0156
*       RFY                                                        0157
*         SDUMPBUF UNRSTD;                                         0157
*                                                                  0157
*       /*************************************************************/
*       /*                                                           */
*       /* TAKE A DUMP OF SQA, THIS MODULE, AND THE SDUMP BUFFER     */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0158
*       RFY                                                        0158
*        (SDMPASID,                                                0158
*         APPTAB)RSTD;                                             0158
*       SDMPASID=PSAAOLD->ASCBASID; /* RUN IT IN THIS MEMORY         */
         L     @15,PSAAOLD                                         0159
         SR    SDMPASID,SDMPASID                                   0159
         ICM   SDMPASID,3,ASCBASID(@15)                            0159
*       APPTAB=MCRMCA;              /* USE MCAWSA AS A WORK ARE TO 0160
*                                      BUILD PLIST                   */
         L     APPTAB,MCRMCA(,MCRWSAPT)                            0160
*       MCAWSA(1:32)=MCAWSA(1:32)&&MCAWSA(1:32);/* CLEAR PLIST       */
         L     @15,AWSAPTR(,MCRWSAPT)                              0161
         XC    MCAWSA(32,@15),MCAWSA(@15)                          0161
*       SECONDSV=MCRWSAPT;          /* SAVE MCRWSA ADDRESS   @YM03677*/
         LR    SECONDSV,MCRWSAPT                                   0162
*       RFY                                                        0163
*         MCRWSA BASED(SECONDSV);   /*                       @YM03677*/
*       SAVERAD=ADDR(MCAWORK);      /* GIVE SDUMP A SAVE AREA      0164
*                                                            @YM03677*/
         L     SAVERAD,AWSAPTR(,SECONDSV)                          0164
         LA    SAVERAD,MCAWORK(,SAVERAD)                           0164
*       GENERATE;                                                  0165
        SDUMP HDR='ERROR IN MODULE AHLMCER',SDATA=SQA,BUFFER=YES,      *
               BRANCH=YES,ASID=(SDMPASID),LIST=MCERSTG,                *
               MF=(E,(APPTAB))
*       MCRWSAPT=SECONDSV;          /* RESTORE MCRWSA ADDRESS      0166
*                                                            @YM03677*/
         LR    MCRWSAPT,SECONDSV                                   0166
*       RFY                                                        0167
*         MCRWSA BASED(MCRWSAPT);   /*                       @YM03677*/
*     END;                          /* END OF BUFFER AVAILABLE PATH  */
*   GO TO SDUMPSAV;                 /* RETURN TO CALLER              */
@RF00137 BR    SDUMPSAV                                            0169
*   RFY                                                            0170
*    (SDMPASID,                                                    0170
*     APPTAB,                                                      0170
*     SDUMPSAV)UNRSTD;                                             0170
*                                                                  0171
*   /*****************************************************************/
*   /*                                                               */
*   /* THE FOLLOWING ROUTINE DISABLES THE APPLICATION WHICH WAS IN   */
*   /* CONTROL AT THE TIME OF THE ERROR. THE MCQE ADDRESS IS FOUND IN*/
*   /* THE FIRST WORD OF MCROUTSA.                                   */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0171
*AHLTFGBR:                                                         0171
*   RFY                                                            0171
*     MCRWSA BASED(WSACGTF);                                       0171
AHLTFGBR DS    0H                                                  0172
*   RFY                                                            0172
*     MCQE BASED(TMPMCQE);                                         0172
*   RFY                                                            0173
*     TMPMCQE RSTD;                                                0173
*   TMPMCQE=MCROUTSA(1:4);          /* LOAD MCQE ADDR FROM MCRWSA    */
*                                                                  0174
         L     @15,LCCAPTR                                         0174
         L     @15,LCCACPUS(,@15)                                  0174
         L     @15,WSACGTF(,@15)                                   0174
         L     TMPMCQE,MCROUTSA(,@15)                              0174
*   /*****************************************************************/
*   /*                                                               */
*   /* DISABLE VIA SETEVENT ALL ROUTINES FOR THIS APPLICATION        */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0175
*   DO;                             /* SETEVENT MCQE(MCQE)         0175
*                                      ACTION(DISABLE) EIDNO(0)    0175
*                                      CLASSNO(0) NAME(MCQENAME)   0175
*                                      MF(E,SETLST)                  */
*                                                                  0175
*     /***************************************************************/
*     /*                                                             */
*     /* THE FOLLOWING SECTION OF CODE IS GENERATED BY THE SETEVENT  */
*     /* MACRO. THIS CODE WILL BE EITHER AN INITIALIZED PARAMETER    */
*     /* LIST, OR IF IT IS THE RESULT OF STANDARD OR EXECUTE FORM IT */
*     /* WILL FILL in the list, GENERATE ALL LINKAGES AND CALL THE   */
*     /* PROPER sERVICE, EITHER AHLSETEV OR AHLSETD                  */
*     /*                                                             */
*     /***************************************************************/
*                                                                  0176
*     DCL                                                          0176
*       AHLPPTR REG(1)PTR(31)RSTD;  /* PARAMETER LIST ADDRESS        */
*     DCL                                                          0177
*       AHLSETEV ENTRY OPTIONS(EXIT,SEQFLOW)BASED(MCHSETE)VALRG(0);/*
*                                      ENTRY FOR ADD ACTIVAT,FREE    */
*     DCL                                                          0178
*       AHLSETD ENTRY OPTIONS(EXIT,SEQFLOW)BASED(MCHSETD)VALRG(0);/*
*                                      ENTRY FOR DISABLE AND CHANGE  */
*     DCL                                                          0179
*       1 SEPL BASED(AHLPPTR)BDY(WORD),/* DSECT PARAMETER LIST       */
*        2 SEFG PTR(8),             /* ACTION GLAGS                  */
*        2 * PTR(8),                                               0179
*        2 SEEN PTR(8),             /* EID COUNT                     */
*        2 SECN PTR(8),             /* CLASS COUNT                   */
*        2 SENM CHAR(8),            /* APPLICATION NMAE              */
*        2 SEEL PTR(31),            /* ADDRESS OF LIST OF EIDS       */
*        2 SECL PTR(31),            /* ADDRESS OF LIST OF CLASSES    */
*        2 SEMC PTR(31);            /* MCQE ADDRESS                  */
*     AHLPPTR=ADDR(SETLST);         /* SET UP PLIST PTR              */
         L     AHLPPTR,AWSAPTR(,@15)                               0180
         LA    AHLPPTR,SETLST(,AHLPPTR)                            0180
*     SEMC=ADDR(MCQE);              /* SET UP MCQE ADDRESS           */
         ST    TMPMCQE,SEMC(,AHLPPTR)                              0181
*     SENM=MCQENAME;                /* MOVE NAME INTO PLIST          */
         MVC   SENM(8,AHLPPTR),MCQENAME(TMPMCQE)                   0182
*     SEFG=32;                      /* MOVE FLAGS INTO PLIST         */
         MVI   SEFG(AHLPPTR),X'20'                                 0183
*     SEEN=0;                       /* SET TO VALUE SPECIFIED        */
         MVI   SEEN(AHLPPTR),X'00'                                 0184
*     SECN=0;                       /* SET TO VALUE SPECIFIED        */
         MVI   SECN(AHLPPTR),X'00'                                 0185
*     IF SEFG=32|SEFG=8 THEN        /* CHECK FOR DISABLE OR * CHANGE */
         CLI   SEFG(AHLPPTR),32                                    0186
         BE    @RT00186                                            0186
         CLI   SEFG(AHLPPTR),8                                     0186
         BNE   @RF00186                                            0186
@RT00186 DS    0H                                                  0187
*       CALL AHLSETD;               /* YES                           */
         L     @09,CVTPTR                                          0187
         L     @09,CVTGTF(,@09)                                    0187
         L     @15,MCHSETD(,@09)                                   0187
         BALR  @14,@15                                             0187
*     ELSE                          /* NO                            */
*       CALL AHLSETEV;                                             0188
         B     @RC00186                                            0188
@RF00186 L     @09,CVTPTR                                          0188
         L     @09,CVTGTF(,@09)                                    0188
         L     @15,MCHSETE(,@09)                                   0188
         BALR  @14,@15                                             0188
*   END;                            /* DISABLE ALL ROUTINES FOR THIS
*                                      APPLICATION                   */
*                                                                  0189
@RC00186 DS    0H                                                  0190
*   /*****************************************************************/
*   /*                                                               */
*   /* SCHEDULE SRB IN THIS APPLICATIONS MCQE IF IT HAS NOT ALREADY  */
*   /* BEEN SCHEDULED. THE SRB ROUTINE WILL POST THE TERMINATION ECB */
*   /* IN THE MCQE. PROCESSING THEN CONTINUES AT LABEL AHLRELOD TO   */
*   /* CONTINUE PROCESSING OF THIS EVENT WITH THE NEXT MCEE/MCCLE.   */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0190
*   GENERATE;                                                      0190
         TS    MCQESCHE(TMPMCQE)         /* Q. IS SRB IN THIS MCQE
*                                         ALREADY SCHEDULED          */
         BC    7,AHLRELOD              /* IF SO, DONT SCHEDULE AGAIN */
         LA    SRBREG,MCQESRB(TMPMCQE)   /* IF NOT SCHEDULED, DO SO  */
         SCHEDULE SRB=(1)
         B     AHLRELOD
*                                                                  0191
*   /*****************************************************************/
*   /*                                                               */
*   /* THIS ROUTINE RECEIVES CONTROL AS A RETRY ROUTINE WHEN ERROR   */
*   /* RECOVERY DETERMINES THAT ALL APPLICATIONS ARE TO BE           */
*   /* TERMINATED. ROUTING IS MARKED AS INACTIVE AND ALL APPLICATIONS*/
*   /* ARE TERMINATED BY SCHEDULING THE SRB IN EACH MCQE.            */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0191
*AHLTALL:                                                          0191
*   RFY                                                            0191
*     MCCE BASED(MCCEAD);                                          0191
AHLTALL  DS    0H                                                  0192
*   RFY                                                            0192
*     TMPMCQE RSTD;                                                0192
*   MCHTERM='1'B;                   /* SET TERMINATION FLAG TO     0193
*                                      INDICATE THAT AHLMCER HAS   0193
*                                      TERMINATED MC ROUTING.        */
*   MCHACT='0'B;                    /* TURN OFF ACTIVE FLAG          */
         L     @15,CVTPTR                                          0194
         L     @15,CVTGTF(,@15)                                    0194
         OI    MCHTERM(@15),B'01000000'                            0194
         NI    MCHACT(@15),B'01111111'                             0194
*   MCERROR='1'B;                   /* SET CRITICAL ERROR FLAG, IN 0195
*                                      CASE OF ERROR SCHEDULING SRBS.*/
         L     @15,LCCAPTR                                         0195
         L     @15,LCCACPUS(,@15)                                  0195
         L     @15,WSACGTF(,@15)                                   0195
         OI    MCERROR(@15),B'00100000'                            0195
*   RFY                                                            0196
*    (MSGPTR,                                                      0196
*     SAVERAD)RSTD;                 /*                        @YM3668*/
*   SAVERAD=ADDR(MCAWORK);          /* FIND SAVEAREA FOR RECORD    0197
*                                                             @YM3668*/
         L     SAVERAD,AWSAPTR(,@15)                               0197
         LA    SAVERAD,MCAWORK(,SAVERAD)                           0197
*   MSGPTR=M132ADDR;                /* PICK UP MESSAGE ADDRESS       */
         L     MSGPTR,M132ADDR                                     0198
*   GENERATE;                                                      0199
        RECORD TYPE=WTO,RCVRY=SETFRR,DATAADR=(MSGPTR),BUFFER=NO
*   MCRWSAPT=WSACGTF;               /* REESTABLISH MCRWSA ADDR     0200
*                                                             @YM3668*/
         L     @15,LCCAPTR                                         0200
         L     @15,LCCACPUS(,@15)                                  0200
         L     MCRWSAPT,WSACGTF(,@15)                              0200
*   RFY                                                            0201
*    (MSGPTR,                                                      0201
*     SAVERAD)UNRSTD;               /*                        @YM3668*/
*   TMPMCQE=MCCEQEA;                /* LOAD FIRST MCQE ADDRESS       */
         L     TMPMCQE,MCCEQEA(,MCCEAD)                            0202
*   GENERATE;                                                      0203
AHLMCPST TS    MCQESCHE(TMPMCQE)         /* Q. HAS SRB IN THIS MCQE AL-
*                                         READY BEEN SCHEDULED       */
         BC    7,AHLMCLNK              /* IF SO, DONT SCHEDULE       */
         LA    SRBREG,MCQESRB(TMPMCQE) /* IF NOT, FIND SRB           */
         SCHEDULE SRB=(1)              /* SCHEDULE IT                */
AHLMCLNK L     TMPMCQE,MCQEMCQE(TMPMCQE) /* LOAD NEXT MCQE ADDR      */
         LTR   TMPMCQE,TMPMCQE         /* Q. IS THIS LAST ONE        */
         BNE   AHLMCPST                /* IF NOT, SCHEDULE THIS ONE  */
*   MCERROR='0'B;                   /* RESET CRITICAL ERROR FLAG     */
         L     @15,LCCAPTR                                         0204
         L     @15,LCCACPUS(,@15)                                  0204
         L     @15,WSACGTF(,@15)                                   0204
         NI    MCERROR(@15),B'11011111'                            0204
*   GO TO AHLXIT1;                  /* QUIT                          */
         B     AHLXIT1                                             0205
*                                                                  0206
*   /*****************************************************************/
*   /*                                                               */
*   /* THE FOLLOWING EXIT CODE IS IDENTICAL TO THE CODE AT LABEL     */
*   /* AHLXIT1 EXCEPT THAT THE SETFRR HAS BEEN REMOVED. THIS EXIT IS */
*   /* USED IF A RECURSIVE ERROR OCCURS, AND IS SCHEDULED AS A RETRY */
*   /* ROUTINE IN THAT CASE                                          */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0206
*   GENERATE;                                                      0206
AHLXITA  L     USECOUNT,MCHCNT(HEADREG) /* LOAD USE COUNT FROM MCHEAD*/
         LR    WORK1,MCCEAD            /* CREATE BACKUP FOR MCCE @   */
AHLCSDB  LR    WORK2,USECOUNT          /* CREATE COPY OF USE COUNT   */
         BCTR  USECOUNT,0              /* DECREMENT USE COUNT BY 1   */
         CDS   WORK1,MCCEAD,MCHCUR(HEADREG) /* DECREMENT COUNT AND
*                                         VERIFY MCCE ADDRESS        */
         BC    8,AHLXITB               /* IF SUCCESSFUL, EXIT        */
         CR    WORK1,MCCEAD            /* Q. DID TABLE ADDR CHANGE   */
         BE    AHLCSDB                 /* IF NOT, REDO TO SET CORRECT
*                                         COUNT                      */
         LTR   MCCEAD,MCCEAD           /* Q. WAS OLD ONE ZERO        */
         BE    AHLXITB                 /* IF SO, EXIT                */
         L     WORK2,MCCECNT(MCCEAD)   /* LOAD USE COUNT FROM MCCE   */
AHLCSDC  LR    USECOUNT,WORK2          /* CREATE COPY OF COUNT       */
         BCTR  USECOUNT,0              /* DECREMENT BY 1             */
         CS    WORK2,USECOUNT,MCCECNT(MCCEAD) /* PLACE IN MCCE       */
         BC    7,AHLCSDC               /* IF DIDNT GO, REDO UNTIL OK */
         LTR   USECOUNT,USECOUNT       /* Q. DID COUNT BECOME ZERO   */
         BNE   AHLXITB                 /* IF NOT, EXIT               */
         LA    SRBREG,MCCESRB(MCCEAD)  /* SRB ADDR TO REG 1          */
         SCHEDULE SRB=(SRBREG)         /* SCHEDULE SRB TO FREE TABLES*/
AHLXITB  NI    MCRWSAF(MCRWSAPT),X'FF'-MCINCNTL-BRNCHENT /*RESET FLGS*/
AHLXITC  LM    MCQEAD,RETURNAD,MCRMCIH(MCRWSAPT) /* RESTORE REGS     */
         BR    RETURNAD                /* RETURN TO CALLER           */
         LTORG
M132ADDR DC    A(AHLMCMSG)
AHLMCMSG CSECT
      WTO 'AHL132I MC ROUTING FACILITY TERMINATING ON ERROR CONDITION',*
               ROUTCDE=(2),DESC=(4),MF=L
AHLMCER CSECT
*   DECLARE                         /* GENERAL PURPOSE REGISTERS     */
*     GPR00P PTR(31)REG(0),                                        0207
*     GPR01P PTR(31)REG(1),                                        0207
*     GPR14P PTR(31)REG(14),                                       0207
*     GPR15P PTR(31)REG(15);                                       0207
*   DECLARE                         /* COMMON VARIABLES              */
*     I256C CHAR(256)BASED,                                        0208
*     I031F FIXED(31)BASED,                                        0208
*     I031P PTR(31)BASED,                                          0208
*     I015F FIXED(15)BASED,                                        0208
*     I015P PTR(15)BASED,                                          0208
*     I008P PTR(8)BASED,                                           0208
*     I001C CHAR(1)BASED;                                          0208
*AHLMCERN:                                                         0209
*   END AHLMCER                                                    0209
*                                                                  0209
*/* THE FOLLOWING INCLUDE STATEMENTS WERE FOUND IN THIS PROGRAM.     */
*/*%INCLUDE SYSLIB  (CVT     )                                       */
*/*%INCLUDE SYSLIB  (IHAWSAVT)                                       */
*/*%INCLUDE SYSLIB  (IHAPSA  )                                       */
*/*%INCLUDE SYSLIB  (IHAASCB )                                       */
*/*%INCLUDE SYSLIB  (IHALCCA )                                       */
*/*%INCLUDE SYSLIB  (IHASDWA )                                       */
*/*%INCLUDE SYSLIB  (IHAFRRS )                                       */
*/*%INCLUDE SYSLIB  (IHASRB  )                                       */
*/*%INCLUDE SYSLIB  (MCCE    )                                       */
*/*%INCLUDE SYSLIB  (MCQE    )                                       */
*/*%INCLUDE SYSLIB  (MCCD    )                                       */
*/*%INCLUDE SYSLIB  (MCEE    )                                       */
*/*%INCLUDE SYSLIB  (MCCLE   )                                       */
*/*%INCLUDE SYSLIB  (MCHEAD  )                                       */
*/*%INCLUDE SYSLIB  (MCRWSA  )                                       */
*/*%INCLUDE SYSLIB  (MCAWSA  )                                       */
*                                                                  0209
*       ;                                                          0209
AHLMCERN DS    0H                                                  0209
@DATA    DS    0H
@CH01941 DC    H'136'
@DATD    DSECT
         DS    0F
AHLMCER  CSECT
         DS    0F
@DATD    DSECT
         DS    0D
         ORG   *+1-(*-@DATD)/(*-@DATD) INSURE DSECT DATA
@ENDDATD EQU   *
AHLMCER  CSECT
         DS    0F
@SIZDATD DC    AL1(0)
         DC    AL3(@ENDDATD-@DATD)
         DS    0D
MCERORG  DC    AL4(AHLMCER1)
SDUMPMSK DC    XL4'80000000'
@CB01913 DC    X'000000000000'
         DS    CL2
MCERSTG  DS    CL8
         ORG   MCERSTG
@NM00084 DC    AL4(AHLMCER)
@NM00085 DC    XL1'80'
@NM00086 DC    AL3(AHLMCERN)
         ORG   MCERSTG+8
MCERID   DC    CL24'AHLMCER AHLMCER AHLMCER'
AHLMPTCH DC    100X'00'
@00      EQU   00                      EQUATES FOR REGISTERS 0-15
@01      EQU   01
@02      EQU   02
@03      EQU   03
@04      EQU   04
@05      EQU   05
@06      EQU   06
@07      EQU   07
@08      EQU   08
@09      EQU   09
@10      EQU   10
@11      EQU   11
@12      EQU   12
@13      EQU   13
@14      EQU   14
@15      EQU   15
SDWAAD   EQU   @01
APPTAB   EQU   @02
MCCEAD   EQU   @04
RTMADDR  EQU   @04
RETRYAD  EQU   @05
SDWAPTR  EQU   @06
MV3      EQU   @06
MV4      EQU   @07
MSGPTR   EQU   @07
SECONDSV EQU   @08
TMPMCQE  EQU   @08
MV1      EQU   @08
MV2      EQU   @09
SDMPASID EQU   @09
FRRWORK  EQU   @09
DUMPBUF  EQU   @10
SDUMPBUF EQU   @10
SDUMPSAV EQU   @11
SAVERAD  EQU   @13
MCRWSAPT EQU   @13
RETURNAD EQU   @14
GPR00P   EQU   @00
GPR01P   EQU   @01
GPR14P   EQU   @14
GPR15P   EQU   @15
AHLPPTR  EQU   @01
APPLCRTN EQU   @15
ELEMAD   EQU   @06
HEADREG  EQU   @11
MCAPTR   EQU   @03
MCDA     EQU   @02
MCERBASE EQU   @12
MCQEAD   EQU   @00
RETURNER EQU   @07
SRBREG   EQU   @01
TEMPPTR  EQU   @15
USECOUNT EQU   @05
WORK1    EQU   @02
WORK2    EQU   @03
         ENTRY AHLMPTCH
CVTPTR   EQU   16
PSA      EQU   0
FLCRNPSW EQU   PSA
FLCROPSW EQU   PSA+8
FLCICCW2 EQU   PSA+16
PSAEEPSW EQU   PSA+132
PSAESPSW EQU   PSA+136
FLCSVILC EQU   PSAESPSW+1
PSAEPPSW EQU   PSA+140
FLCPIILC EQU   PSAEPPSW+1
FLCPICOD EQU   PSAEPPSW+2
PSAPICOD EQU   FLCPICOD+1
FLCTEA   EQU   PSAEPPSW+4
FLCPER   EQU   PSA+152
FLCMCLA  EQU   PSA+168
FLCIOEL  EQU   FLCMCLA+4
FLCIOA   EQU   FLCMCLA+16
FLCFSA   EQU   FLCMCLA+80
PSALCCAV EQU   PSA+528
PSAAOLD  EQU   PSA+548
PSASUPER EQU   PSA+552
PSASUP1  EQU   PSASUPER
PSASUP2  EQU   PSASUPER+1
PSASUP3  EQU   PSASUPER+2
PSASUP4  EQU   PSASUPER+3
PSACLHT  EQU   PSA+640
PSALKSA  EQU   PSA+696
PSAHLHI  EQU   PSA+760
PSADSSFL EQU   PSA+836
PSADSSF1 EQU   PSADSSFL
PSADSSF3 EQU   PSADSSFL+2
PSADSSF4 EQU   PSADSSFL+3
PSARSVT  EQU   PSA+896
CVTMAP   EQU   0
CVTDAR   EQU   CVTMAP+72
CVTFLGS1 EQU   CVTDAR
CVTDCB   EQU   CVTMAP+116
CVTIERLC EQU   CVTMAP+144
CVTOPTA  EQU   CVTMAP+182
CVTOPTB  EQU   CVTMAP+183
CVTGTF   EQU   CVTMAP+236
CVTGTFST EQU   CVTGTF
CVTGTFS  EQU   CVTGTFST
CVTSTATE EQU   CVTGTFST
CVTTMODE EQU   CVTGTFST
CVTFORM  EQU   CVTGTFST
CVTUSR   EQU   CVTGTFST
CVTAQAVT EQU   CVTMAP+240
CVTTCMFG EQU   CVTAQAVT
CVTVOLM2 EQU   CVTMAP+244
CVTTATA  EQU   CVTVOLM2
CVTTSKS  EQU   CVTTATA
CVTVOLF2 EQU   CVTTSKS
CVTTAT   EQU   CVTTATA+1
CVTATER  EQU   CVTMAP+248
CVTEXT1  EQU   CVTMAP+252
CVTPURG  EQU   CVTMAP+260
CVTQMSG  EQU   CVTMAP+268
CVTDMSR  EQU   CVTMAP+272
CVTERPV  EQU   CVTMAP+316
CVTINTLA EQU   CVTMAP+320
CVTAPF   EQU   CVTMAP+324
CVTEXT2  EQU   CVTMAP+328
CVTHJES  EQU   CVTMAP+332
CVTPGSIA EQU   CVTMAP+348
CVTA1F1  EQU   CVTMAP+356
CVTSYSK  EQU   CVTMAP+357
CVTVOLM1 EQU   CVTMAP+380
CVTVOLF1 EQU   CVTVOLM1
CVTATMCT EQU   CVTMAP+388
CVTXTNT1 EQU   0
CVTXTNT2 EQU   0
CVTDSSV  EQU   CVTXTNT2
CVTRSV90 EQU   CVTXTNT2+5
CVTQID   EQU   CVTXTNT2+24
CVTRV400 EQU   CVTXTNT2+52
CVTRV409 EQU   CVTXTNT2+53
CVTATCVT EQU   CVTXTNT2+64
CVTRV429 EQU   CVTXTNT2+84
CVTRV438 EQU   CVTXTNT2+85
CVTRV457 EQU   CVTXTNT2+112
CVTRV466 EQU   CVTXTNT2+113
CVTFIX   EQU   0
CVTRELNO EQU   CVTFIX+252
WSAC     EQU   0
WSACGTF  EQU   WSAC+4
ASCB     EQU   0
ASCBASID EQU   ASCB+36
ASCBFW1  EQU   ASCB+100
ASCBRCTF EQU   ASCBFW1+2
ASCBFLG1 EQU   ASCBFW1+3
ASCBDSP1 EQU   ASCB+114
ASCBFLG2 EQU   ASCB+115
LCCA     EQU   0
LCCAIHRC EQU   LCCA+520
LCCAIHR1 EQU   LCCAIHRC
LCCAIHR2 EQU   LCCAIHRC+1
LCCAIHR3 EQU   LCCAIHRC+2
LCCAIHR4 EQU   LCCAIHRC+3
LCCASPIN EQU   LCCA+524
LCCASPN1 EQU   LCCASPIN
LCCASPN2 EQU   LCCASPIN+1
LCCASPN3 EQU   LCCASPIN+2
LCCASPN4 EQU   LCCASPIN+3
LCCACPUS EQU   LCCA+536
LCCADSF1 EQU   LCCA+540
LCCADSF2 EQU   LCCA+541
LCCASPSA EQU   LCCA+544
LCCACRFL EQU   LCCA+692
LCCACREX EQU   LCCA+693
LCCALKFG EQU   LCCA+694
LCCASRBF EQU   LCCA+720
SDWA     EQU   0
SDWAFIOB EQU   SDWA+4
SDWAABCC EQU   SDWAFIOB
SDWACMPF EQU   SDWAABCC
SDWAREQ  EQU   SDWACMPF
SDWACTL1 EQU   SDWA+8
SDWACMKA EQU   SDWACTL1
SDWAMWPA EQU   SDWACTL1+1
SDWAPMKA EQU   SDWACTL1+4
SDWACTL2 EQU   SDWA+16
SDWACMKP EQU   SDWACTL2
SDWAMWPP EQU   SDWACTL2+1
SDWAPMKP EQU   SDWACTL2+4
SDWANXTP EQU   SDWACTL2+5
SDWAGRSV EQU   SDWA+24
SDWANAME EQU   SDWA+88
SDWAEC1  EQU   SDWA+104
SDWAEMK1 EQU   SDWAEC1
SDWAMWP1 EQU   SDWAEC1+1
SDWAINT1 EQU   SDWAEC1+2
SDWANXT1 EQU   SDWAEC1+4
SDWAAEC1 EQU   SDWA+112
SDWAILC1 EQU   SDWAAEC1+1
SDWAINC1 EQU   SDWAAEC1+2
SDWAICD1 EQU   SDWAINC1+1
SDWAEC2  EQU   SDWA+120
SDWAEMK2 EQU   SDWAEC2
SDWAMWP2 EQU   SDWAEC2+1
SDWAINT2 EQU   SDWAEC2+2
SDWANXT2 EQU   SDWAEC2+4
SDWAAEC2 EQU   SDWA+128
SDWAILC2 EQU   SDWAAEC2+1
SDWAINC2 EQU   SDWAAEC2+2
SDWAICD2 EQU   SDWAINC2+1
SDWASRSV EQU   SDWA+136
SDWASR04 EQU   SDWASRSV+16
SDWASR11 EQU   SDWASRSV+44
SDWASR12 EQU   SDWASRSV+48
SDWASR13 EQU   SDWASRSV+52
SDWAIDNT EQU   SDWA+200
SDWAMCH  EQU   SDWA+204
SDWASTCK EQU   SDWAMCH
SDWAMCHI EQU   SDWAMCH+8
SDWAMCHS EQU   SDWAMCHI
SDWAMCHD EQU   SDWAMCHI+1
SDWAREGU EQU   SDWAMCHD
SDWAPSWU EQU   SDWAMCHD
SDWAINSF EQU   SDWAMCHD
SDWARSR1 EQU   SDWAMCH+12
SDWARSR2 EQU   SDWAMCH+13
SDWAFLGS EQU   SDWA+232
SDWAERRA EQU   SDWAFLGS
SDWAERRB EQU   SDWAFLGS+1
SDWAERRC EQU   SDWAFLGS+2
SDWAPERC EQU   SDWAERRC
SDWAERRD EQU   SDWAFLGS+3
SDWAIOFS EQU   SDWA+238
SDWARTYA EQU   SDWA+240
SDWACPUA EQU   SDWA+248
SDWAPARQ EQU   SDWA+252
SDWARCDE EQU   SDWAPARQ
SDWAACF2 EQU   SDWAPARQ+1
SDWAUPRG EQU   SDWAACF2
SDWAACF3 EQU   SDWAPARQ+2
SDWAACF4 EQU   SDWAPARQ+3
SDWALKWA EQU   SDWA+256
SDWALKWS EQU   SDWALKWA
SDWARECP EQU   SDWA+292
SDWASNPA EQU   SDWA+320
SDWADUMP EQU   SDWASNPA
SDWADPFS EQU   SDWADUMP+1
SDWADDAT EQU   SDWASNPA+4
SDWASDAT EQU   SDWADDAT
SDWAPDAT EQU   SDWADDAT+2
SDWADPSA EQU   SDWA+328
SDWADPSL EQU   SDWADPSA
SDWARA   EQU   SDWA+400
SDWADPVA EQU   SDWARA+2
FRRS     EQU   0
FRRSHEAD EQU   FRRS
FRRSPTR  EQU   0
FRRSENTR EQU   0
FRRSFLGS EQU   FRRSENTR+4
FRRSFLG1 EQU   FRRSFLGS
FRREPTR  EQU   0
SRBPTR   EQU   0
SRBSECT  EQU   0
SRB      EQU   SRBSECT
SRBFLC   EQU   SRB+12
MCCE     EQU   0
MCCEQEA  EQU   MCCE+16
MCQE     EQU   0
MCQENAME EQU   MCQE+8
MCQEFLGS EQU   MCQE+41
MCCD     EQU   0
MCCDFLG1 EQU   MCCD+8
MCEE     EQU   0
MCEEFLGS EQU   MCEE+8
MCEEFLG1 EQU   MCEEFLGS
MCCLE    EQU   0
MCCLFLGS EQU   MCCLE+8
MCCLFLG1 EQU   MCCLFLGS
MCHEAD   EQU   0
MCHFLGS  EQU   MCHEAD+24
MCHFLG1  EQU   MCHFLGS
MCHACT   EQU   MCHFLG1
MCHTERM  EQU   MCHFLG1
MCHSETE  EQU   MCHEAD+28
MCHSETD  EQU   MCHEAD+32
MCRWSA   EQU   0
MCRMCIH  EQU   MCRWSA
MCROUTSA EQU   MCRWSA+64
MCRMCA   EQU   MCRWSA+128
MCRWSAF  EQU   MCRWSA+132
MCINCTL  EQU   MCRWSAF
MCINFGBR EQU   MCRWSAF
MCERROR  EQU   MCRWSAF
MCAWSA   EQU   0
MCATRAIL EQU   MCAWSA+256
MCATRL1  EQU   MCATRAIL
MCATRL2  EQU   MCATRAIL+1
MCATRL3  EQU   MCATRAIL+2
MCATRL4  EQU   MCATRAIL+3
MCATRL5  EQU   MCATRAIL+4
MCATRL6  EQU   MCATRAIL+5
MCATRL7  EQU   MCATRAIL+6
MCAWORK  EQU   MCAWSA+584
RETRYADR EQU   0
RTM      EQU   0
SDMPBUFR EQU   0
MCRADD   EQU   SDMPBUFR
MCRLEN   EQU   SDMPBUFR+4
MCRDATA  EQU   SDMPBUFR+6
SDWADD   EQU   SDMPBUFR+142
SDWLEN   EQU   SDMPBUFR+146
SDWDATA  EQU   SDMPBUFR+148
ENDOFBUF EQU   SDMPBUFR+660
I256C    EQU   0
AHLSETEV EQU   0
AHLSETD  EQU   0
SEPL     EQU   0
SEFG     EQU   SEPL
SEEN     EQU   SEPL+2
SECN     EQU   SEPL+3
SENM     EQU   SEPL+4
SEMC     EQU   SEPL+20
I001C    EQU   0
I008P    EQU   0
I015F    EQU   0
I015P    EQU   0
I031F    EQU   0
I031P    EQU   0
RETURNPT EQU   0
CVTS01   EQU   CVTPGSIA
CVTLPDIA EQU   CVTS01+12
CVTDIRST EQU   CVTLPDIA
CVTSLIDA EQU   CVTS01+24
CVTCTLFG EQU   CVTS01+50
CVTSDBF  EQU   CVTS01+240
CVTRV210 EQU   CVTS01+424
CVTRV219 EQU   CVTS01+425
CVTRV228 EQU   CVTS01+426
CVTRV237 EQU   CVTS01+427
CVTMFRTR EQU   CVTS01+452
CVTRV262 EQU   CVTS01+468
CVTRV271 EQU   CVTS01+469
CVTRV280 EQU   CVTS01+470
CVTRV289 EQU   CVTS01+471
CVTGSDA  EQU   CVTS01+600
PSARSVTE EQU   PSARSVT
ASCBPTR  EQU   PSAAOLD
LCCAPTR  EQU   PSALCCAV
AWSAPTR  EQU   MCRMCA
MCCESAV  EQU   MCRMCIH+60
SETLST   EQU   MCAWORK
FLC      EQU   PSA
*                                      START UNREFERENCED COMPONENTS
SETLST07 EQU   SETLST+20
SETLST06 EQU   SETLST+16
SETLST05 EQU   SETLST+12
SETLST04 EQU   SETLST+4
SETLST03 EQU   SETLST+3
SETLST02 EQU   SETLST+2
@NM00087 EQU   SETLST+1
SETLST01 EQU   SETLST
PSARSAV  EQU   PSARSVTE+60
PSARSTK  EQU   PSARSVTE+56
PSAESAV3 EQU   PSARSVTE+52
PSAESTK3 EQU   PSARSVTE+48
PSAESAV2 EQU   PSARSVTE+44
PSAESTK2 EQU   PSARSVTE+40
PSAESAV1 EQU   PSARSVTE+36
PSAESTK1 EQU   PSARSVTE+32
PSAPSAV  EQU   PSARSVTE+28
PSAPSTK  EQU   PSARSVTE+24
PSAMSAV  EQU   PSARSVTE+20
PSAMSTK  EQU   PSARSVTE+16
PSASSAV  EQU   PSARSVTE+12
PSASSTK  EQU   PSARSVTE+8
PSANSTK  EQU   PSARSVTE+4
PSACSTK  EQU   PSARSVTE
CVTTPIO  EQU   CVTS01+608
CVTADV   EQU   CVTS01+604
CVTGSDAB EQU   CVTGSDA
CVTQV3   EQU   CVTS01+596
CVTQV2   EQU   CVTS01+592
CVTQV1   EQU   CVTS01+588
CVTRPT   EQU   CVTS01+584
CVTSSRB  EQU   CVTS01+580
CVTCSDRL EQU   CVTS01+576
CVTEXP1  EQU   CVTS01+572
CVTRMPMT EQU   CVTS01+568
CVTRMPTT EQU   CVTS01+564
CVTVPSA  EQU   CVTS01+560
CVTVSTOP EQU   CVTS01+556
CVTGTFR8 EQU   CVTS01+552
CVTQUIT  EQU   CVTS01+548
CVTVACR  EQU   CVTS01+544
CVTWTCB  EQU   CVTS01+540
CVTSTPRS EQU   CVTS01+536
CVT0PT02 EQU   CVTS01+532
CVTDARCM EQU   CVTS01+528
CVTIRECM EQU   CVTS01+524
CVTJRECM EQU   CVTS01+520
CVTVEMS0 EQU   CVTS01+516
CVTSPFRR EQU   CVTS01+512
CVTRLSTG EQU   CVTS01+508
CVT0TC0A EQU   CVTS01+504
CVTGMBR  EQU   CVTS01+500
CVTLFRM  EQU   CVTS01+496
CVTRMBR  EQU   CVTS01+492
CVTVIOP  EQU   CVTS01+488
CVTRV307 EQU   CVTS01+486
CVTRV306 EQU   CVTS01+484
CVTRV305 EQU   CVTS01+482
CVTRV304 EQU   CVTS01+480
CVTRV303 EQU   CVTS01+478
CVTRV302 EQU   CVTS01+476
CVTRV301 EQU   CVTS01+475
CVTRV300 EQU   CVTS01+474
CVTRV299 EQU   CVTS01+473
CVTRV298 EQU   CVTS01+472
CVTRV297 EQU   CVTRV289
CVTRV296 EQU   CVTRV289
CVTRV295 EQU   CVTRV289
CVTRV294 EQU   CVTRV289
CVTRV293 EQU   CVTRV289
CVTRV292 EQU   CVTRV289
CVTRV291 EQU   CVTRV289
CVTRV290 EQU   CVTRV289
CVTRV288 EQU   CVTRV280
CVTRV287 EQU   CVTRV280
CVTRV286 EQU   CVTRV280
CVTRV285 EQU   CVTRV280
CVTRV284 EQU   CVTRV280
CVTRV283 EQU   CVTRV280
CVTRV282 EQU   CVTRV280
CVTRV281 EQU   CVTRV280
CVTRV279 EQU   CVTRV271
CVTRV278 EQU   CVTRV271
CVTRV277 EQU   CVTRV271
CVTRV276 EQU   CVTRV271
CVTRV275 EQU   CVTRV271
CVTRV274 EQU   CVTRV271
CVTRV273 EQU   CVTRV271
CVTRV272 EQU   CVTRV271
CVTRV270 EQU   CVTRV262
CVTRV269 EQU   CVTRV262
CVTRV268 EQU   CVTRV262
CVTRV267 EQU   CVTRV262
CVTRV266 EQU   CVTRV262
CVTRV265 EQU   CVTRV262
CVTRV264 EQU   CVTRV262
CVTRV263 EQU   CVTRV262
CVTVFP   EQU   CVTS01+464
CVTVSI   EQU   CVTS01+460
CVTVPSIB EQU   CVTS01+456
CVTMFACT EQU   CVTMFRTR
CVTMFCTL EQU   CVTS01+448
CVTPVBP  EQU   CVTS01+444
CVTPWI   EQU   CVTS01+440
CVTRV254 EQU   CVTS01+438
CVTRV253 EQU   CVTS01+436
CVTRV252 EQU   CVTS01+434
CVTRV251 EQU   CVTS01+433
CVTRV250 EQU   CVTS01+432
CVTRV249 EQU   CVTS01+431
CVTRV248 EQU   CVTS01+430
CVTRV247 EQU   CVTS01+429
CVTRV246 EQU   CVTS01+428
CVTRV245 EQU   CVTRV237
CVTRV244 EQU   CVTRV237
CVTRV243 EQU   CVTRV237
CVTRV242 EQU   CVTRV237
CVTRV241 EQU   CVTRV237
CVTRV240 EQU   CVTRV237
CVTRV239 EQU   CVTRV237
CVTRV238 EQU   CVTRV237
CVTRV236 EQU   CVTRV228
CVTRV235 EQU   CVTRV228
CVTRV234 EQU   CVTRV228
CVTRV233 EQU   CVTRV228
CVTRV232 EQU   CVTRV228
CVTRV231 EQU   CVTRV228
CVTRV230 EQU   CVTRV228
CVTRV229 EQU   CVTRV228
CVTRV227 EQU   CVTRV219
CVTRV226 EQU   CVTRV219
CVTRV225 EQU   CVTRV219
CVTRV224 EQU   CVTRV219
CVTRV223 EQU   CVTRV219
CVTRV222 EQU   CVTRV219
CVTRV221 EQU   CVTRV219
CVTRV220 EQU   CVTRV219
CVTRV218 EQU   CVTRV210
CVTRV217 EQU   CVTRV210
CVTRV216 EQU   CVTRV210
CVTRV215 EQU   CVTRV210
CVTRV214 EQU   CVTRV210
CVTRV213 EQU   CVTRV210
CVTRV212 EQU   CVTRV210
CVTRV211 EQU   CVTRV210
CVTLCCAT EQU   CVTS01+420
CVTPCCAT EQU   CVTS01+416
CVTIPCRP EQU   CVTS01+412
CVTIPCRI EQU   CVTS01+408
CVTIPCDS EQU   CVTS01+404
CVTAIDVT EQU   CVTS01+400
CVTSSAP  EQU   CVTS01+396
CVTEHCIR EQU   CVTS01+392
CVTEHDEF EQU   CVTS01+388
CVTDAIR  EQU   CVTS01+384
CVTPERFM EQU   CVTS01+380
CVT044R2 EQU   CVTS01+376
CVTFETCH EQU   CVTS01+372
CVTRSTWD EQU   CVTS01+368
CVTSPOST EQU   CVTS01+364
CVTIOBP  EQU   CVTS01+360
CVTASMVT EQU   CVTS01+356
CVTRECRQ EQU   CVTS01+352
CVTWSAC  EQU   CVTS01+348
CVTRV149 EQU   CVTS01+344
CVTWSAL  EQU   CVTS01+340
CVTSPSA  EQU   CVTS01+336
CVTGLMN  EQU   CVTS01+332
CVTVEAC0 EQU   CVTS01+328
CVT062R1 EQU   CVTS01+324
CVTRPOST EQU   CVTS01+320
CVTDQIQE EQU   CVTS01+316
CVTCSD   EQU   CVTS01+312
CVTLKRMA EQU   CVTS01+308
CVTRSPIE EQU   CVTS01+304
CVTRENQ  EQU   CVTS01+300
CVTLQCB  EQU   CVTS01+296
CVTFQCB  EQU   CVTS01+292
CVTQCS01 EQU   CVTS01+288
CVTAPFT  EQU   CVTS01+284
CVTPARRL EQU   CVTS01+280
CVTVWAIT EQU   CVTS01+276
CVTGSPL  EQU   CVTS01+272
CVTLSMQ  EQU   CVTS01+268
CVTGSMQ  EQU   CVTS01+264
CVTEXPRO EQU   CVTS01+260
CVTOPCTP EQU   CVTS01+256
CVTSIC   EQU   CVTS01+252
CVTTPIOS EQU   CVTS01+248
CVTRTMS  EQU   CVTS01+244
CVTSCBP  EQU   CVTS01+236
CVTSDMP  EQU   CVTS01+232
CVTSV60  EQU   CVTS01+228
CVTRTMCT EQU   CVTS01+224
CVTASCBL EQU   CVTS01+220
CVTASCBH EQU   CVTS01+216
CVTGDA   EQU   CVTS01+212
CVTASVT  EQU   CVTS01+208
CVTVVMDI EQU   CVTS01+204
CVTAQTOP EQU   CVTS01+200
CVTIOSCS EQU   CVTS01+196
CVTSDRM  EQU   CVTS01+192
CVTOPTE  EQU   CVTS01+188
CVTSTXU  EQU   CVTS01+184
CVTQUIS  EQU   CVTS01+180
CVTPARS  EQU   CVTS01+176
CVTS1EE  EQU   CVTS01+172
CVTFRAS  EQU   CVTS01+168
CVTQSAS  EQU   CVTS01+164
CVTCRAS  EQU   CVTS01+160
CVTCRMN  EQU   CVTS01+156
CVTDELCP EQU   CVTS01+152
CVTFRECL EQU   CVTS01+148
CVTGETCL EQU   CVTS01+144
CVTBLDCP EQU   CVTS01+140
CVTAUTHL EQU   CVTS01+136
CVTSCAN  EQU   CVTS01+132
CVTRV144 EQU   CVTS01+130
CVTMAXMP EQU   CVTS01+128
CVTSTCK  EQU   CVTS01+124
CVTRV139 EQU   CVTS01+123
CVTDSSAC EQU   CVTS01+122
CVTRV513 EQU   CVTS01+121
CVTIOSPL EQU   CVTS01+120
CVTPTGT  EQU   CVTS01+116
CVTCSPIE EQU   CVTS01+112
CVTSMFEX EQU   CVTS01+108
CVTOLT0A EQU   CVTS01+104
CVTSRBRT EQU   CVTS01+100
CVTPUTL  EQU   CVTS01+96
CVTRV519 EQU   CVTS01+92
CVTRV327 EQU   CVTS01+88
CVTRV326 EQU   CVTS01+84
CVTRV325 EQU   CVTS01+80
CVTRV324 EQU   CVTS01+76
CVT0VL01 EQU   CVTS01+72
CVTSHRVM EQU   CVTS01+68
CVTRV332 EQU   CVTS01+64
CVTTAS   EQU   CVTS01+60
CVTRSCN  EQU   CVTS01+56
CVTTRAC2 EQU   CVTS01+54
CVTTRACE EQU   CVTS01+52
CVTAPG   EQU   CVTS01+51
CVTSDTRC EQU   CVTCTLFG
CVTGTRCE EQU   CVTCTLFG
CVTNOMP  EQU   CVTCTLFG
CVTRSV79 EQU   CVTCTLFG
CVTDSTAT EQU   CVTCTLFG
CVTRSV78 EQU   CVTCTLFG
CVTRV333 EQU   CVTCTLFG
CVTRV323 EQU   CVTCTLFG
CVTSPVLK EQU   CVTS01+49
CVTRSV77 EQU   CVTS01+48
CVTRV331 EQU   CVTS01+44
CVTRV330 EQU   CVTS01+40
CVTRV329 EQU   CVTS01+36
CVTRV328 EQU   CVTS01+32
CVTRV322 EQU   CVTS01+28
CVTSLID  EQU   CVTSLIDA+1
CVTSYLK  EQU   CVTSLIDA
CVTRV321 EQU   CVTS01+20
CVTRV320 EQU   CVTS01+16
CVTLPDIR EQU   CVTLPDIA+1
CVTRSV69 EQU   CVTDIRST
CVTRSV68 EQU   CVTDIRST
CVTRSV67 EQU   CVTDIRST
CVTRSV66 EQU   CVTDIRST
CVTRSV65 EQU   CVTDIRST
CVTRSV64 EQU   CVTDIRST
CVTRSV63 EQU   CVTDIRST
CVTDICOM EQU   CVTDIRST
CVTPVTP  EQU   CVTS01+8
CVTLPDSR EQU   CVTS01+4
CVTGETL  EQU   CVTS01
SECL     EQU   SEPL+16
SEEL     EQU   SEPL+12
@NM00088 EQU   SEPL+1
MCASWORK EQU   MCAWSA+644
MCAREC   EQU   MCAWSA+284
MCARECPR EQU   MCAWSA+268
MCAMCR   EQU   MCAWSA+264
MCATRL8  EQU   MCATRAIL+7
MCAFRECT EQU   MCATRL7
MCAFRECC EQU   MCATRL7
MCAFRESP EQU   MCATRL7
MCAFREXJ EQU   MCATRL7
MCAFRSBR EQU   MCATRL6
MCAFRDMJ EQU   MCATRL6
MCAFRDPC EQU   MCATRL6
MCAFRPIC EQU   MCATRL6
MCAFRPIJ EQU   MCATRL6
@NM00083 EQU   MCATRL5
MCADREGS EQU   MCATRL5
MCAFRRB  EQU   MCATRL5
MCAFRRJ  EQU   MCATRL5
MCAFRRA  EQU   MCATRL5
MCAFRERT EQU   MCATRL5
MCAFREPC EQU   MCATRL5
MCAMJOBN EQU   MCATRL4
MCAMSDWA EQU   MCATRL4
MCAMBTU  EQU   MCATRL4
MCAMIOSB EQU   MCATRL4
MCAMTCB  EQU   MCATRL4
MCAMASCB EQU   MCATRL4
MCAMUCB  EQU   MCATRL4
MCAMEXT  EQU   MCATRL4
MCAFRFRT EQU   MCATRL3
MCAFRFA  EQU   MCATRL3
MCAFRSJ  EQU   MCATRL3
MCAFRSA  EQU   MCATRL3
MCAPIF   EQU   MCATRL3
MCASIOF  EQU   MCATRL3
MCAIOF   EQU   MCATRL3
MCASVCF  EQU   MCATRL3
MCATDIR  EQU   MCATRL2
MCALSR   EQU   MCATRL2
MCAERROR EQU   MCATRL2
MCAUIO   EQU   MCATRL2
MCASTA   EQU   MCATRL2
MCAFRR   EQU   MCATRL2
MCASRM   EQU   MCATRL2
MCARNIO  EQU   MCATRL2
MCAUSR   EQU   MCATRL1
MCAPI    EQU   MCATRL1
MCASRB   EQU   MCATRL1
MCADSP   EQU   MCATRL1
MCASIO   EQU   MCATRL1
MCAIO    EQU   MCATRL1
MCAEXT   EQU   MCATRL1
MCASVC   EQU   MCATRL1
MCAMSG   EQU   MCAWSA+192
MCASETEV EQU   MCAWSA+128
MCAFWORK EQU   MCAWSA+112
MCASFEOB EQU   MCAWSA+56
MCASBLOK EQU   MCAWSA
MCREID   EQU   MCRWSA+134
MCRRESV  EQU   MCRWSAF
MCRBRENT EQU   MCRWSAF
MCHEADTR EQU   MCHEAD+48
MCHEADRD EQU   MCHEAD+44
MCHFRRAD EQU   MCHEAD+40
MCHMCER  EQU   MCHEAD+36
@NM00082 EQU   MCHFLGS+1
@NM00081 EQU   MCHFLG1
MCHDIS   EQU   MCHEAD+20
MCHCTL   EQU   MCHEAD+16
MCHCNT   EQU   MCHEAD+12
MCHCUR   EQU   MCHEAD+8
MCHIDEN  EQU   MCHEAD
MCCLMCQL EQU   MCCLE+24
MCCLEIDL EQU   MCCLE+20
MCCLMCQE EQU   MCCLE+16
MCCLRTN  EQU   MCCLE+12
MCCLCLAS EQU   MCCLFLGS+2
MCCLFLG2 EQU   MCCLFLGS+1
MCCLRESV EQU   MCCLFLG1
MCCLDIS  EQU   MCCLFLG1
MCCLIDEN EQU   MCCLE
MCEEMCQL EQU   MCEE+24
MCEEEIDL EQU   MCEE+20
MCEEMCQE EQU   MCEE+16
MCEERTN  EQU   MCEE+12
MCEEEID  EQU   MCEEFLGS+2
MCEEFLG2 EQU   MCEEFLGS+1
MCEERESV EQU   MCEEFLG1
MCEEDIS  EQU   MCEEFLG1
MCEEIDEN EQU   MCEE
MCCDCLE  EQU   MCCD+12
MCCDCNT  EQU   MCCD+10
MCCDRESV EQU   MCCDFLG1
MCCDDEL  EQU   MCCDFLG1
MCCDIDEN EQU   MCCD
MCQESRB  EQU   MCQE+44
@NM00080 EQU   MCQE+42
@NM00079 EQU   MCQEFLGS
MCQEACT  EQU   MCQEFLGS
MCQESCHE EQU   MCQE+40
MCQETECB EQU   MCQE+36
MCQEAT   EQU   MCQE+32
MCQEMCCL EQU   MCQE+28
MCQEMCEE EQU   MCQE+24
MCQEMCQE EQU   MCQE+20
MCQEASCB EQU   MCQE+16
MCQEIDEN EQU   MCQE
MCCESRB  EQU   MCCE+44
MCCEECB  EQU   MCCE+40
MCCEMCCE EQU   MCCE+36
MCCECNT  EQU   MCCE+32
MCCEOMCQ EQU   MCCE+28
MCCEOCDA EQU   MCCE+24
MCCEOEDA EQU   MCCE+20
MCCECDA  EQU   MCCE+12
MCCEEDA  EQU   MCCE+8
MCCEIDEN EQU   MCCE
@NM00078 EQU   SRB+40
@NM00077 EQU   SRB+38
SRBPRIOR EQU   SRB+37
SRBPKF   EQU   SRB+36
SRBSAVE  EQU   SRB+32
SRBPARM  EQU   SRB+28
SRBRMTR  EQU   SRB+24
SRBEP    EQU   SRB+20
SRBPTCB  EQU   SRBFLC+4
SRBPASID EQU   SRBFLC+2
SRBCPAFF EQU   SRBFLC
SRBASCB  EQU   SRB+8
SRBFLNK  EQU   SRB+4
SRBID    EQU   SRB
FRRSPARM EQU   FRRSENTR+8
@NM00076 EQU   FRRSFLGS+1
@NM00075 EQU   FRRSFLG1
FRRSNEST EQU   FRRSFLG1
FRRSRCUR EQU   FRRSFLG1
FRRSFRRA EQU   FRRSENTR
FRRSENTS EQU   FRRS+84
FRRSRTMW EQU   FRRS+16
FRRSCURR EQU   FRRSHEAD+12
FRRSELEN EQU   FRRSHEAD+8
FRRSLAST EQU   FRRSHEAD+4
FRRSEMP  EQU   FRRSHEAD
@NM00074 EQU   SDWA+512
SDWAVRA  EQU   SDWARA+4
SDWAURAL EQU   SDWARA+3
@NM00073 EQU   SDWADPVA
SDWAEBC  EQU   SDWADPVA
SDWAHEX  EQU   SDWADPVA
SDWAVRAL EQU   SDWARA
@NM00072 EQU   SDWA+396
SDWACOMP EQU   SDWA+392
SDWARCPL EQU   SDWA+364
@NM00071 EQU   SDWADPSA+32
SDWATO4  EQU   SDWADPSL+28
SDWAFRM4 EQU   SDWADPSL+24
SDWATO3  EQU   SDWADPSL+20
SDWAFRM3 EQU   SDWADPSL+16
SDWATO2  EQU   SDWADPSL+12
SDWAFRM2 EQU   SDWADPSL+8
SDWATO1  EQU   SDWADPSL+4
SDWAFRM1 EQU   SDWADPSL
@NM00070 EQU   SDWADDAT+3
@NM00069 EQU   SDWAPDAT
SDWAUSPL EQU   SDWAPDAT
SDWADPSW EQU   SDWAPDAT
SDWATJPA EQU   SDWAPDAT
SDWATLPA EQU   SDWAPDAT
SDWADREG EQU   SDWAPDAT
SDWADSAH EQU   SDWAPDAT
SDWADSAS EQU   SDWAPDAT
@NM00068 EQU   SDWADDAT+1
@NM00067 EQU   SDWASDAT
SDWAQQS  EQU   SDWASDAT
SDWACBS  EQU   SDWASDAT
SDWAGTF  EQU   SDWASDAT
SDWASWA  EQU   SDWASDAT
SDWALSQA EQU   SDWASDAT
SDWASQA  EQU   SDWASDAT
SDWANUC  EQU   SDWASDAT
@NM00066 EQU   SDWADUMP+2
@NM00065 EQU   SDWADPFS
SDWASLST EQU   SDWADPFS
@NM00064 EQU   SDWADPFS
SDWADLST EQU   SDWADPFS
SDWADPT  EQU   SDWADPFS
SDWADPID EQU   SDWADUMP
SDWADPLA EQU   SDWA+316
SDWAREXN EQU   SDWARECP+16
SDWACSCT EQU   SDWARECP+8
SDWAMODN EQU   SDWARECP
@NM00063 EQU   SDWALKWA+32
SDWATALW EQU   SDWALKWS+28
SDWATDLW EQU   SDWALKWS+24
SDWATNLW EQU   SDWALKWS+20
SDWAAPLW EQU   SDWALKWS+16
SDWAIPLW EQU   SDWALKWS+12
SDWAILLW EQU   SDWALKWS+8
SDWAIULW EQU   SDWALKWS+4
SDWAICLW EQU   SDWALKWS
SDWAFLLK EQU   SDWAACF4
SDWACMS  EQU   SDWAACF4
SDWAOPTM EQU   SDWAACF4
SDWATADB EQU   SDWAACF4
SDWATDNB EQU   SDWAACF4
SDWATNCB EQU   SDWAACF4
SDWAILCH EQU   SDWAACF4
SDWAIUCB EQU   SDWAACF4
SDWAICAT EQU   SDWAACF3
SDWAIPRG EQU   SDWAACF3
SDWASALL EQU   SDWAACF3
SDWAASMP EQU   SDWAACF3
SDWADISP EQU   SDWAACF3
@NM00062 EQU   SDWAACF3
@NM00061 EQU   SDWAACF2
SDWAFREE EQU   SDWAACF2
@NM00060 EQU   SDWAACF2
SDWASPIN EQU   SDWAACF2
@NM00059 EQU   SDWAACF2
SDWARCRD EQU   SDWAACF2
SDWALCPU EQU   SDWACPUA+2
@NM00058 EQU   SDWACPUA
SDWARECA EQU   SDWA+244
@NM00057 EQU   SDWA+239
@NM00056 EQU   SDWAIOFS
SDWANIOP EQU   SDWAIOFS
SDWANOIO EQU   SDWAIOFS
SDWAIOHT EQU   SDWAIOFS
SDWAIOQR EQU   SDWAIOFS
SDWAFMID EQU   SDWA+236
@NM00055 EQU   SDWAERRD
SDWAMCIV EQU   SDWAERRD
SDWARPIV EQU   SDWAERRD
SDWAMABD EQU   SDWAERRD
SDWACTS  EQU   SDWAERRD
SDWASTAE EQU   SDWAERRD
SDWANRBE EQU   SDWAERRD
SDWACLUP EQU   SDWAERRD
@NM00054 EQU   SDWAERRC
SDWAEAS  EQU   SDWAERRC
SDWAIRB  EQU   SDWAERRC
SDWASTAI EQU   SDWAERRC
SDWASTAF EQU   SDWAERRC
SDWASRBM EQU   SDWAERRB
SDWALDIS EQU   SDWAERRB
SDWAENRB EQU   SDWAERRB
SDWATYP1 EQU   SDWAERRB
@NM00053 EQU   SDWAERRB
SDWAPGIO EQU   SDWAERRA
SDWATEXC EQU   SDWAERRA
SDWASVCE EQU   SDWAERRA
SDWAABTM EQU   SDWAERRA
SDWASVCD EQU   SDWAERRA
SDWARKEY EQU   SDWAERRA
SDWAPCHK EQU   SDWAERRA
SDWAMCHK EQU   SDWAERRA
SDWATIME EQU   SDWAMCH+20
SDWARFSA EQU   SDWAMCH+16
@NM00052 EQU   SDWAMCH+14
SDWAVEQR EQU   SDWARSR2
SDWAPGFX EQU   SDWARSR2
SDWAFLSQ EQU   SDWARSR2
SDWAFSQA EQU   SDWARSR2
SDWANUCL EQU   SDWARSR2
SDWASPER EQU   SDWARSR2
SDWAINTC EQU   SDWARSR2
SDWAOFLN EQU   SDWARSR2
SDWACHNG EQU   SDWARSR1
SDWAMSER EQU   SDWARSR1
@NM00051 EQU   SDWARSR1
SDWACPID EQU   SDWAMCH+10
SDWATERR EQU   SDWAMCHD
SDWAFPRX EQU   SDWAMCHD
SDWAACR  EQU   SDWAMCHD
SDWASCK  EQU   SDWAMCHD
SDWASKYF EQU   SDWAMCHD
@NM00050 EQU   SDWAMCHS
SDWARSRF EQU   SDWAMCHS
SDWARSRC EQU   SDWAMCHS
SDWAINVP EQU   SDWAMCHS
SDWATSVL EQU   SDWAMCHS
SDWARCDF EQU   SDWAMCHS
SDWASRVL EQU   SDWAMCHS
SDWASCKE EQU   SDWASTCK+4
SDWASCKB EQU   SDWASTCK
SDWALNTH EQU   SDWAIDNT+1
SDWASPID EQU   SDWAIDNT
SDWASR15 EQU   SDWASRSV+60
SDWASR14 EQU   SDWASRSV+56
SDWASR10 EQU   SDWASRSV+40
SDWASR09 EQU   SDWASRSV+36
SDWASR08 EQU   SDWASRSV+32
SDWASR07 EQU   SDWASRSV+28
SDWASR06 EQU   SDWASRSV+24
SDWASR05 EQU   SDWASRSV+20
SDWASR03 EQU   SDWASRSV+12
SDWASR02 EQU   SDWASRSV+8
SDWASR01 EQU   SDWASRSV+4
SDWASR00 EQU   SDWASRSV
SDWATRN2 EQU   SDWAAEC2+4
SDWAIPC2 EQU   SDWAICD2
SDWAIMC2 EQU   SDWAICD2
SDWAIPR2 EQU   SDWAICD2
@NM00049 EQU   SDWAINC2
@NM00048 EQU   SDWAILC2
SDWAIL2  EQU   SDWAILC2
@NM00047 EQU   SDWAILC2
@NM00046 EQU   SDWAAEC2
SDWAADD2 EQU   SDWANXT2+1
@NM00045 EQU   SDWANXT2
@NM00044 EQU   SDWAEC2+3
SDWASGN2 EQU   SDWAINT2
SDWAEXP2 EQU   SDWAINT2
SDWADEC2 EQU   SDWAINT2
SDWAFPO2 EQU   SDWAINT2
SDWACC2  EQU   SDWAINT2
@NM00043 EQU   SDWAINT2
SDWAPGM2 EQU   SDWAMWP2
SDWAWAT2 EQU   SDWAMWP2
SDWAMCK2 EQU   SDWAMWP2
SDWAECT2 EQU   SDWAMWP2
SDWAKEY2 EQU   SDWAMWP2
SDWAEXT2 EQU   SDWAEMK2
SDWAIO2  EQU   SDWAEMK2
SDWATRM2 EQU   SDWAEMK2
@NM00042 EQU   SDWAEMK2
SDWAPER2 EQU   SDWAEMK2
@NM00041 EQU   SDWAEMK2
SDWATRAN EQU   SDWAAEC1+4
SDWAIPC1 EQU   SDWAICD1
SDWAIMC1 EQU   SDWAICD1
SDWAIPR1 EQU   SDWAICD1
@NM00040 EQU   SDWAINC1
@NM00039 EQU   SDWAILC1
SDWAIL1  EQU   SDWAILC1
@NM00038 EQU   SDWAILC1
@NM00037 EQU   SDWAAEC1
SDWAADD1 EQU   SDWANXT1+1
@NM00036 EQU   SDWANXT1
@NM00035 EQU   SDWAEC1+3
SDWASGN1 EQU   SDWAINT1
SDWAEXP1 EQU   SDWAINT1
SDWADEC1 EQU   SDWAINT1
SDWAFPO1 EQU   SDWAINT1
SDWACC1  EQU   SDWAINT1
@NM00034 EQU   SDWAINT1
SDWAPGM1 EQU   SDWAMWP1
SDWAWAT1 EQU   SDWAMWP1
SDWAMCK1 EQU   SDWAMWP1
SDWAECT1 EQU   SDWAMWP1
SDWAKEY1 EQU   SDWAMWP1
SDWAEXT1 EQU   SDWAEMK1
SDWAIO1  EQU   SDWAEMK1
SDWATRM1 EQU   SDWAEMK1
@NM00033 EQU   SDWAEMK1
SDWAPER1 EQU   SDWAEMK1
@NM00032 EQU   SDWAEMK1
SDWAIOBR EQU   SDWA+100
SDWAEPA  EQU   SDWA+96
@NM00031 EQU   SDWANAME+4
SDWARBAD EQU   SDWANAME
SDWAGR15 EQU   SDWAGRSV+60
SDWAGR14 EQU   SDWAGRSV+56
SDWAGR13 EQU   SDWAGRSV+52
SDWAGR12 EQU   SDWAGRSV+48
SDWAGR11 EQU   SDWAGRSV+44
SDWAGR10 EQU   SDWAGRSV+40
SDWAGR09 EQU   SDWAGRSV+36
SDWAGR08 EQU   SDWAGRSV+32
SDWAGR07 EQU   SDWAGRSV+28
SDWAGR06 EQU   SDWAGRSV+24
SDWAGR05 EQU   SDWAGRSV+20
SDWAGR04 EQU   SDWAGRSV+16
SDWAGR03 EQU   SDWAGRSV+12
SDWAGR02 EQU   SDWAGRSV+8
SDWAGR01 EQU   SDWAGRSV+4
SDWAGR00 EQU   SDWAGRSV
SDWASGP  EQU   SDWAPMKP
SDWAEUP  EQU   SDWAPMKP
SDWADOP  EQU   SDWAPMKP
SDWAFPP  EQU   SDWAPMKP
SDWACCP  EQU   SDWAPMKP
SDWAILP  EQU   SDWAPMKP
SDWAINTP EQU   SDWACTL2+2
SDWASPVP EQU   SDWAMWPP
SDWAWATP EQU   SDWAMWPP
SDWAMCKP EQU   SDWAMWPP
@NM00030 EQU   SDWAMWPP
SDWAKEYP EQU   SDWAMWPP
SDWAEXTP EQU   SDWACMKP
SDWAIOP  EQU   SDWACMKP
SDWANXTA EQU   SDWACTL1+5
SDWASGA  EQU   SDWAPMKA
SDWAEUA  EQU   SDWAPMKA
SDWADOA  EQU   SDWAPMKA
SDWAFPA  EQU   SDWAPMKA
SDWACCA  EQU   SDWAPMKA
SDWAILA  EQU   SDWAPMKA
SDWAINTA EQU   SDWACTL1+2
SDWASPVA EQU   SDWAMWPA
SDWAWATA EQU   SDWAMWPA
SDWAMCKA EQU   SDWAMWPA
@NM00029 EQU   SDWAMWPA
SDWAKEYA EQU   SDWAMWPA
SDWAEXTA EQU   SDWACMKA
SDWAIOA  EQU   SDWACMKA
SDWACMPC EQU   SDWAABCC+1
@NM00028 EQU   SDWACMPF
SDWASTCC EQU   SDWACMPF
@NM00027 EQU   SDWACMPF
SDWASTEP EQU   SDWACMPF
SDWAPARM EQU   SDWA
LCCAR125 EQU   LCCA+964
LCCAR124 EQU   LCCA+960
LCCAR123 EQU   LCCA+956
LCCAR122 EQU   LCCA+952
LCCAR121 EQU   LCCA+948
LCCAR120 EQU   LCCA+944
LCCAR119 EQU   LCCA+940
LCCAR118 EQU   LCCA+936
LCCAR117 EQU   LCCA+932
LCCAR116 EQU   LCCA+928
LCCAR115 EQU   LCCA+924
LCCAR114 EQU   LCCA+920
LCCAR113 EQU   LCCA+916
LCCAR112 EQU   LCCA+912
LCCAR111 EQU   LCCA+908
LCCAR110 EQU   LCCA+904
LCCAR109 EQU   LCCA+900
LCCAR108 EQU   LCCA+896
LCCADRT2 EQU   LCCA+888
LCCADRT1 EQU   LCCA+880
LCCAR103 EQU   LCCA+876
LCCAESS2 EQU   LCCA+872
LCCASPLJ EQU   LCCA+868
LCCASMQJ EQU   LCCA+864
LCCAIRT  EQU   LCCA+736
LCCARV90 EQU   LCCA+732
LCCARV89 EQU   LCCA+728
LCCAPGTA EQU   LCCASRBF+2
LCCASAFN EQU   LCCASRBF
LCCAECSA EQU   LCCA+716
LCCAICR0 EQU   LCCA+712
LCCALWTM EQU   LCCA+704
LCCARV78 EQU   LCCA+700
LCCAPINV EQU   LCCA+696
LCCARV88 EQU   LCCA+695
LCCARV87 EQU   LCCALKFG
LCCARV86 EQU   LCCALKFG
LCCARV85 EQU   LCCALKFG
LCCARV84 EQU   LCCALKFG
LCCALKRD EQU   LCCALKFG
LCCALKAQ EQU   LCCALKFG
LCCALKSA EQU   LCCALKFG
LCCALKDP EQU   LCCALKFG
LCCACRST EQU   LCCACREX
LCCACRDP EQU   LCCACREX
LCCACRLM EQU   LCCACREX
LCCACRIN EQU   LCCACREX
LCCACRRT EQU   LCCACREX
LCCACRLE EQU   LCCACREX
LCCACRRM EQU   LCCACREX
LCCACREF EQU   LCCACREX
LCCAVARY EQU   LCCACRFL
LCCARV73 EQU   LCCACRFL
LCCARV72 EQU   LCCACRFL
LCCARV71 EQU   LCCACRFL
LCCARV70 EQU   LCCACRFL
LCCARV69 EQU   LCCACRFL
LCCACLMS EQU   LCCACRFL
LCCACRTM EQU   LCCACRFL
LCCALCR0 EQU   LCCA+688
LCCACRLC EQU   LCCA+684
LCCARCPU EQU   LCCA+680
LCCADCPU EQU   LCCA+676
LCCASRBJ EQU   LCCA+672
LCCADSSR EQU   LCCA+668
LCCADSSC EQU   LCCA+660
LCCADSS3 EQU   LCCA+648
LCCADSS2 EQU   LCCA+636
LCCADSS1 EQU   LCCA+624
LCCAWTIM EQU   LCCA+616
LCCAITOD EQU   LCCA+608
LCCADTOD EQU   LCCA+600
LCCASTOD EQU   LCCA+592
LCCARIR5 EQU   LCCASPSA+44
LCCARIR4 EQU   LCCASPSA+40
LCCARIR3 EQU   LCCASPSA+36
LCCARIR2 EQU   LCCASPSA+32
LCCARPR5 EQU   LCCASPSA+28
LCCARPR4 EQU   LCCASPSA+24
LCCARPR3 EQU   LCCASPSA+20
LCCARPR2 EQU   LCCASPSA+16
LCCADSR5 EQU   LCCASPSA+12
LCCADSR4 EQU   LCCASPSA+8
LCCADSR3 EQU   LCCASPSA+4
LCCADSR2 EQU   LCCASPSA
LCCARV68 EQU   LCCA+543
LCCAPSMK EQU   LCCA+542
LCCARV67 EQU   LCCADSF2
LCCARV66 EQU   LCCADSF2
LCCARV65 EQU   LCCADSF2
LCCARV64 EQU   LCCADSF2
LCCADSRW EQU   LCCADSF2
LCCADSPL EQU   LCCADSF2
LCCAGSRB EQU   LCCADSF2
LCCASRBM EQU   LCCADSF2
LCCARV61 EQU   LCCADSF1
LCCARV60 EQU   LCCADSF1
LCCARV59 EQU   LCCADSF1
LCCARV58 EQU   LCCADSF1
LCCATIMR EQU   LCCADSF1
LCCADSS  EQU   LCCADSF1
LCCAVCPU EQU   LCCADSF1
LCCAACR  EQU   LCCADSF1
LCCAASCP EQU   LCCA+532
LCCAESSA EQU   LCCA+528
LCCARV55 EQU   LCCASPN4
LCCARV54 EQU   LCCASPN4
LCCARV53 EQU   LCCASPN4
LCCARV52 EQU   LCCASPN4
LCCARV51 EQU   LCCASPN4
LCCARV50 EQU   LCCASPN4
LCCARV49 EQU   LCCASPN4
LCCARV48 EQU   LCCASPN4
LCCARV47 EQU   LCCASPN3
LCCARV46 EQU   LCCASPN3
LCCARV45 EQU   LCCASPN3
LCCARV44 EQU   LCCASPN3
LCCARV43 EQU   LCCASPN3
LCCARV42 EQU   LCCASPN3
LCCARV41 EQU   LCCASPN3
LCCARV40 EQU   LCCASPN3
LCCARV39 EQU   LCCASPN2
LCCARV38 EQU   LCCASPN2
LCCARV37 EQU   LCCASPN2
LCCARV36 EQU   LCCASPN2
LCCARV35 EQU   LCCASPN2
LCCARV34 EQU   LCCASPN2
LCCARV33 EQU   LCCASPN2
LCCARV32 EQU   LCCASPN2
LCCARV31 EQU   LCCASPN1
LCCARV30 EQU   LCCASPN1
LCCAMFIO EQU   LCCASPN1
LCCARSTR EQU   LCCASPN1
LCCATSPN EQU   LCCASPN1
LCCALOCK EQU   LCCASPN1
LCCASIGP EQU   LCCASPN1
LCCAPTLB EQU   LCCASPN1
LCCARV27 EQU   LCCAIHR4
LCCARV26 EQU   LCCAIHR4
LCCARV25 EQU   LCCAIHR4
LCCARV24 EQU   LCCAIHR4
LCCARV23 EQU   LCCAIHR4
LCCARV22 EQU   LCCAIHR4
LCCARV21 EQU   LCCAIHR4
LCCARV20 EQU   LCCAIHR4
LCCARV19 EQU   LCCAIHR3
LCCARV18 EQU   LCCAIHR3
LCCARV17 EQU   LCCAIHR3
LCCARV16 EQU   LCCAIHR3
LCCARV15 EQU   LCCAIHR3
LCCARV14 EQU   LCCAIHR3
LCCARV13 EQU   LCCAIHR3
LCCARV12 EQU   LCCAIHR3
LCCARV11 EQU   LCCAIHR2
LCCARV10 EQU   LCCAIHR2
LCCARV09 EQU   LCCAIHR2
LCCARV08 EQU   LCCAIHR2
LCCARV07 EQU   LCCAIHR2
LCCARV06 EQU   LCCAIHR2
LCCARV05 EQU   LCCAIHR2
LCCARV04 EQU   LCCAIHR2
LCCARV03 EQU   LCCAIHR1
LCCARV02 EQU   LCCAIHR1
LCCARV01 EQU   LCCAIHR1
LCCAPPIE EQU   LCCAIHR1
LCCAPSG1 EQU   LCCAIHR1
LCCAPDAT EQU   LCCAIHR1
LCCAXRC2 EQU   LCCAIHR1
LCCAXRC1 EQU   LCCAIHR1
LCCAIOPS EQU   LCCA+512
LCCAGPGR EQU   LCCA+448
LCCARSFP EQU   LCCA+416
LCCARSGR EQU   LCCA+352
LCCAXGR3 EQU   LCCA+288
LCCAXGR2 EQU   LCCA+224
LCCAXGR1 EQU   LCCA+160
LCCACR0  EQU   LCCA+156
LCCAMCR1 EQU   LCCA+152
LCCAPVAD EQU   LCCA+148
LCCAPINT EQU   LCCA+144
LCCAPPSW EQU   LCCA+136
LCCAPGR2 EQU   LCCA+72
LCCAPGR1 EQU   LCCA+8
LCCARV77 EQU   LCCA+6
LCCACPUA EQU   LCCA+4
LCCALCCA EQU   LCCA
ASCBEND  EQU   ASCB+208
ASCBSRBT EQU   ASCB+200
ASCBSWTL EQU   ASCB+196
ASCBRS14 EQU   ASCB+195
ASCBSMCT EQU   ASCB+194
ASCBRS12 EQU   ASCB+192
ASCBPCTT EQU   ASCB+188
ASCBVGTT EQU   ASCB+184
ASCBLGCB EQU   ASCB+180
ASCBJBNS EQU   ASCB+176
ASCBJBNI EQU   ASCB+172
ASCBMCC  EQU   ASCB+168
ASCBRTWA EQU   ASCB+164
ASCBIQEA EQU   ASCB+160
ASCBXMPQ EQU   ASCB+156
ASCBRS01 EQU   ASCB+154
ASCBFMCT EQU   ASCB+152
ASCBOUXB EQU   ASCB+148
ASCBOUCB EQU   ASCB+144
ASCBMECB EQU   ASCB+140
ASCBQECB EQU   ASCB+136
ASCBCMSB EQU   ASCB+132
ASCBCMSF EQU   ASCB+128
ASCBTCBS EQU   ASCB+124
ASCBNVSC EQU   ASCB+122
ASCBVSC  EQU   ASCB+120
ASCBSRBS EQU   ASCB+118
ASCBSSRB EQU   ASCB+116
ASCBRV06 EQU   ASCBFLG2
ASCBRV05 EQU   ASCBFLG2
ASCBRV04 EQU   ASCBFLG2
ASCBSNQS EQU   ASCBFLG2
ASCBS2S  EQU   ASCBFLG2
ASCBCEXT EQU   ASCBFLG2
ASCBPXMT EQU   ASCBFLG2
ASCBXMPT EQU   ASCBFLG2
ASCBRF07 EQU   ASCBDSP1
ASCBRF06 EQU   ASCBDSP1
ASCBRF05 EQU   ASCBDSP1
ASCBRF04 EQU   ASCBDSP1
ASCBRF03 EQU   ASCBDSP1
ASCBRF02 EQU   ASCBDSP1
ASCBFAIL EQU   ASCBDSP1
ASCBNOQ  EQU   ASCBDSP1
ASCBSWCT EQU   ASCB+112
ASCBASXB EQU   ASCB+108
ASCBTMCH EQU   ASCB+104
ASCBNSWP EQU   ASCBFLG1
ASCBTYP1 EQU   ASCBFLG1
ASCBSTND EQU   ASCBFLG1
ASCBABNT EQU   ASCBFLG1
ASCBTERM EQU   ASCBFLG1
ASCBS3S  EQU   ASCBFLG1
ASCBCMSH EQU   ASCBFLG1
ASCBTOFF EQU   ASCBFLG1
ASCBRF01 EQU   ASCBRCTF
ASCBTMLW EQU   ASCBRCTF
ASCBOUT  EQU   ASCBRCTF
ASCBWAIT EQU   ASCBRCTF
ASCBRV08 EQU   ASCBRCTF
ASCBFQU  EQU   ASCBRCTF
ASCBFRS  EQU   ASCBRCTF
ASCBTMNO EQU   ASCBRCTF
ASCBAFFN EQU   ASCBFW1
ASCBDUMP EQU   ASCB+96
ASCBQSVC EQU   ASCB+92
ASCBUBET EQU   ASCB+88
ASCBECB  EQU   ASCB+84
ASCBJSTL EQU   ASCB+80
ASCBEWST EQU   ASCB+72
ASCBEJST EQU   ASCB+64
ASCBTSB  EQU   ASCB+60
ASCBCSCB EQU   ASCB+56
ASCBRSM  EQU   ASCB+52
ASCBLDA  EQU   ASCB+48
ASCBSTOR EQU   ASCB+44
ASCBDP   EQU   ASCB+43
ASCBRV07 EQU   ASCB+42
ASCBIOSM EQU   ASCB+40
ASCBSEQN EQU   ASCB+38
ASCBCPUS EQU   ASCB+32
ASCBSPL  EQU   ASCB+28
ASCBLSLQ EQU   ASCB+24
ASCBFSLQ EQU   ASCB+20
ASCBIOSP EQU   ASCB+16
ASCBLOCK EQU   ASCB+12
ASCBBWDP EQU   ASCB+8
ASCBFWDP EQU   ASCB+4
ASCBASCB EQU   ASCB
ASCBEGIN EQU   ASCB
WSACCCH  EQU   WSAC+52
WSACRRSA EQU   WSAC+48
WSACREST EQU   WSAC+44
WSACRSTI EQU   WSAC+40
WSACABTM EQU   WSAC+36
WSACMF1  EQU   WSAC+32
WSACEDS0 EQU   WSAC+28
WSACIOS  EQU   WSAC+24
WSACRTMK EQU   WSAC+20
WSACACR  EQU   WSAC+16
WSACTIME EQU   WSAC+12
WSACOPTM EQU   WSAC+8
WSACCWSA EQU   WSAC
CVTLEVL  EQU   CVTRELNO+2
CVTNUMB  EQU   CVTRELNO
CVTMDL   EQU   CVTFIX+250
@NM00002 EQU   CVTFIX+248
@NM00001 EQU   CVTFIX
CVTRV482 EQU   CVTXTNT2+128
CVTRV481 EQU   CVTXTNT2+124
CVTRV480 EQU   CVTXTNT2+120
CVTRV479 EQU   CVTXTNT2+118
CVTRV478 EQU   CVTXTNT2+117
CVTRV477 EQU   CVTXTNT2+116
CVTRV476 EQU   CVTXTNT2+115
CVTRV475 EQU   CVTXTNT2+114
CVTRV474 EQU   CVTRV466
CVTRV473 EQU   CVTRV466
CVTRV472 EQU   CVTRV466
CVTRV471 EQU   CVTRV466
CVTRV470 EQU   CVTRV466
CVTRV469 EQU   CVTRV466
CVTRV468 EQU   CVTRV466
CVTRV467 EQU   CVTRV466
CVTRV465 EQU   CVTRV457
CVTRV464 EQU   CVTRV457
CVTRV463 EQU   CVTRV457
CVTRV462 EQU   CVTRV457
CVTRV461 EQU   CVTRV457
CVTRV460 EQU   CVTRV457
CVTRV459 EQU   CVTRV457
CVTRV458 EQU   CVTRV457
CVTRV456 EQU   CVTXTNT2+108
CVTRV455 EQU   CVTXTNT2+104
CVTRV454 EQU   CVTXTNT2+100
CVTRV453 EQU   CVTXTNT2+96
CVTRV452 EQU   CVTXTNT2+94
CVTRV451 EQU   CVTXTNT2+92
CVTRV450 EQU   CVTXTNT2+90
CVTRV449 EQU   CVTXTNT2+88
CVTRV448 EQU   CVTXTNT2+87
CVTRV447 EQU   CVTXTNT2+86
CVTRV446 EQU   CVTRV438
CVTRV445 EQU   CVTRV438
CVTRV444 EQU   CVTRV438
CVTRV443 EQU   CVTRV438
CVTRV442 EQU   CVTRV438
CVTRV441 EQU   CVTRV438
CVTRV440 EQU   CVTRV438
CVTRV439 EQU   CVTRV438
CVTRV437 EQU   CVTRV429
CVTRV436 EQU   CVTRV429
CVTRV435 EQU   CVTRV429
CVTRV434 EQU   CVTRV429
CVTRV433 EQU   CVTRV429
CVTRV432 EQU   CVTRV429
CVTRV431 EQU   CVTRV429
CVTRV430 EQU   CVTRV429
CVTRV428 EQU   CVTXTNT2+80
CVTRV427 EQU   CVTXTNT2+76
CVTRV426 EQU   CVTXTNT2+72
CVTRV425 EQU   CVTXTNT2+68
CVTATACT EQU   CVTATCVT
CVTRV423 EQU   CVTXTNT2+62
CVTRV422 EQU   CVTXTNT2+60
CVTRV421 EQU   CVTXTNT2+58
CVTRV420 EQU   CVTXTNT2+56
CVTRV419 EQU   CVTXTNT2+55
CVTRV418 EQU   CVTXTNT2+54
CVTRV417 EQU   CVTRV409
CVTRV416 EQU   CVTRV409
CVTRV415 EQU   CVTRV409
CVTRV414 EQU   CVTRV409
CVTRV413 EQU   CVTRV409
CVTRV412 EQU   CVTRV409
CVTRV411 EQU   CVTRV409
CVTRV410 EQU   CVTRV409
CVTRV408 EQU   CVTRV400
CVTRV407 EQU   CVTRV400
CVTRV406 EQU   CVTRV400
CVTRV405 EQU   CVTRV400
CVTRV404 EQU   CVTRV400
CVTRV403 EQU   CVTRV400
CVTRV402 EQU   CVTRV400
CVTRV401 EQU   CVTRV400
CVTRSVA1 EQU   CVTXTNT2+48
CVTRSVA0 EQU   CVTXTNT2+44
CVTRSV99 EQU   CVTXTNT2+40
CVTRSV98 EQU   CVTXTNT2+36
CVTRSV97 EQU   CVTXTNT2+34
CVTRSV96 EQU   CVTXTNT2+32
CVTOLTEP EQU   CVTXTNT2+28
CVTQIDA  EQU   CVTQID+1
CVTRSV95 EQU   CVTQID
CVTRSV94 EQU   CVTXTNT2+20
CVTRSV93 EQU   CVTXTNT2+16
CVTRSV92 EQU   CVTXTNT2+12
CVTDEBVR EQU   CVTXTNT2+8
CVTRSV91 EQU   CVTXTNT2+6
CVTRSV9H EQU   CVTRSV90
CVTRSV9G EQU   CVTRSV90
CVTRSV9F EQU   CVTRSV90
CVTRSV9E EQU   CVTRSV90
CVTRSV9D EQU   CVTRSV90
CVTRSV9C EQU   CVTRSV90
CVTRSV9B EQU   CVTRSV90
CVTRSV9A EQU   CVTRSV90
CVTNUCLS EQU   CVTXTNT2+4
CVTDSSVA EQU   CVTDSSV+1
CVTRSV89 EQU   CVTDSSV
CVTRSV88 EQU   CVTXTNT1+8
CVTRSV87 EQU   CVTXTNT1+4
CVTFACHN EQU   CVTXTNT1
CVTRV488 EQU   CVTMAP+412
CVTRV487 EQU   CVTMAP+408
CVTRV486 EQU   CVTMAP+404
CVTRV485 EQU   CVTMAP+400
CVTRV484 EQU   CVTMAP+396
CVTAUTH  EQU   CVTMAP+392
CVTATMCA EQU   CVTATMCT+1
CVTATMST EQU   CVTATMCT
CVTRSV61 EQU   CVTMAP+384
CVTVOLT1 EQU   CVTVOLM1+1
CVTVOLI1 EQU   CVTVOLF1
CVTSTOA  EQU   CVTMAP+376
CVTRSV58 EQU   CVTMAP+374
CVTRSV57 EQU   CVTMAP+372
CVTDDCE  EQU   CVTMAP+368
CVTPNWFR EQU   CVTMAP+364
CVTSMF   EQU   CVTMAP+360
CVTSULK  EQU   CVTMAP+358
CVTSLKO  EQU   CVTSYSK
CVTSLKP  EQU   CVTSYSK
CVTSLKQ  EQU   CVTSYSK
CVTSLKR  EQU   CVTSYSK
CVTRSV56 EQU   CVTSYSK
CVTRSV55 EQU   CVTSYSK
CVTRSV54 EQU   CVTSYSK
CVTRSV53 EQU   CVTSYSK
CVTRSV52 EQU   CVTA1F1
CVTRSV51 EQU   CVTA1F1
CVTRSV50 EQU   CVTA1F1
CVTRSV49 EQU   CVTA1F1
CVTRSV48 EQU   CVTA1F1
CVTRSV47 EQU   CVTA1F1
CVTSRSW  EQU   CVTA1F1
CVTPFSW  EQU   CVTA1F1
CVTPCVT  EQU   CVTMAP+352
CVTRSV46 EQU   CVTMAP+344
CVTRSV45 EQU   CVTMAP+340
CVTRSV44 EQU   CVTMAP+338
CVTRSV43 EQU   CVTMAP+336
CVTHJESA EQU   CVTHJES+1
CVTRSV42 EQU   CVTHJES
CVTEXT2A EQU   CVTEXT2+1
CVTRSV41 EQU   CVTEXT2
CVTAPFA  EQU   CVTAPF+1
CVTRSV40 EQU   CVTAPF
CVTRV518 EQU   CVTINTLA
CVTRV517 EQU   CVTERPV
CVTEORM  EQU   CVTMAP+312
CVTMCHPR EQU   CVTMAP+308
CVTTZ    EQU   CVTMAP+304
CVTJEPS  EQU   CVTMAP+300
CVTJESCT EQU   CVTMAP+296
CVTMODE  EQU   CVTMAP+292
CVTPTRV  EQU   CVTMAP+288
CVTREAL  EQU   CVTMAP+284
CVTRSV39 EQU   CVTMAP+280
CVTRSV38 EQU   CVTMAP+276
CVTDMSRA EQU   CVTDMSR+1
CVTRSV37 EQU   CVTDMSR
CVTQMSGA EQU   CVTQMSG+1
CVTRSV36 EQU   CVTQMSG
CVTAMFF  EQU   CVTMAP+264
CVTPURGA EQU   CVTPURG+1
CVTRSV35 EQU   CVTPURG
CVTCBSP  EQU   CVTMAP+256
CVTATERA EQU   CVTATER+1
CVTSYST  EQU   CVTATER
CVTVOLT2 EQU   CVTTAT
CVTVOLI2 EQU   CVTVOLF2
CVTAQAVB EQU   CVTAQAVT+1
CVTRSV34 EQU   CVTTCMFG
CVTRSV33 EQU   CVTTCMFG
CVTRSV32 EQU   CVTTCMFG
CVTRSV31 EQU   CVTTCMFG
CVTRSV30 EQU   CVTTCMFG
CVTRSV29 EQU   CVTTCMFG
CVTRSV28 EQU   CVTTCMFG
CVTTCRDY EQU   CVTTCMFG
CVTGTFA  EQU   CVTGTF+1
CVTRSV27 EQU   CVTGTFST
CVTRNIO  EQU   CVTGTFST
CVTRV319 EQU   CVTUSR
CVTRV318 EQU   CVTFORM
CVTRV317 EQU   CVTTMODE
CVTRV316 EQU   CVTSTATE
CVTRV315 EQU   CVTGTFS
CVTGTFAV EQU   CVTGTFS
CVT0SCR1 EQU   CVTMAP+232
CVTRV515 EQU   CVTMAP+228
CVTRMS   EQU   CVTMAP+224
CVTPATCH EQU   CVTMAP+220
CVTTSCE  EQU   CVTMAP+216
CVTLNKSC EQU   CVTMAP+214
CVTQABST EQU   CVTMAP+212
CVTMDLDS EQU   CVTMAP+208
CVTUSER  EQU   CVTMAP+204
CVTABEND EQU   CVTMAP+200
CVTSMCA  EQU   CVTMAP+196
CVTRSV18 EQU   CVTMAP+192
CVTQLPAQ EQU   CVTMAP+188
CVTQCDSR EQU   CVTMAP+184
CVTRSV17 EQU   CVTOPTB
CVTRSV16 EQU   CVTOPTB
CVTFP    EQU   CVTOPTB
CVTAPTHR EQU   CVTOPTB
CVTNLOG  EQU   CVTOPTB
CVTTOD   EQU   CVTOPTB
CVTCTIMS EQU   CVTOPTB
CVTPROT  EQU   CVTOPTB
CVTXPFP  EQU   CVTOPTA
CVTASCII EQU   CVTOPTA
CVTRSV13 EQU   CVTOPTA
CVTRSV12 EQU   CVTOPTA
CVTNIP   EQU   CVTOPTA
CVTDDR   EQU   CVTOPTA
CVTAPR   EQU   CVTOPTA
CVTCCH   EQU   CVTOPTA
CVTSNCTR EQU   CVTMAP+180
CVTQMWR  EQU   CVTMAP+176
CVTQOCR  EQU   CVTMAP+172
CVT1EF00 EQU   CVTMAP+168
CVTMZ00  EQU   CVTMAP+164
CVTHEAD  EQU   CVTMAP+160
CVTRSV11 EQU   CVTMAP+156
CVT0PT01 EQU   CVTMAP+152
CVTMSER  EQU   CVTMAP+148
CVTRV516 EQU   CVTIERLC
CVTILCH  EQU   CVTMAP+140
CVT0DS   EQU   CVTMAP+136
CVTFBOSV EQU   CVTMAP+132
CVTNUCB  EQU   CVTMAP+128
CVTIXAVL EQU   CVTMAP+124
CVTIOQET EQU   CVTMAP+120
CVTDCBA  EQU   CVTMAP+117
CVTMVS2  EQU   CVTDCB
CVT6DAT  EQU   CVTDCB
CVT4MPS  EQU   CVTDCB
CVTRSV09 EQU   CVTDCB
CVT4MS1  EQU   CVTDCB
CVT2SPS  EQU   CVTDCB
CVT1SSS  EQU   CVTDCB
CVTRSV08 EQU   CVTDCB
CVTSTB   EQU   CVTMAP+112
CVTQTD00 EQU   CVTMAP+108
CVTQTE00 EQU   CVTMAP+104
CVTCUCB  EQU   CVTMAP+100
CVTSJQ   EQU   CVTMAP+96
CVTPBLDL EQU   CVTMAP+92
CVTTPC   EQU   CVTMAP+88
CVTSVDCB EQU   CVTMAP+84
CVTBRET  EQU   CVTMAP+82
CVTEXIT  EQU   CVTMAP+80
CVT0FN00 EQU   CVTMAP+76
CVTDARA  EQU   CVTDAR+1
CVTRSV07 EQU   CVTFLGS1
CVTRSV06 EQU   CVTFLGS1
CVTRSV05 EQU   CVTFLGS1
CVTRSV04 EQU   CVTFLGS1
CVTRSV03 EQU   CVTFLGS1
CVTRSV02 EQU   CVTFLGS1
CVTRSV01 EQU   CVTFLGS1
CVTDMPLK EQU   CVTFLGS1
CVTXITP  EQU   CVTMAP+68
CVTZDTAB EQU   CVTMAP+64
CVTMSLT  EQU   CVTMAP+60
CVTDATE  EQU   CVTMAP+56
CVTBTERM EQU   CVTMAP+52
CVTSYSAD EQU   CVTMAP+48
CVTXTLER EQU   CVTMAP+44
CVTILK2  EQU   CVTMAP+40
CVTILK1  EQU   CVTMAP+36
CVTPRLTV EQU   CVTMAP+32
CVTPCNVT EQU   CVTMAP+28
CVT0VL00 EQU   CVTMAP+24
CVTXAPG  EQU   CVTMAP+20
CVTBUF   EQU   CVTMAP+16
CVTJOB   EQU   CVTMAP+12
CVTLINK  EQU   CVTMAP+8
CVT0EF00 EQU   CVTMAP+4
CVTTCBP  EQU   CVTMAP
CVT      EQU   CVTMAP
@NM00026 EQU   PSA+3412
PSASTAK  EQU   PSA+3072
@NM00025 EQU   PSA+1032
PSAUSEND EQU   PSA+1032
PSAPCPSW EQU   PSA+1024
PSARV060 EQU   PSA+1020
PSARV059 EQU   PSA+1018
PSASVC13 EQU   PSA+1016
PSALSFCC EQU   PSA+1012
PSASFACC EQU   PSA+1008
PSASTOP  EQU   PSA+992
PSASTART EQU   PSA+976
PSARSPSW EQU   PSA+968
PSASRPSW EQU   PSA+960
PSARV045 EQU   PSA+892
PSARV044 EQU   PSA+888
PSARV043 EQU   PSA+884
PSARV042 EQU   PSA+880
PSARV041 EQU   PSA+876
PSARV040 EQU   PSA+872
PSARV025 EQU   PSA+868
PSADSSED EQU   PSA+868
PSADSSPR EQU   PSA+864
PSADSSFW EQU   PSA+860
PSADSS14 EQU   PSA+856
PSADSSPP EQU   PSA+848
PSADSSRP EQU   PSA+840
PSADSS05 EQU   PSADSSF4
PSADSS10 EQU   PSADSSF4
PSADSSVE EQU   PSADSSF4
PSADSSDE EQU   PSADSSF4
PSADSSC0 EQU   PSADSSF4
PSADSSIE EQU   PSADSSF4
PSADSS12 EQU   PSADSSF4
PSADSSRC EQU   PSADSSF4
PSARV057 EQU   PSADSSF3
PSARV056 EQU   PSADSSF3
PSARV055 EQU   PSADSSF3
PSADSSMC EQU   PSADSSF3
PSADSSRW EQU   PSADSSF3
PSADSSNM EQU   PSADSSF3
PSADSSES EQU   PSADSSF3
PSADSSGP EQU   PSADSSF3
PSADSSF2 EQU   PSADSSFL+1
PSADSSPI EQU   PSADSSF1
PSADSSOI EQU   PSADSSF1
PSADSSSP EQU   PSADSSF1
PSADSSTP EQU   PSADSSF1
PSADSSDW EQU   PSADSSF1
PSADSSDD EQU   PSADSSF1
PSADSSDM EQU   PSADSSF1
PSADSSMV EQU   PSADSSF1
PSADSSTS EQU   PSA+816
PSADSSWK EQU   PSA+812
PSADSSR3 EQU   PSA+808
PSADSSR2 EQU   PSA+804
PSADSSRS EQU   PSA+800
PSASTOR  EQU   PSA+796
PSACPUSA EQU   PSA+794
PSAVSTAP EQU   PSA+792
PSAWKVAP EQU   PSA+788
PSAWKRAP EQU   PSA+784
PSAMCHIC EQU   PSA+783
PSARV061 EQU   PSA+782
PSASYMSK EQU   PSA+781
PSAMCHFL EQU   PSA+780
PSACR0   EQU   PSA+776
PSAPSWSV EQU   PSA+768
PSALITA  EQU   PSA+764
PSACLHS  EQU   PSAHLHI
PSALKR15 EQU   PSALKSA+60
PSALKR14 EQU   PSALKSA+56
PSALKR13 EQU   PSALKSA+52
PSALKR12 EQU   PSALKSA+48
PSALKR11 EQU   PSALKSA+44
PSALKR10 EQU   PSALKSA+40
PSALKR9  EQU   PSALKSA+36
PSALKR8  EQU   PSALKSA+32
PSALKR7  EQU   PSALKSA+28
PSALKR6  EQU   PSALKSA+24
PSALKR5  EQU   PSALKSA+20
PSALKR4  EQU   PSALKSA+16
PSALKR3  EQU   PSALKSA+12
PSALKR2  EQU   PSALKSA+8
PSALKR1  EQU   PSALKSA+4
PSALKR0  EQU   PSALKSA
PSARV023 EQU   PSACLHT+52
PSALOCAL EQU   PSACLHT+48
PSACMSL  EQU   PSACLHT+44
PSAOPTL  EQU   PSACLHT+40
PSATPACL EQU   PSACLHT+36
PSATPDNL EQU   PSACLHT+32
PSATPNCL EQU   PSACLHT+28
PSAIOSLL EQU   PSACLHT+24
PSAIOSUL EQU   PSACLHT+20
PSAIOSCL EQU   PSACLHT+16
PSAIOSSL EQU   PSACLHT+12
PSASALCL EQU   PSACLHT+8
PSAASML  EQU   PSACLHT+4
PSADISPL EQU   PSACLHT
PSASRSA  EQU   PSA+636
PSARV050 EQU   PSA+634
PSADSSGO EQU   PSA+633
PSARECUR EQU   PSA+632
PSAHLHIS EQU   PSA+628
PSAIPCSA EQU   PSA+624
@NM00024 EQU   PSA+621
PSAIPCDM EQU   PSA+620
PSAIPCD  EQU   PSA+616
@NM00023 EQU   PSA+613
PSAIPCRM EQU   PSA+612
PSAIPCR  EQU   PSA+608
PSAMCHEX EQU   PSA+600
PSAMPSW  EQU   PSA+592
PSAEXPS2 EQU   PSA+584
PSAEXPS1 EQU   PSA+576
PSAPIREG EQU   PSA+572
PSARSREG EQU   PSA+568
PSAGPREG EQU   PSA+556
PSARV022 EQU   PSASUP4
PSARV021 EQU   PSASUP4
PSARV020 EQU   PSASUP4
PSARV019 EQU   PSASUP4
PSARV018 EQU   PSASUP4
PSARV017 EQU   PSASUP4
PSARV016 EQU   PSASUP4
PSARV015 EQU   PSASUP4
PSARV014 EQU   PSASUP3
PSARV013 EQU   PSASUP3
PSARV012 EQU   PSASUP3
PSARV011 EQU   PSASUP3
PSARV010 EQU   PSASUP3
PSARV009 EQU   PSASUP3
PSARV008 EQU   PSASUP3
PSAIOSUP EQU   PSASUP3
PSALCR   EQU   PSASUP2
PSARTM   EQU   PSASUP2
PSAACR   EQU   PSASUP2
PSAIPCE2 EQU   PSASUP2
PSAIPCES EQU   PSASUP2
PSAIPCEC EQU   PSASUP2
PSAGTF   EQU   PSASUP2
PSAIPCRI EQU   PSASUP2
PSAIPCRP EQU   PSASUP1
PSAIPCDR EQU   PSASUP1
PSADISP  EQU   PSASUP1
PSALOCK  EQU   PSASUP1
PSAPI    EQU   PSASUP1
PSAEXT   EQU   PSASUP1
PSASVC   EQU   PSASUP1
PSAIO    EQU   PSASUP1
PSAANEW  EQU   PSA+544
PSATOLD  EQU   PSA+540
PSATNEW  EQU   PSA+536
PSALCCAR EQU   PSA+532
PSAPCCAR EQU   PSA+524
PSAPCCAV EQU   PSA+520
PSACPULA EQU   PSA+518
PSACPUPA EQU   PSA+516
PSAPSA   EQU   PSA+512
FLCHDEND EQU   PSA+512
FLCCRSAV EQU   FLCMCLA+280
FLCGRSAV EQU   FLCMCLA+216
FLCFPSAV EQU   FLCMCLA+184
FLCFLA   EQU   FLCMCLA+88
FLCRGNCD EQU   FLCMCLA+84
FLCFSAA  EQU   FLCFSA+1
@NM00022 EQU   FLCFSA
@NM00021 EQU   FLCMCLA+72
FLCMCIC  EQU   FLCMCLA+64
@NM00020 EQU   FLCMCLA+20
FLCIOAA  EQU   FLCIOA+1
@NM00019 EQU   FLCIOA
@NM00018 EQU   FLCMCLA+15
@NM00017 EQU   FLCMCLA+14
@NM00016 EQU   FLCMCLA+12
FLCLCL   EQU   FLCMCLA+8
FLCIOELA EQU   FLCIOEL+1
@NM00015 EQU   FLCIOEL
FLCCHNID EQU   FLCMCLA
@NM00014 EQU   PSA+160
FLCMTRCD EQU   PSA+157
@NM00013 EQU   PSA+156
FLCPERA  EQU   FLCPER+1
@NM00012 EQU   FLCPER
@NM00011 EQU   PSA+151
FLCPERCD EQU   PSA+150
FLCMCNUM EQU   PSA+149
@NM00010 EQU   PSA+148
FLCTEAA  EQU   FLCTEA+1
@NM00009 EQU   FLCTEA
PSAPIPC  EQU   PSAPICOD
PSAPIMC  EQU   PSAPICOD
PSAPIPER EQU   PSAPICOD
PSARV049 EQU   FLCPICOD
FLCPILCB EQU   FLCPIILC
@NM00008 EQU   FLCPIILC
@NM00007 EQU   PSAEPPSW
FLCSVCN  EQU   PSAESPSW+2
FLCSILCB EQU   FLCSVILC
@NM00006 EQU   FLCSVILC
@NM00005 EQU   PSAESPSW
FLCEICOD EQU   PSAEEPSW+2
PSASPAD  EQU   PSAEEPSW
@NM00004 EQU   PSA+128
FLCINPSW EQU   PSA+120
FLCMNPSW EQU   PSA+112
FLCPNPSW EQU   PSA+104
FLCSNPSW EQU   PSA+96
FLCENPSW EQU   PSA+88
FLCTRACE EQU   PSA+84
FLCTIMER EQU   PSA+80
FLCCVT2  EQU   PSA+76
FLCCAW   EQU   PSA+72
FLCCSW   EQU   PSA+64
FLCIOPSW EQU   PSA+56
FLCMOPSW EQU   PSA+48
FLCPOPSW EQU   PSA+40
FLCSOPSW EQU   PSA+32
FLCEOPSW EQU   PSA+24
@NM00003 EQU   FLCICCW2+4
FLCCVT   EQU   FLCICCW2
FLCICCW1 EQU   FLCROPSW
FLCIPPSW EQU   FLCRNPSW
*                                      END UNREFERENCED COMPONENTS
@ENDDATA EQU   *
         END   AHLMCER,(C'PL/S-II',0502,74116)
