WS06     TITLE 'AHLREADR, DATA INTERFACE TO THE TRACE WRITER           *
                        '
*                                                                  0028
*   /*****************************************************************/
*   /*                                                               */
*   /* STRUCTURE DECLARES                                            */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0028
*   ;                                                              0028
*                                                                  0028
*/*                                                                  */
*/*  FRR PARM SAVE AREA - ENTRY POINTS AHLREAD1 AND AHLRDFR ONLY     */
*/*                                                                  */
*                                                                  0029
*   DECLARE                                                        0029
*     1 FRRPARM BASED(R9PARM),      /* FRR PARM SAVE AREA            */
*       3 ECBSAVE PTR(31),          /* SAVE AREA FOR LOCAL ECB TO BE
*                                      POSTED                        */
*       3 SAVESRB PTR(31),          /* SRB@ FOR AHLREADR. IF 0 THE 0029
*                                      AREA HAS BEEN FREED OR SHOULD
*                                      NOT BE FREED ( THE PLIST HAS
*                                      BEEN QUEUED IN THE GTFPCT)    */
*       3 MCCESAVE PTR(31),         /* MCCE @                        */
*       3 GMANSAVE PTR(31),         /* SAVE AREA FOR @ OF 800 BYTE 0029
*                                      GETMAINED AREA. IF 0 THE AREA
*                                      HAS BEEN FREED                */
*       3 FRRTRAIL PTR(32),         /* TRAIL USED BY FRR ROUTINE   0029
*                                      (AHLRDFR) TO DETERMINE WHAT 0029
*                                      SHOULD BE CLEANED UP. THE   0029
*                                      TRAIL BITS ARE SET BY THE MAIN
*                                      ENTRY POINT (AHLREAD1). SEE 0029
*                                      ALSO SAVESRB AND GMANSAVE FOR
*                                      TRAIL INFORMATION USED BY THE
*                                      FRR ROUTINE                   */
*         5 MCENQD BIT(1),          /* THE MC CONTROL BLOCKS ARE   0029
*                                      ENQ'D ON                      */
*         5 LOCHELD BIT(1),         /* THE LOCAL LOCK IS HELD        */
*         5 SLOCHELD BIT(1),        /* THE SALLOC LOCK IS HELD       */
*         5 POSTDONE BIT(1),        /* LOCAL ECB HAS BEEN POSTED OR
*                                      DOES NOT NEED TO BE POSTED    */
*       3 RTNSAVE PTR(31);          /* R14 SAVE AREA               0029
*                                                                    */
*                                                                  0030
*/*                                                                  */
*/*  INPUT PARAMETER LIST - ENTRY POINTS AHLREAD1, AHLREAD2, AHLRDCU2,
*    AHLRDCU3                                                        */
*/*                                                                  */
*                                                                  0030
*   DECLARE                                                        0030
*     1 AHLRDPL BASED(PLISTREG),    /* INPUT PARAMETER LIST          */
*       3 AHLCHAIN PTR(31),         /* THIS IS THE AHLRDPLQ QUEUE  0030
*                                      CHAIN FIELD AND WILL POINT TO
*                                      THE NEXT AHLRDPL OR BE 0 -  0030
*                                      AHLREAD1 ONLY                 */
*       3 AHLRDID CHAR(8),          /* THIS ID IS MATCHED WITH THE 0030
*                                      MCQENAME FIELD TO DETERMINE 0030
*                                      WHICH APPLICATION THE DATA IS
*                                      TO COME FROM - AHLREAD1 ONLY  */
*       3 * PTR(16),                                               0030
*       3 AHLRDDID CHAR(6) BDY(WORD,3),/* DUMP ID                    */
*        4 AHLRDDASI PTR(16),       /* ASID OF ADDR SPACE BEING    0030
*                                      DUMPED                        */
*        4 AHLRDTCB PTR(31),        /* TCB ADDR FOR DUMP OR 0        */
*       3 AHLRDECB PTR(31),         /* ECB@ TO BE POSTED IN ERROR  0030
*                                      RECOVERY OR IF GTF NOT FOUND
*                                      (AHLREAD1) OR WHEN THE GTF  0030
*                                      WRITER COMPLETES THE DUMP   0030
*                                      REQUEST (AHLREAD2)            */
*       3 AHLRDATA PTR(31),         /* ADDR OF DATA AREA             */
*       3 AHLRDASC PTR(31),         /* ASCB ADDR WHERE ECB IS LOCATED*/
*       3 AHLPCOD FIXED(31),        /* COMPLETION CODE TO BE USED IN
*                                      POSTING THE LOCAL ECB -     0030
*                                      AHLREAD2 AND AHLRDCU3 ONLY    */
*       3 AHLRDSRB PTR(31);         /* ADDR OF STORAGE OBTAINED FOR
*                                      AHLREADR'S SRBS. THE SAME SRB
*                                      IS USED BOTH FOR AHLREAD1 AND
*                                      AHLREAD2. THE SRB IS        0030
*                                      IMMEDIATELY FOLLOWED BY THIS
*                                      PARMLIST WHICH MUST BE FREED
*                                      WHEN THE SRB IS FREED         */
*/* STORAGE LIST FOR SDUMP                                           */
*                                                                  0031
*   DECLARE                                                        0031
*     1 READRMOD STATIC LOCAL,                                     0031
*       3 * PTR(31) INIT(ADDR(AHLREADR)),/* ADDR OF START OF MODULE  */
*       3 * PTR(32),                                               0031
*         5 * BIT(8) INIT('80'X),   /* END OF LIST INDICATOR         */
*         5 * PTR(24) INIT(ADDR(AHLREADN));/* ADDR OF END OF MODULE
*                                                                    */
*                                                                  0032
*   /*****************************************************************/
*   /*                                                               */
*   /* CONSTANT DECLARES                                             */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0032
*   DECLARE                                                        0032
*     ON BIT(1) CONSTANT('1'B),     /* USED TO TURN BITS ON          */
*     OFF BIT(1) CONSTANT('0'B),    /* USED TO TURN BITS OFF         */
*     ECBSIGN BIT(32) CONSTANT('80000000'X),/* USED TO TURN ON HIGH
*                                      ORDER BIT IN REGISTER       0032
*                                      CONTAINING ECB@ FOR     XMPOST*/
*     ERRCODE FIXED(8) CONSTANT(4), /* ERROR RETURN CODE             */
*     XPOSTCD FIXED(8) CONSTANT(0); /* RETURN CODE FOR CROSS-MEMORY
*                                      POST                          */
*   GEN;                                                           0033
AHLRDSP EQU   245       SUBPOOL FOR GETMAINS AND FREEMAINS
*                                                                  0034
*   /*****************************************************************/
*   /*                                                               */
*   /* MISCELLANEOUS DECLARES                                        */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0034
*   DECLARE                                                        0034
*     READBASE PTR(31) INIT(ADDR(AHLREADR)) STATIC LOCAL;/* BASE ADDR*/
*   DECLARE                                                        0035
*     CVTPTR PTR(31) DEFINED(FLCCVT);/* BASE FOR CVT                 */
*   DECLARE                                                        0036
*     FRRSPTR PTR(31) BASED,        /* INCLUDED TO ELIMINATE ERRORS  */
*     FRREPTR PTR(31) BASED,        /* DURING COMPILATION            */
*     AWSAPTR PTR(31) BASED,        /* DITTO                         */
*     ASCBPTR PTR(31) BASED;        /* DITTO                         */
*   DECLARE                                                        0037
*     ACRADDR LABEL BASED(SDWANXT1),/* MAPS ACR RETRY ADDRESS        */
*     SRBADDR LABEL BASED(RTNSAVE); /* MAPS ALL OTHER RETRY ADDRESSES*/
*   DECLARE                                                        0038
*     RECID CHAR(24) INIT('AHLREADRAHLREADRAHLRDFR ') STATIC LOCAL;
*   DECLARE                                                        0039
*     CLRPARM BIT(192) BASED(R1) BDY(WORD);/* USED TO CLEAR SVCDUMP'S
*                                      PARMLIST                      */
*   DECLARE                                                        0040
*     I256C CHAR(256) BASED;                                       0040
*   DECLARE                                                        0041
*     AHLREAD2 LABEL LOCAL EXTERNAL,/* DECLARE LABEL FOR ENTRY       */
*     AHLRDCU3 LABEL LOCAL EXTERNAL,/* DECLARE LABEL FOR ENTRY       */
*     AHLRDXP1 LABEL LOCAL EXTERNAL,/* DECLARE LABEL FOR ENTRY       */
*     AHLRDFR LABEL LOCAL EXTERNAL; /* DECLARE LABEL FOR ENTRY     0041
*                                                                    */
*   RFY                                                            0042
*     MCCE BASED(R0);                                              0042
*   RFY                                                            0043
*     MCQE BASED(MCQEPNT);                                         0043
*   GEN REFS(AHLREAD1,AHLRDCU2) NOEXIT NOFLOWS SEQFLOW;            0044
AHLREADR CSECT
         DC    A(AHLREAD1)         ADCON FOR MAIN ENTRY POINT
         DC    A(AHLRDCU2)         ADCON FOR ITS RMTR ENTRY POINT
*AHLREAD1:                                                         0045
*   GEN SETS(BASEREG) REFS(R15ENTRY,READBASE) NOEXIT NOFLOWS SEQFLOW
*       NODEFS;                                                    0045
*                                                                  0045
AHLREAD1 DS    0H                                                  0045
         USING AHLREAD1,R15ENTRY   SETUP TEMP BASE
         L     BASEREG,READBASE    GET BASE ADDRESS UPON ENTRY
         USING AHLREADR,BASEREG    TELL ASSEMBLER ABOUT OUR BASE
         DROP  R15ENTRY            TELL ASSEMBLER TO QUIT USING R15
*   /*****************************************************************/
*   /*                                                               */
*   /* THIS ENTRY POINT PERFORMS MAIN LINE FUNCTIONS - QUEUING THE   */
*   /* PLIST ONTO THE CHAIN IN THE GTFPCT AND NOTIFYING THE GTF      */
*   /* WRITER VIA A CROSS-MEMORY POST TO DUMP THE GTF BUFFERS        */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0046
*   DO;                                                            0046
*                                                                  0046
*     /***************************************************************/
*     /*                                                             */
*     /* HOUSEKEEPING - DEFINE THE ERROR ENVIRONMENT VIA SETFRR AND  */
*     /* SAVE REG14, REQUESTOR'S ECB@ AND AHLREAD1'S SRB@ IN THE FRR */
*     /* PARM AREA. THE ECB MUST BE POSTED DURING ERROR RECOVERY     */
*     /* PROCESSING OR IF GTF IS NOT RUNNING. THE SRB MUST BE        */
*     /* FREEMAINED BOTH DURING NORMAL PROCESSING AND ERROR RECOVERY */
*     /* IF THE PARMLIST IS NOT QUEUED                               */
*     /*                                                             */
*     /***************************************************************/
*                                                                  0047
*     RFY                                                          0047
*      (R14,                                                       0047
*       FRRADDR,                                                   0047
*       R12WORK,                                                   0047
*       PLISTREG,                                                  0047
*       R1) RSTD;                                                  0047
*     PLISTREG=R1;                  /* SAVE PARMLIST ADDRESS         */
         LR    PLISTREG,R1                                         0048
*     RFY                                                          0049
*       R1 UNRSTD;                                                 0049
*     FRRADDR=ADDR(AHLRDFR);        /* GET @ OF THE RECOVERY ROUTINE */
         LA    FRRADDR,AHLRDFR                                     0050
*     GEN SETS(R9PARM,R12WORK) REFS(FRRADDR,PSACSTK,FRRSCURR,FRRSLAST,
*         FRRSENTR,FRRS,PSA,PSALSFCC,FRRSELEN,FRRSFRRA,FRRSPARM) NOEXIT
*         NOFLOWS SEQFLOW;                                         0051
         SETFRR A,FRRAD=(FRRADDR),PARMAD=(R9PARM),                     *
               WRKREGS=(R9PARM,R12WORK)  ADD FRR ROUTINE TO STACK
*     RTNSAVE=R14;                  /* SAVE SCHEDULER RETURN @       */
         ST    R14,RTNSAVE(,R9PARM)                                0052
*     RFY                                                          0053
*      (R14,                                                       0053
*       FRRADDR,                                                   0053
*       R12WORK) UNRSTD;                                           0053
*     ECBSAVE=AHLRDECB;             /* SAVE ECB @                    */
         MVC   ECBSAVE(4,R9PARM),AHLRDECB(PLISTREG)                0054
*     SAVESRB=AHLRDSRB;             /* SAVE SRB @                  0055
*                                                                    */
         MVC   SAVESRB(4,R9PARM),AHLRDSRB(PLISTREG)                0055
*                                                                  0056
*     /***************************************************************/
*     /*                                                             */
*     /* ENQ ON THE MC CONTROL BLOCKS TO PREVENT THEIR CHANGING WHILE*/
*     /* I AM SCANNING AND USING THEM. THE @ OF THE MCCE WILL BE     */
*     /* RETURNED IN R0. THE MCCE @ MUST BE SAVED FOR USE IN DEQUING */
*     /* THE CONTROL BLOCKS LATER                                    */
*     /*                                                             */
*     /***************************************************************/
*                                                                  0056
*     DO;                                                          0056
*                                                                  0056
*       /*************************************************************/
*       /*                                                           */
*       /* THE ENQING MACRO EXPECTS REG3 TO CONTAIN THE @ OF THE     */
*       /* MCAWSA. A BRANCH ENTRY GETMAIN IS REQUIRED TO FULFILL THIS*/
*       /* REQUIREMENT                                               */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0057
*       DO;                                                        0057
*                                                                  0057
*         /***********************************************************/
*         /*                                                         */
*         /* THE SALLOC LOCK MUST BE HELD BEFORE PERFORMING A BRANCH */
*         /* ENTRY GETMAIN FOR SUBPOOL AHLRDSP                       */
*         /*                                                         */
*         /***********************************************************/
*                                                                  0058
*         GEN REFS(PSALITA,FLC) EXIT NOFLOWS SEQFLOW;              0058
GETSAL3  SETLOCK OBTAIN,TYPE=SALLOC,MODE=UNCOND,                       *
               RELATED=(GLOBAL,AHLREADR(FREESAL3,FREESAL4))
*         SLOCHELD=ON;              /* INDICATE SALLOC LOCK HELD   0059
*                                                                    */
         OI    SLOCHELD(R9PARM),B'00100000'                        0059
*                                                                  0060
*         /***********************************************************/
*         /*                                                         */
*         /* GET THE DUMMY MCAWSA                                    */
*         /*                                                         */
*         /***********************************************************/
*                                                                  0060
*         RFY                                                      0060
*          (R0,                                                    0060
*           R1,                                                    0060
*           R15,                                                   0060
*           CODERG) RSTD;                                          0060
*         R0=LENGTH(MCAWSA);        /* LENGTH OF AREA TO BE ACQUIRED */
         LA    R0,800                                              0061
*         GEN SETS(R14,R15,R1,R3,R4) REFS(R0,CVTSPSA,WSAGGMFM,WSAG,
*             CVTGLMN,CVTMAP) EXIT SEQFLOW NOFLOWS;                0062
         GETMAIN RC,LV=(0),SP=AHLRDSP,BRANCH=(YES,GLOBAL)
*         CODERG=R15;               /* SAVE RETURN CODE              */
         LR    CODERG,R15                                          0063
*         RFY                                                      0064
*           R3 RSTD;                                               0064
*         R3=R1;                    /* LOAD ADDRESS OF 'MCAWSA' INTO
*                                      R3 FOR SETEVENT SERVICE (ENQ) */
         LR    R3,R1                                               0065
*         RFY                                                      0066
*          (R1,                                                    0066
*           R15) UNRSTD;                                           0066
*                                                                  0066
*         /***********************************************************/
*         /*                                                         */
*         /* RELEASE SALLOC LOCK                                     */
*         /*                                                         */
*         /***********************************************************/
*                                                                  0067
*         GEN REFS(PSALITA,FLC) EXIT NOFLOWS SEQFLOW;              0067
FREESAL3 SETLOCK RELEASE,TYPE=SALLOC,                                  *
               RELATED=(GLOBAL,AHLREADR(GETSAL3))
*         SLOCHELD=OFF;             /* INDICATE SALLOC LOCK NOT HELD */
         NI    SLOCHELD(R9PARM),B'11011111'                        0068
*       END;                                                       0069
*                                                                  0069
*       /*************************************************************/
*       /*                                                           */
*       /* CHECK FOR SUCCESSFUL GETMAIN                              */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0070
*       IF CODERG^=0 THEN           /* CHECK FOR SUCCESSFUL GETMAIN  */
         SLR   @12,@12                                             0070
         CR    CODERG,@12                                          0070
         BNE   @RT00070                                            0070
*         GO TO CLEANUP;            /* UNSUCCESSFUL - POST REQUESTOR */
*       RFY                                                        0072
*         CODERG UNRSTD;                                           0072
*       GMANSAVE=R3;                /* SAVE ADDRESS OF GETMAINED AREA
*                                                                    */
         ST    R3,GMANSAVE(,R9PARM)                                0073
*       MCENQD=ON;                  /* INDICATE THAT DEQ OF MC     0074
*                                      CONTROL BLOCKS WILL BE      0074
*                                      REQUIRED                      */
*                                                                  0074
         OI    MCENQD(R9PARM),B'10000000'                          0074
*       /*************************************************************/
*       /*                                                           */
*       /* ENQ ON THE MC CONTROL BLOCKS                              */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0075
*       DO;                         /* SETEVENT ACTION(ENQ)          */
*                                                                  0075
*         /***********************************************************/
*         /*                                                         */
*         /* THE FOLLOWING SECTION OF CODE IS GENERATED BY THE       */
*         /* SETEVENT MACRO. THIS CODE WILL BE EITHER AN INITIALIZED */
*         /* PARAMETER LIST, OR IF IT IS THE RESULT OF STANDARD OR   */
*         /* EXECUTE FORM IT WILL FILL in the list, GENERATE ALL     */
*         /* LINKAGES AND CALL THE PROPER sERVICE, EITHER AHLSETEV OR*/
*         /* AHLSETD                                                 */
*         /*                                                         */
*         /***********************************************************/
*                                                                  0076
*         DCL                                                      0076
*           AHLPPTR REG(1) PTR(31) RSTD;/* PARAMETER LIST ADDRESS    */
*         DCL                                                      0077
*           AHLSETEV ENTRY OPTIONS(EXIT,SEQFLOW) BASED(MCHSETE) VALRG(0
*               );                  /* ENTRY FOR ADD ACTIVAT,FREE    */
*         DCL                                                      0078
*           AHLSETD ENTRY OPTIONS(EXIT,SEQFLOW) BASED(MCHSETD) VALRG(0)
*             ;                     /* ENTRY FOR DISABLE AND CHANGE  */
*         DCL                                                      0079
*           1 SEPL BASED(AHLPPTR) BDY(WORD),/* DSECT PARAMETER LIST  */
*            2 SEFG PTR(8),         /* ACTION GLAGS                  */
*            2 * PTR(8),                                           0079
*            2 SEEN PTR(8),         /* EID COUNT                     */
*            2 SECN PTR(8),         /* CLASS COUNT                   */
*            2 SENM CHAR(8),        /* APPLICATION NMAE              */
*            2 SEEL PTR(31),        /* ADDRESS OF LIST OF EIDS       */
*            2 SECL PTR(31),        /* ADDRESS OF LIST OF CLASSES    */
*            2 SEMC PTR(31);        /* MCQE ADDRESS                  */
*         AHLPPTR=0;                /* SET TO INDCIATE ENQ           */
         LR    AHLPPTR,@12                                         0080
*         CALL AHLSETD;                                            0081
         L     @12,CVTPTR                                          0081
         L     @12,CVTGTF(,@12)                                    0081
         L     @15,MCHSETD(,@12)                                   0081
         BALR  @14,@15                                             0081
*       END;                        /* LOCK UP THE MC CONTROL BLOCKS */
*       ;                                                          0083
*       MCCESAVE=R0;                /* SAVE THE MCCE @ IN THE FRR  0084
*                                      PARM AREA                     */
         ST    R0,MCCESAVE(,R9PARM)                                0084
*       RFY                                                        0085
*         R3 UNRSTD;                                               0085
*     END;                                                         0086
*                                                                  0087
*     /***************************************************************/
*     /*                                                             */
*     /* SCAN THE MCQE CHAIN LOOKING FOR THE GTF MCQE. IF FOUND      */
*     /* NORMAL PROCESSING WILL CONTINUE, IF NOT CLEANUP FUNCTIONS   */
*     /* MUST BE PERFORMED                                           */
*     /*                                                             */
*     /***************************************************************/
*                                                                  0087
*     IF R0=0 THEN                  /* WAS THE MCCE @ RETURNED ?     */
         LTR   R0,R0                                               0087
         BZ    @RT00087                                            0087
*       GO TO CLEANUP;              /* IF NOT THE CHAIN CANNOT BE  0088
*                                      SCANNED                       */
*     RFY                                                          0089
*       MCQEPNT RSTD;                                              0089
*     MCQEPNT=MCCEQEA;              /* GET @ OF START OF MCQE QUEUE
*                                      FROM THE MCCE                 */
         LR    @12,R0                                              0090
         L     MCQEPNT,MCCEQEA(,@12)                               0090
*     RFY                                                          0091
*       R0 UNRSTD;                                                 0091
*MCQESCAN:                                                         0092
*     DO;                                                          0092
MCQESCAN DS    0H                                                  0093
*       IF MCQEPNT=0 THEN           /* END OF QUEUE?                 */
         LTR   MCQEPNT,MCQEPNT                                     0093
         BZ    @RT00093                                            0093
*         GO TO CLEANUP;            /* YES - GTF IS NOT ON MCQE CHAIN*/
*/*                    OTHERWISE CONTINUE SCANNING QUEUE             */
*                                                                  0095
*       IF MCQENAME=AHLRDID THEN    /* IS IT THE GTF MCQE ?          */
         CLC   MCQENAME(8,MCQEPNT),AHLRDID(PLISTREG)               0095
         BE    @RT00095                                            0095
*         GO TO GOODMCQE;           /* YES - GET OUT OF SCAN LOOP    */
*       ELSE                                                       0097
*         DO;                                                      0097
*           MCQEPNT=MCQEMCQE;       /* STEP TO NEXT MCQE ON QUEUE    */
         L     MCQEPNT,MCQEMCQE(,MCQEPNT)                          0098
*           GO TO MCQESCAN;         /* CONTINUE LOOKING FOR END OF 0099
*                                      QUEUE OR GTF MCQE             */
         B     MCQESCAN                                            0099
*         END;                                                     0100
*     END;                                                         0101
*GOODMCQE:                                                         0102
*                                                                  0102
*     /***************************************************************/
*     /*                                                             */
*     /* IF THIS IS GTF'S ADDR SPACE BEING DUMPED, DO NOT ATTEMPT TO */
*     /* GET TRACE DATA FROM THE TRACE WRITER BECAUSE IT IS MARKED   */
*     /* NONDISPATCHABLE.                                    @YM03681*/
*     /*                                                             */
*     /***************************************************************/
*                                                                  0102
*     IF MCQEASCB=AHLRDASC THEN                                    0102
GOODMCQE CLC   MCQEASCB(4,MCQEPNT),AHLRDASC(PLISTREG)              0102
         BE    @RT00102                                            0102
*       GO TO CLEANUP;                                             0103
*                                                                  0103
*     /***************************************************************/
*     /*                                                             */
*     /* ENSURE THAT THE GTFPCT POINTER IS GOOD AND ADD THE INPUT    */
*     /* PLIST TO THE QUEUE IN THE PCT. THE GTF WRITER WILL LATER    */
*     /* DEQUE THE PLIST. ONCE ON THE QUEUE THE PLIST MAY NOT BE     */
*     /* REFERENCED AGAIN BY THIS PROGRAM. A COMPARE & SWAP IS USED  */
*     /* TO OBTAIN A STABLE COPY OF THE QUEUE BEFORE ADDING THE PLIST*/
*     /*                                                             */
*     /***************************************************************/
*                                                                  0104
*     RFY                                                          0104
*       PCTPTR RSTD;                                               0104
*     PCTPTR=MCQEAT;                /* GET @ OF GTFPCT               */
         L     PCTPTR,MCQEAT(,MCQEPNT)                             0105
*     RFY                                                          0106
*       MCQEPNT UNRSTD;                                            0106
*     IF PCTPTR=0 THEN              /* IS THERE A GTFPCT ?           */
         LTR   PCTPTR,PCTPTR                                       0107
         BZ    @RT00107                                            0107
*       GO TO CLEANUP;              /* NO - THE PLIST CANNOT BE    0108
*                                      QUEUED                        */
*     DO;                                                          0109
*                                                                  0109
*       /*************************************************************/
*       /*                                                           */
*       /* UPDATE THE SRB FOR AHLREAD1 FOR USE WITH AHLREAD2. THE GTF*/
*       /* WRITER WILL USE THIS SRB IN SCHEDULING REENTRY TO AHLREADR*/
*       /* TO POST THE REQUEST ORIGINATOR                            */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0110
*       RFY                                                        0110
*         SRBPTR RSTD;                                             0110
*       SRBPTR=AHLRDSRB;            /* GET POINTER TO SRB            */
         L     SRBPTR,AHLRDSRB(,PLISTREG)                          0111
*       SRBEP=ADDR(AHLREAD2);       /* FILL IN ADDRESS OF SRB ROUTINE*/
         LA    @12,AHLREAD2                                        0112
         ST    @12,SRBEP(,SRBPTR)                                  0112
*       SRBRMTR=ADDR(AHLRDCU3);     /* AND THE ADDRESS OF ITS      0113
*                                      RESOURCE MANAGER TERMINATION
*                                      ROUTINE                       */
         LA    @12,AHLRDCU3                                        0113
         ST    @12,SRBRMTR(,SRBPTR)                                0113
*       RFY                                                        0114
*         SRBPTR UNRSTD;                                           0114
*                                                                  0115
*       /*************************************************************/
*       /*                                                           */
*       /* COMPLETE THE PARMLIST (AHLRDPLQ CHAINING) AND ADD IT TO   */
*       /* THE QUEUE                                                 */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0115
*       RFY                                                        0115
*         R12WORK RSTD;                                            0115
*       R12WORK=AHLRDPLQ;           /* GET @ OF LAST ITEM PLACED ON
*                                      QUEUE                         */
         L     R12WORK,AHLRDPLQ(,PCTPTR)                           0116
*ADDPLIST:                                                         0117
*       AHLCHAIN=R12WORK;           /* PUSH IT DOWN IN THE QUEUE   0117
*                                      (LIFO)                        */
ADDPLIST ST    R12WORK,AHLCHAIN(,PLISTREG)                         0117
*       CS(R12WORK,PLISTREG,AHLRDPLQ);/* C&S TO PLACE THIS PLIST AT
*                                      TOP OF QUEUE IN PCT           */
         CS    R12WORK,PLISTREG,AHLRDPLQ(PCTPTR)                   0118
*       BC(4,ADDPLIST);             /* QUEUE WAS UPDATED SINCE WE  0119
*                                      LAST LOOKED AT IT - CONTINUE
*                                      ATTEMPT TO GET A STABLE COPY
*                                      OF THE PLIST. R12WORK HAS NEW
*                                      LAST ITEM PLACED ON THE QUEUE */
         BC    4,ADDPLIST                                          0119
*       RFY                                                        0120
*        (R12WORK,                                                 0120
*         PLISTREG) UNRSTD;                                        0120
*                                                                  0120
*/*                      THE COMPARE AND SWAP WAS SUCCESSFUL - THE   */
*/*                      PLIST HAS BEEN ADDED TO THE AHLRDPLQ IN     */
*/*                      THE GTFPCT                                  */
*                                                                  0121
*       SAVESRB=0;                  /* INDICATE THAT THE SRB SHOULD
*                                      NOT BE FREEMAINED DURING    0121
*                                      NORMAL CLEANUP OR FRR       0121
*                                      PROCESSING                    */
         SLR   @12,@12                                             0121
         ST    @12,SAVESRB(,R9PARM)                                0121
*       POSTDONE=ON;                /* INDICATE LOCAL POST NOT     0122
*                                      REQUIRED DURING CLEANUP       */
         OI    POSTDONE(R9PARM),B'00010000'                        0122
*     END;                                                         0123
*                                                                  0124
*     /***************************************************************/
*     /*                                                             */
*     /* PERFORM A CROSS-MEMORY POST TO NOTIFY THE GTF WRITER TO DUMP*/
*     /* THE GTF BUFFERS. A BRANCH & LINK ENTRY TO THE POST ROUTINE  */
*     /* IS USED SINCE AHLREADR IS AN SRB ROUTINE                    */
*     /*                                                             */
*     /***************************************************************/
*                                                                  0124
*     DO;                                                          0124
*                                                                  0124
*       /*************************************************************/
*       /*                                                           */
*       /* THE SALLOC LOCK MUST BE OBTAINED BEFORE PERFORMING A      */
*       /* CROSS-MEMORY POST                                         */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0125
*       GEN REFS(PSALITA,FLC) EXIT NOFLOWS SEQFLOW;                0125
GETSAL1  SETLOCK OBTAIN,TYPE=SALLOC,MODE=UNCOND,                       *
               RELATED=(GLOBAL,AHLREADR(FREESAL1,FREESAL4))
*       SLOCHELD=ON;                /* INDICATE THAT THE SALLOC LOCK
*                                      IS HELD                       */
*                                                                  0126
         OI    SLOCHELD(R9PARM),B'00100000'                        0126
*       /*************************************************************/
*       /*                                                           */
*       /* SET UP FOR BRANCH & LINK ENTRY TO CROSS MEMORY POST       */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0127
*       RFY                                                        0127
*        (POSTRTN,                                                 0127
*         POSTECB,                                                 0127
*         POSTERR,                                                 0127
*         POSTASCB,                                                0127
*         POSTECB,                                                 0127
*         R15,                                                     0127
*         R14) RSTD;                                               0127
*       POSTRTN=XPOSTCD;            /* COMPLETION CODE               */
         SLR   POSTRTN,POSTRTN                                     0128
*       POSTECB=ADDR(WRTRCOM);      /* GTF WRITER'S ECB @            */
         LA    POSTECB,WRTRCOM(,PCTPTR)                            0129
*       POSTECB=POSTECB|ECBSIGN;    /* TURN ON SIGN BIT - RQ'D BY  0130
*                                      XMPOST                        */
         O     POSTECB,@CF01791                                    0130
*       POSTERR=ADDR(AHLRDXP1);     /* ADDR TO WHICH CONTROL IS TO BE
*                                      GIVEN IF XMPOST FAILS         */
         LA    POSTERR,AHLRDXP1                                    0131
*       POSTASCB=GTFASCB;           /* GTF ASCB @                    */
         L     POSTASCB,GTFASCB(,PCTPTR)                           0132
*       R15=CVT0PT01;               /* @ OF CROSS-MEMORY POST ROUTINE*/
         L     @04,CVTPTR                                          0133
         L     R15,CVT0PT01(,@04)                                  0133
*       RFY                                                        0134
*         PCTPTR UNRSTD;                                           0134
*                                                                  0135
*       /*************************************************************/
*       /*                                                           */
*       /* PERFORM CROSS-MEMORY POST                                 */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0135
*       GEN SETS(R14) REFS(R15) EXIT SEQFLOW NOFLOWS(BALR  R14,R15);
         BALR  R14,R15
*       RFY                                                        0136
*        (POSTRTN,                                                 0136
*         POSTECB,                                                 0136
*         POSTERR,                                                 0136
*         POSTASCB,                                                0136
*         POSTECB,                                                 0136
*         R15) UNRSTD;                                             0136
*UNLOCK:                                                           0137
*                                                                  0137
*       /*************************************************************/
*       /*                                                           */
*       /* BASE REGISTER MUST BE RESTORED AND SALLOC LOCK RELEASED   */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0137
*       GEN SETS(BASEREG) REFS(R14) NOEXIT NOFLOWS SEQFLOW;        0137
UNLOCK   DS    0H                                                  0137
         DROP  BASEREG
         USING UNLOCK,R14          SETUP TEMP BASE
         L     BASEREG,READBASE    GET BASE ADDRESS AT MAIN ENTRY
         USING AHLREADR,BASEREG    TELL ASSEMBLER ABOUT OUR BASE
         DROP  R14                 TELL ASSEMBLER TO QUIT USING R14
*       RFY                                                        0138
*         R14 UNRSTD;                                              0138
*       GEN REFS(PSALITA,FLC) EXIT NOFLOWS SEQFLOW;                0139
FREESAL1 SETLOCK RELEASE,TYPE=SALLOC,                                  *
               RELATED=(GLOBAL,AHLREADR(GETSAL1))
*       SLOCHELD=OFF;               /* INDICATE THAT THE SALLOC LOCK
*                                      HAS BEEN RELEASED             */
         NI    SLOCHELD(R9PARM),B'11011111'                        0140
*     END;                                                         0141
*     RFY                                                          0142
*       SAVER14 RSTD;                                              0142
*     SAVER14=RTNSAVE;              /* RELOAD R14 RETURN ADDRESS TO
*                                      MAKE FOLLOWING CODE USEABLE BY
*                                      AHLREAD1 AND AHLRDFR        0143
*                                                                    */
         L     SAVER14,RTNSAVE(,R9PARM)                            0143
*                                                                  0144
*     /***************************************************************/
*     /*                                                             */
*     /* RELEASE THE MC CONTROL BLOCKS. THE MCCE @ MUST BE IN REG0   */
*     /* AND THE 'MCAWSA' @ IN REG3                                  */
*     /*                                                             */
*     /***************************************************************/
*                                                                  0144
*MCDEQ:                                                            0144
*     RFY                                                          0144
*      (R0,                                                        0144
*       R3) RSTD;                                                  0144
MCDEQ    DS    0H                                                  0145
*     R3=GMANSAVE;                  /* RESTORE 'MCAWSA' BASE         */
         L     R3,GMANSAVE(,R9PARM)                                0145
*     IF MCENQD=OFF THEN            /* IS A DEQ REQUIRED ?           */
         TM    MCENQD(R9PARM),B'10000000'                          0146
         BZ    @RT00146                                            0146
*       GO TO FREEMCA;              /* NO - BYPASS DEQ OF MC CONTROL
*                                      BLOCKS                        */
*     R0=MCCESAVE;                  /* RESTORE MCCE BASE             */
         L     R0,MCCESAVE(,R9PARM)                                0148
*     DO;                           /* SETEVENT ACTION(DEQ)          */
*                                                                  0149
*       /*************************************************************/
*       /*                                                           */
*       /* THE FOLLOWING SECTION OF CODE IS GENERATED BY THE SETEVENT*/
*       /* MACRO. THIS CODE WILL BE EITHER AN INITIALIZED PARAMETER  */
*       /* LIST, OR IF IT IS THE RESULT OF STANDARD OR EXECUTE FORM  */
*       /* IT WILL FILL in the list, GENERATE ALL LINKAGES AND CALL  */
*       /* THE PROPER sERVICE, EITHER AHLSETEV OR AHLSETD            */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0150
*       AHLPPTR=0;                  /* SET TO INDCIATE ENQ           */
         SLR   AHLPPTR,AHLPPTR                                     0150
*       AHLPPTR=AHLPPTR-1;          /* MODIFY TO INDICATE DEQ        */
         BCTR  AHLPPTR,0                                           0151
*       CALL AHLSETD;                                              0152
         L     @12,CVTPTR                                          0152
         L     @12,CVTGTF(,@12)                                    0152
         L     @15,MCHSETD(,@12)                                   0152
         BALR  @14,@15                                             0152
*     END;                          /* FREE UP THE CONTROL BLOCKS    */
*     MCENQD=OFF;                   /* INDICATE THAT THE MC CONTROL
*                                      BLOCKS HAVE BEEN DEQ'D      0154
*                                                                    */
         NI    MCENQD(R9PARM),B'01111111'                          0154
*FREEMCA:                                                          0155
*                                                                  0155
*     /***************************************************************/
*     /*                                                             */
*     /* CHECK FOR AREAS TO BE FREEMAINED                            */
*     /*                                                             */
*     /***************************************************************/
*                                                                  0155
*     IF R3^=0|SAVESRB^=0 THEN      /* ARE THERE ANY FREEMAINS TO BE
*                                      PERFORMED                     */
FREEMCA  SLR   @12,@12                                             0155
         CR    R3,@12                                              0155
         BNE   @RT00155                                            0155
         C     @12,SAVESRB(,R9PARM)                                0155
         BE    @RF00155                                            0155
@RT00155 DS    0H                                                  0156
*       DO;                         /* YES                           */
*                                                                  0156
*         /***********************************************************/
*         /*                                                         */
*         /* THE SALLOC LOCK MUST BE OBTAINED BEFORE PERFORMING A    */
*         /* BRANCH AND LINK FREEMAIN                                */
*         /*                                                         */
*         /***********************************************************/
*                                                                  0157
*         GEN REFS(PSALITA,FLC) EXIT NOFLOWS SEQFLOW;              0157
GETSAL2  SETLOCK OBTAIN,TYPE=SALLOC,MODE=UNCOND,                       *
               RELATED=(GLOBAL,AHLREADR(FREESAL2,FREESAL4))
*         SLOCHELD=ON;              /* INDICATE THAT THE SALLOC LOCK
*                                      IS HELD                       */
*                                                                  0158
         OI    SLOCHELD(R9PARM),B'00100000'                        0158
*         /***********************************************************/
*         /*                                                         */
*         /* FREE THE DUMMY MCAWSA OBTAINED FROM SQA. A BRANCH AND   */
*         /* LINK ENTRY IS REQUIRED SINCE AHLREADR IS AN SRB ROUTINE */
*         /*                                                         */
*         /***********************************************************/
*                                                                  0159
*         DO;                                                      0159
*                                                                  0159
*           /*********************************************************/
*           /*                                                       */
*           /* SET UP FOR BRANCH & LINK ENTRY TO FREEMAIN            */
*           /*                                                       */
*           /*********************************************************/
*                                                                  0160
*           RFY                                                    0160
*             R1 RSTD;                                             0160
*           IF R3=0 THEN            /* CHECK FOR VALID MCAWSA POINTER*/
         LTR   R3,R3                                               0161
         BZ    @RT00161                                            0161
*             GO TO FREESRB;        /* NOT VALID - BYPASS FREEMAIN   */
*           R0=LENGTH(MCAWSA);      /* LENGTH OF AREA TO BE RELEASED */
         LA    R0,800                                              0163
*           R1=R3;                  /* ADDRESS OF AREA               */
         LR    R1,R3                                               0164
*           RFY                                                    0165
*             R3 UNRSTD;                                           0165
*                                                                  0166
*           /*********************************************************/
*           /*                                                       */
*           /* FREE THE 'MCAWSA'                                     */
*           /*                                                       */
*           /*********************************************************/
*                                                                  0166
*           GEN SETS(R14,R15,R3,R4) REFS(R1,R0,CVTSPSA,WSAGGMFM,WSAG,
*               CVTGLMN,CVTMAP) EXIT NOFLOWS SEQFLOW;              0166
         FREEMAIN RU,LV=(0),A=(1),BRANCH=(YES,GLOBAL),SP=AHLRDSP
*           GMANSAVE=0;             /* INDICATE THAT THE AREA WAS  0167
*                                      FREED                         */
         SLR   @12,@12                                             0167
         ST    @12,GMANSAVE(,R9PARM)                               0167
*         END;                                                     0168
*         IF SAVESRB=0 THEN         /* ANY MORE AREAS TO FREEMAIN ?  */
         C     @12,SAVESRB(,R9PARM)                                0169
         BE    @RT00169                                            0169
*           GO TO RELEASE;          /* NO                          0170
*                                                                    */
*FREESRB:                                                          0171
*                                                                  0171
*         /***********************************************************/
*         /*                                                         */
*         /* FREE THE SRB AND PLIST OBTAINED FROM SQA FOR AHLREAD1.  */
*         /* THE SALLOC LOCK IS ALREADY HELD                         */
*         /*                                                         */
*         /***********************************************************/
*                                                                  0171
*         DO;                                                      0171
*                                                                  0171
FREESRB  DS    0H                                                  0172
*           /*********************************************************/
*           /*                                                       */
*           /* SET UP FOR BRANCH ENTRY FREEMAIN                      */
*           /*                                                       */
*           /*********************************************************/
*                                                                  0172
*           R0=LENGTH(SRBSECT)+LENGTH(AHLRDPL);/* LENGTH OF AREA TO
*                                      BE RELEASED                   */
         LA    R0,84                                               0172
*           R1=SAVESRB;             /* ADDRESS OF AREA               */
*                                                                  0173
         L     R1,SAVESRB(,R9PARM)                                 0173
*           /*********************************************************/
*           /*                                                       */
*           /* FREE THE SRB AND PLIST                                */
*           /*                                                       */
*           /*********************************************************/
*                                                                  0174
*           GEN SETS(R14,R15,R3,R4) REFS(R1,R0,CVTSPSA,WSAGGMFM,WSAG,
*               CVTGLMN,CVTMAP) EXIT SEQFLOW NOFLOWS;              0174
         FREEMAIN RU,LV=(0),A=(1),BRANCH=(YES,GLOBAL),SP=AHLRDSP
*           SAVESRB=0;              /* INDICATE THAT THE AHLREADR SRB
*                                      HAS BEEN RELEASED             */
         SLR   @12,@12                                             0175
         ST    @12,SAVESRB(,R9PARM)                                0175
*           RFY                                                    0176
*            (R0,                                                  0176
*             R1) UNRSTD;                                          0176
*         END;                                                     0177
*RELEASE:                                                          0178
*                                                                  0178
*         /***********************************************************/
*         /*                                                         */
*         /* RELEASE THE SALLOC LOCK                                 */
*         /*                                                         */
*         /***********************************************************/
*                                                                  0178
*         GEN REFS(PSALITA,FLC) EXIT NOFLOWS SEQFLOW;              0178
RELEASE  DS    0H                                                  0178
FREESAL2 SETLOCK RELEASE,TYPE=SALLOC,                                  *
               RELATED=(GLOBAL,AHLREADR(GETSAL2))
*         SLOCHELD=OFF;             /* INDICATE THAT THE SALLOC LOCK
*                                      HAS BEEN RELEASED             */
         NI    SLOCHELD(R9PARM),B'11011111'                        0179
*       END;                                                       0180
*                                                                  0180
*     /***************************************************************/
*     /*                                                             */
*     /* DELETE THE FRR ROUTINE FROM THE STACK                       */
*     /*                                                             */
*     /***************************************************************/
*                                                                  0181
*     RFY                                                          0181
*      (R14,                                                       0181
*       R12WORK) RSTD;                                             0181
@RF00155 DS    0H                                                  0182
*     GEN SETS(R9PARM,R12WORK) REFS(PSACSTK,FRRSCURR,FRRSEMP,FRRSELEN)
*         NOEXIT NOFLOWS SEQFLOW;                                  0182
*                                                                  0182
         SETFRR D,WRKREGS=(R9PARM,R12WORK) DELETE FRR FROM LIST
*     /***************************************************************/
*     /*                                                             */
*     /* RESTORE R14 AND EXIT                                        */
*     /*                                                             */
*     /***************************************************************/
*                                                                  0183
*     R14=SAVER14;                  /* RESTORE R14                   */
         LR    R14,SAVER14                                         0183
*     GEN REFS(R14) EXIT(BR R14  RETURN TO SRB SCHEDULER OR RTM);  0184
         BR R14  RETURN TO SRB SCHEDULER OR RTM
*     RFY                                                          0185
*      (R14,                                                       0185
*       R12WORK) UNRSTD;                                           0185
*CLEANUP:                                                          0186
*                                                                  0186
*     /***************************************************************/
*     /*                                                             */
*     /* GTF COULD NOT BE FOUND. POST REQUESTOR'S ECB INDICATING     */
*     /* ERROR CONDITION. BRANCH AND LINK ENTRY TO POST MUST BE USED */
*     /* SINCE AHLREADR IS AN SRB ROUTINE                            */
*     /*                                                             */
*     /***************************************************************/
*                                                                  0186
*     SAVER14=RTNSAVE;              /* RELOAD RETURN ADDRESS INTO REG
*                                      SO THAT THE FOLLOWING CODE MAY
*                                      BE USED BY AHLREAD1 AND     0186
*                                      AHLRDFR                       */
CLEANUP  L     SAVER14,RTNSAVE(,R9PARM)                            0186
*LOCLPOST:                                                         0187
*     DO;                                                          0187
*                                                                  0187
LOCLPOST DS    0H                                                  0188
*       /*************************************************************/
*       /*                                                           */
*       /* LOCAL LOCK MUST BE OBTAINED BEFORE BRANCH AND LINK POST   */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0188
*       GEN REFS(PSALITA,FLC) EXIT SEQFLOW NOFLOWS;                0188
GETLOC1  SETLOCK OBTAIN,TYPE=LOCAL,MODE=UNCOND,                        *
               RELATED=(POST,AHLREADR(FREELOC1))
*       LOCHELD=ON;                 /* INDICATE THAT THE LOCAL LOCK
*                                      IS HELD                       */
*                                                                  0189
         OI    LOCHELD(R9PARM),B'01000000'                         0189
*       /*************************************************************/
*       /*                                                           */
*       /* SET UP FOR LOCAL POST                                     */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0190
*       RFY                                                        0190
*        (POSTRTN,                                                 0190
*         POSTECB,                                                 0190
*         R15,                                                     0190
*         R14) RSTD;                                               0190
*       POSTRTN=ERRCODE;            /* COMPLETION CODE               */
         LA    POSTRTN,4                                           0191
*       POSTECB=ECBSAVE;            /* REQUESTOR'S ECB @             */
         L     POSTECB,ECBSAVE(,R9PARM)                            0192
*       R15=CVT0PT02;               /* @ OF POST ROUTINE           0193
*                                                                    */
         L     @12,CVTPTR                                          0193
         L     R15,CVT0PT02(,@12)                                  0193
*                                                                  0194
*       /*************************************************************/
*       /*                                                           */
*       /* POST REQUESTER                                            */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0194
*       GEN SETS(R14) REFS(R15) EXIT SEQFLOW NOFLOWS(BALR R14,R15);
         BALR R14,R15
*       RFY                                                        0195
*        (POSTRTN,                                                 0195
*         POSTECB,                                                 0195
*         R15,                                                     0195
*         R14) UNRSTD;                                             0195
*       POSTDONE=ON;                /* INDICATE THAT THE ECB HAS BEEN
*                                      POSTED                        */
         OI    POSTDONE(R9PARM),B'00010000'                        0196
*RELLOCL:                                                          0197
*                                                                  0197
*       /*************************************************************/
*       /*                                                           */
*       /* RELEASE LOCAL LOCK                                        */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0197
*       GEN REFS(PSALITA,FLC) EXIT SEQFLOW NOFLOWS;                0197
RELLOCL  DS    0H                                                  0197
FREELOC1 SETLOCK RELEASE,TYPE=LOCAL,                                   *
               RELATED=(POST,AHLREADR(GETLOC1))
*       LOCHELD=OFF;                /* INDICATE THAT THE LOCAL LOCK
*                                      HAS BEEN RELEASED             */
         NI    LOCHELD(R9PARM),B'10111111'                         0198
*     END;                                                         0199
*                                                                  0199
*     /***************************************************************/
*     /*                                                             */
*     /* CONTINUE WITH NORMAL CLEANUP FUNCTIONS                      */
*     /*                                                             */
*     /***************************************************************/
*                                                                  0200
*     GO TO MCDEQ;                                                 0200
         B     MCDEQ                                               0200
*     RFY                                                          0201
*       SAVER14 UNRSTD;                                            0201
*   END;                                                           0202
*AHLRDFR:                                                          0203
*   GEN SETS(BASEREG) REFS(READBASE,R15ENTRY) NOEXIT NOFLOWS SEQFLOW
*       NODEFS;                                                    0203
*                                                                  0203
AHLRDFR  DS    0H                                                  0203
         USING AHLRDFR,R15ENTRY    SETUP TEMP BASE
         L     BASEREG,READBASE    GET BASE ADDRESS UPON ENTRY
         USING AHLREADR,BASEREG    TELL ASSEMBLER ABOUT OUR BASE
         DROP  R15ENTRY            TELL ASSEMBLER TO QUIT USING R15
*   /*****************************************************************/
*   /*                                                               */
*   /* THIS ENTRY POINT PERFORMS ERROR RECOVERY FUNCTIONS IN THE     */
*   /* EVENT OF A FAILURE IN THE MAIN LINE CODE (AHLREAD1) - TWO     */
*   /* BASIC COURSES OF ACTION ARE FOLLOWED: 1. IF THE ERROR IS A    */
*   /* RECOVERABLE ACR MACHINE CHECK THIS ROUTINE NOTIFIES RTM TO    */
*   /* RETRY AT THE NEXT INSTRUCTION, 2. ALL OTHER ERRORS WILL RESULT*/
*   /* IN RTM BEING NOTIFIED TO CONTINUE AT AHLREAD1'S RETURN ADDRESS*/
*   /* AND A GRACEFUL CLEANUP OF CONTROL BLOCKS AND LOCKS            */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0204
*   DO;                                                            0204
*                                                                  0204
*     /***************************************************************/
*     /*                                                             */
*     /* HOUSEKEEPING - SAVE R14 AND RELOAD BASE FOR FRR PARM AREA   */
*     /*                                                             */
*     /***************************************************************/
*                                                                  0205
*     RFY                                                          0205
*      (R14,                                                       0205
*       SDWAPTR,                                                   0205
*       R1,                                                        0205
*       SAVER14,                                                   0205
*       R0) RSTD;                                                  0205
*     SDWAPTR=R1;                   /* GET POINTER TO SDWA           */
         LR    SDWAPTR,R1                                          0206
*     SAVER14=R14;                  /* SAVE RETURN ADDRESS           */
         LR    SAVER14,R14                                         0207
*     R1=R0;                        /* GET POINTER TO WORKAREA TO BE
*                                      USED TO BUILD PARMLIST FOR  0208
*                                      SDUMP                         */
         LR    R1,R0                                               0208
*     RFY                                                          0209
*      (R0,                                                        0209
*       R14) UNRSTD;                                               0209
*     R9PARM=SDWAPARM;              /* POINTER TO FRR PARM SAVE AREA
*                                                                    */
         L     R9PARM,SDWAPARM(,SDWAPTR)                           0210
*                                                                  0211
*     /***************************************************************/
*     /*                                                             */
*     /* DUMP AHLREADR AND SQA USING SVCDUMP                         */
*     /*                                                             */
*     /***************************************************************/
*                                                                  0211
*     DO;                                                          0211
*                                                                  0211
*       /*************************************************************/
*       /*                                                           */
*       /* SET UP THE PARMLIST FOR SVCDUMP                           */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0212
*       RFY                                                        0212
*         R12WORK RSTD;                                            0212
*       CLRPARM=CLRPARM&&CLRPARM;   /* CLEAR PARMLIST                */
         XC    CLRPARM(24,R1),CLRPARM(R1)                          0213
*       R12WORK=PSAAOLD->ASCBASID;  /* GET ASID                      */
*                                                                  0214
         L     @04,PSAAOLD                                         0214
         SLR   R12WORK,R12WORK                                     0214
         ICM   R12WORK,3,ASCBASID(@04)                             0214
*       /*************************************************************/
*       /*                                                           */
*       /* TAKE A DUMP                                               */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0215
*       GEN SETS(R15) REFS(R1,R12WORK,READRMOD,CVTSDMP,CVTMAP,CVTPTR)
*           EXIT NOFLOWS SEQFLOW;                                  0215
         SDUMP HDR='DUMP OF AHLREADR',SDATA=SQA,BRANCH=YES,            *
               LIST=READRMOD,ASID=(R12WORK),MF=(E,(1))
*       RFY                                                        0216
*        (R1,                                                      0216
*         R12WORK) UNRSTD;                                         0216
*     END;                                                         0217
*                                                                  0218
*     /***************************************************************/
*     /*                                                             */
*     /* IF THE FOLLOWING CONDITIONS ARE MET THE ERROR IS A          */
*     /* RECOVERABLE ACR MACHINE CHECK ERROR: 1. IT IS A MACHINE     */
*     /* CHECK, 2. THERE WAS AN INSTRUCTION FAILURE, 3. THE PSW IS   */
*     /* VALID AND 4. THE REGISTERS ARE VALID                        */
*     /*                                                             */
*     /***************************************************************/
*                                                                  0218
*     IF SDWAMCHK=ON&SDWAINSF=ON&SDWAREGU=OFF&SDWAPSWU=OFF THEN    0218
         TM    SDWAMCHK(SDWAPTR),B'10000000'                       0218
         BNO   @RF00218                                            0218
         TM    SDWAINSF(SDWAPTR),B'00000100'                       0218
         BNO   @RF00218                                            0218
         TM    SDWAREGU(SDWAPTR),B'01100000'                       0218
         BNZ   @RF00218                                            0218
*       DO;                         /* ACR TYPE ERROR                */
*                                                                  0219
*         /***********************************************************/
*         /*                                                         */
*         /* NOTIFY RTM TO RETRY AT THE NEXT INSTRUCTION AND RETURN  */
*         /* TO RTM                                                  */
*         /*                                                         */
*         /***********************************************************/
*                                                                  0220
*         DO;                       /* SETRP RECPARM(RECID)        0220
*                                      RECORD(YES) RC(SDWARETY)    0220
*                                      RETADDR(ACRADDR)            0220
*                                      WKAREA(SDWAPTR)               */
*           RESPECIFY                                              0221
*            (GPR00P,                                              0221
*             GPR01P,                                              0221
*             GPR14P,                                              0221
*             GPR15P) RSTD;                                        0221
*           GPR01P=SDWAPTR;                                        0222
         LR    GPR01P,SDWAPTR                                      0222
*           GPR01P->SDWARCDE=SDWARETY;/* STORE RC INTO SDWA          */
         MVI   SDWARCDE(GPR01P),X'04'                              0223
*           GPR01P->SDWARTYA=ADDR(ACRADDR);/* SAVE RETRY ADDRESS     */
         MVC   SDWARTYA(4,GPR01P),SDWANXT1(SDWAPTR)                0224
*           GPR01P->SDWARCRD='1'B;  /* TURN ON RECORD INDICATOR      */
         OI    SDWARCRD(GPR01P),B'10000000'                        0225
*           GPR15P=ADDR(RECID);     /* ACCESS RECORD PARAMETER LIST  */
         LA    GPR15P,RECID                                        0226
*           GPR01P->SDWARECP=GPR15P->I256C(1:24);/* COPY RECORD    0227
*                                      PARAMETERS                    */
         MVC   SDWARECP(24,GPR01P),I256C(GPR15P)                   0227
*           RESPECIFY                                              0228
*            (GPR00P,                                              0228
*             GPR01P,                                              0228
*             GPR14P,                                              0228
*             GPR15P) UNRSTD;                                      0228
*         END;                                                     0229
*         RFY                                                      0230
*           R14 RSTD;                                              0230
*         R14=SAVER14;              /* RETORE R14 RETURN ADDRESS     */
         LR    R14,SAVER14                                         0231
*         GEN REFS(R14) EXIT(BR   R14  RETURN TO RTM);             0232
         BR   R14  RETURN TO RTM
*       END;                                                       0233
*     ELSE                          /* ALL OTHER TYPES OF ERRORS     */
*       DO;                                                        0234
*                                                                  0234
         B     @RC00218                                            0234
@RF00218 DS    0H                                                  0235
*         /***********************************************************/
*         /*                                                         */
*         /* NOTIFY RTM TO RETRY AT AHLREAD1'S RETURN ADDRESS AND    */
*         /* PERFORM CLEANUP FUNCTIONS. CLEANUP FUNCTIONS MAY INCLUDE*/
*         /* POSTING THE ORIGINATOR OF THE REQUEST TO THE GTF WRITER,*/
*         /* RELEASING LOCKS, DEQING THE MC CONTROL BLOCKS, RELEASING*/
*         /* GETMAINED AREAS AND DELETING THE FRR ROUTINE FROM THE   */
*         /* STACK.                                                  */
*         /*                                                         */
*         /***********************************************************/
*                                                                  0235
*         DO;                                                      0235
*                                                                  0235
*           /*********************************************************/
*           /*                                                       */
*           /* NOTIFY RTM OF RETRY ADDRESS                           */
*           /*                                                       */
*           /*********************************************************/
*                                                                  0236
*           DO;                     /* SETRP RECPARM(RECID)        0236
*                                      RECORD(YES) RC(SDWARETY)    0236
*                                      RETADDR(SRBADDR)            0236
*                                      WKAREA(SDWAPTR)               */
*             RESPECIFY                                            0237
*              (GPR00P,                                            0237
*               GPR01P,                                            0237
*               GPR14P,                                            0237
*               GPR15P) RSTD;                                      0237
*             GPR01P=SDWAPTR;                                      0238
         LR    GPR01P,SDWAPTR                                      0238
*             GPR01P->SDWARCDE=SDWARETY;/* STORE RC INTO SDWA        */
         MVI   SDWARCDE(GPR01P),X'04'                              0239
*             GPR01P->SDWARTYA=ADDR(SRBADDR);/* SAVE RETRY ADDRESS   */
         MVC   SDWARTYA(4,GPR01P),RTNSAVE(R9PARM)                  0240
*             GPR01P->SDWARCRD='1'B;/* TURN ON RECORD INDICATOR      */
         OI    SDWARCRD(GPR01P),B'10000000'                        0241
*             GPR15P=ADDR(RECID);   /* ACCESS RECORD PARAMETER LIST  */
         LA    GPR15P,RECID                                        0242
*             GPR01P->SDWARECP=GPR15P->I256C(1:24);/* COPY RECORD  0243
*                                      PARAMETERS                    */
         MVC   SDWARECP(24,GPR01P),I256C(GPR15P)                   0243
*             RESPECIFY                                            0244
*              (GPR00P,                                            0244
*               GPR01P,                                            0244
*               GPR14P,                                            0244
*               GPR15P) UNRSTD;                                    0244
*           END;                                                   0245
*           RFY                                                    0246
*             SDWAPTR UNRSTD;                                      0246
*                                                                  0247
*           /*********************************************************/
*           /*                                                       */
*           /* RELEASE THE SALLOC LOCK IF IT IS HELD                 */
*           /*                                                       */
*           /*********************************************************/
*                                                                  0247
*           IF SLOCHELD=ON THEN     /* IS THE LOCK HELD ?            */
         TM    SLOCHELD(R9PARM),B'00100000'                        0247
         BNO   @RF00247                                            0247
*             DO;                   /* YES - RELEASE IT              */
*               GEN REFS(PSALITA,FLC) EXIT NOFLOWS SEQFLOW;        0249
FREESAL4 SETLOCK RELEASE,TYPE=SALLOC,RELATED=(GLOBAL,AHLREADR(GETSAL1,G*
               ETSAL2,GETSAL3))
*             END;                                                 0250
*                                                                  0250
*           /*********************************************************/
*           /*                                                       */
*           /* POST THE LOCAL ECB IS THE PARMLIST WAS NOT QUEUED AND */
*           /* THE POST WAS NOT PERFORMED AS PART OF NORMAL CLEANUP  */
*           /*                                                       */
*           /*********************************************************/
*                                                                  0251
*           IF POSTDONE=OFF THEN                                   0251
@RF00247 TM    POSTDONE(R9PARM),B'00010000'                        0251
         BZ    @RT00251                                            0251
*             GO TO LOCLPOST;       /* POST IS REQUIRED              */
*           ELSE                    /* POST NOT REQUIRED             */
*                                                                  0253
*             /*******************************************************/
*             /*                                                     */
*             /* IF THE LOCAL LOCK WAS HELD RELEASE IT               */
*             /*                                                     */
*             /*******************************************************/
*                                                                  0253
*             IF LOCHELD=OFF THEN                                  0253
         TM    LOCHELD(R9PARM),B'01000000'                         0253
         BZ    @RT00253                                            0253
*               GO TO MCDEQ;        /* NOT HELD, BYPASS LOCK RELEASE */
*           GO TO RELLOCL;          /* RELEASE THE LOCAL LOCK        */
         B     RELLOCL                                             0255
*         END;                                                     0256
*       END;                                                       0257
*     RFY                                                          0258
*       SAVER14 UNRSTD;                                            0258
@RC00218 DS    0H                                                  0259
*   END;                                                           0259
*AHLRDXP1:                                                         0260
*   GEN SETS(BASEREG) REFS(READBASE,R15ENTRY) NOEXIT NOFLOWS SEQFLOW
*       NODEFS;                                                    0260
*                                                                  0260
AHLRDXP1 DS    0H                                                  0260
         USING AHLRDXP1,R15ENTRY   SETUP TEMP BASE
         L     BASEREG,READBASE    GET BASE ADDRESS UPON ENTRY
         USING AHLREADR,BASEREG    TELL ASSEMBLER ABOUT OUR BASE
         DROP  R15ENTRY            TELL ASSEMBLER TO QUIT USING R15
*   /*****************************************************************/
*   /*                                                               */
*   /* THIS ENTRY POINT PERFORMS CLEANUP FUNCTIONS IN THE EVENT OF A */
*   /* FAILURE PERFORMING THE CROSS-MEMORY POST TO THE GTF WRITER -  */
*   /* CLEANUP FUNCTIONS INCLUDE: NONE                               */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0261
*   DO;                                                            0261
*                                                                  0261
*     /***************************************************************/
*     /*                                                             */
*     /* SINCE NOTHING CAN BE GAINED PRESUMABLY BY REATTEMPTING THE  */
*     /* CROSS-MEMORY POST TO THE GTF WRITER AND THIS IS THE ONLY    */
*     /* INFORMATION AVAILABLE A SIMPLE RETURN IS MADE. IT IS ASSUMED*/
*     /* THAT SINCE THE GTF WRITER IS STILL ACTIVE IT WILL POST THE  */
*     /* REQUESTOR WHEN IT IS DISPATCHED AND LOCATES THE QUEUED      */
*     /* PARMLIST                                                    */
*     /*                                                             */
*     /***************************************************************/
*                                                                  0262
*     GEN REFS(R14) EXIT(BR    R14         RETURN TO DISPATCHER);  0262
         BR    R14         RETURN TO DISPATCHER
*   END;                                                           0263
*AHLREAD2:                                                         0264
*   GEN SETS(BASEREG) REFS(READBASE,R15ENTRY) NOEXIT NOFLOWS SEQFLOW
*       NODEFS;                                                    0264
*                                                                  0264
AHLREAD2 DS    0H                                                  0264
         USING AHLREAD2,R15ENTRY   SETUP TEMP BASE
         L     BASEREG,READBASE    GET BASE ADDRESS UPON ENTRY
         USING AHLREADR,BASEREG    TELL ASSEMBLER ABOUT OUR BASE
         DROP  R15ENTRY            TELL ASSEMBLER TO QUIT USING R15
*   /*****************************************************************/
*   /*                                                               */
*   /* THIS ENTRY POINT PERFORMS MAIN LINE FUNCTIONS - POSTING THE   */
*   /* REQUESTOR'S ECB OF THE GTF WRITER'S COMPLETION AND FREEMAINING*/
*   /* THE SRB USED TO SCHEDULE AHLREAD1 AND THIS ENTRY POINT        */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0265
*   DO;                                                            0265
*                                                                  0265
*     /***************************************************************/
*     /*                                                             */
*     /* HOUSEKEEPING - SET UP PARMLIST BASE AND SAVE RETURN ADDRESS */
*     /*                                                             */
*     /***************************************************************/
*                                                                  0266
*     RFY                                                          0266
*       AHLRDPL BASED(R1);                                         0266
*     RFY                                                          0267
*      (R14,                                                       0267
*       SAVER14,                                                   0267
*       R1) RSTD;                                                  0267
*                                                                  0267
*     /***************************************************************/
*     /*                                                             */
*     /* COMMON LOGIC FOR AHLREAD2, AHLRDCU2 AND AHLRDCU3 FOLLOWS    */
*     /*                                                             */
*     /***************************************************************/
*                                                                  0268
*COMMON:                                                           0268
*     SAVER14=R14;                  /* SAVE THE RETURN ADDRESS       */
COMMON   LR    SAVER14,R14                                         0268
*     RFY                                                          0269
*       R14 UNRSTD;                                                0269
*                                                                  0270
*     /***************************************************************/
*     /*                                                             */
*     /* POST REQUESTOR OF COMPLETION OF REQUEST - BRANCH ENTRY TO   */
*     /* LOCAL POST MUST BE USED SINCE AHLREAD2 IS AN SRB ROUTINE    */
*     /*                                                             */
*     /***************************************************************/
*                                                                  0270
*     DO;                                                          0270
*                                                                  0270
*       /*************************************************************/
*       /*                                                           */
*       /* LOCAL LOCK IS REQ'D FOR LOCAL BRANCH ENTRY POST           */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0271
*       GEN REFS(PSALITA,FLC) EXIT SEQFLOW NOFLOWS;                0271
*                                                                  0271
GETLOC2  SETLOCK OBTAIN,TYPE=LOCAL,MODE=UNCOND,                        *
               RELATED=(LPOST,AHLREADR(FREELOC2))
*       /*************************************************************/
*       /*                                                           */
*       /* SET UP FOR LOCAL POST                                     */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0272
*       RFY                                                        0272
*        (POSTRTN,                                                 0272
*         POSTECB,                                                 0272
*         R14,                                                     0272
*         R15) RSTD;                                               0272
*       POSTRTN=AHLPCOD;            /* COMPLETION CODE               */
         L     POSTRTN,AHLPCOD(,R1)                                0273
*       POSTECB=AHLRDECB;           /* ECB @                         */
         L     POSTECB,AHLRDECB(,R1)                               0274
*       R15=CVT0PT02;               /* @ OF LOCAL POST ROUTINE       */
*                                                                  0275
         L     @12,CVTPTR                                          0275
         L     R15,CVT0PT02(,@12)                                  0275
*       /*************************************************************/
*       /*                                                           */
*       /* PERFORM LOCAL POST                                        */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0276
*       GEN SETS(R14) REFS(R15) EXIT SEQFLOW NOFLOWS(BALR  R14,R15);
         BALR  R14,R15
*       RFY                                                        0277
*        (POSTRTN,                                                 0277
*         POSTECB,                                                 0277
*         R14,                                                     0277
*         R15) UNRSTD;                                             0277
*                                                                  0278
*       /*************************************************************/
*       /*                                                           */
*       /* RELEASE LOCAL LOCK                                        */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0278
*       GEN REFS(PSALITA,FLC) EXIT SEQFLOW NOFLOWS;                0278
FREELOC2 SETLOCK RELEASE,TYPE=LOCAL,RELATED=(LPOST,AHLREADR(GETLOC2))
*     END;                                                         0279
*                                                                  0280
*     /***************************************************************/
*     /*                                                             */
*     /* FREE THE SRB AND PLIST - BRANCH ENTRY FREEMAIN IS EMPLOYED  */
*     /*                                                             */
*     /***************************************************************/
*                                                                  0280
*     DO;                                                          0280
*                                                                  0280
*       /*************************************************************/
*       /*                                                           */
*       /* SALLOC LOCK IS REQ'D TO FREE SPACE IN SQA                 */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0281
*       GEN REFS(PSALITA,FLC) EXIT SEQFLOW NOFLOWS;                0281
*                                                                  0281
GETSAL6  SETLOCK OBTAIN,TYPE=SALLOC,MODE=UNCOND,                       *
               RELATED=(FREEMAIN,AHLREADR(GETSAL6))
*       /*************************************************************/
*       /*                                                           */
*       /* SET UP FOR BRANCH ENTRY FREEMAIN                          */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0282
*       RFY                                                        0282
*         R0 RSTD;                                                 0282
*       R0=LENGTH(SRBSECT)+LENGTH(AHLRDPL);/* LENGTH OF AREA TO BE 0283
*                                      RELEASED                      */
         LA    R0,84                                               0283
*       R1=AHLRDSRB;                /* ADDRESS OF AREA               */
*                                                                  0284
         L     R1,AHLRDSRB(,R1)                                    0284
*       /*************************************************************/
*       /*                                                           */
*       /* FREE THE SRB AND PLIST                                    */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0285
*       GEN SETS(R14,R15,R3,R4) REFS(R1,R0,CVTSPSA,WSAGGMFM,WSAG,  0285
*           CVTGLMN,CVTMAP) EXIT SEQFLOW NOFLOWS;                  0285
         FREEMAIN RU,LV=(0),A=(1),BRANCH=(YES,GLOBAL),SP=AHLRDSP
*       RFY                                                        0286
*        (R0,                                                      0286
*         R1) UNRSTD;                                              0286
*                                                                  0287
*       /*************************************************************/
*       /*                                                           */
*       /* RELEASE THE SALLOC LOCK                                   */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0287
*       GEN REFS(PSALITA,FLC) EXIT SEQFLOW NOFLOWS;                0287
FREESAL6 SETLOCK RELEASE,TYPE=SALLOC,                                  *
               RELATED=(FREEMAIN,AHLREADR(GETSAL6))
*     END;                                                         0288
*                                                                  0288
*     /***************************************************************/
*     /*                                                             */
*     /* RESTORE R14 RETURN ADDRESS AND EXIT                         */
*     /*                                                             */
*     /***************************************************************/
*                                                                  0289
*     RFY                                                          0289
*       R14 RSTD;                                                  0289
*     R14=SAVER14;                  /* RESTORE RETURN ADDRESS        */
         LR    R14,SAVER14                                         0290
*     GEN REFS(R14) EXIT(BR   R14    RETURN TO CALLER);            0291
         BR   R14    RETURN TO CALLER
*     RFY                                                          0292
*      (R14,                                                       0292
*       PLISTREG,                                                  0292
*       SAVER14) UNRSTD;                                           0292
*   END;                                                           0293
*AHLRDCU2:                                                         0294
*   GEN SETS(BASEREG) REFS(READBASE,R15ENTRY) NOEXIT NOFLOWS SEQFLOW
*       NODEFS;                                                    0294
*                                                                  0294
AHLRDCU2 DS    0H                                                  0294
         USING AHLRDCU2,R15ENTRY   SETUP TEMP BASE
         L     BASEREG,READBASE    GET BASE ADDRESS UPON ENTRY
         USING AHLREADR,BASEREG    TELL ASSEMBLER ABOUT OUR BASE
         DROP  R15ENTRY            TELL ASSEMBLER TO QUIT USING R15
*   /*****************************************************************/
*   /*                                                               */
*   /* THIS ENTRY POINT PERFORMS CLEANUP FUNCTIONS IN THE EVENT OF   */
*   /* THE AHLREADR SRB BEING PURGED - CLEANUP FUNCTIONS INCLUDE: 1. */
*   /* POSTING REQUESTOR'S ECB, 2. FREEMAINING THE SRB FOR AHLREAD1  */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0295
*   DO;                                                            0295
*                                                                  0295
*     /***************************************************************/
*     /*                                                             */
*     /* HOUSEKEEPING - SET UP PARMLIST BASE AND SET COMPLETION CODE */
*     /* FOR LOCAL POST                                              */
*     /*                                                             */
*     /***************************************************************/
*                                                                  0296
*     RFY                                                          0296
*      (R14,                                                       0296
*       PLISTREG,                                                  0296
*       R1) RSTD;                                                  0296
*     R1=PLISTREG;                  /* SET UP PARMLIST BASE          */
         LR    R1,PLISTREG                                         0297
*     AHLPCOD=ERRCODE;              /* SET UP COMPLETION CODE SO THAT
*                                      COMMON CODE MAY BE USED       */
*                                                                  0298
         MVC   AHLPCOD(4,R1),@CF00052                              0298
*     /***************************************************************/
*     /*                                                             */
*     /* GO PERFORM ALL NECESSARY FUNCTIONS                          */
*     /*                                                             */
*     /***************************************************************/
*                                                                  0299
*     GO TO COMMON;                                                0299
         B     COMMON                                              0299
*     RFY                                                          0300
*      (R14,                                                       0300
*       PLISTREG,                                                  0300
*       R1) UNRSTD;                                                0300
*   END;                                                           0301
*AHLRDCU3:                                                         0302
*   GEN SETS(BASEREG) REFS(READBASE,R15ENTRY) NOEXIT NOFLOWS SEQFLOW
*       NODEFS;                                                    0302
*                                                                  0302
AHLRDCU3 DS    0H                                                  0302
         USING AHLRDCU3,R15ENTRY   SETUP TEMP BASE
         L     BASEREG,READBASE    GET BASE ADDRESS UPON ENTRY
         USING AHLREADR,BASEREG    TELL ASSEMBLER ABOUT OUR BASE
         DROP  R15ENTRY            TELL ASSEMBLER TO QUIT USING R15
*   /*****************************************************************/
*   /*                                                               */
*   /* THIS ENTRY POINT PERFORMS CLEANUP FUNCTIONS IN THE EVENT OF   */
*   /* THE AHLREAD2 SRB BEING PURGED - CLEANUP FUNCTIONS INCLUDE: 1. */
*   /* POSTING THE REQUESTOR'S ECB. 2. FREEMAINING THE SRB FOR       */
*   /* AHLREAD2                                                      */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0303
*   DO;                                                            0303
*                                                                  0303
*     /***************************************************************/
*     /*                                                             */
*     /* HOUSEKEEPING - SET UP PARMLIST BASE                         */
*     /*                                                             */
*     /***************************************************************/
*                                                                  0304
*     RFY                                                          0304
*      (R14,                                                       0304
*       PLISTREG,                                                  0304
*       R1) RSTD;                                                  0304
*     R1=PLISTREG;                  /* SET UP PARMLIST BASE          */
*                                                                  0305
         LR    R1,PLISTREG                                         0305
*     /***************************************************************/
*     /*                                                             */
*     /* BRANCH TO COMMON LOGIC FOR ALL REQUIRED PROCESSING          */
*     /*                                                             */
*     /***************************************************************/
*                                                                  0306
*     GO TO COMMON;                                                0306
         B     COMMON                                              0306
*     RFY                                                          0307
*      (R14,                                                       0307
*       PLISTREG,                                                  0307
*       R1) UNRSTD;                                                0307
*   END;                                                           0308
*AHLREADN:                                                         0309
*   END AHLREADR                                                   0309
*                                                                  0309
*/* THE FOLLOWING INCLUDE STATEMENTS WERE FOUND IN THIS PROGRAM.     */
*/*%INCLUDE SYSUT5  (PROLOG  )                                       */
*/*%INCLUDE SYSUT5  (FL1STMTS)                                       */
*/*%INCLUDE SYSUT5  (DECLS   )                                       */
*/*%INCLUDE SYSLIB  (CVT     )                                       */
*/*%INCLUDE SYSLIB  (IHAWSAVT)                                       */
*/*%INCLUDE SYSLIB  (IHAPSA  )                                       */
*/*%INCLUDE SYSLIB  (IHASRB  )                                       */
*/*%INCLUDE SYSLIB  (MCHEAD  )                                       */
*/*%INCLUDE SYSLIB  (MCCE    )                                       */
*/*%INCLUDE SYSLIB  (MCQE    )                                       */
*/*%INCLUDE SYSLIB  (GTFPCT  )                                       */
*/*%INCLUDE SYSLIB  (IHAFRRS )                                       */
*/*%INCLUDE SYSLIB  (IHASDWA )                                       */
*/*%INCLUDE SYSLIB  (IHAASCB )                                       */
*/*%INCLUDE SYSLIB  (MCAWSA  )                                       */
*/*%INCLUDE SYSUT5  (READR   )                                       */
*/*%INCLUDE SYSUT5  (FRRERR  )                                       */
*/*%INCLUDE SYSUT5  (XPOST1  )                                       */
*/*%INCLUDE SYSUT5  (XPOST2  )                                       */
*/*%INCLUDE SYSUT5  (PURGEMOD)                                       */
*/*%INCLUDE SYSUT5  (PURGEMD2)                                       */
*                                                                  0309
*       ;                                                          0309
AHLREADN DS    0H                                                  0309
@DATA    DS    0H
@DATD    DSECT
         DS    0F
AHLREADR CSECT
         DS    0F
@CF00052 DC    F'4'
@CF01791 DC    XL4'80000000'
@DATD    DSECT
         DS    0D
@ENDDATD EQU   *
AHLREADR CSECT
         NOPR  ((@ENDDATD-@DATD)*16)
         DS    0F
@SIZDATD DC    AL1(0)
         DC    AL3(@ENDDATD-@DATD)
         DS    0D
READBASE DC    AL4(AHLREADR)
READRMOD DS    CL8
         ORG   READRMOD
@NM00093 DC    AL4(AHLREADR)
@NM00094 DS    AL4
         ORG   @NM00094
@NM00095 DC    X'80'
@NM00096 DC    AL3(AHLREADN)
         ORG   READRMOD+8
RECID    DC    CL24'AHLREADRAHLREADRAHLRDFR '
@00      EQU   00                      EQUATES FOR REGISTERS 0-15
@01      EQU   01
@02      EQU   02
@03      EQU   03
@04      EQU   04
@05      EQU   05
@06      EQU   06
@07      EQU   07
@08      EQU   08
@09      EQU   09
@10      EQU   10
@11      EQU   11
@12      EQU   12
@13      EQU   13
@14      EQU   14
@15      EQU   15
SRBPTR   EQU   @01
PCTPTR   EQU   @08
SDWAPTR  EQU   @08
R0       EQU   @00
R1       EQU   @01
PLISTREG EQU   @02
SAVER14  EQU   @02
R3       EQU   @03
CODERG   EQU   @04
R4       EQU   @04
BASEREG  EQU   @05
MCQEPNT  EQU   @06
R9PARM   EQU   @09
POSTRTN  EQU   @10
FRRADDR  EQU   @11
POSTECB  EQU   @11
POSTERR  EQU   @12
R12WORK  EQU   @12
POSTASCB EQU   @13
R14      EQU   @14
R15ENTRY EQU   @15
R15      EQU   @15
GPR00P   EQU   @00
GPR01P   EQU   @01
GPR14P   EQU   @14
GPR15P   EQU   @15
AHLPPTR  EQU   @01
         ENTRY AHLREAD2
         ENTRY AHLRDCU3
         ENTRY AHLRDXP1
         ENTRY AHLRDFR
PSA      EQU   0
FLCRNPSW EQU   PSA
FLCROPSW EQU   PSA+8
FLCICCW2 EQU   PSA+16
FLCCVT   EQU   FLCICCW2
PSAEEPSW EQU   PSA+132
PSAESPSW EQU   PSA+136
FLCSVILC EQU   PSAESPSW+1
PSAEPPSW EQU   PSA+140
FLCPIILC EQU   PSAEPPSW+1
FLCPICOD EQU   PSAEPPSW+2
PSAPICOD EQU   FLCPICOD+1
FLCTEA   EQU   PSAEPPSW+4
FLCPER   EQU   PSA+152
FLCMCLA  EQU   PSA+168
FLCIOEL  EQU   FLCMCLA+4
FLCIOA   EQU   FLCMCLA+16
FLCFSA   EQU   FLCMCLA+80
PSAAOLD  EQU   PSA+548
PSASUPER EQU   PSA+552
PSASUP1  EQU   PSASUPER
PSASUP2  EQU   PSASUPER+1
PSASUP3  EQU   PSASUPER+2
PSASUP4  EQU   PSASUPER+3
PSACLHT  EQU   PSA+640
PSALKSA  EQU   PSA+696
PSAHLHI  EQU   PSA+760
PSALITA  EQU   PSA+764
PSADSSFL EQU   PSA+836
PSADSSF1 EQU   PSADSSFL
PSADSSF3 EQU   PSADSSFL+2
PSADSSF4 EQU   PSADSSFL+3
PSARSVT  EQU   PSA+896
PSALSFCC EQU   PSA+1012
CVTMAP   EQU   0
CVTDAR   EQU   CVTMAP+72
CVTFLGS1 EQU   CVTDAR
CVTDCB   EQU   CVTMAP+116
CVT0PT01 EQU   CVTMAP+152
CVTOPTA  EQU   CVTMAP+182
CVTOPTB  EQU   CVTMAP+183
CVTGTF   EQU   CVTMAP+236
CVTGTFST EQU   CVTGTF
CVTGTFS  EQU   CVTGTFST
CVTSTATE EQU   CVTGTFST
CVTTMODE EQU   CVTGTFST
CVTFORM  EQU   CVTGTFST
CVTUSR   EQU   CVTGTFST
CVTAQAVT EQU   CVTMAP+240
CVTTCMFG EQU   CVTAQAVT
CVTVOLM2 EQU   CVTMAP+244
CVTTATA  EQU   CVTVOLM2
CVTTSKS  EQU   CVTTATA
CVTVOLF2 EQU   CVTTSKS
CVTTAT   EQU   CVTTATA+1
CVTATER  EQU   CVTMAP+248
CVTEXT1  EQU   CVTMAP+252
CVTPURG  EQU   CVTMAP+260
CVTQMSG  EQU   CVTMAP+268
CVTDMSR  EQU   CVTMAP+272
CVTAPF   EQU   CVTMAP+324
CVTEXT2  EQU   CVTMAP+328
CVTHJES  EQU   CVTMAP+332
CVTPGSIA EQU   CVTMAP+348
CVTA1F1  EQU   CVTMAP+356
CVTSYSK  EQU   CVTMAP+357
CVTVOLM1 EQU   CVTMAP+380
CVTVOLF1 EQU   CVTVOLM1
CVTATMCT EQU   CVTMAP+388
CVTXTNT1 EQU   0
CVTXTNT2 EQU   0
CVTDSSV  EQU   CVTXTNT2
CVTRSV90 EQU   CVTXTNT2+5
CVTQID   EQU   CVTXTNT2+24
CVTRV400 EQU   CVTXTNT2+52
CVTRV409 EQU   CVTXTNT2+53
CVTATCVT EQU   CVTXTNT2+64
CVTRV429 EQU   CVTXTNT2+84
CVTRV438 EQU   CVTXTNT2+85
CVTRV457 EQU   CVTXTNT2+112
CVTRV466 EQU   CVTXTNT2+113
CVTFIX   EQU   0
CVTRELNO EQU   CVTFIX+252
WSAG     EQU   0
WSAGGMFM EQU   WSAG+4
SRBSECT  EQU   0
SRB      EQU   SRBSECT
SRBFLC   EQU   SRB+12
SRBEP    EQU   SRB+20
SRBRMTR  EQU   SRB+24
MCHEAD   EQU   0
MCHFLGS  EQU   MCHEAD+24
MCHFLG1  EQU   MCHFLGS
MCHSETE  EQU   MCHEAD+28
MCHSETD  EQU   MCHEAD+32
MCCE     EQU   0
MCCEQEA  EQU   MCCE+16
MCQE     EQU   0
MCQENAME EQU   MCQE+8
MCQEASCB EQU   MCQE+16
MCQEMCQE EQU   MCQE+20
MCQEAT   EQU   MCQE+32
MCQEFLGS EQU   MCQE+41
GTFPCT   EQU   0
GTFSTAT  EQU   GTFPCT+8
GTFOPTS  EQU   GTFPCT+12
GTFOPTS1 EQU   GTFOPTS
GTFOPTS2 EQU   GTFOPTS+1
GTFOPTS3 EQU   GTFOPTS+2
GTFOPTS4 EQU   GTFOPTS+3
PCTCATF  EQU   GTFPCT+16
NEXTBLOK EQU   GTFPCT+180
AHLRDPLQ EQU   GTFPCT+196
WRTRCOM  EQU   GTFPCT+204
TRMWRIT  EQU   GTFPCT+212
WRTRERR  EQU   GTFPCT+216
GTFSSRB  EQU   GTFPCT+220
QLOCKWRD EQU   GTFPCT+236
QLOCKECB EQU   GTFPCT+240
AUDITFLG EQU   GTFPCT+296
GTFASCB  EQU   GTFPCT+300
FRRS     EQU   0
FRRSHEAD EQU   FRRS
FRRSEMP  EQU   FRRSHEAD
FRRSLAST EQU   FRRSHEAD+4
FRRSELEN EQU   FRRSHEAD+8
FRRSCURR EQU   FRRSHEAD+12
FRRSPTR  EQU   0
FRRSENTR EQU   0
FRRSFRRA EQU   FRRSENTR
FRRSFLGS EQU   FRRSENTR+4
FRRSFLG1 EQU   FRRSFLGS
FRRSPARM EQU   FRRSENTR+8
FRREPTR  EQU   0
SDWA     EQU   0
SDWAPARM EQU   SDWA
SDWAFIOB EQU   SDWA+4
SDWAABCC EQU   SDWAFIOB
SDWACMPF EQU   SDWAABCC
SDWACTL1 EQU   SDWA+8
SDWACMKA EQU   SDWACTL1
SDWAMWPA EQU   SDWACTL1+1
SDWAPMKA EQU   SDWACTL1+4
SDWACTL2 EQU   SDWA+16
SDWACMKP EQU   SDWACTL2
SDWAMWPP EQU   SDWACTL2+1
SDWAPMKP EQU   SDWACTL2+4
SDWAGRSV EQU   SDWA+24
SDWANAME EQU   SDWA+88
SDWAEC1  EQU   SDWA+104
SDWAEMK1 EQU   SDWAEC1
SDWAMWP1 EQU   SDWAEC1+1
SDWAINT1 EQU   SDWAEC1+2
SDWANXT1 EQU   SDWAEC1+4
SDWAAEC1 EQU   SDWA+112
SDWAILC1 EQU   SDWAAEC1+1
SDWAINC1 EQU   SDWAAEC1+2
SDWAICD1 EQU   SDWAINC1+1
SDWAEC2  EQU   SDWA+120
SDWAEMK2 EQU   SDWAEC2
SDWAMWP2 EQU   SDWAEC2+1
SDWAINT2 EQU   SDWAEC2+2
SDWANXT2 EQU   SDWAEC2+4
SDWAAEC2 EQU   SDWA+128
SDWAILC2 EQU   SDWAAEC2+1
SDWAINC2 EQU   SDWAAEC2+2
SDWAICD2 EQU   SDWAINC2+1
SDWASRSV EQU   SDWA+136
SDWAIDNT EQU   SDWA+200
SDWAMCH  EQU   SDWA+204
SDWASTCK EQU   SDWAMCH
SDWAMCHI EQU   SDWAMCH+8
SDWAMCHS EQU   SDWAMCHI
SDWAMCHD EQU   SDWAMCHI+1
SDWAREGU EQU   SDWAMCHD
SDWAPSWU EQU   SDWAMCHD
SDWAINSF EQU   SDWAMCHD
SDWARSR1 EQU   SDWAMCH+12
SDWARSR2 EQU   SDWAMCH+13
SDWAFLGS EQU   SDWA+232
SDWAERRA EQU   SDWAFLGS
SDWAMCHK EQU   SDWAERRA
SDWAERRB EQU   SDWAFLGS+1
SDWAERRC EQU   SDWAFLGS+2
SDWAERRD EQU   SDWAFLGS+3
SDWAIOFS EQU   SDWA+238
SDWARTYA EQU   SDWA+240
SDWACPUA EQU   SDWA+248
SDWAPARQ EQU   SDWA+252
SDWARCDE EQU   SDWAPARQ
SDWAACF2 EQU   SDWAPARQ+1
SDWARCRD EQU   SDWAACF2
SDWAACF3 EQU   SDWAPARQ+2
SDWAACF4 EQU   SDWAPARQ+3
SDWALKWA EQU   SDWA+256
SDWALKWS EQU   SDWALKWA
SDWARECP EQU   SDWA+292
SDWASNPA EQU   SDWA+320
SDWADUMP EQU   SDWASNPA
SDWADPFS EQU   SDWADUMP+1
SDWADDAT EQU   SDWASNPA+4
SDWASDAT EQU   SDWADDAT
SDWAPDAT EQU   SDWADDAT+2
SDWADPSA EQU   SDWA+328
SDWADPSL EQU   SDWADPSA
SDWARA   EQU   SDWA+400
SDWADPVA EQU   SDWARA+2
ASCB     EQU   0
ASCBASID EQU   ASCB+36
ASCBFW1  EQU   ASCB+100
ASCBRCTF EQU   ASCBFW1+2
ASCBFLG1 EQU   ASCBFW1+3
ASCBDSP1 EQU   ASCB+114
ASCBFLG2 EQU   ASCB+115
ASCBPTR  EQU   0
MCAWSA   EQU   0
MCATRAIL EQU   MCAWSA+256
MCATRL1  EQU   MCATRAIL
MCATRL2  EQU   MCATRAIL+1
MCATRL3  EQU   MCATRAIL+2
MCATRL4  EQU   MCATRAIL+3
MCATRL5  EQU   MCATRAIL+4
MCATRL6  EQU   MCATRAIL+5
MCATRL7  EQU   MCATRAIL+6
AWSAPTR  EQU   0
FRRPARM  EQU   0
ECBSAVE  EQU   FRRPARM
SAVESRB  EQU   FRRPARM+4
MCCESAVE EQU   FRRPARM+8
GMANSAVE EQU   FRRPARM+12
FRRTRAIL EQU   FRRPARM+16
MCENQD   EQU   FRRTRAIL
LOCHELD  EQU   FRRTRAIL
SLOCHELD EQU   FRRTRAIL
POSTDONE EQU   FRRTRAIL
RTNSAVE  EQU   FRRPARM+20
AHLRDPL  EQU   0
AHLCHAIN EQU   AHLRDPL
AHLRDID  EQU   AHLRDPL+4
AHLRDDID EQU   AHLRDPL+14
AHLRDECB EQU   AHLRDPL+20
AHLRDASC EQU   AHLRDPL+28
AHLPCOD  EQU   AHLRDPL+32
AHLRDSRB EQU   AHLRDPL+36
ACRADDR  EQU   0
SRBADDR  EQU   0
CLRPARM  EQU   0
I256C    EQU   0
AHLSETD  EQU   0
SEPL     EQU   0
AHLSETEV EQU   0
CVTPTR   EQU   FLCCVT
CVTS01   EQU   CVTPGSIA
CVTLPDIA EQU   CVTS01+12
CVTDIRST EQU   CVTLPDIA
CVTSLIDA EQU   CVTS01+24
CVTCTLFG EQU   CVTS01+50
CVTSDMP  EQU   CVTS01+232
CVTGLMN  EQU   CVTS01+332
CVTSPSA  EQU   CVTS01+336
CVTRV210 EQU   CVTS01+424
CVTRV219 EQU   CVTS01+425
CVTRV228 EQU   CVTS01+426
CVTRV237 EQU   CVTS01+427
CVTMFRTR EQU   CVTS01+452
CVTRV262 EQU   CVTS01+468
CVTRV271 EQU   CVTS01+469
CVTRV280 EQU   CVTS01+470
CVTRV289 EQU   CVTS01+471
CVT0PT02 EQU   CVTS01+532
CVTGSDA  EQU   CVTS01+600
FLC      EQU   PSA
PSARSVTE EQU   PSARSVT
PSACSTK  EQU   PSARSVTE
         AGO   .@UNREFD                START UNREFERENCED COMPONENTS
PSARSAV  EQU   PSARSVTE+60
PSARSTK  EQU   PSARSVTE+56
PSAESAV3 EQU   PSARSVTE+52
PSAESTK3 EQU   PSARSVTE+48
PSAESAV2 EQU   PSARSVTE+44
PSAESTK2 EQU   PSARSVTE+40
PSAESAV1 EQU   PSARSVTE+36
PSAESTK1 EQU   PSARSVTE+32
PSAPSAV  EQU   PSARSVTE+28
PSAPSTK  EQU   PSARSVTE+24
PSAMSAV  EQU   PSARSVTE+20
PSAMSTK  EQU   PSARSVTE+16
PSASSAV  EQU   PSARSVTE+12
PSASSTK  EQU   PSARSVTE+8
PSANSTK  EQU   PSARSVTE+4
CVTTPIO  EQU   CVTS01+608
CVTADV   EQU   CVTS01+604
CVTGSDAB EQU   CVTGSDA
CVTQV3   EQU   CVTS01+596
CVTQV2   EQU   CVTS01+592
CVTQV1   EQU   CVTS01+588
CVTRPT   EQU   CVTS01+584
CVTSSRB  EQU   CVTS01+580
CVTCSDRL EQU   CVTS01+576
CVTEXP1  EQU   CVTS01+572
CVTRMPMT EQU   CVTS01+568
CVTRMPTT EQU   CVTS01+564
CVTVPSA  EQU   CVTS01+560
CVTVSTOP EQU   CVTS01+556
CVTGTFR8 EQU   CVTS01+552
CVTQUIT  EQU   CVTS01+548
CVTVACR  EQU   CVTS01+544
CVTWTCB  EQU   CVTS01+540
CVTSTPRS EQU   CVTS01+536
CVTDARCM EQU   CVTS01+528
CVTIRECM EQU   CVTS01+524
CVTJRECM EQU   CVTS01+520
CVTVEMS0 EQU   CVTS01+516
CVTSPFRR EQU   CVTS01+512
CVTRLSTG EQU   CVTS01+508
CVT0TC0A EQU   CVTS01+504
CVTGMBR  EQU   CVTS01+500
CVTLFRM  EQU   CVTS01+496
CVTRMBR  EQU   CVTS01+492
CVTVIOP  EQU   CVTS01+488
CVTRV307 EQU   CVTS01+486
CVTRV306 EQU   CVTS01+484
CVTRV305 EQU   CVTS01+482
CVTRV304 EQU   CVTS01+480
CVTRV303 EQU   CVTS01+478
CVTRV302 EQU   CVTS01+476
CVTRV301 EQU   CVTS01+475
CVTRV300 EQU   CVTS01+474
CVTRV299 EQU   CVTS01+473
CVTRV298 EQU   CVTS01+472
CVTRV297 EQU   CVTRV289
CVTRV296 EQU   CVTRV289
CVTRV295 EQU   CVTRV289
CVTRV294 EQU   CVTRV289
CVTRV293 EQU   CVTRV289
CVTRV292 EQU   CVTRV289
CVTRV291 EQU   CVTRV289
CVTRV290 EQU   CVTRV289
CVTRV288 EQU   CVTRV280
CVTRV287 EQU   CVTRV280
CVTRV286 EQU   CVTRV280
CVTRV285 EQU   CVTRV280
CVTRV284 EQU   CVTRV280
CVTRV283 EQU   CVTRV280
CVTRV282 EQU   CVTRV280
CVTRV281 EQU   CVTRV280
CVTRV279 EQU   CVTRV271
CVTRV278 EQU   CVTRV271
CVTRV277 EQU   CVTRV271
CVTRV276 EQU   CVTRV271
CVTRV275 EQU   CVTRV271
CVTRV274 EQU   CVTRV271
CVTRV273 EQU   CVTRV271
CVTRV272 EQU   CVTRV271
CVTRV270 EQU   CVTRV262
CVTRV269 EQU   CVTRV262
CVTRV268 EQU   CVTRV262
CVTRV267 EQU   CVTRV262
CVTRV266 EQU   CVTRV262
CVTRV265 EQU   CVTRV262
CVTRV264 EQU   CVTRV262
CVTRV263 EQU   CVTRV262
CVTVFP   EQU   CVTS01+464
CVTVSI   EQU   CVTS01+460
CVTVPSIB EQU   CVTS01+456
CVTMFACT EQU   CVTMFRTR
CVTMFCTL EQU   CVTS01+448
CVTPVBP  EQU   CVTS01+444
CVTPWI   EQU   CVTS01+440
CVTRV254 EQU   CVTS01+438
CVTRV253 EQU   CVTS01+436
CVTRV252 EQU   CVTS01+434
CVTRV251 EQU   CVTS01+433
CVTRV250 EQU   CVTS01+432
CVTRV249 EQU   CVTS01+431
CVTRV248 EQU   CVTS01+430
CVTRV247 EQU   CVTS01+429
CVTRV246 EQU   CVTS01+428
CVTRV245 EQU   CVTRV237
CVTRV244 EQU   CVTRV237
CVTRV243 EQU   CVTRV237
CVTRV242 EQU   CVTRV237
CVTRV241 EQU   CVTRV237
CVTRV240 EQU   CVTRV237
CVTRV239 EQU   CVTRV237
CVTRV238 EQU   CVTRV237
CVTRV236 EQU   CVTRV228
CVTRV235 EQU   CVTRV228
CVTRV234 EQU   CVTRV228
CVTRV233 EQU   CVTRV228
CVTRV232 EQU   CVTRV228
CVTRV231 EQU   CVTRV228
CVTRV230 EQU   CVTRV228
CVTRV229 EQU   CVTRV228
CVTRV227 EQU   CVTRV219
CVTRV226 EQU   CVTRV219
CVTRV225 EQU   CVTRV219
CVTRV224 EQU   CVTRV219
CVTRV223 EQU   CVTRV219
CVTRV222 EQU   CVTRV219
CVTRV221 EQU   CVTRV219
CVTRV220 EQU   CVTRV219
CVTRV218 EQU   CVTRV210
CVTRV217 EQU   CVTRV210
CVTRV216 EQU   CVTRV210
CVTRV215 EQU   CVTRV210
CVTRV214 EQU   CVTRV210
CVTRV213 EQU   CVTRV210
CVTRV212 EQU   CVTRV210
CVTRV211 EQU   CVTRV210
CVTLCCAT EQU   CVTS01+420
CVTPCCAT EQU   CVTS01+416
CVTIPCRP EQU   CVTS01+412
CVTIPCRI EQU   CVTS01+408
CVTIPCDS EQU   CVTS01+404
CVTAIDVT EQU   CVTS01+400
CVTSSAP  EQU   CVTS01+396
CVTEHCIR EQU   CVTS01+392
CVTEHDEF EQU   CVTS01+388
CVTDAIR  EQU   CVTS01+384
CVTPERFM EQU   CVTS01+380
CVT044R2 EQU   CVTS01+376
CVTFETCH EQU   CVTS01+372
CVTRSTWD EQU   CVTS01+368
CVTSPOST EQU   CVTS01+364
CVTIOBP  EQU   CVTS01+360
CVTASMVT EQU   CVTS01+356
CVTRECRQ EQU   CVTS01+352
CVTWSAC  EQU   CVTS01+348
CVTWSAG  EQU   CVTS01+344
CVTWSAL  EQU   CVTS01+340
CVTVEAC0 EQU   CVTS01+328
CVT062R1 EQU   CVTS01+324
CVTRPOST EQU   CVTS01+320
CVTDQIQE EQU   CVTS01+316
CVTCSD   EQU   CVTS01+312
CVTLKRMA EQU   CVTS01+308
CVTRSPIE EQU   CVTS01+304
CVTRENQ  EQU   CVTS01+300
CVTLQCB  EQU   CVTS01+296
CVTFQCB  EQU   CVTS01+292
CVTQCS01 EQU   CVTS01+288
CVTAPFT  EQU   CVTS01+284
CVTPARRL EQU   CVTS01+280
CVTVWAIT EQU   CVTS01+276
CVTGSPL  EQU   CVTS01+272
CVTLSMQ  EQU   CVTS01+268
CVTGSMQ  EQU   CVTS01+264
CVTEXPRO EQU   CVTS01+260
CVTOPCTP EQU   CVTS01+256
CVTSIC   EQU   CVTS01+252
CVTTPIOS EQU   CVTS01+248
CVTRTMS  EQU   CVTS01+244
CVTSDBF  EQU   CVTS01+240
CVTSCBP  EQU   CVTS01+236
CVTSV60  EQU   CVTS01+228
CVTRTMCT EQU   CVTS01+224
CVTASCBL EQU   CVTS01+220
CVTASCBH EQU   CVTS01+216
CVTGDA   EQU   CVTS01+212
CVTASVT  EQU   CVTS01+208
CVTVVMDI EQU   CVTS01+204
CVTAQTOP EQU   CVTS01+200
CVTIOSCS EQU   CVTS01+196
CVTSDRM  EQU   CVTS01+192
CVTOPTE  EQU   CVTS01+188
CVTSTXU  EQU   CVTS01+184
CVTQUIS  EQU   CVTS01+180
CVTPARS  EQU   CVTS01+176
CVTS1EE  EQU   CVTS01+172
CVTFRAS  EQU   CVTS01+168
CVTQSAS  EQU   CVTS01+164
CVTCRAS  EQU   CVTS01+160
CVTCRMN  EQU   CVTS01+156
CVTDELCP EQU   CVTS01+152
CVTFRECL EQU   CVTS01+148
CVTGETCL EQU   CVTS01+144
CVTBLDCP EQU   CVTS01+140
CVTAUTHL EQU   CVTS01+136
CVTSCAN  EQU   CVTS01+132
CVTRV144 EQU   CVTS01+130
CVTMAXMP EQU   CVTS01+128
CVTSTCK  EQU   CVTS01+124
CVTRV139 EQU   CVTS01+123
CVTDSSAC EQU   CVTS01+122
CVTRV513 EQU   CVTS01+121
CVTIOSPL EQU   CVTS01+120
CVTPTGT  EQU   CVTS01+116
CVTCSPIE EQU   CVTS01+112
CVTSMFEX EQU   CVTS01+108
CVTOLT0A EQU   CVTS01+104
CVTSRBRT EQU   CVTS01+100
CVTPUTL  EQU   CVTS01+96
CVTSYSWT EQU   CVTS01+92
CVTRV327 EQU   CVTS01+88
CVTRV326 EQU   CVTS01+84
CVTRV325 EQU   CVTS01+80
CVTRV324 EQU   CVTS01+76
CVT0VL01 EQU   CVTS01+72
CVTSHRVM EQU   CVTS01+68
CVTRV332 EQU   CVTS01+64
CVTTAS   EQU   CVTS01+60
CVTRSCN  EQU   CVTS01+56
CVTTRAC2 EQU   CVTS01+54
CVTTRACE EQU   CVTS01+52
CVTAPG   EQU   CVTS01+51
CVTSDTRC EQU   CVTCTLFG
CVTGTRCE EQU   CVTCTLFG
CVTNOMP  EQU   CVTCTLFG
CVTRSV79 EQU   CVTCTLFG
CVTDSTAT EQU   CVTCTLFG
CVTRSV78 EQU   CVTCTLFG
CVTRV333 EQU   CVTCTLFG
CVTRV323 EQU   CVTCTLFG
CVTSPVLK EQU   CVTS01+49
CVTRSV77 EQU   CVTS01+48
CVTRV331 EQU   CVTS01+44
CVTRV330 EQU   CVTS01+40
CVTRV329 EQU   CVTS01+36
CVTRV328 EQU   CVTS01+32
CVTRV322 EQU   CVTS01+28
CVTSLID  EQU   CVTSLIDA+1
CVTSYLK  EQU   CVTSLIDA
CVTRV321 EQU   CVTS01+20
CVTRV320 EQU   CVTS01+16
CVTLPDIR EQU   CVTLPDIA+1
CVTRSV69 EQU   CVTDIRST
CVTRSV68 EQU   CVTDIRST
CVTRSV67 EQU   CVTDIRST
CVTRSV66 EQU   CVTDIRST
CVTRSV65 EQU   CVTDIRST
CVTRSV64 EQU   CVTDIRST
CVTRSV63 EQU   CVTDIRST
CVTDICOM EQU   CVTDIRST
CVTPVTP  EQU   CVTS01+8
CVTLPDSR EQU   CVTS01+4
CVTGETL  EQU   CVTS01
SEMC     EQU   SEPL+20
SECL     EQU   SEPL+16
SEEL     EQU   SEPL+12
SENM     EQU   SEPL+4
SECN     EQU   SEPL+3
SEEN     EQU   SEPL+2
@NM00097 EQU   SEPL+1
SEFG     EQU   SEPL
AHLRDATA EQU   AHLRDPL+24
AHLRDTCB EQU   AHLRDDID+2
AHLR$ASI EQU   AHLRDDID
@NM00092 EQU   AHLRDPL+12
MCASWORK EQU   MCAWSA+644
MCAWORK  EQU   MCAWSA+584
MCAREC   EQU   MCAWSA+284
MCARECPR EQU   MCAWSA+268
MCAMCR   EQU   MCAWSA+264
MCATRL8  EQU   MCATRAIL+7
MCAFRECT EQU   MCATRL7
MCAFRECC EQU   MCATRL7
MCAFRESP EQU   MCATRL7
MCAFREXJ EQU   MCATRL7
MCAFRSBR EQU   MCATRL6
MCAFRDMJ EQU   MCATRL6
MCAFRDPC EQU   MCATRL6
MCAFRPIC EQU   MCATRL6
MCAFRPIJ EQU   MCATRL6
@NM00091 EQU   MCATRL5
MCADREGS EQU   MCATRL5
MCAFRRB  EQU   MCATRL5
MCAFRRJ  EQU   MCATRL5
MCAFRRA  EQU   MCATRL5
MCAFRERT EQU   MCATRL5
MCAFREPC EQU   MCATRL5
MCAMJOBN EQU   MCATRL4
MCAMSDWA EQU   MCATRL4
MCAMBTU  EQU   MCATRL4
MCAMIOSB EQU   MCATRL4
MCAMTCB  EQU   MCATRL4
MCAMASCB EQU   MCATRL4
MCAMUCB  EQU   MCATRL4
MCAMEXT  EQU   MCATRL4
MCAFRFRT EQU   MCATRL3
MCAFRFA  EQU   MCATRL3
MCAFRSJ  EQU   MCATRL3
MCAFRSA  EQU   MCATRL3
MCAPIF   EQU   MCATRL3
MCASIOF  EQU   MCATRL3
MCAIOF   EQU   MCATRL3
MCASVCF  EQU   MCATRL3
MCATDIR  EQU   MCATRL2
MCALSR   EQU   MCATRL2
MCAERROR EQU   MCATRL2
MCAUIO   EQU   MCATRL2
MCASTA   EQU   MCATRL2
MCAFRR   EQU   MCATRL2
MCASRM   EQU   MCATRL2
MCARNIO  EQU   MCATRL2
MCAUSR   EQU   MCATRL1
MCAPI    EQU   MCATRL1
MCASRB   EQU   MCATRL1
MCADSP   EQU   MCATRL1
MCASIO   EQU   MCATRL1
MCAIO    EQU   MCATRL1
MCAEXT   EQU   MCATRL1
MCASVC   EQU   MCATRL1
MCAMSG   EQU   MCAWSA+192
MCASETEV EQU   MCAWSA+128
MCAFWORK EQU   MCAWSA+112
MCASFEOB EQU   MCAWSA+56
MCASBLOK EQU   MCAWSA
ASCBEND  EQU   ASCB+208
ASCBSRBT EQU   ASCB+200
ASCBSWTL EQU   ASCB+196
ASCBRS14 EQU   ASCB+195
ASCBSMCT EQU   ASCB+194
ASCBRS12 EQU   ASCB+192
ASCBPCTT EQU   ASCB+188
ASCBVGTT EQU   ASCB+184
ASCBLGCB EQU   ASCB+180
ASCBJBNS EQU   ASCB+176
ASCBJBNI EQU   ASCB+172
ASCBMCC  EQU   ASCB+168
ASCBRTWA EQU   ASCB+164
ASCBIQEA EQU   ASCB+160
ASCBXMPQ EQU   ASCB+156
ASCBRS01 EQU   ASCB+154
ASCBFMCT EQU   ASCB+152
ASCBOUXB EQU   ASCB+148
ASCBOUCB EQU   ASCB+144
ASCBMECB EQU   ASCB+140
ASCBQECB EQU   ASCB+136
ASCBCMSB EQU   ASCB+132
ASCBCMSF EQU   ASCB+128
ASCBTCBS EQU   ASCB+124
ASCBNVSC EQU   ASCB+122
ASCBVSC  EQU   ASCB+120
ASCBSRBS EQU   ASCB+118
ASCBSSRB EQU   ASCB+116
ASCBRV06 EQU   ASCBFLG2
ASCBRV05 EQU   ASCBFLG2
ASCBRV04 EQU   ASCBFLG2
ASCBSNQS EQU   ASCBFLG2
ASCBS2S  EQU   ASCBFLG2
ASCBCEXT EQU   ASCBFLG2
ASCBPXMT EQU   ASCBFLG2
ASCBXMPT EQU   ASCBFLG2
ASCBRF07 EQU   ASCBDSP1
ASCBRF06 EQU   ASCBDSP1
ASCBRF05 EQU   ASCBDSP1
ASCBRF04 EQU   ASCBDSP1
ASCBRF03 EQU   ASCBDSP1
ASCBRF02 EQU   ASCBDSP1
ASCBFAIL EQU   ASCBDSP1
ASCBNOQ  EQU   ASCBDSP1
ASCBSWCT EQU   ASCB+112
ASCBASXB EQU   ASCB+108
ASCBTMCH EQU   ASCB+104
ASCBNSWP EQU   ASCBFLG1
ASCBTYP1 EQU   ASCBFLG1
ASCBSTND EQU   ASCBFLG1
ASCBABNT EQU   ASCBFLG1
ASCBTERM EQU   ASCBFLG1
ASCBS3S  EQU   ASCBFLG1
ASCBCMSH EQU   ASCBFLG1
ASCBTOFF EQU   ASCBFLG1
ASCBRF01 EQU   ASCBRCTF
ASCBTMLW EQU   ASCBRCTF
ASCBOUT  EQU   ASCBRCTF
ASCBWAIT EQU   ASCBRCTF
ASCBRV08 EQU   ASCBRCTF
ASCBFQU  EQU   ASCBRCTF
ASCBFRS  EQU   ASCBRCTF
ASCBTMNO EQU   ASCBRCTF
ASCBAFFN EQU   ASCBFW1
ASCBDUMP EQU   ASCB+96
ASCBQSVC EQU   ASCB+92
ASCBUBET EQU   ASCB+88
ASCBECB  EQU   ASCB+84
ASCBJSTL EQU   ASCB+80
ASCBEWST EQU   ASCB+72
ASCBEJST EQU   ASCB+64
ASCBTSB  EQU   ASCB+60
ASCBCSCB EQU   ASCB+56
ASCBRSM  EQU   ASCB+52
ASCBLDA  EQU   ASCB+48
ASCBSTOR EQU   ASCB+44
ASCBDP   EQU   ASCB+43
ASCBRV07 EQU   ASCB+42
ASCBIOSM EQU   ASCB+40
ASCBSEQN EQU   ASCB+38
ASCBCPUS EQU   ASCB+32
ASCBSPL  EQU   ASCB+28
ASCBLSLQ EQU   ASCB+24
ASCBFSLQ EQU   ASCB+20
ASCBIOSP EQU   ASCB+16
ASCBLOCK EQU   ASCB+12
ASCBBWDP EQU   ASCB+8
ASCBFWDP EQU   ASCB+4
ASCBASCB EQU   ASCB
ASCBEGIN EQU   ASCB
@NM00090 EQU   SDWA+512
SDWAVRA  EQU   SDWARA+4
SDWAURAL EQU   SDWARA+3
@NM00089 EQU   SDWADPVA
SDWAEBC  EQU   SDWADPVA
SDWAHEX  EQU   SDWADPVA
SDWAVRAL EQU   SDWARA
@NM00088 EQU   SDWA+396
SDWACOMP EQU   SDWA+392
SDWARCPL EQU   SDWA+364
@NM00087 EQU   SDWADPSA+32
SDWATO4  EQU   SDWADPSL+28
SDWAFRM4 EQU   SDWADPSL+24
SDWATO3  EQU   SDWADPSL+20
SDWAFRM3 EQU   SDWADPSL+16
SDWATO2  EQU   SDWADPSL+12
SDWAFRM2 EQU   SDWADPSL+8
SDWATO1  EQU   SDWADPSL+4
SDWAFRM1 EQU   SDWADPSL
@NM00086 EQU   SDWADDAT+3
@NM00085 EQU   SDWAPDAT
SDWAUSPL EQU   SDWAPDAT
SDWADPSW EQU   SDWAPDAT
SDWATJPA EQU   SDWAPDAT
SDWATLPA EQU   SDWAPDAT
SDWADREG EQU   SDWAPDAT
SDWADSAH EQU   SDWAPDAT
SDWADSAS EQU   SDWAPDAT
@NM00084 EQU   SDWADDAT+1
@NM00083 EQU   SDWASDAT
SDWAQQS  EQU   SDWASDAT
SDWACBS  EQU   SDWASDAT
SDWAGTF  EQU   SDWASDAT
SDWASWA  EQU   SDWASDAT
SDWALSQA EQU   SDWASDAT
SDWASQA  EQU   SDWASDAT
SDWANUC  EQU   SDWASDAT
@NM00082 EQU   SDWADUMP+2
@NM00081 EQU   SDWADPFS
SDWASLST EQU   SDWADPFS
@NM00080 EQU   SDWADPFS
SDWADLST EQU   SDWADPFS
SDWADPT  EQU   SDWADPFS
SDWADPID EQU   SDWADUMP
SDWADPLA EQU   SDWA+316
SDWAREXN EQU   SDWARECP+16
SDWACSCT EQU   SDWARECP+8
SDWAMODN EQU   SDWARECP
@NM00079 EQU   SDWALKWA+32
SDWATALW EQU   SDWALKWS+28
SDWATDLW EQU   SDWALKWS+24
SDWATNLW EQU   SDWALKWS+20
SDWAAPLW EQU   SDWALKWS+16
SDWAIPLW EQU   SDWALKWS+12
SDWAILLW EQU   SDWALKWS+8
SDWAIULW EQU   SDWALKWS+4
SDWAICLW EQU   SDWALKWS
SDWAFLLK EQU   SDWAACF4
SDWACMS  EQU   SDWAACF4
SDWAOPTM EQU   SDWAACF4
SDWATADB EQU   SDWAACF4
SDWATDNB EQU   SDWAACF4
SDWATNCB EQU   SDWAACF4
SDWAILCH EQU   SDWAACF4
SDWAIUCB EQU   SDWAACF4
SDWAICAT EQU   SDWAACF3
SDWAIPRG EQU   SDWAACF3
SDWASALL EQU   SDWAACF3
SDWAASMP EQU   SDWAACF3
SDWADISP EQU   SDWAACF3
@NM00078 EQU   SDWAACF3
@NM00077 EQU   SDWAACF2
SDWAFREE EQU   SDWAACF2
SDWAUPRG EQU   SDWAACF2
@NM00076 EQU   SDWAACF2
SDWASPIN EQU   SDWAACF2
@NM00075 EQU   SDWAACF2
SDWALCPU EQU   SDWACPUA+2
@NM00074 EQU   SDWACPUA
SDWARECA EQU   SDWA+244
@NM00073 EQU   SDWA+239
@NM00072 EQU   SDWAIOFS
SDWANIOP EQU   SDWAIOFS
SDWANOIO EQU   SDWAIOFS
SDWAIOHT EQU   SDWAIOFS
SDWAIOQR EQU   SDWAIOFS
SDWAFMID EQU   SDWA+236
@NM00071 EQU   SDWAERRD
SDWAMCIV EQU   SDWAERRD
SDWARPIV EQU   SDWAERRD
SDWAMABD EQU   SDWAERRD
SDWACTS  EQU   SDWAERRD
SDWASTAE EQU   SDWAERRD
SDWANRBE EQU   SDWAERRD
SDWACLUP EQU   SDWAERRD
@NM00070 EQU   SDWAERRC
SDWAEAS  EQU   SDWAERRC
SDWAPERC EQU   SDWAERRC
SDWAIRB  EQU   SDWAERRC
SDWASTAI EQU   SDWAERRC
SDWASTAF EQU   SDWAERRC
SDWASRBM EQU   SDWAERRB
SDWALDIS EQU   SDWAERRB
SDWAENRB EQU   SDWAERRB
SDWATYP1 EQU   SDWAERRB
@NM00069 EQU   SDWAERRB
SDWAPGIO EQU   SDWAERRA
SDWATEXC EQU   SDWAERRA
SDWASVCE EQU   SDWAERRA
SDWAABTM EQU   SDWAERRA
SDWASVCD EQU   SDWAERRA
SDWARKEY EQU   SDWAERRA
SDWAPCHK EQU   SDWAERRA
SDWATIME EQU   SDWAMCH+20
SDWARFSA EQU   SDWAMCH+16
@NM00068 EQU   SDWAMCH+14
SDWAVEQR EQU   SDWARSR2
SDWAPGFX EQU   SDWARSR2
SDWAFLSQ EQU   SDWARSR2
SDWAFSQA EQU   SDWARSR2
SDWANUCL EQU   SDWARSR2
SDWASPER EQU   SDWARSR2
SDWAINTC EQU   SDWARSR2
SDWAOFLN EQU   SDWARSR2
SDWACHNG EQU   SDWARSR1
SDWAMSER EQU   SDWARSR1
@NM00067 EQU   SDWARSR1
SDWACPID EQU   SDWAMCH+10
SDWATERR EQU   SDWAMCHD
SDWAFPRX EQU   SDWAMCHD
SDWAACR  EQU   SDWAMCHD
SDWASCK  EQU   SDWAMCHD
SDWASKYF EQU   SDWAMCHD
@NM00066 EQU   SDWAMCHS
SDWARSRF EQU   SDWAMCHS
SDWARSRC EQU   SDWAMCHS
SDWAINVP EQU   SDWAMCHS
SDWATSVL EQU   SDWAMCHS
SDWARCDF EQU   SDWAMCHS
SDWASRVL EQU   SDWAMCHS
SDWASCKE EQU   SDWASTCK+4
SDWASCKB EQU   SDWASTCK
SDWALNTH EQU   SDWAIDNT+1
SDWASPID EQU   SDWAIDNT
SDWASR15 EQU   SDWASRSV+60
SDWASR14 EQU   SDWASRSV+56
SDWASR13 EQU   SDWASRSV+52
SDWASR12 EQU   SDWASRSV+48
SDWASR11 EQU   SDWASRSV+44
SDWASR10 EQU   SDWASRSV+40
SDWASR09 EQU   SDWASRSV+36
SDWASR08 EQU   SDWASRSV+32
SDWASR07 EQU   SDWASRSV+28
SDWASR06 EQU   SDWASRSV+24
SDWASR05 EQU   SDWASRSV+20
SDWASR04 EQU   SDWASRSV+16
SDWASR03 EQU   SDWASRSV+12
SDWASR02 EQU   SDWASRSV+8
SDWASR01 EQU   SDWASRSV+4
SDWASR00 EQU   SDWASRSV
SDWATRN2 EQU   SDWAAEC2+4
SDWAIPC2 EQU   SDWAICD2
SDWAIMC2 EQU   SDWAICD2
SDWAIPR2 EQU   SDWAICD2
@NM00065 EQU   SDWAINC2
@NM00064 EQU   SDWAILC2
SDWAIL2  EQU   SDWAILC2
@NM00063 EQU   SDWAILC2
@NM00062 EQU   SDWAAEC2
SDWAADD2 EQU   SDWANXT2+1
@NM00061 EQU   SDWANXT2
@NM00060 EQU   SDWAEC2+3
SDWASGN2 EQU   SDWAINT2
SDWAEXP2 EQU   SDWAINT2
SDWADEC2 EQU   SDWAINT2
SDWAFPO2 EQU   SDWAINT2
SDWACC2  EQU   SDWAINT2
@NM00059 EQU   SDWAINT2
SDWAPGM2 EQU   SDWAMWP2
SDWAWAT2 EQU   SDWAMWP2
SDWAMCK2 EQU   SDWAMWP2
SDWAECT2 EQU   SDWAMWP2
SDWAKEY2 EQU   SDWAMWP2
SDWAEXT2 EQU   SDWAEMK2
SDWAIO2  EQU   SDWAEMK2
SDWATRM2 EQU   SDWAEMK2
@NM00058 EQU   SDWAEMK2
SDWAPER2 EQU   SDWAEMK2
@NM00057 EQU   SDWAEMK2
SDWATRAN EQU   SDWAAEC1+4
SDWAIPC1 EQU   SDWAICD1
SDWAIMC1 EQU   SDWAICD1
SDWAIPR1 EQU   SDWAICD1
@NM00056 EQU   SDWAINC1
@NM00055 EQU   SDWAILC1
SDWAIL1  EQU   SDWAILC1
@NM00054 EQU   SDWAILC1
@NM00053 EQU   SDWAAEC1
SDWAADD1 EQU   SDWANXT1+1
@NM00052 EQU   SDWANXT1
@NM00051 EQU   SDWAEC1+3
SDWASGN1 EQU   SDWAINT1
SDWAEXP1 EQU   SDWAINT1
SDWADEC1 EQU   SDWAINT1
SDWAFPO1 EQU   SDWAINT1
SDWACC1  EQU   SDWAINT1
@NM00050 EQU   SDWAINT1
SDWAPGM1 EQU   SDWAMWP1
SDWAWAT1 EQU   SDWAMWP1
SDWAMCK1 EQU   SDWAMWP1
SDWAECT1 EQU   SDWAMWP1
SDWAKEY1 EQU   SDWAMWP1
SDWAEXT1 EQU   SDWAEMK1
SDWAIO1  EQU   SDWAEMK1
SDWATRM1 EQU   SDWAEMK1
@NM00049 EQU   SDWAEMK1
SDWAPER1 EQU   SDWAEMK1
@NM00048 EQU   SDWAEMK1
SDWAIOBR EQU   SDWA+100
SDWAEPA  EQU   SDWA+96
@NM00047 EQU   SDWANAME+4
SDWARBAD EQU   SDWANAME
SDWAGR15 EQU   SDWAGRSV+60
SDWAGR14 EQU   SDWAGRSV+56
SDWAGR13 EQU   SDWAGRSV+52
SDWAGR12 EQU   SDWAGRSV+48
SDWAGR11 EQU   SDWAGRSV+44
SDWAGR10 EQU   SDWAGRSV+40
SDWAGR09 EQU   SDWAGRSV+36
SDWAGR08 EQU   SDWAGRSV+32
SDWAGR07 EQU   SDWAGRSV+28
SDWAGR06 EQU   SDWAGRSV+24
SDWAGR05 EQU   SDWAGRSV+20
SDWAGR04 EQU   SDWAGRSV+16
SDWAGR03 EQU   SDWAGRSV+12
SDWAGR02 EQU   SDWAGRSV+8
SDWAGR01 EQU   SDWAGRSV+4
SDWAGR00 EQU   SDWAGRSV
SDWANXTP EQU   SDWACTL2+5
SDWASGP  EQU   SDWAPMKP
SDWAEUP  EQU   SDWAPMKP
SDWADOP  EQU   SDWAPMKP
SDWAFPP  EQU   SDWAPMKP
SDWACCP  EQU   SDWAPMKP
SDWAILP  EQU   SDWAPMKP
SDWAINTP EQU   SDWACTL2+2
SDWASPVP EQU   SDWAMWPP
SDWAWATP EQU   SDWAMWPP
SDWAMCKP EQU   SDWAMWPP
@NM00046 EQU   SDWAMWPP
SDWAKEYP EQU   SDWAMWPP
SDWAEXTP EQU   SDWACMKP
SDWAIOP  EQU   SDWACMKP
SDWANXTA EQU   SDWACTL1+5
SDWASGA  EQU   SDWAPMKA
SDWAEUA  EQU   SDWAPMKA
SDWADOA  EQU   SDWAPMKA
SDWAFPA  EQU   SDWAPMKA
SDWACCA  EQU   SDWAPMKA
SDWAILA  EQU   SDWAPMKA
SDWAINTA EQU   SDWACTL1+2
SDWASPVA EQU   SDWAMWPA
SDWAWATA EQU   SDWAMWPA
SDWAMCKA EQU   SDWAMWPA
@NM00045 EQU   SDWAMWPA
SDWAKEYA EQU   SDWAMWPA
SDWAEXTA EQU   SDWACMKA
SDWAIOA  EQU   SDWACMKA
SDWACMPC EQU   SDWAABCC+1
@NM00044 EQU   SDWACMPF
SDWASTCC EQU   SDWACMPF
@NM00043 EQU   SDWACMPF
SDWASTEP EQU   SDWACMPF
SDWAREQ  EQU   SDWACMPF
@NM00042 EQU   FRRSFLGS+1
@NM00041 EQU   FRRSFLG1
FRRSNEST EQU   FRRSFLG1
FRRSRCUR EQU   FRRSFLG1
FRRSENTS EQU   FRRS+84
FRRSRTMW EQU   FRRS+16
PCTWTOMD EQU   GTFPCT+312
PCTDMPMD EQU   GTFPCT+308
TRANSMAX EQU   GTFPCT+304
@NM00040 EQU   AUDITFLG+3
AFSLEBLD EQU   AUDITFLG+3
WSERFG06 EQU   AUDITFLG+3
WSERFG05 EQU   AUDITFLG+3
WSERFG04 EQU   AUDITFLG+3
WSERFG03 EQU   AUDITFLG+3
WSERFG02 EQU   AUDITFLG+2
WSERFLAG EQU   AUDITFLG+2
TERMFLAG EQU   AUDITFLG+2
AFXWRIT  EQU   AUDITFLG+2
AFQLWAIT EQU   AUDITFLG+2
AFSLEGET EQU   AUDITFLG+2
AFBUFGET EQU   AUDITFLG+2
AFFEOB   EQU   AUDITFLG+2
AFBLKFIX EQU   AUDITFLG+1
AFEQFIX  EQU   AUDITFLG+1
AFPGRLSE EQU   AUDITFLG+1
AFWRAP   EQU   AUDITFLG+1
AFBUFOFF EQU   AUDITFLG+1
AFLDFX   EQU   AUDITFLG+1
AFCLOSE  EQU   AUDITFLG+1
AFOPEN   EQU   AUDITFLG+1
AFGMBLOK EQU   AUDITFLG
AFGMSRB  EQU   AUDITFLG
AFWAIT   EQU   AUDITFLG
AFTERM   EQU   AUDITFLG
AFINIT   EQU   AUDITFLG
AFWWRIT  EQU   AUDITFLG
AFCWRIT  EQU   AUDITFLG
AFIWRIT  EQU   AUDITFLG
EQSHORT  EQU   GTFPCT+292
SLEMAX   EQU   GTFPCT+288
SLECNT   EQU   GTFPCT+284
RQPURGE  EQU   GTFPCT+280
RQTOTAL  EQU   GTFPCT+276
WRTDLST  EQU   GTFPCT+272
NUMOFBUF EQU   GTFPCT+268
SBUFDISA EQU   GTFPCT+264
SLESUSED EQU   GTFPCT+260
EQMIN    EQU   GTFPCT+256
EQLENGTH EQU   GTFPCT+252
WQMAX    EQU   GTFPCT+248
WQLENGTH EQU   GTFPCT+244
QLECBP   EQU   QLOCKECB
@NM00039 EQU   QLOCKECB
@NM00038 EQU   QLOCKWRD+3
SCHEDBUF EQU   QLOCKWRD+2
POSTWRIT EQU   QLOCKWRD+1
QLOCK    EQU   QLOCKWRD
WRITERDD EQU   GTFPCT+228
GTFLOSTR EQU   GTFPCT+224
SRBAVAIL EQU   GTFSSRB
WRTRERRP EQU   WRTRERR
@NM00037 EQU   WRTRERR
TRMWRITP EQU   TRMWRIT
@NM00036 EQU   TRMWRIT
GTFCMECB EQU   GTFPCT+208
WRTRCOMP EQU   WRTRCOM
@NM00035 EQU   WRTRCOM
TRANSCNT EQU   GTFPCT+200
SFEOBRTN EQU   GTFPCT+192
SBLOKRTN EQU   GTFPCT+188
CURRBLOK EQU   GTFPCT+184
GBCDS    EQU   NEXTBLOK
WSMODEND EQU   GTFPCT+176
WSMODBEG EQU   GTFPCT+172
BCBPAGE  EQU   GTFPCT+156
SLEPAGE  EQU   GTFPCT+152
SAVECNT  EQU   GTFPCT+148
SLQHEAD  EQU   GTFPCT+144
HQLENGTH EQU   GTFPCT+140
QTAIL    EQU   GTFPCT+136
HQHEAD   EQU   GTFPCT+132
WQHEAD   EQU   GTFPCT+128
RQHEAD   EQU   GTFPCT+124
EQHEAD   EQU   GTFPCT+120
WPOSTSRB EQU   GTFPCT+116
WTSKTCBA EQU   GTFPCT+112
WRTRTCBA EQU   GTFPCT+108
TRMWTASK EQU   GTFPCT+104
WTSKATTH EQU   GTFPCT+100
WTSKINIT EQU   GTFPCT+96
WTASKECB EQU   GTFPCT+92
WMTABPTR EQU   GTFPCT+88
ATTCHECB EQU   GTFPCT+84
AHLECB   EQU   GTFPCT+80
STOPECBA EQU   GTFPCT+76
ECBADRLT EQU   GTFPCT+72
FIXLEN   EQU   GTFPCT+68
FIXPTR   EQU   GTFPCT+64
INITPTR  EQU   GTFPCT+60
MCQEPTR  EQU   GTFPCT+56
GTFEIDL  EQU   GTFPCT+52
GTFPIBL  EQU   GTFPCT+48
GTFPIFT  EQU   GTFPCT+44
GTFSVCBL EQU   GTFPCT+40
GTFSVCFT EQU   GTFPCT+36
GTFIOBL  EQU   GTFPCT+32
GTFIOFT  EQU   GTFPCT+28
GTFSIOBL EQU   GTFPCT+24
GTFSIOFT EQU   GTFPCT+20
@NM00034 EQU   PCTCATF+1
PCTPIF   EQU   PCTCATF+1
PCTSIOF  EQU   PCTCATF+1
PCTIOF   EQU   PCTCATF+1
PCTSVCF  EQU   PCTCATF+1
PCTRR    EQU   PCTCATF+1
PCTSRM   EQU   PCTCATF+1
PCTRNIO  EQU   PCTCATF+1
PCTUSR   EQU   PCTCATF
PCTPI    EQU   PCTCATF
@NM00033 EQU   PCTCATF
PCTDSP   EQU   PCTCATF
PCTSIO   EQU   PCTCATF
PCTIO    EQU   PCTCATF
PCTEXT   EQU   PCTCATF
PCTSVC   EQU   PCTCATF
OPTTIME  EQU   GTFOPTS4
OPTRES3  EQU   GTFOPTS4
OPTIOSIO EQU   GTFOPTS3
OPTRES2  EQU   GTFOPTS3
OPTRR    EQU   GTFOPTS3
OPTSRM   EQU   GTFOPTS3
OPTRNIO  EQU   GTFOPTS3
OPTEXT   EQU   GTFOPTS3
OPTIOP   EQU   GTFOPTS2
OPTIO    EQU   GTFOPTS2
OPTPIP   EQU   GTFOPTS2
OPTPI    EQU   GTFOPTS2
OPTSIOP  EQU   GTFOPTS2
OPTSIO   EQU   GTFOPTS2
OPTSVCP  EQU   GTFOPTS2
OPTSVC   EQU   GTFOPTS2
OPTPCI   EQU   GTFOPTS1
OPTRES1  EQU   GTFOPTS1
OPTDSP   EQU   GTFOPTS1
OPTTRC   EQU   GTFOPTS1
OPTUSR   EQU   GTFOPTS1
OPTSYS   EQU   GTFOPTS1
OPTSYSP  EQU   GTFOPTS1
OPTSYSM  EQU   GTFOPTS1
GTFRESV  EQU   GTFSTAT
GTFDEBUG EQU   GTFSTAT
GTFMODE  EQU   GTFSTAT
GTFPCTID EQU   GTFPCT
MCQESRB  EQU   MCQE+44
@NM00032 EQU   MCQE+42
@NM00031 EQU   MCQEFLGS
MCQEACT  EQU   MCQEFLGS
MCQESCHE EQU   MCQE+40
MCQETECB EQU   MCQE+36
MCQEMCCL EQU   MCQE+28
MCQEMCEE EQU   MCQE+24
MCQEIDEN EQU   MCQE
MCCESRB  EQU   MCCE+44
MCCEECB  EQU   MCCE+40
MCCEMCCE EQU   MCCE+36
MCCECNT  EQU   MCCE+32
MCCEOMCQ EQU   MCCE+28
MCCEOCDA EQU   MCCE+24
MCCEOEDA EQU   MCCE+20
MCCECDA  EQU   MCCE+12
MCCEEDA  EQU   MCCE+8
MCCEIDEN EQU   MCCE
MCHEADTR EQU   MCHEAD+48
MCHEADRD EQU   MCHEAD+44
MCHFRRAD EQU   MCHEAD+40
MCHMCER  EQU   MCHEAD+36
@NM00030 EQU   MCHFLGS+1
@NM00029 EQU   MCHFLG1
MCHTERM  EQU   MCHFLG1
MCHACT   EQU   MCHFLG1
MCHDIS   EQU   MCHEAD+20
MCHCTL   EQU   MCHEAD+16
MCHCNT   EQU   MCHEAD+12
MCHCUR   EQU   MCHEAD+8
MCHIDEN  EQU   MCHEAD
@NM00028 EQU   SRB+40
@NM00027 EQU   SRB+38
SRBPRIOR EQU   SRB+37
SRBPKF   EQU   SRB+36
SRBSAVE  EQU   SRB+32
SRBPARM  EQU   SRB+28
SRBPTCB  EQU   SRBFLC+4
SRBPASID EQU   SRBFLC+2
SRBCPAFF EQU   SRBFLC
SRBASCB  EQU   SRB+8
SRBFLNK  EQU   SRB+4
SRBID    EQU   SRB
WSAGSCHE EQU   WSAG+40
WSAGREST EQU   WSAG+36
WSAGNQDQ EQU   WSAG+32
WSAGMEMT EQU   WSAG+28
WSAGOPTM EQU   WSAG+24
WSAGSTAT EQU   WSAG+20
WSAGEMS0 EQU   WSAG+16
WSAGSSRS EQU   WSAG+12
WSAGRSM  EQU   WSAG+8
WSAGPGIO EQU   WSAG
CVTLEVL  EQU   CVTRELNO+2
CVTNUMB  EQU   CVTRELNO
CVTMDL   EQU   CVTFIX+250
@NM00002 EQU   CVTFIX+248
@NM00001 EQU   CVTFIX
CVTRV482 EQU   CVTXTNT2+128
CVTRV481 EQU   CVTXTNT2+124
CVTRV480 EQU   CVTXTNT2+120
CVTRV479 EQU   CVTXTNT2+118
CVTRV478 EQU   CVTXTNT2+117
CVTRV477 EQU   CVTXTNT2+116
CVTRV476 EQU   CVTXTNT2+115
CVTRV475 EQU   CVTXTNT2+114
CVTRV474 EQU   CVTRV466
CVTRV473 EQU   CVTRV466
CVTRV472 EQU   CVTRV466
CVTRV471 EQU   CVTRV466
CVTRV470 EQU   CVTRV466
CVTRV469 EQU   CVTRV466
CVTRV468 EQU   CVTRV466
CVTRV467 EQU   CVTRV466
CVTRV465 EQU   CVTRV457
CVTRV464 EQU   CVTRV457
CVTRV463 EQU   CVTRV457
CVTRV462 EQU   CVTRV457
CVTRV461 EQU   CVTRV457
CVTRV460 EQU   CVTRV457
CVTRV459 EQU   CVTRV457
CVTRV458 EQU   CVTRV457
CVTRV456 EQU   CVTXTNT2+108
CVTRV455 EQU   CVTXTNT2+104
CVTRV454 EQU   CVTXTNT2+100
CVTRV453 EQU   CVTXTNT2+96
CVTRV452 EQU   CVTXTNT2+94
CVTRV451 EQU   CVTXTNT2+92
CVTRV450 EQU   CVTXTNT2+90
CVTRV449 EQU   CVTXTNT2+88
CVTRV448 EQU   CVTXTNT2+87
CVTRV447 EQU   CVTXTNT2+86
CVTRV446 EQU   CVTRV438
CVTRV445 EQU   CVTRV438
CVTRV444 EQU   CVTRV438
CVTRV443 EQU   CVTRV438
CVTRV442 EQU   CVTRV438
CVTRV441 EQU   CVTRV438
CVTRV440 EQU   CVTRV438
CVTRV439 EQU   CVTRV438
CVTRV437 EQU   CVTRV429
CVTRV436 EQU   CVTRV429
CVTRV435 EQU   CVTRV429
CVTRV434 EQU   CVTRV429
CVTRV433 EQU   CVTRV429
CVTRV432 EQU   CVTRV429
CVTRV431 EQU   CVTRV429
CVTRV430 EQU   CVTRV429
CVTRV428 EQU   CVTXTNT2+80
CVTRV427 EQU   CVTXTNT2+76
CVTRV426 EQU   CVTXTNT2+72
CVTRV425 EQU   CVTXTNT2+68
CVTATACT EQU   CVTATCVT
CVTRV423 EQU   CVTXTNT2+62
CVTRV422 EQU   CVTXTNT2+60
CVTRV421 EQU   CVTXTNT2+58
CVTRV420 EQU   CVTXTNT2+56
CVTRV419 EQU   CVTXTNT2+55
CVTRV418 EQU   CVTXTNT2+54
CVTRV417 EQU   CVTRV409
CVTRV416 EQU   CVTRV409
CVTRV415 EQU   CVTRV409
CVTRV414 EQU   CVTRV409
CVTRV413 EQU   CVTRV409
CVTRV412 EQU   CVTRV409
CVTRV411 EQU   CVTRV409
CVTRV410 EQU   CVTRV409
CVTRV408 EQU   CVTRV400
CVTRV407 EQU   CVTRV400
CVTRV406 EQU   CVTRV400
CVTRV405 EQU   CVTRV400
CVTRV404 EQU   CVTRV400
CVTRV403 EQU   CVTRV400
CVTRV402 EQU   CVTRV400
CVTRV401 EQU   CVTRV400
CVTRSVA1 EQU   CVTXTNT2+48
CVTRSVA0 EQU   CVTXTNT2+44
CVTRSV99 EQU   CVTXTNT2+40
CVTRSV98 EQU   CVTXTNT2+36
CVTRSV97 EQU   CVTXTNT2+34
CVTRSV96 EQU   CVTXTNT2+32
CVTOLTEP EQU   CVTXTNT2+28
CVTQIDA  EQU   CVTQID+1
CVTRSV95 EQU   CVTQID
CVTRSV94 EQU   CVTXTNT2+20
CVTRSV93 EQU   CVTXTNT2+16
CVTRSV92 EQU   CVTXTNT2+12
CVTDEBVR EQU   CVTXTNT2+8
CVTRSV91 EQU   CVTXTNT2+6
CVTRSV9H EQU   CVTRSV90
CVTRSV9G EQU   CVTRSV90
CVTRSV9F EQU   CVTRSV90
CVTRSV9E EQU   CVTRSV90
CVTRSV9D EQU   CVTRSV90
CVTRSV9C EQU   CVTRSV90
CVTRSV9B EQU   CVTRSV90
CVTRSV9A EQU   CVTRSV90
CVTNUCLS EQU   CVTXTNT2+4
CVTDSSVA EQU   CVTDSSV+1
CVTRSV89 EQU   CVTDSSV
CVTRSV88 EQU   CVTXTNT1+8
CVTRSV87 EQU   CVTXTNT1+4
CVTFACHN EQU   CVTXTNT1
CVTRV488 EQU   CVTMAP+412
CVTRV487 EQU   CVTMAP+408
CVTRV486 EQU   CVTMAP+404
CVTRV485 EQU   CVTMAP+400
CVTRV484 EQU   CVTMAP+396
CVTAUTH  EQU   CVTMAP+392
CVTATMCA EQU   CVTATMCT+1
CVTATMST EQU   CVTATMCT
CVTRSV61 EQU   CVTMAP+384
CVTVOLT1 EQU   CVTVOLM1+1
CVTVOLI1 EQU   CVTVOLF1
CVTSTOA  EQU   CVTMAP+376
CVTRSV58 EQU   CVTMAP+374
CVTRSV57 EQU   CVTMAP+372
CVTDDCE  EQU   CVTMAP+368
CVTPNWFR EQU   CVTMAP+364
CVTSMF   EQU   CVTMAP+360
CVTSULK  EQU   CVTMAP+358
CVTSLKO  EQU   CVTSYSK
CVTSLKP  EQU   CVTSYSK
CVTSLKQ  EQU   CVTSYSK
CVTSLKR  EQU   CVTSYSK
CVTRSV56 EQU   CVTSYSK
CVTRSV55 EQU   CVTSYSK
CVTRSV54 EQU   CVTSYSK
CVTRSV53 EQU   CVTSYSK
CVTRSV52 EQU   CVTA1F1
CVTRSV51 EQU   CVTA1F1
CVTRSV50 EQU   CVTA1F1
CVTRSV49 EQU   CVTA1F1
CVTRSV48 EQU   CVTA1F1
CVTRSV47 EQU   CVTA1F1
CVTSRSW  EQU   CVTA1F1
CVTPFSW  EQU   CVTA1F1
CVTPCVT  EQU   CVTMAP+352
CVTRSV46 EQU   CVTMAP+344
CVTRSV45 EQU   CVTMAP+340
CVTRSV44 EQU   CVTMAP+338
CVTRSV43 EQU   CVTMAP+336
CVTHJESA EQU   CVTHJES+1
CVTRSV42 EQU   CVTHJES
CVTEXT2A EQU   CVTEXT2+1
CVTRSV41 EQU   CVTEXT2
CVTAPFA  EQU   CVTAPF+1
CVTRSV40 EQU   CVTAPF
CVTINTLA EQU   CVTMAP+320
CVTERPV  EQU   CVTMAP+316
CVTEORM  EQU   CVTMAP+312
CVTMCHPR EQU   CVTMAP+308
CVTTZ    EQU   CVTMAP+304
CVTJEPS  EQU   CVTMAP+300
CVTJESCT EQU   CVTMAP+296
CVTMODE  EQU   CVTMAP+292
CVTPTRV  EQU   CVTMAP+288
CVTREAL  EQU   CVTMAP+284
CVTRSV39 EQU   CVTMAP+280
CVTRSV38 EQU   CVTMAP+276
CVTDMSRA EQU   CVTDMSR+1
CVTRSV37 EQU   CVTDMSR
CVTQMSGA EQU   CVTQMSG+1
CVTRSV36 EQU   CVTQMSG
CVTAMFF  EQU   CVTMAP+264
CVTPURGA EQU   CVTPURG+1
CVTRSV35 EQU   CVTPURG
CVTCBSP  EQU   CVTMAP+256
CVTATERA EQU   CVTATER+1
CVTSYST  EQU   CVTATER
CVTVOLT2 EQU   CVTTAT
CVTVOLI2 EQU   CVTVOLF2
CVTAQAVB EQU   CVTAQAVT+1
CVTRSV34 EQU   CVTTCMFG
CVTRSV33 EQU   CVTTCMFG
CVTRSV32 EQU   CVTTCMFG
CVTRSV31 EQU   CVTTCMFG
CVTRSV30 EQU   CVTTCMFG
CVTRSV29 EQU   CVTTCMFG
CVTRSV28 EQU   CVTTCMFG
CVTTCRDY EQU   CVTTCMFG
CVTGTFA  EQU   CVTGTF+1
CVTRSV27 EQU   CVTGTFST
CVTRNIO  EQU   CVTGTFST
CVTRV319 EQU   CVTUSR
CVTRV318 EQU   CVTFORM
CVTRV317 EQU   CVTTMODE
CVTRV316 EQU   CVTSTATE
CVTRV315 EQU   CVTGTFS
CVTGTFAV EQU   CVTGTFS
CVT0SCR1 EQU   CVTMAP+232
CVTRV515 EQU   CVTMAP+228
CVTRMS   EQU   CVTMAP+224
CVTPATCH EQU   CVTMAP+220
CVTTSCE  EQU   CVTMAP+216
CVTLNKSC EQU   CVTMAP+214
CVTQABST EQU   CVTMAP+212
CVTMDLDS EQU   CVTMAP+208
CVTUSER  EQU   CVTMAP+204
CVTABEND EQU   CVTMAP+200
CVTSMCA  EQU   CVTMAP+196
CVTRSV18 EQU   CVTMAP+192
CVTQLPAQ EQU   CVTMAP+188
CVTQCDSR EQU   CVTMAP+184
CVTRSV17 EQU   CVTOPTB
CVTRSV16 EQU   CVTOPTB
CVTFP    EQU   CVTOPTB
CVTAPTHR EQU   CVTOPTB
CVTNLOG  EQU   CVTOPTB
CVTTOD   EQU   CVTOPTB
CVTCTIMS EQU   CVTOPTB
CVTPROT  EQU   CVTOPTB
CVTXPFP  EQU   CVTOPTA
CVTASCII EQU   CVTOPTA
CVTRSV13 EQU   CVTOPTA
CVTRSV12 EQU   CVTOPTA
CVTNIP   EQU   CVTOPTA
CVTDDR   EQU   CVTOPTA
CVTAPR   EQU   CVTOPTA
CVTCCH   EQU   CVTOPTA
CVTSNCTR EQU   CVTMAP+180
CVTQMWR  EQU   CVTMAP+176
CVTQOCR  EQU   CVTMAP+172
CVT1EF00 EQU   CVTMAP+168
CVTMZ00  EQU   CVTMAP+164
CVTHEAD  EQU   CVTMAP+160
CVTRSV11 EQU   CVTMAP+156
CVTMSER  EQU   CVTMAP+148
CVTIERLC EQU   CVTMAP+144
CVTILCH  EQU   CVTMAP+140
CVT0DS   EQU   CVTMAP+136
CVTFBOSV EQU   CVTMAP+132
CVTNUCB  EQU   CVTMAP+128
CVTIXAVL EQU   CVTMAP+124
CVTIOQET EQU   CVTMAP+120
CVTDCBA  EQU   CVTMAP+117
CVTMVS2  EQU   CVTDCB
CVT6DAT  EQU   CVTDCB
CVT4MPS  EQU   CVTDCB
CVTRSV09 EQU   CVTDCB
CVT4MS1  EQU   CVTDCB
CVT2SPS  EQU   CVTDCB
CVT1SSS  EQU   CVTDCB
CVTRSV08 EQU   CVTDCB
CVTSTB   EQU   CVTMAP+112
CVTQTD00 EQU   CVTMAP+108
CVTQTE00 EQU   CVTMAP+104
CVTCUCB  EQU   CVTMAP+100
CVTSJQ   EQU   CVTMAP+96
CVTPBLDL EQU   CVTMAP+92
CVTTPC   EQU   CVTMAP+88
CVTSVDCB EQU   CVTMAP+84
CVTBRET  EQU   CVTMAP+82
CVTEXIT  EQU   CVTMAP+80
CVT0FN00 EQU   CVTMAP+76
CVTDARA  EQU   CVTDAR+1
CVTRSV07 EQU   CVTFLGS1
CVTRSV06 EQU   CVTFLGS1
CVTRSV05 EQU   CVTFLGS1
CVTRSV04 EQU   CVTFLGS1
CVTRSV03 EQU   CVTFLGS1
CVTRSV02 EQU   CVTFLGS1
CVTRSV01 EQU   CVTFLGS1
CVTDMPLK EQU   CVTFLGS1
CVTXITP  EQU   CVTMAP+68
CVTZDTAB EQU   CVTMAP+64
CVTMSLT  EQU   CVTMAP+60
CVTDATE  EQU   CVTMAP+56
CVTBTERM EQU   CVTMAP+52
CVTSYSAD EQU   CVTMAP+48
CVTXTLER EQU   CVTMAP+44
CVTILK2  EQU   CVTMAP+40
CVTILK1  EQU   CVTMAP+36
CVTPRLTV EQU   CVTMAP+32
CVTPCNVT EQU   CVTMAP+28
CVT0VL00 EQU   CVTMAP+24
CVTXAPG  EQU   CVTMAP+20
CVTBUF   EQU   CVTMAP+16
CVTJOB   EQU   CVTMAP+12
CVTLINK  EQU   CVTMAP+8
CVT0EF00 EQU   CVTMAP+4
CVTTCBP  EQU   CVTMAP
CVT      EQU   CVTMAP
@NM00026 EQU   PSA+3412
PSASTAK  EQU   PSA+3072
@NM00025 EQU   PSA+1032
PSAUSEND EQU   PSA+1032
PSAPCPSW EQU   PSA+1024
PSARV060 EQU   PSA+1020
PSARV059 EQU   PSA+1018
PSASVC13 EQU   PSA+1016
PSASFACC EQU   PSA+1008
PSASTOP  EQU   PSA+992
PSASTART EQU   PSA+976
PSARSPSW EQU   PSA+968
PSASRPSW EQU   PSA+960
PSARV045 EQU   PSA+892
PSARV044 EQU   PSA+888
PSARV043 EQU   PSA+884
PSARV042 EQU   PSA+880
PSARV041 EQU   PSA+876
PSARV040 EQU   PSA+872
PSARV025 EQU   PSA+868
PSADSSED EQU   PSA+868
PSADSSPR EQU   PSA+864
PSADSSFW EQU   PSA+860
PSADSS14 EQU   PSA+856
PSADSSPP EQU   PSA+848
PSADSSRP EQU   PSA+840
PSADSS05 EQU   PSADSSF4
PSADSS10 EQU   PSADSSF4
PSADSSVE EQU   PSADSSF4
PSADSSDE EQU   PSADSSF4
PSADSSC0 EQU   PSADSSF4
PSADSSIE EQU   PSADSSF4
PSADSS12 EQU   PSADSSF4
PSADSSRC EQU   PSADSSF4
PSARV057 EQU   PSADSSF3
PSARV056 EQU   PSADSSF3
PSARV055 EQU   PSADSSF3
PSARV054 EQU   PSADSSF3
PSADSSRW EQU   PSADSSF3
PSADSSNM EQU   PSADSSF3
PSADSSES EQU   PSADSSF3
PSADSSGP EQU   PSADSSF3
PSADSSF2 EQU   PSADSSFL+1
PSADSSPI EQU   PSADSSF1
PSADSSOI EQU   PSADSSF1
PSADSSSP EQU   PSADSSF1
PSADSSTP EQU   PSADSSF1
PSADSSDW EQU   PSADSSF1
PSADSSDD EQU   PSADSSF1
PSADSSDM EQU   PSADSSF1
PSADSSMV EQU   PSADSSF1
PSADSSTS EQU   PSA+816
PSADSSWK EQU   PSA+812
PSADSSR3 EQU   PSA+808
PSADSSR2 EQU   PSA+804
PSADSSRS EQU   PSA+800
PSASTOR  EQU   PSA+796
PSARV058 EQU   PSA+794
PSAVSTAP EQU   PSA+792
PSAWKVAP EQU   PSA+788
PSAWKRAP EQU   PSA+784
PSAMCHIC EQU   PSA+783
PSAMODE  EQU   PSA+782
PSASYMSK EQU   PSA+781
PSAMCHFL EQU   PSA+780
PSACR0   EQU   PSA+776
PSAPSWSV EQU   PSA+768
PSACLHS  EQU   PSAHLHI
PSALKR15 EQU   PSALKSA+60
PSALKR14 EQU   PSALKSA+56
PSALKR13 EQU   PSALKSA+52
PSALKR12 EQU   PSALKSA+48
PSALKR11 EQU   PSALKSA+44
PSALKR10 EQU   PSALKSA+40
PSALKR9  EQU   PSALKSA+36
PSALKR8  EQU   PSALKSA+32
PSALKR7  EQU   PSALKSA+28
PSALKR6  EQU   PSALKSA+24
PSALKR5  EQU   PSALKSA+20
PSALKR4  EQU   PSALKSA+16
PSALKR3  EQU   PSALKSA+12
PSALKR2  EQU   PSALKSA+8
PSALKR1  EQU   PSALKSA+4
PSALKR0  EQU   PSALKSA
PSARV023 EQU   PSACLHT+52
PSALOCAL EQU   PSACLHT+48
PSACMSL  EQU   PSACLHT+44
PSAOPTL  EQU   PSACLHT+40
PSATPACL EQU   PSACLHT+36
PSATPDNL EQU   PSACLHT+32
PSATPNCL EQU   PSACLHT+28
PSAIOSLL EQU   PSACLHT+24
PSAIOSUL EQU   PSACLHT+20
PSAIOSCL EQU   PSACLHT+16
PSAIOSSL EQU   PSACLHT+12
PSASALCL EQU   PSACLHT+8
PSAASML  EQU   PSACLHT+4
PSADISPL EQU   PSACLHT
PSASRSA  EQU   PSA+636
PSARV050 EQU   PSA+634
PSADSSGO EQU   PSA+633
PSARECUR EQU   PSA+632
PSAHLHIS EQU   PSA+628
PSAIPCSA EQU   PSA+624
@NM00024 EQU   PSA+621
PSAIPCDM EQU   PSA+620
PSAIPCD  EQU   PSA+616
@NM00023 EQU   PSA+613
PSAIPCRM EQU   PSA+612
PSAIPCR  EQU   PSA+608
PSAMCHEX EQU   PSA+600
PSAMPSW  EQU   PSA+592
PSAEXPS2 EQU   PSA+584
PSAEXPS1 EQU   PSA+576
PSAPIREG EQU   PSA+572
PSARSREG EQU   PSA+568
PSAGPREG EQU   PSA+556
PSARV022 EQU   PSASUP4
PSARV021 EQU   PSASUP4
PSARV020 EQU   PSASUP4
PSARV019 EQU   PSASUP4
PSARV018 EQU   PSASUP4
PSARV017 EQU   PSASUP4
PSARV016 EQU   PSASUP4
PSARV015 EQU   PSASUP4
PSARV014 EQU   PSASUP3
PSARV013 EQU   PSASUP3
PSARV012 EQU   PSASUP3
PSARV011 EQU   PSASUP3
PSARV010 EQU   PSASUP3
PSARV009 EQU   PSASUP3
PSARV008 EQU   PSASUP3
PSAIOSUP EQU   PSASUP3
PSALCR   EQU   PSASUP2
PSARTM   EQU   PSASUP2
PSAACR   EQU   PSASUP2
PSAIPCE2 EQU   PSASUP2
PSAIPCES EQU   PSASUP2
PSAIPCEC EQU   PSASUP2
PSAGTF   EQU   PSASUP2
PSAIPCRI EQU   PSASUP2
PSAIPCRP EQU   PSASUP1
PSAIPCDR EQU   PSASUP1
PSADISP  EQU   PSASUP1
PSALOCK  EQU   PSASUP1
PSAPI    EQU   PSASUP1
PSAEXT   EQU   PSASUP1
PSASVC   EQU   PSASUP1
PSAIO    EQU   PSASUP1
PSAANEW  EQU   PSA+544
PSATOLD  EQU   PSA+540
PSATNEW  EQU   PSA+536
PSALCCAR EQU   PSA+532
PSALCCAV EQU   PSA+528
PSAPCCAR EQU   PSA+524
PSAPCCAV EQU   PSA+520
PSACPULA EQU   PSA+518
PSACPUPA EQU   PSA+516
PSAPSA   EQU   PSA+512
FLCHDEND EQU   PSA+512
FLCCRSAV EQU   FLCMCLA+280
FLCGRSAV EQU   FLCMCLA+216
FLCFPSAV EQU   FLCMCLA+184
FLCFLA   EQU   FLCMCLA+88
FLCRGNCD EQU   FLCMCLA+84
FLCFSAA  EQU   FLCFSA+1
@NM00022 EQU   FLCFSA
@NM00021 EQU   FLCMCLA+72
FLCMCIC  EQU   FLCMCLA+64
@NM00020 EQU   FLCMCLA+20
FLCIOAA  EQU   FLCIOA+1
@NM00019 EQU   FLCIOA
@NM00018 EQU   FLCMCLA+15
@NM00017 EQU   FLCMCLA+14
@NM00016 EQU   FLCMCLA+12
FLCLCL   EQU   FLCMCLA+8
FLCIOELA EQU   FLCIOEL+1
@NM00015 EQU   FLCIOEL
FLCCHNID EQU   FLCMCLA
@NM00014 EQU   PSA+160
FLCMTRCD EQU   PSA+157
@NM00013 EQU   PSA+156
FLCPERA  EQU   FLCPER+1
@NM00012 EQU   FLCPER
@NM00011 EQU   PSA+151
FLCPERCD EQU   PSA+150
FLCMCNUM EQU   PSA+149
@NM00010 EQU   PSA+148
FLCTEAA  EQU   FLCTEA+1
@NM00009 EQU   FLCTEA
PSAPIPC  EQU   PSAPICOD
PSAPIMC  EQU   PSAPICOD
PSAPIPER EQU   PSAPICOD
PSARV049 EQU   FLCPICOD
FLCPILCB EQU   FLCPIILC
@NM00008 EQU   FLCPIILC
@NM00007 EQU   PSAEPPSW
FLCSVCN  EQU   PSAESPSW+2
FLCSILCB EQU   FLCSVILC
@NM00006 EQU   FLCSVILC
@NM00005 EQU   PSAESPSW
FLCEICOD EQU   PSAEEPSW+2
PSASPAD  EQU   PSAEEPSW
@NM00004 EQU   PSA+128
FLCINPSW EQU   PSA+120
FLCMNPSW EQU   PSA+112
FLCPNPSW EQU   PSA+104
FLCSNPSW EQU   PSA+96
FLCENPSW EQU   PSA+88
FLCTRACE EQU   PSA+84
FLCTIMER EQU   PSA+80
FLCCVT2  EQU   PSA+76
FLCCAW   EQU   PSA+72
FLCCSW   EQU   PSA+64
FLCIOPSW EQU   PSA+56
FLCMOPSW EQU   PSA+48
FLCPOPSW EQU   PSA+40
FLCSOPSW EQU   PSA+32
FLCEOPSW EQU   PSA+24
@NM00003 EQU   FLCICCW2+4
FLCICCW1 EQU   FLCROPSW
FLCIPPSW EQU   FLCRNPSW
.@UNREFD ANOP                          END UNREFERENCED COMPONENTS
@RT00070 EQU   CLEANUP
@RT00087 EQU   CLEANUP
@RT00093 EQU   CLEANUP
@RT00095 EQU   GOODMCQE
@RT00102 EQU   CLEANUP
@RT00107 EQU   CLEANUP
@RT00146 EQU   FREEMCA
@RT00161 EQU   FREESRB
@RT00169 EQU   RELEASE
@RT00251 EQU   LOCLPOST
@RT00253 EQU   MCDEQ
@ENDDATA EQU   *
         END   AHLREADR,(C'PL/S-II',0503,73286)
