*%GO TO CBSBSL1;                                       /*    @Z40BHUC*/
* /*                                                         @Z40BHUC
         MACRO
         AMCBS
         AGO   .CBSBAL                                       @Z40BHUC
*                                                                    */
 /********************************************************************/
 /*                                                                  */
 /*   MACRO NAME = AMCBS                                             */
 /*                                                                  */
 /*   DESCRIPTIVE NAME = ACCESS METHOD CONTROL BLOCK STRUCTURE BLOCK */
 /*                                                                  */
 /*   FUNCTION = THE ACCESS METHOD CONTROL BLOCK STRUCTURE (AMCBS)   */
 /*              CONTAINS INFORMATION THAT IS USED BY OS/VS TO       */
 /*              LOCATE THE MASTER CATALOG AND USER CATALOGS.  THE   */
 /*              AMCBS IS COMPLETED WHEN THE MASTER CATALOG IS       */
 /*              OPENED.                                             */
 /*                                                                  */
 /*              THE AMCBS CONTAINS:                                 */
 /*                 * ENTRY POINTS TO VSAM CATALOG ROUTINES          */
 /*                 * ENTRY POINTS TO GENCB, MODCB, SHOWCB ROUTINES  */
 /*                 * POINTER TO THE MASTER CATALOG ACB              */
 /*                 * POINTER TO THE CAXWA CHAIN                     */
 /*                 * 8 DOUBLEWORDS FOR EACH OF THE VSAM SHARED      */
 /*                     RESOURCE POOLS (GSR OPTION). THE FIRST WORD  */
 /*                     OF EACH DOUBLWORD CONTAINS THE CELL USE      */
 /*                     COUNT                                        */
 /*                     THE SECOND WORD OF EACH DOUBLEWORD CONTAINS  */
 /*                     THE ADDRESS OF THE CELL. A COMPARE AND SWAP  */
 /*                     DOUBLE (CDS) INSTRUCTION IS USED TO SET THE  */
 /*                     CELL USE COUNT AND THE CELL ADDRESS. @G38KSCM*/
 /*                 * POINTER TO THE IDAVSI (VSAM SHARED INFO) CHAIN.*/
 /*                   A VSI BIT INDICATING THAT UNUSED VSI'S LEFT    */
 /*                   FROM ABEND MAY EXIST ON THE VSI CHAIN WHICH    */
 /*                   REQUIRE CLEAN UP.                              */
 /*                                                                  */
 /*   CONTROL BLOCK STRUCTURE = THE AMCBS IS POINTED TO BY THE       */
 /*                             CVT (CVTCBSP).                       */
 /*                                                                  */
 /*   INCLUDED MACROS = NONE                                         */
 /*                                                                  */
 /*   METHOD OF ACCESS = PL/S - NO DECLARES NECESSARY                */
 /*                                                                  */
 /*   CREATED BY: VSAM CATALOG MODULE IEAVNP11 DURING                */
 /*               NIP MASTER CATALOG OPEN                            */
 /*                                                                  */
 /*   STATUS = MVS VERSION 1/RELEASE 1.                      @G38KSRL*/
 /*                                                                  */
 /*   COPYRIGHT = REFER TO MODULE ACB                        @G38KSRL*/
 /*                                                                  */
 /*   DATE OF LAST CHANGE = 22 JAN 76                        @Z40BHUC*/
 /*                         08/16/76 CBUF SUPPORT            @G38KSRL*/
 /*                                                                  */
 /********************************************************************/
*%CBSBSL1:  ;                                            /*  @Z40BHUC*/
    DECLARE
      1 AMCBS BASED(CBSPTR) BDY(DWORD), /* AMCBS LEVEL ONE   @Y30SSSB*/
        2 CBSID CHAR(2),            /* AMCBS ID CHARACTER            */
        2 CBSSIZ PTR(15),           /* LENGTH OF AMCBS               */
        2 CBSMCSTA CHAR(4),         /* CCHH OF MASTER CATALOG  Y02020*/
        2 CBSACB PTR(31),           /* PTR TO MASTER CATALOG'S ACB   */
        2 CBSCBP PTR(31),           /* POINTER TO CONTROL BLOCK
                                       MANIPULATION ROUTINE          */
        2 CBSCMP PTR(31),           /* POINTER TO CATALOG ROUTINE    */
          3 CBSMCUCB PTR(31),       /* MASTER CATALOG UCB ADDRESS
                                       (NIP THROUGH MASTER CATALOG
                                       OPEN)                   Y02020*/
        2 CBSCAXCN PTR(31),         /* POINTER TO CAXWA CHAIN        */
        2 CBSCRACA PTR(31),         /* PTR TO CRA CAXWA CHN  @Y30SSSB*/
        2 CBSCRTCB PTR(31),         /* CRA TASK TCB POINTER  @Y30SSSB*/
        2 CBSVSRT(8)  CHAR(8) BDY(DWORD), /* CDS WORDS FOR CELLS FOR
                                                KEY 0 TO 7   @G38KSCM*/
          3 CBSVUSE FIXED(31),      /* CELL USE COUNT        @G38KSCM*/
          3 CBSVPTR PTR(31),        /* POINTER TO CELL       @G38KSCM*/
        2 CBSVSICN PTR(31),         /* PTR TO IDAVSI CHAIN   @G38KSRS*/
        2 CBSFLG1 BIT(8),           /* AMCBS FLAGS           @G38KSRS*/
          3 CBSCUVSI BIT(1),        /* CLEAN UP OF VSI CHAIN IS
                                       REQUIRED              @G38KSRS*/
          3 *      BIT(7),          /* RESERVED              @G38KSRS*/
        2 *     CHAR(3);            /* RESERVED              @G38KSRS*/
*%GOTO CBSBSL2 ;                                         /*  @Z40BHUC*/
*/*
*/*
.CBSBAL   ANOP                                           /*  @Z40BHUC*/
*      DUMMY AMCBS FOR CALL IN IDA019C1 FOR VS2 SYSTEM               *
         MEND                                            /*  @Z40BHUC*/
*%CBSBSL2:;                                              /*  @Z40BHUC*/
