*
*        %GOTO PRIN1;              /*
         MACRO
&LABEL   AMDDATA   &DSECT=YES                                        */
*%PRIN1 : ;
*
*/*      AMDPRDMP INPUT MAPPING MACRO                                */
*/*      OS/VS2 RELEASE 2  -- 8/31/72 -- LEVEL 001                   */
*/*                                                                  */
*/*      THIS MACRO DEFINES THE VARIOUS FORMATS OF AMDPRDMP INPUTS.  */
*/*                                                                  */
*/*      TO USE THIS MACRO TO OBTAIN A DSECT OF AMDPRDMP INPUT       */
*/*      IN A BAL MODULE, CODE:                                      */
*/*         LABEL  AMDDATA                                           */
*/*      ISSUE A USING ON EITHER LABEL OR PRDINPUT (IF LABEL IS      */
*/*      OMITTED)  IN ORDER TO REFERENCE THE AREAS DEFINED IN THE    */
*/*      DSECT.                                                      */
*/*      TO USE THIS MACRO TO DEFINE AMDPRDMP INPUT IN A BAL         */
*/*      MODULE WITHOUT GETTING A DSECT, CODE:                       */
*/*         LABEL  AMDDATA  &DSECT=NO                                */
*/*                                                                  */
*/*      TO USE THIS MACRO IN PLS, DEFINE A POINTER, PRDINPTR,       */
*/*      TO POINT TO EITHER:                                         */
*/*         1. THE AREA OF STORAGE INTO WHICH AMDPRDMP INPUT WILL BE */
*/*            READ. (SAME AS BAL DSECT FACILITY)                    */
*/*         2. A 4104-BYTE AREA INTO WHICH DATA WILL BE MOVED TO     */
*/*            CREATE AN AMDPRDMP INPUT RECORD.                      */
*/*                                                                  */
*/*A000000-999999                                              Y02006*/
*
*%GOTO PRIN2;                      /*
         SPACE 1
         AIF   ('&DSECT' EQ 'NO').PRIN010
&LABEL   DSECT
         AGO   .PRIN020
.PRIN010 ANOP
&LABEL   DS    0F
.PRIN020 ANOP
***********************************************************************
*        AMDPRDMP HEADER RECORD FORMATS  --  COMMON FIELDS AND        *
*        FIELDS UNIQUE FOR DSS OR SVCDUMP INPUT                       *
***********************************************************************
         SPACE 1
PRDINPUT EQU   *
PRDHDRID DS    CL1                 HEADER RECORD ID
PRDHDR   EQU   X'FF'               HEADER ID
PRDRECID DS    CL1                 RECORD ID
PRDHDREC EQU   X'FF'               HEADER ID
PRDSAWRK EQU   X'00'               AMDSADMP WORK RECORD ID
PRDASID  DS    CL2                 ASID OF MEMORY BEING DUMPED
PRDMODNM DS    CL8                 NAME OF PROGRAM THAT CREATED INPUT
PRDTODVL DS    CL8                 TOD CLOCK VALUE AT TIME OF DUMP
PRDTITLE DS    CL100               TITLE FOR DUMP
PRDREGS  EQU   *
PRDFPR   DS    CL32                FLOATING POINT REGISTERS
PRDGPR   DS    CL64                GENERAL PURPOSE REGISTERS
PRDCR    DS    CL64                CONTROL REGISTERS
PRDPSW   DS    CL8                 CURRENT PSW AT TIME OF DUMP
PRDCVT   DS    CL4                 REAL ADDRESS OF CVT
         DS   8F                 RESERVED FOR SVC DUMP USE     @Z81700
PRDERRID DS   CL10               ERROR ID                      @Z81700
         DS   CL48               RESERVED FOR SVC DUMP USE     UZ83300
         DS   CL3722             REMAINING BYTES IN RECORD     UZ83300
         SPACE 1
***********************************************************************
*        THE FOLLOWING FIELDS OVERLAY THE PRDFPR AND SUCCEEDING       *
*        FIELDS FOR AMDSADMP INPUT                                    *
***********************************************************************
         SPACE 1
         ORG   PRDFPR
PRDFLC   EQU   *
PRDCSW   DS    CL8                 CSW AT ABSOLUTE LOCATION 64
PRDCAW   DS    CL4                 CAW AT ABSOLUTE LOCATION 72
         DS    CL3972              RESERVED AREA
         SPACE 1
***********************************************************************
*        AMDPRDMP DATA RECORD FORMAT                                  *
***********************************************************************
         SPACE 1
         ORG   PRDHDRID
PRDKEY1  DS    CL1                 STORAGE KEY FOR 1ST 2K OF BLOCK
PRDKEY2  DS    CL1                 STORAGE KEY FOR 2ND 2K OF BLOCK
         DS    CL2                 NAME OF THIS FIELD IS SAME AS
*                                  CORRESPONDING FIELD IN HEADER  --
*                                  I.E.,PRDASID  -- CONTAINS ASID OF
*                                  MEMORY DUMPED
PRDADDR  DS    CL4                 ADDRESS OF STORAGE DUMPED (ON 4K
*                                  BOUNDARY)
PRDDATA  DS    CL4096              DATA FIELD  -- CONTAINS DATA THAT
*                                  WAS AT THE ADDRESS LISTED IN THE
*                                  PRDADDR FIELD
         SPACE 1
***********************************************************************
*        AMDPRDMP CPU STATUS RECORD FORMAT                            *
***********************************************************************
         SPACE 1
         ORG   PRDHDRID
         DS    CL1                 NAME OF THIS FIELD IS SAME AS
*                                  CORRESPONDING FIELD IN HEADER --
*                                  I.E., PRDHDRID  -- CONTAINS  ID OF
*                                  RECORD
         DS    CL1                 NAME OF THIS FIELD IS SAME AS
*                                  CORRESPONDING FIELD IN HEADER --
*                                  I.E., PRDRECID  -- CONTAINS ID OF
*                                  RECORD
PRDCPUID EQU   X'0F'               CPU STATUS RECORD ID
PRDFLAGS DS    CL1                 FLAGS IN CPU STATUS RECORD
PRDUNIPR EQU   X'80'               UNIPROCESSOR FLAG
PRDSSINV EQU   X'40'               STORE STATUS MAY BE INVALID FLAG
PRDGPRVL EQU   X'20'               GPRS VALID IF PRDSSINV ALSO =1
         DS    CL1                 RESERVED
         DC    X'0000'             THIS FIELD MUST BE '0000'X
PRDCPUAD DS    CL2                 ADDR OF CPU WHOSE STATUS WAS STORED
         DS    CL4096              NAME OF THIS FIELD IS SAME AS
*                                  CORRESPONDING FIELD IN DATA RECORD
*                                  -- I.E., PRDDATA  -- CONTAINS CPU
*                                  STATUS DATA
         SPACE 1
         ORG
*        RESTORE POINTER TO HIGHEST VALUE
         MEND                                                        */
*%PRIN2 : ;
*
*/********************************************************************/
*/*      AMDPRDMP HEADER RECORD FORMATS  --  COMMON FIELDS AND       */
*/*      FIELDS UNIQUE FOR DSS OR SVCDUMP INPUT                      */
*/********************************************************************/
*
*DECLARE
*  1 PRDINPUT BASED(PRDINPTR) BDY(WORD),
*   2 PRDHDRID CHAR(1) BDY(WORD),      /* HEADER RECORD ID           */
*   2 PRDRECID CHAR(1),                /* RECORD ID                  */
*   2 PRDASID CHAR(2) BDY(HWORD),      /* ASID OF MEMORY DUMPED      */
*   2 PRDMODNM CHAR(8) BDY(WORD),      /* PROGRAM THAT CREATED INPUT */
*   2 PRDTODVL CHAR(8) BDY(WORD),      /* TOD CLOCK VALUE AT TIME OF
*                                         DUMP                       */
*   2 PRDTITLE CHAR(100) BDY(WORD),    /* TITLE FROM DUMP            */
*   2 PRDREGS CHAR(168) BDY(WORD),
*    3 PRDFPR CHAR(32) BDY(WORD),       /* FLOATING POINT REGISTERS  */
*    3 PRDGPR CHAR(64) BDY(WORD),       /* GENERAL PURPOSE REGISTERS */
*    3 PRDCR CHAR(64) BDY(WORD),        /* CONTROL REGISTERS         */
*    3 PRDPSW CHAR(8) BDY(WORD),        /* CURRENT PSW AT TIME OF
*                                         DUMP                       */
*   2 PRDCVT CHAR(4) BDY(WORD),        /* REAL ADDR OF CVT           */
     2 *        CHAR(32),     /* RESERVED FOR SVC DUMP USE           */
     2 PRDERRID CHAR(10),     /* ERROR ID                            */
     2 *        CHAR(48),     /* RESERVED FOR SVC DUMP USE  UZ83300  */
     2 *        CHAR(3722);   /* REMAINING BYTES IN RECORD  UZ83300  */
*
*DECLARE
*  PRDHDR BIT(8) CONSTANT('FF'X),      /* HEADER ID IN PRDHDRID FIELD*/
*  PRDHDREC BIT(8) CONSTANT('FF'X),    /* HEADER ID IN PRDRECID
*                                         FIELD                      */
*  PRDSAWRK BIT(8) CONSTANT('00'X);    /* AMDSADMP WORK RECORD ID IN
*                                         PRDRECID FIELD             */
*
*/********************************************************************/
*/*      THE FOLLOWING FIELDS OVERLAY THE PRDFPR AND SUCCEEDING      */
*/*      FIELDS FOR AMDSADMP INPUT                                   */
*/********************************************************************/
*
*DECLARE
*  1 PRDFLC DEF(PRDFPR) BDY(WORD),
*   2 PRDCSW CHAR(8) BDY(WORD),        /* CSW AT ABSOLUTE LOCATION 64
*                                                                    */
*   2 PRDCAW CHAR(4) BDY(WORD),        /* CAW AT ABSOLUTE LOCATION 72
*                                                                    */
*   2 * CHAR(3972) BDY(WORD);          /* RESERVED AREA              */
*
*/********************************************************************/
*/*      AMDPRDMP DATA RECORD FORMAT                                 */
*/********************************************************************/
*
*DECLARE
*  1 * DEF(PRDHDRID) BDY(WORD),
*   2 PRDKEY1 CHAR(1) BDY(WORD),       /* STORAGE KEY FOR 1ST 2K OF
*                                         BLOCK                      */
*   2 PRDKEY2 CHAR(1),                 /* STORAGE KEY FOR 2ND 2K OF
*                                         BLOCK                      */
*   2 * CHAR(2) BDY(HWORD),            /* NAME OF THIS FIELD SAME AS
*                                         CORRESPONDING FIELD IN HEADER
*                                         I.E., PRDASID -- CONTAINS
*                                         ASID OF MEMORY DUMPED      */
*   2 PRDADDR CHAR(4) BDY(WORD),       /* ADDRESS OF STORAGE DUMPED
*                                         (ON 4K BOUNDARY)           */
*   2 PRDDATA CHAR(4096) BDY(WORD);    /* DATA FIELD  -- CONTAINS DATA
*                                         THAT WAS AT THE ADDRESS
*                                         LISTED IN THE PRDADDR FIELD*/
*
*/********************************************************************/
*/*      AMDPRDMP CPU STATUS RECORD FORMAT                           */
*/********************************************************************/
*
*DECLARE
*  1 * DEF(PRDHDRID) BDY(WORD),
*   2 * CHAR(1) BDY(WORD),             /* NAME OF THIS FIELD SAME AS
*                                         CORRESPONDING FIELD IN HEADER
*                                         I.E., PRDHDRID -- CONTAINS
*                                         ID OF RECORD               */
*   2 * CHAR(1),                       /* NAME OF THIS FIELD SAME AS
*                                         CORRESPONDING FIELD IN HEADER
*                                         I.E., PRDRECID -- CONTAINS
*                                         ID OF RECORD               */
*   2 PRDFLAGS CHAR(1) BDY(HWORD),     /* FLAGS                      */
*    3 PRDUNIPR BIT(1),                /* UNIPROCCESSOR FLAG         */
*    3 PRDSSINV BIT(1),                /* STORE STATUS MAY BE INVALID
*                                         FLAG                       */
*    3 PRDGPRVL BIT(1),                /* GPRS VALID IF PRDSSINV
*                                         ALSO =1                    */
*    3 * BIT(5),                       /* UNUSED FLAGS               */
*   2 * CHAR(1),                       /* RESERVED FIELD             */
*   2 * CHAR(2),                       /* FIELD OF ZEROES            */
*   2 PRDCPUAD CHAR(2) BDY(HWORD),     /* ADDR OF CPU WHOSE STATUS
*                                         WAS STORED                 */
*   2 * CHAR(4096) BDY(WORD);          /* NAME OF THIS FIELD SAME AS
*                                         CORRESPONDING FIELD IN DATA
*                                         RECORD -- I.E., PRDDATA --
*                                         CONTAINS CPU STATUS DATA   */
*
*DECLARE
*  PRDCPUID BIT(8) CONSTANT('0F'X);    /* CPU STATUS RECORD ID IN
*                                         PRDRECID FIELD             */
*
