         TITLE 'AMDPRPJB - PRINT JOBNAME EXECUTOR                      *
                       '
AMDPRPJB CSECT ,                                                01S0001
@MAINENT DS    0H                                               01S0001
         USING *,@15                                            01S0001
         B     @PROLOG                                          01S0001
         DC    AL1(16)                                          01S0001
         DC    C'AMDPRPJB  73.242'                              01S0001
         DROP  @15
@PROLOG  STM   @14,@12,12(@13)                                  01S0001
         BALR  @11,0                                            01S0001
@PSTART  DS    0H                                               01S0001
         USING @PSTART,@11                                      01S0001
         ST    @13,@SA00001+4                                   01S0001
         LA    @14,@SA00001                                     01S0001
         ST    @14,8(,@13)                                      01S0001
         LR    @13,@14                                          01S0001
*/*------------------------------------------------------------------*/
*/* AMDPRPJB: SCANS INPUT FOR JOBNAMES AND INITIATES CONTROL BLOCK   */
*/* FORMATTING AND PRINTING OF STORAGE FOR EACH NAME THAT CAN BE     */
*/* FOUND IN THE DUMP.                                               */
*/*------------------------------------------------------------------*/
*/*------------------------------------------------------------------*/
*/* ESTABLISH ERROR ROUTINE ADDRESSES AND INIT SWITCHES              */
*/*------------------------------------------------------------------*/
*DO;                                                            02S0043
*  GEN(USING AMDPRPJX,R10);                                     02S0044
         USING AMDPRPJX,R10
*  READSAVE = ERRADDR;            /* SAVE PREVIOUS READ ERROR RTN    */
         MVC   READSAVE(4),ERRADDR(COMBASE)                     02S0045
*  STOPSAVE = STOPEXIT;           /* SAVE PREVIOUS STOP ERROR RTN    */
         MVC   STOPSAVE(4),STOPEXIT(COMBASE)                    02S0046
*  ERRADDR = ADDR(PJBREAD);       /* ADDR OF PJB READ ERROR RTN      */
         LA    @10,PJBREAD                                      02S0047
         ST    @10,ERRADDR(,COMBASE)                            02S0047
*  STOPEXIT = ADDR(PJBSTOP);      /* ADDR OF PJB STOP ERROR RTN      */
         LA    @10,PJBSTOP                                      02S0048
         ST    @10,STOPEXIT(,COMBASE)                           02S0048
*  RESPECIFY R13 RESTRICTED;                                    02S0049
*  PJBSAVE = R13;                 /* SAVE AREA ADDR FOR ASYNC RTNS   */
         ST    R13,PJBSAVE                                      02S0050
*  RESPECIFY R13 UNRESTRICTED;                                  02S0051
*  STATUS = GOOD;                 /* INIT SYNTAX ERROR SWITCH        */
         MVI   STATUS,X'00'                                     02S0052
*  PCBPL = PCBPL&&PCBPL;          /* ZERO OUT PCB PARM LIST          */
         XC    PCBPL(12),PCBPL                                  02S0053
*  JOBCOUNT = 0;                  /* INIT JOBNAME TABLE              */
         SR    @10,@10                                          02S0054
         ST    @10,JOBCOUNT                                     02S0054
*  LASTASID = 0;                                                02S0055
         LR    LASTASID,@10                                     02S0055
*  DO I=1 TO 10;                  /* INIT JOB STATUS BITS            */
         LA    I,1                                              02S0056
@DL00056 DS    0H                                               02S0057
*    JOBHIT(I) = OFF;                                           02S0057
         LA    @10,JOBHIT-1(I)                                  02S0057
         NI    0(@10),B'01111111'                               02S0057
*  END;                                                         02S0058
         AH    I,@CH00060                                       02S0058
         CH    I,@CH00953                                       02S0058
         BNH   @DL00056                                         02S0058
*  FIRST = ON;                    /* DONT DO SKIP FIRST TIME         */
         OI    FIRST,B'10000000'                                02S0059
*END;                                                           02S0060
*  IF DELIMCD^=EQUAL THEN         /* NO JOBNAMES SPECIFIED           */
         CLC   DELIMCD(4,COMBASE),@CF00058                      01S0061
         BE    @RF00061                                         01S0061
*    STATUS = INVALDLM;                                         01S0062
         MVI   STATUS,X'40'                                     01S0062
*  ELSE                           /* OPERANDS WERE SPECIFIED         */
*    DO;                                                        01S0063
         B     @RC00061                                         01S0063
@RF00061 DS    0H                                               01S0064
*      OPSCAN = ON;               /* INIT LOOP CONTROL SWITCH        */
         OI    OPSCAN,B'10000000'                               01S0064
*      CALL DELIMSCN;                                           01S0065
         BAL   @14,DELIMSCN                                     01S0065
*      IF DELIMCD=LPAREN & OPSIZE=0 THEN /* VALID SUBFIELD           */
         CLC   DELIMCD(4,COMBASE),@CF00730                      01S0066
         BNE   @RF00066                                         01S0066
         LTR   OPSIZE,OPSIZE                                    01S0066
         BNZ   @RF00066                                         01S0066
*        DO;                                                    01S0067
*          DO JOBS=1 TO 10 WHILE OPSCAN=ON; /* SCAN FOR JOBNAMES     */
         LA    JOBS,1                                           01S0068
@DL00068 TM    OPSCAN,B'10000000'                               01S0068
         BNO   @DC00068                                         01S0068
*            CALL DELIMSCN;       /* GET NEXT DELIMITER              */
         BAL   @14,DELIMSCN                                     01S0069
*            IF DELIMCD=COMA THEN /* MORE THAN ONE JOBNAME           */
         CLC   DELIMCD(4,COMBASE),@CF00052                      01S0070
         BNE   @RF00070                                         01S0070
*              STATUS = GOOD;     /* CONTINUE SCAN                   */
         MVI   STATUS,X'00'                                     01S0071
*            ELSE                                               01S0072
*              IF DELIMCD=RPAREN THEN /* END OF OPERANDS             */
         B     @RC00070                                         01S0072
@RF00070 CLC   DELIMCD(4,COMBASE),@CF00987                      01S0072
         BNE   @RF00072                                         01S0072
*                DO;                                            01S0073
*                  STATUS = GOOD;                               01S0074
         MVI   STATUS,X'00'                                     01S0074
*                  OPSCAN = OFF;   /* END OPERAND SCAN               */
         NI    OPSCAN,B'01111111'                               01S0075
*                END;                                           01S0076
*              ELSE               /* INVALID DELIMITER               */
*                DO;                                            01S0077
         B     @RC00072                                         01S0077
@RF00072 DS    0H                                               01S0078
*                  STATUS = INVALDLM;                           01S0078
         MVI   STATUS,X'40'                                     01S0078
*                  OPSCAN = OFF; /* TERMINATE SCAN                   */
         NI    OPSCAN,B'01111111'                               01S0079
*                END;                                           01S0080
*            IF STATUS = GOOD THEN /* NO PROBLEMS TO THIS POINT      */
@RC00072 DS    0H                                               01S0081
@RC00070 CLI   STATUS,X'00'                                     01S0081
         BNE   @RF00081                                         01S0081
*/*------------------------------------------------------------------*/
*/* CHECK FOR DUPLICATE NAME AND PLACE IN NAME TABLE                 */
*/*------------------------------------------------------------------*/
*DO;                                                            02S0082
*  IF OPSIZE=0 THEN               /* OPERAND IS MISSING              */
         LTR   OPSIZE,OPSIZE                                    02S0083
         BNZ   @RF00083                                         02S0083
*    DO;                                                        02S0084
*      STATUS = OPOMIT;                                         02S0085
         MVI   STATUS,X'10'                                     02S0085
*      OPSCAN = OFF;              /* TERMINATE SCAN                  */
         NI    OPSCAN,B'01111111'                               02S0086
*    END;                                                       02S0087
*  ELSE                                                         02S0088
*    IF OPSIZE>8 THEN             /* OPERAND IS TOO BIG              */
         B     @RC00083                                         02S0088
@RF00083 CH    OPSIZE,@CH00058                                  02S0088
         BNH   @RF00088                                         02S0088
*      DO;                                                      02S0089
*        STATUS = NAMTOBIG;                                     02S0090
         MVI   STATUS,X'08'                                     02S0090
*        OPSCAN = OFF;            /* TERMINATE SCAN                  */
         NI    OPSCAN,B'01111111'                               02S0091
*      END;                                                     02S0092
*    ELSE                         /* SIZE IS GOOD                    */
*      DO;                                                      02S0093
         B     @RC00088                                         02S0093
@RF00088 DS    0H                                               02S0094
*        JOBNAMEC = JOBNAME(1:OPSIZE); /* PAD JOBNAME WITH BLANKS    */
         MVI   JOBNAMEC+1,C' '                                  02S0094
         MVC   JOBNAMEC+2(6),JOBNAMEC+1                         02S0094
         LR    @10,OPSIZE                                       02S0094
         BCTR  @10,0                                            02S0094
         L     @02,KYWDBGN(,COMBASE)                            02S0094
         EX    @10,@SM01292                                     02S0094
*        DUPE = OFF;              /* INIT LOOP CONTROL               */
         NI    DUPE,B'10111111'                                 02S0095
*        DO DUPECHK=1 TO JOBCOUNT WHILE DUPE=OFF; /* SCAN TABLE FOR
*                                  DUPLICATE ENTRY                   */
         LA    DUPECHK,1                                        02S0096
         B     @DE00096                                         02S0096
@DL00096 TM    DUPE,B'01000000'                                 02S0096
         BNZ   @DC00096                                         02S0096
*          IF JOBENTRY(DUPECHK)=JOBNAMEC THEN /* DUPE                */
         LR    @10,DUPECHK                                      02S0097
         SLA   @10,3                                            02S0097
         LA    @02,JOBENTRY-8(@10)                              02S0097
         CLC   0(8,@02),JOBNAMEC                                02S0097
         BNE   @RF00097                                         02S0097
*            DUPE = ON;                                         02S0098
         OI    DUPE,B'01000000'                                 02S0098
*        END;                                                   02S0099
@RF00097 AH    DUPECHK,@CH00060                                 02S0099
@DE00096 C     DUPECHK,JOBCOUNT                                 02S0099
         BNH   @DL00096                                         02S0099
@DC00096 DS    0H                                               02S0100
*        IF DUPE=OFF THEN         /* UNIQUE ENTRY - PUT IN TABLE     */
         TM    DUPE,B'01000000'                                 02S0100
         BNZ   @RF00100                                         02S0100
*          DO;                                                  02S0101
*            JOBCOUNT = JOBCOUNT+1;                             02S0102
         LA    @10,1                                            02S0102
         A     @10,JOBCOUNT                                     02S0102
         ST    @10,JOBCOUNT                                     02S0102
*            JOBENTRY(JOBCOUNT) = JOBNAMEC;                     02S0103
         SLA   @10,3                                            02S0103
         LA    @15,JOBENTRY-8(@10)                              02S0103
         MVC   0(8,@15),JOBNAMEC                                02S0103
*          END;                                                 02S0104
*      END;                                                     02S0105
@RF00100 DS    0H                                               02S0106
*END;                                                           02S0106
@RC00088 DS    0H                                               02S0106
@RC00083 DS    0H                                               02S0107
*          END;                                                 01S0107
@RF00081 AH    JOBS,@CH00060                                    01S0107
         CH    JOBS,@CH00953                                    01S0107
         BNH   @DL00068                                         01S0107
@DC00068 DS    0H                                               01S0108
*          IF JOBS>10 & OPSCAN=ON THEN /* TOO MANY JOBNAMES SPECIFIED*/
         CH    JOBS,@CH00953                                    01S0108
         BNH   @RF00108                                         01S0108
         TM    OPSCAN,B'10000000'                               01S0108
         BNO   @RF00108                                         01S0108
*            STATUS = TOOMANY;                                  01S0109
         MVI   STATUS,X'20'                                     01S0109
*          ELSE                                                 01S0110
*            IF STATUS=GOOD THEN  /* NO ERRORS IN PARM FIELD         */
         B     @RC00108                                         01S0110
@RF00108 CLI   STATUS,X'00'                                     01S0110
         BNE   @RF00110                                         01S0110
*/*------------------------------------------------------------------*/
*/* CHECK IF LAST DELIMITER IS OK                                    */
*/*------------------------------------------------------------------*/
*DO;                                                            02S0111
*  CALL DELIMSCN;                 /* GET NEXT DELIMITER              */
         BAL   @14,DELIMSCN                                     02S0112
*  IF DELIMCD^=BLANK & DELIMCD^=COMA THEN /* INVALID DELIMITER       */
         L     @10,DELIMCD(,COMBASE)                            02S0113
         CH    @10,@CH01013                                     02S0113
         BE    @RF00113                                         02S0113
         CH    @10,@CH00052                                     02S0113
         BE    @RF00113                                         02S0113
*    STATUS = BADLAST;                                          02S0114
         MVI   STATUS,X'04'                                     02S0114
*  ELSE                           /* DELIMITER IS GOOD               */
*    IF OPSIZE^=0 THEN            /* DELIMITER DOES NOT FOLLOW RIGHT
*                                    PAREN                           */
         B     @RC00113                                         02S0115
@RF00113 LTR   OPSIZE,OPSIZE                                    02S0115
         BZ    @RF00115                                         02S0115
*      STATUS = BADLAST;                                        02S0116
         MVI   STATUS,X'04'                                     02S0116
*END;                                                           02S0117
*        END;                                                   01S0118
*      ELSE                       /* DELIMITER WAS NOT LEFT PAREN    */
*        STATUS = INVALDLM;                                     01S0119
         B     @RC00066                                         01S0119
@RF00066 MVI   STATUS,X'40'                                     01S0119
*    END;                                                       01S0120
@RC00066 DS    0H                                               01S0121
*    IF STATUS=GOOD THEN                                        01S0121
@RC00061 CLI   STATUS,X'00'                                     01S0121
         BNE   @RF00121                                         01S0121
*      IF FLSHMODE=OFF THEN       /* PROCESS NAMES                   */
         TM    FLSHMODE(COMBASE),B'10000000'                    01S0122
         BNZ   @RF00122                                         01S0122
*/*------------------------------------------------------------------*/
*/* OBTAIN THE JOBNAME ASSOCIATED WITH AN ASCB AND CHECK FOR A       */
*/* MATCH IN THE NAME TABLE.                                         */
*/*------------------------------------------------------------------*/
*DO;                                                            02S0123
*  ASVTFAIL = ON;                 /* WILL BE TURNED OFF IF ASVT IS
*                                    READ SUCCESSFULLY               */
         OI    ASVTFAIL,B'00010000'                             02S0124
*  IF CVTPTR^=0 THEN              /* CVT IS AVAILABLE                */
         SR    @10,@10                                          02S0125
         L     @04,CVTPTR(,COMBASE)                             02S0125
         CR    @04,@10                                          02S0125
         BE    @RF00125                                         02S0125
*    DO;                                                        02S0126
*      RESPECIFY R2 RESTRICTED;   /* GET POINTER TO ASVT             */
*                                                               02S0127
*      DO;                                                      02S0128
*        PREG = ADDR(CVTASVT);                                  02S0129
         LA    PREG,CVTASVT(,@04)                               02S0129
*        RETCODE = 0;                                           02S0130
         ST    @10,RETCODE                                      02S0130
*        R2 = 0;                                                02S0131
         LR    R2,@10                                           02S0131
*        GEN(BRREAD (PREG),DATA,ASID=(R2))                      02S0132
*           REFS(BRRDDATA)                                      02S0132
*           SETS(PREG,RETCODE)                                  02S0132
*           FLOWS(PJBREAD);                                     02S0132
         BRREAD (PREG),DATA,ASID=(R2)
*      END;                                                     02S0133
*      RESPECIFY R2 UNRESTRICTED;                               02S0134
*      IF RETCODE=0 & DATAP24^=0 THEN /* ASVT POINTER WAS OBTAINED   */
         SR    @10,@10                                          02S0135
         C     @10,RETCODE                                      02S0135
         BNE   @RF00135                                         02S0135
         ICM   @04,7,DATAP24(R1)                                02S0135
         BZ    @RF00135                                         02S0135
*        DO;                                                    02S0136
*          ASVTPTR = DATAWORD;                                  02S0137
         L     @04,DATAWORD(,R1)                                02S0137
         ST    @04,ASVTPTR                                      02S0137
*          /*      GET TOT NUMBER OF ASVT ENTRIES                    */
*                                                               02S0138
*          DO;                                                  02S0138
*            PREG = ADDR(ASVTMAXU);                             02S0139
         LA    PREG,ASVTMAXU(,@04)                              02S0139
*            RETCODE = 0;                                       02S0140
         ST    @10,RETCODE                                      02S0140
*            GEN(BRREAD (PREG))                                 02S0141
*               REFS(BRRDDATA)                                  02S0141
*               SETS(PREG,RETCODE)                              02S0141
*               FLOWS(PJBREAD);                                 02S0141
         BRREAD (PREG)
*          END;                                                 02S0142
*          IF RETCODE=0 THEN  /* SUCCESSFUL READ                 */
         ICM   @10,15,RETCODE                                   02S0143
         BNZ   @RF00143                                         02S0143
*            DO;                                                02S0144
*              NUMASCB = DATAWORD;                              02S0145
         MVC   NUMASCB(4),DATAWORD(R1)                          02S0145
*              ASVTFAIL = OFF; /* USE ASVT FOR ASCB ADDRS        */
         NI    ASVTFAIL,B'11101111'                             02S0146
*            END;                                               02S0147
*        END;                                                   02S0148
@RF00143 DS    0H                                               02S0149
*    END;                                                       02S0149
@RF00135 DS    0H                                               02S0150
*    IF ASVTFAIL=ON THEN          /* THEN MUST USE ASCBMAP           */
@RF00125 TM    ASVTFAIL,B'00010000'                             02S0150
         BNO   @RF00150                                         02S0150
*      IF ASCBMAP^=0 THEN         /* THERE IS AN ASCBMAP             */
         L     @10,ASCBMAP(,COMBASE)                            02S0151
         LTR   @10,@10                                          02S0151
         BZ    @RF00151                                         02S0151
*        NUMASCB = MAPNUM;        /* NUMBER OF ENTRIES IN ASCBMAP    */
         LH    @10,MAPNUM(,@10)                                 02S0152
         ST    @10,NUMASCB                                      02S0152
*      ELSE                       /* ASCBMAP IS EMPTY                */
*/*------------------------------------------------------------------*/
*/* INDICATE THAT PJB CANNOT PROCESS                                 */
*/*------------------------------------------------------------------*/
*DO;                                                            03S0153
         B     @RC00151                                         03S0153
@RF00151 DS    0H                                               03S0154
*  RESPECIFY (R10,R2) RESTRICTED;                               03S0154
*  R10 = APJX;                    /* GET ADDRESSABILITY TO  MSG CSECT *
         L     R10,APJX                                         03S0155
*  R2 = M166ILGT-4;               /* MSG LENGTH                      */
         LA    @15,4                                            03S0156
         LH    R2,M166ILGT                                      03S0156
         SR    R2,@15                                           03S0156
*  R1 = ADDR(AMD166I)+4;                                        03S0157
         LA    R1,AMD166I                                       03S0157
         AR    R1,@15                                           03S0157
*  CALL PRTMSG;                   /* SEND MSG TO SYSPRINT            */
         L     @15,APRTMSG(,COMBASE)                            03S0158
         BALR  @14,@15                                          03S0158
*  IF RDRSW=OFF THEN              /* SHOULD TELL OPERATOR            */
*                                                               03S0159
         TM    RDRSW(COMBASE),B'00000001'                       03S0159
         BNZ   @RF00159                                         03S0159
*     DO;/*WTOP MF(E,AMD166I)*/                                 03S0160
*       RFY GPR01P RSTD; /*RESTRICT REG 1*/                     03S0161
*       GPR01P=ADDR(AMD166I); /*ADDRESS CONTROL PROGRAM LIST*/  03S0162
         LA    GPR01P,AMD166I                                   03S0162
*       SVC (35); /*ISSUE WTO SVC*/                             03S0163
         SVC   35                                               03S0163
*       RFY GPR01P UNRSTD; /*RELEASE REG 1*/                    03S0164
*     END; /*WTOP MF(E,AMD166I)*/                               03S0165
*  RESPECIFY (R10,R2) UNRESTRICTED;                             03S0166
@RF00159 DS    0H                                               03S0167
*  STOPEXIT = STOPSAVE;           /* RESTORE PREVIOUS STOP RTN       */
         MVC   STOPEXIT(4,COMBASE),STOPSAVE                     03S0167
*  ERRADDR = READSAVE;            /* RESTORE PREVIOUS READ ERR RTN   */
         MVC   ERRADDR(4,COMBASE),READSAVE                      03S0168
*  RETURN;                                                      03S0169
@EL00001 L     @13,4(,@13)                                      03S0169
@EF00001 DS    0H                                               03S0169
@ER00001 LM    @14,@12,12(@13)                                  03S0169
         BR    @14                                              03S0169
*END;                                                           03S0170
*    GEN(BRWRITE SKIP)                                          02S0171
*       REFS(AWRITE);             /* SKIP TO TOP OF PAGE             */
@RC00151 DS    0H                                               02S0171
@RF00150 DS    0H                                               02S0171
         BRWRITE SKIP
*    TITLEPLC = PJBTITLE;                                       02S0172
         L     @10,CURBUF(,COMBASE)                             02S0172
         MVC   TITLEPLC+39(42,@10),PJBTITLE                     02S0172
*    GEN(BRWRITE 3);              /* PRINT TITLE                     */
         BRWRITE 3
*    EXITFLAG = DCURJOB;                                        02S0174
         MVI   EXITFLAG(COMBASE),X'10'                          02S0174
*    CALL AMDPRUIM;               /* CALL USER EXITS                 */
         L     @15,AUSREXIT(,COMBASE)                           02S0175
         BALR  @14,@15                                          02S0175
*/*------------------------------------------------------------------*/
*/* THE OUTER LOOP IS EXECUTED ONLY ONCE IF THERE IS NO PROBLEM      */
*/* USING THE ASVT. IF THERE IS A READ FAILURE WHILE READING THE     */
*/* ASVT THEN THE CONTROL VARIABLES ARE RESET USING THE ASCBMAP      */
*/* AND THE LOOP IS ENTERED AGAIN.                                   */
*/*------------------------------------------------------------------*/
*SEARCH = ON;                     /* INIT LOOP CONTROL               */
*ALTPATH = ON;                    /* INIT LOOP CONTROL               */
         OI    SEARCH,B'00000110'                               03S0177
*DO WHILE ALTPATH=ON & SEARCH=ON;                               03S0178
         B     @DE00178                                         03S0178
@DL00178 DS    0H                                               03S0179
*  ALTPATH = OFF;                                               03S0179
         NI    ALTPATH,B'11111011'                              03S0179
*  DO LOOPNX=1 TO NUMASCB WHILE ALTPATH=OFF;                    03S0180
         LA    LOOPNX,1                                         03S0180
         B     @DE00180                                         03S0180
@DL00180 TM    ALTPATH,B'00000100'                              03S0180
         BNZ   @DC00180                                         03S0180
*    NOGOSW = OFF;                /* INIT TO VALID ENTRY             */
         NI    NOGOSW,B'11110111'                               03S0181
*    IF ASVTFAIL = ON THEN        /* USE ASCBMAP                     */
         TM    ASVTFAIL,B'00010000'                             03S0182
         BNO   @RF00182                                         03S0182
*      IF MAPASID(LOOPNX)>LASTASID THEN /* THIS ASCB HAS NOT BEEN
*                                    PROCESSED BEFORE                */
         LR    @10,LOOPNX                                       03S0183
         AR    @10,@10                                          03S0183
         L     @15,ASCBMAP(,COMBASE)                            03S0183
         ALR   @10,@15                                          03S0183
         SR    @14,@14                                          03S0183
         ICM   @14,3,MAPASID-2(@10)                             03S0183
         CR    @14,LASTASID                                     03S0183
         BNH   @RF00183                                         03S0183
*        DO;                                                    03S0184
*          THISASID = MAPASID(LOOPNX);                          03S0185
         STH   @14,THISASID                                     03S0185
*          ADDRASCB = TABASCB(LOOPNX);                          03S0186
         LR    @10,LOOPNX                                       03S0186
         SLA   @10,3                                            03S0186
         L     @15,MAPTAB(,@15)                                 03S0186
         AL    @15,@CF01300                                     03S0186
         L     @10,TABASCB(@10,@15)                             03S0186
         ST    @10,ADDRASCB                                     03S0186
*        END;                                                   03S0187
*      ELSE                       /* ASCB HAS BEEN PROCESSED         */
*        NOGOSW = ON;             /* DONT DO SEARCH                  */
         B     @RC00183                                         03S0188
@RF00183 OI    NOGOSW,B'00001000'                               03S0188
*    ELSE                         /* USE ASVT                        */
*      DO;                                                      03S0189
         B     @RC00182                                         03S0189
@RF00182 DS    0H                                               03S0190
*        THISASID = LOOPNX;                                     03S0190
         STH   LOOPNX,THISASID                                  03S0190
*        RESPECIFY R2 RESTRICTED; /* GET NEXT ASVT ENTRY             */
*                                                               03S0191
*        DO;                                                    03S0192
*          PREG = ADDR(ASVTENTY(LOOPNX));                       03S0193
         LR    @10,LOOPNX                                       03S0193
         SLA   @10,2                                            03S0193
         L     PREG,ASVTPTR                                     03S0193
         LA    PREG,ASVTENTY-4(@10,PREG)                        03S0193
*          RETCODE = 0;                                         03S0194
         SR    @10,@10                                          03S0194
         ST    @10,RETCODE                                      03S0194
*          R2 = 0;                                              03S0195
         LR    R2,@10                                           03S0195
*          GEN(BRREAD (PREG),DATA,ASID=(R2))                    03S0196
*             REFS(BRRDDATA)                                    03S0196
*             SETS(PREG,RETCODE)                                03S0196
*             FLOWS(PJBREAD);                                   03S0196
         BRREAD (PREG),DATA,ASID=(R2)
*        END;                                                   03S0197
*        RESPECIFY R2 UNRESTRICTED;                             03S0198
*        IF RETCODE=0 THEN        /* READ WAS SUCCESSFUL             */
         ICM   @10,15,RETCODE                                   03S0199
         BNZ   @RF00199                                         03S0199
*          IF DATABIT=OFF & DATAP24^=0 THEN /* GOOD ENTRY            */
         TM    DATABIT(R1),B'10000000'                          03S0200
         BNZ   @RF00200                                         03S0200
         ICM   @10,7,DATAP24(R1)                                03S0200
         BZ    @RF00200                                         03S0200
*            ADDRASCB = DATAWORD;                               03S0201
         MVC   ADDRASCB(4),DATAWORD(R1)                         03S0201
*          ELSE                   /* NOT ASSIGNED                    */
*            NOGOSW = ON;         /* SKIP THIS ENTRY                 */
         B     @RC00200                                         03S0202
@RF00200 OI    NOGOSW,B'00001000'                               03S0202
*        ELSE                     /* UNABLE TO USE REMAINDER OF ASVT */
*          DO;                                                  03S0203
         B     @RC00199                                         03S0203
@RF00199 DS    0H                                               03S0204
*            ALTPATH = ON;        /* GET BACK INTO THIS LOOP         */
*            NOGOSW = ON;         /* TERMINATE THIS PASS             */
         OI    ALTPATH,B'00001100'                              03S0205
*            IF ASCBMAP^=0 THEN   /* ASCBMAP IS AVAILABLE            */
         L     @10,ASCBMAP(,COMBASE)                            03S0206
         LTR   @10,@10                                          03S0206
         BZ    @RF00206                                         03S0206
*              DO;                                              03S0207
*                LASTASID = LOOPNX-1; /* ASCBMAP PROCESSING WILL
*                                    START AT THIS ASID              */
         LR    LASTASID,LOOPNX                                  03S0208
         BCTR  LASTASID,0                                       03S0208
*                ASVTFAIL = ON;   /* USE ASCBMAP FROM NOW ON         */
         OI    ASVTFAIL,B'00010000'                             03S0209
*                NUMASCB = MAPNUM; /* RESET LOOP CONTROL             */
         LH    @10,MAPNUM(,@10)                                 03S0210
         ST    @10,NUMASCB                                      03S0210
*              END;                                             03S0211
*            ELSE                 /* ASCBMAP NOT AVAILABLE           */
*              SEARCH = OFF;      /*STOP PROCESSING                  */
         B     @RC00206                                         03S0212
@RF00206 NI    SEARCH,B'11111101'                               03S0212
*          END;                                                 03S0213
@RC00206 DS    0H                                               03S0214
*      END;                                                     03S0214
@RC00199 DS    0H                                               03S0215
*    IF NOGOSW=OFF THEN           /* PROCESS THIS ASCB               */
@RC00182 TM    NOGOSW,B'00001000'                               03S0215
         BNZ   @RF00215                                         03S0215
*/*------------------------------------------------------------------*/
*/* GET THE NAME ASSOCIATED WITH THIS ASCB AND COMPARE WITH THE      */
*/* NAMES IN THE NAME TABLE                                          */
*/*------------------------------------------------------------------*/
*DO;                              /* GET ADDR OF P/P JOBNAME         */
*  RESPECIFY R2 RESTRICTED;                                     04S0217
*                                                               04S0217
*  DO;                                                          04S0218
*    PREG = ADDR(ASCBJBNI);                                     04S0219
         L     PREG,ASCBPTR                                     04S0219
         LA    PREG,ASCBJBNI(,PREG)                             04S0219
*    RETCODE = 0;                                               04S0220
         SR    @10,@10                                          04S0220
         ST    @10,RETCODE                                      04S0220
*    GEN(BRREAD (PREG))                                         04S0221
*       REFS(BRRDDATA)                                          04S0221
*       SETS(PREG,RETCODE)                                      04S0221
*       FLOWS(PJBREAD);                                         04S0221
         BRREAD (PREG)
*  END;                                                         04S0222
*  RESPECIFY R2 UNRESTRICTED;                                   04S0223
*  IF RETCODE=0 THEN              /* ASCBJBNI WAS READ               */
         SR    @10,@10                                          04S0224
         C     @10,RETCODE                                      04S0224
         BNE   @RF00224                                         04S0224
*    DO;                                                        04S0225
*      IF DATAP24=0 THEN          /* NO INITIATOR JOBNAME            */
         ICM   @00,7,DATAP24(R1)                                04S0226
         BNZ   @RF00226                                         04S0226
*        DO;                      /* GET SYSTEM NAME ADDR            */
*                                                               04S0227
*          DO;                                                  04S0228
*            PREG = ADDR(ASCBJBNS);                             04S0229
         L     PREG,ASCBPTR                                     04S0229
         LA    PREG,ASCBJBNS(,PREG)                             04S0229
*            RETCODE = 0;                                       04S0230
         ST    @10,RETCODE                                      04S0230
*            GEN(BRREAD (PREG))                                 04S0231
*               REFS(BRRDDATA)                                  04S0231
*               SETS(PREG,RETCODE)                              04S0231
*               FLOWS(PJBREAD);                                 04S0231
         BRREAD (PREG)
*          END;                                                 04S0232
*          IF RETCODE^=0 | DATAP24=0 THEN /* NO SYSTEM NAME EITHER   */
         ICM   @10,15,RETCODE                                   04S0233
         BNZ   @RT00233                                         04S0233
         ICM   @10,7,DATAP24(R1)                                04S0233
         BNZ   @RF00233                                         04S0233
@RT00233 DS    0H                                               04S0234
*            NOGOSW = ON;         /* DONT CONTINUE                   */
         OI    NOGOSW,B'00001000'                               04S0234
*        END;                                                   04S0235
@RF00233 DS    0H                                               04S0236
*      IF NOGOSW=OFF THEN         /* ONE OF THE TWO POINTERS WAS GOOD*/
@RF00226 TM    NOGOSW,B'00001000'                               04S0236
         BNZ   @RF00236                                         04S0236
*        DO;                      /* COPY NAME INTO WORK AREA        */
*          NAMEADDR = DATAWORD;                                 04S0238
         L     NAMEADDR,DATAWORD(,R1)                           04S0238
*                                 /* GET FIRST FOUR BYTES OF NAME    */
*                                                               04S0239
*          DO;                                                  04S0239
*            PREG = ADDR(ANAME1);                               04S0240
         LR    PREG,NAMEADDR                                    04S0240
*            RETCODE = 0;                                       04S0241
         SR    @10,@10                                          04S0241
         ST    @10,RETCODE                                      04S0241
*            GEN(BRREAD (PREG))                                 04S0242
*               REFS(BRRDDATA)                                  04S0242
*               SETS(PREG,RETCODE)                              04S0242
*               FLOWS(PJBREAD);                                 04S0242
         BRREAD (PREG)
*          END;                                                 04S0243
*          IF RETCODE=0 THEN                                    04S0244
         SR    @10,@10                                          04S0244
         C     @10,RETCODE                                      04S0244
         BNE   @RF00244                                         04S0244
*            DO;                                                04S0245
*              NAME1 = DATAWORD;  /* FIRST HALF OF JOBNAME           */
*                                                               04S0246
         MVC   NAME1(4),DATAWORD(R1)                            04S0246
*              DO;                                              04S0247
*                PREG = ADDR(ANAME2);                           04S0248
         LA    PREG,4                                           04S0248
         AR    PREG,NAMEADDR                                    04S0248
*                RETCODE = 0;                                   04S0249
         ST    @10,RETCODE                                      04S0249
*                GEN(BRREAD (PREG))                             04S0250
*                   REFS(BRRDDATA)                              04S0250
*                   SETS(PREG,RETCODE)                          04S0250
*                   FLOWS(PJBREAD);                             04S0250
         BRREAD (PREG)
*              END;                                             04S0251
*              IF RETCODE=0 THEN                                04S0252
         ICM   @10,15,RETCODE                                   04S0252
         BNZ   @RF00252                                         04S0252
*                DO;                                            04S0253
*                  NAME2 = DATAWORD; /* SECOND HALF OF JOBNAME       */
         MVC   NAME2(4),DATAWORD(R1)                            04S0254
*                  FOUND = OFF;   /* INIT LOOP CONTROL SWITCH        */
         NI    FOUND,B'11011111'                                04S0255
*                  /*------------------------------------------------*/
*                  /* SCAN TABLE FOR MATCHING NAME                   */
*                  /*------------------------------------------------*/
*                  DO TABLSRCH=1 TO JOBCOUNT WHILE FOUND=OFF;   04S0256
         LA    TABLSRCH,1                                       04S0256
         B     @DE00256                                         04S0256
@DL00256 TM    FOUND,B'00100000'                                04S0256
         BNZ   @DC00256                                         04S0256
*                    IF JOBENTRY(TABLSRCH)=NAME THEN            04S0257
         LR    @10,TABLSRCH                                     04S0257
         SLA   @10,3                                            04S0257
         LA    @02,JOBENTRY-8(@10)                              04S0257
         CLC   0(8,@02),NAME                                    04S0257
         BNE   @RF00257                                         04S0257
*                      DO;                                      04S0258
*                        IF FIRST=OFF THEN /* SKIP TO NEW PAGE       */
         TM    FIRST,B'10000000'                                04S0259
         BNZ   @RF00259                                         04S0259
*                          GENERATE(BRWRITE SKIP);              04S0260
         BRWRITE SKIP
*                        FIRST = OFF;                           04S0261
@RF00259 NI    FIRST,B'01111111'                                04S0261
*                        JOBHIT(TABLSRCH) = ON; /* INDICATE JOB FOUND*/
         LA    @10,JOBHIT-1(TABLSRCH)                           04S0262
         OI    0(@10),B'10000000'                               04S0262
*                        PCBPASID = THISASID; /* SET UP PCB          */
         MVC   PCBPASID(2),THISASID                             04S0263
*                        PCBPFUNC = PCBPENQ;                    04S0264
         NI    PCBPFUNC,B'01111111'                             04S0264
*                        PCBPVIRT = ON;                         04S0265
         OI    PCBPVIRT,B'10000000'                             04S0265
*                        CALL AMDPRFUB(ADDRASCB,THISASID,PCBPL);
         L     @15,ARGNBND(,COMBASE)                            04S0266
         LA    @01,@AL00266                                     04S0266
         BALR  @14,@15                                          04S0266
*                                 /* CALL FUB TO GET REGION BOUNDS   */
*                        CALL AMDPRFSR(ADDRASCB,THISASID);      04S0267
         L     @15,AFORMAT(,COMBASE)                            04S0267
         LA    @01,@AL00267                                     04S0267
         BALR  @14,@15                                          04S0267
*                                 /* CALL FSR - FORMAT CONTROL BLOCKS*/
*                        IF PCBPTR^=0 THEN                      04S0268
         ICM   @10,15,PCBPTR(COMBASE)                           04S0268
         BZ    @RF00268                                         04S0268
*                          DO;                                  04S0269
*                            GENERATE (BRWRITE SKIP); /* SKIP TO TOP */
         BRWRITE SKIP
*                            CALL AMDPRDPS; /* PRINT STORAGE         */
         L     @15,APRTSTG(,COMBASE)                            04S0271
         BALR  @14,@15                                          04S0271
*                          END;                                 04S0272
*                        FOUND = ON;                            04S0273
@RF00268 OI    FOUND,B'00100000'                                04S0273
*                      END;                                     04S0274
*                  END;                                         04S0275
@RF00257 AH    TABLSRCH,@CH00060                                04S0275
@DE00256 C     TABLSRCH,JOBCOUNT                                04S0275
         BNH   @DL00256                                         04S0275
@DC00256 DS    0H                                               04S0276
*                END;                                           04S0276
*            END;                                               04S0277
@RF00252 DS    0H                                               04S0278
*        END;                                                   04S0278
@RF00244 DS    0H                                               04S0279
*    END;                                                       04S0279
@RF00236 DS    0H                                               04S0280
*END;                                                           04S0280
@RF00224 DS    0H                                               04S0281
*  END;                                                         03S0281
@RF00215 AH    LOOPNX,@CH00060                                  03S0281
@DE00180 C     LOOPNX,NUMASCB                                   03S0281
         BNH   @DL00180                                         03S0281
@DC00180 DS    0H                                               03S0282
*END;                                                           03S0282
@DE00178 TM    ALTPATH,B'00000110'                              03S0282
         BO    @DL00178                                         03S0282
*    SOMEFND = OFF;               /* INIT TO NO JOBS FOUND           */
         NI    SOMEFND,B'11111110'                              02S0283
*    DO TABLSRCH=1 TO JOBCOUNT;   /* LOOK FOR NOT FOUND NAMES        */
         LA    TABLSRCH,1                                       02S0284
         B     @DE00284                                         02S0284
@DL00284 DS    0H                                               02S0285
*      IF JOBHIT(TABLSRCH)=OFF THEN /* JOB NOT FOUND                 */
         LA    @10,JOBHIT-1(TABLSRCH)                           02S0285
         TM    0(@10),B'10000000'                               02S0285
         BNZ   @RF00285                                         02S0285
*/*------------------------------------------------------------------*/
*/* ISSUE A MESSAGE FOR JOB NOT FOUND                                */
*/*------------------------------------------------------------------*/
*DO;                                                            03S0286
*  RESPECIFY (R10,R2) RESTRICTED;                               03S0287
*  R10 = APJX;                                                  03S0288
         L     R10,APJX                                         03S0288
*  WTOMSG(17:24) = JOBENTRY(TABLSRCH); /* PUT NAME INTO MESSAGE      */
         LR    @15,TABLSRCH                                     03S0289
         SLA   @15,3                                            03S0289
         LA    @14,JOBENTRY-8(@15)                              03S0289
         MVC   WTOMSG+16(8),0(@14)                              03S0289
*  R2 = WTOTEXTL - 4;             /* LENGTH OF TEXT                  */
         LA    @15,4                                            03S0290
         LH    R2,WTOTEXTL                                      03S0290
         SR    R2,@15                                           03S0290
*  R1 = ADDR(WTOMSG)+4;                                         03S0291
         LA    R1,WTOMSG                                        03S0291
         AR    R1,@15                                           03S0291
*  CALL PRTMSG;                   /* SEND MESSAGE TO SYSPRINT        */
         L     @15,APRTMSG(,COMBASE)                            03S0292
         BALR  @14,@15                                          03S0292
*  IF RDRSW=OFF THEN              /* TELL OPERATOR ALSO              */
*                                                               03S0293
         TM    RDRSW(COMBASE),B'00000001'                       03S0293
         BNZ   @RF00293                                         03S0293
*    DO;/*WTOP MF(E,AMD162I)*/                                  03S0294
*      RFY GPR01P RSTD; /*RESTRICT REG 1*/                      03S0295
*      GPR01P=ADDR(AMD162I); /*ADDRESS CONTROL PROGRAM LIST*/   03S0296
         LA    GPR01P,AMD162I                                   03S0296
*      SVC (35); /*ISSUE WTO SVC*/                              03S0297
         SVC   35                                               03S0297
*      RFY GPR01P UNRSTD; /*RELEASE REG 1*/                     03S0298
*    END; /*WTOP MF(E,AMD162I)*/                                03S0299
*  RESPECIFY (R10,R2) UNRESTRICTED;                             03S0300
@RF00293 DS    0H                                               03S0301
*END;                                                           03S0301
*      ELSE                                                     02S0302
*        SOMEFND = ON;            /* INDICATE THAT THERE WAS OUTPUT  */
         B     @RC00285                                         02S0302
@RF00285 OI    SOMEFND,B'00000001'                              02S0302
*    END;                                                       02S0303
@RC00285 AH    TABLSRCH,@CH00060                                02S0303
@DE00284 C     TABLSRCH,JOBCOUNT                                02S0303
         BNH   @DL00284                                         02S0303
*    IF SOMEFND=OFF THEN          /* NO OUTPUT                       */
         TM    SOMEFND,B'00000001'                              02S0304
         BNZ   @RF00304                                         02S0304
*      DO;                                                      02S0305
*        MESSAGE(1:LENGTH(NOJOBMSG)) = NOJOBMSG;                02S0306
         L     @10,CURBUF(,COMBASE)                             02S0306
         MVC   MESSAGE+1(18,@10),NOJOBMSG                       02S0306
*        GEN(BRWRITE 1)                                         02S0307
*          REFS(AWRITE);                                        02S0307
         BRWRITE 1
*      END;                                                     02S0308
*    ELSE                                                       02S0309
*      CALL TCBSMRY;              /* PRINT A TCB SUMMARY             */
         B     @RC00304                                         02S0309
@RF00304 L     @15,ATCBSMRY(,COMBASE)                           02S0309
         BALR  @14,@15                                          02S0309
*END;                                                           02S0310
*      ELSE ;                     /* DONT DO ANYTHING                */
@RF00122 DS    0H                                               01S0312
*    ELSE                                                       01S0312
*/*------------------------------------------------------------------*/
*/* ISSUE APPROPRIATE ERROR MESSAGE AND TERMINATE                    */
*/*------------------------------------------------------------------*/
*DO;                                                            02S0312
         B     @RC00121                                         02S0312
@RF00121 DS    0H                                               02S0313
*  RESPECIFY R15 RESTRICTED;                                    02S0313
*  DELIMCD = 0;                   /* SET INVALID TO TERMINATE SCAN OF
*                                    CURRENT CONTROL CARD            */
         SR    @14,@14                                          02S0314
         ST    @14,DELIMCD(,COMBASE)                            02S0314
*  GEN(USING SYNEPS,R15);                                       02S0315
         USING SYNEPS,R15
*  R15 = ASYNTAX;                 /* ENTRY ADDRESS OF SYNTAX WRITER  */
         L     R15,ASYNTAX(,COMBASE)                            02S0316
*  IF STATUS=INVALDLM THEN                                      02S0317
         CLI   STATUS,X'40'                                     02S0317
         BNE   @RF00317                                         02S0317
*    MSGADDR = ADDR(DELIM);                                     02S0318
         LA    @14,DELIM                                        02S0318
         ST    @14,MSGADDR                                      02S0318
*  ELSE                                                         02S0319
*    IF STATUS=TOOMANY THEN                                     02S0319
         B     @RC00317                                         02S0319
@RF00317 CLI   STATUS,X'20'                                     02S0319
         BNE   @RF00319                                         02S0319
*      MSGADDR = ADDR(TOOMNY);                                  02S0320
         LA    @14,TOOMNY                                       02S0320
         ST    @14,MSGADDR                                      02S0320
*    ELSE                                                       02S0321
*      IF STATUS=NAMTOBIG THEN                                  02S0321
         B     @RC00319                                         02S0321
@RF00319 CLI   STATUS,X'08'                                     02S0321
         BNE   @RF00321                                         02S0321
*        MSGADDR = ADDR(TOOBIG);                                02S0322
         LA    @14,TOOBIG                                       02S0322
         ST    @14,MSGADDR                                      02S0322
*      ELSE                                                     02S0323
*        IF STATUS=OPOMIT THEN                                  02S0323
         B     @RC00321                                         02S0323
@RF00321 CLI   STATUS,X'10'                                     02S0323
         BNE   @RF00323                                         02S0323
*          MSGADDR = ADDR(OPMISS);                              02S0324
         LA    @14,OPMISS                                       02S0324
         ST    @14,MSGADDR                                      02S0324
*  SYNMSGA = ADDR(MSGADDR);                                     02S0325
@RF00323 DS    0H                                               02S0325
@RC00321 DS    0H                                               02S0325
@RC00319 DS    0H                                               02S0325
@RC00317 LA    @14,MSGADDR                                      02S0325
         ST    @14,SYNMSGA(,COMBASE)                            02S0325
*  IF STATUS=BADLAST THEN                                       02S0326
         CLI   STATUS,X'04'                                     02S0326
         BNE   @RF00326                                         02S0326
*    CALL SYNTAX;                 /* ISSUE STANDARD MESSAGE          */
         BAL   @14,SYNTAX                                       02S0327
*  ELSE                                                         02S0328
*    CALL SYNTAXA;                /* ISSUE SYNTAX MESSAGE            */
         B     @RC00326                                         02S0328
@RF00326 BAL   @14,SYNTAXA                                      02S0328
*  RESPECIFY R15 UNRESTRICTED;                                  02S0329
@RC00326 DS    0H                                               02S0330
*END;                                                           02S0330
*  ERRADDR = READSAVE;            /* RESTORE PREVIOUS READ ERR RTN   */
@RC00121 MVC   ERRADDR(4,COMBASE),READSAVE                      01S0331
*  STOPEXIT = STOPSAVE;           /* RESTORE PREVIOUS STOP RTN       */
         MVC   STOPEXIT(4,COMBASE),STOPSAVE                     01S0332
*RETURN;                                                        01S0333
         B     @EL00001                                         01S0333
*/*------------------------------------------------------------------*/
*/* PJBREAD IS ENTERED ASYNCHRONOUSLY AFTER A BRREAD IF THE DATA     */
*/* REQUESTED WAS NOT IN THE DUMP                                    */
*/*------------------------------------------------------------------*/
*PJBREAD:                                                       02S0334
*  RESPECIFY R14 RESTRICTED;                                    02S0334
PJBREAD  DS    0H                                               02S0335
*  GENERATE REFS(PJBSAVE);                                      02S0335
              USING *,R15         SET UP ADDRESSABILITY
              L     R13,PJBSAVE
              LM    R14,R12,12(R13)
              DROP R15
*  RETCODE = 4;                   /* INDICATE DATA UNAVAILABLE       */
         MVC   RETCODE(4),@CF00052                              02S0336
*  GO TO MAINLINE;                                              02S0337
         BR    R14                                              02S0337
*  RESPECIFY R14 UNRESTRICTED;                                  02S0338
*/*------------------------------------------------------------------*/
*/* PJBSTOP IS ENTERED ASYNCHRONOUSLY AFTER A BRWRITE IF THE OPER    */
*/* REQUESTED THAT PRDMP STOP PROCESSING                             */
*/*------------------------------------------------------------------*/
*PJBSTOP:                                                       02S0339
*  GENERATE REFS(PJBSAVE);                                      02S0339
PJBSTOP  DS    0H                                               02S0339
              USING *,R15         SET UP ADDRESSABILITY
              L     R13,PJBSAVE
              LM    R14,R12,12(R13)
              DROP R15
*  DO WHILE PCBPTR^=0;            /* PURGE THE PCB QUEUE             */
         B     @DE00340                                         02S0340
@DL00340 DS    0H                                               02S0341
*    R1 = ADDR(PCBPL);                                          02S0341
         LA    R1,PCBPL                                         02S0341
*    PCBPFUNC = PCBPDEQ;                                        02S0342
         OI    PCBPFUNC,B'10000000'                             02S0342
*    CALL PCBRTN;                                               02S0343
         L     @15,APCBENQ(,COMBASE)                            02S0343
         BALR  @14,@15                                          02S0343
*  END;                                                         02S0344
@DE00340 ICM   @10,15,PCBPTR(COMBASE)                           02S0344
         BNZ   @DL00340                                         02S0344
*  STOPEXIT = STOPSAVE;           /* RESTORE PREVIOUS STOP RTN       */
         L     @10,STOPSAVE                                     02S0345
         ST    @10,STOPEXIT(,COMBASE)                           02S0345
*  ERRADDR = READSAVE;            /* RESTORE PREVIOUS READ ERR RTN   */
         MVC   ERRADDR(4,COMBASE),READSAVE                      02S0346
*  RESPECIFY R15 RESTRICTED;                                    02S0347
*  R15 = STOPSAVE;                /* ADDRESS OF PREVIOUS STOP EXIT   */
         LR    R15,@10                                          02S0348
*  GO TO R15;                     /* PERCOLATE TO PREVIOUS STOP EXIT */
         BR    R15                                              02S0349
*  RESPECIFY R15 UNRESTRICTED;                                  02S0350
*/*------------------------------------------------------------------*/
*/* ROUTINE TO SCAN FOR THE NEXT DELIMITER AND RETURN THE SIZE       */
*/* AND ADDRESS OF THE OPERAND                                       */
*/*------------------------------------------------------------------*/
*DELIMSCN: PROCEDURE;                                           02S0351
DELIMSCN STM   @14,@02,12(@13)                                  02S0351
         STM   @04,@12,36(@13)                                  02S0351
*  RESPECIFY (R2,R0) RESTRICTED;                                02S0352
*  KYWDBGN = KYWDEND + 1;         /* START WITH CHAR AFTER LAST DELIM*/
         LA    @10,1                                            02S0353
         A     @10,KYWDEND(,COMBASE)                            02S0353
         ST    @10,KYWDBGN(,COMBASE)                            02S0353
*  R2 = 0;                                                      02S0354
         SR    R2,R2                                            02S0354
*  TRT(OPERAND,BLNK);             /* SCAN FOR DELIMITER              */
         L     @10,KYWDBGN(,COMBASE)                            02S0355
         TRT   OPERAND(68,@10),BLNK(COMBASE)                    02S0355
*  KYWDEND = R1;                  /* ADDRESS OF DELIMITER            */
         ST    R1,KYWDEND(,COMBASE)                             02S0356
*  DELIMCD = R2;                  /* DELIMITER CODE NUMBER           */
         ST    R2,DELIMCD(,COMBASE)                             02S0357
*  OPSIZE = KYWDEND - KYWDBGN;    /* SIZE OF THE OPERAND             */
         L     @10,KYWDEND(,COMBASE)                            02S0358
         S     @10,KYWDBGN(,COMBASE)                            02S0358
         LR    OPSIZE,@10                                       02S0358
*  RESPECIFY (R2,R0) UNRESTRICTED;                              02S0359
*  RETURN;                                                      02S0360
@EL00002 DS    0H                                               02S0360
@EF00002 DS    0H                                               02S0360
@ER00002 LM    @14,@02,12(@13)                                  02S0360
         LM    @04,@12,36(@13)                                  02S0360
         BR    @14                                              02S0360
*END DELIMSCN;                                                  02S0361
*/*------------------------------------------------------------------*/
*/* THE FOLLOWING DECLARES ARE GENERATED BY THE EPILOG MACRO AND     */
*/* ARE USED BY ANY PLS VERSIONS OF SYSTEM MACROS                    */
*/*------------------------------------------------------------------*/
*                                                               01S0362
*                                                               01S0362
* DECLARE /*GENERAL PURPOSE REGISTERS */                        01S0362
*   GPR01P PTR(31) REG(1);                                      01S0362
*                                                               01S0362
* DECLARE /* COMMON VARIABLES */                                01S0363
*   I256C CHAR(256) BASED,                                      01S0363
*   I031F FIXED(31) BASED,                                      01S0363
*   I031P PTR(31)   BASED,                                      01S0363
*   I015F FIXED(15) BASED,                                      01S0363
*   I015P PTR(15)   BASED,                                      01S0363
*   I008P PTR(8)    BASED,                                      01S0363
*   I001C CHAR(1)   BASED;                                      01S0363
*END AMDPRPJB                                                   01S0364
*/* THE FOLLOWING INCLUDE STATEMENTS WERE FOUND IN THIS PROGRAM.      *
*/*%INCLUDE SYSUT5  (PROLOG  )                                        *
*/*%INCLUDE SYSUT5  (PJBFL1  )                                        *
*/*%INCLUDE SYSUT5  (DECLARES)                                        *
*/*%INCLUDE SYSLIB  (CVT     )                                        *
*/*%INCLUDE SYSLIB  (IHAASVT )                                        *
*/*%INCLUDE SYSLIB  (IHAASCB )                                        *
*/*%INCLUDE SYSLIB  (COMMON  )                                        *
*/*%INCLUDE SYSLIB  (AMDPCBPL)                                        *
*/*%INCLUDE SYSUT5  (INIT    )                                        *
*/*%INCLUDE SYSUT5  (OPPROCES)                                        *
*/*%INCLUDE SYSUT5  (SCANLAST)                                        *
*/*%INCLUDE SYSUT5  (NAMESRCH)                                        *
*/*%INCLUDE SYSUT5  (PJBFAIL )                                        *
*/*%INCLUDE SYSUT5  (ASCBSCAN)                                        *
*/*%INCLUDE SYSUT5  (GETNAME )                                        *
*/*%INCLUDE SYSUT5  (NOTFOUND)                                        *
*/*%INCLUDE SYSUT5  (SYNTXMSG)                                        *
*/*%INCLUDE SYSUT5  (PJBREAD )                                        *
*/*%INCLUDE SYSUT5  (PJBSTOP )                                        *
*/*%INCLUDE SYSUT5  (DELIMSCN)                                        *
*;                                                              01S0364
         B     @EL00001                                         01S0364
@DATA    DS    0H
@CH00060 DC    H'1'
@CH00953 DC    H'10'
@CH01013 DC    H'12'
@SM01292 MVC   JOBNAMEC(0),JOBNAME(@02)
         DS    0F
@AL00266 EQU   *                       LIST WITH   3 ARGUMENT(S)
@AL00267 DC    A(ADDRASCB)             LIST WITH   2 ARGUMENT(S)
         DC    A(THISASID)
         DC    A(PCBPL)
         DS    0F
@SA00001 DS    18F
         DS    0F
@CF01300 DC    F'-8'
@CF00052 DC    F'4'
@CH00052 EQU   @CF00052+2
@CF00058 DC    F'8'
@CH00058 EQU   @CF00058+2
@CF00730 DC    F'16'
@CF00987 DC    F'20'
         DS    0D
ASVTPTR  DS    A
ADDRASCB DS    AL4
         ORG   ADDRASCB
AVAILBIT DS    BL1
@NM00054 EQU   ADDRASCB+0
         ORG   ADDRASCB+4
RETCODE  DS    F
PJBSAVE  DS    A
MSGADDR  DS    A
NUMASCB  DS    F
READSAVE DS    A
STOPSAVE DS    A
THISASID DS    H
         DS    CL2
PCBPL    DS    CL12
         ORG   PCBPL
PCBPBGN  DS    AL4
PCBPEND  DS    AL4
PCBPASID DS    BL2
PCBPFLG1 DS    CL1
         ORG   PCBPFLG1
PCBPVIRT DS    BL1
PCBPREAL EQU   PCBPFLG1+0
PCBPLOWC EQU   PCBPFLG1+0
PCBPTOPC EQU   PCBPFLG1+0
@NM00052 EQU   PCBPFLG1+0
         ORG   PCBPL+11
PCBPFLG2 DS    CL1
         ORG   PCBPFLG2
PCBPFUNC DS    BL1
@NM00053 EQU   PCBPFLG2+0
         ORG   PCBPL+12
PJBTITLE DC    CL42'* * * *  P R I N T  J O B N A M E  * * * *'
STATUS   DS    CL1
PJBSWTCH DS    CL2
         ORG   PJBSWTCH
OPSCAN   DS    BL1
DUPE     EQU   PJBSWTCH+0
FOUND    EQU   PJBSWTCH+0
ASVTFAIL EQU   PJBSWTCH+0
NOGOSW   EQU   PJBSWTCH+0
ALTPATH  EQU   PJBSWTCH+0
SEARCH   EQU   PJBSWTCH+0
SOMEFND  EQU   PJBSWTCH+0
FIRST    DS    BL1
         ORG   PJBSWTCH+2
NOJOBMSG DC    CL18'NO JOBS WERE FOUND'
         DS    CL1
JOBTABL  DS    CL94
         ORG   JOBTABL
JOBCOUNT DS    FL4
JOBENTRY DS    10CL8
JOBHIT   DS    10BL1
         ORG   JOBTABL+94
JOBNAMEC DS    CL8
NAME     DS    CL8
         ORG   NAME
NAME1    DS    CL4
NAME2    DS    CL4
         ORG   NAME+8
         DS    CL2
DELIM    DS    CL55
         ORG   DELIM
DELIM01  DC    H'51'
DELIM02  DC    B'1000000000000000'
DELIM03  DC    CL47'        DELIMITER ERROR IN JOBNAME OPERAND LIST'
DELIM04  DC    B'0000001000000000'
DELIM05  DC    B'0100000000000000'
         ORG   DELIM+55
         DS    CL1
OPMISS   DS    CL54
         ORG   OPMISS
OPMISS01 DC    H'50'
OPMISS02 DC    B'1000000000000000'
OPMISS03 DC    CL46'        NAME MISSING FROM JOBNAME OPERAND LIST'
OPMISS04 DC    B'0000001000000000'
OPMISS05 DC    B'0100000000000000'
         ORG   OPMISS+54
         DS    CL2
TOOMNY   DS    CL41
         ORG   TOOMNY
TOOMNY01 DC    H'37'
TOOMNY02 DC    B'1000000000000000'
TOOMNY03 DC    CL33'        TOO MANY JOBNAMES IN LIST'
TOOMNY04 DC    B'0000001000000000'
TOOMNY05 DC    B'0100000000000000'
         ORG   TOOMNY+41
         DS    CL3
TOOBIG   DS    CL45
         ORG   TOOBIG
TOOBIG01 DC    H'41'
TOOBIG02 DC    B'1000000000000000'
TOOBIG03 DC    CL37'        JOBNAME LENGTH GREATER THAN 8'
TOOBIG04 DC    B'0000001000000000'
TOOBIG05 DC    B'0100000000000000'
         ORG   TOOBIG+45
         DS    CL3
PATCH    DC    30F'0'
AMDPRPJB CSECT
DTAE     EQU   32                  DATA EBCDIC BIT
DTAC     EQU   16                  DATA IN CORE BIT
DTAP     EQU   8                   DATA PTR BIT
DTA      EQU   4                   DATA INCLUDED BIT
LBLP     EQU   2                   LABEL PTR BIT
LBL      EQU   1                   LABEL INCLUDED BIT
AMDPRPJB CSECT
         SYNEPS
AMDPRPJB CSECT
APJX     DC    V(AMDPRPJX)
AMDPRPJX CSECT
AMD162I WTO 'AMD162I JOB          NOT FOUND',ROUTCDE=(2),DESC=7,MF=L
AMD166I WTO 'AMD166I FORMAT ERROR DURING JOBNAME SEARCH',ROUTCDE=(2),  *
               DESC=7,MF=L
AMDPRPJB CSECT
@00      EQU   00                      EQUATES FOR REGISTERS 0-15
@01      EQU   01
@02      EQU   02
@03      EQU   03
@04      EQU   04
@05      EQU   05
@06      EQU   06
@07      EQU   07
@08      EQU   08
@09      EQU   09
@10      EQU   10
@11      EQU   11
@12      EQU   12
@13      EQU   13
@14      EQU   14
@15      EQU   15
NAMEADDR EQU   @03
LASTASID EQU   @05
OPSIZE   EQU   @03
TABLSRCH EQU   @03
DUPECHK  EQU   @03
JOBS     EQU   @04
I        EQU   @03
LOOPNX   EQU   @04
R0       EQU   @00
R1       EQU   @01
R2       EQU   @02
R10      EQU   @10
R13      EQU   @13
R14      EQU   @14
R15      EQU   @15
COMBASE  EQU   @12
PREG     EQU   @01
GPR01P   EQU   @01
BASE1    EQU   @11
BASE2    EQU   @10
BASE3    EQU   @09
BUFREG   EQU   @06
CNTREG   EQU   @03
LINEREG  EQU   @08
R11      EQU   @11
R12      EQU   @12
R3       EQU   @03
R4       EQU   @04
R5       EQU   @05
R6       EQU   @06
R7       EQU   @07
R8       EQU   @08
R9       EQU   @09
STOPBASE EQU   @05
CVTMAP   EQU   0
CVTDAR   EQU   CVTMAP+72
CVTFLGS1 EQU   CVTDAR
CVTDCB   EQU   CVTMAP+116
CVTOPTA  EQU   CVTMAP+182
CVTOPTB  EQU   CVTMAP+183
CVTTSCVT EQU   CVTMAP+228
CVTTSFLG EQU   CVTTSCVT
CVTGTF   EQU   CVTMAP+236
CVTGTFST EQU   CVTGTF
CVTGTFS  EQU   CVTGTFST
CVTSTATE EQU   CVTGTFST
CVTTMODE EQU   CVTGTFST
CVTFORM  EQU   CVTGTFST
CVTUSR   EQU   CVTGTFST
CVTAQAVT EQU   CVTMAP+240
CVTTCMFG EQU   CVTAQAVT
CVTVOLM2 EQU   CVTMAP+244
CVTTATA  EQU   CVTVOLM2
CVTTSKS  EQU   CVTTATA
CVTVOLF2 EQU   CVTTSKS
CVTTAT   EQU   CVTTATA+1
CVTATER  EQU   CVTMAP+248
CVTEXT1  EQU   CVTMAP+252
CVTPURG  EQU   CVTMAP+260
CVTQMSG  EQU   CVTMAP+268
CVTDMSR  EQU   CVTMAP+272
CVTAPF   EQU   CVTMAP+324
CVTEXT2  EQU   CVTMAP+328
CVTHJES  EQU   CVTMAP+332
CVTPGSIA EQU   CVTMAP+348
CVTA1F1  EQU   CVTMAP+356
CVTSYSK  EQU   CVTMAP+357
CVTVOLM1 EQU   CVTMAP+380
CVTVOLF1 EQU   CVTVOLM1
CVTATMCT EQU   CVTMAP+388
CVTXTNT1 EQU   0
CVTXTNT2 EQU   0
CVTDSSV  EQU   CVTXTNT2
CVTRSV90 EQU   CVTXTNT2+5
CVTQID   EQU   CVTXTNT2+24
CVTRV400 EQU   CVTXTNT2+52
CVTRV409 EQU   CVTXTNT2+53
CVTATCVT EQU   CVTXTNT2+64
CVTRV429 EQU   CVTXTNT2+84
CVTRV438 EQU   CVTXTNT2+85
CVTRV457 EQU   CVTXTNT2+112
CVTRV466 EQU   CVTXTNT2+113
CVTFIX   EQU   0
CVTRELNO EQU   CVTFIX+252
ASVT     EQU   0
ASVTMAXU EQU   ASVT+516
ASVTFRST EQU   ASVT+524
ASVTENTY EQU   ASVT+528
ASCB     EQU   0
ASCBFW1  EQU   ASCB+100
ASCBRCTF EQU   ASCBFW1+2
ASCBFLG1 EQU   ASCBFW1+3
ASCBDSP1 EQU   ASCB+114
ASCBFLG2 EQU   ASCB+115
ASCBJBNI EQU   ASCB+172
ASCBJBNS EQU   ASCB+176
COMMON   EQU   0
ERRADDR  EQU   COMMON
KYWDBGN  EQU   COMMON+12
KYWDEND  EQU   COMMON+16
DELIMCD  EQU   COMMON+20
CURBUF   EQU   COMMON+48
CVTADDR  EQU   COMMON+56
PCBPTR   EQU   COMMON+60
SWA      EQU   COMMON+122
RDRSW    EQU   SWA
SWB      EQU   COMMON+123
SWC      EQU   COMMON+124
SWD      EQU   COMMON+125
FLSHMODE EQU   SWD
SWE      EQU   COMMON+126
SWF      EQU   COMMON+127
BUFSW    EQU   COMMON+128
PRSW     EQU   COMMON+129
TABLE    EQU   COMMON+659
HEXTABL  EQU   TABLE+63
BLNK     EQU   COMMON+988
AWRITE   EQU   COMMON+1500
APRTMSG  EQU   COMMON+1504
ASYNTAX  EQU   COMMON+1508
ARGNBND  EQU   COMMON+1524
STOPEXIT EQU   COMMON+1528
SYNMSGA  EQU   COMMON+1532
APCBENQ  EQU   COMMON+1560
AFORMAT  EQU   COMMON+1568
APRTSTG  EQU   COMMON+1572
ATCBSMRY EQU   COMMON+1604
DCBADDRS EQU   COMMON+1608
@NM00045 EQU   DCBADDRS+16
@NM00046 EQU   @NM00045
ASCBMAP  EQU   COMMON+1976
BRRDDATA EQU   COMMON+1984
AUSREXIT EQU   COMMON+2008
EXITFLAG EQU   COMMON+2022
TITLEPLC EQU   0
MAINLINE EQU   0
MESSAGE  EQU   0
OPERAND  EQU   0
JOBNAME  EQU   0
DATAWORD EQU   0
DATABIT  EQU   DATAWORD
DATAP24  EQU   DATAWORD+1
AMDPRFUB EQU   0
AMDPRFSR EQU   0
AMDPRDPS EQU   0
AMDPRUIM EQU   0
PRTMSG   EQU   0
TCBSMRY  EQU   0
PCBRTN   EQU   0
ANAME1   EQU   0
ANAME2   EQU   0
MAP      EQU   0
MAPTAB   EQU   MAP
MAPNUM   EQU   MAP+4
MAPASID  EQU   MAP+16
TAB      EQU   0
TABASCB  EQU   TAB
I001C    EQU   0
I008P    EQU   0
I015F    EQU   0
I015P    EQU   0
I031F    EQU   0
I031P    EQU   0
I256C    EQU   0
LASTDLM  EQU   0
CVTPTR   EQU   CVTADDR
CVTS01   EQU   CVTPGSIA
CVTLPDIA EQU   CVTS01+12
CVTDIRST EQU   CVTLPDIA
CVTSLIDA EQU   CVTS01+24
CVTCTLFG EQU   CVTS01+50
CVTRV100 EQU   CVTS01+116
CVTRV109 EQU   CVTS01+117
CVTRV118 EQU   CVTS01+118
CVTRV127 EQU   CVTS01+119
CVTASVT  EQU   CVTS01+208
CVTRV210 EQU   CVTS01+424
CVTRV219 EQU   CVTS01+425
CVTRV228 EQU   CVTS01+426
CVTRV237 EQU   CVTS01+427
CVTMFRTR EQU   CVTS01+452
CVTRV262 EQU   CVTS01+468
CVTRV271 EQU   CVTS01+469
CVTRV280 EQU   CVTS01+470
CVTRV289 EQU   CVTS01+471
CVTGSDA  EQU   CVTS01+600
ASCBPTR  EQU   ADDRASCB
M166ILGT EQU   AMD166I
WTOMSG   EQU   AMD162I
WTOTEXTL EQU   WTOMSG
         AGO   .@UNREFD                START UNREFERENCED COMPONENTS
CVTTPIO  EQU   CVTS01+608
CVTADV   EQU   CVTS01+604
CVTGSDAB EQU   CVTGSDA
CVTQV3   EQU   CVTS01+596
CVTQV2   EQU   CVTS01+592
CVTQV1   EQU   CVTS01+588
CVTRPT   EQU   CVTS01+584
CVTSSRB  EQU   CVTS01+580
CVTCSDRL EQU   CVTS01+576
CVTEXP1  EQU   CVTS01+572
CVTRMPMT EQU   CVTS01+568
CVTRMPTT EQU   CVTS01+564
CVTVPSA  EQU   CVTS01+560
CVTVSTOP EQU   CVTS01+556
CVTGTFR8 EQU   CVTS01+552
CVTQUIT  EQU   CVTS01+548
CVTVACR  EQU   CVTS01+544
CVTWTCB  EQU   CVTS01+540
CVTSTPRS EQU   CVTS01+536
CVT0PT02 EQU   CVTS01+532
CVTDARCM EQU   CVTS01+528
CVTIRECM EQU   CVTS01+524
CVTJRECM EQU   CVTS01+520
CVTVEMS0 EQU   CVTS01+516
CVTSPFRR EQU   CVTS01+512
CVTRLSTG EQU   CVTS01+508
CVT0TC0A EQU   CVTS01+504
CVTGMBR  EQU   CVTS01+500
CVTLFRM  EQU   CVTS01+496
CVTRMBR  EQU   CVTS01+492
CVTVIOP  EQU   CVTS01+488
CVTRV307 EQU   CVTS01+486
CVTRV306 EQU   CVTS01+484
CVTRV305 EQU   CVTS01+482
CVTRV304 EQU   CVTS01+480
CVTRV303 EQU   CVTS01+478
CVTRV302 EQU   CVTS01+476
CVTRV301 EQU   CVTS01+475
CVTRV300 EQU   CVTS01+474
CVTRV299 EQU   CVTS01+473
CVTRV298 EQU   CVTS01+472
CVTRV297 EQU   CVTRV289
CVTRV296 EQU   CVTRV289
CVTRV295 EQU   CVTRV289
CVTRV294 EQU   CVTRV289
CVTRV293 EQU   CVTRV289
CVTRV292 EQU   CVTRV289
CVTRV291 EQU   CVTRV289
CVTRV290 EQU   CVTRV289
CVTRV288 EQU   CVTRV280
CVTRV287 EQU   CVTRV280
CVTRV286 EQU   CVTRV280
CVTRV285 EQU   CVTRV280
CVTRV284 EQU   CVTRV280
CVTRV283 EQU   CVTRV280
CVTRV282 EQU   CVTRV280
CVTRV281 EQU   CVTRV280
CVTRV279 EQU   CVTRV271
CVTRV278 EQU   CVTRV271
CVTRV277 EQU   CVTRV271
CVTRV276 EQU   CVTRV271
CVTRV275 EQU   CVTRV271
CVTRV274 EQU   CVTRV271
CVTRV273 EQU   CVTRV271
CVTRV272 EQU   CVTRV271
CVTRV270 EQU   CVTRV262
CVTRV269 EQU   CVTRV262
CVTRV268 EQU   CVTRV262
CVTRV267 EQU   CVTRV262
CVTRV266 EQU   CVTRV262
CVTRV265 EQU   CVTRV262
CVTRV264 EQU   CVTRV262
CVTRV263 EQU   CVTRV262
CVTVFP   EQU   CVTS01+464
CVTVSI   EQU   CVTS01+460
CVTVPSIB EQU   CVTS01+456
CVTMFACT EQU   CVTMFRTR
CVTMFCTL EQU   CVTS01+448
CVTPVBP  EQU   CVTS01+444
CVTPWI   EQU   CVTS01+440
CVTRV254 EQU   CVTS01+438
CVTRV253 EQU   CVTS01+436
CVTRV252 EQU   CVTS01+434
CVTRV251 EQU   CVTS01+433
CVTRV250 EQU   CVTS01+432
CVTRV249 EQU   CVTS01+431
CVTRV248 EQU   CVTS01+430
CVTRV247 EQU   CVTS01+429
CVTRV246 EQU   CVTS01+428
CVTRV245 EQU   CVTRV237
CVTRV244 EQU   CVTRV237
CVTRV243 EQU   CVTRV237
CVTRV242 EQU   CVTRV237
CVTRV241 EQU   CVTRV237
CVTRV240 EQU   CVTRV237
CVTRV239 EQU   CVTRV237
CVTRV238 EQU   CVTRV237
CVTRV236 EQU   CVTRV228
CVTRV235 EQU   CVTRV228
CVTRV234 EQU   CVTRV228
CVTRV233 EQU   CVTRV228
CVTRV232 EQU   CVTRV228
CVTRV231 EQU   CVTRV228
CVTRV230 EQU   CVTRV228
CVTRV229 EQU   CVTRV228
CVTRV227 EQU   CVTRV219
CVTRV226 EQU   CVTRV219
CVTRV225 EQU   CVTRV219
CVTRV224 EQU   CVTRV219
CVTRV223 EQU   CVTRV219
CVTRV222 EQU   CVTRV219
CVTRV221 EQU   CVTRV219
CVTRV220 EQU   CVTRV219
CVTRV218 EQU   CVTRV210
CVTRV217 EQU   CVTRV210
CVTRV216 EQU   CVTRV210
CVTRV215 EQU   CVTRV210
CVTRV214 EQU   CVTRV210
CVTRV213 EQU   CVTRV210
CVTRV212 EQU   CVTRV210
CVTRV211 EQU   CVTRV210
CVTLCCAT EQU   CVTS01+420
CVTPCCAT EQU   CVTS01+416
CVTIPCRP EQU   CVTS01+412
CVTIPCRI EQU   CVTS01+408
CVTIPCDS EQU   CVTS01+404
CVTAIDVT EQU   CVTS01+400
CVTSSAP  EQU   CVTS01+396
CVTRV202 EQU   CVTS01+394
CVTRV201 EQU   CVTS01+392
CVTRV200 EQU   CVTS01+390
CVTRV199 EQU   CVTS01+388
CVTRV198 EQU   CVTS01+386
CVTRV197 EQU   CVTS01+384
CVTRV196 EQU   CVTS01+383
CVTRV195 EQU   CVTS01+382
CVTRV194 EQU   CVTS01+381
CVTRV193 EQU   CVTS01+380
CVT044R2 EQU   CVTS01+376
CVTFETCH EQU   CVTS01+372
CVTRSTWD EQU   CVTS01+368
CVTSPOST EQU   CVTS01+364
CVTIOBP  EQU   CVTS01+360
CVTASMVT EQU   CVTS01+356
CVTRECRQ EQU   CVTS01+352
CVTWSAC  EQU   CVTS01+348
CVTWSAG  EQU   CVTS01+344
CVTWSAL  EQU   CVTS01+340
CVTSPSA  EQU   CVTS01+336
CVTGLMN  EQU   CVTS01+332
CVTVEAC0 EQU   CVTS01+328
CVT062R1 EQU   CVTS01+324
CVTRPOST EQU   CVTS01+320
CVTDQIQE EQU   CVTS01+316
CVTCSD   EQU   CVTS01+312
CVTLKRMA EQU   CVTS01+308
CVTRSPIE EQU   CVTS01+304
CVTRENQ  EQU   CVTS01+300
CVTLQCB  EQU   CVTS01+296
CVTFQCB  EQU   CVTS01+292
CVTQCS01 EQU   CVTS01+288
CVTAPFT  EQU   CVTS01+284
CVTPARRL EQU   CVTS01+280
CVTVWAIT EQU   CVTS01+276
CVTGSPL  EQU   CVTS01+272
CVTLSMQ  EQU   CVTS01+268
CVTGSMQ  EQU   CVTS01+264
CVTEXPRO EQU   CVTS01+260
CVTOPCTP EQU   CVTS01+256
CVTSIC   EQU   CVTS01+252
CVTTPIOS EQU   CVTS01+248
CVTRTMS  EQU   CVTS01+244
CVTSDBF  EQU   CVTS01+240
CVTSCBP  EQU   CVTS01+236
CVTSDMP  EQU   CVTS01+232
CVTSV60  EQU   CVTS01+228
CVTRTMCT EQU   CVTS01+224
CVTASCBL EQU   CVTS01+220
CVTASCBH EQU   CVTS01+216
CVTGDA   EQU   CVTS01+212
CVTVVMDI EQU   CVTS01+204
CVTAQTOP EQU   CVTS01+200
CVTIOSCS EQU   CVTS01+196
CVTSDRM  EQU   CVTS01+192
CVTOPTE  EQU   CVTS01+188
CVTSTXU  EQU   CVTS01+184
CVTQUIS  EQU   CVTS01+180
CVTRV514 EQU   CVTS01+176
CVTS1EE  EQU   CVTS01+172
CVTFRAS  EQU   CVTS01+168
CVTQSAS  EQU   CVTS01+164
CVTCRAS  EQU   CVTS01+160
CVTCRMN  EQU   CVTS01+156
CVTDELCP EQU   CVTS01+152
CVTFRECL EQU   CVTS01+148
CVTGETCL EQU   CVTS01+144
CVTBLDCP EQU   CVTS01+140
CVTAUTHL EQU   CVTS01+136
CVTRV146 EQU   CVTS01+134
CVTRV145 EQU   CVTS01+132
CVTRV144 EQU   CVTS01+130
CVTMAXMP EQU   CVTS01+128
CVTRV142 EQU   CVTS01+126
CVTRV141 EQU   CVTS01+125
CVTRV140 EQU   CVTS01+124
CVTRV139 EQU   CVTS01+123
CVTDSSAC EQU   CVTS01+122
CVTRV513 EQU   CVTS01+121
CVTIOSPL EQU   CVTS01+120
CVTRV135 EQU   CVTRV127
CVTRV134 EQU   CVTRV127
CVTRV133 EQU   CVTRV127
CVTRV132 EQU   CVTRV127
CVTRV131 EQU   CVTRV127
CVTRV130 EQU   CVTRV127
CVTRV129 EQU   CVTRV127
CVTRV128 EQU   CVTRV127
CVTRV126 EQU   CVTRV118
CVTRV125 EQU   CVTRV118
CVTRV124 EQU   CVTRV118
CVTRV123 EQU   CVTRV118
CVTRV122 EQU   CVTRV118
CVTRV121 EQU   CVTRV118
CVTRV120 EQU   CVTRV118
CVTRV119 EQU   CVTRV118
CVTRV117 EQU   CVTRV109
CVTRV116 EQU   CVTRV109
CVTRV115 EQU   CVTRV109
CVTRV114 EQU   CVTRV109
CVTRV113 EQU   CVTRV109
CVTRV112 EQU   CVTRV109
CVTRV111 EQU   CVTRV109
CVTRV110 EQU   CVTRV109
CVTRV108 EQU   CVTRV100
CVTRV107 EQU   CVTRV100
CVTRV106 EQU   CVTRV100
CVTRV105 EQU   CVTRV100
CVTRV104 EQU   CVTRV100
CVTRV103 EQU   CVTRV100
CVTRV102 EQU   CVTRV100
CVTRV101 EQU   CVTRV100
CVTCSPIE EQU   CVTS01+112
CVTSMFEX EQU   CVTS01+108
CVTOLT0A EQU   CVTS01+104
CVTSRBRT EQU   CVTS01+100
CVTRSV82 EQU   CVTS01+98
CVTRSV81 EQU   CVTS01+96
CVTSYSWT EQU   CVTS01+92
CVTRV327 EQU   CVTS01+88
CVTRV326 EQU   CVTS01+84
CVTRV325 EQU   CVTS01+80
CVTRV324 EQU   CVTS01+76
CVT0VL01 EQU   CVTS01+72
CVTSHRVM EQU   CVTS01+68
CVTRV332 EQU   CVTS01+64
CVTTAS   EQU   CVTS01+60
CVTRSCN  EQU   CVTS01+56
CVTTRAC2 EQU   CVTS01+54
CVTTRACE EQU   CVTS01+52
CVTAPG   EQU   CVTS01+51
CVTSDTRC EQU   CVTCTLFG
CVTGTRCE EQU   CVTCTLFG
CVTNOMP  EQU   CVTCTLFG
CVTRSV79 EQU   CVTCTLFG
CVTDSTAT EQU   CVTCTLFG
CVTRSV78 EQU   CVTCTLFG
CVTRV333 EQU   CVTCTLFG
CVTRV323 EQU   CVTCTLFG
CVTSPVLK EQU   CVTS01+49
CVTRSV77 EQU   CVTS01+48
CVTRV331 EQU   CVTS01+44
CVTRV330 EQU   CVTS01+40
CVTRV329 EQU   CVTS01+36
CVTRV328 EQU   CVTS01+32
CVTRV322 EQU   CVTS01+28
CVTSLID  EQU   CVTSLIDA+1
CVTSYLK  EQU   CVTSLIDA
CVTRV321 EQU   CVTS01+20
CVTRV320 EQU   CVTS01+16
CVTLPDIR EQU   CVTLPDIA+1
CVTRSV69 EQU   CVTDIRST
CVTRSV68 EQU   CVTDIRST
CVTRSV67 EQU   CVTDIRST
CVTRSV66 EQU   CVTDIRST
CVTRSV65 EQU   CVTDIRST
CVTRSV64 EQU   CVTDIRST
CVTRSV63 EQU   CVTDIRST
CVTDICOM EQU   CVTDIRST
CVTPVTP  EQU   CVTS01+8
CVTLPDSR EQU   CVTS01+4
CVTRSVA2 EQU   CVTS01
@NM00057 EQU   TAB+4
@NM00056 EQU   MAP+6
@NM00055 EQU   DATAWORD
CSADDR   EQU   COMMON+2072
@NM00051 EQU   COMMON+2070
TOPICHDR EQU   COMMON+2060
DFLTCSA  EQU   COMMON+2056
LPAMAX   EQU   COMMON+2052
DNUCTOP  EQU   COMMON+2048
XLMAX    EQU   COMMON+2044
DQEMAX   EQU   COMMON+2042
ASCBMAX  EQU   COMMON+2040
TCBMAX   EQU   COMMON+2038
SRBMAX   EQU   COMMON+2036
DDMAX    EQU   COMMON+2034
DEBMAX   EQU   COMMON+2032
JPQMAX   EQU   COMMON+2030
LLEMAX   EQU   COMMON+2028
PQEMAX   EQU   COMMON+2026
RBMAX    EQU   COMMON+2024
@NM00050 EQU   COMMON+2023
AUSRASID EQU   COMMON+2020
AUSRTCBA EQU   COMMON+2016
AUSRDEL  EQU   COMMON+2012
AUSRINIT EQU   COMMON+2004
ASRBFMT  EQU   COMMON+2000
AASCBFMT EQU   COMMON+1996
BRRDADJ  EQU   COMMON+1992
BRRDINIT EQU   COMMON+1988
BUFERMAP EQU   COMMON+1980
CPUMAP   EQU   COMMON+1972
ASIDNDX  EQU   COMMON+1968
@NM00049 EQU   COMMON+1964
HDRTITLE EQU   COMMON+1864
HDRREGS  EQU   COMMON+1696
SACSWCAW EQU   COMMON+1684
ASVTADDR EQU   COMMON+1680
PREFXRGV EQU   COMMON+1676
PREFXRGR EQU   COMMON+1672
CURASCB  EQU   COMMON+1668
IPLCPU   EQU   COMMON+1666
QASID    EQU   COMMON+1664
QAPFT    EQU   COMMON+1660
@NM00048 EQU   COMMON+1656
REALMAX  EQU   COMMON+1652
SEGTABOR EQU   COMMON+1648
REALMAP  EQU   COMMON+1644
@NM00047 EQU   COMMON+1641
EDITER   EQU   COMMON+1640
AROOT    EQU   COMMON+1636
AEDITCB  EQU   COMMON+1632
TRCCOUNT EQU   COMMON+1628
ASYSUDCB EQU   @NM00045+1
ENDLIST  EQU   @NM00046
AINDCB   EQU   DCBADDRS+12
ARDRDCB  EQU   DCBADDRS+8
APTRDCB  EQU   DCBADDRS+4
AOUTDCB  EQU   DCBADDRS
ATCBSMFR EQU   COMMON+1600
ONGOPTR  EQU   COMMON+1596
AEND     EQU   COMMON+1592
AERRMSGA EQU   COMMON+1584
BUFREINT EQU   COMMON+1580
BUFSUM   EQU   COMMON+1576
ASTPROUT EQU   COMMON+1564
ATCBRTRV EQU   COMMON+1556
ATCBREMV EQU   COMMON+1552
ATCBSAVE EQU   COMMON+1548
QATMERTN EQU   COMMON+1544
ALOADER  EQU   COMMON+1540
AEREXIT  EQU   COMMON+1536
AWRDCNVT EQU   COMMON+1520
AADRCNVT EQU   COMMON+1516
AFMTLINE EQU   COMMON+1512
NONBLNK  EQU   COMMON+1244
@NM00044 EQU   COMMON+972
@NM00043 EQU   COMMON+915
EBCTABL  EQU   HEXTABL+10
@NM00042 EQU   HEXTABL
@NM00041 EQU   TABLE
CAPTABL  EQU   COMMON+403
TITLEPGE EQU   COMMON+394
@NM00040 EQU   COMMON+392
TITLETME EQU   COMMON+379
@NM00039 EQU   COMMON+377
TITLEDTE EQU   COMMON+364
@NM00038 EQU   COMMON+362
TITLEMOD EQU   COMMON+347
TITLEMSG EQU   COMMON+283
MSG2     EQU   COMMON+257
MSG1     EQU   COMMON+231
STOP     EQU   COMMON+227
TITLE    EQU   COMMON+222
BLANKS   EQU   COMMON+214
WTORMSG  EQU   COMMON+133
@NM00037 EQU   COMMON+130
@NM00036 EQU   PRSW
@NM00035 EQU   PRSW
PRNTREAL EQU   PRSW
PRNTRL   EQU   PRSW
TTLSW    EQU   PRSW
@NM00034 EQU   PRSW
QSEGTBSW EQU   PRSW
@NM00033 EQU   PRSW
@NM00032 EQU   BUFSW
PREFM    EQU   BUFSW
@NM00031 EQU   BUFSW
@NM00030 EQU   BUFSW
@NM00029 EQU   BUFSW
@NM00028 EQU   BUFSW
@NM00027 EQU   BUFSW
@NM00026 EQU   BUFSW
@NM00025 EQU   SWF
QUT1LOD  EQU   SWF
@NM00024 EQU   SWF
PAGEOK   EQU   SWF
DMPIC    EQU   SWF
QSADMP   EQU   SWF
NUCTFRMC EQU   SWF
QPRDINIT EQU   SWF
@NM00023 EQU   SWE
@NM00022 EQU   SWE
@NM00021 EQU   SWE
BUILDMAP EQU   SWE
TITLESW  EQU   SWE
RESPC    EQU   SWE
@NM00020 EQU   SWE
STOPSW   EQU   SWE
@NM00019 EQU   SWD
GPRSFND  EQU   SWD
CONTSW   EQU   SWD
NOLOADSW EQU   SWD
NOSTDMG  EQU   SWD
@NM00018 EQU   SWD
@NM00017 EQU   SWD
@NM00016 EQU   SWC
@NM00015 EQU   SWC
@NM00014 EQU   SWC
EDITSW   EQU   SWC
TREADIN  EQU   SWC
POSITSW  EQU   SWC
SETFLSH  EQU   SWC
MSTRSW   EQU   SWC
@NM00013 EQU   SWB
@NM00012 EQU   SWB
QSYSUT2  EQU   SWB
ENDSW    EQU   SWB
@NM00011 EQU   SWB
@NM00010 EQU   SWB
FMTERR   EQU   SWB
IOERR    EQU   SWB
SETCVTSW EQU   SWA
@NM00009 EQU   SWA
GOSW     EQU   SWA
@NM00008 EQU   SWA
@NM00007 EQU   SWA
@NM00006 EQU   SWA
@NM00005 EQU   SWA
LINENUM  EQU   COMMON+120
LINENUMB EQU   COMMON+118
SIXTEEN  EQU   COMMON+116
TWELVE   EQU   COMMON+114
ELEVEN   EQU   COMMON+112
HTEN     EQU   COMMON+110
EIGHT    EQU   COMMON+108
SEVEN    EQU   COMMON+106
FIVE     EQU   COMMON+104
FOUR     EQU   COMMON+102
THREE    EQU   COMMON+100
TWO      EQU   COMMON+98
ONEA     EQU   COMMON+96
READTM   EQU   COMMON+92
RDERCNT  EQU   COMMON+88
READNO   EQU   COMMON+84
RDENTRY  EQU   COMMON+80
@NM00004 EQU   COMMON+78
FILESEQ  EQU   COMMON+76
INDD     EQU   COMMON+68
STORSIZE EQU   COMMON+64
TCBLIST  EQU   COMMON+52
PAGENUMB EQU   COMMON+44
LINECNT  EQU   COMMON+40
SIX      EQU   COMMON+36
NUCTOP   EQU   COMMON+32
WORK1    EQU   COMMON+24
VERBEND  EQU   COMMON+8
VERBGN   EQU   COMMON+4
ASCBEND  EQU   ASCB+208
ASCBSRBT EQU   ASCB+200
ASCBSWTL EQU   ASCB+196
ASCBRS14 EQU   ASCB+195
ASCBSMCT EQU   ASCB+194
ASCBRS12 EQU   ASCB+192
ASCBPCTT EQU   ASCB+188
ASCBVGTT EQU   ASCB+184
ASCBLGCB EQU   ASCB+180
ASCBMCC  EQU   ASCB+168
ASCBRTWA EQU   ASCB+164
ASCBIQEA EQU   ASCB+160
ASCBXMPQ EQU   ASCB+156
ASCBRS01 EQU   ASCB+154
ASCBFMCT EQU   ASCB+152
ASCBOUXB EQU   ASCB+148
ASCBOUCB EQU   ASCB+144
ASCBMECB EQU   ASCB+140
ASCBQECB EQU   ASCB+136
ASCBCMSB EQU   ASCB+132
ASCBCMSF EQU   ASCB+128
ASCBTCBS EQU   ASCB+124
ASCBNVSC EQU   ASCB+122
ASCBVSC  EQU   ASCB+120
ASCBSRBS EQU   ASCB+118
ASCBSSRB EQU   ASCB+116
ASCBRV06 EQU   ASCBFLG2
ASCBRV05 EQU   ASCBFLG2
ASCBRV04 EQU   ASCBFLG2
ASCBSNQS EQU   ASCBFLG2
ASCBS2S  EQU   ASCBFLG2
ASCBCEXT EQU   ASCBFLG2
ASCBPXMT EQU   ASCBFLG2
ASCBXMPT EQU   ASCBFLG2
ASCBRF07 EQU   ASCBDSP1
ASCBRF06 EQU   ASCBDSP1
ASCBRF05 EQU   ASCBDSP1
ASCBRF04 EQU   ASCBDSP1
ASCBRF03 EQU   ASCBDSP1
ASCBRF02 EQU   ASCBDSP1
ASCBFAIL EQU   ASCBDSP1
ASCBNOQ  EQU   ASCBDSP1
ASCBSWCT EQU   ASCB+112
ASCBASXB EQU   ASCB+108
ASCBTMCH EQU   ASCB+104
ASCBNSWP EQU   ASCBFLG1
ASCBTYP1 EQU   ASCBFLG1
ASCBSTND EQU   ASCBFLG1
ASCBABNT EQU   ASCBFLG1
ASCBTERM EQU   ASCBFLG1
ASCBS3S  EQU   ASCBFLG1
ASCBCMSH EQU   ASCBFLG1
ASCBTOFF EQU   ASCBFLG1
ASCBRF01 EQU   ASCBRCTF
ASCBTMLW EQU   ASCBRCTF
ASCBOUT  EQU   ASCBRCTF
ASCBWAIT EQU   ASCBRCTF
ASCBRV08 EQU   ASCBRCTF
ASCBFQU  EQU   ASCBRCTF
ASCBFRS  EQU   ASCBRCTF
ASCBTMNO EQU   ASCBRCTF
ASCBAFFN EQU   ASCBFW1
ASCBDUMP EQU   ASCB+96
ASCBQSVC EQU   ASCB+92
ASCBUBET EQU   ASCB+88
ASCBECB  EQU   ASCB+84
ASCBJSTL EQU   ASCB+80
ASCBEWST EQU   ASCB+72
ASCBEJST EQU   ASCB+64
ASCBTSB  EQU   ASCB+60
ASCBCSCB EQU   ASCB+56
ASCBRSM  EQU   ASCB+52
ASCBLDA  EQU   ASCB+48
ASCBSTOR EQU   ASCB+44
ASCBDP   EQU   ASCB+43
ASCBRV07 EQU   ASCB+42
ASCBIOSM EQU   ASCB+40
ASCBSEQN EQU   ASCB+38
ASCBASID EQU   ASCB+36
ASCBCPUS EQU   ASCB+32
ASCBSPL  EQU   ASCB+28
ASCBLSLQ EQU   ASCB+24
ASCBFSLQ EQU   ASCB+20
ASCBIOSP EQU   ASCB+16
ASCBLOCK EQU   ASCB+12
ASCBBWDP EQU   ASCB+8
ASCBFWDP EQU   ASCB+4
ASCBASCB EQU   ASCB
ASCBEGIN EQU   ASCB
ASVTEND  EQU   ASVT+528
ASVTAVAL EQU   ASVTENTY
ASVTAVAI EQU   ASVTFRST
ASVTRS00 EQU   ASVT+520
ASVTASVT EQU   ASVT+512
ASVTBEGN EQU   ASVT+512
@NM00003 EQU   ASVT
CVTLEVL  EQU   CVTRELNO+2
CVTNUMB  EQU   CVTRELNO
CVTMDL   EQU   CVTFIX+250
@NM00002 EQU   CVTFIX+248
@NM00001 EQU   CVTFIX
CVTRV482 EQU   CVTXTNT2+128
CVTRV481 EQU   CVTXTNT2+124
CVTRV480 EQU   CVTXTNT2+120
CVTRV479 EQU   CVTXTNT2+118
CVTRV478 EQU   CVTXTNT2+117
CVTRV477 EQU   CVTXTNT2+116
CVTRV476 EQU   CVTXTNT2+115
CVTRV475 EQU   CVTXTNT2+114
CVTRV474 EQU   CVTRV466
CVTRV473 EQU   CVTRV466
CVTRV472 EQU   CVTRV466
CVTRV471 EQU   CVTRV466
CVTRV470 EQU   CVTRV466
CVTRV469 EQU   CVTRV466
CVTRV468 EQU   CVTRV466
CVTRV467 EQU   CVTRV466
CVTRV465 EQU   CVTRV457
CVTRV464 EQU   CVTRV457
CVTRV463 EQU   CVTRV457
CVTRV462 EQU   CVTRV457
CVTRV461 EQU   CVTRV457
CVTRV460 EQU   CVTRV457
CVTRV459 EQU   CVTRV457
CVTRV458 EQU   CVTRV457
CVTRV456 EQU   CVTXTNT2+108
CVTRV455 EQU   CVTXTNT2+104
CVTRV454 EQU   CVTXTNT2+100
CVTRV453 EQU   CVTXTNT2+96
CVTRV452 EQU   CVTXTNT2+94
CVTRV451 EQU   CVTXTNT2+92
CVTRV450 EQU   CVTXTNT2+90
CVTRV449 EQU   CVTXTNT2+88
CVTRV448 EQU   CVTXTNT2+87
CVTRV447 EQU   CVTXTNT2+86
CVTRV446 EQU   CVTRV438
CVTRV445 EQU   CVTRV438
CVTRV444 EQU   CVTRV438
CVTRV443 EQU   CVTRV438
CVTRV442 EQU   CVTRV438
CVTRV441 EQU   CVTRV438
CVTRV440 EQU   CVTRV438
CVTRV439 EQU   CVTRV438
CVTRV437 EQU   CVTRV429
CVTRV436 EQU   CVTRV429
CVTRV435 EQU   CVTRV429
CVTRV434 EQU   CVTRV429
CVTRV433 EQU   CVTRV429
CVTRV432 EQU   CVTRV429
CVTRV431 EQU   CVTRV429
CVTRV430 EQU   CVTRV429
CVTRV428 EQU   CVTXTNT2+80
CVTRV427 EQU   CVTXTNT2+76
CVTRV426 EQU   CVTXTNT2+72
CVTRV425 EQU   CVTXTNT2+68
CVTATACT EQU   CVTATCVT
CVTRV423 EQU   CVTXTNT2+62
CVTRV422 EQU   CVTXTNT2+60
CVTRV421 EQU   CVTXTNT2+58
CVTRV420 EQU   CVTXTNT2+56
CVTRV419 EQU   CVTXTNT2+55
CVTRV418 EQU   CVTXTNT2+54
CVTRV417 EQU   CVTRV409
CVTRV416 EQU   CVTRV409
CVTRV415 EQU   CVTRV409
CVTRV414 EQU   CVTRV409
CVTRV413 EQU   CVTRV409
CVTRV412 EQU   CVTRV409
CVTRV411 EQU   CVTRV409
CVTRV410 EQU   CVTRV409
CVTRV408 EQU   CVTRV400
CVTRV407 EQU   CVTRV400
CVTRV406 EQU   CVTRV400
CVTRV405 EQU   CVTRV400
CVTRV404 EQU   CVTRV400
CVTRV403 EQU   CVTRV400
CVTRV402 EQU   CVTRV400
CVTRV401 EQU   CVTRV400
CVTRSVA1 EQU   CVTXTNT2+48
CVTRSVA0 EQU   CVTXTNT2+44
CVTRSV99 EQU   CVTXTNT2+40
CVTRSV98 EQU   CVTXTNT2+36
CVTRSV97 EQU   CVTXTNT2+34
CVTRSV96 EQU   CVTXTNT2+32
CVTOLTEP EQU   CVTXTNT2+28
CVTQIDA  EQU   CVTQID+1
CVTRSV95 EQU   CVTQID
CVTRSV94 EQU   CVTXTNT2+20
CVTRSV93 EQU   CVTXTNT2+16
CVTRSV92 EQU   CVTXTNT2+12
CVTDEBVR EQU   CVTXTNT2+8
CVTRSV91 EQU   CVTXTNT2+6
CVTRSV9H EQU   CVTRSV90
CVTRSV9G EQU   CVTRSV90
CVTRSV9F EQU   CVTRSV90
CVTRSV9E EQU   CVTRSV90
CVTRSV9D EQU   CVTRSV90
CVTRSV9C EQU   CVTRSV90
CVTRSV9B EQU   CVTRSV90
CVTRSV9A EQU   CVTRSV90
CVTNUCLS EQU   CVTXTNT2+4
CVTDSSVA EQU   CVTDSSV+1
CVTRSV89 EQU   CVTDSSV
CVTRSV88 EQU   CVTXTNT1+8
CVTRSV87 EQU   CVTXTNT1+4
CVTFACHN EQU   CVTXTNT1
CVTRV488 EQU   CVTMAP+412
CVTRV487 EQU   CVTMAP+408
CVTRV486 EQU   CVTMAP+404
CVTRV485 EQU   CVTMAP+400
CVTRV484 EQU   CVTMAP+396
CVTAUTH  EQU   CVTMAP+392
CVTATMCA EQU   CVTATMCT+1
CVTATMST EQU   CVTATMCT
CVTRSV61 EQU   CVTMAP+384
CVTVOLT1 EQU   CVTVOLM1+1
CVTVOLI1 EQU   CVTVOLF1
CVTSTOA  EQU   CVTMAP+376
CVTRSV58 EQU   CVTMAP+374
CVTRSV57 EQU   CVTMAP+372
CVTDDCE  EQU   CVTMAP+368
CVTPNWFR EQU   CVTMAP+364
CVTSMF   EQU   CVTMAP+360
CVTSULK  EQU   CVTMAP+358
CVTSLKO  EQU   CVTSYSK
CVTSLKP  EQU   CVTSYSK
CVTSLKQ  EQU   CVTSYSK
CVTSLKR  EQU   CVTSYSK
CVTRSV56 EQU   CVTSYSK
CVTRSV55 EQU   CVTSYSK
CVTRSV54 EQU   CVTSYSK
CVTRSV53 EQU   CVTSYSK
CVTRSV52 EQU   CVTA1F1
CVTRSV51 EQU   CVTA1F1
CVTRSV50 EQU   CVTA1F1
CVTRSV49 EQU   CVTA1F1
CVTRSV48 EQU   CVTA1F1
CVTRSV47 EQU   CVTA1F1
CVTSRSW  EQU   CVTA1F1
CVTPFSW  EQU   CVTA1F1
CVTPCVT  EQU   CVTMAP+352
CVTRSV46 EQU   CVTMAP+344
CVTRSV45 EQU   CVTMAP+340
CVTRSV44 EQU   CVTMAP+338
CVTRSV43 EQU   CVTMAP+336
CVTHJESA EQU   CVTHJES+1
CVTRSV42 EQU   CVTHJES
CVTEXT2A EQU   CVTEXT2+1
CVTRSV41 EQU   CVTEXT2
CVTAPFA  EQU   CVTAPF+1
CVTRSV40 EQU   CVTAPF
CVTINTLA EQU   CVTMAP+320
CVTERPV  EQU   CVTMAP+316
CVTEORM  EQU   CVTMAP+312
CVTMCHPR EQU   CVTMAP+308
CVTTZ    EQU   CVTMAP+304
CVTJEPS  EQU   CVTMAP+300
CVTJESCT EQU   CVTMAP+296
CVTMODE  EQU   CVTMAP+292
CVTPTRV  EQU   CVTMAP+288
CVTREAL  EQU   CVTMAP+284
CVTRSV39 EQU   CVTMAP+280
CVTRSV38 EQU   CVTMAP+276
CVTDMSRA EQU   CVTDMSR+1
CVTRSV37 EQU   CVTDMSR
CVTQMSGA EQU   CVTQMSG+1
CVTRSV36 EQU   CVTQMSG
CVTAMFF  EQU   CVTMAP+264
CVTPURGA EQU   CVTPURG+1
CVTRSV35 EQU   CVTPURG
CVTCBSP  EQU   CVTMAP+256
CVTATERA EQU   CVTATER+1
CVTSYST  EQU   CVTATER
CVTVOLT2 EQU   CVTTAT
CVTVOLI2 EQU   CVTVOLF2
CVTAQAVB EQU   CVTAQAVT+1
CVTRSV34 EQU   CVTTCMFG
CVTRSV33 EQU   CVTTCMFG
CVTRSV32 EQU   CVTTCMFG
CVTRSV31 EQU   CVTTCMFG
CVTRSV30 EQU   CVTTCMFG
CVTRSV29 EQU   CVTTCMFG
CVTRSV28 EQU   CVTTCMFG
CVTTCRDY EQU   CVTTCMFG
CVTGTFA  EQU   CVTGTF+1
CVTRSV27 EQU   CVTGTFST
CVTRNIO  EQU   CVTGTFST
CVTRV319 EQU   CVTUSR
CVTRV318 EQU   CVTFORM
CVTRV317 EQU   CVTTMODE
CVTRV316 EQU   CVTSTATE
CVTRV315 EQU   CVTGTFS
CVTGTFAV EQU   CVTGTFS
CVT0SCR1 EQU   CVTMAP+232
CVTTSCVB EQU   CVTTSCVT+1
CVTRSV25 EQU   CVTTSFLG
CVTRSV24 EQU   CVTTSFLG
CVTRSV23 EQU   CVTTSFLG
CVTRSV22 EQU   CVTTSFLG
CVTRSV21 EQU   CVTTSFLG
CVTRSV20 EQU   CVTTSFLG
CVTRSV19 EQU   CVTTSFLG
CVTTSRDY EQU   CVTTSFLG
CVTRMS   EQU   CVTMAP+224
CVTPATCH EQU   CVTMAP+220
CVTTSCE  EQU   CVTMAP+216
CVTLNKSC EQU   CVTMAP+214
CVTQABST EQU   CVTMAP+212
CVTMDLDS EQU   CVTMAP+208
CVTUSER  EQU   CVTMAP+204
CVTABEND EQU   CVTMAP+200
CVTSMCA  EQU   CVTMAP+196
CVTRSV18 EQU   CVTMAP+192
CVTQLPAQ EQU   CVTMAP+188
CVTQCDSR EQU   CVTMAP+184
CVTRSV17 EQU   CVTOPTB
CVTRSV16 EQU   CVTOPTB
CVTFP    EQU   CVTOPTB
CVTAPTHR EQU   CVTOPTB
CVTNLOG  EQU   CVTOPTB
CVTTOD   EQU   CVTOPTB
CVTCTIMS EQU   CVTOPTB
CVTPROT  EQU   CVTOPTB
CVTXPFP  EQU   CVTOPTA
CVTASCII EQU   CVTOPTA
CVTRSV13 EQU   CVTOPTA
CVTRSV12 EQU   CVTOPTA
CVTNIP   EQU   CVTOPTA
CVTDDR   EQU   CVTOPTA
CVTAPR   EQU   CVTOPTA
CVTCCH   EQU   CVTOPTA
CVTSNCTR EQU   CVTMAP+180
CVTQMWR  EQU   CVTMAP+176
CVTQOCR  EQU   CVTMAP+172
CVT1EF00 EQU   CVTMAP+168
CVTMZ00  EQU   CVTMAP+164
CVTHEAD  EQU   CVTMAP+160
CVTRSV11 EQU   CVTMAP+156
CVT0PT01 EQU   CVTMAP+152
CVTMSER  EQU   CVTMAP+148
CVTIERLC EQU   CVTMAP+144
CVTILCH  EQU   CVTMAP+140
CVT0DS   EQU   CVTMAP+136
CVTFBOSV EQU   CVTMAP+132
CVTNUCB  EQU   CVTMAP+128
CVTIXAVL EQU   CVTMAP+124
CVTIOQET EQU   CVTMAP+120
CVTDCBA  EQU   CVTMAP+117
CVTMVS2  EQU   CVTDCB
CVT6DAT  EQU   CVTDCB
CVT4MPS  EQU   CVTDCB
CVTRSV09 EQU   CVTDCB
CVT4MS1  EQU   CVTDCB
CVT2SPS  EQU   CVTDCB
CVT1SSS  EQU   CVTDCB
CVTRSV08 EQU   CVTDCB
CVTSTB   EQU   CVTMAP+112
CVTQTD00 EQU   CVTMAP+108
CVTQTE00 EQU   CVTMAP+104
CVTCUCB  EQU   CVTMAP+100
CVTSJQ   EQU   CVTMAP+96
CVTPBLDL EQU   CVTMAP+92
CVTTPC   EQU   CVTMAP+88
CVTSVDCB EQU   CVTMAP+84
CVTBRET  EQU   CVTMAP+82
CVTEXIT  EQU   CVTMAP+80
CVT0FN00 EQU   CVTMAP+76
CVTDARA  EQU   CVTDAR+1
CVTRSV07 EQU   CVTFLGS1
CVTRSV06 EQU   CVTFLGS1
CVTRSV05 EQU   CVTFLGS1
CVTRSV04 EQU   CVTFLGS1
CVTRSV03 EQU   CVTFLGS1
CVTRSV02 EQU   CVTFLGS1
CVTRSV01 EQU   CVTFLGS1
CVTDMPLK EQU   CVTFLGS1
CVTXITP  EQU   CVTMAP+68
CVTZDTAB EQU   CVTMAP+64
CVTMSLT  EQU   CVTMAP+60
CVTDATE  EQU   CVTMAP+56
CVTBTERM EQU   CVTMAP+52
CVTSYSAD EQU   CVTMAP+48
CVTXTLER EQU   CVTMAP+44
CVTILK2  EQU   CVTMAP+40
CVTILK1  EQU   CVTMAP+36
CVTPRLTV EQU   CVTMAP+32
CVTPCNVT EQU   CVTMAP+28
CVT0VL00 EQU   CVTMAP+24
CVTXAPG  EQU   CVTMAP+20
CVTBUF   EQU   CVTMAP+16
CVTJOB   EQU   CVTMAP+12
CVTLINK  EQU   CVTMAP+8
CVT0EF00 EQU   CVTMAP+4
CVTTCBP  EQU   CVTMAP
CVT      EQU   CVTMAP
.@UNREFD ANOP                          END UNREFERENCED COMPONENTS
@RF00110 EQU   @RC00066
@RC00108 EQU   @RC00066
@RF00115 EQU   @RC00066
@RC00113 EQU   @RC00066
@RC00183 EQU   @RC00182
@RC00200 EQU   @RC00199
@RC00122 EQU   @RC00121
@PB00002 EQU   @EL00001
@RC00304 EQU   @RC00122
@ENDDATA EQU   *
         END   AMDPRPJB,(C'PL/S-II',0502,73242)
