MOD      TITLE 'IPCS ALLOCATION MODELS'
*** START OF SPECIFICATIONS *******************************************
*
*   MODULE NAME= BLSCAMOD
*
*   DESCRIPTIVE NAME= IPCS DAS ALLOCATION MODELS
*
*   COPYRIGHT= NONE
*
*   STATUS= SU57 RELEASE 1, LEVEL 0
*
*   FUNCTION=
*     SUPPLIES STATIC PARTS OF THE DYNAMIC ALLOCATION PARAMETER
*     LISTS, OPEN/CLOSE LISTS AND DCB OR ACB AND RPL MODELS
*     FOR EACH DATA SET TYPE KNOWN TO IPCS DATA ACCESS SERVICES.
*
*   NOTES= NONE
*
*   MODULE TYPE= NON EXECUTABLE STATIC DATA
*
*      PROCESSOR= ASSEMBLER F
*
*      MODULE SIZE= TO BE COMPLETED
*
*      ATTRIBUTES= PAGEABLE  NON-EXECUTABLE STATIC CONTROL BLOCK
*
*   ENTRY POINT= BLSCAMOD
*
*      PURPOSE= HEAD OF CHAIN OF DAS ALLOCATION MODELS
*
*      LINKAGE= N/A
*
*   ENTRY POINT= BLSCFMSM
*
*      PURPOSE= IDCAMS SYSIN DATA STREAM FOR VSAM CLUSTER DELETE.
*               USED BY THE BLSCFAMS MODULE FOR THE BLSFREE FUNCTION.
*
*   INPUTS= N/A
*
*   OUTPUTS= N/A
*
*   EXIT NORMAL= N/A
*
*   EXIT ERROR= N/A
*
*   EXTERNAL REFERENCES= NONE
*
*   MACROS= ACB       VSAM ACCESS CONTROL BLOCK
*           BLSCAMMM  MODEL GENERATOR MACRO (OUTER)
*           BLSCAMM1  MODEL GENERATOR MACRO INNER)
*           BLSCAMM2  MODEL GENERATOR MACRO INNER)
*           BLSCAMSL  AMS SYSIN TEXT STREAM GENERATOR
*           DCB       DATA CONTROL BLOCK
*           IDACBACB
*           IDACBOPT
*           IDACBRPL
*           IDACB3
*           IHB01
*           OPEN      OPEN/CLOSE PARAMETER LIST
*           RPL       VSAM REQUEST PARAMETER LIST
*
*   CHANGE ACTIVITY=
*     THIS MODULE IS WRITTEN FOR @G57LPSR
*
*   MESSAGES ISSUED= N/A
*
*   ABEND CODES= N/A
*
*   DATA SETS ACCESSED= N/A
*
*   PROCESSING DESCRIPTION= N/A
*
* * END OF SPECIFICATIONS *********************************************
         SPACE 3
BLSCAMOD CSECT
         SPACE
*   SET UP ALLOCATION DEFAULTS FOR DATA SETS
         SPACE
         LCLC  &DUNIT         IPCS DISK UNIT NAME
         LCLC  &DVOL          IPCS DISK VOLUME SERIAL
         LCLC  &SYSOUCL       PRINTED OUTPUT SYSOUT CLASS
         LCLC  &INTRDCL       INTERNAL READER CLASS
&DUNIT   SETC  '3330-1'       DISK UNIT NAME DEFAULT
&DVOL    SETC  'IPCSPK'       DISK VOLUME SERIAL DEFAULT
&SYSOUCL SETC  'A'            PRINTED OUTPUT SYSOUT CLASS DEFAULT
&INTRDCL SETC  'A'            INTERNAL READER CLASS DEFAULT
         SPACE
*   GENERATE MODULE HEADER FOR INTERNAL DOCUMENTATION
         SPACE
         DC    A(A)           ADDRESS OF FIRST MODEL
         DC    AL1(27)        HEADER LENGTH
         DC    CL11'BLSCAMOD' MODULE NAME
         DC    CL10'&SYSDATE' COMPILE DATE
         DC    CL6'&SYSTIME'  COMPILR TOD
         EJECT
*   RDQSAMDS -- READ NON-VSAM DATA SET MODEL
         SPACE
*        REQUIRED USER SUPPLIED ALLOCATION PARAMETERS:
*              DSN=
         SPACE
*   DCB PARAMETERS ARE OBTAINED FROM THE DATA SET LABEL
         SPACE
A        BLSCAMMM B,RDQSAMDS,Q
         SPACE
         ORG   DCBA
         DCB   DDNAME=RDQSAMDS,DSORG=PS,MACRF=(GM,PM),EROPT=ACC
         ORG
         EJECT
*   RDIPCSPR -- MODEL TO GET READ ACCESS TO SYS1.PARMLIB TO OBTAIN THE
*               IPCS SESSION PARAMETERS
         SPACE
*        REQUIRED USER SUPPLIED ALLOCATION PARAMETERS:
*              MEMBER=
         SPACE
*        DCB PARAMETERS ARE OBTAINED FROM THE DATA SET LABEL
         SPACE
B        BLSCAMMM C,RDIPCSPR,Q,DSN='SYS1.PARMLIB'
         SPACE
         ORG   DCBB
         DCB   DDNAME=RDIPCSPR,DSORG=PS,MACRF=(GM),EROPT=ACC
         ORG
         EJECT
*   DSDY -- UPDATE THE DATA SET DIRECTORY MODEL DATA SET MODEL
         SPACE
C        BLSCAMMM F,DSDY,                                              *
               OPEN=(,(UPDAT,DISP))
         SPACE
         ORG   ACBC
         ACB   DDNAME=DSDY,AM=VSAM,MACRF=(KEY,DIR,SEQ,OUT)
         ORG   RPLC
         RPL   ACB=0
         ORG
         EJECT
*   PRINTMOD -- QSAM PUT MOVE DATA TO SYSOUT -- LRECL = 121
F        BLSCAMMM G,PRINTMOD,Q,                                        *
               OPEN=(,(OUTPUT,DISP)),                                  *
               SYSOUT=&SYSOUCL,DISP=
         SPACE
         ORG   DCBF
         DCB   DDNAME=PRINTMOD,DSORG=PS,MACRF=PM,EROPT=ACC,            *
               RECFM=FBM,LRECL=121,BLKSIZE=1936
         ORG
         EJECT
*   INTREADR -- OUTPUT A JOB TO THE INTERNAL READER MODEL
         SPACE
G        BLSCAMMM 0,INTREADR,V,                                        *
               OPEN=(,(OUTPUT,DISP)),                                  *
               SYSOUT=(&INTRDCL,INTRDR),DISP=
         SPACE
         ORG   ACBG
         ACB   DDNAME=INTREADR,AM=VSAM,MACRF=(ADR,SEQ,OUT)
         ORG   RPLG
         RPL   ACB=0,OPTCD=(ADR,SEQ,SYN,NUP),RECLEN=80
         ORG
         EJECT
*   IDCAMS SYSIN DATA FOR DATA SET DELETE. USED BY BLSCFREE.
         SPACE
         DS    0D
         ENTRY BLSCFMSM
BLSCFMSM BLSCAMSL ('DELETE -',                                         *
               '12345678901234567890123456789012345678901234 -',       *
               'PURGE CLUSTER')
         SPACE 2
         END
