         MACRO
&L       BLSCFRES &R,&LV=,&A=
.*** START OF SPECIFICATIONS *****************************************/
.**                                                                  */
.** MODULE NAME= BLSCFRES                                            */
.**                                                                  */
.** DESCRIPTIVE NAME= IPCS DAS STORAGE DEALLOCATION MACRO.           */
.**                                                                  */
.** COPYRIGHT=                                                       */
.**                                                                  */
.** STATUS= SU57 RELEASE 1, LEVEL 0                                  */
.**                                                                  */
.** FUNCTION=  BLSCFRES RETURNS THE STORAGE ALLOCATED BY THE         */
.**            BLSCGETS MACRO TO THE FREE STORAGE POOL               */
.**            IN THE DMCB.                                          */
.**                                                                  */
.** NOTES= SEE BELOW                                                 */
.**                                                                  */
.**    REGISTER CONVENTIONS=                                         */
.**                                                                  */
.**       @01 - REG  1 - INITIALLY CONTAINS THE ADDRESS OF STORAGE   */
.**                      TO BE RETURNED.                             */
.**                                                                  */
.**       @13 - REG 13 - USED TO ADDRESS SAVE AREA BELONGING TO      */
.**                      BLSCRQSTS CALLER                            */
.**                                                                  */
.**       @14 - REG 14 - USED TO ADDRESS DMCB DURING STORAGE         */
.**                      ALLOCATION.  NOT RESTORED BY MACRO.         */
.**                                                                  */
.** MODULE TYPE= MACRO                                               */
.**                                                                  */
.**    PROCESSOR= ASSEMBLER                                          */
.**                                                                  */
.**    MODULE SIZE= TO BE COMPLETED                                  */
.**                                                                  */
.** ENTRY POINT= BLSCFRES                                            */
.**                                                                  */
.**    PURPOSE= SEE FUNCTION                                         */
.**                                                                  */
.**    LINKAGE=                                                      */
.**             R01 LOADED WITH ADDRESS OF STORAGE TO BE FREED.      */
.**                                                                  */
.**             THIS MACRO IS INVOKED BY THE EPILOGUE CODE  IN LIEU  */
.**             OF FREEMAIN FOR THE IPCS DAS MODULES:                */
.**                                                                  */
.**               BLSCRQST, BLSCOPEN, BLSCCLSE, BLSCSETT, BLSCGETT,  */
.**               BLSCPUTT, BLSCPOIN, BLSCENDD, AND BLSCERSE.        */
.**                                                                  */
.** EXIT NORMAL=                                                     */
.**                                                                  */
.**             REGISTER 1 CONTAINS THE ADDRESS OF THE AREA WHICH    */
.**             WAS FREED.                                           */
.**             REGISTER 14 POINTS TO THE DMCB.                      */
.**                                                                  */
.** EXTERNAL REFERENCES=                                             */
.**                                                                  */
.**    CONTROL BLOCKS=  DATA ACCESS SERVICES CONTROL BLOCK (DMCB)    */
.**                                                                  */
.** CHANGE ACTIVITY= AS FOLLOWS:                                     */
.*         THIS MODULE IS WRITTEN FOR @G57LPSR                       */
.**                                                                  */
.*** END OF SPECIFICATIONS *******************************************/
&L       L     @14,24(@13)       PICK UP DMCB POINTER FROM SAVE AREA
         ST    @01,DMCBFRE(@14)  RESTORE NEXT FREE AREA ADDRESS
         MEND
