         TITLE 'BLSR3270--BLSR327I--STATIC STORAGE DATA'
*---------------------------------------------------------------------*
*                                                                     *
*BLSR327I--STATIC STORAGE DATA                                        *
*                                                                     *
*---------------------------------------------------------------------*
         SPACE 2
*---------------------------------------------------------------------*
*        LITERAL POOL                                                 *
*---------------------------------------------------------------------*
         SPACE
         LTORG
         SPACE 2
*---------------------------------------------------------------------*
*OPERATIONAL MESSAGES                                                 *
*---------------------------------------------------------------------*
         SPACE
MSGSTK   DC    C' ADDRESS STACK FULL'
MSGSTKLN EQU   L'MSGSTK
         SPACE
MSGIER   DC    C' ERROR IN INPUT    '
MSGIERLN EQU   L'MSGIER
         EJECT
*---------------------------------------------------------------------*
*ERASE/WRITE COMMAND SEQUENCE                                         *
*---------------------------------------------------------------------*
ERSWRT   DC    XL1'27'              ESCAPE CHARACTER
         DC    XL1'F5'              ERASE/WRITE COMMAND
ERSWRTLN EQU   *-ERSWRT             COMMAND SEQUENCE LENGTH
         SPACE 2
*---------------------------------------------------------------------*
*THE INITIAL COMMAND/ORDER STRING FOR EACH WRITE                      *
*---------------------------------------------------------------------*
         SPACE
ESCWRITE BLSRWCC
         BLSRSBA 24,80              'FULL SCREEN' INTERFACE FOR THE
*                                   SPF TCAM/TSO MCP
ESCWRTLN EQU   *-ESCWRITE
         SPACE 2
*---------------------------------------------------------------------*
*ORDER SEQUENCE TO ERASE THE ENTIRE SCREEN                            *
*---------------------------------------------------------------------*
         SPACE
ERASEALL BLSRSBA 1,1                LINE 1, COLUMN 1
         BLSRRA 1,1,0
ERASELEN EQU    *-ERASEALL
         SPACE 2
*---------------------------------------------------------------------*
*SCREEN FORMATTING SEQUENCE                                           *
*---------------------------------------------------------------------*
         SPACE
RWL1ORDS BLSRSBA 1,1              LINE 1
         BLSRSF ,                  FIRST CURSOR POSITION
         DC    C'3END '
         BLSRSF ,                  SECOND CURSOR POSITION
         DC    C'7<-SCROLL+>8 '
         BLSRSF ,                  THIRD CURSOR POSITION
         DC    C'9STACK '
         BLSRSF ,                  FOURTH CURSOR POSITION
         DC    C'10<-SKIP+>11'
         BLSRSF (PROT,INTENDET,NUM) MESSAGE AREA
         BLSRRA 2,1,0              CLEAR OUT MESSAGE AREA
RWL1ORLN EQU   *-RWL1ORDS
         SPACE
R2T4ORDS BLSRSBA 2,1              LINE 2
         BLSRSF PROT
         DC    C'SK'
         BLSRSF ,                  UNPROTECTED FOR USE OF PT ORDERS
         BLSRSBA 2,11              SECOND STACK ENTRY
         BLSRSF
         BLSRSBA 2,18              THIRD STACK ENTRY
         BLSRSF
         BLSRSBA 2,25              FOURTH STACK ENTRY
         BLSRSF
         BLSRSBA 2,32              FIFTH STACK ENTRY
         BLSRSF
         BLSRSBA 2,39              SIXTH STACK ENTRY
         BLSRSF
         BLSRSBA 2,46              SEVENTH STACK ENTRY
         BLSRSF
         BLSRSBA 2,53              EIGHTH STACK ENTRY
         BLSRSF
         BLSRSBA 2,60              NINTH STACK ENTRY
         BLSRSF
         BLSRSBA 2,67              TENTH STACK ENTRY
         BLSRSF
         BLSRSBA 2,74              LAST STACK ENTRY FIELD
         BLSRSF
         BLSRSBA 3,1              LINE 3
         BLSRSF (PROT,NUM)         CAN'T UPDATE LABEL
         DC    C'RF'               REFERENCE - WHAT THE STACK ENTS MEAN
         BLSRSF
         BLSRSBA 3,11              SECOND NOTE-LIST FIELD
         BLSRSF
         BLSRSBA 3,18              THIRD
         BLSRSF
         BLSRSBA 3,25              FOURTH
         BLSRSF
         BLSRSBA 3,32              FIFTH
         BLSRSF
         BLSRSBA 3,39              SIXTH
         BLSRSF
         BLSRSBA 3,46              SEVENTH
         BLSRSF
         BLSRSBA 3,53              EIGTH
         BLSRSF
         BLSRSBA 3,60              NINTH
         BLSRSF
         BLSRSBA 3,67              TENTH
         BLSRSF
         BLSRSBA 3,74              ELEVENTH AND LAST NOTE LIST ENTRY
         BLSRSF
R2T4ORLN EQU   *-R2T4ORDS          LENGTH OF ORDERS FOR LINES 2-3
RWL4ORDS BLSRSBA 4,1              LINE 4
         BLSRSF (PROT,NUM)
         DC    C'ADDR'             PROMPT FOR ADDRESS ENTRY
         BLSRSF
         BLSRSBA 4,13              PROTECT THE ASID PROMPT FIELD
         BLSRSF (PROT,NUM)         ''
         DC    C'ASID'             ''
         BLSRSF
         BLSRSBA 4,23              POSITION TO 'FORMAT' PROMPT FIELD
         BLSRSF (PROT,NUM)
         DC    C'FMT'              PROMPT FOR 'X' OR 'C' FORMAT
         BLSRSF
         DC    C'X'                PAD TO 'AREA' PROMPT FIELD
         BLSRSF (PROT,NUM)         PROTECT THE PROMPT
         DC    C'AREA'             TELL HIM WHAT WE WANT
         BLSRSF
         DC    C'A'                PAD TO AREA ALLOCATION PROMPT
         BLSRSF (PROT,NUM)
         DC    C'LINES/AREA: A'    TELL HIM WHAT WE NOW HAVE
         BLSRSF
         DC    C'04'               PAD TO 'B' AREA ALLOCATION
         BLSRSF (PROT,NUM)         PROTECT THE AREA ID
         DC    C'B'
         BLSRSF
         DC    C'04'               PAD TO 'C' AREA ALLOCATION
         BLSRSF (PROT,NUM)         PROTECT THE 'C' AREA ID
         DC    C'C'
         BLSRSF
         DC    C'04'               PAD TO 'D' AREA ALLOCATION
         BLSRSF (PROT,NUM)         PROTECT THE 'D' AREA ID
         DC    C'D'
         BLSRSF
         DC    C'04'               PAD TO THE 'SKIP' FIELD PROMPT
         BLSRSF (PROT,NUM)         PROTECT THE PROMPT
         DC    C'SKIP'             PROMPT FOR 'SKIP' AMOUNT
         BLSRSF
         BLSRSBA 4,80              TERMINATE THE ENTRY AREA
         BLSRSF (PROT,NUM)
RWL4ORLN EQU   *-RWL4ORDS          LENGTH OF LINE 4 ORDERS
         SPACE
RWL5ORDS DC    C' SUBCMND/CLIST:'
         BLSRSF
         BLSRSBA 5,80              POSITION TO END OF ROW 5
         BLSRSF PROT               LEST HE WRITE TOO MUCH
RWL5ORLN EQU   *-RWL5ORDS          LENGTH OF LINE 5 ORDERS
         SPACE 2
*---------------------------------------------------------------------*
*        3277 LITERAL ORDERS                                          *
*---------------------------------------------------------------------*
         SPACE
RW1UMGOR BLSRSBA 1,43             POSITION TO MESSAGE AREA
RW2SBAOR BLSRSBA 2,5              POSITION TO 1ST STACK ENTRY
ERASR2OR BLSREUA 3,5              ERASE ALL REMAINING STACK ENTRIES
RW3SBAOR BLSRSBA 3,5              POSITION TO 1 NOTE LIST ENTRY
ERASR3OR BLSREUA 4,7              ERASE REMAINING NOTE ENTRIES
RW4AADOR BLSRSBA 4,6              POSITION TO ADDR ATTRIBUTE FIELD
RW4UADOR BLSRSBA 4,7              POSITION TO ADDR ENTRY FIELD
RW4AASOR BLSRSBA 4,18             POSITION TO ASID ATTRIBUTE FIELD
RW4UASOR BLSRSBA 4,19             POSITION TO ASID ENTRY FIELD
RW4AFMOR BLSRSBA 4,27             POSITION TO FMT ATTRIBUTE FIELD
RW4UFMOR BLSRSBA 4,28             POSITION TO FMT ENTRY FIELD
RW4AAROR BLSRSBA 4,34             POSITION TO WINDOW ATTRIBUTE FIELD
RW4UAROR BLSRSBA 4,35             POSITION TO WINDOW ENTRY FIELD
RW4AL1OR BLSRSBA 4,50             POSITION TO AREA A ATTRIBUTE FIELD
RW4AL2OR BLSRSBA 4,55             -DO NOT MOVE - AREA B ATTRIBUTE FIELD
RW4AL3OR BLSRSBA 4,60             -DO NOT MOVE - AREA C ATTRIBUTE FIELD
RW4AL4OR BLSRSBA 4,65             -DO NOT MOVE - AREA D ATTRIBUTE FIELD
RW4ULNOR BLSRSBA 4,51             POINT TO LINES ENTRY FIELD
RW4ASPOR BLSRSBA 4,73             POSITION TO SKIP ATTRIBUTE FIELD
RW4USPOR BLSRSBA 4,74             POINT TO SKIP ENTRY FIELD
RW5UCMOR BLSRSBA 5,17             POSITION TO SUBCOMMAND ENTRY FIELD
         SPACE 2
*---------------------------------------------------------------------*
*        ORDER SEQUENCE TO ERASE THE REMAINDER OF THE DUMP DISPLAY    *
*        WINDOWS                                                      *
*---------------------------------------------------------------------*
         SPACE
RW6RAORD BLSRRA 1,1,0             NULLS REST OF SCREEN
         SPACE 2
*---------------------------------------------------------------------*
*        ORDER SEQUENCE TO ESTABLISH A NORMAL INTENSITY, UNPROTECTED  *
*        FIELD FOR DUMP DATA DISPLAY                                  *
*---------------------------------------------------------------------*
         SPACE
NORMAREA BLSRSF
         SPACE 2
*---------------------------------------------------------------------*
*        ORDER SEQUENCE TO ESTABLISH A NORMAL INTENSITY, PROTECTED    *
*        FIELD FOR DUMP DATA DISPLAY                                  *
*---------------------------------------------------------------------*
         SPACE
PROTAREA BLSRSF PROT
         SPACE 2
*---------------------------------------------------------------------*
*        ORDER SEQUENCE TO ESTABLISH AN INTENSIFIED UNPROTECTED       *
*        FIELD FOR DUMP DATA DISPLAY                                  *
*---------------------------------------------------------------------*
INTNSESF BLSRSF INTENDET
         SPACE 2
*---------------------------------------------------------------------*
*        MISCELLANEOUS TABLES                                         *
*---------------------------------------------------------------------*
         SPACE
         PRINT DATA
T3270TAB DC    X'&TR3270'
         DC    0H'0'              ALIGN FOR BUFFER ADDRESS TABLE
BUFADTAB BLSRROTB 6,24,1
         PRINT NODATA
         DS    0D
SBATRTTB DC    256AL1(0)          SKIP PAST ALL CHARS -
         ORG   SBATRTTB+ORDERSBA  - EXCEPT THE SET-BUFFER-ADDRESS
         DC    AL1(255)           - DISPLAY ORDER CODE
         ORG
         SPACE 2
*---------------------------------------------------------------------*
*        PATCH AREA ADDRESSABLE FROM ASSEMBLER CODE                   *
*---------------------------------------------------------------------*
         SPACE
BLSRPTCH DC    CL8'ZAPAREA',(((*-BLSR327A+19)/20+7)/8)CL8'BLSR327A'
