*---------------------------------------------------------------------*
*                                                                     *
*BLSR327W--BLSR3270 CONTROL AREA                                      *
*                                                                     *
*---------------------------------------------------------------------*
         SPACE
         IEZBITS
WKAORG   DS    0F                 ORIGIN OF WORK AREA
         DC    CL8'BLSR327W'      IDENTIFIER
         DC    A(0)
         DC    A(0)
         SPACE 2
*---------------------------------------------------------------------*
*        11-ENTRY ADDRESS STACK                                       *
*---------------------------------------------------------------------*
         SPACE
WKASTACK DC    11A(0)             ADDRESS LIST
WKASKDEL EQU   BIT0               PURGE THIS ENTRY FROM STACK
WKANB1   DC    0CL6'CVT...'       'REAL' SIZE OF A NOTE LIST ENTRY
WKANOTES DC    CL8'CVT',10CL8' '  NOTE LIST
WKASKASI DC    11Y(1)             ASID LIST
         SPACE 2
*---------------------------------------------------------------------*
*        STACK MANAGEMENT COUNTERS                                    *
*---------------------------------------------------------------------*
         SPACE
WKASKNUM DC    FL1'1'             ONE INITIAL ADDRESS ENTRY--THE CVT
WKANBNUM DC    FL1'1'             ONE INITIAL NOTE ENTRY--'CVT'
         SPACE 2
*---------------------------------------------------------------------*
*        CURRENT ENTRY LINE VALUES                                    *
*---------------------------------------------------------------------*
         SPACE
WKAADDR  DS    0A                 CURRENT ADDRESS
         DC    AL1(WKAADRLL),AL3(0) NEEDN'T STACK ZERO ON INIT REQ
WKAADRLL EQU   BIT1               DO NOT STACK IMPLICITLY
WKAASID  DC    Y(1)               MVS ASID
WKAFMT   DC    C'X'               HEXADECIMAL DISPLAY FORMATTING
WKAAREA  DC    C'A'               START IN FIRST DISPLAY WINDOW
WKALINES DC    AL1(19,0,0,0)      ALL LINES IN WINDOW A
WKASKIP  DC    A(512)             START SKIP VALUE = 800 BYTES
         SPACE 2
*---------------------------------------------------------------------*
*        THE VECTOR THAT DEFINES CURRENT USAGE OF LINES 6-24 IT       *
*        INDICATES WHAT WINDOW A GIVEN ROW LOGICALLY BELONGS TO. THE  *
*        HIGH ORDER BIT IN EACH BYTE INDICATES THAT THE ROW MUST BE   *
*        RE-WRITTEN.                                                  *
*---------------------------------------------------------------------*
         SPACE
WKALNCTL DS    0XL19              NINETEEN ROWS BELOW HEADER LINES
         DC    19XL1'01'          NINETEEN ROWS IN WINDOW A
         DC    0X'02'             NO ROWS IN WINDOW B
         DC    0X'03'             NO ROWS IN WINDOW C
         DC    0X'04'             NO ROWS IN WINDOW D
         DC    0X'00'             NO UNUSED ROWS
WKALNCTW EQU   BIT0               MUST WRITE THIS LINE
         DC    BL1'00000011'
         SPACE 2
*---------------------------------------------------------------------*
*        WINDOW CONTROL ARRAYS                                        *
*---------------------------------------------------------------------*
         SPACE
WKALNCTV DC    A(0,20,20,20)      INDEX VALUES INTO WKALNCTL FOR
*                                 WINDOWS A,B,C, AND D
WKAVCTA  DC    4A(0)              START ADDRESSES
WKAVCTB  DC    4A(0)              CURRENT LINE START ADDRESSES
WKAVCTC  DC    4A(WKAVCTAI)       EACH WINDOW INITIALLY INVALID
WKAVASI  EQU   WKAVCTC,2,C'H'     ASID'S
WKAVFMT  EQU   WKAVCTC+2,1,C'C'   FORMATS
WKAVFLAG EQU   WKAVCTC+3,1,C'B'   FLAGS
WKAVCTAI EQU   BIT0               SCREEN WINDOW NOT YET USED
         DC    A(0)
         DC    Y(0)
         DC    C'X'
         DC    C'A'
         DC    AL1(19,0,0,0)
         SPACE 2
*---------------------------------------------------------------------*
*        SCRATCH-PAD FOR THE FORMAT ROUTINES                          *
*---------------------------------------------------------------------*
         SPACE
         DC    D'0'
         DC    A(0)
         DC    A(0)
WKACRPOS DC    2A(0)              ROW/COLUMN ADDRESS OF CURSOR
WKAAIDNX DC    Y(0)               INDEX INTO AID PROCESSOR YCON TABS
WKACORDS DC    X'11C55013'        INSERT CURSOR
         DC    X'0000'
         SPACE 2
*---------------------------------------------------------------------*
*        SUBCOMMAND DATA                                              *
*---------------------------------------------------------------------*
         SPACE
WKABLSRC DC    CL79'LAST SUBCOMMAND ENTERED UNDER DSPL3270'
WKABLSRN DC    AL1(0)             AMOUNT OF DATA VALID IN BLSRC FIELD
WKALENG  EQU   *-WKAORG           LENGTH OF THIS WORKAREA
