*/*                                                                 */
*/* ***** VTAM DEVICE DEPENDENT EWA SECTION OF EWATMAP *****        */
*/*                                                                 */
*%GOTO   EWAPLS1;
* *****   ASSEMBLER LANGUAGE DSECT FOR EWATMAP   *******
         MACRO
         EWATMAP
EWATMAP  DSECT
         ORG   EWAIERP
         DS    0F                       FORCE WORD BOUNDARY
EWATRS01 DS    CL4                      RESERVED
EWATOBR  DS    0CL18                    OBR INTERFACE
EWATSIO  DS    XL2                      SIO COUNTER
EWATTMP  DS    XL1                      TEMPORARY ERROR COUNTER
EWATRS02 DS    XL1                      RESERVED
EWATCCL  DS    XL1                      LAST EXECUTED COMMAND
EWATCCF  DS    XL1                      FIRST COMMAND IN ERROR
EWATREC  DS    XL1                      RECD TYPE, IF ZERO PERM ERROR
*           EQUATES FOR EWATREC FLAGS
EWATRS03 EQU   X'80'                    RESERVED
EWATOVF  EQU   X'40'                    COUNTER OVERFLOW RECORD
EWATCLO  EQU   X'20'                    CLOSEDOWN RECORD
EWATRS04 EQU   X'1F'                    RESERVED (LAST 5 BITS/FLAGS)
*
EWATRS05 DS    XL1                      RESERVED
EWATTRM  DS    CL8                      SYMBOLIC TERMINAL NAME
EWATSNL  DS    XL1                      LAST SENSE RECEIVED
EWATSNF  DS    XL1                      FIRST SENSE RECEIVED
EWATSR06 DS    XL3                      RESERVED
EWATCSW  DS    XL7                      ORIGINAL CSW - LAST 7 BYTES
EWATCCW  DS    XL8                      ORIGINAL CCW
         DS    0F                       FORCE WORD BDY FOR EWATERPW
EWATERPW DS    0XL20                    3270 ERP WORK AREA
EWATLFCM DS    A                        CURRENT FAILING CCW POINTER
EWATCFCS DS    A                        CURRENT FAILING SET POINTER
EWATEWRT DS    A                        E/W CCW SET POINTER
EWATWSBA DS    A                        W/SBA CCW SET POINTER
EWATCFOP DS    XL1                      CURRENT FAILING OP-CODE
EWATRECT DS    XL1                      RECORD TYPE FLAGS
*           EQUATES FOR EWATRECT FLAGS
EWATRS07 EQU   X'80'                    RESERVED
EWATCTOV EQU   X'40'                    COUNTER OVERFLOW RECORD
EWATCLOS EQU   X'20'                    CLOSEDOWN RECORD
EWATRS08 EQU   X'1F'                    RESERVED (LAST 5 BITS/FLAGS)
*
EWATLPC  DS    XL2                      LOCAL PROCESS CONTROL SWS
*           EWATLPC FIRST FLAG BYTE EQUATES
EWATLPC0 EQU   X'80'                    INVALID CCW ADDRESS
EWATLPC1 EQU   X'40'                    SEARCH EXITING
EWATLPC2 EQU   X'20'                    SEARCH DATA CHAINING
EWATLPC3 EQU   X'10'                    CHANNEL PGM NOT ALL READS
EWATLPC4 EQU   X'08'                    E/W OR W/SBA FOUND
EWATLPC5 EQU   X'04'                    RD FOLLOWS E/W OR W/SBA
EWATLPC6 EQU   X'02'                    RD & WT FOLLOWS E/W OR W/SBA
EWATLPC7 EQU   X'01'                    ALLOW RETRY ( CCC/ICC/CDC/UC )
*           EWATLPC SECOND FLAG BYTE EQUATES
EWATLPC8 EQU   X'80'                    RETRY CONTROL SWITCH 1
EWATLPC9 EQU   X'40'                    SUCCESSFUL RETRY
EWATPLCA EQU   X'20'                    RETRY CONTROL SWITCH 2
EWATLPCR EQU   X'1F'                    RESERVED (LAST 5 BITS/FLAGS)
         MEND
*%EWAPLS1: ;
*DCL
*  1  EWATMAP  BDY(WORD) DEFINED(EWAIERP), /* VTAM DEP. EWA SECTION  */
*     2  EWATRS01 CHAR(4),                 /* RESERVED               */
*     2  EWATOBR  CHAR(18),           /* OBR INTERFACE               */
*        3  EWATSIO  CHAR(2),         /* SIO COUNTER                 */
*        3  EWATTMP  CHAR(1),         /* TEMPORARY ERROR COUNTER     */
*        3  EWATRS02 CHAR(1),         /* RESERVED                    */
*        3  EWATCCL  CHAR(1),         /* LAST EXECUTED COMMAND       */
*        3  EWATCCF  CHAR(1),         /* FIRST COMMAND IN ERROR      */
*        3  EWATREC  CHAR(1),         /* RECORD TYPE, IF ZERO PERMANENT
*                                        ERROR                       */
*           4  EWATRS03 BIT(1),       /* RESERVED                    */
*           4  EWATOVF  BIT(1),       /* COUNTER OVERFLOW RECORD     */
*           4  EWATCLO  BIT(1),       /* CLOSEDOWN RECORD            */
*           4  EWATRS04 BIT(5),       /* RESERVED                    */
*        3  EWATRS05 CHAR(1),         /* RESERVED                    */
*        3  EWATTRM  CHAR(8),         /* SYMBOLIC TERMINAL NAME      */
*        3  EWATSNL  CHAR(1),         /* LAST SENSE RECEIVED         */
*        3  EWATSNF  CHAR(1),         /* FIRST SENSE RECEIVED        */
*     2  EWATRS06 CHAR(3),            /* RESERVED                    */
*     2  EWATCSW  CHAR(7),            /* ORIGINAL CSW - LAST 7 BYTES */
*     2  EWATCCW  CHAR(8),            /* ORIGINAL CCW                */
*     2  EWATERPW CHAR(20) BDY(WORD), /* 3270 ERP WORK AREA          */
*        3  EWATLFCM PTR(31),         /* CURRENT FAILING CCW POINTER */
*        3  EWATCFCS PTR(31),         /* CURRENT FAILING SET POINTER */
*        3  EWATEWRT PTR(31),         /* E/W CCW SET POINTER         */
*        3  EWATWSBA PTR(31),         /* W/SBA CCW SET POINTER       */
*        3  EWATCFOP CHAR(1),         /* CURRENT FAILING OP-CODE     */
*        3  EWATRECT BIT(8),          /* RECORD TYPE FLAGS           */
*           4  EWATRS07 BIT(1),       /* RESERVED                    */
*           4  EWATCTOV BIT(1),       /* COUNTER OVERFLOW RECORD     */
*           4  EWATCLOS BIT(1),       /* CLOSEDOWN RECORD            */
*           4  EWATRS08 BIT(5),       /* RESERVED                    */
*        3  EWATLPC  BIT(16),         /* LOCAL PROCESS CONTROL SWS   */
*           4  EWATLPC0 BIT(1),       /* INVALID CCW ADDRESS         */
*           4  EWATLPC1 BIT(1),       /* SEARCH EXITING              */
*           4  EWATLPC2 BIT(1),       /* SEARCH DATA CHAINING        */
*           4  EWATLPC3 BIT(1),       /* CHANNEL PGM NOT ALL READS   */
*           4  EWATLPC4 BIT(1),       /* E/W OR W/SBA FOUND          */
*           4  EWATLPC5 BIT(1),       /* RD FOLLOWS E/W OR W/SBA     */
*           4  EWATLPC6 BIT(1),       /* RD & WT FOLLOWS E/W OR W/SBA*/
*           4  EWATLPC7 BIT(1),       /* ALLOW RETRY (CCC/ICC/CDC/UC)*/
*           4  EWATLPC8 BIT(1),       /* RETRY CONTROL SWITCH 1      */
*           4  EWATLPC9 BIT(1),       /* SUCCESSFUL RETRY            */
*           4  EWATLPCA BIT(1),       /* RETRY CONTROL SWITCH 2      */
*           4  EWATLPCR BIT(5);       /* RESERVED                    */
