*@LIST PUSH;
*@LIST OFF ;
* /*
         MACRO
         EWTCMAP
         SPACE 1
****************************************************************
*                                                              *
*    THIS DSECT DESCRIBES THE TELECOMMUNICATIONS ACCESS METHOD *
*    DEVICE DEPENDENT SECTION OF THE ERP WORKAREA. IT IS       *
*    INVOKED BY IECDERWA IF EWTC IS SPECIFIED AS AN OPTION ON  *
*    THE MACRO CALL.                                           *
*                                                              *
*   OS/VS2 RELEASE 2,4/1/73,LEVEL=01                           *
*                                                              *
****************************************************************
         SPACE 1
EWTCADDR EQU *
EWTCSNS  DS    AL2                      SENSE INFORMATION
EWTCTID  DS    AL2                      TERMINAL IDENTIFICATION
*                                       CHARACTERS
***********************************************************************
*        START OF DEVICE DEPENDENT INFORMATION FOR OBR/SDR            *
***********************************************************************
EWTCSIO  DS    AL2                      COUNT OF START I/O COMMANDS FOR
*                                       LINE OR STATION
EWTCTMP  DS    AL1                      COUNT OF TEMPORARY ERRORS FOR
*                                       LINE OR STATION
EWTCMSK  DS    AL1                      LINE OR STATION RECORDING ERROR
*                                       MASK
EWTCTPL  DS    AL1                      TP OP-CODE OF LAST INTERRUPTED
*                                       I/O OPERATION
EWTCTPF  DS    AL1                      TP OP-CODE OF FIRST INTERRUPTED
*                                       I/O OPERATION
EWTCFLG  DS    AL1                      OBR/SDR FLAG BYTE
*                  BIT DEFINITIONS
EWTCTEM  EQU   X'80'                    TEMPORARY ERROR
EWTCOVF  EQU   X'40'                    COUNTER OVERFLOW
EWTCEOD  EQU   X'20'                    END-OF-DAY RECORDING
EWTCSEL  EQU   X'10'                    INITIAL SELECTION ERROR
EWTCGRA  DS    AL1                      GRAPHIC RESPONSE CHARACTER
EWTCTRM  DS    CL8                      TERMINAL OR UCB NAME
EWTCSNL  DS    AL1                      SENSE OF LAST INTERRUPTED I/O
*                                       OPERATION.
EWTCSNF  DS    AL1                      SENSE OF FIRST INTERRUPTED I/O
*                                       OPERATION.
***********************************************************************
*        END OF DEVICE DEPENDENT INFORMATION FOR OBR/SDR              *
***********************************************************************
EWTCRSV1 DS    AL2                      RESERVED
EWTCRSV2 DS    AL1                      RESERVED
EWTCCSW  DS    XL7                      INTERRUPTED CSW
EWTCCCW  DS    2A                       INTERRUPTED CCW.
EWTCBUFF DS    A                        ADDRESS OF TPER BUFFER FOR MDR
EWTCEND  EQU   *
*
***********************************************************************
*   0  *   EWTCSNS                     *   EWTCTID                    *
***********************************************************************
*   4  *   EWTCSIO                     *   EWTCTMP     *   EWTCMSK    *
***********************************************************************
*   8  *   EWTCTPL     *   EWTCTPF     *   EWTCFLG     *   EWTCGRA    *
***********************************************************************
*  12  *                               EWTCTRM                        *
***********************************************************************
*  16  *                                                              *
***********************************************************************
*  20  *   EWTCSNL     *   EWTCSNF     *   EWTCRSV1                   *
***********************************************************************
*  24  *   EWTCRSV2    *               EWTCCSW                        *
***********************************************************************
*  28  *                                                              *
***********************************************************************
*  32  *                               EWTCCCW                        *
***********************************************************************
*  36  *                                                              *
***********************************************************************
*  40  *                               EWTCBUFF                       *
***********************************************************************
         MEND
* */
*@LIST POP;
*
* /************************************************************/
* /*                                                          */
* /*   THIS STRUCTURE DESCRIBES THE TELECOMMUNICATIONS ACCESS */
* /*   METHOD DEVICE DEPENDENT SECTION OF THE ERP WORKAREA. IT*/
* /*   IS INVOKED BY IECDERWA IF EWTC IS SPECIFIED AS AN      */
* /*   OPTION ON THE MACRO CALL.                              */
* /*                                                          */
* /*   OS/VS2 RELEASE2,4/1/73,LEVEL=01                        */
* /*                                                          */
* /************************************************************/
*
         DCL 1 EWTCADDR CHAR(44) BASED(ADDR(EWAIERP)) BDY(DWORD),
*            2 EWTCSNS FIXED (16),     /* SENSE INFORMATION          */
*            2 EWTCTID FIXED (16),     /* TERMINAL IDENTIFICATION    */
*                                      /* CHARACTERS.                */
* /*******************************************************************/
* /*         START OF DEVICE DEPENDENT INFORMATION FOR OBR/SDR       */
* /*******************************************************************/
*            2 EWTCSIO FIXED (16),     /* COUNT OF START I/O COMMANDS*/
*                                      /* FOR LINE OR STATION        */
*            2 EWTCTMP FIXED  (8),     /* COUNT OF TEMPORARY ERRORS  */
*                                      /* FOR LINE OR STATION        */
*            2 EWTCMSK FIXED  (8),     /* LINE OR STATION RECORDING  */
*                                      /* ERROR MASK                 */
*            2 EWTCTPL FIXED  (8),     /* TP OP-CODE OF LAST         */
*                                      /* INTERRUPTED I/O OPERATION  */
*            2 EWTCTPF FIXED  (8),     /* TP OP-CODE OF FIRST        */
*                                      /* INTERRUPTED I/O OPERATION  */
*            2 EWTCFLG FIXED  (8),     /* OBR/SDR FLAG BYTE          */
*              3 EWTCTEM BIT(1),       /* TEMPORARY ERROR            */
*              3 EWTCOVF BIT(1),       /* COUNTER OVERFLOW           */
*              3 EWTCEOD BIT(1),       /* END-OF-DAY RECORDING       */
*              3 EWTCSEL BIT(1),       /* INITIAL SELECTION ERROR    */
*            2 EWTCGRA FIXED  (8),     /* GRAPHIC RESPONSE           */
*                                      /* CHARACTER.                 */
*            2 EWTCTRM CHAR   (8),     /* TERMINAL OR UCB NAME       */
*            2 EWTCSNL FIXED  (8),     /* SENSE OF LAST INTERRUPTED  */
*                                      /* I/O OPERATION              */
*            2 EWTCSNF FIXED  (8),     /* SENSE OF FIRST INTERRUPTED */
*                                      /* I/O OPERATION              */
*            2 EWTCRSV1 FIXED (16),    /* RESERVED                   */
* /*******************************************************************/
* /*         END OF DEVICE DEPENDENT INFORMATION FOR OBR/SDR         */
* /*******************************************************************/
*            2 EWTCRSV2 FIXED  (8),    /* RESERVED                   */
*            2 EWTCCSW  CHAR (7),      /* INTERRUPTED CSW.           */
*            2 EWTCCCW CHAR(8),        /* INTERRUPTED CCW.           */
             2 EWTCBUFF CHAR(4),       /* ADDRESS OF TPER BUFFER     */
*                                      /*  FOR MDR                   */
* /*******************************************************************/
* /*  0  *   EWTCSNS                   *   EWTCTID                   */
* /*******************************************************************/
* /*  4  *   EWTCSIO                   *   EWTCTMP    *  EWTCMSK     */
* /*******************************************************************/
* /*  8  *   EWTCTPL    *   EWTCTPF    *   EWTCFLG    *  EWTCGRA     */
* /*******************************************************************/
* /* 12  *                         EWTCTRM                           */
* /*******************************************************************/
* /* 16  *                                                           */
* /*******************************************************************/
* /* 20  *   EWTCSNL    *   EWTCSNF    *   EWTCRSV1                  */
* /*******************************************************************/
* /* 24  *   EWTCRSV2   *          EWTCCSW                           */
* /*******************************************************************/
* /* 28  *                                                           */
* /*******************************************************************/
* /* 32  *                         EWTCCCW                           */
* /*******************************************************************/
* /* 36  *                                                           */
* /*******************************************************************/
* /* 40  *                         EWTCBUFF                          */
* /*******************************************************************/
*            2 EWTCEND CHAR(0);        /* END OF EWTC                */
