*
         MACRO
         EWTMAP
*
***********************************************************************
*              MAGNETIC TAPE ERP - DEVICE DEPENDENT SECTION           *
*   THIS SECTION DESCRIBES THE TAPE ERP DEVICE DEPENDENT SECTION OF   *
*   THE EXTENDED WORK AREA.  IT IS INVOKED BY IECDERWA IF EWT IS      *
*   SPECIFIED AS AN OPTION ON THE MACRO CALL.                         *
***********************************************************************
         ORG   EWAIERP
***********************************************************************
*                         24 SENSE BYTES                              *
***********************************************************************
EWTSNS   DS    XL24                    TAPE SENSE INFORMATION
         ORG   EWTSNS
EWTSNS0  DS    XL1                     SENSE BYTE 0
EWTCREJ  EQU   X'80'                   COMMAND REJECT
EWTINT   EQU   X'40'                   INTERVENTION REQUIRED
EWTBUSO  EQU   X'20'                   BUS OUT
EWTEQU   EQU   X'10'                   EQUIPMENT CHECK
EWTDATA  EQU   X'08'                   DATA CHECK
EWTOVRN  EQU   X'04'                   OVERRUN
EWTWCZ   EQU   X'02'                   WORD COUNT ZERO
EWTDCC   EQU   X'01'                   DATA CONVERTER CHECK
EWTSNS1  DS    XL1                     SENSE BYTE 1
EWTNOISE EQU   X'80'                   NOISE
EWTSTA   EQU   X'40'                   TU STATUS A
EWTSTB   EQU   X'20'                   TU STATUS B
EWT7TK   EQU   X'10'                   SEVEN-TRACK
EWTLP    EQU   X'08'                   LOAD POINT
EWTWRT   EQU   X'04'                   WRITE STATUS
EWTFP    EQU   X'02'                   FILE PROTECT
EWTNCAP  EQU   X'01'                   NOT CAPABLE
EWTSNS2  DS    XL1                     SENSE BYTE 2
EWTTIE   EQU   X'FF'                   TIE BYTE
EWTINVAL EQU   X'03'                   TIE BYTE INVALID
EWTSNS3  DS    XL1                     SENSE BYTE 3
EWTSNS4  DS    XL1                     SENSE BYTE 4
EWTSNS5  DS    XL1                     SENSE BYTE 5
EWTPEID  EQU   X'10'                   PE ID BURST CHECK'
EWTSNS6  DS    XL1                     SENSE BYTE 6
EWTSNS7  DS    XL1                     SENSE BYTE 7
EWTDSE   EQU   X'08'                   DATA SECURITY ERASE
EWTSNS8  DS    XL1                     SENSE BYTE 8
EWTSNS9  DS    XL1                     SENSE BYTE 9
EWTSNS10 DS    XL1                     SENSE BYTE 10
EWTSNS11 DS    XL1                     SENSE BYTE 11
EWTSNS12 DS    XL1                     SENSE BYTE 12
EWTSNS13 DS    XL1                     SENSE BYTE 13
EWTSNS14 DS    XL1                     SENSE BYTE 14
EWTSNS15 DS    XL1                     SENSE BYTE 15
EWTSNS16 DS    XL1                     SENSE BYTE 16
EWTSNS17 DS    XL1                     SENSE BYTE 17
EWTSNS18 DS    XL1                     SENSE BYTE 18
EWTSNS19 DS    XL1                     SENSE BYTE 19
EWTSNS20 DS    XL1                     SENSE BYTE 20
EWTSNS21 DS    XL1                     SENSE BYTE 21
EWTSNS22 DS    XL1                     SENSE BYTE 22
EWTSNS23 DS    XL1                     SENSE BYTE 23
***********************************************************************
*                        IDAL LIST FOR ROR                            *
***********************************************************************
*
EWTIDAL  DS    17F                     ERP IDAL LIST
*
***********************************************************************
*                         WTO MESSAGE AREA                            *
***********************************************************************
         ORG   EWTIDAL
EWTWTO   DS    0F                      WTO OUTPUT MESSAGE
EWTLNGTH DS    AL2                     MESSAGE LENGTH
         DS    XL2                     MCS FLAGS
EWTMSGNO DS    CL8                     MESSAGE ID
EWTUNID  DS    CL4                     UNIT ADDRESS
EWTTEXT  DS    CL13                    MESSAGE TEXT
EWTOPCDE DS    CL3                     CCW OP CODE
EWTSTAT  DS    CL5                     CCW STATUS
EWTSENSE DS    CL5                     SENSE DATA
EWTLOC   DS    CL9                     DCB BLOCK COUNT
EWTVOL   DS    CL6                     VOLUME SERIAL NUMBER
EWTROUTE DS    XL4                     DESCRIPTOR AND ROUTING
EWTMGEND EQU   *
         DS    CL7                     N/A
EWTVIRT  DS    A                       IOSB START ADDRESS
***********************************************************************
*                             ROR CCW                                 *
***********************************************************************
*
EWTRRCCW DS    CL8                     ROR CCW
         ORG   EWTRRCCW
EWTRRCMD DS    CL1                     ROR COMMAND
         ORG   EWTRRCCW
EWTRRADR DS    CL4                     ROR CCW DATA ADDRESS
EWTRRFLS DS    CL2                     ROR CCW FLAGS
EWTRRCNT DS    CL2                     ROR CCW COUNT
*
***********************************************************************
*                        OBR RECORD AREA                              *
***********************************************************************
EWTOBR   EQU   *                       OBR INFORMATION
EWTVOLID DS    XL6                     VOLUME SERIAL NUMBER
EWTBLK   DS    XL2                     BLOCK COUNT
EWTVES   DS    XL16                    VES INFORMATION
*
***********************************************************************
*                        MISCELLANEOUS                                *
***********************************************************************
         ORG   EWTOBR
EWTDCB   DS    A                       DCB ADDR SAVE AREA
EWTDEB   DS    A                       DEB ADDR SAVE AREA
EWTRES   DS    F                       RESIDUAL CNT FROM RECORD LENGTH
EWTNBFP  DS    F                       NUMBER OF BYTES IN FIRST PAGE
EWTC1    DS    F                       CONSTANT (1) - MADE + OR -
EWTC7FF  DS    F                       CONSTANT (2047) - MADE + OR -
*
         ORG   EWTNBFP
EWTWORD  DS    0F                      WORK AREA
EWTMASK  DS    F                       SAVE AREA FOR MASK BYTE
EWTTST   DS    XL1                     SENSE BYTE TEST AREA
         MEND
