*@LIST PUSH;
*@LIST OFF;
*/*
         MACRO
         EWUMAP
**/
*@LIST POP;
*/********************************************************************/
*/* EWUMAP MAPS THE DEVICE DEPENDENT SECTION OF THE ERP WORK AREA    */
*/*        FOR UNIT RECORD DEVICES. IT IS CALLED AS AN INNER MACRO   */
*/*        FROM IECDERWA.                                            */
*/*        THE FOLLOWING CODES ARE USED TO INDICATE WHICH DEVICES    */
*/*        THE FIELDS APPLY TO:                                      */
*/*        A - 1403,1443                                             */
*/*        B - 3211                                                  */
*/*        C - 1442,2501,2520,2596                                   */
*/*        D - 1402,2540                                             */
*/*        E - 3505,3525                                             */
*/*        F - 2671                                                  */
*/*        G - 3800                                                  */
*/********************************************************************/
*@LIST PUSH;
*@LIST OFF;
*/*
         ORG   EWAIERP
EWUSN0   DS    X                  1ST SENSE BYTE
EWUCREJ  EQU   X'80'              COMMAND REJECT      (ALL)
EWUINT   EQU   X'40'              INTERVENTION REQD.  (ALL)
EWUBUSO  EQU   X'20'              BUS OUT             (ALL)
EWUEQCK  EQU   X'10'              EQUIPMENT CHECK     (ALL)
EWUDTCK  EQU   X'08'              DATA CHECK          (ALL)
EWUBUFP  EQU   X'04'              BUFFER PARITY       (A,B)
EWUOVRN  EQU   X'04'              OVERRUN             (C)
EWULDCK  EQU   X'02'              LOAD CHECK          (B,G)
EWUUSEQ  EQU   X'02'              UNUSUAL SEQUENCE    (D)
EWUABFR  EQU   X'02'              ABNORMAL FMT RESET  (E)
EWUCH9   EQU   X'01'              CHANNEL 9           (A,B,G)
EWUPEK   EQU   X'01'              PERMANENT ERROR KEY (E)
EWUSN1   DS    X                  2ND SENSE BYTE
EWUCRTRY EQU   X'80'              COMMAND RETRY       (B)
EWUPERM  EQU   X'80'              PERMANENT ERROR     (E)
EWUIVCMD EQU   X'80'              INVALID COMMAND     (G)
EWUNORDY EQU   X'80'              NOT READY           (G)
EWUCMD   EQU   X'80'              BUS OUT PARITY COMMAND  (G)
EWUHARD  EQU   X'80'              EQMT CK HARDWARE ERROR  (G)
EWUUNPRT EQU   X'80'              UNPRINTABLE CHARACTER   (G)
EWUINVLN EQU   X'80'              INCORRECT LENGTH    (G)
EWUOPCK  EQU   X'40'              OPERATION CHECK      (G)
EWUDATA  EQU   X'40'              BUS OUT PARITY DATA (G)
EWUPRM   EQU   X'40'              PERMANENT ERROR     (G)
EWUERLPI EQU   X'40'              INCORRECT LPI IN FCB (G)
EWUPCK   EQU   X'40'              PRINT CHECK         (B)
EWUARTRY EQU   X'40'              AUTOMATIC RETRY     (E)
EWUPQ    EQU   X'20'              PRINT QUALITY       (B)
EWUMOT   EQU   X'20'              MOTION ERROR        (E)
EWUTONFL EQU   X'20'              TONER COLLECTOR FULL (G)
EWUELGFL EQU   X'20'              ERROR LOG FULL      (G)
EWUNOTRT EQU   X'20'              NO TRANSLATE TABLE  (G)
EWUHLFER EQU   X'20'              FCB HALF INCH ERROR (G)
EWULNPOS EQU   X'10'              LINE POSITION       (B)
EWUIRTRY EQU   X'10'              RETRY AFTER INT.REQ.(E)
EWUNOTNE EQU   X'10'              TONER EMPTY         (G)
EWUCANCL EQU   X'10'              CANCEL KEY          (G)
EWUCHCOD EQU   X'10'              NO MATCH FCB CHAN CODE (G)
EWUBADCC EQU   X'10'              FCB INVALID CHAN CODE  (G)
EWUFORM  EQU   X'08'              FORMS CHECK         (B)
EWUDEVRQ EQU   X'08'              DEVELOPER REPL REQUIRED (G)
EWUMLTCH EQU   X'08'              MULTIPLE CHARACTERS (G)
EWUFCBLN EQU   X'08'              FCB LENGTH ERROR    (G)
EWUSUPR  EQU   X'04'              COMMAND SUPPRESS    (B)
EWUEOFRM EQU   X'04'              END OF FORMS        (G)
EWUNOWCG EQU   X'04'              WCGM NOT LOADED FOR TRANSL CODE (G)
EWUMECMO EQU   X'02'              MECHANICAL MOTION   (B)
EWUOUTFL EQU   X'02'              OUTPUT FULL         (G)
EWUBADTC EQU   X'02'              INVALID TRANSLATE CODES (G)
EWUSN2   DS    X                  3RD SENSE BYTE
EWUUCSBP EQU   X'80'              UCS PARITY ERROR    (B)
EWUHLDL  EQU   X'80'              FORMS HOLDER INTERLOCK (G)
EWUBDWCG EQU   X'80'              INVALID WCGM ID     (G)
EWUPLBP  EQU   X'40'              PLB PARITY ERROR    (B)
EWUXFRCK EQU   X'40'              TRANSFER CHECK      (G)
EWUWCG00 EQU   X'40'              NO ID FOR WCGM 00   (G)
EWUFCBP  EQU   X'20'              FCB PARITY ERROR    (B)
EWUFUSCK EQU   X'20'              FUSER CHECK         (G)
EWUBDCPY EQU   X'20'              INVALID COPY MOD    (G)
EWUCFS   EQU   X'10'              CFS CHECK    (G)
EWUBDFOV EQU   X'10'              INVALID FORMS OVERLAY SEQ (G)
EWUPRCCK EQU   X'08'              PROCESS CHECK          (G)
EWUBDGRM EQU   X'08'              INVALID GRAPHIC MOD (G)
EWUWCPAR EQU   X'04'              WCGM DATA PARITY ERROR (G)
EWULINOV EQU   X'01'              LINE OVER-RUN       (G)
EWUSN3   DS    X                  4TH SENSE BYTE
EWUPRRDY EQU   X'80'              PRINTER READY       (G)
EWUPGEPT EQU   X'40'              PAGE BUFFER EMPTY   (G)
EWUBLKDC EQU   X'20'              BLOCK DATA CHECK    (G)
EWUTHRED EQU   X'10'              BURSTER SS THREADED (G)
EWUSYRST EQU   X'08'              SYSTEM RESTART REQUIRED  (G)
EWUPCADV EQU   X'04'              PC ADVANCE ENABLED  (G)
EWUSN4   DS    X                  5TH SENSE BYTE
EWUSN5   DS    X                  6TH SENSE BYTE
         DS    XL2                RESERVED
EWUWORK  DS    0D,120X            RESERVED FOR COMPILER ASSIGNED TEMPS
         MEND
**/
*@LIST POP;
* %IF EWUSYS='VS1' %THEN %GO TO EWUA;
* DCL
*  1 EWUMAP CHAR(128)BDY(DWORD)DEF(EWAIERP),
* %GO TO EWUD;
* %EWUA:;
*   DCL 1 EWUMAP CHAR(24) BASED(UCBSNADR),
* %EWUD:;
*   2 EWUSN0 BIT(8),            /*1ST SENSE BYTE                     */
*    3 EWUCREJ BIT(1),          /*COMMAND REJECT      (ALL)          */
*    3 EWUINT  BIT(1),          /*INTERVENTION REQD.  (ALL)          */
*    3 EWUBUSO BIT(1),          /*BUS OUT             (ALL)          */
*    3 EWUEQCK BIT(1),          /*EQUIPMENT CHECK     (ALL)          */
*    3 EWUDTCK BIT(1),          /*DATA CHECK          (ALL)          */
*    3 EWUBUFP BIT(1),          /*BUFFER PARITY       (A,B)          */
*     4 EWUOVRN BIT(1),         /*OVERRUN             (C)            */
*    3 EWULDCK BIT(1),          /*LOAD CHECK          (B,G)          */
*     4 EWUUSEQ BIT(1),         /*UNUSUAL SEQUENCE    (D)            */
*      5 EWUABFR BIT(1),        /*ABNORMAL FMT RESET  (E)            */
*    3 EWUCH9  BIT(1),          /*CHANNEL 9           (A,B,G)        */
*     4 EWUPEK  BIT(1),         /*PERMANENT ERROR KEY (E)            */
*   2 EWUSN1 BIT(8),            /*2ND SENSE BYTE                     */
*    3 EWUCRTRY BIT(1),         /*COMMAND RETRY       (B)            */
*     4 EWUPERM BIT(1),         /*PERMANENT ERROR     (E)            */
*      5 EWUIVCMD BIT(1),       /* INVALID COMMAND    (G)            */
*       6 EWUNORDY BIT(1),      /* NOT READY          (G)            */
*        7 EWUCMD BIT(1),       /* BUS OUT PARITY CMD (G)            */
*         8 EWUHARD BIT(1),     /* HARDWARE ERROR     (G)            */
*          9 EWUUNPRT BIT(1),   /* UNPRINTABLE CHAR   (G)            */
*           10 EWUINVLN BIT(1), /* INCORRECT LENGTH   (G)            */
*    3 EWUPCK BIT(1),           /*PRINT CHECK         (B)            */
*     4 EWUARTRY BIT(1),        /*AUTOMATIC RETRY     (E)            */
*       5 EWUOPCK BIT(1),       /* OPERATION CHECK     (G)           */
*        6 EWUDATA BIT(1),      /* BUS OUT PARITY DATA (G)           */
*         7 EWUPRM BIT(1),      /* PERMANENT ERROR    (G)            */
*          8 EWUERLPI BIT(1),   /* INCORRECT LPI IN FCB (G)          */
*    3 EWUPQ BIT(1),            /*PRINT QUALITY       (B)            */
*     4 EWUMOT BIT(1),          /*MOTION ERROR        (E)            */
*       5 EWUTONFL BIT(1),      /* TONER COLLECTOR FULL  (G)         */
*        6 EWUELGFL BIT(1),     /* ERROR LOG FULL     (G)            */
*         7 EWUNOTRT BIT(1),    /* NO TRANSLATE TABLE (G)            */
*          8 EWUHLFER BIT(1),   /* FCB HALF INCH ERROR (G)           */
*    3 EWULNPOS BIT(1),         /*LINE POSITION       (B)            */
*     4 EWUIRTRY BIT(1),        /*RETRY AFTER INT.REQ.(E)            */
*      5 EWUNOTNE BIT(1),       /* TONER EMPTY        (G)            */
*       6 EWUCANCL BIT(1),      /* CANCEL KEY         (G)            */
*        7 EWUCHCOD BIT(1),     /* NO MATCH FCB CHAN CODE (G)        */
*         8 EWUBADCC BIT(1),    /* FCB INVALID CHAN CODES (G)        */
*    3 EWUFORM BIT(1),          /*FORMS CHECK         (B)            */
*     4 EWUDEVRQ BIT(1),        /* DEVELOPER REPL REQUIRED   (G)     */
*      5 EWUMLTCH BIT(1),       /* MULTIPLE CHAR      (G)            */
*       6 EWUFCBLN BIT(1),      /* FCB LENGTH ERROR   (G)            */
*    3 EWUSUPR BIT(1),          /*COMMAND SUPPRESS    (B)            */
*     4 EWUEOFRM BIT(1),        /* END OF FORMS       (G)            */
*       5 EWUNOWCG BIT(1),      /* WCGM NOT LOADED    (G)            */
*    3 EWUMECMO BIT(1),         /*MECHANICAL MOTION   (B)            */
*     4 EWUOUTFL BIT(1),        /* OUTPUT FULL        (G)            */
*      5 EWUBADTC BIT(1),       /* INVALID TRANSLATE CODES (G)       */
*   2 EWUSN2 BIT(8),            /*3RD SENSE BYTE                     */
*    3 EWUUCSBP BIT(1),         /*UCS PARITY ERROR    (B)            */
*     4 EWUHLDL  BIT(1),        /* FORMS HOLDER INTERLOCK (G)        */
*      5 EWUBDWCG BIT(1),       /* INVALID WCGM ID    (G)            */
*    3 EWUPLBP BIT(1),          /*PLB PARITY ERROR    (B)            */
*     4 EWUXFRCK BIT(1),        /* TRANSFER CHECK     (G)            */
*      5 EWUWCG00 BIT(1),       /* NO ID FOR WCGM 00  (G)            */
*    3 EWUFCBP BIT(1),          /*FCB PARITY ERROR    (B)            */
*     4 EWUFUSCK BIT(1),        /* FUSER CHECK        (G)            */
*      5 EWUBDCPY BIT(1),       /* INVALID COPY MOD   (G)            */
*    3 EWUCFS BIT(1),           /* CFS CHECK   (G)                   */
*     4 EWUBDFOV BIT(1),        /* INVALID FORMS OVERLAY SEQ (G)     */
*    3 EWUPRCCK BIT(1),         /* PROCESS CHECK (G)                 */
*     4 EWUBDGRM BIT(1),        /* INVALID GRAPHIC MOD (G)           */
*    3 EWUWCPAR BIT(1),         /* WCGM DATA PARITY ERROR (G)        */
*    3 * BIT(1),                /* RESERVED  (G)                     */
*    3 EWULINOV BIT(1),         /* LINE OVER-RUN      (G)            */
*   2 EWUSN3 BIT(8),            /*4TH SENSE BYTE      (G)            */
*    3 EWUPRRDY BIT(1),         /* PRINTER READY      (G)            */
*    3 EWUPGEPT BIT(1),         /* PAGE BUFFER EMPTY  (G)            */
*    3 EWUBLKDC BIT(1),         /* BLOCK DATA CHECK   (G)            */
*    3 EWUTHRED BIT(1),         /* BURSTER SS THREADED (G)           */
*    3 EWUSYRST BIT(1),         /* SYSTEM RESTART REQ (G)            */
*    3 EWUPCADV BIT(1),         /* PC ADVANCE ENABLED (G)            */
*   2 EWUSN4 BIT(8),            /*5TH SENSE BYTE                     */
*   2 EWUSN5 BIT(8),            /*6TH SENSE BYTE                     */
*   2 EWUSN6 BIT(8),            /* 7TH SENSE BYTE                    */
*   2 EWUSN7 BIT(8),            /* 8TH SENSE BYTE                    */
*   2 EWUSN8 BIT(8),            /* 9TH SENSE BYTE                    */
*   2 EWUSN9 BIT(8),            /* 10TH SENSE BYTE                   */
*   2 EWUSN10 BIT(8),           /* 11TH SENSE BYTE                   */
*   2 EWUSN11 BIT(8),           /* 12TH SENSE BYTE                   */
*   2 EWUSN12 BIT(8),           /* 13TH SENSE BYTE                   */
*   2 EWUSN13 BIT(8),           /* 14TH SENSE BYTE                   */
*   2 EWUSN14 BIT(8),           /* 15TH SENSE BYTE                   */
*   2 EWUSN15 BIT(8),           /* 16TH SENSE BYTE                   */
*   2 EWUSN16 BIT(8),           /* 17TH SENSE BYTE                   */
*   2 EWUSN17 BIT(8),           /* 18TH SENSE BYTE                   */
*   2 EWUSN18 BIT(8),           /* 19TH SENSE BYTE                   */
*   2 EWUSN19 BIT(8),           /* 20TH SENSE BYTE                   */
*   2 EWUBKUP FIXED(15),        /* PAGE BACK UP CNT FOR PAPER JAM    */
*    3 EWUSN20 BIT(8),          /* 21TH SENSE BYTE                   */
*    3 EWUSN21 BIT(8),          /* 22ND SENSE BYTE                   */
*   2 EWUSN22 BIT(8),           /* 23RD SENSE BYTE                   */
*  %IF EWUSYS='VS1' %THEN %GO TO EWUC;
*   2 EWUSN23 BIT(8),           /* 24TH SENSE BYTE                   */
*   2 EWUWORK CHAR(104)BDY(DWORD);/*RESERVED FOR COMPILER TEMPS      */
*  %GO TO EWUG;
* %EWUC:;
*   2 EWUSN23 BIT(8);           /* 24TH SENSE BYTE                   */
* %EWUG:;
