         MACRO
         HEWLDCOM  &MAXEXT=32,&EXTSIZ=32
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
*
*    02/25/72          LEVEL=21
*
*STATUS - CHANGE LEVEL 021                                            *
*         TSO CHANGES FOR SYSTERM,INCORE DATA SET, PASSED SYSLIB,     *
*                         AND IDENTIFICATION                          *
*         APAR FIX 27445 - ZERO-LENGTH CSECTS OKAY                    *
*FUNCTION/OPERATION: TO PROVIDE A COMMUNICATIONS AREA FOR THE LOADER. *
*    ALL DYNAMIC DATA USED BY THE PROCESSING PORTION OF THE LOADER    *
*    IS CONTAINED IN THIS AREA. IEWLIOCA ALLOCATES SPACE FOR THIS     *
*    DATA AREA AND INITIALIZES IT. IT IS REFERENCED THROUGH REGISTER  *
*    11.                                                              *
*ENTRY POINTS: NOT APPLICABLE                                         *
*INPUT/OUTPUT: NOT APPLICABLE                                         *
*EXTERNAL ROUTINES: NOT APPLICABLE                                    *
*EXITS: NOT APPLICABLE                                                *
*TABLES/WORKAREAS:                                                    *
*ATTRIBUTES: NOT APPLICABLE                                           *
*NOTES: THE ADDRESS OF IEWLDCOM IS PLACED IN REGISTER 11 BY IEWLIOCA  *
*    AND KEPT THERE FOR USE BY ALL MODULES IN THE PROCESSING PORTION  *
*    OF THE LOADER                                                    *
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
         SPACE 3
HEWLDCOM DSECT
CMXDBLWD DS    D         TEMPORARY DOUBLE WORD
CMADCON  EQU   CMXDBLWD  ALIGNMENT AREA FOR RELOCATION
CMFSTSAV DS    F         POINTER TO FIRST SAVE AREA
CMBEGADR DS    F         DEFAULT ENTRY POINT TO MODULE
CMRDCBPT DS    F         INPUT DCB POINTER
CMWDCBPT DS    F         OUTPUT DCB POINTER
CMTDCBPT DS    F         SYSTERM DCB POINTER
CMRDECPT DS    F         INPUT DECB POINTER
CMWDECPT DS    F         OUTPUT DECB POINTER
CMGETREC DS    F         INPUT LOGICAL RECORD POINTER
CMPUTREC DS    F         OUTPUT LOGICAL RECORD POINTER
CMTRMREC DS    F         SYSTERM BUFFER POINTER
CMNXTTXT DS    F         NEXT ADDRESS TO BE ASSIGNED TO A CSECT
CMLSTTXT DS    F         HIGHEST TEXT ADDRESS ASSIGNED TO CURRENT CSECT
CMLOWTBL DS    F         LOWEST ADDRESS ASSIGNED FOR LOADER TABLES
CMHITBL  DS    F         HIGHEST STORAGE ADDRESS AVAILABLE TO LOADER
CMIOLST1 DS    F         OPEN LIST DCB POINTER
CMIOLST2 DS    F         OPEN LIST DCB POINTER
CMIOLST3 DS    F         OPEN LIST DCB POINTER
CMCORE1  DS    F         CORRESPONDS TO CMNXTTXT FOR PRE-LOADED TEXT
CMCORE2  DS    F         CORRESPONDS TO CMLSTTXT FOR PRE-LOADED TEXT
CMTOPCOD DS    F         TOP OF LOADED CODE BEFORE COMMON ALLOCATED
CMLIBEOD DS    F         PASSED SYSLIB EXIT ROUTINE ADDRESSES
CMLIBSYN DS    F             - SYNAD ERROR ROUTINE POINTER
CMLIBEXL DS    F             - EXIT LIST POINTER
CMBLKSIZ DS    H         BLOCKSIZE OF CURRENT INPUT OBJECT MODULE
CMMAXLNE DS    H         MAXIMUM LINE-COUNT  (SYSPRINT)
*            NEXT THREE OPTIONS MUST STAY IN THIS ORDER.  THEY
*                          ARE REFERENCED TOGETHER.
CMMAPLIN DS    H         LENGTH OF MAP LINE
CMWLRECL DS    H         SYSPRINT RECORD SIZE
CMMAXLST DS    H         MAXIMUM LENGTH OF INVALID OPTIONS LIST
         DS    0D
*
CMINITCM EQU   *         BEGINNING OF AREA COMMON TO INITMAIN
*
CMMAINPT DS    F         VARIABLE-CONDITIONAL GETMAIN ADDRESS
CMMAINSZ DS    F         VARIABLE-CONDITIONAL GETMAIN SIZE
CMPRNTDD DS    CL8       PRINT DDNAME
CMLINDD  DS    CL8       PRIMARY INPUT DDNAME
CMLIBDD  DS    CL8       LIBRARY DDNAME
CMTERMDD DS    CL8       DIAGNOSTIC DDNAME
CMEPNAME DS    CL8       ENTRY POINT NAME
CMPGMNM  DS    CL8       PROGRAM NAME
CMLINDCB DS    F         PASSED SYSLIN DCB POINTER
CMLIBDCB DS    F         PASSED SYSLIB DCB POINTER
*
*    PARAMETER FLAGS PASSED FROM PARAMETER LIST
*
CMPRMFLG DS    X         PARAMETER FLAGS
CQRES    EQU   X'01'     RES/NORES
CQMAP    EQU   X'02'     MAP/NOMAP
CQPRINT  EQU   X'04'     PRINT/NOPRINT
CQLET    EQU   X'08'     LET/NOLET
CQCALL   EQU   X'10'     CALL/NOCALL
CQEPNAME EQU   X'20'     ENTRY POINT NAME DEFINED
CQEPADDR EQU   X'40'     ENTRY POINT ADDRESS DEFINED
CQTERM   EQU   X'80'     TERM/NOTERM
*
*    INPUT - OUTPUT FLAGS
*
CMIOFLGS DS    X         I/O FLAGS
CQEOCB   EQU   X'01'     END OF CONCATENATION
CQEOFB   EQU   X'02'     END OF FILE
CQEOFSB  EQU   X'04'     END OF FILE SIGNIFICANCE
CQRECFM  EQU   X'08'     INPUT RECORD FORMAT -- 0 - FIXED
*                                               1 - UNDEFINED
CQUNDEF  EQU   CQRECFM   SEPARATE NAME IN ALLOCATION FOR UNDEFINED
CQFIXED  EQU   X'10'     FIXED RECORD FORMAT
CQIGNCR  EQU   X'20'     IGNORE CONTROL RECORD ON LOAD MODULE
CQIOERR  EQU   X'40'     AN I/O ERROR HAS OCCURRED
*
CMFLAG3  DS    X         ASSORTED FLAGS
CQTS     EQU   X'02'     TIME-SHARING ENVIRONMENT
CQPGMNM  EQU   X'04'     PROGRAM NAME PASSED
CQPASLIN EQU   X'08'     SYSLIN DCB PASSED
CQPASLIB EQU   X'10'     SYSLIB DCB PASSED
CQINCORE EQU   X'20'     WE'RE PROCESSING INCORE SYSLIN
CQIDEN   EQU   X'40'     ENTERED AT IEWLOAD. IDENTIFICATION WANTED
CMFLAG4  DS    X         ASSORTED FLAGS
CQESDS   EQU   X'01'     ESDS HAVE BEEN ENCOUNTERED
CQMOD    EQU   X'02'     MOD CARD HAS BEEN ENCOUNTERED
CQNOEX   EQU   X'04'     EXECUTION NOT SCHEDULED
CQMINI   EQU   X'08'     MINI-CESD BUILT
CQMVT    EQU   X'10'     MVT OPERATING
CQCOMMON EQU   X'20'     COMMON RECEIVED
CQTRMOPN EQU   X'40'     SYSTERM OPEN
CQIDONE  EQU   X'80'     IDENTIFICATION ACCOMPLISHED
CMSYSTYP DS    F         SYSTEM TYPE STORED HERE BY HEWLDLIB     YM2946
*                        LAST THREE BYTES ARE UNUSED SPACE
CMRSAVE  DS    9F        LIB WILL SAVE REGS HERE WHEN CALLING    YM2946
*                        LPA SEARCH ROUTINE (IEAVVMSR) IN VS2
*                        REGS ARE IN ORDER 2-10
*
         DS    0D
*
CMINTZRO EQU   *      ALL FOLLOWING THIS POINT IS INITIALIZED TO ZERO
*
CMXLCHN  DS    F         POINTER TO CHAIN OF EXTENTS
CMBITMAP DS    F         ERROR BIT MAP
CMERLIST DS    F         POINTER TO ERRORS ENCOUNTERED DURING OPEN
CMRLDCHN DS    F         FREE RLD ENTRY CHAIN (8 BYTES/ENTRY)
CMESDCHN DS    F         FREE CESD ENTRY CHAIN (20 BYTES/ENTRY)
CMEPADDR DS    F         ENTRY POINT ADDRESS TO LOADED PROGRAM
CMTRCTRL DS    &MAXEXT.F      TRANSLATE CONTROL LIST
CMBLDLPT DS    F         BLDL POINTER
CMCXDPT  DS    F         POINTER TO CXD ADDRESSES
CMFRECOR DS    F         FREE STORAGE CHAIN
CMMODLNG DS    F         LENGTH OF MODULE CURRENTLY BEING PROCESSED
CMOBJST  DS    F         STARTING POINT FOR OBJECT MODULE       SA49491
CMTEMPCH DS    F         POINTER TO LOAD CHAIN ENTRY TO BE FREED
CMEPCESD DS    F         CESD LINE ADDRESS OF THE ENTRY POINT NAME
CMPREVPT DS    F         PREVIOUS ELEMENT IN A CHAIN FOR INSERT-DELETE
CMLOADCH DS    F         TEMPORARY CHAIN FOR ESD'S IN A LOAD MODULE
CMESDSAV DS    F         CESD REG SAVE AREA FOR REL             SA56381
*
*    CESD TYPE CHAIN POINTERS -- THEY MUST REMAIN IN ORDER OF
*   TYPE NUMBER FOR INDEXING PURPOSES
*
CMTYPCHN EQU   *         INDEX POINT FOR THE VECTOR TABLE
CMSDCHN  DS    F         TYPE 0 - SECTION DEFINITION
CMLDCHN  DS    F         TYPE 1 - LABLE DEFINITION
CMERCHN  DS    F         TYPE 2 - EXTERNAL REFERENCE
CMLRCHN  DS    F         TYPE 3 - LABLE REFERENCE
CMPCCHN  DS    F         TYPE 4 - PRIVATE CODE
CMCMCHN  DS    F         TYPE 5 - COMMON
CMPRCHN  DS    F         TYPE 6 - PSEUDO REGISTER
CMNULCHN DS    F         TYPE 7 - NULL ENTRY
*
CMCURRID DS    H         ESDID COUNTER
CMLNECNT DS    H         CURRENT LINE-COUNT  (SYSPRINT)
CMBLDLNO DS    H         NUMBER OF BLDL ENTRIES
CMWTBFCT DS    H         HORIZONTAL BYTE COUNT IN PRINT RECORD
CMNUMXS  DS    H         NUMBER OF EXTENTS
*
CQMAXEXT EQU   &MAXEXT   MAXIMUM TRANSLATION TABLE EXTENTS
CQEXTSIZ EQU   &EXTSIZ   TRANSLATION TABLE EXTENT SIZE (NUMBER OF ENT)
*
CMLIBFLG DS    X         AUTO-CALL AND LOAD MODULE PROCESSOR FLAGS
CQKEEPS  EQU   X'01'     KEEP SOME TEXT FROM THIS RECORD
CQDELETE EQU   X'02'     DELETE SOME TEXT FROM THIS RECORD
CQAUTOC  EQU   X'04'     AUTO-CALL IS IN PROCESS
CQCESDR  EQU   X'08'     CESD HAS BEEN RECEIVED FOR LOAD MODULE
CQNOTXT  EQU   X'10'     TEXT HAS BEEN RECEIVED
CQLPASRH EQU   X'20'     LPA RESOLUTION POSSIBLE
CQFIRST  EQU   X'40'     FIRST REC FROM LOAD MODULE WAS CESD
CQMFTLPA EQU   X'80'     MFT LINK PACK AREA
*
CMRELFLG DS    X         RELOCATION AND OBJECT MODULE PROCESSOR FLAGS
CQESD    EQU   X'01'     ESD ROUTINE IS CALLER TO ID TRANSLATE ROUTINE
CQNOLNG  EQU   X'02'     LENGTH NOT YET RECEIVED FOR CURRENT CSECT
CQDELINK EQU   X'04'     DELINKING IS REQUIRED FOR COMMON
CQLIB    EQU   X'08'     RESOLUTION FROM SYSLIB IN PROCESS
CQNOEND  EQU   X'10'     END CARD HAS BEEN RECEIVED
CQINPUT  EQU   X'20'     INPUT HAS BEEN RECEIVED
CQENTRY  EQU   X'40'     RLD IS FOR ENTRY POINT
CQNOLNTX EQU   X'80'     TEXT RECEIVED FOR NO-LENGTH CSECT      27445
*
CMSTATUS DS    X         LOADER STATUS FLAG
CQPRTOPN EQU   X'01'     PRINT DCB ALLOCATED FOR
CQLIBOPN EQU   X'02'     LIBRARY DCB OPEN
CQABORT  EQU   X'04'     ABORT LOADING
CQREJOPT EQU   X'08'     INVALID OPTIONS ARE TO BE PRINTED
CQOPNERR EQU   X'10'     ERRORS WERE ENCOUNTERED DURING OPEN
CQRETURN EQU   X'20'     CALLER TO ERROR ROUTINE MUST REGAIN CONTROL
CQMSGSAV EQU   X'40'     REQUEST OPEN-EXIT TO SAVE ERROR MESSAGES
CQPRTDCB EQU   X'80'     PRINT DCB IS OPEN
*
CMPRTCTL DS    X         INDEX FOR PRINTER CARRIAGE CONTROL
*
CMOPTECT DS    X         COUNT OF INVALID OPTIONS TO BE PRINTED
         DS    0D
CQINTSIZ EQU   *-CMINTZRO SIZE OF ZERO INITIALIZATION AREA
*
CQCMSIZE EQU *-HEWLDCOM SIZE OF COMMUNICATION AREA
         EJECT
*    ERROR CODE DEFINITIONS --- THESE CODES CORRESPOND TO BIT POSITIONS
*   IN THE ERROR BIT-MAP NUMBERED FROM RIGHT TO LEFT BEGINNING WITH 0.
*   THE CODES (AND CORRESPONDING BIT-MAP POSITIONS) ARE IN ORDER OF
*   INCREASING SEVERITY.
*
ERCODES  DSECT
*
ERRELO1  DS    X    WARNING - UNRESOLVED ER (NCAL SPECIFIED)          1
ERENTR1  DS    X    NO ENTRY POINT RECEIVED                           1
ERINPT8  DS    X    CARD RECEIVED NOT AN OBJECT CARD                  1
*
ERINPT10 DS    X    END CARD MISSING                                  2
ERINPT2  DS    X    LENGTH NOT SPECIFIED                              2
ERRELO2  DS    X    ERROR - UNRESOLVED ER                             2
ERINPT4  DS    X    DOUBLY DEFINED ESD                                2
ERINPT5  DS    X    INVALID 2 BYTE ADCON                              2
ERINPT7  DS    X    INVALID ID RECEIVED                               2
ERINPT9  DS    X    INVALID OBJECT CARD RECEIVED                      2
ERINPT1  DS    X    INPUT BLKSIZE IS INVALID                          2
*
ERINPT3  DS    X    NO TEXT                                           3
ERENTR2  DS    X    ENTRY POINT RECEIVED BUT NOT MATCHED              3
ERIOUT4  DS    X    ERROR ON BLDL                                     3
ERINPT6  DS    X    INVALID RECORD FROM LOAD MODULE                   3
*
ERIOUT3  DS    X    UNACCEPTABLE RECFM (VARIABLE ON INPUT)            4
ERIOUT1  DS    X    DDNAME CANNOT BE OPENED                           4
ERIOUT2  DS    X    SYNCHRONOUS ERROR                                 4
ERSIZE2  DS    X    PROGRAM TOO LARGE                                 4
ERSIZE3  DS    X    INPUT ESDID TOO LARGE                             4
ERIDEN1  DS    X    IDENTIFY FAILED. DUPLICATE PROGRAM NAME           4
ERIDEN2  DS    X    IDENTIFY FAILED.  ALL OTHER RETURN CODES          4
         EJECT
*   PRINTER CARRIAGE CONTROL DEFINITIONS FOR ASA CODE
*
*   ANY CHANGE IN THE DISPLACEMENTS DEFINED HERE REQUIRES A
*  CORRESPONDING CHANGE IN THE 'PRTCNTRL' TABLE IN IEWLIOCA
*
*
*
CTSPACE1 EQU   0         SPACE 1 BEFORE PRINTING
CTSPACE2 EQU   2         SPACE 2 BEFORE PRINTING
CTSPACE3 EQU   4         SPACE 3 BEFORE PRINTING
CTEJECT  EQU   6         EJECT BEFORE PRINTING
         MEND
