         TITLE    'HEWLFBTP  BIT MAP PROCESSOR'
HEWLFBTP CSECT
***********************************************************************
*037300-041500,053400,069500,139500-148600,168900-172400         S21016
*220700-227700,304000-311700,912300-935400                       S21016
*900400-911600                                                   S01904
*052700                                                          XM7010
*C226700,A314400,A936000                                         A52450
*A238700,C532900,C534300                                        OY00131
*C214400,C238700,936080                                 OX03510,OY03043
*C215800,C232600,I936565                                OX04280,OY03413
*C218600,C236800,I314440,I889900                                XA04649
* SEE FIX FOR XA04649                                           YA03751
***********************************************************************
*                                                                     *
*FUNCTION: PRINTS ENGLISH LANGUAGE MESSAGES CORRESPONDING TO          *
*   ERRROR CODES GENERATED.                                           *
*                                                                     *
*ENTRY POINTS   HEWLFBTP ONLY                                         *
*                                                                     *
*INPUT: BIT MAP (2 WORDS) IN ALL PURPOSE TABLE.                       *
*                                                                     *
*OUTPUT: ON SYSPRINT.                                                 *
*                                                                     *
*EXITS: NORMAL RETURN ONLY.                                           *
*                                                                     *
*TABLES:                                                              *
*                                                                     *
*TABLE CONTAINS INCREMENTS INTO THE LIST ARRAY. THE LIST ARRAY IS USED*
*TO COMPOSE THE PHRASE TABLE.                                         *
*                                                                     *
*PHRASES CONTAINS PHRASES WHICH ARE ASSEMBLED TO FORM MESSAGES.       *
*                                                                     *
*REUSABLE.                                                            *
*                                                                     *
ENDFLAG  EQU   X'FF'
SINGLE   EQU   X'09'                   PRINT AND SINGLE SPACE
DOUBLE   EQU   X'13'                   IMMEDIATE DOUBLE SPACE
TRIPLE   EQU   X'19'                   PRINT AND TRIPLE SPACE
SKIP     EQU   X'8B'                   IMMEDIATE SKIP TO CHANNEL 1
SKPLN    EQU   X'0B'                   IMMEDIATE SKIP ONE LINE
TABENTSZ EQU   2
LISENTSZ EQU   3
NUMBLINS EQU   55                      LINES PER PAGE
RENTRY   EQU   1
APT      EQU   2
REXEC    EQU   3
NUM      EQU   3
TSO      EQU   X'80'                   TSO SWITCH IN APTSWS
TERM     EQU   X'02'                   TERM SWITCH IN NEWSW
TERMWRT  EQU   X'04'                   WRITE TO TERM. SWITCH
RBITMAP1 EQU   4
RBITMAP2 EQU   5
RINDEX   EQU   6
RLIMIT   EQU   7
RTEST1   EQU   8
RPRINT   EQU   8
RDCB     EQU   9
RTEST2   EQU   9
RTABLE   EQU   10
RINTRET  EQU   11
RBASE    EQU   12
RSAVREG  EQU   13
RBUF     EQU   14
RLIST    EQU   15
         SPACE 1                                                 S21016
******SYMBOLIC EQUATES FOR HANDLING BITMAP2 MESSAGES******       S21016
         SPACE 1                                                 S21016
SWON     EQU   X'01'                   MASK FOR BITMAP2 SWITCH   S21016
SWOFF    EQU   X'FE'                   IMMEDIATE TO TURN OFF     S21016
*                                      BITMAP2 SWITCH            S21016
ONE      EQU   1                       VALUE OF 1                S21016
BM2LN    EQU   16                      LENGTH OF BITMAP+BITMAP2  S21016
         USING *,RLIST
         USING APTDSECT,APT            ESTABLISH ADDRESSABILITY WITH
*                                      APT
*
*        ESTABLISH BASE ADDRESSABILITY AND SAVE REGISTERS.
*
BTP000   BC    15,MODID+6              BRANCH AROUND MODULE IDENT
MODID    DC    C'02MBTP'
         STM   RBUF,RBASE,SPACES+12    SAVE REGS.
         LA    RSAVREG,REGSA           LOAD SAVE AREA POINTER
         LR    RBASE,RLIST             ESTABLISH
         USING BTP000,RBASE            ADDRESSABILITY
         DROP  RLIST
         L     RPRINT,TXTIO            LOAD ADDRESS OF PRINT BUFFER
         MVC   0(2,RPRINT),P086        SET TWO BLANKS FOR FINAL PRINT
         MVC   2(120,RPRINT),1(RPRINT) BLANK OUT BUFFERS         XM7010
         NC    BITMAP(BM2LN),BITMAP    ARE ANY MESSAGES LOGGED?  S21016
         BC    8,BTP074                NO, EXIT
*        GIVEN AT LEAST ONE MESSAGE,PRINT HEADER LINE
         MVI   0(RPRINT),DOUBLE        SET FOR DOUBLE SPACE
         TM    APTSWS,TSO          IS TSO IN EFFECT?
         BC    1,BTP005            YES--BRANCH AROUND LINE COUNT
         LH    REXEC,LINECNT           GET NO. OF LINES ON OUTPUT PAGE
         SH    REXEC,CNTDEC            DECREMENT LINE COUNT BY 5
         BC    2,BTP005                BRANCH IF GREATER THAN ZERO
         LA    REXEC,52                IF NOT, SET LINE COUNT T0 52 FOR
*                                      NEW PAGE
         MVI   0(RPRINT),SKIP          SET FOR EJECT TO NEW PAGE
BTP005   LH    NUM,HEWLCWBB+14     LOAD LRECL
         BAL   RINTRET,BTP060
         STH   REXEC,LINECNT           STORE LINE COUNT
         MVC   2(120,RPRINT),1(RPRINT) BLANK OUT BUFFERS
         MVC   46(28,RPRINT),BTPHDR    MOVE IN HEADER
         MVI   0(RPRINT),TRIPLE        SET FOR TRIPLE SPACE
         BAL   RINTRET,BTP060          TO PRINT ROUTINE
*
*        INITIALIZE REGISTERS
*
         MVI   CHARTEST,C'0'           INITIALIZE SEVERITY LEVEL
         NI    BTP2SW,SWOFF            TURN OFF BITMAP2 SWITCH   S21016
         LM    RBITMAP1,RBITMAP2,BITMAP  GET BITMAP
         SR    REXEC,REXEC         ZERO OUT REGISTER
         XC    NCHAR(2),NCHAR      ZERO OUT COUNTER
         LA    RINDEX,TABENTSZ         SET INCREMENT FOR LOOPING THRU
*                                      TABLE
         LA    RLIMIT,TABLEND          SET LIMIT FOR LOOPING THROUGH
*                                      TABLE
*
*        LOOP ON SEVERITY LEVEL
*
BTP007   SR    RTEST1,RTEST1           INITIALIZE TEST REG. TO ZERO
         LA    RTEST2,1                TURN ON LOW-ORDER BIT IN REG.-
*                                      PAIR FOR TESTING BITMAP
         LA    RTABLE,TABLE            INITIALIZE TABLE ENTRY POINTER
*
*        LOOP TESTING SUCCESSIVE BITS FOR NEED FOR ERROR MESSAGES.
*
BTP010   STM   RTEST1,RTEST2,BITMAP    SAVE BIT CONFIGURATION TO BE
*                                      TESTED
         L     RBUF,TXTIO              GET ADDRESS OF PRINT BUFFER
         MVI   1(RBUF),C' '            SET BLANK IN FIRST CHARACTER OF
*                                      LINE
         MVC   2(240,RBUF),1(RBUF)     PROPOGATE BLANKS THROUGH BUFFER
         MVC   4(4,RBUF),IEWHEAD       MOVE IN 'IEW0' MESSAGE HEADER
         LA    RBUF,8(0,RBUF)          POINT TO LOCATION TO PLACE MSG.#
         NR    RTEST2,RBITMAP2         'AND' WORD 2 OF BITMAP WITH TEST
*                                      BIT
         BC    4,BTP020                BRANCH IF MATCH
         NR    RTEST1,RBITMAP1         TEST WORD ONE OF BITMAP
         BC    8,BTP040                BRANCH IF NO MATCH
*
*        ASSEMBLE INDICATED MESSAGE
*
BTP020   LH    RLIST,0(0,RTABLE)       GET INDEX TO APPROPRIATE MESSAGE
*                                      LIST
         LA    RLIST,LIST(RLIST)       ADD BEGINNING LIST ADDRESS TO
*                                      INDEX
BTP030   MVC   CRNO(2),1(RLIST)        GET INDEX TO MSG. PHRASE
         LH    RENTRY,CRNO             SET POINTER TO MSG. PHRASE
         LA    RENTRY,PHRASES(RENTRY)  ADD STARTING ADDR. OF PHRASES TO
*                                      PTR
         IC    REXEC,0(0,RLIST)        GET NUMBER OF CHARACTERS IN
*                                      PHRASE-1
         EX    REXEC,BTP050            MOVE PHRASE INTO BUFFER
         LA    RBUF,2(RBUF,REXEC)      POINT TO LOC. FOR NEXT PHRASE
         LA    RLIST,LISENTSZ(0,RLIST) POINT TO NEXT ENTRY IN MSG. LIST
         CLI   0(RLIST),ENDFLAG        IS MSG. COMPLETE?
         BC    7,BTP030                IF NOT CONTINUE LOOP
         BCTR  RBUF,0                  IF COMPLETE, END
         MVI   0(RBUF),C'.'            SENTENCE WITH '.'
*
*        PRINT THE ASSEMBLED MESSAGE.
*
         L     RPRINT,TXTIO
         CLC   10(1,RPRINT),CHARTEST   TEST FOR THIS SEVERITY
         BC    7,BTP040                NO, OMIT PRINTING
         SR    RBUF,RPRINT         GET NO. CHAR. IN MESSAGE
         STH   RBUF,NCHAR          SAVE
         TM    APTSWS,TSO          TSO IN EFFECT?
         BC    1,BTP035A           YES - SKIP LINE COUNT
BTP031   LH    RDCB,LINECNT            PICK UP LINE CNT
         BCT   RDCB,BTP035             DECREMENT AND TEST FOR ZERO
         LA    RDCB,NUMBLINS           SET TO NUMBER OF LINES PER PAGE
         MVI   0(RPRINT),SKIP          SET TO SKIP TO ONE
         BAL   RINTRET,BTP060          TO PRINT ROUTINE
BTP035   STH   RDCB,LINECNT            RESTORE LINE COUNTER
BTP035A  MVI   0(RPRINT),SINGLE    SET CARRIAGE CONTROL
         LH    RTEST2,HEWLCWBB+14  GET LRECL
         AR    RTEST2,RPRINT       GET END OF PRINT LINE
         BCTR  RTEST2,0            ADJUST FOR CARRIAGE CONTROL
BTP035B  CLI   0(RTEST2),C' '      IS END OF LINE A BLANK
         BE    BTP035C             YES - BRANCH
         BCT   RTEST2,BTP035B      LOOK FOR BLANK
BTP035C  LR    NUM,RTEST2
         SR    NUM,RPRINT          GET NO. CHAR. ON LINE
         BAL   RINTRET,BTP060      GO PRINT LINE
         LH    RTEST2,NCHAR
         SR    RTEST2,NUM          GET NO. OF CHAR. LEFT
         BC    12,BTP040           BRANCH IF NONE LEFT.
         LA    RTEST2,11(RTEST2)   ADJUST COUNT FOR LEADNG BLNKS
         STH   RTEST2,NCHAR        STORE COUNT
         AR    RPRINT,NUM
         LA    RTEST2,11
         SR    RPRINT,RTEST2       GET BEGINNING OF NEXT PART
         MVI   1(RPRINT),C' '
         MVC   2(10,RPRINT),1(RPRINT)   MOVE IN LEADING BLANKS
         B     BTP035A
*
*        EXECUTED MOVE.
*
BTP050   MVC   0(0,RBUF),0(RENTRY)
BTP055   MVC   0(0,RDCB),0(RPRINT)      EX.  MOVE
*
*        REINITIALIZE REGISTERS AND LOOP UNTIL LAST BIT TESTED.
*
BTP040   LM    RTEST1,RTEST2,BITMAP
         XC    NCHAR(2),NCHAR      ZERO OUT COUNTER
         SLDL  RTEST1,1
         BXLE  RTABLE,RINDEX,BTP010
         TM    BTP2SW,SWON             IS BITMAP2 SWITCH ON?     S21016
         BO    BTP042                  IF SO, BRANCH             S21016
         OI    BTP2SW,SWON             IF NOT, TURN IT ON        S21016
         STM   RBITMAP1,RBITMAP2,SAVBTP1  SAVE BITMAP            S21016
         LM    RBITMAP1,RBITMAP2,BITMAP2  LOAD BITMAP2           S21016
         LA    RTABLE,TABLE2           POINT TO BITMAP2 TABLE    S21016
         LA    RLIMIT,TAB2END          POINT TO BITMAP2 LIMIT    S21016
         SR    RTEST1,RTEST1           ZERO TEST REG.1           S21016
         LA    RTEST2,ONE              TURN ON LOW ORDER BIT IN  S21016
*                                      TEST REG.2                S21016
         B     BTP010                  GO TO SCAN BITMAP2 FOR    S21016
*                                      THE CURRENT SEVERITY      S21016
BTP042   NI    BTP2SW,SWOFF            TURN OFF BITMAP2 SWITCH   S21016
         LM    RBITMAP1,RBITMAP2,SAVBTP1  RESTORE BITMAP         S21016
         CLI   CHARTEST,C'4'           TEST FOR TOP SEVERITY
         BE    BTP074                  YES EXIT
         IC    RTEST2,CHARTEST         NO  INSERT FOR INCREMENTING
         LA    RTEST2,1(0,RTEST2)      INCREMENT BY ONE
         STC   RTEST2,CHARTEST         RESTORE UPDATED CURRENT SEVERITY
         B     BTP007                  LOOP ON THIS SEVERITY
*
*        EXIT
BTP074   L     RPRINT,HEWLCWBB+20      ADDRESS OF PRINT BUFFER
         MVI   0(RPRINT),SKPLN         IMMEDIATE SKIP ONE LINE
BTP075   BAL   RINTRET,BTP065          GO TO PRINT
         LM    RBUF,RBASE,SPACES+12    RESTORE
         BR    RBUF
BTP060   L     RDCB,HEWLCWBB+20
         EX    NUM,BTP055          MOVE IN MESSAGE.
BTP065   L     RLIST,PRNTAD            ADDRESS OF PRINT ROUTINE
         TM    NEWSW,TERM          IS TERM ON?
         BC    8,BTP065A           NO - BRANCH
         OI    HEWLCWBB+24,TERMWRT     WRITE TO TERM. NEECED
BTP065A  BALR  RBUF,RLIST
         BR    RINTRET
CNTDEC   DC    AL2(5)
NCHAR    DC    1H'0'               CHARACTER COUNTER
*
*        CONSTANTS AND BUFFERS
*
PRNTAD   DC    V(HEWLEPNT)             ADDRESS OF PRINT ROUTINE
IEWHEAD  DC    C'IEW0'
SAVBTP1  DS    2F                      SAVE AREA FOR BITMAP      S21016
BTP2SW   DS    XL1                     SWITCH FOR PROCESSING     S21016
*                                      BITMAP2; WHEN ON (VALUE = S21016
*                                      X'01') BITMAP2 WILL BE    S21016
*                                      SCANNED FOR MESSAGES IN   S21016
*                                      THE CURRENT SEVERITY      S21016
         DS    0H
*
*        TABLE OF INCREMENTS TO MESSAGE LISTS.
*
TABLE    DC    AL2(B001-LIST)
         DC    AL2(B002-LIST)
         DC    AL2(B003-LIST)
         DC    AL2(B004-LIST)
         DC    AL2(B005-LIST)
         DC    AL2(B006-LIST)
         DC    AL2(B007-LIST)
         DC    AL2(B008-LIST)
         DC    AL2(B009-LIST)
         DC    AL2(B010-LIST)
         DC    AL2(B011-LIST)
         DC    AL2(B012-LIST)
         DC    AL2(B013-LIST)
         DC    AL2(B014-LIST)
         DC    AL2(B015-LIST)
         DC    AL2(B016-LIST)
         DC    AL2(B017-LIST)
         DC    AL2(B018-LIST)
         DC    AL2(B019-LIST)
         DC    AL2(B020-LIST)
         DC    AL2(B021-LIST)
         DC    AL2(B022-LIST)
         DC    AL2(B023-LIST)
         DC    AL2(B024-LIST)
         DC    AL2(B025-LIST)
         DC    AL2(B026-LIST)
         DC    AL2(B027-LIST)
         DC    AL2(B028-LIST)
         DC    AL2(B029-LIST)
         DC    AL2(B030-LIST)
         DC    AL2(B031-LIST)
         DC    AL2(B032-LIST)
         DC    AL2(B033-LIST)
         DC    AL2(B034-LIST)
         DC    AL2(B035-LIST)
         DC    AL2(B036-LIST)
         DC    AL2(B037-LIST)
         DC    AL2(B038-LIST)
         DC    AL2(B039-LIST)
         DC    AL2(B040-LIST)
         DC    AL2(B041-LIST)
         DC    AL2(B042-LIST)
         DC    AL2(B043-LIST)
         DC    AL2(B044-LIST)
         DC    AL2(B045-LIST)
         DC    AL2(B046-LIST)
         DC    AL2(B047-LIST)
         DC    AL2(B048-LIST)
         DC    AL2(B049-LIST)
         DC    AL2(B050-LIST)
         DC    AL2(B051-LIST)
         DC    AL2(B052-LIST)
         DC    AL2(B053-LIST)
         DC    AL2(B054-LIST)
         DC    AL2(B055-LIST)
         DC    AL2(B056-LIST)                           OX03510,OY03043
         DC    AL2(B057-LIST)
         DC    AL2(B058-LIST)                           OX04280,OY03413
         DC    AL2(B059-LIST)
         DC    AL2(B060-LIST)
         DC    AL2(B061-LIST)
         DC    AL2(B062-LIST)                                   XA04649
TABLEND  EQU   *
         DC    AL2(B063-LIST)
*                                                                S21016
*        TABLE OF MESSAGE LIST INCREMENTS FOR BITMAP2            S21016
*                                                                S21016
TABLE2   DC    AL2(B064-LIST)          MESSAGE 64                S21016
         DC    AL2(B065-LIST)          MESSAGE 65                S21016
         DC    AL2(0)                  MESSAGE 66                S21016
         DC    AL2(B067-LIST)          MESSAGE 67                S21016
         DC    AL2(B068-LIST)          MESSAGE 68                S21016
         DC    AL2(B069-LIST)          MESSAGE 69                S21016
         DC    AL2(B070-LIST)          MESSAGE 70                S21016
         DC    AL2(B071-LIST)          MESSAGE 71                S21016
         DC    AL2(B072-LIST)          MESSAGE 72                A37667
         DC    AL2(B073-LIST)          MESSAGE 73                A52450
         DC    AL2(B074-LIST)          MESSAGE 74                Y01031
TAB2END  EQU   *                       TABLE2 LIMIT              S21016
         DC    AL2(0)                  MESSAGE 99                S21016
*
*        PHRASES FROM WHICH MESSAGES ARE COMPOSED.
*
P001     DC    C'16193421264043241438302211320254'
PHRASES  EQU   P001
         DC    C'382412043552602'
         DC    C'564572581'                             OX04280,OY03413
P002     DC    C'18284617294053544454847206364093'
CHARTEST EQU   P002+16                 CURRENT SEVERITY FOR PRINTING
P081     DC    C'2'
P003     DC    C'012314033274073740833945029102'
P021     DC    C'322272'
P056     DC    C'191622'
P082     DC    C'594614'                                        XA04649
P097     DC    C'630722'                                         A37667
P233     DC    C'233564'                        OY00131,OX03510,OY03043
P004     DC    C'CARD IGNORED152 '
P005     DC    C'ERROR - '
P006     DC    C'INPUT CONTAINS '
P007     DC    C'INVALID TWO-BYTE RELOCATABLE '
P008     DC    C'ADDRESS CONSTANT, CONSTANT HAS '
P009     DC    C'NOT BEEN RELOCATED.'
P010     DC    C'V-TYPE'
P011     DC    C'ENTRY STATEMENT '
P012     DC    C'SYMBOL PRINTED IS '
P013     DC    C'INVALID (NOT AN EXTERNAL NAME), '
P014     DC    C'NO ENTRY POINT ASSIGNED'
P015     DC    C'ON '
P016     DC    C'END NO '
P017     DC    C'TEXT RECORD ID IS INVALID, '
P018     DC    C'NOT IN ROOT SEGMENT OF '
P019     DC    C'OVERLAY STRUCTURE, '
P020     DC    C'OUTPUT MODULE'
P022     DC    C'UNLESS LET OPTION WAS '
P023     DC    C'SPECIFIED DATA SET'
P024     DC    C'CONTAINS NO '
P025     DC    C'CONTROL SECTIONS'
P026     DC    C'NO ESD ENTRIES, '
P027     DC    C'EXECUTION IMPOSSIBLE'
P028     DC    C'IS AN UNRESOLVED EXTERNAL '
P029     DC    C'REFERENCE;'
P030     DC    C'NCALIS '
P031     DC    C'INVALID '
P032     DC    C'EXCLUSIVE CALL '
P033     DC    C'FROM SEGMENT NUMBER'
P034     DC    C'XCAL'
P036     DC    C'MAIN STORAGE REQUIREMENTS FOR '
P037     DC    C'SCAN TERMINATED'
P038     DC    C'MET'
P039     DC    C'CONTAINS ONLY ONE'
P040     DC    C'-- OVERLAY OPTION CANCELED'
P041     DC    C'EXPECTED CONTINUATION CARD'
P042     DC    C'WARNING - '
P043     DC    C'CARD PRINTED'
P044     DC    C'INPUT FROM OBJECT MODULE'
P046     DC    C'IS DOUBLY DEFINED -- ESD TYPE '
P047     DC    C'DEFINITIONS CONFLICT'
P048     DC    C'TABLE OVERFLOW -- TOO MANY '
P049     DC    C'INPUT LOAD MODULE CONTAINS '
P050     DC    C'TOO MANY EXTERNAL SYMBOLS IN ESD'
P051     DC    C'TO LEVEL F'
P052     DC    C'CALLS BETWEEN'
P053     DC    C' CONTAINING SUCH CONSTANTS'
P054     DC    C'-- DDNAME PRINTED '
P055     DC    C'CANNOT BE OPENED,'
P057     DC    C'HAD SYNCHRONOUS ERROR'
P058     DC    C'MAXIMUM NUMBER OF '
P059     DC    C'REGIONS (4) '
P060     DC    C'EXCEEDED,'
P061     DC    C'SEGMENTS'
P062     DC    C'ALIASES(16)'
P035     DC    C'NO CALLS OR BRANCHES MADE FROM '
P063     DC    C'LIBRARY SPECIFIED DOES NOT '
P064     DC    C'CONTAIN'
P065     DC    C'AFFECTED BY '
P066     DC    C'RELOCATION.'
P067     DC    C'INPUT TEXT EXCEEDED MAXIMUM '
P068     DC    C'OR TOO MANY CHANGES OF ORIGIN'
P069     DC    C'COMMON'
P070     DC    C'MEMBER NOT STORED IN LIBRARY -- '
P071     DC    C'NO SPACE LEFT IN DIRECTORY,'
P072     DC    C'IDENTICAL NAME'
P073     DC    C'WILL TRY TO STORE UNDER '
P074     DC    C'''TEMPNAME'''
P076     DC    C'DOWNWARD'
P078     DC    C'WITHIN A'
P079     DC    C'UNDEFINED IN INPUT,'
P080     DC    C'ON END CARD,'
P083     DC    C'CONSTANTS OR'
P084     DC    C'PERMANENT DEVICE ERROR'
P085     DC    C'CARD FOUND IN LIBRARY,'
P045     DC    C'492'
P087     DC    C'EXCESS'
P088     DC    C'512K BYTESHAVE'
P089     DC    C'INCLUDE STATEMENT SYNTAX '
P090     DC    C'CONFLICTS WITH '
P091     DC    C'RECORD FORMAT OF'
P092     DC    C'HAS UNACCEPTABLE'
P093     DC    C'512522'
P094     DC    C'532'
P095     DC    C'BLOCKSIZE OF'
P096     DC    C'DD CARD MAY BE MISSING'
P098     DC    C'- XREF ABORTED'
P099     DC    C'LENGTH'
P086     DC    C'    '
P077     DC    C'AND SUBROUTINE HAVE'
P100     DC    C'OR THE REFERENCE WAS MARKED FOR '
P101     DC    C'RESTRICTED NO-CALL OR NEVERCALL'
P102     DC    C'SPECIFIED,'
P103     DC    C'670 THE SPECIFIED IDENTIFY DATA HAS BEEN'       S21016
P104     DC    C'ADDED TO THE IDR FOR THE CONTROL SECTION '      S21016
         DC    C'NAME PRINTED'                                   S21016
P105     DC    C'682 ERROR - CONTROL SECTION NAME ON AN '        S21016
         DC    C'IDENTIFY CONTROL'                               S21016
P106     DC    C'STATEMENT IS INCORRECT OR THE STATEMENT IS'     S21016
P107     DC    C'MISPLACED -- IDENTIFY DATA IGNORED'             S21016
P108     DC    C'694 ERROR - TABLE OVERFLOW -- SIZE VALUE'       S21016
P109     DC    C'SPECIFIED NOT LARGE ENOUGH FOR CSECT IDR'       S21016
P110     DC    C'INPUT -- LINKAGE EDITOR PROCESSING TERMINATED'  S21016
P111     DC    C'704 UNRECOVERABLE ERROR DETECTED IN CSECT IDR'  S21016
P112     DC    C'INPUT -- LINKAGE EDITOR PROCESSING TERMINATED'  S21016
P113     DC    C'642 SYMBOL PRINTED APPEARED ON CONTROL STATEMENT '
         DC    C'BUT WAS NOT MATCHED'                           S01904
P114     DC    C'652 CONFLICT IN ORDER SPECIFIED FOR SYMBOL PRINTED'
P115     DC    C'714'                                            S21016
P116     DC    C'STOW WORKSPACE UNAVAILABLE'                     S21016
P117     DC    C'740 THE INDICATED ACTION WAS TAKEN FOR AN '     Y01031
         DC    C'EXPAND REQUEST'                                 Y01031
P118     DC    C'731 WARNING - ALIAS MATCHES MEMBER NAME - ALIAS IGNOREX
               D'                                                A52450
P119     DC    C'REFERENCES NULL UNNAMED'                       XA04649
BTPHDR   DC    C'DIAGNOSTIC MESSAGE DIRECTORY'
*
*        LISTS COMPRISING GROUPS OF 3-BYTE ENTRIES AS FOLLOWS --
*
*              1 BYTE = LENGTH-1 OF PHRASE
*              2 BYTES = INCREMENT TO PHRASE,
*
*        EACH GROUP FOLLOWED BY AN END FLAG.
*
*    IEW0*012*ERROR - INPUT CONTAINS ILLEGAL TWO-BYTE RELOCATABLE
*             ADDRESS CONSTANT, CONSTANT HAS NOT BEEN RELOCATED.
B001     DC    AL1(02)
LIST     EQU   B001
         DC    AL2(P003+00-P001)
         DC    AL1(100)
         DC    AL2(P005+00-P001)
         DC    X'FF'
*    IEW0*022*ERROR - INPUT CONTAINS ILLEGAL*V-TYPE*ADDRESS CONSTANT,
*             CONSTANT HAS NOT BEEN RELOCATED.
B002     DC    AL1(02)
         DC    AL2(P001+21-P001)
         DC    AL1(29)
         DC    AL2(P005+00-P001)
         DC    AL1(05)
         DC    AL2(P010+00-P001)
         DC    AL1(48)
         DC    AL2(P008+00-P001)
         DC    X'FF'
*    IEW0*033*ERROR -*ILLEGAL*ENTRY POINT*ON END CARD,*ENTRY POINT*
*             IGNORED.
B003     DC    AL1(02)
         DC    AL2(P003+06-P001)
         DC    AL1(06)
         DC    AL2(P005+00-P001)
         DC    AL1(06)
         DC    AL2(P013+00-P001)
         DC    AL1(10)
         DC    AL2(P014+03-P001)
         DC    AL1(03)
         DC    AL2(P033+00-P001)
         DC    AL1(08)
         DC    AL2(P080+03-P001)
         DC    AL1(22)
         DC    AL2(P014+00-P001)
         DC    X'FF'
B004     DC    AL1(02)
         DC    AL2(P001+38-P001)
         DC    AL1(06)
         DC    AL2(P005+00-P001)
         DC    AL1(13)
         DC    AL2(P006+00-P001)
         DC    AL1(06)
         DC    AL2(P017+18-P001)
         DC    AL1(15)
         DC    AL2(P050+09-P001)
         DC    AL1(01)
         DC    AL2(P017+12-P001)
         DC    X'FF'
*    IEW0*053*ERROR -*ENTRY STATEMENT SYMBOL PRINTED IS ILLEGAL (NOT
*             AN EXTERNAL NAME), NO ENTRY POINT ASSIGNED.
B005     DC    AL1(02)
         DC    AL2(P002+11-P001)
         DC    AL1(06)
         DC    AL2(P005+00-P001)
         DC    AL1(88)
         DC    AL2(P011+00-P001)
         DC    X'FF'
*    IEW0*063*ERROR -*END CARD*SYMBOL PRINTED IS ILLEGAL (NOT AN
*             EXTERNAL NAME), NO ENTRY POINT ASSIGNED.
B006     DC    AL1(02)
         DC    AL2(P002+24-P001)
         DC    AL1(06)
         DC    AL2(P005+00-P001)
         DC    AL1(07)
         DC    AL2(P080+03-P001)
         DC    AL1(72)
         DC    AL2(P012+00-P001)
         DC    X'FF'
*    IEW0*073*ERROR -*ENTRY STATEMENT SYMBOL PRINTED IS*NOT IN ROOT
*             SEGMENT OF OVERLAY STRUCTURE,*NO ENTRY POINT ASSIGNED.
B007     DC    AL1(02)
         DC    AL2(P003+12-P001)
         DC    AL1(06)
         DC    AL2(P005+00-P001)
         DC    AL1(32)
         DC    AL2(P011+00-P001)
         DC    AL1(40)
         DC    AL2(P018+00-P001)
         DC    AL1(22)
         DC    AL2(P014+00-P001)
         DC    X'FF'
*    IEW0*083*ERROR -*END CARD*SYMBOL PRINTED*IS NOT IN ROOT SEGMENT
*             OF OVERLAY STRUCTURE,*NO ENTRY POINT ASSIGNED.
B008     DC    AL1(02)
         DC    AL2(P003+17-P001)
         DC    AL1(06)
         DC    AL2(P005+00-P001)
         DC    AL1(07)
         DC    AL2(P080+03-P001)
         DC    AL1(16)
         DC    AL2(P012+00-P001)
         DC    AL1(40)
         DC    AL2(P018+00-P001)
         DC    AL1(22)
         DC    AL2(P014+00-P001)
         DC    X'FF'
*    IEW0*093*ERROR -*END CARD*ENTRY POINT*ADDRESS*PRINTED IS*NOT IN
*             ROOT SEGMENT OF OVERLAY STRUCTURE,*NO ENTRY POINT*   *
*             ASSIGNED
B009     DC    AL1(02)
         DC    AL2(P002+29-P001)
         DC    AL1(06)
         DC    AL2(P005+00-P001)
         DC    AL1(07)
         DC    AL2(P080+03-P001)
         DC    AL1(10)
         DC    AL2(P014+03-P001)
         DC    AL1(06)
         DC    AL2(P008+00-P001)
         DC    AL1(09)
         DC    AL2(P012+07-P001)
         DC    AL1(40)
         DC    AL2(P018+00-P001)
         DC    AL1(22)
         DC    AL2(P014+00-P001)
         DC    X'FF'
*    IEW0*102*ERROR -*ILLEGAL*ENTRY POINT*ID ON END CARD,*ENTRY POINT*
*             IGNORED.
B010     DC    AL1(02)
         DC    AL2(P003+27-P001)
         DC    AL1(06)
         DC    AL2(P005+00-P001)
         DC    AL1(06)
         DC    AL2(P013+00-P001)
         DC    AL1(10)
         DC    AL2(P014+03-P001)
         DC    AL1(11)
         DC    AL2(P080+00-P001)
         DC    AL1(10)
         DC    AL2(P014+03-P001)
         DC    AL1(06)
         DC    AL2(P004+05-P001)
         DC    X'FF'
*    IEW0*113*ERROR -*OUTPUT MODULE*CONTAINS NO CONTROL SECTIONS*IN
*             ROOT SEGMENT OF OVERLAY STRUCTURE,*NO ENTRY POINT*    *
*             ASSIGNED.
B011     DC    AL1(02)
         DC    AL2(P001+24-P001)
         DC    AL1(06)
         DC    AL2(P005+00-P001)
         DC    AL1(12)
         DC    AL2(P020+00-P001)
         DC    AL1(27)
         DC    AL2(P024+00-P001)
         DC    AL1(36)
         DC    AL2(P018+04-P001)
         DC    AL1(22)
         DC    AL2(P014+00-P001)
         DC    X'FF'
*    IEW0*123*ERROR -*NO ESD ENTRIES, EXECUTION IMPOSSIBLE.
B012     DC    AL1(02)
         DC    AL2(P003+01-P001)
         DC    AL1(06)
         DC    AL2(P005+00-P001)
         DC    AL1(35)
         DC    AL2(P026+00-P001)
         DC    X'FF'
*    IEW0*132*ERROR -*SYMBOL PRINTED IS*AN UNRESOLVED EXTERNAL
*             REFERENCE.
B013     DC    AL1(02)
         DC    AL2(P001+25-P001)
         DC    AL1(06)
         DC    AL2(P005+00-P001)
         DC    AL1(13)
         DC    AL2(P012+00-P001)
         DC    AL1(34)
         DC    AL2(P028+00-P001)
         DC    X'FF'
*    IEW0*143*ERROR -*NO TEXT*FOUND.
B014     DC    AL1(02)
         DC    AL2(P001+16-P001)
         DC    AL1(06)
         DC    AL2(P005+00-P001)
         DC    AL1(06)
         DC    AL2(P016+04-P001)
         DC    X'FF'
*    IEW0*152 ERROR -*ILLEGAL*OVERLAY STRUCTURE,*NO CALLS OR BRANCHES
*             MADE FROM*ROOT SEGMENT.
B015     DC    AL1(10)
         DC    AL2(P004+12-P001)
         DC    AL1(06)
         DC    AL2(P007+00-P001)
         DC    AL1(17)
         DC    AL2(P019+00-P001)
         DC    AL1(29)
         DC    AL2(P035+00-P001)
         DC    AL1(11)
         DC    AL2(P018+07-P001)
         DC    X'FF'
*    IEW0*161*WARNING -*EXCLUSIVE CALL FROM SEGMENT NUMBER*PRINTED*TO*
*             SYMBOL PRINTED.
B016     DC    AL1(02)
         DC    AL2(P001+00-P001)
         DC    AL1(08)
         DC    AL2(P042+00-P001)
         DC    AL1(33)
         DC    AL2(P032+00-P001)
         DC    AL1(06)
         DC    AL2(P012+07-P001)
         DC    AL1(01)
         DC    AL2(P048+18-P001)
         DC    AL1(13)
         DC    AL2(P012+00-P001)
         DC    AL1(01)
         DC    AL2(P040+00-P001)
         DC    AL1(03)
         DC    AL2(P034+00-P001)
         DC    AL1(12)
         DC    AL2(P022+18-P001)
         DC    X'FF'
*    IEW0*172*ERROR -*EXCLUSIVE CALL FROM SEGMENT NUMBER*PRINTED*TO*
*             SYMBOL PRINTED*--*XCAL*OPTION*NOT*SPECIFIED.
B017     DC    AL1(02)
         DC    AL2(P002+06-P001)
         DC    AL1(06)
         DC    AL2(P005+00-P001)
         DC    AL1(33)
         DC    AL2(P032+00-P001)
         DC    AL1(06)
         DC    AL2(P012+07-P001)
         DC    AL1(01)
         DC    AL2(P048+18-P001)
         DC    AL1(13)
         DC    AL2(P012+00-P001)
         DC    X'FF'
*    IEW0*182*ERROR -*INVALID EXCLUSIVE CALL FROM SEGMENT NUMBER*
*             PRINTED*TO*SYMBOL PRINTED.
B018     DC    AL1(02)
         DC    AL2(P002+00-P001)
         DC    AL1(06)
         DC    AL2(P005+00-P001)
         DC    AL1(41)
         DC    AL2(P031+00-P001)
         DC    AL1(06)
         DC    AL2(P012+07-P001)
         DC    AL1(01)
         DC    AL2(P048+18-P001)
         DC    AL1(13)
         DC    AL2(P012+00-P001)
         DC    X'FF'
*    IEW0*191*WARNING -MAIN STORAGE REQUIREMENTS FOR*OUTPUT*LOAD    XXX
*              MODULE*HAVE*EXCEEDED*512K BYTES
B019     DC    AL1(02)
         DC    AL2(P056+00-P001)
         DC    AL1(08)
         DC    AL2(P042+00-P001)
         DC    AL1(28)
         DC    AL2(P036+00-P001)
         DC    AL1(05)
         DC    AL2(P020+00-P001)
         DC    AL1(10)
         DC    AL2(P049+06-P001)
         DC    AL1(03)
         DC    AL2(P088+10-P001)
         DC    AL1(07)
         DC    AL2(P060+00-P001)
         DC    AL1(09)
         DC    AL2(P088+00-P001)
         DC    X'FF'
*    IEW0*202*WARNING -*OVERLAY STRUCTURE*CONTAINS ONLY ONE*SEGMENT*
*             -- OVERLAY OPTION CANCELED.
B020     DC    AL1(02)
         DC    AL2(P081+00-P001)
         DC    AL1(08)
         DC    AL2(P042+00-P001)
         DC    AL1(16)
         DC    AL2(P019+00-P001)
         DC    AL1(16)
         DC    AL2(P039+00-P001)
         DC    AL1(06)
         DC    AL2(P018+12-P001)
         DC    AL1(25)
         DC    AL2(P040+00-P001)
         DC    X'FF'
*    IEW0*212*ERROR - EXPECTED CONTINUATION CARD*NOT*FOUND*--*CARD
*             IGNORED.
B021     DC    AL1(02)
         DC    AL2(P001+06-P001)
         DC    AL1(06)
         DC    AL2(P005+00-P001)
         DC    AL1(25)
         DC    AL2(P041+00-P001)
         DC    AL1(02)
         DC    AL2(P018+00-P001)
         DC    AL1(04)
         DC    AL2(P085+05-P001)
         DC    X'FF'
*    IEW0*222*ERROR - CARD PRINTED NOT RECOGNIZED AS INPUT FROM OBJECT
*             MODULE.
B022     DC    AL1(02)
         DC    AL2(P021+01-P001)
         DC    AL1(06)
         DC    AL2(P005+00-P001)
         DC    AL1(11)
         DC    AL2(P043+00-P001)
         DC    AL1(07)
         DC    AL2(P039+00-P001)
         DC    AL1(06)
         DC    AL2(P031+00-P001)
         DC    AL1(23)
         DC    AL2(P044+00-P001)
         DC    X'FF'
*    IEW0*233*ERROR -*INPUT FROM*LOAD MODULE*IS INVALID.        OY00131
B023     DC    AL1(02)
         DC    AL2(P233+00-P001)                                OY00131
         DC    AL1(06)
         DC    AL2(P005+00-P001)
         DC    AL1(09)
         DC    AL2(P044+00-P001)
         DC    AL1(10)
         DC    AL2(P049+06-P001)
         DC    AL1(09)
         DC    AL2(P030+04-P001)
         DC    X'FF'
*    IEW0*241*WARNING -*EXTERNAL SYMBOL*PRINTED*IS DOUBLY DEFINED --
*             ESD TYPE DEFINITIONS CONFLICT.
B024     DC    AL1(02)
         DC    AL2(P001+14-P001)
         DC    AL1(08)
         DC    AL2(P042+00-P001)
         DC    AL1(14)
         DC    AL2(P050+09-P001)
         DC    AL1(06)
         DC    AL2(P012+07-P001)
         DC    AL1(49)
         DC    AL2(P046+00-P001)
         DC    X'FF'
*    IEW0*254*ERROR -*TABLE OVERFLOW --*TOO MANY EXTERNAL SYMBOLS IN
*             ESD.
B025     DC    AL1(02)
         DC    AL2(P001+29-P001)
         DC    AL1(06)
         DC    AL2(P005+00-P001)
         DC    AL1(16)
         DC    AL2(P048+00-P001)
         DC    AL1(31)
         DC    AL2(P050+00-P001)
         DC    X'FF'
*    IEW0*264*ERROR -*TABLE OVERFLOW --*INPUT LOAD MODULE CONTAINS TOO
*             MANY EXTERNAL SYMBOLS IN ESD.
B026     DC    AL1(02)
         DC    AL2(P001+08-P001)
         DC    AL1(06)
         DC    AL2(P005+00-P001)
         DC    AL1(16)
         DC    AL2(P048+00-P001)
         DC    AL1(04)
         DC    AL2(P049+00-P001)
         DC    AL1(52)
         DC    AL2(P049+06-P001)
         DC    X'FF'
*    IEW0*274*ERROR -*LOAD MODULE*FROM LIBRARY SPECIFIED*UNACCEPTABLE*
*        TO LEVEL F.
B027     DC    AL1(02)
         DC    AL2(P021+03-P001)
         DC    AL1(06)
         DC    AL2(P005+00-P001)
         DC    AL1(10)
         DC    AL2(P049+06-P001)
         DC    AL1(21)
         DC    AL2(P035+26-P001)
         DC    AL1(11)
         DC    AL2(P092+04-P001)
         DC    AL1(09)
         DC    AL2(P051+00-P001)
         DC    X'FF'
*    IEW0*284*ERROR -*DATA SET NAME PRINTED CANNOT BE OPENED.
B028     DC    AL1(02)
         DC    AL2(P002+02-P001)
         DC    AL1(06)
         DC    AL2(P005+00-P001)
         DC    AL1(30)
         DC    AL2(P054+03-P001)
         DC    X'FF'
*    IEW0*294*ERROR -*DATA SET NAME PRINTED*HAD SYNCHRONOUS ERROR.
B029     DC    AL1(02)
         DC    AL2(P002+08-P001)
         DC    AL1(06)
         DC    AL2(P005+00-P001)
         DC    AL1(13)
         DC    AL2(P054+03-P001)
         DC    AL1(20)
         DC    AL2(P057+00-P001)
         DC    X'FF'
*    IEW0*302*ERROR -*INVALID*STATEMENT*--*CARD IGNORED.
B030     DC    AL1(02)
         DC    AL2(P001+20-P001)
         DC    AL1(06)
         DC    AL2(P005+00-P001)
         DC    AL1(06)
         DC    AL2(P031+00-P001)
         DC    AL1(08)
         DC    AL2(P011+06-P001)
         DC    AL1(01)
         DC    AL2(P040+00-P001)
         DC    AL1(14)
         DC    AL2(P037+00-P001)
         DC    X'FF'
*    IEW0*314*ERROR -*MAXIMUM NUMBER OF REGIONS (4) EXCEEDED.
B031     DC    AL1(02)
         DC    AL2(P003+03-P001)
         DC    AL1(06)
         DC    AL2(P005+00-P001)
         DC    AL1(37)
         DC    AL2(P058+00-P001)
         DC    X'FF'
*    IEW0*324*ERROR -*MAXIMUM NUMBER OF*SEGMENTS*EXCEEDED.
B032     DC    AL1(02)
         DC    AL2(P001+13-P001)
         DC    AL1(06)
         DC    AL2(P005+00-P001)
         DC    AL1(16)
         DC    AL2(P058+00-P001)
         DC    AL1(07)
         DC    AL2(P061+00-P001)
         DC    AL1(07)
         DC    AL2(P060+00-P001)
         DC    X'FF'
*    IEW0*332*ERROR-*MAXIMUM NUMBER OF *ALIASES(16)*EXCEEDED,EXCESS*
*             IGNORED.
B033     DC    AL1(02)
         DC    AL2(P003+07-P001)
         DC    AL1(06)
         DC    AL2(P005+00-P001)
         DC    AL1(16)
         DC    AL2(P058+00-P001)
         DC    AL1(10)
         DC    AL2(P062+00-P001)
         DC    AL1(08)
         DC    AL2(P060+00-P001)
         DC    AL1(05)
         DC    AL2(P087+00-P001)
         DC    AL1(06)
         DC    AL2(P004+05-P001)
         DC    X'FF'
*    IEW0*342*ERROR -*LIBRARY SPECIFIED DOES NOT CONTAIN*MODULE.
B034     DC    AL1(02)
         DC    AL2(P001+04-P001)
         DC    AL1(06)
         DC    AL2(P005+00-P001)
         DC    AL1(33)
         DC    AL2(P063+00-P001)
         DC    AL1(05)
         DC    AL2(P044+18-P001)
         DC    X'FF'
*    IEW0*354*ERROR -*TABLE OVERFLOW -- TOO MANY*CALLS BETWEEN*CONTROL
*             SECTIONS.
B035     DC    AL1(02)
         DC    AL2(P002+13-P001)
         DC    AL1(06)
         DC    AL2(P005+00-P001)
         DC    AL1(25)
         DC    AL2(P048+00-P001)
         DC    AL1(12)
         DC    AL2(P052+00-P001)
         DC    AL1(15)
         DC    AL2(P025+00-P001)
         DC    X'FF'
*    IEW0*364*ERROR -*TABLE OVERFLOW --*INPUT TEXT EXCEEDED MAXIMUM
*             OR TOO MANY CHANGES OF ORIGIN*IN INPUT.
B036     DC    AL1(02)
         DC    AL2(P002+26-P001)
         DC    AL1(06)
         DC    AL2(P005+00-P001)
         DC    AL1(16)
         DC    AL2(P048+00-P001)
         DC    AL1(56)
         DC    AL2(P067+00-P001)
         DC    AL1(07)
         DC    AL2(P079+10-P001)
         DC    X'FF'
*    IEW0*374*ERROR -*TABLE OVERFLOW --*INPUT*CONTAINS*TOO MANY*
*             RELOCATABLE ADDRESS*CONSTANTS OR*TOO MANY*CONTROL
*             SECTIONS* CONTAINING SUCH CONSTANTS.
B037     DC    AL1(02)
         DC    AL2(P003+14-P001)
         DC    AL1(06)
         DC    AL2(P005+00-P001)
         DC    AL1(16)
         DC    AL2(P048+00-P001)
         DC    AL1(04)
         DC    AL2(P049+00-P001)
         DC    AL1(07)
         DC    AL2(P024+00-P001)
         DC    AL1(07)
         DC    AL2(P050+00-P001)
         DC    AL1(18)
         DC    AL2(P007+17-P001)
         DC    AL1(11)
         DC    AL2(P083+00-P001)
         DC    AL1(07)
         DC    AL2(P050+00-P001)
         DC    AL1(15)
         DC    AL2(P025+00-P001)
         DC    AL1(25)
         DC    AL2(P053+00-P001)
         DC    X'FF'
*    IEW0*383*ERROR -*TEXT RECORD ID IS ILLEGAL,*CARD IGNORED.
B038     DC    AL1(02)
         DC    AL2(P001+32-P001)
         DC    AL1(06)
         DC    AL2(P005+00-P001)
         DC    AL1(25)
         DC    AL2(P017+00-P001)
         DC    AL1(11)
         DC    AL2(P004+00-P001)
         DC    X'FF'
*    IEW0*394*ERROR -*MEMBER NOT STORED IN LIBRARY --*PERMANENT DISK
*             ERROR.
B039     DC    AL1(02)
         DC    AL2(P003+20-P001)
         DC    AL1(06)
         DC    AL2(P005+00-P001)
         DC    AL1(30)
         DC    AL2(P070+00-P001)
         DC    AL1(21)
         DC    AL2(P084+00-P001)
         DC    X'FF'
*    IEW0*404*ERROR -*MEMBER NOT STORED IN LIBRARY -- NO SPACE LEFT IN
*             DIRECTORY.
B040     DC    AL1(02)
         DC    AL2(P001+10-P001)
         DC    AL1(06)
         DC    AL2(P005+00-P001)
         DC    AL1(57)
         DC    AL2(P070+00-P001)
         DC    X'FF'
*    IEW0*414*ERROR -*ALIAS*NOT STORED IN LIBRARY -- NO SPACE LEFT IN
*             DIRECTORY.
B041     DC    AL1(02)
         DC    AL2(P001+35-P001)
         DC    AL1(06)
         DC    AL2(P005+00-P001)
         DC    AL1(04)
         DC    AL2(P062+00-P001)
         DC    AL1(50)
         DC    AL2(P070+07-P001)
         DC    X'FF'
*    IEW0*421*WARNING -*MEMBER NOT STORED IN LIBRARY --*IDENTICAL
*             NAME*IN DIRECTORY,*WILL TRY TO STORE UNDER 'TEMPNAME'.
B042     DC    AL1(02)
         DC    AL2(P001+05-P001)
         DC    AL1(08)
         DC    AL2(P042+00-P001)
         DC    AL1(30)
         DC    AL2(P070+00-P001)
         DC    AL1(13)
         DC    AL2(P072+00-P001)
         DC    AL1(12)
         DC    AL2(P071+14-P001)
         DC    AL1(33)
         DC    AL2(P073+00-P001)
         DC    X'FF'
*    IEW0*432*ERROR -*LIBRARY NAME PRINTED CANNOT BE OPENED, DD CARD
*             MAY BE MISSING
B043     DC    AL1(02)
         DC    AL2(P001+12-P001)
         DC    AL1(06)
         DC    AL2(P005+00-P001)
         DC    AL1(06)
         DC    AL2(P063+00-P001)
         DC    AL1(29)
         DC    AL2(P054+05-P001)
         DC    AL1(21)
         DC    AL2(P096+00-P001)
         DC    X'FF'
*    IEW0*444*ERROR -*TABLE OVERFLOW -- TOO MANY*DOWNWARD*CALLS.
B044     DC    AL1(02)
         DC    AL2(P002+15-P001)
         DC    AL1(06)
         DC    AL2(P005+00-P001)
         DC    AL1(25)
         DC    AL2(P048+00-P001)
         DC    AL1(07)
         DC    AL2(P076+00-P001)
         DC    AL1(04)
         DC    AL2(P052+00-P001)
         DC    X'FF'
*    IEW0*454*ERROR -*TABLE OVERFLOW --*SEGMENT CONTAINS*TOO MANY*
*             DOWNWARD CALLS.
B045     DC    AL1(02)
         DC    AL2(P002+17-P001)
         DC    AL1(06)
         DC    AL2(P005+00-P001)
         DC    AL1(16)
         DC    AL2(P048+00-P001)
         DC    AL1(06)
         DC    AL2(P033+05-P001)
         DC    AL1(07)
         DC    AL2(P006+06-P001)
         DC    AL1(07)
         DC    AL2(P048+18-P001)
         DC    AL1(07)
         DC    AL2(P076+00-P001)
         DC    AL1(04)
         DC    AL2(P052+00-P001)
         DC    X'FF'
*    IEW0*461*WARNING -*SYMBOL PRINTED*IS AN UNRESOLVED EXTERNAL
*             REFERENCE;*NCAL*WAS*SPECIFIED,*OR THE REFERENCE
*             WAS MARKED FOR RESTRICTED NO-CALL OR NEVERCALL.
B046     DC    AL1(02)
         DC    AL2(P002+04-P001)
         DC    AL1(08)
         DC    AL2(P042+00-P001)
         DC    AL1(13)
         DC    AL2(P012+00-P001)
         DC    AL1(35)
         DC    AL2(P028+00-P001)
         DC    AL1(03)
         DC    AL2(P030+00-P001)
         DC    AL1(2)
         DC    AL2(P022+18-P001)
         DC    AL1(9)
         DC    AL2(P102+00-P001)
         DC    AL1(62)
         DC    AL2(P100+00-P001)
         DC    X'FF'
*    IEW0*473*ERROR -*INVALID*ALIAS*ENTRY POINT*IN*OVERLAY STRUCTURE.
B047     DC    AL1(02)
         DC    AL2(P002+21-P001)
         DC    AL1(06)
         DC    AL2(P005+00-P001)
         DC    AL1(06)
         DC    AL2(P031+00-P001)
         DC    AL1(04)
         DC    AL2(P062+00-P001)
         DC    AL1(10)
         DC    AL2(P014+03-P001)
         DC    AL1(01)
         DC    AL2(P018+04-P001)
         DC    AL1(16)
         DC    AL2(P019+00-P001)
         DC    X'FF'
*    IEW0*484*ERROR -*TABLE OVERFLOW -- TOO MANY*EXTERNAL SYMBOLS*
*              AFFECTED BY RELOCATION.
B048     DC    AL1(02)
         DC    AL2(P002+19-P001)
         DC    AL1(06)
         DC    AL2(P005+00-P001)
         DC    AL1(25)
         DC    AL2(P048+00-P001)
         DC    AL1(15)
         DC    AL2(P050+09-P001)
         DC    AL1(21)
         DC    AL2(P065+00-P001)
         DC    X'FF'
*    IEW0*504*ERROR -*ALIAS*NOT STORED IN LIBRARY --*PERMANENT DISK
*             ERROR.
B050     DC    AL1(02)
         DC    AL2(P003+23-P001)
         DC    AL1(06)
         DC    AL2(P005+00-P001)
         DC    AL1(04)
         DC    AL2(P062+00-P001)
         DC    AL1(23)
         DC    AL2(P070+07-P001)
         DC    AL1(21)
         DC    AL2(P084+00-P001)
         DC    X'FF'
*    IEW0*492*ERROR -*NAME CARD FOUND IN LIBRARY,*CARD IGNORED.
B049     DC    AL1(02)
         DC    AL2(P045+00-P001)
         DC    AL1(06)
         DC    AL2(P005+00-P001)
         DC    AL1(03)
         DC    AL2(P054+05-P001)
         DC    AL1(21)
         DC    AL2(P085+00-P001)
         DC    AL1(11)
         DC    AL2(P004+00-P001)
         DC    X'FF'
*    IEW0*512*ERROR -*INCLUDE STATEMENT SYNTAX CONFLICTS WITH RECORD
*             FORMAT OF*SPECIFIED*DATA SET.
B051     DC    AL1(02)
         DC    AL2(P093+00-P001)
         DC    AL1(06)
         DC    AL2(P005+00-P001)
         DC    AL1(55)
         DC    AL2(P089+00-P001)
         DC    AL1(17)
         DC    AL2(P023+00-P001)
         DC    AL1(16)
         DC    AL2(P054+00-P001)
         DC    X'FF'
*    IEW0*522*ERROR -*SPECIFIED*DATA SET*HAS UNACCEPTABLE*RECORD
*             FORMAT.
B052     DC    AL1(02)
         DC    AL2(P093+03-P001)
         DC    AL1(06)
         DC    AL2(P005+00-P001)
         DC    AL1(17)
         DC    AL2(P023+00-P001)
         DC    AL1(15)
         DC    AL2(P092+00-P001)
         DC    AL1(12)
         DC    AL2(P091+00-P001)
         DC    AL1(16)
         DC    AL2(P054+00-P001)
         DC    X'FF'
*    IEW0*532*ERROR -*BLOCKSIZE OF*LIBRARY*EXCEEDED MAXIMUM.
B053     DC    AL1(02)
         DC    AL2(P094+00-P001)
         DC    AL1(06)
         DC    AL2(P005+00-P001)
         DC    AL1(11)
         DC    AL2(P095+00-P001)
         DC    AL1(06)
         DC    AL2(P085+14-P001)
         DC    AL1(07)
         DC    AL2(P023+10-P001)
         DC    AL1(15)
         DC    AL2(P067+11-P001)
         DC    AL1(16)
         DC    AL2(P054+00-P001)
         DC    X'FF'
*    IEW0*543*ERROR -*MEMBER NOT STORED IN LIBRARY --*IDENTICAL NAME*
*             IN DIRECTORY.
B054     DC    AL1(02)
         DC    AL2(P001+30-P001)
         DC    AL1(06)
         DC    AL2(P005+00-P001)
         DC    AL1(13)
         DC    AL2(P072+00-P001)
         DC    AL1(11)
         DC    AL2(P071+14-P001)
         DC    X'FF'
*    IEW0*552*ERROR -*COMMON*PRINTED*EXCEEDED*SIZE OF*CONTROL SECTION*
*                     WITH*IDENTICAL NAME.
B055     DC    AL1(02)
         DC    AL2(P001+41-P001)
         DC    AL1(06)
         DC    AL2(P005+00-P001)
         DC    AL1(05)
         DC    AL2(P069+00-P001)
         DC    AL1(06)
         DC    AL2(P012+07-P001)
         DC    AL1(07)
         DC    AL2(P060+00-P001)
         DC    AL1(06)
         DC    AL2(P095+05-P001)
         DC    AL1(14)
         DC    AL2(P025+00-P001)
         DC    AL1(03)
         DC    AL2(P078+00-P001)
         DC    AL1(13)
         DC    AL2(P072+00-P001)
         DC    X'FF'
*
*IEW0*572*ERROR-*COMMON*PRINTED*AND SUBROUTINE HAVE*IDENTICAL NAME.
*
B057     DC    AL1(02)
         DC    AL2(P001+50-P001)
         DC    AL1(06)
         DC    AL2(P005+00-P001)
         DC    AL1(05)
         DC    AL2(P069+00-P001)
         DC    AL1(06)
         DC    AL2(P012+07-P001)
         DC    AL1(18)
         DC    AL2(P077+00-P001)
         DC      AL1(13)
         DC    AL2(P072+00-P001)
         DC    X'FF'
*    IEW0*594*ERROR -*INPUT DATA SET BLOCKSIZE IS INVALID
B059     DC    AL1(02)
         DC    AL2(P082+00-P001)
         DC    AL1(06)
         DC    AL2(P005+00-P001)
         DC    AL1(4)
         DC    AL2(P044+00-P001)
         DC    AL1(07)
         DC    AL2(P023+10-P001)
         DC    AL1(08)
         DC    AL2(P095+00-P001)
         DC    AL1(09)
         DC    AL2(P017+15-P001)
         DC    X'FF'
*
*  IEW0* 602*ERROR -*INPUT FROM OBJECT MODULE* IS INVALID*- *
*     END CARD* MISSING*
B060     DC    AL1(02)
         DC    AL2(P001+44-P001)
         DC    AL1(06)
         DC    AL2(P005+00-P001)
         DC    AL1(23)
         DC    AL2(P044+00-P001)
         DC    AL1(09)
         DC    AL2(P017+15-P001)
         DC    AL1(01)
         DC    AL2(P098+00-P001)
         DC    AL1(07)
         DC    AL2(P080+03-P001)
         DC    AL1(06)
         DC    AL2(P096+15-P001)
         DC    X'FF'
*    IEW0*614 -*LENGTH*NOT*SPECIFIED*FOR*EXTERNAL*SYMBOL PRINTED
B061     DC    AL1(02)
         DC    AL2(P082+03-P001)
         DC    AL1(06)
         DC    AL2(P005+00-P001)
         DC    AL1(5)
         DC    AL2(P099+00-P001)
         DC    AL1(2)
         DC    AL2(P018+00-P001)
         DC    AL1(8)
         DC    AL2(P023+00-P001)
         DC    AL1(2)
         DC    AL2(P036+26-P001)
         DC    AL1(7)
         DC    AL2(P013+16-P001)
         DC    AL1(13)
         DC    AL2(P012+00-P001)
         DC    X'FF'
*
*    IEW0*622*ERROR -*ADDRESS CONSTANT*REFERENCESNULL UNNAMED*CONTROL
*             SECTION.
*
B062     DC    AL1(02)                                          XA04649
         DC    AL2(P056+03-P001)                                XA04649
         DC    AL1(06)                                          XA04649
         DC    AL2(P005+00-P001)                                XA04649
         DC    AL1(15)                                          XA04649
         DC    AL2(P008+00-P001)                                XA04649
         DC    AL1(22)                                          XA04649
         DC    AL2(P119+00-P001)                                XA04649
         DC    AL1(14)                                          XA04649
         DC    AL2(P025+00-P001)                                XA04649
         DC    X'FF'                                            XA04649
*    IEW0*630*ERROR -*DATA SET NAME PRINTED*HAD SYNCHRONOUS ERROR
*             *- XREF ABORTED.
B063     DC    AL1(02)
         DC    AL2(P097+00-P001)
         DC    AL1(06)
         DC    AL2(P005+00-P001)
         DC    AL1(13)
         DC    AL2(P054+03-P001)
         DC    AL1(20)
         DC    AL2(P057+00-P001)
         DC    AL1(13)
         DC    AL2(P098+00-P001)
         DC    X'FF'
*    IEW0*642 ERROR   -SYMBOL PRINTED APPEARED ON CONTROL STATEMENT
*             BUT WAS NOT MATCHED                               S01904
B064     DC    AL1(02)                                          S01904
         DC    AL2(P113+00-P001)                                S01904
         DC    AL1(06)                                          S01904
         DC    AL2(P005+00-P001)                                S01904
         DC    AL1(63)                                          S01904
         DC    AL2(P113+04-P001)                                S01904
         DC    X'FF'                                            S01904
*    IEW0*652 ERROR   -CONFLICT IN ORDER SPECIFIED FOR SYMBOL PRINTED
*                                                               S01904
B065     DC    AL1(02)                                          S01904
         DC    AL2(P114+00-P001)                                S01904
         DC    AL1(06)                                          S01904
         DC    AL2(P005+00-P001)                                S01904
         DC    AL1(45)                                          S01904
         DC    AL2(P114+04-P001)                                S01904
         DC    X'FF'                                            S01904
*    IEW0*670 THE SPECIFIED IDENTIFY DATA HAS BEEN ADDED TO THE  S21016
*             IDR FOR THE CONTROL SECTION NAME PRINTED.          S21016
B067     DC    AL1(39)                                           S21016
         DC    AL2(P103+00-P001)                                 S21016
         DC    AL1(52)                                           S21016
         DC    AL2(P104+00-P001)                                 S21016
         DC    X'FF'                                             S21016
*    IEW0*682 ERROR - CONTROL SECTION NAME ON AN IDENTIFY        S21016
*             CONTROL STATEMENT IS INCORRECT OR THE STATEMENT    S21016
*             IS MISPLACED -- IDENTIFY DATA IGNORED.             S21016
B068     DC    AL1(54)                                           S21016
         DC    AL2(P105+00-P001)                                 S21016
         DC    AL1(41)                                           S21016
         DC    AL2(P106+00-P001)                                 S21016
         DC    AL1(33)                                           S21016
         DC    AL2(P107+00-P001)                                 S21016
         DC    X'FF'                                             S21016
*    IEW0*694 ERROR - TABLE OVERFLOW -- SIZE VALUE SPECIFIED     S21016
*             NOT LARGE ENOUGH FOR CSECT IDR INPUT -- LINKAGE    S21016
*             EDITOR PROCESSING TERMINATED.                      S21016
B069     DC    AL1(39)                                           S21016
         DC    AL2(P108+00-P001)                                 S21016
         DC    AL1(39)                                           S21016
         DC    AL2(P109+00-P001)                                 S21016
         DC    AL1(44)                                           S21016
         DC    AL2(P110+00-P001)                                 S21016
         DC    X'FF'                                             S21016
*    IEW0*704 UNRECOVERABLE ERROR DETECTED IN CSECT IDR INPUT    S21016
*              -- LINKAGE EDITOR PROCESSING TERMINATED.          S21016
B070     DC    AL1(44)                                           S21016
         DC    AL2(P111+00-P001)                                 S21016
         DC    AL1(44)                                           S21016
         DC    AL2(P112+00-P001)                                 S21016
         DC    X'FF'                                             S21016
*    IEW0*714*ERROR -*MEMBER NOT STORED IN LIBRARY --* STOW      S21016
*             WORKSPACE UNAVAILABLE.                             S21016
B071     DC    AL1(02)                                           S21016
         DC    AL2(P115+00-P001)                                 S21016
         DC    AL1(06)                                           S21016
         DC    AL2(P005+00-P001)                                 S21016
         DC    AL1(30)                                           S21016
         DC    AL2(P070+00-P001)                                 S21016
         DC    AL1(25)                                           S21016
         DC    AL2(P116+00-P001)                                 S21016
         DC    X'FF'                                             S21016
*    IEW0*722*ERROR -*INVALID*ALIAS*NAME.                        A37667
B072     DC    AL1(02)                                           A37667
         DC    AL2(P097+03-P001)                                 A37667
         DC    AL1(06)                                           A37667
         DC    AL2(P005+00-P001)                                 A37667
         DC    AL1(06)                                           A37667
         DC    AL2(P013+00-P001)                                 A37667
         DC    AL1(04)                                           A37667
         DC    AL2(P062+00-P001)                                 A37667
         DC    AL1(03)                                           A37667
         DC    AL2(P072+10-P001)                                 A37667
         DC    X'FF'                                             A37667
* IEW0731 WARNING - ALIAS MATCHES MEMBER NAME - ALIAS IGNORED
B073     DC    AL1(54)                                           A52450
         DC    AL2(P118+00-P001)                                 A52450
         DC    X'FF'                                             A52450
*    IEW0*740 THE INDICATED ACTION WAS TAKEN FOR AN EXPAND REQUEST.
B074     DC    AL1(55)                                           Y01031
         DC    AL2(P117+00-P001)                                 Y01031
         DC    X'FF'                                             Y01031
* IEW0*564*ERROR -*INVALID*TEXT*ORIGIN*- LINKAGE EDITOR PROCESSING TERMX
               INATED.
B056     DC    AL1(02)                                  OX03510,OY03043
         DC    AL2(P233+03-P001)                        OX03510,OY03043
         DC    AL1(06)                                  OX03510,OY03043
         DC    AL2(P005+00-P001)                        OX03510,OY03043
         DC    AL1(06)                                  OX03510,OY03043
         DC    AL2(P013+00-P001)                        OX03510,OY03043
         DC    AL1(03)                                  OX03510,OY03043
         DC    AL2(P017+00-P001)                        OX03510,OY03043
         DC    AL1(05)                                  OX03510,OY03043
         DC    AL2(P068+23-P001)                        OX03510,OY03043
         DC    AL1(37)                                  OX03510,OY03043
         DC    AL2(P110+07-P001)                        OX03510,OY03043
         DC    X'FF'                                    OX03510,OY03043
*
* IEW0*581*WARNING -*INVALID*MEMBER NAME -*WILL TRY TO STORE UNDER 'TEMX
               PNAME'.
*
B058     DC    AL1(02)                                  OX04280,OY03413
         DC    AL2(P001+53-P001)                        OX04280,OY03413
         DC    AL1(08)                                  OX04280,OY03413
         DC    AL2(P042-P001)                           OX04280,OY03413
         DC    AL1(06)                                  OX04280,OY03413
         DC    AL2(P031-P001)                           OX04280,OY03413
         DC    AL1(12)                                  OX04280,OY03413
         DC    AL2(P118+28-P001)                        OX04280,OY03413
         DC    AL1(33)                                  OX04280,OY03413
         DC    AL2(P073-P001)                           OX04280,OY03413
         DC    X'FF'                                    OX04280,OY03413
         HEWAPT
          END
