         TITLE 'HMASMUXD - SMP USER DETERMINATION ROUTINE'
HMASMUXD CSECT ,                                                   0001
@MAINENT DS    0H                                                  0001
         USING *,@15                                               0001
         B     @PROLOG                                             0001
         DC    AL1(16)                                             0001
         DC    C'HMASMUXD  78.334'                                 0001
         DROP  @15
@PROLOG  STM   @14,@12,12(@13)                                     0001
         BALR  @12,0                                               0001
@PSTART  DS    0H                                                  0001
         USING @PSTART,@12                                         0001
         MVC   @PC00001(4),0(@01)                                  0001
*                                                                  0008
*/********************************************************************/
*/*                                                                  */
*/* START_OF_SPECIFICATIONS ******************************************/
*/*                                                                  */
*/* MODULE_NAME = HMASMUXD                                           */
*/*                                                                  */
*/* DESCRIPTIVE_NAME = ROUTINE TO DETERMINE PROPER USER EXIT         */
*/*                                                                  */
*/* COPYRIGHT = NONE                                                 */
*/*                                                                  */
*/* STATUS = HMASMP RELEASE 04                                       */
*/*                                                                  */
*/* FUNCTION = THIS ROUTINE IS PASSED A PARAMETER THAT CONTAINS      */
*/*     A ONE BYTE FUNCTION CODE INDICATING THE USER EXIT            */
*/*     THAT SMP REQUIRES. THE PARAMETER LIST ALSO CONTAINS AN 8     */
*/*     CHARACTER FIELDS USED TO RETURN THE NAME OF THE LOAD         */
*/*     MODULE HMASMP IS TO LOAD AND LINK TO FOR THE USER EXIT.      */
*/*     THE PARAMETER ALSO CONTAINS A FULL WORD USED TO RETURN THE   */
*/*     ADDRESS OF A USER EXIT ROUTINE THAT HMASMP IS TO CALL.       */
*/*     THE FUNCTION OF THIS ROUTINE IS TO SET UP EITHER ONE OF      */
*/*     THE TWO RETURN AREAS IN THE PARM ( OR LEAVE BOTH ASIS        */
*/*     IF NO USER EXIT IS REQUIRED).                                */
*/*        THIS ROUTINE IS BEING SHIPPED WITH HMASMP RELEASE 4       */
*/*     AND WILL ALWAYS LEAVE THE PARAMETERS ASIS TO INDICATE THAT   */
*/*     NO USER EXIT IS PRESENT. EACH USER IS EXPECTED TO REPLACE    */
*/*     THIS MODULE WITH HIS OWN VERSION TO HANDLE HIS UNIQUE USER   */
*/*     EXITS.                                                       */
*/*                                                                  */
*/* SUBROUTINE_CALLING_SEQUENCE = NONE                               */
*/*                                                                  */
*/* OPERATION = SEE BELOW                                            */
*/*                                                                  */
*/*     MAIN ROUTINE OPERATION                                       */
*/*                                                                  */
*/*       1. RETURN WITH RETURN CODE EQUAL TO UXPGOOD IN REGISTER 15 */
*/*                                                                  */
*/* NOTES = NONE                                                     */
*/*                                                                  */
*/*     DEPENDENCIES = NONE                                          */
*/*                                                                  */
*/*     REGISTER_CONVENTIONS = NONE USED                             */
*/*                                                                  */
*/*     PATCH_LABEL = NONE                                           */
*/*                                                                  */
*/* MODULE_TYPE = PROCEDURE                                          */
*/*                                                                  */
*/*     PROCESSOR = PLS                                              */
*/*                                                                  */
*/*     ATTRIBUTES = REUS                                            */
*/*                                                                  */
*/* ENTRY_POINT = HMASMUXD                                           */
*/*                                                                  */
*/*     PURPOSE = SET UXPUXNAM OR UXPUXAD FOR SPECIFIED USER EXIT.   */
*/*                                                                  */
*/*     LINKAGE = STANDARD                                           */
*/*                                                                  */
*/*     INPUT =                                                      */
*/*                                                                  */
*/*          1. HMASMUXP AS DEFINED IN MAPPING MACRO                 */
*/*                                                                  */
*/*     OUTPUT =                                                     */
*/*                                                                  */
*/*          1. HMASMUXP                                             */
*/*             UXPUXNAM - NAME OF USER EXIT LMOD                    */
*/*             UXPUXAD  - ADDRESS OF USER EXIT ROUTINE              */
*/*          2. REGISTER 15                                          */
*/*             SET TO ONE OF DEFINED CODES                          */
*/*                                                                  */
*/* EXIT_NORMAL = RETURN AFTER COMPLETION OF SPECIFIED FUNCTION      */
*/*                                                                  */
*/*     UXPUCNAM OR UXPUXAD SET OR LEFT ASIS                         */
*/*     RETURN CODE IN REGISTER 15                                   */
*/*       00 - EXIT SPECIFIED                                        */
*/*                                                                  */
*/* EXIT_ERROR = SPECIFIED FUNCTION NOT COMPLETED                    */
*/*                                                                  */
*/*     RETURN CODE IN REGISTER 15                                   */
*/*       12 - STOP FUNCTION                                         */
*/*       16 - STOP SMP                                              */
*/*                                                                  */
*/* EXTERNAL_REFERENCES = SEE BELOW                                  */
*/*                                                                  */
*/*     ROUTINES = NONE                                              */
*/*                                                                  */
*/*     DATA_AREAS = NONE                                            */
*/*                                                                  */
*/*     DATA_SETS = NONE                                             */
*/*                                                                  */
*/*     CONTROL_BLOCKS = SEE BELOW                                   */
*/*                                                                  */
*/*       HMASMUXP - SEE MAPPING MACRO                               */
*/*                                                                  */
*/* TABLES = NONE                                                    */
*/*                                                                  */
*/* MACROS = SEE BELOW                                               */
*/*                                                                  */
*/*     HMASMUXP                                                     */
*/*                                                                  */
*/* CHANGE_ACTIVITY = HMASMP RELEASE 04.00                           */
*/*                                                                  */
*/*     04.00 - Z67SP00, INITIAL LEVEL OF SMP RELEASE 04             */
*/*                                                                  */
*/* END_OF_SPECIFICATIONS ********************************************/
*/*                                                                  */
*/********************************************************************/
*                                                                  0008
*                                                                  0008
*   /*****************************************************************/
*   /*                                                               */
*   /* RETURN WITH RETURN CODE INDICATING SUCCESS. NO FIELDS HAVE    */
*   /* BEEN CHANGED IN THE PARAMETER LIST. THIS WILL INDICATE TO     */
*   /* HMASMP THAT NO USER EXITS IS PRESENT.                         */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0008
*   RETURN CODE(UXPGOOD);           /*                               */
         SLR   @15,@15                                             0008
         L     @14,12(,@13)                                        0008
         LM    @00,@12,20(@13)                                     0008
         BR    @14                                                 0008
*   END HMASMUXD                    /*                               */
*                                                                  0009
*/* THE FOLLOWING INCLUDE STATEMENTS WERE FOUND IN THIS PROGRAM.     */
*/*%INCLUDE SYSLIB  (HMASMUXP)                                       */
*                                                                  0009
*       ;                                                          0009
@DATA    DS    0H
         DS    0F
@PC00001 DS    1F
         DS    0F
         DS    0D
@00      EQU   00                      EQUATES FOR REGISTERS 0-15
@01      EQU   01
@02      EQU   02
@03      EQU   03
@04      EQU   04
@05      EQU   05
@06      EQU   06
@07      EQU   07
@08      EQU   08
@09      EQU   09
@10      EQU   10
@11      EQU   11
@12      EQU   12
@13      EQU   13
@14      EQU   14
@15      EQU   15
UX001PRM EQU   0
HMASMUXP EQU   0
         AGO   .@UNREFD                START UNREFERENCED COMPONENTS
UXPMODAD EQU   HMASMUXP+40
UXPCTBAD EQU   HMASMUXP+36
UXPLOEAD EQU   HMASMUXP+32
UXPLOJAD EQU   HMASMUXP+28
UXPPRMAD EQU   HMASMUXP+24
UXPFUNCT EQU   HMASMUXP+16
UXPUXAD  EQU   HMASMUXP+12
UXPUXNAM EQU   HMASMUXP+4
@NM00001 EQU   HMASMUXP+2
UXPUXNUM EQU   HMASMUXP
UX001RCD EQU   UX001PRM+1
UX001RC  EQU   UX001PRM
.@UNREFD ANOP                          END UNREFERENCED COMPONENTS
@ENDDATA EQU   *
         END   HMASMUXD,(C'PLS2238',0802,78334)
