* %/*  START OF SPECIFICATIONS****                             @Y30LB02
.*                                                             @Y30LB02
.*01   MODULE-NAME = ICBASDAS                                  @Y30LB02
.*                                                             @Y30LB02
.*01   DESCRIPTIVE-NAME = ASSOCIATE-DISASSOCIATE MACRO         @Y30LB02
.*                                                             @Y30LB02
.*01   COPYRIGHT = NONE                                        @Y30LB02
.*                                                             @Y30LB02
.*01   STATUS = OS/VS1 RELEASE 4, OS/VS2 RELEASE 3             @Y30LB02
.*                                                             @Y30LB02
.*01   FUNCTION=THIS MACRO BUILDS THE REQUEST BLOCK            @Y30LB02
.*     NECESSARY TO ASSOCIATE/DISASSOCIATE CPU'S IN AN         @Y30LB02
.*     MP ENVIRONMENT                                          @Y30LB02
.*                                                             @Y30LB02
.*01   NOTES = AS FOLLOWS:                                     @Y30LB02
.*                                                             @Y30LB02
.*02     CODE = MACRO IS BILINGUALLY CODED                     @Y30LB02
.*                                                             @Y30LB02
.*02     RESTRICTIONS = THE FOLLOWING PREFIXES SHOULD BE       @Y30LB02
.*                      AVOIDED IN THE USER'S INVOCATION:      @Y30LB02
.*                      ICB AND AS/DAS                         @Y30LB02
.*                                                             @Y30LB02
.*02     REGISTER-CONVENTIONS = FOLLOW NORMAL USE OF           @Y30LB02
.*                              REGISTERS BY MACROS:           @Y30LB02
.*                              R0,R1,R14, AND R15.            @Y30LB02
.*                                                             @Y30LB02
.*01   MODULE-TYPE = MACRO                                     @Y30LB02
.*                                                             @Y30LB02
.*02     PROCESSOR = PLS2 AND ASSEMBLER                        @Y30LB02
.*                                                             @Y30LB02
.*02     ATTRIBUTES = REUSABLE                                 @Y30LB02
.*                                                             @Y30LB02
.*02     ENTRY-POINT = ICBASDAS                                @Y30LB02
.*                                                             @Y30LB02
.*                                                             @Y30LB02
.*02     LINKAGE = SVC 126                                     @Y30LB02
.*                                                             @Y30LB02
.*01  INPUT                                                    @Y30LB02
.*                                                             @Y30LB02
.*   THE ASSOCIATE-DISASSOCIATE MACRO IS ISSUED TO             @Y30LB02
.*   CHANGE THE RELATIONSHIP BETWEEN CPU'S(HOSTS) OF           @Y30LB02
.*   TIGHTLY COUPLED MP SYSTEMS  AND  NETWORKS.                @Y30LB02
.*                                                             @Y30LB02
.*   THE ASSOCIATE-DISASSOCIATE MACRO WILL                     @Y30LB02
.*   PERFORM THE FOLLOWING:                                    @Y30LB02
.*                                                             @Y30LB02
.*        (1)  ASSOCIATE CPU AND ITS PREDEFINED ASSOCIATE      @Y30LB02
.*             CPU AS TIGHTLY COUPLED MP  CPU'S.               @Y30LB02
.*                                                             @Y30LB02
.*        (2)  DISASSOCIATE CPU1 AND ITS PREDEFINED ASSOCIATE  @Y30LB02
.*             CPU.                                            @Y30LB02
.*                                                             @Y30LB02
.*                                                             @Y30LB02
.*        (3)  DEINITIALIZE THE INTERFACE FOR THE              @Y30LB02
.*             ASSOCIATED CPU                                  @Y30LB02
.*                                                             @Y30LB02
.*        (4)  DEMOUNT ALL VOLUMES FOR BOTH CPUS               @Y30LB02
.*                                                             @Y30LB02
.*        MACRO SYNTAX:                                        @Y30LB02
.*                                                             @Y30LB02
.*   LIST FORM                                                 @Y30LB02
.*                                                             @Y30LB02
.* VERB    REQUIRED PARMS        OPTIONAL PARMS                @Y30LB02
.*                                                             @Y30LB02
.*ICBASDAS MF=L - (BAL)          MF=(L,MAP) - BAL              @Y30LB02
.*         MF(L,NAME/(R))-PLS    MF(L,NAME/(R),ATTR)-PLS       @Y30LB02
.*                                                             @Y30LB02
.*   STANDARD FORM                                             @Y30LB02
.*                                                             @Y30LB02
.* VERB    REQUIRED PARMS        OPTIONAL PARMS                @Y30LB02
.*                                                             @Y30LB02
.*ICBASDAS HOSTID=ADDR/(R)       NONE                          @Y30LB02
.*         FLAGS=ADDR/(R)                                      @Y30LB02
.*                                                             @Y30LB02
.*                                                             @Y30LB02
.* EXECUTE FORM                                                @Y30LB02
.*                                                             @Y30LB02
.* VERB    REQUIRED PARMS        OPTIONAL PARMS                @Y30LB02
.*                                                             @Y30LB02
.*ICBASDAS MF(E,NAME/(R))       MF(E,NAME/(R),COMPLETE)-PLS    @Y30LB02
.*                              FLAGS=ADDR/(R)                 @Y30LB02
.*                              HOSTID=ADDR/(R)                @Y30LB02
.*                                                             @Y30LB02
.*   KEYWORD PARAMETERS:                                       @Y30LB02
.*                                                             @Y30LB02
.*   MF  -  MACRO FORMAT: THIS PARAMETER DESCRIBES THE         @Y30LB02
.*          MACRO FORMAT AND MAY GIVE THE ADDRESS OR           @Y30LB02
.*          ADDRESS IN A REGISTER WHERE THE REQUEST BLOCK      @Y30LB02
.*          IS STORED.                                         @Y30LB02
.*                                                             @Y30LB02
.*          L - LIST FORM: THE EXPANSION OF THE L-FORM         @Y30LB02
.*              MACRO WILL RESULT IN A REQUEST BLOCK WITH      @Y30LB02
.*              THE ONLY NON-ZERO FIELDS BEING THE OPCODE      @Y30LB02
.*              AND LENGTH FIELDS.                             @Y30LB02
.*                                                             @Y30LB02
.*          (1) 'MAP' - IF MAP IS SPECIFIED WITH THE           @Y30LB02
.*              ASSEMBLER MACRO CALL A DSECT EQUIVALENT TO     @Y30LB02
.*              A MAPPING MACRO IS PRODUCED.                   @Y30LB02
.*                                                             @Y30LB02
.*          (2) NAME - THE MACRO INVOKER MUST SPECIFY A        @Y30LB02
.*              NAME FOR HIS STRUCTURE WHEN INVOKING THE       @Y30LB02
.*              PLS LIST FORM.                                 @Y30LB02
.*                                                             @Y30LB02
.*          (3) ATTRIBUTE - THE MACRO WILL PLACE ANY PLS       @Y30LB02
.*              ATTRIBUTE SPECIFIED IN THE MACRO INVOCATION    @Y30LB02
.*              IN AN UNINITIALIZED REQUEST BLOCK.  ATTRI-     @Y30LB02
.*              BUTE EXAMPLE:                                  @Y30LB02
.*                                                             @Y30LB02
.*              CHAR, FIXED, STATIC LOCAL, NONLOCAL,           @Y30LB02
.*              BASED(*), ETC.                                 @Y30LB02
.*                                                             @Y30LB02
.*       NULL - STANDARD FORM: THE EXPANSION OF THIS FORM      @Y30LB02
.*              CONSISTS OF A REQUEST BLOCK, A LINKAGE         @Y30LB02
.*              INSTRUCTION, AND, POSSIBLY, PARAMETER          @Y30LB02
.*              BINDING INSTRUCTION.                           @Y30LB02
.*                                                             @Y30LB02
.*          E - EXECUTABLE FORM: THE EXPANSION OF THIS FORM    @Y30LB02
.*              CONSISTS OF A LINKAGE INSTRUCTION AND          @Y30LB02
.*              POSSIBLY, PARAMETER BINDING INSTRUCTIONS.      @Y30LB02
.*                                                             @Y30LB02
.*              SUB-PARAMETERS                                 @Y30LB02
.*                                                             @Y30LB02
.*              (1)  AN E MUST BE SPECIFIED IN THE FIRST       @Y30LB02
.*                   SUB-PARAMETER POSITION.  THIS INDICATES   @Y30LB02
.*                   THAT THE MACRO IS IN EXECUTABLE FORM.     @Y30LB02
.*                                                             @Y30LB02
.*              (2)  A NAME OR A REGISTER MUST BE SPECIFIED    @Y30LB02
.*                   IN THE SECOND SUB-PARAMETER.              @Y30LB02
.*                                                             @Y30LB02
.*              (3)  'COMPLETE' - COMPLETE WILL CAUSE THE      @Y30LB02
.*                   MACRO TO ZERO OUT THE REQUEST BLOCK.      @Y30LB02
.*                   AFTER ZEROING THE REQUEST BLOCK THE       @Y30LB02
.*                   FUNCTION OPCODE AND LENGTH ARE PLACED     @Y30LB02
.*                   IN THE REQUEST BLOCK.                     @Y30LB02
.*                                                             @Y30LB02
.*   FLAGS  - THE 2 BYTE FIELD WHICH INDICATES THE FUNCTION    @Y30LB02
.*            TO BE PERFORMED.  THE ATTRIBUTES FOLLOW:         @Y30LB02
.*                                                             @Y30LB02
.*       ASSOCIATE CPU                                         @Y30LB02
.*                                                             @Y30LB02
.*         IF THIS ATTRIBUTE IS SPECIFIED, CPU (SPECIFIED      @Y30LB02
.*         BY HOSTID) AND ITS PREDEFINED ASSOCIATE CPU WILL    @Y30LB02
.*         BE ASSOCIATED AS TIGHTLY COUPLED MP HOSTS.          @Y30LB02
.*                                                             @Y30LB02
.*       DISASSOCIATE CPU                                      @Y30LB02
.*                                                             @Y30LB02
.*         IF THIS ATTRIBUTE IS SPECIFIED, CPU (SPECIFIED      @Y30LB02
.*         BY HOSTID) AND ITS PREDEFINED ASSOCIATED CPU        @Y30LB02
.*         WILL NO LONGER BE ASSOCIATED AS TIGHTLY COUPLED     @Y30LB02
.*         MP HOSTS.                                           @Y30LB02
.*                                                             @Y30LB02
.*        DEINITIALIZE INTERFACE                               @Y30LB02
.*                                                             @Y30LB02
.*         THIS BIT HAS THE SAME FUNCTION AS ATTRIBUTE         @Y30LB02
.*         BIT 1 PLUS DEINITIALIZE THE INTERFACE FOR THE       @Y30LB02
.*         OTHER CPU SPECIFIED IN THE CPU ASSOCIATION          @Y30LB02
.*         TABLE.  IF THE CPU'S ARE ALREADY DISASSOCIATED      @Y30LB02
.*         THE ORDER IS UNIT CHECKED.                          @Y30LB02
.*                                                             @Y30LB02
.*        DEMOUNT                                              @Y30LB02
.*                                                             @Y30LB02
.*         THIS ATTRIBUTE HAS THE SAME FUNCTION AS             @Y30LB02
.*         ATTRIBUTE BIT 0 EXCEPT ALL VOLUMES FOR BOTH         @Y30LB02
.*         CPU'S ARE DEMOUNTED.  THE FUNCTION IS DONE          @Y30LB02
.*         EVEN THOUGH THE CPU'S ARE ALREADY ASSOCIATED.       @Y30LB02
.*                                                             @Y30LB02
.*                                                             @Y30LB02
.*       THE FORMAT OF THE FLAGS FIELD IS                      @Y30LB02
.*                                                             @Y30LB02
.*      ____________________________________________________   @Y30LB02
.*      | X | X | 0 | 0 | 0 | X | X |BITS 7-15 MUST BE ZERO|   @Y30LB02
.*      -----------------------------------------------------  @Y30LB02
.*      BIT 0------------'1'B          ASSOCIATE CPUS          @Y30LB02
.*                       '0'B          DON'T ASSOCIATE         @Y30LB02
.*                                                             @Y30LB02
.*      BIT 1------------'1'B          DISASSOCIATE CPUS       @Y30LB02
.*                       '0'B          DON'T DISASSOCIATE      @Y30LB02
.*                                                             @Y30LB02
.*      BITS 2-4 --------              |RESERVED,MUST BE ZERO| @Y30LB02
.*                                                             @Y30LB02
.*      BIT 5------------'1'B          DEINITIALIZE INTERFACE  @Y30LB02
.*                       '0'B          DON'T DENITIALIZE       @Y30LB02
.*                                                             @Y30LB02
.*      BIT 6------------'1'B          DEMOUNT                 @Y30LB02
.*                       '0'B          DON'T DEMOUNT           @Y30LB02
.*                                                             @Y30LB02
.*      BITS 7-15-------               |UNUSED,MUST BE ZERO|   @Y30LB02
.*                                                             @Y30LB02
.*      HOSTID - HOSTID IDENTIFIER:  THE 5 BYTE AREA WHICH     @Y30LB02
.*               CONTAINS THE MANUFACTURER'S CPU IDENTI-       @Y30LB02
.*               FICATION OF CPU #1 OR CPU #2 OF A MP          @Y30LB02
.*               OR NETWORK ENVIRONMENT.                       @Y30LB02
.*                                                             @Y30LB02
.*01  EXIT-NORMAL = VALID INVOCATION                           @Y30LB02
.*                                                             @Y30LB02
.*                                                             @Y30LB02
.*02     CONDITION = RETURN CODE = 0                           @Y30LB02
.*                                                             @Y30LB02
.*02     OUTPUT = IN-LINE PLS/BAL STATEMENTS THAT PERFORM      @Y30LB02
.*       THE REQUESTED FUNCTION                                @Y30LB02
.*                                                             @Y30LB02
.*01  EXIT-ERROR = INVALID INVOCATION                          @Y30LB02
.*                                                             @Y30LB02
.*02     CONDITION = RETURN CODE = 12                          @Y30LB02
.*                                                             @Y30LB02
.*02     OUTPUT = ERROR MESSAGE AS A COMMENT AT POINT OF       @Y30LB02
.*                INVOCATION                                   @Y30LB02
.*                                                             @Y30LB02
.*01  EXTERNAL REFERENCES = NONE                               @Y30LB02
.*                                                             @Y30LB02
.*                                                             @Y30LB02
.*01  TABLES = NONE                                            @Y30LB02
.*                                                             @Y30LB02
.*01  MESSAGES = AS FOLLOWS:                                   @Y30LB02
.*     ICB602I:  A NAME FOR THE REQUEST BLOCK MUST BE          @Y30LB02
.*               SPECIFIED IN MF(2)                            @Y30LB02
.*     ICB604I:  WARNING ONLY THE MF  PARAMETER  IS            @Y30LB02
.*               VALID FOR LIST FORM                           @Y30LB02
.*     ICB607I:  FLAGS MUST BE SPECIFIED FOR STANDARD          @Y30LB02
.*               FORM MACRO                                    @Y30LB02
.*     ICB608I:  HOSTID MUST BE SPECIFIED FOR STANDARD         @Y30LB02
.*               FORM MACRO                                    @Y30LB02
.*     ICB612I:  MF(2) MUST CONTAIN REQ BLK NAME IF            @Y30LB02
.*               EXEC MACRO FORM REQUESTED                     @Y30LB02
.*     ICB615I:  INVALID MF PARAMETER SPECIFIED, MUST BE       @Y30LB02
.*                L,E, OR NULL                                 @Y30LB02
.*                                                             @Y30LB02
.*01  CONTROL-BLOCKS = NONE                                    @Y30LB02
.*                                                             @Y30LB02
.*01  INNER MACROS = NONE                                      @Y30LB02
.*                                                             @Y30LB02
.*01  SYSTEM MACRO = IHBINNRA                                  @Y30LB02
.*                                                             @Y30LB02
.*01  CHANGE-ACTIVITY = S/D X04AC02 & Y30LB02                  @Y30LB02
.*                                                             @Y30LB02
.**** END OF SPECIFICATIONS ***                                @Y30LB02
         MACRO
&SYMBOL  ICBASDAS &MF=,&FLAGS=,&HOSTID=
         LCLB &ERSW               ERROR SWITCH                 @Y30LB02
         LCLC &ASDAS              ASSOC MACRO INSTR INDX       @Y30LB02
&ASDAS   SETC 'ASD'.'&SYSNDX'     ASSIGN CHARACTER VALUE       @Y30LB02
.*                                                             @Y30LB02
.*       DETERMINATION OF DESIRED MACRO FORM                   @Y30LB02
.*                                                             @Y30LB02
         AIF  ('&MF(1)' NE 'L').EFORM       LIST FORM?         @Y30LB02
         AIF  ('&FLAGS' EQ '' AND '&HOSTID' EQ '').LISTOK      @AS17746
         MNOTE 4,'  ICB604I - WARNING-ONLY THE MF  '           @Y30LB02
         MNOTE 4,'  PARAMETER IS VALID FOR LIST FORM '         @Y30LB02
.*                                                             @Y30LB02
.LISTOK  ANOP                                                  @Y30LB02
*  MACMEAN  ASSOCIATE MACRO--INITIALIZED LIST FORM             @Y30LB02
*  VS1-4/VS2-3 VERSION--06/09/74   LEVEL 00                    @Y30LB02
         AIF  ('&MF(2)' EQ 'MAP').LISTDS   DSECT REQUESTED?    @Y30LB02
&SYMBOL  DS   0F                                               @Y30LB02
ASDALEN  DC   F'16'               LENGTH OF ASSOC REQ BLOCK    @Y30LB02
ASDAOPC  DC   XL1'2C'             ASSOCIATE  FUNCTION OPCODE   @Y30LB02
ASDA001  DC   XL1'00'             1-BYTE RESERVED AREA         @Y30LB02
ASDAFLG  DC   XL2'0000'           2-BYTE FLAGS AREA            @Y30LB02
ASDACPU  DC   CL5'00000'          5-BYTE HOSTID AREA           @Y30LB02
ASDA002  DC   XL3'000000'         3-BYTE RESERVED AREA         @Y30LB02
         AGO  .FINISH                                          @Y30LB02
.*                                                             @Y30LB02
.LISTDS  ANOP                                                  @Y30LB02
*  MACMEAN  ASSOCIATE MACRO--UNINITIALIZED LIST FORM           @Y30LB02
*  VS1-4/VS2-3 VERSION--06/09/74   LEVEL 00                    @Y30LB02
ICBASDAS DSECT                                                 @Y30LB02
ASDALEN  DS   F                   LENGTH OF ASSOC 16 DEC       @Y30LB02
ASDAOPC  DS   XL1                 ASSOCIATE OPCODE 2C HEX      @Y30LB02
ASDA001  DS   XL1                 1-BYTE RESERVED AREA-ZERO    @Y30LB02
ASDAFLG  DS   XL2                 2-BYTE FLAGS AREA            @Y30LB02
ASDACPU  DS   CL5                 5-BYTE HOSTID AREA           @Y30LB02
ASDA002  DS   XL3                 3-BYTE RESERVED AREA         @Y30LB02
         AGO  .FINISH                                          @Y30LB02
.*                                                             @Y30LB02
.*       THE FOLLOWING PROCESSING IS ACCOMPLISHED FOR THE      @Y30LB02
.*       EXECUTABLE MACRO FORM                                 @Y30LB02
.*                                                             @Y30LB02
.EFORM   AIF  ('&MF(1)' NE 'E').SFORM       EXECUTE FORM?      @Y30LB02
         AIF  ('&MF(2)' EQ '').EXFAIL       MF(2) NULL?        @Y30LB02
*  MACMEAN  ASSOCIATE MACRO--EXECUTE FORM                      @Y30LB02
*  VS1-4/VS2-3 VERSION--06/09/74   LEVEL 00                    @Y30LB02
&SYMBOL  IHBINNRA &MF(2)          LOAD REG ONE USING           @Y30LB02
.*                                IHBINNRA MACRO               @Y30LB02
         LA   0,16                LEN OF ASSOC REQBLK          @Y30LB02
         ST   0,0(1)              STORE LEN IN REQBLK          @Y30LB02
         MVI  4(1),X'2C'          ASSOC OPCODE IN BLK          @Y30LB02
         AGO  .CKSW1                                           @Y30LB02
.*                                                             @Y30LB02
.EXFAIL  ANOP                                                  @Y30LB02
         MNOTE 12,'  ICB612I - MF(2) MUST CONTAIN REQ BLK '    @Y30LB02
         MNOTE 12,'  NAME IF EXEC MACRO FORM IS REQUESTED '    @Y30LB02
&ERSW    SETB 1                   SET ERROR SWITCH TO 1        @Y30LB02
.*                                                             @Y30LB02
.CKSW1   AIF  (&ERSW).FINISH      IF ERROR-END PROCESSING      @Y30LB02
         AGO  .COMMON                                          @Y30LB02
.*                                                             @Y30LB02
.*       PROCESSING OF THE STANDARD FORM MACRO                 @Y30LB02
.*                                                             @Y30LB02
.SFORM   AIF  ('&MF(1)' NE '').BADFORM      STANDARD FORM?     @Y30LB02
         AIF  ('&FLAGS' NE '').CKHOST       FLAGS SPECIFIED?   @Y30LB02
&ERSW    SETB 1                   SET ERROR SWITCH TO 1        @Y30LB02
         MNOTE 12,'  ICB607I - FLAGS MUST BE SPECIFIED '       @Y30LB02
         MNOTE 12,'  FOR STANDARD FORM MACRO '                 @Y30LB02
         AGO  .CKSW2                                           @Y30LB02
.CKHOST  AIF  ('&HOSTID' NE '').CKSW2    HOSTID SPECIFIED?     @Y30LB02
&ERSW    SETB 1                   SET ERROR SWITCH TO 1        @Y30LB02
         MNOTE 12,'  ICB608I - HOSTID MUST BE SPECIFIED '      @Y30LB02
         MNOTE 12,'  FOR STANDARD FORM MACRO '                 @Y30LB02
         AGO  .CKSW2                                           @Y30LB02
.*                                                             @Y30LB02
.BADFORM ANOP                                                  @Y30LB02
&ERSW    SETB 1                   SET ERROR SWITCH TO 1        @Y30LB02
         MNOTE 12,'  ICB615I - INVALID MF PARAMETER '          @Y30LB02
         MNOTE 12,'  SPECIFIED, MUST BE L, E, OR NULL.'        @Y30LB02
.*                                                             @Y30LB02
.*       THE FOLLOWING CODE CHECKS TO DETERMINE IF THE ERROR   @Y30LB02
.*       SWITCH IS ON. IF YES, PROCESSING IS TERMINATED, OTHER @Y30LB02
.*       WISE STANDARD FORM MACRO PROCESSING WILL BE CON-      @Y30LB02
.*       TINUED                                                @Y30LB02
.*                                                             @Y30LB02
.CKSW2   AIF  (&ERSW).FINISH      IF YES-END PROCESSING        @Y30LB02
*  MACMEAN ASSOCIATE MACRO--STANDARD FORM                      @Y30LB02
*  VS1-4/VS2-3 VERSION--06/09/74   LEVEL 00                    @Y30LB02
         CNOP 0,4                                              @Y30LB02
&SYMBOL  BAL  1,&ASDAS            SET R1 ADDR OF REQBLK        @Y30LB02
ASDALEN  DC   A(&ASDAS-*)         LENGTH OF REQUEST BLOCK      @Y30LB02
ASDAOPC  DC   XL1'2C'             ASSOCIATE  FUNCTION OPCODE   @Y30LB02
ASDA001  DC   XL1'00'             1-BYTE RESERVED AREA         @Y30LB02
ASDAFLG  DC   XL2'0000'           2-BYTE FLAGS AREA            @Y30LB02
ASDACPU  DC   CL5'00000'          5-BYTE HOSTID AREA           @Y30LB02
ASDA002  DC   XL3'000000'         3-BYTE RESERVED AREA         @Y30LB02
&ASDAS   EQU  *                                                @Y30LB02
.*                                                             @Y30LB02
.*       THE FOLLOWING CODE CHECKS FOR VALID PARAMETERS IF     @Y30LB02
.*       STANDARD OR EXECUTE FORM MACRO IS SPECIFIED.          @Y30LB02
.*       IF PARAMETERS ARE SPECIFIED, THEY WILL BE STORED      @Y30LB02
.*       IN THE REQUEST BLOCK.                                 @Y30LB02
.*                                                             @Y30LB02
.COMMON  AIF  ('&FLAGS' EQ '').HOSTD       FLAGS SPECIFIED?    @Y30LB02
         AIF  ('&FLAGS'(1,1) EQ '(').FLREG  FLAGS IN REG-FORM? @Y30LB02
         MVC  6(2,1),&FLAGS       PUT FLAGS IN PARM LIST       @Y30LB02
         AGO  .HOSTD              BRANCH TO CK HOSTID          @Y30LB02
.*                                                             @Y30LB02
.FLREG   ANOP                                                  @Y30LB02
         MVC  6(2,1),0(&FLAGS(1)) REG-FORM PLACE FLAGS IN BLK  @Y30LB02
.*                                                             @Y30LB02
.HOSTD   AIF  ('&HOSTID' EQ '').INVOKE      HOSTID SPECIFIED?  @Y30LB02
         AIF  ('&HOSTID'(1,1) EQ '(').HREG  REGISTER FORM?     @Y30LB02
         MVC  8(5,1),&HOSTID      ADDRFORM-PUT HOSTID IN BLK   @Y30LB02
         AGO  .INVOKE                                          @Y30LB02
.*                                                             @Y30LB02
.HREG    ANOP                                                  @Y30LB02
         MVC  8(5,1),0(&HOSTID(1)) REGFORM-PUT HOSTID IN BLK   @Y30LB02
.INVOKE  ANOP                                                  @Y30LB02
         SVC  126                 INVOKE THE SVC               @Y30LB02
.FINISH  MEND                                                  @Y30LB02
**/
*   ICBASDAS: MACRO KEYS(MF,FLAGS,HOSTID);                 /*@Y30LB02*/
*/*                                                          @Y30LB02*/
*/*                     EXTERNAL DECLARES                    @Y30LB02*/
*/*********************************************************  @Y30LB02*/
*/*      ASDATEST IS USED TO DETERMINE WHETHER THE STANDARD  @Y30LB02*/
*/*      FORM MACRO HAS BEEN INVOKED MORE THAN ONCE BY THE   @Y30LB02*/
*/*      SAME CALLER.                                        @Y30LB02*/
*/*********************************************************  @Y30LB02*/
*/*      ASTESTR1 WILL BE USED TO DETERMINE IF IT IS NECES-  @Y30LB02*/
*/*      SARY TO DECLARE R1 OR WHETHER IT IS ALREADY DCLD    @Y30LB02*/
*/*********************************************************  @Y30LB02*/
*/*                                                          @Y30LB02*/
*   DCL  ASTESTR1  FIXED  EXT;    /*REG1 DECLARE COUNTER     @Y30LB02*/
*   DCL  ASDATEST  FIXED  EXT;    /*STANDARD INVOC COUNTER   @Y30LB02*/
*/*                                                          @Y30LB02*/
*/*      INTERNAL DECLARES                                   @Y30LB02*/
*   DCL  ASDOP   CHAR;       /*DEFINE ASSOC OPCODE           @Y30LB02*/
*   DCL  ASDLEN  CHAR;       /*DECLARE LENGTH OF ORDER       @Y30LB02*/
*   DCL  ERSW     FIXED;     /*DECLARE ERROR COND SWITCH     @Y30LB02*/
*   DCL  RETCODE  FIXED;     /*DECLARE RETURN CODE AREA      @Y30LB02*/
*   DCL  CTR      FIXED;     /*DECLARE CTR FOR LIST FORM     @Y30LB02*/
*        ERSW=0;             /*INITIALIZE ERROR SWITCH       @Y30LB02*/
*        RETCODE=0;          /*INITIALIZE RETURN CODE        @Y30LB02*/
*        ASDLEN='10';        /*INITIALIZE LENGTH             @Y30LB02*/
*        ASDOP='2C';         /*INITIALIZE OPCODE             @Y30LB02*/
*        CTR=0;              /*INITIALIZE PARM CTR           @Y30LB02*/
*/********************************************************   @Y30LB02*/
*/*      CHECK FOR VALID MACRO FORM--E INDICATES EXECUTE     @Y30LB02*/
*/*      FORM, L INDICATES LIST FORM AND IF THE MF PARA-     @Y30LB02*/
*/*      METER IS NULL THE STANDARD FORM MACRO IS INVOKED    @Y30LB02*/
*/********************************************************   @Y30LB02*/
*        IF ASTESTR1=0 THEN   /*REGISTER ONE DECLARED?       @Y30LB02*/
*             DO;             /*NO,DECLARE REGISTER ONE      @Y30LB02*/
*                  ANS('DCL ASDAR1 REG(1) PTR;/*PTR'||
*                  ' TO REQUEST BLOCK @Y30LB02*/')SKIP;
*                  ASTESTR1=ASTESTR1+1; /*INCREM REG CTR     @Y30LB02*/
*             END;           /*                              @Y30LB02*/
*   IF MF(1) ^= 'L' THEN     /*IS IT LIST FORM?              @Y30LB02*/
*        GO TO EFORM;        /*NO, CK FOR EXEC               @Y30LB02*/
*   IF MF(2) = '' THEN       /*LIST NAME SPECIFIED?          @Y30LB02*/
*        DO;                 /*NO, DO ERROR PROCESSING       @Y30LB02*/
*             ERSW=1;        /*SET ERROR SWITCH TO ONE       @Y30LB02*/
*             RETCODE=12;    /*SET RETURN CODE TO 12         @Y30LB02*/
*             ANS MSG('  ICB602I - A NAME FOR THE REQUEST BLOCK '||
*             'MUST BE SPECIFIED IN MF(2) ')SKIP;          /*@Y30LB02*/
*             GO TO FINISH;  /*BRANCH TO END PROCESSING      @Y30LB02*/
*        END;                /*                              @Y30LB02*/
*/*                                                          @Y30LB02*/
*   IF FLAGS ^= '' THEN      /*IS THE FLAGS AREA NULL        @Y30LB02*/
*        CTR=CTR+1;          /*INCREMENT PARAMETER COUNTER   @Y30LB02*/
*   IF HOSTID ^= '' THEN     /*IS THE HOSTID AREA NULL       @Y30LB02*/
*        CTR=CTR+1;          /*INCREMENT PARAMETER COUNTER   @Y30LB02*/
*   IF CTR > 0 THEN          /*INCREMENT CTR > ZERO?         @Y30LB02*/
*        DO;                 /*DO ERROR PROCESSING           @Y30LB02*/
*           RETCODE=4;     /*SET RETRUN CODE TO 4            @Y30LB02*/
*           ANS MSG('  ICB604I - WARNING-ONLY THE MF PARAMETER'||
*             ' IS VALID FOR LIST FORM')SKIP;              /*@Y30LB02*/
*        END;                /*                              @Y30LB02*/
*   IF MF(3) ^= '' THEN      /*PLS ATTRIBUTE SPECIFIED?      @Y30LB02*/
*        GO TO ATTRLST;      /*BRANCH TO UNINITL LIST FORM   @Y30LB02*/
*/*                                                          @Y30LB02*/
*             ANS('/*******************************************'||
*                 '************** @Y30LB02*/')SKIP;
*             ANS('/*     MACMEAN  MSSC ASSOCIATE MACRO        '||
*                 '               @Y30LB02*/')SKIP;
*             ANS('/*VS1-4/VS2-3 VERSION--06/09/74 LEVEL 00    '||
*                 '               @Y30LB02*/')SKIP;
*             ANS('/*THIS IS THE INITIALIZED LIST FORM         '||
*                 '               @Y30LB02*/')SKIP;
*             ANS('/*******************************************'||
*                 '************** @Y30LB02*/')SKIP;
*             ANS('DCL 1 '||MF(2)||'  STATIC LOCAL,'||
*             ' /*ASSOCIATE REQUEST BLOCK @Y30LB02*/')SKIP;
*             ANS('    2  ASDALEN  FIXED(31)INIT('||QUOTE
*             ('10')||'X),/*LENG OF ASSOC REQ BLK @Y30LB02*/')SKIP;
*             ANS('    2  ASDAOPC CHAR(1)INIT('||QUOTE('2C')||
*             'X),/*ASSOCIATE OPCODE @Y30LB02*/')SKIP;
*             ANS('    2  ASDA001 CHAR(1)INIT('||QUOTE('00')||
*             'X),/*RESERVED AND ZERO @Y30LB02*/')SKIP;
*             ANS('    2  ASDAFLG BIT(16)INIT('||QUOTE
*             ('0000000000000000')||'B),/*TWO BYTE ATTRI'||
*             'BUTE AREA @Y30LB02*/')SKIP;
*             ANS('       3  ASASSOC BIT(1),/*ASSOCIATE'||
*             ' ATTRIBUTE @Y30LB02*/')SKIP;
*             ANS('       3  ASDASSOC BIT(1),/*DISASSOCIATE'||
*             ' ATTRIBUTE @Y30LB02*/')SKIP;
*             ANS('       3  *    BIT(3),/*THREE BITS'||
*             ' RESERVE @Y30LB02*/')SKIP;
*             ANS('       3  ASDEINT BIT(1),/*DISASSOC'||
*             ' AND DEINITIALIZE THE INTERFACE FOR THE'||
*             ' OTHER CPU SPECIFIED IN THE CPU ASSOCIATE'||
*             ' TABLE @Y30LB02*/')SKIP;
*             ANS('       3  ASDMNT BIT(1),/*ASSOC'||
*             ' CPUS AND DEMOUNT ALL VOLUMES FOR BOTH'||
*             ' CPUS @Y30LB02*/')SKIP;
*             ANS('       3  *      BIT(9),/*RESERVED AND'||
*             ' MUST BE ZERO @Y30LB02*/')SKIP;
*             ANS('    2  ASDACPU  CHAR(5) INIT('||QUOTE
*             ('0000000000')||'X),/*HOSTID @Y30LB02*/')SKIP;
*             ANS('    2  ASDA002  CHAR(3) INIT('||QUOTE
*             ('000000')||'X);/*RESERVED AREA @Y30LB02*/')SKIP;
*             GO TO FINISH;                                /*@Y30LB02*/
*/*                                                          @Y30LB02*/
*ATTRLST:
*             ANS('/*******************************************'||
*                 '************** @Y30LB02*/')SKIP;
*             ANS('/*      MACMEAN  MSSC ASSOCIATE MACRO       '||
*                 '               @Y30LB02*/')SKIP;
*             ANS('/*VS1-4/VS2-3 VERSION--06/09/74 LEVEL 00    '||
*                 '               @Y30LB02*/')SKIP;
*             ANS('/*THIS IS THE UNINITIALIZED LIST FORM       '||
*                 '               @Y30LB02*/')SKIP;
*             ANS('/*******************************************'||
*                 '************** @Y30LB02*/')SKIP;
*             ANS('DCL 1 '||MF(2)||' '||MF(3)||','||
*             ' /*ASSOCIATE REQUEST BLOCK @Y30LB02*/')SKIP;
*             ANS('    2  ASDALEN  FIXED(31),/*LENG'||
*             'TH OF ASSOCIATE REQ BLOCK=10 HEX @Y30LB02*/')SKIP;
*             ANS('    2  ASDAOPC CHAR(1),'||
*             '/*ASSOCIATE OPCODE=2C HEX @Y30LB02*/')SKIP;
*             ANS('    2  ASDA001 CHAR(1),'||
*             ' /*RESERVED AND ZERO @Y30LB02*/')SKIP;
*             ANS('    2  ASDAFLG BIT(16),'||
*             '/*TWO BYTE ATTRIBUTE AREA @Y30LB02*/')SKIP;
*             ANS('       3  ASASSOC BIT(1),/*ASSOCIATE'||
*             ' ATTRIBUTE @Y30LB02*/')SKIP;
*             ANS('       3  ASDASSOC BIT(1),/*DISASSOCIATE'||
*             ' ATTRIBUTE @Y30LB02*/')SKIP;
*             ANS('       3  *    BIT(3),/*THREE BITS'||
*             ' RESERVE @Y30LB02*/')SKIP;
*             ANS('       3  ASDEINT BIT(1),/*DISASSOC'||
*             ' AND DEINITIALIZE THE INTERFACE FOR THE'||
*             ' OTHER CPU SPECIFIED IN THE CPU ASSOCIATE'||
*             ' TABLE @Y30LB02*/')SKIP;
*             ANS('       3  ASDMNT BIT(1),/*ASSOC'||
*             ' CPUS AND DEMOUNT ALL VOLUMES FOR BOTH'||
*             ' CPUS @Y30LB02*/')SKIP;
*             ANS('       3  *      BIT(9),/*RESERVED AND'||
*             ' MUST BE ZERO @Y30LB02*/')SKIP;
*             ANS('    2  ASDACPU  CHAR(5),/*HOSTID @Y30LB02*/')SKIP;
*             ANS('    2  ASDA002  CHAR(3);/*RESERVED'||
*             ' AREA @Y30LB02*/')SKIP;
*             GO TO FINISH;                                /*@Y30LB02*/
*/*                                                          @Y30LB02*/
*/*      PROCESSING THE EXECUTE MACRO FORM                   @Y30LB02*/
*/*                                                          @Y30LB02*/
*EFORM:
*   IF MF(1) ^= 'E' THEN     /*EXCUTE FORM                   @Y30LB02*/
*        GO TO SFORM;        /*NO, CK FOR STANDARD           @Y30LB02*/
*   IF MF(2) = '' THEN       /*YES,LIST NAME SPECD?          @Y30LB02*/
*        DO;                 /*DO ERROR PROCESSING           @Y30LB02*/
*             ERSW=1;        /*SET ERROR SWITCH TO ONE       @Y30LB02*/
*             RETCODE=12;    /*SET ERROR RETURN CODE TO 12   @Y30LB02*/
*             ANS MSG('  ICB612I - MF(2) MUST CONTAIN'||
*                ' REQ BLK NAME IF EXEC '||
*                ' MACRO FORM REQUESTED')SKIP;             /*@Y30LB02*/
*             GO TO CKSW;    /*BRCH TO CK ERROR CONDITION    @Y30LB02*/
*        END;                /*                              @Y30LB02*/
*/*                                                          @Y30LB02*/
*   ELSE                     /*EXECUTE FORM PROCESSING       @Y30LB02*/
*/*                                                          @Y30LB02*/
*        ANS('/*******************************************'||
*            '************* @Y30LB02*/')SKIP;
*        ANS('/*     MACMEAN  MSSC ASSOCIATE MACRO        '||
*            '              @Y30LB02*/')SKIP;
*        ANS('/*VS1-4/VS2-3 VERSION-- 06/09/74 LEVEL 00   '||
*            '              @Y30LB02*/')SKIP;
*        ANS('/*THIS IS THE OUTPUT FOR THE EXECUTE FORM.  '||
*            '              @Y30LB02*/')SKIP;
*        ANS('/*THE LIST FORM OF THIS MACRO SHOULD BE     '||
*            '              @Y30LB02*/')SKIP;
*        ANS('/*INVOKED FIRST IN ORDER TO SET UP NECESSARY'||
*            '              @Y30LB02*/')SKIP;
*        ANS('/*DECLARES.  IF THE COMPLETE ARGUMENT IS    '||
*            '              @Y30LB02*/')SKIP;
*        ANS('/*SPECIFIED THE REQ BLOCK WILL BE ZEROED.   '||
*            '              @Y30LB02*/')SKIP;
*        ANS('/*******************************************'||
*            '************* @Y30LB02*/')SKIP;
*        ANS('RFY(ASDAR1)RSTD;/*RESTRICT REG 1 @Y30LB02*/')SKIP;
*        ANS('ASDAR1=ADDR('||MF(2)||');/*R1 POINTER TO'||
*        ' REQUEST BLOCK @Y30LB02*/')SKIP;
*   IF MF(3) = 'COMPLETE' THEN   /*COMPLETE SPECIFIED        @Y30LB02*/
*     DO;                        /*ZERO REQ BLOCK            @Y30LB02*/
*        ANS(' '||MF(2)||'='||MF(2)||'&&'||MF(2)||';'||    /*@Y30LB02*/
*        '/*ZERO BLOCK @Y30LB02*/')SKIP;
*     END;                       /*                          @Y30LB02*/
*        ANS('ASDALEN= '||QUOTE(ASDLEN)||'X;/* '||
*        'LENGTH OF ASSOC REQUEST @Y30LB02*/')SKIP;
*        ANS('ASDAOPC= '||QUOTE(ASDOP)||'X;/*ASSOCIATE'||
*        ' OPCODE @Y30LB02*/')SKIP;
*/*                                                          @Y30LB02*/
*CKSW:
*   IF ERSW=1 THEN             /*ERROR SWITCH EQ ONE?        @Y30LB02*/
*        GO TO FINISH;         /*YES,BRANCH TO END           @Y30LB02*/
*   ELSE                       /*NO,CK PARAMETERS            @Y30LB02*/
*        GO TO COMPROC;        /*BRANCH TO CK PARAMETERS     @Y30LB02*/
*/*                                                          @Y30LB02*/
*SFORM:
*   IF MF(1) ^= '' THEN        /*STANDARD FORM               @Y30LB02*/
*     DO;                      /*NO,DO ERROR PROCESSING      @Y30LB02*/
*        ERSW=1;               /*SET ERROR SWITCH TO ONE     @Y30LB02*/
*        RETCODE=12;           /*SET RETURN CODE TO 12       @Y30LB02*/
*        ANS MSG('  ICB615I - INVALID MF PARAMETER '||
*                'SPECIFIED, MUST BE L, E, OR NULL')SKIP;  /*@Y30LB02*/
*        GO TO CKSW2;          /*BRANCH TO CK ERROR SWITCH   @Y30LB02*/
*     END;                                                 /*@Y30LB02*/
*/*                                                          @Y30LB02*/
*   IF FLAGS = '' THEN         /*FLAGS SPECIFIED?            @Y30LB02*/
*     DO;                      /*NO,DO ERROR PROCESSING      @Y30LB02*/
*        ERSW=1;               /*SET ERROR SWITCH TO 1       @Y30LB02*/
*        RETCODE=12;           /*SET RETURN CODE TO 12       @Y30LB02*/
*        ANS MSG('  ICB607I - FLAGS MUST BE SPECIFIED  '||
*        'FOR STANDARD FORM MACRO')SKIP;                   /*@Y30LB02*/
*        GO TO CKSW2;          /*BRANCH TO CK SWITCH         @Y30LB02*/
*     END;                     /*                            @Y30LB02*/
*   IF HOSTID = '' THEN        /*HOSTID SPECIFIED?           @Y30LB02*/
*     DO;                      /*DO ERROR PROCESSING         @Y30LB02*/
*        ERSW=1;               /*SET ERROR CODE TO ONE       @Y30LB02*/
*        RETCODE=12;           /*SET RETURN CODE TO 12       @Y30LB02*/
*        ANS MSG('  ICB608I - HOSTID MUST BE SPECIFIED  '||
*        'FOR STANDARD FORM MACRO')SKIP;                   /*@Y30LB02*/
*     END;                     /*                            @Y30LB02*/
*/*                                                          @Y30LB02*/
*CKSW2:
*/*                                                          @Y30LB02*/
*   IF ERSW = 1 THEN           /*ERROR SWITCH EQUAL 1?       @Y30LB02*/
*        GO TO FINISH;         /*YES,BRANCH TO END           @Y30LB02*/
*/*                                                          @Y30LB02*/
*   IF ASDATEST = 1 THEN       /*FIRST STANDARD FORM?        @Y30LB02*/
*     DO;                      /*NO,PUT OUT NO DCLS          @Y30LB02*/
*        ANS('/*******************************************'||
*            '************** @Y30LB02*/')SKIP;
*        ANS('/*     MACMEAN  MSSC ASSOCIATE MACRO        '||
*            '               @Y30LB02*/')SKIP;
*        ANS('/*VS1-4/VS2-3 VERSION--06/09/74 LEVEL 00    '||
*            '               @Y30LB02*/')SKIP;
*        ANS('/*THIS IS THE OUTPUT FOR A SECONDARY        '||
*            '               @Y30LB02*/')SKIP;
*        ANS('/*INVOCATION OF THE STANDARD FORM MACRO     '||
*            '               @Y30LB02*/')SKIP;
*        ANS('/*******************************************'||
*            '************** @Y30LB02*/')SKIP;
*        ANS('RFY(ASDAR1)RSTD;/*RESTRICT REG 1 @Y30LB02*/')SKIP;
*        ANS('ASDAR1=ADDR(ASDALEN);/*R1 PTR TO BLK @Y30LB02*/')SKIP;
*        ANS('ASDALEN= '||QUOTE(ASDLEN)||'X;/* '||
*        'LENGTH OF ASSOC REQUEST @Y30LB02*/')SKIP;
*        ANS('ASDAOPC='||QUOTE(ASDOP)||'X;/*ASSOC'||
*        ' OPCODE @Y30LB02*/')SKIP;
*        GO TO COMPROC;      /*BRANCH TO CK PARAMETERS       @Y30LB02*/
*     END;                   /*                              @Y30LB02*/
*/*                                                          @Y30LB02*/
*   ELSE                     /*PUT OUT THE DECLARES          @Y30LB02*/
*     DO;                    /*STANDARD FIRST TIME           @Y30LB02*/
*        ANS('/*******************************************'||
*            '************** @Y30LB02*/')SKIP;
*        ANS('/*    MACMEAN  MSSC ASSOCIATE MACRO         '||
*            '               @Y30LB02*/')SKIP;
*        ANS('/*VS1-4/VS2-3 VERSION--06/09/74 LEVEL 00    '||
*            '               @Y30LB02*/')SKIP;
*        ANS('/*THIS IS THE STANDARD FORM  MACRO          '||
*            '               @Y30LB02*/')SKIP;
*        ANS('/*******************************************'||
*            '************** @Y30LB02*/')SKIP;
*        ANS('RFY(ASDAR1)RSTD;/*RESTRICT REG 1 @Y30LB02*/')SKIP;
*        ANS('ASDAR1=ADDR(ASDALEN);/*R1 PTR  '||
*        'TO REQUEST BLOCK @Y30LB02*/')SKIP;
*        ANS('DCL 1 ASDALST  STATIC LOCAL,'||
*        ' /*ASSOCIATE REQUEST BLOCK @Y30LB02*/')SKIP;
*        ANS('    2  ASDALEN  FIXED(31)INIT('||QUOTE
*        ('10')||'X),/*LENG OF ASSOC REQ BLK @Y30LB02*/')SKIP;
*        ANS('    2  ASDAOPC CHAR(1)INIT('||QUOTE('2C')||
*        'X),/*ASSOCIATE OPCODE @Y30LB02*/')SKIP;
*        ANS('    2  *      CHAR(1)INIT('||QUOTE('00')||
*        'X),/*RESERVED AND ZERO @Y30LB02*/')SKIP;
*        ANS('    2  ASDAFLG BIT(16)INIT('||QUOTE
*        ('0000000000000000')||'B),/*TWO BYTE ATTRI'||
*        'BUTE AREA @Y30LB02*/')SKIP;
*        ANS('       3  ASASSOC BIT(1),/*ASSOCIATE'||
*        ' ATTRIBUTE @Y30LB02*/')SKIP;
*        ANS('       3  ASDASSOC BIT(1),/*DISASSOCIATE'||
*        ' ATTRIBUTE @Y30LB02*/')SKIP;
*        ANS('       3  *     BIT(1),/*THREE BITS'||
*        ' RESERVE @Y30LB02*/')SKIP;
*        ANS('       3  ASDEINT BIT(1),/*DISASSOC'||
*        ' AND DEINITIALIZE THE INTERFACE FOR THE'||
*        ' OTHER CPU SPECIFIED IN THE CPU ASSOCIATE'||
*        ' TABLE @Y30LB02*/')SKIP;
*        ANS('       3  ASDMNT BIT(1),/*ASSOC'||
*        ' CPUS AND DEMOUNT ALL VOLUMES FOR BOTH'||
*        ' CPUS @Y30LB02*/')SKIP;
*        ANS('       3  *      BIT(9),/*RESERVED AND'||
*        ' MUST BE ZERO @Y30LB02*/')SKIP;
*        ANS('    2  ASDACPU  CHAR(5) INIT('||QUOTE
*        ('0000000000')||'X),/*HOSTID @Y30LB02*/')SKIP;
*        ANS('    2  ASDA002  CHAR(3) INIT('||QUOTE
*        ('000000')||'X);/*RESERVED AREA @Y30LB02*/')SKIP;
*        ASDATEST=ASDATEST+1; /*INCREM STD FORM CTR          @Y30LB02*/
*        GO TO COMPROC;       /*BRANCH,CK PARAMETERS         @Y30LB02*/
*     END;                    /*                             @Y30LB02*/
*/*                                                          @Y30LB02*/
*/*********************************************************  @Y30LB02*/
*/*      COMMON PROCESSING FOR EXECUTE AND STANDARD FORMS    @Y30LB02*/
*/*      THE FOLLOWING CODE WILL CHECK TO DETERMINE WHICH    @Y30LB02*/
*/*      PARAMETERS ARE SPECIFIED AND PLACE THE VALUE IN     @Y30LB02*/
*/*      THE REQUEST BLOCK                                   @Y30LB02*/
*/*********************************************************  @Y30LB02*/
*COMPROC:
*   IF FLAGS ^= '' THEN      /*FLAGS SPECIFIED?              @Y30LB02*/
*        ANS('ASDAFLG= '||FLAGS||';/*VALUE OF FLAGS '||
*        'PARAMETER @Y30LB02*/')SKIP;
*/*                                                          @Y30LB02*/
*   IF HOSTID ^= '' THEN    /*HOSTID SPECIFIED?              @Y30LB02*/
*        ANS('ASDACPU= '||HOSTID||';/*HOSTID @Y30LB02*/')SKIP;
*/*                                                          @Y30LB02*/
*/********************************************************   @Y30LB02*/
*/*      THIS SECTION OF CODE WILL INVOKE SVC 126 AND        @Y30LB02*/
*/*      SET THE PROPER RETURN CODE, THEN END PROCESSING     @Y30LB02*/
*/********************************************************   @Y30LB02*/
*/********************************************************   @Y30LB02*/
*        ANS('SVC (126);/*INVOKE THE SVC  @Y30LB02*/')SKIP;
*        ANS('RFY  ASDAR1 UNRSTD;/*UNRESTRICT REG 1 @Y30LB02*/')SKIP;
*/*                                                          @Y30LB02*/
*FINISH:
*        RETURN CODE(RETCODE);                             /*@Y30LB02*/
*        %END;                                             /*@Y30LB02*/
