* %/*  START OF SPECIFICATIONS****                             @Y30LB02
.*                                                             @Y30LB02
.*01   MODULE-NAME = ICBCOVC                                   @Y30LB02
.*                                                             @Y30LB02
.*01   DESCRIPTIVE-NAME = COPY VOLUME/CARTRIDGE MACRO          @Y30LB02
.*                                                             @Y30LB02
.*01   COPYRIGHT = NONE                                        @Y30LB02
.*                                                             @Y30LB02
.*01   STATUS = OS/VS1 RELEASE 4, OS/VS2 RELEASE 3             @Y30LB02
.*                                                             @Y30LB02
.*01   FUNCTION = REQUEST COPY VOLUME/CART OF MSS DATA         @Y30LB02
.*                                                             @Y30LB02
.*01   NOTES = AS FOLLOWS:                                     @Y30LB02
.*                                                             @Y30LB02
.*02     CODE = MACRO IS BILINGUALLY CODED                     @Y30LB02
.*                                                             @Y30LB02
.*02     RESTRICTIONS = THE FOLLOWING PREFIXES SHOULD BE       @Y30LB02
.*                      AVOIDED IN THE USER'S INVOCATION:      @Y30LB02
.*                      ICB, CVO, AND CCRT.                    @Y30LB02
.*                                                             @Y30LB02
.*02  REGISTER-CONVENTIONS = FOLLOWS NORMAL USE OF REGISTERS   @Y30LB02
.*                              BY MACROS: R0,R1,R14, AND R15  @Y30LB02
.*                                                             @Y30LB02
.*01   MODULE-TYPE = MACRO                                     @Y30LB02
.*                                                             @Y30LB02
.*02     PROCESSOR = PLS AND ASSEMBLER                         @Y30LB02
.*                                                             @Y30LB02
.*02     ATTRIBUTES = REUSABLE                                 @Y30LB02
.*                                                             @Y30LB02
.*02     ENTRY-POINT = ICBCOVC                                 @Y30LB02
.*                                                             @Y30LB02
.*02     PURPOSE = THE ICBCOVC MACRO SERVES AS A COMMUNI-      @Y30LB02
.*       CATIONS LINK BETWEEN THE MSSC CALLER AND THE          @Y30LB02
.*       MSSC SVC ROUTINE.                                     @Y30LB02
.*                                                             @Y30LB02
.*02     LINKAGE =  SVC 126                                    @Y30LB02
.*                                                             @Y30LB02
.*01  INPUT = PARAMETERS SPECIFIED ON THE PLS/BAL MACRO        @Y30LB02
.*            INVOCATION                                       @Y30LB02
.*                                                             @Y30LB02
.*   THE ICBCOVC MACRO REQUEST IS ISSUED TO SATISFY COPY       @Y30LB02
.*                                                             @Y30LB02
.*   VOLUME AND COPY CARTRIDGE REQUESTS.                       @Y30LB02
.*                                                             @Y30LB02
.*   THE COPY VOLUME (CVOL) REQUEST IS ISSUED IF THE CALLER    @Y30LB02
.*   WISHES TO:                                                @Y30LB02
.*                                                             @Y30LB02
.*   (1)  CAUSE REAL 3330I DASD TO BE COPIED TO A SUBSYSTEM    @Y30LB02
.*        VOLUME.                                              @Y30LB02
.*                                                             @Y30LB02
.*   (2)  CAUSE A SUBSYSTEM VOLUME TO BE COPIED TO REAL        @Y30LB02
.*        3330I DASD.                                          @Y30LB02
.*                                                             @Y30LB02
.*   (3)  CAUSE A VIRTUAL VOLUME TO BE COPIED TO A VIRTUAL     @Y30LB02
.*        VOLUME HAVING THE SAME VOLID BUT NOT ACTIVE.         @Y30LB02
.*                                                             @Y30LB02
.*   (4)  CAUSE A VIRTUAL VOLUME SPECIFIED BY CSN1 TO BE       @Y30LB02
.*        COPIED TO A VIRTUAL VOLUME HAVING THE SAME VOLID     @Y30LB02
.*        AND ACTIVE.                                          @Y30LB02
.*                                                             @Y30LB02
.*   THE COPY CARTRIDGE (CCRT) REQUEST IS ISSUED IF THE        @Y30LB02
.*   CALLER WISHES TO CAUSE A CARTRIDGE TO BE COPIED TO A      @Y30LB02
.*   DIFFERENT CARTRIDGE.                                      @Y30LB02
.*                                                             @Y30LB02
.*   MACRO SYNTAX                                              @Y30LB02
.*                                                             @Y30LB02
.*   LIST FORM                                                 @Y30LB02
.*                                                             @Y30LB02
.* VERB    REQUIRED PARMS        OPTIONAL PARMS                @Y30LB02
.*                                                             @Y30LB02
.*ICBCOVC  MF=L - (BAL)          MF=(L,MAP) - BAL              @Y30LB02
.*         MF(L,NAME/(R))-PLS    MF(L,NAME/(R),ATTR)-PLS       @Y30LB02
.*         TYPE=CCRT/CVOL                                      @Y30LB02
.*                                                             @Y30LB02
.*   STANDARD FORM                                             @Y30LB02
.*                                                             @Y30LB02
.* VERB    REQUIRED PARMS        OPTIONAL PARMS                @Y30LB02
.*                                                             @Y30LB02
.*ICBCOVC  TYPE=CCRT/CVOL        VOLID=ADDR/(R)                @Y30LB02
.*         FLAGS=ADDR/(R)        CSN=ADDR/(R)                  @Y30LB02
.*         ECB=ADDR/(R)          RUA=ADDR/(R)                  @Y30LB02
.*                                                             @Y30LB02
.* EXECUTE FORM                                                @Y30LB02
.*                                                             @Y30LB02
.* VERB    REQUIRED PARMS        OPTIONAL PARMS                @Y30LB02
.*                                                             @Y30LB02
.*ICBCOVC  MF(E,NAME/(R))       MF(E,NAME/(R),COMPLETE)-PLS    @Y30LB02
.*         TYPE=CCRT/CVOL       VOLID=ADDR/(R)                 @Y30LB02
.*                              ECB=ADDR/(R)                   @Y30LB02
.*                              CSN=ADDR/(R)                   @Y30LB02
.*                              RUA=ADDR/(R)                   @Y30LB02
.*                              FLAGS=ADDR/(R)                 @Y30LB02
.*                              VVICEXT=ADDR/(R)               @Y30LB02
.*                                                             @Y30LB02
.*   KEYWORD PARAMETERS:                                       @Y30LB02
.*                                                             @Y30LB02
.*                                                             @Y30LB02
.*  TYPE -  TYPE:  INDICATES WHETHER THE REQUEST FOR THE       @Y30LB02
.*          THE COPY VOLUME(CVOL) OR THE COPY CARTRIDGE        @Y30LB02
.*          (CCRT) FUNCTION.  IF CVOL IS SPECIFIED, HEX        @Y30LB02
.*          '2A' IS PLACED IN THE OPCODE FIELD.  FOR           @Y30LB02
.*          TYPE=CCRT, HEX '28' IS PLACED IN THE OPCODE        @Y30LB02
.*          FIELD.                                             @Y30LB02
.*                                                             @Y30LB02
.*   MF  -  MACRO FORMAT: THIS PARAMETER DESCRIBES THE         @Y30LB02
.*          MACRO FORMAT AND MAY GIVE THE ADDRESS OR           @Y30LB02
.*          ADDRESS IN A REGISTER WHERE THE REQUEST BLOCK      @Y30LB02
.*          IS STORED.                                         @Y30LB02
.*                                                             @Y30LB02
.*          L - LIST FORM: THE EXPANSION OF THE L-FORM         @Y30LB02
.*              MACRO WILL RESULT IN A REQUEST BLOCK WITH      @Y30LB02
.*              THE ONLY NON-ZERO FIELDS BEING THE OPCODE      @Y30LB02
.*              AND LENGTH FIELDS.                             @Y30LB02
.*                                                             @Y30LB02
.*          (1) 'MAP' - IF MAP IS SPECIFIED WITH THE           @Y30LB02
.*              ASSEMBLER MACRO CALL A DSECT EQUIVALENT TO     @Y30LB02
.*              A MAPPING MACRO IS PRODUCED.                   @Y30LB02
.*                                                             @Y30LB02
.*          (2) NAME - THE MACRO INVOKER MUST SPECIFY A        @Y30LB02
.*              NAME FOR HIS STRUCTURE WHEN INVOKING THE       @Y30LB02
.*              PLS LIST FORM.                                 @Y30LB02
.*                                                             @Y30LB02
.*          (3) ATTRIBUTE - THE MACRO WILL PLACE ANY PLS       @Y30LB02
.*              ATTRIBUTE SPECIFIED IN THE MACRO INVOCATION    @Y30LB02
.*              IN AN UNINITIALIZED REQUEST BLOCK.  ATTRI-     @Y30LB02
.*              BUTE EXAMPLE:                                  @Y30LB02
.*                                                             @Y30LB02
.*              CHAR, FIXED, STATIC LOCAL, NONLOCAL,           @Y30LB02
.*              BASED(*), ETC.                                 @Y30LB02
.*                                                             @Y30LB02
.*       NULL - STANDARD FORM: THE EXPANSION OF THIS FORM      @Y30LB02
.*              CONSISTS OF A REQUEST BLOCK, A LINKAGE         @Y30LB02
.*              INSTRUCTION, AND, POSSIBLY, PARAMETER          @Y30LB02
.*              BINDING INSTRUCTIONS.                          @Y30LB02
.*                                                             @Y30LB02
.*          E - EXECUTABLE FORM: THE EXPANSION OF THIS FORM    @Y30LB02
.*              CONSISTS OF A LINKAGE INSTRUCTION AND          @Y30LB02
.*              POSSIBLY, PARAMETER BINDING INSTRUCTIONS.      @Y30LB02
.*                                                             @Y30LB02
.*              SUB-PARAMETERS                                 @Y30LB02
.*                                                             @Y30LB02
.*              (1)  AN E MUST BE SPECIFIED IN THE FIRST       @Y30LB02
.*                   SUB-PARAMETER POSITION.  THIS INDICATES   @Y30LB02
.*                   THAT THE MACRO IS IN EXECUTABLE FORM.     @Y30LB02
.*                                                             @Y30LB02
.*              (2)  A NAME OR A REGISTER MUST BE SPECIFIED    @Y30LB02
.*                   IN THE SECOND SUB-PARAMETER.              @Y30LB02
.*                                                             @Y30LB02
.*              (3)  'COMPLETE' - COMPLETE WILL CAUSE THE      @Y30LB02
.*                   MACRO TO ZERO OUT THE REQUEST BLOCK.      @Y30LB02
.*                   AFTER ZEROING THE REQUEST BLOCK THE       @Y30LB02
.*                   FUNCTION OPCODE AND LENGTH ARE PLACED     @Y30LB02
.*                   IN THE REQUEST BLOCK.                     @Y30LB02
.*                                                             @Y30LB02
.*   FLAGS - FLAGS: THE FIELD WHICH INDICATES THE FUNCTION(S)  @Y30LB02
.*   TO BE PERFORMED.  THE FORMAT OF THE FLAGS FIELD IS        @Y30LB02
.*   SHOWN BELOW:                                              @Y30LB02
.*                                                             @Y30LB02
.*   --------------------------------------------              @Y30LB02
.*   | X | X | X | X |BITS 4-15 UNUSED AND ZERO |              @Y30LB02
.*   --------------------------------------------              @Y30LB02
.*   IF CVOL (COPY VOLUME) IS SPECIFIED FOR THE TYPE           @Y30LB02
.*   PARAMETER:                                                @Y30LB02
.*                                                             @Y30LB02
.*   BIT 0-------'1'B   TRANSFER DATA FROM DASD TO             @Y30LB02
.*                      CARTRIDGE(S)                           @Y30LB02
.*               '0'B   NOT DASD TO CARTRIDGE                  @Y30LB02
.*                                                             @Y30LB02
.*   BIT 1-------'1'B   TRANSFER DATA FROM                     @Y30LB02
.*                      CARTRIDGE(S) TO DASD                   @Y30LB02
.*               '0'B   NOT CARTRIDGE TO DASD                  @Y30LB02
.*                                                             @Y30LB02
.*   BIT 2-------'1'B   TRANSFER DATA FROM CARTRIDGE           @Y30LB02
.*                      TO CARTRIDGE (TRANSIENT)               @Y30LB02
.*               '0'B   NOT CARTRIDGE TO CARTRIDGE             @Y30LB02
.*                                                             @Y30LB02
.*   BIT 3-------'1'B   TRANSFER DATA FROM CARTRIDGE           @Y30LB02
.*                      TO CARTRIDGE (INVENTORY)               @Y30LB02
.*               '0'B   NOT CARTRIDGE TO CARTRIDGE             @Y30LB02
.*                                                             @Y30LB02
.*   BITS 4-15---       NOT USED AND MUST BE ZERO              @Y30LB02
.*                                                             @Y30LB02
.*   NOTE:  BITS 0-3 ARE MUTUALLY EXCLUSIVE.                   @Y30LB02
.*                                                             @Y30LB02
.*   PACK TO CARTRIDGE                                         @Y30LB02
.*                                                             @Y30LB02
.*          IF THIS ATTRIBUTE IS SPECIFIED, THEN, DATA         @Y30LB02
.*          FROM A REAL 3330I DASD PACK (SPECIFIED BY RUA)     @Y30LB02
.*          WILL BE COPIED TO A SUBSYSTEM VOLUME (SPECIFIED    @Y30LB02
.*          BY VOLID).                                         @Y30LB02
.*                                                             @Y30LB02
.*          PACK TO CARTRIDGE REQUIRED PARAMETERS: TYPE,       @Y30LB02
.*          FLAGS, ECB, VOLID, AND RUA.                        @Y30LB02
.*          OPTIONAL PARAMETER:  VVICEXT                       @Y30LB02
.*                                                             @Y30LB02
.*   CARTRIDGE TO PACK                                         @Y30LB02
.*                                                             @Y30LB02
.*          IF THIS ATTRIBUTE IS SPECIFIED, THEN, DATA         @Y30LB02
.*          FROM A SUBSYSTEM VOLUME (SPECIFIED BY VOLID)       @Y30LB02
.*          IS COPIED TO A REAL 3330I DASD PACK (SPECIFIED     @Y30LB02
.*          BY RUA).                                           @Y30LB02
.*                                                             @Y30LB02
.*          CARTRIDGE TO PACK REQUIRED PARAMETERS: TYPE,       @Y30LB02
.*          FLAGS, ECB, VOLID, AND RUA.                        @Y30LB02
.*          OPTIONAL PARAMETER:  VVICEXT                       @Y30LB02
.*                                                             @Y30LB02
.*   CARTRIDGE TO CARTRIDGE(INVENTORY TO TRANSIENT)            @Y30LB02
.*                                                             @Y30LB02
.*          IF THIS ATTRIBUTE IS SPECIFIED, THEN, DATA         @Y30LB02
.*          FROM A SUBSYSTEM VOLUME SPECIFIED BY VOLID         @Y30LB02
.*          WILL BE COPIED TO ANOTHER SUBSYSTEM VOLUME         @Y30LB02
.*          SPECIFIED BY CARTRIDGE SERIAL NUMBER (CSN).        @Y30LB02
.*                                                             @Y30LB02
.*          CARTRIDGE TO CARTRIDGE REQUIRED PARAMETERS:        @Y30LB02
.*          TYPE, FLAGS, ECB, VOLID, AND CSN.                  @Y30LB02
.*          OPTIONAL PARAMETER:  VVICEXT                       @Y30LB02
.*                                                             @Y30LB02
.*   CARTRIDGE TO CARTRIDGE(TRANSIENT TO INVENTORY)            @Y30LB02
.*                                                             @Y30LB02
.*          IF THIS ATTRIBUTE IS SPECIFIED, THEN, DATA         @Y30LB02
.*          FROM A SUBSYSTEM VOLUME SPECIFIED BY CSN1 WILL     @Y30LB02
.*          BE COPIED TO ANOTHER SUBSYSTEM VOLUME SPECIFIED    @Y30LB02
.*          BY VOLID.                                          @Y30LB02
.*                                                             @Y30LB02
.*          CARTRIDGE TO CARTRIDGE REQUIRED PARAMETERS:        @Y30LB02
.*          TYPE, FLAGS, ECB, VOLID, AND CSN.                  @Y30LB02
.*          OPTIONAL PARAMETER:  VVICEXT                       @Y30LB02
.*                                                             @Y30LB02
.*   IF CCRT (COPY CARTRIDGE) IS SPECIFIED FOR THE TYPE        @Y30LB02
.*   PARAMETER:                                                @Y30LB02
.*                                                             @Y30LB02
.*   BIT 0-------'1'B   CARTRIDGE 1 OF 2 IS BEING COPIED       @Y30LB02
.*               '0'B   NOT CARTRIDGE ONE                      @Y30LB02
.*                                                             @Y30LB02
.*   BIT 1-------'1'B   CARTRIDGE 2 OF 2 IS BEING COPIED       @Y30LB02
.*               '0'B   NOT CARTRIDGE TWO                      @Y30LB02
.*                                                             @Y30LB02
.*   BITS 2-15---       NOT USED AND MUST BE ZERO              @Y30LB02
.*                                                             @Y30LB02
.*   NOTE:  BITS 0-1 ARE MUTUALLY EXCLUSIVE.                   @Y30LB02
.*                                                             @Y30LB02
.*   CARTRIDGE 1 OF 2:                                         @Y30LB02
.*                                                             @Y30LB02
.*          IF THIS ATTRIBUTE IS SPECIFIED, THEN THE FIRST     @Y30LB02
.*          CARTRIDGE OF A 2 CARTRIDGE VOLUME(SPECIFIED BY     @Y30LB02
.*          VOLID) IS COPIED TO A DIFFERENT CARTRIDGE WHICH    @Y30LB02
.*          IS SPECIFIED BY CSN.                               @Y30LB02
.*                                                             @Y30LB02
.*          CARTRIDGE 1 OF 2 REQUIRED PARAMETERS:              @Y30LB02
.*          TYPE, FLAGS, ECB, VOLID, AND CSN.                  @Y30LB02
.*                                                             @Y30LB02
.*   CARTRIDGE 2 OF 2:                                         @Y30LB02
.*                                                             @Y30LB02
.*          IF THIS ATTRIBUTE IS SPECIFIED, THEN, THE          @Y30LB02
.*          SECOND CARTRIDGE OF A 2 CARTRIDGE VOLUME(SPECI-    @Y30LB02
.*          FIED BY VOLID) IS COPIED TO A DIFFERENT            @Y30LB02
.*          CARTRIDGE WHICH IS SPECIFIED BY CSN.               @Y30LB02
.*                                                             @Y30LB02
.*          CARTRIDGE 2 OF 2 REQUIRED PARAMETERS:              @Y30LB02
.*          TYPE, FLAGS, ECB, VOLID, AND CSN.                  @Y30LB02
.*                                                             @Y30LB02
.*   VOLID - VOLUME IDENTIFIER: THE VOLUME IDENTIFIER OF THE   @Y30LB02
.*           VOLUME TO BE COPIED.                              @Y30LB02
.*                                                             @Y30LB02
.*   CSN   - CARTRIDGE SERIAL NUMBER: A 12 BYTE AREA WHICH     @Y30LB02
.*           CONTAINS THE CARTRIDGE SERIAL NUMBER.             @Y30LB02
.*                                                             @Y30LB02
.*   ECB   - THE NAME OF THE EVENT CONTROL BLOCK (ECB) TO BE   @Y30LB02
.*           POSTED WHEN THE REQUEST IS COMPLETE.  THE USER    @Y30LB02
.*           MUST ALSO DECLARE A MINIMUM 50 BYTE CONTIGUOUS    @Y30LB02
.*           AREA TO CONTAIN THE MESSAGE GENERATED BY THE      @Y30LB02
.*           MESSAGE TASK.  (THE ECB AND APPENDED DATA AREA    @Y30LB02
.*           MUST BE IN COMMON CORE IN VS/2).  THE ECB IS      @Y30LB02
.*           POSTED WITH '7F'X FOR SUCCESSFUL (IN LOW-ORDER    @Y30LB02
.*           BYTE OF ECB).  THE MSC DATA WILL BE MOVED         @Y30LB02
.*           TO CORE LOCATION ADDRESS(ECB)+4.  ECB             @Y30LB02
.*           MUST BE SPECIFIED AND THE ECB AREA MUST BE        @Y30LB02
.*           CLEARED (SET TO BINARY 0) BEFORE INVOKING         @Y30LB02
.*           THE MACRO.                                        @Y30LB02
.*                                                             @Y30LB02
.*   RUA   - REAL UNIT ADDRESS: THE REAL UNIT DESIGNATED TO    @Y30LB02
.*           RECEIVE THE SUBSYSTEM DATA.  MUST BE SPECIFIED    @Y30LB02
.*           WITH EACH STANDARD FORM COPY VOLUME REQUEST       @Y30LB02
.*           WHICH SPECIFIES PACK TO CARTRIDGE OR CARTRIDGE    @Y30LB02
.*           TO PACK.                                          @Y30LB02
.*                                                             @Y30LB02
.*                                                             @Y30LB02
.* VVICEXT - THE NAME OF AN AREA WHICH CONTAINS THE MSVC       @Y30LB02
.*           EXTENSION (VVICEXT) MAPPING.  IF THIS PARAMETER   @Y30LB02
.*           IS NOT SPECIFIED, THE CORRESPONDING POSITION IN   @Y30LB02
.*           THE REQUEST BLOCK MUST BE SET TO ZERO.  THE       @Y30LB02
.*           MAPPING MACRO FOR THE MSVC EXTENSION TO COPY      @Y30LB02
.*           VOLUME IS IEZCOVCE (VVICEXT IS NOT A VALID        @Y30LB02
.*           PARAMETER FOR THE COPY CARTRIDGE REQUEST).        @Y30LB02
.*                                                             @Y30LB02
.*01  EXIT-NORMAL = VALID INVOCATION                           @Y30LB02
.*                                                             @Y30LB02
.*02     CONDITION = RETURN CODE = 0                           @Y30LB02
.*                                                             @Y30LB02
.*02     OUTPUT = IN-LINE PLS/BAL STATEMENTS THAT PERFORM      @Y30LB02
.*                THE REQUESTED FUNCTION                       @Y30LB02
.*                                                             @Y30LB02
.*01  EXIT-ERROR = INVALID INVOCATION                          @Y30LB02
.*                                                             @Y30LB02
.*02     CONDITION = RETURN CODE = 12                          @Y30LB02
.*                                                             @Y30LB02
.*02     OUTPUT = ERROR MESSAGE AS A COMMENT AT POINT OF       @Y30LB02
.*                INVOCATION                                   @Y30LB02
.*                                                             @Y30LB02
.*01  EXTERNAL REFERENCES = NONE                               @Y30LB02
.*                                                             @Y30LB02
.*01  TABLES = NONE                                            @Y30LB02
.*                                                             @Y30LB02
.*01  MESSAGES = AS FOLLOWS:                                   @Y30LB02
.*     ICB600I:  TYPE MUST BE SPECIFIED                        @Y30LB02
.*     ICB601I:  TYPE IS INCORRECTLY SPECIFIED                 @Y30LB02
.*     ICB602I:  A NAME FOR THE REQUEST BLOCK MUST BE          @Y30LB02
.*               SPECIFIED IN MF(2)                            @Y30LB02
.*     ICB603I:  WARNING-ONLY MF AND TYPE PARAMETERS ARE       @Y30LB02
.*               VALID FOR LIST FORM                           @Y30LB02
.*     ICB605I:  ECB MUST BE SPECIFIED FOR STANDARD            @Y30LB02
.*               FORM MACRO                                    @Y30LB02
.*     ICB607I:  FLAGS MUST BE SPECIFIED FOR STANDARD          @Y30LB02
.*               FORM MACRO                                    @Y30LB02
.*     ICB610I:  VOLID MUST BE SPECIFIED FOR STANDARD          @Y30LB02
.*               FORM MACRO                                    @Y30LB02
.*     ICB616I:  RUA MUST BE SPECIFIED FOR STANDARD            @Y30LB02
.*               FORM MACRO                                    @Y30LB02
.*     ICB612I:  MF(2) MUST CONTAIN REQ BLK NAME               @Y30LB02
.*               IF EXEC MACRO FORM REQUESTED                  @Y30LB02
.*     ICB613I:  MISSING REQ BLK NAME OR MORE                  @Y30LB02
.*               THAN 2 SUBPARAMETERS FOR MF                   @Y30LB02
.*     ICB615I:  INVALID MF PARAMETER SPECIFIED, MUST          @Y30LB02
.*                BE E, L, OR NULL                             @Y30LB02
.*01  CONTROL-BLOCKS = NONE                                    @Y30LB02
.*                                                             @Y30LB02
.*01  INNER MACROS = NONE                                      @Y30LB02
.*                                                             @Y30LB02
.*01  SYSTEM MACRO = NONE                                      @Y30LB02
.*                                                             @Y30LB02
.*01  CHANGE-ACTIVITY = S/D X04AC02 AND Y30LB02                @Y30LB02
.*                                                             @Y30LB02
.**** END OF SPECIFICATIONS ***                                @Y30LB02
         MACRO
&SYMBOL  ICBCOVC &MF=,&TYPE=,&FLAGS=,&ECB=,&RUA=,&VOLID=,              *
               &CSN=,&VVICEXT=
         LCLC  &LBL                DEFINE MACRO INSTR INDX     @Y30LB02
         LCLB  &ERSW               DEFINE ERROR SWITCH         @Y30LB02
&LBL     SETC  'CVC'.'&SYSNDX'     ASSIGN CHARACTER VALUE      @Y30LB02
.*                                                             @Y30LB02
.*       CHECK FOR VALID TYPE SPECIFICATION                    @Y30LB02
.TYPE    AIF   ('&TYPE' EQ '').NUL                             @Y30LB02
         AIF   ('&TYPE' EQ 'CVOL' OR '&TYPE' EQ 'CCRT').START  @Y30LB02
         MNOTE 12,'  ICB601I - TYPE IS INCORRECTLY SPECIFIED'  @Y30LB02
         MEXIT                                                 @Y30LB02
.*                                                             @Y30LB02
.NUL     ANOP                                                  @Y30LB02
         MNOTE 12,'  ICB600I - TYPE MUST BE SPECIFIED '        @Y30LB02
         MEXIT                                                 @Y30LB02
.*                                                             @Y30LB02
.*       DETERMINATION OF DESIRED MACRO FORM                   @Y30LB02
.*                                                             @Y30LB02
.START   AIF   ('&MF(1)' EQ 'L').LFORM      LIST FORM?         @Y30LB02
         AIF   ('&MF(1)' EQ 'E').EFORM      EXECUTE FORM?      @Y30LB02
         AIF   ('&MF(1)' EQ '').SFORM       STANDARD FORM?     @Y30LB02
         MNOTE 12,'  ICB615I - INVALID MF PARAMETER '          @Y30LB02
         MNOTE 12,'  SPECIFIED, MUST BE L, E, OR NULL '        @Y30LB02
&ERSW    SETB  1                                               @Y30LB02
         AGO   .PROCES                                         @Y30LB02
.*                                                             @Y30LB02
.*       PROCESSING OF 'LIST' MACRO FORM                       @Y30LB02
.*       THE FOLLOWING CODE CHECKS FOR ILLEGAL PARAMETERS ON   @Y30LB02
.*       THE LIST FORM MACRO AND GIVES WARNING IF FOUND        @Y30LB02
.*                                                             @Y30LB02
.LFORM   ANOP                                                  @Y30LB02
         AIF   ('&FLAGS' NE '' OR '&ECB' NE '' OR '&RUA' NE            *
               '' OR '&VOLID' NE '' OR '&CSN' NE ''                    *
               OR '&VVICEXT' NE '').WARN                       @Y30LB02
         AGO   .LIST1                                          @Y30LB02
.*                                                             @Y30LB02
.WARN    MNOTE 4,'  ICB603I - WARNING-ONLY MF AND TYPE '       @Y30LB02
         MNOTE 4,'  PARAMETERS ARE VALID FOR LIST FORM '       @Y30LB02
.*                                                             @Y30LB02
.LIST1   AIF   ('&TYPE' EQ 'CVOL').COPYV    COPY VOL REQ?      @Y30LB02
         AIF   ('&MF(2)' EQ 'MAP').LISTDS   DSECT REQUESTED?   @Y30LB02
*  MACMEAN  MSSC COPY CARTRIDGE MACRO--INITIALIZED LIST FORM   @Y30LB02
*  VS1-4/VS2-3 VERSION--06/09/74   LEVEL 00                    @Y30LB02
&SYMBOL  DS    0F                                              @Y30LB02
CCRTLEN  DC    F'32'               LENGTH OF CCRT REQ BLK      @Y30LB02
CCRTOPC  DC    XL1'28'             COPY CARTRIDGE OPCODE       @Y30LB02
CCRTRES1 DC    XL1'00'             1-BYTE RESERVED AREA        @Y30LB02
CCRTFLG  DC    XL2'0000'           2-BYTE FLAGS AREA           @Y30LB02
CCRTVOL  DC    XL6'0000'           6-BYTE VOLID AREA           @Y30LB02
CCRTASID DC    XL2'0000'           2-BYTE ASID AREA            @Y30LB02
CCRTECB  DC    XL4'00000000'       4-BYTE AREA FOR ECB         @Y30LB02
CCRTCSN  DC    XL12'0000000000'    12-BYTE CSN AREA            @Y30LB02
         MEXIT                                                 @Y30LB02
.*                                                             @Y30LB02
.LISTDS  ANOP                                                  @Y30LB02
*  MACMEAN  MSSC COPY CARTRIDGE MACRO-UNINITIALIZED LIST FORM  @Y30LB02
*  VS1-4/VS2-3 VERSION--06/09/74   LEVEL 00                    @Y30LB02
ICBCOVC  DSECT                                                 @Y30LB02
CCRTLEN  DS    F                   LEN OF CCRT REQ 20 HEX      @Y30LB02
CCRTOPC  DS    XL1                 COPY CART OPCODE 28 HEX     @Y30LB02
CCRTRES1 DS    XL1                 1-BYTE RESERVED FIELD       @Y30LB02
CCRTFLG  DS    XL2                 2-BYTE FLAGS FIELD          @Y30LB02
CCRTVOL  DS    CL6                 6-BYTE VOLID FIELD          @Y30LB02
CCRTASID DS    XL2                 2-BYTE ASID FIELD           @Y30LB02
CCRTECB  DS    A                   4-BYTE ECB FIELD            @Y30LB02
CCRTCSN  DS    CL12                12-BYTE CSN FIELD           @Y30LB02
         MEXIT                                                 @Y30LB02
.*                                                             @Y30LB02
.COPYV   ANOP                                                  @Y30LB02
         AIF   ('&MF(2)' EQ 'MAP').LISTDS2  DSECT REQUESTED?   @Y30LB02
*  MACMEAN  MSSC COPY VOLUME MACRO--INITIALIZED LIST FORM      @Y30LB02
*  VS1-4/VS2-3 VERSION--06/09/74   LEVEL 00                    @Y30LB02
&SYMBOL  DS    0F                                              @Y30LB02
CVOLLEN  DC    F'40'               LENGTH OF CVOL REQ BLK      @Y30LB02
CVOLOPC  DC    XL1'2A'             COPY VOLUME OPCODE          @Y30LB02
CVOLRES1 DC    XL1'00'             1-BYTE RESERVED AREA        @Y30LB02
CVOLFLG  DC    XL2'0000'           2-BYTE FLAGS AREA-ZERO      @Y30LB02
CVOLVOL  DC    XL6'0000'           6 BYTE VOLID AREA           @Y30LB02
CVOLASID DC    XL2'0000'           2-BYTE ASID AREA            @Y30LB02
CVOLECB  DC    XL4'00000000'       4-BYTE ECB AREA             @Y30LB02
CVOLCSN  DC    XL12'000000'        12-BYTE CSN AREA            @Y30LB02
CVOLRUA  DC    XL2'0000'           2-BYTE RUA AREA             @Y30LB02
CVOLRES2 DC    XL2'0000'           2-BYTE RESERVED AREA        @Y30LB02
CVOLVEXT DC    XL4'00000000'       4-BYTE VVICEXT AREA         @Y30LB02
         MEXIT                                                 @Y30LB02
.*                                                             @Y30LB02
.LISTDS2 ANOP                                                  @Y30LB02
*  MACMEAN  MSSC COPY VOLUME MACRO--UNINITIALIZED LIST FORM    @Y30LB02
*  VS1-4/VS2-3 VERSION--06/09/74   LEVEL 00                    @Y30LB02
ICBCOVC1 DSECT                                                 @Y30LB02
CVOLLEN  DS    F                   LEN CVOL REQ BLK 28 HEX     @Y30LB02
CVOLOPC  DS    XL1                 COPY VOL OPCODE 2A HEX      @Y30LB02
CVOLRES1 DS    XL1                 1-BYTE RESERVED FIELD       @Y30LB02
CVOLFLG  DS    XL2                 2-BYTE FLAGS FIELD-ZERO     @Y30LB02
CVOLVOL  DS    CL6                 6 BYTE VOLID FIELD          @Y30LB02
CVOLASID DS    XL2                 2-BYTE ASID FIELD           @Y30LB02
CVOLECB  DS    A                   4-BYTE ECB ADDR             @Y30LB02
CVOLCSN  DS    CL12                12-BYTE CSN FIELD           @Y30LB02
CVOLRUA  DS    XL2                 2-BYTE RUA FIELD            @Y30LB02
CVOLRES2 DS    XL2                 2-BYTE RESERVED FIELD       @Y30LB02
CVOLVEXT DS    A                   4-BYTE VVICEXT FIELD        @Y30LB02
         MEXIT                                                 @Y30LB02
.*       PROCESSING OF THE 'EXECUTE' MACRO FORM                @Y30LB02
.*                                                             @Y30LB02
.EFORM   ANOP                                                  @Y30LB02
         AIF   (N'&MF EQ 2).PARMOK  LIST NAME MUST BE SPEC-    @Y30LB02
.*                                 FIED, OTHERWISE ERROR.      @Y30LB02
         MNOTE 12,'  ICB613I - MISSING REQ BLK NAME OR MORE '  @Y30LB02
         MNOTE 12,'  THAN 2 SUBPARAMETERS FOR MF '             @Y30LB02
&ERSW    SETB  1                                               @Y30LB02
         AGO   .PROCES                                         @Y30LB02
.*                                                             @Y30LB02
.PARMOK  ANOP                                                  @Y30LB02
*  MACMEAN  MSSC COPY VOLUME/CARTRIDGE MACRO--EXECUTE FORM     @Y30LB02
*  VS1-4/VS2-3 VERSION--06/09/74   LEVEL 00                    @Y30LB02
&SYMBOL  IHBINNRA &MF(2)           LD ADDR OF REQUEST BLK      @Y30LB02
.*                                 USING IHBINNRA MACRO        @Y30LB02
         AIF   ('&TYPE' EQ 'CVOL').CVOL1     TYPE COPYV?       @Y30LB02
         LA    0,32                   LD LENGTH OF CCRT        @Y30LB02
         ST    0,0(1)                 STORE LENGTH             @Y30LB02
         MVI   0,X'28'                LOAD CCRT OPCODE         @Y30LB02
         AGO   .PROCES                                         @Y30LB02
.*                                                             @Y30LB02
.CVOL1   ANOP                                                  @Y30LB02
         LA    0,40                   LD LENG OF CVOL REQ      @Y30LB02
         ST    0,0(1)                 STORE LENGTH             @Y30LB02
         MVI   0,X'2A'                LOAD CVOL OPCODE         @Y30LB02
         AGO   .PROCES                                         @Y30LB02
.*                                                             @Y30LB02
.*       PROCESSING OF 'STANDARD' MACRO FORM                   @Y30LB02
.*                                                             @Y30LB02
.*                                                             @Y30LB02
.SFORM   AIF   ('&FLAGS' NE '').CKECB       FLAGS SPECIFIED?   @Y30LB02
         MNOTE 12,'  ICB607I - FLAGS MUST BE SPECIFIED '       @Y30LB02
         MNOTE 12,'  FOR STANDARD FORM MACRO '                 @Y30LB02
         AGO   .FINISH                                         @Y30LB02
.CKECB   AIF   ('&ECB' NE '').CKRUA        ECB SPECIFIED?      @Y30LB02
         MNOTE 12,'  ICB605I - ECB MUST BE SPECIFIED '         @Y30LB02
         MNOTE 12,'  FOR STANDARD FORM MACRO '                 @Y30LB02
         AGO   .FINISH                                         @Y30LB02
.CKRUA   AIF   ('&TYPE' EQ 'CCRT').CKVOLD   BRCH IF CCRT       @Y30LB02
         AIF   ('&RUA' NE '').SFORM1        RUA SPECIFIED?     @Y30LB02
         MNOTE 12,'  ICB616I - RUA MUST BE SPECIFIED FOR '     @Y30LB02
         MNOTE 12,'  STANDARD FORM MACRO '                     @Y30LB02
         AGO   .FINISH                                         @Y30LB02
.CKVOLD  AIF   ('&VOLID' NE '').SFORM1     VOLID SPECIFIED?    @Y30LB02
         MNOTE 12,'  ICB610I - VOLID MUST BE SPECIFIED FOR '   @Y30LB02
         MNOTE 12,'  STANDARD FORM MACRO '                     @Y30LB02
         AGO   .FINISH                                         @Y30LB02
.SFORM1  ANOP                                                  @Y30LB02
*  MACMEAN  MSSC COPY VOLUME/CARTRIDGE MACRO--STANDARD FORM    @Y30LB02
*  VS1-4/VS2-3 VERSION--06/09/74   LEVEL 00                    @Y30LB02
         CNOP  0,4                                             @Y30LB02
&SYMBOL  BAL   1,&LBL              BRCH AROUND REQ BLK         @Y30LB02
         AIF   ('&TYPE' EQ 'CVOL').CVOL2           COPYVOL?    @Y30LB02
CCRTLEN  DC    A(&LBL-*)           CCRT LENGTH FIELD           @Y30LB02
CCRTOPC  DC    XL1'28'             COPY CARTRIDGE OPCODE       @Y30LB02
CCRTRES1 DC    XL1'00'             1-BYTE RESERVED AREA        @Y30LB02
CCRTFLG  DC    XL2'0000'           2-BYTE FLAGS AREA           @Y30LB02
CCRTVOL  DC    XL6'0000'           6-BYTE VOLID AREA           @Y30LB02
CCRTASID DC    XL2'0000'           2-BYTE ASID AREA            @Y30LB02
CCRTECB  DC    XL4'00000000'       4-BYTE AREA FOR ECB         @Y30LB02
CCRTCSN  DC    XL12'0000000000'    12-BYTE CSN AREA            @Y30LB02
&LBL     EQU   *                                               @Y30LB02
         AGO   .PROCES                                         @Y30LB02
.*                                                             @Y30LB02
.CVOL2   ANOP                                                  @Y30LB02
CVOLLEN  DC    A(&LBL-*)           CVOL LENGTH FIELD           @Y30LB02
CVOLOPC  DC    XL1'2A'             COPY VOLUME OPCODE          @Y30LB02
CVOLRES1 DC    XL1'00'             1-BYTE RESERVED AREA        @Y30LB02
CVOLFLG  DC    XL2'0000'           2-BYTE FLAGS AREA-ZERO      @Y30LB02
CVOLVOL  DC    XL6'0000'           6 BYTE VOLID AREA           @Y30LB02
CVOLASID DC    XL2'0000'           2-BYTE ASID AREA            @Y30LB02
CVOLECB  DC    XL4'00000000'       4-BYTE ECB AREA             @Y30LB02
CVOLCSN  DC    XL12'000000'        12-BYTE CSN AREA            @Y30LB02
CVOLRUA  DC    XL2'0000'           2-BYTE RUA AREA             @Y30LB02
CVOLRES2 DC    XL2'0000'           2-BYTE RESERVED AREA        @Y30LB02
CVOLVEXT DC    XL4'0000'           2-BYTE VVICEXT AREA         @Y30LB02
&LBL     EQU   *                                               @Y30LB02
.*                                                             @Y30LB02
.*       PROCESS REQUEST BLOCK FOR STANDARD & EXECUTE FORMS    @Y30LB02
.*                                                             @Y30LB02
.PROCES  AIF   (&ERSW).FINISH                                  @Y30LB02
         AIF   ('&FLAGS' EQ '').VOLID       FLAGS SPECIFIED?   @Y30LB02
         AIF   ('&FLAGS'(1,1) EQ '(').REGF FLAGS IN REGFORM?   @Y30LB02
         MVC   6(2,1),&FLAGS          MOVE FLAGS TO REQ BLK    @Y30LB02
         AGO   .VOLID                 BR TO CHECK FOR VOLID    @Y30LB02
.*                                                             @Y30LB02
.REGF    ANOP                                                  @Y30LB02
         MVC   6(2,1),0(&FLAGS(1))    REG-FORM-STORE FLAGS     @Y30LB02
.*                                                             @Y30LB02
.VOLID   AIF   ('&VOLID' EQ '').ECB          VOLID SPECIFIED?  @Y30LB02
         AIF   ('&VOLID'(1,1) EQ '(').SREG   REG-FORM?         @Y30LB02
         MVC   8(6,1),&VOLID          MOVE VOLID TO REQBLK     @Y30LB02
         AGO   .ECB                                            @Y30LB02
.*                                                             @Y30LB02
.SREG    ANOP                                                  @Y30LB02
         MVC   8(6,1),0(&VOLID(1))    REG-FORM--STORE VOLID    @Y30LB02
.*                                                             @Y30LB02
.ECB     AIF   ('&ECB' EQ '').CSN          ECB SPECIFIED?      @Y30LB02
         AIF   ('&ECB'(1,1) EQ '(').EREG   REG-FORM?           @Y30LB02
         LA    15,&ECB                LOAD R15 WITH ADDR       @Y30LB02
         ST    15,16(1)               ST ADDR IN ECB FIELD     @Y30LB02
         AGO   .CSN                                            @Y30LB02
.*                                                             @Y30LB02
.EREG    ANOP                                                  @Y30LB02
         ST    &ECB,16(1)             REG-FORM--STORE ECB      @Y30LB02
.CSN     AIF   ('&CSN' EQ '').RUA  IS CSN SPECIFIED            @Y30LB02
         AIF   ('&CSN'(1,1) EQ '(').CREG    REG-FORM           @Y30LB02
         MVC   20(12,1),&CSN          MOVE CSN TO REQBLK       @Y30LB02
         AIF   ('&TYPE' EQ 'CVOL').RUA     BRCH TO CHECK RUA   @Y30LB02
         AGO   .INVOKE                                         @Y30LB02
.*                                                             @Y30LB02
.CREG    ANOP                                                  @Y30LB02
         MVC   20(12,1),0(&CSN(1))    REG-FORM--STORE CSN      @Y30LB02
         AIF   ('&TYPE' EQ 'CVOL').RUA     BRCH TO CHECK RUA   @Y30LB02
         AGO   .INVOKE                                         @Y30LB02
.*                                                             @Y30LB02
.*                                                             @Y30LB02
.RUA     AIF   ('&TYPE' EQ 'CCRT').INVOKE    BR TO SVC IF CCRT @Y30LB02
         AIF   ('&RUA' EQ '').VEXT           BRCH IF RUA NULL  @Y30LB02
         AIF   ('&RUA'(1,1) EQ '(').UREG     REGISTER FORM?    @Y30LB02
         MVC   32(2,1),&RUA           MOVE RUA TO REQ BLK      @Y30LB02
         AGO   .VEXT                                           @Y30LB02
.*                                                             @Y30LB02
.UREG    ANOP                                                  @Y30LB02
         MVC   32(2,1),0(&RUA(1))     REG-FORM, STORE RUA      @Y30LB02
.*                                                             @Y30LB02
.VEXT    AIF   ('&VVICEXT' EQ '').INVOKE   VVICEXT SPECIFIED?  @Y30LB02
         AIF   ('&VVICEXT'(1,1) EQ '(').VEREG    REG FORM?     @Y30LB02
         LA    15,&VVICEXT            LOAD ADDRESS IN R15      @Y30LB02
         ST    15,36(1)               STORE ADDRESS            @Y30LB02
         AGO   .INVOKE                                         @Y30LB02
.*                                                             @Y30LB02
.VEREG   ANOP                                                  @Y30LB02
         ST    &VVICEXT,36(1)         REG-FORM, STORE VVICEXT  @Y30LB02
.*                                                             @Y30LB02
.INVOKE  ANOP                                                  @Y30LB02
         SVC   126                    INVOKE SVC               @Y30LB02
.FINISH  MEND                                                  @Y30LB02
**/
*   ICBCOVC:  MACRO KEYS(MF,TYPE,FLAGS,VOLID,RUA,ECB,CSN,
*                     VVICEXT);                            /*@Y30LB02*/
*/*                                                          @Y30LB02*/
*/*            EXTERNAL DECLARES                             @Y30LB02*/
*        DCL CVTESTR FIXED EXT;  /*INVOCATION COUNTER        @Y30LB02*/
*        DCL CVOLTEST FIXED EXT; /*CTR FOR STANDARD FORM     @Y30LB02*/
*        DCL CCRTTEST FIXED EXT;  /*CTR FOR  CCRT S-FORM     @Y30LB02*/
*/*                                                          @Y30LB02*/
*/*                                                          @Y30LB02*/
*/*            INTERNAL DECLARES                             @Y30LB02*/
*/*                                                          @Y30LB02*/
*   DCL CTR        FIXED;        /*CTR FOR LIST PARAMETERS   @Y30LB02*/
*   DCL ERSW       FIXED;        /*ERROR COND SWITCH         @Y30LB02*/
*   DCL CVOLCOD    CHAR;         /*COPYV OPCODE              @Y30LB02*/
*   DCL CCRTCOD    CHAR;         /*COPYC OPCODE              @Y30LB02*/
*   DCL RETCODE    FIXED;        /*RETURN CODE AREA          @Y30LB02*/
*   DCL CVLEN      CHAR;         /*LENGTH OF CVOL REQ BLOCK  @Y30LB02*/
*   DCL CCLEN      CHAR;         /*LENGTH OF CCRT REQ BLOCK  @Y30LB02*/
*        CVOLCOD='2A';           /*COPY VOLUME OPCODE        @Y30LB02*/
*        CCRTCOD='28';           /*COPY CARTRIDGE OPCODE     @Y30LB02*/
*        RETCODE=0;              /*INITIALIZE RETURN CODE    @Y30LB02*/
*        CCLEN='20';             /*COPY CARTRIDGE LENGTH     @Y30LB02*/
*        ERSW = 0;               /*INITIALIZE ERROR SWITCH   @Y30LB02*/
*        CVLEN='28';             /*COPY VOLUME LENGTH        @Y30LB02*/
*        CTR = 0;                /*INITIALIZE PARM COUNTER   @Y30LB02*/
*/*                                                          @Y30LB02*/
*/*            CHECK FOR VALID TYPE SPECIFICATION            @Y30LB02*/
*/*                                                          @Y30LB02*/
*   IF TYPE='' THEN              /*TYPE SPECIFIED?           @Y30LB02*/
*     DO;                        /*NO,PRINT ERROR MESSAGE    @Y30LB02*/
*        ERSW=1;                 /*SET ERROR SWITCH          @Y30LB02*/
*        ANS MSG('  ICB600I - TYPE MUST BE SPECIFIED')SKIP;/*@Y30LB02*/
*        RETCODE=12;             /*SET RETURN CODE           @Y30LB02*/
*        GO TO FINISH;           /*BRANCH,END PROCESSING     @Y30LB02*/
*     END;                       /*                          @Y30LB02*/
*   IF ERSW=1 THEN               /*IS ERROR SWITCH SET       @Y30LB02*/
*        GO TO FINISH;           /*YES,BRCH,END PROCESSING   @Y30LB02*/
*   IF TYPE(1)='CVOL' THEN       /*TYPE COPY VOL?            @Y30LB02*/
*        GO TO START;            /*VALID TYPE,BRANCH         @Y30LB02*/
*   IF TYPE(1) = 'CCRT' THEN     /*TYPE COPY CART?           @Y30LB02*/
*        GO TO START;            /*VALID TYPE,CONTINUE       @Y30LB02*/
*/*                                                          @Y30LB02*/
*/*      INVALID 'TYPE' WILL CREATE THE FOLLOWING ERR MSGS   @Y30LB02*/
*/*                                                          @Y30LB02*/
*   ERSW=1;                       /*SET ERROR SWITCH         @Y30LB02*/
*   ANS MSG('  ICB601I - TYPE IS INCORRECTLY'||
*           ' SPECIFIED')SKIP;                             /*@Y30LB02*/
*   RETCODE=12;               /*SET RETURN CODE TO 12        @Y30LB02*/
*   IF ERSW=1 THEN            /*CHECK ERROR SWITCH           @Y30LB02*/
*   GO TO FINISH;             /*IF SET,BRCH TO END           @Y30LB02*/
*/*                                                          @Y30LB02*/
*START:
*     IF CVTESTR = 0 THEN    /*REG 1 DECLARED?               @Y30LB02*/
*      DO;                   /*NO,DECLARE IT                 @Y30LB02*/
*        ANS('DCL CVOLR1 REG(1) PTR;/*DECLARE R1 - '||
*        'ADDRESS OF REQUEST BLOCK @Y30LB02*/')SKIP;
*        CVTESTR=1;          /*INCREM REG COUNTER            @Y30LB02*/
*      END;                  /*                              @Y30LB02*/
*   IF MF(1) ^= 'L' THEN     /*LIST FORM REQUEST?            @Y30LB02*/
*        GO TO CKFORM;       /*NO,BRCH,CK FOR OTHER FORM     @Y30LB02*/
*   IF MF(2) ^= '' THEN      /*LIST NAME SPECIFIED?          @Y30LB02*/
*        GO TO LISTFORM;     /*YES,BRCH,PROCESS REQUEST      @Y30LB02*/
*   ERSW=1;                  /*NO,SET ERROR SWITCH           @Y30LB02*/
*   ANS MSG('  ICB602I - A NAME FOR THE '||
*     'REQUEST BLOCK MUST BE SPECIFIED IN MF(2)')SKIP;     /*@Y30LB02*/
*   RETCODE=12;             /*SET RETURN CODE TO 12          @Y30LB02*/
*   IF ERSW=1 THEN          /*ERROR SWITCH SET?              @Y30LB02*/
*   GO TO FINISH;           /*YES,BRCH,END PROCESSING        @Y30LB02*/
*/*                                                          @Y30LB02*/
*LISTFORM:
*/********************************************************   @Y30LB02*/
*/*  CHECK FOR ILLEGAL PARAMETERS AND PRINT OUT DECLARES     @Y30LB02*/
*/********************************************************   @Y30LB02*/
*   IF FLAGS ^= '' THEN     /*FLAGS PARAMETER SPECIFIED?     @Y30LB02*/
*        CTR = CTR + 1;     /*YES,INCREMENT COUNTER          @Y30LB02*/
*   IF VOLID ^= '' THEN     /*VOLID PARAMETER SPECIFIED?     @Y30LB02*/
*        CTR = CTR + 1;     /*YES,INCREMENT COUNTER          @Y30LB02*/
*   IF RUA ^= '' THEN       /*RUA SPECIFIED?                 @Y30LB02*/
*        CTR = CTR + 1;     /*YES,INCREMENT COUNTER          @Y30LB02*/
*   IF ECB ^= '' THEN       /*ECB PARAMETER SPECIFIED?       @Y30LB02*/
*        CTR = CTR + 1;     /*YES,INCREMENT COUNTER          @Y30LB02*/
*   IF CSN ^= '' THEN       /*CSN PARAMETER SPECIFIED?       @Y30LB02*/
*        CTR = CTR + 1;     /*YES INCREMENT COUNTER          @Y30LB02*/
*   IF VVICEXT ^= '' THEN   /*VVICEXT SPECIFIED?             @Y30LB02*/
*        CTR = CTR + 1;     /*YES,INCREMENT COUNTER          @Y30LB02*/
*   IF CTR > 0 THEN         /*IS COUNTER GT ZERO?            @Y30LB02*/
*     DO;                   /*YES,PRINT WARNING MSG          @Y30LB02*/
*        RETCODE=4;         /*SET RETURN CODE TO 4           @Y30LB02*/
*        ANS MSG('  ICB603I - WARNING-ONLY MF AND '||
*             'TYPE PARAMETERS ARE VALID FOR LIST '||
*             'FORM ')SKIP;                                /*@Y30LB02*/
*     END;                  /*                               @Y30LB02*/
*/*                                                          @Y30LB02*/
*    IF MF(3) ^= '' THEN    /*PLS ATTRIBUTE SPECIFIED?       @Y30LB02*/
*       GO TO ATTRLST;      /*YES,BRANCH                     @Y30LB02*/
*/*                                                          @Y30LB02*/
*   IF TYPE(1)='CVOL' THEN   /*TYPE CVOL?                    @Y30LB02*/
*     DO;                    /*PRINT CVOL LIST FORM          @Y30LB02*/
*        ANS('/*******************************************'||
*            '************** @Y30LB02*/')SKIP;
*        ANS('/*    MACMEAN  MSSC COPY VOLUME MACRO       '||
*            '               @Y30LB02*/')SKIP;
*        ANS('/*VS1-4/VS2-3 VERSION--06/09/74 LEVEL 00    '||
*            '               @Y30LB02*/')SKIP;
*        ANS('/*THIS IS THE INITIALIZED LIST FORM         '||
*            '               @Y30LB02*/')SKIP;
*        ANS('/*******************************************'||
*            '************** @Y30LB02*/')SKIP;
*        ANS('DCL 1 ' ||MF(2)|| '  STATIC LOCAL,'||
*        ' /*COPY VOLUME REQUEST BLOCK @Y30LB02*/')SKIP;
*        ANS('    2  CVOLLEN  FIXED(31)INIT('||QUOTE
*        ('28')||'X),/*LENGTH OF REQBLK @Y30LB02*/')SKIP;
*        ANS('    2  CVOLOPCD CHAR(1)INIT('||QUOTE('2A')||
*        'X),/*COPY VOLUME OPCODE @Y30LB02*/')SKIP;
*        ANS('    2  CVOLRES1 CHAR(1)INIT('||QUOTE('00')||
*        'X), /*ONE BYTE OF ZERO @Y30LB02*/')SKIP;
*        ANS('    2  CVOLFLG BIT(16)INIT('||QUOTE
*        ('0000000000000000')||'B), /*FLAGS AREA @Y30LB02*/')SKIP;
*        ANS('     3  CVODASCR  BIT(1), /*DASD TO '||
*        'CARTRIDGE ATTRIBUTE @Y30LB02*/')SKIP;
*        ANS('     3  CVOCRDAS  BIT(1),/*CARTRIDGE '||
*        'TO DASD ATTRIBUTE @Y30LB02*/')SKIP;
*        ANS('     3  CVOCRCR  BIT(1),/*CARTRIDGE '||
*        'TO CARTRIDGE ATTRIBUTE TRANS VOL @Y30LB02*/')SKIP;
*        ANS('     3  CVOCRCRV BIT(1),/*CARTRIDGE '||
*        'TO CARTRIDGE ATTRIBUTE VOL INV LIST @Y30LB02*/')SKIP;
*        ANS('     3  *      BIT(12),'||
*        ' /*TWELVE BITS RESERVED @Y30LB02*/')SKIP;
*        ANS('    2  CVOLID  CHAR(6) INIT('||QUOTE
*        ('000000000000')||'X), /*VOLUME ID  @Y30LB02*/')SKIP;
*        ANS('    2  CVOLASID CHAR(2) INIT('||QUOTE
*        ('0000')||'X),/*ASID AREA @Y30LB02*/')SKIP;
*        ANS('    2  CVOLECB  FIXED(31) INIT(0),'||
*        ' /*EVENT CONTROL BLOCK  @Y30LB02*/')SKIP;
*        ANS('    2  CVOLCSN CHAR(12),/*CSN AREA @Y30LB02*/')SKIP;
*        ANS('       3  *(12) CHAR(1)INIT((12)'||QUOTE
*        ('00')||'X),/*INIT CSN AREA @Y30LB02*/')SKIP;
*        ANS('    2  CVOLRUA  FIXED(15) INIT(0),'||
*        ' /*REAL UNIT ADDRESS  @Y30LB02*/')SKIP;
*        ANS('    2  CVOLRES2 CHAR(2) INIT('||QUOTE
*        ('0000')||'X),/*RESERVED AREA @Y30LB02*/')SKIP;
*        ANS('    2  CVOLVEXT FIXED(31) INIT(0);'||
*        '/*MSVC EXTENSION AREA @Y30LB02*/')SKIP;
*        GO TO FINISH;        /*BRANCH TO END                @Y30LB02*/
*     END;                    /*                             @Y30LB02*/
*/*                                                          @Y30LB02*/
*  ELSE                       /*COPY CART REQUEST            @Y30LB02*/
*     DO;                     /*PRINT COPY CART REQBLK       @Y30LB02*/
*        ANS('/*******************************************'||
*            '************** @Y30LB02*/')SKIP;
*        ANS('/*    MACMEAN  MSSC COPY CARTRIDGE MACRO    '||
*            '               @Y30LB02*/')SKIP;
*        ANS('/*VS1-4/VS2-3 VERSION--06/09/74 LEVEL 00    '||
*            '               @Y30LB02*/')SKIP;
*        ANS('/*THIS IS THE INITIALIZED LIST FORM         '||
*            '               @Y30LB02*/')SKIP;
*        ANS('/*******************************************'||
*           '************** @Y30LB02*/')SKIP;
*        ANS('DCL 1 ' ||MF(2)|| '  STATIC LOCAL,'||
*        ' /*COPY CARTRIDGE REQUEST BLOCK @Y30LB02*/')SKIP;
*        ANS('    2  CCRTLEN  FIXED(31)INIT('||QUOTE('20')||
*        'X),/*LENGTH OF REQUEST BLOCK @Y30LB02*/')SKIP;
*        ANS('    2  CCRTOPCD CHAR(1)INIT('||QUOTE('28')||
*        'X),/*COPY CARTRIDGE OPCODE @Y30LB02*/')SKIP;
*        ANS('    2  CCRTRES1 CHAR(1)INIT('||QUOTE('00')||
*        'X), /*ONE BYTE OF ZERO @Y30LB02*/')SKIP;
*        ANS('    2  CCRTFLG BIT(16)INIT('||QUOTE
*        ('0000000000000000')||'B), /*FLAGS AREA @Y30LB02*/')SKIP;
*        ANS('     3  CCRTCRT1  BIT(1), /*CART 1 OF 2 '||
*        'ATTRIBUTE @Y30LB02*/')SKIP;
*        ANS('     3  CCRTCRT2  BIT(1), /*CART 2 OF 2 '||
*        'ATTRIBUTE @Y30LB02*/')SKIP;
*        ANS('     3  *      BIT(14),'||
*        ' /*FOURTEEN BITS RESERVED @Y30LB02*/')SKIP;
*        ANS('    2  CCRTVOL  CHAR(6) INIT('||QUOTE
*        ('000000000000')||'X),/*VOLID AREA @Y30LB02*/')SKIP;
*        ANS('    2  CCRTASID CHAR(2) INIT('||QUOTE
*        ('0000')||'X),/*ASID AREA @Y30LB02*/')SKIP;
*        ANS('    2  CCRTECB  FIXED(31) INIT(0),'||
*        ' /*EVENT CONTROL BLOCK  @Y30LB02*/')SKIP;
*        ANS('    2  CCRTCSN CHAR(12),/*CSN AREA @Y30LB02*/')SKIP;
*        ANS('       3  *(12) CHAR(1)INIT((12)'||QUOTE
*        ('00')||'X);/*INIT CSN AREA @Y30LB02*/')SKIP;
*        GO TO FINISH;        /*BRANCH TO END                @Y30LB02*/
*     END;                    /*                             @Y30LB02*/
*ATTRLST:
*/*                                                          @Y30LB02*/
*   IF TYPE(1)='CVOL' THEN    /*COPY VOL REQUEST?            @Y30LB02*/
*     DO;                     /*CVOL UNINIT REQUEST BLOCK    @Y30LB02*/
*        ANS('/*******************************************'||
*            '************* @Y30LB02*/')SKIP;
*        ANS('/*     MACMEAN  MSSC COPY VOLUME MACRO      '||
*            '              @Y30LB02*/')SKIP;
*        ANS('/*VS1-4/VS2-3 VERSION--06/09/74 LEVEL 00    '||
*            '              @Y30LB02*/')SKIP;
*        ANS('/*THIS IS THE UNINITIALIZED LIST FORM       '||
*            '              @Y30LB02*/')SKIP;
*        ANS('/*******************************************'||
*            '************* @Y30LB02*/')SKIP;
*        ANS('DCL 1 ' ||MF(2)||' '||MF(3)||','||
*        ' /*COPY VOLUME REQUEST BLOCK @Y30LB02*/')SKIP;
*        ANS('    2  CVOLLEN  FIXED(31),/*LENGTH'||
*        ' OF REQ BLOCK = 28 BYTES HEX @Y30LB02*/')SKIP;
*        ANS('    2  CVOLOPCD CHAR(1),'||
*        '/*COPY VOLUME OPCODE = 2A HEX @Y30LB02*/')SKIP;
*        ANS('    2  CVOLRES1 CHAR(1),'||
*        ' /*ONE BYTE OF ZERO @Y30LB02*/')SKIP;
*        ANS('    2  CVOLFLG BIT(16),'||
*        ' /*FLAGS AREA @Y30LB02*/')SKIP;
*        ANS('     3  CVODASCR  BIT(1), /*DASD TO '||
*        'CARTRIDGE ATTRIBUTE @Y30LB02*/')SKIP;
*        ANS('     3  CVOCRDAS  BIT(1),/*CARTRIDGE '||
*        'TO DASD ATTRIBUTE @Y30LB02*/')SKIP;
*        ANS('     3  CVOCRCR  BIT(1),/*CARTRIDGE '||
*        'TO CARTRIDGE ATTRIBUTE TRANS VOL @Y30LB02*/')SKIP;
*        ANS('     3  CVOCRCRV BIT(1),/*CARTRIDGE '||
*        'TO CARTRIDGE ATTRIBUTE VOL INV LIST @Y30LB02*/')SKIP;
*        ANS('     3  *      BIT(12),'||
*        ' /*THIRTEEN BITS RESERVED @Y30LB02*/')SKIP;
*        ANS('    2  CVOLID  CHAR(6),'||
*        ' /*VOLUME ID  @Y30LB02*/')SKIP;
*        ANS('    2  CVOLASID CHAR(2) ,'||
*        '/*ASID AREA @Y30LB02*/')SKIP;
*        ANS('    2  CVOLECB  FIXED(31) ,'||
*        ' /*EVENT CONTROL BLOCK  @Y30LB02*/')SKIP;
*        ANS('    2  CVOLCSN CHAR(12),/*CSN AREA @Y30LB02*/')SKIP;
*        ANS('    2  CVOLRUA  FIXED(15),'||
*        ' /*REAL UNIT ADDRESS  @Y30LB02*/')SKIP;
*        ANS('    2  CVOLRES2 CHAR(2) ,'||
*        '/*RESERVED AREA @Y30LB02*/')SKIP;
*        ANS('    2  CVOLVEXT  FIXED(31) ;'||
*        ' /*MSVC EXTENTION AREA  @Y30LB02*/')SKIP;
*        GO TO FINISH;        /*BRANCH TO END                @Y30LB02*/
*     END;                    /*                             @Y30LB02*/
*/*                                                          @Y30LB02*/
*  ELSE                       /*COPY CARTRIDGE REQUEST       @Y30LB02*/
*     DO;                     /*COPY CART REQ BLOCK          @Y30LB02*/
*        ANS('/*******************************************'||
*            '************* @Y30LB02*/')SKIP;
*        ANS('/*   MACMEAN  MSSC COPY CARTRIDGE MACRO     '||
*            '              @Y30LB02*/')SKIP;
*        ANS('/*VS1-4/VS2-3 VERSION--06/09/74 LEVEL 00    '||
*            '              @Y30LB02*/')SKIP;
*        ANS('/*THIS IS THE UNINITIALIZED LIST FORM       '||
*            '              @Y30LB02*/')SKIP;
*        ANS('/*******************************************'||
*            '************* @Y30LB02*/')SKIP;
*        ANS('DCL 1 ' ||MF(2)||' '||MF(3)||','||
*        ' /*COPY CARTRIDGE REQUEST BLOCK @Y30LB02*/')SKIP;
*        ANS('    2  CCRTLEN  FIXED(31),/*LENGTH OF'||
*        ' REQUEST BLOCK = 20 HEX @Y30LB02*/')SKIP;
*        ANS('    2  CCRTOPCD CHAR(1),'||
*        '/*COPY CARTRIDGE OPCODE = 28 HEX @Y30LB02*/')SKIP;
*        ANS('    2  CCRTRES1 CHAR(1),'||
*        ' /*ONE BYTE OF ZERO @Y30LB02*/')SKIP;
*        ANS('    2  CCRTFLG BIT(16),/*FLAGS AREA @Y30LB02*/')SKIP;
*        ANS('     3  CCRTCRT1  BIT(1), /*CART 1 OF 2 '||
*        'ATTRIBUTE @Y30LB02*/')SKIP;
*        ANS('     3  CCRTCRT2  BIT(1), /*CART 2 OF 2 '||
*        'ATTRIBUTE @Y30LB02*/')SKIP;
*        ANS('     3  *      BIT(14),'||
*        ' /*FOURTEEN BITS RESERVED @Y30LB02*/')SKIP;
*        ANS('    2  CCRTVOL  CHAR(6),'||
*        '/*VOLID AREA @Y30LB02*/')SKIP;
*        ANS('    2  CCRTASID CHAR(2),/*ASID AREA @Y30LB02*/')SKIP;
*        ANS('    2  CCRTECB  FIXED(31),'||
*        ' /*EVENT CONTROL BLOCK  @Y30LB02*/')SKIP;
*        ANS('    2  CCRTCSN CHAR(12);/*CSN AREA @Y30LB02*/')SKIP;
*        GO TO FINISH;        /*BRANCH TO END                @Y30LB02*/
*     END;                    /*                             @Y30LB02*/
*/*                                                        /*@Y30LB02*/
*/*      CHECK FOR EXECUTE FORM SPECIFICATION              /*@Y30LB02*/
*/*                                                          @Y30LB02*/
*CKFORM:
*   IF MF(1) ^= 'E' THEN       /*EXECUTE FORM SPECIFIED?     @Y30LB02*/
*        GO TO SFORM;          /*NO,CK FOR STANDARD          @Y30LB02*/
*   IF MF(2)='' THEN           /*2ND SUB-PARM SPECIFIED?     @Y30LB02*/
*     DO;                      /*PRINT ERROR MESSAGE         @Y30LB02*/
*        ANS MSG('  ICB612I - MF(2) MUST '||
*             'CONTAIN REQ BLK NAME IF '||
*             'EXEC MACRO FORM REQUESTED')SKIP;            /*@Y30LB02*/
*        RETCODE=12;           /*SET ERROR RETURN CODE       @Y30LB02*/
*        ERSW = 1;             /*SET ERROR SWITCH            @Y30LB02*/
*        GO TO COMPROC;        /*BRANCH TO CK ERROR SWITCH   @Y30LB02*/
*     END;                     /*                            @Y30LB02*/
*/*                                                        /*@Y30LB02*/
*   ANS('/*******************************************'||
*       '************* @Y30LB02*/')SKIP;
*   ANS('/*MACMEAN  MSSC COPY VOLUME/CARTRIDGE MACRO '||
*       '              @Y30LB02*/')SKIP;
*   ANS('/*VS1-4/VS2-3 VERSION-- 06/09/74 LEVEL 00   '||
*       '              @Y30LB02*/')SKIP;
*   ANS('/*THIS IS THE OUTPUT FOR THE EXECUTE FORM.  '||
*       '              @Y30LB02*/')SKIP;
*   ANS('/*THE LIST FORM OF THIS MACRO SHOULD BE     '||
*       '              @Y30LB02*/')SKIP;
*   ANS('/*INVOKED FIRST IN ORDER TO SET UP NECESSARY'||
*       '              @Y30LB02*/')SKIP;
*   ANS('/*DECLARES.  IF THE COMPLETE ARGUMENT IS    '||
*       '              @Y30LB02*/')SKIP;
*   ANS('/*SPECIFIED THE REQ BLOCK WILL BE ZEROED.   '||
*       '              @Y30LB02*/')SKIP;
*   ANS('/*******************************************'||
*       '************* @Y30LB02*/')SKIP;
*    IF MF(3) = 'COMPLETE' THEN   /*REQUEST TO ZERO BLOCK?   @Y30LB02*/
*      DO;                     /*                            @Y30LB02*/
*        ANS(' '||MF(2)||'='||MF(2)||'&&'||MF(2)||';'||
*        '/*ZERO OUT REQUEST BLOCK @Y30LB02*/')SKIP;
*      END;                    /*                            @Y30LB02*/
*/*                                                          @Y30LB02*/
*        ANS('RFY(CVOLR1)RSTD;/*RESTRICT REG 1 @Y30LB02*/')SKIP;
*        ANS('CVOLR1=ADDR('||MF(2)||'); /*R1 PTR'||
*        ' TO LIST  @Y30LB02*/')SKIP;
*        GO TO COMPROC;       /*BRANCH TO CK PARAMETERS      @Y30LB02*/
*/*                                                          @Y30LB02*/
*SFORM:
*   IF MF(1) ^= '' THEN       /* FORM STANDARD?              @Y30LB02*/
*     DO;                     /*NO,PRINT ERROR MESSAGE       @Y30LB02*/
*        ERSW = 1;            /*SET ERROR SWITCH             @Y30LB02*/
*        RETCODE=12;          /*SET RETURN CODE              @Y30LB02*/
*        ANS MSG('  ICB615I - INVALID MF PARAMETER '||
*             'SPECIFIED, MUST BE L, E, OR NULL')SKIP;     /*@Y30LB02*/
*        GO TO COMPROC;       /*BRANCH,CK ERROR SWITCH       @Y30LB02*/
*     END;                    /*                             @Y30LB02*/
*/*                                                          @Y30LB02*/
*   IF FLAGS = '' THEN        /*FLAGS SPECIFIED?             @Y30LB02*/
*     DO;                     /*NO,PROCESS ERROR MESSAGE     @Y30LB02*/
*        ERSW=1;              /*SET THE ERROR SWITCH         @Y30LB02*/
*        RETCODE=12;          /*SET RETURN CODE TO 12        @Y30LB02*/
*        ANS MSG('  ICB607I - FLAGS MUST BE SPECIFIED '||
*        'FOR STANDARD FORM MACRO')SKIP;                   /*@Y30LB02*/
*        GO TO COMPROC;       /*BRANCH TO CK ERROR SWITCH    @Y30LB02*/
*     END;                    /*                             @Y30LB02*/
*/*                                                          @Y30LB02*/
*   IF VOLID = '' THEN        /*VOLID SPECIFIED?             @Y30LB02*/
*    IF TYPE(1) = 'CCRT' THEN /*TYPE CCRT?                   @Y30LB02*/
*     DO;                     /*NO,PRINT ERROR MESSAGE       @Y30LB02*/
*        ERSW=1;              /*SET ERROR SWITCH             @Y30LB02*/
*        RETCODE=12;          /*SET RETURN CODE              @Y30LB02*/
*        ANS MSG('  ICB610I - VOLID MUST BE SPECIFIED '||
*        'FOR STANDARD FORM MACRO')SKIP;                   /*@Y30LB02*/
*        GO TO COMPROC;       /*BRANCH TO CK ERROR SWITCH    @Y30LB02*/
*     END;                    /*                             @Y30LB02*/
*/*                                                          @Y30LB02*/
*   IF RUA = '' THEN        /*VOLID SPECIFIED?               @Y30LB02*/
*    IF TYPE(1) = 'CVOL' THEN  /*NO,COPY VOLUME?             @Y30LB02*/
*     DO;                     /*YES,PRINT ERROR MESSAGE      @Y30LB02*/
*        ERSW=1;              /*SET ERROR SWITCH             @Y30LB02*/
*        RETCODE=12;          /*SET RETURN CODE              @Y30LB02*/
*        ANS MSG('  ICB616I - RUA MUST BE SPECIFIED '||
*        'FOR STANDARD FORM MACRO ')SKIP;                  /*@Y30LB02*/
*        GO TO COMPROC;       /*BRANCH TO CK ERROR SWITCH    @Y30LB02*/
*     END;                    /*                             @Y30LB02*/
*   IF ECB = '' THEN          /*ECB SPECIFIED                @Y30LB02*/
*     DO;                     /*NO,PRINT ERROR MESSAGE       @Y30LB02*/
*        ERSW=1;              /*SET ERROR SWITCH             @Y30LB02*/
*        RETCODE=12;          /*SET RETURN CODE              @Y30LB02*/
*        ANS MSG('  ICB605I - ECB MUST BE SPECIFIED '||
*        'FOR STANDARD FORM MACRO')SKIP;                   /*@Y30LB02*/
*        GO TO COMPROC;        /*BRANCH TO CK ERROR SWITCH   @Y30LB02*/
*     END;                     /*                            @Y30LB02*/
*/*                                                          @Y30LB02*/
*   IF TYPE(1)='CVOL' THEN     /*TYPE COPY VOLUME?           @Y30LB02*/
*     IF CVOLTEST => 1 THEN    /*STD FORM INVOKED BEFORE?    @Y30LB02*/
*      DO;                     /*YES,DON'T PRINT DECLARES    @Y30LB02*/
*        ANS('/*******************************************'||
*            '************* @Y30LB02*/')SKIP;
*        ANS('/*   MACMEAN  MSSC COPY VOLUME MACRO        '||
*            '              @Y30LB02*/')SKIP;
*        ANS('/*VS1-4/VS2-3 VERSION--06/09/74 LEVEL 00    '||
*            '              @Y30LB02*/')SKIP;
*        ANS('/*THIS IS THE OUTPUT FOR A SECONDARY        '||
*            '              @Y30LB02*/')SKIP;
*        ANS('/*INVOCATION OF THE STANDARD FORM MACRO     '||
*            '              @Y30LB02*/')SKIP;
*        ANS('/*******************************************'||
*            '************* @Y30LB02*/')SKIP;
*        ANS('RFY(CVOLR1)RSTD;/*RESTRICT REG 1 @Y30LB02*/')SKIP;
*        ANS('CVOLR1=ADDR(CVOLLEN);/*PTR TO REQBLK    @Y30LB02*/')SKIP;
*        GO TO COMPROC;       /*BRANCH TO CK PARAMETERS      @Y30LB02*/
*      END;                   /*                             @Y30LB02*/
*/*                                                        /*@Y30LB02*/
*     IF TYPE(1) = 'CVOL' THEN  /*COPY VOLUME                @Y30LB02*/
*      DO;                   /*PRINT DECLARES                @Y30LB02*/
*        ANS('/*******************************************'||
*            '************** @Y30LB02*/')SKIP;
*        ANS('/*    MACMEAN  MSSC COPY VOLUME MACRO       '||
*            '               @Y30LB02*/')SKIP;
*        ANS('/*VS1-4/VS2-3 VERSION--06/09/74 LEVEL 00    '||
*            '               @Y30LB02*/')SKIP;
*        ANS('/*OUTPUT FOR THE STANDARD FORM MACRO        '||
*            '               @Y30LB02*/')SKIP;
*        ANS('/*******************************************'||
*            '************** @Y30LB02*/')SKIP;
*        ANS('RFY(CVOLR1)RSTD;/*RESTRICT REG 1 @Y30LB02*/')SKIP;
*        ANS('CVOLR1=ADDR(CVOLLEN);/*PTR REQUEST BLK  @Y30LB02*/')SKIP;
*        ANS('DCL 1  CVOLLST  STATIC LOCAL,'||
*        ' /*COPY VOLUME REQUEST BLOCK @Y30LB02*/')SKIP;
*        ANS('    2  CVOLLEN  FIXED(31)INIT('||QUOTE('28')||
*        'X),/*LENGTH OF REQUEST BLOCK @Y30LB02*/')SKIP;
*        ANS('    2  CVOLOPCD CHAR(1)INIT('||QUOTE('2A')||
*        'X),/*COPY VOLUME OPCODE @Y30LB02*/')SKIP;
*        ANS('    2  CVOLRES1 CHAR(1)INIT('||QUOTE('00')||
*        'X), /*ONE BYTE OF ZERO @Y30LB02*/')SKIP;
*        ANS('    2  CVOLFLG BIT(16)INIT('||QUOTE
*        ('0000000000000000')||'B), /*FLAGS AREA @Y30LB02*/')SKIP;
*        ANS('     3  CVODASCR  BIT(1), /*DASD TO '||
*        'CARTRIDGE ATTRIBUTE @Y30LB02*/')SKIP;
*        ANS('     3  CVOCRDAS  BIT(1),/*CARTRIDGE '||
*        'TO DASD ATTRIBUTE @Y30LB02*/')SKIP;
*        ANS('     3  CVOCRCR  BIT(1),/*CARTRIDGE '||
*        'TO CARTRIDGE ATTRIBUTE TRAN VOL @Y30LB02*/')SKIP;
*        ANS('     3  CVOCRCRV BIT(1),/*CARTRIDGE '||
*        'TO CARTRIDGE ATTRIBUTE VOL INVL @Y30LB02*/')SKIP;
*        ANS('     3  *      BIT(12),'||
*        ' /*TWELVE BITS RESERVED @Y30LB02*/')SKIP;
*        ANS('    2  CVOLID  CHAR(6) INIT('||QUOTE
*        ('000000000000')||'X), /*VOLUME ID  @Y30LB02*/')SKIP;
*        ANS('    2  CVOLASID CHAR(2) INIT('||QUOTE
*        ('0000')||'X),/*ASID AREA @Y30LB02*/')SKIP;
*        ANS('    2  CVOLECB  FIXED(31) INIT(0),'||
*        ' /*EVENT CONTROL BLOCK  @Y30LB02*/')SKIP;
*        ANS('    2  CVOLCSN CHAR(12),/*CSN AREA @Y30LB02*/')SKIP;
*        ANS('       3  *(12) CHAR(1)INIT((12)'||QUOTE
*        ('00')||'X),/*INIT CSN AREA @Y30LB02*/')SKIP;
*        ANS('    2  CVOLRUA  FIXED(15) INIT(0),'||
*        ' /*REAL UNIT ADDRESS  @Y30LB02*/')SKIP;
*        ANS('    2  CVOLRES2 CHAR(2) INIT('||QUOTE
*        ('0000')||'X),/*RESERVED AREA @Y30LB02*/')SKIP;
*        ANS('    2  CVOLVEXT  FIXED(31) INIT(0);'||
*        ' /*MSVC EXTENSION AREA  @Y30LB02*/')SKIP;
*        CVOLTEST=CVOLTEST+1; /*INCREM COUNTER               @Y30LB02*/
*        GO TO COMPROC;    /*BRANCH TO CK PARAMETERS         @Y30LB02*/
*     END;                /*                                 @Y30LB02*/
*/*                                                          @Y30LB02*/
*   ELSE                     /*PROCESS COPY CARTRIDGE        @Y30LB02*/
*     IF CCRTTEST => 1 THEN  /*STD FM INVOKED BEFORE?        @Y30LB02*/
*      DO;                   /*YES,DON'T PRINT DCLS          @Y30LB02*/
*        ANS('/*******************************************'||
*            '************** @Y30LB02*/')SKIP;
*        ANS('/*   MACMEAN  MSSC COPY CARTRIDGE MACRO     '||
*            '               @Y30LB02*/')SKIP;
*        ANS('/*VS1-4/VS2-3 VERSION--06/09/74 LEVEL 00    '||
*            '               @Y30LB02*/')SKIP;
*        ANS('/*THIS IS THE OUTPUT FOR A SECONDARY        '||
*            '               @Y30LB02*/')SKIP;
*        ANS('/*INVOCATION OF THE STANDARD FORM MACRO     '||
*            '               @Y30LB02*/')SKIP;
*        ANS('/*******************************************'||
*            '************** @Y30LB02*/')SKIP;
*        ANS('RFY(CVOLR1)RSTD;/*RESTRICT REG 1 @Y30LB02*/')SKIP;
*        ANS('CVOLR1=ADDR(CCRTLEN);/*PTR TO BLOCK @Y30LB02*/')SKIP;
*        GO TO COMPROC;                                    /*@Y30LB02*/
*      END;                                                /*@Y30LB02*/
*     IF CCRTTEST=0 THEN      /*                             @Y30LB02*/
*     DO;                                                  /*@Y30LB02*/
*        ANS('/*******************************************'||
*            '************** @Y30LB02*/')SKIP;
*        ANS('/*   MACMEAN  MSSC COPY CARTRIDGE MACRO     '||
*            '               @Y30LB02*/')SKIP;
*        ANS('/*VS1-4/VS2-3 VERSION--06/09/74 LEVEL 00    '||
*            '               @Y30LB02*/')SKIP;
*        ANS('/*THIS IS THE OUTPUT FOR THE STANDARD FORM  '||
*            '               @Y30LB02*/')SKIP;
*        ANS('/*******************************************'||
*            '************** @Y30LB02*/')SKIP;
*        ANS('RFY(CVOLR1)RSTD;/*RESTRICT REG 1 @Y30LB02*/')SKIP;
*        ANS('CVOLR1=ADDR(CCRTLEN);/*R1 PTR TO BLOCK @Y30LB02*/')SKIP;
*        ANS('DCL 1 CCRTLST  STATIC LOCAL,'||
*        ' /*COPY CARTRIDGE REQUEST BLOCK @Y30LB02*/')SKIP;
*        ANS('    2  CCRTLEN  FIXED(31)INIT('||QUOTE
*        ('20')||'X),/*LENGTH OF REQ BLOCK @Y30LB02*/')SKIP;
*        ANS('    2  CCRTOPCD CHAR(1)INIT('||QUOTE('28')||
*        'X),/*COPY CARTRIDGE OPCODE @Y30LB02*/')SKIP;
*        ANS('    2  CCRTRES1 CHAR(1)INIT('||QUOTE('00')||
*        'X), /*ONE BYTE OF ZERO @Y30LB02*/')SKIP;
*        ANS('    2  CCRTFLG BIT(16)INIT('||QUOTE
*        ('0000000000000000')||'B), /*FLAGS AREA @Y30LB02*/')SKIP;
*        ANS('     3  CCRTCRT1  BIT(1), /*CART 1 OF 2 '||
*        'ATTRIBUTE @Y30LB02*/')SKIP;
*        ANS('     3  CCRTCRT2  BIT(1), /*CART 2 OF 2 '||
*        'ATTRIBUTE @Y30LB02*/')SKIP;
*        ANS('     3  *      BIT(14),'||
*        ' /*FOURTEEN BITS RESERVED @Y30LB02*/')SKIP;
*        ANS('    2  CCRTVOL  CHAR(6) INIT('||QUOTE
*        ('000000000000')||'X),/*VOLID AREA @Y30LB02*/')SKIP;
*        ANS('    2  CCRTASID CHAR(2) INIT('||QUOTE
*        ('0000')||'X),/*ASID AREA @Y30LB02*/')SKIP;
*        ANS('    2  CCRTECB  FIXED(31) INIT(0),'||
*        ' /*EVENT CONTROL BLOCK  @Y30LB02*/')SKIP;
*        ANS('    2  CCRTCSN CHAR(12),/*CSN AREA @Y30LB02*/')SKIP;
*        ANS('       3  *(12) CHAR(1)INIT((12)'||QUOTE
*        ('00')||'X);/*INIT CSN AREA @Y30LB02*/')SKIP;
*        CCRTTEST=CCRTTEST+1; /*INCREMENT CTR                @Y30LB02*/
*     END;                    /*                             @Y30LB02*/
*/*                                                          @Y30LB02*/
*COMPROC:
*   IF ERSW =1 THEN          /*ERROR SWITCH SET?             @Y30LB02*/
*     GO TO FINISH;          /*YES,BRANCH TO END             @Y30LB02*/
*   IF TYPE(1)='CVOL' THEN  /*TYPE CVOL?                     @Y30LB02*/
*    DO;                    /*OUTPUT LEN AND OPC             @Y30LB02*/
*     ANS('CVOLLEN=' ||QUOTE(CVLEN)|| 'X; /*LENGTH OF '||
*      'COPY VOLUME REQUEST BLOCK @Y30LB02*/')SKIP;
*     ANS('CVOLOPCD=' ||QUOTE(CVOLCOD)|| 'X;/*COPYVL '||
*     ' OPCODE @Y30LB02*/')SKIP;
*    END;                 /*                                 @Y30LB02*/
*/*                                                          @Y30LB02*/
*   ELSE                 /*CCRT LEN AND OPC                  @Y30LB02*/
*    DO;                 /*                                  @Y30LB02*/
*     ANS('CCRTLEN=' ||QUOTE(CCLEN)|| 'X; /*LENGTH'||
*    ' COPY CARTRIDGE REQUEST BLOCK @Y30LB02*/')SKIP;
*     ANS('CCRTOPCD=' ||QUOTE(CCRTCOD)|| 'X;/*OPCODE FOR'||
*    ' COPY CARTRIDGE LIST @Y30LB02*/')SKIP;
*    END;                /*                                  @Y30LB02*/
*/*                                                          @Y30LB02*/
*   IF TYPE(1)='CVOL' THEN  /*TYPE COPY VOL?                 @Y30LB02*/
*    IF FLAGS ^= '' THEN    /*FLAGS PARAMETER SPECIFIED      @Y30LB02*/
*     ANS('CVOLFLG=' ||FLAGS|| '; /*VALUE OF FLAGS    @Y30LB02*/')SKIP;
*/*                                                          @Y30LB02*/
*   IF TYPE(1)='CCRT' THEN    /*COPY CARTRIDGE?              @Y30LB02*/
*    IF FLAGS ^= '' THEN      /*FLAGS SPECIFIED?             @Y30LB02*/
*     ANS('CCRTFLG=' ||FLAGS|| '; /*VALUE OF FLAGS    @Y30LB02*/')SKIP;
*/*                                                          @Y30LB02*/
*   IF VOLID ^= '' THEN      /*VOLID SPECIFIED?              @Y30LB02*/
*    IF TYPE(1) = 'CVOL' THEN    /*COPY VOLUME?              @Y30LB02*/
*     ANS('CVOLID=' ||VOLID|| '; /*VALUE OF VOLID @Y30LB02*/')SKIP;
*/*                                                          @Y30LB02*/
*   IF VOLID ^= '' THEN     /*VOLID SPECIFIED?               @Y30LB02*/
*    IF TYPE(1) = 'CCRT' THEN  /*COPY CARTRIDGE?             @Y30LB02*/
*     ANS('CCRTVOL= ' ||VOLID|| ';/*VALUE OF VOLID    @Y30LB02*/')SKIP;
*/*                                                          @Y30LB02*/
*   IF CSN ^= '' THEN    /*CSN SPECIFIED?                    @Y30LB02*/
*    IF TYPE(1) = 'CVOL' THEN   /*TYPE COPY VOLUME?          @Y30LB02*/
*     ANS('CVOLCSN=' ||CSN|| '; /*VALUE OF CSN @Y30LB02*/')SKIP;
*/*                                                          @Y30LB02*/
*   IF CSN ^= '' THEN
*    IF TYPE(1) = 'CCRT' THEN  /*COPY CARTRIDGE?             @Y30LB02*/
*     ANS('CCRTCSN= ' ||CSN|| ';/*VALUE OF CSN @Y30LB02*/')SKIP;
*/*                                                          @Y30LB02*/
*   IF ECB ^= ''  THEN      /*ECB PARAMETER SPECIFIED        @Y30LB02*/
*     IF TYPE(1) = 'CCRT' THEN
*        ANS('CCRTECB=ADDR' ||ECB||';/*ADDRESS OF ECB'||
*        ' @Y30LB02*/')SKIP;
*/*                                                          @Y30LB02*/
*   IF ECB ^= ''  THEN
*     IF TYPE(1) = 'CVOL' THEN
*        ANS('CVOLECB=ADDR' ||ECB||';/*ADDRESS OF ECB'||
*        ' @Y30LB02*/')SKIP;
*/*                                                          @Y30LB02*/
*   IF RUA ^= '' THEN      /*RUA PARAMETER SPECIFIED?        @Y30LB02*/
*    IF TYPE(1) = 'CVOL' THEN
*     ANS('CVOLRUA=' ||RUA|| '; /*VALUE OF RUA @Y30LB02*/')SKIP;
*/*                                                          @Y30LB02*/
*   IF VVICEXT ^= ''  THEN  /*MSVC EXTENSION?                @Y30LB02*/
*     IF TYPE(1) = 'CVOL' THEN
*        ANS('CVOLVEXT=ADDR'||VVICEXT||';/*ADDRESS OF '||
*        'VVICEXT @Y30LB02*/')SKIP;
*/*                                                          @Y30LB02*/
*     ANS('SVC (126);/*INVOKE THE SVC @Y30LB02*/')SKIP;
*     ANS('RFY  CVOLR1 UNRSTD;/*UNRESTRICT REG 1 @Y30LB02*/')SKIP;
*/*                                                          @Y30LB02*/
*FINISH:  RETURN CODE(RETCODE);                            /*@Y30LB02*/
*         %END;                                            /*@Y30LB02*/
