* %/*   START OF SPECIFICATIONS****                            @Y30LB02
.*                                                             @Y30LB02
.*01   MODULE-NAME = ICBDEFV                                   @Y30LB02
.*                                                             @Y30LB02
.*01   DESCRIPTIVE-NAME = DEFINE VOLUME MACRO                  @Y30LB02
.*                                                             @Y30LB02
.*01   COPYRIGHT = NONE                                        @Y30LB02
.*                                                             @Y30LB02
.*01   STATUS = OS/VS1 RELEASE 4, OS/VS2 RELEASE 3             @Y30LB02
.*                                                             @Y30LB02
.*01   FUNCTION = REQUEST VIRTUAL VOLUMES BE DEFINED BY        @Y30LB02
.*                THE MSC                                      @Y30LB02
.*                                                             @Y30LB02
.*01   NOTES = AS FOLLOWS:                                     @Y30LB02
.*                                                             @Y30LB02
.*02     CODE = MACRO IS BILINGUALLY CODED                     @Y30LB02
.*                                                             @Y30LB02
.*02     RESTRICTIONS = THE FOLLOWING PREFIXES SHOULD BE       @Y30LB02
.*                      AVOIDED IN THE USER'S INVOCATION:      @Y30LB02
.*                      ICB AND DEF                            @Y30LB02
.*                                                             @Y30LB02
.*02  REGISTER-CONVENTIONS = FOLLOWS NORMAL USE OF REGISTERS   @Y30LB02
.*                              BY MACROS: R0,R1,R14, AND R15  @Y30LB02
.*                                                             @Y30LB02
.*01   MODULE-TYPE = MACRO                                     @Y30LB02
.*                                                             @Y30LB02
.*02     PROCESSOR = PLS2 AND ASSEMBLER                        @Y30LB02
.*                                                             @Y30LB02
.*02     ATTRIBUTES = REUSABLE                                 @Y30LB02
.*                                                             @Y30LB02
.*02     ENTRY-POINT = ICBDEFV                                 @Y30LB02
.*                                                             @Y30LB02
.*02     PURPOSE = A REQUEST TO DEFINE A VOLUME IS             @Y30LB02
.*       ISSUED WHENEVER ONE OF THE FOLLOWING IS TO            @Y30LB02
.*       BE PERFORMED:                                         @Y30LB02
.*          DEFINE A NEW VIRTUAL VOLUME.                       @Y30LB02
.*          ELIMINATE A VIRTUAL VOLUME.                        @Y30LB02
.*          RENAME A VIRTUAL VOLUME.                           @Y30LB02
.*          DESIGNATE VOLUME FLAGS                             @Y30LB02
.*          ACTIVATE A VOLUME.                                 @Y30LB02
.*          DEACTIVATE A VOLUME.                               @Y30LB02
.*                                                             @Y30LB02
.*02     LINKAGE = SVC 126                                     @Y30LB02
.*                                                             @Y30LB02
.*01  INPUT                                                    @Y30LB02
.*                                                             @Y30LB02
.*                                                             @Y30LB02
.*MACRO SYNTAX                                                 @Y30LB02
.*                                                             @Y30LB02
.*LIST FORM                                                    @Y30LB02
.*                                                             @Y30LB02
.* VERB    REQUIRED PARMS        OPTIONAL PARMS                @Y30LB02
.*                                                             @Y30LB02
.*ICBDEFV  MF=L - (BAL)          MF=(L,MAP) - BAL              @Y30LB02
.*         MF(L,NAME/(R))-PLS    MF(L,NAME/(R),ATTR)-PLS       @Y30LB02
.*                                                             @Y30LB02
.*STANDARD FORM                                                @Y30LB02
.*                                                             @Y30LB02
.* VERB    REQUIRED PARMS        OPTIONAL PARMS                @Y30LB02
.*                                                             @Y30LB02
.*ICBDEFV  ECB=ADDR/(R)          VOLID=ADDR/(R)                @Y30LB02
.*         FLAGS=ADDR/(R)        CSN1=ADDR/(R)                 @Y30LB02
.*                               LIBID=ADDR/(R)                @Y30LB02
.*                               CSN2=ADDR/(R)                 @Y30LB02
.*                               NVOLID=ADDR/(R)               @Y30LB02
.*                               USDATA=ADDR/(R)               @Y30LB02
.*                               VVICEXT=ADDR/(R)              @Y30LB02
.*                                                             @Y30LB02
.*EXECUTE FORM                                                 @Y30LB02
.*                                                             @Y30LB02
.* VERB    REQUIRED PARMS        OPTIONAL PARMS                @Y30LB02
.*                                                             @Y30LB02
.*ICBDEFV  MF(E,NAME/(R))       MF(E,NAME/(R),COMPLETE)-PLS    @Y30LB02
.*                              FLAGS=ADDR/(R)                 @Y30LB02
.*                              VOLID=ADDR/(R)                 @Y30LB02
.*                              ECB=ADDR/(R)                   @Y30LB02
.*                              CSN1=ADDR/(R)                  @Y30LB02
.*                              CSN2=ADDR/(R)                  @Y30LB02
.*                              NVOLID=ADDR/(R)                @Y30LB02
.*                              USDATA=ADDR/(R)                @Y30LB02
.*                              VVICEXT=ADDR/(R)               @Y30LB02
.*                              LIBID=ADDR/(R)                 @Y30LB02
.*                              VOLFLG=ADDR/(R)                @Y30LB02
.*                                                             @Y30LB02
.*   KEYWORD PARAMETERS:                                       @Y30LB02
.*                                                             @Y30LB02
.*                                                             @Y30LB02
.*                                                             @Y30LB02
.*   MF  -  MACRO FORMAT: THIS PARAMETER DESCRIBES THE         @Y30LB02
.*          MACRO FORMAT AND MAY GIVE THE ADDRESS OR           @Y30LB02
.*          ADDRESS IN A REGISTER WHERE THE REQUEST BLOCK      @Y30LB02
.*          IS STORED.                                         @Y30LB02
.*                                                             @Y30LB02
.*          L - LIST FORM: THE EXPANSION OF THE L-FORM         @Y30LB02
.*              MACRO WILL RESULT IN A REQUEST BLICK WITH      @Y30LB02
.*              THE ONLY NON-ZERO FIELDS BEING THE OPCODE      @Y30LB02
.*              AND LENGTH FIELDS.                             @Y30LB02
.*                                                             @Y30LB02
.*          (1) 'MAP' - IF MAP IS SPECIFIED WITH THE           @Y30LB02
.*              ASSEMBLER MACRO CALL A DSECT EQUIVALENT TO     @Y30LB02
.*              A MAPPING MACRO IS PRODUCED.                   @Y30LB02
.*                                                             @Y30LB02
.*          (2) NAME - THE MACRO INVOKER MUST SPECIFY A        @Y30LB02
.*              NAME FOR HIS STRUCTURE WHEN INVOKING THE       @Y30LB02
.*              PLS LIST FORM.                                 @Y30LB02
.*                                                             @Y30LB02
.*          (3) ATTRIBUTE - THE MACRO WILL PLACE ANY PLS       @Y30LB02
.*              ATTRIBUTE SPECIFIED IN THE MACRO INVOCATION    @Y30LB02
.*              IN AN UNINITIALIZED REQUEST BLOCK.  ATTRI-     @Y30LB02
.*              BUTE EXAMPLE:                                  @Y30LB02
.*                                                             @Y30LB02
.*              CHAR, FIXED, STATIC LOCAL, NONLOCAL,           @Y30LB02
.*              BASED(*), ETC.                                 @Y30LB02
.*                                                             @Y30LB02
.*       NULL - STANDARD FORM: THE EXPANSION OF THIS FORM      @Y30LB02
.*              CONSISTS OF A REQUEST BLOCK, A LINKAGE         @Y30LB02
.*              INSTRUCTION, AND, POSSIBLY, PARAMETER          @Y30LB02
.*              BINDING INSTRUCTIONS.                          @Y30LB02
.*                                                             @Y30LB02
.*          E - EXECUTABLE FORM: THE EXPANSION OF THIS FORM    @Y30LB02
.*              CONSISTS OF A LINKAGE INSTRUCTION AND          @Y30LB02
.*              POSSIBLY, PARAMETER BINDING INSTRUCTIONS.      @Y30LB02
.*                                                             @Y30LB02
.*              SUB-PARAMETERS                                 @Y30LB02
.*                                                             @Y30LB02
.*              (1)  AN E MUST BE SPECIFIED IN THE FIRST       @Y30LB02
.*                   SUB-PARAMETER POSITION.  THIS INDICATES   @Y30LB02
.*                   THAT THE MACRO IS IN EXECUTABLE FORM.     @Y30LB02
.*                                                             @Y30LB02
.*              (2)  A NAME OR A REGISTER MUST BE SPECIFIED    @Y30LB02
.*                   IN THE SECOND SUB-PARAMETER.              @Y30LB02
.*                                                             @Y30LB02
.*              (3)  'COMPLETE' - COMPLETE WILL CAUSE THE      @Y30LB02
.*                   MACRO TO ZERO OUT THE REQUEST BLOCK.      @Y30LB02
.*                   AFTER ZEROING THE REQUEST BLOCK THE       @Y30LB02
.*                   FUNCTION OPCODE AND LENGTH ARE PLACED     @Y30LB02
.*                   IN THE REQUEST BLOCK.                     @Y30LB02
.*                                                             @Y30LB02
.*                                                             @Y30LB02
.*  LIBID - THE FIELD WHICH IDENTIFIES THE MSF ACCESSED.       @Y30LB02
.*   LIBID MUST BE SPECIFIED WITH THE CREATE ATTRIBUTE.        @Y30LB02
.*   THE FORMAT OF THE LIBID FIELD IS SHOWN BELOW:             @Y30LB02
.*                                                             @Y30LB02
.*    ---------------------------------                        @Y30LB02
.*    | 0 | 0 | 0 | 0 | 0 | 0 | X | X |                        @Y30LB02
.*    ---------------------------------                        @Y30LB02
.*                                                             @Y30LB02
.* BITS 0-5 ---------------------IGNORED-MUST BE SET TO ZERO   @Y30LB02
.*                                                             @Y30LB02
.* BITS 6-7 ---------------------- MAY BE SET TO 0,1,2, OR 3   @Y30LB02
.*                                                             @Y30LB02
.* FLAGS -  FLAGS:  THE FIELD WHICH INDICATES THE FUNCTION(S)  @Y30LB02
.* TO BE PERFORMED.  THE FORMAT OF THE FLAGS FIELD IS SHOWN    @Y30LB02
.* BELOW:                                                      @Y30LB02
.*    ---------------------------------                        @Y30LB02
.*    | X | X | X | X | X | X | X | X |                        @Y30LB02
.*    ---------------------------------                        @Y30LB02
.*                                                             @Y30LB02
.*         BIT 0-----------'1'B   CREATE VOLUME                @Y30LB02
.*                         '0'B   NO FUNCTION REQUESTED        @Y30LB02
.*                                                             @Y30LB02
.*         BIT 1-----------'1'B   ELIMINATE VOLUME             @Y30LB02
.*                         '0'B   NO FUNCTION REQUESTED        @Y30LB02
.*                                                             @Y30LB02
.*         BIT 2-----------'1'B   RENAME VOLUME                @Y30LB02
.*                         '0'B   NO FUNCTION REQUESTED        @Y30LB02
.*                                                             @Y30LB02
.*         BIT 3-----------'1'B   REPLACE VOLUME FLAGS         @Y30LB02
.*                         '0'B   NO FUNCTION REQUESTED        @Y30LB02
.*                                                             @Y30LB02
.*         BIT 4-----------'1'B   ELIMINATE TRANSIENT          @Y30LB02
.*                                VOLUME                       @Y30LB02
.*                         '0'B   NO FUNCTION REQUESTED        @Y30LB02
.*                                                             @Y30LB02
.*         BIT 5-----------'1'B   RENAME TRANSIENT             @Y30LB02
.*                                VOLUME                       @Y30LB02
.*                         '0'B  NO FUNCTION REQUESTED         @Y30LB02
.*                                                             @Y30LB02
.*        BIT 6-----------'1'B   ACTIVATE TRANSIENT            @Y30LB02
.*                               VOLUME                        @Y30LB02
.*                        '0'B   NO FUNCTION REQUESTED         @Y30LB02
.*                                                             @Y30LB02
.*         BIT 7-----------'1'B  DEACTIVATE VOLUME             @Y30LB02
.*                         '0'B  NO FUNCTION REQUESTED         @Y30LB02
.*                                                             @Y30LB02
.*   CREATE:   CAUSES A NEW VOLUME TO BE CREATED.  THE         @Y30LB02
.*   CARTRIDGE SERIAL NUMBERS (CSNS) MAY BE SPECIFIED IF       @Y30LB02
.*   SPECIFIC CARTRIDGES ARE DESIRED.  VOLID AND LIBID MUST    @Y30LB02
.*   BE SPECIFIED WITH CREATE.  AFTER THE VOLUME IS CREATED    @Y30LB02
.*   IT WILL HAVE AN ENTRY IN THE TRANSIENT LIST.  IF A CE     @Y30LB02
.*   FLAG IS SET A CSN MUST BE SUPPLIED AND MUST BE THE SAME   @Y30LB02
.*   FOR BOTH CSN1 AND CSN2.                                   @Y30LB02
.*                                                             @Y30LB02
.*   CREATE REQUIRED PARAMETERS:  FLAGS, ECB, VOLID, AND       @Y30LB02
.*   LIBID.                                                    @Y30LB02
.*   CREATE OPTIONAL PARAMETERS: CNS1 AND CSN2.                @Y30LB02
.*                                                             @Y30LB02
.*   ELINMINATE:  THE VOLUME IDENTIFIED BY THE GIVEN VOLID     @Y30LB02
.*   IS ELIMINATED FROM THE VOLUME INVENTORY.  IT'S            @Y30LB02
.*   CARTRIDGES ARE MADE AVAILABLE FOR REALLOCATION.           @Y30LB02
.*   VOLID MUST BE SPECIFIED.                                  @Y30LB02
.*                                                             @Y30LB02
.*   ELIMINATE REQUIRED PARMS:  VOLID, FLAGS, AND ECB.         @Y30LB02
.*                                                             @Y30LB02
.*   RENAME:   THE VOLUME CURRENTLY IDENTIFIED BY THE VOLID    @Y30LB02
.*   LISTED IN THIS REQUEST IS TO BE RENAMED WITH THE NEW      @Y30LB02
.*   VOLID (NVOLID).  THE VOLUME TO BE RENAMED MUST BE         @Y30LB02
.*   ALREADY IN THE SYSTEM'S INVENTORY .  IF THE VOLUME'S      @Y30LB02
.*   CHARACTERISTICS ARE TO BE CHANGED, THEN THE USER MUST     @Y30LB02
.*   INSURE THAT THE "VOLFLG" FIELD IS SPECIFIED WITH THE      @Y30LB02
.*   DESIRED CHARACTERISTICS.  OTHERWISE THE USER WILL SET     @Y30LB02
.*   THE VOLFLG FIELD TO 'FF', INDICATING NO CHANGE IS         @Y30LB02
.*   REQUIRED IN VOLUME CHARACTERISTICS. BOTH VOLID AND        @Y30LB02
.*   NVOLID MUST BE SPECIFIED. AFTER A RENAME IS COMPLETE THE  @Y30LB02
.*   VOLUME WILL BE PLACED ON THE TRANSIENT (INACTIVE) LIST.   @Y30LB02
.*                                                             @Y30LB02
.*   RENAME REQUIRED PARAMETERS ARE:  FLAGS, ECB, VOLID,       @Y30LB02
.*   NVOLID, AND VOLFLG.                                       @Y30LB02
.*                                                             @Y30LB02
.*   REPLACE:    REPLACE VOLUME FLAGS - THE VOLUME IDENTIFIED  @Y30LB02
.*   BY THE VOLID IN THIS REQUEST HAS ITS FLAGS UPDATED. THE   @Y30LB02
.*   VOLUME WILL REMAIN ACTIVE. THE VOLFLG FIELD MUST BE       @Y30LB02
.*   SPECIFIED.                                                @Y30LB02
.*                                                             @Y30LB02
.*   REPLACE REQUIRED PARAMETERS ARE:  FLAGS, ECB,             @Y30LB02
.*   VOLID, AND VOLFLG.                                        @Y30LB02
.*                                                             @Y30LB02
.*   ELIMINATE TRANSIENT VOLUME:                               @Y30LB02
.*   THE VOLUME IDENTIFIED BY THE GIVEN SEQUENCE ONE SERIAL    @Y30LB02
.*   NUMBER (CSN1) IS ELIMINATED FROM THE MSF.                 @Y30LB02
.*                                                             @Y30LB02
.*   ELIMINATE TRANSIENT VOLUME REQUIRED PARAMETERS:           @Y30LB02
.*   FLAGS, ECB, AND CSN1.                                     @Y30LB02
.*                                                             @Y30LB02
.*   RENAME TRANSIENT VOLUME:                                  @Y30LB02
.*   THE VOLUME THAT IS CURRENTLY IDENTIFIED BY SEQUENCE ONE   @Y30LB02
.*   SERIAL NUMBER (CSN1), LISTED IN THE DEFINE REQUEST IS TO  @Y30LB02
.*   BE RENAMED WITH THE NEW VOLID. IF NO CHANGES ARE DESIRED  @Y30LB02
.*   IN THE VOLUME FLAGS FIELD(VOLFLG), THE USER MUST SET THE  @Y30LB02
.*   VOLFLG FIELD TO 'FF'.  AFTER THE RENAME IS COMPLETE THE   @Y30LB02
.*   VOLUME ENTRY WILL REMAIN ON THE TRANSIENT VOLUME LIST.    @Y30LB02
.*   (INACTIVE)                                                @Y30LB02
.*                                                             @Y30LB02
.*   RENAME TRANSIENT VOLUME REQUIRED PARAMETERS:              @Y30LB02
.*   FLAGS, ECB, VOLFLG, AND CSN1.                             @Y30LB02
.*                                                             @Y30LB02
.*   ACTIVATE TRANSIENT VOLUME:                                @Y30LB02
.*   THE VOLUME SPECIFIED BY CSN1 IS DELETED FROM THE          @Y30LB02
.*   TRANSIENT VOLUME LIST AND WILL BE MADE AVAILABLE FOR      @Y30LB02
.*   USE BY THE MSC.                                           @Y30LB02
.*                                                             @Y30LB02
.*   ACTIVATE TRANSIENT VOLUME REQUIRED PARAMETERS:            @Y30LB02
.*   FLAGS, ECB, AND CSN1.                                     @Y30LB02
.*                                                             @Y30LB02
.*   DEACTIVATE VOLUME:                                        @Y30LB02
.*   THE VOLUME SPECIFIED BY VOLID WILL BE MADE UNAVAILABLE    @Y30LB02
.*   FOR USE BY THE MSC (PLACED ON THE TRANSIENT VOLUME LIST). @Y30LB02
.*                                                             @Y30LB02
.*   DEACTIVATE VOLUME REQUIRED PARAMETERS:  FLAGS,            @Y30LB02
.*   ECB, AND VOLID.                                           @Y30LB02
.*                                                             @Y30LB02
.*   NOTE:  BITS 0-7 ARE MUTUALLY EXCLUSIVE:  ONE              @Y30LB02
.*   (AND ONLY ONE) MAY BE ON.                                 @Y30LB02
.*                                                             @Y30LB02
.*                                                             @Y30LB02
.*  VOLFLG-  THE 'VOLUME FLAGS' FIELD INDICATES THE            @Y30LB02
.*  CHARACTERISTICS A VOLUME WILL EXHIBIT WHEN CREATE, RENAME  @Y30LB02
.*  OR REPLACE VOLUME FLAGS IS SPECIFIED IN THE FLAGS FIELD.   @Y30LB02
.*  THE FORMAT OF THE VOLFLG FIELD IS SHOWN BELOW:             @Y30LB02
.*                                                             @Y30LB02
.*                                                             @Y30LB02
.*   ---------------------------------                         @Y30LB02
.*   | X | 0 | X | X | 0 | X | X | 0 |                         @Y30LB02
.*   ---------------------------------                         @Y30LB02
.*                                                             @Y30LB02
.*                                                             @Y30LB02
.*   BIT 0-----------'1'B   CE CARTRIDGE                       @Y30LB02
.*                   '0'B   NO FUNCTION REQUESTED              @Y30LB02
.*                                                             @Y30LB02
.*   BIT 1-----------'0'B   UNUSED - MUST BE SET TO ZERO       @Y30LB02
.*                                                             @Y30LB02
.*                                                             @Y30LB02
.*   BIT 2-----------'1'B   SECURE VOLUME                      @Y30LB02
.*                   '0'B   NO FUNCTION REQUESTED              @Y30LB02
.*                                                             @Y30LB02
.*   BIT 3-----------'1'B   EXCLUSIVE VOLUME                   @Y30LB02
.*                   '0'B   NO FUNCTION REQUESTED              @Y30LB02
.*                                                             @Y30LB02
.*   BIT 4-----------       RESERVED AND MUST BE ZERO          @Y30LB02
.*                                                             @Y30LB02
.*   BIT 5-----------'1'B   BIND VOLUME                        @Y30LB02
.*                    '0'B  NO FUNCTION                        @Y30LB02
.*                                                             @Y30LB02
.*                                                             @Y30LB02
.*   BIT 6-----------'1'B   WRITE INHIBIT                      @Y30LB02
.*                   '0'B   NO FUNCTION                        @Y30LB02
.*                                                             @Y30LB02
.*   BIT 7-----------       |UNUSED - MUST BE SET TO ZERO|     @Y30LB02
.*                                                             @Y30LB02
.*   NOTE:  IF THE VOLFLG PARAMETER IS NOT SPECIFIED,          @Y30LB02
.*   A VOLUME WILL BE DEFINED WITHOUT SPECIAL ATTRIBUTES.      @Y30LB02
.*                                                             @Y30LB02
.*                                                             @Y30LB02
.*  CE CARTRIDGE:                                              @Y30LB02
.*  IF THIS ATTRIBUTE IS SPECIFIED WITH THE                    @Y30LB02
.*  CREATE FUNCTION, THE CARTRIDGE IS DESIGNATED               @Y30LB02
.*  FOR CE USE.  ONCE A CARTRIDGE IS DESIGNATED                @Y30LB02
.*  AS CE THE VOLUME FLAGS CANNOT BE CHANGED                   @Y30LB02
.*  NOR CAN THE CARTRIDGE BE ELIMINATED.                       @Y30LB02
.*                                                             @Y30LB02
.*  SECURE VOLUME:                                             @Y30LB02
.*  WHEN SPECIFIED WITH THE CREATE OR RENAME ATTRIBUTE         @Y30LB02
.*  THE VOLUME SPECIFIED IS DESIGNATED FOR SECURE ERASE.       @Y30LB02
.*  AN INDICATION OF THIS ATTRIBUTE IS IN THE INVENTORY        @Y30LB02
.*  ENTRY AND CTOC OF THE VOLUME.  MSC WILL RECOGNIZE          @Y30LB02
.*  THIS VOLUME FLAG WHEN CYLINDER EXTENTS ARE DESTAGED,       @Y30LB02
.*  AND THEREFORE ERASE DASD.  THIS HELPS TO PREVENT THE       @Y30LB02
.*  POSSIBILITY OF SENSITIVE DATA BEING INADVERTENTLY          @Y30LB02
.*  COPIED BY AN UNAUTHORIZED USER.                            @Y30LB02
.*                                                             @Y30LB02
.*  EXCLUSIVE:                                                 @Y30LB02
.*  IF THIS VOLUME FLAG IS SPECIFIED, WHENEVER A REQUEST       @Y30LB02
.*  TO MOUNT THE VOLUME IS GIVEN IT WILL BE MOUNTED            @Y30LB02
.*  EXCLUSIVE.  NO OTHER HOST WILL BE ABLE TO ACCESS           @Y30LB02
.*  THE VOLUME UNTIL IT IS RELEASED BY THE REQUESTING HOST.    @Y30LB02
.*                                                             @Y30LB02
.*  BIND:                                                      @Y30LB02
.*  IF THIS VOLUME FLAG IS SPECIFIED, THE                      @Y30LB02
.*  VOLUME WILL HAVE THE BIND ATTRIBUTE                        @Y30LB02
.*  UNTIL REDEFINED.  WHENEVER, A REQUEST                      @Y30LB02
.*  TO MOUNT THE VOLUME IS RECEIVED IT WILL                    @Y30LB02
.*  BE MOUNTED AND ALL CYLINDERS ACQUIRED WILL BE BOUND.       @Y30LB02
.*                                                             @Y30LB02
.*  WRITE INHIBIT:                                             @Y30LB02
.*  IF THIS VOLUME FLAG IS SPECIFIED,                          @Y30LB02
.*  THE VOLUME IS DEFINED FOR READ ONLY.  THE                  @Y30LB02
.*  VOLUME CANNOT BE UPDATED.                                  @Y30LB02
.*                                                             @Y30LB02
.*  VOLID -  VOLUME IDENTIFIER:   THE IDENTIFIER OF THE        @Y30LB02
.*  VOLUME TO BE DEFINED.                                      @Y30LB02
.*                                                             @Y30LB02
.*  NVOLID-  NEW VOLUME IDENTIFIER:   THE NEW VOLUME           @Y30LB02
.*  IDENTIFIER WHEN RENAMING A VOLUME.                         @Y30LB02
.*                                                             @Y30LB02
.*  CSN1 -   CARTRIDGE SERIAL NUMBER ONE IS A 12               @Y30LB02
.*  BYTE AREA WHICH CONTAINS THE MANUFACTURER'S SERIAL         @Y30LB02
.*  NUMBER FOR CARTRIDGE SEQUENCE NUMBER ONE.                  @Y30LB02
.*  CSN1 MUST BE SPECIFIED WHEN DEFINING TRANSIENT VOLUMES.    @Y30LB02
.*  OTHERWISE IT IS OPTIONAL.                                  @Y30LB02
.*                                                             @Y30LB02
.*  CSN2 -   CARTRIDGE SERIAL NUMBER TWO IS A 12               @Y30LB02
.*  BYTE AREA WHICH CONTAINS THE MANUFACTURER'S SERIAL         @Y30LB02
.*  NUMBER FOR CARTRIDGE SEQUENCE NUMBER TWO.                  @Y30LB02
.*                                                             @Y30LB02
.*  ECB  - THE NAME OF THE EVENT CONTROL BLOCK(ECB)            @Y30LB02
.*  TO BE POSTED WHEN DEFINE IS COMPLETE.  THE                 @Y30LB02
.*  THE USER MUST ALSO DECLARE A MINIMUM 50 BYTE CONTIGUOUS    @Y30LB02
.*  AREA TO CONTAIN THE MESSAGE GENERATED BY THE MSSC MESSAGE  @Y30LB02
.*  TASK. (THE ECB AND APPENDED DATA AREA MUST BE IN COMMON    @Y30LB02
.*  CORE IN VS/2.) THE ECB IS POSTED WITH ONE OF THE           @Y30LB02
.*  FOLLOWING POST CODES: 70,71,72,73,74, ETC.                 @Y30LB02
.*  THE POST CODE WILL BE PLACED IN THE LOW-ORDER BYTE         @Y30LB02
.*  OF THE ECB - '7F'X INDICATES SUCCESSFUL COMPLETION.        @Y30LB02
.*  THE MSC DATA WILL BE MOVED TO CORE LOCATION ADDR(ECB)+4.   @Y30LB02
.*  ECB MUST BE SPECIFIED.  THE ECB AREA MUST BE CLEARED       @Y30LB02
.*  (SET TO BINARY 0) BEFORE INVOKING THE MACRO.               @Y30LB02
.*                                                             @Y30LB02
.*  USDATA-  USER DATA:  THE NAME OF AN AREA WHICH             @Y30LB02
.*  CONTAINS 72 BYTES OF CARTRIDGE LABEL INFORMATION.          @Y30LB02
.*  THE USER DATA PARAMETER MAY BE OPTIONALLY SPECIFIED        @Y30LB02
.*  WITH CREATE, RENAME,AND RENAME TRANSIENT VOLUME.           @Y30LB02
.*  WHEN SPECIFIED WITH RENAME, ANY BYTE WHICH IS X'00'        @Y30LB02
.*  (BINARY ZERO) DOES NOT UPDATE THE CORRESPONDING BYTE       @Y30LB02
.*  OF THE CARTRIDGE LABEL USER AREA.                          @Y30LB02
.*                                                             @Y30LB02
.*  VVICEXT- THE NAME OF AN AREA WHICH CONTAINS THE            @Y30LB02
.*  MSVC EXTENSION (VVICEXT) MAPPING.                          @Y30LB02
.*  IF THIS PARAMETER IS NOT SPECIFIED, THE CORRESPONDING      @Y30LB02
.*  POSITION IN THE REQUEST BLOCK MUST BE SET                  @Y30LB02
.*  TO ZERO. THE MAPPING MACRO FOR THE MSVC EXTENSION          @Y30LB02
.*  TO DEFINE VOLUME IS IEZDEFVE.                              @Y30LB02
.*                                                             @Y30LB02
.*01  EXIT-NORMAL = VALID INVOCATION                           @Y30LB02
.*                                                             @Y30LB02
.*02     CONDITION = RETURN CODE = 0                           @Y30LB02
.*                                                             @Y30LB02
.*02     OUTPUT = REQUESTED ORDER GENERATED FOR THE MSSC-SVC   @Y30LB02
.*                                                             @Y30LB02
.*01  EXIT-ERROR = INVALID INVOCATION                          @Y30LB02
.*                                                             @Y30LB02
.*02     CONDITION = RETURN CODE = 12                          @Y30LB02
.*                                                             @Y30LB02
.*02     OUTPUT = ERROR MESSAGE AS A COMMENT AT POINT OF       @Y30LB02
.*                INVOCATION                                   @Y30LB02
.*                                                             @Y30LB02
.*01  EXTERNAL REFERENCES = NONE                               @Y30LB02
.*                                                             @Y30LB02
.*01  TABLES = NONE                                            @Y30LB02
.*                                                             @Y30LB02
.*01  MESSAGES = AS FOLLOWS:                                   @Y30LB02
.*     ICB602I:  A NAME FOR THE REQUEST BLOCK MUST BE          @Y30LB02
.*               SPECIFIED IN MF(2)                            @Y30LB02
.*     ICB604I:  WARNING-ONLY THE MF PARAMETER IS VALID        @Y30LB02
.*               FOR THE LIST FORM                             @Y30LB02
.*     ICB605I:  ECB MUST BE SPECIFIED FOR STANDARD            @Y30LB02
.*               FORM MACRO                                    @Y30LB02
.*     ICB607I:  FLAGS MUST BE SPECIFIED FOR STANDARD          @Y30LB02
.*               FORM MACRO                                    @Y30LB02
.*     ICB612I:  MF(2) MUST CONTAIN REQ BLK NAME               @Y30LB02
.*               IF EXEC MACRO FORM REQUESTED                  @Y30LB02
.*     ICB615I:  INVALID MF PARAMETER SPECIFIED, MUST          @Y30LB02
.*               BE L, E, OR NULL                              @Y30LB02
.*                                                             @Y30LB02
.*01  CONTROL-BLOCKS = NONE                                    @Y30LB02
.*                                                             @Y30LB02
.*01  INNER MACROS = NONE                                      @Y30LB02
.*                                                             @Y30LB02
.*01  SYSTEM MACRO = IHBINNRA                                  @Y30LB02
.*                                                             @Y30LB02
.*01  CHANGE-ACTIVITY = S/D X04AC02 AND Y30LB02                @Y30LB02
.*                          ZM31011                            @ZM31011
.*                                                             @Y30LB02
.**** END OF SPECIFICATIONS ***                                @Y30LB02
         MACRO
&SYMBOL  ICBDEFV &MF=,&FLAGS=,&VOLID=,&NVOLID=,&LIBID=,                *
               &VOLFLG=,&CSN1=,&CSN2=,&ECB=,&USDATA=,                  *
               &VVICEXT=
         LCLB  &ERSW               CONDITION SWITCH            @Y30LB02
         LCLC  &DEFV               DEFINE MACRO INSTR INDX     @Y30LB02
&DEFV    SETC  'D'.'&SYSNDX'       ASSIGN CHARACTER VALUE      @Y30LB02
.*                                                             @Y30LB02
.*       DETERMINATION OF DESIRED MACRO FORM                   @Y30LB02
.*                                                             @Y30LB02
         AIF   ('&MF(1)' NE 'L').EFORM      LIST FORM?         @Y30LB02
.*                                                             @Y30LB02
.*       PROCESSING OF LIST MACRO FORM                         @Y30LB02
.*                                                             @Y30LB02
.*       THE FOLLOWING CODE CHECKS FOR ILLEGAL PARAMETERS      @Y30LB02
.*       SPECIFIED FOR THE LIST FORM AND PUTS OUT DEFINE       @Y30LB02
.*       VOLUME REQUEST BLOCK.                                 @Y30LB02
.*                                                             @Y30LB02
         AIF   ('&FLAGS' NE '' OR '&VOLID' NE '' OR '&LIBID'           *
               NE '' OR '&CSN1' NE '' OR '&CSN2' NE '' OR              *
               '&VOLFLG' NE '' OR '&NVOLID' NE '').WARN        @Y30LB02
         AIF   ('&ECB' NE ''OR '&VVICEXT' NE '' OR '&USDATA'           *
               NE '').WARN                                     @Y30LB02
         AGO   .LIST                                           @Y30LB02
.WARN    MNOTE 4,'  ICB604I - WARNING-ONLY THE MF PARAMETER '  @Y30LB02
         MNOTE 4,'  IS VALID FOR THE LIST FORM '               @Y30LB02
.*                                                             @Y30LB02
.LIST    ANOP                                                  @Y30LB02
         AIF   ('&MF(2)' EQ 'MAP').LISTDS   DSECT REQUESTED?   @Y30LB02
*  MACMEAN  MSSC DEFINE VOLUME MACRO--INITIALIZED LIST FORM    @Y30LB02
*  VS1-4/VS2-3 VERSION--06/09/74   LEVEL 00                    @Y30LB02
&SYMBOL  DS    0F                                              @Y30LB02
DEFVLEN  DC    F'132'              LENGTH OF DEFINE REQ        @Y30LB02
DEFVOPC  DC    XL1'18'             DEFINE VOLUME OPCODE        @Y30LB02
DEFVRES1 DC    XL1'00'             1-BYTE RESERVED AREA        @Y30LB02
DEFVFLG  DC    XL1'00'             1-BYTE FLAGS AREA           @Y30LB02
DEFVLIB  DC    XL1'00'             1-BYTE LIBID AREA           @Y30LB02
DEFVVOL  DC    XL6'000000000000'   6-BYTE AREA FOR VOLID       @Y30LB02
DEFVVFL  DC    XL1'00'             1-BYTE VOLUME FLAGS AREA    @Y30LB02
DEFVRES2 DC    XL1'00'             1-BYTE RESERVE AREA         @Y30LB02
DEFVNVL  DC    XL6'000000000000'   6-BYTE NEW VOLID AREA       @Y30LB02
DEFVRES3 DC    XL2'0000'           2-BYTE RESERVE AREA         @Y30LB02
DEFVCSN1 DC    2XL6'000000000000'  12-BYTE AREA FOR SEQ CART1  @Y30LB02
DEFVCSN2 DC    2XL6'000000000000'  12-BYTE AREA FOR SEQ CART2  @Y30LB02
DEFVRES4 DC    XL2'0000'           2-BYTE RESERVE AREA         @Y30LB02
DEFVASID DC    XL2'0000'           2-BYTE ASID AREA            @Y30LB02
DEFVECB  DC    XL4'00000000'       4-BYTE ECB AREA             @Y30LB02
DEFVDATA DC    18XL4'00000000'     72-BYTE DATA AREA           @Y30LB02
DEFVVEXT DC    XL4'00000000'       4-BYTE VVICEXT AREA         @Y30LB02
         AGO   .FINISH                                         @Y30LB02
.*                                                             @Y30LB02
.LISTDS  ANOP                                                  @Y30LB02
*  MACMEAN  MSSC DEFINE VOLUME MACRO--UNINITIALIZED LIST FORM  @Y30LB02
*  VS1-4/VS2-3 VERSION--06/09/74   LEVEL 00                    @Y30LB02
ICBDEFV  DSECT                                                 @Y30LB02
DEFVLEN  DS    F                   DEFINE REQ LEN 84 HEX       @Y30LB02
DEFVOPC  DS    XL1                 DEFINE  OPCODE 18 HEX       @Y30LB02
DEFVRES1 DS    XL1                 1-BYTE RESERVED AREA        @Y30LB02
DEFVFLG  DS    XL1                 1-BYTE FLAGS AREA           @Y30LB02
DEFVLIB  DS    XL1                 1-BYTE LIBID AREA           @Y30LB02
DEFVVOL  DS    CL6                 6-BYTE AREA FOR VOLID       @Y30LB02
DEFVVFL  DS    XL1                 1-BYTE VOLUME FLAGS         @Y30LB02
DEFVRES2 DS    XL1                 1-BYTE RESERVE AREA         @Y30LB02
DEFVNVL  DS    CL6                 6-BYTE NEW VOLID AREA       @Y30LB02
DEFVRES3 DS    XL2                 2-BYTE RESERVE AREA         @Y30LB02
DEFVCSN1 DS    CL12                12-BYTE AREA SEQ CART1      @Y30LB02
DEFVCSN2 DS    CL12                12-BYTE AREA FOR SEQ CART2  @Y30LB02
DEFVRES4 DS    XL2                 2-BYTE RESERVE AREA         @Y30LB02
DEFVASID DS    XL2                 2-BYTE ASID AREA            @Y30LB02
DEFVECB  DS    A                   4-BYTE ECB ADDR             @Y30LB02
DEFVDATA DS    CL72                72-BYTE DATA AREA           @Y30LB02
DEFVVEXT DS    A                   4-BYTE VVICEXT ADDR         @Y30LB02
         AGO   .FINISH                                         @Y30LB02
.*       PROCESSING FOR THE EXECUTE MACRO FORM                 @Y30LB02
.*                                                             @Y30LB02
.EFORM   AIF   ('&MF(1)' NE 'E').SFORM      IS IT EFORM?       @Y30LB02
         AIF   ('&MF(2)' EQ '').EFOUT       IS 2ND PARM NULL?  @Y30LB02
.*                                                             @Y30LB02
*  MACMEAN  MSSC DEFINE VOLUME MACRO--EXECUTE FORM             @Y30LB02
*  VS1-4/VS2-3 VERSION--06/09/74   LEVEL 00                    @Y30LB02
&SYMBOL  IHBINNRA &MF(2)           LD ADDR OF REQUEST BLK      @Y30LB02
.*                                 USING IHBINNRA MACRO        @Y30LB02
         LA    0,132                 LENGTH OF DEFV REQ BLK    @Y30LB02
         ST    0,0(1)                STORE LENGTH              @Y30LB02
         MVI   4(1),X'18'            STORE DEFINE OPCODE       @Y30LB02
         AGO   .CKSW2                                          @Y30LB02
.*                                                             @Y30LB02
.EFOUT   ANOP                                                  @Y30LB02
         MNOTE 12,'  ICB612I - MF(2) MUST CONTAIN REQ BLK '    @Y30LB02
         MNOTE 12,'  NAME IF EXEC MACRO  FORM REQUESTED '      @Y30LB02
&ERSW    SETB  1                   SET CONDITION SWITCH TO 1   @Y30LB02
.*                                                             @Y30LB02
.CKSW2   AIF   (&ERSW).FINISH      IF ERROR - END PROCESSING   @Y30LB02
         AGO   .CPROC              NAME OK - CONTINUE PROCESS  @Y30LB02
.*                                                             @Y30LB02
.*       PROCESSING OF 'STANDARD' MACRO FORM                   @Y30LB02
.*                                                             @Y30LB02
.SFORM   AIF   ('&MF(1)' NE '').INCFM      STANDARD FORM?      @Y30LB02
         AIF   ('&ECB' NE '').CKFLG    ECB SPECIFIED           @Y30LB02
&ERSW    SETB  1                 ERROR CONDITION NOTED         @Y30LB02
         MNOTE 12,'  ICB605I - ECB MUST BE SPECIFIED FOR '     @Y30LB02
         MNOTE 12,'  STANDARD FORM MACRO '                     @Y30LB02
         AGO   .CKSW4                                          @Y30LB02
.*                                                             @Y30LB02
.CKFLG   AIF   ('&FLAGS' NE '').CKSW4    FLAGS SPECIFIED       @Y30LB02
&ERSW    SETB  1                 ERROR CONDITION NOTED         @Y30LB02
         MNOTE 12,'  ICB607I - FLAGS MUST BE SPECIFIED '       @Y30LB02
         MNOTE 12,'  FOR STANDARD FORM MACRO '                 @Y30LB02
         AGO   .CKSW4                                          @Y30LB02
.*                                                             @Y30LB02
.INCFM   ANOP                                                  @Y30LB02
&ERSW    SETB  1                   ERROR CONDITION NOTED       @Y30LB02
         MNOTE 12,'  ICB615I - INVALID MF PARAMETER '          @Y30LB02
         MNOTE 12,'  SPECIFIED, MUST BE, L,E, OR NULL'         @Y30LB02
.CKSW4   AIF   (&ERSW).FINISH      IF ERROR-END PROCESSING     @Y30LB02
*  MACMEAN  MSSC DEFINE VOLUME MACRO--STANDARD FORM            @Y30LB02
*  VS1-4/VS2-3 VERSION--06/09/74   LEVEL 00                    @Y30LB02
         CNOP 0,4                                              @Y30LB02
&SYMBOL  BAL   1,&DEFV             BRANCH AROUND REQ BLK       @Y30LB02
DEFVLEN  DC    A(&DEFV-*)          LENGTH OF DEFINE REQ BLK    @Y30LB02
DEFVOPC  DC    XL1'18'             DEFINE VOLUME OPCODE        @Y30LB02
DEFVRES1 DC    XL1'00'             1-BYTE RESERVED AREA        @Y30LB02
DEFVFLG  DC    XL1'00'             1-BYTE FLAGS AREA           @Y30LB02
DEFVLIB  DC    XL1'00'             1-BYTE LIBID AREA           @Y30LB02
DEFVVOL  DC    XL6'000000000000'   6-BYTE AREA FOR VOLID       @Y30LB02
DEFVVFL  DC    XL1'00'             1-BYTE VOLUME FLAGS AREA    @Y30LB02
DEFVRES2 DC    XL1'00'             1-BYTE RESERVED AREA        @Y30LB02
DEFVNVL  DC    XL6'000000000000'   6-BYTE NEW VOLID AREA       @Y30LB02
DEFVRES3 DC    XL2'0000'           2-BYTE RESERVED AREA        @Y30LB02
DEFVCSN1 DC    2XL6'000000000000'  12-BYTE AREA FOR CART SEQ1  @Y30LB02
DEFVCSN2 DC    2XL6'000000000000'  12-BYTE AREA FOR CART SEQ2  @Y30LB02
DEFVRES4 DC    XL2'0000'           2-BYTE RESERVE AREA         @Y30LB02
DEFVASID DC    XL2'0000'           2-BYTE ASID AREA            @Y30LB02
DEFVECB  DC    XL4'00000000'       4-BYTE ECB AREA             @Y30LB02
DEFVDATA DC    18XL4'00000000'     72-BYTE DATA AREA           @Y30LB02
DEFVVEXT DC    XL4'00000000'       4-BYTE VVICEXT AREA         @Y30LB02
&DEFV    EQU   *                                               @Y30LB02
.*                                                             @Y30LB02
.*       PROCESS REQUEST BLOCK FOR STANDARD AND EXECUTE FORMS  @Y30LB02
.*                                                             @Y30LB02
.CPROC   AIF   ('&FLAGS' EQ '').LIBID       FLAGS SPECIFIED?   @Y30LB02
         AIF   ('&FLAGS'(1,1) EQ '(').FLREG FLAGS IN REG-FORM? @Y30LB02
         MVC   6(1,1),&FLAGS         PUT FLAGS IN REQ BLK      @Y30LB02
         AGO   .LIBID                BRANCH                    @Y30LB02
.*                                                             @Y30LB02
.FLREG   ANOP                                                  @Y30LB02
         MVC   6(1,1),0(&FLAGS(1))   REGFORM-PLACE FLAGS REQB  @Y30LB02
.*                                                             @Y30LB02
.LIBID   AIF   ('&LIBID' EQ '').VOLID       LIBID SPECIFIED?   @Y30LB02
         AIF   ('&LIBID'(1,1) EQ '(').LIBREG  REG-FORM?        @Y30LB02
         MVC   7(1,1),&LIBID         ADDR-FM,LIBID IN REQB     @Y30LB02
         AGO   .VOLID                BRANCH                    @Y30LB02
.*                                                             @Y30LB02
.LIBREG  ANOP                                                  @Y30LB02
         MVC   7(1,1),0(&LIBID(1))   REG-FORM-LIBID IN REQB    @Y30LB02
.*                                                             @Y30LB02
.VOLID   AIF   ('&VOLID' EQ '').VOLFLG      VOLID SPECIFIED?   @Y30LB02
         AIF   ('&VOLID'(1,1) EQ  '(').REGV VOLID IN REG-FORM? @Y30LB02
         MVC   8(6,1),&VOLID         PUT VOLID IN REQBLK       @Y30LB02
         AGO   .VOLFLG               BRANCH                    @Y30LB02
.*                                                             @Y30LB02
.REGV    ANOP                                                  @Y30LB02
         MVC   8(6,1),0(&VOLID(1))   REGFORM-VOLID IN BLK      @Y30LB02
.*                                                             @Y30LB02
.VOLFLG  AIF   ('&VOLFLG' EQ '').NVOLID     VOLFLG SPECIFIED?  @Y30LB02
         AIF   ('&VOLFLG'(1,1) EQ '(').REFLG VOLFLG REG-FORM?  @Y30LB02
         MVC   14(1,1),&VOLFLG       PUT VAL VOLFLG IN BLK     @Y30LB02
         AGO   .NVOLID               BRANCH                    @Y30LB02
.*                                                             @Y30LB02
.REFLG   ANOP                                                  @Y30LB02
         MVC   14(1,1),0(&VOLFLG(1)) REG FORM-VOLFLG IN BLK    @Y30LB02
.*                                                             @Y30LB02
.NVOLID  AIF   ('&NVOLID' EQ '').CSN1       NVOLID SPECIFIED   @Y30LB02
         AIF   ('&NVOLID'(1,1) EQ '(').RNVL NVOLID REG-FORM?   @Y30LB02
         MVC   16(6,1),&NVOLID       ADDRFORM-NVOLID IN BLK    @Y30LB02
         AGO   .CSN1                                           @Y30LB02
.*                                                             @Y30LB02
.RNVL    ANOP                                                  @Y30LB02
         MVC   16(6,1),0(&NVOLID(1)) REG-FORM-NVOLID IN BLK    @Y30LB02
.*                                                             @Y30LB02
.CSN1    AIF  ('&CSN1' EQ '').CSN2            CSN1 SPECIFIED?  @Y30LB02
         AIF   ('&CSN1'(1,1) EQ '(').REGC1    CSN1 REG FORM?   @Y30LB02
         MVC   24(12,1),&CSN1        ADDRFORM-CSN1 PARM        @Y30LB02
         AGO   .CSN2                 BRANCH                    @Y30LB02
.*                                                             @Y30LB02
.REGC1   ANOP                                                  @Y30LB02
         MVC   24(12,1),0(&CSN1(1))  REG FORM-CSN1 TO BLK      @Y30LB02
.*                                                             @Y30LB02
.CSN2    AIF   ('&CSN2' EQ '').CKECB2       CSN2 SPECIFIED?    @Y30LB02
         AIF   ('&CSN2'(1,1) EQ '(').REGC2  CSN2 IN REG FORM?  @Y30LB02
         MVC   36(12,1),&CSN2        ADDRFORM-CSN2 IN BLK      @Y30LB02
         AGO   .CKECB2                                         @Y30LB02
.*                                                             @Y30LB02
.REGC2   ANOP                                                  @Y30LB02
         MVC   36(12,1),0(&CSN2(1))  REG FORM-CSN2 TO BLK      @Y30LB02
.*                                                             @Y30LB02
.CKECB2  AIF   ('&ECB' EQ '').VEXT   ECB SPECIFIED?            @Y30LB02
         AIF   ('&ECB'(1,1) EQ '(').ECBREG  ECB REG-FORM?      @Y30LB02
         LA    15,&ECB               ADDRFORM--ECB IN BLK      @Y30LB02
         ST    15,52(1)              STORE ADDR IN BLK         @Y30LB02
         AGO   .VEXT                                           @Y30LB02
.ECBREG  ANOP                                                  @Y30LB02
         ST    &ECB,52(1)            REGFORM-ECB IN BLK        @Y30LB02
.VEXT    ANOP                                                  @Y30LB02
         AIF   ('&VVICEXT' EQ '').DATA  VVICEXT SPECD?         @Y30LB02
         AIF   ('&VVICEXT'(1,1) EQ '(').RVEXT REGFORM BRCH     @Y30LB02
         LA    15,&VVICEXT           LOAD REG 15 WITH          @Y30LB02
.*                                   VVICEXT ADDRESS           @Y30LB02
         ST    15,128(1)             STORE ADDRESS             @Y30LB02
         AGO   .DATA                 BRANCH                    @Y30LB02
.*                                                             @Y30LB02
.RVEXT   ANOP                                                  @Y30LB02
         ST    &VVICEXT,128(1)       STORE VVICEXT ADDRESS     @Y30LB02
.DATA    AIF   ('&USDATA' EQ '').INVOKE   BRCH IF NULL         @Y30LB02
         AIF   ('&USDATA'(1,1) EQ '(').RDTA  IF REGFORM BRCH   @Y30LB02
         MVC   56(72,1),&USDATA      LOAD DATA IN REQ BLK      @Y30LB02
         AGO   .INVOKE               BRANCH                    @Y30LB02
.RDTA    ANOP                                                  @Y30LB02
         MVC   56(72,1),0(&USDATA(1)) LOAD DATA INTO REQ BLK   @Y30LB02
.INVOKE  ANOP                                                  @Y30LB02
         SVC   126           ISSUE SVC INSTRUCTION             @ZM31011
.FINISH  MEND                                                  @Y30LB02
**/
*   ICBDEFV:  MACRO KEYS(MF,FLAGS,LIBID,VOLID,VOLFLG,NVOLID,
*                        CSN1,CSN2,ECB,USDATA,VVICEXT);    /*@Y30LB02*/
*/*                                                          @Y30LB02*/
*/*                          EXTERNAL DECLARES               @Y30LB02*/
*/*                                                          @Y30LB02*/
*   DCL  DEFVTEST  FIXED EXT;    /*CTR FOR S-FORM INVOC      @Y30LB02*/
*   DCL  DEFTESR1  FIXED EXT;    /*TEST FOR REG1 INVOC       @Y30LB02*/
*/*                                                          @Y30LB02*/
*/*                          INTERNAL DECLARES               @Y30LB02*/
*/*                                                          @Y30LB02*/
*   DCL  ERSW     FIXED;     /*ERROR CONDITION SWITCH        @Y30LB02*/
*   DCL  DEFVCD   CHAR;      /*DEFINE VOLUME OPCODE          @Y30LB02*/
*   DCL  RETCODE  FIXED;     /*RETURN CODE                   @Y30LB02*/
*   DCL  DEFVLN   CHAR;      /*LENGTH OF DEFINE VOL LIST     @Y30LB02*/
*   DCL  CTR   FIXED;        /*LIST FORM PARAMETER CTR       @Y30LB02*/
*        DEFVCD = '18';      /*HEX OPCODE FOR DEFINE         @Y30LB02*/
*        DEFVLN = '84';      /*HEX LENGTH OF DEFINE REQ      @Y30LB02*/
*        CTR = 0;            /*INITIALIZE PARM CTR           @Y30LB02*/
*        RETCODE = 0;        /*INITIALIZE RETURN CODE        @Y30LB02*/
*        ERSW = 0;           /*INITIALIZE ERROR SWITCH       @Y30LB02*/
*/*                                                          @Y30LB02*/
*/*      CHECK FOR VALID MACRO FORMAT - E, L, OR NULL        @Y30LB02*/
*/*********************************************************  @Y30LB02*/
*/*                                                          @Y30LB02*/
*     IF DEFTESR1=0 THEN     /*REG 1 ALREADY DCLD?           @Y30LB02*/
*        DO;                 /*NO,DECLARE IT                 @Y30LB02*/
*          ANS('DCL DEFVR1 REG(1) PTR ;/*ADDRESS OF '||
*          'REQUEST BLOCK @Y30LB02*/')SKIP;
*          DEFTESR1=DEFTESR1+1;   /*INCREM REG COUNTER       @Y30LB02*/
*        END;                     /*                         @Y30LB02*/
*/*                                                          @Y30LB02*/
*   IF MF(1) ^= 'L' THEN     /*IS IT LIST FORM?              @Y30LB02*/
*     GO TO EFORM;           /*NO,BRCH,CK FOR EXECUTE        @Y30LB02*/
*   IF MF(2) = '' THEN       /*LIST NAME SPECIFIED?          @Y30LB02*/
*     DO;                    /*NO,PROCESS ERROR              @Y30LB02*/
*        ERSW = 1;           /*SET ERROR SWITCH TO ONE       @Y30LB02*/
*        RETCODE = 12;       /*SET RETURN CODE TO 12         @Y30LB02*/
*        ANS MSG('  ICB602I -  A NAME FOR THE '||
*        'REQUEST BLOCK MUST BE SPECIFIED IN MF(2)')SKIP;  /*@Y30LB02*/
*        GO TO FINISH;       /*BRANCH TO END                 @Y30LB02*/
*     END;                   /*                              @Y30LB02*/
*/*                                                          @Y30LB02*/
*/********************************************************   @Y30LB02*/
*/*      THE FOLLOWING CODE WILL CHECK FOR ILLEGAL           @Y30LB02*/
*/*      PARAMETERS SPECIFIED WITH LIST FORM AND             @Y30LB02*/
*/*      PUT OUT DEFINE VOLUME REQUEST BLOCK                 @Y30LB02*/
*/********************************************************   @Y30LB02*/
*   ELSE                     /*                              @Y30LB02*/
*     DO;                    /*CHECK PARAMETERS              @Y30LB02*/
*        IF FLAGS ^= '' THEN /*FLAGS SPECIFIED?              @Y30LB02*/
*             CTR = CTR + 1;/*YES,INCREMENT CTR              @Y30LB02*/
*        IF VOLID ^= '' THEN /*VOLID SPECIFIED?              @Y30LB02*/
*             CTR = CTR + 1; /*YES,INCREMENT COUNTER         @Y30LB02*/
*        IF LIBID ^= '' THEN /*LIBID SPECIFIED?              @Y30LB02*/
*             CTR = CTR + 1; /*YES,INCREMENT COUNTER         @Y30LB02*/
*        IF VOLFLG ^= '' THEN /*VOLUME FLAGS SPECIFIED?      @Y30LB02*/
*             CTR = CTR + 1;  /*YES,INCREMENT COUNTER        @Y30LB02*/
*        IF NVOLID ^= '' THEN /*NEW VOLID SPECIFIED?         @Y30LB02*/
*             CTR = CTR + 1;  /*YES,INCREMENT COUNTER        @Y30LB02*/
*        IF CSN1 ^= '' THEN   /*CART SEQ 1 SPECIFIED?        @Y30LB02*/
*             CTR = CTR + 1;  /*YES,INCREMENT COUNTER        @Y30LB02*/
*        IF CSN2 ^= '' THEN   /*CART SEQ 2 SPECIFIED?        @Y30LB02*/
*             CTR = CTR + 1;  /*YES,INCREMENT COUNTER        @Y30LB02*/
*        IF ECB ^= '' THEN    /*ECB SPECIFIED?               @Y30LB02*/
*             CTR = CTR + 1;  /*YES,INCREMENT COUNTER        @Y30LB02*/
*        IF USDATA ^= '' THEN /*USER DATA SPECIFIED?         @Y30LB02*/
*             CTR = CTR + 1;  /*YES,INCREMENT COUNTER        @Y30LB02*/
*        IF VVICEXT ^= '' THEN /*VVICEXT SPECIFIED           @Y30LB02*/
*             CTR = CTR + 1;  /*YES,INCREMENT COUNTER        @Y30LB02*/
*        IF CTR > 0 THEN      /*COUNTER GT ZERO?             @Y30LB02*/
*          DO;                /*YES,PRINT WARNING MSG        @Y30LB02*/
*             RETCODE = 4;    /*SET RETURN CODE TO 4         @Y30LB02*/
*             ANS MSG('  ICB604I -  WARNING-ONLY'||
*                 ' THE MF PARAMETER IS VALID FOR THE'||
*                 ' LIST FORM  ')SKIP;                     /*@Y30LB02*/
*          END;               /*                             @Y30LB02*/
*     END;                    /*                             @Y30LB02*/
*   IF MF(3) ^= '' THEN       /*PLS ATTRIBUTE SPECIFIED?     @Y30LB02*/
*      GO TO ATTRLST;         /*BRANCH,PROCESS ATTRIBUTE     @Y30LB02*/
*/*                                                          @Y30LB02*/
*   ELSE                      /*INITIALIZED LIST FORM        @Y30LB02*/
*     DO;                     /*OUTPUT DECLARES FOR REQ BLK  @Y30LB02*/
*        ANS('/*******************************************'||
*            '************** @Y30LB02*/')SKIP;
*        ANS('/*    MACMEAN  MSSC DEFINE VOLUME MACRO     '||
*            '               @Y30LB02*/')SKIP;
*        ANS('/*VS1-4/VS2-3 VERSION--06/09/74 LEVEL 00    '||
*            '               @Y30LB02*/')SKIP;
*        ANS('/*THIS IS THE INITIALIZED LIST FORM         '||
*            '               @Y30LB02*/')SKIP;
*        ANS('/*******************************************'||
*            '************** @Y30LB02*/')SKIP;
*        ANS('DCL 1 '||MF(2)||'  STATIC LOCAL,'||
*        '/*DEFINE VOLUME REQUEST BLOCK @Y30LB02*/')SKIP;
*        ANS('    2  DEFVLEN  FIXED(31)INIT('||QUOTE('84')||
*        'X),/*LENGTH OF DEFINE VOLUME REQ BLK @Y30LB02*/')SKIP;
*        ANS('    2  DEFVOPCD  FIXED(8)INIT('||QUOTE('18')||
*        'X),/*DEFINE VOLUME OPCODE @Y30LB02*/')SKIP;
*        ANS('    2  *       CHAR(1)INIT('||QUOTE('00')||
*        'X),/*RESERVED AND ZERO @Y30LB02*/')SKIP;
*        ANS('    2  DEFVFLG   BIT(8)INIT('||QUOTE
*        ('00000000')||'B),/*ONE BYTE FLAGS  @Y30LB02*/')SKIP;
*        ANS('       3  DEFVCR  BIT(1),/*CREATE ATTRI'||
*        'BUTE @Y30LB02*/')SKIP;
*        ANS('       3  DEFVELM BIT(1),/*ELIMINATE'||
*        ' ATTRIBUTE @Y30LB02*/')SKIP;
*        ANS('       3  DEFVRNM  BIT(1),/*RENAME ATTRI'||
*        'BUTE @Y30LB02*/')SKIP;
*        ANS('       3  DEFVREP  BIT(1),/*REPLACE VOLUME'||
*        ' FLAGS @Y30LB02*/')SKIP;
*        ANS('       3  DEFVELTR BIT(1),/*ELIMINATE TRAN'||
*        'SIENT VOLUME ATTRIBUTE @Y30LB02*/')SKIP;
*        ANS('       3  DEFVRNTR BIT(1),/*RENAME TRAN'||
*        'SIENT VOLUME ATTRIBUTE @Y30LB02*/')SKIP;
*        ANS('       3  DEFVACT BIT(1),/*ACTIVATE TRAN'||
*        'SIENT VOLUME ATTRIBUTE @Y30LB02*/')SKIP;
*        ANS('       3  DEFVDACT BIT(1),/*DEACTIVATE'||
*        ' VOLUME ATTRIBUTE @Y30LB02*/')SKIP;
*        ANS('    2  DEFVLIB  BIT(8)INIT('||QUOTE
*        ('00000000')||'B), /*ONE BYTE LIBID @Y30LB02*/')SKIP;
*        ANS('       3  *       BIT(6),/*RESERVED AND'||
*        ' MUST BE ZERO @Y30LB02*/')SKIP;
*        ANS('       3  DEFVLID BIT(2),/*BINARY NUMBER'||
*        ' ZERO TO THREE @Y30LB02*/')SKIP;
*        ANS('    2  DEFVOLD CHAR(6) ,/*VOLUME IDENTIFI'||
*        'CATION @Y30LB02*/')SKIP;
*        ANS('        3  *(6)  CHAR(1)INIT((6)'||QUOTE
*        ('00')||'X),/*INIT VOLID AREA TO ZERO @Y30LB02*/')SKIP;
*        ANS('    2  DEFVVFLG  BIT(8)INIT('||QUOTE
*        ('00000000')||'B),/*VOLUME FLAG ATTRIB @Y30LB02*/')SKIP;
*        ANS('       3  DEFVCECT BIT(1),/*CE CARTRIDGE'||
*        ' @Y30LB02*/')SKIP;
*        ANS('       3  *  BIT(1),/*RESERVED BIT'||
*        ' @Y30LB02*/')SKIP;
*        ANS('       3  DEFVSEC  BIT(1),/*SECURE VOLUME'||
*        ' @Y30LB02*/')SKIP;
*        ANS('       3  DEFVEXCL  BIT(1),/*EXCLUSIVE '||
*        'VOLUME @Y30LB02*/')SKIP;
*        ANS('       3  *  BIT(1),/*RESERVED '||
*        'BIT-USED BY THE SUBSYSTEM @Y30LB02*/')SKIP;
*        ANS('       3  DEFVBIND  BIT(1),/*BIND VOLUME'||
*        ' @Y30LB02*/')SKIP;
*        ANS('       3  DEFVWINH  BIT(1),/*WRITE INHIBIT'||
*        ' @Y30LB02*/')SKIP;
*        ANS('       3  *       BIT(1),/*RESERVED-ZERO'||
*        ' @Y30LB02*/')SKIP;
*        ANS('    2  *         CHAR(1)INIT('||QUOTE('00')||
*        'X),/*1-BYTE RESERVED AREA @Y30LB02*/')SKIP;
*        ANS('    2  DEFVNVOL  CHAR(6) ,/*NEW VOL ID @Y30LB02*/')SKIP;
*        ANS('        3  *(6)  CHAR(1)INIT((6)'||QUOTE
*        ('00')||'X),/*INIT AREA TO ZERO @Y30LB02*/')SKIP;
*        ANS('    2  *          CHAR(2) ,/*2-BYTE RESERVED'||
*        ' AREA @Y30LB02*/')SKIP;
*        ANS('        3  *(2)  CHAR(1)INIT((2)'||QUOTE
*        ('00')||'X),/*INIT RESERVED AREA TO ZERO @Y30LB02*/')SKIP;
*        ANS('    2  DEFVCSN1  CHAR(12) ,/*CART SEQUENCE'||
*        ' ONE @Y30LB02*/')SKIP;
*        ANS('        3  *(12)  CHAR(1)INIT((12)'||QUOTE
*        ('00')||'X),/*INIT CART ONE AREA TO ZERO @Y30LB02*/')SKIP;
*        ANS('    2  DEFVCSN2     CHAR(12) ,/*CART SEQ'||
*        ' TWO @Y30LB02*/')SKIP;
*        ANS('        3  *(12)  CHAR(1)INIT((12)'||QUOTE
*        ('00')||'X),/*INIT CART TWO AREA TO ZERO @Y30LB02*/')SKIP;
*        ANS('    2  *     CHAR(2) INIT('||
*        QUOTE('0000')||'X),/*RESERVED @Y30LB02*/')SKIP;
*        ANS('    2  DEFVASID CHAR(2) INIT('||
*        QUOTE('0000')||'X),/*ASID AREA @Y30LB02*/')SKIP;
*        ANS('    2  DEFVECB  FIXED(31)INIT(0),/*EVENT '||
*        'CONTROL BLOCK ADDRESS @Y30LB02*/')SKIP;
*        ANS('    2  DEFVDATA CHAR(72) INIT('||
*        QUOTE('')||'B),/*USER DATA ARRAY @Y30LB02*/')SKIP;
*        ANS('       3  DEFR50 CHAR(2),/*RESERVED AND MUST '||
*        'ALWAYS BE ZERO/BLANK @Y30LB02*/')SKIP;
*        ANS('       3  DEFACSEC CHAR(1),/*ACCESSI'||
*        'BILITY(SECURITY) @Y30LB02*/')SKIP;
*        ANS('       3  DEFR55 CHAR(26),/*RESERVED AREA '||
*        'MUST BE ZERO/BLANK @Y30LB02*/')SKIP;
*        ANS('       3  DEFOWNID CHAR(14),/*OWNER'||
*        ' IDENTIFICATION @Y30LB02*/')SKIP;
*        ANS('       3  DEFR60 CHAR(28),/*RESERVED AREA '||
*        'MUST BE ZERO/BLANK @Y30LB02*/')SKIP;
*        ANS('       3  DEFTLAB CHAR(1),/*T LABEL '||
*        'STANDARD VERSION @Y30LB02*/')SKIP;
*        ANS('    2  DEFVVEXT  FIXED(31)INIT(0);/*MSVC '||
*        'EXTENSION AREA @Y30LB02*/')SKIP;
*        GO TO FINISH;         /*BRANCH TO END               @Y30LB02*/
*     END;                     /*                            @Y30LB02*/
*/*                                                          @Y30LB02*/
*ATTRLST:
*/*                                                          @Y30LB02*/
*        ANS('/*******************************************'||
*            '************** @Y30LB02*/')SKIP;
*        ANS('/*     MACMEAN  MSSC DEFINE VOLUME MACRO    '||
*            '               @Y30LB02*/')SKIP;
*        ANS('/*VS1-4/VS2-3 VERSION--06/09/74 LEVEL 00    '||
*            '               @Y30LB02*/')SKIP;
*        ANS('/*THIS IS THE UNINITIALIZED LIST FORM       '||
*            '               @Y30LB02*/')SKIP;
*        ANS('/*******************************************'||
*            '************** @Y30LB02*/')SKIP;
*        ANS('DCL 1 '||MF(2)||' '||MF(3)||','||
*        ' /*DEFINE VOLUME REQUEST BLOCK @Y30LB02*/')SKIP;
*        ANS('    2  DEFVLEN  FIXED(31),/*LENGTH '||
*        'OF DEFINE VOLUME REQ BLK=84 HEX @Y30LB02*/')SKIP;
*        ANS('    2  DEFVOPCD  FIXED(8),/*DEFINE '||
*        'OPCODE = 18 HEX @Y30LB02*/')SKIP;
*        ANS('    2  *  CHAR(1),/*RESERVED AND ZERO @Y30LB02 */')SKIP;
*        ANS('    2  DEFVFLG   BIT(8) ,/*ONE BYTE'||
*        ' FLAGS AREA @Y30LB02*/')SKIP;
*        ANS('       3  DEFVCR  BIT(1),/*CREATE ATTRI'||
*        'BUTE @Y30LB02*/')SKIP;
*        ANS('       3  DEFVELM BIT(1),/*ELIMINATE'||
*        ' ATTRIBUTE @Y30LB02*/')SKIP;
*        ANS('       3  DEFVRNM  BIT(1),/*RENAME ATTRI'||
*        'BUTE @Y30LB02*/')SKIP;
*        ANS('       3  DEFVREP  BIT(1),/*REPLACE VOLUME'||
*        ' FLAGS @Y30LB02*/')SKIP;
*        ANS('       3  DEFVELTR BIT(1),/*ELIMINATE TRAN'||
*        'SIENT VOLUME ATTRIBUTE @Y30LB02*/')SKIP;
*        ANS('       3  DEFVRNTR BIT(1),/*RENAME TRAN'||
*        'SIENT VOLUME ATTRIBUTE @Y30LB02*/')SKIP;
*        ANS('       3  DEFVACT BIT(1),/*ACTIVATE TRAN'||
*        'SIENT VOLUME ATTRIBUTE @Y30LB02*/')SKIP;
*        ANS('       3  DEFVDACT BIT(1),/*DEACTIVATE'||
*        ' VOLUME ATTRIBUTE @Y30LB02*/')SKIP;
*        ANS('    2  DEFVLIB  BIT(8),/*ONE BYTE LIBID @Y30LB02*/')SKIP;
*        ANS('       3  *       BIT(6),/*RESERVED AND'||
*        ' MUST BE ZERO @Y30LB02*/')SKIP;
*        ANS('       3  DEFVLID BIT(2),/*BINARY NUMBER'||
*        ' ZERO TO THREE @Y30LB02*/')SKIP;
*        ANS('    2  DEFVOLD CHAR(6) ,/*VOLUME IDENTIFI'||
*        'CATION @Y30LB02*/')SKIP;
*        ANS('    2  DEFVVFLG  BIT(8),'||
*        '/*VOLUME FLAG ATTRIB @Y30LB02*/')SKIP;
*        ANS('       3  DEFVCECT BIT(1),/*CE CARTRIDGE'||
*        ' @Y30LB02*/')SKIP;
*        ANS('       3  *  BIT(1),/*RESERVED BIT'||
*        ' @Y30LB02*/')SKIP;
*        ANS('       3  DEFVSEC  BIT(1),/*SECURE VOLUME'||
*        ' @Y30LB02*/')SKIP;
*        ANS('       3  DEFVEXCL  BIT(1),/*EXCLUSIVE '||
*        ' VOLUME @Y30LB02*/')SKIP;
*        ANS('       3  *  BIT(1),/*SCRATCH '||
*        'CARTRIDGE RESERVED FOR SUBSYS @Y30LB02*/')SKIP;
*        ANS('       3  DEFVBIND  BIT(1),/*BIND VOLUME'||
*        ' @Y30LB02*/')SKIP;
*        ANS('       3  DEFVWINH  BIT(1),/*WRITE INHIBIT'||
*        ' @Y30LB02*/')SKIP;
*        ANS('       3  *       BIT(1),/*RESERVED-ZERO'||
*        ' @Y30LB02*/')SKIP;
*        ANS('    2  *  CHAR(1),/*BYTE RESVD AREA @Y30LB02*/')SKIP;
*        ANS('    2  DEFVNVOL CHAR(6),/*NEW VOLID @Y30LB02*/')SKIP;
*        ANS('    2  *          CHAR(2) ,/*2-BYTE RESERVED'||
*        ' AREA @Y30LB02*/')SKIP;
*        ANS('    2  DEFVCSN1     CHAR(12) ,/*CART SEQUENCE'||
*        ' ONE @Y30LB02*/')SKIP;
*        ANS('    2  DEFVCSN2     CHAR(12) ,/*CART SEQ'||
*        ' TWO @Y30LB02*/')SKIP;
*        ANS('    2  *     CHAR(2) ,'||
*        '/*RESERVED @Y30LB02*/')SKIP;
*        ANS('    2  DEFVASID CHAR(2) ,'||
*        '/*ASID AREA @Y30LB02*/')SKIP;
*        ANS('    2  DEFVECB  FIXED(31),/*EVENT '||
*        'CONTROL BLOCK ADDRESS @Y30LB02*/')SKIP;
*        ANS('    2  DEFVDATA CHAR(72),'||
*        '/*USER DATA ARRAY @Y30LB02*/')SKIP;
*        ANS('       3  DEFR50 CHAR(2),/*RESERVED AND MUST '||
*        'ALWAYS BE ZERO/BLANK @Y30LB02*/')SKIP;
*        ANS('       3  DEFACSEC CHAR(1),/*ACCESSI'||
*        'BILITY(SECURITY) @Y30LB02*/')SKIP;
*        ANS('       3  DEFR55 CHAR(26),/*RESERVED AREA '||
*        'MUST BE ZERO/BLANK @Y30LB02*/')SKIP;
*        ANS('       3  DEFOWNID CHAR(14),/*OWNER'||
*        ' IDENTIFICATION @Y30LB02*/')SKIP;
*        ANS('       3  DEFR60 CHAR(28),/*RESERVED AREA '||
*        'MUST BE ZERO/BLANK @Y30LB02*/')SKIP;
*        ANS('       3  DEFTLAB CHAR(1),/*T LABEL '||
*        'STANDARD VERSION @Y30LB02*/')SKIP;
*        ANS('    2  DEFVVEXT  FIXED(31);/*MSVC '||
*        'EXTENSION AREA @Y30LB02*/')SKIP;
*        GO TO FINISH;     /*BRANCH TO END                   @Y30LB02*/
*/*                                                          @Y30LB02*/
*/*   PROCESSING THE EXECUTE MACRO FORM                      @Y30LB02*/
*/*                                                          @Y30LB02*/
*EFORM:
*   IF MF(1) ^= 'E' THEN     /*EXECUTE FORM SPECIFIED?       @Y30LB02*/
*     GO TO SFORM;           /*NO,BRCH AND CK FOR STD FORM   @Y30LB02*/
*   IF MF(2) = '' THEN       /*IS LIST NAME SPECIFIED?       @Y30LB02*/
*     DO;                    /*NO,PRINT OUT ERROR MSG        @Y30LB02*/
*        ERSW = 1;           /*SET ERROR SWITCH TO ONE       @Y30LB02*/
*        RETCODE = 12;       /*SET RETURN CODE TO 12         @Y30LB02*/
*        ANS MSG('  ICB612I - MF(2) MUST CONTAIN REQ BLK '||
*        'NAME IF EXEC MACRO FORM REQUESTED')SKIP;         /*@Y30LB02*/
*        GO TO CKSW;         /*BRANCH TO CHECK ERROR SWITCH  @Y30LB02*/
*     END;                   /*                              @Y30LB02*/
*/*                                                          @Y30LB02*/
*   ELSE                     /*REQUEST TO ZERO BLOCK         @Y30LB02*/
*        ANS('/*******************************************'||
*            '************** @Y30LB02*/')SKIP;
*        ANS('/*     MACMEAN  MSSC DEFINE VOLUME MACRO    '||
*            '               @Y30LB02*/')SKIP;
*        ANS('/*VS1-4/VS2-3 VERSION-- 06/09/74 LEVEL 00   '||
*            '               @Y30LB02*/')SKIP;
*        ANS('/*THIS IS THE OUTPUT FOR THE EXECUTE FORM.  '||
*            '               @Y30LB02*/')SKIP;
*        ANS('/*THE LIST FORM OF THIS MACRO SHOULD BE     '||
*            '               @Y30LB02*/')SKIP;
*        ANS('/*INVOKED FIRST IN ORDER TO SET UP NECESSARY'||
*            '               @Y30LB02*/')SKIP;
*        ANS('/*DECLARES.  IF THE COMPLETE ARGUMENT IS    '||
*            '               @Y30LB02*/')SKIP;
*        ANS('/*SPECIFIED THE REQ BLOCK WILL BE ZEROED.   '||
*            '               @Y30LB02*/')SKIP;
*        ANS('/*******************************************'||
*            '************** @Y30LB02*/')SKIP;
*/*                                                          @Y30LB02*/
*   IF MF(3) = 'COMPLETE' THEN  /*COMPLETE SPECIFIED         @Y30LB02*/
*     DO;                    /*ZERO OUT THE BLOCK            @Y30LB02*/
*      ANS(' '||MF(2)||'='||MF(2)||'&&'||MF(2)||';/*ZERO '||
*        ' AND INIT REQUEST BLOCK @Y30LB02*/')SKIP;
*     END;                                                 /*@Y30LB02*/
*/*                                                          @Y30LB02*/
*   ANS('RFY DEFVR1 RSTD;/*RESTRICT REG 1 @Y30LB02*/')SKIP;
*   ANS('DEFVR1= ADDR('||MF(2)||'); /*R1 PTR'||
*       ' TO REQUEST BLOCK @Y30LB02*/')SKIP;
*CKSW:
*   IF ERSW = 1 THEN        /*SET RETURN CODE TO ONE         @Y30LB02*/
*     GO TO FINISH;         /*BRANCH TO END                  @Y30LB02*/
*   ELSE                    /*                               @Y30LB02*/
*     GO TO COMPROC;        /*BRANCH TO CK PARAMETERS        @Y30LB02*/
*/*                                                          @Y30LB02*/
*SFORM:
*   IF MF(1) ^= '' THEN     /*STANDARD FORM REQUEST?         @Y30LB02*/
*     DO;                   /*NO,PROCESS ERROR               @Y30LB02*/
*        ERSW = 1;          /*SET ERROR SWITCH TO ONE        @Y30LB02*/
*        RETCODE = 12;      /*SET RETURN CODE TO 12          @Y30LB02*/
*        ANS MSG('  ICB615I - INVALID MF PARAMETER '||
*             'SPECIFIED, MUST BE L, E, OR NULL')SKIP;     /*@Y30LB02*/
*        GO TO CKSW2;       /*BRANCH TO CK ERROR SWITCH      @Y30LB02*/
*     END;                  /*                               @Y30LB02*/
*/*                                                          @Y30LB02*/
*   IF ECB = '' THEN        /*ECB SPECIFIED?                 @Y30LB02*/
*     DO;                   /*NO,PROCESS ERROR MSG           @Y30LB02*/
*        ERSW = 1;          /*SET ERROR SWITCH TO ONE        @Y30LB02*/
*        RETCODE = 12;      /*SET RETURN CODE TO 12          @Y30LB02*/
*        ANS MSG('  ICB605I - ECB MUST BE SPECIFIED '||
*        'FOR STANDARD FORM MACRO')SKIP;                   /*@Y30LB02*/
*        GO TO CKSW2;       /*BRANCH TO CK ERROR SWITCH      @Y30LB02*/
*     END;                  /*                               @Y30LB02*/
*   IF FLAGS = '' THEN      /*FLAGS SPECIFIED?               @Y30LB02*/
*     DO;                   /*NO,PRINT ERROR MESSAGE         @Y30LB02*/
*        ERSW = 1;          /*SET ERROR SWITCH TO ONE        @Y30LB02*/
*        RETCODE = 12;      /*SET RETURN CODE TO 12          @Y30LB02*/
*        ANS MSG('  ICB607I - FLAGS MUST BE SPECIFIED '||
*        'FOR STANDARD FORM MACRO')SKIP;                   /*@Y30LB02*/
*     END;                  /*                               @Y30LB02*/
*CKSW2:
*   IF ERSW = 1 THEN        /*IS ERROR SWITCH SET?           @Y30LB02*/
*     GO TO FINISH;         /*YES,BRANCH TO END              @Y30LB02*/
*   IF DEFVTEST = 1 THEN    /*1ST STANDARD FORM REQ?         @Y30LB02*/
*     DO;                   /*NO,DON'T PUT OUT DCLS          @Y30LB02*/
*        ANS('/*******************************************'||
*            '************** @Y30LB02*/')SKIP;
*        ANS('/*     MACMEAN  MSSC DEFINE VOLUME MACRO    '||
*            '               @Y30LB02*/')SKIP;
*        ANS('/*VS1-4/VS2-3 VERSION--06/09/74 LEVEL 00    '||
*            '               @Y30LB02*/')SKIP;
*        ANS('/*THIS IS THE OUTPUT FOR A SECONDARY        '||
*            '               @Y30LB02*/')SKIP;
*        ANS('/*INVOCATION OF THE STANDARD FORM MACRO     '||
*            '               @Y30LB02*/')SKIP;
*        ANS('/*******************************************'||
*            '************** @Y30LB02*/')SKIP;
*        ANS('RFY DEFVR1 RSTD;/*RESTRICT REG 1 @Y30LB02*/')SKIP;
*        ANS('DEFVR1= ADDR(DEFVLEN); /*R1 PTR'||
*            ' TO REQUEST BLOCK @Y30LB02*/')SKIP;
*        GO TO COMPROC;                                    /*@Y30LB02*/
*     END;                                                 /*@Y30LB02*/
*/*                                                          @Y30LB02*/
*   ELSE                /*FIRST INVOC OF STD FORM            @Y30LB02*/
*     DO;               /*PRINT OUT THE DECLARES             @Y30LB02*/
*        ANS('/*******************************************'||
*            '************** @Y30LB02*/')SKIP;
*        ANS('/*     MACMEAN  MSSC DEFINE VOLUME MACRO    '||
*            '               @Y30LB02*/')SKIP;
*        ANS('/*VS1-4/VS2-3 VERSION--06/09/74 LEVEL 00    '||
*            '               @Y30LB02*/')SKIP;
*        ANS('/*INVOCATION OF THE STANDARD FORM MACRO     '||
*            '               @Y30LB02*/')SKIP;
*        ANS('/*******************************************'||
*            '************** @Y30LB02*/')SKIP;
*        ANS('DCL 1 DEFVLS01  STATIC LOCAL,'||
*        '/*DEFINE VOLUME REQUEST BLOCK @Y30LB02*/')SKIP;
*        ANS('    2  DEFVLEN  FIXED(31)INIT('||QUOTE('84')||
*        'X),/*LENGTH OF DEFINE VOLUME REQ BLK @Y30LB02*/')SKIP;
*        ANS('    2  DEFVOPCD  FIXED(8)INIT('||QUOTE('18')||
*        'X),/*DEFINE VOLUME OPCODE @Y30LB02*/')SKIP;
*        ANS('    2  *       CHAR(1)INIT('||QUOTE('00')||
*        'X),/*RESERVED AND ZERO @Y30LB02*/')SKIP;
*        ANS('    2  DEFVFLG   BIT(8)INIT('||QUOTE
*        ('00000000')||'B),/*ONE BYTE FLAGS AREA @Y30LB02*/')SKIP;
*        ANS('       3  DEFVCR  BIT(1),/*CREATE ATTRI'||
*        'BUTE @Y30LB02*/')SKIP;
*        ANS('       3  DEFVELM  BIT(1),/*ELIMINATE'||
*        ' ATTRIBUTE @Y30LB02*/')SKIP;
*        ANS('       3  DEFVRNM  BIT(1),/*RENAME ATTRI'||
*        'BUTE @Y30LB02*/')SKIP;
*        ANS('       3  DEFVREP  BIT(1),/*REPLACE VOLUME'||
*        ' FLAGS @Y30LB02*/')SKIP;
*        ANS('       3  DEFVELTR BIT(1),/*ELIMINATE TRAN'||
*        'SIENT VOLUME ATTRIBUTE @Y30LB02*/')SKIP;
*        ANS('       3  DEFVRNTR  BIT(1),/*RENAME TRAN'||
*        'SIENT VOLUME ATTRIBUTE @Y30LB02*/')SKIP;
*        ANS('       3  DEFVACT BIT(1),/*ACTIVATE TRAN'||
*        'SIENT VOLUME ATTRIBUTE @Y30LB02*/')SKIP;
*        ANS('       3  DEFVDACT BIT(1),/*DEACTIVATE'||
*        ' VOLUME ATTRIBUTE @Y30LB02*/')SKIP;
*        ANS('    2  DEFVLIB  BIT(8)INIT('||QUOTE
*        ('00000000')||'B), /*ONE BYTE MSF ID @Y30LB02*/')SKIP;
*        ANS('       3  *       BIT(6),/*RESERVED AND'||
*        ' MUST BE ZERO @Y30LB02*/')SKIP;
*        ANS('       3  DEFVLID BIT(2),/*BINARY NUMBER'||
*        ' ZERO TO THREE @Y30LB02*/')SKIP;
*        ANS('    2  DEFVOLD CHAR(6) ,/*VOLUME ID @Y30LB02*/')SKIP;
*        ANS('        3  *(6)  CHAR(1)INIT((6)'||QUOTE
*        ('00')||'X),/*INIT VOLID AREA TO ZERO @Y30LB02*/')SKIP;
*        ANS('    2  DEFVVFLG  BIT(8)INIT('||QUOTE
*        ('00000000')||'B),/*VOLUME FLAG ATTRIB @Y30LB02*/')SKIP;
*        ANS('       3  DEFVCECT  BIT(1),/*CE CARTRIDGE'||
*        ' @Y30LB02*/')SKIP;
*        ANS('       3  *  BIT(1),/*RESERVED BIT'||
*        ' @Y30LB02*/')SKIP;
*        ANS('       3  DEFVSEC  BIT(1),/*SECURE VOLUME'||
*        ' @Y30LB02*/')SKIP;
*        ANS('       3  DEFVEXCL  BIT(1),/*EXCLUSIVE '||
*        ' VOLUME @Y30LB02*/')SKIP;
*        ANS('       3  *  BIT(1),/*SCRATCH '||
*        'CARTRIDGE - USED BY MSC @Y30LB02*/')SKIP;
*        ANS('       3  DEFVBIND  BIT(1),/*BIND VOLUME'||
*        ' @Y30LB02*/')SKIP;
*        ANS('       3  DEFVWINH  BIT(1),/*WRITE INHIBIT'||
*        ' @Y30LB02*/')SKIP;
*        ANS('       3  *       BIT(1),/*RESERVED-ZERO'||
*        ' @Y30LB02*/')SKIP;
*        ANS('    2  *          CHAR(1)INIT('||QUOTE
*        ('00')||'X),/*1-BYTE RESERVED AREA @Y30LB02*/')SKIP;
*        ANS('    2  DEFVNVOL     CHAR(6) ,/*NEW VOL'||
*        'ID @Y30LB02*/')SKIP;
*        ANS('        3  *(6)  CHAR(1)INIT((6)'||QUOTE
*        ('00')||'X),/*INIT NEW VOLID TO ZERO @Y30LB02*/')SKIP;
*        ANS('    2  *          CHAR(2) ,/*2-BYTE'||
*        ' RESERVED AREA @Y30LB02*/')SKIP;
*        ANS('        3  *(2)  CHAR(1)INIT((2)'||QUOTE
*        ('00')||'X),/*INIT RESERVED AREA @Y30LB02*/')SKIP;
*        ANS('    2  DEFVCSN1     CHAR(12),/*CART SEQ'||
*        ' ONE @Y30LB02*/')SKIP;
*        ANS('        3  *(12)  CHAR(1)INIT((12)'||QUOTE
*        ('00')||'X),/*INIT CART SEQ ONE  @Y30LB02*/')SKIP;
*        ANS('    2  DEFVCSN2    CHAR(12) ,/*CART SEQ'||
*        ' TWO @Y30LB02*/')SKIP;
*        ANS('        3  *(12)  CHAR(1)INIT((12)'||QUOTE
*        ('00')||'X),/*INIT CART SEQ TWO @Y30LB02*/')SKIP;
*        ANS('    2  *     CHAR(2) INIT('||
*        QUOTE('0000')||'X),/*RESERVED @Y30LB02*/')SKIP;
*        ANS('    2  DEFVASID CHAR(2) INIT('||
*        QUOTE('0000')||'X),/*ASID AREA @Y30LB02*/')SKIP;
*        ANS('    2  DEFVECB  FIXED(31)INIT(0),/*EVENT '||
*        'CONTROL BLOCK ADDRESS @Y30LB02*/')SKIP;
*        ANS('    2  DEFVDATA CHAR(72) INIT('||
*        QUOTE('')||'B),/*USER DATA ARRAY @Y30LB02*/')SKIP;
*        ANS('       3  DEFR50 CHAR(2),/*RESERVED AND MUST '||
*        'ALWAYS BE ZERO/BLANK @Y30LB02*/')SKIP;
*        ANS('       3  DEFACSEC CHAR(1),/*ACCESSI'||
*        'BILITY(SECURITY) @Y30LB02*/')SKIP;
*        ANS('       3  DEFR55 CHAR(26),/*RESERVED AREA '||
*        'MUST BE ZERO/BLANK @Y30LB02*/')SKIP;
*        ANS('       3  DEFOWNID CHAR(14),/*OWNER'||
*        ' IDENTIFICATION @Y30LB02*/')SKIP;
*        ANS('       3  DEFR60 CHAR(28),/*RESERVED AREA '||
*        'MUST BE ZERO/BLANK @Y30LB02*/')SKIP;
*        ANS('       3  DEFTLAB CHAR(1),/*T LABEL '||
*        'STANDARD VERSION @Y30LB02*/')SKIP;
*        ANS('    2  DEFVVEXT  FIXED(31)INIT(0);/*MSVC '||
*        'EXTENSION AREA @Y30LB02*/')SKIP;
*        ANS('RFY DEFVR1 RSTD;/*RESTRICT REG 1 @Y30LB02*/')SKIP;
*        ANS('DEFVR1= ADDR(DEFVLEN); /*R1 PTR'||
*        ' TO REQUEST BLOCK @Y30LB02*/')SKIP;
*        DEFVTEST = DEFVTEST + 1;    /*INCREM STD FORM CTR   @Y30LB02*/
*     END;                           /*                      @Y30LB02*/
*/*                                                          @Y30LB02*/
*/*   COMMON PROCESSING FOR EXECUTE AND STANDARDS FORMS      @Y30LB02*/
*/*                                                          @Y30LB02*/
*COMPROC:
*        ANS('DEFVLEN= '||QUOTE(DEFVLN)||'X;/*'||
*        'LENGTH-DEFINE REQUEST BLOCK @Y30LB02*/')SKIP;
*        ANS('DEFVOPCD= '||QUOTE(DEFVCD)||'X;/*'||
*        'DEFINE VOL OPCODE @Y30LB02*/')SKIP;
*/*                                                          @Y30LB02*/
*   IF FLAGS ^= '' THEN     /*FLAGS SPECIFIED                @Y30LB02*/
*/*                                                          @Y30LB02*/
*        ANS('DEFVFLG= ' ||FLAGS||';/*VALUE OF FLAGS'||
*        ' @Y30LB02*/')SKIP;
*/*                                                          @Y30LB02*/
*   IF LIBID ^= '' THEN    /*LIBID SPECIFIED?                @Y30LB02*/
*        ANS('DEFVLIB= '||LIBID||';/*VALUE OF LIBID   @Y30LB02*/')SKIP;
*/*                                                          @Y30LB02*/
*   IF VOLID ^= '' THEN    /*VOLID SPECIFIED?                @Y30LB02*/
*        ANS('DEFVOLD= '||VOLID||';/*VOLUME ID @Y30LB02*/')SKIP;
*/*                                                          @Y30LB02*/
*   IF VOLFLG ^= '' THEN   /*VOLUME FLAGS SPECIFIED?         @Y30LB02*/
*          ANS('DEFVVFLG= '||VOLFLG||';/*VOLUME FLAGS @Y30LB02*/')SKIP;
*/*                                                          @Y30LB02*/
*   IF NVOLID ^= '' THEN   /*NEW VOLID SPECIFIED?            @Y30LB02*/
*        ANS('DEFVNVOL= '||NVOLID||';/*NEW VOLUME ID'||
*        ' @Y30LB02*/')SKIP;
*/*                                                          @Y30LB02*/
*   IF CSN1 ^= '' THEN     /*CSN1 SPECIFIED?                 @Y30LB02*/
*        ANS('DEFVCSN1= '||CSN1||';/*CARTRIDGE SEQUENCE'||
*        ' ONE @Y30LB02*/')SKIP;
*/*                                                          @Y30LB02*/
*   IF CSN2 ^= '' THEN     /*CART SEQ NUM 2 SPECIFIED        @Y30LB02*/
*        ANS('DEFVCSN2= ' ||CSN2||';/*CARTRIDGE SEQUENCE'||
*        ' TWO @Y30LB02*/')SKIP;
*/*                                                          @Y30LB02*/
*   IF ECB ^= '' THEN      /*ECB SPECIFIED?                  @Y30LB02*/
*        ANS('DEFVECB=ADDR' ||ECB|| ';/*ADDRESS '||
*        'OF ECB @Y30LB02*/')SKIP;
*/*                                                          @Y30LB02*/
*   IF USDATA ^= '' THEN   /*USER DATA SPECIFIED?            @Y30LB02*/
*        ANS('DEFVDATA='||USDATA||' ;/*MOVE 72 BYTES OF'||
*        'CARTRIDGE DATA TO THE REQ BLK @Y30LB02*/')SKIP;
*/*                                                          @Y30LB02*/
*   IF VVICEXT ^= '' THEN    /*MSVC EXTENSION SPECIFIED?     @Y30LB02*/
*        ANS('DEFVVEXT=ADDR'||VVICEXT||';/*ADDRESS '||
*        'OF MSVC EXTENSION @Y30LB02*/')SKIP;
*/*                                                          @Y30LB02*/
*/*      INVOKE SVC AND END PROCESSING                       @Y30LB02*/
*/*                                                          @Y30LB02*/
*QUIT:   ANS('SVC (126);/*INVOKE THE MSSC-SVC  @Y30LB02*/')SKIP;
*        ANS('RFY  DEFVR1 UNRSTD;/*UNRESTRICT REG 1 @Y30LB02 */')SKIP;
*/*                                                          @Y30LB02*/
*FINISH:
*        RETURN CODE(RETCODE);                             /*@Y30LB02*/
*        %END;                                             /*@Y30LB02*/
