* %/* START OF SPECIFICATIONS  ***                             @Y30LB02
.*                                                             @Y30LB02
.*01  MODULE-NAME = ICBPAIR                                    @Y30LB02
.*                                                             @Y30LB02
.*01  DESCRIPTIVE-NAME = PURGE/ASSIGN PRIMARY HOST/            @Y30LB02
.*                       INITIALIZE/HOST READY                 @Y30LB02
.*                                                             @Y30LB02
.*01  COPYRIGHT = NONE                                         @Y30LB02
.*                                                             @Y30LB02
.*01  STATUS = OS/VS1 RELEASE 4.0,                             @Y30LB02
.*             OS/VS2 RELEASE 3.0                              @Y30LB02
.*                                                             @Y30LB02
.*01  FUNCTION = BUILDS A REQUEST BLOCK FOR A PURGE/           @Y30LB02
.*               ASSIGN PRIMARY HOST/INITIALIZE/               @Y30LB02
.*               HOST READY REQUEST.  THE MACRO IS A           @Y30LB02
.*               COMMUNICATION LINK BETWEEN THE CALLER         @Y30LB02
.*               AND THE MSSC SVC MODULE.                      @Y30LB02
.*                                                             @Y30LB02
.*01  NOTES = ICBPAIR IS A BILINQUAL MACRO.                    @Y30LB02
.*                                                             @Y30LB02
.*02    DEPENDENCIES = NONE                                    @Y30LB02
.*                                                             @Y30LB02
.*02    RESTRICTIONS = THE CALLER SHOULD AVOID USING THE       @Y30LB02
.*        THE FOLLOWING PREFIXES: ICB, AIR, PAIR, AND PURG.    @Y30LB02
.*                                                             @Y30LB02
.*02    REGISTER-CONVENTIONS = FOLLOWS NORMAL USE OF           @Y30LB02
.*                             REGISTERS BY MACROS:            @Y30LB02
.*                             R0,R1,R14, AND R15.             @Y30LB02
.*                                                             @Y30LB02
.*01  MODULE-TYPE = MACRO                                      @Y30LB02
.*                                                             @Y30LB02
.*02    PROCESSOR = PLS2 AND ASSEM                             @Y30LB02
.*                                                             @Y30LB02
.*01  INPUT                                                    @Y30LB02
.*                                                             @Y30LB02
.*     THE PURGE REQUEST IS ISSUED WHEN THE CALLER WANTS ALL   @Y30LB02
.*     VOLUMES MOUNTED FOR THE HOST (OPTIONALLY SPECIFIED BY   @Y30LB02
.*     THE HOST ID) TO BE DEMOUNTED.  IF THE FLAGS FIELD IS    @Y30LB02
.*     SPECIFIED, THEN THE PURGE IS FOR THE OTHER PROCESSOR    @Y30LB02
.*     OF THE MP PAIR.                                         @Y30LB02
.*                                                             @Y30LB02
.*     THE ASSIGN PRIMARY HOST REQUREST IS ISSUED WHEN THE     @Y30LB02
.*     CALLER WISHES TO ESTABLISH THE HOST TO RECEIVE UN-      @Y30LB02
.*     TAGGED MESSAGES; THAT IS, MESSAGES FROM THE SUBSYSTEM   @Y30LB02
.*     NOT ASSOCIATED WITH A PARTICULAR ORDER OR REQUEST.      @Y30LB02
.*                                                             @Y30LB02
.*     THE INITIALIZE REQUEST IS ISSUED WHEN THE CALLER        @Y30LB02
.*     WISHES TO ESTABLISH COMMUNICATION WITH THE MSC, OR TO   @Y30LB02
.*     INITIALIZE BOTH CPUS OF A TIGHTLY COUPLED MP PAIR.      @Y30LB02
.*     (IF THE FLAGS FIELD IS SPECIFIED, THEN, INITIALIZE      @Y30LB02
.*     BOTH CPUS OF A TIGHTLY COUPLED MP ENVIRONMENT).         @Y30LB02
.*                                                             @Y30LB02
.*     THE HOST READY REQUEST IS ISSUED WHEN THE CALLER        @Y30LB02
.*     WANTS TO INDICATE TO THE MSC THAT THE HOST IS READY     @Y30LB02
.*     TO ACCEPT ATTENTION INTERRUPTS.                         @Y30LB02
.*                                                             @Y30LB02
.*   MACRO SYNTAX                                              @Y30LB02
.*                                                             @Y30LB02
.*   LIST FORM                                                 @Y30LB02
.*                                                             @Y30LB02
.* VERB    REQUIRED PARMS        OPTIONAL PARMS                @Y30LB02
.*                                                             @Y30LB02
.*ICBPAIR  MF=L - (BAL)          MF=(L,MAP) - BAL              @Y30LB02
.*         MF(L,NAME/(R))-PLS    MF(L,NAME/(R),ATTR)-PLS       @Y30LB02
.*         TYPE=PURG/APH/INITL/RDY                             @Y30LB02
.*                                                             @Y30LB02
.*   STANDARD FORM                                             @Y30LB02
.*                                                             @Y30LB02
.* VERB    REQUIRED PARMS            OPTIONAL PARMS            @Y30LB02
.*                                                             @Y30LB02
.*ICBPAIR  TYPE=PURG/APH/INITL/RDY  FLAGS=ADDR/(R)             @Y30LB02
.*                                  HOSTID=ADDR/(R)            @Y30LB02
.*                                                             @Y30LB02
.* EXECUTE FORM                                                @Y30LB02
.*                                                             @Y30LB02
.* VERB    REQUIRED PARMS        OPTIONAL PARMS                @Y30LB02
.*                                                             @Y30LB02
.*ICBPAIR  MF(E,NAME/(R))       MF(E,NAME/(R),COMPLETE)-PLS    @Y30LB02
.*      TYPE=PURG/APH/INITL/RDY FLAGS=ADDR/(R)                 @Y30LB02
.*                              HOSTID=ADDR/(R)                @Y30LB02
.*                                                             @Y30LB02
.*   KEYWORD PARAMETERS:                                       @Y30LB02
.*                                                             @Y30LB02
.*                                                             @Y30LB02
.*   MF  -  MACRO FORMAT: THIS PARAMETER DESCRIBES THE         @Y30LB02
.*          MACRO FORMAT AND MAY GIVE THE ADDRESS OR           @Y30LB02
.*          ADDRESS IN A REGISTER WHERE THE REQUEST BLOCK      @Y30LB02
.*          IS STORED.                                         @Y30LB02
.*                                                             @Y30LB02
.*          L - LIST FORM: THE EXPANSION OF THE L-FORM         @Y30LB02
.*              MACRO WILL RESULT IN A REQUEST BLOCK WITH      @Y30LB02
.*              THE ONLY NON-ZERO FIELDS BEING THE OPCODE      @Y30LB02
.*              AND LENGTH FIELDS.                             @Y30LB02
.*                                                             @Y30LB02
.*          (1) 'MAP' - IF MAP IS SPECIFIED WITH THE           @Y30LB02
.*              ASSEMBLER MACRO CALL A DSECT EQUIVALENT TO     @Y30LB02
.*              A MAPPING MACRO IS PRODUCED.                   @Y30LB02
.*                                                             @Y30LB02
.*          (2) NAME - THE MACRO INVOKER MUST SPECIFY A        @Y30LB02
.*              NAME FOR HIS STRUCTURE WHEN INVOKING THE       @Y30LB02
.*              PLS LIST FORM.                                 @Y30LB02
.*                                                             @Y30LB02
.*          (3) ATTRIBUTE - THE MACRO WILL PLACE ANY PLS       @Y30LB02
.*              ATTRIBUTE SPECIFIED IN THE MACRO INVOCATION    @Y30LB02
.*              IN AN UNINITIALIZED REQUEST BLOCK.  ATTRI-     @Y30LB02
.*              BUTE EXAMPLE:                                  @Y30LB02
.*                                                             @Y30LB02
.*              CHAR, FIXED, STATIC LOCAL, NONLOCAL,           @Y30LB02
.*              BASED(*), ETC.                                 @Y30LB02
.*                                                             @Y30LB02
.*       NULL - STANDARD FORM: THE EXPANSION OF THIS FORM      @Y30LB02
.*              CONSISTS OF A REQUEST BLOCK, A LINKAGE         @Y30LB02
.*              INSTRUCTION, AND, POSSIBLY, PARAMETER          @Y30LB02
.*              BINDING INSTRUCTIONS.                          @Y30LB02
.*                                                             @Y30LB02
.*          E - EXECUTABLE FORM: THE EXPANSION OF THIS FORM    @Y30LB02
.*              CONSISTS OF A LINKAGE INSTRUCTION AND          @Y30LB02
.*              POSSIBLY, PARAMETER BINDING INSTRUCTIONS.      @Y30LB02
.*                                                             @Y30LB02
.*              SUB-PARAMETERS                                 @Y30LB02
.*                                                             @Y30LB02
.*              (1)  AN E MUST BE SPECIFIED IN THE FIRST       @Y30LB02
.*                   SUB-PARAMETER POSITION.  THIS INDICATES   @Y30LB02
.*                   THAT THE MACRO IS IN EXECUTABLE FORM.     @Y30LB02
.*                                                             @Y30LB02
.*              (2)  A NAME OR A REGISTER MUST BE SPECIFIED    @Y30LB02
.*                   IN THE SECOND SUB-PARAMETER.              @Y30LB02
.*                                                             @Y30LB02
.*              (3)  'COMPLETE' - COMPLETE WILL CAUSE THE      @Y30LB02
.*                   MACRO TO ZERO OUT THE REQUEST BLOCK.      @Y30LB02
.*                   AFTER ZEROING THE REQUEST BLOCK THE       @Y30LB02
.*                   FUNCTION OPCODE AND LENGTH ARE PLACED     @Y30LB02
.*                   IN THE REQUEST BLOCK.                     @Y30LB02
.*                                                             @Y30LB02
.*   TYPE - INDICATES WHETHER THE REQUEST IS FOR PURGE         @Y30LB02
.*          (PURG), ASSIGN PRIMARY HOST(APH), INITIALIZE       @Y30LB02
.*          (INTL) OR HOST READY(RDY) COMMAND. THE OPCODE      @Y30LB02
.*          FIELD OF THE REQUEST BLOCK IS FILLED IN BY         @Y30LB02
.*          THE MACRO.  THE FOLLOWING TABLE GIVES THE          @Y30LB02
.*          OPCODES FOR EACH REQUEST.                          @Y30LB02
.*                                                             @Y30LB02
.*               REQUEST               | OPCODE                @Y30LB02
.*               -----------------------------------           @Y30LB02
.*               PURGE                 | HEX'14'               @Y30LB02
.*               ASSIGN PRIMARY HOST   | HEX'12'               @Y30LB02
.*               INITIALIZE            | HEX'10'               @Y30LB02
.*               HOST READY            | HEX'20'               @Y30LB02
.*                                                             @Y30LB02
.*   HOSTID-OPTIONALLY INDICATES THE HOST (OTHER THAN THE      @Y30LB02
.*          ISSUING HOST) FOR WHICH THE REQUEST IS BEING       @Y30LB02
.*          ISSUED.  SPECIFIED FOR PURGE REQUESTS ONLY.        @Y30LB02
.*                                                             @Y30LB02
.*   FLAGS -THE FIELD WHICH INDICATES THE FUNCTION(S) TO BE    @Y30LB02
.*          PERFORMED.  THIS PARAMETER IS SPECIFIED ONLY IF    @Y30LB02
.*          TYPE IS SPECIFIED AS INITL OR PURG.  THE FORMAT    @Y30LB02
.*          OF THE FIELD IS SHOWN BELOW.                       @Y30LB02
.*                                                             @Y30LB02
.*   FLAGS:  2 BYTES                                           @Y30LB02
.*    _________________________________                        @Y30LB02
.*    | | |0|0|0|0|0|0|0|0|0|0|0|0|0|0|                        @Y30LB02
.*    _________________________________                        @Y30LB02
.*                                                             @Y30LB02
.*                                                             @Y30LB02
.* IF TYPE IS SPECIFIED AS INITL, THEN:                        @Y30LB02
.*                                                             @Y30LB02
.*   BIT 0-------  ALWAYS ZEROES                               @Y30LB02
.*                                                             @Y30LB02
.*   BIT 1--'1'B,  INITIALIZE BOTH CPU'S OF A TIGHTLY          @Y30LB02
.*                 COUPLED MP ENVIRONMENT                      @Y30LB02
.*          '0'B,  NO FUNCTION REQUESTED                       @Y30LB02
.*                                                             @Y30LB02
.*   BITS 2-15--   ALWAYS ZEROES.                              @Y30LB02
.*                                                             @Y30LB02
.* IF TYPE IS  SPECIFIED AS PURG, THEN:                        @Y30LB02
.*                                                             @Y30LB02
.*   BIT 0--'1'B,  PURGE FOR THE OTHER PROCESSOR OF THIS       @Y30LB02
.*                  MP PAIR.                                   @Y30LB02
.*          '0'B, PURGE IS FOR REQUESTING HOST.                @Y30LB02
.*                                                             @Y30LB02
.*   BITS 1-15--ALWAYS ZEROES.                                 @Y30LB02
.*                                                             @Y30LB02
.*                                                             @Y30LB02
.*01  EXIT-NORMAL = VALID INVOCATION                           @Y30LB02
.*                                                             @Y30LB02
.*02    CONDITION = RETURN CODE = 0.                           @Y30LB02
.*                                                             @Y30LB02
.*02    OUTPUT = IN-LINE PLS/BAL STATEMENTS THAT PERFORM       @Y30LB02
.*               THE REQUESTED FUNCTION.                       @Y30LB02
.*                                                             @Y30LB02
.*01  EXIT-ERROR = INVALID INVOCATION                          @Y30LB02
.*                                                             @Y30LB02
.*02    CONDITION = RETURN CODE = 12.                          @Y30LB02
.*                                                             @Y30LB02
.*02    OUTPUT = ERROR MESSAGE                                 @Y30LB02
.*                                                             @Y30LB02
.*01  EXTERNAL-REFERENCES = NONE                               @Y30LB02
.*                                                             @Y30LB02
.*01  TABLES = NONE                                            @Y30LB02
.*                                                             @Y30LB02
.*01 MESAGES = AS FOLLOWS:                                     @Y30LB02
.*           ICB600I: TYPE MUST BE SPECIFIED                   @Y30LB02
.*           ICB601I: TYPE IS INCORRECTLY SPECIFIED            @Y30LB02
.*           ICB602I: A NAME FOR THE REQUEST BLOCK MUST        @Y30LB02
.*                    BE SPECIFIED IN MF(2)                    @Y30LB02
.*           ICB612I: MF(2) MUST CONTAIN REQ BLK NAME          @Y30LB02
.*                    IF EXEC MACRO FORM REQUESTED             @Y30LB02
.*           ICB613I: MISSING REQ BLK NAME OR MORE             @Y30LB02
.*                    THAN 2 SUBPARAMETERS FOR MF              @Y30LB02
.*           ICB615I: INVALID MF PARAMETER SPECIFIED,          @Y30LB02
.*                    MUST BE L, E, OR NULL                    @Y30LB02
.*                                                             @Y30LB02
.*01  INNER-MACRO = NONE                                       @Y30LB02
.*                                                             @Y30LB02
.*01  SYSTEM-MACROS = IHBINNRA                                 @Y30LB02
.*                                                             @Y30LB02
.*01  CHANGE-ACTIVITY = S/D = X04AC02 AND Y30LB02              @Y30LB02
.*                                                             @Y30LB02
.**** END OF SPECIFICATIONS ***                                @Y30LB02
         MACRO                                                 @Y30LB02
&SYMBOL  ICBPAIR &MF=,&TYPE=,&HOSTID=,&FLAGS=                  @Y30LB02
         LCLB  &ESW                    EXIT-SWITCH             @Y30LB02
         LCLB  &BSW                    BRCH-SWITCH             @Y30LB02
         LCLB  &LSW                    LINK-SWITCH             @Y30LB02
         LCLC  &PARMAC                 SETC SYMBOL             @Y30LB02
         LCLC  &PURMAC                 SETC SYMBOL             @Y30LB02
&PARMAC  SETC  'P'.'&SYSNDX'                                   @Y30LB02
&PURMAC  SETC  'PU'.'&SYSNDX'                                  @Y30LB02
         AIF   ('&TYPE' EQ 'PURG' OR '&TYPE' EQ 'APH' OR               *
               '&TYPE' EQ 'INITL' OR '&TYPE' EQ 'RDY').TEST1   @Y30LB02
&ESW     SETB  1                       SET EXIT-SWITCH TO 1    @Y30LB02
         AIF   ('&TYPE' EQ '').NOT     IF TYPE NULL, BRCH      @Y30LB02
         MNOTE 12,'  ICB601I - TYPE IS INCORRECTLY SPECIFIED'  @Y30LB02
         AGO   .TEST1                  BRANCH                  @Y30LB02
.NOT     ANOP                                                  @Y30LB02
         MNOTE 12,'  ICB600I - TYPE MUST BE SPECIFIED '        @Y30LB02
.TEST1   AIF   (&ESW).EXIT             IF EXIT-SWITCH ON,BRCH  @Y30LB02
         AIF   ('&MF(1)' NE 'L').NLIST BRCH IF NOT LIST FORM   @Y30LB02
*  MACMEAN  PURGE/ASSIGN/INITIALIZE/READY MACRO                @Y30LB02
*    INITIALIZED/UNINITIALIZED LIST FORM                       @Y30LB02
*  VS1-4/VS2-3 VERSION--06/09/74   LEVEL 00                    @Y30LB02
         AIF   ('&TYPE' EQ 'PURG').LPURG BRCH IF PURG REQUEST  @Y30LB02
         AIF   ('&MF(2)' EQ 'MAP').LISTDS   DESECT REQUESTED   @Y30LB02
&SYMBOL  DS    0F                                              @Y30LB02
AIRLEN   DC    F'8'                    REQUEST BLOCK LENGTH    @Y30LB02
         AIF   ('&TYPE' EQ 'APH').LAPH BRCH IF APH REQUEST     @Y30LB02
         AIF   ('&TYPE' EQ 'INITL').LINITL BRCH IF INITL REQ.  @Y30LB02
AIROP    DC    XL1'20'                 RDY OPCODE              @Y30LB02
         AGO   .ZEROES                 BRANCH                  @Y30LB02
.LAPH    ANOP                                                  @Y30LB02
AIROP    DC    XL1'12'                 APH OPCODE              @Y30LB02
         AGO   .ZEROES                 BRANCH                  @Y30LB02
.LINITL  ANOP                                                  @Y30LB02
AIROP    DC    XL1'10'                 INITL OPCODE            @Y30LB02
.ZEROES  ANOP                                                  @Y30LB02
AIRRES0  DC    XL1'00'                 ZERO RESERVED FIELD     @Y30LB02
AIRFLAG  DC    XL2'0000'               ZERO FLAGS FIELD        @Y30LB02
         AGO   .EXIT                   BRANCH                  @Y30LB02
.*                                                             @Y30LB02
.LISTDS  ANOP                                                  @Y30LB02
ICBPAIR  DSECT                                                 @Y30LB02
AIRLEN   DS    F                       REQUEST BLK 8 BYTES     @Y30LB02
         AIF   ('&TYPE' EQ 'APH').LAPH1 BRCH IF APH REQUEST    @Y30LB02
         AIF   ('&TYPE' EQ 'INITL').LINITL1 BRCH IF INITL REQ. @Y30LB02
AIROP    DS    XL1                     RDY OPCODE 20 HEX       @Y30LB02
         AGO   .ZEROE1                 BRANCH                  @Y30LB02
.LAPH1   ANOP                                                  @Y30LB02
AIROP    DS    XL1                     APH OPCODE 12 HEX       @Y30LB02
         AGO   .ZEROE1                 BRANCH                  @Y30LB02
.LINITL1 ANOP                                                  @Y30LB02
AIROP    DS    XL1                     INITL OPCODE 10 HEX     @Y30LB02
.ZEROE1  ANOP                                                  @Y30LB02
AIRRES0  DS    XL1                     ZERO RESERVED FIELD     @Y30LB02
AIRFLAG  DS    XL2                     ZERO FLAGS FIELD        @Y30LB02
         AGO   .EXIT                   BRANCH                  @Y30LB02
.*                                                             @Y30LB02
.LPURG   ANOP                                                  @Y30LB02
         AIF   ('&MF(2)' EQ 'MAP').LPURGDS  PURGE DSECT        @Y30LB02
&SYMBOL  DS    0F                                              @Y30LB02
PURGLEN  DC    F'13'                   PURGE BLOCK LENGTH      @Y30LB02
PURGOP   DC    XL1'14'                 PURG OPCODE             @Y30LB02
PURGRES0 DC    XL1'00'                 ZERO RESERVED FIELD     @Y30LB02
PURGFLG  DC    XL2'0000'               ZERO FLAGS FIELD        @Y30LB02
PURGHOST DC    XL5'0000000000'         ZERO HOSTID FIELD       @Y30LB02
         AGO   .EXIT                   BRCH TO EXIT            @Y30LB02
.*                                                             @Y30LB02
.LPURGDS ANOP                                                  @Y30LB02
ICBPAIR  DSECT                                                 @Y30LB02
PURGLEN  DS    F                       PURGE BLK 13 BYTES      @Y30LB02
PURGOP   DS    XL1                     PURG OPCODE 14 HEX      @Y30LB02
PURGRES0 DS    XL1                     ZERO RESERVED FIELD     @Y30LB02
PURGFLG  DS    XL2                     FLAGS FIELD             @Y30LB02
PURGHOST DS    CL5                     HOSTID FIELD            @Y30LB02
         AGO   .EXIT                   BRCH TO EXIT            @Y30LB02
.*                                                             @Y30LB02
.NLIST   AIF   ('&MF(1)' NE '').EXCK   IF NOT STD FORM,BRCH    @Y30LB02
*  MACMEAN  PURGE/ASSIGN/INITIALIZE/READY MACRO                @Y30LB02
*              STANDARD FORM                                   @Y30LB02
*  VS1-4/VS2-3 VERSION--06/09/74   LEVEL 00                    @Y30LB02
         CNOP  0,4                                             @Y30LB02
         AIF   ('&TYPE' EQ 'PURG').SPURG BRCH IF PURG REQUEST  @Y30LB02
&SYMBOL  BAL   1,&PARMAC               BRCH AROUND BLOCK       @Y30LB02
AIRLEN   DC    A(&PARMAC-*)            REQUEST BLOCK LENGTH    @Y30LB02
         AIF   ('&TYPE' EQ 'APH').SAPH BRCH IF APH REQUEST     @Y30LB02
         AIF   ('&TYPE' EQ 'INITL').SINITL BRCH IF INITL REQ.  @Y30LB02
AIROP    DC    XL1'20'                 RDY OPCODE              @Y30LB02
         AGO   .REST                   BRCH TO REST OF DC'S    @Y30LB02
.SAPH    ANOP                                                  @Y30LB02
AIROP    DC    XL1'12'                 APH OPCODE              @Y30LB02
         AGO   .REST                   BRCH TO REST OF DC'S    @Y30LB02
.SINITL  ANOP                                                  @Y30LB02
AIROP    DC    XL1'10'                 INITL OPCODE            @Y30LB02
.REST    ANOP                                                  @Y30LB02
AIRRES0  DC    XL1'00'                 ZERO RESERVED FIELD     @Y30LB02
AIRFLAG  DC    XL2'0000'               ZERO FLAGS FIELD        @Y30LB02
&PARMAC  EQU   *                                               @Y30LB02
         AGO   .CONT0                  BRCH IF NOT PURGE       @Y30LB02
.SPURG   ANOP                                                  @Y30LB02
&SYMBOL  BAL   1,&PURMAC               BRCH AROUND BLOCK       @Y30LB02
PURGLEN  DC    A(&PARMAC-*)            REQUEST BLOCK LENGTH    @Y30LB02
PURGOP   DC    XL1'14'                 PURG OPCODE             @Y30LB02
PURGRES0 DC    XL1'00'                 ZERO RESERVED FIELD     @Y30LB02
PURGFLG  DC    XL2'0000'               ZERO FLAGS FIELD        @Y30LB02
PURGHOST DC    XL5'0000000000'         ZERO HOSTID FIELD       @Y30LB02
&PARMAC  EQU   *                                               @Y30LB02
&PURMAC  DS    0F                                              @Y30LB02
.CONT0   ANOP                                                  @Y30LB02
&BSW     SETB  1                       SET BRCH-SWITCH TO 1    @Y30LB02
         AGO   .TEST2                  BRANCH                  @Y30LB02
.EXCK    AIF   ('&MF(1)' EQ 'E').EXEC  IF EXECUTABLE FORM,BRCH @Y30LB02
&ESW     SETB  1                       SET EXIT-SWITCH TO 1    @Y30LB02
         MNOTE 12,'  ICB615I - INVALID MF PARAMETER '          @Y30LB02
         MNOTE 12,'  SPECIFIED, MUST BE, L, E, OR NULL'        @Y30LB02
         AGO   .TEST2                  BRANCH                  @Y30LB02
.EXEC    AIF   (N'&MF EQ 2).CONT1      IF 2 SUBPARAMETERS,BRH  @Y30LB02
&ESW     SETB  1                       SET EXIT-SWITCH TO 1    @Y30LB02
         MNOTE 12,'  ICB613I - MISSING REQ BLK NAME OR MORE '
         MNOTE 12,'  THAN 2 SUBPARAMETERS FOR MF '
         AGO   .TEST2                  BRANCH                  @Y30LB02
.CONT1   ANOP                                                  @Y30LB02
*  MACMEAN  PURGE/ASSIGN/INITIALIZE/READY MACRO                @Y30LB02
*              EXECUTE FORM                                    @Y30LB02
*  VS1-4/VS2-3 VERSION--06/09/74   LEVEL 00                    @Y30LB02
&SYMBOL  IHBINNRA &MF(2)               LOAD THE ADDR INTO R1   @Y30LB02
.*                                     BY USING IHBINNRA MAC   @Y30LB02
         AIF   ('&TYPE' EQ 'PURG').CONT2 BRCH IF PURGE         @Y30LB02
         LA    15,8                    PUT LENGTH(8) INTO R15  @Y30LB02
         AGO   .CONT3                                          @Y30LB02
.CONT2   ANOP                                                  @Y30LB02
         LA    15,13                   PUT LENGTH(13) INTO R15 @Y30LB02
.CONT3   ANOP                                                  @Y30LB02
         ST    15,0(1)                 R15 INTO LENGTH FIELD   @Y30LB02
.TEST2   AIF   (&ESW).EXIT             BRCH IF EXIT-SWITCH ON  @Y30LB02
         AIF   (&BSW).TYPECK           BRCH IF BRCH-SWITCH ON  @Y30LB02
         AIF   ('&TYPE' EQ 'PURG').EPURG BRCH IF PURG REQUEST  @Y30LB02
         AIF   ('&TYPE' EQ 'APH').EAPH BRCH IF APH REQUEST     @Y30LB02
         AIF   ('&TYPE' EQ 'INITL').EINITL BRCH IF INITL REQ.  @Y30LB02
         MVI   4(1),X'20'              PUT RDY OPCODE IN BLK   @Y30LB02
         AGO   .TYPECK                 BRANCH                  @Y30LB02
.EPURG   ANOP                                                  @Y30LB02
         MVI   4(1),X'14'              PUT PURG OPCODE IN BLK  @Y30LB02
         AGO   .TYPECK                 BRANCH                  @Y30LB02
.EAPH    ANOP                                                  @Y30LB02
         MVI   4(1),X'12'              PUT APH OPCODE IN BLK   @Y30LB02
         AGO   .TYPECK                 BRANCH                  @Y30LB02
.EINITL  ANOP                                                  @Y30LB02
         MVI   4(1),X'10'              PUT INITL OPCODE IN BLK @Y30LB02
.*      THE FOLLOWING CODE CHECKS FOR PURG BECAUSE HOSTID      @Y30LB02
.*      IS A VALID PARAMETER FOR THAT REQUEST ONLY.            @Y30LB02
.*      IF PURG IS NOT SPECIFIED THE SECTION OF CODE(AT TEST3) @Y30LB02
.*      THAT CHECKS FOR HOSTID IS BY-PASSED.                   @Y30LB02
.TYPECK  AIF   ('&TYPE' EQ 'PURG').CKFLG                       @Y30LB02
         AIF   ('&TYPE' NE 'INITL').SETLSW IF NOT INITL        @Y30LB02
.*                                     REQUEST,BRANCH          @Y30LB02
.*      THIS SECTION OF CODE IS FOR INITL REQUESTS.            @Y30LB02
.*      IT CHECKS FOR THE FLAGS PARAMETER.                     @Y30LB02
.CKFLG   AIF   ('&FLAGS' EQ '').SETLSW BRCH IF FLAGS ARE NULL  @Y30LB02
         AIF   ('&FLAGS'(1,1) EQ '(').RFLAGS BRCH IF IN REG.   @Y30LB02
         MVC   6(2,1),&FLAGS           MOVE FLAGS INFO INTO    @Y30LB02
*                                      FLAGS FIELD             @Y30LB02
         AIF   ('&TYPE' EQ 'PURG').TEST3 IF PURG-BRCH          @Y30LB02
         AIF   ('&TYPE' EQ 'PURG').TEST3 IF PURG-BRCH          @Y30LB02
         AGO   .SETLSW                 BRCH TO SET LSW         @Y30LB02
.RFLAGS  ANOP                                                  @Y30LB02
         MVC   6(2,1),0(&FLAGS(1))     MOVE FLAGS INFO INTO    @Y30LB02
*                                      FLAGS FIELD             @Y30LB02
         AIF   ('&TYPE' EQ 'PURG').TEST3 IF PURG-BRCH          @Y30LB02
         AIF   ('&TYPE' EQ 'PURG').TEST3 IF PURG-BRCH          @Y30LB02
.SETLSW  ANOP                                                  @Y30LB02
         AIF   ('&TYPE' EQ 'PURG').TEST3 IF PURG-BRCH          @Y30LB02
         AIF   ('&TYPE' EQ 'PURG').TEST3 IF PURG-BRCH          @Y30LB02
&LSW     SETB  1                       SET LINK SWITCH TO 1    @Y30LB02
.TEST3   AIF   (&LSW).LINK             BRCH IF LINK-SWITCH ON  @Y30LB02
         AIF   ('&HOSTID' NE '').TEST4 BRCH IF NOT NULL        @Y30LB02
&LSW     SETB  1                       SET LINK-SWITCH TO 1    @Y30LB02
.TEST4   AIF   (&ESW).EXIT             BRCH IF EXIT-SWITCH ON  @Y30LB02
         AIF   (&LSW).LINK             BRCH IF LINK-SWITCH ON  @Y30LB02
         AIF   ('&HOSTID'(1,1) EQ '(').RHOSTID BRCH IF IN REG  @Y30LB02
         MVC   8(5,1),&HOSTID          MV HOSTID TO HOSTID FLD @Y30LB02
         AGO   .LINK                   BRANCH                  @Y30LB02
.RHOSTID ANOP                                                  @Y30LB02
         MVC   8(5,1),0(&HOSTID(1))    MV HOSTID TO HOSTID FLD @Y30LB02
.LINK    ANOP                                                  @Y30LB02
         SVC   126                     ISSUE SVC INSTRUCITON   @Y30LB02
.EXIT    MEND                          MACRO ENDS              @Y30LB02
**/
* ICBPAIR: MACRO KEYS(MF,TYPE,HOSTID,FLAGS);               /*@Y30LB02*/
*/*                                                          @Y30LB02*/
*/*                                                          @Y30LB02*/
*/* EXTERNAL DECLARES                                        @Y30LB02*/
*   DCL  AIRTEST FIXED EXT;            /*USED IN TESTS TO    @Y30LB02*/
*   DCL PURGTEST FIXED EXT;            /*SEE IF STD FORMS    @Y30LB02*/
*                                      /*HAVE ALREADY BEEN   @Y30LB02*/
*                                      /*INVOKED             @Y30LB02*/
*   DCL PAIRTSTR FIXED EXT;            /*USED AS A TEST TO   @Y30LB02*/
*                                      /*SEE IF R1 ALREADY   @Y30LB02*/
*                                      /*DECLARED            @Y30LB02*/
*/* INTERNAL DECLARES                                        @Y30LB02*/
*   DCL RETCODE FIXED;                 /*RETURN CODE         @Y30LB02*/
*   DCL POPCODE CHAR;                  /*PURG OPCODE         @Y30LB02*/
*   DCL AOPCODE CHAR;                  /*APH OPCODE          @Y30LB02*/
*   DCL IOPCODE CHAR;                  /*INITL OPCODE        @Y30LB02*/
*   DCL ROPCODE CHAR;                  /*RDY OPCODE          @Y30LB02*/
*   DCL LENGTH CHAR;                   /*LENGTH OF LIST      @Y30LB02*/
*   DCL PLENGTH CHAR;                  /*LEN OF PURG LIST    @Y30LB02*/
*   DCL ESW FIXED;                     /*EXIT SWITCH         @Y30LB02*/
*   DCL BSW FIXED;                     /*BRANCH SWITCH       @Y30LB02*/
*   DCL LSW FIXED;                     /*LINK SWITCH         @Y30LB02*/
*   POPCODE='14';                      /*PURG OPCODE         @Y30LB02*/
*   AOPCODE='12';                      /*APH OPCODE          @Y30LB02*/
*   IOPCODE='10';                      /*INITL OPCODE        @Y30LB02*/
*   ROPCODE='20';                      /*RDY OPCODE          @Y30LB02*/
*   LENGTH='08';                       /*DEFINE LENGTH       @Y30LB02*/
*   PLENGTH='0D';                      /*DEF PURGE LENGTH    @Y30LB02*/
*/* INITIALIZE SWITCHES TO ZERO                              @Y30LB02*/
*   ESW=0;                                                 /*@Y30LB02*/
*   BSW=0;                                                 /*@Y30LB02*/
*   LSW=0;                                                 /*@Y30LB02*/
*/* END OF DECLARES AND INITIALIZATION                       @Y30LB02*/
*   IF TYPE(1)='PURG' THEN             /*PURG REQUEST?       @Y30LB02*/
*        GO TO TEST1;                  /*YES, BRANCH         @Y30LB02*/
*   IF TYPE(1)='APH'  THEN             /*APH  REQUEST?       @Y30LB02*/
*        GO TO TEST1;                  /*YES, BRANCH         @Y30LB02*/
*   IF TYPE(1)='INITL' THEN            /*INITL REQUEST?      @Y30LB02*/
*        GO TO TEST1;                  /*YES, BRANCH         @Y30LB02*/
*   IF TYPE(1)='RDY' THEN              /*RDY  REQUEST?       @Y30LB02*/
*        GO TO TEST1;                  /*YES, BRANCH         @Y30LB02*/
*   ESW=1;                             /*TURN ON ESW         @Y30LB02*/
*   IF TYPE='' THEN                    /*IS TYPE NULL?       @Y30LB02*/
*        DO;                           /*YES,PRT ERROR MSG   @Y30LB02*/
*             ANS MSG('  ICB600I - TYPE'||
*                  ' MUST BE SPECIFIED') SKIP(5);          /*@Y30LB02*/
*        END;                                              /*@Y30LB02*/
*   ELSE                               /*PRINT ERROR MSG     @Y30LB02*/
*        DO;                                               /*@Y30LB02*/
*             ANS MSG('  ICB601I - TYPE'||
*                  ' IS INCORRECTLY SPECIFIED') SKIP(5);   /*@Y30LB02*/
*        END;                                              /*@Y30LB02*/
*   RETCODE=12;                                            /*@Y30LB02*/
*TEST1: IF ESW=1 THEN                  /*ESW ON?             @Y30LB02*/
*        GO TO EXIT;                   /*YES, GO TO EXIT     @Y30LB02*/
*   IF PAIRTSTR=0 THEN                 /*WAS R1 ALREADY      @Y30LB02*/
*                                      /*DECLARED?           @Y30LB02*/
*        DO;                           /*NO,PRT DCL FOR R1   @Y30LB02*/
*             ANS('DCL PAIRR1  REG(1) PTR; '||             /*@Y30LB02*/
*                  '/* WILL CONTAIN BLK ADDRESS @Y30LB02*/') SKIP(1);
*             PAIRTSTR=1;              /*TURN SWITCH ON      @Y30LB02*/
*        END;                                              /*@Y30LB02*/
*   IF MF(1)^='L' THEN                 /*IF NOT LIST FORM    @Y30LB02*/
*        GO TO NOTLIST;                /*BRANCH              @Y30LB02*/
*   IF MF(2)='' THEN                   /*WAS A NAME GIVEN?   @Y30LB02*/
*        DO;                           /*IF NOT, THEN        @Y30LB02*/
*             ESW=1;                   /*TURN ON ESW         @Y30LB02*/
*                                      /*AND,PRT ERROR MSG   @Y30LB02*/
*             ANS MSG('  ICB602I - A NAME FOR THE '||
*                  'REQUEST BLOCK MUST BE SPECIFIED '||
*                  'IN MF(2)')SKIP(5);                     /*@Y30LB02*/
*             RETCODE=12;                                  /*@Y30LB02*/
*        END;                                              /*@Y30LB02*/
*   IF ESW=1 THEN                      /*ESW ON?             @Y30LB02*/
*        GO TO EXIT;                   /*YES,BRANCH TO EXIT  @Y30LB02*/
*/*                                                          @Y30LB02*/
*   IF MF(3) ^= '' THEN
*        GO TO ATTRLST;                                    /*@Y30LB02*/
*/*********************************************************  @Y30LB02*/
*/* START TO PRINT OUT DECLARES FOR LIST FORM                @Y30LB02*/
*/*********************************************************  @Y30LB02*/
*/*                                                          @Y30LB02*/
*   ANS('/*******************************************'||
*       '************** @Y30LB02*/')SKIP;
*   ANS('/*MACMEAN  MSSC PURG/ASSIGN/INITL/READY MACRO'||
*       '              @Y30LB02*/')SKIP;
*   ANS('/*VS1-4/VS2-3 VERSION--06/09/74 LEVEL 00    '||
*       '               @Y30LB02*/')SKIP;
*   ANS('/*THIS IS THE INITIALIZED LIST FORM         '||
*       '               @Y30LB02*/')SKIP;
*   ANS('/*******************************************'||
*       '************** @Y30LB02*/')SKIP;
*   ANS('DCL 1   '||MF(2)||'  STATIC LOCAL,') SKIP(1);     /*@Y30LB02*/
*   IF TYPE(1)^='PURG' THEN             /*NOT A PURG REQ?    @Y30LB02*/
*        DO;                                               /*@Y30LB02*/
*             ANS('      2  AIRLL FIXED(31) INIT('||QUOTE('08')||
*                  'X), /*LENGTH @Y30LB02*/')  SKIP(1);
*             IF TYPE(1)='APH' THEN    /*APH REQUEST?        @Y30LB02*/
*                  DO;                 /*PUT IN APH  OPCODE  @Y30LB02*/
*                       ANS('      2  AIROP FIXED(8) INIT('
*                            ||QUOTE(AOPCODE)||
*                            'X), /*OPCODE @Y30LB02*/') SKIP(1);
*                  END;                                    /*@Y30LB02*/
*             ELSE
*                  IF TYPE(1)='INITL' THEN /*INITL REQUEST?  @Y30LB02*/
*                     DO;              /*PUT IN INITL  OPCD  @Y30LB02*/
*                       ANS('      2  AIROP FIXED(8) INIT('
*                            ||QUOTE(IOPCODE)||
*                            'X),/*OPCODE @Y30LB02*/') SKIP(1);
*                     END;                                 /*@Y30LB02*/
*                  ELSE
*                     DO;              /*PUT IN RDY OPCODE   @Y30LB02*/
*                       ANS('      2  AIROP FIXED(8) INIT('
*                            ||QUOTE(ROPCODE)||
*                            'X),/*OPCODE @Y30LB02*/') SKIP(1);
*                     END;                                 /*@Y30LB02*/
*             ANS ('      2  * CHAR(1) INIT('||
*                  QUOTE('00')||'X), /*ZEROES   @Y30LB02*/') SKIP(1);
*             ANS ('      2  AIRFLAG BIT(16) INIT('||
*                 QUOTE('0000000000000000')||
*                 'B),/*FLAGS/ZEROES @Y30LB02*/') SKIP(1);
*             ANS ('        3  AIRRESV BIT(1),'||
*                  '/*RESERVED BIT  @Y30LB02*/') SKIP(1);
*             ANS ('        3  AIRCPUS BIT(1),'||
*                  '/*INITIALIZE BOTH CPUS  @Y30LB02*/') SKIP(1);
*             ANS ('        3  *      BIT(14);'||          /*@Y30LB02*/
*                  '/*RESERVED BITS  @Y30LB02*/') SKIP(1);
*        END;                                              /*@Y30LB02*/
*   ELSE                               /*PURG REQUEST        @Y30LB02*/
*        DO;                           /*DCL PURGE LIST      @Y30LB02*/
*             ANS('      2  PURGLL FIXED(31) INIT('||QUOTE('0D')||
*                  'X), /*LENGTH @Y30LB02*/')  SKIP(1);
*             ANS('      2  PURGOP FIXED(8) INIT('||
*                  QUOTE(POPCODE)||'X), /*OPCODE @Y30LB02*/') SKIP(1);
*             ANS ('      2  * CHAR(1) INIT('||
*                  QUOTE('00')||'X), /*ZEROES   @Y30LB02*/')
*                  SKIP(1);                                /*@Y30LB02*/
*             ANS ('      2  PURGFLG BIT(16) INIT('||
*                  QUOTE('0000000000000000')||'B),'||
*                  '/*ZEROES   @Y30LB02*/') SKIP(1);
*             ANS ('        3  PURGMPP BIT(1),'||
*                  '/*PURGE OTHER PROCESSOR  @Y30LB02*/') SKIP(1);
*             ANS ('        3  *      BIT(15),'||
*                  '/*RESERVED BITS  @Y30LB02*/') SKIP(1);
*             ANS('      2  PURGHOST CHAR(5) INIT('||
*                  QUOTE('0000000000')||'X); /*HOSTID @Y30LB02*/')
*                  SKIP(1);                                /*@Y30LB02*/
*        END;                                              /*@Y30LB02*/
*   GO TO EXIT;                        /*BRANCH TO EXIT      @Y30LB02*/
*/*                                                          @Y30LB02*/
*/*********************************************************  @Y30LB02*/
*/* THAT IS ALL THAT IS DONE FOR LIST FORM                   @Y30LB02*/
*/*********************************************************  @Y30LB02*/
*/*                                                          @Y30LB02*/
*ATTRLST:
*   ANS('/*******************************************'||
*       '************* @Y30LB02*/')SKIP;
*   ANS('/*MACMEAN  MSSC PURG/ASSIGN/INITL/READY MACRO'||
*       '             @Y30LB02*/')SKIP;
*   ANS('/*VS1-4/VS2-3 VERSION--06/09/74 LEVEL 00    '||
*       '              @Y30LB02*/')SKIP;
*   ANS('/*THIS IS THE UNINITIALIZED LIST FORM       '||
*       '              @Y30LB02*/')SKIP;
*   ANS('/*******************************************'||
*       '************* @Y30LB02*/')SKIP;
*   ANS('DCL 1   '||MF(2)||' '||MF(3)||','||
*              '/*REQUEST BLOCK @Y30LB02*/') SKIP(1);
*   IF TYPE(1)^='PURG' THEN             /*NOT A PURG REQ?    @Y30LB02*/
*        DO;                                               /*@Y30LB02*/
*             ANS('      2  AIRLL FIXED(31) ,  '||
*                  ' /*LENGTH  = 8 BYTES @Y30LB02*/')  SKIP(1);
*             IF TYPE(1)='APH' THEN    /*APH REQUEST?        @Y30LB02*/
*                  DO;                 /*PUT IN APH  OPCODE  @Y30LB02*/
*                       ANS('      2  AIROP FIXED(8),'||
*                            ' /*OPCODE=12 HEX @Y30LB02*/') SKIP(1);
*                  END;                                    /*@Y30LB02*/
*             ELSE
*                  IF TYPE(1)='INITL' THEN /*INITL REQUEST?  @Y30LB02*/
*                     DO;              /*PUT IN INITL  OPCD  @Y30LB02*/
*                       ANS('      2  AIROP FIXED(8),'||
*                            '/*OPCODE=10 HEX @Y30LB02*/') SKIP(1);
*                     END;                                 /*@Y30LB02*/
*                  ELSE
*                     DO;              /*PUT IN RDY OPCODE   @Y30LB02*/
*                       ANS('      2  AIROP FIXED(8),'||
*                            '/*OPCODE=20 HEX @Y30LB02*/') SKIP(1);
*                     END;                                 /*@Y30LB02*/
*             ANS ('      2  * CHAR(1),/*ZEROES   @Y30LB02*/') SKIP(1);
*             ANS ('      2  AIRFLAG BIT(16),'||
*                 '/*FLAGS/ZEROES @Y30LB02*/') SKIP(1);
*             ANS ('        3  AIRRESV BIT(1),'||
*                  '/*RESERVED BIT  @Y30LB02*/') SKIP(1);
*             ANS ('        3  AIRCPUS BIT(1),'||
*                  '/*INITIALIZE BOTH CPUS  @Y30LB02*/') SKIP(1);
*             ANS ('        3  *      BIT(14);'||          /*@Y30LB02*/
*                  '/*RESERVED BITS  @Y30LB02*/') SKIP(1);
*        END;                                              /*@Y30LB02*/
*   ELSE                               /*PURG REQUEST        @Y30LB02*/
*        DO;                           /*DCL PURGE LIST      @Y30LB02*/
*             ANS('      2  PURGLL FIXED(31),  '||
*                  ' /*LENGTH=13 BYTES @Y30LB02*/')  SKIP(1);
*             ANS('      2  PURGOP FIXED(8),'||
*                  ' /*OPCODE=14 HEX @Y30LB02*/') SKIP(1);
*             ANS ('      2  * CHAR(1),'||
*                 '/*RESERVED/ZEROES @Y30LB02*/') SKIP(1);
*             ANS ('      2  PURGFLG BIT(16),'||
*                  '/*FLAGS FIELD   @Y30LB02*/') SKIP(1);
*             ANS ('        3  PURGMPP BIT(1),'||
*                  '/*PURGE OTHER PROCESSOR  @Y30LB02*/') SKIP(1);
*             ANS ('        3  *      BIT(15),'||
*                  '/*RESERVED BITS  @Y30LB02*/') SKIP(1);
*             ANS('      2  PURGHOST CHAR(5);'||
*                  ' /*HOSTID @Y30LB02*/') SKIP(1);
*        END;                                              /*@Y30LB02*/
*   GO TO EXIT;                        /*BRANCH TO EXIT      @Y30LB02*/
*NOTLIST:
*   IF MF(1)^='' THEN                  /*IF NOT STD FORM     @Y30LB02*/
*        GO TO EXCHECK;                /*BRANCH              @Y30LB02*/
*/*                                                          @Y30LB02*/
*/*********************************************************  @Y30LB02*/
*/* THIS PART OF THE MACRO IS FOR STD FORM (MF(1)='')        @Y30LB02*/
*/*********************************************************  @Y30LB02*/
*/*                                                          @Y30LB02*/
*   IF TYPE(1)='PURG' THEN             /*PURG REQUEST?       @Y30LB02*/
*        IF PURGTEST=1 THEN            /*IF STD FORM HAS     @Y30LB02*/
*                                      /*BEEN INVOKED ALRDY  @Y30LB02*/
*             DO;                      /*SET UP REG1 TO PT   @Y30LB02*/
*                                      /*TO PURG LIST        @Y30LB02*/
*   ANS('/*******************************************'||
*       '************* @Y30LB02*/')SKIP;
*   ANS('/*MACMEAN  MSSC PURGE MACRO                 '||
*       '              @Y30LB02*/')SKIP;
*   ANS('/*VS1-4/VS2-3 VERSION--06/09/74 LEVEL 00    '||
*       '              @Y30LB02*/')SKIP;
*   ANS('/*THIS IS THE OUTPUT FOR A SECONDARY        '||
*       '              @Y30LB02*/')SKIP;
*   ANS('/*INVOCATION OF THE STANDARD FORM MACRO     '||
*       '              @Y30LB02*/')SKIP;
*   ANS('/*******************************************'||
*       '************* @Y30LB02*/')SKIP;
*                  ANS ('RFY(PAIRR1)RSTD;/*RESTRICT '||
*                       'R1 @Y30LB02*/')SKIP;
*                  ANS ('PAIRR1=ADDR(PURGLL);'||           /*@Y30LB02*/
*                    '/*PAIRR1 SET TO ADDR OF PURG LIST @Y30LB02*/')
*                     SKIP(1);                             /*@Y30LB02*/
*                  GO TO TEST2;        /*BRANCH              @Y30LB02*/
*             END;                                         /*@Y30LB02*/
*   IF TYPE(1)^='PURG' THEN             /*NOT PURG REQUEST?  @Y30LB02*/
*        IF  AIRTEST=1 THEN            /*IF STD FORM HAS     @Y30LB02*/
*                                      /*BEEN INVOKED ALRDY  @Y30LB02*/
*             DO;                      /*SET UP REG1 TO PT   @Y30LB02*/
*                                      /*TO REQUEST BLOCK   @Y30LB02*/
*   ANS('/*******************************************'||
*       '************* @Y30LB02*/')SKIP;
*   ANS('/*MACMEAN  MSSC ASSIGN/INITIALIZE/READY MACRO'||
*       '              @Y30LB02*/')SKIP;
*   ANS('/*VS1-4/VS2-3 VERSION--06/09/74 LEVEL 00    '||
*       '              @Y30LB02*/')SKIP;
*   ANS('/*THIS IS THE OUTPUT FOR A SECONDARY        '||
*       '              @Y30LB02*/')SKIP;
*   ANS('/*INVOCATION OF THE STANDARD FORM MACRO     '||
*       '              @Y30LB02*/')SKIP;
*   ANS('/*******************************************'||
*       '************* @Y30LB02*/')SKIP;
*                  ANS ('RFY(PAIRR1)RSTD;/*RESTRICT '||
*                       'R1 @Y30LB02*/')SKIP;
*                  ANS ('PAIRR1=ADDR(AIRLL);'||            /*@Y30LB02*/
*                    '/*PAIRR1 SET TO ADDR OF AIR LIST @Y30LB02*/')
*                     SKIP(1);                             /*@Y30LB02*/
*                  GO TO TEST2;        /*BRANCH              @Y30LB02*/
*             END;                                         /*@Y30LB02*/
*/*                                                          @Y30LB02*/
*/*********************************************************  @Y30LB02*/
*/* OTHERWISE PRINT OUT THE DECLARE STATEMENTS FOR STD FORM  @Y30LB02*/
*/*********************************************************  @Y30LB02*/
*/*                                                          @Y30LB02*/
*   IF TYPE(1)^='PURG' THEN             /*NOT A PURG REQ?    @Y30LB02*/
*        DO;                                               /*@Y30LB02*/
*             ANS('/*******************************************'||
*                 '************* @Y30LB02*/')SKIP;
*             ANS('/*MACMEAN  MSSC ASSIGN/INITIALIZE/READY MACRO'||
*                 '             @Y30LB02*/')SKIP;
*             ANS('/*VS1-4/VS2-3 VERSION--06/09/74 LEVEL 00    '||
*                 '              @Y30LB02*/')SKIP;
*             ANS('/*THIS IS THE STANDARD FORM - ICBPAIR MACRO '||
*                 '              @Y30LB02*/')SKIP;
*             ANS('/*******************************************'||
*                 '************* @Y30LB02*/')SKIP;
*             ANS('DCL  1   AIRLIST  STATIC LOCAL,') SKIP(1);
*             ANS('      2  AIRLL FIXED(31) INIT('||QUOTE('08')||
*                  'X), /*LENGTH @Y30LB02*/')  SKIP(1);
*             IF TYPE(1)='APH' THEN    /*APH REQUEST?        @Y30LB02*/
*                  DO;                 /*PUT IN APH  OPCODE  @Y30LB02*/
*                       ANS('      2  AIROP FIXED(8) INIT('
*                            ||QUOTE(AOPCODE)||
*                            'X), /*OPCODE @Y30LB02*/') SKIP(1);
*                  END;                                    /*@Y30LB02*/
*             ELSE
*                  IF TYPE(1)='INITL' THEN /*INITL REQUEST?  @Y30LB02*/
*                     DO;              /*PUT IN INITL  OPCD  @Y30LB02*/
*                       ANS('      2  AIROP FIXED(8) INIT('
*                            ||QUOTE(IOPCODE)||
*                            'X),/*OPCODE @Y30LB02*/') SKIP(1);
*                     END;                                 /*@Y30LB02*/
*                  ELSE
*                     DO;              /*PUT IN RDY OPCODE   @Y30LB02*/
*                       ANS('      2  AIROP FIXED(8) INIT('
*                            ||QUOTE(ROPCODE)||
*                            'X),/*OPCODE @Y30LB02*/') SKIP(1);
*                     END;                                 /*@Y30LB02*/
*             ANS ('      2  * CHAR(1) INIT('||
*                  QUOTE('00')||'X), /*ZEROES   @Y30LB02*/') SKIP(1);
*             ANS ('      2  AIRFLAG BIT(16) INIT('||
*                 QUOTE('0000000000000000')||
*                 'B),/*FLAGS/ZEROES @Y30LB02*/') SKIP(1);
*             ANS ('        3  AIRRESV BIT(1),'||
*                  '/*RESERVED BIT  @Y30LB02*/') SKIP(1);
*             ANS ('        3  AIRCPUS BIT(1),'||
*                  '/*INITIALIZE BOTH CPUS  @Y30LB02*/') SKIP(1);
*             ANS ('        3  *      BIT(14);'||
*                  '/*RESERVED BITS  @Y30LB02*/') SKIP(1);
*             ANS ('RFY(PAIRR1)RSTD;/*RESTRICT '||
*                  'R1 @Y30LB02*/')SKIP;
*             ANS('PAIRR1=ADDR(AIRLL); '||                 /*@Y30LB02*/
*                '/*PAIRR1 SET TO ADDR OF BLK @Y30LB02*/') SKIP(1);
*             AIRTEST=1;               /*SET SO KNOW STD     @Y30LB02*/
*                                      /*HAS BEEN INVOKED    @Y30LB02*/
*        END;                                              /*@Y30LB02*/
*   ELSE                               /*PURG REQUEST        @Y30LB02*/
*        DO;                           /*DCL PURGE LIST      @Y30LB02*/
*             ANS('/*******************************************'||
*                 '************* @Y30LB02*/')SKIP;
*             ANS('/*MACMEAN  MSSC PURGE MACRO                 '||
*                 '              @Y30LB02*/')SKIP;
*             ANS('/*VS1-4/VS2-3 VERSION--06/09/74 LEVEL 00    '||
*                 '              @Y30LB02*/')SKIP;
*             ANS('/*THIS IS THE STANDARD FORM - ICBPAIR MACRO '||
*                 '              @Y30LB02*/')SKIP;
*             ANS('/*******************************************'||
*                 '************* @Y30LB02*/')SKIP;
*             ANS('DCL  1   PURGLIST  STATIC LOCAL,') SKIP;/*@Y30LB02*/
*             ANS('      2  PURGLL FIXED(31) INIT('||QUOTE('0D')||
*                  'X), /*LENGTH @Y30LB02*/')  SKIP(1);
*             ANS('      2  PURGOP FIXED(8) INIT('||
*                  QUOTE(POPCODE)||'X), /*OPCODE @Y30LB02*/') SKIP(1);
*             ANS ('      2  * CHAR(1) INIT('||
*                  QUOTE('00')||'X), /*ZEROES   @Y30LB02*/')
*                  SKIP(1);                                /*@Y30LB02*/
*             ANS ('      2  PURGFLG BIT(16) INIT('||
*                  QUOTE('0000000000000000')||'B),'||
*                  '/*ZEROES   @Y30LB02*/') SKIP(1);
*             ANS ('        3  PURGMPP BIT(1),'||
*                  '/*PURGE OTHER PROCESSOR  @Y30LB02*/') SKIP(1);
*             ANS ('        3  *      BIT(15),'||
*                  '/*RESERVED BITS  @Y30LB02*/') SKIP(1);
*             ANS('      2  PURGHOST CHAR(5) INIT('||
*                  QUOTE('0000000000')||'X); /*HOSTID @Y30LB02*/')
*                  SKIP(1);                                /*@Y30LB02*/
*             ANS ('RFY(PAIRR1)RSTD;/*RESTRICT'||
*                  ' R1 @Y30LB02*/')SKIP;
*             ANS('PAIRR1=ADDR(PURGLL); '||                /*@Y30LB02*/
*                 '/*PAIRR1 SET TO ADDR OF LIST @Y30LB02*/') SKIP(1);
*             PURGTEST=1;              /*SET SO KNOW STD     @Y30LB02*/
*                                      /*HAS BEEN INVOKED    @Y30LB02*/
*        END;                                              /*@Y30LB02*/
*/*                                                          @Y30LB02*/
*/*********************************************************  @Y30LB02*/
*/* END OF DCLS TO BE PRINTED OUT FOR REQUEST BLOCK          @Y30LB02*/
*/*********************************************************  @Y30LB02*/
*/*                                                          @Y30LB02*/
*   BSW=1;                             /*TURN BSW SWITCH     @Y30LB02*/
*   GO TO TEST2;                       /*BRANCH              @Y30LB02*/
*/*                                                          @Y30LB02*/
*/*********************************************************  @Y30LB02*/
*/* THE MACRO BRANCHES HERE IF EXECUTABLE FORM WAS REQUESTD  @Y30LB02*/
*/*********************************************************  @Y30LB02*/
*/*                                                          @Y30LB02*/
*EXCHECK: IF MF(1)='E' THEN            /*EXEC FORM SPECD?    @Y30LB02*/
*             GO TO EXFORM;            /*YES, BRANCH         @Y30LB02*/
*   ESW=1;                             /*TURN ON ESW         @Y30LB02*/
*   DO;                                /*PRINT ERROR MSG     @Y30LB02*/
*        ANS MSG('  ICB615I - INVALID MF PARAMETER SPECIFIED,'||
*             ' MUST BE L, E, OR NULL ') SKIP(1);          /*@Y30LB02*/
*   END;                                /*                   @Y30LB02*/
*   RETCODE=12;                        /*SET RETURN CODE     @Y30LB02*/
*   GO TO TEST2;                       /*BRANCH              @Y30LB02*/
*EXFORM: IF MF(2)='' THEN              /*ADDRESS GIVEN?      @Y30LB02*/
*             DO;                      /*NO,TURN ON ESW AND  @Y30LB02*/
*                  ESW=1;              /*PRINT ERROR MSG     @Y30LB02*/
*                  ANS MSG('  ICB612I - MF(2) MUST CONTAIN'||
*                       ' REQ BLK NAME IF EXEC MACRO '||
*                       'FORM REQUESTED')SKIP(5);          /*@Y30LB02*/
*                  RETCODE=12;         /*SET RETURN CODE     @Y30LB02*/
*                  GO TO TEST2;        /*BRANCH              @Y30LB02*/
*             END;                                         /*@Y30LB02*/
*   ANS('/*******************************************'||
*       '************* @Y30LB02*/')SKIP;
*   ANS('/*MACMEAN  PURGE/ASSIGN/INITIALIZE/READY    '||
*       'MACRO         @Y30LB02*/')SKIP;
*   ANS('/*VS1-4/VS2-3 VERSION-- 06/09/74 LEVEL 00   '||
*       '              @Y30LB02*/')SKIP;
*   ANS('/*THIS IS THE OUTPUT FOR THE EXECUTE FORM.  '||
*       '              @Y30LB02*/')SKIP;
*   ANS('/*THE LIST FORM OF THIS MACRO SHOULD BE     '||
*       '              @Y30LB02*/')SKIP;
*   ANS('/*INVOKED FIRST IN ORDER TO SET UP NECESSARY'||
*       '              @Y30LB02*/')SKIP;
*   ANS('/*DECLARES.  IF THE COMPLETE ARGUMENT IS    '||
*       '              @Y30LB02*/')SKIP;
*   ANS('/*SPECIFIED THE REQ BLOCK WILL BE ZEROED.   '||
*       '              @Y30LB02*/')SKIP;
*   ANS('/*******************************************'||
*       '************* @Y30LB02*/')SKIP;
*   ANS ('RFY(PAIRR1)RSTD;/*RESTRICT  R1 @Y30LB02*/')SKIP;
*   ANS('PAIRR1=ADDR('||MF(2)||
*        '); /*SET PAIRR1 TO REQ BLOCK @Y30LB02*/')  SKIP(1);
*   IF MF(3) = 'COMPLETE' THEN
*      DO;                                                 /*@Y30LB02*/
*        ANS(' '||MF(2)||'='||MF(2)||'&&'||MF(2)||';'||    /*@Y30LB02*/
*           '/*ZERO REQUEST BLOCK @Y30LB02*/')SKIP;
*      END;                                                /*@Y30LB02*/
*   IF TYPE(1)='PURG' THEN             /*SET LENGTH FLD=13   @Y30LB02*/
*        ANS('PURGLL='||QUOTE(PLENGTH)||'X; /*SET LENGTH '||
*            'FIELD @Y30LB02*/')SKIP(1);
*   ELSE                               /*SET LENGTH FLD=8    @Y30LB02*/
*        ANS('AIRLL='||QUOTE(LENGTH)||'X; /*SET LENGTH '||
*            'FIELD @Y30LB02*/')SKIP(1);
*TEST2: IF ESW=1 THEN                  /*IS ESW ON?          @Y30LB02*/
*        GO TO EXIT;                   /*YES, BRANCH         @Y30LB02*/
*   IF BSW=1 THEN                      /*IS BSW ON?          @Y30LB02*/
*        GO TO TYPECK;                 /*YES, BRANCH         @Y30LB02*/
*   IF TYPE(1)='PURG' THEN             /*PURG REQUEST?       @Y30LB02*/
*        DO;                           /*YES,PUT IN PURG     @Y30LB02*/
*                                      /*OPCODE              @Y30LB02*/
*             ANS('PURGOP='||QUOTE(POPCODE)||'X;'||
*                  '/*PURG  OPCODE @Y30LB02*/') SKIP(1);
*        END;                                              /*@Y30LB02*/
*   ELSE
*        IF TYPE(1)='APH' THEN         /*APH  REQUEST?       @Y30LB02*/
*             DO;                      /*YES,PUT IN APH      @Y30LB02*/
*                                      /*OPCODE              @Y30LB02*/
*                  ANS('AIROP='||QUOTE(AOPCODE)||'X;'||
*                       '/*APH  OPCODE @Y30LB02*/') SKIP(1);
*             END;                                         /*@Y30LB02*/
*        ELSE
*             IF TYPE(1)='INITL' THEN  /*INITL REQUEST?      @Y30LB02*/
*                  DO;                 /*YES,PUT IN INITL    @Y30LB02*/
*                                      /*OPCODE              @Y30LB02*/
*                       ANS('AIROP='||QUOTE(IOPCODE)||'X;'||
*                            '/*INITL OPCODE @Y30LB02*/') SKIP(1);
*                  END;                                    /*@Y30LB02*/
*             ELSE
*                  DO;                 /*PUT IN RDY OPCODE   @Y30LB02*/
*                       ANS('AIROP='||QUOTE(ROPCODE)||'X;'||
*                            '/*RDY OPCODE @Y30LB02*/') SKIP(1);
*                  END;                                    /*@Y30LB02*/
*TYPECK: IF TYPE(1)='PURG' THEN
*             GO TO TEST3;             /*BRCH IF PURG REQ.   @Y30LB02*/
*   IF TYPE(1)='INITL' THEN            /*INITL REQUEST?      @Y30LB02*/
*        DO;                           /*YES,CHECK FLAGS     @Y30LB02*/
*             IF FLAGS^='' THEN        /*IS FLAGS NULL?      @Y30LB02*/
*                  DO;                 /*NO,FILL IN FLAGS    @Y30LB02*/
*                                      /*FIELD               @Y30LB02*/
*                       ANS('AIRFLAG='||FLAGS||
*                            ';/*FILL IN FLAGS FIELD @Y30LB02*/')
*                            SKIP(1);                      /*@Y30LB02*/
*                  END;                                    /*@Y30LB02*/
*        END;                                              /*@Y30LB02*/
*   LSW=1;                             /*TURN ON LSW         @Y30LB02*/
*TEST3: IF LSW=1 THEN                  /*IS LSW ON?          @Y30LB02*/
*        GO TO LINK;                   /*YES, BRANCH         @Y30LB02*/
*             IF FLAGS^='' THEN        /*IS FLAGS NULL?      @Y30LB02*/
*                  DO;                 /*NO,FILL IN FLAGS    @Y30LB02*/
*                                      /*FIELD               @Y30LB02*/
*                       ANS('PURGFLG='||FLAGS||
*                            ';/*FILL IN FLAGS FIELD @Y30LB02*/')
*                            SKIP(1);                      /*@Y30LB02*/
*                  END;                                    /*@Y30LB02*/
*   IF HOSTID='' THEN                  /*HOSTID NULL?        @Y30LB02*/
*                  LSW=1;              /*TURN LSW ON         @Y30LB02*/
*   IF ESW=1 THEN                      /*ESW ON?             @Y30LB02*/
*        GO TO EXIT;                   /*YES, BRANCH         @Y30LB02*/
*   IF LSW=1 THEN                      /*LSW ON?             @Y30LB02*/
*        GO TO LINK;                   /*YES, BRANCH         @Y30LB02*/
*/* OTHERWISE PUT HOSTID IN HOSTID FIELD & INVOKE SVC INST   @Y30LB02*/
*   ANS ('PURGHOST='||HOSTID||'; /*FILL IN HOSTID FIELD @Y30LB02*/')
*        SKIP(1);                                          /*@Y30LB02*/
*LINK: ANS('SVC  (126); /*ISSUE SVC INST.  @Y30LB02*/') SKIP(1);
*      ANS ('RFY(PAIRR1)UNRSTD;/*UNRESTRICT'||
*           ' R1 @Y30LB02*/')SKIP;
*EXIT: RETURN CODE(RETCODE);                               /*@Y30LB02*/
*   %END;                                                  /*@Y30LB02*/
