         TITLE '*********** ICBTMSS0: VS2 MSS MISSING INTERRUPT HANDLER*
               R *******'
ICBTMSS0 CSECT ,                                                   0001
@MAINENT DS    0H                                                  0001
         USING *,@15                                               0001
         B     @PROLOG                                             0001
         DC    AL2(@EP00001-@MAINENT)
         DC    AL1(16)                                             0001
         DC    C'ICBTMSS0  77.167'                                 0001
ICBTMSS1 DS    0H                                                  0001
         USING *,@15                                               0001
         B     @PROLOG                                             0001
         DC    AL2(@EP00066-ICBTMSS1)
         ENTRY ICBTMSS1
         DROP  @15
@PROLOG  STM   @14,@12,12(@13)                                     0001
         BALR  @10,0                                               0001
@PSTART  DS    0H                                                  0001
         USING @PSTART,@10                                         0001
         AH    @15,4(,@15)                                         0001
         BR    @15                                                 0001
@EP00001 DS    0H                                                  0002
*                                                            @ZA20263*/
*                                                                  0063
*/*********************************************************  @G24LB61*/
*/*                                                          @G24LB61*/
*/*    PROCEDURE NAME - ICBTMSS0                             @G24LB61*/
*/*                                                          @G24LB61*/
*/*    FUNCTION - THIS MAIN PROCEDURE CONTAINS THE TWO       @G24LB61*/
*/*               ENTRY POINTS OF ICBTMSS0 AND CONTROLS THE  @G24LB61*/
*/*               INVOCATION OF SUBPROCEDURES TO PERFORM     @G24LB61*/
*/*               THE INDIVIDUAL FUNCTIONS.                  @G24LB61*/
*/*                                                          @G24LB61*/
*/*    INPUT - (1) MSS INTERRUPT TIME PERIOD COUNTER #1      @G24LB61*/
*/*                                                          @G24LB61*/
*/*    OUTPUT - NONE                                         @G24LB61*/
*/*                                                          @G24LB61*/
*/*********************************************************  @G24LB61*/
*                                                                  0063
*                                                                  0063
*   /*****************************************************************/
*   /*                                                               */
*   /* FIRST ENTRY POINT - ICBTMSS0 -                        @G24LB61*/
*   /* ENTERED ONCE PER INTERRUPT CHECKING TIME PERIOD TO    @G24LB61*/
*   /* ADJUST VARIABLES THAT CONTROL MSS MISSING INTERRUPT   @G24LB61*/
*   /* CHECKING AND HANDLING, AND TO REDRIVE I/O HAVING      @G24LB61*/
*   /* MISSING ATTENTION INTERRUPTS ASSOCIATED WITH 3330V'S. @G24LB61*/
*   /* UNCONDITIONALLY CALL THE ROUTINE THAT ADJUSTS THE     @G24LB61*/
*   /* COUNT/LIMIT VARIABLES USED FOR CONTROLLING THE        @G24LB61*/
*   /* FREQUENCY OF MSS MISSING INTERRUPT CHECKING.          @G24LB61*/
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0063
*   CALL FIXCNTS;                   /*                       @G24LB61*/
*                                                                  0063
         BAL   @14,FIXCNTS                                         0063
*   /*****************************************************************/
*   /*                                                               */
*   /* GO CHECK IF ANY I/O REQUESTS NEED TO BE REDRIVEN      @G24LB61*/
*   /* DUE TO MISSING ATTENTION INTERRUPTS.                  @G24LB61*/
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0064
*   CALL REDRIVIO;                  /*                       @G24LB61*/
         BAL   @14,REDRIVIO                                        0064
*   RETURN;                         /*                       @G24LB61*/
@EL00001 DS    0H                                                  0065
@EF00001 DS    0H                                                  0065
@ER00001 LM    @14,@12,12(@13)                                     0065
         BR    @14                                                 0065
*                                                                  0066
*   /*****************************************************************/
*   /*                                                               */
*   /* SECOND ENTRY POINT - ICBTMSS1 -                       @G24LB61*/
*   /* ENTERED FOR EACH ONLINE 3330V OR 3851 UCB FOUND BY    @G24LB61*/
*   /* THE SYSTEM MISSING INTERRUPT CHECKER/HANDLER DURING   @G24LB61*/
*   /* AN INTERRUPT CHECKING TIME PERIOD. THIS ENTRY ALLOWS  @G24LB61*/
*   /* MSS TO DETERMINE IF CHECKING SHOULD BE PERFORMED,     @G24LB61*/
*   /* AND IF AN I/O RESTART SHOULD BE DONE FOR A MISSING    @G24LB61*/
*   /* INTERRUPT. CHECKING FOR MISSING ATTENTION INTERRUPTS  @G24LB61*/
*   /* ALSO DONE IF THIS IS THE PROPER TIME PERIOD.          @G24LB61*/
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0066
*ICBTMSS1:                                                         0066
*   ENTRY;                          /*                       @G24LB61*/
*                                                                  0066
@EP00066 DS    0H                                                  0067
*   /*****************************************************************/
*   /*                                                               */
*   /* GO PROCESS ANY PENDING INTERRUPT FOR THIS MSS UCB.    @G24LB61*/
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0067
*   CALL MSSUCB;                    /*                       @G24LB61*/
         BAL   @14,MSSUCB                                          0067
*   RETURN;                         /*                       @G24LB61*/
         B     @EL00001                                            0068
*                                                                  0069
*/*********************************************************  @G24LB61*/
*/*                                                          @G24LB61*/
*/*    PROCEDURE NAME - FIXCNTS                              @G24LB61*/
*/*                                                          @G24LB61*/
*/*    FUNCTION - THIS PROCEDURE ADJUSTS COUNT/LIMIT         @G24LB61*/
*/*               VARIABLES USED TO CONTROL THE FREQUENCY    @G24LB61*/
*/*               OF MISSING INTERRUPT CHECKING FOR MSS      @G24LB61*/
*/*               DEVICES.                                   @G24LB61*/
*/*                                                          @G24LB61*/
*/*    INPUT - (1) MSS CHECKING-FREQUENCY LIMIT VALUE #1     @G24LB61*/
*/*            (2) MSS CHECKING-FREQUENCY LIMIT VALUE #2     @G24LB61*/
*/*            (3) MSS TIME PERIOD COUNTER #1                @G24LB61*/
*/*            (4) MSS TIME PERIOD COUNTER #2                @G24LB61*/
*/*                                                          @G24LB61*/
*/*    OUTPUT- (1) MSS TIME PERIOD COUNTER #1                @G24LB61*/
*/*            (2) MSS TIME PERIOD COUNTER #2                @G24LB61*/
*/*                                                          @G24LB61*/
*/*********************************************************  @G24LB61*/
*                                                                  0069
*FIXCNTS:                                                          0069
*   PROCEDURE OPTIONS(NOSAVE,NOSAVEAREA,RETREG);/*           @G24LB61*/
FIXCNTS  DS    0H                                                  0070
*   RESPECIFY                                                      0070
*     RETRNREG RESTRICTED;          /*                       @G24LB61*/
*   SAVE1=RETRNREG;                 /* SAVE RETURN ADDRESS   @G24LB61*/
*                                                                  0071
         LR    SAVE1,RETRNREG                                      0071
*   /*****************************************************************/
*   /*                                                               */
*   /* IF THIS IS THE FIRST CALL TO THIS ROUTINE, GO         @G24LB61*/
*   /* VALIDITY-CHECK THE INPUT TIME INTERVAL RATIO VALUES   @G24LB61*/
*   /* AND INITIALIZE COUNT/LIMIT VARIABLES.                 @G24LB61*/
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0072
*   IF LIMIT1=0 THEN                                               0072
         LH    @15,LIMIT1                                          0072
         LTR   @15,@15                                             0072
         BNZ   @RF00072                                            0072
*     CALL INITCNTS;                /*                       @G24LB61*/
*                                                                  0073
         BAL   @14,INITCNTS                                        0073
*   /*****************************************************************/
*   /*                                                               */
*   /* IF A TIME PERIOD COUNTER HAS REACHED ZERO, RESET      @G24LB61*/
*   /* IT TO ITS RESPECTIVE LIMIT VALUE                      @G24LB61*/
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0074
*   IF TPCNTR1=0 THEN                                              0074
@RF00072 LH    @15,TPCNTR1                                         0074
         LTR   @15,@15                                             0074
         BNZ   @RF00074                                            0074
*     TPCNTR1=LIMIT1;               /*                       @G24LB61*/
         LH    @15,LIMIT1                                          0075
         STH   @15,TPCNTR1                                         0075
*   IF TPCNTR2=0 THEN                                              0076
@RF00074 LH    @15,TPCNTR2                                         0076
         LTR   @15,@15                                             0076
         BNZ   @RF00076                                            0076
*     TPCNTR2=LIMIT2;               /*                       @G24LB61*/
*                                                                  0077
         LH    @15,LIMIT2                                          0077
         STH   @15,TPCNTR2                                         0077
*   /*****************************************************************/
*   /*                                                               */
*   /* DECREMENT THE TIME PERIOD COUNTERS BY ONE TO COUNT    @G24LB61*/
*   /* THE CURRENT TIME PERIOD.                              @G24LB61*/
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0078
*   TPCNTR1=TPCNTR1-1;              /*                       @G24LB61*/
@RF00076 LH    @15,TPCNTR1                                         0078
         BCTR  @15,0                                               0078
         STH   @15,TPCNTR1                                         0078
*   TPCNTR2=TPCNTR2-1;              /*                       @G24LB61*/
         LH    @15,TPCNTR2                                         0079
         BCTR  @15,0                                               0079
         STH   @15,TPCNTR2                                         0079
*   RETRNREG=SAVE1;                 /* RESTORE RETURN ADDR   @G24LB61*/
         LR    RETRNREG,SAVE1                                      0080
*   END FIXCNTS;                    /*                       @G24LB61*/
@EL00002 DS    0H                                                  0081
@EF00002 DS    0H                                                  0081
@ER00002 BR    @14                                                 0081
*                                                                  0082
*/*********************************************************  @G24LB61*/
*/*                                                          @G24LB61*/
*/*    PROCEDURE NAME - INITCNTS                             @G24LB61*/
*/*                                                          @G24LB61*/
*/*    FUNCTION- THIS PROCEDURE VALIDITY CHECKS THE INPUT    @G24LB61*/
*/*              RATIO VALUES WHICH INDICATE MSS MISSING     @G24LB61*/
*/*              INTERRUPT CHECKING FREQUENCY, AND ALSO      @G24LB61*/
*/*              INITIALIZES COUNT/LIMIT VARIABLES USED TO   @G24LB61*/
*/*              CONTROL THE FREQUENCY OF CHECKING.          @G24LB61*/
*/*                                                          @G24LB61*/
*/*    INPUT - (1) MSS RATIO VALUE #1                        @G24LB61*/
*/*            (2) MSS RATIO VALUE #2                        @G24LB61*/
*/*                                                          @G24LB61*/
*/*    OUTPUT- (1) MSS LIMIT VALUE #1                        @G24LB61*/
*/*            (2) MSS LIMIT VALUE #2                        @G24LB61*/
*/*                                                          @G24LB61*/
*/*********************************************************  @G24LB61*/
*                                                                  0082
*INITCNTS:                                                         0082
*   PROCEDURE OPTIONS(NOSAVE,NOSAVEAREA,RETREG);/*           @G24LB61*/
INITCNTS DS    0H                                                  0083
*   SAVE2=RETRNREG;                 /* SAVE RETURN ADDRESS   @G24LB61*/
*                                                                  0083
         LR    SAVE2,RETRNREG                                      0083
*   /*****************************************************************/
*   /*                                                               */
*   /* PERFORM VALIDITY CHECKING ON EACH OF THE INPUT RATIO  @G24LB61*/
*   /* VALUES TO INSURE THEY ARE IN THE RANGE X'F0F1' TO     @G24LB61*/
*   /* X'F9F9', AND CONVERT THE VALUES FROM EBCDIC TO BINARY @G24LB61*/
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0084
*   RATIOPTR=ADDR(MSSRVAL1);        /*                       @G24LB61*/
         LA    RATIOPTR,MSSRVAL1(,PARMPTR)                         0084
*   LIMITPTR=ADDR(LIMIT1);          /*                       @G24LB61*/
         LA    LIMITPTR,LIMIT1                                     0085
*   DO INDEX1=1 TO RATIOTOT;        /*                       @G24LB61*/
         LA    INDEX1,1                                            0086
@DL00086 DS    0H                                                  0087
*     DO INDEX2=1 TO LENGTH(RATIO) WHILE(RATIO(INDEX2)>='0'&RATIO( 0087
*           INDEX2)<='9');          /*                       @G24LB61*/
         LA    INDEX2,1                                            0087
@DL00087 LR    @15,RATIOPTR                                        0087
         ALR   @15,INDEX2                                          0087
         AL    @15,@CF01497                                        0087
         CLI   RATIO(@15),C'0'                                     0087
         BL    @DC00087                                            0087
         LR    @15,RATIOPTR                                        0087
         ALR   @15,INDEX2                                          0087
         AL    @15,@CF01497                                        0087
         CLI   RATIO(@15),C'9'                                     0087
         BH    @DC00087                                            0087
*       LIMIT=LIMIT*10+(RATIO(INDEX2)&RATIOMSK);/*           @G24LB61*/
         LH    @15,LIMIT(,LIMITPTR)                                0088
         MH    @15,@CH01483                                        0088
         LA    @05,15                                              0088
         ST    @15,@TF00001                                        0088
         LR    @15,RATIOPTR                                        0088
         AL    @15,@CF01497                                        0088
         SLR   @00,@00                                             0088
         IC    @00,RATIO(INDEX2,@15)                               0088
         NR    @05,@00                                             0088
         AL    @05,@TF00001                                        0088
         STH   @05,LIMIT(,LIMITPTR)                                0088
*     END;                          /*                       @G24LB61*/
*                                                                  0089
         AL    INDEX2,@CF00049                                     0089
         C     INDEX2,@CF00078                                     0089
         BNH   @DL00087                                            0089
@DC00087 DS    0H                                                  0090
*     /***************************************************************/
*     /*                                                             */
*     /* IF ALL THE BYTES OF THE RATIO VALUE WEREN'T VALID   @G24LB61*/
*     /* OR IF THE RATIO VALUE IS ZERO, ASSIGN THE DEFAULT   @G24LB61*/
*     /* TO BE USED IN ITS PLACE                             @G24LB61*/
*     /*                                                             */
*     /***************************************************************/
*                                                                  0090
*     IF INDEX2<=LENGTH(RATIO)|LIMIT=0 THEN                        0090
         C     INDEX2,@CF00078                                     0090
         BNH   @RT00090                                            0090
         LH    @15,LIMIT(,LIMITPTR)                                0090
         LTR   @15,@15                                             0090
         BNZ   @RF00090                                            0090
@RT00090 DS    0H                                                  0091
*       LIMIT=DFLTRVAL;             /*                       @G24LB61*/
*                                                                  0091
         MVC   LIMIT(2,LIMITPTR),@CH00132                          0091
*     /***************************************************************/
*     /*                                                             */
*     /* NOW POINT TO THE SECOND RATIO VALUE TO BE EXAMINED  @G24LB61*/
*     /* AND NEXT LIMIT VALUE TO BE COMPUTED.                @G24LB61*/
*     /*                                                             */
*     /***************************************************************/
*                                                                  0092
*     RATIOPTR=ADDR(MSSRVAL2);      /*                       @G24LB61*/
@RF00090 LA    RATIOPTR,MSSRVAL2(,PARMPTR)                         0092
*     LIMITPTR=ADDR(LIMIT2);        /*                       @G24LB61*/
         LA    LIMITPTR,LIMIT2                                     0093
*   END;                            /*                       @G24LB61*/
         AL    INDEX1,@CF00049                                     0094
         C     INDEX1,@CF00078                                     0094
         BNH   @DL00086                                            0094
*   RETRNREG=SAVE2;                 /* RESTORE RETURN ADDR   @G24LB61*/
         LR    RETRNREG,SAVE2                                      0095
*   END INITCNTS;                   /*                       @G24LB61*/
@EL00003 DS    0H                                                  0096
@EF00003 DS    0H                                                  0096
@ER00003 BR    @14                                                 0096
*                                                                  0097
*/*********************************************************  @G24LB61*/
*/*                                                          @G24LB61*/
*/*    PROCEDURE NAME - REDRIVIO                             @G24LB61*/
*/*                                                          @G24LB61*/
*/*    FUNCTION- THIS PROCEDURE SIMULATES CHANNEL-AVAILABLE  @G24LB61*/
*/*              INTERRUPTS TO ALL CHANNELS WHICH HAD AT     @G24LB61*/
*/*              LEAST ONE DEVICE WITH A MISSING ATTENTION   @G24LB61*/
*/*              INTERRUPT, THUS CAUSING THE I/O REQUESTS    @G24LB61*/
*/*              THAT WERE WAITING FOR ATTENTIONS TO BE      @G24LB61*/
*/*              REDRIVEN.                                   @G24LB61*/
*/*                                                          @G24LB61*/
*/*    INPUT - (1) CHANNEL MAP CONTAINING UCB ADDRESSES      @G24LB61*/
*/*                                                          @G24LB61*/
*/*    OUTPUT- (1) SIMULATED CHANNEL-AVAILABLE INTERRUPTS    @G24LB61*/
*/*            (2) REINITIALIZED CHANNEL MAP                 @G24LB61*/
*/*                                                          @G24LB61*/
*/*********************************************************  @G24LB61*/
*                                                                  0097
*REDRIVIO:                                                         0097
*   PROCEDURE OPTIONS(NOSAVE,NOSAVEAREA,RETREG);/*           @G24LB61*/
REDRIVIO DS    0H                                                  0098
*   SAVE4=RETRNREG;                 /* SAVE RETURN ADDRESS   @G24LB61*/
*                                                                  0098
         LR    SAVE4,RETRNREG                                      0098
*   /*****************************************************************/
*   /*                                                               */
*   /* CHECK EACH CHANNEL MAP ENTRY FOR A (NON-ZERO) UNIT    @G24LB61*/
*   /* ADDRESS, INDICATING AN ASSOCIATED CHANNEL NEEDING A   @G24LB61*/
*   /* SIMULATED CHANNEL-AVAILABLE INTERRUPT.                @G24LB61*/
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0099
*   DO INDEX1=1 TO MAXCHNL;         /*                       @G24LB61*/
         LA    INDEX1,1                                            0099
@DL00099 DS    0H                                                  0100
*     IF CHNLMAP(INDEX1)^=0 THEN                                   0100
         LR    @15,INDEX1                                          0100
         SLA   @15,2                                               0100
         L     @15,CHNLMAP-4(@15)                                  0100
         LTR   @15,@15                                             0100
         BZ    @RF00100                                            0100
*       DO;                         /*                       @G24LB61*/
*         UCBPTR=CHNLMAP(INDEX1);   /*                       @G24LB61*/
*                                                                  0102
         LR    UCBPTR,@15                                          0102
*         /***********************************************************/
*         /*                                                         */
*         /* SIMULATE THE CHANNEL-AVAILABLE INTERRUPT VIA    @G24LB61*/
*         /* THE IOSINTRP MACRO                              @ZA20263*/
*         /*                                                         */
*         /***********************************************************/
*                                                                  0103
*SIMINT:                                                           0103
*         WORKREG1=R13;             /* SAVE CALLERS SAVE AREA PTR  0103
*                                                            @ZA20263*/
SIMINT   LR    WORKREG1,R13                                        0103
*         R13=ADDR(REGSAV);         /* SAVE AREA FOR IOSINTRP      0104
*                                                            @ZA20263*/
         LA    R13,REGSAV                                          0104
*         GEN REFS(UCBPTR,FLCIOPSW,FLCIOAA,FLCCSW,FLCINPSW,PSA,R13);
 IOSINTRP   UCB=UCBPTR,VAR=2,BRANCH=YES                     @ZA20263
*         R13=WORKREG1;             /* RESTORE PTR TO CALLERS SAVE 0106
*                                      AREA                  @ZA20263*/
         LR    R13,WORKREG1                                        0106
*       END;                        /*                       @G24LB61*/
*   END;                            /*                       @G24LB61*/
*                                                                  0108
@RF00100 AL    INDEX1,@CF00049                                     0108
         C     INDEX1,@CF00354                                     0108
         BNH   @DL00099                                            0108
*   /*****************************************************************/
*   /*                                                               */
*   /* REINITIALIZE THE CHANNEL MAP TO ZEROS.                @G24LB61*/
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0109
*   DO INDEX1=1 TO MAXCHNL;         /*                       @G24LB61*/
         LA    INDEX1,1                                            0109
@DL00109 DS    0H                                                  0110
*     CHNLMAP(INDEX1)=0;            /*                       @G24LB61*/
         LR    @15,INDEX1                                          0110
         SLA   @15,2                                               0110
         SLR   @12,@12                                             0110
         ST    @12,CHNLMAP-4(@15)                                  0110
*   END;                            /*                       @G24LB61*/
         AL    INDEX1,@CF00049                                     0111
         C     INDEX1,@CF00354                                     0111
         BNH   @DL00109                                            0111
*   RETRNREG=SAVE4;                 /* RESTORE RETURN ADDR   @G24LB61*/
         LR    RETRNREG,SAVE4                                      0112
*   END REDRIVIO;                   /*                       @G24LB61*/
@EL00004 DS    0H                                                  0113
@EF00004 DS    0H                                                  0113
@ER00004 BR    @14                                                 0113
*                                                                  0114
*/*********************************************************  @G24LB61*/
*/*                                                          @G24LB61*/
*/*    PROCEDURE NAME - MSSUCB                               @G24LB61*/
*/*                                                          @G24LB61*/
*/*    FUNCTION- THIS PROCEDURE DETERMINES THE TYPE OF MSS   @G24LB61*/
*/*              UCB BEING CURRENTLY PROCESSED BY THE        @G24LB61*/
*/*              SYSTEM MISSING INTERRUPT CHECKER/HANDLER    @G24LB61*/
*/*              AND DETERMINES WHETHER MISSING INTERRUPT    @G24LB61*/
*/*              CHECKING SHOULD BE PERFORMED FOR IT DURING  @G24LB61*/
*/*              THE CURRENT TIME PERIOD.  IF CHECKING       @G24LB61*/
*/*              SHOULD BE DONE, IT DETERMINES IF AN I/O     @G24LB61*/
*/*              RESTART SHOULD BE DONE IF THE INTERRUPT IS  @G24LB61*/
*/*              FOUND TO BE MISSING.  FOR MISSING ATTENTION @G24LB61*/
*/*              CHECKING, THE UCB ADDRESS IS SAVED IN THE   @G24LB61*/
*/*              CHANNEL MAP TO IDENTIFY WHICH CHANNELS NEED @G24LB61*/
*/*              TO HAVE THEIR I/O REDRIVEN.                 @G24LB61*/
*/*                                                          @G24LB61*/
*/*    INPUT - (1) PARAMETER LIST IDENTIFYING ANY PENDING    @G24LB61*/
*/*                INTERRUPTS TO BE CHECKED                  @G24LB61*/
*/*            (2) UCB FOR THE CURRENT DEVICE                @G24LB61*/
*/*            (3) MSS TIME PERIOD COUNTER #1                @G24LB61*/
*/*            (4) MSS TIME PERIOD COUNTER #2                @G24LB61*/
*/*                                                          @G24LB61*/
*/*    OUTPUT- (1) MODIFIED PARAMETER LIST IDENTIFYING ANY   @G24LB61*/
*/*                PENDING INTERRUPTS STILL TO BE CHECKED    @G24LB61*/
*/*                AND INDICATING I/O RESTART ACTION         @G24LB61*/
*/*            (2) UPDATED CHANNEL MAP IDENTIFYING WHICH     @G24LB61*/
*/*                CHANNELS NEED TO HAVE CHANNEL-            @G24LB61*/
*/*                AVAILABLE INTERRUPTS SIMULATED.           @G24LB61*/
*/*                                                          @G24LB61*/
*/*********************************************************  @G24LB61*/
*                                                                  0114
*MSSUCB:                                                           0114
*   PROCEDURE OPTIONS(NOSAVE,NOSAVEAREA,RETREG);/*           @G24LB61*/
MSSUCB   DS    0H                                                  0115
*   SAVE5=RETRNREG;                 /* SAVE RETURN ADDRESS   @G24LB61*/
*                                                                  0115
         LR    SAVE5,RETRNREG                                      0115
*   /*****************************************************************/
*   /*                                                               */
*   /* INITIALLY SET FOR NO I/O RESTART                      @G24LB61*/
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0116
*   IORSTART=OFF;                   /*                       @G24LB61*/
*                                                                  0116
         NI    IORSTART(PARMPTR),B'01111111'                       0116
*   /*****************************************************************/
*   /*                                                               */
*   /* DETERMINE IF THE UCB IS FOR A 3330V                   @G24LB61*/
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0117
*   IF UCB3DACC=ON&UCBRVDEV=ON THEN                                0117
*                                                                  0117
         TM    UCB3DACC(UCBPTR),B'00100000'                        0117
         BNO   @RF00117                                            0117
         TM    UCBRVDEV(UCBPTR),B'00001000'                        0117
         BNO   @RF00117                                            0117
*     /***************************************************************/
*     /*                                                             */
*     /* IF THIS IS A 3330V WITH CHANNEL END PENDING, THEN   @G24LB61*/
*     /* SEE IF THIS IS A PROPER TIME PERIOD FOR CHECKING.   @G24LB61*/
*     /* IF IT IS, JUST SET THE I/O RESTART FLAG 'ON'. IF    @G24LB61*/
*     /* NOT, ZERO OUT THE PARAMETER FLAGS TO PREVENT ANY    @G24LB61*/
*     /* CHECKING FOR THIS UCB.                              @G24LB61*/
*     /*                                                             */
*     /***************************************************************/
*                                                                  0118
*A3330V:                                                           0118
*     DO;                           /*                       @G24LB61*/
A3330V   DS    0H                                                  0119
*       IF CEPEND=ON THEN                                          0119
         TM    CEPEND(PARMPTR),B'00000010'                         0119
         BNO   @RF00119                                            0119
*         IF TPCNTR2=0 THEN                                        0120
         LH    @15,TPCNTR2                                         0120
         LTR   @15,@15                                             0120
         BNZ   @RF00120                                            0120
*           IORSTART=ON;            /*                       @G24LB61*/
         OI    IORSTART(PARMPTR),B'10000000'                       0121
*         ELSE                                                     0122
*           PENDING=''B;            /*                       @G24LB61*/
         B     @RC00120                                            0122
@RF00120 MVI   PENDING(PARMPTR),X'00'                              0122
*       ELSE                                                       0123
*                                                                  0123
*         /***********************************************************/
*         /*                                                         */
*         /* IF A 3330V MOUNT IS PENDING, ZERO OUT ALL THE   @G24LB61*/
*         /* PARAMETER FLAGS TO PREVENT CHECKING UNLESS THIS @G24LB61*/
*         /* IS A PROPER TIME PERIOD FOR SUCH CHECKING.      @G24LB61*/
*         /*                                                         */
*         /***********************************************************/
*                                                                  0123
*         IF MNTPEND=ON&TPCNTR1^=0 THEN                            0123
         B     @RC00119                                            0123
@RF00119 TM    MNTPEND(PARMPTR),B'00000100'                        0123
         BNO   @RF00123                                            0123
         LH    @15,TPCNTR1                                         0123
         LTR   @15,@15                                             0123
         BZ    @RF00123                                            0123
*           PENDING=''B;            /*                       @G24LB61*/
*                                                                  0124
         MVI   PENDING(PARMPTR),X'00'                              0124
*       /*************************************************************/
*       /*                                                           */
*       /* FOR ANY OTHER 3330V INTERRUPT AND TIME PERIOD     @G24LB61*/
*       /* COMBINATION, THE PARAMETER LIST IS NOT MODIFIED.  @G24LB61*/
*       /*                                                           */
*       /*************************************************************/
*                                                                  0125
*         ELSE                                                     0125
*           ;                       /*                       @G24LB61*/
*                                                                  0125
@RF00123 DS    0H                                                  0126
*       /*************************************************************/
*       /*                                                           */
*       /* IF THIS IS THE PROPER TIME PERIOD, CHECK IF THERE @G24LB61*/
*       /* ANY MISSING ATTENTION INTERRUPTS ASSOCIATED WITH  @G24LB61*/
*       /* THIS 3330V. CALL THE IOSMSSA MACRO TO TEST THE    @G24LB61*/
*       /* MISSING ATTENTION STATUS IN THE UCB AND SET OR    @G24LB61*/
*       /* RESET FLAGS ACCORDINGLY.                          @G24LB61*/
*       /*                                                           */
*       /*************************************************************/
*                                                                  0126
*       IF TPCNTR1=0 THEN                                          0126
@RC00119 LH    @15,TPCNTR1                                         0126
         LTR   @15,@15                                             0126
         BNZ   @RF00126                                            0126
*MATTNCHK:                                                         0127
*         DO;                       /*                       @G24LB61*/
MATTNCHK DS    0H                                                  0128
*           GENERATE REFS(UCBPTR,UCBFL4,UCBOB,UCBSQC) SETS(WORKREG1,
*               WORKREG2,UCBFL4);                                  0128
*                                                                  0128
*                                                         /*@G24LB61*/
 IOSMSSA WORKREG1,WORKREG2,UCBPTR                             @G24LB61
*           /*********************************************************/
*           /*                                                       */
*           /* IF A NON-ZERO RETURN CODE IS RETURNED,        @G24LB61*/
*           /* IT INDICATES THERE IS A MISSING ATTENTION; IF @G24LB61*/
*           /* SO, OBTAIN THE CHANNEL NUMBER OF THE DEVICE THAT      */
*           /*                                               @G24LB61*/
*           /* HAS THE MISSING ATTENTION INTERRUPT, AND STORE        */
*           /*                                               @G24LB61*/
*           /* THE DEVICE'S UNIT ADDRESS IN THE CHANNEL MAP  @G24LB61*/
*           /* SLOT THAT IS RESERVED FOR THAT CHANNEL.       @G24LB61*/
*           /*                                                       */
*           /*********************************************************/
*                                                                  0129
*           IF WORKREG1^=0 THEN                                    0129
         LTR   WORKREG1,WORKREG1                                   0129
         BZ    @RF00129                                            0129
*             DO;                   /*                       @G24LB61*/
*               INDEX2=(UCBCHA&CHNLMASK)+1;/*                @G24LB61*/
         LA    INDEX2,15                                           0131
         SLR   @15,@15                                             0131
         IC    @15,UCBCHA(,UCBPTR)                                 0131
         NR    INDEX2,@15                                          0131
         AL    INDEX2,@CF00049                                     0131
*               CHNLMAP(INDEX2)=UCBCHAN;/*                   @G24LB61*/
         LR    @15,INDEX2                                          0132
         SLA   @15,2                                               0132
         LH    @12,UCBCHAN(,UCBPTR)                                0132
         N     @12,@CF01500                                        0132
         ST    @12,CHNLMAP-4(@15)                                  0132
*             END;                  /*                       @G24LB61*/
*         END MATTNCHK;             /*                       @G24LB61*/
*     END A3330V;                   /*                       @G24LB61*/
*   ELSE                                                           0136
*                                                                  0136
*     /***************************************************************/
*     /*                                                             */
*     /* FOR A 3851 UCB WITH CHANNEL END PENDING, ZERO OUT   @G24LB61*/
*     /* ALL THE PARAMETER FLAGS UNLESS THIS IS A PROPER     @G24LB61*/
*     /* TIME PERIOD FOR SUCH CHECKING.                      @G24LB61*/
*     /*                                                             */
*     /***************************************************************/
*                                                                  0136
*     IF CEPEND=ON&TPCNTR1^=0 THEN                                 0136
         B     @RC00117                                            0136
@RF00117 TM    CEPEND(PARMPTR),B'00000010'                         0136
         BNO   @RF00136                                            0136
         LH    @15,TPCNTR1                                         0136
         LTR   @15,@15                                             0136
         BZ    @RF00136                                            0136
*       PENDING=''B;                /*                       @G24LB61*/
*                                                                  0137
         MVI   PENDING(PARMPTR),X'00'                              0137
*   /*****************************************************************/
*   /*                                                               */
*   /* FOR ANY OTHER 3851 INTERRUPT AND TIME PERIOD          @G24LB61*/
*   /* COMBINATION, THE PARAMETER LIST IS NOT MODIFIED.      @G24LB61*/
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0138
*     ELSE                                                         0138
*       ;                           /*                       @G24LB61*/
@RF00136 DS    0H                                                  0139
*   RETRNREG=SAVE5;                 /*                       @G24LB61*/
@RC00117 LR    RETRNREG,SAVE5                                      0139
*   END MSSUCB;                     /*                       @G24LB61*/
@EL00005 DS    0H                                                  0140
@EF00005 DS    0H                                                  0140
@ER00005 BR    @14                                                 0140
*   RESPECIFY                                                      0141
*     RETRNREG UNRESTRICTED;        /*                       @G24LB61*/
*   END ICBTMSS0                    /*                       @G24LB61*/
*                                                                  0142
*/* THE FOLLOWING INCLUDE STATEMENTS WERE FOUND IN THIS PROGRAM.     */
*/*%INCLUDE SYSLIB  (IEFUCBOB)                                       */
*/*%INCLUDE SYSLIB  (IECDIOCM)                                       */
*/*%INCLUDE SYSLIB  (CVT     )                                       */
*/*%INCLUDE SYSLIB  (IHAPSA  )                                       */
*                                                                  0142
*       ;                                                          0142
@DATA    DS    0H
@CH00132 DC    H'4'
@CH01483 DC    H'10'
         DS    0F
@TF00001 DS    F
         DS    0F
@CF00049 DC    F'1'
@CF00078 DC    F'2'
@CF00354 DC    F'16'
@CF01497 DC    F'-1'
@CF01500 DC    XL4'0000FFFF'
         DS    0D
IOCOMPTR DS    A
LIMIT1   DC    H'0'
LIMIT2   DC    H'0'
TPCNTR1  DC    H'0'
TPCNTR2  DC    H'0'
FIXAREA  DS    CL100
         ORG   FIXAREA
@NM00035 DC    100X'00'
         ORG   FIXAREA+100
CHNLMAP  DC    16A(0)
REGSAV   DS    16F
@00      EQU   00                      EQUATES FOR REGISTERS 0-15
@01      EQU   01
@02      EQU   02
@03      EQU   03
@04      EQU   04
@05      EQU   05
@06      EQU   06
@07      EQU   07
@08      EQU   08
@09      EQU   09
@10      EQU   10
@11      EQU   11
@12      EQU   12
@13      EQU   13
@14      EQU   14
@15      EQU   15
SAVE5    EQU   @06
SAVE4    EQU   @07
SAVE2    EQU   @11
SAVE1    EQU   @12
INDEX2   EQU   @07
INDEX1   EQU   @06
LIMITPTR EQU   @09
RATIOPTR EQU   @08
BASEREG  EQU   @10
UCBPTR   EQU   @02
PARMPTR  EQU   @01
WORKREG1 EQU   @03
WORKREG2 EQU   @04
R13      EQU   @13
RETRNREG EQU   @14
CVTPTR   EQU   16
PSA      EQU   0
FLCRNPSW EQU   PSA
FLCROPSW EQU   PSA+8
FLCICCW2 EQU   PSA+16
FLCIOPSW EQU   PSA+56
FLCCSW   EQU   PSA+64
FLCINPSW EQU   PSA+120
PSAEEPSW EQU   PSA+132
PSAESPSW EQU   PSA+136
FLCSVILC EQU   PSAESPSW+1
PSAEPPSW EQU   PSA+140
FLCPIILC EQU   PSAEPPSW+1
FLCPICOD EQU   PSAEPPSW+2
PSAPICOD EQU   FLCPICOD+1
FLCTEA   EQU   PSAEPPSW+4
FLCPER   EQU   PSA+152
FLCMCLA  EQU   PSA+168
FLCIOEL  EQU   FLCMCLA+4
FLCIOA   EQU   FLCMCLA+16
FLCIOAA  EQU   FLCIOA+1
FLCFSA   EQU   FLCMCLA+80
PSASUPER EQU   PSA+552
PSASUP1  EQU   PSASUPER
PSASUP2  EQU   PSASUPER+1
PSASUP3  EQU   PSASUPER+2
PSASUP4  EQU   PSASUPER+3
PSACLHT  EQU   PSA+640
PSALKSA  EQU   PSA+696
PSAHLHI  EQU   PSA+760
PSADSSFL EQU   PSA+836
PSADSSF1 EQU   PSADSSFL
PSADSSF3 EQU   PSADSSFL+2
PSADSSF4 EQU   PSADSSFL+3
PSARSVT  EQU   PSA+896
UCB      EQU   0
UCBOB    EQU   0
UCBJBNR  EQU   UCBOB
UCBFL5   EQU   UCBOB+1
UCBAF    EQU   UCBFL5
UCBSTAT  EQU   UCBOB+3
UCBCHAN  EQU   UCBOB+4
UCBCHA   EQU   UCBCHAN
UCBSFLS  EQU   UCBOB+6
UCBFLA   EQU   UCBSFLS
UCBFL1   EQU   UCBFLA
UCBBSY   EQU   UCBFL1
UCBNRY   EQU   UCBFL1
UCBPST   EQU   UCBFL1
UCBCUB   EQU   UCBFL1
UCBFLB   EQU   UCBSFLS+1
UCBCHM   EQU   UCBOB+8
UCBCHM1  EQU   UCBCHM
UCBPTH0  EQU   UCBCHM1
UCBPTH1  EQU   UCBCHM1
UCBWGT   EQU   UCBOB+12
UCBTYP   EQU   UCBOB+16
UCBTBYT1 EQU   UCBTYP
UCB1FEA5 EQU   UCBTBYT1
UCB1FEA6 EQU   UCBTBYT1
UCBTBYT2 EQU   UCBTYP+1
UCB2OPT2 EQU   UCBTBYT2
UCBDUDN1 EQU   UCB2OPT2
UCB2OPT3 EQU   UCBTBYT2
UCBDUDN2 EQU   UCB2OPT3
UCB2OPT4 EQU   UCBTBYT2
UCBRWTAU EQU   UCB2OPT4
UCBRVDEV EQU   UCBRWTAU
UCB2OPT6 EQU   UCBTBYT2
UCB2OPT7 EQU   UCBTBYT2
UCBTBYT3 EQU   UCBTYP+2
UCBDVCLS EQU   UCBTBYT3
UCB3DACC EQU   UCBDVCLS
UCBTBYT4 EQU   UCBTYP+3
UCBEXTPT EQU   UCBOB+20
UCBFLC   EQU   UCBEXTPT
UCBDEV   EQU   UCBOB+24
UCBCMEXT EQU   0
UCBATI   EQU   UCBCMEXT+3
@NM00004 EQU   UCBATI
UCBFLP1  EQU   UCBCMEXT+5
UCBMT    EQU   0
UCBOCR   EQU   0
UCB3540X EQU   0
UCBDKBYT EQU   UCB3540X+6
UCB3800X EQU   0
UCBOPTNS EQU   UCB3800X
UCBACTIV EQU   UCB3800X+3
UCBMDRBF EQU   UCB3800X+36
UCBUCS   EQU   0
UCBUCSOP EQU   UCBUCS+4
UCBFCBOP EQU   UCBUCS+5
IOCOM    EQU   0
CVTMAP   EQU   0
CVTDAR   EQU   CVTMAP+72
CVTFLGS1 EQU   CVTDAR
CVTDCB   EQU   CVTMAP+116
CVTIOQET EQU   CVTMAP+120
CVTIERLC EQU   CVTMAP+144
CVTHEAD  EQU   CVTMAP+160
CVTSV76C EQU   CVTHEAD
CVTOPTA  EQU   CVTMAP+182
CVTOPTB  EQU   CVTMAP+183
CVTGTF   EQU   CVTMAP+236
CVTGTFST EQU   CVTGTF
CVTGTFS  EQU   CVTGTFST
CVTSTATE EQU   CVTGTFST
CVTTMODE EQU   CVTGTFST
CVTFORM  EQU   CVTGTFST
CVTAQAVT EQU   CVTMAP+240
CVTTCMFG EQU   CVTAQAVT
CVTVOLM2 EQU   CVTMAP+244
CVTTATA  EQU   CVTVOLM2
CVTTSKS  EQU   CVTTATA
CVTVOLF2 EQU   CVTTSKS
CVTTAT   EQU   CVTTATA+1
CVTATER  EQU   CVTMAP+248
CVTEXT1  EQU   CVTMAP+252
CVTPURG  EQU   CVTMAP+260
CVTQMSG  EQU   CVTMAP+268
CVTDMSR  EQU   CVTMAP+272
CVTRSV37 EQU   CVTDMSR
CVTDMSRF EQU   CVTRSV37
CVTERPV  EQU   CVTMAP+316
CVTINTLA EQU   CVTMAP+320
CVTAPF   EQU   CVTMAP+324
CVTEXT2  EQU   CVTMAP+328
CVTHJES  EQU   CVTMAP+332
CVTPGSIA EQU   CVTMAP+348
CVTA1F1  EQU   CVTMAP+356
CVTSYSK  EQU   CVTMAP+357
CVTVOLM1 EQU   CVTMAP+380
CVTVOLF1 EQU   CVTVOLM1
CVTATMCT EQU   CVTMAP+388
CVTXTNT1 EQU   0
CVTXTNT2 EQU   0
CVTDSSV  EQU   CVTXTNT2
CVTFLGBT EQU   CVTXTNT2+5
CVTQID   EQU   CVTXTNT2+24
CVTRV400 EQU   CVTXTNT2+52
CVTRV409 EQU   CVTXTNT2+53
CVTATCVT EQU   CVTXTNT2+64
CVTRV429 EQU   CVTXTNT2+84
CVTRV438 EQU   CVTXTNT2+85
CVTRV457 EQU   CVTXTNT2+112
CVTRV466 EQU   CVTXTNT2+113
CVTFIX   EQU   0
CVTRELNO EQU   CVTFIX+252
INTVL    EQU   0
MSSRVAL1 EQU   INTVL+8
MSSRVAL2 EQU   INTVL+10
INTFLAGS EQU   0
IORSTART EQU   INTFLAGS
PENDING  EQU   INTFLAGS+3
MNTPEND  EQU   PENDING
CEPEND   EQU   PENDING
RATIO    EQU   0
LIMIT    EQU   0
UCBBGN   EQU   0
UCBOBS01 EQU   UCBDEV
UCBSTAB  EQU   UCBOBS01+10
UCBBSVL  EQU   UCBSTAB
UCBPRSRS EQU   UCBSTAB
UCBDMCT  EQU   UCBOBS01+11
UCBSQC   EQU   UCBOBS01+12
UCBFL4   EQU   UCBOBS01+13
UCBOBS02 EQU   UCBDEV
UCBTFL1  EQU   UCBOBS02+19
UCBXTN   EQU   UCBOBS02+20
UCBVOPT  EQU   UCBXTN
UCBOBS03 EQU   UCBDEV
UCBXTADR EQU   UCBOBS03
UCBOBS04 EQU   UCBDEV
UCBBTA   EQU   UCBOBS04+12
UCBOBS06 EQU   UCBDEV
UCBAOF   EQU   UCBOBS06
UCBAOF1  EQU   UCBAOF
UCBAOF2  EQU   UCBAOF+1
@NM00003 EQU   UCBOBS06+3
UCBIRB   EQU   UCBOBS06+4
UCBGRAF  EQU   UCBIRB
UCBLDNCA EQU   UCBOBS06+8
UCBRDYQ  EQU   UCBLDNCA
UCBIRLN  EQU   UCBRDYQ
UCBLDNCB EQU   UCBRDYQ+1
UCBCTLNK EQU   UCBOBS06+12
UCBOBS07 EQU   UCBDEV
UCBOBS08 EQU   UCBDEV
UCBCTCAD EQU   UCBOBS08
UCBCTCF1 EQU   UCBOBS08+4
UCBOBS09 EQU   UCBDEV
CVTS01   EQU   CVTPGSIA
CVTLPDIA EQU   CVTS01+12
CVTDIRST EQU   CVTLPDIA
CVTSLIDA EQU   CVTS01+24
CVTCTLFG EQU   CVTS01+50
CVTRV210 EQU   CVTS01+424
CVTRV219 EQU   CVTS01+425
CVTRV228 EQU   CVTS01+426
CVTRV237 EQU   CVTS01+427
CVTMFRTR EQU   CVTS01+452
CVTRV262 EQU   CVTS01+468
CVTRV271 EQU   CVTS01+469
CVTRV280 EQU   CVTS01+470
CVTRV289 EQU   CVTS01+471
CVTGSDA  EQU   CVTS01+600
PSARSVTE EQU   PSARSVT
FLC      EQU   PSA
*                                      START UNREFERENCED COMPONENTS
PSARSAV  EQU   PSARSVTE+60
PSARSTK  EQU   PSARSVTE+56
PSAESAV3 EQU   PSARSVTE+52
PSAESTK3 EQU   PSARSVTE+48
PSAESAV2 EQU   PSARSVTE+44
PSAESTK2 EQU   PSARSVTE+40
PSAESAV1 EQU   PSARSVTE+36
PSAESTK1 EQU   PSARSVTE+32
PSAPSAV  EQU   PSARSVTE+28
PSAPSTK  EQU   PSARSVTE+24
PSAMSAV  EQU   PSARSVTE+20
PSAMSTK  EQU   PSARSVTE+16
PSASSAV  EQU   PSARSVTE+12
PSASSTK  EQU   PSARSVTE+8
PSANSTK  EQU   PSARSVTE+4
PSACSTK  EQU   PSARSVTE
CVTRV628 EQU   CVTS01+728
CVTRV627 EQU   CVTS01+724
CVTRV626 EQU   CVTS01+720
CVTRV625 EQU   CVTS01+716
CVTRV624 EQU   CVTS01+712
CVTRV623 EQU   CVTS01+708
CVTRV622 EQU   CVTS01+704
CVTRV621 EQU   CVTS01+700
CVTIHASU EQU   CVTS01+696
CVTRV619 EQU   CVTS01+692
CVTRV618 EQU   CVTS01+688
CVTRV617 EQU   CVTS01+684
CVTRV616 EQU   CVTS01+680
CVTRV615 EQU   CVTS01+676
CVTRV614 EQU   CVTS01+672
CVTRV613 EQU   CVTS01+668
CVTTCASP EQU   CVTS01+664
CVT0PT03 EQU   CVTS01+660
CVT0PT0E EQU   CVTS01+656
CVTRV609 EQU   CVTS01+652
CVTCGK   EQU   CVTS01+648
CVTRAC   EQU   CVTS01+644
CVTRV606 EQU   CVTS01+640
CVTRV605 EQU   CVTS01+636
CVTRV604 EQU   CVTS01+632
CVTEFF02 EQU   CVTS01+628
CVTCBBR  EQU   CVTS01+624
CVTSSCR  EQU   CVTS01+620
CVTEVENT EQU   CVTS01+616
CVTCRCA  EQU   CVTS01+612
CVTTPIO  EQU   CVTS01+608
CVTADV   EQU   CVTS01+604
CVTGSDAB EQU   CVTGSDA
CVTQV3   EQU   CVTS01+596
CVTQV2   EQU   CVTS01+592
CVTQV1   EQU   CVTS01+588
CVTRPT   EQU   CVTS01+584
CVTSSRB  EQU   CVTS01+580
CVTCSDRL EQU   CVTS01+576
CVTEXP1  EQU   CVTS01+572
CVTRMPMT EQU   CVTS01+568
CVTRMPTT EQU   CVTS01+564
CVTVPSA  EQU   CVTS01+560
CVTVSTOP EQU   CVTS01+556
CVTGTFR8 EQU   CVTS01+552
CVTQUIT  EQU   CVTS01+548
CVTVACR  EQU   CVTS01+544
CVTWTCB  EQU   CVTS01+540
CVTSTPRS EQU   CVTS01+536
CVT0PT02 EQU   CVTS01+532
CVTDARCM EQU   CVTS01+528
CVTIRECM EQU   CVTS01+524
CVTJRECM EQU   CVTS01+520
CVTVEMS0 EQU   CVTS01+516
CVTSPFRR EQU   CVTS01+512
CVTRLSTG EQU   CVTS01+508
CVT0TC0A EQU   CVTS01+504
CVTGMBR  EQU   CVTS01+500
CVTLFRM  EQU   CVTS01+496
CVTRMBR  EQU   CVTS01+492
CVTVIOP  EQU   CVTS01+488
CVTRV307 EQU   CVTS01+486
CVTRV306 EQU   CVTS01+484
CVTRV305 EQU   CVTS01+482
CVTRV304 EQU   CVTS01+480
CVTRV303 EQU   CVTS01+478
CVTRV302 EQU   CVTS01+476
CVTTRCA  EQU   CVTS01+472
CVTRV297 EQU   CVTRV289
CVTRV296 EQU   CVTRV289
CVTRV295 EQU   CVTRV289
CVTRV294 EQU   CVTRV289
CVTRV293 EQU   CVTRV289
CVTRV292 EQU   CVTRV289
CVTRV291 EQU   CVTRV289
CVTRV290 EQU   CVTRV289
CVTRV288 EQU   CVTRV280
CVTRV287 EQU   CVTRV280
CVTRV286 EQU   CVTRV280
CVTRV285 EQU   CVTRV280
CVTRV284 EQU   CVTRV280
CVTRV283 EQU   CVTRV280
CVTRV282 EQU   CVTRV280
CVTRV281 EQU   CVTRV280
CVTRV279 EQU   CVTRV271
CVTRV278 EQU   CVTRV271
CVTRV277 EQU   CVTRV271
CVTRV276 EQU   CVTRV271
CVTRV275 EQU   CVTRV271
CVTRV274 EQU   CVTRV271
CVTRV273 EQU   CVTRV271
CVTRV272 EQU   CVTRV271
CVTRV270 EQU   CVTRV262
CVTRV269 EQU   CVTRV262
CVTRV268 EQU   CVTRV262
CVTRV267 EQU   CVTRV262
CVTRV266 EQU   CVTRV262
CVTRV265 EQU   CVTRV262
CVTRV264 EQU   CVTRV262
CVTRV263 EQU   CVTRV262
CVTVFP   EQU   CVTS01+464
CVTVSI   EQU   CVTS01+460
CVTVPSIB EQU   CVTS01+456
CVTMFACT EQU   CVTMFRTR
CVTMFCTL EQU   CVTS01+448
CVTPVBP  EQU   CVTS01+444
CVTPWI   EQU   CVTS01+440
CVTRV254 EQU   CVTS01+438
CVTRV253 EQU   CVTS01+436
CVTRV252 EQU   CVTS01+434
CVTRV251 EQU   CVTS01+433
CVTRV250 EQU   CVTS01+432
CVTRV249 EQU   CVTS01+431
CVTRV248 EQU   CVTS01+430
CVTRV247 EQU   CVTS01+429
CVTRV246 EQU   CVTS01+428
CVTRV245 EQU   CVTRV237
CVTRV244 EQU   CVTRV237
CVTRV243 EQU   CVTRV237
CVTRV242 EQU   CVTRV237
CVTRV241 EQU   CVTRV237
CVTRV240 EQU   CVTRV237
CVTRV239 EQU   CVTRV237
CVTRV238 EQU   CVTRV237
CVTRV236 EQU   CVTRV228
CVTRV235 EQU   CVTRV228
CVTRV234 EQU   CVTRV228
CVTRV233 EQU   CVTRV228
CVTRV232 EQU   CVTRV228
CVTRV231 EQU   CVTRV228
CVTRV230 EQU   CVTRV228
CVTRV229 EQU   CVTRV228
CVTRV227 EQU   CVTRV219
CVTRV226 EQU   CVTRV219
CVTRV225 EQU   CVTRV219
CVTRV224 EQU   CVTRV219
CVTRV223 EQU   CVTRV219
CVTRV222 EQU   CVTRV219
CVTRV221 EQU   CVTRV219
CVTRV220 EQU   CVTRV219
CVTRV218 EQU   CVTRV210
CVTRV217 EQU   CVTRV210
CVTRV216 EQU   CVTRV210
CVTRV215 EQU   CVTRV210
CVTRV214 EQU   CVTRV210
CVTRV213 EQU   CVTRV210
CVTRV212 EQU   CVTRV210
CVTRV211 EQU   CVTRV210
CVTLCCAT EQU   CVTS01+420
CVTPCCAT EQU   CVTS01+416
CVTIPCRP EQU   CVTS01+412
CVTIPCRI EQU   CVTS01+408
CVTIPCDS EQU   CVTS01+404
CVTAIDVT EQU   CVTS01+400
CVTSSAP  EQU   CVTS01+396
CVTEHCIR EQU   CVTS01+392
CVTEHDEF EQU   CVTS01+388
CVTDAIR  EQU   CVTS01+384
CVTPERFM EQU   CVTS01+380
CVT044R2 EQU   CVTS01+376
CVTFETCH EQU   CVTS01+372
CVTRSTWD EQU   CVTS01+368
CVTSPOST EQU   CVTS01+364
CVTIOBP  EQU   CVTS01+360
CVTASMVT EQU   CVTS01+356
CVTRECRQ EQU   CVTS01+352
CVTWSAC  EQU   CVTS01+348
CVTRV149 EQU   CVTS01+344
CVTWSAL  EQU   CVTS01+340
CVTSPSA  EQU   CVTS01+336
CVTGLMN  EQU   CVTS01+332
CVTVEAC0 EQU   CVTS01+328
CVT062R1 EQU   CVTS01+324
CVTRPOST EQU   CVTS01+320
CVTDQIQE EQU   CVTS01+316
CVTCSD   EQU   CVTS01+312
CVTLKRMA EQU   CVTS01+308
CVTRSPIE EQU   CVTS01+304
CVTRENQ  EQU   CVTS01+300
CVTLQCB  EQU   CVTS01+296
CVTFQCB  EQU   CVTS01+292
CVTQCS01 EQU   CVTS01+288
CVTAPFT  EQU   CVTS01+284
CVTPARRL EQU   CVTS01+280
CVTVWAIT EQU   CVTS01+276
CVTGSPL  EQU   CVTS01+272
CVTLSMQ  EQU   CVTS01+268
CVTGSMQ  EQU   CVTS01+264
CVTEXPRO EQU   CVTS01+260
CVTOPCTP EQU   CVTS01+256
CVTSIC   EQU   CVTS01+252
CVTTPIOS EQU   CVTS01+248
CVTRTMS  EQU   CVTS01+244
CVTSDBF  EQU   CVTS01+240
CVTSCBP  EQU   CVTS01+236
CVTSDMP  EQU   CVTS01+232
CVTSV60  EQU   CVTS01+228
CVTRTMCT EQU   CVTS01+224
CVTASCBL EQU   CVTS01+220
CVTASCBH EQU   CVTS01+216
CVTGDA   EQU   CVTS01+212
CVTASVT  EQU   CVTS01+208
CVTVVMDI EQU   CVTS01+204
CVTAQTOP EQU   CVTS01+200
CVTIOSCS EQU   CVTS01+196
CVTSDRM  EQU   CVTS01+192
CVTOPTE  EQU   CVTS01+188
CVTSTXU  EQU   CVTS01+184
CVTQUIS  EQU   CVTS01+180
CVTPARS  EQU   CVTS01+176
CVTS1EE  EQU   CVTS01+172
CVTFRAS  EQU   CVTS01+168
CVTQSAS  EQU   CVTS01+164
CVTCRAS  EQU   CVTS01+160
CVTCRMN  EQU   CVTS01+156
CVTDELCP EQU   CVTS01+152
CVTFRECL EQU   CVTS01+148
CVTGETCL EQU   CVTS01+144
CVTBLDCP EQU   CVTS01+140
CVTAUTHL EQU   CVTS01+136
CVTSCAN  EQU   CVTS01+132
CVTRV144 EQU   CVTS01+130
CVTMAXMP EQU   CVTS01+128
CVTSTCK  EQU   CVTS01+124
CVTRV139 EQU   CVTS01+123
CVTDSSAC EQU   CVTS01+122
CVTRV513 EQU   CVTS01+121
CVTIOSPL EQU   CVTS01+120
CVTPTGT  EQU   CVTS01+116
CVTCSPIE EQU   CVTS01+112
CVTSMFEX EQU   CVTS01+108
CVTOLT0A EQU   CVTS01+104
CVTSRBRT EQU   CVTS01+100
CVTPUTL  EQU   CVTS01+96
CVTASCRL EQU   CVTS01+92
CVTASCRF EQU   CVTS01+88
CVTRV326 EQU   CVTS01+84
CVTRV325 EQU   CVTS01+80
CVTRV324 EQU   CVTS01+76
CVT0VL01 EQU   CVTS01+72
CVTSHRVM EQU   CVTS01+68
CVTRV332 EQU   CVTS01+64
CVTTAS   EQU   CVTS01+60
CVTRSCN  EQU   CVTS01+56
CVTTRAC2 EQU   CVTS01+54
CVTTRACE EQU   CVTS01+52
CVTAPG   EQU   CVTS01+51
CVTSDTRC EQU   CVTCTLFG
CVTGTRCE EQU   CVTCTLFG
CVTNOMP  EQU   CVTCTLFG
CVTRSV79 EQU   CVTCTLFG
CVTDSTAT EQU   CVTCTLFG
CVTRSV78 EQU   CVTCTLFG
CVTRV333 EQU   CVTCTLFG
CVTRV323 EQU   CVTCTLFG
CVTSPVLK EQU   CVTS01+49
CVTRSV77 EQU   CVTS01+48
CVTRV331 EQU   CVTS01+44
CVTRV330 EQU   CVTS01+40
CVTRV329 EQU   CVTS01+36
CVTRV328 EQU   CVTS01+32
CVTRV322 EQU   CVTS01+28
CVTSLID  EQU   CVTSLIDA+1
CVTSYLK  EQU   CVTSLIDA
CVTRV321 EQU   CVTS01+20
CVTRV320 EQU   CVTS01+16
CVTLPDIR EQU   CVTLPDIA+1
CVTRSV69 EQU   CVTDIRST
CVTRSV68 EQU   CVTDIRST
CVTRSV67 EQU   CVTDIRST
CVTRSV66 EQU   CVTDIRST
CVTRSV65 EQU   CVTDIRST
CVTRSV64 EQU   CVTDIRST
CVTRSV63 EQU   CVTDIRST
CVTDICOM EQU   CVTDIRST
CVTPVTP  EQU   CVTS01+8
CVTLPDSR EQU   CVTS01+4
CVTGETL  EQU   CVTS01
UCBRV066 EQU   UCBOBS09+4
UCBIOSBA EQU   UCBOBS09
UCBRV042 EQU   UCBOBS08+5
UCBRV082 EQU   UCBCTCF1
UCBRV081 EQU   UCBCTCF1
UCBRV080 EQU   UCBCTCF1
UCBRV079 EQU   UCBCTCF1
UCBRV078 EQU   UCBCTCF1
UCBRV077 EQU   UCBCTCF1
UCBRV076 EQU   UCBCTCF1
UCBCTC80 EQU   UCBCTCF1
UCBCTCAL EQU   UCBCTCAD
UCBICNCB EQU   UCBOBS07+4
UCBRV040 EQU   UCBOBS07
UCBCTLNA EQU   UCBCTLNK+1
UCBRLN   EQU   UCBCTLNK
UCBRDYQA EQU   UCBLDNCB
UCBINRLN EQU   UCBIRLN
UCBIRBA  EQU   UCBIRB+1
UCBRV039 EQU   UCBGRAF
UCBDWNR  EQU   UCBGRAF
UCBRPND  EQU   UCBGRAF
UCBUPM   EQU   UCBGRAF
UCBBTAM  EQU   UCBGRAF
UCBDRNO  EQU   UCBGRAF
UCBDRO   EQU   UCBGRAF
UCBOIP   EQU   UCBGRAF
UCBATRCD EQU   @NM00003
UCBSKPFG EQU   @NM00003
UCBRIPND EQU   @NM00003
UCBRTIAC EQU   @NM00003
UCBRSV79 EQU   @NM00003
UCBRSV78 EQU   @NM00003
UCBRSV77 EQU   @NM00003
UCBOLTEP EQU   @NM00003
UCBATNCT EQU   UCBOBS06+2
UCBRSV76 EQU   UCBAOF2
UCBRSV75 EQU   UCBAOF2
UCBRSV74 EQU   UCBAOF2
UCBRSV73 EQU   UCBAOF2
UCBRSV72 EQU   UCBAOF2
UCBRSV71 EQU   UCBAOF2
UCBRSV70 EQU   UCBAOF2
UCBRSV69 EQU   UCBAOF2
UCBRSV68 EQU   UCBAOF1
UCBRSV67 EQU   UCBAOF1
UCBRSV66 EQU   UCBAOF1
UCBRSV65 EQU   UCBAOF1
UCBRSV64 EQU   UCBAOF1
UCBOFNL  EQU   UCBAOF1
UCBOFSP  EQU   UCBAOF1
UCBOFMCR EQU   UCBAOF1
UCBBTB   EQU   UCBBTA+1
UCBDI    EQU   UCBBTA
UCBSNS   EQU   UCBOBS04+8
UCBTEB   EQU   UCBOBS04+4
UCBGCB   EQU   UCBOBS04+3
UCBOPEN  EQU   UCBOBS04+2
UCBSTART EQU   UCBOBS04
UCBXTNB  EQU   UCBXTN+1
UCBRSV22 EQU   UCBVOPT
UCBRSV21 EQU   UCBVOPT
UCBRSV20 EQU   UCBVOPT
UCBESVE  EQU   UCBVOPT
UCBERPC  EQU   UCBVOPT
UCBESVC  EQU   UCBVOPT
UCBEVA   EQU   UCBVOPT
UCBESV   EQU   UCBVOPT
UCBRV009 EQU   UCBTFL1
UCBRV008 EQU   UCBTFL1
UCBRV007 EQU   UCBTFL1
UCBRV006 EQU   UCBTFL1
UCBRV005 EQU   UCBTFL1
UCBDQDSP EQU   UCBTFL1
UCBNSLTP EQU   UCBTFL1
UCBNLTP  EQU   UCBTFL1
UCBRES1B EQU   UCBOBS02+18
UCBFSER  EQU   UCBOBS02+12
@NM00002 EQU   UCBOBS02+4
UCBFSEQ  EQU   UCBOBS02+2
UCBFSCT  EQU   UCBOBS02
UCBNEXP  EQU   UCBOBS01+20
UCBBASE  EQU   UCBOBS01+16
UCBRES1A EQU   UCBOBS01+15
UCBUSER  EQU   UCBOBS01+14
UCBFL47  EQU   UCBFL4
UCBFL46  EQU   UCBFL4
UCBFL45  EQU   UCBFL4
UCBRV065 EQU   UCBFL4
UCBDSS   EQU   UCBFL4
UCBRESVP EQU   UCBFL4
UCBWDAV  EQU   UCBFL4
UCBDAVV  EQU   UCBFL4
UCBDATP  EQU   UCBOBS01+12
UCBDMC   EQU   UCBDMCT
UCBMOUNT EQU   UCBDMCT
UCBBNUL  EQU   UCBSTAB
UCBSHAR  EQU   UCBSTAB
UCBBSTR  EQU   UCBSTAB
UCBBPUB  EQU   UCBSTAB
UCBBPRV  EQU   UCBSTAB
UCBBALB  EQU   UCBPRSRS
UCBPGFL  EQU   UCBSTAB
UCBDVSHR EQU   UCBBSVL
UCBVOLI  EQU   UCBOBS01+4
UCBVTOC  EQU   UCBOBS01
DEPEND   EQU   PENDING
SWAPPEND EQU   PENDING
@NM00034 EQU   PENDING
@NM00033 EQU   INTFLAGS
TIMINTVL EQU   INTVL
CVTLEVL  EQU   CVTRELNO+2
CVTNUMB  EQU   CVTRELNO
CVTMDL   EQU   CVTFIX+250
@NM00008 EQU   CVTFIX+248
@NM00007 EQU   CVTFIX
CVTRV482 EQU   CVTXTNT2+128
CVTRV481 EQU   CVTXTNT2+124
CVTRV480 EQU   CVTXTNT2+120
CVTRV479 EQU   CVTXTNT2+118
CVTRV478 EQU   CVTXTNT2+117
CVTRV477 EQU   CVTXTNT2+116
CVTRV476 EQU   CVTXTNT2+115
CVTRV475 EQU   CVTXTNT2+114
CVTRV474 EQU   CVTRV466
CVTRV473 EQU   CVTRV466
CVTRV472 EQU   CVTRV466
CVTRV471 EQU   CVTRV466
CVTRV470 EQU   CVTRV466
CVTRV469 EQU   CVTRV466
CVTRV468 EQU   CVTRV466
CVTRV467 EQU   CVTRV466
CVTRV465 EQU   CVTRV457
CVTRV464 EQU   CVTRV457
CVTRV463 EQU   CVTRV457
CVTRV462 EQU   CVTRV457
CVTRV461 EQU   CVTRV457
CVTRV460 EQU   CVTRV457
CVTRV459 EQU   CVTRV457
CVTRV458 EQU   CVTRV457
CVTRV456 EQU   CVTXTNT2+108
CVTRV455 EQU   CVTXTNT2+104
CVTRV454 EQU   CVTXTNT2+100
CVTRV453 EQU   CVTXTNT2+96
CVTRV452 EQU   CVTXTNT2+94
CVTRV451 EQU   CVTXTNT2+92
CVTRV450 EQU   CVTXTNT2+90
CVTRV449 EQU   CVTXTNT2+88
CVTRV448 EQU   CVTXTNT2+87
CVTRV447 EQU   CVTXTNT2+86
CVTRV446 EQU   CVTRV438
CVTRV445 EQU   CVTRV438
CVTRV444 EQU   CVTRV438
CVTRV443 EQU   CVTRV438
CVTRV442 EQU   CVTRV438
CVTRV441 EQU   CVTRV438
CVTRV440 EQU   CVTRV438
CVTRV439 EQU   CVTRV438
CVTRV437 EQU   CVTRV429
CVTRV436 EQU   CVTRV429
CVTRV435 EQU   CVTRV429
CVTRV434 EQU   CVTRV429
CVTRV433 EQU   CVTRV429
CVTRV432 EQU   CVTRV429
CVTRV431 EQU   CVTRV429
CVTRV430 EQU   CVTRV429
CVTRV428 EQU   CVTXTNT2+80
CVTRV427 EQU   CVTXTNT2+76
CVTRV426 EQU   CVTXTNT2+72
CVTRV425 EQU   CVTXTNT2+68
CVTATACT EQU   CVTATCVT
CVTRV423 EQU   CVTXTNT2+62
CVTRV422 EQU   CVTXTNT2+60
CVTRV421 EQU   CVTXTNT2+58
CVTRV420 EQU   CVTXTNT2+56
CVTRV419 EQU   CVTXTNT2+55
CVTRV418 EQU   CVTXTNT2+54
CVTRV417 EQU   CVTRV409
CVTRV416 EQU   CVTRV409
CVTRV415 EQU   CVTRV409
CVTRV414 EQU   CVTRV409
CVTRV413 EQU   CVTRV409
CVTRV412 EQU   CVTRV409
CVTRV411 EQU   CVTRV409
CVTRV410 EQU   CVTRV409
CVTRV408 EQU   CVTRV400
CVTRV407 EQU   CVTRV400
CVTRV406 EQU   CVTRV400
CVTRV405 EQU   CVTRV400
CVTRV404 EQU   CVTRV400
CVTRV403 EQU   CVTRV400
CVTRV402 EQU   CVTRV400
CVTRV401 EQU   CVTRV400
CVTICB   EQU   CVTXTNT2+48
CVTSKTA  EQU   CVTXTNT2+44
CVTRSV99 EQU   CVTXTNT2+40
CVTRSV98 EQU   CVTXTNT2+36
CVTRSV97 EQU   CVTXTNT2+34
CVTRSV96 EQU   CVTXTNT2+32
CVTOLTEP EQU   CVTXTNT2+28
CVTQIDA  EQU   CVTQID+1
CVTRSV95 EQU   CVTQID
CVTRSV94 EQU   CVTXTNT2+20
CVTRSV93 EQU   CVTXTNT2+16
CVTRSV92 EQU   CVTXTNT2+12
CVTDEBVR EQU   CVTXTNT2+8
CVTRSV91 EQU   CVTXTNT2+6
CVTRSV9H EQU   CVTFLGBT
CVTRSV9G EQU   CVTFLGBT
CVTRSV9F EQU   CVTFLGBT
CVTRSV9E EQU   CVTFLGBT
CVTRSV9D EQU   CVTFLGBT
CVTRSV9C EQU   CVTFLGBT
CVTVME   EQU   CVTFLGBT
CVTNPE   EQU   CVTFLGBT
CVTNUCLS EQU   CVTXTNT2+4
CVTDSSVA EQU   CVTDSSV+1
CVTRSV89 EQU   CVTDSSV
CVTRSV88 EQU   CVTXTNT1+8
CVTRSV87 EQU   CVTXTNT1+4
CVTFACHN EQU   CVTXTNT1
CVTRV488 EQU   CVTMAP+412
CVTRV487 EQU   CVTMAP+408
CVTRV486 EQU   CVTMAP+404
CVTRV485 EQU   CVTMAP+400
CVTACTAP EQU   CVTMAP+396
CVTAUTH  EQU   CVTMAP+392
CVTATMCA EQU   CVTATMCT+1
CVTATMST EQU   CVTATMCT
CVTRSV61 EQU   CVTMAP+384
CVTVOLT1 EQU   CVTVOLM1+1
CVTVOLI1 EQU   CVTVOLF1
CVTSTOA  EQU   CVTMAP+376
CVTRSV58 EQU   CVTMAP+374
CVTRSV57 EQU   CVTMAP+372
CVTDDCE  EQU   CVTMAP+368
CVTPNWFR EQU   CVTMAP+364
CVTSMF   EQU   CVTMAP+360
CVTSULK  EQU   CVTMAP+358
CVTSLKO  EQU   CVTSYSK
CVTSLKP  EQU   CVTSYSK
CVTSLKQ  EQU   CVTSYSK
CVTSLKR  EQU   CVTSYSK
CVTRSV56 EQU   CVTSYSK
CVTRSV55 EQU   CVTSYSK
CVTRSV54 EQU   CVTSYSK
CVTRSV53 EQU   CVTSYSK
CVTRSV52 EQU   CVTA1F1
CVTRSV51 EQU   CVTA1F1
CVTRSV50 EQU   CVTA1F1
CVTRSV49 EQU   CVTA1F1
CVTRSV48 EQU   CVTA1F1
CVTRSV47 EQU   CVTA1F1
CVTSRSW  EQU   CVTA1F1
CVTPFSW  EQU   CVTA1F1
CVTPCVT  EQU   CVTMAP+352
CVTRSV46 EQU   CVTMAP+344
CVTRSV45 EQU   CVTMAP+340
CVTRSV44 EQU   CVTMAP+338
CVTRSV43 EQU   CVTMAP+336
CVTHJESA EQU   CVTHJES+1
CVTRSV42 EQU   CVTHJES
CVTEXT2A EQU   CVTEXT2+1
CVTRSV41 EQU   CVTEXT2
CVTAPFA  EQU   CVTAPF+1
CVTRSV40 EQU   CVTAPF
CVTRV518 EQU   CVTINTLA
CVTRV517 EQU   CVTERPV
CVTEORM  EQU   CVTMAP+312
CVTMCHPR EQU   CVTMAP+308
CVTTZ    EQU   CVTMAP+304
CVTJEPS  EQU   CVTMAP+300
CVTJESCT EQU   CVTMAP+296
CVTMODE  EQU   CVTMAP+292
CVTPTRV  EQU   CVTMAP+288
CVTREAL  EQU   CVTMAP+284
CVTRSV39 EQU   CVTMAP+280
CVTRSV38 EQU   CVTMAP+276
CVTDMSRA EQU   CVTDMSR+1
CVTRV634 EQU   CVTDMSRF
CVTRV633 EQU   CVTDMSRF
CVTRV632 EQU   CVTDMSRF
CVTRV631 EQU   CVTDMSRF
CVTRV630 EQU   CVTDMSRF
CVTRV629 EQU   CVTDMSRF
CVTUDUMP EQU   CVTDMSRF
CVTSDUMP EQU   CVTDMSRF
CVTQMSGA EQU   CVTQMSG+1
CVTRSV36 EQU   CVTQMSG
CVTAMFF  EQU   CVTMAP+264
CVTPURGA EQU   CVTPURG+1
CVTRSV35 EQU   CVTPURG
CVTCBSP  EQU   CVTMAP+256
CVTATERA EQU   CVTATER+1
CVTSYST  EQU   CVTATER
CVTVOLT2 EQU   CVTTAT
CVTVOLI2 EQU   CVTVOLF2
CVTAQAVB EQU   CVTAQAVT+1
CVTRSV34 EQU   CVTTCMFG
CVTRSV33 EQU   CVTTCMFG
CVTRSV32 EQU   CVTTCMFG
CVTRSV31 EQU   CVTTCMFG
CVTRSV30 EQU   CVTTCMFG
CVTRSV29 EQU   CVTTCMFG
CVTRSV28 EQU   CVTTCMFG
CVTTCRDY EQU   CVTTCMFG
CVTGTFA  EQU   CVTGTF+1
CVTRSV27 EQU   CVTGTFST
CVTRNIO  EQU   CVTGTFST
CVTUSR   EQU   CVTGTFST
CVTRV318 EQU   CVTFORM
CVTRV317 EQU   CVTTMODE
CVTRV316 EQU   CVTSTATE
CVTRV315 EQU   CVTGTFS
CVTGTFAV EQU   CVTGTFS
CVT0SCR1 EQU   CVTMAP+232
CVTRV515 EQU   CVTMAP+228
CVTRMS   EQU   CVTMAP+224
CVTPATCH EQU   CVTMAP+220
CVTTSCE  EQU   CVTMAP+216
CVTLNKSC EQU   CVTMAP+214
CVTQABST EQU   CVTMAP+212
CVTMDLDS EQU   CVTMAP+208
CVTUSER  EQU   CVTMAP+204
CVTABEND EQU   CVTMAP+200
CVTSMCA  EQU   CVTMAP+196
CVTRSV18 EQU   CVTMAP+192
CVTQLPAQ EQU   CVTMAP+188
CVTQCDSR EQU   CVTMAP+184
CVTRSV17 EQU   CVTOPTB
CVTRSV16 EQU   CVTOPTB
CVTFP    EQU   CVTOPTB
CVTAPTHR EQU   CVTOPTB
CVTNLOG  EQU   CVTOPTB
CVTTOD   EQU   CVTOPTB
CVTCTIMS EQU   CVTOPTB
CVTPROT  EQU   CVTOPTB
CVTXPFP  EQU   CVTOPTA
CVTASCII EQU   CVTOPTA
CVTRSV13 EQU   CVTOPTA
CVTRSV12 EQU   CVTOPTA
CVTNIP   EQU   CVTOPTA
CVTDDR   EQU   CVTOPTA
CVTAPR   EQU   CVTOPTA
CVTCCH   EQU   CVTOPTA
CVTSNCTR EQU   CVTMAP+180
CVTQMWR  EQU   CVTMAP+176
CVTQOCR  EQU   CVTMAP+172
CVT1EF00 EQU   CVTMAP+168
CVTMZ00  EQU   CVTMAP+164
CVTSV76Q EQU   CVTSV76C
CVTRSV11 EQU   CVTMAP+156
CVT0PT01 EQU   CVTMAP+152
CVTMSER  EQU   CVTMAP+148
CVTRV516 EQU   CVTIERLC
CVTILCH  EQU   CVTMAP+140
CVT0DS   EQU   CVTMAP+136
CVTFBOSV EQU   CVTMAP+132
CVTNUCB  EQU   CVTMAP+128
CVTIXAVL EQU   CVTMAP+124
CVTSV76M EQU   CVTIOQET
CVTDCBA  EQU   CVTMAP+117
CVTMVS2  EQU   CVTDCB
CVT6DAT  EQU   CVTDCB
CVT4MPS  EQU   CVTDCB
CVTRSV09 EQU   CVTDCB
CVT4MS1  EQU   CVTDCB
CVT2SPS  EQU   CVTDCB
CVT1SSS  EQU   CVTDCB
CVTRSV08 EQU   CVTDCB
CVTSTB   EQU   CVTMAP+112
CVTQTD00 EQU   CVTMAP+108
CVTQTE00 EQU   CVTMAP+104
CVTCUCB  EQU   CVTMAP+100
CVTSJQ   EQU   CVTMAP+96
CVTPBLDL EQU   CVTMAP+92
CVTTPC   EQU   CVTMAP+88
CVTSVDCB EQU   CVTMAP+84
CVTBRET  EQU   CVTMAP+82
CVTEXIT  EQU   CVTMAP+80
CVT0FN00 EQU   CVTMAP+76
CVTDARA  EQU   CVTDAR+1
CVTRSV07 EQU   CVTFLGS1
CVTRSV06 EQU   CVTFLGS1
CVTRSV05 EQU   CVTFLGS1
CVTRSV04 EQU   CVTFLGS1
CVTRSV03 EQU   CVTFLGS1
CVTRSV02 EQU   CVTFLGS1
CVTRSV01 EQU   CVTFLGS1
CVTDMPLK EQU   CVTFLGS1
CVTXITP  EQU   CVTMAP+68
CVTZDTAB EQU   CVTMAP+64
CVTMSLT  EQU   CVTMAP+60
CVTDATE  EQU   CVTMAP+56
CVTBTERM EQU   CVTMAP+52
CVTSYSAD EQU   CVTMAP+48
CVTXTLER EQU   CVTMAP+44
CVTILK2  EQU   CVTMAP+40
CVTILK1  EQU   CVTMAP+36
CVTPRLTV EQU   CVTMAP+32
CVTPCNVT EQU   CVTMAP+28
CVT0VL00 EQU   CVTMAP+24
CVTXAPG  EQU   CVTMAP+20
CVTBUF   EQU   CVTMAP+16
CVTJOB   EQU   CVTMAP+12
CVTLINK  EQU   CVTMAP+8
CVT0EF00 EQU   CVTMAP+4
CVTTCBP  EQU   CVTMAP
CVT      EQU   CVTMAP
IOCOEND  EQU   IOCOM+128
IOCPATCH EQU   IOCOM+124
IOCUCBBM EQU   IOCOM+120
IOCQCNT  EQU   IOCOM+116
IOCIOSDQ EQU   IOCOM+112
IOCIOSEQ EQU   IOCOM+108
IOCSVCF  EQU   IOCOM+104
IOCTCCW  EQU   IOCOM+100
IOCRSVTB EQU   IOCOM+96
IOCMFCNT EQU   IOCOM+92
IOCMFHK  EQU   IOCOM+88
IOCGENA  EQU   IOCOM+84
IOCCCH   EQU   IOCOM+80
IOCASYNQ EQU   IOCOM+76
IOCLCHTB EQU   IOCOM+72
IOCATTBL EQU   IOCOM+68
IOCOMEX  EQU   IOCOM+64
IOCSYNCH EQU   IOCOM+56
IOCCATLK EQU   IOCOM+48
IOCPRGID EQU   IOCOM+44
IOCIOSCP EQU   IOCOM+40
IOCORMGT EQU   IOCOM+36
IOCVOID  EQU   IOCOM+32
IOCSTIO  EQU   IOCOM+28
@NM00006 EQU   IOCOM+24
@NM00005 EQU   IOCOM+20
IOCINT   EQU   IOCOM+16
IOCCTBL  EQU   IOCOM+12
IOCHIO   EQU   IOCOM+8
IOCPST   EQU   IOCOM+4
IOCPGCT  EQU   IOCOM+2
IOCVOICT EQU   IOCOM
UCBERADR EQU   UCBUCS+12
UCBFCBID EQU   UCBUCS+8
UCBERCNT EQU   UCBUCS+7
UCBRSV51 EQU   UCBUCS+6
UCBRSV50 EQU   UCBFCBOP
UCBRSV49 EQU   UCBFCBOP
UCBRSV48 EQU   UCBFCBOP
UCBRSV47 EQU   UCBFCBOP
UCBRSV46 EQU   UCBFCBOP
UCBRSV45 EQU   UCBFCBOP
UCBRSV44 EQU   UCBFCBOP
UCBFCBO1 EQU   UCBFCBOP
UCBUCSPE EQU   UCBUCSOP
UCBRSV43 EQU   UCBUCSOP
UCBRSV42 EQU   UCBUCSOP
UCBRSV41 EQU   UCBUCSOP
UCBRSV40 EQU   UCBUCSOP
UCBRSV39 EQU   UCBUCSOP
UCBUCSO2 EQU   UCBUCSOP
UCBUCSO1 EQU   UCBUCSOP
UCBUCSID EQU   UCBUCS
UCBMDRBA EQU   UCBMDRBF+1
UCBRV075 EQU   UCBMDRBF
UCBRV074 EQU   UCB3800X+32
UCBIMAGE EQU   UCB3800X+28
UCBFCBNM EQU   UCB3800X+24
UCBCHAR4 EQU   UCB3800X+20
UCBCHAR3 EQU   UCB3800X+16
UCBCHAR2 EQU   UCB3800X+12
UCBCHAR1 EQU   UCB3800X+8
UCBCGMID EQU   UCB3800X+4
UCBBRSTA EQU   UCBACTIV
UCBRV063 EQU   UCBACTIV
UCBRV062 EQU   UCBACTIV
UCBRV061 EQU   UCBACTIV
UCBRV060 EQU   UCBACTIV
UCBRV059 EQU   UCBACTIV
UCBRV058 EQU   UCBACTIV
UCBRV057 EQU   UCBACTIV
UCBRV050 EQU   UCB3800X+2
UCBCGMNO EQU   UCB3800X+1
UCBRV083 EQU   UCBOPTNS
UCBBRSTR EQU   UCBOPTNS
UCBRV056 EQU   UCBOPTNS
UCBRV055 EQU   UCBOPTNS
UCBRV054 EQU   UCBOPTNS
UCBRV053 EQU   UCBOPTNS
UCBRV052 EQU   UCBOPTNS
UCBRV051 EQU   UCBOPTNS
UCBRV073 EQU   UCB3540X+7
UCBRV072 EQU   UCBDKBYT
UCBRV071 EQU   UCBDKBYT
UCBRV070 EQU   UCBDKBYT
UCBRV069 EQU   UCBDKBYT
UCBRV068 EQU   UCBDKBYT
UCBRV067 EQU   UCBDKBYT
UCBVLVER EQU   UCBDKBYT
UCBDKAMX EQU   UCBDKBYT
UCBVLSER EQU   UCB3540X
UCBRDATA EQU   UCBOCR+4
UCBFRID  EQU   UCBOCR
UCBCLN   EQU   UCBMT+14
UCBERG   EQU   UCBMT+12
UCBMS    EQU   UCBMT+11
UCBNB    EQU   UCBMT+10
UCBPW    EQU   UCBMT+9
UCBPR    EQU   UCBMT+8
UCBSIO   EQU   UCBMT+6
UCBTW    EQU   UCBMT+5
UCBTR    EQU   UCBMT+4
UCBTWT   EQU   UCBMT+3
UCBTRT   EQU   UCBMT+2
UCBCTD   EQU   UCBMT
UCBWTOID EQU   UCBCMEXT+17
UCBRV043 EQU   UCBCMEXT+16
UCBASID  EQU   UCBCMEXT+14
UCBMFCNT EQU   UCBCMEXT+12
UCBPMSK  EQU   UCBCMEXT+10
UCBCCWOF EQU   UCBCMEXT+8
UCBRV041 EQU   UCBCMEXT+6
UCBRV036 EQU   UCBFLP1
UCBRV035 EQU   UCBFLP1
UCBERLOG EQU   UCBFLP1
UCBRV033 EQU   UCBFLP1
UCBINHIO EQU   UCBFLP1
UCBNSWAP EQU   UCBFLP1
UCBSHRUP EQU   UCBFLP1
UCBNSRCH EQU   UCBFLP1
UCBSNSCT EQU   UCBCMEXT+4
UCBHPDV  EQU   @NM00004
UCBHALI  EQU   @NM00004
UCBRSV09 EQU   @NM00004
UCBRSV08 EQU   @NM00004
UCBRSV07 EQU   @NM00004
UCBRSV06 EQU   @NM00004
UCBRSV05 EQU   @NM00004
UCBRSV04 EQU   @NM00004
UCBDTI   EQU   UCBCMEXT+2
UCBSTI   EQU   UCBCMEXT+1
UCBETI   EQU   UCBCMEXT
UCBEXTP  EQU   UCBEXTPT+1
UCBDDRSW EQU   UCBFLC
UCBTICBT EQU   UCBFLC
UCBIVRR  EQU   UCBFLC
UCBIVRS  EQU   UCBFLC
UCBITF   EQU   UCBFLC
UCBUDE   EQU   UCBFLC
UCBWAA   EQU   UCBFLC
UCBATTP  EQU   UCBFLC
UCBUNTYP EQU   UCBTBYT4
UCBRSV11 EQU   UCBDVCLS
UCBRSV10 EQU   UCBDVCLS
UCB3CHAR EQU   UCBDVCLS
UCB3UREC EQU   UCBDVCLS
UCB3DISP EQU   UCBDVCLS
UCB3COMM EQU   UCBDVCLS
UCB3TAPE EQU   UCBDVCLS
UCBDVPWR EQU   UCB2OPT7
UCBVLPWR EQU   UCB2OPT6
UCB2OPT5 EQU   UCBTBYT2
UCBRPS   EQU   UCBDUDN2
UCBRR    EQU   UCBDUDN1
UCB2OPT1 EQU   UCBTBYT2
UCB2OPT0 EQU   UCBTBYT2
UCB1FEA7 EQU   UCBTBYT1
UCBD6250 EQU   UCB1FEA6
UCBD1600 EQU   UCB1FEA5
UCB1FEA4 EQU   UCBTBYT1
UCB1FEA3 EQU   UCBTBYT1
UCB1FEA2 EQU   UCBTBYT1
UCB1FEA1 EQU   UCBTBYT1
UCB1FEA0 EQU   UCBTBYT1
UCBNAME  EQU   UCBOB+13
UCBRV029 EQU   UCBWGT
UCBVHRSN EQU   UCBWGT
UCBVORSN EQU   UCBWGT
UCBMTPXP EQU   UCBWGT
UCBREW   EQU   UCBWGT
UCBPUB   EQU   UCBWGT
UCBOUT   EQU   UCBWGT
UCBIN    EQU   UCBWGT
UCBCPU   EQU   UCBOB+11
UCBLCI   EQU   UCBOB+10
UCBCNT   EQU   UCBOB+9
UCBRV017 EQU   UCBCHM1
UCBRV016 EQU   UCBCHM1
UCBRV015 EQU   UCBCHM1
UCBRV014 EQU   UCBCHM1
UCBSPB   EQU   UCBPTH1
UCBPPB   EQU   UCBPTH1
UCBSPA   EQU   UCBPTH0
UCBPPA   EQU   UCBPTH0
UCBSIGP  EQU   UCBFLB
UCBVALPH EQU   UCBFLB
UCBCRHSN EQU   UCBFLB
UCBCRHRV EQU   UCBFLB
UCBRESVH EQU   UCBFLB
UCBSPST  EQU   UCBFLB
UCBASNS  EQU   UCBFLB
UCBIORST EQU   UCBFLB
UCBQISCE EQU   UCBFL1
UCBACTV  EQU   UCBFL1
UCBSAP   EQU   UCBFL1
UCBNOTRC EQU   UCBCUB
UCBPSNS  EQU   UCBFL1
UCBUSING EQU   UCBPST
UCBNOTRD EQU   UCBNRY
UCBBUSYD EQU   UCBBSY
UCBUA    EQU   UCBCHAN+1
UCBDADI  EQU   UCBSTAT
UCBSYSR  EQU   UCBSTAT
UCBPRES  EQU   UCBSTAT
UCBALOC  EQU   UCBSTAT
UCBUNLD  EQU   UCBSTAT
UCBRESV  EQU   UCBSTAT
UCBCHGS  EQU   UCBSTAT
UCBONLI  EQU   UCBSTAT
UCBID    EQU   UCBOB+2
UCBALTPH EQU   UCBFL5
UCBALTCU EQU   UCBFL5
UCBNALOC EQU   UCBFL5
UCBENVRD EQU   UCBFL5
UCBVSDR  EQU   UCBFL5
UCBSASK  EQU   UCBFL5
UCBAMV   EQU   UCBAF
UCBDCC   EQU   UCBFL5
UCBMONT  EQU   UCBJBNR
UCBRV011 EQU   UCBJBNR
UCBMMSGP EQU   UCBJBNR
UCBOLDSM EQU   UCBJBNR
UCBRV003 EQU   UCBJBNR
UCBDUC   EQU   UCBJBNR
UCBJES3  EQU   UCBJBNR
UCBVRDEV EQU   UCBJBNR
UCBCMSEG EQU   UCBOB
UCBPFXND EQU   UCB+512
UCBIOQ   EQU   UCB+508
UCBLOCK  EQU   UCB+504
UCBPXST  EQU   UCB+504
@NM00001 EQU   UCB
@NM00032 EQU   PSA+3668
PSASTAK  EQU   PSA+3072
@NM00031 EQU   PSA+1048
PSAUSEND EQU   PSA+1048
PSARV062 EQU   PSA+1044
PSACDAL  EQU   PSA+1040
PSAWTCOD EQU   PSA+1036
PSAATCVT EQU   PSA+1032
PSAPCPSW EQU   PSA+1024
PSAPIR2  EQU   PSA+1020
PSARV059 EQU   PSA+1018
PSASVC13 EQU   PSA+1016
PSALSFCC EQU   PSA+1012
PSASFACC EQU   PSA+1008
PSASTOP  EQU   PSA+992
PSASTART EQU   PSA+976
PSARSPSW EQU   PSA+968
PSASRPSW EQU   PSA+960
PSARV045 EQU   PSA+892
PSARV044 EQU   PSA+888
PSARV043 EQU   PSA+884
PSARV042 EQU   PSA+880
PSARV041 EQU   PSA+876
PSARV040 EQU   PSA+872
PSARV025 EQU   PSA+868
PSADSSED EQU   PSA+868
PSADSSPR EQU   PSA+864
PSADSSFW EQU   PSA+860
PSADSS14 EQU   PSA+856
PSADSSPP EQU   PSA+848
PSADSSRP EQU   PSA+840
PSADSS05 EQU   PSADSSF4
PSADSS10 EQU   PSADSSF4
PSADSSVE EQU   PSADSSF4
PSADSSDE EQU   PSADSSF4
PSADSSC0 EQU   PSADSSF4
PSADSSIE EQU   PSADSSF4
PSADSS12 EQU   PSADSSF4
PSADSSRC EQU   PSADSSF4
PSARV057 EQU   PSADSSF3
PSARV056 EQU   PSADSSF3
PSARV055 EQU   PSADSSF3
PSADSSMC EQU   PSADSSF3
PSADSSRW EQU   PSADSSF3
PSADSSNM EQU   PSADSSF3
PSADSSES EQU   PSADSSF3
PSADSSGP EQU   PSADSSF3
PSADSSF2 EQU   PSADSSFL+1
PSADSSPI EQU   PSADSSF1
PSADSSOI EQU   PSADSSF1
PSADSSSP EQU   PSADSSF1
PSADSSTP EQU   PSADSSF1
PSADSSDW EQU   PSADSSF1
PSADSSDD EQU   PSADSSF1
PSADSSDM EQU   PSADSSF1
PSADSSMV EQU   PSADSSF1
PSADSSTS EQU   PSA+816
PSADSSWK EQU   PSA+812
PSADSSR3 EQU   PSA+808
PSADSSR2 EQU   PSA+804
PSADSSRS EQU   PSA+800
PSASTOR  EQU   PSA+796
PSACPUSA EQU   PSA+794
PSAVSTAP EQU   PSA+792
PSAWKVAP EQU   PSA+788
PSAWKRAP EQU   PSA+784
PSAMCHIC EQU   PSA+783
PSARV061 EQU   PSA+782
PSASYMSK EQU   PSA+781
PSAMCHFL EQU   PSA+780
PSACR0   EQU   PSA+776
PSAPSWSV EQU   PSA+768
PSALITA  EQU   PSA+764
PSACLHS  EQU   PSAHLHI
PSALKR15 EQU   PSALKSA+60
PSALKR14 EQU   PSALKSA+56
PSALKR13 EQU   PSALKSA+52
PSALKR12 EQU   PSALKSA+48
PSALKR11 EQU   PSALKSA+44
PSALKR10 EQU   PSALKSA+40
PSALKR9  EQU   PSALKSA+36
PSALKR8  EQU   PSALKSA+32
PSALKR7  EQU   PSALKSA+28
PSALKR6  EQU   PSALKSA+24
PSALKR5  EQU   PSALKSA+20
PSALKR4  EQU   PSALKSA+16
PSALKR3  EQU   PSALKSA+12
PSALKR2  EQU   PSALKSA+8
PSALKR1  EQU   PSALKSA+4
PSALKR0  EQU   PSALKSA
PSARV023 EQU   PSACLHT+52
PSALOCAL EQU   PSACLHT+48
PSACMSL  EQU   PSACLHT+44
PSAOPTL  EQU   PSACLHT+40
PSATPACL EQU   PSACLHT+36
PSATPDNL EQU   PSACLHT+32
PSATPNCL EQU   PSACLHT+28
PSAIOSLL EQU   PSACLHT+24
PSAIOSUL EQU   PSACLHT+20
PSAIOSCL EQU   PSACLHT+16
PSAIOSSL EQU   PSACLHT+12
PSASALCL EQU   PSACLHT+8
PSAASML  EQU   PSACLHT+4
PSADISPL EQU   PSACLHT
PSASRSA  EQU   PSA+636
PSARV050 EQU   PSA+634
PSADSSGO EQU   PSA+633
PSARECUR EQU   PSA+632
PSAHLHIS EQU   PSA+628
PSAIPCSA EQU   PSA+624
@NM00030 EQU   PSA+621
PSAIPCDM EQU   PSA+620
PSAIPCD  EQU   PSA+616
@NM00029 EQU   PSA+613
PSAIPCRM EQU   PSA+612
PSAIPCR  EQU   PSA+608
PSAMCHEX EQU   PSA+600
PSAMPSW  EQU   PSA+592
PSAEXPS2 EQU   PSA+584
PSAEXPS1 EQU   PSA+576
PSAPIREG EQU   PSA+572
PSARSREG EQU   PSA+568
PSAGPREG EQU   PSA+556
PSARV022 EQU   PSASUP4
PSARV021 EQU   PSASUP4
PSARV020 EQU   PSASUP4
PSARV019 EQU   PSASUP4
PSARV018 EQU   PSASUP4
PSARV017 EQU   PSASUP4
PSARV016 EQU   PSASUP4
PSARV015 EQU   PSASUP4
PSARV014 EQU   PSASUP3
PSARV013 EQU   PSASUP3
PSARV012 EQU   PSASUP3
PSAESTA  EQU   PSASUP3
PSASPR   EQU   PSASUP3
PSAPSREG EQU   PSASUP3
PSAPI2   EQU   PSASUP3
PSAIOSUP EQU   PSASUP3
PSALCR   EQU   PSASUP2
PSARTM   EQU   PSASUP2
PSAACR   EQU   PSASUP2
PSAIPCE2 EQU   PSASUP2
PSAIPCES EQU   PSASUP2
PSAIPCEC EQU   PSASUP2
PSAGTF   EQU   PSASUP2
PSAIPCRI EQU   PSASUP2
PSATYPE6 EQU   PSASUP1
PSATCTL  EQU   PSASUP1
PSADISP  EQU   PSASUP1
PSALOCK  EQU   PSASUP1
PSAPI    EQU   PSASUP1
PSAEXT   EQU   PSASUP1
PSASVC   EQU   PSASUP1
PSAIO    EQU   PSASUP1
PSAAOLD  EQU   PSA+548
PSAANEW  EQU   PSA+544
PSATOLD  EQU   PSA+540
PSATNEW  EQU   PSA+536
PSALCCAR EQU   PSA+532
PSALCCAV EQU   PSA+528
PSAPCCAR EQU   PSA+524
PSAPCCAV EQU   PSA+520
PSACPULA EQU   PSA+518
PSACPUPA EQU   PSA+516
PSAPSA   EQU   PSA+512
FLCHDEND EQU   PSA+512
FLCCRSAV EQU   FLCMCLA+280
FLCGRSAV EQU   FLCMCLA+216
FLCFPSAV EQU   FLCMCLA+184
FLCFLA   EQU   FLCMCLA+88
FLCRGNCD EQU   FLCMCLA+84
FLCFSAA  EQU   FLCFSA+1
@NM00028 EQU   FLCFSA
@NM00027 EQU   FLCMCLA+72
FLCMCIC  EQU   FLCMCLA+64
@NM00026 EQU   FLCMCLA+20
@NM00025 EQU   FLCIOA
@NM00024 EQU   FLCMCLA+15
@NM00023 EQU   FLCMCLA+14
@NM00022 EQU   FLCMCLA+12
FLCLCL   EQU   FLCMCLA+8
FLCIOELA EQU   FLCIOEL+1
@NM00021 EQU   FLCIOEL
FLCCHNID EQU   FLCMCLA
@NM00020 EQU   PSA+160
FLCMTRCD EQU   PSA+157
@NM00019 EQU   PSA+156
FLCPERA  EQU   FLCPER+1
@NM00018 EQU   FLCPER
@NM00017 EQU   PSA+151
FLCPERCD EQU   PSA+150
FLCMCNUM EQU   PSA+149
@NM00016 EQU   PSA+148
FLCTEAA  EQU   FLCTEA+1
@NM00015 EQU   FLCTEA
PSAPIPC  EQU   PSAPICOD
PSAPIMC  EQU   PSAPICOD
PSAPIPER EQU   PSAPICOD
PSARV049 EQU   FLCPICOD
FLCPILCB EQU   FLCPIILC
@NM00014 EQU   FLCPIILC
@NM00013 EQU   PSAEPPSW
FLCSVCN  EQU   PSAESPSW+2
FLCSILCB EQU   FLCSVILC
@NM00012 EQU   FLCSVILC
@NM00011 EQU   PSAESPSW
FLCEICOD EQU   PSAEEPSW+2
PSASPAD  EQU   PSAEEPSW
@NM00010 EQU   PSA+128
FLCMNPSW EQU   PSA+112
FLCPNPSW EQU   PSA+104
FLCSNPSW EQU   PSA+96
FLCENPSW EQU   PSA+88
FLCTRACE EQU   PSA+84
FLCTIMER EQU   PSA+80
FLCCVT2  EQU   PSA+76
FLCCAW   EQU   PSA+72
FLCMOPSW EQU   PSA+48
FLCPOPSW EQU   PSA+40
FLCSOPSW EQU   PSA+32
FLCEOPSW EQU   PSA+24
@NM00009 EQU   FLCICCW2+4
FLCCVT   EQU   FLCICCW2
FLCICCW1 EQU   FLCROPSW
FLCIPPSW EQU   FLCRNPSW
*                                      END UNREFERENCED COMPONENTS
@RC00120 EQU   @RC00119
@RF00126 EQU   @RC00117
@RF00129 EQU   @RC00117
@ENDDATA EQU   *
         END   ICBTMSS0,(C'PLS2038',0603,77167)
