* %/*  START OF SPECIFICATIONS****                             @Y30LB02
.*                                                             @Y30LB02
.*01   MODULE-NAME = ICBVARY                                   @Y30LB02
.*                                                             @Y30LB02
.*01   DESCRIPTIVE-NAME = VARYON/VARYOFF MACRO                 @Y30LB02
.*                                                             @Y30LB02
.*01   COPYRIGHT = NONE                                        @Y30LB02
.*                                                             @Y30LB02
.*01   STATUS = OS/VS1 RELEASE 4, OS/VS2 RELEASE 3             @Y30LB02
.*                                                             @Y30LB02
.*01   FUNCTION = REQUEST VARYON/VARYOFF OF SS1 DEVICES        @Y30LB02
.*                BY THE MSC                                   @Y30LB02
.*                                                             @Y30LB02
.*01   NOTES = AS FOLLOWS:                                     @Y30LB02
.*                                                             @Y30LB02
.*02     CODE = MACRO IS BILINGUALLY CODED                     @Y30LB02
.*                                                             @Y30LB02
.*02     RESTRICTIONS = THE FOLLOWING PREFIXES SHOULD BE       @Y30LB02
.*                      AVOIDED IN THE USER'S INVOCATION:      @Y30LB02
.*                      ICB, VON, AND VOF.                     @Y30LB02
.*                                                             @Y30LB02
.*02   REGISTER-CONVENTIONS = FOLLOWS NORMAL USE OF REGISTERS  @Y30LB02
.*                              BY MACROS: R0,R1,R14, AND R15  @Y30LB02
.*                                                             @Y30LB02
.*01   MODULE-TYPE = MACRO                                     @Y30LB02
.*                                                             @Y30LB02
.*02     PROCESSOR = PLS2 AND ASSEMBLER                        @Y30LB02
.*                                                             @Y30LB02
.*02     ATTRIBUTES = REUSABLE                                 @Y30LB02
.*                                                             @Y30LB02
.*02     ENTRY-POINT = ICBVARY                                 @Y30LB02
.*                                                             @Y30LB02
.*02     PURPOSE = THE VARY ON REQUEST NOTIFIES THE MSS        @Y30LB02
.*       THAT IT CAN START USING  A SPECIFIED ADDRESSABLE      @Y30LB02
.*       UNIT; THE VARY OFF REQUEST NOTIFIES THE MSS TO        @Y30LB02
.*       STOP USING A SPECIFIED ADDRESSABLE UNIT (E.G.         @Y30LB02
.*       MSF, DRD, DASD UNIT).                                 @Y30LB02
.*                                                             @Y30LB02
.*02     LINKAGE = SVC 126                                     @Y30LB02
.*                                                             @Y30LB02
.*01  INPUT = PARAMETERS SPECIFIED ON THE PLS/BAL MACRO        @Y30LB02
.*            INVOCATION                                       @Y30LB02
.*                                                             @Y30LB02
.* VARY-ON:  THIS REQUEST IS ISSUED WHEN                       @Y30LB02
.*  A UNIT PREVIOUSLY ADDRESSABLE TO THE MSC                   @Y30LB02
.*  IS AVAILABLE FOR USE.  THE UNIT SPECIFIED MAY BE           @Y30LB02
.*  EITHER A  SUBSYSTEM DASD, DRD, CONTROLLER, STAGING         @Y30LB02
.*  ADAPTER(SA), MSF OR UC0 OF A MSF.                          @Y30LB02
.*  VARY-ON COMPLETION IS INDICATED BY DEVICE END.             @Y30LB02
.*                                                             @Y30LB02
.*                                                             @Y30LB02
.* VARY-OFF:  THIS REQUEST IS ISSUED WHEN THE                  @Y30LB02
.*  MSC IS TO STOP USING A  SPECIFIC UNIT.  THE UNIT           @Y30LB02
.*  SPECIFIED MAY BE EITHER A SUBSYSTEM DASD, DRD,             @Y30LB02
.*  CONTROLLER, STAGING ADAPTER(SA), MSF OR UC0 OF A           @Y30LB02
.*  MSF.  VARY-OFF COMPLETION IS INDICATED BY DEVICE           @Y30LB02
.*  END, EXCEPT FOR A DASD WITH THE STAGING DASD ATTRIBUTE.    @Y30LB02
.*                                                             @Y30LB02
.* MACRO SYNTAX                                                @Y30LB02
.*   LIST FORM                                                 @Y30LB02
.*                                                             @Y30LB02
.* VERB    REQUIRED PARMS        OPTIONAL PARMS                @Y30LB02
.*                                                             @Y30LB02
.*ICBVARY  MF=L - (BAL)          MF=(L,MAP) - BAL              @Y30LB02
.*         MF(L,NAME/(R))-PLS    MF(L,NAME/(R),ATTR)-PLS       @Y30LB02
.*         TYPE=VON/VOF                                        @Y30LB02
.*                                                             @Y30LB02
.*   STANDARD FORM                                             @Y30LB02
.*                                                             @Y30LB02
.* VERB    REQUIRED PARMS        OPTIONAL PARMS                @Y30LB02
.*                                                             @Y30LB02
.*ICBVARY  TYPE=VON/VOF          ECB=ADDR/(R)                  @Y30LB02
.*         SSID=ADDR/(R)         FLAGS=ADDR/(R)                @Y30LB02
.*                               RUA=ADDR/(R)                  @Y30LB02
.*                                                             @Y30LB02
.* EXECUTE FORM                                                @Y30LB02
.*                                                             @Y30LB02
.* VERB    REQUIRED PARMS        OPTIONAL PARMS                @Y30LB02
.*                                                             @Y30LB02
.*ICBVARY  MF(E,NAME/(R))       MF(E,NAME/(R),COMPLETE)-PLS    @Y30LB02
.*         TYPE=VON/VOF         SSID=ADDR/(R)                  @Y30LB02
.*                              ECB=ADDR/(R)                   @Y30LB02
.*                              RUA=ADDR/(R)                   @Y30LB02
.*                              FLAGS=ADDR/(R)                 @Y30LB02
.*                                                             @Y30LB02
.*   KEYWORD PARAMETERS:                                       @Y30LB02
.*                                                             @Y30LB02
.*   MF  -  MACRO FORMAT: THIS PARAMETER DESCRIBES THE         @Y30LB02
.*          MACRO FORMAT AND MAY GIVE THE ADDRESS OR           @Y30LB02
.*          ADDRESS IN A REGISTER WHERE THE REQUEST BLOCK      @Y30LB02
.*          IS STORED.                                         @Y30LB02
.*                                                             @Y30LB02
.*          L - LIST FORM: THE EXPANSION OF THE L-FORM         @Y30LB02
.*              MACRO WILL RESULT IN A REQUEST BLOCK WITH      @Y30LB02
.*              THE ONLY NON-ZERO FIELDS BEING THE OPCODE      @Y30LB02
.*              AND LENGTH FIELDS.                             @Y30LB02
.*                                                             @Y30LB02
.*          (1) 'MAP' - IF MAP IS SPECIFIED WITH THE           @Y30LB02
.*              ASSEMBLER MACRO CALL A DSECT EQUIVALENT TO     @Y30LB02
.*              A MAPPING MACRO IS PRODUCED.                   @Y30LB02
.*                                                             @Y30LB02
.*          (2) NAME - THE MACRO INVOKER MUST SPECIFY A        @Y30LB02
.*              NAME FOR HIS STRUCTURE WHEN INVOKING THE       @Y30LB02
.*              PLS LIST FORM.                                 @Y30LB02
.*                                                             @Y30LB02
.*          (3) ATTRIBUTE - THE MACRO WILL PLACE ANY PLS       @Y30LB02
.*              ATTRIBUTE SPECIFIED IN THE MACRO INVOCATION    @Y30LB02
.*              IN AN UNINITIALIZED REQUEST BLOCK.  ATTRI-     @Y30LB02
.*              BUTE EXAMPLE:                                  @Y30LB02
.*                                                             @Y30LB02
.*              CHAR, FIXED, STATIC LOCAL, NONLOCAL,           @Y30LB02
.*              BASED(*), ETC.                                 @Y30LB02
.*                                                             @Y30LB02
.*       NULL - STANDARD FORM: THE EXPANSION OF THIS FORM      @Y30LB02
.*              CONSISTS OF A REQUEST BLOCK, A LINKAGE         @Y30LB02
.*              INSTRUCTION, AND, POSSIBLY, PARAMETER          @Y30LB02
.*              BINDING INSTRUCTION.                           @Y30LB02
.*                                                             @Y30LB02
.*          E - EXECUTABLE FORM: THE EXPANSION OF THIS FORM    @Y30LB02
.*              CONSISTS OF A LINKAGE INSTRUCTION AND          @Y30LB02
.*              POSSIBLY, PARAMETER BINDING INSTRUCTIONS.      @Y30LB02
.*                                                             @Y30LB02
.*              SUB-PARAMETERS                                 @Y30LB02
.*                                                             @Y30LB02
.*              (1)  AN E MUST BE SPECIFIED IN THE FIRST       @Y30LB02
.*                   SUB-PARAMETER POSITION.  THIS INDICATES   @Y30LB02
.*                   THAT THE MACRO IS IN EXECUTABLE FORM.     @Y30LB02
.*                                                             @Y30LB02
.*              (2)  A NAME OR A REGISTER MUST BE SPECIFIED    @Y30LB02
.*                   IN THE SECOND SUB-PARAMETER.              @Y30LB02
.*                                                             @Y30LB02
.*              (3)  'COMPLETE' - COMPLETE WILL CAUSE THE      @Y30LB02
.*                   MACRO TO ZERO OUT THE REQUEST BLOCK.      @Y30LB02
.*                   AFTER ZEROING THE REQUEST BLOCK THE       @Y30LB02
.*                   FUNCTION OPCODE AND LENGTH ARE PLACED     @Y30LB02
.*                   IN THE REQUEST BLOCK.                     @Y30LB02
.*                                                             @Y30LB02
.*                                                             @Y30LB02
.* TYPE- INDICATES WHETHER THE REQUEST IS FOR THE              @Y30LB02
.*       VARY-ON (VON) OR VARY-OFF (VOF) COMMAND.              @Y30LB02
.*                                                             @Y30LB02
.* FLAGS -  THE TWO BYTE FIELD WHICH INDICATES THE             @Y30LB02
.*  FUNCTION(S) TO BE PERFORMED.  THE FLAGS FIELD IS ONLY      @Y30LB02
.*  VALID IF THE REQUEST IS FOR SUBSYSTEM DASD.                @Y30LB02
.*  IF A SUBSYSTEM'S STAGING DEVICE IS REQUESTED, THEN         @Y30LB02
.*  ONE AND ONLY ONE FLAG BIT MUST BE SET TO '1'B.             @Y30LB02
.*                                                             @Y30LB02
.*       -------------------------------------------------     @Y30LB02
.*       | X | X | X | X |OTHER BITS MUST BE SET TO ZERO |     @Y30LB02
.*       -------------------------------------------------     @Y30LB02
.*                                                             @Y30LB02
.*       BIT 0------------'1'B     STAGING DASD                @Y30LB02
.*                         '0'B    NO FUNCTION                 @Y30LB02
.*                                                             @Y30LB02
.*       BIT 1------------'1'B     REAL DASD                   @Y30LB02
.*                         '0'B    NO FUNCTION                 @Y30LB02
.*                                                             @Y30LB02
.*       BIT 2------------'1'B     NEUTRAL DASD                @Y30LB02
.*                         '0'B    NO FUNCTION                 @Y30LB02
.*                                                             @Y30LB02
.*       BIT 3------------'1'B     TEST DASD                   @Y30LB02
.*                         '0'B    NO FUNCTION                 @Y30LB02
.*                                                             @Y30LB02
.*       BITS 4-15--------         |RESERVED AND MUST BE       @Y30LB02
.*                                  ZERO|                      @Y30LB02
.*                                                             @Y30LB02
.*  STAGING DASD                                               @Y30LB02
.*                                                             @Y30LB02
.*   VARY-ON:  THE SPECIFIED SUBSYSTEM DASD IS MADE            @Y30LB02
.*   AVAILABLE FOR STAGING SPACE.  THE SSID PARAMETER          @Y30LB02
.*   MUST BE SPECIFIED.                                        @Y30LB02
.*                                                             @Y30LB02
.*  VARY-OFF:  THE SPECIFIED SUBSYSTEM DASD IS MADE            @Y30LB02
.*   UNAVAILABLE FOR STAGING SPACE.  THE CALLER MUST           @Y30LB02
.*   SPECIFY THE  ECB PARAMETER IN ORDER TO RECEIVE COMPLE-    @Y30LB02
.*   TION NOTIFICATION OF NECESSARY DESTAGING.                 @Y30LB02
.*   BOTH THE SSID AND ECB PARAMETERS MUST BE                  @Y30LB02
.*   SPECIFIED.                                                @Y30LB02
.*                                                             @Y30LB02
.*  REAL                                                       @Y30LB02
.*                                                             @Y30LB02
.*  VARY-ON:  USE OF THIS ATTRIBUTE CAUSES                     @Y30LB02
.*   THE SSID SPECIFIED TO BECOME A REAL DASD                  @Y30LB02
.*   UNTIL VARIED OFF.                                         @Y30LB02
.*                                                             @Y30LB02
.*  VARY-OFF: APPLIES ONLY TO DASD WHICH HAVE BEEN             @Y30LB02
.*   PREVIOUSLY VARIED ON WITH THE REAL ATTRIBUTE.             @Y30LB02
.*   THE SPINDLE WILL NO LONGER BE DESIGNATED AS REAL.         @Y30LB02
.*                                                             @Y30LB02
.*   NEUTRAL                                                   @Y30LB02
.*                                                             @Y30LB02
.*  VARY-OFF: THIS ATTRIBUTE APPLIES TO SUBSYSTEM              @Y30LB02
.*   DASD VARIED ON WITH THE STAGING SUBSYSTEM                 @Y30LB02
.*   DASD ATTRIBUTE.  THE SPECIFIED DASD IS MARKED             @Y30LB02
.*   UNAVAILABLE FOR THE MSC AFTER CURRENT STAGE/              @Y30LB02
.*   DESTAGE ACTIVITY IS COMPLETE.                             @Y30LB02
.*   A VARYON WITH THE STAGING DASD ATTRIBUTE                  @Y30LB02
.*   NULLIFIES THE NEUTRAL STATE.                              @Y30LB02
.*                                                             @Y30LB02
.*  TEST                                                       @Y30LB02
.*                                                             @Y30LB02
.*  VARY-OFF: FOR USE BY OLTEP.                                @Y30LB02
.*   THE RUA PARAMETER IS REQUIRED.                            @Y30LB02
.*   THE HOSTID WILL BE INSERTED BY THE MSSC-SVC.              @Y30LB02
.*   THE PATH INDICATED BY THE RUA (MAY BE                     @Y30LB02
.*   EITHER A VIRTUAL 3330 UCB OR A REAL 3330                  @Y30LB02
.*   UCB) WILL BE DESIGNATED REAL FOR OLTEP'S USE.             @Y30LB02
.*                                                             @Y30LB02
.*                                                             @Y30LB02
.* SSID  - SUB-SYSTEM IDENTIFICATION:  A UNIQUE NUMBER         @Y30LB02
.*  WHICH APPEARS EXTERNALLY ON EACH  UNIT                     @Y30LB02
.*  IN THE SUBSYSTEM. THE SSID PARAMETER MUST                  @Y30LB02
.*  BE SPECIFIED WITH EACH VARY REQUEST.                       @Y30LB02
.*                                                             @Y30LB02
.* RUA  -   THE UNIT (UCB) TO BE USED BY OLTEP.                @Y30LB02
.*                                                             @Y30LB02
.* ECB - THE NAME OF THE EVENT CONTROL BLOCK;                  @Y30LB02
.*  THE CALLER WILL BE NOTIFIED WHEN THE VARY OFF              @Y30LB02
.*  PROCESS HAS COMPLETED.  THE ECB PARAMETER IS REQUIRED      @Y30LB02
.*  ONLY IF THE STAGING DASD ATTRIBUTE IS SPECIFIED            @Y30LB02
.*  WITH A VARYOFF REQUEST OF A SUBSYSTEM                      @Y30LB02
.*  DASD UNIT.  THE ECB IS POSTED WITH A POST CODE             @Y30LB02
.*  OF 71, 72, 73, 74, ETC.. THE POST CODE WILL  BE            @Y30LB02
.*  PLACED IN THE LOW-ORDER BYTE OF THE ECB - '7F'X            @Y30LB02
.*  INDICATES SUCCESSFUL COMPLETION.  THE ECB AREA MUST        @Y30LB02
.*  BE CLEARED(SET TO BINARY 0) BEFORE INVOKING THE MACRO.     @Y30LB02
.*                                                             @Y30LB02
.*01  EXIT-NORMAL = VALID INVOCATION                           @Y30LB02
.*                                                             @Y30LB02
.*02     CONDITION = RETURN CODE = 0                           @Y30LB02
.*                                                             @Y30LB02
.*02     OUTPUT = IN-LINE PLS/BAL STATEMENTS THAT PERFORM      @Y30LB02
.*                THE REQUESTED FUNCTION                       @Y30LB02
.*                                                             @Y30LB02
.*01  EXIT-ERROR = INVALID INVOCATION                          @Y30LB02
.*                                                             @Y30LB02
.*02     CONDITION = RETURN CODE = 12                          @Y30LB02
.*                                                             @Y30LB02
.*02     OUTPUT = ERROR MESSAGE AS A COMMENT AT POINT OF       @Y30LB02
.*                INVOCATION                                   @Y30LB02
.*                                                             @Y30LB02
.*01  EXTERNAL REFERENCES = NONE                               @Y30LB02
.*                                                             @Y30LB02
.*01  TABLES = NONE                                            @Y30LB02
.*                                                             @Y30LB02
.*01  MESSAGES = AS FOLLOWS:                                   @Y30LB02
.*     ICB600I:  TYPE MUST BE SPECIFIED                        @Y30LB02
.*     ICB601I:  TYPE IS INCORRECTLY SPECIFIED                 @Y30LB02
.*     ICB602I:  A NAME FOR THE REQUEST BLOCK MUST BE          @Y30LB02
.*               SPECIFIED IN MF(2)                            @Y30LB02
.*     ICB603I:  WARNING-ONLY MF AND TYPE PARAMETERS ARE       @Y30LB02
.*               VALID FOR LIST FORM                           @Y30LB02
.*     ICB612I:  MF(2) MUST CONTAIN REQ BLK NAME IF            @Y30LB02
.*               EXEC MACRO FORM REQUESTED                     @Y30LB02
.*     ICB613I:  MISSING REQ BLK NAME OR MORE                  @Y30LB02
.*               THAN 2 SUBPARAMETERS FOR MF                   @Y30LB02
.*     ICB615I:  INVALID MF PARAMETER SPECIFIED, MUST BE       @Y30LB02
.*               L, E, OR NULL                                 @Y30LB02
.*                                                             @Y30LB02
.*01  CONTROL-BLOCKS = NONE                                    @Y30LB02
.*                                                             @Y30LB02
.*01  INNER MACROS = NONE                                      @Y30LB02
.*                                                             @Y30LB02
.*01  SYSTEM MACRO = IHBINNRA                                  @Y30LB02
.*                                                             @Y30LB02
.*01  CHANGE-ACTIVITY = S/D X04AC02 AND Y30LB02                @Y30LB02
.*                                                             @Y30LB02
.**** END OF SPECIFICATIONS ***                                @Y30LB02
         MACRO
&SYMBOL  ICBVARY &MF=,&TYPE=,&FLAGS=,&ECB=,&RUA=,&SSID=
         LCLC  &LBL                DEFINE MACRO INSTR INDX     @Y30LB02
         LCLB  &ERSW               DEFINE ERROR SWITCH         @Y30LB02
&LBL     SETC  'V'.'&SYSNDX'       ASSIGN CHARACTER VALUE      @Y30LB02
.*                                                             @Y30LB02
.*       CHECK FOR VALID TYPE SPECIFICATION                    @Y30LB02
.TYPE    AIF   ('&TYPE' EQ '').NUL                             @Y30LB02
         AIF   ('&TYPE' EQ 'VON' OR '&TYPE' EQ 'VOF').START    @Y30LB02
         MNOTE 12,'  ICB601I - TYPE IS INCORRECTLY SPECIFIED'  @Y30LB02
         MEXIT                                                 @Y30LB02
.*                                                             @Y30LB02
.NUL     ANOP                                                  @Y30LB02
         MNOTE 12,'  ICB600I - TYPE MUST BE SPECIFIED '        @Y30LB02
         MEXIT                                                 @Y30LB02
.*                                                             @Y30LB02
.*       DETERMINATION OF DESIRED MACRO FORM                   @Y30LB02
.*                                                             @Y30LB02
.START   AIF   ('&MF(1)' EQ 'L').LFORM      LIST FORM?         @Y30LB02
         AIF   ('&MF(1)' EQ 'E').EFORM      EXECUTE FORM?      @Y30LB02
         AIF   ('&MF(1)' EQ '').SFORM       STANDARD FORM?     @Y30LB02
         MNOTE 12,'  ICB615I - INVALID MF PARAMETER '          @Y30LB02
         MNOTE 12,'  SPECIFIED, MUST BE L, E, OR NULL.'        @Y30LB02
&ERSW    SETB  1                                               @Y30LB02
         AGO   .PROCES                                         @Y30LB02
.*                                                             @Y30LB02
.*       PROCESSING OF 'LIST' MACRO FORM                       @Y30LB02
.*       THE FOLLOWING CODE CHECKS FOR ILLEGAL PARAMETERS ON   @Y30LB02
.*       THE LIST FORM MACRO AND GIVES WARNING IF FOUND        @Y30LB02
.*                                                             @Y30LB02
.LFORM   ANOP                                                  @Y30LB02
         AIF   ('&FLAGS' NE '' OR '&ECB' NE '' OR '&RUA' NE            *
               '' OR '&SSID' NE '').WARN                       @Y30LB02
         AGO   .LIST1                                          @Y30LB02
.*                                                             @Y30LB02
.WARN    MNOTE 4,'  ICB603I - WARNING-ONLY MF AND TYPE '       @Y30LB02
         MNOTE 4,'  PARAMETERS ARE VALID FOR LIST FORM '       @Y30LB02
.*                                                             @Y30LB02
.LIST1   ANOP                                                  @Y30LB02
         AIF   ('&TYPE' EQ 'VON').VARYON  VARYON REQUEST?      @Y30LB02
         AIF   ('&MF(2)' EQ 'MAP').VOFDS  DSECT REQUESTED      @Y30LB02
*  MACMEAN  VARYOFF MACRO--INITIALIZED LIST FORM               @Y30LB02
*  VS1-4/VS2-3 VERSION--06/09/74   LEVEL 00                    @Y30LB02
&SYMBOL  DS    0F                                              @Y30LB02
VOFLEN   DC    F'24'               LENGTH OF VOF REQ BLK       @Y30LB02
VOFOPCD  DC    XL1'0C'             OPCODE PLACED IN REQ        @Y30LB02
VOFRES1  DC    XL1'00'             1-BYTE RESERVED AREA        @Y30LB02
VOFFLAG  DC    XL2'0000'           2-BYTE FLAGS AREA           @Y30LB02
VOFSSID  DC    XL2'0000'           2-BYTE SSID AREA            @Y30LB02
VOFRUA   DC    XL2'0000'           2-BYTE RUA AREA             @Y30LB02
VOFHOST  DC    XL5'0000000000'     5-BYTE HOST ID AREA         @Y30LB02
VOFRES2  DC    XL1'00'             1-BYTE RESERVED AREA        @Y30LB02
VOFASID  DC    XL2'0000'           2-BYTE ASID AREA            @Y30LB02
VOFECB   DC    XL4'00000000'       4-BYTE AREA FOR ECB         @Y30LB02
         MEXIT                                                 @Y30LB02
.*                                                             @Y30LB02
.VOFDS   ANOP                                                  @Y30LB02
*  MACMEAN  VARYOFF MACRO--UNINITIALIZED LIST FORM             @Y30LB02
*  VS1-4/VS2-3 VERSION--06/09/74   LEVEL 00                    @Y30LB02
ICBVARY  DSECT                                                 @Y30LB02
VOFLEN   DS    F                   LENGTH OF VOF 24 DEC        @Y30LB02
VOFOPCD  DS    XL1                 VOF OPCODE 0C HEX           @Y30LB02
VOFRES1  DS    XL1                 1-BYTE RESERVED AREA        @Y30LB02
VOFFLAG  DS    XL2                 2-BYTE FLAGS AREA           @Y30LB02
VOFSSID  DS    XL2                 2-BYTE SSID AREA            @Y30LB02
VOFRUA   DS    XL2                 2-BYTE RUA AREA             @Y30LB02
VOFHOST  DS    CL5                 5-BYTE HOST ID AREA         @Y30LB02
VOFRES2  DS    XL1                 1-BYTE RESERVED AREA        @Y30LB02
VOFASID  DS    XL2                 2-BYTE ASID AREA            @Y30LB02
VOFECB   DS    A                   4-BYTE ECB ADDR             @Y30LB02
         MEXIT                                                 @Y30LB02
.*                                                             @Y30LB02
.VARYON  ANOP                                                  @Y30LB02
         AIF   ('&MF(2)' EQ 'MAP').VONDS   DSECT REQUEST       @Y30LB02
*  MACMEAN  VARYON MACRO--INITIALIZED LIST FORM                @Y30LB02
*  VS1-4/VS2-3 VERSION--06/09/74   LEVEL 00                    @Y30LB02
&SYMBOL  DS    0F                                              @Y30LB02
VONLEN   DC    F'12'               LENGTH OF VON REQ BLK       @Y30LB02
VONOPCD  DC    XL1'0A'             OPCODE PLACED IN BLOCK      @Y30LB02
VONRES1  DC    XL1'00'             1-BYTE RESERVED AREA        @Y30LB02
VONFLAG  DC    XL2'0000'           2-BYTE FLAGS AREA-ZERO      @Y30LB02
VONSSID  DC    XL2'0000'           2 BYTE SSID AREA            @Y30LB02
VONRES2  DC    XL2'0000'           2-BYTE RESERVED AREA        @Y30LB02
         MEXIT                                                 @Y30LB02
.*                                                             @Y30LB02
.VONDS   ANOP                                                  @Y30LB02
*  MACMEAN  VARYON MACRO--UNINITIALIZED LIST FORM              @Y30LB02
*  VS1-4/VS2-3 VERSION--06/09/74   LEVEL 00                    @Y30LB02
ICBVARY1 DSECT                                                 @Y30LB02
VONLEN   DS    F                   LENGTH OF VON 12 DEC        @Y30LB02
VONOPCD  DS    XL1                 VON OPCODE 0A HEX           @Y30LB02
VONRES1  DS    XL1                 1-BYTE RESERVED AREA        @Y30LB02
VONFLAG  DS    XL2                 2-BYTE FLAGS AREA-ZERO      @Y30LB02
VONSSID  DS    XL2                 2 BYTE SSID AREA            @Y30LB02
VONRES2  DS    XL2                 2-BYTE RESERVED AREA        @Y30LB02
         MEXIT                                                 @Y30LB02
.*       PROCESSING OF THE 'EXECUTE' MACRO FORM                @Y30LB02
.*                                                             @Y30LB02
.EFORM   ANOP                                                  @Y30LB02
         AIF   (N'&MF EQ 2).PARMOK  MORE THAN TWO MF SUB-      @Y30LB02
.*                                 PARAMETERS SPECD?           @Y30LB02
         MNOTE 12,'  ICB613I - MISSING REQ BLK NAME OR '       @Y30LB02
         MNOTE 12,'  MORE THAN 2 SUBPARAMETERS FOR MF '        @Y30LB02
&ERSW    SETB  1                                               @Y30LB02
         AGO   .PROCES                                         @Y30LB02
.*                                                             @Y30LB02
.PARMOK  ANOP                                                  @Y30LB02
*  MACMEAN  VARYON/VARYOFF--EXECUTE FORM                       @Y30LB02
*  VS1-4/VS2-3 VERSION--06/09/74   LEVEL 00                    @Y30LB02
&SYMBOL  IHBINNRA &MF(2)          LD ADDR OF REQUEST BLK       @Y30LB02
.*                                USING IHBINNRA MACRO         @Y30LB02
.*                                                             @Y30LB02
         AIF   ('&TYPE' EQ 'VON').VON1          TYPE VARYON?   @Y30LB02
         LA    0,24                LD LENGTH OF VARYOFF        @Y30LB02
         ST    0,0(1)              STORE LENGTH IN REQ BLK     @Y30LB02
         MVI   4(1),X'0C'          LOAD VARYOFF OPCODE         @Y30LB02
         AGO   .PROCES                                         @Y30LB02
.*                                                             @Y30LB02
.VON1    ANOP                                                  @Y30LB02
         LA    0,12                LD LENG OF VARYON REQ       @Y30LB02
         ST    0,0(1)              STORE LENGTH                @Y30LB02
         MVI   4(1),X'0A'          LD VARYON OPCODE IN REG     @Y30LB02
         AGO   .PROCES                                         @Y30LB02
.*                                                             @Y30LB02
.*       PROCESSING OF 'STANDARD' MACRO FORM                   @Y30LB02
.*                                                             @Y30LB02
.*                                                             @Y30LB02
.SFORM   ANOP                                                  @Y30LB02
*  MACMEAN VARYON/VARYOFF MACRO--STANDARD FORM                 @Y30LB02
*  VS1-4/VS2-3 VERSION--06/09/74   LEVEL 00                    @Y30LB02
         CNOP 0,4                                              @Y30LB02
&SYMBOL  BAL   1,&LBL              BRCH AROUND REQ BLK         @Y30LB02
         AIF   ('&TYPE' EQ 'VON').VON2           VARYON?       @Y30LB02
VOFLEN   DC    A(&LBL-*)           LENGTH OF VOF REQ BLK       @Y30LB02
VOFOPCD  DC    XL1'0C'             DEFINE VARYOFF OPCODE       @Y30LB02
VOFRES1  DC    XL1'00'             1-BYTE RESERVED AREA        @Y30LB02
VOFFLAG  DC    XL2'0000'           2-BYTE FLAGS AREA           @Y30LB02
VOFSSID  DC    XL2'0000'           2-BYTE SSID AREA            @Y30LB02
VOFRUA   DC    XL2'0000'           2-BYTE RUA AREA             @Y30LB02
VOFHOST  DC    XL5'0000000000'     5-BYTE HOSTID AREA          @Y30LB02
VOFRES2  DC    XL1'00'             1-BYTE RESERVED AREA        @Y30LB02
VOFASID  DC    XL2'0000'           2-BYTE ASID AREA            @Y30LB02
VOFECB   DC    XL4'00000000'       4-BYTE ECB AREA             @Y30LB02
&LBL     EQU   *                                               @Y30LB02
         AGO   .PROCES                                         @Y30LB02
.*                                                             @Y30LB02
.VON2    ANOP                                                  @Y30LB02
VONLEN   DC    A(&LBL-*)           LENGTH OF VON REQ BLK       @Y30LB02
VONOPCD  DC    XL1'0A'             DEFINE VARYON OPCODE        @Y30LB02
VONRES1  DC    XL1'00'             1-BYTE RESERVED AREA        @Y30LB02
VONFLAG  DC    XL2'0000'           2-BYTE FLAGS AREA           @Y30LB02
VONSSID  DC    XL2'0000'           2-BYTE SSID AREA            @Y30LB02
VONRES2  DC    XL2'0000'           2-BYTE RESERVED AREA        @Y30LB02
&LBL     EQU   *                                               @Y30LB02
.*                                                             @Y30LB02
.*       PROCESS REQUEST BLOCK FOR STANDARD & EXECUTE FORMS    @Y30LB02
.*                                                             @Y30LB02
.PROCES  AIF   (&ERSW).FINISH                                  @Y30LB02
         AIF   ('&FLAGS' EQ '').SSID       FLAGS SPECIFIED?    @Y30LB02
         AIF   ('&FLAGS'(1,1) EQ '(').REGF   FLAGS REGFORM?    @Y30LB02
         MVC   6(2,1),&FLAGS       PUT FLAGS IN REQ BLOCK      @Y30LB02
         AGO   .SSID               BR TO CHECK FOR SSID        @Y30LB02
.*                                                             @Y30LB02
.REGF    ANOP                                                  @Y30LB02
         MVC   6(2,1),0(&FLAGS(1)) REG-FORM-STORE FLAGS        @Y30LB02
.*                                                             @Y30LB02
.SSID    AIF   ('&SSID' EQ '').RUA          SSID SPECIFIED?    @Y30LB02
         AIF   ('&SSID'(1,1) EQ '(').SREG   REG-FORM?          @Y30LB02
         MVC   8(2,1),&SSID        PUT SSID IN REQ BLOCK       @Y30LB02
         AGO   .RUA                                            @Y30LB02
.*                                                             @Y30LB02
.SREG    ANOP                                                  @Y30LB02
         MVC   8(2,1),0(&SSID(1))  REG-FORM--STORE SSID        @Y30LB02
.*                                                             @Y30LB02
.RUA     AIF   ('&TYPE' EQ 'VON').CVS2     BR IF VARYON        @Y30LB02
         AIF   ('&RUA' EQ '').CKECB        RUA SPECIFIED?      @Y30LB02
         AIF   ('&RUA'(1,1) EQ '(').VREG    REG-FORM?          @Y30LB02
         MVC   10(2,1),&RUA        PUT RUA IN REQ BLOCK        @Y30LB02
         AGO   .CKECB                                          @Y30LB02
.*                                                             @Y30LB02
.VREG    ANOP                                                  @Y30LB02
         MVC   10(2,1),0(&RUA(1))  REG-FORM--STORE RUA         @Y30LB02
.*                                                             @Y30LB02
.CKECB   AIF   ('&ECB' EQ '').CVS2                             @Y30LB02
         AIF   ('&ECB'(1,1) EQ '(').UREG     REGISTER FORM?    @Y30LB02
         LA    15,&ECB             LOAD ADDRESS OF ECB         @Y30LB02
         ST    15,20(1)            STORE ADDRESS OF ECB        @Y30LB02
         AGO   .CVS2                                           @Y30LB02
.*                                                             @Y30LB02
.UREG    ANOP                                                  @Y30LB02
         ST    &ECB,20(1)          REG-FORM,STORE ECB          @Y30LB02
.*                                                             @Y30LB02
.*                                                             @Y30LB02
.CVS2    ANOP                                                  @Y30LB02
         SVC   126                 INVOKE SVC                  @Y30LB02
.FINISH  MEND                                                  @Y30LB02
**/
*   ICBVARY:  MACRO KEYS(MF,TYPE,FLAGS,SSID,RUA,ECB);      /*@Y30LB02*/
*/*                                                          @Y30LB02*/
*/*            EXTERNAL DECLARES                             @Y30LB02*/
*        DCL ICBTESTR FIXED EXT;/*INVOCATION COUNTER         @Y30LB02*/
*        DCL VONTEST FIXED EXT; /*COUNTER FOR STANDARD FORM  @Y30LB02*/
*        DCL VOFTES1 FIXED EXT;  /*COUNTER FOR  VOF S-FORM   @Y30LB02*/
*/*                                                          @Y30LB02*/
*/*                                                          @Y30LB02*/
*/*            INTERNAL DECLARES                             @Y30LB02*/
*/*                                                          @Y30LB02*/
*   DCL CTR        FIXED;         /*CTR FOR LIST PARAMETERS  @Y30LB02*/
*   DCL ERSW       FIXED;         /*ERROR COND SWITCH        @Y30LB02*/
*   DCL VONCOD     CHAR;         /*VARYON OPCODE             @Y30LB02*/
*   DCL VOFCOD     CHAR;         /*VARYOFF OPCODE            @Y30LB02*/
*   DCL RETCODE    FIXED;        /*RETURN CODE AREA          @Y30LB02*/
*   DCL VNLEN      CHAR;         /*LENGTH OF VON REQ BLOCK   @Y30LB02*/
*   DCL VFLEN      CHAR;         /*LENGTH OF VOF REQ BLOCK   @Y30LB02*/
*        VONCOD='0A';            /*INIT VARYON OPCODE        @Y30LB02*/
*        VOFCOD='0C';            /*INITIALIZE VARYOFF OPCOD  @Y30LB02*/
*        RETCODE=0;              /*INITIALIZE RETURNCODE     @Y30LB02*/
*        VNLEN='0C';             /*INITIALIZE VARYON LENGTH  @Y30LB02*/
*        ERSW = 0;               /*INITIALIZE ERROR SWITCH   @Y30LB02*/
*        VFLEN='18';             /*INITIALIZE VARYOFF LEN    @Y30LB02*/
*        CTR = 0;                /*INITIALIZE PARM COUNTER   @Y30LB02*/
*/*                                                          @Y30LB02*/
*/*            CHECK FOR VALID TYPE SPECIFICATION            @Y30LB02*/
*/*                                                          @Y30LB02*/
*   IF TYPE='' THEN              /*TYPE SPECIFIED?           @Y30LB02*/
*     DO;                        /*NO,PROCESS ERROR MSG      @Y30LB02*/
*        ERSW=1;                 /*SET ERROR SWITCH TO 1     @Y30LB02*/
*        ANS MSG('  ICB600I - TYPE MUST BE '||
*                'SPECIFIED')SKIP;                         /*@Y30LB02*/
*        RETCODE=12;        /*SET RETURN CODE TO 12          @Y30LB02*/
*        GO TO FINISH;      /*BRANCH TO END                  @Y30LB02*/
*     END;                  /*                               @Y30LB02*/
*   IF ERSW=1 THEN          /*ERROR SWITCH SET?              @Y30LB02*/
*        GO TO FINISH;      /*YES,BRCH END PROCES            @Y30LB02*/
*   IF ICBTESTR = 0 THEN    /*REG 1 ALREADY DCLD?            @Y30LB02*/
*      DO;                  /*NO,PRINT DECLARE               @Y30LB02*/
*        ANS('DCL ICBR1 REG(1) PTR ;/*'||
*        'ADDRESS OF REQUEST BLOCK @Y30LB02*/')SKIP;
*        ICBTESTR=1;        /*INCREM DCL COUNTER             @Y30LB02*/
*      END;                 /*                               @Y30LB02*/
*   IF TYPE(1)='VON' THEN   /*TYPE VARYON?                   @Y30LB02*/
*        GO TO START;       /*YES,BRCH,VALID TYPE            @Y30LB02*/
*   IF TYPE(1) = 'VOF' THEN /*TYPE VARYOFF?                  @Y30LB02*/
*        GO TO START;       /*YES,BRCH,VALID TYPE            @Y30LB02*/
*/*                                                          @Y30LB02*/
*/*      INVALID 'TYPE' WILL CREATE THE FOLLOWING ERR MSGS   @Y30LB02*/
*/*                                                          @Y30LB02*/
*   ERSW=1;                 /*SET ERROR SWITCH TO ONE        @Y30LB02*/
*   ANS MSG('  ICB601I - TYPE IS INCORRECTLY '||
*           'SPECIFIED')SKIP(3);                           /*@Y30LB02*/
*   RETCODE=12;             /*SET RETURN CODE TO 12          @Y30LB02*/
*   IF ERSW=1 THEN          /*ERROR SWITCH SET TO ONE?       @Y30LB02*/
*   GO TO FINISH;           /*YES,BRCH TO END PROCESS        @Y30LB02*/
*/*                                                          @Y30LB02*/
*START:
*   IF MF(1) ^= 'L' THEN    /*LIST FORM REQUEST?             @Y30LB02*/
*        GO TO CKFORM;      /*NO,CHECK FOR OTHER FORMS       @Y30LB02*/
*   IF MF(2) ^= '' THEN     /*LIST NAME SPECIFIED?           @Y30LB02*/
*        GO TO LISTFORM;    /*YES,BRCH PROCESS REQUEST       @Y30LB02*/
*   ERSW=1;                 /*NO,SET ERROR SWITCH            @Y30LB02*/
*   ANS MSG('  ICB602I - A NAME FOR THE '||
*           'REQUEST BLOCK MUST BE SPECIFIED IN '||
*           'MF(2) ')SKIP(3);                              /*@Y30LB02*/
*   RETCODE=12;             /*SET RETURN CODE TO 12          @Y30LB02*/
*   IF ERSW=1 THEN          /*CHECK THE ERROR SWITCH         @Y30LB02*/
*   GO TO FINISH;                                          /*@Y30LB02*/
*/*                                                          @Y30LB02*/
*LISTFORM:
*/********************************************************@Y30LB02*/
*/*  CHECK FOR ILLEGAL PARAMETERS AND PRINT OUT DECLARES  @Y30LB02*/
*/********************************************************@Y30LB02*/
*   IF FLAGS ^= '' THEN     /*FLAGS SPECIFIED?               @Y30LB02*/
*        CTR = CTR + 1;     /*YES,INCREMENT COUNTER          @Y30LB02*/
*   IF SSID ^= '' THEN      /*SSID SPECIFIED?                @Y30LB02*/
*        CTR = CTR + 1;     /*YES,INCREMENT COUNTER          @Y30LB02*/
*   IF RUA ^= '' THEN       /*RUA SPECIFIED?                 @Y30LB02*/
*        CTR = CTR + 1;     /*YES,INCREMENT COUNTER          @Y30LB02*/
*   IF ECB ^= '' THEN       /*ECB SPECIFIED?                 @Y30LB02*/
*        CTR = CTR + 1;     /*YES,INCREMENT COUNTER          @Y30LB02*/
*   IF CTR > 0 THEN         /*COUNTER GT ZERO?               @Y30LB02*/
*     DO;                   /*YES,WARN USER                  @Y30LB02*/
*        RETCODE=4;         /*SET RETURN CODE TO 4           @Y30LB02*/
*        ANS MSG('  ICB603I - WARNING-ONLY MF'||
*             ' AND TYPE PARAMETERS ARE VALID FOR'||
*             ' LIST FORM  ')SKIP(3);                      /*@Y30LB02*/
*     END;                  /*                               @Y30LB02*/
*/*                                                          @Y30LB02*/
*   IF MF(3) ^= '' THEN     /*PLS ATTRIBUTE SPECIFIED?       @Y30LB02*/
*       GO TO ATTRLST;      /*YES,PROCESS IT                 @Y30LB02*/
*   IF TYPE(1)='VON' THEN   /*IS TYPE VARYON?                @Y30LB02*/
*     DO;                   /*YES,PUT VARYON REQ BLOCK       @Y30LB02*/
*        ANS('/*******************************************'||
*            '************** @Y30LB02*/')SKIP;
*        ANS('/*MACMEAN  MSSC VARYON MACRO                '||
*            '               @Y30LB02*/')SKIP;
*        ANS('/*VS1-4/VS2-3 VERSION--06/09/74 LEVEL 00    '||
*            '               @Y30LB02*/')SKIP;
*        ANS('/*THIS IS THE INITIALIZED LIST FORM         '||
*            '               @Y30LB02*/')SKIP;
*        ANS('/*******************************************'||
*           '************** @Y30LB02*/')SKIP;
*        ANS('DCL 1 ' ||MF(2)|| '  STATIC LOCAL,'||
*        ' /*VARYON REQ BLOCK @Y30LB02*/')SKIP;
*        ANS('    2  VONLEN  FIXED(31)INIT('||QUOTE
*        ('0C')||'X),/*LENGTH OF VON REQUEST BLOCK @Y30LB02*/')SKIP;
*        ANS('    2  VONOPCD CHAR(1)INIT('||QUOTE('0A')||
*        'X),/*VARYON OPCODE @Y30LB02*/')SKIP;
*        ANS('    2  VONRES1 CHAR(1)INIT('||QUOTE('00')||
*        'X), /*ONE BYTE OF ZERO @Y30LB02*/')SKIP;
*        ANS('    2  VONFLG BIT(16)INIT('||QUOTE
*        ('0000000000000000')||'B), /*FLAGS AREA @Y30LB02*/')SKIP;
*        ANS('     3  VONSTAG  BIT(1), /*STAGING '||
*        'ATTRIBUTE @Y30LB02*/')SKIP;
*        ANS('     3  VONREAL  BIT(1), /*REAL '||
*        'ATTRIBUTE @Y30LB02*/')SKIP;
*        ANS('     3  *      BIT(14),'||
*        ' /*FOURTEEN BITS RESERVED @Y30LB02*/')SKIP;
*        ANS('    2  VONSSID  FIXED(15) INIT(0),'||
*        ' /*SUBSYSTEM ID  @Y30LB02*/')SKIP;
*        ANS('    2  VONRES2  CHAR(2) INIT('||QUOTE
*        ('0000')||'X);/*RESERVED AREA @Y30LB02*/')SKIP;
*        GO TO FINISH;                                     /*@Y30LB02*/
*     END;                                                 /*@Y30LB02*/
*/*                                                          @Y30LB02*/
*  ELSE
*     DO;                                                  /*@Y30LB02*/
*        ANS('/*******************************************'||
*            '************** @Y30LB02*/')SKIP;
*        ANS('/*MACMEAN  MSSC VARYOFF MACRO               '||
*            '               @Y30LB02*/')SKIP;
*        ANS('/*VS1-4/VS2-3 VERSION--06/09/74 LEVEL 00    '||
*            '               @Y30LB02*/')SKIP;
*        ANS('/*THIS IS THE INITIALIZED LIST FORM         '||
*            '               @Y30LB02*/')SKIP;
*        ANS('/*******************************************'||
*            '************** @Y30LB02*/')SKIP;
*        ANS('DCL 1 ' ||MF(2)|| '  STATIC LOCAL,'||
*        ' /*VARYOFF REQ BLOCK @Y30LB02*/')SKIP;
*        ANS('    2  VOFLEN  FIXED(31)INIT('||QUOTE
*        ('18')||'X),/*LENGTH OF VOF REQUEST BLK @Y30LB02*/')SKIP;
*        ANS('    2  VOFOPCD CHAR(1)INIT('||QUOTE('0C')||
*        'X),/*VARYOFF OPCODE @Y30LB02*/')SKIP;
*        ANS('    2  VOFRES1 CHAR(1)INIT('||QUOTE('00')||
*        'X), /*ONE BYTE OF ZERO @Y30LB02*/')SKIP;
*        ANS('    2  VOFFLG BIT(16)INIT('||QUOTE
*        ('0000000000000000')||'B), /*FLAGS AREA @Y30LB02*/')SKIP;
*        ANS('     3  VOFSTAG  BIT(1), /*VIRTUAL '||
*        'ATTRIBUTE @Y30LB02*/')SKIP;
*        ANS('     3  VOFREAL  BIT(1), /*REAL '||
*        'ATTRIBUTE @Y30LB02*/')SKIP;
*        ANS('     3  VOFNEUT  BIT(1), /*NEUTRAL '||
*        'ATTRIBUTE @Y30LB02*/')SKIP;
*        ANS('     3  VOFTEST  BIT(1), /*TEST '||
*        'ATTRIBUTE @Y30LB02*/')SKIP;
*        ANS('     3  *      BIT(12),'||
*        ' /*TWELVE BITS RESERVED @Y30LB02*/')SKIP;
*        ANS('    2  VOFSSID  FIXED(15) INIT(0),'||
*        ' /*SUBSYSTEM ID  @Y30LB02*/')SKIP;
*        ANS('    2  VOFRUA  FIXED(15) INIT(0),'||
*        ' /*REAL UNIT ADDRESS  @Y30LB02*/')SKIP;
*        ANS('    2  VOFHOST  CHAR(5) INIT('||QUOTE
*        ('0000000000')||'X),/*HOSTID AREA @Y30LB02*/')SKIP;
*        ANS('    2  *     CHAR(1) INIT('||QUOTE
*        ('00')||'X),/*RESERVED AREA @Y30LB02*/')SKIP;
*        ANS('    2  VOFASID CHAR(2) INIT('||QUOTE
*        ('0000')||'X),/*ASID AREA @Y30LB02*/')SKIP;
*        ANS('    2  VOFECB  FIXED(31) INIT(0);'||
*        ' /* EVENT CONTROL BLOCK AREA @Y30LB02*/')SKIP;
*        GO TO FINISH;       /*BRCH TO END                   @Y30LB02*/
*     END;                   /*                              @Y30LB02*/
*ATTRLST:
*   IF TYPE(1)='VON' THEN    /*VARYON REQUEST                @Y30LB02*/
*     DO;                    /*OUTPUT UNINIT REQ BLOCK       @Y30LB02*/
*        ANS('/*******************************************'||
*            '************* @Y30LB02*/')SKIP;
*        ANS('/*MACMEAN  MSSC VARYON MACRO                '||
*            '              @Y30LB02*/')SKIP;
*        ANS('/*VS1-4/VS2-3 VERSION--06/09/74 LEVEL 00    '||
*            '              @Y30LB02*/')SKIP;
*        ANS('/*THIS IS THE UNINITIALIZED LIST FORM       '||
*            '              @Y30LB02*/')SKIP;
*        ANS('/*******************************************'||
*            '************* @Y30LB02*/')SKIP;
*        ANS('DCL 1 ' ||MF(2)||'  '||MF(3)||','||
*        ' /*VARYON REQ BLOCK @Y30LB02*/')SKIP;
*        ANS('    2  VONLEN  FIXED(31), /*LENGTH'||
*        ' OF BLOCK = 0C BYTES HEX @Y30LB02*/')SKIP;
*        ANS('    2  VONOPCD CHAR(1),/*VARYON'||
*        ' OPCODE = 0A HEX @Y30LB02*/')SKIP;
*        ANS('    2  VONRES1 CHAR(1),/*ONE '||
*        ' BYTE OF ZERO @Y30LB02*/')SKIP;
*        ANS('    2  VONFLG BIT(16), /*FLAGS AREA @Y30LB02*/')SKIP;
*        ANS('     3  VONSTAG  BIT(1), /*STAGING '||
*        'ATTRIBUTE @Y30LB02*/')SKIP;
*        ANS('     3  VONREAL  BIT(1), /*REAL '||
*        'ATTRIBUTE @Y30LB02*/')SKIP;
*        ANS('     3  *      BIT(14),'||
*        ' /*FOURTEEN BITS RESERVED @Y30LB02*/')SKIP;
*        ANS('    2  VONSSID  FIXED(15),'||
*        ' /*SUBSYSTEM ID  @Y30LB02*/')SKIP;
*        ANS('    2  VONRES2  CHAR(2);'||
*        '/*RESERVED AREA @Y30LB02*/')SKIP;
*        GO TO FINISH;           /*BRCH TO END               @Y30LB02*/
*     END;                       /*                          @Y30LB02*/
*/*                                                          @Y30LB02*/
*  ELSE                          /*VARYOFF REQUEST           @Y30LB02*/
*     DO;                        /*OUTPUT VARYOFF BLOCK      @Y30LB02*/
*        ANS('/*******************************************'||
*            '************** @Y30LB02*/')SKIP;
*        ANS('/*MACMEAN  MSSC VARYOFF MACRO               '||
*            '               @Y30LB02*/')SKIP;
*        ANS('/*VS1-4/VS2-3 VERSION--06/09/74 LEVEL 00    '||
*            '               @Y30LB02*/')SKIP;
*        ANS('/*THIS IS THE UNINITIALIZED LIST FORM       '||
*            '               @Y30LB02*/')SKIP;
*        ANS('/*******************************************'||
*            '************** @Y30LB02*/')SKIP;
*        ANS('DCL 1 ' ||MF(2)||'  '||MF(3)||','||
*        ' /*VARYOFF REQ BLOCK @Y30LB02*/')SKIP;
*        ANS('    2  VOFLEN  FIXED(31),/*LENGTH OF'||
*        ' REQUEST BLOCK = 18 HEX @Y30LB02*/')SKIP;
*        ANS('    2  VOFOPCD CHAR(1), '||
*        '/*VARYOFF OPCODE = 0C HEX @Y30LB02*/')SKIP;
*        ANS('    2  VOFRES1  CHAR(1),/*ONE '||
*        'BYTE OF ZERO @Y30LB02*/')SKIP;
*        ANS('    2  VOFFLG BIT(16),/*FLAGS AREA @Y30LB02*/')SKIP;
*        ANS('     3  VOFSTAG  BIT(1), /*STAGING '||
*        'ATTRIBUTE @Y30LB02*/')SKIP;
*        ANS('     3  VOFREAL  BIT(1), /*REAL '||
*        'ATTRIBUTE @Y30LB02*/')SKIP;
*        ANS('     3  VOFNEUT  BIT(1), /*NEUTRAL '||
*        'ATTRIBUTE @Y30LB02*/')SKIP;
*        ANS('     3  VOFTEST  BIT(1), /*TEST '||
*        'ATTRIBUTE @Y30LB02*/')SKIP;
*        ANS('     3  *      BIT(12),'||
*        ' /*TWELVE BITS RESERVED @Y30LB02*/')SKIP;
*        ANS('    2  VOFSSID FIXED(15),'||
*        ' /*SUBSYSTEM ID  @Y30LB02*/')SKIP;
*        ANS('    2  VOFRUA  FIXED(15),'||
*        ' /*REAL UNIT ADDRESS  @Y30LB02*/')SKIP;
*        ANS('    2  VOFHOST  CHAR(5),'||
*        '/*HOSTID AREA @Y30LB02*/')SKIP;
*        ANS('    2  * CHAR(1) ,/*RESERVED AREA @Y30LB02*/')SKIP;
*        ANS('    2  VOFASID  CHAR(2),'||
*        '/*ASID AREA @Y30LB02*/')SKIP;
*        ANS('    2  VOFECB  FIXED(31);'||
*        ' /* EVENT CONTROL BLOCK AREA @Y30LB02*/')SKIP;
*        GO TO FINISH;           /*BRANCH TO END             @Y30LB02*/
*/*                                                          @Y30LB02*/
*     END;                       /*                          @Y30LB02*/
*/*                                                          @Y30LB02*/
*/*      CHECK FOR EXECUTE FORM SPECIFICATION                @Y30LB02*/
*/*                                                          @Y30LB02*/
*CKFORM:
*   IF MF(1) ^= 'E' THEN       /* EXECUTE FORM SPECIFIED?    @Y30LB02*/
*        GO TO SFORM;         /*NO,CHECK FOR STANDARD        @Y30LB02*/
*   IF MF(2)='' THEN          /* BLOCK NAME SPECIFIED?       @Y30LB02*/
*     DO;                     /*YES,PRINT ERROR MESSAGE      @Y30LB02*/
*        ANS MSG('  ICB612I - MF(2) MUST CONTAIN'||
*                ' REQ BLK NAME IF EXEC'||
*                ' MACRO FORM REQUESTED')SKIP(3);          /*@Y30LB02*/
*        RETCODE=12;          /*SET RETURN CODE TO 12        @Y30LB02*/
*        ERSW = 1;            /*SET ERROR SWITCH             @Y30LB02*/
*        GO TO COMPROC;       /*BRCH TO CHECK SWITCH         @Y30LB02*/
*     END;                    /*                             @Y30LB02*/
*/*                                                          @Y30LB02*/
*        ANS('/*******************************************'||
*            '************** @Y30LB02*/')SKIP;
*        ANS('/*MACMEAN  MSSC VARYON/VARYOFF MACRO        '||
*            '               @Y30LB02*/')SKIP;
*        ANS('/*VS1-4/VS2-3 VERSION-- 06/09/74 LEVEL 00   '||
*            '               @Y30LB02*/')SKIP;
*        ANS('/*THIS IS THE OUTPUT FOR THE EXECUTE FORM.  '||
*            '               @Y30LB02*/')SKIP;
*        ANS('/*THE LIST FORM OF THIS MACRO SHOULD BE     '||
*            '               @Y30LB02*/')SKIP;
*        ANS('/*INVOKED FIRST IN ORDER TO SET UP NECESSARY'||
*            '               @Y30LB02*/')SKIP;
*        ANS('/*DECLARES.  IF THE COMPLETE ARGUMENT IS    '||
*            '               @Y30LB02*/')SKIP;
*        ANS('/*SPECIFIED THE REQ BLOCK WILL BE ZEROED.   '||
*            '               @Y30LB02*/')SKIP;
*        ANS('/*******************************************'||
*            '************** @Y30LB02*/')SKIP;
*        ANS('RFY(ICBR1)RSTD;/*RESTRICT REG 1 @Y30LB02*/')SKIP;
*        ANS('ICBR1=ADDR('||MF(2)||'); /*R1 PTR'||
*        ' TO REQUEST BLOCK @Y30LB02*/')SKIP(2);
*   IF MF(3) = 'COMPLETE' THEN     /*COMPLETE SPECIFIED      @Y30LB02*/
*        GO TO EXCOMP;             /*YES,BRCH TO ZERO BLK    @Y30LB02*/
*   ELSE                           /*NO ZERO REQUESTED       @Y30LB02*/
*        GO TO COMPROC;            /*BRANCH TO CK PARAMETERS @Y30LB02*/
*EXCOMP:
*        ANS(' '||MF(2)||'='||MF(2)||'&&'||MF(2)||';/*ZERO'||
*        ' REQUEST BLOCK @Y30LB02*/')SKIP;
*        GO TO COMPROC;           /*BRANCH TO CK PARAMETERS  @Y30LB02*/
*/*                                                          @Y30LB02*/
*/*                                                          @Y30LB02*/
*SFORM:
*   IF MF(1) ^= '' THEN       /* FORM STANDARD?              @Y30LB02*/
*     DO;                     /*PRINT OUT ERROR MESSAGE      @Y30LB02*/
*        ANS MSG('  ICB615I - INVALID MF PARAMETER'||
*                ' SPECIFIED, MUST BE L,E, OR NULL')SKIP;  /*@Y30LB02*/
*        ERSW = 1;            /*SET ERROR SWITCH TO 1        @Y30LB02*/
*        RETCODE=12;          /*SET RETURN CODE TO 12        @Y30LB02*/
*        GO TO COMPROC;       /*BRANCH TO CK SWITCH          @Y30LB02*/
*     END;                    /*                             @Y30LB02*/
*/*                                                          @Y30LB02*/
*/*                                                          @Y30LB02*/
*   IF TYPE(1)='VON' THEN     /*TYPE EQUAL VARYON?           @Y30LB02*/
*     IF VONTEST => 1 THEN    /*1ST VARYON STD FORM?         @Y30LB02*/
*      DO;                    /*NO,DON'T PRINT DCLS          @Y30LB02*/
*        ANS('/*******************************************'||
*            '************* @Y30LB02*/')SKIP;
*        ANS('/*MACMEAN  MSSC VARYON MACRO                '||
*            '              @Y30LB02*/')SKIP;
*        ANS('/*VS1-4/VS2-3 VERSION--06/09/74 LEVEL 00    '||
*            '              @Y30LB02*/')SKIP;
*        ANS('/*THIS IS THE OUTPUT FOR A SECONDARY        '||
*            '              @Y30LB02*/')SKIP;
*        ANS('/*INVOCATION OF THE STANDARD FORM MACRO     '||
*           '              @Y30LB02*/')SKIP;
*        ANS('/*******************************************'||
*            '************* @Y30LB02*/')SKIP;
*        ANS('RFY(ICBR1)RSTD;/*RESTRICT REG 1 @Y30LB02*/')SKIP;
*        ANS('ICBR1=ADDR(VONLEN);/*PTR TO REQ BLK @Y30LB02*/')SKIP;
*        GO TO COMPROC;        /*BRANCH TO CK PARAMETERS     @Y30LB02*/
*      END;                    /*                            @Y30LB02*/
*/*                                                          @Y30LB02*/
*     IF TYPE(1) = 'VON' THEN  /*TYPE EQUAL VARYON?          @Y30LB02*/
*      DO;                     /*PUT OUT THE DCLS            @Y30LB02*/
*        ANS('/*******************************************'||
*            '************* @Y30LB02*/')SKIP;
*        ANS('/*MACMEAN  MSSC VARYON MACRO                '||
*            '              @Y30LB02*/')SKIP;
*        ANS('/*VS1-4/VS2-3 VERSION--06/09/74 LEVEL 00    '||
*            '              @Y30LB02*/')SKIP;
*        ANS('/*THIS IS THE STANDARD FORM - VARYON MACRO  '||
*            '              @Y30LB02*/')SKIP;
*        ANS('/*******************************************'||
*            '************* @Y30LB02*/')SKIP;
*        ANS('RFY(ICBR1)RSTD;/*RESTRICT REG 1 @Y30LB02*/')SKIP;
*        ANS('ICBR1=ADDR(VONLEN);/*R1 PTR TO REQ BLK @Y30LB02*/')SKIP;
*        ANS('DCL 1  VONLST01  STATIC LOCAL,'||
*        ' /*VARYON REQUEST BLOCK @Y30LB02*/')SKIP;
*        ANS('    2  VONLEN  FIXED(31)INIT('||QUOTE('0C')||
*        'X),/*LENGTH OF VARYON REQ BLK @Y30LB02*/')SKIP;
*        ANS('    2  VONOPCD CHAR(1)INIT('||QUOTE('0A')||
*        'X),/*VARYON OPCODE @Y30LB02*/')SKIP;
*        ANS('    2  VONRES1 CHAR(1)INIT('||QUOTE('00')||
*        'X), /*ONE BYTE OF ZERO @Y30LB02*/')SKIP;
*        ANS('    2  VONFLG BIT(16)INIT('||QUOTE
*        ('0000000000000000')||'B), /*FLAGS AREA @Y30LB02*/')SKIP;
*        ANS('     3  VONSTAG  BIT(1), /*STAGING '||
*        'ATTRIBUTE @Y30LB02*/')SKIP;
*        ANS('     3  VONREAL  BIT(1), /*REAL '||
*        'ATTRIBUTE @Y30LB02*/')SKIP;
*        ANS('     3  *      BIT(14),'||
*        ' /*FOURTEEN BITS RESERVED @Y30LB02*/')SKIP;
*        ANS('    2  VONSSID  FIXED(15) INIT(0),'||
*        ' /*SUBSYSTEM ID  @Y30LB02*/')SKIP;
*        ANS('    2  VONRES2  CHAR(2) INIT('||QUOTE
*        ('0000')||'X);/*RESERVED AREA @Y30LB02*/')SKIP;
*        VONTEST=VONTEST+1;    /*INCREMENT STD FORM CTR      @Y30LB02*/
*        GO TO COMPROC;        /*BRANCH TO CK PARAMETERS     @Y30LB02*/
*     END;                     /*                            @Y30LB02*/
*/*                                                          @Y30LB02*/
*   ELSE                       /*VARYOFF PROCESSING          @Y30LB02*/
*     IF VOFTES1 => 1 THEN     /*1ST VARYOFF STD FORM?       @Y30LB02*/
*      DO;                     /*NO,DON'T PRINT DCLS         @Y30LB02*/
*        ANS('/*******************************************'||
*            '************** @Y30LB02*/')SKIP;
*        ANS('/*MACMEAN  MSSC VARYOFF MACRO               '||
*            '               @Y30LB02*/')SKIP;
*        ANS('/*VS1-4/VS2-3 VERSION--06/09/74 LEVEL 00    '||
*            '               @Y30LB02*/')SKIP;
*        ANS('/*THIS IS THE OUTPUT FOR A SECONDARY        '||
*            '               @Y30LB02*/')SKIP;
*        ANS('/*INVOCATION OF THE STANDARD FORM MACRO     '||
*            '               @Y30LB02*/')SKIP;
*        ANS('/*******************************************'||
*            '************** @Y30LB02*/')SKIP;
*        ANS('RFY(ICBR1)RSTD;/*RESTRICT REG 1 @Y30LB02*/')SKIP;
*        ANS('ICBR1=ADDR(VOFLEN);/*PTR TO REQ BLK @Y30LB02*/')SKIP;
*        GO TO COMPROC;        /*BRANCH TO CK PARAMETERS     @Y30LB02*/
*      END;                    /*                            @Y30LB02*/
*     IF VOFTES1=0 THEN        /*1ST VARYOFF STD FORM        @Y30LB02*/
*     DO;                      /*PUT OUT THE DCLS            @Y30LB02*/
*        ANS('/*******************************************'||
*            '************* @Y30LB02*/')SKIP;
*        ANS('/*MACMEAN  MSSC VARYOFF MACRO               '||
*            '              @Y30LB02*/')SKIP;
*        ANS('/*VS1-4/VS2-3 VERSION--06/09/74 LEVEL 00    '||
*            '              @Y30LB02*/')SKIP;
*        ANS('/*THIS IS THE STANDARD FORM - VARYOFF MACRO '||
*            '              @Y30LB02*/')SKIP;
*        ANS('/*******************************************'||
*            '************* @Y30LB02*/')SKIP;
*        ANS('RFY(ICBR1)RSTD;/*RESTRICT REG 1 @Y30LB02*/')SKIP;
*        ANS('ICBR1=ADDR(VOFLEN);/*R1 PTR TO REQ BLK @Y30LB02*/')SKIP;
*        ANS('DCL 1 VOFLST01  STATIC LOCAL,'||
*        ' /*VARYOFF REQUEST BLOCK @Y30LB02*/')SKIP;
*        ANS('    2  VOFLEN  FIXED(31)INIT('||QUOTE('18')||
*        'X),/*LENGTH OF VOF REQ BLOCK @Y30LB02*/')SKIP;
*        ANS('    2  VOFOPCD CHAR(1)INIT('||QUOTE('0C')||
*        'X),/*VARYOFF OPCODE @Y30LB02*/')SKIP;
*        ANS('    2  VOFRES1 CHAR(1)INIT('||QUOTE('00')||
*        'X), /*ONE BYTE OF ZERO @Y30LB02*/')SKIP;
*        ANS('    2  VOFFLG BIT(16)INIT('||QUOTE
*        ('0000000000000000')||'B), /*FLAGS AREA @Y30LB02*/')SKIP;
*        ANS('     3  VOFSTAG  BIT(1), /*STAGING '||
*        'ATTRIBUTE @Y30LB02*/')SKIP;
*        ANS('     3  VOFREAL  BIT(1), /*REAL '||
*        'ATTRIBUTE @Y30LB02*/')SKIP;
*        ANS('     3  VOFNEUT  BIT(1), /*NEUTRAL '||
*        'ATTRIBUTE @Y30LB02*/')SKIP;
*        ANS('     3  VOFTEST  BIT(1), /*TEST '||
*        'ATTRIBUTE @Y30LB02*/')SKIP;
*        ANS('     3  *      BIT(12),'||
*        ' /*TWELVE BITS RESERVED @Y30LB02*/')SKIP;
*        ANS('    2  VOFSSID  FIXED(15) INIT(0),'||
*        ' /*SUBSYSTEM ID  @Y30LB02*/')SKIP;
*        ANS('    2  VOFRUA  FIXED(15) INIT(0),'||
*        ' /*REAL UNIT ADDRESS  @Y30LB02*/')SKIP;
*        ANS('    2  VOFHOST CHAR(5) INIT('||QUOTE
*        ('0000000000')||'X),/*HOSTID AREA @Y30LB02*/')SKIP;
*        ANS('    2  *     CHAR(1) INIT('||QUOTE
*        ('00')||'X),/*RESERVED AREA @Y30LB02*/')SKIP;
*        ANS('    2  VOFASID  CHAR(2) INIT('||QUOTE
*        ('0000')||'X),/*ASID AREA @Y30LB02*/')SKIP;
*        ANS('    2  VOFECB  FIXED(31) INIT(0);'||
*        ' /* EVENT CONTROL BLOCK AREA @Y30LB02*/')SKIP;
*        VOFTES1=VOFTES1+1;    /*INCREM VOF STD FORM CTR     @Y30LB02*/
*     END;                     /*                            @Y30LB02*/
*/*                                                          @Y30LB02*/
*COMPROC:
*/*                                                          @Y30LB02*/
*   IF ERSW =1 THEN           /*ERROR SWITCH SET?            @Y30LB02*/
*     GO TO FINISH;           /*YES,BRANCH OUT               @Y30LB02*/
*/*                                                          @Y30LB02*/
*   IF TYPE(1)='VON' THEN  /*VARYON REQUEST?                 @Y30LB02*/
*    DO;                   /*PROCESS LEN AND OPCOD           @Y30LB02*/
*     ANS('VONLEN=' ||QUOTE(VNLEN)|| 'X;'||
*     '  /*LENG-VARYON REQUEST BLOCK @Y30LB02*/')SKIP;
*     ANS('VONOPCD=' ||QUOTE(VONCOD)|| 'X;/*VARYON '||
*     ' OPCODE @Y30LB02*/')SKIP;
*    END;                   /*                               @Y30LB02*/
*/*                                                          @Y30LB02*/
*   ELSE                    /*PROCESS LEN AND OPC FOR VOF    @Y30LB02*/
*    DO;                    /*                               @Y30LB02*/
*     ANS('VOFLEN=' ||QUOTE(VFLEN)|| 'X;'||
*     '  /*LENG-VARYOFF REQUEST BLOCK @Y30LB02*/')SKIP;
*     ANS('VOFOPCD=' ||QUOTE(VOFCOD)|| 'X;/*OPCODE FOR'||
*    ' VARYOFF REQ @Y30LB02*/')SKIP;
*    END;                                                  /*@Y30LB02*/
*/*                                                          @Y30LB02*/
*   IF TYPE(1)='VON' THEN     /*VARYON REQUEST?              @Y30LB02*/
*    IF FLAGS ^= '' THEN      /*FLAGS SPECIFIED              @Y30LB02*/
*     ANS('VONFLG=' ||FLAGS|| '; /*VALUE OF FLAGS @Y30LB02*/')SKIP;
*/*                                                          @Y30LB02*/
*   IF TYPE(1)='VOF' THEN     /*VARYOFF SPECIFIED?           @Y30LB02*/
*    IF FLAGS ^= '' THEN      /*FLAGS SPECIFIED?             @Y30LB02*/
*     ANS('VOFFLG=' ||FLAGS|| '; /*VALUE OF FLAGS @Y30LB02*/')SKIP;
*/*                                                          @Y30LB02*/
*   IF SSID ^= '' THEN          /*SSID SPECIFIED?            @Y30LB02*/
*    IF TYPE(1) = 'VON' THEN   /*VARYON SPECIFIED?           @Y30LB02*/
*     ANS('VONSSID=' ||SSID|| '; /*VALUE OF SSID @Y30LB02*/')SKIP;
*/*                                                          @Y30LB02*/
*   IF SSID ^= '' THEN          /*SSID SPECIFIED ?           @Y30LB02*/
*    IF TYPE(1) = 'VOF' THEN    /*VARYOFF SPECIFIED?         @Y30LB02*/
*     ANS('VOFSSID= ' ||SSID|| ';/*VALUE OF SSID @Y30LB02*/')SKIP;
*/*                                                          @Y30LB02*/
*   IF TYPE(1) = 'VON' THEN     /*TYPE EQUAL VARYON?         @Y30LB02*/
*     GO TO LINK;               /*BRCH TO LINK TO SVC        @Y30LB02*/
*/*                                                          @Y30LB02*/
*   IF RUA ^= '' THEN           /*RUA SPECIFIED?             @Y30LB02*/
*    IF TYPE(1) = 'VOF' THEN    /*TYPE EQUAL VARRYOFF?       @Y30LB02*/
*     ANS('VOFRUA= ' ||RUA|| ';/*VALUE OF RUA @Y30LB02*/')SKIP;
*/*                                                          @Y30LB02*/
*   IF ECB ^= ''  THEN    /*ECB SPECIFIED?                   @Y30LB02*/
*        ANS('VOFECB=ADDR' ||ECB||';/*ADDRESS OF ECB'||
*        ' @Y30LB02*/')SKIP;
*/*                                                          @Y30LB02*/
*LINK:
*     ANS('SVC   (126);/*INVOKE THE SVC @Y30LB02*/')SKIP;
*     ANS('RFY  ICBR1  UNRSTD;/*UNRESTRICT REG 1 @Y30LB02*/')SKIP;
*/*                                                          @Y30LB02*/
*FINISH:  RETURN CODE(RETCODE);                            /*@Y30LB02*/
*         %END;                                            /*@Y30LB02*/
