         TITLE 'ICBVMG00 - MSVC STATIC TEXT MESSAGE MODULE   -- MVS'
*                                                              @Y30LB22
* /* START OF SPECIFICATIONS ****                              @Y30LB22
*                                                              @Y30LB22
*01*  NAME = ICBVMG00                                          @Y30LB22
*                                                              @Y30LB22
*02*    ASSEMBLY-MODULE-NAME = ICBVMG00                        @Y30LB22
*                                                              @Y30LB22
*02*    DESCRIPTIVE-NAME = STATIC TEXT MESSAGE MODULE          @Y30LB22
*                                                              @Y30LB22
*02*    LOAD-MODULE-NAME = ICBVVI00                            @Y30LB22
*                                                              @Y30LB22
*02*    ALIASES = NONE                                         @Y30LB22
*                                                              @Y30LB22
*02*    CSECTS = ICBVMG00                                      @Y30LB22
*                                                              @Y30LB22
*01*  COPYRIGHT = NONE                                         @Y30LB22
*                                                              @Y30LB22
*01*  STATUS = OS/VS2 RELEASE 3, LEVEL 0                       @Y30LB22
*                                                              @Y30LB22
*01*  FUNCTION = CONTAINS NO EXECUTIBLE CODE, ONLY STATIC TEXT ENTRIES
*                REQUIRED BY ICBVOP00.  ENTRIES CONTAIN THE ADDRESS
*                OF MESSAGE, TEXT OF THE MESSAGE, LENGTH OF THE
*                MESSAGE, THE RETURN CODE, THE REASON CODE, THE
*                DESCRIPTOR CODE, AND THE ROUTING CODE.  FLAGS ARE
*                ALSO SET TO INDICATE WHETHER THE MESSAGE IS FOR
*                THE OPERATOR, THE LIBRARIAN, OR THE OPERATOR WITH
*                REPLY, OR ANY COMBINATION THEREOF.  ENTRIES CAN ALSO
*                CONTAIN DISPLACEMENT AND LENGTH VALUES USED TO INSERT
*                VARIABLE TEXT DATA.                           @Y30LB22
*                                                              @Y30LB22
*01*  OPERATION = NONE                                         @Y30LB22
*                                                              @Y30LB22
*01*  NOTES = NONE                                             @Y30LB22
*                                                              @Y30LB22
*02*    CHARACTER-CODE-DEPENDENCIES = EBCDIC                   @Y30LB22
*                                                              @Y30LB22
*02*    DEPENDENCIES = NONE                                    @Y30LB22
*                                                              @Y30LB22
*02*    RESTRICTIONS = NONE                                    @Y30LB22
*                                                              @Y30LB22
*02*    REGISTER-CONVENTIONS = N/A                             @Y30LB22
*                                                              @Y30LB22
*02*    PATCH AREA = N/A                                       @Y30LB22
*                                                              @Y30LB22
*01*  MODULE-TYPE = TABLES                                     @Y30LB22
*                                                              @Y30LB22
*02*    PROCESSOR = ASSEMBLER                                  @Y30LB22
*                                                              @Y30LB22
*02*    MODULE-SIZE = 6225 BYTES                               @G24LB04
*                                                              @Y30LB22
*02*    ATTRIBUTES = READ ONLY                                 @Y30LB22
*                                                              @Y30LB22
*01*  ENTRY-POINT = ICBVMG00, ADDRESS OF START OF CSECT.       @Y30LB22
*                                                              @Y30LB22
*01*  EXTERNAL-REFERENCES = N/A                                @Y30LB22
*                                                              @Y30LB22
*01*  TABLES = MESSAGE ADDRESS TABLE CONTAINED HEREIN.         @Y30LB22
*                                                              @Y30LB22
*01*  MACROS = N/A                                             @Y30LB22
*                                                              @Y30LB22
*01*  MESSAGES = N/A                                           @Y30LB22
*
*01*  CHANGE-ACTIVITY = AS FOLLOWS
*
*        CHANGE 01 01/28/75 ADD MSGS 473 AND 474. UPDATE MSGS  @VS34320
*        422, 432, 446, 467, 472, AND 474.
*
*        CHANGE 02 02/20/75 ADD MSGS 475 AND 476               @ZM30724
*
*        CHANGE 03 03/18/75 UPDATE 409                         @ZM30746
*
*        CHANGE 04 05/12/75 UPDATE MSGS 463, 464, AND 465      @ZM31067
*
*        CHANGE 05 07/01/75 INSURE SYS PROG MSGS ARE ROUTED TO
*        SYS OPER CONSOLE                                      @ZM31103
*
*        CHANGE 06 11/4/75 ADD MESSAGE 477                     @ZM31134
*
*        CHANGE 07 01/29/76 CHANGE MSG 473 TO INDICATE VUA     @OX10810
*
*        CHANGE 08 03/23/76 CHANGE 2 DGT FDBK TO 3 DIGIT       @OZ09533
*
*        CHANGE 09 04/05/76 ADD MESSAGE ICB480I                @OZ09538
*
*        CHANGE 10 12/21/75 ADD MESSAGE 478                    @ZA09550
*
*        CHANGE 11 01/19/76 ADD MESSAGE 479  (SU18)            @G18MB04
*
*        CHANGE 12 06/07/76 ALLOCATE TO MOUNTED VOLUMES (SU24) @G24LB04
*                           MESSAGES 481, 482 AND 483          @G24LB04
*
*        CHANGE 13 10/20/77 ELIMINATE REDUNDANT ACQUIRES       @ZA27588
*
*        CHANGE 14 10/21/77 SPACE ACCOUNTING, ADD MSG 441      @ZA28479
*                           CHANGE MESSAGE ICB408I             @ZA28479
*
**** END OF SPECIFICATIONS ***/                                @Y30LB22
         EJECT
**********************************************************************
*                                                                    *
*        THE FOLLOWING IS A DESCRIPTION OF THE MACRO AND ITS OPTIONS *
*                                                                    *
**********************************************************************
*                                                              @Y30LB22
*  THE MACRO                                                   @Y30LB22
*                                                              @Y30LB22
*     PROCESSOR = ASSEM                                        @Y30LB22
*                                                              @Y30LB22
*     MESSAGES = MESSAGE TEXT MUST BE SPECIFIED                @Y30LB22
*                REASON CODE OPERAND MUST BE SPECIFIED         @Y30LB22
*                NN IS INVALID DESCRIPTOR - IGNORED            @Y30LB22
*                NN IS INVALID ROUTE - IGNORED                 @Y30LB22
*                NN IS INVALID FLAG  - IGNORED                 @Y30LB22
*                                                              @Y30LB22
*     TEXT     = THE TEXT OF THE MESSAGE.  IT IS A REQUIRED    @Y30LB22
*                POSITIONAL PARAMETER.  AND IT MUST BE LESS    @Y30LB22
*                THAN OR EQUAL TO 72 CHARACTERS IN LENGTH.     @Y30LB22
*                                                              @Y30LB22
*     RSNCODE  = REASON CODE.  A 4 DIGIT HEX NUMBER WHICH      @Y30LB22
*                MUST BE SPECIFIED,  AND WHOSE VALUE RANGE     @Y30LB22
*                is 0000 OR 0200 thru 0300.                    @Y30LB22
*                                                              @Y30LB22
*     RTNCODE  = RETURN CODE.  A SINGLE DIGIT NUMBER WHOSE     @Y30LB22
*                DEFAULT VALUE IS 0.                           @Y30LB22
*                                                              @Y30LB22
*     ROUTCDE  = ROUTING CODE.  A NUMBER WHOSE VALUE RANGE IS  @Y30LB22
*                1 THRU 16, AND WHOSE DEFAULT VALUE IS 2.      @Y30LB22
*                                                              @Y30LB22
*     DESC     = DESCRIPTOR CODE.  A NUMBER WHOSE VALUE RANGE  @Y30LB22
*                IS 1 THUR 16, AND WHOSE DEFAULT VALUE IS 4.   @Y30LB22
*                                                              @Y30LB22
*     FLAGS    = MESSAGE INDICATORS, AS FOLLOWS;               @Y30LB22
*                FLAGS = 1 IS OPERATOR ONLY                    @Y30LB22
*                FLAGS = 2 IS LIBRARIAN ONLY                   @Y30LB22
*                FLAGS = (1,2) IS BOTH OPERATOR AND LIBRARIAN  @Y30LB22
*                FLAGS = (1,3) IS WRITE TO OPERATOR WITH REPLY @Y30LB22
*                                                              @Y30LB22
*  VARIABLE LENGTH AND LOCATION FACILITY                       @Y30LB22
*                                                              @Y30LB22
*     OLEN     = THE NUMBER OF BYTES INDICATING THE SIZE OF    @Y30LB22
*                THE ITH REPLACEMENT DATA.                     @Y30LB22
*     OLOC     = THE OFFSET NUMBER OF BYTES FROM THE BEGINNING @Y30LB22
*                OF THE MESSAGE TEXT TO THE LOCATION OF THE    @Y30LB22
*                ITH rEPLACEMENT DATA.                         @Y30LB22
*                                                              @Y30LB22
         EJECT
         MACRO                                                 @Y30LB22
         MSGDEF &TEXT,&RSNCODE=,&RTNCODE=0,&ROUTCDE=2,&DESC=4, @Y30LB22*
               &FLAGS=,&OLEN1=0,&OLEN2=0,&OLEN3=0,&OLEN4=0,    @Y30LB22*
               &OLEN5=0,&OLOC1=0,&OLOC2=0,&OLOC3=0,&OLOC4=0,   @Y30LB22*
               &OLOC5=0                                        @Y30LB22
         LCLC  &NAME,&ANAME,&CD(5)                             @Y30LB22
         LCLA  &I,&N,&RTN,&MLEN,&LEN1,&LEN2,&LEN3,&LEN4,&LEN5  @Y30LB22
         LCLA  &LOC1,&LOC2,&LOC3,&LOC4,&LOC5                   @Y30LB22
         LCLB  &B(40)                                          @Y30LB22
         AIF   (T'&TEXT NE 'O').RSCHK                          @Y30LB22
         MNOTE 8,'MESSAGE TEXT MUST BE SPECIFIED'              @Y30LB22
.RSCHK  ANOP                                                   @Y30LB22
&NAME    SETC  '&TEXT'(2,6)                                    @Y30LB22
&ANAME   SETC  '&TEXT'(5,3)                                    @Y30LB22
         AIF   (T'&RSNCODE NE 'O').DSCHK                       @Y30LB22
         MNOTE 8,'REASON CODE OPERAND MUST BE SPECIFIED'       @Y30LB22
.DSCHK   ANOP                                                  @Y30LB22
&RTN     SETA  &RTNCODE                                        @Y30LB22
.*                                                             @Y30LB22
.* DESCRIPTOR CODES                                            @Y30LB22
.*                                                             @Y30LB22
&I       SETA  1                                               @Y30LB22
.DCHK    AIF   (T'&DESC EQ 'O').RCHK                           @Y30LB22
&N       SETA  &DESC(&I)                                       @Y30LB22
&I       SETA  &I+1                                            @Y30LB22
         AIF   (&N GE 1 AND &N LE 16).ASSIGND                  @Y30LB22
         MNOTE 8,'&DESC(&I) IS INVALID DESCRIPTOR - IGNORED'   @Y30LB22
         AGO   .NXTD                                           @Y30LB22
.ASSIGND ANOP                                                  @Y30LB22
&B(&N)   SETB  1                                               @Y30LB22
.NXTD    AIF  (&I LE N'&DESC).DCHK                             @Y30LB22
&I       SETA  1                                               @Y30LB22
.*                                                             @Y30LB22
.* ROUTE CODES                                                 @Y30LB22
.*                                                             @Y30LB22
.RCHK    AIF   (T'&ROUTCDE EQ 'O').FCHK                        @Y30LB22
&N       SETA  &ROUTCDE(&I)                                    @Y30LB22
&I       SETA  &I+1                                            @Y30LB22
         AIF   (&N GE 1 AND &N LE 16).ASSIGNR                  @Y30LB22
         MNOTE 8,'ROUTCDE(&I) IS INVALID ROUTE - IGNORED'      @Y30LB22
         AGO   .NXTR                                           @Y30LB22
.ASSIGNR ANOP                                                  @Y30LB22
&B(&N+16) SETB  1                                              @Y30LB22
.NXTR    AIF   (&I LE N'&ROUTCDE).RCHK                         @Y30LB22
&I       SETA  1                                               @Y30LB22
.*                                                             @Y30LB22
.* FLAGS                                                       @Y30LB22
.*                                                             @Y30LB22
&I       SETA  1                                               @Y30LB22
.FCHK    AIF   (T'&FLAGS EQ 'O').ASSIGNC                       @Y30LB22
&N       SETA  &FLAGS(&I)                                      @Y30LB22
&I       SETA  &I+1                                            @Y30LB22
         AIF   (&N GE 1 AND &N LE 4).ASSIGNF                   @Y30LB22
         MNOTE 8,'&FLAGS(&I) IS INVALID FLAG - IGNORED'        @Y30LB22
         AGO   .NXTF                                           @Y30LB22
.ASSIGNF ANOP                                                  @Y30LB22
&B(&N+32) SETB  1                                              @Y30LB22
.NXTF    AIF   (&I LE N'&FLAGS).FCHK                           @Y30LB22
.ASSIGNC ANOP                                                  @Y30LB22
&I       SETA  1                                               @Y30LB22
&CD(&I)   SETC  '&B(1)&B(2)&B(3)&B(4)&B(5)&B(6)&B(7)&B(8)'     @Y30LB22
&CD(&I+1) SETC  '&B(9)&B(10)&B(11)&B(12)&B(13)&B(14)&B(15)&B(16)'
&CD(&I+2) SETC  '&B(17)&B(18)&B(19)&B(20)&B(21)&B(22)&B(23)&B(24)'
&CD(&I+3) SETC  '&B(25)&B(26)&B(27)&B(28)&B(29)&B(30)&B(31)&B(32)'
&CD(&I+4) SETC  '&B(33)&B(34)&B(35)&B(36)&B(37)&B(38)&B(39)&B(40)'
&LEN1    SETA  &OLEN1                                          @Y30LB22
&LEN2    SETA  &OLEN2                                          @Y30LB22
&LEN3    SETA  &OLEN3                                          @Y30LB22
&LEN4    SETA  &OLEN4                                          @Y30LB22
&LEN5    SETA  &OLEN5                                          @Y30LB22
&LOC1    SETA  &OLOC1                                          @Y30LB22
&LOC2    SETA  &OLOC2                                          @Y30LB22
&LOC3    SETA  &OLOC3                                          @Y30LB22
&LOC4    SETA  &OLOC4                                          @Y30LB22
&LOC5    SETA  &OLOC5                                          @Y30LB22
&MLEN    SETA  K'&TEXT-2                                       @Y30LB22
         DS    0F                                              @Y30LB22
&NAME    DC    XL2'&RSNCODE'           REASON CODE             @Y30LB22
         DC    AL2(&RTN)               RETURN CODE             @Y30LB22
         DC    BL2'&CD(3)&CD(4)'       ROUTE CODE              @Y30LB22
         DC    BL2'&CD(1)&CD(2)'       DESCRIPTION CODE        @Y30LB22
         DC    AL1(&MLEN)              MESSAGE LENGTH          @Y30LB22
         DC    AL3(A&ANAME)            MESSAGE LOCATION        @Y30LB22
         DC    BL1'&CD(5)'             FLAGS                   @Y30LB22
         DC    AL1(0)                  RESERVED                @Y30LB22
         DC    AL1(&LEN1)              COMPLETION TEXT1 LENGTH @Y30LB22
         DC    AL1(&LOC1)              COMPLETION TEXT1 LOCATION
         DC    AL1(&LEN2)              COMPLETION TEXT2 LENGTH @Y30LB22
         DC    AL1(&LOC2)              COMPLETION TEXT2 LOCATION
         DC    AL1(&LEN3)              COMPLETION TEXT3 LENGTH @Y30LB22
         DC    AL1(&LOC3)              COMPLETION TEXT3 LOCATION
         DC    AL1(&LEN4)              COMPLETION TEXT4 LENGTH @Y30LB22
         DC    AL1(&LOC4)              COMPLETION TEXT4 LOCATION
         DC    AL1(&LEN5)              COMPLETION TEXT5 LENGTH @Y30LB22
         DC    AL1(&LOC5)              COMPLETION TEXT5 LOCATION
A&ANAME  DC C&TEXT
         SPACE 1                                               @Y30LB22
         MEND                                                  @Y30LB22
         EJECT                                                 @Y30LB22
**********************************************************************
*                                                                    *
* THIS MODULE IS THE MSVC STATIC TEXT MESSAGE MODULE                 *
*                                                                    *
**********************************************************************
ICBVMG00 CSECT                                                 @Y30LB22
*                                                              @Y30LB22
* MESSAGE ADDRESS TABLE                                        @Y30LB22
*                                                              @Y30LB22
LIMITADR DC    A(MSGLIMIT)                                     @Y30LB22
MSGTABLE DC    A(ICB400)                                       @Y30LB22
         DC    A(ICB401)                                       @Y30LB22
         DC    A(ICB402)                                       @Y30LB22
         DC    A(ICB403)                                       @Y30LB22
         DC    A(ICB404)                                       @Y30LB22
         DC    A(ICB405)                                       @Y30LB22
         DC    A(0)                                            @Y30LB22
         DC    A(ICB407)                                       @Y30LB22
         DC    A(ICB408)                                       @Y30LB22
         DC    A(ICB409)                                       @Y30LB22
         DC    A(ICB410)                                       @Y30LB22
         DC    A(ICB411)                                       @Y30LB22
         DC    A(ICB412)                                       @Y30LB22
         DC    A(ICB413)                                       @Y30LB22
         DC    A(ICB414)                                       @Y30LB22
         DC    A(ICB415)                                       @Y30LB22
         DC    A(ICB416)                                       @Y30LB22
         DC    A(ICB417)                                       @Y30LB22
         DC    A(ICB418)                                       @Y30LB22
         DC    A(ICB419)                                       @Y30LB22
         DC    A(ICB420)                                       @Y30LB22
         DC    A(ICB421)                                       @Y30LB22
         DC    A(ICB422)                                       @Y30LB22
         DC    A(ICB423)                                       @Y30LB22
         DC    A(ICB424)                                       @Y30LB22
         DC    A(ICB425)                                       @Y30LB22
         DC    A(ICB426)                                       @Y30LB22
         DC    A(ICB427)                                       @Y30LB22
         DC    A(ICB428)                                       @Y30LB22
         DC    A(ICB429)                                       @Y30LB22
         DC    A(ICB430)                                       @Y30LB22
         DC    A(ICB431)                                       @Y30LB22
         DC    A(ICB432)                                       @Y30LB22
         DC    A(ICB433)                                       @Y30LB22
         DC    A(ICB434)                                       @ZA27588
         DC    A(ICB435)                                       @Y30LB22
         DC    A(ICB436)                                       @Y30LB22
         DC    A(ICB437)                                       @Y30LB22
         DC    A(ICB438)                                       @Y30LB22
         DC    A(ICB439)                                       @Y30LB22
         DC    A(ICB440)                                       @Y30LB22
         DC    A(ICB441)                                       @ZA28479
         DC    A(ICB442)                                       @Y30LB22
         DC    A(ICB443)                                       @Y30LB22
         DC    A(ICB444)                                       @Y30LB22
         DC    A(ICB445)                                       @Y30LB22
         DC    A(ICB446)                                       @Y30LB22
         DC    A(ICB447)                                       @Y30LB22
         DC    A(ICB448)                                       @Y30LB22
         DC    A(ICB449)                                       @Y30LB22
         DC    A(ICB450)                                       @Y30LB22
         DC    A(ICB451)                                       @Y30LB22
         DC    A(ICB452)                                       @Y30LB22
         DC    A(ICB453)                                       @Y30LB22
         DC    A(ICB454)                                       @Y30LB22
         DC    A(ICB455)                                       @Y30LB22
         DC    A(ICB456)                                       @Y30LB22
         DC    A(ICB457)                                       @Y30LB22
         DC    A(ICB458)                                       @Y30LB22
         DC    A(ICB459)                                       @Y30LB22
         DC    A(ICB460)                                       @Y30LB22
         DC    A(ICB461)                                       @Y30LB22
         DC    A(ICB462)                                       @Y30LB22
         DC    A(ICB463)                                       @Y30LB22
         DC    A(ICB464)                                       @Y30LB22
         DC    A(ICB465)                                       @Y30LB22
         DC    A(ICB466)                                       @Y30LB22
         DC    A(ICB467)                                       @Y30LB22
         DC    A(ICB468)                                       @Y30LB22
         DC    A(ICB469)                                       @Y30LB22
         DC    A(ICB470)                                       @Y30LB22
         DC    A(ICB471)                                       @Y30LB22
         DC    A(ICB472)                                       @Y30LB22
         DC    A(ICB473)                                       @YM03240
         DC    A(ICB474)                                       @YM03240
         DC    A(ICB475)                                       @ZM30724
         DC    A(ICB476)                                       @ZM30724
         DC    A(ICB477)                                       @ZM31134
         DC    A(ICB478)                                       @ZA09550
         DC    A(ICB479)                                       @G18MB04
         DC    A(ICB480)                                       @OZ09538
         DC    A(ICB481)                                       @G24LB04
         DC    A(ICB482)                                       @G24LB04
         DC    A(ICB483)                                       @G24LB04
MSGLIMIT DC    A((*-MSGTABLE)/4)                               @Y30LB22
         EJECT                                                 @Y30LB22
         MSGDEF 'ICB400I VOLUME        WAS NOT LOCATED DURING THE UCB S*
               CAN',RSNCODE=0000,OLEN1=6,OLOC1=16,FLAGS=(1,2)  @ZM31103
         EJECT                                                 @Y30LB22
         MSGDEF 'ICB401I LSPACE FAILURE ON VOLUME        - RETURN CODE *
                   ',RSNCODE=0000,OLEN1=6,OLOC1=34,OLEN2=4,OLOC2=55,   *
               FLAGS=(1,2)                                     @ZM31103
         EJECT                                                 @Y30LB22
         MSGDEF 'ICB402I VOLUME        NOT FOUND IN MSVC INVENTORY',   *
               RSNCODE=0000,OLEN1=6,OLOC1=16,FLAGS=2           @Y30LB22
         EJECT                                                 @Y30LB22
         MSGDEF 'ICB403I GROUP          NOT FOUND FOR VOLUME       ',  *
               RSNCODE=0000,OLEN1=8,OLOC1=15,OLEN2=6,OLOC2=45, @Y30LB22*
               FLAGS=2                                         @Y30LB22
         EJECT                                                 @Y30LB22
         MSGDEF 'ICB404I THE HOST CPUID DID NOT MATCH CPUID RECORD ENTR*
               Y',RSNCODE=022B,RTNCODE=4,FLAGS=(1,2)           @ZM31103
         EJECT                                                 @Y30LB22
         MSGDEF 'ICB405I MSVI I/O ERROR: ',OLEN1=36,           @Y30LB22*
               OLOC1=25,FLAGS=(1,2),RSNCODE=0000               @Y30LB22
         EJECT                                                 @Y30LB22
         MSGDEF 'ICB407I NO VOLUME IN GROUP          MATCHES SELECTION *
               REQUIREMENTS',RSNCODE=0000,OLEN1=8,OLOC1=28,    @Y30LB22*
               FLAGS=2                                         @Y30LB22
         EJECT                                                 @Y30LB22
         MSGDEF 'ICB408I GROUP          HAS REACHED ITS THRESHOLD OF TO*
               TAL SPACE',RSNCODE=0000,OLEN1=8,OLOC1=15,       @ZA28479*
               FLAGS=2                                         @ZA28479
         EJECT                                                 @Y30LB22
         MSGDEF 'ICB409I NO STORAGE AVAILABLE',FLAGS=(1,2),    @Y30LB22*
               RSNCODE=0234,RTNCODE=4                          @ZM30746
         EJECT                                                 @Y30LB22
         MSGDEF 'ICB410I CPUID RECORD COULD NOT BE READ',FLAGS=(1,2),  *
               RSNCODE=0000                                    @Y30LB22
         EJECT                                                 @Y30LB22
         MSGDEF 'ICB411I UNABLE TO RESTORE BASE VOLUME        RECORD', *
               RSNCODE=0000,FLAGS=(1,2),OLEN1=6,OLOC1=39       @ZM31103
         EJECT                                                 @Y30LB22
         MSGDEF 'ICB412I ',FLAGS=(1,2),RSNCODE=0000,OLEN1=52,OLOC1=9
         EJECT                                                 @Y30LB22
         MSGDEF 'ICB413I REQUEST TYPE COULD NOT BE DETERMINED BY THE MS*
               VC I/O PROCESSOR',RSNCODE=0000,FLAGS=(1,2)      @ZM31103
         EJECT                                                 @Y30LB22
         MSGDEF 'ICB414I MSVI VSAM RETURN CODE IS   , FEEDBACK IS    ',*
               RSNCODE=0000,FLAGS=(1,2),OLEN1=2,OLOC1=34,      @OZ09533*
               OLEN2=3,OLOC2=50                                @OZ09533
         EJECT                                                 @Y30LB22
         MSGDEF 'ICB415I GROUP          NOT FOUND IN THE MSVC INVENTORY*
               ',RSNCODE=0000,FLAGS=2,OLEN1=8,OLOC1=15
         EJECT                                                 @Y30LB22
         MSGDEF 'ICB416I ICBVVICB NOT INITIALIZED',RTNCODE=4,FLAGS=1,  *
               RSNCODE=0233                                    @Y30LB22
         EJECT                                                 @Y30LB22
         MSGDEF 'ICB417I CPU ASSOCIATION RECORD EXHAUSTED',RTNCODE=4,  *
               RSNCODE=0234,FLAGS=(1,2)                        @Y30LB22
         EJECT                                                 @Y30LB22
         MSGDEF 'ICB418I MSVC ENABLE SUCCESSFUL',RSNCODE=0000,         *
               FLAGS=(1,2)                                     @Y30LB22
         EJECT                                                 @Y30LB22
         MSGDEF 'ICB419D REPLY Y CONT WITH MSVC DISABLED, N CONT WITHOU*
               T 3850; OR REIPL',RSNCODE=0000,FLAGS=(1,3),DESC=2
         EJECT                                                 @Y30LB22
         MSGDEF 'ICB420I MSVC PARAMETERS - ',RSNCODE=0000,     @Y30LB22*
               FLAGS=1                                         @Y30LB22
         EJECT                                                 @Y30LB22
         MSGDEF 'ICB421I MESSAGE ID         WAS NOT FOUND IN MESSAGE TA*
               BLE',RSNCODE=0000,FLAGS=(1,2),OLEN1=7,OLOC1=20  @ZM31103
         EJECT                                                 @Y30LB22
         MSGDEF 'ICB422I SYS1.PARMLIB(MVIKEY00) SPECIFICATION ERROR -  *
               ',FLAGS=1,OLEN1=4,OLOC1=54,RSNCODE=0000         @YM04320
         EJECT                                                 @Y30LB22
         MSGDEF 'ICB423D REPLY WITH MSVC PARAMETERS OR U',     @Y30LB22*
               RSNCODE=0000,FLAGS=(1,3),DESC=2                 @Y30LB22
         EJECT                                                 @Y30LB22
         MSGDEF 'ICB424I INVALID REQUEST DURING SYSTEM INITIALIZATION',*
               RSNCODE=0216,FLAGS=1,RTNCODE=4                  @Y30LB22
         EJECT                                                 @Y30LB22
         MSGDEF 'ICB425I ABEND IN PROCESS FOR MSVC TASK (        )',   *
               RSNCODE=0200,FLAGS=1,RTNCODE=4,OLEN1=8,OLOC1=40 @Y30LB22
         EJECT                                                 @Y30LB22
         MSGDEF 'ICB426I RECURSIVE ABEND IN MSVC TASK (ICBVPR00)',     *
               RSNCODE=0200,FLAGS=1,RTNCODE=4                  #Y30LB22
         EJECT                                                 #Y30LB22
         MSGDEF 'ICB427I INVENTORY ALREADY RESERVED BY TASK',  @Y30LB22*
               RSNCODE=0000,FLAGS=(1,2)                        @ZM31103
         EJECT                                                 @Y30LB22
         MSGDEF 'ICB428I JOURNAL ALREADY RESERVED BY TASK',    @Y30LB22*
               RSNCODE=0000,FLAGS=(1,2)                        @ZM31103
         EJECT                                                 @Y30LB22
         MSGDEF 'ICB429I REQUEST TYPE COULD NOT BE DETERMINED BY THE RE*
               SERVE PROCESSOR',RSNCODE=0000,FLAGS=(1,2)       @ZM31103
         EJECT                                                 @Y30LB22
         MSGDEF 'ICB430I INVENTORY NOT RESERVED BY TASK',      @Y30LB22*
               RSNCODE=0000,FLAGS=(1,2)                        @ZM31103
         EJECT                                                 @Y30LB22
         MSGDEF 'ICB431I JOURNAL NOT RESERVED BY TASK',        @Y30LB22*
               RSNCODE=0000,FLAGS=(1,2)                        @ZM31103
         EJECT                                                 @Y30LB22
         MSGDEF 'ICB432I MSVC PURGE|ASSC|DISASSC|SUSPEND FAILURE -  ', *
               FLAGS=(1,2),OLEN1=2,OLOC1=51,RSNCODE=0000,RTNCODE=4
         EJECT                                                 @Y30LB22
         MSGDEF 'ICB433I UNABLE TO ESTABLISH RECOVERY ENVIRONMENT -    *
                     -     ',FLAGS=1,RSNCODE=0000,             @Y30LB22*
               OLEN1=8,OLOC1=52,OLEN2=4,OLOC2=63               @Y30LB22
         EJECT                                                 @Y30LB22
         MSGDEF 'ICB434I MSS VOLUME TRACKING INHIBITED - NO STORAGE AVA*
               ILABLE',FLAGS=1,RSNCODE=0000                    @ZA27588
         EJECT                                                 @Y30LB22
         MSGDEF 'ICB435D REPLY (ENABLE, DISABLE, DISABLEJ), HOSTID=(ONL*
               INE,OFFLINE)',FLAGS=1,RSNCODE=0000              @ZM31103
         EJECT                                                 #Y30LB22
         MSGDEF 'ICB436D ICBVDR01 PARMS REPLY (RECOVER, BACKUP, PRINT)'*
               ,FLAGS=1,RSNCODE=0000                           @ZM31103
         EJECT                                                 #Y30LB22
         MSGDEF 'ICB437I          ERROR DURING SUBTASK PROCESSING CODE=*
                   ',FLAGS=1,RSNCODE=0000,OLEN1=8,OLOC1=9      #Y30LB22*
               OLEN2=4,OLOC2=55                                #Y30LB22
         EJECT                                                 #Y30LB22
         MSGDEF 'ICB438I UNABLE TO LOCATE THE ENTRY ADDRESS OF ICBVQM00*
               ',FLAGS=1,RSNCODE=0233,RTNCODE=4                @Y30LB22
         EJECT                                                 @Y30LB22
         MSGDEF 'ICB439I          ABNORMALLY TERMINATED -         ',   *
               FLAGS=1,RSNCODE=0233,OLEN1=8,OLOC1=9,OLEN2=8,OLOC2=42,  *
               RTNCODE=4                                       @Y30LB22
         EJECT                                                 @Y30LB22
         MSGDEF 'ICB440I UNABLE TO ESTABLISH THE MSVC TASK         ',  *
               FLAGS=1,RSNCODE=0233,RTNCODE=4,OLEN1=8,OLOC1=43 @Y30LB22
         EJECT                                                 @ZA28479
         MSGDEF 'ICB441I GROUP          HAS REACHED ITS THRESHOLD OF SE*
               LECTABLE SPACE',RSNCODE=0000,OLEN1=8,OLOC1=15,  @ZA28479*
               FLAGS=2                                         @ZA28479
         EJECT                                                 @Y30LB22
         MSGDEF 'ICB442I DYNAMIC ALLOCATION ERROR - MSVC INVENTORY -   *
                 ',FLAGS=(1,2),RSNCODE=0234,RTNCODE=4,OLEN1=4,OLOC1=53
         EJECT                                                 @Y30LB22
         MSGDEF 'ICB443I DYNAMIC ALLOCATION ERROR - MSVC JOURNAL -     *
               ',FLAGS=(1,2),RSNCODE=0234,RTNCODE=4,OLEN1=4,OLOC1=51
         EJECT                                                 @Y30LB22
         MSGDEF 'ICB444I OPEN ERROR - MSVC INVENTORY -     ',          *
               FLAGS=(1,2),RSNCODE=0234,RTNCODE=4,OLEN1=4,OLOC1=39
         EJECT                                                 @Y30LB22
         MSGDEF 'ICB445I VOLUME        NOT FOUND FOR GROUP         ',  *
               FLAGS=2,RSNCODE=0000,OLEN1=6,OLOC1=16,OLEN2=8,OLOC2=43
         EJECT                                                 @Y30LB22
         MSGDEF 'ICB446I OPEN ERROR - MSVC JOURNAL',           @YM04320*
               FLAGS=(1,2),RSNCODE=0234,RTNCODE=4              @YM04320
         EJECT                                                 @Y30LB22
         MSGDEF 'ICB447I MSVC ENQ/RESERVE FAILURE -     ',     @YM31067*
               FLAGS=(1,2),RSNCODE=0234,RTNCODE=4,OLEN1=4,OLOC1=36
         EJECT                                                 @Y30LB22
         MSGDEF 'ICB448I MSVC JOURNAL FAILURE -     ',         @Y30LB22*
               FLAGS=(1,2),RSNCODE=0234,RTNCODE=4,OLEN1=4,OLOC1=32
         EJECT                                                 @Y30LB22
         MSGDEF 'ICB449I I/O ERROR MSVC INVENTORY -              -     *
               ',RTNCODE=4,FLAGS=(1,2),RSNCODE=0234,           @Y30LB22*
               OLEN1=12,OLOC1=36,OLEN2=4,OLOC2=51              @Y30LB22
         EJECT                                                 @Y30LB22
         MSGDEF 'ICB450I DYNAMIC DE-ALLOCATION ERROR - MSVC INVENTORY -*
                    ',FLAGS=(1,2),RSNCODE=0234,RTNCODE=4,      @Y30LB22*
               OLEN1=4,OLOC1=56                                @Y30LB22
         EJECT                                                 @Y30LB22
         MSGDEF 'ICB451I DYNAMIC DE-ALLOCATION ERROR - MSVC JOURNAL -  *
                  ',FLAGS=(1,2),RSNCODE=0234,RTNCODE=4,        @Y30LB22*
               OLEN1=4,OLOC1=54                                @Y30LB22
         EJECT                                                 @Y30LB22
         MSGDEF 'ICB452I CLOSE ERROR - MSVC INVENTORY -     ',         *
               FLAGS=(1,2),RSNCODE=0234,RTNCODE=4,             @Y30LB22*
               OLEN1=4,OLOC1=40                                @Y30LB22
         EJECT                                                 @Y30LB22
         MSGDEF 'ICB453I CLOSE ERROR - MSVC JOURNAL',          @ZM30724*
               FLAGS=(1,2),RSNCODE=0234,RTNCODE=4              @ZM30724
         EJECT                                                 @Y30LB22
         MSGDEF 'ICB454I MSVC ALREADY ENABLED',                @Y30LB22*
               FLAGS=(1,2),RSNCODE=0000                        @Y30LB22
         EJECT                                                 @Y30LB22
         MSGDEF 'ICB455I MSVC DISABLE SUCCESSFUL',             @Y30LB22*
               FLAGS=(1,2),RSNCODE=0000                        @Y30LB22
         EJECT                                                 @Y30LB22
         MSGDEF 'ICB456I                                            ', *
               FLAGS=1,RSNCODE=0000,OLEN1=60,OLOC1=9           @Y30LB22
         EJECT                                                 @Y30LB22
         MSGDEF 'ICB457I PARAMETER SPECIFICATION ERROR',       @Y30LB22*
               FLAGS=1,RSNCODE=0000                            @Y30LB22
         EJECT                                                 @Y30LB22
         MSGDEF 'ICB458I I/O ERROR - MSVC JOURNAL CONTROL RECORD',     *
               FLAGS=(1,2),RSNCODE=023A,RTNCODE=4              @Y30LB22
         EJECT                                                 @Y30LB22
         MSGDEF 'ICB459I I/O ERROR - MSVC JOURNAL DATA RECORD',        *
               FLAGS=(1,2),RSNCODE=0000                        @Y30LB22
         EJECT                                                 @Y30LB22
         MSGDEF 'ICB460I                                               *
                     ',FLAGS=(1,2),RSNCODE=0000,OLEN1=61,OLOC1=9
         EJECT                                                 @Y30LB22
         MSGDEF 'ICB461I MSVC JRNL PROCESSING CONTINUES WITH NEXT TRACK*
               ',FLAGS=(1,2),RSNCODE=0000                      @Y30LB22
         EJECT                                                 @Y30LB22
         MSGDEF 'ICB462I FOUR TRACKS IS MIN MSVC JRNL ALLOCATION',     *
               FLAGS=(1,2),RSNCODE=023A,RTNCODE=4              @Y30LB22
         EJECT                                                 @Y30LB22
         MSGDEF 'ICB463E MSVC JOURNAL THRESHOLD EXCEEDED',     @YM31067*
               FLAGS=(1,2),RSNCODE=023A,RTNCODE=4,DESC=3       @YM31067
         EJECT                                                 @Y30LB22
         MSGDEF 'ICB464E MSVC JOURNAL EXHAUSTED',              @YM31067*
               FLAGS=(1,2),RSNCODE=023A,RTNCODE=4,DESC=3       @YM31067
         EJECT                                                 @Y30LB22
         MSGDEF 'ICB465E MSVC JOURNAL DATA LOST',              @YM31067*
               FLAGS=(1,2),RSNCODE=023A,RTNCODE=4,DESC=3       @YM31067
         EJECT                                                 @Y30LB22
         MSGDEF 'ICB466I INVALID ORDER -   ',OLEN1=2,OLOC1=25, @Y30LB22*
               FLAGS=(1,2),RSNCODE=0234,RTNCODE=4              @Y30LB22
         EJECT                                                 @Y30LB22
         MSGDEF 'ICB467I HOSTID NOT FOUND -      ',OLEN1=10,OLOC1=28,  *
               FLAGS=(1,2),RSNCODE=0239,RTNCODE=4              #Y30LB22
         EJECT                                                 #Y30LB22
         MSGDEF 'ICB468I MSVC USER CATLG VOL NOT MOUNTED -       ',    *
               FLAGS=(1,2),RSNCODE=0234,RTNCODE=4,OLEN1=6,OLOC1=43
         EJECT                                                 #Y30LB22
         MSGDEF 'ICB469I MSVC INVENTORY VOLUME NOT MOUNTED -       ',  *
               FLAGS=(1,2),RSNCODE=0234,RTNCODE=4,OLEN1=6,OLOC1=45
         EJECT                                                 #Y30LB22
         MSGDEF 'ICB470I MSVC JOURNAL VOLUME NOT MOUNTED -       ',    *
               FLAGS=(1,2),RSNCODE=0234,RTNCODE=4,OLEN1=6,OLOC1=43
         EJECT                                                 #Y30LB22
         MSGDEF 'ICB471I MSVC LOCATE ERROR -                   -     ',*
               FLAGS=(1,2),RSNCODE=0234,RTNCODE=4,OLEN1=17,OLOC1=29,   *
               OLEN2=4,OLOC2=49                                #YM04320
         EJECT                                                 #Y30LB22
         MSGDEF 'ICB472I SUSPEND FOR RECONFIGURATION INVALID - MSVC DIS*
               ABLED',FLAGS=(1,2),RSNCODE=0211,RTNCODE=4       #Y30LB22
         EJECT                                                 #Y30LB22
         MSGDEF 'ICB473I MOUNT FAILURE ON VUA     FOR VOLUME        - M*
               SC CODE     ',RSNCODE=0000,OLEN1=3,OLOC1=30,OLEN2=6,    *
               OLOC2=45,OLEN3=4,OLOC3=63,FLAGS=(1,2)           @OX10810
         EJECT                                                 #Y30LB22
         MSGDEF 'ICB474I MSVC ENABLE INVALID - 3850 INOPERATIVE',      *
               FLAGS=(1,2),RSNCODE=234,RTNCODE=4               @YM04320
         EJECT                                                 @ZM30724
         MSGDEF 'ICB475I OPEN ERROR - MSVC CATALOG -          -     ', *
               FLAGS=(1,2),RSNCODE=0234,RTNCODE=4,OLEN1=8,     @ZM30724*
               OLOC1=37,OLEN2=4,OLOC2=48                       @ZM30724
         EJECT                                                 @ZM30724
         MSGDEF 'ICB476I CLOSE ERROR - MSVC CATALOG -          -     ',*
               FLAGS=(1,2),RSNCODE=0234,RTNCODE=4,OLEN1=8,     @ZM30724*
               OLOC1=38,OLEN2=4,OLOC2=49                       @ZM30724
         EJECT                                                 @ZM31134
         MSGDEF 'ICB477I MSVC LOGICALLY DISABLED',                     *
               RSNCODE=0000,FLAGS=(1,2)                        @ZA09550
         EJECT                                                 @ZA09550
               MSGDEF 'ICB478I MSVC JOURNAL LOGICALLY DISABLED',       *
               FLAGS=(1,2),RSNCODE=023A,RTNCODE=4              @ZA09550
         EJECT                                                 @G18LB04
         MSGDEF 'ICB479I JES3 REJECTED MSVC SELECTION OF VOLUME       '*
               ,FLAGS=(2),RSNCODE=0000,RTNCODE=0,OLEN1=6,              *
               OLOC1=48                                        @G18MB04
         EJECT                                                 #Y30LB22
         MSGDEF 'ICB480I MSVC OBTAIN ERROR -                   -     ',*
               FLAGS=(1,2),RSNCODE=0234,RTNCODE=4,OLEN1=17,OLOC1=29,   *
               OLEN2=4,OLOC2=49                                @OZ09538
         EJECT                                                 @G18LB04
         MSGDEF 'ICB481I VOLUME        IN GROUP          EXPIRES      '*
               ,FLAGS=(2),RSNCODE=0000,RTNCODE=0,OLEN1=6,              *
               OLOC1=16,OLEN2=8,OLOC2=32,OLEN3=5,OLOC3=49      @G24LB04
         EJECT                                                 @G24LB04
         MSGDEF 'ICB482I INVALID DEVICE ADDRESS,     X, IN MOUNT FOR VO*
               LUME       ',FLAGS=(1,2),RSNCODE=023D,RTNCODE=4,        *
               OLEN1=4,OLOC1=33,OLEN2=6,OLOC2=60               @G24LB04
         EJECT                                                 @G24LB04
         MSGDEF 'ICB483I VOLUME        IN GROUP          HAS INVALID RU*
               NNING SPACE',FLAGS=(2),RSNCODE=0000,RTNCODE=0,OLEN1=6,  *
               OLOC1=16,OLEN2=8,OLOC2=32                       @G24LB04
         END   ICBVMG00                                        @Y30LB22
