UP00     TITLE '**********  ICBVUP00:  MSVC UNIT PROCESSOR MODULE  *****
               *******  '
ICBVUP00 CSECT ,                                                   0001
@MAINENT DS    0H                                                  0001
         USING *,@15                                               0001
         B     @PROLOG                                             0001
         DC    AL1(16)                                             0001
         DC    C'ICBVUP00  76.279'                                 0001
         DROP  @15
@PROLOG  STM   @14,@12,12(@13)                                     0001
         BALR  @12,0                                               0001
@PSTART  DS    0H                                                  0001
         USING @PSTART,@12                                         0001
         ST    @13,@SA00001+4                                      0001
         LA    @14,@SA00001                                        0001
         ST    @14,8(,@13)                                         0001
         LR    @13,@14                                             0001
         MVC   @PC00001(8),0(@01)                                  0001
*   VVIPTR=ADDR(VVICBLK);           /*                       @G24LB37*/
         L     VVIPTR,@PC00001+4                                   0069
*   UNITPTR=ADDR(UNITRPL);          /*                       @G24LB37*/
         L     UNITPTR,@PC00001                                    0070
*   RETCODE=FOUR;                   /*                       @G24LB37*/
*                                                                  0071
         LA    RETCODE,4                                           0071
*   /*****************************************************************/
*   /*                                                               */
*   /* IF, IN THE UNITP, THE UNIFMTD FLAG IS ON, REQUESTING  @G24LB37*/
*   /* THE UNIT PROCESSOR TO DETERMINE IF THE GIVEN VOLUME   @G24LB37*/
*   /* SERIAL IS MOUNTED ON A 3330V UNIT, WITHIN THE SYSTEM, @G24LB37*/
*   /* CALL SCANUCBS.                                        @G24LB37*/
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0072
*   IF UNIFMTD=ON THEN                                             0072
         TM    UNIFMTD(UNITPTR),B'10000000'                        0072
         BNO   @RF00072                                            0072
*     CALL SCANUCBS;                /*                       @G24LB37*/
*                                                                  0073
         BAL   @14,SCANUCBS                                        0073
*   /*****************************************************************/
*   /*                                                               */
*   /* IF THE UNIFINCL FLAG IS ON, THEN CALL UNITINCL TO     @G24LB37*/
*   /* DETERMINE IF THE SPECIFIED UCB ADDRESS IS INCLUDED    @G24LB37*/
*   /* OR NOT INCLUDED WITHIN THE SPECIFIED DEVICE TYPE.     @G24LB37*/
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0074
*   ELSE                                                           0074
*     IF UNIFINCL=ON THEN                                          0074
         B     @RC00072                                            0074
@RF00072 TM    UNIFINCL(UNITPTR),B'01000000'                       0074
         BNO   @RF00074                                            0074
*       CALL UNITINCL;              /*                       @G24LB37*/
*                                                                  0075
         BAL   @14,UNITINCL                                        0075
*   /*****************************************************************/
*   /*                                                               */
*   /* IF THE UNIFALLV FLAG IS ON, THEN CALL ALLVIRT TO      @G24LB37*/
*   /* DETERMINE IF THE SPECIFIED DEVICE TYPE IS ALL 3330V   @G24LB37*/
*   /* UNITS.                                                @G24LB37*/
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0076
*     ELSE                                                         0076
*       IF UNIFALLV=ON THEN                                        0076
         B     @RC00074                                            0076
@RF00074 TM    UNIFALLV(UNITPTR),B'00100000'                       0076
         BNO   @RF00076                                            0076
*         CALL ALLVIRT;             /*                       @G24LB37*/
         BAL   @14,ALLVIRT                                         0077
*                                                                  0078
*   /*****************************************************************/
*   /*                                                               */
*   /* RETURN TO CALLER. RETURN CODE IS RETURNED IN REG 15.  @G24LB37*/
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0078
*   RETURN CODE(RETCODE);           /* RETURN TO CALLER      @G24LB37*/
@RF00076 DS    0H                                                  0078
@RC00074 DS    0H                                                  0078
@RC00072 LR    @15,RETCODE                                         0078
         L     @13,4(,@13)                                         0078
         L     @14,12(,@13)                                        0078
         LM    @00,@12,20(@13)                                     0078
         BR    @14                                                 0078
*                                                                  0079
*/********************************************************************/
*/*                                                                  */
*/*     PROCEDURE NAME - SCANUCBS                            @G24LB37*/
*/*                                                          @G24LB37*/
*/*     FUNCTION - THIS PROCEDURE SCANS THE 3330V UCB TABLE  @G24LB37*/
*/*                BUILT BY MSVC FOR THE UCB THAT CONTAINS   @G24LB37*/
*/*                THE VOLUME SERIAL IN THE UCBVOLI FIELD    @G24LB37*/
*/*                WHICH MATCHES THE ONE PASSED BY THE       @G24LB37*/
*/*                CALLER.                                   @G24LB37*/
*/*                                                          @G24LB37*/
*/*     INPUT - THE VOLUME SERIAL TO SEARCH FOR IN THE UCBS. @G24LB37*/
*/*             THE POINTER TO THE MSVC UCB LOOK UP TABLE    @G24LB37*/
*/*             IN THE VVICB.                                @G24LB37*/
*/*                                                          @G24LB37*/
*/*     OUTPUT -   THE ADDRESS OF THE UCB THAT THE VOLUME    @G24LB37*/
*/*                WAS FOUND MOUNTED ON AND/OR A RETURN      @G24LB37*/
*/*                CODE IN RETCODE AREA AS FOLLOWS:          @G24LB37*/
*/*                0 = SUCCESSFUL                            @G24LB37*/
*/*                4 = NOT FOUND                             @G24LB37*/
*/*                                                                  */
*/********************************************************************/
*                                                                  0079
*SCANUCBS:                                                         0079
*   PROCEDURE OPTIONS(NOSAVE);      /*                       @G24LB37*/
SCANUCBS DS    0H                                                  0080
*                                                                  0080
*   /*****************************************************************/
*   /*                                                               */
*   /* INITIALIZE AND ESTABLISH ADDRESSIBILITY TO THE MSVC   @G24LB37*/
*   /* 3330V UCB ADDRESS TABLE USING THE VVIUCB FIELD IN THE @G24LB37*/
*   /* VVICB CONTROL BLOCK. TURN FOUNDSW OFF.                @G24LB37*/
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0080
*   MSVLKPTR=VVIUCB;                /*                       @G24LB37*/
         L     MSVLKPTR,VVIUCB(,VVIPTR)                            0080
*   FOUNDSW=OFF;                    /*                       @G24LB37*/
*                                                                  0081
         NI    FOUNDSW,B'01111111'                                 0081
*   /*****************************************************************/
*   /*                                                               */
*   /* SCAN THE MSVC 3330V UCB ADDRESS TABLE, TAKE EACH UCB  @G24LB37*/
*   /* ADDRESS AND CHECK THE UCBVOLI FIELD FOR THE MATCHING  @G24LB37*/
*   /* VOLSER THAT WAS PASSED IN THE UNITP. ADD A PLUS FOUR  @G24LB37*/
*   /* TO THE ADDRESS OF THE TABLE TO INCREMENT TO THE NEXT  @G24LB37*/
*   /* UCB ADDRESS ENTRY. IF THE UCB ADDRESS IS ALL HEX      @G24LB37*/
*   /* FOXES THEN THE END OF THE TABLE HAS BEEN REACHED.     @G24LB37*/
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0082
*   DO WHILE(MSVUCBP^=UCBDELIM)&(FOUNDSW=OFF);/*             @G24LB37*/
         B     @DE00082                                            0082
@DL00082 DS    0H                                                  0083
*     UCBPTR=MSVUCBP;               /*                       @G24LB37*/
         L     UCBPTR,MSVUCBP(,MSVLKPTR)                           0083
*     IF UCBVOLI=UNIVOL THEN                                       0084
         CLC   UCBVOLI(6,UCBPTR),UNIVOL(UNITPTR)                   0084
         BNE   @RF00084                                            0084
*       DO;                         /*                       @G24LB37*/
*                                                                  0085
*         /***********************************************************/
*         /*                                                         */
*         /* IF THE VOLSER IS FOUND TO BE MOUNTED SET THE    @G24LB37*/
*         /* RETURN CODE TO ZERO AND INSERT THE UCB ADDRESS  @G24LB37*/
*         /* INTO THE UNITP FIELD UNIUCBP, AND TURN ON THE   @G24LB37*/
*         /* FOUND SWITCH. IF THE VOLSER IS NOT FOUND        @G24LB37*/
*         /* (END OF TABLE REACHED), THEN THE RETURN CODE    @G24LB37*/
*         /* IS ALREADY SET TO FOUR.                         @G24LB37*/
*         /*                                                         */
*         /***********************************************************/
*                                                                  0086
*         FOUNDSW=ON;               /*                       @G24LB37*/
         OI    FOUNDSW,B'10000000'                                 0086
*         UNIUCBP=UCBPTR;           /*                       @G24LB37*/
         ST    UCBPTR,UNIUCBP(,UNITPTR)                            0087
*         RETCODE=ZERO;             /*                       @G24LB37*/
         SLR   RETCODE,RETCODE                                     0088
*       END;                        /*                       @G24LB37*/
*     ELSE                                                         0090
*       MSVLKPTR=MSVLKPTR+FOUR;     /*                       @G24LB37*/
         B     @RC00084                                            0090
@RF00084 AL    MSVLKPTR,@CF00039                                   0090
*   END;                            /*                       @G24LB37*/
*                                                                  0091
@RC00084 DS    0H                                                  0091
@DE00082 CLC   MSVUCBP(4,MSVLKPTR),UCBDELIM                        0091
         BE    @DC00082                                            0091
         TM    FOUNDSW,B'10000000'                                 0091
         BZ    @DL00082                                            0091
@DC00082 DS    0H                                                  0092
*   /*****************************************************************/
*   /*                                                               */
*   /* RETURN CODE IS SET IN RETCODE AREA.                   @G24LB37*/
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0092
*   RETURN;                         /* RET TO MAIN ROUTINE   @G24LB37*/
@EL00002 DS    0H                                                  0092
@EF00002 DS    0H                                                  0092
@ER00002 BR    @14                                                 0092
*   END SCANUCBS;                   /* END OF SCANUCBS PROC  @G24LB37*/
*                                                                  0094
*/********************************************************************/
*/*                                                                  */
*/*     PROCEDURE NAME - ALLVIRT                             @G24LB37*/
*/*                                                          @G24LB37*/
*/*     FUNCTION - THIS PROCEDURE DETERMINES IF THE PASSED   @G24LB37*/
*/*                DEVICE TYPE HAS ANY UCB'S WITHIN THE      @G24LB37*/
*/*                ESOTERIC GROUP THAT ARE NOT 3330V         @G24LB37*/
*/*                DEVICES (I.E. MIXED ESOTERIC).            @G24LB37*/
*/*                                                          @G24LB37*/
*/*     INPUT - THE DEVICE TYPE TO SEARCH FOR, PASSED IN THE @G24LB37*/
*/*             UNITP.  THE DEVICE MASK TABLE POINTED TO BY  @G24LB37*/
*/*             THE VVICB FIELD VVIDVMTA, AND THE LENGTH OF  @G24LB37*/
*/*             A DEVICE MASK ENTRY IN VVICB FIELD VVIDVMEL. @G24LB37*/
*/*                                                          @G24LB37*/
*/*     OUTPUT -   RETURN CODE IS RETURNED IN RETCODE AREA   @G24LB37*/
*/*                AS FOLLOWS:                               @G24LB37*/
*/*                0 = DEVICE TYPE IS ALL 3330V'S            @G24LB37*/
*/*                4 = DEVICE TYPE HAS AT LEAST ONE NON-     @G24LB37*/
*/*                    3330V UNIT                            @G24LB37*/
*/*                                                                  */
*/********************************************************************/
*                                                                  0094
*ALLVIRT:                                                          0094
*   PROCEDURE OPTIONS(NOSAVE);      /*                       @G24LB37*/
ALLVIRT  DS    0H                                                  0095
*                                                                  0095
*   /*****************************************************************/
*   /*                                                               */
*   /* INITIALIZE AND ESTABLISH ADDRESSIBILITY TO THE DEVICE @G24LB37*/
*   /* MASK TABLE USING THE VVIDVMTA FIELD IN THE VVICB      @G24LB37*/
*   /* CONTROL BLOCK. TAKE THE NUMBER OF WORDS IN VVIDVMEL,  @G24LB37*/
*   /* ADD TWO TO THAT TOTAL FOR THE TWO EXTRA WORDS IN A    @G24LB37*/
*   /* ENTRY AND MULTIPLY BY 4 TO GET THE NUMBER OF BYTES.   @G24LB37*/
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0095
*   DVMSKPTR=VVIDVMTA;              /*                       @G24LB37*/
         L     DVMSKPTR,VVIDVMTA(,VVIPTR)                          0095
*   DVMSKMLN=VVIDVMEL*FOUR;         /*                       @G24LB37*/
         L     @11,VVIDVMEL(,VVIPTR)                               0096
         LR    DVMSKMLN,@11                                        0096
         SLA   DVMSKMLN,2                                          0096
*   DVMSKELN=(VVIDVMEL+TWO)*FOUR;   /*                       @G24LB37*/
         AL    @11,@CF00043                                        0097
         SLA   @11,2                                               0097
         LR    DVMSKELN,@11                                        0097
*   DVMSKELP=ADDR(DEVMSKEL);        /*                       @G24LB37*/
         LA    DVMSKELP,DEVMSKEL(,DVMSKPTR)                        0098
*   FOUNDSW=OFF;                    /*                       @G24LB37*/
*   EXITSW=OFF;                     /*                       @G24LB37*/
         NI    FOUNDSW,B'00111111'                                 0100
*   SAV3330P=ZERO;                  /*                       @G24LB37*/
*                                                                  0101
         SLR   SAV3330P,SAV3330P                                   0101
*   /*****************************************************************/
*   /*                                                               */
*   /* SCAN THE DEVICE MASK TABLE FOR THE 3330V DEVICE MASK  @G24LB37*/
*   /* USING THE CONSTANT '30582009'X DEVICE TYPE. IF THE    @G24LB37*/
*   /* DEVICE TYPE IS FOUND, SAVE THE ADDRESS. ALSO,         @G24LB37*/
*   /* TAKE THE PASSED DEVICE TYPE AND FIND ITS CORRESPOND-  @G24LB37*/
*   /* ING DEVICE BIT MASK, IN THE DEVICE MASK TABLE.        @G24LB37*/
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0102
*   DO X=ONE TO DEVNUMEL WHILE EXITSW=OFF;/*                 @G24LB37*/
         LA    X,1                                                 0102
         B     @DE00102                                            0102
@DL00102 TM    EXITSW,B'01000000'                                  0102
         BNZ   @DC00102                                            0102
*     IF DEVTYPE=DEV3330V THEN                                     0103
         CLC   DEVTYPE(4,DVMSKELP),DEV3330V                        0103
         BNE   @RF00103                                            0103
*       SAV3330P=DVMSKELP;          /*                       @G24LB37*/
         LR    SAV3330P,DVMSKELP                                   0104
*     IF DEVTYPE=UNIDEVTP THEN                                     0105
@RF00103 CLC   DEVTYPE(4,DVMSKELP),UNIDEVTP(UNITPTR)               0105
         BNE   @RF00105                                            0105
*       DO;                         /*                       @G24LB37*/
*         FOUNDSW=ON;               /*                       @G24LB37*/
         OI    FOUNDSW,B'10000000'                                 0107
*         SAVDEVTP=DVMSKELP;        /*                       @G24LB37*/
         ST    DVMSKELP,SAVDEVTP                                   0108
*       END;                        /*                       @G24LB37*/
*     IF SAV3330P^=ZERO&FOUNDSW=ON THEN                            0110
@RF00105 LTR   SAV3330P,SAV3330P                                   0110
         BZ    @RF00110                                            0110
         TM    FOUNDSW,B'10000000'                                 0110
         BNO   @RF00110                                            0110
*       EXITSW=ON;                  /*                       @G24LB37*/
         OI    EXITSW,B'01000000'                                  0111
*     DVMSKELP=DVMSKELP+DVMSKELN;   /*                       @G24LB37*/
@RF00110 ALR   DVMSKELP,DVMSKELN                                   0112
*   END;                            /*                       @G24LB37*/
         AL    X,@CF00048                                          0113
@DE00102 CH    X,DEVNUMEL(,DVMSKPTR)                               0113
         BNH   @DL00102                                            0113
@DC00102 DS    0H                                                  0114
*                                                                  0114
*   /*****************************************************************/
*   /*                                                               */
*   /* IF THE FOUND SWITCH IS ON, THEN 'AND' THE TWO MASKS   @G24LB37*/
*   /* TOGETHER AND CHECK THE RESULT FOR AN EQUAL CONDITION. @G24LB37*/
*   /* IF THE RESULT IS EQUAL THEN THE DEVICE TYPE IS NOT    @G24LB37*/
*   /* MIXED. SET THE RETURN CODE TO ZERO IF EQUAL, ELSE,    @G24LB37*/
*   /* SET THE RETURN CODE TO EIGHT, INDICATING THE DEVICE   @G24LB37*/
*   /* TYPE PASSED IS NOT ALL 3330V UNITS.                   @G24LB37*/
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0114
*   IF FOUNDSW=ON THEN                                             0114
         TM    FOUNDSW,B'10000000'                                 0114
         BNO   @RF00114                                            0114
*     DO;                           /*                       @G24LB37*/
*       DVMSKELP=SAVDEVTP;          /*                       @G24LB37*/
         L     DVMSKELP,SAVDEVTP                                   0116
*       WORKMASK(ONE:DVMSKMLN)=DEVMASK(ONE:DVMSKMLN)&SAVMASK(ONE:  0117
*           DVMSKMLN);              /*                       @G24LB37*/
         LR    @06,DVMSKMLN                                        0117
         BCTR  @06,0                                               0117
         EX    @06,@SM01249                                        0117
         EX    @06,@SN01251                                        0117
*       IF WORKMASK(ONE:DVMSKMLN)=DEVMASK(ONE:DVMSKMLN) THEN       0118
         EX    @06,@SC01253                                        0118
         BNE   @RF00118                                            0118
*         RETCODE=ZERO;             /*                       @G24LB37*/
         SLR   RETCODE,RETCODE                                     0119
*       ELSE                                                       0120
*         RETCODE=EIGHT;            /*                       @G24LB37*/
         B     @RC00118                                            0120
@RF00118 LA    RETCODE,8                                           0120
*     END;                          /*                       @G24LB37*/
*   ELSE                                                           0122
*     RETCODE=EIGHT;                /*                       @G24LB37*/
         B     @RC00114                                            0122
@RF00114 LA    RETCODE,8                                           0122
*   RETURN;                         /* RET TO MAIN ROUTINE   @G24LB37*/
@EL00003 DS    0H                                                  0123
@EF00003 DS    0H                                                  0123
@ER00003 BR    @14                                                 0123
*   END ALLVIRT;                    /* END OF ALLVIRT PROC   @G24LB37*/
         B     @EL00003                                            0124
*                                                                  0125
*/********************************************************************/
*/*                                                                  */
*/*     PROCEDURE NAME - UNITINCL                            @G24LB37*/
*/*                                                          @G24LB37*/
*/*     FUNCTION - THIS PROCEDURE DETERMINES IF THE PASSED   @G24LB37*/
*/*                UCB ADDRESS IS INCLUDED WITHIN THE SPEC-  @G24LB37*/
*/*                IFIED DEVICE TYPE, CALLS SCANLKUP TO SCAN @G24LB37*/
*/*                THE UCB LOOK UP TABLE FOR THE PASSED UCB  @G24LB37*/
*/*                ADDRESS, AND TO COUNT ITS OFFSET WITHIN   @G24LB37*/
*/*                THE LOOK UP TABLE.  IF THE SCAN IS SUC-   @G24LB37*/
*/*                CESSFUL, THEN CALLS THE SCANMASK PROC-    @G24LB37*/
*/*                EDURE TO DETERMINE BY SCANNING THE DEVICE @G24LB37*/
*/*                MASK TABLE IF THE UCB OFFSET BIT IN THE   @G24LB37*/
*/*                MASK IS ON FOR THAT DEVICE TYPE.          @G24LB37*/
*/*                                                          @G24LB37*/
*/*     INPUT - THE DEVICE TYPE AND THE UCB ADDRESS OF THE   @G24LB37*/
*/*             UNIT TO DETERMINE IF INCLUDED, PASSED IN THE @G24LB37*/
*/*             FIELDS UNIDEVTP AND UNIUCBP IN THE UNITP.    @G24LB37*/
*/*                                                          @G24LB37*/
*/*     OUTPUT -   RETURN CODE IS RETURNED IN RETCODE AREA   @G24LB37*/
*/*                AS FOLLOWS:                               @G24LB37*/
*/*                0 = UCB ADDRESS IS INCLUDED WITHIN THE    @G24LB37*/
*/*                    SPECIFIED DEVICE TYPE                 @G24LB37*/
*/*                4 = UCB ADDRESS IS NOT INCLUDED WITHIN    @G24LB37*/
*/*                    THE SPECIFIED DEVICE TYPE, OR THE     @G24LB37*/
*/*                    SPECIFIED DEVICE TYPE OR UCB ADDRESS  @G24LB37*/
*/*                    WAS NOT FOUND                         @G24LB37*/
*/*                                                                  */
*/********************************************************************/
*                                                                  0125
*UNITINCL:                                                         0125
*   PROCEDURE OPTIONS(SAVE(REG14)); /*                       @G24LB37*/
UNITINCL ST    @14,@SA00004                                        0125
*                                                                  0126
*   /*****************************************************************/
*   /*                                                               */
*   /* INITIALIZE AND ESTABLISH ADDRESSIBILITY TO THE UCB    @G24LB37*/
*   /* BY SETTING THE PASSED UCB ADDRESS INTO THE UCBPTR.    @G24LB37*/
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0126
*   UCBPTR=UNIUCBP;                 /*                       @G24LB37*/
*                                                                  0126
         L     UCBPTR,UNIUCBP(,UNITPTR)                            0126
*   /*****************************************************************/
*   /*                                                               */
*   /* CALL THE SCANLKUP PROCEDURE TO SCAN THE SYSTEM UCB    @G24LB37*/
*   /* LOOK UP TABLE TO FIND THE MATCHING UCB ADDRESS AS     @G24LB37*/
*   /* THE ONE PASSED, TO COMPARE AGAINST THE DEVICE MASK    @G24LB37*/
*   /* TABLE. IF THE UCB ADDRESS IS NOT FOUND, A RETURN      @G24LB37*/
*   /* CODE OF FOUR WILL BE RETURNED. IF FOUND A COUNTER     @G24LB37*/
*   /* (UCBCNTR) WILL BE SET INDICATING WHAT POSITION WITHIN @G24LB37*/
*   /* THE LOOK UP TABLE THE ADDRESS WAS FOUND (1ST, 2ND,    @G24LB37*/
*   /* ETC.), AND A RETURN CODE OF ZERO.                     @G24LB37*/
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0127
*   CALL SCANLKUP;                  /*                       @G24LB37*/
*                                                                  0127
         BAL   @14,SCANLKUP                                        0127
*   /*****************************************************************/
*   /*                                                               */
*   /* IF RETURN CODE IS ZERO, CALL THE SCANMASK PROCEDURE   @G24LB37*/
*   /* TO DETERMINE IF THE UCB IS INCLUDED WITHIN THE        @G24LB37*/
*   /* SPECIFIED DEVICE TYPE. A RETURN CODE OF ZERO WILL BE  @G24LB37*/
*   /* RETURNED IF INCLUDED, OR A RETURN CODE OF FOUR, IF    @G24LB37*/
*   /* NOT INCLUDED.                                         @G24LB37*/
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0128
*   IF RETCODE=ZERO THEN                                           0128
         LTR   RETCODE,RETCODE                                     0128
         BNZ   @RF00128                                            0128
*     CALL SCANMASK;                /*                       @G24LB37*/
         BAL   @14,SCANMASK                                        0129
*   RETURN;                         /* RET TO MAIN ROUTINE   @G24LB37*/
@EL00004 DS    0H                                                  0130
@EF00004 DS    0H                                                  0130
@ER00004 L     @14,@SA00004                                        0130
         BR    @14                                                 0130
*   END UNITINCL;                   /* END OF UNITINCL PROC  @G24LB37*/
         B     @EL00004                                            0131
*                                                                  0132
*/********************************************************************/
*/*                                                                  */
*/*     PROCEDURE NAME - SCANLKUP                            @G24LB37*/
*/*                                                          @G24LB37*/
*/*     FUNCTION - THIS PROCEDURE DETERMINES IF THE PASSED   @G24LB37*/
*/*                UCB ADDRESS IS IN THE SYSTEM LOOK UP      @G24LB37*/
*/*                TABLE, AND COUNTS THE UCB'S OFFSET WITHIN @G24LB37*/
*/*                THE SYSTEM UCB LOOK UP TABLE.             @G24LB37*/
*/*                                                          @G24LB37*/
*/*     INPUT - THE UCB ADDRESS OF THE UNIT, PASSED IN THE   @G24LB37*/
*/*             UNITP.  THE ADDRESS OF THE SYSTEM LOOK UP    @G24LB37*/
*/*             TABLE IN THE CVT FIELD CVTILK2.              @G24LB37*/
*/*                                                          @G24LB37*/
*/*     OUTPUT -   RETURN CODE IS RETURNED IN RETCODE AREA   @G24LB37*/
*/*                AS FOLLOWS:                               @G24LB37*/
*/*                0 = UCB ADDRESS WAS FOUND                 @G24LB37*/
*/*                4 = UCB ADDRESS WAS NOT FOUND             @G24LB37*/
*/*                                                                  */
*/********************************************************************/
*                                                                  0132
*SCANLKUP:                                                         0132
*   PROCEDURE OPTIONS(NOSAVE);      /*                       @G24LB37*/
SCANLKUP DS    0H                                                  0133
*                                                                  0133
*   /*****************************************************************/
*   /*                                                               */
*   /* INITIALIZE AND ESTABLISH ADDRESSIBILITY TO THE SYSTEM @G24LB37*/
*   /* UCB LOOK UP TABLE USING THE CVTILK2 FIELD IN THE CVT. @G24LB37*/
*   /* CLEAR COUNTER AND TURN FOUNDSW OFF.                   @G24LB37*/
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0133
*   UCBLOKUP=CVTILK2;               /*                       @G24LB37*/
         L     @09,CVTPTR                                          0133
         L     UCBLOKUP,CVTILK2(,@09)                              0133
*   UCBCNTR=ZERO;                   /*                       @G24LB37*/
         SLR   UCBCNTR,UCBCNTR                                     0134
*   FOUNDSW=OFF;                    /*                       @G24LB37*/
*                                                                  0135
         NI    FOUNDSW,B'01111111'                                 0135
*   /*****************************************************************/
*   /*                                                               */
*   /* SCAN THE SYSTEM UCB LOOK UP TABLE, TAKE EACH UCB      @G24LB37*/
*   /* ADDRESS AND CHECK THAT ADDRESS FIELD FOR THE MATCHING @G24LB37*/
*   /* UCBADDR THAT WAS PASSED IN THE UNITP. ADD A PLUS TWO  @G24LB37*/
*   /* TO THE ADDRESS OF THE TABLE TO INCREMENT TO THE NEXT  @G24LB37*/
*   /* UCB ADDRESS ENTRY. IF THE UCB ADDRESS IS ALL HEX      @G24LB37*/
*   /* FOXES THEN THE END OF THE TABLE HAS BEEN REACHED.     @G24LB37*/
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0136
*   DO WHILE(UCBADDR^=UCBDELIM(ONE:TWO))&(FOUNDSW=OFF);/*    @G24LB37*/
         B     @DE00136                                            0136
@DL00136 DS    0H                                                  0137
*     IF UCBADDR=UCBPTR THEN                                       0137
         LH    @09,UCBADDR(,UCBLOKUP)                              0137
         N     @09,@CF01255                                        0137
         CR    UCBPTR,@09                                          0137
         BNE   @RF00137                                            0137
*       FOUNDSW=ON;                 /*                       @G24LB37*/
         OI    FOUNDSW,B'10000000'                                 0138
*     ELSE                                                         0139
*       UCBCNTR=UCBCNTR+ONE;        /*                       @G24LB37*/
         B     @RC00137                                            0139
@RF00137 AL    UCBCNTR,@CF00048                                    0139
*     UCBLOKUP=UCBLOKUP+TWO;        /*                       @G24LB37*/
@RC00137 AL    UCBLOKUP,@CF00043                                   0140
*   END;                            /*                       @G24LB37*/
*                                                                  0141
@DE00136 CLC   UCBADDR(2,UCBLOKUP),UCBDELIM                        0141
         BE    @DC00136                                            0141
         TM    FOUNDSW,B'10000000'                                 0141
         BZ    @DL00136                                            0141
@DC00136 DS    0H                                                  0142
*   /*****************************************************************/
*   /*                                                               */
*   /* IF THE UCB ADDRESS IS FOUND IN THE SYSTEM LOOK UP     @G24LB37*/
*   /* TABLE, THEN SET THE RETURN CODE TO ZERO. IF THE UCB   @G24LB37*/
*   /* ADDRESS IS NOT FOUND (END OF TABLE REACHED), THEN     @G24LB37*/
*   /* THE RETURN CODE IS ALREADY SET TO FOUR.               @G24LB37*/
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0142
*   IF FOUNDSW=ON THEN                                             0142
         TM    FOUNDSW,B'10000000'                                 0142
         BNO   @RF00142                                            0142
*     RETCODE=ZERO;                 /*                       @G24LB37*/
         SLR   RETCODE,RETCODE                                     0143
*   RETURN;                         /* RET TO UNITINCL PROC  @G24LB37*/
@EL00005 DS    0H                                                  0144
@EF00005 DS    0H                                                  0144
@ER00005 BR    @14                                                 0144
*   END SCANLKUP;                   /* END OF SCANLKUP PROC  @G24LB37*/
         B     @EL00005                                            0145
*                                                                  0146
*/********************************************************************/
*/*                                                                  */
*/*     PROCEDURE NAME - SCANMASK                            @G24LB37*/
*/*                                                          @G24LB37*/
*/*     FUNCTION - THIS PROCEDURE DETERMINES BY USING THE    @G24LB37*/
*/*                UCB ADDRESS OFFSET COUNTER INITIALIZED BY @G24LB37*/
*/*                THE SCANLKUP PROCEDURE, TO SCAN THE       @G24LB37*/
*/*                DEVICE MASK TABLE ENTRY, TO DETERMINE IF  @G24LB37*/
*/*                THE UCB OFFSET BIT IN THE MASK IS ON      @G24LB37*/
*/*                FOR THAT DEVICE TYPE.                     @G24LB37*/
*/*                                                          @G24LB37*/
*/*     INPUT - THE DEVICE TYPE, PASSED IN FIELD UNIDEVTP,   @G24LB37*/
*/*             AND THE UCB ADDRESS OFFSET COUNTER FROM      @G24LB37*/
*/*             THE SCANLKUP PROCEDURE.  THE ADDRESS OF THE  @G24LB37*/
*/*             DEVICE MASK TABLE AND THE ELEMENT LENGTH     @G24LB37*/
*/*             PASSED IN THE VVICB CONTROL BLOCK.           @G24LB37*/
*/*                                                          @G24LB37*/
*/*     OUTPUT -   RETURN CODE IS RETURNED IN RETCODE AREA   @G24LB37*/
*/*                AS FOLLOWS:                               @G24LB37*/
*/*                0 = UCB ADDRESS IS INCLUDED WITHIN THE    @G24LB37*/
*/*                    SPECIFIED DEVICE TYPE                 @G24LB37*/
*/*                4 = UCB ADDRESS IS NOT INCLUDED WITHIN    @G24LB37*/
*/*                    THE SPECIFIED DEVICE TYPE, OR THE     @G24LB37*/
*/*                    SPECIFIED DEVICE TYPE WAS NOT FOUND   @G24LB37*/
*/*                                                                  */
*/********************************************************************/
*                                                                  0146
*SCANMASK:                                                         0146
*   PROCEDURE OPTIONS(NOSAVE);      /*                       @G24LB37*/
SCANMASK DS    0H                                                  0147
*                                                                  0147
*   /*****************************************************************/
*   /*                                                               */
*   /* INITIALIZE AND ESTABLISH ADDRESSIBILITY TO THE DEVICE @G24LB37*/
*   /* MASK TABLE (DEVMASKT). COMPUTE THE TOTAL ENTRY        @G24LB37*/
*   /* LENGTH OF THE DEVICE MASK TABLE BY TAKING THE FIELD   @G24LB37*/
*   /* VVIDVMEL AND ADDING A PLUS TWO TO THE FIELD AND PUT   @G24LB37*/
*   /* IN THE ELEMENT INDEX FIELD. THE TWO WORDS ADDED ARE   @G24LB37*/
*   /* FOR THE DEVICE TYPE AND THE NUMBER OF BITS IN THE     @G24LB37*/
*   /* MASK FIELDS.                                          @G24LB37*/
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0147
*   DVMSKPTR=VVIDVMTA;              /*                       @G24LB37*/
         L     DVMSKPTR,VVIDVMTA(,VVIPTR)                          0147
*   DVMSKMLN=VVIDVMEL*FOUR;         /*                       @G24LB37*/
         L     @11,VVIDVMEL(,VVIPTR)                               0148
         LR    DVMSKMLN,@11                                        0148
         SLA   DVMSKMLN,2                                          0148
*   DVMSKELN=(VVIDVMEL+TWO)*FOUR;   /*                       @G24LB37*/
         AL    @11,@CF00043                                        0149
         SLA   @11,2                                               0149
         LR    DVMSKELN,@11                                        0149
*   DVMSKELP=ADDR(DEVMSKEL);        /*                       @G24LB37*/
         LA    DVMSKELP,DEVMSKEL(,DVMSKPTR)                        0150
*   SAV3330P=ZERO;                  /*                       @G24LB37*/
         SLR   SAV3330P,SAV3330P                                   0151
*   WORKAREA=''B;                   /*                       @G24LB37*/
*                                                                  0152
         XC    WORKAREA(4),WORKAREA                                0152
*   /*****************************************************************/
*   /*                                                               */
*   /* SCAN THE DEVICE MASK TABLE FOR THE PASSED DEVICE TYPE @G24LB37*/
*   /* IN THE UNITP. ONCE A COMPARE EQUAL IS FOUND SAVE      @G24LB37*/
*   /* THAT ENTRIES ADDRESS FOR THE NEXT STEP. IF NOT FOUND  @G24LB37*/
*   /* SET THE RETURN CODE TO FOUR.                          @G24LB37*/
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0153
*   DO X=ONE TO DEVNUMEL WHILE SAV3330P=ZERO;/*              @G24LB37*/
         LA    X,1                                                 0153
         B     @DE00153                                            0153
@DL00153 LTR   SAV3330P,SAV3330P                                   0153
         BNZ   @DC00153                                            0153
*     IF DEVTYPE=UNIDEVTP THEN                                     0154
         CLC   DEVTYPE(4,DVMSKELP),UNIDEVTP(UNITPTR)               0154
         BNE   @RF00154                                            0154
*       SAV3330P=DVMSKELP;          /*                       @G24LB37*/
         LR    SAV3330P,DVMSKELP                                   0155
*     ELSE                                                         0156
*       DVMSKELP=DVMSKELP+DVMSKELN; /*                       @G24LB37*/
         B     @RC00154                                            0156
@RF00154 ALR   DVMSKELP,DVMSKELN                                   0156
*   END;                            /*                       @G24LB37*/
*                                                                  0157
@RC00154 AL    X,@CF00048                                          0157
@DE00153 CH    X,DEVNUMEL(,DVMSKPTR)                               0157
         BNH   @DL00153                                            0157
@DC00153 DS    0H                                                  0158
*   /*****************************************************************/
*   /*                                                               */
*   /* IF THE ENTRY WAS FOUND THEN DETERMINE IF THE BIT IS   @G24LB37*/
*   /* ON CORRESPONDING TO THE PASSED SYSTEM UCB LOOK UP     @G24LB37*/
*   /* OFFSET NUMBER.                                        @G24LB37*/
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0158
*   IF SAV3330P^=ZERO THEN                                         0158
         LTR   SAV3330P,SAV3330P                                   0158
         BZ    @RF00158                                            0158
*     DO;                           /*                       @G24LB37*/
*                                                                  0160
*       /*************************************************************/
*       /*                                                           */
*       /* THE BIT OFFSET IS DIVIDED BY EIGHT TO GET THE     @G24LB37*/
*       /* BYTE OFFSET IN THE MASK ENTRY. THE REMAINDER OF   @G24LB37*/
*       /* THE DIVIDE IS THE BIT OFFSET WITHIN THE BYTE.     @G24LB37*/
*       /*                                                           */
*       /*************************************************************/
*                                                                  0160
*       BYTOFFST=UCBCNTR/EIGHT;     /*                       @G24LB37*/
         LR    @00,UCBCNTR                                         0160
         SRDA  @00,32                                              0160
         D     @00,@CF00057                                        0160
         LR    BYTOFFST,@01                                        0160
*       BITOFFST=UCBCNTR//EIGHT;    /*                       @G24LB37*/
*                                                                  0161
         LR    @00,UCBCNTR                                         0161
         SRDA  @00,32                                              0161
         D     @00,@CF00057                                        0161
         LR    BITOFFST,@00                                        0161
*       /*************************************************************/
*       /*                                                           */
*       /* TAKE THE BYTE COMPUTED IN THE DIVIDE AND 'AND'    @G24LB37*/
*       /* THE BITMASK TO THE UNIT BIT WITHIN THE BYTE       @G24LB37*/
*       /* USING THE BIT OFFSET. THIS IS DONE TO ELIMINATE   @G24LB37*/
*       /* ALL OTHER BITS IN THE BYTE FOR THE SHIFT TO GIVE  @G24LB37*/
*       /* CORRECT RESULTS(CONDITION CODE). PUT THE BYTE     @G24LB37*/
*       /* INTO THE HIGH ORDER BYTE OF THE REGISTER.         @G24LB37*/
*       /*                                                           */
*       /*************************************************************/
*                                                                  0162
*       WORKBYTE=DEVMASK(BYTOFFST+ONE);/*                    @G24LB37*/
         LR    @01,DVMSKELP                                        0162
         ALR   @01,BYTOFFST                                        0162
         MVC   WORKBYTE(1),DEVMASK(@01)                            0162
*       WORKBYTE=BITMASK(BITOFFST+ONE)&WORKBYTE;/*           @G24LB37*/
         LA    @04,BITMASK(BITOFFST)                               0163
         NC    WORKBYTE(1),0(@04)                                  0163
*       RFY                                                        0164
*         REG4 RESTRICTED;          /*                       @G24LB37*/
*       REG4=WORKAREA;              /*                       @G24LB37*/
*                                                                  0165
         ICM   REG4,15,WORKAREA                                    0165
*       /*************************************************************/
*       /*                                                           */
*       /* SHIFT THE REGISTER THE NUMBER OF BITS INDICATED   @G24LB37*/
*       /* BY THE BIT OFFSET AND TEST THE RESULTS FOR A      @G24LB37*/
*       /* MINUS OR AN OVERFLOW CONDITION, WHICH WILL BE     @G24LB37*/
*       /* ONLY TRUE IF THE BIT IS ON. BRANCH TO END OF      @G24LB37*/
*       /* THE PROCEDURE IF MINUS OR AN OVERFLOW CONDITION,  @G24LB37*/
*       /* RETCODE IS ALREADY ZERO, ELSE SET RETCODE TO      @G24LB37*/
*       /* FOUR, THE BIT IS NOT ON IN THE MASK.              @G24LB37*/
*       /*                                                           */
*       /*************************************************************/
*                                                                  0166
*       SLA(REG4,BITOFFST);         /*                       @G24LB37*/
         SLA   REG4,0(BITOFFST)                                    0166
*       BC(FIVE,BITON);             /*                       @G24LB37*/
         BC    5,BITON                                             0167
*       RFY                                                        0168
*         REG4 UNRESTRICTED;        /*                       @G24LB37*/
*       RETCODE=FOUR;               /*                       @G24LB37*/
         LA    RETCODE,4                                           0169
*     END;                          /*                       @G24LB37*/
*                                                                  0171
*   /*****************************************************************/
*   /*                                                               */
*   /* SET RETURN CODE TO FOUR, DEVICE TYPE WAS NOT FOUND.   @G24LB37*/
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0171
*   ELSE                                                           0171
*     RETCODE=FOUR;                 /*                       @G24LB37*/
*                                                                  0171
         B     @RC00158                                            0171
@RF00158 LA    RETCODE,4                                           0171
*   /*****************************************************************/
*   /*                                                               */
*   /* RETURN TO CALLER, THE RETCODE AREA IS SET WITH RETURN @G24LB37*/
*   /* CODE.                                                 @G24LB37*/
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0172
*BITON:                                                            0172
*   RETURN;                         /* RET TO UNITINCL PROC  @G24LB37*/
@EL00006 DS    0H                                                  0172
@EF00006 DS    0H                                                  0172
@ER00006 BR    @14                                                 0172
*   END SCANMASK;                   /* END OF SCANMASK PROC  @G24LB37*/
         B     @EL00006                                            0173
*   END ICBVUP00                    /* END OF ICBVUP00       @G24LB37*/
*                                                                  0174
*/* THE FOLLOWING INCLUDE STATEMENTS WERE FOUND IN THIS PROGRAM.     */
*/*%INCLUDE SYSLIB  (IEZUNITP)                                       */
*/*%INCLUDE SYSLIB  (IEZVVICB)                                       */
*/*%INCLUDE SYSLIB  (CVT     )                                       */
*/*%INCLUDE SYSLIB  (IEFUCBOB)                                       */
*                                                                  0174
*       ;                                                          0174
@DATA    DS    0H
@SM01249 MVC   WORKMASK(0),DEVMASK(DVMSKELP)
@SN01251 NC    WORKMASK(0),SAVMASK(SAV3330P)
@SC01253 CLC   WORKMASK(0),DEVMASK(DVMSKELP)
         DS    0F
@SA00001 DS    18F
@PC00001 DS    2F
@SA00004 DS    1F
         DS    0F
@CF00048 DC    F'1'
@CF00043 DC    F'2'
@CF00039 DC    F'4'
@CF00057 DC    F'8'
@CF01255 DC    XL4'0000FFFF'
         DS    0D
SAVDEVTP DS    A
DEV3330V DC    X'30582009'
UCBDELIM DC    X'FFFFFFFF'
VUP00SWS DS    CL2
         ORG   VUP00SWS
FOUNDSW  DS    BL1
EXITSW   EQU   VUP00SWS+0
@NM00009 EQU   VUP00SWS+0
         ORG   VUP00SWS+2
WORKAREA DS    CL4
         ORG   WORKAREA
WORKBYTE DS    CL1
@NM00010 DS    CL3
         ORG   WORKAREA+4
WORKMASK DS    CL256
         DS    CL2
FIXAREA  DS    CL100
         ORG   FIXAREA
@NM00012 DC    100X'00'
         ORG   FIXAREA+100
BITMASK  DC    X'80'
         DC    X'40'
         DC    X'20'
         DC    X'10'
         DC    X'08'
         DC    X'04'
         DC    X'02'
         DC    X'01'
@00      EQU   00                      EQUATES FOR REGISTERS 0-15
@01      EQU   01
@02      EQU   02
@03      EQU   03
@04      EQU   04
@05      EQU   05
@06      EQU   06
@07      EQU   07
@08      EQU   08
@09      EQU   09
@10      EQU   10
@11      EQU   11
@12      EQU   12
@13      EQU   13
@14      EQU   14
@15      EQU   15
BITOFFST EQU   @03
BYTOFFST EQU   @04
UCBCNTR  EQU   @08
DVMSKMLN EQU   @07
DVMSKELN EQU   @10
RETCODE  EQU   @05
X        EQU   @09
SAV3330P EQU   @03
DVMSKELP EQU   @02
DVMSKPTR EQU   @04
UCBLOKUP EQU   @02
MSVLKPTR EQU   @02
UNITPTR  EQU   @06
UCBPTR   EQU   @04
VVIPTR   EQU   @03
REG4     EQU   @04
REG14    EQU   @14
REG0     EQU   @00
REG1     EQU   @01
REG15    EQU   @15
CVTPTR   EQU   16
UNITP    EQU   0
UNIDEVTP EQU   UNITP
UNIVOL   EQU   UNITP+4
UNIUCBP  EQU   UNITP+12
UNIFLAGS EQU   UNITP+16
UNIFMTD  EQU   UNIFLAGS
UNIFINCL EQU   UNIFLAGS
UNIFALLV EQU   UNIFLAGS
VVICB    EQU   0
VVIFLGA  EQU   VVICB+15
VVIUCB   EQU   VVICB+60
VVIDVMTA EQU   VVICB+84
VVIDVMEL EQU   VVICB+104
CVTMAP   EQU   0
CVTILK2  EQU   CVTMAP+40
CVTDAR   EQU   CVTMAP+72
CVTFLGS1 EQU   CVTDAR
CVTDCB   EQU   CVTMAP+116
CVTIERLC EQU   CVTMAP+144
CVTOPTA  EQU   CVTMAP+182
CVTOPTB  EQU   CVTMAP+183
CVTGTF   EQU   CVTMAP+236
CVTGTFST EQU   CVTGTF
CVTGTFS  EQU   CVTGTFST
CVTSTATE EQU   CVTGTFST
CVTTMODE EQU   CVTGTFST
CVTFORM  EQU   CVTGTFST
CVTAQAVT EQU   CVTMAP+240
CVTTCMFG EQU   CVTAQAVT
CVTVOLM2 EQU   CVTMAP+244
CVTTATA  EQU   CVTVOLM2
CVTTSKS  EQU   CVTTATA
CVTVOLF2 EQU   CVTTSKS
CVTTAT   EQU   CVTTATA+1
CVTATER  EQU   CVTMAP+248
CVTEXT1  EQU   CVTMAP+252
CVTPURG  EQU   CVTMAP+260
CVTQMSG  EQU   CVTMAP+268
CVTDMSR  EQU   CVTMAP+272
CVTRSV37 EQU   CVTDMSR
CVTDMSRF EQU   CVTRSV37
CVTERPV  EQU   CVTMAP+316
CVTINTLA EQU   CVTMAP+320
CVTAPF   EQU   CVTMAP+324
CVTEXT2  EQU   CVTMAP+328
CVTHJES  EQU   CVTMAP+332
CVTPGSIA EQU   CVTMAP+348
CVTA1F1  EQU   CVTMAP+356
CVTSYSK  EQU   CVTMAP+357
CVTVOLM1 EQU   CVTMAP+380
CVTVOLF1 EQU   CVTVOLM1
CVTATMCT EQU   CVTMAP+388
CVTXTNT1 EQU   0
CVTXTNT2 EQU   0
CVTDSSV  EQU   CVTXTNT2
CVTFLGBT EQU   CVTXTNT2+5
CVTQID   EQU   CVTXTNT2+24
CVTRV400 EQU   CVTXTNT2+52
CVTRV409 EQU   CVTXTNT2+53
CVTATCVT EQU   CVTXTNT2+64
CVTRV429 EQU   CVTXTNT2+84
CVTRV438 EQU   CVTXTNT2+85
CVTRV457 EQU   CVTXTNT2+112
CVTRV466 EQU   CVTXTNT2+113
CVTFIX   EQU   0
CVTRELNO EQU   CVTFIX+252
UCB      EQU   0
UCBOB    EQU   0
UCBJBNR  EQU   UCBOB
UCBFL5   EQU   UCBOB+1
UCBAF    EQU   UCBFL5
UCBSTAT  EQU   UCBOB+3
UCBCHAN  EQU   UCBOB+4
UCBSFLS  EQU   UCBOB+6
UCBFLA   EQU   UCBSFLS
UCBFL1   EQU   UCBFLA
UCBBSY   EQU   UCBFL1
UCBNRY   EQU   UCBFL1
UCBPST   EQU   UCBFL1
UCBCUB   EQU   UCBFL1
UCBFLB   EQU   UCBSFLS+1
UCBCHM   EQU   UCBOB+8
UCBCHM1  EQU   UCBCHM
UCBPTH0  EQU   UCBCHM1
UCBPTH1  EQU   UCBCHM1
UCBWGT   EQU   UCBOB+12
UCBTYP   EQU   UCBOB+16
UCBTBYT1 EQU   UCBTYP
UCB1FEA5 EQU   UCBTBYT1
UCB1FEA6 EQU   UCBTBYT1
UCBTBYT2 EQU   UCBTYP+1
UCB2OPT2 EQU   UCBTBYT2
UCBDUDN1 EQU   UCB2OPT2
UCB2OPT3 EQU   UCBTBYT2
UCBDUDN2 EQU   UCB2OPT3
UCB2OPT4 EQU   UCBTBYT2
UCBRWTAU EQU   UCB2OPT4
UCB2OPT6 EQU   UCBTBYT2
UCB2OPT7 EQU   UCBTBYT2
UCBTBYT3 EQU   UCBTYP+2
UCBDVCLS EQU   UCBTBYT3
UCBTBYT4 EQU   UCBTYP+3
UCBEXTPT EQU   UCBOB+20
UCBFLC   EQU   UCBEXTPT
UCBDEV   EQU   UCBOB+24
UCBCMEXT EQU   0
UCBATI   EQU   UCBCMEXT+3
@NM00008 EQU   UCBATI
UCBFLP1  EQU   UCBCMEXT+5
UCBMT    EQU   0
UCBOCR   EQU   0
UCB3540X EQU   0
UCBDKBYT EQU   UCB3540X+6
UCB3800X EQU   0
UCBOPTNS EQU   UCB3800X
UCBACTIV EQU   UCB3800X+3
UCBMDRBF EQU   UCB3800X+36
UCBUCS   EQU   0
UCBUCSOP EQU   UCBUCS+4
UCBFCBOP EQU   UCBUCS+5
MSVLKUPT EQU   0
MSVUCBP  EQU   MSVLKUPT
SYSLKUPT EQU   0
UCBADDR  EQU   SYSLKUPT
DEVMASKT EQU   0
DEVNUMEL EQU   DEVMASKT
DEVMSKEL EQU   DEVMASKT+4
DEVMASKE EQU   0
DEVTYPE  EQU   DEVMASKE+4
DEVMASK  EQU   DEVMASKE+8
SAVMASKE EQU   0
SAVMASK  EQU   SAVMASKE+8
UCBBGN   EQU   0
UNITRPL  EQU   0
VVICBLK  EQU   0
CVTS01   EQU   CVTPGSIA
CVTLPDIA EQU   CVTS01+12
CVTDIRST EQU   CVTLPDIA
CVTSLIDA EQU   CVTS01+24
CVTCTLFG EQU   CVTS01+50
CVTRV210 EQU   CVTS01+424
CVTRV219 EQU   CVTS01+425
CVTRV228 EQU   CVTS01+426
CVTRV237 EQU   CVTS01+427
CVTMFRTR EQU   CVTS01+452
CVTRV262 EQU   CVTS01+468
CVTRV271 EQU   CVTS01+469
CVTRV280 EQU   CVTS01+470
CVTRV289 EQU   CVTS01+471
CVTGSDA  EQU   CVTS01+600
UCBOBS01 EQU   UCBDEV
UCBVOLI  EQU   UCBOBS01+4
UCBSTAB  EQU   UCBOBS01+10
UCBBSVL  EQU   UCBSTAB
UCBPRSRS EQU   UCBSTAB
UCBDMCT  EQU   UCBOBS01+11
UCBFL4   EQU   UCBOBS01+13
UCBOBS02 EQU   UCBDEV
UCBTFL1  EQU   UCBOBS02+19
UCBXTN   EQU   UCBOBS02+20
UCBVOPT  EQU   UCBXTN
UCBOBS03 EQU   UCBDEV
UCBXTADR EQU   UCBOBS03
UCBOBS04 EQU   UCBDEV
UCBBTA   EQU   UCBOBS04+12
UCBOBS06 EQU   UCBDEV
UCBAOF   EQU   UCBOBS06
UCBAOF1  EQU   UCBAOF
UCBAOF2  EQU   UCBAOF+1
@NM00007 EQU   UCBOBS06+3
UCBIRB   EQU   UCBOBS06+4
UCBGRAF  EQU   UCBIRB
UCBLDNCA EQU   UCBOBS06+8
UCBRDYQ  EQU   UCBLDNCA
UCBIRLN  EQU   UCBRDYQ
UCBLDNCB EQU   UCBRDYQ+1
UCBCTLNK EQU   UCBOBS06+12
UCBOBS07 EQU   UCBDEV
UCBOBS08 EQU   UCBDEV
UCBCTCAD EQU   UCBOBS08
UCBCTCF1 EQU   UCBOBS08+4
UCBOBS09 EQU   UCBDEV
*                                      START UNREFERENCED COMPONENTS
UCBRV066 EQU   UCBOBS09+4
UCBIOSBA EQU   UCBOBS09
UCBRV042 EQU   UCBOBS08+5
UCBRV082 EQU   UCBCTCF1
UCBRV081 EQU   UCBCTCF1
UCBRV080 EQU   UCBCTCF1
UCBRV079 EQU   UCBCTCF1
UCBRV078 EQU   UCBCTCF1
UCBRV077 EQU   UCBCTCF1
UCBRV076 EQU   UCBCTCF1
UCBCTC80 EQU   UCBCTCF1
UCBCTCAL EQU   UCBCTCAD
UCBICNCB EQU   UCBOBS07+4
UCBRV040 EQU   UCBOBS07
UCBCTLNA EQU   UCBCTLNK+1
UCBRLN   EQU   UCBCTLNK
UCBRDYQA EQU   UCBLDNCB
UCBINRLN EQU   UCBIRLN
UCBIRBA  EQU   UCBIRB+1
UCBRV039 EQU   UCBGRAF
UCBDWNR  EQU   UCBGRAF
UCBRPND  EQU   UCBGRAF
UCBUPM   EQU   UCBGRAF
UCBBTAM  EQU   UCBGRAF
UCBDRNO  EQU   UCBGRAF
UCBDRO   EQU   UCBGRAF
UCBOIP   EQU   UCBGRAF
UCBATRCD EQU   @NM00007
UCBSKPFG EQU   @NM00007
UCBRIPND EQU   @NM00007
UCBRTIAC EQU   @NM00007
UCBRSV79 EQU   @NM00007
UCBRSV78 EQU   @NM00007
UCBRSV77 EQU   @NM00007
UCBOLTEP EQU   @NM00007
UCBATNCT EQU   UCBOBS06+2
UCBRSV76 EQU   UCBAOF2
UCBRSV75 EQU   UCBAOF2
UCBRSV74 EQU   UCBAOF2
UCBRSV73 EQU   UCBAOF2
UCBRSV72 EQU   UCBAOF2
UCBRSV71 EQU   UCBAOF2
UCBRSV70 EQU   UCBAOF2
UCBRSV69 EQU   UCBAOF2
UCBRSV68 EQU   UCBAOF1
UCBRSV67 EQU   UCBAOF1
UCBRSV66 EQU   UCBAOF1
UCBRSV65 EQU   UCBAOF1
UCBRSV64 EQU   UCBAOF1
UCBOFNL  EQU   UCBAOF1
UCBOFSP  EQU   UCBAOF1
UCBOFMCR EQU   UCBAOF1
UCBBTB   EQU   UCBBTA+1
UCBDI    EQU   UCBBTA
UCBSNS   EQU   UCBOBS04+8
UCBTEB   EQU   UCBOBS04+4
UCBGCB   EQU   UCBOBS04+3
UCBOPEN  EQU   UCBOBS04+2
UCBSTART EQU   UCBOBS04
UCBXTNB  EQU   UCBXTN+1
UCBRSV22 EQU   UCBVOPT
UCBRSV21 EQU   UCBVOPT
UCBRSV20 EQU   UCBVOPT
UCBESVE  EQU   UCBVOPT
UCBERPC  EQU   UCBVOPT
UCBESVC  EQU   UCBVOPT
UCBEVA   EQU   UCBVOPT
UCBESV   EQU   UCBVOPT
UCBRV009 EQU   UCBTFL1
UCBRV008 EQU   UCBTFL1
UCBRV007 EQU   UCBTFL1
UCBRV006 EQU   UCBTFL1
UCBRV005 EQU   UCBTFL1
UCBRV038 EQU   UCBTFL1
UCBNSLTP EQU   UCBTFL1
UCBNLTP  EQU   UCBTFL1
UCBRES1B EQU   UCBOBS02+18
UCBFSER  EQU   UCBOBS02+12
@NM00006 EQU   UCBOBS02+4
UCBFSEQ  EQU   UCBOBS02+2
UCBFSCT  EQU   UCBOBS02
UCBNEXP  EQU   UCBOBS01+20
UCBBASE  EQU   UCBOBS01+16
UCBRES1A EQU   UCBOBS01+15
UCBUSER  EQU   UCBOBS01+14
UCBFL47  EQU   UCBFL4
UCBMAT   EQU   UCBFL4
UCBHOLD  EQU   UCBFL4
UCBATTN  EQU   UCBFL4
UCBDSS   EQU   UCBFL4
UCBRESVP EQU   UCBFL4
UCBWDAV  EQU   UCBFL4
UCBDAVV  EQU   UCBFL4
UCBSQC   EQU   UCBOBS01+12
UCBDATP  EQU   UCBOBS01+12
UCBDMC   EQU   UCBDMCT
UCBMOUNT EQU   UCBDMCT
UCBBNUL  EQU   UCBSTAB
UCBSHAR  EQU   UCBSTAB
UCBBSTR  EQU   UCBSTAB
UCBBPUB  EQU   UCBSTAB
UCBBPRV  EQU   UCBSTAB
UCBBALB  EQU   UCBPRSRS
UCBPGFL  EQU   UCBSTAB
UCBDVSHR EQU   UCBBSVL
UCBVTOC  EQU   UCBOBS01
CVTRV628 EQU   CVTS01+728
CVTRV627 EQU   CVTS01+724
CVTRV626 EQU   CVTS01+720
CVTRV625 EQU   CVTS01+716
CVTRV624 EQU   CVTS01+712
CVTRV623 EQU   CVTS01+708
CVTRV622 EQU   CVTS01+704
CVTRV621 EQU   CVTS01+700
CVTIHASU EQU   CVTS01+696
CVTRV619 EQU   CVTS01+692
CVTRV618 EQU   CVTS01+688
CVTRV617 EQU   CVTS01+684
CVTRV616 EQU   CVTS01+680
CVTRV615 EQU   CVTS01+676
CVTRV614 EQU   CVTS01+672
CVTRV613 EQU   CVTS01+668
CVTTCASP EQU   CVTS01+664
CVT0PT03 EQU   CVTS01+660
CVT0PT0E EQU   CVTS01+656
CVTRV609 EQU   CVTS01+652
CVTCGK   EQU   CVTS01+648
CVTRAC   EQU   CVTS01+644
CVTRV606 EQU   CVTS01+640
CVTRV605 EQU   CVTS01+636
CVTRV604 EQU   CVTS01+632
CVTEFF02 EQU   CVTS01+628
CVTCBBR  EQU   CVTS01+624
CVTSSCR  EQU   CVTS01+620
CVTEVENT EQU   CVTS01+616
CVTCRCA  EQU   CVTS01+612
CVTTPIO  EQU   CVTS01+608
CVTADV   EQU   CVTS01+604
CVTGSDAB EQU   CVTGSDA
CVTQV3   EQU   CVTS01+596
CVTQV2   EQU   CVTS01+592
CVTQV1   EQU   CVTS01+588
CVTRPT   EQU   CVTS01+584
CVTSSRB  EQU   CVTS01+580
CVTCSDRL EQU   CVTS01+576
CVTEXP1  EQU   CVTS01+572
CVTRMPMT EQU   CVTS01+568
CVTRMPTT EQU   CVTS01+564
CVTVPSA  EQU   CVTS01+560
CVTVSTOP EQU   CVTS01+556
CVTGTFR8 EQU   CVTS01+552
CVTQUIT  EQU   CVTS01+548
CVTVACR  EQU   CVTS01+544
CVTWTCB  EQU   CVTS01+540
CVTSTPRS EQU   CVTS01+536
CVT0PT02 EQU   CVTS01+532
CVTDARCM EQU   CVTS01+528
CVTIRECM EQU   CVTS01+524
CVTJRECM EQU   CVTS01+520
CVTVEMS0 EQU   CVTS01+516
CVTSPFRR EQU   CVTS01+512
CVTRLSTG EQU   CVTS01+508
CVT0TC0A EQU   CVTS01+504
CVTGMBR  EQU   CVTS01+500
CVTLFRM  EQU   CVTS01+496
CVTRMBR  EQU   CVTS01+492
CVTVIOP  EQU   CVTS01+488
CVTRV307 EQU   CVTS01+486
CVTRV306 EQU   CVTS01+484
CVTRV305 EQU   CVTS01+482
CVTRV304 EQU   CVTS01+480
CVTRV303 EQU   CVTS01+478
CVTRV302 EQU   CVTS01+476
CVTTRCA  EQU   CVTS01+472
CVTRV297 EQU   CVTRV289
CVTRV296 EQU   CVTRV289
CVTRV295 EQU   CVTRV289
CVTRV294 EQU   CVTRV289
CVTRV293 EQU   CVTRV289
CVTRV292 EQU   CVTRV289
CVTRV291 EQU   CVTRV289
CVTRV290 EQU   CVTRV289
CVTRV288 EQU   CVTRV280
CVTRV287 EQU   CVTRV280
CVTRV286 EQU   CVTRV280
CVTRV285 EQU   CVTRV280
CVTRV284 EQU   CVTRV280
CVTRV283 EQU   CVTRV280
CVTRV282 EQU   CVTRV280
CVTRV281 EQU   CVTRV280
CVTRV279 EQU   CVTRV271
CVTRV278 EQU   CVTRV271
CVTRV277 EQU   CVTRV271
CVTRV276 EQU   CVTRV271
CVTRV275 EQU   CVTRV271
CVTRV274 EQU   CVTRV271
CVTRV273 EQU   CVTRV271
CVTRV272 EQU   CVTRV271
CVTRV270 EQU   CVTRV262
CVTRV269 EQU   CVTRV262
CVTRV268 EQU   CVTRV262
CVTRV267 EQU   CVTRV262
CVTRV266 EQU   CVTRV262
CVTRV265 EQU   CVTRV262
CVTRV264 EQU   CVTRV262
CVTRV263 EQU   CVTRV262
CVTVFP   EQU   CVTS01+464
CVTVSI   EQU   CVTS01+460
CVTVPSIB EQU   CVTS01+456
CVTMFACT EQU   CVTMFRTR
CVTMFCTL EQU   CVTS01+448
CVTPVBP  EQU   CVTS01+444
CVTPWI   EQU   CVTS01+440
CVTRV254 EQU   CVTS01+438
CVTRV253 EQU   CVTS01+436
CVTRV252 EQU   CVTS01+434
CVTRV251 EQU   CVTS01+433
CVTRV250 EQU   CVTS01+432
CVTRV249 EQU   CVTS01+431
CVTRV248 EQU   CVTS01+430
CVTRV247 EQU   CVTS01+429
CVTRV246 EQU   CVTS01+428
CVTRV245 EQU   CVTRV237
CVTRV244 EQU   CVTRV237
CVTRV243 EQU   CVTRV237
CVTRV242 EQU   CVTRV237
CVTRV241 EQU   CVTRV237
CVTRV240 EQU   CVTRV237
CVTRV239 EQU   CVTRV237
CVTRV238 EQU   CVTRV237
CVTRV236 EQU   CVTRV228
CVTRV235 EQU   CVTRV228
CVTRV234 EQU   CVTRV228
CVTRV233 EQU   CVTRV228
CVTRV232 EQU   CVTRV228
CVTRV231 EQU   CVTRV228
CVTRV230 EQU   CVTRV228
CVTRV229 EQU   CVTRV228
CVTRV227 EQU   CVTRV219
CVTRV226 EQU   CVTRV219
CVTRV225 EQU   CVTRV219
CVTRV224 EQU   CVTRV219
CVTRV223 EQU   CVTRV219
CVTRV222 EQU   CVTRV219
CVTRV221 EQU   CVTRV219
CVTRV220 EQU   CVTRV219
CVTRV218 EQU   CVTRV210
CVTRV217 EQU   CVTRV210
CVTRV216 EQU   CVTRV210
CVTRV215 EQU   CVTRV210
CVTRV214 EQU   CVTRV210
CVTRV213 EQU   CVTRV210
CVTRV212 EQU   CVTRV210
CVTRV211 EQU   CVTRV210
CVTLCCAT EQU   CVTS01+420
CVTPCCAT EQU   CVTS01+416
CVTIPCRP EQU   CVTS01+412
CVTIPCRI EQU   CVTS01+408
CVTIPCDS EQU   CVTS01+404
CVTAIDVT EQU   CVTS01+400
CVTSSAP  EQU   CVTS01+396
CVTEHCIR EQU   CVTS01+392
CVTEHDEF EQU   CVTS01+388
CVTDAIR  EQU   CVTS01+384
CVTPERFM EQU   CVTS01+380
CVT044R2 EQU   CVTS01+376
CVTFETCH EQU   CVTS01+372
CVTRSTWD EQU   CVTS01+368
CVTSPOST EQU   CVTS01+364
CVTIOBP  EQU   CVTS01+360
CVTASMVT EQU   CVTS01+356
CVTRECRQ EQU   CVTS01+352
CVTWSAC  EQU   CVTS01+348
CVTRV149 EQU   CVTS01+344
CVTWSAL  EQU   CVTS01+340
CVTSPSA  EQU   CVTS01+336
CVTGLMN  EQU   CVTS01+332
CVTVEAC0 EQU   CVTS01+328
CVT062R1 EQU   CVTS01+324
CVTRPOST EQU   CVTS01+320
CVTDQIQE EQU   CVTS01+316
CVTCSD   EQU   CVTS01+312
CVTLKRMA EQU   CVTS01+308
CVTRSPIE EQU   CVTS01+304
CVTRENQ  EQU   CVTS01+300
CVTLQCB  EQU   CVTS01+296
CVTFQCB  EQU   CVTS01+292
CVTQCS01 EQU   CVTS01+288
CVTAPFT  EQU   CVTS01+284
CVTPARRL EQU   CVTS01+280
CVTVWAIT EQU   CVTS01+276
CVTGSPL  EQU   CVTS01+272
CVTLSMQ  EQU   CVTS01+268
CVTGSMQ  EQU   CVTS01+264
CVTEXPRO EQU   CVTS01+260
CVTOPCTP EQU   CVTS01+256
CVTSIC   EQU   CVTS01+252
CVTTPIOS EQU   CVTS01+248
CVTRTMS  EQU   CVTS01+244
CVTSDBF  EQU   CVTS01+240
CVTSCBP  EQU   CVTS01+236
CVTSDMP  EQU   CVTS01+232
CVTSV60  EQU   CVTS01+228
CVTRTMCT EQU   CVTS01+224
CVTASCBL EQU   CVTS01+220
CVTASCBH EQU   CVTS01+216
CVTGDA   EQU   CVTS01+212
CVTASVT  EQU   CVTS01+208
CVTVVMDI EQU   CVTS01+204
CVTAQTOP EQU   CVTS01+200
CVTIOSCS EQU   CVTS01+196
CVTSDRM  EQU   CVTS01+192
CVTOPTE  EQU   CVTS01+188
CVTSTXU  EQU   CVTS01+184
CVTQUIS  EQU   CVTS01+180
CVTPARS  EQU   CVTS01+176
CVTS1EE  EQU   CVTS01+172
CVTFRAS  EQU   CVTS01+168
CVTQSAS  EQU   CVTS01+164
CVTCRAS  EQU   CVTS01+160
CVTCRMN  EQU   CVTS01+156
CVTDELCP EQU   CVTS01+152
CVTFRECL EQU   CVTS01+148
CVTGETCL EQU   CVTS01+144
CVTBLDCP EQU   CVTS01+140
CVTAUTHL EQU   CVTS01+136
CVTSCAN  EQU   CVTS01+132
CVTRV144 EQU   CVTS01+130
CVTMAXMP EQU   CVTS01+128
CVTSTCK  EQU   CVTS01+124
CVTRV139 EQU   CVTS01+123
CVTDSSAC EQU   CVTS01+122
CVTRV513 EQU   CVTS01+121
CVTIOSPL EQU   CVTS01+120
CVTPTGT  EQU   CVTS01+116
CVTCSPIE EQU   CVTS01+112
CVTSMFEX EQU   CVTS01+108
CVTOLT0A EQU   CVTS01+104
CVTSRBRT EQU   CVTS01+100
CVTPUTL  EQU   CVTS01+96
CVTASCRL EQU   CVTS01+92
CVTASCRF EQU   CVTS01+88
CVTRV326 EQU   CVTS01+84
CVTRV325 EQU   CVTS01+80
CVTRV324 EQU   CVTS01+76
CVT0VL01 EQU   CVTS01+72
CVTSHRVM EQU   CVTS01+68
CVTRV332 EQU   CVTS01+64
CVTTAS   EQU   CVTS01+60
CVTRSCN  EQU   CVTS01+56
CVTTRAC2 EQU   CVTS01+54
CVTTRACE EQU   CVTS01+52
CVTAPG   EQU   CVTS01+51
CVTSDTRC EQU   CVTCTLFG
CVTGTRCE EQU   CVTCTLFG
CVTNOMP  EQU   CVTCTLFG
CVTRSV79 EQU   CVTCTLFG
CVTDSTAT EQU   CVTCTLFG
CVTRSV78 EQU   CVTCTLFG
CVTRV333 EQU   CVTCTLFG
CVTRV323 EQU   CVTCTLFG
CVTSPVLK EQU   CVTS01+49
CVTRSV77 EQU   CVTS01+48
CVTRV331 EQU   CVTS01+44
CVTRV330 EQU   CVTS01+40
CVTRV329 EQU   CVTS01+36
CVTRV328 EQU   CVTS01+32
CVTRV322 EQU   CVTS01+28
CVTSLID  EQU   CVTSLIDA+1
CVTSYLK  EQU   CVTSLIDA
CVTRV321 EQU   CVTS01+20
CVTRV320 EQU   CVTS01+16
CVTLPDIR EQU   CVTLPDIA+1
CVTRSV69 EQU   CVTDIRST
CVTRSV68 EQU   CVTDIRST
CVTRSV67 EQU   CVTDIRST
CVTRSV66 EQU   CVTDIRST
CVTRSV65 EQU   CVTDIRST
CVTRSV64 EQU   CVTDIRST
CVTRSV63 EQU   CVTDIRST
CVTDICOM EQU   CVTDIRST
CVTPVTP  EQU   CVTS01+8
CVTLPDSR EQU   CVTS01+4
CVTGETL  EQU   CVTS01
SAVTYPE  EQU   SAVMASKE+4
SAVNOBIT EQU   SAVMASKE
DEVNOBIT EQU   DEVMASKE
@NM00011 EQU   DEVMASKT+2
UCBERADR EQU   UCBUCS+12
UCBFCBID EQU   UCBUCS+8
UCBERCNT EQU   UCBUCS+7
UCBRSV51 EQU   UCBUCS+6
UCBRSV50 EQU   UCBFCBOP
UCBRSV49 EQU   UCBFCBOP
UCBRSV48 EQU   UCBFCBOP
UCBRSV47 EQU   UCBFCBOP
UCBRSV46 EQU   UCBFCBOP
UCBRSV45 EQU   UCBFCBOP
UCBRSV44 EQU   UCBFCBOP
UCBFCBO1 EQU   UCBFCBOP
UCBUCSPE EQU   UCBUCSOP
UCBRSV43 EQU   UCBUCSOP
UCBRSV42 EQU   UCBUCSOP
UCBRSV41 EQU   UCBUCSOP
UCBRSV40 EQU   UCBUCSOP
UCBRSV39 EQU   UCBUCSOP
UCBUCSO2 EQU   UCBUCSOP
UCBUCSO1 EQU   UCBUCSOP
UCBUCSID EQU   UCBUCS
UCBMDRBA EQU   UCBMDRBF+1
UCBRV075 EQU   UCBMDRBF
UCBRV074 EQU   UCB3800X+32
UCBIMAGE EQU   UCB3800X+28
UCBFCBNM EQU   UCB3800X+24
UCBCHAR4 EQU   UCB3800X+20
UCBCHAR3 EQU   UCB3800X+16
UCBCHAR2 EQU   UCB3800X+12
UCBCHAR1 EQU   UCB3800X+8
UCBCGMID EQU   UCB3800X+4
UCBBRSTA EQU   UCBACTIV
UCBRV063 EQU   UCBACTIV
UCBRV062 EQU   UCBACTIV
UCBRV061 EQU   UCBACTIV
UCBRV060 EQU   UCBACTIV
UCBRV059 EQU   UCBACTIV
UCBRV058 EQU   UCBACTIV
UCBRV057 EQU   UCBACTIV
UCBRV050 EQU   UCB3800X+2
UCBCGMNO EQU   UCB3800X+1
UCBRV083 EQU   UCBOPTNS
UCBBRSTR EQU   UCBOPTNS
UCBRV056 EQU   UCBOPTNS
UCBRV055 EQU   UCBOPTNS
UCBRV054 EQU   UCBOPTNS
UCBRV053 EQU   UCBOPTNS
UCBRV052 EQU   UCBOPTNS
UCBRV051 EQU   UCBOPTNS
UCBRV073 EQU   UCB3540X+7
UCBRV072 EQU   UCBDKBYT
UCBRV071 EQU   UCBDKBYT
UCBRV070 EQU   UCBDKBYT
UCBRV069 EQU   UCBDKBYT
UCBRV068 EQU   UCBDKBYT
UCBRV067 EQU   UCBDKBYT
UCBVLVER EQU   UCBDKBYT
UCBDKAMX EQU   UCBDKBYT
UCBVLSER EQU   UCB3540X
UCBRDATA EQU   UCBOCR+4
UCBFRID  EQU   UCBOCR
UCBCLN   EQU   UCBMT+14
UCBERG   EQU   UCBMT+12
UCBMS    EQU   UCBMT+11
UCBNB    EQU   UCBMT+10
UCBPW    EQU   UCBMT+9
UCBPR    EQU   UCBMT+8
UCBSIO   EQU   UCBMT+6
UCBTW    EQU   UCBMT+5
UCBTR    EQU   UCBMT+4
UCBTWT   EQU   UCBMT+3
UCBTRT   EQU   UCBMT+2
UCBCTD   EQU   UCBMT
UCBWTOID EQU   UCBCMEXT+17
UCBMIHTI EQU   UCBCMEXT+16
UCBASID  EQU   UCBCMEXT+14
UCBMFCNT EQU   UCBCMEXT+12
UCBPMSK  EQU   UCBCMEXT+10
UCBCCWOF EQU   UCBCMEXT+8
UCBRV041 EQU   UCBCMEXT+6
UCBRV036 EQU   UCBFLP1
UCBRV035 EQU   UCBFLP1
UCBERLOG EQU   UCBFLP1
UCBRV033 EQU   UCBFLP1
UCBRV032 EQU   UCBFLP1
UCBRV031 EQU   UCBFLP1
UCBSHRUP EQU   UCBFLP1
UCBNSRCH EQU   UCBFLP1
UCBSNSCT EQU   UCBCMEXT+4
UCBHPDV  EQU   @NM00008
UCBHALI  EQU   @NM00008
UCBRSV09 EQU   @NM00008
UCBRSV08 EQU   @NM00008
UCBRSV07 EQU   @NM00008
UCBRSV06 EQU   @NM00008
UCBRSV05 EQU   @NM00008
UCBRSV04 EQU   @NM00008
UCBDTI   EQU   UCBCMEXT+2
UCBSTI   EQU   UCBCMEXT+1
UCBETI   EQU   UCBCMEXT
UCBEXTP  EQU   UCBEXTPT+1
UCBDDRSW EQU   UCBFLC
UCBTICBT EQU   UCBFLC
UCBIVRR  EQU   UCBFLC
UCBIVRS  EQU   UCBFLC
UCBITF   EQU   UCBFLC
UCBUDE   EQU   UCBFLC
UCBWAA   EQU   UCBFLC
UCBATTP  EQU   UCBFLC
UCBUNTYP EQU   UCBTBYT4
UCBRSV11 EQU   UCBDVCLS
UCBRSV10 EQU   UCBDVCLS
UCB3CHAR EQU   UCBDVCLS
UCB3UREC EQU   UCBDVCLS
UCB3DISP EQU   UCBDVCLS
UCB3DACC EQU   UCBDVCLS
UCB3COMM EQU   UCBDVCLS
UCB3TAPE EQU   UCBDVCLS
UCBDVPWR EQU   UCB2OPT7
UCBVLPWR EQU   UCB2OPT6
UCB2OPT5 EQU   UCBTBYT2
UCBRVDEV EQU   UCBRWTAU
UCBRPS   EQU   UCBDUDN2
UCBRR    EQU   UCBDUDN1
UCB2OPT1 EQU   UCBTBYT2
UCB2OPT0 EQU   UCBTBYT2
UCB1FEA7 EQU   UCBTBYT1
UCBD6250 EQU   UCB1FEA6
UCBD1600 EQU   UCB1FEA5
UCB1FEA4 EQU   UCBTBYT1
UCB1FEA3 EQU   UCBTBYT1
UCB1FEA2 EQU   UCBTBYT1
UCB1FEA1 EQU   UCBTBYT1
UCB1FEA0 EQU   UCBTBYT1
UCBNAME  EQU   UCBOB+13
UCBRV029 EQU   UCBWGT
UCBVHRSN EQU   UCBWGT
UCBVORSN EQU   UCBWGT
UCBMTPXP EQU   UCBWGT
UCBREW   EQU   UCBWGT
UCBPUB   EQU   UCBWGT
UCBOUT   EQU   UCBWGT
UCBIN    EQU   UCBWGT
UCBCPU   EQU   UCBOB+11
UCBLCI   EQU   UCBOB+10
UCBCNT   EQU   UCBOB+9
UCBRV017 EQU   UCBCHM1
UCBRV016 EQU   UCBCHM1
UCBRV015 EQU   UCBCHM1
UCBRV014 EQU   UCBCHM1
UCBSPB   EQU   UCBPTH1
UCBPPB   EQU   UCBPTH1
UCBSPA   EQU   UCBPTH0
UCBPPA   EQU   UCBPTH0
UCBSIGP  EQU   UCBFLB
UCBVALPH EQU   UCBFLB
UCBCRHSN EQU   UCBFLB
UCBCRHRV EQU   UCBFLB
UCBRESVH EQU   UCBFLB
UCBSPST  EQU   UCBFLB
UCBASNS  EQU   UCBFLB
UCBIORST EQU   UCBFLB
UCBQISCE EQU   UCBFL1
UCBACTV  EQU   UCBFL1
UCBSAP   EQU   UCBFL1
UCBNOTRC EQU   UCBCUB
UCBPSNS  EQU   UCBFL1
UCBUSING EQU   UCBPST
UCBNOTRD EQU   UCBNRY
UCBBUSYD EQU   UCBBSY
UCBUA    EQU   UCBCHAN+1
UCBCHA   EQU   UCBCHAN
UCBDADI  EQU   UCBSTAT
UCBSYSR  EQU   UCBSTAT
UCBPRES  EQU   UCBSTAT
UCBALOC  EQU   UCBSTAT
UCBUNLD  EQU   UCBSTAT
UCBRESV  EQU   UCBSTAT
UCBCHGS  EQU   UCBSTAT
UCBONLI  EQU   UCBSTAT
UCBID    EQU   UCBOB+2
UCBALTPH EQU   UCBFL5
UCBALTCU EQU   UCBFL5
UCBNALOC EQU   UCBFL5
UCBENVRD EQU   UCBFL5
UCBVSDR  EQU   UCBFL5
UCBSASK  EQU   UCBFL5
UCBAMV   EQU   UCBAF
UCBDCC   EQU   UCBFL5
UCBMONT  EQU   UCBJBNR
UCBRV011 EQU   UCBJBNR
UCBRSV02 EQU   UCBJBNR
UCBOLDSM EQU   UCBJBNR
UCBRV003 EQU   UCBJBNR
UCBDUC   EQU   UCBJBNR
UCBJES3  EQU   UCBJBNR
UCBVRDEV EQU   UCBJBNR
UCBCMSEG EQU   UCBOB
UCBPFXND EQU   UCB+512
UCBIOQ   EQU   UCB+508
UCBLOCK  EQU   UCB+504
UCBPXST  EQU   UCB+504
@NM00005 EQU   UCB
CVTLEVL  EQU   CVTRELNO+2
CVTNUMB  EQU   CVTRELNO
CVTMDL   EQU   CVTFIX+250
@NM00004 EQU   CVTFIX+248
@NM00003 EQU   CVTFIX
CVTRV482 EQU   CVTXTNT2+128
CVTRV481 EQU   CVTXTNT2+124
CVTRV480 EQU   CVTXTNT2+120
CVTRV479 EQU   CVTXTNT2+118
CVTRV478 EQU   CVTXTNT2+117
CVTRV477 EQU   CVTXTNT2+116
CVTRV476 EQU   CVTXTNT2+115
CVTRV475 EQU   CVTXTNT2+114
CVTRV474 EQU   CVTRV466
CVTRV473 EQU   CVTRV466
CVTRV472 EQU   CVTRV466
CVTRV471 EQU   CVTRV466
CVTRV470 EQU   CVTRV466
CVTRV469 EQU   CVTRV466
CVTRV468 EQU   CVTRV466
CVTRV467 EQU   CVTRV466
CVTRV465 EQU   CVTRV457
CVTRV464 EQU   CVTRV457
CVTRV463 EQU   CVTRV457
CVTRV462 EQU   CVTRV457
CVTRV461 EQU   CVTRV457
CVTRV460 EQU   CVTRV457
CVTRV459 EQU   CVTRV457
CVTRV458 EQU   CVTRV457
CVTRV456 EQU   CVTXTNT2+108
CVTRV455 EQU   CVTXTNT2+104
CVTRV454 EQU   CVTXTNT2+100
CVTRV453 EQU   CVTXTNT2+96
CVTRV452 EQU   CVTXTNT2+94
CVTRV451 EQU   CVTXTNT2+92
CVTRV450 EQU   CVTXTNT2+90
CVTRV449 EQU   CVTXTNT2+88
CVTRV448 EQU   CVTXTNT2+87
CVTRV447 EQU   CVTXTNT2+86
CVTRV446 EQU   CVTRV438
CVTRV445 EQU   CVTRV438
CVTRV444 EQU   CVTRV438
CVTRV443 EQU   CVTRV438
CVTRV442 EQU   CVTRV438
CVTRV441 EQU   CVTRV438
CVTRV440 EQU   CVTRV438
CVTRV439 EQU   CVTRV438
CVTRV437 EQU   CVTRV429
CVTRV436 EQU   CVTRV429
CVTRV435 EQU   CVTRV429
CVTRV434 EQU   CVTRV429
CVTRV433 EQU   CVTRV429
CVTRV432 EQU   CVTRV429
CVTRV431 EQU   CVTRV429
CVTRV430 EQU   CVTRV429
CVTRV428 EQU   CVTXTNT2+80
CVTRV427 EQU   CVTXTNT2+76
CVTRV426 EQU   CVTXTNT2+72
CVTRV425 EQU   CVTXTNT2+68
CVTATACT EQU   CVTATCVT
CVTRV423 EQU   CVTXTNT2+62
CVTRV422 EQU   CVTXTNT2+60
CVTRV421 EQU   CVTXTNT2+58
CVTRV420 EQU   CVTXTNT2+56
CVTRV419 EQU   CVTXTNT2+55
CVTRV418 EQU   CVTXTNT2+54
CVTRV417 EQU   CVTRV409
CVTRV416 EQU   CVTRV409
CVTRV415 EQU   CVTRV409
CVTRV414 EQU   CVTRV409
CVTRV413 EQU   CVTRV409
CVTRV412 EQU   CVTRV409
CVTRV411 EQU   CVTRV409
CVTRV410 EQU   CVTRV409
CVTRV408 EQU   CVTRV400
CVTRV407 EQU   CVTRV400
CVTRV406 EQU   CVTRV400
CVTRV405 EQU   CVTRV400
CVTRV404 EQU   CVTRV400
CVTRV403 EQU   CVTRV400
CVTRV402 EQU   CVTRV400
CVTRV401 EQU   CVTRV400
CVTICB   EQU   CVTXTNT2+48
CVTSKTA  EQU   CVTXTNT2+44
CVTRSV99 EQU   CVTXTNT2+40
CVTRSV98 EQU   CVTXTNT2+36
CVTRSV97 EQU   CVTXTNT2+34
CVTRSV96 EQU   CVTXTNT2+32
CVTOLTEP EQU   CVTXTNT2+28
CVTQIDA  EQU   CVTQID+1
CVTRSV95 EQU   CVTQID
CVTRSV94 EQU   CVTXTNT2+20
CVTRSV93 EQU   CVTXTNT2+16
CVTRSV92 EQU   CVTXTNT2+12
CVTDEBVR EQU   CVTXTNT2+8
CVTRSV91 EQU   CVTXTNT2+6
CVTRSV9H EQU   CVTFLGBT
CVTRSV9G EQU   CVTFLGBT
CVTRSV9F EQU   CVTFLGBT
CVTRSV9E EQU   CVTFLGBT
CVTRSV9D EQU   CVTFLGBT
CVTRSV9C EQU   CVTFLGBT
CVTVME   EQU   CVTFLGBT
CVTNPE   EQU   CVTFLGBT
CVTNUCLS EQU   CVTXTNT2+4
CVTDSSVA EQU   CVTDSSV+1
CVTRSV89 EQU   CVTDSSV
CVTRSV88 EQU   CVTXTNT1+8
CVTRSV87 EQU   CVTXTNT1+4
CVTFACHN EQU   CVTXTNT1
CVTRV488 EQU   CVTMAP+412
CVTRV487 EQU   CVTMAP+408
CVTRV486 EQU   CVTMAP+404
CVTRV485 EQU   CVTMAP+400
CVTACTAP EQU   CVTMAP+396
CVTAUTH  EQU   CVTMAP+392
CVTATMCA EQU   CVTATMCT+1
CVTATMST EQU   CVTATMCT
CVTRSV61 EQU   CVTMAP+384
CVTVOLT1 EQU   CVTVOLM1+1
CVTVOLI1 EQU   CVTVOLF1
CVTSTOA  EQU   CVTMAP+376
CVTRSV58 EQU   CVTMAP+374
CVTRSV57 EQU   CVTMAP+372
CVTDDCE  EQU   CVTMAP+368
CVTPNWFR EQU   CVTMAP+364
CVTSMF   EQU   CVTMAP+360
CVTSULK  EQU   CVTMAP+358
CVTSLKO  EQU   CVTSYSK
CVTSLKP  EQU   CVTSYSK
CVTSLKQ  EQU   CVTSYSK
CVTSLKR  EQU   CVTSYSK
CVTRSV56 EQU   CVTSYSK
CVTRSV55 EQU   CVTSYSK
CVTRSV54 EQU   CVTSYSK
CVTRSV53 EQU   CVTSYSK
CVTRSV52 EQU   CVTA1F1
CVTRSV51 EQU   CVTA1F1
CVTRSV50 EQU   CVTA1F1
CVTRSV49 EQU   CVTA1F1
CVTRSV48 EQU   CVTA1F1
CVTRSV47 EQU   CVTA1F1
CVTSRSW  EQU   CVTA1F1
CVTPFSW  EQU   CVTA1F1
CVTPCVT  EQU   CVTMAP+352
CVTRSV46 EQU   CVTMAP+344
CVTRSV45 EQU   CVTMAP+340
CVTRSV44 EQU   CVTMAP+338
CVTRSV43 EQU   CVTMAP+336
CVTHJESA EQU   CVTHJES+1
CVTRSV42 EQU   CVTHJES
CVTEXT2A EQU   CVTEXT2+1
CVTRSV41 EQU   CVTEXT2
CVTAPFA  EQU   CVTAPF+1
CVTRSV40 EQU   CVTAPF
CVTRV518 EQU   CVTINTLA
CVTRV517 EQU   CVTERPV
CVTEORM  EQU   CVTMAP+312
CVTMCHPR EQU   CVTMAP+308
CVTTZ    EQU   CVTMAP+304
CVTJEPS  EQU   CVTMAP+300
CVTJESCT EQU   CVTMAP+296
CVTMODE  EQU   CVTMAP+292
CVTPTRV  EQU   CVTMAP+288
CVTREAL  EQU   CVTMAP+284
CVTRSV39 EQU   CVTMAP+280
CVTRSV38 EQU   CVTMAP+276
CVTDMSRA EQU   CVTDMSR+1
CVTRV634 EQU   CVTDMSRF
CVTRV633 EQU   CVTDMSRF
CVTRV632 EQU   CVTDMSRF
CVTRV631 EQU   CVTDMSRF
CVTRV630 EQU   CVTDMSRF
CVTRV629 EQU   CVTDMSRF
CVTUDUMP EQU   CVTDMSRF
CVTSDUMP EQU   CVTDMSRF
CVTQMSGA EQU   CVTQMSG+1
CVTRSV36 EQU   CVTQMSG
CVTAMFF  EQU   CVTMAP+264
CVTPURGA EQU   CVTPURG+1
CVTRSV35 EQU   CVTPURG
CVTCBSP  EQU   CVTMAP+256
CVTATERA EQU   CVTATER+1
CVTSYST  EQU   CVTATER
CVTVOLT2 EQU   CVTTAT
CVTVOLI2 EQU   CVTVOLF2
CVTAQAVB EQU   CVTAQAVT+1
CVTRSV34 EQU   CVTTCMFG
CVTRSV33 EQU   CVTTCMFG
CVTRSV32 EQU   CVTTCMFG
CVTRSV31 EQU   CVTTCMFG
CVTRSV30 EQU   CVTTCMFG
CVTRSV29 EQU   CVTTCMFG
CVTRSV28 EQU   CVTTCMFG
CVTTCRDY EQU   CVTTCMFG
CVTGTFA  EQU   CVTGTF+1
CVTRSV27 EQU   CVTGTFST
CVTRNIO  EQU   CVTGTFST
CVTUSR   EQU   CVTGTFST
CVTRV318 EQU   CVTFORM
CVTRV317 EQU   CVTTMODE
CVTRV316 EQU   CVTSTATE
CVTRV315 EQU   CVTGTFS
CVTGTFAV EQU   CVTGTFS
CVT0SCR1 EQU   CVTMAP+232
CVTRV515 EQU   CVTMAP+228
CVTRMS   EQU   CVTMAP+224
CVTPATCH EQU   CVTMAP+220
CVTTSCE  EQU   CVTMAP+216
CVTLNKSC EQU   CVTMAP+214
CVTQABST EQU   CVTMAP+212
CVTMDLDS EQU   CVTMAP+208
CVTUSER  EQU   CVTMAP+204
CVTABEND EQU   CVTMAP+200
CVTSMCA  EQU   CVTMAP+196
CVTRSV18 EQU   CVTMAP+192
CVTQLPAQ EQU   CVTMAP+188
CVTQCDSR EQU   CVTMAP+184
CVTRSV17 EQU   CVTOPTB
CVTRSV16 EQU   CVTOPTB
CVTFP    EQU   CVTOPTB
CVTAPTHR EQU   CVTOPTB
CVTNLOG  EQU   CVTOPTB
CVTTOD   EQU   CVTOPTB
CVTCTIMS EQU   CVTOPTB
CVTPROT  EQU   CVTOPTB
CVTXPFP  EQU   CVTOPTA
CVTASCII EQU   CVTOPTA
CVTRSV13 EQU   CVTOPTA
CVTRSV12 EQU   CVTOPTA
CVTNIP   EQU   CVTOPTA
CVTDDR   EQU   CVTOPTA
CVTAPR   EQU   CVTOPTA
CVTCCH   EQU   CVTOPTA
CVTSNCTR EQU   CVTMAP+180
CVTQMWR  EQU   CVTMAP+176
CVTQOCR  EQU   CVTMAP+172
CVT1EF00 EQU   CVTMAP+168
CVTMZ00  EQU   CVTMAP+164
CVTHEAD  EQU   CVTMAP+160
CVTRSV11 EQU   CVTMAP+156
CVT0PT01 EQU   CVTMAP+152
CVTMSER  EQU   CVTMAP+148
CVTRV516 EQU   CVTIERLC
CVTILCH  EQU   CVTMAP+140
CVT0DS   EQU   CVTMAP+136
CVTFBOSV EQU   CVTMAP+132
CVTNUCB  EQU   CVTMAP+128
CVTIXAVL EQU   CVTMAP+124
CVTIOQET EQU   CVTMAP+120
CVTDCBA  EQU   CVTMAP+117
CVTMVS2  EQU   CVTDCB
CVT6DAT  EQU   CVTDCB
CVT4MPS  EQU   CVTDCB
CVTRSV09 EQU   CVTDCB
CVT4MS1  EQU   CVTDCB
CVT2SPS  EQU   CVTDCB
CVT1SSS  EQU   CVTDCB
CVTRSV08 EQU   CVTDCB
CVTSTB   EQU   CVTMAP+112
CVTQTD00 EQU   CVTMAP+108
CVTQTE00 EQU   CVTMAP+104
CVTCUCB  EQU   CVTMAP+100
CVTSJQ   EQU   CVTMAP+96
CVTPBLDL EQU   CVTMAP+92
CVTTPC   EQU   CVTMAP+88
CVTSVDCB EQU   CVTMAP+84
CVTBRET  EQU   CVTMAP+82
CVTEXIT  EQU   CVTMAP+80
CVT0FN00 EQU   CVTMAP+76
CVTDARA  EQU   CVTDAR+1
CVTRSV07 EQU   CVTFLGS1
CVTRSV06 EQU   CVTFLGS1
CVTRSV05 EQU   CVTFLGS1
CVTRSV04 EQU   CVTFLGS1
CVTRSV03 EQU   CVTFLGS1
CVTRSV02 EQU   CVTFLGS1
CVTRSV01 EQU   CVTFLGS1
CVTDMPLK EQU   CVTFLGS1
CVTXITP  EQU   CVTMAP+68
CVTZDTAB EQU   CVTMAP+64
CVTMSLT  EQU   CVTMAP+60
CVTDATE  EQU   CVTMAP+56
CVTBTERM EQU   CVTMAP+52
CVTSYSAD EQU   CVTMAP+48
CVTXTLER EQU   CVTMAP+44
CVTILK1  EQU   CVTMAP+36
CVTPRLTV EQU   CVTMAP+32
CVTPCNVT EQU   CVTMAP+28
CVT0VL00 EQU   CVTMAP+24
CVTXAPG  EQU   CVTMAP+20
CVTBUF   EQU   CVTMAP+16
CVTJOB   EQU   CVTMAP+12
CVTLINK  EQU   CVTMAP+8
CVT0EF00 EQU   CVTMAP+4
CVTTCBP  EQU   CVTMAP
CVT      EQU   CVTMAP
VVIUNUSD EQU   VVICB+116
VVINUSDC EQU   VVICB+112
VVITPFCH EQU   VVICB+108
VVIVBSTF EQU   VVICB+100
VVISSOBA EQU   VVICB+96
VVIVSCRA EQU   VVICB+92
VVISTPTB EQU   VVICB+88
VVIJUCB  EQU   VVICB+80
VVIIUCB  EQU   VVICB+76
VVIRES6  EQU   VVICB+72
VVIRES5  EQU   VVICB+68
VVIRES4  EQU   VVICB+64
VVIVJL   EQU   VVICB+56
VVIVRR   EQU   VVICB+52
VVIQLSPL EQU   VVICB+48
VVIQRPL2 EQU   VVICB+44
VVIQRPL1 EQU   VVICB+40
VVIRES3  EQU   VVICB+36
VVIVQMP  EQU   VVICB+32
VVIECB1  EQU   VVICB+28
VVICATAD EQU   VVICB+24
VVIDCBAD EQU   VVICB+20
VVIACBAD EQU   VVICB+16
VVIFLG7  EQU   VVIFLGA
VVIFLG6  EQU   VVIFLGA
VVIFLG5  EQU   VVIFLGA
VVIFLG4  EQU   VVIFLGA
VVIFLG3  EQU   VVIFLGA
VVIFLG2  EQU   VVIFLGA
VVIFLG1  EQU   VVIFLGA
VVIFLG0  EQU   VVIFLGA
VVIALCON EQU   VVICB+14
VVICPUID EQU   VVICB+12
VVIUCAT  EQU   VVICB+4
VVICID   EQU   VVICB
@NM00002 EQU   UNIFLAGS
@NM00001 EQU   UNITP+10
*                                      END UNREFERENCED COMPONENTS
@RC00114 EQU   @EL00003
@RF00128 EQU   @EL00004
@RF00142 EQU   @EL00005
@RC00158 EQU   @EL00006
BITON    EQU   @EL00006
@RC00118 EQU   @RC00114
@ENDDATA EQU   *
         END   ICBVUP00,(C'PLS1821',0603,76279)
