         TITLE 'ICGDSB12 MSC TABLE CREATE, SCRATCH CARTRIDGE LIST      *
                        '
ICGDSB12 CSECT ,                                                   0001
@MAINENT DS    0H                                                  0001
         USING *,@15                                               0001
         B     @PROLOG                                             0001
         DC    AL1(16)                                             0001
         DC    C'ICGDSB12  76.337'                                 0001
         DROP  @15
@PROLOG  STM   @14,@12,12(@13)                                     0001
         BALR  @12,0                                               0001
@PSTART  DS    0H                                                  0001
         USING @PSTART,@12                                         0001
         L     @00,@SIZDATD                                        0001
         GETMAIN  R,LV=(0)
         LR    @11,@01                                             0001
         USING @DATD,@11                                           0001
         ST    @13,@SA00001+4                                      0001
         LM    @00,@01,20(@13)                                     0001
         ST    @11,8(,@13)                                         0001
         LR    @13,@11                                             0001
         XC    @ZTEMPS(@ZLEN),@ZTEMPS
*                                                                  0016
*/********************************************************** @XD00153*/
*/*      ICGDSB12 (MAINLINE)                                 @XD00153*/
*/*                                                          @XD00153*/
*/*      INITIALIZE FIELDS AND ESTABLISH ADDRESSABILITY TO   @XD00153*/
*/*      DCB'S AND I/O BUFFERS.  SET UP LIBRARY'S SECOND     @XD00153*/
*/*      TRACK ADDRESS FOR THE SCRATCH CARTRIDGE LISTS.      @XD00153*/
*/*      CALL PROCEDURE 'NEW' TO BUILD A NEW LIBRARY, OR     @XD00153*/
*/*      CALL 'DUPELIB' IF A LIBRARY IS TO BE UPDATED.       @XD00153*/
*/********************************************************** @XD00153*/
*                                                                  0016
*   OUTCYL(1)=UT2VCYL;              /* STARTING CYLINDER NUMBER    0016
*                                                            @Y30LB14*/
         L     @10,BUILDPTR(,R4)                                   0016
         LH    @05,@CH00457                                        0016
         ALR   @05,@10                                             0016
         MVC   OUTCYL(1,@05),UT2VCYL(@10)                          0016
*   OUTHEAD(1)=UT2VHEAD;            /* STARTING HEAD NUMBER  @Y30LB14*/
         MVC   OUTHEAD(1,@05),UT2VHEAD(@10)                        0017
*   ORECORD(1)=UT2VREC;             /* STARTING RECORD NUMBER      0018
*                                                            @Y30LB14*/
         MVC   ORECORD(1,@05),UT2VREC(@10)                         0018
*   B05DCBPT=ADDR(UT1DCB);          /*                       @Y30LB14*/
         LA    @05,UT1DCB(,@10)                                    0019
         ST    @05,B05DCBPT(,@10)                                  0019
*   B06DCBPT=ADDR(UT2DCB);          /*                       @Y30LB14*/
         LA    @05,UT2DCB(,@10)                                    0020
         ST    @05,B06DCBPT(,@10)                                  0020
*   B06BUFPT=ADDR(UT2BUFER);        /* ADDRESS OF WRITE      @Y30LB14
*                                      BUFFER                @Y30LB14*/
         LR    @05,@10                                             0021
         AL    @05,@CF00457                                        0021
         ST    @05,B06BUFPT(,@10)                                  0021
*   B05BUFPT=ADDR(UT1BUFER);        /* ADDRESS OF READ       @Y30LB14
*                                      BUFFER                @Y30LB14*/
         LR    @05,@10                                             0022
         AL    @05,@CF00459                                        0022
         ST    @05,B05BUFPT(,@10)                                  0022
*   STOPSCAN='0'B;                  /*                       @Y30LB14*/
         NI    STOPSCAN,B'01111111'                                0023
*   SWITCH='N';                     /*                       @Y30LB14
*                                                            @Y30LB14*/
*                                                                  0024
         MVI   SWITCH,C'N'                                         0024
*   /*****************************************************************/
*   /*                                                               */
*   /* ***********************************************       @XD00153*/
*   /* SET UP SECOND TRACK ADDRESS OF ALL 4 LIBRARIES        @Y30LB14*/
*   /* ***********************************************       @XD00153*/
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0025
*   DO K=1 TO 4;                    /*                       @Y30LB14*/
         LA    K,1                                                 0025
@DL00025 DS    0H                                                  0026
*     TRK2HED(K)=(UT2VHEAD+12*K-8)//19;/*                    @Y30LB14*/
         LR    @10,K                                               0026
         MH    @10,@CH00048                                        0026
         LA    @05,19                                              0026
         L     @02,BUILDPTR(,R4)                                   0026
         LR    @15,K                                               0026
         MH    @15,@CH00128                                        0026
         MVC   @ZT00003+3(1),UT2VHEAD(@02)                         0026
         AL    @15,@ZT00003                                        0026
         SH    @15,@CH00040                                        0026
         LR    @00,@15                                             0026
         SRDA  @00,32                                              0026
         DR    @00,@05                                             0026
         STC   @00,TRK2HED-3(@10)                                  0026
*     TRK2CYL(K)=                   /*                       @Y30LB14*/
*         UT2VCYL+(UT2VHEAD+12*K-8)/19;/*                    @Y30LB14*/
         LR    @00,@15                                             0027
         SRDA  @00,32                                              0027
         DR    @00,@05                                             0027
         MVC   @ZT00003+3(1),UT2VCYL(@02)                          0027
         AL    @01,@ZT00003                                        0027
         STC   @01,TRK2CYL-3(@10)                                  0027
*   END;                            /*                       @Y30LB14
*                                                            @Y30LB14*/
*                                                                  0028
         AH    K,@CH00042                                          0028
         CH    K,@CH00068                                          0028
         BNH   @DL00025                                            0028
*   /*****************************************************************/
*   /*                                                               */
*   /* ***********************************************       @XD00153*/
*   /* IF A COMPLETELY NEW LIBRARY IS TO BE BUILT            @Y30LB14*/
*   /* FROM SCRATCH, THEN 'NEW' IS CALLED.                   @XD00153*/
*   /* IF A LIBRARY IS BEING UPDATED THEN THE CON-           @Y30LB14*/
*   /* TENTS OF THE OLD LIBRARIES ARE COPIED INTO            @Y30LB14*/
*   /* THE NEW LIBRARIES VIA PROCEDURE 'DUPELIB'.            @XD00153*/
*   /* ***********************************************       @XD00153*/
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0029
*   IF NEWCREAT='1'B                /*                       @Y30LB14*/
*     THEN                          /*                       @Y30LB14*/
         TM    NEWCREAT(R4),B'01000000'                            0029
         BNO   @RF00029                                            0029
*     CALL NEW;                     /* BUILD A COMPLETELY NEW LIB  0030
*                                                            @Y30LB14*/
         BAL   @14,NEW                                             0030
*   IF UPDCREAT='1'B                /*                       @Y30LB14*/
*     THEN                          /*                       @Y30LB14*/
@RF00029 TM    UPDCREAT(R4),B'00100000'                            0031
         BNO   @RF00031                                            0031
*     CALL DUPELIB;                 /* COPY THE CURRENT LIBRARY    0032
*                                                            @Y30LB14
*                                                            @Y30LB14*/
*                                                                  0032
         BAL   @14,DUPELIB                                         0032
*   /*****************************************************************/
*   /*                                                               */
*   /* ***********************************************       @XD00153*/
*   /* RETURN TO THE BUILD MODULE - ICGDSBLD                 @Y30LB14*/
*   /* ***********************************************       @XD00153*/
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0033
*   RETURN;                         /* RETURN TO BUILD       @Y30LB14*/
@EL00001 L     @13,4(,@13)                                         0033
@EF00001 L     @00,@SIZDATD                                        0033
         LR    @01,@11                                             0033
         FREEMAIN R,LV=(0),A=(1)
@ER00001 LM    @14,@12,12(@13)                                     0033
         BR    @14                                                 0033
*                                                                  0034
*/********************************************************** @XD00153*/
*/*                                                          @XD00153*/
*/* PROCEDURE NAME - NEW                                     @XD00153*/
*/*                                                          @XD00153*/
*/* FUNCTION - THIS ROUTINE DIRECTS CONTROL TO 3 SUBROUTINES @XD00153*/
*/*            TO WRITE TRACK AND PREFIX INFO.  THE 3RD      @XD00153*/
*/*            ROUTINE IS CALLED TO MODIFY THE LAST RECORD   @XD00153*/
*/*            SO THAT IT INDICATES IT IS THE LAST RECORD.   @XD00153*/
*/*                                                          @XD00153*/
*/********************************************************** @XD00153*/
*                                                                  0034
*NEW:                                                              0034
*   PROCEDURE;                      /*                       @Y30LB14*/
NEW      STM   @14,@12,@SA00002                                    0034
*   SWITCH='Y';                     /*                       @Y30LB14*/
         MVI   SWITCH,C'Y'                                         0035
*   DO K=1 TO 4;                    /*                       @Y30LB14*/
         LA    K,1                                                 0036
@DL00036 DS    0H                                                  0037
*     CALL WRANYTRK;                /* WRITE BASIC INFO IN A TRACK 0037
*                                                            @Y30LB14*/
         BAL   @14,WRANYTRK                                        0037
*     CALL WRITETRK;                /* PUT PREFIX INFO IN THE TRACK
*                                                            @Y30LB14*/
         BAL   @14,WRITETRK                                        0038
*   END;                            /*                       @Y30LB14*/
         AH    K,@CH00042                                          0039
         CH    K,@CH00068                                          0039
         BNH   @DL00036                                            0039
*   SWITCH='N';                     /*                       @Y30LB14*/
         MVI   SWITCH,C'N'                                         0040
*   DO K=1 TO 4;                    /*                       @Y30LB14*/
         LA    K,1                                                 0041
@DL00041 DS    0H                                                  0042
*     DO I=1 TO 11;                 /*                       @Y30LB14*/
         LA    I,1                                                 0042
@DL00042 DS    0H                                                  0043
*       CALL WRANYTRK;              /* WRITE BASIC INFO IN A TRK   0043
*                                                            @Y30LB14*/
         BAL   @14,WRANYTRK                                        0043
*       CALL WRITETRK;              /* PUT PREFIX INFO IN THE TRK  0044
*                                                            @Y30LB14*/
         BAL   @14,WRITETRK                                        0044
*     END;                          /*                       @Y30LB14*/
         AH    I,@CH00042                                          0045
         CH    I,@CH00246                                          0045
         BNH   @DL00042                                            0045
*     CALL WRANYTRK;                /* WRITE BASIC INFO IN A TRACK 0046
*                                                            @Y30LB14*/
         BAL   @14,WRANYTRK                                        0046
*     CALL WRLASTTK;                /* MODIFY TRACK INTO LAST TRACK
*                                                            @Y30LB14*/
         BAL   @14,WRLASTTK                                        0047
*     CALL WRITETRK;                /* PUT PREFIX INFO IN THE TRACK
*                                                            @Y30LB14*/
         BAL   @14,WRITETRK                                        0048
*   END;                            /* END OF DO K LOOP      @Y30LB14*/
         AH    K,@CH00042                                          0049
         CH    K,@CH00068                                          0049
         BNH   @DL00041                                            0049
*   RETURN;                         /* RETURN TO CALLER      @Y30LB14*/
@EL00002 DS    0H                                                  0050
@EF00002 DS    0H                                                  0050
@ER00002 LM    @14,@12,@SA00002                                    0050
         BR    @14                                                 0050
*   END NEW;                        /*                       @Y30LB14*/
*                                                                  0052
*/********************************************************** @XD00153*/
*/*                                                          @XD00153*/
*/* PROCEDURE NAME - COPYLIB                                 @XD00153*/
*/*                                                          @XD00153*/
*/* FUNCTION - THIS ROUTINE GETS A TRACK FROM AN OLD LIBRARY @XD00153*/
*/*            VIA ICGDSB05, AND MOVES THE DATA TO THE       @XD00153*/
*/*            OUTPUT BUFFER.  IT SETS THE NEXT TRACK ADDR   @XD00153*/
*/*            IN STORAGE FOR NEXT READ REQUEST.             @XD00153*/
*/*                                                          @XD00153*/
*/********************************************************** @XD00153*/
*                                                                  0052
*COPYLIB:                                                          0052
*   PROCEDURE;                      /*                       @Y30LB14
*                                                            @Y30LB14*/
*                                                                  0052
COPYLIB  STM   @14,@12,@SA00003                                    0052
*   /*****************************************************************/
*   /*                                                               */
*   /* ***********************************************       @XD00153*/
*   /* READ IN A COMPLETE TRACK FROM THE OLD LIBRARY         @Y30LB14*/
*   /* ***********************************************       @XD00153*/
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0053
*   B05ADDR=INADDR;                 /* SET READ ADDRESS      @Y30LB14*/
         L     @10,BUILDPTR(,R4)                                   0053
         MVC   B05ADDR(3,@10),INADDR(@10)                          0053
*   GEN(LINK EP=ICGDSB05);          /* READ IN A TRACK       @Y30LB14
*                                                            @Y30LB14*/
         LINK EP=ICGDSB05
*   UT1VHEAD=UT1VHEAD+1;            /* INCR INPUT HEAD COUNT @Y30LB14*/
         L     @10,BUILDPTR(,R4)                                   0055
         LA    @05,1                                               0055
         SLR   @15,@15                                             0055
         IC    @15,UT1VHEAD(,@10)                                  0055
         ALR   @15,@05                                             0055
         STC   @15,UT1VHEAD(,@10)                                  0055
*   IF UT1VHEAD>18                  /*                       @Y30LB14*/
*     THEN                          /*                       @Y30LB14*/
         CLI   UT1VHEAD(@10),18                                    0056
         BNH   @RF00056                                            0056
*     DO;                           /*                       @Y30LB14*/
*       UT1VHEAD=0;                 /*                       @Y30LB14*/
         MVI   UT1VHEAD(@10),X'00'                                 0058
*       UT1VCYL=UT1VCYL+1;          /*                       @Y30LB14*/
         MVC   @ZT00003+3(1),UT1VCYL(@10)                          0059
         AL    @05,@ZT00003                                        0059
         STC   @05,UT1VCYL(,@10)                                   0059
*     END;                          /*                       @Y30LB14*/
*                                                                  0060
*   /*****************************************************************/
*   /*                                                               */
*   /* ***********************************************       @XD00153*/
*   /* COPY INFORMATION FROM INPUT BUFFER TO OUTPUT          @Y30LB14*/
*   /* BUFFER                                                @Y30LB14*/
*   /* ***********************************************       @XD00153*/
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0061
*   DO J=1 TO 32;                   /*                       @Y30LB14*/
@RF00056 LA    J,1                                                 0061
@DL00061 DS    0H                                                  0062
*     OBLKPRFX(J)=INBLKPFX(J);      /* MOVE INPUT TRK        @Y30LB14*/
         LR    @10,J                                               0062
         MH    @10,@CH00458                                        0062
         L     @05,BUILDPTR(,R4)                                   0062
         LH    @03,@CH00457                                        0062
         ALR   @03,@05                                             0062
         ST    @10,@TF00001                                        0062
         ALR   @10,@03                                             0062
         AL    @10,@CF00466                                        0062
         LR    @15,J                                               0062
         MH    @15,@CH00460                                        0062
         AH    @05,@CH00459                                        0062
         ST    @15,@TF00002                                        0062
         ALR   @15,@05                                             0062
         AL    @15,@CF00466                                        0062
         MVC   OBLKPRFX-8(8,@10),INBLKPFX(@15)                     0062
*     OCONTROL(J)=INCONTRL(J);      /*                       @Y30LB14*/
         LR    @10,@03                                             0063
         AL    @10,@TF00001                                        0063
         AL    @10,@CF00467                                        0063
         LR    @01,@05                                             0063
         AL    @01,@TF00002                                        0063
         AL    @01,@CF00467                                        0063
         MVC   OCONTROL-16(8,@10),INCONTRL-8(@01)                  0063
*     OCARTBLK(J)=ICRTBLK(J);       /*                       @Y30LB14*/
         LR    @10,@03                                             0064
         AL    @10,@TF00001                                        0064
         AL    @10,@CF00468                                        0064
         LR    @01,@05                                             0064
         AL    @01,@TF00002                                        0064
         AL    @01,@CF00468                                        0064
         MVC   OCARTBLK-24(240,@10),ICRTBLK-16(@01)                0064
*     OFILLER(J)=IFILLER(J);        /*                       @Y30LB14*/
         AL    @03,@TF00001                                        0065
         AL    @03,@CF00469                                        0065
         AL    @05,@TF00002                                        0065
         AL    @05,@CF00469                                        0065
         MVC   OFILLER-264(8,@03),IFILLER-256(@05)                 0065
*   END;                            /*                       @Y30LB14
*                                                            @Y30LB14*/
         AH    J,@CH00042                                          0066
         CH    J,@CH00309                                          0066
         BNH   @DL00061                                            0066
*   RETURN;                         /* RETURN TO CALLER      @Y30LB14*/
@EL00003 DS    0H                                                  0067
@EF00003 DS    0H                                                  0067
@ER00003 LM    @14,@12,@SA00003                                    0067
         BR    @14                                                 0067
*   END COPYLIB;                    /*                       @Y30LB14
*                                                            @Y30LB14*/
*                                                                  0069
*/********************************************************** @XD00153*/
*/*                                                          @XD00153*/
*/* PROCEDURE NAME - DUPELIB                                 @XD00153*/
*/*                                                          @XD00153*/
*/* FUNCTION - DIRECTS CONTROL TO PROCEDURES 'COPYLIB' AND   @XD00153*/
*/*            'WRITETRK' TO GET OLD LIBRARY DATA AND PUT    @XD00153*/
*/*            THE DATA INTO THE NEW LIBRARY.                @XD00153*/
*/*                                                          @XD00153*/
*/********************************************************** @XD00153*/
*                                                                  0069
*DUPELIB:                                                          0069
*   PROCEDURE;                      /*                       @Y30LB14*/
DUPELIB  STM   @14,@12,@SA00004                                    0069
*   DO K=1 TO 4;                    /*                       @Y30LB14*/
         LA    K,1                                                 0070
@DL00070 DS    0H                                                  0071
*     CALL COPYLIB;                 /* COPY OLD LIBRARY INTO NEW LIB
*                                                            @Y30LB14*/
         BAL   @14,COPYLIB                                         0071
*     DO J=1 TO 32;                 /*                       @Y30LB14*/
         LA    J,1                                                 0072
@DL00072 DS    0H                                                  0073
*       OHEAD(J)=TRK2HED(K);        /*                       @Y30LB14*/
         LR    @10,J                                               0073
         MH    @10,@CH00458                                        0073
         LH    @05,@CH00457                                        0073
         AL    @05,BUILDPTR(,R4)                                   0073
         LR    @15,K                                               0073
         MH    @15,@CH00048                                        0073
         SLR   @14,@14                                             0073
         IC    @14,TRK2HED-3(@15)                                  0073
         LA    @01,0(@10,@05)                                      0073
         AL    @01,@CF00470                                        0073
         STC   @14,OHEAD-22(,@01)                                  0073
*       OCYL(J)=TRK2CYL(K);         /*                       @Y30LB14*/
         SLR   @14,@14                                             0074
         IC    @14,TRK2CYL-3(@15)                                  0074
         AL    @05,@CF00471                                        0074
         STC   @14,OCYL-21(@10,@05)                                0074
*     END;                          /*                       @Y30LB14*/
         AH    J,@CH00042                                          0075
         CH    J,@CH00309                                          0075
         BNH   @DL00072                                            0075
*     CALL WRITETRK;                /* PUT PREFIX INFO IN THE TRACK
*                                                            @Y30LB14*/
         BAL   @14,WRITETRK                                        0076
*   END;                            /*                       @Y30LB14*/
         AH    K,@CH00042                                          0077
         CH    K,@CH00068                                          0077
         BNH   @DL00070                                            0077
*   DO K=1 TO 4;                    /*                       @Y30LB14*/
         LA    K,1                                                 0078
@DL00078 DS    0H                                                  0079
*     DO I=1 TO 11;                 /*                       @Y30LB14*/
         LA    I,1                                                 0079
@DL00079 DS    0H                                                  0080
*       CALL COPYLIB;               /* COPY OLD LIB INTO NEW LIB   0080
*                                                            @Y30LB14*/
         BAL   @14,COPYLIB                                         0080
*       OHEAD(1)=UT2VHEAD+1;        /*                       @Y30LB14*/
         L     @10,BUILDPTR(,R4)                                   0081
         LH    @02,@CH00457                                        0081
         ALR   @02,@10                                             0081
         LA    @15,1                                               0081
         SLR   @14,@14                                             0081
         IC    @14,UT2VHEAD(,@10)                                  0081
         ALR   @14,@15                                             0081
         STC   @14,OHEAD(,@02)                                     0081
*       OCYL(1)=UT2VCYL;            /*                       @Y30LB14*/
         MVC   OCYL(1,@02),UT2VCYL(@10)                            0082
*       IF OHEAD(1)>18              /*                       @Y30LB14*/
*         THEN                      /*                       @Y30LB14*/
         CLI   OHEAD(@02),18                                       0083
         BNH   @RF00083                                            0083
*         DO;                       /*                       @Y30LB14*/
*           OHEAD(1)=0;             /*                       @Y30LB14*/
         MVI   OHEAD(@02),X'00'                                    0085
*           OCYL(1)=OCYL(1)+1;      /*                       @Y30LB14*/
         MVC   @ZT00003+3(1),OCYL(@02)                             0086
         AL    @15,@ZT00003                                        0086
         STC   @15,OCYL(,@02)                                      0086
*         END;                      /*                       @Y30LB14*/
*       DO J=2 TO 32;               /*                       @Y30LB14*/
@RF00083 LA    J,2                                                 0088
@DL00088 DS    0H                                                  0089
*         OHEAD(J)=OHEAD(1);        /*                       @Y30LB14*/
         LR    @10,J                                               0089
         MH    @10,@CH00458                                        0089
         LH    @15,@CH00457                                        0089
         AL    @15,BUILDPTR(,R4)                                   0089
         SLR   @14,@14                                             0089
         IC    @14,OHEAD(,@15)                                     0089
         LA    @01,0(@10,@15)                                      0089
         AL    @01,@CF00470                                        0089
         STC   @14,OHEAD-22(,@01)                                  0089
*         OCYL(J)=OCYL(1);          /*                       @Y30LB14*/
         SLR   @14,@14                                             0090
         IC    @14,OCYL(,@15)                                      0090
         AL    @15,@CF00471                                        0090
         STC   @14,OCYL-21(@10,@15)                                0090
*       END;                        /*                       @Y30LB14*/
         AH    J,@CH00042                                          0091
         CH    J,@CH00309                                          0091
         BNH   @DL00088                                            0091
*       CALL WRITETRK;              /* PUT PREFIX INFO IN THE TRK  0092
*                                                            @Y30LB14*/
         BAL   @14,WRITETRK                                        0092
*     END;                          /*                       @Y30LB14*/
         AH    I,@CH00042                                          0093
         CH    I,@CH00246                                          0093
         BNH   @DL00079                                            0093
*     CALL COPYLIB;                 /*                       @Y30LB14*/
         BAL   @14,COPYLIB                                         0094
*     DO J=1 TO 32;                 /*                       @Y30LB14*/
         LA    J,1                                                 0095
@DL00095 DS    0H                                                  0096
*       OHEAD(J)=0;                 /*                       @Y30LB14*/
         SLR   @10,@10                                             0096
         LR    @05,J                                               0096
         MH    @05,@CH00458                                        0096
         LH    @15,@CH00457                                        0096
         AL    @15,BUILDPTR(,R4)                                   0096
         LA    @01,0(@05,@15)                                      0096
         AL    @01,@CF00470                                        0096
         STC   @10,OHEAD-22(,@01)                                  0096
*       OCYL(J)=0;                  /*                       @Y30LB14*/
         AL    @15,@CF00471                                        0097
         STC   @10,OCYL-21(@05,@15)                                0097
*     END;                          /*                       @Y30LB14*/
         AH    J,@CH00042                                          0098
         CH    J,@CH00309                                          0098
         BNH   @DL00095                                            0098
*     CALL WRITETRK;                /* PUT PREFIX INFO IN THE TRK  0099
*                                                            @Y30LB14*/
         BAL   @14,WRITETRK                                        0099
*   END;                            /*                       @Y30LB14*/
         AH    K,@CH00042                                          0100
         CH    K,@CH00068                                          0100
         BNH   @DL00078                                            0100
*   RETURN;                         /* RETURN TO CALLER      @Y30LB14*/
@EL00004 DS    0H                                                  0101
@EF00004 DS    0H                                                  0101
@ER00004 LM    @14,@12,@SA00004                                    0101
         BR    @14                                                 0101
*   END DUPELIB;                    /*                       @Y30LB14*/
*                                                                  0103
*/********************************************************** @XD00153*/
*/*                                                          @XD00153*/
*/* PROCEDURE NAME - WRLASTTK                                @XD00153*/
*/*                                                          @XD00153*/
*/* FUNCTION - THIS ROUTINE WRITES THE PROPER CONTROL BITS   @XD00153*/
*/*            IN THE LAST TRACK OF THE TABLE.  THE BITS     @XD00153*/
*/*            THAT ARE SET ARE:                             @XD00153*/
*/*                     END OF TRACK BLOCK                   @XD00153*/
*/*                     LAST TRACK IN TABLE                  @XD00153*/
*/*            THE VOLUME, CYLINDER, TRACK AND RECORD OF THE @XD00153*/
*/*            NEXT AVAILABLE ARE FORCED TO ZEROS.           @XD00153*/
*/*                                                          @XD00153*/
*/********************************************************** @XD00153*/
*                                                                  0103
*WRLASTTK:                                                         0103
*   PROCEDURE;                      /*                       @Y30LB14*/
*                                                                  0103
WRLASTTK STM   @14,@12,12(@13)                                     0103
*   /*****************************************************************/
*   /*                                                               */
*   /* ***********************************************       @XD00153*/
*   /* PUT CONTROL BIT INFORMATION IN ALL 32 BLOCKS          @Y30LB14*/
*   /* OF THE LAST TRACK                                     @Y30LB14*/
*   /* ***********************************************       @XD00153*/
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0104
*   DO I=1 TO 32;                   /*                       @Y30LB14*/
         LA    I,1                                                 0104
@DL00104 DS    0H                                                  0105
*     OLTIT(I)='1'B;                /*                       @Y30LB14*/
         LR    @10,I                                               0105
         MH    @10,@CH00458                                        0105
         LH    @15,@CH00457                                        0105
         AL    @15,BUILDPTR(,R4)                                   0105
         ST    @10,@TF00001                                        0105
         ALR   @10,@15                                             0105
         AL    @10,@CF00467                                        0105
         OI    OLTIT-16(@10),B'00010000'                           0105
*     OVOLUME(I)=0;                 /*                       @Y30LB14*/
         SLR   @10,@10                                             0106
         L     @14,@TF00001                                        0106
         AL    @14,@CF00473                                        0106
         STC   @10,OVOLUME-20(@14,@15)                             0106
*     OCYL(I)=0;                    /*                       @Y30LB14*/
         L     @14,@TF00001                                        0107
         AL    @14,@CF00471                                        0107
         STC   @10,OCYL-21(@14,@15)                                0107
*     OHEAD(I)=0;                   /*                       @Y30LB14*/
         L     @14,@TF00001                                        0108
         AL    @14,@CF00470                                        0108
         STC   @10,OHEAD-22(@14,@15)                               0108
*     ORECORD(I)=0;                 /*                       @Y30LB14*/
         L     @14,@TF00001                                        0109
         AL    @15,@CF00474                                        0109
         STC   @10,ORECORD-23(@14,@15)                             0109
*   END;                            /*                       @Y30LB14
*                                                            @Y30LB14*/
*                                                                  0110
         AH    I,@CH00042                                          0110
         CH    I,@CH00309                                          0110
         BNH   @DL00104                                            0110
*   /*****************************************************************/
*   /*                                                               */
*   /* SET LAST TABLE BLOCK                                  @Y30LB14*/
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0111
*   OLTB(32)='1'B;                  /*                       @Y30LB14
*                                                            @Y30LB14*/
         L     @10,BUILDPTR(,R4)                                   0111
         AL    @10,@CF00475                                        0111
         OI    OLTB(@10),B'10000000'                               0111
*   RETURN;                         /* RETURN TO CALLER      @Y30LB14*/
@EL00005 DS    0H                                                  0112
@EF00005 DS    0H                                                  0112
@ER00005 LM    @14,@12,12(@13)                                     0112
         BR    @14                                                 0112
*   END WRLASTTK;                   /*                       @Y30LB14
*                                                            @Y30LB14*/
*                                                                  0114
*/********************************************************** @XD00153*/
*/*                                                          @XD00153*/
*/* PROCEDURE NAME - WRANYTRK                                @XD00153*/
*/*                                                          @XD00153*/
*/* FUNCTION - THIS ROUTINE INITIALIZES PART OF THE OUTPUT   @XD00153*/
*/*            BUFFER, WHICH INCLUDES ENTERING THE CCHHR     @XD00153*/
*/*            TRACK ADDRESS INFORMATION.                    @XD00153*/
*/*                                                          @XD00153*/
*/********************************************************** @XD00153*/
*                                                                  0114
*WRANYTRK:                                                         0114
*   PROCEDURE;                      /*                       @Y30LB14*/
WRANYTRK STM   @14,@12,12(@13)                                     0114
*   OLTB(1)='0'B;                   /*                       @Y30LB14*/
*   OLAB(1)='0'B;                   /*                       @Y30LB14*/
*   OEOTB(1)='0'B;                  /*                       @Y30LB14*/
*   OLTIT(1)='0'B;                  /*                       @Y30LB14*/
         LH    @10,@CH00457                                        0118
         AL    @10,BUILDPTR(,R4)                                   0118
         NI    OLTB(@10),B'00001111'                               0118
*   OCOMPLEN(1)='1100'B;            /*                       @Y30LB14*/
         NI    OCOMPLEN(@10),B'11111100'                           0119
         OI    OCOMPLEN(@10),B'00001100'                           0119
*   OENTRYLN(1)=20;                 /*                       @Y30LB14*/
         MVI   OENTRYLN(@10),X'14'                                 0120
*   OMAXEPB(1)=12;                  /*                       @Y30LB14*/
         MVI   OMAXEPB(@10),X'0C'                                  0121
*   OUSECNT(1)=0;                   /*                       @Y30LB14*/
         MVI   OUSECNT(@10),X'00'                                  0122
*   OVOLUME(1)=0;                   /*                       @Y30LB14*/
         MVI   OVOLUME(@10),X'00'                                  0123
*   IF OUTHEAD(1)+1>18              /*                       @Y30LB14*/
*     THEN                          /*                       @Y30LB14*/
         LA    @05,1                                               0124
         SLR   @02,@02                                             0124
         IC    @02,OUTHEAD(,@10)                                   0124
         ALR   @02,@05                                             0124
         CH    @02,@CH00435                                        0124
         BNH   @RF00124                                            0124
*     DO;                           /*                       @Y30LB14*/
*       OHEAD(1)=0;                 /*                       @Y30LB14*/
         MVI   OHEAD(@10),X'00'                                    0126
*       OCYL(1)=OUTCYL(1)+1;        /*                       @Y30LB14*/
         MVC   @ZT00003+3(1),OUTCYL(@10)                           0127
         AL    @05,@ZT00003                                        0127
         STC   @05,OCYL(,@10)                                      0127
*     END;                          /*                       @Y30LB14*/
*   ELSE                            /*                       @Y30LB14*/
*     DO;                           /*                       @Y30LB14*/
         B     @RC00124                                            0129
@RF00124 DS    0H                                                  0130
*       OHEAD(1)=OUTHEAD(1)+1;      /*                       @Y30LB14*/
         LH    @10,@CH00457                                        0130
         AL    @10,BUILDPTR(,R4)                                   0130
         LA    @05,1                                               0130
         MVC   @ZT00003+3(1),OUTHEAD(@10)                          0130
         AL    @05,@ZT00003                                        0130
         STC   @05,OHEAD(,@10)                                     0130
*       OCYL(1)=OUTCYL(1);          /*                       @Y30LB14*/
         MVC   OCYL(1,@10),OUTCYL(@10)                             0131
*     END;                          /*                       @Y30LB14*/
*   IF SWITCH='Y'                   /* TO PUT IN 2ND TRK ADDR      0133
*                                                            @Y30LB14*/
*     THEN                          /*                       @Y30LB14*/
@RC00124 CLI   SWITCH,C'Y'                                         0133
         BNE   @RF00133                                            0133
*     DO;                           /*                       @Y30LB14*/
*       OHEAD(1)=TRK2HED(K);        /*                       @Y30LB14*/
         LH    @10,@CH00457                                        0135
         AL    @10,BUILDPTR(,R4)                                   0135
         LR    @05,K                                               0135
         MH    @05,@CH00048                                        0135
         SLR   @02,@02                                             0135
         IC    @02,TRK2HED-3(@05)                                  0135
         STC   @02,OHEAD(,@10)                                     0135
*       OCYL(1)=TRK2CYL(K);         /*                       @Y30LB14*/
         SLR   @02,@02                                             0136
         IC    @02,TRK2CYL-3(@05)                                  0136
         STC   @02,OCYL(,@10)                                      0136
*     END;                          /*                       @Y30LB14*/
*   ORECORD(1)=1;                   /*                       @Y30LB14*/
@RF00133 LH    @10,@CH00457                                        0138
         AL    @10,BUILDPTR(,R4)                                   0138
         MVI   ORECORD(@10),X'01'                                  0138
*   OCARTBLK(1)=''B;                /* SET CART INFO TO ZERO @Y30LB14*/
         XC    OCARTBLK(240,@10),OCARTBLK(@10)                     0139
*   OFILLER(1)=''B;                 /* SET FILLER TO ZERO    @Y30LB14
*                                                            @Y30LB14*/
         XC    OFILLER(8,@10),OFILLER(@10)                         0140
*   DO J=2 TO 32;                   /* PUT IN ALL 32 BLOCKS  @Y30LB14*/
         LA    J,2                                                 0141
@DL00141 DS    0H                                                  0142
*     OCONTROL(J)=OCONTROL(1);      /*                       @Y30LB14*/
         LR    @10,J                                               0142
         MH    @10,@CH00458                                        0142
         LH    @05,@CH00457                                        0142
         AL    @05,BUILDPTR(,R4)                                   0142
         ST    @10,@TF00001                                        0142
         ALR   @10,@05                                             0142
         AL    @10,@CF00467                                        0142
         MVC   @TS00001(8),OCONTROL(@05)                           0142
         MVC   OCONTROL-16(8,@10),@TS00001                         0142
*     OCARTBLK(J)=OCARTBLK(1);      /*                       @Y30LB14*/
         LR    @10,@05                                             0143
         AL    @10,@TF00001                                        0143
         AL    @10,@CF00468                                        0143
         MVC   @TS00001(240),OCARTBLK(@05)                         0143
         MVC   OCARTBLK-24(240,@10),@TS00001                       0143
*     OFILLER(J)=OFILLER(1);        /*                       @Y30LB14*/
         LR    @10,@05                                             0144
         AL    @10,@TF00001                                        0144
         AL    @10,@CF00469                                        0144
         MVC   @TS00001(8),OFILLER(@05)                            0144
         MVC   OFILLER-264(8,@10),@TS00001                         0144
*   END;                            /*                       @Y30LB14
*                                                            @Y30LB14*/
*                                                                  0145
         AH    J,@CH00042                                          0145
         CH    J,@CH00309                                          0145
         BNH   @DL00141                                            0145
*   /*****************************************************************/
*   /*                                                               */
*   /* SET END OF TRACK BLOCK                                @Y30LB14*/
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0146
*   OEOTB(32)='1'B;                 /*                       @Y30LB14*/
         L     @10,BUILDPTR(,R4)                                   0146
         AL    @10,@CF00475                                        0146
         OI    OEOTB(@10),B'00100000'                              0146
*   RETURN;                         /* RETURN TO CALLER      @Y30LB14*/
@EL00006 DS    0H                                                  0147
@EF00006 DS    0H                                                  0147
@ER00006 LM    @14,@12,12(@13)                                     0147
         BR    @14                                                 0147
*   END WRANYTRK;                   /*                       @Y30LB14
*                                                            @Y30LB14*/
*                                                                  0149
*/***********************************************************@XD00153*/
*/*                                                          @XD00153*/
*/* PROCEDURE NAME - WRITETRK                                @XD00153*/
*/*                                                          @XD00153*/
*/* FUNCTION - SETS OUTPUT CCHHR AND THE OUTPUT TABLE ID IN  @XD00153*/
*/*            THE OUTPUT BUFFER (FOR 32 BLOCKS), THEN CALLS @XD00153*/
*/*            THE 'WRITE' PROCEDURE TO WRITE THE TRACK ON   @XD00153*/
*/*            THE DASD DEVICE.                              @XD00153*/
*/*                                                          @XD00153*/
*/********************************************************** @XD00153*/
*                                                                  0149
*WRITETRK:                                                         0149
*   PROCEDURE;                      /*                       @Y30LB14*/
WRITETRK STM   @14,@12,@SA00007                                    0149
*   DO J=1 TO 32;                   /*                       @Y30LB14*/
         LA    J,1                                                 0150
@DL00150 DS    0H                                                  0151
*     OUTREC(J)=J;                  /* SET THE PREFIX RECORD NUM   0151
*                                                            @Y30LB14*/
         LR    @10,J                                               0151
         MH    @10,@CH00458                                        0151
         L     @05,BUILDPTR(,R4)                                   0151
         LH    @03,@CH00457                                        0151
         ALR   @03,@05                                             0151
         LA    @01,0(@10,@03)                                      0151
         AL    @01,@CF00480                                        0151
         STC   J,OUTREC-11(,@01)                                   0151
*     OUTHEAD(J)=UT2VHEAD;          /* SET THE HEAD NUMBER   @Y30LB14*/
         SLR   @15,@15                                             0152
         IC    @15,UT2VHEAD(,@05)                                  0152
         LA    @14,0(@10,@03)                                      0152
         AL    @14,@CF00481                                        0152
         STC   @15,OUTHEAD-10(,@14)                                0152
*     OUTCYL(J)=UT2VCYL;            /* SET THE CYL NUMBER    @Y30LB14*/
         SLR   @15,@15                                             0153
         IC    @15,UT2VCYL(,@05)                                   0153
         LA    @05,0(@10,@03)                                      0153
         AL    @05,@CF00482                                        0153
         STC   @15,OUTCYL-9(,@05)                                  0153
*     OUTFLR(J)=''B;                /* SET FILLER TO ZERO    @Y30LB14*/
         ST    @10,@TF00001                                        0154
         ALR   @10,@03                                             0154
         AL    @10,@CF00483                                        0154
         XC    OUTFLR-12(4,@10),OUTFLR-12(@10)                     0154
*     OUTABLID(J)='30'X;            /*                       @ZD00179*/
         AL    @03,@TF00001                                        0155
         AL    @03,@CF00466                                        0155
         MVI   OUTABLID-8(@03),X'30'                               0155
*   END;                            /*                       @Y30LB14
*                                                            @Y30LB14*/
         AH    J,@CH00042                                          0156
         CH    J,@CH00309                                          0156
         BNH   @DL00150                                            0156
*   CALL WRITE;                     /* WRITE OUT THE TRACK   @Y30LB14*/
         BAL   @14,WRITE                                           0157
*   RETURN;                         /* RETURN TO CALLER      @Y30LB14
*                                                            @Y30LB14*/
@EL00007 DS    0H                                                  0158
@EF00007 DS    0H                                                  0158
@ER00007 LM    @14,@12,@SA00007                                    0158
         BR    @14                                                 0158
*   END WRITETRK;                   /*                       @Y30LB14*/
*                                                                  0160
*/********************************************************** @XD00153*/
*/*                                                          @XD00153*/
*/* PROCEDURE NAME - WRITE                                   @XD00153*/
*/*                                                          @XD00153*/
*/* FUNCTION - THIS ROUTINE REQUESTS THE TRACK JUST BUILT TO @XD00153*/
*/*            WRITTEN VIA ICGDSB06.  ON RETURN, IT UPDATES  @XD00153*/
*/*            THE CCHHR ADDRESS FOR THE NEXT TRACK.         @XD00153*/
*/*                                                          @XD00153*/
*/********************************************************** @XD00153*/
*                                                                  0160
*WRITE:                                                            0160
*   PROCEDURE;                      /*                       @Y30LB14*/
WRITE    STM   @14,@12,@SA00008                                    0160
*   B06ADDR=OUTADDR;                /* SET OUTPUT ADDRESS FOR B06  0161
*                                                            @XD00153*/
         L     @10,BUILDPTR(,R4)                                   0161
         MVC   B06ADDR(3,@10),OUTADDR(@10)                         0161
*   GEN(LINK EP=ICGDSB06);          /* WRITE OUT TRACK       @Y30LB14*/
         LINK EP=ICGDSB06
*   UT2VHEAD=UT2VHEAD+1;            /* INCR TO NEXT TRACK    @Y30LB14*/
         L     @10,BUILDPTR(,R4)                                   0163
         LA    @05,1                                               0163
         SLR   @15,@15                                             0163
         IC    @15,UT2VHEAD(,@10)                                  0163
         ALR   @15,@05                                             0163
         STC   @15,UT2VHEAD(,@10)                                  0163
*   IF UT2VHEAD>18                  /*                       @Y30LB14*/
*     THEN                          /*                       @Y30LB14*/
         CLI   UT2VHEAD(@10),18                                    0164
         BNH   @RF00164                                            0164
*     DO;                           /*                       @Y30LB14*/
*       UT2VHEAD=0;                 /* SET TRACK TO ZERO     @Y30LB14*/
         MVI   UT2VHEAD(@10),X'00'                                 0166
*       UT2VCYL=UT2VCYL+1;          /* INCR TO NEXT CYL      @Y30LB14*/
         MVC   @ZT00003+3(1),UT2VCYL(@10)                          0167
         AL    @05,@ZT00003                                        0167
         STC   @05,UT2VCYL(,@10)                                   0167
*     END;                          /*                       @Y30LB14*/
*   OUTCYL(1)=UT2VCYL;              /* SET FOR NEXT AVAIL CYL      0169
*                                                            @Y30LB14*/
@RF00164 L     @10,BUILDPTR(,R4)                                   0169
         LH    @05,@CH00457                                        0169
         ALR   @05,@10                                             0169
         MVC   OUTCYL(1,@05),UT2VCYL(@10)                          0169
*   OUTHEAD(1)=UT2VHEAD;            /* SET FOR NEXT AVAIL HEAD     0170
*                                                            @Y30LB14*/
         MVC   OUTHEAD(1,@05),UT2VHEAD(@10)                        0170
*   RETURN;                         /* RETURN TO CALLER      @Y30LB14*/
@EL00008 DS    0H                                                  0171
@EF00008 DS    0H                                                  0171
@ER00008 LM    @14,@12,@SA00008                                    0171
         BR    @14                                                 0171
*   END WRITE;                      /*                       @Y30LB14*/
*                                                                  0173
*/*********************************************************  @XD00153*/
*/*                   P A T C H  A R E A                     @XD00153*/
*/*********************************************************  @XD00153*/
*                                                                  0173
*   GENERATE;                                                      0173
*                                                         /*@XD00153*/
PATCHB12 DC    32C'PATCHB12'                              /*@XD00153*/
*   END ICGDSB12                    /*                       @Y30LB14*/
*                                                                  0174
*/* THE FOLLOWING INCLUDE STATEMENTS WERE FOUND IN THIS PROGRAM.     */
*/*%INCLUDE SYSLIB  (ICGDSMAC)                                       */
*/*%INCLUDE SYSLIB  (ICGDSMA5)                                       */
*                                                                  0174
*       ;                                                          0174
         B     @EL00001                                            0174
@DATA    DS    0H
@CH00042 DC    H'1'
@CH00048 DC    H'3'
@CH00068 DC    H'4'
@CH00040 DC    H'8'
@CH00246 DC    H'11'
@CH00128 DC    H'12'
@CH00435 DC    H'18'
@CH00309 DC    H'32'
@CH00460 DC    H'264'
@CH00458 DC    H'272'
@DATD    DSECT
         DS    0F
@SA00001 DS    18F
@SA00002 DS    15F
@SA00004 DS    15F
@SA00007 DS    15F
@SA00003 DS    15F
@SA00008 DS    15F
@TF00001 DS    F
@TF00002 DS    F
@ZTEMPS  DS    0F
@ZT00003 DC    F'0'
@ZTEMPND EQU   *
@ZLEN    EQU   @ZTEMPND-@ZTEMPS
ICGDSB12 CSECT
         DS    0F
@CF00459 DC    F'5084'
@CH00459 EQU   @CF00459+2
@CF00457 DC    F'13532'
@CH00457 EQU   @CF00457+2
@CF00475 DC    F'21964'
@CF00466 DC    F'-264'
@CF00482 DC    F'-263'
@CF00481 DC    F'-262'
@CF00480 DC    F'-261'
@CF00483 DC    F'-260'
@CF00467 DC    F'-256'
@CF00473 DC    F'-252'
@CF00471 DC    F'-251'
@CF00470 DC    F'-250'
@CF00474 DC    F'-249'
@CF00468 DC    F'-248'
@CF00469 DC    F'-8'
@DATD    DSECT
         DS    0D
@TS00001 DS    CL240
STOPSCAN DS    BL1
SWITCH   DS    CL1
ADDR2NDT DS    CL3
         ORG   ADDR2NDT+0
TRK2CYL  DS    FL1
TRK2HED  DS    FL1
TRK2REC  DS    FL1
         ORG   ADDR2NDT+12
         ORG   *+1-(*-@DATD)/(*-@DATD) INSURE DSECT DATA
@ENDDATD EQU   *
ICGDSB12 CSECT
         DS    0F
@SIZDATD DC    AL1(0)
         DC    AL3(@ENDDATD-@DATD)
         DS    0D
@00      EQU   00                      EQUATES FOR REGISTERS 0-15
@01      EQU   01
@02      EQU   02
@03      EQU   03
@04      EQU   04
@05      EQU   05
@06      EQU   06
@07      EQU   07
@08      EQU   08
@09      EQU   09
@10      EQU   10
@11      EQU   11
@12      EQU   12
@13      EQU   13
@14      EQU   14
@15      EQU   15
K        EQU   @03
J        EQU   @02
I        EQU   @05
R4       EQU   @04
COMTAB   EQU   0
READER   EQU   COMTAB+256
READFLAG EQU   READER+96
PCHBF    EQU   READER+99
STARTCOL EQU   READER+180
NEXTCOL  EQU   READER+184
PRINTER  EQU   COMTAB+464
MESSAGES EQU   COMTAB+810
SPECLMSG EQU   MESSAGES+18
GENIO    EQU   COMTAB+832
DCBPTR   EQU   GENIO+4
COMPTR2  EQU   GENIO+16
BUILDPTR EQU   GENIO+20
INVOKED  EQU   COMTAB+856
SAVEDDS  EQU   INVOKED+4
BUILDRSG EQU   COMTAB+900
RSGS     EQU   BUILDRSG
RSG      EQU   RSGS
RSGABOX  EQU   RSG
RSGTODS  EQU   RSG+7
LIBRARY  EQU   COMTAB+1170
LIBS     EQU   LIBRARY
LIB      EQU   LIBS
LIBBITS  EQU   LIB
PABTABLE EQU   COMTAB+1218
PABDEV   EQU   PABTABLE
PABFLAGS EQU   PABDEV
PABREAL  EQU   PABDEV+1
PABAADDD EQU   PABDEV+2
DSPAIRS  EQU   COMTAB+1938
PHYSTYPE EQU   COMTAB+2002
PHYSFLGS EQU   PHYSTYPE
MERLICEB EQU   PHYSFLGS
CPUASSOC EQU   COMTAB+3026
CPUS     EQU   CPUASSOC+2
CPU      EQU   CPUS
CPUFLAG1 EQU   CPU+6
OPSYSTYP EQU   CPUFLAG1
CPUFLAG2 EQU   CPU+7
LOWERCON EQU   COMTAB+3156
LOWDSS   EQU   LOWERCON
LOWFLGS  EQU   LOWDSS
LIBCTL   EQU   COMTAB+3284
LIBCTLS  EQU   LIBCTL
CREATE   EQU   COMTAB+3288
@NM00017 EQU   CREATE
NEWCREAT EQU   @NM00017
UPDCREAT EQU   @NM00017
COMTAB2  EQU   0
DSTORSG  EQU   COMTAB2
DSENTRY  EQU   DSTORSG
CONFGCON EQU   COMTAB2+32
RSGUCB   EQU   CONFGCON
RSGFLAGS EQU   RSGUCB
CONFGUCB EQU   COMTAB2+464
CONFGDEV EQU   CONFGUCB
USEFLAGS EQU   CONFGDEV
ALTPATH1 EQU   CONFGDEV+2
ALTPATH2 EQU   CONFGDEV+5
ALTPATH3 EQU   CONFGDEV+8
BUILDTAB EQU   0
COMB06   EQU   BUILDTAB
B06DCBPT EQU   COMB06
B06BUFPT EQU   COMB06+4
B06ADDR  EQU   COMB06+9
COMB05   EQU   BUILDTAB+12
B05DCBPT EQU   COMB05
B05BUFPT EQU   COMB05+4
B05ADDR  EQU   COMB05+9
BUILDGEN EQU   BUILDTAB+24
UT2VCHR  EQU   BUILDGEN+8
OUTADDR  EQU   UT2VCHR+1
UT2VCYL  EQU   OUTADDR
UT2VHEAD EQU   OUTADDR+1
UT2VREC  EQU   OUTADDR+2
UT1VCHR  EQU   BUILDGEN+12
INADDR   EQU   UT1VCHR+1
UT1VCYL  EQU   INADDR
UT1VHEAD EQU   INADDR+1
UT1STUFF EQU   BUILDTAB+40
UT1DCB   EQU   UT1STUFF
UT1FLAG  EQU   UT1STUFF+96
UT2STUFF EQU   BUILDTAB+664
UT2DCB   EQU   UT2STUFF
UT2FLAG  EQU   UT2STUFF+96
UT3STUFF EQU   BUILDTAB+1288
UT3FLAG  EQU   UT3STUFF+96
UT1BUFER EQU   BUILDTAB+5084
UT2BUFER EQU   BUILDTAB+13532
INBUFFER EQU   0
INBLOCK  EQU   INBUFFER
INBLKPFX EQU   INBLOCK
INCONTRL EQU   INBLOCK+8
ICRTBLK  EQU   INBLOCK+16
IFILLER  EQU   INBLOCK+256
OUTBUFFR EQU   0
OUTBLOCK EQU   OUTBUFFR
OBLKPRFX EQU   OUTBLOCK+8
OUTABLID EQU   OBLKPRFX
OUTCYL   EQU   OBLKPRFX+1
OUTHEAD  EQU   OBLKPRFX+2
OUTREC   EQU   OBLKPRFX+3
OUTFLR   EQU   OBLKPRFX+4
OCONTROL EQU   OUTBLOCK+16
OLTB     EQU   OCONTROL
OLAB     EQU   OCONTROL
OEOTB    EQU   OCONTROL
OLTIT    EQU   OCONTROL
OCOMPLEN EQU   OCONTROL
OENTRYLN EQU   OCONTROL+1
OMAXEPB  EQU   OCONTROL+2
OUSECNT  EQU   OCONTROL+3
OVOLUME  EQU   OCONTROL+4
OCYL     EQU   OCONTROL+5
OHEAD    EQU   OCONTROL+6
ORECORD  EQU   OCONTROL+7
OCARTBLK EQU   OUTBLOCK+24
OFILLER  EQU   OUTBLOCK+264
SCANBUF  EQU   0
SCANDATA EQU   0
         AGO   .@UNREFD                START UNREFERENCED COMPONENTS
@NM00024 EQU   OUTBLOCK
IRECORD  EQU   INCONTRL+7
IHEAD    EQU   INCONTRL+6
ICYL     EQU   INCONTRL+5
IVOLUME  EQU   INCONTRL+4
IUSECNT  EQU   INCONTRL+3
IMAXEPB  EQU   INCONTRL+2
IENTYLN  EQU   INCONTRL+1
ICOMPLN  EQU   INCONTRL
ILTIT    EQU   INCONTRL
IEOTB    EQU   INCONTRL
ILAB     EQU   INCONTRL
ILTB     EQU   INCONTRL
INFLR    EQU   INBLKPFX+4
INREC    EQU   INBLKPFX+3
INHEAD   EQU   INBLKPFX+2
INCYL    EQU   INBLKPFX+1
INTABLID EQU   INBLKPFX
TEMPEND  EQU   BUILDTAB+22396
LTRTRANI EQU   BUILDTAB+22316
LTRTRANO EQU   BUILDTAB+22236
NVERIFY  EQU   BUILDTAB+3500
CVERIFY  EQU   BUILDTAB+1916
@NM00023 EQU   UT3STUFF+624
UT3DDN   EQU   UT3STUFF+616
UT3CCWS  EQU   UT3STUFF+320
UT3IOB   EQU   UT3STUFF+280
UT3ECB   EQU   UT3STUFF+276
UT3JFCB  EQU   UT3STUFF+100
@NM00022 EQU   UT3FLAG
UT3VWERR EQU   UT3FLAG
UT3VOERR EQU   UT3FLAG
UT3VUPDT EQU   UT3FLAG
UT3DCB   EQU   UT3STUFF
UT2DDN   EQU   UT2STUFF+616
UT2CCWS  EQU   UT2STUFF+320
UT2IOB   EQU   UT2STUFF+280
UT2ECB   EQU   UT2STUFF+276
UT2JFCB  EQU   UT2STUFF+100
@NM00021 EQU   UT2FLAG
UT2VCERR EQU   UT2FLAG
UT2VWERR EQU   UT2FLAG
UT2VOERR EQU   UT2FLAG
UT2VUPDT EQU   UT2FLAG
UT1DDN   EQU   UT1STUFF+616
UT1CCWS  EQU   UT1STUFF+320
UT1IOB   EQU   UT1STUFF+280
UT1ECB   EQU   UT1STUFF+276
UT1JFCB  EQU   UT1STUFF+100
@NM00020 EQU   UT1FLAG
UT1VWERR EQU   UT1FLAG
UT1VOERR EQU   UT1FLAG
UT1VUPDT EQU   UT1FLAG
UT1VREC  EQU   INADDR+2
UT1TABID EQU   UT1VCHR
UT2TABID EQU   UT2VCHR
ADDRBUF2 EQU   BUILDGEN+4
ADDRBUF1 EQU   BUILDGEN
B05REC   EQU   B05ADDR+2
B05HEAD  EQU   B05ADDR+1
B05CYL   EQU   B05ADDR
B05TBLID EQU   COMB05+8
B06REC   EQU   B06ADDR+2
B06HEAD  EQU   B06ADDR+1
B06CYL   EQU   B06ADDR
B06TBLID EQU   COMB06+8
ALTCH3   EQU   ALTPATH3+2
ALTCI3   EQU   ALTPATH3+1
ALTDS3   EQU   ALTPATH3
ALTCH2   EQU   ALTPATH2+2
ALTCI2   EQU   ALTPATH2+1
ALTDS2   EQU   ALTPATH2
ALTCH1   EQU   ALTPATH1+2
ALTCI1   EQU   ALTPATH1+1
ALTDS1   EQU   ALTPATH1
INDEXRSG EQU   CONFGDEV+1
ICEBERG  EQU   USEFLAGS
ITISALTP EQU   USEFLAGS
USECONVR EQU   USEFLAGS
SUPPUNCH EQU   USEFLAGS
USEREAL  EQU   USEFLAGS
USEVS    EQU   USEFLAGS
USEV     EQU   USEFLAGS
USESPEC  EQU   USEFLAGS
RSGCUA   EQU   RSGUCB+8
RSGCHAN  EQU   RSGUCB+7
CPUREFNO EQU   RSGUCB+6
RSGCPUID EQU   RSGUCB+1
@NM00019 EQU   RSGFLAGS
CISPEC   EQU   RSGFLAGS
TORSG2   EQU   DSENTRY+1
TORSG1   EQU   DSENTRY
COM2BASE EQU   COMTAB+3304
LRUCLOCK EQU   CREATE+11
VOLSER   EQU   CREATE+5
VPAGES   EQU   CREATE+1
@NM00018 EQU   @NM00017
PRNTONLY EQU   @NM00017
CMDCREAT EQU   @NM00017
RW67RGHT EQU   LIBCTLS
RW67LEFT EQU   LIBCTLS
RW45RGHT EQU   LIBCTLS
RW45LEFT EQU   LIBCTLS
RW23RGHT EQU   LIBCTLS
RW23LEFT EQU   LIBCTLS
RW01RGHT EQU   LIBCTLS
RW01LEFT EQU   LIBCTLS
LOWLIB   EQU   LOWDSS+1
@NM00016 EQU   LOWFLGS
LOWRGHT  EQU   LOWFLGS
LOWLEFT  EQU   LOWFLGS
LOWRW67  EQU   LOWFLGS
LOWRW45  EQU   LOWFLGS
LOWRW23  EQU   LOWFLGS
LOWRW01  EQU   LOWFLGS
LOWSPEC  EQU   LOWFLGS
ALTMSCIN EQU   CPUFLAG2
@NM00015 EQU   CPUFLAG2
ALTMSGBF EQU   CPUFLAG2
@NM00014 EQU   CPUFLAG2
CPUSPEC  EQU   CPUFLAG2
CPUMSCIN EQU   CPUFLAG1
OPJES3   EQU   OPSYSTYP
OPVS2    EQU   OPSYSTYP
OPVS1    EQU   OPSYSTYP
CPUALTFL EQU   CPUFLAG1
CPUTIGHT EQU   CPUFLAG1
@NM00013 EQU   CPUFLAG1
TOMPCPU  EQU   CPU+5
CPUID    EQU   CPU
CPUNUM   EQU   CPUASSOC
SPNRSGNO EQU   PHYSTYPE+1
LGDEVICE EQU   PHYSFLGS
LOGABOX1 EQU   PHYSFLGS
PHYSSSID EQU   PHYSFLGS
PHYSREAL EQU   PHYSFLGS
PHYSICEB EQU   MERLICEB
PHYSMERL EQU   MERLICEB
PHYSDS2  EQU   DSPAIRS
PABDDD   EQU   PABAADDD
PABAA    EQU   PABAADDD
PABZEROS EQU   PABAADDD
PAB2D    EQU   PABREAL
PAB2C    EQU   PABREAL
PAB2B    EQU   PABREAL
@NM00012 EQU   PABREAL
PAB1D    EQU   PABREAL
PAB1C    EQU   PABREAL
PAB1B    EQU   PABREAL
PABIMPLR EQU   PABREAL
PABBERG2 EQU   PABFLAGS
@NM00011 EQU   PABFLAGS
PABDSMTL EQU   PABFLAGS
PABIBERG EQU   PABFLAGS
@NM00010 EQU   PABFLAGS
PABVOVIR EQU   PABFLAGS
PABEXIST EQU   PABFLAGS
MAPEXIT  EQU   LIB+4
LIBMAP   EQU   LIB+3
LIBDSMID EQU   LIB+2
LIBSIZE  EQU   LIB+1
@NM00009 EQU   LIBBITS
LIBSPEC  EQU   LIBBITS
TODS2    EQU   RSGTODS+1
TODS1    EQU   RSGTODS
RSGSLICE EQU   RSG+3
RSGUDEL  EQU   RSG+2
RSGLDEL  EQU   RSG+1
@NM00008 EQU   RSG
RSGABOX1 EQU   RSGABOX
RSGABOX0 EQU   RSGABOX
RSGSPEC  EQU   RSG
SVSYSUT3 EQU   SAVEDDS+32
SVSYSUT2 EQU   SAVEDDS+24
SVSYSUT1 EQU   SAVEDDS+16
SVSYSPCH EQU   SAVEDDS+8
SVSYSIN  EQU   SAVEDDS
PARMPTR  EQU   INVOKED
SAVE14   EQU   GENIO+12
EXLST    EQU   GENIO+8
@NM00007 EQU   DCBPTR+1
DCBFLAG  EQU   DCBPTR
OPENLIST EQU   GENIO
@NM00006 EQU   MESSAGES+19
PRNTBUF2 EQU   SPECLMSG
NEEDEOJ  EQU   SPECLMSG
ENDPHASE EQU   SPECLMSG
@NM00005 EQU   SPECLMSG
PRNTCARD EQU   SPECLMSG
@NM00004 EQU   SPECLMSG
NEED102  EQU   SPECLMSG
NEED101  EQU   SPECLMSG
PRINTRC  EQU   MESSAGES+16
TERM     EQU   MESSAGES+12
WARN     EQU   MESSAGES+8
TERMINAT EQU   MESSAGES+6
WARNING  EQU   MESSAGES+4
MSGNO    EQU   MESSAGES+2
RETCODE  EQU   MESSAGES
OUTBUF2  EQU   PRINTER+225
OUTBUF   EQU   PRINTER+104
LINECT   EQU   PRINTER+102
LINECTR  EQU   PRINTER+100
PAGENO   EQU   PRINTER+96
DCBPRINT EQU   PRINTER
@NM00003 EQU   READER+206
SCANLEN  EQU   READER+204
SVEODAD  EQU   READER+200
SVSYNAD2 EQU   READER+196
SAVENCOL EQU   READER+192
SAVESCOL EQU   READER+188
INBUF    EQU   READER+100
SSELECT  EQU   PCHBF
@NM00002 EQU   READER+97
@NM00001 EQU   READFLAG
LASTPARM EQU   READFLAG
ENDSCAN  EQU   READFLAG
PARMBIT  EQU   READFLAG
KEYBIT   EQU   READFLAG
READTERM EQU   READFLAG
READDCB  EQU   READER
PATCH    EQU   COMTAB
.@UNREFD ANOP                          END UNREFERENCED COMPONENTS
@RF00031 EQU   @EL00001
@ENDDATA EQU   *
         END   ICGDSB12,(C'PLS1611',0603,76337)
