 /***********************************************************@Y30LB12*/
 /*                                                          @Y30LB12*/
 /* THE FOLLOWING DECLARE STATEMENT DESCRIBES BUILDTAB,      @Y30LB12*/
 /* THE BUILD COMMUNICATIONS AREA.  THIS AREA IS OBTAINED    @Y30LB12*/
 /* AND FREED BY ICGDSBLD, THE BUILD EXECUTIVE PHASE.        @Y30LB12*/
 /*                                                          @Y30LB12*/
 /***********************************************************@Y30LB12*/
 DCL 1 BUILDTAB BOUNDARY(DWORD) BASED(BUILDPTR),           /*@Y30LB12*/
       /*****************************************************@Y30LB12*/
       /*                                                    @Y30LB12*/
       /* THE FOLLOWING AREA IS USED TO COMMUNICATE WITH     @Y30LB12*/
       /* THE DASD READ AND WRITE MODULES.  UPON CALL TO     @Y30LB12*/
       /* ICGDSB06, THIS AREA MUST CONTAIN                   @Y30LB12*/
       /*    1. THE ADDRESS OF THE DCB.                      @Y30LB12*/
       /*    2. THE ADDRESS OF THE BUFFER TO BE WRITTEN      @Y30LB12*/
       /*    3. THE VIRTUAL CYLINDER AND HEAD TO WHICH       @Y30LB12*/
       /*       TO WRITE.                                    @Y30LB12*/
       /*                                                    @Y30LB12*/
       /*****************************************************@Y30LB12*/
       2 COMB06,                                           /*@Y30LB12*/
         3 B06DCBPT FIXED(31),                             /*@Y30LB12*/
         3 B06BUFPT FIXED(31),                             /*@Y30LB12*/
         3 B06TBLID FIXED(8),                              /*@Y30LB12*/
         3 B06ADDR CHAR(3),                                /*@Y30LB12*/
           4 B06CYL FIXED(8),                              /*@Y30LB12*/
           4 B06HEAD FIXED(8),                             /*@Y30LB12*/
           4 B06REC FIXED(8),                              /*@Y30LB12*/
       /*****************************************************@Y30LB12*/
       /*                                                    @Y30LB12*/
       /* THE FOLLOWING AREA IS USED TO COMMUNICATE WITH     @Y30LB12*/
       /* THE DASD READ AND WRITE MODULES.  UPON CALL TO     @Y30LB12*/
       /* ICGDSB05, THIS AREA MUST CONTAIN                   @Y30LB12*/
       /*    1. THE ADDRESS OF THE DCB.                      @Y30LB12*/
       /*    2. THE ADDRESS OF THE BUFFER TO BE READ INTO    @Y30LB12*/
       /*    3. THE VIRTUAL CYLINDER AND HEAD FROM WHICH     @Y30LB12*/
       /*       TO READ.                                     @Y30LB12*/
       /*                                                    @Y30LB12*/
       /*****************************************************@Y30LB12*/
       2 COMB05,                                           /*@Y30LB12*/
         3 B05DCBPT FIXED(31),                             /*@Y30LB12*/
         3 B05BUFPT FIXED(31),                             /*@Y30LB12*/
         3 B05TBLID FIXED(8),                              /*@Y30LB12*/
         3 B05ADDR CHAR(3),                                /*@Y30LB12*/
           4 B05CYL FIXED(8),                              /*@Y30LB12*/
           4 B05HEAD FIXED(8),                             /*@Y30LB12*/
           4 B05REC FIXED(8),                              /*@Y30LB12*/
       /*****************************************************@Y30LB12*/
       /*                                                    @Y30LB12*/
       /* THE FOLLOWING IS A GENERAL WORK AREA CONTAINING    @Y30LB12*/
       /* POINTERS TO THE TWO BUFFERS OBTAINED IN THE        @Y30LB12*/
       /* 'BUILDTAB GETMAIN', THE ADDRESS OF THE NEXT        @Y30LB12*/
       /* AVAILABLE VIRTUAL CYLINDER AND HEAD ON SYSUT2,     @Y30LB12*/
       /*                                                    @Y30LB12*/
       /*****************************************************@Y30LB12*/
       2 BUILDGEN,                                         /*@Y30LB12*/
         3 ADDRBUF1 FIXED(31),                             /*@Y30LB12*/
         3 ADDRBUF2 FIXED(31),                             /*@Y30LB12*/
         3 UT2VCHR FIXED(31),                              /*@Y30LB12*/
           4 UT2TABID FIXED(8),                            /*@Y30LB12*/
           4 OUTADDR CHAR(3),                              /*@Y30LB12*/
             5 UT2VCYL FIXED(8),                           /*@Y30LB12*/
             5 UT2VHEAD FIXED(8),                          /*@Y30LB12*/
             5 UT2VREC FIXED(8),                           /*@Y30LB12*/
         3 UT1VCHR FIXED(31),                              /*@Y30LB12*/
           4 UT1TABID FIXED(8),                            /*@Y30LB12*/
           4 INADDR CHAR(3),                               /*@Y30LB12*/
             5 UT1VCYL FIXED(8),                           /*@Y30LB12*/
             5 UT1VHEAD FIXED(8),                          /*@Y30LB12*/
             5 UT1VREC FIXED(8),                           /*@Y30LB12*/
       2 UT1STUFF BOUNDARY(DWORD),                         /*@Y30LB12*/
         3 UT1DCB CHAR(96),                                /*@Y30LB12*/
         3 UT1FLAG BIT(32),                                /*@Y30LB12*/
           4 UT1VUPDT BIT(1),                              /*@Y30LB12*/
           4 UT1VOERR BIT(1),                              /*@Y30LB12*/
           4 UT1VWERR BIT(1),                              /*@Y30LB12*/
           4 * BIT(29),                                    /*@Y30LB12*/
         3 UT1JFCB CHAR(176),                              /*@Y30LB12*/
         3 UT1ECB CHAR(4),                                 /*@Y30LB12*/
         3 UT1IOB CHAR(40),                                /*@Y30LB12*/
         3 UT1CCWS (37) CHAR(8),                           /*@Y30LB12*/
         3 UT1DDN CHAR(8),                                 /*@Y30LB12*/
       /*****************************************************@Y30LB12*/
       /*                                                    @Y30LB12*/
       /* THE FOLLOWING AREA WILL CONTAIN THE DCB, IOB,      @Y30LB12*/
       /* AND CCW STRINGS FOR SYSUT2, THE 'NEW' TABLES       @Y30LB12*/
       /* PACK,                                              @Y30LB12*/
       /*                                                    @Y30LB12*/
       /*****************************************************@Y30LB12*/
       2 UT2STUFF BOUNDARY(DWORD),                         /*@Y30LB12*/
         3 UT2DCB CHAR(96),                                /*@Y30LB12*/
         3 UT2FLAG BIT(32),                                /*@Y30LB12*/
           4 UT2VUPDT BIT(1),                              /*@Y30LB12*/
           4 UT2VOERR BIT(1),                              /*@Y30LB12*/
           4 UT2VWERR BIT(1),                              /*@Y30LB12*/
           4 UT2VCERR BIT(1),                              /*@Y30LB12*/
           4 * BIT(28),                                    /*@Y30LB12*/
         3 UT2JFCB CHAR(176),                              /*@Y30LB12*/
         3 UT2ECB CHAR(4),                                 /*@Y30LB12*/
         3 UT2IOB CHAR(40),                                /*@Y30LB12*/
         3 UT2CCWS (37) CHAR(8),                           /*@Y30LB12*/
         3 UT2DDN CHAR(8),                                 /*@Y30LB12*/
       2 UT3STUFF BOUNDARY(DWORD),                         /*@Y30LB12*/
         3 UT3DCB CHAR(96),                                /*@Y30LB12*/
         3 UT3FLAG BIT(32),                                /*@Y30LB12*/
           4 UT3VUPDT BIT(1),                              /*@Y30LB12*/
           4 UT3VOERR BIT(1),                              /*@Y30LB12*/
           4 UT3VWERR BIT(1),                              /*@Y30LB12*/
           4 * BIT(29),                                    /*@Y30LB12*/
         3 UT3JFCB CHAR(176),                              /*@Y30LB12*/
         3 UT3ECB CHAR(4),                                 /*@Y30LB12*/
         3 UT3IOB CHAR(40),                                /*@Y30LB12*/
         3 UT3CCWS (37) CHAR(8),                           /*@Y30LB12*/
         3 UT3DDN CHAR(8),                                 /*@Y30LB12*/
         3 * CHAR(4),                                      /*@Y30LB12*/
       2 CVERIFY CHAR(1584),                               /*@Y30LB12*/
       2 NVERIFY CHAR(1584),                               /*@Y30LB12*/
       2 UT1BUFER CHAR(8448),                              /*@Y30LB12*/
       2 UT2BUFER CHAR(8704),                              /*@Y30LB12*/
       2 LTRTRANO (40) FIXED(15),                          /*@Y30LB12*/
       2 LTRTRANI (40) FIXED(15),                          /*@Y30LB12*/
       2 TEMPEND CHAR(1);                                  /*@Y30LB12*/
