***********************************************************************
*                                                                     *
* MODULE NAME - ICKTSCC0                                              *
*                                                                     *
* DESCRIPTIVE NAME - STATIC TEXT MODULE FOR THE COMMAND CONTROLLERS   *
*                                                                     *
* FUNCTION - CONTAINS NO EXECUTABLE CODE, ONLY STATIC TEXT ENTRIES    *
*            FOR THE COMMAND CONTROLLERS                              *
*            THIS MODULE IS LOADED BY ICKTP05 WHEN A STATIC REPORT    *
*            REQUEST IS MADE.                                         *
*                                                                     *
* STATUS -  RELEASE-1 VERSION-0                                       *
*                                                                     *
* NOTES - NONE                                                        *
*                                                                     *
*   DEPENDENCIES - NONE                                               *
*   RESTRICTIONS - NONE                                               *
*   REGISTER CONVENTIONS - NONE                                       *
*   PATCH AREA - NONE                                                 *
*                                                                     *
* MODULE TYPE - TABLES                                                *
*                                                                     *
*   PROCESSOR - ASSEMBLER                                             *
*   MODULE SIZE - 4666 BYTES                                          *
*   ATTRIBUTES - READ ONLY                                            *
*                                                                     *
* ENTRY POINT - NA                                                    *
*                                                                     *
* EXIT NORMAL - NA                                                    *
*                                                                     *
* EXIT ERROR  - NA                                                    *
*                                                                     *
* EXTERNAL REFERENCES - NA                                            *
*                                                                     *
* TABLES - NA                                                         *
*                                                                     *
* MACROS - NA                                                         *
*                                                                     *
* CHANGE ACTIVITY - NONE                                      @G840B00*
*                                                                     *
*                                                                     *
***********************************************************************
*                                                                     *
ICKTSCC0 CSECT
***********************************************************************
*                                                                     *
* THIS SECTION CONTAINS THE INDICES TO REACH AN ENTRY                 *
*                                                                     *
***********************************************************************
*                                                                     *
***********************************************************************
INDEX    DC    Y((INDEXEND-INDEX1)/2) COUNT OF ENTRIES
INDEX1   DC    Y(TXT1-INDEX)        ALTERNATE TRACK FOUND UNRECOVERABL
INDEX2   DC    Y(TXT2-INDEX)        PRIMARY TRACK FOUND UNRECOVERABLE
INDEX3   DC    Y(TXT3-INDEX)        ILLEGAL VTOC ORIGIN SPECIFICATION
INDEX4   DC    Y(TXT4-INDEX)        ILLEGAL VTOC EXTENT SPECIFICATION
INDEX5   DC    Y(TXT5-INDEX)        VTOC CREATION FAILED
INDEX6   DC    Y(TXT6-INDEX)        VTOC DOES NOT EXIST
INDEX7   DC    Y(TXT7-INDEX)        VOLUME LABEL CREATION FAILED
INDEX8   DC    Y(TXT8-INDEX)        TRACK DESCRIPTOR INCORRECT
INDEX9   DC    Y(TXT9-INDEX)        UNABLE TO WRITE IPL RECORDS
INDEX10  DC    Y(TXT10-INDEX)       IPL PROGRAM SUPPLIED FOR MSS
INDEX11  DC    Y(TXT11-INDEX)       UNABLE TO CLOSE VOLUME
INDEX12  DC    Y(TXT12-INDEX)       CRITICAL TRACK DESCRIPTOR INC.
INDEX13  DC    Y(TXT13-INDEX)       VOLID NOT SPECIFIED AND NO VOLID
INDEX14  DC    Y(TXT14-INDEX)       UNRECOVERABLE TRACK THRESHOLD MET
INDEX15  DC    Y(TXT15-INDEX)       SURFACE CHECK FUNCTION FAILED
INDEX16  DC    Y(TXT16-INDEX)       UNABLE TO READ VOLUME LABEL
INDEX17  DC    Y(TXT17-INDEX)       AN ALTERNATE TRACK WAS ASSIGNED
INDEX18  DC    Y(TXT18-INDEX)       NO ALTERNATE TRACK LEFT ON TRACK
INDEX19  DC    Y(TXT19-INDEX)       ALTERNATE TRACK WAS RE-ASSIGNED
INDEX20  DC    Y(TXT20-INDEX)       NEXT AVAIL ALT PTR INVALID
INDEX21  DC    Y(TXT21-INDEX)       ALTERNATE TRACK WAS RECLAIMED
INDEX22  DC    Y(TXT22-INDEX)       PRIMARY TRACK WAS RECLAIMED
INDEX23  DC    Y(TXT23-INDEX)       UNABLE TO CHANGE VOLUME LABEL
INDEX24  DC    Y(TXT24-INDEX)       INVALID CUU OR DDNAME SPECIFIED
INDEX25  DC    Y(TXT25-INDEX)       UNABLE TO OPEN VOLUME.
INDEX26  DC    Y(TXT26-INDEX)       VOLUME NOT MOUNTED PRIVATE
INDEX27  DC    Y(TXT27-INDEX)       CMD INVALID FOR UNINIT. VOLUME
INDEX28  DC    Y(TXT28-INDEX)       UNABLE TO WRITE VOLUME LABEL
INDEX29  DC    Y(TXT29-INDEX)       NOT ALLOWED TO CHNG VOL LBL
INDEX30  DC    Y(TXT30-INDEX)       NOT ALLOWED TO WRITE IPL
INDEX31  DC    Y(TXT31-INDEX)       ALTERNATE TRACK RECLAMATION FAILED
INDEX32  DC    Y(TXT32-INDEX)       PRIMARY TRACK RECLAMATION FAILED
INDEX33  DC    Y(TXT33-INDEX)       DISSOCIATION OF PRIM/ALT FAILED
INDEX34  DC    Y(TXT34-INDEX)       COMBO OF ASSIGN/NOCHECK/ALLTRACKS
INDEX35  DC    Y(TXT35-INDEX)       UNABLE TO READ FORMAT-4 DSCB
INDEX36  DC    H'-1'
INDEX37  DC    Y(TXT37-INDEX)       ILLEGAL TRACK SPECIFIED FOR INSPECT
INDEX38  DC    Y(TXT38-INDEX)       NO LEGAL TRACKS SPECIFIED FOR INSP
INDEX39  DC    Y(TXT39-INDEX)       PRIMARY DEFECTIVE -- DATA SAVED
INDEX40  DC    Y(TXT40-INDEX)       PRIMARY DEFECTIVE -- DATA LOST
INDEX41  DC    Y(TXT41-INDEX)       ALTERNATE DEFECTIVE -- DATA SAVED
INDEX42  DC    Y(TXT42-INDEX)       ALTERNATE DEFECTIVE -- DATA LOST
INDEX43  DC    Y(TXT43-INDEX)       NO STORAGE FOR PRESERVE
INDEX44  DC    Y(TXT44-INDEX)       UNABLE TO PRESERVE -- BAD READ
INDEX45  DC    Y(TXT45-INDEX)       UNABLE TO PRESERVE -- DEFCTV TRK
INDEX46  DC    Y(TXT46-INDEX)       UNABLE TO WRITE FORMAT-4 DSCB
INDEX47  DC    Y(TXT47-INDEX)       UNABLE TO PRESERVE -- BAD WRITE
INDEX48  DC    Y(TXT48-INDEX)       PACK BECOMES NOT IPLABLE
INDEX49  DC    Y(TXT49-INDEX)       CUU SPECIFIED FOR VOL MOUNTED O-L
INDEX50  DC    Y(TXT50-INDEX)       VTOC SPEC'D FOR MSS STAGING PACK
INDEX51  DC    Y(TXT51-INDEX)       LABELS PARAM SPEC'D FOR MSS PACK
INDEX52  DC    Y(TXT52-INDEX)       MINIMAL INIT. NOT PERMITTED FOR MSS
         SPACE
INDEXEND EQU   *      ADD ALL NEW ENTRIES ABOVE HERE
         EJECT
***********************************************************************
*                                                                     *
* THIS SECTION CONTAINS THE TEXT ENTRIES                              *
*                                                                     *
***********************************************************************
         SPACE
***********************************************************************
*                                                                     *
* ALTERNATE TRACK FOUND UNRECOVERABLE                                 *
*                                                                     *
***********************************************************************
*                                                                     *
TXT1     DC    Y(TXT1B-TXT1A)       ENTRY LENGTH
         DC    X'9000'              MESSAGE FLAG
*  SPACING CONTROL STRUCTURE
*
TXT1A    DC    X'4000'              SPACE CONTROL
         DC    H'2'                 SPACING FACTOR
         DC    C'R '                SPACING TYPE
*  STATIC TEXT SUBSTRUCTURE
         DC    X'0400'              STATIC TEXT FLAG
         DC    Y(STE11B-STE11A)     STATIC TEXT LENGTH
         DC    Y(STE11A-TXT1A)      STATIC TEXT OFFSET
         DC    H'1'                 PRINT COLUMN
         DC    Y(STE11B-STE11A)     PRINT FIELD LENGTH
         DC    H'0'                 CONVERSION FLAG (CHAR)
*  INSERT DATA STRUCTURE
         DC    X'2000'              INSERT DATA FLAG
         DC    H'1'                 REFERENCE NUMBER
         DC    H'0'                 NOT USED
         DC    H'27'                PRINT COLUMN
         DC    H'4'                 PRINT FIELD LENGTH
         DC    X'8000'              CONVERSION FLAG (B TO X)
*  INSERT DATA STRUCTURE
         DC    X'2000'              INSERT DATA FLAG
         DC    H'2'                 REFERENCE NUMBER
         DC    H'0'                 NOT USED
         DC    H'32'                PRINT COLUMN
         DC    H'4'                 PRINT FIELD LENGTH
         DC    X'8000'              CONVERSION FLAG (B TO X)
*  STATIC TEXT SUB-STRUCTURE
         DC    X'8400'              STATIC TEXT END OF LIST
         DC    Y(STE12B-STE12A)     STATIC TEXT LENGTH
         DC    Y(STE12A-TXT1A)      STATIC TEXT OFFSET
         DC    H'37'                PRINT COLUMN
         DC    Y(STE12B-STE12A)     PRINT FIELD LENGTH
         DC    H'0'                 CONVERSION FLAG (CHAR)
*
* STATIC TEXT ENTRIES
*
STE11A   DC    C'ICK21000I ALTERNATE TRACK '
STE11B   EQU   *
STE12A   DC    C'FOUND UNRECOVERABLE.'
STE12B   EQU   *
TXT1B    EQU   *
         EJECT
***********************************************************************
*                                                                     *
* PRIMARY TRACK FOUND UNRECOVERABLE                                   *
*                                                                     *
***********************************************************************
*
TXT2     DC    Y(TXT2B-TXT2A)       ENTRY LENGTH
         DC    X'9000'              MESSAGE FLAG
*  SPACING CONTROL SUB-STRUCTURE
TXT2A    DC    X'4000'              SPACING CONTROL FLAG
         DC    H'2'                 SPACING FACTOR
         DC    C'R '                SPACING TYPE
*  STATIC TEXT SUB-STRUCTURE
         DC    X'0400'              STATIC TEXT
         DC    Y(STE21B-STE21A)     STATIC TEXT LENGTH
         DC    Y(STE21A-TXT2A)      STATIC TEXT OFFSET
         DC    H'01'                PRINT COLUMN
         DC    Y(STE21B-STE21A)     PRINT FIELD LENGTH
         DC    H'0'                 CONVERSION FLAG (CHAR)
*  INSERT DATA STRUCTURE
         DC    X'2000'              INSERT DATA FLAG
         DC    H'1'                 REFERENCE NUMBER
         DC    H'0'                 NOT USED
         DC    H'25'                PRINT COLUMN
         DC    H'4'                 PRINT FIELD LENGTH
         DC    X'8000'              CONVERSION FLAG (B TO X)
*  INSERT DATA STRUCTURE
         DC    X'2000'              INSERT DATA FLAG
         DC    H'2'                 REFERENCE NUMBER
         DC    H'0'                 NOT USED
         DC    H'30'                PRINT COLUMN
         DC    H'4'                 PRINT FIELD LENGTH
         DC    X'8000'              CONVERSION FLAG (B TO X)
*  STATIC TEXT SUB-STRUCTURE
         DC    X'8400'              STATIC TEXT
         DC    Y(STE22B-STE22A)     STATIC TEXT LENGTH
         DC    Y(STE22A-TXT2A)      STATIC TEXT OFFSET
         DC    H'35'                PRINT COLUMN
         DC    Y(STE22B-STE22A)     PRINT FIELD LENGTH
         DC    H'0'                 CONVERSION FLAG (CHAR)
*
* STATIC TEXT ENTRIES
*
STE21A   DC    C'ICK21001I PRIMARY TRACK '
STE21B   EQU   *
STE22A   DC    C'FOUND UNRECOVERABLE.'
STE22B   EQU   *
TXT2B    EQU   *
         EJECT
***********************************************************************
*                                                                     *
* ILLEGAL VTOC ORIGIN SPECIFICATION                                   *
*                                                                     *
***********************************************************************
*
TXT3     DC    Y(TXT3B-TXT3A)       ENTRY LENGTH
         DC    X'9000'              MESSAGE FLAG
*  SPACING CONTROL SUB-STRUCTURE
TXT3A    DC    X'4000'              SPACING CONTROL FLAG
         DC    H'2'                 SPACING FACTOR
         DC    C'R '                SPACING TYPE
*  STATIC TEXT SUB-STRUCTURE
         DC    X'0400'              STATIC TEXT
         DC    Y(STE31B-STE31A)     STATIC TEXT LENGTH
         DC    Y(STE31A-TXT3A)      STATIC TEXT OFFSET
         DC    H'01'                PRINT COLUMN
         DC    Y(STE31B-STE31A)     PRINT FIELD LENGTH
         DC    H'0'                 CONVERSION FLAG (CHAR)
*  INSERT DATA STRUCTURE
         DC    X'A000'              INSERT DATA FLAG END-OF-LIST
         DC    H'1'                 REFERENCE NUMBER
         DC    H'0'                 NOT USED
         DC    H'55'                PRINT COLUMN
         DC    H'9'                 PRINT FIELD LENGTH
         DC    H'0'                 CONVERSION FLAG (CHAR)
*
* STATIC TEXT ENTRIES
*
STE31A   DC    C'ICK21002I INVALID VTOC ORIGIN SPECIFICATION FOR '
         DC    C'TRACK '
STE31B   EQU   *
TXT3B    EQU   *
         EJECT
***********************************************************************
*                                                                     *
* ILLEGAL VTOC EXTENT SPECIFICATION                                   *
*                                                                     *
***********************************************************************
*
TXT4     DC    Y(TXT4B-TXT4A)       ENTRY LENGTH
         DC    X'9000'              MESSAGE FLAG
*  SPACING CONTROL SUB-STRUCTURE
TXT4A    DC    X'4000'              SPACING CONTROL FLAG
         DC    H'2'                 SPACING FACTOR
         DC    C'R '                SPACING TYPE
*  STATIC TEXT SUB-STRUCTURE
         DC    X'0400'              STATIC TEXT
         DC    Y(STE41B-STE41A)     STATIC TEXT LENGTH
         DC    Y(STE41A-TXT4A)      STATIC TEXT OFFSET
         DC    H'01'                PRINT COLUMN
         DC    Y(STE41B-STE41A)     PRINT FIELD LENGTH
         DC    H'0'                 CONVERSION FLAG (CHAR)
*  INSERT DATA STRUCTURE
         DC    X'A000'              INSERT DATA FLAG
         DC    H'1'                 REFERENCE NUMBER
         DC    H'0'                 NOT USED
         DC    H'46'                PRINT COLUMN
         DC    H'5'                 PRINT FIELD LENGTH
         DC    X'1000'              CONVERSION FLAG (B TO DEC)
*
* STATIC TEXT ENTRIES
*
STE41A   DC    C'ICK21003I INVALID VTOC EXTENT '
         DC    C'SPECIFICATION: '
STE41B   EQU   *
TXT4B    EQU   *
         EJECT
***********************************************************************
*                                                                     *
* VTOC CREATION FAILED                                                *
*                                                                     *
***********************************************************************
*
TXT5     DC    Y(TXT5B-TXT5A)       ENTRY LENGTH
         DC    X'9000'              MESSAGE FLAG
*  SPACING CONTROL SUB-STRUCTURE
TXT5A    DC    X'4000'              SPACING CONTROL FLAG
         DC    H'2'                 SPACING FACTOR
         DC    C'R '                SPACING TYPE
*  STATIC TEXT SUB-STRUCTURE
         DC    X'8400'              STATIC TEXT END-OF-LIST
         DC    Y(STE51B-STE51A)     STATIC TEXT LENGTH
         DC    Y(STE51A-TXT5A)      STATIC TEXT OFFSET
         DC    H'01'                PRINT COLUMN
         DC    Y(STE51B-STE51A)     PRINT FIELD LENGTH
         DC    H'0'                 CONVERSION FLAG (CHAR)
*
* STATIC TEXT ENTRIES
*
STE51A   DC    C'ICK31004I VTOC CREATION FAILED.'
STE51B   EQU   *
TXT5B    EQU   *
         EJECT
***********************************************************************
*                                                                     *
* VTOC DOES NOT EXIST                                                 *
*                                                                     *
***********************************************************************
*
TXT6     DC    Y(TXT6B-TXT6A)       ENTRY LENGTH
         DC    X'9000'              MESSAGE FLAG
*  SPACING CONTROL SUB-STRUCTURE
TXT6A    DC    X'4000'              SPACING CONTROL FLAG
         DC    H'2'                 SPACING FACTOR
         DC    C'R '                SPACING TYPE
*  STATIC TEXT SUB-STRUCTURE
         DC    X'8400'              STATIC TEXT END-OF-LIST
         DC    Y(STE61B-STE61A)     STATIC TEXT LENGTH
         DC    Y(STE61A-TXT6A)      STATIC TEXT OFFSET
         DC    H'01'                PRINT COLUMN
         DC    Y(STE61B-STE61A)     PRINT FIELD LENGTH
         DC    H'0'                 CONVERSION FLAG (CHAR)
*
* STATIC TEXT ENTRIES
*
STE61A   DC    C'ICK11005I VTOC DOES NOT EXIST.'
STE61B   EQU   *
TXT6B    EQU   *
         EJECT
***********************************************************************
*                                                                     *
* VOLUME LABEL CREATION FAILED                                        *
*                                                                     *
***********************************************************************
*
TXT7     DC    Y(TXT7B-TXT7A)       ENTRY LENGTH
         DC    X'9000'              MESSAGE FLAG
*  SPACING CONTROL SUB-STRUCTURE
TXT7A    DC    X'4000'              SPACING CONTROL FLAG
         DC    H'2'                 SPACING FACTOR
         DC    C'R '                SPACING TYPE
*  STATIC TEXT SUB-STRUCTURE
         DC    X'8400'              STATIC TEXT END-OF-LIST
         DC    Y(STE71B-STE71A)     STATIC TEXT LENGTH
         DC    Y(STE71A-TXT7A)      STATIC TEXT OFFSET
         DC    H'01'                PRINT COLUMN
         DC    Y(STE71B-STE71A)     PRINT FIELD LENGTH
         DC    H'0'                 CONVERSION FLAG (CHAR)
*
* STATIC TEXT ENTRIES
*
STE71A   DC    C'ICK31006I VOLUME LABEL CREATION FAILED.'
STE71B   EQU   *
TXT7B    EQU   *
         EJECT
***********************************************************************
*                                                                     *
*  RECORD-ZERO INCORRECT -- X CCCC:HHHH ( CCCC:HHHH) Y CCCC:HHHH      *
*                                                                     *
***********************************************************************
*
TXT8     DC    Y(TXT8B-TXT8A)       ENTRY LENGTH
         DC    X'9000'              MESSAGE FLAG
*  SPACING CONTROL SUB-STRUCTURE
TXT8A    DC    X'4000'              SPACING CONTROL FLAG
         DC    H'2'                 SPACING FACTOR
         DC    C'R '                SPACING TYPE
*  STATIC TEXT SUB-STRUCTURE
         DC    X'0400'              STATIC TEXT
         DC    Y(STE81B-STE81A)     STATIC TEXT LENGTH
         DC    Y(STE81A-TXT8A)      STATIC TEXT OFFSET
         DC    H'01'                PRINT COLUMN
         DC    Y(STE81B-STE81A)     PRINT FIELD LENGTH
         DC    H'0'                 CONVERSION FLAG (CHAR)
*  INSERT DATA STRUCTURE
         DC    X'2000'              INSERT DATA FLAG
         DC    H'1'                 REFERENCE NUMBER
         DC    H'0'                 NOT USED
         DC    H'31'                PRINT COLUMN
         DC    H'1'                 PRINT FIELD LENGTH
         DC    H'0'                 CONVERSION FLAG (CHAR)
*  INSERT DATA STRUCTURE
         DC    X'2000'              INSERT DATA FLAG
         DC    H'2'                 REFERENCE NUMBER
         DC    H'0'                 NOT USED
         DC    H'33'                PRINT COLUMN
         DC    H'4'                 PRINT FIELD LENGTH
         DC    X'8000'              CONVERSION FLAG (BIN TO HEX)
*  INSERT DATA STRUCTURE
         DC    X'2000'              INSERT DATA FLAG
         DC    H'3'                 REFERENCE NUMBER
         DC    H'0'                 NOT USED
         DC    H'38'                PRINT COLUMN
         DC    H'4'                 PRINT FIELD LENGTH
         DC    X'8000'              CONVERSION FLAG (BIN TO HEX)
*  INSERT DATA STRUCTURE
         DC    X'2000'              INSERT DATA FLAG
         DC    H'4'                 REFERENCE NUMBER
         DC    H'0'                 NOT USED
         DC    H'44'                PRINT COLUMN
         DC    H'4'                 PRINT FIELD LENGTH
         DC    X'8000'              CONVERSION FLAG (BIN TO HEX)
*  INSERT DATA STRUCTURE
         DC    X'2000'              INSERT DATA FLAG
         DC    H'5'                 REFERENCE NUMBER
         DC    H'0'                 NOT USED
         DC    H'49'                PRINT COLUMN
         DC    H'4'                 PRINT FIELD LENGTH
         DC    X'8000'              CONVERSION FLAG (BIN TO HEX)
*  INSERT DATA STRUCTURE
         DC    X'2000'              INSERT DATA FLAG
         DC    H'6'                 REFERENCE NUMBER
         DC    H'0'                 NOT USED
         DC    H'55'                PRINT COLUMN
         DC    H'1'                 PRINT FIELD LENGTH
         DC    H'0'                 CONVERSION FLAG (CHAR)
*  INSERT DATA STRUCTURE
         DC    X'2000'              INSERT DATA FLAG
         DC    H'7'                 REFERENCE NUMBER
         DC    H'0'                 NOT USED
         DC    H'57'                PRINT COLUMN
         DC    H'4'                 PRINT FIELD LENGTH
         DC    X'8000'              CONVERSION FLAG (BIN TO HEX)
*  INSERT DATA STRUCTURE
         DC    X'A000'              INSERT DATA FLAG END-OF-LIST
         DC    H'8'                 REFERENCE NUMBER
         DC    H'0'                 NOT USED
         DC    H'62'                PRINT COLUMN
         DC    H'4'                 PRINT FIELD LENGTH
         DC    X'8000'              CONVERSION FLAG (BIN TO HEX)
*
* STATIC TEXT ENTRIES
*
STE81A   DC    C'ICK21007I R-ZERO INCORRECT -- '
         DC    C'X CCCC:HHHH (CCCC:HHHH) Y CCCC:HHHH'
STE81B   EQU   *
TXT8B    EQU   *
         EJECT
***********************************************************************
*                                                                     *
* UNABLE TO WRITE IPL RECORDS                                         *
*                                                                     *
***********************************************************************
*
TXT9     DC    Y(TXT9B-TXT9A)       ENTRY LENGTH
         DC    X'9000'              MESSAGE FLAG
*  SPACING CONTROL SUB-STRUCTURE
TXT9A    DC    X'4000'              SPACING CONTROL FLAG
         DC    H'2'                 SPACING FACTOR
         DC    C'R '                SPACING TYPE
*  STATIC TEXT SUB-STRUCTURE
         DC    X'8400'              STATIC TEXT END-OF-LIST
         DC    Y(STE91B-STE91A)     STATIC TEXT LENGTH
         DC    Y(STE91A-TXT9A)      STATIC TEXT OFFSET
         DC    H'01'                PRINT COLUMN
         DC    Y(STE91B-STE91A)     PRINT FIELD LENGTH
         DC    H'0'                 CONVERSION FLAG (CHAR)
*
* STATIC TEXT ENTRIES
*
STE91A   DC    C'ICK21008I UNABLE TO WRITE IPL RECORDS.'
STE91B   EQU   *
TXT9B    EQU   *
         EJECT
***********************************************************************
*                                                                     *
* IPL PROGRAM SUPPLIED FOR MSS                                        *
*                                                                     *
***********************************************************************
*
TXT10    DC    Y(TXT10B-TXT10A)     ENTRY LENGTH
         DC    X'9000'              MESSAGE FLAG
*  SPACING CONTROL SUB-STRUCTURE
TXT10A   DC    X'4000'              SPACING CONTROL FLAG
         DC    H'2'                 SPACING FACTOR
         DC    C'R '                SPACING TYPE
*  STATIC TEXT SUB-STRUCTURE
         DC    X'8400'              STATIC TEXT END-OF-LIST
         DC    Y(STE101B-STE101A)   STATIC TEXT LENGTH
         DC    Y(STE101A-TXT10A)    STATIC TEXT OFFSET
         DC    H'01'                PRINT COLUMN
         DC    Y(STE101B-STE101A)   PRINT FIELD LENGTH
         DC    H'0'                 CONVERSION FLAG (CHAR)
*
* STATIC TEXT ENTRIES
*
STE101A  DC    C'ICK11009I IPL PROGRAM SUPPLIED FOR MSS -- IGNORED.'
STE101B  EQU   *
TXT10B   EQU   *
         EJECT
***********************************************************************
*                                                                     *
* UNABLE TO CLOSE VOLUME                                              *
*                                                                     *
***********************************************************************
*
TXT11    DC    Y(TXT11B-TXT11A)     ENTRY LENGTH
         DC    X'9000'              MESSAGE FLAG
*  SPACING CONTROL SUB-STRUCTURE
TXT11A   DC    X'4000'              SPACING CONTROL FLAG
         DC    H'2'                 SPACING FACTOR
         DC    C'R '                SPACING TYPE
*  STATIC TEXT SUB-STRUCTURE
         DC    X'8400'              STATIC TEXT END-OF-LIST
         DC    Y(STE111B-STE111A)   STATIC TEXT LENGTH
         DC    Y(STE111A-TXT11A)    STATIC TEXT OFFSET
         DC    H'01'                PRINT COLUMN
         DC    Y(STE111B-STE111A)   PRINT FIELD LENGTH
         DC    H'0'                 CONVERSION FLAG (CHAR)
*
* STATIC TEXT ENTRIES
*
STE111A  DC    C'ICK11010I UNABLE TO CLOSE VOLUME.'
STE111B  EQU   *
TXT11B   EQU   *
         EJECT
***********************************************************************
*                                                                     *
* CRTICAL TRACK CCCC:HHHH DESCRIPTOR INCORRECT                        *
*                                                                     *
***********************************************************************
*                                                                     *
TXT12    DC    Y(TXT12B-TXT12A)     ENTRY LENGTH
         DC    X'9000'              MESSAGE FLAG
*  SPACING CONTROL STRUCTURE
*
TXT12A   DC    X'4000'              SPACE CONTROL
         DC    H'2'                 SPACING FACTOR
         DC    C'R '                SPACING TYPE
*  STATIC TEXT SUBSTRUCTURE
         DC    X'0400'              STATIC FLAG END OF LIST
         DC    Y(STE121B-STE121A)   STATIC TEXT LENGTH
         DC    Y(STE121A-TXT12A)    STATIC TEXT OFFSET
         DC    H'1'                 PRINT COLUMN
         DC    Y(STE121B-STE121A)   PRINT FIELD LENGTH
         DC    H'0'                 CONVERSION FLAG (CHAR)
*  INSERT DATA STRUCTURE
         DC    X'2000'              INSERT DATA FLAG
         DC    H'1'                 REFERENCE NUMBER
         DC    H'0'                 NOT USED
         DC    H'26'                PRINT COLUMN
         DC    H'4'                 PRINT FIELD LENGTH
         DC    X'8000'              CONVERSION FLAG (B TO X)
*  INSERT DATA STRUCTURE
         DC    X'2000'              INSERT DATA FLAG
         DC    H'2'                 REFERENCE NUMBER
         DC    H'0'                 NOT USED
         DC    H'31'                PRINT COLUMN
         DC    H'4'                 PRINT FIELD LENGTH
         DC    X'8000'              CONVERSION FLAG (B TO X)
*  STATIC TEXT SUB-STRUCTURE
         DC    X'8400'              STATIC TEXT END OF LIST
         DC    Y(STE122B-STE122A)   STATIC TEXT LENGTH
         DC    Y(STE122A-TXT12A)    STATIC TEXT OFFSET
         DC    H'36'                PRINT COLUMN
         DC    Y(STE122B-STE122A)   PRINT FIELD LENGTH
         DC    H'0'                 CONVERSION FLAG (CHAR)
*
* STATIC TEXT ENTRIES
*
STE121A  DC    C'ICK21011I CRITICAL TRACK '
STE121B  EQU   *
STE122A  DC    C'DESCRIPTOR INCORRECT'
STE122B  EQU   *
TXT12B   EQU   *
         EJECT
***********************************************************************
*                                                                     *
* VOLID NOT SPECIFIED AND NO VOLUME LABEL EXISTS                      *
*                                                                     *
***********************************************************************
*
TXT13    DC    Y(TXT13B-TXT13A)     ENTRY LENGTH
         DC    X'9000'              MESSAGE FLAG
*  SPACING CONTROL SUB-STRUCTURE
TXT13A   DC    X'4000'              SPACING CONTROL FLAG
         DC    H'2'                 SPACING FACTOR
         DC    C'R '                SPACING TYPE
*  STATIC TEXT SUB-STRUCTURE
         DC    X'8400'              STATIC TEXT
         DC    Y(STE131B-STE131A)   STATIC TEXT LENGTH
         DC    Y(STE131A-TXT13A)    STATIC TEXT OFFSET
         DC    H'01'                PRINT COLUMN
         DC    Y(STE131B-STE131A)   PRINT FIELD LENGTH
         DC    H'0'                 CONVERSION FLAG (CHAR)
*
* STATIC TEXT ENTRY
*
STE131A  DC    C'ICK31012I VOLID NOT SPECIFIED AND NO VOLUME LABEL '
         DC    C'EXISTS.'
STE131B  EQU   *
TXT13B   EQU   *
         EJECT
***********************************************************************
*                                                                     *
* UNRECOVERABLE TRACKS THRESHOLD MET                                  *
*                                                                     *
***********************************************************************
*
TXT14    DC    Y(TXT14B-TXT14A)     ENTRY LENGTH
         DC    X'9000'              MESSAGE FLAG
*  SPACING CONTROL SUB-STRUCTURE
TXT14A   DC    X'4000'              SPACING CONTROL FLAG
         DC    H'2'                 SPACING FACTOR
         DC    C'R '                SPACING TYPE
*  STATIC TEXT SUB-STRUCTURE
         DC    X'8400'              STATIC TEXT END-OF-LIST
         DC    Y(STE141B-STE141A)   STATIC TEXT LENGTH
         DC    Y(STE141A-TXT14A)    STATIC TEXT OFFSET
         DC    H'01'                PRINT COLUMN
         DC    Y(STE141B-STE141A)   PRINT FIELD LENGTH
         DC    H'0'                 CONVERSION FLAG (CHAR)
*
* STATIC TEXT ENTRY
*
STE141A  DC    C'ICK31013I UNRECOVERABLE TRACK THRESHOLD MET.'
STE141B  EQU   *
TXT14B   EQU   *
         EJECT
***********************************************************************
*                                                                     *
* SURFACE CHECK FUNCTION FAILED                                       *
*                                                                     *
***********************************************************************
*
TXT15    DC    Y(TXT15B-TXT15A)     ENTRY LENGTH
         DC    X'9000'              MESSAGE FLAG
*  SPACING CONTROL SUB-STRUCTURE
TXT15A   DC    X'4000'              SPACING CONTROL FLAG
         DC    H'2'                 SPACING FACTOR
         DC    C'R '                SPACING TYPE
*  STATIC TEXT SUB-STRUCTURE
         DC    X'0400'              STATIC TEXT
         DC    Y(STE151B-STE151A)   STATIC TEXT LENGTH
         DC    Y(STE151A-TXT15A)    STATIC TEXT OFFSET
         DC    H'01'                PRINT COLUMN
         DC    Y(STE151B-STE151A)   PRINT FIELD LENGTH
         DC    H'0'                 CONVERSION FLAG (CHAR)
*  INSERT DATA STRUCTURE
         DC    X'2000'              INSERT DATA FLAG
         DC    H'1'                 REFERENCE NUMBER
         DC    H'0'                 NOT USED
         DC    H'49'                PRINT COLUMN
         DC    H'4'                 PRINT FIELD LENGTH
         DC    X'8000'              CONVERSION FLAG (BIN TO HEX)
*  INSERT DATA STRUCTURE
         DC    X'A000'              INSERT DATA FLAG END-OF-LIST
         DC    H'2'                 REFERENCE NUMBER
         DC    H'0'                 NOT USED
         DC    H'54'                PRINT COLUMN
         DC    H'4'                 PRINT FIELD LENGTH
         DC    X'8000'              CONVERSION FLAG (BIN TO HEX)
*
* STATIC TEXT ENTRY
*
STE151A  DC    C'ICK21014I SURFACE CHECK FUNCTION FAILS ON TRACK '
STE151B  EQU   *
TXT15B   EQU   *
         EJECT
***********************************************************************
*                                                                     *
* UNABLE TO READ VOLUME LABEL                                         *
*                                                                     *
***********************************************************************
*
TXT16    DC    Y(TXT16B-TXT16A)     ENTRY LENGTH
         DC    X'9000'              MESSAGE FLAG
*  SPACING CONTROL SUB-STRUCTURE
TXT16A   DC    X'4000'              SPACING CONTROL FLAG
         DC    H'2'                 SPACING FACTOR
         DC    C'R '                SPACING TYPE
*  STATIC TEXT SUB-STRUCTURE
         DC    X'8400'              STATIC TEXT
         DC    Y(STE161B-STE161A)   STATIC TEXT LENGTH
         DC    Y(STE161A-TXT16A)    STATIC TEXT OFFSET
         DC    H'01'                PRINT COLUMN
         DC    Y(STE161B-STE161A)   PRINT FIELD LENGTH
         DC    H'0'                 CONVERSION FLAG (CHAR)
*
* STATIC TEXT ENTRIES
*
STE161A  DC    C'ICK31015I UNABLE TO READ VOLUME LABEL.'
STE161B  EQU   *
TXT16B   EQU   *
         EJECT
***********************************************************************
*                                                                     *
* AN ALTERNATE TRACK WAS ASSIGNED                                     *
*                                                                     *
***********************************************************************
*
*
TXT17    DC    Y(TXT17B-TXT17A)     ENTRY LENGTH
         DC    X'9000'              MESSAGE FLAG
*  SPACING CONTROL SUB-STRUCTURE
TXT17A   DC    X'4000'              SPACING CONTROL FLAG
         DC    H'2'                 SPACING FACTOR
         DC    C'R '                SPACING TYPE
*  STATIC TEXT SUB-STRUCTURE
         DC    X'0400'              STATIC TEXT
         DC    Y(STE171B-STE171A)   STATIC TEXT LENGTH
         DC    Y(STE171A-TXT17A)    STATIC TEXT OFFSET
         DC    H'01'                PRINT COLUMN
         DC    Y(STE171B-STE171A)   PRINT FIELD LENGTH
         DC    H'0'                 CONVERSION FLAG (CHAR)
*  INSERT DATA STRUCTURE
         DC    X'2000'              INSERT DATA FLAG
         DC    H'1'                 REFERENCE NUMBER
         DC    H'0'                 NOT USED
         DC    H'27'                PRINT COLUMN
         DC    H'4'                 PRINT FIELD LENGTH
         DC    X'8000'              CONVERSION FLAG (BIN TO HEX)
*  INSERT DATA STRUCTURE
         DC    X'2000'              INSERT DATA FLAG
         DC    H'2'                 REFERENCE NUMBER
         DC    H'0'                 NOT USED
         DC    H'32'                PRINT COLUMN
         DC    H'4'                 PRINT FIELD LENGTH
         DC    X'8000'              CONVERSION FLAG (BIN TO HEX)
*  STATIC TEXT SUB-STRUCTURE
         DC    X'0400'              STATIC TEXT
         DC    Y(STE172B-STE172A)   STATIC TEXT LENGTH
         DC    Y(STE172A-TXT17A)    STATIC TEXT OFFSET
         DC    H'37'                PRINT COLUMN
         DC    Y(STE172B-STE172A)   PRINT FIELD LENGTH
         DC    H'0'                 CONVERSION FLAG (CHAR)
*  INSERT DATA STRUCTURE
         DC    X'2000'              INSERT DATA FLAG
         DC    H'3'                 REFERENCE NUMBER
         DC    H'0'                 NOT USED
         DC    H'63'                PRINT COLUMN
         DC    H'4'                 PRINT FIELD LENGTH
         DC    X'8000'              CONVERSION FLAG (BIN TO HEX)
*  INSERT DATA STRUCTURE
         DC    X'A000'              INSERT DATA FLAG
         DC    H'4'                 REFERENCE NUMBER
         DC    H'0'                 NOT USED
         DC    H'68'                PRINT COLUMN
         DC    H'4'                 PRINT FIELD LENGTH
         DC    X'8000'              CONVERSION FLAG (BIN TO HEX)
*
* STATIC TEXT ENTRIES
*
STE171A  DC    C'ICK01016I ALTERNATE TRACK '
STE171B  EQU   *
STE172A  DC    C'ASSIGNED TO PRIMARY TRACK '
STE172B  EQU   *
TXT17B   EQU   *
         EJECT
***********************************************************************
*
*                                                                     *
* NO MORE ALTERNATES TRACKS LEFT ON PACK                              *
*                                                                     *
***********************************************************************
*
TXT18    DC    Y(TXT18B-TXT18A)     ENTRY LENGTH
         DC    X'9000'              MESSAGE FLAG
*  SPACING CONTROL SUB-STRUCTURE
TXT18A   DC    X'4000'              SPACING CONTROL FLAG
         DC    H'2'                 SPACING FACTOR
         DC    C'R '                SPACING TYPE
*  STATIC TEXT SUB-STRUCTURE
         DC    X'8400'              STATIC TEXT
         DC    Y(STE181B-STE181A)   STATIC TEXT LENGTH
         DC    Y(STE181A-TXT18A)    STATIC TEXT OFFSET
         DC    H'01'                PRINT COLUMN
         DC    Y(STE181B-STE181A)   PRINT FIELD LENGTH
         DC    H'0'                 CONVERSION FLAG (CHAR)
*
* STATIC TEXT ENTRIES
*
STE181A  DC    C'ICK21017I NO MORE ALTERNATE TRACKS LEFT ON PACK.'
STE181B  EQU    *
TXT18B   EQU   *
         EJECT
***********************************************************************
*                                                                     *
* AN ALTERNATE WAS RE-ASSIGNED FOR PRIMARY TRACK                      *
*                                                                     *
***********************************************************************
*
TXT19    DC    Y(TXT19B-TXT19A)     ENTRY LENGTH
         DC    X'9000'              MESSAGE FLAG
*  SPACING CONTROL SUB-STRUCTURE
TXT19A   DC    X'4000'              SPACING CONTROL FLAG
         DC    H'2'                 SPACING FACTOR
         DC    C'R '                SPACING TYPE
*  STATIC TEXT SUB-STRUCTURE
         DC    X'0400'              STATIC TEXT
         DC    Y(STE191B-STE191A)   STATIC TEXT LENGTH
         DC    Y(STE191A-TXT19A)    STATIC TEXT OFFSET
         DC    H'01'                PRINT COLUMN
         DC    Y(STE191B-STE191A)   PRINT FIELD LENGTH
         DC    H'0'                 CONVERSION FLAG (CHAR)
*  INSERT DATA STRUCTURE
         DC    X'2000'              INSERT DATA FLAG
         DC    H'1'                 REFERENCE NUMBER
         DC    H'0'                 NOT USED
         DC    H'21'                PRINT COLUMN
         DC    H'4'                 PRINT FIELD LENGTH
         DC    X'8000'              CONVERSION FLAG (BIN TO HEX)
*  INSERT DATA STRUCTURE
         DC    X'2000'              INSERT DATA FLAG
         DC    H'2'                 REFERENCE NUMBER
         DC    H'0'                 NOT USED
         DC    H'26'                PRINT COLUMN
         DC    H'4'                 PRINT FIELD LENGTH
         DC    X'8000'              CONVERSION FLAG (BIN TO HEX)
*  STATIC TEXT SUB-STRUCTURE
         DC    X'0400'              STATIC TEXT
         DC    Y(STE192B-STE192A)   STATIC TEXT LENGTH
         DC    Y(STE192A-TXT19A)    STATIC TEXT OFFSET
         DC    H'31'                PRINT COLUMN
         DC    Y(STE192B-STE192A)   PRINT FIELD LENGTH
         DC    H'0'                 CONVERSION FLAG (CHAR)
*  INSERT DATA STRUCTURE
         DC    X'2000'              INSERT DATA FLAG
         DC    H'3'                 REFERENCE NUMBER
         DC    H'0'                 NOT USED
         DC    H'55'                PRINT COLUMN
         DC    H'4'                 PRINT FIELD LENGTH
         DC    X'8000'              CONVERSION FLAG (BIN TO HEX)
*  INSERT DATA STRUCTURE
         DC    X'A000'              INSERT DATA FLAG
         DC    H'4'                 REFERENCE NUMBER
         DC    H'0'                 NOT USED
         DC    H'60'                PRINT COLUMN
         DC    H'4'                 PRINT FIELD LENGTH
         DC    X'8000'              CONVERSION FLAG (BIN TO HEX)
*
* STATIC TEXT ENTRIES
*
STE191A  DC    C'ICK01018I ALTERNATE '
STE191B  EQU   *
STE192A  DC    C'RE-ASSIGNED FOR PRIMARY '
STE192B  EQU   *
TXT19B   EQU   *
         EJECT
***********************************************************************
*                                                                     *
* NEXT-AVAILABLE-ALTERNATE POINTER IN VTOC IS INVALID                 *
*                                                                     *
***********************************************************************
*
TXT20    DC    Y(TXT20B-TXT20A)     ENTRY LENGTH
         DC    X'9000'              MESSAGE FLAG
*  SPACING CONTROL SUB-STRUCTURE
TXT20A   DC    X'4000'              SPACING CONTROL FLAG
         DC    H'2'                 SPACING FACTOR
         DC    C'R '                SPACING TYPE
*  STATIC TEXT SUB-STRUCTURE
         DC    X'8400'              STATIC TEXT END-OF-LIST
         DC    Y(STE201B-STE201A)   STATIC TEXT LENGTH
         DC    Y(STE201A-TXT20A)    STATIC TEXT OFFSET
         DC    H'01'                PRINT COLUMN
         DC    Y(STE201B-STE201A)   PRINT FIELD LENGTH
         DC    H'0'                 CONVERSION FLAG (CHAR)
*
* STATIC TEXT ENTRIES
*
STE201A  DC    C'ICK31019I NEXT-AVAILABLE-ALTERNATE POINTER OR '
         DC    C'COUNTER IN VTOC IS INVALID'
STE201B  EQU   *
TXT20B   EQU   *
         EJECT
***********************************************************************
*                                                                     *
* ALTERNATE TRACK WAS RECLAIMED                                       *
*                                                                     *
***********************************************************************
*
TXT21    DC    Y(TXT21B-TXT21A)     ENTRY LENGTH
         DC    X'9000'              MESSAGE FLAG
*  SPACING CONTROL SUB-STRUCTURE
TXT21A   DC    X'4000'              SPACING CONTROL FLAG
         DC    H'2'                 SPACING FACTOR
         DC    C'R '                SPACING TYPE
*  STATIC TEXT SUB-STRUCTURE
         DC    X'0400'              STATIC TEXT
         DC    Y(STE211B-STE211A)   STATIC TEXT LENGTH
         DC    Y(STE211A-TXT21A)    STATIC TEXT OFFSET
         DC    H'01'                PRINT COLUMN
         DC    Y(STE211B-STE211A)   PRINT FIELD LENGTH
         DC    H'0'                 CONVERSION FLAG (CHAR)
*  INSERT DATA STRUCTURE
         DC    X'2000'              INSERT DATA FLAG
         DC    H'1'                 REFERENCE NUMBER
         DC    H'0'                 NOT USED
         DC    H'27'                PRINT COLUMN
         DC    H'4'                 PRINT FIELD LENGTH
         DC    X'8000'              CONVERSION FLAG (BIN TO HEX)
*  INSERT DATA STRUCTURE
         DC    X'2000'              INSERT DATA FLAG
         DC    H'2'                 REFERENCE NUMBER
         DC    H'0'                 NOT USED
         DC    H'32'                PRINT COLUMN
         DC    H'4'                 PRINT FIELD LENGTH
         DC    X'8000'              CONVERSION FLAG (BIN TO HEX)
*  STATIC TEXT SUB-STRUCTURE
         DC    X'8400'              STATIC TEXT END-OF-LIST
         DC    Y(STE212B-STE212A)   STATIC TEXT LENGTH
         DC    Y(STE212A-TXT21A)    STATIC TEXT OFFSET
         DC    H'37'                PRINT COLUMN
         DC    Y(STE212B-STE212A)   PRINT FIELD LENGTH
         DC    H'0'                 CONVERSION FLAG (CHAR)
*
* STATIC TEXT ENTRIES
*
STE211A  DC    C'ICK01020I ALTERNATE TRACK '
STE211B  EQU   *
STE212A  DC    C'WAS RECLAIMED.'
STE212B  EQU   *
TXT21B   EQU   *
         EJECT
***********************************************************************
*                                                                     *
* PRIMARY TRACK WAS RECLAIMED                                         *
*                                                                     *
***********************************************************************
*
TXT22    DC    Y(TXT22B-TXT22A)     ENTRY LENGTH
         DC    X'9000'              MESSAGE FLAG
*  SPACING CONTROL SUB-STRUCTURE
TXT22A   DC    X'4000'              SPACING CONTROL FLAG
         DC    H'2'                 SPACING FACTOR
         DC    C'R '                SPACING TYPE
*  STATIC TEXT SUB-STRUCTURE
         DC    X'0400'              STATIC TEXT
         DC    Y(STE221B-STE221A)   STATIC TEXT LENGTH
         DC    Y(STE221A-TXT22A)    STATIC TEXT OFFSET
         DC    H'01'                PRINT COLUMN
         DC    Y(STE221B-STE221A)   PRINT FIELD LENGTH
         DC    H'0'                 CONVERSION FLAG (CHAR)
*  INSERT DATA STRUCTURE
         DC    X'2000'              INSERT DATA FLAG
         DC    H'1'                 REFERENCE NUMBER
         DC    H'0'                 NOT USED
         DC    H'25'                PRINT COLUMN
         DC    H'4'                 PRINT FIELD LENGTH
         DC    X'8000'              CONVERSION FLAG (BIN TO HEX)
*  INSERT DATA STRUCTURE
         DC    X'2000'              INSERT DATA FLAG
         DC    H'2'                 REFERENCE NUMBER
         DC    H'0'                 NOT USED
         DC    H'30'                PRINT COLUMN
         DC    H'4'                 PRINT FIELD LENGTH
         DC    X'8000'              CONVERSION FLAG (BIN TO HEX)
*  STATIC TEXT SUB-STRUCTURE
         DC    X'8400'              STATIC TEXT END-OF-LIST
         DC    Y(STE222B-STE222A)   STATIC TEXT LENGTH
         DC    Y(STE222A-TXT22A)    STATIC TEXT OFFSET
         DC    H'35'                PRINT COLUMN
         DC    Y(STE222B-STE222A)   PRINT FIELD LENGTH
         DC    H'0'                 CONVERSION FLAG (CHAR)
*
* STATIC TEXT ENTRIES
*
STE221A  DC    C'ICK01021I PRIMARY TRACK '
STE221B  EQU   *
STE222A  DC    C'WAS RECLAIMED.'
STE222B  EQU   *
TXT22B   EQU   *
         EJECT
***********************************************************************
*                                                                     *
* UNABLE TO CHANGE VOLUME LABEL                                       *
*                                                                     *
***********************************************************************
*
TXT23    DC    Y(TXT23B-TXT23A)     ENTRY LENGTH
         DC    X'9000'              MESSAGE FLAG
*  SPACING CONTROL SUB-STRUCTURE
TXT23A   DC    X'4000'              SPACING CONTROL FLAG
         DC    H'2'                 SPACING FACTOR
         DC    C'R '                SPACING TYPE
*  STATIC TEXT SUB-STRUCTURE
         DC    X'8400'              STATIC TEXT END-OF-LIST
         DC    Y(STE231B-STE231A)   STATIC TEXT LENGTH
         DC    Y(STE231A-TXT23A)    STATIC TEXT OFFSET
         DC    H'01'                PRINT COLUMN
         DC    Y(STE231B-STE231A)   PRINT FIELD LENGTH
         DC    H'0'                 CONVERSION FLAG (CHAR)
*
* STATIC TEXT ENTRIES
*
STE231A  DC    C'ICK31022I UNABLE TO CHANGE VOLUME LABEL'
STE231B  EQU   *
TXT23B   EQU   *
         EJECT
***********************************************************************
*                                                                     *
* INVALID UNITADDRESS OR DDNAME SPECIFIED                             *
*                                                                     *
***********************************************************************
*
TXT24    DC    Y(TXT24B-TXT24A)     ENTRY LENGTH
         DC    X'9000'              MESSAGE FLAG
*  SPACING CONTROL SUB-STRUCTURE
TXT24A   DC    X'4000'              SPACING CONTROL FLAG
         DC    H'2'                 SPACING FACTOR
         DC    C'R '                SPACING TYPE
*  STATIC TEXT SUB-STRUCTURE
         DC    X'8400'              STATIC TEXT END-OF-LIST
         DC    Y(STE241B-STE241A)   STATIC TEXT LENGTH
         DC    Y(STE241A-TXT24A)    STATIC TEXT OFFSET
         DC    H'01'                PRINT COLUMN
         DC    Y(STE241B-STE241A)   PRINT FIELD LENGTH
         DC    H'0'                 CONVERSION FLAG (CHAR)
*
* STATIC TEXT ENTRIES
*
STE241A  DC    C'ICK31023I INVALID UNITADDRESS OR DDNAME SPECIFIED.'
STE241B  EQU   *
TXT24B   EQU   *
         EJECT
***********************************************************************
*                                                                     *
* UNABLE TO OPEN VOLUME
*                                                                     *
***********************************************************************
*
TXT25    DC    Y(TXT25B-TXT25A)     ENTRY LENGTH
         DC    X'9000'              MESSAGE FLAG
*  SPACING CONTROL SUB-STRUCTURE
TXT25A   DC    X'4000'              SPACING CONTROL FLAG
         DC    H'2'                 SPACING FACTOR
         DC    C'R '                SPACING TYPE
*  STATIC TEXT SUB-STRUCTURE
         DC    X'8400'              STATIC TEXT
         DC    Y(STE251B-STE251A)   STATIC TEXT LENGTH
         DC    Y(STE251A-TXT25A)    STATIC TEXT OFFSET
         DC    H'01'                PRINT COLUMN
         DC    Y(STE251B-STE251A)   PRINT FIELD LENGTH
         DC    H'0'                 CONVERSION FLAG (CHAR)
*
* STATIC TEXT ENTRY
*
STE251A  DC    C'ICK31024I UNABLE TO OPEN VOLUME.'
STE251B  EQU   *
TXT25B   EQU   *
         EJECT
***********************************************************************
*                                                                     *
* VOLUME NOT MOUNTED PRIVATE                                          *
*                                                                     *
***********************************************************************
*
TXT26    DC    Y(TXT26B-TXT26A)     ENTRY LENGTH
         DC    X'9000'              MESSAGE FLAG
*  SPACING CONTROL SUB-STRUCTURE
TXT26A   DC    X'4000'              SPACING CONTROL FLAG
         DC    H'2'                 SPACING FACTOR
         DC    C'R '                SPACING TYPE
*  STATIC TEXT SUB-STRUCTURE
         DC    X'8400'              STATIC TEXT END-OF-LIST
         DC    Y(STE261B-STE261A)   STATIC TEXT LENGTH
         DC    Y(STE261A-TXT26A)    STATIC TEXT OFFSET
         DC    H'01'                PRINT COLUMN
         DC    Y(STE261B-STE261A)   PRINT FIELD LENGTH
         DC    H'0'                 CONVERSION FLAG (CHAR)
*
* STATIC TEXT ENTRY
*
STE261A  DC    C'ICK31025I VOLUME NOT MOUNTED PRIVATE.'
STE261B  EQU   *
TXT26B   EQU   *
         EJECT
***********************************************************************
*                                                                     *
* COMMAND INVALID FOR UNINITIALIZED VOLUME                            *
*                                                                     *
***********************************************************************
*
TXT27    DC    Y(TXT27B-TXT27A)     ENTRY LENGTH
         DC    X'9000'              MESSAGE FLAG
*  SPACING CONTROL SUB-STRUCTURE
TXT27A   DC    X'4000'              SPACING CONTROL FLAG
         DC    H'2'                 SPACING FACTOR
         DC    C'R '                SPACING TYPE
*  STATIC TEXT SUB-STRUCTURE
         DC    X'8400'              STATIC TEXT END-OF-LIST
         DC    Y(STE271B-STE271A)   STATIC TEXT LENGTH
         DC    Y(STE271A-TXT27A)    STATIC TEXT OFFSET
         DC    H'01'                PRINT COLUMN
         DC    Y(STE271B-STE271A)   PRINT FIELD LENGTH
         DC    H'0'                 CONVERSION FLAG (CHAR)
*
* STATIC TEXT ENTRY
*
STE271A  DC    C'ICK31026I COMMAND INVALID FOR UNINITIALIZED VOLUME.'
STE271B  EQU   *
TXT27B   EQU   *
         EJECT
**********************************************************************
*                                                                    *
* UNABLE TO WRITE VOLUME LABEL DURING VTOC CREATION                  *
*                                                                    *
**********************************************************************
*
TXT28    DC    Y(TXT28B-TXT28A)     ENTRY LENGTH
         DC    X'9000'              MESSAGE FLAG
*  SPACING CONTROL SUB-STRUCTURE
TXT28A   DC    X'4000'              SPACING CONTROL FLAG
         DC    H'2'                 SPACING FACTOR
         DC    C'R '                SPACING TYPE
*  STATIC TEXT SUB-STRUCTURE
         DC    X'8400'              STATIC TEXT
         DC    Y(STE281B-STE281A)   STATIC TEXT LENGTH
         DC    Y(STE281A-TXT28A)    STATIC TEXT OFFSET
         DC    H'01'                PRINT COLUMN
         DC    Y(STE281B-STE281A)   PRINT FIELD LENGTH
         DC    H'0'                 CONVERSION FLAG (CHAR)
*
* STATIC TEXT ENTRY
*
STE281A  DC    C'ICK31027I UNABLE TO WRITE VOLUME LABEL DURING '
         DC    C'VTOC CREATION.'
STE281B  EQU   *
TXT28B   EQU   *
         EJECT
**********************************************************************
*                                                                    *
* NOT ALLOWED TO CHANGE VOLUME LABEL IN SYSTEM WITH RACF             *
*                                                                    *
**********************************************************************
*
TXT29    DC    Y(TXT29B-TXT29A)     ENTRY LENGTH
         DC    X'9000'              MESSAGE FLAG
*  SPACING CONTROL SUB-STRUCTURE
TXT29A   DC    X'4000'              SPACING CONTROL FLAG
         DC    H'2'                 SPACING FACTOR
         DC    C'R '                SPACING TYPE
*  STATIC TEXT SUB-STRUCTURE
         DC    X'8400'              STATIC TEXT
         DC    Y(STE291B-STE291A)   STATIC TEXT LENGTH
         DC    Y(STE291A-TXT29A)    STATIC TEXT OFFSET
         DC    H'01'                PRINT COLUMN
         DC    Y(STE291B-STE291A)   PRINT FIELD LENGTH
         DC    H'0'                 CONVERSION FLAG (CHAR)
*
* STATIC TEXT ENTRY
*
STE291A  DC    C'ICK21028I NOT ALLOWED TO CHANGE VOLUME LABEL '
STE291B  EQU   *
TXT29B   EQU   *
         EJECT
**********************************************************************
*                                                                    *
* NOT ALLOWED TO WRITE IPL RECORDS ON RACF SUPPORTED SYSTEM          *
*                                                                    *
**********************************************************************
*
TXT30    DC    Y(TXT30B-TXT30A)     ENTRY LENGTH
         DC    X'9000'              MESSAGE FLAG
*  SPACING CONTROL SUB-STRUCTURE
TXT30A   DC    X'4000'              SPACING CONTROL FLAG
         DC    H'2'                 SPACING FACTOR
         DC    C'R '                SPACING TYPE
*  STATIC TEXT SUB-STRUCTURE
         DC    X'8400'              STATIC TEXT
         DC    Y(STE301B-STE301A)   STATIC TEXT LENGTH
         DC    Y(STE301A-TXT30A)    STATIC TEXT OFFSET
         DC    H'01'                PRINT COLUMN
         DC    Y(STE301B-STE301A)   PRINT FIELD LENGTH
         DC    H'0'                 CONVERSION FLAG (CHAR)
*
* STATIC TEXT ENTRY
*
STE301A  DC    C'ICK21030I NOT ALLOWED TO WRITE IPL RECORDS '
STE301B  EQU   *
TXT30B   EQU   *
         EJECT
**********************************************************************
*                                                                    *
* UNABLE TO RECLAIM ALTERNATE TRACK                                  *
*                                                                    *
**********************************************************************
*
TXT31    DC    Y(TXT31B-TXT31A)     ENTRY LENGTH
         DC    X'9000'              MESSAGE FLAG
*  SPACING CONTROL SUB-STRUCTURE
TXT31A   DC    X'4000'              SPACING CONTROL FLAG
         DC    H'2'                 SPACING FACTOR
         DC    C'R '                SPACING TYPE
*  STATIC TEXT SUB-STRUCTURE
         DC    X'0400'              STATIC TEXT
         DC    Y(STE311B-STE311A)   STATIC TEXT LENGTH
         DC    Y(STE311A-TXT31A)    STATIC TEXT OFFSET
         DC    H'01'                PRINT COLUMN
         DC    Y(STE311B-STE311A)   PRINT FIELD LENGTH
         DC    H'0'                 CONVERSION FLAG (CHAR)
*  INSERT DATA STRUCTURE
         DC    X'2000'              INSERT DATA FLAG
         DC    H'1'                 REFERENCE NUMBER
         DC    H'0'                 NOT USED
         DC    Y(STE311B-STE311A+1) PRINT COLUMN
         DC    H'4'                 PRINT FIELD LENGTH
         DC    X'8000'              CONVERSION FLAG (BIN TO HEX)
*  INSERT DATA STRUCTURE
         DC    X'A000'              INSERT DATA FLAG
         DC    H'2'                 REFERENCE NUMBER
         DC    H'0'                 NOT USED
         DC    Y(STE311B-STE311A+6) PRINT COLUMN
         DC    H'4'                 PRINT FIELD LENGTH
         DC    X'8000'              CONVERSION FLAG (BIN TO HEX)
*
* STATIC TEXT ENTRY
*
STE311A  DC    C'ICK21031I UNABLE TO RECLAIM ALTERNATE TRACK '
STE311B  EQU  *
         DC    C'****:'
         DC    C'**** '
TXT31B   EQU   *
         EJECT
**********************************************************************
*                                                                    *
* UNABLE TO RECLAIM PRIMARY TRACK                                    *
*                                                                    *
**********************************************************************
*
TXT32    DC    Y(TXT32B-TXT32A)     ENTRY LENGTH
         DC    X'9000'              MESSAGE FLAG
*  SPACING CONTROL SUB-STRUCTURE
TXT32A   DC    X'4000'              SPACING CONTROL FLAG
         DC    H'2'                 SPACING FACTOR
         DC    C'R '                SPACING TYPE
*  STATIC TEXT SUB-STRUCTURE
         DC    X'0400'              STATIC TEXT
         DC    Y(STE321B-STE321A)   STATIC TEXT LENGTH
         DC    Y(STE321A-TXT32A)    STATIC TEXT OFFSET
         DC    H'01'                PRINT COLUMN
         DC    Y(STE321B-STE321A)   PRINT FIELD LENGTH
         DC    H'0'                 CONVERSION FLAG (CHAR)
*  INSERT DATA STRUCTURE
         DC    X'2000'              INSERT DATA FLAG
         DC    H'1'                 REFERENCE NUMBER
         DC    H'0'                 NOT USED
         DC    Y(STE321B-STE321A+1) PRINT COLUMN
         DC    H'4'                 PRINT FIELD LENGTH
         DC    X'8000'              CONVERSION FLAG (BIN TO HEX)
*  INSERT DATA STRUCTURE
         DC    X'A000'              INSERT DATA FLAG
         DC    H'2'                 REFERENCE NUMBER
         DC    H'0'                 NOT USED
         DC    Y(STE321B-STE321A+6) PRINT COLUMN
         DC    H'4'                 PRINT FIELD LENGTH
         DC    X'8000'              CONVERSION FLAG (BIN TO HEX)
*
* STATIC TEXT ENTRY
*
STE321A  DC    C'ICK21032I UNABLE TO RECLAIM PRIMARY TRACK '
STE321B  EQU   *
         DC    C'****:'
         DC    C'**** '
TXT32B   EQU   *
         EJECT
**********************************************************************
*                                                                    *
* DISSOCIATION OF PRIMARY TO ALTERNATE TRACK FAILED                  *
*                                                                    *
**********************************************************************
*
TXT33    DC    Y(TXT33B-TXT33A)     ENTRY LENGTH
         DC    X'9000'              MESSAGE FLAG
*  SPACING CONTROL SUB-STRUCTURE
TXT33A   DC    X'4000'              SPACING CONTROL FLAG
         DC    H'2'                 SPACING FACTOR
         DC    C'R '                SPACING TYPE
*  STATIC TEXT SUB-STRUCTURE
         DC    X'0400'              STATIC TEXT
         DC    Y(STE331B-STE331A)   STATIC TEXT LENGTH
         DC    Y(STE331A-TXT33A)    STATIC TEXT OFFSET
         DC    H'01'                PRINT COLUMN
         DC    Y(STE331B-STE331A)   PRINT FIELD LENGTH
         DC    H'0'                 CONVERSION FLAG (CHAR)
*  INSERT DATA STRUCTURE
         DC    X'2000'              INSERT DATA FLAG
         DC    H'1'                 REFERENCE NUMBER
         DC    H'0'                 NOT USED
         DC    Y(STE331B-STE331A+1) PRINT COLUMN
         DC    H'4'                 PRINT FIELD LENGTH
         DC    X'8000'              CONVERSION FLAG (BIN TO HEX)
*  INSERT DATA STRUCTURE
         DC    X'2000'              INSERT DATA FLAG
         DC    H'2'                 REFERENCE NUMBER
         DC    H'0'                 NOT USED
         DC    Y(STE331B-STE331A+6) PRINT COLUMN
         DC    H'4'                 PRINT FIELD LENGTH
         DC    X'8000'              CONVERSION FLAG (BIN TO HEX)
*  INSERT DATA STRUCTURE
         DC    X'2000'              INSERT DATA FLAG
         DC    H'1'                 REFERENCE NUMBER
         DC    H'0'                 NOT USED
         DC    Y(STE332B-STE332A+1) PRINT COLUMN
         DC    H'4'                 PRINT FIELD LENGTH
         DC    X'8000'              CONVERSION FLAG (BIN TO HEX)
*  INSERT DATA STRUCTURE
         DC    X'A000'              INSERT DATA FLAG
         DC    H'2'                 REFERENCE NUMBER
         DC    H'0'                 NOT USED
         DC    Y(STE332B-STE332A+6) PRINT COLUMN
         DC    H'4'                 PRINT FIELD LENGTH
         DC    X'8000'              CONVERSION FLAG (BIN TO HEX)
*
* STATIC TEXT ENTRY
*
STE331A  DC    C'ICK21033I TRACK DISSOCIATION FAILED -- '
STE331B  EQU  *
         DC    C'****:'
         DC    C'**** AND '
STE332A  EQU  *
         DC    C'****:'
         DC    C'****'
STE332B  EQU  *
TXT33B   EQU  *
         EJECT
**********************************************************************
*                                                                    *
* COMBINATION OF NOCHECK & NOASSIGN & ALLTRACKS PROHIBITED           *
*                                                                    *
**********************************************************************
*
TXT34    DC    Y(TXT34B-TXT34A)     ENTRY LENGTH
         DC    X'9000'              MESSAGE FLAG
*  SPACING CONTROL SUB-STRUCTURE
TXT34A   DC    X'4000'              SPACING CONTROL FLAG
         DC    H'2'                 SPACING FACTOR
         DC    C'R '                SPACING TYPE
*  STATIC TEXT SUB-STRUCTURE
         DC    X'8400'              STATIC TEXT
         DC    Y(STE341B-STE341A)   STATIC TEXT LENGTH
         DC    Y(STE341A-TXT34A)    STATIC TEXT OFFSET
         DC    H'01'                PRINT COLUMN
         DC    Y(STE341B-STE341A)   PRINT FIELD LENGTH
         DC    H'0'                 CONVERSION FLAG (CHAR)
*
* STATIC TEXT ENTRY
*
STE341A  DC    C'ICK31034I COMBINATION OF ASSIGN AND ALLTRACKS '
         DC    C'AND NOCHECK PROHIBITED.'
STE341B  EQU   *
TXT34B   EQU   *
         EJECT
**********************************************************************
*                                                                    *
* UNABLE TO READ FORMAT-4 DSCB                                       *
*                                                                    *
**********************************************************************
*
TXT35    DC    Y(TXT35B-TXT35A)     ENTRY LENGTH
         DC    X'9000'              MESSAGE FLAG
*  SPACING CONTROL SUB-STRUCTURE
TXT35A   DC    X'4000'              SPACING CONTROL FLAG
         DC    H'2'                 SPACING FACTOR
         DC    C'R '                SPACING TYPE
*  STATIC TEXT SUB-STRUCTURE
         DC    X'8400'              STATIC TEXT
         DC    Y(STE351B-STE351A)   STATIC TEXT LENGTH
         DC    Y(STE351A-TXT35A)    STATIC TEXT OFFSET
         DC    H'01'                PRINT COLUMN
         DC    Y(STE351B-STE351A)   PRINT FIELD LENGTH
         DC    H'0'                 CONVERSION FLAG (CHAR)
*
* STATIC TEXT ENTRY
*
STE351A  DC    C'ICK31035I UNABLE TO READ FORMAT-4 DSCB.'
STE351B  EQU   *
TXT35B   EQU   *
         EJECT
TXT36    EQU   *
         EJECT
**********************************************************************
*                                                                    *
* INVALID TRACK ADDRESS SPECIFIED FOR INSPECTION                     *
*                                                                    *
**********************************************************************
*
TXT37    DC    Y(TXT37B-TXT37A)     ENTRY LENGTH
         DC    X'9000'              MESSAGE FLAG
*  SPACING CONTROL SUB-STRUCTURE
TXT37A   DC    X'4000'              SPACING CONTROL FLAG
         DC    H'2'                 SPACING FACTOR
         DC    C'R '                SPACING TYPE
*  STATIC TEXT SUB-STRUCTURE
         DC    X'0400'              STATIC TEXT
         DC    Y(STE371B-STE371A)   STATIC TEXT LENGTH
         DC    Y(STE371A-TXT37A)    STATIC TEXT OFFSET
         DC    H'01'                PRINT COLUMN
         DC    Y(STE371B-STE371A)   PRINT FIELD LENGTH
         DC    H'0'                 CONVERSION FLAG (CHAR)
*  INSERT DATA STRUCTURE
         DC    X'A000'              INSERT DATA FLAG
         DC    H'1'                 REFERENCE NUMBER
         DC    H'0'                 NOT USED
         DC    Y(STE371B-STE371A+1) PRINT COLUMN
         DC    H'9'                 PRINT FIELD LENGTH
         DC    H'0'                 CONVERSION FLAG (CHAR)
*
* STATIC TEXT ENTRY
*
STE371A  DC    C'ICK21037I INVALID TRACK ADDRESS SPECIFIED: '
STE371B  EQU   *
         DC    C'*********'
TXT37B   EQU   *
         EJECT
**********************************************************************
*                                                                    *
* NO VALID TRACKS SPECIFIED FOR INSPECTION                           *
*                                                                    *
**********************************************************************
*
TXT38    DC    Y(TXT38B-TXT38A)     ENTRY LENGTH
         DC    X'9000'              MESSAGE FLAG
*  SPACING CONTROL SUB-STRUCTURE
TXT38A   DC    X'4000'              SPACING CONTROL FLAG
         DC    H'2'                 SPACING FACTOR
         DC    C'R '                SPACING TYPE
*  STATIC TEXT SUB-STRUCTURE
         DC    X'8400'              STATIC TEXT
         DC    Y(STE381B-STE381A)   STATIC TEXT LENGTH
         DC    Y(STE381A-TXT38A)    STATIC TEXT OFFSET
         DC    H'01'                PRINT COLUMN
         DC    Y(STE381B-STE381A)   PRINT FIELD LENGTH
         DC    H'0'                 CONVERSION FLAG (CHAR)
*
* STATIC TEXT ENTRY
*
STE381A  DC    C'ICK31038I NO VALID TRACKS WERE SPECIFIED.'
STE381B  EQU   *
TXT38B   EQU   *
         EJECT
**********************************************************************
*                                                                    *
* PRIMARY TRACK DEFECTIVE AND ALTERNATE ASSIGNMENT FAILED (SAVED)    *
*                                                                    *
**********************************************************************
*
TXT39    DC    Y(TXT39B-TXT39A)     ENTRY LENGTH
         DC    X'9000'              MESSAGE FLAG
*  SPACING CONTROL SUB-STRUCTURE
TXT39A   DC    X'4000'              SPACING CONTROL FLAG
         DC    H'2'                 SPACING FACTOR
         DC    C'R '                SPACING TYPE
*  STATIC TEXT SUB-STRUCTURE
         DC    X'0400'              STATIC TEXT
         DC    Y(STE391B-STE391A)   STATIC TEXT LENGTH
         DC    Y(STE391A-TXT39A)    STATIC TEXT OFFSET
         DC    H'01'                PRINT COLUMN
         DC    Y(STE391B-STE391A)   PRINT FIELD LENGTH
         DC    H'0'                 CONVERSION FLAG (CHAR)
*  INSERT DATA STRUCTURE
         DC    X'2000'              INSERT DATA FLAG
         DC    H'1'                 REFERENCE NUMBER
         DC    H'0'                 NOT USED
         DC    Y(STE391B-STE391A+1) PRINT COLUMN
         DC    H'4'                 PRINT FIELD LENGTH
         DC    X'8000'              CONVERSION FLAG (BIN TO HEX)
*  INSERT DATA STRUCTURE
         DC    X'2000'              INSERT DATA FLAG
         DC    H'2'                 REFERENCE NUMBER
         DC    H'0'                 NOT USED
         DC    Y(STE391B-STE391A+6) PRINT COLUMN
         DC    H'4'                 PRINT FIELD LENGTH
         DC    X'8000'              CONVERSION FLAG (BIN TO HEX)
*  STATIC TEXT SUB-STRUCTURE
         DC    X'8400'              STATIC TEXT
         DC    Y(STE392B-STE392A)   STATIC TEXT LENGTH
         DC    Y(STE392A-TXT39A)    STATIC TEXT OFFSET
         DC    Y(STE392A-STE391A+1) PRINT COLUMN
         DC    Y(STE392B-STE392A)   PRINT FIELD LENGTH
         DC    H'0'                 CONVERSION FLAG (CHAR)
*
* STATIC TEXT ENTRY
*
STE391A  DC    C'ICK21039I PRIMARY TRACK '
STE391B  EQU   *
         DC    C'****:'
         DC    C'**** '
STE392A  DC    C'DEFECTIVE, NO ALTERNATE -- DATA SAVED.'
STE392B  EQU   *
TXT39B   EQU   *
         EJECT
**********************************************************************
*                                                                    *
* PRIMARY TRACK DEFECTIVE AND ALTERNATE ASSIGNMENT FAILED (LOST)     *
*                                                                    *
**********************************************************************
*
TXT40    DC    Y(TXT40B-TXT40A)     ENTRY LENGTH
         DC    X'9000'              MESSAGE FLAG
*  SPACING CONTROL SUB-STRUCTURE
TXT40A   DC    X'4000'              SPACING CONTROL FLAG
         DC    H'2'                 SPACING FACTOR
         DC    C'R '                SPACING TYPE
*  STATIC TEXT SUB-STRUCTURE
         DC    X'0400'              STATIC TEXT
         DC    Y(STE401B-STE401A)   STATIC TEXT LENGTH
         DC    Y(STE401A-TXT40A)    STATIC TEXT OFFSET
         DC    H'01'                PRINT COLUMN
         DC    Y(STE401B-STE401A)   PRINT FIELD LENGTH
         DC    H'0'                 CONVERSION FLAG (CHAR)
*  INSERT DATA STRUCTURE
         DC    X'2000'              INSERT DATA FLAG
         DC    H'1'                 REFERENCE NUMBER
         DC    H'0'                 NOT USED
         DC    Y(STE401B-STE401A+1) PRINT COLUMN
         DC    H'4'                 PRINT FIELD LENGTH
         DC    X'8000'              CONVERSION FLAG (BIN TO HEX)
*  INSERT DATA STRUCTURE
         DC    X'2000'              INSERT DATA FLAG
         DC    H'2'                 REFERENCE NUMBER
         DC    H'0'                 NOT USED
         DC    Y(STE401B-STE401A+6) PRINT COLUMN
         DC    H'4'                 PRINT FIELD LENGTH
         DC    X'8000'              CONVERSION FLAG (BIN TO HEX)
*  STATIC TEXT SUB-STRUCTURE
         DC    X'8400'              STATIC TEXT
         DC    Y(STE402B-STE402A)   STATIC TEXT LENGTH
         DC    Y(STE402A-TXT40A)    STATIC TEXT OFFSET
         DC    Y(STE402A-STE401A+1) PRINT COLUMN
         DC    Y(STE402B-STE402A)   PRINT FIELD LENGTH
         DC    H'0'                 CONVERSION FLAG (CHAR)
*
* STATIC TEXT ENTRY
*
STE401A  DC    C'ICK21040I PRIMARY TRACK '
STE401B  EQU   *
         DC    C'****:'
         DC    C'**** '
STE402A  DC    C'DEFECTIVE, NO ALTERNATE -- DATA LOST.'
STE402B  EQU   *
TXT40B   EQU   *
         EJECT
**********************************************************************
*                                                                    *
* ALTERNATE TRACK DEFECTIVE AND REASSIGNMENT FAILED (SAVED)          *
*                                                                    *
**********************************************************************
*
TXT41    DC    Y(TXT41B-TXT41A)     ENTRY LENGTH
         DC    X'9000'              MESSAGE FLAG
*  SPACING CONTROL SUB-STRUCTURE
TXT41A   DC    X'4000'              SPACING CONTROL FLAG
         DC    H'2'                 SPACING FACTOR
         DC    C'R '                SPACING TYPE
*  STATIC TEXT SUB-STRUCTURE
         DC    X'0400'              STATIC TEXT
         DC    Y(STE411B-STE411A)   STATIC TEXT LENGTH
         DC    Y(STE411A-TXT41A)    STATIC TEXT OFFSET
         DC    H'01'                PRINT COLUMN
         DC    Y(STE411B-STE411A)   PRINT FIELD LENGTH
         DC    H'0'                 CONVERSION FLAG (CHAR)
*  INSERT DATA STRUCTURE
         DC    X'2000'              INSERT DATA FLAG
         DC    H'1'                 REFERENCE NUMBER
         DC    H'0'                 NOT USED
         DC    Y(STE411B-STE411A+1) PRINT COLUMN
         DC    H'4'                 PRINT FIELD LENGTH
         DC    X'8000'              CONVERSION FLAG (BIN TO HEX)
*  INSERT DATA STRUCTURE
         DC    X'2000'              INSERT DATA FLAG
         DC    H'2'                 REFERENCE NUMBER
         DC    H'0'                 NOT USED
         DC    Y(STE411B-STE411A+6) PRINT COLUMN
         DC    H'4'                 PRINT FIELD LENGTH
         DC    X'8000'              CONVERSION FLAG (BIN TO HEX)
*  STATIC TEXT SUB-STRUCTURE
         DC    X'8400'              STATIC TEXT
         DC    Y(STE412B-STE412A)   STATIC TEXT LENGTH
         DC    Y(STE412A-TXT41A)    STATIC TEXT OFFSET
         DC    Y(STE412A-STE411A+1) PRINT COLUMN
         DC    Y(STE412B-STE412A)   PRINT FIELD LENGTH
         DC    H'0'                 CONVERSION FLAG (CHAR)
*
* STATIC TEXT ENTRY
*
STE411A  DC    C'ICK21041I ALTERNATE TRACK '
STE411B  EQU   *
         DC    C'****:'
         DC    C'**** '
STE412A  DC    C'DEFECTIVE -- DATA SAVED.'
STE412B  EQU   *
TXT41B   EQU   *
         EJECT
**********************************************************************
*                                                                    *
* ALTERNATE TRACK DEFECTIVE AND REASSIGNMENT FAILED (LOST)           *
*                                                                    *
**********************************************************************
*
TXT42    DC    Y(TXT42B-TXT42A)     ENTRY LENGTH
         DC    X'9000'              MESSAGE FLAG
*  SPACING CONTROL SUB-STRUCTURE
TXT42A   DC    X'4000'              SPACING CONTROL FLAG
         DC    H'2'                 SPACING FACTOR
         DC    C'R '                SPACING TYPE
*  STATIC TEXT SUB-STRUCTURE
         DC    X'0400'              STATIC TEXT
         DC    Y(STE421B-STE421A)   STATIC TEXT LENGTH
         DC    Y(STE421A-TXT42A)    STATIC TEXT OFFSET
         DC    H'01'                PRINT COLUMN
         DC    Y(STE421B-STE421A)   PRINT FIELD LENGTH
         DC    H'0'                 CONVERSION FLAG (CHAR)
*  INSERT DATA STRUCTURE
         DC    X'2000'              INSERT DATA FLAG
         DC    H'1'                 REFERENCE NUMBER
         DC    H'0'                 NOT USED
         DC    Y(STE421B-STE421A+1) PRINT COLUMN
         DC    H'4'                 PRINT FIELD LENGTH
         DC    X'8000'              CONVERSION FLAG (BIN TO HEX)
*  INSERT DATA STRUCTURE
         DC    X'2000'              INSERT DATA FLAG
         DC    H'2'                 REFERENCE NUMBER
         DC    H'0'                 NOT USED
         DC    Y(STE421B-STE421A+6) PRINT COLUMN
         DC    H'4'                 PRINT FIELD LENGTH
         DC    X'8000'              CONVERSION FLAG (BIN TO HEX)
*  STATIC TEXT SUB-STRUCTURE
         DC    X'8400'              STATIC TEXT
         DC    Y(STE422B-STE422A)   STATIC TEXT LENGTH
         DC    Y(STE422A-TXT42A)    STATIC TEXT OFFSET
         DC    Y(STE422A-STE421A+1) PRINT COLUMN
         DC    Y(STE422B-STE422A)   PRINT FIELD LENGTH
         DC    H'0'                 CONVERSION FLAG (CHAR)
*
* STATIC TEXT ENTRY
*
STE421A  DC    C'ICK21042I ALTERNATE TRACK '
STE421B  EQU   *
         DC    C'****:'
         DC    C'**** '
STE422A  DC    C'DEFECTIVE -- DATA LOST.'
STE422B  EQU   *
TXT42B   EQU   *
         EJECT
**********************************************************************
*                                                                    *
* NO STORAGE AVAILABLE FOR HOLDING RECORD BEING PRESERVED            *
*                                                                    *
**********************************************************************
*
TXT43    DC    Y(TXT43B-TXT43A)     ENTRY LENGTH
         DC    X'9000'              MESSAGE FLAG
*  SPACING CONTROL SUB-STRUCTURE
TXT43A   DC    X'4000'              SPACING CONTROL FLAG
         DC    H'2'                 SPACING FACTOR
         DC    C'R '                SPACING TYPE
*  STATIC TEXT SUB-STRUCTURE
         DC    X'0400'              STATIC TEXT
         DC    Y(STE431B-STE431A)   STATIC TEXT LENGTH
         DC    Y(STE431A-TXT43A)    STATIC TEXT OFFSET
         DC    H'01'                PRINT COLUMN
         DC    Y(STE431B-STE431A)   PRINT FIELD LENGTH
         DC    H'0'                 CONVERSION FLAG (CHAR)
*  INSERT DATA STRUCTURE
         DC    X'2000'              INSERT DATA FLAG
         DC    H'1'                 REFERENCE NUMBER
         DC    H'0'                 NOT USED
         DC    Y(STE431B-STE431A+1) PRINT COLUMN
         DC    H'4'                 PRINT FIELD LENGTH
         DC    X'8000'              CONVERSION FLAG (BIN TO HEX)
*  INSERT DATA STRUCTURE
         DC    X'A000'              INSERT DATA FLAG
         DC    H'2'                 REFERENCE NUMBER
         DC    H'0'                 NOT USED
         DC    Y(STE431B-STE431A+6) PRINT COLUMN
         DC    H'4'                 PRINT FIELD LENGTH
         DC    X'8000'              CONVERSION FLAG (BIN TO HEX)
*
* STATIC TEXT ENTRY
*
STE431A  DC    C'ICK31043I NO STORAGE AVAILABLE TO HOLD RECORD '
         DC    C'BEING PRESERVED, TRACK '
STE431B  EQU   *
         DC    C'****:'
         DC    C'****'
TXT43B   EQU   *
         EJECT
**********************************************************************
*                                                                    *
* UNABLE TO PRESERVE DATA DUE TO INABILITY TO READ IT                *
*                                                                    *
**********************************************************************
*
TXT44    DC    Y(TXT44B-TXT44A)     ENTRY LENGTH
         DC    X'9000'              MESSAGE FLAG
*  SPACING CONTROL SUB-STRUCTURE
TXT44A   DC    X'4000'              SPACING CONTROL FLAG
         DC    H'2'                 SPACING FACTOR
         DC    C'R '                SPACING TYPE
*  STATIC TEXT SUB-STRUCTURE
         DC    X'0400'              STATIC TEXT
         DC    Y(STE441B-STE441A)   STATIC TEXT LENGTH
         DC    Y(STE441A-TXT44A)    STATIC TEXT OFFSET
         DC    H'01'                PRINT COLUMN
         DC    Y(STE441B-STE441A)   PRINT FIELD LENGTH
         DC    H'0'                 CONVERSION FLAG (CHAR)
*  INSERT DATA STRUCTURE
         DC    X'2000'              INSERT DATA FLAG
         DC    H'1'                 REFERENCE NUMBER
         DC    H'0'                 NOT USED
         DC    Y(STE441B-STE441A+1) PRINT COLUMN
         DC    H'4'                 PRINT FIELD LENGTH
         DC    X'8000'              CONVERSION FLAG (BIN TO HEX)
*  INSERT DATA STRUCTURE
         DC    X'2000'              INSERT DATA FLAG
         DC    H'2'                 REFERENCE NUMBER
         DC    H'0'                 NOT USED
         DC    Y(STE441B-STE441A+6) PRINT COLUMN
         DC    H'4'                 PRINT FIELD LENGTH
         DC    X'8000'              CONVERSION FLAG (BIN TO HEX)
*  INSERT DATA STRUCTURE
         DC    X'A000'              INSERT DATA FLAG
         DC    H'3'                 REFERENCE NUMBER
         DC    H'0'                 NOT USED
         DC    Y(STE442A-STE441A+1) PRINT COLUMN
         DC    H'5'                 PRINT FIELD LENGTH
         DC    X'10A0'              CONVERSION FLAG (BIN TO DEC)
*
* STATIC TEXT ENTRY
*
STE441A  DC    C'ICK21044I UNABLE TO PRESERVE -- '
         DC    C'UNABLE TO READ TRACK '
STE441B  EQU   *
         DC    C'****:'
         DC    C'****, '
STE442A  DC    C'*****.'            RECORD NUMBER
STE442B  EQU   *
TXT44B   EQU   *
         EJECT
**********************************************************************
*                                                                    *
* UNABLE TO PRESERVE RECORD DUE TO TRACK BEING MARKED DEFECTIVE      *
*                                                                    *
**********************************************************************
*
TXT45    DC    Y(TXT45B-TXT45A)     ENTRY LENGTH
         DC    X'9000'              MESSAGE FLAG
*  SPACING CONTROL SUB-STRUCTURE
TXT45A   DC    X'4000'              SPACING CONTROL FLAG
         DC    H'2'                 SPACING FACTOR
         DC    C'R '                SPACING TYPE
*  STATIC TEXT SUB-STRUCTURE
         DC    X'0400'              STATIC TEXT
         DC    Y(STE451B-STE451A)   STATIC TEXT LENGTH
         DC    Y(STE451A-TXT45A)    STATIC TEXT OFFSET
         DC    H'01'                PRINT COLUMN
         DC    Y(STE451B-STE451A)   PRINT FIELD LENGTH
         DC    H'0'                 CONVERSION FLAG (CHAR)
*  INSERT DATA STRUCTURE
         DC    X'2000'              INSERT DATA FLAG
         DC    H'1'                 REFERENCE NUMBER
         DC    H'0'                 NOT USED
         DC    Y(STE451B-STE451A+1) PRINT COLUMN
         DC    H'4'                 PRINT FIELD LENGTH
         DC    X'8000'              CONVERSION FLAG (BIN TO HEX)
*  INSERT DATA STRUCTURE
         DC    X'2000'              INSERT DATA FLAG
         DC    H'2'                 REFERENCE NUMBER
         DC    H'0'                 NOT USED
         DC    Y(STE451B-STE451A+6) PRINT COLUMN
         DC    H'4'                 PRINT FIELD LENGTH
         DC    X'8000'              CONVERSION FLAG (BIN TO HEX)
*  STATIC TEXT SUB-STRUCTURE
         DC    X'8400'              STATIC TEXT
         DC    Y(STE452B-STE452A)   STATIC TEXT LENGTH
         DC    Y(STE452A-TXT45A)    STATIC TEXT OFFSET
         DC    Y(STE452A-STE451A+1) PRINT COLUMN
         DC    Y(STE452B-STE452A)   PRINT FIELD LENGTH
         DC    H'0'                 CONVERSION FLAG (CHAR)
*
* STATIC TEXT ENTRY
*
STE451A  DC    C'ICK21045I UNABLE TO PRESERVE -- TRACK '
STE451B  EQU   *
         DC    C'****:'
         DC    C'**** '
STE452A  DC    C'MARKED DEFECTIVE.'
STE452B  EQU   *
TXT45B   EQU   *
         EJECT
**********************************************************************
*                                                                    *
* UNABLE TO WRITE FORMAT-4 DSCB                                      *
*                                                                    *
**********************************************************************
*
TXT46    DC    Y(TXT46B-TXT46A)     ENTRY LENGTH
         DC    X'9000'              MESSAGE FLAG
*  SPACING CONTROL SUB-STRUCTURE
TXT46A   DC    X'4000'              SPACING CONTROL FLAG
         DC    H'2'                 SPACING FACTOR
         DC    C'R '                SPACING TYPE
*  STATIC TEXT SUB-STRUCTURE
         DC    X'0400'              STATIC TEXT
         DC    Y(STE461B-STE461A)   STATIC TEXT LENGTH
         DC    Y(STE461A-TXT46A)    STATIC TEXT OFFSET
         DC    H'01'                PRINT COLUMN
         DC    Y(STE461B-STE461A)   PRINT FIELD LENGTH
         DC    H'0'                 CONVERSION FLAG (CHAR)
*  INSERT DATA STRUCTURE
         DC    X'2000'              INSERT DATA FLAG
         DC    H'1'                 REFERENCE NUMBER
         DC    H'0'                 NOT USED
         DC    Y(STE461B-STE461A+1) PRINT COLUMN
         DC    H'4'                 PRINT FIELD LENGTH
         DC    X'8000'              CONVERSION FLAG (BIN TO HEX)
*  INSERT DATA STRUCTURE
         DC    X'A000'              INSERT DATA FLAG
         DC    H'2'                 REFERENCE NUMBER
         DC    H'0'                 NOT USED
         DC    Y(STE461B-STE461A+6) PRINT COLUMN
         DC    H'4'                 PRINT FIELD LENGTH
         DC    X'8000'              CONVERSION FLAG (BIN TO HEX)
*
* STATIC TEXT ENTRY
*
STE461A  DC    C'ICK31046I UNABLE TO WRITE FORMAT-4 DSCB AT '
STE461B  EQU   *
         DC    C'****:'
         DC    C'**** '
TXT46B   EQU   *
         EJECT
**********************************************************************
*                                                                    *
* UNABLE TO PRESERVE RECORD BECAUSE OF INABILITY TO WRITE TRACK      *
*                                                                    *
**********************************************************************
*
TXT47    DC    Y(TXT47B-TXT47A)     ENTRY LENGTH
         DC    X'9000'              MESSAGE FLAG
*  SPACING CONTROL SUB-STRUCTURE
TXT47A   DC    X'4000'              SPACING CONTROL FLAG
         DC    H'2'                 SPACING FACTOR
         DC    C'R '                SPACING TYPE
*  STATIC TEXT SUB-STRUCTURE
         DC    X'0400'              STATIC TEXT
         DC    Y(STE471B-STE471A)   STATIC TEXT LENGTH
         DC    Y(STE471A-TXT47A)    STATIC TEXT OFFSET
         DC    H'01'                PRINT COLUMN
         DC    Y(STE471B-STE471A)   PRINT FIELD LENGTH
         DC    H'0'                 CONVERSION FLAG (CHAR)
*  INSERT DATA STRUCTURE
         DC    X'2000'              INSERT DATA FLAG
         DC    H'1'                 REFERENCE NUMBER
         DC    H'0'                 NOT USED
         DC    Y(STE471B-STE471A+1) PRINT COLUMN
         DC    H'4'                 PRINT FIELD LENGTH
         DC    X'8000'              CONVERSION FLAG (BIN TO HEX)
*  INSERT DATA STRUCTURE
         DC    X'A000'              INSERT DATA FLAG
         DC    H'2'                 REFERENCE NUMBER
         DC    H'0'                 NOT USED
         DC    Y(STE471B-STE471A+6) PRINT COLUMN
         DC    H'4'                 PRINT FIELD LENGTH
         DC    X'8000'              CONVERSION FLAG (BIN TO HEX)
*
* STATIC TEXT ENTRY
*
STE471A  DC    C'ICK21047I UNABLE TO PRESERVE -- '
         DC    C'UNABLE TO WRITE TRACK '
STE471B  EQU   *
         DC    C'****:'
         DC    C'**** '
TXT47B   EQU   *
         EJECT
***********************************************************************
*                                                                     *
* PACK BECOMES NOT IPLABLE                                            *
*                                                                     *
***********************************************************************
*
TXT48    DC    Y(TXT48B-TXT48A)     ENTRY LENGTH
         DC    X'9000'              MESSAGE FLAG
*  SPACING CONTROL SUB-STRUCTURE
TXT48A   DC    X'4000'              SPACING CONTROL FLAG
         DC    H'2'                 SPACING FACTOR
         DC    C'R '                SPACING TYPE
*  STATIC TEXT SUB-STRUCTURE
         DC    X'8400'              STATIC TEXT END-OF-LIST
         DC    Y(STE481B-STE481A)   STATIC TEXT LENGTH
         DC    Y(STE481A-TXT48A)    STATIC TEXT OFFSET
         DC    H'01'                PRINT COLUMN
         DC    Y(STE481B-STE481A)   PRINT FIELD LENGTH
         DC    H'0'                 CONVERSION FLAG (CHAR)
*
* STATIC TEXT ENTRY
*
STE481A  DC    C'ICK21048I CYL-0 TRK-0 DEFECTIVE, PACK UNUSABLE'
         DC    C' FOR IPL.'
STE481B  EQU   *
TXT48B   EQU   *
         EJECT
***********************************************************************
*                                                                     *
* CUU SPECIFIED FOR VOLUME MOUNTED ON-LINE                            *
*                                                                     *
***********************************************************************
*
TXT49    DC    Y(TXT49B-TXT49A)     ENTRY LENGTH
         DC    X'9000'              MESSAGE FLAG
*  SPACING CONTROL SUB-STRUCTURE
TXT49A   DC    X'4000'              SPACING CONTROL FLAG
         DC    H'2'                 SPACING FACTOR
         DC    C'R '                SPACING TYPE
*  STATIC TEXT SUB-STRUCTURE
         DC    X'8400'              STATIC TEXT END-OF-LIST
         DC    Y(STE491B-STE491A)   STATIC TEXT LENGTH
         DC    Y(STE491A-TXT49A)    STATIC TEXT OFFSET
         DC    H'01'                PRINT COLUMN
         DC    Y(STE491B-STE491A)   PRINT FIELD LENGTH
         DC    H'0'                 CONVERSION FLAG (CHAR)
*
* STATIC TEXT ENTRY
*
STE491A  DC    C'ICK31049I UNITADDRESS SPECIFIED FOR VOLUME'
         DC    C' MOUNTED ON-LINE.'
STE491B  EQU   *
TXT49B   EQU   *
         EJECT
***********************************************************************
*                                                                     *
* VTOC LOCATION SPECIFIED FOR MSS STAGING PACK -- IGNORED             *
*                                                                     *
***********************************************************************
*
TXT50    DC    Y(TXT50B-TXT50A)     ENTRY LENGTH
         DC    X'9000'              MESSAGE FLAG
*  SPACING CONTROL SUB-STRUCTURE
TXT50A   DC    X'4000'              SPACING CONTROL FLAG
         DC    H'2'                 SPACING FACTOR
         DC    C'R '                SPACING TYPE
*  STATIC TEXT SUB-STRUCTURE
         DC    X'8400'              STATIC TEXT END-OF-LIST
         DC    Y(STE501B-STE501A)   STATIC TEXT LENGTH
         DC    Y(STE501A-TXT50A)    STATIC TEXT OFFSET
         DC    H'01'                PRINT COLUMN
         DC    Y(STE501B-STE501A)   PRINT FIELD LENGTH
         DC    H'0'                 CONVERSION FLAG (CHAR)
*
* STATIC TEXT ENTRY
*
STE501A  DC    C'ICK11050I VTOC LOCATION SPECIFIED FOR MSS STAGING PAC'
         DC    C'K -- IGNORED.'
STE501B  EQU   *
TXT50B   EQU   *
         EJECT
***********************************************************************
*                                                                     *
* LABELS PARAMETER SPECIFIED FOR MSS STAGING PACK -- IGNORED          *
*                                                                     *
***********************************************************************
*
TXT51    DC    Y(TXT51B-TXT51A)     ENTRY LENGTH
         DC    X'9000'              MESSAGE FLAG
*  SPACING CONTROL SUB-STRUCTURE
TXT51A   DC    X'4000'              SPACING CONTROL FLAG
         DC    H'2'                 SPACING FACTOR
         DC    C'R '                SPACING TYPE
*  STATIC TEXT SUB-STRUCTURE
         DC    X'8400'              STATIC TEXT END-OF-LIST
         DC    Y(STE511B-STE511A)   STATIC TEXT LENGTH
         DC    Y(STE511A-TXT51A)    STATIC TEXT OFFSET
         DC    H'01'                PRINT COLUMN
         DC    Y(STE511B-STE511A)   PRINT FIELD LENGTH
         DC    H'0'                 CONVERSION FLAG (CHAR)
*
* STATIC TEXT ENTRY
*
STE511A  DC    C'ICK11051I LABELS PARAMETER SPECIFIED FOR MSS STAGING '
         DC    C'PACK -- IGNORED.'
STE511B  EQU   *
TXT51B   EQU   *
         EJECT
***********************************************************************
*                                                                     *
* MINIMAL INITIALIZATION NOT PERMITTED FOR MSS STAGING PACK           *
*                                                                     *
***********************************************************************
*
TXT52    DC    Y(TXT52B-TXT52A)     ENTRY LENGTH
         DC    X'9000'              MESSAGE FLAG
*  SPACING CONTROL SUB-STRUCTURE
TXT52A   DC    X'4000'              SPACING CONTROL FLAG
         DC    H'2'                 SPACING FACTOR
         DC    C'R '                SPACING TYPE
*  STATIC TEXT SUB-STRUCTURE
         DC    X'8400'              STATIC TEXT END-OF-LIST
         DC    Y(STE521B-STE521A)   STATIC TEXT LENGTH
         DC    Y(STE521A-TXT52A)    STATIC TEXT OFFSET
         DC    H'01'                PRINT COLUMN
         DC    Y(STE521B-STE521A)   PRINT FIELD LENGTH
         DC    H'0'                 CONVERSION FLAG (CHAR)
*
* STATIC TEXT ENTRY
*
STE521A  DC    C'ICK31052I MINIMAL INITIALIZATION NOT PERMITTED FOR MS'
         DC    C'S STAGING PACK.'
STE521B  EQU   *
TXT52B   EQU   *
         SPACE
         END
