***********************************************************************
*                                                                     *
* MODULE NAME - ICKTSDV0                                              *
*                                                                     *
* DESCRIPTIVE NAME - STATIC TEXT MODULE FOR THE DEVICE ADAPTER        *
*                                                                     *
* FUNCTION - CONTAINS NO EXECUTABLE CODE, ONLY STATIC TEXT ENTRIES    *
*            FOR THE DEVICE ADAPTERS                                  *
*            THIS MODULE IS LOADED BY ICKTP05 WHEN A STATIC REPORT    *
*            REQUEST IS MADE.                                         *
*                                                                     *
* RELEASE STATUS  -  RELEASE-1 VERSION-0                              *
*                                                                     *
* NOTES - NONE                                                        *
*                                                                     *
*   DEPENDENCIES - NONE                                               *
*   RESTRICTIONS - NONE                                               *
*   REGISTER CONVENTIONS - NONE                                       *
*   PATCH AREA - NONE                                                 *
*                                                                     *
* MODULE TYPE - TABLES                                                *
*                                                                     *
*   PROCESSOR - ASSEMBLER                                             *
*   MODULE SIZE - 52 BYTES                                            *
*   ATTRIBUTES - READ ONLY                                            *
*                                                                     *
* ENTRY POINT - NA                                                    *
*                                                                     *
* EXIT NORMAL - NA                                                    *
*                                                                     *
* EXIT ERROR  - NA                                                    *
*                                                                     *
* EXTERNAL REFERENCES - NA                                            *
*                                                                     *
* TABLES - NA                                                         *
*                                                                     *
* MACROS - NA                                                         *
*                                                                     *
* CHANGE ACTIVITY - NONE                                      @G840B00*
*                                                                     *
***********************************************************************
*                                                                     *
ICKTSDV0 CSECT
***********************************************************************
*                                                                     *
* THIS SECTION CONTAINS THE INDICES TO REACH AN ENTRY                 *
*                                                                     *
***********************************************************************
*                                                                     *
***********************************************************************
INDEX    DC    Y((INDEXEND-INDEX1)/2) COUNT OF ENTRIES
INDEX1   DC    Y(TXT1-INDEX)        EQUIPMENT CHECK
INDEX2   DC    Y(TXT2-INDEX)        OPERATOR DID NOT READY DEVICE
INDEX3   DC    Y(TXT3-INDEX)        DEVICE ALREADY IN USE
INDEX4   DC    Y(TXT4-INDEX)        INVALID DEVICE TYPE FOR FUNCTION
INDEX5   DC    Y(TXT5-INDEX)        OPERATOR DID NOT SET WRITE MODE
INDEX6   DC    Y(TXT6-INDEX)        DEVICTEYPE MISSING OR ERRONEOUS
         SPACE
INDEXEND  EQU *    PLACE ALL ENTRIES BEFORE THIS POINT
         EJECT
*                                                                     *
***********************************************************************
*                                                                     *
* THIS SECTION CONTAINS THE TEXT ENTRIES                              *
*                                                                     *
***********************************************************************
         SPACE
***********************************************************************
*                                                                     *
* EQUIPMENT CHECK                                                     *
*                                                                     *
***********************************************************************
*                                                                     *
TXT1     DC    Y(TXT1B-TXT1A)       ENTRY LENGTH
         DC    X'9000'              MESSAGE FLAG
*  SPACING CONTROL STRUCTURE
*
TXT1A    DC    X'4000'              SPACE CONTROL
         DC    H'2'                 SPACING FACTOR
         DC    C'R '                SPACING TYPE
*  STATIC TEXT SUBSTRUCTURE
         DC    X'8400'              STATIC FLAG END OF LIST
         DC    Y(STE11B-STE11A)     STATIC TEXT LENGTH
         DC    Y(STE11A-TXT1A)      STATIC TEXT OFFSET
         DC    H'1'                 PRINT COLUMN
         DC    Y(STE11B-STE11A)     PRINT FIELD LENGTH
         DC    H'0'                 CONVERSION FLAG (CHAR)
*
* STATIC TEXT ENTRIES
*
STE11A   DC    C'ICK30701I EQUIPMENT CHECK '
STE11B   EQU   *
TXT1B    EQU   *
         EJECT
***********************************************************************
*                                                                     *
* OPERATOR DID NOT READY DEVICE                                       *
*                                                                     *
***********************************************************************
*                                                                     *
TXT2     DC    Y(TXT2B-TXT2A)       ENTRY LENGTH
         DC    X'9000'              MESSAGE FLAG
*  SPACING CONTROL STRUCTURE
*
TXT2A    DC    X'4000'              SPACE CONTROL
         DC    H'2'                 SPACING FACTOR
         DC    C'R '                SPACING TYPE
*  STATIC TEXT SUBSTRUCTURE
         DC    X'8400'              STATIC FLAG END OF LIST
         DC    Y(STE21B-STE21A)     STATIC TEXT LENGTH
         DC    Y(STE21A-TXT2A)      STATIC TEXT OFFSET
         DC    H'1'                 PRINT COLUMN
         DC    Y(STE21B-STE21A)     PRINT FIELD LENGTH
         DC    H'0'                 CONVERSION FLAG (CHAR)
*
* STATIC TEXT ENTRIES
*
STE21A   DC    C'ICK30702I OPERATOR DID NOT READY DEVICE'
STE21B   EQU   *
TXT2B    EQU   *
         EJECT
***********************************************************************
*                                                                     *
* DEVICE ALREADY IN USE                                               *
*                                                                     *
***********************************************************************
*                                                                     *
TXT3     DC    Y(TXT3B-TXT3A)       ENTRY LENGTH
         DC    X'9000'              MESSAGE FLAG
*  SPACING CONTROL STRUCTURE
*
TXT3A    DC    X'4000'              SPACE CONTROL
         DC    H'2'                 SPACING FACTOR
         DC    C'R '                SPACING TYPE
*  STATIC TEXT SUBSTRUCTURE
         DC    X'8400'              STATIC FLAG END OF LIST
         DC    Y(STE31B-STE31A)     STATIC TEXT LENGTH
         DC    Y(STE31A-TXT3A)      STATIC TEXT OFFSET
         DC    H'1'                 PRINT COLUMN
         DC    Y(STE31B-STE31A)     PRINT FIELD LENGTH
         DC    H'0'                 CONVERSION FLAG (CHAR)
*
* STATIC TEXT ENTRIES
*
STE31A   DC    C'ICK30703I DEVICE ALREADY IN USE'
STE31B   EQU   *
TXT3B    EQU   *
         EJECT
***********************************************************************
*                                                                     *
* INVALID DEVICE TYPE FOR FUNCTION                                    *
*                                                                     *
***********************************************************************
*                                                                     *
TXT4     DC    Y(TXT4B-TXT4A)       ENTRY LENGTH
         DC    X'9000'              MESSAGE FLAG
*  SPACING CONTROL STRUCTURE
*
TXT4A    DC    X'4000'              SPACE CONTROL
         DC    H'2'                 SPACING FACTOR
         DC    C'R '                SPACING TYPE
*  STATIC TEXT SUBSTRUCTURE
         DC    X'8400'              STATIC FLAG END OF LIST
         DC    Y(STE41B-STE41A)     STATIC TEXT LENGTH
         DC    Y(STE41A-TXT4A)      STATIC TEXT OFFSET
         DC    H'1'                 PRINT COLUMN
         DC    Y(STE41B-STE41A)     PRINT FIELD LENGTH
         DC    H'0'                 CONVERSION FLAG (CHAR)
*
* STATIC TEXT ENTRIES
*
STE41A   DC    C'ICK30704I INVALID DEVICE-TYPE FOR FUNCTION'
STE41B   EQU   *
TXT4B    EQU   *
         EJECT
***********************************************************************
*                                                                     *
* OPERATOR DID NOT SET WRITE MODE                                     *
*                                                                     *
***********************************************************************
*                                                                     *
TXT5     DC    Y(TXT5B-TXT5A)       ENTRY LENGTH
         DC    X'9000'              MESSAGE FLAG
*  SPACING CONTROL STRUCTURE
*
TXT5A    DC    X'4000'              SPACE CONTROL
         DC    H'2'                 SPACING FACTOR
         DC    C'R '                SPACING TYPE
*  STATIC TEXT SUBSTRUCTURE
         DC    X'8400'              STATIC FLAG END OF LIST
         DC    Y(STE51B-STE51A)     STATIC TEXT LENGTH
         DC    Y(STE51A-TXT5A)      STATIC TEXT OFFSET
         DC    H'1'                 PRINT COLUMN
         DC    Y(STE51B-STE51A)     PRINT FIELD LENGTH
         DC    H'0'                 CONVERSION FLAG (CHAR)
*
* STATIC TEXT ENTRIES
*
STE51A   DC    C'ICK30705I OPERATOR DID NOT SET DEVICE TO WRITE-MODE'
STE51B   EQU   *
TXT5B    EQU   *
         EJECT
***********************************************************************
*                                                                     *
* DEVICETYPE PARAMETER MISSING OR ERRONEOUS                           *
*                                                                     *
***********************************************************************
*                                                                     *
TXT6     DC    Y(TXT6B-TXT6A)       ENTRY LENGTH
         DC    X'9000'              MESSAGE FLAG
*  SPACING CONTROL STRUCTURE
*
TXT6A    DC    X'4000'              SPACE CONTROL
         DC    H'2'                 SPACING FACTOR
         DC    C'R '                SPACING TYPE
*  STATIC TEXT SUBSTRUCTURE
         DC    X'8400'              STATIC FLAG END OF LIST
         DC    Y(STE61B-STE61A)     STATIC TEXT LENGTH
         DC    Y(STE61A-TXT6A)      STATIC TEXT OFFSET
         DC    H'1'                 PRINT COLUMN
         DC    Y(STE61B-STE61A)     PRINT FIELD LENGTH
         DC    H'0'                 CONVERSION FLAG (CHAR)
*
* STATIC TEXT ENTRIES
*
STE61A   DC    C'ICK30706I DEVICETYPE PARAMETER MISSING OR ERRONEOUS'
STE61B   EQU   *
TXT6B    EQU   *
         SPACE
         END
