***********************************************************************
*                                                                     *
* MODULE NAME - ICKTSEF0 - STATIC TEXT MODULE FOR ELEMENTARY          *
*                          FACILITIES MESSAGES.                       *
*                                                                     *
* DESCRIPTIVE NAME - STATIC TEXT MODULE FOR THE ELEMENTARY FACILITES  *
*                    FUNCTIONS.                                       *
*                                                                     *
* STATUS - RELEASE-1 VERSION-0                                        *
*                                                                     *
*                                                                     *
* FUNCTION - CONTAINS NO EXECUTABLE CODE, ONLY STATIC TEXT ENTRIES    *
*            FOR THE ELEMENTARY FACILITIES.                           *
*            THIS MODULE IS LOADED BY ICKTP05 WHEN A STATIC REPORT    *
*            REQUEST IS MADE.                                         *
*                                                                     *
* NOTES - NONE                                                        *
*                                                                     *
*   DEPENDENCIES - NONE                                               *
*   RESTRICTIONS - NONE                                               *
*   REGISTER CONVENTIONS - NONE                                       *
*   PATCH AREA - NONE                                                 *
*                                                                     *
* MODULE TYPE - TABLES                                                *
*                                                                     *
*   PROCESSOR - ASSEMBLER                                             *
*   MODULE SIZE - 2620 BYTES                                          *
*   ATTRIBUTES - READ ONLY                                            *
*                                                                     *
* ENTRY POINT - NA                                                    *
*                                                                     *
* EXIT NORMAL - NA                                                    *
*                                                                     *
* EXIT ERROR  - NA                                                    *
*                                                                     *
* EXTERNAL REFERENCES - NA                                            *
*                                                                     *
* TABLES - NA                                                         *
*                                                                     *
* MACROS - NA                                                         *
*                                                                     *
* CHANGE ACTIVITY - NONE                                      @G840B00*
*                                                                     *
***********************************************************************
         EJECT
ICKTSEF0 CSECT
         SPACE 2
***********************************************************************
*                                                                     *
* THIS SECTION CONTAINS THE INDICES TO REACH AN ENTRY                 *
*                                                                     *
***********************************************************************
         SPACE 2
INDEX    DC    Y((INDEXEND-INDEX1)/2)    COUNT OF ENTRIES
         SPACE
INDEX1   DC    Y(TXT1-INDEX)        NO VOL SER VERIFICATION
INDEX2   DC    Y(TXT2-INDEX)        NO OWNER-ID VERIFICATION
INDEX3   DC    Y(TXT3-INDEX)        NO VTOC ON VOLUME
INDEX4   DC    Y(TXT4-INDEX)        UNABLE TO VERIFY AUTHORIZATION
INDEX5   DC    Y(TXT5-INDEX)        NO DATA SET PURGING
INDEX6   DC    Y(TXT6-INDEX)        UNEXPIRED DATA SET FOUND
INDEX7   DC    Y(TXT7-INDEX)         RESERVED FOR WTO MESSAGES
INDEX8   DC    Y(TXT8-INDEX)         RESERVED FOR WTO MESSAGES
INDEX9   DC    Y(TXT9-INDEX)        VOLUME CONTAINS VSAM DATA SETS
INDEX10  DC    Y(TXT10-INDEX)       IMPROPER RACF ACCESS AUTHORITY
INDEX11  DC    H'-1'                NOT USED
INDEX12  DC    H'-1'                NOT USED
INDEX13  DC    H'-1'                NOT USED
INDEX14  DC    H'-1'                NOT USED
INDEX15  DC    H'-1'                NOT USED
INDEX16  DC    H'-1'                NOT USED
INDEX17  DC    H'-1'                NOT USED
INDEX18  DC    Y(TXT18-INDEX)       NO PACK MAP SPACE AVAILABLE
INDEX19  DC    H'-1'                NOT USED
INDEX20  DC    Y(TXT20-INDEX)       DEFECT TRACK LIST FOR VOLUME
INDEX21  DC    Y(TXT21-INDEX)       FOLLOWING PRIMARY TRACKS DEFECT
INDEX22  DC    Y(TXT22-INDEX)       FOLLOWING ALTERNATES TRACKS DEFEC
INDEX23  DC    Y(TXT23-INDEX)       CCHH OF TRACK
INDEX24  DC    Y(TXT24-INDEX)       CCHH OF TRACK ALT.
INDEX25  DC    Y(TXT25-INDEX)       CCHH OF TRACK PRIMARY
INDEX26  DC    Y(TXT26-INDEX)       CCHH OF TRACK PRIMARY
INDEX27  DC    Y(TXT27-INDEX)       NO DEFECTIVE TRACKS FOUND
INDEX28  DC    Y(TXT28-INDEX)       NO DEFECTIVE PRIMARY TRACKS
INDEX29  DC    Y(TXT29-INDEX)       NO DEFECTIVE ALTERNATES TRKS/
INDEX30  DC    Y(TXT30-INDEX)       FIRST DETAILED PACK MAP LINE
INDEX31  DC    Y(TXT31-INDEX)       SECOND DETAILED PACK MAP LINE
INDEX32  DC    Y(TXT32-INDEX)       THIS VOLUME CONTAINS
INDEX33  DC    Y(TXT33-INDEX)       VTOC LOCATION FOR THIS PACK
INDEX34  DC    H'-1'                NOT USED
INDEX35  DC    H'-1'                NOT USED
INDEX36  DC    H'-1'                NOT USED
INDEX37  DC    H'-1'                NOT USED
INDEX38  DC    H'-1'                NOT USED
INDEX39  DC    H'-1'                NOT USED
INDEX40  DC    Y(TXT40-INDEX)       UNABLE TO READ VOLUME LABEL
INDEX41  DC    Y(TXT41-INDEX)       UNABLE TO OPEN IPL DATA SET
INDEX42  DC    Y(TXT42-INDEX)       IPL INPUT RECORDS IMPROPER (1)
INDEX43  DC    Y(TXT43-INDEX)       IPL INPUT RECORDS IMPROPER (2)
INDEX44  DC    Y(TXT44-INDEX)       UNABLE TO WRITE IPL BOOTSTRAP R (1)
INDEX45  DC    Y(TXT45-INDEX)       UNABLE TO WRITE IPL BOOTSTRAP R (2)
INDEX46  DC    Y(TXT46-INDEX)       UNABLE TO WRITE IPL PROGRAM REC
INDEX47  DC    Y(TXT47-INDEX)       SPECIFIED IPL PROGRAM LENGTH WRONG
INDEX48  DC    Y(TXT48-INDEX)       IPL PROGRAM INPUT CONTAINS ONLY END
INDEX49  DC    Y(TXT49-INDEX)       OPERATOR REFUSED PURGE PERMISSION
         SPACE
INDEXEND EQU   *     (PLACE ALL ENTRIES ABOVE HERE)
         EJECT
***********************************************************************
*                                                                     *
* THIS SECTION CONTAINS THE TEXT ENTRIES                              *
*                                                                     *
***********************************************************************
         SPACE 2
***********************************************************************
*                                                                     *
* NO VOLUME SERIAL VERIFICATION                                       *
*                                                                     *
***********************************************************************
*                                                                     *
TXT1     DC    Y(TXT1B-TXT1A)       ENTRY LENGTH
         DC    X'9000'              MESSAGE FLAG
*  SPACING CONTROL STRUCTURE
TXT1A    DC    X'4000'              SPACE CONTROL
         DC    H'2'                 SPACING FACTOR
         DC    C'R '                SPACING TYPE
*  STATIC TEXT SUBSTRUCTURE
         DC    X'8400'              STATIC FLAG END OF LIST
         DC    Y(STE11B-STE11A)     STATIC TEXT LENGTH
         DC    Y(STE11A-TXT1A)      STATIC TEXT OFFSET
         DC    H'1'                 PRINT COLUMN
         DC    Y(STE11B-STE11A)     PRINT FIELD LENGTH
         DC    H'0'                 CONVERSION FLAG (CHAR)
*  STATIC TEXT ENTRY
STE11A   DC    C'ICK31300I VERIFICATION FAILED: '
         DC    C'VOLUME-SERIAL WRONG.'
STE11B   EQU   *
TXT1B    EQU   *
         EJECT
***********************************************************************
*                                                                     *
* OWNER-ID VERIFICATION FAILED                                        *
*                                                                     *
***********************************************************************
*
TXT2     DC    Y(TXT2B-TXT2A)       ENTRY LENGTH
         DC    X'9000'              MESSAGE FLAG
*  SPACING CONTOL SUBSTRUCTURE
TXT2A    DC    X'4000'              SPACING CONTROL FLAG
         DC    H'2'                 SPACING FACTOR
         DC    C'R '                SPACING TYPE
*  STATIC TEXT SUB-STRUCTURE
         DC    X'8400'              STATIC TEXT END OF LIST
         DC    Y(STE21B-STE21A)     STATIC TEXT LENGTH
         DC    Y(STE21A-TXT2A)      STATIC TEXT OFFSET
         DC    H'1'                 PRINT COLUMN
         DC    Y(STE21B-STE21A)     PRINT FIELD LENGTH
         DC    H'0'                 CONVERSION FLAG (CHAR)
*  STATIC TEXT ENTRY
STE21A   DC    C'ICK31301I VERIFICATION FAILED: '
         DC    C'OWNER-ID WRONG.'
STE21B   EQU   *
TXT2B    EQU   *
         EJECT
***********************************************************************
*                                                                     *
* NO VTOC FOUND ON VOLUME                                             *
*                                                                     *
***********************************************************************
*
TXT3     DC    Y(TXT3B-TXT3A)       ENTRY LENGTH
         DC    X'9000'              MESSAGE FLAG
*  SPACING CONTROL STRUCTURE
*
TXT3A    DC    X'4000'              SPACE CONTROL
         DC    H'2'                 SPACING FACTOR
         DC    C'R '                SPACING TYPE
*  STATIC TEXT SUB-STRUCTURE
         DC    X'8400'              STATIC TEXT END OF LIST
         DC    Y(STE31B-STE31A)     STATIC TEXT LENGTH
         DC    Y(STE31A-TXT3A)      STATIC TEXT OFFSET
         DC    H'1'                 PRINT COLUMN
         DC    Y(STE31B-STE31A)     PRINT FIELD LENGTH
         DC    H'0'                 CONVERSION FLAG (CHAR)
*  STATIC TEXT ENTRY
STE31A   DC    C'ICK01302I NO VTOC FOUND ON VOLUME,'
         DC    C' INITIALIZATION CONTINUES.'
STE31B   EQU   *
TXT3B    EQU   *
         EJECT
**********************************************************************
*                                                                    *
* UNABLE TO VERIFY AUTHORIZATION FOR PROTECTED DATA SET              *
*                                                                    *
**********************************************************************
*
TXT4     DC    Y(TXT4B-TXT4A)       ENTRY LENGTH
         DC    X'9000'              MESSAGE FLAG
*  SPACING CONTROL STRUCTURE
TXT4A    DC    X'4000'              SPACE CONTROL
         DC    H'2'                 SPACING FACTOR
         DC    C'R '                SPACING TYPE
*  STATIC TEXT SUB-STRUCTURE
         DC    X'8400'              STATIC TEXT END OF LIST
         DC    Y(STE41B-STE41A)     STATIC TEXT LENGTH
         DC    Y(STE41A-TXT4A)      STATIC TEXT OFFSET
         DC    H'1'                 PRINT COLUMN
         DC    Y(STE41B-STE41A)     PRINT FIELD LENGTH
         DC    H'0'                 CONVERSION FLAG (CHAR)
*  STATIC TEXT ENTRY
STE41A   DC    C'ICK31303I UNABLE TO VERIFY AUTHORIZATION FOR'
         DC    C' PROTECTED DATA SET'
STE41B   EQU   *
TXT4B    EQU   *
         EJECT
**********************************************************************
*                                                                    *
* SYSTEM OPERATOR DID NOT CONFIRM DATA SET PURGING                   *
*                                                                    *
**********************************************************************
*
TXT5     DC    Y(TXT5B-TXT5A)       ENTRY LENGTH
         DC    X'9000'              MESSAGE FLAG
*  SPACING CONTROL STRUCTURE
TXT5A    DC    X'4000'              SPACE CONTROL
         DC    H'2'                 SPACING FACTOR
         DC    C'R '                SPACING TYPE
*  STATIC TEXT SUB-STRUCTURE
         DC    X'8400'              STATIC TEXT END OF LIST
         DC    Y(STE51B-STE51A)     STATIC TEXT LENGTH
         DC    Y(STE51A-TXT5A)      STATIC TEXT OFFSET
         DC    H'1'                 PRINT COLUMN
         DC    Y(STE51B-STE51A)     PRINT FIELD LENGTH
         DC    H'0'                 CONVERSION FLAG (CHAR)
*  STATIC TEXT ENTRY
STE51A   DC    C'ICK31304I SYSTEM OPERATOR DID NOT CONFIRM DATA SET '
         DC    C'PURGING.'
STE51B   EQU   *
TXT5B    EQU   *
         EJECT
**********************************************************************
*                                                                    *
* UNEXPIRED DATA SET FOUND ON VOLUME                                 *
*                                                                    *
**********************************************************************
*
TXT6     DC    Y(TXT6B-TXT6A)       ENTRY LENGTH
         DC    X'9000'              MESSAGE FLAG
*  SPACING CONTROL SUBSTRUCTURE
TXT6A    DC    X'4000'              SPACING CONTROL FLAG
         DC    H'2'                 SPACING FACTOR
         DC    C'R '                SPACING TYPE
*  STATIC TEXT SUB-STRUCTURE
         DC    X'8400'              STATIC TEXT END OF LIST
         DC    Y(STE61B-STE61A)     STATIC TEXT LENGTH
         DC    Y(STE61A-TXT6A)      STATIC TEXT OFFSET
         DC    H'1'                 PRINT COLUMN
         DC    Y(STE61B-STE61A)     PRINT FIELD LENGTH
         DC    H'0'                 CONVERSION FLAG (CHAR)
*  STATIC TEXT ENTRY
STE61A   DC    C'ICK31305I UNEXPIRED OR PASSWORD PROTECTED '
         DC    C'DATA SET ON VOLUME'
STE61B   EQU   *
TXT6B    EQU   *
         EJECT
TXT7     EQU   *                    UNUSED
TXT8     EQU   *                    UNUSED
         EJECT
**********************************************************************
*                                                                    *
* VOLUME CONTAINS VSAM DATA SET(S)                                   *
*                                                                    *
**********************************************************************
*
TXT9     DC    Y(TXT9B-TXT9A)       ENTRY LENGTH
         DC    X'9000'              MESSAGE FLAG
*  SPACING CONTROL SUBSTRUCTURE
TXT9A    DC    X'4000'              SPACING CONTROL FLAG
         DC    H'2'                 SPACING FACTOR
         DC    C'R '                SPACING TYPE
*  STATIC TEXT SUB-STRUCTURE
         DC    X'8400'              STATIC TEXT END OF LIST
         DC    Y(STE91B-STE91A)     STATIC TEXT LENGTH
         DC    Y(STE91A-TXT9A)      STATIC TEXT OFFSET
         DC    H'1'                 PRINT COLUMN
         DC    Y(STE91B-STE91A)     PRINT FIELD LENGTH
         DC    H'0'                 CONVERSION FLAG (CHAR)
*  STATIC TEXT ENTRY
STE91A   DC    C'ICK31324I VOLUME CONTAINS VSAM DATA SET(S).'
STE91B   EQU   *
TXT9B    EQU   *
         EJECT
***********************************************************************
*                                                                     *
*  IMPROPER RACF ACCESS AUTHORITY                                     *
*                                                                     *
***********************************************************************
*
TXT10    DC    Y(TXT10B-TXT10A)     ENTRY LENGTH
         DC    X'9000'              MESSAGE FLAG
*  SPACING CONTROL SUB-STRUCTURE
TXT10A   DC    X'4000'              SPACING CONTROL FLAG
         DC    H'2'                 SPACING FACTOR
         DC    C'R '                SPACING TYPE
*  STATIC TEXT SUB-STRUCTURE
         DC    X'8400'              STATIC TEXT
         DC    Y(STE101B-STE101A)   STATIC TEXT LENGTH
         DC    Y(STE101A-TXT10A)    STATIC TEXT OFFSET
         DC    H'01'                PRINT COLUMN
         DC    Y(STE101B-STE101A)   PRINT FIELD LENGTH
         DC    H'0'                 CONVERSION FLAG (CHAR)
*  STATIC TEXT ENTRIES
STE101A  DC    C'ICK31326I IMPROPER RACF ACCESS AUTHORITY'
STE101B  EQU   *
TXT10B   EQU   *
         EJECT
TXT11    EQU   *                    UNUSED
TXT12    EQU   *                    UNUSED
TXT13    EQU   *                    UNUSED
TXT14    EQU   *                    UNUSED
TXT15    EQU   *                    UNUSED
TXT16    EQU   *                    UNUSED
TXT17    EQU   *                    UNUSED
         EJECT
***********************************************************************
*                                                                     *
*  NO STORAGE AVAILABLE FOR PACK MAP                                  *
*                                                                     *
***********************************************************************
*
TXT18    DC    Y(TXT18B-TXT18A)     ENTRY LENGTH
         DC    X'9000'              MESSAGE FLAG
*  SPACING CONTROL SUB-STRUCTURE
TXT18A   DC    X'4000'              SPACING CONTROL FLAG
         DC    H'2'                 SPACING FACTOR
         DC    C'R '                SPACING TYPE
*  STATIC TEXT SUB-STRUCTURE
         DC    X'8400'              STATIC TEXT
         DC    Y(STE181B-STE181A)   STATIC TEXT LENGTH
         DC    Y(STE181A-TXT18A)    STATIC TEXT OFFSET
         DC    H'01'                PRINT COLUMN
         DC    Y(STE181B-STE181A)   PRINT FIELD LENGTH
         DC    H'0'                 CONVERSION FLAG (CHAR)
*  STATIC TEXT ENTRIES
STE181A  DC    C'ICK11306I NO STORAGE AVAILABLE FOR PACK MAP.'
STE181B  EQU   *
TXT18B   EQU   *
*
*
TXT19    EQU   *
         EJECT
***********************************************************************
*                                                                     *
* DEFECTIVE TRACK LIST FOR VOLUME                                     *
*                                                                     *
***********************************************************************
*
TXT20    DC    Y(TXT20B-TXT20A)     ENTRY LENGTH
         DC    X'9000'              MESSAGE FLAG
*  SPACING CONTROL SUB-STRUCTURE
TXT20A   DC    X'4000'              SPACING CONTROL FLAG
         DC    H'2'                 SPACING FACTOR
         DC    C'R '                SPACING TYPE
*  STATIC TEXT SUB-STRUCTURE
         DC    X'0400'              STATIC TEXT
         DC    Y(STE201B-STE201A)   STATIC TEXT LENGTH
         DC    Y(STE201A-TXT20A)    STATIC TEXT OFFSET
         DC    H'1'                 PRINT COLUMN
         DC    Y(STE201B-STE201A)   PRINT FIELD LENGTH
         DC    H'0'                 CONVERSION FLAG (CHAR)
*  INSERT DATA STRUCTURE
         DC    X'A000'              INSERT DATA FLAG END OF LIST
         DC    H'1'                 REFERENCE NUMBER
         DC    H'0'                 NOT USED
         DC    Y(STE201B-STE201A+1) PRINT COLUMN
         DC    H'6'                 PRINT FIELD LENGTH
         DC    H'0'                 CONVERSION FLAG (CHAR)
*  STATIC TEXT ENTRIES
STE201A  DC    C'ICK01307I DEFECTIVE-TRACK LIST FOR VOLUME '
STE201B  EQU   *
TXT20B   EQU   *
         EJECT
***********************************************************************
*                                                                     *
* THE FOLLOWING PRIMARY TRACKS WERE FOUND DEFECTIVE                   *
*                                                                     *
***********************************************************************
*
TXT21    DC    Y(TXT21B-TXT21A)     ENTRY LENGTH
         DC    X'9000'              MESSAGE FLAG
*  SPACING CONTROL SUB-STRUCTURE
TXT21A   DC    X'4000'              SPACING CONTROL FLAG
         DC    H'2'                 SPACING FACTOR
         DC    C'R '                SPACING TYPE
*  STATIC TEXT SUB-STRUCTURE
         DC    X'8400'              STATIC TEXT END OF LIST
         DC    Y(STE211B-STE211A)   STATIC TEXT LENGTH
         DC    Y(STE211A-TXT21A)    STATIC TEXT OFFSET
         DC    H'01'                PRINT COLUMN
         DC    Y(STE211B-STE211A)   PRINT FIELD LENGTH
         DC    H'0'                 CONVERSION FLAG (CHAR)
*  STATIC TEXT ENTRIES
STE211A  DC    C'ICK01308I '
         DC    C'THE FOLLOWING PRIMARY TRACKS WERE FOUND DEFECTIVE:'
STE211B  EQU   *
TXT21B   EQU   *
         EJECT
***********************************************************************
*                                                                     *
* THE FOLLOWING ALTERNATES TRACKS WERE FOUND DEFECTIVE                *
*                                                                     *
***********************************************************************
*
TXT22    DC    Y(TXT22B-TXT22A)     ENTRY LENGTH
         DC    X'9000'              MESSAGE FLAG
*  SPACING CONTROL SUB-STRUCTURE
TXT22A   DC    X'4000'              SPACING CONTROL FLAG
         DC    H'2'                 SPACING FACTOR
         DC    C'R '                SPACING TYPE
*  STATIC TEXT SUB-STRUCTURE
         DC    X'8400'              STATIC TEXT END OF LIST
         DC    Y(STE221B-STE221A)   STATIC TEXT LENGTH
         DC    Y(STE221A-TXT22A)    STATIC TEXT OFFSET
         DC    H'01'                PRINT COLUMN
         DC    Y(STE221B-STE221A)   PRINT FIELD LENGTH
         DC    H'0'                 CONVERSION FLAG (CHAR)
*  STATIC TEXT ENTRIES
STE221A  DC    C'ICK01309I '
         DC    C'THE FOLLOWING ALTERNATE TRACKS WERE FOUND DEFECTIVE:'
STE221B  EQU   *
TXT22B   EQU   *
         EJECT
***********************************************************************
*                                                                     *
* CCHH OF TRACK     CCHH OF ALTERNATE   FLAGGED DEFECTIVE             *
*                                                                     *
***********************************************************************
*
TXT23    DC    Y(TXT23B-TXT23A)     ENTRY LENGTH
         DC    X'0000'              MESSAGE FLAG
*  SPACING CONTROL SUB-STRUCTURE
TXT23A   DC    X'4000'              SPACING CONTROL FLAG
         DC    H'2'                 SPACING FACTOR
         DC    C'R '                SPACING TYPE
*  STATIC TEXT SUB-STRUCTURE
         DC    X'8400'              STATIC TEXT END OF LIST
         DC    Y(STE231B-STE231A)   STATIC TEXT LENGTH
         DC    Y(STE231A-TXT23A)    STATIC TEXT OFFSET
         DC    H'01'                PRINT COLUMN
         DC    Y(STE231B-STE231A)   PRINT FIELD LENGTH
         DC    H'0'                 CONVERSION FLAG (CHAR)
*  STATIC TEXT ENTRIES
STE231A  DC    C'  CCHH OF TRACK --- CCHH OF ALTERNATE --- '
         DC    C'FLAGGED DEFECTIVE -- TRACK CONDITION'
STE231B  EQU   *
TXT23B   EQU   *
         EJECT
***********************************************************************
*                                                                     *
* CCHH OF TRACK     CCHH OF ALTERNATE   FLAGGED DEFECTIVE             *
*                                                                     *
***********************************************************************
*
TXT24    DC    Y(TXT24B-TXT24A)     ENTRY LENGTH
         DC    X'0000'              MESSAGE FLAG
*  SPACING CONTROL SUB-STRUCTURE
TXT24A   DC    X'4000'              SPACING CONTROL FLAG
         DC    H'2'                 SPACING FACTOR
         DC    C'R '                SPACING TYPE
*  STATIC TEXT SUB-STRUCTURE
         DC    X'8400'              STATIC TEXT END OF LIST
         DC    Y(STE241B-STE241A)   STATIC TEXT LENGTH
         DC    Y(STE241A-TXT24A)    STATIC TEXT OFFSET
         DC    H'01'                PRINT COLUMN
         DC    Y(STE241B-STE241A)   PRINT FIELD LENGTH
         DC    H'0'                 CONVERSION FLAG (CHAR)
*
*  STATIC TEXT ENTRIES
*
STE241A  DC    C'  CCHH OF TRACK --- CCHH OF ALTERNATE --- '
         DC    C'FLAGGED DEFECTIVE    '
STE241B  EQU   *
TXT24B   EQU   *
         EJECT
***********************************************************************
*                                                                     *
* CCHH OF TRACK     CCHH OF PRIMARY     FLAGGED DEFECTIVE             *
*                                                                     *
***********************************************************************
*
TXT25    DC    Y(TXT25B-TXT25A)     ENTRY LENGTH
         DC    X'0000'              MESSAGE FLAG
*  SPACING CONTROL SUB-STRUCTURE
TXT25A   DC    X'4000'              SPACING CONTROL FLAG
         DC    H'2'                 SPACING FACTOR
         DC    C'R '                SPACING TYPE
*  STATIC TEXT SUB-STRUCTURE
         DC    X'8400'              STATIC TEXT END OF LIST
         DC    Y(STE251B-STE251A)   STATIC TEXT LENGTH
         DC    Y(STE251A-TXT25A)    STATIC TEXT OFFSET
         DC    H'01'                PRINT COLUMN
         DC    Y(STE251B-STE251A)   PRINT FIELD LENGTH
         DC    H'0'                 CONVERSION FLAG (CHAR)
*
*  STATIC TEXT ENTRIES
*
STE251A  DC    C'  CCHH OF TRACK --- CCHH OF PRIMARY ----- '
         DC    C'FLAGGED DEFECTIVE -- TRACK CONDITION'
STE251B  EQU   *
TXT25B   EQU   *
         EJECT
***********************************************************************
*                                                                     *
* CCHH OF TRACK     CCHH OF PRIMARY     FLAGGED DEFECTIVE             *
*                                                                     *
***********************************************************************
*
TXT26    DC    Y(TXT26B-TXT26A)     ENTRY LENGTH
         DC    X'0000'              MESSAGE FLAG
*  SPACING CONTROL SUB-STRUCTURE
TXT26A   DC    X'4000'              SPACING CONTROL FLAG
         DC    H'2'                 SPACING FACTOR
         DC    C'R '                SPACING TYPE
*  STATIC TEXT SUB-STRUCTURE
         DC    X'8400'              STATIC TEXT END OF LIST
         DC    Y(STE261B-STE261A)   STATIC TEXT LENGTH
         DC    Y(STE261A-TXT26A)    STATIC TEXT OFFSET
         DC    H'01'                PRINT COLUMN
         DC    Y(STE261B-STE261A)   PRINT FIELD LENGTH
         DC    H'0'                 CONVERSION FLAG (CHAR)
*
*  STATIC TEXT ENTRIES
*
STE261A  DC    C'  CCHH OF TRACK --- CCHH OF PRIMARY ----- '
         DC    C'FLAGGED DEFECTIVE    '
STE261B  EQU   *
TXT26B   EQU   *
         EJECT
***********************************************************************
*                                                                     *
* NO DEFECTIVE TRACKS WERE FOUND                                      *
*                                                                     *
***********************************************************************
*
TXT27    DC    Y(TXT27B-TXT27A)     ENTRY LENGTH
         DC    X'9000'              MESSAGE FLAG
*  SPACING CONTROL SUB-STRUCTURE
TXT27A   DC    X'4000'              SPACING CONTROL FLAG
         DC    H'2'                 SPACING FACTOR
         DC    C'R '                SPACING TYPE
*  STATIC TEXT SUB-STRUCTURE
         DC    X'8400'              STATIC TEXT
         DC    Y(STE271B-STE271A)   STATIC TEXT LENGTH
         DC    Y(STE271A-TXT27A)    STATIC TEXT OFFSET
         DC    H'01'                PRINT COLUMN
         DC    Y(STE271B-STE271A)   PRINT FIELD LENGTH
         DC    H'0'                 CONVERSION FLAG (CHAR)
*
*  STATIC TEXT ENTRY
*
STE271A  DC    C'ICK01310I NO DEFECTIVE TRACKS WERE FOUND.'
STE271B  EQU   *
TXT27B   EQU   *
         EJECT
***********************************************************************
*                                                                     *
*  NO DEFECTIVE PRIMARY TRACKS WERE FOUND                             *
*                                                                     *
***********************************************************************
*
TXT28    DC    Y(TXT28B-TXT28A)     ENTRY LENGTH
         DC    X'9000'              MESSAGE FLAG
*  SPACING CONTROL SUB-STRUCTURE
TXT28A   DC    X'4000'              SPACING CONTROL FLAG
         DC    H'2'                 SPACING FACTOR
         DC    C'R '                SPACING TYPE
*  STATIC TEXT SUB-STRUCTURE
         DC    X'8400'              STATIC TEXT
         DC    Y(STE281B-STE281A)   STATIC TEXT LENGTH
         DC    Y(STE281A-TXT28A)    STATIC TEXT OFFSET
         DC    H'01'                PRINT COLUMN
         DC    Y(STE281B-STE281A)   PRINT FIELD LENGTH
         DC    H'0'                 CONVERSION FLAG (CHAR)
*
*  STATIC TEXT ENTRIES
*
STE281A  DC    C'ICK01311I NO DEFECTIVE PRIMARY TRACKS WERE FOUND.'
STE281B  EQU   *
TXT28B   EQU   *
         EJECT
***********************************************************************
*                                                                     *
* NO DEFECTIVE ALTERNATES TRACKS                                      *
*                                                                     *
***********************************************************************
*
TXT29    DC    Y(TXT29B-TXT29A)     ENTRY LENGTH
         DC    X'9000'              MESSAGE FLAG
*  SPACING CONTROL SUB-STRUCTURE
TXT29A   DC    X'4000'              SPACING CONTROL FLAG
         DC    H'2'                 SPACING FACTOR
         DC    C'R '                SPACING TYPE
*  STATIC TEXT SUB-STRUCTURE
         DC    X'8400'              STATIC TEXT END OF LIST
         DC    Y(STE291B-STE291A)   STATIC TEXT LENGTH
         DC    Y(STE291A-TXT29A)    STATIC TEXT OFFSET
         DC    H'01'                PRINT COLUMN
         DC    Y(STE291B-STE291A)   PRINT FIELD LENGTH
         DC    H'0'                 CONVERSION FLAG (CHAR)
*
*  STATIC TEXT ENTRIES
*
STE291A  DC    C'ICK01312I NO DEFECTIVE ALTERNATE TRACKS WERE FOUND.'
STE291B  EQU   *
TXT29B   EQU   *
         EJECT
***********************************************************************
*                                                                     *
* FIRST PACK MAP DETAIL LINE                                          *
*                                                                     *
***********************************************************************
*
TXT30    DC    Y(TXT30B-TXT30A)     ENTRY LENGTH
         DC    X'0000'              MESSAGE FLAG
*  SPACING CONTROL STRUCTURE
*
TXT30A   DC    X'4000'              SPACE CONTROL FLAG
         DC    H'1'                 SPACING FACTOR
         DC    C'R '                SPACING TYPE
*  INSERT DATA STRUCTURE
         DC    X'2000'              INSERT DATA FLAG
         DC    H'1'                 REFERENCE NUMBER
         DC    H'0'                 UNUSED
         DC    H'5'                 PRINT COLUMN
         DC    H'4'                 PRINT FIELD LENGTH
         DC    X'8000'              CONVERSION FLAG (B TO X)
*  INSERT DATA STRUCTURE
         DC    X'2000'              INSERT DATA FLAG
         DC    H'2'                 REFERENCE NUMBER
         DC    H'0'                 NOT USED
         DC    H'10'                PRINT COLUMN
         DC    H'4'                 PRINT FIELD LENGTH
         DC    X'8000'              CONVERSION FLAG (B TO X)
*  INSERT DATA STRUCTURE
         DC    X'2000'              INSERT DATA FLAG
         DC    H'3'                 REFERENCE NUMBER
         DC    H'0'                 NOT USED
         DC    H'24'                PRINT COLUMN
         DC    H'4'                 PRINT FIELD LENGTH
         DC    X'8000'              CONVERSION FLAG (B TO X)
*  INSERT DATA STRUCTURE
         DC    X'2000'              INSERT DATA FLAG
         DC    H'4'                 REFERENCE NUMBER
         DC    H'0'                 NOT USED
         DC    H'29'                PRINT COLUMN
         DC    H'4'                 PRINT FIELD LENGTH
         DC    X'8000'              CONVERSION FLAG (B TO X)
*  INSERT DATA STRUCTURE
         DC    X'2000'              INSERT DATA FLAG
         DC    H'5'                 REFERENCE NUMBER
         DC    H'0'                 NOT USED
         DC    H'49'                PRINT COLUMN
         DC    H'3'                 PRINT FIELD LENGTH
         DC    H'0'                 CONVERSION FLAG (CHAR)
*  INSERT DATA STRUCTURE
         DC    X'A000'              INSERT DATA FLAG - END OF LIST
         DC    H'6'                 REFERENCE NUMBER
         DC    H'0'                 NOT USED
         DC    H'64'                PRINT COLUMN
         DC    H'13'                PRINT FIELD LENGTH
         DC    H'0'                 CONVERSION FLAG (CHAR)
*
*  NO STATIC TEXT ENTRIES
*
TXT30B   EQU   *
         EJECT
***********************************************************************
*                                                                     *
* SECOND PACK MAP DETAIL LINE                                         *
*                                                                     *
***********************************************************************
*
TXT31    DC    Y(TXT31B-TXT31A)     ENTRY LENGTH
         DC    X'0000'              MESSAGE FLAG
*  SPACING CONTROL STRUCTURE
*
TXT31A   DC    X'4000'              SPACE CONTROL FLAG
         DC    H'1'                 SPACING FACTOR
         DC    C'R '                SPACING TYPE
*  INSERT DATA STRUCTURE
         DC    X'2000'              INSERT DATA FLAG
         DC    H'1'                 REFERENCE NUMBER
         DC    H'0'                 UNUSED
         DC    H'5'                 PRINT COLUMN
         DC    H'4'                 PRINT FIELD LENGTH
         DC    X'8000'              CONVERSION FLAG (B TO X)
*  INSERT DATA STRUCTURE
         DC    X'2000'              INSERT DATA FLAG
         DC    H'2'                 REFERENCE NUMBER
         DC    H'0'                 NOT USED
         DC    H'10'                PRINT COLUMN
         DC    H'4'                 PRINT FIELD LENGTH
         DC    X'8000'              CONVERSION FLAG (B TO X)
*  STATIC TEXT SUB-STRUCTURE
         DC    X'0400'              STATIC FLAG
         DC    Y(STE311B-STE311A)   STATIC TEXT LENGTH
         DC    Y(STE311A-TXT31A)    STATIC TEXT OFFSET
         DC    H'26'                PRINT COLUMN
         DC    Y(STE311B-STE311A)   PRINT FIELD LENGTH
         DC    H'0'                 CONVERSION FLAGS (CHAR)
*  INSERT DATA STRUCTURE
         DC    X'2000'              INSERT DATA FLAG
         DC    H'5'                 REFERENCE NUMBER
         DC    H'0'                 NOT USED
         DC    H'49'                PRINT COLUMN
         DC    H'3'                 PRINT FIELD LENGTH
         DC    H'0'                 CONVERSION FLAG (CHAR)
*  INSERT DATA STRUCTURE
         DC    X'A000'              INSERT DATA FLAG - END OF LIST
         DC    H'6'                 REFERENCE NUMBER
         DC    H'0'                 NOT USED
         DC    H'64'                PRINT COLUMN
         DC    H'13'                PRINT FIELD LENGTH
         DC    H'0'                 CONVERSION FLAG (CHAR)
*
*
STE311A  DC    C'NONE'
STE311B  EQU   *
TXT31B   EQU   *
         EJECT
***********************************************************************
*                                                                     *
* THIS VOL CONTAINS X ALTERNATES TRACKS WHICH X REMAIN AVAILABLE      *
*                                                                     *
***********************************************************************
*
TXT32    DC    Y(TXT32B-TXT32A)     ENTRY LENGTH
         DC    X'9000'              MESSAGE FLAG
*  SPACING CONTROL SUB-STRUCTURE
TXT32A   DC    X'4000'              SPACE CONTROL FLAG
         DC    H'2'                 SPACING FACTOR
         DC    C'R '                SPACING TYPE
*  STATIC TEXT SUB-STRUCTURE
         DC    X'0400'              STATIC TEXT END OF LIST
         DC    Y(STE321B-STE321A)   STATIC TEXT LENGTH
         DC    Y(STE321A-TXT32A)    STATIC TEXT OFFSET
         DC    H'1'                 PRINT COLUMN
         DC    Y(STE321B-STE321A)   PRINT FIELD LENGTH
         DC    H'0'                 CONVERSION FLAG (CHAR)
*  INSERT DATA STRUCTURE
         DC    X'2000'              INSERT DATA FLAG
         DC    H'1'                 REFERENCE NUMBER
         DC    H'0'                 NOT USED
         DC    Y(STE321B-STE321A+1) PRINT COLUMN
         DC    H'5'                 PRINT FIELD LENGTH
         DC    X'10A0'              CONVERSION FLAG (BIN TO DEC)
*  STATIC TEXT SUB-STRUCTURE
         DC    X'0400'              STATIC TEXT END OF LIST
         DC    Y(STE322B-STE322A)   STATIC TEXT LENGTH
         DC    Y(STE322A-TXT32A)    STATIC TEXT OFFSET
         DC    Y(STE322A-STE321A+1) PRINT COLUMN
         DC    Y(STE322B-STE322A)   PRINT FIELD LENGTH
         DC    H'0'                 CONVERSION FLAG (CHAR)
*  INSERT DATA STRUCTURE
         DC    X'2000'              INSERT DATA FLAG
         DC    H'2'                 REFERENCE NUMBER
         DC    H'0'                 NOT USED
         DC    Y(STE322B-STE321A+1) PRINT COLUMN
         DC    H'5'                 PRINT FIELD LENGTH
         DC    X'10A0'              CONVERSION FLAG (BIN TO DEC)
*  STATIC TEXT SUB-STRUCTURE
         DC    X'8400'              STATIC TEXT END OF LIST
         DC    Y(STE323B-STE323A)   STATIC TEXT LENGTH
         DC    Y(STE323A-TXT32A)    STATIC TEXT OFFSET
         DC    Y(STE323A-STE321A+1) PRINT COLUMN
         DC    Y(STE323B-STE323A)   PRINT FIELD LENGTH
         DC    H'0'                 CONVERSION FLAG (CHAR)
*
*  STATIC TEXT ENTRIES
*
STE321A  DC    C'ICK01313I VOLUME CONTAINS '
STE321B  EQU   *
         DC    C'*****'
STE322A  DC    C' ALTERNATE TRACKS -- '
STE322B  EQU   *
         DC    C'*****'
STE323A  DC    C' AVAILABLE.'
STE323B  EQU   *
TXT32B   EQU   *
         EJECT
***********************************************************************
*                                                                     *
* THE VTOC IS LOCATED AT CCCC HHHH AND IS NNNNN TRACKS                *
*                                                                     *
***********************************************************************
*
TXT33    DC    Y(TXT33B-TXT33A)     ENTRY LENGTH
         DC    X'9000'              MESSAGE FLAG
*  SPACING CONTROL STRUCTURE
TXT33A   DC    X'4000'              SPACING CONTROL FLAG
         DC    H'2'                 SPACING FACTOR
         DC    C'R '                SPACING TYPE
*  STATIC TEXT SUB-STRUCTURE
         DC    X'0400'              STATIC TEXT END OF LIST
         DC    Y(STE331B-STE331A)   STATIC TEXT LENGTH
         DC    Y(STE331A-TXT33A)    STATIC TEXT OFFSET
         DC    H'1'                 PRINT COLUMN
         DC    Y(STE331B-STE331A)   PRINT FIELD LENGTH
         DC    H'0'                 CONVERSION FLAG (CHAR)
*  INSERT DATA STRUCTURE
         DC    X'2000'              INSERT DATA FLAG
         DC    H'1'                 REFERENCE NUMBER
         DC    H'0'                 NOT USED
         DC    Y(STE331B-STE331A+1) PRINT COLUMN
         DC    H'4'                 PRINT FIELD LENGTH
         DC    X'8000'              CONVERSION FLAG (BIN TO HEX)
*  INSERT DATA STRUCTURE
         DC    X'2000'              INSERT DATA FLAG
         DC    H'2'                 REFERENCE NUMBER
         DC    H'0'                 NOT USED
         DC    Y(STE331B-STE331A+6) PRINT COLUMN
         DC    H'4'                 PRINT FIELD LENGTH
         DC    X'8000'              CONVERSION FLAG (CHAR)
*  STATIC TEXT SUB-STRUCTURE
         DC    X'0400'              STATIC TEXT END OF LIST
         DC    Y(STE332B-STE332A)   STATIC TEXT LENGTH
         DC    Y(STE332A-TXT33A)    STATIC TEXT OFFSET
         DC    Y(STE332A-STE331A+1) PRINT COLUMN
         DC    Y(STE332B-STE332A)   PRINT FIELD LENGTH
         DC    H'0'                 CONVERSION FLAG (CHAR)
*  INSERT DATA STRUCTURE
         DC    X'2000'              INSERT DATA FLAG
         DC    H'3'                 REFERENCE NUMBER
         DC    H'0'                 NOT USED
         DC    Y(STE332B-STE331A+1) PRINT COLUMN
         DC    H'5'                 PRINT FIELD LENGTH
         DC    X'10A0'              CONVERSION FLAG (BIN TO DEC)
*  STATIC TEXT SUB-STRUCTURE
         DC    X'8400'              STATIC TEXT END OF LIST
         DC    Y(STE333B-STE333A)   STATIC TEXT LENGTH
         DC    Y(STE333A-TXT33A)    STATIC TEXT OFFSET
         DC    Y(STE333A-STE331A+1) PRINT COLUMN
         DC    Y(STE333B-STE333A)   PRINT FIELD LENGTH
         DC    H'0'                 CONVERSION FLAG (CHAR)
*
*  STATIC TEXT ENTRIES
*
STE331A  DC    C'ICK01314I VTOC IS LOCATED AT '
STE331B  EQU   *
         DC    C'**** '
         DC    C'****'
STE332A  DC    C' AND IS '
STE332B  EQU   *
         DC    C'*****'
STE333A  DC    C' TRACKS.'
STE333B  EQU   *
TXT33B   EQU   *
         EJECT
TXT34    EQU *               (UNUSED)
TXT35    EQU *               (UNUSED)
TXT36    EQU *               (UNUSED)
TXT37    EQU *               (UNUSED)
TXT38    EQU *               (UNUSED)
TXT39    EQU *               (UNUSED)
         EJECT
***********************************************************************
*                                                                     *
* UNABLE TO READ VOLUME LABEL                                         *
*                                                                     *
***********************************************************************
*
TXT40    DC    Y(TXT40B-TXT40A)     ENTRY LENGTH
         DC    X'9000'              MESSAGE FLAG
*  SPACING CONTROL SUB-STRUCTURE
TXT40A   DC    X'4000'              SPACING CONTROL FLAG
         DC    H'2'                 SPACING FACTOR
         DC    C'R '                SPACING TYPE
*  STATIC TEXT SUB-STRUCTURE
         DC    X'8400'              STATIC TEXT END OF LIST
         DC    Y(STE401B-STE401A)   STATIC TEXT LENGTH
         DC    Y(STE401A-TXT40A)    STATIC TEXT OFFSET
         DC    H'01'                PRINT COLUMN
         DC    Y(STE401B-STE401A)   PRINT FIELD LENGTH
         DC    H'0'                 CONVERSION FLAG (CHAR)
*  STATIC TEXT ENTRIES
STE401A  DC    C'ICK11315I '
         DC    C'UNABLE TO READ VOLUME LABEL.'
STE401B  EQU   *
TXT40B   EQU   *
         EJECT
***********************************************************************
*                                                                     *
* UNABLE TO OPEN THE IPL DATA SET                                     *
*                                                                     *
***********************************************************************
*
TXT41    DC    Y(TXT41B-TXT41A)     ENTRY LENGTH
         DC    X'9000'              MESSAGE FLAG
*  SPACING CONTROL SUB-STRUCTURE
TXT41A   DC    X'4000'              SPACING CONTROL FLAG
         DC    H'2'                 SPACING FACTOR
         DC    C'R '                SPACING TYPE
*  STATIC TEXT SUB-STRUCTURE
         DC    X'8400'              STATIC TEXT END OF LIST
         DC    Y(STE411B-STE411A)   STATIC TEXT LENGTH
         DC    Y(STE411A-TXT41A)    STATIC TEXT OFFSET
         DC    H'01'                PRINT COLUMN
         DC    Y(STE411B-STE411A)   PRINT FIELD LENGTH
         DC    H'0'                 CONVERSION FLAG (CHAR)
*  STATIC TEXT ENTRIES
STE411A  DC    C'ICK21316I '
         DC    C'UNABLE TO OPEN IPL INPUT DATA SET.'
STE411B  EQU   *
TXT41B   EQU   *
         EJECT
***********************************************************************
*                                                                     *
* IPL INPUT RECORDS IMPROPER (1)                                      *
*                                                                     *
***********************************************************************
*
TXT42    DC    Y(TXT42B-TXT42A)     ENTRY LENGTH
         DC    X'9000'              MESSAGE FLAG
*  SPACING CONTROL SUB-STRUCTURE
TXT42A   DC    X'4000'              SPACING CONTROL FLAG
         DC    H'2'                 SPACING FACTOR
         DC    C'R '                SPACING TYPE
*  STATIC TEXT SUB-STRUCTURE
         DC    X'8400'              STATIC TEXT END OF LIST
         DC    Y(STE421B-STE421A)   STATIC TEXT LENGTH
         DC    Y(STE421A-TXT42A)    STATIC TEXT OFFSET
         DC    H'01'                PRINT COLUMN
         DC    Y(STE421B-STE421A)   PRINT FIELD LENGTH
         DC    H'0'                 CONVERSION FLAG (CHAR)
*  STATIC TEXT ENTRIES
STE421A  DC    C'ICK21317I '
         DC    C'IPL INPUT RECORD-1 FORMAT IMPROPER'
STE421B  EQU   *
TXT42B   EQU   *
         EJECT
***********************************************************************
*                                                                     *
* IPL INPUT RECORDS IMPROPER (2)                                      *
*                                                                     *
***********************************************************************
*
TXT43    DC    Y(TXT43B-TXT43A)     ENTRY LENGTH
         DC    X'9000'              MESSAGE FLAG
*  SPACING CONTROL SUB-STRUCTURE
TXT43A   DC    X'4000'              SPACING CONTROL FLAG
         DC    H'2'                 SPACING FACTOR
         DC    C'R '                SPACING TYPE
*  STATIC TEXT SUB-STRUCTURE
         DC    X'8400'              STATIC TEXT END OF LIST
         DC    Y(STE431B-STE431A)   STATIC TEXT LENGTH
         DC    Y(STE431A-TXT43A)    STATIC TEXT OFFSET
         DC    H'01'                PRINT COLUMN
         DC    Y(STE431B-STE431A)   PRINT FIELD LENGTH
         DC    H'0'                 CONVERSION FLAG (CHAR)
*  STATIC TEXT ENTRIES
STE431A  DC    C'ICK21318I '
         DC    C'IPL INPUT RECORD-2 FORMAT IMPROPER'
STE431B  EQU   *
TXT43B   EQU   *
         EJECT
***********************************************************************
*                                                                     *
* UNABLE TO WRITE BOOTSTRAP RECORD ON THE VOLUME (1)                  *
*                                                                     *
***********************************************************************
*
TXT44    DC    Y(TXT44B-TXT44A)     ENTRY LENGTH
         DC    X'9000'              MESSAGE FLAG
*  SPACING CONTROL SUB-STRUCTURE
TXT44A   DC    X'4000'              SPACING CONTROL FLAG
         DC    H'2'                 SPACING FACTOR
         DC    C'R '                SPACING TYPE
*  STATIC TEXT SUB-STRUCTURE
         DC    X'8400'              STATIC TEXT END OF LIST
         DC    Y(STE441B-STE441A)   STATIC TEXT LENGTH
         DC    Y(STE441A-TXT44A)    STATIC TEXT OFFSET
         DC    H'01'                PRINT COLUMN
         DC    Y(STE441B-STE441A)   PRINT FIELD LENGTH
         DC    H'0'                 CONVERSION FLAG (CHAR)
*  STATIC TEXT ENTRIES
STE441A  DC    C'ICK21319I '
         DC    C'UNABLE TO WRITE BOOTSTRAP RECORD-1 ON VOLUME'
STE441B  EQU   *
TXT44B   EQU   *
         EJECT
***********************************************************************
*                                                                     *
* UNABLE TO WRITE IPL BOOTSTRAP RECORD ON THE VOLUME (2)              *
*                                                                     *
***********************************************************************
*
TXT45    DC    Y(TXT45B-TXT45A)     ENTRY LENGTH
         DC    X'9000'              MESSAGE FLAG
*  SPACING CONTROL SUB-STRUCTURE
TXT45A   DC    X'4000'              SPACING CONTROL FLAG
         DC    H'2'                 SPACING FACTOR
         DC    C'R '                SPACING TYPE
*  STATIC TEXT SUB-STRUCTURE
         DC    X'8400'              STATIC TEXT END OF LIST
         DC    Y(STE451B-STE451A)   STATIC TEXT LENGTH
         DC    Y(STE451A-TXT45A)    STATIC TEXT OFFSET
         DC    H'01'                PRINT COLUMN
         DC    Y(STE451B-STE451A)   PRINT FIELD LENGTH
         DC    H'0'                 CONVERSION FLAG (CHAR)
*  STATIC TEXT ENTRIES
STE451A  DC    C'ICK21320I '
         DC    C'UNABLE TO WRITE BOOTSTRAP RECORD-2 ON VOLUME'
STE451B  EQU   *
TXT45B   EQU   *
         EJECT
***********************************************************************
*                                                                     *
* UNABLE TO WRITE IPL PROGRAM ON THE VOLUME                           *
*                                                                     *
***********************************************************************
*
TXT46    DC    Y(TXT46B-TXT46A)     ENTRY LENGTH
         DC    X'9000'              MESSAGE FLAG
*  SPACING CONTROL SUB-STRUCTURE
TXT46A   DC    X'4000'              SPACING CONTROL FLAG
         DC    H'2'                 SPACING FACTOR
         DC    C'R '                SPACING TYPE
*  STATIC TEXT SUB-STRUCTURE
         DC    X'8400'              STATIC TEXT END OF LIST
         DC    Y(STE461B-STE461A)   STATIC TEXT LENGTH
         DC    Y(STE461A-TXT46A)    STATIC TEXT OFFSET
         DC    H'01'                PRINT COLUMN
         DC    Y(STE461B-STE461A)   PRINT FIELD LENGTH
         DC    H'0'                 CONVERSION FLAG (CHAR)
*  STATIC TEXT ENTRIES
STE461A  DC    C'ICK21321I '
         DC    C'UNABLE TO WRITE IPL PROGRAM ON VOLUME.'
STE461B  EQU   *
TXT46B   EQU   *
         EJECT
***********************************************************************
*                                                                     *
* SPECIFIED IPL PROGRAM LENGTH IS WRONG                               *
*                                                                     *
***********************************************************************
*
TXT47    DC    Y(TXT47B-TXT47A)     ENTRY LENGTH
         DC    X'9000'              MESSAGE FLAG
*  SPACING CONTROL SUB-STRUCTURE
TXT47A   DC    X'4000'              SPACING CONTROL FLAG
         DC    H'2'                 SPACING FACTOR
         DC    C'R '                SPACING TYPE
*  STATIC TEXT SUB-STRUCTURE
         DC    X'8400'              STATIC TEXT END OF LIST
         DC    Y(STE471B-STE471A)   STATIC TEXT LENGTH
         DC    Y(STE471A-TXT47A)    STATIC TEXT OFFSET
         DC    H'01'                PRINT COLUMN
         DC    Y(STE471B-STE471A)   PRINT FIELD LENGTH
         DC    H'0'                 CONVERSION FLAG (CHAR)
*  STATIC TEXT ENTRIES
STE471A  DC    C'ICK21322I '
         DC    C'SPECIFIED IPL PROGRAM LENGTH IS EXCESSIVE.'
STE471B  EQU   *
TXT47B   EQU   *
         EJECT
***********************************************************************
*                                                                     *
* IPL PROGRAM INPUT TEXT CONTAINS ONLY AN END CARD                    *
*                                                                     *
***********************************************************************
*
TXT48    DC    Y(TXT48B-TXT48A)     ENTRY LENGTH
         DC    X'9000'              MESSAGE FLAG
*  SPACING CONTROL SUB-STRUCTURE
TXT48A   DC    X'4000'              SPACING CONTROL FLAG
         DC    H'2'                 SPACING FACTOR
         DC    C'R '                SPACING TYPE
*  STATIC TEXT SUB-STRUCTURE
         DC    X'8400'              STATIC TEXT END OF LIST
         DC    Y(STE481B-STE481A)   STATIC TEXT LENGTH
         DC    Y(STE481A-TXT48A)    STATIC TEXT OFFSET
         DC    H'01'                PRINT COLUMN
         DC    Y(STE481B-STE481A)   PRINT FIELD LENGTH
         DC    H'0'                 CONVERSION FLAG (CHAR)
*  STATIC TEXT ENTRIES
STE481A  DC    C'ICK21323I '
         DC    C'IPL PROGRAM INPUT CONTAINS NO TXT CARDS.'
STE481B  EQU   *
TXT48B   EQU   *
         EJECT
***********************************************************************
*                                                                     *
* OPERATOR REFUSED PURGE PERMISSION                                   *
*                                                                     *
***********************************************************************
*
TXT49    DC    Y(TXT49B-TXT49A)     ENTRY LENGTH
         DC    X'9000'              MESSAGE FLAG
*  SPACING CONTROL SUB-STRUCTURE
TXT49A   DC    X'4000'              SPACING CONTROL FLAG
         DC    H'2'                 SPACING FACTOR
         DC    C'R '                SPACING TYPE
*  STATIC TEXT SUB-STRUCTURE
         DC    X'8400'              STATIC TEXT END OF LIST
         DC    Y(STE491B-STE491A)   STATIC TEXT LENGTH
         DC    Y(STE491A-TXT49A)    STATIC TEXT OFFSET
         DC    H'01'                PRINT COLUMN
         DC    Y(STE491B-STE491A)   PRINT FIELD LENGTH
         DC    H'0'                 CONVERSION FLAG (CHAR)
*  STATIC TEXT ENTRIES
STE491A  DC    C'ICK31325I '
         DC    C'OPERATOR REFUSED PURGE PERMISSION.'
STE491B  EQU   *
TXT49B   EQU   *
         SPACE
         END
