* /* START OF SPECIFICATIONS ****
*
*01* MODULE-NAME = ICKTSEX0
*01* MODULE-TYPE = MODULE
*02*   PROCESSOR = ASSEMBLER
*
**** END OF SPECIFICATIONS **                                        */
         TITLE '***** ICKTSEX0 - EXECUTIVE STATIC TEXT *****'
**********************************************************************
*                                                                    *
* MODULE NAME - ICKTSEX0 - STATIC TEXT MODULE FOR THE EXECUTIVE      *
*                                                                    *
* DESCRIPTIVE NAME - STATIC TEXT MODULE FOR THE EXECUTIVE            *
*                                                                    *
* COPYRIGHT - NONE                                                   *
*                                                                    *
* STATUS - RELEASE-1 VERSION-0
*                                                                    *
* FUNCTION - CONTAINS NO EXECUTABLE CODE, ONLY STATIC TEXT ENTRIES   *
*        FOR THE EXECUTIVE                                           *
*        THIS MODULE IS LOADED BY ICKTP05 WHEN A STATIC TEXT         *
*        REQUEST IS MADE.                                            *
*                                                                    *
* NOTES - NONE                                                       *
*                                                                    *
*    DEPENDENCIES - NONE                                             *
*    RESTRICTIONS - NONE                                             *
*    REGISTER CONVENTIONS - NA                                       *
*    PATCH AREA - NA                                                 *
*                                                                    *
* MODULE TYPE - TABLES                                               *
*                                                                    *
*    PROCESSOR - ASSEMBLER                                           *
*    MODULE SIZE - 861
*    ATTRIBUTES - READ-ONLY                                          *
*                                                                    *
*  ENTRY POINT - NA                                                  *
*                                                                    *
*  EXIT NORMAL - NA                                                  *
*                                                                    *
*  EXIT ERROR - NA                                                   *
*                                                                    *
*  EXTERNAL REFERENCES - NA                                          *
*                                                                    *
*  TABLES - NA                                                       *
*                                                                    *
*  MACROS - NA                                                       *
*                                                                    *
* CHANGE ACTIVITY - NONE                                     @G840B00*
*                                                                    *
**********************************************************************
*
**********************************************************************
*                                                                    *
* THIS MODULE IS THE FIRST MODULE OF STATIC TEXT REQUIRED BY THE     *
* EXECUTIVE MODULES.                                                 *
*                                                                    *
* THIS IS CURRENTLY THE ONLY MODULE.                                 *
*                                                                    *
**********************************************************************
*
*
ICKTSEX0  CSECT
*                                                                    *
* THIS SECTION CONTAINS THE INDICES TO REACH AN ENTRY.               *
*                                                                    *
INDEX     DC  H'12'                     COUNT OF ENTRIES.
INDEX1    DC  Y(TXT1-INDEX)             EXEC UESTS ENTRY.
INDEX2    DC  Y(TXT2-INDEX)             DUMP FORMAT LIST.
INDEX3    DC  Y(TXT3-INDEX)             COVERAGE MATRIX TITLE
INDEX4    DC  Y(TXT4-INDEX)             COVERAGE DETAIL PRINT LINE
INDEX5    DC  Y(TXT5-INDEX)             DUMP ELEMENT INVALID.
INDEX6    DC  Y(TXT6-INDEX)             ARRAY HEADER INVALID.
INDEX7    DC  Y(TXT7-INDEX)             DUMP INVOKED AT.
INDEX8    DC  Y(TXT8-INDEX)             SNAP DUMP PRODUCED AT.
INDEX9    DC  Y(TXT9-INDEX)             INTER MODULE TRACE.
INDEX10   DC  Y(TXT10-INDEX)            INTRA MODULE TRACE.
INDEX11   DC  H'-1'                     NULL ENTRY
INDEX12   DC  Y(TXT12-INDEX)            INVALID MARGINS VALUES.
          EJECT
********************************************************************
*                                                                    *
* THIS SECTION CONTAINS THE ENTRIES.                                 *
*                                                                    *
********************************************************************
*
          DS  0F
TXT1      DC  Y(TXT1B-TXT1A)            UESTS ENTRY LENGTH.
FLG1A     DC  H'0'                      FLAG FIELD.
TXT1A     DC  A(STE11A-TXT1A)           MAIN TITLE LINE OFFSET
          DC  F'0'                      SUB-TITLE LINE OFFSET
          DC  F'0'                      FOOTING LINE OFFSET
          DC  F'0'                      PRINT CHAIN OFFSET
          DC  H'107'                    PAGE NO LOC IN TITLE.
          DC  H'73'                     TIME LOC IN TITLE.
          DC  H'89'                     DATE LOC IN TITLE.
          DC  H'1'                      MAIN TITLE LINE COUNT.
          DC  H'0'                      SUB-TITLE LINE COUNT.
          DC  H'0'                      FOOTING LINE COUNT.
          DC  H'120'                    LINE WIDTH.
          DC  H'66'                     PAGE DEPTH.
          DC  X'0100'                   DEFAULT SPACE CHAR.
* MAIN TITLE LINE STATIC TEXT ENTRY.
STE11A    DC  C' ICKDSF  DEVICE SUPPORT FACILITIES                '
          DC  C'                 TIME: XX:XX:XX        XX/XX/XX   '
          DC  C'  PAGE XXXX          '
STE11B    EQU *
TXT1B     EQU *
         EJECT
*
* THIS IS THE FORMAT LIST FOR THE DB01 LINE DUMP.
*
          DS  0F
TXT2      DC  Y(TXT2B-TXT2A)            LENGTH OF THE LIST.
FLAG2     DC  H'0'                      FLAG FIELD
TXT2A     DC  X'9000'                   END OF LIST, BLOCK DATA.
          DC  H'120'                    DATA LENGTH.
          DC  X'0000'                   INPUT OFFSET.
          DC  X'0001'                   PRINT COLUMN.
          DC  H'120'                    OUTPUT LENGTH.
          DC  H'0000'                   CONVERSION FLAGS. (NONE)
TXT2B     EQU *
          EJECT
*
*  THIS IS COVERAGE REPORT TITLE LINE
*
TXT3     DC    Y(TXT3B-TXT3A)       ENTRY LENGTH
         DC    X'0000'              MESSAGE FLAG
*  SPACING CONTROL SUB-STRUCTURE
TXT3A    DC    X'4000'              SPACING CONTROL FLAG
         DC    H'2'                 SPACING FACTOR
         DC    C'R '                SPACING TYPE
*  STATIC TEXT SUB-STRUCTURE
         DC    X'0400'              STATIC TEXT
         DC    Y(STE31B-STE31A)     STATIC TEXT LENGTH
         DC    Y(STE31A-TXT3A)      STATIC TEXT OFFSET
         DC    H'35'                PRINT COLUMN
         DC    Y(STE31B-STE31A)     PRINT FIELD LENGTH
         DC    H'0'                 CONVERSION FLAG (CHAR)
*  SPACING CONTROL SUB-STRUCTURE
         DC    X'4000'              SPACING CONTROL FLAG
         DC    H'2'                 SPACING FACTOR
         DC    C'R '                SPACING TYPE
*  STATIC TEXT SUB-STRUCTURE
         DC    X'8400'              STATIC TEXT
         DC    Y(STE32B-STE32A)     STATIC TEXT LENGTH
         DC    Y(STE32A-TXT3A)      STATIC TEXT OFFSET
         DC    H'01'                PRINT COLUMN
         DC    Y(STE32B-STE32A)     PRINT FIELD LENGTH
         DC    H'0'                 CONVERSION FLAG (CHAR)
*
* STATIC TEXT ENTRIES
*
STE31A   DC    C'TEST  COVERAGE  MATRIX  (UCOVER MACRO)'
STE31B   EQU   *
STE32A   DC    C'         '
STE32B   EQU   *
TXT3B    EQU   *
*
*
***********************************************************************
*                                                                     *
* UCOVER PRINT LINE OF MATRIX                                         *
*                                                                     *
***********************************************************************
*
TXT4     DC    Y(TXT4B-TXT4A)       ENTRY LENGTH
         DC    X'0000'              MESSAGE FLAG
*  SPACING CONTROL SUB-STRUCTURE
TXT4A    DC    X'4000'              SPACING CONTROL FLAG
         DC    H'1'                 SPACING FACTOR
         DC    C'R '                SPACING TYPE
*  BLOCK DATA STRUCTURE
         DC    X'9000'              INSERT DATA FLAG
         DC    H'100'               INPUT LENGTH
         DC    H'0'                 INPUT OFFSET
         DC    H'01'                PRINT COLUMN
         DC    H'100'               PRINT FIELD LENGTH
         DC    H'0'                 CONVERSION FLAG (CHAR)
*
*  NO STATIC TEXT ENTRIES
*
TXT4B    EQU   *
          EJECT
*
* DUMP ELEMENT INVALID.
*
TXT5      DC  Y(TXT5B-TXT5A)            ENTRY LENGTH.
          DC  X'8000'                   MESSAGE FLAG.
* SPACING SUB-STRUCTURE.
TXT5A     DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
          DC  H'2'                      SPACING FACTOR.
          DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
          DC  X'0400'                   STATIC SUB-STRUCTURE FLAG.
          DC  Y(STE51B-STE51A)          STATIC TEXT LENGTH.
          DC  Y(STE51A-TXT5A)           STATIC TEXT OFFSET.
          DC  H'1'                      PRINT COLUMN.
          DC  Y(STE51B-STE51A)          PRINT FIELD LENGTH.
          DC  H'0'                      CONVERSION FLAGS. (CHAR)
* BLOCK DATA SUB-STRUCTURE.
          DC  X'9000'                   BLOCK SUB-STRUCTURE FLAG.
          DC  H'8'                      INPUT LENGTH.
          DC  H'0'                      INPUT OFFSET.
          DC  H'13'                     PRINT COLUMN.
          DC  H'8'                      PRINT FIELD LENGTH.
          DC  H'0'                      CONVERSION FLAGS (CHAR)
* STATIC TEXT ENTRY.
STE51A    DC  C'ICK00922I  ''        '' DUMP ELEMENT INVALID FOR '
          DC  C'SYMBOLIC DUMP'
STE51B    EQU *
TXT5B     EQU *
          EJECT
*
* ARRAY HEADER INVALID FOR SYMBOLIC DUMP.
*
TXT6      DC  Y(TXT6B-TXT6A)            ENTRY LENGTH.
          DC  X'8000'                   MESSAGE FLAG.
* SPACING SUB-STRUCTURE.
TXT6A     DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
          DC  H'2'                      SPACING FACTOR.
          DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
          DC  X'0400'                   STATIC SUB-STRUCTURE FLAG.
          DC  Y(STE61B-STE61A)          STATIC TEXT LENGTH.
          DC  Y(STE61A-TXT6A)           STATIC TEXT OFFSET.
          DC  H'1'                      PRINT COLUMN.
          DC  Y(STE61B-STE61A)          PRINT FIELD LENGTH.
          DC  H'0'                      CONVERSION FLAGS. (CHAR)
* BLOCK DATA SUB-STRUCTURE.
          DC  X'9000'                   BLOCK SUB-STRUCTURE FLAG.
          DC  H'8'                      INPUT LENGTH.
          DC  H'0'                      INPUT OFFSET.
          DC  H'13'                     PRINT COLUMN.
          DC  H'8'                      PRINT FIELD LENGTH.
          DC  H'0'                      CONVERSION FLAGS. (CHAR)
* STATIC TEXT ENTRY.
STE61A    DC  C'ICK00923I  ''        '' ARRAY HEADER INVALID FOR'
          DC  C' SYMBOLIC DUMP'
STE61B    EQU *
TXT6B     EQU *
          EJECT
*
* DUMP ROUTINE INVOKED AT--
*
TXT7      DC  Y(TXT7B-TXT7A)            ENTRY LENGTH.
          DC  X'8000'                   MESSAGE FLAG.
* SPACING SUB-STRUCTURE.
TXT7A     DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
          DC  H'2'                      SPACING FACTOR.
          DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
          DC  X'0400'                   STATIC SUB-STRUCTURE FLAG.
          DC  Y(STE71B-STE71A)          STATIC TEXT LENGTH.
          DC  Y(STE71A-TXT7A)           STATIC TEXT OFFSET.
          DC  H'1'                      PRINT COLUMN.
          DC  Y(STE71B-STE71A)          PRINT FIELD LENGTH.
          DC  H'0'                      CONVERSION FLAGS. (CHAR)
* BLOCK DATA SUB-STRUCTURE.
          DC  X'9000'                   EOF & BLOCK FLAGS.
          DC  H'4'                      INPUT LENGTH.
          DC  H'0'                      INPUT OFFSET.
          DC  H'37'                     PRINT COLUMN.
          DC  H'4'                      PRINT FIELD LENGTH.
          DC  H'0'                      CONVERSION FLAGS. (CHAR)
* STATIC TEXT ENTRY.
STE71A    DC  C'ICK00924I  DUMP ROUTINE INVOKED AT ''    '''
STE71B    EQU *
TXT7B     EQU *
          EJECT
*
* SNAP DUMP NNN PRODUCED AT DUMP POINT CCCC.
*
TXT8      DC  Y(TXT8B-TXT8A)            ENTRY LENGTH.
          DC  X'8000'                   MESSAGE FLAG.
* SPACING SUB-STRUCTURE.
TXT8A     DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
          DC  H'2'                      SPACING FACTOR.
          DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
          DC  X'0400'                   STATIC SUB-STRUCTURE FLAG.
          DC  Y(STE81B-STE81A)          STATIC TEXT LENGTH.
          DC  Y(STE81A-TXT8A)           STATIC TEXT OFFSET.
          DC  H'1'                      PRINT COLUMN.
          DC  Y(STE81B-STE81A)          PRINT FIELD LENGTH.
          DC  H'0'                      CONVERSION FLAGS. (CHAR)
* BLOCK DATA SUB-STRUCTURE.
          DC  X'1000'                   BLOCK SUB-STRUCTURE FLAG.
          DC  H'2'                      INPUT LENGTH.
          DC  H'0'                      INPUT OFFSET.
          DC  H'16'                     PRINT COLUMN.
          DC  H'3'                      PRINT FIELD LENGTH.
          DC  X'1020'                   CONVERSION FLAGS. (BD,SS)
* BLOCK DATA SUB-STRUCTURE.
          DC  X'9000'                   EOF & BLOCK FLAGS.
          DC  H'4'                      INPUT LENGTH.
          DC  H'2'                      INPUT OFFSET.
          DC  H'45'                     PRINT COLUMN.
          DC  H'4'                      PRINT FIELD LENGTH.
          DC  H'0'                      CONVERSION FLAGS (CHAR)
* STATIC TEXT ENTRY.
STE81A    DC  C'ICK00925I DUMP XXX PRODUCED AT DUMP POINT '
          DC  C'''XXX'''
STE81B    EQU *
TXT8B     EQU *
          EJECT
*
* INTER MODULE TRACE:
*
TXT9      DC  Y(TXT9B-TXT9A)            ENTRY LENGTH.
          DC  H'0'                      FLAG FIELD.
* STATIC TEXT SUB-STRUCTURE.
TXT9A     DC  X'0400'                   STATIC SUB-STRUCTURE FLAG.
          DC  Y(STE91B-STE91A)          STATIC TEXT LENGTH.
          DC  Y(STE91A-TXT9A)           STATIC TEXT OFFSET.
          DC  H'1'                      PRINT COLUMN.
          DC  Y(STE91B-STE91A)          PRINT FIELD LENGTH.
          DC  H'0'                      CONVERSION FLAGS. (CHAR)
* BLOCK DATA SUB-STRUCTURE.
          DC  X'9000'                   BLOCK SUB-STRUCTURE FLAG.
          DC  H'100'                    INPUT LENGTH.
          DC  H'0'                      INPUT OFFSET.
          DC  H'21'                     PRINT COLUMN.
          DC  H'100'                    PRINT FIELD LENGTH.
          DC  H'0'                      CONVERSION FLAGS. (CHAR)
* STATIC TEXT ENTRY.
STE91A    DC  C'INTER-MODULE TRACE:'
STE91B    EQU *
TXT9B     EQU *
          EJECT
*
* INTRA MODULE TRACE:
*
TXT10     DC  Y(TXT10B-TXT10A)          ENTRY LENGTH.
          DC  H'0'                      FLAG FIELD.
* STATIC TEXT SUB-STRUCTURE.
TXT10A    DC  X'0400'                   STATIC SUB-STRUCTURE.
          DC  Y(STE101B-STE101A)        STATIC TEXT LENGTH.
          DC  Y(STE101A-TXT10A)         STATIC TEXT OFFSET.
          DC  H'1'                      PRINT COLUMN.
          DC  Y(STE101B-STE101A)        PRINT FIELD LENGTH.
          DC  H'0'                      CONVERSION FLAGS. (CHAR)
* BLOCK DATA SUB-STRUCTURE.
          DC  X'9000'                   EOF & BLOCK FLAGS.
          DC  H'100'                    INPUT LENGTH.
          DC  H'0'                      INPUT OFFSET.
          DC  H'21'                     PRINT COLUMN.
          DC  H'100'                    PRINT FIELD LENGTH.
          DC  H'0'                      CONVERSION FLAGS. (CHAR)
* STATIC TEXT ENTRY.
STE101A   DC  C'INTRA-MODULE TRACE:'
STE101B   EQU *
TXT10B    EQU *
          EJECT
*
* ENTRY 11 IS CURRENTLY UNUSED.
*
          EJECT
*
* INVALID 'MARGINS' VALUES SPECIFIED.
*
*
TXT12     DC  Y(TXT12B-TXT12A)          ENTRY LENGTH.
          DC  X'8000'                   MESSAGE FLAG.
* SPACING CONTROL SUB-STRUCTURE.
TXT12A    DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
          DC  H'2'                      SPACING FACTOR.
          DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
          DC  X'8400'                   EOF & STATIC FLAGS.
          DC  Y(STE121B-STE121A)        STATIC TEXT LENGTH.
          DC  Y(STE121A-TXT12A)         STATIC TEXT OFFSET.
          DC  H'1'                      PRINT COLUMN.
          DC  Y(STE121B-STE121A)        PRINT FIELD LENGTH.
          DC  H'0'                      CONVERSION FLAGS (CHAR)
* STATIC TEXT ENTRY.
STE121A   DC  C'ICK10927I  INVALID ''MARGINS'' VALUES SPECIFIED.'
          DC  C'  DEFAULT MARGINS ASSUMED'
STE121B   EQU *
TXT12B    EQU *
         END
