* /* START OF SPECIFICATIONS ****
*
*01* MODULE-NAME = ICKTSIO0
*01* MODULE-TYPE = MODULE
*02*   PROCESSOR = ASSEMBLER
*
**** END OF SPECIFICATIONS **                                        */
         TITLE  '***** ICKTSIO0 - IO ADAPTOR STATIC TEXT *****'
**********************************************************************
*                                                                    *
* MODULE NAME - ICKTSIO0 - STATIC TEXT MODULE FOR IO ADAPTOR         *
*                                                                    *
* DESCRIPTIVE NAME - STATIC TEXT MODULE FOR THE IO ADAPTOR           *
*                                                                    *
* COPYRIGHT - NONE                                                   *
*                                                                    *
* STATUS - RELEASE-1 VERSION-0                                       *
*                                                                    *
* FUNCTION - CONTAINS NO EXECUTABLE CODE, ONLY STATIC TEXT ENTRIES   *
*        FOR THE IO ADAPTOR                                          *
*        THIS MODULE IS LOADED BY ICKTP05 WHEN A STATIC TEXT         *
*        REQUEST IS MADE.                                            *
*                                                                    *
* NOTES - NONE                                                       *
*                                                                    *
*    DEPENDENCIES - NONE                                             *
*    RESTRICTIONS - NONE                                             *
*    REGISTER CONVENTIONS - NA                                       *
*    PATCH AREA - NA                                                 *
*                                                                    *
* MODULE TYPE - TABLES                                               *
*                                                                    *
*    PROCESSOR - ASSEMBLER                                           *
*    MODULE SIZE - 749 BYTES                                         *
*    ATTRIBUTES - READ-ONLY                                          *
*                                                                    *
*  ENTRY POINT - NA                                                  *
*                                                                    *
*  EXIT NORMAL - NA                                                  *
*                                                                    *
*  EXIT ERROR - NA                                                   *
*                                                                    *
*  EXTERNAL REFERENCES - NA                                          *
*                                                                    *
*  TABLES - NA                                                       *
*                                                                    *
*  MACROS - NA                                                       *
*                                                                    *
* CHANGE ACTIVITY - NONE                                     @G840B00*
*                                                                    *
**********************************************************************
*
**********************************************************************
*                                                                    *
* THIS MODULE IS THE FIRST MODULE OF STATIC TEXT REQUIRED BY THE     *
* I/O SERVICE ROUTINE.                                               *
*                                                                    *
**********************************************************************
*
ICKTSIO0  CSECT
*
* THIS SECTION CONTAINS THE INDICES TO REACH AN ENTRY.               *
*
INDEX     DC  AL2((LASTINDX-INDEX1)/2)  COUNT OF ENTRIES.
INDEX1    DC  Y(TXT1-INDEX)             OPEN ERROR
INDEX2    DC  Y(TXT2-INDEX)             CLOSE ERROR
INDEX3    DC  Y(TXT3-INDEX)             ACTION ERROR
INDEX4    DC  Y(TXT4-INDEX)             OPEN ERROR (NON-AM0 UPDATE)
INDEX5    DC  Y(TXT5-INDEX)             DD CARD MISSING.
INDEX6    DC  H'-1'
INDEX7    DC  H'-1'
INDEX8    DC  H'-1'
INDEX9    DC  H'-1'
INDEX10   DC  H'-1'
INDEX11   DC  H'-1'
INDEX12   DC  Y(TXT12-INDEX)            SEQUENTIAL RECORD TOO LONG
INDEX13   DC  H'-1'
INDEX14   DC  H'-1'
INDEX15   DC  Y(TXT15-INDEX)            OPEN FAILURE.
INDEX16   DC  Y(TXT16-INDEX)            NON-VSAM SYNAD MESSAGE.
INDEX17   DC  H'-1'
INDEX18   DC  H'-1'
INDEX19   DC  H'-1'
INDEX20   DC  Y(TXT20-INDEX)            PERM I/O ERROR
INDEX21   DC  H'-1'
INDEX22   DC  H'-1'
INDEX23   DC  H'-1'
INDEX24   DC  Y(TXT24-INDEX)            ABEND EXIT TAKEN.
INDEX25   DC  H'-1'
INDEX26   DC  H'-1'
INDEX27   DC  H'-1'
INDEX28   DC  H'-1'
INDEX29   DC  H'-1'
INDEX30   DC  H'-1'
INDEX31   DC  H'-1'
INDEX32   DC  H'-1'
INDEX33   DC  H'-1'
INDEX34   DC  H'-1'
INDEX35   DC  H'-1'
INDEX36   DC  H'-1'
INDEX37   DC  H'-1'
INDEX38   DC  H'-1'
INDEX39   DC  H'-1'
INDEX40   DC  H'-1'
INDEX41   DC  H'-1'
INDEX42   DC  H'-1'
INDEX43   DC  H'-1'
INDEX44   DC  Y(TXT44-INDEX)            RECORD SIZE > 32K
INDEX45   DC  H'-1'
INDEX46   DC  H'-1'
INDEX47   DC  H'-1'
INDEX48   DC  H'-1'
**********************************************************************
*                                       INSERT ALL INDEX
LASTINDX  EQU *                         NUMBERS BEFORE THIS
*                                       BOX
**********************************************************************
          EJECT
**********************************************************************
*                                                                    *
* THIS SECTION CONTAINS THE ENTRIES.                                 *
*                                                                    *
**********************************************************************
*
* OPEN ERROR MESSAGE.
*
TXT1      DC    Y(TXT1B-TXT1A)          ENTRY LENGTH.
FLG1A     DC    X'8000'                 MESSAGE FLAG.
* DOUBLE SPACE SUB-STRUCTURE.
TXT1A     DC    X'4000'                 SPACE SUB-STRUCTURE FLAG.
          DC    H'2'                    SPACING FACTOR.
          DC    C'R '                   SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
          DC    X'0400'                 STATIC TEXT FLAG.
          DC    Y(STE11B-STE11A)        STATIC TEXT LENGTH.
          DC    Y(STE11A-TXT1A)         STATIC TEXT OFFSET.
          DC    H'1'                    PRINT COLUMN NO.
          DC    Y(STE11B-STE11A)        OUTPUT LENGTH.
          DC    H'0'                    CONVERSION FLAGS (EBCDIC)
* BLOCK DATA SUB-STRUCTURE.
          DC    X'9000'                 EOF & BLOCK DATA FLAGS.
          DC    H'44'                   MAXIMUM INPUT LENGTH.
          DC    H'0'                    INPUT OFFSET
          DC    H'26'                   PRINT COLUMN.
          DC    H'0'                    PRINT FIELD LENGTH
          DC    H'0'                    CONVERSION FLAGS (EBCDIC)
* STATIC ENTRY.
STE11A    DC    C'ICK30300I  ERROR OPENING'
STE11B    EQU *
TXT1B     EQU *
          EJECT
*
* ERROR ON CLOSING MESSAGE.
*
TXT2      DC    Y(TXT2B-TXT2A)          ENTRY LENGTH.
FLG2A     DC    X'8000'                 MESSAGE FLAG.
* DOUBLE SPACE SUB-STRUCTURE.
TXT2A     DC    X'4000'                 SPACE SUB-STRUCTURE FLAG.
          DC    H'2'                    SPACING FACTOR.
          DC    C'R '                   SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
          DC    X'0400'                 STATIC TEXT FLAG.
          DC    Y(STE21B-STE21A)        STATIC TEXT LENGTH.
          DC    Y(STE21A-TXT2A)         STATIC TEXT OFFSET.
          DC    H'1'                    PRINT COLUMN NO.
          DC    Y(STE21B-STE21A)        OUTPUT LENGTH.
          DC    H'0'                    CONVERSION FLAGS (EBCDIC)
* BLOCK DATA SUB-STRUCTURE.
          DC    X'9000'                 EOF & BLOCK DATA FLAGS.
          DC    H'44'                   MAXIMUM INPUT LENGTH.
          DC    H'0'                    INPUT OFFSET
          DC    H'26'                   PRINT COLUMN.
          DC    H'0'                    PRINT FIELD LENGTH
          DC    H'0'                    CONVERSION FLAGS (EBCDIC)
* STATIC ENTRY.
STE21A    DC    C'ICK30301I ERROR CLOSING'
STE21B    EQU *
TXT2B     EQU *
          EJECT
*
* IO ERROR MESSAGE.
*
TXT3      DC    Y(TXT3B-TXT3A)          ENTRY LENGTH.
FLG3A     DC    X'8000'                 MESSAGE FLAG.
* DOUBLE SPACE SUB-STRUCTURE.
TXT3A     DC    X'4000'                 SPACE SUB-STRUCTURE FLAG.
          DC    H'2'                    SPACING FACTOR.
          DC    C'R '                   SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
          DC    X'0400'                 STATIC TEXT FLAG.
          DC    Y(STE31B-STE31A)        STATIC TEXT LENGTH.
          DC    Y(STE31A-TXT3A)         STATIC TEXT OFFSET.
          DC    H'1'                    PRINT COLUMN NO.
          DC    Y(STE31B-STE31A)        OUTPUT LENGTH.
          DC    H'0'                    CONVERSION FLAGS (EBCDIC)
* BLOCK DATA SUB-STRUCTURE.
          DC    X'9000'                 EOF & BLOCK DATA FLAGS.
          DC    H'44'                   MAXIMUM INPUT LENGTH.
          DC    H'0'                    INPUT OFFSET
          DC    H'28'                   PRINT COLUMN.
          DC    H'0'                    PRINT FIELD LENGTH
          DC    H'0'                    CONVERSION FLAGS (EBCDIC)
* STATIC ENTRY.
STE31A    DC    C'ICK30302I  ACTION ERROR ON'
STE31B    EQU *
TXT3B     EQU *
          EJECT
*
* NON-AM/0 OPEN FOR UPDATE ERROR MESSAGE.
*
TXT4      DC    Y(TXT4B-TXT4A)          ENTRY LENGTH.
FLG4A     DC    X'A000'                 MESSAGE FLAG.
* STATIC TEXT SUB-STRUCTURE.
TXT4A     DC    X'8400'                 STATIC SUB-STRUCTURE FLAG.
          DC    Y(STE41B-STE41A)        STATIC TEXT LENGTH.
          DC    Y(STE41A-TXT4A)         STATIC TEXT OFFSET.
          DC    H'1'                    PRINT COLUMN.
          DC    Y(STE41B-STE41A)        PRINT FIELD LENGTH.
          DC    H'0'                    CONVERSION FLAGS. (EBCDIC)
* STATIC TEXT ENTRY.
STE41A    DC  C'ICK30303I ** CANNOT OPEN FOR UPDATE'
STE41B    EQU *
TXT4B     EQU *
          EJECT
*
* DD CARD MISSING ERROR MESSAGE.
*
TXT5      DC    Y(TXT5B-TXT5A)          ENTRY LENGTH.
FLG5A     DC    X'A000'                 MESSAGE FLAG.
* STATIC TEXT SUB-STRUCTURE.
TXT5A     DC    X'8400'                 STATIC SUB-STRUCTURE FLAG.
          DC    Y(STE51B-STE51A)        STATIC TEXT LENGTH.
          DC    Y(STE51A-TXT5A)         STATIC TEXT OFFSET.
          DC    H'1'                    PRINT COLUMN.
          DC    Y(STE51B-STE51A)        PRINT FIELD LENGTH.
          DC    H'0'                    CONVERSION FLAGS. (EBCDIC)
* STATIC TEXT ENTRY.
STE51A    DC  C'ICK30304I ** JCL STATEMENT MISSING'
STE51B    EQU *
TXT5B     EQU *
          EJECT
TXT6      EQU *
TXT7      EQU *
TXT8      EQU *
TXT9     EQU *                                                 @X60KAFY
TXT10    EQU *
TXT11    EQU *
               EJECT
*
* NON-KEYED RECORD TOO LONG FOR DATA SET ERROR MESSAGE.
*
TXT12     DC    Y(TXT12B-TXT12A)        ENTRY LENGTH.
FLG12B    DC    X'A000'                 MESSAGE FLAG.
* STATIC TEXT SUB-STRUCTURE.
TXT12A    DC    X'0400'                 STATIC SUB-STRUCTURE FLAG.
          DC    Y(STE121B-STE121A)      STATIC TEXT LENGTH.
          DC    Y(STE121A-TXT12A)       STATIC TEXT OFFSET.
          DC    H'1'                    PRINT COLUMN.
          DC    Y(STE121B-STE121A)      PRINT FIELD LENGTH.
          DC    H'0'                    CONVERSION FLAGS. (EBCDIC)
* BLOCK DATA SUB-STRUCTURE.
         DC  X'1000'                   BLOCK DATA FLAG.
         DC  H'5'                      INPUT LENGTH.
         DC  H'0'                      INPUT OFFSET.
         DC  H'20'                     PRINT COLUMN.
         DC  H'10'                     OUTPUT LENGTH.
         DC  X'4000'                   CONVERSION FLAGS.  (BHA)
* STATIC TEXT SUB-STRUCTURE.
         DC  X'8400'                   EOF AND STATIC FLAGS.
         DC  Y(STE122B-STE122A)        STATIC TEXT LENGTH.
         DC  Y(STE122A-TXT12A)         STATIC TEXT OFFSET.
         DC  H'35'                     PRINT COLUMN.
         DC  Y(STE122B-STE122A)        PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* STATIC TEXT ENTRY.
STE121A   DC  C'ICK30309I ** RECORD'
STE121B   EQU *
STE122A  DC  C'NOT WRITTEN.  LENGTH INVALID'
STE122B  EQU *
TXT12B    EQU *
          EJECT
TXT13     EQU *
TXT14     EQU *
          EJECT
*
* DCBOFLGS NOT SET AFTER OPEN REQUEST.
*
TXT15     DC  Y(TXT15B-TXT15A)          ENTRY LENGTH.
FLG15A    DC  X'A000'                   MESSAGE FLAGS.
* STATIC TEXT SUB-STRUCTURE.
TXT15A    DC  X'8400'                   STATIC TEXT FLAG.
          DC  Y(STE151B-STE151A)        STATIC TEXT LENGTH.
          DC  Y(STE151A-TXT15A)         STATIC TEXT OFFSET.
          DC  H'1'                      PRINT COLUMN.
          DC  Y(STE151B-STE151A)        PRINT LENGTH.
          DC  H'0'                      CONVERSION FLAGS. (CHAR)
*STATIC TEXT ENTRY.
STE151A   DC  C'ICK30312I ** SYSTEM UNABLE TO OPEN'
STE151B   EQU *
TXT15B    EQU *
          EJECT
*
* SYNAD MESSAGE.  STATIC TEXT CONSISTS OF MESSAGE NUMBER ONLY.
*
TXT16     DC  Y(TXT16B-TXT16A)          ENTRY LENGTH.
FLG16A    DC  X'A000'                   MESSAGE FLAG.
* STATIC TEXT SUB-STRUCTURE.
TXT16A    DC  X'0400'                   STATIC FLAG.
          DC  Y(STE161B-STE161A)        STATIC TEXT LENGTH.
          DC  Y(STE161A-TXT16A)         STATIC TEXT OFFSET.
          DC  H'1'                      PRINT COLUMN.
          DC  Y(STE161B-STE161A)        PRINT LENGTH.
          DC  H'0'                      CONVERSION FLAGS. (CHAR)
* BLOCK DATA SUB-STRUCTURE.
          DC  X'1000'                   EOF & BLOCK DATA FLAG.
          DC  H'36'                     INPUT LENGTH.
          DC  H'0'                      INPUT OFFSET
          DC  H'14'                     PRINT COLUMN.
          DC  H'36'                     PRINT FIELD LENGTH.
          DC  H'0'                      CONVERSION FLAG. (CHAR)
* SPACING CONTROL SUB-STRUCTURE.
         DC  X'4000'                   SPACE CONTROL SUB-STRUCTURE.
         DC  H'1'                      SPACING FACTOR.
         DC  C'R '                     SPACING TYPE.
* BLOCK DATA SUB-STRUCTURE.
          DC  X'9000'                   EOF & BLOCK DATA FLAG.
          DC  H'44'                     INPUT LENGTH.
          DC  H'36'                     INPUT OFFSET
          DC  H'12'                     PRINT COLUMN.
          DC  H'44'                     PRINT FIELD LENGTH.
          DC  H'0'                      CONVERSION FLAG. (CHAR)
* STATIC TEXT ENTRY
STE161A   DC  C'ICK30313I **'
STE161B   EQU *
TXT16B    EQU *
          EJECT
TXT17    EQU *
TXT18    EQU  *
TXT19     EQU *
         EJECT
*
* PERMANENT I/O ERROR
*
TXT20     DC  Y(TXT20B-TXT20A)          ENTRY LENGTH.
FLG20A    DC  X'A000'                   MESSAGE FLAG.
* STATIC TEXT SUB-STRUCTURE.
TXT20A    DC  X'8400'                   EOF & STATIC FLAGS.
          DC  Y(STE201B-STE201A)        STATIC TEXT LENGTH.
          DC  Y(STE201A-TXT20A)         STATIC TEXT OFFSET.
          DC  H'1'                      PRINT COLUMN.
          DC  Y(STE201B-STE201A)        OUTPUT LENGTH.
          DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* STATIC TEXT ENTRY.
STE201A   DC  C'ICK30317I ** PERMANENT I/O ERROR'
STE201B   EQU *
TXT20B    EQU *
         EJECT
*
* STATIC TEXT NUMBER IO021 IS UNUSED
*
         EJECT
*
* STATIC TEXT NUMBER IO022 IS UNUSED
*
         EJECT
*
* STATIC TEXT NUMBER IO023 IS UNUSED
*
         EJECT
*
* ABEND EXIT TAKEN.
*
TXT24     DC  Y(TXT24B-TXT24A)          ENTRY LENGTH.
FLG24A    DC  X'A000'                   MESSAGE FLAG.
* STATIC TEXT SUB-STRUCTURE.
TXT24A    DC  X'8400'                   EOF & STATIC FLAGS.
          DC  Y(STE241B-STE241A)        STATIC TEXT LENGTH.
          DC  Y(STE241A-TXT24A)         STATIC TEXT OFFSET.
          DC  H'1'                      PRINT COLUMN.
          DC  Y(STE241B-STE241A)        OUTPUT LENGTH.
          DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* STATIC TEXT ENTRY.
STE241A  DC  C'ICK30321I ** OPEN/CLOSE ABEND EXIT TAKEN'
STE241B  EQU *
TXT24B   EQU *
          EJECT
TXT25     EQU *
TXT26     EQU *
TXT27     EQU *
TXT28     EQU *
TXT29     EQU *
TXT30     EQU *
TXT31     EQU *
TXT32     EQU *
TXT33     EQU *
TXT34     EQU *
TXT35     EQU *
TXT36     EQU *
TXT37     EQU *
TXT38     EQU *
TXT39     EQU *
TXT40     EQU *
TXT41     EQU *
TXT42     EQU *
TXT43     EQU *
*
          EJECT
*
* RECORD SIZE GREATER THAN 32767
*
TXT44     DC    Y(TXT44B-TXT44A)        ENTRY LENGTH.
FLG44B    DC    X'A000'                 MESSAGE FLAG.
* STATIC TEXT SUB-STRUCTURE.
TXT44A    DC    X'8400'                 STATIC SUB-STRUCTURE FLAG.
          DC    Y(STE441B-STE441A)      STATIC TEXT LENGTH.
          DC    Y(STE441A-TXT44A)       STATIC TEXT OFFSET.
          DC    H'1'                    PRINT COLUMN.
          DC    Y(STE441B-STE441A)      PRINT FIELD LENGTH.
          DC    H'0'                    CONVERSION FLAGS. (EBCDIC)
* STATIC TEXT ENTRY.
STE441A   DC  C'ICK30315I ** RECORD SIZE GREATER THAN 32767 NOT SUPPORT*
               ED'
STE441B   EQU *
TXT44B    EQU *
          EJECT
TXT45     EQU *
TXT46     EQU *
TXT47     EQU *
TXT48     EQU *
          END
