       TITLE '***** ICKTSRI0 - READER INTERPRETER STATIC TEXT *****'
**********************************************************************
*                                                                    *
* MODULE NAME - ICKTSRI0 - STATIC TEXT MODULE FOR READER INTERPRETER *
*                                                                    *
* DESCRIPTIVE NAME - STATIC TEXT MODULE FOR THE READER INTERPRETER   *
*                                                                    *
* COPYRIGHT - NONE                                                   *
*                                                                    *
* STATUS - RELEASE-1 VERSION-0
*                                                                    *
* FUNCTION - CONTAINS NO EXECUTABLE CODE, ONLY STATIC TEXT ENTRIES   *
*        FOR THE READER INTERPRETER                                  *
*        THIS MODULE IS LOADED BY ICKTP05 WHEN A STATIC TEXT         *
*        REQUEST IS MADE.                                            *
*                                                                    *
* NOTES - NONE                                                       *
*                                                                    *
*    DEPENDENCIES - NONE                                             *
*    RESTRICTIONS - NONE                                             *
*    REGISTER CONVENTIONS - NA                                       *
*    PATCH AREA - NA                                                 *
*                                                                    *
* MODULE TYPE - TABLES                                               *
*                                                                    *
*    PROCESSOR - ASSEMBLER                                           *
*    MODULE SIZE - 2978 DECIMAL BYTES
*    ATTRIBUTES - READ-ONLY                                          *
*                                                                    *
*  ENTRY POINT - NA                                                  *
*                                                                    *
*  EXIT NORMAL - NA                                                  *
*                                                                    *
*  EXIT ERROR - NA                                                   *
*                                                                    *
*  EXTERNAL REFERENCES - NA                                          *
*                                                                    *
*  TABLES - NA                                                       *
*                                                                    *
*  MACROS - NA                                                       *
*                                                                    *
* CHANGE ACTIVITY - NONE                                     @G840B00*
*                                                                    *
**********************************************************************
*
*********************************************************************
*                                                                    *
* THIS MODULE IS THE FIRST MODULE OF STATIC TEXT REQUIRED BY THE     *
* READER INTERPRETER SERVICE ROUTINES.                               *
*                                                                    *
*********************************************************************
*
*
ICKTSRI0  CSECT
*
*********************************************************************
*                                                                    *
* THIS SECTION OF CODE CONTAINS THE INDICIES REQUIRED TO REACH       *
* THE STATIC TEXT ENTRIES.                                           *
*                                                                    *
*********************************************************************
*
INDEX     DC  H'39'                     NUMBER OF ENTRIES.
INDEX1    DC  Y(TXT1-INDEX)             EXCESS POSIT SUB-PARMS
INDEX2    DC  Y(TXT2-INDEX)             SCALAR VALUE TOO LONG.
INDEX3    DC  Y(TXT3-INDEX)             TEXT BYPASSED COND CODE 12
INDEX4    DC  Y(TXT4-INDEX)             NAME NOT WITHIN RESTRICTIONS
INDEX5    DC  Y(TXT5-INDEX)             COMMAND NOT EXECUTED
INDEX6    DC  Y(TXT6-INDEX)             IMPROPER DELIMITER
INDEX7    DC  Y(TXT7-INDEX)             IMPROPER COMMA
INDEX8    DC  Y(TXT8-INDEX)             REMAINDER OF COMMAND IGNORED
INDEX9    DC  Y(TXT9-INDEX)             MISSING LEFT PAREN.
INDEX10   DC  Y(TXT10-INDEX)            MISSING RIGHT PAREN.
INDEX11   DC  Y(TXT11-INDEX)            INVALID PAREN'S
INDEX12   DC  Y(TXT12-INDEX)            INVALID KEYWORD.
INDEX13   DC  Y(TXT13-INDEX)            INVALID LEFT PAREN.
INDEX14   DC  Y(TXT14-INDEX)            KEYWORD TOO OFTEN.
INDEX15   DC  Y(TXT15-INDEX)            IMPROPER HEX OR BINARY VALUE.
INDEX16   DC  H'-1'                     NULL ENTRY
INDEX17   DC  Y(TXT17-INDEX)            REMAINDER OF COMMAND BYPASSED
INDEX18   DC  Y(TXT18-INDEX)            IMPROPER PASSWORD
INDEX19   DC  Y(TXT19-INDEX)            EXCESS SUBPARM LIST REP'S
INDEX20   DC  Y(TXT20-INDEX)            UNKNOWN VERB NAME.
INDEX21   DC  Y(TXT21-INDEX)            BAD NUMERIC DIGIT.
INDEX22   DC  Y(TXT22-INDEX)            CONSTANT NOT IN VALUE RANGE
INDEX23   DC  Y(TXT23-INDEX)            SEMICOLON WITHIN QUOTED STRING
INDEX24   DC  Y(TXT24-INDEX)            TOO MANY SCALARS IN LIST
INDEX25   DC  H'-1'                     NULL ENTRY
INDEX26   DC  Y(TXT26-INDEX)            REQUIRED PARAMETER MISSING.
INDEX27   DC  Y(TXT27-INDEX)            BAD PARAMETER COMBINATION.
INDEX28   DC  Y(TXT28-INDEX)            BAD ELSE COMMAND.
INDEX29   DC  Y(TXT29-INDEX)            BAD END COMMAND.
INDEX30   DC  Y(TXT30-INDEX)            INVALID RELATIONAL EXPRESSION.
INDEX31   DC  Y(TXT31-INDEX)            INVALID ASSIGNMENT EXPRESSION.
INDEX32   DC  H'-1'                     NULL ENTRY
INDEX33   DC  Y(TXT33-INDEX)            MISSING OR IMPROPER 'THEN'
INDEX34   DC  Y(TXT34-INDEX)            TOO MANY RIGHT PARENTHESES.
INDEX35   DC  Y(TXT35-INDEX)            TOO FEW RIGHT PARENTHESES.
INDEX36   DC  H'-1'                     NULL ENTRY
INDEX37   DC  Y(TXT37-INDEX)            IMPROPER SYSIN END-OF-FILE.
INDEX38   DC  Y(TXT38-INDEX)            TOO MUCH 'IF' NESTING
INDEX39   DC  Y(TXT39-INDEX)            PRINT INPUT RECORD
          EJECT
*********************************************************************
*                                                                    *
* THIS SECTION CONTAINS THE ENTRIES.                                 *
*                                                                    *
*********************************************************************
*
*
* TOO MANY POSITIONAL SUBPARAMETERS IN A LIST.
*
TXT1      DC  Y(TXT1B-TXT1A)            ENTRY LENGTH.
FLG1A     DC  X'8000'                   MESSAGE FLAG.
* DOUBLE SPACE SUB-STRUCTURE
TXT1A     DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
          DC  H'2'                      SPACING FACTOR.
          DC  C'R '                     RELATIVE SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE
          DC  X'0400'                   STATIC SUB-STRUCTURE FLAG.
          DC  Y(STE11B-STE11A)          STATIC TEXT LENGTH.
          DC  Y(STE11A-TXT1A)           STATIC TEXT OFFSET.
          DC  H'1'                      PRINT COLUMN NUMBER.
          DC  Y(STE11B-STE11A)          OUTPUT LENGTH.
          DC  H'0'                      CONVERSION FLAGS. (CHAR)
* BLOCK DATA SUB-STRUCTURE.
         DC  X'1000'                   BLOCK DATA FLAG.
         DC  H'20'                     DATA LENGTH.
         DC  H'0'                      DATA OFFSET.
         DC  H'49'                     PRINT COLUMN.
         DC  H'20'                     PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* STATIC TEXT SUB-STRUCTURE.
         DC  X'8400'                   STATIC TEXT FLAG.
         DC  Y(STE12B-STE12A)          TEXT LENGTH.
         DC  Y(STE12A-TXT1A)           TEXT OFFSET.
         DC  H'0'                      PRINT OFFSET.
         DC  Y(STE12B-STE12A)          PRINT FIELD LENGTH.
         DC  X'0010'                   CONVERSION FLAGS.  (CHAR,BS)
* STATIC TEXT ENTRY
STE11A    DC  C'ICK30200I TOO MANY POSITIONAL PARAMETERS AFTER '''
STE11B    EQU *
STE12A    DC  C''''
STE12B    EQU *
TXT1B     EQU *
          EJECT
*
* SCALAR VALUE EXCEEDS LENGTH LIMIT.
*
TXT2      DC  Y(TXT2B-TXT2A)            ENTRY LENGTH.
FLG2A     DC  X'8000'                   MESSAGE FLAG.
* DOUBLE SPACE SUB-STRUCTURE
TXT2A     DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
          DC  H'2'                      SPACING FACTOR.
          DC  C'R '                     RELATIVE SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE
          DC  X'0400'                   STATIC SUB-STRUCTURE FLAG.
          DC  Y(STE21B-STE21A)          STATIC TEXT LENGTH.
          DC  Y(STE21A-TXT2A)           STATIC TEXT OFFSET.
          DC  H'1'                      PRINT COLUMN NUMBER.
          DC  Y(STE21B-STE21A)          OUTPUT LENGTH.
          DC  H'0'                      CONVERSION FLAGS. (CHAR)
* BLOCK DATA SUB-STRUCTURE.
         DC  X'1000'                   BLOCK DATA FLAG.
         DC  H'20'                     DATA LENGTH.
         DC  H'0'                      DATA OFFSET.
         DC  H'21'                     PRINT COLUMN.
         DC  H'20'                     PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.   (CHAR)
* STATIC TEXT SUB-STRUCTURE.
         DC  X'8400'                   EOF & STATIC TEXT FLAGS.
         DC  Y(STE22B-STE22A)          TEXT LENGTH.
         DC  Y(STE22A-TXT2A)           TEXT OFFSET.
         DC  H'0'                      PRINT OFFSET.
         DC  Y(STE22B-STE22A)          PRINT FIELD LENGTH.
         DC  X'0010'                   CONVERSION FLAGS.  (CHAR,BS)
*STATIC TEXT ENTRY
STE21A    DC  C'ICK30201I CONSTANT '''
STE21B    EQU *
STE22A    DC  C''' EXCEEDS LENGTH LIMIT'
STE22B    EQU *
TXT2B     EQU *
          EJECT
*
* REMAINDER OF COMMAND BYPASSED. CONDITION CODE IS 12.
*
TXT3      DC  Y(TXT3B-TXT3A)            ENTRY LENGTH.
FLG3A     DC  X'8000'                   MESSAGE FLAG.
* DOUBLE SPACE SUB-STRUCTURE
TXT3A     DC  X'4000'                   SPACE FLAG.
          DC  H'2'                      SPACING FACTOR.
          DC  C'R '                     RELATIVE SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
          DC  X'8400'                   EOF AND STATIC FLAGS.
          DC  Y(STE31B-STE31A)          TEXT LENGTH.
          DC  Y(STE31A-TXT3A)           TEXT OFFSET.
          DC  H'1'                      PRINT COLUMN.
          DC  Y(STE31B-STE31A)          OUTPUT LENGTH.
          DC  H'0'                      CONVERSION FLAGS (CHAR)
STE31A    DC  C'ICK30202I ABOVE TEXT BYPASSED UNTIL NEXT COMMAND. '
          DC  C'CONDITION CODE IS 12'
STE31B    EQU *
TXT3B     EQU *
          EJECT
*
* ITEM DOES NOT ADHERE TO RESTRICTIONS
*
TXT4      DC  Y(TXT4B-TXT4A)            ENTRY LENGTH.
FLG4A     DC  X'8000'                   MESSAGE FLAG.
* DOUBLE SPACE SUB-STRUCTURE
TXT4A     DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
          DC  H'2'                      SPACING FACTOR.
          DC  C'R '                     RELATIVE SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
          DC  X'0400'                   EOF AND STATIC FLAGS.
          DC  Y(STE41B-STE41A)          TEXT LENGTH.
          DC  Y(STE41A-TXT4A)           TEXT OFFSET.
          DC  H'1'                      PRINT COLUMN.
          DC  Y(STE41B-STE41A)          OUTPUT LENGTH.
          DC  H'0'                      CONVERSION FLAGS (CHAR)
* BLOCK DATA SUB-STRUCTURE.
         DC  X'1000'                   BLOCK DATA FLAG.
         DC  H'20'                     DATA LENGTH.
         DC  H'0'                      DATA OFFSET.
         DC  H'17'                     PRINT COLUMN.
         DC  H'20'                     PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* STATIC TEXT SUB-STRUCTURE.
         DC  X'8400'                   EOF & STATIC FLAGS.
         DC  Y(STE42B-STE42A)          TEXT LENGTH.
         DC  Y(STE42A-TXT4A)           TEXT OFFSET.
         DC  H'0'                      PRINT OFFSET.
         DC  Y(STE42B-STE42A)          PRINT FIELD LENGTH.
         DC  X'0010'                   CONVERSION FLAGS.  (CHAR,BS)
STE41A    DC  C'ICK30203I ITEM '''
STE41B    EQU *
STE42A    DC  C''' DOES NOT ADHERE TO RESTRICTIONS'
STE42B    EQU *
TXT4B     EQU *
          EJECT
*
* PRECEDING COMMAND NOT EXECUTED DUE TO CONDITION CODES.
*
TXT5      DC  Y(TXT5B-TXT5A)            ENTRY LENGTH.
FLG5A     DC  X'8000'                   MESSAGE FLAG.
* DOUBLE SPACE SUB-STRUCTURE
TXT5A     DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
          DC  H'2'                      SPACING FACTOR.
          DC  C'R '                     RELATIVE SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
          DC  X'8400'                   EOF AND STATIC FLAGS.
          DC  Y(STE51B-STE51A)          TEXT LENGTH.
          DC  Y(STE51A-TXT5A)           TEXT OFFSET.
          DC  H'1'                      PRINT COLUMN.
          DC  Y(STE51B-STE51A)          OUTPUT LENGTH.
          DC  H'0'                      CONVERSION FLAGS (CHAR)
STE51A    DC  C'ICK00204I PRECEDING COMMAND BYPASSED DUE '
          DC  C'TO CONDITION CODES'
STE51B    EQU *
TXT5B     EQU *
          EJECT
*
* A DELIMITER IS NOT PROPERLY PRECEDED BY A SCALAR OR KEYWORD
*
TXT6      DC  Y(TXT6B-TXT6A)            ENTRY LENGTH.
FLG6A     DC  X'8000'                   MESSAGE FLAG.
* DOUBLE SPACE SUB-STRUCTURE
TXT6A     DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
          DC  H'2'                      SPACING FACTOR.
          DC  C'R '                     RELATIVE SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
          DC  X'0400'                   EOF AND STATIC FLAGS.
          DC  Y(STE61B-STE61A)          TEXT LENGTH.
          DC  Y(STE61A-TXT6A)           TEXT OFFSET.
          DC  H'1'                      PRINT COLUMN.
          DC  Y(STE61B-STE61A)          OUTPUT LENGTH.
          DC  H'0'                      CONVERSION FLAGS (CHAR)
* BLOCK DATA SUB-STRUCTURE.
         DC  X'1000'                   BLOCK DATA FLAG.
         DC  H'1'                      DATA LENGTH.
         DC  H'0'                      DATA OFFSET.
         DC  H'22'                     PRINT COLUMN.
         DC  H'1'                      PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* STATIC TEXT SUB-STRUCTURE.
         DC  X'8400'                   EOF & STATIC FLAGS.
         DC  Y(STE62B-STE62A)          STATIC TEXT LENGTH.
         DC  Y(STE62A-TXT6A)           TEXT OFFSET.
         DC  H'0'                      PRINT OFFSET.
         DC  Y(STE62B-STE62A)          PRINT FIELD LENGTH.
         DC  X'0010'                   CONVERSION FLAGS.  (CHAR,BS)
* STATIC TEXT ENTRIES.
STE61A    DC  C'ICK30205I DELIMITER '''
STE61B    EQU *
STE62A    DC  C''' IS NOT PROPERLY PRECEDED BY A CONSTANT OR KEYWORD'
STE62B    EQU *
TXT6B     EQU *
          EJECT
*
* IMPROPERLY PLACED COMMA HAS BEEN FOUND AND IGNORED
*
TXT7      DC  Y(TXT7B-TXT7A)            ENTRY LENGTH.
FLG7A     DC  X'8000'                   MESSAGE FLAG.
* DOUBLE SPACE SUB-STRUCTURE
TXT7A     DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
          DC  H'2'                      SPACING FACTOR.
          DC  C'R '                     RELATIVE SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
          DC  X'8400'                   EOF AND STATIC FLAGS.
          DC  Y(STE71B-STE71A)          TEXT LENGTH.
          DC  Y(STE71A-TXT7A)           TEXT OFFSET.
          DC  H'1'                      PRINT COLUMN.
          DC  Y(STE71B-STE71A)          OUTPUT LENGTH.
          DC  H'0'                      CONVERSION FLAGS (CHAR)
STE71A    DC  C'ICK00206I IMPROPERLY PLACED COMMA HAS BEEN '
          DC  C'FOUND AND IGNORED'
STE71B    EQU *
TXT7B     EQU *
          EJECT
*
* REMAINDER OF COMMAND INPUT STREAM IGNORED
*
TXT8      DC  Y(TXT8B-TXT8A)            ENTRY LENGTH.
FLG8A     DC  X'8000'                   MESSAGE FLAG.
* DOUBLE SPACE SUB-STRUCTURE
TXT8A     DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
          DC  H'2'                      SPACING FACTOR.
          DC  C'R '                     RELATIVE SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
          DC  X'8400'                   EOF AND STATIC FLAGS.
          DC  Y(STE81B-STE81A)          TEXT LENGTH.
          DC  Y(STE81A-TXT8A)           TEXT OFFSET.
          DC  H'1'                      PRINT COLUMN.
          DC  Y(STE81B-STE81A)          OUTPUT LENGTH.
          DC  H'0'                      CONVERSION FLAGS (CHAR)
STE81A    DC  C'ICK30207I REMAINDER OF COMMAND INPUT STREAM IGNORED'
STE81B    EQU *
TXT8B     EQU *
          EJECT
*
* DELIMITING LEFT PARENTHESIS MISSING.
*
TXT9      DC  Y(TXT9B-TXT9A)            ENTRY LENGTH.
FLG9A     DC  X'8000'                   MESSAGE FLAG.
* DOUBLE SPACE SUB-STRUCTURE
TXT9A     DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
          DC  H'2'                      SPACING FACTOR.
          DC  C'R '                     RELATIVE SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
          DC  X'0400'                   EOF AND STATIC FLAGS.
          DC  Y(STE91B-STE91A)          TEXT LENGTH.
          DC  Y(STE91A-TXT9A)           TEXT OFFSET.
          DC  H'1'                      PRINT COLUMN.
          DC  Y(STE91B-STE91A)          OUTPUT LENGTH.
          DC  H'0'                      CONVERSION FLAGS (CHAR)
* BLOCK DATA SUB-STRUCTURE.
         DC  X'1000'                   BLOCK DATA FLAG.
         DC  H'20'                     DATA LENGTH.
         DC  H'0'                      DATA OFFSET.
         DC  H'55'                     PRINT COLUMN.
         DC  H'20'                     PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* STATIC TEXT SUB-STRUCTURE.
         DC  X'8400'                   EOF & STATIC FLAGS.
         DC  Y(STE92B-STE92A)          TEXT LENGTH.
         DC  Y(STE92A-TXT9A)           TEXT OFFSET.
         DC  H'0'                      PRINT OFFSET.
         DC  Y(STE92B-STE92A)          PRINT FIELD LENGTH.
         DC  X'0010'                   CONVERSION FLAGS.  (CHAR,BS)
* STATIC TEXT ENTRIES.
STE91A    DC  C'ICK30208I LEFT PARENTHESIS MISSING'
          DC  C' FOLLOWING KEYWORD '''
STE91B    EQU *
STE92A    DC  C''''
STE92B    EQU *
TXT9B     EQU *
          EJECT
*
* DELIMITING RIGHT PARENTHESIS MISSING.
*
TXT10     DC  Y(TXT10B-TXT10A)          ENTRY LENGTH.
FLG10A    DC  X'8000'                   MESSAGE FLAG.
* DOUBLE SPACE SUB-STRUCTURE
TXT10A    DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
          DC  H'2'                      SPACING FACTOR.
          DC  C'R '                     RELATIVE SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
          DC  X'0400'                   EOF AND STATIC FLAGS.
          DC  Y(STE101B-STE101A)        TEXT LENGTH.
          DC  Y(STE101A-TXT10A)         TEXT OFFSET.
          DC  H'1'                      PRINT COLUMN.
          DC  Y(STE101B-STE101A)        OUTPUT LENGTH.
          DC  H'0'                      CONVERSION FLAGS (CHAR)
* BLOCK DATA SUB-STRUCTURE.
         DC  X'1000'                   BLOCK DATA FLAG.
         DC  H'20'                     DATA LENGTH.
         DC  H'0'                      DATA OFFSET.
         DC  H'44'                     PRINT COLUMN.
         DC  H'20'                     PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* STATIC TEXT SUB-STRUCTURE.
         DC  X'8400'                   EOF & STATIC FLAGS.
         DC  Y(STE102B-STE102A)        TEXT LENGTH.
         DC  Y(STE102A-TXT10A)         TEXT OFFSET.
         DC  H'0'                      PRINT OFFSET.
         DC  Y(STE102B-STE102A)        PRINT FIELD LENGTH.
         DC  X'0010'                   CONVERSION FLAGS.  (CHAR,BS)
* STATIC TEXT ENTRIES.
STE101A   DC  C'ICK30209I RIGHT PARENTHESIS MISSING'
          DC  C' AFTER '''
STE101B   EQU *
STE102A   DC  C''''
STE102B   EQU *
TXT10B    EQU *
          EJECT
*
* PARENTHESIS TO DELIMIT REPEATED SUBLIST IS MISSING.
*
TXT11     DC  Y(TXT11B-TXT11A)          ENTRY LENGTH.
FLG11A    DC  X'8000'                   MESSAGE FLAG.
* DOUBLE SPACE SUB-STRUCTURE
TXT11A    DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
          DC  H'2'                      SPACING FACTOR.
          DC  C'R '                     RELATIVE SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
          DC  X'8400'                   EOF AND STATIC FLAGS.
          DC  Y(STE111B-STE111A)        TEXT LENGTH.
          DC  Y(STE111A-TXT11A)         TEXT OFFSET.
          DC  H'1'                      PRINT COLUMN.
          DC  Y(STE111B-STE111A)        OUTPUT LENGTH.
          DC  H'0'                      CONVERSION FLAGS (CHAR)
STE111A   DC  C'ICK30210I INVALID PARENTHESES FOR SPECIFYING REPEATED '
          DC  C'SUBPARAMETER LIST'
STE111B   EQU *
TXT11B    EQU *
          EJECT
*
* INVALID KEYWORD FOUND OR KEYWORD USED IMPROPERLY.
*
TXT12     DC  Y(TXT12B-TXT12A)          ENTRY LENGTH.
FLG12A    DC  X'8000'                   MESSAGE FLAG.
* DOUBLE SPACE SUB-STRUCTURE
TXT12A    DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
          DC  H'2'                      SPACING FACTOR.
          DC  C'R '                     RELATIVE SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
          DC  X'0400'                   EOF AND STATIC FLAGS.
          DC  Y(STE121B-STE121A)        TEXT LENGTH.
          DC  Y(STE121A-TXT12A)         TEXT OFFSET.
          DC  H'1'                      PRINT COLUMN.
          DC  Y(STE121B-STE121A)        OUTPUT LENGTH.
          DC  H'0'                      CONVERSION FLAGS (CHAR)
* BLOCK DATA SUB-STRUCTURE.
         DC  X'1000'                   BLOCK DATA SUB-STRUCTURE.
         DC  H'20'                     DATA LENGTH.
         DC  H'0'                      DATA OFFSET.
         DC  H'20'                     PRINT COLUMN.
         DC  H'20'                     PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* STATIC TEXT SUB-STRUCTURE.
         DC  X'8400'                   EOF & STATIC FLAGS.
         DC  Y(STE122B-STE122A)        STATIC TEXT LENGTH.
         DC  Y(STE122A-TXT12A)         TEXT OFFSET.
         DC  H'0'                      PRINT OFFSET.
         DC  Y(STE122B-STE122A)        PRINT FIELD LENGTH.
         DC  X'0010'                   CONVERSION FLAGS.  (CHAR,BS)
* STATIC TEXT ENTRIES.
STE121A   DC  C'ICK30211I KEYWORD '''
STE121B   EQU *
STE122A  DC  C''' IS IMPROPER'
STE122B  EQU *
TXT12B    EQU *
          EJECT
*
* INVALID LEFT PARENTHESIS FOUND.
*
TXT13     DC  Y(TXT13B-TXT13A)          ENTRY LENGTH.
FLG13A    DC  X'8000'                   MESSAGE FLAG.
* DOUBLE SPACE SUB-STRUCTURE
TXT13A    DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
          DC  H'2'                      SPACING FACTOR.
          DC  C'R '                     RELATIVE SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
          DC  X'0400'                   EOF AND STATIC FLAGS.
          DC  Y(STE131B-STE131A)        TEXT LENGTH.
          DC  Y(STE131A-TXT13A)         TEXT OFFSET.
          DC  H'1'                      PRINT COLUMN.
          DC  Y(STE131B-STE131A)        OUTPUT LENGTH.
          DC  H'0'                      CONVERSION FLAGS (CHAR)
* BLOCK DATA SUB-STRUCTURE.
         DC  X'1000'                   BLOCK DATA FLAG.
         DC  H'20'                     INPUT LENGTH
         DC  H'0'                      INPUT OFFSET
         DC  H'43'                     PRINT COLUMN
         DC  H'20'                     PRINT FIELD LENGTH
         DC  H'0'                      CONVERSION FLAGS  (CHAR)
* STATIC TEXT SUB-STRUCTURE.
         DC  X'8400'                   EOF & STATIC FLAGS
         DC  Y(STE132B-STE132A)        TEXT LENGTH
         DC  Y(STE132A-TXT13A)         TEXT OFFSET
         DC  H'0'                      PRINT OFFSET
         DC  Y(STE132B-STE132A)        PRINT FIELD LENGTH
         DC  X'0010'                   CONVERSION FLAGS  (CHAR,BS)
* STATIC TEXT ENTRIES.
STE131A   DC  C'ICK30212I INVALID LEFT PARENTHESIS AFTER '''
STE131B   EQU *
STE132A   DC  C''''
STE132B   EQU *
TXT13B    EQU *
          EJECT
*
* KEYWORD APPEARS TOO OFTEN.
*
TXT14     DC  Y(TXT14B-TXT14A)          ENTRY LENGTH.
FLG14A    DC  X'8000'                   MESSAGE FLAG.
* DOUBLE SPACE SUB-STRUCTURE
TXT14A    DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
          DC  H'2'                      SPACING FACTOR.
          DC  C'R '                     RELATIVE SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
          DC  X'0400'                   EOF AND STATIC FLAGS.
          DC  Y(STE141B-STE141A)        TEXT LENGTH.
          DC  Y(STE141A-TXT14A)         TEXT OFFSET.
          DC  H'1'                      PRINT COLUMN.
          DC  Y(STE141B-STE141A)        OUTPUT LENGTH.
          DC  H'0'                      CONVERSION FLAGS (CHAR)
* BLOCK DATA SUB-STRUCTURE.
         DC  X'1000'                    BLOCK DATA FLAG
         DC  H'20'                      INPUT LENGTH
         DC  H'0'                       INPUT OFFSET
         DC  H'20'                      PRINT COLUMN
         DC  H'20'                      PRINT FIELD LENGTH
         DC  H'0'                       CONVERSION FLAGS  (CHAR)
* STATIC TEXT SUB-STRUCTURE.
         DC  X'8400'                    EOL & STATIC FLAGS
         DC  Y(STE142B-STE142A)         TEXT LENGTH
         DC  Y(STE142A-TXT14A)          TEXT OFFSET
         DC  H'0'                       PRINT OFFSET
         DC  Y(STE142B-STE142A)         PRINT FIELD LENGTH
         DC  X'0010'                    CONVERSION FLAGS  (CHAR,BS)
* STATIC TEXT ENTRIES.
STE141A   DC  C'ICK30213I KEYWORD '''
STE141B   EQU *
STE142A   DC  C''' APPEARS TOO OFTEN'
STE142B   EQU *
TXT14B    EQU *
          EJECT
*
* HEX OR BINARY VALUE SPECIFIED IMPROPERLY.
*
TXT15     DC  Y(TXT15B-TXT15A)          ENTRY LENGTH.
FLG15A    DC  X'8000'                   MESSAGE FLAG.
* DOUBLE SPACE SUB-STRUCTURE
TXT15A    DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
          DC  H'2'                      SPACING FACTOR.
          DC  C'R '                     RELATIVE SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
          DC  X'8400'                   EOF AND STATIC FLAGS.
          DC  Y(STE151B-STE151A)        TEXT LENGTH.
          DC  Y(STE151A-TXT15A)         TEXT OFFSET.
          DC  H'1'                      PRINT COLUMN.
          DC  Y(STE151B-STE151A)        OUTPUT LENGTH.
          DC  H'0'                      CONVERSION FLAGS (CHAR)
STE151A   DC  C'ICK30214I HEX OR BINARY CONSTANT SPECIFIED IMPROPERLY'
STE151B   EQU *
TXT15B    EQU *
          EJECT
*
* ENTRY 16 IS CURRENTLY UNUSED
*
          EJECT
*
* TEXT HAS BEEN SKIPPED UNTIL NEXT SEMICOLON
*
TXT17     DC  Y(TXT17B-TXT17A)          ENTRY LENGTH.
FLG17A    DC  X'8000'                   MESSAGE FLAG.
* DOUBLE SPACE SUB-STRUCTURE
TXT17A    DC  X'4000'                   SPACE FLAG.
          DC  H'2'                      SPACING FACTOR.
          DC  C'R '                     RELATIVE SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
          DC  X'8400'                   EOF AND STATIC FLAGS.
          DC  Y(STE171B-STE171A)        TEXT LENGTH.
          DC  Y(STE171A-TXT17A)         TEXT OFFSET.
          DC  H'1'                      PRINT COLUMN.
          DC  Y(STE171B-STE171A)        OUTPUT LENGTH.
          DC  H'0'                      CONVERSION FLAGS (CHAR)
* STATIC TEXT ENTRIES.
STE171A   DC  C'ICK30216I ABOVE TEXT BYPASSED UNTIL NEXT COMMAND'
STE171B   EQU *
TXT17B    EQU *
          EJECT
*
* PASSWORD APPEARS IMPROPERLY
*
TXT18     DC  Y(TXT18B-TXT18A)          ENTRY LENGTH.
FLG18A    DC  X'8000'                   MESSAGE FLAG.
* DOUBLE SPACE SUB-STRUCTURE
TXT18A    DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
          DC  H'2'                      SPACING FACTOR.
          DC  C'R '                     RELATIVE SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
          DC  X'0400'                   EOF AND STATIC FLAGS.
          DC  Y(STE181B-STE181A)        TEXT LENGTH.
          DC  Y(STE181A-TXT18A)         TEXT OFFSET.
          DC  H'1'                      PRINT COLUMN.
          DC  Y(STE181B-STE181A)        OUTPUT LENGTH.
          DC  H'0'                      CONVERSION FLAGS (CHAR)
* BLOCK DATA SUB-STRUCTURE.
         DC  X'1000'                    BLOCK FLAG
         DC  H'20'                      INPUT LENGTH
         DC  H'0'                       INPUT OFFSET
         DC  H'36'                      PRINT COLUMN
         DC  H'20'                      PRINT FIELD LENGTH
         DC  H'0'                       CONVERSION FLAGS
* STATIC TEXT SUB-STRUCTURE.
         DC  X'8400'                    EOL & STATIC FLAGS
         DC  Y(STE182B-STE182A)         TEXT LENGTH
         DC  Y(STE182A-TXT18A)          INPUT OFFSET
         DC  H'0'                       PRINT OFFSET
         DC  Y(STE182B-STE182A)         PRINT FIELD LENGTH
         DC  X'0010'                    CONVERSION FLAGS  (CHAR,BS)
* STATIC TEXT ENTRIES.
STE181A   DC  C'ICK30217I PASSWORD IMPROPER AFTER '''
STE181B   EQU *
STE182A   DC  C''''
STE182B   EQU *
TXT18B    EQU *
          EJECT
*
* TOO MANY REPEATED SUBPARAMETER LISTS APPEAR.
*
TXT19     DC  Y(TXT19B-TXT19A)          ENTRY LENGTH.
FLG19A    DC  X'8000'                   MESSAGE FLAG.
* DOUBLE SPACE SUB-STRUCTURE
TXT19A    DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
          DC  H'2'                      SPACING FACTOR.
          DC  C'R '                     RELATIVE SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
          DC  X'8400'                   EOF AND STATIC FLAGS.
          DC  Y(STE191B-STE191A)        TEXT LENGTH.
          DC  Y(STE191A-TXT19A)         TEXT OFFSET.
          DC  H'1'                      PRINT COLUMN.
          DC  Y(STE191B-STE191A)        OUTPUT LENGTH.
          DC  H'0'                      CONVERSION FLAGS (CHAR)
STE191A   DC  C'ICK30218I TOO MANY REPEATED SUBPARAMETER LISTS APPEAR'
STE191B   EQU *
TXT19B    EQU *
          EJECT
*
* VERB NAME UNKNOWN TO XMS PROCESSOR.
*
TXT20     DC  Y(TXT20B-TXT20A)          ENTRY LENGTH.
FLG20A    DC  X'8000'                   MESSAGE FLAG.
* DOUBLE SPACE SUB-STRUCTURE
TXT20A    DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
          DC  H'2'                      SPACING FACTOR.
          DC  C'R '                     RELATIVE SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
          DC  X'0400'                   EOF AND STATIC FLAGS.
          DC  Y(STE201B-STE201A)        TEXT LENGTH.
          DC  Y(STE201A-TXT20A)         TEXT OFFSET.
          DC  H'1'                      PRINT COLUMN.
          DC  Y(STE201B-STE201A)        OUTPUT LENGTH.
          DC  H'0'                      CONVERSION FLAGS (CHAR)
* BLOCK DATA SUB-STRUCTURE.
         DC  X'1000'                    BLOCK FLAG
         DC  H'20'                      INPUT LENGTH
         DC  H'0'                       INPUT OFFSET
         DC  H'22'                      PRINT COLUMN
         DC  H'20'                      PRINT FIELD LENGTH
         DC  H'0'                       CONVERSION FLAGS  (CHAR)
* STATIC TEXT SUB-STRUCTURE.
         DC  X'8400'                    EOL & STATIC FLAGS
         DC  Y(STE202B-STE202A)         TEXT LENGTH
         DC  Y(STE202A-TXT20A)          TEXT OFFSET
         DC  H'0'                       PRINT OFFSET
         DC  Y(STE202B-STE202A)         PRINT FIELD LENGTH
         DC  X'0010'                    CONVERSION FLAGS  (CHAR,BS)
* STATIC TEXT ENTRIES.
STE201A   DC  C'ICK30219I VERB NAME '''
STE201B   EQU *
STE202A   DC  C''' UNKNOWN'
STE202B   EQU *
TXT20B    EQU *
         EJECT
*
* IMPROPER NUMERIC DIGIT FOUND.
*
*
TXT21    DC  Y(TXT21B-TXT21A)          ENTRY LENGTH.
         DC  X'8000'                   MESSAGE FLAG.
* SPACING CONTROL SUB-STRUCTURE.
TXT21A   DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
         DC  H'2'                      SPACING FACTOR.
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC TEXT SUB-STRUCTURE.
         DC  Y(STE211B-STE211A)        STATIC TEXT LENGTH.
         DC  Y(STE211A-TXT21A)         STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE211B-STE211A)        PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* BLOCK DATA SUB-STRUCTURE.
         DC  X'1000'                   BLOCK FLAG
         DC  H'20'                     INPUT LENGTH
         DC  H'0'                      INPUT OFFSET
         DC  H'44'                     PRINT COLUMN
         DC  H'20'                     PRINT FIELD LENGTH
         DC  H'0'                      CONVERSION FLAGS  (CHAR)
* STATIC TEXT SUB-STRUCTURE.
         DC  X'8400'                   EOL & STATIC FLAGS
         DC  Y(STE212B-STE212A)        TEXT LENGTH
         DC  Y(STE212A-TXT21A)         TEXT OFFSET
         DC  H'0'                      PRINT OFFSET
         DC  Y(STE212B-STE212A)        PRINT FIELD LENGTH
         DC  X'0010'                   CONVERSION FLAGS  (CHAR,BS)
* STATIC TEXT ENTRY.
STE211A  DC  C'ICK30220I IMPROPER NUMERIC DIGIT FOUND IN '''
STE211B  EQU *
STE212A  DC  C''''
STE212B  EQU *
TXT21B   EQU *
         EJECT
*
* CONSTANT NOT WITHIN VALUE RANGE
*
*
TXT22    DC  Y(TXT22B-TXT22A)          ENTRY LENGTH.
         DC  X'8000'                   MESSAGE FLAG.
* SPACING CONTROL SUB-STRUCTURE.
TXT22A   DC  X'4000'                   SPAC SUB-STRUCTURE FLAG.
         DC  H'2'                      SPACING FACTOR.
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC TEXT SUB-STRUCTURE.
         DC  Y(STE221B-STE221A)        STATIC TEXT LENGTH.
         DC  Y(STE221A-TXT22A)         STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE221B-STE221A)        PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* BLOCK DATA SUB-STRUCTURE.
         DC  X'1000'                   BLOCK FLAG
         DC  H'20'                     INPUT LENGTH
         DC  H'0'                      INPUT OFFSET
         DC  H'21'                     PRINT COLUMN
         DC  H'20'                     PRINT FIELD LENGTH
         DC  H'0'                      CONVERSION FLAGS  (CHAR)
* STATIC TEXT SUB-STRUCTURE.
         DC  X'8400'                   EOL & STATIC FLAGS
         DC  Y(STE222B-STE222A)        TEXT LENGTH
         DC  Y(STE222A-TXT22A)         TEXT OFFSET
         DC  H'0'                      PRINT OFFSET
         DC  Y(STE222B-STE222A)        PRINT FIELD LENGTH
         DC  X'0010'                   CONVERSION FLAGS  (CHAR,BS)
* STATIC TEXT ENTRY.
STE221A  DC  C'ICK30221I CONSTANT '''
STE221B  EQU *
STE222A  DC  C''' NOT WITHIN VALUE RANGE'
STE222B  EQU *
TXT22B   EQU *
         EJECT
*
* SEMICOLON APPEAR WITHIN QUOTED STRING
*
TXT23    DC  Y(TXT23B-TXT23A)          ENTRY LENGTH.
         DC  X'8000'                   MESSAGE FLAG.
* SPACING CONTROL SUB-STRUCTURE.
TXT23A   DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
         DC  H'2'                      SPACING FACTOR.
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'8400'                   STATIC SUB-STRUCTURE FLAG.
         DC  Y(STE231B-STE231A)        STATIC TEXT LENGTH.
         DC  Y(STE231A-TXT23A)         STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE231B-STE231A)        PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS. (CHAR)
* STATIC TEXT ENTRY.
STE231A  DC  C'ICK00222I WARNING: COMMAND-END DELIMITER APPEARS WITHIN'
         DC  C' APOSTROPHES'
STE231B  EQU *
TXT23B   EQU *
         EJECT
*
* TOO MANY SCALARS APPEAR IN A LIST.
*
*
TXT24    DC  Y(TXT24B-TXT24A)          ENTRY LENGTH.
         DC  X'8000'                   MESSAGE FLAGS.
* SPACING SUB-STRUCTURE.
TXT24A   DC  X'4000'                   SPACE CONTROL FLAGS.
         DC  H'2'                      SPACING FLAGS.
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC SUB-STRUCTURE FLAG.
         DC  Y(STE241B-STE241A)        STATIC TEXT LENGTH.
         DC  Y(STE241A-TXT24A)         STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE241B-STE241A)        PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* BLOCK DATA SUB-STRUCTURE.
         DC  X'1000'                   BLOCK FLAG
         DC  H'20'                     INPUT LENGTH
         DC  H'0'                      INPUT OFFSET
         DC  H'52'                     PRINT COLUMN
         DC  H'20'                     PRINT FIELD LENGTH
         DC  H'0'                      CONVERSION FLAGS  (CHAR)
* STATIC TEXT SUB-STRUCTURE.
         DC  X'8400'                   EOL & STATIC FLAGS
         DC  Y(STE242B-STE242A)        TEXT LENGTH
         DC  Y(STE242A-TXT24A)         TEXT OFFSET
         DC  H'0'                      PRINT OFFSET
         DC  Y(STE242B-STE242A)        PRINT FIELD LENGTH
         DC  X'0010'                   CONVERSION FLAGS  (CHAR,BS)
* STATIC TEXT ENTRY.
STE241A  DC  C'ICK30223I TOO MANY CONSTANTS IN LIST BEGINNING AT '''
STE241B  EQU *
STE242A  DC  C''''
STE242B  EQU *
TXT24B   EQU *
         EJECT
*
* ENTRY 25 IS CURRENTLY UNUSED
*
*
         EJECT
*
* A REQUIRED PARAMETER IS MISSING.
*
*
TXT26    DC  Y(TXT26B-TXT26A)          ENTRY LENGTH.
         DC  X'8000'                   MESSAGE FLAG.
* SPACING CONTROL SUB-STRUCTURE.
TXT26A   DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
         DC  H'2'                      SPACING FACTOR.
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC SUB-STRUCTURE FLAG.
         DC  Y(STE261B-STE261A)        STATIC TEXT LENGTH.
         DC  Y(STE261A-TXT26A)         STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE261B-STE261A)        PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* BLOCK DATA SUB-STRUCTURE.
         DC  X'1000'                   BLOCK FLAG
         DC  H'20'                     INPUT LENGTH
         DC  H'0'                      INPUT OFFSET
         DC  H'39'                     PRINT COLUMN
         DC  H'20'                     PRINT FIELD LENGTH
         DC  H'0'                      CONVERSION FLAGS  (CHAR)
* STATIC TEXT SUB-STRUCTURE.
         DC  X'8400'                   EOL & STATIC FLAGS
         DC  Y(STE262B-STE262A)        TEXT LENGTH
         DC  Y(STE262A-TXT26A)         TEXT OFFSET
         DC  H'0'                      PRINT OFFSET
         DC  Y(STE262B-STE262A)        PRINT FIELD LENGTH
         DC  X'0010'                   CONVERSION FLAGS  (CHAR,BS)
* STATIC TEXT ENTRY.
STE261A  DC  C'ICK30225I REQUIRED (SUB)PARAMETER OF '''
STE261B  EQU *
STE262A  DC  C''' IS MISSING'
STE262B  EQU *
TXT26B   EQU *
         EJECT
*
* AN IMPROPER COMBINATION OF PARAMETERS EXISTS.
*
*
TXT27    DC  Y(TXT27B-TXT27A)          ENTRY LENGTH.
         DC  X'8000'                   MESSAGE FLAG.
* SPACING CONTROL SUB-STRUCTURE.
TXT27A   DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
         DC  H'2'                      SPACING FACTOR.
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC SUB-STRUCTURE FLAG.
         DC  Y(STE271B-STE271A)        STATIC TEXT LENGTH.
         DC  Y(STE271A-TXT27A)         STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE271B-STE271A)        PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* BLOCK DATA SUB-STRUCTURE.
         DC  X'1000'                   BLOCK FLAG
         DC  H'20'                     INPUT LENGTH
         DC  H'0'                      INPUT OFFSET
         DC  H'45'                     PRINT COLUMN
         DC  H'20'                     PRINT FIELD LENGTH
         DC  H'0'                      CONVERSION FLAGS  (CHAR)
* STATIC TEXT SUB-STRUCTURE.
         DC  X'8400'                   EOL & STATIC FLAGS
         DC  Y(STE272B-STE272A)        TEXT LENGTH
         DC  Y(STE272A-TXT27A)         TEXT OFFSET
         DC  H'0'                      PRINT OFFSET
         DC  Y(STE272B-STE272A)        PRINT FIELD LENGTH
         DC  X'0010'                   CONVERSION FLAGS  (CHAR,BS)
* STATIC TEXT ENTRY.
STE271A  DC  C'ICK30226I INCONSISTENT PARAMETERS INVOLVING '''
STE271B  EQU *
STE272A  DC  C''''
STE272B  EQU *
TXT27B   EQU *
         EJECT
*
* AN ELSE COMMAND APPEARS IMPROPERLY.
*
TXT28    DC  Y(TXT28B-TXT28A)          ENTRY LENGTH.
         DC  X'8000'                   MESSAGE FLAG.
* SPACING CONTROL SUB-STRUCTURE.
TXT28A   DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
         DC  H'2'                      SPACING FACTOR.
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'8400'                   STATIC SUB-STRUCTURE FLAG.
         DC  Y(STE281B-STE281A)        STATIC TEXT LENGTH.
         DC  Y(STE281A-TXT28A)         STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE281B-STE281A)        PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* STATIC TEXT ENTRY.
STE281A  DC  C'ICK40227I AN ''ELSE'' COMMAND APPEARS IMPROPERLY'
STE281B  EQU *
TXT28B   EQU *
         EJECT
*
* AN END COMMAND IS INVALID.
*
*
TXT29    DC  Y(TXT29B-TXT29A)          ENTRY LENGTH.
         DC  X'8000'                   MESSAGE FLAG.
* SPACING CONTROL SUB-STRUCTURE.
TXT29A   DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
         DC  H'2'                      SPACING FACTOR.
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'8400'                   STATIC SUB-STRUCTURE FLAG.
         DC  Y(STE291B-STE291A)        STATIC TEXT LENGTH.
         DC  Y(STE291A-TXT29A)         STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE291B-STE291A)        PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* STATIC TEXT ENTRY.
STE291A  DC  C'ICK40228I AN ''END'' COMMAND IS INVALID'
STE291B  EQU *
TXT29B   EQU *
         EJECT
*
* IF COMMAND HAS INVALID RELATIONAL EXPRESSION.
*
TXT30    DC  Y(TXT30B-TXT30A)          ENTRY LENGTH.
         DC  X'8000'                   MESSAGE FLAG
* SPACING CONTROL SUB-STRUCTURE.
TXT30A   DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
         DC  H'2'                      SPACING FACTOR.
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'8400'                   STATIC SUB-STRUCTURE FLAG.
         DC  Y(STE301B-STE301A)        STATIC TEXT LENGTH.
         DC  Y(STE301A-TXT30A)         STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE301B-STE301A)        PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* STATIC TEXT ENTRY.
STE301A  DC  C'ICK40229I ''IF'' COMMAND HAS INVALID RELATIONAL '
         DC  C'EXPRESSION'
STE301B  EQU *
TXT30B   EQU *
         EJECT
*
* SET COMMAND HAS INVALID ASSIGNMENT EXPRESSION.
*
*
TXT31    DC  Y(TXT31B-TXT31A)          ENTRY LENGTH.
         DC  X'8000'                   MESSAGE FLAG
* SPACING CONTROL SUB-STRUCTURE.
TXT31A   DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
         DC  H'2'                      SPACING FACTOR.
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'8400'                   STATIC SUB-STRUCTURE FLAG.
         DC  Y(STE311B-STE311A)        STATIC TEXT LENGTH.
         DC  Y(STE311A-TXT31A)         STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE311B-STE311A)        PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* STATIC TEXT ENTRY.
STE311A  DC  C'ICK40230I ''SET'' COMMAND HAS INVALID ASSIGNMENT '
         DC  C'EXPRESSION'
STE311B   EQU *
TXT31B   EQU *
         EJECT
*
* ENTRY 32 IS CURRENTLY UNUSED
*
*
         EJECT
*
* IMPROPER OR MISSING THEN KEYWORD.
*
TXT33    DC  Y(TXT33B-TXT33A)          ENTRY LENGTH.
         DC  X'8000'                   MESSAGE FLAG.
* SPACING CONTROL SUB-STRUCTURE.
TXT33A   DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
         DC  H'2'                      SPACING FACTOR.
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'8400'                   STATIC SUB-STRUCTURE FLAG.
         DC  Y(STE331B-STE331A)        STATIC TEXT LENGTH.
         DC  Y(STE331A-TXT33A)         STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE331B-STE331A)        PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS  (CHAR)
* STATIC TEXT ENTRY.
STE331A  DC  C'ICK40232I IMPROPER OR MISSING ''THEN'' KEYWORD'
STE331B  EQU *
TXT33B   EQU *
         EJECT
*
* TOO MANY RIGHT PARENTHESES AT COMMAND END - EXCESS IGNORED.
*
*
TXT34    DC  Y(TXT34B-TXT34A)          ENTRY LENGTH.
         DC  X'8000'                   MESSAGE FLAG.
* SPACING CONTROL SUB-STRUCTURE.
TXT34A   DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
         DC  H'2'                      SPACING FACTOR.
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'8400'                   STATIC SUB-STRUCTURE FLAG.
         DC  Y(STE341B-STE341A)        STATIC TEXT LENGTH.
         DC  Y(STE341A-TXT34A)         STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE341B-STE341A)        PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS. (CHAR)
* STATIC TEXT ENTRY.
STE341A  DC  C'ICK00233I TOO MANY RIGHT PARENTHESES '
         DC  C'FOUND.  EXCESS IGNORED'
STE341B  EQU *
TXT34B   EQU *
         EJECT
*
*
* TOO FEW RIGHT PARENTHESES FOUND AT COMMAND END.
*
*
TXT35    DC  Y(TXT35B-TXT35A)          ENTRY LENGTH.
         DC  X'8000'                   MESSAGE FLAG.
* SPACING CONTROL SUB-STRUCTURE.
TXT35A   DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
         DC  H'2'                      SPACING FACTOR.
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'8400'                   STATIC SUB-STRUCTURE FLAG.
         DC  Y(STE351B-STE351A)        STATIC TEXT LENGTH.
         DC  Y(STE351A-TXT35A)         STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE351B-STE351A)        PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* STATIC TEXT ENTRY.
STE351A  DC  C'ICK00234I WARNING: TOO FEW RIGHT PARENTHESES FOUND AT '
         DC  C'END OF COMMAND'
STE351B  EQU *
TXT35B   EQU *
         EJECT
*
* ENTRY 36 IS CURRENTLY UNUSED.
*
         EJECT
*
* SYSIN END-OF-FILE OCCURRED BEFORE END OF CURRENT COMMAND.
*
*
TXT37    DC  Y(TXT37B-TXT37A)          ENTRY LENGTH.
         DC  X'8000'                   MESSAGE FLAG.
* SPACING CONTROL SUB-STRUCTURE.
TXT37A   DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
         DC  H'2'                      SPACING FACTOR.
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'8400'                   STATIC SUB-STRUCTURE FLAG.
         DC  Y(STE371B-STE371A)        STATIC TEXT LENGTH.
         DC  Y(STE371A-TXT37A)         STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE371B-STE371A)        PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.
* STATIC TEXT ENTRY.
STE371A  DC  C'ICK40236I INPUT STREAM END-OF-FILE FOUND BEFORE END'
         DC  C' OF COMMAND'
STE371B  EQU *
TXT37B   EQU *
         EJECT
*
* TOO MUCH NESTING OF 'IF' MODAL COMMANDS
*
*
TXT38    DC  Y(TXT38B-TXT38A)          ENTRY LENGTH.
         DC  X'8000'                   MESSAGE FLAG.
* SPACING CONTROL SUB-STRUCTURE.
TXT38A   DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
         DC  H'2'                      SPACING FACTOR.
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'8400'                   STATIC SUB-STRUCTURE FLAG.
         DC  Y(STE381B-STE381A)        STATIC TEXT LENGTH.
         DC  Y(STE381A-TXT38A)         STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE381B-STE381A)        PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.
* STATIC TEXT ENTRY.
STE381A  DC  C'ICK40237I TOO MANY LEVELS OF ''IF'' COMMAND NESTING'
STE381B  EQU *
TXT38B   EQU *
         EJECT
*
* PRINT COMMAND STREAM INPUT RECORD
*
*
TXT39    DC  Y(TXT39B-TXT39A)          ENTRY LENGTH.
         DC  X'0000'                   MESSAGE FLAG.
* BLOCK DATA SUB-STRUCTURE.
TXT39A   DC  X'9000'                   BLOCK DATA SUB-STRUCTURE FLAG.
         DC  H'32767'                  INPUT MAXIMUM RECORD LENGTH
         DC  H'0'                      INPUT FIELD OFFSET
         DC  H'1'                      PRINT COLUMN.
         DC  H'32767'                  OUTPUT FIELD MAXIMUM LENGTH
         DC  H'0'                      CONVERSION FLAGS.
TXT39B   EQU *
         END
