* /* START OF SPECIFICATIONS ****
*
*01* MODULE-NAME = ICKTSSA0
*01* MODULE-TYPE = MODULE
*02*   PROCESSOR = ASSEMBLER
*
**** END OF SPECIFICATIONS **
         TITLE  '***** ICKTSSA0 - SYS ADAPTER STATIC TEXT       *****'
**********************************************************************
*                                                                    *
* MODULE NAME - ICKTSSA0 - STATIC TEXT MODULE FOR SYSTEM ADAPTER     *
*                                                                    *
*                                                                    *
* DESCRIPTIVE NAME - STATIC TEXT MODULE FOR THE SYSTEM ADAPTER       *
*                                                                    *
*                                                                    *
* COPYRIGHT - NONE                                                   *
*                                                                    *
* STATUS - RELEASE-1 VERSION-0                                       *
*                                                                    *
* FUNCTION - CONTAINS NO EXECUTABLE CODE, ONLY STATIC TEXT ENTRIES   *
*                                                                    *
*        THIS MODULE IS LOADED BY ICKTP05 WHEN A STATIC TEXT         *
*        REQUEST IS MADE.                                            *
*                                                                    *
* NOTES - NONE                                                       *
*                                                                    *
*    DEPENDENCIES - NONE                                             *
*    RESTRICTIONS - NONE                                             *
*    REGISTER CONVENTIONS - NA                                       *
*    PATCH AREA - NA                                                 *
*                                                                    *
* MODULE TYPE - TABLES                                               *
*                                                                    *
*    PROCESSOR - ASSEMBLER                                           *
*    MODULE SIZE - 0693 BYTES                                        *
*    ATTRIBUTES - READ-ONLY                                          *
*                                                                    *
*  ENTRY POINT - NA                                                  *
*                                                                    *
*  EXIT NORMAL - NA                                                  *
*                                                                    *
*  EXIT ERROR - NA                                                   *
*                                                                    *
*  EXTERNAL REFERENCES - NA                                          *
*                                                                    *
*  TABLES - NA                                                       *
*                                                                    *
*  MACROS - NA                                                       *
*                                                                    *
* CHANGE ACTIVITY - NONE                                     @G840B00*
*                                                                    *
**********************************************************************
*
**********************************************************************
*                                                                    *
* THIS MODULE IS THE FIRST MODULE OF STATIC TEXT REQUIRED BY THE     *
* SYSTEM SERVICE ROUTINE.                                            *
*                                                                    *
**********************************************************************
*
ICKTSSA0  CSECT
*
**********************************************************************
*                                                                    *
* THIS SECTION CONTAINS THE INDICES TO REACH AN ENTRY.               *
*                                                                    *
**********************************************************************
*
INDEX     DC  AL2((LASTINDX-INDEX1)/2)  COUNT OF ENTRIES
INDEX1    DC  Y(TXT1-INDEX)             UNABLE TO SCRATCH DSN
INDEX2    DC  Y(TXT2-INDEX)             NO VOLUME MOUNTED
INDEX3    DC  H'-1'                     (UNUSED)
INDEX4    DC  Y(TXT4-INDEX)             BAD PASSWORD
INDEX5    DC  Y(TXT5-INDEX)             NON-EXPIRED DSN ON VOLUME
INDEX6    DC  Y(TXT6-INDEX)             PERM I/O ERROR ON VOLUME
INDEX7    DC  Y(TXT7-INDEX)             UNABLE TO MOUNT VOLUME
INDEX8    DC  Y(TXT8-INDEX)             DATA SET WAS IN USE
INDEX9    DC  Y(TXT9-INDEX)             NO RACF PROFILE ON 'ENTITY'
INDEX10   DC  Y(TXT10-INDEX)            URACHECK FAILED FOR 'ENTITY'
INDEX11   DC  Y(TXT11-INDEX)            INVALID RACF PARM LIST
INDEX12   DC  Y(TXT12-INDEX)            INVALID RACF AUTHORIZATION
*                                                                    *
**********************************************************************
*                                       INSERT ALL INDEX             *
LASTINDX EQU   *                        NUMBERS BEFORE THIS          *
*                                       BOX                          *
**********************************************************************
          EJECT
**********************************************************************
*                                                                    *
* THIS SECTION CONTAINS THE ENTRIES.                                 *
*                                                                    *
**********************************************************************
          SPACE 2
*
* DATA SET COULD NOT BE SCRATCHED MESSAGE.
*
TXT1      DC    Y(TXT1B-TXT1A)          ENTRY LENGTH.
          DC    X'8000'                 MESSAGE FLAG.
* DOUBLE SPACE SUB-STRUCTURE.
TXT1A     DC    X'4000'                 SPACE CONTROL FLAG.
          DC    H'2'                    SPACING FACTOR.
          DC    C'R '                   SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
          DC    X'0400'                 STATIC TEXT FLAG.
          DC    Y(STE11B-STE11A)        STATIC TEXT LENGTH.
          DC    Y(STE11A-TXT1A)         STATIC TEXT OFFSET.
          DC    H'1'                    PRINT COLUMN NO.
          DC    Y(STE11B-STE11A)        PRINT FIELD LENGTH
          DC    H'0'                    CONVERSION FLAGS(CHAR)
* BLOCK DATA SUB-STRUCTURE.
          DC    X'9000'                 EOF & BLOCK DATA FLAGS
          DC    H'44'                   INPUT DATA LENGTH.
          DC    H'0'                    INPUT DATA OFFSET
          DC    H'29'                   PRINT COLUMN.
          DC    H'44'                   PRINT FIELD LENGTH
          DC    H'0'                    CONVERSION FLAGS(CHAR)
* STATIC ENTRY.
STE11A    DC    C'ICK20800I UNABLE TO SCRATCH '
STE11B    EQU *
TXT1B     EQU *
          EJECT
*
* NO VOLUME MOUNTED MESSAGE.
*
TXT2      DC    Y(TXT2B-TXT2A)          ENTRY LENGTH.
          DC    X'A000'                 MESSAGE FLAG.
* STATIC TEXT SUB-STRUCTURE.
TXT2A     DC    X'8400'                 STATIC TEXT FLAG.
          DC    Y(STE21B-STE21A)        STATIC TEXT LENGTH.
          DC    Y(STE21A-TXT2A)         STATIC TEXT OFFSET.
          DC    H'1'                    PRINT COLUMN.
          DC    Y(STE21B-STE21A)        PRINT FIELD LENGTH.
          DC    H'0'                    CONVERSION FLAGS(CHAR)
* STATIC TEXT ENTRY.
STE21A    DC  C'ICK20801I ** NO VOLUME MOUNTED'
STE21B    EQU *
TXT2B     EQU *
          EJECT
*
* DATA SET NOT ON VOLUME MESSAGE.NO LONGER ISSUED
*
          EJECT
*
* PASSWORD VERIFICATION FAILED MESSAGE.
*
TXT4      DC    Y(TXT4B-TXT4A)          ENTRY LENGTH.
          DC    X'A000'                 MESSAGE FLAG.
* STATIC TEXT SUB-STRUCTURE.
TXT4A     DC    X'8400'                 STATIC TEXT FLAG.
          DC    Y(STE41B-STE41A)        STATIC TEXT LENGTH.
          DC    Y(STE41A-TXT4A)         STATIC TEXT OFFSET.
          DC    H'1'                    PRINT COLUMN.
          DC    Y(STE41B-STE41A)        PRINT FIELD LENGTH.
          DC    H'0'                    CONVERSION FLAGS(CHAR)
* STATIC TEXT ENTRY.
STE41A    DC  C'ICK20802I ** PASSWORD VERIFICATION FAILED'
STE41B    EQU *
TXT4B     EQU *
          EJECT
*
* NON-EXPIRED DATA SET ON VOLUME MESSAGE.
*
TXT5      DC    Y(TXT5B-TXT5A)          ENTRY LENGTH.
          DC    X'A000'                 MESSAGE FLAG.
* STATIC TEXT SUB-STRUCTURE.
TXT5A     DC    X'0400'                 STATIC TEXT FLAG.
          DC    Y(STE51B-STE51A)        STATIC TEXT LENGTH.
          DC    Y(STE51A-TXT5A)         STATIC TEXT OFFSET.
          DC    H'1'                    PRINT COLUMN NO.
          DC    Y(STE51B-STE51A)        PRINT FIELD LENGTH
          DC    H'0'                    CONVERSION FLAGS(CHAR)
* BLOCK DATA SUB-STRUCTURE.
          DC    X'9000'                 EOF & BLOCK DATA FLAGS
          DC    H'6'                    INPUT DATA LENGTH.
          DC    H'0'                    INPUT DATA OFFSET
          DC    H'49'                   PRINT COLUMN.
          DC    H'6'                    PRINT FIELD LENGTH
          DC    H'0'                    CONVERSION FLAGS(CHAR)
* STATIC ENTRY.
STE51A    DC    C'ICK20803I ** DATA SET HAS NOT EXPIRED ON '
          DC    C'VOLUME '
STE51B    EQU *
TXT5B     EQU *
          EJECT
*
* PERMANENT I/O ERROR ON VOLUME MESSAGE.
*
TXT6      DC    Y(TXT6B-TXT6A)          ENTRY LENGTH.
          DC    X'A000'                 MESSAGE FLAG.
* STATIC TEXT SUB-STRUCTURE.
TXT6A     DC    X'0400'                 STATIC TEXT FLAG.
          DC    Y(STE61B-STE61A)        STATIC TEXT LENGTH.
          DC    Y(STE61A-TXT6A)         STATIC TEXT OFFSET.
          DC    H'1'                    PRINT COLUMN NO.
          DC    Y(STE61B-STE61A)        PRINT FIELD LENGTH
          DC    H'0'                    CONVERSION FLAGS(CHAR)
* BLOCK DATA SUB-STRUCTURE.
          DC    X'9000'                 EOF & BLOCK DATA FLAGS
          DC    H'6'                    INPUT DATA LENGTH.
          DC    H'0'                    INPUT DATA OFFSET
          DC    H'44'                   PRINT COLUMN.
          DC    H'6'                    PRINT FIELD LENGTH
          DC    H'0'                    CONVERSION FLAGS(CHAR)
* STATIC ENTRY.
STE61A    DC    C'ICK20804I ** PERMANENT I/O ERROR ON VOLUME '
STE61B    EQU *
TXT6B     EQU *
          EJECT
*
* UNABLE TO MOUNT VOLUME MESSAGE.
*
TXT7      DC    Y(TXT7B-TXT7A)          ENTRY LENGTH.
          DC    X'A000'                 MESSAGE FLAG.
* STATIC TEXT SUB-STRUCTURE.
TXT7A     DC    X'0400'                 STATIC TEXT FLAG.
          DC    Y(STE71B-STE71A)        STATIC TEXT LENGTH.
          DC    Y(STE71A-TXT7A)         STATIC TEXT OFFSET.
          DC    H'1'                    PRINT COLUMN NO.
          DC    Y(STE71B-STE71A)        PRINT FIELD LENGTH
          DC    H'0'                    CONVERSION FLAGS(CHAR)
* BLOCK DATA SUB-STRUCTURE.
          DC    X'9000'                 EOF & BLOCK DATA FLAGS
          DC    H'6'                    INPUT DATA LENGTH.
          DC    H'0'                    INPUT DATA OFFSET
          DC    H'37'                   PRINT COLUMN.
          DC    H'6'                    PRINT FIELD LENGTH
          DC    H'0'                    CONVERSION FLAGS(CHAR)
* STATIC ENTRY.
STE71A    DC    C'ICK20805I ** UNABLE TO MOUNT VOLUME '
STE71B    EQU *
TXT7B     EQU *
          EJECT
*
* DATA SET WAS IN USE MESSAGE.
*
TXT8      DC    Y(TXT8B-TXT8A)          ENTRY LENGTH.
          DC    X'A000'                 MESSAGE FLAG.
* STATIC TEXT SUB-STRUCTURE.
TXT8A    DC    X'8400'                  STATIC TEXT FLAG.
          DC    Y(STE81B-STE81A)        STATIC TEXT LENGTH.
          DC    Y(STE81A-TXT8A)         STATIC TEXT OFFSET.
          DC    H'1'                    PRINT COLUMN NO.
          DC    Y(STE81B-STE81A)        PRINT FIELD LENGTH
          DC    H'0'                    CONVERSION FLAGS(CHAR)
* STATIC ENTRY.
STE81A    DC    C'ICK20806I ** DATA SET WAS IN USE'
STE81B    EQU *
TXT8B     EQU *
          EJECT
*
* NO RACF PROFILE NO 'ENTITY' MESSAGE.
*
TXT9      DC    Y(TXT9B-TXT9A)          ENTRY LENGTH.
          DC    X'8000'                 MESSAGE FLAG.
* DOUBLE SPACE SUB-STRUCTURE.
TXT9A     DC    X'4000'                 SPACE CONTROL FLAG.
          DC    H'2'                    SPACING FACTOR.
          DC    C'R '                   SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
          DC    X'0400'                 STATIC TEXT FLAG.
          DC    Y(STE91B-STE91A)        STATIC TEXT LENGTH.
          DC    Y(STE91A-TXT9A)         STATIC TEXT OFFSET.
          DC    H'1'                    PRINT COLUMN NO.
          DC    Y(STE91B-STE91A)        PRINT FIELD LENGTH
          DC    H'0'                    CONVERSION FLAGS(CHAR)
* BLOCK DATA SUB-STRUCTURE.
          DC    X'9000'                 EOF & BLOCK DATA FLAGS
          DC    H'44'                   INPUT DATA LENGTH.
          DC    H'0'                    INPUT DATA OFFSET
          DC    H'30'                   PRINT COLUMN.
          DC    H'44'                   PRINT FIELD LENGTH
          DC    H'0'                    CONVERSION FLAGS(CHAR)
* STATIC ENTRY.
STE91A    DC    C'ICK20807I NO RACF PROFILE ON '
STE91B    EQU *
TXT9B     EQU *
          EJECT
*
* RACHECK FAILED FOR 'ENTITY' MESSAGE.
*
TXT10     DC    Y(TXT10B-TXT10A)        ENTRY LENGTH.
          DC    X'8000'                 MESSAGE FLAG.
* DOUBLE SPACE SUB-STRUCTURE.
TXT10A    DC    X'4000'                 SPACE CONTROL FLAG.
          DC    H'2'                    SPACING FACTOR.
          DC    C'R '                   SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
          DC    X'0400'                 STATIC TEXT FLAG.
          DC    Y(STE101B-STE101A)      STATIC TEXT LENGTH.
          DC    Y(STE101A-TXT10A)       STATIC TEXT OFFSET.
          DC    H'1'                    PRINT COLUMN NO.
          DC    Y(STE101B-STE101A)      PRINT FIELD LENGTH
          DC    H'0'                    CONVERSION FLAGS(CHAR)
* BLOCK DATA SUB-STRUCTURE.
          DC    X'9000'                 EOF & BLOCK DATA FLAGS
          DC    H'44'                   INPUT DATA LENGTH.
          DC    H'0'                    INPUT DATA OFFSET
          DC    H'30'                   PRINT COLUMN.
          DC    H'44'                   PRINT FIELD LENGTH
          DC    H'0'                    CONVERSION FLAGS(CHAR)
* STATIC ENTRY.
STE101A   DC    C'ICK20808I RACHECK FAILED FOR '
STE101B   EQU *
TXT10B    EQU *
          EJECT
*
* INVALID URACHECK PARAMETER LIST MESSAGE.
*
TXT11     DC    Y(TXT11B-TXT11A)        ENTRY LENGTH.
          DC    X'A000'                 MESSAGE FLAG.
* STATIC TEXT SUB-STRUCTURE.
TXT11A    DC    X'8400'                 STATIC TEXT FLAG.
          DC    Y(STE111B-STE111A)      STATIC TEXT LENGTH.
          DC    Y(STE111A-TXT11A)       STATIC TEXT OFFSET.
          DC    H'1'                    PRINT COLUMN.
          DC    Y(STE111B-STE111A)      PRINT FIELD LENGTH.
          DC    H'0'                    CONVERSION FLAGS(CHAR)
* STATIC TEXT ENTRY.
STE111A   DC  C'ICK20809I INVALID URACHECK PARAMETER LIST'
STE111B   EQU *
TXT11B    EQU *
          EJECT
*
* INVALID RACF AUTHORIZATION   MESSAGE.
*
TXT12     DC    Y(TXT12B-TXT12A)        ENTRY LENGTH.
          DC    X'A000'                 MESSAGE FLAG.
* STATIC TEXT SUB-STRUCTURE.
TXT12A    DC    X'8400'                 STATIC TEXT FLAG.
          DC    Y(STE121B-STE121A)      STATIC TEXT LENGTH.
          DC    Y(STE121A-TXT12A)       STATIC TEXT OFFSET.
          DC    H'1'                    PRINT COLUMN.
          DC    Y(STE121B-STE121A)      PRINT FIELD LENGTH.
          DC    H'0'                    CONVERSION FLAGS(CHAR)
* STATIC TEXT ENTRY.
STE121A   DC  C'ICK20810I ** INVALID RACF AUTHORIZATION'
STE121B   EQU *
TXT12B    EQU *
          EJECT
          END
