         TITLE '*****ICKTSTP1 - TEXT PROCESSOR STATIC TEXT *****'
**********************************************************************
*                                                                    *
* MODULE NAME - ICKTSTP1 - STATIC TEXT MODULE FOR TEXT PROCESSOR     *
*        THIS MODULE CONTAINS THE MESSAGES FOR THE TEXT PROCESSOR.   *
*                                                                    *
* DESCRIPTIVE NAME - STATIC TEXT MODULE FOR THE TEXT PROCESSOR       *
*                                                                    *
* COPYRIGHT - NONE                                                   *
*                                                                    *
* STATUS - RELEASE-1 VERSION-0                                       *
*                                                                    *
* FUNCTION - CONTAINS NO EXECUTABLE CODE, ONLY STATIC TEXT ENTRIES   *
*        FOR THE TEXT PROCESSOR                                      *
*        THIS MODULE IS LOADED BY ICKTP05 WHEN A STATIC TEXT         *
*        REQUEST IS MADE.                                            *
*                                                                    *
* NOTES - NONE                                                       *
*                                                                    *
*    DEPENDENCIES - NONE                                             *
*    RESTRICTIONS - NONE                                             *
*    REGISTER CONVENTIONS - NA                                       *
*    PATCH AREA - NA                                                 *
*                                                                    *
* MODULE TYPE - TABLES                                               *
*                                                                    *
*    PROCESSOR - ASSEMBLER                                           *
*    MODULE SIZE - 368 BYTES                                         *
*    ATTRIBUTES - READ-ONLY                                          *
*                                                                    *
*  ENTRY POINT - NA                                                  *
*                                                                    *
*  EXIT NORMAL - NA                                                  *
*                                                                    *
*  EXIT ERROR - NA                                                   *
*                                                                    *
*  EXTERNAL REFERENCES - NA                                          *
*                                                                    *
*  TABLES - NA                                                       *
*                                                                    *
*  MACROS - NA                                                       *
*                                                                    *
* CHANGE ACTIVITY - NONE                                     @G840B00*
*                                                                    *
**********************************************************************
*
*********************************************************************
*                                                                    *
* THIS MODULE IS THE SECOND MODULE OF STATIC TEXT REQUIRED BY THE    *
* TEXT PROCESSING ROUTINES.                                          *
*                                                                    *
********************************************************************
*
*
ICKTSTP1  CSECT
*
* THIS SECTION CONTAINS THE INDICES TO REACH AN ENTRY.
*
INDEX     DC  H'7'                      NULL INDEX VALUE.
INDEX1    DC  Y(TXT1-INDEX)             FORMAT ERROR
INDEX2    DC  Y(TXT2-INDEX)             OUT COL ERROR
INDEX3    DC  Y(TXT3-INDEX)             LONG LENGTH FIELD
INDEX4    DC  Y(TXT4-INDEX)             NESTED REDO
INDEX5    DC  H'-1'                     NULL ENTRY
INDEX6    DC  Y(TXT6-INDEX)             MISSING ENTRY
INDEX7    DC  Y(TXT7-INDEX)             INVALID DECIMAL
          EJECT
**********************************************************************
*                                                                    *
* THIS SECTION CONTAINS THE ENTRIES.                                 *
*                                                                    *
**********************************************************************
*
* AN INVALID FORMAT STRUCTURE HAS BEEN ENCOUNTERED.
*
TXT1      DC  Y(TXT1B-TXT1A)            LENGTH.
FLG1A     DC  X'8000'                   MESSAGE FLAG.
* STATIC TEXT SUB-STRUCTURE.
TXT1A     DC  X'8400'                   EOF & STATIC FLAGS.
          DC  Y(STE11B-STE11A)          STATIC TEXT LENGTH.
          DC  Y(STE11A-TXT1A)           STATIC TEXT OFFSET.
          DC  H'1'                      PRINT COLUMN.
          DC  Y(STE11B-STE11A)          OUTPUT LENGTH.
          DC  H'0'                      CONVERSION FLAGS. (CHAR)
* STATIC TEXT ENTRY.
STE11A    DC  C'ICK20950I  INVALID FORMAT STRUCTURE'
STE11B    EQU *
TXT1B     EQU *
          EJECT
*
* AN OUTPUT COLUMN HAS BEEN SPECIFIED BEYOND THE LINE WIDTH.
*
TXT2      DC  Y(TXT2B-TXT2A)            LENGTH.
FLG2A     DC  X'8000'                   MESSAGE FLAG.
* STATIC TEXT SUB-STRUCTURE.
TXT2A     DC  X'8400'                   EOF AND STATIC FLAGS.
          DC  Y(STE21B-STE21A)          STATIC TEXT LENGTH.
          DC  Y(STE21A-TXT2A)           STATIC TEXT OFFSET.
          DC  H'1'                      PRINT COLUMN.
          DC  Y(STE21B-STE21A)          PRINT FIELD LENGTH.
          DC  H'0'                      CONVERSION FLAGS. (CHAR)
* STATIC TEXT ENTRY.
STE21A    DC  C'ICK20951I  OUTPUT COLUMN SPECIFIED OUT OF RANGE'
STE21B    EQU *
TXT2B     EQU *
          EJECT
*
* A FIELD HAS BEEN ENCOUNTERED WHOSE LENGTH EXCEEDS THE ALLOWABLE
* MAXIMUM.
*
TXT3      DC  Y(TXT3B-TXT3A)            LENGTH.
FLG3A     DC  X'8000'                   MESSAGE FLAG.
* STATIC TEXT SUB-STRUCTURE.
TXT3A     DC  X'8400'                   EOF AND STATIC FLAGS.
          DC  Y(STE31B-STE31A)          STATIC TEXT LENGTH.
          DC  Y(STE31A-TXT3A)           STATIC TEXT OFFSET.
          DC  H'1'                      PRINT COLUMN.
          DC  Y(STE31B-STE31A)          PRINT FIELD LENGTH.
          DC  H'0'                      CONVERSION FLAGS. (CHAR)
* STATIC TEXT ENTRY.
STE31A    DC  C'ICK20952I  EXCESSIVE FIELD LENGTH FOR BD OR PU CONV'
STE31B    EQU *
TXT3B     EQU *
          EJECT
*
* A REQUEST FOR A REDO HAS BEEN ENCOUNTERED WITHIN A REDO.
*
TXT4      DC  Y(TXT4B-TXT4A)            LENGTH.
FLG4A     DC  X'8000'                   MESSAGE FLAG.
* STATIC TEXT SUB-STRUCTURE.
TXT4A     DC  X'8400'                   EOF & STATIC FLAGS.
          DC  Y(STE41B-STE41A)          STATIC TEXT LENGTH.
          DC  Y(STE41A-TXT4A)           STATIC TEXT OFFSET.
          DC  H'1'                      PRINT COLUMN.
          DC  Y(STE41B-STE41A)          PRINT FIELD LENGTH.
          DC  H'0'                      CONVERSION FLAGS. (CHAR)
* STATIC TEXT ENTRY.
STE41A    DC  C'ICK20953I  A REDO SUB-STRUCTURE IS NESTED'
STE41B    EQU *
TXT4B     EQU *
          EJECT
*
* A STATIC TEXT ENTRY IS NOT IN THE INDICATED MODULE.
*
TXT6      DC  Y(TXT6B-TXT6A)            LENGTH.
FLG6A     DC  X'8000'                   MESSAGE FLAG.
* STATIC TEXT SUB-STRUCTURE.
TXT6A     DC  X'8400'                   EOF & STATIC FLAGS.
          DC  Y(STE61B-STE61A)          STATIC TEXT LENGTH.
          DC  Y(STE61A-TXT6A)           STATIC TEXT OFFSET.
          DC  H'1'                      PRINT COLUMN.
          DC  Y(STE61B-STE61A)          PRINT FIELD LENGTH.
          DC  H'0'                      CONVERSION FLAGS. (CHAR)
* STATIC TEXT ENTRY.
STE61A    DC  C'ICK20954I  STATIC TEXT ENTRY REQUESTED NOT IN MODULE'
STE61B    EQU *
TXT6B     EQU *
          EJECT
*
* AN INVALID PACKED DECIMAL FIELD WAS FURNISHED FOR CONVERSION.
*
TXT7      DC  Y(TXT7B-TXT7A)            LENGTH.
FLG7A     DC  X'8000'                   MESSAGE FLAG.
* STATIC TEXT SUB-STRUCTURE.
TXT7A     DC  X'8400'                   EOF AND STATIC FLAGS.
          DC  Y(STE71B-STE71A)          STATIC TEXT LENGTH.
          DC  Y(STE71A-TXT7A)           STATIC TEXT OFFSET.
          DC  H'1'                      PRINT COLUMN.
          DC  Y(STE71B-STE71A)          PRINT FIELD LENGTH.
          DC  H'0'                      CONVERSION FLAGS. (CHAR)
* STATIC TEXT ENTRY.
STE71A    DC  C'ICK20955I  INVALID PACKED DECIMAL FIELD'
STE71B    EQU *
TXT7B     EQU *
          END
