         TITLE 'IDA0192G - MVM VSAM DATA SPACE SECURITY VERIFICATION   *
                       '
IDA0192G CSECT ,                                                   0001
@MAINENT DS    0H                                                  0001
         USING *,@15                                               0001
         B     @PROLOG                                             0001
         DC    AL1(16)                                             0001
         DC    C'IDA0192G  73.306'                                 0001
         DROP  @15
@PROLOG  STM   @14,@12,12(@13)                                     0001
         BALR  @03,0                                               0001
@PSTART  DS    0H                                                  0001
         USING @PSTART,@03                                         0001
*   R12=R13;                        /* LOAD PTR TO SECURITY WORK AREA*/
         LR    R12,R13                                             0072
*   GEN(MODESET EXTKEY=ZERO);       /* RUN IN KEY ZERO       @YO04666*/
         MODESET EXTKEY=ZERO
*   R1=ADDR(GETPLIST);              /* LOAD ADDR OF PARAMETER LIST   */
         LA    R1,GETPLIST(,R12)                                   0074
*   R6=ADDR(GETADDR);               /* LOAD PTR TO RESULT ADDR       */
         LA    R6,GETADDR(,R12)                                    0075
*   R8=WKPOOL;                      /* LOAD SUBPOOL NUMBER           */
         LA    R8,252                                              0076
*   GEN SETS(R7,RETCODE);                                          0077
         L     R7,@SIZDATD              LD SIZE OF WORK AREA
         GETMAIN EC,LV=(R7),A=(R6),SP=(R8),MF=(E,(1))
*   IF RETCODE=0 THEN                                              0078
         SR    @14,@14                                             0078
         CR    RETCODE,@14                                         0078
         BNE   @RF00078                                            0078
*     DO;                                                          0079
*       R6=GETADDR;                 /* LOAD ADDR OF WORK AREA        */
         L     R6,GETADDR(,R12)                                    0080
*       R13=R6;                     /* LOAD ADDR OF WORK AREA        */
         LR    R13,R6                                              0081
*       R9=0;                                                      0082
         LR    R9,@14                                              0082
*       GEN(MVCL R6,R8);            /* ZERO WORK AREA                */
         MVCL R6,R8
*       GEN(ST R12,4(R13));         /* STORE PTR TO LAST SAVE AREA   */
         ST R12,4(R13)
*       GEN(USING @DATD,R13);       /* ESTABLISH ADDRESSABILITY      */
         USING @DATD,R13
*     END;                                                         0086
*   ELSE                                                           0087
*     DO;                                                          0087
         B     @RC00078                                            0087
@RF00078 DS    0H                                                  0088
*       GEN;                                                       0088
         L     RET,12(R13)              LD RETURN ADDRESS
         LM    0,12,20(R13)            RESTORE REGS 0-12
         LA    RETCODE,4                INDICATE ERROR OCCURRED
           MODESET EXTKEY=DATAMGT    SET KEY 5 FOR RETURN      @YO04666
         BR    RET                      RETURN TO CALLER
*     END;                                                         0089
*   RFY                                                            0090
*    (R6,                                                          0090
*     R7,                                                          0090
*     R8,                                                          0090
*     R9)UNRESTRICTED;                                             0090
*                                                                  0090
@RC00078 DS    0H                                                  0091
*   /*****************************************************************/
*   /*                                                               */
*   /* DETERMINE CALLER AND GO TO INDICATED FUNCTION                 */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0091
*   IF MYCODE1=OPEN|MYCODE1=EOV THEN/* TEST IF CALLER IS OPEN OR EOV */
         CLI   MYCODE1(R12),0                                      0091
         BE    @RT00091                                            0091
         CLI   MYCODE1(R12),1                                      0091
         BNE   @RF00091                                            0091
@RT00091 DS    0H                                                  0092
*     DO;                                                          0092
*       CALL OEVERIFY;              /* VERIFY SECURITY FOR OPEN/ EOV */
         BAL   @14,OEVERIFY                                        0093
*     END;                                                         0094
*   ELSE                                                           0095
*     IF MYCODE1=SCRATCH|MYCODE1=RENAME THEN/* TEST IF CALLER IS   0095
*                                      SCRATCH/RENAME                */
         B     @RC00091                                            0095
@RF00091 CLI   MYCODE1(R12),3                                      0095
         BE    @RT00095                                            0095
         CLI   MYCODE1(R12),2                                      0095
         BNE   @RF00095                                            0095
@RT00095 DS    0H                                                  0096
*       DO;                                                        0096
*         CALL SRVERIFY;            /* VERIFY SECURITY FOR         0097
*                                      SCRATCH/RENAME                */
         BAL   @14,SRVERIFY                                        0097
*       END;                                                       0098
*     ELSE                          /* NOT O/EOV OR S/R.      Y021130*/
*       IF MYCODE1=RESTART THEN     /* IS THE CALLER          Y021130*/
         B     @RC00095                                            0099
@RF00095 CLI   MYCODE1(R12),4                                      0099
         BNE   @RF00099                                            0099
*         DO;                       /* RESTART. IF SO         Y021130*/
*           CALL OEVERIFY;          /* THEN VERIFY SECURITY   Y021130*/
         BAL   @14,OEVERIFY                                        0101
*         END;                      /* THEN FALL OUT.         Y021130*/
*       ELSE                                                       0103
*         RETCODE=ERROR;            /* CALLER IS NOT VALID    Y021130*/
*                                                                  0103
         B     @RC00099                                            0103
@RF00099 LA    RETCODE,4                                           0103
*   /*****************************************************************/
*   /*                                                               */
*   /* FREE WORK AREA, RESTORE REGISTERS, AND RETURN TO CALLER       */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0104
*   MAINPOOL=WKPOOL;                /* SET SUBPOOL NUMBER            */
@RC00099 DS    0H                                                  0104
@RC00095 DS    0H                                                  0104
@RC00091 MVI   MAINPOOL,X'FC'                                      0104
*   GEN(L R7,@SIZDATD);             /* LOAD WORK AREA SIZE           */
         L R7,@SIZDATD
*   MAINLEN=R7;                     /* SET LENGTH FOR FREEMAIN       */
         STCM  R7,7,MAINLEN                                        0106
*   R0=MAINR0;                      /* LD SUBPOOL AND LENGTH INTO  0107
*                                      REGISTER                      */
         L     R0,MAINR0                                           0107
*   R1=R13;                         /* LOAD ADDR OF MODULE WORK AREA */
         LR    R1,R13                                              0108
*   GEN(L R13,4(R13));              /* LD PTR TO LAST SAVE AREA      */
         L R13,4(R13)
*   RET=RETCODE;                    /* SAVE RETURN CODE              */
         LR    RET,RETCODE                                         0110
*   GEN(FREEMAIN R,LV=(0),A=(1));   /* FREE WORK AREA                */
         FREEMAIN R,LV=(0),A=(1)
*   RETCODE=RET;                    /* RESTORE RETURN CODE           */
         LR    RETCODE,RET                                         0112
*   GEN(L RET,12(13));              /* LOAD RETURN ADDRESS           */
         L RET,12(13)
*   GEN(LM 0,12,20(13));            /* RESTORE REGS 0-12             */
         LM 0,12,20(13)
*   GEN(MODESET EXTKEY=DATAMGT);    /* RETURN IN KEY 5       @YO04666*/
         MODESET EXTKEY=DATAMGT
*   GEN(BR 14);                     /* RETURN TO CALLER              */
         BR 14
*OEVERIFY:                                                         0117
*                                                                  0117
*   /*****************************************************************/
*   /*                                                               */
*   /* THIS ROUTINE VERIFIES SECURITY FOR A VSAM DATA SPACE WHEN     */
*   /* CALLER IS OPEN, END-OF-VOLUME OR RESTART               Y021130*/
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0117
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);                               0117
         B     @PB00002                                            0117
OEVERIFY DS    0H                                                  0118
*   SAVEA=RET;                      /* SAVE RETURN ADDRESS           */
*                                                                  0118
         ST    RET,SAVEA                                           0118
*   /*****************************************************************/
*   /*                                                               */
*   /* INITIALIZE PARAMETER LIST FOR CALLING VSAM CATALOG INTERFACE  */
*   /* ROUTINE TO VERIFY SECURITY FOR A VSAM DATA SPACE              */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0119
*   CALLID=COMMON;                  /* SET CALLER ID                 */
         MVI   CALLID,X'10'                                        0119
*   DSNPTR=R11;                     /* LOAD PTR TO DATA SET NAME     */
         ST    R11,DSNPTR                                          0120
*   VOLSERPT=ADDR(DSCFILSR);        /* LOAD PTR TO VOL SER NO.       */
         LA    @10,DSCFILSR(,RCORE)                                0121
         ST    @10,VOLSERPT                                        0121
*   R1=ADDR(CATPLIST);              /* LOAD ADDR OF PARAMETER LIST IN
*                                      REG 1                         */
         LA    R1,CATPLIST                                         0122
*   CALL IDA0192C;                  /* CALL CATLG INTERFACE          */
         L     @15,@CV01943                                        0123
         BALR  @14,@15                                             0123
*   RET=SAVEA;                      /* RESTORE RETURN ADDRESS        */
         L     RET,SAVEA                                           0124
*   END OEVERIFY;                                                  0125
@EL00002 DS    0H                                                  0125
@EF00002 DS    0H                                                  0125
@ER00002 BR    @14                                                 0125
*SRVERIFY:                                                         0126
*                                                                  0126
*   /*****************************************************************/
*   /*                                                               */
*   /* THIS ROUTINE VERIFIES SECURITY FOR A VSAM DATA SET WHEN CALLER*/
*   /* IS SCRATCH OR RENAME                                          */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0126
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);                               0126
SRVERIFY DS    0H                                                  0127
*   IF XRBLNKA->PKEY='0000'B&XRBLNKA->PROB=OFF THEN/* TEST FOR KEY 0127
*                                      ZERO AND SUPERVISOR STATE IN
*                                      CALLERS PSW                   */
         L     @10,CVTPTR                                          0127
         L     @10,CVTTCBP(,@10)                                   0127
         L     @10,TCBPTR(,@10)                                    0127
         L     @10,TCBRBP(,@10)                                    0127
         SR    @05,@05                                             0127
         ICM   @05,7,XRBLNKA(@10)                                  0127
         TM    PKEY(@05),B'11110000'                               0127
         BNZ   @RF00127                                            0127
         TM    PROB(@05),B'00000001'                               0127
         BNZ   @RF00127                                            0127
*     RETCODE=NOERROR;              /* INDICATE SECURITY VERIFIED    */
         SR    RETCODE,RETCODE                                     0128
*   ELSE                                                           0129
*     RETCODE=ERROR;                /* INDICATE SECURITY NOT VERIFIED*/
         B     @RC00127                                            0129
@RF00127 LA    RETCODE,4                                           0129
*   END SRVERIFY;                                                  0130
@EL00003 DS    0H                                                  0130
@EF00003 DS    0H                                                  0130
@ER00003 BR    @14                                                 0130
@PB00003 DS    0H                                                  0130
*   END IDA0192G                                                   0131
*/* THE FOLLOWING INCLUDE STATEMENTS WERE FOUND IN THIS PROGRAM.      *
*/*%INCLUDE SYSLIB  (IDAFOREC)                                        *
*/*%INCLUDE SYSLIB  (IEFJFCBN)                                        *
*/*%INCLUDE SYSLIB  (IEFJFCBX)                                        *
*/*%INCLUDE SYSLIB  (IDAPDPRM)                                        *
*/*%INCLUDE SYSLIB  (IHARB   )                                        *
*/*%INCLUDE SYSLIB  (IEZXRB  )                                        *
*/*%INCLUDE SYSLIB  (IKJRB   )                                        *
*/*%INCLUDE SYSLIB  (IKJTCB  )                                        *
*/*%INCLUDE SYSLIB  (CVT     )                                        *
*;                                                                 0131
@DATA    DS    0H
@DATD    DSECT
         DS    0F
@SA00001 DS    18F
IDA0192G CSECT
         DS    0F
@DATD    DSECT
         DS    0D
WORKAREA DS    CL96
         ORG   WORKAREA
REGSAVE  DS    CL72
SAVEA    DS    AL4
SAVEB    DS    AL4
CATPLIST DS    CL12
         ORG   CATPLIST
CALLFLAG DS    CL4
         ORG   CALLFLAG
CALLID   DS    BL1
@NM00062 DS    CL3
         ORG   CATPLIST+4
DSNPTR   DS    AL4
VOLSERPT DS    AL4
         ORG   WORKAREA+92
MAINR0   DS    FL4
         ORG   MAINR0
MAINPOOL DS    FL1
MAINLEN  DS    FL3
         ORG   WORKAREA+96
IDA0192G CSECT
         DS    0F
@SIZDATD DC    AL1(0)
         DC    AL3(@ENDDATD-@DATD)
@CV01943 DC    V(IDA0192C)
         DS    0D
IDA0192G CSECT
         IDAPATCH
@DATD    DSECT
         ORG   *+1-(*-@DATD)/(*-@DATD) INSURE DSECT DATA
@ENDDATD EQU   *
IDA0192G CSECT
@00      EQU   00                      EQUATES FOR REGISTERS 0-15
@01      EQU   01
@02      EQU   02
@03      EQU   03
@04      EQU   04
@05      EQU   05
@06      EQU   06
@07      EQU   07
@08      EQU   08
@09      EQU   09
@10      EQU   10
@11      EQU   11
@12      EQU   12
@13      EQU   13
@14      EQU   14
@15      EQU   15
RCORE    EQU   @04
RBASE    EQU   @03
R11      EQU   @11
R12      EQU   @12
R13      EQU   @13
R0       EQU   @00
R1       EQU   @01
R6       EQU   @06
R7       EQU   @07
R8       EQU   @08
R9       EQU   @09
RET      EQU   @14
RETCODE  EQU   @15
R10      EQU   @10
R15      EQU   @15
CVTPTR   EQU   16
FORECORE EQU   0
INFMJFCB EQU   0
JFCBDSNM EQU   INFMJFCB
JFCBELNM EQU   INFMJFCB+44
JFCBTSDM EQU   INFMJFCB+52
JFCFCBID EQU   INFMJFCB+56
JFCBFRID EQU   JFCFCBID
JFCBLTYP EQU   INFMJFCB+66
JFCBOTTR EQU   INFMJFCB+67
JFCBUFOF EQU   JFCBOTTR
JFCBFLSQ EQU   JFCBOTTR+1
JFCFUNC  EQU   JFCBFLSQ
JFCBMASK EQU   INFMJFCB+72
JFCBFLG1 EQU   JFCBMASK+5
JFCOPEN  EQU   JFCBFLG1
JFCBFLG2 EQU   JFCBMASK+6
JFCDEFER EQU   JFCBFLG2
JFCBIND1 EQU   INFMJFCB+86
JFCBIND2 EQU   INFMJFCB+87
JFCAMPTR EQU   INFMJFCB+88
JFCBUFRQ EQU   JFCAMPTR
JFCBUFNO EQU   JFCBUFRQ
JFCBGNCP EQU   JFCAMPTR+1
JFCBHIAR EQU   JFCBGNCP
JFCBFALN EQU   JFCBHIAR
JFCBFTEK EQU   JFCBFALN
JFCBBFTA EQU   JFCBFTEK
JFCEROPT EQU   INFMJFCB+92
JFCTRTCH EQU   INFMJFCB+93
JFCBX    EQU   0
IDAPDPRM EQU   0
RBPRFX   EQU   0
RBBASIC  EQU   0
RBEXRTNM EQU   RBBASIC
RBTMFLD  EQU   RBEXRTNM
RBSTAB   EQU   RBBASIC+10
XSTAB    EQU   RBSTAB
RBSTAB1  EQU   XSTAB
XSTAB1   EQU   RBSTAB1
RBFTCKPT EQU   XSTAB1
RBSTAB2  EQU   XSTAB+1
XSTAB2   EQU   RBSTAB2
RBTCBNXT EQU   XSTAB2
RBFACTV  EQU   XSTAB2
RBFDYN   EQU   XSTAB2
RBECBWT  EQU   XSTAB2
RBOPSW   EQU   RBBASIC+16
XRBPSW   EQU   RBOPSW
RBLINK   EQU   RBBASIC+28
XRBLNK   EQU   RBLINK
RBWCF    EQU   XRBLNK
RBLINKB  EQU   XRBLNK+1
XRBLNKA  EQU   RBLINKB
RBGRSAVE EQU   RBBASIC+32
XRBREG   EQU   RBGRSAVE
RBGRS0   EQU   XRBREG
RBGRS1   EQU   XRBREG+4
RBGRS2   EQU   XRBREG+8
RBGRS3   EQU   XRBREG+12
RBGRS4   EQU   XRBREG+16
RBGRS5   EQU   XRBREG+20
RBGRS6   EQU   XRBREG+24
RBGRS7   EQU   XRBREG+28
RBGRS8   EQU   XRBREG+32
RBGRS9   EQU   XRBREG+36
RBGRS10  EQU   XRBREG+40
RBGRS11  EQU   XRBREG+44
RBGRS12  EQU   XRBREG+48
RBGRS13  EQU   XRBREG+52
RBGRS14  EQU   XRBREG+56
RBGRS15  EQU   XRBREG+60
XRBESA   EQU   RBBASIC+96
XRBPRFX  EQU   0
XRBPRFX1 EQU   0
XRB      EQU   0
@NM00035 EQU   XRB+10
@NM00036 EQU   @NM00035
XRBLRBFX EQU   @NM00036
@NM00038 EQU   @NM00035+1
@NM00039 EQU   @NM00038
@NM00040 EQU   @NM00038
XRBWTL   EQU   XRB+12
XRBEP    EQU   XRBWTL
@NM00043 EQU   XRB+16
XRTLPRB  EQU   @NM00043+4
XRBLOCK  EQU   XRTLPRB
XRBFLAG1 EQU   XRBLOCK
@NM00046 EQU   XRB+28
CDB      EQU   0
CDBMDAD  EQU   CDB
CDBMDSZ  EQU   CDB+4
TCBFIX   EQU   0
TCBFRS   EQU   TCBFIX
TCB      EQU   0
TCBRBP   EQU   TCB
TCBPIE   EQU   TCB+4
TCBPMASK EQU   TCBPIE
TCBCMP   EQU   TCB+16
TCBCMPF  EQU   TCBCMP
TCBCPP   EQU   TCBCMPF
TCBSTCC  EQU   TCBCMPF
TCBCDBL  EQU   TCBCMPF
TCBCWTO  EQU   TCBCMPF
TCBCIND  EQU   TCBCMPF
TCBCMSG  EQU   TCBCMPF
TCBTRN   EQU   TCB+20
TCBABF   EQU   TCBTRN
TCBMSS   EQU   TCB+24
TCBPKF   EQU   TCB+28
TCBFLGS  EQU   TCB+29
TCBFLGS1 EQU   TCBFLGS
TCBFERA  EQU   TCBFLGS1
TCBPDUMP EQU   TCBFLGS1
TCBFT    EQU   TCBFLGS1
TCBFLGS2 EQU   TCBFLGS+1
TCBSYSTK EQU   TCBFLGS2
TCBFDSOP EQU   TCBFLGS2
TCBFLGS3 EQU   TCBFLGS+2
TCBADINP EQU   TCBFLGS3
TCBABTRM EQU   TCBFLGS3
TCBABGM  EQU   TCBFLGS3
TCBRSV06 EQU   TCBFLGS3
TCBRSV07 EQU   TCBFLGS3
TCBRSV08 EQU   TCBFLGS3
TCBDWSTA EQU   TCBFLGS3
TCBFLGS4 EQU   TCBFLGS+3
TCBFLGS5 EQU   TCBFLGS+4
TCBABWF  EQU   TCBFLGS5
TCBFTJST EQU   TCB+44
TCBJPQ   EQU   TCBFTJST
TCBPURGE EQU   TCBJPQ
TCBFTJSA EQU   TCBJPQ+1
TCBGRS   EQU   TCB+48
TCBFSA   EQU   TCB+112
TCBIDF   EQU   TCBFSA
TCBTME   EQU   TCB+120
TCBPIB   EQU   TCB+124
TCBJSTCB EQU   TCBPIB
TCBPIBT  EQU   TCBJSTCB
TCBPIBA  EQU   TCBJSTCB+1
TCBTSFLG EQU   TCB+148
TCBTSTSK EQU   TCBTSFLG
TCBPQE   EQU   TCB+152
TCBFTFLG EQU   TCBPQE+1
TCBFTFL1 EQU   TCBFTFLG
TCBFTFL2 EQU   TCBFTFLG+1
TCBFTFL3 EQU   TCBFTFLG+2
TCBAQE   EQU   TCB+156
TCBSTAB  EQU   TCB+160
TCBNSTAE EQU   TCBSTAB
TCBXCTL  EQU   TCBNSTAE
TCBSCAT  EQU   TCBNSTAE
TCBSUPER EQU   TCBNSTAE
TCBRETRY EQU   TCBNSTAE
TCBVALID EQU   TCBNSTAE
TCBTCT   EQU   TCB+164
TCBTCTGF EQU   TCBTCT
TCBSCNDY EQU   TCB+172
TCBNDSP  EQU   TCBSCNDY
TCBNDSP1 EQU   TCBNDSP+1
TCBNDSP2 EQU   TCBNDSP+2
TCBNDSP3 EQU   TCBNDSP+3
TCBLJSND EQU   TCBNDSP3
TCBRV302 EQU   TCBNDSP3
TCBSRBND EQU   TCBNDSP3
TCBNDINT EQU   TCBNDSP3
TCBJSCB  EQU   TCB+180
TCBRECDE EQU   TCBJSCB
TCBEXT1  EQU   TCB+196
TCBBITS  EQU   TCB+200
TCBNDSP4 EQU   TCBBITS
TCBNDSP5 EQU   TCBBITS+1
TCBFLGS6 EQU   TCBBITS+2
TCBCPU   EQU   TCBFLGS6
TCBSPVLK EQU   TCBFLGS6
TCBRV303 EQU   TCBFLGS6
TCBMIGR  EQU   TCBFLGS6
TCBAPG   EQU   TCBFLGS6
TCBNTJS  EQU   TCBFLGS6
TCBFLGS7 EQU   TCBBITS+3
TCBGPECB EQU   TCBFLGS7
TCBRSV33 EQU   TCBFLGS7
TCBRSV34 EQU   TCBFLGS7
TCBSTACK EQU   TCBFLGS7
TCBRSTSK EQU   TCBFLGS7
TCBADMP  EQU   TCBFLGS7
TCBDAR   EQU   TCB+204
TCBDARC  EQU   TCBDAR
TCBEXT2  EQU   TCB+208
TCBPCB   EQU   TCB+212
TCBARB   EQU   TCB+220
TCBTTQE  EQU   TCB+224
TCBXTNT2 EQU   0
TCBGTF   EQU   TCBXTNT2
TCBTFLG  EQU   TCBGTF
TCBRV146 EQU   TCBXTNT2+28
TCBRV155 EQU   TCBXTNT2+29
TCBRV164 EQU   TCBXTNT2+30
TCBRV173 EQU   TCBXTNT2+31
CVTMAP   EQU   0
CVTTCBP  EQU   CVTMAP
CVTDAR   EQU   CVTMAP+72
CVTFLGS1 EQU   CVTDAR
CVTDCB   EQU   CVTMAP+116
CVTOPTA  EQU   CVTMAP+182
CVTOPTB  EQU   CVTMAP+183
CVTGTF   EQU   CVTMAP+236
CVTGTFST EQU   CVTGTF
CVTGTFS  EQU   CVTGTFST
CVTSTATE EQU   CVTGTFST
CVTTMODE EQU   CVTGTFST
CVTFORM  EQU   CVTGTFST
CVTUSR   EQU   CVTGTFST
CVTAQAVT EQU   CVTMAP+240
CVTTCMFG EQU   CVTAQAVT
CVTVOLM2 EQU   CVTMAP+244
CVTTATA  EQU   CVTVOLM2
CVTTSKS  EQU   CVTTATA
CVTVOLF2 EQU   CVTTSKS
CVTTAT   EQU   CVTTATA+1
CVTATER  EQU   CVTMAP+248
CVTEXT1  EQU   CVTMAP+252
CVTPURG  EQU   CVTMAP+260
CVTQMSG  EQU   CVTMAP+268
CVTDMSR  EQU   CVTMAP+272
CVTAPF   EQU   CVTMAP+324
CVTEXT2  EQU   CVTMAP+328
CVTHJES  EQU   CVTMAP+332
CVTPGSIA EQU   CVTMAP+348
CVTA1F1  EQU   CVTMAP+356
CVTSYSK  EQU   CVTMAP+357
CVTVOLM1 EQU   CVTMAP+380
CVTVOLF1 EQU   CVTVOLM1
CVTATMCT EQU   CVTMAP+388
CVTXTNT1 EQU   0
CVTXTNT2 EQU   0
CVTDSSV  EQU   CVTXTNT2
CVTRSV90 EQU   CVTXTNT2+5
CVTQID   EQU   CVTXTNT2+24
CVTRV400 EQU   CVTXTNT2+52
CVTRV409 EQU   CVTXTNT2+53
CVTATCVT EQU   CVTXTNT2+64
CVTRV429 EQU   CVTXTNT2+84
CVTRV438 EQU   CVTXTNT2+85
CVTRV457 EQU   CVTXTNT2+112
CVTRV466 EQU   CVTXTNT2+113
CVTFIX   EQU   0
CVTRELNO EQU   CVTFIX+252
SECWORK  EQU   0
GETPLIST EQU   SECWORK+96
GETADDR  EQU   GETPLIST+12
MYCODE1  EQU   SECWORK+112
TCBPTRS  EQU   0
TCBPTR   EQU   TCBPTRS+4
DSNAME   EQU   0
FL2BUFOF EQU   0
DXLBL    EQU   FORECORE
DSECT01  EQU   FORECORE+37
DSECT02  EQU   FORECORE
FL1RES   EQU   DSECT02+73
DSECT03  EQU   FORECORE+4
FL2JSID  EQU   DSECT03+13
DXDSCB   EQU   FORECORE
DSCFILSR EQU   DXDSCB+1
DXDSCB3K EQU   FORECORE
DSCBEXSK EQU   DXDSCB3K+4
DSECT04  EQU   FORECORE
DSCBEXSD EQU   DSECT04+1
DSECT05  EQU   FORECORE
DSECT06  EQU   FORECORE+12
MSGINSTR EQU   DSECT06+3
MSGSER   EQU   MSGINSTR
DXJBF    EQU   FORECORE+100
JFCKEYLE EQU   JFCTRTCH
JFCCODE  EQU   JFCKEYLE
JFCSTACK EQU   JFCTRTCH
JFCMODE  EQU   JFCSTACK
JFCSPPRT EQU   JFCTRTCH
JFCBABFS EQU   JFCSPPRT+2
JFCLIMCT EQU   JFCBABFS
JFCDSORG EQU   JFCSPPRT+5
JFCDSRG1 EQU   JFCDSORG
JFCDSRG2 EQU   JFCDSORG+1
JFCRECFM EQU   JFCSPPRT+7
JFCRCFM  EQU   JFCRECFM
JFCOPTCD EQU   JFCSPPRT+8
JFCWVCSP EQU   JFCOPTCD
JFCWVCIS EQU   JFCWVCSP
JFCWVCBD EQU   JFCWVCIS
JFCALLOW EQU   JFCOPTCD
JFCRSV17 EQU   JFCALLOW
JFCOVER  EQU   JFCRSV17
JFCPCIBT EQU   JFCOPTCD
JFCMAST  EQU   JFCPCIBT
JFCEXT   EQU   JFCMAST
JFCBCKPT EQU   JFCOPTCD
JFCIND   EQU   JFCBCKPT
JFCRSV18 EQU   JFCOPTCD
JFCCYL   EQU   JFCRSV18
JFCACT   EQU   JFCCYL
JFCREDUC EQU   JFCOPTCD
JFCRSV19 EQU   JFCREDUC
JFCRSV20 EQU   JFCRSV19
JFCRSV21 EQU   JFCOPTCD
JFCDEL   EQU   JFCRSV21
JFCRSV23 EQU   JFCOPTCD
JFCREORG EQU   JFCRSV23
JFCBLKSI EQU   JFCSPPRT+9
JFCBUFSI EQU   JFCBLKSI
JFCAMSYN EQU   JFCSPPRT+11
JFCNCP   EQU   JFCAMSYN+2
JFCNTM   EQU   JFCAMSYN+3
JFCBFSEQ EQU   JFCNTM
JFCPCI   EQU   JFCBFSEQ
JFCRESRV EQU   JFCAMSYN+4
JFCUCSEG EQU   JFCRESRV
JFCUCSOP EQU   JFCUCSEG+4
JFCOUTLI EQU   JFCUCSEG+5
JFCTHRSH EQU   JFCOUTLI
JFCCPRI  EQU   JFCTHRSH
JFCBVOLS EQU   JFCUCSEG+10
JFCBPQTY EQU   JFCUCSEG+44
JFCBCTRI EQU   JFCUCSEG+47
JFCBSQTY EQU   JFCUCSEG+48
JFCBIND3 EQU   JFCBSQTY+2
JFCFLGS1 EQU   JFCUCSEG+51
DXIOB    EQU   FORECORE+280
IOBSENSE EQU   DXIOB+2
IOBECBPT EQU   DXIOB+4
IOBCSW   EQU   DXIOB+8
DYYYY    EQU   FORECORE+320
DXDEBIRB EQU   DYYYY+4
DXDEBDCB EQU   DYYYY+20
DXDCBAD  EQU   DXDEBDCB
DXDEBUCB EQU   DYYYY+28
DXCCW    EQU   FORECORE+368
PDWLIST  EQU   FORECORE
PDWWORK  EQU   FORECORE+320
DSECTMVM EQU   FORECORE+524
DXTIOTAD EQU   DSECTMVM+32
DXUDCBAD EQU   DSECTMVM+44
DXPDCBAD EQU   DSECTMVM+48
DXATCOM1 EQU   FORECORE+588
TCBS01   EQU   TCBPCB
TCBFOE   EQU   TCBS01+32
TCBESTAE EQU   TCBS01+52
TCBESTRM EQU   TCBESTAE+1
TCBFBYT1 EQU   TCBS01+64
TCBFBYT2 EQU   TCBS01+65
TCBRV124 EQU   TCBS01+66
TCBRV133 EQU   TCBS01+67
CVTS01   EQU   CVTPGSIA
CVTLPDIA EQU   CVTS01+12
CVTDIRST EQU   CVTLPDIA
CVTSLIDA EQU   CVTS01+24
CVTCTLFG EQU   CVTS01+50
CVTRV210 EQU   CVTS01+424
CVTRV219 EQU   CVTS01+425
CVTRV228 EQU   CVTS01+426
CVTRV237 EQU   CVTS01+427
CVTMFRTR EQU   CVTS01+452
CVTRV262 EQU   CVTS01+468
CVTRV271 EQU   CVTS01+469
CVTRV280 EQU   CVTS01+470
CVTRV289 EQU   CVTS01+471
CVTGSDA  EQU   CVTS01+600
USERPSW  EQU   XRBPSW
KEYSTATE EQU   USERPSW+1
PKEY     EQU   KEYSTATE
STATE    EQU   KEYSTATE
PROB     EQU   STATE
DSCBEND  EQU   FORECORE+100
DSCCORE  EQU   FORECORE+96
DXCCW8   EQU   DXTIOTAD
DXDADDR  EQU   FORECORE+312
DXDCB    EQU   FORECORE+320
DXDCBDEB EQU   FORECORE+364
DXDEB    EQU   FORECORE+316
DXECB    EQU   FORECORE+276
DXVSAMID EQU   FORECORE+488
DXXXX    EQU   FORECORE+364
         AGO   .@UNREFD                START UNREFERENCED COMPONENTS
@NM00061 EQU   USERPSW+2
AMW      EQU   STATE
SYSMASK  EQU   USERPSW
CVTTPIO  EQU   CVTS01+608
CVTADV   EQU   CVTS01+604
CVTGSDAB EQU   CVTGSDA
CVTQV3   EQU   CVTS01+596
CVTQV2   EQU   CVTS01+592
CVTQV1   EQU   CVTS01+588
CVTRPT   EQU   CVTS01+584
CVTSSRB  EQU   CVTS01+580
CVTCSDRL EQU   CVTS01+576
CVTEXP1  EQU   CVTS01+572
CVTRMPMT EQU   CVTS01+568
CVTRMPTT EQU   CVTS01+564
CVTVPSA  EQU   CVTS01+560
CVTVSTOP EQU   CVTS01+556
CVTGTFR8 EQU   CVTS01+552
CVTQUIT  EQU   CVTS01+548
CVTVACR  EQU   CVTS01+544
CVTWTCB  EQU   CVTS01+540
CVTSTPRS EQU   CVTS01+536
CVT0PT02 EQU   CVTS01+532
CVTDARCM EQU   CVTS01+528
CVTIRECM EQU   CVTS01+524
CVTJRECM EQU   CVTS01+520
CVTVEMS0 EQU   CVTS01+516
CVTSPFRR EQU   CVTS01+512
CVTRLSTG EQU   CVTS01+508
CVT0TC0A EQU   CVTS01+504
CVTGMBR  EQU   CVTS01+500
CVTLFRM  EQU   CVTS01+496
CVTRMBR  EQU   CVTS01+492
CVTVIOP  EQU   CVTS01+488
CVTRV307 EQU   CVTS01+486
CVTRV306 EQU   CVTS01+484
CVTRV305 EQU   CVTS01+482
CVTRV304 EQU   CVTS01+480
CVTRV303 EQU   CVTS01+478
CVTRV302 EQU   CVTS01+476
CVTRV301 EQU   CVTS01+475
CVTRV300 EQU   CVTS01+474
CVTRV299 EQU   CVTS01+473
CVTRV298 EQU   CVTS01+472
CVTRV297 EQU   CVTRV289
CVTRV296 EQU   CVTRV289
CVTRV295 EQU   CVTRV289
CVTRV294 EQU   CVTRV289
CVTRV293 EQU   CVTRV289
CVTRV292 EQU   CVTRV289
CVTRV291 EQU   CVTRV289
CVTRV290 EQU   CVTRV289
CVTRV288 EQU   CVTRV280
CVTRV287 EQU   CVTRV280
CVTRV286 EQU   CVTRV280
CVTRV285 EQU   CVTRV280
CVTRV284 EQU   CVTRV280
CVTRV283 EQU   CVTRV280
CVTRV282 EQU   CVTRV280
CVTRV281 EQU   CVTRV280
CVTRV279 EQU   CVTRV271
CVTRV278 EQU   CVTRV271
CVTRV277 EQU   CVTRV271
CVTRV276 EQU   CVTRV271
CVTRV275 EQU   CVTRV271
CVTRV274 EQU   CVTRV271
CVTRV273 EQU   CVTRV271
CVTRV272 EQU   CVTRV271
CVTRV270 EQU   CVTRV262
CVTRV269 EQU   CVTRV262
CVTRV268 EQU   CVTRV262
CVTRV267 EQU   CVTRV262
CVTRV266 EQU   CVTRV262
CVTRV265 EQU   CVTRV262
CVTRV264 EQU   CVTRV262
CVTRV263 EQU   CVTRV262
CVTVFP   EQU   CVTS01+464
CVTVSI   EQU   CVTS01+460
CVTVPSIB EQU   CVTS01+456
CVTMFACT EQU   CVTMFRTR
CVTMFCTL EQU   CVTS01+448
CVTPVBP  EQU   CVTS01+444
CVTPWI   EQU   CVTS01+440
CVTRV254 EQU   CVTS01+438
CVTRV253 EQU   CVTS01+436
CVTRV252 EQU   CVTS01+434
CVTRV251 EQU   CVTS01+433
CVTRV250 EQU   CVTS01+432
CVTRV249 EQU   CVTS01+431
CVTRV248 EQU   CVTS01+430
CVTRV247 EQU   CVTS01+429
CVTRV246 EQU   CVTS01+428
CVTRV245 EQU   CVTRV237
CVTRV244 EQU   CVTRV237
CVTRV243 EQU   CVTRV237
CVTRV242 EQU   CVTRV237
CVTRV241 EQU   CVTRV237
CVTRV240 EQU   CVTRV237
CVTRV239 EQU   CVTRV237
CVTRV238 EQU   CVTRV237
CVTRV236 EQU   CVTRV228
CVTRV235 EQU   CVTRV228
CVTRV234 EQU   CVTRV228
CVTRV233 EQU   CVTRV228
CVTRV232 EQU   CVTRV228
CVTRV231 EQU   CVTRV228
CVTRV230 EQU   CVTRV228
CVTRV229 EQU   CVTRV228
CVTRV227 EQU   CVTRV219
CVTRV226 EQU   CVTRV219
CVTRV225 EQU   CVTRV219
CVTRV224 EQU   CVTRV219
CVTRV223 EQU   CVTRV219
CVTRV222 EQU   CVTRV219
CVTRV221 EQU   CVTRV219
CVTRV220 EQU   CVTRV219
CVTRV218 EQU   CVTRV210
CVTRV217 EQU   CVTRV210
CVTRV216 EQU   CVTRV210
CVTRV215 EQU   CVTRV210
CVTRV214 EQU   CVTRV210
CVTRV213 EQU   CVTRV210
CVTRV212 EQU   CVTRV210
CVTRV211 EQU   CVTRV210
CVTLCCAT EQU   CVTS01+420
CVTPCCAT EQU   CVTS01+416
CVTIPCRP EQU   CVTS01+412
CVTIPCRI EQU   CVTS01+408
CVTIPCDS EQU   CVTS01+404
CVTAIDVT EQU   CVTS01+400
CVTSSAP  EQU   CVTS01+396
CVTEHCIR EQU   CVTS01+392
CVTEHDEF EQU   CVTS01+388
CVTDAIR  EQU   CVTS01+384
CVTPERFM EQU   CVTS01+380
CVT044R2 EQU   CVTS01+376
CVTFETCH EQU   CVTS01+372
CVTRSTWD EQU   CVTS01+368
CVTSPOST EQU   CVTS01+364
CVTIOBP  EQU   CVTS01+360
CVTASMVT EQU   CVTS01+356
CVTRECRQ EQU   CVTS01+352
CVTWSAC  EQU   CVTS01+348
CVTWSAG  EQU   CVTS01+344
CVTWSAL  EQU   CVTS01+340
CVTSPSA  EQU   CVTS01+336
CVTGLMN  EQU   CVTS01+332
CVTVEAC0 EQU   CVTS01+328
CVT062R1 EQU   CVTS01+324
CVTRPOST EQU   CVTS01+320
CVTDQIQE EQU   CVTS01+316
CVTCSD   EQU   CVTS01+312
CVTLKRMA EQU   CVTS01+308
CVTRSPIE EQU   CVTS01+304
CVTRENQ  EQU   CVTS01+300
CVTLQCB  EQU   CVTS01+296
CVTFQCB  EQU   CVTS01+292
CVTQCS01 EQU   CVTS01+288
CVTAPFT  EQU   CVTS01+284
CVTPARRL EQU   CVTS01+280
CVTVWAIT EQU   CVTS01+276
CVTGSPL  EQU   CVTS01+272
CVTLSMQ  EQU   CVTS01+268
CVTGSMQ  EQU   CVTS01+264
CVTEXPRO EQU   CVTS01+260
CVTOPCTP EQU   CVTS01+256
CVTSIC   EQU   CVTS01+252
CVTTPIOS EQU   CVTS01+248
CVTRTMS  EQU   CVTS01+244
CVTSDBF  EQU   CVTS01+240
CVTSCBP  EQU   CVTS01+236
CVTSDMP  EQU   CVTS01+232
CVTSV60  EQU   CVTS01+228
CVTRTMCT EQU   CVTS01+224
CVTASCBL EQU   CVTS01+220
CVTASCBH EQU   CVTS01+216
CVTGDA   EQU   CVTS01+212
CVTASVT  EQU   CVTS01+208
CVTVVMDI EQU   CVTS01+204
CVTAQTOP EQU   CVTS01+200
CVTIOSCS EQU   CVTS01+196
CVTSDRM  EQU   CVTS01+192
CVTOPTE  EQU   CVTS01+188
CVTSTXU  EQU   CVTS01+184
CVTQUIS  EQU   CVTS01+180
CVTPARS  EQU   CVTS01+176
CVTS1EE  EQU   CVTS01+172
CVTFRAS  EQU   CVTS01+168
CVTQSAS  EQU   CVTS01+164
CVTCRAS  EQU   CVTS01+160
CVTCRMN  EQU   CVTS01+156
CVTDELCP EQU   CVTS01+152
CVTFRECL EQU   CVTS01+148
CVTGETCL EQU   CVTS01+144
CVTBLDCP EQU   CVTS01+140
CVTAUTHL EQU   CVTS01+136
CVTSCAN  EQU   CVTS01+132
CVTRV144 EQU   CVTS01+130
CVTMAXMP EQU   CVTS01+128
CVTSTCK  EQU   CVTS01+124
CVTRV139 EQU   CVTS01+123
CVTDSSAC EQU   CVTS01+122
CVTRV513 EQU   CVTS01+121
CVTIOSPL EQU   CVTS01+120
CVTPTGT  EQU   CVTS01+116
CVTCSPIE EQU   CVTS01+112
CVTSMFEX EQU   CVTS01+108
CVTOLT0A EQU   CVTS01+104
CVTSRBRT EQU   CVTS01+100
CVTPUTL  EQU   CVTS01+96
CVTSYSWT EQU   CVTS01+92
CVTRV327 EQU   CVTS01+88
CVTRV326 EQU   CVTS01+84
CVTRV325 EQU   CVTS01+80
CVTRV324 EQU   CVTS01+76
CVT0VL01 EQU   CVTS01+72
CVTSHRVM EQU   CVTS01+68
CVTRV332 EQU   CVTS01+64
CVTTAS   EQU   CVTS01+60
CVTRSCN  EQU   CVTS01+56
CVTTRAC2 EQU   CVTS01+54
CVTTRACE EQU   CVTS01+52
CVTAPG   EQU   CVTS01+51
CVTSDTRC EQU   CVTCTLFG
CVTGTRCE EQU   CVTCTLFG
CVTNOMP  EQU   CVTCTLFG
CVTRSV79 EQU   CVTCTLFG
CVTDSTAT EQU   CVTCTLFG
CVTRSV78 EQU   CVTCTLFG
CVTRV333 EQU   CVTCTLFG
CVTRV323 EQU   CVTCTLFG
CVTSPVLK EQU   CVTS01+49
CVTRSV77 EQU   CVTS01+48
CVTRV331 EQU   CVTS01+44
CVTRV330 EQU   CVTS01+40
CVTRV329 EQU   CVTS01+36
CVTRV328 EQU   CVTS01+32
CVTRV322 EQU   CVTS01+28
CVTSLID  EQU   CVTSLIDA+1
CVTSYLK  EQU   CVTSLIDA
CVTRV321 EQU   CVTS01+20
CVTRV320 EQU   CVTS01+16
CVTLPDIR EQU   CVTLPDIA+1
CVTRSV69 EQU   CVTDIRST
CVTRSV68 EQU   CVTDIRST
CVTRSV67 EQU   CVTDIRST
CVTRSV66 EQU   CVTDIRST
CVTRSV65 EQU   CVTDIRST
CVTRSV64 EQU   CVTDIRST
CVTRSV63 EQU   CVTDIRST
CVTDICOM EQU   CVTDIRST
CVTPVTP  EQU   CVTS01+8
CVTLPDSR EQU   CVTS01+4
CVTGETL  EQU   CVTS01
@NM00056 EQU   TCBS01+84
TCBRV185 EQU   TCBS01+80
TCBSWASA EQU   TCBS01+76
TCBDBTB  EQU   TCBS01+72
TCBRPT   EQU   TCBS01+68
TCBRV141 EQU   TCBRV133
TCBRV140 EQU   TCBRV133
TCBRV139 EQU   TCBRV133
TCBRV138 EQU   TCBRV133
TCBRV137 EQU   TCBRV133
TCBRV136 EQU   TCBRV133
TCBRV135 EQU   TCBRV133
TCBRV134 EQU   TCBRV133
TCBRV132 EQU   TCBRV124
TCBRV131 EQU   TCBRV124
TCBRV130 EQU   TCBRV124
TCBRV129 EQU   TCBRV124
TCBRV128 EQU   TCBRV124
TCBRV127 EQU   TCBRV124
TCBRV126 EQU   TCBRV124
TCBRV125 EQU   TCBRV124
TCBRV123 EQU   TCBFBYT2
TCBRV122 EQU   TCBFBYT2
TCBECBNV EQU   TCBFBYT2
TCBSSSYN EQU   TCBFBYT2
TCBFPRAP EQU   TCBFBYT2
TCBFDW   EQU   TCBFBYT2
TCBFMW   EQU   TCBFBYT2
TCBCNCB  EQU   TCBFBYT2
TCBLLH   EQU   TCBFBYT1
TCBRV113 EQU   TCBFBYT1
TCBEOT   EQU   TCBFBYT1
TCBRTM2  EQU   TCBFBYT1
TCBPGNLY EQU   TCBFBYT1
TCBNDIOS EQU   TCBFBYT1
TCBACTIV EQU   TCBFBYT1
TCBEOTFM EQU   TCBFBYT1
TCBAFFN  EQU   TCBS01+62
TCBCCPVI EQU   TCBS01+60
TCBUKYSP EQU   TCBS01+56
TCBMODE  EQU   TCBESTAE+3
TCBERTYP EQU   TCBESTAE+2
TCBRV314 EQU   TCBESTRM
TCBRV313 EQU   TCBESTRM
TCBRV312 EQU   TCBESTRM
TCBRV311 EQU   TCBESTRM
TCBRV310 EQU   TCBESTRM
TCBRV309 EQU   TCBESTRM
TCBRV308 EQU   TCBESTRM
TCBETERM EQU   TCBESTRM
TCBSCBKY EQU   TCBESTAE
TCBRTM12 EQU   TCBS01+48
TCBTCBID EQU   TCBS01+44
TCBRSV96 EQU   TCBS01+40
TCBSWA   EQU   TCBS01+36
TCBFOEA  EQU   TCBFOE+1
TCBRSV42 EQU   TCBFOE
TCBRV306 EQU   TCBS01+28
TCBRSV41 EQU   TCBS01+27
TCBTID   EQU   TCBS01+26
TCBRSVAA EQU   TCBS01+25
TCBABCUR EQU   TCBS01+24
TCBTMSAV EQU   TCBS01+20
TCBIOTIM EQU   TCBS01+16
TCBRTWA  EQU   TCBS01+12
TCBBACK  EQU   TCBS01+8
TCBTIRB  EQU   TCBS01+4
TCBAECB  EQU   TCBS01
DXATEXC2 EQU   DXATCOM1+20
DXATEXC1 EQU   DXATCOM1+16
DXATCOM4 EQU   DXATCOM1+12
DXATCOM3 EQU   DXATCOM1+8
@NM00025 EQU   DXATCOM1+6
DXATOPEN EQU   DXATCOM1+5
DXATEOV  EQU   DXATCOM1+4
DXATDACC EQU   DXATCOM1+3
DXATOUTA EQU   DXATCOM1+2
DXATCLOS EQU   DXATCOM1+1
DXATGENS EQU   DXATCOM1
DXPRPARC EQU   DSECTMVM+56
DXUDCBMI EQU   DSECTMVM+54
DXUDCBPL EQU   DSECTMVM+52
DXPACBAD EQU   DXPDCBAD+1
@NM00024 EQU   DXPDCBAD
DXUACBAD EQU   DXUDCBAD+1
@NM00023 EQU   DXUDCBAD
DXUCBSAV EQU   DSECTMVM+40
DXUCBADR EQU   DSECTMVM+36
DXDEBXAD EQU   DSECTMVM+28
DXDSAB   EQU   DSECTMVM+24
DXDSABAD EQU   DSECTMVM+20
DXDSABQD EQU   DSECTMVM+16
DXJSCBAD EQU   DSECTMVM+12
DXTCBADR EQU   DSECTMVM+8
DXASCBAD EQU   DSECTMVM+4
DXEXTSW  EQU   DSECTMVM+3
DXUKEY   EQU   DSECTMVM+2
DXWKEYSV EQU   DSECTMVM+1
DXRESSW  EQU   DSECTMVM
PDWORKSP EQU   PDWWORK+80
PDWERRCD EQU   PDWWORK+76
PDWSAVEC EQU   PDWWORK+72
PDWSAVEB EQU   PDWWORK+68
PDWSAVEA EQU   PDWWORK+64
PDWSAVE  EQU   PDWWORK
WTPROUT  EQU   PDWLIST+75
WTPMSG   EQU   PDWLIST+4
WTPFLGS  EQU   PDWLIST+2
WTPLNGTH EQU   PDWLIST
DXCCW12  EQU   DXCCW+88
DXCCW11  EQU   DXCCW+80
DXCCW10  EQU   DXCCW+72
DXCCW9   EQU   DXCCW+64
@NM00022 EQU   DXCCW+56
DXCCW7   EQU   DXCCW+48
DXCCW6   EQU   DXCCW+40
DXCCW5   EQU   DXCCW+32
DXCCW4   EQU   DXCCW+24
DXCCW3   EQU   DXCCW+16
DXCCW2   EQU   DXCCW+8
DXCCW1   EQU   DXCCW
DXDEBNTR EQU   DYYYY+42
DXDEBEHH EQU   DYYYY+40
DXDEBECC EQU   DYYYY+38
DXDEBSHH EQU   DYYYY+36
DXDEBSCC EQU   DYYYY+34
DXDEBBIN EQU   DYYYY+32
DXDEBMOD EQU   DXDEBUCB
DXDEBAPP EQU   DYYYY+24
DXDEBID  EQU   DXDCBAD
DXDEBECB EQU   DYYYY+16
DXDEBUSR EQU   DYYYY+12
DXDEBSYS EQU   DYYYY+8
DXDEBOFL EQU   DXDEBIRB
DXDEBDEB EQU   DYYYY
IOBERRCT EQU   DXIOB+30
IOBINCAM EQU   DXIOB+28
@NM00021 EQU   DXIOB+25
@NM00020 EQU   DXIOB+24
IOBDCBPT EQU   DXIOB+21
IOBWGHT  EQU   DXIOB+20
IOBSTART EQU   DXIOB+17
IOBSIOCC EQU   DXIOB+16
IOBCNT   EQU   IOBCSW+6
IOBSTAT1 EQU   IOBCSW+5
IOBSTAT0 EQU   IOBCSW+4
IOBCOMAD EQU   IOBCSW
@NM00019 EQU   IOBECBPT+1
@NM00018 EQU   IOBECBPT
IOBSENS1 EQU   IOBSENSE+1
IOBSENS0 EQU   IOBSENSE
IOBFLAG2 EQU   DXIOB+1
IOBFLAG1 EQU   DXIOB
JFCBEND  EQU   JFCUCSEG+68
JFCBSPTN EQU   JFCUCSEG+67
JFCBVLCT EQU   JFCUCSEG+66
JFCBDRLH EQU   JFCUCSEG+63
JFCBSBNM EQU   JFCUCSEG+60
JFCBABST EQU   JFCUCSEG+58
JFCBSPNM EQU   JFCUCSEG+55
JFCBDQTY EQU   JFCUCSEG+52
JFCBUAFF EQU   JFCFLGS1
JFCRSV45 EQU   JFCFLGS1
JFCVRDS  EQU   JFCFLGS1
JFCRSV43 EQU   JFCFLGS1
JFCRSV42 EQU   JFCFLGS1
JFCRSV41 EQU   JFCFLGS1
JFCTOPEN EQU   JFCFLGS1
JFCRSV39 EQU   JFCFLGS1
JFCRSV52 EQU   JFCBIND3
JFCRSV51 EQU   JFCBIND3
JFCRSV50 EQU   JFCBIND3
JFCRSV49 EQU   JFCBIND3
JFCRSV48 EQU   JFCBIND3
JFCRSV47 EQU   JFCBIND3
JFCRSV46 EQU   JFCBIND3
JFCBDLET EQU   JFCBIND3
JFCRQID  EQU   JFCBSQTY
JFCROUND EQU   JFCBCTRI
JFCALX   EQU   JFCBCTRI
JFCMIXG  EQU   JFCBCTRI
JFCONTIG EQU   JFCBCTRI
JFCRSV29 EQU   JFCBCTRI
JFCRSV28 EQU   JFCBCTRI
JFCBSPAC EQU   JFCBCTRI
JFCRUNIT EQU   JFCBPQTY
JFCBEXAD EQU   JFCUCSEG+41
JFCBEXTL EQU   JFCUCSEG+40
JFCAVOLS EQU   JFCBVOLS
JFCBNVOL EQU   JFCUCSEG+9
JFCBNTCS EQU   JFCUCSEG+8
JFCSOWA  EQU   JFCOUTLI+1
JFCSEND  EQU   JFCCPRI
JFCEQUAL EQU   JFCCPRI
JFCRECV  EQU   JFCCPRI
JFCRSV34 EQU   JFCCPRI
JFCRSV33 EQU   JFCCPRI
JFCRSV55 EQU   JFCCPRI
JFCRSV54 EQU   JFCCPRI
JFCRSV53 EQU   JFCCPRI
JFCRSV27 EQU   JFCUCSOP
JFCRSV26 EQU   JFCUCSOP
JFCFCBVR EQU   JFCUCSOP
JFCFCBAL EQU   JFCUCSOP
JFCVER   EQU   JFCUCSOP
JFCRSV25 EQU   JFCUCSOP
JFCFOLD  EQU   JFCUCSOP
JFCRSV24 EQU   JFCUCSOP
JFCUCSID EQU   JFCUCSEG
JFCINTVL EQU   JFCSPPRT+19
JFCDBUFN EQU   JFCRESRV+3
JFCCYLOF EQU   JFCRESRV+2
JFCRKP   EQU   JFCRESRV
JFCPCIR2 EQU   JFCPCI
JFCPCIR1 EQU   JFCPCI
JFCPCIN2 EQU   JFCPCI
JFCPCIN1 EQU   JFCPCI
JFCPCIA2 EQU   JFCPCI
JFCPCIA1 EQU   JFCPCI
JFCPCIX2 EQU   JFCPCI
JFCPCIX1 EQU   JFCPCI
JFCBUFMX EQU   JFCNCP
JFCLRECL EQU   JFCAMSYN
JFCBAXBF EQU   JFCBUFSI
JFCREL   EQU   JFCREORG
JFCRSV22 EQU   JFCDEL
JFCSRCHD EQU   JFCRSV20
JFCOPTQ  EQU   JFCACT
JFCFEED  EQU   JFCIND
JFCCBWU  EQU   JFCEXT
JFCWUMSG EQU   JFCOVER
JFCSDNAM EQU   JFCWVCBD
@NM00014 EQU   JFCRECFM
JFCCHAR  EQU   JFCRECFM
JFCRFS   EQU   JFCRECFM
JFCRFB   EQU   JFCRECFM
JFCRFO   EQU   JFCRCFM
JFCFMREC EQU   JFCRCFM
JFCRSV16 EQU   JFCDSRG2
JFCRSV15 EQU   JFCDSRG2
JFCORGTR EQU   JFCDSRG2
JFCORGAM EQU   JFCDSRG2
JFCRSV13 EQU   JFCDSRG2
JFCORGTQ EQU   JFCDSRG2
JFCORGTX EQU   JFCDSRG2
JFCORGGS EQU   JFCDSRG2
JFCORGU  EQU   JFCDSRG1
JFCORGPO EQU   JFCDSRG1
JFCORGMQ EQU   JFCDSRG1
JFCORGCQ EQU   JFCDSRG1
JFCORGCX EQU   JFCDSRG1
JFCORGDA EQU   JFCDSRG1
JFCORGPS EQU   JFCDSRG1
JFCORGIS EQU   JFCDSRG1
JFCTRKBL EQU   JFCLIMCT+1
@NM00013 EQU   JFCLIMCT
JFCDEN   EQU   JFCSPPRT+1
JFCPRTSP EQU   JFCSPPRT
JFCONE   EQU   JFCMODE
JFCTWO   EQU   JFCMODE
JFCRSV07 EQU   JFCMODE
JFCRSV06 EQU   JFCMODE
JFCMODER EQU   JFCMODE
JFCMODEO EQU   JFCMODE
JFCEBCD  EQU   JFCMODE
JFCBIN   EQU   JFCMODE
JFCRSV32 EQU   JFCCODE
JFCTTY   EQU   JFCCODE
JFCASCII EQU   JFCCODE
JFCNCR   EQU   JFCCODE
JFCBUR   EQU   JFCCODE
JFCFRI   EQU   JFCCODE
JFCBCD   EQU   JFCCODE
JFCNOCON EQU   JFCCODE
MSGTEXT  EQU   DSECT06+21
MSGCOMM2 EQU   DSECT06+20
MSGVOLSR EQU   DSECT06+14
MSGCOMM1 EQU   DSECT06+13
MSGUN    EQU   DSECT06+10
MSGBLANK EQU   DSECT06+9
MSGACTN  EQU   MSGINSTR+5
@NM00011 EQU   MSGINSTR+3
MSGSERLO EQU   MSGSER+2
@NM00010 EQU   MSGSER
MSGIOSUP EQU   DSECT06
REPLY    EQU   DSECT05+84
ROUTCODE EQU   DSECT05+82
DESCODE  EQU   DSECT05+80
MESSAGEA EQU   DSECT05+12
MCSFLAGS EQU   DSECT05+10
MSGLSTSZ EQU   DSECT05+8
REPLYECB EQU   DSECT05+4
REPLYADR EQU   DSECT05+1
REPLYLTH EQU   DSECT05
DSCBNEXT EQU   DSECT04+91
DSCBEXD  EQU   DSCBEXSD+80
DSCBEXC  EQU   DSCBEXSD+70
DSCBEXB  EQU   DSCBEXSD+60
DSCBEXA  EQU   DSCBEXSD+50
DSCBEX9  EQU   DSCBEXSD+40
DSCBEX8  EQU   DSCBEXSD+30
DSCBEX7  EQU   DSCBEXSD+20
DSCBEX6  EQU   DSCBEXSD+10
DSCBEX5  EQU   DSCBEXSD
DSCBFMID EQU   DSECT04
DSCBEX4  EQU   DSCBEXSK+30
DSCBEX3  EQU   DSCBEXSK+20
DSCBEX2  EQU   DSCBEXSK+10
DSCBULMT EQU   DSCBEXSK+6
DSCBLLMT EQU   DSCBEXSK+2
DSCBEXSQ EQU   DSCBEXSK+1
DSCBEXTY EQU   DSCBEXSK
DSCBF3C  EQU   DXDSCB3K
DSCNEXT  EQU   DXDSCB+91
DSCEXT2  EQU   DXDSCB+81
DSCEXT1  EQU   DXDSCB+71
DSCUPPLM EQU   DXDSCB+67
DSCLOWLM EQU   DXDSCB+63
DSCEXTSQ EQU   DXDSCB+62
DSCEXTYP EQU   DXDSCB+61
DSCTRBAL EQU   DXDSCB+59
DSCLSTAR EQU   DXDSCB+54
DSCSCALO EQU   DXDSCB+50
DSCDSIND EQU   DXDSCB+49
DSCRKP   EQU   DXDSCB+47
DSCKEYL  EQU   DXDSCB+46
DSCLRECL EQU   DXDSCB+44
DSCBLKL  EQU   DXDSCB+42
DSCOPTCD EQU   DXDSCB+41
DSCRECFM EQU   DXDSCB+40
DSCFILTY EQU   DXDSCB+38
@NM00009 EQU   DXDSCB+31
DSCSYSCD EQU   DXDSCB+18
@NM00008 EQU   DXDSCB+17
DSCBLDBL EQU   DXDSCB+16
DSCNOEXT EQU   DXDSCB+15
DSCEXPDT EQU   DXDSCB+12
DSCCREDT EQU   DXDSCB+9
DSCVOLSR EQU   DXDSCB+7
DSCFMTID EQU   DXDSCB
FL2RES   EQU   DSECT03+35
FL2BLKA  EQU   DSECT03+34
@NM00007 EQU   DSECT03+33
FL2CNTRL EQU   DSECT03+32
FL2TRTCH EQU   DSECT03+30
FL2STEPD EQU   FL2JSID+9
FL2JSSP  EQU   FL2JSID+8
FL2JOBD  EQU   FL2JSID
FL2FILP  EQU   DSECT03+12
FL2DEN   EQU   DSECT03+11
FL2LRECL EQU   DSECT03+6
FL2BLKL  EQU   DSECT03+1
FL2RECFM EQU   DSECT03
FL1RES1  EQU   FL1RES+1
@NM00006 EQU   FL1RES
FL1SYSCD EQU   DSECT02+60
FL1BLKCT EQU   DSECT02+54
FL1FSEC  EQU   DSECT02+53
FL1EXPDT EQU   DSECT02+47
FL1CREDT EQU   DSECT02+41
FL1VNG   EQU   DSECT02+39
FL1GNO   EQU   DSECT02+35
FL1FILSQ EQU   DSECT02+31
FL1VOLSQ EQU   DSECT02+27
FL1FILSR EQU   DSECT02+21
FL1ID    EQU   DSECT02+4
FL1NO    EQU   DSECT02+3
FL1LABI  EQU   DSECT02
LABSTAND EQU   DSECT01+42
@NM00005 EQU   DSECT01+14
AVOLOWNR EQU   DSECT01
@NM00004 EQU   DXLBL+51
VOLOWNER EQU   DXLBL+41
@NM00003 EQU   DXLBL+31
@NM00002 EQU   DXLBL+21
@NM00001 EQU   DXLBL+16
VOLVTOC  EQU   DXLBL+11
VOLSEC   EQU   DXLBL+10
VOLSERNO EQU   DXLBL+4
VOLNO    EQU   DXLBL+3
VOLLABI  EQU   DXLBL
NEXTTCB  EQU   TCBPTRS
MYCODE2  EQU   SECWORK+113
GETWORK  EQU   GETPLIST
@NM00060 EQU   SECWORK+72
REGSAVEA EQU   SECWORK
CVTLEVL  EQU   CVTRELNO+2
CVTNUMB  EQU   CVTRELNO
CVTMDL   EQU   CVTFIX+250
@NM00059 EQU   CVTFIX+248
@NM00058 EQU   CVTFIX
CVTRV482 EQU   CVTXTNT2+128
CVTRV481 EQU   CVTXTNT2+124
CVTRV480 EQU   CVTXTNT2+120
CVTRV479 EQU   CVTXTNT2+118
CVTRV478 EQU   CVTXTNT2+117
CVTRV477 EQU   CVTXTNT2+116
CVTRV476 EQU   CVTXTNT2+115
CVTRV475 EQU   CVTXTNT2+114
CVTRV474 EQU   CVTRV466
CVTRV473 EQU   CVTRV466
CVTRV472 EQU   CVTRV466
CVTRV471 EQU   CVTRV466
CVTRV470 EQU   CVTRV466
CVTRV469 EQU   CVTRV466
CVTRV468 EQU   CVTRV466
CVTRV467 EQU   CVTRV466
CVTRV465 EQU   CVTRV457
CVTRV464 EQU   CVTRV457
CVTRV463 EQU   CVTRV457
CVTRV462 EQU   CVTRV457
CVTRV461 EQU   CVTRV457
CVTRV460 EQU   CVTRV457
CVTRV459 EQU   CVTRV457
CVTRV458 EQU   CVTRV457
CVTRV456 EQU   CVTXTNT2+108
CVTRV455 EQU   CVTXTNT2+104
CVTRV454 EQU   CVTXTNT2+100
CVTRV453 EQU   CVTXTNT2+96
CVTRV452 EQU   CVTXTNT2+94
CVTRV451 EQU   CVTXTNT2+92
CVTRV450 EQU   CVTXTNT2+90
CVTRV449 EQU   CVTXTNT2+88
CVTRV448 EQU   CVTXTNT2+87
CVTRV447 EQU   CVTXTNT2+86
CVTRV446 EQU   CVTRV438
CVTRV445 EQU   CVTRV438
CVTRV444 EQU   CVTRV438
CVTRV443 EQU   CVTRV438
CVTRV442 EQU   CVTRV438
CVTRV441 EQU   CVTRV438
CVTRV440 EQU   CVTRV438
CVTRV439 EQU   CVTRV438
CVTRV437 EQU   CVTRV429
CVTRV436 EQU   CVTRV429
CVTRV435 EQU   CVTRV429
CVTRV434 EQU   CVTRV429
CVTRV433 EQU   CVTRV429
CVTRV432 EQU   CVTRV429
CVTRV431 EQU   CVTRV429
CVTRV430 EQU   CVTRV429
CVTRV428 EQU   CVTXTNT2+80
CVTRV427 EQU   CVTXTNT2+76
CVTRV426 EQU   CVTXTNT2+72
CVTRV425 EQU   CVTXTNT2+68
CVTATACT EQU   CVTATCVT
CVTRV423 EQU   CVTXTNT2+62
CVTRV422 EQU   CVTXTNT2+60
CVTRV421 EQU   CVTXTNT2+58
CVTRV420 EQU   CVTXTNT2+56
CVTRV419 EQU   CVTXTNT2+55
CVTRV418 EQU   CVTXTNT2+54
CVTRV417 EQU   CVTRV409
CVTRV416 EQU   CVTRV409
CVTRV415 EQU   CVTRV409
CVTRV414 EQU   CVTRV409
CVTRV413 EQU   CVTRV409
CVTRV412 EQU   CVTRV409
CVTRV411 EQU   CVTRV409
CVTRV410 EQU   CVTRV409
CVTRV408 EQU   CVTRV400
CVTRV407 EQU   CVTRV400
CVTRV406 EQU   CVTRV400
CVTRV405 EQU   CVTRV400
CVTRV404 EQU   CVTRV400
CVTRV403 EQU   CVTRV400
CVTRV402 EQU   CVTRV400
CVTRV401 EQU   CVTRV400
CVTRSVA1 EQU   CVTXTNT2+48
CVTRSVA0 EQU   CVTXTNT2+44
CVTRSV99 EQU   CVTXTNT2+40
CVTRSV98 EQU   CVTXTNT2+36
CVTRSV97 EQU   CVTXTNT2+34
CVTRSV96 EQU   CVTXTNT2+32
CVTOLTEP EQU   CVTXTNT2+28
CVTQIDA  EQU   CVTQID+1
CVTRSV95 EQU   CVTQID
CVTRSV94 EQU   CVTXTNT2+20
CVTRSV93 EQU   CVTXTNT2+16
CVTRSV92 EQU   CVTXTNT2+12
CVTDEBVR EQU   CVTXTNT2+8
CVTRSV91 EQU   CVTXTNT2+6
CVTRSV9H EQU   CVTRSV90
CVTRSV9G EQU   CVTRSV90
CVTRSV9F EQU   CVTRSV90
CVTRSV9E EQU   CVTRSV90
CVTRSV9D EQU   CVTRSV90
CVTRSV9C EQU   CVTRSV90
CVTRSV9B EQU   CVTRSV90
CVTRSV9A EQU   CVTRSV90
CVTNUCLS EQU   CVTXTNT2+4
CVTDSSVA EQU   CVTDSSV+1
CVTRSV89 EQU   CVTDSSV
CVTRSV88 EQU   CVTXTNT1+8
CVTRSV87 EQU   CVTXTNT1+4
CVTFACHN EQU   CVTXTNT1
CVTRV488 EQU   CVTMAP+412
CVTRV487 EQU   CVTMAP+408
CVTRV486 EQU   CVTMAP+404
CVTRV485 EQU   CVTMAP+400
CVTRV484 EQU   CVTMAP+396
CVTAUTH  EQU   CVTMAP+392
CVTATMCA EQU   CVTATMCT+1
CVTATMST EQU   CVTATMCT
CVTRSV61 EQU   CVTMAP+384
CVTVOLT1 EQU   CVTVOLM1+1
CVTVOLI1 EQU   CVTVOLF1
CVTSTOA  EQU   CVTMAP+376
CVTRSV58 EQU   CVTMAP+374
CVTRSV57 EQU   CVTMAP+372
CVTDDCE  EQU   CVTMAP+368
CVTPNWFR EQU   CVTMAP+364
CVTSMF   EQU   CVTMAP+360
CVTSULK  EQU   CVTMAP+358
CVTSLKO  EQU   CVTSYSK
CVTSLKP  EQU   CVTSYSK
CVTSLKQ  EQU   CVTSYSK
CVTSLKR  EQU   CVTSYSK
CVTRSV56 EQU   CVTSYSK
CVTRSV55 EQU   CVTSYSK
CVTRSV54 EQU   CVTSYSK
CVTRSV53 EQU   CVTSYSK
CVTRSV52 EQU   CVTA1F1
CVTRSV51 EQU   CVTA1F1
CVTRSV50 EQU   CVTA1F1
CVTRSV49 EQU   CVTA1F1
CVTRSV48 EQU   CVTA1F1
CVTRSV47 EQU   CVTA1F1
CVTSRSW  EQU   CVTA1F1
CVTPFSW  EQU   CVTA1F1
CVTPCVT  EQU   CVTMAP+352
CVTRSV46 EQU   CVTMAP+344
CVTRSV45 EQU   CVTMAP+340
CVTRSV44 EQU   CVTMAP+338
CVTRSV43 EQU   CVTMAP+336
CVTHJESA EQU   CVTHJES+1
CVTRSV42 EQU   CVTHJES
CVTEXT2A EQU   CVTEXT2+1
CVTRSV41 EQU   CVTEXT2
CVTAPFA  EQU   CVTAPF+1
CVTRSV40 EQU   CVTAPF
CVTINTLA EQU   CVTMAP+320
CVTERPV  EQU   CVTMAP+316
CVTEORM  EQU   CVTMAP+312
CVTMCHPR EQU   CVTMAP+308
CVTTZ    EQU   CVTMAP+304
CVTJEPS  EQU   CVTMAP+300
CVTJESCT EQU   CVTMAP+296
CVTMODE  EQU   CVTMAP+292
CVTPTRV  EQU   CVTMAP+288
CVTREAL  EQU   CVTMAP+284
CVTRSV39 EQU   CVTMAP+280
CVTRSV38 EQU   CVTMAP+276
CVTDMSRA EQU   CVTDMSR+1
CVTRSV37 EQU   CVTDMSR
CVTQMSGA EQU   CVTQMSG+1
CVTRSV36 EQU   CVTQMSG
CVTAMFF  EQU   CVTMAP+264
CVTPURGA EQU   CVTPURG+1
CVTRSV35 EQU   CVTPURG
CVTCBSP  EQU   CVTMAP+256
CVTATERA EQU   CVTATER+1
CVTSYST  EQU   CVTATER
CVTVOLT2 EQU   CVTTAT
CVTVOLI2 EQU   CVTVOLF2
CVTAQAVB EQU   CVTAQAVT+1
CVTRSV34 EQU   CVTTCMFG
CVTRSV33 EQU   CVTTCMFG
CVTRSV32 EQU   CVTTCMFG
CVTRSV31 EQU   CVTTCMFG
CVTRSV30 EQU   CVTTCMFG
CVTRSV29 EQU   CVTTCMFG
CVTRSV28 EQU   CVTTCMFG
CVTTCRDY EQU   CVTTCMFG
CVTGTFA  EQU   CVTGTF+1
CVTRSV27 EQU   CVTGTFST
CVTRNIO  EQU   CVTGTFST
CVTRV319 EQU   CVTUSR
CVTRV318 EQU   CVTFORM
CVTRV317 EQU   CVTTMODE
CVTRV316 EQU   CVTSTATE
CVTRV315 EQU   CVTGTFS
CVTGTFAV EQU   CVTGTFS
CVT0SCR1 EQU   CVTMAP+232
CVTRV515 EQU   CVTMAP+228
CVTRMS   EQU   CVTMAP+224
CVTPATCH EQU   CVTMAP+220
CVTTSCE  EQU   CVTMAP+216
CVTLNKSC EQU   CVTMAP+214
CVTQABST EQU   CVTMAP+212
CVTMDLDS EQU   CVTMAP+208
CVTUSER  EQU   CVTMAP+204
CVTABEND EQU   CVTMAP+200
CVTSMCA  EQU   CVTMAP+196
CVTRSV18 EQU   CVTMAP+192
CVTQLPAQ EQU   CVTMAP+188
CVTQCDSR EQU   CVTMAP+184
CVTRSV17 EQU   CVTOPTB
CVTRSV16 EQU   CVTOPTB
CVTFP    EQU   CVTOPTB
CVTAPTHR EQU   CVTOPTB
CVTNLOG  EQU   CVTOPTB
CVTTOD   EQU   CVTOPTB
CVTCTIMS EQU   CVTOPTB
CVTPROT  EQU   CVTOPTB
CVTXPFP  EQU   CVTOPTA
CVTASCII EQU   CVTOPTA
CVTRSV13 EQU   CVTOPTA
CVTRSV12 EQU   CVTOPTA
CVTNIP   EQU   CVTOPTA
CVTDDR   EQU   CVTOPTA
CVTAPR   EQU   CVTOPTA
CVTCCH   EQU   CVTOPTA
CVTSNCTR EQU   CVTMAP+180
CVTQMWR  EQU   CVTMAP+176
CVTQOCR  EQU   CVTMAP+172
CVT1EF00 EQU   CVTMAP+168
CVTMZ00  EQU   CVTMAP+164
CVTHEAD  EQU   CVTMAP+160
CVTRSV11 EQU   CVTMAP+156
CVT0PT01 EQU   CVTMAP+152
CVTMSER  EQU   CVTMAP+148
CVTIERLC EQU   CVTMAP+144
CVTILCH  EQU   CVTMAP+140
CVT0DS   EQU   CVTMAP+136
CVTFBOSV EQU   CVTMAP+132
CVTNUCB  EQU   CVTMAP+128
CVTIXAVL EQU   CVTMAP+124
CVTIOQET EQU   CVTMAP+120
CVTDCBA  EQU   CVTMAP+117
CVTMVS2  EQU   CVTDCB
CVT6DAT  EQU   CVTDCB
CVT4MPS  EQU   CVTDCB
CVTRSV09 EQU   CVTDCB
CVT4MS1  EQU   CVTDCB
CVT2SPS  EQU   CVTDCB
CVT1SSS  EQU   CVTDCB
CVTRSV08 EQU   CVTDCB
CVTSTB   EQU   CVTMAP+112
CVTQTD00 EQU   CVTMAP+108
CVTQTE00 EQU   CVTMAP+104
CVTCUCB  EQU   CVTMAP+100
CVTSJQ   EQU   CVTMAP+96
CVTPBLDL EQU   CVTMAP+92
CVTTPC   EQU   CVTMAP+88
CVTSVDCB EQU   CVTMAP+84
CVTBRET  EQU   CVTMAP+82
CVTEXIT  EQU   CVTMAP+80
CVT0FN00 EQU   CVTMAP+76
CVTDARA  EQU   CVTDAR+1
CVTRSV07 EQU   CVTFLGS1
CVTRSV06 EQU   CVTFLGS1
CVTRSV05 EQU   CVTFLGS1
CVTRSV04 EQU   CVTFLGS1
CVTRSV03 EQU   CVTFLGS1
CVTRSV02 EQU   CVTFLGS1
CVTRSV01 EQU   CVTFLGS1
CVTDMPLK EQU   CVTFLGS1
CVTXITP  EQU   CVTMAP+68
CVTZDTAB EQU   CVTMAP+64
CVTMSLT  EQU   CVTMAP+60
CVTDATE  EQU   CVTMAP+56
CVTBTERM EQU   CVTMAP+52
CVTSYSAD EQU   CVTMAP+48
CVTXTLER EQU   CVTMAP+44
CVTILK2  EQU   CVTMAP+40
CVTILK1  EQU   CVTMAP+36
CVTPRLTV EQU   CVTMAP+32
CVTPCNVT EQU   CVTMAP+28
CVT0VL00 EQU   CVTMAP+24
CVTXAPG  EQU   CVTMAP+20
CVTBUF   EQU   CVTMAP+16
CVTJOB   EQU   CVTMAP+12
CVTLINK  EQU   CVTMAP+8
CVT0EF00 EQU   CVTMAP+4
CVT      EQU   CVTMAP
@NM00057 EQU   TCBXTNT2+32
TCBRV181 EQU   TCBRV173
TCBRV180 EQU   TCBRV173
TCBRV179 EQU   TCBRV173
TCBRV178 EQU   TCBRV173
TCBRV177 EQU   TCBRV173
TCBRV176 EQU   TCBRV173
TCBRV175 EQU   TCBRV173
TCBRV174 EQU   TCBRV173
TCBRV172 EQU   TCBRV164
TCBRV171 EQU   TCBRV164
TCBRV170 EQU   TCBRV164
TCBRV169 EQU   TCBRV164
TCBRV168 EQU   TCBRV164
TCBRV167 EQU   TCBRV164
TCBRV166 EQU   TCBRV164
TCBRV165 EQU   TCBRV164
TCBRV163 EQU   TCBRV155
TCBRV162 EQU   TCBRV155
TCBRV161 EQU   TCBRV155
TCBRV160 EQU   TCBRV155
TCBRV159 EQU   TCBRV155
TCBRV158 EQU   TCBRV155
TCBRV157 EQU   TCBRV155
TCBRV156 EQU   TCBRV155
TCBRV154 EQU   TCBRV146
TCBRV153 EQU   TCBRV146
TCBRV152 EQU   TCBRV146
TCBRV151 EQU   TCBRV146
TCBRV150 EQU   TCBRV146
TCBRV149 EQU   TCBRV146
TCBRV148 EQU   TCBRV146
TCBRV147 EQU   TCBRV146
TCBRV145 EQU   TCBXTNT2+26
TCBRV144 EQU   TCBXTNT2+24
TCBRV143 EQU   TCBXTNT2+20
TCBRV142 EQU   TCBXTNT2+16
TCBRSV49 EQU   TCBXTNT2+12
TCBRSV48 EQU   TCBXTNT2+8
TCBRCMP  EQU   TCBXTNT2+5
TCBRSVAB EQU   TCBXTNT2+4
TCBGTFA  EQU   TCBGTF+1
TCBRSV47 EQU   TCBTFLG
TCBRSV46 EQU   TCBTFLG
TCBRSV45 EQU   TCBTFLG
TCBRSV44 EQU   TCBTFLG
TCBRSV43 EQU   TCBTFLG
TCBDSPIT EQU   TCBTFLG
TCBERRTN EQU   TCBTFLG
TCBASYNC EQU   TCBTFLG
@NM00055 EQU   TCB+232
TCBRV186 EQU   TCB+228
TCBJSONQ EQU   TCBTTQE
TCBARBA  EQU   TCBARB+1
TCBRSV85 EQU   TCBARB
TCBGQE   EQU   TCB+216
TCBEXT2A EQU   TCBEXT2+1
TCBRSV39 EQU   TCBEXT2
TCBSTMCT EQU   TCB+207
TCBSYSCT EQU   TCB+206
TCBRSV37 EQU   TCB+205
TCBEXSVC EQU   TCBDAR
TCBRSV36 EQU   TCBDAR
TCBDARWT EQU   TCBDAR
TCBDARO  EQU   TCBDAR
TCBDARMC EQU   TCBDARC
TCBDARD  EQU   TCBDAR
TCBDARS  EQU   TCBDAR
TCBDARP  EQU   TCBDAR
TCBGTOFM EQU   TCBFLGS7
TCBRSV84 EQU   TCBADMP
TCBRSV83 EQU   TCBRSTSK
TCBRSV35 EQU   TCBFLGS7
TCBFWDD  EQU   TCBSTACK
TCBFDDEI EQU   TCBRSV34
TCBFDDT  EQU   TCBRSV33
TCBFDD   EQU   TCBGPECB
TCBSTIJS EQU   TCBNTJS
TCBDSINQ EQU   TCBAPG
TCBRUNJB EQU   TCBMIGR
TCBRUNPN EQU   TCBRV303
TCBFPROT EQU   TCBSPVLK
TCBPANIC EQU   TCBCPU
TCBPIE17 EQU   TCBFLGS6
TCBRV    EQU   TCBFLGS6
TCBRSV79 EQU   TCBNDSP5
TCBRSV78 EQU   TCBNDSP5
TCBRSV77 EQU   TCBNDSP5
TCBRSV76 EQU   TCBNDSP5
TCBRSV75 EQU   TCBNDSP5
TCBRSV74 EQU   TCBNDSP5
TCBNDGTF EQU   TCBNDSP5
TCBNDSPL EQU   TCBNDSP5
TCBRSV93 EQU   TCBNDSP4
TCBRSV92 EQU   TCBNDSP4
TCBRSV91 EQU   TCBNDSP4
TCBRSV90 EQU   TCBNDSP4
TCBRSV89 EQU   TCBNDSP4
TCBRSV88 EQU   TCBNDSP4
TCBRSV87 EQU   TCBNDSP4
TCBRSV86 EQU   TCBNDSP4
TCBEXT1A EQU   TCBEXT1+1
TCBRSV32 EQU   TCBEXT1
TCBRSV30 EQU   TCB+192
TCBIOBRC EQU   TCB+188
TCBDDWTC EQU   TCB+186
TCBDDEXC EQU   TCB+184
TCBJSCBB EQU   TCBJSCB+1
@NM00054 EQU   TCBRECDE
TCBREC   EQU   TCBRECDE
TCBMDIDS EQU   TCB+176
TCBRSV28 EQU   TCBNDINT
TCBRSV27 EQU   TCBNDSP3
TCBRSV26 EQU   TCBNDSP3
TCBRSV25 EQU   TCBNDSP3
TCBRSV24 EQU   TCBNDSP3
TCBNDSDA EQU   TCBSRBND
TCBABTER EQU   TCBRV302
TCBTERM  EQU   TCBLJSND
TCBABE   EQU   TCBNDSP2
TCBDSS   EQU   TCBNDSP2
TCBOWAIT EQU   TCBNDSP2
TCBIWAIT EQU   TCBNDSP2
TCBNDTS  EQU   TCBNDSP2
TCBNDSVC EQU   TCBNDSP2
TCBSTPP  EQU   TCBNDSP2
TCBABD   EQU   TCBNDSP2
TCBRSV22 EQU   TCBNDSP1
TCBPIEND EQU   TCBNDSP1
TCBTPSP  EQU   TCBNDSP1
TCBDDRND EQU   TCBNDSP1
TCBRSPND EQU   TCBNDSP1
TCBRSTND EQU   TCBNDSP1
TCBDARPN EQU   TCBNDSP1
TCBDARTN EQU   TCBNDSP1
TCBNDSP0 EQU   TCBNDSP
TCBUSER  EQU   TCB+168
TCBTCTB  EQU   TCBTCT+1
TCBRSV9C EQU   TCBTCTGF
TCBRSV9B EQU   TCBTCTGF
TCBRSV9A EQU   TCBTCTGF
TCBRSV99 EQU   TCBTCTGF
TCBRSV98 EQU   TCBTCTGF
TCBRSV97 EQU   TCBTCTGF
TCBRSV20 EQU   TCBTCTGF
TCBSMFGF EQU   TCBTCTGF
TCBSTABB EQU   TCBSTAB+1
TCBSTCUR EQU   TCBVALID
TCBRV301 EQU   TCBRETRY
TCBSYNCH EQU   TCBSUPER
TCBHALT  EQU   TCBNSTAE
TCBPPSUP EQU   TCBSCAT
TCB33E   EQU   TCBXCTL
TCBQUIES EQU   TCBNSTAE
TCBSTABE EQU   TCBNSTAE
TCBDDRTI EQU   TCBAQE
TCBRSV73 EQU   TCBFTFL3
TCBRSV72 EQU   TCBFTFL3
TCBFTDUM EQU   TCBFTFL3
TCBRSV71 EQU   TCBFTFL3
TCBRSV70 EQU   TCBFTFL3
TCBRSV69 EQU   TCBFTFL3
TCBRSV68 EQU   TCBFTFL3
TCBRSV67 EQU   TCBFTFL3
TCBRSV66 EQU   TCBFTFL2
TCBSYSAB EQU   TCBFTFL2
@NM00053 EQU   TCBFTFL2
TCBRSV65 EQU   TCBFTFL2
TCBRSV64 EQU   TCBFTFL2
TCBRSV63 EQU   TCBFTFL2
TCBRSV62 EQU   TCBFTFL2
TCBRSV61 EQU   TCBFTFL2
TCBENQ   EQU   TCBFTFL1
TCBFTCOM EQU   TCBFTFL1
TCBFTTOP EQU   TCBFTFL1
TCBRSV60 EQU   TCBFTFL1
TCBRSV59 EQU   TCBFTFL1
TCBRSV58 EQU   TCBFTFL1
TCBRSV57 EQU   TCBFTFL1
TCBRSV56 EQU   TCBFTFL1
TCBFTLMP EQU   TCBPQE
TCBTSDP  EQU   TCB+151
TCBTSLP  EQU   TCB+150
TCBSTPCT EQU   TCB+149
TCBCPUBN EQU   TCBTSFLG
TCBDYDSP EQU   TCBTSFLG
TCBRSV18 EQU   TCBTSFLG
TCBRSV17 EQU   TCBTSFLG
TCBTIOTG EQU   TCBTSFLG
TCBATT   EQU   TCBTSFLG
TCBSTPPR EQU   TCBTSFLG
TCBRV300 EQU   TCBTSTSK
TCBECB   EQU   TCB+144
TCBIQE   EQU   TCB+140
TCBLTC   EQU   TCB+136
TCBOTC   EQU   TCB+132
TCBNTC   EQU   TCB+128
TCBJSTCA EQU   TCBPIBA
TCBSCHED EQU   TCBPIBT
TCBWRITE EQU   TCBPIBT
TCBSCHTI EQU   TCBPIBT
TCBRSV54 EQU   TCBPIBT
TCBSTOP  EQU   TCBPIBT
TCBSIZE  EQU   TCBPIBT
TCBPART  EQU   TCBPIBT
TCBTQET  EQU   TCBTME
TCBTCB   EQU   TCB+116
TCBFSAB  EQU   TCBFSA+1
TCBQEL   EQU   TCBIDF
TCBGRS15 EQU   TCBGRS+60
TCBGRS14 EQU   TCBGRS+56
TCBGRS13 EQU   TCBGRS+52
TCBGRS12 EQU   TCBGRS+48
TCBGRS11 EQU   TCBGRS+44
TCBGRS10 EQU   TCBGRS+40
TCBGRS9  EQU   TCBGRS+36
TCBGRS8  EQU   TCBGRS+32
TCBGRS7  EQU   TCBGRS+28
TCBGRS6  EQU   TCBGRS+24
TCBGRS5  EQU   TCBGRS+20
TCBGRS4  EQU   TCBGRS+16
TCBGRS3  EQU   TCBGRS+12
TCBGRS2  EQU   TCBGRS+8
TCBGRS1  EQU   TCBGRS+4
TCBGRS0  EQU   TCBGRS
TCBJPQB  EQU   TCBFTJSA
TCBRSV15 EQU   TCBPURGE
TCBRSV14 EQU   TCBPURGE
TCBRSV13 EQU   TCBPURGE
TCBRSV12 EQU   TCBPURGE
TCBRSV11 EQU   TCBPURGE
TCBRSV10 EQU   TCBPURGE
TCBRSV09 EQU   TCBPURGE
TCBJPQF  EQU   TCBPURGE
TCBJLB   EQU   TCB+40
TCBLLS   EQU   TCB+36
TCBDSP   EQU   TCB+35
TCBLMP   EQU   TCB+34
TCBPNDSP EQU   TCBFLGS5
TCBFCD1  EQU   TCBFLGS5
TCBSTP   EQU   TCBFLGS5
TCBSYS   EQU   TCBFLGS5
TCBANDSP EQU   TCBFLGS5
TCBPAGE  EQU   TCBFLGS5
TCBUXNDF EQU   TCBABWF
TCBFC    EQU   TCBFLGS5
TCBONDSP EQU   TCBFLGS4
TCBMPCND EQU   TCBFLGS4
TCBMPCVQ EQU   TCBFLGS4
TCBUXNDV EQU   TCBFLGS4
TCBHNDSP EQU   TCBFLGS4
TCBRQENA EQU   TCBFLGS4
TCBSER   EQU   TCBFLGS4
TCBNDUMP EQU   TCBFLGS4
TCBRSV53 EQU   TCBDWSTA
TCBPKCHG EQU   TCBRSV08
TCBSCHAB EQU   TCBRSV07
TCBFLREG EQU   TCBRSV06
TCBRSV52 EQU   TCBABGM
TCBSYSER EQU   TCBABTRM
TCBRSV51 EQU   TCBADINP
TCBFSM   EQU   TCBFLGS3
TCBFTS   EQU   TCBFLGS2
TCBFETXR EQU   TCBFLGS2
TCBRSV50 EQU   TCBFDSOP
TCBFJMC  EQU   TCBFLGS2
TCBFSMC  EQU   TCBFLGS2
TCBFABOP EQU   TCBFLGS2
TCBFSTI  EQU   TCBFLGS2
TCBFOINP EQU   TCBSYSTK
TCBFX    EQU   TCBFLGS1
TCBFS    EQU   TCBFLGS1
TCBPOOL  EQU   TCBFT
TCBDMPA  EQU   TCBPDUMP
TCBRSV04 EQU   TCBFLGS1
@NM00052 EQU   TCBFERA
TCBFE    EQU   TCBFLGS1
TCBFA    EQU   TCBFLGS1
TCBZERO  EQU   TCBPKF
TCBFLAG  EQU   TCBPKF
TCBMSSB  EQU   TCBMSS+1
TCBRSV03 EQU   TCBMSS
TCBTRNB  EQU   TCBTRN+1
TCBRSV02 EQU   TCBABF
TCBOLTEP EQU   TCBABF
TCBTCP   EQU   TCBABF
TCBTCPP  EQU   TCBABF
TCBRSV01 EQU   TCBABF
TCBGRPH  EQU   TCBABF
TCBNOCHK EQU   TCBABF
TCBMOD91 EQU   TCBABF
TCBCMPC  EQU   TCBCMP+1
TCBRV318 EQU   TCBCMSG
TCBRV317 EQU   TCBCIND
TCBRV316 EQU   TCBCWTO
TCBCASID EQU   TCBCDBL
TCBNOCC  EQU   TCBSTCC
TCBDMPO  EQU   TCBCPP
TCBCSTEP EQU   TCBCMPF
TCBCREQ  EQU   TCBCMPF
TCBTIO   EQU   TCB+12
TCBDEB   EQU   TCB+8
TCBPIEA  EQU   TCBPIE+1
TCBPM    EQU   TCBPMASK
@NM00051 EQU   TCBPMASK
TCBFRS6  EQU   TCBFRS+24
TCBFRS4  EQU   TCBFRS+16
TCBFRS2  EQU   TCBFRS+8
TCBFRS0  EQU   TCBFRS
CDBMDSZA EQU   CDBMDSZ+1
CDBSUBPL EQU   CDBMDSZ
CDBMDADA EQU   CDBMDAD+1
CDBNLSZ  EQU   CDBMDAD
XSVRBEND EQU   XRB+152
@NM00050 EQU   XRB+96
XSIRBEND EQU   XRB+96
XIRBEND  EQU   XRB+96
@NM00049 EQU   XRB+32
XLPRBEND EQU   XRB+32
XPRBEND  EQU   XRB+32
@NM00048 EQU   @NM00046+1
@NM00047 EQU   @NM00046
XRBQ     EQU   XRB+24
XFRBEND  EQU   XRB+24
@NM00045 EQU   XRTLPRB+1
XRBWTIS  EQU   XRBFLAG1
@NM00044 EQU   XRBFLAG1
XRBSRSW  EQU   XRBFLAG1
XRBPFSW  EQU   XRBFLAG1
XRREQ    EQU   @NM00043
XLRBEND  EQU   XRB+16
XRBEPA   EQU   XRBEP+1
XRBUSE   EQU   XRBEP
@NM00042 EQU   @NM00038
@NM00041 EQU   @NM00038
XRBIRBBT EQU   @NM00038
XRBREUS  EQU   @NM00038
XRBRSREG EQU   @NM00038
XRBGTMAN EQU   @NM00040
XRBNRENT EQU   @NM00039
XRBREFR  EQU   @NM00036
XRBETXR  EQU   XRBLRBFX
@NM00037 EQU   @NM00036
XRBSVRES EQU   @NM00036
XRBTYPF  EQU   @NM00036
XRBSZY   EQU   XRB+9
XRBCDBPY EQU   XRB+8
XRBNM    EQU   XRB
XRBPFXND EQU   XRBPRFX1+8
XRBPRE   EQU   XRBPRFX1+4
XRBSUC   EQU   XRBPRFX1
XRBQMAJ  EQU   XRBPRFX+4
@NM00034 EQU   XRBPRFX
RBEXSAVE EQU   XRBESA
XRBREG15 EQU   RBGRS15
XRBREG14 EQU   RBGRS14
XRBREG13 EQU   RBGRS13
XRBREG12 EQU   RBGRS12
XRBREG11 EQU   RBGRS11
XRBREG10 EQU   RBGRS10
XRBREG9  EQU   RBGRS9
XRBREG8  EQU   RBGRS8
XRBREG7  EQU   RBGRS7
XRBREG6  EQU   RBGRS6
XRBREG5  EQU   RBGRS5
XRBREG4  EQU   RBGRS4
XRBREG3  EQU   RBGRS3
XRBREG2  EQU   RBGRS2
XRBREG1  EQU   RBGRS1
XRBREG0  EQU   RBGRS0
XRBWT    EQU   RBWCF
@NM00033 EQU   RBBASIC+24
@NM00032 EQU   RBBASIC+12
XRBWAIT  EQU   RBECBWT
XRBFRRB  EQU   RBFDYN
@NM00031 EQU   XSTAB2
XRBACTV  EQU   RBFACTV
XRBTCBP  EQU   RBTCBNXT
@NM00030 EQU   XSTAB1
XRBCKPT  EQU   RBFTCKPT
@NM00029 EQU   XSTAB1
@NM00028 EQU   RBBASIC+8
@NM00027 EQU   RBEXRTNM+1
RBTMIND3 EQU   RBTMFLD
RBTMIND2 EQU   RBTMFLD
RBTMCMP  EQU   RBTMFLD
RBWLIM   EQU   RBTMFLD
RBRSV005 EQU   RBTMFLD
RBTMTOD  EQU   RBTMFLD
RBTMQUE  EQU   RBTMFLD
@NM00026 EQU   RBPRFX
PDPCTACB EQU   IDAPDPRM+28
PDPDSN   EQU   IDAPDPRM+24
PDPCLSNM EQU   IDAPDPRM+20
PDPVLSER EQU   IDAPDPRM+16
PDPTIOT  EQU   IDAPDPRM+12
PDPUCB   EQU   IDAPDPRM+8
PDPACB   EQU   IDAPDPRM+4
PDPKEY   EQU   IDAPDPRM+3
PDPFUNC  EQU   IDAPDPRM+2
PDPCODE  EQU   IDAPDPRM+1
PDPCALL  EQU   IDAPDPRM
JFCBXNXT EQU   JFCBX+172
@NM00017 EQU   JFCBX+144
JFCBXDEV EQU   JFCBX+140
JFCBXNAM EQU   JFCBX+96
@NM00016 EQU   JFCBX+94
JFCBXVOL EQU   JFCBX+4
@NM00015 EQU   JFCBX+3
JFCBXTTR EQU   JFCBX
JFCRSV05 EQU   JFCEROPT
JFCRSV04 EQU   JFCEROPT
JFCRSV03 EQU   JFCEROPT
JFCRSV02 EQU   JFCEROPT
JFCTOPT  EQU   JFCEROPT
JFCABN   EQU   JFCEROPT
JFCSKP   EQU   JFCEROPT
JFCACC   EQU   JFCEROPT
JFCBUFL  EQU   JFCAMPTR+2
JFCFWORD EQU   JFCBFTEK
JFCDWORD EQU   JFCBFTEK
JFCHIER1 EQU   JFCBFTEK
JFCDYN   EQU   JFCBFTEK
JFCEXC   EQU   JFCBFTEK
JFCBBFTR EQU   JFCBBFTA
JFCSIM   EQU   JFCBBFTA
JFCHIER  EQU   JFCBFTEK
JFCBFOUT EQU   JFCBUFNO
JFCBUFIN EQU   JFCBUFNO
JFCTEMP  EQU   JFCBIND2
JFCREQ   EQU   JFCBIND2
JFCENT   EQU   JFCBIND2
JFCSHARE EQU   JFCBIND2
JFCSECUR EQU   JFCBIND2
JFCDISP  EQU   JFCBIND2
JFCPDS   EQU   JFCBIND1
JFCGDG   EQU   JFCBIND1
JFCADDED EQU   JFCBIND1
JFCLOC   EQU   JFCBIND1
JFCRLSE  EQU   JFCBIND1
JFCBXPDT EQU   INFMJFCB+83
JFCBCRDT EQU   INFMJFCB+80
JFCBOPS2 EQU   JFCBMASK+7
JFCRCTLG EQU   JFCBFLG2
JFCBBUFF EQU   JFCBFLG2
JFCTRACE EQU   JFCBFLG2
JFCSDRPS EQU   JFCBFLG2
JFCMODNW EQU   JFCBFLG2
JFCNRPS  EQU   JFCDEFER
JFCOUTOP EQU   JFCBFLG2
JFCINOP  EQU   JFCBFLG2
JFCBPWBP EQU   JFCOPEN
@NM00012 EQU   JFCOPEN
JFCDUAL  EQU   JFCBFLG1
JFCSLDES EQU   JFCBFLG1
JFCSLCRE EQU   JFCBFLG1
JFCSTAND EQU   JFCBFLG1
JFCBOPS1 EQU   JFCBMASK
JFCBVLSQ EQU   INFMJFCB+70
JFCRSV31 EQU   JFCFUNC
JFCFNCBT EQU   JFCFUNC
JFCFNCBX EQU   JFCFUNC
JFCFNCBD EQU   JFCFUNC
JFCFNCBW EQU   JFCFUNC
JFCFNCBP EQU   JFCFUNC
JFCFNCBR EQU   JFCFUNC
JFCFNCBI EQU   JFCFUNC
JFCBFOFL EQU   JFCBUFOF
JFCNL    EQU   JFCBLTYP
JFCSL    EQU   JFCBLTYP
JFCNSL   EQU   JFCBLTYP
JFCSUL   EQU   JFCBLTYP
JFCBLP   EQU   JFCBLTYP
JFCBLTM  EQU   JFCBLTYP
JFCBAL   EQU   JFCBLTYP
JFCRSV38 EQU   JFCBLTYP
JFCRSV01 EQU   INFMJFCB+64
JFCNLREC EQU   INFMJFCB+62
JFCBADBF EQU   INFMJFCB+60
JFCAMSTR EQU   JFCBFRID+2
JFCAMCRO EQU   JFCBFRID
JFCBDSCB EQU   INFMJFCB+53
JFCPAT   EQU   JFCBTSDM
JFCNDCB  EQU   JFCBTSDM
JFCNDSCB EQU   JFCBTSDM
JFCNWRIT EQU   JFCBTSDM
JFCTTR   EQU   JFCBTSDM
JFCSDS   EQU   JFCBTSDM
JFCVSL   EQU   JFCBTSDM
JFCCAT   EQU   JFCBTSDM
JFCIPLTX EQU   JFCBELNM
JFCBQNAM EQU   JFCBDSNM
.@UNREFD ANOP                          END UNREFERENCED COMPONENTS
@PB00002 EQU   @PB00003
@RC00127 EQU   @EL00003
@ENDDATA EQU   *
         END   IDA0192G,(C'PL/S-II',0502,73306)
