         TITLE 'IDA019RN  INDEXING SUBROUTINES                         *
                        '
IDA019RN CSECT ,                                                   0001
@MAINENT DS    0H                                                  0001
         USING *,@15                                               0001
         B     @PROLOG                                             0001
         DC    AL2(@EP00001-@MAINENT)
         DC    AL1(16)                                             0001
         DC    C'IDA019RN  78.172'                                 0001
IDAAQR   DS    0H                                                  0001
         USING *,@15                                               0001
         B     @PROLOG                                             0001
         DC    AL2(@EP00097-IDAAQR)
         ENTRY IDAAQR
IDAER    DS    0H                                                  0001
         USING *,@15                                               0001
         B     @PROLOG                                             0001
         DC    AL2(@EP00226-IDAER)
         ENTRY IDAER
         DROP  @15
@PROLOG  BALR  @11,0                                               0001
@PSTART  DS    0H                                                  0001
         USING @PSTART,@11                                         0001
         AH    @15,4(,@15)                                         0001
         BR    @15                                                 0001
@EP00001 DS    0H                                                  0002
*                                                                  0097
*/*    IDAAQR SUBROUTINE                                             */
*/*       FUNCTION                                                   */
*/*        OBTAINS AN RBA FOR AN INDEX RECORD                        */
*/*        PREFORMATS THE RECORD IF REQUIRED                         */
*/*       INPUT -                                                    */
*/*        RWORK1 = POINTER TO CURRENT WORK AREA                     */
*/*       OUTPUT -                                                   */
*/*        RBA WILL BE PLACED INTO ICWCRBA FIELD OF WORK AREA        */
*/*        AFTER ICWCRBA HAS BEEN MOVED TO ICWPRBA                   */
*/*       RETURN -                                                   */
*/*        TO CALLER IF NO ERRORS WERE ENCOUNTERED                   */
*/*        TO CALLER OF CALLER IN CASE OF I/O ERROR                  */
*/*                                                                  */
*                                                                  0097
*IDAAQR:                                                           0097
*   ENTRY;                          /*                               */
@EP00097 DS    0H                                                  0098
*   GEN SETS(PLHRETO,PLHRET1)(IDASVR14);/* SAVE REG 14               */
         IDASVR14
*   RESPECIFY                                                      0099
*    (RWORK2) RSTD;                 /*                               */
*   RWORK2=AMDPARDB;                /* POINT TO FIRST ARDB           */
         L     @10,AMBDSB(,RAMB)                                   0100
         L     RWORK2,AMDPARDB(,@10)                               0100
*   IF AMDSDT=ON THEN               /* IS SEQ SET WITH DATA          */
         TM    AMDSDT(@10),B'00100000'                             0101
         BNO   @RF00101                                            0101
*     DO;                           /* YES                           */
*       IF ICWLN=ICWSS THEN         /* IS THIS SEQ SET LEVEL         */
         CLC   ICWLN(2,RWORK1),@CH00053                            0103
         BNE   @RF00103                                            0103
*         DO;                       /* YES                           */
*           IF ICWKRDS=ON THEN      /* IS THIS A KEY RANGE DS        */
         TM    ICWKRDS(RWORK1),B'00000100'                         0105
         BNO   @RF00105                                            0105
*             DO WHILE RWORK2->ARDNPTR/* YES, START ROUTINE TO       */
*                   ^=ZERO;         /* LOCATE ARDB WITH ARDKR        */
         B     @DE00106                                            0106
@DL00106 DS    0H                                                  0107
*               IF RWORK2->ARDKR=ON THEN/* = ON AND LO AND HI KEY    */
         TM    ARDKR(RWORK2),B'10000000'                           0107
         BNO   @RF00107                                            0107
*                 DO;               /* BRACKETING PLH KEY            */
*                   IF RWORK2->ARDKEYS(1:AMDKEYLN)/* IS LO KEY LESS  */
*                       ^>PLHKEY(1:AMDKEYLN) THEN/* THAN OR = PLHKEY */
         L     @10,PLHKEYPT(,RPLH)                                 0109
         L     @07,AMBDSB(,RAMB)                                   0109
         LH    @07,AMDKEYLN(,@07)                                  0109
         LR    @15,@07                                             0109
         BCTR  @15,0                                               0109
         EX    @15,@SC00895                                        0109
         BH    @RF00109                                            0109
*                     DO;           /* YES, POINT TO HI KEY          */
*                       RPARM1=RWORK2+AMDKEYLN;/* OF THE ARDB        */
         ALR   @07,RWORK2                                          0111
         LR    RPARM1,@07                                          0111
*                       IF RPARM1->ARDKEYS(1:AMDKEYLN)/* IS HI KEY > */
*                           ^<PLHKEY(1:AMDKEYLN) THEN/* OR = TO    0112
*                                      PLHKEY                        */
         EX    @15,@SC00897                                        0112
         BNL   @RT00112                                            0112
*                         GO TO PROCEED;/* YES, ARDB FOUND           */
*                     END;          /*                               */
*                 END;              /*                               */
@RF00109 DS    0H                                                  0116
*               RWORK2=RWORK2->ARDNPTR;/* POINT TO NEXT ARDB         */
@RF00107 L     RWORK2,ARDNPTR(,RWORK2)                             0116
*             END;                  /*                               */
@DE00106 L     @10,ARDNPTR(,RWORK2)                                0117
         LTR   @10,@10                                             0117
         BNZ   @DL00106                                            0117
*           ELSE                    /* NOT KEY RANGE DATA SET        */
*             DO WHILE RWORK2->ARDNPTR/* LOOP THRU ARDB STRING       */
*                   ^=ZERO;         /* LOOKING FOR THE ONE           */
         B     @RC00105                                            0118
@RF00105 B     @DE00118                                            0118
@DL00118 DS    0H                                                  0119
*               IF RWORK2->ARDSS=ON THEN/* WHICH REPRESENTS THE      */
         TM    ARDSS(RWORK2),B'00100000'                           0119
         BO    @RT00119                                            0119
*                 GO TO PROCEED;    /* SEQUENCE                      */
*               ELSE                /*                               */
*                 RWORK2=RWORK2->ARDNPTR;/* MOVE TO NEXT ARDB        */
         L     RWORK2,ARDNPTR(,RWORK2)                             0121
*             END;                  /*                               */
@DE00118 L     @10,ARDNPTR(,RWORK2)                                0122
         LTR   @10,@10                                             0122
         BNZ   @DL00118                                            0122
*         END;                      /*                               */
*       ELSE                        /* NOT SEQUENCE SET LVL          */
*         DO WHILE RWORK2->ARDNPTR  /* SO LOOP THRU ARDB             */
*               ^=ZERO;             /* STRING TO LOCATE ARDB         */
         B     @RC00103                                            0124
@RF00103 B     @DE00124                                            0124
@DL00124 DS    0H                                                  0125
*           IF RWORK2->ARDHLI=ON THEN/* REPRESENTING THE HI          */
         TM    ARDHLI(RWORK2),B'01000000'                          0125
         BO    @RT00125                                            0125
*             GO TO PROCEED;        /* LEVELS OF INDEX               */
*           RWORK2=RWORK2->ARDNPTR; /* MOVE TO NEXT ARDB             */
         L     RWORK2,ARDNPTR(,RWORK2)                             0127
*         END;                      /*                               */
@DE00124 L     @10,ARDNPTR(,RWORK2)                                0128
         LTR   @10,@10                                             0128
         BNZ   @DL00124                                            0128
*     END;                          /*                               */
@RC00103 DS    0H                                                  0130
*PROCEED:                                                          0130
*   IF RWORK2->ARDHRBA^<            /* IS SPACE AVAILABLE IN         */
*       RWORK2->ARDERBA THEN        /* THIS ARDB                     */
@RF00101 DS    0H                                                  0130
PROCEED  CLC   ARDHRBA(4,RWORK2),ARDERBA(RWORK2)                   0130
         BL    @RF00130                                            0130
*     DO;                           /* NO                            */
*       PLHEOVR=AMBEOVAR;           /* REQUEST ALLOC. BY RBA         */
         MVI   PLHEOVR(RPLH),B'10000010'                           0132
*       PLHEOVPT=ADDR(RWORK2->ARDERBA);/* SET RBA TO EXTEND          */
         LA    @10,ARDERBA(,RWORK2)                                0133
         ST    @10,PLHEOVPT(,RPLH)                                 0133
*       RPARM1=RWORK2;              /* SAVE ARDB ADDRESS             */
         LR    RPARM1,RWORK2                                       0134
*I01:                                                              0135
*       DO;                         /* IDACALL(IDAEOVIF)             */
I01      DS    0H                                                  0136
*         CALL IDAEOVIF;            /* EXIT TO IDAEOVIF              */
         L     @15,@CV00854                                        0136
         BALR  @14,@15                                             0136
*         GEN(BALR @11,0);          /* LOAD ADDR OF REENTRY          */
         BALR @11,0
*         GEN(USING *,@11);         /* ESTABLISH ADDRESSING          */
         USING *,@11
*         GEN(L     @11,=A(@PSTART));/* RELOAD BASE                  */
         L     @11,=A(@PSTART)
*         GEN(USING @PSTART,@11);   /* ESTABLISH ADDRESSING          */
         USING @PSTART,@11
*       END I01;                    /* GO TO EOV ROUTINE             */
*       RESPECIFY                                                  0142
*        (RWORK1,                                                  0142
*         RWORK2) RSTD;             /*                               */
*       RESPECIFY                                                  0143
*        (R15) RSTD;                /*                               */
*       IF RPLERREG^=ZERO THEN      /* WAS SPACE AVAILABLE           */
         CLI   RPLERREG(RRPL),0                                    0144
         BE    @RF00144                                            0144
*         DO;                       /* NO                            */
*           IF AMBCREAT=ON THEN     /* IS THIS CREATE MODE           */
         TM    AMBCREAT(RAMB),B'10000000'                          0146
         BNO   @RF00146                                            0146
*             PLHKEYMD=OFF;         /* YES, FORCE ERRORS IF USER   0147
*                                      CONTINUES TO ADD RECORDS TO 0147
*                                      DATA SET                      */
         NI    PLHKEYMD(RPLH),B'11011111'                          0147
*           RAMB=AMBLDTA;           /* RESTORE RAMB                  */
@RF00146 L     @14,RPLDACB(,RRPL)                                  0148
         L     @14,ACBAMBL(,@14)                                   0148
         L     RAMB,AMBLDTA(,@14)                                  0148
*           R15=IOERR;              /* SET CATASTROPHIC ERROR        */
         LA    R15,4                                               0149
*           GEN(IDARST14);          /* POINT TO CALLER               */
         IDARST14
*           CALL EXIT;              /* RETURN TO CALLER              */
         BAL   @14,EXIT                                            0151
*           RESPECIFY                                              0152
*            (R15) UNRSTD;          /*                               */
*         END;                      /*                               */
*       DO;                         /*                               */
@RF00144 DS    0H                                                  0155
*         RWORK1=AMBIWA;            /* POINT TO FIRST WA             */
         L     RWORK1,AMBIWA(,RAMB)                                0155
*         RWORK2=ICWADD;            /* GET ADDRESS OF CURRENT        */
         L     RWORK2,ICWADD(,RWORK1)                              0156
*         RWORK1=RWORK2;            /* WA IN RWORK1                  */
         LR    RWORK1,RWORK2                                       0157
*         RWORK2=RPARM1;            /* POINT TO ARDB                 */
         LR    RWORK2,RPARM1                                       0158
*         RWORK2->ARDUSED=OFF;      /* INSURE PREFORMAT              */
         NI    ARDUSED(RWORK2),B'11111011'                         0159
*       END;                        /*                               */
*     END;                          /*                               */
*   DO;                             /*                               */
@RF00130 DS    0H                                                  0163
*     ICWPRBA=ICWCRBA;              /* MOVE CURR. TO PREV. RBA       */
         L     @10,ICWCRBA(,RWORK1)                                0163
         ST    @10,ICWPRBA(,RWORK1)                                0163
*     ICWCRBA=RWORK2->ARDHRBA;      /* MOVE NEW RBA TO WA            */
         L     @10,ARDHRBA(,RWORK2)                                0164
         ST    @10,ICWCRBA(,RWORK1)                                0164
*     AMDNLR=AMDNLR+ONE;            /* BUMP STATISTICS COUNT         */
         L     @07,AMBDSB(,RAMB)                                   0165
         LA    @00,1                                               0165
         AL    @00,AMDNLR(,@07)                                    0165
         ST    @00,AMDNLR(,@07)                                    0165
*     AMDASPA=AMDASPA-AMDCINV;      /* REDUCE TOTAL NO. BYTES        */
         L     @15,AMDCINV(,@07)                                   0166
         L     @00,AMDASPA(,@07)                                   0166
         SLR   @00,@15                                             0166
         ST    @00,AMDASPA(,@07)                                   0166
*     RWORK2->ARDHRBA=RWORK2->ARDHRBA/* MOVE HIGH USED               */
*         +AMDCINV;                 /* RBA UP BY CI LENGTH           */
         ALR   @15,@10                                             0167
         ST    @15,ARDHRBA(,RWORK2)                                0167
*     IF RWORK2->ARDUSED=OFF THEN   /* HAS ANY SPACE BEEN USED       */
         TM    ARDUSED(RWORK2),B'00000100'                         0168
         BNZ   @RF00168                                            0168
*       DO;                         /* NO, PREFORMAT IS REQD.        */
*         ICWARDBP=RWORK2;          /* SAVE ARDB PTR IN WA           */
         ST    RWORK2,ICWARDBP(,RWORK1)                            0170
*         RPARM1=ICWCRBA;           /* GET INITIAL RBA AND           */
         LR    RPARM1,@10                                          0171
*I02:                                                              0172
*         DO;                       /* IDACALL(IDA019RK)             */
I02      DS    0H                                                  0173
*           CALL IDA019RK;          /* EXIT TO IDA019RK              */
         L     @15,@CV00855                                        0173
         BALR  @14,@15                                             0173
*           GEN(BALR @11,0);        /* LOAD ADDR OF REENTRY          */
         BALR @11,0
*           GEN(USING *,@11);       /* ESTABLISH ADDRESSING          */
         USING *,@11
*           GEN(L     @11,=A(@PSTART));/* RELOAD BASE                */
         L     @11,=A(@PSTART)
*           GEN(USING @PSTART,@11); /* ESTABLISH ADDRESSING          */
         USING @PSTART,@11
*         END I02;                  /* GO PREFORMAT                  */
*         RESPECIFY                                                0179
*          (RWORK1,                                                0179
*           RWORK2) RSTD;           /*                               */
*         IF RPLERREG^=ZERO THEN    /* WAS THERE AN I/O ERROR        */
         CLI   RPLERREG(RRPL),0                                    0180
         BNE   @RT00180                                            0180
*           GO TO FMTERR;           /* GO RETURN WITH ERROR          */
*         RWORK1=AMBIWA;            /* REESTABLISH RWORK1            */
         L     RWORK1,AMBIWA(,RAMB)                                0182
*         RWORK2=ICWADD;            /* AND RWORK2 REGS               */
         L     RWORK2,ICWADD(,RWORK1)                              0183
*         RWORK1=RWORK2;            /* BECAUSE THEY WERE             */
         LR    RWORK1,RWORK2                                       0184
*         RWORK2=ICWARDBP;          /* SUBJECT TO DESTRUCTION        */
         L     RWORK2,ICWARDBP(,RWORK1)                            0185
*         RWORK2->ARDUSED=ON;       /* MARK ARDB INITIALIZED         */
         OI    ARDUSED(RWORK2),B'00000100'                         0186
*       END;                        /*                               */
*     IF AMDREPL=ON|(AMDSDT=ON&     /* IS REPLICATION                */
*         ICWLN=ICWSS) THEN         /* SPECIFIED OR IMPLIED          */
@RF00168 L     @10,AMBDSB(,RAMB)                                   0188
         TM    AMDREPL(@10),B'00010000'                            0188
         BO    @RT00188                                            0188
         TM    AMDSDT(@10),B'00100000'                             0188
         BNO   @RF00188                                            0188
         CLC   ICWLN(2,RWORK1),@CH00053                            0188
         BE    @RT00188                                            0188
*       GO TO PREFMT;               /* YES                           */
*     DO;                           /* ARE ANY PREFORMATTED          */
@RF00188 DS    0H                                                  0191
*       RPARM1=((ICWCRBA/AMDCINV)//(AMDCIPCA))+ONE;/* RECORDS        */
         L     @10,AMBDSB(,RAMB)                                   0191
         L     @09,ICWCRBA(,RWORK1)                                0191
         SLR   @08,@08                                             0191
         D     @08,AMDCINV(,@10)                                   0191
         LH    @10,AMDCIPCA(,@10)                                  0191
         SLR   @08,@08                                             0191
         DR    @08,@10                                             0191
         AL    @08,@CF00053                                        0191
         LR    RPARM1,@08                                          0191
*       IF RPARM1=AMDCIPCA&RWORK2->ARDHRBA^=/* REMAINING             */
*           RWORK2->ARDERBA THEN    /*                               */
         CR    RPARM1,@10                                          0192
         BNE   @RF00192                                            0192
         CLC   ARDHRBA(4,RWORK2),ARDERBA(RWORK2)                   0192
         BE    @RF00192                                            0192
*PREFMT:                                                           0193
*         DO;                       /* FINAL CHK BEFORE PREFMT       */
PREFMT   DS    0H                                                  0194
*           IF RWORK2->ARDHRBA<     /* IS ANY SPACE AVAILABLE        */
*               RWORK2->ARDERBA THEN/* IN ARDB TO PREFORMAT          */
         L     @10,ARDHRBA(,RWORK2)                                0194
         CL    @10,ARDERBA(,RWORK2)                                0194
         BNL   @RF00194                                            0194
*             DO;                   /* YES                           */
*               RPARM1=RWORK2->ARDHRBA;/* GET RBA TO PREFORMAT       */
         LR    RPARM1,@10                                          0196
*I03:                                                              0197
*               DO;                 /* IDACALL(IDA019RK)             */
I03      DS    0H                                                  0198
*                 CALL IDA019RK;    /* EXIT TO IDA019RK              */
         L     @15,@CV00855                                        0198
         BALR  @14,@15                                             0198
*                 GEN(BALR @11,0);  /* LOAD ADDR OF REENTRY          */
         BALR @11,0
*                 GEN(USING *,@11); /* ESTABLISH ADDRESSING          */
         USING *,@11
*                 GEN(L     @11,=A(@PSTART));/* RELOAD BASE          */
         L     @11,=A(@PSTART)
*                 GEN(USING @PSTART,@11);/* ESTABLISH ADDRESSING     */
         USING @PSTART,@11
*               END I03;            /* GO TO PREFORMAT ROUTINE       */
*               RESPECIFY                                          0204
*                (RWORK1) RSTD;     /*                               */
*               IF RPLERREG^=ZERO THEN/* WAS THERE AN ERROR          */
         CLI   RPLERREG(RRPL),0                                    0205
         BE    @RF00205                                            0205
*FMTERR:                                                           0206
*                 DO;               /* YES                           */
FMTERR   DS    0H                                                  0207
*                   RESPECIFY                                      0207
*                    (R15) RSTD;    /*                               */
*                   R15=IOERR;      /* SHOW ERROR IN REG 15          */
         LA    R15,4                                               0208
*                   RAMB=AMBLDTA;   /* RESTORE RAMB FOR CALLER       */
         L     @14,RPLDACB(,RRPL)                                  0209
         L     @14,ACBAMBL(,@14)                                   0209
         L     RAMB,AMBLDTA(,@14)                                  0209
*                   GEN(IDARST14);  /* POINT BACK TO CALLER          */
         IDARST14
*                   CALL EXIT;      /* RETURN                        */
         BAL   @14,EXIT                                            0211
*                   RESPECIFY                                      0212
*                    (R15) UNRSTD;  /*                               */
*                 END;              /*                               */
*               DO;                 /* REESTABLISH RWORK1            */
@RF00205 DS    0H                                                  0215
*                 RESPECIFY                                        0215
*                  (RWORK2) RSTD;   /*                               */
*                 RWORK1=AMBIWA;    /* BECAUSE OF EXPOSURE           */
         L     RWORK1,AMBIWA(,RAMB)                                0216
*                 RWORK2=ICWADD;    /* TO LOSS IN PREFORMAT          */
         L     RWORK2,ICWADD(,RWORK1)                              0217
*                 RWORK1=RWORK2;    /* PROCESS                       */
         LR    RWORK1,RWORK2                                       0218
*               END;                /*                               */
*             END;                  /*                               */
*         END;                      /*                               */
@RF00194 DS    0H                                                  0222
*     END;                          /*                               */
@RF00192 DS    0H                                                  0223
*ENDPRFT:                                                          0223
*   END;                            /*                               */
ENDPRFT  DS    0H                                                  0224
*   RESPECIFY                                                      0224
*    (RWORK2) UNRSTD;               /*                               */
*   CALL EXIT;                      /* RETURN TO CALLER              */
         BAL   @14,EXIT                                            0225
*                                                                  0226
*/*                                                                  */
*/*    IDAER SUBROUTINE                                              */
*/*                                                                  */
*/*       FUNCTION -                                                 */
*/*        REMOVES THE DUMMY ENTRY AT THE HIGH KEY END               */
*/*        OF THE INDEX RECORD IN THE CURRENT BUFFER IN              */
*/*        CORE.  CONVERTS THE ENTRY PRECEEDING THE DUMMY            */
*/*        TO A SECTION ENTRY, IF IT IS NOT ALREADY ONE.             */
*/*       INPUT -                                                    */
*/*        RWORK1 = POINTER TO CURRENT WORK AREA.                    */
*/*       OUTPUT -                                                   */
*/*        NONE                                                      */
*/*       RETURN -                                                   */
*/*        ALWAYS TO CALLER.  NO ERRORS ARE DETECTED.                */
*/*                                                                  */
*                                                                  0226
*IDAER:                                                            0226
*   ENTRY;                          /*                               */
@EP00226 DS    0H                                                  0227
*   GEN SETS(PLHRETO,PLHRET1)(IDASVR14);/* SAVE REG 14               */
         IDASVR14
*   RESPECIFY                                                      0228
*    (RWORK2,                                                      0228
*     RWORK3,                                                      0228
*     RWORK4,                                                      0228
*     RWORK0) RSTD;                 /*                               */
*   RWORK2=ICWBUFC->BUFCBAD;        /* POINT TO INDEX BUFFER         */
         L     @10,ICWBUFC(,RWORK1)                                0229
         L     RWORK2,BUFCBAD(,@10)                                0229
*   RWORK3=RWORK2+RWORK2->IXHLEO+   /* POINT TO THE DUMMY            */
*       LENGTH(IBFLPF)+             /* ENTRYS POINTER                */
*       LENGTH(IBFLPL);             /* FIELD                         */
         LR    RWORK3,RWORK2                                       0230
         LH    @10,IXHLEO(,RWORK2)                                 0230
         ALR   RWORK3,@10                                          0230
         AL    RWORK3,@CF00108                                     0230
*   RWORK4=RWORK2->IXHPTLS;         /* PICK UP MASK FROM HDR.        */
         SLR   RWORK4,RWORK4                                       0231
         IC    RWORK4,IXHPTLS(,RWORK2)                             0231
*   IF ICWLN=ICWSS|ICWSPLIT=ON THEN /* SEQ SET OR SPLIT              */
         CLC   ICWLN(2,RWORK1),@CH00053                            0232
         BE    @RT00232                                            0232
         TM    ICWSPLIT(RWORK1),B'00000010'                        0232
         BNO   @RF00232                                            0232
@RT00232 DS    0H                                                  0233
*     DO;                           /* YES                           */
*       RWORK0=RWORK3;              /* SAVE DUMMYS PTR. ADD.         */
         LR    RWORK0,RWORK3                                       0234
*       GEN(EX  RWORK4,PICKPT);     /* EXTRACT DUMMYS PTR            */
         EX  RWORK4,PICKPT
*       RWORK3=RWORK2+RWORK2->IXHFSO;/* POINT TO FREE SPACE          */
         LH    @10,IXHFSO(,RWORK2)                                 0236
         LR    RWORK3,RWORK2                                       0236
         ALR   RWORK3,@10                                          0236
*       IF RWORK2->IXHFSO^<LENGTH(IDAIXH) THEN/*                     */
         C     @10,@CF00145                                        0237
         BL    @RF00237                                            0237
*         GEN(EX  RWORK4,STOREPT);  /* SAVE PTR IN FREE SPACE        */
         EX  RWORK4,STOREPT
*       RWORK3=RWORK0;              /* POINT BACK TO DUMMY PTR       */
@RF00237 LR    RWORK3,RWORK0                                       0239
*       RWORK2->IXHFSO=RWORK2->IXHFSO+/* ADJUST FREE SPACE           */
*           ICWPTL;                 /* DISPLACEMENT IN HEADER        */
         SLR   @10,@10                                             0240
         IC    @10,ICWPTL(,RWORK1)                                 0240
         AH    @10,IXHFSO(,RWORK2)                                 0240
         STH   @10,IXHFSO(,RWORK2)                                 0240
*     END;                          /*                               */
*   RPARM1=ZERO;                    /* PREPARE TO STORE ZEROS        */
@RF00232 SLR   RPARM1,RPARM1                                       0242
*   GEN(EX  RWORK4,STOREPT);        /* CLEAR DUMMYS PTR FIELD        */
         EX  RWORK4,STOREPT
*   RESPECIFY                                                      0244
*    (RWORK0) UNRSTD;               /*                               */
*   RWORK3=RWORK2+RWORK2->IXHSEO;   /* POINT TO FIRST SECTION        */
         LR    RWORK3,RWORK2                                       0245
         LH    @10,IXHSEO(,RWORK2)                                 0245
         ALR   RWORK3,@10                                          0245
*   DO WHILE RWORK3-RPARM1^=RWORK2+ /* LOOP TO WORK                  */
*         RWORK2->IXHLEO;           /* THROUGH INDEX RECORD TO LOCATE
*                                      THE LAST SECTION WRITTEN    0246
*                                      BEFORE THE DUMMY              */
         B     @DE00246                                            0246
@DL00246 DS    0H                                                  0247
*     RWORK3=RWORK3-RPARM1;         /* MOVE TO NEXT SECTION          */
         SLR   RWORK3,RPARM1                                       0247
*     RWORK4=RWORK3-                /* ESTABLISH POINTER TO          */
*         RWORK3->IBFLPL-           /* SECTION CHAINING              */
*         LENGTH(IXSELL);           /* FIELD                         */
         LR    RWORK4,RWORK3                                       0248
         SLR   @10,@10                                             0248
         IC    @10,IBFLPL(,RWORK3)                                 0248
         SLR   RWORK4,@10                                          0248
         BCTR  RWORK4,0                                            0248
         BCTR  RWORK4,0                                            0248
*     RPARM1=RWORK4->IXSELL;        /* DISPLACEMENT OF NEXT          */
         SLR   RPARM1,RPARM1                                       0249
         ICM   RPARM1,3,IXSELL(RWORK4)                             0249
*   END;                            /* SECTION TO RPARM1             */
@DE00246 LR    @10,RWORK3                                          0250
         SLR   @10,RPARM1                                          0250
         LR    @09,RWORK2                                          0250
         LH    @00,IXHLEO(,RWORK2)                                 0250
         ALR   @09,@00                                             0250
         CLR   @10,@09                                             0250
         BNE   @DL00246                                            0250
*   RPARM1=RWORK2+RWORK2->IXHLEO;   /* DETERMINE IF THE LAST         */
         LR    RPARM1,@09                                          0251
*   IF RPARM1+RWORK2->IXHFLPLN      /* SECTION JUST LOCATED          */
*       =RWORK3-RWORK3->IBFLPL-     /* IS THE ENTRY PRECEED-         */
*       LENGTH(IXSELL) THEN         /* ING THE DUMMY                 */
         LR    @10,RPARM1                                          0252
         SLR   @09,@09                                             0252
         IC    @09,IXHFLPLN(,RWORK2)                               0252
         ALR   @10,@09                                             0252
         LA    @09,2                                               0252
         LR    @00,RWORK3                                          0252
         SLR   @15,@15                                             0252
         IC    @15,IBFLPL(,RWORK3)                                 0252
         SLR   @00,@15                                             0252
         SLR   @00,@09                                             0252
         CR    @10,@00                                             0252
         BNE   @RF00252                                            0252
*     DO;                           /* IT IS, THEREFORE IT IS NOT  0253
*                                      NECESSARY TO CREATE A SECTION
*                                      ENTRY                         */
*       RESPECIFY                                                  0254
*        (RWORK5) RSTD;             /* AS THE LAST ENTRY             */
*       RWORK4=RWORK2->IXHPTLS;     /* MASK IN RWORK4                */
         SLR   RWORK4,RWORK4                                       0255
         IC    RWORK4,IXHPTLS(,RWORK2)                             0255
*       RWORK5=RWORK3;              /* PRESERVE SECTION PTR.         */
         LR    RWORK5,RWORK3                                       0256
*       RWORK3=RPARM1+LENGTH(IBFLPF)+/* POINT TO DUMMYS              */
*           LENGTH(IBFLPL);         /* POINTER FIELD                 */
         LA    @10,2                                               0257
         ALR   @10,RPARM1                                          0257
         LR    RWORK3,@10                                          0257
*       RPARM1=ZERO;                /*                               */
         SLR   RPARM1,RPARM1                                       0258
*       GEN(EX RWORK4,STOREPT);     /* CLEAR THE POINTER             */
         EX RWORK4,STOREPT
*       RWORK2->IXHLEO=RWORK5-RWORK2;/* SET OFFSET TO LAST ENTY      */
         LR    @10,RWORK5                                          0260
         SLR   @10,RWORK2                                          0260
         STH   @10,IXHLEO(,RWORK2)                                 0260
*       RWORK3=RWORK5-RWORK5->IBFLPL-/* POINT TO FIELD POINTING      */
*           LENGTH(IXSELL);         /* FORWARD TO NEXT SECT.         */
         LR    RWORK3,RWORK5                                       0261
         SLR   @10,@10                                             0261
         IC    @10,IBFLPL(,RWORK5)                                 0261
         SLR   RWORK3,@10                                          0261
         BCTR  RWORK3,0                                            0261
         BCTR  RWORK3,0                                            0261
*       RWORK4='03'X;               /* SET MASK FOR 2 BYTES          */
         LA    RWORK4,3                                            0262
*       GEN(EX  RWORK4,STOREPT);    /* ZERO THE FIELD                */
         EX  RWORK4,STOREPT
*       RESPECIFY                                                  0264
*        (RWORK2,                                                  0264
*         RWORK3,                                                  0264
*         RWORK4,                                                  0264
*         RWORK5) UNRSTD;           /*                               */
*       CALL EXIT;                  /* RETURN                @X04SVES*/
         BAL   @14,EXIT                                            0265
*     END;                          /*                               */
*   ELSE                            /*                               */
*     DO;                           /*                               */
         B     @RC00252                                            0267
@RF00252 DS    0H                                                  0268
*       RESPECIFY                                                  0268
*        (RWORK2,                                                  0268
*         RWORK3,                                                  0268
*         RWORK4,                                                  0268
*         RWORK5) RSTD;             /*                               */
*       IF RWORK2->IXHSEO=RWORK2->IXHLEO THEN/* IS THERE A           */
         CLC   IXHSEO(2,RWORK2),IXHLEO(RWORK2)                     0269
         BNE   @RF00269                                            0269
*         DO;                       /* SECTION BESIDES DUMMY         */
*           RWORK3=RWORK2+RWORK2->IXHLL/* NO, POINT TO FIRST         */
*               -RWORK2->IXHFLPLN;  /* ENTRY IN RECORD               */
         LR    RWORK3,RWORK2                                       0271
         LH    @10,IXHLL(,RWORK2)                                  0271
         N     @10,@CF00901                                        0271
         ALR   RWORK3,@10                                          0271
         SLR   @10,@10                                             0271
         IC    @10,IXHFLPLN(,RWORK2)                               0271
         SLR   RWORK3,@10                                          0271
*           ICWVSE=OFF;             /* SET SECTION INVALID           */
         NI    ICWVSE(RWORK1),B'11101111'                          0272
*         END;                      /*                               */
*       ELSE                        /*                               */
*         DO;                       /* OTHER SECTIONS EXIST          */
         B     @RC00269                                            0274
@RF00269 DS    0H                                                  0275
*           PLHSAVE1=RWORK3;        /* SAVE PREV. SECT. PTR          */
         ST    RWORK3,PLHSAVE1(,RPLH)                              0275
*           ICWVSE=ON;              /* SHOW SECTION VALID            */
         OI    ICWVSE(RWORK1),B'00010000'                          0276
*           RPARM1=RWORK3->IBFLPL+  /* COMPUTE OFFSET FROM           */
*               LENGTH(IXSELL)+     /* CURRENT ENTRY                 */
*               RWORK2->IXHFLPLN;   /* TO NEXT INDEX ENTRY           */
         LA    RPARM1,2                                            0277
         SLR   @10,@10                                             0277
         IC    @10,IBFLPL(,RWORK3)                                 0277
         ALR   RPARM1,@10                                          0277
         SLR   @10,@10                                             0277
         IC    @10,IXHFLPLN(,RWORK2)                               0277
         ALR   RPARM1,@10                                          0277
*           RWORK3=RWORK3-RPARM1;   /* MOVE PTR TO NEXT ENTRY        */
         SLR   RWORK3,RPARM1                                       0278
*         END;                      /*                               */
*       RPARM1=ZERO;                /*                               */
@RC00269 SLR   RPARM1,RPARM1                                       0280
*       DO WHILE RWORK3-RPARM1^=RWORK2/* LOOP THROUGH THE            */
*             +RWORK2->IXHLEO;      /* REMAINING ENTRIES TO          */
         B     @DE00281                                            0281
@DL00281 DS    0H                                                  0282
*         RWORK3=RWORK3-RPARM1;     /* DETERMINE THE LAST            */
         SLR   RWORK3,RPARM1                                       0282
*         RPARM1=RWORK3->IBFLPL+    /* ENTRY PRIOR TO THE            */
*             RWORK2->IXHFLPLN;     /* DUMMY ENTRY                   */
         SLR   RPARM1,RPARM1                                       0283
         IC    RPARM1,IBFLPL(,RWORK3)                              0283
         SLR   @10,@10                                             0283
         IC    @10,IXHFLPLN(,RWORK2)                               0283
         ALR   RPARM1,@10                                          0283
*       END;                        /*                               */
@DE00281 LR    @10,RWORK3                                          0284
         SLR   @10,RPARM1                                          0284
         LR    @00,RWORK2                                          0284
         LH    @15,IXHLEO(,RWORK2)                                 0284
         ALR   @00,@15                                             0284
         CLR   @10,@00                                             0284
         BNE   @DL00281                                            0284
*       RESPECIFY                                                  0285
*        (RWORK0) RSTD;             /*                               */
*       RWORK0=RWORK3;              /* SAVE ENTRY POINTER            */
         LR    RWORK0,RWORK3                                       0286
*       IF ICWWNF=ON THEN           /* IF WONT FIT CASE, SET         */
         TM    ICWWNF(RWORK1),B'10000000'                          0287
         BNO   @RF00287                                            0287
*         ICWCER=ICWCERP;           /* REAR COMPRESSION              */
         IC    @10,ICWCERP(,RWORK1)                                0288
         STC   @10,ICWCER(,RWORK1)                                 0288
*       IF ICWVSE=ON THEN           /* ARE THE OTHER SECTIONS        */
@RF00287 TM    ICWVSE(RWORK1),B'00010000'                          0289
         BNO   @RF00289                                            0289
*         DO;                       /* YES                           */
*           RWORK2=ADDR(ICWKEY1);   /* POINT FIRST TO CURR KEY       */
         LA    RWORK2,ICWKEY1(,RWORK1)                             0291
*           RWORK4=RWORK2+(TWO*AMDKEYLN);/* POINT TO SECTION KEY     */
         L     @10,AMBDSB(,RAMB)                                   0292
         LH    RWORK4,AMDKEYLN(,@10)                               0292
         ALR   RWORK4,RWORK4                                       0292
         ALR   RWORK4,RWORK2                                       0292
*           IF ICWWNF=OFF THEN      /* NOT WONT FIT CASE             */
         TM    ICWWNF(RWORK1),B'10000000'                          0293
         BNZ   @RF00293                                            0293
*             DO;                   /* CHOOSE SMALLEST OF            */
*               RPARM1=MIN(ICWKEY1L,ICWKEY3L);/* CURRENT & SECT. KEYS*/
         LH    RPARM1,ICWKEY1L(,RWORK1)                            0295
         LH    @10,ICWKEY3L(,RWORK1)                               0295
         CR    RPARM1,@10                                          0295
         BNH   *+6
         LR    RPARM1,@10                                          0295
*             END;                  /*                               */
*           ELSE                    /* TWO KEY LENGTHS               */
*             DO;                   /* MOVE POINTER TO POINT         */
         B     @RC00293                                            0297
@RF00293 DS    0H                                                  0298
*               RWORK2=RWORK2+AMDKEYLN;/* AT PREVIOUS KEY            */
         L     @10,AMBDSB(,RAMB)                                   0298
         LH    @10,AMDKEYLN(,@10)                                  0298
         ALR   RWORK2,@10                                          0298
*               RPARM1=MIN(ICWKEY2L,ICWKEY3L);/* CHOOSE SMALLEST   0299
*                                      LENGTH                        */
         LH    RPARM1,ICWKEY2L(,RWORK1)                            0299
         LH    @10,ICWKEY3L(,RWORK1)                               0299
         CR    RPARM1,@10                                          0299
         BNH   *+6
         LR    RPARM1,@10                                          0299
*             END;                  /*                               */
*           RWORK3=RPARM1;          /* SET COMPARE LENGTH            */
@RC00293 LR    RWORK3,RPARM1                                       0301
*           RWORK5=RWORK3;          /* SAME LENGTH FOR RWORK5        */
         LR    RWORK5,RWORK3                                       0302
*           GEN(CLCL  RWORK2,RWORK4);/* COMPARE KEY TO LAST SECTION
*                                      KEY TO DETERMINE FRONT      0303
*                                      COMPRESSION                   */
         CLCL  RWORK2,RWORK4
*           ICWCEF=RPARM1-RWORK3;   /* SAVE FRONT COMPRESSION        */
         LR    @10,RPARM1                                          0304
         SLR   @10,RWORK3                                          0304
         STC   @10,ICWCEF(,RWORK1)                                 0304
*           RWORK3=RWORK0;          /* POINT BACK TO INSERT PT       */
         LR    RWORK3,RWORK0                                       0305
*         END;                      /*                               */
*       ELSE                        /* NO PREVIOUS SECTIONS          */
*         DO;                       /*                               */
         B     @RC00289                                            0307
@RF00289 DS    0H                                                  0308
*           ICWCEF=ZERO;            /* SET FRONT COMPR = ZERO        */
         MVI   ICWCEF(RWORK1),X'00'                                0308
*         END;                      /*                               */
*       IF ICWCER>ICWCEF THEN       /* DOES REAR COMPRESSION POSITION
*                                      EXCEED FRONT COMPRESSION      */
@RC00289 CLC   ICWCER(1,RWORK1),ICWCEF(RWORK1)                     0310
         BNH   @RF00310                                            0310
*         ICWCEL=ICWCER-ICWCEF;     /* YES, L = DIFFERENCE           */
         SLR   @10,@10                                             0311
         IC    @10,ICWCER(,RWORK1)                                 0311
         SLR   @15,@15                                             0311
         IC    @15,ICWCEF(,RWORK1)                                 0311
         SLR   @10,@15                                             0311
         STC   @10,ICWCEL(,RWORK1)                                 0311
*       ELSE                        /* IF NOT, SET THE LENGTH        */
*         ICWCEL=ZERO;              /* TO ZERO                       */
         B     @RC00310                                            0312
@RF00310 MVI   ICWCEL(RWORK1),X'00'                                0312
*       RWORK3->IBFLPF=ICWCEF;      /* PLACE F INTO RECORD           */
@RC00310 IC    @10,ICWCEF(,RWORK1)                                 0313
         STC   @10,IBFLPF(,RWORK3)                                 0313
*       RWORK3->IBFLPL=ICWCEL;      /* PLACE L INTO RECORD           */
         SLR   @10,@10                                             0314
         IC    @10,ICWCEL(,RWORK1)                                 0314
         STC   @10,IBFLPL(,RWORK3)                                 0314
*       RWORK2=RWORK3-ICWCEL;       /* POINT TO KEY LOCATIONS        */
         LCR   @10,@10                                             0315
         ALR   @10,RWORK3                                          0315
         LR    RWORK2,@10                                          0315
*       IF ICWWNF=OFF THEN          /* NOT WONT FIT CASE             */
         TM    ICWWNF(RWORK1),B'10000000'                          0316
         BNZ   @RF00316                                            0316
*         RWORK4=ZERO;              /* YES, FORCE KEY1 ADDRESS       */
         SLR   RWORK4,RWORK4                                       0317
*       ELSE                        /* NO USE LENGTH OF KEY          */
*         RWORK4=AMDKEYLN;          /* TO FORCE KEY2 ADDRESS         */
         B     @RC00316                                            0318
@RF00316 L     @10,AMBDSB(,RAMB)                                   0318
         LH    RWORK4,AMDKEYLN(,@10)                               0318
*       RWORK4=RWORK4+ADDR(ICWKEY1)+/* COMPUTE FROM ADDRESS OF       */
*           ICWCEF;                 /* KEY TO BE STORED              */
@RC00316 LA    @10,ICWKEY1(,RWORK1)                                0319
         ALR   @10,RWORK4                                          0319
         SLR   @15,@15                                             0319
         IC    @15,ICWCEF(,RWORK1)                                 0319
         ALR   @10,@15                                             0319
         LR    RWORK4,@10                                          0319
*       RWORK5=ICWCEL;              /* SET LENGTH OF MOVE            */
         SLR   RWORK5,RWORK5                                       0320
         IC    RWORK5,ICWCEL(,RWORK1)                              0320
*       RWORK3=RWORK5;              /* SET LENGTH IN RWORK5          */
         LR    RWORK3,RWORK5                                       0321
*       GEN(MVCL RWORK2,RWORK4);    /* MOVE KEY TO BUFFER            */
         MVCL RWORK2,RWORK4
*       RWORK2=ICWBUFC->BUFCBAD;    /* POINT TO BEGINNING OF BUFFER  */
         L     @10,ICWBUFC(,RWORK1)                                0323
         L     RWORK2,BUFCBAD(,@10)                                0323
*       RWORK2->IXHLEO=RWORK0-RWORK2;/* RESET OFFSET TO LAST         */
         LR    @10,RWORK0                                          0324
         SLR   @10,RWORK2                                          0324
         STH   @10,IXHLEO(,RWORK2)                                 0324
*       IF ICWVSE=OFF THEN          /* IF THIS IS ONLY        SECTION*/
         TM    ICWVSE(RWORK1),B'00010000'                          0325
         BNZ   @RF00325                                            0325
*         DO;                       /*                               */
*           RWORK2->IXHSEO=RWORK2->IXHLEO;/* CORRECT SECT. OFFSET    */
         STH   @10,IXHSEO(,RWORK2)                                 0327
*           CALL EXIT;              /* RETURN                @X40SVES*/
         BAL   @14,EXIT                                            0328
*         END;                      /*                               */
*       ELSE                        /*                               */
*         DO;                                                      0330
         B     @RC00325                                            0330
@RF00325 DS    0H                                                  0331
*           RWORK2=PLHSAVE1;        /* BACKUP ONE SECTION            */
         L     RWORK2,PLHSAVE1(,RPLH)                              0331
*           RWORK3=RWORK2-RWORK2->IBFLPL-/* POINT TO CHAIN POINTER   */
*               LENGTH(IXSELL);     /* AT PREVIOUS SECTION           */
         LR    RWORK3,RWORK2                                       0332
         SLR   @10,@10                                             0332
         IC    @10,IBFLPL(,RWORK2)                                 0332
         SLR   RWORK3,@10                                          0332
         BCTR  RWORK3,0                                            0332
         BCTR  RWORK3,0                                            0332
*           RWORK3->IXSELL=RWORK2-RWORK0;/* SET CHAIN TO THIS        */
         LR    @10,RWORK2                                          0333
         SLR   @10,RWORK0                                          0333
         STCM  @10,3,IXSELL(RWORK3)                                0333
*         END;                      /* ENTRY                         */
*       ICWVSE=OFF;                 /* RESET VALID SECTION FLG       */
@RC00325 NI    ICWVSE(RWORK1),B'11101111'                          0335
*       RESPECIFY                                                  0336
*        (RWORK0,                                                  0336
*         RWORK2,                                                  0336
*         RWORK3,                                                  0336
*         RWORK4,                                                  0336
*         RWORK5) UNRSTD;           /*                               */
*     END;                          /*                               */
*   CALL EXIT;                      /* RETURN                @X04SVES*/
@RC00252 BAL   @14,EXIT                                            0338
*                                                                  0339
*   /*****************************************************************/
*   /*                                                               */
*   /* * * * * * * * * * * * * * * * * * * * * * * * * * * *@X04SVES */
*   /* EXIT SUBROUTINE                                       @X04SVES*/
*   /*                                                       @X04SVES*/
*   /* FUNCTION:                                             @X04SVES*/
*   /* RESTORES REGISTER 14 FROM THE PLACEHOLDER             @X04SVES*/
*   /* PUSH DOWN LIST AND RETURNS                            @X04SVES*/
*   /* * * * * * * * * * * * * * * * * * * * * * * * * * * *@X04SVES */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0339
*EXIT:                                                             0339
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);/*                       @X04SVES*/
         B     @PB00002                                            0339
EXIT     DS    0H                                                  0340
*   GEN(IDARST14);                  /* RESTORE R14           @X04SVES*/
         IDARST14
*   END EXIT;                       /* RETURN                @X04SVES*/
@EL00002 DS    0H                                                  0341
@EF00002 DS    0H                                                  0341
@ER00002 BR    @14                                                 0341
@PB00002 DS    0H                                                  0342
*   GEN;                                                           0342
*                                          /*                        */
PICKPT   ICM   RPARM1,@00,@00(RWORK3)      /* OBTAINS POINTER        */
STOREPT  STCM  RPARM1,@00,@00(RWORK3)      /* STORES POINTER         */
*   GEN(IDAPATCH);                  /*                               */
         IDAPATCH
*   END IDA019RN                    /*                               */
*                                                                  0344
*/* THE FOLLOWING INCLUDE STATEMENTS WERE FOUND IN THIS PROGRAM.     */
*/*%INCLUDE SYSLIB  (IDAREGS )                                       */
*/*%INCLUDE SYSLIB  (IDAICWA )                                       */
*/*%INCLUDE SYSLIB  (IDAIRD  )                                       */
*/*%INCLUDE SYSLIB  (IFGRPL  )                                       */
*/*%INCLUDE SYSLIB  (IDAPLH  )                                       */
*/*%INCLUDE SYSLIB  (IDAAMBL )                                       */
*/*%INCLUDE SYSLIB  (IDAAMDSB)                                       */
*/*%INCLUDE SYSLIB  (IDAARDB )                                       */
*/*%INCLUDE SYSLIB  (IFGACB  )                                       */
*/*%INCLUDE SYSLIB  (IDAAMB  )                                       */
*/*%INCLUDE SYSLIB  (IDABUFC )                                       */
*                                                                  0344
*       ;                                                          0344
@EL00001 DS    0H                                                  0344
@EF00001 DS    0H                                                  0344
@ER00001 BR    @14                                                 0344
@DATA    DS    0H
@SC00895 CLC   ARDKEYS(0,RWORK2),PLHKEY(@10)
@SC00897 CLC   ARDKEYS(0,RPARM1),PLHKEY(@10)
@DATD    DSECT
         DS    0F
IDA019RN CSECT
         DS    0F
@CF00053 DC    F'1'
@CH00053 EQU   @CF00053+2
@CF00108 DC    F'2'
@CF00145 DC    F'24'
@CF00901 DC    XL4'0000FFFF'
@DATD    DSECT
         DS    0D
         ORG   *+1-(*-@DATD)/(*-@DATD) INSURE DSECT DATA
@ENDDATD EQU   *
IDA019RN CSECT
         DS    0F
@SIZDATD DC    AL1(0)
         DC    AL3(@ENDDATD-@DATD)
@CV00854 DC    V(IDAEOVIF)
@CV00855 DC    V(IDA019RK)
         DS    0D
HWORD4   DC    H'4'
@00      EQU   00                      EQUATES FOR REGISTERS 0-15
@01      EQU   01
@02      EQU   02
@03      EQU   03
@04      EQU   04
@05      EQU   05
@06      EQU   06
@07      EQU   07
@08      EQU   08
@09      EQU   09
@10      EQU   10
@11      EQU   11
@12      EQU   12
@13      EQU   13
@14      EQU   14
@15      EQU   15
RWORK0   EQU   @00
RRPL     EQU   @01
RPLH     EQU   @02
RAMB     EQU   @03
RBUFC    EQU   @04
RWORK1   EQU   @05
RWORK2   EQU   @06
RWORK3   EQU   @07
RWORK4   EQU   @08
RWORK5   EQU   @09
RPARM1   EQU   @12
R15      EQU   @15
R1       EQU   @01
R10      EQU   @10
R11      EQU   @11
R13      EQU   @13
R14      EQU   @14
IDAICWA  EQU   0
ICWFLG1  EQU   IDAICWA+1
ICWWNF   EQU   ICWFLG1
ICWVSE   EQU   ICWFLG1
ICWKRDS  EQU   ICWFLG1
ICWSPLIT EQU   ICWFLG1
ICWBUFC  EQU   IDAICWA+8
ICWCRBA  EQU   IDAICWA+12
ICWPRBA  EQU   IDAICWA+16
ICWADD   EQU   IDAICWA+24
ICWARDBP EQU   IDAICWA+36
ICWLN    EQU   IDAICWA+40
ICWKEY1L EQU   IDAICWA+42
ICWKEY2L EQU   IDAICWA+44
ICWKEY3L EQU   IDAICWA+46
ICWPTL   EQU   IDAICWA+55
ICWCER   EQU   IDAICWA+56
ICWCEF   EQU   IDAICWA+57
ICWCEL   EQU   IDAICWA+58
ICWCERP  EQU   IDAICWA+59
ICWKEY1  EQU   IDAICWA+60
IDAIXH   EQU   0
IXHLL    EQU   IDAIXH
IXHFLPLN EQU   IDAIXH+2
IXHPTLS  EQU   IDAIXH+3
IXHFSO   EQU   IDAIXH+18
IXHLEO   EQU   IDAIXH+20
IXHSEO   EQU   IDAIXH+22
IDAIBFLP EQU   0
IBFLPF   EQU   IDAIBFLP
IBFLPL   EQU   IDAIBFLP+1
IBFLP3   EQU   IDAIBFLP+2
IBFLP2   EQU   IBFLP3
IDASELL  EQU   0
IXSELL   EQU   IDASELL
IDAIXK   EQU   0
IFGRPL   EQU   0
RPLCOMN  EQU   IFGRPL
RPLIDWD  EQU   RPLCOMN
RPLLEN   EQU   RPLIDWD+3
RPLECB   EQU   RPLCOMN+8
RPLFDBWD EQU   RPLCOMN+12
RPLFDBK  EQU   RPLFDBWD+1
RPLRTNCD EQU   RPLFDBK
RPLERREG EQU   RPLRTNCD
RPLCNDCD EQU   RPLFDBK+1
RPLCMPON EQU   RPLCNDCD
RPLFDB2  EQU   RPLCMPON
RPLERRCD EQU   RPLCNDCD+1
RPLFDB3  EQU   RPLERRCD
RPLKEYLE EQU   RPLCOMN+16
RPLDACB  EQU   RPLCOMN+24
RPLARG   EQU   RPLCOMN+36
RPLOPTCD EQU   RPLCOMN+40
RPLOPT1  EQU   RPLOPTCD
RPLECBSW EQU   RPLOPT1
RPLOPT2  EQU   RPLOPTCD+1
RPLADR   EQU   RPLOPT2
RPLOPT3  EQU   RPLOPTCD+2
RPLNXTRP EQU   RPLCOMN+44
RPLOPTC2 EQU   RPLCOMN+56
RPLOPT5  EQU   RPLOPTC2
RPLWRTYP EQU   RPLOPT5
RPLOPT6  EQU   RPLOPTC2+1
RPLUNTYP EQU   RPLOPT6
RPLOPT7  EQU   RPLOPTC2+2
RPLCNOPT EQU   RPLOPT7
RPLOPT8  EQU   RPLOPTC2+3
RPLRBAR  EQU   RPLCOMN+60
RPLAIXID EQU   RPLRBAR+2
RPLEXTDS EQU   RPLCOMN+68
RPLEXTD1 EQU   RPLEXTDS
IDAPLHDR EQU   0
IDAPLH   EQU   0
PLHFLG1  EQU   IDAPLH+2
PLHFLG2  EQU   IDAPLH+3
PLHKEYMD EQU   PLHFLG2
PLHEFLGS EQU   IDAPLH+4
PLHFLG3  EQU   IDAPLH+6
PLHAFLGS EQU   IDAPLH+7
PLHCRBA  EQU   IDAPLH+28
PLHJORBA EQU   PLHCRBA
PLHJCODE EQU   IDAPLH+40
PLHEOVR  EQU   IDAPLH+42
PLHDIOB  EQU   IDAPLH+76
PLHSAVE1 EQU   IDAPLH+84
PLHRETO  EQU   IDAPLH+116
PLHRET1  EQU   IDAPLH+120
PLHEOVPT EQU   IDAPLH+180
PLHIXSPL EQU   IDAPLH+200
PLHSSRBA EQU   PLHIXSPL
PLHWAX   EQU   IDAPLH+232
PLHKEYPT EQU   IDAPLH+248
PLHEND   EQU   IDAPLH+280
PLHKEY   EQU   0
IDAAMBL  EQU   0
AMBLEOV  EQU   IDAAMBL+12
AMBLEFLG EQU   AMBLEOV
AMBLDDNM EQU   IDAAMBL+16
AMBLIDF  EQU   AMBLDDNM
AMBLQ    EQU   AMBLIDF+7
AMBLVC   EQU   IDAAMBL+28
AMBLTYPE EQU   IDAAMBL+30
AMBLSHAR EQU   IDAAMBL+33
AMBLFLG1 EQU   IDAAMBL+35
AMBLFLG2 EQU   IDAAMBL+36
AMBLDTA  EQU   IDAAMBL+52
IDAAMDSB EQU   0
AMDATTR  EQU   IDAAMDSB+1
AMDSDT   EQU   AMDATTR
AMDREPL  EQU   AMDATTR
AMDNEST  EQU   IDAAMDSB+4
AMDKEYLN EQU   IDAAMDSB+8
AMDCIPCA EQU   IDAAMDSB+12
AMDCINV  EQU   IDAAMDSB+20
AMDHLRBA EQU   IDAAMDSB+28
AMDSSRBA EQU   IDAAMDSB+32
AMDPARDB EQU   IDAAMDSB+36
AMDATTR3 EQU   IDAAMDSB+40
AMDSTAT  EQU   IDAAMDSB+48
AMDNLR   EQU   AMDSTAT+12
AMDASPA  EQU   AMDSTAT+32
IDAARDB  EQU   0
ARDTYPE  EQU   IDAARDB+1
ARDKR    EQU   ARDTYPE
ARDHLI   EQU   ARDTYPE
ARDSS    EQU   ARDTYPE
ARDUSED  EQU   ARDTYPE
ARDNPTR  EQU   IDAARDB+4
ARDHRBA  EQU   IDAARDB+12
ARDERBA  EQU   IDAARDB+16
ARDPRF   EQU   IDAARDB+28
ARDKEYS  EQU   IDAARDB+29
IFGACB   EQU   0
ACBCOMN  EQU   IFGACB
ACBLENG  EQU   ACBCOMN+2
ACBLENG2 EQU   ACBLENG
ACBAMBL  EQU   ACBCOMN+4
ACBJWA   EQU   ACBAMBL
ACBMACRF EQU   ACBCOMN+12
ACBMACR1 EQU   ACBMACRF
ACBADR   EQU   ACBMACR1
ACBCNV   EQU   ACBMACR1
ACBMACR2 EQU   ACBMACRF+1
ACBBUFPL EQU   ACBCOMN+20
ACBMACR3 EQU   ACBBUFPL
ACBRECFM EQU   ACBCOMN+24
ACBCCTYP EQU   ACBCOMN+25
ACBOPT   EQU   ACBCOMN+26
ACBDSORG EQU   ACBOPT
ACBCROPS EQU   ACBDSORG
ACBEXLST EQU   ACBCOMN+36
ACBDDNM  EQU   ACBCOMN+40
ACBAMETH EQU   ACBDDNM+3
ACBOFLGS EQU   ACBCOMN+48
ACBEXFG  EQU   ACBOFLGS
ACBIOSFG EQU   ACBOFLGS
ACBINFLG EQU   ACBCOMN+50
ACBUJFCB EQU   ACBCOMN+52
ACBBLKSZ EQU   ACBCOMN+60
IDAAMB   EQU   0
AMBDSB   EQU   IDAAMB+20
AMBEOVR  EQU   IDAAMB+24
AMBFLG0  EQU   AMBEOVR
AMBFLG1  EQU   IDAAMB+25
AMBCREAT EQU   AMBFLG1
AMBDSORG EQU   IDAAMB+26
AMBIOBAD EQU   IDAAMB+28
AMBINFL  EQU   IDAAMB+42
AMBDEBPT EQU   IDAAMB+44
AMBOFLGS EQU   IDAAMB+48
AMBFLG2  EQU   IDAAMB+49
AMBEOVPT EQU   IDAAMB+56
AMBIWA   EQU   IDAAMB+64
AMBCSWD1 EQU   IDAAMB+84
AMBAFLG  EQU   AMBCSWD1
IDABUFDR EQU   0
BUFDRCIX EQU   IDABUFDR+9
BUFDRFLG EQU   IDABUFDR+11
IDABUFC  EQU   0
BUFCAVL  EQU   IDABUFC
BUFCFLG1 EQU   IDABUFC+1
BUFCIOFL EQU   IDABUFC+2
BUFCFLG2 EQU   IDABUFC+3
BUFCPLH  EQU   IDABUFC+4
BUFCBAD  EQU   IDABUFC+20
BUFCINV  EQU   IDABUFC+28
ICWKEY2  EQU   0
ICWKEY3  EQU   0
PLHPDL   EQU   0
PLHPDLE  EQU   0
PLHRRN   EQU   0
PLHEXTEN EQU   PLHEND
PLHBMWRK EQU   PLHEXTEN+5
BUFCRSC1 EQU   BUFCAVL
         AGO   .@UNREFD                START UNREFERENCED COMPONENTS
PLHBMSV5 EQU   PLHEXTEN+24
PLHBMSV4 EQU   PLHEXTEN+20
PLHBMSV3 EQU   PLHEXTEN+16
PLHBMSV2 EQU   PLHEXTEN+12
PLHBMSV1 EQU   PLHEXTEN+8
PLHRDCNT EQU   PLHEXTEN+6
PLHBMSOV EQU   PLHBMWRK
PLHBEUC  EQU   PLHBMWRK
PLHBMRDF EQU   PLHBMWRK
@NM00011 EQU   PLHEXTEN+4
PLHRESR1 EQU   PLHEXTEN
BUFCEND  EQU   IDABUFC+64
BUFCUCDN EQU   IDABUFC+60
BUFCUCUP EQU   IDABUFC+56
BUFCMDBT EQU   IDABUFC+52
BUFCHAIN EQU   IDABUFC+48
BUFXORBA EQU   IDABUFC+44
BUFXIRBA EQU   IDABUFC+40
BUFCNXT2 EQU   IDABUFC+37
BUFCIDXL EQU   IDABUFC+36
BUFCDSPC EQU   IDABUFC+32
BUFCWLEN EQU   BUFCINV
BUFCNXT1 EQU   IDABUFC+24
BUFCCPA  EQU   IDABUFC+16
BUFCORBA EQU   IDABUFC+12
BUFCDDDD EQU   IDABUFC+8
BUFCAMB  EQU   BUFCPLH
@NM00046 EQU   BUFCFLG2
BUFCEOD  EQU   BUFCFLG2
BUFCBSYW EQU   BUFCFLG2
BUFCBSYR EQU   BUFCFLG2
BUFCNLAS EQU   BUFCFLG2
BUFCXDDR EQU   BUFCFLG2
BUFCFIX  EQU   BUFCIOFL
BUFCPFCP EQU   BUFCIOFL
BUFCXEDB EQU   BUFCIOFL
BUFCWC   EQU   BUFCIOFL
BUFCREAL EQU   BUFCIOFL
BUFCRRD  EQU   BUFCIOFL
BUFCFMT  EQU   BUFCIOFL
BUFCMW   EQU   BUFCIOFL
BUFCEPT  EQU   BUFCFLG1
BUFCEXC  EQU   BUFCFLG1
BUFCVAL  EQU   BUFCFLG1
BUFCER2  EQU   BUFCFLG1
BUFCER1  EQU   BUFCFLG1
BUFCINS  EQU   BUFCFLG1
BUFCSEG  EQU   BUFCFLG1
BUFCUPG  EQU   BUFCFLG1
BUFCUCNT EQU   BUFCAVL
@NM00045 EQU   IDABUFDR+16
BUFDBUFC EQU   IDABUFDR+12
@NM00044 EQU   BUFDRFLG
BUFDRAVL EQU   BUFDRFLG
BUFDRREL EQU   BUFDRFLG
BUFDRTSB EQU   IDABUFDR+10
BUFDRMAX EQU   BUFDRCIX
BUFDRPFN EQU   IDABUFDR+8
BUFDRPFB EQU   IDABUFDR+4
BUFDRLEN EQU   IDABUFDR+2
BUFDRNO  EQU   IDABUFDR+1
BUFDRID  EQU   IDABUFDR
AMBTRACE EQU   IDAAMB+120
AMBVIOT  EQU   IDAAMB+116
AMBSZCP  EQU   IDAAMB+114
AMBSZFW  EQU   IDAAMB+112
AMBSZWR  EQU   IDAAMB+110
AMBSZRD  EQU   IDAAMB+108
AMBEXEX  EQU   IDAAMB+100
AMBWSHD  EQU   IDAAMB+96
AMBCPA   EQU   IDAAMB+92
AMBBM2SH EQU   IDAAMB+88
AMBRDCNT EQU   AMBCSWD1+2
@NM00043 EQU   AMBCSWD1+1
@NM00042 EQU   AMBAFLG
AMBCFX   EQU   AMBAFLG
AMBSIS   EQU   AMBAFLG
AMBDFR   EQU   AMBAFLG
AMBICI   EQU   AMBAFLG
AMBGSR   EQU   AMBAFLG
AMBLSR   EQU   AMBAFLG
@NM00041 EQU   AMBAFLG
AMBUPLH  EQU   IDAAMB+80
AMBPAMBL EQU   IDAAMB+76
AMBPIXP  EQU   IDAAMB+72
@NM00040 EQU   IDAAMB+68
AMBWKA   EQU   IDAAMB+60
AMBAMBXN EQU   AMBEOVPT
AMBEDB   EQU   IDAAMB+52
AMBRPT   EQU   IDAAMB+50
AMBPUG   EQU   AMBFLG2
AMBBUSY  EQU   AMBOFLGS
AMBEXFG  EQU   AMBOFLGS
@NM00039 EQU   AMBOFLGS
AMBOPEN  EQU   AMBOFLGS
@NM00038 EQU   AMBOFLGS
AMBDEBAD EQU   AMBDEBPT+1
AMBIFLGS EQU   AMBDEBPT
AMBAMETH EQU   IDAAMB+43
AMBUPX   EQU   AMBINFL
AMBUCRA  EQU   AMBINFL
AMBSCRA  EQU   AMBINFL
AMBCAT   EQU   AMBINFL
@NM00037 EQU   AMBINFL
@NM00036 EQU   AMBINFL
AMBTIOT  EQU   IDAAMB+40
@NM00035 EQU   IDAAMB+38
AMBDDSN  EQU   IDAAMB+35
AMBCDSN  EQU   IDAAMB+32
AMBIOMB  EQU   AMBIOBAD
@NM00034 EQU   AMBDSORG+1
AMBDORGA EQU   AMBDSORG+1
@NM00033 EQU   AMBDSORG
AMBINBUF EQU   AMBFLG1
AMBJRN   EQU   AMBFLG1
AMBUBF   EQU   AMBFLG1
AMBSPEED EQU   AMBFLG1
AMBPCAT  EQU   AMBFLG1
AMBMCAT  EQU   AMBFLG1
AMBTYPE  EQU   AMBFLG1
@NM00032 EQU   AMBFLG0
AMBPSDS  EQU   AMBFLG0
AMBCACB  EQU   IDAAMB+16
AMBPH    EQU   IDAAMB+12
AMBBUFC  EQU   IDAAMB+8
AMBLINK  EQU   IDAAMB+4
AMBLEN   EQU   IDAAMB+2
AMBRSC   EQU   IDAAMB+1
AMBID    EQU   IDAAMB
ACBAPID  EQU   ACBCOMN+72
ACBCBMWA EQU   ACBCOMN+68
ACBUAPTR EQU   ACBCOMN+64
ACBLRECL EQU   ACBCOMN+62
ACBMSGLN EQU   ACBBLKSZ
ACBBUFSP EQU   ACBCOMN+56
@NM00031 EQU   ACBUJFCB+1
ACBOPTN  EQU   ACBUJFCB
ACBVVIC  EQU   ACBINFLG
ACBUCRA  EQU   ACBINFLG
ACBSCRA  EQU   ACBINFLG
ACBCAT   EQU   ACBINFLG
ACBIJRQE EQU   ACBINFLG
ACBJEPS  EQU   ACBINFLG
@NM00030 EQU   ACBINFLG
ACBERFLG EQU   ACBCOMN+49
ACBBUSY  EQU   ACBIOSFG
ACBLOCK  EQU   ACBEXFG
@NM00029 EQU   ACBOFLGS
ACBDSERR EQU   ACBOFLGS
ACBOPEN  EQU   ACBOFLGS
ACBEOV   EQU   ACBOFLGS
@NM00028 EQU   ACBOFLGS
ACBDEB   EQU   ACBDDNM+5
ACBERFL  EQU   ACBDDNM+4
ACBAM    EQU   ACBAMETH
ACBINFL  EQU   ACBDDNM+2
ACBTIOT  EQU   ACBDDNM
ACBUEL   EQU   ACBEXLST
ACBPASSW EQU   ACBCOMN+32
ACBMSGAR EQU   ACBCOMN+28
@NM00027 EQU   ACBDSORG+1
ACBDORGA EQU   ACBDSORG+1
@NM00026 EQU   ACBDSORG
ACBCRNRE EQU   ACBCROPS
ACBCRNCK EQU   ACBCROPS
ACBASA   EQU   ACBCCTYP
@NM00025 EQU   ACBCCTYP
ACBRECAF EQU   ACBRECFM
ACBJBUF  EQU   ACBBUFPL+2
ACBMACR4 EQU   ACBBUFPL+1
@NM00024 EQU   ACBMACR3
ACBNCFX  EQU   ACBMACR3
ACBSIS   EQU   ACBMACR3
ACBDFR   EQU   ACBMACR3
ACBICI   EQU   ACBMACR3
ACBGSR   EQU   ACBMACR3
ACBLSR   EQU   ACBMACR3
@NM00023 EQU   ACBMACR3
ACBBUFNI EQU   ACBCOMN+18
ACBBUFND EQU   ACBCOMN+16
ACBSTRNO EQU   ACBCOMN+15
ACBBSTNO EQU   ACBCOMN+14
ACBAIX   EQU   ACBMACR2
ACBDSN   EQU   ACBMACR2
ACBRST   EQU   ACBMACR2
ACBLOGON EQU   ACBMACR2
ACBSKP   EQU   ACBMACR2
@NM00022 EQU   ACBMACR2
ACBUBF   EQU   ACBMACR1
ACBOUT   EQU   ACBMACR1
ACBIN    EQU   ACBMACR1
ACBDIR   EQU   ACBMACR1
ACBSEQ   EQU   ACBMACR1
ACBBLK   EQU   ACBCNV
ACBADD   EQU   ACBADR
ACBKEY   EQU   ACBMACR1
ACBINRTN EQU   ACBCOMN+8
ACBIBCT  EQU   ACBJWA
ACBLEN2  EQU   ACBLENG2
ACBSTYP  EQU   ACBCOMN+1
ACBID    EQU   ACBCOMN
@NM00021 EQU   ARDPRF
ARDPRFMT EQU   ARDPRF
ARDPRSS  EQU   ARDPRF
ARDRELNO EQU   IDAARDB+26
ARDVOLSR EQU   IDAARDB+20
ARDHKRBA EQU   IDAARDB+8
ARDLEN   EQU   IDAARDB+2
ARDEOD   EQU   ARDTYPE
ARDUOVFL EQU   ARDTYPE
ARDID    EQU   IDAARDB
AMDEXCP  EQU   AMDSTAT+44
AMDNCAS  EQU   AMDSTAT+40
AMDNCIS  EQU   AMDSTAT+36
AMDRETR  EQU   AMDSTAT+28
AMDUPR   EQU   AMDSTAT+24
AMDIREC  EQU   AMDSTAT+20
AMDDELR  EQU   AMDSTAT+16
AMDNEXT  EQU   AMDSTAT+10
AMDNIL   EQU   AMDSTAT+8
AMDSTSP  EQU   AMDSTAT
@NM00020 EQU   IDAAMDSB+41
@NM00019 EQU   AMDATTR3
AMDLM    EQU   AMDATTR3
AMDWAIT  EQU   AMDATTR3
AMDBIND  EQU   AMDATTR3
AMDFAULT EQU   AMDATTR3
AMDUNQ   EQU   AMDATTR3
AMDMAXRR EQU   AMDSSRBA
AMDNSLOT EQU   AMDHLRBA
AMDLRECL EQU   IDAAMDSB+24
AMDFSCI  EQU   IDAAMDSB+16
AMDFSCA  EQU   IDAAMDSB+14
AMDPCTCI EQU   IDAAMDSB+11
AMDPCTCA EQU   IDAAMDSB+10
AMDRKP   EQU   IDAAMDSB+6
AMDAXRKP EQU   AMDNEST
AMDLEN   EQU   IDAAMDSB+2
AMDSPAN  EQU   AMDATTR
AMDRRDS  EQU   AMDATTR
AMDRANGE EQU   AMDATTR
AMDORDER EQU   AMDATTR
AMDWCK   EQU   AMDATTR
AMDDST   EQU   AMDATTR
AMDSBID  EQU   IDAAMDSB
AMBLCMB  EQU   IDAAMBL+64
AMBLBIB  EQU   IDAAMBL+60
AMBLIX   EQU   IDAAMBL+56
AMBLMIDS EQU   IDAAMBL+42
AMBLNIDS EQU   IDAAMBL+41
@NM00018 EQU   IDAAMBL+40
AMBLNUM  EQU   IDAAMBL+38
AMBLNST  EQU   IDAAMBL+37
@NM00017 EQU   AMBLFLG2
AMBLSTAG EQU   AMBLFLG2
@NM00016 EQU   AMBLFLG2
AMBLDUMY EQU   AMBLFLG1
AMBLCAT  EQU   AMBLFLG1
AMBLUCRA EQU   AMBLFLG1
AMBLSCRA EQU   AMBLFLG1
AMBLVVIC EQU   AMBLFLG1
AMBLUPD  EQU   AMBLFLG1
AMBLCINV EQU   AMBLFLG1
AMBLFULL EQU   AMBLFLG1
AMBLLEN  EQU   IDAAMBL+34
@NM00015 EQU   AMBLSHAR
AMBLWRIT EQU   AMBLSHAR
AMBLCATO EQU   AMBLSHAR
AMBLPRIM EQU   AMBLSHAR
AMBLID   EQU   IDAAMBL+32
@NM00014 EQU   IDAAMBL+31
@NM00013 EQU   AMBLTYPE
AMBLFIX  EQU   AMBLTYPE
AMBLBASE EQU   AMBLTYPE
AMBLAIX  EQU   AMBLTYPE
AMBLUPGR EQU   AMBLTYPE
AMBLPATH EQU   AMBLTYPE
AMBLENO  EQU   AMBLVC+1
AMBLVRT  EQU   AMBLVC
AMBLXPT  EQU   IDAAMBL+24
AMBLDFR  EQU   AMBLQ
AMBLESDS EQU   AMBLQ
AMBLKSDS EQU   AMBLQ
AMBLUBF  EQU   AMBLQ
AMBLFSTP EQU   AMBLQ
AMBLLSR  EQU   AMBLQ
AMBLGSR  EQU   AMBLQ
AMBLDDC  EQU   AMBLQ
AMBLDCI  EQU   AMBLIDF+4
AMBLCACB EQU   AMBLIDF
@NM00012 EQU   AMBLEOV+2
AMBLCOMP EQU   AMBLEOV+1
AMBLESET EQU   AMBLEFLG
AMBLWAIT EQU   AMBLEFLG
AMBLACB  EQU   IDAAMBL+8
AMBLSCHN EQU   IDAAMBL+4
AMBLPCHN EQU   IDAAMBL
PLHERRET EQU   IDAPLH+276
PLHASCB  EQU   IDAPLH+272
PLHECB   EQU   IDAPLH+268
@NM00010 EQU   IDAPLH+265
PLHDRMSK EQU   IDAPLH+264
PLHR13   EQU   IDAPLH+260
PLHPARM1 EQU   IDAPLH+256
PLHDRRSC EQU   IDAPLH+252
PLHSLRBA EQU   IDAPLH+244
PLHSRCSG EQU   IDAPLH+242
PLHNOSEG EQU   IDAPLH+240
PLHLLOR  EQU   IDAPLH+236
PLHXPLH  EQU   PLHWAX
@NM00009 EQU   PLHIXSPL+8
PLHIXBFC EQU   PLHIXSPL+4
PLHHIREC EQU   PLHSSRBA
PLHISPLP EQU   IDAPLH+196
PLHRBUFC EQU   IDAPLH+192
PLHIBUFC EQU   IDAPLH+188
PLHNRBA  EQU   IDAPLH+184
PLHDDDD  EQU   PLHEOVPT
PLHAR14  EQU   IDAPLH+176
@NM00008 EQU   IDAPLH+172
@NM00007 EQU   IDAPLH+168
PLHASAVE EQU   IDAPLH+164
PLHRETOS EQU   IDAPLH+118
PLHCHAIN EQU   IDAPLH+112
PLHAMB   EQU   IDAPLH+108
PLHSAVE6 EQU   IDAPLH+104
PLHSAVE5 EQU   IDAPLH+100
PLHSAVE4 EQU   IDAPLH+96
PLHSAVE3 EQU   IDAPLH+92
PLHSAVE2 EQU   IDAPLH+88
PLHARET  EQU   IDAPLH+80
PLHIIOB  EQU   PLHDIOB
PLHSRSID EQU   IDAPLH+74
PLHRDFC  EQU   IDAPLH+72
PLHRDFP  EQU   IDAPLH+68
PLHFSP   EQU   IDAPLH+64
PLHRECP  EQU   IDAPLH+60
PLHNBUFC EQU   IDAPLH+56
PLHDBUFC EQU   IDAPLH+52
PLHLRECL EQU   IDAPLH+48
PLHARDB  EQU   IDAPLH+44
@NM00006 EQU   IDAPLH+43
PLHRCODE EQU   IDAPLH+41
PLHUCODE EQU   PLHJCODE
PLHJNRBA EQU   IDAPLH+36
PLHJRNLL EQU   IDAPLH+32
PLHUPECB EQU   PLHJORBA
PLHDSIDA EQU   IDAPLH+24
PLHCRPL  EQU   IDAPLH+20
PLHMRPL  EQU   IDAPLH+16
PLHBFRNO EQU   IDAPLH+15
PLHFRCNT EQU   IDAPLH+14
PLHRMIN  EQU   IDAPLH+13
PLHDSTYP EQU   IDAPLH+12
PLHACB   EQU   IDAPLH+8
PLHRAE   EQU   PLHAFLGS
PLHRABWD EQU   PLHAFLGS
PLHIOSID EQU   PLHAFLGS
PLHDBDC  EQU   PLHAFLGS
PLHVAMB  EQU   PLHAFLGS
PLHIOSRQ EQU   PLHAFLGS
PLHDRLM  EQU   PLHAFLGS
PLHEOVDF EQU   PLHFLG3
PLHRVRS  EQU   PLHFLG3
PLHBWD   EQU   PLHFLG3
PLHSLVLD EQU   PLHFLG3
PLHRAHD  EQU   PLHFLG3
PLHSRBSG EQU   PLHFLG3
@NM00005 EQU   PLHEFLGS+1
PLHRSTRT EQU   PLHEFLGS+1
PLHDSCAN EQU   PLHEFLGS
PLHINVAL EQU   PLHEFLGS
PLHEODX  EQU   PLHEFLGS
PLHNOADV EQU   PLHEFLGS
PLHSRINV EQU   PLHEFLGS
PLHSKPER EQU   PLHEFLGS
PLH1ST   EQU   PLHEFLGS
PLHNOSPC EQU   PLHEFLGS
PLHIWAIT EQU   PLHFLG2
PLHSVADV EQU   PLHFLG2
PLHCIINS EQU   PLHFLG2
PLHKRE   EQU   PLHFLG2
PLHADDTE EQU   PLHFLG2
PLHSQINS EQU   PLHFLG2
PLHUPD   EQU   PLHFLG2
@NM00004 EQU   PLHFLG1
PLHDRPND EQU   PLHFLG1
PLHASYRQ EQU   PLHFLG1
PLHRDEXC EQU   PLHFLG1
PLHSSR   EQU   PLHFLG1
PLHASKBF EQU   PLHFLG1
PLHENDRQ EQU   PLHFLG1
PLHEOVW  EQU   PLHFLG1
PLHATV   EQU   IDAPLH+1
PLHAVL   EQU   IDAPLH
PLHIOSDQ EQU   IDAPLHDR+12
PLHDRCUR EQU   IDAPLHDR+10
PLHDRMAX EQU   IDAPLHDR+8
PLHDRREQ EQU   IDAPLHDR+4
PLHELTH  EQU   IDAPLHDR+2
PLHCNT   EQU   IDAPLHDR+1
PLHID    EQU   IDAPLHDR
RPLERMSA EQU   RPLCOMN+72
RPLEMLEN EQU   RPLCOMN+70
RPLACTIV EQU   RPLCOMN+69
RPLBRANC EQU   RPLEXTD1
RPLNIB   EQU   RPLEXTD1
@NM00003 EQU   RPLEXTD1
RPLEXIT  EQU   RPLEXTD1
RPLNEXIT EQU   RPLEXTD1
RPLEXSCH EQU   RPLEXTD1
RPLDDDD  EQU   RPLRBAR+4
@NM00002 EQU   RPLRBAR+3
@NM00001 EQU   RPLAIXID
RPLAXPKP EQU   RPLAIXID
RPLAIXPC EQU   RPLRBAR
RPLRSV88 EQU   RPLOPT8
RPLUNCON EQU   RPLOPT8
RPLACTV  EQU   RPLOPT8
RPLSESS  EQU   RPLOPT8
RPLPEND  EQU   RPLOPT8
RPLODPRM EQU   RPLOPT8
RPLODACP EQU   RPLOPT8
RPLODACQ EQU   RPLOPT8
RPLRSV78 EQU   RPLOPT7
RPLRSV77 EQU   RPLOPT7
RPLRLSOP EQU   RPLOPT7
RPLTPOST EQU   RPLOPT7
RPLQOPT  EQU   RPLOPT7
RPLCNIMM EQU   RPLCNOPT
RPLCNANY EQU   RPLCNOPT
RPLCNALL EQU   RPLCNOPT
RPLRSV68 EQU   RPLOPT6
RPLRSV67 EQU   RPLOPT6
RPLLOCK  EQU   RPLOPT6
RPLNCOND EQU   RPLOPT6
RPLCOND  EQU   RPLOPT6
RPLEOT   EQU   RPLUNTYP
RPLEOM   EQU   RPLUNTYP
RPLEOB   EQU   RPLUNTYP
RPLWROPT EQU   RPLOPT5
RPLNODE  EQU   RPLOPT5
RPLERACE EQU   RPLWRTYP
RPLEAU   EQU   RPLWRTYP
RPLNERAS EQU   RPLWRTYP
RPLPSOPT EQU   RPLOPT5
RPLSSNIN EQU   RPLOPT5
RPLDLGIN EQU   RPLOPT5
RPLBUFL  EQU   RPLCOMN+52
RPLRLEN  EQU   RPLCOMN+48
RPLCHAIN EQU   RPLNXTRP
RPLOPT4  EQU   RPLOPTCD+3
RPLALIGN EQU   RPLOPT3
RPLFMT   EQU   RPLOPT3
RPLFLD   EQU   RPLOPT3
RPLVFY   EQU   RPLOPT3
RPLBLK   EQU   RPLOPT3
RPLSFORM EQU   RPLOPT3
RPLEODS  EQU   RPLOPT3
RPLNSP   EQU   RPLOPT2
RPLUPD   EQU   RPLOPT2
RPLWAITX EQU   RPLOPT2
RPLLRD   EQU   RPLOPT2
RPLBWD   EQU   RPLOPT2
RPLCNV   EQU   RPLOPT2
RPLADD   EQU   RPLADR
RPLKEY   EQU   RPLOPT2
RPLECBIN EQU   RPLECBSW
RPLGEN   EQU   RPLOPT1
RPLKGE   EQU   RPLOPT1
RPLASY   EQU   RPLOPT1
RPLSKP   EQU   RPLOPT1
RPLSEQ   EQU   RPLOPT1
RPLDIR   EQU   RPLOPT1
RPLLOC   EQU   RPLOPT1
RPLDAF   EQU   RPLARG+2
RPLSAF   EQU   RPLARG
RPLAREA  EQU   RPLCOMN+32
RPLTCBPT EQU   RPLCOMN+28
RPLCCHAR EQU   RPLCOMN+20
RPLSTRID EQU   RPLCOMN+18
RPLKEYL  EQU   RPLKEYLE
RPLRDSOH EQU   RPLFDB3
RPLRLG   EQU   RPLFDB3
RPLLGFRC EQU   RPLFDB3
RPLREOT  EQU   RPLFDB3
RPLREOM  EQU   RPLFDB3
RPLREOB  EQU   RPLFDB3
RPLSV32  EQU   RPLFDB3
RPLUINPT EQU   RPLFDB3
RPLSTSAV EQU   RPLFDB2
RPLCUERR EQU   RPLFDB2
RPLDLGFL EQU   RPLFDB2
RPLIOERR EQU   RPLFDB2
RPLDVUNS EQU   RPLFDB2
RPLATND  EQU   RPLFDB2
RPLRVID  EQU   RPLFDB2
RPLERLK  EQU   RPLFDB2
RPLSTAT  EQU   RPLFDBWD
RPLPOST  EQU   RPLECB
RPLWAIT  EQU   RPLECB
RPLPLHPT EQU   RPLCOMN+4
RPLLEN2  EQU   RPLLEN
RPLREQ   EQU   RPLIDWD+2
RPLSTYP  EQU   RPLIDWD+1
RPLID    EQU   RPLIDWD
IXKEY    EQU   IDAIXK
IBFLP1   EQU   IBFLP2
IXHFLGS  EQU   IDAIXH+17
IXHLV    EQU   IDAIXH+16
IXHXX    EQU   IDAIXH+12
IXHHP    EQU   IDAIXH+8
IXHBRBA  EQU   IDAIXH+4
ICWREQ   EQU   IDAICWA+54
ICWCRSEG EQU   IDAICWA+52
ICWNOSEG EQU   IDAICWA+50
ICWNEST  EQU   IDAICWA+48
ICWTPTR  EQU   IDAICWA+32
ICWTBASE EQU   IDAICWA+28
ICWSCNT  EQU   IDAICWA+22
ICWPSEO  EQU   IDAICWA+20
ICWCHN   EQU   IDAICWA+4
ICWLEN   EQU   IDAICWA+2
ICWENDRQ EQU   ICWFLG1
ICWVNE   EQU   ICWFLG1
ICWRBAOK EQU   ICWFLG1
ICWWAGM  EQU   ICWFLG1
ICWID    EQU   IDAICWA
.@UNREFD ANOP                          END UNREFERENCED COMPONENTS
@RT00112 EQU   PROCEED
@RT00119 EQU   PROCEED
@RC00105 EQU   @RC00103
@RT00125 EQU   PROCEED
@RT00180 EQU   FMTERR
@RT00188 EQU   PREFMT
@ENDDATA EQU   *
         END   IDA019RN,(C'PLS2100',0701,78172)
