         TITLE 'IDA019S6 - CONTROL INTERVAL REBUILD                    *
                        '
IDA019S6 CSECT ,                                                   0001
@MAINENT DS    0H                                                  0001
         USING *,@15                                               0001
         B     @PROLOG                                             0001
         DC    AL1(16)                                             0001
         DC    C'IDA019S6  78.172'                                 0001
         DROP  @15
@PROLOG  BALR  @11,0                                               0001
@PSTART  DS    0H                                                  0001
         USING @PSTART,@11                                         0001
*                                                                  0170
         IDASVR14
*   /*****************************************************************/
*   /*                                                               */
*   /* SYNCHRONIZE WITH ANY OUTSTANDING CONTROL INTERVAL SPLITS BY   */
*   /* OBTAINING CONTROL OF THE DIWA                                 */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0171
*LOCKDIWA:                                                         0171
*   RAMB=AMBLDTA;                   /* POINT TO DATA AMB             */
LOCKDIWA L     @10,RPLDACB(,RRPL)                                  0171
         L     @10,ACBAMBL(,@10)                                   0171
         L     RAMB,AMBLDTA(,@10)                                  0171
*   TS(DIWATV);                     /* SEE IF RESOURCE IS AVAILABLE  */
         L     @10,AMBIWA(,RAMB)                                   0172
         TS    DIWATV(@10)                                         0172
*   BC(8,LOCKED);                   /* BRANCH IF DIWA WAS OBTAINED   */
         BC    8,LOCKED                                            0173
*   RESPECIFY                                                      0174
*     RWORK0 RESTRICTED;            /* GET PARAMETER REGISTER        */
*   RWORK0=DEFR0;                   /* SET DEFER PARAMETER           */
*                                                                  0175
         SLR   RWORK0,RWORK0                                       0175
*   /*****************************************************************/
*   /*                                                               */
*   /* DEFER THE REQUEST UNTIL THE DIWA IS AVAILABLE                 */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0176
*I01:                                                              0176
*   DO;                             /* IDACALL(IDADRQ)               */
I01      DS    0H                                                  0177
*     CALL IDADRQ;                  /* EXIT TO IDADRQ                */
         L     @15,@CV01046                                        0177
         BALR  @14,@15                                             0177
*     GEN(BALR @11,0);              /* LOAD ADDR OF REENTRY          */
         BALR @11,0
*     GEN(USING *,@11);             /* ESTABLISH ADDRESSING          */
         USING *,@11
*     GEN(L     @11,=A(@PSTART));   /* RELOAD BASE                   */
         L     @11,=A(@PSTART)
*     GEN(USING @PSTART,@11);       /* ESTABLISH ADDRESSING          */
         USING @PSTART,@11
*   END I01;                        /* DEFER REQUEST                 */
*   GO TO LOCKDIWA;                 /* RETRY RESOURCE                */
         B     LOCKDIWA                                            0183
*   RESPECIFY                                                      0184
*     RWORK0 UNRESTRICTED;          /* RELEASE PARAMETER REGISTER    */
*LOCKED:                                                           0185
*                                                                  0185
*   /*****************************************************************/
*   /*                                                               */
*   /* IDA019S6 NOW OWNS THE DIWA SO CONTINUE PROCESSING             */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0185
*   DIWPLH=ADDR(IDAPLH);            /* NOTE WHO HAS DIWA RESOURCE    */
LOCKED   L     @10,AMBIWA(,RAMB)                                   0185
         ST    RPLH,DIWPLH(,@10)                                   0185
*   RBUFC=PLHDBUFC;                 /* ADDRESSABILITY TO DATA BUFC   */
         L     RBUFC,PLHDBUFC(,RPLH)                               0186
*   RPLDDDD=BUFCDDDD;               /* PASS RBA OF CI TO USER        */
         L     @05,BUFCDDDD(,RBUFC)                                0187
         ST    @05,RPLDDDD(,RRPL)                                  0187
*                                                                  0188
*   /*****************************************************************/
*   /*                                                               */
*   /* IF SHARED RESOURCES GET THE DATA BUFFER FOR EXCLUSIVE CONTROL */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0188
*   IF PLHDBDC=ON&BUFCEXC=OFF THEN  /* SHARED RESOURCES & ^ EXC CNTL */
         TM    PLHDBDC(RPLH),B'00010000'                           0188
         BNO   @RF00188                                            0188
         TM    BUFCEXC(RBUFC),B'00000010'                          0188
         BNZ   @RF00188                                            0188
*     DO;                           /* YES, TRY TO GET EXCLUSIVE CTL */
*       DIWSAVE2=IDABUFC(1:4);      /* SET UP COMPARE WORD           */
         ICM   @05,15,IDABUFC(RBUFC)                               0190
         ST    @05,DIWSAVE2(,@10)                                  0190
*       ADDR(DIWSAVE2)->BUFCUCNT=ONE;/* SET USE COUNT TO ONE         */
         MVI   BUFCUCNT+32(@10),X'01'                              0191
*       DIWSAVE3=DIWSAVE2;          /* SET UP SWAP WORD              */
         ST    @05,DIWSAVE3(,@10)                                  0192
*       ADDR(DIWSAVE3)->BUFCUCNT=ONE;/* SET USE COUNT TO ONE         */
         AL    @10,@CF00766                                        0193
         MVI   BUFCUCNT(@10),X'01'                                 0193
*       ADDR(DIWSAVE3)->BUFCEXC=ON; /* SET EXCLUSIVE CONTROL FLAG    */
*                                                                  0194
         OI    BUFCEXC(@10),B'00000010'                            0194
*       /*************************************************************/
*       /*                                                           */
*       /* GET THE DATA BUFFER IN EXCLUSIVE CONTROL                  */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0195
*       CS(DIWSAVE2,DIWSAVE3,IDABUFC(1:4));/* SWAP IN EXCLUSIVE CNTL */
         L     @10,AMBIWA(,RAMB)                                   0195
         L     @05,DIWSAVE2(,@10)                                  0195
         L     @10,AMBIWA(,RAMB)                                   0195
         L     @10,DIWSAVE3(,@10)                                  0195
         CS    @05,@10,IDABUFC(RBUFC)                              0195
         BZ    @BC00195                                            0195
         BALR  @10,0                                               0195
         L     @15,AMBIWA(,RAMB)                                   0195
         SPM   @10                                                 0195
         ST    @05,DIWSAVE2(,@15)                                  0195
@BC00195 DS    0H                                                  0196
*       IF BUFCEXC=OFF THEN         /* BUFFER IN EXCLUSIVE CONTROL?  */
         TM    BUFCEXC(RBUFC),B'00000010'                          0196
         BNZ   @RF00196                                            0196
*         DO;                       /* NO, CONTROL INTERVAL IN ERROR */
*           PLHSKPER=ON;            /* CI IN ERROR - SKIP            */
         OI    PLHSKPER(RPLH),B'00100000'                          0198
*           RPLERREG='08'X;         /* SET LOGICAL ERROR             */
         MVI   RPLERREG(RRPL),X'08'                                0199
*           RPLERRCD=RPLINCNV;      /* SET INVALID CONTROL INTERVAL  */
         MVI   RPLERRCD(RRPL),X'9C'                                0200
*         END;                      /* END - CONTROL INTERVAL IN ERR */
*     END;                          /* END - GET EXCLUSIVE CONTROL   */
@RF00196 DS    0H                                                  0203
*                                                                  0203
*   /*****************************************************************/
*   /*                                                               */
*   /* CI SPLIT QUIESCED SINCE DIWA HAS BEEN OBTAINED                */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0203
*   IF RPLERREG=ZERO&CIDFBUSY=ON THEN/* NO ERRORS & SPLIT INCOMPLETE */
@RF00188 CLI   RPLERREG(RRPL),0                                    0203
         BNE   @RF00203                                            0203
         L     @10,AMBDSB(,RAMB)                                   0203
         L     @05,BUFCBAD(,RBUFC)                                 0203
         AL    @05,AMDCINV(,@10)                                   0203
         BCTR  @05,0                                               0203
         BCTR  @05,0                                               0203
         TM    CIDFBUSY-2(@05),B'10000000'                         0203
         BNO   @RF00203                                            0203
*     IF RPLKEY=ON THEN             /* IS REQUEST FOR KEYED ACCESS   */
         TM    RPLKEY(RRPL),B'10000000'                            0204
         BNO   @RF00204                                            0204
*       DO;                         /* YES, FIX DATA BUFFER          */
*                                                                  0205
*         /***********************************************************/
*         /*                                                         */
*         /* CHECK THE DATA CI FOR A VALID FORMAT                    */
*         /*                                                         */
*         /***********************************************************/
*                                                                  0206
*         CALL VALIDCI;             /* CALL VALIDATE CI              */
*                                                                  0206
         BAL   @14,VALIDCI                                         0206
*         /***********************************************************/
*         /*                                                         */
*         /* CORRECT THE DATA CONTROL INTERVAL                       */
*         /*                                                         */
*         /***********************************************************/
*                                                                  0207
*         CALL FIXCI;               /* CORRECT THE DATA CI BUFFER    */
         BAL   @14,FIXCI                                           0207
*         IF RPLERREG=ZERO&         /* IF NO ERRORS AND              */
*             PLHRDEXC=ON&          /* BUFFER IN EXCLUSIVE CONTROL   */
*             AMBLWRIT=ON THEN      /* AND OUTPUT IS ALLOWED         */
         CLI   RPLERREG(RRPL),0                                    0208
         BNE   @RF00208                                            0208
         TM    PLHRDEXC(RPLH),B'00001000'                          0208
         BNO   @RF00208                                            0208
         L     @10,RPLDACB(,RRPL)                                  0208
         L     @10,ACBAMBL(,@10)                                   0208
         TM    AMBLWRIT(@10),B'00100000'                           0208
         BNO   @RF00208                                            0208
*           DO;                     /* WRITE THE DATA CI             */
*             BUFCMW=ON;            /* BUFFER TO BE WRITTEN          */
         OI    BUFCMW(RBUFC),B'10000000'                           0210
*             BUFCORBA=BUFCDDDD;    /* SET THE OUTPUT RBA            */
*                                                                  0211
         L     @10,BUFCDDDD(,RBUFC)                                0211
         ST    @10,BUFCORBA(,RBUFC)                                0211
*             /*******************************************************/
*             /*                                                     */
*             /* WRITE THE BUFFER                                    */
*             /*                                                     */
*             /*******************************************************/
*                                                                  0212
*I02:                                                              0212
*             DO;                   /* IDACALL(IDAWRBFR)             */
I02      DS    0H                                                  0213
*               CALL IDAWRBFR;      /* EXIT TO IDAWRBFR              */
         L     @15,@CV01047                                        0213
         BALR  @14,@15                                             0213
*               GEN(BALR @11,0);    /* LOAD ADDR OF REENTRY          */
         BALR @11,0
*               GEN(USING *,@11);   /* ESTABLISH ADDRESSING          */
         USING *,@11
*               GEN(L     @11,=A(@PSTART));/* RELOAD BASE            */
         L     @11,=A(@PSTART)
*               GEN(USING @PSTART,@11);/* ESTABLISH ADDRESSING       */
         USING @PSTART,@11
*             END I02;              /* WRITE THE BUFFER              */
*           END;                    /* END - WRITE THE DATA CI       */
*       END;                        /* END - CORRECT THE DATA CI     */
*                                                                  0221
*/********************************************************************/
*/*                                                                  */
*/*   PROCESSING FOR ADDRESSED ACCESS                                */
*/*                                                                  */
*/********************************************************************/
*                                                                  0221
*     ELSE                          /* ADDRESSED PROCESSING          */
*       IF RPLUPD=ON|RPLREQ=RPLPUT THEN/* IS REQUEST FOR UPD OR PUT  */
         B     @RC00204                                            0221
@RF00204 TM    RPLUPD(RRPL),B'00000010'                            0221
         BO    @RT00221                                            0221
         CLI   RPLREQ(RRPL),1                                      0221
         BNE   @RF00221                                            0221
@RT00221 DS    0H                                                  0222
*         DO;                       /* YES, ERROR SITUATION          */
*           RPLERREG='08'X;         /* SET LOGICAL ERROR             */
         MVI   RPLERREG(RRPL),X'08'                                0223
*           RPLERRCD=RPLINCNV;      /* SET INVALID CONTROL INTERVAL  */
         MVI   RPLERRCD(RRPL),X'9C'                                0224
*           PLHSKPER=ON;            /* CI IN ERROR - SKIP            */
         OI    PLHSKPER(RPLH),B'00100000'                          0225
*         END;                      /* END - PUT OR UPDATE           */
*       ELSE                        /* NOT OUTPUT SITUATION SO       */
*         DO;                       /* ALLOW CI TO BE READ           */
         B     @RC00221                                            0227
@RF00221 DS    0H                                                  0228
*           BUFCVAL=OFF;            /* INVALIDATE BUFC               */
         NI    BUFCVAL(RBUFC),B'11111011'                          0228
*           RPLERRCD=RPLCIWNG;      /* WARNING, INTERRUPTED CI SPLIT */
         MVI   RPLERRCD(RRPL),X'1C'                                0229
*           CALL VALIDCI;           /* VALIDATE THE CIDF AND RDFS    */
         BAL   @14,VALIDCI                                         0230
*           CIDFBUSY=OFF;           /* SET BUSY INDICATOR OFF        */
         L     @10,AMBDSB(,RAMB)                                   0231
         L     @05,BUFCBAD(,RBUFC)                                 0231
         AL    @05,AMDCINV(,@10)                                   0231
         BCTR  @05,0                                               0231
         BCTR  @05,0                                               0231
         NI    CIDFBUSY-2(@05),B'01111111'                         0231
*         END;                      /* END - ALLOW CI TO BE READ     */
*                                                                  0232
*   /*****************************************************************/
*   /*                                                               */
*   /* REESTABLISH THE EXCLUSIVE CONTROL STATUS OF THE DATA BUFFER   */
*   /* AND RETURN TO THE CALLER FOR BOTH KEYED AND ADDRESSED ACCESS. */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0233
*   IF PLHRDEXC=OFF THEN            /* IF READ EXCLUSIVE OFF         */
@RC00221 DS    0H                                                  0233
@RC00204 DS    0H                                                  0233
@RF00203 TM    PLHRDEXC(RPLH),B'00001000'                          0233
         BNZ   @RF00233                                            0233
*     BUFCEXC=OFF;                  /* RELEASE EXCLUSIVE CONTROL     */
         NI    BUFCEXC(RBUFC),B'11111101'                          0234
*   DIWATV=ZERO;                    /* RELEASE THE DIWA              */
@RF00233 L     @10,AMBIWA(,RAMB)                                   0235
         MVI   DIWATV(@10),X'00'                                   0235
*   CALL EXIT;                      /* RETURN                        */
         BAL   @14,EXIT                                            0236
*VALIDCI:                                                          0237
*                                                                  0237
*/********************************************************************/
*/*                                                                  */
*/*   FUNCTION - VALIDATE THE DATA CONTROL INTERVAL.                 */
*/*                                                                  */
*/*   INPUT    - PLHDBUFC POINTS TO THE INTERRUPTED CI.              */
*/*              THE DATA BUFFER IS IN EXCLUSIVE CONTROL.            */
*/*                                                                  */
*/*   OUTPUT   - THE RETURN CODE IS IN RPLERREG AND RPLERRCD.        */
*/*              PLHFSP POINTS TO THE DATA CI FREE SPACE.            */
*/*                                                                  */
*/********************************************************************/
*                                                                  0237
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);                               0237
         B     @PB00002                                            0237
VALIDCI  DS    0H                                                  0238
*   GEN(IDASVR14);                  /* SAVE REGISTER 14 IN PLH       */
*                                                                  0238
         IDASVR14
*   /*****************************************************************/
*   /*                                                               */
*   /* VALIDATE THE CIDF                                             */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0239
*   RBUFC=PLHDBUFC;                 /* ADDRESSABILITY TO DATA BUFC   */
         L     RBUFC,PLHDBUFC(,RPLH)                               0239
*   CIDFBUSY=OFF;                   /* TURN OFF THE BUSY BIT         */
         LA    @10,4                                               0240
         L     @05,AMBDSB(,RAMB)                                   0240
         L     @05,AMDCINV(,@05)                                   0240
         L     @15,BUFCBAD(,RBUFC)                                 0240
         ALR   @15,@05                                             0240
         SLR   @15,@10                                             0240
         NI    CIDFBUSY(@15),B'01111111'                           0240
*   IF FSO<ZERO|                    /* IF FREE SPACE OFFSET NEGATIVE */
*       (FSO+FSL)>(AMDCINV-LENGTH(IDACIDF))/* OR FREE SPACE INVALID  */
*     THEN                                                         0241
         LH    @14,FSO(,@15)                                       0241
         LTR   @14,@14                                             0241
         BM    @RT00241                                            0241
         AH    @14,FSL(,@15)                                       0241
         SLR   @05,@10                                             0241
         CR    @14,@05                                             0241
         BNH   @RF00241                                            0241
@RT00241 DS    0H                                                  0242
*     CALL ERREXIT;                 /* CIDF IN ERROR, RETURN         */
*                                                                  0242
         BAL   @14,ERREXIT                                         0242
*   /*****************************************************************/
*   /*                                                               */
*   /* VALIDATE THE DATA BY MAKING SURE THAT THE RDF'S ARE CONSISTENT*/
*   /* WITH THE FREE SPACE OFFSET AND LENGTH IN THE CIDF             */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0243
*   S6NOKEY=ON;                     /* NO PREVIOUS KEY               */
@RF00241 L     @10,AMBIWA(,RAMB)                                   0243
         OI    S6NOKEY(@10),B'10000000'                            0243
*   PLHRECP=BUFCBAD;                /* BEGINNING OF CI               */
         L     @10,BUFCBAD(,RBUFC)                                 0244
         ST    @10,PLHRECP(,RPLH)                                  0244
*   PLHFSP=BUFCBAD+CIDFOSET;        /* SET FREE SPACE POINTER        */
         L     @05,AMBDSB(,RAMB)                                   0245
         LR    @15,@10                                             0245
         AL    @15,AMDCINV(,@05)                                   0245
         SL    @15,@CF00089                                        0245
         AH    @10,CIDFOSET(,@15)                                  0245
         ST    @10,PLHFSP(,RPLH)                                   0245
*   PLHRDFP=ADDR(IDACIDF);          /* POSITION TO THE CIDF          */
         ST    @15,PLHRDFP(,RPLH)                                  0246
*   PLHRDFC=ONE;                    /* INITIALIZE RDF REPL COUNT     */
         MVC   PLHRDFC(2,RPLH),@CH00051                            0247
*   PLHLRECL=ZERO;                  /* NO PREVIOUS RECORD IN THIS CI */
         SLR   @10,@10                                             0248
         ST    @10,PLHLRECL(,RPLH)                                 0248
*   DO WHILE PLHRECP<PLHFSP;        /* DO WHILE NOT IN FREE SPACE    */
         B     @DE00249                                            0249
@DL00249 DS    0H                                                  0250
*     CALL ADVRDF;                  /* ADVANCE THE PLH TO NEXT RDF   */
         BAL   @14,ADVRDF                                          0250
*     IF RDFNOT1=ON|RDF1ST=ON THEN  /* IS THE RDF FOR SPANNED RECORD */
         L     @10,PLHRDFP(,RPLH)                                  0251
         TM    RDFNOT1(@10),B'00110000'                            0251
         BZ    @RF00251                                            0251
*       CALL ERREXIT;               /* YES, INVALID CI - RETURN      */
         BAL   @14,ERREXIT                                         0252
*     IF S6NOKEY=ON THEN            /* IF NO PREVIOUS KEY (RECORD)   */
@RF00251 L     @10,AMBIWA(,RAMB)                                   0253
         TM    S6NOKEY(@10),B'10000000'                            0253
         BNO   @RF00253                                            0253
*       S6NOKEY=OFF;                /* INDICATE A PREVIOUS KEY       */
         NI    S6NOKEY(@10),B'01111111'                            0254
*     ELSE                          /* IF THERE IS A PREVIOUS KEY    */
*       IF KEY(1:AMDKEYLN)^>RPARM1->KEY(1:AMDKEYLN)/* IS CURRENT KEY */
*         THEN                      /* GREATER THAN THE PREVIOUS KEY */
         B     @RC00253                                            0255
@RF00253 L     @10,AMBDSB(,RAMB)                                   0255
         LH    @05,AMDRKP(,@10)                                    0255
         AL    @05,PLHRECP(,RPLH)                                  0255
         LH    @10,AMDKEYLN(,@10)                                  0255
         BCTR  @10,0                                               0255
         EX    @10,@SC01093                                        0255
         BH    @RF00255                                            0255
*         CALL ERREXIT;             /* NO, THEN INVALID CI - RETURN  */
         BAL   @14,ERREXIT                                         0256
*     RPARM1=ADDR(KEY);             /* SAVE ADDRESS OF CURRENT KEY   */
@RF00255 DS    0H                                                  0257
@RC00253 L     @10,AMBDSB(,RAMB)                                   0257
         LH    @05,AMDRKP(,@10)                                    0257
         L     RPARM1,PLHRECP(,RPLH)                               0257
         ALR   RPARM1,@05                                          0257
*     IF PLHLRECL<AMDRKP+AMDKEYLN THEN/* IS NEXT RECORD POINTER OK   */
         AH    @05,AMDKEYLN(,@10)                                  0258
         C     @05,PLHLRECL(,RPLH)                                 0258
         BNH   @RF00258                                            0258
*       CALL ERREXIT;               /* NO, EXIT - INVALID CI         */
         BAL   @14,ERREXIT                                         0259
*     PLHRECP=PLHRECP+PLHLRECL;     /* ADVANCE CURRENT RECORD POINTER*/
@RF00258 L     @10,PLHRECP(,RPLH)                                  0260
         AL    @10,PLHLRECL(,RPLH)                                 0260
         ST    @10,PLHRECP(,RPLH)                                  0260
*   END;                            /* END - NOT IN FREE SPACE       */
*                                                                  0261
@DE00249 L     @10,PLHRECP(,RPLH)                                  0261
         L     @05,PLHFSP(,RPLH)                                   0261
         CR    @10,@05                                             0261
         BL    @DL00249                                            0261
*   /*****************************************************************/
*   /*                                                               */
*   /* MAKE SURE THAT THE ENDING VALUES ARE CORRECT                  */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0262
*   IF PLHRECP^=PLHFSP|             /* IF FREE SPACE DOES NOT START
*                                      AT THE END OF LAST RECORD OR  */
*       PLHRDFP^=PLHFSP+CIDFLL|     /* IF FREE SPACE DOES NOT END AT
*                                      THE START OF LAST RDF OR      */
*       PLHRDFC^=ONE THEN           /* IF A GROUP RDF HAS NOT BEEN 0262
*                                      DECREMENTED TO ONE            */
         CR    @10,@05                                             0262
         BNE   @RT00262                                            0262
         L     @10,AMBDSB(,RAMB)                                   0262
         L     @15,BUFCBAD(,RBUFC)                                 0262
         AL    @15,AMDCINV(,@10)                                   0262
         BCTR  @15,0                                               0262
         BCTR  @15,0                                               0262
         AH    @05,CIDFLL-2(,@15)                                  0262
         C     @05,PLHRDFP(,RPLH)                                  0262
         BNE   @RT00262                                            0262
         CLC   PLHRDFC(2,RPLH),@CH00051                            0262
         BE    @RF00262                                            0262
@RT00262 DS    0H                                                  0263
*     CALL ERREXIT;                 /* ANY OF THE ABOVE, ERROR EXIT  */
*                                                                  0263
         BAL   @14,ERREXIT                                         0263
*   /*****************************************************************/
*   /*                                                               */
*   /* IN CASE ANY ERRORS OCCUR PRIOR TO FIXCI, SET THE BUSY FLAG ON */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0264
*   ELSE                            /* NO ERROR,                     */
*     CIDFBUSY=ON;                  /* SET CIDFBUSY ON               */
         B     @RC00262                                            0264
@RF00262 L     @10,AMBDSB(,RAMB)                                   0264
         L     @05,BUFCBAD(,RBUFC)                                 0264
         AL    @05,AMDCINV(,@10)                                   0264
         BCTR  @05,0                                               0264
         BCTR  @05,0                                               0264
         OI    CIDFBUSY-2(@05),B'10000000'                         0264
*   CALL EXIT;                      /* EXIT FROM VALIDATE DATA CI    */
@RC00262 BAL   @14,EXIT                                            0265
*   END VALIDCI;                    /* END - VALIDATE DATA CI        */
@EL00002 DS    0H                                                  0266
@EF00002 DS    0H                                                  0266
@ER00002 BR    @14                                                 0266
*FIXCI:                                                            0267
*                                                                  0267
*/********************************************************************/
*/*                                                                  */
*/*   FUNCTION - REMOVE ANY DUPLICATE RECORDS FROM THE DATA          */
*/*              CONTROL INTERVAL.                                   */
*/*                                                                  */
*/*   INPUT    - PLHDBUFC POINTS TO THE INTERRUPTED BUFC.            */
*/*              PLHFSP POINTS TO THE DATA CI FREE SPACE.            */
*/*              DIWA IS LOCKED.                                     */
*/*              THE DATA BUFFER IS IN EXCLUSIVE CONTROL FOR SHARED  */
*/*                RESOURCES.                                        */
*/*                                                                  */
*/*   OUTPUT   - RBUFC POINTS TO THE CURRENT BUFC.                   */
*/*              THE RETURN CODE IS IN RPLERREG AND RPLERRCD.        */
*/*                                                                  */
*/********************************************************************/
*                                                                  0267
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);                               0267
FIXCI    DS    0H                                                  0268
*   GEN(IDASVR14);                  /* SAVE REGISTER 14 IN PLH       */
         IDASVR14
*   RBUFC=PLHDBUFC;                 /* POINT TO THE DATA BUFC        */
         L     RBUFC,PLHDBUFC(,RPLH)                               0269
*   PLHRECP=BUFCBAD;                /* BEGINNING OF CI               */
         L     @10,BUFCBAD(,RBUFC)                                 0270
         ST    @10,PLHRECP(,RPLH)                                  0270
*   PLHRDFP=ADDR(IDACIDF);          /* POSITION TO THE CIDF          */
         L     @05,AMBDSB(,RAMB)                                   0271
         AL    @10,AMDCINV(,@05)                                   0271
         SL    @10,@CF00089                                        0271
         ST    @10,PLHRDFP(,RPLH)                                  0271
*   CIDFBUSY=OFF;                   /* SET BUSY OFF WHILE PROCESSING */
         NI    CIDFBUSY(@10),B'01111111'                           0272
*   PLHRDFC=ONE;                    /* INITIALIZE RDF REPL COUNT     */
         MVC   PLHRDFC(2,RPLH),@CH00051                            0273
*   CALL ADVRDF;                    /* ADVANCE TO THE FIRST RDF      */
*                                                                  0274
         BAL   @14,ADVRDF                                          0274
*   /*****************************************************************/
*   /*                                                               */
*   /* INITIALIZE INPUT REGISTERS TO THE SCIB ROUTINE                */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0275
*   RESPECIFY                                                      0275
*     RWORK3 RESTRICTED;            /* RESTRICT REG FOR SCIB         */
*   RBUFC=PLHIBUFC->BUFCBAD;        /* POINT TO INDEX BUFFER         */
         L     @10,PLHIBUFC(,RPLH)                                 0276
         L     RBUFC,BUFCBAD(,@10)                                 0276
*   RWORK3=ADDR(IMWISWKA);          /* INDEX SEARCH PARAMETER LIST   */
*                                                                  0277
         L     @10,RPLDACB(,RRPL)                                  0277
         L     @10,ACBAMBL(,@10)                                   0277
         L     @10,AMBLIX(,@10)                                    0277
         L     @10,AMBIWA(,@10)                                    0277
         L     RWORK3,ICWCHN(,@10)                                 0277
         LA    RWORK3,IMWISWKA(,RWORK3)                            0277
*   /*****************************************************************/
*   /*                                                               */
*   /* VERIFY THAT THE KEY OF EACH RECORD IN THE CONTROL INTERVAL    */
*   /* BELONGS IN THE CI BY CALLING IDA019RC (SCIB).                 */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0278
*   DO WHILE PLHRECP<PLHFSP;        /* DO WHILE NOT IN FREE SPACE    */
         B     @DE00278                                            0278
@DL00278 DS    0H                                                  0279
*     RPARM1=PLHRECP+AMDRKP;        /* POINT TO THE CURRENT KEY      */
         L     @10,AMBDSB(,RAMB)                                   0279
         LH    RPARM1,AMDRKP(,@10)                                 0279
         AL    RPARM1,PLHRECP(,RPLH)                               0279
*                                                                  0280
*     /***************************************************************/
*     /*                                                             */
*     /* CALL SCIB, SEARCH COMPRESSED INDEX BLOCK                    */
*     /*                                                             */
*     /***************************************************************/
*                                                                  0280
*I03:                                                              0280
*     DO;                           /* IDACALL(IDA019RC)             */
I03      DS    0H                                                  0281
*       CALL IDA019RC;              /* EXIT TO IDA019RC              */
         L     @15,@CV01048                                        0281
         BALR  @14,@15                                             0281
*       GEN(BALR @11,0);            /* LOAD ADDR OF REENTRY          */
         BALR @11,0
*       GEN(USING *,@11);           /* ESTABLISH ADDRESSING          */
         USING *,@11
*       GEN(L     @11,=A(@PSTART)); /* RELOAD BASE                   */
         L     @11,=A(@PSTART)
*       GEN(USING @PSTART,@11);     /* ESTABLISH ADDRESSING          */
         USING @PSTART,@11
*     END I03;                      /* CALL SCIB                     */
*     RESPECIFY                                                    0287
*      (RWORK2,                                                    0287
*       RWORK4,                                                    0287
*       RWORK5,                                                    0287
*       R15) RESTRICTED;                                           0287
*     IF R15^=ZERO&                 /* RECORD NOT IN THIS CI         */
*         R15^=FOUR THEN            /* RECORD NOT IN ANY CA          */
         LTR   R15,R15                                             0288
         BZ    @RF00288                                            0288
         CH    R15,FOUR                                            0288
         BE    @RF00288                                            0288
*       CALL ERREXIT;               /* CALL ERROR                    */
         BAL   @14,ERREXIT                                         0289
*     IF R15=ZERO THEN              /* WAS THE KEY LOCATED?          */
@RF00288 LTR   R15,R15                                             0290
         BNZ   @RF00290                                            0290
*       DO;                         /* YES, CALCULATE RBA OF CI      */
*         RWORK4=ADDR(IBFLP3);      /* GET ADDRESS OF RELATIVE CI #  */
         L     RWORK4,IXSHEP(,RWORK3)                              0292
         LA    RWORK4,IBFLP3(,RWORK4)                              0292
*         RWORK5=IXHPTLS;           /* GET MASK FOR ICM INSTRUCTION  */
         SLR   RWORK5,RWORK5                                       0293
         IC    RWORK5,IXHPTLS(,RBUFC)                              0293
*         RWORK2=ZERO;              /* CLEAR FOR INSERT OF CI #      */
         SLR   RWORK2,RWORK2                                       0294
*         GEN FLOWS(INSERT) REFS(RWORK4,RWORK5) SETS(RWORK2)       0295
*             (EX    RWORK5,INSERT);/* EXECUTE ICM INTO RWORK2       */
         EX    RWORK5,INSERT
*       END;                        /* END - CALCULATE RBA           */
*     RESPECIFY                                                    0297
*      (RWORK4,                                                    0297
*       RWORK5) UNRESTRICTED;                                      0297
*                                                                  0297
@RF00290 DS    0H                                                  0298
*     /***************************************************************/
*     /*                                                             */
*     /* IF THE KEY IS NOT IN THE CURRENT CI, ERASE THE CURRENT      */
*     /* RECORD AND ALL HIGHER KEY RECORDS THAT ARE IN THE CI.       */
*     /*                                                             */
*     /***************************************************************/
*                                                                  0298
*     IF R15=FOUR|                  /* RECORD NOT IN THIS CA         */
*         PLHDBUFC->BUFCDDDD^=RWORK2*AMDCINV+IXHBRBA/* OR EXPECTED 0298
*                                      RBA                           */
*       THEN                        /* NOT EQUAL THE ACTUAL?         */
         CH    R15,FOUR                                            0298
         BE    @RT00298                                            0298
         L     @14,PLHDBUFC(,RPLH)                                 0298
         L     @10,AMBDSB(,RAMB)                                   0298
         LR    @09,RWORK2                                          0298
         M     @08,AMDCINV(,@10)                                   0298
         AL    @09,IXHBRBA(,RBUFC)                                 0298
         CL    @09,BUFCDDDD(,@14)                                  0298
         BE    @RF00298                                            0298
@RT00298 DS    0H                                                  0299
*       DO;                         /* YES, PREPARE TO ERASE RECORDS */
*         RBUFC=PLHDBUFC;           /* POINT TO THE DATA BUFC        */
         L     RBUFC,PLHDBUFC(,RPLH)                               0300
*         IF PLHRECP-BUFCBAD=ZERO THEN/* FIRST RECORD IN THE CI?     */
         L     @14,PLHRECP(,RPLH)                                  0301
         SL    @14,BUFCBAD(,RBUFC)                                 0301
         LTR   @14,@14                                             0301
         BNZ   @RF00301                                            0301
*           CALL ERREXIT;           /* YES, INVALID CONTROL INTERVAL */
         BAL   @14,ERREXIT                                         0302
*         ELSE                      /* NOT FIRST RECORD IN CI SO     */
*           RWORK3=PLHRECP-BUFCBAD; /* FREE SPACE OFFSET             */
*                                                                  0303
         B     @RC00301                                            0303
@RF00301 L     RWORK3,PLHRECP(,RPLH)                               0303
         SL    RWORK3,BUFCBAD(,RBUFC)                              0303
*         /***********************************************************/
*         /*                                                         */
*         /* SET UP THE PLH TO ERASE DUPLICATE DATA FROM THE CI      */
*         /*                                                         */
*         /***********************************************************/
*                                                                  0304
*         PLHFSP=PLHRECP;           /* SET THE FREE SPACE POINTER    */
@RC00301 L     @14,PLHRECP(,RPLH)                                  0304
         ST    @14,PLHFSP(,RPLH)                                   0304
*         IF RDFREPL=ON THEN        /* RDFLL = REPLICATION COUNT ?   */
         L     @14,PLHRDFP(,RPLH)                                  0305
         TM    RDFREPL(@14),B'00001000'                            0305
         BNO   @RF00305                                            0305
*           DO;                     /* YES, ADJUST REPLICATED RDF    */
*             RDFLL=RDFLL-PLHRDFC;  /* DECREMENT BY CURRENT COUNT    */
         SLR   @10,@10                                             0307
         ICM   @10,3,RDFLL(@14)                                    0307
         SH    @10,PLHRDFC(,RPLH)                                  0307
         STCM  @10,3,RDFLL(@14)                                    0307
*             IF RDFLL=ZERO THEN    /* IS THE COUNT NOW ZERO?        */
         LTR   @10,@10                                             0308
         BNZ   @RF00308                                            0308
*               PLHRDFP=PLHRDFP+2*LENGTH(IDARDF);/* YES, REMOVE RDFS */
         AL    @14,@CF00370                                        0309
         ST    @14,PLHRDFP(,RPLH)                                  0309
*             IF RDFLL=ONE THEN     /* IS THE COUNT NOW ONE?         */
@RF00308 L     @14,PLHRDFP(,RPLH)                                  0310
         CLC   RDFLL(2,@14),@CH00051                               0310
         BNE   @RF00310                                            0310
*               DO;                 /* YES, CONVRT TO SINGLE         */
*                 PLHRDFP=PLHRDFP+LENGTH(IDARDF);/* REMOVE SECOND OF
*                                      GROUP                         */
         AL    @14,@CF00063                                        0312
         ST    @14,PLHRDFP(,RPLH)                                  0312
*                 RDFCTNU=OFF;      /* RESET CONTROL INDICATOR       */
         NI    RDFCTNU(@14),B'10111111'                            0313
*               END;                /* END CONVERT TO SINGLE         */
*           END;                    /* END - REPLICATED RDFS         */
*         ELSE                      /* NOT REPLICATED RECORDS        */
*           PLHRDFP=PLHRDFP+LENGTH(IDARDF);/* SO REMOVE THE RDF      */
*                                                                  0316
         B     @RC00305                                            0316
@RF00305 LA    @14,3                                               0316
         AL    @14,PLHRDFP(,RPLH)                                  0316
         ST    @14,PLHRDFP(,RPLH)                                  0316
*         /***********************************************************/
*         /*                                                         */
*         /* ERASE THE DUPLICATE DATA FROM THE CONTROL INTERVAL      */
*         /*                                                         */
*         /***********************************************************/
*                                                                  0317
*         RESPECIFY                                                0317
*          (RWORK4,                                                0317
*           RWORK5) RESTRICTED;                                    0317
@RC00305 DS    0H                                                  0318
*         RWORK4=PLHRECP;           /* START OF AREA TO BE CLEARED   */
         L     @14,PLHRECP(,RPLH)                                  0318
         LR    RWORK4,@14                                          0318
*         RWORK5=PLHRDFP-PLHRECP;   /* LENGTH OF AREA TO BE CLEARED  */
         LCR   @14,@14                                             0319
         AL    @14,PLHRDFP(,RPLH)                                  0319
         LR    RWORK5,@14                                          0319
*         CIDFOSET=RWORK3;          /* ESTABLISH FREE SPACE OFFSET   */
         L     @14,AMBDSB(,RAMB)                                   0320
         L     @10,BUFCBAD(,RBUFC)                                 0320
         AL    @10,AMDCINV(,@14)                                   0320
         SL    @10,@CF00089                                        0320
         STH   RWORK3,CIDFOSET(,@10)                               0320
*         CIDFLL=RWORK5;            /* ESTABLISH FREE SPACE LENGTH   */
         STH   RWORK5,CIDFLL(,@10)                                 0321
*         R15=ZERO;                 /* R15 IS ZERO TO CLEAR AREA     */
         SLR   R15,R15                                             0322
*         MVCL(RWORK4,R14);         /* CLEAR THE CI FREE SPACE       */
         MVCL  RWORK4,R14                                          0323
*         RESPECIFY                                                0324
*          (RWORK4,                                                0324
*           RWORK5) UNRESTRICTED;                                  0324
*       END;                        /* END - ERASE PROCESSING        */
*     ELSE                          /* EXPECTED EQUALS ACTUAL        */
*       DO;                         /* ADVANCE RDF & RECORD POINTERS */
         B     @RC00298                                            0326
@RF00298 DS    0H                                                  0327
*         PLHRECP=PLHRECP+PLHLRECL; /* ADVANCE TO NEXT RECORD        */
         L     @14,PLHRECP(,RPLH)                                  0327
         AL    @14,PLHLRECL(,RPLH)                                 0327
         ST    @14,PLHRECP(,RPLH)                                  0327
*         CALL ADVRDF;              /* ADVANCE TO THE NEXT RDF       */
         BAL   @14,ADVRDF                                          0328
*       END;                        /* END - ADVANCE POINTERS        */
*     RESPECIFY                                                    0330
*      (RWORK2,                                                    0330
*       R15) UNRESTRICTED;                                         0330
@RC00298 DS    0H                                                  0331
*   END;                            /* END - WHILE NOT IN FREE SPACE */
@DE00278 CLC   PLHRECP(4,RPLH),PLHFSP(RPLH)                        0331
         BL    @DL00278                                            0331
*   RESPECIFY                                                      0332
*     RWORK3 UNRESTRICTED;          /* RELEASE REGISTER FOR SCIB     */
*   RBUFC=PLHDBUFC;                 /* RBUFC POINTS TO DATA BUFC     */
         L     RBUFC,PLHDBUFC(,RPLH)                               0333
*   CALL EXIT;                      /* EXIT TO MAIN ROUTINE          */
*                                                                  0334
         BAL   @14,EXIT                                            0334
*   /*****************************************************************/
*   /*                                                               */
*   /* INSERT-CHARACTER-UNDER-MASK INSTRUCTION USED TO PROCESS INDEX */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0335
*INSERT:                                                           0335
*   GEN(ICM   RWORK2,0,0(RWORK4));  /* INSERT RELATIVE CI NUMBER     */
INSERT   ICM   RWORK2,0,0(RWORK4)
*   END FIXCI;                                                     0336
@EL00003 DS    0H                                                  0336
@EF00003 DS    0H                                                  0336
@ER00003 BR    @14                                                 0336
*ADVRDF:                                                           0337
*                                                                  0337
*/********************************************************************/
*/*                                                                  */
*/*   FUNCTION - ADVANCES THE PLHRDFC AND PLHRDFP FIELDS TO THE      */
*/*              NEXT LOGICAL RDF.                                   */
*/*                                                                  */
*/*   INPUT    - RPLH POINTS TO THE PLH.                             */
*/*              PLHLRECL CONTAINS THE LENGTH OF THE PREVIOUS RECORD.*/
*/*              PLHRDFC CONTAINS THE CURRENT RDF REPLICATION COUNT. */
*/*              PLHRDFP POINTS TO THE CURRENT RDF.                  */
*/*                                                                  */
*/*   OUTPUT   - PLHLRECL CONTAINS THE LENGTH OF THE CURRENT RECORD. */
*/*              PLHRDFC AND PLHRDFP HAVE BEEN ADVANCED.             */
*/*                                                                  */
*/********************************************************************/
*                                                                  0337
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);                               0337
ADVRDF   DS    0H                                                  0338
*   RESPECIFY                                                      0338
*    (RWORK1,                                                      0338
*     R14) RESTRICTED;              /* RESTRICT REGISTERS            */
*   RESPECIFY                                                      0339
*     IDARDF BASED(RWORK1);         /* RDF POINTER FOR ADVRDF        */
*   RWORK1=PLHRDFP;                 /* ADDRESSABILITY TO THE RDF     */
         L     RWORK1,PLHRDFP(,RPLH)                               0340
*   IF PLHRDFC>ONE THEN             /* IF REPLICATION COUNT > ONE    */
         LH    @15,PLHRDFC(,RPLH)                                  0341
         C     @15,@CF00051                                        0341
         BNH   @RF00341                                            0341
*     PLHRDFC=PLHRDFC-ONE;          /* DECREMENT THE COUNT           */
         BCTR  @15,0                                               0342
         STH   @15,PLHRDFC(,RPLH)                                  0342
*   ELSE                            /* IF REPLICATION COUNT < TWO    */
*     DO;                           /* ADVANCE THE RDF POINTER       */
         B     @RC00341                                            0343
@RF00341 DS    0H                                                  0344
*       RWORK1=RWORK1-LENGTH(IDARDF);/* MOVE TO THE NEXT RDF         */
         LA    @15,3                                               0344
         SLR   RWORK1,@15                                          0344
*       PLHLRECL=RDFLL;             /* UPDATE THE RECORD LENGTH      */
         SLR   @10,@10                                             0345
         ICM   @10,3,RDFLL(RWORK1)                                 0345
         ST    @10,PLHLRECL(,RPLH)                                 0345
*       IF RDFCTNU=ON THEN          /* IS THIS A GROUP RDF?          */
         TM    RDFCTNU(RWORK1),B'01000000'                         0346
         BNO   @RF00346                                            0346
*         DO;                       /* YES                           */
*           RWORK1=RWORK1-LENGTH(IDARDF);/* MOVE TO THE NEXT RDF     */
         SLR   RWORK1,@15                                          0348
*           PLHRDFC=RDFLL;          /* SET THE RECORD COUNT          */
         MVC   PLHRDFC(2,RPLH),RDFLL(RWORK1)                       0349
*         END;                      /* END - GROUP RDF               */
*       PLHRDFP=RWORK1;             /* SET NEW RDF POINTER           */
@RF00346 ST    RWORK1,PLHRDFP(,RPLH)                               0351
*     END;                          /* END - ADVANCE RDF POINTER     */
*   RESPECIFY                                                      0353
*     IDARDF BASED(PLHRDFP);        /* RESET RDF BASING              */
*   RESPECIFY                                                      0354
*    (RWORK1,                                                      0354
*     R14) UNRESTRICTED;            /* RELEASE REGISTERS AND         */
*   END ADVRDF;                     /* RETURN                        */
@EL00004 DS    0H                                                  0355
@EF00004 DS    0H                                                  0355
@ER00004 BR    @14                                                 0355
*EXIT:                                                             0356
*                                                                  0356
*/********************************************************************/
*/*                                                                  */
*/*   FUNCTION - RESTORES REGISTER 14 FROM PLH PUSHDOWN LIST AND     */
*/*               RETURNS.                                           */
*/*                                                                  */
*/********************************************************************/
*                                                                  0356
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);                               0356
EXIT     DS    0H                                                  0357
*   PLHNOADV=OFF;                   /* CALLER MUST SET POSITIONING   */
         NI    PLHNOADV(RPLH),B'11110111'                          0357
*   GEN REFS(HWORD4)(IDARST14);     /* RESTORE REGISTER 14           */
         IDARST14
*   END EXIT;                       /* RETURN                        */
@EL00005 DS    0H                                                  0359
@EF00005 DS    0H                                                  0359
@ER00005 BR    @14                                                 0359
*ERREXIT:                                                          0360
*                                                                  0360
*/********************************************************************/
*/*                                                                  */
*/*   FUNCTION - PERFORMS ERROR PROCESSING FOR AN INVALID CONTROL    */
*/*              INTERVAL AND RETURNS TO THE CALLING ROUTINE.        */
*/*                                                                  */
*/********************************************************************/
*                                                                  0360
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);                               0360
ERREXIT  DS    0H                                                  0361
*   CIDFBUSY=ON;                    /* TURN THE BUSY BIT ON AGAIN    */
         L     @10,AMBDSB(,RAMB)                                   0361
         L     @05,BUFCBAD(,RBUFC)                                 0361
         AL    @05,AMDCINV(,@10)                                   0361
         BCTR  @05,0                                               0361
         BCTR  @05,0                                               0361
         OI    CIDFBUSY-2(@05),B'10000000'                         0361
*   PLHSKPER=ON;                    /* CI IN ERROR - SKIP            */
         OI    PLHSKPER(RPLH),B'00100000'                          0362
*   RPLERREG='08'X;                 /* SET LOGICAL ERROR             */
         MVI   RPLERREG(RRPL),X'08'                                0363
*   RPLERRCD=RPLINCNV;              /* SET INVALID CONTROL INTERVAL  */
         MVI   RPLERRCD(RRPL),X'9C'                                0364
*   GEN(IDARST14);                  /* RESTORE REGISTER 14           */
         IDARST14
*   END ERREXIT;                    /* RETURN, CI IS IN ERROR        */
@EL00006 DS    0H                                                  0366
@EF00006 DS    0H                                                  0366
@ER00006 BR    @14                                                 0366
@PB00006 DS    0H                                                  0367
*   GEN(IDAPATCH);                  /* DEFINE A PATCH SPACE          */
         IDAPATCH
*   END IDA019S6                                                   0368
*                                                                  0368
*/* THE FOLLOWING INCLUDE STATEMENTS WERE FOUND IN THIS PROGRAM.     */
*/*%INCLUDE SYSLIB  (IFGACB  )                                       */
*/*%INCLUDE SYSLIB  (IDAAMB  )                                       */
*/*%INCLUDE SYSLIB  (IDAAMBL )                                       */
*/*%INCLUDE SYSLIB  (IDAAMDSB)                                       */
*/*%INCLUDE SYSLIB  (IDABUFC )                                       */
*/*%INCLUDE SYSLIB  (IDACIDF )                                       */
*/*%INCLUDE SYSLIB  (IDADIWA )                                       */
*/*%INCLUDE SYSLIB  (IDAICWA )                                       */
*/*%INCLUDE SYSLIB  (IDAIMWA )                                       */
*/*%INCLUDE SYSLIB  (IDAIRD  )                                       */
*/*%INCLUDE SYSLIB  (IDAIXSPL)                                       */
*/*%INCLUDE SYSLIB  (IDAPLH  )                                       */
*/*%INCLUDE SYSLIB  (IDARDF  )                                       */
*/*%INCLUDE SYSLIB  (IDARMRCD)                                       */
*/*%INCLUDE SYSLIB  (IFGRPL  )                                       */
*/*%INCLUDE SYSLIB  (IDAREGS )                                       */
*                                                                  0368
*       ;                                                          0368
@EL00001 DS    0H                                                  0368
@EF00001 DS    0H                                                  0368
@ER00001 BR    @14                                                 0368
@DATA    DS    0H
@SC01093 CLC   KEY(0,@05),KEY(RPARM1)
@DATD    DSECT
         DS    0F
IDA019S6 CSECT
         DS    0F
@CF00051 DC    F'1'
@CH00051 EQU   @CF00051+2
@CF00063 DC    F'3'
@CF00089 DC    F'4'
@CF00370 DC    F'6'
@CF00766 DC    F'36'
@DATD    DSECT
         DS    0D
IDA019S6 CSECT
         NOPR  ((@ENDDATD-@DATD)*16)
         DS    0F
@SIZDATD DC    AL1(0)
         DC    AL3(@ENDDATD-@DATD)
@CV01046 DC    V(IDADRQ)
@CV01047 DC    V(IDAWRBFR)
@CV01048 DC    V(IDA019RC)
         DS    0D
FOUR     DC    H'4'
HWORD4   DC    H'4'
@DATD    DSECT
*                                                          /*@X04SVLC*/
RDFCTNUA EQU   X'40'                    COMPLEX RDF INDICATOR
RDFCTNUX EQU   X'FF'-RDFCTNUA           RESET COMPLEX MASK
RDFREPLA EQU   X'08'                    COUNT RDF INDICATOR
RDFREPLX EQU   X'FF'-RDFREPLA           RESET COUNT MASK
RDFEMPTI EQU   X'04'                    EMPTY RECORD       /*@X04SVLC*/
RDFLEN   EQU   3                        LENGTH OF RDF
RDFLLOFF EQU   1                        OFFSET WITHIN RDF TO LL
RDFSGLR  EQU   X'00'                   MASK FOR SINGLE RECORD RDF
RDFGRP   EQU   RDFCTNUA                 MASK FOR LL RDF OF A GROUP RDF
RDFCNT   EQU   RDFREPLA                 MASK FOR COUNT RDF
@DATD    DSECT
@ENDDATD EQU   *
IDA019S6 CSECT
@00      EQU   00                      EQUATES FOR REGISTERS 0-15
@01      EQU   01
@02      EQU   02
@03      EQU   03
@04      EQU   04
@05      EQU   05
@06      EQU   06
@07      EQU   07
@08      EQU   08
@09      EQU   09
@10      EQU   10
@11      EQU   11
@12      EQU   12
@13      EQU   13
@14      EQU   14
@15      EQU   15
RWORK0   EQU   @00
RRPL     EQU   @01
RPLH     EQU   @02
RAMB     EQU   @03
RBUFC    EQU   @04
RWORK1   EQU   @05
RWORK2   EQU   @06
RWORK3   EQU   @07
RWORK4   EQU   @08
RWORK5   EQU   @09
RPARM1   EQU   @12
R14      EQU   @14
R15      EQU   @15
R1       EQU   @01
R10      EQU   @10
R11      EQU   @11
R13      EQU   @13
IFGACB   EQU   0
ACBCOMN  EQU   IFGACB
ACBLENG  EQU   ACBCOMN+2
ACBLENG2 EQU   ACBLENG
ACBAMBL  EQU   ACBCOMN+4
ACBJWA   EQU   ACBAMBL
ACBMACRF EQU   ACBCOMN+12
ACBMACR1 EQU   ACBMACRF
ACBADR   EQU   ACBMACR1
ACBCNV   EQU   ACBMACR1
ACBMACR2 EQU   ACBMACRF+1
ACBBUFPL EQU   ACBCOMN+20
ACBMACR3 EQU   ACBBUFPL
ACBRECFM EQU   ACBCOMN+24
ACBCCTYP EQU   ACBCOMN+25
ACBOPT   EQU   ACBCOMN+26
ACBDSORG EQU   ACBOPT
ACBCROPS EQU   ACBDSORG
ACBEXLST EQU   ACBCOMN+36
ACBDDNM  EQU   ACBCOMN+40
ACBAMETH EQU   ACBDDNM+3
ACBOFLGS EQU   ACBCOMN+48
ACBEXFG  EQU   ACBOFLGS
ACBIOSFG EQU   ACBOFLGS
ACBINFLG EQU   ACBCOMN+50
ACBUJFCB EQU   ACBCOMN+52
ACBBLKSZ EQU   ACBCOMN+60
IDAAMB   EQU   0
AMBDSB   EQU   IDAAMB+20
AMBEOVR  EQU   IDAAMB+24
AMBFLG0  EQU   AMBEOVR
AMBFLG1  EQU   IDAAMB+25
AMBDSORG EQU   IDAAMB+26
AMBIOBAD EQU   IDAAMB+28
AMBINFL  EQU   IDAAMB+42
AMBDEBPT EQU   IDAAMB+44
AMBOFLGS EQU   IDAAMB+48
AMBFLG2  EQU   IDAAMB+49
AMBEOVPT EQU   IDAAMB+56
AMBIWA   EQU   IDAAMB+64
AMBCSWD1 EQU   IDAAMB+84
AMBAFLG  EQU   AMBCSWD1
IDAAMBL  EQU   0
AMBLEOV  EQU   IDAAMBL+12
AMBLEFLG EQU   AMBLEOV
AMBLDDNM EQU   IDAAMBL+16
AMBLIDF  EQU   AMBLDDNM
AMBLQ    EQU   AMBLIDF+7
AMBLVC   EQU   IDAAMBL+28
AMBLTYPE EQU   IDAAMBL+30
AMBLSHAR EQU   IDAAMBL+33
AMBLWRIT EQU   AMBLSHAR
AMBLFLG1 EQU   IDAAMBL+35
AMBLFLG2 EQU   IDAAMBL+36
AMBLDTA  EQU   IDAAMBL+52
AMBLIX   EQU   IDAAMBL+56
IDAAMDSB EQU   0
AMDATTR  EQU   IDAAMDSB+1
AMDNEST  EQU   IDAAMDSB+4
AMDRKP   EQU   IDAAMDSB+6
AMDKEYLN EQU   IDAAMDSB+8
AMDCINV  EQU   IDAAMDSB+20
AMDHLRBA EQU   IDAAMDSB+28
AMDSSRBA EQU   IDAAMDSB+32
AMDATTR3 EQU   IDAAMDSB+40
AMDSTAT  EQU   IDAAMDSB+48
IDABUFDR EQU   0
BUFDRCIX EQU   IDABUFDR+9
BUFDRFLG EQU   IDABUFDR+11
IDABUFC  EQU   0
BUFCAVL  EQU   IDABUFC
BUFCUCNT EQU   BUFCAVL
BUFCFLG1 EQU   IDABUFC+1
BUFCVAL  EQU   BUFCFLG1
BUFCEXC  EQU   BUFCFLG1
BUFCIOFL EQU   IDABUFC+2
BUFCMW   EQU   BUFCIOFL
BUFCFLG2 EQU   IDABUFC+3
BUFCPLH  EQU   IDABUFC+4
BUFCDDDD EQU   IDABUFC+8
BUFCORBA EQU   IDABUFC+12
BUFCBAD  EQU   IDABUFC+20
BUFCINV  EQU   IDABUFC+28
IDACIDF  EQU   0
CIDFOSET EQU   IDACIDF
CIDFLL   EQU   IDACIDF+2
CIDFBUSY EQU   CIDFLL
IDADIWA  EQU   0
DIWATV   EQU   IDADIWA+1
DIWFLG1  EQU   IDADIWA+4
DIWFLG2  EQU   IDADIWA+5
DIWPLH   EQU   IDADIWA+16
DIWSAVE  EQU   IDADIWA+28
DIWSAVE1 EQU   DIWSAVE
DIWSAVE2 EQU   DIWSAVE+4
DIWSAVE3 EQU   DIWSAVE+8
IDAICWA  EQU   0
ICWFLG1  EQU   IDAICWA+1
ICWCHN   EQU   IDAICWA+4
IDAIMWA  EQU   0
IMWFLAGS EQU   IDAIMWA+1
IMWISWKA EQU   IDAIMWA+8
IDAIXH   EQU   0
IXHPTLS  EQU   IDAIXH+3
IXHBRBA  EQU   IDAIXH+4
IDAIBFLP EQU   0
IBFLP3   EQU   IDAIBFLP+2
IBFLP2   EQU   IBFLP3
IDASELL  EQU   0
IDAIXK   EQU   0
IDAIXSPL EQU   0
IXSBFLG  EQU   IDAIXSPL+17
IXSHEP   EQU   IDAIXSPL+20
IDAPLHDR EQU   0
IDAPLH   EQU   0
PLHFLG1  EQU   IDAPLH+2
PLHRDEXC EQU   PLHFLG1
PLHFLG2  EQU   IDAPLH+3
PLHEFLGS EQU   IDAPLH+4
PLHSKPER EQU   PLHEFLGS
PLHNOADV EQU   PLHEFLGS
PLHFLG3  EQU   IDAPLH+6
PLHAFLGS EQU   IDAPLH+7
PLHDBDC  EQU   PLHAFLGS
PLHCRBA  EQU   IDAPLH+28
PLHJORBA EQU   PLHCRBA
PLHJCODE EQU   IDAPLH+40
PLHLRECL EQU   IDAPLH+48
PLHDBUFC EQU   IDAPLH+52
PLHRECP  EQU   IDAPLH+60
PLHFSP   EQU   IDAPLH+64
PLHRDFP  EQU   IDAPLH+68
PLHRDFC  EQU   IDAPLH+72
PLHDIOB  EQU   IDAPLH+76
PLHRETO  EQU   IDAPLH+116
PLHRET1  EQU   IDAPLH+120
PLHEOVPT EQU   IDAPLH+180
PLHIBUFC EQU   IDAPLH+188
PLHIXSPL EQU   IDAPLH+200
PLHSSRBA EQU   PLHIXSPL
PLHWAX   EQU   IDAPLH+232
PLHKEYPT EQU   IDAPLH+248
PLHEND   EQU   IDAPLH+280
IDARDF   EQU   0
RDFRBYTE EQU   IDARDF
RDFCTNU  EQU   RDFRBYTE
RDFSEG   EQU   RDFRBYTE
RDFNOT1  EQU   RDFSEG
RDF1ST   EQU   RDFSEG
RDFREPL  EQU   RDFRBYTE
RDFLL    EQU   IDARDF+1
IDADATA  EQU   0
IDAKEY   EQU   0
KEY      EQU   IDAKEY
IFGRPL   EQU   0
RPLCOMN  EQU   IFGRPL
RPLIDWD  EQU   RPLCOMN
RPLREQ   EQU   RPLIDWD+2
RPLLEN   EQU   RPLIDWD+3
RPLECB   EQU   RPLCOMN+8
RPLFDBWD EQU   RPLCOMN+12
RPLFDBK  EQU   RPLFDBWD+1
RPLRTNCD EQU   RPLFDBK
RPLERREG EQU   RPLRTNCD
RPLCNDCD EQU   RPLFDBK+1
RPLCMPON EQU   RPLCNDCD
RPLFDB2  EQU   RPLCMPON
RPLERRCD EQU   RPLCNDCD+1
RPLFDB3  EQU   RPLERRCD
RPLKEYLE EQU   RPLCOMN+16
RPLDACB  EQU   RPLCOMN+24
RPLARG   EQU   RPLCOMN+36
RPLOPTCD EQU   RPLCOMN+40
RPLOPT1  EQU   RPLOPTCD
RPLECBSW EQU   RPLOPT1
RPLOPT2  EQU   RPLOPTCD+1
RPLKEY   EQU   RPLOPT2
RPLADR   EQU   RPLOPT2
RPLUPD   EQU   RPLOPT2
RPLOPT3  EQU   RPLOPTCD+2
RPLNXTRP EQU   RPLCOMN+44
RPLOPTC2 EQU   RPLCOMN+56
RPLOPT5  EQU   RPLOPTC2
RPLWRTYP EQU   RPLOPT5
RPLOPT6  EQU   RPLOPTC2+1
RPLUNTYP EQU   RPLOPT6
RPLOPT7  EQU   RPLOPTC2+2
RPLCNOPT EQU   RPLOPT7
RPLOPT8  EQU   RPLOPTC2+3
RPLRBAR  EQU   RPLCOMN+60
RPLAIXID EQU   RPLRBAR+2
RPLDDDD  EQU   RPLRBAR+4
RPLEXTDS EQU   RPLCOMN+68
RPLEXTD1 EQU   RPLEXTDS
ICWKEY2  EQU   0
ICWKEY3  EQU   0
PLHKEY   EQU   0
PLHPDL   EQU   0
PLHPDLE  EQU   0
PLHRRN   EQU   0
FSO      EQU   CIDFOSET
FSL      EQU   CIDFLL
PLHEXTEN EQU   PLHEND
PLHBMWRK EQU   PLHEXTEN+5
@NM00061 EQU   DIWSAVE1
S6FLAGS  EQU   @NM00061
S6NOKEY  EQU   S6FLAGS
BUFCRSC1 EQU   BUFCAVL
         AGO   .@UNREFD                START UNREFERENCED COMPONENTS
PLHBMSV5 EQU   PLHEXTEN+24
PLHBMSV4 EQU   PLHEXTEN+20
PLHBMSV3 EQU   PLHEXTEN+16
PLHBMSV2 EQU   PLHEXTEN+12
PLHBMSV1 EQU   PLHEXTEN+8
PLHRDCNT EQU   PLHEXTEN+6
PLHBMSOV EQU   PLHBMWRK
PLHBEUC  EQU   PLHBMWRK
PLHBMRDF EQU   PLHBMWRK
@NM00057 EQU   PLHEXTEN+4
PLHRESR1 EQU   PLHEXTEN
RPLERMSA EQU   RPLCOMN+72
RPLEMLEN EQU   RPLCOMN+70
RPLACTIV EQU   RPLCOMN+69
RPLBRANC EQU   RPLEXTD1
RPLNIB   EQU   RPLEXTD1
@NM00060 EQU   RPLEXTD1
RPLEXIT  EQU   RPLEXTD1
RPLNEXIT EQU   RPLEXTD1
RPLEXSCH EQU   RPLEXTD1
@NM00059 EQU   RPLRBAR+3
@NM00058 EQU   RPLAIXID
RPLAXPKP EQU   RPLAIXID
RPLAIXPC EQU   RPLRBAR
RPLRSV88 EQU   RPLOPT8
RPLUNCON EQU   RPLOPT8
RPLACTV  EQU   RPLOPT8
RPLSESS  EQU   RPLOPT8
RPLPEND  EQU   RPLOPT8
RPLODPRM EQU   RPLOPT8
RPLODACP EQU   RPLOPT8
RPLODACQ EQU   RPLOPT8
RPLRSV78 EQU   RPLOPT7
RPLRSV77 EQU   RPLOPT7
RPLRLSOP EQU   RPLOPT7
RPLTPOST EQU   RPLOPT7
RPLQOPT  EQU   RPLOPT7
RPLCNIMM EQU   RPLCNOPT
RPLCNANY EQU   RPLCNOPT
RPLCNALL EQU   RPLCNOPT
RPLRSV68 EQU   RPLOPT6
RPLRSV67 EQU   RPLOPT6
RPLLOCK  EQU   RPLOPT6
RPLNCOND EQU   RPLOPT6
RPLCOND  EQU   RPLOPT6
RPLEOT   EQU   RPLUNTYP
RPLEOM   EQU   RPLUNTYP
RPLEOB   EQU   RPLUNTYP
RPLWROPT EQU   RPLOPT5
RPLNODE  EQU   RPLOPT5
RPLERACE EQU   RPLWRTYP
RPLEAU   EQU   RPLWRTYP
RPLNERAS EQU   RPLWRTYP
RPLPSOPT EQU   RPLOPT5
RPLSSNIN EQU   RPLOPT5
RPLDLGIN EQU   RPLOPT5
RPLBUFL  EQU   RPLCOMN+52
RPLRLEN  EQU   RPLCOMN+48
RPLCHAIN EQU   RPLNXTRP
RPLOPT4  EQU   RPLOPTCD+3
RPLALIGN EQU   RPLOPT3
RPLFMT   EQU   RPLOPT3
RPLFLD   EQU   RPLOPT3
RPLVFY   EQU   RPLOPT3
RPLBLK   EQU   RPLOPT3
RPLSFORM EQU   RPLOPT3
RPLEODS  EQU   RPLOPT3
RPLNSP   EQU   RPLOPT2
RPLWAITX EQU   RPLOPT2
RPLLRD   EQU   RPLOPT2
RPLBWD   EQU   RPLOPT2
RPLCNV   EQU   RPLOPT2
RPLADD   EQU   RPLADR
RPLECBIN EQU   RPLECBSW
RPLGEN   EQU   RPLOPT1
RPLKGE   EQU   RPLOPT1
RPLASY   EQU   RPLOPT1
RPLSKP   EQU   RPLOPT1
RPLSEQ   EQU   RPLOPT1
RPLDIR   EQU   RPLOPT1
RPLLOC   EQU   RPLOPT1
RPLDAF   EQU   RPLARG+2
RPLSAF   EQU   RPLARG
RPLAREA  EQU   RPLCOMN+32
RPLTCBPT EQU   RPLCOMN+28
RPLCCHAR EQU   RPLCOMN+20
RPLSTRID EQU   RPLCOMN+18
RPLKEYL  EQU   RPLKEYLE
RPLRDSOH EQU   RPLFDB3
RPLRLG   EQU   RPLFDB3
RPLLGFRC EQU   RPLFDB3
RPLREOT  EQU   RPLFDB3
RPLREOM  EQU   RPLFDB3
RPLREOB  EQU   RPLFDB3
RPLSV32  EQU   RPLFDB3
RPLUINPT EQU   RPLFDB3
RPLSTSAV EQU   RPLFDB2
RPLCUERR EQU   RPLFDB2
RPLDLGFL EQU   RPLFDB2
RPLIOERR EQU   RPLFDB2
RPLDVUNS EQU   RPLFDB2
RPLATND  EQU   RPLFDB2
RPLRVID  EQU   RPLFDB2
RPLERLK  EQU   RPLFDB2
RPLSTAT  EQU   RPLFDBWD
RPLPOST  EQU   RPLECB
RPLWAIT  EQU   RPLECB
RPLPLHPT EQU   RPLCOMN+4
RPLLEN2  EQU   RPLLEN
RPLSTYP  EQU   RPLIDWD+1
RPLID    EQU   RPLIDWD
AMDATA   EQU   IDADATA
RDFEMPTY EQU   RDFRBYTE
RDFTYPE  EQU   RDFRBYTE
PLHERRET EQU   IDAPLH+276
PLHASCB  EQU   IDAPLH+272
PLHECB   EQU   IDAPLH+268
@NM00056 EQU   IDAPLH+265
PLHDRMSK EQU   IDAPLH+264
PLHR13   EQU   IDAPLH+260
PLHPARM1 EQU   IDAPLH+256
PLHDRRSC EQU   IDAPLH+252
PLHSLRBA EQU   IDAPLH+244
PLHSRCSG EQU   IDAPLH+242
PLHNOSEG EQU   IDAPLH+240
PLHLLOR  EQU   IDAPLH+236
PLHXPLH  EQU   PLHWAX
@NM00055 EQU   PLHIXSPL+8
PLHIXBFC EQU   PLHIXSPL+4
PLHHIREC EQU   PLHSSRBA
PLHISPLP EQU   IDAPLH+196
PLHRBUFC EQU   IDAPLH+192
PLHNRBA  EQU   IDAPLH+184
PLHDDDD  EQU   PLHEOVPT
PLHAR14  EQU   IDAPLH+176
@NM00054 EQU   IDAPLH+172
@NM00053 EQU   IDAPLH+168
PLHASAVE EQU   IDAPLH+164
PLHRETOS EQU   IDAPLH+118
PLHCHAIN EQU   IDAPLH+112
PLHAMB   EQU   IDAPLH+108
PLHSAVE6 EQU   IDAPLH+104
PLHSAVE5 EQU   IDAPLH+100
PLHSAVE4 EQU   IDAPLH+96
PLHSAVE3 EQU   IDAPLH+92
PLHSAVE2 EQU   IDAPLH+88
PLHSAVE1 EQU   IDAPLH+84
PLHARET  EQU   IDAPLH+80
PLHIIOB  EQU   PLHDIOB
PLHSRSID EQU   IDAPLH+74
PLHNBUFC EQU   IDAPLH+56
PLHARDB  EQU   IDAPLH+44
@NM00052 EQU   IDAPLH+43
PLHEOVR  EQU   IDAPLH+42
PLHRCODE EQU   IDAPLH+41
PLHUCODE EQU   PLHJCODE
PLHJNRBA EQU   IDAPLH+36
PLHJRNLL EQU   IDAPLH+32
PLHUPECB EQU   PLHJORBA
PLHDSIDA EQU   IDAPLH+24
PLHCRPL  EQU   IDAPLH+20
PLHMRPL  EQU   IDAPLH+16
PLHBFRNO EQU   IDAPLH+15
PLHFRCNT EQU   IDAPLH+14
PLHRMIN  EQU   IDAPLH+13
PLHDSTYP EQU   IDAPLH+12
PLHACB   EQU   IDAPLH+8
PLHRAE   EQU   PLHAFLGS
PLHRABWD EQU   PLHAFLGS
PLHIOSID EQU   PLHAFLGS
PLHVAMB  EQU   PLHAFLGS
PLHIOSRQ EQU   PLHAFLGS
PLHDRLM  EQU   PLHAFLGS
PLHEOVDF EQU   PLHFLG3
PLHRVRS  EQU   PLHFLG3
PLHBWD   EQU   PLHFLG3
PLHSLVLD EQU   PLHFLG3
PLHRAHD  EQU   PLHFLG3
PLHSRBSG EQU   PLHFLG3
@NM00051 EQU   PLHEFLGS+1
PLHRSTRT EQU   PLHEFLGS+1
PLHDSCAN EQU   PLHEFLGS
PLHINVAL EQU   PLHEFLGS
PLHEODX  EQU   PLHEFLGS
PLHSRINV EQU   PLHEFLGS
PLH1ST   EQU   PLHEFLGS
PLHNOSPC EQU   PLHEFLGS
PLHIWAIT EQU   PLHFLG2
PLHSVADV EQU   PLHFLG2
PLHCIINS EQU   PLHFLG2
PLHKRE   EQU   PLHFLG2
PLHADDTE EQU   PLHFLG2
PLHKEYMD EQU   PLHFLG2
PLHSQINS EQU   PLHFLG2
PLHUPD   EQU   PLHFLG2
@NM00050 EQU   PLHFLG1
PLHDRPND EQU   PLHFLG1
PLHASYRQ EQU   PLHFLG1
PLHSSR   EQU   PLHFLG1
PLHASKBF EQU   PLHFLG1
PLHENDRQ EQU   PLHFLG1
PLHEOVW  EQU   PLHFLG1
PLHATV   EQU   IDAPLH+1
PLHAVL   EQU   IDAPLH
PLHIOSDQ EQU   IDAPLHDR+12
PLHDRCUR EQU   IDAPLHDR+10
PLHDRMAX EQU   IDAPLHDR+8
PLHDRREQ EQU   IDAPLHDR+4
PLHELTH  EQU   IDAPLHDR+2
PLHCNT   EQU   IDAPLHDR+1
PLHID    EQU   IDAPLHDR
IXSLEP   EQU   IDAIXSPL+28
IXSSEP   EQU   IDAIXSPL+24
IXSPEC   EQU   IDAIXSPL+19
IXSEKON  EQU   IDAIXSPL+18
@NM00049 EQU   IXSBFLG
IXSLELV  EQU   IXSBFLG
IXSSSRH  EQU   IXSBFLG
IXSNOSR  EQU   IDAIXSPL+16
IXSKLEN  EQU   IDAIXSPL+14
IXSILN   EQU   IDAIXSPL+13
IXSTLN   EQU   IDAIXSPL+12
IXSARG   EQU   IDAIXSPL+8
IXSBUFC  EQU   IDAIXSPL+4
IXSSTRBA EQU   IDAIXSPL
IXKEY    EQU   IDAIXK
IXSELL   EQU   IDASELL
IBFLP1   EQU   IBFLP2
IBFLPL   EQU   IDAIBFLP+1
IBFLPF   EQU   IDAIBFLP
IXHSEO   EQU   IDAIXH+22
IXHLEO   EQU   IDAIXH+20
IXHFSO   EQU   IDAIXH+18
IXHFLGS  EQU   IDAIXH+17
IXHLV    EQU   IDAIXH+16
IXHXX    EQU   IDAIXH+12
IXHHP    EQU   IDAIXH+8
IXHFLPLN EQU   IDAIXH+2
IXHLL    EQU   IDAIXH
IMWKEY1  EQU   IDAIMWA+76
@NM00048 EQU   IDAIMWA+72
IMWNSOFF EQU   IDAIMWA+70
IMWCIMVN EQU   IDAIMWA+68
@NM00047 EQU   IDAIMWA+67
IMWSVIEL EQU   IDAIMWA+66
IMWIEL   EQU   IDAIMWA+65
IMWFGAIN EQU   IDAIMWA+64
IMWBUFP  EQU   IDAIMWA+60
IMWLBUFC EQU   IDAIMWA+56
IMWIPTR  EQU   IDAIMWA+52
IMWXPTR  EQU   IDAIMWA+48
IMWIKEYP EQU   IDAIMWA+44
IMWXKEYP EQU   IDAIMWA+40
IMWIXSP  EQU   IDAIMWA+4
IMWLEN   EQU   IDAIMWA+2
IMWBSE   EQU   IMWFLAGS
IMWRIPL  EQU   IMWFLAGS
IMWNEWHL EQU   IMWFLAGS
IMWID    EQU   IDAIMWA
ICWKEY1  EQU   IDAICWA+60
ICWCERP  EQU   IDAICWA+59
ICWCEL   EQU   IDAICWA+58
ICWCEF   EQU   IDAICWA+57
ICWCER   EQU   IDAICWA+56
ICWPTL   EQU   IDAICWA+55
ICWREQ   EQU   IDAICWA+54
ICWCRSEG EQU   IDAICWA+52
ICWNOSEG EQU   IDAICWA+50
ICWNEST  EQU   IDAICWA+48
ICWKEY3L EQU   IDAICWA+46
ICWKEY2L EQU   IDAICWA+44
ICWKEY1L EQU   IDAICWA+42
ICWLN    EQU   IDAICWA+40
ICWARDBP EQU   IDAICWA+36
ICWTPTR  EQU   IDAICWA+32
ICWTBASE EQU   IDAICWA+28
ICWADD   EQU   IDAICWA+24
ICWSCNT  EQU   IDAICWA+22
ICWPSEO  EQU   IDAICWA+20
ICWPRBA  EQU   IDAICWA+16
ICWCRBA  EQU   IDAICWA+12
ICWBUFC  EQU   IDAICWA+8
ICWLEN   EQU   IDAICWA+2
ICWENDRQ EQU   ICWFLG1
ICWSPLIT EQU   ICWFLG1
ICWKRDS  EQU   ICWFLG1
ICWVNE   EQU   ICWFLG1
ICWVSE   EQU   ICWFLG1
ICWRBAOK EQU   ICWFLG1
ICWWAGM  EQU   ICWFLG1
ICWWNF   EQU   ICWFLG1
ICWID    EQU   IDAICWA
@NM00046 EQU   IDADIWA+92
@NM00045 EQU   IDADIWA+88
@NM00044 EQU   IDADIWA+84
@NM00043 EQU   IDADIWA+80
@NM00042 EQU   IDADIWA+76
@NM00041 EQU   IDADIWA+72
@NM00040 EQU   IDADIWA+68
@NM00039 EQU   IDADIWA+64
@NM00038 EQU   IDADIWA+60
@NM00037 EQU   IDADIWA+56
DIWINRBA EQU   IDADIWA+52
DIWRKCT  EQU   IDADIWA+48
DIWSAVE5 EQU   DIWSAVE+16
DIWSAVE4 EQU   DIWSAVE+12
DIWSPLTP EQU   IDADIWA+24
DIWBUFC  EQU   IDADIWA+20
DIWHRBA  EQU   IDADIWA+12
DIWLRBA  EQU   IDADIWA+8
@NM00036 EQU   IDADIWA+6
DIWFSPF  EQU   DIWFLG2
DIW1ST   EQU   DIWFLG1
DIWNOT1  EQU   DIWFLG1
DIWSHIFT EQU   DIWFLG1
DIWGSPC  EQU   DIWFLG1
DIWEOKR  EQU   DIWFLG1
DIWPFERR EQU   DIWFLG1
DIWCISPL EQU   DIWFLG1
DIWCAS   EQU   DIWFLG1
DIWLEN   EQU   IDADIWA+2
DIWID    EQU   IDADIWA
@NM00035 EQU   CIDFLL
BUFCEND  EQU   IDABUFC+64
BUFCUCDN EQU   IDABUFC+60
BUFCUCUP EQU   IDABUFC+56
BUFCMDBT EQU   IDABUFC+52
BUFCHAIN EQU   IDABUFC+48
BUFXORBA EQU   IDABUFC+44
BUFXIRBA EQU   IDABUFC+40
BUFCNXT2 EQU   IDABUFC+37
BUFCIDXL EQU   IDABUFC+36
BUFCDSPC EQU   IDABUFC+32
BUFCWLEN EQU   BUFCINV
BUFCNXT1 EQU   IDABUFC+24
BUFCCPA  EQU   IDABUFC+16
BUFCAMB  EQU   BUFCPLH
@NM00034 EQU   BUFCFLG2
BUFCEOD  EQU   BUFCFLG2
BUFCBSYW EQU   BUFCFLG2
BUFCBSYR EQU   BUFCFLG2
BUFCNLAS EQU   BUFCFLG2
BUFCXDDR EQU   BUFCFLG2
BUFCFIX  EQU   BUFCIOFL
BUFCPFCP EQU   BUFCIOFL
BUFCXEDB EQU   BUFCIOFL
BUFCWC   EQU   BUFCIOFL
BUFCREAL EQU   BUFCIOFL
BUFCRRD  EQU   BUFCIOFL
BUFCFMT  EQU   BUFCIOFL
BUFCEPT  EQU   BUFCFLG1
BUFCER2  EQU   BUFCFLG1
BUFCER1  EQU   BUFCFLG1
BUFCINS  EQU   BUFCFLG1
BUFCSEG  EQU   BUFCFLG1
BUFCUPG  EQU   BUFCFLG1
@NM00033 EQU   IDABUFDR+16
BUFDBUFC EQU   IDABUFDR+12
@NM00032 EQU   BUFDRFLG
BUFDRAVL EQU   BUFDRFLG
BUFDRREL EQU   BUFDRFLG
BUFDRTSB EQU   IDABUFDR+10
BUFDRMAX EQU   BUFDRCIX
BUFDRPFN EQU   IDABUFDR+8
BUFDRPFB EQU   IDABUFDR+4
BUFDRLEN EQU   IDABUFDR+2
BUFDRNO  EQU   IDABUFDR+1
BUFDRID  EQU   IDABUFDR
AMDEXCP  EQU   AMDSTAT+44
AMDNCAS  EQU   AMDSTAT+40
AMDNCIS  EQU   AMDSTAT+36
AMDASPA  EQU   AMDSTAT+32
AMDRETR  EQU   AMDSTAT+28
AMDUPR   EQU   AMDSTAT+24
AMDIREC  EQU   AMDSTAT+20
AMDDELR  EQU   AMDSTAT+16
AMDNLR   EQU   AMDSTAT+12
AMDNEXT  EQU   AMDSTAT+10
AMDNIL   EQU   AMDSTAT+8
AMDSTSP  EQU   AMDSTAT
@NM00031 EQU   IDAAMDSB+41
@NM00030 EQU   AMDATTR3
AMDLM    EQU   AMDATTR3
AMDWAIT  EQU   AMDATTR3
AMDBIND  EQU   AMDATTR3
AMDFAULT EQU   AMDATTR3
AMDUNQ   EQU   AMDATTR3
AMDPARDB EQU   IDAAMDSB+36
AMDMAXRR EQU   AMDSSRBA
AMDNSLOT EQU   AMDHLRBA
AMDLRECL EQU   IDAAMDSB+24
AMDFSCI  EQU   IDAAMDSB+16
AMDFSCA  EQU   IDAAMDSB+14
AMDCIPCA EQU   IDAAMDSB+12
AMDPCTCI EQU   IDAAMDSB+11
AMDPCTCA EQU   IDAAMDSB+10
AMDAXRKP EQU   AMDNEST
AMDLEN   EQU   IDAAMDSB+2
AMDSPAN  EQU   AMDATTR
AMDRRDS  EQU   AMDATTR
AMDRANGE EQU   AMDATTR
AMDORDER EQU   AMDATTR
AMDREPL  EQU   AMDATTR
AMDSDT   EQU   AMDATTR
AMDWCK   EQU   AMDATTR
AMDDST   EQU   AMDATTR
AMDSBID  EQU   IDAAMDSB
AMBLCMB  EQU   IDAAMBL+64
AMBLBIB  EQU   IDAAMBL+60
AMBLMIDS EQU   IDAAMBL+42
AMBLNIDS EQU   IDAAMBL+41
@NM00029 EQU   IDAAMBL+40
AMBLNUM  EQU   IDAAMBL+38
AMBLNST  EQU   IDAAMBL+37
@NM00028 EQU   AMBLFLG2
AMBLSTAG EQU   AMBLFLG2
@NM00027 EQU   AMBLFLG2
AMBLDUMY EQU   AMBLFLG1
AMBLCAT  EQU   AMBLFLG1
AMBLUCRA EQU   AMBLFLG1
AMBLSCRA EQU   AMBLFLG1
AMBLVVIC EQU   AMBLFLG1
AMBLUPD  EQU   AMBLFLG1
AMBLCINV EQU   AMBLFLG1
AMBLFULL EQU   AMBLFLG1
AMBLLEN  EQU   IDAAMBL+34
@NM00026 EQU   AMBLSHAR
AMBLCATO EQU   AMBLSHAR
AMBLPRIM EQU   AMBLSHAR
AMBLID   EQU   IDAAMBL+32
@NM00025 EQU   IDAAMBL+31
@NM00024 EQU   AMBLTYPE
AMBLFIX  EQU   AMBLTYPE
AMBLBASE EQU   AMBLTYPE
AMBLAIX  EQU   AMBLTYPE
AMBLUPGR EQU   AMBLTYPE
AMBLPATH EQU   AMBLTYPE
AMBLENO  EQU   AMBLVC+1
AMBLVRT  EQU   AMBLVC
AMBLXPT  EQU   IDAAMBL+24
AMBLDFR  EQU   AMBLQ
AMBLESDS EQU   AMBLQ
AMBLKSDS EQU   AMBLQ
AMBLUBF  EQU   AMBLQ
AMBLFSTP EQU   AMBLQ
AMBLLSR  EQU   AMBLQ
AMBLGSR  EQU   AMBLQ
AMBLDDC  EQU   AMBLQ
AMBLDCI  EQU   AMBLIDF+4
AMBLCACB EQU   AMBLIDF
@NM00023 EQU   AMBLEOV+2
AMBLCOMP EQU   AMBLEOV+1
AMBLESET EQU   AMBLEFLG
AMBLWAIT EQU   AMBLEFLG
AMBLACB  EQU   IDAAMBL+8
AMBLSCHN EQU   IDAAMBL+4
AMBLPCHN EQU   IDAAMBL
AMBTRACE EQU   IDAAMB+120
AMBVIOT  EQU   IDAAMB+116
AMBSZCP  EQU   IDAAMB+114
AMBSZFW  EQU   IDAAMB+112
AMBSZWR  EQU   IDAAMB+110
AMBSZRD  EQU   IDAAMB+108
AMBEXEX  EQU   IDAAMB+100
AMBWSHD  EQU   IDAAMB+96
AMBCPA   EQU   IDAAMB+92
AMBBM2SH EQU   IDAAMB+88
AMBRDCNT EQU   AMBCSWD1+2
@NM00022 EQU   AMBCSWD1+1
@NM00021 EQU   AMBAFLG
AMBCFX   EQU   AMBAFLG
AMBSIS   EQU   AMBAFLG
AMBDFR   EQU   AMBAFLG
AMBICI   EQU   AMBAFLG
AMBGSR   EQU   AMBAFLG
AMBLSR   EQU   AMBAFLG
@NM00020 EQU   AMBAFLG
AMBUPLH  EQU   IDAAMB+80
AMBPAMBL EQU   IDAAMB+76
AMBPIXP  EQU   IDAAMB+72
@NM00019 EQU   IDAAMB+68
AMBWKA   EQU   IDAAMB+60
AMBAMBXN EQU   AMBEOVPT
AMBEDB   EQU   IDAAMB+52
AMBRPT   EQU   IDAAMB+50
AMBPUG   EQU   AMBFLG2
AMBBUSY  EQU   AMBOFLGS
AMBEXFG  EQU   AMBOFLGS
@NM00018 EQU   AMBOFLGS
AMBOPEN  EQU   AMBOFLGS
@NM00017 EQU   AMBOFLGS
AMBDEBAD EQU   AMBDEBPT+1
AMBIFLGS EQU   AMBDEBPT
AMBAMETH EQU   IDAAMB+43
AMBUPX   EQU   AMBINFL
AMBUCRA  EQU   AMBINFL
AMBSCRA  EQU   AMBINFL
AMBCAT   EQU   AMBINFL
@NM00016 EQU   AMBINFL
@NM00015 EQU   AMBINFL
AMBTIOT  EQU   IDAAMB+40
@NM00014 EQU   IDAAMB+38
AMBDDSN  EQU   IDAAMB+35
AMBCDSN  EQU   IDAAMB+32
AMBIOMB  EQU   AMBIOBAD
@NM00013 EQU   AMBDSORG+1
AMBDORGA EQU   AMBDSORG+1
@NM00012 EQU   AMBDSORG
AMBINBUF EQU   AMBFLG1
AMBJRN   EQU   AMBFLG1
AMBUBF   EQU   AMBFLG1
AMBSPEED EQU   AMBFLG1
AMBPCAT  EQU   AMBFLG1
AMBMCAT  EQU   AMBFLG1
AMBTYPE  EQU   AMBFLG1
AMBCREAT EQU   AMBFLG1
@NM00011 EQU   AMBFLG0
AMBPSDS  EQU   AMBFLG0
AMBCACB  EQU   IDAAMB+16
AMBPH    EQU   IDAAMB+12
AMBBUFC  EQU   IDAAMB+8
AMBLINK  EQU   IDAAMB+4
AMBLEN   EQU   IDAAMB+2
AMBRSC   EQU   IDAAMB+1
AMBID    EQU   IDAAMB
ACBAPID  EQU   ACBCOMN+72
ACBCBMWA EQU   ACBCOMN+68
ACBUAPTR EQU   ACBCOMN+64
ACBLRECL EQU   ACBCOMN+62
ACBMSGLN EQU   ACBBLKSZ
ACBBUFSP EQU   ACBCOMN+56
@NM00010 EQU   ACBUJFCB+1
ACBOPTN  EQU   ACBUJFCB
ACBVVIC  EQU   ACBINFLG
ACBUCRA  EQU   ACBINFLG
ACBSCRA  EQU   ACBINFLG
ACBCAT   EQU   ACBINFLG
ACBIJRQE EQU   ACBINFLG
ACBJEPS  EQU   ACBINFLG
@NM00009 EQU   ACBINFLG
ACBERFLG EQU   ACBCOMN+49
ACBBUSY  EQU   ACBIOSFG
ACBLOCK  EQU   ACBEXFG
@NM00008 EQU   ACBOFLGS
ACBDSERR EQU   ACBOFLGS
ACBOPEN  EQU   ACBOFLGS
ACBEOV   EQU   ACBOFLGS
@NM00007 EQU   ACBOFLGS
ACBDEB   EQU   ACBDDNM+5
ACBERFL  EQU   ACBDDNM+4
ACBAM    EQU   ACBAMETH
ACBINFL  EQU   ACBDDNM+2
ACBTIOT  EQU   ACBDDNM
ACBUEL   EQU   ACBEXLST
ACBPASSW EQU   ACBCOMN+32
ACBMSGAR EQU   ACBCOMN+28
@NM00006 EQU   ACBDSORG+1
ACBDORGA EQU   ACBDSORG+1
@NM00005 EQU   ACBDSORG
ACBCRNRE EQU   ACBCROPS
ACBCRNCK EQU   ACBCROPS
ACBASA   EQU   ACBCCTYP
@NM00004 EQU   ACBCCTYP
ACBRECAF EQU   ACBRECFM
ACBJBUF  EQU   ACBBUFPL+2
ACBMACR4 EQU   ACBBUFPL+1
@NM00003 EQU   ACBMACR3
ACBNCFX  EQU   ACBMACR3
ACBSIS   EQU   ACBMACR3
ACBDFR   EQU   ACBMACR3
ACBICI   EQU   ACBMACR3
ACBGSR   EQU   ACBMACR3
ACBLSR   EQU   ACBMACR3
@NM00002 EQU   ACBMACR3
ACBBUFNI EQU   ACBCOMN+18
ACBBUFND EQU   ACBCOMN+16
ACBSTRNO EQU   ACBCOMN+15
ACBBSTNO EQU   ACBCOMN+14
ACBAIX   EQU   ACBMACR2
ACBDSN   EQU   ACBMACR2
ACBRST   EQU   ACBMACR2
ACBLOGON EQU   ACBMACR2
ACBSKP   EQU   ACBMACR2
@NM00001 EQU   ACBMACR2
ACBUBF   EQU   ACBMACR1
ACBOUT   EQU   ACBMACR1
ACBIN    EQU   ACBMACR1
ACBDIR   EQU   ACBMACR1
ACBSEQ   EQU   ACBMACR1
ACBBLK   EQU   ACBCNV
ACBADD   EQU   ACBADR
ACBKEY   EQU   ACBMACR1
ACBINRTN EQU   ACBCOMN+8
ACBIBCT  EQU   ACBJWA
ACBLEN2  EQU   ACBLENG2
ACBSTYP  EQU   ACBCOMN+1
ACBID    EQU   ACBCOMN
.@UNREFD ANOP                          END UNREFERENCED COMPONENTS
@RF00208 EQU   @RC00204
@RF00310 EQU   @RC00305
@RC00341 EQU   @EL00004
@PB00005 EQU   @PB00006
@PB00004 EQU   @PB00005
@PB00003 EQU   @PB00004
@PB00002 EQU   @PB00003
@ENDDATA EQU   *
         END   IDA019S6,(C'PLS2232',0701,78172)
