         TITLE 'IDA019SA--CONTROL INTERVAL INITIALIZATION              *
                        '
IDA019SA CSECT ,                                                   0001
@MAINENT DS    0H                                                  0001
         USING *,@15                                               0001
         B     @PROLOG                                             0001
         DC    AL1(16)                                             0001
         DC    C'IDA019SA  78.172'                                 0001
         DROP  @15
@PROLOG  BALR  @11,0                                               0001
@PSTART  DS    0H                                                  0001
         USING @PSTART,@11                                         0001
         IDASVR14
*   RBUFC=PLHDBUFC;                 /* POINT TO CURRENT BUFC         */
         L     RBUFC,PLHDBUFC(,RPLH)                               0108
*   RPARM1=BUFCORBA;                /* GET RBA IN REG        @X04SVMR*/
         L     RPARM1,BUFCORBA(,RBUFC)                             0109
*/*  DETERMINE HOW MANY FREE CONTROL INTERVALS ARE LEFT IN THE     0110
*    CONTROL AREA AND ALSO THE RBA OF THE NEXT CONTROL AREA.         */
*                                                                  0110
*   DIWSAVE5=AMDCIPCA-(RPARM1X/AMDCINV)///* GET THE NUMBER   @X04SVMR*/
*       AMDCIPCA-ONE;               /* OF FREE CINVS IN CA   @X04SVMR
*                                                            @ZA10887*/
         L     @10,AMBIWA(,RAMB)                                   0110
         L     @05,AMBDSB(,RAMB)                                   0110
         LH    @15,AMDCIPCA(,@05)                                  0110
         L     @14,AMDCINV(,@05)                                   0110
         LR    @07,RPARM1X                                         0110
         SLR   @06,@06                                             0110
         DR    @06,@14                                             0110
         SLR   @06,@06                                             0110
         DR    @06,@15                                             0110
         SLR   @15,@06                                             0110
         BCTR  @15,0                                               0110
         ST    @15,DIWSAVE5(,@10)                                  0110
*   DIWSAVE3=RPARM1+(DIWSAVE5+ONE)*AMDCINV;/* NEXT CA RBA            */
         LA    @07,1                                               0111
         ALR   @07,@15                                             0111
         MR    @06,@14                                             0111
         ALR   @07,RPARM1                                          0111
         ST    @07,DIWSAVE3(,@10)                                  0111
*   RFY                                                            0112
*     IDARDF BASED(PLHRDFP);        /* DEFINE RDF BASE       @X04SVMR*/
*/*  ENSURE ENOUGH SPACE IS AVAILABLE FOR ANY NEW CONTROL AREA THAT
*    MAY BE NEEDED.                                                  */
*                                                                  0113
*   IF PLHKRE=OFF&                  /* IF EOKR, SPACE HERE           */
*       RDF1ST=OFF&                 /* OR WITHIN S.R.        @X04SVMR*/
*       AMDFSCA>DIWSAVE5-ONE THEN   /* ELSE GET NEW CA               */
         TM    PLHKRE(RPLH),B'00001000'                            0113
         BNZ   @RF00113                                            0113
         L     @10,PLHRDFP(,RPLH)                                  0113
         TM    RDF1ST(@10),B'00010000'                             0113
         BNZ   @RF00113                                            0113
         BCTR  @15,0                                               0113
         CH    @15,AMDFSCA(,@05)                                   0113
         BNL   @RF00113                                            0113
*     DO;                                                          0114
*       CALL GETSPACE;              /* GET NEXT CONTROL AREA         */
         BAL   @14,GETSPACE                                        0115
*       DIWGSPC=ON;                 /* INDICATE NEW CA       @X04SVMR*/
         L     @10,AMBIWA(,RAMB)                                   0116
         OI    DIWGSPC(@10),B'00001000'                            0116
*     END;                          /* END OF NON-EOKR CODE  @X04SVMR*/
*   BUFCSEG=ON;                     /* ASSUME A SPANNED RCD  @X04SVMR*/
@RF00113 OI    BUFCSEG(RBUFC),B'01000000'                          0118
*   DIW1ST=ON;                      /*                       @X04SVMR*/
*   DIWNOT1=ON;                     /*                       @X04SVMR*/
         L     @10,AMBIWA(,RAMB)                                   0120
         OI    DIW1ST(@10),B'00000011'                             0120
*   IF RDF1ST=OFF THEN              /* IF NOT S.R./LAST SEG  @X04SVMR*/
         L     @05,PLHRDFP(,RPLH)                                  0121
         TM    RDF1ST(@05),B'00010000'                             0121
         BNZ   @RF00121                                            0121
*     DO;                           /* MAY NEED IX ENTRY     @X04SVMR*/
*       DIW1ST=OFF;                 /* REMEMBER RDF1ST OFF   @X04SVMR*/
         NI    DIW1ST(@10),B'11111110'                             0123
*       IF RDFNOT1=OFF THEN         /* IF NOT S.R. RESET FLG @X04SVMR*/
         TM    RDFNOT1(@05),B'00100000'                            0124
         BNZ   @RF00124                                            0124
*         DO;                                                      0125
*           DIWNOT1=OFF;            /* REMEMBER RDFNOT1 OFF  @X04SVMR*/
         NI    DIWNOT1(@10),B'11111101'                            0126
*           BUFCSEG=OFF;            /* RESET SPAN RCD FLAG   @X04SVMR*/
         NI    BUFCSEG(RBUFC),B'10111111'                          0127
*         END;                      /* END OF NON S.R.       @X04SVMR*/
*/*  IF THE DATA SET IS KEYED, CALL INDEX INSERT SO THAT AN ENTRY WILL
*    BE MADE IN THE INDEX TO REFLECT THE LAST CONTROL INTERVAL (THE ONE
*    JUST FILLED).  IF AN ENTRY WILL NOT FIT IN THE SEQUENCE SET,  0129
*    PREVENT THE CONTROL INTERVAL FROM BEING WRITTEN UNTIL A NEW   0129
*    CONTROL AREA HAS BEEN OBTAINED AND THE DATA RBA HAS BEEN RESET. */
*                                                                  0129
*       IF AMDDST='1'B              /* IF DATA SET IS KEYED,         */
*         THEN                      /* AN INDEX INSERT MUST          */
@RF00124 L     @10,AMBDSB(,RAMB)                                   0129
         TM    AMDDST(@10),B'10000000'                             0129
         BNO   @RF00129                                            0129
*         DO;                       /* BE DONE                       */
*           RPARM1=ZERO;            /* INDICATE INDEX INSERT         */
         SLR   RPARM1,RPARM1                                       0131
*I01:                                                              0132
*           DO;                     /* IDACALL(IDA019RG)             */
I01      DS    0H                                                  0133
*             CALL IDA019RG;        /* EXIT TO IDA019RG              */
         L     @15,@CV00885                                        0133
         BALR  @14,@15                                             0133
*             GEN(BALR @11,0);      /* LOAD ADDR OF REENTRY          */
         BALR @11,0
*             GEN(USING *,@11);     /* ESTABLISH ADDRESSING          */
         USING *,@11
*             GEN(L     @11,=A(@PSTART));/* RELOAD BASE              */
         L     @11,=A(@PSTART)
*             GEN(USING @PSTART,@11);/* ESTABLISH ADDRESSING         */
         USING @PSTART,@11
*           END I01;                /* INSERT INDEX ENTRY            */
*           RBUFC=PLHDBUFC;         /* POINT TO DATA BUFC            */
         L     RBUFC,PLHDBUFC(,RPLH)                               0139
*           RFY                                                    0140
*             R15 RSTD;             /* SAVE RETURN CODE              */
*           IF R15^=ZERO            /* IF ENTRY WILL NOT FIT,        */
*             THEN                  /* TRY NEW CONTROL AREA          */
*                                                                  0141
         LTR   R15,R15                                             0141
         BZ    @RF00141                                            0141
*             /*******************************************************/
*             /*                                                     */
*             /* SEGMENT(IXNOFIT)REQUEST                             */
*             /*                                                     */
*             /*******************************************************/
*                                                                  0142
*             DO;                                                  0142
*               GOTO IXNOFIT;                                      0143
         B     IXNOFIT                                             0143
*IXNOFIT#:                                                         0144
*             END;                                                 0144
IXNOFIT# DS    0H                                                  0145
*           RFY                                                    0145
*             R15 UNRSTD;           /* DROP RETURN REG       @X04SVMR*/
@RF00141 DS    0H                                                  0146
*         END;                      /* END OF INDEX INSERT           */
*     END;                          /* END--NON-S.R./LAST    @X04SVMR*/
*                                                                  0147
*   /*****************************************************************/
*   /*                                                               */
*   /* HERE IF FIRST OR MIDDLE SPANNED RCD SEG IS IN BUFFER  @X04SVMR*/
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0148
*   ELSE                            /* RDF1ST IS ON          @X04SVMR*/
*     DO;                                                          0148
         B     @RC00121                                            0148
@RF00121 DS    0H                                                  0149
*       IF RDFNOT1=OFF THEN         /* SEE IF 1ST SEG        @X04SVMR*/
*                                                                  0149
         L     @10,PLHRDFP(,RPLH)                                  0149
         TM    RDFNOT1(@10),B'00100000'                            0149
         BNZ   @RF00149                                            0149
*         /***********************************************************/
*         /*                                                         */
*         /* SEGMENT(SEG1ST)REQUEST                                  */
*         /*                                                         */
*         /***********************************************************/
*                                                                  0150
*         DO;                                                      0150
*           GOTO SEG1ST;                                           0151
         B     SEG1ST                                              0151
*SEG1ST#:                                                          0152
*         END;                                                     0152
SEG1ST#  DS    0H                                                  0153
*     END;                          /* END--1ST/MIDDLE SEG   @X04SVMR*/
@RF00149 DS    0H                                                  0154
*   RFY                                                            0154
*    (RWORK1,                                                      0154
*     RWORK2) UNRSTD;               /* DROP WORK REGS        @X04SVMR*/
*                                                                  0154
@RC00121 DS    0H                                                  0155
*   /*****************************************************************/
*   /*                                                               */
*   /* SEGMENT(GETCI)REQUEST                                         */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0155
*   DO;                                                            0155
*     GOTO GETCI;                                                  0156
         B     GETCI                                               0156
*GETCI#:                                                           0157
*   END;                                                           0157
*                                                                  0157
GETCI#   DS    0H                                                  0158
*/*        UPDATE THE HIGH DATA AND KEY POINTERS                   0158
*    FOR SPEED OR CSDS POINT TO THE CONTROL INTERVAL PAST THE LAST 0158
*    ONE WHICH WILL HAVE DATA IN IT.  IF KSDS, UPDATE THE HIGH KEY 0158
*    CONTROL INTERVAL POINTER.                                       */
*                                                                  0158
*UPDARDB:                                                          0158
*   IF AMBSPEED=ON|                 /* IF SPEED OPTION OR            */
*       AMDDST='0'B THEN            /* IF A CSDS, SET                */
UPDARDB  TM    AMBSPEED(RAMB),B'00001000'                          0158
         BO    @RT00158                                            0158
         L     @10,AMBDSB(,RAMB)                                   0158
         TM    AMDDST(@10),B'10000000'                             0158
         BNZ   @RF00158                                            0158
@RT00158 DS    0H                                                  0159
*     ARDHRBA=BUFCORBA+AMDCINV;     /* NEW HIGH RBA                  */
         L     @10,PLHARDB(,RPLH)                                  0159
         L     @05,AMBDSB(,RAMB)                                   0159
         L     @00,BUFCORBA(,RBUFC)                                0159
         AL    @00,AMDCINV(,@05)                                   0159
         ST    @00,ARDHRBA(,@10)                                   0159
*   IF AMDDST='1'B THEN             /* IF KEYED DATA SET,    @X04SVMR*/
@RF00158 L     @10,AMBDSB(,RAMB)                                   0160
         TM    AMDDST(@10),B'10000000'                             0160
         BNO   @RF00160                                            0160
*     ARDHKRBA=BUFXIRBA;            /* MAINTAIN HIGH KEY RBA @X04SVMR*/
         L     @10,PLHARDB(,RPLH)                                  0161
         L     @05,BUFXIRBA(,RBUFC)                                0161
         ST    @05,ARDHKRBA(,@10)                                  0161
*   AMDASPA=AMDASPA-AMDCINV;        /* DECREMENT AVAILABLE SPACE     */
@RF00160 L     @10,AMBDSB(,RAMB)                                   0162
         L     @05,AMDASPA(,@10)                                   0162
         SL    @05,AMDCINV(,@10)                                   0162
         ST    @05,AMDASPA(,@10)                                   0162
*CISPLITX:                                                         0163
*   GEN(IDARST14);                  /* RESTORE RETURN REG            */
CISPLITX IDARST14
*   RETURN;                         /* RETURN TO CALLER              */
@EL00001 DS    0H                                                  0164
@EF00001 DS    0H                                                  0164
@ER00001 BR    @14                                                 0164
*                                                                  0165
*/*  EOCA -- FINISH A CONTROL AREA AND PREPARE THE NEXT CONTROL AREA */
*/*          IN PHYSICAL SEQUENCE.                                   */
*/* FUNCTION - (1)WRITE DATA, (2)WRITE INDEX, (3)IF SPEED, PAD OLD   */
*/* CONTROL AREA, (4)GET NEXT CONTROL AREA RBA, (5)IF RECOVERY,      */
*/* PREFORMAT NEW CNTL AREA, AND (6)SET WRITE CONDITION FOR NEW RBA. */
*/* INPUT - BUFCORBA = LAST RBA USED FOR OUTPUT,                     */
*/* DIWSAVE5 = NUMBER OF FREE CONTROL INTERVALS LEFT IN              */
*/* OLD CONTROL AREA, DIWSAVE3 = RBA OF NEXT CONTROL AREA, AND       */
*/* RBUFC = PLHDBUFC.                                                */
*/* OUTPUT - BUFCORBA IS SET, AND PREFORMAT DONE.                    */
*                                                                  0165
*EOCA:                                                             0165
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);/* HERE TO GET NEW CA            */
EOCA     DS    0H                                                  0166
*   GEN(IDASVR14);                  /* SAVE RETURN REGISTER          */
*                                                                  0166
         IDASVR14
*   /*****************************************************************/
*   /*                                                               */
*   /* WRITE OUT RECORDS REMAINING IN OLD CONTROL AREA               */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0167
*I05:                                                              0167
*   DO;                             /* IDACALL(IDAWRBFR)             */
I05      DS    0H                                                  0168
*     CALL IDAWRBFR;                /* EXIT TO IDAWRBFR              */
         L     @15,@CV00884                                        0168
         BALR  @14,@15                                             0168
*     GEN(BALR @11,0);              /* LOAD ADDR OF REENTRY          */
         BALR @11,0
*     GEN(USING *,@11);             /* ESTABLISH ADDRESSING          */
         USING *,@11
*     GEN(L     @11,=A(@PSTART));   /* RELOAD BASE                   */
         L     @11,=A(@PSTART)
*     GEN(USING @PSTART,@11);       /* ESTABLISH ADDRESSING          */
         USING @PSTART,@11
*   END I05;                                                       0173
*   IF RPLERREG^='00'X THEN         /* IF AN ERROR OCCURRED,         */
         CLI   RPLERREG(RRPL),0                                    0174
         BNE   @RT00174                                            0174
*     GO TO EOCAX;                  /* EXIT                          */
*   PLHFRCNT=ZERO;                  /* INDICATE NO MW BUFFERS        */
*                                                                  0176
         MVI   PLHFRCNT(RPLH),X'00'                                0176
*   /*****************************************************************/
*   /*                                                               */
*   /* BEFORE LEAVING THE OLD CONTROL AREA, IF IT IS THE SPEED OPTION*/
*   /* AND IF THERE IS FREE SPACE LEFT IN THE CONTROL AREA, IT MUST  */
*   /* BE PADDED WITH FREE SPACE CONTROL INTERVALS                   */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0177
*   IF(AMBSPEED=ON|                 /* IF SPEED OPTION OR IF         */
*       AMDDST='0'B)&               /* ESDS AND              @X04SVMR*/
*       (DIWSAVE5^=ZERO|            /* FREE SPACE WILL BE LEFT       */
*       (DIWEOKR=ON&                /* OR END OF KEY RANGE   @OZA7543*/
*       ARDHRBA^=ARDERBA))          /* AND NOT END OF EXTENT @OZA7543*/
*     THEN                          /* IN THE OLD CA, IT MUST        */
         TM    AMBSPEED(RAMB),B'00001000'                          0177
         BO    @GL00004                                            0177
         L     @10,AMBDSB(,RAMB)                                   0177
         TM    AMDDST(@10),B'10000000'                             0177
         BNZ   @RF00177                                            0177
@GL00004 L     @10,AMBIWA(,RAMB)                                   0177
         L     @05,DIWSAVE5(,@10)                                  0177
         LTR   @05,@05                                             0177
         BNZ   @RT00177                                            0177
         TM    DIWEOKR(@10),B'00010000'                            0177
         BNO   @RF00177                                            0177
         L     @10,PLHARDB(,RPLH)                                  0177
         CLC   ARDHRBA(4,@10),ARDERBA(@10)                         0177
         BE    @RF00177                                            0177
@RT00177 DS    0H                                                  0178
*     DO;                           /* BE PADDED                     */
*       RPARM1=BUFCORBA+AMDCINV;    /* GET THE RBA OF 1ST PAD        */
         L     @10,AMBDSB(,RAMB)                                   0179
         L     RPARM1,BUFCORBA(,RBUFC)                             0179
         AL    RPARM1,AMDCINV(,@10)                                0179
*       DIWFSPF=ON;                 /* FORCE FS WRITE        @X04SVMR*/
*                                                                  0180
         L     @10,AMBIWA(,RAMB)                                   0180
         OI    DIWFSPF(@10),B'10000000'                            0180
*       /*************************************************************/
*       /*                                                           */
*       /* CALL THE PREFORMAT ROUTINE TO PAD OUT THE OLD CA          */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0181
*I06:                                                              0181
*       DO;                         /* IDACALL(IDA019RK)             */
I06      DS    0H                                                  0182
*         CALL IDA019RK;            /* EXIT TO IDA019RK              */
         L     @15,@CV00886                                        0182
         BALR  @14,@15                                             0182
*         GEN(BALR @11,0);          /* LOAD ADDR OF REENTRY          */
         BALR @11,0
*         GEN(USING *,@11);         /* ESTABLISH ADDRESSING          */
         USING *,@11
*         GEN(L     @11,=A(@PSTART));/* RELOAD BASE                  */
         L     @11,=A(@PSTART)
*         GEN(USING @PSTART,@11);   /* ESTABLISH ADDRESSING          */
         USING @PSTART,@11
*       END I06;                                                   0187
*       DIWFSPF=OFF;                /* RESET FLAG            @X04SVMR*/
         L     @10,AMBIWA(,RAMB)                                   0188
         NI    DIWFSPF(@10),B'01111111'                            0188
*       IF RPLERREG^='00'X          /* SEE IF ANY ERRORS             */
*         THEN                      /* EXIT IF SO                    */
         CLI   RPLERREG(RRPL),0                                    0189
         BNE   @RT00189                                            0189
*         GO TO EOCAX;              /* EXIT FROM MODULE              */
*     END;                          /* END OF PAD OLD CA             */
*   RBUFC=PLHDBUFC;                 /* GET CURRENT BUFC              */
@RF00177 L     RBUFC,PLHDBUFC(,RPLH)                               0192
*   BUFCORBA=DIWSAVE3;              /* SET NEW OUTPUT RBA            */
         L     @10,AMBIWA(,RAMB)                                   0193
         L     @05,DIWSAVE3(,@10)                                  0193
         ST    @05,BUFCORBA(,RBUFC)                                0193
*   BUFXIRBA=BUFCORBA;              /* SET EXCL CNTL RBA     @X04SVMR*/
         ST    @05,BUFXIRBA(,RBUFC)                                0194
*   BUFXORBA=BUFCORBA;              /* SET EXCL CNTL RBA     @ZA17187*/
         ST    @05,BUFXORBA(,RBUFC)                                0195
*   BUFCDDDD=BUFCORBA;              /* SET FOR LOOK-ASIDE    @X04SVMR*/
         ST    @05,BUFCDDDD(,RBUFC)                                0196
*   BUFCEXC=ON;                     /* GET EXCL CONTROL      @X04SVMR*/
*   BUFCVAL=ON;                     /* RBA IS VALID          @X04SVMR*/
         OI    BUFCEXC(RBUFC),B'00000110'                          0198
*   IF DIWEOKR=ON THEN              /* IF END OF KEY RANGE,          */
         TM    DIWEOKR(@10),B'00010000'                            0199
         BNO   @RF00199                                            0199
*     PLHARDB=ARDNPTR;              /* GO TO NEW ARDB                */
*                                                                  0200
         L     @10,PLHARDB(,RPLH)                                  0200
         L     @10,ARDNPTR(,@10)                                   0200
         ST    @10,PLHARDB(,RPLH)                                  0200
*   /*****************************************************************/
*   /*                                                               */
*   /* IF THE DATA SET IS KEYED, IT IS NECESSARY TO WRITE OUT THE    */
*   /* INDEX FOR THE OLD CONTROL AREA AND TO INITIALIZE THE INDEX FOR*/
*   /* THE NEW CONTROL AREA.                                         */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0201
*   IF AMDDST='1'B                  /* IF DATA SET IS KEYED,         */
*     THEN                          /* AN INDEX MUST BE WRIT-        */
@RF00199 L     @10,AMBDSB(,RAMB)                                   0201
         TM    AMDDST(@10),B'10000000'                             0201
         BNO   @RF00201                                            0201
*     DO;                           /* TEN                           */
*       RPARM1=IXWRITE;             /* INDICATE AN INDEX WRITE       */
         LA    RPARM1,4                                            0203
*I07:                                                              0204
*       DO;                         /* IDACALL(IDA019RG)             */
I07      DS    0H                                                  0205
*         CALL IDA019RG;            /* EXIT TO IDA019RG              */
         L     @15,@CV00885                                        0205
         BALR  @14,@15                                             0205
*         GEN(BALR @11,0);          /* LOAD ADDR OF REENTRY          */
         BALR @11,0
*         GEN(USING *,@11);         /* ESTABLISH ADDRESSING          */
         USING *,@11
*         GEN(L     @11,=A(@PSTART));/* RELOAD BASE                  */
         L     @11,=A(@PSTART)
*         GEN(USING @PSTART,@11);   /* ESTABLISH ADDRESSING          */
         USING @PSTART,@11
*       END I07;                                                   0210
*       RFY                                                        0211
*         R15 RSTD;                 /* GET RETURN REG        @X04SVMR*/
*       IF R15^=ZERO                /* IF AN I/O ERROR OCCUR-        */
*         THEN                      /* RED, EXIT FROM MODULE.        */
         LTR   R15,R15                                             0212
         BZ    @RF00212                                            0212
*         DO;                                                      0213
*           RFY                                                    0214
*             R15 UNRSTD;           /* DROP RETURN REG       @X04SVMR*/
*EOCAX:                                                            0215
*           GEN(IDARST14);          /* CAUSE DATA INSERT RETURN      */
EOCAX    IDARST14
*           DIWEOKR=OFF;            /* RESET BIT                     */
         L     @10,AMBIWA(,RAMB)                                   0216
         NI    DIWEOKR(@10),B'11101111'                            0216
*           GO TO EOCAOUT;          /* EXIT                          */
         B     EOCAOUT                                             0217
*         END;                      /* END OF ERROR CODE             */
*     END;                          /* END OF INDEX WRITE            */
@RF00212 DS    0H                                                  0220
*   RBUFC=PLHDBUFC;                 /* PTR TO CURRENT BUFC           */
*                                                                  0220
@RF00201 L     RBUFC,PLHDBUFC(,RPLH)                               0220
*   /*****************************************************************/
*   /*                                                               */
*   /* IF IT IS NOT A SPEED CREATE (RECOVERY MODE) IT IS NECESSARY TO*/
*   /* PREFORMAT A NEW CONTROL AREA BEFORE WRITING OVER THE END OF   */
*   /* DATA CONTROL INTERVAL. THIS IS NECESSARY BECAUSE AN END OF    */
*   /* DATA MUST ALWAYS BE PRESENT TO ENABLE VERIFICATION OF THE DATA*/
*   /* SET IN THE EVENT IT IS NOT PROPERLY CLOSED.                   */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0221
*   IF AMBSPEED=OFF|                /* IF RECOVERY WAS SET OR        */
*       PLHENDRQ=ON                 /* CLOSE IS FORCING EOKR,        */
*     THEN                          /* PREFORMAT OF ONE CA           */
         TM    AMBSPEED(RAMB),B'00001000'                          0221
         BZ    @RT00221                                            0221
         TM    PLHENDRQ(RPLH),B'01000000'                          0221
         BNO   @RF00221                                            0221
@RT00221 DS    0H                                                  0222
*     DO;                                                          0222
*       RPARM1=BUFCORBA;            /* POINT TO NEXT CA RBA          */
         L     RPARM1,BUFCORBA(,RBUFC)                             0223
*       IF ARDHRBA<=RPARM1          /* IF NOT YET PREFORMATTED       */
*         THEN                      /* THEN PREFORMAT CA             */
         L     @10,PLHARDB(,RPLH)                                  0224
         CL    RPARM1,ARDHRBA(,@10)                                0224
         BL    @RF00224                                            0224
*         DO;                                                      0225
*                                                                  0225
*           /*********************************************************/
*           /*                                                       */
*           /* PREFORMAT THE NEXT CONTROL AREA                       */
*           /*                                                       */
*           /*********************************************************/
*                                                                  0226
*I08:                                                              0226
*           DO;                     /* IDACALL(IDA019RK)             */
I08      DS    0H                                                  0227
*             CALL IDA019RK;        /* EXIT TO IDA019RK              */
         L     @15,@CV00886                                        0227
         BALR  @14,@15                                             0227
*             GEN(BALR @11,0);      /* LOAD ADDR OF REENTRY          */
         BALR @11,0
*             GEN(USING *,@11);     /* ESTABLISH ADDRESSING          */
         USING *,@11
*             GEN(L     @11,=A(@PSTART));/* RELOAD BASE              */
         L     @11,=A(@PSTART)
*             GEN(USING @PSTART,@11);/* ESTABLISH ADDRESSING         */
         USING @PSTART,@11
*           END I08;                                               0232
*           IF RPLERREG^='00'X THEN /* IF PREFORMAT ERROR,           */
         CLI   RPLERREG(RRPL),0                                    0233
         BNE   @RT00233                                            0233
*             GO TO EOCAX;          /* MUST EXIT                     */
*           RBUFC=PLHDBUFC;         /* RESET DATA BUFC PTR           */
         L     RBUFC,PLHDBUFC(,RPLH)                               0235
*           ARDHRBA=RPARM1;         /* SET NEW HIGH RBA              */
         L     @10,PLHARDB(,RPLH)                                  0236
         ST    RPARM1,ARDHRBA(,@10)                                0236
*         END;                      /* END OF PREFORMAT CODE         */
*     END;                          /* END, NON SPEED/CREATE         */
@RF00224 DS    0H                                                  0239
*/*  INDICATE THAT THE DATA BUFFER IS TO BE WRITTEN                  */
*                                                                  0239
*   BUFCMW=ON;                      /* SET MUST WRITE ON AGAIN       */
@RF00221 OI    BUFCMW(RBUFC),B'10000000'                           0239
*EOCAOUT:                                                          0240
*   GEN(IDARST14);                  /* RESTORE RETURN REGISTER       */
EOCAOUT  IDARST14
*   END EOCA;                       /* END OF EOCA CODE              */
@EL00002 DS    0H                                                  0241
@EF00002 DS    0H                                                  0241
@ER00002 BR    @14                                                 0241
*                                                                  0242
*/*                            GETSPACE                              */
*/*  FUNCTION = ENSURE ENOUGH SPACE FOR A NEW DATA CONTROL AREA.     */
*/*  INPUT = DIWSAVE3 IS THE RBA OF NEXT CONTROL AREA TO BE NEEDED,  */
*/*          RAMB IS THE DATA AMB.                                   */
*/*  OUTPUT = DIWSAVE3 IS THE RBA OF THE NEXT AVAILABLE CONTROL AREA */
*/*          AND ARDHRBA IS UPDATED FOR THE RECOVERY OPTION.         */
*                                                                  0242
*GETSPACE:                                                         0242
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);                               0242
GETSPACE DS    0H                                                  0243
*   RFY                                                            0243
*     R14 RSTD;                     /* SAVE RETURN REGISTER          */
*                                                                  0243
*   /*****************************************************************/
*   /*                                                               */
*   /* CHECK FOR AN END OF EXTENT CONDITION. IF THE NEW CONTROL AREA */
*   /* MATCHES THE ENDING RBA OF THE EXTENT, IT IS NECESSARY TO CALL */
*   /* END-OF-VOLUME IN ORDER TO ALLOCATE ANOTHER EXTENT. IF A NEW   */
*   /* EXTENT CAN NOT BE ALLOCATED, A NO SPACE FOUND CONDITION IS SET*/
*   /* IN THE RPL AND A RETURN IS MADE TO DATA INSERT.               */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0244
*   IF DIWSAVE3>=ARDERBA            /* SEE IF END OF ALLOC SP        */
*     THEN                          /* IF SO, COME HERE              */
         L     @15,AMBIWA(,RAMB)                                   0244
         L     @10,PLHARDB(,RPLH)                                  0244
         CLC   DIWSAVE3(4,@15),ARDERBA(@10)                        0244
         BL    @RF00244                                            0244
*     DO;                                                          0245
*       GEN(IDASVR14);              /* SAVE RETURN REGISTER          */
         IDASVR14
*       PLHEOVR=AMBEOVAR;           /* SET ALLOC BY RBA              */
         MVI   PLHEOVR(RPLH),B'10000010'                           0247
*       PLHEOVPT=ADDR(ARDERBA);     /* POINT TO CURR RBA             */
         L     @15,PLHARDB(,RPLH)                                  0248
         LA    @15,ARDERBA(,@15)                                   0248
         ST    @15,PLHEOVPT(,RPLH)                                 0248
*I09:                                                              0249
*       DO;                         /* IDACALL(IDAEOVIF)             */
I09      DS    0H                                                  0250
*         CALL IDAEOVIF;            /* EXIT TO IDAEOVIF              */
         L     @15,@CV00880                                        0250
         BALR  @14,@15                                             0250
*         GEN(BALR @11,0);          /* LOAD ADDR OF REENTRY          */
         BALR @11,0
*         GEN(USING *,@11);         /* ESTABLISH ADDRESSING          */
         USING *,@11
*         GEN(L     @11,=A(@PSTART));/* RELOAD BASE                  */
         L     @11,=A(@PSTART)
*         GEN(USING @PSTART,@11);   /* ESTABLISH ADDRESSING          */
         USING @PSTART,@11
*       END I09;                    /* TRY TO GET MORE SPACE         */
*       GEN(IDARST14);              /* EXIT FROM MODULE              */
         IDARST14
*       IF RPLERREG^='00'X          /* IF SPACE COULD NOT BE         */
*         THEN                      /* OBTAINED, EXIT.               */
         CLI   RPLERREG(RRPL),0                                    0257
         BE    @RF00257                                            0257
*         DO;                                                      0258
*           PLHNOSPC=ON;            /* NO SPACE--CREATE MODE         */
         OI    PLHNOSPC(RPLH),B'10000000'                          0259
*           GEN(IDARST14);          /* EXIT FROM MODULE              */
         IDARST14
*           RETURN;                 /* RETURN TO DATA INSERT         */
@EL00003 DS    0H                                                  0261
@EF00003 DS    0H                                                  0261
@ER00003 BR    @14                                                 0261
*         END;                      /* END OF EOV ERROR CODE         */
*       RBUFC=PLHDBUFC;             /* RESTORE BUFC PTR              */
@RF00257 L     RBUFC,PLHDBUFC(,RPLH)                               0263
*       PLHNOSPC=OFF;               /* EOV WAS SUCCESSFUL            */
         NI    PLHNOSPC(RPLH),B'01111111'                          0264
*       DIWSAVE3=ARDHRBA;           /* POINT TO NEXT RBA             */
         L     @15,AMBIWA(,RAMB)                                   0265
         L     @10,PLHARDB(,RPLH)                                  0265
         L     @05,ARDHRBA(,@10)                                   0265
         ST    @05,DIWSAVE3(,@15)                                  0265
*       IF AMBSPEED=OFF THEN        /* FOR RECOVERY CREATE           */
         TM    AMBSPEED(RAMB),B'00001000'                          0266
         BNZ   @RF00266                                            0266
*         ARDHRBA=ARDHRBA+AMDCINV*AMDCIPCA;/* SET SEOF PTR           */
         L     @15,AMBDSB(,RAMB)                                   0267
         L     @00,AMDCINV(,@15)                                   0267
         MH    @00,AMDCIPCA(,@15)                                  0267
         ALR   @05,@00                                             0267
         ST    @05,ARDHRBA(,@10)                                   0267
*     END;                          /* END OF EOV CALL CODE          */
*   END GETSPACE;                   /* END OF GET SPACE CODE         */
         B     @EL00003                                            0269
*                                                                  0270
*/*   BUILDFS -- BUILD A FREE SPACE CONTROL INTERVAL                 */
*/* FUNCTION - BUILD ONE CONTROL OF FREE SPACE IN A DATA BUFFER      */
*/* INPUT - RBUFC POINTS TO A DATA BUFC                              */
*/* OUTPUT - WORK REGISTERS ARE ALTERED AND  A FREE SPACE CINV IS    */
*/*          CREATED IN THE DESIRED BUFFER.  RWORK1 = ADDR(CIDF).    */
*                                                                  0270
*BUILDFS:                                                          0270
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);                               0270
BUILDFS  DS    0H                                                  0271
*   RFY                                                            0271
*    (RWORK1,                                                      0271
*     RWORK2,                                                      0271
*     RWORK3,                                                      0271
*     RWORK4,                                                      0271
*     RWORK5) RSTD;                 /* GET WORK REGS                 */
*   RWORK2=BUFCBAD;                 /* POINT TO CINV                 */
         L     RWORK2,BUFCBAD(,RBUFC)                              0272
*   RWORK3=AMDCINV;                 /* GET LENGTH                    */
         L     @15,AMBDSB(,RAMB)                                   0273
         L     RWORK3,AMDCINV(,@15)                                0273
*   RWORK5=ZERO;                    /* GET PROPAGATION               */
         SLR   RWORK5,RWORK5                                       0274
*   GEN SETS(RWORK2,RWORK3,RWORK4,RWORK5)(MVCL  RWORK2,RWORK4);/*  0275
*                                      ZERO                          */
         MVCL  RWORK2,RWORK4
*   RWORK1=BUFCBAD+AMDCINV-LENGTH(IDACIDF);/* POINT TO CIDF          */
         LA    @15,4                                               0276
         L     @10,AMBDSB(,RAMB)                                   0276
         L     @10,AMDCINV(,@10)                                   0276
         L     RWORK1,BUFCBAD(,RBUFC)                              0276
         ALR   RWORK1,@10                                          0276
         SLR   RWORK1,@15                                          0276
*   RWORK1->CIDFLL=AMDCINV-LENGTH(IDACIDF);/* SET FREE SPACE         */
         SLR   @10,@15                                             0277
         STH   @10,CIDFLL(,RWORK1)                                 0277
*   RFY                                                            0278
*    (RWORK4,                                                      0278
*     RWORK5) UNRSTD;               /* RELEASE WORK REGISTERS        */
*   END BUILDFS;                    /* FS CINV BUILT                 */
@EL00004 DS    0H                                                  0279
@EF00004 DS    0H                                                  0279
@ER00004 BR    @14                                                 0279
*                                                                  0280
*/*  INDEX ENTRY DID NOT FIT.  MUST CHANGE RBA OF CI IF IT WAS NOT   */
*/*  SPANNED OR IF IT WAS THE FIRST SEGMENT OF A SPANNED RECORD.  IF */
*/*  THE LAST RECORD WAS SPANNED AND ITS ENTRY DOES NOT FIT SOME OF  */
*/*  ITS CONTROL INTERVALS HAVE ALREADY BEEN WRITTEN PROBABLY.  IN   */
*/*  THIS CASE ALLOW THE REMAINING SEGMENT TO BE WRITTEN AND THEN    */
*/*  MOVE THE ENTIRE SPANNED RECORD TO THE NEW CONTROL AREA.         */
*                                                                  0280
*   /*****************************************************************/
*   /*                                                               */
*   /* SEGMENT(IXNOFIT)START                                         */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0280
*   DO;                                                            0280
*     GOTO IXNOFIT@;                                               0281
*IXNOFIT:                                                          0282
*   END;                            /* INDEX ENTRY DID NOT FIT       */
IXNOFIT  DS    0H                                                  0283
*   RFY                                                            0283
*     R15 UNRSTD;                   /* DROP RETURN REG       @X04SVMR*/
*   RFY                                                            0284
*     IDARDF BASED(PLHRDFP);        /* RESET RDF BASE        @X04SVMR*/
*   DIWGSPC=OFF;                    /* INDICATE SPACE GOT    @X04SVMR*/
         L     @15,AMBIWA(,RAMB)                                   0285
         NI    DIWGSPC(@15),B'11110111'                            0285
*   CALL GETSPACE;                  /* MAKE SURE CA AVAILABLE        */
         BAL   @14,GETSPACE                                        0286
*   IF RDFNOT1=OFF THEN             /* IF NON-S.R. DO NOT    @X04SVMR*/
         L     @15,PLHRDFP(,RPLH)                                  0287
         TM    RDFNOT1(@15),B'00100000'                            0287
         BNZ   @RF00287                                            0287
*     DO;                           /* WRITE IT IN OLD CA.   @X04SVMR*/
*                                                                  0288
*       /*************************************************************/
*       /*                                                           */
*       /* INDICATE THAT THE LAST RECORD IN THE CONTROL AREA IS PRIOR*/
*       /* TO THE ONE TO BE MOVED AND THAT SPACE IS LEFT IN THE      */
*       /* CONTROL AREA SO THAT PADDING WILL OCCUR IF NECESSARY.     */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0289
*       IF AMBJRN=ON THEN           /* SAVE RBA TO BE SHIFTED        */
         TM    AMBJRN(RAMB),B'00000010'                            0289
         BNO   @RF00289                                            0289
*         PLHJORBA=BUFCORBA;        /* FOR THE JOURNAL EXIT.         */
         L     @15,BUFCORBA(,RBUFC)                                0290
         ST    @15,PLHJORBA(,RPLH)                                 0290
*       BUFCORBA=BUFCORBA-AMDCINV;  /* BACK UP ONE CINV              */
@RF00289 L     @15,AMBDSB(,RAMB)                                   0291
         L     @10,BUFCORBA(,RBUFC)                                0291
         SL    @10,AMDCINV(,@15)                                   0291
         ST    @10,BUFCORBA(,RBUFC)                                0291
*       DIWSAVE5=ONE+DIWSAVE5;      /* ONE MORE CINV IN CA           */
         L     @15,AMBIWA(,RAMB)                                   0292
         LA    @10,1                                               0292
         AL    @10,DIWSAVE5(,@15)                                  0292
         ST    @10,DIWSAVE5(,@15)                                  0292
*       BUFCVAL=OFF;                /* RBA NOT VALID         @X04SVMR*/
         NI    BUFCVAL(RBUFC),B'11111011'                          0293
*       ARDHKRBA=DIWSAVE3;          /* SET HIGH KEY RBA AS RBA OF NEW
*                                      CA                    @ZA02289*/
         L     @10,PLHARDB(,RPLH)                                  0294
         L     @15,DIWSAVE3(,@15)                                  0294
         ST    @15,ARDHKRBA(,@10)                                  0294
*       BUFCMW=OFF;                 /* DATA CINV WILL GO ELSE-       */
         NI    BUFCMW(RBUFC),B'01111111'                           0295
*       CALL EOCA;                  /* WHERE--DONT WRITE IT          */
*                                                                  0296
         BAL   @14,EOCA                                            0296
*       /*************************************************************/
*       /*                                                           */
*       /* IF JOURNALING IS BEING DONE, NOTIFY USER OF RBA CHANGE    */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0297
*       IF AMBJRN=ON                /* SEE IF A JOURNAL EXIT         */
*         THEN                      /* WAS SPECIFIED.                */
         TM    AMBJRN(RAMB),B'00000010'                            0297
         BNO   @RF00297                                            0297
*         DO;                                                      0298
*           PLHJCODE=PLHJRBAC;      /* RBA CHANGE CODE               */
         MVI   PLHJCODE(RPLH),B'00001100'                          0299
*           PLHJNRBA=DIWSAVE3;      /* SET NEW RBA                   */
         L     @15,AMBIWA(,RAMB)                                   0300
         L     @15,DIWSAVE3(,@15)                                  0300
         ST    @15,PLHJNRBA(,RPLH)                                 0300
*           PLHJRNLL=PLHRECP-BUFCBAD;/* SET LENGTH OF DATA           */
         L     @15,PLHRECP(,RPLH)                                  0301
         SL    @15,BUFCBAD(,RBUFC)                                 0301
         ST    @15,PLHJRNLL(,RPLH)                                 0301
*I11:                                                              0302
*           DO;                     /* IDACALL(IDATJXIT)             */
I11      DS    0H                                                  0303
*             CALL IDATJXIT;        /* EXIT TO IDATJXIT              */
         L     @15,@CV00883                                        0303
         BALR  @14,@15                                             0303
*             GEN(BALR @11,0);      /* LOAD ADDR OF REENTRY          */
         BALR @11,0
*             GEN(USING *,@11);     /* ESTABLISH ADDRESSING          */
         USING *,@11
*             GEN(L     @11,=A(@PSTART));/* RELOAD BASE              */
         L     @11,=A(@PSTART)
*             GEN(USING @PSTART,@11);/* ESTABLISH ADDRESSING         */
         USING @PSTART,@11
*           END I11;                /* TAKE JOURNAL EXIT             */
*         END;                      /* END OF JOURNAL EXIT           */
*       DIWSAVE5=AMDCIPCA-ONE;      /* RESET FREE CINV COUNT         */
@RF00297 L     @15,AMBIWA(,RAMB)                                   0310
         L     @10,AMBDSB(,RAMB)                                   0310
         LH    @10,AMDCIPCA(,@10)                                  0310
         BCTR  @10,0                                               0310
         ST    @10,DIWSAVE5(,@15)                                  0310
*     END;                          /* END OF NON-SR CODE    @X04SVMR*/
*   ELSE                            /* HERE TO MOVE S.R.     @X04SVMR*/
*                                                                  0312
*     /***************************************************************/
*     /*                                                             */
*     /* SEGMENT(MOVESR)REQUEST                                      */
*     /*                                                             */
*     /***************************************************************/
*                                                                  0312
*     DO;                                                          0312
         B     @RC00287                                            0312
@RF00287 DS    0H                                                  0313
*       GOTO MOVESR;                                               0313
         B     MOVESR                                              0313
*MOVESR#:                                                          0314
*     END;                                                         0314
MOVESR#  DS    0H                                                  0315
*   DIWSAVE3=DIWSAVE3+AMDCINV*AMDCIPCA;/* PT TO NEXT CA BDY          */
@RC00287 L     @15,AMBIWA(,RAMB)                                   0315
         L     @10,AMBDSB(,RAMB)                                   0315
         L     @00,AMDCINV(,@10)                                   0315
         MH    @00,AMDCIPCA(,@10)                                  0315
         AL    @00,DIWSAVE3(,@15)                                  0315
         ST    @00,DIWSAVE3(,@15)                                  0315
*   RPARM1=ZERO;                    /* INDICATE INDEX INSERT         */
         SLR   RPARM1,RPARM1                                       0316
*I13:                                                              0317
*   DO;                             /* IDACALL(IDA019RG)             */
I13      DS    0H                                                  0318
*     CALL IDA019RG;                /* EXIT TO IDA019RG              */
         L     @15,@CV00885                                        0318
         BALR  @14,@15                                             0318
*     GEN(BALR @11,0);              /* LOAD ADDR OF REENTRY          */
         BALR @11,0
*     GEN(USING *,@11);             /* ESTABLISH ADDRESSING          */
         USING *,@11
*     GEN(L     @11,=A(@PSTART));   /* RELOAD BASE                   */
         L     @11,=A(@PSTART)
*     GEN(USING @PSTART,@11);       /* ESTABLISH ADDRESSING          */
         USING @PSTART,@11
*   END I13;                        /* INSERT ENTRY IN INDEX         */
*   RFY                                                            0324
*     R15 RSTD;                     /* GET RETURN CODE       @X04SVMR
*                                      IF ENTRY STILL NOT FITTING, 0324
*                                      INDEX CREATE IS WAITING TO BE
*                                      CALLED AGAIN FROM ENDREQ SO 0324
*                                      THAT IT CAN UPDATE THE DUMMY
*                                      ENTRY AND SET THE BASE RBA  0324
*                                      FROM BUFCORBA                 */
*   RBUFC=PLHDBUFC;                 /* POINT TO CURRENT DBUFC        */
         L     RBUFC,PLHDBUFC(,RPLH)                               0325
*   IF R15^=ZERO THEN               /* IF AN ERROR OCCURRED          */
         LTR   R15,R15                                             0326
         BNZ   @RT00326                                            0326
*     GO TO UPDARDB;                /* ENDREQ WILL CALL AGAIN        */
*                                                                  0327
*   /*****************************************************************/
*   /*                                                               */
*   /* SEGMENT(IXNOFIT)FINISH                                        */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0328
*   DO;                                                            0328
*     GOTO IXNOFIT#;                                               0329
         B     IXNOFIT#                                            0329
*IXNOFIT@:                                                         0330
*   END;                                                           0330
IXNOFIT@ DS    0H                                                  0331
*                                                                  0331
*   /*****************************************************************/
*   /*                                                               */
*   /* HERE IF THE FIRST SEGMENT OF A SPANNED RECORD         @X04SVMR*/
*   /* SEGMENT(SEG1ST)START                                          */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0331
*   DO;                                                            0331
*     GOTO SEG1ST@;                                                0332
         B     SEG1ST@                                             0332
*SEG1ST:                                                           0333
*   END;                            /* FIRST SEGMENT                 */
SEG1ST   DS    0H                                                  0334
*   RFY                                                            0334
*    (RWORK1,                                                      0334
*     RWORK2) RSTD;                 /* GET WORK REGISTERS    @X04SVMR*/
*   DIWNOT1=OFF;                    /* INDICATE 1ST SEGMENT  @X04SVMR*/
*                                                                  0335
         L     @10,AMBIWA(,RAMB)                                   0335
         NI    DIWNOT1(@10),B'11111101'                            0335
*   /*****************************************************************/
*   /*                                                               */
*   /* DETERMINE THE NUMBER OF CONTROL INTERVALS REQUIRED    @X04SVMR*/
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0336
*   RWORK1=PLHNOSEG-ONE;            /* SAVE SEGMENT COUNT    @X04SVMR*/
         LH    RWORK1,PLHNOSEG(,RPLH)                              0336
         BCTR  RWORK1,0                                            0336
*   BUFXIRBA=BUFCORBA;              /* SET EXCL CNTL RBA     @X04SVMR*/
         L     @00,BUFCORBA(,RBUFC)                                0337
         ST    @00,BUFXIRBA(,RBUFC)                                0337
*   RWORK2=DIWSAVE5-AMDFSCA;        /* GET NO OF CIS TIL FS  @X04SVMR*/
*                                                                  0338
         L     @10,DIWSAVE5(,@10)                                  0338
         L     @09,AMBDSB(,RAMB)                                   0338
         LR    RWORK2,@10                                          0338
         SH    RWORK2,AMDFSCA(,@09)                                0338
*   /*****************************************************************/
*   /*                                                               */
*   /* IF THERE ARE NOT ENOUGH CIS LEFT IN THE CA OR IF USING THIS CA*/
*   /* WOULD CAUSE A POORER USAGE OF THE FREE SPACE QUANTITY, GET A  */
*   /* NEW CA UNLESS TO DO SO WOULD CAUSE A CONTROL AREA TO BE       */
*   /* COMPLETELY EMPTY.                                     @X04SVMR*/
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0339
*   IF RWORK1>DIWSAVE5|(RWORK1>=TWO*RWORK2&AMDCIPCA^=DIWSAVE5) THEN/*
*                                      READY FOR NEW CA      @X04SVMR*/
         CR    RWORK1,@10                                          0339
         BH    @RT00339                                            0339
         LR    @00,RWORK2                                          0339
         ALR   @00,@00                                             0339
         CLR   RWORK1,@00                                          0339
         BL    @RF00339                                            0339
         CH    @10,AMDCIPCA(,@09)                                  0339
         BE    @RF00339                                            0339
@RT00339 DS    0H                                                  0340
*     DO;                           /*                       @X04SVMR*/
*       DIWGSPC=OFF;                /* INDICATE SPACE GOT    @X04SVMR*/
         L     @10,AMBIWA(,RAMB)                                   0341
         NI    DIWGSPC(@10),B'11110111'                            0341
*       CALL GETSPACE;              /* GET NEW CA            @X04SVMR*/
         BAL   @14,GETSPACE                                        0342
*       PLHJORBA=BUFCORBA;          /* SAVE ORIGINAL RBA     @X04SVMR*/
         L     @10,BUFCORBA(,RBUFC)                                0343
         ST    @10,PLHJORBA(,RPLH)                                 0343
*       BUFCORBA=BUFCORBA-AMDCINV;  /* BACK UP ONE CINV      @X04SVMR*/
         L     @09,AMBDSB(,RAMB)                                   0344
         L     @09,AMDCINV(,@09)                                   0344
         SLR   @10,@09                                             0344
         ST    @10,BUFCORBA(,RBUFC)                                0344
*       DIWSAVE5=ONE+DIWSAVE5;      /* ONE MORE CINV IN CA   @X04SVMR*/
         L     @10,AMBIWA(,RAMB)                                   0345
         LA    @00,1                                               0345
         AL    @00,DIWSAVE5(,@10)                                  0345
         ST    @00,DIWSAVE5(,@10)                                  0345
*       BUFCVAL=OFF;                /* RBA NOT VALID         @X04SVMR*/
         NI    BUFCVAL(RBUFC),B'11111011'                          0346
*       BUFCMW=OFF;                 /* DATA CI WILL MOVE     @X04SVMR*/
         NI    BUFCMW(RBUFC),B'01111111'                           0347
*       IF AMBJRN=ON THEN           /* IF JRNAD PRESENT      @X04SVMR*/
         TM    AMBJRN(RAMB),B'00000010'                            0348
         BNO   @RF00348                                            0348
*         DO;                       /* JOURNAL RBA CHANGE    @X04SVMR*/
*           PLHJCODE=PLHJRBAC;      /* RBA CHANGE            @X04SVMR*/
         MVI   PLHJCODE(RPLH),B'00001100'                          0350
*           PLHJNRBA=DIWSAVE3;      /* NEW RBA               @X04SVMR*/
         L     @10,DIWSAVE3(,@10)                                  0351
         ST    @10,PLHJNRBA(,RPLH)                                 0351
*           PLHJRNLL=AMDCINV;       /* LENGTH OF DATA        @X04SVMR*/
         ST    @09,PLHJRNLL(,RPLH)                                 0352
*I16:                                                              0353
*           DO;                     /* IDACALL(IDATJXIT)             */
I16      DS    0H                                                  0354
*             CALL IDATJXIT;        /* EXIT TO IDATJXIT              */
         L     @15,@CV00883                                        0354
         BALR  @14,@15                                             0354
*             GEN(BALR @11,0);      /* LOAD ADDR OF REENTRY          */
         BALR @11,0
*             GEN(USING *,@11);     /* ESTABLISH ADDRESSING          */
         USING *,@11
*             GEN(L     @11,=A(@PSTART));/* RELOAD BASE              */
         L     @11,=A(@PSTART)
*             GEN(USING @PSTART,@11);/* ESTABLISH ADDRESSING         */
         USING @PSTART,@11
*           END I16;                /* TAKE JRNAD EXIT       @X04SVMR*/
*         END;                      /* END OF JRNAD CODE     @X04SVMR*/
*       CALL EOCA;                  /* GET NEW CA            @X04SVMR*/
@RF00348 BAL   @14,EOCA                                            0361
*       DIWSAVE5=AMDCIPCA-ONE;      /* RESET FREE CINV COUNT @X04SVMR*/
         L     @10,AMBIWA(,RAMB)                                   0362
         L     @09,AMBDSB(,RAMB)                                   0362
         LH    @00,AMDCIPCA(,@09)                                  0362
         BCTR  @00,0                                               0362
         ST    @00,DIWSAVE5(,@10)                                  0362
*     END;                          /* END OF NEW CA NEEDED  @X04SVMR*/
*                                                                  0363
*   /*****************************************************************/
*   /*                                                               */
*   /* IF ADDING TO ESDS WITH AN UPGRADE SET PRESENT, MUST DO THE    */
*   /* UPGRADE FIRST.                                        @X04SVMR*/
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0364
*   IF AMBUPX=ON&                   /* UPGRADE SET HERE?     @X04SVMR*/
*       AMDDST='0'B THEN            /* ESDS?                 @X04SVMR*/
@RF00339 TM    AMBUPX(RAMB),B'00000010'                            0364
         BNO   @RF00364                                            0364
         L     @10,AMBDSB(,RAMB)                                   0364
         TM    AMDDST(@10),B'10000000'                             0364
         BNZ   @RF00364                                            0364
*     DO;                           /* YES, CALL UPGRADE.    @X04SVMR*/
*       RPLDDDD=BUFXIRBA;           /* SET RBA IN RPL.       @X04SVMR*/
         L     @10,BUFXIRBA(,RBUFC)                                0366
         ST    @10,RPLDDDD(,RRPL)                                  0366
*I17:                                                              0367
*       DO;                         /* IDACALL(IDA019RU)             */
I17      DS    0H                                                  0368
*         CALL IDA019RU;            /* EXIT TO IDA019RU              */
         L     @15,@CV00887                                        0368
         BALR  @14,@15                                             0368
*         GEN(BALR @11,0);          /* LOAD ADDR OF REENTRY          */
         BALR @11,0
*         GEN(USING *,@11);         /* ESTABLISH ADDRESSING          */
         USING *,@11
*         GEN(L     @11,=A(@PSTART));/* RELOAD BASE                  */
         L     @11,=A(@PSTART)
*         GEN(USING @PSTART,@11);   /* ESTABLISH ADDRESSING          */
         USING @PSTART,@11
*       END I17;                    /* CALL AIX UPGRADE.     @X04SVMR*/
*       RBUFC=PLHDBUFC;             /* RESTORE BUFC REG      @X04SVMR*/
         L     RBUFC,PLHDBUFC(,RPLH)                               0374
*       IF RPLERREG^='00'X THEN     /* SEE IF UPGRADE OK.    @X04SVMR*/
         CLI   RPLERREG(RRPL),0                                    0375
         BE    @RF00375                                            0375
*         DO;                       /* IF NOT, STOP INSERT.  @X04SVMR*/
*           BUFCMW=OFF;             /* DO NOT WRITE BUFFER.  @X04SVMR*/
         NI    BUFCMW(RBUFC),B'01111111'                           0377
*           BUFCVAL=OFF;            /* CONTENTS ARE INVALID  @X04SVMR*/
*                                                                  0378
         NI    BUFCVAL(RBUFC),B'11111011'                          0378
*           /*********************************************************/
*           /*                                                       */
*           /* GO AHEAD AND LET AN EMPTY CI BE CREATED. BUT FIRST    */
*           /* DECREMENT THE RBAS IN THE BUFC.               @X04SVMR*/
*           /*                                                       */
*           /*********************************************************/
*                                                                  0379
*           BUFCORBA=BUFCORBA-AMDCINV;/* BACK UP 1 CINV      @X04SVMR*/
         L     @10,AMBDSB(,RAMB)                                   0379
         L     @00,BUFCORBA(,RBUFC)                                0379
         SL    @00,AMDCINV(,@10)                                   0379
         ST    @00,BUFCORBA(,RBUFC)                                0379
*           BUFXIRBA=BUFCORBA;      /*                       @X04SVMR*/
         ST    @00,BUFXIRBA(,RBUFC)                                0380
*         END;                      /* END OF UPGRADE ERROR  @X04SVMR*/
*     END;                          /* END OF UPGRADE CALL.  @X04VSMR*/
*                                                                  0382
@RF00375 DS    0H                                                  0383
*   /*****************************************************************/
*   /*                                                               */
*   /* SEGMENT(SEG1ST)FINISH                                         */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0383
*   DO;                                                            0383
@RF00364 DS    0H                                                  0384
*     GOTO SEG1ST#;                                                0384
         B     SEG1ST#                                             0384
*SEG1ST@:                                                          0385
*   END;                                                           0385
SEG1ST@  DS    0H                                                  0386
*                                                                  0386
*/*  WRITE OUT REST OF SPANNED RECORD AND DO ANY PREFORMATTING       */
*/*  THAT IS NECESSARY.  THEN MOVE THE SPANNED RECORD TO THE NEW     */
*/*  CONTROL AREA.                                                   */
*                                                                  0386
*   /*****************************************************************/
*   /*                                                               */
*   /* SEGMENT(MOVESR)START                                          */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0386
*   DO;                                                            0386
*     GOTO MOVESR@;                                                0387
         B     MOVESR@                                             0387
*MOVESR:                                                           0388
*   END;                            /* MOVE SPANNED RECORD           */
MOVESR   DS    0H                                                  0389
*   BUFXORBA=BUFXIRBA;              /* SAVE ORIGINAL RBA     @X04SVMR*/
         L     @10,BUFXIRBA(,RBUFC)                                0389
         ST    @10,BUFXORBA(,RBUFC)                                0389
*   CALL EOCA;                      /* FINISH OLD CA         @X04SVMR*/
*                                                                  0390
         BAL   @14,EOCA                                            0390
*   /*****************************************************************/
*   /*                                                               */
*   /* MOVE SPANNED RECORD TO NEW CONTROL AREA               @X04SVMR*/
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0391
*   DIWSAVE4=BUFXORBA;              /* SET FIRST RBA OF S.R. @X04SVMR*/
         L     @10,AMBIWA(,RAMB)                                   0391
         L     @00,BUFXORBA(,RBUFC)                                0391
         ST    @00,DIWSAVE4(,@10)                                  0391
*   DIWSAVE5=DIWSAVE4;              /* SAVE FOR LATER        @X04SVMR*/
         ST    @00,DIWSAVE5(,@10)                                  0392
*   DIWSAVE1=DIWSAVE3;              /* GET 1ST RBA IN NEW CA @X04SVMR*/
         L     @00,DIWSAVE3(,@10)                                  0393
         ST    @00,DIWSAVE1(,@10)                                  0393
*I20:                                                              0394
*   DO;                             /* IDACALL(IDAFREEB)             */
I20      DS    0H                                                  0395
*     CALL IDAFREEB;                /* EXIT TO IDAFREEB              */
         L     @15,@CV00888                                        0395
         BALR  @14,@15                                             0395
*     GEN(BALR @11,0);              /* LOAD ADDR OF REENTRY          */
         BALR @11,0
*     GEN(USING *,@11);             /* ESTABLISH ADDRESSING          */
         USING *,@11
*     GEN(L     @11,=A(@PSTART));   /* RELOAD BASE                   */
         L     @11,=A(@PSTART)
*     GEN(USING @PSTART,@11);       /* ESTABLISH ADDRESSING          */
         USING @PSTART,@11
*   END I20;                        /* FREE OLD BUFFER       @X04SVLP*/
*                                                                  0400
*   /*****************************************************************/
*   /*                                                               */
*   /* COPY THE SPANNED RECORD TO NEW CONTROL AREA           @X04SVMR*/
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0401
*   DO DIWSAVE2=ONE TO PLHNOSEG;                                   0401
         LA    @10,1                                               0401
         B     @DE00401                                            0401
@DL00401 DS    0H                                                  0402
*     RPARM1=DIWSAVE4;              /* GET RBA OF S.R. SEG   @X04SVMR*/
         L     @10,AMBIWA(,RAMB)                                   0402
         L     RPARM1,DIWSAVE4(,@10)                               0402
*I21:                                                              0403
*     DO;                           /* IDACALL(IDAGRB)               */
I21      DS    0H                                                  0404
*       CALL IDAGRB;                /* EXIT TO IDAGRB                */
         L     @15,@CV00882                                        0404
         BALR  @14,@15                                             0404
*       GEN(BALR @11,0);            /* LOAD ADDR OF REENTRY          */
         BALR @11,0
*       GEN(USING *,@11);           /* ESTABLISH ADDRESSING          */
         USING *,@11
*       GEN(L     @11,=A(@PSTART)); /* RELOAD BASE                   */
         L     @11,=A(@PSTART)
*       GEN(USING @PSTART,@11);     /* ESTABLISH ADDRESSING          */
         USING @PSTART,@11
*     END I21;                      /* READ IN S.R. SEG      @X04SVMR*/
*     IF RPLERREG^='00'X THEN       /* IF ERROR, EXIT.       @X04SVMR*/
         CLI   RPLERREG(RRPL),0                                    0410
         BNE   @RT00410                                            0410
*       GO TO CISPLITX;             /* STOP CI SPLIT         @X04SVMR*/
*     RPARM1=DIWSAVE1;              /* GET RBA IN NEW CA     @X04SVMR*/
         L     @10,AMBIWA(,RAMB)                                   0412
         L     @09,DIWSAVE1(,@10)                                  0412
         LR    RPARM1,@09                                          0412
*     DO;                           /* SET OUTPUT RBA                */
*       BUFCORBA=RPARM1;                                           0414
         ST    RPARM1,BUFCORBA(,RBUFC)                             0414
*       BUFCMW=ON;                  /* SET MUST WRITE                */
         OI    BUFCMW(RBUFC),B'10000000'                           0415
*     END;                          /* SET MW AND OUTPUT RBA @X04SVMR*/
*     IF AMBJRN=ON THEN             /* IF JRNAD SPECIFIED    @X04SVMR*/
         TM    AMBJRN(RAMB),B'00000010'                            0417
         BNO   @RF00417                                            0417
*       DO;                                                        0418
*         PLHJCODE=PLHJRBAC;        /* INDICATE RBA CHANGE   @X04SVMR*/
         MVI   PLHJCODE(RPLH),B'00001100'                          0419
*         PLHJORBA=DIWSAVE4;        /* SET OLD RBA           @X04SVMR*/
         L     @10,DIWSAVE4(,@10)                                  0420
         ST    @10,PLHJORBA(,RPLH)                                 0420
*         PLHJNRBA=DIWSAVE1;        /* SET NEW RBA           @X04SVMR*/
         ST    @09,PLHJNRBA(,RPLH)                                 0421
*         PLHJRNLL=AMDCINV;         /* SET LENGTH OF MOVE    @X04SVMR*/
         L     @10,AMBDSB(,RAMB)                                   0422
         L     @10,AMDCINV(,@10)                                   0422
         ST    @10,PLHJRNLL(,RPLH)                                 0422
*I23:                                                              0423
*         DO;                       /* IDACALL(IDATJXIT)             */
I23      DS    0H                                                  0424
*           CALL IDATJXIT;          /* EXIT TO IDATJXIT              */
         L     @15,@CV00883                                        0424
         BALR  @14,@15                                             0424
*           GEN(BALR @11,0);        /* LOAD ADDR OF REENTRY          */
         BALR @11,0
*           GEN(USING *,@11);       /* ESTABLISH ADDRESSING          */
         USING *,@11
*           GEN(L     @11,=A(@PSTART));/* RELOAD BASE                */
         L     @11,=A(@PSTART)
*           GEN(USING @PSTART,@11); /* ESTABLISH ADDRESSING          */
         USING @PSTART,@11
*         END I23;                  /* TAKE JRNAD EXIT       @X04SVMR*/
*       END;                        /* END OF JRNAD CODE     @X04SVMR*/
*     DIWSAVE1=DIWSAVE1+AMDCINV;    /* GET NEW OUT RBA       @X04SVMR*/
@RF00417 L     @10,AMBIWA(,RAMB)                                   0431
         L     @09,AMBDSB(,RAMB)                                   0431
         L     @09,AMDCINV(,@09)                                   0431
         L     @00,DIWSAVE1(,@10)                                  0431
         ALR   @00,@09                                             0431
         ST    @00,DIWSAVE1(,@10)                                  0431
*     DIWSAVE4=DIWSAVE4+AMDCINV;    /* GET NEW IN RBA        @X04SVMR*/
         AL    @09,DIWSAVE4(,@10)                                  0432
         ST    @09,DIWSAVE4(,@10)                                  0432
*I24:                                                              0433
*     DO;                           /* IDACALL(IDAFREEB)             */
I24      DS    0H                                                  0434
*       CALL IDAFREEB;              /* EXIT TO IDAFREEB              */
         L     @15,@CV00888                                        0434
         BALR  @14,@15                                             0434
*       GEN(BALR @11,0);            /* LOAD ADDR OF REENTRY          */
         BALR @11,0
*       GEN(USING *,@11);           /* ESTABLISH ADDRESSING          */
         USING *,@11
*       GEN(L     @11,=A(@PSTART)); /* RELOAD BASE                   */
         L     @11,=A(@PSTART)
*       GEN(USING @PSTART,@11);     /* ESTABLISH ADDRESSING          */
         USING @PSTART,@11
*     END I24;                      /* FREE THE BUFFER       @X04SVLP*/
*   END;                            /* END OF S.R. COPY      @X04SVMR*/
         L     @09,AMBIWA(,RAMB)                                   0440
         LA    @10,1                                               0440
         AL    @10,DIWSAVE2(,@09)                                  0440
@DE00401 L     @09,AMBIWA(,RAMB)                                   0440
         ST    @10,DIWSAVE2(,@09)                                  0440
         CH    @10,PLHNOSEG(,RPLH)                                 0440
         BNH   @DL00401                                            0440
*   ARDHKRBA=DIWSAVE3;              /* 1ST CI IN CA IS HIGH  @X04SVMR*/
*                                                                  0441
         L     @10,PLHARDB(,RPLH)                                  0441
         L     @09,AMBIWA(,RAMB)                                   0441
         L     @00,DIWSAVE3(,@09)                                  0441
         ST    @00,ARDHKRBA(,@10)                                  0441
*   /*****************************************************************/
*   /*                                                               */
*   /* CONVERT SPANNED RCD IN OLD CA TO FREE SPACE           @X04SVMR*/
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0442
*   DO DIWSAVE2=ONE TO PLHNOSEG;                                   0442
         LA    @10,1                                               0442
         B     @DE00442                                            0442
@DL00442 DS    0H                                                  0443
*I25:                                                              0443
*     DO;                           /* IDACALL(IDAGNNFL)             */
I25      DS    0H                                                  0444
*       CALL IDAGNNFL;              /* EXIT TO IDAGNNFL              */
         L     @15,@CV00881                                        0444
         BALR  @14,@15                                             0444
*       GEN(BALR @11,0);            /* LOAD ADDR OF REENTRY          */
         BALR @11,0
*       GEN(USING *,@11);           /* ESTABLISH ADDRESSING          */
         USING *,@11
*       GEN(L     @11,=A(@PSTART)); /* RELOAD BASE                   */
         L     @11,=A(@PSTART)
*       GEN(USING @PSTART,@11);     /* ESTABLISH ADDRESSING          */
         USING @PSTART,@11
*     END I25;                      /* GET AN EMPTY BUFFER   @X04SVMR*/
*     IF RPLERREG^='00'X THEN       /* IF ANY ERROR,         @X04SVMR*/
         CLI   RPLERREG(RRPL),0                                    0450
         BNE   @RT00450                                            0450
*       GO TO CISPLITX;             /* THEN EXIT.            @X04SVMR*/
*INITCI:                                                           0452
*     CALL BUILDFS;                 /* BUILD FS RECORD       @X04SVMR*/
INITCI   BAL   @14,BUILDFS                                         0452
*     RPARM1=DIWSAVE5;              /* GET OLD S.R. RBA      @X04SVMR*/
         L     @10,AMBIWA(,RAMB)                                   0453
         L     @09,DIWSAVE5(,@10)                                  0453
         LR    RPARM1,@09                                          0453
*     DO;                           /* SET OUTPUT RBA                */
*       BUFCORBA=RPARM1;                                           0455
         ST    RPARM1,BUFCORBA(,RBUFC)                             0455
*       BUFCMW=ON;                  /* SET MUST WRITE                */
         OI    BUFCMW(RBUFC),B'10000000'                           0456
*     END;                          /* SET MW AND OUTPUT RBA @X04SVMR*/
*     DIWSAVE5=DIWSAVE5+AMDCINV;    /* NEXT SEGMENT          @X04SVMR*/
         L     @08,AMBDSB(,RAMB)                                   0458
         AL    @09,AMDCINV(,@08)                                   0458
         ST    @09,DIWSAVE5(,@10)                                  0458
*I27:                                                              0459
*     DO;                           /* IDACALL(IDAFREEB)             */
I27      DS    0H                                                  0460
*       CALL IDAFREEB;              /* EXIT TO IDAFREEB              */
         L     @15,@CV00888                                        0460
         BALR  @14,@15                                             0460
*       GEN(BALR @11,0);            /* LOAD ADDR OF REENTRY          */
         BALR @11,0
*       GEN(USING *,@11);           /* ESTABLISH ADDRESSING          */
         USING *,@11
*       GEN(L     @11,=A(@PSTART)); /* RELOAD BASE                   */
         L     @11,=A(@PSTART)
*       GEN(USING @PSTART,@11);     /* ESTABLISH ADDRESSING          */
         USING @PSTART,@11
*     END I27;                      /* FREE WORK BUFFER      @X04SVLP*/
*   END;                            /* END OF FS CONVERT     @X04SVMR*/
         L     @09,AMBIWA(,RAMB)                                   0466
         LA    @10,1                                               0466
         AL    @10,DIWSAVE2(,@09)                                  0466
@DE00442 L     @09,AMBIWA(,RAMB)                                   0466
         ST    @10,DIWSAVE2(,@09)                                  0466
         CH    @10,PLHNOSEG(,RPLH)                                 0466
         BNH   @DL00442                                            0466
*   DIWSAVE5=AMDCIPCA-PLHNOSEG;     /* NEW FREE CI NO        @X04SVMR*/
         L     @10,AMBIWA(,RAMB)                                   0467
         L     @09,AMBDSB(,RAMB)                                   0467
         LH    @00,AMDCIPCA(,@09)                                  0467
         SH    @00,PLHNOSEG(,RPLH)                                 0467
         ST    @00,DIWSAVE5(,@10)                                  0467
*I28:                                                              0468
*   DO;                             /* IDACALL(IDAGNNFL)             */
I28      DS    0H                                                  0469
*     CALL IDAGNNFL;                /* EXIT TO IDAGNNFL              */
         L     @15,@CV00881                                        0469
         BALR  @14,@15                                             0469
*     GEN(BALR @11,0);              /* LOAD ADDR OF REENTRY          */
         BALR @11,0
*     GEN(USING *,@11);             /* ESTABLISH ADDRESSING          */
         USING *,@11
*     GEN(L     @11,=A(@PSTART));   /* RELOAD BASE                   */
         L     @11,=A(@PSTART)
*     GEN(USING @PSTART,@11);       /* ESTABLISH ADDRESSING          */
         USING @PSTART,@11
*   END I28;                        /* SET FOR FREE BFR      @X04SVMR*/
*   BUFCORBA=DIWSAVE1-AMDCINV;      /* LAST OUTPUT RBA       @X04SVMR*/
         L     @10,AMBIWA(,RAMB)                                   0475
         L     @09,AMBDSB(,RAMB)                                   0475
         L     @00,DIWSAVE1(,@10)                                  0475
         SL    @00,AMDCINV(,@09)                                   0475
         ST    @00,BUFCORBA(,RBUFC)                                0475
*   BUFXIRBA=DIWSAVE3;              /* SET FOR IDA019RG      @X04SVMR*/
         L     @10,DIWSAVE3(,@10)                                  0476
         ST    @10,BUFXIRBA(,RBUFC)                                0476
*   IF RPLERREG^='00'X THEN         /* IF ANY ERROR,         @X04SVMR*/
         CLI   RPLERREG(RRPL),0                                    0477
         BNE   @RT00477                                            0477
*     GO TO CISPLITX;               /* THEN EXIT.            @X04SVMR*/
*                                                                  0478
*   /*****************************************************************/
*   /*                                                               */
*   /* SEGMENT(MOVESR)FINISH                                         */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0479
*   DO;                                                            0479
*     GOTO MOVESR#;                                                0480
         B     MOVESR#                                             0480
*MOVESR@:                                                          0481
*   END;                                                           0481
MOVESR@  DS    0H                                                  0482
*                                                                  0482
*/*  DETERMINE WHERE THE NEXT CI OF USABLE SPACE IS.  IF NECESSARY   */
*/*  GET A NEW CONTROL AREA.   SET THE OUTPUT RBA AND THE MUST WRITE */
*/*  FLAG ONCE THE CONTROL INTERVAL OF SPACE IS INITIALIZED AND ITS  */
*/*  RBA IS DETERMINED.                                      @X04SVMR*/
*/* SEGMENT(GETCI)START                                              */
*                                                                  0482
*   DO;                                                            0482
*     GOTO GETCI@;                                                 0483
         B     GETCI@                                              0483
*GETCI:                                                            0484
*   END;                            /* GET NEXT BUFFER               */
GETCI    DS    0H                                                  0485
*   DIWSAVE4=BUFCORBA;              /* SAVE LAST OUTPUT RBA          */
         L     @10,AMBIWA(,RAMB)                                   0485
         L     @00,BUFCORBA(,RBUFC)                                0485
         ST    @00,DIWSAVE4(,@10)                                  0485
*   DIWSAVE2=BUFXIRBA;              /* SAVE EXCL CNTL RBA    @X04SVMR*/
         L     @00,BUFXIRBA(,RBUFC)                                0486
         ST    @00,DIWSAVE2(,@10)                                  0486
*/* FREE BUFFER IN ORDER TO GET A WORK BUFFER                        */
*                                                                  0487
*I31:                                                              0487
*   DO;                             /* IDACALL(IDAFREEB)             */
I31      DS    0H                                                  0488
*     CALL IDAFREEB;                /* EXIT TO IDAFREEB              */
         L     @15,@CV00888                                        0488
         BALR  @14,@15                                             0488
*     GEN(BALR @11,0);              /* LOAD ADDR OF REENTRY          */
         BALR @11,0
*     GEN(USING *,@11);             /* ESTABLISH ADDRESSING          */
         USING *,@11
*     GEN(L     @11,=A(@PSTART));   /* RELOAD BASE                   */
         L     @11,=A(@PSTART)
*     GEN(USING @PSTART,@11);       /* ESTABLISH ADDRESSING          */
         USING @PSTART,@11
*   END I31;                        /*                       @X04SVLP*/
*/* GET THE NEXT PLH BUFFER FOR DATA INSERT                          */
*                                                                  0494
*I32:                                                              0494
*   DO;                             /* IDACALL(IDAGNNFL)             */
I32      DS    0H                                                  0495
*     CALL IDAGNNFL;                /* EXIT TO IDAGNNFL              */
         L     @15,@CV00881                                        0495
         BALR  @14,@15                                             0495
*     GEN(BALR @11,0);              /* LOAD ADDR OF REENTRY          */
         BALR @11,0
*     GEN(USING *,@11);             /* ESTABLISH ADDRESSING          */
         USING *,@11
*     GEN(L     @11,=A(@PSTART));   /* RELOAD BASE                   */
         L     @11,=A(@PSTART)
*     GEN(USING @PSTART,@11);       /* ESTABLISH ADDRESSING          */
         USING @PSTART,@11
*   END I32;                                                       0500
*   IF RPLERREG^='00'X THEN         /* IF AN ERROR                   */
         CLI   RPLERREG(RRPL),0                                    0501
         BNE   @RT00501                                            0501
*     GO TO CISPLITX;               /* EXIT                          */
*/* LEAVE CONTENTS OF BUFFER INVALID UNTIL RBA DETERMINED.           */
*                                                                  0503
*   BUFCORBA=DIWSAVE4;              /* RESTORE LAST OUTPUT RBA       */
         L     @10,AMBIWA(,RAMB)                                   0503
         L     @10,DIWSAVE4(,@10)                                  0503
         ST    @10,BUFCORBA(,RBUFC)                                0503
*/*  BUILD A CONTROL INTERVAL OF FREE SPACE AND RESET THE INSERT   0504
*    POINTERS IN THE PLACEHOLDER FOR THE BENEFIT OF DATA INSERT.     */
*                                                                  0504
*   RFY                                                            0504
*    (RWORK1,                                                      0504
*     RWORK4,                                                      0504
*     RWORK2) RSTD;                 /* GET REGS              @X04SVMR*/
*   RFY                                                            0505
*    (RWORK3,                                                      0505
*     RWORK5) RSTD;                 /* GET WORK REGISTERS            */
*   CALL BUILDFS;                   /* BUILD FS CINV                 */
         BAL   @14,BUILDFS                                         0506
*   RFY                                                            0507
*    (RWORK3,                                                      0507
*     RWORK4,                                                      0507
*     RWORK5) UNRSTD;               /* DROP WORK REGS        @X04SVMR*/
*   PLHFSP=BUFCBAD;                 /* SET FREE SPACE PTR            */
         L     @10,BUFCBAD(,RBUFC)                                 0508
         ST    @10,PLHFSP(,RPLH)                                   0508
*   PLHRECP=BUFCBAD;                /* POINT TO BEGINNING            */
         ST    @10,PLHRECP(,RPLH)                                  0509
*   PLHRDFP=RWORK1;                 /* SET RDF POINTER       @X04SVMR*/
         ST    RWORK1,PLHRDFP(,RPLH)                               0510
*   PLHNRBA=BUFCORBA+AMDCINV;       /* PT TO NEXT CI         @ZA12918*/
         L     @10,AMBDSB(,RAMB)                                   0511
         L     @07,BUFCORBA(,RBUFC)                                0511
         AL    @07,AMDCINV(,@10)                                   0511
         ST    @07,PLHNRBA(,RPLH)                                  0511
*/*  IF AN END OF KEY RANGE CONDITION IS INDICATED,  IT IS NECESSARY
*    TO FINISH THE CURRENT CONTROL AREA AND TO GET THE NEXT CONTROL
*    AREA FROM THE BEGINNING OF THE NEXT KEY RANGE.  BEFORE CALLING
*    EOCA (WHICH CALLS INDEX CREATE FOR A WRITE OF THE INDEX),     0512
*    THE PLACEHOLDER KEY IS SET TO THE LOW KEY OF THE NEW KEY RANGE
*    SO THAT THE PROPER KEY COMPRESSION WILL OCCUR AT THE END OF THE
*    OLD KEY RANGE.                                                  */
*                                                                  0512
*   IF PLHKRE=ON&                   /* IF END OF KEY RANGE & @X04SVMR*/
*       DIW1ST=OFF                  /* NOT INSIDE A SPAN RCD @X04SVMR*/
*     THEN                          /* THEN FORCE NEW CA             */
         TM    PLHKRE(RPLH),B'00001000'                            0512
         BNO   @RF00512                                            0512
         L     @10,AMBIWA(,RAMB)                                   0512
         TM    DIW1ST(@10),B'00000001'                             0512
         BNZ   @RF00512                                            0512
*     DO;                                                          0513
*       PLHNOSPC=OFF;               /* SPACE MUST BE PRESENT         */
         NI    PLHNOSPC(RPLH),B'01111111'                          0514
*       IF AMBSPEED=ON THEN         /* IF SPEED OPTION,              */
         TM    AMBSPEED(RAMB),B'00001000'                          0515
         BNO   @RF00515                                            0515
*         ARDHRBA=DIWSAVE3;         /* SET NEW HRBA                  */
         L     @07,PLHARDB(,RPLH)                                  0516
         L     @10,DIWSAVE3(,@10)                                  0516
         ST    @10,ARDHRBA(,@07)                                   0516
*       DIWEOKR=ON;                 /* INDICATE SEOF NEEDED          */
@RF00515 L     @10,AMBIWA(,RAMB)                                   0517
         OI    DIWEOKR(@10),B'00010000'                            0517
*       DIWSAVE3=ARDNPTR->ARDHRBA;  /* GET 1ST RBA IN KR             */
*                                                                  0518
         L     @07,PLHARDB(,RPLH)                                  0518
         L     @07,ARDNPTR(,@07)                                   0518
         L     @00,ARDHRBA(,@07)                                   0518
         ST    @00,DIWSAVE3(,@10)                                  0518
*       /*************************************************************/
*       /*                                                           */
*       /* SET PLHKEY TO THE LOW KEY OF NEXT KEY RANGE.              */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0519
*       PLHKEY(ONE:AMDKEYLN)=ARDNPTR->ARDKEYS(ONE:AMDKEYLN);       0519
         L     @10,PLHKEYPT(,RPLH)                                 0519
         L     @09,AMBDSB(,RAMB)                                   0519
         LH    @09,AMDKEYLN(,@09)                                  0519
         BCTR  @09,0                                               0519
         EX    @09,@SM01016                                        0519
*       CALL EOCA;                  /* GET NEW CNTL AREA             */
         BAL   @14,EOCA                                            0520
*       DIWEOKR=OFF;                /* RESET EOKR/SEOF BIT           */
         L     @10,AMBIWA(,RAMB)                                   0521
         NI    DIWEOKR(@10),B'11101111'                            0521
*     END;                          /* END OF EOKR CODE              */
*   ELSE                            /* HERE FOR NORMAL CASE          */
*     DO;                                                          0523
*                                                                  0523
         B     @RC00512                                            0523
@RF00512 DS    0H                                                  0524
*       /*************************************************************/
*       /*                                                           */
*       /* IF NOT END OF KEY RANGE, SEE IF WE DETERMINED ABOVE THAT A*/
*       /* NEW CONTROL AREA IS NECESSARY.                    @X04SVMR*/
*       /*                                                           */
*       /*************************************************************/
*                                                                  0524
*       IF DIWGSPC=ON               /* SEE IF ENUF CINVS ARE @X04SVMR*/
*         THEN                      /* AVAILABLE TO HOLD THE         */
         L     @10,AMBIWA(,RAMB)                                   0524
         TM    DIWGSPC(@10),B'00001000'                            0524
         BNO   @RF00524                                            0524
*         DO;                       /* DATA RECORD--NO, NEW CA       */
*           DIWGSPC=OFF;            /* RESET GET SPACE FLAG  @X04SVMR*/
         NI    DIWGSPC(@10),B'11110111'                            0526
*           CALL EOCA;              /* GO TO NEW CONTROL AREA        */
         BAL   @14,EOCA                                            0527
*         END;                      /* END OF EOCA CODE              */
*                                                                  0528
*       /*************************************************************/
*       /*                                                           */
*       /* IF IT IS NOT AN END OF CONTROL AREA, ALL THAT IS NECESSARY*/
*       /* IS TO SET THE NEXT RBA IN PHYSICAL SEQUENCE.              */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0529
*       ELSE                        /* HERE IF NOT EOCA              */
*         DO;                                                      0529
         B     @RC00524                                            0529
@RF00524 DS    0H                                                  0530
*           RPARM1=BUFCORBA+AMDCINV;/* GET NEXT RBA                  */
         L     @10,AMBDSB(,RAMB)                                   0530
         L     RPARM1,BUFCORBA(,RBUFC)                             0530
         AL    RPARM1,AMDCINV(,@10)                                0530
*           IF DIW1ST=ON|           /* IF IN MIDDLE OF SPAN  @X04SVMR*/
*               DIWNOT1=ON THEN     /* RCD, EXCL CNTL RBA    @X04SVMR*/
         L     @10,AMBIWA(,RAMB)                                   0531
         TM    DIW1ST(@10),B'00000011'                             0531
         BZ    @RF00531                                            0531
*             DO;                   /*                       @ZA17187*/
*               BUFXIRBA=DIWSAVE2;  /* IS THAT OF 1ST CI     @X04SVMR*/
         L     @10,DIWSAVE2(,@10)                                  0533
         ST    @10,BUFXIRBA(,RBUFC)                                0533
*               BUFXORBA=DIWSAVE2;  /*                       @ZA17187*/
         ST    @10,BUFXORBA(,RBUFC)                                0534
*             END;                  /*                       @ZA17187*/
*           ELSE                    /* NON-SPANNED RECORD    @X04SVMR*/
*             DO;                   /*                       @ZA17187*/
         B     @RC00531                                            0536
@RF00531 DS    0H                                                  0537
*               BUFXIRBA=RPARM1;    /* SET EXCL CNTL RBA     @X04SVMR*/
         ST    RPARM1,BUFXIRBA(,RBUFC)                             0537
*               BUFXORBA=RPARM1;    /*                       @ZA17187*/
         ST    RPARM1,BUFXORBA(,RBUFC)                             0538
*             END;                  /*                       @ZA17187*/
*           DO;                     /* SET OUTPUT RBA                */
@RC00531 DS    0H                                                  0541
*             BUFCORBA=RPARM1;                                     0541
         ST    RPARM1,BUFCORBA(,RBUFC)                             0541
*             BUFCMW=ON;            /* SET MUST WRITE                */
         OI    BUFCMW(RBUFC),B'10000000'                           0542
*           END;                                                   0543
*           BUFCDDDD=RPARM1;        /* SET INPUT RBA TOO     @X04SVMR*/
         ST    RPARM1,BUFCDDDD(,RBUFC)                             0544
*           BUFCEXC=ON;             /* HOLD EXCLUSIVE CNTL   @X04SVMR*/
*           BUFCVAL=ON;             /* MARK IT VALID         @X04SVMR*/
         OI    BUFCEXC(RBUFC),B'00000110'                          0546
*         END;                      /* END OF NON-EOCA CODE          */
*     END;                          /* END OF NON-EOKR CODE          */
@RC00524 DS    0H                                                  0549
*/* SEGMENT(GETCI)FINISH                                             */
*                                                                  0549
*   DO;                                                            0549
@RC00512 DS    0H                                                  0550
*     GOTO GETCI#;                                                 0550
         B     GETCI#                                              0550
*GETCI@:                                                           0551
*   END;                                                           0551
GETCI@   DS    0H                                                  0552
*   GEN(IDAPATCH);                  /* DEFINE PATCH AREA             */
         IDAPATCH
*   END IDA019SA                    /* END OF CI SPLIT               */
*                                                                  0553
*/* THE FOLLOWING INCLUDE STATEMENTS WERE FOUND IN THIS PROGRAM.     */
*/*%INCLUDE SYSLIB  (IDAAMB  )                                       */
*/*%INCLUDE SYSLIB  (IDAAMBL )                                       */
*/*%INCLUDE SYSLIB  (IFGRPL  )                                       */
*/*%INCLUDE SYSLIB  (IDAIRD  )                                       */
*/*%INCLUDE SYSLIB  (IFGACB  )                                       */
*/*%INCLUDE SYSLIB  (IDADIWA )                                       */
*/*%INCLUDE SYSLIB  (IDAPLH  )                                       */
*/*%INCLUDE SYSLIB  (IDAAMDSB)                                       */
*/*%INCLUDE SYSLIB  (IDABUFC )                                       */
*/*%INCLUDE SYSLIB  (IDACIDF )                                       */
*/*%INCLUDE SYSLIB  (IDAARDB )                                       */
*/*%INCLUDE SYSLIB  (IDAIXSPL)                                       */
*/*%INCLUDE SYSLIB  (IDAREGS )                                       */
*/*%INCLUDE SYSLIB  (IDARDF  )                                       */
*                                                                  0553
*       ;                                                          0553
         B     @EL00001                                            0553
@DATA    DS    0H
@SM01016 MVC   PLHKEY(0,@10),ARDKEYS(@07)
@DATD    DSECT
         DS    0F
IDA019SA CSECT
         DS    0F
@DATD    DSECT
         DS    0D
IDA019SA CSECT
         DS    0F
@SIZDATD DC    AL1(0)
         DC    AL3(@ENDDATD-@DATD)
@CV00880 DC    V(IDAEOVIF)
@CV00881 DC    V(IDAGNNFL)
@CV00882 DC    V(IDAGRB)
@CV00883 DC    V(IDATJXIT)
@CV00884 DC    V(IDAWRBFR)
@CV00885 DC    V(IDA019RG)
@CV00886 DC    V(IDA019RK)
@CV00887 DC    V(IDA019RU)
@CV00888 DC    V(IDAFREEB)
         DS    0D
HWORD4   DC    H'4'
@DATD    DSECT
*                                                          /*@X04SVLC*/
RDFCTNUA EQU   X'40'                    COMPLEX RDF INDICATOR
RDFCTNUX EQU   X'FF'-RDFCTNUA           RESET COMPLEX MASK
RDFREPLA EQU   X'08'                    COUNT RDF INDICATOR
RDFREPLX EQU   X'FF'-RDFREPLA           RESET COUNT MASK
RDFEMPTI EQU   X'04'                    EMPTY RECORD       /*@X04SVLC*/
RDFLEN   EQU   3                        LENGTH OF RDF
RDFLLOFF EQU   1                        OFFSET WITHIN RDF TO LL
RDFSGLR  EQU   X'00'                   MASK FOR SINGLE RECORD RDF
RDFGRP   EQU   RDFCTNUA                 MASK FOR LL RDF OF A GROUP RDF
RDFCNT   EQU   RDFREPLA                 MASK FOR COUNT RDF
@DATD    DSECT
         ORG   *+1-(*-@DATD)/(*-@DATD) INSURE DSECT DATA
@ENDDATD EQU   *
IDA019SA CSECT
@00      EQU   00                      EQUATES FOR REGISTERS 0-15
@01      EQU   01
@02      EQU   02
@03      EQU   03
@04      EQU   04
@05      EQU   05
@06      EQU   06
@07      EQU   07
@08      EQU   08
@09      EQU   09
@10      EQU   10
@11      EQU   11
@12      EQU   12
@13      EQU   13
@14      EQU   14
@15      EQU   15
RRPL     EQU   @01
RPLH     EQU   @02
RAMB     EQU   @03
RBUFC    EQU   @04
RWORK1   EQU   @05
RWORK2   EQU   @06
RWORK3   EQU   @07
RWORK4   EQU   @08
RWORK5   EQU   @09
RPARM1   EQU   @12
R14      EQU   @14
R15      EQU   @15
RPARM1X  EQU   @12
RWORK0   EQU   @00
R1       EQU   @01
R10      EQU   @10
R11      EQU   @11
R13      EQU   @13
IDAAMB   EQU   0
AMBDSB   EQU   IDAAMB+20
AMBEOVR  EQU   IDAAMB+24
AMBFLG0  EQU   AMBEOVR
AMBFLG1  EQU   IDAAMB+25
AMBSPEED EQU   AMBFLG1
AMBJRN   EQU   AMBFLG1
AMBDSORG EQU   IDAAMB+26
AMBIOBAD EQU   IDAAMB+28
AMBINFL  EQU   IDAAMB+42
AMBUPX   EQU   AMBINFL
AMBDEBPT EQU   IDAAMB+44
AMBOFLGS EQU   IDAAMB+48
AMBFLG2  EQU   IDAAMB+49
AMBEOVPT EQU   IDAAMB+56
AMBIWA   EQU   IDAAMB+64
AMBCSWD1 EQU   IDAAMB+84
AMBAFLG  EQU   AMBCSWD1
IDAAMBL  EQU   0
AMBLEOV  EQU   IDAAMBL+12
AMBLEFLG EQU   AMBLEOV
AMBLDDNM EQU   IDAAMBL+16
AMBLIDF  EQU   AMBLDDNM
AMBLQ    EQU   AMBLIDF+7
AMBLVC   EQU   IDAAMBL+28
AMBLTYPE EQU   IDAAMBL+30
AMBLSHAR EQU   IDAAMBL+33
AMBLFLG1 EQU   IDAAMBL+35
AMBLFLG2 EQU   IDAAMBL+36
IFGRPL   EQU   0
RPLCOMN  EQU   IFGRPL
RPLIDWD  EQU   RPLCOMN
RPLLEN   EQU   RPLIDWD+3
RPLECB   EQU   RPLCOMN+8
RPLFDBWD EQU   RPLCOMN+12
RPLFDBK  EQU   RPLFDBWD+1
RPLRTNCD EQU   RPLFDBK
RPLERREG EQU   RPLRTNCD
RPLCNDCD EQU   RPLFDBK+1
RPLCMPON EQU   RPLCNDCD
RPLFDB2  EQU   RPLCMPON
RPLERRCD EQU   RPLCNDCD+1
RPLFDB3  EQU   RPLERRCD
RPLKEYLE EQU   RPLCOMN+16
RPLDACB  EQU   RPLCOMN+24
RPLARG   EQU   RPLCOMN+36
RPLOPTCD EQU   RPLCOMN+40
RPLOPT1  EQU   RPLOPTCD
RPLECBSW EQU   RPLOPT1
RPLOPT2  EQU   RPLOPTCD+1
RPLADR   EQU   RPLOPT2
RPLOPT3  EQU   RPLOPTCD+2
RPLNXTRP EQU   RPLCOMN+44
RPLOPTC2 EQU   RPLCOMN+56
RPLOPT5  EQU   RPLOPTC2
RPLWRTYP EQU   RPLOPT5
RPLOPT6  EQU   RPLOPTC2+1
RPLUNTYP EQU   RPLOPT6
RPLOPT7  EQU   RPLOPTC2+2
RPLCNOPT EQU   RPLOPT7
RPLOPT8  EQU   RPLOPTC2+3
RPLRBAR  EQU   RPLCOMN+60
RPLAIXID EQU   RPLRBAR+2
RPLDDDD  EQU   RPLRBAR+4
RPLEXTDS EQU   RPLCOMN+68
RPLEXTD1 EQU   RPLEXTDS
IDAIXH   EQU   0
IDAIBFLP EQU   0
IBFLP3   EQU   IDAIBFLP+2
IBFLP2   EQU   IBFLP3
IDASELL  EQU   0
IDAIXK   EQU   0
IFGACB   EQU   0
ACBCOMN  EQU   IFGACB
ACBLENG  EQU   ACBCOMN+2
ACBLENG2 EQU   ACBLENG
ACBAMBL  EQU   ACBCOMN+4
ACBJWA   EQU   ACBAMBL
ACBMACRF EQU   ACBCOMN+12
ACBMACR1 EQU   ACBMACRF
ACBADR   EQU   ACBMACR1
ACBCNV   EQU   ACBMACR1
ACBMACR2 EQU   ACBMACRF+1
ACBBUFPL EQU   ACBCOMN+20
ACBMACR3 EQU   ACBBUFPL
ACBRECFM EQU   ACBCOMN+24
ACBCCTYP EQU   ACBCOMN+25
ACBOPT   EQU   ACBCOMN+26
ACBDSORG EQU   ACBOPT
ACBCROPS EQU   ACBDSORG
ACBEXLST EQU   ACBCOMN+36
ACBDDNM  EQU   ACBCOMN+40
ACBAMETH EQU   ACBDDNM+3
ACBOFLGS EQU   ACBCOMN+48
ACBEXFG  EQU   ACBOFLGS
ACBIOSFG EQU   ACBOFLGS
ACBINFLG EQU   ACBCOMN+50
ACBUJFCB EQU   ACBCOMN+52
ACBBLKSZ EQU   ACBCOMN+60
IDADIWA  EQU   0
DIWFLG1  EQU   IDADIWA+4
DIWEOKR  EQU   DIWFLG1
DIWGSPC  EQU   DIWFLG1
DIWNOT1  EQU   DIWFLG1
DIW1ST   EQU   DIWFLG1
DIWFLG2  EQU   IDADIWA+5
DIWFSPF  EQU   DIWFLG2
DIWSAVE  EQU   IDADIWA+28
DIWSAVE1 EQU   DIWSAVE
DIWSAVE2 EQU   DIWSAVE+4
DIWSAVE3 EQU   DIWSAVE+8
DIWSAVE4 EQU   DIWSAVE+12
DIWSAVE5 EQU   DIWSAVE+16
IDAPLHDR EQU   0
IDAPLH   EQU   0
PLHFLG1  EQU   IDAPLH+2
PLHENDRQ EQU   PLHFLG1
PLHFLG2  EQU   IDAPLH+3
PLHKRE   EQU   PLHFLG2
PLHEFLGS EQU   IDAPLH+4
PLHNOSPC EQU   PLHEFLGS
PLHFLG3  EQU   IDAPLH+6
PLHAFLGS EQU   IDAPLH+7
PLHFRCNT EQU   IDAPLH+14
PLHCRBA  EQU   IDAPLH+28
PLHJORBA EQU   PLHCRBA
PLHJRNLL EQU   IDAPLH+32
PLHJNRBA EQU   IDAPLH+36
PLHJCODE EQU   IDAPLH+40
PLHEOVR  EQU   IDAPLH+42
PLHARDB  EQU   IDAPLH+44
PLHDBUFC EQU   IDAPLH+52
PLHRECP  EQU   IDAPLH+60
PLHFSP   EQU   IDAPLH+64
PLHRDFP  EQU   IDAPLH+68
PLHDIOB  EQU   IDAPLH+76
PLHRETO  EQU   IDAPLH+116
PLHRET1  EQU   IDAPLH+120
PLHEOVPT EQU   IDAPLH+180
PLHNRBA  EQU   IDAPLH+184
PLHIXSPL EQU   IDAPLH+200
PLHSSRBA EQU   PLHIXSPL
PLHWAX   EQU   IDAPLH+232
PLHNOSEG EQU   IDAPLH+240
PLHKEYPT EQU   IDAPLH+248
PLHEND   EQU   IDAPLH+280
PLHKEY   EQU   0
IDAAMDSB EQU   0
AMDATTR  EQU   IDAAMDSB+1
AMDDST   EQU   AMDATTR
AMDNEST  EQU   IDAAMDSB+4
AMDKEYLN EQU   IDAAMDSB+8
AMDCIPCA EQU   IDAAMDSB+12
AMDFSCA  EQU   IDAAMDSB+14
AMDCINV  EQU   IDAAMDSB+20
AMDHLRBA EQU   IDAAMDSB+28
AMDSSRBA EQU   IDAAMDSB+32
AMDATTR3 EQU   IDAAMDSB+40
AMDSTAT  EQU   IDAAMDSB+48
AMDASPA  EQU   AMDSTAT+32
IDABUFDR EQU   0
BUFDRCIX EQU   IDABUFDR+9
BUFDRFLG EQU   IDABUFDR+11
IDABUFC  EQU   0
BUFCAVL  EQU   IDABUFC
BUFCFLG1 EQU   IDABUFC+1
BUFCSEG  EQU   BUFCFLG1
BUFCVAL  EQU   BUFCFLG1
BUFCEXC  EQU   BUFCFLG1
BUFCIOFL EQU   IDABUFC+2
BUFCMW   EQU   BUFCIOFL
BUFCFLG2 EQU   IDABUFC+3
BUFCPLH  EQU   IDABUFC+4
BUFCDDDD EQU   IDABUFC+8
BUFCORBA EQU   IDABUFC+12
BUFCBAD  EQU   IDABUFC+20
BUFCINV  EQU   IDABUFC+28
BUFXIRBA EQU   IDABUFC+40
BUFXORBA EQU   IDABUFC+44
IDACIDF  EQU   0
CIDFLL   EQU   IDACIDF+2
IDAARDB  EQU   0
ARDTYPE  EQU   IDAARDB+1
ARDNPTR  EQU   IDAARDB+4
ARDHKRBA EQU   IDAARDB+8
ARDHRBA  EQU   IDAARDB+12
ARDERBA  EQU   IDAARDB+16
ARDPRF   EQU   IDAARDB+28
ARDKEYS  EQU   IDAARDB+29
IDAIXSPL EQU   0
IXSBFLG  EQU   IDAIXSPL+17
IDARDF   EQU   0
RDFRBYTE EQU   IDARDF
RDFSEG   EQU   RDFRBYTE
RDFNOT1  EQU   RDFSEG
RDF1ST   EQU   RDFSEG
IDADATA  EQU   0
IDAKEY   EQU   0
PLHPDL   EQU   0
PLHPDLE  EQU   0
PLHRRN   EQU   0
PLHEXTEN EQU   PLHEND
PLHBMWRK EQU   PLHEXTEN+5
BUFCRSC1 EQU   BUFCAVL
         AGO   .@UNREFD                START UNREFERENCED COMPONENTS
PLHBMSV5 EQU   PLHEXTEN+24
PLHBMSV4 EQU   PLHEXTEN+20
PLHBMSV3 EQU   PLHEXTEN+16
PLHBMSV2 EQU   PLHEXTEN+12
PLHBMSV1 EQU   PLHEXTEN+8
PLHRDCNT EQU   PLHEXTEN+6
PLHBMSOV EQU   PLHBMWRK
PLHBEUC  EQU   PLHBMWRK
PLHBMRDF EQU   PLHBMWRK
@NM00051 EQU   PLHEXTEN+4
PLHRESR1 EQU   PLHEXTEN
KEY      EQU   IDAKEY
AMDATA   EQU   IDADATA
RDFLL    EQU   IDARDF+1
RDFEMPTY EQU   RDFRBYTE
RDFREPL  EQU   RDFRBYTE
RDFCTNU  EQU   RDFRBYTE
RDFTYPE  EQU   RDFRBYTE
IXSLEP   EQU   IDAIXSPL+28
IXSSEP   EQU   IDAIXSPL+24
IXSHEP   EQU   IDAIXSPL+20
IXSPEC   EQU   IDAIXSPL+19
IXSEKON  EQU   IDAIXSPL+18
@NM00059 EQU   IXSBFLG
IXSLELV  EQU   IXSBFLG
IXSSSRH  EQU   IXSBFLG
IXSNOSR  EQU   IDAIXSPL+16
IXSKLEN  EQU   IDAIXSPL+14
IXSILN   EQU   IDAIXSPL+13
IXSTLN   EQU   IDAIXSPL+12
IXSARG   EQU   IDAIXSPL+8
IXSBUFC  EQU   IDAIXSPL+4
IXSSTRBA EQU   IDAIXSPL
@NM00058 EQU   ARDPRF
ARDPRFMT EQU   ARDPRF
ARDPRSS  EQU   ARDPRF
ARDRELNO EQU   IDAARDB+26
ARDVOLSR EQU   IDAARDB+20
ARDLEN   EQU   IDAARDB+2
ARDUSED  EQU   ARDTYPE
ARDEOD   EQU   ARDTYPE
ARDUOVFL EQU   ARDTYPE
ARDSS    EQU   ARDTYPE
ARDHLI   EQU   ARDTYPE
ARDKR    EQU   ARDTYPE
ARDID    EQU   IDAARDB
@NM00057 EQU   CIDFLL
CIDFBUSY EQU   CIDFLL
CIDFOSET EQU   IDACIDF
BUFCEND  EQU   IDABUFC+64
BUFCUCDN EQU   IDABUFC+60
BUFCUCUP EQU   IDABUFC+56
BUFCMDBT EQU   IDABUFC+52
BUFCHAIN EQU   IDABUFC+48
BUFCNXT2 EQU   IDABUFC+37
BUFCIDXL EQU   IDABUFC+36
BUFCDSPC EQU   IDABUFC+32
BUFCWLEN EQU   BUFCINV
BUFCNXT1 EQU   IDABUFC+24
BUFCCPA  EQU   IDABUFC+16
BUFCAMB  EQU   BUFCPLH
@NM00056 EQU   BUFCFLG2
BUFCEOD  EQU   BUFCFLG2
BUFCBSYW EQU   BUFCFLG2
BUFCBSYR EQU   BUFCFLG2
BUFCNLAS EQU   BUFCFLG2
BUFCXDDR EQU   BUFCFLG2
BUFCFIX  EQU   BUFCIOFL
BUFCPFCP EQU   BUFCIOFL
BUFCXEDB EQU   BUFCIOFL
BUFCWC   EQU   BUFCIOFL
BUFCREAL EQU   BUFCIOFL
BUFCRRD  EQU   BUFCIOFL
BUFCFMT  EQU   BUFCIOFL
BUFCEPT  EQU   BUFCFLG1
BUFCER2  EQU   BUFCFLG1
BUFCER1  EQU   BUFCFLG1
BUFCINS  EQU   BUFCFLG1
BUFCUPG  EQU   BUFCFLG1
BUFCUCNT EQU   BUFCAVL
@NM00055 EQU   IDABUFDR+16
BUFDBUFC EQU   IDABUFDR+12
@NM00054 EQU   BUFDRFLG
BUFDRAVL EQU   BUFDRFLG
BUFDRREL EQU   BUFDRFLG
BUFDRTSB EQU   IDABUFDR+10
BUFDRMAX EQU   BUFDRCIX
BUFDRPFN EQU   IDABUFDR+8
BUFDRPFB EQU   IDABUFDR+4
BUFDRLEN EQU   IDABUFDR+2
BUFDRNO  EQU   IDABUFDR+1
BUFDRID  EQU   IDABUFDR
AMDEXCP  EQU   AMDSTAT+44
AMDNCAS  EQU   AMDSTAT+40
AMDNCIS  EQU   AMDSTAT+36
AMDRETR  EQU   AMDSTAT+28
AMDUPR   EQU   AMDSTAT+24
AMDIREC  EQU   AMDSTAT+20
AMDDELR  EQU   AMDSTAT+16
AMDNLR   EQU   AMDSTAT+12
AMDNEXT  EQU   AMDSTAT+10
AMDNIL   EQU   AMDSTAT+8
AMDSTSP  EQU   AMDSTAT
@NM00053 EQU   IDAAMDSB+41
@NM00052 EQU   AMDATTR3
AMDLM    EQU   AMDATTR3
AMDWAIT  EQU   AMDATTR3
AMDBIND  EQU   AMDATTR3
AMDFAULT EQU   AMDATTR3
AMDUNQ   EQU   AMDATTR3
AMDPARDB EQU   IDAAMDSB+36
AMDMAXRR EQU   AMDSSRBA
AMDNSLOT EQU   AMDHLRBA
AMDLRECL EQU   IDAAMDSB+24
AMDFSCI  EQU   IDAAMDSB+16
AMDPCTCI EQU   IDAAMDSB+11
AMDPCTCA EQU   IDAAMDSB+10
AMDRKP   EQU   IDAAMDSB+6
AMDAXRKP EQU   AMDNEST
AMDLEN   EQU   IDAAMDSB+2
AMDSPAN  EQU   AMDATTR
AMDRRDS  EQU   AMDATTR
AMDRANGE EQU   AMDATTR
AMDORDER EQU   AMDATTR
AMDREPL  EQU   AMDATTR
AMDSDT   EQU   AMDATTR
AMDWCK   EQU   AMDATTR
AMDSBID  EQU   IDAAMDSB
PLHERRET EQU   IDAPLH+276
PLHASCB  EQU   IDAPLH+272
PLHECB   EQU   IDAPLH+268
@NM00050 EQU   IDAPLH+265
PLHDRMSK EQU   IDAPLH+264
PLHR13   EQU   IDAPLH+260
PLHPARM1 EQU   IDAPLH+256
PLHDRRSC EQU   IDAPLH+252
PLHSLRBA EQU   IDAPLH+244
PLHSRCSG EQU   IDAPLH+242
PLHLLOR  EQU   IDAPLH+236
PLHXPLH  EQU   PLHWAX
@NM00049 EQU   PLHIXSPL+8
PLHIXBFC EQU   PLHIXSPL+4
PLHHIREC EQU   PLHSSRBA
PLHISPLP EQU   IDAPLH+196
PLHRBUFC EQU   IDAPLH+192
PLHIBUFC EQU   IDAPLH+188
PLHDDDD  EQU   PLHEOVPT
PLHAR14  EQU   IDAPLH+176
@NM00048 EQU   IDAPLH+172
@NM00047 EQU   IDAPLH+168
PLHASAVE EQU   IDAPLH+164
PLHRETOS EQU   IDAPLH+118
PLHCHAIN EQU   IDAPLH+112
PLHAMB   EQU   IDAPLH+108
PLHSAVE6 EQU   IDAPLH+104
PLHSAVE5 EQU   IDAPLH+100
PLHSAVE4 EQU   IDAPLH+96
PLHSAVE3 EQU   IDAPLH+92
PLHSAVE2 EQU   IDAPLH+88
PLHSAVE1 EQU   IDAPLH+84
PLHARET  EQU   IDAPLH+80
PLHIIOB  EQU   PLHDIOB
PLHSRSID EQU   IDAPLH+74
PLHRDFC  EQU   IDAPLH+72
PLHNBUFC EQU   IDAPLH+56
PLHLRECL EQU   IDAPLH+48
@NM00046 EQU   IDAPLH+43
PLHRCODE EQU   IDAPLH+41
PLHUCODE EQU   PLHJCODE
PLHUPECB EQU   PLHJORBA
PLHDSIDA EQU   IDAPLH+24
PLHCRPL  EQU   IDAPLH+20
PLHMRPL  EQU   IDAPLH+16
PLHBFRNO EQU   IDAPLH+15
PLHRMIN  EQU   IDAPLH+13
PLHDSTYP EQU   IDAPLH+12
PLHACB   EQU   IDAPLH+8
PLHRAE   EQU   PLHAFLGS
PLHRABWD EQU   PLHAFLGS
PLHIOSID EQU   PLHAFLGS
PLHDBDC  EQU   PLHAFLGS
PLHVAMB  EQU   PLHAFLGS
PLHIOSRQ EQU   PLHAFLGS
PLHDRLM  EQU   PLHAFLGS
PLHEOVDF EQU   PLHFLG3
PLHRVRS  EQU   PLHFLG3
PLHBWD   EQU   PLHFLG3
PLHSLVLD EQU   PLHFLG3
PLHRAHD  EQU   PLHFLG3
PLHSRBSG EQU   PLHFLG3
@NM00045 EQU   PLHEFLGS+1
PLHRSTRT EQU   PLHEFLGS+1
PLHDSCAN EQU   PLHEFLGS
PLHINVAL EQU   PLHEFLGS
PLHEODX  EQU   PLHEFLGS
PLHNOADV EQU   PLHEFLGS
PLHSRINV EQU   PLHEFLGS
PLHSKPER EQU   PLHEFLGS
PLH1ST   EQU   PLHEFLGS
PLHIWAIT EQU   PLHFLG2
PLHSVADV EQU   PLHFLG2
PLHCIINS EQU   PLHFLG2
PLHADDTE EQU   PLHFLG2
PLHKEYMD EQU   PLHFLG2
PLHSQINS EQU   PLHFLG2
PLHUPD   EQU   PLHFLG2
@NM00044 EQU   PLHFLG1
PLHDRPND EQU   PLHFLG1
PLHASYRQ EQU   PLHFLG1
PLHRDEXC EQU   PLHFLG1
PLHSSR   EQU   PLHFLG1
PLHASKBF EQU   PLHFLG1
PLHEOVW  EQU   PLHFLG1
PLHATV   EQU   IDAPLH+1
PLHAVL   EQU   IDAPLH
PLHIOSDQ EQU   IDAPLHDR+12
PLHDRCUR EQU   IDAPLHDR+10
PLHDRMAX EQU   IDAPLHDR+8
PLHDRREQ EQU   IDAPLHDR+4
PLHELTH  EQU   IDAPLHDR+2
PLHCNT   EQU   IDAPLHDR+1
PLHID    EQU   IDAPLHDR
@NM00043 EQU   IDADIWA+92
@NM00042 EQU   IDADIWA+88
@NM00041 EQU   IDADIWA+84
@NM00040 EQU   IDADIWA+80
@NM00039 EQU   IDADIWA+76
@NM00038 EQU   IDADIWA+72
@NM00037 EQU   IDADIWA+68
@NM00036 EQU   IDADIWA+64
@NM00035 EQU   IDADIWA+60
@NM00034 EQU   IDADIWA+56
DIWINRBA EQU   IDADIWA+52
DIWRKCT  EQU   IDADIWA+48
DIWSPLTP EQU   IDADIWA+24
DIWBUFC  EQU   IDADIWA+20
DIWPLH   EQU   IDADIWA+16
DIWHRBA  EQU   IDADIWA+12
DIWLRBA  EQU   IDADIWA+8
@NM00033 EQU   IDADIWA+6
DIWSHIFT EQU   DIWFLG1
DIWPFERR EQU   DIWFLG1
DIWCISPL EQU   DIWFLG1
DIWCAS   EQU   DIWFLG1
DIWLEN   EQU   IDADIWA+2
DIWATV   EQU   IDADIWA+1
DIWID    EQU   IDADIWA
ACBAPID  EQU   ACBCOMN+72
ACBCBMWA EQU   ACBCOMN+68
ACBUAPTR EQU   ACBCOMN+64
ACBLRECL EQU   ACBCOMN+62
ACBMSGLN EQU   ACBBLKSZ
ACBBUFSP EQU   ACBCOMN+56
@NM00032 EQU   ACBUJFCB+1
ACBOPTN  EQU   ACBUJFCB
ACBVVIC  EQU   ACBINFLG
ACBUCRA  EQU   ACBINFLG
ACBSCRA  EQU   ACBINFLG
ACBCAT   EQU   ACBINFLG
ACBIJRQE EQU   ACBINFLG
ACBJEPS  EQU   ACBINFLG
@NM00031 EQU   ACBINFLG
ACBERFLG EQU   ACBCOMN+49
ACBBUSY  EQU   ACBIOSFG
ACBLOCK  EQU   ACBEXFG
@NM00030 EQU   ACBOFLGS
ACBDSERR EQU   ACBOFLGS
ACBOPEN  EQU   ACBOFLGS
ACBEOV   EQU   ACBOFLGS
@NM00029 EQU   ACBOFLGS
ACBDEB   EQU   ACBDDNM+5
ACBERFL  EQU   ACBDDNM+4
ACBAM    EQU   ACBAMETH
ACBINFL  EQU   ACBDDNM+2
ACBTIOT  EQU   ACBDDNM
ACBUEL   EQU   ACBEXLST
ACBPASSW EQU   ACBCOMN+32
ACBMSGAR EQU   ACBCOMN+28
@NM00028 EQU   ACBDSORG+1
ACBDORGA EQU   ACBDSORG+1
@NM00027 EQU   ACBDSORG
ACBCRNRE EQU   ACBCROPS
ACBCRNCK EQU   ACBCROPS
ACBASA   EQU   ACBCCTYP
@NM00026 EQU   ACBCCTYP
ACBRECAF EQU   ACBRECFM
ACBJBUF  EQU   ACBBUFPL+2
ACBMACR4 EQU   ACBBUFPL+1
@NM00025 EQU   ACBMACR3
ACBNCFX  EQU   ACBMACR3
ACBSIS   EQU   ACBMACR3
ACBDFR   EQU   ACBMACR3
ACBICI   EQU   ACBMACR3
ACBGSR   EQU   ACBMACR3
ACBLSR   EQU   ACBMACR3
@NM00024 EQU   ACBMACR3
ACBBUFNI EQU   ACBCOMN+18
ACBBUFND EQU   ACBCOMN+16
ACBSTRNO EQU   ACBCOMN+15
ACBBSTNO EQU   ACBCOMN+14
ACBAIX   EQU   ACBMACR2
ACBDSN   EQU   ACBMACR2
ACBRST   EQU   ACBMACR2
ACBLOGON EQU   ACBMACR2
ACBSKP   EQU   ACBMACR2
@NM00023 EQU   ACBMACR2
ACBUBF   EQU   ACBMACR1
ACBOUT   EQU   ACBMACR1
ACBIN    EQU   ACBMACR1
ACBDIR   EQU   ACBMACR1
ACBSEQ   EQU   ACBMACR1
ACBBLK   EQU   ACBCNV
ACBADD   EQU   ACBADR
ACBKEY   EQU   ACBMACR1
ACBINRTN EQU   ACBCOMN+8
ACBIBCT  EQU   ACBJWA
ACBLEN2  EQU   ACBLENG2
ACBSTYP  EQU   ACBCOMN+1
ACBID    EQU   ACBCOMN
IXKEY    EQU   IDAIXK
IXSELL   EQU   IDASELL
IBFLP1   EQU   IBFLP2
IBFLPL   EQU   IDAIBFLP+1
IBFLPF   EQU   IDAIBFLP
IXHSEO   EQU   IDAIXH+22
IXHLEO   EQU   IDAIXH+20
IXHFSO   EQU   IDAIXH+18
IXHFLGS  EQU   IDAIXH+17
IXHLV    EQU   IDAIXH+16
IXHXX    EQU   IDAIXH+12
IXHHP    EQU   IDAIXH+8
IXHBRBA  EQU   IDAIXH+4
IXHPTLS  EQU   IDAIXH+3
IXHFLPLN EQU   IDAIXH+2
IXHLL    EQU   IDAIXH
RPLERMSA EQU   RPLCOMN+72
RPLEMLEN EQU   RPLCOMN+70
RPLACTIV EQU   RPLCOMN+69
RPLBRANC EQU   RPLEXTD1
RPLNIB   EQU   RPLEXTD1
@NM00022 EQU   RPLEXTD1
RPLEXIT  EQU   RPLEXTD1
RPLNEXIT EQU   RPLEXTD1
RPLEXSCH EQU   RPLEXTD1
@NM00021 EQU   RPLRBAR+3
@NM00020 EQU   RPLAIXID
RPLAXPKP EQU   RPLAIXID
RPLAIXPC EQU   RPLRBAR
RPLRSV88 EQU   RPLOPT8
RPLUNCON EQU   RPLOPT8
RPLACTV  EQU   RPLOPT8
RPLSESS  EQU   RPLOPT8
RPLPEND  EQU   RPLOPT8
RPLODPRM EQU   RPLOPT8
RPLODACP EQU   RPLOPT8
RPLODACQ EQU   RPLOPT8
RPLRSV78 EQU   RPLOPT7
RPLRSV77 EQU   RPLOPT7
RPLRLSOP EQU   RPLOPT7
RPLTPOST EQU   RPLOPT7
RPLQOPT  EQU   RPLOPT7
RPLCNIMM EQU   RPLCNOPT
RPLCNANY EQU   RPLCNOPT
RPLCNALL EQU   RPLCNOPT
RPLRSV68 EQU   RPLOPT6
RPLRSV67 EQU   RPLOPT6
RPLLOCK  EQU   RPLOPT6
RPLNCOND EQU   RPLOPT6
RPLCOND  EQU   RPLOPT6
RPLEOT   EQU   RPLUNTYP
RPLEOM   EQU   RPLUNTYP
RPLEOB   EQU   RPLUNTYP
RPLWROPT EQU   RPLOPT5
RPLNODE  EQU   RPLOPT5
RPLERACE EQU   RPLWRTYP
RPLEAU   EQU   RPLWRTYP
RPLNERAS EQU   RPLWRTYP
RPLPSOPT EQU   RPLOPT5
RPLSSNIN EQU   RPLOPT5
RPLDLGIN EQU   RPLOPT5
RPLBUFL  EQU   RPLCOMN+52
RPLRLEN  EQU   RPLCOMN+48
RPLCHAIN EQU   RPLNXTRP
RPLOPT4  EQU   RPLOPTCD+3
RPLALIGN EQU   RPLOPT3
RPLFMT   EQU   RPLOPT3
RPLFLD   EQU   RPLOPT3
RPLVFY   EQU   RPLOPT3
RPLBLK   EQU   RPLOPT3
RPLSFORM EQU   RPLOPT3
RPLEODS  EQU   RPLOPT3
RPLNSP   EQU   RPLOPT2
RPLUPD   EQU   RPLOPT2
RPLWAITX EQU   RPLOPT2
RPLLRD   EQU   RPLOPT2
RPLBWD   EQU   RPLOPT2
RPLCNV   EQU   RPLOPT2
RPLADD   EQU   RPLADR
RPLKEY   EQU   RPLOPT2
RPLECBIN EQU   RPLECBSW
RPLGEN   EQU   RPLOPT1
RPLKGE   EQU   RPLOPT1
RPLASY   EQU   RPLOPT1
RPLSKP   EQU   RPLOPT1
RPLSEQ   EQU   RPLOPT1
RPLDIR   EQU   RPLOPT1
RPLLOC   EQU   RPLOPT1
RPLDAF   EQU   RPLARG+2
RPLSAF   EQU   RPLARG
RPLAREA  EQU   RPLCOMN+32
RPLTCBPT EQU   RPLCOMN+28
RPLCCHAR EQU   RPLCOMN+20
RPLSTRID EQU   RPLCOMN+18
RPLKEYL  EQU   RPLKEYLE
RPLRDSOH EQU   RPLFDB3
RPLRLG   EQU   RPLFDB3
RPLLGFRC EQU   RPLFDB3
RPLREOT  EQU   RPLFDB3
RPLREOM  EQU   RPLFDB3
RPLREOB  EQU   RPLFDB3
RPLSV32  EQU   RPLFDB3
RPLUINPT EQU   RPLFDB3
RPLSTSAV EQU   RPLFDB2
RPLCUERR EQU   RPLFDB2
RPLDLGFL EQU   RPLFDB2
RPLIOERR EQU   RPLFDB2
RPLDVUNS EQU   RPLFDB2
RPLATND  EQU   RPLFDB2
RPLRVID  EQU   RPLFDB2
RPLERLK  EQU   RPLFDB2
RPLSTAT  EQU   RPLFDBWD
RPLPOST  EQU   RPLECB
RPLWAIT  EQU   RPLECB
RPLPLHPT EQU   RPLCOMN+4
RPLLEN2  EQU   RPLLEN
RPLREQ   EQU   RPLIDWD+2
RPLSTYP  EQU   RPLIDWD+1
RPLID    EQU   RPLIDWD
AMBLCMB  EQU   IDAAMBL+64
AMBLBIB  EQU   IDAAMBL+60
AMBLIX   EQU   IDAAMBL+56
AMBLDTA  EQU   IDAAMBL+52
AMBLMIDS EQU   IDAAMBL+42
AMBLNIDS EQU   IDAAMBL+41
@NM00019 EQU   IDAAMBL+40
AMBLNUM  EQU   IDAAMBL+38
AMBLNST  EQU   IDAAMBL+37
@NM00018 EQU   AMBLFLG2
AMBLSTAG EQU   AMBLFLG2
@NM00017 EQU   AMBLFLG2
AMBLDUMY EQU   AMBLFLG1
AMBLCAT  EQU   AMBLFLG1
AMBLUCRA EQU   AMBLFLG1
AMBLSCRA EQU   AMBLFLG1
AMBLVVIC EQU   AMBLFLG1
AMBLUPD  EQU   AMBLFLG1
AMBLCINV EQU   AMBLFLG1
AMBLFULL EQU   AMBLFLG1
AMBLLEN  EQU   IDAAMBL+34
@NM00016 EQU   AMBLSHAR
AMBLWRIT EQU   AMBLSHAR
AMBLCATO EQU   AMBLSHAR
AMBLPRIM EQU   AMBLSHAR
AMBLID   EQU   IDAAMBL+32
@NM00015 EQU   IDAAMBL+31
@NM00014 EQU   AMBLTYPE
AMBLFIX  EQU   AMBLTYPE
AMBLBASE EQU   AMBLTYPE
AMBLAIX  EQU   AMBLTYPE
AMBLUPGR EQU   AMBLTYPE
AMBLPATH EQU   AMBLTYPE
AMBLENO  EQU   AMBLVC+1
AMBLVRT  EQU   AMBLVC
AMBLXPT  EQU   IDAAMBL+24
AMBLDFR  EQU   AMBLQ
AMBLESDS EQU   AMBLQ
AMBLKSDS EQU   AMBLQ
AMBLUBF  EQU   AMBLQ
AMBLFSTP EQU   AMBLQ
AMBLLSR  EQU   AMBLQ
AMBLGSR  EQU   AMBLQ
AMBLDDC  EQU   AMBLQ
AMBLDCI  EQU   AMBLIDF+4
AMBLCACB EQU   AMBLIDF
@NM00013 EQU   AMBLEOV+2
AMBLCOMP EQU   AMBLEOV+1
AMBLESET EQU   AMBLEFLG
AMBLWAIT EQU   AMBLEFLG
AMBLACB  EQU   IDAAMBL+8
AMBLSCHN EQU   IDAAMBL+4
AMBLPCHN EQU   IDAAMBL
AMBTRACE EQU   IDAAMB+120
AMBVIOT  EQU   IDAAMB+116
AMBSZCP  EQU   IDAAMB+114
AMBSZFW  EQU   IDAAMB+112
AMBSZWR  EQU   IDAAMB+110
AMBSZRD  EQU   IDAAMB+108
AMBEXEX  EQU   IDAAMB+100
AMBWSHD  EQU   IDAAMB+96
AMBCPA   EQU   IDAAMB+92
AMBBM2SH EQU   IDAAMB+88
AMBRDCNT EQU   AMBCSWD1+2
@NM00012 EQU   AMBCSWD1+1
@NM00011 EQU   AMBAFLG
AMBCFX   EQU   AMBAFLG
AMBSIS   EQU   AMBAFLG
AMBDFR   EQU   AMBAFLG
AMBICI   EQU   AMBAFLG
AMBGSR   EQU   AMBAFLG
AMBLSR   EQU   AMBAFLG
@NM00010 EQU   AMBAFLG
AMBUPLH  EQU   IDAAMB+80
AMBPAMBL EQU   IDAAMB+76
AMBPIXP  EQU   IDAAMB+72
@NM00009 EQU   IDAAMB+68
AMBWKA   EQU   IDAAMB+60
AMBAMBXN EQU   AMBEOVPT
AMBEDB   EQU   IDAAMB+52
AMBRPT   EQU   IDAAMB+50
AMBPUG   EQU   AMBFLG2
AMBBUSY  EQU   AMBOFLGS
AMBEXFG  EQU   AMBOFLGS
@NM00008 EQU   AMBOFLGS
AMBOPEN  EQU   AMBOFLGS
@NM00007 EQU   AMBOFLGS
AMBDEBAD EQU   AMBDEBPT+1
AMBIFLGS EQU   AMBDEBPT
AMBAMETH EQU   IDAAMB+43
AMBUCRA  EQU   AMBINFL
AMBSCRA  EQU   AMBINFL
AMBCAT   EQU   AMBINFL
@NM00006 EQU   AMBINFL
@NM00005 EQU   AMBINFL
AMBTIOT  EQU   IDAAMB+40
@NM00004 EQU   IDAAMB+38
AMBDDSN  EQU   IDAAMB+35
AMBCDSN  EQU   IDAAMB+32
AMBIOMB  EQU   AMBIOBAD
@NM00003 EQU   AMBDSORG+1
AMBDORGA EQU   AMBDSORG+1
@NM00002 EQU   AMBDSORG
AMBINBUF EQU   AMBFLG1
AMBUBF   EQU   AMBFLG1
AMBPCAT  EQU   AMBFLG1
AMBMCAT  EQU   AMBFLG1
AMBTYPE  EQU   AMBFLG1
AMBCREAT EQU   AMBFLG1
@NM00001 EQU   AMBFLG0
AMBPSDS  EQU   AMBFLG0
AMBCACB  EQU   IDAAMB+16
AMBPH    EQU   IDAAMB+12
AMBBUFC  EQU   IDAAMB+8
AMBLINK  EQU   IDAAMB+4
AMBLEN   EQU   IDAAMB+2
AMBRSC   EQU   IDAAMB+1
AMBID    EQU   IDAAMB
.@UNREFD ANOP                          END UNREFERENCED COMPONENTS
@RF00129 EQU   @RC00121
@RT00174 EQU   EOCAX
@RT00189 EQU   EOCAX
@RT00233 EQU   EOCAX
@RF00244 EQU   @EL00003
@RF00266 EQU   @EL00003
@RT00326 EQU   UPDARDB
@RT00410 EQU   CISPLITX
@RT00450 EQU   CISPLITX
@RT00477 EQU   CISPLITX
@RT00501 EQU   CISPLITX
@ENDDATA EQU   *
         END   IDA019SA,(C'PLS2214',0701,78172)
