         TITLE 'IDA019SN - TERMINATE RPL                               *
                        '
IDA019SN CSECT ,                                                   0001
@MAINENT DS    0H                                                  0001
         USING *,@15                                               0001
         B     @PROLOG                                             0001
         DC    AL1(16)                                             0001
         DC    C'IDA019SN  78.188'                                 0001
         DROP  @15
@PROLOG  BALR  @11,0                                               0001
@PSTART  DS    0H                                                  0001
         USING @PSTART,@11                                         0001
*                                                                  0157
*   /*****************************************************************/
*   /*                                                               */
*   /* TERMRPL MAIN ROUTINE                                          */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0157
*   RPLFDBWD=ZERO;                  /* CLEAR RPL FEEDBACK WORD       */
         SLR   @15,@15                                             0157
         ST    @15,RPLFDBWD(,RRPL)                                 0157
*   RBUFC=R14;                      /* SAVE RETURN ADDRESS           */
         LR    RBUFC,R14                                           0158
*   CALL VALCHK;                    /* CALL VALIDITY CHECK ROUTINE   */
         BAL   @14,VALCHK                                          0159
*   R14=RBUFC;                      /* RESTORE RETURN ADDRESS        */
         LR    R14,RBUFC                                           0160
*   IF RPLERREG=ZERO THEN           /* ANY ATTRIBUTE OR OPTION ERROR?*/
         CLI   RPLERREG(RRPL),0                                    0161
         BNE   @RF00161                                            0161
*     DO;                           /* NO ERROR, CONTINUE THE PROCESS*/
*                                                                  0162
*       /*************************************************************/
*       /*                                                           */
*       /* INITIALIZE PLH PUSH DOWN STACK OFFSET AND SAVE RETURN     */
*       /* ADDRESS BEFORE RELEASING THE RESOURCES.                   */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0163
*       PLHTERM=ON;                 /* SET TERMRPL IN PROCESS BIT    */
         OI    PLHTERM(RPLH),B'10000000'                           0163
*       PLHRETO=PLHRETOS;           /* CLEAR OFFSET OF PUSH DOWN   0164
*                                      STACK                         */
         LH    @15,PLHRETOS(,RPLH)                                 0164
         STH   @15,PLHRETO(,RPLH)                                  0164
*       GEN(IDASVR14);              /* SAVE RETURN ADDRESS IN PLH    */
*                                                                  0165
         IDASVR14
*       /*************************************************************/
*       /*                                                           */
*       /* RELEASE BUFC HEADER IF OWNED                              */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0166
*       IF PLHBUFHD=ON THEN         /* DOES PLH OWN THE BUFC HDR?    */
         TM    PLHBUFHD(RPLH),B'01000000'                          0166
         BNO   @RF00166                                            0166
*         DO;                       /* YES, RELEASE IT               */
*           BUFDRTSB=CZERO;         /* RELEASE BUFC HEADER           */
         L     @15,AMBBUFC(,RAMB)                                  0168
         MVI   BUFDRTSB(@15),B'00000000'                           0168
*           PLHTMBUF=ON;            /* SET PROCESS BIT IN PLH        */
         OI    PLHTMBUF(RPLH),B'01000000'                          0169
*         END;                      /* END OF BUFC HDR CASE          */
*       ELSE                                                       0171
*         ;                         /* ELSE NOT OWN BUFC HDR         */
@RF00166 DS    0H                                                  0172
*       RAMB=AMBLIX;                /* LOAD INDEX AMB                */
         L     @15,RPLDACB(,RRPL)                                  0172
         L     @15,ACBAMBL(,@15)                                   0172
         L     RAMB,AMBLIX(,@15)                                   0172
*       IF RAMB^=ZERO THEN          /* IS IT A KSDS ?                */
         LTR   RAMB,RAMB                                           0173
         BZ    @RF00173                                            0173
*         CALL RELINX;              /* CALL RELINX TO RELEASE INDEX
*                                      BUFC                          */
         BAL   @14,RELINX                                          0174
*       ELSE                                                       0175
*         ;                         /* ELSE NOT A KSDS               */
@RF00173 DS    0H                                                  0176
*       RAMB=AMBLDTA;               /* RESET AMB BASE                */
         L     @15,RPLDACB(,RRPL)                                  0176
         L     @15,ACBAMBL(,@15)                                   0176
         L     RAMB,AMBLDTA(,@15)                                  0176
*       CALL RELDIWA;               /* CALL RELDIWA TO RELEASE DIWA  */
         BAL   @14,RELDIWA                                         0177
*       CALL RELDTA;                /* CALL RELDTA TO RELEASE DATA 0178
*                                      BUFC                          */
         BAL   @14,RELDTA                                          0178
*                                                                  0179
*       /*************************************************************/
*       /*                                                           */
*       /* TERMRPL WILL ATTEMPT TO RESTART DEFERRED REQUESTS BY      */
*       /* CALLING IDARSTRT ROUTINE. IDARSTRT WILL NOT RESTART       */
*       /* ASYNCHRONOUS DEFERRED REQUEST AND WILL RETURN AN          */
*       /* INFORMATION CODE TO THE USER TO INDICATE THE SITUATION.   */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0179
*       IF PLHDRREQ^=ZERO THEN      /* ANY DEFERRED REQUEST ?        */
         L     @15,AMBPH(,RAMB)                                    0179
         L     @15,PLHDRREQ(,@15)                                  0179
         LTR   @15,@15                                             0179
         BZ    @RF00179                                            0179
*I01:                                                              0180
*         DO;                       /* IDACALL(IDARSTRT)             */
I01      DS    0H                                                  0181
*           CALL IDARSTRT;          /* EXIT TO IDARSTRT              */
         L     @15,@CV00992                                        0181
         BALR  @14,@15                                             0181
*           GEN(BALR @11,0);        /* LOAD ADDR OF REENTRY          */
         BALR @11,0
*           GEN(USING *,@11);       /* ESTABLISH ADDRESSING          */
         USING *,@11
*           GEN(L     @11,=A(@PSTART));/* RELOAD BASE                */
         L     @11,=A(@PSTART)
*           GEN(USING @PSTART,@11); /* ESTABLISH ADDRESSING          */
         USING @PSTART,@11
*         END I01;                  /* TRY TO RESTART THEM           */
*       ELSE                                                       0187
*         ;                         /* NO DEFERRED REQUEST           */
@RF00179 DS    0H                                                  0188
*       GEN REFS(HWORD4)(IDARST14); /* RESTORE RETURN ADDRESS        */
         IDARST14
*       RFY                                                        0189
*         R14 RSTD;                                                0189
*                                                                  0189
*       /*************************************************************/
*       /*                                                           */
*       /* DISCONNECT THE PLH                                        */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0190
*       IF PLHDBPER=OFF THEN        /* ANY ERROR IN THE BUFC PTR?    */
         TM    PLHDBPER(RPLH),B'00000010'                          0190
         BNZ   @RF00190                                            0190
*         DO;                       /* NO ERROR, DISCONNECT PLH      */
*           PLHFLG1=CZERO;          /* CLEAR PROCESS FLAGS IN PLH    */
         MVI   PLHFLG1(RPLH),B'00000000'                           0192
*           PLHFLG2=CZERO;                                         0193
         MVI   PLHFLG2(RPLH),B'00000000'                           0193
*           PLHFLG3=CZERO;                                         0194
         MVI   PLHFLG3(RPLH),B'00000000'                           0194
*           PLHEFLGS=C2ZERO;                                       0195
         MVC   PLHEFLGS(2,RPLH),C2ZERO                             0195
*           PLHINVAL=ON;            /* SET PLH INVALID               */
         OI    PLHINVAL(RPLH),B'00000010'                          0196
*           PLHARDB=ZERO;           /* ZERO ARDB FIELD               */
         SLR   @15,@15                                             0197
         ST    @15,PLHARDB(,RPLH)                                  0197
*           PLHMRPL=ZERO;           /* DISCONNECT PLH                */
         ST    @15,PLHMRPL(,RPLH)                                  0198
*           PLHDRCUR=PLHDRCUR-ONE;  /* DECREMENT COUNT               */
         L     @15,AMBPH(,RAMB)                                    0199
         LH    @10,PLHDRCUR(,@15)                                  0199
         BCTR  @10,0                                               0199
         STH   @10,PLHDRCUR(,@15)                                  0199
*           PLHAVL=CZERO;           /* SET PLH AVAILABLE             */
         MVI   PLHAVL(RPLH),B'00000000'                            0200
*           IF RPLECBSW=ON THEN     /* EXTERNAL ECB ?                */
         TM    RPLECBSW(RRPL),B'00000001'                          0201
         BNO   @RF00201                                            0201
*             USERECB=POSTED;       /* SET POST FLAG IN USER ECB     */
         L     @15,RPLECB(,RRPL)                                   0202
         MVC   USERECB(4,@15),POSTED                               0202
*           ELSE                                                   0203
*             RPLECB=POSTED;        /* ELSE SET POST FLAG IN RPLECB  */
         B     @RC00201                                            0203
@RF00201 L     @15,POSTED                                          0203
         ST    @15,RPLECB(,RRPL)                                   0203
*           RPLACTIV=CZERO;         /* SET RPL INACTIVE              */
@RC00201 MVI   RPLACTIV(RRPL),B'00000000'                          0204
*         END;                      /* END OF NO BUFC PTR ERROR      */
*       ELSE                                                       0206
*         ;                         /* ELSE, DATA BUFC PTR ERROR     */
@RF00190 DS    0H                                                  0207
*     END;                          /* END OF VALID REQUEST CASE     */
*   ELSE                                                           0208
*     ;                             /* ELSE ERROR, RETURN            */
@RF00161 DS    0H                                                  0209
*   RETURN;                         /* RETURN TO CALLER              */
@EL00001 DS    0H                                                  0209
@EF00001 DS    0H                                                  0209
@ER00001 BR    @14                                                 0209
*                                                                  0210
*/********************************************************************
**  VALCHK: ROUTINE USED TO VALIDITY CHECK THE DATA SET ATTRIBUTES,  *
**          RPL OPTIONS, AND PROCESSING CONDITIONS OF THE TERMRPL    *
**          REQUEST.  IF AN ERROR IS FOUND, SET RPLERREG AND         *
**          RPLERRCD AND RETURN.  R14 IS RESTRICTED IN THIS ROUTINE. *
******************************************************************** */
*                                                                  0210
*VALCHK:                                                           0210
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);                               0210
VALCHK   DS    0H                                                  0211
*   RFY                                                            0211
*     RWORK1 RSTD;                                                 0211
*   RWORK1=ZERO;                    /* CLEAR WORK REGISTER           */
*                                                                  0212
         SLR   RWORK1,RWORK1                                       0212
*   /*****************************************************************/
*   /*                                                               */
*   /* CHECK IF THE PREVIOUS REQUEST WAS TERMRPL, IF YES, SET ERROR  */
*   /* CODE.                                                         */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0213
*   IF PLHTERM=ON THEN              /* IS TERMRPL IN PROCESS BIT ON? */
         TM    PLHTERM(RPLH),B'10000000'                           0213
         BNO   @RF00213                                            0213
*     RWORK1=RPLPTERM;              /* YES, THE PREVIOUS REQUEST IS
*                                      TERMRPL                       */
         LA    RWORK1,52                                           0214
*   ELSE                                                           0215
*     ;                             /* ELSE CONTINUE                 */
*                                                                  0215
@RF00213 DS    0H                                                  0216
*   /*****************************************************************/
*   /*                                                               */
*   /* VALIDITY CHECK DATA SET ATTRIBUTES, RPL OPTIONS, AND          */
*   /* PROCESSING OPTIONS.                                           */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0216
*   IF RPLCNV=ON|RPLASY=ON|RPLCHAIN^=ZERO|/* INVALID RPL OPTIONS     */
*       AMBLPATH=ON|AMBCREAT=ON|    /* INVALID PROCESSING OPTIONS    */
*       AMBGSR=ON|AMBLSR=ON|        /* INVALID PROCESSING OPTIONS    */
*       AMDRRDS=ON|AMDSPAN=ON       /* INVALID DATASET ATTRIBUTES    */
*     THEN                                                         0216
         TM    RPLCNV(RRPL),B'00100000'                            0216
         BO    @RT00216                                            0216
         TM    RPLASY(RRPL),B'00001000'                            0216
         BO    @RT00216                                            0216
         L     @15,RPLCHAIN(,RRPL)                                 0216
         LTR   @15,@15                                             0216
         BNZ   @RT00216                                            0216
         L     @15,RPLDACB(,RRPL)                                  0216
         L     @15,ACBAMBL(,@15)                                   0216
         TM    AMBLPATH(@15),B'10000000'                           0216
         BO    @RT00216                                            0216
         TM    AMBCREAT(RAMB),B'10000000'                          0216
         BO    @RT00216                                            0216
         TM    AMBGSR(RAMB),B'01100000'                            0216
         BNZ   @RT00216                                            0216
         L     @15,AMBDSB(,RAMB)                                   0216
         TM    AMDRRDS(@15),B'00000011'                            0216
         BZ    @RF00216                                            0216
@RT00216 DS    0H                                                  0217
*     RWORK1=RPLINTRM;              /* SET ERROR CODE                */
         LA    RWORK1,48                                           0217
*   ELSE                                                           0218
*     DO;                           /* ELSE VALID REQUEST            */
*                                                                  0218
         B     @RC00216                                            0218
@RF00216 DS    0H                                                  0219
*       /*************************************************************/
*       /*                                                           */
*       /* CHECK IF USER IS IN SUPERVISOR STATE AND KEY 0            */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0219
*       RFY                                                        0219
*        (RWORK2,                                                  0219
*         R15) RSTD;                                               0219
*       RWORK2=RRPL;                /* SAVE RPL ADDRESS              */
         LR    RWORK2,RRPL                                         0220
*       GEN(TESTAUTH STATE=YES,RBLEVEL=1);/* TEST FOR SUPV. STATE    */
         TESTAUTH STATE=YES,RBLEVEL=1
*       RRPL=RWORK2;                /* RESTORE RPL ADDRESS           */
         LR    RRPL,RWORK2                                         0222
*       IF R15^=ZERO THEN           /* NOT SUPV. STATE               */
         LTR   R15,R15                                             0223
         BZ    @RF00223                                            0223
*         RWORK1=RPLINTRM;          /* SET ERROR CODE                */
         LA    RWORK1,48                                           0224
*       ELSE                                                       0225
*         DO;                       /* ELSE TEST FOR KEY 0           */
         B     @RC00223                                            0225
@RF00223 DS    0H                                                  0226
*           RWORK2=RPLH;            /* SAVE REGISTER 2               */
         LR    RWORK2,RPLH                                         0226
*           RPLH=ZERO;              /* CLEAR WORK REGISTER           */
         SLR   RPLH,RPLH                                           0227
*           GEN(IPK);               /* OBTAIN KEY                    */
         IPK
*           IF RPLH^=ZERO THEN      /* KEY 0 ?                       */
         LTR   RPLH,RPLH                                           0229
         BZ    @RF00229                                            0229
*             DO;                   /* NO                            */
*               RPLH=RWORK2;        /* RESTORE REGISTER 2            */
         LR    RPLH,RWORK2                                         0231
*               RWORK1=RPLINTRM;    /* SET ERROR CODE                */
         LA    RWORK1,48                                           0232
*             END;                  /* END OF ERROR CASE             */
*           ELSE                                                   0234
*             DO;                   /* SUPV. STATE AND KEY 0         */
         B     @RC00229                                            0234
@RF00229 DS    0H                                                  0235
*               RPLH=RWORK2;        /* RESTORE REG2                  */
*                                                                  0235
         LR    RPLH,RWORK2                                         0235
*               /*****************************************************/
*               /*                                                   */
*               /* IF EOV WAS IN PROCESS (PLHINEOV = ON) WHEN THE    */
*               /* REQUEST WAS TERMINATED, THE REQUEST WILL BE       */
*               /* REJECTED AND AN ERROR CODE WILL BE RETURNED TO THE*/
*               /* USER.                                             */
*               /*                                                   */
*               /*****************************************************/
*                                                                  0236
*               IF PLHINEOV=ON THEN /* WAS EOV IN PROCESS?           */
         TM    PLHINEOV(RPLH),B'10000000'                          0236
         BNO   @RF00236                                            0236
*                 RWORK1=RPLINTRM;  /* SET ERROR CODE                */
*                                                                  0237
         LA    RWORK1,48                                           0237
*               /*****************************************************/
*               /*                                                   */
*               /* IF THE IOMB IS LOCKED BY I/O MANAGEMENT ROUTINES, */
*               /* THE REQUEST WAS TERMINATED DURING ITS I/O         */
*               /* OPERATION, POSSIBLE DATA SET ERROR, SET           */
*               /* INFORMATION CODE TO WARN THE USER.                */
*               /*                                                   */
*               /*****************************************************/
*                                                                  0238
*               ELSE                                               0238
*                 IF IOMLOCK^=ZERO&IOMEOVTS=OFF THEN               0238
         B     @RC00236                                            0238
@RF00236 L     @10,PLHDIOB(,RPLH)                                  0238
         CLI   IOMLOCK(@10),0                                      0238
         BE    @RF00238                                            0238
         TM    IOMEOVTS(@10),B'00100000'                           0238
         BNZ   @RF00238                                            0238
*                   DO;             /* IOMB LOCKED BY I/O MANAGER    */
*                     RPLERRCD=RPLDSERR;/* SET INFORMATION CODE      */
         MVI   RPLERRCD(RRPL),X'24'                                0240
*                     PLHDSERR=ON;  /* SET FDBK INDICATOR IN PLH     */
         OI    PLHDSERR(RPLH),B'00000100'                          0241
*                     IOECB=POSTED; /* SET POST FLAG                 */
         L     @07,IOMECBPT(,@10)                                  0242
         MVC   IOECB(4,@07),POSTED                                 0242
*                     IOMLOCK=OFF;  /* RELEASE IOMB                  */
         MVI   IOMLOCK(@10),B'00000000'                            0243
*                     PLHTMIOB=ON;  /* SET PROCESS BIT IN PLH        */
         OI    PLHTMIOB(RPLH),B'00000100'                          0244
*                   END;            /* END OF IOMB LOCKED CASE       */
*             END;                  /* END OF KEY 0 CASE             */
@RF00238 DS    0H                                                  0246
@RC00236 DS    0H                                                  0247
*         END;                      /* END OF SUPV. STATE CASE       */
@RC00229 DS    0H                                                  0248
*     END;                          /* END OF VALIDITY CHECK         */
@RC00223 DS    0H                                                  0249
*   RFY                                                            0249
*    (RWORK2,                                                      0249
*     R15) UNRSTD;                                                 0249
@RC00216 DS    0H                                                  0250
*   IF RWORK1^=ZERO THEN            /* ANY ERROR ?                   */
         LTR   RWORK1,RWORK1                                       0250
         BZ    @RF00250                                            0250
*     DO;                           /* YES                           */
*       RPLERREG='08'X;             /* SET LOGICAL ERROR             */
         MVI   RPLERREG(RRPL),X'08'                                0252
*       RPLERRCD=RWORK1;            /* SET FEEDBACK CODE             */
         STC   RWORK1,RPLERRCD(,RRPL)                              0253
*     END;                          /* END OF ERROR CASE             */
*   ELSE                                                           0255
*     ;                             /* NO ERROR                      */
@RF00250 DS    0H                                                  0256
*   RFY                                                            0256
*     RWORK1 UNRSTD;                                               0256
*   RETURN;                         /* RETURN TO MAIN ROUTINE        */
@EL00002 DS    0H                                                  0257
@EF00002 DS    0H                                                  0257
@ER00002 BR    @14                                                 0257
*   END VALCHK;                     /* END OF VALCHK PROC.           */
*                                                                  0259
*/* ******************************************************************
*  * RELINX: ROUTINE USED TO RELEASE THE INDEX BUFC(S) THAT IS OWNED *
*  *         BY THE SPECIFIED PLH.                                   *
*  *******************************************************************/
*                                                                  0259
*RELINX:                                                           0259
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);                               0259
RELINX   DS    0H                                                  0260
*   GEN(IDASVR14);                  /* SAVE RETURN ADDRESS           */
         IDASVR14
*   RFY                                                            0261
*     R14 UNRSTD;                                                  0261
*                                                                  0261
*   /*****************************************************************/
*   /*                                                               */
*   /* CHECK INDEX BUFC CHAIN AND RELEASE ALL OWNED INDEX BUFC'S     */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0262
*   RBUFC=BUFDBUFC;                 /* LOAD FIRST INDEX BUFC         */
         L     @10,AMBBUFC(,RAMB)                                  0262
         L     RBUFC,BUFDBUFC(,@10)                                0262
*   DO UNTIL RBUFC=ZERO;            /* LOOP THROUGH BUFC CHAIN       */
@DL00263 DS    0H                                                  0264
*     IF BUFCPLH=RPLH THEN          /* DOES PLH OWN BUFC?            */
         C     RPLH,BUFCPLH(,RBUFC)                                0264
         BNE   @RF00264                                            0264
*       DO;                         /* YES                           */
*         IF BUFCMW=ON THEN         /* MUST WRITE BIT ON?            */
         TM    BUFCMW(RBUFC),B'10000000'                           0266
         BNO   @RF00266                                            0266
*           DO;                     /* YES                           */
*             RPLERRCD=RPLDSERR;    /* SET FEEDBACK CODE             */
         MVI   RPLERRCD(RRPL),X'24'                                0268
*             PLHDSERR=ON;          /* SET FDBK INDICATOR IN PLH     */
         OI    PLHDSERR(RPLH),B'00000100'                          0269
*             BUFCMW=OFF;           /* SET MUST WRITE BIT OFF        */
         NI    BUFCMW(RBUFC),B'01111111'                           0270
*           END;                    /* END OF MUST WRITE CASE        */
*         ELSE                                                     0272
*           ;                       /* ELSE NO MUST WRITE DATA       */
@RF00266 DS    0H                                                  0273
*         BUFCVAL=OFF;              /* INVALIDATE BUFC               */
         NI    BUFCVAL(RBUFC),B'11111011'                          0273
*I02:                                                              0274
*         DO;                       /* IDACALL(IDAFREEB)             */
I02      DS    0H                                                  0275
*           CALL IDAFREEB;          /* EXIT TO IDAFREEB              */
         L     @15,@CV00991                                        0275
         BALR  @14,@15                                             0275
*           GEN(BALR @11,0);        /* LOAD ADDR OF REENTRY          */
         BALR @11,0
*           GEN(USING *,@11);       /* ESTABLISH ADDRESSING          */
         USING *,@11
*           GEN(L     @11,=A(@PSTART));/* RELOAD BASE                */
         L     @11,=A(@PSTART)
*           GEN(USING @PSTART,@11); /* ESTABLISH ADDRESSING          */
         USING @PSTART,@11
*         END I02;                  /* FREE BUFC                     */
*         PLHTMINX=ON;              /* TURN PROCESS BIT ON           */
         OI    PLHTMINX(RPLH),B'00001000'                          0281
*       END;                        /* END OF OWNED CASE             */
*     ELSE                                                         0283
*       ;                           /* ELSE NOT OWNED BY PLH         */
@RF00264 DS    0H                                                  0284
*     RBUFC=BUFCHAIN;               /* GET NEXT BUFC IN CHAIN        */
         L     RBUFC,BUFCHAIN(,RBUFC)                              0284
*   END;                            /* END OF DO-UNTIL               */
@DE00263 LTR   RBUFC,RBUFC                                         0285
         BNZ   @DL00263                                            0285
*   GEN REFS(HWORD4)(IDARST14);     /* RESTORE RETURN ADDRESS        */
         IDARST14
*   RETURN;                         /* RETURN TO MAIN ROUTINE        */
@EL00003 DS    0H                                                  0287
@EF00003 DS    0H                                                  0287
@ER00003 BR    @14                                                 0287
*   END RELINX;                     /* END OF RELINX PROC.           */
*                                                                  0289
*/********************************************************************/
*/*  RELDIWA: ROUTINE USED TO RELEASE THE DIWA IF OWNED.             */
*/*                                                                  */
*/*  FUNCTION: CHECK IF THIS REQUEST OWNS THE DIWA, FREE THE INSERT  */
*/*            BUFFER BEFORE RELEASING THE DIWA.  THE INSERT BUFFER  */
*/*            CAN BE RELEASED IN ONE OF TWO WAYS:                   */
*/*            (1) IF THE INSERT BUFFER WAS SWAPPED WITH THE DATA    */
*/*                BUFC BY THE CI SPLIT ROUTINE, IT HAS TO BE        */
*/*                SWAPPED BACK AND FREED BY IDAFREEB.               */
*/*            (2) IF THE INSERT BUFFER WAS ADDED TO THE DATA BUFFER */
*/*                CHAIN, IT HAS TO BE SUBTRACTED FROM THE CHAIN BY  */
*/*                IDASBF.                                           */
*/********************************************************************/
*                                                                  0289
*RELDIWA:                                                          0289
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);                               0289
RELDIWA  DS    0H                                                  0290
*   GEN(IDASVR14);                  /* SAVE RETURN ADDRESS           */
         IDASVR14
*   IF DIWATV^=ZERO THEN            /* IS DIWA BUSY?                 */
         L     @10,AMBIWA(,RAMB)                                   0291
         CLI   DIWATV(@10),0                                       0291
         BE    @RF00291                                            0291
*     IF DIWPLH=RPLH THEN           /* DOES PLH OWN DIWA ?           */
         C     RPLH,DIWPLH(,@10)                                   0292
         BNE   @RF00292                                            0292
*       DO;                         /* YES                           */
*                                                                  0293
*         /***********************************************************/
*         /*                                                         */
*         /* CHECK IF A SWAP WAS DONE BETWEEN THE INSERT BUFFER      */
*         /* POINTER (DIWBUFC) AND THE DATA BUFC POINTER (PLHDBUFC)  */
*         /*                                                         */
*         /***********************************************************/
*                                                                  0294
*         IF DIWBUFC^=BUFDBUFC THEN /* DOES DIWBUFC PT TO INSERT BUF?*/
         L     @05,DIWBUFC(,@10)                                   0294
         L     @15,AMBBUFC(,RAMB)                                  0294
         L     @15,BUFDBUFC(,@15)                                  0294
         CR    @05,@15                                             0294
         BE    @RF00294                                            0294
*           IF PLHDBUFC=BUFDBUFC THEN/* PLH PTS TO INSERT BUFC?      */
         C     @15,PLHDBUFC(,RPLH)                                 0295
         BNE   @RF00295                                            0295
*             DO;                   /* YES, SWAP                     */
*               PLHDBUFC=DIWBUFC;   /* RESTORE DATA BUFC PTR         */
         ST    @05,PLHDBUFC(,RPLH)                                 0297
*               DIWBUFC=BUFDBUFC;   /* RESTORE INSERT BUFC PTR       */
         ST    @15,DIWBUFC(,@10)                                   0298
*             END;                  /* END OF SWAP CASE              */
*           ELSE                    /* ELSE DATA BUFC PTR INCORRECT  */
*             DO;                   /* SEARCH DATA BUFC CHAIN        */
         B     @RC00295                                            0300
@RF00295 DS    0H                                                  0301
*               DIWBUFC=BUFDBUFC;   /* RESET INSERT BUF. PTR         */
         L     @10,AMBIWA(,RAMB)                                   0301
         L     @05,AMBBUFC(,RAMB)                                  0301
         L     @05,BUFDBUFC(,@05)                                  0301
         ST    @05,DIWBUFC(,@10)                                   0301
*               CALL FINDBUF;       /* CALL FINDBUFC ROUTINE         */
         BAL   @14,FINDBUF                                         0302
*             END;                  /* END OF ERROR CASE             */
*         ELSE                      /* DIWBUFC PTS TO INSERT BUF     */
*           IF PLHDBUFC=DIWBUFC THEN/* PLHDBUFC PTS TO INSERT BUF?   */
         B     @RC00294                                            0304
@RF00294 L     @10,AMBIWA(,RAMB)                                   0304
         CLC   PLHDBUFC(4,RPLH),DIWBUFC(@10)                       0304
         BNE   @RF00304                                            0304
*             CALL FINDBUF;         /* YES, SEARCH FOR DATA BUF PTR  */
         BAL   @14,FINDBUF                                         0305
*           ELSE                                                   0306
*             ;                     /* ELSE PLHDBUFC IS GOOD         */
@RF00304 DS    0H                                                  0307
*         RBUFC=DIWBUFC;            /* LOAD INSERT BUFC ADDR.        */
@RC00294 L     @10,AMBIWA(,RAMB)                                   0307
         L     RBUFC,DIWBUFC(,@10)                                 0307
*         IF BUFCMW=ON THEN         /* IS MUST WRITE BIT ON?         */
         TM    BUFCMW(RBUFC),B'10000000'                           0308
         BNO   @RF00308                                            0308
*           DO;                     /* YES                           */
*             RPLERRCD=RPLDSERR;    /* SET INFORMATION CODE          */
         MVI   RPLERRCD(RRPL),X'24'                                0310
*             PLHDSERR=ON;          /* SET FDBK INDICATOR IN PLH     */
         OI    PLHDSERR(RPLH),B'00000100'                          0311
*             BUFCMW=OFF;           /* RESET MUST WRITE BIT          */
         NI    BUFCMW(RBUFC),B'01111111'                           0312
*           END;                    /* END OF MUST WRITE CASE        */
*         ELSE                                                     0314
*           ;                       /* ELSE MUST WRITE BIT NOT ON    */
*                                                                  0314
@RF00308 DS    0H                                                  0315
*         /***********************************************************/
*         /*                                                         */
*         /* IF THE INSERT BUFFER IS NOT IN THE DATA BUFFER CHAIN,   */
*         /* CALL IDAFREEB TO FREE THE BUFFER                        */
*         /*                                                         */
*         /***********************************************************/
*                                                                  0315
*         IF RBUFC=BUFCNXT2 THEN    /* NOT IN DATA BUFFER CHAIN?     */
         L     @10,BUFCNXT2-1(,RBUFC)                              0315
         LA    @10,0(,@10)                                         0315
         CR    RBUFC,@10                                           0315
         BNE   @RF00315                                            0315
*I03:                                                              0316
*           DO;                     /* IDACALL(IDAFREEB)             */
I03      DS    0H                                                  0317
*             CALL IDAFREEB;        /* EXIT TO IDAFREEB              */
         L     @15,@CV00991                                        0317
         BALR  @14,@15                                             0317
*             GEN(BALR @11,0);      /* LOAD ADDR OF REENTRY          */
         BALR @11,0
*             GEN(USING *,@11);     /* ESTABLISH ADDRESSING          */
         USING *,@11
*             GEN(L     @11,=A(@PSTART));/* RELOAD BASE              */
         L     @11,=A(@PSTART)
*             GEN(USING @PSTART,@11);/* ESTABLISH ADDRESSING         */
         USING @PSTART,@11
*           END I03;                /* FREE INSERT BUFFER            */
*                                                                  0322
*         /***********************************************************/
*         /*                                                         */
*         /* IF THE INSERT BUFFER IS IN THE DATA BUFFER CHAIN, CALL  */
*         /* IDASBF TO SUBTRACT THE INSERT BUFFER FROM THE CHAIN.    */
*         /*                                                         */
*         /***********************************************************/
*                                                                  0323
*         ELSE                                                     0323
*I04:                                                              0323
*           DO;                     /* IDACALL(IDASBF)               */
         B     @RC00315                                            0323
@RF00315 DS    0H                                                  0323
I04      DS    0H                                                  0324
*             CALL IDASBF;          /* EXIT TO IDASBF                */
         L     @15,@CV00990                                        0324
         BALR  @14,@15                                             0324
*             GEN(BALR @11,0);      /* LOAD ADDR OF REENTRY          */
         BALR @11,0
*             GEN(USING *,@11);     /* ESTABLISH ADDRESSING          */
         USING *,@11
*             GEN(L     @11,=A(@PSTART));/* RELOAD BASE              */
         L     @11,=A(@PSTART)
*             GEN(USING @PSTART,@11);/* ESTABLISH ADDRESSING         */
         USING @PSTART,@11
*           END I04;                /* SUBTRACT INSERT BUFFER IF IN
*                                      DATA BUFFER CHAIN             */
*         DIWATV=ZERO;              /* RELEASE DIWA                  */
@RC00315 L     @10,AMBIWA(,RAMB)                                   0330
         MVI   DIWATV(@10),X'00'                                   0330
*         PLHTMDIW=ON;              /* SET PROCESS BIT IN PLH        */
         OI    PLHTMDIW(RPLH),B'00100000'                          0331
*       END;                        /* END OF DIWA CASE              */
*     ELSE                                                         0333
*       ;                           /* ELSE PLH DOES NOT OWN DIWA    */
@RF00292 DS    0H                                                  0334
*   ELSE                                                           0334
*     ;                             /* ELSE DIWA NOT BUSY            */
@RF00291 DS    0H                                                  0335
*   GEN REFS(HWORD4)(IDARST14);     /* RESTORE RETURN ADDRESS        */
         IDARST14
*   RETURN;                         /* RETURN TO MAIN ROUTINE        */
@EL00004 DS    0H                                                  0336
@EF00004 DS    0H                                                  0336
@ER00004 BR    @14                                                 0336
*   END RELDIWA;                    /* END OF RELDIWA PROC.          */
*                                                                  0338
*   /*****************************************************************/
*   /*                                                               */
*   /* FINDBUF: ROUTINE USED TO SEARCH THROUGH DATA BUFC CHAIN TO    */
*   /* FIND A DATA BUFC THAT BELONGS TO THIS PLH                     */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0338
*FINDBUF:                                                          0338
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);                               0338
FINDBUF  DS    0H                                                  0339
*   RFY                                                            0339
*     R14 RSTD;                                                    0339
*   RBUFC=BUFDBUFC->BUFCHAIN;       /* GET 1ST DATA BUFC             */
         L     @15,AMBBUFC(,RAMB)                                  0340
         L     @15,BUFDBUFC(,@15)                                  0340
         L     RBUFC,BUFCHAIN(,@15)                                0340
*   DO UNTIL RBUFC=ZERO;            /* SEARCH DATA BUF CHAIN         */
@DL00341 DS    0H                                                  0342
*     IF BUFCAVL^=CZERO&BUFCPLH=RPLH THEN                          0342
         CLI   BUFCAVL(RBUFC),B'00000000'                          0342
         BE    @RF00342                                            0342
         C     RPLH,BUFCPLH(,RBUFC)                                0342
         BNE   @RF00342                                            0342
*       DO;                         /* DOES BUFC BELONG TO THIS PLH? */
*         PLHDBUFC=RBUFC;           /* SET DATA BUFC PTR             */
         ST    RBUFC,PLHDBUFC(,RPLH)                               0344
*         RBUFC=ZERO;               /* SET LOOP SWITCH               */
         SLR   RBUFC,RBUFC                                         0345
*       END;                        /* END OF FOUND DATA BUFC CASE   */
*     ELSE                          /* ELSE BUFC DOES NOT BELONG TO
*                                      PLH                           */
*       DO;                         /* GET NEXT BUFC IN CHAIN        */
         B     @RC00342                                            0347
@RF00342 DS    0H                                                  0348
*         RBUFC=BUFCHAIN;           /* GET NEXT PTR                  */
         L     RBUFC,BUFCHAIN(,RBUFC)                              0348
*         IF RBUFC=ZERO THEN        /* REACH END OF CHAIN ?          */
         LTR   RBUFC,RBUFC                                         0349
         BNZ   @RF00349                                            0349
*           DO;                     /* YES, ERROR IN PLH DATA BUF PTR*/
*             RPLERRCD=RPLDBPER;    /* SET INFO. CODE                */
         MVI   RPLERRCD(RRPL),X'28'                                0351
*             PLHDBPER=ON;          /* SET INDICATOR IN PLH          */
         OI    PLHDBPER(RPLH),B'00000010'                          0352
*           END;                    /* END OF DATA BUFC PTR ERROR  0353
*                                      CASE                          */
*         ELSE                                                     0354
*           ;                       /* ELSE, TRY NEXT BUFC           */
@RF00349 DS    0H                                                  0355
*       END;                        /* END OF ELSE                   */
*   END;                            /* END OF DO-UNTIL LOOP          */
@RC00342 DS    0H                                                  0356
@DE00341 LTR   RBUFC,RBUFC                                         0356
         BNZ   @DL00341                                            0356
*   RETURN;                         /* RETURN TO CALLER              */
@EL00005 DS    0H                                                  0357
@EF00005 DS    0H                                                  0357
@ER00005 BR    @14                                                 0357
*   RFY                                                            0358
*     R14 UNRSTD;                                                  0358
*   END FINDBUF;                    /* END OF FINDBUF PROC           */
*                                                                  0360
*/********************************************************************
** RELDTA:  ROUTINE USED TO RELEASE THE EXCESS DATA BUFC'S OF THIS   *
**          PLH.                                                     *
** FUNCTION: CHECK IF THERE IS AN ERROR IN THE DATA BUFC POINTER.    *
**           RELEASE DATA BUFC'S FOR REUSE BY CALLING IDASBF. BEFORE *
**           CALLING IDASBF, GO THROUGH BUFFER CHAIN AND TURN ALL THE*
**           BUFCMW BITS OFF TO AVOID FORCE WRITE IN IDASBF.         *
******************************************************************** */
*                                                                  0360
*RELDTA:                                                           0360
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);                               0360
RELDTA   DS    0H                                                  0361
*   GEN(IDASVR14);                  /* SAVE RETURN ADDRESS           */
         IDASVR14
*   IF PLHDBPER=OFF THEN            /* ANY ERROR IN DATA BUFC PTR?   */
         TM    PLHDBPER(RPLH),B'00000010'                          0362
         BNZ   @RF00362                                            0362
*     DO;                           /* NO, RELEASE DATA BUFFERS      */
*       RBUFC=PLHDBUFC;             /* SET UP WORK REGISTER          */
         L     RBUFC,PLHDBUFC(,RPLH)                               0364
*       DO UNTIL RBUFC=PLHDBUFC;    /* GO THROUGH BUF CHAIN          */
@DL00365 DS    0H                                                  0366
*         IF BUFCMW=ON THEN         /* TEST FOR BUFCMW               */
         TM    BUFCMW(RBUFC),B'10000000'                           0366
         BNO   @RF00366                                            0366
*           DO;                     /* YES                           */
*             BUFCMW=OFF;           /* SET BIT OFF                   */
         NI    BUFCMW(RBUFC),B'01111111'                           0368
*             RPLERRCD=RPLDSERR;    /* SET FEEDBACK CODE             */
         MVI   RPLERRCD(RRPL),X'24'                                0369
*             PLHDSERR=ON;          /* SET FDBK INDICATOR IN PLH     */
         OI    PLHDSERR(RPLH),B'00000100'                          0370
*           END;                    /* END OF MUST WRITE             */
*         ELSE                                                     0372
*           ;                                                      0372
@RF00366 DS    0H                                                  0373
*         RBUFC=BUFCNXT2;           /* NEXT BUFC                     */
         L     @10,BUFCNXT2-1(,RBUFC)                              0373
         LA    @10,0(,@10)                                         0373
         LR    RBUFC,@10                                           0373
*       END;                        /* END OF DO-UNTIL LOOP          */
*                                                                  0374
@DE00365 C     RBUFC,PLHDBUFC(,RPLH)                               0374
         BNE   @DL00365                                            0374
*       /*************************************************************/
*       /*                                                           */
*       /* SET UP PARAMETER TO CALL IDASBF TO SUBTRACT EXCESS DATA   */
*       /* BUFC'S                                                    */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0375
*       RBUFC=ZERO;                 /* SET PARAMETER FOR IDASBF      */
         SLR   RBUFC,RBUFC                                         0375
*I05:                                                              0376
*       DO;                         /* IDACALL(IDASBF)               */
I05      DS    0H                                                  0377
*         CALL IDASBF;              /* EXIT TO IDASBF                */
         L     @15,@CV00990                                        0377
         BALR  @14,@15                                             0377
*         GEN(BALR @11,0);          /* LOAD ADDR OF REENTRY          */
         BALR @11,0
*         GEN(USING *,@11);         /* ESTABLISH ADDRESSING          */
         USING *,@11
*         GEN(L     @11,=A(@PSTART));/* RELOAD BASE                  */
         L     @11,=A(@PSTART)
*         GEN(USING @PSTART,@11);   /* ESTABLISH ADDRESSING          */
         USING @PSTART,@11
*       END I05;                    /* SUBTRACT EXCESS DATA BUFC'S   */
*       PLHTMDTA=ON;                /* SET PROCESS BIT IN PLH        */
         OI    PLHTMDTA(RPLH),B'00010000'                          0383
*     END;                          /* END OF DATA BUFC RELEASE      */
*   ELSE                                                           0385
*     ;                             /* ELSE ERROR IN DATA BUFC PTR   */
@RF00362 DS    0H                                                  0386
*   GEN REFS(HWORD4)(IDARST14);     /* RESTORE RETURN ADDRESS        */
         IDARST14
*   RETURN;                         /* RETURN TO MAIN ROUTINE        */
@EL00006 DS    0H                                                  0387
@EF00006 DS    0H                                                  0387
@ER00006 BR    @14                                                 0387
*   END RELDTA;                     /* END OF RELDTA PROC.           */
*   GEN(IDAPATCH);                  /* DEFINE PATCH AREA             */
         IDAPATCH
*   END IDA019SN                    /* END OF TERMINATE RPL          */
*                                                                  0390
*/* THE FOLLOWING INCLUDE STATEMENTS WERE FOUND IN THIS PROGRAM.     */
*/*%INCLUDE SYSLIB  (IFGACB  )                                       */
*/*%INCLUDE SYSLIB  (IDAAMB  )                                       */
*/*%INCLUDE SYSLIB  (IDAAMBL )                                       */
*/*%INCLUDE SYSLIB  (IDAAMDSB)                                       */
*/*%INCLUDE SYSLIB  (IDABUFC )                                       */
*/*%INCLUDE SYSLIB  (IDADIWA )                                       */
*/*%INCLUDE SYSLIB  (IDAIOMB )                                       */
*/*%INCLUDE SYSLIB  (IDAPLH  )                                       */
*/*%INCLUDE SYSLIB  (IFGRPL  )                                       */
*/*%INCLUDE SYSLIB  (IDARMRCD)                                       */
*/*%INCLUDE SYSLIB  (IDAREGS )                                       */
*                                                                  0390
*       ;                                                          0390
         B     @EL00001                                            0390
@DATA    DS    0H
@DATD    DSECT
         DS    0F
IDA019SN CSECT
         DS    0F
@DATD    DSECT
         DS    0D
@ENDDATD EQU   *
IDA019SN CSECT
         NOPR  ((@ENDDATD-@DATD)*16)
         DS    0F
@SIZDATD DC    AL1(0)
         DC    AL3(@ENDDATD-@DATD)
@CV00990 DC    V(IDASBF)
@CV00991 DC    V(IDAFREEB)
@CV00992 DC    V(IDARSTRT)
         DS    0D
HWORD4   DC    H'4'
         DS    CL2
POSTED   DC    X'40000000'
C2ZERO   DC    X'0000'
@00      EQU   00                      EQUATES FOR REGISTERS 0-15
@01      EQU   01
@02      EQU   02
@03      EQU   03
@04      EQU   04
@05      EQU   05
@06      EQU   06
@07      EQU   07
@08      EQU   08
@09      EQU   09
@10      EQU   10
@11      EQU   11
@12      EQU   12
@13      EQU   13
@14      EQU   14
@15      EQU   15
RRPL     EQU   @01
RPLH     EQU   @02
RAMB     EQU   @03
RBUFC    EQU   @04
RWORK1   EQU   @05
RWORK2   EQU   @06
RPARM1   EQU   @12
R14      EQU   @14
R15      EQU   @15
RWORK0   EQU   @00
RWORK3   EQU   @07
RWORK4   EQU   @08
RWORK5   EQU   @09
R1       EQU   @01
R10      EQU   @10
R11      EQU   @11
R13      EQU   @13
IFGACB   EQU   0
ACBCOMN  EQU   IFGACB
ACBLENG  EQU   ACBCOMN+2
ACBLENG2 EQU   ACBLENG
ACBAMBL  EQU   ACBCOMN+4
ACBJWA   EQU   ACBAMBL
ACBMACRF EQU   ACBCOMN+12
ACBMACR1 EQU   ACBMACRF
ACBADR   EQU   ACBMACR1
ACBCNV   EQU   ACBMACR1
ACBMACR2 EQU   ACBMACRF+1
ACBBUFPL EQU   ACBCOMN+20
ACBMACR3 EQU   ACBBUFPL
ACBRECFM EQU   ACBCOMN+24
ACBCCTYP EQU   ACBCOMN+25
ACBOPT   EQU   ACBCOMN+26
ACBDSORG EQU   ACBOPT
ACBCROPS EQU   ACBDSORG
ACBEXLST EQU   ACBCOMN+36
ACBDDNM  EQU   ACBCOMN+40
ACBAMETH EQU   ACBDDNM+3
ACBOFLGS EQU   ACBCOMN+48
ACBEXFG  EQU   ACBOFLGS
ACBIOSFG EQU   ACBOFLGS
ACBINFLG EQU   ACBCOMN+50
ACBUJFCB EQU   ACBCOMN+52
ACBBLKSZ EQU   ACBCOMN+60
IDAAMB   EQU   0
AMBBUFC  EQU   IDAAMB+8
AMBPH    EQU   IDAAMB+12
AMBDSB   EQU   IDAAMB+20
AMBEOVR  EQU   IDAAMB+24
AMBFLG0  EQU   AMBEOVR
AMBFLG1  EQU   IDAAMB+25
AMBCREAT EQU   AMBFLG1
AMBDSORG EQU   IDAAMB+26
AMBIOBAD EQU   IDAAMB+28
AMBINFL  EQU   IDAAMB+42
AMBDEBPT EQU   IDAAMB+44
AMBOFLGS EQU   IDAAMB+48
AMBFLG2  EQU   IDAAMB+49
AMBEOVPT EQU   IDAAMB+56
AMBIWA   EQU   IDAAMB+64
AMBCSWD1 EQU   IDAAMB+84
AMBAFLG  EQU   AMBCSWD1
AMBLSR   EQU   AMBAFLG
AMBGSR   EQU   AMBAFLG
IDAAMBL  EQU   0
AMBLEOV  EQU   IDAAMBL+12
AMBLEFLG EQU   AMBLEOV
AMBLDDNM EQU   IDAAMBL+16
AMBLIDF  EQU   AMBLDDNM
AMBLQ    EQU   AMBLIDF+7
AMBLVC   EQU   IDAAMBL+28
AMBLTYPE EQU   IDAAMBL+30
AMBLPATH EQU   AMBLTYPE
AMBLSHAR EQU   IDAAMBL+33
AMBLFLG1 EQU   IDAAMBL+35
AMBLFLG2 EQU   IDAAMBL+36
AMBLDTA  EQU   IDAAMBL+52
AMBLIX   EQU   IDAAMBL+56
IDAAMDSB EQU   0
AMDATTR  EQU   IDAAMDSB+1
AMDRRDS  EQU   AMDATTR
AMDSPAN  EQU   AMDATTR
AMDNEST  EQU   IDAAMDSB+4
AMDHLRBA EQU   IDAAMDSB+28
AMDSSRBA EQU   IDAAMDSB+32
AMDATTR3 EQU   IDAAMDSB+40
AMDSTAT  EQU   IDAAMDSB+48
IDABUFDR EQU   0
BUFDRCIX EQU   IDABUFDR+9
BUFDRTSB EQU   IDABUFDR+10
BUFDRFLG EQU   IDABUFDR+11
BUFDBUFC EQU   IDABUFDR+12
IDABUFC  EQU   0
BUFCAVL  EQU   IDABUFC
BUFCFLG1 EQU   IDABUFC+1
BUFCVAL  EQU   BUFCFLG1
BUFCIOFL EQU   IDABUFC+2
BUFCMW   EQU   BUFCIOFL
BUFCFLG2 EQU   IDABUFC+3
BUFCPLH  EQU   IDABUFC+4
BUFCINV  EQU   IDABUFC+28
BUFCNXT2 EQU   IDABUFC+37
BUFCHAIN EQU   IDABUFC+48
IDADIWA  EQU   0
DIWATV   EQU   IDADIWA+1
DIWFLG1  EQU   IDADIWA+4
DIWFLG2  EQU   IDADIWA+5
DIWPLH   EQU   IDADIWA+16
DIWBUFC  EQU   IDADIWA+20
DIWSAVE  EQU   IDADIWA+28
IDAIOMB  EQU   0
IOMECBPT EQU   IDAIOMB+24
IOMFLAGS EQU   IDAIOMB+40
IOMFL    EQU   IOMFLAGS
IOMAPEND EQU   IOMFL
IOMSTIND EQU   IOMFLAGS+2
IOMEOVTS EQU   IOMSTIND
IOMLOCK  EQU   IDAIOMB+45
IOMSAVER EQU   IDAIOMB+52
IDAPLHDR EQU   0
PLHDRREQ EQU   IDAPLHDR+4
PLHDRCUR EQU   IDAPLHDR+10
IDAPLH   EQU   0
PLHAVL   EQU   IDAPLH
PLHFLG1  EQU   IDAPLH+2
PLHFLG2  EQU   IDAPLH+3
PLHEFLGS EQU   IDAPLH+4
PLHINVAL EQU   PLHEFLGS
PLHFLG3  EQU   IDAPLH+6
PLHAFLGS EQU   IDAPLH+7
PLHMRPL  EQU   IDAPLH+16
PLHCRBA  EQU   IDAPLH+28
PLHJORBA EQU   PLHCRBA
PLHJCODE EQU   IDAPLH+40
PLHRSCS  EQU   IDAPLH+43
PLHINEOV EQU   PLHRSCS
PLHBUFHD EQU   PLHRSCS
PLHDSERR EQU   PLHRSCS
PLHDBPER EQU   PLHRSCS
PLHARDB  EQU   IDAPLH+44
PLHDBUFC EQU   IDAPLH+52
PLHDIOB  EQU   IDAPLH+76
PLHRETO  EQU   IDAPLH+116
PLHRETOS EQU   IDAPLH+118
PLHRET1  EQU   IDAPLH+120
PLHEOVPT EQU   IDAPLH+180
PLHIXSPL EQU   IDAPLH+200
PLHSSRBA EQU   PLHIXSPL
PLHWAX   EQU   IDAPLH+232
PLHKEYPT EQU   IDAPLH+248
PLHTMRPL EQU   IDAPLH+265
PLHTERM  EQU   PLHTMRPL
PLHTMBUF EQU   PLHTMRPL
PLHTMDIW EQU   PLHTMRPL
PLHTMDTA EQU   PLHTMRPL
PLHTMINX EQU   PLHTMRPL
PLHTMIOB EQU   PLHTMRPL
PLHEND   EQU   IDAPLH+280
IFGRPL   EQU   0
RPLCOMN  EQU   IFGRPL
RPLIDWD  EQU   RPLCOMN
RPLLEN   EQU   RPLIDWD+3
RPLECB   EQU   RPLCOMN+8
RPLFDBWD EQU   RPLCOMN+12
RPLFDBK  EQU   RPLFDBWD+1
RPLRTNCD EQU   RPLFDBK
RPLERREG EQU   RPLRTNCD
RPLCNDCD EQU   RPLFDBK+1
RPLCMPON EQU   RPLCNDCD
RPLFDB2  EQU   RPLCMPON
RPLERRCD EQU   RPLCNDCD+1
RPLFDB3  EQU   RPLERRCD
RPLKEYLE EQU   RPLCOMN+16
RPLDACB  EQU   RPLCOMN+24
RPLARG   EQU   RPLCOMN+36
RPLOPTCD EQU   RPLCOMN+40
RPLOPT1  EQU   RPLOPTCD
RPLASY   EQU   RPLOPT1
RPLECBSW EQU   RPLOPT1
RPLOPT2  EQU   RPLOPTCD+1
RPLADR   EQU   RPLOPT2
RPLCNV   EQU   RPLOPT2
RPLOPT3  EQU   RPLOPTCD+2
RPLNXTRP EQU   RPLCOMN+44
RPLCHAIN EQU   RPLNXTRP
RPLOPTC2 EQU   RPLCOMN+56
RPLOPT5  EQU   RPLOPTC2
RPLWRTYP EQU   RPLOPT5
RPLOPT6  EQU   RPLOPTC2+1
RPLUNTYP EQU   RPLOPT6
RPLOPT7  EQU   RPLOPTC2+2
RPLCNOPT EQU   RPLOPT7
RPLOPT8  EQU   RPLOPTC2+3
RPLRBAR  EQU   RPLCOMN+60
RPLAIXID EQU   RPLRBAR+2
RPLEXTDS EQU   RPLCOMN+68
RPLEXTD1 EQU   RPLEXTDS
RPLACTIV EQU   RPLCOMN+69
IOECB    EQU   0
USERECB  EQU   0
PLHKEY   EQU   0
PLHPDL   EQU   0
PLHPDLE  EQU   0
PLHRRN   EQU   0
PLHEXTEN EQU   PLHEND
PLHBMWRK EQU   PLHEXTEN+5
BUFCRSC1 EQU   BUFCAVL
         AGO   .@UNREFD                START UNREFERENCED COMPONENTS
PLHBMSV5 EQU   PLHEXTEN+24
PLHBMSV4 EQU   PLHEXTEN+20
PLHBMSV3 EQU   PLHEXTEN+16
PLHBMSV2 EQU   PLHEXTEN+12
PLHBMSV1 EQU   PLHEXTEN+8
PLHRDCNT EQU   PLHEXTEN+6
PLHBMSOV EQU   PLHBMWRK
PLHBEUC  EQU   PLHBMWRK
PLHBMRDF EQU   PLHBMWRK
@NM00059 EQU   PLHEXTEN+4
PLHRESR1 EQU   PLHEXTEN
RPLERMSA EQU   RPLCOMN+72
RPLEMLEN EQU   RPLCOMN+70
RPLBRANC EQU   RPLEXTD1
RPLNIB   EQU   RPLEXTD1
@NM00062 EQU   RPLEXTD1
RPLEXIT  EQU   RPLEXTD1
RPLNEXIT EQU   RPLEXTD1
RPLEXSCH EQU   RPLEXTD1
RPLDDDD  EQU   RPLRBAR+4
@NM00061 EQU   RPLRBAR+3
@NM00060 EQU   RPLAIXID
RPLAXPKP EQU   RPLAIXID
RPLAIXPC EQU   RPLRBAR
RPLRSV88 EQU   RPLOPT8
RPLUNCON EQU   RPLOPT8
RPLACTV  EQU   RPLOPT8
RPLSESS  EQU   RPLOPT8
RPLPEND  EQU   RPLOPT8
RPLODPRM EQU   RPLOPT8
RPLODACP EQU   RPLOPT8
RPLODACQ EQU   RPLOPT8
RPLRSV78 EQU   RPLOPT7
RPLRSV77 EQU   RPLOPT7
RPLRLSOP EQU   RPLOPT7
RPLTPOST EQU   RPLOPT7
RPLQOPT  EQU   RPLOPT7
RPLCNIMM EQU   RPLCNOPT
RPLCNANY EQU   RPLCNOPT
RPLCNALL EQU   RPLCNOPT
RPLRSV68 EQU   RPLOPT6
RPLRSV67 EQU   RPLOPT6
RPLLOCK  EQU   RPLOPT6
RPLNCOND EQU   RPLOPT6
RPLCOND  EQU   RPLOPT6
RPLEOT   EQU   RPLUNTYP
RPLEOM   EQU   RPLUNTYP
RPLEOB   EQU   RPLUNTYP
RPLWROPT EQU   RPLOPT5
RPLNODE  EQU   RPLOPT5
RPLERACE EQU   RPLWRTYP
RPLEAU   EQU   RPLWRTYP
RPLNERAS EQU   RPLWRTYP
RPLPSOPT EQU   RPLOPT5
RPLSSNIN EQU   RPLOPT5
RPLDLGIN EQU   RPLOPT5
RPLBUFL  EQU   RPLCOMN+52
RPLRLEN  EQU   RPLCOMN+48
RPLOPT4  EQU   RPLOPTCD+3
RPLALIGN EQU   RPLOPT3
RPLFMT   EQU   RPLOPT3
RPLFLD   EQU   RPLOPT3
RPLVFY   EQU   RPLOPT3
RPLBLK   EQU   RPLOPT3
RPLSFORM EQU   RPLOPT3
RPLEODS  EQU   RPLOPT3
RPLNSP   EQU   RPLOPT2
RPLUPD   EQU   RPLOPT2
RPLWAITX EQU   RPLOPT2
RPLLRD   EQU   RPLOPT2
RPLBWD   EQU   RPLOPT2
RPLADD   EQU   RPLADR
RPLKEY   EQU   RPLOPT2
RPLECBIN EQU   RPLECBSW
RPLGEN   EQU   RPLOPT1
RPLKGE   EQU   RPLOPT1
RPLSKP   EQU   RPLOPT1
RPLSEQ   EQU   RPLOPT1
RPLDIR   EQU   RPLOPT1
RPLLOC   EQU   RPLOPT1
RPLDAF   EQU   RPLARG+2
RPLSAF   EQU   RPLARG
RPLAREA  EQU   RPLCOMN+32
RPLTCBPT EQU   RPLCOMN+28
RPLCCHAR EQU   RPLCOMN+20
RPLSTRID EQU   RPLCOMN+18
RPLKEYL  EQU   RPLKEYLE
RPLRDSOH EQU   RPLFDB3
RPLRLG   EQU   RPLFDB3
RPLLGFRC EQU   RPLFDB3
RPLREOT  EQU   RPLFDB3
RPLREOM  EQU   RPLFDB3
RPLREOB  EQU   RPLFDB3
RPLSV32  EQU   RPLFDB3
RPLUINPT EQU   RPLFDB3
RPLSTSAV EQU   RPLFDB2
RPLCUERR EQU   RPLFDB2
RPLDLGFL EQU   RPLFDB2
RPLIOERR EQU   RPLFDB2
RPLDVUNS EQU   RPLFDB2
RPLATND  EQU   RPLFDB2
RPLRVID  EQU   RPLFDB2
RPLERLK  EQU   RPLFDB2
RPLSTAT  EQU   RPLFDBWD
RPLPOST  EQU   RPLECB
RPLWAIT  EQU   RPLECB
RPLPLHPT EQU   RPLCOMN+4
RPLLEN2  EQU   RPLLEN
RPLREQ   EQU   RPLIDWD+2
RPLSTYP  EQU   RPLIDWD+1
RPLID    EQU   RPLIDWD
PLHERRET EQU   IDAPLH+276
PLHASCB  EQU   IDAPLH+272
PLHECB   EQU   IDAPLH+268
@NM00058 EQU   IDAPLH+266
@NM00057 EQU   PLHTMRPL
PLHDRMSK EQU   IDAPLH+264
PLHR13   EQU   IDAPLH+260
PLHPARM1 EQU   IDAPLH+256
PLHDRRSC EQU   IDAPLH+252
PLHSLRBA EQU   IDAPLH+244
PLHSRCSG EQU   IDAPLH+242
PLHNOSEG EQU   IDAPLH+240
PLHLLOR  EQU   IDAPLH+236
PLHXPLH  EQU   PLHWAX
@NM00056 EQU   PLHIXSPL+8
PLHIXBFC EQU   PLHIXSPL+4
PLHHIREC EQU   PLHSSRBA
PLHISPLP EQU   IDAPLH+196
PLHRBUFC EQU   IDAPLH+192
PLHIBUFC EQU   IDAPLH+188
PLHNRBA  EQU   IDAPLH+184
PLHDDDD  EQU   PLHEOVPT
PLHAR14  EQU   IDAPLH+176
@NM00055 EQU   IDAPLH+172
@NM00054 EQU   IDAPLH+168
PLHASAVE EQU   IDAPLH+164
PLHCHAIN EQU   IDAPLH+112
PLHAMB   EQU   IDAPLH+108
PLHSAVE6 EQU   IDAPLH+104
PLHSAVE5 EQU   IDAPLH+100
PLHSAVE4 EQU   IDAPLH+96
PLHSAVE3 EQU   IDAPLH+92
PLHSAVE2 EQU   IDAPLH+88
PLHSAVE1 EQU   IDAPLH+84
PLHARET  EQU   IDAPLH+80
PLHIIOB  EQU   PLHDIOB
PLHSRSID EQU   IDAPLH+74
PLHRDFC  EQU   IDAPLH+72
PLHRDFP  EQU   IDAPLH+68
PLHFSP   EQU   IDAPLH+64
PLHRECP  EQU   IDAPLH+60
PLHNBUFC EQU   IDAPLH+56
PLHLRECL EQU   IDAPLH+48
@NM00053 EQU   PLHRSCS
PLHASYER EQU   PLHRSCS
@NM00052 EQU   PLHRSCS
PLHEOVR  EQU   IDAPLH+42
PLHRCODE EQU   IDAPLH+41
PLHUCODE EQU   PLHJCODE
PLHJNRBA EQU   IDAPLH+36
PLHJRNLL EQU   IDAPLH+32
PLHUPECB EQU   PLHJORBA
PLHDSIDA EQU   IDAPLH+24
PLHCRPL  EQU   IDAPLH+20
PLHBFRNO EQU   IDAPLH+15
PLHFRCNT EQU   IDAPLH+14
PLHRMIN  EQU   IDAPLH+13
PLHDSTYP EQU   IDAPLH+12
PLHACB   EQU   IDAPLH+8
PLHRAE   EQU   PLHAFLGS
PLHRABWD EQU   PLHAFLGS
PLHIOSID EQU   PLHAFLGS
PLHDBDC  EQU   PLHAFLGS
PLHVAMB  EQU   PLHAFLGS
PLHIOSRQ EQU   PLHAFLGS
PLHDRLM  EQU   PLHAFLGS
PLHEOVDF EQU   PLHFLG3
PLHRVRS  EQU   PLHFLG3
PLHBWD   EQU   PLHFLG3
PLHSLVLD EQU   PLHFLG3
PLHRAHD  EQU   PLHFLG3
PLHSRBSG EQU   PLHFLG3
@NM00051 EQU   PLHEFLGS+1
PLHRSTRT EQU   PLHEFLGS+1
PLHDSCAN EQU   PLHEFLGS
PLHEODX  EQU   PLHEFLGS
PLHNOADV EQU   PLHEFLGS
PLHSRINV EQU   PLHEFLGS
PLHSKPER EQU   PLHEFLGS
PLH1ST   EQU   PLHEFLGS
PLHNOSPC EQU   PLHEFLGS
PLHIWAIT EQU   PLHFLG2
PLHSVADV EQU   PLHFLG2
PLHCIINS EQU   PLHFLG2
PLHKRE   EQU   PLHFLG2
PLHADDTE EQU   PLHFLG2
PLHKEYMD EQU   PLHFLG2
PLHSQINS EQU   PLHFLG2
PLHUPD   EQU   PLHFLG2
@NM00050 EQU   PLHFLG1
PLHDRPND EQU   PLHFLG1
PLHASYRQ EQU   PLHFLG1
PLHRDEXC EQU   PLHFLG1
PLHSSR   EQU   PLHFLG1
PLHASKBF EQU   PLHFLG1
PLHENDRQ EQU   PLHFLG1
PLHEOVW  EQU   PLHFLG1
PLHATV   EQU   IDAPLH+1
PLHIOSDQ EQU   IDAPLHDR+12
PLHDRMAX EQU   IDAPLHDR+8
PLHELTH  EQU   IDAPLHDR+2
PLHCNT   EQU   IDAPLHDR+1
PLHID    EQU   IDAPLHDR
IOMUFLD  EQU   IDAIOMB+120
IOMNXT1  EQU   IDAIOMB+116
IOMSAVEF EQU   IOMSAVER+60
IOMSAVEE EQU   IOMSAVER+56
IOMSAVED EQU   IOMSAVER+52
IOMSAVEC EQU   IOMSAVER+48
IOMSAVEB EQU   IOMSAVER+44
IOMSAVEA EQU   IOMSAVER+40
IOMSAVE9 EQU   IOMSAVER+36
IOMSAVE8 EQU   IOMSAVER+32
IOMSAVE7 EQU   IOMSAVER+28
IOMSAVE6 EQU   IOMSAVER+24
IOMSAVE5 EQU   IOMSAVER+20
IOMSAVE4 EQU   IOMSAVER+16
IOMSAVE3 EQU   IOMSAVER+12
IOMSAVE2 EQU   IOMSAVER+8
IOMSAVE1 EQU   IOMSAVER+4
IOMSAVE0 EQU   IOMSAVER
IOMNSEG  EQU   IDAIOMB+50
IOMNBUF  EQU   IDAIOMB+48
IOMNMOD  EQU   IDAIOMB+46
IOMPFERR EQU   IDAIOMB+44
IOMCKEY  EQU   IDAIOMB+43
@NM00049 EQU   IOMSTIND
IOMSRBM  EQU   IOMSTIND
IOMSLOC  EQU   IOMSTIND
IOMLLOCK EQU   IOMSTIND
IOMEOVXC EQU   IOMSTIND
IOMEOVW  EQU   IOMSTIND
IOMAMUSE EQU   IOMSTIND
@NM00048 EQU   IOMFL+1
IOMIRBSW EQU   IOMFL+1
IOMEEXIT EQU   IOMFL+1
@NM00047 EQU   IOMFL+1
IOMCPRB  EQU   IOMFL+1
IOMDDR   EQU   IOMFL+1
IOMCSW   EQU   IOMFL
IOMPGFIX EQU   IOMFL
IOMADERR EQU   IOMFL
IOMCBERR EQU   IOMFL
@NM00046 EQU   IOMFL
IOMPURGE EQU   IOMFL
IOMAE    EQU   IOMAPEND
IOMNE    EQU   IOMAPEND
IOMIOSB  EQU   IDAIOMB+36
IOMPGAD  EQU   IDAIOMB+32
IOMVSL   EQU   IDAIOMB+28
IOMIQE   EQU   IDAIOMB+20
IOMAMB   EQU   IDAIOMB+16
IOMPLH   EQU   IDAIOMB+12
IOMCPA   EQU   IDAIOMB+8
IOMBUFC  EQU   IDAIOMB+4
IOMBID   EQU   IDAIOMB
@NM00045 EQU   IDADIWA+92
@NM00044 EQU   IDADIWA+88
@NM00043 EQU   IDADIWA+84
@NM00042 EQU   IDADIWA+80
@NM00041 EQU   IDADIWA+76
@NM00040 EQU   IDADIWA+72
@NM00039 EQU   IDADIWA+68
@NM00038 EQU   IDADIWA+64
@NM00037 EQU   IDADIWA+60
@NM00036 EQU   IDADIWA+56
DIWINRBA EQU   IDADIWA+52
DIWRKCT  EQU   IDADIWA+48
DIWSAVE5 EQU   DIWSAVE+16
DIWSAVE4 EQU   DIWSAVE+12
DIWSAVE3 EQU   DIWSAVE+8
DIWSAVE2 EQU   DIWSAVE+4
DIWSAVE1 EQU   DIWSAVE
DIWSPLTP EQU   IDADIWA+24
DIWHRBA  EQU   IDADIWA+12
DIWLRBA  EQU   IDADIWA+8
@NM00035 EQU   IDADIWA+6
DIWFSPF  EQU   DIWFLG2
DIW1ST   EQU   DIWFLG1
DIWNOT1  EQU   DIWFLG1
DIWSHIFT EQU   DIWFLG1
DIWGSPC  EQU   DIWFLG1
DIWEOKR  EQU   DIWFLG1
DIWPFERR EQU   DIWFLG1
DIWCISPL EQU   DIWFLG1
DIWCAS   EQU   DIWFLG1
DIWLEN   EQU   IDADIWA+2
DIWID    EQU   IDADIWA
BUFCEND  EQU   IDABUFC+64
BUFCUCDN EQU   IDABUFC+60
BUFCUCUP EQU   IDABUFC+56
BUFCMDBT EQU   IDABUFC+52
BUFXORBA EQU   IDABUFC+44
BUFXIRBA EQU   IDABUFC+40
BUFCIDXL EQU   IDABUFC+36
BUFCDSPC EQU   IDABUFC+32
BUFCWLEN EQU   BUFCINV
BUFCNXT1 EQU   IDABUFC+24
BUFCBAD  EQU   IDABUFC+20
BUFCCPA  EQU   IDABUFC+16
BUFCORBA EQU   IDABUFC+12
BUFCDDDD EQU   IDABUFC+8
BUFCAMB  EQU   BUFCPLH
@NM00034 EQU   BUFCFLG2
BUFCEOD  EQU   BUFCFLG2
BUFCBSYW EQU   BUFCFLG2
BUFCBSYR EQU   BUFCFLG2
BUFCNLAS EQU   BUFCFLG2
BUFCXDDR EQU   BUFCFLG2
BUFCFIX  EQU   BUFCIOFL
BUFCPFCP EQU   BUFCIOFL
BUFCXEDB EQU   BUFCIOFL
BUFCWC   EQU   BUFCIOFL
BUFCREAL EQU   BUFCIOFL
BUFCRRD  EQU   BUFCIOFL
BUFCFMT  EQU   BUFCIOFL
BUFCEPT  EQU   BUFCFLG1
BUFCEXC  EQU   BUFCFLG1
BUFCER2  EQU   BUFCFLG1
BUFCER1  EQU   BUFCFLG1
BUFCINS  EQU   BUFCFLG1
BUFCSEG  EQU   BUFCFLG1
BUFCUPG  EQU   BUFCFLG1
BUFCUCNT EQU   BUFCAVL
@NM00033 EQU   IDABUFDR+16
@NM00032 EQU   BUFDRFLG
BUFDRAVL EQU   BUFDRFLG
BUFDRREL EQU   BUFDRFLG
BUFDRMAX EQU   BUFDRCIX
BUFDRPFN EQU   IDABUFDR+8
BUFDRPFB EQU   IDABUFDR+4
BUFDRLEN EQU   IDABUFDR+2
BUFDRNO  EQU   IDABUFDR+1
BUFDRID  EQU   IDABUFDR
AMDEXCP  EQU   AMDSTAT+44
AMDNCAS  EQU   AMDSTAT+40
AMDNCIS  EQU   AMDSTAT+36
AMDASPA  EQU   AMDSTAT+32
AMDRETR  EQU   AMDSTAT+28
AMDUPR   EQU   AMDSTAT+24
AMDIREC  EQU   AMDSTAT+20
AMDDELR  EQU   AMDSTAT+16
AMDNLR   EQU   AMDSTAT+12
AMDNEXT  EQU   AMDSTAT+10
AMDNIL   EQU   AMDSTAT+8
AMDSTSP  EQU   AMDSTAT
@NM00031 EQU   IDAAMDSB+41
@NM00030 EQU   AMDATTR3
AMDLM    EQU   AMDATTR3
AMDWAIT  EQU   AMDATTR3
AMDBIND  EQU   AMDATTR3
AMDFAULT EQU   AMDATTR3
AMDUNQ   EQU   AMDATTR3
AMDPARDB EQU   IDAAMDSB+36
AMDMAXRR EQU   AMDSSRBA
AMDNSLOT EQU   AMDHLRBA
AMDLRECL EQU   IDAAMDSB+24
AMDCINV  EQU   IDAAMDSB+20
AMDFSCI  EQU   IDAAMDSB+16
AMDFSCA  EQU   IDAAMDSB+14
AMDCIPCA EQU   IDAAMDSB+12
AMDPCTCI EQU   IDAAMDSB+11
AMDPCTCA EQU   IDAAMDSB+10
AMDKEYLN EQU   IDAAMDSB+8
AMDRKP   EQU   IDAAMDSB+6
AMDAXRKP EQU   AMDNEST
AMDLEN   EQU   IDAAMDSB+2
AMDRANGE EQU   AMDATTR
AMDORDER EQU   AMDATTR
AMDREPL  EQU   AMDATTR
AMDSDT   EQU   AMDATTR
AMDWCK   EQU   AMDATTR
AMDDST   EQU   AMDATTR
AMDSBID  EQU   IDAAMDSB
AMBLCMB  EQU   IDAAMBL+64
AMBLBIB  EQU   IDAAMBL+60
AMBLMIDS EQU   IDAAMBL+42
AMBLNIDS EQU   IDAAMBL+41
@NM00029 EQU   IDAAMBL+40
AMBLNUM  EQU   IDAAMBL+38
AMBLNST  EQU   IDAAMBL+37
@NM00028 EQU   AMBLFLG2
AMBLSTAG EQU   AMBLFLG2
@NM00027 EQU   AMBLFLG2
AMBLDUMY EQU   AMBLFLG1
AMBLCAT  EQU   AMBLFLG1
AMBLUCRA EQU   AMBLFLG1
AMBLSCRA EQU   AMBLFLG1
AMBLVVIC EQU   AMBLFLG1
AMBLUPD  EQU   AMBLFLG1
AMBLCINV EQU   AMBLFLG1
AMBLFULL EQU   AMBLFLG1
AMBLLEN  EQU   IDAAMBL+34
@NM00026 EQU   AMBLSHAR
AMBLWRIT EQU   AMBLSHAR
AMBLCATO EQU   AMBLSHAR
AMBLPRIM EQU   AMBLSHAR
AMBLID   EQU   IDAAMBL+32
@NM00025 EQU   IDAAMBL+31
@NM00024 EQU   AMBLTYPE
AMBLFIX  EQU   AMBLTYPE
AMBLBASE EQU   AMBLTYPE
AMBLAIX  EQU   AMBLTYPE
AMBLUPGR EQU   AMBLTYPE
AMBLENO  EQU   AMBLVC+1
AMBLVRT  EQU   AMBLVC
AMBLXPT  EQU   IDAAMBL+24
AMBLDFR  EQU   AMBLQ
AMBLESDS EQU   AMBLQ
AMBLKSDS EQU   AMBLQ
AMBLUBF  EQU   AMBLQ
AMBLFSTP EQU   AMBLQ
AMBLLSR  EQU   AMBLQ
AMBLGSR  EQU   AMBLQ
AMBLDDC  EQU   AMBLQ
AMBLDCI  EQU   AMBLIDF+4
AMBLCACB EQU   AMBLIDF
@NM00023 EQU   AMBLEOV+2
AMBLCOMP EQU   AMBLEOV+1
AMBLESET EQU   AMBLEFLG
AMBLWAIT EQU   AMBLEFLG
AMBLACB  EQU   IDAAMBL+8
AMBLSCHN EQU   IDAAMBL+4
AMBLPCHN EQU   IDAAMBL
AMBTRACE EQU   IDAAMB+120
AMBVIOT  EQU   IDAAMB+116
AMBSZCP  EQU   IDAAMB+114
AMBSZFW  EQU   IDAAMB+112
AMBSZWR  EQU   IDAAMB+110
AMBSZRD  EQU   IDAAMB+108
AMBEXEX  EQU   IDAAMB+100
AMBWSHD  EQU   IDAAMB+96
AMBCPA   EQU   IDAAMB+92
AMBBM2SH EQU   IDAAMB+88
AMBRDCNT EQU   AMBCSWD1+2
@NM00022 EQU   AMBCSWD1+1
@NM00021 EQU   AMBAFLG
AMBCFX   EQU   AMBAFLG
AMBSIS   EQU   AMBAFLG
AMBDFR   EQU   AMBAFLG
AMBICI   EQU   AMBAFLG
@NM00020 EQU   AMBAFLG
AMBUPLH  EQU   IDAAMB+80
AMBPAMBL EQU   IDAAMB+76
AMBPIXP  EQU   IDAAMB+72
@NM00019 EQU   IDAAMB+68
AMBWKA   EQU   IDAAMB+60
AMBAMBXN EQU   AMBEOVPT
AMBEDB   EQU   IDAAMB+52
AMBRPT   EQU   IDAAMB+50
AMBPUG   EQU   AMBFLG2
AMBBUSY  EQU   AMBOFLGS
AMBEXFG  EQU   AMBOFLGS
@NM00018 EQU   AMBOFLGS
AMBOPEN  EQU   AMBOFLGS
@NM00017 EQU   AMBOFLGS
AMBDEBAD EQU   AMBDEBPT+1
AMBIFLGS EQU   AMBDEBPT
AMBAMETH EQU   IDAAMB+43
AMBUPX   EQU   AMBINFL
AMBUCRA  EQU   AMBINFL
AMBSCRA  EQU   AMBINFL
AMBCAT   EQU   AMBINFL
@NM00016 EQU   AMBINFL
@NM00015 EQU   AMBINFL
AMBTIOT  EQU   IDAAMB+40
@NM00014 EQU   IDAAMB+38
AMBDDSN  EQU   IDAAMB+35
AMBCDSN  EQU   IDAAMB+32
AMBIOMB  EQU   AMBIOBAD
@NM00013 EQU   AMBDSORG+1
AMBDORGA EQU   AMBDSORG+1
@NM00012 EQU   AMBDSORG
AMBINBUF EQU   AMBFLG1
AMBJRN   EQU   AMBFLG1
AMBUBF   EQU   AMBFLG1
AMBSPEED EQU   AMBFLG1
AMBPCAT  EQU   AMBFLG1
AMBMCAT  EQU   AMBFLG1
AMBTYPE  EQU   AMBFLG1
@NM00011 EQU   AMBFLG0
AMBPSDS  EQU   AMBFLG0
AMBCACB  EQU   IDAAMB+16
AMBLINK  EQU   IDAAMB+4
AMBLEN   EQU   IDAAMB+2
AMBRSC   EQU   IDAAMB+1
AMBID    EQU   IDAAMB
ACBAPID  EQU   ACBCOMN+72
ACBCBMWA EQU   ACBCOMN+68
ACBUAPTR EQU   ACBCOMN+64
ACBLRECL EQU   ACBCOMN+62
ACBMSGLN EQU   ACBBLKSZ
ACBBUFSP EQU   ACBCOMN+56
@NM00010 EQU   ACBUJFCB+1
ACBOPTN  EQU   ACBUJFCB
ACBVVIC  EQU   ACBINFLG
ACBUCRA  EQU   ACBINFLG
ACBSCRA  EQU   ACBINFLG
ACBCAT   EQU   ACBINFLG
ACBIJRQE EQU   ACBINFLG
ACBJEPS  EQU   ACBINFLG
@NM00009 EQU   ACBINFLG
ACBERFLG EQU   ACBCOMN+49
ACBBUSY  EQU   ACBIOSFG
ACBLOCK  EQU   ACBEXFG
@NM00008 EQU   ACBOFLGS
ACBDSERR EQU   ACBOFLGS
ACBOPEN  EQU   ACBOFLGS
ACBEOV   EQU   ACBOFLGS
@NM00007 EQU   ACBOFLGS
ACBDEB   EQU   ACBDDNM+5
ACBERFL  EQU   ACBDDNM+4
ACBAM    EQU   ACBAMETH
ACBINFL  EQU   ACBDDNM+2
ACBTIOT  EQU   ACBDDNM
ACBUEL   EQU   ACBEXLST
ACBPASSW EQU   ACBCOMN+32
ACBMSGAR EQU   ACBCOMN+28
@NM00006 EQU   ACBDSORG+1
ACBDORGA EQU   ACBDSORG+1
@NM00005 EQU   ACBDSORG
ACBCRNRE EQU   ACBCROPS
ACBCRNCK EQU   ACBCROPS
ACBASA   EQU   ACBCCTYP
@NM00004 EQU   ACBCCTYP
ACBRECAF EQU   ACBRECFM
ACBJBUF  EQU   ACBBUFPL+2
ACBMACR4 EQU   ACBBUFPL+1
@NM00003 EQU   ACBMACR3
ACBNCFX  EQU   ACBMACR3
ACBSIS   EQU   ACBMACR3
ACBDFR   EQU   ACBMACR3
ACBICI   EQU   ACBMACR3
ACBGSR   EQU   ACBMACR3
ACBLSR   EQU   ACBMACR3
@NM00002 EQU   ACBMACR3
ACBBUFNI EQU   ACBCOMN+18
ACBBUFND EQU   ACBCOMN+16
ACBSTRNO EQU   ACBCOMN+15
ACBBSTNO EQU   ACBCOMN+14
ACBAIX   EQU   ACBMACR2
ACBDSN   EQU   ACBMACR2
ACBRST   EQU   ACBMACR2
ACBLOGON EQU   ACBMACR2
ACBSKP   EQU   ACBMACR2
@NM00001 EQU   ACBMACR2
ACBUBF   EQU   ACBMACR1
ACBOUT   EQU   ACBMACR1
ACBIN    EQU   ACBMACR1
ACBDIR   EQU   ACBMACR1
ACBSEQ   EQU   ACBMACR1
ACBBLK   EQU   ACBCNV
ACBADD   EQU   ACBADR
ACBKEY   EQU   ACBMACR1
ACBINRTN EQU   ACBCOMN+8
ACBIBCT  EQU   ACBJWA
ACBLEN2  EQU   ACBLENG2
ACBSTYP  EQU   ACBCOMN+1
ACBID    EQU   ACBCOMN
.@UNREFD ANOP                          END UNREFERENCED COMPONENTS
@RC00295 EQU   @RC00294
@ENDDATA EQU   *
         END   IDA019SN,(C'PLS1801',0701,78188)
