         TITLE 'IDA121A6--MVM I/O MANAGER PURGE ROUTINE                *
                        '
IDA121A6 CSECT ,                                                   0001
@MAINENT DS    0H                                                  0001
         USING *,@15                                               0001
         B     @PROLOG                                             0001
         DC    AL1(16)                                             0001
         DC    C'IDA121A6  78.180'                                 0001
         DROP  @15
@PROLOG  STM   @14,@12,12(@13)                                     0001
         BALR  @09,0                                               0001
@PSTART  DS    0H                                                  0001
         USING @PSTART,@09                                         0001
*   ASXBPTR=ASCBASXB;               /* POINTER TO ASXB               */
         L     @12,PSAAOLD                                         0110
         L     ASXBPTR,ASCBASXB(,@12)                              0110
*   IPIBPTR=R1;                     /* SAVE POINTER TO IPIB          */
         LR    IPIBPTR,R1                                          0111
*   RESPECIFY                                                      0112
*    (R1) UNRSTD;                                                  0112
*                                                                  0112
*   /*****************************************************************/
*   /*                                                               */
*   /* OBTAIN LOCAL LOCK - REGS 10 THROUGH 14 CHANGED        @ZA02502*/
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0113
*   RESPECIFY                                                      0113
*    (R4,                                                          0113
*     RW1,                                                         0113
*     RW2,                                                         0113
*     RW3) RSTD;                    /*                       @ZA02502*/
*   R4=RSAVE;                       /* SAVE REG 13 CONTENTS  @ZA02502*/
         LR    R4,RSAVE                                            0114
*   GEN SETS(RSAVE) REFS(PSALITA,FLC)/*                      @ZA02502*/
*                                                                  0115
*(SETLOCK OBTAIN,TYPE=LOCAL,MODE=UNCOND,RELATED=(LOCAL,IDA121A6)); 0115
         SETLOCK OBTAIN,TYPE=LOCAL,MODE=UNCOND,RELATED=(LOCAL,IDA121A6)
*   IF RSAVE^=ZERO THEN             /* CHECK RETURN CODE     @ZA02502*/
         LTR   RSAVE,RSAVE                                         0116
         BZ    @RF00116                                            0116
*     DO;                           /* ERROR IN SETLOCK      @ZA02502*/
*       R2=HWORD4;                  /* REASON CODE OF 4 - R2 @ZA02502*/
         LA    R2,4                                                0118
*       DO;                         /* ABEND(377) DUMP SYSTEM        */
*         RESPECIFY                                                0120
*          (GPR01F) RESTRICTED;                                    0120
*         GPR01F=((377)&'00000FFF'X)*4096;/* COMP CODE IN BITS 8-19  */
         L     GPR01F,@CF01706                                     0121
*         GPR01F=GPR01F|'80000000'X;/* DUMP/STEP/DUMPOPTS FLAG       */
         O     GPR01F,@CF00069                                     0122
*         SVC(13);                  /* ISSUE ABEND SVC               */
         SVC   13                                                  0123
*         RESPECIFY                                                0124
*          (GPR01F) UNRESTRICTED;                                  0124
*       END;                        /* ABEND(377) DUMP SYSTEM LOCK 0125
*                                      ALREADY HELD          @ZA02502*/
*     END;                          /*                       @ZA02502*/
*   RSAVE=R4;                       /* RESTORE REGISTER 13   @ZA02502*/
@RF00116 LR    RSAVE,R4                                            0127
*   RESPECIFY                                                      0128
*    (R4,                                                          0128
*     RW1,                                                         0128
*     RW2,                                                         0128
*     RW3) UNRSTD;                  /*                       @ZA02502*/
*                                                                  0128
*   /*****************************************************************/
*   /*                                                               */
*   /* HALT REQUEST                                                  */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0129
*   IQEPTR=ASXBFIQE;                /* 1ST IQE IN ASYNCH LIST      0129
*                                                            @ZA04206*/
         L     IQEPTR,ASXBFIQE(,ASXBPTR)                           0129
*   IF IPIBHALT=ON THEN                                            0130
         TM    IPIBHALT(IPIBPTR),B'00000100'                       0130
         BNO   @RF00130                                            0130
*HALTREQ:                                                          0131
*     DO;                           /* HALT REQUEST                  */
*                                                                  0131
HALTREQ  DS    0H                                                  0132
*       /*************************************************************/
*       /*                                                           */
*       /* IF THIS IS A MEMORY PURGE, BYPASS ALL PROCESSING          */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0132
*       IF IPIBMEM=ON THEN                                         0132
         TM    IPIBMEM(IPIBPTR),B'10000000'                        0132
         BO    @RT00132                                            0132
*         GO TO FREELOCK;           /* RETURN TO CALLER      @ZA04206*/
*                                                                  0133
*       /*************************************************************/
*       /*                                                           */
*       /* RELEASE PAGES SIOD FIXED FOR IOSB-S PASSED IN IPIB        */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0134
*       RESPECIFY                                                  0134
*        (IOSBPTR,                                                 0134
*         SRBPTR) RSTD;                                            0134
*       SRBPTR=IPIBSRB;             /* ADDRESS OF FIRST SRB IN QUEUE */
         L     SRBPTR,IPIBSRB(,IPIBPTR)                            0135
*FREPAGES:                                                         0136
*       DO WHILE SRBPTR^=ZERO;                                     0136
FREPAGES B     @DE00136                                            0136
@DL00136 DS    0H                                                  0137
*         IOSBPTR=SRBPARM;          /* IOSB ADDRESS FROM THE SRB     */
         L     IOSBPTR,SRBPARM(,SRBPTR)                            0137
*         RIOMB=IOSUSE;             /* IOMB ADDRESS FROM THE IOSB    */
*                                                                  0138
         L     RIOMB,IOSUSE(,IOSBPTR)                              0138
*         /***********************************************************/
*         /*                                                         */
*         /* VERIFY THAT IOMB IS VALID AND IN CURRENT MEMORY         */
*         /*                                                         */
*         /***********************************************************/
*                                                                  0139
*         IF IOSDVRID=ABPID&        /* I/O MANAGER'S DRIVER ID       */
*             IOSASID=ASCBASID&     /* CHECK MEMORY ID               */
*             IOMBID=VALID&         /* CHECK IF THIS IS AN IOMB      */
*             IOMPGFIX=ON THEN      /* PAGES WERE FIXED IN SIOD      */
         CLI   IOSDVRID(IOSBPTR),X'03'                             0139
         BNE   @RF00139                                            0139
         L     @12,PSAAOLD                                         0139
         CLC   IOSASID(2,IOSBPTR),ASCBASID(@12)                    0139
         BNE   @RF00139                                            0139
         CLC   IOMBID(4,RIOMB),@CC00071                            0139
         BNE   @RF00139                                            0139
         TM    IOMPGFIX(RIOMB),B'00000010'                         0139
         BNO   @RF00139                                            0139
*           DO;                                                    0140
*             IQEPTR=IOMIQE;        /* IQE POINTER FROM IOMB         */
*                                                                  0141
         L     IQEPTR,IOMIQE(,RIOMB)                               0141
*             /*******************************************************/
*             /*                                                     */
*             /* RELEASE PAGES IF IQE IS RELEVANT                    */
*             /*                                                     */
*             /*******************************************************/
*                                                                  0142
*             IF(IPIBTASK=ON&IQETCB=IPIBARG)|(IPIBTASK=OFF&AMBDEBAD=
*                 IPIBARG) THEN                                    0142
         TM    IPIBTASK(IPIBPTR),B'01000000'                       0142
         BNO   @GL00004                                            0142
         CLC   IQETCB(4,IQEPTR),IPIBARG(IPIBPTR)                   0142
         BE    @RT00142                                            0142
@GL00004 TM    IPIBTASK(IPIBPTR),B'01000000'                       0142
         BNZ   @RF00142                                            0142
         L     @12,IOMAMB(,RIOMB)                                  0142
         L     @12,AMBDEBAD-1(,@12)                                0142
         LA    @12,0(,@12)                                         0142
         C     @12,IPIBARG(,IPIBPTR)                               0142
         BNE   @RF00142                                            0142
@RT00142 DS    0H                                                  0143
*               DO;                 /* RELEASE PAGES FIXED IN SIOD   */
*                 RESPECIFY                                        0144
*                  (R0,                                            0144
*                   R1,                                            0144
*                   R4,                                            0144
*                   R14,                                           0144
*                   R15) RSTD;      /*                       @ZA04947*/
*                 R0=ZERO;          /* ZERO REGISTER 0       @ZA04947*/
         SLR   R0,R0                                               0145
*                 R1=IOMVSL;        /* POINTER TO VSL        @ZA04947*/
         L     R1,IOMVSL(,RIOMB)                                   0146
*                 R1=R1|PAGEMASK;   /* HIGH BIT ON 1         @ZA04947*/
         O     R1,@CF00069                                         0147
*                 VSLFIX=OFF;       /* PAGE FIX BIT OFF      @ZA04947*/
*                 VSLFREE=ON;       /* PAGE FREE BIT ON      @ZA04947*/
         OI    VSLFREE(R1),B'00100000'                             0149
         NI    VSLFIX(R1),B'10111111'                              0149
*                 R4=ZERO;          /* NO ACCOUNTING         @ZA04947*/
         SLR   R4,R4                                               0150
*                 CALL CVTVPSIB;    /* PAGEFREE RTN CALL     @ZM41828*/
         L     @12,CVTPTR                                          0151
         L     @15,CVTVPSIB(,@12)                                  0151
         BALR  @14,@15                                             0151
*                 IOMPGFIX=OFF;     /* PAGES FREED           @ZA04947*/
         NI    IOMPGFIX(RIOMB),B'11111101'                         0152
*                 RESPECIFY                                        0153
*                  (R0,                                            0153
*                   R1,                                            0153
*                   R4,                                            0153
*                   R14,                                           0153
*                   R15) UNRSTD;                                   0153
*               END;                                               0154
*           END;                                                   0155
@RF00142 DS    0H                                                  0156
*         SRBPTR=SRBFLNK;           /* NEXT SRB ON QUEUE             */
@RF00139 L     SRBPTR,SRBFLNK(,SRBPTR)                             0156
*       END FREPAGES;                                              0157
@DE00136 LTR   SRBPTR,SRBPTR                                       0157
         BNZ   @DL00136                                            0157
*       RESPECIFY                                                  0158
*        (SRBPTR,                                                  0158
*         IOSBPTR) UNRSTD;                                         0158
*                                                                  0158
*       /*************************************************************/
*       /*                                                           */
*       /* EITHER TCB OR DSID PURGE REMOVE I/O MGR IQE'S FROM ASYNCH */
*       /* EXIT QUEUE                                                */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0159
*       RESPECIFY                                                  0159
*         RW1 RESTRICTED;           /*                       @Z40TSDT*/
*       IQEPTR=ASXBFIQE;            /* PTR TO 1ST IQE IN ASYNCH LIST */
         L     IQEPTR,ASXBFIQE(,ASXBPTR)                           0160
*REMOVIQE:                                                         0161
*       DO WHILE IQEPTR^=ZERO;                                     0161
REMOVIQE B     @DE00161                                            0161
@DL00161 DS    0H                                                  0162
*         RIOMB=IQEPARAM;           /* IOMB ADDRESS INTO REGISTER    */
         L     RIOMB,IQEPARAM(,IQEPTR)                             0162
*         IF IOMBID=VALID THEN      /* REMOVE IQE FROM CHAIN IF NEC  */
         CLC   IOMBID(4,RIOMB),@CC00071                            0163
         BNE   @RF00163                                            0163
*           IF IPIBTASK=ON THEN     /* TCB PURGE                     */
         TM    IPIBTASK(IPIBPTR),B'01000000'                       0164
         BNO   @RF00164                                            0164
*             IF IQETCB=IPIBARG THEN/* TCB ADDRESSES COMPARE         */
         CLC   IQETCB(4,IQEPTR),IPIBARG(IPIBPTR)                   0165
         BE    @RT00165                                            0165
*               GO TO RECHAIN;      /* REMOVE IQE FROM CHAIN         */
*             ELSE                  /* DIFFERENT TCB ADDRESSES       */
*               GO TO NXTIQE;       /* CHECK NEXT IQE                */
         B     NXTIQE                                              0167
*           ELSE                    /* DSID PURGE                    */
*             IF AMBDEBAD=IPIBARG THEN/* DEB ADDRESSES COMPARE       */
@RF00164 L     @12,IOMAMB(,RIOMB)                                  0168
         L     @12,AMBDEBAD-1(,@12)                                0168
         LA    @12,0(,@12)                                         0168
         C     @12,IPIBARG(,IPIBPTR)                               0168
         BE    @RT00168                                            0168
*               GO TO RECHAIN;      /* REMOVE IQE FROM CHAIN         */
*             ELSE                  /* DIFFERENT DEB ADDRESSES       */
*               GO TO NXTIQE;       /* CHECK NEXT IQE                */
         B     NXTIQE                                              0170
*         ELSE                      /* NOT AN I/O MANAGER IQE        */
*           GO TO NXTIQE;           /* CHECK NEXT IQE                */
*                                                                  0171
*         /***********************************************************/
*         /*                                                         */
*         /* REMOVE RELEVANT IQE FROM ASYNCH EXIT QUEUE              */
*         /*                                                         */
*         /***********************************************************/
*                                                                  0172
*RECHAIN:                                                          0172
*         IF IQEPTR=ASXBFIQE THEN   /* FIRST IQE IN QUEUE REMOVED    */
RECHAIN  C     IQEPTR,ASXBFIQE(,ASXBPTR)                           0172
         BNE   @RF00172                                            0172
*           ASXBFIQE=IQELNK;        /* CHAIN ASXB TO NEXT IQE        */
         L     @12,IQELNK(,IQEPTR)                                 0173
         ST    @12,ASXBFIQE(,ASXBPTR)                              0173
*         ELSE                      /* RW1 POINTS TO PREVIOUS IQE    */
*           DO;                                                    0174
         B     @RC00172                                            0174
@RF00172 DS    0H                                                  0175
*             RW1->IQELNK=IQELNK;   /* RECHAIN PREVIOUS IQE          */
         L     @12,IQELNK(,IQEPTR)                                 0175
         ST    @12,IQELNK(,RW1)                                    0175
*             IQEPTR=RW1;           /* PTR TO PREVIOUS IQE ON CHAIN  */
         LR    IQEPTR,RW1                                          0176
*           END;                                                   0177
*         IOMLOCK=OFF;                                             0178
@RC00172 MVI   IOMLOCK(RIOMB),B'00000000'                          0178
*         IOMAMUSE=OFF;             /* TURN OFF USE INDICATOR        */
         NI    IOMAMUSE(RIOMB),B'01111111'                         0179
*NXTIQE:                                                           0180
*         RW1=IQEPTR;               /* SAVE POINTER TO PREVIOUS IQE  */
NXTIQE   LR    RW1,IQEPTR                                          0180
*         IQEPTR=IQELNK;            /* NEXT IQE IN CHAIN             */
         L     IQEPTR,IQELNK(,IQEPTR)                              0181
*       END REMOVIQE;                                              0182
@DE00161 SLR   @12,@12                                             0182
         CR    IQEPTR,@12                                          0182
         BNE   @DL00161                                            0182
*       IF ASXBFIQE=ZERO THEN       /* NO IQE'S ON QUEUE     @ZA02502*/
         C     @12,ASXBFIQE(,ASXBPTR)                              0183
         BNE   @RF00183                                            0183
*         ASXBLIQE=ZERO;            /* SET LAST PTR TO ZERO  @ZA02502*/
         ST    @12,ASXBLIQE(,ASXBPTR)                              0184
*       ELSE                        /* QUEUE NOT EMPTY       @ZA02502*/
*         ASXBLIQE=RW1;             /* LAST IQE PTR IN ASXB  @ZA02502*/
         B     @RC00183                                            0185
@RF00183 ST    RW1,ASXBLIQE(,ASXBPTR)                              0185
*       RESPECIFY                                                  0186
*         RW1 UNRESTRICTED;         /*                       @Z40TSDT*/
@RC00183 DS    0H                                                  0187
*     END HALTREQ;                                                 0187
*   ELSE                            /* QUIESCE REQUEST               */
*/********************************************************************/
*/*                  QUIESCE REQUEST                                 */
*/********************************************************************/
*/*     INCREMENT IQE COUNT IN IPIB FOR EACH RELEVANT I/O MGR IQE    */
*/*     SET IOMPURGE BIT ON AND STORE IPIB ADDRESS IN THE IOSB       */
*/*     FOR USE IN THE ASYNCHRONOUS ROUTINE                          */
*/********************************************************************/
*                                                                  0188
*QUIESCE:                                                          0188
*     IF IPIBRBP=ON THEN            /* RB PURGE BIT ON       @ZA00644*/
         B     @RC00130                                            0188
@RF00130 DS    0H                                                  0188
QUIESCE  TM    IPIBRBP(IPIBPTR),B'00100000'                        0188
         BNO   @RF00188                                            0188
*       DO WHILE IQEPTR^=ZERO;                                     0189
         B     @DE00189                                            0189
@DL00189 DS    0H                                                  0190
*         RIOMB=IQEPARAM;           /* PARAMETER ADDRESS IN REGISTER */
         L     RIOMB,IQEPARAM(,IQEPTR)                             0190
*         IF IOMBID=VALID THEN      /* THIS IS AN IOMB               */
         CLC   IOMBID(4,RIOMB),@CC00071                            0191
         BNE   @RF00191                                            0191
*           IF IPIBMEM=ON THEN      /* QUIESCE FOR MEMORY PURGE      */
         TM    IPIBMEM(IPIBPTR),B'10000000'                        0192
         BO    @RT00192                                            0192
*             GO TO SETPURGE;       /* PURGE ALL I/O MGR IQE'S       */
*           ELSE                    /* NOT A MEMORY PURGE            */
*             IF IPIBTASK=ON THEN   /* TCB PURGE                     */
         TM    IPIBTASK(IPIBPTR),B'01000000'                       0194
         BNO   @RF00194                                            0194
*               IF IQETCB=IPIBARG THEN/* TCB ADDRESSES COMPARE       */
         CLC   IQETCB(4,IQEPTR),IPIBARG(IPIBPTR)                   0195
         BE    @RT00195                                            0195
*                 GO TO SETPURGE;   /* RELEVANT IQE                  */
*               ELSE                /* DIFFERENT TCB ADDRESSES       */
*                 GO TO NEXTIQE;    /* CHECK NEXT IQE                */
         B     NEXTIQE                                             0197
*             ELSE                  /* DSID PURGE                    */
*               IF AMBDEBAD=IPIBARG THEN/* DEB ADDRESSES COMPARE     */
@RF00194 L     @12,IOMAMB(,RIOMB)                                  0198
         L     @12,AMBDEBAD-1(,@12)                                0198
         LA    @12,0(,@12)                                         0198
         C     @12,IPIBARG(,IPIBPTR)                               0198
         BE    @RT00198                                            0198
*                 GO TO SETPURGE;   /* RELEVANT IQE                  */
*               ELSE                /* DIFFERENT DEB ADDRESSES       */
*                 GO TO NEXTIQE;    /* CHECK NEXT IQE                */
         B     NEXTIQE                                             0200
*         ELSE                      /* NOT AN IOMB                   */
*           GO TO NEXTIQE;          /* CHECK THE NEXT IQE ON CHAIN   */
*         RESPECIFY                                                0202
*          (RW1,                                                   0202
*           RW2) RSTD;                                             0202
*SETPURGE:                                                         0203
*         IOMPURGE=ON;              /* SET PURGE BIT FOR ASYNCH RTN  */
SETPURGE OI    IOMPURGE(RIOMB),B'00100000'                         0203
*         RW1=IPIBCNT;              /* INITIAL COUNT IN IPIB         */
         L     RW1,IPIBCNT(,IPIBPTR)                               0204
*SETCOUNT:                                                         0205
*         RW2=RW1+ONE;              /* INCREMENT COUNT BY ONE IN REG */
SETCOUNT LA    RW2,1                                               0205
         ALR   RW2,RW1                                             0205
*         GEN;                                                     0206
*                                   /* COMPARE AND SWAP COUNT        */
         CS    RW1,RW2,IPIBCNT(IPIBPTR)
*         BC(7,SETCOUNT);           /* REPEAT IF NOT SUCCESSFUL      */
         BC    7,SETCOUNT                                          0207
*         RESPECIFY                                                0208
*          (IOSBPTR) RSTD;                                         0208
*         IOSBPTR=IOMIOSB;          /* IOSB ADDRESS INTO REGISTER    */
         L     IOSBPTR,IOMIOSB(,RIOMB)                             0209
*         IOSIPIB=IPIBPTR;          /* PTR TO IPIB FOR ASYNCH ROUTINE*/
         ST    IPIBPTR,IOSIPIB(,IOSBPTR)                           0210
*         RESPECIFY                                                0211
*          (RW1,                                                   0211
*           RW2,                                                   0211
*           IOSBPTR) UNRSTD;        /*                       @Z40TSDT*/
*NEXTIQE:                                                          0212
*         IQEPTR=IQELNK;            /* POINTER TO NEXT IQE IN CHAIN  */
NEXTIQE  L     IQEPTR,IQELNK(,IQEPTR)                              0212
*       END;                        /* END OF QUIESCE        @ZA00644*/
*                                                                  0213
@DE00189 LTR   IQEPTR,IQEPTR                                       0213
         BNZ   @DL00189                                            0213
*   /*****************************************************************/
*   /*                                                               */
*   /* RELEASE LOCAL LOCK                                    @ZA02502*/
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0214
*   RESPECIFY                                                      0214
*    (R4,                                                          0214
*     RW1,                                                         0214
*     RW2,                                                         0214
*     RW3) RSTD;                    /*                       @ZA02502*/
@RF00188 DS    0H                                                  0214
@RC00130 DS    0H                                                  0215
*FREELOCK:                          /*                       @ZA04206*/
*   R4=RSAVE;                       /* SAVE REGISTER 13      @ZA02502*/
FREELOCK LR    R4,RSAVE                                            0215
*   GEN REFS(PSALITA,FLC)           /*                       @ZA02502*/
*       (SETLOCK RELEASE,TYPE=LOCAL,RELATED=(LOCAL,IDA121A6));     0216
         SETLOCK RELEASE,TYPE=LOCAL,RELATED=(LOCAL,IDA121A6)
*   IF RSAVE^=ZERO THEN             /* CHECK RETURN CODE     @ZA02502*/
         LTR   RSAVE,RSAVE                                         0217
         BZ    @RF00217                                            0217
*     DO;                           /* ERROR IN ABEND        @ZA02502*/
*       R2=HWORD4;                  /* REASON CODE 4 IN R2   @ZA02502*/
         LA    R2,4                                                0219
*       DO;                         /* ABEND(377) DUMP SYSTEM        */
*         RESPECIFY                                                0221
*          (GPR01F) RESTRICTED;                                    0221
*         GPR01F=((377)&'00000FFF'X)*4096;/* COMP CODE IN BITS 8-19  */
         L     GPR01F,@CF01706                                     0222
*         GPR01F=GPR01F|'80000000'X;/* DUMP/STEP/DUMPOPTS FLAG       */
         O     GPR01F,@CF00069                                     0223
*         SVC(13);                  /* ISSUE ABEND SVC               */
         SVC   13                                                  0224
*         RESPECIFY                                                0225
*          (GPR01F) UNRESTRICTED;                                  0225
*       END;                        /* ABEND(377) DUMP SYSTEM LOCK 0226
*                                      ALREADY HELD          @ZA02502*/
*     END;                          /*                       @ZA02502*/
*   RSAVE=R4;                       /* RESTORE REG 13        @ZA02502*/
@RF00217 LR    RSAVE,R4                                            0228
*   RESPECIFY                                                      0229
*    (R4,                                                          0229
*     RW1,                                                         0229
*     RW2,                                                         0229
*     RW3) UNRSTD;                  /*                       @ZA02502*/
*   RETURN;                         /* ALL IQE'S CHECKED     @ZA04206*/
@EL00001 DS    0H                                                  0230
@EF00001 DS    0H                                                  0230
@ER00001 LM    @14,@12,12(@13)                                     0230
         BR    @14                                                 0230
*   DECLARE                         /* GENERAL PURPOSE REGISTERS     */
*     GPR01F FIXED(31) REG(1);                                     0231
*   DECLARE                         /* COMMON VARIABLES              */
*     I256C CHAR(256) BASED,                                       0232
*     I031F FIXED(31) BASED,                                       0232
*     I031P PTR(31) BASED,                                         0232
*     I015F FIXED(15) BASED,                                       0232
*     I015P PTR(15) BASED,                                         0232
*     I008P PTR(8) BASED,                                          0232
*     I001C CHAR(1) BASED;          /* DECLARES FOR PLS MACROS       */
*   END IDA121A6                                                   0233
*                                                                  0233
*/* THE FOLLOWING INCLUDE STATEMENTS WERE FOUND IN THIS PROGRAM.     */
*/*%INCLUDE SYSLIB  (IDAAMB  )                                       */
*/*%INCLUDE SYSLIB  (IHAASCB )                                       */
*/*%INCLUDE SYSLIB  (IHAASXB )                                       */
*/*%INCLUDE SYSLIB  (CVT     )                                       */
*/*%INCLUDE SYSLIB  (IDAIOMB )                                       */
*/*%INCLUDE SYSLIB  (IECDIOSB)                                       */
*/*%INCLUDE SYSLIB  (IECDIPIB)                                       */
*/*%INCLUDE SYSLIB  (IHAIQE  )                                       */
*/*%INCLUDE SYSLIB  (IHAPSA  )                                       */
*/*%INCLUDE SYSLIB  (IHASRB  )                                       */
*                                                                  0233
*       ;                                                          0233
@DATA    DS    0H
@DATD    DSECT
         DS    0F
IDA121A6 CSECT
         DS    0F
@CF01706 DC    F'1544192'
@CF00069 DC    XL4'80000000'
@DATD    DSECT
         DS    0D
         ORG   *+1-(*-@DATD)/(*-@DATD) INSURE DSECT DATA
@ENDDATD EQU   *
IDA121A6 CSECT
         DS    0F
@SIZDATD DC    AL1(0)
         DC    AL3(@ENDDATD-@DATD)
         DS    0D
@CC00071 DC    C'IOMB'
@00      EQU   00                      EQUATES FOR REGISTERS 0-15
@01      EQU   01
@02      EQU   02
@03      EQU   03
@04      EQU   04
@05      EQU   05
@06      EQU   06
@07      EQU   07
@08      EQU   08
@09      EQU   09
@10      EQU   10
@11      EQU   11
@12      EQU   12
@13      EQU   13
@14      EQU   14
@15      EQU   15
R0       EQU   @00
R1       EQU   @01
R2       EQU   @02
IPIBPTR  EQU   @02
IQEPTR   EQU   @03
R4       EQU   @04
RIOMB    EQU   @05
ASXBPTR  EQU   @06
SRBPTR   EQU   @07
IOSBPTR  EQU   @08
RBASE    EQU   @09
RW1      EQU   @10
RW2      EQU   @11
RW3      EQU   @12
RSAVE    EQU   @13
R14      EQU   @14
R15      EQU   @15
GPR01F   EQU   @01
PSA      EQU   0
FLCRNPSW EQU   PSA
FLCROPSW EQU   PSA+8
FLCICCW2 EQU   PSA+16
FLCCVT   EQU   FLCICCW2
PSAEEPSW EQU   PSA+132
PSAESPSW EQU   PSA+136
FLCSVILC EQU   PSAESPSW+1
PSAEPPSW EQU   PSA+140
FLCPIILC EQU   PSAEPPSW+1
FLCPICOD EQU   PSAEPPSW+2
PSAPICOD EQU   FLCPICOD+1
FLCTEA   EQU   PSAEPPSW+4
FLCPER   EQU   PSA+152
FLCMCLA  EQU   PSA+168
FLCIOEL  EQU   FLCMCLA+4
FLCIOA   EQU   FLCMCLA+16
FLCFSA   EQU   FLCMCLA+80
PSAAOLD  EQU   PSA+548
PSASUPER EQU   PSA+552
PSASUP1  EQU   PSASUPER
PSASUP2  EQU   PSASUPER+1
PSASUP3  EQU   PSASUPER+2
PSASUP4  EQU   PSASUPER+3
PSACLHT  EQU   PSA+640
PSALKSA  EQU   PSA+696
PSAHLHI  EQU   PSA+760
PSALITA  EQU   PSA+764
PSADSSFL EQU   PSA+836
PSADSSF1 EQU   PSADSSFL
PSADSSF3 EQU   PSADSSFL+2
PSADSSF4 EQU   PSADSSFL+3
PSARSVT  EQU   PSA+896
@NM00001 EQU   0
VSLFIX   EQU   @NM00001
VSLFREE  EQU   @NM00001
IDAAMB   EQU   0
AMBEOVR  EQU   IDAAMB+24
AMBFLG0  EQU   AMBEOVR
AMBFLG1  EQU   IDAAMB+25
AMBDSORG EQU   IDAAMB+26
AMBIOBAD EQU   IDAAMB+28
AMBINFL  EQU   IDAAMB+42
AMBDEBPT EQU   IDAAMB+44
AMBDEBAD EQU   AMBDEBPT+1
AMBOFLGS EQU   IDAAMB+48
AMBFLG2  EQU   IDAAMB+49
AMBEOVPT EQU   IDAAMB+56
AMBCSWD1 EQU   IDAAMB+84
AMBAFLG  EQU   AMBCSWD1
ASCB     EQU   0
ASCBSUPC EQU   ASCB+16
ASCBASID EQU   ASCB+36
ASCBRSM  EQU   ASCB+52
ASCBRSMF EQU   ASCBRSM
ASCBFW1  EQU   ASCB+100
ASCBRCTF EQU   ASCBFW1+2
ASCBFLG1 EQU   ASCBFW1+3
ASCBASXB EQU   ASCB+108
ASCBDSP1 EQU   ASCB+114
ASCBFLG2 EQU   ASCB+115
ASCBLKGP EQU   ASCB+128
ASCBSRQ  EQU   ASCB+180
ASCBSRQ1 EQU   ASCBSRQ
ASCBSRQ2 EQU   ASCBSRQ+1
ASCBSRQ3 EQU   ASCBSRQ+2
ASCBSRQ4 EQU   ASCBSRQ+3
ASXB     EQU   0
ASXBAEQ  EQU   ASXB+168
ASXBFIQE EQU   ASXBAEQ
ASXBLIQE EQU   ASXBAEQ+4
ASXBSECR EQU   ASXB+199
ASCBSFLG EQU   ASXBSECR
ASXBCASW EQU   ASXB+216
ASXBCRB1 EQU   ASXBCASW
CVTMAP   EQU   0
CVTDAR   EQU   CVTMAP+72
CVTFLGS1 EQU   CVTDAR
CVTDCB   EQU   CVTMAP+116
CVTIOQET EQU   CVTMAP+120
CVTIERLC EQU   CVTMAP+144
CVTHEAD  EQU   CVTMAP+160
CVTSV76C EQU   CVTHEAD
CVTOPTA  EQU   CVTMAP+182
CVTOPTB  EQU   CVTMAP+183
CVTGTF   EQU   CVTMAP+236
CVTGTFST EQU   CVTGTF
CVTGTFS  EQU   CVTGTFST
CVTSTATE EQU   CVTGTFST
CVTTMODE EQU   CVTGTFST
CVTFORM  EQU   CVTGTFST
CVTAQAVT EQU   CVTMAP+240
CVTTCMFG EQU   CVTAQAVT
CVTVOLM2 EQU   CVTMAP+244
CVTTATA  EQU   CVTVOLM2
CVTTSKS  EQU   CVTTATA
CVTVOLF2 EQU   CVTTSKS
CVTTAT   EQU   CVTTATA+1
CVTATER  EQU   CVTMAP+248
CVTEXT1  EQU   CVTMAP+252
CVTPURG  EQU   CVTMAP+260
CVTQMSG  EQU   CVTMAP+268
CVTDMSR  EQU   CVTMAP+272
CVTRSV37 EQU   CVTDMSR
CVTDMSRF EQU   CVTRSV37
CVTERPV  EQU   CVTMAP+316
CVTINTLA EQU   CVTMAP+320
CVTAPF   EQU   CVTMAP+324
CVTEXT2  EQU   CVTMAP+328
CVTHJES  EQU   CVTMAP+332
CVTPGSIA EQU   CVTMAP+348
CVTA1F1  EQU   CVTMAP+356
CVTSYSK  EQU   CVTMAP+357
CVTVOLM1 EQU   CVTMAP+380
CVTVOLF1 EQU   CVTVOLM1
CVTATMCT EQU   CVTMAP+388
CVTXTNT1 EQU   0
CVTXTNT2 EQU   0
CVTDSSV  EQU   CVTXTNT2
CVTFLGBT EQU   CVTXTNT2+5
CVTQID   EQU   CVTXTNT2+24
CVTRV400 EQU   CVTXTNT2+52
CVTRV409 EQU   CVTXTNT2+53
CVTATCVT EQU   CVTXTNT2+64
CVTRV429 EQU   CVTXTNT2+84
CVTRV438 EQU   CVTXTNT2+85
CVTRV457 EQU   CVTXTNT2+112
CVTRV466 EQU   CVTXTNT2+113
CVTFIX   EQU   0
CVTRELNO EQU   CVTFIX+252
IDAIOMB  EQU   0
IOMBID   EQU   IDAIOMB
IOMAMB   EQU   IDAIOMB+16
IOMIQE   EQU   IDAIOMB+20
IOMVSL   EQU   IDAIOMB+28
IOMIOSB  EQU   IDAIOMB+36
IOMFLAGS EQU   IDAIOMB+40
IOMFL    EQU   IOMFLAGS
IOMAPEND EQU   IOMFL
IOMPURGE EQU   IOMFL
IOMPGFIX EQU   IOMFL
IOMSTIND EQU   IOMFLAGS+2
IOMAMUSE EQU   IOMSTIND
IOMLOCK  EQU   IDAIOMB+45
IOMSAVER EQU   IDAIOMB+52
IOSB     EQU   0
IOSFLA   EQU   IOSB
IOSACHN  EQU   IOSFLA
IOSFLB   EQU   IOSB+1
IOSFLC   EQU   IOSB+2
IOSDVALT EQU   IOSFLC
IOSDVRID EQU   IOSB+4
IOSASID  EQU   IOSB+6
IOSPKEY  EQU   IOSB+12
IOSOPT   EQU   IOSB+14
IOSOPT2  EQU   IOSB+15
@NM00021 EQU   IOSB+20
IOSCSW   EQU   @NM00021+1
IOSTATUS EQU   IOSCSW+3
IOSUSE   EQU   IOSB+32
IOSIPIB  EQU   IOSB+44
IOSPATH  EQU   IOSB+86
IOSCHN   EQU   IOSPATH
IOSCKEY  EQU   IOSB+89
IOSEEKA  EQU   IOSB+100
IOSCCHH  EQU   IOSEEKA+3
IOSSKHH  EQU   IOSCCHH+2
IPIB     EQU   0
IPIBOPT  EQU   IPIB
IPIBMEM  EQU   IPIBOPT
IPIBTASK EQU   IPIBOPT
IPIBRBP  EQU   IPIBOPT
IPIBHALT EQU   IPIBOPT
IPIBFLG1 EQU   IPIB+2
IPIBCNT  EQU   IPIB+4
IPIBARG  EQU   IPIB+12
IPIBSRB  EQU   IPIB+16
IQESECT  EQU   0
IQELNK   EQU   IQESECT
IQEPARAM EQU   IQESECT+4
IQEIRB   EQU   IQESECT+8
IQEFLAGS EQU   IQEIRB
IQETCB   EQU   IQESECT+12
SRBSECT  EQU   0
SRB      EQU   SRBSECT
SRBFLNK  EQU   SRB+4
SRBFLC   EQU   SRB+12
SRBPARM  EQU   SRB+28
IQEEND   EQU   0
I001C    EQU   0
I008P    EQU   0
I015F    EQU   0
I015P    EQU   0
I031F    EQU   0
I031P    EQU   0
I256C    EQU   0
CVTPTR   EQU   FLCCVT
CVTS01   EQU   CVTPGSIA
CVTLPDIA EQU   CVTS01+12
CVTDIRST EQU   CVTLPDIA
CVTSLIDA EQU   CVTS01+24
CVTCTLFG EQU   CVTS01+50
CVTRV210 EQU   CVTS01+424
CVTRV219 EQU   CVTS01+425
CVTRV228 EQU   CVTS01+426
CVTRV237 EQU   CVTS01+427
CVTMFRTR EQU   CVTS01+452
CVTVPSIB EQU   CVTS01+456
CVTRV262 EQU   CVTS01+468
CVTRV271 EQU   CVTS01+469
CVTRV280 EQU   CVTS01+470
CVTRV289 EQU   CVTS01+471
CVTGSDA  EQU   CVTS01+600
IOSATTSC EQU   IOSIPIB
IOSWTOWA EQU   IOSIPIB
IOSPCISC EQU   IOSIPIB
FLC      EQU   PSA
PSARSVTE EQU   PSARSVT
         AGO   .@UNREFD                START UNREFERENCED COMPONENTS
PSARSAV  EQU   PSARSVTE+60
PSARSTK  EQU   PSARSVTE+56
PSAESAV3 EQU   PSARSVTE+52
PSAESTK3 EQU   PSARSVTE+48
PSAESAV2 EQU   PSARSVTE+44
PSAESTK2 EQU   PSARSVTE+40
PSAESAV1 EQU   PSARSVTE+36
PSAESTK1 EQU   PSARSVTE+32
PSAPSAV  EQU   PSARSVTE+28
PSAPSTK  EQU   PSARSVTE+24
PSAMSAV  EQU   PSARSVTE+20
PSAMSTK  EQU   PSARSVTE+16
PSASSAV  EQU   PSARSVTE+12
PSASSTK  EQU   PSARSVTE+8
PSANSTK  EQU   PSARSVTE+4
PSACSTK  EQU   PSARSVTE
IOSPCIWA EQU   IOSPCISC+44
IOSPCIRS EQU   IOSPCISC+8
@NM00026 EQU   IOSPCISC+4
@NM00025 EQU   IOSPCISC
IOSWRNDR EQU   IOSWTOWA+4
IOSWTOPT EQU   IOSWTOWA+3
IOSWTOCP EQU   IOSWTOWA+2
IOSWTOCH EQU   IOSWTOWA
IOSATTWA EQU   IOSATTSC+40
@NM00024 EQU   IOSATTSC+24
IOSATTSN EQU   IOSATTSC
CVTRV628 EQU   CVTS01+728
CVTRV627 EQU   CVTS01+724
CVTRV626 EQU   CVTS01+720
CVTRV625 EQU   CVTS01+716
CVTRV624 EQU   CVTS01+712
CVTRV623 EQU   CVTS01+708
CVTRV622 EQU   CVTS01+704
CVTRV621 EQU   CVTS01+700
CVTIHASU EQU   CVTS01+696
CVTSUSP  EQU   CVTS01+692
CVTT6SVC EQU   CVTS01+688
CVTCDAL  EQU   CVTS01+684
CVTTCTL  EQU   CVTS01+680
CVTRSUME EQU   CVTS01+676
CVTJTERM EQU   CVTS01+672
CVTASMRM EQU   CVTS01+668
CVTTCASP EQU   CVTS01+664
CVT0PT03 EQU   CVTS01+660
CVT0PT0E EQU   CVTS01+656
CVTRV609 EQU   CVTS01+652
CVTCGK   EQU   CVTS01+648
CVTRAC   EQU   CVTS01+644
CVTHSM   EQU   CVTS01+640
CVTRV605 EQU   CVTS01+636
CVTRV604 EQU   CVTS01+632
CVTEFF02 EQU   CVTS01+628
CVTCBBR  EQU   CVTS01+624
CVTSSCR  EQU   CVTS01+620
CVTEVENT EQU   CVTS01+616
CVTCRCA  EQU   CVTS01+612
CVTTPIO  EQU   CVTS01+608
CVTADV   EQU   CVTS01+604
CVTGSDAB EQU   CVTGSDA
CVTQV3   EQU   CVTS01+596
CVTQV2   EQU   CVTS01+592
CVTQV1   EQU   CVTS01+588
CVTRPT   EQU   CVTS01+584
CVTSSRB  EQU   CVTS01+580
CVTCSDRL EQU   CVTS01+576
CVTEXP1  EQU   CVTS01+572
CVTRMPMT EQU   CVTS01+568
CVTRMPTT EQU   CVTS01+564
CVTVPSA  EQU   CVTS01+560
CVTVSTOP EQU   CVTS01+556
CVTGTFR8 EQU   CVTS01+552
CVTQUIT  EQU   CVTS01+548
CVTVACR  EQU   CVTS01+544
CVTWTCB  EQU   CVTS01+540
CVTSTPRS EQU   CVTS01+536
CVT0PT02 EQU   CVTS01+532
CVTDARCM EQU   CVTS01+528
CVTIRECM EQU   CVTS01+524
CVTJRECM EQU   CVTS01+520
CVTVEMS0 EQU   CVTS01+516
CVTSPFRR EQU   CVTS01+512
CVTRLSTG EQU   CVTS01+508
CVT0TC0A EQU   CVTS01+504
CVTGMBR  EQU   CVTS01+500
CVTLFRM  EQU   CVTS01+496
CVTRMBR  EQU   CVTS01+492
CVTVIOP  EQU   CVTS01+488
CVTRV307 EQU   CVTS01+486
CVTRV306 EQU   CVTS01+484
CVTRV305 EQU   CVTS01+482
CVTRV304 EQU   CVTS01+480
CVTRV303 EQU   CVTS01+478
CVTRV302 EQU   CVTS01+476
CVTTRCA  EQU   CVTS01+472
CVTRV297 EQU   CVTRV289
CVTRV296 EQU   CVTRV289
CVTRV295 EQU   CVTRV289
CVTRV294 EQU   CVTRV289
CVTRV293 EQU   CVTRV289
CVTRV292 EQU   CVTRV289
CVTRV291 EQU   CVTRV289
CVTRV290 EQU   CVTRV289
CVTRV288 EQU   CVTRV280
CVTRV287 EQU   CVTRV280
CVTRV286 EQU   CVTRV280
CVTRV285 EQU   CVTRV280
CVTRV284 EQU   CVTRV280
CVTRV283 EQU   CVTRV280
CVTRV282 EQU   CVTRV280
CVTRV281 EQU   CVTRV280
CVTRV279 EQU   CVTRV271
CVTRV278 EQU   CVTRV271
CVTRV277 EQU   CVTRV271
CVTRV276 EQU   CVTRV271
CVTRV275 EQU   CVTRV271
CVTRV274 EQU   CVTRV271
CVTRV273 EQU   CVTRV271
CVTRV272 EQU   CVTRV271
CVTRV270 EQU   CVTRV262
CVTRV269 EQU   CVTRV262
CVTRV268 EQU   CVTRV262
CVTRV267 EQU   CVTRV262
CVTRV266 EQU   CVTRV262
CVTRV265 EQU   CVTRV262
CVTRV264 EQU   CVTRV262
CVTRV263 EQU   CVTRV262
CVTVFP   EQU   CVTS01+464
CVTVSI   EQU   CVTS01+460
CVTMFACT EQU   CVTMFRTR
CVTMFCTL EQU   CVTS01+448
CVTPVBP  EQU   CVTS01+444
CVTPWI   EQU   CVTS01+440
CVTRV254 EQU   CVTS01+438
CVTRV253 EQU   CVTS01+436
CVTRV252 EQU   CVTS01+434
CVTRV251 EQU   CVTS01+433
CVTRV250 EQU   CVTS01+432
CVTRV249 EQU   CVTS01+431
CVTRV248 EQU   CVTS01+430
CVTRV247 EQU   CVTS01+429
CVTRV246 EQU   CVTS01+428
CVTRV245 EQU   CVTRV237
CVTRV244 EQU   CVTRV237
CVTRV243 EQU   CVTRV237
CVTRV242 EQU   CVTRV237
CVTRV241 EQU   CVTRV237
CVTRV240 EQU   CVTRV237
CVTRV239 EQU   CVTRV237
CVTRV238 EQU   CVTRV237
CVTRV236 EQU   CVTRV228
CVTRV235 EQU   CVTRV228
CVTRV234 EQU   CVTRV228
CVTRV233 EQU   CVTRV228
CVTRV232 EQU   CVTRV228
CVTRV231 EQU   CVTRV228
CVTRV230 EQU   CVTRV228
CVTRV229 EQU   CVTRV228
CVTRV227 EQU   CVTRV219
CVTRV226 EQU   CVTRV219
CVTRV225 EQU   CVTRV219
CVTRV224 EQU   CVTRV219
CVTRV223 EQU   CVTRV219
CVTRV222 EQU   CVTRV219
CVTRV221 EQU   CVTRV219
CVTRV220 EQU   CVTRV219
CVTRV218 EQU   CVTRV210
CVTRV217 EQU   CVTRV210
CVTRV216 EQU   CVTRV210
CVTRV215 EQU   CVTRV210
CVTRV214 EQU   CVTRV210
CVTRV213 EQU   CVTRV210
CVTRV212 EQU   CVTRV210
CVTRV211 EQU   CVTRV210
CVTLCCAT EQU   CVTS01+420
CVTPCCAT EQU   CVTS01+416
CVTIPCRP EQU   CVTS01+412
CVTIPCRI EQU   CVTS01+408
CVTIPCDS EQU   CVTS01+404
CVTAIDVT EQU   CVTS01+400
CVTSSAP  EQU   CVTS01+396
CVTEHCIR EQU   CVTS01+392
CVTEHDEF EQU   CVTS01+388
CVTDAIR  EQU   CVTS01+384
CVTPERFM EQU   CVTS01+380
CVT044R2 EQU   CVTS01+376
CVTFETCH EQU   CVTS01+372
CVTRSTWD EQU   CVTS01+368
CVTSPOST EQU   CVTS01+364
CVTIOBP  EQU   CVTS01+360
CVTASMVT EQU   CVTS01+356
CVTRECRQ EQU   CVTS01+352
CVTWSAC  EQU   CVTS01+348
CVTRV149 EQU   CVTS01+344
CVTWSAL  EQU   CVTS01+340
CVTSPSA  EQU   CVTS01+336
CVTGLMN  EQU   CVTS01+332
CVTVEAC0 EQU   CVTS01+328
CVT062R1 EQU   CVTS01+324
CVTRPOST EQU   CVTS01+320
CVTDQIQE EQU   CVTS01+316
CVTCSD   EQU   CVTS01+312
CVTLKRMA EQU   CVTS01+308
CVTRSPIE EQU   CVTS01+304
CVTRENQ  EQU   CVTS01+300
CVTLQCB  EQU   CVTS01+296
CVTFQCB  EQU   CVTS01+292
CVTQCS01 EQU   CVTS01+288
CVTAPFT  EQU   CVTS01+284
CVTPARRL EQU   CVTS01+280
CVTVWAIT EQU   CVTS01+276
CVTGSPL  EQU   CVTS01+272
CVTLSMQ  EQU   CVTS01+268
CVTGSMQ  EQU   CVTS01+264
CVTEXPRO EQU   CVTS01+260
CVTOPCTP EQU   CVTS01+256
CVTSIC   EQU   CVTS01+252
CVTTPIOS EQU   CVTS01+248
CVTRTMS  EQU   CVTS01+244
CVTSDBF  EQU   CVTS01+240
CVTSCBP  EQU   CVTS01+236
CVTSDMP  EQU   CVTS01+232
CVTSV60  EQU   CVTS01+228
CVTRTMCT EQU   CVTS01+224
CVTASCBL EQU   CVTS01+220
CVTASCBH EQU   CVTS01+216
CVTGDA   EQU   CVTS01+212
CVTASVT  EQU   CVTS01+208
CVTVVMDI EQU   CVTS01+204
CVTAQTOP EQU   CVTS01+200
CVTIOSCS EQU   CVTS01+196
CVTSDRM  EQU   CVTS01+192
CVTOPTE  EQU   CVTS01+188
CVTSTXU  EQU   CVTS01+184
CVTQUIS  EQU   CVTS01+180
CVTPARS  EQU   CVTS01+176
CVTS1EE  EQU   CVTS01+172
CVTFRAS  EQU   CVTS01+168
CVTQSAS  EQU   CVTS01+164
CVTCRAS  EQU   CVTS01+160
CVTCRMN  EQU   CVTS01+156
CVTDELCP EQU   CVTS01+152
CVTFRECL EQU   CVTS01+148
CVTGETCL EQU   CVTS01+144
CVTBLDCP EQU   CVTS01+140
CVTAUTHL EQU   CVTS01+136
CVTSCAN  EQU   CVTS01+132
CVTRV144 EQU   CVTS01+130
CVTMAXMP EQU   CVTS01+128
CVTSTCK  EQU   CVTS01+124
CVTRV139 EQU   CVTS01+123
CVTDSSAC EQU   CVTS01+122
CVTRV513 EQU   CVTS01+121
CVTIOSPL EQU   CVTS01+120
CVTPTGT  EQU   CVTS01+116
CVTCSPIE EQU   CVTS01+112
CVTSMFEX EQU   CVTS01+108
CVTOLT0A EQU   CVTS01+104
CVTSRBRT EQU   CVTS01+100
CVTPUTL  EQU   CVTS01+96
CVTASCRL EQU   CVTS01+92
CVTASCRF EQU   CVTS01+88
CVTRV326 EQU   CVTS01+84
CVTRV325 EQU   CVTS01+80
CVTRV324 EQU   CVTS01+76
CVT0VL01 EQU   CVTS01+72
CVTSHRVM EQU   CVTS01+68
CVTRV332 EQU   CVTS01+64
CVTTAS   EQU   CVTS01+60
CVTRSCN  EQU   CVTS01+56
CVTTRAC2 EQU   CVTS01+54
CVTTRACE EQU   CVTS01+52
CVTAPG   EQU   CVTS01+51
CVTSDTRC EQU   CVTCTLFG
CVTGTRCE EQU   CVTCTLFG
CVTNOMP  EQU   CVTCTLFG
CVTRSV79 EQU   CVTCTLFG
CVTDSTAT EQU   CVTCTLFG
CVTRSV78 EQU   CVTCTLFG
CVTRV333 EQU   CVTCTLFG
CVTRV323 EQU   CVTCTLFG
CVTSPVLK EQU   CVTS01+49
CVTRSV77 EQU   CVTS01+48
CVTRV331 EQU   CVTS01+44
CVTRV330 EQU   CVTS01+40
CVTRV329 EQU   CVTS01+36
CVTRV328 EQU   CVTS01+32
CVTRV322 EQU   CVTS01+28
CVTSLID  EQU   CVTSLIDA+1
CVTSYLK  EQU   CVTSLIDA
CVTRV321 EQU   CVTS01+20
CVTRV320 EQU   CVTS01+16
CVTLPDIR EQU   CVTLPDIA+1
CVTRSV69 EQU   CVTDIRST
CVTRSV68 EQU   CVTDIRST
CVTRSV67 EQU   CVTDIRST
CVTRSV66 EQU   CVTDIRST
CVTRSV65 EQU   CVTDIRST
CVTRSV64 EQU   CVTDIRST
CVTRSV63 EQU   CVTDIRST
CVTDICOM EQU   CVTDIRST
CVTPVTP  EQU   CVTS01+8
CVTLPDSR EQU   CVTS01+4
CVTGETL  EQU   CVTS01
@NM00062 EQU   SRB+40
@NM00061 EQU   SRB+38
SRBPRIOR EQU   SRB+37
SRBPKF   EQU   SRB+36
SRBSAVE  EQU   SRB+32
SRBRMTR  EQU   SRB+24
SRBEP    EQU   SRB+20
SRBPTCB  EQU   SRBFLC+4
SRBPASID EQU   SRBFLC+2
SRBCPAFF EQU   SRBFLC
SRBASCB  EQU   SRB+8
SRBID    EQU   SRB
IQEOUTLM EQU   IQESECT+20
IQEDCB   EQU   IQESECT+16
IQETCBA  EQU   IQETCB+1
IQESTAT2 EQU   IQETCB
IQEIRBA  EQU   IQEIRB+1
@NM00036 EQU   IQEFLAGS
@NM00035 EQU   IQEFLAGS
@NM00034 EQU   IQEFLAGS
@NM00033 EQU   IQEFLAGS
@NM00032 EQU   IQEFLAGS
@NM00031 EQU   IQEFLAGS
@NM00030 EQU   IQEFLAGS
IQEPURGE EQU   IQEFLAGS
IQELNKA  EQU   IQELNK+1
IQESTAT1 EQU   IQELNK
IPIBEND  EQU   IPIB+40
IPIBLNK  EQU   IPIB+36
IPIBPSQ  EQU   IPIB+32
IPIBPIRL EQU   IPIB+28
IPIBDVRU EQU   IPIB+24
IPIBIO   EQU   IPIB+20
IPIBECB  EQU   IPIB+8
@NM00029 EQU   IPIB+3
@NM00028 EQU   IPIBFLG1
IPIBDQ   EQU   IPIBFLG1
IPIBDVID EQU   IPIB+1
@NM00027 EQU   IPIBOPT
IPIBOTCB EQU   IPIBOPT
IPIBREL  EQU   IPIBOPT
IPIBPOST EQU   IPIBOPT
IOSEND   EQU   IOSB+108
IOSSKR   EQU   IOSEEKA+7
IOSSKH2  EQU   IOSSKHH+1
IOSSKH1  EQU   IOSSKHH
IOSSKCC  EQU   IOSCCHH
IOSSKBB  EQU   IOSEEKA+1
IOSSKM   EQU   IOSEEKA
IOSEEK   EQU   IOSB+92
IOSMDM   EQU   IOSB+91
IOSMDB   EQU   IOSB+90
IOSCKEY7 EQU   IOSCKEY
IOSCKEY6 EQU   IOSCKEY
IOSCKEY5 EQU   IOSCKEY
IOSCKEY4 EQU   IOSCKEY
@NM00023 EQU   IOSCKEY
IOSFMSK  EQU   IOSB+88
IOSCUDEV EQU   IOSPATH+1
@NM00022 EQU   IOSCHN
IOSPATH3 EQU   IOSCHN
IOSPATH2 EQU   IOSCHN
IOSEXP   EQU   IOSCHN
IOSGDP   EQU   IOSCHN
IOSAFF   EQU   IOSB+85
IOSRSS1B EQU   IOSB+84
IOSDSID  EQU   IOSB+80
IOSVST   EQU   IOSB+76
IOSRST   EQU   IOSB+72
IOSDIE   EQU   IOSB+68
IOSABN   EQU   IOSB+64
IOSNRM   EQU   IOSB+60
IOSPCI   EQU   IOSB+56
IOSERP   EQU   IOSB+52
IOSPCHN  EQU   IOSB+48
IOSSNS   EQU   IOSB+42
IOSAPMSK EQU   IOSB+40
IOSRES4A EQU   IOSB+36
IOSSRB   EQU   IOSB+28
IOSCSWRC EQU   IOSCSW+5
IOSTSB   EQU   IOSTATUS+1
IOSTSA   EQU   IOSTATUS
IOSCSWCA EQU   IOSCSW
IOSCC    EQU   @NM00021
IOSUCB   EQU   IOSB+16
IOSOPT2X EQU   IOSOPT2
IOSIGP   EQU   IOSOPT2
IOSHTP   EQU   IOSOPT2
IOSRELSE EQU   IOSOPT
IOSAPR   EQU   IOSOPT
IOSTSLL  EQU   IOSOPT
IOSNERP  EQU   IOSOPT
IOSPSLL  EQU   IOSOPT
IOSQISCE EQU   IOSOPT
IOSDEP   EQU   IOSOPT
IOSBYP   EQU   IOSOPT
IOSCOD   EQU   IOSB+13
IOSPKY7  EQU   IOSPKEY
IOSPGDPX EQU   IOSPKEY
IOSIDR   EQU   IOSPKEY
IOSLCL   EQU   IOSPKEY
@NM00020 EQU   IOSPKEY
IOSPGAD  EQU   IOSB+8
IOSPRLVL EQU   IOSB+5
IOSPROC  EQU   IOSB+3
IOSFLC7  EQU   IOSFLC
IOSCTCNR EQU   IOSFLC
IOSRWAIT EQU   IOSFLC
IOSTP    EQU   IOSFLC
IOSCC3WE EQU   IOSFLC
IOSVERIF EQU   IOSDVALT
IOSDVMNT EQU   IOSFLC
IOSLOG   EQU   IOSFLB
IOSBDCST EQU   IOSFLB
IOSMSG   EQU   IOSFLB
IOSFLB4  EQU   IOSFLB
IOSFLB3  EQU   IOSFLB
IOSNOTRS EQU   IOSFLB
IOSSDR   EQU   IOSFLB
IOSDIESE EQU   IOSFLB
IOSIOSB  EQU   IOSFLA
IOSDOM   EQU   IOSFLA
IOSEX    EQU   IOSFLA
IOSSMDB  EQU   IOSFLA
IOSSMDA  EQU   IOSFLA
IOSERR   EQU   IOSFLA
IOSCCHN  EQU   IOSACHN
IOSDCHN  EQU   IOSACHN
IOMSTCB  EQU   IDAIOMB+128
IOMSRBP  EQU   IDAIOMB+124
IOMUFLD  EQU   IDAIOMB+120
IOMNXT1  EQU   IDAIOMB+116
IOMSAVEF EQU   IOMSAVER+60
IOMSAVEE EQU   IOMSAVER+56
IOMSAVED EQU   IOMSAVER+52
IOMSAVEC EQU   IOMSAVER+48
IOMSAVEB EQU   IOMSAVER+44
IOMSAVEA EQU   IOMSAVER+40
IOMSAVE9 EQU   IOMSAVER+36
IOMSAVE8 EQU   IOMSAVER+32
IOMSAVE7 EQU   IOMSAVER+28
IOMSAVE6 EQU   IOMSAVER+24
IOMSAVE5 EQU   IOMSAVER+20
IOMSAVE4 EQU   IOMSAVER+16
IOMSAVE3 EQU   IOMSAVER+12
IOMSAVE2 EQU   IOMSAVER+8
IOMSAVE1 EQU   IOMSAVER+4
IOMSAVE0 EQU   IOMSAVER
IOMNSEG  EQU   IDAIOMB+50
IOMNBUF  EQU   IDAIOMB+48
IOMNMOD  EQU   IDAIOMB+46
IOMPFERR EQU   IDAIOMB+44
IOMCKEY  EQU   IDAIOMB+43
IOMSR    EQU   IOMSTIND
IOMSRBM  EQU   IOMSTIND
IOMSLOC  EQU   IOMSTIND
IOMLLOCK EQU   IOMSTIND
IOMEOVXC EQU   IOMSTIND
IOMEOVTS EQU   IOMSTIND
IOMEOVW  EQU   IOMSTIND
@NM00019 EQU   IOMFL+1
IOMIRBSW EQU   IOMFL+1
IOMEEXIT EQU   IOMFL+1
@NM00018 EQU   IOMFL+1
IOMCPRB  EQU   IOMFL+1
IOMDDR   EQU   IOMFL+1
IOMCSW   EQU   IOMFL
IOMADERR EQU   IOMFL
IOMCBERR EQU   IOMFL
@NM00017 EQU   IOMFL
IOMAE    EQU   IOMAPEND
IOMNE    EQU   IOMAPEND
IOMPGAD  EQU   IDAIOMB+32
IOMECBPT EQU   IDAIOMB+24
IOMPLH   EQU   IDAIOMB+12
IOMCPA   EQU   IDAIOMB+8
IOMBUFC  EQU   IDAIOMB+4
CVTLEVL  EQU   CVTRELNO+2
CVTNUMB  EQU   CVTRELNO
CVTMDL   EQU   CVTFIX+250
@NM00016 EQU   CVTFIX+248
@NM00015 EQU   CVTFIX
CVTRV482 EQU   CVTXTNT2+128
CVTRV481 EQU   CVTXTNT2+124
CVTRV480 EQU   CVTXTNT2+120
CVTRV479 EQU   CVTXTNT2+118
CVTRV478 EQU   CVTXTNT2+117
CVTRV477 EQU   CVTXTNT2+116
CVTRV476 EQU   CVTXTNT2+115
CVTRV475 EQU   CVTXTNT2+114
CVTRV474 EQU   CVTRV466
CVTRV473 EQU   CVTRV466
CVTRV472 EQU   CVTRV466
CVTRV471 EQU   CVTRV466
CVTRV470 EQU   CVTRV466
CVTRV469 EQU   CVTRV466
CVTRV468 EQU   CVTRV466
CVTRV467 EQU   CVTRV466
CVTRV465 EQU   CVTRV457
CVTRV464 EQU   CVTRV457
CVTRV463 EQU   CVTRV457
CVTRV462 EQU   CVTRV457
CVTRV461 EQU   CVTRV457
CVTRV460 EQU   CVTRV457
CVTRV459 EQU   CVTRV457
CVTRV458 EQU   CVTRV457
CVTRV456 EQU   CVTXTNT2+108
CVTRV455 EQU   CVTXTNT2+104
CVTRV454 EQU   CVTXTNT2+100
CVTRV453 EQU   CVTXTNT2+96
CVTRV452 EQU   CVTXTNT2+94
CVTRV451 EQU   CVTXTNT2+92
CVTRV450 EQU   CVTXTNT2+90
CVTRV449 EQU   CVTXTNT2+88
CVTRV448 EQU   CVTXTNT2+87
CVTRV447 EQU   CVTXTNT2+86
CVTRV446 EQU   CVTRV438
CVTRV445 EQU   CVTRV438
CVTRV444 EQU   CVTRV438
CVTRV443 EQU   CVTRV438
CVTRV442 EQU   CVTRV438
CVTRV441 EQU   CVTRV438
CVTRV440 EQU   CVTRV438
CVTRV439 EQU   CVTRV438
CVTRV437 EQU   CVTRV429
CVTRV436 EQU   CVTRV429
CVTRV435 EQU   CVTRV429
CVTRV434 EQU   CVTRV429
CVTRV433 EQU   CVTRV429
CVTRV432 EQU   CVTRV429
CVTRV431 EQU   CVTRV429
CVTRV430 EQU   CVTRV429
CVTRV428 EQU   CVTXTNT2+80
CVTRV427 EQU   CVTXTNT2+76
CVTRV426 EQU   CVTXTNT2+72
CVTRV425 EQU   CVTXTNT2+68
CVTATACT EQU   CVTATCVT
CVTRV423 EQU   CVTXTNT2+62
CVTRV422 EQU   CVTXTNT2+60
CVTRV421 EQU   CVTXTNT2+58
CVTRV420 EQU   CVTXTNT2+56
CVTRV419 EQU   CVTXTNT2+55
CVTRV418 EQU   CVTXTNT2+54
CVTRV417 EQU   CVTRV409
CVTRV416 EQU   CVTRV409
CVTRV415 EQU   CVTRV409
CVTRV414 EQU   CVTRV409
CVTRV413 EQU   CVTRV409
CVTRV412 EQU   CVTRV409
CVTRV411 EQU   CVTRV409
CVTRV410 EQU   CVTRV409
CVTRV408 EQU   CVTRV400
CVTRV407 EQU   CVTRV400
CVTRV406 EQU   CVTRV400
CVTRV405 EQU   CVTRV400
CVTRV404 EQU   CVTRV400
CVTRV403 EQU   CVTRV400
CVTRV402 EQU   CVTRV400
CVTRV401 EQU   CVTRV400
CVTICB   EQU   CVTXTNT2+48
CVTSKTA  EQU   CVTXTNT2+44
CVTCCVT  EQU   CVTXTNT2+40
CVTRSV98 EQU   CVTXTNT2+36
CVTRSV97 EQU   CVTXTNT2+34
CVTRSV96 EQU   CVTXTNT2+32
CVTOLTEP EQU   CVTXTNT2+28
CVTQIDA  EQU   CVTQID+1
CVTRSV95 EQU   CVTQID
CVTRSV94 EQU   CVTXTNT2+20
CVTRSV93 EQU   CVTXTNT2+16
CVTRSV92 EQU   CVTXTNT2+12
CVTDEBVR EQU   CVTXTNT2+8
CVTRSV91 EQU   CVTXTNT2+6
CVTRSV9H EQU   CVTFLGBT
CVTRSV9G EQU   CVTFLGBT
CVTRSV9F EQU   CVTFLGBT
CVTRSV9E EQU   CVTFLGBT
CVTRSV9D EQU   CVTFLGBT
CVTRSV9C EQU   CVTFLGBT
CVTVME   EQU   CVTFLGBT
CVTNPE   EQU   CVTFLGBT
CVTNUCLS EQU   CVTXTNT2+4
CVTDSSVA EQU   CVTDSSV+1
CVTRSV89 EQU   CVTDSSV
CVTRSV88 EQU   CVTXTNT1+8
CVTRSV87 EQU   CVTXTNT1+4
CVTFACHN EQU   CVTXTNT1
CVTRV488 EQU   CVTMAP+412
CVTRV487 EQU   CVTMAP+408
CVTRV486 EQU   CVTMAP+404
CVTRV485 EQU   CVTMAP+400
CVTACTAP EQU   CVTMAP+396
CVTAUTH  EQU   CVTMAP+392
CVTATMCA EQU   CVTATMCT+1
CVTATMST EQU   CVTATMCT
CVTRSV61 EQU   CVTMAP+384
CVTVOLT1 EQU   CVTVOLM1+1
CVTVOLI1 EQU   CVTVOLF1
CVTSTOA  EQU   CVTMAP+376
CVTRSV58 EQU   CVTMAP+374
CVTRSV57 EQU   CVTMAP+372
CVTDDCE  EQU   CVTMAP+368
CVTPNWFR EQU   CVTMAP+364
CVTSMF   EQU   CVTMAP+360
CVTSULK  EQU   CVTMAP+358
CVTSLKO  EQU   CVTSYSK
CVTSLKP  EQU   CVTSYSK
CVTSLKQ  EQU   CVTSYSK
CVTSLKR  EQU   CVTSYSK
CVTRSV56 EQU   CVTSYSK
CVTRSV55 EQU   CVTSYSK
CVTRSV54 EQU   CVTSYSK
CVTRSV53 EQU   CVTSYSK
CVTRSV52 EQU   CVTA1F1
CVTRSV51 EQU   CVTA1F1
CVTRSV50 EQU   CVTA1F1
CVTRSV49 EQU   CVTA1F1
CVTRSV48 EQU   CVTA1F1
CVTRSV47 EQU   CVTA1F1
CVTSRSW  EQU   CVTA1F1
CVTPFSW  EQU   CVTA1F1
CVTPCVT  EQU   CVTMAP+352
CVTRSV46 EQU   CVTMAP+344
CVTRSV45 EQU   CVTMAP+340
CVTRSV44 EQU   CVTMAP+338
CVTRSV43 EQU   CVTMAP+336
CVTHJESA EQU   CVTHJES+1
CVTRSV42 EQU   CVTHJES
CVTEXT2A EQU   CVTEXT2+1
CVTRSV41 EQU   CVTEXT2
CVTAPFA  EQU   CVTAPF+1
CVTRSV40 EQU   CVTAPF
CVTRV518 EQU   CVTINTLA
CVTRV517 EQU   CVTERPV
CVTEORM  EQU   CVTMAP+312
CVTMCHPR EQU   CVTMAP+308
CVTTZ    EQU   CVTMAP+304
CVTJEPS  EQU   CVTMAP+300
CVTJESCT EQU   CVTMAP+296
CVTMODE  EQU   CVTMAP+292
CVTPTRV  EQU   CVTMAP+288
CVTREAL  EQU   CVTMAP+284
CVTRSV39 EQU   CVTMAP+280
CVTRSV38 EQU   CVTMAP+276
CVTDMSRA EQU   CVTDMSR+1
CVTRV634 EQU   CVTDMSRF
CVTRV633 EQU   CVTDMSRF
CVTRV632 EQU   CVTDMSRF
CVTRV631 EQU   CVTDMSRF
CVTRV630 EQU   CVTDMSRF
CVTRV629 EQU   CVTDMSRF
CVTUDUMP EQU   CVTDMSRF
CVTSDUMP EQU   CVTDMSRF
CVTQMSGA EQU   CVTQMSG+1
CVTRSV36 EQU   CVTQMSG
CVTAMFF  EQU   CVTMAP+264
CVTPURGA EQU   CVTPURG+1
CVTRSV35 EQU   CVTPURG
CVTCBSP  EQU   CVTMAP+256
CVTATERA EQU   CVTATER+1
CVTSYST  EQU   CVTATER
CVTVOLT2 EQU   CVTTAT
CVTVOLI2 EQU   CVTVOLF2
CVTAQAVB EQU   CVTAQAVT+1
CVTRSV34 EQU   CVTTCMFG
CVTRSV33 EQU   CVTTCMFG
CVTRSV32 EQU   CVTTCMFG
CVTRSV31 EQU   CVTTCMFG
CVTRSV30 EQU   CVTTCMFG
CVTRSV29 EQU   CVTTCMFG
CVTLDEV  EQU   CVTTCMFG
CVTTCRDY EQU   CVTTCMFG
CVTGTFA  EQU   CVTGTF+1
CVTRSV27 EQU   CVTGTFST
CVTRNIO  EQU   CVTGTFST
CVTUSR   EQU   CVTGTFST
CVTRV318 EQU   CVTFORM
CVTRV317 EQU   CVTTMODE
CVTRV316 EQU   CVTSTATE
CVTRV315 EQU   CVTGTFS
CVTGTFAV EQU   CVTGTFS
CVT0SCR1 EQU   CVTMAP+232
CVTRV515 EQU   CVTMAP+228
CVTRMS   EQU   CVTMAP+224
CVTPATCH EQU   CVTMAP+220
CVTTSCE  EQU   CVTMAP+216
CVTLNKSC EQU   CVTMAP+214
CVTQABST EQU   CVTMAP+212
CVTMDLDS EQU   CVTMAP+208
CVTUSER  EQU   CVTMAP+204
CVTABEND EQU   CVTMAP+200
CVTSMCA  EQU   CVTMAP+196
CVTRSV18 EQU   CVTMAP+192
CVTQLPAQ EQU   CVTMAP+188
CVTQCDSR EQU   CVTMAP+184
CVTRSV17 EQU   CVTOPTB
CVTRSV16 EQU   CVTOPTB
CVTFP    EQU   CVTOPTB
CVTAPTHR EQU   CVTOPTB
CVTNLOG  EQU   CVTOPTB
CVTTOD   EQU   CVTOPTB
CVTCTIMS EQU   CVTOPTB
CVTPROT  EQU   CVTOPTB
CVTXPFP  EQU   CVTOPTA
CVTASCII EQU   CVTOPTA
CVTRSV13 EQU   CVTOPTA
CVTRSV12 EQU   CVTOPTA
CVTNIP   EQU   CVTOPTA
CVTDDR   EQU   CVTOPTA
CVTAPR   EQU   CVTOPTA
CVTCCH   EQU   CVTOPTA
CVTSNCTR EQU   CVTMAP+180
CVTQMWR  EQU   CVTMAP+176
CVTQOCR  EQU   CVTMAP+172
CVT1EF00 EQU   CVTMAP+168
CVTMZ00  EQU   CVTMAP+164
CVTSV76Q EQU   CVTSV76C
CVTRSV11 EQU   CVTMAP+156
CVT0PT01 EQU   CVTMAP+152
CVTMSER  EQU   CVTMAP+148
CVTRV516 EQU   CVTIERLC
CVTILCH  EQU   CVTMAP+140
CVT0DS   EQU   CVTMAP+136
CVTFBOSV EQU   CVTMAP+132
CVTNUCB  EQU   CVTMAP+128
CVTIXAVL EQU   CVTMAP+124
CVTSV76M EQU   CVTIOQET
CVTDCBA  EQU   CVTMAP+117
CVTMVS2  EQU   CVTDCB
CVT6DAT  EQU   CVTDCB
CVT4MPS  EQU   CVTDCB
CVTRSV09 EQU   CVTDCB
CVT4MS1  EQU   CVTDCB
CVT2SPS  EQU   CVTDCB
CVT1SSS  EQU   CVTDCB
CVTRSV08 EQU   CVTDCB
CVTSTB   EQU   CVTMAP+112
CVTQTD00 EQU   CVTMAP+108
CVTQTE00 EQU   CVTMAP+104
CVTCUCB  EQU   CVTMAP+100
CVTSJQ   EQU   CVTMAP+96
CVTPBLDL EQU   CVTMAP+92
CVTTPC   EQU   CVTMAP+88
CVTSVDCB EQU   CVTMAP+84
CVTBRET  EQU   CVTMAP+82
CVTEXIT  EQU   CVTMAP+80
CVT0FN00 EQU   CVTMAP+76
CVTDARA  EQU   CVTDAR+1
CVTRSV07 EQU   CVTFLGS1
CVTRSV06 EQU   CVTFLGS1
CVTRSV05 EQU   CVTFLGS1
CVTRSV04 EQU   CVTFLGS1
CVTRSV03 EQU   CVTFLGS1
CVTRSV02 EQU   CVTFLGS1
CVTRSV01 EQU   CVTFLGS1
CVTDMPLK EQU   CVTFLGS1
CVTXITP  EQU   CVTMAP+68
CVTZDTAB EQU   CVTMAP+64
CVTMSLT  EQU   CVTMAP+60
CVTDATE  EQU   CVTMAP+56
CVTBTERM EQU   CVTMAP+52
CVTSYSAD EQU   CVTMAP+48
CVTXTLER EQU   CVTMAP+44
CVTILK2  EQU   CVTMAP+40
CVTILK1  EQU   CVTMAP+36
CVTPRLTV EQU   CVTMAP+32
CVTPCNVT EQU   CVTMAP+28
CVT0VL00 EQU   CVTMAP+24
CVTXAPG  EQU   CVTMAP+20
CVTBUF   EQU   CVTMAP+16
CVTJOB   EQU   CVTMAP+12
CVTLINK  EQU   CVTMAP+8
CVT0EF00 EQU   CVTMAP+4
CVTTCBP  EQU   CVTMAP
CVT      EQU   CVTMAP
ASXBEND  EQU   ASXB+232
ASXBRV25 EQU   ASXB+228
ASXBRV24 EQU   ASXB+224
ASXBPT0E EQU   ASXB+220
ASXBCRB4 EQU   ASXBCASW+3
ASXBCRB3 EQU   ASXBCASW+2
ASXBCRB2 EQU   ASXBCASW+1
ASXBCR06 EQU   ASXBCRB1
ASXBCR05 EQU   ASXBCRB1
ASXBCR04 EQU   ASXBCRB1
ASXBCR03 EQU   ASXBCRB1
ASXBCR02 EQU   ASXBCRB1
ASXBCR01 EQU   ASXBCRB1
ASXBTFD  EQU   ASXBCRB1
ASXBPIP  EQU   ASXBCRB1
ASXBCTDC EQU   ASXB+212
ASXBTDCB EQU   ASXB+208
ASXBRV19 EQU   ASXB+204
ASXBSENV EQU   ASXBSECR+1
ASXBRV34 EQU   ASCBSFLG
ASXBRV33 EQU   ASCBSFLG
ASXBRV32 EQU   ASCBSFLG
ASXBRV31 EQU   ASCBSFLG
ASXBRV30 EQU   ASCBSFLG
ASXBRV29 EQU   ASCBSFLG
ASXBRV28 EQU   ASCBSFLG
ASXBRV27 EQU   ASCBSFLG
ASXBUSER EQU   ASXB+192
ASXBLSRB EQU   ASXBAEQ+20
ASXBFSRB EQU   ASXBAEQ+16
ASXBLRQE EQU   ASXBAEQ+12
ASXBFRQE EQU   ASXBAEQ+8
ASXBETSK EQU   ASXB+164
ASXBSIRB EQU   ASXB+160
ASXBPSWD EQU   ASXB+152
ASXBPRG  EQU   ASXB+136
ASXBRV26 EQU   ASXB+132
ASXBOUSB EQU   ASXB+128
ASXBDDR  EQU   ASXB+124
ASXBRCTD EQU   ASXB+120
ASXBRSMD EQU   ASXB+116
ASXBSPSA EQU   ASXB+112
ASXBFRWA EQU   ASXB+108
ASXBFLSA EQU   ASXB+36
ASXBIHSA EQU   ASXB+32
ASXBRV15 EQU   ASXB+28
ASXBRV14 EQU   ASXB+24
ASXBLWA  EQU   ASXB+20
ASXBMPST EQU   ASXB+16
ASXBRS00 EQU   ASXB+14
ASXBTCBS EQU   ASXB+12
ASXBLTCB EQU   ASXB+8
ASXBFTCB EQU   ASXB+4
ASXBASXB EQU   ASXB
ASXBEGIN EQU   ASXB
ASCBEND  EQU   ASCB+208
ASCBSRBT EQU   ASCB+200
ASCBSWTL EQU   ASCB+196
ASCBRS14 EQU   ASCB+195
ASCBSMCT EQU   ASCB+194
ASCBRS12 EQU   ASCB+192
ASCBPCTT EQU   ASCB+188
ASCBVGTT EQU   ASCB+184
ASCBRV43 EQU   ASCBSRQ4
ASCBRV42 EQU   ASCBSRQ4
ASCBRV41 EQU   ASCBSRQ4
ASCBRV40 EQU   ASCBSRQ4
ASCBRV39 EQU   ASCBSRQ4
ASCBRV38 EQU   ASCBSRQ4
ASCBRV37 EQU   ASCBSRQ4
ASCBRV36 EQU   ASCBSRQ4
ASCBRV35 EQU   ASCBSRQ3
ASCBRV34 EQU   ASCBSRQ3
ASCBRV33 EQU   ASCBSRQ3
ASCBRV32 EQU   ASCBSRQ3
ASCBRV31 EQU   ASCBSRQ3
ASCBRV30 EQU   ASCBSRQ3
ASCBRV29 EQU   ASCBSRQ3
ASCBRV28 EQU   ASCBSRQ3
ASCBRV27 EQU   ASCBSRQ2
ASCBRV26 EQU   ASCBSRQ2
ASCBRV25 EQU   ASCBSRQ2
ASCBRV24 EQU   ASCBSRQ2
ASCBRV23 EQU   ASCBSRQ2
ASCBRV22 EQU   ASCBSRQ2
ASCBRV21 EQU   ASCBSRQ2
ASCBRV20 EQU   ASCBSRQ2
ASCBRV19 EQU   ASCBSRQ1
ASCBRV18 EQU   ASCBSRQ1
ASCBRV17 EQU   ASCBSRQ1
ASCBRV16 EQU   ASCBSRQ1
ASCBRV15 EQU   ASCBSRQ1
ASCBRV14 EQU   ASCBSRQ1
ASCBRV13 EQU   ASCBSRQ1
ASCBSTA  EQU   ASCBSRQ1
ASCBJBNS EQU   ASCB+176
ASCBJBNI EQU   ASCB+172
ASCBMCC  EQU   ASCB+168
ASCBRTWA EQU   ASCB+164
ASCBIQEA EQU   ASCB+160
ASCBXMPQ EQU   ASCB+156
ASCBRS01 EQU   ASCB+154
ASCBFMCT EQU   ASCB+152
ASCBOUXB EQU   ASCB+148
ASCBOUCB EQU   ASCB+144
ASCBMECB EQU   ASCB+140
ASCBQECB EQU   ASCB+136
ASCBLSQH EQU   ASCBLKGP+4
ASCBLOCK EQU   ASCBLKGP
ASCBTCBS EQU   ASCB+124
ASCBNVSC EQU   ASCB+122
ASCBVSC  EQU   ASCB+120
ASCBSRBS EQU   ASCB+118
ASCBSSRB EQU   ASCB+116
ASCBRV06 EQU   ASCBFLG2
ASCBRV05 EQU   ASCBFLG2
ASCBRV04 EQU   ASCBFLG2
ASCBSNQS EQU   ASCBFLG2
ASCBS2S  EQU   ASCBFLG2
ASCBCEXT EQU   ASCBFLG2
ASCBPXMT EQU   ASCBFLG2
ASCBXMPT EQU   ASCBFLG2
ASCBRF07 EQU   ASCBDSP1
ASCBRF06 EQU   ASCBDSP1
ASCBRF05 EQU   ASCBDSP1
ASCBRF04 EQU   ASCBDSP1
ASCBRF03 EQU   ASCBDSP1
ASCBRF02 EQU   ASCBDSP1
ASCBFAIL EQU   ASCBDSP1
ASCBNOQ  EQU   ASCBDSP1
ASCBSWCT EQU   ASCB+112
ASCBTMCH EQU   ASCB+104
ASCBNSWP EQU   ASCBFLG1
ASCBTYP1 EQU   ASCBFLG1
ASCBSTND EQU   ASCBFLG1
ASCBABNT EQU   ASCBFLG1
ASCBTERM EQU   ASCBFLG1
ASCBS3S  EQU   ASCBFLG1
ASCBCMSH EQU   ASCBFLG1
ASCBTOFF EQU   ASCBFLG1
ASCBRF01 EQU   ASCBRCTF
ASCBTMLW EQU   ASCBRCTF
ASCBOUT  EQU   ASCBRCTF
ASCBWAIT EQU   ASCBRCTF
ASCBRV08 EQU   ASCBRCTF
ASCBFQU  EQU   ASCBRCTF
ASCBFRS  EQU   ASCBRCTF
ASCBTMNO EQU   ASCBRCTF
ASCBAFFN EQU   ASCBFW1
ASCBDUMP EQU   ASCB+96
ASCBRV44 EQU   ASCB+92
ASCBUBET EQU   ASCB+88
ASCBECB  EQU   ASCB+84
ASCBJSTL EQU   ASCB+80
ASCBEWST EQU   ASCB+72
ASCBEJST EQU   ASCB+64
ASCBTSB  EQU   ASCB+60
ASCBCSCB EQU   ASCB+56
ASCBRSMA EQU   ASCBRSM+1
ASCBRV54 EQU   ASCBRSMF
ASCBRV53 EQU   ASCBRSMF
ASCBRV52 EQU   ASCBRSMF
ASCBRV51 EQU   ASCBRSMF
ASCBVEQR EQU   ASCBRSMF
ASCBN2LP EQU   ASCBRSMF
ASCB1LPU EQU   ASCBRSMF
ASCB2LPU EQU   ASCBRSMF
ASCBLDA  EQU   ASCB+48
ASCBSTOR EQU   ASCB+44
ASCBDP   EQU   ASCB+43
ASCBRV07 EQU   ASCB+42
ASCBIOSM EQU   ASCB+40
ASCBSEQN EQU   ASCB+38
ASCBCPUS EQU   ASCB+32
ASCBSPL  EQU   ASCB+28
ASCBIOSP EQU   ASCB+24
ASCBSYNC EQU   ASCBSUPC+4
ASCBSVRB EQU   ASCBSUPC
ASCBCMSF EQU   ASCB+12
ASCBBWDP EQU   ASCB+8
ASCBFWDP EQU   ASCB+4
ASCBASCB EQU   ASCB
ASCBEGIN EQU   ASCB
AMBTRACE EQU   IDAAMB+120
AMBVIOT  EQU   IDAAMB+116
AMBSZCP  EQU   IDAAMB+114
AMBSZFW  EQU   IDAAMB+112
AMBSZWR  EQU   IDAAMB+110
AMBSZRD  EQU   IDAAMB+108
AMBEXEX  EQU   IDAAMB+100
AMBWSHD  EQU   IDAAMB+96
AMBCPA   EQU   IDAAMB+92
AMBBM2SH EQU   IDAAMB+88
AMBRDCNT EQU   AMBCSWD1+2
@NM00014 EQU   AMBCSWD1+1
@NM00013 EQU   AMBAFLG
AMBCFX   EQU   AMBAFLG
AMBSIS   EQU   AMBAFLG
AMBDFR   EQU   AMBAFLG
AMBICI   EQU   AMBAFLG
AMBGSR   EQU   AMBAFLG
AMBLSR   EQU   AMBAFLG
@NM00012 EQU   AMBAFLG
AMBUPLH  EQU   IDAAMB+80
AMBPAMBL EQU   IDAAMB+76
AMBPIXP  EQU   IDAAMB+72
@NM00011 EQU   IDAAMB+68
AMBIWA   EQU   IDAAMB+64
AMBWKA   EQU   IDAAMB+60
AMBAMBXN EQU   AMBEOVPT
AMBEDB   EQU   IDAAMB+52
AMBRPT   EQU   IDAAMB+50
AMBPUG   EQU   AMBFLG2
AMBBUSY  EQU   AMBOFLGS
AMBEXFG  EQU   AMBOFLGS
@NM00010 EQU   AMBOFLGS
AMBOPEN  EQU   AMBOFLGS
@NM00009 EQU   AMBOFLGS
AMBIFLGS EQU   AMBDEBPT
AMBAMETH EQU   IDAAMB+43
AMBSDS   EQU   AMBINFL
AMBUPX   EQU   AMBINFL
AMBUCRA  EQU   AMBINFL
AMBSCRA  EQU   AMBINFL
AMBCAT   EQU   AMBINFL
@NM00008 EQU   AMBINFL
@NM00007 EQU   AMBINFL
AMBTIOT  EQU   IDAAMB+40
@NM00006 EQU   IDAAMB+38
AMBDDSN  EQU   IDAAMB+35
AMBCDSN  EQU   IDAAMB+32
AMBIOMB  EQU   AMBIOBAD
@NM00005 EQU   AMBDSORG+1
AMBDORGA EQU   AMBDSORG+1
@NM00004 EQU   AMBDSORG
AMBINBUF EQU   AMBFLG1
AMBJRN   EQU   AMBFLG1
AMBUBF   EQU   AMBFLG1
AMBSPEED EQU   AMBFLG1
AMBPCAT  EQU   AMBFLG1
AMBMCAT  EQU   AMBFLG1
AMBTYPE  EQU   AMBFLG1
AMBCREAT EQU   AMBFLG1
@NM00003 EQU   AMBFLG0
AMBSWSP  EQU   AMBFLG0
AMBPSDS  EQU   AMBFLG0
AMBDSB   EQU   IDAAMB+20
AMBCACB  EQU   IDAAMB+16
AMBPH    EQU   IDAAMB+12
AMBBUFC  EQU   IDAAMB+8
AMBLINK  EQU   IDAAMB+4
AMBLEN   EQU   IDAAMB+2
AMBRSC   EQU   IDAAMB+1
AMBID    EQU   IDAAMB
@NM00002 EQU   @NM00001
@NM00060 EQU   PSA+3668
PSASTAK  EQU   PSA+3072
@NM00059 EQU   PSA+1048
PSAUSEND EQU   PSA+1048
PSARV062 EQU   PSA+1044
PSACDAL  EQU   PSA+1040
PSAWTCOD EQU   PSA+1036
PSAATCVT EQU   PSA+1032
PSAPCPSW EQU   PSA+1024
PSAPIR2  EQU   PSA+1020
PSARV059 EQU   PSA+1018
PSASVC13 EQU   PSA+1016
PSALSFCC EQU   PSA+1012
PSASFACC EQU   PSA+1008
PSASTOP  EQU   PSA+992
PSASTART EQU   PSA+976
PSARSPSW EQU   PSA+968
PSASRPSW EQU   PSA+960
PSARV045 EQU   PSA+892
PSARV044 EQU   PSA+888
PSARV043 EQU   PSA+884
PSARV042 EQU   PSA+880
PSARV041 EQU   PSA+876
PSARV040 EQU   PSA+872
PSARV025 EQU   PSA+868
PSADSSED EQU   PSA+868
PSADSSPR EQU   PSA+864
PSADSSFW EQU   PSA+860
PSADSS14 EQU   PSA+856
PSADSSPP EQU   PSA+848
PSADSSRP EQU   PSA+840
PSADSS05 EQU   PSADSSF4
PSADSS10 EQU   PSADSSF4
PSADSSVE EQU   PSADSSF4
PSADSSDE EQU   PSADSSF4
PSADSSC0 EQU   PSADSSF4
PSADSSIE EQU   PSADSSF4
PSADSS12 EQU   PSADSSF4
PSADSSRC EQU   PSADSSF4
PSARV057 EQU   PSADSSF3
PSARV056 EQU   PSADSSF3
PSARV055 EQU   PSADSSF3
PSADSSMC EQU   PSADSSF3
PSADSSRW EQU   PSADSSF3
PSADSSNM EQU   PSADSSF3
PSADSSES EQU   PSADSSF3
PSADSSGP EQU   PSADSSF3
PSADSSF2 EQU   PSADSSFL+1
PSADSSPI EQU   PSADSSF1
PSADSSOI EQU   PSADSSF1
PSADSSSP EQU   PSADSSF1
PSADSSTP EQU   PSADSSF1
PSADSSDW EQU   PSADSSF1
PSADSSDD EQU   PSADSSF1
PSADSSDM EQU   PSADSSF1
PSADSSMV EQU   PSADSSF1
PSADSSTS EQU   PSA+816
PSADSSWK EQU   PSA+812
PSADSSR3 EQU   PSA+808
PSADSSR2 EQU   PSA+804
PSADSSRS EQU   PSA+800
PSASTOR  EQU   PSA+796
PSACPUSA EQU   PSA+794
PSAVSTAP EQU   PSA+792
PSAWKVAP EQU   PSA+788
PSAWKRAP EQU   PSA+784
PSAMCHIC EQU   PSA+783
PSARV061 EQU   PSA+782
PSASYMSK EQU   PSA+781
PSAMCHFL EQU   PSA+780
PSACR0   EQU   PSA+776
PSAPSWSV EQU   PSA+768
PSACLHS  EQU   PSAHLHI
PSALKR15 EQU   PSALKSA+60
PSALKR14 EQU   PSALKSA+56
PSALKR13 EQU   PSALKSA+52
PSALKR12 EQU   PSALKSA+48
PSALKR11 EQU   PSALKSA+44
PSALKR10 EQU   PSALKSA+40
PSALKR9  EQU   PSALKSA+36
PSALKR8  EQU   PSALKSA+32
PSALKR7  EQU   PSALKSA+28
PSALKR6  EQU   PSALKSA+24
PSALKR5  EQU   PSALKSA+20
PSALKR4  EQU   PSALKSA+16
PSALKR3  EQU   PSALKSA+12
PSALKR2  EQU   PSALKSA+8
PSALKR1  EQU   PSALKSA+4
PSALKR0  EQU   PSALKSA
PSARV023 EQU   PSACLHT+52
PSALOCAL EQU   PSACLHT+48
PSACMSL  EQU   PSACLHT+44
PSAOPTL  EQU   PSACLHT+40
PSATPACL EQU   PSACLHT+36
PSATPDNL EQU   PSACLHT+32
PSATPNCL EQU   PSACLHT+28
PSAIOSLL EQU   PSACLHT+24
PSAIOSUL EQU   PSACLHT+20
PSAIOSCL EQU   PSACLHT+16
PSAIOSSL EQU   PSACLHT+12
PSASALCL EQU   PSACLHT+8
PSAASML  EQU   PSACLHT+4
PSADISPL EQU   PSACLHT
PSASRSA  EQU   PSA+636
PSARV050 EQU   PSA+634
PSADSSGO EQU   PSA+633
PSARECUR EQU   PSA+632
PSAHLHIS EQU   PSA+628
PSAIPCSA EQU   PSA+624
@NM00058 EQU   PSA+621
PSAIPCDM EQU   PSA+620
PSAIPCD  EQU   PSA+616
@NM00057 EQU   PSA+613
PSAIPCRM EQU   PSA+612
PSAIPCR  EQU   PSA+608
PSAMCHEX EQU   PSA+600
PSAMPSW  EQU   PSA+592
PSAEXPS2 EQU   PSA+584
PSAEXPS1 EQU   PSA+576
PSAPIREG EQU   PSA+572
PSARSREG EQU   PSA+568
PSAGPREG EQU   PSA+556
PSARV022 EQU   PSASUP4
PSARV021 EQU   PSASUP4
PSARV020 EQU   PSASUP4
PSARV019 EQU   PSASUP4
PSARV018 EQU   PSASUP4
PSARV017 EQU   PSASUP4
PSARV016 EQU   PSASUP4
PSARV015 EQU   PSASUP4
PSARV014 EQU   PSASUP3
PSAULCMS EQU   PSASUP3
PSARV012 EQU   PSASUP3
PSAESTA  EQU   PSASUP3
PSASPR   EQU   PSASUP3
PSAPSREG EQU   PSASUP3
PSAPI2   EQU   PSASUP3
PSAIOSUP EQU   PSASUP3
PSALCR   EQU   PSASUP2
PSARTM   EQU   PSASUP2
PSAACR   EQU   PSASUP2
PSAIPCE2 EQU   PSASUP2
PSAIPCES EQU   PSASUP2
PSAIPCEC EQU   PSASUP2
PSAGTF   EQU   PSASUP2
PSAIPCRI EQU   PSASUP2
PSATYPE6 EQU   PSASUP1
PSATCTL  EQU   PSASUP1
PSADISP  EQU   PSASUP1
PSALOCK  EQU   PSASUP1
PSAPI    EQU   PSASUP1
PSAEXT   EQU   PSASUP1
PSASVC   EQU   PSASUP1
PSAIO    EQU   PSASUP1
PSAANEW  EQU   PSA+544
PSATOLD  EQU   PSA+540
PSATNEW  EQU   PSA+536
PSALCCAR EQU   PSA+532
PSALCCAV EQU   PSA+528
PSAPCCAR EQU   PSA+524
PSAPCCAV EQU   PSA+520
PSACPULA EQU   PSA+518
PSACPUPA EQU   PSA+516
PSAPSA   EQU   PSA+512
FLCHDEND EQU   PSA+512
FLCCRSAV EQU   FLCMCLA+280
FLCGRSAV EQU   FLCMCLA+216
FLCFPSAV EQU   FLCMCLA+184
FLCFLA   EQU   FLCMCLA+88
FLCRGNCD EQU   FLCMCLA+84
FLCFSAA  EQU   FLCFSA+1
@NM00056 EQU   FLCFSA
@NM00055 EQU   FLCMCLA+72
FLCMCIC  EQU   FLCMCLA+64
@NM00054 EQU   FLCMCLA+20
FLCIOAA  EQU   FLCIOA+1
@NM00053 EQU   FLCIOA
@NM00052 EQU   FLCMCLA+15
@NM00051 EQU   FLCMCLA+14
@NM00050 EQU   FLCMCLA+12
FLCLCL   EQU   FLCMCLA+8
FLCIOELA EQU   FLCIOEL+1
@NM00049 EQU   FLCIOEL
FLCCHNID EQU   FLCMCLA
@NM00048 EQU   PSA+160
FLCMTRCD EQU   PSA+157
@NM00047 EQU   PSA+156
FLCPERA  EQU   FLCPER+1
@NM00046 EQU   FLCPER
@NM00045 EQU   PSA+151
FLCPERCD EQU   PSA+150
FLCMCNUM EQU   PSA+149
@NM00044 EQU   PSA+148
FLCTEAA  EQU   FLCTEA+1
@NM00043 EQU   FLCTEA
PSAPIPC  EQU   PSAPICOD
PSAPIMC  EQU   PSAPICOD
PSAPIPER EQU   PSAPICOD
PSARV049 EQU   FLCPICOD
FLCPILCB EQU   FLCPIILC
@NM00042 EQU   FLCPIILC
@NM00041 EQU   PSAEPPSW
FLCSVCN  EQU   PSAESPSW+2
FLCSILCB EQU   FLCSVILC
@NM00040 EQU   FLCSVILC
@NM00039 EQU   PSAESPSW
FLCEICOD EQU   PSAEEPSW+2
PSASPAD  EQU   PSAEEPSW
@NM00038 EQU   PSA+128
FLCINPSW EQU   PSA+120
FLCMNPSW EQU   PSA+112
FLCPNPSW EQU   PSA+104
FLCSNPSW EQU   PSA+96
FLCENPSW EQU   PSA+88
FLCTRACE EQU   PSA+84
FLCTIMER EQU   PSA+80
FLCCVT2  EQU   PSA+76
FLCCAW   EQU   PSA+72
FLCCSW   EQU   PSA+64
FLCIOPSW EQU   PSA+56
FLCMOPSW EQU   PSA+48
FLCPOPSW EQU   PSA+40
FLCSOPSW EQU   PSA+32
FLCEOPSW EQU   PSA+24
@NM00037 EQU   FLCICCW2+4
FLCICCW1 EQU   FLCROPSW
FLCIPPSW EQU   FLCRNPSW
.@UNREFD ANOP                          END UNREFERENCED COMPONENTS
@RT00132 EQU   FREELOCK
@RT00165 EQU   RECHAIN
@RF00165 EQU   NXTIQE
@RT00168 EQU   RECHAIN
@RF00168 EQU   NXTIQE
@RF00163 EQU   NXTIQE
@RT00192 EQU   SETPURGE
@RT00195 EQU   SETPURGE
@RF00195 EQU   NEXTIQE
@RT00198 EQU   SETPURGE
@RF00198 EQU   NEXTIQE
@RF00191 EQU   NEXTIQE
@ENDDATA EQU   *
         END   IDA121A6,(C'PLS0047',0701,78180)
