IDA121CV CSECT
      TITLE 'IDA121CV-IEZABP CSECT'
*
*     START OF SPECIFICATIONS *****
*
*01*  MODULE-NAME = IDA121CV
*
*01*  DESCRIPTIVE-NAME = IEZABP CSECT
*
*01*  COPYRIGHT = NONE
*
*01*  STATUS = NONE
*
*01*  CHANGE ACTIVITY = NONE
*
*02*    A = NONE
*02*    D = NONE
*02*    C = NONE
*
*01*  FUNCTION = THIS IS A CSECT FOR IEZABP AND CONTAINS THE ADDRESS
*     VECTORS FOR THE I/O MANAGEMENT ROUTINES WHICH RESIDE IN
*     THE NUCLEUS AND WHOSE ADDRESS IS REQUIRED BY OTHER ROUTINES.
*
*01*  NOTES = NONE
*
*01*  MODULE-TYPE = REGULAR
*
*02*    PROCESSOR = PLS2
*
*02*    MODULE-SIZE = 20
*
*02*    ATTRIBUTES = NO EXECUTABLE CODE
*
*01*  ENTRY = IDA121CV
*
*02*    PURPOSE = DEFINED ABOVE
*
*02*    LINKAGE = POINTER IN CVTIOBP
*
*02*    INPUT = NONE
*
*02*    OUTPUT = ADDRESSES OF SUPERVISOR STATE I/O DRIVER,
*               ACTUAL BLOCK PROCESSOR, NORMAL END APPENDAGE,
*               AND ABNORMAL END APPENDAGE ARE PUT INTO
*               IEZABP MACRO TOGETHER WITH A BR 14 INSTRUCTION.
*
*02*    EXIT-NORMAL = NO EXECUTABLE CODE
*
*02*    EXIT-ERROR = NONE
*
*01*  EXTERNAL-REFERENCES = IGC121   (SIOD)
*                           IDA121A2 (ABP)
*                           IDA121A3 (NE)
*                           IDA121A4 (AE)
*
*01*  TABLES = NONE
*
*01*  MACROS = NONE
*
***** END OF SPECIFICATIONS *****/
*/********************************************************************/
*/*                                                                  */
*/*                      DECLARATIONS                                */
*/*                                                                  */
*/********************************************************************/
*/*                                                                  */
ABPID    DC    CL1'A'
ABPLEN   DC    AL1(20)
ABPBR14  DC    X'07FE'
ABPSIOD  DC    VL4(IGC121)
ABPABP   DC    VL4(IDA121A2)
ABPNE    DC    VL4(IDA121A3)
ABPAE    DC    VL4(IDA121A4)
         END   IDA121CV
