*/********************************************************************/
*/*                                                                  */
*/*   MACRO NAME = IDAAMBXN                                          */
*/*                                                                  */
*/*   DESCRIPTIVE NAME = VSAM AMB EXTENSION - IOMB EXTENSION         */
*/*                                                                  */
*/*   FUNCTION =  TO PROVIDE ADDITIONAL FIELDS FOR MVM               */
*/*                                                                  */
*/*   INCLUDED MACROS = NONE                                         */
*/*                                                                  */
*/*   METHOD OF ACCESS = PL/S - NO DECLARES NECESSARY                */
*/*                                                                  */
*/*   CREATED BY = VSAM OPEN                                         */
*/*                                                                  */
*/*   STATUS = VS/2 RELEASE 3    (CHANGE FLAG @Y30SDXX)              */
*/*            VS/2 RELEASE 4.1  (CHANGE FLAG @Z40GSDT)              */
*/*                                                                  */
*/*   DATE OF LAST CHANGE = 15 AUGUST 75                             */
*/*                         11 APR  77                       @ZA14809*/
*/*                          9 MAY  77                       @ZA14824*/
*/*                                                                  */
*/********************************************************************/
* /*                                                                 */
* /*    MACCOMP                         Y-2 SC1DE/SJD61              */
* /*    MACSTAT                         Y-2 73191/Y02113             */
* /*                                                                 */
*/********************************************************************/
*/* VSAM IDAAMB EXTENSION                                            */
*/********************************************************************/
        DCL 1 IDAAMBXN BASED(AMBEOVPT), /*AMB EXTENSION BLK  @X30SDLC*/
                2 AMBXEOV   BDY(WORD),  /* EOV INTERFACE FIELD.Y02113*/
                  3 AMBXEVPT PTR(31),   /* EOV DATA PTR              */
                  3 AMBXRSC  BIT(8),    /* RESOURCE T&S BYTE         */
                  3 AMBXEOVR CHAR(1),   /* EOV REQUEST TYPE          */
                  3 AMBXEVRC PTR(8),    /* AMEOV RETURN CODE @OZ04909*/
                  3 *        BIT(8),    /* UNUSED            @OZ04909*/
                2 AMBXASCB   PTR(31),   /* EOV CALLER ASCB   @OZ04909*/
                2 AMBXECB    FIXED(31), /* ECB FOR AMEOV     @OZ04909*/
                2 AMBXCSWD PTR(31)BDY(WORD),/* BFR MGR CS WD @Y30SDLC*/
                  3 * FIXED(15),    /* UNUSED                @Y30SDLC*/
                  3 AMBXRDCT FIXED(15),/* NBR CI READ        @Y30SDLC*/
                2 AMBXBM2S PTR(31); /* ADDR OF PLH DOING 2ND SEARCH
                                       OF SUBPOOL            @Y30SDLC*/
*/********************************************************************/
*/* VSAM IDAIOMB EXTENSION                                           */
*/********************************************************************/
         DCL 1 IDAIOMBX BASED BDY(WORD),/* MVM IOMB EXT      @X30SDLC*/
                2 IOMXLOCK CHAR(1),     /* RESOURCE T&S BYTE         */
                2 IOMXFLGS BIT(8),      /* I/O MGR FLAGS       */
                  3 IOMXUSE BIT(1),     /* REDUNDANT BIT     @Y30SSMR*/
                  3 IOMXEOVW BIT(1),    /* EOV WAIT FOR ASYN @ZA02269*/
                  3 IOMXSCAN BIT(1),    /* SCANBUFF BIT      @ZA14824*/
                  3 * BIT(5),           /* RESERVED          @ZA02269*/
                2 * CHAR(2),            /* RESERVED          @Z40GSDT*/
                2 IOMXPDET,         /* PD FIELDS             @X30SDLC*/
                  3 IOMXBFLG FIXED(16), /* I/O FLAGS AT I/O INITIATION*/
                  3 * CHAR(2),          /* RESERVED          @Z40GSDT*/
                  3 IOMXR13S PTR(31),   /* USER SAVE AREA PTR*/
                  3 IOMXRPL PTR(31),    /*PTR TO HEAD RPL*/
                2 IOMXR14 PTR(31),      /*ASYNC REG 14 SAVE  @ZA14809*/
                2 IOMXRECB CHAR(4) BDY(WORD), /*RECORD MGT I/O ECB */
                  3 IOMXECB PTR(31),    /* I/O ECB*/
                    4 IOMXWAIT BIT(1),  /* I/O WAIT BIT*/
                    4 IOMXRSLT BIT(7),  /* I/O COMPLETION RESULT*/
                      5 IOMXPOST BIT(1),/* I/O POST BIT*/
                      5 IOMXIOCC BIT(6),/* I/O COMPLETION CODE*/
                    4 IOMXRBPT PTR(24); /* PTR TO RB OR RESULT*/
