*/********************************************************************/
*/*                                                                  */
*/*   MACRO NAME = IDAAMDSB                                          */
*/*                                                                  */
*/*   DESCRIPTIVE NAME =DATA SET CHARACTERISTICS                     */
*/*              AND STATISTICS BLOCK                                */
*/*                                                                  */
*/*   FUNCTION = CONTAINS DATA SET CHARACTERISTICS AND STATISTICS    */
*/*                                                                  */
*/*   CONTROL BLOCK STRUCTURE = THE IDAAMDSB IS POINTED TO BY IDAAMB */
*/*                                                                  */
*/*   INCLUDED MACROS = NONE                                         */
*/*                                                                  */
*/*   METHOD OF ACCESS = PL/S - NO DECLARES NECESSARY                */
*/*                                                                  */
*/*   CREATED BY = VSAM OPEN                                         */
*/*                                                                  */
*/*   STATUS = VS/1 RELEASE 4  (CHANGE FLAG @X04SVXX)                */
*/*                                                                  */
*/*   DATE OF LAST CHANGE = 8 AUG 74                                 */
*/*                                                                  */
*/********************************************************************/
*        DCL 1 IDAAMDSB BASED,/* DATA SET CHAR./STATISTICS BLOCK     */
*              2 AMDSBID      CHAR(1),  /* CONTROL BLOCK ID          */
*              2 AMDATTR      CHAR(1),  /* ATTRIBUTES                */
*                3 AMDDST     BIT(1),   /* KEY, CHRONOLOGIC          */
*                3 AMDWCK     BIT(1),   /* WRITE CHECK               */
*                3 AMDSDT     BIT(1),   /* SEQ SET WITH DATA         */
*                3 AMDREPL BIT(1),      /* REPLICATION               */
*                3 AMDORDER   BIT(1),   /* USE VOLS IN LIST ORDER    */
*                3 AMDRANGE   BIT(1),   /* KEY RANGE DATA SET        */
*                3 AMDRRDS    BIT(1),   /* RELATIVE RECORD DATA SET
*                                                            @X04SVLC*/
*                3 AMDSPAN    BIT(1),   /* SPANNED RECORDS ARE ALLOWED
*                                                            @X04SVLC*/
*              2 AMDLEN FIXED(15),      /* LENGTH OF AMDSB           */
*              2 AMDNEST      FIXED(15),/* NO OF ENTRIES IN IDX SECTN*/
*                3 AMDAXRKP   FIXED(15),/* RELATIVE KEY POSITION OF
*                                            ALTERNATE KEY   @X04SVLC*/
*              2 AMDRKP       FIXED(15),/* RELATIVE KEY POSITION     */
*              2 AMDKEYLN     FIXED(15),/* KEY LENGTH                */
*              2 AMDPCTCA PTR(8),       /* % FREE CI IN CA           */
*              2 AMDPCTCI PTR(8),       /* % FREE BYTES IN CI        */
*              2 AMDCIPCA FIXED(15),    /* TOTAL NO. OF CIS PER CA   */
*              2 AMDFSCA      FIXED(15),/* NO OF FREE CIS PER CA     */
*              2 AMDFSCI      FIXED(31),/* NO OF FREE BYTES PER CI   */
*              2 AMDCINV      FIXED(31),/* CONTROL INTERVAL SIZE     */
*              2 AMDLRECL     FIXED(31),/* MAXIMUM RECORD SIZE       */
*              2 AMDHLRBA     FIXED(32),/* RBA OF HIGH LEVEL IDX REC */
*                3 AMDNSLOT   FIXED(31),/* NO. OF RECORD SLOTS PER CI
*                                                            @X04SVLC*/
*              2 AMDSSRBA     FIXED(32),/* RBA OF FIRST SEQ SET REC  */
*                3 AMDMAXRR   FIXED(31),/* MAX RELATIVE RECORD NUMBER
*                                                            @X04SVLC*/
*              2 AMDPARDB     PTR(31),  /* PTR TO FIRST ARDB         */
*              2 AMDATTR3   BIT(8),     /* ATTRIBUTES        @X04SVLC*/
*                3 AMDUNQ     BIT(1),  /* ON=NON-UNIQUE KEYS @X04SVLC
*                                         OFF=UNIQUE KEYS    @X04SVLC*/
*                3 AMDFAULT   BIT(1),  /* ON=CYLINDER FAULT ON SS1
*                                         OFF=STAGE THE DATA SET
*                                         (DEFAULT)          @X04SVLC*/
*                3 AMDBIND    BIT(1),  /* ON=BIND THE DATA SET ON SS1
*                                         OFF=DO NOT BIND (DEFAULT)
*                                                            @X04SVLC*/
*                3 AMDWAIT    BIT(1),  /* ON=WAIT ON A RELINQUISH
*                                         OFF=DO NOT WAIT (DEFAULT)
*                                                            @X04SVLC*/
*                3 AMDLM      BIT(1),   /* ON=DATA SET LOADED
*                                          OFF=LOAD MODE OR NOT LOADED
*                                                            @X04SVLC*/
*                3 *          BIT(3),   /* UNUSED            @X04SVLC*/
*              2 *          CHAR(7),    /* UNUSED            @X04SVLC*/
*              2 AMDSTAT      BDY(WORD),/* STATISTICS        @X04SVLC*/
*                3 AMDSTSP    CHAR(8),  /*    SYSTEM TIME STAMP      */
*                3 AMDNIL     FIXED(15),/* NUMBER INDEX LEVELS       */
*                3 AMDNEXT    FIXED(15),/* NUMBER OF EXTENTS         */
*                3 AMDNLR     FIXED(31),/* NUMBER LOGICAL RECORDS    */
*                3 AMDDELR    FIXED(31),/* NUMBER DELETED RECORDS    */
*                3 AMDIREC    FIXED(31),/* NUMBER INSERTED RECORDS   */
*                3 AMDUPR     FIXED(31),/* NUMBER UPDATED RECORDS    */
*                3 AMDRETR    FIXED(31),/* NUMBER RETRIEVED RECORDS  */
*                3 AMDASPA    FIXED(31),/* BYTES OF FREE SPACE IN DS */
*                3 AMDNCIS    FIXED(31),/* NUMBER OF CI SPLITS       */
*                3 AMDNCAS    FIXED(31),/* NUMBER OF CA SPLITS       */
*                3 AMDEXCP    FIXED(31);/* NUMBER OF EXCPS           */
*
*
*
*%  DCL  (AMDKSDS,AMDCSDS) CHAR;
*%       AMDKSDS = '''1''B';            /* KEY SEQUENTIAL DATA SET   */
*%       AMDCSDS = '''0''B';            /* CHRONOLOGIC SEQ DATA SET  */
*%       AMDSBLEN = 'LENGTH(IDAAMDSB)'; /* LENGTH OF AMDSB           */
