*/********************************************************************/
*/*                                                                  */
*/*   MACRO NAME = IDAARDB                                           */
*/*                                                                  */
*/*   DESCRIPTIVE NAME =ADDRESS RANGE DEFINITION BLOCK               */
*/*                                                                  */
*/*   FUNCTION = TO DEFINE THE HIGH AND LOW KEYS OF A KEY RANGE.     */
*/*              IT DESCRIBES THE KEY RANGE, ITS LOCATION AND RBA    */
*/*              EXTENTS.                                            */
*/*                                                                  */
*/*   CONTROL BLOCK STRUCTURE = THE QUEUE OF IDAARDBS ORIGINATES     */
*/*              IN THE IDAAMDSB                                     */
*/*                                                                  */
*/*   INCLUDED MACROS = NONE                                         */
*/*                                                                  */
*/*   METHOD OF ACCESS = PL/S - NO DECLARES NECESSARY                */
*/*                                                                  */
*/*   CREATED BY = VSAM OPEN                                         */
*/*                                                                  */
*/*   STATUS = VS/1 RELEASE 4  (CHANGE FLAG @X04SVXX)                */
*/*                                                                  */
*/*   DATE OF LAST CHANGE = 8 AUG 74                                 */
*/*                                                                  */
*/********************************************************************/
*        DCL 1 IDAARDB BASED, /* ADDRESS RANGE DEFINITION BLOCK      */
*              2 ARDID        CHAR(1),  /* CONTROL BLOCK ID          */
*              2 ARDTYPE      CHAR(1),  /* ENTRY TYPE                */
*                3 ARDKR      BIT(1),   /* KEY RANGE ENTRY           */
*                3 ARDHLI     BIT(1),   /* HIGH LVS (OR TOTAL) INDEX */
*                3 ARDSS      BIT(1),   /* SEQ SET FOR SS WITH DATA  */
*                3 ARDUOVFL BIT(1),     /* USE OVFL FOR THIS KEY     */
*                                       /* RANGE                     */
*                3 ARDEOD     BIT(1),   /* END OF DATA ARDB          */
*                3 ARDUSED    BIT(1),   /* ARDB HAS HAD SPACE REMOVED*/
*              2 ARDLEN       FIXED(15),/* LENGTH OF THIS ARDB       */
*              2 ARDNPTR      PTR(31),  /* PTR TO NEXT ARDB          */
*              2 ARDHKRBA     FIXED(32),/* RBA OF HIGH KEY CI        */
*              2 ARDHRBA      FIXED(32),/* HIGH USED RBA             */
*              2 ARDERBA      FIXED(32),/* HIGH ALLOCATED RBA        */
*              2 ARDVOLSR     CHAR(6),  /* SER OF HIGH RBA VOLUME    */
*              2 ARDRELNO     FIXED(15),/* I/O SUPPORT-CATALOG INFO  */
*              2 ARDPRF BIT(8),         /* PREFORMAT BYTE            */
*                                       /* CORRESPONDS TO FIELD      */
*                                       /*  ITYPEXT OF THE VSAM      */
*                                       /*  CATALOG                  */
*                3 ARDPRSS BIT(1),      /* SEQ SET WITH DATA         */
*                3 ARDPRFMT BIT(1),     /* EXTENTS NOT PREFORMATTED  */
*                3 * BIT(6),            /* RESERVED AND MUST AGREE   */
*                                       /*  WITH ITYPEXT             */
*              2 ARDKEYS      CHAR(*);  /* LOW AND HIGH KEY VALUES   */
*                                       /* FOR KEY RANGE ENTRY,      */
*                                       /* SIZE = 2*AMDKEYLN         */
