* /* ARWA (VSAM RESTART WORK AREA) DECLARATION                      */
* /*                                                                 */
* /* MACCOMP Y-2 SC1DE/SJD61                                         */
* /* MACSTAT Y-2 73192/Y02113                                @Y021131*/
* /*                                                                 */
* /* DESCRIBES WORK AREA USED BY ALL AM/0 RESTART ROUTINES          */
* /* CREATED BY VSAM RESTART                                        */
* /*                                                                */
*%GOTO   ARWA1;
* /*     ARWA DIGRAM                                                */
* /*  0 -------------------------------------------                 */
* /*    |                    |                    |                 */
* /*    |      ARWASIZE      |      ARWAACBN      |                 */
* /*  4 |--------------------|--------------------|                 */
* /*    |                    |          |         |                 */
* /*    |      ARWABUFS      | RESERVED |ARWAMCDE |                 */
* /*  8 |-----------------------------------------|                 */
* /*    |          |                              |                 */
* /*    | ARWARCDE |           ARWAOPEN           |                 */
* /* 12 |-----------------------------------------|                 */
* /*    |                                         |                 */
* /*    |                ARWARSWA                 |                 */
* /* 16 |-----------------------------------------|                 */
* /*    |                                         |                 */
* /*    |                ARWAUALP                 |                 */
* /* 20 |-----------------------------------------|                 */
* /*    |                                         |                 */
* /*    |                ARWAWALP                 |                 */
* /* 24 |-----------------------------------------|                 */
* /*    |                                         |                 */
* /*    |                ARWAACBU                 |                 */
* /* 28 |-----------------------------------------|                 */
* /*    |                                         |                 */
* /*    |                ARWAACBW                 |                 */
* /* 32 |-----------------------------------------|                 */
* /*    |                                         |                 */
* /*    |                ARWAAMLU                 |                 */
* /* 36 |-----------------------------------------|                 */
* /*    |                                         |                 */
* /*    |                ARWAAMLW                 |                 */
* /* 40 |-----------------------------------------|                 */
* /*    |                                         |                 */
* /*    |                ARWAAMBU                 |                 */
* /* 44 |-----------------------------------------|                 */
* /*    |                                         |                 */
* /*    |                ARWAAMBW                 |                 */
* /* 48 |-----------------------------------------|                 */
* /*    |                                         |                 */
* /*    |                ARWAAMBL                 |                 */
* /* 52 |-----------------------------------------|                 */
* /*    |                                         |                 */
* /*    |                ARWAWORK                 |                 */
* /* 56 |-----------------------------------------|                 */
* /*    |                                         |                 */
* /*    |                ARWAWAEP                 |                 */
* /* 60 |-----------------------------------------|                 */
* /*    |                                         |                 */
* /*    |                ARWAMDSB                 |                 */
* /* 64 |-----------------------------------------|                 */
* /*    |                                         |                 */
* /*    |                ARWABLPT                 |                 */
* /* 68 |-----------------------------------------|                 */
* /*    |                                         |                 */
* /*    |                ARWAMBPT                 |                 */
* /* 72 |-----------------------------------------|                 */
* /*    |                                         |                 */
* /*    |                ARWAXBEG                 |                 */
* /* 76 |-----------------------------------------|                 */
* /*    |          |                              |                 */
* /*    | ARWAXFL2 |           ARWAXEND           |                 */
* /* 80 |-----------------------------------------|                 */
* /*    |                                         |                 */
* /*    |                ARWAECB                  |                 */
* /* 84 |-----------------------------------------|                 */
* /*    |                                         |                 */
* /*    |                RESERVED                 |                 */
* /* 88 |-----------------------------------------|                 */
* /*    |                                         |                 */
* /*    |                RESERVED                 |                 */
* /* 92 |-----------------------------------------|                 */
* /*    |                                         |                 */
* /*    |                RESERVED                 |                 */
* /* 96 |-----------------------------------------|                 */
* /*    |                                         |                 */
* /*    |                RESERVED                 |                 */
* /* 100|-----------------------------------------|                 */
* /*    |                                         |                 */
* /*    |                RESERVED                 |                 */
* /* 104|-----------------------------------------|                 */
* /*    |                                         |                 */
* /*    |                RESERVED                 |                 */
* /* 108|-----------------------------------------|                 */
* /*    |                                         |                 */
* /*    |                RESERVED                 |                 */
* /* 112|-----------------------------------------|                 */
* /*    |                                         |                 */
* /*    |                RESERVED                 |                 */
* /* 116|-----------------------------------------|                 */
* /*    |                                         |                 */
* /*    |                RESERVED                 |                 */
* /* 120 -----------------------------------------           @Y021131*/
* /*                                                                */
* /*     ARWA DECLARATION                                           */
* /*                                                                */
* /*                                                                */
*%ARWA1: ;
* /*                                                                */
*        DCL  1 IDAARWA  BASED,              /* ARWA                */
*               2 ARWASIZE  FIXED(15),       /* ARWA SIZE           */
*               2 ARWAACBN    FIXED(15),     /* NUMBER OF USER ACBS */
*               2 ARWABUFS    FIXED(15),     /* USED TO COMPUTE
*                                               LENGTH OF THE ARDKEYS
*                                               FIELD IN THE ARDB   */
*               2 *           BIT(8),        /* RESERVED            */
*               2 ARWAMCDE    FIXED(8),      /* ERROR MESSAGE CODE  */
*               2 ARWARCDE    FIXED(8),      /* ERROR RETURN CODE   */
*               2 ARWAOPEN    PTR(24),       /* OPEN PARAMETER LIST */
*               2 ARWARSWA    PTR(31),       /* PTR VS  RESTART WA  */
*               2 ARWAAL      CHAR(8) BDY(WORD), /* PT ACB LISTS    */
*                 3 ARWAUALP  PTR(31),       /* PT USER/WORK ACB LIST
*                                                            @Y021131*/
*                 3 ARWAWALP  PTR(31),       /* PT WORK ACBS @Y021131*/
*               2 ARWAACB     CHAR(8) BDY(WORD), /* PT CURRENT ACBS */
*                 3 ARWAACBU  PTR(31),       /* PTR CURRENT USER ACB*/
*                 3 ARWAACBW  PTR(31),       /* PTR CURRENT WORK ACB*/
*               2 ARWAAML     CHAR(8) BDY(WORD), /* PT CURRENT AMBLS*/
*                 3 ARWAAMLU  PTR(31),       /* PTR  USER  AMBL     */
*                 3 ARWAAMLW  PTR(31),       /* PTR  WORK  AMBL     */
*               2 ARWAAMB     CHAR(8) BDY(WORD), /* PT CURRENT AMBS */
*                 3 ARWAAMBU  PTR(31),       /* PTR CURRENT USER AMB*/
*                 3 ARWAAMBW  PTR(31),       /* PTR CURRENT WORK AMB*/
*               2 ARWAAMBL    PTR(31),       /* SAVE JSCB AMBL PT   */
*               2 ARWAWORK    PTR(31),       /* WORK AREA           */
*               2 ARWARSA     CHAR(64) BDY(WORD), /* VSAM RESTART
*                                               ERROR MESSAGE AND
*                                               PAGE FIX WORK AREA  */
*                 3 ARWAWAEP  PTR(31),       /* POINTER TO WORK
*                                               ACB EXTENSION       */
*                 3 ARWAMDSB  PTR(31),       /* PT TO CURRENT AMDSB */
*                 3 ARWABLPT  PTR(31),       /* PT TO CURRENT AMBL  */
*                 3 ARWAMBPT  PTR(31),       /* PT TO CURRENT AMB   */
*                 3 ARWAXBEG  PTR(31),       /* PT MSTR BLK TO FIX  */
*                 3 ARWAXFL2  BIT(8),        /* END LIST INDICATOR  */
*                 3 ARWAXEND  PTR(24),       /* PT END OF MSTR BLK  */
*                 3 ARWAECB   CHAR(4),       /* PAGE FIX ECB        */
*                   4 *       CHAR(3),       /* RESERVE SECTION ECB */
*                   4 ARWACC  BIT(8),        /* ECB CONDITION CODE  */
*                     5 *     BIT(4),        /*   UNUSED            */
*                     5 ARWAFXER BIT(1),     /* PAGE FIX INDICATOR  */
*                     5 *     BIT(3),        /*     UNUSED          */
*                 3 *         PTR(31),       /* RESERVED            */
*                 3 *         PTR(31),       /* RESERVED            */
*                 3 *         PTR(31),       /* RESERVED            */
*                 3 *         PTR(31),       /* RESERVED            */
*                 3 *         PTR(31),       /* RESERVED            */
*                 3 *         PTR(31),       /* RESERVED            */
*                 3 *         PTR(31),       /* RESERVED            */
*                 3 *         PTR(31),       /* RESERVED     @Y021131*/
*             2 ARWAUWAL CHAR(0); /* USER/WORK ACB LIST      @Y021131*/
* /*                                                                */
*%GOTO ARWA2;
* /*                                                                */
* /*                ARWA ASSEMBLER DSECT                            */
* /*                                                                */
         MACRO
IGCARWA  DSECT                               ARWA DSECT
ARWASIZE DS    H                             RESTART WORK AREA SIZE
ARWAACBN DS    H                             NUMBER OF OPEN VSAM ACBS
ARWABUFS DS    H                             LENGTH OF ARDKEYS FIELD
         DS    BL1                           RESERVED
ARWAMCDE DS    XL1                           ERROR MESSAGE CODE
ARWARCDE DS    XL1                           ERROR RETURN CODE
ARWAOPEN DS    AL3                           PT TO OPEN PARAMETER LIST
ARWARSWA DS    A                             POINTER TO VS  RESTART WA
ARWAAL   DS    0CL8                          PTR USER / WORK ACB LIST
ARWAUALP DS    A                             POINTER TO USER ACB LIST
ARWAWALP DS    A                             POINTER TO WORK ACBS
ARWAACB  DS    0CL8                          PTR TO CURRENT ACBS
ARWAACBU DS    A                             PTR TO CURRENT USER ACB
ARWAACBW DS    A                             PTR TO CURRENT WORK ACB
ARWAAML  DS    0CL8                          PTR TO CURRENT AMBLS
ARWAAMLU DS    A                             PTR TO CURRENT USER AMBL
ARWAAMLW DS    A                             PTR TO CURRENT WORK AMBL
ARWAAMB  DS    0CL8                          PTR TO CURRENT AMBS
ARWAAMBU DS    A                             PTR TO CURRENT USER AMB
ARWAAMBW DS    A                             PTR TO CURRENT WORK AMB
ARWAAMBL DS    A                             SAVE AREA FOR JSCB AMBL PT
ARWAWORK DS    A                             WORK AREA
ARWARSA  DS    0CL64                         PAGEFIX ERROR MSG WRK AREA
ARWAWAEP DC    A                             WORK ACB EXTENSION PT
ARWAMDSB DC    A                             CURRENT AMDSB POINTER
ARWABLPT DC    A                             CURRENT AMBL POINTER
ARWAMBPT DC    A                             CURRENT AMB POINTER
ARWAXBEG DC    A                             PT MASTER BLK TO BE FIXED
ARWAXFL2 DC    0BL1                          END OF LIST INDICATOR
ARWAXEND DC    A                             PT TO END OF MASTER BLK
ARWAECB  DC    0A                            MASTER BLOCK ECB
         DC    CL3                           RESERVE SECTION OF ECB
ARWACC   DC    CL1                           ECB CONDITION CODE
ARWAFXER EQU   X'08'                         PAGE FIX INDICATOR
         DC    A                             RESERVED
         DC    A                             RESERVED
         DC    A                             RESERVED
         DC    A                             RESERVED
         DC    A                             RESERVED
         DC    A                             RESERVED
         DC    A                             RESERVED
         DC    A                             RESERVED
         DC    A                             RESERVED
         DC    A                             RESERVED
ARWAPGFX DC    A                             ADDRESS OF PAGE FIX LIST
         DC    F                             RESERVED
         MEND
* /*                                                                */
* /*           END OF IGCARWA, AM/0 RESTART WORK AREA               */
* /*                                                                */
*%ARWA2:  ;
