 /********************************************************************/
 /*                                                                  */
 /*   MACRO NAME = IDABIB                                            */
 /*                                                                  */
 /*   DESCRIPTIVE NAME = BASE INFORMATION BLOCK                      */
 /*                                                                  */
 /*   FUNCTION = THE BIB CONTAINS INFORMATION RELATING TO THE        */
 /*              OPERATIONAL SPHERE.                                 */
 /*                                                                  */
 /*   CONTROL BLOCK STRUCTURE = POINTED TO BY THE AMBL (AMBLBIB).    */
 /*                                                                  */
 /*   INCLUDED MACROS = NONE                                         */
 /*                                                                  */
 /*   METHOD OF ACCESS = PL/S - RESPECIFY IDABIB BASED.              */
 /*                                                                  */
 /*   CREATED BY: VSAM OPEN MODULE IDA0192A.                         */
 /*                                                                  */
 /*   STATUS = VS1 RELEASE 4, VS2 RELEASE 3.                         */
 /*                                                                  */
 /*   DATE OF LAST CHANGE = 22 JANUARY 75                            */
 /*                                                                  */
 /********************************************************************/
    DCL 1 IDABIB BASED BDY (WORD),  /* BASE INFORMATION BLOCK        */
          2 BIBHDR,                 /* BIB HEADER SECTION            */
            3 BIBID CHAR(1),        /* CONTROL BLOCK ID              */
            3 BIBFLG1 BIT(8),       /* BIB FLAG BYTE                 */
              4 BIBVIRT BIT(1),     /* VIRTUAL UCB'S IN SPHERE       */
              4 BIBREST BIT(1),     /* RESTART PROCESSING SPHERE     */
              4 BIBCKPT BIT(1),     /* CHECKPOINT PROCESSING SPHERE  */
              4 * BIT(5),           /* UNUSED                        */
            3 BIBLEN FIXED(15),     /* LENGTH OF BIB                 */
          2 BIBFLG2 BIT(8),         /* FLAGS                         */
          2 * CHAR(3),              /* NOT USED                      */
          2 BIBUPT PTR(31),         /* ADDR OF UPGRADE TABLE         */
          2 BIBVMT PTR(31),         /* ADDR OF VOLUME MOUNT TABLE    */
          2 BIBDACB PTR(31),        /* ADDR OF DUMMY ACB             */
          2 BIBPAMBL PTR(31),       /* ADDR OF PRIMARY AMBL          */
          2 BIBSPHPT PTR(31),       /* PTR TO SPHERE BLOCK           */
          2 BIBPRSPH PTR(31),       /* PTR TO PROTECTED SPHERE BLK   */
          2 BIBHEBPT PTR(31),       /* PTR TO FIRST HEB              */
          2 BIBHEBFQ PTR(31),       /* PTR FIRST FREE HEADER ELEMENT */
          2 BIBVCRT PTR(31),        /* ADDR OF VSAM C/R TABLE        */
          2 BIBWSHD PTR(31),        /* ADDR OF WORK SPACE HEADER BLK */
          2 BIBCSL PTR(31),         /* IN VS2, PTR TO CSL CHAIN.     */
          2 BIBPSAB PTR(31),        /* ADDRS OF PROT SPHERE AMBL BLK.*/
          2 BIBVGTT PTR(31),        /* IN VS2, ADDRESS OF SPHERE VGTT*/
          2 BIBRTNS,                /* PTR'S TO RECORD MGMT ROUTINES */
            3 BIBINTRF PTR(31),     /* INTERFACE ROUTINE             */
            3 BIBCEAPP PTR(31),     /* CHANNEL END APPENDAGE         */
            3 BIBASYRT PTR(31),     /* ASYNCHRONOUS ROUTINES         */
            3 BIBSIOAP PTR(31),     /* START I/O APPENDAGE           */
          2 BIBJOBNM CHAR(8),       /* JOBNAME OF ISSUER OF OPEN     */
          2 BIBSTPNM CHAR(8),       /* STEP NAME OF OPENER           */
          2 BIBDDNM CHAR(8),        /* DDNAME OF OPENER              */
          2 BIBASCB PTR(31);        /* ASCB ADDR OF ISSUER OF OPEN   */
