*/********************************************************************/
*/*                                                                  */
*/*   MACRO NAME = IDABSPH                                           */
*/*                                                                  */
*/*   DESCRIPTIVE NAME = BUFFER SUBPOOL HEADER                       */
*/*                                                                  */
*/*   FUNCTION =  DEFINES VSAM BUFFER POOL FOR SHARED RESOURCES      */
*/*                                                                  */
*/*   CONTROL BLOCK STRUCTURE = IDABSPH IS POINTED TO BY IDAAMB      */
*/*                                                                  */
*/*   INCLUDED MACROS = NONE                                         */
*/*                                                                  */
*/*   METHOD OF ACCESS = PL/S - NO DECLARES NECESSARY                */
*/*                                                                  */
*/*   CREATED BY = VSAM BLDVRP                                       */
*/*                                                                  */
*/*   STATUS = VS/2 RELEASE 3  (CHANGE FLAG @Y30SDXX)                */
*/*                                                                  */
*/*   DATE OF LAST CHANGE = 19 SEPT 74                               */
*/*                                                                  */
*/********************************************************************/
  DCL 1 IDABSPH BASED,              /* BUFFER SUBPOOL HEADER         */
       2 BSPHID CHAR(1),            /* BSPH IDENTIFICATION           */
       2 BSPHFLG1 BIT(8),           /* FLAG BYTE 1                   */
        3 BSPHIOBF BIT(1),          /* I/O BLOCKS FIXED              */
        3 BSPHBFRF BIT(1),          /* BUFFERS FIXED                 */
       2 BSPHLEN FIXED(15),         /* LENGTH OF BSPH                */
       2 BSPHNM CHAR(4),            /* EBCDIC BSPH ID                */
       2 BSPHNBSP PTR(31),          /* NEXT BSPH                     */
       2 BSPHBFNO FIXED(15),        /* NUMBER OF BUFFERS             */
       2 BSPHERCT FIXED(15),        /* WRITE ERROR COUNT             */
       2 BSPHBUFC PTR(31),          /* FIRST BUFC IN POOL            */
       2 BSPHMDBT FIXED(32),        /* MODIFICATION BITS             */
       2 BSPHBSZ FIXED(31),         /* BUFFER SIZE                   */
       2 BSPHCSRC FIXED(31),        /* COMPARE/SWAP RESOURCE         */
        3 BSPHFLG2 BIT(8),          /* FLAG BYTE 2                   */
         4 BSPHAPRT BIT(1),         /* ARITHMETIC PROTECT BIT        */
         4 BSPHPCUC BIT(1),         /* USE CHAIN CHANGING            */
        3 * PTR(8),                 /* RESERVED                      */
        3 BSPHPSUC FIXED(15),       /* NBR OF PLHS SEARCHING USE CHN */
       2 BSPHCPLH PTR(31),          /* PLH CHANGING USE CHAIN        */
       2 BSPHRDS FIXED(31),         /* NUMBER OF BUFFER READS        */
       2 BSPHFND FIXED(31),         /* NBR TIMES RBA FOUND BY
                                       LOOK-ASIDE                    */
       2 BSPHUIW FIXED(31),         /* NBR OF USER INITIATED WRITES  */
       2 BSPHNUIW FIXED(31),        /* NON-UIW COUNT                 */
       2 BSPHUTOP PTR(31),          /* PTR TO USE CHAIN TOP          */
       2 BSPHUBTM PTR(31),          /* PTR TO BOTTOM OF USE CHAIN    */
       2 BSPH1ST PTR(31);           /* POINTER TO 1ST IDABSPH        */
