         TITLE 'IDACKRA1 - VSAM CHECKPOINT/RESTART ESTAE ROUTINE       *
                        '
IDACKRA1 CSECT ,                                                   0001
@MAINENT DS    0H                                                  0001
         USING *,@15                                               0001
         B     @PROLOG                                             0001
         DC    AL1(16)                                             0001
         DC    C'IDACKRA1  75.042'                                 0001
         DROP  @15
@PROLOG  BALR  @12,0                                               0001
@PSTART  DS    0H                                                  0001
         USING @PSTART,@12                                         0001
*                                                                  0123
*   /*****************************************************************/
*   /*                                                               */
*   /* CHECK IF SDWA IS AVAILABLE                                    */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0123
*   IF GPR00F=NOSDWA THEN           /* IF NO SDWA STRUCTURE          */
         CH    GPR00F,@CH00984                                     0123
         BNE   @RF00123                                            0123
*     RETURN CODE(ZERO);            /* CONTINUE TERMINATION          */
*                                                                  0124
         SLR   @15,@15                                             0124
@EL00001 DS    0H                                                  0124
@EF00001 DS    0H                                                  0124
@ER00001 BR    @14                                                 0124
*   /*****************************************************************/
*   /*                                                               */
*   /* SDWA IS AVAILABLE, SO CONTINUTE PROCESSING                    */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0125
*   SDWAPTR=GPR01P;                 /* SAVE SDWA POINTER             */
@RF00123 LR    SDWAPTR,GPR01P                                      0125
*   R14SAVE=GPR14P;                 /* SAVE RETURN VECTOR            */
         LR    R14SAVE,GPR14P                                      0126
*   ESTAEPTR=SDWAPARM;              /* ADDRESSIBILITY TO PARAM LIST  */
         L     ESTAEPTR,SDWAPARM(,SDWAPTR)                         0127
*   RESPECIFY                       /* FREE REGISTERS FOR COMPILER   */
*    (GPR01P,                                                      0128
*     GPR00F,                                                      0128
*     GPR14P) UNRESTRICTED;                                        0128
*                                                                  0128
*   /*****************************************************************/
*   /*                                                               */
*   /* IDENTIFY MODULE THAT FAILED                                   */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0129
*   SDWARECP=MODNAMES;              /* FILL IN SKELETON              */
         MVC   SDWARECP(24,SDWAPTR),@CC01616                       0129
*   IDAMOD=RSTATRTN;                /* IDENTIFY THE CSECT            */
*                                                                  0130
         MVC   IDAMOD(4,SDWAPTR),RSTATRTN(ESTAEPTR)                0130
*   /*****************************************************************/
*   /*                                                               */
*   /* SETUP RECOVERY ROUTINE REGISTERS                              */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0131
*   SDWASR03=IDABASER;              /* BASE REGISTER FOR RECOVERY    */
         MVC   SDWASR03(4,SDWAPTR),IDABASER(ESTAEPTR)              0131
*   SDWASR04=ADDR(FORCORE);         /* ADDRESS OF FORCORE IN RCORE   */
         ST    ESTAEPTR,SDWASR04(,SDWAPTR)                         0132
*   SDWASR13=IDADATAR;              /* DATA REGISTER FOR RECOVERY    */
         MVC   SDWASR13(4,SDWAPTR),IDADATAR(ESTAEPTR)              0133
*                                                                  0134
*   /*****************************************************************/
*   /*                                                               */
*   /* CONSTRUCT A MEANINGFUL MESSAGE - INCLUDE MODULE NAME AND TYPE */
*   /* OF ERROR. THIS MESSAGE WILL BE USED AS THE HEADER FOR SDUMP AS*/
*   /* WELL AS THE MESSAGE IN THE RTCA WHEN RECORDING.               */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0134
*   SDWAEBC=ON;                     /* MESSAGE SHOULD BE IN EBCDIC   */
         OI    SDWAEBC(SDWAPTR),B'01000000'                        0134
*   MSGPTR=ADDR(SDWAVRA);           /* FIRST AREA TO PLACE MESSAGE   */
         LA    MSGPTR,SDWAVRA(,SDWAPTR)                            0135
*   SDWAURAL=ZERO;                  /* LENGTH = ZERO - NO MESSAGE YET*/
*                                                                  0136
         MVI   SDWAURAL(SDWAPTR),X'00'                             0136
*   /*****************************************************************/
*   /*                                                               */
*   /* START OF MESSAGE = MODULE NAME                                */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0137
*   INDEX=ONE;                      /* INIT INDEX TO MESSAGE ARRAY   */
         LA    @06,1                                               0137
         LR    INDEX,@06                                           0137
*   IF IDARRSTR=ON THEN             /* IF A RESTART IS IN PROCESS    */
         TM    IDARRSTR(ESTAEPTR),B'01000000'                      0138
         BNO   @RF00138                                            0138
*     INDEX=INDEX+ONE;              /* INCREMENT THE INDEX           */
         ALR   INDEX,@06                                           0139
*   MSG(1:MSGLEN(INDEX))=MESSAGE(INDEX,1:MSGLEN(INDEX));/* MOVE FIRST
*                                      PART OF MESSAGE INTO SDWA     */
@RF00138 SLR   @06,@06                                             0140
         IC    @06,MSGLEN-1(INDEX)                                 0140
         LR    @15,@06                                             0140
         BCTR  @15,0                                               0140
         LR    @14,INDEX                                           0140
         MH    @14,@CH01619                                        0140
         LA    @01,MESSAGE-41(@14)                                 0140
         EX    @15,@SM01707                                        0140
*   SDWAURAL=MSGLEN(INDEX);         /* SET LENGTH IN SDWA            */
         STC   @06,SDWAURAL(,SDWAPTR)                              0141
*   IF IDARRSTR=ON THEN             /* IF RESTART IN PROCESS, POINT  */
         TM    IDARRSTR(ESTAEPTR),B'01000000'                      0142
         BNO   @RF00142                                            0142
*     MSGPTR=MSGPTR+LENGTH('VSAM RESTART(IDA0');/* TO MOD NAME IN  0143
*                                      RESTART MSG                   */
         AH    MSGPTR,@CH01108                                     0143
*   ELSE                            /* CHECKPOINT IN PROCESS, POINT  */
*     MSGPTR=MSGPTR+LENGTH('VSAM CHECKPOINT(IDA0');/* TO MOD NAME IN
*                                      CHECKPT MSG                   */
         B     @RC00142                                            0144
@RF00142 AH    MSGPTR,@CH00058                                     0144
*   MSG(1:4)=RSTATRTN;              /* LAST FOUR BYTES OF MODUL NAME */
@RC00142 MVC   MSG(4,MSGPTR),RSTATRTN(ESTAEPTR)                    0145
*   MSGPTR=MSGPTR+LENGTH('XXXX), ');/* POINT TO NEXT AVAILABLE     0146
*                                      LOCATION IN MESSAGE AREA      */
*                                                                  0146
         AH    MSGPTR,@CH00461                                     0146
*   /*****************************************************************/
*   /*                                                               */
*   /* CHECK FOR TYPE OF ERROR TO TAILOR MESSAGE TO ERROR TYPE       */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0147
*   INDEX=THREE;                    /* INIT INDEX FOR ERROR MESSAGE  */
         LA    INDEX,3                                             0147
*   IF SDWAMCHK=ON THEN             /* CHECK FOR MACHINE CHECK       */
         TM    SDWAMCHK(SDWAPTR),B'10000000'                       0148
         BNO   @RF00148                                            0148
*     ERRORCOD=MCHCHECK;            /* SET THE ERROR CODE            */
         LA    ERRORCOD,242                                        0149
*   ELSE                            /* NOT MACHINE CHECK, CONTINUE   */
*     DO;                           /* CHECK FOR TYPE OF ERROR       */
         B     @RC00148                                            0150
@RF00148 DS    0H                                                  0151
*       INDEX=INDEX+ONE;            /* INCREMENT ARRAY INDEX         */
         LA    @15,1                                               0151
         ALR   INDEX,@15                                           0151
*       ERRORCOD=INDETERM;          /* AN INDETERMINATE ERROR        */
         LA    ERRORCOD,241                                        0152
*       IF SDWAPCHK=OFF THEN        /* CHECK FOR PROGRAM CHECK       */
         TM    SDWAPCHK(SDWAPTR),B'01000000'                       0153
         BNZ   @RF00153                                            0153
*         DO;                       /* NOT A PROGRAM CHECK           */
*           INDEX=INDEX+ONE;        /* INCREMENT THE INDEX           */
         ALR   INDEX,@15                                           0155
*           IF SDWARKEY=OFF THEN    /* RESTART KEY HIT               */
         TM    SDWARKEY(SDWAPTR),B'00100000'                       0156
         BNZ   @RF00156                                            0156
*             DO;                   /* NO                            */
*               INDEX=INDEX+ONE;    /* INCREMENT THE INDEX           */
         ALR   INDEX,@15                                           0158
*               IF SDWATEXC=OFF&    /* CHECK FOR PAGING ERROR        */
*                   SDWAPGIO=OFF THEN/* IF NOT, ASSUME ABEND         */
         TM    SDWATEXC(SDWAPTR),B'00000011'                       0159
         BNZ   @RF00159                                            0159
*                 INDEX=INDEX+ONE;  /* INCREMENT THE INDEX           */
         ALR   INDEX,@15                                           0160
*             END;                  /* END NOT RESTART KEY           */
@RF00159 DS    0H                                                  0162
*         END;                      /* END NOT PROGRAM CHECK         */
@RF00156 DS    0H                                                  0163
*     END;                          /* END NOT MACHINE CHECK         */
*                                                                  0163
@RF00153 DS    0H                                                  0164
*   /*****************************************************************/
*   /*                                                               */
*   /* ADD THE MESSAGE TO THE HEADER AND FILL IN THE MISSING PIECES  */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0164
*   MSG(1:MSGLEN(INDEX))=MESSAGE(INDEX,1:MSGLEN(INDEX));           0164
@RC00148 SLR   @15,@15                                             0164
         IC    @15,MSGLEN-1(INDEX)                                 0164
         LR    @14,@15                                             0164
         BCTR  @14,0                                               0164
         LR    @11,INDEX                                           0164
         MH    @11,@CH01619                                        0164
         LA    @10,MESSAGE-41(@11)                                 0164
         EX    @14,@SM01709                                        0164
*   SDWAURAL=SDWAURAL+MSGLEN(INDEX);/* UPDATE THE MSG LENGTH IN SDWA */
         SLR   @14,@14                                             0165
         IC    @14,SDWAURAL(,SDWAPTR)                              0165
         ALR   @15,@14                                             0165
         STC   @15,SDWAURAL(,SDWAPTR)                              0165
*   IF INDEX=FOUR THEN              /* RTM ENTERED FOR PROGRAM CHECK */
         CH    INDEX,@CH00084                                      0166
         BNE   @RF00166                                            0166
*     DO;                           /* ADD PGM CHECK ADDRESS TO MSG  */
*       MVO(PACKED,XXXXADD1);       /* MVO SHIFTS BITS FOR SIGN      */
         MVO   PACKED(8,SDWAPTR),XXXXADD1(3,SDWAPTR)               0168
*       SIGNBYTE=SIGNBYTE|SIGN;     /* SET SIGN IN LOW-ORDER BITS    */
         OI    SIGNBYTE(SDWAPTR),X'0F'                             0169
*       UNPK(UNPACKED,PACKED);      /* UNPACK FOR TRANSLATION        */
         UNPK  UNPACKED(16,SDWAPTR),PACKED(8,SDWAPTR)              0170
*       TR(UNPACKED,IKEBC);         /* TRANSLATE TO EBCDIC           */
         LA    @15,TRTTABLE                                        0171
         AL    @15,@CF01711                                        0171
         TR    UNPACKED(16,SDWAPTR),IKEBC(@15)                     0171
*       MSGPTR=MSGPTR+LENGTH('PROGRAM CHECK LOCATION = ');/* PT TO 0172
*                                      ADDRESS LOCATION IN MSG       */
         AH    MSGPTR,@CH01703                                     0172
*       MSG(1:6)=CHAR6;             /* MOVE IN PROGRAM CHECK ADDRESS */
         MVC   MSG(6,MSGPTR),CHAR6(SDWAPTR)                        0173
*     END;                                                         0174
*   IF INDEX=SEVEN THEN             /* RTM ENTERED FOR ABEND         */
*                                                                  0175
@RF00166 CH    INDEX,@CH00461                                      0175
         BNE   @RF00175                                            0175
*     /***************************************************************/
*     /*                                                             */
*     /* FORMAT THE SYSTEM ABEND CODE AND PUT IN MESSAGE             */
*     /*                                                             */
*     /***************************************************************/
*                                                                  0176
*     DO;                                                          0176
*       WORKWORD=COMPCODE;          /* COMPLETION CODE IN WORK WORD  */
         L     WORKWORD,COMPCODE(,SDWAPTR)                         0177
*       SLL(WORKWORD,LENGTH(CCFLAGS));/* SHIFT OUT HIGH-ORDER BITS   */
         SLL   WORKWORD,8                                          0178
*       SRL(WORKWORD,LENGTH(COMPCODE)-LENGTH(SYSTEM));/* SHIFT CODE
*                                      TO LOW-ORDER POSITION         */
         SRL   WORKWORD,20                                         0179
*       CHAR4=WORKWORD;             /* SET UP FOR MVO INSTRUCTION    */
         ST    WORKWORD,CHAR4(,SDWAPTR)                            0180
*       MVO(PACKED,CHAR4);          /* MVO CLEARS BITS FOR SIGN      */
         MVO   PACKED(8,SDWAPTR),CHAR4(4,SDWAPTR)                  0181
*       SIGNBYTE=SIGNBYTE|SIGN;     /* SET THE SIGN BITS TO ALL ONES */
         OI    SIGNBYTE(SDWAPTR),X'0F'                             0182
*       UNPK(UNPACKED,PACKED);      /* UNPACK FOR TRANSLATION        */
         UNPK  UNPACKED(16,SDWAPTR),PACKED(8,SDWAPTR)              0183
*       TR(UNPACKED,IKEBC);         /* TRANSLATE TO EBCDIC           */
         LA    @15,TRTTABLE                                        0184
         AL    @15,@CF01711                                        0184
         TR    UNPACKED(16,SDWAPTR),IKEBC(@15)                     0184
*       MSGPTR=MSGPTR+LENGTH('ABEND S');/* PT TO SYSTEM CODE IN MSG  */
         AH    MSGPTR,@CH00461                                     0185
*       MSG(1:3)=CHAR3;             /* MOVE IN SYSTEM COMP CODE      */
         MVC   MSG(3,MSGPTR),CHAR3(SDWAPTR)                        0186
*                                                                  0187
*       /*************************************************************/
*       /*                                                           */
*       /* CONVERT USER ABEND CODE TO DECIMAL AND PUT IN MESSAGE     */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0187
*       WORKWORD=COMPCODE;          /* COMPLETION CODE IN WORK WORD  */
         L     WORKWORD,COMPCODE(,SDWAPTR)                         0187
*       SLL(WORKWORD,LENGTH(COMPCODE)-LENGTH(USER));/* SHIFT OUT THE
*                                      HIGH-ORDER BITS               */
         SLL   WORKWORD,20                                         0188
*       SRL(WORKWORD,LENGTH(COMPCODE)-LENGTH(USER));/* SHIFT CODE TO
*                                      LOW-ORDER POSITION            */
         SRL   WORKWORD,20                                         0189
*       CVD(WORKWORD,PACKED);       /* CONVERT TO PACKED DECIMAL     */
         CVD   WORKWORD,PACKED(,SDWAPTR)                           0190
*       SIGNBYTE=SIGNBYTE|SIGN;     /* SET THE LOW ORDER FOUR BITS   */
         OI    SIGNBYTE(SDWAPTR),X'0F'                             0191
*       UNPK(UNPACKED,PACKED);      /* UNPACK USER COMPLETION CODE   */
         UNPK  UNPACKED(16,SDWAPTR),PACKED(8,SDWAPTR)              0192
*       TR(UNPACKED,IKEBC);         /* TRANSLATE TO EBCDIC           */
         LA    @03,TRTTABLE                                        0193
         SH    @03,@CH01680                                        0193
         TR    UNPACKED(16,SDWAPTR),IKEBC(@03)                     0193
*       MSGPTR=MSGPTR+LENGTH('XXX, U');/* POINT TO CODE IN MESSAGE   */
         AH    MSGPTR,@CH00082                                     0194
*       MSG(1:4)=CHAR4;             /* MOVE IN USER COMPLETION CODE  */
*                                                                  0195
         MVC   MSG(4,MSGPTR),CHAR4(SDWAPTR)                        0195
*       /*************************************************************/
*       /*                                                           */
*       /* FORMAT REGISTER 15 AND PUT IN MESSAGE                     */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0196
*       MVO(PACKED,XXXXGR15);       /* MOVE INTO PACKED AREA         */
         MVO   PACKED(8,SDWAPTR),XXXXGR15(4,SDWAPTR)               0196
*       SIGNBYTE=SIGNBYTE|SIGN;     /* SET THE LOW-ORDER 4 BITS      */
         OI    SIGNBYTE(SDWAPTR),X'0F'                             0197
*       UNPK(UNPACKED,PACKED);      /* UNPACK THE REGISTER CONTENTS  */
         UNPK  UNPACKED(16,SDWAPTR),PACKED(8,SDWAPTR)              0198
*       TR(UNPACKED,IKEBC);         /* TRANSLATE TO EBCDIC           */
         TR    UNPACKED(16,SDWAPTR),IKEBC(@03)                     0199
*       MSGPTR=MSGPTR+LENGTH('XXXX, REGISTER 15 = ');/* PT TO      0200
*                                      REGISTER LOC IN MSG           */
         AH    MSGPTR,@CH00058                                     0200
*       MSG(1:8)=CHAR8;             /* MOVE IN TRANSLATED REG 15     */
         MVC   MSG(8,MSGPTR),CHAR8(SDWAPTR)                        0201
*     END;                                                         0202
*                                                                  0202
*   /*****************************************************************/
*   /*                                                               */
*   /* SDUMP THE MESSAGE, USER REGION,SQA AND ACTIVE LPA MODULES     */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0203
*   SDUMPPRM=SDUMPMST;              /* RESET SDUMP PARAMETER LIST    */
@RF00175 MVC   SDUMPPRM(24,SDWAPTR),SDUMPMST                       0203
*   GEN(SDUMP HDRAD=SDWAURAL(SDWAPTR),MF=(E,SDUMPPRM(SDWAPTR)))    0204
*   REFS(SDWAURAL,SDWAVRA) SETS(SDUMPPRM);                         0204
         SDUMP HDRAD=SDWAURAL(SDWAPTR),MF=(E,SDUMPPRM(SDWAPTR))
*                                                                  0205
*   /*****************************************************************/
*   /*                                                               */
*   /* SET UP MESSAGE CODE FOR RETRY                                 */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0205
*   IF IDARRSTR=ON THEN                                            0205
*                                                                  0205
         TM    IDARRSTR(ESTAEPTR),B'01000000'                      0205
         BNO   @RF00205                                            0205
*     /***************************************************************/
*     /*                                                             */
*     /* RESTART IN CONTROL                                          */
*     /*                                                             */
*     /***************************************************************/
*                                                                  0206
*     RSRETCD2=ERRORCOD;            /* ERROR CODE FOR RESTART        */
         L     @04,IDACRWAP(,ESTAEPTR)                             0206
         STC   ERRORCOD,RSRETCD2(,@04)                             0206
*   ELSE                                                           0207
*                                                                  0207
*     /***************************************************************/
*     /*                                                             */
*     /* CHECKPOINT IN CONTROL                                       */
*     /*                                                             */
*     /***************************************************************/
*                                                                  0207
*     DO;                                                          0207
         B     @RC00205                                            0207
@RF00205 DS    0H                                                  0208
*       CKMSGCD2=ERRORCOD;          /* ERROR CODE FOR CHECKPOINT     */
         L     @04,IDACRWAP(,ESTAEPTR)                             0208
         STC   ERRORCOD,CKMSGCD2(,@04)                             0208
*       CKRETCD2=SYSTMERR;          /* NON-USER ERROR                */
         MVI   CKRETCD2(@04),X'0C'                                 0209
*     END;                                                         0210
*                                                                  0211
*   /*****************************************************************/
*   /*                                                               */
*   /* SET UP RTCA AND RETURN TO RTM                                 */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0211
*   RESPECIFY                                                      0211
*     GPR01P RESTRICTED;                                           0211
@RC00205 DS    0H                                                  0212
*   SDWADPSA=SDWADPSA&&SDWADPSA;    /* CLEAR AREA USED FOR WORKAREA  */
         XC    SDWADPSA(36,SDWAPTR),SDWADPSA(SDWAPTR)              0212
*   GPR01P=SDWAPTR;                 /* REESTABLISH RTCA            0213
*                                      ADDRESSABILITY FOR RTM        */
*                                                                  0213
         LR    GPR01P,SDWAPTR                                      0213
*   /*****************************************************************/
*   /*                                                               */
*   /* CHECK IF RETRY ALLOWED                                        */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0214
*   IF SDWACLUP=ON|IDARCURS=ON THEN                                0214
         TM    SDWACLUP(SDWAPTR),B'10000000'                       0214
         BO    @RT00214                                            0214
         TM    IDARCURS(ESTAEPTR),B'00010000'                      0214
         BNO   @RF00214                                            0214
@RT00214 DS    0H                                                  0215
*     DO;                           /* SETRP RC(0)                   */
*       RESPECIFY                                                  0216
*        (GPR00P,                                                  0216
*         GPR01P,                                                  0216
*         GPR14P,                                                  0216
*         GPR15P) RSTD;                                            0216
*       GPR01P->SDWARCDE=0;         /* SAVE RC VALUE                 */
         MVI   SDWARCDE(GPR01P),X'00'                              0217
*       RESPECIFY                                                  0218
*        (GPR00P,                                                  0218
*         GPR01P,                                                  0218
*         GPR14P,                                                  0218
*         GPR15P) UNRSTD;                                          0218
*     END;                          /* IF NOT, CONTINUE TERMINATION  */
*   ELSE                            /* RETRY ALLOWED                 */
*     DO;                           /* SETRP RC(4)RETREGS(YES)FRESDWA
*                                      (YES)DUMP(IGNORE)RETADDR(IDARE
*                                      TRY->MODULE)                  */
         B     @RC00214                                            0220
@RF00214 DS    0H                                                  0221
*       RESPECIFY                                                  0221
*        (GPR00P,                                                  0221
*         GPR01P,                                                  0221
*         GPR14P,                                                  0221
*         GPR15P) RSTD;                                            0221
*       GPR01P->SDWARCDE=4;         /* STORE RC INTO SDWA            */
         MVI   SDWARCDE(GPR01P),X'04'                              0222
*       GPR01P->SDWARTYA=ADDR(IDARETRY->MODULE);/* SAVE RETRY ADDRESS*/
         MVC   SDWARTYA(4,GPR01P),IDARETRY(ESTAEPTR)               0223
*       GPR01P->SDWAFREE='1'B;      /* SET FLAG TO FREE SDWA         */
*       GPR01P->SDWAUPRG='1'B;      /* TURN ON RETREGS INDICATOR     */
         OI    SDWAFREE(GPR01P),B'00001100'                        0225
*       RESPECIFY                                                  0226
*        (GPR00P,                                                  0226
*         GPR01P,                                                  0226
*         GPR14P,                                                  0226
*         GPR15P) UNRSTD;                                          0226
*     END;                          /* SET UP SDWA FOR RETRY         */
*   RESPECIFY                                                      0228
*    (GPR01P,                                                      0228
*     GPR14P) RESTRICTED;                                          0228
@RC00214 DS    0H                                                  0229
*   IDARCURS=ON;                    /* PREVENT RECURSION             */
         OI    IDARCURS(ESTAEPTR),B'00010000'                      0229
*   GPR14P=R14SAVE;                 /* RESTORE RETURN VECTOR         */
         LR    GPR14P,R14SAVE                                      0230
*   RETURN;                         /* GO BACK TO RTM                */
         B     @EL00001                                            0231
*   END IDACKRA1                                                   0232
*                                                                  0232
*/* THE FOLLOWING INCLUDE STATEMENTS WERE FOUND IN THIS PROGRAM.     */
*/*%INCLUDE SYSLIB  (LCGPLSSW)                                       */
*/*%INCLUDE SYSLIB  (IEEVCHWA)                                       */
*/*%INCLUDE SYSLIB  (IHAPSA  )                                       */
*/*%INCLUDE SYSLIB  (IEEVRSWA)                                       */
*/*%INCLUDE SYSLIB  (IHASDWA )                                       */
*/*%INCLUDE SYSLIB  (IDAFOREC)                                       */
*/*%INCLUDE SYSLIB  (IECDSECT)                                       */
*/*%INCLUDE SYSLIB  (IECDSECS)                                       */
*/*%INCLUDE SYSLIB  (IEFJFCBN)                                       */
*/*%INCLUDE SYSLIB  (IEFJFCBX)                                       */
*/*%INCLUDE SYSLIB  (IDAPDPRM)                                       */
*/*%INCLUDE SYSLIB  (IDARTMAC)                                       */
*                                                                  0232
*       ;                                                          0232
@DATA    DS    0H
@CH00084 DC    H'4'
@CH00082 DC    H'6'
@CH00461 DC    H'7'
@CH00984 DC    H'12'
@CH01108 DC    H'17'
@CH00058 DC    H'20'
@CH01703 DC    H'25'
@CH01619 DC    H'41'
@CH01680 DC    H'240'
@SM01707 MVC   MSG(0,MSGPTR),0(@01)
@SM01709 MVC   MSG(0,MSGPTR),0(@10)
@DATD    DSECT
         DS    0F
IDACKRA1 CSECT
         DS    0F
@CF01711 DC    F'-240'
@DATD    DSECT
         DS    0D
IDACKRA1 CSECT
         NOPR  ((@ENDDATD-@DATD)*16)
         DS    0F
@SIZDATD DC    AL1(0)
         DC    AL3(@ENDDATD-@DATD)
         DS    0D
@CC01616 DC    C'IDA0192AIDA0XXXXIDACKRA1'
TRTTABLE DC    CL16'0123456789ABCDEF'
MESSAGE  DC    CL41'VSAM CHECKPOINT(IDA0XXXX), '
         DC    CL41'VSAM RESTART(IDA0XXXX), '
         DC    CL41'MACHINE CHECK'
         DC    CL41'PROGRAM CHECK LOCATION = XXXXXX'
         DC    CL41'RESTART KEY DEPRESSED'
         DC    CL41'PAGING ERROR'
         DC    CL41'ABEND SXXX, UXXXX, REGISTER 15 = XXXXXXXX'
MSGLEN   DC    AL1(27)
         DC    AL1(24)
         DC    AL1(13)
         DC    AL1(31)
         DC    AL1(21)
         DC    AL1(12)
         DC    AL1(41)
IDACKRA1 CSECT
SDUMPMST SDUMP SDATA=(RGN,LPA,SQA,CSA),MF=L MASTER SDUMP PARAMETER LIST
IDACKRA1 CSECT
         DS    0D                   START ON DOUBLE WORD BOUNDARY
PCHCKRA1 DC    ((*-IDACKRA1)/20)X'00' PATCH AREA
@DATD    DSECT
@ENDDATD EQU   *
IDACKRA1 CSECT
@00      EQU   00                      EQUATES FOR REGISTERS 0-15
@01      EQU   01
@02      EQU   02
@03      EQU   03
@04      EQU   04
@05      EQU   05
@06      EQU   06
@07      EQU   07
@08      EQU   08
@09      EQU   09
@10      EQU   10
@11      EQU   11
@12      EQU   12
@13      EQU   13
@14      EQU   14
@15      EQU   15
WORKWORD EQU   @03
INDEX    EQU   @03
ERRORCOD EQU   @06
MSGPTR   EQU   @04
R14SAVE  EQU   @07
ESTAEPTR EQU   @05
SDWAPTR  EQU   @02
GPR00F   EQU   @00
GPR00P   EQU   @00
GPR01P   EQU   @01
GPR14P   EQU   @14
GPR15P   EQU   @15
GPR01F   EQU   @01
GPR14F   EQU   @14
GPR15F   EQU   @15
PSA      EQU   0
FLCRNPSW EQU   PSA
FLCROPSW EQU   PSA+8
FLCICCW2 EQU   PSA+16
PSAEEPSW EQU   PSA+132
PSAESPSW EQU   PSA+136
FLCSVILC EQU   PSAESPSW+1
PSAEPPSW EQU   PSA+140
FLCPIILC EQU   PSAEPPSW+1
FLCPICOD EQU   PSAEPPSW+2
PSAPICOD EQU   FLCPICOD+1
FLCTEA   EQU   PSAEPPSW+4
FLCPER   EQU   PSA+152
FLCMCLA  EQU   PSA+168
FLCIOEL  EQU   FLCMCLA+4
FLCIOA   EQU   FLCMCLA+16
FLCFSA   EQU   FLCMCLA+80
PSASUPER EQU   PSA+552
PSASUP1  EQU   PSASUPER
PSASUP2  EQU   PSASUPER+1
PSASUP3  EQU   PSASUPER+2
PSASUP4  EQU   PSASUPER+3
PSACLHT  EQU   PSA+640
PSALKSA  EQU   PSA+696
PSAHLHI  EQU   PSA+760
PSADSSFL EQU   PSA+836
PSADSSF1 EQU   PSADSSFL
PSADSSF3 EQU   PSADSSFL+2
PSADSSF4 EQU   PSADSSFL+3
PSARSVT  EQU   PSA+896
CHKWA    EQU   0
CKRETCOD EQU   CHKWA+44
CKRETCD2 EQU   CKRETCOD+1
CKMSGCOD EQU   CHKWA+46
CKMSGCD2 EQU   CKMSGCOD+1
CKDECB1  EQU   CHKWA+52
XCTLNAME EQU   CKDECB1
CKDCBAD1 EQU   CKDECB1+8
CKDECB2  EQU   CHKWA+72
RSTWA    EQU   0
RSDCBL   EQU   RSTWA+24
RSRETCOD EQU   RSTWA+72
RSRETCD2 EQU   RSRETCOD+1
XCTLNAM1 EQU   RSTWA+180
RSECB1   EQU   XCTLNAM1
RSDCB    EQU   RSTWA+188
SDWA     EQU   0
SDWAPARM EQU   SDWA
SDWAFIOB EQU   SDWA+4
SDWAABCC EQU   SDWAFIOB
SDWACMPF EQU   SDWAABCC
SDWACTL1 EQU   SDWA+8
SDWACMKA EQU   SDWACTL1
SDWAMWPA EQU   SDWACTL1+1
SDWAPMKA EQU   SDWACTL1+4
SDWACTL2 EQU   SDWA+16
SDWACMKP EQU   SDWACTL2
SDWAMWPP EQU   SDWACTL2+1
SDWAPMKP EQU   SDWACTL2+4
SDWAGRSV EQU   SDWA+24
SDWAGR15 EQU   SDWAGRSV+60
SDWANAME EQU   SDWA+88
SDWAEC1  EQU   SDWA+104
SDWAEMK1 EQU   SDWAEC1
SDWAMWP1 EQU   SDWAEC1+1
SDWAINT1 EQU   SDWAEC1+2
SDWANXT1 EQU   SDWAEC1+4
SDWAADD1 EQU   SDWANXT1+1
SDWAAEC1 EQU   SDWA+112
SDWAILC1 EQU   SDWAAEC1+1
SDWAINC1 EQU   SDWAAEC1+2
SDWAICD1 EQU   SDWAINC1+1
SDWAEC2  EQU   SDWA+120
SDWAEMK2 EQU   SDWAEC2
SDWAMWP2 EQU   SDWAEC2+1
SDWAINT2 EQU   SDWAEC2+2
SDWANXT2 EQU   SDWAEC2+4
SDWAAEC2 EQU   SDWA+128
SDWAILC2 EQU   SDWAAEC2+1
SDWAINC2 EQU   SDWAAEC2+2
SDWAICD2 EQU   SDWAINC2+1
SDWASRSV EQU   SDWA+136
SDWASR03 EQU   SDWASRSV+12
SDWASR04 EQU   SDWASRSV+16
SDWASR13 EQU   SDWASRSV+52
SDWAIDNT EQU   SDWA+200
SDWAMCH  EQU   SDWA+204
SDWASTCK EQU   SDWAMCH
SDWAMCHI EQU   SDWAMCH+8
SDWAMCHS EQU   SDWAMCHI
SDWAMCHD EQU   SDWAMCHI+1
SDWARSR1 EQU   SDWAMCH+12
SDWARSR2 EQU   SDWAMCH+13
SDWAFLGS EQU   SDWA+232
SDWAERRA EQU   SDWAFLGS
SDWAMCHK EQU   SDWAERRA
SDWAPCHK EQU   SDWAERRA
SDWARKEY EQU   SDWAERRA
SDWATEXC EQU   SDWAERRA
SDWAPGIO EQU   SDWAERRA
SDWAERRB EQU   SDWAFLGS+1
SDWAERRC EQU   SDWAFLGS+2
SDWAERRD EQU   SDWAFLGS+3
SDWACLUP EQU   SDWAERRD
SDWAIOFS EQU   SDWA+238
SDWARTYA EQU   SDWA+240
SDWACPUA EQU   SDWA+248
SDWAPARQ EQU   SDWA+252
SDWARCDE EQU   SDWAPARQ
SDWAACF2 EQU   SDWAPARQ+1
SDWAUPRG EQU   SDWAACF2
SDWAFREE EQU   SDWAACF2
SDWAACF3 EQU   SDWAPARQ+2
SDWAACF4 EQU   SDWAPARQ+3
SDWALKWA EQU   SDWA+256
SDWALKWS EQU   SDWALKWA
SDWARECP EQU   SDWA+292
SDWACSCT EQU   SDWARECP+8
SDWASNPA EQU   SDWA+320
SDWADUMP EQU   SDWASNPA
SDWADPFS EQU   SDWADUMP+1
SDWADDAT EQU   SDWASNPA+4
SDWASDAT EQU   SDWADDAT
SDWAPDAT EQU   SDWADDAT+2
SDWADPSA EQU   SDWA+328
SDWADPSL EQU   SDWADPSA
SDWARA   EQU   SDWA+400
SDWADPVA EQU   SDWARA+2
SDWAEBC  EQU   SDWADPVA
SDWAURAL EQU   SDWARA+3
SDWAVRA  EQU   SDWARA+4
FORCORE  EQU   0
DXDSCB   EQU   FORCORE
DXJBF    EQU   FORCORE+100
DXIOB    EQU   FORCORE+280
DXDAADDR EQU   FORCORE+312
DXDCB    EQU   FORCORE+320
DXCCW    EQU   FORCORE+368
DXCCW5   EQU   DXCCW+32
DXCCW8   EQU   DXCCW+56
DXCCW12  EQU   DXCCW+88
DXXCTL   EQU   FORCORE+472
DXVOLSR  EQU   FORCORE+500
DXVOLSR1 EQU   DXVOLSR
DXVOLSR2 EQU   DXVOLSR+6
DXVOLSR3 EQU   DXVOLSR+12
DXRESSW  EQU   FORCORE+524
DXUCBSAV EQU   FORCORE+564
DXUDCBAD EQU   FORCORE+568
DXPDCBAD EQU   FORCORE+572
DXATCOM1 EQU   FORCORE+588
DXATGENS EQU   DXATCOM1
DXATVGIV EQU   DXATGENS
DXATOUTA EQU   DXATCOM1+2
DXATDACC EQU   DXATCOM1+3
DXATCOM2 EQU   FORCORE+592
DXATEOV  EQU   DXATCOM2
DXATOPEN EQU   DXATCOM2+1
DXATALL  EQU   DXATCOM2+2
DXATEXC1 EQU   FORCORE+604
DXATEXC2 EQU   FORCORE+608
DSECTSIZ EQU   FORCORE+612
IECPREFX EQU   0
IECEXTPR EQU   IECPREFX+32
IECWTGTB EQU   IECEXTPR+72
IECUPRML EQU   IECEXTPR+80
IECRESWA EQU   IECEXTPR+84
RWARESWA EQU   0
RWAPREFX EQU   RWARESWA
USERPRML EQU   0
IECRRPL  EQU   0
RRPLIST  EQU   IECRRPL
RRFUNCTN EQU   RRPLIST
RRFLAGS1 EQU   RRPLIST+1
RRFLAGS2 EQU   RRPLIST+2
RRFLAGS3 EQU   RRPLIST+3
RRXRETRY EQU   RRPLIST+12
DSMADTRL EQU   0
DSMADTW1 EQU   DSMADTRL
DSMADTB1 EQU   DSMADTW1
DSMADTB2 EQU   DSMADTW1+1
WTGTABLE EQU   0
WTGWTOPR EQU   WTGTABLE
WTG      EQU   0
WTGAREA  EQU   WTG
WTGMODNM EQU   WTGAREA
WTGPREFX EQU   WTGAREA+16
WTGPATHS EQU   WTG+30
WTGENTRY EQU   0
WTGIDTTR EQU   WTGENTRY
APPNMTBL EQU   0
APPENTRY EQU   APPNMTBL+4
INFMJFCB EQU   0
JFCBDSNM EQU   INFMJFCB
JFCBELNM EQU   INFMJFCB+44
JFCBTSDM EQU   INFMJFCB+52
JFCFCBID EQU   INFMJFCB+56
JFCBFRID EQU   JFCFCBID
JFCBLTYP EQU   INFMJFCB+66
JFCBOTTR EQU   INFMJFCB+67
JFCBUFOF EQU   JFCBOTTR
JFCBFLSQ EQU   JFCBOTTR+1
JFCFUNC  EQU   JFCBFLSQ
JFCBMASK EQU   INFMJFCB+72
JFCBFLG1 EQU   JFCBMASK+5
JFCOPEN  EQU   JFCBFLG1
JFCBFLG2 EQU   JFCBMASK+6
JFCDEFER EQU   JFCBFLG2
JFCBIND1 EQU   INFMJFCB+86
JFCBIND2 EQU   INFMJFCB+87
JFCAMPTR EQU   INFMJFCB+88
JFCBUFRQ EQU   JFCAMPTR
JFCBUFNO EQU   JFCBUFRQ
JFCBGNCP EQU   JFCAMPTR+1
JFCBHIAR EQU   JFCBGNCP
JFCBFALN EQU   JFCBHIAR
JFCBFTEK EQU   JFCBFALN
JFCBBFTA EQU   JFCBFTEK
JFCEROPT EQU   INFMJFCB+92
JFCTRTCH EQU   INFMJFCB+93
JFCBX    EQU   0
IDAPDPRM EQU   0
PDPMSGFL EQU   IDAPDPRM+34
IDAVGTT  EQU   0
VGTTTYPE EQU   IDAVGTT+4
IKEBC    EQU   0
MODULE   EQU   0
MSG      EQU   0
IKEBF15  EQU   0
IKEBF31  EQU   0
IKEBP15  EQU   0
IKEBP31  EQU   0
IKEBP8   EQU   0
PSARSVTE EQU   PSARSVT
DXXWTG   EQU   DSECTSIZ
DXXAREA  EQU   DSECTSIZ+4
DXXMODNM EQU   DXXAREA
DXXLNG   EQU   DXXAREA+29
DXXENTRY EQU   DXXAREA+32
DXXIDTTR EQU   DXXENTRY
DXREGSAV EQU   DXCCW8
DXREG1   EQU   DXREGSAV+28
DXIDENT  EQU   DXCCW12
DXRETMOD EQU   DXIDENT+2
@NM00102 EQU   DXXCTL
DXSAVMOD EQU   @NM00102+2
@NM00103 EQU   DXRESSW
JFCKEYLE EQU   JFCTRTCH
JFCCODE  EQU   JFCKEYLE
JFCSTACK EQU   JFCTRTCH
JFCMODE  EQU   JFCSTACK
JFCSPPRT EQU   JFCTRTCH
JFCBABFS EQU   JFCSPPRT+2
JFCLIMCT EQU   JFCBABFS
JFCDSORG EQU   JFCSPPRT+5
JFCDSRG1 EQU   JFCDSORG
JFCDSRG2 EQU   JFCDSORG+1
JFCRECFM EQU   JFCSPPRT+7
JFCRCFM  EQU   JFCRECFM
JFCOPTCD EQU   JFCSPPRT+8
JFCWVCSP EQU   JFCOPTCD
JFCWVCIS EQU   JFCWVCSP
JFCWVCBD EQU   JFCWVCIS
JFCALLOW EQU   JFCOPTCD
JFCRSV17 EQU   JFCALLOW
JFCOVER  EQU   JFCRSV17
JFCPCIBT EQU   JFCOPTCD
JFCMAST  EQU   JFCPCIBT
JFCEXT   EQU   JFCMAST
JFCBCKPT EQU   JFCOPTCD
JFCIND   EQU   JFCBCKPT
JFCRSV18 EQU   JFCOPTCD
JFCCYL   EQU   JFCRSV18
JFCACT   EQU   JFCCYL
JFCREDUC EQU   JFCOPTCD
JFCRSV19 EQU   JFCREDUC
JFCRSV20 EQU   JFCRSV19
JFCRSV21 EQU   JFCOPTCD
JFCDEL   EQU   JFCRSV21
JFCRSV23 EQU   JFCOPTCD
JFCREORG EQU   JFCRSV23
JFCBLKSI EQU   JFCSPPRT+9
JFCBUFSI EQU   JFCBLKSI
JFCAMSYN EQU   JFCSPPRT+11
JFCNCP   EQU   JFCAMSYN+2
JFCNTM   EQU   JFCAMSYN+3
JFCBFSEQ EQU   JFCNTM
JFCPCI   EQU   JFCBFSEQ
JFCRESRV EQU   JFCAMSYN+4
JFCUCSEG EQU   JFCRESRV
JFCUCSOP EQU   JFCUCSEG+4
JFCOUTLI EQU   JFCUCSEG+5
JFCTHRSH EQU   JFCOUTLI
JFCCPRI  EQU   JFCTHRSH
JFCBVOLS EQU   JFCUCSEG+10
JFCBS001 EQU   JFCBVOLS
JFCBPQTY EQU   JFCBS001+34
JFCBCTRI EQU   JFCBS001+37
JFCBSQTY EQU   JFCBS001+38
JFCFLGS1 EQU   JFCBS001+41
PDWLIST  EQU   FORCORE
PDWWORK  EQU   DXDCB
IDARRPL  EQU   DXATCOM1
IDARRFLG EQU   IDARRPL+1
IDARSTAT EQU   DXATEXC1
RSTAT    EQU   IDARSTAT
RSTATCRO EQU   RSTAT+1
IDARRSTR EQU   RSTATCRO
IDARCURS EQU   RSTATCRO
RSTATOP2 EQU   RSTAT+2
IDARRTN  EQU   DXATEXC2
RSTATRTN EQU   IDARRTN
XXXXADD1 EQU   SDWAADD1
XXXXGR15 EQU   SDWAGR15
COMPCODE EQU   SDWAABCC
CCFLAGS  EQU   COMPCODE
SYSTEM   EQU   COMPCODE+1
USER     EQU   COMPCODE+2
WORKAREA EQU   SDWADPSA
PACKED   EQU   WORKAREA
SIGNBYTE EQU   PACKED+7
UNPACKED EQU   WORKAREA+8
CHAR8    EQU   UNPACKED+8
CHAR6    EQU   CHAR8+2
CHAR4    EQU   CHAR6+2
CHAR3    EQU   CHAR4+1
SDUMPWA  EQU   SDWADPSA
SDUMPPRM EQU   SDUMPWA
IDACSECT EQU   SDWACSCT
IDAMOD   EQU   IDACSECT+4
IDAESTAE EQU   DXATCOM1
IDABASER EQU   IDAESTAE
IDADATAR EQU   IDAESTAE+4
IDARETRY EQU   IDAESTAE+8
IDACRWAP EQU   IDAESTAE+12
DXBTAMX  EQU   DXREG1
DXDSNAME EQU   DXCCW5
FLC      EQU   PSA
IDAESPL  EQU   DXATCOM1
IDARTSA  EQU   DXJBF
         AGO   .@UNREFD                START UNREFERENCED COMPONENTS
IDACOM   EQU   IDACSECT
@NM00125 EQU   CHAR4
@NM00124 EQU   CHAR6
@NM00123 EQU   CHAR8
@NM00122 EQU   UNPACKED
@NM00121 EQU   PACKED
@NM00120 EQU   RSTAT+3
@NM00119 EQU   RSTATOP2
RSTATCSA EQU   RSTATOP2
IDARCRCU EQU   RSTATCRO
IDARCKPT EQU   RSTATCRO
RSTATOPT EQU   RSTAT
@NM00118 EQU   IDARRPL+2
@NM00117 EQU   IDARRFLG
RRPLVSAM EQU   IDARRFLG
@NM00116 EQU   IDARRFLG
@NM00115 EQU   IDARRPL
PDWORKSP EQU   PDWWORK+88
PDWERRCD EQU   PDWWORK+84
PDWMSGPT EQU   PDWWORK+80
PDWSAVED EQU   PDWWORK+76
PDWSAVEC EQU   PDWWORK+72
PDWSAVEB EQU   PDWWORK+68
PDWSAVEA EQU   PDWWORK+64
PDWSAVE  EQU   PDWWORK
WTPROUT  EQU   PDWLIST+75
WTPMSG   EQU   PDWLIST+4
WTPFLGS  EQU   PDWLIST+2
WTPLNGTH EQU   PDWLIST
JFCBEND  EQU   JFCBS001+58
JFCBSPTN EQU   JFCBS001+57
JFCBVLCT EQU   JFCBS001+56
JFCBDRLH EQU   JFCBS001+53
JFCBSBNM EQU   JFCBS001+50
JFCBABST EQU   JFCBS001+48
JFCBSPNM EQU   JFCBS001+45
JFCBDQTY EQU   JFCBS001+42
JFCBUAFF EQU   JFCFLGS1
JFCRSV45 EQU   JFCFLGS1
JFCVRDS  EQU   JFCFLGS1
JFCBCEOV EQU   JFCFLGS1
JFCRSV42 EQU   JFCFLGS1
JFCRSV41 EQU   JFCFLGS1
JFCTOPEN EQU   JFCFLGS1
JFCBDLET EQU   JFCFLGS1
JFCRQID  EQU   JFCBSQTY
JFCROUND EQU   JFCBCTRI
JFCALX   EQU   JFCBCTRI
JFCMIXG  EQU   JFCBCTRI
JFCONTIG EQU   JFCBCTRI
JFCRSV29 EQU   JFCBCTRI
JFCBMSGP EQU   JFCBCTRI
JFCBSPAC EQU   JFCBCTRI
JFCRUNIT EQU   JFCBPQTY
JFCBEXAD EQU   JFCBS001+31
JFCBEXTL EQU   JFCBS001+30
JFCMSVGP EQU   JFCBS001+22
@NM00107 EQU   JFCBS001
JFCAVOLS EQU   JFCBVOLS
JFCBNVOL EQU   JFCUCSEG+9
JFCBNTCS EQU   JFCUCSEG+8
JFCSOWA  EQU   JFCOUTLI+1
JFCSEND  EQU   JFCCPRI
JFCEQUAL EQU   JFCCPRI
JFCRECV  EQU   JFCCPRI
JFCRSV34 EQU   JFCCPRI
JFCRSV33 EQU   JFCCPRI
JFCRSV55 EQU   JFCCPRI
JFCRSV54 EQU   JFCCPRI
JFCRSV53 EQU   JFCCPRI
JFCRSV27 EQU   JFCUCSOP
JFCRSV26 EQU   JFCUCSOP
JFCFCBVR EQU   JFCUCSOP
JFCFCBAL EQU   JFCUCSOP
JFCVER   EQU   JFCUCSOP
JFCRSV25 EQU   JFCUCSOP
JFCFOLD  EQU   JFCUCSOP
JFCRSV24 EQU   JFCUCSOP
JFCUCSID EQU   JFCUCSEG
JFCINTVL EQU   JFCSPPRT+19
JFCDBUFN EQU   JFCRESRV+3
JFCCYLOF EQU   JFCRESRV+2
JFCRKP   EQU   JFCRESRV
JFCPCIR2 EQU   JFCPCI
JFCPCIR1 EQU   JFCPCI
JFCPCIN2 EQU   JFCPCI
JFCPCIN1 EQU   JFCPCI
JFCPCIA2 EQU   JFCPCI
JFCPCIA1 EQU   JFCPCI
JFCPCIX2 EQU   JFCPCI
JFCPCIX1 EQU   JFCPCI
JFCBUFMX EQU   JFCNCP
JFCLRECL EQU   JFCAMSYN
JFCBAXBF EQU   JFCBUFSI
JFCREL   EQU   JFCREORG
JFCRSV22 EQU   JFCDEL
JFCSRCHD EQU   JFCRSV20
JFCOPTQ  EQU   JFCACT
JFCFEED  EQU   JFCIND
JFCCBWU  EQU   JFCEXT
JFCWUMSG EQU   JFCOVER
JFCSDNAM EQU   JFCWVCBD
@NM00106 EQU   JFCRECFM
JFCCHAR  EQU   JFCRECFM
JFCRFS   EQU   JFCRECFM
JFCRFB   EQU   JFCRECFM
JFCRFO   EQU   JFCRCFM
JFCFMREC EQU   JFCRCFM
JFCRSV16 EQU   JFCDSRG2
JFCRSV15 EQU   JFCDSRG2
JFCORGTR EQU   JFCDSRG2
JFCORGAM EQU   JFCDSRG2
JFCRSV13 EQU   JFCDSRG2
JFCORGTQ EQU   JFCDSRG2
JFCORGTX EQU   JFCDSRG2
JFCORGGS EQU   JFCDSRG2
JFCORGU  EQU   JFCDSRG1
JFCORGPO EQU   JFCDSRG1
JFCORGMQ EQU   JFCDSRG1
JFCORGCQ EQU   JFCDSRG1
JFCORGCX EQU   JFCDSRG1
JFCORGDA EQU   JFCDSRG1
JFCORGPS EQU   JFCDSRG1
JFCORGIS EQU   JFCDSRG1
JFCTRKBL EQU   JFCLIMCT+1
@NM00105 EQU   JFCLIMCT
JFCDEN   EQU   JFCSPPRT+1
JFCPRTSP EQU   JFCSPPRT
JFCONE   EQU   JFCMODE
JFCTWO   EQU   JFCMODE
JFCRSV07 EQU   JFCMODE
JFCRSV06 EQU   JFCMODE
JFCMODER EQU   JFCMODE
JFCMODEO EQU   JFCMODE
JFCEBCD  EQU   JFCMODE
JFCBIN   EQU   JFCMODE
JFCRSV32 EQU   JFCCODE
JFCTTY   EQU   JFCCODE
JFCASCII EQU   JFCCODE
JFCNCR   EQU   JFCCODE
JFCBUR   EQU   JFCCODE
JFCFRI   EQU   JFCCODE
JFCBCD   EQU   JFCCODE
JFCNOCON EQU   JFCCODE
DXRESIND EQU   @NM00103
DXSAVOFF EQU   @NM00102+7
DXSAVADR EQU   DXSAVMOD+2
DXSAVID  EQU   DXSAVMOD
DXABCODE EQU   @NM00102
DXRETCOD EQU   DXIDENT+7
DXRETTTR EQU   DXRETMOD+2
DXRETID  EQU   DXRETMOD
DXCALLID EQU   DXIDENT
DXREG0   EQU   DXREGSAV+24
DXREGE   EQU   DXREGSAV+20
DXREGD   EQU   DXREGSAV+16
DXREGC   EQU   DXREGSAV+12
DXREGB   EQU   DXREGSAV+8
DXREGA   EQU   DXREGSAV+4
DXREG9   EQU   DXREGSAV
DXXEND   EQU   DXXAREA+48
DXXLAST  EQU   DXXAREA+40
DXXCORE  EQU   DXXENTRY+5
DXETTR   EQU   DXXIDTTR+2
DXEID    EQU   DXXIDTTR
DXXPATHS EQU   DXXAREA+30
DXOPCLSW EQU   DXXLNG
DXXTXTLN EQU   DXXAREA+27
DXXMODSZ EQU   DXXAREA+24
DXXATTRB EQU   DXXAREA+22
@NM00087 EQU   DXXAREA+20
DXXPREFX EQU   DXXAREA+16
@NM00086 EQU   DXXAREA+12
DXXMODEP EQU   DXXAREA+8
DXXMODID EQU   DXXMODNM+6
@NM00085 EQU   DXXMODNM
DXXWTOPR EQU   DXXWTG
PSARSAV  EQU   PSARSVTE+60
PSARSTK  EQU   PSARSVTE+56
PSAESAV3 EQU   PSARSVTE+52
PSAESTK3 EQU   PSARSVTE+48
PSAESAV2 EQU   PSARSVTE+44
PSAESTK2 EQU   PSARSVTE+40
PSAESAV1 EQU   PSARSVTE+36
PSAESTK1 EQU   PSARSVTE+32
PSAPSAV  EQU   PSARSVTE+28
PSAPSTK  EQU   PSARSVTE+24
PSAMSAV  EQU   PSARSVTE+20
PSAMSTK  EQU   PSARSVTE+16
PSASSAV  EQU   PSARSVTE+12
PSASSTK  EQU   PSARSVTE+8
PSANSTK  EQU   PSARSVTE+4
PSACSTK  EQU   PSARSVTE
VGTTCORE EQU   IDAVGTT+32
VGTTOPWA EQU   IDAVGTT+28
VGTTPSB  EQU   IDAVGTT+24
VGTTVUSE EQU   IDAVGTT+20
VGTTBIB  EQU   IDAVGTT+16
VGTTNEXT EQU   IDAVGTT+12
VGTTSIZE EQU   IDAVGTT+8
VGTTSP   EQU   IDAVGTT+7
@NM00114 EQU   IDAVGTT+6
@NM00113 EQU   IDAVGTT+5
@NM00112 EQU   VGTTTYPE
VGTTOPEN EQU   VGTTTYPE
VGTTCTLG EQU   VGTTTYPE
VGTTLSR  EQU   VGTTTYPE
VGTTGSR  EQU   VGTTTYPE
VGTTRSTR EQU   VGTTTYPE
VGTTID   EQU   IDAVGTT
PDPSFI   EQU   IDAPDPRM+36
@NM00111 EQU   IDAPDPRM+35
PDPNOMSG EQU   PDPMSGFL
PDPNOTRC EQU   PDPMSGFL
PDPSPACE EQU   PDPMSGFL
PDPNOTFC EQU   PDPMSGFL
PDPDSTYP EQU   IDAPDPRM+33
PDPKEY   EQU   IDAPDPRM+32
PDPCTACB EQU   IDAPDPRM+28
PDPDSN   EQU   IDAPDPRM+24
PDPCLSNM EQU   IDAPDPRM+20
PDPVLSER EQU   IDAPDPRM+16
PDPTIOT  EQU   IDAPDPRM+12
PDPUCB   EQU   IDAPDPRM+8
PDPACB   EQU   IDAPDPRM+4
PDPSFC   EQU   IDAPDPRM+3
PDPFUNC  EQU   IDAPDPRM+2
PDPCODE  EQU   IDAPDPRM+1
PDPCALL  EQU   IDAPDPRM
JFCBXNXT EQU   JFCBX+172
@NM00110 EQU   JFCBX+144
JFCBXDEV EQU   JFCBX+140
JFCBXNAM EQU   JFCBX+96
@NM00109 EQU   JFCBX+94
JFCBXVOL EQU   JFCBX+4
@NM00108 EQU   JFCBX+3
JFCBXTTR EQU   JFCBX
JFCRSV05 EQU   JFCEROPT
JFCRSV04 EQU   JFCEROPT
JFCRSV03 EQU   JFCEROPT
JFCRSV02 EQU   JFCEROPT
JFCTOPT  EQU   JFCEROPT
JFCABN   EQU   JFCEROPT
JFCSKP   EQU   JFCEROPT
JFCACC   EQU   JFCEROPT
JFCBUFL  EQU   JFCAMPTR+2
JFCFWORD EQU   JFCBFTEK
JFCDWORD EQU   JFCBFTEK
JFCHIER1 EQU   JFCBFTEK
JFCDYN   EQU   JFCBFTEK
JFCEXC   EQU   JFCBFTEK
JFCBBFTR EQU   JFCBBFTA
JFCSIM   EQU   JFCBBFTA
JFCHIER  EQU   JFCBFTEK
JFCBFOUT EQU   JFCBUFNO
JFCBUFIN EQU   JFCBUFNO
JFCTEMP  EQU   JFCBIND2
JFCREQ   EQU   JFCBIND2
JFCENT   EQU   JFCBIND2
JFCSHARE EQU   JFCBIND2
JFCSECUR EQU   JFCBIND2
JFCDISP  EQU   JFCBIND2
JFCPDS   EQU   JFCBIND1
JFCGDG   EQU   JFCBIND1
JFCADDED EQU   JFCBIND1
JFCLOC   EQU   JFCBIND1
JFCRLSE  EQU   JFCBIND1
JFCBXPDT EQU   INFMJFCB+83
JFCBCRDT EQU   INFMJFCB+80
JFCBOPS2 EQU   JFCBMASK+7
JFCRCTLG EQU   JFCBFLG2
JFCBBUFF EQU   JFCBFLG2
JFCTRACE EQU   JFCBFLG2
JFCSDRPS EQU   JFCBFLG2
JFCMODNW EQU   JFCBFLG2
JFCNRPS  EQU   JFCDEFER
JFCOUTOP EQU   JFCBFLG2
JFCINOP  EQU   JFCBFLG2
JFCBPWBP EQU   JFCOPEN
@NM00104 EQU   JFCOPEN
JFCDUAL  EQU   JFCBFLG1
JFCSLDES EQU   JFCBFLG1
JFCSLCRE EQU   JFCBFLG1
JFCSTAND EQU   JFCBFLG1
JFCBOPS1 EQU   JFCBMASK
JFCBVLSQ EQU   INFMJFCB+70
JFCRSV31 EQU   JFCFUNC
JFCFNCBT EQU   JFCFUNC
JFCFNCBX EQU   JFCFUNC
JFCFNCBD EQU   JFCFUNC
JFCFNCBW EQU   JFCFUNC
JFCFNCBP EQU   JFCFUNC
JFCFNCBR EQU   JFCFUNC
JFCFNCBI EQU   JFCFUNC
JFCBFOFL EQU   JFCBUFOF
JFCNL    EQU   JFCBLTYP
JFCSL    EQU   JFCBLTYP
JFCNSL   EQU   JFCBLTYP
JFCSUL   EQU   JFCBLTYP
JFCBLP   EQU   JFCBLTYP
JFCBLTM  EQU   JFCBLTYP
JFCBAL   EQU   JFCBLTYP
JFCRSV38 EQU   JFCBLTYP
JFCVINDX EQU   INFMJFCB+64
JFCNLREC EQU   INFMJFCB+62
JFCBADBF EQU   INFMJFCB+60
JFCAMSTR EQU   JFCBFRID+2
JFCAMCRO EQU   JFCBFRID
JFCBDSCB EQU   INFMJFCB+53
JFCPAT   EQU   JFCBTSDM
JFCNDCB  EQU   JFCBTSDM
JFCNDSCB EQU   JFCBTSDM
JFCNWRIT EQU   JFCBTSDM
JFCTTR   EQU   JFCBTSDM
JFCSDS   EQU   JFCBTSDM
JFCVSL   EQU   JFCBTSDM
JFCCAT   EQU   JFCBTSDM
JFCIPLTX EQU   JFCBELNM
JFCBQNAM EQU   JFCBDSNM
APPNAMID EQU   APPNMTBL+24
APPOFFST EQU   APPENTRY+2
APPCOUNT EQU   APPENTRY
APPSIZE  EQU   APPNMTBL+2
APPBAL   EQU   APPNMTBL
WTGCORE  EQU   WTGENTRY+5
WTGETTR  EQU   WTGIDTTR+2
WTGEID   EQU   WTGIDTTR
WTGOPD   EQU   WTGPATHS+1
WTGRECHK EQU   WTGPATHS+1
WTGTSENQ EQU   WTGPATHS+1
@NM00101 EQU   WTGPATHS+1
WTGTRACE EQU   WTGPATHS+1
@NM00100 EQU   WTGPATHS
WTGJFCBW EQU   WTGPATHS
WTGSMF   EQU   WTGPATHS
WTGTCOS  EQU   WTGPATHS
WTGNSL   EQU   WTGPATHS
WTGPRLSE EQU   WTGPATHS
WTGLNG   EQU   WTG+29
WTGTXTLN EQU   WTGAREA+27
WTGMODSZ EQU   WTGAREA+24
WTGATTRB EQU   WTGAREA+22
@NM00099 EQU   WTGAREA+20
@NM00098 EQU   WTGAREA+12
WTGMODEP EQU   WTGAREA+8
WTGMODID EQU   WTGMODNM+6
@NM00097 EQU   WTGMODNM
DSMADTW6 EQU   DSMADTRL+20
DSMADTW5 EQU   DSMADTRL+16
DSMADTW4 EQU   DSMADTRL+12
DSMADTW3 EQU   DSMADTRL+8
DSMADTW2 EQU   DSMADTRL+4
DSMADTB4 EQU   DSMADTW1+3
DSMADTB3 EQU   DSMADTW1+2
@NM00096 EQU   DSMADTB2
DSMDSNE  EQU   DSMADTB2
DSMTIOTE EQU   DSMADTB2
DSMSMCE  EQU   DSMADTB2
DSMVTOCR EQU   DSMADTB2
DSMASWAP EQU   DSMADTB1
DSMUCBAL EQU   DSMADTB1
DSMRPSAP EQU   DSMADTB1
DSMLOCK  EQU   DSMADTB1
@NM00095 EQU   DSMADTB1
DSMVIO   EQU   DSMADTB1
DSMISAM  EQU   DSMADTB1
RRFWORK  EQU   RRPLIST+20
RRMLRTRY EQU   RRPLIST+16
RRUCBPTR EQU   RRXRETRY
RR1RETRY EQU   RRPLIST+8
RR1WRKAR EQU   RRPLIST+4
@NM00094 EQU   RRFLAGS3
RRFTERM  EQU   RRFLAGS3
RRFFCEXC EQU   RRFLAGS3
RRFFINFC EQU   RRFLAGS3
RRFNRTCA EQU   RRFLAGS3
@NM00093 EQU   RRFLAGS3
RRFENQUL EQU   RRFLAGS2
RRFPRDET EQU   RRFLAGS2
@NM00092 EQU   RRFLAGS2
RRFQMNGR EQU   RRFLAGS2
RRFENQPW EQU   RRFLAGS2
@NM00091 EQU   RRFLAGS2
RRFFIN1  EQU   RRFLAGS2
RRFTRACE EQU   RRFLAGS1
RRFSMF   EQU   RRFLAGS1
RRFNSL   EQU   RRFLAGS1
RRFAMSTR EQU   RRFLAGS1
RRFAMEXR EQU   RRFLAGS1
RRFAMEXG EQU   RRFLAGS1
RRFUSREX EQU   RRFLAGS1
@NM00090 EQU   RRFLAGS1
RRFRJFCB EQU   RRFUNCTN
RRFDADSM EQU   RRFUNCTN
DXDCBLST EQU   USERPRML
RWALIST  EQU   RWARESWA+12
RWAPARM  EQU   RWAPREFX+8
RWATRBUF EQU   RWAPREFX+4
RWATRACE EQU   RWAPREFX
IECQMNGR EQU   IECEXTPR+92
IECMSGQA EQU   IECEXTPR+88
IECDCBNO EQU   IECUPRML
IECRRPRM EQU   IECEXTPR+76
IECREGSV EQU   IECEXTPR
IECCORP2 EQU   IECPREFX+28
IECCORP1 EQU   IECPREFX+24
IECCORPS EQU   IECPREFX+20
IECCORSP EQU   IECPREFX+19
@NM00089 EQU   IECPREFX+17
IECCORKY EQU   IECPREFX+16
IECCORAD EQU   IECPREFX+12
IECCORLN EQU   IECPREFX+8
@NM00088 EQU   IECPREFX+4
IECCORID EQU   IECPREFX
DXATEXB2 EQU   DXATEXC2
DXATEXB1 EQU   DXATEXC1
DXATCOM4 EQU   FORCORE+600
DXATCOM3 EQU   FORCORE+596
@NM00084 EQU   DXATCOM2+3
@NM00083 EQU   DXATALL
DXATSWAP EQU   DXATALL
DXATFC   EQU   DXATALL
@NM00082 EQU   DXATOPEN
DXATDFIN EQU   DXATOPEN
DXATDSIN EQU   DXATOPEN
DXATMODM EQU   DXATOPEN
DXATMODE EQU   DXATOPEN
DXATMODS EQU   DXATOPEN
DXATIGN  EQU   DXATOPEN
DXATVCAT EQU   DXATEOV
DXATDADM EQU   DXATEOV
DXATREMT EQU   DXATEOV
DXATDNEW EQU   DXATEOV
DXATDFRE EQU   DXATEOV
DXATDCHN EQU   DXATEOV
DXATNVOL EQU   DXATEOV
DXATCCAT EQU   DXATEOV
DXATRDDB EQU   DXATDACC
DXATEOF  EQU   DXATDACC
@NM00081 EQU   DXATDACC
DXATSMF  EQU   DXATDACC
DXATUPDB EQU   DXATDACC
DXATDRCT EQU   DXATDACC
DXATTRAK EQU   DXATDACC
DXATF1CE EQU   DXATDACC
DXATNSL  EQU   DXATOUTA
DXATTTM2 EQU   DXATOUTA
DXATTTM1 EQU   DXATOUTA
DXATTRL2 EQU   DXATOUTA
DXATTRL1 EQU   DXATOUTA
DXATDATM EQU   DXATOUTA
DXATHDTM EQU   DXATOUTA
DXATVLHD EQU   DXATOUTA
DXATCLOS EQU   DXATCOM1+1
DXATSRET EQU   DXATGENS
DXATVCIG EQU   DXATVGIV
DXATVTMG EQU   DXATVGIV
DXATVSMG EQU   DXATVGIV
DXATJFCB EQU   DXATGENS
DXATDISP EQU   DXATGENS
DXATREFR EQU   DXATGENS
DXATDMCT EQU   DXATGENS
DXMSGADR EQU   FORCORE+584
DXPRPARC EQU   FORCORE+580
DXUDCBML EQU   FORCORE+578
DXUDCBPL EQU   FORCORE+576
DXPACBAD EQU   DXPDCBAD+1
@NM00080 EQU   DXPDCBAD
DXUACBAD EQU   DXUDCBAD+1
@NM00079 EQU   DXUDCBAD
DXUCBSVV EQU   DXUCBSAV+1
@NM00078 EQU   DXUCBSAV
DXUCBADR EQU   FORCORE+560
DXTIOTAD EQU   FORCORE+556
DXDEBXAD EQU   FORCORE+552
DXDSAB   EQU   FORCORE+548
DXDSABAD EQU   FORCORE+544
DXDSABQD EQU   FORCORE+540
DXJSCBAD EQU   FORCORE+536
DXTCBADR EQU   FORCORE+532
DXASCBAD EQU   FORCORE+528
DXEXTSW  EQU   FORCORE+527
DXUKEY   EQU   FORCORE+526
DXWKEYSV EQU   FORCORE+525
DXUNITOF EQU   FORCORE+522
DXNOUNIT EQU   FORCORE+520
DXVOLSEQ EQU   FORCORE+518
DXVOLMT3 EQU   DXVOLSR3
DXVOLMT2 EQU   DXVOLSR2
DXVOLMT1 EQU   DXVOLSR1
DXWORK4  EQU   FORCORE+496
DXWORK3  EQU   FORCORE+492
DXWORK2  EQU   FORCORE+488
DXWORK1  EQU   FORCORE+484
DXWORK   EQU   FORCORE+480
@NM00077 EQU   FORCORE+464
DXCCW11  EQU   DXCCW+80
DXCCW10  EQU   DXCCW+72
DXCCW9   EQU   DXCCW+64
DXCCW7   EQU   DXCCW+48
DXCCW6   EQU   DXCCW+40
DXCCW4   EQU   DXCCW+24
DXCCW3   EQU   DXCCW+16
DXCCW2   EQU   DXCCW+8
DXCCW1   EQU   DXCCW
DXDCBDEB EQU   DXDCB+44
@NM00076 EQU   DXDCB+24
DXDEBDCB EQU   DXDCB+20
@NM00075 EQU   DXDCB
DXDEB    EQU   DXDAADDR+4
@NM00074 EQU   DXDAADDR
DXECB    EQU   FORCORE+276
DSCCORE  EQU   FORCORE+96
DXLBL    EQU   DXDSCB
@NM00073 EQU   SDWA+512
@NM00072 EQU   SDWADPVA
SDWAHEX  EQU   SDWADPVA
SDWAVRAL EQU   SDWARA
@NM00071 EQU   SDWA+396
SDWACOMP EQU   SDWA+392
SDWARCPL EQU   SDWA+364
@NM00070 EQU   SDWADPSA+32
SDWATO4  EQU   SDWADPSL+28
SDWAFRM4 EQU   SDWADPSL+24
SDWATO3  EQU   SDWADPSL+20
SDWAFRM3 EQU   SDWADPSL+16
SDWATO2  EQU   SDWADPSL+12
SDWAFRM2 EQU   SDWADPSL+8
SDWATO1  EQU   SDWADPSL+4
SDWAFRM1 EQU   SDWADPSL
@NM00069 EQU   SDWADDAT+3
@NM00068 EQU   SDWAPDAT
SDWAUSPL EQU   SDWAPDAT
SDWADPSW EQU   SDWAPDAT
SDWATJPA EQU   SDWAPDAT
SDWATLPA EQU   SDWAPDAT
SDWADREG EQU   SDWAPDAT
SDWADSAH EQU   SDWAPDAT
SDWADSAS EQU   SDWAPDAT
@NM00067 EQU   SDWADDAT+1
@NM00066 EQU   SDWASDAT
SDWAQQS  EQU   SDWASDAT
SDWACBS  EQU   SDWASDAT
SDWAGTF  EQU   SDWASDAT
SDWASWA  EQU   SDWASDAT
SDWALSQA EQU   SDWASDAT
SDWASQA  EQU   SDWASDAT
SDWANUC  EQU   SDWASDAT
@NM00065 EQU   SDWADUMP+2
@NM00064 EQU   SDWADPFS
SDWASLST EQU   SDWADPFS
@NM00063 EQU   SDWADPFS
SDWADLST EQU   SDWADPFS
SDWADPT  EQU   SDWADPFS
SDWADPID EQU   SDWADUMP
SDWADPLA EQU   SDWA+316
SDWAREXN EQU   SDWARECP+16
SDWAMODN EQU   SDWARECP
@NM00062 EQU   SDWALKWA+32
SDWATALW EQU   SDWALKWS+28
SDWATDLW EQU   SDWALKWS+24
SDWATNLW EQU   SDWALKWS+20
SDWAAPLW EQU   SDWALKWS+16
SDWAIPLW EQU   SDWALKWS+12
SDWAILLW EQU   SDWALKWS+8
SDWAIULW EQU   SDWALKWS+4
SDWAICLW EQU   SDWALKWS
SDWAFLLK EQU   SDWAACF4
SDWACMS  EQU   SDWAACF4
SDWAOPTM EQU   SDWAACF4
SDWATADB EQU   SDWAACF4
SDWATDNB EQU   SDWAACF4
SDWATNCB EQU   SDWAACF4
SDWAILCH EQU   SDWAACF4
SDWAIUCB EQU   SDWAACF4
SDWAICAT EQU   SDWAACF3
SDWAIPRG EQU   SDWAACF3
SDWASALL EQU   SDWAACF3
SDWAASMP EQU   SDWAACF3
SDWADISP EQU   SDWAACF3
@NM00061 EQU   SDWAACF3
@NM00060 EQU   SDWAACF2
@NM00059 EQU   SDWAACF2
SDWASPIN EQU   SDWAACF2
@NM00058 EQU   SDWAACF2
SDWARCRD EQU   SDWAACF2
SDWALCPU EQU   SDWACPUA+2
@NM00057 EQU   SDWACPUA
SDWARECA EQU   SDWA+244
@NM00056 EQU   SDWA+239
@NM00055 EQU   SDWAIOFS
SDWANIOP EQU   SDWAIOFS
SDWANOIO EQU   SDWAIOFS
SDWAIOHT EQU   SDWAIOFS
SDWAIOQR EQU   SDWAIOFS
SDWAFMID EQU   SDWA+236
@NM00054 EQU   SDWAERRD
SDWAMCIV EQU   SDWAERRD
SDWARPIV EQU   SDWAERRD
SDWAMABD EQU   SDWAERRD
SDWACTS  EQU   SDWAERRD
SDWASTAE EQU   SDWAERRD
SDWANRBE EQU   SDWAERRD
@NM00053 EQU   SDWAERRC
SDWAEAS  EQU   SDWAERRC
SDWAPERC EQU   SDWAERRC
SDWAIRB  EQU   SDWAERRC
SDWASTAI EQU   SDWAERRC
SDWASTAF EQU   SDWAERRC
SDWASRBM EQU   SDWAERRB
SDWALDIS EQU   SDWAERRB
SDWAENRB EQU   SDWAERRB
SDWATYP1 EQU   SDWAERRB
@NM00052 EQU   SDWAERRB
SDWASVCE EQU   SDWAERRA
SDWAABTM EQU   SDWAERRA
SDWASVCD EQU   SDWAERRA
SDWATIME EQU   SDWAMCH+20
SDWARFSA EQU   SDWAMCH+16
@NM00051 EQU   SDWAMCH+14
SDWAVEQR EQU   SDWARSR2
SDWAPGFX EQU   SDWARSR2
SDWAFLSQ EQU   SDWARSR2
SDWAFSQA EQU   SDWARSR2
SDWANUCL EQU   SDWARSR2
SDWASPER EQU   SDWARSR2
SDWAINTC EQU   SDWARSR2
SDWAOFLN EQU   SDWARSR2
SDWACHNG EQU   SDWARSR1
SDWAMSER EQU   SDWARSR1
@NM00050 EQU   SDWARSR1
SDWACPID EQU   SDWAMCH+10
SDWATERR EQU   SDWAMCHD
SDWAFPRX EQU   SDWAMCHD
SDWAINSF EQU   SDWAMCHD
SDWAACR  EQU   SDWAMCHD
SDWASCK  EQU   SDWAMCHD
SDWAPSWU EQU   SDWAMCHD
SDWAREGU EQU   SDWAMCHD
SDWASKYF EQU   SDWAMCHD
@NM00049 EQU   SDWAMCHS
SDWARSRF EQU   SDWAMCHS
SDWARSRC EQU   SDWAMCHS
SDWAINVP EQU   SDWAMCHS
SDWATSVL EQU   SDWAMCHS
SDWARCDF EQU   SDWAMCHS
SDWASRVL EQU   SDWAMCHS
SDWASCKE EQU   SDWASTCK+4
SDWASCKB EQU   SDWASTCK
SDWALNTH EQU   SDWAIDNT+1
SDWASPID EQU   SDWAIDNT
SDWASR15 EQU   SDWASRSV+60
SDWASR14 EQU   SDWASRSV+56
SDWASR12 EQU   SDWASRSV+48
SDWASR11 EQU   SDWASRSV+44
SDWASR10 EQU   SDWASRSV+40
SDWASR09 EQU   SDWASRSV+36
SDWASR08 EQU   SDWASRSV+32
SDWASR07 EQU   SDWASRSV+28
SDWASR06 EQU   SDWASRSV+24
SDWASR05 EQU   SDWASRSV+20
SDWASR02 EQU   SDWASRSV+8
SDWASR01 EQU   SDWASRSV+4
SDWASR00 EQU   SDWASRSV
SDWATRN2 EQU   SDWAAEC2+4
SDWAIPC2 EQU   SDWAICD2
SDWAIMC2 EQU   SDWAICD2
SDWAIPR2 EQU   SDWAICD2
@NM00048 EQU   SDWAINC2
@NM00047 EQU   SDWAILC2
SDWAIL2  EQU   SDWAILC2
@NM00046 EQU   SDWAILC2
@NM00045 EQU   SDWAAEC2
SDWAADD2 EQU   SDWANXT2+1
@NM00044 EQU   SDWANXT2
@NM00043 EQU   SDWAEC2+3
SDWASGN2 EQU   SDWAINT2
SDWAEXP2 EQU   SDWAINT2
SDWADEC2 EQU   SDWAINT2
SDWAFPO2 EQU   SDWAINT2
SDWACC2  EQU   SDWAINT2
@NM00042 EQU   SDWAINT2
SDWAPGM2 EQU   SDWAMWP2
SDWAWAT2 EQU   SDWAMWP2
SDWAMCK2 EQU   SDWAMWP2
SDWAECT2 EQU   SDWAMWP2
SDWAKEY2 EQU   SDWAMWP2
SDWAEXT2 EQU   SDWAEMK2
SDWAIO2  EQU   SDWAEMK2
SDWATRM2 EQU   SDWAEMK2
@NM00041 EQU   SDWAEMK2
SDWAPER2 EQU   SDWAEMK2
@NM00040 EQU   SDWAEMK2
SDWATRAN EQU   SDWAAEC1+4
SDWAIPC1 EQU   SDWAICD1
SDWAIMC1 EQU   SDWAICD1
SDWAIPR1 EQU   SDWAICD1
@NM00039 EQU   SDWAINC1
@NM00038 EQU   SDWAILC1
SDWAIL1  EQU   SDWAILC1
@NM00037 EQU   SDWAILC1
@NM00036 EQU   SDWAAEC1
@NM00035 EQU   SDWANXT1
@NM00034 EQU   SDWAEC1+3
SDWASGN1 EQU   SDWAINT1
SDWAEXP1 EQU   SDWAINT1
SDWADEC1 EQU   SDWAINT1
SDWAFPO1 EQU   SDWAINT1
SDWACC1  EQU   SDWAINT1
@NM00033 EQU   SDWAINT1
SDWAPGM1 EQU   SDWAMWP1
SDWAWAT1 EQU   SDWAMWP1
SDWAMCK1 EQU   SDWAMWP1
SDWAECT1 EQU   SDWAMWP1
SDWAKEY1 EQU   SDWAMWP1
SDWAEXT1 EQU   SDWAEMK1
SDWAIO1  EQU   SDWAEMK1
SDWATRM1 EQU   SDWAEMK1
@NM00032 EQU   SDWAEMK1
SDWAPER1 EQU   SDWAEMK1
@NM00031 EQU   SDWAEMK1
SDWAIOBR EQU   SDWA+100
SDWAEPA  EQU   SDWA+96
@NM00030 EQU   SDWANAME+4
SDWARBAD EQU   SDWANAME
SDWAGR14 EQU   SDWAGRSV+56
SDWAGR13 EQU   SDWAGRSV+52
SDWAGR12 EQU   SDWAGRSV+48
SDWAGR11 EQU   SDWAGRSV+44
SDWAGR10 EQU   SDWAGRSV+40
SDWAGR09 EQU   SDWAGRSV+36
SDWAGR08 EQU   SDWAGRSV+32
SDWAGR07 EQU   SDWAGRSV+28
SDWAGR06 EQU   SDWAGRSV+24
SDWAGR05 EQU   SDWAGRSV+20
SDWAGR04 EQU   SDWAGRSV+16
SDWAGR03 EQU   SDWAGRSV+12
SDWAGR02 EQU   SDWAGRSV+8
SDWAGR01 EQU   SDWAGRSV+4
SDWAGR00 EQU   SDWAGRSV
SDWANXTP EQU   SDWACTL2+5
SDWASGP  EQU   SDWAPMKP
SDWAEUP  EQU   SDWAPMKP
SDWADOP  EQU   SDWAPMKP
SDWAFPP  EQU   SDWAPMKP
SDWACCP  EQU   SDWAPMKP
SDWAILP  EQU   SDWAPMKP
SDWAINTP EQU   SDWACTL2+2
SDWASPVP EQU   SDWAMWPP
SDWAWATP EQU   SDWAMWPP
SDWAMCKP EQU   SDWAMWPP
@NM00029 EQU   SDWAMWPP
SDWAKEYP EQU   SDWAMWPP
SDWAEXTP EQU   SDWACMKP
SDWAIOP  EQU   SDWACMKP
SDWANXTA EQU   SDWACTL1+5
SDWASGA  EQU   SDWAPMKA
SDWAEUA  EQU   SDWAPMKA
SDWADOA  EQU   SDWAPMKA
SDWAFPA  EQU   SDWAPMKA
SDWACCA  EQU   SDWAPMKA
SDWAILA  EQU   SDWAPMKA
SDWAINTA EQU   SDWACTL1+2
SDWASPVA EQU   SDWAMWPA
SDWAWATA EQU   SDWAMWPA
SDWAMCKA EQU   SDWAMWPA
@NM00028 EQU   SDWAMWPA
SDWAKEYA EQU   SDWAMWPA
SDWAEXTA EQU   SDWACMKA
SDWAIOA  EQU   SDWACMKA
SDWACMPC EQU   SDWAABCC+1
@NM00027 EQU   SDWACMPF
SDWASTCC EQU   SDWACMPF
@NM00026 EQU   SDWACMPF
SDWASTEP EQU   SDWACMPF
SDWAREQ  EQU   SDWACMPF
RSTIOT   EQU   RSTWA+440
RSTIOTL  EQU   RSTWA+432
RSREGSAV EQU   RSTWA+360
RSERAS09 EQU   RSTWA+356
RSERAS08 EQU   RSTWA+352
RSERAS07 EQU   RSTWA+348
RSERAS06 EQU   RSTWA+344
RSERAS05 EQU   RSTWA+340
RSERAS04 EQU   RSTWA+336
RSERAS03 EQU   RSTWA+332
RSERAS02 EQU   RSTWA+328
RSERAS01 EQU   RSTWA+324
RSERAS00 EQU   RSTWA+320
RSIOBCP  EQU   RSTWA+200
RSIOBPT1 EQU   RSTWA+196
RSAREA1  EQU   RSTWA+192
RSDCBAD1 EQU   RSDCB
RSLNGTH1 EQU   XCTLNAM1+6
RSTYPE1  EQU   XCTLNAM1+4
RSDECB1  EQU   RSECB1
RSBDCB   EQU   RSTWA+92
RSSSCR   EQU   RSTWA+88
RSPIE    EQU   RSTWA+84
RSNSTAE  EQU   RSTWA+80
RSSVRB   EQU   RSTWA+76
@NM00025 EQU   RSTWA+74
RSRETCD1 EQU   RSRETCOD
RSDCBSI  EQU   RSTWA+70
RSFLAG2  EQU   RSTWA+69
RSFLAG1  EQU   RSTWA+68
RSSVRBN  EQU   RSTWA+64
RSCIRTTR EQU   RSTWA+60
RSTIOTAD EQU   RSTWA+56
RSTIOTO  EQU   RSTWA+52
RSPPEL   EQU   RSTWA+48
RSPPML   EQU   RSTWA+44
RSPPE    EQU   RSTWA+40
RSPPM    EQU   RSTWA+36
RSTCBAD  EQU   RSTWA+32
RSINT    EQU   RSTWA+28
RSDCBFLG EQU   RSDCBL
RSBUFL   EQU   RSTWA+20
RSWACL   EQU   RSTWA+16
RSCKDCB  EQU   RSTWA+12
RSBFOFST EQU   RSTWA+8
RSMWOFST EQU   RSTWA+4
RSWAOFST EQU   RSTWA
CKJCT    EQU   CHKWA+256
CKREGSAV EQU   CHKWA+184
CKERAS09 EQU   CHKWA+180
CKERAS08 EQU   CHKWA+176
CKERAS07 EQU   CHKWA+172
CKERAS06 EQU   CHKWA+168
CKERAS05 EQU   CHKWA+164
CKERAS04 EQU   CHKWA+160
CKERAS03 EQU   CHKWA+156
CKERAS02 EQU   CHKWA+152
CKERAS01 EQU   CHKWA+148
CKERAS00 EQU   CHKWA+144
CKJCTMB  EQU   CHKWA+136
CKTTR    EQU   CHKWA+132
CKCHEKID EQU   CHKWA+121
CKVOLSER EQU   CHKWA+115
CKDDNAME EQU   CHKWA+107
CKUNIT   EQU   CHKWA+104
CKPARMAD EQU   CHKWA+100
CKSYNAD  EQU   CHKWA+96
CKINT    EQU   CHKWA+92
CKIOBPT2 EQU   CKDECB2+16
CKAREA2  EQU   CKDECB2+12
CKDCBAD2 EQU   CKDECB2+8
CKLNGTH2 EQU   CKDECB2+6
CKTYPE2  EQU   CKDECB2+4
CKECB2   EQU   CKDECB2
CKIOBPT1 EQU   CKDECB1+16
CKAREA1  EQU   CKDECB1+12
CKDCBAD  EQU   CKDCBAD1
CKLNGTH1 EQU   XCTLNAME+6
CKTYPE1  EQU   XCTLNAME+4
CKECB1   EQU   XCTLNAME
CKSSCR   EQU   CHKWA+48
CKMSGCD1 EQU   CKMSGCOD
CKRETCD1 EQU   CKRETCOD
CKDCBSI  EQU   CHKWA+42
CKFLAG2  EQU   CHKWA+41
CKFLAG1  EQU   CHKWA+40
CKTIOLN  EQU   CHKWA+36
CKPPEL   EQU   CHKWA+32
CKPPML   EQU   CHKWA+28
CKPPE    EQU   CHKWA+24
CKPPM    EQU   CHKWA+20
CKTCBAD  EQU   CHKWA+16
CKBUFL   EQU   CHKWA+12
CKWACL   EQU   CHKWA+8
CKBFOFST EQU   CHKWA+4
CKWAOFST EQU   CHKWA
@NM00024 EQU   PSA+3668
PSASTAK  EQU   PSA+3072
@NM00023 EQU   PSA+1040
PSAUSEND EQU   PSA+1040
PSARV062 EQU   PSA+1036
PSAATCVT EQU   PSA+1032
PSAPCPSW EQU   PSA+1024
PSAPIR2  EQU   PSA+1020
PSARV059 EQU   PSA+1018
PSASVC13 EQU   PSA+1016
PSALSFCC EQU   PSA+1012
PSASFACC EQU   PSA+1008
PSASTOP  EQU   PSA+992
PSASTART EQU   PSA+976
PSARSPSW EQU   PSA+968
PSASRPSW EQU   PSA+960
PSARV045 EQU   PSA+892
PSARV044 EQU   PSA+888
PSARV043 EQU   PSA+884
PSARV042 EQU   PSA+880
PSARV041 EQU   PSA+876
PSARV040 EQU   PSA+872
PSARV025 EQU   PSA+868
PSADSSED EQU   PSA+868
PSADSSPR EQU   PSA+864
PSADSSFW EQU   PSA+860
PSADSS14 EQU   PSA+856
PSADSSPP EQU   PSA+848
PSADSSRP EQU   PSA+840
PSADSS05 EQU   PSADSSF4
PSADSS10 EQU   PSADSSF4
PSADSSVE EQU   PSADSSF4
PSADSSDE EQU   PSADSSF4
PSADSSC0 EQU   PSADSSF4
PSADSSIE EQU   PSADSSF4
PSADSS12 EQU   PSADSSF4
PSADSSRC EQU   PSADSSF4
PSARV057 EQU   PSADSSF3
PSARV056 EQU   PSADSSF3
PSARV055 EQU   PSADSSF3
PSADSSMC EQU   PSADSSF3
PSADSSRW EQU   PSADSSF3
PSADSSNM EQU   PSADSSF3
PSADSSES EQU   PSADSSF3
PSADSSGP EQU   PSADSSF3
PSADSSF2 EQU   PSADSSFL+1
PSADSSPI EQU   PSADSSF1
PSADSSOI EQU   PSADSSF1
PSADSSSP EQU   PSADSSF1
PSADSSTP EQU   PSADSSF1
PSADSSDW EQU   PSADSSF1
PSADSSDD EQU   PSADSSF1
PSADSSDM EQU   PSADSSF1
PSADSSMV EQU   PSADSSF1
PSADSSTS EQU   PSA+816
PSADSSWK EQU   PSA+812
PSADSSR3 EQU   PSA+808
PSADSSR2 EQU   PSA+804
PSADSSRS EQU   PSA+800
PSASTOR  EQU   PSA+796
PSACPUSA EQU   PSA+794
PSAVSTAP EQU   PSA+792
PSAWKVAP EQU   PSA+788
PSAWKRAP EQU   PSA+784
PSAMCHIC EQU   PSA+783
PSARV061 EQU   PSA+782
PSASYMSK EQU   PSA+781
PSAMCHFL EQU   PSA+780
PSACR0   EQU   PSA+776
PSAPSWSV EQU   PSA+768
PSALITA  EQU   PSA+764
PSACLHS  EQU   PSAHLHI
PSALKR15 EQU   PSALKSA+60
PSALKR14 EQU   PSALKSA+56
PSALKR13 EQU   PSALKSA+52
PSALKR12 EQU   PSALKSA+48
PSALKR11 EQU   PSALKSA+44
PSALKR10 EQU   PSALKSA+40
PSALKR9  EQU   PSALKSA+36
PSALKR8  EQU   PSALKSA+32
PSALKR7  EQU   PSALKSA+28
PSALKR6  EQU   PSALKSA+24
PSALKR5  EQU   PSALKSA+20
PSALKR4  EQU   PSALKSA+16
PSALKR3  EQU   PSALKSA+12
PSALKR2  EQU   PSALKSA+8
PSALKR1  EQU   PSALKSA+4
PSALKR0  EQU   PSALKSA
PSARV023 EQU   PSACLHT+52
PSALOCAL EQU   PSACLHT+48
PSACMSL  EQU   PSACLHT+44
PSAOPTL  EQU   PSACLHT+40
PSATPACL EQU   PSACLHT+36
PSATPDNL EQU   PSACLHT+32
PSATPNCL EQU   PSACLHT+28
PSAIOSLL EQU   PSACLHT+24
PSAIOSUL EQU   PSACLHT+20
PSAIOSCL EQU   PSACLHT+16
PSAIOSSL EQU   PSACLHT+12
PSASALCL EQU   PSACLHT+8
PSAASML  EQU   PSACLHT+4
PSADISPL EQU   PSACLHT
PSASRSA  EQU   PSA+636
PSARV050 EQU   PSA+634
PSADSSGO EQU   PSA+633
PSARECUR EQU   PSA+632
PSAHLHIS EQU   PSA+628
PSAIPCSA EQU   PSA+624
@NM00022 EQU   PSA+621
PSAIPCDM EQU   PSA+620
PSAIPCD  EQU   PSA+616
@NM00021 EQU   PSA+613
PSAIPCRM EQU   PSA+612
PSAIPCR  EQU   PSA+608
PSAMCHEX EQU   PSA+600
PSAMPSW  EQU   PSA+592
PSAEXPS2 EQU   PSA+584
PSAEXPS1 EQU   PSA+576
PSAPIREG EQU   PSA+572
PSARSREG EQU   PSA+568
PSAGPREG EQU   PSA+556
PSARV022 EQU   PSASUP4
PSARV021 EQU   PSASUP4
PSARV020 EQU   PSASUP4
PSARV019 EQU   PSASUP4
PSARV018 EQU   PSASUP4
PSARV017 EQU   PSASUP4
PSARV016 EQU   PSASUP4
PSARV015 EQU   PSASUP4
PSARV014 EQU   PSASUP3
PSARV013 EQU   PSASUP3
PSARV012 EQU   PSASUP3
PSARV011 EQU   PSASUP3
PSARV010 EQU   PSASUP3
PSAPSREG EQU   PSASUP3
PSAPI2   EQU   PSASUP3
PSAIOSUP EQU   PSASUP3
PSALCR   EQU   PSASUP2
PSARTM   EQU   PSASUP2
PSAACR   EQU   PSASUP2
PSAIPCE2 EQU   PSASUP2
PSAIPCES EQU   PSASUP2
PSAIPCEC EQU   PSASUP2
PSAGTF   EQU   PSASUP2
PSAIPCRI EQU   PSASUP2
PSAIPCRP EQU   PSASUP1
PSAIPCDR EQU   PSASUP1
PSADISP  EQU   PSASUP1
PSALOCK  EQU   PSASUP1
PSAPI    EQU   PSASUP1
PSAEXT   EQU   PSASUP1
PSASVC   EQU   PSASUP1
PSAIO    EQU   PSASUP1
PSAAOLD  EQU   PSA+548
PSAANEW  EQU   PSA+544
PSATOLD  EQU   PSA+540
PSATNEW  EQU   PSA+536
PSALCCAR EQU   PSA+532
PSALCCAV EQU   PSA+528
PSAPCCAR EQU   PSA+524
PSAPCCAV EQU   PSA+520
PSACPULA EQU   PSA+518
PSACPUPA EQU   PSA+516
PSAPSA   EQU   PSA+512
FLCHDEND EQU   PSA+512
FLCCRSAV EQU   FLCMCLA+280
FLCGRSAV EQU   FLCMCLA+216
FLCFPSAV EQU   FLCMCLA+184
FLCFLA   EQU   FLCMCLA+88
FLCRGNCD EQU   FLCMCLA+84
FLCFSAA  EQU   FLCFSA+1
@NM00020 EQU   FLCFSA
@NM00019 EQU   FLCMCLA+72
FLCMCIC  EQU   FLCMCLA+64
@NM00018 EQU   FLCMCLA+20
FLCIOAA  EQU   FLCIOA+1
@NM00017 EQU   FLCIOA
@NM00016 EQU   FLCMCLA+15
@NM00015 EQU   FLCMCLA+14
@NM00014 EQU   FLCMCLA+12
FLCLCL   EQU   FLCMCLA+8
FLCIOELA EQU   FLCIOEL+1
@NM00013 EQU   FLCIOEL
FLCCHNID EQU   FLCMCLA
@NM00012 EQU   PSA+160
FLCMTRCD EQU   PSA+157
@NM00011 EQU   PSA+156
FLCPERA  EQU   FLCPER+1
@NM00010 EQU   FLCPER
@NM00009 EQU   PSA+151
FLCPERCD EQU   PSA+150
FLCMCNUM EQU   PSA+149
@NM00008 EQU   PSA+148
FLCTEAA  EQU   FLCTEA+1
@NM00007 EQU   FLCTEA
PSAPIPC  EQU   PSAPICOD
PSAPIMC  EQU   PSAPICOD
PSAPIPER EQU   PSAPICOD
PSARV049 EQU   FLCPICOD
FLCPILCB EQU   FLCPIILC
@NM00006 EQU   FLCPIILC
@NM00005 EQU   PSAEPPSW
FLCSVCN  EQU   PSAESPSW+2
FLCSILCB EQU   FLCSVILC
@NM00004 EQU   FLCSVILC
@NM00003 EQU   PSAESPSW
FLCEICOD EQU   PSAEEPSW+2
PSASPAD  EQU   PSAEEPSW
@NM00002 EQU   PSA+128
FLCINPSW EQU   PSA+120
FLCMNPSW EQU   PSA+112
FLCPNPSW EQU   PSA+104
FLCSNPSW EQU   PSA+96
FLCENPSW EQU   PSA+88
FLCTRACE EQU   PSA+84
FLCTIMER EQU   PSA+80
FLCCVT2  EQU   PSA+76
FLCCAW   EQU   PSA+72
FLCCSW   EQU   PSA+64
FLCIOPSW EQU   PSA+56
FLCMOPSW EQU   PSA+48
FLCPOPSW EQU   PSA+40
FLCSOPSW EQU   PSA+32
FLCEOPSW EQU   PSA+24
@NM00001 EQU   FLCICCW2+4
FLCCVT   EQU   FLCICCW2
FLCICCW1 EQU   FLCROPSW
FLCIPPSW EQU   FLCRNPSW
.@UNREFD ANOP                          END UNREFERENCED COMPONENTS
@ENDDATA EQU   *
         END   IDACKRA1,(C'PLS1255',0602,75042)
