 /********************************************************************/
 /*                                                                  */
 /*   MACRO NAME = IDACLWRK                                          */
 /*                                                                  */
 /*   DESCRIPTIVE NAME = VSAM CLOSE AND T-CLOSE ACB WORK AREA.       */
 /*                                                                  */
 /*   FUNCTION = THE ACB WORK AREA IS USED FOR INTERNAL COMMUNICATION*/
 /*              WITHIN THE CLOSE MODULES AND THE T-CLOSE MODULES.   */
 /*                                                                  */
 /*   CONTROL BLOCK STRUCTURE = THE IDACLWRK IS POINTED TO BY        */
 /*                             REGISTER 4 (RCORE).                  */
 /*                                                                  */
 /*   INCLUDED MACROS = NONE                                         */
 /*                                                                  */
 /*   METHOD OF ACCESS = PL/S - NO DECLARES NECESSARY.               */
 /*                                                                  */
 /*   CREATED BY: VSAM CLOSE MODULE IDA0200T.                        */
 /*               VSAM T-CLOSE MODULE IDA0231T.                      */
 /*                                                                  */
 /*   STATUS = VS1 RELEASE 4, VS2 RELEASE 3.                         */
 /*                                                                  */
 /*   DATE OF LAST CHANGE = 22 NOVEMBER 74                   @Z30SSRL*/
 /*                                                                  */
 /********************************************************************/
    DCL
      1 IDACLWRK BASED(RCORE),      /* ACB WORK AREA                 */
       2 CLWID CHAR(8),             /* CLOSE ACB WK AREA ID  @Z30SSRL*/
       2 CLWCOMWK PTR(31),          /* ADDRESS OF COMMON WORK AREA   */
       2 CLWAMBPT PTR(31),          /* CURRENT AMB POINTER           */
       2 CLWSFI CHAR(12),           /* SUB FUNCTION INFORMATION AREA */
       2 CLWBNOFL BIT(1),           /* INDICATE NO BUFFER FLUSH      */
       2 CLWCNOUP BIT(1),           /* INDICATE NO CATALOG UPDATE    */
       2 CLWNWRIT BIT(1),           /* INDICATE NO WRTBFR            */
       2 CLWPATH BIT(1),            /* INDICATE PATH PROCESSING      */
       2 CLWSPHCL BIT(1),           /* INDICATE CLOSE ENTIRE SPHERE  */
       2 CLWDUMMY BIT(1),           /* INDICATE DUMMY DATA SET       */
       2 CLWOUTPT BIT(1),           /* INDICATE BASE DATA SET OPENNED
                                       FOR OUTPUT                    */
       2 CLWPARCL BIT(1),           /* INDICATE PARTIAL CLOSE        */
       2 CLWPRMCL BIT(1),           /* INDICATE PRIMARY CLOSE        */
       2 CLWSECCL BIT(1),           /* INDICATE SECONDARY CLOSE      */
       2 CLWGMAIN BIT(1),           /* IND MODULE WORK AREA BUILT    */
       2 CLWTERM  BIT(1);           /* INDICATE TERMINATING ERROR IN
                                       IDA0200B                      */
