 /********************************************************************/
 /*                                                                  */
 /*   MACRO NAME = IDACMB                                            */
 /*                                                                  */
 /*   DESCRIPTIVE NAME = CLUSTER MANAGEMENT BLOCK.                   */
 /*                                                                  */
 /*   FUNCTION = THE CMB POINTS TO CORE BLOCK HEADERS WHICH REFLECT  */
 /*              GOTTEN CORE FOR AN ESDS OR A KSDS CONTROL BLOCK     */
 /*              STRUCTURE.                                          */
 /*                                                                  */
 /*   CONTROL BLOCK STRUCTURE = POINTED TO BY THE AMBL (AMBLCMB).    */
 /*                                                                  */
 /*   INCLUDED MACROS = NONE                                         */
 /*                                                                  */
 /*   METHOD OF ACCESS = PL/S - RESPECIFY IDACMB BASED.              */
 /*                                                                  */
 /*   CREATED BY: VSAM OPEN MODULE IDA0192F.                         */
 /*                                                                  */
 /*   STATUS = VS2 RELEASE 3.                                        */
 /*                                                                  */
 /*   DATE OF LAST CHANGE = 10/22/74                                 */
 /*                                                                  */
 /********************************************************************/
 DCL 1 IDACMB BASED,                /* CLUSTER MANAGEMENT BLOCK      */
       2 CMBID    CHAR(1),          /* CONTROL BLOCK ID              */
       2 *        CHAR(1),          /* UNUSED                        */
       2 CMBLEN   FIXED(15),        /* LENGTH OF CMB                 */
       2 CMBFLGS BIT(8),            /* INDICATOR FLAGS               */
         3 CMBOUT BIT(1),           /* STRUCTURE ALLOWS OUTPUT       */
       2 CMBNST CHAR(1),            /* NUMBER OF STRINGS             */
       2 CMBCNT   FIXED(15),        /* NUMBER OF ENTRIES IN CMB      */
       2 CMBPTRS,                   /* PTR'S TO STORAGE BLOCKS       */
         3 CMBUSRPT PTR(31),        /* USER BLOCK HEADER             */
         3 CMBPRPTR PTR(31),        /* PROTECT BLOCK HEADER          */
         3 CMBSTPTR PTR(31),        /* NON-PROTECTED STRING BLK HDR  */
         3 CMBUSPTR PTR(31),        /* NON-PROT UPGR STRING BLK HDR  */
         3 CMBFSTPT PTR(31),        /* VS2 - GLOBAL FIXED STRING BLOCK
                                       HEADER                @ZA04718*/
         3 CMBUFSPT PTR(31),        /* VS2 - GLOBAL UPGRADE FIXED
                                       STRING BLOCK HEADER   @ZA04718*/
         3 CMBBFRPT PTR(31),        /* BUFFER BLOCK HEADER           */
         3 CMBUBFPT PTR(31),        /* UPGRADE BUFFER BLOCK HEADER   */
         3 CMBDEBPT PTR(31),        /* DEB BLOCK HEADER              */
         3 CMBEDBPT PTR(31),        /* EDB BLOCK HEADER              */
         3 CMBPSTPT PTR(31),        /* VS2 - PROTECTED STRING BLK HDR*/
         3 CMBPUSPT PTR(31),        /* VS2 - PROT UPGR STRING BLK HDR*/
         3 CMBFXDPT PTR(31),        /* FIXED BLOCK HEADER    @ZA04718*/
         3 * PTR(31);               /* RESERVED              @ZA04718*/
