 /********************************************************************/
 /*                                                                  */
 /*   MACRO NAME = IDACSL                                            */
 /*                                                                  */
 /*   DESCRIPTIVE NAME = CORE SAVE LIST.                             */
 /*                                                                  */
 /*   FUNCTION = IDACSL DEFINES THE STRUCTURE OF THE CORE SAVE LIST. */
 /*              ALL SUCCESSFUL GETMAINS FOR VIRTUAL STORAGE WHICH   */
 /*              ARE NOT NORMALLY FREED DURING OPEN TERMINATION ARE  */
 /*              RECORED IN THIS LIST.  ADDITIONAL LISTS ARE CHAINED */
 /*              AS REQUIRED.                                        */
 /*                                                                  */
 /*   CONTROL BLOCK STRUCTURE = POINTED TO BY THE OPEN ACB WORK AREA.*/
 /*                                                                  */
 /*   INCLUDED MACROS = NONE                                         */
 /*                                                                  */
 /*   METHOD OF ACCESS = PL/S - RESPECIFY IDACSL AND CSLENTRY BASED. */
 /*                                                                  */
 /*   CREATED BY: VSAM OPEN MODULE IDA0192M.                         */
 /*                                                                  */
 /*   STATUS = VS2 RELEASE 4                                 @Z40ESSR*/
 /*                                                                  */
 /*   DATE OF LAST CHANGE = 01/31/75                         @Z40ESSR*/
 /*                                                                  */
 /********************************************************************/
    DCL 1 IDACSL BASED,             /* CORE SAVE LIST                */
          2 CSLR0,                  /* USED TO LOAD FREEMAIN REG 0   */
            3 CSLSUBPL FIXED (8),   /* SUBPOOL NUMBER OF THIS CSL    */
            3 CSLLENTH FIXED (24),  /* LENGTH IN BYTES OF THIS CSL   */
          2 CSLID    CHAR (8),      /* BLOCK IDENTIFIER              */
          2 CSLNXPTR PTR (31),      /* PTR TO NEXT CSL OR 0 IF LAST
                                       CSL IN CHAIN                  */
          2 CSLACTEN FIXED (15),    /* NUMBER OF ACTIVE ENTRIES      */
          2 CSLGSRK FIXED(8),       /* GSR KEY - VS2         @Z40ESSR*/
          2 *       FIXED(8),       /*  NOT USED             @Z40ESSR*/
          2 CSLNTRYS (32) CHAR(12); /* CORE ENTRIES                  */
    DCL 1 CSLENTRY BASED,           /* CORE SAVE LIST ENTRY          */
          2 CSLFREMN,               /* FEEEMAIN INFORMATION          */
            3 CSLPOOLN FIXED (8),   /* SUBPOOL NUMBER OF GOTTEN CORE */
            3 CSLCORLN FIXED (24),  /* LENGTH OF BLOCK OF GOTTEN CORE*/
            3 CSLCORPT PTR (31),    /* PTR TO BLOCK OF GOTTEN CORE   */
          2 CSLFLAGS BIT(8),        /* FLAGS                         */
            3 CSLKEY5  BIT(1),      /* CORE IS IN KEY 5 - VS2        */
            3 CSLGSRKT  BIT(1),      /* CORE IN GSR KEY- VS2 @Z40ESSR*/
                                   /* ELSE CORE IN KEY 0-VS2 @Z40ESSR*/
            3 CSLJSTCB BIT(1),      /* CORE IS OWNED BY JOBSTEP TCB  */
          2 CSLANCPT PTR(24);       /* PTR TO ADDR OF HEB HDR ELEM FOR
                                       THIS BLK OF CORE OR ZERO      */
    DCL IDACSLID CHAR (8) CONSTANT (' IDACSL '); /* CHAR CONSTANT
                                       FOR CSLID                     */
