 /********************************************************************/
 /*                                                                  */
 /*   MACRO NAME = IDACTREC                                          */
 /*                                                                  */
 /*   DESCRIPTIVE NAME = AMB WORK AREA.                              */
 /*                                                                  */
 /*   FUNCTION = THE AMB WORK AREA CONTAINS ALL THE CATALOG INFORMA- */
 /*              TIONS OF AN AMB.                                    */
 /*                                                                  */
 /*   CONTROL BLOCK STRUCTURE = POINTED TO BY THE AMB (AMBWKA).      */
 /*                                                                  */
 /*   INCLUDED MACROS = NONE                                         */
 /*                                                                  */
 /*   METHOD OF ACCESS = PL/S - NO DECLARES NECESSARY FOR THE MAIN   */
 /*                             SECTION.  RESPECIFY CTVOLENT BASED   */
 /*                             FOR THE CATALOG VOLUME ENTRY.        */
 /*                             RESPECIFY CTKEYENT BASED FOR THE KEY */
 /*                             RANGE ENTRY.  RESPECIFY CTEXTENT     */
 /*                             BASED FOR THE EXTENT ENTRY.          */
 /*                                                                  */
 /*   CREATED BY: VSAM OPEN MODULE IDA0192C.                         */
 /*                                                                  */
 /*   STATUS = VS1 RELEASE 4   (CHANGE FLAG @X04SVXX)                */
 /*            VS2 RELEASE 3   (CHANGE FLAG @Z30SSXX)        @Z30SSRL*/
 /*                                                                  */
 /*   DATE OF LAST CHANGE = 3 MARCH 75                       @Z30SSRL*/
 /*                                                                  */
 /********************************************************************/
   DCL 1 AMBWORK BASED(AMBWKA),     /* AMB WORK AREA         @X04SVRL*/
     2 AMACATLG PTR,                /* POINTER TO CATLG ACB  @X04SVRL*/
     2 AMATIOT FIXED(15),           /* OFFSET OF TIOT ENTRY  @X04SVRL*/
     2 AMALEN FIXED(15),            /* LENGTH OF AMB WA              */
     2 AMATIOE PTR,                 /* POINTER TO TIOT ENTRY @X04SVRL*/
     2 VOLENTNO FIXED(15),          /* NUMBER OF VOLUME ENTRIES      */
     2 CTINFO BDY(BYTE),            /* CATALOG INFO                  */
              3 CTATTRA BIT(8),     /* DATA SET OPTIONS              */
                4 CTAMDSPD BIT(1),  /* SPEED OPTION                  */
                4 CTUNIQ BIT(1),    /* UNIQUE DATA SET               */
                4 CTRELOP BIT(1),   /* RELEASE OPTION                */
                4 CTERASE BIT(1),   /* ERASE OPTION                  */
                4 *       BIT(1),   /* RESERVED                      */
                4 CTRDONLY BIT(1),  /* INHIBIT UPDATES               */
                4 CTTEMPEX BIT(1),  /* TEMPROARY EXPORT              */
                4 CTTOVFL  BIT(1),  /* TRACK OVERFLOW IN MVM @Y30DSJH*/
              3 CTATTRB BIT(8),     /* MISC INDICATORS               */
                4 CTOPEN BIT(1),    /* DATA SET OPEN FOR WRITE       */
                4 CTCYL BIT(1),     /* CYLINDER ALLOCATION           */
                4 CTINDXSS BIT(1),  /* INDEX & SEQ SET W/DATA        */
                4 CTINDX BIT(1),    /* INDEX DATA SET                */
              3 CTSHROP BIT(8),     /* SHARE OPTIONS                 */
                4 CTSHARE BIT(1),   /* FULL SHARE                    */
                4 CTSHRW BIT(1),    /* WRITE INTEGRITY               */
                4 CTSHRF BIT(1),    /* FULL INTEGRITY                */
                4 CTHELP BIT(1),    /* INVALIDATE BUFFERS            */
                4 CTSDHELP BIT(1),  /* SHARED DASD INVALIDATE BFRS   */
                4 * BIT(1),         /* RESERVED              @Z40WSRL*/
                4 CTINTDS BIT(1),   /* INTERNAL DATA SET     @Z40WSRL*/
                4 CTUNUSE BIT(1),   /* DATA SET UNUSABLE             */
              3 CTAUTH BIT(8),      /* AUTHORIZATION LEVEL   @X04SVRL*/
                4 CTFULL BIT(1),    /* FULL AUTHORIZATION    @X04SVRL*/
                4 CTCINV BIT(1),    /* CI AUTHORIZATION      @X04SVRL*/
                4 CTUPD BIT(1),     /* UPDATE AUTHORIZATION  @X04SVRL*/
              3 * CHAR(2),          /* NOT USED              @X04SVRL*/
              3 CTBLKSZ,            /* PHYSICAL BLOCK SIZE           */
              3 CTDEVTYP CHAR(4),   /* DEVICE TYPE           @X04SVRL*/
                4 * CHAR(1),        /* NOT USED              @X04SVRL*/
                4 CTDEV2 BIT(8),    /* 2ND BYTE OF DEV TYPE  @X04SVRL*/
                  5 * BIT(3),       /* NOT USED              @X04SVRL*/
                  5 CTBRPS BIT(1),  /* RPS DEVICE TYPE               */
                  5 CTVIRT BIT(1),  /* VIRTUAL DEVICE TYPE   @X04SVRP*/
              3 CTTRKAU,            /* TRKS/ALLOCATION UNIT          */
              3 CTSTRKAU,           /* TRACK/ALLOCATION UNIT SS W/DTA*/
              3 CTBLKTR,            /* PHYSICAL BLOCKS/TRACK         */
              3 CTSBLKTR,           /* PHYSICAL BLOCKS/TRACK SS W/DTA*/
              3 CTBYTAU  FIXED(31), /* BYTES/ALLOC FOR TRACK OVERFLOW
                                       IN MVM                @Y30DSJH*/
              3 CTSBYTAU FIXED(31), /* BYTES/ALLOC FOR SS WITH DATA AND
                                       TRACK OVERFLOW IN MVM @Y30DSJH*/
              3 CTBYTTRK FIXED(31), /* BYTES/TRACK FOR TRACK OVERFLOW
                                       IN MVM                @Y30DSJH*/
              3 CTSBYTRK FIXED(31), /* BYTES/TRACK FOR SS WITH DATA AND
                                       TRACK OVERFLOW IN MVM @Y30DSJH*/
              3 CTHSHDSN CHAR (3) , /* DATA SET NAME, HASHED         */
              3 * CHAR(1),          /* NOT USED              @X04SVRL*/
              3 CTHSHCAT PTR(31) ,  /* CATALOG ACB PTR       @X04SVRL*/
              3 CTHURBA FIXED (32), /* DATA SET HIGH USED RBA        */
              3 CTBUFSIZ,           /* MINIMUM BUFFER SPACE          */
              3 CTCISIZ,            /* CI SIZE                       */
              3 CTEXEX   CHAR(8),   /* EXCEPTION EXIT NAME   @X04SVGP*/
              3 CTDATANM CHAR(44) , /* DATA SET NAME                 */
              3 CTAMDSB  CHAR(LENGTH(IDAAMDSB)), /* AMDSB    @Y30DSJH*/
              3 *        CHAR(4);   /* NOT USED              @Z30SSRL*/
  DCL 1 CTVOLENT BASED,             /* CATALOG VOLUME ENTRY          */
     2 CTVOLFLG BIT(8),             /* VOLUME FLAG                   */
       3 CTVOLMT BIT(1),            /* VOL IS MOUNTED                */
      3 CTOFLOW BIT(1),             /* OVERFLOW VOLUME               */
     2 CTNOEXT FIXED(8),            /* NBR EXTENTS ON THIS VOLUME    */
     2 * CHAR(2),                   /* NOT USED              @X04SVRL*/
     2 CTVOLUCB PTR(31),            /* UCB ADDRESS                   */
     2 CTNOKEY FIXED(15),           /* NUMBER OF KEY RANGES ON VOL   */
     2 CTKEYLEN FIXED (15),         /* KEY LENGTH FOR KEY RANGE SPEC */
     2 CTVOLSER CHAR(6),            /* VOLUME SERIAL NUMBER          */
     2 * CHAR(2),                   /* NOT USED              @X04SVRL*/
     2 CTKEYEN1 CHAR(*);            /* FIRST KEY ENTRY               */
 DCL 1 CTKEYENT BASED,              /* KEY RANGE ENTRY               */
     2 CTKEYFLG BIT(8),             /* KEY FLAG                      */
       3 CTSSWDTA BIT(1),           /* SEQ SET WITH DATA             */
       3 CTPRFMT BIT(1),            /* EXTENT NOT PREFORMATED        */
     2 CTNOKEXT FIXED(8),           /* NBR EXTS THIS KEY RANGE       */
     2 CTKRELNO FIXED(15),          /* VOL OCCURENCE NBR             */
     2 CTKHKRBA FIXED(32),          /* HI KEY RBA                    */
     2 CTKHURBA FIXED(32),          /* HIGH USED RBA THIS KEY RANGE  */
      2 CTKHARBA FIXED(32),         /* HIGH ALLOCATED RBA THIS
                                       KEY RANGE                     */
     2 CTKEY CHAR(*);               /* FIRST LOW KEY                 */
   DCL 1 CTEXTENT BASED BDY(BYTE),  /* EXTENT ENTRY                  */
     2 CTEXTFLG BIT(8),             /* ENTENT FLAG                   */
     2 * CHAR(1),                   /* RESERVED                      */
     2 CTABSBEG CHAR(4),            /* BEGINNING CCHH                */
       3 CTCCBEG FIXED(16)BDY(BYTE),/* BEGINNING CC          @X04SVRL*/
       3 CTHHBEG FIXED(16)BDY(BYTE),/* BEGINNING HH          @X04SVRL*/
     2 CTABSEND CHAR(4),            /* ENDING CCHH                   */
       3 CTCCEND FIXED(16)BDY(BYTE),/* ENDING CC             @X04SVRL*/
       3 CTHHEND FIXED(16)BDY(BYTE),/* ENDING HH             @X04SVRL*/
     2 CTNOTRKS FIXED(15)BDY(BYTE), /* NBR TRACKS IN EXTENT          */
     2 CTRBABEG FIXED(32)BDY(BYTE), /* BEGINNING RBA                 */
     2 CTRBAEND FIXED(32)BDY(BYTE), /* ENDING RBA                    */
     2 * CHAR(*);                   /* NOT USED              @X04SVRL*/
