*/********************************************************************/
*/*                                                                  */
*/*   MACRO NAME = IDADIWA                                           */
*/*                                                                  */
*/*   DESCRIPTIVE NAME = DATA INSERT WORK AREA                       */
*/*                                                                  */
*/*   FUNCTION = USED BY VSAM RECORD MANAGEMENT TO INSERT DATA       */
*/*              INTO A CONTROL INTERVAL                             */
*/*                                                                  */
*/*   CONTROL BLOCK STRUCTURE = POINTED TO BY THE IDAAMB             */
*/*                                                                  */
*/*   INCLUDED MACROS = NONE                                         */
*/*                                                                  */
*/*   METHOD OF ACCESS = PL/S - NO DECLARES NECESSARY                */
*/*                                                                  */
*/*   CREATED BY = VSAM OPEN                                         */
*/*                                                                  */
*/*   STATUS = VS/1 RELEASE 4  (CHANGE FLAG @X04SVXX)                */
*/*                                                                  */
*/*   DATE OF LAST CHANGE = 01 SEPT 77                       @ZA25653*/
*/*                         23 AUG 74                                */
*/*                         15 SEPT 76                       @ZA02289*/
*/*                                                                  */
*/********************************************************************/
*  DCL 1 IDADIWA BDY(WORD) BASED,       /* DATA INSERT WORK AREA     */
*        2 DIWID         CHAR(1),       /* CONTROL BLOCK ID          */
*        2 DIWATV        CHAR(1),       /* INSERT IN PROGRESS - TEST */
*                                       /* AND SET BYTE              */
*        2 DIWLEN        FIXED(15),     /* CONTROL BLOCK LENGTH      */
*        2 DIWFLG1       BIT(8),        /*   FLAGS                   */
*          3 DIWCAS      BIT(1),        /* CONTROL AREA SPLIT IN     */
*                                       /* PROGRESS                  */
*          3 DIWCISPL    BIT(1),        /* CI SPLIT HAS OCCURRED     */
*          3 DIWPFERR    BIT(1),           /* PREFORMAT I/O ERROR    */
*          3 DIWEOKR     BIT(1),        /* CI SPLIT DUE TO EOKR      */
*          3 DIWGSPC     BIT(1),        /* RCD NEEDS NEW CA  @X04SVLC*/
*          3 DIWSHIFT    BIT(1),        /* ON--INSERT CI SHIFTING TO
*                                          RBA IN DIWINRBA   @ZA25653*/
*          3 DIWNOT1     BIT(1),        /* ON--BUFFER HAD MIDDLE/LAST
*                                       SEG OF A SPANNED RCD @X04SVMR*/
*          3 DIW1ST      BIT(1),        /* ON--BUFFER HAD MIDDLE/FIRST
*                                       SEG OF A SPANNED RCD @X04SVMR*/
*        2 DIWFLG2       BIT(8),        /* FLAGS            @X04SVLC*/
*          3 DIWFSPF     BIT(1),        /* FREE SPACE PREFORMAT
*                                       NEEDED IN ESDS       @X04SVMR*/
*        2 *             FIXED(15),     /* NOT USED                  */
*        2 DIWLRBA       PTR(32),       /* CA SPLIT START RBA        */
*        2 DIWHRBA       PTR(32),       /* CA SPLIT NEXT CA RBA      */
*        2 DIWPLH        PTR(31),       /* PTR TO PLH USING DIWA     */
*        2 DIWBUFC       PTR(31),       /* PTR TO INSERT WORK BUFC   */
*        2 DIWSPLTP      PTR(31),       /* PTR TO SPLIT RDF          */
*        2 DIWSAVE       BDY(WORD),     /* REGISTER SAVE AREA        */
*          3 DIWSAVE1    PTR(31),       /* REGISTER SAVE 1           */
*          3 DIWSAVE2    PTR(31),       /* REGISTER SAVE 2           */
*          3 DIWSAVE3    PTR(31),       /* REGISTER SAVE 3           */
*          3 DIWSAVE4    PTR(31),       /* REGISTER SAVE 4           */
*          3 DIWSAVE5    PTR(31),       /* REGISTER SAVE 5           */
*        2 DIWRKCT       PTR(32),       /* COUNTER FOR RK.   @ZA02289*/
*        2 DIWINRBA      FIXED(32),     /* INSERT CI RBA     @ZA25653*/
*        2 *             PTR(32),       /* RESERVED. TWO     @ZA02289*/
*        2 *             PTR(32),       /* RESERVED. THREE   @ZA02289*/
*        2 *             PTR(32),       /* RESERVED. FOUR    @ZA02289*/
*        2 *             PTR(32),       /* RESERVED. FIVE    @ZA02289*/
*        2 *             PTR(32),       /* RESERVED. SIX     @ZA02289*/
*        2 *             PTR(32),       /* RESERVED. SEVEN   @ZA02289*/
*        2 *             PTR(32),       /* RESERVED. EIGHT   @ZA02289*/
*        2 *             PTR(32),       /* RESERVED. NINE    @ZA02289*/
*        2 *             PTR(32),       /* RESERVED. TEN     @ZA02289*/
*        2 *             PTR(32);       /* RESERVED. ELEVEN  @ZA02289*/
