 /********************************************************************/
 /*                                                                  */
 /*   MACRO NAME = IDADSL                                            */
 /*                                                                  */
 /*   DESCRIPTIVE NAME = DEB SAVE LIST.                              */
 /*                                                                  */
 /*   FUNCTION = ALL DEB'S SUCCESSFULLY CHAINED AND ADDED TO THE DEB */
 /*              TABLE ARE RECORDED IN THIS LIST. ADDITIONAL LIST    */
 /*              ARE CHAINED AS REQUIRED.                            */
 /*                                                                  */
 /*   CONTROL BLOCK STRUCTURE = POINTED TO BY THE OPEN ACB WORK AREA.*/
 /*                                                                  */
 /*   INCLUDED MACROS = NONE                                         */
 /*                                                                  */
 /*   METHOD OF ACCESS = PL/S - RESPECIFY IDADSL BASED.              */
 /*                                                                  */
 /*   CREATED BY: VSAM OPEN MODULE IDA0192A.                         */
 /*                                                                  */
 /*   STATUS = VS1 RELEASE 4, VS2 RELEASE 3.                         */
 /*                                                                  */
 /*   DATE OF LAST CHANGE = 2 AUGUST 74                              */
 /*                                                                  */
 /********************************************************************/
    DCL 1 IDADSL BASED,             /* DEB SAVE LIST                 */
          2 DSLSUBPL FIXED (8),     /* SUBPOOL NUMBER OF THIS DSL    */
          2 DSLLENTH FIXED (24),    /* LENGTH IN BYTES OF THIS DSL   */
          2 DSLID CHAR (8),         /* BLOCK IDENTIFIER              */
          2 DSLNXPTR PTR (31),      /* POINTER TO NEXT DSL OR 0 IF
                                       LAST DSL IN CHAIN.            */
          2 DSLACTEN FIXED (15),    /* NUMBER OF ACTIVE ENTRIES      */
          2 * FIXED (15),           /* RESERVED                      */
          2 DSLENTRY (16),          /* DEB ENTRIES                   */
            3 DSLFLG BIT (8),       /* FLAGS                         */
              4 * BIT (7),          /* RESERVED                      */
              4 DSLFDDEB BIT (1),   /* BIT ON INDICATES DUMMY DEB    */
            3 DSLDEBAD PTR (24)     /* ADDRESS OF DEB                */
    ;
    DCL IDADSLID CHAR (8) CONSTANT (' IDADSL '); /* CHAR CONSTANT
                                       FOR DSLID                     */
