*/********************************************************************/
*/*                                                                  */
*/*   MACRO NAME = IDAEDB                                            */
*/*                                                                  */
*/*   DESCRIPTIVE NAME =EXTENT DEFINITION BLOCK                      */
*/*                                                                  */
*/*   FUNCTION = DESCRIBES LOGICAL EXTENTS OF A VSAM DATA SET        */
*/*                                                                  */
*/*   CONTROL BLOCK STRUCTURE = THE IDAEDB IS POINTED TO BY THE      */
*/*              IDAAMB                                              */
*/*                                                                  */
*/*   INCLUDED MACROS = NONE                                         */
*/*                                                                  */
*/*   METHOD OF ACCESS = PL/S - NO DECLARES NECESSARY                */
*/*                                                                  */
*/*   CREATED BY = VSAM OPEN                                         */
*/*                                                                  */
*/*   STATUS = VS/1 RELEASE 4  (CHANGE FLAG @X04SVXX)                */
*/*            VS/2 RELEASE 3  (CHANGE FLAG @Y30SDXX)                */
*/*                                                                  */
*/*   DATE OF LAST CHANGE = 30 AUG 74                                */
*/*                                                                  */
*/********************************************************************/
*/********************************************************************/
*/* EXTENT DEFINITION BLOCK HEADER                                   */
*/********************************************************************/
*        DCL 1 IDAEDBHD BASED,
*              2 EDBID       PTR(8),    /* EDB IDENTIFIER           */
*              2 EDBNO       PTR(8),    /* NUMBER OF ENTRIES        */
*              2 EDBLEN      FIXED(15), /* LENGTH OF ENTRY          */
*              2 EDBLPMBC    PTR(31);   /* PTR TO FIRST LPMB        */
*/********************************************************************/
*/* EXTENT DEFINITION BLOCK                                          */
*/********************************************************************/
*        DCL 1 IDAEDB BASED,            /* ENTRY DEFINITION         */
*              2 *           CHAR(2),   /* NOT USED          @Y30DSJH*/
*              2 EDBFLG1     BIT(8),    /* EDB FLAGS FOR MVM @Y30DSJH*/
*                3 EDBLKR    BIT(1),    /* CATLG LOW KEY RNG @Y30DSJH*/
*                3 EDBTOFLW  BIT(1),    /* TRACK OVERFLOW    @Y30DSJH*/
*                3 EDBPSDS   BIT(1),    /* PAGE SPACE D.S.   @Y30DSJH*/
*                3 *         BIT(5),    /* UNUSED            @Y30DSJH*/
*              2 EDBM        PTR(8),    /* ENTENT NUMBER            */
*              2 EDBLPMBA    PTR(31),   /* ADDRESS OF LPMB          */
*              2 EDBSTTRK    PTR(31),   /* EXTENT RELATIVE TRK ADDR */
*              2 EDBLORBA    PTR(32),   /* LO RBA LIMIT             */
*              2 EDBHIRBA    PTR(32),   /* HI RBA LIMIT             */
*              2 EDBTKBAL    FIXED(31); /* MVM TRACK BAL CTR @Y30DSJH*/
