 /********************************************************************/
 /*                                                                  */
 /*   MACRO NAME = IDAERMAP                                          */
 /*                                                                  */
 /*   DESCRIPTIVE NAME = ERROR CODE MAPPING MACRO                    */
 /*                                                                  */
 /*   FUNCTION = THIS MACRO DEFINES AN ARRAY THAT MAPS THE ERROR CODE*/
 /*              (PPCODE) IN THE IEC ERROR MESSAGE (DEFINED BY THE   */
 /*              IDAPPCDE MACRO) INTO THE CORRESPONDING CODE THAT IS */
 /*              SET IN THE ACBERFLG FIELD (DEFINED BY THE IDAERRCD  */
 /*              MACRO).  THE PPCODE IS USED AS AN INDEX INTO THE    */
 /*              ARRAY DEFINED BY THIS MACRO TO REFERENCE THE        */
 /*              ACBERFLG CORRESPONDING TO THIS PPCODE.  THIS MACRO  */
 /*              WILL NEED TO BE UPDATED WHENEVER THE IDAPPCDE OR    */
 /*              IDAERRCD MACRO ARE CHANGED.                         */
 /*                                                                  */
 /*   CONTROL BLOCK STRUCTURE = NONE                                 */
 /*                                                                  */
 /*   INCLUDED MACROS = NONE                                         */
 /*                                                                  */
 /*   METHOD OF ACCESS = PL/S - NO DECLARES NECESSARY                */
 /*                                                                  */
 /*   STATUS = VS1 RELEASE 4, VS2 RELEASE 3.                         */
 /*                                                                  */
 /*   DATE OF LAST CHANGE = 10/13/75                         @Z40WSRL*/
 /*                                                                  */
 /********************************************************************/
    DCL
      IDAERMAP(256) FIXED(8) STATIC LOCAL INIT( /* ERROR CODE MAP    */
          (3)0,                     /* NOT USED                      */
          132,                      /* PP4                           */
          (15)0,                    /* NOT USED                      */
          136,                      /* PP20                          */
          0,                        /* NOT USED                      */
          184,                      /* PP22                          */
          (5)0,                     /* NOT USED                      */
          180,                      /* PP28                          */
          (3)0,                     /* NOT USED                      */
          148,                      /* PP32                          */
          0,                        /* PP33                          */
          0,                        /* PP34                          */
          0,                        /* PP35                          */
          144,                      /* PP36                          */
          148,                      /* PP37                          */
          196,                      /* PP38                          */
          100,                      /* PP39                          */
          152,                      /* PP40                          */
          160,                      /* PP41                          */
          (2)0,                     /* NOT USED                      */
          160,                      /* PP44                          */
          96,                       /* PP45                          */
          192,                      /* PP46                          */
          160,                      /* PP47                          */
          160,                      /* PP48                          */
          224,                      /* PP49                          */
          176,                      /* PP50                          */
          0,                        /* NOT USED                      */
          168,                      /* PP52                          */
          0,                        /* NOT USED                      */
          160,                      /* PP54                          */
          0,                        /* NOT USED                      */
          116,                      /* PP56                          */
          0,                        /* NOT USED                      */
          108,                      /* PP58                          */
          104,                      /* PP59                          */
          240,                      /* PP60                          */
          (7)0,                     /* NOT USED                      */
          160,                      /* PP68                          */
          (3)0,                     /* NOT USED                      */
          160,                      /* PP72                          */
          (3)0,                     /* NOT USED                      */
          188,                      /* PP76                  @Z40WSRL*/
          0,                        /* NOT USED                      */
          188,                      /* PP78                          */
          0,                        /* NOT USED                      */
          160,                      /* PP80                          */
          (3)0,                     /* NOT USED                      */
          232,                      /* PP84                          */
          (3)0,                     /* NOT USED                      */
          160,                      /* PP88                          */
          0,                        /* NOT USED                      */
          0,                        /* PP90                          */
          0,                        /* PP91                          */
          236,                      /* PP92                          */
          236,                      /* PP93                          */
          0,                        /* PP94                          */
          (5)0,                     /* NOT USED                      */
          0,                        /* PP100                         */
          (3)0,                     /* NOT USED                      */
          0,                        /* PP104                         */
          (3)0,                     /* NOT USED                      */
          0,                        /* PP108                         */
          (3)0,                     /* NOT USED                      */
          0,                        /* PP112                         */
          (3)0,                     /* NOT USED                      */
          164,                      /* PP116                         */
          (3)0,                     /* NOT USED                      */
          220,                      /* PP120                         */
          (3)0,                     /* NOT USED                      */
          228,                      /* PP124                         */
          (3)0,                     /* NOT USED                      */
          184,                      /* PP128                         */
          (3)0,                     /* NOT USED                      */
          208,                      /* PP132                         */
          (3)0,                     /* NOT USED                      */
          160,                      /* PP136                         */
          (3)0,                     /* NOT USED                      */
          160,                      /* PP140                         */
          (3)0,                     /* NOT USED                      */
          160,                      /* PP144                         */
          (3)0,                     /* NOT USED                      */
          204,                      /* PP148                         */
          (3)0,                     /* NOT USED                      */
          212,                      /* PP152                         */
          (3)0,                     /* NOT USED                      */
          216,                      /* PP156                         */
          (7)0,                     /* NOT USED                      */
          160,                      /* PP164                         */
          (3)0,                     /* NOT USED                      */
          244,                      /* PP168                         */
          (3)0,                     /* NOT USED                      */
          200,                      /* PP172                         */
          (3)0,                   /* PP173-PP175 ARE UNUSED. @Z30SSMD*/
           0,              /* PP176, USE ACBERFLAG OF ZERO.  @Z30SSMD*/
          (3)0,                   /* PP177-PP179 ARE UNUSED. @Z30SSMD*/
           0,              /* PP180, USE ACBERFLAG OF ZERO.  @Z30SSMD*/
          (3)0,                   /* PP181-PP183 ARE UNUSED. @Z30SSMD*/
           0,              /* PP184, USE ACBERFLAG OF ZERO.  @Z30SSMD*/
          (3)0,                   /* PP185-PP187 ARE UNUSED  @Z40WSRL*/
           160,                   /* PP188                   @Z40WSRL*/
          (3)0,                   /* PP189-PP191 ARE UNUSED  @Z40WSRL*/
           160,                   /* PP192                   @Z40WSRL*/
          (64)0);                  /* PP193-PP256 ARE UNUSED @Z40WSRL*/
