 /********************************************************************/
 /*                                                                  */
 /*   MACRO NAME = IDAERRCD                                          */
 /*                                                                  */
 /*   DESCRIPTIVE NAME = VSAM OPEN/CLOSE/EOV ERROR CODES.            */
 /*                                                                  */
 /*   FUNCTION = THE ERROR CODE IS DETERMINED BY THE PROBLEM CODE    */
 /*              RELATING TO A PROBLEM. THE ERROR CODE IS THEN MOVED */
 /*              INTO THE ACB (ACBERFLG) TO COMMUNICATE WITH THE     */
 /*              USER.                                               */
 /*                                                                  */
 /*   CONTROL BLOCK STRUCTURE = NONE                                 */
 /*                                                                  */
 /*   INCLUDED MACROS = NONE                                         */
 /*                                                                  */
 /*   METHOD OF ACCESS = PL/S - NO DECLARES NECESSARY                */
 /*                                                                  */
 /*   CREATED BY: N/A                                                */
 /*                                                                  */
 /*   STATUS = VSAM MVS SELECTABLE UNIT 7                    @ZA16012*/
 /*                                                                  */
 /*   DATE OF LAST CHANGE = 05 AUG 1976                      @ZA16012*/
 /*                                                                  */
 /********************************************************************/
   DCL (OPERR000 CONSTANT(0),     /* NO ERROR FOR OPEN OR CLOSE */
    OPERR004 CONSTANT(4),    /* WARNING - ACB ALREADY OPEN FOR OPEN OR
                                ACB NOT OPEN FOR CLOSE AND TCLOSE    */
    OPERR080 CONSTANT(80),   /* WARNING - PROCESSING INTEGRITY */
    OPERR096 CONSTANT(96),   /* WARNING - UNUSABLE DATA SET OPENED
                                          FOR INPUT          @X04SVRL*/
    OPERR100 CONSTANT(100),  /* WARNING - EMPTY UPGRADE AIX  @X04SVRL*/
    OPERR104 CONSTANT(104),  /* WARNING-VOLUME TIMESTAMP DISCREPANCY
                                AND ACB INDICATES INPUT      @X04SVRP*/
    OPERR108 CONSTANT(108),  /* WARNING-D.S. TIMESTAMP DISCREPANCY   */
    OPERR116 CONSTANT(116),  /* WARNING - DATA SET NOT PROPERLY CLOSED*/
    OPERR128 CONSTANT(128),  /* DD NAME NOT FOUND IN TIOT */
    OPERR132 CONSTANT(132),  /* I/O ERR RD/WRT JFCB */
    OPERR136 CONSTANT(136),  /* NO CORE AVAILABLE */
    OPERR144 CONSTANT(144),  /* I/O ERROR RD/WRT CATALOG ENT */
    OPERR148 CONSTANT(148),  /* CATALOG ENTRY NOT FOUND */
    OPERR152 CONSTANT(152),  /* DATA SET SECURITY INVALID */
    OPERR160 CONSTANT(160),  /* CONFLICTING PARAMETERS */
    OPERR164 CONSTANT(164),  /* I/O ERROR READING VOLUME LABEL */
    OPERR168 CONSTANT(168),  /* DATA SET NOT AVAILABLE */
    OPERR176 CONSTANT(176),  /* PGFIX FAILURE                       */
    OPERR180 CONSTANT(180),  /* CAT DOES NOT EXIST OR NOT OPEN      */
    OPERR184 CONSTANT(184),  /* I/O ERROR COMPLETING I/O REQUEST    */
    OPERR188 CONSTANT(188),  /* ACB IS NOT FOR A VALID DATA SET */
    OPERR192 CONSTANT(192),  /* UNUSABLE DATA SET OPENED FOR OUTPUT
                                                             @X04SVRL*/
    OPERR196 CONSTANT(196),  /* ACCESS TO DATA REQUESTED VIA EMPTY
                                PATH AIX                     @X04SVRL*/
    OPERR200 CONSTANT(200),  /* FMT 4 DSCB INDICATES VOL IS UNUSABLE
                                                             @X04SVRL*/
    OPERR204 CONSTANT(204),  /* ACB INDICATES GSR OR CBIC BUT CALLER IS
                                NOT IN SUPERVISOR STATE AND KEY 0 TO 7
                                                             @ZA16012*/
    OPERR208 CONSTANT(208),  /* ACB INDICATES GSR AND SYSTEM IS VS1
                                                             @X04SVRL*/
    OPERR212 CONSTANT(212),  /* ACB INDICATES LSR/GSR AND DATA SET
                                IS EMPTY                     @X04SVRL*/
    OPERR216 CONSTANT(216),  /* ACB INDICATES LSR/GSR AND KEY LENGTH
                                OF DS EXCEEDED MAXKEY IN BLDVRP MACRO
                                                             @X04SVRL*/
    OPERR220 CONSTANT(220),  /* DB/DC - BSPH TOO SMALL       @X04SVGP*/
    OPERR224 CONSTANT(224),  /*ICI PROCESSING AND CREATE MODE INDICATED
                                                             @X04SVRL*/
    OPERR228 CONSTANT(228),  /* DB/DC - VSRT DOES NOT EXIST  @X04SVRL*/
    OPERR232 CONSTANT(232),  /* RESET SPECIFIED FOR NON-REUSABLE DS
                                                             @X04SVRL*/
    OPERR236 CONSTANT(236),  /* MSS STAGE OR DESTAGE ERROR   @X04SVRL*/
    OPERR240 CONSTANT(240), /* VOLUME TIMESTAMP DISCREPANCY AND
                               ACB INDICATES OUTPUT          @X04SVRP*/
    OPERR244 CONSTANT(244)) /* CRA VOLUME NOT MOUNTED        @X04SVRP*/
         FIXED(31);          /* ERRORS DETECTED BY OPEN AND CLOSE   */
  /* THE FOLLOWING ERRORS ARE DETECTED BY OPEN, CLOSE, EOV OR        */
  /* TCLOSE, BUT ERROR FLAGS ARE NOT SET IN THE ACB IN ORDER         */
  /* NOT TO INTERFERE WITH ANY POSSIBLE PROCESSING BEING DONE        */
  /* ON THAT ACB BY ANOTHER TASK:                                    */
  /*     ACB BUSY                                                    */
  /*     ACB DOES NOT BELONG TO JOB STEP ISSUING OPEN, CLOSE         */
  /*       OR TCLOSE                                                 */
