 /********************************************************************/
 /*                                                                  */
 /*   MACRO NAME = IDAESL                                            */
 /*                                                                  */
 /*   DESCRIPTIVE NAME = ENQUEUE SAVE LIST.                          */
 /*                                                                  */
 /*   FUNCTION = IDAESL CONTAINS A LIST OF ALL ENQUEUES COMPLETED    */
 /*              SUCCESSFULLY DURING OPEN PROCESSING. ADDITIONAL     */
 /*              LISTS ARE CHAINED AS REQUIRED.                      */
 /*                                                                  */
 /*   CONTROL BLOCK STRUCTURE = POINTED TO THE OPEN ACB WORK AREA.   */
 /*                                                                  */
 /*   INCLUDED MACROS = NONE                                         */
 /*                                                                  */
 /*   METHOD OF ACCESS = PL/S - RESPECIFY IDAESL BASED.              */
 /*                                                                  */
 /*   CREATED BY: VSAM OPEN MODULE IDA0192A.                         */
 /*                                                                  */
 /*   STATUS = VS/1 RELEASE 4, VS2 RELEASE 3.                        */
 /*                                                                  */
 /*   DATE OF LAST CHANGE = 2 AUGUST 74                              */
 /*                                                                  */
 /********************************************************************/
    DCL 1 IDAESL BASED BDY(WORD),   /* ENQUEUE SAVE LIST             */
          2 ESLSUBPL FIXED (8),     /* SUBPOOL NUMBER OF THIS ESL    */
          2 ESLLENTH FIXED (24),    /* LENGTH IN BYTES OF THIS ESL   */
          2 ESLID CHAR (8),         /* BLOCK IDENTIFIER              */
          2 ESLNXPTR PTR (31),      /* PTR TO NEXT ESL OR 0 IF LAST
                                       ESL IN CHAIN                  */
          2 ESLACTEN FIXED (15),    /* NUMBER OF ACTIVE ENTRIES      */
          2 * FIXED (15),           /* RESERVED                      */
          2 ESLENTRY (16),          /* ENQUEUE ENTRIES              */
            3 ESLENQOP CHAR(1),     /* ENQUEUE OPTION FOR THIS ENTRY */
            3 ESLRNAME,             /* ENQUEUE RNAME FOR THIS ENTRY  */
              4 ESLCINBR CHAR(3),   /* CI NUMBER FOR THIS ENTRY      */
              4 ESLACBAD CHAR(4),   /* POINTER TO ACB FOR THIS ENTRY */
              4 ESLIO CHAR(1)       /* I OR O                        */
    ;
    DCL IDAESLID CHAR (8) CONSTANT (' IDAESL '); /* CHAR CONSTANT
                                       FOR ESLID                     */
