 /********************************************************************/
 /*                                                                  */
 /*   MACRO NAME = IDAHEB                                            */
 /*                                                                  */
 /*   DESCRIPTIVE NAME = HEADER ELEMENT BLOCK.                       */
 /*                                                                  */
 /*   FUNCTION = THE HEB CONTAINS UP TO 16 ACTIVE CORE BLOCK HEADERS */
 /*              USED TO REFLECT GOTTEN CORE FOR VSAM CONTROL BLOCKS.*/
 /*              ADDITIONAL HEB(S) ARE CHAINED AS REQUIRED.          */
 /*                                                                  */
 /*   CONTROL BLOCK STRUCTURE = THE HEB IS POINTED TO BY THE BIB     */
 /*                             (BIBHEBPT). THE FIRST FREE HEADER    */
 /*                             ELEMENT IS POINTED TO BY (BIBHEBFQ). */
 /*                                                                  */
 /*   INCLUDED MACROS = NONE                                         */
 /*                                                                  */
 /*   METHOD OF ACCESS = PL/S - RESPECIFY IDAHEB AND HEBHDREL BASED. */
 /*                                                                  */
 /*   CREATED BY: VSAM OPEN MODULE IDA0192M.                         */
 /*                                                                  */
 /*   STATUS = VS2 RELEASE 4                                 @Z40ESSR*/
 /*                                                                  */
 /*   DATE OF LAST CHANGE = 04/11/75                         @Z40ESSR*/
 /*                                                                  */
 /********************************************************************/
 DCL HEBNEL CONSTANT(16) FIXED(31); /* NUMBER OF ELEMENTS IN A HEB   */
 DCL 1 HEBHDREL BASED BDY(WORD),    /* HEADER ELEMENT                */
       2 HEBFREMN,                  /* FREEMAIN INFORMATION          */
         3 HEBSP    FIXED(8),       /* SUBPOOL OF BLOCK              */
         3 HEBLN    FIXED(24),      /* LENGTH OF BLOCK               */
         3 HEBBLKPT PTR(31),        /* POINTER TO CORE BLOCK         */
       2 HEBFLAGS BIT(8),           /* FLAGS                         */
         3 HEBJSTCB BIT(1),         /* CORE IS OWNED BY JOBSTEP TCB  */
         3 HEBKEY5  BIT(1),         /* STORAGE IS IN KEY 5 - VS2     */
         3 HEBGSRKT BIT(1),         /* STOR IN GSR KEY - VS2 @Z40ESSR*/
                                    /* NOTE - IF NOT KEY 5 OR GSR KEY
                                       GET CORE IN KEY 0     @Z40ESSR*/
         3 HEBIOSUP BIT(1),         /* O/C/E SPECIAL REQUEST BLK -VS2*/
         3 HEBRTFLG BIT(1),         /* RECOVERY/TERM FREED CORE - VS2*/
       2 HEBAVSP  FIXED(24),        /* AMOUNT OF AVAILABLE CORE      */
       2 HEBELCHN PTR(31),          /* PTR TO NEXT HDR ELEMENT       */
       2 HEBNBYTE PTR(31),          /* PTR TO NEXT AVAIL BYT @Z40ESSR*/
       2 * CHAR(4),                                        /*@Z40ESSR*/
         3 HEBGSRK FIXED(8),        /*GSR KEY IF HEBGSRKT ON @Z40ESSR*/
         3 *       FIXED(24);       /* UNUSED                @Z40ESSR*/
 DCL 1 IDAHEB BASED BDY(WORD),      /* HEADER ELEMENT BLOCK  @Z40ESSR*/
       2 HEBID    CHAR(1),          /* CONTROL BLOCK ID      @Z40ESSR*/
       2 *        CHAR(1),          /* RESERVED - NOT USED   @Z40ESSR*/
       2 HEBLEN   FIXED(15),        /* LENGTH OF HEB         @Z40ESSR*/
       2 HEBNHEB  PTR (31),         /* POINTER TO NEXT HEB OR ZERO   */
       2 *        CHAR(2),          /* UNUSED                @Z40ESSR*/
       2 HEBCNT   FIXED(15),        /* NUMBER OF HEADER ELEMENTS     */
       2 HEBHDELS(HEBNEL) CHAR(LENGTH(HEBHDREL));/* HDR ELEM @Z40ESSR*/
