*/********************************************************************/
*/*                                                                  */
*/*   MACRO NAME = IDAICWA                                           */
*/*                                                                  */
*/*   DESCRIPTIVE NAME = INDEX CREATE WORK AREA                      */
*/*                                                                  */
*/*   FUNCTION = USED BY VSAM RECORD MAGANEMENT WHEN CREATING        */
*/*         AN INDEX                                                 */
*/*                                                                  */
*/*   CONTROL BLOCK STRUCTURE = POINTED TO BY IDAAMB                 */
*/*                                                                  */
*/*   INCLUDED MACROS = NONE                                         */
*/*                                                                  */
*/*   METHOD OF ACCESS = PL/S - NO DECLARES NECESSARY                */
*/*                                                                  */
*/*   CREATED BY = VSAM OPEN                                         */
*/*                                                                  */
*/*   STATUS = VS/1 RELEASE 4  (CHANGE FLAG @X04SVXX)                */
*/*                                                                  */
*/*   DATE OF LAST CHANGE = 9 AUG 74                                 */
*/*                                                                  */
*/********************************************************************/
*  DCL 1  IDAICWA  BASED,                  /* INDEX CREATE WORK AREA */
*        2 ICWID CHAR(1),                  /* CONTROL BLOCK ID     */
*        2 ICWFLG1 BIT(8),                 /* FLAG BYTE ONE        */
*          3 ICWWNF BIT(1),                /* ENTRY WILL NOT FIT     */
*          3 ICWWAGM BIT(1),               /* WORK AREA NOT FROM OPEN*/
*          3 ICWRBAOK BIT(1),              /* DONT GET RBA ON INITAL */
*          3 ICWVSE BIT(1),                /* SECTION ENTRY IS VALID */
*          3 ICWVNE BIT(1),                /* PREVIOUS ENTRY IS VALID*/
*          3 ICWKRDS BIT(1),               /* KEY RANGE DATA SET     */
*          3 ICWSPLIT BIT(1),              /* AREA USED BY SPLT I.R. */
*          3 ICWENDRQ BIT(1),              /* CLOSE REQUIRES CI SPLT.*/
*        2 ICWLEN FIXED(15),               /* LENGTH OF CONTROL BLK*/
*        2 ICWCHN PTR(31),                 /* PTR TO NEXT ICWA     */
*        2 ICWBUFC PTR(31),                /* PTR TO CURR IX BUFC  */
*        2 ICWCRBA PTR(32),                /* CURRENT INDEX RBA      */
*        2 ICWPRBA PTR(32),                /* PREVIOUS INDEX RBA     */
*        2 ICWPSEO PTR(15),                /* PRIOR SECT ENTRY PTR */
*        2 ICWSCNT PTR(15),                /* ENTRIES IN CURR SECT */
*        2 ICWADD PTR(31),                 /* PTR TO CURRENT W.A.    */
*        2 ICWTBASE PTR(32),               /* BASE RBA SAVE POSITION */
*        2 ICWTPTR PTR(31),                /* INDEX PTR SAVE POSITION*/
*        2 ICWARDBP PTR(31),               /* POINTER TO CURRENT ARDB*/
*        2 ICWLN FIXED(15),                /* INDEX LEVEL NUMBER     */
*        2 ICWKEY1L FIXED(15),             /* LENGTH OF CURRENT KEY  */
*        2 ICWKEY2L FIXED(15),             /* LENGTH OF PREVIOUS KEY */
*        2 ICWKEY3L FIXED(15),             /* LENGTH OF SECTION KEY  */
*        2 ICWNEST  FIXED(15),             /* NO ENTRYS IN INDX SECT */
*        2 ICWNOSEG FIXED(15),             /* NO. SEGMENTS IN SPANNED
*                                             RECORD         @X04SVLC*/
*        2 ICWCRSEG FIXED(15),             /* CURRENT SEGMENT BEING
*                                             PROCESSED      @X04SVLC*/
*        2 ICWREQ PTR(8),                  /* REQUEST TYPE           */
*        2 ICWPTL PTR(8),                  /* INDEX ENTRY POINTER LEN*/
*        2 ICWCER PTR(8),                  /* REAR COMP. OF CUR ENTRY*/
*        2 ICWCEF PTR(8),                  /* CURRENT ENTRY F      */
*        2 ICWCEL PTR(8),                  /* CURRENT ENTRY L      */
*        2 ICWCERP PTR(8),                 /* REAR COMP. OF PREVIOUS */
*        2 ICWKEY1 CHAR(*);                /* FIRST KEY SAVED      */
*  DCL ICWKEY2 CHAR(*) BASED;              /* SECOND KEY SAVED     */
*  DCL ICWKEY3 CHAR(*) BASED;              /* THIRD KEY SAVED      */
