* /* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
* /*                                                                 */
* /*     ISAM INTERFACE CONTROL BLOCK  - IICB                        */
* /*                                                                 */
* /*                                                                 */
* /* MACCOMP Y-2 SC1DE/SJD61                                         */
* /* MACSTAT Y-2 73212/Y02113                                @Y021130*/
* /*                                                                 */
* /*     ISAM INTERFACE OPEN CREATES AND INITIALIZES THE IICB.       */
* /*     IT IS USED TO POINT TO THE ISAM (DCB) AND VSAM (ACB         */
* /*     AND RPL) CONTROL BLOCKS AND ASSOCIATED AREAS NEEDED BY      */
* /*     THE ISAM INTERFACE.  IT IS POINTED TO BY THE ISAM DEB       */
* /*     (DEBWKPT5) TO PROVIDE INTEGRITY AND BY THE RPL EXTENSION    */
* /*     (RRLIICB) TO PROVIDE A CONNECTION TO THE VSAM CONTROL BLOCK */
* /*     STRUCTURE.  IT IS FREED BY ISAM INTERFACE CLOSE.            */
* /*                                                                 */
* /* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
* /*                                                                 */
*   DCL  1 IDAIICB            BASED,    /* ISAM INTERFACE CONTROL BLK*/
*          2 IICBID           PTR(8),   /* IICB ID X'80'             */
*          2 *                PTR(8),   /* RESERVED                  */
*          2 IICBLEN          FIXED(15),/* LENGTH OF IICB            */
*          2 IIDCBPTR         PTR(31),  /* DCB POINTER               */
*          2 IIACBPTR         PTR(31),  /* ABC POINTER               */
*          2 IIRPLPTR         PTR(31),  /* RPL POINTER               */
*                                       /* WORK AREA PTR             */
*          2 IIW1CBF          PTR(31),  /* DUMMY SCAN WA PTR         */
*            3 IISAVLRL       FIXED (15), /* SAVE REC LENGTH @Y021130*/
*            3 IIMAXLRL       FIXED (15), /* MAX REC LENGTH  @Y021130*/
*          2 IIKEYPT          PTR(31),  /* KEYSAVE PTR               */
*          2 IIFLAG1          BIT(8),   /* ISAM INTERFACE FLAG BYTE 1*/
*            3 IIFSCAN        BIT(1),   /* SCAN MODE                 */
*            3 IIFGET         BIT(1),   /* FIRST GET                 */
*            3 *              BIT(1),   /* RESERVED                  */
*            3 IIFCLOSE       BIT(1),   /* CLOSE IN PROCESS          */
*            3 IIDATA         BIT(1),   /* DATA ONLY RETRIVAL        */
*            3 IIFTEST        BIT(1),   /* LOOP TEST BIT             */
*            3 *              BIT(1),   /* RESERVED                  */
*            3 IIQBFRS        BIT(1),   /* QISAM W/O BFRS-NO FREEMAIN*/
*                                       /* GETMAIN/FREEMAIN LENGTHS  */
*          2 IIACBL           FIXED(24),/* ACB,EXLST,IICB LENGTH     */
*          2 IIFLAG2          BIT(8),   /* ISAM INTERFACE FLAG BYTE 2*/
*                                       /* USED BY OPEN TO DESIGNATE */
*                                       /* THE FIELDS BEING MERGED   */
*                                       /* BY II.  II CLOSE USES THE */
*                                       /* SAME MASK TO RESTORE THE  */
*                                       /* DCB TO PRE-OPEN CONDITION */
*            3 MRKP      BIT (1),       /* RELATIVE KEY POSITION     */
*            3 MLRECL    BIT (1),       /* LOGICAL RECORD LENGTH     */
*            3 MBLKSI    BIT (1),       /* BLOCK SIZE                */
*            3 MOPTCD    BIT (1),       /* OPTION CODE               */
*            3 MRECFM    BIT (1),       /* RECORD FORMAT             */
*            3 MBUFL     BIT (1),       /* BUFFER LENGTH             */
*            3 MBUFNO    BIT (1),       /* BUFFER NUMBER             */
*            3 MKEYLE    BIT (1),       /* KEY LENGTH                */
*          2 IIRPLL           FIXED(24),/* RPL, RPLE LENGTH-FREEMAIN */
*          2 IIKEYSL          FIXED(15),/* KEY SAVE AREA LENGTH      */
*          2 IIBUFL           FIXED(15),/* II SINGLE BUFFER LENGTH   */
*          2 IIFLAG3          BIT(8),   /* ISAM INTERFACE FLAG BYTE 3*/
*            3 MBFALN         BIT(1),   /* BFALN MERGE BIT           */
*            3 *              BIT(7),   /* RESERVED                  */
*          2 IIMSGL           FIXED(24),/* MESSAGE AREA LENGTH       */
*          2 IIMSGPTR         PTR(31),  /* MESSAGE AREA POINTER      */
*          2 IIBUFNO          PTR(8),   /* II BUFFER NUMBER          */
*          2 IITBUFL          FIXED(24),/* TOTAL BCB & BUFFER LENGTH */
*          2 IISVCLST         PTR(31),  /* SVC EXIT - SYNADAF        */
*          2 IISAMSYN         CHAR(8),  /* ISAM SYNAD NAME           */
*          2 IIREGSAV,                  /* REG SAVE AREA (II - VSAM) */
*            3 *              PTR(31),  /*                           */
*            3 IIREGBC        PTR(31),  /* PREVIOUS SAVE AREA PTR    */
*            3 IIREGFC        PTR(31),  /* NEXT SAVE AREA PTR        */
*            3 *              CHAR(60), /* REMAINDER OF SAVE AREA    */
*          2 IIAUD  ,                   /* AUDIT INFORMATION @Y021130*/
*            3 IIAUDHDR ,               /* FIRST WORD        @Y021130*/
*             4 IIAUDFL1      BIT(8),   /* II AUDIT FLAGS    @Y021130*/
*              5 AUDACBOP  BIT (1),     /* ACB OPEN ISSUED   @Y021130*/
*              5 AUDACBRO  BIT (1),     /* ACB OPEN RETURNED @Y021130*/
*              5 AUDDCBEX  BIT (1),     /* DCB EXIT TAKEN    @Y021130*/
*              5 AUDDCBRT  BIT (1),     /* DCB EXIT RETURNED @Y021130*/
*              5 AUDPRMOD  BIT (2),     /* PROCESSING MOD LOADED     */
*                                       /* '11' = IDAIIPM3   @Y021130*/
*                                       /* '10' = IDAIIPM2   @Y021130*/
*                                       /* '01' = IDAIIPM1   @Y021130*/
*              5 AUDIISYN  BIT (1),     /* II SYNAD LOADED   @Y021130*/
*              5 AUDURSYN  BIT (1),     /* USER SYNAD LOADED @Y021130*/
*             4 IIAUDFL2      BIT(8),   /* II AUDIT FLAGS    @Y021130*/
*              5 AUDIIFBF  BIT (1),     /* IDAIIFBF LOADED   @Y021130*/
*              5 AUDACBCL  BIT (1),     /* ACB CLOSE ISSUED  @Y021130*/
*              5 AUDACBRC  BIT (1),     /* ACB CLOSE RETURN  @Y021130*/
*              5 AUDBFREX  BIT (1),     /* FLUSH BFR EXIT    @Y021130*/
*              5 AUDBFRRT  BIT (1),     /* FLUSH BFR RETURN  @Y021130*/
*              5 AUDDEBXF  BIT (1),     /* DEB EXTENSION FREED       */
*              5 *         BIT (2),     /* UNUSED            @Y021130*/
*             4 IIGMCNTR   FIXED (15),  /* USED FOR OFFSET TO ENTRY  */
*                                       /* OF GOTTEN CORE    @Y021130*/
*            3 IIGMAUD ,                /* LIST OF CORE ADDRESSES    */
*                                       /* GOTTEN            @Y021130*/
*             4 AUDCIICB      PTR (31), /* ADDR IICB         @Y021130*/
*             4 AUDCSPLI      PTR (32), /* SUBPOOL/LENGTH    @Y021130*/
*              5 AUDCSPI    FIXED (8),  /* SUBPOOL           @Y021130*/
*              5 AUDCLI     FIXED (24), /* LENGTH            @Y021130*/
*             4 AUDCDEB       PTR (31), /* ADDR DEB          @Y021130*/
*             4 AUDCSPLD      PTR (32), /* SUBPOOL/LENGTH    @Y021130*/
*              5 AUDCSPD    FIXED (8),  /* SUBPOOL           @Y021130*/
*              5 AUDCLD     FIXED (24), /* LENGTH            @Y021130*/
*             4 AUDCBFRS      PTR (31), /* BUFFERS,RPLS,ETC  @Y021130*/
*             4 AUDCSPLB      PTR (32), /* SUBPOOL/LENGTH    @Y021130*/
*              5 AUDCSPB    FIXED (8),  /* SUBPOOL           @Y021130*/
*              5 AUDCLB     FIXED (24), /* LENGTH            @Y021130*/
*             4 AUDCMSGA      PTR (31), /* MESSAGE AREA      @Y021130*/
*             4 AUDCSPLM      PTR (32), /* SUBPOOL/LENGTH    @Y021130*/
*              5 AUDCSPM    FIXED (8),  /* SUBPOOL           @Y021130*/
*              5 AUDCLM     FIXED (24); /* LENGTH            @Y021130*/
*        /* AUDIT GETMAIN ENTRY DESCRIPTION                  @Y021130*/
*        DCL 1 IIGMNTRY BASED (ADDR(IIAUD)+IIGMCNTR), /* DESCRIPTION */
*                                       /* OF GOTTEN CORE ENTRIES    */
*          2 IIGMADDR     PTR(31),      /* ADDRESS OF CORE   @Y021130*/
*          2 IIGMSPLG ,                 /* SUBPOOL/LENGTH    @Y021130*/
*            3 IIGMPOOL   FIXED(8),     /* SUBPOOL           @Y021130*/
*            3 IIGMLEN    FIXED (24);   /* LENGTH            @Y021130*/
