         TITLE 'IDAIIPM2--ISAM INTERFACE SCAN                          *
                        '
IDAIIPM2 CSECT ,                                                   0001
@PROLOG  DS    0H                                                  0002
@PSTART  EQU   *                           LABEL FOR PATCH MACRO
         DC    A(IIGET)                    /* ENTRY ADDR FOR GET    */
         DC    A(IISETL)                   /* ENTRY ADDR FOR SETL   */
         DC    A(IIESETL)                  /* ENTRY ADDR FOR ESETL  */
         DC    A(IIEODAD)                  /* ENTRY ADDR FOR EODAD  */
* /******************************************************************/
* /*                                                                */
* /*               BRANCH TABLE                                     */
* /*                                                                */
* /******************************************************************/
         USING *,R15                       /* ENTRY ADDRESSABILITY  */
IIGET    B     GETRTNE                     /* ENTRY FOR GET         */
         B     IIPUTX                      /* BRANCH TO PUTX EP     */
         B     IIRELSE                     /* BRANCH TO RELSE EP    */
*        /* CHANGE ADDRESSABILITY REGISTER                          */
         DROP  R15                         /* STOP USING R15 AS BASE*/
         USING IIGET,R11                   /* USE R11 AS A BASE REG */
         EJECT                             /* SKIP TO NEW PAGE      */
* /******************************************************************/
* /*                                                                */
* /*                 SETL MACRO ENTRY POINT                         */
* /*                                                                */
* /******************************************************************/
IISETL   STM   R14,R12,12(R13)             /* SAVE USER'S REGS      */
*   R11=DCBGET;                     /* ESTABLISH BASE REG            */
         L     R11,DCBGET+48(,RDCB)                                0168
*   RIICB=DEBWKPT5;                 /* SET IICB BASE                 */
         L     @14,DCBDEBAD+40(,RDCB)                              0169
         L     @14,DEBEXPT(,@14)                                   0169
         L     RIICB,DEBWKPT5(,@14)                                0169
*   IIREGBC=R13;                    /* KEEP PTR TO USER SAVE         */
         ST    R13,IIREGBC(,RIICB)                                 0170
*   R15=ADDR(IIREGSAV);             /* HOLD II SAVE ADDR             */
         LA    R15,IIREGSAV(,RIICB)                                0171
*   GEN(ST R15,8(0,R13));           /* STORE IT IN USER SAVE         */
         ST R15,8(0,R13)
*   R13=R15;                        /* ESTABLISH SAVE PTR            */
         LR    R13,R15                                             0173
*   RRPL=IIRPLPTR;                  /* ESTABLISH RPL BASE            */
         L     RRPL,IIRPLPTR(,RIICB)                               0174
*   IIKEYPT=R0;                     /* SETL TYPE CODE                */
         ST    R0,IIKEYPT(,RIICB)                                  0175
*   RFY                                                            0176
*    (R0,                                                          0176
*     R15) UNRSTD;                  /* DROP REGISTERS                */
*   DCBEXCD1=CZERO;                 /* CLEAR ERROR FLAGS             */
         LA    @12,52                                              0177
         ALR   @12,RDCB                                            0177
         MVI   DCBEXCD1(@12),B'00000000'                           0177
*   DCBEXCD2=CZERO;                 /* CLEAR ERROR FLAGS CONSECUTIVE
*                                      SETL'S?                       */
         MVI   DCBEXCD2(@12),B'00000000'                           0178
*   IF IIFSCAN=ON THEN              /* SCAN BIT ON?                  */
         TM    IIFSCAN(RIICB),B'10000000'                          0179
         BO    @RT00179                                            0179
*     GOTO INVALID;                 /* YES, --- INVALID REQ          */
*/* ******************************************************************/
*/*                                                                  */
*/*         DETERMINE SEARCH LOGIC FOR VSAM POINT:                   */
*/*                                                                  */
*/*            ISAM SETL K = VSAM POINT KEQ, FKS                     */
*/*            ISAM SETL KH = VSAM POINT KGE, FKS                    */
*/*            ISAM SETL KC = VSAM POINT GEN, KEQ            @XA05682*/
*/*            ISAM SETL B  = VSAM POINT KGE, GEN WITH KEY = ZERO    */
*/*                           AND VSAM KEY LENGTH FOR GENERIC SETL   */
*/*                                                                  */
*/* ******************************************************************/
*                                                                  0181
*   RPLGEN=OFF;                     /* ASSUME A FULL KEY SCH         */
*   RPLKGE=OFF;                     /* AND FOR KEY EQUAL             */
         NI    RPLGEN(RRPL),B'11111001'                            0182
*   RPLARG=KEYPTR;                  /* PUT KEY POINTER IN RPL        */
         L     @12,IIREGBC(,RIICB)                                 0183
         L     @10,KEYPTR-1(,@12)                                  0183
         LA    @10,0(,@10)                                         0183
         ST    @10,RPLARG(,RRPL)                                   0183
*   IF SETLDAT=ON THEN              /* IF DATA ONLY RETRIEVAL,       */
         TM    SETLDAT(@12),B'00001000'                            0184
         BNO   @RF00184                                            0184
*     IIDATA=ON;                    /* SET FLAG IN THE               */
         OI    IIDATA(RIICB),B'00001000'                           0185
*   ELSE                                                           0186
*     IIDATA=OFF;                   /* IICB.                         */
         B     @RC00184                                            0186
@RF00184 NI    IIDATA(RIICB),B'11110111'                           0186
*   IF SETLKEY=ON THEN              /* IF SETL BY KEY, CHECK         */
@RC00184 L     @12,IIREGBC(,RIICB)                                 0187
         TM    SETLKEY(@12),B'10000000'                            0187
         BNO   @RF00187                                            0187
*     DO;                           /* SEARCH LOGIC DESIRED          */
*       IF SETLKGE=ON THEN          /* IF SEARCH HIGH / EQUAL        */
         TM    SETLKGE(@12),B'00000010'                            0189
         BNO   @RF00189                                            0189
*         RPLKGE=ON;                /* INDICATE GT/EQ SEARCH         */
         OI    RPLKGE(RRPL),B'00000100'                            0190
*                                                                  0191
*       /*************************************************************/
*       /*                                                           */
*       /* IF GENERIC, DETERMINE NUMBER OF KEY BYTES FOR SEARCH.     */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0191
*       ELSE                        /* IF NOT SEARCH HIGH OR         */
*         IF SETLGEN=ON THEN        /* EQUAL, BUT GENERIC            */
         B     @RC00189                                            0191
@RF00189 L     @12,IIREGBC(,RIICB)                                 0191
         TM    SETLGEN(@12),B'01000000'                            0191
         BNO   @RF00191                                            0191
*           DO;                     /* SEARCH, INDICATE A            */
*             RPLGEN=ON;            /* GENERIC SEARCH TO VSAM SEARCH
*                                      KEQ TO ALLOW KEY NOT FOUND  0193
*                                                            @XA05682*/
         OI    RPLGEN(RRPL),B'00000010'                            0193
*             RFY                                                  0194
*               RWORK1 RSTD;        /* GET WORK REGISTER             */
*             RWORK1=KEYPTR+DCBKEYLE-ONE;/* A(LAST KEY BYTE)         */
         L     RWORK1,KEYPTR-1(,@12)                               0195
         LA    RWORK1,0(,RWORK1)                                   0195
         SLR   @12,@12                                             0195
         IC    @12,DCBKEYLE+16(,RDCB)                              0195
         ALR   RWORK1,@12                                          0195
         BCTR  RWORK1,0                                            0195
*             DO WHILE KEYBYTE=CZERO;/* LOOP UNTIL WE LOCATE A       */
         B     @DE00196                                            0196
@DL00196 DS    0H                                                  0197
*               RWORK1=RWORK1-ONE;  /* NON-ZERO KEY BYTE             */
         BCTR  RWORK1,0                                            0197
*             END;                  /* END OF SEARCH                 */
@DE00196 CLI   KEYBYTE(RWORK1),B'00000000'                         0198
         BE    @DL00196                                            0198
*             RPLKEYLE=RWORK1-KEYPTR+ONE;/* SET LENGTH IN RPL        */
         LA    @12,1                                               0199
         L     @10,IIREGBC(,RIICB)                                 0199
         LR    @07,RWORK1                                          0199
         L     @10,KEYPTR-1(,@10)                                  0199
         LA    @10,0(,@10)                                         0199
         SLR   @07,@10                                             0199
         ALR   @07,@12                                             0199
         STH   @07,RPLKEYLE(,RRPL)                                 0199
*             IF RPLKEYLE<ONE THEN  /* SEE IF KEY ALL 0              */
         CR    @07,@12                                             0200
         BL    @RT00200                                            0200
*               GO TO INVALID;      /* IF SO, INVALID REQ            */
*           END;                    /* END OF GENERIC CODE           */
*         ELSE                                                     0203
*           ;                       /* HERE IF NOT GEN/KH            */
@RF00191 DS    0H                                                  0204
*     END;                          /* END OF SETL K CODE            */
*                                                                  0204
*   /*****************************************************************/
*   /*                                                               */
*   /* IF SETL TO BEGINNING, SET DUMMY KEY OF ZERO FOR SEARCH.       */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0205
*   ELSE                            /* IF NOT A SETL K, SEE IF       */
*     DO;                                                          0205
         B     @RC00187                                            0205
@RF00187 DS    0H                                                  0206
*       IF SETLBEG=ON THEN          /* IT IS A SETL B.               */
         L     @12,IIREGBC(,RIICB)                                 0206
         TM    SETLBEG(@12),B'00010000'                            0206
         BNO   @RF00206                                            0206
*         CALL SETLB;               /* IF SO, POINT TO ZERO          */
         BAL   @14,SETLB                                           0207
*       ELSE                        /* IF NONE OF THE ABOVE,         */
*         DO;                       /* IT IS AN UNKNOWN SETL         */
         B     @RC00206                                            0208
@RF00206 DS    0H                                                  0209
*INVALID:                                                          0209
*           DCBEXINV=ON;            /* INDICATE INVALID REQ          */
INVALID  OI    DCBEXINV+52(RDCB),B'00010000'                       0209
*           GO TO ERROR;            /* EXIT                          */
         B     ERROR                                               0210
*         END;                      /* END OF INVALID REQ CODE       */
*     END;                          /* END OF NON-SETL K CODE        */
@RC00206 DS    0H                                                  0213
*                                                                  0213
*   /*****************************************************************/
*   /*                                                               */
*   /* ISSUE VSAM POINT. IF THE SETL WAS BY KEY, ISSUE A GET SO THAT */
*   /* IF THE RECORD IS MARKED FOR DELETION A NO RECORD FOUND        */
*   /* CONDITION CAN BE INDICATED.                                   */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0213
*   RWORK1=RDCB;                    /* SAVE DCB ADDRESS              */
@RC00187 LR    RWORK1,RDCB                                         0213
*   RDCB=RRPL;                      /* GET RPL ADDRESS INTO R1 ISSUE
*                                      VSAM POINT                    */
         LR    RDCB,RRPL                                           0214
*   GEN(POINT RPL=(1));             /*                               */
         POINT RPL=(1)
*   RDCB=RWORK1;                    /* RESTORE DCB BASE              */
         LR    RDCB,RWORK1                                         0216
*   IF RPLERRCD=RPLNOPLH THEN       /* IF NO PLACEHOLDER,            */
         CLI   RPLERRCD(RRPL),64                                   0217
         BE    @RT00217                                            0217
*     GO TO INVALID;                /* SET INVALID REQUEST           */
*   IF RPLGEN=OFF&                  /* IF SETL BY KEY (NOT B         */
*       RPLKGE=OFF&                 /* H OR C) CHECK FOR A           */
*       DCBOPTL=ON THEN             /* SETL TO A DELETED REC.        */
         TM    RPLGEN(RRPL),B'00000110'                            0219
         BNZ   @RF00219                                            0219
         TM    DCBOPTL+52(RDCB),B'00000010'                        0219
         BNO   @RF00219                                            0219
*     DO;                           /* SET NO RECORD FOUND           */
*       RPLAREA=RPLIIBFR;           /* POINT TO II BUFFER            */
         L     @12,RPLIIBFR+76(,RRPL)                              0221
         ST    @12,RPLAREA(,RRPL)                                  0221
*       IF DCBRECL='01'B THEN       /* IF VLR, LEAVE RDW SPACE AT  0222
*                                      BEGINNING OF BUFFER           */
         TM    DCBRECL+28(RDCB),B'01000000'                        0222
         BNO   @RF00222                                            0222
         TM    DCBRECL+28(RDCB),B'10000000'                        0222
         BNZ   @RF00222                                            0222
*         RPLAREA=RPLAREA+LENGTH(ALLRDW);/* POINT PAST RDW           */
         AL    @12,@CF00183                                        0223
         ST    @12,RPLAREA(,RRPL)                                  0223
*       RWORK1=RDCB;                /* SAVE DCB ADDRESS              */
@RF00222 LR    RWORK1,RDCB                                         0224
*       RDCB=RRPL;                  /* GET A (RPL) IN R1 ISSUE VSAM
*                                      GET                           */
         LR    RDCB,RRPL                                           0225
*       GEN(GET   RPL=(1));         /*                               */
         GET   RPL=(1)
*       RDCB=RWORK1;                /* RESTORE DCB ADDRESS           */
         LR    RDCB,RWORK1                                         0227
*       IF DCBRECL='01'B THEN       /* SEE IF VLR                    */
         TM    DCBRECL+28(RDCB),B'01000000'                        0228
         BNO   @RF00228                                            0228
         TM    DCBRECL+28(RDCB),B'10000000'                        0228
         BNZ   @RF00228                                            0228
*         DO;                       /* IF SO, MAKE AN RDW            */
*           RPLIIBFR->RDW=RPLRLEN+LENGTH(ALLRDW);/* SET RDW LENGTH   */
         L     @12,RPLIIBFR+76(,RRPL)                              0230
         LA    @10,4                                               0230
         AL    @10,RPLRLEN(,RRPL)                                  0230
         STH   @10,RDW(,@12)                                       0230
*           RPLIIBFR->RDW00=ZERO;   /* SET UNUSED TO ZERO            */
         SLR   @10,@10                                             0231
         STH   @10,RDW00(,@12)                                     0231
*         END;                      /* END OF VLR RDW CODE           */
*       IF DCBRKP=ZERO THEN         /* FIND DELETE CODE BYTE         */
@RF00228 LH    @12,DCBRKP+52(,RDCB)                                0233
         LTR   @12,@12                                             0233
         BNZ   @RF00233                                            0233
*         RWORK1=RPLAREA+DCBKEYLE;  /* POINT TO 1ST DATA BYTE        */
         SLR   RWORK1,RWORK1                                       0234
         IC    RWORK1,DCBKEYLE+16(,RDCB)                           0234
         AL    RWORK1,RPLAREA(,RRPL)                               0234
*       ELSE                                                       0235
*         RWORK1=RPLAREA;           /* ALLOW FOR KEY IF RKP=0        */
         B     @RC00233                                            0235
@RF00233 L     RWORK1,RPLAREA(,RRPL)                               0235
*       IF DATABYT1=DELCODE THEN    /* IF DELETED RECORD,            */
@RC00233 CLI   DATABYT1(RWORK1),B'11111111'                        0236
         BNE   @RF00236                                            0236
*         DO;                       /* SET NO RECORD FOUND           */
*           DCBEXNKY=ON;            /* INDICATE KEY NOT FOUND        */
         OI    DCBEXNKY+52(RDCB),B'10000000'                       0238
*           GO TO ERROR;            /* EXIT                          */
         B     ERROR                                               0239
*         END;                      /* END OF NO RECORD FOUND        */
*       IIFGET=ON;                  /* TELL 1ST GET REC HERE         */
@RF00236 OI    IIFGET(RIICB),B'01000000'                           0241
*     END;                          /* END OF DELETE REC CHECK       */
*   DCBEXOFL=ON;                    /* INDICATE OVERFLOW             */
@RF00219 OI    DCBEXOFL+52(RDCB),B'00010000'                       0243
*   IIFSCAN=ON;                     /* INDICATE GOOD SETL            */
         OI    IIFSCAN(RIICB),B'10000000'                          0244
*   GO TO PM2EXIT;                  /* RETURN TO USER                */
         B     PM2EXIT                                             0245
*                                                                  0246
*/* **************************************************************** */
*/*                                                                  */
*/*        GET MACRO ENTRY POINT FROM BRANCH TABLE                   */
*/*                                                                  */
*/* **************************************************************** */
*                                                                  0246
*GETRTNE:                           /* TARGET FROM BRANCH TBL        */
*   GEN(STM R14,R12,12(R13));       /* SAVE USER'S REGS              */
GETRTNE  STM R14,R12,12(R13)
*   RFY                                                            0247
*    (R0,                                                          0247
*     R15) RSTD;                    /* GET REGISTERS                 */
*   R11=R15;                        /* LOAD BASE ADDR                */
         LR    R11,R15                                             0248
*   RIICB=DEBWKPT5;                 /* SET IICB BASE                 */
         L     @14,DCBDEBAD+40(,RDCB)                              0249
         L     @14,DEBEXPT(,@14)                                   0249
         L     RIICB,DEBWKPT5(,@14)                                0249
*   IIREGBC=R13;                    /* SAVE BACKCHAIN PTR            */
         ST    R13,IIREGBC(,RIICB)                                 0250
*   R15=ADDR(IIREGSAV);             /* HOLD II SAVE ADDR             */
         LA    R15,IIREGSAV(,RIICB)                                0251
*   GEN(ST  R15,8(0,R13));          /* STORE IT IN USER SAVE         */
         ST  R15,8(0,R13)
*   R13=R15;                        /* II SAVE PTR IN R13            */
         LR    R13,R15                                             0253
*   RRPL=IIRPLPTR;                  /* ESTABLISH RPL BASE            */
         L     RRPL,IIRPLPTR(,RIICB)                               0254
*   RFY                                                            0255
*     R8 RSTD;                      /* GET A WORK REGISTER           */
*   R8=R0;                          /* SAVE USER BFR ADDRESS         */
         LR    R8,R0                                               0256
*   RFY                                                            0257
*    (R0,                                                          0257
*     R15) UNRSTD;                  /* DROP REGISTERS                */
*   DCBEXCD1=CZERO;                 /* CLEAR THE ERROR FLAGS         */
         LA    @12,52                                              0258
         ALR   @12,RDCB                                            0258
         MVI   DCBEXCD1(@12),B'00000000'                           0258
*   DCBEXCD2=CZERO;                 /* IN THE DCB                    */
*                                                                  0259
         MVI   DCBEXCD2(@12),B'00000000'                           0259
*   /*****************************************************************/
*   /*                                                               */
*   /* IF NOT YET IN SCAN MODE, A SETL BD IS IMPLIED.                */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0260
*   IF IIFSCAN=OFF THEN             /* IF GET WITHOUT SETL,          */
         TM    IIFSCAN(RIICB),B'10000000'                          0260
         BNZ   @RF00260                                            0260
*     DO;                           /* A SETL B IS IMPLIED.          */
*       CALL SETLB;                 /* SET UP RPL FOR POINT          */
         BAL   @14,SETLB                                           0262
*       RWORK1=RDCB;                /* SAVE DCB ADDRESS              */
         LR    RWORK1,RDCB                                         0263
*       RDCB=RRPL;                  /* GET RPL ADDRESS INTO R1 ISSUE
*                                      VSAM POINT                    */
         LR    RDCB,RRPL                                           0264
*       GEN(POINT RPL=(1));         /*                               */
         POINT RPL=(1)
*       RDCB=RWORK1;                /* RESTORE DCB BASE              */
         LR    RDCB,RWORK1                                         0266
*       KEYADDR=R8;                 /* RESTORE USER REG 0            */
         L     @12,IIREGBC(,RIICB)                                 0267
         ST    R8,KEYADDR(,@12)                                    0267
*       IF RPLERRCD=RPLNOPLH THEN   /* IF NO PLACEHOLDER,            */
         CLI   RPLERRCD(RRPL),64                                   0268
         BE    @RT00268                                            0268
*         GO TO INVALID;            /* SET INVALID REQUEST           */
*       IIFSCAN=ON;                 /* INDICATE SCAN                 */
*       IIDATA=OFF;                 /* SET KEY/DATA RETRIEVAL        */
         OI    IIFSCAN(RIICB),B'10000000'                          0271
         NI    IIDATA(RIICB),B'11110111'                           0271
*     END;                          /* END OF IMPLIED SETL B         */
*                                                                  0273
*   /*****************************************************************/
*   /*                                                               */
*   /* IF THIS IS THE FIRST GET AFTER A SETL (KEQ AND FKS) THEN THE  */
*   /* FIRST VSAM GET HAS ALREADY BEEN ISSUED. ALL THAT IS NECESSARY */
*   /* IS TO MOVE THE RECORD FROM THE ISAM INTERFACE BUFFER TO THE   */
*   /* USER AREA                                                     */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0273
*   IF IIFGET=ON THEN               /* WAS FIRST RECORD READ DURING  */
@RF00260 TM    IIFGET(RIICB),B'01000000'                           0273
         BNO   @RF00273                                            0273
*     DO;                           /* SETL? IF SO, BYPASS VSAM      */
*       IIFGET=OFF;                 /* GET & RESET FIRST GET BIT     */
         NI    IIFGET(RIICB),B'10111111'                           0275
*       IF DCBMFLCG=OFF&            /* IF RECORD WOULD HAVE BEEN     */
*           IIDATA=OFF THEN         /* READ INTO THE USER BUFFER,    */
         TM    DCBMFLCG+40(RDCB),B'00001000'                       0276
         BNZ   @RF00276                                            0276
         TM    IIDATA(RIICB),B'00001000'                           0276
         BNZ   @RF00276                                            0276
*         DO;                       /* THEN MOVE IT THERE.           */
*           RFY                                                    0278
*            (R4,                                                  0278
*             R5,                                                  0278
*             R6,                                                  0278
*             R7) RSTD;             /* GET REGS FOR MVCL             */
*           IF DCBRECBR=OFF&        /* IF RECORDS ARE UNBLOCKED      */
*               DCBRKP^=ZERO THEN   /* AND KEYS ARE EMBEDDED,        */
         TM    DCBRECBR+28(RDCB),B'00010000'                       0279
         BNZ   @RF00279                                            0279
         LH    @12,DCBRKP+52(,RDCB)                                0279
         LTR   @12,@12                                             0279
         BZ    @RF00279                                            0279
*             R4=R8+DCBKEYLE;       /* ALLOW FOR KEY MOVE            */
         LR    R4,R8                                               0280
         SLR   @12,@12                                             0280
         IC    @12,DCBKEYLE+16(,RDCB)                              0280
         ALR   R4,@12                                              0280
*           ELSE                                                   0281
*             R4=R8;                /* ELSE, MOVE TO BUFFER START    */
         B     @RC00279                                            0281
@RF00279 LR    R4,R8                                               0281
*           R6=RPLIIBFR;            /* GET FROM ADDRESS              */
@RC00279 L     R6,RPLIIBFR+76(,RRPL)                               0282
*           IF DCBRECL='01'B THEN   /* IF VLR, LENGTH FROM RDW       */
         TM    DCBRECL+28(RDCB),B'01000000'                        0283
         BNO   @RF00283                                            0283
         TM    DCBRECL+28(RDCB),B'10000000'                        0283
         BNZ   @RF00283                                            0283
*             R5=R6->RDW;           /* AND FOR FLR THE LENGTH        */
         LH    R5,RDW(,R6)                                         0284
*           ELSE                    /* IS DCB LRECL                  */
*             IF DCBRKP=ZERO&       /* IF NON-EMBEDDED               */
*                 DCBRECBR=OFF THEN /* KEY, THEN LRECL               */
         B     @RC00283                                            0285
@RF00283 LA    @12,52                                              0285
         ALR   @12,RDCB                                            0285
         LH    @10,DCBRKP(,@12)                                    0285
         LTR   @10,@10                                             0285
         BNZ   @RF00285                                            0285
         TM    DCBRECBR+28(RDCB),B'00010000'                       0285
         BNZ   @RF00285                                            0285
*               R5=DCBLRECL+DCBKEYLE;/* DOES NOT                     */
         SLR   R5,R5                                               0286
         IC    R5,DCBKEYLE+16(,RDCB)                               0286
         AH    R5,DCBLRECL(,@12)                                   0286
*             ELSE                                                 0287
*               R5=DCBLRECL;        /* INCLUDE THE KEY LENGTH        */
         B     @RC00285                                            0287
@RF00285 LH    R5,DCBLRECL+52(,RDCB)                               0287
*           R7=R5;                  /* LENGTH IN BOTH ODD REGS       */
@RC00285 DS    0H                                                  0288
@RC00283 LR    R7,R5                                               0288
*           GEN(MVCL  R4,R6);       /* MOVE RECORD TO USER BFR       */
         MVCL  R4,R6
*           RFY                                                    0290
*            (R4,                                                  0290
*             R5,                                                  0290
*             R6,                                                  0290
*             R7) UNRSTD;           /* RELEASE WORK REGISTERS        */
*         END;                      /* END OF 1ST GET DATA MVC       */
*     END;                          /* END OF 1ST GET CODE           */
*                                                                  0293
*   /*****************************************************************/
*   /*                                                               */
*   /* FOR NON-FIRST ISAM GET SET UP AREA ADDRESS AND ISSUE VSAM GET.*/
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0293
*   ELSE                            /* HERE IF NOT THE FIRST         */
*     DO;                           /* GET AFTER A SETL K            */
         B     @RC00273                                            0293
@RF00273 DS    0H                                                  0294
*       IF DCBMFLCG=ON|             /* IF LOCATE MODE OR IF          */
*           IIDATA=ON THEN          /* A DATA ONLY RETRIEVAL,        */
         TM    DCBMFLCG+40(RDCB),B'00001000'                       0294
         BO    @RT00294                                            0294
         TM    IIDATA(RIICB),B'00001000'                           0294
         BNO   @RF00294                                            0294
@RT00294 DS    0H                                                  0295
*         RPLAREA=RPLIIBFR;         /* USE THE II BUFFER.            */
         L     @12,RPLIIBFR+76(,RRPL)                              0295
         ST    @12,RPLAREA(,RRPL)                                  0295
*       ELSE                        /* READ INTO USER BUFFER.        */
*         IF DCBRECBR=OFF&          /* IF KEY NOT EMBEDDED AND       */
*             DCBRKP^=ZERO THEN     /* RECORD UNBLOCKED, ALLOW       */
         B     @RC00294                                            0296
@RF00294 TM    DCBRECBR+28(RDCB),B'00010000'                       0296
         BNZ   @RF00296                                            0296
         LH    @12,DCBRKP+52(,RDCB)                                0296
         LTR   @12,@12                                             0296
         BZ    @RF00296                                            0296
*           RPLAREA=R8+DCBKEYLE;    /* ROOM FOR EXTRACTED KEY        */
         LR    @12,R8                                              0297
         SLR   @10,@10                                             0297
         IC    @10,DCBKEYLE+16(,RDCB)                              0297
         ALR   @12,@10                                             0297
         ST    @12,RPLAREA(,RRPL)                                  0297
*         ELSE                                                     0298
*           RPLAREA=R8;             /* AT START OF USER AREA.        */
         B     @RC00296                                            0298
@RF00296 ST    R8,RPLAREA(,RRPL)                                   0298
*       IF DCBRECL='01'B THEN       /* IF VLR, LEAVE RDW SPACE       */
@RC00296 DS    0H                                                  0299
@RC00294 TM    DCBRECL+28(RDCB),B'01000000'                        0299
         BNO   @RF00299                                            0299
         TM    DCBRECL+28(RDCB),B'10000000'                        0299
         BNZ   @RF00299                                            0299
*         RPLAREA=RPLAREA+LENGTH(ALLRDW);/* AT FRONT OF BUFFER       */
         LA    @12,4                                               0300
         AL    @12,RPLAREA(,RRPL)                                  0300
         ST    @12,RPLAREA(,RRPL)                                  0300
*       RFY                                                        0301
*         R4 RSTD;                  /* GET NEW DCB BASE REG          */
@RF00299 DS    0H                                                  0302
*       R4=RDCB;                    /* SAVE DCB ADDRESS              */
         LR    R4,RDCB                                             0302
*       RFY                                                        0303
*         IHADCB BASED(R4);         /* NEW DCB BASE                  */
*       RDCB=RRPL;                  /* GET RPL POINTER IN R1 ISSUE 0304
*                                      VSAM GET                      */
         LR    RDCB,RRPL                                           0304
*       GEN(GET   RPL=(1));         /*                               */
*                                                                  0305
         GET   RPL=(1)
*       /*************************************************************/
*       /*                                                           */
*       /* IF THE RECORD IS DELETED, ISSUE SEQUENTIAL GETS UNTIL A   */
*       /* NON- DELETED RECORD IS FOUND.                             */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0306
*       IF DCBOPTL=ON THEN          /* IF DELETE OPTION ON           */
         LA    @12,52                                              0306
         ALR   @12,R4                                              0306
         TM    DCBOPTL(@12),B'00000010'                            0306
         BNO   @RF00306                                            0306
*         DO;                       /* CHECK FOR DELETED RCD         */
*           RFY                                                    0308
*             R5 RSTD;              /* GET WORK REGISTER             */
*           IF DCBRKP=ZERO THEN     /* IF RKP = 0 (RECFM=F           */
         LH    @12,DCBRKP(,@12)                                    0309
         LTR   @12,@12                                             0309
         BNZ   @RF00309                                            0309
*             R5=RPLAREA+DCBKEYLE;  /* IMPLIED) PT PAST KEY          */
         SLR   R5,R5                                               0310
         IC    R5,DCBKEYLE+16(,R4)                                 0310
         AL    R5,RPLAREA(,RRPL)                                   0310
*           ELSE                                                   0311
*             R5=RPLAREA;           /* OTHERWISE 1ST BYTE            */
         B     @RC00309                                            0311
@RF00309 L     R5,RPLAREA(,RRPL)                                   0311
*           DO WHILE R5->DATABYT1=DELCODE;/* LOOP UNTIL NON-DELETE   */
@RC00309 B     @DE00312                                            0312
@DL00312 DS    0H                                                  0313
*             GEN(GET   RPL=(1));   /* GET NEXT RECORD               */
         GET   RPL=(1)
*           END;                    /* END OF DELETE REC LOOP        */
@DE00312 CLI   DATABYT1(R5),B'11111111'                            0314
         BE    @DL00312                                            0314
*         END;                      /* END OF DELETE OPTION          */
*       RDCB=R4;                    /* RESTORE DCB BASE              */
@RF00306 LR    RDCB,R4                                             0316
*       RFY                                                        0317
*         IHADCB BASED(RDCB);       /* OLD DCB BASE                  */
*                                                                  0318
*       /*************************************************************/
*       /*                                                           */
*       /* IF THE RECORDS ARE VARIABLE, BUILD A RECORD DESCRIPTOR    */
*       /* WORD.                                                     */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0318
*       IF DCBRECL='01'B THEN       /* IF VLR, SET UP AN RDW         */
         TM    DCBRECL+28(RDCB),B'01000000'                        0318
         BNO   @RF00318                                            0318
         TM    DCBRECL+28(RDCB),B'10000000'                        0318
         BNZ   @RF00318                                            0318
*         DO;                       /* IN FRONT OF THE RECORD        */
*           R4=RPLAREA-LENGTH(ALLRDW);/* POINT TO RDW SLOT           */
         LA    @12,4                                               0320
         L     R4,RPLAREA(,RRPL)                                   0320
         SLR   R4,@12                                              0320
*           R4->RDW=RPLRLEN+LENGTH(ALLRDW);/* SET RECORD LENGTH      */
         AL    @12,RPLRLEN(,RRPL)                                  0321
         STH   @12,RDW(,R4)                                        0321
*           R4->RDW00=ZERO;         /* (INCL RDW LENGTH)             */
         SLR   @12,@12                                             0322
         STH   @12,RDW00(,R4)                                      0322
*         END;                      /* END OF RDW CONSTRUCTION       */
*     END;                          /* END OF NON-FIRST GET          */
@RF00318 DS    0H                                                  0325
*   DCBEXOFL=ON;                    /* INDICATE OVERFLOW             */
*                                                                  0325
@RC00273 LA    @12,52                                              0325
         ALR   @12,RDCB                                            0325
         OI    DCBEXOFL(@12),B'00010000'                           0325
*   /*****************************************************************/
*   /*                                                               */
*   /* FOR ALL GETS, ESTABLISH KEY AND DATA POINTERS FOR THE USER OR */
*   /* MOVE RECORD TO USER AREA (DATA ONLY RETRIEVAL). KEYADDR = USER*/
*   /* REGISTER 0 DATADDR = USER REGISTER 1                          */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0326
*   IF DCBMFLCG=ON THEN             /* IF LOCATE MODE, RECORD        */
         TM    DCBMFLCG+40(RDCB),B'00001000'                       0326
         BNO   @RF00326                                            0326
*     DO;                           /* IS IN THE II BUFFER           */
*       IF IIDATA=OFF THEN          /* KEY AND DATA BOTH?            */
         TM    IIDATA(RIICB),B'00001000'                           0328
         BNZ   @RF00328                                            0328
*         KEYADDR=RPLIIBFR+DCBRKP;  /* YES - SET KEY POINTER         */
         L     @10,IIREGBC(,RIICB)                                 0329
         LH    @12,DCBRKP(,@12)                                    0329
         AL    @12,RPLIIBFR+76(,RRPL)                              0329
         ST    @12,KEYADDR(,@10)                                   0329
*       IF DCBRKP=ZERO&             /* IF KEY NOT EMBEDDED           */
*           DCBRECBR=OFF THEN       /* POINT PAST IT.                */
@RF00328 LH    @12,DCBRKP+52(,RDCB)                                0330
         LTR   @12,@12                                             0330
         BNZ   @RF00330                                            0330
         TM    DCBRECBR+28(RDCB),B'00010000'                       0330
         BNZ   @RF00330                                            0330
*         DATADDR=RPLIIBFR+DCBKEYLE;/* OTHERWISE, POINT TO           */
         L     @12,IIREGBC(,RIICB)                                 0331
         SLR   @10,@10                                             0331
         IC    @10,DCBKEYLE+16(,RDCB)                              0331
         AL    @10,RPLIIBFR+76(,RRPL)                              0331
         ST    @10,DATADDR(,@12)                                   0331
*       ELSE                                                       0332
*         DATADDR=RPLIIBFR;         /* THE DATA RECORD.              */
         B     @RC00330                                            0332
@RF00330 L     @12,IIREGBC(,RIICB)                                 0332
         L     @10,RPLIIBFR+76(,RRPL)                              0332
         ST    @10,DATADDR(,@12)                                   0332
*     END;                          /* END OF LOCATE MODE CODE       */
*   ELSE                            /* IF MOVE MODE AND IF           */
*     IF IIDATA=ON THEN             /* DATA ONLY, MOVE DATA. @YA04306*/
         B     @RC00326                                            0334
@RF00326 TM    IIDATA(RIICB),B'00001000'                           0334
         BNO   @RF00334                                            0334
*       DO;                         /* (ASSUME DCBRECFM = F) @YA04306*/
*         RFY                                                      0336
*          (R6,                                                    0336
*           R7) RSTD;               /* GET WORK REGISTERS            */
*         R4=R8;                    /* SET TO ADDRESS                */
         LR    R4,R8                                               0337
*         IF DCBRKP=0 THEN          /* IS RKP = 0            @YA04306*/
         LA    @12,52                                              0338
         ALR   @12,RDCB                                            0338
         LH    @10,DCBRKP(,@12)                                    0338
         LTR   @10,@10                                             0338
         BNZ   @RF00338                                            0338
*           DO;                     /* YES, DATA ONLY        @YA04306*/
*             R6=RPLIIBFR+DCBKEYLE; /* PNT PAST KEY          @YA04306*/
         SLR   @10,@10                                             0340
         IC    @10,DCBKEYLE+16(,RDCB)                              0340
         L     R6,RPLIIBFR+76(,RRPL)                               0340
         ALR   R6,@10                                              0340
*             R5=DCBLRECL-DCBKEYLE; /* SET DATA LNGTH        @YA04306*/
         LCR   @10,@10                                             0341
         AH    @10,DCBLRECL(,@12)                                  0341
         LR    R5,@10                                              0341
*           END;                    /* END RKP = 0           @YA04306*/
*         ELSE                                                     0343
*           DO;                     /* RKP ^=0               @YA04306*/
         B     @RC00338                                            0343
@RF00338 DS    0H                                                  0344
*             R6=RPLIIBFR;          /* SET FROM PTR          @YA04306*/
         L     R6,RPLIIBFR+76(,RRPL)                               0344
*             R5=DCBLRECL;          /* SET DATA LNGTH        @YA04306*/
         LH    R5,DCBLRECL+52(,RDCB)                               0345
*           END;                    /* END RKP ^= 0          @YA04306*/
*         R7=R5;                    /* BOTH ODD REGS. MOVE           */
@RC00338 LR    R7,R5                                               0347
*         GEN(MVCL  R4,R6);         /* DATA TO USER AREA.            */
         MVCL  R4,R6
*         RFY                                                      0349
*          (R4,                                                    0349
*           R5,                                                    0349
*           R6,                                                    0349
*           R7,                                                    0349
*           R8) UNRSTD;             /* RELEASE MVCL REGISTERS        */
*       END;                        /* END OF DATA ONLY MOVE         */
*     ELSE                          /* IF MOVE MODE, UNBLOCKED       */
*       IF DCBRECBR=OFF&            /* RECORDS, EMBEDDED KEYS,       */
*           DCBRKP^=ZERO THEN       /* EXTRACT KEY AND PUT IT        */
         B     @RC00334                                            0351
@RF00334 TM    DCBRECBR+28(RDCB),B'00010000'                       0351
         BNZ   @RF00351                                            0351
         LH    @12,DCBRKP+52(,RDCB)                                0351
         LTR   @12,@12                                             0351
         BZ    @RF00351                                            0351
*         DO;                       /* IN FRONT OF USER AREA         */
*           RFY                                                    0353
*            (R6,                                                  0353
*             R8) RSTD;             /* GET WORK REGISTER             */
*           R6=RPLAREA+DCBRKP;      /* POINT TO KEY IN RECORD COPY 0354
*                                      KEY TO FRONT OF BUFFER        */
         AL    @12,RPLAREA(,RRPL)                                  0354
         LR    R6,@12                                              0354
*           USERKEY(ONE:DCBKEYLE)=EMBEDKEY(ONE:DCBKEYLE);          0355
         SLR   @12,@12                                             0355
         IC    @12,DCBKEYLE+16(,RDCB)                              0355
         BCTR  @12,0                                               0355
         EX    @12,@SM01273                                        0355
*           RFY                                                    0356
*            (R6,                                                  0356
*             R8) UNRSTD;           /* RELEASE WORK REGISTER         */
*         END;                      /* END OF KEY EXTRACTION         */
*   GO TO PM2EXIT;                  /* RETURN TO USER                */
         B     PM2EXIT                                             0358
*                                                                  0359
*/* **************************************************************** */
*/*                                                                  */
*/*        PUTX MACRO ENTRY POINT FROM BRANCH TABLE                  */
*/*                                                                  */
*/* **************************************************************** */
*                                                                  0359
*IIPUTX:                                                           0359
*   GEN(STM R14,R12,12(R13));       /* SAVE USER'S REGS              */
IIPUTX   STM R14,R12,12(R13)
*   RFY                                                            0360
*    (R0,                                                          0360
*     R15) RSTD;                    /* GET REGISTERS                 */
*   R11=R15;                        /* TRANSFER BASE ADDR            */
         LR    R11,R15                                             0361
*   RIICB=DEBWKPT5;                 /* SET IICB BASE                 */
         L     @14,DCBDEBAD+40(,RDCB)                              0362
         L     @14,DEBEXPT(,@14)                                   0362
         L     RIICB,DEBWKPT5(,@14)                                0362
*   IIREGBC=R13;                    /* BACKCHAIN TO USER SAVE        */
         ST    R13,IIREGBC(,RIICB)                                 0363
*   R15=ADDR(IIREGSAV);             /* HOLD II SAVE ADDR             */
         LA    R15,IIREGSAV(,RIICB)                                0364
*   GEN(ST R15,8(0,R13));           /* STORE IT IN USER SAVE         */
         ST R15,8(0,R13)
*   R13=R15;                        /* ESTABLISH SAVE PTR            */
         LR    R13,R15                                             0366
*   RFY                                                            0367
*    (R0,                                                          0367
*     R15) UNRSTD;                  /* DROP REGISTERS                */
*   RRPL=IIRPLPTR;                  /* ESTABLISH RPL BASE            */
*                                                                  0368
         L     RRPL,IIRPLPTR(,RIICB)                               0368
*   /*****************************************************************/
*   /*                                                               */
*   /* FOR DATA ONLY RETRIEVAL MOVE RECORD TO II BUFFER.             */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0369
*   IF IIDATA=ON THEN               /* IF DATA ONLY RETRIEVAL, RECORD
*                                      MUST BE MOVED                 */
         TM    IIDATA(RIICB),B'00001000'                           0369
         BNO   @RF00369                                            0369
*     DO;                           /* FROM USER AREA.               */
*       RFY                                                        0371
*        (R4,                                                      0371
*         R5,                                                      0371
*         R6,                                                      0371
*         R7) RSTD;                 /* GET WORK REGISTERS            */
*       R6=RPLAREA;                 /* MOVE FROM ADDR        @ZA14819*/
         L     R6,RPLAREA(,RRPL)                                   0372
*       IF DCBRKP=ZERO THEN         /* RKP = ZERO?           @OZ04616*/
         LA    @12,52                                              0373
         ALR   @12,RDCB                                            0373
         LH    @10,DCBRKP(,@12)                                    0373
         LTR   @10,@10                                             0373
         BNZ   @RF00373                                            0373
*         DO;                       /* RKP IS ZERO           @OZ04616*/
*           R5=DCBLRECL-DCBKEYLE;   /* SUB KEYLE             @OZ04616*/
         SLR   @10,@10                                             0375
         IC    @10,DCBKEYLE+16(,RDCB)                              0375
         LH    R5,DCBLRECL(,@12)                                   0375
         SLR   R5,@10                                              0375
*           R4=RPLIIBFR+DCBKEYLE;   /* ADJ TO ADDR           @OZ04616*/
         AL    @10,RPLIIBFR+76(,RRPL)                              0376
         LR    R4,@10                                              0376
*         END;                      /* END RKP ZERO          @OZ04616*/
*       ELSE                                                       0378
*         DO;                       /* RKP NON-ZERO          @OZ04616*/
         B     @RC00373                                            0378
@RF00373 DS    0H                                                  0379
*           R5=DCBLRECL;            /* MOVE LRECL            @OZ04616*/
         LH    R5,DCBLRECL+52(,RDCB)                               0379
*           R4=RPLIIBFR;            /* TO ADDR               @OZ04616*/
         L     @12,RPLIIBFR+76(,RRPL)                              0380
         LR    R4,@12                                              0380
*           IF DCBRECL='01'B THEN   /* IF VLR, SKIP          @ZA14819*/
         TM    DCBRECL+28(RDCB),B'01000000'                        0381
         BNO   @RF00381                                            0381
         TM    DCBRECL+28(RDCB),B'10000000'                        0381
         BNZ   @RF00381                                            0381
*             R6=RPLIIBFR+LENGTH(ALLRDW);/* CONTROL INFO     @ZA14819*/
         AL    @12,@CF00183                                        0382
         LR    R6,@12                                              0382
*         END;                      /* END NON-ZERO          @OZ04616*/
@RF00381 DS    0H                                                  0384
*       R7=R5;                      /* BOTH ODD REGS                 */
@RC00373 LR    R7,R5                                               0384
*       GEN(MVCL  R4,R6);           /* MOVE RECORD TO II BFR         */
         MVCL  R4,R6
*       RFY                                                        0386
*        (R4,                                                      0386
*         R5,                                                      0386
*         R6) UNRSTD;               /* DROP REGISTERS                */
*       RPLAREA=RPLIIBFR;           /* RESET POINTER FOR PUT         */
         L     @12,RPLIIBFR+76(,RRPL)                              0387
         ST    @12,RPLAREA(,RRPL)                                  0387
*     END;                          /* END OF MOVE RECORD CODE       */
*   R7=RDCB;                        /* SAVE DCB REGISTER ONE         */
@RF00369 LR    R7,RDCB                                             0389
*   RFY                                                            0390
*     IHADCB BASED(R7);             /* RESET DCB BASE                */
*   R1=RRPL;                        /* POINT TO RPL                  */
         LR    R1,RRPL                                             0391
*   RFY                                                            0392
*     IFGRPL BASED(R1);             /* RESET RPL BASE                */
*   RFY                                                            0393
*     RWORK1 RSTD;                  /* GET WORK REGISTER             */
*                                                                  0393
*   /*****************************************************************/
*   /*                                                               */
*   /* IF THE RECORD HAS BEEN MARKED FOR DELETION, ISSUE AN ERASE.   */
*   /* OTHERWISE, DO A PUT FOR UPDATE.                               */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0394
*   IF DCBRKP=ZERO THEN             /* FIND DELETE CODE BYTE         */
         LH    @12,DCBRKP+52(,R7)                                  0394
         LTR   @12,@12                                             0394
         BNZ   @RF00394                                            0394
*     RWORK1=RPLAREA+DCBKEYLE;      /* POINT TO FIRST DATA           */
         SLR   RWORK1,RWORK1                                       0395
         IC    RWORK1,DCBKEYLE+16(,R7)                             0395
         AL    RWORK1,RPLAREA(,R1)                                 0395
*   ELSE                                                           0396
*     RWORK1=RPLAREA;               /* BYTE UNLESS RKP=0             */
         B     @RC00394                                            0396
@RF00394 L     RWORK1,RPLAREA(,R1)                                 0396
*   IF DCBOPTL=ON&                  /* IF DELETE AND ERASE           */
*       DCBOPTI=ON&                 /* OPTION ON AND RECORD          */
*       DATABYT1=DELCODE THEN       /* IS MARKED FOR DELETION ISSUE
*                                      VSAM ERASE                    */
@RC00394 TM    DCBOPTL+52(R7),B'00010010'                          0397
         BNO   @RF00397                                            0397
         CLI   DATABYT1(RWORK1),B'11111111'                        0397
         BNE   @RF00397                                            0397
*     GEN(ERASE RPL=(1));           /* ELSE ISSUE VSAM PUT           */
         ERASE RPL=(1)
*   ELSE                                                           0399
*     GEN(PUT   RPL=(1));           /*                               */
         B     @RC00397                                            0399
@RF00397 DS    0H                                                  0399
         PUT   RPL=(1)
*   RFY                                                            0400
*     RWORK1 UNRSTD;                /* DROP WORK REGISTER            */
@RC00397 DS    0H                                                  0401
*   RFY                                                            0401
*     IHADCB BASED(RDCB);           /* RESET DCB BASE                */
*   RFY                                                            0402
*     IFGRPL BASED(RRPL);           /* RESET RPL BASE                */
*   RDCB=R7;                        /* RESTORE DCB REGISTER          */
         LR    RDCB,R7                                             0403
*   GO TO PM2EXIT;                  /* EXIT                          */
         B     PM2EXIT                                             0404
*                                                                  0405
*/* **************************************************************** */
*/*                                                                  */
*/*                  ESETL MACRO ENTRY POINT                         */
*/*                                                                  */
*/* **************************************************************** */
*                                                                  0405
*IIESETL:                                                          0405
*   GEN;                                                           0405
IIESETL  DS    0H                                                  0405
         STM   R14,R12,12(R13)             /* SAVE USER'S REGS      */
*   RFY                                                            0406
*    (R0,                                                          0406
*     R15) RSTD;                    /* GET REGISTERS                 */
*   R11=DCBGET;                     /* ESTABLISH BASE ADDR           */
         L     R11,DCBGET+48(,RDCB)                                0407
*   RIICB=DEBWKPT5;                 /* SET IICB BASE                 */
         L     @14,DCBDEBAD+40(,RDCB)                              0408
         L     @14,DEBEXPT(,@14)                                   0408
         L     RIICB,DEBWKPT5(,@14)                                0408
*   IIREGBC=R13;                    /* BACKCHAIN TO USER SAVE        */
         ST    R13,IIREGBC(,RIICB)                                 0409
*   R15=ADDR(IIREGSAV);             /* HOLD II SAVE ADDR             */
         LA    R15,IIREGSAV(,RIICB)                                0410
*   GEN(ST R15,8(0,R13));           /* STORE IT IN USER SAVE         */
         ST R15,8(0,R13)
*   R13=R15;                        /* ESTABLISH SAVE PTR            */
         LR    R13,R15                                             0412
*   RFY                                                            0413
*    (R0,                                                          0413
*     R15) UNRSTD;                  /* DROP REGISTERS                */
*   R7=RDCB;                        /* SAVE DCB ADDRESS              */
         LR    R7,RDCB                                             0414
*   DCBEXCD1=CZERO;                 /* CLEAR ERROR FLAGS             */
         LA    @12,52                                              0415
         ALR   @12,RDCB                                            0415
         MVI   DCBEXCD1(@12),B'00000000'                           0415
*   DCBEXCD2=CZERO;                 /* CLEAR ERROR FLAGS             */
*                                                                  0416
         MVI   DCBEXCD2(@12),B'00000000'                           0416
*   /*****************************************************************/
*   /*                                                               */
*   /* RESET SCAN MODE INDICATORS AND ISSUE AN ENDREQ TO RELEASE ANY */
*   /* VSAM RESOURCES.                                               */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0417
*   R1=IIRPLPTR;                    /* ESTABLISH RPL BASE            */
         L     R1,IIRPLPTR(,RIICB)                                 0417
*   IIFGET=OFF;                     /* NOT FIRST GET                 */
*   IIFSCAN=OFF;                    /* TAKE OUT OF SCAN ISSUE VSAM 0419
*                                      ENDREQ TO TERMINATE SCAN      */
         NI    IIFGET(RIICB),B'00111111'                           0419
*   GEN(ENDREQ RPL=(1));            /*                               */
         ENDREQ RPL=(1)
*PM2EXIT:                           /* RETURN TO USER                */
*   R13=IIREGBC;                    /* GET PTR TO USER SAVE          */
PM2EXIT  L     R13,IIREGBC(,RIICB)                                 0421
*   GEN;                                                           0422
         LM  R14,R12,12(R13)        /* RESTORE USER'S REGS          */
         BR  R14                    /* RETURN TO USER               */
*                                                                  0423
*/* **************************************************************** */
*/*                                                                  */
*/*        RELSE MACRO ENTRY POINT FROM BRANCH TABLE                 */
*/*                                                                  */
*/*        BECAUSE NO FUNCTION IS PERFORMED BY II, CONTROL IS        */
*/*        RETURNED TO THE USER                                      */
*/*                                                                  */
*/* **************************************************************** */
*                                                                  0423
*IIRELSE:                                                          0423
*   GEN(BR  R14);                                                  0423
IIRELSE  BR  R14
*                                                                  0424
*/* **************************************************************** */
*/*                                                                  */
*/*                  ERROR ROUTINE                                   */
*/*                                                                  */
*/*         ENTERED FROM SETL AND GET ROUTINES                       */
*/*         EXIT TO II SYNAD ROUTINE (IDAIISM1)                      */
*/*                                                                  */
*/* **************************************************************** */
*                                                                  0424
*ERROR:                                                            0424
*   R1=RRPL;                        /* ENTER RPL ADDRESS             */
ERROR    LR    R1,RRPL                                             0424
*   RFY                                                            0425
*     R15 RSTD;                     /* GET LINKAGE REGISTER          */
*   R15=EXLLERP;                    /* ENTER IDAIISM1 ADDRESS        */
         L     @12,RPLDACB(,RRPL)                                  0426
         L     @12,ACBUEL(,@12)                                    0426
         ICM   R15,15,EXLLERP(@12)                                 0426
*   GEN(BR  R15);                   /* GOTO II SYNAD ROUTINE         */
         BR  R15
*                                                                  0428
*/* **************************************************************** */
*/*                                                                  */
*/*                  EODAD ROUTINE                                   */
*/*                                                                  */
*/*    ENTERED FROM VSAM OR II SYNAD VIA EXIT LIST ON END OF DATA    */
*/*                                                                  */
*/* **************************************************************** */
*                                                                  0428
*IIEODAD:                                                          0428
*   RRPL=R1;                        /* GET RPL ADDRESS               */
IIEODAD  LR    RRPL,R1                                             0428
*   RFY                                                            0429
*     IDAIICB BASED(RPLIICB);       /* RESET IICB BASE               */
*   RFY                                                            0430
*     IHADCB BASED(IIDCBPTR);       /* RESET DCB BASE                */
*   R11=DCBGET;                     /* ESTABLISH BASE ADDRESS        */
*                                                                  0431
         L     @14,RPLIICB+76(,RRPL)                               0431
         L     @14,IIDCBPTR(,@14)                                  0431
         L     R11,DCBGET+48(,@14)                                 0431
*   /*****************************************************************/
*   /*                                                               */
*   /* TEST FOR ENTRY FROM POINT                             @XA05682*/
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0432
*   IF RPLREQ=RPLPOINT THEN         /* IF POINT RESULTED IN AN       */
         CLI   RPLREQ(RRPL),3                                      0432
         BNE   @RF00432                                            0432
*     DO;                           /* EOD FROM VSAM, CONVERT        */
*       DCBEXNKY=ON;                /* TO NO RECORD FOUND AND        */
         OI    DCBEXNKY+52(@14),B'10000000'                        0434
*       GO TO ERROR;                /* EXIT TO II SYNAD              */
         B     ERROR                                               0435
*     END;                          /*                       @XA05682*/
*                                                                  0436
*   /*****************************************************************/
*   /*                                                               */
*   /* TEST FOR ISAM EODAD ROUTINE SPECIFICATION                     */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0437
*   RFY                                                            0437
*    (R7,                                                          0437
*     R15) RSTD;                    /* GET WORK REGISTERS            */
@RF00432 DS    0H                                                  0438
*   R7=DCBEODA;                     /* STORE EODAD ADDRESS           */
         L     @14,RPLIICB+76(,RRPL)                               0438
         L     @12,IIDCBPTR(,@14)                                  0438
         L     R7,DCBEODA+27(,@12)                                 0438
         LA    R7,0(,R7)                                           0438
*   IF R7>ONE THEN                  /* EODAD ADDR SPECIFIED?         */
         C     R7,@CF00069                                         0439
         BNH   @RF00439                                            0439
*     DO;                           /* RESTORE USER'S REGS           */
*       R15=R7;                     /* LOAD EODAD ADDR               */
         LR    R15,R7                                              0441
*       R13=IIREGBC;                /* GET USER SAVE AREA PTR        */
         L     R13,IIREGBC(,@14)                                   0442
*       GEN;                                                       0443
               L   R14,12(R13)          RESTORE REG14        @OZ16018
               LM  R0,R12,20(R13)       RESTORE USER REGS
               BR  R15                  GOTO USER EODAD
*     END;                                                         0444
*   ELSE                            /* NO                            */
*     DO;                           /* ISSUE ABEND 039               */
         B     @RC00439                                            0445
@RF00439 DS    0H                                                  0446
*       R1=ABCODE39;                /* LOAD ABEND CONSTANT           */
         L     R1,ABCODE39                                         0446
*       GEN(ABEND  (1));            /* ABEND                         */
         ABEND  (1)
*     END;                                                         0448
*                                                                  0449
*/* **************************************************************** */
*/*                                                                  */
*/*     FUNCTION = SETL B ROUTINE                                    */
*/*        INITIALIZE RPL FOR SETL TO BEGINNING OF DATA SET          */
*/*        PREPARE RPL FOR POINT TO ZERO                             */
*/*                                                                  */
*/*     INPUT =                                                      */
*/*        REGISTER 1 - RDCB  - DCB POINTER                          */
*/*        REGISTER 2 - RIICB - IICB POINTER                         */
*/*        REGISTER 3 - RRPL  - RPL POINTER                          */
*/*                                                                  */
*/*     OUTPUT =                                                     */
*/*        RPL IS INITIALIZED FOR POINT TO ZERO                      */
*/*                                                                  */
*/* **************************************************************** */
*                                                                  0449
*SETLB:                                                            0449
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);                               0449
@EL00001 DS    0H                                                  0449
@EF00001 DS    0H                                                  0449
@ER00001 BR    @14                                                 0449
SETLB    DS    0H                                                  0450
*   RFY                                                            0450
*     R14 RSTD;                     /* SAVE RETURN REG               */
*   RPLKEYLE=ONE;                   /* SET MINIMUM KEY LENGTH        */
         MVC   RPLKEYLE(2,RRPL),@CH00069                           0451
*   RPLKGE=ON;                      /* SET GT/EQ SEARCH              */
*   RPLGEN=ON;                      /* INDICATE GENERIC        SEARCH*/
         OI    RPLKGE(RRPL),B'00000110'                            0453
*   KEYPTR=ZERO;                    /* SET DUMMY KEY                 */
         L     @12,RPLIICB+76(,RRPL)                               0454
         L     @12,IIREGBC(,@12)                                   0454
         SLR   @10,@10                                             0454
         STCM  @10,7,KEYPTR(@12)                                   0454
*   RPLARG=ADDR(KEYPTR);            /* PUT A(DUMMY KEY) IN RPL       */
         LA    @12,KEYPTR(,@12)                                    0455
         ST    @12,RPLARG(,RRPL)                                   0455
*   RETURN;                         /* RETURN TO CALLER              */
@EL00002 DS    0H                                                  0456
@EF00002 DS    0H                                                  0456
@ER00002 BR    @14                                                 0456
*   GEN(IDAPATCH);                  /* DEFINE A PATCH AREA           */
         IDAPATCH
*   END SETLB;                      /* END OF SETL TYPE B            */
         B     @EL00002                                            0458
*   END IDAIIPM2                    /* END OF IDAIIPM2 MODULE        */
*                                                                  0459
*/* THE FOLLOWING INCLUDE STATEMENTS WERE FOUND IN THIS PROGRAM.     */
*/*%INCLUDE SYSLIB  (IDAIIREG)                                       */
*/*%INCLUDE SYSLIB  (IDAIICB )                                       */
*/*%INCLUDE SYSLIB  (IHADCBDF)                                       */
*/*%INCLUDE SYSLIB  (IHADCB  )                                       */
*/*%INCLUDE SYSLIB  (IFGRPL  )                                       */
*/*%INCLUDE SYSLIB  (IDARPLE )                                       */
*/*%INCLUDE SYSLIB  (IEZDEB  )                                       */
*/*%INCLUDE SYSLIB  (IFGACB  )                                       */
*/*%INCLUDE SYSLIB  (IFGEXLST)                                       */
*/*%INCLUDE SYSLIB  (IDARMRCD)                                       */
*                                                                  0459
*       ;                                                          0459
@DATA    DS    0H
@SM01273 MVC   USERKEY(0,R8),EMBEDKEY(R6)
@DATD    DSECT
         DS    0F
IDAIIPM2 CSECT
         DS    0F
@CF00069 DC    F'1'
@CH00069 EQU   @CF00069+2
@CF00183 DC    F'4'
@DATD    DSECT
         DS    0D
DEBDAPTR DS    A
DEBEXPTR DS    A
DEBSBPTR DS    A
         ORG   *+1-(*-@DATD)/(*-@DATD) INSURE DSECT DATA
@ENDDATD EQU   *
IDAIIPM2 CSECT
         DS    0F
@SIZDATD DC    AL1(0)
         DC    AL3(@ENDDATD-@DATD)
         DS    0D
ABCODE39 DC    XL4'80039000'
@00      EQU   00                      EQUATES FOR REGISTERS 0-15
@01      EQU   01
@02      EQU   02
@03      EQU   03
@04      EQU   04
@05      EQU   05
@06      EQU   06
@07      EQU   07
@08      EQU   08
@09      EQU   09
@10      EQU   10
@11      EQU   11
@12      EQU   12
@13      EQU   13
@14      EQU   14
@15      EQU   15
R0       EQU   @00
R1       EQU   @01
RDCB     EQU   @01
RIICB    EQU   @02
RRPL     EQU   @03
R4       EQU   @04
R5       EQU   @05
R6       EQU   @06
RWORK1   EQU   @06
R7       EQU   @07
R8       EQU   @08
R11      EQU   @11
DEBPTR   EQU   @11
R13      EQU   @13
R14      EQU   @14
R15      EQU   @15
JFCBPTR  EQU   @09
RACB     EQU   @06
RBUFF    EQU   @05
RCORE    EQU   @04
RDEB     EQU   @11
RDECB    EQU   @01
RFMADDR  EQU   @07
RGMLEN   EQU   @09
RGMSP    EQU   @08
RLKRETSV EQU   @10
RPARC    EQU   @07
RTIOT    EQU   @09
RWORK2   EQU   @07
RWORK3   EQU   @08
R10      EQU   @10
R12      EQU   @12
R2       EQU   @02
R3       EQU   @03
R9       EQU   @09
IDAIICB  EQU   0
IIDCBPTR EQU   IDAIICB+4
IIRPLPTR EQU   IDAIICB+12
IIW1CBF  EQU   IDAIICB+16
IIKEYPT  EQU   IDAIICB+20
IIFLAG1  EQU   IDAIICB+24
IIFSCAN  EQU   IIFLAG1
IIFGET   EQU   IIFLAG1
IIDATA   EQU   IIFLAG1
IIFLAG2  EQU   IDAIICB+28
IIFLAG3  EQU   IDAIICB+36
IIREGSAV EQU   IDAIICB+60
IIREGBC  EQU   IIREGSAV+4
IIAUD    EQU   IDAIICB+132
IIAUDHDR EQU   IIAUD
IIAUDFL1 EQU   IIAUDHDR
IIAUDFL2 EQU   IIAUDHDR+1
IIGMCNTR EQU   IIAUDHDR+2
IIGMAUD  EQU   IIAUD+4
AUDCSPLI EQU   IIGMAUD+4
AUDCSPLD EQU   IIGMAUD+12
AUDCSPLB EQU   IIGMAUD+20
AUDCSPLM EQU   IIGMAUD+28
IIGMNTRY EQU   0
IIGMSPLG EQU   IIGMNTRY+4
IHADCB   EQU   0
IHADCS00 EQU   0
DCBFDAD  EQU   IHADCS00+5
IHADCS01 EQU   0
DCBDVTBL EQU   IHADCS01
IHADCS11 EQU   0
DCBRELB  EQU   IHADCS11
DCBKEYLE EQU   DCBRELB
DCBREL   EQU   DCBRELB+1
DCBBUFCB EQU   IHADCS11+4
DCBDSORG EQU   IHADCS11+10
DCBDSRG1 EQU   DCBDSORG
DCBDSRG2 EQU   DCBDSORG+1
DCBIOBAD EQU   IHADCS11+12
DCBODEB  EQU   DCBIOBAD
DCBLNP   EQU   DCBODEB
DCBQSLM  EQU   DCBLNP
DCBIOBAA EQU   DCBODEB+1
IHADCS50 EQU   0
DCBSVCXL EQU   IHADCS50
DCBEODAD EQU   IHADCS50+4
DCBBFALN EQU   DCBEODAD
DCBHIARC EQU   DCBBFALN
DCBBFTEK EQU   DCBHIARC
DCBBFT   EQU   DCBBFTEK
DCBEODA  EQU   DCBEODAD+1
DCBEXLST EQU   IHADCS50+8
DCBRECFM EQU   DCBEXLST
DCBRECLA EQU   DCBRECFM
DCBRECL  EQU   DCBRECLA
DCBRECBR EQU   DCBRECFM
IHADCS24 EQU   0
DCBOFLGS EQU   IHADCS24+8
DCBOFLWR EQU   DCBOFLGS
DCBIFLG  EQU   IHADCS24+9
DCBIBPCT EQU   DCBIFLG
DCBMACR  EQU   IHADCS24+10
DCBMACR1 EQU   DCBMACR
DCBMRFE  EQU   DCBMACR1
DCBMRGET EQU   DCBMRFE
DCBMRAPG EQU   DCBMACR1
DCBMRRD  EQU   DCBMRAPG
DCBMRCI  EQU   DCBMACR1
DCBMRMVG EQU   DCBMRCI
DCBMRLCG EQU   DCBMACR1
DCBMRABC EQU   DCBMACR1
DCBMRPT1 EQU   DCBMRABC
DCBMRSBG EQU   DCBMRPT1
DCBMRCRL EQU   DCBMACR1
DCBMRCHK EQU   DCBMRCRL
DCBMRRDX EQU   DCBMRCHK
DCBMRDMG EQU   DCBMACR1
DCBMACR2 EQU   DCBMACR+1
DCBMRPUT EQU   DCBMACR2
DCBMRWRT EQU   DCBMACR2
DCBMRMVP EQU   DCBMACR2
DCBMR5WD EQU   DCBMACR2
DCBMRLDM EQU   DCBMR5WD
DCBMRLCP EQU   DCBMRLDM
DCBMR4WD EQU   DCBMACR2
DCBMRPT2 EQU   DCBMR4WD
DCBMRTMD EQU   DCBMRPT2
DCBMR3WD EQU   DCBMACR2
DCBMRCTL EQU   DCBMR3WD
DCBMRSTK EQU   DCBMRCTL
DCBMR1WD EQU   DCBMACR2
DCBMRSWA EQU   DCBMR1WD
DCBMRDMD EQU   DCBMRSWA
IHADCS25 EQU   0
DCBMACRF EQU   IHADCS25+2
DCBMACF1 EQU   DCBMACRF
DCBMFFE  EQU   DCBMACF1
DCBMFGET EQU   DCBMFFE
DCBMFAPG EQU   DCBMACF1
DCBMFRD  EQU   DCBMFAPG
DCBMFCI  EQU   DCBMACF1
DCBMFMVG EQU   DCBMFCI
DCBMFLCG EQU   DCBMACF1
DCBMFABC EQU   DCBMACF1
DCBMFPT1 EQU   DCBMFABC
DCBMFSBG EQU   DCBMFPT1
DCBMFCRL EQU   DCBMACF1
DCBMFCHK EQU   DCBMFCRL
DCBMFDMG EQU   DCBMACF1
DCBMACF2 EQU   DCBMACRF+1
DCBMFPUT EQU   DCBMACF2
DCBMFWRT EQU   DCBMACF2
DCBMFMVP EQU   DCBMACF2
DCBMF5WD EQU   DCBMACF2
DCBMFLDM EQU   DCBMF5WD
DCBMFLCP EQU   DCBMFLDM
DCBMF4WD EQU   DCBMACF2
DCBMFPT2 EQU   DCBMF4WD
DCBMFTMD EQU   DCBMFPT2
DCBMF3WD EQU   DCBMACF2
DCBMFCTL EQU   DCBMF3WD
DCBMFSTK EQU   DCBMFCTL
DCBMF1WD EQU   DCBMACF2
DCBMFSWA EQU   DCBMF1WD
DCBMFDMD EQU   DCBMFSWA
DCBDEBAD EQU   IHADCS25+4
DCBIFLGS EQU   DCBDEBAD
DCBIFPCT EQU   DCBIFLGS
IHADCS27 EQU   0
DCBGET   EQU   IHADCS27
DCBPUT   EQU   DCBGET
DCBGETA  EQU   DCBPUT+1
IHADCS29 EQU   0
DCBOPTCD EQU   IHADCS29
DCBOPTI  EQU   DCBOPTCD
DCBOPTL  EQU   DCBOPTCD
DCBMAC   EQU   IHADCS29+1
DCBRKP   EQU   IHADCS29+8
DCBMSHI  EQU   IHADCS29+20
DCBEXCD1 EQU   IHADCS29+28
DCBEXNKY EQU   DCBEXCD1
DCBEXINV EQU   DCBEXCD1
DCBEXCD2 EQU   IHADCS29+29
DCBEXOFL EQU   DCBEXCD2
DCBEXLTH EQU   DCBEXCD2
DCBLRECL EQU   IHADCS29+30
DCBST    EQU   IHADCS29+108
IHADCS55 EQU   0
IFGRPL   EQU   0
RPLCOMN  EQU   IFGRPL
RPLIDWD  EQU   RPLCOMN
RPLREQ   EQU   RPLIDWD+2
RPLLEN   EQU   RPLIDWD+3
RPLECB   EQU   RPLCOMN+8
RPLFDBWD EQU   RPLCOMN+12
RPLFDBK  EQU   RPLFDBWD+1
RPLRTNCD EQU   RPLFDBK
RPLCNDCD EQU   RPLFDBK+1
RPLCMPON EQU   RPLCNDCD
RPLFDB2  EQU   RPLCMPON
RPLERRCD EQU   RPLCNDCD+1
RPLFDB3  EQU   RPLERRCD
RPLKEYLE EQU   RPLCOMN+16
RPLDACB  EQU   RPLCOMN+24
RPLAREA  EQU   RPLCOMN+32
RPLARG   EQU   RPLCOMN+36
RPLOPTCD EQU   RPLCOMN+40
RPLOPT1  EQU   RPLOPTCD
RPLKGE   EQU   RPLOPT1
RPLGEN   EQU   RPLOPT1
RPLECBSW EQU   RPLOPT1
RPLOPT2  EQU   RPLOPTCD+1
RPLADR   EQU   RPLOPT2
RPLOPT3  EQU   RPLOPTCD+2
RPLNXTRP EQU   RPLCOMN+44
RPLRLEN  EQU   RPLCOMN+48
RPLOPTC2 EQU   RPLCOMN+56
RPLOPT5  EQU   RPLOPTC2
RPLWRTYP EQU   RPLOPT5
RPLOPT6  EQU   RPLOPTC2+1
RPLUNTYP EQU   RPLOPT6
RPLOPT7  EQU   RPLOPTC2+2
RPLCNOPT EQU   RPLOPT7
RPLOPT8  EQU   RPLOPTC2+3
RPLRBAR  EQU   RPLCOMN+60
RPLAIXID EQU   RPLRBAR+2
RPLEXTDS EQU   RPLCOMN+68
RPLEXTD1 EQU   RPLEXTDS
IDARPLE  EQU   0
RPLIICB  EQU   IDARPLE
RPLIIBFR EQU   IDARPLE+8
DEBBASIC EQU   0
DEBTCBAD EQU   DEBBASIC
DEBDEBAD EQU   DEBBASIC+4
DEBIRBAD EQU   DEBBASIC+8
DEBOFLGS EQU   DEBIRBAD
DEBOPATB EQU   DEBBASIC+12
DEBFLGS1 EQU   DEBBASIC+14
DEBUSRPG EQU   DEBBASIC+16
DEBRRQ   EQU   DEBBASIC+20
DEBECBAD EQU   DEBRRQ
DEBDCBAD EQU   DEBBASIC+24
DEBPROTG EQU   DEBDCBAD
DEBAPPAD EQU   DEBBASIC+28
DEBBASND EQU   DEBBASIC+32
DEBDASD  EQU   0
DEBUCBAD EQU   DEBDASD
DEBACSMD EQU   0
DEBVOLSQ EQU   DEBACSMD
DEBVOLBT EQU   DEBVOLSQ
DEBDSNM  EQU   DEBACSMD+4
DEBUTSAA EQU   DEBDSNM
DEBACS01 EQU   0
DEBDSNAM EQU   DEBACS01
DEBACS02 EQU   0
DEBDBLK  EQU   DEBACS02
DEBACS03 EQU   0
DEBACS04 EQU   0
DEBTBFRA EQU   DEBACS04
DEBTCCWA EQU   DEBACS04+4
DEBACS05 EQU   0
DEBFUCBA EQU   DEBACS05
DEBLUCBA EQU   DEBACS05+4
DEBACS06 EQU   0
DEBACS07 EQU   0
DEBWKPT5 EQU   DEBACS07+12
DEBACS08 EQU   0
DEBSUBNM EQU   0
DEB      EQU   0
DEBAVT   EQU   DEB
DEBEOEA  EQU   DEBAVT
DEBEOEAB EQU   DEBEOEA
DEBSIOA  EQU   DEBAVT+4
DEBSIOAB EQU   DEBSIOA
DEBPCIA  EQU   DEBAVT+8
DEBPCIAB EQU   DEBPCIA
DEBCEA   EQU   DEBAVT+12
DEBCEAB  EQU   DEBCEA
DEBXCEA  EQU   DEBAVT+16
DEBXCEAB EQU   DEBXCEA
DEBPREFX EQU   DEB+20
DEBXTNP  EQU   DEBPREFX+8
DEBXTN   EQU   0
DEBXFLG1 EQU   DEBXTN+2
IFGACB   EQU   0
ACBCOMN  EQU   IFGACB
ACBLENG  EQU   ACBCOMN+2
ACBLENG2 EQU   ACBLENG
ACBAMBL  EQU   ACBCOMN+4
ACBJWA   EQU   ACBAMBL
ACBMACRF EQU   ACBCOMN+12
ACBMACR1 EQU   ACBMACRF
ACBADR   EQU   ACBMACR1
ACBCNV   EQU   ACBMACR1
ACBMACR2 EQU   ACBMACRF+1
ACBBUFPL EQU   ACBCOMN+20
ACBMACR3 EQU   ACBBUFPL
ACBRECFM EQU   ACBCOMN+24
ACBCCTYP EQU   ACBCOMN+25
ACBOPT   EQU   ACBCOMN+26
ACBDSORG EQU   ACBOPT
ACBCROPS EQU   ACBDSORG
ACBDVIND EQU   ACBDSORG
ACBEXLST EQU   ACBCOMN+36
ACBUEL   EQU   ACBEXLST
ACBDDNM  EQU   ACBCOMN+40
ACBAMETH EQU   ACBDDNM+3
ACBOFLGS EQU   ACBCOMN+48
ACBEXFG  EQU   ACBOFLGS
ACBIOSFG EQU   ACBOFLGS
ACBINFLG EQU   ACBCOMN+50
ACBVVIC  EQU   ACBINFLG
ACBUJFCB EQU   ACBCOMN+52
ACBBLKSZ EQU   ACBCOMN+60
IFGEXLST EQU   0
EXLCOMN  EQU   IFGEXLST
EXLLEN   EQU   EXLCOMN+2
EXLEODF  EQU   EXLCOMN+5
EXLSYNF  EQU   EXLCOMN+10
EXLLERF  EQU   EXLCOMN+15
EXLLERP  EQU   EXLCOMN+16
EXLSCIPF EQU   EXLCOMN+20
EXLUPADF EQU   EXLSCIPF
EXLSCIPS EQU   EXLUPADF
EXLSCIPA EQU   EXLUPADF
EXLSCIPK EQU   EXLUPADF
EXLSCIPP EQU   EXLCOMN+21
EXLLGNF  EQU   EXLCOMN+25
EXLJRNF  EQU   EXLCOMN+30
EXLOPNF  EQU   EXLCOMN+35
IFGEXLEF EQU   0
EXLENTRY EQU   IFGEXLEF
EXLFLAG  EQU   EXLENTRY
EXLENFL  EQU   EXLFLAG
EXLEXITP EQU   EXLENTRY+1
ALLRDW   EQU   0
RDW      EQU   ALLRDW
RDW00    EQU   ALLRDW+2
DATABYT1 EQU   0
KEYBYTE  EQU   0
USERKEY  EQU   0
EMBEDKEY EQU   0
KEYADDR  EQU   20
SETLTYPE EQU   KEYADDR
SETLKEY  EQU   SETLTYPE
SETLGEN  EQU   SETLTYPE
SETLBEG  EQU   SETLTYPE
SETLDAT  EQU   SETLTYPE
SETLKGE  EQU   SETLTYPE
KEYPTR   EQU   KEYADDR+1
DATADDR  EQU   24
DEBBAS02 EQU   DEBBASND
DEBDDS1  EQU   DEBBAS02
DEBSUCBA EQU   DEBDDS1
DEBDEVED EQU   DEBDDS1+4
DEBRDCB  EQU   DEBDDS1+4
DEBPDCB  EQU   DEBDDS1+8
DEBWDCB  EQU   DEBDDS1+12
DEBACS09 EQU   DEBDEVED
DEBASC09 EQU   DEBACS09
DEBEAMFG EQU   DEBASC09+3
DEBDSID  EQU   DEBASC09+4
DEBEOD   EQU   DEBASC09+12
DEBBOE   EQU   DEBEOD
DEBEODRV EQU   DEBBOE
DEBEODTT EQU   DEBBOE+1
DEBEOD0  EQU   DEBBOE+2
DEBEODSS EQU   DEBBOE+3
DEBBAS01 EQU   DEBBASND
DEBISAM  EQU   DEBBAS01
DEBFIEAD EQU   DEBISAM
DEBFPEAD EQU   DEBISAM+4
DEBFOEAD EQU   DEBISAM+8
DEBEXPT  EQU   DEBISAM+12
DEBRPSID EQU   DEBEXPT
         AGO   .@UNREFD                START UNREFERENCED COMPONENTS
DEBEXPTA EQU   DEBEXPT+1
DEBRSV12 EQU   DEBRPSID
DEBRSV11 EQU   DEBRPSID
DEBRSV10 EQU   DEBRPSID
DEBRSV09 EQU   DEBRPSID
DEBRPSAP EQU   DEBRPSID
DEBRPSO  EQU   DEBRPSID
DEBRPSI  EQU   DEBRPSID
DEBRPSP  EQU   DEBRPSID
DEBFOEB  EQU   DEBFOEAD+1
DEBNOEE  EQU   DEBFOEAD
DEBFPEB  EQU   DEBFPEAD+1
DEBNPEE  EQU   DEBFPEAD
DEBFIEB  EQU   DEBFIEAD+1
DEBNIEE  EQU   DEBFIEAD
DEBBOESS EQU   DEBEODSS
DEBBOE0  EQU   DEBEOD0
DEBBOETT EQU   DEBEODTT
DEBBOERV EQU   DEBEODRV
DEBRV008 EQU   DEBDSID+7
DEBWTPTI EQU   DEBDSID+6
DEBEXDTE EQU   DEBDSID
DEBRV007 EQU   DEBEAMFG
DEBRV006 EQU   DEBEAMFG
DEBRV005 EQU   DEBEAMFG
DEBRV004 EQU   DEBEAMFG
DEBSECVL EQU   DEBEAMFG
DEBVAMSG EQU   DEBEAMFG
DEBDSOPN EQU   DEBEAMFG
DEBMULTI EQU   DEBEAMFG
DEBVSEQU EQU   DEBASC09+2
DEBDSSQL EQU   DEBASC09+1
DEBVOLAC EQU   DEBASC09
DEBWDCBA EQU   DEBWDCB+1
DEBRSV08 EQU   DEBWDCB
DEBPDCBA EQU   DEBPDCB+1
DEBRSV07 EQU   DEBPDCB
DEBRDCBA EQU   DEBRDCB+1
DEBRSV06 EQU   DEBRDCB
DEBSUCBB EQU   DEBSUCBA+1
DEBSDVM  EQU   DEBSUCBA
@NM00056 EQU   SETLTYPE
SETLID   EQU   SETLTYPE
EXLEADDR EQU   EXLEXITP
@NM00055 EQU   EXLENFL
EXLLNK   EQU   EXLENFL
EXLACTM  EQU   EXLENFL
EXLSPEC  EQU   EXLENFL
EXLOPNP  EQU   EXLCOMN+36
@NM00054 EQU   EXLOPNF
EXLOPNK  EQU   EXLOPNF
EXLOPNA  EQU   EXLOPNF
EXLOPNS  EQU   EXLOPNF
EXLJRNP  EQU   EXLCOMN+31
@NM00053 EQU   EXLJRNF
EXLJRNK  EQU   EXLJRNF
EXLJRNA  EQU   EXLJRNF
EXLJRNS  EQU   EXLJRNF
EXLLGNP  EQU   EXLCOMN+26
@NM00052 EQU   EXLLGNF
EXLLGNK  EQU   EXLLGNF
EXLLGNA  EQU   EXLLGNF
EXLLGNS  EQU   EXLLGNF
EXLUPADP EQU   EXLSCIPP
@NM00051 EQU   EXLUPADF
EXLUPADK EQU   EXLSCIPK
EXLUPADA EQU   EXLSCIPA
EXLUPADS EQU   EXLSCIPS
@NM00050 EQU   EXLLERF
EXLLERK  EQU   EXLLERF
EXLLERA  EQU   EXLLERF
EXLLERS  EQU   EXLLERF
EXLSYNP  EQU   EXLCOMN+11
@NM00049 EQU   EXLSYNF
EXLSYNK  EQU   EXLSYNF
EXLSYNA  EQU   EXLSYNF
EXLSYNS  EQU   EXLSYNF
EXLEODP  EQU   EXLCOMN+6
@NM00048 EQU   EXLEODF
EXLEODK  EQU   EXLEODF
EXLEODA  EQU   EXLEODF
EXLEODS  EQU   EXLEODF
@NM00047 EQU   EXLCOMN+4
EXLLEN2  EQU   EXLLEN
EXLSTYP  EQU   EXLCOMN+1
EXLID    EQU   EXLCOMN
ACBAPID  EQU   ACBCOMN+72
ACBCBMWA EQU   ACBCOMN+68
ACBUAPTR EQU   ACBCOMN+64
ACBLRECL EQU   ACBCOMN+62
ACBMSGLN EQU   ACBBLKSZ
ACBBUFSP EQU   ACBCOMN+56
@NM00046 EQU   ACBUJFCB+1
ACBOPTN  EQU   ACBUJFCB
@NM00045 EQU   ACBINFLG+1
ACBBYPSS EQU   ACBINFLG
ACBSDS   EQU   ACBVVIC
ACBUCRA  EQU   ACBINFLG
ACBSCRA  EQU   ACBINFLG
ACBCAT   EQU   ACBINFLG
ACBIJRQE EQU   ACBINFLG
ACBJEPS  EQU   ACBINFLG
@NM00044 EQU   ACBINFLG
ACBERFLG EQU   ACBCOMN+49
ACBBUSY  EQU   ACBIOSFG
ACBLOCK  EQU   ACBEXFG
@NM00043 EQU   ACBOFLGS
ACBDSERR EQU   ACBOFLGS
ACBOPEN  EQU   ACBOFLGS
ACBEOV   EQU   ACBOFLGS
@NM00042 EQU   ACBOFLGS
ACBDEB   EQU   ACBDDNM+5
ACBERFL  EQU   ACBDDNM+4
ACBAM    EQU   ACBAMETH
ACBINFL  EQU   ACBDDNM+2
ACBTIOT  EQU   ACBDDNM
ACBPASSW EQU   ACBCOMN+32
ACBMSGAR EQU   ACBCOMN+28
@NM00041 EQU   ACBDSORG+1
ACBDORGA EQU   ACBDSORG+1
@NM00040 EQU   ACBDSORG
ACBOPTJ  EQU   ACBDVIND
ACBCRNRE EQU   ACBCROPS
ACBCRNCK EQU   ACBCROPS
ACBASA   EQU   ACBCCTYP
@NM00039 EQU   ACBCCTYP
ACBTRCID EQU   ACBCCTYP
@NM00038 EQU   ACBRECFM
ACBRECAF EQU   ACBRECFM
ACBJBUF  EQU   ACBBUFPL+2
ACBMACR4 EQU   ACBBUFPL+1
@NM00037 EQU   ACBMACR3
ACBNCFX  EQU   ACBMACR3
ACBSIS   EQU   ACBMACR3
ACBDFR   EQU   ACBMACR3
ACBICI   EQU   ACBMACR3
ACBGSR   EQU   ACBMACR3
ACBLSR   EQU   ACBMACR3
@NM00036 EQU   ACBMACR3
ACBBUFNI EQU   ACBCOMN+18
ACBBUFND EQU   ACBCOMN+16
ACBSTRNO EQU   ACBCOMN+15
ACBBSTNO EQU   ACBCOMN+14
ACBAIX   EQU   ACBMACR2
ACBDSN   EQU   ACBMACR2
ACBRST   EQU   ACBMACR2
ACBLOGON EQU   ACBMACR2
ACBSKP   EQU   ACBMACR2
@NM00035 EQU   ACBMACR2
ACBUBF   EQU   ACBMACR1
ACBOUT   EQU   ACBMACR1
ACBIN    EQU   ACBMACR1
ACBDIR   EQU   ACBMACR1
ACBSEQ   EQU   ACBMACR1
ACBBLK   EQU   ACBCNV
ACBADD   EQU   ACBADR
ACBKEY   EQU   ACBMACR1
ACBINRTN EQU   ACBCOMN+8
ACBIBCT  EQU   ACBJWA
ACBLEN2  EQU   ACBLENG2
ACBSTYP  EQU   ACBCOMN+1
ACBID    EQU   ACBCOMN
DEBXSAMB EQU   DEBXTN+28
DEBXOPNJ EQU   DEBXTN+24
DEBXXARG EQU   DEBXTN+20
DEBXMCF2 EQU   DEBXTN+19
DEBXMCF1 EQU   DEBXTN+18
DEBXDSO2 EQU   DEBXTN+17
DEBXDSO1 EQU   DEBXTN+16
DEBXDBPR EQU   DEBXTN+12
DEBXDCBM EQU   DEBXTN+8
DEBXDSAB EQU   DEBXTN+4
DEBXRV48 EQU   DEBXTN+3
DEBXRV47 EQU   DEBXFLG1
DEBXRV46 EQU   DEBXFLG1
DEBXRV45 EQU   DEBXFLG1
DEBXRV44 EQU   DEBXFLG1
DEBXRV43 EQU   DEBXFLG1
DEBXDSSI EQU   DEBXFLG1
DEBXTSKC EQU   DEBXFLG1
DEBXCDCB EQU   DEBXFLG1
DEBXLNGH EQU   DEBXTN
DEBTBLOF EQU   DEBPREFX+14
DEBAMTYP EQU   DEBPREFX+13
DEBLNGTH EQU   DEBPREFX+12
DEBDCBMK EQU   DEBXTNP
DEBDSCBA EQU   DEBPREFX+1
DEBWKARA EQU   DEBPREFX
DEBXCEAD EQU   DEBXCEA+1
DEBXCENP EQU   DEBXCEAB
DEBRSV35 EQU   DEBXCEAB
DEBRSV34 EQU   DEBXCEAB
DEBRSV33 EQU   DEBXCEAB
DEBRSV32 EQU   DEBXCEAB
DEBCEAD  EQU   DEBCEA+1
DEBCENP  EQU   DEBCEAB
DEBRSV31 EQU   DEBCEAB
DEBRSV30 EQU   DEBCEAB
DEBRSV29 EQU   DEBCEAB
DEBRSV28 EQU   DEBCEAB
DEBPCIAD EQU   DEBPCIA+1
DEBPCINP EQU   DEBPCIAB
DEBRSV27 EQU   DEBPCIAB
DEBRSV26 EQU   DEBPCIAB
DEBRSV25 EQU   DEBPCIAB
DEBRSV24 EQU   DEBPCIAB
DEBSIOAD EQU   DEBSIOA+1
DEBSIONP EQU   DEBSIOAB
DEBFIX   EQU   DEBSIOAB
DEBIOVR  EQU   DEBSIOAB
DEBSIOX  EQU   DEBSIOAB
DEBPGFX  EQU   DEBSIOAB
DEBEOEAD EQU   DEBEOEA+1
DEBEOENP EQU   DEBEOEAB
DEBRSV22 EQU   DEBEOEAB
DEBRSV21 EQU   DEBEOEAB
DEBRSV20 EQU   DEBEOEAB
DEBESMVR EQU   DEBEOEAB
DEBSUBID EQU   DEBSUBNM
DEBSIOA2 EQU   DEBACS08+24
DEBRPSIO EQU   DEBACS08+20
DEBFREED EQU   DEBACS08+16
@NM00034 EQU   DEBACS08+12
@NM00033 EQU   DEBACS08+8
DEBDISAD EQU   DEBACS08+4
@NM00032 EQU   DEBACS08
DEBRPSST EQU   DEBACS07+64
DEBARECK EQU   DEBACS07+60
DEBAREWT EQU   DEBACS07+56
DEBACHK  EQU   DEBACS07+52
DEBAWRIT EQU   DEBACS07+48
DEBASETL EQU   DEBACS07+44
DEBAREAD EQU   DEBACS07+40
DEBCRECK EQU   DEBACS07+36
DEBCREWT EQU   DEBACS07+32
DEBCCHK  EQU   DEBACS07+28
DEBCWRIT EQU   DEBACS07+24
DEBCSETL EQU   DEBACS07+20
DEBCREAD EQU   DEBACS07+16
DEBWKPT4 EQU   DEBACS07+8
DEBGET   EQU   DEBACS07+4
@NM00031 EQU   DEBACS07
DEBPUT   EQU   DEBACS06+4
DEBDCBFA EQU   DEBACS06
DEBLUCBB EQU   DEBLUCBA+1
DEBRSV18 EQU   DEBLUCBA
DEBFUCBB EQU   DEBFUCBA+1
DEBRSV17 EQU   DEBFUCBA
DEBTCCWB EQU   DEBTCCWA+1
DEBRSV16 EQU   DEBTCCWA
DEBTBFRB EQU   DEBTBFRA+1
DEBRSV15 EQU   DEBTBFRA
DEBDBPEF EQU   DEBACS03+8
DEBDBPP  EQU   DEBACS03+4
DEBDTPP  EQU   DEBACS03
DEBDBPE  EQU   DEBDBLK+1
DEBDBPT  EQU   DEBDBLK
DEBEXTNM EQU   DEBDSNAM
DEBLRECL EQU   DEBACSMD+14
DEBBLKSI EQU   DEBACSMD+12
DEBRSV14 EQU   DEBDSNM+4
DEBUTSAB EQU   DEBUTSAA+1
DEBRSV13 EQU   DEBUTSAA
DEBVOLNM EQU   DEBACSMD+2
DEBVLSEQ EQU   DEBVOLSQ+1
DEBRSV42 EQU   DEBVOLBT
DEBRSV41 EQU   DEBVOLBT
DEBRSV40 EQU   DEBVOLBT
DEBRSV39 EQU   DEBVOLBT
DEBRSV38 EQU   DEBVOLBT
DEBRSV37 EQU   DEBVOLBT
DEBRSV36 EQU   DEBVOLBT
DEBEXFUL EQU   DEBVOLBT
DEBNMTRK EQU   DEBDASD+14
DEBENDHH EQU   DEBDASD+12
DEBENDCC EQU   DEBDASD+10
DEBSTRHH EQU   DEBDASD+8
DEBSTRCC EQU   DEBDASD+6
DEBBINUM EQU   DEBDASD+4
DEBUCBA  EQU   DEBUCBAD+1
DEBDVMOD EQU   DEBUCBAD
DEBAPPB  EQU   DEBAPPAD+1
DEBEXSCL EQU   DEBAPPAD
DEBDCBB  EQU   DEBDCBAD+1
DEBDEBID EQU   DEBPROTG
DEBECBB  EQU   DEBECBAD+1
DEBPRIOR EQU   DEBECBAD
DEBUSRPB EQU   DEBUSRPG+1
DEBNMEXT EQU   DEBUSRPG
DEBRSV05 EQU   DEBBASIC+15
DEBXTNIN EQU   DEBFLGS1
DEBAPFIN EQU   DEBFLGS1
DEBF1CEV EQU   DEBFLGS1
DEBCINDI EQU   DEBFLGS1
DEBRSV02 EQU   DEBFLGS1
DEBRSIOA EQU   DEBFLGS1
DEBEOFDF EQU   DEBFLGS1
DEBPWCKD EQU   DEBFLGS1
DEBQSCNT EQU   DEBBASIC+13
DEBACCS  EQU   DEBOPATB
DEBPOSIT EQU   DEBOPATB
DEBZERO  EQU   DEBOPATB
DEBABEND EQU   DEBOPATB
DEBIRBB  EQU   DEBIRBAD+1
DEBRERR  EQU   DEBOFLGS
DEBLABEL EQU   DEBOFLGS
DEBSPLIT EQU   DEBOFLGS
DEBDCB   EQU   DEBOFLGS
DEBRLSE  EQU   DEBOFLGS
DEBEOF   EQU   DEBOFLGS
DEBDISP  EQU   DEBOFLGS
DEBDEBB  EQU   DEBDEBAD+1
DEBAMLNG EQU   DEBDEBAD
DEBTCBB  EQU   DEBTCBAD+1
DEBNMSUB EQU   DEBTCBAD
RPLSAVE2 EQU   IDARPLE+24
RPLSAVE  EQU   IDARPLE+20
@NM00030 EQU   IDARPLE+17
RPLIITSB EQU   IDARPLE+16
RPLRPLPT EQU   IDARPLE+12
RPLDECB  EQU   IDARPLE+4
RPLERMSA EQU   RPLCOMN+72
RPLEMLEN EQU   RPLCOMN+70
RPLACTIV EQU   RPLCOMN+69
RPLBRANC EQU   RPLEXTD1
RPLNIB   EQU   RPLEXTD1
@NM00029 EQU   RPLEXTD1
RPLEXIT  EQU   RPLEXTD1
RPLNEXIT EQU   RPLEXTD1
RPLEXSCH EQU   RPLEXTD1
RPLDDDD  EQU   RPLRBAR+4
@NM00028 EQU   RPLRBAR+3
@NM00027 EQU   RPLAIXID
RPLAXPKP EQU   RPLAIXID
RPLAIXPC EQU   RPLRBAR
RPLRSV88 EQU   RPLOPT8
RPLUNCON EQU   RPLOPT8
RPLACTV  EQU   RPLOPT8
RPLSESS  EQU   RPLOPT8
RPLPEND  EQU   RPLOPT8
RPLODPRM EQU   RPLOPT8
RPLODACP EQU   RPLOPT8
RPLODACQ EQU   RPLOPT8
RPLRSV78 EQU   RPLOPT7
RPLRSV77 EQU   RPLOPT7
RPLRLSOP EQU   RPLOPT7
RPLTPOST EQU   RPLOPT7
RPLQOPT  EQU   RPLOPT7
RPLCNIMM EQU   RPLCNOPT
RPLCNANY EQU   RPLCNOPT
RPLCNALL EQU   RPLCNOPT
RPLRSV68 EQU   RPLOPT6
RPLRSV67 EQU   RPLOPT6
RPLLOCK  EQU   RPLOPT6
RPLNCOND EQU   RPLOPT6
RPLCOND  EQU   RPLOPT6
RPLEOT   EQU   RPLUNTYP
RPLEOM   EQU   RPLUNTYP
RPLEOB   EQU   RPLUNTYP
RPLWROPT EQU   RPLOPT5
RPLNODE  EQU   RPLOPT5
RPLERACE EQU   RPLWRTYP
RPLEAU   EQU   RPLWRTYP
RPLNERAS EQU   RPLWRTYP
RPLPSOPT EQU   RPLOPT5
RPLSSNIN EQU   RPLOPT5
RPLDLGIN EQU   RPLOPT5
RPLBUFL  EQU   RPLCOMN+52
RPLCHAIN EQU   RPLNXTRP
RPLOPT4  EQU   RPLOPTCD+3
RPLALIGN EQU   RPLOPT3
RPLFMT   EQU   RPLOPT3
RPLFLD   EQU   RPLOPT3
RPLVFY   EQU   RPLOPT3
RPLBLK   EQU   RPLOPT3
RPLSFORM EQU   RPLOPT3
RPLEODS  EQU   RPLOPT3
RPLNSP   EQU   RPLOPT2
RPLUPD   EQU   RPLOPT2
RPLWAITX EQU   RPLOPT2
RPLLRD   EQU   RPLOPT2
RPLBWD   EQU   RPLOPT2
RPLCNV   EQU   RPLOPT2
RPLADD   EQU   RPLADR
RPLKEY   EQU   RPLOPT2
RPLECBIN EQU   RPLECBSW
RPLASY   EQU   RPLOPT1
RPLSKP   EQU   RPLOPT1
RPLSEQ   EQU   RPLOPT1
RPLDIR   EQU   RPLOPT1
RPLLOC   EQU   RPLOPT1
RPLDAF   EQU   RPLARG+2
RPLSAF   EQU   RPLARG
RPLTCBPT EQU   RPLCOMN+28
RPLCCHAR EQU   RPLCOMN+20
RPLSTRID EQU   RPLCOMN+18
RPLKEYL  EQU   RPLKEYLE
RPLRDSOH EQU   RPLFDB3
RPLRLG   EQU   RPLFDB3
RPLLGFRC EQU   RPLFDB3
RPLREOT  EQU   RPLFDB3
RPLREOM  EQU   RPLFDB3
RPLREOB  EQU   RPLFDB3
RPLSV32  EQU   RPLFDB3
RPLUINPT EQU   RPLFDB3
RPLSTSAV EQU   RPLFDB2
RPLCUERR EQU   RPLFDB2
RPLDLGFL EQU   RPLFDB2
RPLIOERR EQU   RPLFDB2
RPLDVUNS EQU   RPLFDB2
RPLATND  EQU   RPLFDB2
RPLRVID  EQU   RPLFDB2
RPLERLK  EQU   RPLFDB2
RPLERREG EQU   RPLRTNCD
RPLSTAT  EQU   RPLFDBWD
RPLPOST  EQU   RPLECB
RPLWAIT  EQU   RPLECB
RPLPLHPT EQU   RPLCOMN+4
RPLLEN2  EQU   RPLLEN
RPLSTYP  EQU   RPLIDWD+1
RPLID    EQU   RPLIDWD
DCBLPDT  EQU   IHADCS55
DCBWKPT6 EQU   IHADCS29+196
DCBWKPT5 EQU   IHADCS29+192
DCBWKPT4 EQU   IHADCS29+188
DCBWKPT3 EQU   IHADCS29+184
DCBWKPT2 EQU   IHADCS29+180
DCBWKPT1 EQU   IHADCS29+176
@NM00026 EQU   IHADCS29+174
DCBRORG1 EQU   IHADCS29+172
DCBLIOV  EQU   IHADCS29+164
DCBNOREC EQU   IHADCS29+162
@NM00025 EQU   IHADCS29+161
DCBLEMI1 EQU   IHADCS29+156
DCBRORG2 EQU   IHADCS29+154
@NM00024 EQU   IHADCS29+153
DCBLECI  EQU   IHADCS29+148
DCBNBOV  EQU   IHADCS29+146
DCBOVDEV EQU   IHADCS29+145
DCBLETI  EQU   IHADCS29+140
DCBLPDA  EQU   IHADCS29+132
DCBFTHI  EQU   IHADCS29+125
DCBNTHI  EQU   IHADCS29+124
DCBFTMI1 EQU   IHADCS29+117
DCBHIIOV EQU   IHADCS29+116
DCBFTCI  EQU   IHADCS29+109
DCBSTLTF EQU   DCBST
DCBSTLBF EQU   DCBST
DCBSTNMC EQU   DCBST
@NM00023 EQU   DCBST
DCBSTNCY EQU   DCBST
DCBSTLOD EQU   DCBST
DCBSTKSQ EQU   DCBST
DCBSTSSM EQU   DCBST
DCBNREC  EQU   IHADCS29+104
DCBRORG3 EQU   IHADCS29+100
DCBNCRHI EQU   IHADCS29+98
DCBTDC   EQU   IHADCS29+96
DCBHIRSH EQU   IHADCS29+95
DCBHIROV EQU   IHADCS29+94
DCBHIRPD EQU   IHADCS29+93
DCBHIRCM EQU   IHADCS29+92
DCBLDT   EQU   IHADCS29+90
DCBHMASK EQU   IHADCS29+89
DCBFIRSH EQU   IHADCS29+86
DCBNLEV  EQU   IHADCS29+85
DCBLEMI3 EQU   IHADCS29+80
DCBFTMI3 EQU   IHADCS29+73
DCBLEMI2 EQU   IHADCS29+68
DCBFTMI2 EQU   IHADCS29+61
DCBHIRTI EQU   IHADCS29+60
DCBFREED EQU   IHADCS29+56
DCBRELEX EQU   IHADCS29+52
DCBPUTX  EQU   IHADCS29+48
DCBRELSE EQU   IHADCS29+44
DCBLWKN  EQU   IHADCS29+40
DCBLRAN  EQU   IHADCS29+36
DCBESETL EQU   IHADCS29+32
@NM00022 EQU   DCBEXCD2
DCBEXRDE EQU   DCBEXLTH
DCBEXCLD EQU   DCBEXCD2
DCBEXDUP EQU   DCBEXCD2
DCBEXSEQ EQU   DCBEXCD2
DCBEXBLU EQU   DCBEXCD1
DCBEXBLI EQU   DCBEXCD1
DCBEXOER EQU   DCBEXCD1
DCBEXIER EQU   DCBEXCD1
DCBEXNSP EQU   DCBEXCD1
DCBEXIDA EQU   DCBEXCD1
DCBSETL  EQU   IHADCS29+24
DCBMSHIA EQU   DCBMSHI+1
DCBNCP   EQU   DCBMSHI
DCBSMSW  EQU   IHADCS29+18
DCBSMSI  EQU   IHADCS29+16
DCBMSWA  EQU   IHADCS29+12
DCBBLKSI EQU   IHADCS29+10
DCBSYNAD EQU   IHADCS29+4
DCBCYLOF EQU   IHADCS29+3
DCBNTM   EQU   IHADCS29+2
DCBMACRE EQU   DCBMAC
DCBMACAW EQU   DCBMAC
DCBMACUW EQU   DCBMAC
DCBMACUR EQU   DCBMAC
@NM00021 EQU   DCBMAC
DCBOPTR  EQU   DCBOPTCD
@NM00020 EQU   DCBOPTCD
DCBOPTY  EQU   DCBOPTCD
DCBOPTM  EQU   DCBOPTCD
DCBOPTUF EQU   DCBOPTCD
DCBOPTW  EQU   DCBOPTCD
DCBPUTA  EQU   DCBGETA
@NM00019 EQU   DCBPUT
DCBDEBA  EQU   DCBDEBAD+1
@NM00018 EQU   DCBIFLGS
DCBIFIOE EQU   DCBIFLGS
DCBCH12  EQU   DCBIFPCT
DCBCH9   EQU   DCBIFPCT
DCBIFEC  EQU   DCBIFLGS
DCBMFSTI EQU   DCBMFDMD
DCBMFAWR EQU   DCBMFSTK
DCBMFUIP EQU   DCBMFTMD
DCBMFIDW EQU   DCBMFLCP
DCBMFWRK EQU   DCBMFMVP
DCBMFRDQ EQU   DCBMFWRT
DCBMFGTQ EQU   DCBMFPUT
DCBMFSTL EQU   DCBMACF2
DCBMFCK  EQU   DCBMFDMG
DCBMFRDX EQU   DCBMFCHK
DCBMFDBF EQU   DCBMFSBG
DCBMFRDI EQU   DCBMFLCG
DCBMFRDK EQU   DCBMFMVG
DCBMFWRQ EQU   DCBMFRD
DCBMFPTQ EQU   DCBMFGET
DCBMFECP EQU   DCBMACF1
DCBTIOT  EQU   IHADCS25
DCBMRSTI EQU   DCBMRDMD
DCBMRAWR EQU   DCBMRSTK
DCBMRUIP EQU   DCBMRTMD
DCBMRIDW EQU   DCBMRLCP
DCBMRWRK EQU   DCBMRMVP
DCBMRRDQ EQU   DCBMRWRT
DCBMRGTQ EQU   DCBMRPUT
DCBMRSTL EQU   DCBMACR2
DCBMRCK  EQU   DCBMRDMG
DCBPGFXA EQU   DCBMRRDX
DCBMRDBF EQU   DCBMRSBG
DCBMRRDI EQU   DCBMRLCG
DCBMRRDK EQU   DCBMRMVG
DCBMRWRQ EQU   DCBMRRD
DCBMRPTQ EQU   DCBMRGET
DCBMRECP EQU   DCBMACR1
@NM00017 EQU   DCBIFLG
DCBIBIOE EQU   DCBIFLG
DCBICH12 EQU   DCBIBPCT
DCBICH9  EQU   DCBIBPCT
DCBIBEC  EQU   DCBIFLG
DCBOFIOF EQU   DCBOFLGS
DCBOFUEX EQU   DCBOFLGS
DCBOFTM  EQU   DCBOFLGS
DCBOFPPC EQU   DCBOFLGS
DCBOFOPN EQU   DCBOFLGS
DCBOFEOV EQU   DCBOFLGS
DCBOFLRB EQU   DCBOFLGS
DCBOFIOD EQU   DCBOFLWR
DCBDDNAM EQU   IHADCS24
DCBEXLSA EQU   DCBEXLST+1
DCBRECKL EQU   DCBRECFM
DCBRECCC EQU   DCBRECFM
DCBRECSB EQU   DCBRECFM
DCBRECTO EQU   DCBRECLA
DCBBFA   EQU   DCBBFTEK
DCBH0    EQU   DCBBFTEK
DCBBFTKD EQU   DCBBFTEK
DCBBFTE  EQU   DCBBFT
DCBBFTKR EQU   DCBBFT
DCBBFTS  EQU   DCBBFT
DCBH1    EQU   DCBBFTEK
DCBSVCXA EQU   DCBSVCXL+1
@NM00016 EQU   DCBSVCXL
DCBODEBA EQU   DCBIOBAA
@NM00015 EQU   DCBQSLM
DCBUPDBT EQU   DCBQSLM
DCBUPDCM EQU   DCBQSLM
DCB1DVDS EQU   DCBQSLM
@NM00014 EQU   DCBDSRG2
DCBDSGTR EQU   DCBDSRG2
DCBACBM  EQU   DCBDSRG2
@NM00013 EQU   DCBDSRG2
DCBDSGTQ EQU   DCBDSRG2
DCBDSGTX EQU   DCBDSRG2
DCBDSGGS EQU   DCBDSRG2
DCBDSGU  EQU   DCBDSRG1
DCBDSGPO EQU   DCBDSRG1
@NM00012 EQU   DCBDSRG1
@NM00011 EQU   DCBDSRG1
DCBDSGCX EQU   DCBDSRG1
DCBDSGDA EQU   DCBDSRG1
DCBDSGPS EQU   DCBDSRG1
DCBDSGIS EQU   DCBDSRG1
DCBBUFL  EQU   IHADCS11+8
DCBBUFCA EQU   DCBBUFCB+1
DCBBUFNO EQU   DCBBUFCB
DCBDEVT  EQU   DCBREL
DCBTRBAL EQU   IHADCS01+6
@NM00010 EQU   IHADCS01+5
@NM00009 EQU   IHADCS01+4
DCBDVTBA EQU   DCBDVTBL+1
@NM00008 EQU   DCBDVTBL
DCBKEYCN EQU   IHADCS00+4
DCBRELAD EQU   IHADCS00
@NM00007 EQU   IHADCB
IIGMLEN  EQU   IIGMSPLG+1
IIGMPOOL EQU   IIGMSPLG
IIGMADDR EQU   IIGMNTRY
AUDCLM   EQU   AUDCSPLM+1
AUDCSPM  EQU   AUDCSPLM
AUDCMSGA EQU   IIGMAUD+24
AUDCLB   EQU   AUDCSPLB+1
AUDCSPB  EQU   AUDCSPLB
AUDCBFRS EQU   IIGMAUD+16
AUDCLD   EQU   AUDCSPLD+1
AUDCSPD  EQU   AUDCSPLD
AUDCDEB  EQU   IIGMAUD+8
AUDCLI   EQU   AUDCSPLI+1
AUDCSPI  EQU   AUDCSPLI
AUDCIICB EQU   IIGMAUD
@NM00006 EQU   IIAUDFL2
AUDDEBXF EQU   IIAUDFL2
AUDBFRRT EQU   IIAUDFL2
AUDBFREX EQU   IIAUDFL2
AUDACBRC EQU   IIAUDFL2
AUDACBCL EQU   IIAUDFL2
AUDIIFBF EQU   IIAUDFL2
AUDURSYN EQU   IIAUDFL1
AUDIISYN EQU   IIAUDFL1
AUDPRMOD EQU   IIAUDFL1
AUDDCBRT EQU   IIAUDFL1
AUDDCBEX EQU   IIAUDFL1
AUDACBRO EQU   IIAUDFL1
AUDACBOP EQU   IIAUDFL1
@NM00005 EQU   IIREGSAV+12
IIREGFC  EQU   IIREGSAV+8
@NM00004 EQU   IIREGSAV
IISAMSYN EQU   IDAIICB+52
IISVCLST EQU   IDAIICB+48
IITBUFL  EQU   IDAIICB+45
IIBUFNO  EQU   IDAIICB+44
IIMSGPTR EQU   IDAIICB+40
IIMSGL   EQU   IDAIICB+37
@NM00003 EQU   IIFLAG3
MBFALN   EQU   IIFLAG3
IIBUFL   EQU   IDAIICB+34
IIKEYSL  EQU   IDAIICB+32
IIRPLL   EQU   IDAIICB+29
MKEYLE   EQU   IIFLAG2
MBUFNO   EQU   IIFLAG2
MBUFL    EQU   IIFLAG2
MRECFM   EQU   IIFLAG2
MOPTCD   EQU   IIFLAG2
MBLKSI   EQU   IIFLAG2
MLRECL   EQU   IIFLAG2
MRKP     EQU   IIFLAG2
IIACBL   EQU   IDAIICB+25
IIQBFRS  EQU   IIFLAG1
@NM00002 EQU   IIFLAG1
IIFTEST  EQU   IIFLAG1
IIFCLOSE EQU   IIFLAG1
IIFACBCL EQU   IIFLAG1
IIMAXLRL EQU   IIW1CBF+2
IISAVLRL EQU   IIW1CBF
IIACBPTR EQU   IDAIICB+8
IICBLEN  EQU   IDAIICB+2
@NM00001 EQU   IDAIICB+1
IICBID   EQU   IDAIICB
.@UNREFD ANOP                          END UNREFERENCED COMPONENTS
@RT00179 EQU   INVALID
@RT00200 EQU   INVALID
@RC00189 EQU   @RC00187
@RT00217 EQU   INVALID
@RT00268 EQU   INVALID
@RF00276 EQU   @RC00273
@RF00351 EQU   PM2EXIT
@RC00334 EQU   PM2EXIT
@RC00326 EQU   PM2EXIT
@PB00002 EQU   @EL00001
@RC00330 EQU   @RC00326
@RC00439 EQU   @PB00002
@ENDDATA EQU   *
         END   IDAIIPM2,(C'PLS2219',0701,77110)
