*/********************************************************************/
*/*                                                                  */
*/*   MACRO NAME = IDAIMWA                                           */
*/*                                                                  */
*/*   DESCRIPTIVE NAME = INDEX MODIFICATION WORK AREA                */
*/*                                                                  */
*/*   FUNCTION = USED BY VSAM RECORD MANAGEMENT WHEN MODIFING        */
*/*              AN INDEX                                            */
*/*                                                                  */
*/*   CONTROL BLOCK STRUCTURE = POINTED TO BY IDAAMB                 */
*/*                                                                  */
*/*   INCLUDED MACROS = NONE                                         */
*/*                                                                  */
*/*   METHOD OF ACCESS = PL/S - NO DECLARES NECESSARY                */
*/*                                                                  */
*/*   CREATED BY = VSAM OPEN                                         */
*/*                                                                  */
*/*   STATUS = VS/1 RELEASE 4  (CHANGE FLAG @X04SVXX)                */
*/*                                                                  */
*/*   DATE OF LAST CHANGE = 9 AUG 74                                 */
*/*                                                                  */
*/********************************************************************/
*        DCL 1 IDAIMWA BASED BDY(WORD),    /* INDEX INSERT WORK AREA */
*              2 IMWID        CHAR(1),     /* CONTROL BLOCK ID       */
*              2 IMWFLAGS     CHAR(1),     /* PROCESS FLAGS          */
*                3 IMWNEWHL   BIT(1),      /* BUILD NEW HIGH LEVEL   */
*                3 IMWRIPL    BIT(1),      /* RIPPLE INSERT          */
*                3 IMWBSE     BIT(1),      /* BUILD SECTION ENTRY    */
*              2 IMWLEN       FIXED(15),   /* CONTROL BLOCK LENGTH   */
*              2 IMWIXSP      PTR(31),     /* PTR TO IX SEARCH PARML */
*              2 IMWISWKA     CHAR(32) BDY(WORD), /* IX SEARCH PARML */
*              2 IMWXKEYP     PTR(31),     /* PTR TO NEXT DATA KEY   */
*              2 IMWIKEYP     PTR(31),     /* PTR TO INSERT KEY      */
*              2 IMWXPTR      PTR(31),     /* NEXT ENTRY PTR VALUE   */
*              2 IMWIPTR      PTR(31),     /* NEW ENTRY PTR VALUE    */
*              2 IMWLBUFC     PTR(31),     /* LOW KEY DATA BUFC PTR  */
*              2 IMWBUFP      PTR(31),     /* IDX RECORD PTR         */
*              2 IMWFGAIN     PTR(8),      /* NEXT ENTRY F GAIN      */
*              2 IMWIEL       PTR(8),      /* NEW ENTRY L VALUE      */
*              2 IMWSVIEL     PTR(8),      /* SAVE L DURING RIPPLE   */
*              2 *            PTR(8),      /* NOT USED               */
*              2 IMWCIMVN     PTR(15),     /* NO. CIS TO MOVE BACK TO*/
*                                          /* OLD CONTROL AREA       */
*              2 IMWNSOFF     PTR(15),     /* OFFSET TO NEXT SECTION */
*              2 *            PTR(31),     /* RESERVED FOR FUTURE USE*/
*              2 IMWKEY1      CHAR(*);     /* INSERT KEY FOR MASS I. */
