*/*********************************************************************
*                                                                     *
*   THIS MAPPING MACRO DESCRIBES THE CONTROL BLOCK PASSED TO THE I/O  *
*   MANAGER BY USERS SUCH AS RECORD MANAGEMENT AND ASM.  IT CONTAINS  *
*   POINTERS TO OTHER CONTROL BLOCKS, FLAGS FOR I/O MANAGER USE, AND  *
*   A SIXTEEN WORD SAVE AREA.  POINTERS TO THE FIRST BUFC AND CPA ARE *
*   INSERTED BY I/O MGR AFTER THEY HAVE BEEN VERIFIED.                *
*                                                                     *
*   THE IOMB IS USED IN CONJUNCTION WITH AN IOSB AND AN SRB FOR I/O   *
*   PURPOSES IN PLACE OF THE IOB USED BY OTHER IOS DRIVERS.  THE IOMB *
*   POINTS TO THE IOSB, WHICH POINTS TO THE SRB.                      *
*                                                                     *
*    09/18/74          LEVEL=01                                       *
*    08/15/75          LEVEL=02           CHANGE FLAG=@Z40GSDT        *
*                                                                     *
**********************************************************************/
* %      GO TO IOMBPLS;             /* GO TO THE PLS VERSION         */
         MACRO
         IDAIOMB
IOMB     DSECT
         SPACE 1
         DS    0F
IOMBID   DS    XL4                  IOMB IDENTIFIER
IOMBUFC  DS    F                    POINTER TO THE FIRST BUFC
IOMCPA   DS    F                    POINTER TO THE FIRST CPA
IOMPLH   DS    F                    POINTER TO THE PLH
IOMAMB   DS    F                    POINTER TO THE AMB
IOMIQE   DS    F                    POINTER TO THE IQE
IOMECBPT DS    F                    POINTER TO THE ECB
IOMVSL   DS    F                    POINTER TO THE VIRTUAL SUBAREA LIST
IOMPGAD  DS    F                    ADDR OF CALLER TO RECEIVE CONTROL
*                                   ON COMPLETION OF I/O OPERATION
*                                   (ZEROED FOR RECORD MANAGEMENT)
IOMIOSB  DS    F                    POINTER TO THE IOSB
IOMFLAGS DS    0XL3                 INTERNAL FLAGS
IOMFL    DS    XL2                  FLAGS TO BE RESET AFTER I/O
IOMAPEND EQU   X'C0'                ABNORMAL END AND NORMAL END ENTERED
IOMNE    EQU   X'80'                NORMAL END ENTERED
IOMAE    EQU   X'40'                ABNORMAL END ENTERED
IOMPURGE EQU   X'20'                PURGE IN PROGRESS
IOMCBERR EQU   X'08'                CONTROL BLOCK VALIDITY ERROR
IOMADERR EQU   X'04'                ERROR CONVERTING VPL TO IDAL
IOMPGFIX EQU   X'02'                PAGES FIXED
IOMCSW   EQU   X'01'                CSW ADDRESS NOT VALID
*                                   SECOND BYTE OF IOMFL AND IOMFLAGS
IOMDDR   EQU   X'80'                DYNAMIC DEVICE RECONFIGURATION
IOMCPRB  EQU   X'40'                CALLER IN PROBLEM STATE    @ZA09130
IOMEEXIT EQU   X'08'                END APPENDAGE EXIT BIT     @ZA02276
IOMIRBSW EQU   X'04'                ASYNCH PROCESSING SCHED    @ZA02276
         SPACE 1
*                                   THIRD BYTE OF IOMFLAGS
IOMSTIND DS    XL1                  ONE BYTE OF STATUS INDICATORS
IOMAMUSE EQU   X'80'                IOMB CURRENTLY IN USE
IOMEOVW  EQU   X'40'                EOV WAITING FOR IOMB
IOMEOVTS EQU   X'20'                EOV HAS SET IOMLOCK
IOMEOVXC EQU   X'10'                END OF VOLUME INDICATOR
IOMLLOCK EQU   X'08'                LOCAL LOCK HELD
IOMSLOC  EQU   X'04'                SALLOC HELD                @Y30SDLC
IOMSRBM  EQU   X'02'                USER IN SRB MODE           @Y30SDLP
IOMSR    EQU   X'01'                SUSPEND/RESUME INDICATOR   @Z40GSDT
IOMCKEY  DS    XL1                  USER KEY SAVED FOR APPENDAGE USE
IOMPFERR DS    XL1                  RETURN CODE FROM PAGEFIX
IOMLOCK  DS    XL1                  END OF VOLUME LOCK
IOMNMOD  DS    H                    NUMBER OF MODULES TO BE FIXED
IOMNBUF  DS    H                    NUMBER OF BUFFERS
IOMNSEG  DS    H                    NUMBER OF CHANNEL PROGRAM SEGMENTS
IOMSAVER DS    0CL64                16 WORD SAVE AND WORK AREA
IOMSAVE0 DS    F
IOMSAVE1 DS    F
IOMSAVE2 DS    F
IOMSAVE3 DS    F
IOMSAVE4 DS    F
IOMSAVE5 DS    F
IOMSAVE6 DS    F
IOMSAVE7 DS    F
IOMSAVE8 DS    F
IOMSAVE9 DS    F
IOMSAVEA DS    F
IOMSAVEB DS    F
IOMSAVEC DS    F
IOMSAVED DS    F
IOMSAVEE DS    F
IOMSAVEF DS    F
IOMNXT1  DS    F                    POINTER TO NEXT IOMB ON CHAIN
IOMUFLD  DS    F                    USER FIELD-PTR TO IDAIOMBX FOR RM
IOMSRBP  DS    F                    ADDRESS OF SUSPENDED RB    @Z40GSDT
IOMSTCB  DS    F                    TCB FOR SUSPENDED RB       @Z40GSDT
         MEND
         EJECT
* /*      IOMB DECLARATION                                           */
* /*                                                                 */
*%IOMBPLS: ;
* /*                                                                 */
*     DCL 1 IDAIOMB BASED BDY(WORD),
*           2 IOMBID     CHAR(4),   /* IOMB IDENTIFIER               */
*           2 IOMBUFC    PTR(31),   /* FIRST BUFC ADDRESS            */
*           2 IOMCPA     PTR(31),   /* 1ST CPA IN CHAIN              */
*           2 IOMPLH     PTR(31),   /* PLH ADDRESS                   */
*           2 IOMAMB     PTR(31),   /* AMB ADDRESS                   */
*           2 IOMIQE     PTR(31),   /* IQE ADDRESS                   */
*           2 IOMECBPT   PTR(31),   /* ECB ADDRESS                   */
*           2 IOMVSL     PTR(31),   /* VIRTUAL SUBAREA LIST PTR      */
*           2 IOMPGAD    PTR(31),   /* ADDR OF CALLER TO GET CONTROL
*                                      ON COMPLETION OF I/O OPERATION
*                                      (ZEROED FOR RECORD MGMT)      */
*           2 IOMIOSB    PTR(31),   /* IOSB ADDRESS                  */
*           2 IOMFLAGS   BIT(24),   /* INTERNAL FLAGS                */
*             3 IOMFL    BIT(16),   /* FLAGS TO BE RESET AFTER I/O   */
*               4 IOMAPEND BIT(2),  /* APPENDAGE FLAGS               */
*                 5 IOMNE  BIT(1),  /* NE APPENDAGE COMPLETED        */
*                 5 IOMAE  BIT(1),  /* AE APPENDAGE COMPLETED        */
*               4 IOMPURGE BIT(1),  /* PURGE IN PROGRESS             */
*               4 *        BIT(1),  /* RESERVED                      */
*               4 IOMCBERR BIT(1),  /* CONTROL BLOCK VALIDITY ERROR  */
*               4 IOMADERR BIT(1),  /* ERROR CONVERTING VPL TO IDAL  */
*               4 IOMPGFIX BIT(1),  /* PAGES FIXED                   */
*               4 IOMCSW   BIT(1),  /* CSW ADDRESS NOT VALID         */
*               4 IOMDDR   BIT(1),  /* DYNAMIC DEVICE RECONFIGURATION*/
*               4 IOMCPRB  BIT(1),  /* PROBLEM STATE CALLER  @ZA09130*/
*               4 *        BIT(2),  /* RESERVED              @ZA09130*/
*               4 IOMEEXIT BIT(1),  /* END APPENDAGE EXIT    @ZA02276*/
*               4 IOMIRBSW BIT(1),  /* ASYNCH PROCESSING SCH @ZA02276*/
*               4 *        BIT(2),  /* RESERVED              @ZA02276*/
*             3 IOMSTIND   BIT(8),  /* STATUS INDICATORS             */
*               4 IOMAMUSE BIT(1),  /* IOMB CURRENTLY IN USE         */
*               4 IOMEOVW  BIT(1),  /* EOV WAITING FOR IOMB          */
*               4 IOMEOVTS BIT(1),  /* EOV HAS SET IOMLOCK           */
*               4 IOMEOVXC BIT(1),  /* END OF VOLUME INDICATOR       */
*               4 IOMLLOCK BIT(1),  /* LOCAL LOCK HELD               */
*               4 IOMSLOC  BIT(1),  /* SALLOC HELD           @Y30SDLC*/
*               4 IOMSRBM  BIT(1),  /* USER IN SRB MODE      @Y30SDLP*/
*               4 IOMSR    BIT(1),  /* SUSPEND/RESUME IND    @Z40GSDT*/
*           2 IOMCKEY    CHAR(1),   /* USER KEY FOR APPENDAGE USE    */
*           2 IOMPFERR   CHAR(1),   /* RETURN CODE FROM PAGE FIX     */
*           2 IOMLOCK    CHAR(1),   /* END-OF-VOLUME LOCK            */
*           2 IOMNMOD    PTR(16),   /* NUMBER OF MODULES TO BE FIXED */
*           2 IOMNBUF    PTR(16),   /* NUMBER OF BUFFERS             */
*           2 IOMNSEG    PTR(16),   /* NUMBER OF CHANNEL PGM SEGMENTS*/
*           2 IOMSAVER   BDY(WORD), /* 16 WORD SAVE AND WORK AREA    */
*             3 IOMSAVE0 PTR(31),
*             3 IOMSAVE1 PTR(31),
*             3 IOMSAVE2 PTR(31),
*             3 IOMSAVE3 PTR(31),
*             3 IOMSAVE4 PTR(31),
*             3 IOMSAVE5 PTR(31),
*             3 IOMSAVE6 PTR(31),
*             3 IOMSAVE7 PTR(31),
*             3 IOMSAVE8 PTR(31),
*             3 IOMSAVE9 PTR(31),
*             3 IOMSAVEA PTR(31),
*             3 IOMSAVEB PTR(31),
*             3 IOMSAVEC PTR(31),
*             3 IOMSAVED PTR(31),
*             3 IOMSAVEE PTR(31),
*             3 IOMSAVEF PTR(31),
*           2 IOMNXT1    PTR(31),   /* POINTER TO NEXT IOMB ON CHAIN */
*           2 IOMUFLD    PTR(31),   /* USER FIELD   -
*                                      PTR TO IDAIOMBX FOR REC MGMT  */
*           2 IOMSRBP    PTR(31),   /* ADDR OF SUSPENDED RB  @Z40GSDT*/
*           2 IOMSTCB    PTR(31);   /* TCB FOR SUSPENDED RB  @Z40GSDT*/
