     /* REGISTER DECLARES */
* /* MACSTAT Y-2 73276/Y02113                                        */
   DCL (R0 REG(00), R1 REG(01)) PTR(24) UNRESTRICTED;/* WORK REGISTERS*/
   DCL (RACB REG(02),                   /* PTR TO ACB */
        RBASE REG(03),                  /* BASE REGISTER */
        RCORE REG(04))                  /* PTR TO WORK AREA */
                       PTR(24) RESTRICTED;
   DCL ((RAMB,                          /* PTR TO AMB */
         RES) REG(05),                  /* PTR TO RESIDENT ROUTINE */
        (RWTG,                          /* PTR TO WTG TABLE */
         R6) REG(06),                   /* WORK REGISTER */
        (RPARC,                         /* PTR TO CURRENT ENTRY IN PARM
                                        LIST */
         R7) REG(07),                   /* WORK REGISTER */
        (RWTGC,                         /* PTR TO CURRENT WTG ENTRY */
         R8) REG(08),                   /* WORK REGISTER */
        (RTIOT,                         /* POINTER TO TIOT */
         R9) REG(09))                   /* WORK REGISTER */
                 PTR(24) RESTRICTED;    /* RESTRICTED REGISTER POINTERS
                                         */
   DCL ((RUCB,                          /* PTR TO UCB */
         R10) REG(10),                  /* WORK REGISTER */
        (RDEB,                          /* PTR TO DEB */
         R11) REG(11),                  /* WORK REGISTER */
         R12 REG(12),                   /* WORK REGISTER */
         R13 REG(13),                   /* WORK REGISTER */
         RET REG(14),                   /* RETURN REGISTER */
         (RETCODE,R15)REG(15))          /* RETURN CODE REGISTER */
               PTR(24) UNRESTRICTED;    /* WORK REGISTERS */
 @EJECT;
     /* CONSTANT DECLARES */
   DCL (ON CONSTANT('1'B),              /* INDIC BIT IS SET TO 1 */
        OFF CONSTANT('0'B)) BIT(1);     /* INDIC BIT IS SET TO 0*/
   DCL (DWORDLEN CONSTANT(8),           /* BYTE LENGTH OF DWORD */
        FWORDLEN CONSTANT(4),           /* BYTE LENGTH OF WORD */
        HWORDLEN CONSTANT(2)) FIXED;    /* BYTE LENGTH OF HWORD */
   DCL (FIX CONSTANT(0),
       NOFIX CONSTANT(4)) FIXED;
   DCL (EXFGON CONSTANT('0'B),          /* USER EXIT */
       EXFGOFF CONSTANT('1'B)) BIT(1);  /* USER EXIT NOT IN PROGRESS */
   DCL (OPM CONSTANT(4),
       CLM CONSTANT(8),
       OPO CONSTANT(12),
       OPP CONSTANT(16),
       VLT CONSTANT(20),
       CLR CONSTANT(24),
       PRE CONSTANT(32),
       DUM CONSTANT(28)) FIXED;
        DCL (MASTPOOL CONSTANT(250),/* SUBPOOL FOR MASTER BLOCK */
        SRBPOOL CONSTANT(245),       /* SUBPOOL FOR SRB,IOSB @Y021130*/
        RDEBPOOL CONSTANT(230),     /* SUBPOOL FOR REAL DEB  @Y021130*/
        DDEBPOOL CONSTANT(230),     /* SUBPOOL FOR DUMMY DEB @Y021130*/
        FIXDPOOL CONSTANT(245),     /* SUBPOOL FOR FIXED CORE */
        PROTPOOL CONSTANT(252),     /* SUBPOOL FOR PROT BLKS @Y021130*/
        LPMBPOOL CONSTANT(252),         /* SUBPOOL FOR LPMB */
        EDBPOOL CONSTANT(252),          /* SUBPOOL FOR EDB */
        CATPOOL CONSTANT(231),    /* CATALOG UNFIXED SUBPOOL @Y021130*/
        CATPOOL2 CONSTANT(239),     /* CATALOG FIXED SUBPOOL @Y021130*/
        WKPOOL CONSTANT(252),
        AMBLPOOL CONSTANT(252)) FIXED;  /* SUBPOOL FOR AMBL */
     /*  BASED DECLARES */
   DCL 1 MSTRBLK BASED,                 /* MASTER BLOCK FORMAT */
     2 MSTRHDR CHAR(16),
       3 MSTRNEXT PTR,                  /*   NEXT MASTER BLOCK */
       3 MSTRLAST PTR,                  /*   LAST MASTER BLOCK */
       3 *       FIXED(8),              /*                   @Y021130*/
       3 MSTRKEY FIXED(8),              /*  SUBPOOL KEY      @Y021130*/
       3 MSTRPOOL FIXED(8),             /*  SUBPOOL                 */
       3 MSTRCODE FIXED(8),             /*  FLAGS            @Y021130*/
       3 MSTRLEN FIXED(31),            /*  LENGTH THIS BLOCK @Y021130*/
     2 MSTRCORE CHAR(*);                /* REST OF MASTER BLOCK */
    DCL 1 ENQPARML BDY(WORD),       /* ENQ/DEQ PARAMETER LIST */
          2 ENQTCB PTR(31),         /* TCB FOR DIRECTED ENQ/DEQ */
          2 ENQPROPR,
            3 EQNOPT1 BIT(8),
              4 ENQEND BIT(1),      /* 1 INDICS END OF LIST */
              4 ENQNEW BIT(1),      /* 0 INDICS NES FORM OF PARM LIST */
              4 * BIT(5),
            4 ENQDIR BIT(1),        /* 1 INDICS DIRECTED ENQ/DEQ */
            3 ENQRLEN FIXED(8),     /* RNAME LENGTH */
            3 ENQOPT2 BIT(8),       /* OPTION BYTE 2 */
              4 ENQSHR BIT(1),      /* ENQ FOR SHARED CONTROL */
            3 ENQRETC FIXED(8),     /* ENQ/DEQ RETURN CODE */
            3 ENQQNADR PTR(31),     /* QNAME ADDRESS */
          3 ENQRNADR PTR(31),       /* RNAME ADDRESS */
          3 ENQUCADR PTR(31);       /* UCB ADDR FOR RESERVE */
    DCL 1 RNAME CHAR(8),            /* RNAME FOR ENQ/DEQ */
          2 * CHAR(3),              /* CI NBR FOR DS (DSN) */
        2 * CHAR(4),                /* ACB ADDR FOR CATALOG */
          2 * CHAR(1);              /* CONTROL CHAR - O=OUTPUT */
                                    /*                I=NOT OUTPUT */
                                    /*                B=BUSY */
