*/********************************************************************/
*/*                                                                  */
*/*   MACRO NAME = IDAIXSPL                                          */
*/*                                                                  */
*/*   DESCRIPTIVE NAME = INDEX SEARCH PARAMETER LIST                 */
*/*                                                                  */
*/*   FUNCTION = USED TO SEARCH A VSAM INDEX RECORD FOR A PARTICULAR */
*/*              KEY                                                 */
*/*                                                                  */
*/*   INCLUDED MACROS = NONE                                         */
*/*                                                                  */
*/*   METHOD OF ACCESS = PL/S - NO DECLARES NECESSARY                */
*/*                                                                  */
*/*   CREATED BY = VSAM RECORD MANAGEMENT                            */
*/*                                                                  */
*/*   STATUS = VS/1 RELEASE 4  (CHANGE FLAG @X04SVXX)                */
*/*                                                                  */
*/*   DATE OF LAST CHANGE = 9 AUG 74                                 */
*/*                                                                  */
*/********************************************************************/
*     DCL  1 IDAIXSPL  BASED,           /* INDEX SEARCH PARM LIST    */
*            2 IXSSTRBA  PTR(32),       /* START SEARCH RBA          */
*            2 IXSBUFC   PTR(31),       /* PTR TO INDEX BUFC         */
*            2 IXSARG    PTR(31),       /* PTR TO SEARCH ARGUMENT    */
*            2 IXSTLN    PTR(8),        /* TERMINATE LEVEL NO.       */
*            2 IXSILN    PTR(8),        /* INITIAL LEVEL NO.         */
*            2 IXSKLEN   PTR(15),       /* KEY LENGTH        @X04SVLC*/
*            2 IXSNOSR   PTR(8),        /* NBR CIS -1 IN RCD @X04SVLC*/
*            2 IXSBFLG   CHAR(1),       /* SCIB FLAGS                */
*             3 IXSSSRH  BIT(1),        /* SECTION SEARCH            */
              3 IXSLELV  BIT(1),        /* LAST ENTRY IN LEVEL       */
              3 *        BIT(6),        /* UNUSED                    */
*            2 IXSEKON   PTR(8),        /* LENGTH OF F+L+POINTER     */
*            2 IXSPEC    PTR(8),        /* COUNT ON PREVIOUS ENTRY   */
*            2 IXSHEP    PTR(31),       /* POINTER TO ENTRY FOUND    */
*            2 IXSSEP    PTR(31),       /* POINTER TO SECT.          */
*            2 IXSLEP    PTR(31);       /* POINTER TO LOW ENTRY IN   */
*                                       /*  THE SECTION              */
