*/********************************************************************/
*/*                                                                  */
*/*   MACRO NAME = IDALPMB                                           */
*/*                                                                  */
*/*   DESCRIPTIVE NAME = LOGICAL TO PHYSICAL MAPPING BLOCK           */
*/*                                                                  */
*/*   FUNCTION = USED TO MAP THE PHYSICAL ATTRIBUTES OF A VSAM DATA  */
*/*                SET                                               */
*/*                                                                  */
*/*   CONTROL BLOCK STRUCTURE = POINTED TO BY THE IDAEDB             */
*/*                                                                  */
*/*   INCLUDED MACROS = NONE                                         */
*/*                                                                  */
*/*   METHOD OF ACCESS = PL/S - NO DECLARES NECESSARY                */
*/*                                                                  */
*/*   CREATED BY = VSAM OPEN                                         */
*/*                                                                  */
*/*   STATUS = VS/1 RELEASE 4  (CHANGE FLAG @X04SVXX)                */
*/*                                                                  */
*/*   DATE OF LAST CHANGE = 13 AUG 74                                */
*/*                                                                  */
*/********************************************************************/
*  DCL 1 IDALPMB BASED,                    /* LOGICAL TO PHYSICAL  */
*                                          /* MAPPING BLOCK        */
*        2 LPMBID CHAR(1),                 /* LPMB IDENTIFER       */
*        2 LPMBFLGS BIT(8),                /* FLAG BYTE ONE        */
*          3 LPMBRPS BIT(1),               /* ON FOR RPS DEVICE    */
*          3 LPMREPL BIT(1),               /* REPLICATED RECORDS   */
*          3 LPMSS   BIT(1),               /* SEQUENCE SET W/DATA  */
*          3 LPMBTOFL BIT(1),              /* MVM TRK OFLOW  @Y30DSJH*/
*          3 LPMBSSTH BIT(1),              /* ON--SET SECTOR TABLE
*                                             IS HERE        @X04SVMR*/
*          3 *        BIT(3),              /* UNUSED         @Y30DSJH*/
*        2 LPMBLEN FIXED(15),              /* LENGTH OF LPMB       */
*        2 LPMAUSZ FIXED(31),              /* BYTES PER ALLOC UNIT */
*        2 LPMBPTRK FIXED(31),             /* BYTES PER TRACK      */
*        2 LPMBLKSZ FIXED(31),             /* PHYSICAL BLOCKSIZE   */
*        2 LPMTRKAU FIXED(15),             /* TRACKS PER ALLOC UNIT*/
*        2 LPMTPC FIXED(15),               /* TRACKS PER CYLINDER  */
*        2 LPMBLKTR FIXED(15),             /* BLOCKS PER TRACK     */
*        2 * FIXED(15),                    /* NOT USED       @X04SVLC*/
*        2 LPMBEXT PTR(31),                /* RESERVED FOR PTR TO LPMB
*                                             EXTENSION WHEN DEFINED
*                                                            @X04SVLC*/
*        2 LPMBSST CHAR(*);                /* SET SECTOR TAB @X04SVLC*/
