 /********************************************************************/
 /*                                                                  */
 /*   MACRO NAME = IDAOCECN                                          */
 /*                                                                  */
 /*   DESCRIPTIVE NAME = CONSTANTS USED BY OPEN/CLOSE/EOV MODULES.   */
 /*                                                                  */
 /*   FUNCTION = THESE ARE SOME CONSTANTS AND REGISTERS COMMONLY     */
 /*              USED BY THE OPEN/CLOSE/EOV MODULES.                 */
 /*                                                                  */
 /*   CONTROL BLOCK STRUCTURE = NONE                                 */
 /*                                                                  */
 /*   INCLUDED MACROS = NONE                                         */
 /*                                                                  */
 /*   METHOD OF ACCESS = PL/S - NO DECLARES NECESSARY                */
 /*                                                                  */
 /*   CREATED BY: N/A                                                */
 /*                                                                  */
 /*   STATUS = VS1 RELEASE 4, VS2 RELEASE 3.                         */
 /*                                                                  */
 /*   DATE OF LAST CHANGE = 2 AUGUST 74                              */
 /*                                                                  */
 /********************************************************************/
     /* REGISTER DECLARES */
   DCL (R0 REG(00), R1 REG(01)) PTR(31) UNRESTRICTED;/* WORK REGISTERS*/
   DCL (RACB REG(02),                   /* PTR TO ACB */
        RBASEA REG(03),                 /* BASE REGISTER */
       (RBASEB,R12) REG(12),            /* BASE REGISTER */
        R13 REG(13),                    /* PTR TO SAVE AREA */
       (RCORE,R4) REG(04))              /* PTR TO OPEN/CLOSE WKAREA */
                       PTR(31) RESTRICTED;
   DCL (R5 REG(05),                    /* WORK REGISTER */
         R6 REG(06),                   /* WORK REGISTER */
         R7 REG(07),                   /* WORK REGISTER */
         R8 REG(08),                   /* WORK REGISTER */
        (RTIOT,                         /* POINTER TO TIOT */
         R9) REG(09),                  /* WORK REGISTER */
        (RUCB,                          /* PTR TO UCB */
         R10) REG(10),                  /* WORK REGISTER */
        (RDEB,                          /* PTR TO DEB */
         R11) REG(11),                  /* WORK REGISTER */
         RET REG(14),                   /* RETURN REGISTER */
         (RETCODE,R15)REG(15))          /* RETURN CODE REGISTER */
               PTR(31) UNRESTRICTED;    /* WORK REGISTERS */
     /* CONSTANT DECLARES */
   DCL (ON CONSTANT('1'B),              /* INDIC BIT IS SET TO 1 */
        OFF CONSTANT('0'B)) BIT(1);     /* INDIC BIT IS SET TO 0*/
   DCL (DWORDLEN CONSTANT(8),           /* BYTE LENGTH OF DWORD */
        FWORDLEN CONSTANT(4),           /* BYTE LENGTH OF WORD */
        HWORDLEN CONSTANT(2)) FIXED;    /* BYTE LENGTH OF HWORD */
   DCL (FIX CONSTANT(0),
       NOFIX CONSTANT(4)) FIXED;
   DCL (EXFGON CONSTANT('0'B),          /* USER EXIT */
       EXFGOFF CONSTANT('1'B)) BIT(1);  /* USER EXIT NOT IN PROGRESS */
   DCL (OP1 CONSTANT(4),
       CLM CONSTANT(8),
       OPO CONSTANT(12),
       OPP CONSTANT(16),
       VLT CONSTANT(20),
       CLR CONSTANT(24),
       DUM CONSTANT(28),
       PRE CONSTANT(32),
       RCM CONSTANT(36),
       CLD CONSTANT(40),
       OP2 CONSTANT(44),
       CLC CONSTANT(48)) FIXED;
 %IF ENV='VS2'  %THEN
    %GOTO IDAOCE1;
   DCL PAGE CONSTANT(2048) FIXED(31);   /* VS1 PAGE SIZE    */
   DCL (RDEBPOOL CONSTANT(234),     /* SUBPOOL FOR REAL DEB */
        DDEBPOOL CONSTANT(252),         /* SUBPOOL FOR DUMMY DEB */
        FIXDPOOL CONSTANT(234),     /* SUBPOOL FOR FIXED CORE */
        FIXSTRPL CONSTANT(234),     /* SUBPOOL FOR FIXED STRING BLK */
        FIXUPGPL CONSTANT(234),     /* SUBPOOL FOR FIXED UPGRADE STR */
        CATPOOL CONSTANT(241),        /* CATALOG BLOCK SUBPOOL  */
        PRTSPPL CONSTANT(252),     /* SUBPOOL FOR PROTECTED SPHERE BLK*/
 %GOTO IDAOCE2;
 %IDAOCE1: ;
   DCL PAGE CONSTANT(4096) FIXED(31);   /* VS2 PAGE SIZE    */
   DCL (RDEBPOOL CONSTANT(230),     /* SUBPOOL FOR REAL DEB */
        DDEBPOOL CONSTANT(230),     /* SUBPOOL FOR DUMMY DEB */
        FIXDPOOL CONSTANT(245),     /* SUBPOOL FOR FIXED CORE */
        FIXSTRPL CONSTANT(245),     /* SUBPOOL FOR FIXED STRING BLK */
        FIXUPGPL CONSTANT(245),     /* SUBPOOL FOR FIXED UPGRADE STR */
        CATPOOL CONSTANT(231),      /* CATALOG BLOCK SUBPOOL */
        FCATPOOL CONSTANT(231),     /* FETCH PROTECTED CATALOG BLOCK */
        SCATPOOL CONSTANT(241),     /* STORE PROTECTED CATALOG BLOCK */
        PRTSPPL CONSTANT(241),     /* SUBPOOL FOR PROTECTED SPHERE BLK*/
        GSRSPOOL CONSTANT(241),     /* SUBPOOL FOR GSR CONTROL BLKS. */
 %IDAOCE2: ;
        WKPOOL CONSTANT(252),        /* SUBPOOL FOR GENERAL USE */
        EDBPOOL CONSTANT(252),          /* SUBPOOL FOR EDB */
        VATPOOL CONSTANT(252),     /* SUBPOOL FOR VAT            */
        SPBLKPL CONSTANT(250),     /* SUBPOOL FOR SPHERE BLK     */
        VMTPOOL CONSTANT(252),      /* SUBPOOL FOR VMT           */
        BIBPOOL CONSTANT(252),      /* SUBPOOL FOR BIB           */
        USERPOOL CONSTANT(250),     /* SUBPOOL FOR USER BLK       */
        PRTBLKPL CONSTANT(252),     /* PROTECTED USER BLK        */
        STRBLKPL CONSTANT(250),     /* SUBPOOL FOR STRING BLOCK   */
        UPSTRPL CONSTANT(250),      /* SUBPOOL FOR UPGRADE STR BLK */
        BFRPOOL CONSTANT(250),      /* SUBPOOL FOR BUFFER BLOCK  */
        UPGBFRPL CONSTANT(250),     /* SUBPOOL FOR UPGRADE BFR BLK */
        CMBPOOL CONSTANT(252),      /* SUBPOOL FOR CMB           */
        WSHDPL CONSTANT(250),     /* SUBPOOL FOR WSHD */
        AMBLPOOL CONSTANT(252)) FIXED;  /* SUBPOOL FOR AMBL */
