*/********************************************************************/
*/*                                                                  */
*/* MODULE-NAME = IDAPCTT                                            */
*/*                                                                  */
*/* DESCRIPTIVE-NAME = PCTT (PRIVATE CATALOG TERMINATION TABLE)      */
*/*                                                                  */
*/* COPYRIGHT = NONE                                                 */
*/*                                                                  */
*/* STATUS = VERSION 1 - JULY 9, 1973                                */
*/*                                                                  */
*/* FUNCTION = THE PRIVATE CATALOG TERMINATION TABLE, PCTT,          */
*/*   IS USED TO RECORD THE OPEN STATUS OF PRIVATE CATALOGS.         */
*/*   ONE OF ITS PRIMARY PURPOSES IS TO ENABLE PROPER CLEANUP        */
*/*   AND FREEING OF CONTROL BLOCKS DURING TASK TERMINATION.         */
*/*   (MOST OF THE CATALOG CONTROL BLOCKS ARE IN GLOBAL STORAGE.)    */
*/*   THERE IS ONE PCTT PER MEMORY. THE PCTT IS LOCATED FROM THE     */
*/*   ADDRESS SPACE CONTROL BLOCK, ASCB, FIELD - ASCBPCTT.           */
*/*                                                                  */
*/* NOTES = THE LABEL 'PCTT' IS DECLARED BASED ON ASCBPCTT.          */
*@LISTPUSH;
*@LISTOFF;
*/*                                                                  */
*/*    DEPENDENCIES = N/A                                            */
*/*                                                                  */
*/*    RESTRICTIONS = N/A                                            */
*/*                                                                  */
*/*    REGISTER-CONVENTIONS = N/A                                    */
*/*                                                                  */
*/*    PATCH-LABEL = N/A                                             */
*/*                                                                  */
*/* MODULE-TYPE = MAPPING MACRO                                      */
*/*                                                                  */
*/*    PROCESSOR = PLS2                                              */
*/*                                                                  */
*/*    MODULE-SIZE = N/A                                             */
*/*                                                                  */
*/*    ATTRIBUTES = N/A                                              */
*/*                                                                  */
*/* ENTRY-POINT = N/A                                                */
*/*                                                                  */
*/*    PURPOSE = N/A                                                 */
*/*                                                                  */
*/*    LINKAGE = N/A                                                 */
*/*                                                                  */
*/* INPUT = N/A                                                      */
*/*                                                                  */
*/* OUTPUT = N/A                                                     */
*/*                                                                  */
*/* EXIT-NORMAL = N/A                                                */
*/*                                                                  */
*/* EXIT-ERROR = N/A                                                 */
*/*                                                                  */
*/* EXTERNAL-REFERENCES = NONE                                       */
*/*                                                                  */
*/*    ROUTINES = N/A                                                */
*/*                                                                  */
*/*    DATA-AREAS = N/A                                              */
*/*                                                                  */
*/*    CONTROL-BLOCKS = N/A                                          */
*/*                                                                  */
*/* TABLES = N/A                                                     */
*/*                                                                  */
*/* MACROS = N/A                                                     */
*@LISTPOP;
*/*                                                                  */
*/* CHANGE-ACTIVITY = NONE                                           */
*/*                                                                  */
*/*                                                                  */
 /* PCTT                                                             */
 /*                                                                  */
 DCL 1 PCTT BASED(ASCBPCTT),
       2 PCTTHDR,                   /* PCTT HEADER                   */
         3 PCTTID  CHAR(4),         /* PCTT ID - PCTT-               */
         3 PCTTENBR PTR(31),        /* NBR OF SLOTS FOR ACB ADDRS    */
         3 PCTTCURR PTR(31),        /* NBR USED SLOTS FOR ACB ADDRS  */
         3 * PTR(31),               /* RESERVED                      */
       2 PCTTENTR(4),               /* ACB ENTRIES                   */
         3 PCTACBEN,                /* ACB ENTRY                     */
           4 PCTFLGS1 CHAR(1),      /* FLAG BYTE                     */
             5 PCTTCL BIT(1),       /* TEMPORARILY CLOSED            */
           4 * CHAR(1),             /* RESERVED                      */
           4 PCTTOPCT FIXED(15),    /* OPEN COUNT                    */
           4 PCTTACB  PTR(31);      /* ACB ADDRESS SLOT              */
