 /********************************************************************/
 /*                                                                  */
 /*   MACRO NAME = IDAPDFCD                                          */
 /*                                                                  */
 /*   DESCRIPTIVE NAME = VSAM OPEN/CLOSE/EOV PROBLEM DETERMINATION   */
 /*                      MESSAGE FUNCTION CODES.                     */
 /*                                                                  */
 /*   FUNCTION = TO IDENTIFY THE FUNCTION BEING PERFORMED WHEN THE   */
 /*              PROBLEM OCCURED.  THIS CODE IS INCLUDED IN THE      */
 /*              PROBLEM DETERMINATION MESSAGE.                      */
 /*                                                                  */
 /*   CONTROL BLOCK STRUCTURE = NONE                                 */
 /*                                                                  */
 /*   INCLUDED MACROS = NONE                                         */
 /*                                                                  */
 /*   METHOD OF ACCESS = PL/S - NO DECLARES NECESSARY                */
 /*                                                                  */
 /*   STATUS = VS1 RELEASE 4, VS2 RELEASE 3.                         */
 /*                                                                  */
 /*   DATE OF LAST CHANGE = 06/06/78                         @ZA33246*/
 /*                                                                  */
 /********************************************************************/
    DCL
     (PDF1 CONSTANT(1),             /* IDA0192C--INITIALIZATION      */
      PDF2 CONSTANT(2),             /* IDA0A92C--OBTAIN ASSOCIATED
                                       DATA SET CI NUMBERS           */
      PDF3 CONSTANT(3),             /* IDA0192C--OBTAIN DATA SET
                                       ATTRIBUTES                    */
      PDF4 CONSTANT(4),             /* IDA0192C--GET VOL INFO        */
      PDF5 CONSTANT(5),             /* IDA0192C--UPDATE OPEN
                                       INDICATOR IN CATALOG          */
      PDF6 CONSTANT(6),             /* IDA0192C--UPDATE CATALOG
                                       FOR CLOSE                     */
      PDF7 CONSTANT(7),             /* IDA0192C--GET VOL TIME STAMP  */
      PDF8 CONSTANT(8),             /* IDA0192C--RECORD MANAGEMENT
                                       CATALOG UPDATE                */
      PDF9 CONSTANT(9),             /* IDA0192C--UPDATE PREFORMAT
                                       INDICATOR IN CATALOG          */
      PDF10 CONSTANT(10),           /* IDA0192C--RETRIEVE 44 BYTE
                                       CLUSTER NAME                  */
      PDF11 CONSTANT(11),           /* IDA0192C--RETRIEVE 44 BYTE
                                       ELEMENTARY DATA SET NAME      */
      PDF20 CONSTANT(20),           /* IDA0192V--INITIALIZATION      */
      PDF21 CONSTANT(21),           /* IDA0192V--CHECK VOL TIMESTAMP */
      PDF22 CONSTANT(22),           /* IDA0192V--HANDLE MESSAGES     */
      PDF23 CONSTANT(23),           /* IDA0192V--MOUNT VOLUME        */
      PDF24 CONSTANT(24),           /* IDA0192V--MSS JES3    @ZA33246*/
      PDF30 CONSTANT(30),           /* IDA0192S--INITIALIZATION      */
      PDF31 CONSTANT(31),           /* IDA0192S--BUILD SMF RECORD    */
      PDF40 CONSTANT(40),           /* IDA0192D--INITIALIZATION      */
      PDF41 CONSTANT(41),           /* IDA0192D--BUILD UCB LIST      */
      PDF42 CONSTANT(42),           /* IDA0192D--BUILD
                                       ACQUIRE/RELINQUISH LIST       */
      PDF43 CONSTANT(43))           /* IDA0192D--ACQUIRE/RELINQUISH
                                       EXTENTS                       */
        FIXED(8);
    DCL
     (PDF50 CONSTANT(50),           /* IDA0192Z--INITIALIZATION      */
      PDF51 CONSTANT(51),           /* IDA0192Z--DETERMINE NUMBER
                                       OF BUFFERS NEEDED             */
      PDF52 CONSTANT(52),           /* IDA0192Z--BUILD BUFFERS       */
      PDF53 CONSTANT(53),           /* IDA0192Z--BUILD CNTRL BLOCKS  */
      PDF54 CONSTANT(54),           /* IDA0192Y--BUILD STRING BLOCKS */
      PDF60 CONSTANT(60),           /* IDA0192B--MOD INITIALIZATION  */
      PDF61 CONSTANT(61),           /* IDA0192B--LOCATE DATA SET
                                                 ATTRIBUTES AND
                                                 VALIDITY CHECK      */
      PDF62 CONSTANT(62),           /* IDA0192B--VOLUME PROCESSING   */
      PDF63 CONSTANT(63),           /* IDA0192B--PREFORMAT EXTENT    */
      PDF84 CONSTANT(84),           /* IDA0192B--SUBTASK SHARING     */
      PDF70 CONSTANT(70),           /* IDA0192W--INITIALIZATION      */
      PDF71 CONSTANT(71),           /* IDA0192W--BUILD CPA           */
      PDF80 CONSTANT(80),           /* IFG0193A--READ JFCB           */
      PDF81 CONSTANT(81),           /* IDA0192A--INITITALIZATION     */
      PDF82 CONSTANT(82),           /* IDA0192A--VERIFY ACB          */
      PDF83 CONSTANT(83),           /* IDA0192F--FIX CONTROL BLOCKS  */
      PDF85 CONSTANT(85),           /* IDA0192F--MNT AND VERIFY VOLS */
      PDF87 CONSTANT(87),           /* IDA0192A--CONNECT BASE        */
      PDF88 CONSTANT(88),           /* IDA0192F--OPEN BASE CLUSTER   */
      PDF89 CONSTANT(89),           /* IDA0192F--OPEN UPGRADE AIX    */
      PDF90 CONSTANT(90),           /* IDA0192F--OPEN PATH AIX       */
      PDF93 CONSTANT(93),           /* IDA0192A--BUILD DUMMY DEB     */
      PDF95 CONSTANT(95),           /* IDA0192A--OPEN TERMINATION    */
      PDF96 CONSTANT(96))           /* IDA0192A--OPEN ERROR CLEANUP  */
        FIXED(8);
    DCL
     (PDF100 CONSTANT(100),         /* IFG0200V--READ JFCB           */
      PDF101 CONSTANT(101),         /* IDA0200T--INITIALIZATION      */
      PDF103 CONSTANT(103),         /* IDA0200T--COMPLETE I/O        */
      PDF104 CONSTANT(104),         /* IDA0200T--CLOSE PATH          */
      PDF105 CONSTANT(105),         /* IDA0200T--CLOSE BASE          */
      PDF106 CONSTANT(106),         /* IDA0200T--CLOSE SPHERE        */
      PDF107 CONSTANT(107),         /* IDA0200T--CLOSE UPGRADE       */
      PDF108 CONSTANT(108),         /* IDA0200T--VMT PROCESSING      */
      PDF110 CONSTANT(110),         /* IDA0200B--INITIALIZATION      */
      PDF111 CONSTANT(111),         /* IDA0200B--VALIDITY CHECK      */
      PDF112 CONSTANT(112),         /* IDA0200B--SMF PROCESSING      */
      PDF113 CONSTANT(113),         /* IDA0200B--UPDATE CATALOG      */
      PDF114 CONSTANT(114),         /* IDA0200B--RELEASE CONTROL BLK */
      PDF115 CONSTANT(115),         /* IDA0200B--WRITE BUFFER        */
      PDF148 CONSTANT(148),         /* IDA0200T--FORCE DLVRP.@Z30SSMD*/
      PDF149 CONSTANT(149))         /* IDAOCEA2--FORCE DLVRP.@Z30SSMD*/
        FIXED(8);
    DCL
     (PDF150 CONSTANT(150),         /* IGC0002C--READ JFCB           */
      PDF151 CONSTANT(151),         /* IDA0231T--INITIALIZATION      */
      PDF153 CONSTANT(153),         /* IDA0231T--COMPLETE I/O        */
      PDF154 CONSTANT(154),         /* IDA0231T--TCLOSE PATH         */
      PDF155 CONSTANT(155),         /* IDA0231T--TCLOSE BASE         */
      PDF156 CONSTANT(156),         /* IDA0231T--TCLOSE UPGRADE      */
      PDF157 CONSTANT(157),         /* IDA0231B--INITIALIZATION      */
      PDF158 CONSTANT(158),         /* IDA0231B--VALIDITY CHECK      */
      PDF159 CONSTANT(159),         /* IDA0231B--UPDATE CATALOG      */
      PDF160 CONSTANT(160),         /* IDA0231B--SMF PROCESSING      */
      PDF161 CONSTANT(161))         /* IDA0231B--WRITE BUFFER        */
        FIXED(8);
    DCL
     (PDF200 CONSTANT(200),         /* IFG0551F--READ JFCB           */
      PDF201 CONSTANT(201),         /* IDA0557A--INITIALIZATION      */
      PDF202 CONSTANT(202),         /* IDA0557A--LOCATE AND MNT VOL  */
      PDF203 CONSTANT(203),         /* IDA0557A--ALLOCATE SPACE      */
      PDF204 CONSTANT(204),         /* IDA0557A--SWITCH VOLUMES      */
      PDF205 CONSTANT(205),         /* IDA0557A--BLD CONTROL BLOCKS  */
      PDF206 CONSTANT(206),         /* IDA0557A--UPDATE SMF RECORD   */
      PDF207 CONSTANT(207),         /* IDA0557A--PREFORMAT EXTENT    */
      PDF208 CONSTANT(208),         /* IDA0557A--RECORD MANAGEMENT
                                       CATALOG UPDATE                */
      PDF209 CONSTANT(209))         /* IDA0557A--RESET CNTRL BLOCKS  */
        FIXED(8);
