*% GO TO VS1;
         MACRO
         IDAPDPRM
*% VS1: ;
*/********************************************************************/
*/*                                                                  */
*/*   MACRO NAME = IDAPDPRM                                          */
*/*                                                                  */
*/*   DESCRIPTIVE NAME = PROBLEM DETERMINATION PARAMETER LIST.       */
*/*                                                                  */
*/*   FUNCTION = CONTAINS INFORMATIONS USED BY OPEN/CLOSE/EOV MODULES*/
*/*              TO GENERATE THE PROBLEM DETERMINATION MESSAGES.     */
*/*                                                                  */
*/*   CONTROL BLOCK STRUCTURE = NONE                                 */
*/*                                                                  */
*/*   INCLUDED MACROS = NONE                                         */
*/*                                                                  */
*/*   METHOD OF ACCESS = PL/S - RESPECIFY IDAPDPRM BASED.            */
*/*                                                                  */
*/*   CREATED BY: N/A                                                */
*/*                                                                  */
*/*   STATUS = VS1 RELEASE 4   (CHANGE FLAG @X04SVXX)                */
*/*            VS2 RELEASE 3   (CHANGE FLAG @Y30DSXX)                */
*/*            VS2 RELEASE 3  ICR (CHANGE FLAG @Z30SSXX)             */
*/*                                                                  */
*/*   DATE OF LAST CHANGE = 04 OCTOBER 74                    @Z30SSMD*/
*/*                                                                  */
*/********************************************************************/
*% GO TO VS1A;
IDAPDPRM DSECT                          VSAM PD PARAMETER LIST
PDPCALL  DS    CL1                      CALLER IDENTIFICATION CODE
PDPCODE  DS    CL1                      INTERNAL PD CODE
PDPFUNC  DS    CL1                      FUNCTION CODE
PDPSFC   DS    CL1                      SUB-FUNCTION RET CODE  @X04SVRP
PDPACB   DS    F                        ADDR OF USER ACB
PDPUCB   DS    F                        ADDR OF UCB
PDPTIOT  DS    F                        ADDR OF TIOT ENTRY FOR DD NAME
PDPVLSER DS    F                        ADDR OF VOL SER NUMBER
PDPCLSNM DS    F                        ADDR OF 44 BYTE CLUSTER NAME
PDPDSN   DS    F                        ADDR OF 44 BYTE DS NAME
PDPCTACB DS    F                        ADDR OF CATALOG ACB
PDPKEY   DS    CL1                      KEY SAVE AREA FOR MVM  @Y30DSJH
PDPDSTYP DS    CL1                      DATA SET TYPE          @X04SVRL
PDPMSGFL DS    CL1                      MSG AREA FLAG          @X04SVRL
         DS    CL1                      UNUSED                 @X04SVRL
PDPSFI   DS    F                        ADDR OF EXTENDED SUB-FUNCTION
*                                       INFORMATION            @X04SVRP
PDPLNGTH EQU   *-IDAPDPRM               LENGTH OF PARAMETER LIST
* CALLER IDENTIFICATION CODES
PDPOPEN  EQU   0                        OPEN
PDPCLOSE EQU   4                        CLOSE
PDPEOV   EQU   8                        END-OF-VOLUME
PDPTCLOS EQU   12                       TCLOSE
* DATA SET IDENTIFICATION CODE                                 @X04SVRL
PDPNONM  EQU   0                        NO DATA SET NAME       @Z30SSMD
PDPDDNM  EQU   1                        DD DATA SET NAME       @Z30SSMD
PDPBASE  EQU   2                        BASE DATA SET          @Z30SSMD
PDPPATH  EQU   3                        PATH DATA SET          @Z30SSMD
PDPUPGR  EQU   4                        UPGRADE DATA SET       @Z30SSMD
* MESSAGE AREA FLAG                                            @X04SVRL
PDPNOTFC EQU   X'80'                    ON IND NOT FIRST CALL  @X04SVRL
PDPSPACE EQU   X'40'                    ON IND NO MORE SPACE   @X04SVRL
PDPNOTRC EQU   X'20'                    ON IND SUPRESS TRACE   @Z30SSMD
PDPNOMSG EQU   X'10'                    ON IND SUPRESS MSGAREA @Z30SSMD
         MEND
*% VS1A: ;
*   DCL 1 IDAPDPRM BDY(WORD) BASED,    /* VSAM PD PARAMETER LIST     */
*         2 PDPCALL FIXED(8),          /* CALLER IDENTIFICATION      */
*         2 PDPCODE  FIXED(8),         /* INTERNAL PD CODE           */
*         2 PDPFUNC FIXED(8),          /* FUNCTION CODE              */
*         2 PDPSFC FIXED(8),           /* SUB-FUNCTION CODE  @X04SVRP*/
*         2 PDPACB PTR(31),            /* ADDR OF USER ACB           */
*         2 PDPUCB PTR(31),            /* ADDR OF UCB                */
*         2 PDPTIOT,                   /* ADDR OF TIOT ENTRY FOR
*                                         DD NAME                    */
*         2 PDPVLSER PTR(31),          /* ADDR OF VOL SER NUMBER     */
*         2 PDPCLSNM PTR(31),          /* ADDR OF 44 BYTE CLUSTER
*                                         NAME                       */
*         2 PDPDSN   PTR(31),          /* ADDR OF 44 BYTE DS NAME    */
*         2 PDPCTACB PTR(31),          /* ADDR OF CATALOG ACB        */
*         2 PDPKEY   FIXED(8),         /* KEY SAVE FOR MVM   @Y30DSJH*/
*         2 PDPDSTYP CHAR(1),          /* DATA SET TYPE      @X04SVRL*/
*         2 PDPMSGFL CHAR(1),          /* MSG AREA FLAG      @X04SVRL*/
*           3 PDPNOTFC BIT(1),         /* IND NOT FIRST CALL @X04SVRL*/
*           3 PDPSPACE BIT(1),         /* IND NO MORE SPACE  @X04SVRL*/
*           3 PDPNOTRC BIT(1),         /* IF ON THEN SUPRESS THE
*                                         GTF TRACE.VS2 ONLY.@Z30SSMD*/
*           3 PDPNOMSG BIT(1),         /* IF ON THEN SUPRESS MSG  AREA
*                                         SUPPORT. VS2 ONLY. @Z30SSMD*/
*         2 *        CHAR(1),          /* UNUSED             @X04SVRL*/
*         2 PDPSFI PTR(31);            /* ADDR OF EXTENDED SUB-FUNCTION
*                                         INFORMATION        @X04SVRP*/
*   /* CALLER IDENTIFICATION CODES                                   */
*   DCL (PDPOPEN  CONSTANT(0),         /* OPEN                       */
*        PDPCLOSE CONSTANT(4),         /* CLOSE                      */
*        PDPEOV   CONSTANT(8),         /* END-OF-VOLUME              */
*        PDPTCLOS CONSTANT(12))        /* TCLOSE                     */
*          FIXED(8);
*   /* DATA SET IDENTIFICATION CODES                         @X04SVRL*/
*   DCL (PDPNONM  CONSTANT(0),         /* NO DATA SET NAME   @Z30SSMD*/
*        PDPDDNM  CONSTANT(1),         /* DD NAME DATA SET   @Z30SSMD*/
*        PDPBASE  CONSTANT(2),         /* BASE DATA SET      @Z30SSMD*/
*        PDPPATH  CONSTANT(3),         /* PATH DATA SET      @Z30SSMD*/
*        PDPUPGR  CONSTANT(4))         /* UPGRADE DATA SET   @Z30SSMD*/
*          FIXED(8);
