 /********************************************************************/
 /*                                                                  */
 /*   MACRO NAME = IDAPPCDE                                          */
 /*                                                                  */
 /*   DESCRIPTIVE NAME = VSAM OPEN/CLOSE/EOV PROBLEM DETERMINATION   */
 /*                      MESSAGE PROBLEM CODE.                       */
 /*                                                                  */
 /*   FUNCTION = IDENTIFY THE PROBLEM THAT CAUSED THE PROBLEM        */
 /*              DETERMINATION MESSAGE.                              */
 /*                                                                  */
 /*   CONTROL BLOCK STRUCTURE = NONE                                 */
 /*                                                                  */
 /*   INCLUDED MACROS = NONE                                         */
 /*                                                                  */
 /*   METHOD OF ACCESS = PL/S - NO DECLARES NECESSARY                */
 /*                                                                  */
 /*   CREATED BY: N/A                                                */
 /*                                                                  */
 /*   STATUS = VS1 RELEASE 4, VS2 RELEASE 3.                         */
 /*                                                                  */
 /*   DATE OF LAST CHANGE = 11/04/75                         @Z40WSRL*/
 /*                                                                  */
 /********************************************************************/
    DCL
      (PP4 CONSTANT(4),             /* I/O ERROR READING JFCB        */
      PP20 CONSTANT(20),            /* INSUFFICIENT VIRTUAL STORAGE  */
      PP22 CONSTANT(22),            /* I/O ERROR COMPLETING I/O
                                       REQUESTS                      */
      PP28 CONSTANT(28),            /* CATALOG DOES NOT EXIST OR IS
                                       NOT OPEN                      */
      PP32 CONSTANT(32),            /* CATALOG ENTRY NOT FOUND       */
      PP33 CONSTANT(33),            /* CANNOT EXTEND VSAM CATALOG    */
      PP34 CONSTANT(34),            /* DATA SET HAS REACHED MAXIMUM
                                       NUMBER OF EXTENTS             */
      PP35 CONSTANT(35),            /* CATALOG RECORD HAS EXCEEDED
                                       MAX NBR OF OCCURRENCES*/
      PP36 CONSTANT(36),            /* CATALOG I/O ERROR             */
      PP37 CONSTANT(37),            /* UNEXPECTED RETURN CODE FROM
                                       CATALOG                       */
      PP38 CONSTANT(38),            /* EMPTY PATH DATA SET           */
      PP39 CONSTANT(39),            /* EMPTY UPGRADE AIX             */
      PP40 CONSTANT(40),            /* SECURITY VIOLATION            */
      PP41 CONSTANT(41),            /* BUFFER SPACE TO SMALL         */
      PP44 CONSTANT(44),            /* USER BUFFERING AND NOT
                                       CINV PROCESSING               */
      PP45 CONSTANT(45),            /* UNUSABLE DS OPEN FOR INPUT    */
      PP46 CONSTANT(46),            /* UNUSABLE DS OPEN FOR OUTPUT   */
      PP47 CONSTANT(47),            /* ICI & INCONSISTENT PARAMETERS */
      PP48 CONSTANT(48),            /* RESET AND DS IS AN INDEX      */
      PP49 CONSTANT(49),            /* ICI PROCESSING AND CREATE MODE*/
      PP50 CONSTANT(50),            /* UNABLE TO PAGE FIX CNTRL BLKS */
      PP52 CONSTANT(52),            /* UNABLE TO OBTAIN RESOURCE     */
      PP54 CONSTANT(54),            /* KEYED ACCESSING AND NOT KSDS  */
      PP56 CONSTANT(56),            /* DATA SET NOT CLOSED           */
      PP58 CONSTANT(58),            /* INDEX TIMESTAMP LESS THAN
                                       DATA TIMESTAMP                */
      PP59 CONSTANT(59),            /* VOLUME TIMESTAMP ERROR AND
                                       VOL BEING OPENED FOR INPUT    */
      PP60 CONSTANT(60),            /* VOLUME TIMESTAMP ERROR AND
                                       VOL BEING OPENED FOR OUTPUT   */
      PP68 CONSTANT(68),            /* INCONSISTENT DEVICE TYPES     */
      PP72 CONSTANT(72),            /* EMPTY DS NOT OPEN FOR OUTPUT  */
      PP76 CONSTANT(76),            /* INVALID ACB                   */
      PP78 CONSTANT(78),            /* INVALID AMBL                  */
      PP80 CONSTANT(80),            /* DS OPENED FOR CREATE WITH
                                       STRNO GREATER THAN 1          */
      PP84 CONSTANT(84),            /* RESET SPECIFIED FOR NON-REUSABLE
                                       DATA SET                      */
      PP88 CONSTANT(88),            /* RESET SPECIFIED FOR REAL PATH */
      PP90 CONSTANT(90),            /* MSS MOUNT ERROR               */
      PP91 CONSTANT(91),            /* MSS DEMOUNT ERROR             */
      PP92 CONSTANT(92),            /* MSS ACQUIRE ERROR             */
      PP93 CONSTANT(93),            /* MSS RELINQUISH ERROR          */
      PP94 CONSTANT(94),            /* MSS UNABLE TO BIND            */
      PP100 CONSTANT(100),          /* NO SPACE ON CANDIDATE VOLUMES */
      PP104 CONSTANT(104),          /* NO VOLS AVAILABLE FOR
                                       SPACE ALLOCATION              */
      PP108 CONSTANT(108),          /* UNABLE TO MOUNT VOLUME        */
      PP112 CONSTANT(112),          /* UNABLE TO MOUNT VOLUME FOR
                                       SPACE ALLOCATION              */
      PP116 CONSTANT(116),          /* I/O ERROR READING VOLUME LABEL
                                       OR FORMAT 4 DSCB              */
      PP120 CONSTANT(120),          /* LSR/GSR AND CINV SIZE EXCEEDS
                                       MAXIMUM BUFFER SPACE          */
      PP124 CONSTANT(124),          /* LSR/GSR - VSRT DOES NOT EXIST */
      PP128 CONSTANT(128),          /* LSR/GSR - ERROR IN WRTBFR     */
      PP132 CONSTANT(132),          /* GSR AND SYSTEM IS VS1         */
      PP136 CONSTANT(136),          /* LSR/GSR AND RESET             */
      PP140 CONSTANT(140),          /* LSR/GSR AND ICI               */
      PP144 CONSTANT(144),          /* LSR/GSR AND USER BUFFERING    */
      PP148 CONSTANT(148),          /* GSR AND CALLER NOT AUTHORIZED */
      PP152 CONSTANT(152),          /* LSR/GSR AND DATA SET IS EMPTY */
      PP156 CONSTANT(156),          /* LSR/GSR AND KEY LENGTH EXCEEDS
                                       MAXIMUM                       */
      PP164 CONSTANT(164),          /* LSR/GSR WITH DFR AND SHARE
                                       OPTION IS 4                   */
      PP168 CONSTANT(168),          /* CRA VOL NOT MOUNTED           */
      PP172 CONSTANT(172),          /* FMT 4 DSCB INDICATES VOL IS
                                       UNUSABLE                      */
      PP176 CONSTANT(176),          /* GSR FORCE DLVRP WAS DONE,
                                       DUMP WAS TAKEN.       @Z30SSMD*/
      PP180 CONSTANT(180),          /* GSR FORCE DLVRP WAS DONE,
                                       PARTIAL DUMP WAS DONE.@Z30SSMD*/
      PP184 CONSTANT(184),          /* GSR FORCE DLVRP WAS DONE, DUMP
                                       COULD NOT BE DONE.    @Z30SSMD*/
      PP188 CONSTANT(188),          /* SYSTEM DATA SET DOES NOT SUPPORT
                                       THE LSR OR GSR OPTION @Z40WSRL*/
      PP192 CONSTANT(192))          /* SYSTEM DATA SET DOES NOT SUPPORT
                                       PATH OR UPGRADE PROCESSING
                                                             @Z40WSRL*/
        FIXED(8);
