 /********************************************************************/
 /*                                                                  */
 /*   MACRO NAME = IDAPSL                                            */
 /*                                                                  */
 /*   DESCRIPTIVE NAME = PAGE SAVE LIST.                             */
 /*                                                                  */
 /*   FUNCTION = THE PSL CONTAINS A VARABLE NUMBER OF ENTRIES. ALL   */
 /*              SUCCESSFUL FIXED STORAGE FOR AN OPEN IS REFLECTED   */
 /*              IN THIS LIST. THERE IS A MAXIMUM OF 1 LIST PER ESDS */
 /*              OR KSDS.                                            */
 /*                                                                  */
 /*   CONTROL BLOCK STRUCTURE = POINTED TO BY THE OPEN ACB WORK AREA.*/
 /*                                                                  */
 /*   INCLUDED MACROS = NONE                                         */
 /*                                                                  */
 /*   METHOD OF ACCESS = PL/S - RESPECIFY IDAPSL BASED.              */
 /*                                                                  */
 /*   CREATED BY: VSAM OPEN MODULE IDA0192A.                         */
 /*                                                                  */
 /*   STATUS = VS1 RELEASE 4, VS2 RELEASE 3.                         */
 /*                                                                  */
 /*   DATE OF LAST CHANGE = 1 AUGUST 74                              */
 /*                                                                  */
 /********************************************************************/
    DCL 1 IDAPSL BASED,             /* PAGE SAVE LIST                */
          2 PSLSUBPL FIXED (8),     /* SUBPOOL NUMBER OF THIS PSL    */
          2 PSLLENTH FIXED (24),    /* LENGTH IN BYTES OF THIS PSL   */
          2 PSLID CHAR (8),         /* BLOCK IDENTIFIER              */
          2 PSLNXPTR PTR (31),      /* POINTER TO NEXT PSL OR 0 IF
                                       LAST PSL IN CHAIN             */
          2 PSLENTRY (*),           /* PAGE SAVE ENTRY               */
            3 PSLSTAD PTR (31),     /* STARTING ADDR OF FIXED AREA   */
            3 PSLFLG BIT (8),       /* FLAGS                         */
              4 PSLFLGLT BIT (1),   /* BIT ON INDICATES LAST ENTRY   */
              4 * BIT (7),          /* RESERVED                      */
            3 PSLENDAD PTR (24)     /* END ADDR+1 OF FIXED AREA      */
    ;
    DCL IDAPSLID CHAR (8) CONSTANT (' IDAPSL '); /* CHAR CONSTANT
                                       FOR PSLID                     */
