*/********************************************************************/
*/*                                                                  */
*/*   MACRO NAME = IDARDF                                            */
*/*                                                                  */
*/*   DESCRIPTIVE NAME = VSAM RECORD DEFINITION FIELD                */
*/*                                                                  */
*/*   FUNCTION = DESCRIBES THE RECORD DEFINITION FIELD OF A VSAM     */
*/*              RECORD                                              */
*/*                                                                  */
*/*   INCLUDED MACROS = NONE                                         */
*/*                                                                  */
*/*   METHOD OF ACCESS = PL/S - NO DECLARES NECESSARY                */
*/*                                                                  */
*/*   CREATED BY = VSAM RECORD MANAGEMENT                            */
*/*                                                                  */
*/*   STATUS = VS/1 RELEASE 4  (CHANGE FLAG @X04SVXX)                */
*/*                                                                  */
*/*   DATE OF LAST CHANGE = 9 AUG 74                                 */
*/*                                                                  */
*/********************************************************************/
*        DCL 1 IDARDF BASED,            /* RECORD DEFINITION FIELD   */
*              2 RDFRBYTE     CHAR(1),  /*                           */
*                3 RDFTYPE    BIT(1),   /* R TYPE                    */
*                3 RDFCTNU    BIT(1),   /* CONTROL INFO. CONTINUATION*/
*                3 RDFSEG     BIT(2),   /* SEGMENT TYPE INDICATOR    */
*                  4 RDFNOT1 BIT(1),    /* OFF= NOT A SPAN RCD OR
*                                          FIRST SEG OF S.R. @X04SVLC*/
*                                       /* ON = INTERMEDIATE OR LAST
*                                          SEGMENT OF A SPANNED
*                                          RCD               @X04SVLC*/
*                  4 RDF1ST BIT(1),     /* OFF = NOT A SPAN RCD OR LAST
*                                          SEGMENT OF S.R.   @X04SVLC*/
*                                       /* ON  = FIRST OR INTERMEDIATE
*                                          SEGMENT OF SPAN
*                                          RECORD            @X04SVLC*/
*                                       /*  00 COMPLETE REC  @X04SVLC*/
*                                       /*  01 FIRST SEGMENT @X04SVLC*/
*                                       /*  10 LAST  SEGMENT @X04SVLC*/
*                                       /*  11 INTERMEDIATE
*                                          SEGMENT           @X04SVLC*/
*                3 RDFREPL    BIT(1),   /*  0 - LL IS RECORD LENGTH  */
*                                        /*  1 - LL IS RECORD COUNT  */
*                3 RDFEMPTY   BIT(1),   /* EMPTY RECORD      @X04SVLC*/
*              2 RDFLL        CHAR(2);  /*                           */
*/********************************************************************/
*/* DATA DEFINITION                                                  */
*/********************************************************************/
*        DCL 1 IDADATA BASED,            /* DATA DECLARE     @X04SVLC*/
*              2 AMDATA       CHAR(*);                     /*@X04SVLC*/
*/********************************************************************/
*/* KEY DEFINITION                                                   */
*/********************************************************************/
*        DCL 1 IDAKEY BASED,             /* KEY DECLARE      @X04SVLC*/
*              2 KEY         CHAR(*);    /* KEY DECLARE      @X04SVLC*/
       GEN DATA;                                           /*@X04SVLC*/
RDFCTNUA EQU   X'40'                    COMPLEX RDF INDICATOR
RDFCTNUX EQU   X'FF'-RDFCTNUA           RESET COMPLEX MASK
RDFREPLA EQU   X'08'                    COUNT RDF INDICATOR
RDFREPLX EQU   X'FF'-RDFREPLA           RESET COUNT MASK
RDFEMPTI EQU   X'04'                    EMPTY RECORD       /*@X04SVLC*/
RDFLEN   EQU   3                        LENGTH OF RDF
RDFLLOFF EQU   1                        OFFSET WITHIN RDF TO LL
RDFSGLR  EQU   X'00'                   MASK FOR SINGLE RECORD RDF
RDFGRP   EQU   RDFCTNUA                 MASK FOR LL RDF OF A GROUP RDF
RDFCNT   EQU   RDFREPLA                 MASK FOR COUNT RDF
         @ENDGEN;
