*/********************************************************************/
*/*                                                                  */
*/*   MACRO NAME = IDAREGS                                           */
*/*                                                                  */
*/*   DESCRIPTIVE NAME =VSAM RECORD MANAGEMENT REGISTER DECLARES     */
*/*                                                                  */
*/*   FUNCTION = DECLARES REGISTERS USED BY VSAM RECORD MANAGEMENT   */
*/*                                                                  */
*/*   INCLUDED MACROS = NONE                                         */
*/*                                                                  */
*/*   METHOD OF ACCESS = PL/S - NO DECLARES NECESSARY                */
*/*                                                                  */
*/*   STATUS = VS/1 RELEASE 4  (CHANGE FLAG @X04SVXX)                */
*/*                                                                  */
*/*   DATE OF LAST CHANGE = 9 AUG 74                                 */
*/*                                                                  */
*/********************************************************************/
 DCL RWORK0         PTR(32)   REG(0);        /* REQ TYPE REG         */
 DCL RRPL           PTR(31)   REG(1) RESTRICTED;  /* RPL REGISTER    */
 DCL R1             PTR(31)   REG(1);        /* VOLATILE REG         */
 DCL RPLH           PTR(31)   REG(2) RESTRICTED; /* PLH REGISTER     */
 DCL RAMB           PTR(31)   REG(3) RESTRICTED;  /*  AMB REGISTER   */
 DCL RBUFC          PTR(31)   REG(4) RESTRICTED; /* BUFC REGISTER    */
 DCL RWORK1         PTR(31)   REG(5);        /* WORK REGISTER        */
 DCL RWORK2         PTR(32)   REG(6);        /* WORK REGISTER        */
 DCL RWORK3         PTR(31)   REG(7);        /* WORK REGISTER        */
 DCL RWORK4         PTR(31)   REG(8);        /* WORK REGISTER        */
 DCL RWORK5         PTR(31)   REG(9);        /* WORK REGISTER        */
 DCL R10            PTR(31)   REG(10);           /* PL/S REGISTER    */
 DCL R11            PTR(31)   REG(11);           /* PL/S REGISTER    */
 DCL RPARM1         PTR(31)   REG(12) RESTRICTED;  /* PARAMETER REG  */
 DCL R13            PTR(31)   REG(13);       /* ADDRESS OF SAVEAREA  */
 DCL R14            PTR(31)   REG(14);       /* RETURN ADDRESS       */
 DCL R15            PTR(31)   REG(15);       /* RETURN CODE/LINKAGE  */
 DCL ON BIT(1)CONSTANT('1'B);       /* MEANING SET TO ONE    @X04SVLC*/
 DCL OFF BIT(1)CONSTANT('0'B);      /* MEANING RESET TO ZERO @X04SVLC*/
 DCL ZERO  FIXED(15) CONSTANT(0);   /* MEANING EXACTLY ZERO  @X04SVLC*/
 DCL ONE   FIXED(15) CONSTANT(1);   /* MEANING EXACTLY ONE   @X04SVLC*/
 DCL CZERO BIT(8) CONSTANT('00000000'B);/* MEANING CHARACTER ZERO
                                                             @X04SVLC*/
 DCL EOV FIXED(15)CONSTANT(55);     /* EOV SVC NUMBER        @X04SVLC*/
   DCL HWORD4 FIXED(15) INIT(4);        /* CONSTANT FOR LINKAGE      */
