 /********************************************************************/
 /*                                                                  */
 /*   MACRO NAME = IDASSL                                            */
 /*                                                                  */
 /*   DESCRIPTIVE NAME = SWAP SAVE LIST.                             */
 /*                                                                  */
 /*   FUNCTION = IDASSL CONTAINS A LIST OF CONTROL BLOCKS TO BE      */
 /*              CHAINED AFTER OPEN IS GUARANTEED TO OPEN. ADDITIONAL*/
 /*              LISTS ARE CHAINED AS REQUIRED.                      */
 /*                                                                  */
 /*   CONTROL BLOCK STRUCTURE = POINTED TO BY THE OPEN ACB WORK AREA.*/
 /*                                                                  */
 /*   INCLUDED MACROS = NONE                                         */
 /*                                                                  */
 /*   METHOD OF ACCESS = PL/S - NO DECLARES NECESSARY                */
 /*                                                                  */
 /*   CREATED BY: VSAM OPEN MODULE IDA0192A.                         */
 /*                                                                  */
 /*   STATUS = VS1 RELEASE 4, VS2 RELEASE 3.                         */
 /*                                                                  */
 /*   DATE OF LAST CHANGE = 2 AUGUST 74                              */
 /*                                                                  */
 /********************************************************************/
    DCL 1 IDASSL BASED,             /* SWAP SAVE LISTS               */
          2 SSLSUBPL FIXED (8),     /* SUBPOOL NUMBER OF THIS SSL    */
          2 SSLLENTH FIXED (24),    /* LENGTH OF THIS LIST           */
          2 SSLID CHAR (8),         /* BLOCK IDENTIFER               */
          2 SSLNXPTR PTR (31),      /* PTR TO NEXT SSL OR 0 IF END
                                       OF CHAIN                      */
          2 SSLACEN FIXED (15),     /* NUMBER OF ACTIVE ENTRIES      */
          2 * FIXED (15),           /* RESERVED                      */
          2 SSLENTRY (16),          /* SWAP SAVE ENTRY               */
            3 SSLSWPTR PTR (31),    /* PTR TO SWAP WORD              */
            3 SSLSWAP FIXED (31)    /* SWAP CONTENTS                 */
    ;
    DCL IDASSLID CHAR (8) CONSTANT (' IDASSL '); /* CHAR CONSTANT
                                       FOR SSLID                     */
