 /********************************************************************/
 /*                                                                  */
 /*   MACRO NAME = IDAVAT                                            */
 /*                                                                  */
 /*   DESCRIPTIVE NAME = VALID AMBL TABLE.                           */
 /*                                                                  */
 /*   FUNCTION = THE VAT CONTAINS THE ADDRESS OF EACH AMBL CREATED   */
 /*              FOR A BASE KSDS.  THE VAT IS USED FOR VALIDITY CHECK*/
 /*              OF AMBL'S.                                          */
 /*                                                                  */
 /*   CONTROL BLOCK STRUCTURE = POINTED TO BY THE JSCB (JSCBSHR).    */
 /*                                                                  */
 /*   INCLUDED MACROS = NONE                                         */
 /*                                                                  */
 /*   METHOD OF ACCESS = PL/S - RESPECIFY IDAVAT BASED.              */
 /*                                                                  */
 /*   CREATED BY: VSAM OPEN MODULE IDA0192F.                         */
 /*                                                                  */
 /*   STATUS = VS1 RELEASE 4, VS2 RELEASE 3.                         */
 /*                                                                  */
 /*   DATE OF LAST CHANGE = 1 AUGUST 74                              */
 /*                                                                  */
 /********************************************************************/
    DCL 1 IDAVAT BASED BDY (DWORD), /* VALID AMBL TABLE              */
          2 VATHDR,                 /* HEADER                        */
            3 VATID CHAR(1),        /* CONTROL BLOCK ID              */
            3 * CHAR(1),            /* RESERVED                      */
            3 VATLEN FIXED(15),     /* LENGTH OF VAT                 */
          2 VATNEXT PTR(31),        /* ADDRESS OF NEXT VAT           */
          2 VATVSRT CHAR(8) BDY(DWORD), /* USED IN CDS INSTRUCTION   */
            3 VATVUSE FIXED(31),    /* VSRT USE CNT                  */
            3 VATVPTR PTR(31),      /* PTR TO VSRT                   */
          2 VATPAMBL PTR(31),       /* ADR 1ST AMBL IN PRIMARY CHAIN */
          2 VATVC FIXED(15),        /* USED BY AMBL FOR VALIDITY CHECK*/
            3 VATVRT FIXED(8),      /* TABLE NUMBER                  */
            3 VATENO FIXED(8),      /* NUMBER OF ENTRIES             */
          2 * CHAR(2),              /* NOT USED                      */
          2 VATNAE FIXED(31),       /* NUMBER OF ACTIVE ENTRIES      */
          2 VATAMBL(16) PTR(31);    /* ADDRESSES OF VALID AMBL'S     */
