 /*      DATASET  PAGE  CORRESPONDENCE  TABLE                        */
 /*                                                                  */
 /*      NAME       :    IDAVBPH                                     */
 /*                                                                  */
 /*      OWNER      :    VIRTUAL BLOCK PROCESSOR(VBP)                */
 /*                                                                  */
 /*      LANGUAGE   :    PL/S                                        */
 /*                                                                  */
 /*      USAGE      :    USED BY VIO ONLY                    @Z40WSSR*/
 /*                                                                  */
 /*      DESCRIPTION:    VBP'S CONTROL BLOCK THAT DESCRIBES  @Z40WSSR*/
 /*                      THE VIO DATASET. IT POINTS TO AN    @Z40WSSR*/
 /*                      EXTENSION THAT IS USED TO BUILD ASM @Z40WSSR*/
 /*                      AND RSM PARM LISTS(ACA & VCB)       @Z40WSSR*/
 /*                                                                  */
 /*      STORAGE ACQUIRED BY   IDAVBPO1 OR IDAVBPJ2 IN SWA   @Z40WSSR*/
 /*      STORAGE RELEASED BY   IDAVBPS1 FOR DSPCT HEADER &   @Z40WSSR*/
 /*                            IDAVBPS1/IDAVBPS2 FOR DSPCT-  @Z40WSSR*/
 /*                            EXTENSION                     @Z40WSSR*/
 /*      STATUS: VS2 RELEASE 4.1                             @Z40WSSR*/
 /*      LAST CHANGE: 10/07/75                               @Z40WSSR*/
 /*D066500                                                   @Z40WSSR*/
 /*                                                                  */
     DCL 1 VBPDSPCT BASED BDY(WORD),
           2 VBPHFIX BDY(WORD),          /*FIXED SECTION  */
            3 VBPHJJ BDY(WORD),          /*SECTION JOURNALED */
             4 VBPHNAME CHAR(4),        /* DSPCT BLOCK ID    @Z40WSSR*/
             4 VBPHLEN       FIXED(32), /* LENGTH OF HEADER          */
             4 VBPHLGN CHAR(8) BDY(WORD),/*LOGICAL GROUP NUMBER  */
               5 VBPHLGID    FIXED(32), /* LOGICAL GROUP IDENTIFIER */
                 6 VBPHLPG1  FIXED(16), /* ALL ZEROS                 */
                 6 VBPHLPG2  FIXED(16), /* IDENTIFIER                 */
             4 VBPHSYM CHAR(8) BDY(WORD),/* STORAGE LOCATOR SYMBOL   */
               5 VBPHSYM1 FIXED(32), /* 1ST SUBFIELD */
               5 VBPHSYM2 FIXED(32), /* 2ND SUBFIELD */
             4 VBPHPNP FIXED(15),       /* IF VBPHPAS IS ON, 1 + NO.
   OF PAGES ASSIGNED IN PRIOR OPERATION                      @Z40WSSR*/
             4 VBPHDSG       FIXED(16), /* DSPAGEID GENERATOR        */
             4 VBPHDSSZ      FIXED(32), /* MAX. D/S SIZE IN PAGES    */
             4 VBPHOPT       BIT(8),    /* PROCESSING OPTIONS        */
               5 VBPHINS     BIT(1),    /* NOT USED            */
               5 VBPHPGLD    BIT(1),    /* NOT USED          */
               5 VBPHRST     BIT(1),   /* IF ON, DSPCT FROM JOB JOURNAL,
                                 TO BE RESET BY IDAVBPO1.    @Z40WSSR*/
               5 VBPHPAS BIT(1),        /* IF ON, ASSIGN DONE IN PRIOR
      REGUEST */
               5 VBPHDEL BIT (1),   /* IF ON THEN AN ACTIVATE
                                      WAS ISSUED FOR THE LOGICAL
                                      GROUP BUT THE LOGICAL GROUP
                                      HAS BEEN RELEASED AND
                                      DOESN'T EXIST          @ZA00139*/
               5 VBPHPADD BIT(1), /* IF ON, ASSIGN MAP PAGES DURING
                                      RESTART                @Z40WSSR*/
               5 VBPHJRN BIT(1), /* IF VBPHJOU ON, PAGES ADDED SINCE
                                    JOURNALING. ELSE, PAGES ADDED SINCE
                                    CREATION                 @Z40WSSR*/
               5 VBPHJOU BIT(1), /* DSPCT SAVED/JOURNALED    @Z40WSSR*/
             4 VBPHSTA       BIT(8),    /* STATUS BYTE               */
               5 VBPHOPE     BIT(1),    /* IDAVBPO1 IN PROGRESS      */
               5 VBPHRW      BIT(1),/* IDAVBPP1  IN PROGRESS*/
               5 *      BIT(1),/* NOT USED                   @Z40WSSR*/
               5 VBPHSCR     BIT(1),    /* IDAVBPS1 IN PROGRESS      */
               5 VBPHCLO     BIT(1),    /* IDAVBPC1 IN PROGRESS      */
               5 *     BIT(3), /* NOT USED                   @Z40WSSR*/
             4 VBPHNMP     FIXED(15),/* CURRENT NO OF DSPCT MAP PAGES*/
             4 VBPHMMP       FIXED(15), /* MAX. MAP PAGES REQD.      */
             4 VBPHWSZ  FIXED(15), /* WINDOW SIZE IN PAGES   @Z40WSSR*/
             4 VBPHWAD       PTR(31),   /* WINDOW ADDRESS            */
             4 VBPHPRL       PTR(32),/* RELATIVE PAGE NO OF 1ST PAGE
      ASSIGNED TO WINDOW BY PRIOR ASSIGN REQUEST */
             4 VBPHRBN       FIXED(32), /* RBN ASGNED BY IEFXB500    */
           3 VBPHBUFC PTR(31), /*  ADDR OF BUFC */
             4 VBPHVOP  PTR(31), /* ADDR OF VOPEN PARM LIST */
           3 VBPHFRAR PTR(31), /* PTR TO RECOVERY COMM. AREA */
           3 VBPHVCB PTR(31), /* ADDR OF DSPCT EXTENSION     @Z40WSSR*/
           3 VBPHSAVE CHAR(72) BDY(WORD),/* 18 WORD REG. SAVE AREA   */
             4 * PTR(31),
             4 VBPHSAVO PTR(31),       /* ADDR OF CALLERS SAVE AREA  */
           3 SECSAVE CHAR(72) BDY(WORD),/* 2ND SAVE AREA */
            4 * PTR(31),
            4 SECSAVO PTR(31), /* ADDR OF CALLERS SAVE AREA */
      4 DSGSAVE FIXED(16),/* DSPAGEID GENERATOR SAVED IN IDAVBPJ2 */
      4 LGNSAVE CHAR(8),/* LGN SAVED IN IDAVBPJ2 */
         4 OPTSAVE BIT(8), /* USED TO SAVE THE SCRATCH STATUS OF
                            THE DATA SET AND IS SAVED IN MODULE
                               IDAVBPJ2                      @ZA00139*/
     3 VBPHSPUL BIT(8),/* SWA SUBPOOL NO. TO GET/FREEMAIN FOR THE DSPCT
   MAP                                                       @VS07802*/
      3 VBPHJRNP PTR(24), /* ADDR OF IEFXB500 PASSED FROM IDDWIJRN TO
                         IDAVBPJ1                            @Z30TSWT*/
   3 VBPHTCB PTR(32),/* TCB ADDR TO GET/FREEMAIN FOR THE DSPCT
   MAP AND DSPCT EXTENSION                                   @Z40WSSR*/
           2 VBPHMAD(*) PTR(31);   /* MAP PAGE POINTERS. ONE PER
                                      EACH MAP PAGE */

   /*     DSPCT EXTENSION. IS IN LSQA SUBPOOL 255.           @Z40WSSR*/
   /*     NO. OF MOVEOUT/ASSIGN VCBS=SIZE OF WINDOW IN PAGES @Z40WSSR*/
   /*     STORAGE ACQUIRED BY IDAVBPO1 & RELEASED BY         @Z40WSSR*/
   /*     IDAVBPS1                                           @Z40WSSR*/

   DCL 1 VBPVCB BDY(WORD) BASED(VBPHVCB), /* DSPCT EXTENSION @Z40WSSR*/
         2 VBPVFXD,
           3 VBPVNAME CHAR(4), /* ACRONYM ID - VCB           @Z40WSSR*/
           3 VBPVLEN FIXED(31), /* LENGTH OF DSPCT EXTENSION @Z40WSSR*/
           3 VBPVMAP   CHAR(24)BDY(WORD),/* USED AS AN ACA MAP & AS A
                                VCB FOR DSPCT PAGE MAPS      @Z40WSSR*/
           3 VCBSAVAD PTR(31), /* PTR TO 1ST VCB             @Z40WSSR*/
           3 VBPVAPTR PTR(31),  /* ADDR OF ASSIGN VCBS       @Z40WSSR*/
         2 VBPVMOVE(*) CHAR(24);/* MOVEOUT VCBS              @Z40WSSR*/
   DCL VBPVASIN(*) CHAR(24) BASED(VBPVAPTR); /* ASSIGN VCBS  @Z40WSSR*/
