 /********************************************************************/
 /*     DSPCT MAP ENTRY                                              */
 /*      NAME     : IDAVBPM                                          */
 /*      OWNER    : VIO                                              */
 /*      LANGUAGE : PL/S II                                          */
 /*      USAGE    : INTERNAL TO VBP. USED IN ALL VBP MODULES THAT    */
 /*                 REFERENCE DSPCT MAP                              */
 /*      DESCRIPTION:  MAPS EACH DSPCT MAP ENTRY.                    */
 /*               INDICATES WHETHER THE CORRESPONDING DATA SET       */
 /*               PAGE HAS BEEN WRITTEN OUT OR NOT                   */
 /*                 ALSO HAS THE REAL STORAGE NUMBER(RSN) PASSED     */
 /*           BY RSM USED TO RECLAIM THE VIO PAGES IN CORE           */
 /********************************************************************/
 /*                                                                  */
     DCL MAPPAGE CHAR(4096) BASED(MAPPGPTR); /*MAP PAGE */
  /* MAP PAGE ENTRY */
     DCL 1 VBPMAPE BASED(DSPCTMPR) BDY(HWORD),
           2 VBPMFLG     BIT(8),        /* FLAG BYTE */
             3 VBPMRLPG  BIT(1),/* IF ON, PAGE CORRESPONDING TO MAP
               ENTRY EXISTS ON AUXILIARY STORAGE */
             3 *         BIT(7),        /* NOT USED                  */
           2 *           BIT(8),        /* NOT USED */
           2 VBPMRSN     FIXED(16);/* RSN USED FOR RECLAIMING VIO PAGES
              FROM REAL STORAGE.  */
