 /********************************************************************/
 /*                                                                  */
 /*   MACRO NAME = IDAVMT                                            */
 /*                                                                  */
 /*   DESCRIPTIVE NAME = VOLUME MOUNT TABLE.                         */
 /*                                                                  */
 /*   FUNCTION = THE VMT DESCRIBES VOLUME SERIAL NUMBERS TO BE       */
 /*              MOUNTED.  A VMT IS CREATED FOR EACH DEVICE TYPE IN  */
 /*              THE OPERATIONAL SPHERE.                             */
 /*                                                                  */
 /*   CONTROL BLOCK STRUCTURE = POINTED TO BY THE BIB (BIBVMT).      */
 /*                                                                  */
 /*   INCLUDED MACROS = NONE                                         */
 /*                                                                  */
 /*   METHOD OF ACCESS = PL/S - RESPECIFY IDAVMT BASED.              */
 /*                                                                  */
 /*   CREATED BY: VSAM OPEN MODULE IDA0192F.                         */
 /*                                                                  */
 /*   STATUS = VS1 RELEASE 4, VS2 RELEASE 3.                         */
 /*                                                                  */
 /*   DATE OF LAST CHANGE = 1 AUGUST 74                              */
 /*                                                                  */
 /********************************************************************/
    DCL 1 IDAVMT BASED BDY (WORD),  /* VOLUME MOUNT TABLE            */
          2 VMTHDR,                 /* VMT HEADER                    */
            3 VMTID CHAR(1),        /* CONTROL BLOCK ID              */
            3  *    CHAR(1),        /* RESERVED                      */
            3 VMTLEN FIXED(15),     /* LENGTH OF VMT                 */
          2 VMTNXT PTR(31),         /* ADDRESS OF NEXT VMT           */
          2 VMTNOVOL FIXED(15),     /* NO. OF VOL ENTRIES IN TABLE   */
          2 * CHAR(3),              /* NOT USED                      */
          2 VMTDEV BIT(24),         /* DEVICE INFORMATION            */
            3 VMTDVOPT BIT(8),      /* DEVICE OPTIONS                */
            3 VMTDVTYP BIT(16),     /* DEVICE CLASS AND TYPE         */
          2 VMTVOL(*),              /* VOLUME ENTRY -- 1 PER VOLUME  */
            3 VMTUSECT FIXED(31),   /* USE COUNT                     */
            3 VMTVFLG1 BIT(8),      /* VOLUME FLAGS                  */
              4 VMTOPEN BIT(1),     /* VOL BEING PROCESSED BY OPEN   */
              4 * BIT(7),           /* NOT USED                      */
            3 * CHAR(1),            /* NOT USED                      */
            3 VMTVLSER CHAR(6),     /* VOLUME SERIAL NUMBER          */
            3 VMTUCB PTR(31);       /* ADDR OF UCB FOR VOLUME        */
