 /********************************************************************/
 /*                                                                  */
 /*   MACRO NAME = IDAVVOLL                                          */
 /*                                                                  */
 /*   DESCRIPTIVE NAME = VOLUME LIST FOR VSAM VOLUME MOUNT.          */
 /*                                                                  */
 /*   FUNCTION = IDAVVOLL CONTAINS INFORMATIONS OF MOUNTED VOLUME.   */
 /*                                                                  */
 /*   CONTROL BLOCK STRUCTURE = N/A                                  */
 /*                                                                  */
 /*   INCLUDED MACROS = NONE                                         */
 /*                                                                  */
 /*   METHOD OF ACCESS = PL/S - RESPECIFY IDAVVOLL BASED.            */
 /*                                                                  */
 /*   CREATED BY: N/A                                                */
 /*                                                                  */
 /*   STATUS = VS1 RELEASE 4   (CHANGE FLAG @X04SVXX)                */
 /*                                                                  */
 /*   DATE OF LAST CHANGE = 1 AUGUST 74                              */
 /*                                                                  */
 /********************************************************************/
   DCL 1 IDAVVOLL BASED BDY(WORD),      /* VOLUME LIST */
         2 * BIT(8),
           3 *       BIT(1),            /* MUST BE ZERO              */
           3 VVOLLID BIT(1),            /* INDICATES VOLUME LIST     */
           3 VVOLLTIO BIT(1),           /* INDICS VUCBL CREATED      */
           3 VVOLLOPE BIT(1),           /* CALLED BY OPEN            */
            3 VVOLLEOV BIT(1),          /* CALLED BY EOV             */
           3 VVOLLCAT BIT(1),           /* CALLED BY CATALOG         */
           3 VVOLLSWD BIT(1),           /* SEQUENCE SET WITH DATA    */
         2 * CHAR(1),
         2 VVOLLNBR FIXED(15),          /* NUMBER OF VOLSER ENTRIES */
         2 VVOLLTAB PTR(31),            /* PTR TO TIOT DD ENTRY (TIOE)*/
         2 VVOLLACB PTR(31),            /* PTR TO CATALOG ACB */
         2 VVOLLERR FIXED(31),          /* RETURN CODE       @X04SVRP*/
           3 VVOLLPDC FIXED(8),         /* PROB DET ERR CODE @X04SVRP*/
           3 VVOLLFNC FIXED(8),         /* FUNCTION CODE     @X04SVRP*/
           3 VVOLLSFC FIXED(8),         /* SUB-FUNCTION CODE @X04SVRP*/
           3 VVOLLCNT FIXED(8),         /* VOLUME COUNT      @X04SVRP*/
         2 VVOLLSFI CHAR(12),           /* SUB-FUNCTION INFORMATION
                                                        AREA @X04SVRP*/
         2 VVOLLBIB PTR(31),           /* PTR TO BIB         @X04SVRP*/
         2 VVOLLDEB PTR(31),           /* PTR TO DEB         @X04SVRP*/
         2 VVOLLENT (*),
           3 VVOLLUCB PTR(31),          /* PTR TO UCB USED           */
           3 * BIT(16),
             4 VVOLLMNT BIT(1),         /* INDICS VOLUME MOUNTED     */
             4 VVOLLVFY BIT(1),         /* VOLUME IS VERIFIED        */
           3 VVOLLVSR CHAR(6);          /* VOLSER FOR VOLUME         */
