*/********************************************************************/
*/*                                                                  */
*/*   MACRO NAME = IDAWAX                                            */
*/*                                                                  */
*/*   DESCRIPTIVE NAME = WORK AREA FOR PATH PROCESSING               */
*/*                                                                  */
*/*   FUNCTION = CONTAINS POINTERS AND INDICATORS REQUIRED FOR PATH  */
*/*              PROCESSING                                          */
*/*                                                                  */
*/*   CONTROL BLOCK STRUCTURE = POINTED TO BY THE IDAPLH WHEN AIX IS */
*/*              OPENED FOR PATH PROCESSING                          */
*/*                                                                  */
*/*   INCLUDED MACROS = NONE                                         */
*/*                                                                  */
*/*   METHOD OF ACCESS = PL/S - NO DECLARES NECESSARY                */
*/*                                                                  */
*/*   CREATED BY = VSAM OPEN                                         */
*/*                                                                  */
*/*   STATUS = VS/1 RELEASE 4  (CHANGE FLAG @X04SVXX)                */
*/*                                                                  */
*/*   DATE OF LAST CHANGE = 13 AUG 74                                */
*/*                                                                  */
*/********************************************************************/
    DCL
      1 IDAWAX BASED(PLHWAX),       /* WORK AREA FOR PATH PROCESSING */
       2 WAXID FIXED(8),            /* ID FIELD                      */
       2 WAXFLG1 FIXED(8),          /* FLAGS                         */
        3 WAXSRAB BIT(1),           /* ONE INDICATES SRA BUILT       */
        3 WAXPUG BIT(1),            /* AIX IS IN UPGRADE SET         */
        3 WAXPS BIT(1),             /* LAST OPERATION WAS A PUT SEQ  */
        3 WAXNOADV BIT(1),          /* DON'T ADVANCE WAXXPTR @ZA10591*/
       2 WAXLEN FIXED(15),          /* LENGTH OF IDAWAX              */
       2 WAXPL FIXED(15),           /* AIX RECORD PTR LENGTH         */
       2 WAXXXXX2 FIXED(15),        /* UNUSED                        */
       2 WAXIRPL PTR(31),           /* POINTER TO INNER RPL          */
       2 WAXURPL PTR(31),           /* POINTER TO USERS RPL          */
       2 WAXRCDA PTR(31),           /* POINTER TO AIX RECORD         */
       2 WAXXPTR PTR(31),           /* POINTER TO CURRENT AIX PTR    */
       2 WAXEPTR PTR(31),           /* POINTER BEYOND LAST AIX PTR   */
       2 WAXBPLH PTR(31),           /* POINTER TO BASE PLH           */
       2 WAXSRAA PTR(31),           /* POINTER TO SAVED RECORD AREA  */
       2 WAXSRAL FIXED(31),         /* LENGTH OF SAVED RECORD AREA   */
       2 WAXXXXX3 FIXED(31);        /* UNUSED                        */
