*/********************************************************************/
*/*                                                                  */
*/*   MACRO NAME = IDAWSHD                                           */
*/*                                                                  */
*/*   DESCRIPTIVE NAME = WORKING STORAGE HEADER                      */
*/*                                                                  */
*/*   FUNCTION = DESCRIBES BLOCKS OF CORE THAT ARE USED FOR WORKING  */
*/*              STORAGE                                             */
*/*                                                                  */
*/*   CONTROL BLOCK STRUCTURE = POINTED TO BY IDAAMB                 */
*/*                                                                  */
*/*   INCLUDED MACROS = NONE                                         */
*/*                                                                  */
*/*   METHOD OF ACCESS = PL/S - NO DECLARES NECESSARY                */
*/*                                                                  */
*/*   CREATED BY = VSAM OPEN                                         */
*/*                                                                  */
*/*   STATUS = VS/1 RELEASE 4  (CHANGE FLAG @X04SVXX)                */
*/*            @ZA26092                                              */
*/*                                                                  */
*/*   DATE OF LAST CHANGE = 15 APR 75                        @Z40ESSR*/
*/*                       = 01 MAR 78                        @ZA29035*/
*/*                                                                  */
*/********************************************************************/
* DCL 1 IDAWSHD BASED,              /* WORK SPACE HEADER             */
*      2 WSHDID CHAR(1),            /* CONTROL BLOCK ID-X'44'        */
*      2 WSHDPOOL FIXED(8),         /* SUBPOOL OF IDAWSHD            */
*      2 WSHDLEN FIXED(15),         /* LENGTH OF WORK SPACE HEADER   */
*      2 WSHDACHN PTR(31),          /* ACCESS CHAIN          @ZA29035*/
*       3 WSHDGMTB BIT(8),          /* GETMAIN RESOURCE BYTE @ZA26092*/
*       3 WSHDNEXT PTR(24),         /* PTR TO NEXT IDAWSHD   @ZA26092*/
*      2 WSHDGMWA CHAR(10),         /* GETMAIN WORK AREA             */
*      2 WSHDNUS FIXED(15),         /* NBR OF USED SLOTS             */
*      2 WSHDGMRA PTR(31),          /* GETMAIN RESULT                */
*      2 WSHDOCHN PTR(31),          /* ORDERED SLOT CHAIN            */
*      2 WSHDSLT(4),                /* WORK SPACE SLOT               */
*       3 WSHDSAD PTR(31),          /* POINTER TO BLOCK              */
*        4 * BIT(8),                /* FLAG FIELD            @Z30SSMR*/
*         5 * BIT(2),               /* RESERVED              @Z30SSMR*/
*         5 WSHDGSR BIT(1),         /* CORE IS IN GSR KEY    @Z40ESSR*/
*       3 WSHDSGMW,                 /* WORK AREA FOR SLOT GETMAIN    */
*        4 WSHDSFM,                 /* FREEMAIN FIELD FOR DELVRP     */
*         5 WSHDSFSP FIXED(8),      /* SUBPOOL FOR BLOCK             */
*         5 WSHDSFLN FIXED(24),     /* LENGTH IN BYTES OF BLOCK      */
*        4 WSHDSONX PTR(31),        /* PTR TO NEXT ON ORDERED CHN    */
*        4 WSHDSBV FIXED(15),       /* NBR OF BYTES PRE SLOT BIT     */
*        4 WSHDSFLG BIT(8),         /* WORK SPACE SLOT FLAGS         */
*         5 WSHDSFNO BIT(1),        /* SLOT HAS NO AVAILABLE CORE    */
*        4 WSHDSBM BIT(8);          /* BIT MASK                      */
