*/********************************************************************/
*/*                                                                  */
*/*  MODULE NAME - IDCCDCK                                           */
*/*                                                                  */
*/*  DESCRIPTIVE NAME - 'CHKLIST ' COMMAND DESCRIPTOR                */
*/*                                                                  */
*/*  COPYRIGHT - NONE                                                */
*/*                                                                  */
*/*  STATUS - CHANGE LEVEL = 0                                       */
*/*                                                                  */
*/*  FUNCTION - UPON RECOGNITION OF THE 'CHKLIST ' VERBNAME          */
*/*             (OR AN ALLOWABLE ABBREVIATION), THIS MODULE          */
*/*             IS LOADED BY THE IDCAMS READER/INTERPRETER.          */
*/*             THE INFORMATION CONTAINED IN THIS MODULE IS USED TO  */
*/*             SCAN THE INPUT COMMAND AND PERFORM SYNTACTIC AND     */
*/*             SEMANTIC CHECKING ON THE PARAMETERS SPECIFIED, AND   */
*/*             TO BUILD THE FUNCTION DATA TABLE (FDT) WHICH IS      */
*/*             PASSED TO THE 'CHKLIST ' FUNCTION SUPPORT ROUTINE    */
*/*             (IDCCK01 ).                                          */
*/*                                                                  */
*/*  NOTES -                                                         */
*/*                                                                  */
*/*     DEPENDENCIES - THE CHARACTER CODES CONTAINED IN THIS TABLE   */
*/*                    MUST MATCH THOSE OF THE INPUT COMMAND.        */
*/*                    THE CURRENT CHARACTER CODE IS 'EBCDIC'.       */
*/*                                                                  */
*/*     RESTRICTIONS - N/A                                           */
*/*                                                                  */
*/*     REGISTER CONVENTIONS - N/A                                   */
*/*                                                                  */
*/*     PATCH LABEL - N/A                                            */
*/*                                                                  */
*/*  MODULE TYPE - TABLE                                             */
*/*                                                                  */
*/*     PROCESSOR - ASSEMBLER                                        */
*/*                                                                  */
*/*     MODULE SIZE -  533 DECIMAL BYTES                             */
*/*                                                                  */
*/*     ATTRIBUTES - READ ONLY                                       */
*/*                                                                  */
*/*  ENTRY POINT - N/A                                               */
*/*                                                                  */
*/*     PURPOSE - N/A                                                */
*/*                                                                  */
*/*     LINKAGE - N/A                                                */
*/*                                                                  */
*/*  INPUT - N/A                                                     */
*/*                                                                  */
*/*  OUTPUT - N/A                                                    */
*/*                                                                  */
*/*  EXIT NORMAL - N/A                                               */
*/*                                                                  */
*/*  EXIT ERROR - N/A                                                */
*/*                                                                  */
*/*  EXTERNAL REFERENCES - N/A                                       */
*/*                                                                  */
*/*     ROUTINES - N/A                                               */
*/*                                                                  */
*/*     DATA AREAS - N/A                                             */
*/*                                                                  */
*/*     CONTROL BLOCKS - N/A                                         */
*/*                                                                  */
*/*  TABLES - N/A                                                    */
*/*                                                                  */
*/*  MACROS - N/A                                                    */
*/*                                                                  */
*/*  CHANGE ACTIVITY - NONE                                          */
*/*                                                                  */
*/********************************************************************/
         PRINT DATA
IDCCDCK  CSECT
         DC    C'CDCK
         DC    C'
         DC    C'
         DC    C'
PCK00000 IKJPARM DSECT=DCK00000
IFILE00  IKJKEYWD
         IKJNAME 'INFILE',ALIAS=('IFILE'),SUBFLD=@IFILE01
OFILE00  IKJKEYWD
         IKJNAME 'OUTFILE',ALIAS=('OFILE'),SUBFLD=@OFILE01
CHKID00  IKJKEYWD
         IKJNAME 'CHECKID',ALIAS=('CHKID'),SUBFLD=@CHKID01
@IFILE01 IKJSUBF
IFILE01  IKJIDENT '''INFILE'' FILE NAME',HEX,PROMPT='''INFILE'' FILE NA*
               ME',                                                    *
               HELP=('DNAME FOR CHECKPOINT DATA SET')
@OFILE01 IKJSUBF
OFILE01  IKJIDENT '''OUTFILE'' FILE NAME',HEX,PROMPT='''OUTFILE'' FILE *
               NAME',                                                  *
               HELP=('DNAME FOR ALTERNATE OUTPUT FILE')
@CHKID01 IKJSUBF
CHKID01  IKJIDENT 'CHECKPOINT ID LIST',HEX,LIST,PROMPT='CHECKPOINT ID L*
               IST',                                                   *
               HELP=('LIST OF CHECKPOINT ENTRY IDS')
         IKJENDP
         END
