         /************************************************************/
         /*                                                          */
         /*  'MODIFYC ' FUNCTION DATA TABLE DECLARATIONS             */
         /*                                                          */
         /************************************************************/
 %IF BASEFDT = 'YES'
   %THEN
     %GO TO BASEFDT1;

         DCL 1 FDTTBL      BDY(WORD),
 %GO TO BASEFDT2;
 %BASEFDT1:;

         DCL 1 FDTTBL      BASED   BDY(WORD),
 %BASEFDT2:;
               2 FDTVERB   CHAR(8),    /* FUNCTION VERBNAME          */
               2 FDTPTR(*) PTR(31);    /* SCALAR DATA POINTERS       */

         /* DATA DECLARATIONS OF SCALAR DATA ITEMS                   */

         /* 'VOLUME' OPTION FOR LOCATING A CART                      */
         DCL 1   VOL BASED(FDTPTR(  1)) BDY(HWORD),
               2   VOLLEN FIXED(8),    /* DATA ITEM LENGTH           */
               2   VOLVAL CHAR(  6);   /* DATA ITEM VALUE            */

         /* 'CARTRIDGE' OPTION FOR LOCATING A CART                   */
         DCL 1  CART BASED(FDTPTR(  2)) BDY(HWORD),
               2  CARTLEN FIXED(8),    /* DATA ITEM LENGTH           */
               2  CARTVAL CHAR( 12);   /* DATA ITEM VALUE            */

         /* 'CELL' OPTION WITH SPECIFIC XYZ LOCATION                 */
         DCL  CELL    BASED(FDTPTR(  3));

         /* 'X' PORTION OF CELL ADDRESS                              */
         DCL 1 CELLX BASED(FDTPTR(  4)) BDY(WORD),
               2 CELLXVAL FIXED(31);   /* NUMERIC VALUE              */

         /* 'Y' PORTION OF CELL ADDRESS                              */
         DCL 1 CELLY BASED(FDTPTR(  5)) BDY(WORD),
               2 CELLYVAL FIXED(31);   /* NUMERIC VALUE              */

         /* 'Z' PORTION OF CELL ADDRESS                              */
         DCL 1 CELLZ BASED(FDTPTR(  6)) BDY(WORD),
               2 CELLZVAL FIXED(31);   /* NUMERIC VALUE              */

         /* 'SEQUENCE' NUMBER OF CARTRIDGE                           */
         DCL 1   SEQ BASED(FDTPTR(  7)) BDY(WORD),
               2   SEQVAL FIXED(31);   /* NUMERIC VALUE              */

         /* 'MSF' ID NUMBER CONTAINING CARTRIDGE                     */
         DCL 1   MSF BASED(FDTPTR(  8)) BDY(WORD),
               2   MSFVAL FIXED(31);   /* NUMERIC VALUE              */

         /* MODIFY BY A DIRECT EJECT OF CART FUNCTION                */
         DCL   DEJ    BASED(FDTPTR(  9));

         /* MODIFY BY A CHANGE LABEL OF CART FUNCTION                */
         DCL CHNGL    BASED(FDTPTR( 10));

         /* 'CELL' ADDRESS AFTER MODIFICATION                        */
         DCL  NCEL    BASED(FDTPTR( 11));

         /* 'X' PORTION OF CELL ADDRESS                              */
         DCL 1 NCELX BASED(FDTPTR( 12)) BDY(WORD),
               2 NCELXVAL FIXED(31);   /* NUMERIC VALUE              */

         /* 'Y' PORTION OF CELL ADDRESS                              */
         DCL 1 NCELY BASED(FDTPTR( 13)) BDY(WORD),
               2 NCELYVAL FIXED(31);   /* NUMERIC VALUE              */

         /* 'Z' PORTION OF CELL ADDRESS                              */
         DCL 1 NCELZ BASED(FDTPTR( 14)) BDY(WORD),
               2 NCELZVAL FIXED(31);   /* NUMERIC VALUE              */

         /* 'EJECT' MANUAL EXIT STATION AFTER MODIFICATION           */
         DCL EJECT    BASED(FDTPTR( 15));

         /* 'SCRATCH' OPTION AS CART MODIFICATION                    */
         DCL   SCR    BASED(FDTPTR( 16));

         /* 'VOLUME' OPTION AS CART MODIFICATION                     */
         DCL 1  NVOL BASED(FDTPTR( 17)) BDY(HWORD),
               2  NVOLLEN FIXED(8),    /* DATA ITEM LENGTH           */
               2  NVOLVAL CHAR(  6);   /* DATA ITEM VALUE            */

         /* 'SEQUENCE' OPTION AS CART MODIFICATION                   */
         DCL 1  NSEQ BASED(FDTPTR( 18)) BDY(WORD),
               2  NSEQVAL FIXED(31);   /* NUMERIC VALUE              */

         /* 'OTHERCARTRIDGE' CSN OF A PAIR TO BE MODIFIED            */
         DCL 1  OCSN BASED(FDTPTR( 19)) BDY(HWORD),
               2  OCSNLEN FIXED(8),    /* DATA ITEM LENGTH           */
               2  OCSNVAL CHAR( 12);   /* DATA ITEM VALUE            */

         /* 'BIND' ATTRIBUTE OPTION AS CART MODIFICATION             */
         DCL  BIND    BASED(FDTPTR( 20));

         /* 'NOBIND' ATTRIBUTE OPTION AS CART MODIFICATION           */
         DCL NBIND    BASED(FDTPTR( 21));

         /* 'EXCLUSIVE' ATTRIBUTE OPTION AS CART MODIFICATION        */
         DCL   XCL    BASED(FDTPTR( 22));

         /* 'SHARED' ATTRIBUTE OPTION AS CART MODIFICATION           */
         DCL  SHRD    BASED(FDTPTR( 23));

         /* 'READONLY' ATTRIBUTE OPTION AS CART MODIFICATION         */
         DCL RONLY    BASED(FDTPTR( 24));

         /* 'READWRITE' ATTRIBUTE OPTION AS CART MODIFICATION        */
         DCL    RW    BASED(FDTPTR( 25));

         /* 'DASDERASE' ATTRIBUTE OPTION AS CART MODIFICATION        */
         DCL DERAS    BASED(FDTPTR( 26));

         /* 'NODASDERASE' ATTRIBUTE OPTION AS CART MODIFICATION      */
         DCL NERAS    BASED(FDTPTR( 27));
