         /************************************************************/
         /*                                                          */
         /*  'SCRDSET ' FUNCTION DATA TABLE DECLARATIONS             */
         /*                                                          */
         /************************************************************/
 %IF BASEFDT = 'YES'
   %THEN
     %GO TO BASEFDT1;

         DCL 1 FDTTBL      BDY(WORD),
 %GO TO BASEFDT2;
 %BASEFDT1:;

         DCL 1 FDTTBL      BASED   BDY(WORD),
 %BASEFDT2:;
               2 FDTVERB   CHAR(8),    /* FUNCTION VERBNAME          */
               2 FDTPTR(*) PTR(31);    /* SCALAR DATA POINTERS       */

         /* DATA DECLARATIONS OF SCALAR DATA ITEMS                   */

         /* VOLUME(S) TO LIST                                        */
         DCL 1   VOL BASED(FDTPTR(  1)) BDY(HWORD),
               2   VOLCNT FIXED(15),   /* COUNT OF ITEMS IN LIST     */
               2 *(255) BDY(HWORD),
                 3   VOLLEN FIXED(8),  /* DATA ITEM LENGTH           */
                 3   VOLVAL CHAR(  6); /* DATA ITEM VALUE            */

         /* GROUP(S) TO LIST                                         */
         DCL 1   GRP BASED(FDTPTR(  2)) BDY(HWORD),
               2   GRPCNT FIXED(15),   /* COUNT OF ITEMS IN LIST     */
               2 *(255) BDY(HWORD),
                 3   GRPLEN FIXED(8),  /* DATA ITEM LENGTH           */
                 3   GRPVAL CHAR(  8); /* DATA ITEM VALUE            */

         /* OPTION TO LIST ALL VOLUMES                               */
         DCL  AVOL    BASED(FDTPTR(  3));

         /* OPTION TO LIST ALL GROUPS                                */
         DCL  AGRP    BASED(FDTPTR(  4));

         /* 'NON-GROUPED' LIMITING OPTION                            */
         DCL NGRPD    BASED(FDTPTR(  5));

         /* 'GENERAL' LIMITING OPTION                                */
         DCL GENER    BASED(FDTPTR( 16));

         /* LEVEL NAME OF DATA SETS TO LIST                          */
         DCL 1 LEVEL BASED(FDTPTR(  6)) BDY(HWORD),
               2 LEVELPLN FIXED(8),    /* PASSWORD LENGTH            */
               2 LEVELPAS CHAR(8),     /* PASSWORD VALUE             */
               2 LEVELPOS FIXED(8),    /* ASTERISK POSITION          */
               2 LEVELFLG BIT(8),      /* DATA SET FLAGS             */
                 3 LEVELFUQ BIT(1),    /* FLAG-ON IF UNQUALIFIED     */
               2 LEVELMLN FIXED(8),    /* MEMBER NAME LENGTH         */
               2 LEVELMEM CHAR(8),     /* MEMBER NAME                */
               2 LEVELLEN FIXED(8),    /* CATALOGUED NAME LENGTH     */
               2 LEVELVAL CHAR(44);    /* CATALOGUED NAME            */

         /* 'UNCATALOGED' LIMITING OPTION                            */
         DCL UNCAT    BASED(FDTPTR(  7));

         /* 'EXPIRATION DATE' LIMITING OPTION                        */
         DCL 1 EXPDT BASED(FDTPTR(  8)) BDY(WORD),
               2 EXPDTVAL FIXED(31);   /* NUMERIC VALUE              */

         /* 'EXPIRATION DAYS' LIMITING OPTION                        */
         DCL 1 EXPIR BASED(FDTPTR(  9)) BDY(WORD),
               2 EXPIRVAL FIXED(31);   /* NUMERIC VALUE              */

         /* 'CREATION DATE' LIMITING OPTION                          */
         DCL 1 CREDT BASED(FDTPTR( 10)) BDY(WORD),
               2 CREDTVAL FIXED(31);   /* NUMERIC VALUE              */

         /* 'CREATION DAYS' LIMITING OPTION                          */
         DCL 1 CREAT BASED(FDTPTR( 11)) BDY(WORD),
               2 CREATVAL FIXED(31);   /* NUMERIC VALUE              */

         /* 'FILE' DDNAME                                            */
         DCL 1  FILE BASED(FDTPTR( 12)) BDY(HWORD),
               2  FILELEN FIXED(8),    /* DATA ITEM LENGTH           */
               2  FILEVAL CHAR(  8);   /* DATA ITEM VALUE            */

         /* 'SYSTEMNAMES' OPTION                                     */
         DCL  SYSN    BASED(FDTPTR( 13));

         /* OPTION TO PURGE ALL DATA SETS                            */
         DCL PURGE    BASED(FDTPTR( 17));

         /* VOLUMES NOT TO BE SCRATCHED                              */
         DCL 1 EXVOL BASED(FDTPTR( 14)) BDY(HWORD),
               2 EXVOLCNT FIXED(15),   /* COUNT OF ITEMS IN LIST     */
               2 *(255) BDY(HWORD),
                 3 EXVOLLEN FIXED(8),  /* DATA ITEM LENGTH           */
                 3 EXVOLVAL CHAR(  6); /* DATA ITEM VALUE            */

         /* DATA SETS NOT TO BE SCRATCHED                            */
         DCL 1  EXDS BASED(FDTPTR( 15)) BDY(HWORD),
               2  EXDSCNT FIXED(15),   /* COUNT OF ITEMS IN LIST     */
               2 *(255) BDY(HWORD),
                 3  EXDSPLN FIXED(8),  /* PASSWORD LENGTH            */
                 3  EXDSPAS CHAR(8),   /* PASSWORD VALUE             */
                 3  EXDSPOS FIXED(8),  /* ASTERISK POSITION          */
                 3  EXDSFLG BIT(8),    /* DATA SET FLAGS             */
                   4  EXDSFUQ BIT(1),  /* FLAG-ON IF UNQUALIFIED     */
                 3  EXDSMLN FIXED(8),  /* MEMBER NAME LENGTH         */
                 3  EXDSMEM CHAR(8),   /* MEMBER NAME                */
                 3  EXDSLEN FIXED(8),  /* CATALOGUED NAME LENGTH     */
                 3  EXDSVAL CHAR(44);  /* CATALOGUED NAME            */
