 /*********************************************************  @Y30LB33*/
 /*                                                          @Y30LB33*/
 /* MSS GLOBAL DATA AREAS FOR AMS (VS2):        04/05/76     @ZA09521*/
 /*     (1) MSS MESSAGE STRUCTURES                           @Y30LB30*/
 /*     (2) SYSTEM ADAPTER DECLARATIONS                      @Y30LB30*/
 /*         A) DATA STRUCTURES                               @Y30LB30*/
 /*         B) SYMBOLIC RETURN CODES                         @Y30LB30*/
 /*     (3) VOLUME SERVICE DECLARATIONS                      @Y30LB30*/
 /*         A) DATA STRUCTURES                               @Y30LB30*/
 /*         B) SYMBOLIC RETURN CODES                         @Y30LB30*/
 /*     (4) INPUT/OUTPUT ADAPTER DECLARATIONS                @Y30LB30*/
 /*     (5) CONVENTIONALIZED NAMED VALUES DELCARATIONS       @Y30LB30*/
 /*                                                          @Y30LB30*/
 /* CHANGE ACTIVITY -                                        @YD00171*/
 /*       @YD00171                                           @YD00171*/
 /*       @YD00175                                           @YD00175*/
 /* CHANGE 03  3/18/75  NEW COPY CART. MSSC MESSAGE FORMAT   @ZM00741*/
 /* CHANGE 04 11/10/75  NEW STAEPARM FORMAT                  @ZA05112*/
 /* CHANGE 05 03/04/76  MDFORCE IN MDAGL                     @ZA09521*/
 /* CHANGE 06 9/1/76  DCRR - REBUILD A VOLUME LABEL          @ZDR2057*/
 /* CHANGE 07 10/13/76 FIX TO CTMSG CTARRAY MULTIPLE         @ZA14727*/
 /* CHANGE 08 10/20/76 REPAIRV                               @ZA11014*/
 /* CHANGE 09 04/05/76  RACF D.S. PROTECTION FLAG IN VSDSTAT @G24LB31*/
 /* CHANGE 10 05/10/76  NEW KEYWORD FOR MODIFYC              @G24LB40*/
 /*                                                          @YD00171*/
 /*********************************************************  @Y30LB30*/
                                                           /*@Y30LB30*/
 /*********************************************************  @Y30LB33*/
 /*                                                          @Y30LB33*/
 /*  THIS STRUCTURE IS THE FORMAT OF THE COPY CARTRIDGE      @Y30LB33*/
 /*  MESSAGE RETURNED AFTER THE SUCCESSFUL COMPLETION        @Y30LB33*/
 /*  OF THE USSC MACRO.                                      @Y30LB33*/
 /*                                                          @Y30LB33*/
 /*********************************************************  @Y30LB33*/
                                                           /*@Y30LB33*/
         DCL CCMSGPTR PTR(31);         /*PTR TO MSG AREA     @Y30LB33*/
                                                           /*@Y30LB33*/
         DCL 1 CCMSG BASED(CCMSGPTR),                      /*@Y30LB33*/
               2 CCPSTCDE    CHAR(1),  /* POST CODE          @ZM00741*/
               2 CCEJCODE    FIXED(8), /* EJECT CODE         @ZM00741*/
               2 *           CHAR(2),  /* RESERVED           @ZM00741*/
               2 CCVOL       CHAR(6),  /* VOLUME             @Y30LB33*/
               2 *           CHAR(2),  /* RESERVED           @ZM00741*/
               2 CCNEWCSN    CHAR(12), /* REPLACEMENT CART   @Y30LB33*/
               2 CCOLDCSN    CHAR(12); /* OLD CARTRIDGE      @Y30LB33*/
                                                           /*@Y30LB33*/
                                                           /*@Y30LB33*/
 /*********************************************************  @Y30LB33*/
 /*                                                          @Y30LB33*/
 /*  THIS STRUCTURE IS THE FORMAT OF THE MOVE AND            @Y30LB33*/
 /*  DEFINE MESSAGES RETURNED AFTER THE SUCCESSFUL           @Y30LB33*/
 /*  COMPLETION OF THE USSC MACRO                            @Y30LB33*/
 /*                                                          @Y30LB33*/
 /*********************************************************  @Y30LB33*/
                                                           /*@Y30LB33*/
         DCL CMMSGPTR PTR(31);         /*PTR TO MSG AREA     @Y30LB30*/
                                                           /*@Y30LB33*/
         DCL 1 CMMSG BASED(CMMSGPTR),                      /*@Y30LB30*/
               2 CMOLDVOL    CHAR(6),  /* OLD VOLID          @Y30LB30*/
               2 CMVOLFLG    CHAR(1),  /* MESSAGE FLAGS      @Y30LB30*/
                 3 CMCECART  BIT(1),   /* CE CART            @Y30LB30*/
                 3 CMSCRVOL  BIT(1),   /* SCRATCH VOLUME     @Y30LB30*/
                 3 CMDERAS   BIT(1),   /* DASD ERASE         @Y30LB30*/
                 3 CMEXCL    BIT(1),   /* EXCLUSIVE VOLUME   @Y30LB30*/
                 3 CMSCRCRT  BIT(1),   /* SCRATCH CARTRIDGE  @Y30LB30*/
                 3 CMBIND    BIT(1),   /* BOUND VOLUME       @Y30LB30*/
                 3 CMRONLY   BIT(1),   /* READONLY VOLUME    @Y30LB30*/
                 3 *         BIT(1),   /* UNUSED             @Y30LB33*/
               2 *           CHAR(1),  /* UNUSED             @Y30LB33*/
               2 CMNEWVOL    CHAR(6),  /* NEW VOLID          @Y30LB30*/
               2 *           CHAR(1),  /* UNUSED             @Y30LB33*/
               2 CMNUMCRT    CHAR(1),  /* NUMBER OF CARTS    @Y30LB30*/
               2 CMCSN1      CHAR(12), /* CART SERIAL 1      @Y30LB30*/
               2 CMCSN2      CHAR(12); /* CART SERIAL 2      @Y30LB30*/
                                                           /*@Y30LB33*/
 /*********************************************************  @Y30LB33*/
 /*                                                          @Y30LB33*/
 /* THIS STRUCTURE IS THE FORMAT OF THE COPY TABLES          @Y30LB33*/
 /* MESSAGE RETURNED AFTER THE SUCCESSFUL COMPLETION         @Y30LB33*/
 /* OF THE USSC MACRO TO COPY THE MSC TABLES                 @Y30LB30*/
 /*                                                          @Y30LB33*/
 /*********************************************************  @Y30LB33*/
                                                           /*@Y30LB33*/
         DCL CTMSGPTR PTR(31);         /*PTR TO MSG AREA     @Y30LB33*/
                                                           /*@Y30LB33*/
         DCL 1 CTMSG BASED(CTMSGPTR),                      /*@Y30LB33*/
               2 * CHAR(1),            /* UNUSED             @Y30LB33*/
               2 CTREALCC CHAR(2),     /* CYLINDER IN        @Y30LB33*/
                                       /* TARGET DATA SET    @Y30LB33*/
                                       /* WHERE FIRST        @Y30LB33*/
                                       /* BEGINS             @Y30LB33*/
               2 CTREALH FIXED(8) UNSIGNED,                /*@Y30LB33*/
                                       /* TRACK IN TARGET    @Y30LB33*/
                                       /* DATA SET WHERE     @Y30LB33*/
                                       /* FIRST TABLE        @Y30LB33*/
                                       /* BEGINS             @Y30LB33*/
               2 CTARRAY(14) CHAR(4),  /* TABLE TRACKS       @ZA14727*/
                    3 CTTBLID CHAR(1), /* TABLE ID           @Y30LB33*/
                    3 CTTBLCC FIXED(8) /* CYLINDER WHERE     @Y30LB33*/
                             UNSIGNED, /* TABLE BEGAN ON     @Y30LB33*/
                                       /* TABLE VOLUME       @Y30LB33*/
                    3 CTTBLHH FIXED(8) /* TRACK WHERE        @Y30LB33*/
                             UNSIGNED, /* TABLE BEGAN ON     @Y30LB33*/
                                       /* TABLE VOLUME       @Y30LB33*/
                    3 CTTBLRR FIXED(8) /* RECORD WHERE       @Y30LB33*/
                         UNSIGNED;     /* TABLE BEGAN ON     @Y30LB33*/
                                       /* TABLE VOLUME       @Y30LB33*/
 /*                                                          @Y30LB33*/
 /*********************************************************  @Y30LB37*/
 /*                                                          @Y30LB37*/
 /*  THIS STRUCTURE IS THE ARGUMENT LIST FOR MOUNT/DEMOUNT   @Y30LB37*/
 /*  FOR THE UMSSUNIT MACRO CALL.                            @Y30LB37*/
 /*                                                          @Y30LB37*/
 /*********************************************************  @Y30LB37*/
                                                           /*@Y30LB37*/
         DCL 1 MDAGL BDY(WORD) BASED,                      /*@Y30LB37*/
               2 MDHEAD   CHAR(8),     /*MDAGL HEADING       @Y30LB37*/
               2 MDUCBPTR PTR(31),     /*PTR TO UCB ADDR     @Y30LB37*/
               2 MDDDNAME CHAR(8),     /*DDNAME              @Y30LB37*/
               2 MDPUAGL  PTR(31),     /*PTR TO PUAGL        @Y30LB37*/
               2 MDLABEL  CHAR(6),     /*VOL SERIAL NUMBER   @Y30LB37*/
               2 MDFLAGS,              /*OPTION FLAGS        @Y30LB37*/
                 3 MDNEWVOL  BIT(1),   /*NEW VOLUME          @Y30LB37*/
                 3 MDCLEAR   BIT(1),   /*CLEAR WITH MOUNT    @Y30LB37*/
                 3 MDPOST    BIT(1),   /*POST WITH DEMOUNT   @Y30LB37*/
                 3 MDWAIT    BIT(1),   /*WAIT ON DEMOUNT     @Y30LB37*/
                 3 MDENQ     BIT(1),   /*INTERNAL ENQ FLAG   @Y30LB37*/
                 3 MDDEQ     BIT(1),   /*DEQ WITH DEMOUNT    @YD00175*/
                 3 MDFORCE   BIT(1),   /*FORCE DEMOUNT       @ZA09521*/
                 3 MDVTOCTR  BIT(1),   /* USE SUPPLIED VTOC  @ZDR2057*/
              2 * CHAR(1),             /* RESERVED (UNUSED)  @ZDR2057*/
              2 MDVTOC CHAR(5) BDY(WORD), /* VTOC            @ZDR2057*/
                   3 MDCC FIXED(15),   /* CC (CYLANDER)      @ZDR2057*/
                   3 MDHH FIXED(15),   /* HH (HEAD)          @ZDR2057*/
                   3 MDR CHAR(1);      /* R (RECORD)         @ZDR2057*/
                                                           /*@Y30LB30*/
 /*********************************************************  @Y30LB37*/
 /*                                                          @Y30LB37*/
 /*  THIS STRUCTURE IS THE ARGUMENT LIST FOR POST UCB        @Y30LB37*/
 /*  FOR THE UMSSUNIT MACRO CALL.                            @Y30LB37*/
 /*                                                          @Y30LB37*/
 /*********************************************************  @Y30LB37*/
                                                           /*@Y30LB37*/
         DCL 1 PUAGL BDY(WORD) BASED,                      /*@Y30LB37*/
               2 PUHEAD   CHAR(8),     /*PUAGL HEADING       @Y30LB37*/
               2 PUUCBPTR PTR(31),     /*UCB POINTER         @Y30LB37*/
               2 PUTTRPTR PTR(31),     /*TTR POINTER         @Y30LB37*/
               2 PULABELP PTR(31);     /*VOLUME LABEL PTR    @Y30LB37*/
                                                           /*@Y30LB37*/
 /*********************************************************  @Y30LB37*/
 /*                                                          @Y30LB37*/
 /*  THIS STRUCTURE IS THE ARGUMENT LIST FOR CHECK UCB       @Y30LB37*/
 /*  FOR THE UMSSUNIT MACRO CALL.                            @Y30LB37*/
 /*                                                          @Y30LB37*/
 /*********************************************************  @Y30LB37*/
                                                           /*@Y30LB37*/
       DCL 1 CKAGL BDY(WORD) BASED,                        /*@Y30LB37*/
             2 CKHEAD   CHAR(8),       /*CKAGL HEADING       @Y30LB37*/
             2 CKUCBPTR PTR(31),       /*UCB POINTER         @Y30LB37*/
             2 CKDDNAME CHAR(8),       /*DDNAME              @Y30LB37*/
             2 CKDATYPE PTR(31),       /*RET ADDR OF TYPE    @Y30LB37*/
             2 CKLABELP PTR(31),       /*VOLUME LABEL PTR    @Y30LB37*/
             2 CKFLAGS,                /*OPTION  FLAGS       @Y30LB37*/
               3 CKTESTVT BIT(1),      /*TEST VIRTUAL        @Y30LB37*/
               3 CKRETTYP BIT(1),      /*RETURN TYPE         @Y30LB37*/
               3 CKDMTABL BIT(1),      /*TEST DEMOUNTABLE    @Z40LB35*/
               3 *        BIT(5);      /*RESERVED            @YD00175*/
                                                           /*@Y30LB37*/
 /*********************************************************  @YD00175*/
 /*                                                          @YD00175*/
 /*  THIS STRUCTURE IS THE ARGUMENT LIST FOR EXCLUSIVE       @YD00175*/
 /*  CONTROL FOR THE UMSSUNIT MACRO CALL.                    @YD00175*/
 /*                                                          @YD00175*/
 /*********************************************************  @YD00175*/
                                                           /*@YD00175*/
         DCL 1 EXCLAGL BDY(WORD) BASED,                    /*@YD00175*/
               2 EXCLHEAD CHAR(8),     /*EXCLAGL HEADING     @YD00175*/
               2 EXCLUCBP PTR(31),     /*UCB POINTER         @YD00175*/
               2 EXCLDDP  PTR(31),     /*DDNAME POINTER      @YD00175*/
               2 EXCLVOL  CHAR(6),     /*VOLUME SERIAL       @YD00175*/
               2 EXCLFLAG,             /*OPTION FLAGS        @YD00175*/
                 3 EXCLMNT  BIT(1),    /*VOLUME MOUNTED FLAG @YD00175*/
                 3 *        BIT(7);    /*RESERVED            @YD00175*/
                                                           /*@YD00175*/
 /*********************************************************  @YD00175*/
 /*                                                          @Y30LB35*/
 /*  THIS STRUCTURE IS THE ARGUMENT LIST FOR OPEN            @Y30LB35*/
 /*  FOR THE UEXCP MACRO CALL.                               @Y30LB35*/
 /*                                                          @Y30LB35*/
 /*********************************************************  @Y30LB35*/
                                                           /*@Y30LB35*/
         DCL 1 EXOARG BDY(WORD) BASED,                     /*@Y30LB35*/
               2 EXOHEAD  CHAR(8),     /*RESERVED            @Y30LB35*/
               2 EXODDN   PTR(31),     /*POINTER TO DDNAME   @Y30LB35*/
               2 EXODSN   PTR(31),     /*POINTER TO DSNAME   @Y30LB35*/
               2 EXOVSN   PTR(31),     /*POINTER TO VOL SER  @Y30LB35*/
               2 EXOUCB   PTR(31),     /*POINTER TO UCB      @Y30LB35*/
               2 EXOEXT   PTR(31),     /*POINTER RET EXTENTS @Y30LB30*/
               2 EXOCTLBK PTR(31),     /*PTR RET IOCTLBK PTR @Y30LB30*/
               2 EXOPT,                /*OPEN OPITIONS       @Y30LB35*/
                 3 EXOTAB   BIT(1),    /*OPEN FOR MSC TABLES @Y30LB30*/
                 3 EXOLAB   BIT(1),    /*OPEN VOL LABEL      @Y30LB35*/
                 3 EXOPASS  BIT(1),    /*OPEN TEST PASSWD    @Y30LB35*/
                 3 EXONEW   BIT(1),    /*OPEN VOL TO INIT    @Y30LB35*/
                 3 EXOVTOC  BIT(1),    /*OPEN VOL TO READ    @Z40LB35*/
                                       /*VTOC DSCBS          @Z40LB35*/
                 3 EXOREP   BIT(1),    /*REPAIR OPEN         @ZA11014*/
                 3 *        BIT(2),    /*RESERVED            @ZA11014*/
               2 EXFLG,                /*OPEN FLAGS          @Y30LB35*/
                 3 EXOREAD  BIT(1),    /*INDICATES READ ONLY @Y30LB35*/
                 3 *        BIT(2),    /*RESERVED            @ZA11014*/
                 3 EXORVS   BIT(1),    /*VSAM DATA SET       @ZA11014*/
                 3 EXOSPK   BIT(1),    /*STAGING PACK        @ZA11014*/
                 3 EXORDS   BIT(1),    /*DATA SET            @ZA11014*/
                 3 EXORVT   BIT(1),    /*VTOC                @ZA11014*/
                 3 EXOVTH   BIT(1);    /*VTOC HEADER         @ZA11014*/
                                                           /*@Y30LB30*/
 /*********************************************************  @Y30LB35*/
 /*                                                          @Y30LB35*/
 /*  THIS STRUCTURE IS THE ARGUMENT LIST FOR GET             @Y30LB35*/
 /*  FOR THE UEXCP MACRO CALL.                               @Y30LB35*/
 /*                                                          @Y30LB35*/
 /*********************************************************  @Y30LB35*/
                                                           /*@Y30LB35*/
         DCL 1 EXGARG BDY(WORD) BASED,                     /*@Y30LB35*/
               2 EXGHEAD  CHAR(8),     /*RESERVED            @Y30LB35*/
               2 EXGCTLBK PTR(31),     /*POINTER TO IOCTLBK  @Y30LB35*/
               2 EXGCCHH1 PTR(31),     /*PTR TO SEEK CCHHR   @Y30LB35*/
               2 EXGCCHH2 PTR(31),     /*PTR TO SEARCH CCHHR @Y30LB35*/
               2 EXGRECNO FIXED(31),   /*NUM RECORDS TO READ @Y30LB35*/
               2 EXGDATAP PTR(31),     /*PTR AREA FOR RECS   @Y30LB35*/
               2 EXGKEYLN FIXED(8) UNSIGNED, /*LEN OF KEY    @Y30LB35*/
               2 *        FIXED(8),          /*RESERVED      @Y30LB35*/
               2 EXGDATAL FIXED(15) UNSIGNED;/*LEN OF DATA   @Y30LB35*/
 /*********************************************************  @ZA11014*/
 /*                                                          @ZA11014*/
 /* THIS STRUCTURE IS THE ARGUMENT LIST FOR REPAIRV          @ZA11014*/
 /* I/O CALLS TO THE UEXCP MACRO                             @ZA11014*/
 /*                                                          @ZA11014*/
 /*********************************************************  @ZA11014*/
                                                           /*@Y30LB35*/
         DCL 1 EXWRARG BDY(WORD) BASED,                   /*@ZA11014*/
               2 EXRWRES  CHAR(8),     /*RESERVED            @ZA11014*/
               2 EXRWCTBL PTR(31),     /*POINTER TO IOCTLBK  @ZA11014*/
               2 EXRWIOAR PTR(31),     /*PTR TO SEEK CCHHR   @ZA11014*/
               2 EXRWDARE PTR(31),     /*PTR TO SEARCH CCHHR @ZA11014*/
               2 EXLOCPTR PTR(31),     /*NUM RECORDS TO READ @ZA11014*/
               2 EXCCWCNT FIXED(15),   /*PTR AREA FOR RECS   @ZA11014*/
               2 EXRWCHR,                                  /*@ZA11014*/
                 3 EXCC     FIXED(16),                     /*@ZA11014*/
                 3 EXHH     FIXED(16),                     /*@ZA11014*/
                 3 EXRECNUM FIXED(8),                      /*@ZA11014*/
               2 *       FIXED(8),      /* RESERVED          @ZA11014*/
               2 EXRWKDLN PTR(31),                         /*@ZA11014*/
               2 EXSPACE,                                  /*@ZA11014*/
                 3  *    FIXED(8),                         /*@ZA11014*/
                 3  *    PTR(24),                          /*@ZA11014*/
                 3  *    FIXED(15),                        /*@ZA11014*/
                 3  *    FIXED(15),                        /*@ZA11014*/
                 3  *    FIXED(15),                        /*@ZA11014*/
               2 EXRWFUN  FIXED(8);                        /*@ZA11014*/
 /*********************************************************  @Y30LB35*/
 /*                                                          @Y30LB35*/
 /*  THIS STRUCTURE IS THE ARGUMENT LIST FOR PUT             @Y30LB35*/
 /*  FOR THE UEXCP MACRO CALL.                               @Y30LB35*/
 /*                                                          @Y30LB35*/
 /*********************************************************  @Y30LB35*/
                                                           /*@Y30LB35*/
         DCL 1 EXPARG BDY(WORD) BASED,                     /*@Y30LB35*/
               2 EXPHEAD  CHAR(8),     /*RESERVED            @Y30LB35*/
               2 EXPCTLBK PTR(31),     /*PTR IOCTLBK PTR     @Y30LB35*/
               2 EXPDATA  PTR(31),     /*PTR DATA-TO-WRITE   @Y30LB35*/
               2 EXPCCHHR PTR(31);     /*PTR TO SEEK CCHHR   @Y30LB35*/
                                                           /*@Y30LB30*/
 /*********************************************************  @Y30LB35*/
 /*                                                          @Y30LB35*/
 /*  THIS STRUCTURE IS THE ARGUMENT LIST FOR DATA-TO-WRITE   @Y30LB35*/
 /*  FOR THE UEXCP MACRO CALL.                               @Y30LB35*/
 /*                                                          @Y30LB35*/
 /*********************************************************  @Y30LB35*/
                                                           /*@Y30LB35*/
         DCL 1 EXPDATAB BDY(WORD) BASED(EXPDATA),          /*@Y30LB35*/
               2 EXPRECNO FIXED(31),   /*NUM OF RECORDS      @Y30LB35*/
               2 EXPARRAY (*),         /*DATA-TO-WRITE ARRAY @Y30LB35*/
                 3 EXPDATAP PTR(31),   /*PTR TO DATA         @Y30LB30*/
                 3 EXPKEYLN FIXED(8) UNSIGNED, /*LEN OF KEY  @Y30LB35*/
                 3 *        FIXED(8),          /*RESERVED    @Y30LB35*/
                 3 EXPDATAL FIXED(15) UNSIGNED;/*LEN DATA    @Y30LB35*/
                                                           /*@Y30LB30*/
 /*********************************************************  @Y30LB35*/
 /*                                                          @Y30LB35*/
 /*  THIS STRUCTURE IS THE ARGUMENT LIST FOR VOLUME SERVICES @Y30LB35*/
 /*  FOR THE 'INITVOL', 'GETLABEL', AND 'PUTLABEL' REQUEST.  @Y30LB35*/
 /*                                                          @Y30LB35*/
 /*********************************************************  @Y30LB35*/
                                                           /*@Y30LB35*/
         DCL 1 VS2AGL BDY(WORD) BASED,                     /*@Y30LB35*/
               2 VS2HEAD  CHAR(8),     /*RESERVED            @Y30LB35*/
               2 VSUCBPTR PTR(31),     /*PTR TO UCB ADDR     @Y30LB35*/
               2 VSVTOCSZ FIXED(31),   /*VTOC TRK SIZE       @Y30LB35*/
               2 VSOWNPTR PTR(31),     /*PTR TO OWNER NAME   @Y30LB30*/
               2 VSVOLPTR PTR(31),     /*PTR TO VOLUME SER   @Y30LB30*/
               2 VSIOBKPT PTR(31),     /*PTR TO IOXCTLBK PTR @Y30LB30*/
               2 VSLABOPT,             /*LABEL OPTIONS       @Y30LB35*/
                 3 VSOWNER  BIT(1),    /*RETRIEVE OR UPDATE  @Y30LB35*/
                                       /*OWNER FIELD IN LABEL@Y30LB35*/
                 3 VSVOLSER BIT(1),    /*RETRIEVE OR UPDATE  @Y30LB35*/
                                       /*VOL FIELD IN LABEL  @Y30LB35*/
                 3 VSNOVTOC BIT(1),    /* NO DEFAULT VTOC    @ZDR2057*/
                 3 *        BIT(5),    /*RESERVED            @ZDR2057*/
               2 VSVOLUME CHAR(6),     /*SERIAL NUM FOR OPEN @Y30LB35*/
               2 VS2MSG,               /*MESSAGE OPTION      @Y30LB35*/
                 3 VS2TOV   BIT(1),    /*TO VOLUME PLACED IN @Y30LB35*/
                                       /*MESSAGE             @Y30LB35*/
                 3 *        BIT(7),    /*RESERVED            @Y30LB35*/
               2 VS2RESOP,             /*RESERVE OPTION      @Y30LB30*/
                 3 VS2RES   BIT(1),    /*RESERVE TO BE       @Y30LB35*/
                                       /*PERFORMED           @Y30LB35*/
                 3 VS2REAL  BIT(1),    /*REAL VOLUME         @Y30LB35*/
                 3 *        BIT(6),    /*RESERVED            @Y30LB35*/
               2 VSDDNAME CHAR(8),     /*DD NAME             @YD00175*/
               2 * CHAR(3),            /* RESERVED (UNUSED)  @ZDR2057*/
               2 VSVTOCPT PTR(31);     /* PTR TO VTOC        @ZDR2057*/
                                                           /*@Y30LB30*/
 /*********************************************************  @Y30LB30*/
 /*                                                          @Y30LB30*/
 /*  THIS STRUCTURE IS THE ARGUMENT LIST FOR VOLUME SERVICES @Y30LB30*/
 /*  FOR THE 'SECCHECK', 'SCRVTOC ', 'GETVTOC ', 'PUTVTOC ', @Y30LB30*/
 /*  AND 'RECATLG  ' SERVICE REQUESTS.                       @Y30LB30*/
 /*                                                          @Y30LB30*/
 /*********************************************************  @Y30LB30*/
                                                           /*@Y30LB30*/
         DCL 1 VS1AGL BDY (WORD) BASED,                    /*@Y30LB30*/
               2 VSHEAD     CHAR(8),   /*RESERVED            @Y30LB30*/
               2 VSUCBP     PTR(31),   /*UCB ADDRESS PTR     @Y30LB30*/
               2 VSVOLP     PTR(31),   /*VOLUME SER PTR      @Y30LB30*/
               2 VSFILEP    PTR(31),   /*DD NAME PTR         @Y30LB30*/
               2 VSIOP      PTR(31),   /*VTOC IOCSTR PTR     @Y30LB30*/
               2 VSNUMATP   PTR(31),   /*NO. ALT TRACK PTR   @Y30LB30*/
               2 VSNXTATP   PTR(31),   /*NEXT ALT TRK PTR    @Y30LB30*/
               2 VSCATP     PTR(31),   /*VSAM CAT NAME PTR   @Y30LB30*/
               2 VSACBP     PTR(31),   /*VSAM CAT ACB PTR    @Y30LB30*/
               2 VSCATDDP   PTR(31),   /*VSAM CAT DDNAME PTR @Y30LB30*/
               2 VSPSWDP    PTR(31),   /*VSAM CAT PSWD PTR   @Y30LB30*/
               2 VSPFILEP   PTR(31),   /*PASSWORD FILE PTR   @Y30LB30*/
               2 VSSERP     PTR(31),   /*NEW SERIAL PTR      @Y30LB30*/
               2 VSDEVP     PTR(31),   /*DEVICE TYPE PTR     @Y30LB30*/
               2 VSOSERP    PTR(31),   /*OLD SERIAL PTR      @Y30LB30*/
               2 VSODEVP    PTR(31),   /*OLD DEVICE PTR      @Y30LB30*/
               2 VSSECOPT,             /*SECURITY CHECK OPT  @Y30LB30*/
                 3 VSNOVSAM BIT(1),    /*NO VSAM DATA SETS   @Y30LB30*/
                 3 VSMASTER BIT(1), /*VSAM MASTER/RACF ALTER @G24LB31*/
                 3 VSNONONV BIT(1),    /*NO NON-VSAM D.S.    @Y30LB30*/
                 3 VSREAD   BIT(1),  /*NON-VSAM READ ACCESS  @G24LB31*/
                 3 VSWRITE  BIT(1),  /*NON-VSAM WRITE ACCESS @G24LB31*/
                 3 VSUCTEST BIT(1),    /*RET USER CAT INFO   @Y30LB30*/
                 3 VSOPCAT  BIT(1),    /*OPEN USERCAT VS/2   @Y30LB30*/
                 3 VSUCMAST BIT(1),  /*VSAM UCAT MASTER/RACF @G24LB31*/
               2 VSVTOPT,              /*VTOC FIELD OPTIONS  @Y30LB30*/
                 3 VSTIME   BIT(1),    /*VSAM TIME STAMP     @Y30LB30*/
                 3 VSALTTRK BIT(1),    /*ALTERNATE TRACKS    @Y30LB30*/
                 3 VSVSFLAG BIT(1),    /*VSAM OWNERSHIP FLAG @Y30LB30*/
                 3 *        BIT(5),    /*RESERVED            @Y30LB30*/
               2 VSCATOPT,             /*RECATALOG OPTIONS   @Y30LB30*/
                 3 VSDEVICE BIT(1),    /*DEVICE TYPE         @Y30LB30*/
                 3 VSSERIAL BIT(1),    /*VOLUME SERIAL       @Y30LB30*/
                 3 VSLIST   BIT(1),    /*LIST NAMES          @Y30LB30*/
                 3 *        BIT(5),    /*RESERVED            @Y30LB30*/
               2 VSRETURN,             /*INFORMATION RETURN  @Y30LB30*/
                 3 VSVSAM   BIT(1),    /*VOL OWNED BY VSAM   @Y30LB30*/
                 3 VSUCAT   BIT(1),    /*USER CAT ON VOLUME  @Y30LB30*/
                 3 *        BIT(6),    /*RESERVED            @Y30LB30*/
               2 VSMSG,                /*MESSAGE OPTIONS     @Y30LB30*/
                 3 VSFROMV  BIT(1),    /*FROM VOLUME         @Y30LB30*/
                 3 VSTOV    BIT(1),    /*TO VOLUME           @Y30LB30*/
                 3 *        BIT(6),    /*RESERVED            @Y30LB30*/
               2 VSRESOPT,             /*RESERVE OPTIONS     @Y30LB30*/
                 3 VSRES    BIT(1),    /*RESERVE VOLUME      @Y30LB30*/
                 3 VSREAL   BIT(1),    /*REAL VOLUME         @Y30LB30*/
                 3 *        BIT(6);    /*RESERVED            @Y30LB30*/
                                                           /*@Y30LB30*/
 /*********************************************************  @Y30LB34*/
 /*                                                          @Y30LB34*/
 /*  THIS STRUCTURE IS THE ARGUMENT LIST FOR URECAT MACRO    @Y30LB34*/
 /*                                                          @Y30LB34*/
 /*********************************************************  @Y30LB34*/
                                                           /*@Y30LB34*/
         DCL 1 RCTAGL BDY(WORD) BASED,                   /*  @Y30LB34*/
               2 RCTHEAD CHAR(8),     /*RESERVED             @Y30LB30*/
               2 RCTOPT CHAR(2),      /*RECAT OPTIONS        @Y30LB30*/
                 3 RCTDEV BIT(1),     /*DEVICE TYPE          @Y30LB30*/
                 3 RCTVOL BIT(1),     /*VOLUME SERIAL        @Y30LB30*/
                 3 *     BIT(6),      /*RESERVED             @Y30LB34*/
               2 * CHAR(2),           /*RESERVED             @Y30LB34*/
               2 RCTODEV FIXED(31),   /*OLD DEV TYPE         @Y30LB30*/
               2 RCTNDEV FIXED(31),   /*NEW DEV TYPE         @Y30LB30*/
               2 RCTOVOL CHAR(6),     /*OLD VOL SER          @Y30LB30*/
               2 RCTNVOL CHAR(6),     /*NEW VOL SER          @Y30LB30*/
               2 RCTDSET CHAR(44);    /*DATA SET NAME        @Y30LB30*/
                                                           /*@Y30LB34*/
                                                           /*@Y30LB34*/
 /*********************************************************  @Y30LB30*/
 /*                                                          @Y30LB30*/
 /*  THIS STRUCTURE IS THE ARGUMENT LIST FOR USTAE MACRO     @Y30LB30*/
 /*                                                          @Y30LB30*/
 /*********************************************************  @Y30LB30*/
                                                           /*@Y30LB30*/
         DCL 1 STAEPARM BDY(WORD) BASED,                   /*@Y30LB33*/
               2 STAHEAD CHAR(8),     /*RESERVED             @Y30LB30*/
               2 STAVUCB  PTR(31),    /*VIRTUAL UCB ADDR     @Y30LB30*/
               2 STAVVOL  CHAR(6),    /*VIRTUAL VOLSER       @Y30LB30*/
               2 *        CHAR(2),    /*RESERVED             @Y30LB30*/
               2 STARUCB  PTR(31),    /*REAL UCB ADDR        @Y30LB30*/
               2 STARVOL  CHAR(6),    /*REAL VOLSER          @Y30LB30*/
               2 *        CHAR(2),    /*RESERVED             @Y30LB30*/
               2 STARTTR  CHAR(4),    /*TTR TO THE VTOC      @Y30LB30*/
               2 STARTSAV PTR(31),    /*PTR TO RETRY SAVAREA @Y30LB30*/
               2 STAEXSAV PTR(31),    /*PTR STAEEXIT SAVAREA @Y30LB35*/
               2 STARTADD PTR(31),    /*PTR TO RETRY AREA    @Y30LB30*/
               2 STATCB   PTR(31),    /*PTR TO ENQUEUED TCB  @Y30LB35*/
               2 STARCVY,             /*TRACKING FLAGS       @Y30LB30*/
                 3 STAVMNT  BIT(1),   /*VIRT VOL MOUNTED     @Y30LB30*/
                 3 STAVDMNT BIT(1),   /*VIRT VOL DEMOUNTED   @Y30LB30*/
                 3 STAVENQ  BIT(1),   /*VOL ENQUEUED         @Y30LB30*/
                 3 STAVPOST BIT(1),   /*VIRT VOL POSTED      @Y30LB30*/
                 3 STACLEAR BIT(1),   /*REAL UCB CLEARED     @Y30LB30*/
                 3 *        BIT(3),   /*RESERVED             @Y30LB30*/
               2 STARETRY,            /*RETRY FLAGS          @Y30LB30*/
                 3 STAIO05  BIT(1),   /*IO5 RETRY IN CONTROL @Y30LB30*/
                 3 STAOFF   BIT(1),   /*STAE CANCELLED (VS1) @Y30LB35*/
                 3 STAVTOC BIT(1),    /*OPEN VTOC IN-PROCESS @Z40LB35*/
                 3 *        BIT(5),   /*RESERVED             @ZA05112*/
               2 STAVTTR CHAR(4);     /*VIRTUAL VTOC TTR     @ZA05112*/
                                                           /*@Y30LB37*/
 /*********************************************************  @Y30LB37*/
 /*                                                          @Y30LB37*/
 /*  THIS STRUCTURE IS THE MAPPING OF THE VOLUME LABEL REC   @Y30LB37*/
 /*                                                          @Y30LB37*/
 /*********************************************************  @Y30LB37*/
                                                           /*@Y30LB37*/
         DCL 1 VOLLABEL BASED,
               2 VOLKEY   CHAR(4),    /*VOL LABEL KEY        @Y30LB37*/
               2 VOLLABI  CHAR(3),    /*LABEL ID 'VOL'       @Y30LB37*/
               2 VOLNO    CHAR(1),    /*VOL LABEL SEQ NUMBER @Y30LB37*/
               2 VOLSERNO CHAR(6),    /*VOLUME SERIAL        @Y30LB37*/
               2 VOLSECTY CHAR(1),    /*RESERVED             @Y30LB37*/
               2 VOLVTOC  CHAR(5),    /*CCHHR OF THE VTOC    @Y30LB37*/
               2 VOLRESV1 CHAR(25),   /*RESERVED             @Y30LB37*/
               2 VOLOWNER CHAR(10),   /*USER NAME AREA       @Y30LB37*/
               2 VOLRESV3 CHAR(29);   /*RESERVED             @Y30LB37*/
                                                           /*@Y30LB37*/
 /*********************************************************  @Y30LB35*/
 /*                                                          @Y30LB35*/
 /*  THIS STRUCTURE IS THE MAPPING OF THE SVC 82 PARMLIST    @Y30LB35*/
 /*                                                          @Y30LB35*/
 /*********************************************************  @Y30LB35*/
                                                           /*@Y30LB35*/
         DCL 1 SV82LIST BDY(WORD) BASED, /*SVC 82 ARG LIST   @Y30LB35*/
               2 SV82CODE BIT(8),     /*OPERATION CODE       @Y30LB35*/
               2 SV82UCBP PTR(24),    /*UCB ADDRESS          @Y30LB35*/
               2 * PTR(31),           /*THIRD ARGUMENT       @Y30LB35*/
                 3 SV82DCBP PTR(31),  /*DCB PTR FOR - OPEN   @Y30LB35*/
                   4 SV82VOLP PTR(31),/*VOL PTR FOR - POST   @Y30LB35*/
               2 SV82TTRP PTR(31),    /*TTR TO VTOC ADDRESS  @Y30LB35*/
               2 * PTR(31),           /*FIFTH ARGUMENT       @Y30LB35*/
                 3 SV82WRKP PTR(31),  /*ADD RET AREA - CLEAR @Y30LB35*/
                     4 SV82DEBP PTR(31); /*ADDR DEB - CLOSE  @Y30LB35*/
                                                           /*@Y30LB35*/
 /*********************************************************  @Z40LB37*/
 /*                                                          @Z40LB37*/
 /* SORT ARGUMENT LIST                                       @Z40LB37*/
 /*                                                          @Z40LB37*/
 /*********************************************************  @Z40LB37*/

         DCL 1 SRTAGL BDY(WORD) BASED,   /*                  @Z40LB37*/
               2 SRTHEAD CHAR(8),        /*SRTAGL HEADING    @Z40LB37*/
               2 SRTADDR PTR(31),        /*PTR TO FIRST      @Z40LB37*/
                                         /*ELEMENT           @Z40LB37*/
               2 SRTNUM FIXED(31),       /*NUMBER OF         @Z40LB37*/
                                         /*ELEMENTS          @Z40LB37*/
               2 SRTLEN FIXED(31),       /*LENGTH OF         @Z40LB37*/
                                         /*ELEMENT           @Z40LB37*/
               2 SRTPOSIT FIXED(31),     /*SORT FIELD        @Z40LB37*/
                                         /*STARTING POSITION @Z40LB37*/
               2 SRTFLDLN FIXED(31),     /*SORT FIELD LENGTH @Z40LB37*/
               2 SRTWORKP PTR(31);       /*WORK AREA ADDRESS @Z40LB37*/

 /*********************************************************  @Z40LB37*/
 /*                                                          @Z40LB37*/
 /* ULOCATE DATA SET RETURNED INFORMATION AREA               @Z40LB37*/
 /*                                                          @Z40LB37*/
 /*********************************************************  @Z40LB37*/

         DCL 1 LCTINFO BDY(WORD) BASED,  /*                  @Z40LB37*/
               2 LCTHEAD  CHAR(8),       /*LCTINFO HEADING   @Z40LB37*/
               2 LCTMULVC FIXED(31),     /*NUMBER OF VOLUMES @Z40LB37*/
               2 LCTACBP  PTR(31),       /*PTR TO THE ACB    @Z40LB37*/
               2 LCTCREAT CHAR(4),      /*VSAM CREATION DATE @Z40LB37*/
               2 LCTEXPIR CHAR(4),       /*VSAM EXPIRATION   @Z40LB37*/
                                         /*DATE              @Z40LB37*/
               2 LCTOWNER CHAR(8),      /*OWNER NAME         @Z40LB37*/
               2 LCTFLAGS,              /*RETURN FLAGS       @Z40LB37*/
                 3 LCTVSCAT BIT(1),     /*VSAM CATALOG ENTRY @Z40LB37*/
                 3 *        BIT(7);     /*RESERVED           @Z40LB37*/

 /*********************************************************  @Z40LB37*/
 /*                                                          @Z40LB37*/
 /* UUNCATLG ARGUMENT LIST                                   @Z40LB63*/
 /*                                                          @Z40LB37*/
 /*********************************************************  @Z40LB37*/

         DCL 1 UCTAGL BDY(WORD) BASED,   /*                  @Z40LB63*/
               2 UCTHEAD  CHAR(8),       /*UCTAGL HEADING    @Z40LB63*/
               2 UCTDSN   CHAR(44),      /*DATA SET NAME     @Z40LB63*/
               2 UCTACBP  PTR(31),       /*PTR TO CAT ACB    @Z40LB63*/
               2 UCTVOLP  PTR(31),       /*PTR TO VOLUME     @Z40LB30*/
                                         /*LIST              @Z40LB30*/
               2 UCTDD    CHAR(8),       /*DDNAME            @Z40LB63*/
               2 UCTFLAGS,               /*OPTION FLAGS      @Z40LB63*/
                 3 UCTVSCAT BIT(1),      /*VSAM CATALOG      @Z40LB63*/
                 3 *        BIT(7);      /*RESERVED          @Z40LB63*/

 /*********************************************************  @Z40LB37*/
 /*                                                          @Z40LB37*/
 /* ARGUMENT LIST FOR SELECTING A DDNAME                     @Z40LB37*/
 /*                                                          @Z40LB37*/
 /*********************************************************  @Z40LB37*/

         DCL 1 SELAGL BDY(WORD) BASED,  /*                   @Z40LB37*/
               2 SELHEAD CHAR(8),       /*SELAGL HEADING     @Z40LB37*/
               2 SELUCBP PTR(31),       /*UCB POINTER        @Z40LB37*/
               2 SELDDNP PTR(31),       /*DDNAME POINTER     @Z40LB37*/
               2 SELVOL  CHAR(6),       /*VOLUME SERIAL      @Z40LB37*/
               2 SELFLAGS,              /*OPTION FLAGS       @Z40LB37*/
                 3 *     BIT(8);        /*RESERVED           @Z40LB37*/

 /*********************************************************  @Z40LB37*/
 /*                                                          @Z40LB37*/
 /* ARGUMENT LIST FOR CONVERT DATE PROCEDURE                 @Z40LB35*/
 /*                                                          @Z40LB37*/
 /*********************************************************  @Z40LB37*/

         DCL 1 DATESAGL BDY(WORD) BASED,
               2 DATHEAD  CHAR(8),     /*IDENTIFIER HEADER   @Z40LB35*/
               2 DATDATE  FIXED(31),   /*DATE TO CONVERT     @Z40LB35*/
               2 DATDAYS  FIXED(31),   /*DAYS TO ADJUST      @Z40LB35*/
               2 DATRETRN PTR(31),     /*RETURN PTR OF DATE  @Z40LB35*/
               2 DATESOPT BIT(8),      /*OPTIONS FLAGS       @Z40LB35*/
                 3 DATADD   BIT(1),    /*ADD DAYS TO DATE    @Z40LB35*/
                 3 DATSUB   BIT(1),    /*SUBTRACT DAYS       @Z40LB35*/
                 3 DATDTEOP BIT(1),    /*ADJUST DAYS         @Z40LB35*/
                 3 DATDAYOP BIT(1),    /*CONVERT DATE ONLY   @Z40LB35*/
                 3 *        BIT(4);    /*RESERVED            @Z40LB35*/

 /*********************************************************  @Z40LB35*/
 /*                                                          @Z40LB37*/
 /* SELECTDS DATA SET ARGUMENT LIST                          @Z40LB35*/
 /*                                                          @Z40LB35*/
 /*********************************************************  @Z40LB37*/

         DCL 1 VS3AGL BDY(WORD) BASED,
               2  VS3HEAD  CHAR(8),    /*RESERVED            @Z40LB35*/
               2  VS3LISTP PTR(31),    /*PTR LIST ADDR       @Z40LB35*/
               2  VS3EXDSP PTR(31),    /*PTR EXCLUDE DS      @Z40LB35*/
               2  VS3LEVP  PTR(31),    /*PTR LEVEL QUAL      @Z40LB35*/
               2  VS3LEVLN FIXED(15),  /*LENGTH OF QUAL      @Z40LB35*/
               2  VS3AST   FIXED(15),  /*OFFSET ASTERISK     @Z40LB35*/
               2  VS3EXPIR PTR(31),    /*PTR EXPIRATION DATE @Z40LB35*/
               2  VS3CREAT PTR(31),    /*PTR CREATION DATE   @Z40LB35*/
               2  VS3UCBP  PTR(31),    /*PTR UCB             @Z40LB35*/
               2  VS3DEV   CHAR(4),    /*DEVICE TYPE         @Z40LB35*/
               2  VS3POOL  CHAR(4),    /*STORAGE POOL ID     @Z40LB35*/
               2  VS3VOL   CHAR(6),    /*SERIAL NUMBER       @Z40LB35*/
               2  VS3DD    CHAR(8),    /*DDNAME FOR OPEN     @Z40LB35*/
               2  VS3FLAGS,            /*FLAGS               @Z40LB35*/
                  3 VS3STAT  BIT(1),   /*RETURN VSDSTAT      @Z40LB35*/
                  3 VS3USAGE BIT(1),   /*RETURN VSDUSAGE     @Z40LB35*/
                  3 VS3SCR   BIT(1),   /*RETURN VSDSCR       @Z40LB35*/
                  3 VS3UNCAT BIT(1),   /*UNCAT SELECTION     @Z40LB35*/
                  3 VS3SYSNM BIT(1),   /*SYSTEM NAME         @Z40LB35*/
                                       /*SELECTION           @Z40LB35*/
                  3 *        BIT(3);   /*RESERVED            @Z40LB35*/

 /*********************************************************  @YD00175*/
 /*                                                          @YD00175*/
 /*   SELECTED DATA SET ARRAY                                @Z40LB35*/
 /*                                                          @Z40LB35*/
 /*********************************************************  @Z40LB35*/

         DCL ELEMENT FIXED(31);        /*ELEMENT COUNTER     @Z40LB35*/

         DCL 1 VSDVTOC BASED(VSDSPACE),/*LSPACE INFO BLOCK   @Z40LB35*/
               2 *        CHAR(6),     /*RESERVED            @Z40LB35*/
               2 VSDFRCYL CHAR(4),     /*TOTAL FREE CYL      @Z40LB35*/
               2 *        CHAR(1),     /*RESERVED            @Z40LB35*/
               2 VSDFRTRK CHAR(4),     /*TOTAL FREE TRACKS   @Z40LB35*/
               2 *        CHAR(1),     /*RESERVED            @Z40LB35*/
               2 VSDFREXT CHAR(4),     /*TOTAL FREE EXTENTS  @Z40LB35*/
               2 *        CHAR(1),     /*RESERVED            @Z40LB35*/
               2 VSDFRCCL CHAR(4);     /*LARGEST CONT CYL    @Z40LB35*/

         DCL 1 VSDSTAT BASED(ADDR(VSDVARY(ELEMENT))) BDY(WORD),
               2 VSDCREAT FIXED(31),   /*CREATION DATE       @Z40LB35*/
               2 VSDEXPIR FIXED(31),   /*EXPIRATION DATE     @Z40LB35*/
               2 VSDOWNER CHAR(8),     /*OWNER OF D. S.      @Z40LB35*/
               2 VSDSFLG1 BIT(8),      /*FLAG BYTE           @Z40LB35*/
                 3 VSDVTOCC BIT(1),    /*CREATION DATE VTOC  @Z40LB35*/
                 3 VSDVTOCE BIT(1),    /*EXPIRATION DATE     @Z40LB35*/
                                       /*VTOC                @Z40LB35*/
                 3 VSDVSAMC BIT(1),    /*CREATION DATE VSAM  @Z40LB35*/
                 3 VSDVSAME BIT(1),    /*EXPIRATION DATE     @Z40LB35*/
                                       /*VSAM                @Z40LB35*/
                 3 VSDCATLG BIT(1),    /*DSN IS CATALOGED    @Z40LB35*/
                 3 VSDCVSAM BIT(1),    /*CATLG IN VSAM       @Z40LB35*/
                 3 *        BIT(2),    /*RESERVED            @Z40LB35*/
               2 VSDFLG2 BIT(8),       /*FLAG BYTE           @Z40LB35*/
                 3 VSDPWR   BIT(1),    /*READ PROTECTED      @Z40LB35*/
                 3 VSDPWW   BIT(1),    /*WRITE PROTECTED     @Z40LB35*/
                 3 VSDPROT  BIT(1),    /*DSN IS PROTECTED    @Z40LB35*/
                 3 VSDERROR BIT(1),    /*CATALOG ERROR       @Z40LB35*/
                 3 VSDRACF  BIT(1),    /*RACF PROTECTED      @G24LB31*/
                 3 *        BIT(3),    /*RESERVED            @G24LB31*/
         /*THE FOLLOWING PORTION IS THE CALLERS WORK AREA    @Z40LB35*/
               2 VSDCRE   CHAR(2),     /*CREATION DATE       @Z40LB35*/
               2 VSDEXP   CHAR(2),     /*EXPIRATION DATE     @Z40LB35*/
               2 VSDCAT   CHAR(3),     /*CATALOG INFO        @Z40LB35*/
               2 VSDPRTC  CHAR(4),     /*PROTECTION INFO     @G24LB31*/
               2 *        CHAR(3);     /*UNUSED, BDY ALIGN   @G24LB31*/

         DCL 1 VSDSCR BASED(ADDR(VSDVARY(ELEMENT))) BDY(WORD),
               2 VSDACBPT PTR(31),     /*ACB PTR TO VSAM CAT @Z40LB35*/
               2 VSDSCRFL BIT(8),      /*FLAG BYTE           @Z40LB35*/
                 3 VSDCATLC BIT(1),    /*DATA SET IN CATLG   @Z40LB35*/
                 3 VSDVSAM  BIT(1),    /*DSN IN VSAM CATLG   @Z40LB35*/
                 3 *        BIT(6),    /*RESERVED            @Z40LB35*/
               2 *         CHAR(3);    /*RESERVED            @Z40LB35*/


         DCL 1 VSDUSAGE BASED(ADDR(VSDVARY(ELEMENT))) BDY(WORD),
               2 VSDTRKS  FIXED(15),   /*TRACKS ALLOCATED    @Z40LB35*/
               2 VSDFTRK  FIXED(15),   /*TRACKS FREE         @Z40LB35*/
               2 VSDSECAL FIXED(31),   /*SECONDARY ALLOC     @Z40LB35*/
               2 VSDEXTS  FIXED(8),    /*NUMBER EXTENTS      @Z40LB35*/
               2 VSDDORG  BIT(8),      /*FLAG BYTE           @Z40LB35*/
                 3 VSDOPO   BIT(1),    /*PARTITIONED ORG     @Z40LB35*/
                 3 VSDOPS   BIT(1),    /*PHYSICAL SEQUENTIAL @Z40LB35*/
                 3 VSDOUN   BIT(1),    /*UNKNOWN ORG         @Z40LB35*/
                 3 VSDODA   BIT(1),    /*DIRECT ACCESS ORG   @Z40LB35*/
                 3 VSDOIS   BIT(1),    /*INDEX SEQ ORG       @Z40LB35*/
                 3 VSDOU    BIT(1),    /*UNMOVEABLE          @Z40LB35*/
                 3 *        BIT(2),    /*RESERVED            @Z40LB35*/
               2 VSDALLOC BIT(8),      /*FLAG BYTE           @Z40LB35*/
                 3 VSDACYL  BIT(1),    /*CYLINDER ALLOC      @Z40LB35*/
                 3 VSDATRK  BIT(1),    /*TRACK ALLOC         @Z40LB35*/
                 3 VSDABLK  BIT(1),    /*BLOCK ALLOC         @Z40LB35*/
                 3 VSDABSTR BIT(1),    /*ABSOLUTE TRACKS     @Z40LB35*/
                 3 *        BIT(4),    /*RESERVED            @Z40LB35*/
               2 VSDUSEF BIT(8),       /*FLAG BYTE           @Z40LB35*/
                 3 VSDCALFR BIT(1),    /*UNABLE CAL. SPACE   @Z40LB35*/
                 3 *        BIT(7),    /*RESERVED            @Z40LB35*/
         /*THE FOLLOWING PORTION IS THE CALLERS WORK AREA    @Z40LB35*/
               2 VSDSCAL  CHAR(4),     /*SECONDARY ALLOC     @Z40LB35*/
               2 VSDDSORG CHAR(3),     /*DSORG               @Z40LB35*/
                 3 *      CHAR(2),     /*RESERVED            @Z40LB35*/
                 3 VSDDSOR3 CHAR(1),   /*DSORG INFO          @Z40LB35*/
               2 VSDALLC  CHAR(5),     /*TOTAL TRKS ALLOC    @Z40LB35*/
               2 VSDFREE  CHAR(4);     /*FREE TRACKS         @Z40LB35*/

         DCL 1 VSDBLOCK BDY(WORD) BASED,
               2 VSDELEM  FIXED(31),   /*NUMBER DSN'S        @Z40LB35*/
               2 VSDVTOCS FIXED(31),   /*NUMBER TRKS IN VTOC @Z40LB35*/
               2 VSDFMT0  FIXED(31),   /*NUMBER FMT0 IN VTOC @Z40LB35*/
               2 VSDSPACE PTR(31),     /*PTR TO LSPACE INFO  @Z40LB35*/
               2 VSDARRAY(*) BDY(WORD),
                 3 VSDVOLCT FIXED(31), /*VOLUME COUNT        @Z40LB35*/
                 3 VSDDSN  CHAR(44),   /*DSN                 @Z40LB35*/
                 3 VSDVARY CHAR(MAX(LENGTH(VSDSTAT),
                       LENGTH(VSDSCR),LENGTH(VSDUSAGE)));  /*@Z40LB35*/

 /*********************************************************  @YD00175*/
 /*                                                          @YD00175*/
 /*   KEYWORD ARGUMENT DECLARATIONS FOR ADAPTORS AND         #Y30LB30*/
 /*   VOLUME SERVICES                                        #Y30LB30*/
 /*                                                          #Y30LB30*/
 /*********************************************************  #Y30LB30*/
                                                           /*#Y30LB30*/
         DCL SECCHECK CHAR(8) INIT('SECCHECK');            /*#Y30LB30*/
                                       /*ARGUMENT FOR SECURITY CHECK */
         DCL SCRVTOC  CHAR(8) INIT('SCRVTOC ');            /*#Y30LB30*/
                                       /*ARGUMENT FOR SCRATCH        */
         DCL GETVTOC  CHAR(8) INIT('GETVTOC ');            /*@Y30LB30*/
                                       /*ARGURMENT FOR GET VTOC      */
         DCL PUTVTOC  CHAR(8) INIT('PUTVTOC ');            /*@Y30LB30*/
                                       /*ARGUMENT FOR PUT VTOC       */
         DCL RECATLG  CHAR(8) INIT('RECATLG ');            /*@Y30LB30*/
                                       /*ARGUMENT FOR RECATALOG      */
         DCL INITVOL  CHAR(8) INIT('INITVOL ');            /*@Y30LB30*/
                                       /*ARGUMENT FOR INIT VOLUME    */
         DCL CHECK    CHAR(8) INIT('CHECK   ');            /*@Y30LB30*/
                                       /*ARGUMENT FOR CHECK UCB      */
         DCL POSTUCB  CHAR(8) INIT('POSTUCB ');            /*@Y30LB30*/
                                       /*ARGUMENT FOR POST  UCB      */
         DCL GET      CHAR(8) INIT('GET     ');            /*@Y30LB30*/
                                       /*ARGUMENT FOR GET EXCP RECORD*/
         DCL PUT      CHAR(8) INIT('PUT     ');            /*@Y30LB30*/
                                       /*ARGUMENT FOR PUT EXCP RECORD*/
         DCL CLOSE    CHAR(8) INIT('CLOSE   ');            /*@Y30LB30*/
                                       /*ARGUMENT FOR CLOSE EXCP DCB */
         DCL OPEN     CHAR(8) INIT('OPEN    ');            /*@Y30LB30*/
                                       /*ARGUMENT FOR OPEN EXCP DCB  */
         DCL RVOPENR  CHAR(8) INIT('OPENR   ');            /*@ZA11014*/
         DCL RVRDCNT  CHAR(8) INIT('READCNT ');            /*@ZA11014*/
         DCL RVREADKD CHAR(8) INIT('READKD  ');            /*@ZA11014*/
         DCL RVSPACCR CHAR(8) INIT('SPACCR  ');            /*@ZA11014*/
         DCL RVFWRITE CHAR(8) INIT('FWRITE  ');            /*@ZA11014*/
         DCL RVWRITER CHAR(8) INIT('WRITEREC');            /*@ZA11014*/
         DCL PUTLABEL CHAR(8) INIT('PUTLABEL');            /*@Y30LB30*/
                                       /*PUTLABEL VS02 REQUEST       */
         DCL GETLABEL CHAR(8) INIT('GETLABEL');            /*@Y30LB30*/
                                       /*GETLABEL VS02 REQUEST       */
         DCL CANCEL   CHAR(8) INIT('CANCEL  ');            /*@Y30LB37*/
                                       /*CANCEL REQUEST FOR USTAE    */
         DCL SET      CHAR(8) INIT('SET     ');            /*@Y30LB37*/
                                       /*SET REQUEST FOR USTAE       */
         DCL SELECTX  CHAR(8) INIT('SELECTX ');            /*@YD00175*/
                                       /*SELECT REQUEST FOR UMSSUNIT */
         DCL CHANGEX  CHAR(8) INIT('CHANGEX ');            /*@YD00175*/
                                       /*CHANGE REQUEST FOR UMSSUNIT */
         DCL SELECTDD CHAR(8) INIT('SELECTDD');            /*@Z40LB37*/
                                       /*SELECTDD REQUEST    @Z40LB37*/
                                       /*FOR UMSSUNIT        @Z40LB37*/
         DCL SELECTDS CHAR(8) INIT('SELECTDS');            /*@Z40LB37*/
                                       /*SELECTDS REQUEST    @Z40LB37*/
                                       /*FOR IDCVS03         @Z40LB37*/
 /*                                                          @Y40LB63*/
 /*********************************************************  @Y40LB63*/
 /*                                                          @Y40LB63*/
 /*   KEYWORD ARGUMENT DECLARATIONS FOR USSC MACRO FOR       @Y40LB63*/
 /*   MSS RECOVERY                                           @Y40LB63*/
 /*                                                          @Y40LB63*/
 /*********************************************************  @Y40LB63*/
         DCL TBLREST CHAR(8) INIT('TBLREST ');             /*@Y40LB63*/
                                       /*COPY TABLES FOR     @Y40LB63*/
                                       /*INTERNAL TABLE      @Y40LB63*/
                                       /*RESTORE             @Y40LB63*/
         DCL NULLIFYC CHAR(8) INIT ('NULLIFYC');           /*@Y40LB63*/
                                       /*NULLIFYC ORDER WHICH        */
                                       /*ELEMINATES ALL TRACE        */
                                       /*OF ACTIVE OR INACTIVE       */
                                       /*VOLUME OR A SCRATCH CART    */
         DCL RDMSC CHAR(8) INIT ('RDMSC   ');              /*@Y40LB63*/
                                       /*QUERY ORDER TO READ MSC     */
                                       /*STORAGE             @Y40LB63*/
         DCL RDMSCTBL CHAR(8) INIT ('RDMSCTBL');           /*@Y40LB63*/
                                       /*QUERY ORDER TO READ MSC     */
                                       /*TABLES              @Y40LB63*/
         DCL RDCARTLB CHAR(8) INIT ('RDCARTLB');           /*@Y40LB63*/
                                       /*QUERY ORDER TO READ A       */
                                       /*CARTRIDGE LABEL     @Y40LB63*/
         DCL AUDITCEL CHAR(8) INIT('AUDITCEL');            /*@Y40LB63*/
                                       /*QUERY ORDER TO DO A CELL    */
                                       /*AUDIT OF THE MSF    @Y40LB63*/
         DCL RDSTGAD CHAR(8) INIT ('RDSTGAD ');            /*@Y40LB63*/
                                       /*QUERY ORDER TO READ STAG-   */
                                       /*ING ADAPTER STORAGE @Y40LB63*/
         DCL MODIFYC CHAR(8) INIT ('MODIFYC ');            /*@G24LB40*/
                                       /*MODIFY CARTRIDGE    @G24LB40*/
                                       /*ORDER               @G24LB40*/
 %                                                         /*#Y30LB30*/
 /*********************************************************  @Y30LB30*/
 /*                                                          @Y30LB30*/
 /*                  SYMBOLIC DEFINITIONS                    @Y30LB30*/
 /*                                                          @Y30LB30*/
 /*********************************************************  @Y30LB30*/
                                                           /*@Y30LB30*/
         DCL (RCNRECAT,                /*DATA SET NOT RECAT  @Y30LB30*/
              RCVVIERR,                /*VVIC ERROR          @Y30LB35*/
              RCDSERR,                 /*ERR FROM IDCVS03    @Z40LB35*/
              RCDSCLS,                 /*ERR IDCVS03 CLOSE   @Z40LB35*/
              RCNLOCAT,                /*NOT LOCATED IDCSA07 @Z40LB37*/
              RCNCLOSE) FIXED;         /*CLOSE ERROR         @Y30LB35*/
                                                           /*@Y30LB30*/
 % RCNLOCAT = 8;                       /*DATA SET NOT LOCAT  @Y40LB37*/
 % RCNRECAT = 8;                       /*DATA SET NOT RECAT  @Y30LB30*/
 % RCNCLOSE = 8;                       /*DATA SET NOT CLOSED @Y30LB30*/
 % RCVVIERR = 12;                      /*ERR CODE FROM VVIC  @Y30LB30*/
 % RCDSERR  = 8;                       /*ERR FROM IDCVS03    @Z40LB35*/
 % RCDSCLS  = 12;                      /*ERR IDCVS03 CLOSE   @Z40LB35*/
 % NULLAREA = '''''B';                 /*USED TO CLEAR PARM  @Y30LB30*/
