 /*********************************************************  @Z40LB61*/
 /*                                                          @Z40LB61*/
 /* MSS HARDWARE TABLE MAPPINGS FOR AMS (VS2):     3/31/76   @ZD00051*/
 /*     (1) STAGING ADAPTER TABLES                           @Z40LB61*/
 /*     (2) MASS STORAGE CONTROL TABLES                      @Z40LB61*/
 /*                                                          @Z40LB61*/
 /* CHANGE ACTIVITY -                                        @Z40LB61*/
 /*     ZD00051                                              @ZD00051*/
 /*                                                          @Z40LB61*/
 /*********************************************************  @Z40LB61*/

     /* STAGING ADAPTER VIRTUAL ADDRESS DIRECTORY MAPPING    @Z40LB61*/
     DCL VADPTR1   PTR(31);            /*PTR TO 1ST VAD WORD @Z40LB61
                                         FOR 1 SA INTERFACE  @Z40LB61*/
     DCL VADPTR2   PTR(31);            /*PTR TO 2ND VAD WORD @Z40LB61
                                         FOR 1 SA INTERFACE  @Z40LB61*/
     DCL 1 VADWORD1 (64) BDY(WORD) BASED(VADPTR1),
           3 VADVFM    BIT(8),         /*VIRTUAL FILE MASK   @Z40LB61*/
           3 VADVVA    FIXED(8),       /*VIRTUAL VOL ADDRESS @Z40LB61*/
           3 VADRUA    FIXED(8),       /*REAL UNIT ADDRESS   @Z40LB61*/
             5 VADEDI    BIT(1),       /*EXPECTED DEV INTRPT @ZD00051*/
             5 VADCCR    BIT(1),       /*CHANNEL CMD RETRY   @Z40LB61*/
             5 VADUCS    BIT(1),       /*UNIT CHECK SIO      @ZD00051*/
           3 VADLINK   FIXED(8);       /*LINK POINTER        @Z40LB61*/
     DCL 1 VADWORD2 (64) BDY(WORD) BASED(VADPTR2),
           3 VADRPNUM  FIXED(8),       /*REAL PAGE NUMBER    @Z40LB61*/
             5 VADMOD11  BIT(1),       /*VUA FOR 2ND HALF OF @Z40LB61
                                         A 3330 MOD 11       @Z40LB61*/
           3 VADLUA    FIXED(8),       /*LOGICAL UNIT ADDR   @Z40LB61*/
             5 VADUDE    BIT(1),       /*UNSUPPRESSABLE D.E. @ZD00051*/
           3 VADPOH    FIXED(8),       /*PAGE OFFSET/HEAD    @Z40LB61*/
           3 VADFLAGS  BIT(8),         /*ATTRIBUTE FLAGS     @Z40LB61*/
             5 VADVRW    BIT(1),       /*VIRTUAL READ/WRITE  @Z40LB61*/
             5 VADVWG    BIT(1),       /*VIRTUAL WRITE GATE  @Z40LB61*/
             5 VADVWI    BIT(1),       /*VIRT. WRITE INHIBIT @Z40LB61*/
             5 VADRR     BIT(1),       /*REAL RESERVE        @Z40LB61*/
             5 VADRB     BIT(1),       /*REAL BUSY           @Z40LB61*/
             5 VADRDED   BIT(1),       /*REAL DEVICE END DUE @Z40LB61*/
             5 VADVSI    BIT(1),       /*VIRTUAL SEEK ISSUED @Z40LB61*/
             5 VADRM     BIT(1);       /*REAL MODE           @Z40LB61*/

     /* STAGING ADAPTER VIRTUAL VOLUME INFO TABLE MAPPING    @Z40LB61*/
     DCL VVITPTR1  PTR(31);            /*PTR TO VVIT BYTE#1  @Z40LB61*/
     DCL VVITPTR2  PTR(31);            /*PTR TO VVIT BYTE#2  @Z40LB61*/
     DCL 1 VVITBYT1 (256) BIT(8) BASED(VVITPTR1),
           3 VVITDEDA  BIT(1),         /*DEVICE END DUE      @ZD00051
                                         INTERFACE A         @ZD00051*/
           3 VVITDEDB  BIT(1),         /*DEVICE END DUE      @Z40LB61
                                         INTERFACE B         @Z40LB61*/
           3 VVITDEDC  BIT(1),         /*DEVICE END DUE      @Z40LB61
                                         INTERFACE C         @Z40LB61*/
           3 VVITDEDD  BIT(1),         /*DEVICE END DUE      @Z40LB61
                                         INTERFACE D         @Z40LB61*/
           3 VVITNBM   BIT(1),         /*NOT BUSY MESSAGE    @Z40LB61*/
           3 VVITFR    BIT(1),         /*FIRST RESERVE       @Z40LB61*/
           3 VVITVVWI  BIT(1),         /*VIRT. WRITE INHIBIT @Z40LB61*/
           3 VVITVVS   BIT(1);         /*VIRTUAL VOL SHARED  @Z40LB61*/
     DCL 1 VVITBYT2 (256) BIT(8) BASED(VVITPTR2),
           3 VVITCC    BIT(1),         /*CONTINGENT CONNECT. @Z40LB61*/
           3 VVITVVB   BIT(1),         /*VIRTUAL VOL BUSY    @Z40LB61*/
           3 VVITINTF  BIT(2),         /*INTERFACE ID        @Z40LB61*/
           3 VVITRSVD  BIT(1),         /*VOLUME RESERVED     @Z40LB61*/
           3 VVITPCDB  BIT(1),         /*PACK CHANGE DUE     @Z40LB61
                                         INTERFACE B         @Z40LB61*/
           3 VVITPCDC  BIT(1),         /*PACK CHANGE DUE     @Z40LB61
                                         INTERFACE C         @Z40LB61*/
           3 VVITPCDD  BIT(1);         /*PACK CHANGE DUE     @Z40LB61
                                         INTERFACE D         @Z40LB61*/

     /* STAGING ADAPTER PAGE STATUS TABLE MAPPING            @Z40LB61*/
     DCL PSTPTR    PTR(31);            /*PTR TO PST ENTRY    @Z40LB61
                                         FOR ONE REAL PAGE   @Z40LB61*/
     DCL 1 PST BDY(WORD) BASED(PSTPTR),
           3 PSTVVA    FIXED(8),       /*VIRTUAL VOL ADDRESS @Z40LB61*/
           3 PSTVPNUM  FIXED(8),       /*VIRTUAL PAGE NUMBER @Z40LB61*/
           3 PSTCYLV   BIT(8),         /*MAP OF CYL'S VALID  @Z40LB61*/
           3 PSTCYLW   BIT(8);         /*MAP OF CYL'S WRIT'N @Z40LB61*/

     /* STAGING ADAPTER LOGICAL-TO-REAL TABLE MAPPING        @Z40LB61*/
     DCL LTRPTR    PTR(31);            /*PTR TO LTR TABLE    @Z40LB61*/
     DCL 1 LTR BASED(LTRPTR),
           3 LTRRUA(16) FIXED(8),      /*REAL UNIT ADDRESSES @Z40LB61*/
             5 LTRMOD11  BIT(1);       /*UNIT IS SECOND HALF @Z40LB61
                                         OF A 3330 MOD 11    @Z40LB61*/
 @EJECT;                                                    /*@Z40LB61*/
    /* MASS STORAGE CONTROL VERIFICATION TABLE               @Z40LB61*/
    /* RECORD 1 (VERIFY MISCELLANEOUS DATA) MAPPING          @Z40LB61*/
    DCL VTR1PTR PTR(31);             /* VTABLER1 PTR         @Z40LB65*/
    DCL 1 VTABLER1 BDY(WORD) BASED(VTR1PTR),
         2 VTPACKID CHAR(8),            /* TABLE PACK ID     @Z40LB65*/
         2 * CHAR(8) BDY(HWORD),
          3 VTIMPLS FIXED(16),          /* IMPL/SEQUENCE NUM @Z40LB65*/
          3 * CHAR(6),                  /* RESERVED          @Z40LB65*/
         2 VTTBLCHR (16) CHAR(4),       /* TABLE CHRS        @Z40LB65*/
          3 * CHAR(1),                  /* RESERVED          @Z40LB65*/
          3 VTTBLC FIXED(8),            /* CYLINDER NUMBER   @Z40LB65*/
          3 VTTBLH FIXED(8),            /* HEAD NUMBER       @Z40LB65*/
          3 VTTBLR FIXED(8),            /* RECORD NUMBER     @Z40LB65*/
         2 VTSDGID (16) CHAR(4),        /* STG DRIVE GRP ID  @Z40LB65*/
          3 VTL33330 FIXED(8),          /* LOGICAL 3333 0    @Z40LB65*/
          3 VTL33331 FIXED(8),          /* LOGICAL 3333 1    @Z40LB65*/
          3 VTLRU0 FIXED(8),            /* LRU FOR 3333 0    @Z40LB65*/
          3 VTLRU1 FIXED(8),            /* LRU FOR 3333 1    @Z40LB65*/
         2 VTUCB (2) CHAR(8) BDY(HWORD),/* PRIM. & SEC. UCBS @Z40LB65*/
          3 VTFLAGS BIT(8),             /* UCB FLAGS         @Z40LB65*/
           4 VTPVALID BIT(1),           /* PRIMARY VALID     @Z40LB65*/
           4 VTPONLIN BIT(1),           /* PRIMARY ONLINE    @Z40LB65*/
           4 VTPREADY BIT(1),           /* PRIMARY READY     @Z40LB65*/
           4 VTPBUSY BIT(1),            /* PRIMARY BUSY      @Z40LB65*/
           4 VTSVALID BIT(1),           /* SECONDARY VALID   @Z40LB65*/
           4 VTSONLIN BIT(1),           /* SECONDARY ONLINE  @Z40LB65*/
           4 VTSREADY BIT(1),           /* SECONDARY READY   @Z40LB65*/
           4 VTSBUSY BIT(1),            /* SECONDARY BUSY    @Z40LB65*/
          3 VTWORK BIT(8),              /* WORK BITS         @Z40LB65*/
          3 VTACTIVE BIT(8),            /* ACTIVE BITS       @Z40LB65*/
          3 VTPOST BIT(8),              /* POST BITS         @Z40LB65*/
          3 VTPADDR FIXED(16),          /* PRIMARY ADDRESS   @Z40LB65*/
          3 VTSADDR FIXED(16),          /* ALTERNATE ADDRESS @Z40LB65*/
         2 * CHAR(60),                  /* RESERVED          @Z40LB65*/
         2 VTTRCCHR (4) CHAR(4),        /* TRACE CHRS        @Z40LB65*/
          3 VTXY FIXED(8),              /* X,Y END/START     @Z40LB65*/
          3 VTTRCC FIXED(8),            /* CYLINDER NUMBER   @Z40LB65*/
          3 VTTRCH FIXED(8),            /* HEAD NUMBER       @Z40LB65*/
          3 VTTRCR FIXED(8),            /* RECORD NUMBER     @Z40LB65*/
         2 VTLRUCW CHAR(4) BDY(WORD),   /* LRU CONTROL WORD  @Z40LB65*/
          3 VTLRUCLK FIXED(8),          /* LRU INITIAL CLOCK @Z40LB65*/
          3 VTLRUTIM FIXED(8),          /* LRU TIME VALUE    @Z40LB65*/
          3 VTLRUIOS FIXED(16),         /* LRU-IOS INTERFACE @Z40LB65*/
         2 VTRVPAGE CHAR(12),           /* REAL-VIRT PG XREF @Z40LB65*/
          3 VT08TO0F FIXED(8),          /* VIRT. CYLS 08-0F  @Z40LB65*/
          3 VT10TO17 FIXED(8),          /* VIRT. CYLS 10-17  @Z40LB65*/
          3 VT18TO1F FIXED(8),          /* VIRT. CYLS 18-1F  @Z40LB65*/
          3 VT20TO27 FIXED(8),          /* VIRT. CYLS 20-27  @Z40LB65*/
          3 * CHAR(8),                  /* RESERVED          @Z40LB65*/
         2 VTVOLPFX CHAR(4);            /* VOLID PREFIX      @Z40LB65*/

     /* MASS STORAGE CONTROL STAGING DRIVE GROUP TABLE       @Z40LB61*/
     /* REAL PAGE MAP MAPPING                                @Z40LB61*/
     DCL RPMPTR    PTR(31);            /*PTR TO REAL PAGE    @Z40LB61
                                         MAP FOR ONE DEVICE  @Z40LB61*/
     DCL 1 RPM(52) BDY(WORD) BASED(RPMPTR),
           3 RPMFLAGS  BIT(8),         /*PAGE-TYPE FLAGS     @Z40LB61*/
             5 RPMACT    BIT(1),       /*PAGE IS ACTIVE      @Z40LB61*/
             5 RPMINACT  BIT(1),       /*PAGE IS INACTIVE    @Z40LB61*/
             5 RPMBND    BIT(1),       /*PAGE IS BOUND       @Z40LB61*/
             5 RPMVBND   BIT(1),       /*PAGE ALLOCATED TO   @Z40LB61
                                         A BOUND VOLUME      @Z40LB61*/
             5 RPMIOERR  BIT(1),       /*I/O ERROR DETECTED  @Z40LB61*/
             5 *         BIT(1),       /*RESERVED            @Z40LB61*/
             5 RPMMSCT   BIT(1),       /*PAGE OF MSC TABLES  @Z40LB61*/
             5 RPMNA     BIT(1),       /*PAGE NOT AVAILABLE  @Z40LB61*/
           3 RPMVPNUM  FIXED(8),       /*VIRTUAL PAGE NO.    @Z40LB61*/
           3 RPMMVT    FIXED(16);      /*MVT POINTER         @Z40LB61*/

     /* MASS STORAGE CONTROL STAGING DRIVE GROUP TABLE       @Z40LB61*/
     /* PAGE AVAILABILITY BLOCK MAPPING                      @Z40LB61*/
     DCL PABPTR    PTR(31);            /*PTR TO PAB FOR      @Z40LB61
                                         ONE SDG             @Z40LB61*/
     DCL 1 PAB BDY(WORD) BASED(PABPTR),
           3 PABFTOT   FIXED(16),      /*FREE PAGE TOTAL     @Z40LB61*/
           3 PABATOT   FIXED(16),      /*ACTIVE PAGE TOTAL   @Z40LB61*/
           3 PABITOT   FIXED(16),      /*INACTIVE PAGE TOTAL @Z40LB61*/
           3 PABBTOT   FIXED(16),      /*BOUND PAGE TOTAL    @Z40LB61*/
           3 PABPPD    FIXED(8),       /*PAGES PER DEVICE    @Z40LB61*/
           3 PABUPDEL  FIXED(8),       /*UPPER DELTA         @Z40LB61*/
           3 PABUPTH   FIXED(16),      /*UPPER THRESHOLD     @Z40LB61*/
           3 *         FIXED(8),       /*RESERVED            @Z40LB61*/
           3 PABLODEL  FIXED(8),       /*LOWER DELTA         @Z40LB61*/
           3 PABLOTH   FIXED(16),      /*LOWER THRESHOLD     @Z40LB61*/
           3 PABSA (2) FIXED(8),       /*SA ID (LOW 4 BITS)  @Z40LB61*/
             5 PABVLDSA  BIT(1),       /*SA IS VALID         @Z40LB61*/
             5 *         BIT(2),       /*RESERVED            @Z40LB61*/
             5 PAB3333   BIT(1),       /*3333 ID             @Z40LB61*/
           3 *         FIXED(16),      /*RESERVED            @Z40LB61*/
           3 PABSRW    FIXED(8),       /*SLICE RANGE W       @Z40LB61*/
           3 PABSRX    FIXED(8),       /*SLICE RANGE X       @Z40LB61*/
           3 PABSRY    FIXED(8),       /*SLICE RANGE Y       @Z40LB61*/
           3 PABSRZ    FIXED(8),       /*SLICE RANGE Z       @Z40LB61*/
           3 *         CHAR(8),        /*RESERVED            @Z40LB61*/
           3 * (8)     FIXED(32),      /*PAGE COUNTS FOR     @Z40LB61
                                         EACH SDG DEVICE     @Z40LB61*/
             5 PABFCNT   FIXED(8),     /*FREE PAGE COUNT     @Z40LB61*/
             5 PABACNT   FIXED(8),     /*ACTIVE PAGE COUNT   @Z40LB61*/
             5 PABICNT   FIXED(8),     /*INACTIVE PAGE COUNT @Z40LB61*/
             5 PABBCNT   FIXED(8),     /*BOUND PAGE COUNT    @Z40LB61*/
           3 PABFMAP (8,8) BIT(8),     /*FREE PAGE BIT MAP   @Z40LB61
                                         FOR EACH DEVICE     @Z40LB61*/
           3 PABAMAP (8,8) BIT(8),     /*ACTIVE PAGE BIT MAP @Z40LB61
                                         FOR EACH DEVICE     @Z40LB61*/
           3 * (8)     FIXED(32),      /*DEVICE INFORMATION  @Z40LB61
                                         FOR EACH DEVICE     @Z40LB61*/
             5 PABFLAGS  BIT(8),       /*DEVICE ATTRIBUTES   @Z40LB61*/
               7 PABDEX    BIT(1),     /*DEVICE EXISTS       @Z40LB61*/
               7 PABVARV   BIT(1),     /*VARIED ON VIRTUAL   @Z40LB61*/
               7 PABVARR   BIT(1),     /*VARIED ON REAL      @Z40LB61*/
               7 PABMOD11  BIT(1),     /*DEVICE IS HALF OF   @Z40LB61
                                         A 3330 MOD 11       @Z40LB61*/
               7 PABMSCT   BIT(1),     /*DEVICE CONTAINS     @Z40LB61
                                         MSC TABLES          @Z40LB61*/
               7 PABVBND   BIT(1),     /*VOLUME BOUND        @Z40LB61*/
               7 PABVARN   BIT(1),     /*VARIED NEUTRAL      @Z40LB61*/
               7 PAB2M11   BIT(1),     /*DEVICE IS 2ND HALF  @Z40LB61
                                         OF A 3330 MOD 11    @Z40LB61*/
             5 PABRINTF  BIT(8),       /*REAL INTERFACE      @Z40LB61*/
               7 PABRAI    BIT(1),     /*CONVERTIBLE TO REAL @Z40LB61*/
               7 PABSA1B   BIT(1),     /*INTERFACE B OF SA#1 @Z40LB61*/
               7 PABSA1C   BIT(1),     /*INTERFACE C OF SA#1 @Z40LB61*/
               7 PABSA1D   BIT(1),     /*INTERFACE D OF SA#1 @Z40LB61*/
               7 *         BIT(1),     /*RESERVED            @Z40LB61*/
               7 PABSA2B   BIT(1),     /*INTERFACE B OF SA#2 @Z40LB61*/
               7 PABSA2C   BIT(1),     /*INTERFACE C OF SA#2 @Z40LB61*/
               7 PABSA2D   BIT(1),     /*INTERFACE D OF SA#2 @Z40LB61*/
             5 PABORUA   FIXED(8),     /*ORIGINAL RUA        @Z40LB61*/
               7 PABORUAV  BIT(1),     /*OLD RUA IS VALID    @Z40LB61*/
             5 PABRUA    FIXED(8);     /*REAL UNIT ADDRESS   @Z40LB61*/

     /* MASS STORAGE CONTROL STAGING DRIVE GROUP TABLE       @Z40LB61*/
     /* DEMOUNTED VOLUME BLOCK MAPPING                       @Z40LB61*/
     DCL DVBPTR    PTR(31);            /*PTR TO 1 SDG'S DVB  @Z40LB61*/
     DCL 1 DVB BDY(WORD) BASED(DVBPTR),
           3 DVBNEXT   FIXED(8),       /*NEXT ENTRY'S OFFSET @Z40LB61*/
           3 DVBCURR   FIXED(8),       /*CURRENT ENTRY'S     @Z40LB61
                                         OFFSET              @Z40LB61*/
           3 *         FIXED(16),      /*RESERVED            @Z40LB61*/
           3 DVBMVT (126) FIXED(16),   /*MVT POINTERS        @Z40LB61*/
             5 DVBMSFID   BIT(2),      /*MSF CONTAINING VOL  @Z40LB61*/
             5 DVBPFI     BIT(1);      /*PREFERRED INACTIVE  @ZD00051
                                         SPACE FOR THIS VOL  @ZD00051*/

     /* MASS STORAGE CONTROL STAGING DRIVE GROUP TABLE       @Z40LB61*/
     /* LEAST RECENTLY USED PAGES BLOCK MAPPING              @Z40LB61*/
     DCL LPBPTR    PTR(31);            /*PTR TO 1 SDG'S LPB  @Z40LB61*/
     DCL 1 LPB BDY(WORD) BASED(LPBPTR),
           3 LPBNEXT   FIXED(8),       /*NEXT ENTRY'S OFFSET @Z40LB61*/
           3 LPBCURR   FIXED(8),       /*CURRENT ENTRY'S     @Z40LB61
                                         OFFSET              @Z40LB61*/
           3 *         FIXED(16),      /*RESERVED            @Z40LB61*/
           3 LPBMVT (126) FIXED(16),   /*MVT POINTERS        @Z40LB61*/
             5 LPBMSFID   BIT(2),      /*MSF CONTAINING VOL  @Z40LB61*/
             5 LPBPFI     BIT(1);      /*PREFERRED INACTIVE  @ZD00051
                                         SPACE FOR THIS VOL  @ZD00051*/

     /* MASS STORAGE CONTROL VIRTUAL VOLUME ADDRESS /        @Z40LB61*/
     /* MOUNTED VOLUME TABLE CROSS REFERENCE TABLE MAPPING   @Z40LB61*/
     DCL VMXPTR    PTR(31);            /*PTR TO MVT XREF FOR @Z40LB61
                                         A SINGLE VVA ENTRY  @Z40LB61*/
     DCL 1 VMX BDY(WORD) BASED(VMXPTR),
           3 VMXFLAGS  BIT(8),         /*ATTRIBUTE FLAGS     @Z40LB61*/
             5 VMXVALID  BIT(1),       /*ENTRY IS VALID      @Z40LB61*/
             5 *         BIT(7),       /*RESERVED            @Z40LB61*/
           3 *         FIXED(8),       /*RESERVED            @Z40LB61*/
           3 VMXMVT    FIXED(16);      /*MVT POINTER         @Z40LB61*/

     /* MASS STORAGE CONTROL VIRTUAL VOL ADDR TABLE MAPPING  @Z40LB61*/
     DCL VVATPTR   PTR(31);            /*PTR TO VVAT ENTRY   @Z40LB61
                                         FOR ONE SA          @Z40LB61*/
     DCL 1 VVAT BDY(WORD) BASED(VVATPTR),
           3 VVATVVA (32) BIT(8);      /*MAP OF VVA'S IN USE @Z40LB61
                                         (VVA 64 IS 1ST BIT) @Z40LB61*/

     /* MASS STORAGE CONTROL CONFIGURATION BIT MAP MAPPING   @Z40LB64*/
     DCL CBMPTR   PTR(31) BDY(WORD);   /* CBM BASE POINTER   @Z40LB64*/
     DCL 1 CBMAP BDY(WORD) BASED(CBMPTR),
           3 CBMDRD (4) BIT(8),        /* ONE BIT FOR EACH   @Z40LB64
                                          POSSIBLE DRD IN    @Z40LB64
                                          CONFIGURATION      @Z40LB64*/
           3 CBMSA (2) BIT(8),         /* ONE BIT FOR EACH   @Z40LB64
                                          POSSIBLE SA IN     @Z40LB64
                                          CONFIGURATION      @Z40LB64*/
           3 CBMDRC (2) BIT(8),        /* ONE BIT FOR EACH   @Z40LB64
                                          POSSIBLE DRC IN    @Z40LB64
                                          CONFIGURATION      @Z40LB64*/
           3 CBMDRIVE(30) BIT(8),      /* ONE BIT FOR EACH   @Z40LB64
                                          POSSIBLE DRIVE     @Z40LB64
                                          IN CONFIGURATION   @Z40LB64*/
           3 CBMFLAGS BIT(8),          /*ATTRIBUTE FLAGS     @Z40BL64*/
           3 CBMMSF   BIT(8);          /*TWO BITS FOR EACH   @Z40LB64
                                         POSSIBLE MSF (1 BIT @Z40LB64
                                         EACH FOR UC0-2 &    @Z40LB64
                                         UC0-1 RESPECTIVELY) @Z40LB64*/

     /* MASS STORAGE CONTROL MOUNT EQUALIZATION              @Z40LB64*/
     /* RECORD MAPPING                                       @Z40LB64*/
     DCL MERPTR PTR(31);               /* MER BASE POINTER   @Z40LB64*/
     DCL 1 MERECORD BDY(WORD) BASED(MERPTR),
           3 *(30) BDY(WORD),          /* INFORMATION FOR    @Z40LB64
                                          EACH SDG           @Z40LB64*/
             5 MEFLAGS BIT(8),         /* FLAGS              @Z40LB64*/
               7 MEVOI1 BIT(1),        /* INCREMENT VARIED   @Z40LB64
                                          ON COUNT BY 1      @Z40LB64*/
               7 MEVOD1 BIT(1),        /* DECREMENT VARIED   @Z40LB64
                                          ON COUNT BY 1      @Z40LB64*/
               7 MEVOI2 BIT(1),        /* INCREMENT VARIED   @Z40LB64
                                          ON COUNT BY 2      @Z40LB64*/
               7 MEVOD2 BIT(1),        /* DECREMENT VARIED   @Z40LB64
                                          ON COUNT BY 2      @Z40LB64*/
               7 MEMVI1 BIT(1),        /* INCREMENT MOUNTED  @Z40LB64
                                          VOLUMES COUNT BY 1 @Z40LB64*/
               7 MEMVD1 BIT(1),        /* DECREMENT MOUNTED  @Z40LB64
                                          VOLUMES COUNT BY 1 @Z40LB64*/
               7 MEMVI2 BIT(1),        /* INCREMENT MOUNTED  @Z40LB64
                                          VOLUMES COUNT BY 2 @Z40LB64*/
               7 MEMVD2 BIT(1),        /* DECREMENT MOUNTED  @Z40LB64
                                          VOLUMES COUNT BY 2 @Z40LB64*/
             5 MEVOCNT FIXED(8),       /* COUNT OF LOGICAL   @Z40LB64
                                          DRIVES VARIED ON   @Z40LB64*/
             5 MEMNTCNT FIXED(16),     /* COUNT OF VOLUMES   @Z40LB64
                                          MOUNTED ON SDG     @Z40LB64*/
           3 * CHAR(8),                /* RESERVED           @Z40LB64*/
           3 *(30) BDY(WORD),          /* INFORMATION FOR    @Z40LB64
                                          EACH SDG           @Z40LB64*/
             5 MELRUCNT FIXED(8),      /* COUNT OF LRU       @Z40LB64
                                          INVOKES FOR SDG    @Z40LB64*/
             5 MEDRVCNT FIXED(8),      /* COUNT OF LOGICAL   @Z40LB64
                                          DRIVES FOR SDG     @Z40LB64*/
             5 MEUCBCNT FIXED(16);     /* COUNT OF SYSGENED  @Z40LB64
                                          UCBS FOR SDG       @Z40LB64*/

     /* MASS STORAGE CONTROL MOUNTED VOLUME TABLE            @Z40LB64*/
     /* CONTROL BLOCK MAPPING                                @Z40LB64*/
     DCL MVCBPTR PTR(31);              /* MVT CTL BLK PTR    @Z40LB64*/
     DCL 1 MVCTLBLK BDY(WORD) BASED(MVCBPTR),
           3 MVCTLBIT (256) BIT(8);    /* MVT ENTRY IN-USE   @Z40LB64
                                          FLAGS              @Z40LB64*/

     /* MASS STORAGE CONTROL MOUNTED VOLUME TABLE            @Z40LB64*/
     /* INDEX BLOCK MAPPING                                  @Z40LB64*/
     DCL MVIBPTR PTR(31);              /* MVT INDEX BLK PTR  @Z40LB64*/
     DCL 1 MVIDXBLK BDY(WORD) BASED(MVIBPTR),
           3 MVIFLAGS BIT(8),          /* INDEX FLAGS        @Z40LB64*/
             5 MVOFOUT BIT(1),         /* OVERFLOW OUT       @Z40LB64*/
             5 MVOFBLK BIT(1),         /* OVERFLOW BLOCK     @Z40LB64*/
             5 MVLSTBLK BIT(1),        /* LAST BLK IN INDEX  @Z40LB64*/
             5 *       BIT(5),         /* ZEROS              @Z40LB64*/
           3 MVENTLEN FIXED(8),        /* ENTRY LENGTH       @Z40LB64*/
           3 MVENTMAX FIXED(8),        /* MAXIMUM ENTRIES    @Z40LB64*/
           3 MVENTNUM FIXED(8),        /* ACTUAL ENTRIES     @Z40LB64*/
           3 * CHAR(4),                /* RESERVED           @Z40LB64*/
           3 *(31) BDY(WORD),          /* INDEX ENTRY        @Z40LB64*/
             5 MVIVOLID CHAR(6),       /* VOLUME IDENTIFIER  @Z40LB64*/
             5 MVMVTPTR FIXED(16);     /* MVT ENTRY POINTER  @Z40LB64*/

     /* MASS STORAGE CONTROL MOUNTED VOLUME TABLE            @Z40LB64*/
     /* ENTRY MAPPING                                        @Z40LB64*/
     DCL MVENTPTR PTR(31);             /* MVT ENTRY BASE PTR @Z40LB64*/
     DCL MVPATH#   FIXED(15);          /*INDEX TO SA PATH TO @Z40LB61
                                         BE EXAMINED         @Z40LB61*/
     DCL 1 MVENTRY BDY(WORD) BASED(MVENTPTR),
           3 MVVOLID CHAR(6),          /* VOLUME IDENTIFIER  @Z40LB64*/
           3 MVVFLAGS BIT(8),          /* VOLUME FLAGS       @Z40LB64*/
             5 MVCECTG BIT(1),         /* CE CARTRIDGE       @Z40LB64*/
             5 *        BIT(1),        /* RESERVED           @Z40LB64*/
             5 MVSECVOL BIT(1),        /* SECURE VOLUME      @Z40LB64*/
             5 MVEXCVOL BIT(1),        /* EXCLUSIVE VOLUME   @Z40LB64*/
             5 MVSCRCTG BIT(1),        /* SCRATCH CARTRIDGE  @Z40LB64*/
             5 MVBNDVOL BIT(1),        /* BOUND VOLUME       @Z40LB64*/
             5 MVWRTINH BIT(1),        /* WRITE INHIBIT      @Z40LB64*/
             5 *        BIT(1),        /* RESERVED           @Z40LB64*/
           3 *        CHAR(1),         /* RESERVED           @Z40LB64*/
           3 MVLZYX1 FIXED(16),        /* SEQ #1 CTG ADDRESS @Z40LB64*/
           3 MVLZYX2 FIXED(16),        /* SEQ #2 CTG ADDRESS @Z40LB64*/
           3 MVMFLAGS BIT(8),          /* MOUNT FLAGS        @Z40LB64*/
             5 MVMNTVOL BIT(1),        /* VOLUME MOUNTED     @Z40LB64*/
             5 MVMNTEXC BIT(1),        /* MOUNTED EXCLUSIVE  @Z40LB64*/
             5 MVMNTBND BIT(1),        /* MOUNTED BOUND      @Z40LB64*/
             5 MVREMNT  BIT(1),        /* REMOUNTED NEW SDG  @Z40LB61*/
             5 *        BIT(4),        /* RESERVED           @Z40LB64*/
           3 MVPINCNT FIXED(8),        /* INACTIVE PAGE CNT  @Z40LB64*/
           3 MVRESRVE FIXED(8),        /* SA PORT RESERVING  @Z40LB64
                                          VOL (LOW 2 BITS)   @Z40LB64*/
             5 *      BIT(4),          /* RESERVED           @Z40LB64*/
             5 MVSA2RSV BIT(1),        /* 0 FOR SA1          @Z40LB64
                                          1 FOR SA2          @Z40LB64*/
             5 *        BIT(1),        /* RESERVED           @Z40LB64*/
           3 MVSDG    FIXED(8),        /* SDG INDEX          @Z40LB64*/
           3 MV3333   FIXED(8),        /* LOGICAL 3333 ADDR  @Z40LB64*/
           3 MVVAMSG BIT(8),           /* VOL AVAILABLE MSG  @Z40LB64*/
             5 MVINTFA BIT(1),         /* INTERFACE A        @Z40LB64*/
             5 MVINTFB BIT(1),         /* INTERFACE B        @Z40LB64*/
             5 MVINTFC BIT(1),         /* INTERFACE C        @Z40LB64*/
             5 MVINTFD BIT(1),         /* INTERFACE D        @Z40LB64*/
             5 *       BIT(4),         /* RESERVED           @Z40LB64*/
           3 *         CHAR(2),        /* RESERVED           @Z40LB64*/
           3 *(2)  CHAR(8) BDY(WORD),  /* INTERFACE INFO     @Z40LB64*/
             5 MVSA    FIXED(8),       /* SA ADDRESS         @Z40LB64
                                          (LOW 4 BITS)       @Z40LB64*/
               7 MVVLDSA BIT(1),       /* SA IS VALID        @Z40LB64*/
               7 MVACTB BIT(1),        /* INTERFACE B ACTIVE @Z40LB64*/
               7 MVACTC BIT(1),        /* INTERFACE C ACTIVE @Z40LB64*/
               7 MVACTD BIT(1),        /* INTERFACE D ACTIVE @Z40LB64*/
             5 MVCPUIDS FIXED(24),     /* CPU IDENTIFIERS    @Z40LB64
                                          (SEE LOWER LEVEL
                                          STRUCTURE DECLARE) @Z40LB64*/
             5 MVVVA     FIXED(8),     /*VIRTUAL VOL ADDRESS @Z40LB61*/
             5 MVVUAS   FIXED(24),     /* VIRTUAL UNIT ADDRS @Z40LB61
                                          (SEE LOWER LEVEL
                                          STRUCTURE DECLARE) @Z40LB64*/
           3 MVPFI (8) BIT(8),         /*PREFERRED INACTIVE  @ZD00051
                                         PAGE BIT MAP        @ZD00051*/
           3 *         CHAR(8),        /*RESERVED            @ZD00051*/
           3 *(51) CHAR(4) BDY(WORD),  /* PAGE ALLOCATION    @Z40LB64
                                          INFORMATION        @Z40LB64*/
             5 MVLOGDEV FIXED(8),      /* LOGICAL DEVICE     @Z40LB64
                                          (LOW 3 BITS)       @Z40LB64*/
               7 MVPINACT BIT(1),      /* PAGE IS ACTIVE     @Z40LB64*/
               7 MVDSTGC1 BIT(1),      /* CTG #1 SCHEDULED   @Z40LB64
                                          FOR DESTAGE        @Z40LB64*/
               7 MVDSTGC2 BIT(1),      /* CTG #2 SCHEDULED   @Z40LB64
                                          FOR DESTAGE        @Z40LB64*/
               7 *       BIT(2),       /* RESERVED           @Z40LB64*/
             5 MVBNDCNT FIXED(8),      /* BOUND COUNT        @Z40LB64*/
             5 MVRPNUM  FIXED(8),      /* REAL PAGE          @Z40LB64*/
             5 MVCYLMAP BIT(8);        /* CYLINDER MAP       @Z40LB64*/

     /* MASS STORAGE CONTROL MOUNTED VOLUME TABLE ENTRY      @Z40LB64*/
     /* CPU IDENTIFIERS FOR INTERFACES B, C, AND D           @Z40LB64*/
     /* (LOWER LEVEL STRUCTURE DECLARATION FOR 'MVCPUIDS')   @Z40LB64*/
     DCL MVCPUID(3) FIXED(8) BASED(    /* CPU IDENTIFIER     @Z40LB64*/
              ADDR(MVCPUIDS(MVPATH#)));/* (LOW 4 BITS)       @Z40LB64*/

     /* MASS STORAGE CONTROL MOUNTED VOLUME TABLE ENTRY      @Z40LB64*/
     /* VIRTUAL UNIT ADDRESSES FOR INTERFACES B, C, AND D    @Z40LB64*/
     /* (LOWER LEVEL STRUCTURE DECLARATION FOR 'MVVUAS')     @Z40LB64*/
     DCL 1 MVVUA(3) FIXED(8) BASED(    /* VIRTUAL UNIT ADDR  @Z40LB61*/
              ADDR(MVVUAS(MVPATH#))),  /* (LOW 6 BITS)       @Z40LB61*/
           3 MVVUAI#  BIT(2);          /* INTERFACE ID#      @Z40LB64*/

     /* MASS STORAGE CONTROL SCRATCH CARTRIDGE LIST          @Z40LB64*/
     /* CONTROL FIELD MAPPING                                @Z40LB64*/
     DCL SCCFPTR PTR(31);              /* SCL CTL FLD PTR    @Z40LB64*/
     DCL 1 SCCTLFLD BDY(WORD) BASED(SCCFPTR),
           3 SCCOMLEN FIXED(8),        /* COMPARE LENGTH     @Z40LB64
                                          (LOW 4 BITS)       @Z40LB64*/
             5 SCCFLAGS BIT(4),        /* CONTROL FLD FLAGS  @Z40LB64*/
               7 SCLSTBLK BIT(1),      /* LAST TABLE BLOCK   @Z40LB64*/
               7 SCLSTACT BIT(1),      /* LAST ACTIVE BLOCK  @Z40LB64*/
               7 SCENDTRK BIT(1),      /* END OF TRACK BLOCK @Z40LB64*/
               7 SCLSTTRK BIT(1),      /* LAST TABLE TRACK   @Z40LB64*/
           3 SCENTLEN FIXED(8),        /* ENTRY LENGTH       @Z40LB64*/
           3 SCENTMAX FIXED(8),        /* MAXIMUM ENTRIES    @Z40LB64*/
           3 SCENTNUM FIXED(8),        /* ENTRY USE COUNT    @Z40LB64*/
           3 SCTRKPTR CHAR(4),         /* NEXT TRACK POINTER @Z40LB64*/
             5 *      CHAR(1),         /* ZEROS              @Z40LB64*/
             5 SCCYL  FIXED(8),        /* CYLINDER ADDRESS   @Z40LB64*/
             5 SCHEAD FIXED(8),        /* TRACK ADDRESS      @Z40LB64*/
             5 SCREC  FIXED(8);        /* RECORD ADDRESS     @Z40LB64*/

     /* MASS STORAGE CONTROL SCRATCH CARTRIDGE LIST          @Z40LB64*/
     /* ENTRY MAPPING                                        @Z40LB64*/
     DCL SCENTPTR PTR(31);             /* SCL ENTRY POINTER  @Z40LB64*/
     DCL 1 SCENTRY BDY(WORD) BASED(SCENTPTR),
           3 *     CHAR(4),            /* RESERVED           @Z40LB64*/
           3 SCCSN CHAR(12),           /* CARTRIDGE SERIAL   @Z40LB64*/
           3 SCLZYX FIXED(16),         /* CARTRIDGE ADDRESS  @Z40LB64*/
           3 *     CHAR(2);            /* RESERVED           @Z40LB64*/

     /* MASS STORAGE CONTROL VOLUME INVENTORY                @Z40LB64*/
     /* CONTROL FIELD MAPPING                                @Z40LB64*/
     DCL VICFPTR PTR(31);              /* VI CTL FLD PTR     @Z40LB64*/
     DCL 1 VICTLFLD BDY(WORD) BASED(VICFPTR),
           3 VICFLAGS BIT(8),          /* CONTROL FLD FLAGS  @Z40LB64*/
             5 VILSTBLK BIT(1),        /* LAST TABLE BLOCK   @Z40LB64*/
             5 VILSTACT BIT(1),        /* LAST ACTIVE BLOCK  @Z40LB64*/
             5 VIENDTRK BIT(1),        /* END OF TRACK       @Z40LB64*/
             5 VILSTTRK BIT(1),        /* LAST TABLE TRACK   @Z40LB64*/
             5 VIUSEBLK BIT(1),        /* BLOCK USED         @Z40LB64*/
             5 VIAREA   BIT(2),        /* TABLE AREA         @Z40LB64*/
             5 VIOFBLK  BIT(1),        /* OVERFLOW BLOCK     @Z40LB64*/
           3 VIENTLEN FIXED(8),        /* ENTRY LENGTH       @Z40LB64*/
           3 VIENTMAX FIXED(8),        /* MAXIMUM ENTRIES    @Z40LB64*/
           3 VIENTNUM FIXED(8),        /* ACTUAL ENTRIES     @Z40LB64*/
           3 VITRKPTR CHAR(4),         /* NEXT TRACK POINTER @Z40LB64*/
             5 *      CHAR(1),         /* ZEROS              @Z40LB64*/
             5 VICYL  FIXED(8),        /* CYLINDER ADDRESS   @Z40LB64*/
             5 VIHEAD FIXED(8),        /* TRACK ADDRESS      @Z40LB64*/
             5 VIREC  FIXED(8);        /* RECORD ADDRESS     @Z40LB64*/

     /* MASS STORAGE CONTROL VOLUME INVENTORY ENTRY MAPPING  @Z40LB64*/
     DCL VIENTPTR PTR(31);             /* VI ENTRY POINTER   @Z40LB64*/
     DCL 1 VIENTRY BDY(WORD) BASED(VIENTPTR),
           3 VIVOLID CHAR(6),          /* VOLUME IDENTIFIER  @Z40LB64*/
           3 VIVFLAGS BIT(8),          /* VOLUME FLAGS       @Z40LB64*/
             5 VICECTG BIT(1),         /* CE CARTRIDGE       @Z40LB64*/
             5 *       BIT(1),         /* RESERVED           @Z40LB64*/
             5 VISECVOL BIT(1),        /* SECURE VOLUME      @Z40LB64*/
             5 VIEXCVOL BIT(1),        /* EXCLUSIVE VOLUME   @Z40LB64*/
             5 VISCRCTG BIT(1),        /* SCRATCH CARTRIDGE  @Z40LB64*/
             5 VIBNDVOL BIT(1),        /* BOUND VOLUME       @Z40LB64*/
             5 VIWRTINH BIT(1),        /* WRITE INHIBIT      @Z40LB64*/
             5 *        BIT(1),        /* RESERVED           @Z40LB64*/
           3 *         CHAR(1),        /* RESERVED           @Z40LB64*/
           3 VILZYX1   FIXED(16),      /* SEQ #1 CTG ADDRESS @Z40LB64*/
           3 VILZYX2   FIXED(16);      /* SEQ #2 CTG ADDRESS @Z40LB64*/

     /* MASS STORAGE CONTROL TRANSIENT VOLUME LIST           @Z40LB64*/
     /* CONTROL FIELD MAPPING                                @Z40LB64*/
     DCL TVCFPTR PTR(31);              /* TVL CTL FLD PTR    @Z40LB64*/
     DCL 1 TVCTLFLD BDY(WORD) BASED(TVCFPTR),
           3 TVCOMLEN FIXED(8),        /* COMPARE LENGTH     @Z40LB64
                                          (LOW 4 BITS)       @Z40LB64*/
             5 TVCFLAGS BIT(4),        /* CONTROL FLD FLAGS  @Z40LB64*/
               7 TVLSTBLK BIT(1),      /* LAST TABLE BLOCK   @Z40LB64*/
               7 TVLSTACT BIT(1),      /* LAST ACTIVE BLOCK  @Z40LB64*/
               7 TVENDTRK BIT(1),      /* END OF TRACK       @Z40LB64*/
               7 TVLSTTRK BIT(1),      /* LAST TABLE TRACK   @Z40LB64*/
           3 TVENTLEN FIXED(8),        /* ENTRY LENGTH       @Z40LB64*/
           3 TVENTMAX FIXED(8),        /* MAXIMUM ENTRIES    @Z40LB64*/
           3 TVENTNUM FIXED(8),        /* ENTRY USE COUNT    @Z40LB64*/
           3 TVTRKPTR CHAR(4),         /* NEXT TRACK POINTER @Z40LB64*/
             5 *      CHAR(1),         /* ZEROS              @Z40LB64*/
             5 TVCYL FIXED(8),         /* CYLINDER ADDRESS   @Z40LB64*/
             5 TVHEAD FIXED(8),        /* TRACK ADDRESS      @Z40LB64*/
             5 TVREC FIXED(8);         /* RECORD ADDRESS     @Z40LB64*/

     /* MASS STORAGE CONTROL TRANSIENT VOLUME LIST           @Z40LB64*/
     /* ENTRY MAPPING                                        @Z40LB64*/
     DCL TVENTPTR PTR(31);             /* TVL ENTRY POINTER  @Z40LB64*/
     DCL 1 TVENTRY BDY(WORD) BASED(TVENTPTR),
           3 TVLZYX1 FIXED(16),        /* SEQ #1 CTG ADDRESS @Z40LB64*/
           3 TVLZYX2 FIXED(16),        /* SEQ #2 CTG ADDRESS @Z40LB64*/
           3 TVCSN   CHAR(12),         /* CARTRIDGE SERIAL   @Z40LB64*/
           3 TVVOLID CHAR(6),          /* VOLUME IDENTIFIER  @Z40LB64*/
           3 TVVFLAGS BIT(8),          /* VOLUME FLAGS       @Z40LB64*/
             5 TVCECTG BIT(1),         /* CE CARTRIDGE       @Z40LB64*/
             5 *       BIT(1),         /* RESERVED           @Z40LB64*/
             5 TVSECVOL BIT(1),        /* SECURE VOLUME      @Z40LB64*/
             5 TVEXCVOL BIT(1),        /* EXCLUSIVE VOLUME   @Z40LB64*/
             5 TVSCRCTG BIT(1),        /* SCRATCH CARTRIDGE  @Z40LB64*/
             5 TVBNDVOL BIT(1),        /* BOUND VOLUME       @Z40LB64*/
             5 TVWRTINH BIT(1),        /* WRITE INHIBIT      @Z40LB64*/
             5 *        BIT(1),        /* RESERVED           @Z40LB64*/
           3 *          CHAR(1);       /* RESERVED           @Z40LB64*/

     /* MASS STORAGE CONTROL CONFIGURATION INDEX             @Z40LB64*/
     /* ENTRY MAPPING                                        @Z40LB64*/
     DCL CIENTPTR PTR(31);             /* CONFIG INDEX PTR   @Z40LB64*/
     DCL CISA#    FIXED(15);           /*INDEX TO CI DATA    @Z40LB61
                                         FOR A GIVEN SA#     @Z40LB61*/
     DCL 1 CIENTRY(16) BDY(WORD) BASED(CIENTPTR),
           3 CICSCNCT BIT(8),          /* SA MSF CONNECTION  @Z40BL64*/
             5 CIMSF    BIT(1),        /* ID IS FOR AN MSF   @Z40BL64*/
             5 *        BIT(3),        /* RESERVED           @Z40LB64*/
             5 CIMSF0   BIT(1),        /* MSF 0              @Z40LB64*/
             5 CIMSF1   BIT(1),        /* MSF 1              @Z40LB64*/
             5 CIMSF2   BIT(1),        /* MSF 2              @Z40LB64*/
             5 CIMSF3   BIT(1),        /* MSF 3              @Z40LB64*/
           3 *          CHAR(1),       /* RESERVED           @Z40LB64*/
           3 CISACHNL CHAR(6);         /* SA CHANNEL B,C,D   @Z40LB64
                                          (SEE LOWER LEVEL   @Z40LB64
                                          STRUCTURE DECLARE) @Z40LB64*/

     /* MASS STORAGE CONTROL CONFIGURATION INDEX ENTRY       @Z40LB64*/
     /* SA CHANNEL B, C, AND D INFORMATION                   @Z40LB64*/
     /* (LOWER LEVEL STRUCTURE DECLARATION FOR 'CISACHNL')   @Z40LB64*/
     DCL 1 *(3) CHAR(2) BASED(ADDR(CISACHNL(CISA#))),
           3 CICPUID FIXED(8),         /* CPU IDENTIFIER     @Z40LB64*/
           3 CICUCHL FIXED(8),         /* CONTROL UNIT AND   @Z40LB64
                                          CHANNEL ADDRESS    @Z40LB64*/
             5 CICU    BIT(2),         /* CONTROL UNIT       @Z40LB64*/
             5 *       BIT(2),         /* ZEROS              @Z40LB64*/
             5 CICHL   BIT(4);         /* CHANNEL ADDRESS    @Z40LB64*/

     /* MASS STORAGE CONTROL MANUFACTURER'S ID CONVERSION    @Z40LB64*/
     /* TABLE MAPPING                                        @Z40LB64*/
     DCL MICPTR PTR(31);               /* MICT BASE POINTER  @Z40LB64*/
     DCL 1 MICTABLE BDY(WORD) BASED(MICPTR),
           3 *(16) CHAR(8),            /* MICT ENTRY         @Z40LB64*/
             5 MICMFID CHAR(5),        /* MANUFACTURER'S ID  @Z40LB64*/
             5 MICMPCPU FIXED(8),      /* CPUID OF OTHER     @Z40LB64
                                          CPU OF MP PAIR     @Z40LB64*/
             5 MICFLAG1 BIT(8),        /* MICT FLAGS         @Z40LB64*/
               7 *      BIT(1),        /* RESERVED           @Z40LB64*/
               7 MICPOTMP BIT(1),      /* POTENTIAL MP       @Z40LB64*/
               7 MICAPATH BIT(1),      /* ALTERNATE PATH     @Z40LB64*/
               7 *      BIT(3),        /* ZEROS              @Z40LB64*/
               7 MICINTF BIT(2),       /* CPU INTERFACE      @Z40LB64*/
             5 MICFLAG2 BIT(8),        /* MICT FLAGS         @Z40LB64*/
               7 MICVALID BIT(1),      /* MICT ENTRY VALID   @Z40LB64*/
               7 MICCURMP BIT(1),      /* CURRENT MP         @Z40LB64*/
               7 MICCMB   BIT(1),      /* COMMON MSG BUFFER  @Z40LB64*/
               7 *        BIT(3),      /* ZEROS              @Z40LB64*/
               7 MICAINTF BIT(2);      /* ALTERNATE INTRFACE @Z40LB64*/

     /* MASS STORAGE CONTROL CONFIGURATION DATA BLOCK        @Z40LB64*/
     /* MAPPING                                              @Z40LB64*/
     DCL CDBPTR PTR(31);               /* CDB BASE POINTER   @Z40LB64*/
     DCL CDBVUA#   FIXED(15);          /*INDEX TO CDB DATA   @Z40LB61
                                         FOR A GIVEN VUA#    @Z40LB61*/
     DCL 1 CDBLOCK BDY(WORD) BASED(CDBPTR),
           3 *(64) CHAR(4) BDY(WORD),  /* CDB ENTRY          @Z40LB64*/
             5 CDBSDG FIXED(8),        /* STAGING DRIVE      @Z40LB64*/
                                       /* GROUP (LOW 5 BITS) @Z40LB64*/
               7 CDBCNFIG BIT(8),      /* CONFIGURATION BITS @Z40LB64*/
                 9 CDBNOSHR BIT(1),    /* NOT SHARABLE       @Z40LB64*/
                 9 CDBINUSE BIT(1),    /* VUA IN USE         @Z40LB64*/
                 9 CDB3333  BIT(1),    /* LOGICAL 3333 ADDR  @Z40LB64*/
             5 CDBPATHS BIT(8),        /* ALTERNATE PATHS    @ZD00051*/
               7 * BIT(1),             /*RESERVED            @ZD00051*/
               7 CDBSA1B BIT(1),       /*SA-1 INTF-B PATH    @ZD00051*/
               7 CDBSA1C BIT(1),       /*SA-1 INTF-C PATH    @ZD00051*/
               7 CDBSA1D BIT(1),       /*SA-1 INTF-D PATH    @ZD00051*/
               7 * BIT(1),             /*RESERVED            @ZD00051*/
               7 CDBSA2B BIT(1),       /*SA-2 INTF-B PATH    @ZD00051*/
               7 CDBSA2C BIT(1),       /*SA-2 INTF-C PATH    @ZD00051*/
               7 CDBSA2D BIT(1),       /*SA-2 INTF-D PATH    @ZD00051*/
             5 CDBMVTP FIXED(16);      /*MVT POINTER         @ZD00051*/

     /* MASS STORAGE CONTROL CELL MAP CONTROL BLOCK MAPPING  @Z40LB64*/
     DCL CMCBPTR PTR(31);              /* CM CTL BLK PTR     @Z40LB64*/
     DCL 1 CMCTLBLK BDY(WORD) BASED(CMCBPTR),
           3 CMCFLAGS (22) BIT(8),     /* CUBE FLAGS         @Z40LB64*/
           3 CMCPTRS(175) FIXED(8);    /* CUBE POINTERS      @Z40LB64*/

     /* MASS STORAGE CONTROL CELL MAP ENTRY MAPPING          @Z40LB64*/
     DCL CMENTPTR PTR(31);             /* CELL MAP ENTRY PTR @Z40LB64*/
     DCL 1 CMENTRY BIT(8) BASED(CMENTPTR),
           3 CMX0Z0 BIT(1),            /* X=0, Z=0           @Z40LB64*/
           3 CMX0Z1 BIT(1),            /* X=0, Z=1           @Z40LB64*/
           3 CMX1Z0 BIT(1),            /* X=1, Z=0           @Z40LB64*/
           3 CMX1Z1 BIT(1),            /* X=1, Z=1           @Z40LB64*/
           3 CMX2Z0 BIT(1),            /* X=2, Z=0           @Z40LB64*/
           3 CMX2Z1 BIT(1),            /* X=2, Z=1           @Z40LB64*/
           3 CMX3Z0 BIT(1),            /* X=3, Z=0           @Z40LB64*/
           3 CMX3Z1 BIT(1);            /* X=3, Z=1           @Z40LB64*/
