         /************************************************************/
         /* REPAIRV I/O MAPPING MACRO -AMSDF66                       */
         /*                                                          */
         /* THE FOLLOWING STRUCTURE IS USED BY IDCRDRD  & REPAIRV    */
         /* TO DETERMINE THE LOCATION & READ RETURN CODES OF THE     */
         /* RECORDS ON A TRACK.                                      */
         /*                                                          */
         /* IT ALSO CONTAINS A SAVE AREA FOR THE COUNT FIELD AND     */
         /* LENGTH INFORMATION FOR EACH RECORD,IF REQUIRED           */
         /************************************************************/
         DCL 1 LOCTAB(125) BDY (WORD) BASED, /* LOC TABLE FOR READS  */
               2 LOCADDR PTR(31),            /* ENTRY ADDRESS        */
               2 LOCRCNT  FIXED(15),         /*RET CODE OF READ COUNT*/
               2 LOCRCKD FIXED(15),          /*RET CODE KEY/DATA RD  */
               2 LOCCNTFD CHAR(8),           /*SAVE AREA FOR COUNT   */
               2 * CHAR(1),                  /*SAVE AREA FOR COUNT   */
               2 LOCKLEN FIXED(8),           /*KEY LEN FOR SPACCR    */
               2 LOCDLEN FIXED(15);          /*DATA LEN FOR SPACCR   */
         DCL 1 RIOAREA BDY(WORD) BASED,
               2 RIOHDR,
               3 RFIRST     CHAR(1),     /* FIRST TIME INDICATOR    */
               3 *          CHAR(1),     /* RESERVED                */
               3 RPREV,                  /* PREVIOUS CCHHR          */
                   4 RPREVCC FIXED(15),  /* PREVIOUS CYLINDER ADDRESS*/
                   4 RPREVHH FIXED(15),  /* PREVIOUS READ ADDR       */
                   4 RPREVR  FIXED(8),   /* PREVIOUS RECORD NUMBER   */
                 3 *         CHAR(1),    /* RESERVED                 */
                 3 RNUMREC   FIXED(15),  /* NUM OR RECS TO READ      */
                 3 *         CHAR(16),   /* RESERVED FOR KEY AREA    */
                 3 *         CHAR(256),  /* RESERVED                 */
               2 RBUFF       CHAR(*);    /* BUFFER READ IN AREA      */
         DCL 1 RKEY BASED,               /* STRUCTURE FOR KEYAREA    */
               2 RKEYVOL     CHAR(6),    /* VOLID                    */
               2 RKEYCHR,                /* CCHHR                    */
                 3 RKEYCC  FIXED(15),    /* CYLINDER ADDRESS         */
                 3 RKEYHH  FIXED(15),    /* HEAD ADDRESS             */
                 3 RKEYR   FIXED(8),     /* RECORD NUMBER            */
               2 RKEYFLG,                /* FLAG BYTES               */
                 3 RKEYFLG1  CHAR(1),    /* FLAG BYTE ONE            */
                 3 RKEYFLG2  CHAR(2),    /* SECOND FLAGS             */
                 3 RKEYFLG3  CHAR(1),    /* THIRD FLAGS              */
                 3 *         CHAR(1);    /* RESERVED                 */
         DCL 1 RBUF BASED,               /* STRUC FOR RECS IN RBUFF  */
               2 RBUFCNT,                /* RECORD COUNT AREA        */
                 3 RBCCHHR,              /* CCHHR                    */
                   4 RBCC  FIXED(15),    /* CYLINDER ADDRESS         */
                   4 RBHH  FIXED(15),    /* HEAD ADDRESS             */
                   4 RBREC FIXED(8),     /* RECORD NUMBER            */
                 3 RBKL   FIXED(8),      /* KEY LENGTH               */
                 3 RBDL   FIXED(15),     /* DATA LENGTH              */
               2 RKEYDAT  CHAR(*);       /* KEY AND DATA AREA        */
         DCL 1 WIOAREA BASED BDY(WORD),
               2 WNUMREC FIXED(31),      /* NUM OF RECORDS TO WRITE  */
               2 WBUFF CHAR(*);          /* DATA AREAS FOR WRITES    */
         DCL 1 WBUF BASED,               /* STRUC WRITES FROM WBUFF  */
               2 WBUFCNT,                /* RECORD COUNT AREA        */
                 3 WBCCHHR,              /* CCHHR                    */
                   4 WBCC  FIXED(15),    /* CYLINDER ADDRESS         */
                   4 WBHH  FIXED(15),    /* HEAD ADDRESS             */
                   4 WBREC FIXED(8),     /* RECORD NUMBER            */
                 3 WBKL  FIXED(8),       /* KEY LENGTH               */
                 3 WBDL  FIXED(15),      /* DATA LENGTH              */
               2 WKEYDAT CHAR(*);        /* KEY AND DATA BUFFER      */
