* /* START OF SPECIFICATIONS****
*01* PROCESSOR = ASSEM
**** END OF SPECIFICATIONS **                                        */
         TITLE '***** IDCRILT: VERB/DESCRIPTOR MODULE TABLE'   @Y30LSBE
*/********************************************************************/
*/*                                                                  */
*/*  MODULE NAME - IDCRILT                                           */
*/*                                                                  */
*/*  DESCRIPTIVE NAME - IDCAMS VERB/DESCRIPTOR LOAD MODULE TABLE     */
*/*                                                                  */
*/*  COPYRIGHT - NONE                                                */
*/*                                                                  */
*/*  STATUS - RELEASE 3, LEVEL 0                             @ZA07563*/
*/*                                                                  */
*/*  FUNCTION - THIS TABLE IS LOADED DURING READER/INTERPRETER       */
*/*             INITIALIZATION, ALONG WITH IDCRIMT (IF MSS   @ZA07563*/
*/*             IS PRESENT) AND IDCRIFF, TO BE USED          @ZA07563*/
*/*             TO DETERMINE THE VALIDITY OF EACH INPUT      @ZA07563*/
*/*             COMMAND VERB AND IF A VALID VERB, TO LOAD    @ZA07563*/
*/*             THE CORRESPONDING COMMAND DESCRIPTOR MODULE TO       */
*/*             PROCESS THE REMAINDER OF THE INPUT COMMAND.          */
*/*             THIS TABLE CONSISTS OF VERB/DESCRIPTOR LOADNAME      */
*/*             ENTRIES. EACH ENTRY CONSISTS OF AN 8-CHARACTER       */
*/*             VERB NAME FOLLOWED BY THE 8-CHARACTER LOAD MODULE    */
*/*             NAME OF THE CORRESPONDING COMMAND DESCRIPTOR (USED   */
*/*             IN PROCESSING THE INPUT COMMAND).                    */
*/*                                                                  */
*/*  NOTES -                                                         */
*/*                                                                  */
*/*     DEPENDENCIES - THE CHARACTER CODES CONTAINED IN THIS TABLE   */
*/*                    MUST MATCH THOSE OF THE INPUT COMMAND.        */
*/*                    THE CURRENT CHARACTER CODE IS 'EBCDIC'        */
*/*                                                                  */
*/*     RESTRICTIONS - N/A                                           */
*/*                                                                  */
*/*     REGISTER CONVENTIONS - N/A                                   */
*/*                                                                  */
*/*     PATCH LABEL - N/A                                            */
*/*                                                                  */
*/*  MODULE TYPE - TABLE                                             */
*/*                                                                  */
*/*     PROCESSOR - ASSEMBLER                                        */
*/*                                                                  */
*/*     MODULE SIZE - 480 DECIMAL BYTES                      @ZA07563*/
*/*                                                                  */
*/*     ATTRIBUTES - READ ONLY                                       */
*/*                                                                  */
*/*  ENTRY POINT - N/A                                               */
*/*                                                                  */
*/*     PURPOSE - N/A                                                */
*/*                                                                  */
*/*     LINKAGE - N/A                                                */
*/*                                                                  */
*/*  INPUT - N/A                                                     */
*/*                                                                  */
*/*  OUTPUT - N/A                                                    */
*/*                                                                  */
*/*  EXIT NORMAL - N/A                                               */
*/*                                                                  */
*/*  EXIT ERROR - N/A                                                */
*/*                                                                  */
*/*  EXTERNAL REFERENCES - N/A                                       */
*/*                                                                  */
*/*     ROUTINES - N/A                                               */
*/*                                                                  */
*/*     DATA AREAS - N/A                                             */
*/*                                                                  */
*/*     CONTROL BLOCKS - N/A                                         */
*/*                                                                  */
*/*  TABLES - N/A                                                    */
*/*                                                                  */
*/*  MACROS - N/A                                                    */
*/*                                                                  */
*/*  CHANGE ACTIVITY - MSS COMMANDS ADDED                    @ZA04614*/
*/*                    RESETCAT COMMANDS ADDED               @Z30PSFY*/
*/*                    MSS REL.2 COMMANDS ADDED              @Z30LSBS*/
*/*                    PAIRS CONSTANT UPDATED                @ZM40486*/
*/*                    IDCRILT SPLIT                         @ZA07563*/
*/*                                                                  */
*/********************************************************************/
IDCRILT  CSECT
         DC    CL8'PARM'               COMMAND VERB NAME
         DC    CL8'IDCCDPM'            DESCRIPTOR FOR ABOVE COMMAND
         DC    CL8'PRINT'              COMMAND VERB NAME
         DC    CL8'IDCCDPR'            DESCRIPTOR FOR ABOVE COMMAND
         DC    CL8'REPRO'              COMMAND VERB NAME
         DC    CL8'IDCCDRP'            DESCRIPTOR FOR ABOVE COMMAND
         DC    CL8'DELETE'             COMMAND VERB NAME
         DC    CL8'IDCCDDL'            DESCRIPTOR FOR ABOVE COMMAND
         DC    CL8'DEL'                COMMAND VERB NAME
         DC    CL8'IDCCDDL'            DESCRIPTOR FOR ABOVE COMMAND
         DC    CL8'DEFINE'             COMMAND VERB NAME
         DC    CL8'IDCCDDE'            DESCRIPTOR FOR ABOVE COMMAND
         DC    CL8'DEF'                COMMAND VERB NAME
         DC    CL8'IDCCDDE'            DESCRIPTOR FOR ABOVE COMMAND
         DC    CL8'ALTER'              COMMAND VERB NAME
         DC    CL8'IDCCDAL'            DESCRIPTOR FOR ABOVE COMMAND
         DC    CL8'IMPORT'             COMMAND VERB NAME
         DC    CL8'IDCCDMP'            DESCRIPTOR FOR ABOVE COMMAND
         DC    CL8'IMP'                COMMAND VERB NAME
         DC    CL8'IDCCDMP'            DESCRIPTOR FOR ABOVE COMMAND
         DC    CL8'EXPORT'             COMMAND VERB NAME
         DC    CL8'IDCCDXP'            DESCRIPTOR FOR ABOVE COMMAND
         DC    CL8'EXP'                COMMAND VERB NAME
         DC    CL8'IDCCDXP'            DESCRIPTOR FOR ABOVE COMMAND
         DC    CL8'LISTCAT'            COMMAND VERB NAME
         DC    CL8'IDCCDLC'            DESCRIPTOR FOR ABOVE COMMAND
         DC    CL8'LISTC'              COMMAND VERB NAME
         DC    CL8'IDCCDLC'            DESCRIPTOR FOR ABOVE COMMAND
         DC    CL8'VERIFY'             COMMAND VERB NAME
         DC    CL8'IDCCDVY'            DESCRIPTOR FOR ABOVE COMMAND
         DC    CL8'VFY'                COMMAND VERB NAME
         DC    CL8'IDCCDVY'            DESCRIPTOR FOR ABOVE COMMAND
         DC    CL8'CNVTCAT'            COMMAND VERB NAME
         DC    CL8'IDCCDCC'            DESCRIPTOR FOR ABOVE COMMAND
         DC    CL8'CNVTC'              COMMAND VERB NAME
         DC    CL8'IDCCDCC'            DESCRIPTOR FOR ABOVE COMMAND
         DC    CL8'CHKLIST'            COMMAND VERB NAME       @Y30LSBE
         DC    CL8'IDCCDCK'            DESCRIPTOR FOR ABOVE    @Y30LSBE
         DC    CL8'CKLST'              COMMAND VERB NAME       @Y30LSBE
         DC    CL8'IDCCDCK'            DESCRIPTOR FOR ABOVE    @Y30LSBE
         DC    CL8'BLDINDEX'           COMMAND VERB NAME       @Y30SSBE
         DC    CL8'IDCCDBI'            DESCRIPTOR FOR ABOVE    @Y30SSBE
         DC    CL8'BIX'                COMMAND VERB NAME       @Y30SSBE
         DC    CL8'IDCCDBI'            DESCRIPTOR FOR ABOVE    @Y30SSBE
         DC    CL8'EXPORTRA'           COMMAND VERB NAME       @Y30SSBE
         DC    CL8'IDCCDRC'            DESCRIPTOR FOR ABOVE    @Y30SSBE
         DC    CL8'XPRA'               COMMAND VERB NAME       @Y30SSBE
         DC    CL8'IDCCDRC'            DESCRIPTOR FOR ABOVE    @Y30SSBE
         DC    CL8'LISTCRA'            COMMAND VERB NAME       @Y30SSBE
         DC    CL8'IDCCDLR'            DESCRIPTOR FOR ABOVE    @Y30SSBE
         DC    CL8'LISTR'              COMMAND VERB NAME       @Y30SSBE
         DC    CL8'IDCCDLR'            DESCRIPTOR FOR ABOVE    @Y30SSBE
         DC    CL8'IMPORTRA'           COMMAND VERB NAME       @Y30SSBE
         DC    CL8'IDCCDRM'            DESCRIPTOR FOR ABOVE    @Y30SSBE
         DC    CL8'MPRA'               COMMAND VERB NAME       @Y30SSBE
         DC    CL8'IDCCDRM'            DESCRIPTOR FOR ABOVE    @Y30SSBE
         DC    CL8'RESETCAT'           COMMAND VERB NAME       @Z30PSFY
         DC    CL8'IDCCDRS'            DESCRIPTOR FOR ABOVE    @Z30PSFY
         DC    CL8'RCAT'               COMMAND VERB NAME       @Z30PSFY
         DC    CL8'IDCCDRS'            DESCRIPTOR FOR ABOVE    @Z30PSFY
         END   IDCRILT
