* /* START OF SPECIFICATIONS****
*01* PROCESSOR = ASSEM
**** END OF SPECIFICATIONS **                                        */
         TITLE '***** IDCRIMT: MSS VERB/DESCRIPTOR MODULE TABLE *****'
*/********************************************************************/
*/*                                                                  */
*/*  MODULE NAME - IDCRIMT                                           */
*/*                                                                  */
*/*  DESCRIPTIVE NAME - IDCAMS MSS VERB/DESCRIPTOR LOAD MODULE TABLE */
*/*                                                                  */
*/*  COPYRIGHT - NONE                                                */
*/*                                                                  */
*/*  STATUS - RELEASE 3, LEVEL 0                                     */
*/*                                                                  */
*/*  FUNCTION - THIS TABLE IS LOADED DURING READER/INTERPRETER       */
*/*             INITIALIZATION TO BE USED TO DETERMINE THE VALIDITY  */
*/*             OF EACH MSS INPUT COMMAND VERB AND IF A VALID VERB,  */
*/*             TO LOAD THE CORRESPONDING MSS COMMAND DESCRIPTOR     */
*/*             MODULE TO PROCCESS THE REMAINDER OF THE INPUT        */
*/*             COMMAND. THIS TABLE CONSISTS OF VERB/DESCRIPTOR      */
*/*             LOADNAME ENTRIES FOR EACH MSS COMMAND.               */
*/*             EACH ENTRY CONSISTS OF AN 8-CHARACTER VERB NAME      */
*/*             AND THE 8-CHARACTER LOAD MODULE                      */
*/*             NAME OF THE CORRESPONDING COMMAND DESCRIPTOR (USED   */
*/*             IN PROCESSING THE INPUT COMMAND).                    */
*/*             THIS MODULE IS INCLUDED IN THE IDCRILT LOAD MODULE   */
*/*             IF AN MSS WAS SPECIFIED AT SYSGEN TIME. IDCRIMT      */
*/*             CONTAINS THE VERB NAME AND THE COMMAND DESCRIPTOR    */
*/*             LOAD MODULE NAME FOR EACH MSS COMMAND VERB.          */
*/*                                                                  */
*/*  NOTES -                                                         */
*/*                                                                  */
*/*     DEPENDENCIES - THE CHARACTER CODES CONTAINED IN THIS TABLE   */
*/*                    MUST MATCH THOSE OF THE INPUT COMMAND.        */
*/*                    THE CURRENT CHARACTER CODE IS 'EBCDIC'        */
*/*                                                                  */
*/*     RESTRICTIONS - N/A                                           */
*/*                                                                  */
*/*     REGISTER CONVENTIONS - N/A                                   */
*/*                                                                  */
*/*     PATCH LABEL - N/A                                            */
*/*                                                                  */
*/*  MODULE TYPE - TABLE                                             */
*/*                                                                  */
*/*     PROCESSOR - ASSEMBLER                                        */
*/*                                                                  */
*/*     MODULE SIZE -  704 DECIMAL BYTES                             */
*/*                                                                  */
*/*     ATTRIBUTES - READ ONLY                                       */
*/*                                                                  */
*/*  ENTRY POINT - N/A                                               */
*/*                                                                  */
*/*     PURPOSE - N/A                                                */
*/*                                                                  */
*/*     LINKAGE - N/A                                                */
*/*                                                                  */
*/*  INPUT - N/A                                                     */
*/*                                                                  */
*/*  OUTPUT - N/A                                                    */
*/*                                                                  */
*/*  EXIT NORMAL - N/A                                               */
*/*                                                                  */
*/*  EXIT ERROR - N/A                                                */
*/*                                                                  */
*/*  EXTERNAL REFERENCES - N/A                                       */
*/*                                                                  */
*/*     ROUTINES - N/A                                               */
*/*                                                                  */
*/*     DATA AREAS - N/A                                             */
*/*                                                                  */
*/*     CONTROL BLOCKS - N/A                                         */
*/*                                                                  */
*/*  TABLES - N/A                                                    */
*/*                                                                  */
*/*  MACROS - N/A                                                    */
*/*                                                                  */
*/*  CHANGE ACTIVITY - OZ11014                                       */
*/*     @G24LB40 - MODIFYC AND MODC VERBS ADDED 8/9/76               */
*/********************************************************************/
IDCRIMT  CSECT
         DC    CL8'CREATEV'            VERB NAME               @Y30LSBE
         DC    CL8'IDCCDCV'            COMMAND DESCRIPTOR      @Y30LSBE
         DC    CL8'CRV'                VERB NAME               @Y30LSBE
         DC    CL8'IDCCDCV'            COMMAND DESCRIPTOR      @Y30LSBE
         DC    CL8'MODIFYV'            VERB NAME               @Y30LSBE
         DC    CL8'IDCCDMV'            COMMAND DESCRIPTOR      @Y30LSBE
         DC    CL8'MODV'               VERB NAME               @Y30LSBE
         DC    CL8'IDCCDMV'            COMMAND DESCRIPTOR      @Y30LSBE
         DC    CL8'COPYV'              VERB NAME               @Y30LSBE
         DC    CL8'IDCCDCO'            COMMAND DESCRIPTOR      @Y30LSBE
         DC    CL8'RECOVERV'           VERB NAME               @Y30LSBE
         DC    CL8'IDCCDRV'            COMMAND DESCRIPTOR      @Y30LSBE
         DC    CL8'RECV'               VERB NAME               @Y30LSBE
         DC    CL8'IDCCDRV'            COMMAND DESCRIPTOR      @Y30LSBE
         DC    CL8'ADDV'               VERB NAME               @Y30LSBE
         DC    CL8'IDCCDAV'            COMMAND DESCRIPTOR      @Y30LSBE
         DC    CL8'STOREV'             VERB NAME               @Y30LSBE
         DC    CL8'IDCCDSR'            COMMAND DESCRIPTOR      @Y30LSBE
         DC    CL8'CONVERTV'           VERB NAME               @Y30LSBE
         DC    CL8'IDCCDCN'            COMMAND DESCRIPTOR      @Y30LSBE
         DC    CL8'CONV'               VERB NAME               @Y30LSBE
         DC    CL8'IDCCDCN'            COMMAND DESCRIPTOR      @Y30LSBE
         DC    CL8'SCRATCHV'           VERB NAME               @Y30LSBE
         DC    CL8'IDCCDSV'            COMMAND DESCRIPTOR      @Y30LSBE
         DC    CL8'SCRV'               VERB NAME               @Y30LSBE
         DC    CL8'IDCCDSV'            COMMAND DESCRIPTOR      @Y30LSBE
         DC    CL8'EJECTV'             VERB NAME               @Y30LSBE
         DC    CL8'IDCCDEV'            COMMAND DESCRIPTOR      @Y30LSBE
         DC    CL8'REMOVEVR'           VERB NAME               @Y30LSBE
         DC    CL8'IDCCDRR'            COMMAND DESCRIPTOR      @Y30LSBE
         DC    CL8'REMVR'              VERB NAME               @Y30LSBE
         DC    CL8'IDCCDRR'            COMMAND DESCRIPTOR      @Y30LSBE
         DC    CL8'EJECTC'             VERB NAME               @Y30LSBE
         DC    CL8'IDCCDEC'            COMMAND DESCRIPTOR      @Y30LSBE
         DC    CL8'REPLACEC'           VERB NAME               @Y30LSBE
         DC    CL8'IDCCDRL'            COMMAND DESCRIPTOR      @Y30LSBE
         DC    CL8'REPC'               VERB NAME               @Y30LSBE
         DC    CL8'IDCCDRL'            COMMAND DESCRIPTOR      @Y30LSBE
         DC    CL8'CREATEG'            VERB NAME               @Y30LSBE
         DC    CL8'IDCCDGR'            COMMAND DESCRIPTOR      @Y30LSBE
         DC    CL8'CRG'                VERB NAME               @Y30LSBE
         DC    CL8'IDCCDGR'            COMMAND DESCRIPTOR      @Y30LSBE
         DC    CL8'MODIFYG'            VERB NAME               @Y30LSBE
         DC    CL8'IDCCDMG'            COMMAND DESCRIPTOR      @Y30LSBE
         DC    CL8'MODG'               VERB NAME               @Y30LSBE
         DC    CL8'IDCCDMG'            COMMAND DESCRIPTOR      @Y30LSBE
         DC    CL8'SCRATCHG'           VERB NAME               @Y30LSBE
         DC    CL8'IDCCDSG'            COMMAND DESCRIPTOR      @Y30LSBE
         DC    CL8'SCRG'               VERB NAME               @Y30LSBE
         DC    CL8'IDCCDSG'            COMMAND DESCRIPTOR      @Y30LSBE
         DC    CL8'LISTMSF'            VERB NAME               @Y30LSBE
         DC    CL8'IDCCDLM'            COMMAND DESCRIPTOR      @Y30LSBE
         DC    CL8'LISTMSVI'           VERB NAME               @Y30LSBE
         DC    CL8'IDCCDLV'            COMMAND DESCRIPTOR      @Y30LSBE
         DC    CL8'TRACE'              VERB NAME               @Y30LSBE
         DC    CL8'IDCCDTR'            COMMAND DESCRIPTOR      @Y30LSBE
         DC    CL8'TUNE'               VERB NAME               @Y30LSBE
         DC    CL8'IDCCDTU'            COMMAND DESCRIPTOR      @Y30LSBE
         DC    CL8'COPYT'              COMMAND VERB NAME       @ZA04614
         DC    CL8'IDCCDCT'            DESCRIPTOR FOR ABOVE    @ZA04614
         DC    CL8'DUMPMSS'            COMMAND VERB NAME       @ZA04614
         DC    CL8'IDCCDDU'            DESCRIPTOR FOR ABOVE    @ZA04614
         DC    CL8'NULLIFYC'           COMMAND VERB NAME       @ZA04614
         DC    CL8'IDCCDNC'            DESCRIPTOR FOR ABOVE    @ZA04614
         DC    CL8'NULLC'              COMMAND VERB NAME       @ZA04614
         DC    CL8'IDCCDNC'            DESCRIPTOR FOR ABOVE    @ZA04614
         DC    CL8'SWAPT'              COMMAND VERB NAME       @ZA04614
         DC    CL8'IDCCDST'            DESCRIPTOR FOR ABOVE    @ZA04614
         DC    CL8'LISTDSET'           COMMAND VERB NAME       @Z30LSBS
         DC    CL8'IDCCDLD'            DESCRIPTOR FOR ABOVE    @Z30LSBS
         DC    CL8'AUDITMSS'           COMMAND VERB NAME       @Z30LSBS
         DC    CL8'IDCCDAU'            DESCRIPTOR FOR ABOVE    @Z30LSBS
         DC    CL8'CHECKMSS'           COMMAND VERB NAME       @Z30LSBS
         DC    CL8'IDCCDCH'            DESCRIPTOR FOR ABOVE    @Z30LSBS
         DC    CL8'COMPARET'           COMMAND VERB NAME       @Z30LSBS
         DC    CL8'IDCCDCP'            DESCRIPTOR FOR ABOVE    @Z30LSBS
         DC    CL8'CMPT'               COMMAND VERB NAME       @Z30LSBS
         DC    CL8'IDCCDCP'            DESCRIPTOR FOR ABOVE    @Z30LSBS
         DC    CL8'SCRDSET'            COMMAND VERB NAME       @Z30LSBS
         DC    CL8'IDCCDSD'            DESCRIPTOR FOR ABOVE    @Z30LSBS
         DC    CL8'REPAIRV'            COMMAND VERB NAME       @OZ11014
         DC    CL8'IDCCDRD'            DESCRIPTOR FOR ABOVE    @OZ11014
         DC    CL8'REPV'               COMMAND VERB NAME       @OZ11014
         DC    CL8'IDCCDRD'            DESCRIPTOR FOR ABOVE    @OZ11014
         DC    CL8'MODIFYC'            COMMAND VERB NAME       @G24LB40
         DC    CL8'IDCCDMC'            DESCRIPTOR FOR ABOVE    @G24LB40
         DC    CL8'MODC'               COMMAND VERB NAME       @G24LB40
         DC    CL8'IDCCDMC'            DESCRIPTOR FOR ABOVE    @G24LB40
         END
