* /* START OF SPECIFICATIONS ****                            @Y30SSJH
*
*01*  MODULE-NAME = IDCTSAL0
*01*  MODULE-TYPE = MODULE
*02*    PROCESSOR = ASSEMBLER
*
**** END OF SPECIFICATIONS **                                @Y30SSJH*/
         TITLE '***** IDCTSAL0 - ALTER STATIC TEXT MODULE *****'
**********************************************************************
*                                                                    *
* MODULE NAME - IDCTSAL0 - STATIC TEXT MODULE FOR ALTER              *
*                                                                    *
* DESCRIPTIVE NAME - STATIC TEXT MODULE FOR THE FUNCTION ALTER       *
*                                                                    *
* COPYRIGHT - NONE                                                   *
*                                                                    *
* STATUS - RELEASE 2  LEVEL 0                                        *
* CHANGES FOR RELEASE 3                                        @Z40RSSA
*     MODIFY   TXT23.                                          @Z40RSSA
*                                                                    *
* FUNCTION - CONTAINS NO EXECUTIBLE CODE, ONLY STATIC TEXT ENTRIES   *
*        FOR THE FUNCTION ALTER                                      *
*        THIS MODULE IS LOADED BY IDCTP05 WHEN A STATIC TEXT         *
*        REQUEST IS MADE.                                            *
*                                                                    *
* NOTES - NONE                                                       *
*                                                                    *
*    DEPENDENCIES - NONE                                             *
*    RESTRICTIONS - NONE                                             *
*    REGISTER CONVENTIONS - NA                                       *
*    PATCH AREA - NA                                                 *
*                                                                    *
* MODULE TYPE - TABLES                                               *
*                                                                    *
*    PROCESSOR - ASSEMBLER                                           *
*    MODULE SIZE - 2050 BYTES                                  @ZA05940
*    ATTRIBUTES - READ-ONLY                                          *
*                                                                    *
*  ENTRY POINT - NA                                                  *
*                                                                    *
*  EXIT NORMAL - NA                                                  *
*                                                                    *
*  EXIT ERROR - NA                                                   *
*                                                                    *
*  EXTERNAL REFERENCES - NA                                          *
*                                                                    *
*  TABLES - NA                                                       *
*                                                                    *
*  MACROS - NA                                                       *
*                                                                    *
**********************************************************************
*
*********************************************************************
*                                                                    *
* THIS MODULE IS THE FIRST MODULE OF STATIC TEXT REQUIRED BY THE     *
* ALTER FUNCTION SUB-ROUTINES.                                       *
*                                                                    *
*********************************************************************
*                                                                    *
IDCTSAL0 CSECT
*
* THIS SECTION CONTAINS THE INDICES TO REACH AN ENTRY.               *
*
INDEX    DC  H'24'                     COUNT OF ENTRIES.       @ZA05940
INDEX1   DC  Y(TXT1-INDEX)             ALLOCATION STATUS
INDEX2   DC  Y(TXT2-INDEX)             BAD GENERIC COMBINATION
INDEX3   DC  Y(TXT3-INDEX)             UNABLE TO LOCATE MODEL.
INDEX4   DC  Y(TXT4-INDEX)             PASSWORD SUPPRESSION MODEL
INDEX5   DC  Y(TXT5-INDEX)             NEWNAME IS INVALID
INDEX6   DC  Y(TXT6-INDEX)             NOT SAME PDS
INDEX7   DC  Y(TXT7-INDEX)             ENTRY ALTERED
INDEX8   DC  Y(TXT8-INDEX)             ENTRY NOT ALTERED
INDEX9   DC  Y(TXT9-INDEX)             MEMBER SPEC W GENERIC
INDEX10  DC  Y(TXT10-INDEX)            PDS MEMBER NOT RENAMED
INDEX11  DC  Y(TXT11-INDEX)            PDS MEMBER RENAMED
INDEX12  DC  Y(TXT12-INDEX)            INVALID AIX PARMS       @Y30SSJH
INDEX13  DC  Y(TXT13-INDEX)            UNIQUEKEY/UPGRADE ERROR @Y30SSJH
INDEX14  DC  Y(TXT14-INDEX)            KEYS/RECORDSIZE  ERROR  @Y30SSJH
INDEX15  DC  Y(TXT15-INDEX)            CI SIZE CONFLICT        @Y30SSJH
INDEX16  DC  Y(TXT16-INDEX)            BASE CLUSTER CONFLICT   @Y30SSJH
INDEX17  DC  Y(TXT17-INDEX)            RELATIVE REC. ERROR     @Y30SSJH
INDEX18  DC  Y(TXT18-INDEX)            INVALID KEY/REC VALUES  @Y30SSJH
INDEX19  DC  Y(TXT19-INDEX)            INVALID KEY/REC VALUES  @Y30SSJH
INDEX20  DC  Y(TXT20-INDEX)            INVALID KEY/REC VALUES  @Y30SSJH
INDEX21  DC  Y(TXT21-INDEX)            KEY-RECORDSIZE CONFLICT @Y30SSJH
INDEX22  DC  Y(TXT22-INDEX)            INVALID ENTRY TYPE      @Y30SSJH
INDEX23  DC  Y(TXT23-INDEX)            PASSWORD INSUFFICIENT   @Y30SSJH
INDEX24  DC  Y(TXT24-INDEX)            INCONSISTENT PARAMETER  @ZA05940
         EJECT
*********************************************************************
*                                                                    *
* THIS SECTION CONTAINS THE ENTRIES.
*
**********************************************************************
*                                                                    *
* ALTERED ALLOCATION STATUS FOR MOLUME NNNNNN IS NNN
*                                                                    *
TXT1     DC  Y(TXT1B-TXT1A)            ENTRY LENGTH.
         DC  X'8000'                   MESSAGE FLAG.
* SPACING CONTROL SUB-STRUCTURE.
TXT1A    DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
         DC  H'2'                      SPACING FACTOR.
         DC  C'R '                     SPACING TYPE.
* REDO SUB-STRUCTURE.
         DC  X'0800'                   REDO FLAG.
         DC  H'1'                      REFERENCE NUMBER.
         DC  H'3'                      STRUCTURE COUNT.
         DC  H'8'                      INPUT OFFSET.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'8400'                   STATIC & EOF FLAG.
         DC  Y(STE11B-STE11A)          STATIC TEXT LENGTH.
         DC  Y(STE11A-TXT1A)           STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE11B-STE11A)          PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* BLOCK DATA SUB-STRUCTURE.
         DC  X'1000'                   BLOCK DATA FLAG.
         DC  H'6'                      INPUT DATA LENGTH.
         DC  H'2'                      INPUT DATA OFFSET.
         DC  H'47'                     PRINT COLUMN.
         DC  H'6'                      PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* BLOCK DATA SUB-STRUCTURE.
         DC  X'9000'                   BLOCK & EOF FLAGS.
         DC  H'1'                      INPUT DATA LENGTH.
         DC  H'0'                      INPUT DATA OFFSET.
         DC  H'57'                     PRINT COLUMN.
         DC  H'3'                      PRINT FIELD LENGTH.
         DC  X'1060'                   CONVERSION FLAGS.  (BD,AL,SS)
* STATIC TEXT ENTRIES.
STE11A   DC  C'IDC0526I ALTERED ALLOCATION STATUS FOR VOLUME'
         DC  C'        IS'
STE11B   EQU *
TXT1B    EQU *
         EJECT
*                                                                    *
* INVALID USE OF * WITH NEWNAME AND ENTRYNAME.
*                                                                    *
TXT2     DC  Y(TXT2B-TXT2A)            ENTRY LENGTH.
         DC  X'8000'                   MESSAGE FLAG.
* SPACING CONTROL SUB-STRUCTURE.
TXT2A    DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
         DC  H'2'                      SPACING FACTOR.
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'8400'                   STATIC & EOF FLAG.
         DC  Y(STE21B-STE21A)          STATIC TEXT LENGTH.
         DC  Y(STE21A-TXT2A)           STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE21B-STE21A)          PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* STATIC TEXT ENTRY.
STE21A   DC  C'IDC3536I INVALID USE OF * WITH THE '
         DC  C'NEWNAME PARAMETER'
STE21B   EQU *
TXT2B    EQU *
         EJECT
*                                                                    *
* ALTER WAS UNABLE TO LOCATE THE MODEL ENTRY.
*                                                                    *
TXT3     DC  Y(TXT3B-TXT3A)            ENTRY LENGTH.
         DC  X'8000'                   MESSAGE FLAG.
* SPACING CONTROL SUB-STRUCTURE.
TXT3A    DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
         DC  H'2'                      SPACING FACTOR.
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'8400'                   STATIC & EOF FLAG.
         DC  Y(STE31B-STE31A)          STATIC TEXT LENGTH.
         DC  Y(STE31A-TXT3A)           STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE31B-STE31A)          PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* STATIC TEXT ENTRY.
STE31A   DC  C'IDC3527I ALTER WAS UNABLE TO LOCATE THE '
         DC  C'OBJECT TO BE MODIFIED'
STE31B   EQU *
TXT3B    EQU *
         EJECT
*                                                                    *
* THE OBJECT TO BE MODIFIED IS PASSWORD SUPPRESSED.
*                                                                    *
TXT4     DC  Y(TXT4B-TXT4A)            ENTRY LENGTH.
         DC  X'8000'                   MESSAGE FLAG.
* SPACING CONTROL SUB-STRUCTURE.
TXT4A    DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
         DC  H'2'                      SPACING FACTOR.
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'8400'                   STATIC & EOF FLAG.
         DC  Y(STE41B-STE41A)          STATIC TEXT LENGTH.
         DC  Y(STE41A-TXT4A)           STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE41B-STE41A)          PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* STATIC TEXT ENTRY.
STE41A   DC  C'IDC3528I THE OBJECT TO BE MODIFIED IS PASSWORD '
         DC  C'SUPPRESSED'
STE41B   EQU *
TXT4B    EQU *
         EJECT
*
* NAME CREATED FROM GENERIC NEWNAME IS TOO LONG
*
TXT5     DC  Y(TXT5B-TXT5A)            ENTRY LENGTH.
         DC  X'8000'                   MESSAGE FLAG.
* SPACING CONTROL SUB-STRUCTURE.
TXT5A    DC  X'4000'                   SPACE CONTROL FLAG.
         DC  H'2'                      SPACING FACTOR.
         DC  C'R '                     SPACINT TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'8400'                   STATIC TEXT SUB-STRUCTURE.
         DC  Y(STE51B-STE51A)          STATIC TEXT LENGTH.
         DC  Y(STE51A-TXT5A)           STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE51B-STE51A)          PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* STATIC TEXT ENTRIES.
STE51A   DC  C'IDC3529I NAME CREATED FROM GENERIC NEWNAME IS LONGER'
         DC  C' THAN 44 CHARACTERS'
STE51B   EQU *
TXT5B    EQU *
         EJECT
*
* ENTRY AND NEWNAME PDS NAMES MUST BE THE SAME
*
TXT6     DC  Y(TXT6B-TXT6A)            ENTRY LENGTH.
         DC  X'8000'                   MESSAGE FLAG.
* SPACING CONTROL SUB-STRUCTURE.
TXT6A    DC  X'4000'                   SPACE CONTROL FLAG.
         DC  H'2'                      SPACING FACTOR.
         DC  C'R '                     SPACINT TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'8400'                   STATIC TEXT SUB-STRUCTURE.
         DC  Y(STE61B-STE61A)          STATIC TEXT LENGTH.
         DC  Y(STE61A-TXT6A)           STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE61B-STE61A)          PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* STATIC TEXT ENTRIES.
STE61A   DC  C'IDC3530I ENTRY AND NEWNAME PDS NAMES MUST BE THE'
         DC  C' SAME'
STE61B   EQU *
TXT6B    EQU *
         EJECT
*
* ENTRY ALTERED
*
TXT7     DC  Y(TXT7B-TXT7A)            ENTRY LENGTH.
         DC  X'8000'                   MESSAGE FLAG.
* SPACING CONTROL SUB-STRUCTURE.
TXT7A    DC  X'4000'                   SPACE CONTROL FLAG.
         DC  H'2'                      SPACING FACTOR.
         DC  C'R '                     SPACINT TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC TEXT SUB-STRUCTURE.
         DC  Y(STE71B-STE71A)          STATIC TEXT LENGTH.
         DC  Y(STE71A-TXT7A)           STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE71B-STE71A)          PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* BLOCK DATA SUB-STRUCTURE.
         DC  X'1000'                   BLOCK DATA FLAGS.
         DC  H'44'                     INPUT LENGTH.
         DC  H'0'                      INPUT OFFSET.
         DC  H'16'                     PRINT COLUMN.
         DC  H'44'                     PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* STATIC TEXT SUB-STRUCTURE.
         DC  X'8400'                   EOF & STATIC DATA FLAGS.
         DC  Y(STE72B-STE72A)          STATIC TEXT LENGTH.
         DC  Y(STE72A-TXT7A)           STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE72B-STE72A)          PRINT FIELD LENGTH.
         DC  X'0010'                   CONVERSION FLAGS.  (CHAR,BS)
* STATIC TEXT ENTRIES.
STE71A   DC  C'IDC0531I ENTRY'
STE71B   EQU *
STE72A   DC  C'ALTERED'
STE72B   EQU *
TXT7B    EQU *
         EJECT
*
* NO ENTRIES ALTERED.
*
TXT8     DC  Y(TXT8B-TXT8A)            ENTRY LENGTH.
         DC  X'A000'                   MESSAGE FLAG.
* STATIC TEXT SUBSTRUCTURE.
TXT8A    DC  X'0400'                   STATIC FLAG
         DC  Y(STE81B-STE81A)          STATIC TEXT LENGTH
         DC  Y(STE81A-TXT8A)           STATIC TEXT OFFSET
         DC  H'1'                      PRINT COLUMN
         DC  Y(STE81B-STE81A)          PRINT FIELD LENGTH
         DC  H'0'                      CONVERSION FLAGS  (CHAR)
* BLOCK DATA SUB-STRUCTURE.
         DC  X'1000'                   BLOCK DATA FLAG.
         DC  H'44'                     INPUT FIELD LENGTH.
         DC  H'0'                      INPUT OFFSET.
         DC  H'18'                     PRINT COLUMN.
         DC  H'44'                     PRINT FIELD LENGTH.
         DC  H'0'                      COMVERSION FLAGS.  (CHAR)
* STATIC TEXT SUB-STRUCTURE.
         DC  X'8400'                   STATIC TEXT & EOF FLAGS.
         DC  Y(STE82B-STE82A)          STATIC TEXT LENGTH.
         DC  Y(STE82A-TXT8A)           STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE82B-STE82A)          PRINT FIELD LENGTH.
         DC  X'0010'                   CONVERSION FLAGS. (CHAR)
* STATIC TEXT ENTRY.
STE81A   DC  C'IDC0532I **ENTRY'
STE81B   EQU *
STE82A   DC  C'NOT ALTERED'
STE82B   EQU *
TXT8B    EQU *
         EJECT
*
* MEMBER CAN NOT BE SPECIFIED WITH A GENERIC NAME
*
TXT9     DC  Y(TXT9B-TXT9A)            ENTRY LENGTH.
         DC  X'8000'                   MESSAGE FLAG.
* SPACING CONTROL SUB-STRUCTURE.
TXT9A    DC  X'4000'                   SPACE CONTROL FLAG.
         DC  H'2'                      SPACING FACTOR.
         DC  C'R '                     SPACINT TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'8400'                   STATIC TEXT SUB-STRUCTURE.
         DC  Y(STE91B-STE91A)          STATIC TEXT LENGTH.
         DC  Y(STE91A-TXT9A)           STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE91B-STE91A)          PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* STATIC TEXT ENTRIES.
STE91A   DC  C'IDC2533I MEMBER CAN NOT BE SPECIFIED WITH A GENERIC'
         DC  C' NAME'
STE91B   EQU *
TXT9B    EQU *
         EJECT
*
* MEMBER NOT RENAMED.
*
TXT10    DC  Y(TXT10B-TXT10A)          ENTRY LENGTH.
         DC  X'A000'                   MESSAGE FLAG.
* STATIC TEXT SUBSTRUCTURE.
TXT10A   DC  X'0400'                   STATIC FLAG
         DC  Y(STE101B-STE101A)        STATIC TEXT LENGTH
         DC  Y(STE101A-TXT10A)         STATIC TEXT OFFSET
         DC  H'1'                      PRINT COLUMN
         DC  Y(STE101B-STE101A)        PRINT FIELD LENGTH
         DC  H'0'                      CONVERSION FLAGS  (CHAR)
* BLOCK DATA SUB-STRUCTURE.
         DC  X'1000'                   BLOCK DATA FLAG.
         DC  H'8'                      INPUT FIELD LENGTH.
         DC  H'0'                      INPUT OFFSET.
         DC  H'19'                     PRINT COLUMN.
         DC  H'8'                      PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* STATIC TEXT SUB-STRUCTURE.
         DC  X'8400'                   STATIC TEXT & EOF FLAGS.
         DC  Y(STE102B-STE102A)        STATIC TEXT LENGTH.
         DC  Y(STE102A-TXT10A)         STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE102B-STE102A)        PRINT FIELD LENGTH.
         DC  X'0010'                   CONVERSION FLAGS. (CHAR,BS)
* STATIC TEXT ENTRY.
STE101A  DC  C'IDC0534I **MEMBER'
STE101B  EQU *
STE102A  DC  C'NOT RENAMED'
STE102B  EQU *
TXT10B   EQU *
         EJECT
*
* MEMBER RENAMED.
*
TXT11    DC  Y(TXT11B-TXT11A)          ENTRY LENGTH.
         DC  X'8000'                   MESSAGE FLAG.
* SPACING CONTROL SUB-STRUCTURE.
TXT11A   DC  X'4000'                   SPACE CONTROL FLAG.
         DC  H'2'                      SPACING FACTOR.
         DC  C'R '                     SPACINT TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC TEXT SUB-STRUCTURE.
         DC  Y(STE111B-STE111A)        STATIC TEXT LENGTH.
         DC  Y(STE111A-TXT11A)         STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE111B-STE111A)        PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* BLOCK DATA SUB-STRUCTURE.
         DC  X'1000'                   BLOCK DATA FLAGS.
         DC  H'8'                      INPUT LENGTH.
         DC  H'0'                      INPUT OFFSET.
         DC  H'17'                     PRINT COLUMN.
         DC  H'8'                      PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* STATIC TEXT SUB-STRUCTURE.
         DC  X'8400'                   EOF & STATIC DATA FLAGS.
         DC  Y(STE112B-STE112A)        STATIC TEXT LENGTH.
         DC  Y(STE112A-TXT11A)         STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE112B-STE112A)        PRINT FIELD LENGTH.
         DC  X'0010'                   CONVERSION FLAGS.  (CHAR,BS)
* STATIC TEXT ENTRIES.
STE111A  DC  C'IDC0535I MEMBER'
STE111B  EQU *
STE112A  DC  C'RENAMED'
STE112B  EQU *
TXT11B   EQU *
         EJECT
*                                                                    *
* AIX PARAMETERS SPECIFIED FOR A NON-AIX OBJECT                @Y30SSJH
*                                                                    *
TXT12    DC  Y(TXT12B-TXT12A)          ENTRY LENGTH.           @Y30SSJH
         DC  X'8000'                   MESSAGE FLAG.           @Y30SSJH
* SPACING CONTROL SUB-STRUCTURE.                               @Y30SSJH
TXT12A   DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
         DC  H'2'                      SPACING FACTOR.         @Y30SSJH
         DC  C'R '                     SPACING TYPE.           @Y30SSJH
* STATIC TEXT SUB-STRUCTURE.                                   @Y30SSJH
         DC  X'8400'                   STATIC & EOF FLAG.      @Y30SSJH
         DC  Y(STE121B-STE121A)        STATIC TEXT LENGTH.     @Y30SSJH
         DC  Y(STE121A-TXT12A)         STATIC TEXT OFFSET.     @Y30SSJH
         DC  H'1'                      PRINT COLUMN.           @Y30SSJH
         DC  Y(STE121B-STE121A)        PRINT FIELD LENGTH.     @Y30SSJH
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* STATIC TEXT ENTRY.                                           @Y30SSJH
STE121A  DC  C'IDC3537I INVALID ALTERNATE INDEX PARAMETERS '   @Y30SSJH
         DC  C'SPECIFIED'                                      @Y30SSJH
STE121B  EQU *                                                 @Y30SSJH
TXT12B   EQU *                                                 @Y30SSJH
         EJECT                                                 @Y30SSJH
*                                                                    *
*   UNIQUEKEY/UPGRADE SPECIFIED FOR A NON-EMPTY AIX            @Y30SSJH
*                                                                    *
TXT13    DC  Y(TXT13B-TXT13A)          ENTRY LENGTH.           @Y30SSJH
         DC  X'8000'                   MESSAGE FLAG.           @Y30SSJH
* SPACING CONTROL SUB-STRUCTURE.                               @Y30SSJH
TXT13A   DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
         DC  H'2'                      SPACING FACTOR.         @Y30SSJH
         DC  C'R '                     SPACING TYPE.           @Y30SSJH
* STATIC TEXT SUB-STRUCTURE.                                   @Y30SSJH
         DC  X'8400'                   STATIC & EOF FLAG.      @Y30SSJH
         DC  Y(STE131B-STE131A)        STATIC TEXT LENGTH.     @Y30SSJH
         DC  Y(STE131A-TXT13A)         STATIC TEXT OFFSET.     @Y30SSJH
         DC  H'1'                      PRINT COLUMN.           @Y30SSJH
         DC  Y(STE131B-STE131A)        PRINT FIELD LENGTH.     @Y30SSJH
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* STATIC TEXT ENTRY.                                           @Y30SSJH
STE131A  DC  C'IDC3538I UNIQUEKEY/UPGRADE INVALID FOR NON-EMPTY '
         DC  C'ALTERNATE INDEX'                                @Y30SSJH
STE131B  EQU *                                                 @Y30SSJH
TXT13B   EQU *                                                 @Y30SSJH
         EJECT                                                 @Y30SSJH
*                                                                    *
* KEYS/RECORDSIZE SPECIFIED FOR A NON-EMPTY OBJECT             @Y30SSJH
*                                                                    *
TXT14    DC  Y(TXT14B-TXT14A)          ENTRY LENGTH.           @Y30SSJH
         DC  X'8000'                   MESSAGE FLAG.           @Y30SSJH
* SPACING CONTROL SUB-STRUCTURE.                               @Y30SSJH
TXT14A   DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
         DC  H'2'                      SPACING FACTOR.         @Y30SSJH
         DC  C'R '                     SPACING TYPE.           @Y30SSJH
* STATIC TEXT SUB-STRUCTURE.                                   @Y30SSJH
         DC  X'8400'                   STATIC & EOF FLAG.      @Y30SSJH
         DC  Y(STE141B-STE141A)        STATIC TEXT LENGTH.     @Y30SSJH
         DC  Y(STE141A-TXT14A)         STATIC TEXT OFFSET.     @Y30SSJH
         DC  H'1'                      PRINT COLUMN.           @Y30SSJH
         DC  Y(STE141B-STE141A)        PRINT FIELD LENGTH.     @Y30SSJH
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* STATIC TEXT ENTRY.                                           @Y30SSJH
STE141A  DC  C'IDC3539I KEYS AND/OR RECORDSIZE PARAMETER '     @Y30SSJH
         DC  C'SPECIFIED FOR NON-EMPTY OBJECT'                 @Y30SSJH
STE141B  EQU *                                                 @Y30SSJH
TXT14B   EQU *                                                 @Y30SSJH
         EJECT                                                 @Y30SSJH
*                                                                    *
* KEYS/RECORDSIZE VALUES CONFLICT WITH CONTROL INTERVAL SIZE   @Y30SSJH
*                                                                    *
TXT15    DC  Y(TXT15B-TXT15A)          ENTRY LENGTH.           @Y30SSJH
         DC  X'8000'                   MESSAGE FLAG.           @Y30SSJH
* SPACING CONTROL SUB-STRUCTURE.                               @Y30SSJH
TXT15A   DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
         DC  H'2'                      SPACING FACTOR.         @Y30SSJH
         DC  C'R '                     SPACING TYPE.           @Y30SSJH
* STATIC TEXT SUB-STRUCTURE.                                   @Y30SSJH
         DC  X'8400'                   STATIC & EOF FLAG.      @Y30SSJH
         DC  Y(STE151B-STE151A)        STATIC TEXT LENGTH.     @Y30SSJH
         DC  Y(STE151A-TXT15A)         STATIC TEXT OFFSET.     @Y30SSJH
         DC  H'1'                      PRINT COLUMN.           @Y30SSJH
         DC  Y(STE151B-STE151A)        PRINT FIELD LENGTH.     @Y30SSJH
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* STATIC TEXT ENTRY.                                           @Y30SSJH
STE151A  DC  C'IDC3540I KEYS/RECORDSIZE VALUES CONFLICT '      @Y30SSJH
         DC  C'WITH CONTROL INTERVAL SIZE'                     @Y30SSJH
STE151B  EQU *                                                 @Y30SSJH
TXT15B   EQU *                                                 @Y30SSJH
         EJECT                                                 @Y30SSJH
*                                                                    *
* AIX KEY VALUES INCOMPATIBLE WITH RECORDSIZE OF BASE          @Y30SSJH
*                                                                    *
TXT16    DC  Y(TXT16B-TXT16A)          ENTRY LENGTH.           @Y30SSJH
         DC  X'8000'                   MESSAGE FLAG.           @Y30SSJH
* SPACING CONTROL SUB-STRUCTURE.                               @Y30SSJH
TXT16A   DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
         DC  H'2'                      SPACING FACTOR.         @Y30SSJH
         DC  C'R '                     SPACING TYPE.           @Y30SSJH
* STATIC TEXT SUB-STRUCTURE.                                   @Y30SSJH
         DC  X'8400'                   STATIC & EOF FLAG.      @Y30SSJH
         DC  Y(STE161B-STE161A)        STATIC TEXT LENGTH.     @Y30SSJH
         DC  Y(STE161A-TXT16A)         STATIC TEXT OFFSET.     @Y30SSJH
         DC  H'1'                      PRINT COLUMN.           @Y30SSJH
         DC  Y(STE161B-STE161A)        PRINT FIELD LENGTH.     @Y30SSJH
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* STATIC TEXT ENTRY.                                           @Y30SSJH
STE161A  DC  C'IDC3541I NEW ALTERNATE INDEX KEY VALUES '       @Y30SSJH
         DC  C'CONFLICT WITH BASE CLUSTER RECORDSIZE'          @Y30SSJH
STE161B  EQU *                                                 @Y30SSJH
TXT16B   EQU *                                                 @Y30SSJH
         EJECT                                                 @Y30SSJH
*                                                                    *
*   UNEQUAL RECORDSIZE VALUES SPECIFIED FOR A RELATIVE RECORD  @Y30SSJH
*   DATA SET                                                   @Y30SSJH
*                                                                    *
TXT17    DC  Y(TXT17B-TXT17A)          ENTRY LENGTH.           @Y30SSJH
         DC  X'8000'                   MESSAGE FLAG.           @Y30SSJH
* SPACING CONTROL SUB-STRUCTURE.                               @Y30SSJH
TXT17A   DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
         DC  H'2'                      SPACING FACTOR.         @Y30SSJH
         DC  C'R '                     SPACING TYPE.           @Y30SSJH
* STATIC TEXT SUB-STRUCTURE.                                   @Y30SSJH
         DC  X'8400'                   STATIC & EOF FLAG.      @Y30SSJH
         DC  Y(STE171B-STE171A)        STATIC TEXT LENGTH.     @Y30SSJH
         DC  Y(STE171A-TXT17A)         STATIC TEXT OFFSET.     @Y30SSJH
         DC  H'1'                      PRINT COLUMN.           @Y30SSJH
         DC  Y(STE171B-STE171A)        PRINT FIELD LENGTH.     @Y30SSJH
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* STATIC TEXT ENTRY.                                           @Y30SSJH
STE171A  DC  C'IDC3542I AVE AND MAX RECORDSIZE NOT EQUAL FOR ' @Y30SSJH
         DC  C'RELATIVE RECORD DATA SET'                       @Y30SSJH
STE171B  EQU *                                                 @Y30SSJH
TXT17B   EQU *                                                 @Y30SSJH
         EJECT                                                 @Y30SSJH
*                                                                    *
*   NEW KEYS/RECORDSIZE VALUES EQUAL TO OLD                    @Y30SSJH
*                                                                    *
TXT18    DC  Y(TXT18B-TXT18A)          ENTRY LENGTH.           @Y30SSJH
         DC  X'8000'                   MESSAGE FLAG.           @Y30SSJH
* SPACING CONTROL SUB-STRUCTURE.                               @Y30SSJH
TXT18A   DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
         DC  H'2'                      SPACING FACTOR.         @Y30SSJH
         DC  C'R '                     SPACING TYPE.           @Y30SSJH
* STATIC TEXT SUB-STRUCTURE.                                   @Y30SSJH
         DC  X'8400'                   STATIC & EOF FLAG.      @Y30SSJH
         DC  Y(STE181B-STE181A)        STATIC TEXT LENGTH.     @Y30SSJH
         DC  Y(STE181A-TXT18A)         STATIC TEXT OFFSET.     @Y30SSJH
         DC  H'1'                      PRINT COLUMN.           @Y30SSJH
         DC  Y(STE181B-STE181A)        PRINT FIELD LENGTH.     @Y30SSJH
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* STATIC TEXT ENTRY.                                           @Y30SSJH
STE181A  DC  C'IDC1543I NEW KEYS AND/OR RECORDSIZE VALUES '    @Y30SSJH
         DC  C'EQUAL TO PRIOR DEFAULT VALUES'                  @Y30SSJH
STE181B  EQU *                                                 @Y30SSJH
TXT18B   EQU *                                                 @Y30SSJH
         EJECT                                                 @Y30SSJH
*                                                                    *
*   NEW KEYS/RECORDSIZE VALUES EQUAL TO OLD NON-DEFAULT VALUES @Y30SSJH
*                                                                    *
TXT19    DC  Y(TXT19B-TXT19A)          ENTRY LENGTH.           @Y30SSJH
         DC  X'8000'                   MESSAGE FLAG.           @Y30SSJH
* SPACING CONTROL SUB-STRUCTURE.                               @Y30SSJH
TXT19A   DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
         DC  H'2'                      SPACING FACTOR.         @Y30SSJH
         DC  C'R '                     SPACING TYPE.           @Y30SSJH
* STATIC TEXT SUB-STRUCTURE.                                   @Y30SSJH
         DC  X'8400'                   STATIC & EOF FLAG.      @Y30SSJH
         DC  Y(STE191B-STE191A)        STATIC TEXT LENGTH.     @Y30SSJH
         DC  Y(STE191A-TXT19A)         STATIC TEXT OFFSET.     @Y30SSJH
         DC  H'1'                      PRINT COLUMN.           @Y30SSJH
         DC  Y(STE191B-STE191A)        PRINT FIELD LENGTH.     @Y30SSJH
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* STATIC TEXT ENTRY.                                           @Y30SSJH
STE191A  DC  C'IDC1544I KEYS AND/OR RECORDSIZE VALUES EQUAL '  @Y30SSJH
         DC  C'TO PRIOR NON-DEFAULT VALUES'                    @Y30SSJH
STE191B  EQU *                                                 @Y30SSJH
TXT19B   EQU *                                                 @Y30SSJH
         EJECT                                                 @Y30SSJH
*                                                                    *
* KEYS/RECORDSIZE CANNOT BE ALTERED                            @Y30SSJH
*                                                                    *
TXT20    DC  Y(TXT20B-TXT20A)          ENTRY LENGTH.           @Y30SSJH
         DC  X'8000'                   MESSAGE FLAG.           @Y30SSJH
* SPACING CONTROL SUB-STRUCTURE.                               @Y30SSJH
TXT20A   DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
         DC  H'2'                      SPACING FACTOR.         @Y30SSJH
         DC  C'R '                     SPACING TYPE.           @Y30SSJH
* STATIC TEXT SUB-STRUCTURE.                                   @Y30SSJH
         DC  X'8400'                   STATIC & EOF FLAG.      @Y30SSJH
         DC  Y(STE201B-STE201A)        STATIC TEXT LENGTH.     @Y30SSJH
         DC  Y(STE201A-TXT20A)         STATIC TEXT OFFSET.     @Y30SSJH
         DC  H'1'                      PRINT COLUMN.           @Y30SSJH
         DC  Y(STE201B-STE201A)        PRINT FIELD LENGTH.     @Y30SSJH
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* STATIC TEXT ENTRY.                                           @Y30SSJH
STE201A  DC  C'IDC3545I KEYS AND/OR RECORDSIZE VALUES CANNOT ' @Y30SSJH
         DC  C'BE ALTERED'                                     @Y30SSJH
STE201B  EQU *                                                 @Y30SSJH
TXT20B   EQU *                                                 @Y30SSJH
         EJECT                                                 @Y30SSJH
*                                                                    *
*   KEY VALUES CONFLICT WITH RECORDSIZE                        @Y30SSJH
*                                                                    *
TXT21    DC  Y(TXT21B-TXT21A)          ENTRY LENGTH.           @Y30SSJH
         DC  X'8000'                   MESSAGE FLAG.           @Y30SSJH
* SPACING CONTROL SUB-STRUCTURE.                               @Y30SSJH
TXT21A   DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
         DC  H'2'                      SPACING FACTOR.         @Y30SSJH
         DC  C'R '                     SPACING TYPE.           @Y30SSJH
* STATIC TEXT SUB-STRUCTURE.                                   @Y30SSJH
         DC  X'8400'                   STATIC & EOF FLAG.      @Y30SSJH
         DC  Y(STE211B-STE211A)        STATIC TEXT LENGTH.     @Y30SSJH
         DC  Y(STE211A-TXT21A)         STATIC TEXT OFFSET.     @Y30SSJH
         DC  H'1'                      PRINT COLUMN.           @Y30SSJH
         DC  Y(STE211B-STE211A)        PRINT FIELD LENGTH.     @Y30SSJH
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* STATIC TEXT ENTRY.                                           @Y30SSJH
STE211A  DC  C'IDC3546I NEW KEY VALUES CONFLICT WITH '         @Y30SSJH
         DC  C'RECORDSIZE'                                     @Y30SSJH
STE211B  EQU *                                                 @Y30SSJH
TXT21B   EQU *                                                 @Y30SSJH
         EJECT                                                 @Y30SSJH
*                                                                    *
*   KEYS/RECORDSIZE SPECIFIED WITH INVALID OBJECT              @Y30SSJH
*                                                                    *
TXT22    DC  Y(TXT22B-TXT22A)          ENTRY LENGTH.           @Y30SSJH
         DC  X'8000'                   MESSAGE FLAG.           @Y30SSJH
* SPACING CONTROL SUB-STRUCTURE.                               @Y30SSJH
TXT22A   DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
         DC  H'2'                      SPACING FACTOR.         @Y30SSJH
         DC  C'R '                     SPACING TYPE.           @Y30SSJH
* STATIC TEXT SUB-STRUCTURE.                                   @Y30SSJH
         DC  X'8400'                   STATIC & EOF FLAG.      @Y30SSJH
         DC  Y(STE221B-STE221A)        STATIC TEXT LENGTH.     @Y30SSJH
         DC  Y(STE221A-TXT22A)         STATIC TEXT OFFSET.     @Y30SSJH
         DC  H'1'                      PRINT COLUMN.           @Y30SSJH
         DC  Y(STE221B-STE221A)        PRINT FIELD LENGTH.     @Y30SSJH
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* STATIC TEXT ENTRY.                                           @Y30SSJH
STE221A  DC  C'IDC3547I ENTRY TYPE IS INVALID WITH '           @Y30SSJH
         DC  C'KEYS/RECORDSIZE PARAMETER'                      @Y30SSJH
STE221B  EQU *                                                 @Y30SSJH
TXT22B   EQU *                                                 @Y30SSJH
         EJECT                                                 @Y30SSJH
*                                                                    *
* PASSWORD INSUFFICIENT TO ALTER KEYS                          @Y30SSJH
*                                                                    *
TXT23    DC  Y(TXT23B-TXT23A)          ENTRY LENGTH.           @Y30SSJH
         DC  X'8000'                   MESSAGE FLAG.           @Y30SSJH
* SPACING CONTROL SUB-STRUCTURE.                               @Y30SSJH
TXT23A   DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
         DC  H'2'                      SPACING FACTOR.         @Y30SSJH
         DC  C'R '                     SPACING TYPE.           @Y30SSJH
* STATIC TEXT SUB-STRUCTURE.                                   @Y30SSJH
         DC  X'8400'                   STATIC & EOF FLAG.      @Y30SSJH
         DC  Y(STE231B-STE231A)        STATIC TEXT LENGTH.     @Y30SSJH
         DC  Y(STE231A-TXT23A)         STATIC TEXT OFFSET.     @Y30SSJH
         DC  H'1'                      PRINT COLUMN.           @Y30SSJH
         DC  Y(STE231B-STE231A)        PRINT FIELD LENGTH.     @Y30SSJH
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* STATIC TEXT ENTRY.                                           @Y30SSJH
STE231A  DC  C'IDC3525I INSUFFICENT SECURITY AUTHORIZATION'    @Z40RSSA
         DC  C' TO ALTER KEYS'                                 @Z40RSSA
STE231B  EQU *                                                 @Y30SSJH
TXT23B   EQU *                                                 @Y30SSJH
         EJECT                                                 @ZA05940
*                                                                    *
* PARAMETER - ENTRY TYPE CONFLICT                              @ZA05940
*                                                                    *
TXT24    DC  Y(TXT24B-TXT24A)          ENTRY LENGTH.           @ZA05940
         DC  X'A000'                   MESSAGE FLAG.           @ZA05940
* STATIC TEXT SUBSTRUCTURE.                                    @ZA05940
TXT24A   DC  X'0400'                   STATIC FLAG             @ZA05940
         DC  Y(STE241B-STE241A)        STATIC TEXT LENGTH      @ZA05940
         DC  Y(STE241A-TXT24A)         STATIC TEXT OFFSET      @ZA05940
         DC  H'1'                      PRINT COLUMN            @ZA05940
         DC  Y(STE241B-STE241A)        PRINT FIELD LENGTH      @ZA05940
         DC  H'0'                      CONVERSION FLAGS  (CHAR)
* BLOCK DATA SUB-STRUCTURE.                                    @ZA05940
         DC  X'1000'                   BLOCK DATA FLAG.        @ZA05940
         DC  H'13'                     INPUT FIELD LENGTH.     @ZA05940
         DC  H'0'                      INPUT OFFSET.           @ZA05940
         DC  H'11'                     PRINT COLUMN.           @ZA05940
         DC  H'13'                     PRINT FIELD LENGTH.     @ZA05940
         DC  H'0'                      COMVERSION FLAGS.  (CHAR)
* STATIC TEXT SUB-STRUCTURE.                                   @ZA05940
         DC  X'8400'                   STATIC TEXT & EOF FLAGS.
         DC  Y(STE242B-STE242A)        STATIC TEXT LENGTH.     @ZA05940
         DC  Y(STE242A-TXT24A)         STATIC TEXT OFFSET.     @ZA05940
         DC  H'0'                      PRINT COLUMN.           @ZA05940
         DC  Y(STE242B-STE242A)        PRINT FIELD LENGTH.     @ZA05940
         DC  X'0010'                   CONVERSION FLAGS. (CHAR)
* STATIC TEXT ENTRY.                                           @ZA05940
STE241A  DC  C'IDC3190I '''                                    @ZA05940
STE241B  EQU *                                                 @ZA05940
STE242A  DC  C''' PARAMETER INVALID WITH ENTRY TYPE'           @ZA05940
STE242B  EQU *                                                 @ZA05940
TXT24B   EQU *                                                 @ZA05940
         END
