         TITLE '***** IDCTSBI0 - BLDINDEX STATIC TEXT *****'
**********************************************************************
*                                                                    *
* MODULE NAME - IDCTSBI0 - STATIC TEXT MODULE FOR BLDINDEX           *
*                                                                    *
* DESCRIPTIVE NAME - STATIC TEXT MODULE FOR THE FUNCTION BLDINDEX    *
*                                                                    *
* COPYRIGHT - NONE                                                   *
*                                                                    *
* STATUS - RELEASE 2  LEVEL 0                                        *
*                                                                    *
* FUNCTION - CONTAINS NO EXECUTIBLE CODE, ONLY STATIC TEXT ENTRIES   *
*        FOR THE FUNCTION BLDINDEX.                                  *
*        THIS MODULE IS LOADED BY IDCTP05 WHEN A STATIC TEXT         *
*        REQUEST IS MADE.                                            *
*                                                                    *
* NOTES - NONE                                                       *
*                                                                    *
*    DEPENDENCIES - NONE                                             *
*    RESTRICTIONS - NONE                                             *
*    REGISTER CONVENTIONS - NA                                       *
*    PATCH AREA - NA                                                 *
*                                                                    *
* MODULE TYPE - TABLES                                               *
*                                                                    *
*        PROCESSOR - ASSEMBLER                                       *
*        MODULE SIZE - 1400 BYTES                                    *
*        ATTRIBUTES - READ ONLY                                      *
*                                                                    *
*  ENTRY POINT - NA                                                  *
*                                                                    *
*  EXIT NORMAL - NA                                                  *
*                                                                    *
*  EXIT ERROR - NA                                                   *
*                                                                    *
*  EXTERNAL REFERENCES - NA                                          *
*                                                                    *
*  TABLES - NA                                                       *
*                                                                    *
*  MACROS - NA                                                       *
*                                                                    *
* CHANGE ACTIVITY - NONE                                             *
*                                                                    *
**********************************************************************
*********************************************************************
*                                                                    *
* THIS MODULE IS THE FIRST MODULE OF STATIC TEXT REQUIRED BY THE     *
* BLDINDEX FUNCTION SUB-ROUTINES.                                    *
*                                                                    *
*********************************************************************
*                                                                    *
IDCTSBI0 CSECT
*
* THIS SECTION CONTAINS THE INDICES TO REACH AN ENTRY.               *
*
INDEX    DC  H'19'                     COUNT OF ENTRIES.
INDEX1   DC  Y(TXT1-INDEX)             INVALID AIX
INDEX2   DC  Y(TXT2-INDEX)             INVALID BASE CLUSTER
INDEX3   DC  Y(TXT3-INDEX)             AIX NOT RELATED TO BASE
INDEX4   DC  Y(TXT4-INDEX)             BASE IS EMPTY
INDEX5   DC  Y(TXT5-INDEX)             AIX KEY NOT IN BASE - KSDS
INDEX6   DC  Y(TXT6-INDEX)             NONUNIQUE AIX KEY - KSDS
INDEX7   DC  Y(TXT7-INDEX)             EXCESS PRIME POINTERS
INDEX8   DC  Y(TXT8-INDEX)             NO CORE FOR BUFFERS/WORKAREAS
INDEX9   DC  Y(TXT9-INDEX)             JOB CONTROL ERROR
INDEX10  DC  Y(TXT10-INDEX)            NO CORE TO START SORT
INDEX11  DC  Y(TXT11-INDEX)            NO CORE TO FINISH SORT
INDEX12  DC  Y(TXT12-INDEX)            SORT FILE DEFINE FAILED
INDEX13  DC  Y(TXT13-INDEX)            AIX SUCCESSFULLY BUILT
INDEX14  DC  Y(TXT14-INDEX)            AIX BUILT WITH ERRORS
INDEX15  DC  Y(TXT15-INDEX)            AIX WAS NOT BUILT
INDEX16  DC  Y(TXT16-INDEX)            DATA NOT RETURNED BY LOCATE
INDEX17  DC  Y(TXT17-INDEX)            AIX KEY NOT IN BASE - ESDS
INDEX18  DC  Y(TXT18-INDEX)            NONUNIQUE AIX KEY - ESDS
INDEX19  DC  Y(TXT19-INDEX)            LOCATE FAILURE
         EJECT
*********************************************************************
*                                                                    *
* THIS SECTION CONTAINS THE ENTRIES.                                 *
*                                                                    *
*********************************************************************
*                                                                    *
* INVALID ALTERNATE INDEX
*                                                                    *
TXT1     DC  Y(TXT1B-TXT1A)            ENTRY LENGTH.
         DC  X'8000'                   MESSAGE FLAG.
* SPACING CONTROL SUB-STRUCTURE.
TXT1A    DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
         DC  H'2'                      SPACING FACTOR.
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC FLAG.
         DC  Y(STE11B-STE11A)          STATIC TEXT LENGTH.
         DC  Y(STE11A-TXT1A)           STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE11B-STE11A)          PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* BLOCK DATA SUB-STRUCTURE
         DC  X'1000'                   BLOCK DATA FLAG.
         DC  H'44'                     INPUT LENGTH.
         DC  H'0'                      INPUT OFFSET.
         DC  H'10'                     PRINT COLUMN.
         DC  H'44'                     PRINT FIELD LENGTH
         DC  H'0'                      CONVERSION FLAGS (CHAR)
* STATIC TEXT SUB-STRUCTURE.
         DC  X'8400'                   STATIC FLAG.
         DC  Y(STE12B-STE12A)          STATIC TEXT LENGTH.
         DC  Y(STE12A-TXT1A)           STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE12B-STE12A)          PRINT FIELD LENGTH.
         DC  X'0010'                   CONVERSION FLAGS.  (CHAR,BS)
* STATIC TEXT ENTRIES
STE11A   DC  C'IDC2640I'
STE11B   EQU *
STE12A   DC  C'NOT AN AIX'
STE12B   EQU *
TXT1B    EQU *
         EJECT
*                                                                    *
* INVALID BASE CLUSTER
*                                                                    *
TXT2     DC  Y(TXT2B-TXT2A)            ENTRY LENGTH.
         DC  X'8000'                   MESSAGE FLAG.
* SPACING CONTROL SUB-STRUCTURE.
TXT2A    DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
         DC  H'2'                      SPACING FACTOR.
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC FLAG.
         DC  Y(STE21B-STE21A)          STATIC TEXT LENGTH.
         DC  Y(STE21A-TXT2A)           STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE21B-STE21A)          PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* BLOCK DATA SUB-STRUCTURE
         DC  X'1000'                   BLOCK DATA FLAG.
         DC  H'44'                     INPUT LENGTH.
         DC  H'0'                      INPUT OFFSET.
         DC  H'10'                     PRINT COLUMN.
         DC  H'44'                     PRINT FIELD LENGTH
         DC  H'0'                      CONVERSION FLAGS (CHAR)
* STATIC TEXT SUB-STRUCTURE.
         DC  X'8400'                   STATIC FLAG.
         DC  Y(STE22B-STE22A)          STATIC TEXT LENGTH.
         DC  Y(STE22A-TXT2A)           STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE22B-STE22A)          PRINT FIELD LENGTH.
         DC  X'0010'                   CONVERSION FLAGS.  (CHAR,BS)
* STATIC TEXT ENTRIES
STE21A   DC  C'IDC3641I'
STE21B   EQU *
STE22A   DC  C'NOT A BASE CLUSTER'
STE22B   EQU *
TXT2B    EQU *
         EJECT
*                                                                    *
* AIX NOT RELATED TO BASE
*                                                                    *
TXT3     DC  Y(TXT3B-TXT3A)            ENTRY LENGTH.
         DC  X'8000'                   MESSAGE FLAG.
* SPACING CONTROL SUB-STRUCTURE.
TXT3A    DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
         DC  H'2'                      SPACING FACTOR.
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC FLAG.
         DC  Y(STE31B-STE31A)          STATIC TEXT LENGTH.
         DC  Y(STE31A-TXT3A)           STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE31B-STE31A)          PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* BLOCK DATA SUB-STRUCTURE
         DC  X'1000'                   BLOCK DATA FLAG.
         DC  H'44'                     INPUT LENGTH.
         DC  H'0'                      INPUT OFFSET.
         DC  H'10'                     PRINT COLUMN.
         DC  H'44'                     PRINT FIELD LENGTH
         DC  H'0'                      CONVERSION FLAGS (CHAR)
* STATIC TEXT SUB-STRUCTURE.
         DC  X'8400'                   STATIC FLAG.
         DC  Y(STE32B-STE32A)          STATIC TEXT LENGTH.
         DC  Y(STE32A-TXT3A)           STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE32B-STE32A)          PRINT FIELD LENGTH.
         DC  X'0010'                   CONVERSION FLAGS.  (CHAR,BS)
* STATIC TEXT ENTRIES
STE31A   DC  C'IDC2642I'
STE31B   EQU *
STE32A   DC  C'NOT RELATED TO BASE'
STE32B   EQU *
TXT3B    EQU *
         EJECT
*                                                                    *
* AIX IS EMPTY
*                                                                    *
TXT4     DC  Y(TXT4B-TXT4A)            ENTRY LENGTH.
         DC  X'8000'                   MESSAGE FLAG.
* SPACING CONTROL SUB-STRUCTURE.
TXT4A    DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
         DC  H'2'                      SPACING FACTOR.
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC FLAG.
         DC  Y(STE41B-STE41A)          STATIC TEXT LENGTH.
         DC  Y(STE41A-TXT4A)           STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE41B-STE41A)          PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* BLOCK DATA SUB-STRUCTURE
         DC  X'1000'                   BLOCK DATA FLAG.
         DC  H'44'                     INPUT LENGTH.
         DC  H'0'                      INPUT OFFSET.
         DC  H'10'                     PRINT COLUMN.
         DC  H'44'                     PRINT FIELD LENGTH
         DC  H'0'                      CONVERSION FLAGS (CHAR)
* STATIC TEXT SUB-STRUCTURE.
         DC  X'8400'                   STATIC FLAG.
         DC  Y(STE42B-STE42A)          STATIC TEXT LENGTH.
         DC  Y(STE42A-TXT4A)           STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE42B-STE42A)          PRINT FIELD LENGTH.
         DC  X'0010'                   CONVERSION FLAGS.  (CHAR,BS)
* STATIC TEXT ENTRIES
STE41A   DC  C'IDC3643I'
STE41B   EQU *
STE42A   DC  C'IS EMPTY'
STE42B   EQU *
TXT4B    EQU *
         EJECT
*                                                                    *
* AIX KEY NOT IN BASE CLUSTER RECORD - KSDS
*                                                                    *
TXT5     DC  Y(TXT5B-TXT5A)            ENTRY LENGTH.
         DC  X'8000'                   MESSAGE FLAG.
* SPACING CONTROL SUB-STRUCTURE.
TXT5A    DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
         DC  H'2'                      SPACING FACTOR.
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC FLAG.
         DC  Y(STE51B-STE51A)          STATIC TEXT LENGTH.
         DC  Y(STE51A-TXT5A)           STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE51B-STE51A)          PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* BLOCK DATA SUB-STRUCTURE
         DC  X'9000'                   BLOCK DATA FLAG.
         DC  H'32767'                  INPUT LENGTH  (A LENGTH
*                                      OF 32767 FORCES THE TEXT
*                                      PROCESSOR TO GET THE
*                                      LENGTH FROM DARGILP)
         DC  H'0'                      INPUT OFFSET.
         DC  H'49'                     PRINT COLUMN.
         DC  H'20'                     PRINT FIELD LENGTH
         DC  X'8000'                   CONVERSION FLAGS (BH)
* STATIC TEXT ENTRIES
STE51A   DC  C'IDC1644I ALTERNATE INDEX KEY NOT IN BASE RECORD'
STE51B   EQU *
TXT5B    EQU *
         EJECT
*                                                                    *
* NONUNIQUE AIX KEY - KSDS
*                                                                    *
TXT6     DC  Y(TXT6B-TXT6A)            ENTRY LENGTH.
         DC  X'8000'                   MESSAGE FLAG.
* SPACING CONTROL SUB-STRUCTURE.
TXT6A    DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
         DC  H'2'                      SPACING FACTOR.
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC FLAG.
         DC  Y(STE61B-STE61A)          STATIC TEXT LENGTH.
         DC  Y(STE61A-TXT6A)           STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE61B-STE61A)          PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* INSERT DATA SUB-STRUCTURE
         DC  X'2000'                   INSERT DATA FLAG
         DC  H'1'                      REFERENCE NUMBER
         DC  H'0'                      UNUSED
         DC  H'28'                     PRINT COLUMN
         DC  H'20'                     PRINT FIELD LENGTH
         DC  X'8000'                   CONVERSION FLAGS (BH)
* SPACING SUB-STRUCTURE
         DC  X'4000'                   SPACE CONTROL FLAG.
         DC  H'0'                      SPACING FACTOR.
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC FLAG.
         DC  Y(STE62B-STE62A)          STATIC TEXT LENGTH.
         DC  Y(STE62A-TXT6A)           STATIC TEXT OFFSET.
         DC  H'10'                     PRINT COLUMN.
         DC  Y(STE62B-STE62A)          PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* INSERT DATA SUB-STRUCTURE
         DC  X'A000'                   INSERT DATA FLAG
         DC  H'2'                      REFERENCE NUMBER
         DC  H'0'                      UNUSED
         DC  H'23'                     PRINT COLUMN
         DC  H'20'                     PRINT FIELD LENGTH
         DC  X'8000'                   CONVERSION FLAGS (BH)
STE61A   DC  C'IDC1645I NONUNIQUE AIX KEY'
STE61B   EQU *
STE62A   DC  C'PRIME KEY IS'
STE62B   EQU *
TXT6B    EQU *
         EJECT
*                                                                    *
* EXCESS PRIME POINTERS
*                                                                    *
TXT7     DC  Y(TXT7B-TXT7A)            ENTRY LENGTH.
         DC  X'8000'                   MESSAGE FLAG.
* SPACING CONTROL SUB-STRUCTURE.
TXT7A    DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
         DC  H'2'                      SPACING FACTOR.
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC FLAG.
         DC  Y(STE71B-STE71A)          STATIC TEXT LENGTH.
         DC  Y(STE71A-TXT7A)           STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE71B-STE71A)          PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* INSERT DATA SUB-STRUCTURE
         DC  X'2000'                   INSERT DATA FLAG
         DC  H'1'                      REFERENCE NUMBER
         DC  H'0'                      UNUSED
         DC  H'10'                     PRINT COLUMN
         DC  H'5'                      PRINT FIELD LENGTH
         DC  X'10A0'                   CONVERSION FLAGS (BD,ZS,SS)
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC FLAG.
         DC  Y(STE72B-STE72A)          STATIC TEXT LENGTH.
         DC  Y(STE72A-TXT7A)           STATIC TEXT OFFSET.
         DC  H'16'                     PRINT COLUMN.
         DC  Y(STE72B-STE72A)          PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* INSERT DATA SUB-STRUCTURE
         DC  X'2000'                   INSERT DATA FLAG
         DC  H'2'                      REFERENCE NUMBER
         DC  H'0'                      UNUSED
         DC  H'29'                     PRINT COLUMN
         DC  H'3'                      PRINT FIELD LENGTH
         DC  H'0'                      CONVERSION FLAGS (CHAR)
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC FLAG.
         DC  Y(STE73B-STE73A)          STATIC TEXT LENGTH.
         DC  Y(STE73A-TXT7A)           STATIC TEXT OFFSET.
         DC  H'33'                     PRINT COLUMN.
         DC  Y(STE73B-STE73A)          PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* INSERT DATA SUB-STRUCTURE
         DC  X'A000'                   INSERT DATA FLAG
         DC  H'3'                      REFERENCE NUMBER
         DC  H'0'                      UNUSED
         DC  H'52'                     PRINT COLUMN
         DC  H'20'                     PRINT FIELD LENGTH
         DC  X'8000'                   CONVERSION FLAGS (BH)
STE71A   DC  C'IDC1646I'
STE71B   EQU *
STE72A   DC  C'EXCESS PRIME'
STE72B   EQU *
STE73A   DC  C'VALUES FOR AIX KEY'
STE73B   EQU *
TXT7B    EQU *
         EJECT
*                                                                    *
* INSUFFICIENT STORAGE FOR BUFFERS AND WORKAREAS
*                                                                    *
TXT8     DC  Y(TXT8B-TXT8A)            ENTRY LENGTH.
         DC  X'8000'                   MESSAGE FLAG.
* SPACING CONTROL SUB-STRUCTURE.
TXT8A    DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
         DC  H'2'                      SPACING FACTOR.
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'8400'                   STATIC FLAG.
         DC  Y(STE81B-STE81A)          STATIC TEXT LENGTH.
         DC  Y(STE81A-TXT8A)           STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE81B-STE81A)          PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
STE81A   DC  C'IDC2647I INSUFFICIENT STORAGE TO OBTAIN BUFFERS AND WORK*
               AREAS'
STE81B   EQU *
TXT8B    EQU *
         EJECT
*                                                                    *
* JOB CONTROL ERROR
*                                                                    *
TXT9     DC  Y(TXT9B-TXT9A)            ENTRY LENGTH.
         DC  X'8000'                   MESSAGE FLAG.
* SPACING CONTROL SUB-STRUCTURE.
TXT9A    DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
         DC  H'2'                      SPACING FACTOR.
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'8400'                   STATIC FLAG.
         DC  Y(STE91B-STE91A)          STATIC TEXT LENGTH.
         DC  Y(STE91A-TXT9A)           STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE91B-STE91A)          PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
STE91A   DC  C'IDC2648I JOB CONTROL CARDS FOR EXTERNAL SORT MISSING OR *
               IN ERROR'
STE91B   EQU *
TXT9B    EQU *
         EJECT
*                                                                    *
* INSUFFICIENT CORE TO START SORT
*                                                                    *
TXT10    DC  Y(TXT10B-TXT10A)          ENTRY LENGTH.
         DC  X'8000'                   MESSAGE FLAG.
* SPACING CONTROL SUB-STRUCTURE.
TXT10A   DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
         DC  H'2'                      SPACING FACTOR.
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'8400'                   STATIC FLAG.
         DC  Y(STE101B-STE101A)        STATIC TEXT LENGTH.
         DC  Y(STE101A-TXT10A)         STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE101B-STE101A)        PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
STE101A  DC  C'IDC2649I INSUFFICIENT STORAGE TO PERFORM INTERNAL SORT'
STE101B  EQU *
TXT10B   EQU *
         EJECT
*                                                                    *
* INSUFFICIENT CORE TO FINISH SORT
*                                                                    *
TXT11    DC  Y(TXT11B-TXT11A)          ENTRY LENGTH.
         DC  X'8000'                   MESSAGE FLAG.
* SPACING CONTROL SUB-STRUCTURE.
TXT11A   DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
         DC  H'2'                      SPACING FACTOR.
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'8400'                   STATIC FLAG.
         DC  Y(STE111B-STE111A)        STATIC TEXT LENGTH.
         DC  Y(STE111A-TXT11A)         STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE111B-STE111A)        PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
STE111A  DC  C'IDC2650I INSUFFICIENT STORAGE TO FINISH INTERNAL SORT'
STE111B  EQU *
TXT11B   EQU *
         EJECT
*                                                                    *
* SORT FILE DEFINE FAILED
*                                                                    *
TXT12    DC  Y(TXT12B-TXT12A)          ENTRY LENGTH.
         DC  X'8000'                   MESSAGE FLAG.
* SPACING CONTROL SUB-STRUCTURE.
TXT12A   DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
         DC  H'2'                      SPACING FACTOR.
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'8400'                   STATIC FLAG.
         DC  Y(STE121B-STE121A)        STATIC TEXT LENGTH.
         DC  Y(STE121A-TXT12A)         STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE121B-STE121A)        PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* STATIC TEXT ENTRIES
STE121A  DC  C'IDC2651I DEFINE OF SORT WORK FILES FAILED'
STE121B  EQU *
TXT12B   EQU *
         EJECT
*                                                                    *
* AIX SUCCESSFULLY BUILT
*                                                                    *
TXT13    DC  Y(TXT13B-TXT13A)          ENTRY LENGTH.
         DC  X'8000'                   MESSAGE FLAG.
* SPACING CONTROL SUB-STRUCTURE.
TXT13A   DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
         DC  H'2'                      SPACING FACTOR.
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC FLAG.
         DC  Y(STE131B-STE131A)        STATIC TEXT LENGTH.
         DC  Y(STE131A-TXT13A)         STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE131B-STE131A)        PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* BLOCK DATA SUB-STRUCTURE
         DC  X'1000'                   BLOCK DATA FLAG.
         DC  H'44'                     INPUT LENGTH.
         DC  H'0'                      INPUT OFFSET.
         DC  H'10'                     PRINT COLUMN.
         DC  H'44'                     PRINT FIELD LENGTH
         DC  H'0'                      CONVERSION FLAGS (CHAR)
* STATIC TEXT SUB-STRUCTURE.
         DC  X'8400'                   STATIC FLAG.
         DC  Y(STE132B-STE132A)        STATIC TEXT LENGTH.
         DC  Y(STE132A-TXT13A)         STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE132B-STE132A)        PRINT FIELD LENGTH.
         DC  X'0010'                   CONVERSION FLAGS.  (CHAR,BS)
* STATIC TEXT ENTRIES
STE131A  DC  C'IDC0652I'
STE131B  EQU *
STE132A  DC  C'SUCCESSFULLY BUILT'
STE132B  EQU *
TXT13B   EQU *
         EJECT
*                                                                    *
* AIX BUILT WITH ERRORS
*                                                                    *
TXT14    DC  Y(TXT14B-TXT14A)          ENTRY LENGTH.
         DC  X'8000'                   MESSAGE FLAG.
* SPACING CONTROL SUB-STRUCTURE.
TXT14A   DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
         DC  H'2'                      SPACING FACTOR.
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC FLAG.
         DC  Y(STE141B-STE141A)        STATIC TEXT LENGTH.
         DC  Y(STE141A-TXT14A)         STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE141B-STE141A)        PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* BLOCK DATA SUB-STRUCTURE
         DC  X'1000'                   BLOCK DATA FLAG.
         DC  H'44'                     INPUT LENGTH.
         DC  H'0'                      INPUT OFFSET.
         DC  H'10'                     PRINT COLUMN.
         DC  H'44'                     PRINT FIELD LENGTH
         DC  H'0'                      CONVERSION FLAGS (CHAR)
* STATIC TEXT SUB-STRUCTURE.
         DC  X'8400'                   STATIC FLAG.
         DC  Y(STE142B-STE142A)        STATIC TEXT LENGTH.
         DC  Y(STE142A-TXT14A)         STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE142B-STE142A)        PRINT FIELD LENGTH.
         DC  X'0010'                   CONVERSION FLAGS.  (CHAR,BS)
* STATIC TEXT ENTRIES
STE141A  DC  C'IDC1653I'
STE141B  EQU *
STE142A  DC  C'BUILT WITH ERRORS'
STE142B  EQU *
TXT14B   EQU *
         EJECT
*                                                                    *
* AIX WAS NOT BUILT
*                                                                    *
TXT15    DC  Y(TXT15B-TXT15A)          ENTRY LENGTH.
         DC  X'8000'                   MESSAGE FLAG.
* SPACING CONTROL SUB-STRUCTURE.
TXT15A   DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
         DC  H'2'                      SPACING FACTOR.
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC FLAG.
         DC  Y(STE151B-STE151A)        STATIC TEXT LENGTH.
         DC  Y(STE151A-TXT15A)         STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE151B-STE151A)        PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* BLOCK DATA SUB-STRUCTURE
         DC  X'1000'                   BLOCK DATA FLAG.
         DC  H'44'                     INPUT LENGTH.
         DC  H'0'                      INPUT OFFSET.
         DC  H'10'                     PRINT COLUMN.
         DC  H'44'                     PRINT FIELD LENGTH
         DC  H'0'                      CONVERSION FLAGS (CHAR)
* STATIC TEXT SUB-STRUCTURE.
         DC  X'8400'                   STATIC FLAG.
         DC  Y(STE152B-STE152A)        STATIC TEXT LENGTH.
         DC  Y(STE152A-TXT15A)         STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE152B-STE152A)        PRINT FIELD LENGTH.
         DC  X'0010'                   CONVERSION FLAGS.  (CHAR,BS)
* STATIC TEXT ENTRIES
STE151A  DC  C'IDC2654I'
STE151B  EQU *
STE152A  DC  C'WAS NOT BUILT'
STE152B  EQU *
TXT15B   EQU *
         EJECT
*                                                                    *
* LOCATE FAILED TO RETURN ATTRIBUTES
*                                                                    *
TXT16    DC  Y(TXT16B-TXT16A)          ENTRY LENGTH.
         DC  X'8000'                   MESSAGE FLAG.
* SPACING CONTROL SUB-STRUCTURE.
TXT16A   DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
         DC  H'2'                      SPACING FACTOR.
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC FLAG.
         DC  Y(STE161B-STE161A)        STATIC TEXT LENGTH.
         DC  Y(STE161A-TXT16A)         STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE161B-STE161A)        PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* BLOCK DATA SUB-STRUCTURE
         DC  X'9000'                   BLOCK DATA FLAG.
         DC  H'44'                     INPUT LENGTH.
         DC  H'0'                      INPUT OFFSET.
         DC  H'41'                     PRINT COLUMN.
         DC  H'44'                     PRINT FIELD LENGTH
         DC  H'0'                      CONVERSION FLAGS (CHAR)
* STATIC TEXT ENTRIES
STE161A  DC  C'IDC2655I UNABLE TO LOCATE ATTRIBUTES OF'
STE161B  EQU *
TXT16B   EQU *
         EJECT
*                                                                    *
* AIX KEY NOT IN BASE CLUSTER RECORD - ESDS
*                                                                    *
TXT17    DC  Y(TXT17B-TXT17A)          ENTRY LENGTH.
         DC  X'8000'                   MESSAGE FLAG.
* SPACING CONTROL SUB-STRUCTURE.
TXT17A   DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
         DC  H'2'                      SPACING FACTOR.
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC FLAG.
         DC  Y(STE171B-STE171A)        STATIC TEXT LENGTH.
         DC  Y(STE171A-TXT17A)         STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE171B-STE171A)        PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* BLOCK DATA SUB-STRUCTURE
         DC  X'9000'                   BLOCK DATA FLAG.
         DC  H'4'                      INPUT LENGTH.
         DC  H'0'                      INPUT OFFSET.
         DC  H'49'                     PRINT COLUMN.
         DC  H'10'                     PRINT FIELD LENGTH
         DC  X'1060'                   CONVERSION FLAGS (BD,AL,SS)
* STATIC TEXT ENTRIES
STE171A  DC  C'IDC1644I ALTERNATE INDEX KEY NOT IN BASE RECORD'
STE171B  EQU *
TXT17B   EQU *
         EJECT
*                                                                    *
* NONUNIQUE AIX KEY - ESDS
*                                                                    *
TXT18    DC  Y(TXT18B-TXT18A)          ENTRY LENGTH.
         DC  X'8000'                   MESSAGE FLAG.
* SPACING CONTROL SUB-STRUCTURE.
TXT18A   DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
         DC  H'2'                      SPACING FACTOR.
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC FLAG.
         DC  Y(STE181B-STE181A)        STATIC TEXT LENGTH.
         DC  Y(STE181A-TXT18A)         STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE181B-STE181A)        PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* INSERT DATA SUB-STRUCTURE
         DC  X'2000'                   INSERT DATA FLAG
         DC  H'1'                      REFERENCE NUMBER
         DC  H'0'                      UNUSED
         DC  H'28'                     PRINT COLUMN
         DC  H'20'                     PRINT FIELD LENGTH
         DC  X'8000'                   CONVERSION FLAGS (BH)
* SPACING SUB-STRUCTURE
         DC  X'4000'                   SPACE CONTROL FLAG.
         DC  H'0'                      SPACING FACTOR.
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC FLAG.
         DC  Y(STE182B-STE182A)        STATIC TEXT LENGTH.
         DC  Y(STE182A-TXT18A)         STATIC TEXT OFFSET.
         DC  H'10'                     PRINT COLUMN.
         DC  Y(STE182B-STE182A)        PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* INSERT DATA SUB-STRUCTURE
         DC  X'A000'                   INSERT DATA FLAG
         DC  H'2'                      REFERENCE NUMBER
         DC  H'0'                      UNUSED
         DC  H'23'                     PRINT COLUMN
         DC  H'10'                     PRINT FIELD LENGTH
         DC  X'1060'                   CONVERSION FLAGS (BD,AL,SS)
STE181A  DC  C'IDC1645I NONUNIQUE AIX KEY'
STE181B  EQU *
STE182A  DC  C'PRIME RBA IS'
STE182B  EQU *
TXT18B   EQU *
         EJECT
*                                                                    *
* LOCATE FAILURE
*                                                                    *
TXT19    DC  Y(TXT19B-TXT19A)          ENTRY LENGTH.
         DC  X'8000'                   MESSAGE FLAG.
* SPACING CONTROL SUB-STRUCTURE.
TXT19A   DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
         DC  H'2'                      SPACING FACTOR.
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC FLAG.
         DC  Y(STE191B-STE191A)        STATIC TEXT LENGTH.
         DC  Y(STE191A-TXT19A)         STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE191B-STE191A)        PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* BLOCK DATA SUB-STRUCTURE
         DC  X'9000'                   BLOCK DATA FLAG.
         DC  H'44'                     INPUT LENGTH.
         DC  H'0'                      INPUT OFFSET.
         DC  H'28'                     PRINT COLUMN.
         DC  H'44'                     PRINT FIELD LENGTH
         DC  H'0'                      CONVERSION FLAGS (CHAR)
* STATIC TEXT ENTRIES
STE191A  DC  C'IDC2656I LOCATE FAILED FOR'
STE191B  EQU *
TXT19B   EQU *
         END
