* /* START OF SPECIFICATIONS ****                            @Z40LB64
*01* PROCESSOR = ASSEMBLER                                   @Z40LB64
**** END OF SPECIFICATIONS   ***/                            @Z40LB64
************************************************************ @Z40LB64
*                                                          * @Z40LB64
* MODULE NAME - IDCTSCH0                                   * @Z40LB64
*                                                          * @Z40LB64
* DESCRIPTIVE NAME - STATIC TEXT MODULE FOR THE            * @Z40LB64
*                    CHECKMSS FUNCTION                     * @Z40LB64
*                                                          * @Z40LB64
* COPYRIGHT - NONE                                         * @Z40LB64
*                                                          * @Z40LB64
* STATUS - RELEASE 0  LEVEL 2                              * @ZA27324
*                                                          * @Z40LB64
* FUNCTION - CONTAINS NO EXECUTABLE CODE, ONLY STATIC      * @Z40LB64
*            TEXT FOR THE CHECKMSS FUNCTION.               * @Z40LB64
*            THIS MODULE IS LOADED BY IDCTP05 WHEN         * @Z40LB64
*            CHECKMSS STATIC TEXT IS REQUESTED.            * @Z40LB64
*                                                          * @Z40LB64
* NOTES - NONE                                             * @Z40LB64
*                                                          * @Z40LB64
*   DEPENDENCIES - NONE                                    * @Z40LB64
*   RESTRICTIONS - NONE                                    * @Z40LB64
*   REGISTER CONVENTIONS - NA                              * @Z40LB64
*   PATCH AREA - NA                                        * @Z40LB64
*                                                          * @Z40LB64
* MODULE TYPE - TABLES                                     * @Z40LB64
*                                                          * @Z40LB64
*   PROCESSOR - ASSEMBLER                                  * @Z40LB64
*   MODULE SIZE - 4000 BYTES                               * @Z40LB64
*   ATTRIBUTES - READ-ONLY                                 * @Z40LB64
*                                                          * @Z40LB64
* ENTRY POINT - NA                                         * @Z40LB64
*                                                          * @Z40LB64
* EXIT NORMAL - NA                                         * @Z40LB64
*                                                          * @Z40LB64
* EXIT ERROR - NA                                          * @Z40LB64
*                                                          * @Z40LB64
* EXTERNAL REFERENCES - NA                                 * @Z40LB64
*                                                          * @Z40LB64
* TABLES - NA                                              * @Z40LB64
*                                                          * @Z40LB64
* MACROS - NA                                              * @Z40LB64
*                                                          * @Z40LB64
* CHANGE ACTIVITY - AS FOLLOWS:                            * @ZA27324
*            VS41107                                       * @VS41107
* CHANGE 02 10/06/77 - MSG IDC21125I FOR SA SUU OR OFFLINE * @ZA27324
*                                                          * @Z40LB64
************************************************************ @Z40LB64
         EJECT                                               @Z40LB64
IDCTSCH0 CSECT                                               @Z40LB64
         SPACE 1                                             @Z40LB64
************************************************************ @Z40LB64
*                                                          * @Z40LB64
* THIS SECTION CONTAINS THE INDICES TO REACH AN ENTRY.     * @Z40LB64
*                                                          * @Z40LB64
************************************************************ @Z40LB64
         SPACE 1                                             @Z40LB64
INDEX    DC    H'125'                  STATIC TEXT ENTRY CNT @Z40LB64
         SPACE 1                                             @Z40LB64
*   PRIMARY MESSAGE STATIC TEXT ENTRIES                      @Z40LB64
         SPACE 1                                             @Z40LB64
INDEX1   DC    Y(TXT1-INDEX)           INCONSISTENT FIELDS   @Z40LB64
INDEX2   DC    Y(TXT2-INDEX)           DUPLICATE FIELDS      @Z40LB64
INDEX3   DC    Y(TXT3-INDEX)           UNEQUAL SUMS          @Z40LB64
INDEX4   DC    Y(TXT4-INDEX)           NO MATCHING ENTRY     @Z40LB64
INDEX5   DC    Y(TXT5-INDEX)           SA SUU OR OFFLINE     @ZA27324
INDEX6   DC    Y(TXT6-INDEX)           UNABLE TO READ MSC MAIN @ZA27324
INDEX7   DC    Y(TXT7-INDEX)           UNABLE TO READ SA WCS @ZA27324
INDEX8   DC    H'-1'                   RESERVED              @Z40LB64
INDEX9   DC    H'-1'                   RESERVED              @Z40LB64
INDEX10  DC    H'-1'                   RESERVED              @Z40LB64
INDEX11  DC    H'-1'                   RESERVED              @Z40LB64
INDEX12  DC    H'-1'                   RESERVED              @Z40LB64
INDEX13  DC    H'-1'                   RESERVED              @Z40LB64
INDEX14  DC    H'-1'                   RESERVED              @Z40LB64
         SPACE 1                                             @Z40LB64
*   PRIMARY MESSAGE CONTINUATION LINE STATIC TEXT ENTRIES    @Z40LB64
         SPACE 1                                             @Z40LB64
INDEX15  DC    Y(TXT15-INDEX)          UNEQUAL SUMS (LINE 2) @Z40LB64
INDEX16  DC    Y(TXT16-INDEX)          UNEQUAL SUMS (LINE 3) @Z40LB64
INDEX17  DC    Y(TXT17-INDEX)          NO MATCHING ENTRY (2) @Z40LB64
INDEX18  DC    Y(TXT18-INDEX)          NO MATCHING ENTRY (3) @Z40LB64
INDEX19  DC    H'-1'                   RESERVED              @Z40LB64
INDEX20  DC    H'-1'                   RESERVED              @Z40LB64
         SPACE 1                                             @Z40LB64
*   SECONDARY MESSAGE STATIC TEXT ENTRIES                    @Z40LB64
         SPACE 1                                             @Z40LB64
INDEX21  DC    Y(TXT21-INDEX)          VALUE=AAA  TABLE=BBB  @Z40LB64
INDEX22  DC    Y(TXT22-INDEX)          (INDEX=CCC)           @Z40LB64
INDEX23  DC    Y(TXT23-INDEX)          (INDEX=CCC,INDEX=CCC) @Z40LB64
INDEX24  DC    Y(TXT24-INDEX)          (INDEX=CCC,INDEX=CCC, @Z40LB64
*                                      INDEX=CCC)            @Z40LB64
INDEX25  DC    Y(TXT25-INDEX)          (INDEX=CCC,INDEX=CCC, @Z40LB64
*                                      INDEX=CCC,INDEX=CCC)  @Z40LB64
         SPACE 1                                             @Z40LB64
*   FIELD NAME STATIC TEXT ENTRIES                           @Z40LB64
         SPACE 1                                             @Z40LB64
INDEX26  DC    Y(TXT26-INDEX)          VOLUME MOUNTED STATUS @Z40LB64
INDEX27  DC    Y(TXT27-INDEX)          VOLUME SECURE STATUS  @Z40LB64
INDEX28  DC    Y(TXT28-INDEX)          VOL EXCLUSIVE STATUS  @Z40LB64
INDEX29  DC    Y(TXT29-INDEX)          VOLUME BOUND STATUS   @Z40LB64
INDEX30  DC    Y(TXT30-INDEX)          VOL RESERVED STATUS   @Z40LB64
INDEX31  DC    Y(TXT31-INDEX)          WRITE INHIBIT STATUS  @Z40LB64
INDEX32  DC    Y(TXT32-INDEX)          MSF IDENTIFIER        @Z40LB64
INDEX33  DC    Y(TXT33-INDEX)          VOLUME SERIAL NUMBER  @Z40LB64
INDEX34  DC    Y(TXT34-INDEX)          MANUFACTURER'S ID     @Z40LB64
INDEX35  DC    Y(TXT35-INDEX)          VIRTUAL VOL ADDRESS   @Z40LB64
INDEX36  DC    Y(TXT36-INDEX)          VIRTUAL PAGE          @Z40LB64
INDEX37  DC    Y(TXT37-INDEX)          REAL UNIT ADDRESS     @Z40LB64
INDEX38  DC    Y(TXT38-INDEX)          STAGING ADAPTER ID    @Z40LB64
INDEX39  DC    Y(TXT39-INDEX)          FREE PAGE STATUS      @Z40LB64
INDEX40  DC    Y(TXT40-INDEX)          FREE PAGE COUNTS      @Z40LB64
INDEX41  DC    Y(TXT41-INDEX)          ACTIVE PAGE COUNTS    @Z40LB64
INDEX42  DC    Y(TXT42-INDEX)          INACTIVE PAGE COUNTS  @Z40LB64
INDEX43  DC    Y(TXT43-INDEX)          BOUND PAGE COUNTS     @Z40LB64
INDEX44  DC    Y(TXT44-INDEX)          MVT POINTER           @Z40LB64
INDEX45  DC    Y(TXT45-INDEX)          CELL ADDRESS          @Z40LB64
INDEX46  DC    Y(TXT46-INDEX)          CELL OCCUPIED STATUS  @Z40LB64
INDEX47  DC    Y(TXT47-INDEX)          CPU IDENTIFIER        @Z40LB64
INDEX48  DC    Y(TXT48-INDEX)          STAGING DRIVE GROUP   @Z40LB64
INDEX49  DC    Y(TXT49-INDEX)          LOGICAL 3333 ADDRESS  @Z40LB64
INDEX50  DC    Y(TXT50-INDEX)          CARTRIDGE SERIAL      @Z40LB64
INDEX51  DC    Y(TXT51-INDEX)          LRU DELTAS            @Z40LB64
INDEX52  DC    Y(TXT52-INDEX)          MOUNTED VOLUMES       @Z40LB64
INDEX53  DC    Y(TXT53-INDEX)          VIRTUAL UNIT ADDRESS  @Z40LB64
INDEX54  DC    Y(TXT54-INDEX)          BOUND PAGE STATUS     @Z40LB64
INDEX55  DC    Y(TXT55-INDEX)          DEVICE VALID STATUS   @Z40LB64
INDEX56  DC    Y(TXT56-INDEX)          DEVICE ONLINE STATUS  @Z40LB64
INDEX57  DC    Y(TXT57-INDEX)          ADDRESS IN-USE STATUS @Z40LB64
INDEX58  DC    Y(TXT58-INDEX)          ALTERNATE PATH        @Z40LB64
INDEX59  DC    Y(TXT59-INDEX)          VOL SHARED STATUS     @Z40LB64
INDEX60  DC    Y(TXT60-INDEX)          REAL PAGE             @Z40LB64
INDEX61  DC    Y(TXT61-INDEX)          ACTIVE PAGE STATUS    @Z40LB64
INDEX62  DC    Y(TXT62-INDEX)          INACTIVE PAGE STATUS  @Z40LB64
INDEX63  DC    Y(TXT63-INDEX)          FREE PAGES            @Z40LB64
INDEX64  DC    Y(TXT64-INDEX)          ACTIVE PAGES          @Z40LB64
INDEX65  DC    Y(TXT65-INDEX)          INACTIVE PAGES        @Z40LB64
INDEX66  DC    Y(TXT66-INDEX)          BOUND PAGES           @Z40LB64
INDEX67  DC    H'-1'                   RESERVED              @Z40LB64
INDEX68  DC    H'-1'                   RESERVED              @Z40LB64
INDEX69  DC    H'-1'                   RESERVED              @Z40LB64
INDEX70  DC    H'-1'                   RESERVED              @Z40LB64
INDEX71  DC    H'-1'                   RESERVED              @Z40LB64
INDEX72  DC    H'-1'                   RESERVED              @Z40LB64
INDEX73  DC    H'-1'                   RESERVED              @Z40LB64
INDEX74  DC    H'-1'                   RESERVED              @Z40LB64
INDEX75  DC    H'-1'                   RESERVED              @Z40LB64
         SPACE 1                                             @Z40LB64
*   TABLE NAME STATIC TEXT ENTRIES                           @Z40LB64
         SPACE 1                                             @Z40LB64
INDEX76  DC    Y(TXT76-INDEX)          MOUNTED VOLUME TABLE  @Z40LB64
INDEX77  DC    Y(TXT77-INDEX)          VOLUME INVENTORY      @Z40LB64
INDEX78  DC    Y(TXT78-INDEX)          TRANSIENT VOLUME LIST @Z40LB64
INDEX79  DC    Y(TXT79-INDEX)          SCRATCH CTG LIST      @Z40LB64
INDEX80  DC    Y(TXT80-INDEX)          MSVI DATA SET         @Z40LB64
INDEX81  DC    Y(TXT81-INDEX)          CELL MAP              @Z40LB64
INDEX82  DC    Y(TXT82-INDEX)          MFR'S ID CONVERSION   @Z40LB64
INDEX83  DC    Y(TXT83-INDEX)          VIRT ADDR DIRECTORY   @Z40LB64
INDEX84  DC    Y(TXT84-INDEX)          PAGE STATUS TABLE     @Z40LB64
INDEX85  DC    Y(TXT85-INDEX)          LOGICAL TO REAL TABLE @Z40LB64
INDEX86  DC    Y(TXT86-INDEX)          VIRT VOL INFO TABLE   @Z40LB64
INDEX87  DC    Y(TXT87-INDEX)          PAGE AVAIL. BLOCK     @Z40LB64
INDEX88  DC    Y(TXT88-INDEX)          DEMOUNTED VOL BLOCK   @Z40LB64
INDEX89  DC    Y(TXT89-INDEX)          LRU PAGES BLOCK       @Z40LB64
INDEX90  DC    Y(TXT90-INDEX)          REAL PAGE MAP         @Z40LB64
INDEX91  DC    Y(TXT91-INDEX)          VVA/MVT CROSS-REF     @Z40LB64
INDEX92  DC    Y(TXT92-INDEX)          VIRT VOL ADDR TABLE   @Z40LB64
INDEX93  DC    Y(TXT93-INDEX)          CONFIGURATION INDEX   @Z40LB64
INDEX94  DC    Y(TXT94-INDEX)          CONFIG DATA BLOCK     @Z40LB64
INDEX95  DC    Y(TXT95-INDEX)          MOUNT EQUALIZATION    @Z40LB64
INDEX96  DC    Y(TXT96-INDEX)          CONFIG BIT MAP        @Z40LB64
INDEX97  DC    Y(TXT97-INDEX)          VI, TVL, OR SCL       @Z40LB64
INDEX98  DC    H'-1'                   RESERVED              @Z40LB64
INDEX99  DC    H'-1'                   RESERVED              @Z40LB64
INDEX100 DC    H'-1'                   RESERVED              @Z40LB64
         SPACE 1                                             @Z40LB64
*   TABLE INDEX NAME STATIC TEXT ENTRIES                     @Z40LB64
         SPACE 1                                             @Z40LB64
INDEX101 DC    Y(TXT101-INDEX)         CSN                   @Z40LB64
INDEX102 DC    Y(TXT102-INDEX)         VOL                   @Z40LB64
INDEX103 DC    Y(TXT103-INDEX)         KEY                   @Z40LB64
INDEX104 DC    Y(TXT104-INDEX)         MSF                   @Z40LB64
INDEX105 DC    Y(TXT105-INDEX)         CPU                   @Z40LB64
INDEX106 DC    Y(TXT106-INDEX)         SA                    @Z40LB64
INDEX107 DC    Y(TXT107-INDEX)         SDG                   @Z40LB64
INDEX108 DC    Y(TXT108-INDEX)         VUA                   @Z40LB64
INDEX109 DC    Y(TXT109-INDEX)         XYZ                   @Z40LB64
INDEX110 DC    Y(TXT110-INDEX)         LUA                   @Z40LB64
INDEX111 DC    Y(TXT111-INDEX)         VVA                   @Z40LB64
INDEX112 DC    Y(TXT112-INDEX)         INTERFACE             @Z40LB64
INDEX113 DC    Y(TXT113-INDEX)         REALPAGE              @Z40LB64
INDEX114 DC    Y(TXT114-INDEX)         CHR                   @Z40LB64
INDEX115 DC    H'-1'                   RESERVED              @Z40LB64
INDEX116 DC    H'-1'                   RESERVED              @Z40LB64
INDEX117 DC    H'-1'                   RESERVED              @Z40LB64
INDEX118 DC    H'-1'                   RESERVED              @Z40LB64
INDEX119 DC    H'-1'                   RESERVED              @Z40LB64
INDEX120 DC    H'-1'                   RESERVED              @Z40LB64
INDEX121 DC    H'-1'                   RESERVED              @Z40LB64
INDEX122 DC    H'-1'                   RESERVED              @Z40LB64
INDEX123 DC    H'-1'                   RESERVED              @Z40LB64
INDEX124 DC    H'-1'                   RESERVED              @Z40LB64
INDEX125 DC    H'-1'                   RESERVED              @Z40LB64
         EJECT                                               @Z40LB64
************************************************************ @Z40LB64
*                                                          * @Z40LB64
* THIS SECTION CONTAINS THE STATIC TEXT ENTRIES.           * @Z40LB64
*                                                          * @Z40LB64
************************************************************ @Z40LB64
         SPACE 1                                             @Z40LB64
************************************************************ @Z40LB64
*                                                          * @Z40LB64
* PRIMARY MESSAGE STATIC TEXT ENTRIES.                     * @Z40LB64
*                                                          * @Z40LB64
************************************************************ @Z40LB64
         SPACE 1                                             @Z40LB64
************************************************************ @Z40LB64
*                                                          * @Z40LB64
* IDC01120I INCONSISTENT 'FIELD NAME'                      * @Z40LB64
*                                                          * @Z40LB64
************************************************************ @Z40LB64
         SPACE 1                                             @Z40LB64
TXT1     DC    Y(TXT1B-TXT1A)          ENTRY LENGTH          @Z40LB64
         DC    H'0'                                          @Z40LB64
         SPACE 1                                             @Z40LB64
* STATIC TEXT SUB-STRUCTURE                                  @Z40LB64
TXT1A    DC    X'8400'                 STATIC TEXT FLAGS     @Z40LB64
         DC    Y(STE1B-STE1A)          TEXT LENGTH           @Z40LB64
         DC    Y(STE1A-TXT1A)          TEXT OFFSET           @Z40LB64
         DC    H'1'                    PRINT COLUMN          @Z40LB64
         DC    Y(STE1B-STE1A)          PRINT FIELD LENGTH    @Z40LB64
         DC    H'0'                    CONVERSION FLAGS      @Z40LB64
         SPACE 1                                             @Z40LB64
* STATIC TEXT ENTRY                                          @Z40LB64
STE1A    DC    YL1(STE1B-MSG1)         MESSAGE LENGTH        @Z40LB64
         DC    FL1'0'                  NEXT STATIC TEXT      @Z40LB64
         DC    X'84'                   MESSAGE FLAGS         @Z40LB64
         DC    FL1'1'                  INSERT COUNT          @Z40LB64
         DC    X'80'                   INSERT TYPE           @Z40LB64
         DC    FL1'25'                 INSERT POSITION       @Z40LB64
MSG1     DC    C'IDC01120I  INCONSISTENT '                   @Z40LB64
STE1B    EQU   *                                             @Z40LB64
TXT1B    EQU   *                                             @Z40LB64
         EJECT                                               @Z40LB64
************************************************************ @Z40LB64
*                                                          * @Z40LB64
* IDC01121I DUPLICATE 'FIELD NAME' REFERENCE FOUND         * @Z40LB64
*                                                          * @Z40LB64
************************************************************ @Z40LB64
         SPACE 1                                             @Z40LB64
TXT2     DC    Y(TXT2B-TXT2A)          ENTRY LENGTH          @Z40LB64
         DC    H'0'                                          @Z40LB64
         SPACE 1                                             @Z40LB64
* STATIC TEXT SUB-STRUCTURE                                  @Z40LB64
TXT2A    DC    X'8400'                 STATIC TEXT FLAGS     @Z40LB64
         DC    Y(STE2B-STE2A)          TEXT LENGTH           @Z40LB64
         DC    Y(STE2A-TXT2A)          TEXT OFFSET           @Z40LB64
         DC    H'1'                    PRINT COLUMN          @Z40LB64
         DC    Y(STE2B-STE2A)          PRINT FIELD LENGTH    @Z40LB64
         DC    H'0'                    CONVERSION FLAGS      @Z40LB64
         SPACE 1                                             @Z40LB64
* STATIC TEXT ENTRY                                          @Z40LB64
STE2A    DC    YL1(STE2B-MSG2)         MESSAGE LENGTH        @Z40LB64
         DC    FL1'0'                  NEXT STATIC TEXT      @Z40LB64
         DC    X'84'                   MESSAGE FLAGS         @Z40LB64
         DC    FL1'1'                  INSERT COUNT          @Z40LB64
         DC    X'80'                   INSERT TYPE           @Z40LB64
         DC    FL1'22'                 INSERT POSITION       @Z40LB64
MSG2     DC    C'IDC01121I  DUPLICATE  REFERENCE FOUND'      @Z40LB64
STE2B    EQU   *                                             @Z40LB64
TXT2B    EQU   *                                             @Z40LB64
         EJECT                                               @Z40LB64
************************************************************ @Z40LB64
*                                                          * @Z40LB64
* IDC01122I  SUM='VALUE' OF INDIVIDUAL 'FIELD NAME'        * @Z40LB64
*            FROM 'TABLE NAME'                             * @Z40LB64
*            NOT EQUAL TO TOTAL VALUE                      * @Z40LB64
*            (FIRST LINE OF MESSAGE)                       * @Z40LB64
*                                                          * @Z40LB64
************************************************************ @Z40LB64
         SPACE 1                                             @Z40LB64
TXT3     DC    Y(TXT3B-TXT3A)          ENTRY LENGTH          @Z40LB64
         DC    H'0'                                          @Z40LB64
         SPACE 1                                             @Z40LB64
* STATIC TEXT SUB-STRUCTURE                                  @Z40LB64
TXT3A    DC    X'8400'                 STATIC TEXT FLAGS     @Z40LB64
         DC    Y(STE3B-STE3A)          TEXT LENGTH           @Z40LB64
         DC    Y(STE3A-TXT3A)          TEXT OFFSET           @Z40LB64
         DC    H'1'                    PRINT COLUMN          @Z40LB64
         DC    Y(STE3B-STE3A)          PRINT FIELD LENGTH    @Z40LB64
         DC    H'0'                    CONVERSION FLAGS      @Z40LB64
         SPACE 1                                             @Z40LB64
* STATIC TEXT ENTRY                                          @Z40LB64
STE3A    DC    YL1(STE3B-MSG3)         MESSAGE LENGTH        @Z40LB64
         DC    FL1'15'                 NEXT STATIC TEXT      @Z40LB64
         DC    X'88'                   MESSAGE FLAGS         @Z40LB64
         DC    FL1'2'                  INSERT COUNT          @Z40LB64
         DC    X'40'                   INSERT #1 TYPE        @Z40LB64
         DC    FL1'16'                 INSERT #1 POSITION    @Z40LB64
         DC    X'80'                   INSERT #2 TYPE        @Z40LB64
         DC    FL1'31'                 INSERT #2 POSITION    @Z40LB64
MSG3     DC    C'IDC01122I  SUM= OF INDIVIDUAL '             @Z40LB64
STE3B    EQU   *                                             @Z40LB64
TXT3B    EQU   *                                             @Z40LB64
         EJECT                                               @Z40LB64
************************************************************ @Z40LB64
*                                                          * @Z40LB64
* IDC01122I  SUM='VALUE' OF INDIVIDUAL 'FIELD NAME'        * @Z40LB64
*            FROM 'TABLE NAME'                             * @Z40LB64
*            NOT EQUAL TO TOTAL VALUE                      * @Z40LB64
*            (SECOND LINE OF MESSAGE)                      * @Z40LB64
*                                                          * @Z40LB64
************************************************************ @Z40LB64
         SPACE 1                                             @Z40LB64
TXT15    DC    Y(TXT15B-TXT15A)        ENTRY LENGTH          @Z40LB64
         DC    H'0'                                          @Z40LB64
         SPACE 1                                             @Z40LB64
* STATIC TEXT SUB-STRUCTURE                                  @Z40LB64
TXT15A   DC    X'8400'                 STATIC TEXT FLAGS     @Z40LB64
         DC    Y(STE15B-STE15A)        TEXT LENGTH           @Z40LB64
         DC    Y(STE15A-TXT15A)        TEXT OFFSET           @Z40LB64
         DC    H'1'                    PRINT COLUMN          @Z40LB64
         DC    Y(STE15B-STE15A)        PRINT FIELD LENGTH    @Z40LB64
         DC    H'0'                    CONVERSION FLAGS      @Z40LB64
         SPACE 1                                             @Z40LB64
* STATIC TEXT ENTRY                                          @Z40LB64
STE15A   DC    YL1(STE15B-MSG15)       MESSAGE LENGTH        @Z40LB64
         DC    FL1'16'                 NEXT STATIC TEXT      @Z40LB64
         DC    X'A8'                   MESSAGE FLAGS         @Z40LB64
         DC    FL1'1'                  INSERT COUNT          @Z40LB64
         DC    X'20'                   INSERT TYPE           @Z40LB64
         DC    FL1'6'                  INSERT POSITION       @Z40LB64
MSG15    DC    C'FROM '                                      @Z40LB64
STE15B   EQU   *                                             @Z40LB64
TXT15B   EQU   *                                             @Z40LB64
         EJECT                                               @Z40LB64
************************************************************ @Z40LB64
*                                                          * @Z40LB64
* IDC01122I  SUM='VALUE' OF INDIVIDUAL 'FIELD NAME'        * @Z40LB64
*            FROM 'TABLE NAME'                             * @Z40LB64
*            NOT EQUAL TO TOTAL VALUE                      * @Z40LB64
*            (THIRD LINE OF MESSAGE)                       * @Z40LB64
*                                                          * @Z40LB64
************************************************************ @Z40LB64
         SPACE 1                                             @Z40LB64
TXT16    DC    Y(TXT16B-TXT16A)        ENTRY LENGTH          @Z40LB64
         DC    H'0'                                          @Z40LB64
         SPACE 1                                             @Z40LB64
* STATIC TEXT SUB-STRUCTURE                                  @Z40LB64
TXT16A   DC    X'8400'                 STATIC TEXT FLAGS     @Z40LB64
         DC    Y(STE16B-STE16A)        TEXT LENGTH           @Z40LB64
         DC    Y(STE16A-TXT16A)        TEXT OFFSET           @Z40LB64
         DC    H'1'                    PRINT COLUMN          @Z40LB64
         DC    Y(STE16B-STE16A)        PRINT FIELD LENGTH    @Z40LB64
         DC    H'0'                    CONVERSION FLAGS      @Z40LB64
         SPACE 1                                             @Z40LB64
* STATIC TEXT ENTRY                                          @Z40LB64
STE16A   DC    YL1(STE16B-MSG16)       MESSAGE LENGTH        @Z40LB64
         DC    FL1'0'                  NEXT STATIC TEXT      @Z40LB64
         DC    X'A8'                   MESSAGE FLAGS         @Z40LB64
         DC    FL1'0'                  INSERT COUNT          @Z40LB64
MSG16    DC    C'NOT EQUAL TO TOTAL VALUE'                   @Z40LB64
STE16B   EQU   *                                             @Z40LB64
TXT16B   EQU   *                                             @Z40LB64
         EJECT                                               @Z40LB64
************************************************************ @Z40LB64
*                                                          * @Z40LB64
* IDC01124I  MATCHING 'FIELD NAME'='VALUE'                 * @Z40LB64
*            NOT FOUND IN 'TABLE NAME'                     * @Z40LB64
*            TO MATCH 'TABLE NAME' (TABLE INDICES)         * @Z40LB64
*            (FIRST LINE OF MESSAGE)                       * @Z40LB64
*                                                          * @Z40LB64
************************************************************ @Z40LB64
         SPACE 1                                             @Z40LB64
TXT4     DC    Y(TXT4B-TXT4A)          ENTRY LENGTH          @Z40LB64
         DC    H'0'                                          @Z40LB64
         SPACE 1                                             @Z40LB64
* STATIC TEXT SUB-STRUCTURE                                  @Z40LB64
TXT4A    DC    X'8400'                 STATIC TEXT FLAGS     @Z40LB64
         DC    Y(STE4B-STE4A)          TEXT LENGTH           @Z40LB64
         DC    Y(STE4A-TXT4A)          TEXT OFFSET           @Z40LB64
         DC    H'1'                    PRINT COLUMN          @Z40LB64
         DC    Y(STE4B-STE4A)          PRINT FIELD LENGTH    @Z40LB64
         DC    H'0'                    CONVERSION FLAGS      @Z40LB64
         SPACE 1                                             @Z40LB64
* STATIC TEXT ENTRY                                          @Z40LB64
STE4A    DC    YL1(STE4B-MSG4)         MESSAGE LENGTH        @Z40LB64
         DC    FL1'17'                 NEXT STATIC TEXT      @Z40LB64
         DC    X'90'                   MESSAGE FLAGS         @Z40LB64
         DC    FL1'2'                  INSERT COUNT          @Z40LB64
         DC    X'80'                   INSERT #1 TYPE        @Z40LB64
         DC    FL1'21'                 INSERT #1 POSITION    @Z40LB64
         DC    X'40'                   INSERT #2 TYPE        @Z40LB64
         DC    FL1'22'                 INSERT #2 POSITION    @Z40LB64
MSG4     DC    C'IDC01124I  MATCHING ='                      @Z40LB64
STE4B    EQU   *                                             @Z40LB64
TXT4B    EQU   *                                             @Z40LB64
         EJECT                                               @ZA27324
**********************************************************   @ZA27324
*                                                        *   @ZA27324
* IDC21125I SA NNN TABLES CANNOT BE READ; SA IS OFFLINE  *   @ZA27324
*           OR SUU.                                      *   @ZA27324
*                                                        *   @ZA27324
**********************************************************   @ZA27324
         SPACE 3                                             @ZA27324
TXT5     DC    Y(TXT5B-TXT5A)          ENTRY LENGTH          @ZA27324
         DC    X'8000'                 MESSAGE FLAG          @ZA27324
         SPACE 1                                             @ZA27324
* SPACING CONTROL SUB-STRUCTURE                              @ZA27324
TXT5A    DC    X'4000'                 SPACE CONTROL FLAG    @ZA27324
         DC    H'2'                    SPACING FACTOR        @ZA27324
         DC    C'R '                   SPACING TYPE          @ZA27324
         SPACE 1                                             @ZA27324
* STATIC TEXT SUB-STRUCTURE                                  @ZA27324
         DC    X'0400'                 STATIC TEXT FLAG      @ZA27324
         DC    Y(STE5B-STE5A)          TEXT LENGTH           @ZA27324
         DC    Y(STE5A-TXT5A)          TEXT OFFSET           @ZA27324
         DC    H'1'                    PRINT COLUMN          @ZA27324
         DC    Y(STE5B-STE5A)          PRINT FIELD LENGTH    @ZA27324
         DC    X'0010'                 CONVERSION FLAGS      @ZA27324
         SPACE 1                                             @ZA27324
* BLOCK DATA SUB-STRUCTURE                                   @ZA27324
         DC    X'1000'                 STRUCTURE TYPE FLG    @ZA27324
         DC    H'03,00,01,03'          LNG,OFST,PC,LNG       @ZA27324
         DC    X'0050'                 CONVERSION FLGS       @ZA27324
         SPACE 1                                             @ZA27324
* STATIC TEXT SUB-STRUCTURE                                  @ZA27324
         DC    X'8400'                 STATIC TEXT FLAG      @ZA27324
         DC    Y(STE5D-STE5C)          TEXT LENGTH           @ZA27324
         DC    Y(STE5C-TXT5A)          TEXT OFFSET           @ZA27324
         DC    H'1'                    PRINT COLUMN          @ZA27324
         DC    Y(STE5D-STE5C)          PRINT FIELD LENGTH    @ZA27324
         DC    X'0010'                 CONVERSION FLAGS      @ZA27324
         SPACE 1                                             @ZA27324
* STATIC TEXT ENTRIES                                        @ZA27324
STE5A    DC    C'IDC21125I SA'                               @ZA27324
STE5B    EQU   *                                             @ZA27324
STE5C    DC    C'TABLES CANNOT BE COPIED;  SA IS OFFLINE OR' @ZA27324
         DC    C' SUU.'                                      @ZA27324
STE5D    EQU   *                                             @ZA27324
TXT5B    EQU   *                                             @ZA27324
         EJECT                                               @ZA27324
************************************************************ @ZA27324
*                                                          * @ZA27324
* IDC31126I UNABLE TO READ MSC MAIN STORAGE                * @ZA27324
*                                                          * @ZA27324
************************************************************ @ZA27324
         SPACE 3                                             @ZA27324
TXT6     DC    Y(TXT6B-TXT6A)          ENTRY LENGTH          @ZA27324
         DC    X'8000'                 MESSAGE FLAG          @ZA27324
         SPACE 1                                             @ZA27324
* SPACING CONTROL SUB-STRUCTURE                              @ZA27324
TXT6A    DC    X'4000'                 SPACE CONTROL FLAG    @ZA27324
         DC    H'1'                    SPACING FACTOR        @ZA27324
         DC    C'R '                   SPACING TYPE          @ZA27324
         SPACE 1                                             @ZA27324
* STATIC TEXT SUB-STRUCTURE                                  @ZA27324
         DC    X'8400'                 STATIC TEXT FLAG      @ZA27324
         DC    Y(STE6B-STE6A)          TEXT LENGTH           @ZA27324
         DC    Y(STE6A-TXT6A)          TEXT OFFSET           @ZA27324
         DC    H'1'                    PRINT COLUMN          @ZA27324
         DC    Y(STE6B-STE6A)          PRINT FIELD LENGTH    @ZA27324
         DC    H'0'                    CONVERSION FLAGS      @ZA27324
         SPACE 1                                             @ZA27324
* STATIC TEXT ENTRIES                                        @ZA27324
STE6A    DC    C'IDC31126I UNABLE TO READ MSC MAIN STORAGE'  @ZA27324
STE6B    EQU   *                                             @ZA27324
TXT6B    EQU   *                                             @ZA27324
         EJECT                                               @ZA27324
************************************************************ @ZA27324
*                                                          * @ZA27324
* IDC21127I UNABLE TO READ STAGING ADAPTER STORAGE         * @ZA27324
*                                                          * @ZA27324
************************************************************ @ZA27324
         SPACE 3                                             @ZA27324
TXT7     DC    Y(TXT7B-TXT7A)          ENTRY LENGTH          @ZA27324
         DC    X'8000'                 MESSAGE FLAG          @ZA27324
         SPACE 1                                             @ZA27324
* SPACING CONTROL SUB-STRUCTURE                              @ZA27324
TXT7A    DC    X'4000'                 SPACE CONTROL FLAG    @ZA27324
         DC    H'1'                    SPACING FACTOR        @ZA27324
         DC    C'R '                   SPACING TYPE          @ZA27324
         SPACE 1                                             @ZA27324
* STATIC TEXT SUB-STRUCTURE                                  @ZA27324
         DC    X'8400'                 STATIC TEXT FLAG      @ZA27324
         DC    Y(STE7B-STE7A)          TEXT LENGTH           @ZA27324
         DC    Y(STE7A-TXT7A)          TEXT OFFSET           @ZA27324
         DC    H'1'                    PRINT COLUMN          @ZA27324
         DC    Y(STE7B-STE7A)          PRINT FIELD LENGTH    @ZA27324
         DC    H'0'                    CONVERSION FLAGS      @ZA27324
         SPACE 1                                             @ZA27324
* STATIC TEXT ENTRIES                                        @ZA27324
STE7A    DC    C'IDC21127I UNABLE TO READ STAGING ADAPTER'   @ZA27324
         DC    C' STORAGE'                                   @ZA27324
STE7B    EQU   *                                             @ZA27324
TXT7B    EQU   *                                             @ZA27324
         EJECT                                               @Z40LB64
************************************************************ @Z40LB64
*                                                          * @Z40LB64
* IDC01124I  MATCHING 'FIELD NAME'='VALUE'                 * @Z40LB64
*            NOT FOUND IN 'TABLE NAME'                     * @Z40LB64
*            TO MATCH 'TABLE NAME' (TABLE INDICES)         * @Z40LB64
*            (SECOND LINE OF MESSAGE)                      * @Z40LB64
*                                                          * @Z40LB64
************************************************************ @Z40LB64
         SPACE 1                                             @Z40LB64
TXT17    DC    Y(TXT17B-TXT17A)        ENTRY LENGTH          @Z40LB64
         DC    H'0'                                          @Z40LB64
         SPACE 1                                             @Z40LB64
* STATIC TEXT SUB-STRUCTURE                                  @Z40LB64
TXT17A   DC    X'8400'                 STATIC TEXT FLAGS     @Z40LB64
         DC    Y(STE17B-STE17A)        TEXT LENGTH           @Z40LB64
         DC    Y(STE17A-TXT17A)        TEXT OFFSET           @Z40LB64
         DC    H'1'                    PRINT COLUMN          @Z40LB64
         DC    Y(STE17B-STE17A)        PRINT FIELD LENGTH    @Z40LB64
         DC    H'0'                    CONVERSION FLAGS      @Z40LB64
         SPACE 1                                             @Z40LB64
* STATIC TEXT ENTRY                                          @Z40LB64
STE17A   DC    YL1(STE17B-MSG17)       MESSAGE LENGTH        @Z40LB64
         DC    FL1'18'                 NEXT STATIC TEXT      @Z40LB64
         DC    X'B0'                   MESSAGE FLAGS         @Z40LB64
         DC    FL1'1'                  INSERT COUNT          @Z40LB64
         DC    X'20'                   INSERT TYPE           @Z40LB64
         DC    FL1'14'                 INSERT POSITION       @Z40LB64
MSG17    DC    C'NOT FOUND IN '                              @Z40LB64
STE17B   EQU   *                                             @Z40LB64
TXT17B   EQU   *                                             @Z40LB64
         EJECT                                               @Z40LB64
************************************************************ @Z40LB64
*                                                          * @Z40LB64
* IDC01124I  MATCHING 'FIELD NAME'='VALUE'                 * @Z40LB64
*            NOT FOUND IN 'TABLE NAME'                     * @Z40LB64
*            TO MATCH 'TABLE NAME' (TABLE INDICES)         * @Z40LB64
*            (THIRD LINE OF MESSAGE)                       * @Z40LB64
*                                                          * @Z40LB64
************************************************************ @Z40LB64
         SPACE 1                                             @Z40LB64
TXT18    DC    Y(TXT18B-TXT18A)        ENTRY LENGTH          @Z40LB64
         DC    H'0'                                          @Z40LB64
         SPACE 1                                             @Z40LB64
* STATIC TEXT SUB-STRUCTURE                                  @Z40LB64
TXT18A   DC    X'8400'                 STATIC TEXT FLAGS     @Z40LB64
         DC    Y(STE18B-STE18A)        TEXT LENGTH           @Z40LB64
         DC    Y(STE18A-TXT18A)        TEXT OFFSET           @Z40LB64
         DC    H'1'                    PRINT COLUMN          @Z40LB64
         DC    Y(STE18B-STE18A)        PRINT FIELD LENGTH    @Z40LB64
         DC    H'0'                    CONVERSION FLAGS      @Z40LB64
         SPACE 1                                             @Z40LB64
* STATIC TEXT ENTRY                                          @Z40LB64
STE18A   DC    YL1(STE18B-MSG18)       MESSAGE LENGTH        @Z40LB64
         DC    FL1'22'                 NEXT STATIC TEXT      @Z40LB64
         DC    X'B0'                   MESSAGE FLAGS         @Z40LB64
         DC    FL1'1'                  INSERT COUNT          @Z40LB64
         DC    X'20'                   INSERT TYPE           @Z40LB64
         DC    FL1'10'                 INSERT POSITION       @Z40LB64
MSG18    DC    C'TO MATCH '                                  @Z40LB64
STE18B   EQU   *                                             @Z40LB64
TXT18B   EQU   *                                             @Z40LB64
         EJECT                                               @Z40LB64
************************************************************ @Z40LB64
*                                                          * @Z40LB64
* SECONDARY MESSAGE STATIC TEXT ENTRIES.                   * @Z40LB64
*                                                          * @Z40LB64
************************************************************ @Z40LB64
         SPACE 1                                             @Z40LB64
************************************************************ @Z40LB64
*                                                          * @Z40LB64
* IDC01123I  ** VALUE='VALUE' 'TABLE NAME' (TABLE INDICES) * @Z40LB64
*            (FIRST LINE OF MESSAGE)                       * @Z40LB64
*                                                          * @Z40LB64
************************************************************ @Z40LB64
         SPACE 1                                             @Z40LB64
TXT21    DC    Y(TXT21B-TXT21A)        ENTRY LENGTH          @Z40LB64
         DC    H'0'                                          @Z40LB64
         SPACE 1                                             @Z40LB64
* STATIC TEXT SUB-STRUCTURE                                  @Z40LB64
TXT21A   DC    X'8400'                 STATIC TEXT FLAGS     @Z40LB64
         DC    Y(STE21B-STE21A)        TEXT LENGTH           @Z40LB64
         DC    Y(STE21A-TXT21A)        TEXT OFFSET           @Z40LB64
         DC    H'1'                    PRINT COLUMN          @Z40LB64
         DC    Y(STE21B-STE21A)        PRINT FIELD LENGTH    @Z40LB64
         DC    H'0'                    CONVERSION FLAGS      @Z40LB64
         SPACE 1                                             @Z40LB64
* STATIC TEXT ENTRY                                          @Z40LB64
STE21A   DC    YL1(STE21B-MSG21)       MESSAGE LENGTH        @Z40LB64
         DC    FL1'22'                 NEXT STATIC TEXT      @Z40LB64
         DC    X'48'                   MESSAGE FLAGS         @Z40LB64
         DC    FL1'2'                  INSERT COUNT          @Z40LB64
         DC    X'40'                   INSERT #1 TYPE        @Z40LB64
         DC    FL1'21'                 INSERT #1 POSITION    @Z40LB64
         DC    X'20'                   INSERT #2 TYPE        @Z40LB64
         DC    FL1'23'                 INSERT #2 POSITION    @Z40LB64
MSG21    DC    C'IDC01123I  ** VALUE=  '                     @Z40LB64
STE21B   EQU   *                                             @Z40LB64
TXT21B   EQU   *                                             @Z40LB64
         EJECT                                               @Z40LB64
************************************************************ @Z40LB64
*                                                          * @Z40LB64
* ('TABLE INDEX'='VALUE')                                  * @Z40LB64
*                                                          * @Z40LB64
************************************************************ @Z40LB64
         SPACE 1                                             @Z40LB64
TXT22    DC    Y(TXT22B-TXT22A)        ENTRY LENGTH          @Z40LB64
         DC    H'0'                                          @Z40LB64
         SPACE 1                                             @Z40LB64
* STATIC TEXT SUB-STRUCTURE                                  @Z40LB64
TXT22A   DC    X'8400'                 STATIC TEXT FLAGS     @Z40LB64
         DC    Y(STE22B-STE22A)        TEXT LENGTH           @Z40LB64
         DC    Y(STE22A-TXT22A)        TEXT OFFSET           @Z40LB64
         DC    H'1'                    PRINT COLUMN          @Z40LB64
         DC    Y(STE22B-STE22A)        PRINT FIELD LENGTH    @Z40LB64
         DC    H'0'                    CONVERSION FLAGS      @Z40LB64
         SPACE 1                                             @Z40LB64
* STATIC TEXT ENTRY                                          @Z40LB64
STE22A   DC    YL1(STE22B-MSG22)       MESSAGE LENGTH        @Z40LB64
         DC    FL1'0'                  NEXT STATIC TEXT      @Z40LB64
         DC    X'70'                   MESSAGE FLAGS         @Z40LB64
         DC    FL1'2'                  INSERT COUNT          @Z40LB64
         DC    X'10'                   INSERT #1 TYPE        @Z40LB64
         DC    FL1'2'                  INSERT #1 POSITION    @Z40LB64
         DC    X'08'                   INSERT #2 TYPE        @Z40LB64
         DC    FL1'3'                  INSERT #2 POSITION    @Z40LB64
MSG22    DC    C'(=)'                                        @Z40LB64
STE22B   EQU   *                                             @Z40LB64
TXT22B   EQU   *                                             @Z40LB64
         EJECT                                               @Z40LB64
************************************************************ @Z40LB64
*                                                          * @Z40LB64
* ('TABLE INDEX'='VALUE','TABLE INDEX'='VALUE')            * @Z40LB64
*                                                          * @Z40LB64
************************************************************ @Z40LB64
         SPACE 1                                             @Z40LB64
TXT23    DC    Y(TXT23B-TXT23A)        ENTRY LENGTH          @Z40LB64
         DC    H'0'                                          @Z40LB64
         SPACE 1                                             @Z40LB64
* STATIC TEXT SUB-STRUCTURE                                  @Z40LB64
TXT23A   DC    X'8400'                 STATIC TEXT FLAGS     @Z40LB64
         DC    Y(STE23B-STE23A)        TEXT LENGTH           @Z40LB64
         DC    Y(STE23A-TXT23A)        TEXT OFFSET           @Z40LB64
         DC    H'1'                    PRINT COLUMN          @Z40LB64
         DC    Y(STE23B-STE23A)        PRINT FIELD LENGTH    @Z40LB64
         DC    H'0'                    CONVERSION FLAGS      @Z40LB64
         SPACE 1                                             @Z40LB64
* STATIC TEXT ENTRY                                          @Z40LB64
STE23A   DC    YL1(STE23B-MSG23)       MESSAGE LENGTH        @Z40LB64
         DC    FL1'0'                  NEXT STATIC TEXT      @Z40LB64
         DC    X'70'                   MESSAGE FLAGS         @Z40LB64
         DC    FL1'4'                  INSERT COUNT          @Z40LB64
         DC    X'10'                   INSERT #1 TYPE        @Z40LB64
         DC    FL1'2'                  INSERT #1 POSITION    @Z40LB64
         DC    X'08'                   INSERT #2 TYPE        @Z40LB64
         DC    FL1'3'                  INSERT #2 POSITION    @Z40LB64
         DC    X'10'                   INSERT #3 TYPE        @Z40LB64
         DC    FL1'4'                  INSERT #3 POSITION    @Z40LB64
         DC    X'08'                   INSERT #4 TYPE        @Z40LB64
         DC    FL1'5'                  INSERT #4 POSITION    @Z40LB64
MSG23    DC    C'(=,=)'                                      @Z40LB64
STE23B   EQU   *                                             @Z40LB64
TXT23B   EQU   *                                             @Z40LB64
         EJECT                                               @Z40LB64
************************************************************ @Z40LB64
*                                                          * @Z40LB64
* ('TABLE INDEX'='VALUE','TABLE INDEX'='VALUE',            * @Z40LB64
*  'TABLE INDEX'='VALUE')                                  * @Z40LB64
*                                                          * @Z40LB64
************************************************************ @Z40LB64
         SPACE 1                                             @Z40LB64
TXT24    DC    Y(TXT24B-TXT24A)        ENTRY LENGTH          @Z40LB64
         DC    H'0'                                          @Z40LB64
         SPACE 1                                             @Z40LB64
* STATIC TEXT SUB-STRUCTURE                                  @Z40LB64
TXT24A   DC    X'8400'                 STATIC TEXT FLAGS     @Z40LB64
         DC    Y(STE24B-STE24A)        TEXT LENGTH           @Z40LB64
         DC    Y(STE24A-TXT24A)        TEXT OFFSET           @Z40LB64
         DC    H'1'                    PRINT COLUMN          @Z40LB64
         DC    Y(STE24B-STE24A)        PRINT FIELD LENGTH    @Z40LB64
         DC    H'0'                    CONVERSION FLAGS      @Z40LB64
         SPACE 1                                             @Z40LB64
* STATIC TEXT ENTRY                                          @Z40LB64
STE24A   DC    YL1(STE24B-MSG24)       MESSAGE LENGTH        @Z40LB64
         DC    FL1'0'                  NEXT STATIC TEXT      @Z40LB64
         DC    X'70'                   MESSAGE FLAGS         @Z40LB64
         DC    FL1'6'                  INSERT COUNT          @Z40LB64
         DC    X'10'                   INSERT #1 TYPE        @Z40LB64
         DC    FL1'2'                  INSERT #1 POSITION    @Z40LB64
         DC    X'08'                   INSERT #2 TYPE        @Z40LB64
         DC    FL1'3'                  INSERT #2 POSITION    @Z40LB64
         DC    X'10'                   INSERT #3 TYPE        @Z40LB64
         DC    FL1'4'                  INSERT #3 POSITION    @Z40LB64
         DC    X'08'                   INSERT #4 TYPE        @Z40LB64
         DC    FL1'5'                  INSERT #4 POSITION    @Z40LB64
         DC    X'10'                   INSERT #5 TYPE        @Z40LB64
         DC    FL1'6'                  INSERT #5 POSITION    @Z40LB64
         DC    X'08'                   INSERT #6 TYPE        @Z40LB64
         DC    FL1'7'                  INSERT #6 POSITION    @Z40LB64
MSG24    DC    C'(=,=,=)'                                    @Z40LB64
STE24B   EQU   *                                             @Z40LB64
TXT24B   EQU   *                                             @Z40LB64
         EJECT                                               @Z40LB64
************************************************************ @Z40LB64
*                                                          * @Z40LB64
* ('TABLE INDEX'='VALUE','TABLE INDEX'='VALUE',            * @Z40LB64
*  'TABLE INDEX'='VALUE','TABLE INDEX'='VALUE')            * @Z40LB64
*                                                          * @Z40LB64
************************************************************ @Z40LB64
         SPACE 1                                             @Z40LB64
TXT25    DC    Y(TXT25B-TXT25A)        ENTRY LENGTH          @Z40LB64
         DC    H'0'                                          @Z40LB64
         SPACE 1                                             @Z40LB64
* STATIC TEXT SUB-STRUCTURE                                  @Z40LB64
TXT25A   DC    X'8400'                 STATIC TEXT FLAGS     @Z40LB64
         DC    Y(STE25B-STE25A)        TEXT LENGTH           @Z40LB64
         DC    Y(STE25A-TXT25A)        TEXT OFFSET           @Z40LB64
         DC    H'1'                    PRINT COLUMN          @Z40LB64
         DC    Y(STE25B-STE25A)        PRINT FIELD LENGTH    @Z40LB64
         DC    H'0'                    CONVERSION FLAGS      @Z40LB64
         SPACE 1                                             @Z40LB64
* STATIC TEXT ENTRY                                          @Z40LB64
STE25A   DC    YL1(STE25B-MSG25)       MESSAGE LENGTH        @Z40LB64
         DC    FL1'0'                  NEXT STATIC TEXT      @Z40LB64
         DC    X'70'                   MESSAGE FLAGS         @Z40LB64
         DC    FL1'8'                  INSERT COUNT          @Z40LB64
         DC    X'10'                   INSERT #1 TYPE        @Z40LB64
         DC    FL1'2'                  INSERT #1 POSITION    @Z40LB64
         DC    X'08'                   INSERT #2 TYPE        @Z40LB64
         DC    FL1'3'                  INSERT #2 POSITION    @Z40LB64
         DC    X'10'                   INSERT #3 TYPE        @Z40LB64
         DC    FL1'4'                  INSERT #3 POSITION    @Z40LB64
         DC    X'08'                   INSERT #4 TYPE        @Z40LB64
         DC    FL1'5'                  INSERT #4 POSITION    @Z40LB64
         DC    X'10'                   INSERT #5 TYPE        @Z40LB64
         DC    FL1'6'                  INSERT #5 POSITION    @Z40LB64
         DC    X'08'                   INSERT #6 TYPE        @Z40LB64
         DC    FL1'7'                  INSERT #6 POSITION    @Z40LB64
         DC    X'10'                   INSERT #7 TYPE        @Z40LB64
         DC    FL1'8'                  INSERT #7 POSITION    @Z40LB64
         DC    X'08'                   INSERT #8 TYPE        @Z40LB64
         DC    FL1'9'                  INSERT #8 POSITION    @Z40LB64
MSG25    DC    C'(=,=,=,=)'                                  @Z40LB64
STE25B   EQU   *                                             @Z40LB64
TXT25B   EQU   *                                             @Z40LB64
         EJECT                                               @Z40LB64
************************************************************ @Z40LB64
*                                                          * @Z40LB64
* FIELD NAME STATIC TEXT ENTRIES.                          * @Z40LB64
*                                                          * @Z40LB64
* EACH ENTRY CONTAINS THE NAME OF THE FIELD, THE LENGTH    * @Z40LB64
* OF THE FIELD NAME, THE LENGTH OF THE CORRESPONDING       * @Z40LB64
* FIELD VALUE, THE CONVERSION TO BE PERFORMED ON THE       * @Z40LB64
* FIELD VALUE FOR PRINTING, AND THE RESULTANT LENGTH TO    * @Z40LB64
* BE PRINTED AFTER CONVERSION.                             * @Z40LB64
*                                                          * @Z40LB64
************************************************************ @Z40LB64
         SPACE 1                                             @Z40LB64
************************************************************ @Z40LB64
*                                                          * @Z40LB64
* 'VOLUME MOUNTED STATUS' (FIELD NAME)                     * @Z40LB64
*                                                          * @Z40LB64
************************************************************ @Z40LB64
         SPACE 1                                             @Z40LB64
TXT26    DC    Y(TXT26B-TXT26A)        ENTRY LENGTH          @Z40LB64
         DC    H'0'                                          @Z40LB64
         SPACE 1                                             @Z40LB64
* STATIC TEXT SUB-STRUCTURE                                  @Z40LB64
TXT26A   DC    X'8400'                 STATIC TEXT FLAGS     @Z40LB64
         DC    Y(STE26B-STE26A)        TEXT LENGTH           @Z40LB64
         DC    Y(STE26A-TXT26A)        TEXT OFFSET           @Z40LB64
         DC    H'1'                    PRINT COLUMN          @Z40LB64
         DC    Y(STE26B-STE26A)        PRINT FIELD LENGTH    @Z40LB64
         DC    H'0'                    CONVERSION FLAGS      @Z40LB64
         SPACE 1                                             @Z40LB64
* STATIC TEXT ENTRY                                          @Z40LB64
STE26A   DC    YL1(STE26B-MSG26)       FIELD NAME LENGTH     @Z40LB64
         DC    FL1'0'                  RESERVED              @Z40LB64
         DC    FL1'3'                  VALUE INPUT LENGTH    @Z40LB64
         DC    FL1'3'                  VALUE OUTPUT LENGTH   @Z40LB64
         DC    X'0000'                 VALUE CONVERSION      @Z40LB64
MSG26    DC    C'VOLUME MOUNTED STATUS'                      @Z40LB64
STE26B   EQU   *                                             @Z40LB64
TXT26B   EQU   *                                             @Z40LB64
         EJECT                                               @Z40LB64
************************************************************ @Z40LB64
*                                                          * @Z40LB64
* 'VOLUME SECURE STATUS' (FIELD NAME)                      * @Z40LB64
*                                                          * @Z40LB64
************************************************************ @Z40LB64
         SPACE 1                                             @Z40LB64
TXT27    DC    Y(TXT27B-TXT27A)        ENTRY LENGTH          @Z40LB64
         DC    H'0'                                          @Z40LB64
         SPACE 1                                             @Z40LB64
* STATIC TEXT SUB-STRUCTURE                                  @Z40LB64
TXT27A   DC    X'8400'                 STATIC TEXT FLAGS     @Z40LB64
         DC    Y(STE27B-STE27A)        TEXT LENGTH           @Z40LB64
         DC    Y(STE27A-TXT27A)        TEXT OFFSET           @Z40LB64
         DC    H'1'                    PRINT COLUMN          @Z40LB64
         DC    Y(STE27B-STE27A)        PRINT FIELD LENGTH    @Z40LB64
         DC    H'0'                    CONVERSION FLAGS      @Z40LB64
         SPACE 1                                             @Z40LB64
* STATIC TEXT ENTRY                                          @Z40LB64
STE27A   DC    YL1(STE27B-MSG27)       FIELD NAME LENGTH     @Z40LB64
         DC    FL1'0'                  RESERVED              @Z40LB64
         DC    FL1'3'                  VALUE INPUT LENGTH    @Z40LB64
         DC    FL1'3'                  VALUE OUTPUT LENGTH   @Z40LB64
         DC    X'0000'                 VALUE CONVERSION      @Z40LB64
MSG27    DC    C'VOLUME SECURE STATUS'                       @Z40LB64
STE27B   EQU   *                                             @Z40LB64
TXT27B   EQU   *                                             @Z40LB64
         EJECT                                               @Z40LB64
************************************************************ @Z40LB64
*                                                          * @Z40LB64
* 'VOLUME EXCLUSIVE STATUS' (FIELD NAME)                   * @Z40LB64
*                                                          * @Z40LB64
************************************************************ @Z40LB64
         SPACE 1                                             @Z40LB64
TXT28    DC    Y(TXT28B-TXT28A)        ENTRY LENGTH          @Z40LB64
         DC    H'0'                                          @Z40LB64
         SPACE 1                                             @Z40LB64
* STATIC TEXT SUB-STRUCTURE                                  @Z40LB64
TXT28A   DC    X'8400'                 STATIC TEXT FLAGS     @Z40LB64
         DC    Y(STE28B-STE28A)        TEXT LENGTH           @Z40LB64
         DC    Y(STE28A-TXT28A)        TEXT OFFSET           @Z40LB64
         DC    H'1'                    PRINT COLUMN          @Z40LB64
         DC    Y(STE28B-STE28A)        PRINT FIELD LENGTH    @Z40LB64
         DC    H'0'                    CONVERSION FLAGS      @Z40LB64
         SPACE 1                                             @Z40LB64
* STATIC TEXT ENTRY                                          @Z40LB64
STE28A   DC    YL1(STE28B-MSG28)       FIELD NAME LENGTH     @Z40LB64
         DC    FL1'0'                  RESERVED              @Z40LB64
         DC    FL1'3'                  VALUE INPUT LENGTH    @Z40LB64
         DC    FL1'3'                  VALUE OUTPUT LENGTH   @Z40LB64
         DC    X'0000'                 VALUE CONVERSION      @Z40LB64
MSG28    DC    C'VOLUME EXCLUSIVE STATUS'                    @Z40LB64
STE28B   EQU   *                                             @Z40LB64
TXT28B   EQU   *                                             @Z40LB64
         EJECT                                               @Z40LB64
************************************************************ @Z40LB64
*                                                          * @Z40LB64
* 'VOLUME BOUND STATUS' (FIELD NAME)                       * @Z40LB64
*                                                          * @Z40LB64
************************************************************ @Z40LB64
         SPACE 1                                             @Z40LB64
TXT29    DC    Y(TXT29B-TXT29A)        ENTRY LENGTH          @Z40LB64
         DC    H'0'                                          @Z40LB64
         SPACE 1                                             @Z40LB64
* STATIC TEXT SUB-STRUCTURE                                  @Z40LB64
TXT29A   DC    X'8400'                 STATIC TEXT FLAGS     @Z40LB64
         DC    Y(STE29B-STE29A)        TEXT LENGTH           @Z40LB64
         DC    Y(STE29A-TXT29A)        TEXT OFFSET           @Z40LB64
         DC    H'1'                    PRINT COLUMN          @Z40LB64
         DC    Y(STE29B-STE29A)        PRINT FIELD LENGTH    @Z40LB64
         DC    H'0'                    CONVERSION FLAGS      @Z40LB64
         SPACE 1                                             @Z40LB64
* STATIC TEXT ENTRY                                          @Z40LB64
STE29A   DC    YL1(STE29B-MSG29)       FIELD NAME LENGTH     @Z40LB64
         DC    FL1'0'                  RESERVED              @Z40LB64
         DC    FL1'3'                  VALUE INPUT LENGTH    @Z40LB64
         DC    FL1'3'                  VALUE OUTPUT LENGTH   @Z40LB64
         DC    X'0000'                 VALUE CONVERSION      @Z40LB64
MSG29    DC    C'VOLUME BOUND STATUS'                        @Z40LB64
STE29B   EQU   *                                             @Z40LB64
TXT29B   EQU   *                                             @Z40LB64
         EJECT                                               @Z40LB64
************************************************************ @Z40LB64
*                                                          * @Z40LB64
* 'VOLUME RESERVED STATUS' (FIELD NAME)                    * @Z40LB64
*                                                          * @Z40LB64
************************************************************ @Z40LB64
         SPACE 1                                             @Z40LB64
TXT30    DC    Y(TXT30B-TXT30A)        ENTRY LENGTH          @Z40LB64
         DC    H'0'                                          @Z40LB64
         SPACE 1                                             @Z40LB64
* STATIC TEXT SUB-STRUCTURE                                  @Z40LB64
TXT30A   DC    X'8400'                 STATIC TEXT FLAGS     @Z40LB64
         DC    Y(STE30B-STE30A)        TEXT LENGTH           @Z40LB64
         DC    Y(STE30A-TXT30A)        TEXT OFFSET           @Z40LB64
         DC    H'1'                    PRINT COLUMN          @Z40LB64
         DC    Y(STE30B-STE30A)        PRINT FIELD LENGTH    @Z40LB64
         DC    H'0'                    CONVERSION FLAGS      @Z40LB64
         SPACE 1                                             @Z40LB64
* STATIC TEXT ENTRY                                          @Z40LB64
STE30A   DC    YL1(STE30B-MSG30)       FIELD NAME LENGTH     @Z40LB64
         DC    FL1'0'                  RESERVED              @Z40LB64
         DC    FL1'3'                  VALUE INPUT LENGTH    @Z40LB64
         DC    FL1'3'                  VALUE OUTPUT LENGTH   @Z40LB64
         DC    X'0000'                 VALUE CONVERSION      @Z40LB64
MSG30    DC    C'VOLUME RESERVED STATUS'                     @Z40LB64
STE30B   EQU   *                                             @Z40LB64
TXT30B   EQU   *                                             @Z40LB64
         EJECT                                               @Z40LB64
************************************************************ @Z40LB64
*                                                          * @Z40LB64
* 'WRITE INHIBIT STATUS' (FIELD NAME)                      * @Z40LB64
*                                                          * @Z40LB64
************************************************************ @Z40LB64
         SPACE 1                                             @Z40LB64
TXT31    DC    Y(TXT31B-TXT31A)        ENTRY LENGTH          @Z40LB64
         DC    H'0'                                          @Z40LB64
         SPACE 1                                             @Z40LB64
* STATIC TEXT SUB-STRUCTURE                                  @Z40LB64
TXT31A   DC    X'8400'                 STATIC TEXT FLAGS     @Z40LB64
         DC    Y(STE31B-STE31A)        TEXT LENGTH           @Z40LB64
         DC    Y(STE31A-TXT31A)        TEXT OFFSET           @Z40LB64
         DC    H'1'                    PRINT COLUMN          @Z40LB64
         DC    Y(STE31B-STE31A)        PRINT FIELD LENGTH    @Z40LB64
         DC    H'0'                    CONVERSION FLAGS      @Z40LB64
         SPACE 1                                             @Z40LB64
* STATIC TEXT ENTRY                                          @Z40LB64
STE31A   DC    YL1(STE31B-MSG31)       FIELD NAME LENGTH     @Z40LB64
         DC    FL1'0'                  RESERVED              @Z40LB64
         DC    FL1'3'                  VALUE INPUT LENGTH    @Z40LB64
         DC    FL1'3'                  VALUE OUTPUT LENGTH   @Z40LB64
         DC    X'0000'                 VALUE CONVERSION      @Z40LB64
MSG31    DC    C'WRITE INHIBIT STATUS'                       @Z40LB64
STE31B   EQU   *                                             @Z40LB64
TXT31B   EQU   *                                             @Z40LB64
         EJECT                                               @Z40LB64
************************************************************ @Z40LB64
*                                                          * @Z40LB64
* 'MSF IDENTIFIER' (FIELD NAME)                            * @Z40LB64
*                                                          * @Z40LB64
************************************************************ @Z40LB64
         SPACE 1                                             @Z40LB64
TXT32    DC    Y(TXT32B-TXT32A)        ENTRY LENGTH          @Z40LB64
         DC    H'0'                                          @Z40LB64
         SPACE 1                                             @Z40LB64
* STATIC TEXT SUB-STRUCTURE                                  @Z40LB64
TXT32A   DC    X'8400'                 STATIC TEXT FLAGS     @Z40LB64
         DC    Y(STE32B-STE32A)        TEXT LENGTH           @Z40LB64
         DC    Y(STE32A-TXT32A)        TEXT OFFSET           @Z40LB64
         DC    H'1'                    PRINT COLUMN          @Z40LB64
         DC    Y(STE32B-STE32A)        PRINT FIELD LENGTH    @Z40LB64
         DC    H'0'                    CONVERSION FLAGS      @Z40LB64
         SPACE 1                                             @Z40LB64
* STATIC TEXT ENTRY                                          @Z40LB64
STE32A   DC    YL1(STE32B-MSG32)       FIELD NAME LENGTH     @Z40LB64
         DC    FL1'0'                  RESERVED              @Z40LB64
         DC    FL1'4'                  VALUE INPUT LENGTH    @Z40LB64
         DC    FL1'1'                  VALUE OUTPUT LENGTH   @Z40LB64
         DC    X'10A0'                 VALUE CONVERSION      @Z40LB64
MSG32    DC    C'MSF IDENTIFIER'                             @Z40LB64
STE32B   EQU   *                                             @Z40LB64
TXT32B   EQU   *                                             @Z40LB64
         EJECT                                               @Z40LB64
************************************************************ @Z40LB64
*                                                          * @Z40LB64
* 'VOLUME SERIAL NUMBER' (FIELD NAME)                      * @Z40LB64
*                                                          * @Z40LB64
************************************************************ @Z40LB64
         SPACE 1                                             @Z40LB64
TXT33    DC    Y(TXT33B-TXT33A)        ENTRY LENGTH          @Z40LB64
         DC    H'0'                                          @Z40LB64
         SPACE 1                                             @Z40LB64
* STATIC TEXT SUB-STRUCTURE                                  @Z40LB64
TXT33A   DC    X'8400'                 STATIC TEXT FLAGS     @Z40LB64
         DC    Y(STE33B-STE33A)        TEXT LENGTH           @Z40LB64
         DC    Y(STE33A-TXT33A)        TEXT OFFSET           @Z40LB64
         DC    H'1'                    PRINT COLUMN          @Z40LB64
         DC    Y(STE33B-STE33A)        PRINT FIELD LENGTH    @Z40LB64
         DC    H'0'                    CONVERSION FLAGS      @Z40LB64
         SPACE 1                                             @Z40LB64
* STATIC TEXT ENTRY                                          @Z40LB64
STE33A   DC    YL1(STE33B-MSG33)       FIELD NAME LENGTH     @Z40LB64
         DC    FL1'0'                  RESERVED              @Z40LB64
         DC    FL1'6'                  VALUE INPUT LENGTH    @Z40LB64
         DC    FL1'6'                  VALUE OUTPUT LENGTH   @Z40LB64
         DC    X'0000'                 VALUE CONVERSION      @Z40LB64
MSG33    DC    C'VOLUME SERIAL NUMBER'                       @Z40LB64
STE33B   EQU   *                                             @Z40LB64
TXT33B   EQU   *                                             @Z40LB64
         EJECT                                               @Z40LB64
************************************************************ @Z40LB64
*                                                          * @Z40LB64
* 'MANUFACTURER'S IDENTIFIER' (FIELD NAME)                 * @Z40LB64
*                                                          * @Z40LB64
************************************************************ @Z40LB64
         SPACE 1                                             @Z40LB64
TXT34    DC    Y(TXT34B-TXT34A)        ENTRY LENGTH          @Z40LB64
         DC    H'0'                                          @Z40LB64
         SPACE 1                                             @Z40LB64
* STATIC TEXT SUB-STRUCTURE                                  @Z40LB64
TXT34A   DC    X'8400'                 STATIC TEXT FLAGS     @Z40LB64
         DC    Y(STE34B-STE34A)        TEXT LENGTH           @Z40LB64
         DC    Y(STE34A-TXT34A)        TEXT OFFSET           @Z40LB64
         DC    H'1'                    PRINT COLUMN          @Z40LB64
         DC    Y(STE34B-STE34A)        PRINT FIELD LENGTH    @Z40LB64
         DC    H'0'                    CONVERSION FLAGS      @Z40LB64
         SPACE 1                                             @Z40LB64
* STATIC TEXT ENTRY                                          @Z40LB64
STE34A   DC    YL1(STE34B-MSG34)       FIELD NAME LENGTH     @Z40LB64
         DC    FL1'0'                  RESERVED              @Z40LB64
         DC    FL1'5'                  VALUE INPUT LENGTH    @Z40LB64
         DC    FL1'9'                  VALUE OUTPUT LENGTH   @Z40LB64
         DC    X'40A0'                 VALUE CONVERSION      @Z40LB64
MSG34    DC    C'MANUFACTURER''S IDENTIFIER'                 @Z40LB64
STE34B   EQU   *                                             @Z40LB64
TXT34B   EQU   *                                             @Z40LB64
         EJECT                                               @Z40LB64
************************************************************ @Z40LB64
*                                                          * @Z40LB64
* 'VIRTUAL VOLUME ADDRESS' (FIELD NAME)                    * @Z40LB64
*                                                          * @Z40LB64
************************************************************ @Z40LB64
         SPACE 1                                             @Z40LB64
TXT35    DC    Y(TXT35B-TXT35A)        ENTRY LENGTH          @Z40LB64
         DC    H'0'                                          @Z40LB64
         SPACE 1                                             @Z40LB64
* STATIC TEXT SUB-STRUCTURE                                  @Z40LB64
TXT35A   DC    X'8400'                 STATIC TEXT FLAGS     @Z40LB64
         DC    Y(STE35B-STE35A)        TEXT LENGTH           @Z40LB64
         DC    Y(STE35A-TXT35A)        TEXT OFFSET           @Z40LB64
         DC    H'1'                    PRINT COLUMN          @Z40LB64
         DC    Y(STE35B-STE35A)        PRINT FIELD LENGTH    @Z40LB64
         DC    H'0'                    CONVERSION FLAGS      @Z40LB64
         SPACE 1                                             @Z40LB64
* STATIC TEXT ENTRY                                          @Z40LB64
STE35A   DC    YL1(STE35B-MSG35)       FIELD NAME LENGTH     @Z40LB64
         DC    FL1'0'                  RESERVED              @Z40LB64
         DC    FL1'4'                  VALUE INPUT LENGTH    @Z40LB64
         DC    FL1'3'                  VALUE OUTPUT LENGTH   @Z40LB64
         DC    X'10A0'                 VALUE CONVERSION      @Z40LB64
MSG35    DC    C'VIRTUAL VOLUME ADDRESS'                     @Z40LB64
STE35B   EQU   *                                             @Z40LB64
TXT35B   EQU   *                                             @Z40LB64
         EJECT                                               @Z40LB64
************************************************************ @Z40LB64
*                                                          * @Z40LB64
* 'VIRTUAL PAGE' (FIELD NAME)                              * @Z40LB64
*                                                          * @Z40LB64
************************************************************ @Z40LB64
         SPACE 1                                             @Z40LB64
TXT36    DC    Y(TXT36B-TXT36A)        ENTRY LENGTH          @Z40LB64
         DC    H'0'                                          @Z40LB64
         SPACE 1                                             @Z40LB64
* STATIC TEXT SUB-STRUCTURE                                  @Z40LB64
TXT36A   DC    X'8400'                 STATIC TEXT FLAGS     @Z40LB64
         DC    Y(STE36B-STE36A)        TEXT LENGTH           @Z40LB64
         DC    Y(STE36A-TXT36A)        TEXT OFFSET           @Z40LB64
         DC    H'1'                    PRINT COLUMN          @Z40LB64
         DC    Y(STE36B-STE36A)        PRINT FIELD LENGTH    @Z40LB64
         DC    H'0'                    CONVERSION FLAGS      @Z40LB64
         SPACE 1                                             @Z40LB64
* STATIC TEXT ENTRY                                          @Z40LB64
STE36A   DC    YL1(STE36B-MSG36)       FIELD NAME LENGTH     @Z40LB64
         DC    FL1'0'                  RESERVED              @Z40LB64
         DC    FL1'4'                  VALUE INPUT LENGTH    @Z40LB64
         DC    FL1'3'                  VALUE OUTPUT LENGTH   @Z40LB64
         DC    X'10A0'                 VALUE CONVERSION      @Z40LB64
MSG36    DC    C'VIRTUAL PAGE'                               @Z40LB64
STE36B   EQU   *                                             @Z40LB64
TXT36B   EQU   *                                             @Z40LB64
         EJECT                                               @Z40LB64
************************************************************ @Z40LB64
*                                                          * @Z40LB64
* 'REAL UNIT ADDRESS' (FIELD NAME)                         * @Z40LB64
*                                                          * @Z40LB64
************************************************************ @Z40LB64
         SPACE 1                                             @Z40LB64
TXT37    DC    Y(TXT37B-TXT37A)        ENTRY LENGTH          @Z40LB64
         DC    H'0'                                          @Z40LB64
         SPACE 1                                             @Z40LB64
* STATIC TEXT SUB-STRUCTURE                                  @Z40LB64
TXT37A   DC    X'8400'                 STATIC TEXT FLAGS     @Z40LB64
         DC    Y(STE37B-STE37A)        TEXT LENGTH           @Z40LB64
         DC    Y(STE37A-TXT37A)        TEXT OFFSET           @Z40LB64
         DC    H'1'                    PRINT COLUMN          @Z40LB64
         DC    Y(STE37B-STE37A)        PRINT FIELD LENGTH    @Z40LB64
         DC    H'0'                    CONVERSION FLAGS      @Z40LB64
         SPACE 1                                             @Z40LB64
* STATIC TEXT ENTRY                                          @Z40LB64
STE37A   DC    YL1(STE37B-MSG37)       FIELD NAME LENGTH     @Z40LB64
         DC    FL1'0'                  RESERVED              @Z40LB64
         DC    FL1'4'                  VALUE INPUT LENGTH    @Z40LB64
         DC    FL1'3'                  VALUE OUTPUT LENGTH   @Z40LB64
         DC    X'10A0'                 VALUE CONVERSION      @Z40LB64
MSG37    DC    C'REAL UNIT ADDRESS'                          @Z40LB64
STE37B   EQU   *                                             @Z40LB64
TXT37B   EQU   *                                             @Z40LB64
         EJECT                                               @Z40LB64
************************************************************ @Z40LB64
*                                                          * @Z40LB64
* 'STAGING ADAPTER IDENTIFIER' (FIELD NAME)                * @Z40LB64
*                                                          * @Z40LB64
************************************************************ @Z40LB64
         SPACE 1                                             @Z40LB64
TXT38    DC    Y(TXT38B-TXT38A)        ENTRY LENGTH          @Z40LB64
         DC    H'0'                                          @Z40LB64
         SPACE 1                                             @Z40LB64
* STATIC TEXT SUB-STRUCTURE                                  @Z40LB64
TXT38A   DC    X'8400'                 STATIC TEXT FLAGS     @Z40LB64
         DC    Y(STE38B-STE38A)        TEXT LENGTH           @Z40LB64
         DC    Y(STE38A-TXT38A)        TEXT OFFSET           @Z40LB64
         DC    H'1'                    PRINT COLUMN          @Z40LB64
         DC    Y(STE38B-STE38A)        PRINT FIELD LENGTH    @Z40LB64
         DC    H'0'                    CONVERSION FLAGS      @Z40LB64
         SPACE 1                                             @Z40LB64
* STATIC TEXT ENTRY                                          @Z40LB64
STE38A   DC    YL1(STE38B-MSG38)       FIELD NAME LENGTH     @Z40LB64
         DC    FL1'0'                  RESERVED              @Z40LB64
         DC    FL1'4'                  VALUE INPUT LENGTH    @Z40LB64
         DC    FL1'2'                  VALUE OUTPUT LENGTH   @Z40LB64
         DC    X'10A0'                 VALUE CONVERSION      @Z40LB64
MSG38    DC    C'STAGING ADAPTER IDENTIFIER'                 @Z40LB64
STE38B   EQU   *                                             @Z40LB64
TXT38B   EQU   *                                             @Z40LB64
         EJECT                                               @Z40LB64
************************************************************ @Z40LB64
*                                                          * @Z40LB64
* 'FREE PAGE ALLOCATION STATUS' (FIELD NAME)               * @Z40LB64
*                                                          * @Z40LB64
************************************************************ @Z40LB64
         SPACE 1                                             @Z40LB64
TXT39    DC    Y(TXT39B-TXT39A)        ENTRY LENGTH          @Z40LB64
         DC    H'0'                                          @Z40LB64
         SPACE 1                                             @Z40LB64
* STATIC TEXT SUB-STRUCTURE                                  @Z40LB64
TXT39A   DC    X'8400'                 STATIC TEXT FLAGS     @Z40LB64
         DC    Y(STE39B-STE39A)        TEXT LENGTH           @Z40LB64
         DC    Y(STE39A-TXT39A)        TEXT OFFSET           @Z40LB64
         DC    H'1'                    PRINT COLUMN          @Z40LB64
         DC    Y(STE39B-STE39A)        PRINT FIELD LENGTH    @Z40LB64
         DC    H'0'                    CONVERSION FLAGS      @Z40LB64
         SPACE 1                                             @Z40LB64
* STATIC TEXT ENTRY                                          @Z40LB64
STE39A   DC    YL1(STE39B-MSG39)       FIELD NAME LENGTH     @Z40LB64
         DC    FL1'0'                  RESERVED              @Z40LB64
         DC    FL1'3'                  VALUE INPUT LENGTH    @Z40LB64
         DC    FL1'3'                  VALUE OUTPUT LENGTH   @Z40LB64
         DC    X'0000'                 VALUE CONVERSION      @Z40LB64
MSG39    DC    C'FREE PAGE ALLOCATION STATUS'                @Z40LB64
STE39B   EQU   *                                             @Z40LB64
TXT39B   EQU   *                                             @Z40LB64
         EJECT                                               @Z40LB64
************************************************************ @Z40LB64
*                                                          * @Z40LB64
* 'FREE PAGE COUNTS' (FIELD NAME)                          * @Z40LB64
*                                                          * @Z40LB64
************************************************************ @Z40LB64
         SPACE 1                                             @Z40LB64
TXT40    DC    Y(TXT40B-TXT40A)        ENTRY LENGTH          @Z40LB64
         DC    H'0'                                          @Z40LB64
         SPACE 1                                             @Z40LB64
* STATIC TEXT SUB-STRUCTURE                                  @Z40LB64
TXT40A   DC    X'8400'                 STATIC TEXT FLAGS     @Z40LB64
         DC    Y(STE40B-STE40A)        TEXT LENGTH           @Z40LB64
         DC    Y(STE40A-TXT40A)        TEXT OFFSET           @Z40LB64
         DC    H'1'                    PRINT COLUMN          @Z40LB64
         DC    Y(STE40B-STE40A)        PRINT FIELD LENGTH    @Z40LB64
         DC    H'0'                    CONVERSION FLAGS      @Z40LB64
         SPACE 1                                             @Z40LB64
* STATIC TEXT ENTRY                                          @Z40LB64
STE40A   DC    YL1(STE40B-MSG40)       FIELD NAME LENGTH     @Z40LB64
         DC    FL1'0'                  RESERVED              @Z40LB64
         DC    FL1'4'                  VALUE INPUT LENGTH    @Z40LB64
         DC    FL1'5'                  VALUE OUTPUT LENGTH   @Z40LB64
         DC    X'10A0'                 VALUE CONVERSION      @Z40LB64
MSG40    DC    C'FREE PAGE COUNTS'                           @Z40LB64
STE40B   EQU   *                                             @Z40LB64
TXT40B   EQU   *                                             @Z40LB64
         EJECT                                               @Z40LB64
************************************************************ @Z40LB64
*                                                          * @Z40LB64
* 'ACTIVE PAGE COUNTS' (FIELD NAME)                        * @Z40LB64
*                                                          * @Z40LB64
************************************************************ @Z40LB64
         SPACE 1                                             @Z40LB64
TXT41    DC    Y(TXT41B-TXT41A)        ENTRY LENGTH          @Z40LB64
         DC    H'0'                                          @Z40LB64
         SPACE 1                                             @Z40LB64
* STATIC TEXT SUB-STRUCTURE                                  @Z40LB64
TXT41A   DC    X'8400'                 STATIC TEXT FLAGS     @Z40LB64
         DC    Y(STE41B-STE41A)        TEXT LENGTH           @Z40LB64
         DC    Y(STE41A-TXT41A)        TEXT OFFSET           @Z40LB64
         DC    H'1'                    PRINT COLUMN          @Z40LB64
         DC    Y(STE41B-STE41A)        PRINT FIELD LENGTH    @Z40LB64
         DC    H'0'                    CONVERSION FLAGS      @Z40LB64
         SPACE 1                                             @Z40LB64
* STATIC TEXT ENTRY                                          @Z40LB64
STE41A   DC    YL1(STE41B-MSG41)       FIELD NAME LENGTH     @Z40LB64
         DC    FL1'0'                  RESERVED              @Z40LB64
         DC    FL1'4'                  VALUE INPUT LENGTH    @Z40LB64
         DC    FL1'5'                  VALUE OUTPUT LENGTH   @Z40LB64
         DC    X'10A0'                 VALUE CONVERSION      @Z40LB64
MSG41    DC    C'ACTIVE PAGE COUNTS'                         @Z40LB64
STE41B   EQU   *                                             @Z40LB64
TXT41B   EQU   *                                             @Z40LB64
         EJECT                                               @Z40LB64
************************************************************ @Z40LB64
*                                                          * @Z40LB64
* 'INACTIVE PAGE COUNTS' (FIELD NAME)                      * @Z40LB64
*                                                          * @Z40LB64
************************************************************ @Z40LB64
         SPACE 1                                             @Z40LB64
TXT42    DC    Y(TXT42B-TXT42A)        ENTRY LENGTH          @Z40LB64
         DC    H'0'                                          @Z40LB64
         SPACE 1                                             @Z40LB64
* STATIC TEXT SUB-STRUCTURE                                  @Z40LB64
TXT42A   DC    X'8400'                 STATIC TEXT FLAGS     @Z40LB64
         DC    Y(STE42B-STE42A)        TEXT LENGTH           @Z40LB64
         DC    Y(STE42A-TXT42A)        TEXT OFFSET           @Z40LB64
         DC    H'1'                    PRINT COLUMN          @Z40LB64
         DC    Y(STE42B-STE42A)        PRINT FIELD LENGTH    @Z40LB64
         DC    H'0'                    CONVERSION FLAGS      @Z40LB64
         SPACE 1                                             @Z40LB64
* STATIC TEXT ENTRY                                          @Z40LB64
STE42A   DC    YL1(STE42B-MSG42)       FIELD NAME LENGTH     @Z40LB64
         DC    FL1'0'                  RESERVED              @Z40LB64
         DC    FL1'4'                  VALUE INPUT LENGTH    @Z40LB64
         DC    FL1'5'                  VALUE OUTPUT LENGTH   @Z40LB64
         DC    X'10A0'                 VALUE CONVERSION      @Z40LB64
MSG42    DC    C'INACTIVE PAGE COUNTS'                       @Z40LB64
STE42B   EQU   *                                             @Z40LB64
TXT42B   EQU   *                                             @Z40LB64
         EJECT                                               @Z40LB64
************************************************************ @Z40LB64
*                                                          * @Z40LB64
* 'BOUND PAGE COUNTS' (FIELD NAME)                         * @Z40LB64
*                                                          * @Z40LB64
************************************************************ @Z40LB64
         SPACE 1                                             @Z40LB64
TXT43    DC    Y(TXT43B-TXT43A)        ENTRY LENGTH          @Z40LB64
         DC    H'0'                                          @Z40LB64
         SPACE 1                                             @Z40LB64
* STATIC TEXT SUB-STRUCTURE                                  @Z40LB64
TXT43A   DC    X'8400'                 STATIC TEXT FLAGS     @Z40LB64
         DC    Y(STE43B-STE43A)        TEXT LENGTH           @Z40LB64
         DC    Y(STE43A-TXT43A)        TEXT OFFSET           @Z40LB64
         DC    H'1'                    PRINT COLUMN          @Z40LB64
         DC    Y(STE43B-STE43A)        PRINT FIELD LENGTH    @Z40LB64
         DC    H'0'                    CONVERSION FLAGS      @Z40LB64
         SPACE 1                                             @Z40LB64
* STATIC TEXT ENTRY                                          @Z40LB64
STE43A   DC    YL1(STE43B-MSG43)       FIELD NAME LENGTH     @Z40LB64
         DC    FL1'0'                  RESERVED              @Z40LB64
         DC    FL1'4'                  VALUE INPUT LENGTH    @Z40LB64
         DC    FL1'5'                  VALUE OUTPUT LENGTH   @Z40LB64
         DC    X'10A0'                 VALUE CONVERSION      @Z40LB64
MSG43    DC    C'BOUND PAGE COUNTS'                          @Z40LB64
STE43B   EQU   *                                             @Z40LB64
TXT43B   EQU   *                                             @Z40LB64
         EJECT                                               @Z40LB64
************************************************************ @Z40LB64
*                                                          * @Z40LB64
* 'MOUNTED VOLUME TABLE POINTER' (FIELD NAME)              * @Z40LB64
*                                                          * @Z40LB64
************************************************************ @Z40LB64
         SPACE 1                                             @Z40LB64
TXT44    DC    Y(TXT44B-TXT44A)        ENTRY LENGTH          @Z40LB64
         DC    H'0'                                          @Z40LB64
         SPACE 1                                             @Z40LB64
* STATIC TEXT SUB-STRUCTURE                                  @Z40LB64
TXT44A   DC    X'8400'                 STATIC TEXT FLAGS     @Z40LB64
         DC    Y(STE44B-STE44A)        TEXT LENGTH           @Z40LB64
         DC    Y(STE44A-TXT44A)        TEXT OFFSET           @Z40LB64
         DC    H'1'                    PRINT COLUMN          @Z40LB64
         DC    Y(STE44B-STE44A)        PRINT FIELD LENGTH    @Z40LB64
         DC    H'0'                    CONVERSION FLAGS      @Z40LB64
         SPACE 1                                             @Z40LB64
* STATIC TEXT ENTRY                                          @Z40LB64
STE44A   DC    YL1(STE44B-MSG44)       FIELD NAME LENGTH     @Z40LB64
         DC    FL1'0'                  RESERVED              @Z40LB64
         DC    FL1'4'                  VALUE INPUT LENGTH    @Z40LB64
         DC    FL1'5'                  VALUE OUTPUT LENGTH   @Z40LB64
         DC    X'10A0'                 VALUE CONVERSION      @Z40LB64
MSG44    DC    C'MOUNTED VOLUME TABLE POINTER'               @Z40LB64
STE44B   EQU   *                                             @Z40LB64
TXT44B   EQU   *                                             @Z40LB64
         EJECT                                               @Z40LB64
************************************************************ @Z40LB64
*                                                          * @Z40LB64
* 'CELL ADDRESS (MSF-X-Y-Z)' (FIELD NAME)                  * @Z40LB64
*                                                          * @Z40LB64
************************************************************ @Z40LB64
         SPACE 1                                             @Z40LB64
TXT45    DC    Y(TXT45B-TXT45A)        ENTRY LENGTH          @Z40LB64
         DC    H'0'                                          @Z40LB64
         SPACE 1                                             @Z40LB64
* STATIC TEXT SUB-STRUCTURE                                  @Z40LB64
TXT45A   DC    X'8400'                 STATIC TEXT FLAGS     @Z40LB64
         DC    Y(STE45B-STE45A)        TEXT LENGTH           @Z40LB64
         DC    Y(STE45A-TXT45A)        TEXT OFFSET           @Z40LB64
         DC    H'1'                    PRINT COLUMN          @Z40LB64
         DC    Y(STE45B-STE45A)        PRINT FIELD LENGTH    @Z40LB64
         DC    H'0'                    CONVERSION FLAGS      @Z40LB64
         SPACE 1                                             @Z40LB64
* STATIC TEXT ENTRY                                          @Z40LB64
STE45A   DC    YL1(STE45B-MSG45)       FIELD NAME LENGTH     @Z40LB64
         DC    FL1'0'                  RESERVED              @Z40LB64
         DC    FL1'10'                 VALUE INPUT LENGTH    @Z40LB64
         DC    FL1'10'                 VALUE OUTPUT LENGTH   @Z40LB64
         DC    X'0000'                 VALUE CONVERSION      @Z40LB64
MSG45    DC    C'CELL ADDRESS (MSF-X-Y-Z)'                   @Z40LB64
STE45B   EQU   *                                             @Z40LB64
TXT45B   EQU   *                                             @Z40LB64
         EJECT                                               @Z40LB64
************************************************************ @Z40LB64
*                                                          * @Z40LB64
* 'CELL OCCUPIED STATUS' (FIELD NAME)                      * @Z40LB64
*                                                          * @Z40LB64
************************************************************ @Z40LB64
         SPACE 1                                             @Z40LB64
TXT46    DC    Y(TXT46B-TXT46A)        ENTRY LENGTH          @Z40LB64
         DC    H'0'                                          @Z40LB64
         SPACE 1                                             @Z40LB64
* STATIC TEXT SUB-STRUCTURE                                  @Z40LB64
TXT46A   DC    X'8400'                 STATIC TEXT FLAGS     @Z40LB64
         DC    Y(STE46B-STE46A)        TEXT LENGTH           @Z40LB64
         DC    Y(STE46A-TXT46A)        TEXT OFFSET           @Z40LB64
         DC    H'1'                    PRINT COLUMN          @Z40LB64
         DC    Y(STE46B-STE46A)        PRINT FIELD LENGTH    @Z40LB64
         DC    H'0'                    CONVERSION FLAGS      @Z40LB64
         SPACE 1                                             @Z40LB64
* STATIC TEXT ENTRY                                          @Z40LB64
STE46A   DC    YL1(STE46B-MSG46)       FIELD NAME LENGTH     @Z40LB64
         DC    FL1'0'                  RESERVED              @Z40LB64
         DC    FL1'3'                  VALUE INPUT LENGTH    @Z40LB64
         DC    FL1'3'                  VALUE OUTPUT LENGTH   @Z40LB64
         DC    X'0000'                 VALUE CONVERSION      @Z40LB64
MSG46    DC    C'CELL OCCUPIED STATUS'                       @Z40LB64
STE46B   EQU   *                                             @Z40LB64
TXT46B   EQU   *                                             @Z40LB64
         EJECT                                               @Z40LB64
************************************************************ @Z40LB64
*                                                          * @Z40LB64
* 'CPU IDENTIFIER' (FIELD NAME)                            * @Z40LB64
*                                                          * @Z40LB64
************************************************************ @Z40LB64
         SPACE 1                                             @Z40LB64
TXT47    DC    Y(TXT47B-TXT47A)        ENTRY LENGTH          @Z40LB64
         DC    H'0'                                          @Z40LB64
         SPACE 1                                             @Z40LB64
* STATIC TEXT SUB-STRUCTURE                                  @Z40LB64
TXT47A   DC    X'8400'                 STATIC TEXT FLAGS     @Z40LB64
         DC    Y(STE47B-STE47A)        TEXT LENGTH           @Z40LB64
         DC    Y(STE47A-TXT47A)        TEXT OFFSET           @Z40LB64
         DC    H'1'                    PRINT COLUMN          @Z40LB64
         DC    Y(STE47B-STE47A)        PRINT FIELD LENGTH    @Z40LB64
         DC    H'0'                    CONVERSION FLAGS      @Z40LB64
         SPACE 1                                             @Z40LB64
* STATIC TEXT ENTRY                                          @Z40LB64
STE47A   DC    YL1(STE47B-MSG47)       FIELD NAME LENGTH     @Z40LB64
         DC    FL1'0'                  RESERVED              @Z40LB64
         DC    FL1'4'                  VALUE INPUT LENGTH    @Z40LB64
         DC    FL1'2'                  VALUE OUTPUT LENGTH   @Z40LB64
         DC    X'10A0'                 VALUE CONVERSION      @Z40LB64
MSG47    DC    C'CPU IDENTIFIER'                             @Z40LB64
STE47B   EQU   *                                             @Z40LB64
TXT47B   EQU   *                                             @Z40LB64
         EJECT                                               @Z40LB64
************************************************************ @Z40LB64
*                                                          * @Z40LB64
* 'STAGING DRIVE GROUP INDEX' (FIELD NAME)                 * @Z40LB64
*                                                          * @Z40LB64
************************************************************ @Z40LB64
         SPACE 1                                             @Z40LB64
TXT48    DC    Y(TXT48B-TXT48A)        ENTRY LENGTH          @Z40LB64
         DC    H'0'                                          @Z40LB64
         SPACE 1                                             @Z40LB64
* STATIC TEXT SUB-STRUCTURE                                  @Z40LB64
TXT48A   DC    X'8400'                 STATIC TEXT FLAGS     @Z40LB64
         DC    Y(STE48B-STE48A)        TEXT LENGTH           @Z40LB64
         DC    Y(STE48A-TXT48A)        TEXT OFFSET           @Z40LB64
         DC    H'1'                    PRINT COLUMN          @Z40LB64
         DC    Y(STE48B-STE48A)        PRINT FIELD LENGTH    @Z40LB64
         DC    H'0'                    CONVERSION FLAGS      @Z40LB64
         SPACE 1                                             @Z40LB64
* STATIC TEXT ENTRY                                          @Z40LB64
STE48A   DC    YL1(STE48B-MSG48)       FIELD NAME LENGTH     @Z40LB64
         DC    FL1'0'                  RESERVED              @Z40LB64
         DC    FL1'4'                  VALUE INPUT LENGTH    @Z40LB64
         DC    FL1'2'                  VALUE OUTPUT LENGTH   @Z40LB64
         DC    X'10A0'                 VALUE CONVERSION      @Z40LB64
MSG48    DC    C'STAGING DRIVE GROUP INDEX'                  @Z40LB64
STE48B   EQU   *                                             @Z40LB64
TXT48B   EQU   *                                             @Z40LB64
         EJECT                                               @Z40LB64
************************************************************ @Z40LB64
*                                                          * @Z40LB64
* 'LOGICAL 3333 ADDRESS' (FIELD NAME)                      * @Z40LB64
*                                                          * @Z40LB64
************************************************************ @Z40LB64
         SPACE 1                                             @Z40LB64
TXT49    DC    Y(TXT49B-TXT49A)        ENTRY LENGTH          @Z40LB64
         DC    H'0'                                          @Z40LB64
         SPACE 1                                             @Z40LB64
* STATIC TEXT SUB-STRUCTURE                                  @Z40LB64
TXT49A   DC    X'8400'                 STATIC TEXT FLAGS     @Z40LB64
         DC    Y(STE49B-STE49A)        TEXT LENGTH           @Z40LB64
         DC    Y(STE49A-TXT49A)        TEXT OFFSET           @Z40LB64
         DC    H'1'                    PRINT COLUMN          @Z40LB64
         DC    Y(STE49B-STE49A)        PRINT FIELD LENGTH    @Z40LB64
         DC    H'0'                    CONVERSION FLAGS      @Z40LB64
         SPACE 1                                             @Z40LB64
* STATIC TEXT ENTRY                                          @Z40LB64
STE49A   DC    YL1(STE49B-MSG49)       FIELD NAME LENGTH     @Z40LB64
         DC    FL1'0'                  RESERVED              @Z40LB64
         DC    FL1'4'                  VALUE INPUT LENGTH    @Z40LB64
         DC    FL1'1'                  VALUE OUTPUT LENGTH   @Z40LB64
         DC    X'10A0'                 VALUE CONVERSION      @Z40LB64
MSG49    DC    C'LOGICAL 3333 ADDRESS'                       @Z40LB64
STE49B   EQU   *                                             @Z40LB64
TXT49B   EQU   *                                             @Z40LB64
         EJECT                                               @Z40LB64
************************************************************ @Z40LB64
*                                                          * @Z40LB64
* 'CARTRIDGE SERIAL NUMBER' (FIELD NAME)                   * @Z40LB64
*                                                          * @Z40LB64
************************************************************ @Z40LB64
         SPACE 1                                             @Z40LB64
TXT50    DC    Y(TXT50B-TXT50A)        ENTRY LENGTH          @Z40LB64
         DC    H'0'                                          @Z40LB64
         SPACE 1                                             @Z40LB64
* STATIC TEXT SUB-STRUCTURE                                  @Z40LB64
TXT50A   DC    X'8400'                 STATIC TEXT FLAGS     @Z40LB64
         DC    Y(STE50B-STE50A)        TEXT LENGTH           @Z40LB64
         DC    Y(STE50A-TXT50A)        TEXT OFFSET           @Z40LB64
         DC    H'1'                    PRINT COLUMN          @Z40LB64
         DC    Y(STE50B-STE50A)        PRINT FIELD LENGTH    @Z40LB64
         DC    H'0'                    CONVERSION FLAGS      @Z40LB64
         SPACE 1                                             @Z40LB64
* STATIC TEXT ENTRY                                          @Z40LB64
STE50A   DC    YL1(STE50B-MSG50)       FIELD NAME LENGTH     @Z40LB64
         DC    FL1'0'                  RESERVED              @Z40LB64
         DC    FL1'12'                 VALUE INPUT LENGTH    @Z40LB64
         DC    FL1'12'                 VALUE OUTPUT LENGTH   @Z40LB64
         DC    X'0000'                 VALUE CONVERSION      @Z40LB64
MSG50    DC    C'CARTRIDGE SERIAL NUMBER'                    @Z40LB64
STE50B   EQU   *                                             @Z40LB64
TXT50B   EQU   *                                             @Z40LB64
         EJECT                                               @Z40LB64
************************************************************ @Z40LB64
*                                                          * @Z40LB64
* 'LRU DELTAS' (FIELD NAME)                                * @Z40LB64
*                                                          * @Z40LB64
************************************************************ @Z40LB64
         SPACE 1                                             @Z40LB64
TXT51    DC    Y(TXT51B-TXT51A)        ENTRY LENGTH          @Z40LB64
         DC    H'0'                                          @Z40LB64
         SPACE 1                                             @Z40LB64
* STATIC TEXT SUB-STRUCTURE                                  @Z40LB64
TXT51A   DC    X'8400'                 STATIC TEXT FLAGS     @Z40LB64
         DC    Y(STE51B-STE51A)        TEXT LENGTH           @Z40LB64
         DC    Y(STE51A-TXT51A)        TEXT OFFSET           @Z40LB64
         DC    H'1'                    PRINT COLUMN          @Z40LB64
         DC    Y(STE51B-STE51A)        PRINT FIELD LENGTH    @Z40LB64
         DC    H'0'                    CONVERSION FLAGS      @Z40LB64
         SPACE 1                                             @Z40LB64
* STATIC TEXT ENTRY                                          @Z40LB64
STE51A   DC    YL1(STE51B-MSG51)       FIELD NAME LENGTH     @Z40LB64
         DC    FL1'0'                  RESERVED              @Z40LB64
         DC    FL1'4'                  VALUE INPUT LENGTH    @Z40LB64
         DC    FL1'5'                  VALUE OUTPUT LENGTH   @Z40LB64
         DC    X'10A0'                 VALUE CONVERSION      @Z40LB64
MSG51    DC    C'LRU DELTAS'                                 @Z40LB64
STE51B   EQU   *                                             @Z40LB64
TXT51B   EQU   *                                             @Z40LB64
         EJECT                                               @Z40LB64
************************************************************ @Z40LB64
*                                                          * @Z40LB64
* 'MOUNTED VOLUMES' (FIELD NAME)                           * @Z40LB64
*                                                          * @Z40LB64
************************************************************ @Z40LB64
         SPACE 1                                             @Z40LB64
TXT52    DC    Y(TXT52B-TXT52A)        ENTRY LENGTH          @Z40LB64
         DC    H'0'                                          @Z40LB64
         SPACE 1                                             @Z40LB64
* STATIC TEXT SUB-STRUCTURE                                  @Z40LB64
TXT52A   DC    X'8400'                 STATIC TEXT FLAGS     @Z40LB64
         DC    Y(STE52B-STE52A)        TEXT LENGTH           @Z40LB64
         DC    Y(STE52A-TXT52A)        TEXT OFFSET           @Z40LB64
         DC    H'1'                    PRINT COLUMN          @Z40LB64
         DC    Y(STE52B-STE52A)        PRINT FIELD LENGTH    @Z40LB64
         DC    H'0'                    CONVERSION FLAGS      @Z40LB64
         SPACE 1                                             @Z40LB64
* STATIC TEXT ENTRY                                          @Z40LB64
STE52A   DC    YL1(STE52B-MSG52)       FIELD NAME LENGTH     @Z40LB64
         DC    FL1'0'                  RESERVED              @Z40LB64
         DC    FL1'4'                  VALUE INPUT LENGTH    @Z40LB64
         DC    FL1'5'                  VALUE OUTPUT LENGTH   @Z40LB64
         DC    X'10A0'                 VALUE CONVERSION      @Z40LB64
MSG52    DC    C'MOUNTED VOLUMES'                            @Z40LB64
STE52B   EQU   *                                             @Z40LB64
TXT52B   EQU   *                                             @Z40LB64
         EJECT                                               @Z40LB64
************************************************************ @Z40LB64
*                                                          * @Z40LB64
* 'VIRTUAL UNIT ADDRESS' (FIELD NAME)                      * @Z40LB64
*                                                          * @Z40LB64
************************************************************ @Z40LB64
         SPACE 1                                             @Z40LB64
TXT53    DC    Y(TXT53B-TXT53A)        ENTRY LENGTH          @Z40LB64
         DC    H'0'                                          @Z40LB64
         SPACE 1                                             @Z40LB64
* STATIC TEXT SUB-STRUCTURE                                  @Z40LB64
TXT53A   DC    X'8400'                 STATIC TEXT FLAGS     @Z40LB64
         DC    Y(STE53B-STE53A)        TEXT LENGTH           @Z40LB64
         DC    Y(STE53A-TXT53A)        TEXT OFFSET           @Z40LB64
         DC    H'1'                    PRINT COLUMN          @Z40LB64
         DC    Y(STE53B-STE53A)        PRINT FIELD LENGTH    @Z40LB64
         DC    H'0'                    CONVERSION FLAGS      @Z40LB64
         SPACE 1                                             @Z40LB64
* STATIC TEXT ENTRY                                          @Z40LB64
STE53A   DC    YL1(STE53B-MSG53)       FIELD NAME LENGTH     @Z40LB64
         DC    FL1'0'                  RESERVED              @Z40LB64
         DC    FL1'4'                  VALUE INPUT LENGTH    @Z40LB64
         DC    FL1'2'                  VALUE OUTPUT LENGTH   @Z40LB64
         DC    X'10A0'                 VALUE CONVERSION      @Z40LB64
MSG53    DC    C'VIRTUAL UNIT ADDRESS'                       @Z40LB64
STE53B   EQU   *                                             @Z40LB64
TXT53B   EQU   *                                             @Z40LB64
         EJECT                                               @Z40LB64
************************************************************ @Z40LB64
*                                                          * @Z40LB64
* 'BOUND PAGE ALLOCATION STATUS' (FIELD NAME)              * @Z40LB64
*                                                          * @Z40LB64
************************************************************ @Z40LB64
         SPACE 1                                             @Z40LB64
TXT54    DC    Y(TXT54B-TXT54A)        ENTRY LENGTH          @Z40LB64
         DC    H'0'                                          @Z40LB64
         SPACE 1                                             @Z40LB64
* STATIC TEXT SUB-STRUCTURE                                  @Z40LB64
TXT54A   DC    X'8400'                 STATIC TEXT FLAGS     @Z40LB64
         DC    Y(STE54B-STE54A)        TEXT LENGTH           @Z40LB64
         DC    Y(STE54A-TXT54A)        TEXT OFFSET           @Z40LB64
         DC    H'1'                    PRINT COLUMN          @Z40LB64
         DC    Y(STE54B-STE54A)        PRINT FIELD LENGTH    @Z40LB64
         DC    H'0'                    CONVERSION FLAGS      @Z40LB64
         SPACE 1                                             @Z40LB64
* STATIC TEXT ENTRY                                          @Z40LB64
STE54A   DC    YL1(STE54B-MSG54)       FIELD NAME LENGTH     @Z40LB64
         DC    FL1'0'                  RESERVED              @Z40LB64
         DC    FL1'3'                  VALUE INPUT LENGTH    @Z40LB64
         DC    FL1'3'                  VALUE OUTPUT LENGTH   @Z40LB64
         DC    X'0000'                 VALUE CONVERSION      @Z40LB64
MSG54    DC    C'BOUND PAGE ALLOCATION STATUS'               @Z40LB64
STE54B   EQU   *                                             @Z40LB64
TXT54B   EQU   *                                             @Z40LB64
         EJECT                                               @Z40LB64
************************************************************ @Z40LB64
*                                                          * @Z40LB64
* 'DEVICE VALID STATUS' (FIELD NAME)                       * @Z40LB64
*                                                          * @Z40LB64
************************************************************ @Z40LB64
         SPACE 1                                             @Z40LB64
TXT55    DC    Y(TXT55B-TXT55A)        ENTRY LENGTH          @Z40LB64
         DC    H'0'                                          @Z40LB64
         SPACE 1                                             @Z40LB64
* STATIC TEXT SUB-STRUCTURE                                  @Z40LB64
TXT55A   DC    X'8400'                 STATIC TEXT FLAGS     @Z40LB64
         DC    Y(STE55B-STE55A)        TEXT LENGTH           @Z40LB64
         DC    Y(STE55A-TXT55A)        TEXT OFFSET           @Z40LB64
         DC    H'1'                    PRINT COLUMN          @Z40LB64
         DC    Y(STE55B-STE55A)        PRINT FIELD LENGTH    @Z40LB64
         DC    H'0'                    CONVERSION FLAGS      @Z40LB64
         SPACE 1                                             @Z40LB64
* STATIC TEXT ENTRY                                          @Z40LB64
STE55A   DC    YL1(STE55B-MSG55)       FIELD NAME LENGTH     @Z40LB64
         DC    FL1'0'                  RESERVED              @Z40LB64
         DC    FL1'3'                  VALUE INPUT LENGTH    @Z40LB64
         DC    FL1'3'                  VALUE OUTPUT LENGTH   @Z40LB64
         DC    X'0000'                 VALUE CONVERSION      @Z40LB64
MSG55    DC    C'DEVICE VALID STATUS'                        @Z40LB64
STE55B   EQU   *                                             @Z40LB64
TXT55B   EQU   *                                             @Z40LB64
         EJECT                                               @Z40LB64
************************************************************ @Z40LB64
*                                                          * @Z40LB64
* 'DEVICE ONLINE STATUS' (FIELD NAME)                      * @Z40LB64
*                                                          * @Z40LB64
************************************************************ @Z40LB64
         SPACE 1                                             @Z40LB64
TXT56    DC    Y(TXT56B-TXT56A)        ENTRY LENGTH          @Z40LB64
         DC    H'0'                                          @Z40LB64
         SPACE 1                                             @Z40LB64
* STATIC TEXT SUB-STRUCTURE                                  @Z40LB64
TXT56A   DC    X'8400'                 STATIC TEXT FLAGS     @Z40LB64
         DC    Y(STE56B-STE56A)        TEXT LENGTH           @Z40LB64
         DC    Y(STE56A-TXT56A)        TEXT OFFSET           @Z40LB64
         DC    H'1'                    PRINT COLUMN          @Z40LB64
         DC    Y(STE56B-STE56A)        PRINT FIELD LENGTH    @Z40LB64
         DC    H'0'                    CONVERSION FLAGS      @Z40LB64
         SPACE 1                                             @Z40LB64
* STATIC TEXT ENTRY                                          @Z40LB64
STE56A   DC    YL1(STE56B-MSG56)       FIELD NAME LENGTH     @Z40LB64
         DC    FL1'0'                  RESERVED              @Z40LB64
         DC    FL1'3'                  VALUE INPUT LENGTH    @Z40LB64
         DC    FL1'3'                  VALUE OUTPUT LENGTH   @Z40LB64
         DC    X'0000'                 VALUE CONVERSION      @Z40LB64
MSG56    DC    C'DEVICE ONLINE STATUS'                       @Z40LB64
STE56B   EQU   *                                             @Z40LB64
TXT56B   EQU   *                                             @Z40LB64
         EJECT                                               @Z40LB64
************************************************************ @Z40LB64
*                                                          * @Z40LB64
* 'ADDRESS IN-USE STATUS' (FIELD NAME)                     * @Z40LB64
*                                                          * @Z40LB64
************************************************************ @Z40LB64
         SPACE 1                                             @Z40LB64
TXT57    DC    Y(TXT57B-TXT57A)        ENTRY LENGTH          @Z40LB64
         DC    H'0'                                          @Z40LB64
         SPACE 1                                             @Z40LB64
* STATIC TEXT SUB-STRUCTURE                                  @Z40LB64
TXT57A   DC    X'8400'                 STATIC TEXT FLAGS     @Z40LB64
         DC    Y(STE57B-STE57A)        TEXT LENGTH           @Z40LB64
         DC    Y(STE57A-TXT57A)        TEXT OFFSET           @Z40LB64
         DC    H'1'                    PRINT COLUMN          @Z40LB64
         DC    Y(STE57B-STE57A)        PRINT FIELD LENGTH    @Z40LB64
         DC    H'0'                    CONVERSION FLAGS      @Z40LB64
         SPACE 1                                             @Z40LB64
* STATIC TEXT ENTRY                                          @Z40LB64
STE57A   DC    YL1(STE57B-MSG57)       FIELD NAME LENGTH     @Z40LB64
         DC    FL1'0'                  RESERVED              @Z40LB64
         DC    FL1'3'                  VALUE INPUT LENGTH    @Z40LB64
         DC    FL1'3'                  VALUE OUTPUT LENGTH   @Z40LB64
         DC    X'0000'                 VALUE CONVERSION      @Z40LB64
MSG57    DC    C'ADDRESS IN-USE STATUS'                      @Z40LB64
STE57B   EQU   *                                             @Z40LB64
TXT57B   EQU   *                                             @Z40LB64
         EJECT                                               @Z40LB64
************************************************************ @Z40LB64
*                                                          * @Z40LB64
* 'ALTERNATE PATH STATUS' (FIELD NAME)                     * @Z40LB64
*                                                          * @Z40LB64
************************************************************ @Z40LB64
         SPACE 1                                             @Z40LB64
TXT58    DC    Y(TXT58B-TXT58A)        ENTRY LENGTH          @Z40LB64
         DC    H'0'                                          @Z40LB64
         SPACE 1                                             @Z40LB64
* STATIC TEXT SUB-STRUCTURE                                  @Z40LB64
TXT58A   DC    X'8400'                 STATIC TEXT FLAGS     @Z40LB64
         DC    Y(STE58B-STE58A)        TEXT LENGTH           @Z40LB64
         DC    Y(STE58A-TXT58A)        TEXT OFFSET           @Z40LB64
         DC    H'1'                    PRINT COLUMN          @Z40LB64
         DC    Y(STE58B-STE58A)        PRINT FIELD LENGTH    @Z40LB64
         DC    H'0'                    CONVERSION FLAGS      @Z40LB64
         SPACE 1                                             @Z40LB64
* STATIC TEXT ENTRY                                          @Z40LB64
STE58A   DC    YL1(STE58B-MSG58)       FIELD NAME LENGTH     @Z40LB64
         DC    FL1'0'                  RESERVED              @Z40LB64
         DC    FL1'3'                  VALUE INPUT LENGTH    @Z40LB64
         DC    FL1'3'                  VALUE OUTPUT LENGTH   @Z40LB64
         DC    X'0000'                 VALUE CONVERSION      @Z40LB64
MSG58    DC    C'ALTERNATE PATH STATUS'                      @Z40LB64
STE58B   EQU   *                                             @Z40LB64
TXT58B   EQU   *                                             @Z40LB64
         EJECT                                               @Z40LB64
************************************************************ @Z40LB64
*                                                          * @Z40LB64
* 'VOLUME SHARED STATUS' (FIELD NAME)                      * @Z40LB64
*                                                          * @Z40LB64
************************************************************ @Z40LB64
         SPACE 1                                             @Z40LB64
TXT59    DC    Y(TXT59B-TXT59A)        ENTRY LENGTH          @Z40LB64
         DC    H'0'                                          @Z40LB64
         SPACE 1                                             @Z40LB64
* STATIC TEXT SUB-STRUCTURE                                  @Z40LB64
TXT59A   DC    X'8400'                 STATIC TEXT FLAGS     @Z40LB64
         DC    Y(STE59B-STE59A)        TEXT LENGTH           @Z40LB64
         DC    Y(STE59A-TXT59A)        TEXT OFFSET           @Z40LB64
         DC    H'1'                    PRINT COLUMN          @Z40LB64
         DC    Y(STE59B-STE59A)        PRINT FIELD LENGTH    @Z40LB64
         DC    H'0'                    CONVERSION FLAGS      @Z40LB64
         SPACE 1                                             @Z40LB64
* STATIC TEXT ENTRY                                          @Z40LB64
STE59A   DC    YL1(STE59B-MSG59)       FIELD NAME LENGTH     @Z40LB64
         DC    FL1'0'                  RESERVED              @Z40LB64
         DC    FL1'3'                  VALUE INPUT LENGTH    @Z40LB64
         DC    FL1'3'                  VALUE OUTPUT LENGTH   @Z40LB64
         DC    X'0000'                 VALUE CONVERSION      @Z40LB64
MSG59    DC    C'VOLUME SHARED STATUS'                       @Z40LB64
STE59B   EQU   *                                             @Z40LB64
TXT59B   EQU   *                                             @Z40LB64
         EJECT                                               @Z40LB64
************************************************************ @Z40LB64
*                                                          * @Z40LB64
* 'REAL PAGE' (FIELD NAME)                                 * @Z40LB64
*                                                          * @Z40LB64
************************************************************ @Z40LB64
         SPACE 1                                             @Z40LB64
TXT60    DC    Y(TXT60B-TXT60A)        ENTRY LENGTH          @Z40LB64
         DC    H'0'                                          @Z40LB64
         SPACE 1                                             @Z40LB64
* STATIC TEXT SUB-STRUCTURE                                  @Z40LB64
TXT60A   DC    X'8400'                 STATIC TEXT FLAGS     @Z40LB64
         DC    Y(STE60B-STE60A)        TEXT LENGTH           @Z40LB64
         DC    Y(STE60A-TXT60A)        TEXT OFFSET           @Z40LB64
         DC    H'1'                    PRINT COLUMN          @Z40LB64
         DC    Y(STE60B-STE60A)        PRINT FIELD LENGTH    @Z40LB64
         DC    H'0'                    CONVERSION FLAGS      @Z40LB64
         SPACE 1                                             @Z40LB64
* STATIC TEXT ENTRY                                          @Z40LB64
STE60A   DC    YL1(STE60B-MSG60)       FIELD NAME LENGTH     @Z40LB64
         DC    FL1'0'                  RESERVED              @Z40LB64
         DC    FL1'4'                  VALUE INPUT LENGTH    @Z40LB64
         DC    FL1'2'                  VALUE OUTPUT LENGTH   @Z40LB64
         DC    X'10A0'                 VALUE CONVERSION      @Z40LB64
MSG60    DC    C'REAL PAGE'                                  @Z40LB64
STE60B   EQU   *                                             @Z40LB64
TXT60B   EQU   *                                             @Z40LB64
         EJECT                                               @Z40LB64
************************************************************ @Z40LB64
*                                                          * @Z40LB64
* 'ACTIVE PAGE ALLOCATION STATUS' (FIELD NAME)             * @Z40LB64
*                                                          * @Z40LB64
************************************************************ @Z40LB64
         SPACE 1                                             @Z40LB64
TXT61    DC    Y(TXT61B-TXT61A)        ENTRY LENGTH          @Z40LB64
         DC    H'0'                                          @Z40LB64
         SPACE 1                                             @Z40LB64
* STATIC TEXT SUB-STRUCTURE                                  @Z40LB64
TXT61A   DC    X'8400'                 STATIC TEXT FLAGS     @Z40LB64
         DC    Y(STE61B-STE61A)        TEXT LENGTH           @Z40LB64
         DC    Y(STE61A-TXT61A)        TEXT OFFSET           @Z40LB64
         DC    H'1'                    PRINT COLUMN          @Z40LB64
         DC    Y(STE61B-STE61A)        PRINT FIELD LENGTH    @Z40LB64
         DC    H'0'                    CONVERSION FLAGS      @Z40LB64
         SPACE 1                                             @Z40LB64
* STATIC TEXT ENTRY                                          @Z40LB64
STE61A   DC    YL1(STE61B-MSG61)       FIELD NAME LENGTH     @Z40LB64
         DC    FL1'0'                  RESERVED              @Z40LB64
         DC    FL1'3'                  VALUE INPUT LENGTH    @Z40LB64
         DC    FL1'3'                  VALUE OUTPUT LENGTH   @Z40LB64
         DC    X'0000'                 VALUE CONVERSION      @Z40LB64
MSG61    DC    C'ACTIVE PAGE ALLOCATION STATUS'              @Z40LB64
STE61B   EQU   *                                             @Z40LB64
TXT61B   EQU   *                                             @Z40LB64
         EJECT                                               @Z40LB64
************************************************************ @Z40LB64
*                                                          * @Z40LB64
* 'INACTIVE PAGE ALLOCATION STATUS' (FIELD NAME)           * @Z40LB64
*                                                          * @Z40LB64
************************************************************ @Z40LB64
         SPACE 1                                             @Z40LB64
TXT62    DC    Y(TXT62B-TXT62A)        ENTRY LENGTH          @Z40LB64
         DC    H'0'                                          @Z40LB64
         SPACE 1                                             @Z40LB64
* STATIC TEXT SUB-STRUCTURE                                  @Z40LB64
TXT62A   DC    X'8400'                 STATIC TEXT FLAGS     @Z40LB64
         DC    Y(STE62B-STE62A)        TEXT LENGTH           @Z40LB64
         DC    Y(STE62A-TXT62A)        TEXT OFFSET           @Z40LB64
         DC    H'1'                    PRINT COLUMN          @Z40LB64
         DC    Y(STE62B-STE62A)        PRINT FIELD LENGTH    @Z40LB64
         DC    H'0'                    CONVERSION FLAGS      @Z40LB64
         SPACE 1                                             @Z40LB64
* STATIC TEXT ENTRY                                          @Z40LB64
STE62A   DC    YL1(STE62B-MSG62)       FIELD NAME LENGTH     @Z40LB64
         DC    FL1'0'                  RESERVED              @Z40LB64
         DC    FL1'3'                  VALUE INPUT LENGTH    @Z40LB64
         DC    FL1'3'                  VALUE OUTPUT LENGTH   @Z40LB64
         DC    X'0000'                 VALUE CONVERSION      @Z40LB64
MSG62    DC    C'INACTIVE PAGE ALLOCATION STATUS'            @Z40LB64
STE62B   EQU   *                                             @Z40LB64
TXT62B   EQU   *                                             @Z40LB64
         EJECT                                               @Z40LB64
************************************************************ @Z40LB64
*                                                          * @Z40LB64
* 'FREE PAGES' (FIELD NAME)                                * @Z40LB64
*                                                          * @Z40LB64
************************************************************ @Z40LB64
         SPACE 1                                             @Z40LB64
TXT63    DC    Y(TXT63B-TXT63A)        ENTRY LENGTH          @Z40LB64
         DC    H'0'                                          @Z40LB64
         SPACE 1                                             @Z40LB64
* STATIC TEXT SUB-STRUCTURE                                  @Z40LB64
TXT63A   DC    X'8400'                 STATIC TEXT FLAGS     @Z40LB64
         DC    Y(STE63B-STE63A)        TEXT LENGTH           @Z40LB64
         DC    Y(STE63A-TXT63A)        TEXT OFFSET           @Z40LB64
         DC    H'1'                    PRINT COLUMN          @Z40LB64
         DC    Y(STE63B-STE63A)        PRINT FIELD LENGTH    @Z40LB64
         DC    H'0'                    CONVERSION FLAGS      @Z40LB64
         SPACE 1                                             @Z40LB64
* STATIC TEXT ENTRY                                          @Z40LB64
STE63A   DC    YL1(STE63B-MSG63)       FIELD NAME LENGTH     @Z40LB64
         DC    FL1'0'                  RESERVED              @Z40LB64
         DC    FL1'4'                  VALUE INPUT LENGTH    @Z40LB64
         DC    FL1'5'                  VALUE OUTPUT LENGTH   @Z40LB64
         DC    X'10A0'                 VALUE CONVERSION      @Z40LB64
MSG63    DC    C'FREE PAGES'                                 @Z40LB64
STE63B   EQU   *                                             @Z40LB64
TXT63B   EQU   *                                             @Z40LB64
         EJECT                                               @Z40LB64
************************************************************ @Z40LB64
*                                                          * @Z40LB64
* 'ACTIVE PAGES' (FIELD NAME)                              * @Z40LB64
*                                                          * @Z40LB64
************************************************************ @Z40LB64
         SPACE 1                                             @Z40LB64
TXT64    DC    Y(TXT64B-TXT64A)        ENTRY LENGTH          @Z40LB64
         DC    H'0'                                          @Z40LB64
         SPACE 1                                             @Z40LB64
* STATIC TEXT SUB-STRUCTURE                                  @Z40LB64
TXT64A   DC    X'8400'                 STATIC TEXT FLAGS     @Z40LB64
         DC    Y(STE64B-STE64A)        TEXT LENGTH           @Z40LB64
         DC    Y(STE64A-TXT64A)        TEXT OFFSET           @Z40LB64
         DC    H'1'                    PRINT COLUMN          @Z40LB64
         DC    Y(STE64B-STE64A)        PRINT FIELD LENGTH    @Z40LB64
         DC    H'0'                    CONVERSION FLAGS      @Z40LB64
         SPACE 1                                             @Z40LB64
* STATIC TEXT ENTRY                                          @Z40LB64
STE64A   DC    YL1(STE64B-MSG64)       FIELD NAME LENGTH     @Z40LB64
         DC    FL1'0'                  RESERVED              @Z40LB64
         DC    FL1'4'                  VALUE INPUT LENGTH    @Z40LB64
         DC    FL1'5'                  VALUE OUTPUT LENGTH   @Z40LB64
         DC    X'10A0'                 VALUE CONVERSION      @Z40LB64
MSG64    DC    C'ACTIVE PAGES'                               @Z40LB64
STE64B   EQU   *                                             @Z40LB64
TXT64B   EQU   *                                             @Z40LB64
         EJECT                                               @Z40LB64
************************************************************ @Z40LB64
*                                                          * @Z40LB64
* 'INACTIVE PAGES' (FIELD NAME)                            * @Z40LB64
*                                                          * @Z40LB64
************************************************************ @Z40LB64
         SPACE 1                                             @Z40LB64
TXT65    DC    Y(TXT65B-TXT65A)        ENTRY LENGTH          @Z40LB64
         DC    H'0'                                          @Z40LB64
         SPACE 1                                             @Z40LB64
* STATIC TEXT SUB-STRUCTURE                                  @Z40LB64
TXT65A   DC    X'8400'                 STATIC TEXT FLAGS     @Z40LB64
         DC    Y(STE65B-STE65A)        TEXT LENGTH           @Z40LB64
         DC    Y(STE65A-TXT65A)        TEXT OFFSET           @Z40LB64
         DC    H'1'                    PRINT COLUMN          @Z40LB64
         DC    Y(STE65B-STE65A)        PRINT FIELD LENGTH    @Z40LB64
         DC    H'0'                    CONVERSION FLAGS      @Z40LB64
         SPACE 1                                             @Z40LB64
* STATIC TEXT ENTRY                                          @Z40LB64
STE65A   DC    YL1(STE65B-MSG65)       FIELD NAME LENGTH     @Z40LB64
         DC    FL1'0'                  RESERVED              @Z40LB64
         DC    FL1'4'                  VALUE INPUT LENGTH    @Z40LB64
         DC    FL1'5'                  VALUE OUTPUT LENGTH   @Z40LB64
         DC    X'10A0'                 VALUE CONVERSION      @Z40LB64
MSG65    DC    C'INACTIVE PAGES'                             @Z40LB64
STE65B   EQU   *                                             @Z40LB64
TXT65B   EQU   *                                             @Z40LB64
         EJECT                                               @Z40LB64
************************************************************ @Z40LB64
*                                                          * @Z40LB64
* 'BOUND PAGES' (FIELD NAME)                               * @Z40LB64
*                                                          * @Z40LB64
************************************************************ @Z40LB64
         SPACE 1                                             @Z40LB64
TXT66    DC    Y(TXT66B-TXT66A)        ENTRY LENGTH          @Z40LB64
         DC    H'0'                                          @Z40LB64
         SPACE 1                                             @Z40LB64
* STATIC TEXT SUB-STRUCTURE                                  @Z40LB64
TXT66A   DC    X'8400'                 STATIC TEXT FLAGS     @Z40LB64
         DC    Y(STE66B-STE66A)        TEXT LENGTH           @Z40LB64
         DC    Y(STE66A-TXT66A)        TEXT OFFSET           @Z40LB64
         DC    H'1'                    PRINT COLUMN          @Z40LB64
         DC    Y(STE66B-STE66A)        PRINT FIELD LENGTH    @Z40LB64
         DC    H'0'                    CONVERSION FLAGS      @Z40LB64
         SPACE 1                                             @Z40LB64
* STATIC TEXT ENTRY                                          @Z40LB64
STE66A   DC    YL1(STE66B-MSG66)       FIELD NAME LENGTH     @Z40LB64
         DC    FL1'0'                  RESERVED              @Z40LB64
         DC    FL1'4'                  VALUE INPUT LENGTH    @Z40LB64
         DC    FL1'5'                  VALUE OUTPUT LENGTH   @Z40LB64
         DC    X'10A0'                 VALUE CONVERSION      @Z40LB64
MSG66    DC    C'BOUND PAGES'                                @Z40LB64
STE66B   EQU   *                                             @Z40LB64
TXT66B   EQU   *                                             @Z40LB64
         EJECT                                               @Z40LB64
************************************************************ @Z40LB64
*                                                          * @Z40LB64
* TABLE NAME STATIC TEXT ENTRIES.                          * @Z40LB64
*                                                          * @Z40LB64
* EACH ENTRY CONTAINS THE NAME OF THE TABLE, THE LENGTH    * @Z40LB64
* OF THE TABLE NAME, THE NUMBER OF ASSOCIATED TABLE        * @Z40LB64
* INDICES, AND FLAGS INDICATING WHICH TABLE INDICES ARE    * @Z40LB64
* ASSOCIATED WITH THE TABLE.                               * @Z40LB64
*                                                          * @Z40LB64
************************************************************ @Z40LB64
         SPACE 1                                             @Z40LB64
************************************************************ @Z40LB64
*                                                          * @Z40LB64
* 'MSC MOUNTED VOLUME TABLE' (TABLE NAME)                  * @Z40LB64
*                                                          * @Z40LB64
************************************************************ @Z40LB64
         SPACE 1                                             @Z40LB64
TXT76    DC    Y(TXT76B-TXT76A)        ENTRY LENGTH          @Z40LB64
         DC    H'0'                                          @Z40LB64
         SPACE 1                                             @Z40LB64
* STATIC TEXT SUB-STRUCTURE                                  @Z40LB64
TXT76A   DC    X'8400'                 STATIC TEXT FLAGS     @Z40LB64
         DC    Y(STE76B-STE76A)        TEXT LENGTH           @Z40LB64
         DC    Y(STE76A-TXT76A)        TEXT OFFSET           @Z40LB64
         DC    H'1'                    PRINT COLUMN          @Z40LB64
         DC    Y(STE76B-STE76A)        PRINT FIELD LENGTH    @Z40LB64
         DC    H'0'                    CONVERSION FLAGS      @Z40LB64
         SPACE 1                                             @Z40LB64
* STATIC TEXT ENTRY                                          @Z40LB64
STE76A   DC    YL1(STE76B-MSG76)       TABLE NAME LENGTH     @Z40LB64
         DC    FL1'2'                  TABLE INDEX COUNT     @Z40LB64
         DC    FL1'0'                  RESERVED              @Z40LB64
         DC    FL1'0'                  RESERVED              @Z40LB64
         DC    X'4004'                 TABLE INDEX FLAGS     @Z40LB64
MSG76    DC    C'MSC MOUNTED VOLUME TABLE'                   @Z40LB64
STE76B   EQU   *                                             @Z40LB64
TXT76B   EQU   *                                             @Z40LB64
         EJECT                                               @Z40LB64
************************************************************ @Z40LB64
*                                                          * @Z40LB64
* 'MSC VOLUME INVENTORY' (TABLE NAME)                      * @Z40LB64
*                                                          * @Z40LB64
************************************************************ @Z40LB64
         SPACE 1                                             @Z40LB64
TXT77    DC    Y(TXT77B-TXT77A)        ENTRY LENGTH          @Z40LB64
         DC    H'0'                                          @Z40LB64
         SPACE 1                                             @Z40LB64
* STATIC TEXT SUB-STRUCTURE                                  @Z40LB64
TXT77A   DC    X'8400'                 STATIC TEXT FLAGS     @Z40LB64
         DC    Y(STE77B-STE77A)        TEXT LENGTH           @Z40LB64
         DC    Y(STE77A-TXT77A)        TEXT OFFSET           @Z40LB64
         DC    H'1'                    PRINT COLUMN          @Z40LB64
         DC    Y(STE77B-STE77A)        PRINT FIELD LENGTH    @Z40LB64
         DC    H'0'                    CONVERSION FLAGS      @Z40LB64
         SPACE 1                                             @Z40LB64
* STATIC TEXT ENTRY                                          @Z40LB64
STE77A   DC    YL1(STE77B-MSG77)       TABLE NAME LENGTH     @Z40LB64
         DC    FL1'2'                  TABLE INDEX COUNT     @Z40LB64
         DC    FL1'0'                  RESERVED              @Z40LB64
         DC    FL1'0'                  RESERVED              @Z40LB64
         DC    X'4004'                 TABLE INDEX FLAGS     @Z40LB64
MSG77    DC    C'MSC VOLUME INVENTORY'                       @Z40LB64
STE77B   EQU   *                                             @Z40LB64
TXT77B   EQU   *                                             @Z40LB64
         EJECT                                               @Z40LB64
************************************************************ @Z40LB64
*                                                          * @Z40LB64
* 'MSC TRANSIENT VOLUME LIST' (TABLE NAME)                 * @Z40LB64
*                                                          * @Z40LB64
************************************************************ @Z40LB64
         SPACE 1                                             @Z40LB64
TXT78    DC    Y(TXT78B-TXT78A)        ENTRY LENGTH          @Z40LB64
         DC    H'0'                                          @Z40LB64
         SPACE 1                                             @Z40LB64
* STATIC TEXT SUB-STRUCTURE                                  @Z40LB64
TXT78A   DC    X'8400'                 STATIC TEXT FLAGS     @Z40LB64
         DC    Y(STE78B-STE78A)        TEXT LENGTH           @Z40LB64
         DC    Y(STE78A-TXT78A)        TEXT OFFSET           @Z40LB64
         DC    H'1'                    PRINT COLUMN          @Z40LB64
         DC    Y(STE78B-STE78A)        PRINT FIELD LENGTH    @Z40LB64
         DC    H'0'                    CONVERSION FLAGS      @Z40LB64
         SPACE 1                                             @Z40LB64
* STATIC TEXT ENTRY                                          @Z40LB64
STE78A   DC    YL1(STE78B-MSG78)       TABLE NAME LENGTH     @Z40LB64
         DC    FL1'3'                  TABLE INDEX COUNT     @Z40LB64
         DC    FL1'0'                  RESERVED              @Z40LB64
         DC    FL1'0'                  RESERVED              @Z40LB64
         DC    X'C004'                 TABLE INDEX FLAGS     @Z40LB64
MSG78    DC    C'MSC TRANSIENT VOLUME LIST'                  @Z40LB64
STE78B   EQU   *                                             @Z40LB64
TXT78B   EQU   *                                             @Z40LB64
         EJECT                                               @Z40LB64
************************************************************ @Z40LB64
*                                                          * @Z40LB64
* 'MSC SCRATCH CARTRIDGE LIST' (TABLE NAME)                * @Z40LB64
*                                                          * @Z40LB64
************************************************************ @Z40LB64
         SPACE 1                                             @Z40LB64
TXT79    DC    Y(TXT79B-TXT79A)        ENTRY LENGTH          @Z40LB64
         DC    H'0'                                          @Z40LB64
         SPACE 1                                             @Z40LB64
* STATIC TEXT SUB-STRUCTURE                                  @Z40LB64
TXT79A   DC    X'8400'                 STATIC TEXT FLAGS     @Z40LB64
         DC    Y(STE79B-STE79A)        TEXT LENGTH           @Z40LB64
         DC    Y(STE79A-TXT79A)        TEXT OFFSET           @Z40LB64
         DC    H'1'                    PRINT COLUMN          @Z40LB64
         DC    Y(STE79B-STE79A)        PRINT FIELD LENGTH    @Z40LB64
         DC    H'0'                    CONVERSION FLAGS      @Z40LB64
         SPACE 1                                             @Z40LB64
* STATIC TEXT ENTRY                                          @Z40LB64
STE79A   DC    YL1(STE79B-MSG79)       TABLE NAME LENGTH     @Z40LB64
         DC    FL1'3'                  TABLE INDEX COUNT     @Z40LB64
         DC    FL1'0'                  RESERVED              @Z40LB64
         DC    FL1'0'                  RESERVED              @Z40LB64
         DC    X'9004'                 TABLE INDEX FLAGS     @Z40LB64
MSG79    DC    C'MSC SCRATCH CARTRIDGE LIST'                 @Z40LB64
STE79B   EQU   *                                             @Z40LB64
TXT79B   EQU   *                                             @Z40LB64
         EJECT                                               @Z40LB64
************************************************************ @Z40LB64
*                                                          * @Z40LB64
* 'MASS STORAGE VOLUME INVENTORY' (TABLE NAME)             * @Z40LB64
*                                                          * @Z40LB64
************************************************************ @Z40LB64
         SPACE 1                                             @Z40LB64
TXT80    DC    Y(TXT80B-TXT80A)        ENTRY LENGTH          @Z40LB64
         DC    H'0'                                          @Z40LB64
         SPACE 1                                             @Z40LB64
* STATIC TEXT SUB-STRUCTURE                                  @Z40LB64
TXT80A   DC    X'8400'                 STATIC TEXT FLAGS     @Z40LB64
         DC    Y(STE80B-STE80A)        TEXT LENGTH           @Z40LB64
         DC    Y(STE80A-TXT80A)        TEXT OFFSET           @Z40LB64
         DC    H'1'                    PRINT COLUMN          @Z40LB64
         DC    Y(STE80B-STE80A)        PRINT FIELD LENGTH    @Z40LB64
         DC    H'0'                    CONVERSION FLAGS      @Z40LB64
         SPACE 1                                             @Z40LB64
* STATIC TEXT ENTRY                                          @Z40LB64
STE80A   DC    YL1(STE80B-MSG80)       TABLE NAME LENGTH     @Z40LB64
         DC    FL1'1'                  TABLE INDEX COUNT     @Z40LB64
         DC    FL1'0'                  RESERVED              @Z40LB64
         DC    FL1'0'                  RESERVED              @Z40LB64
         DC    X'2000'                 TABLE INDEX FLAGS     @Z40LB64
MSG80    DC    C'MASS STORAGE VOLUME INVENTORY'              @Z40LB64
STE80B   EQU   *                                             @Z40LB64
TXT80B   EQU   *                                             @Z40LB64
         EJECT                                               @Z40LB64
************************************************************ @Z40LB64
*                                                          * @Z40LB64
* 'MSC CELL MAP' (TABLE NAME)                              * @Z40LB64
*                                                          * @Z40LB64
************************************************************ @Z40LB64
         SPACE 1                                             @Z40LB64
TXT81    DC    Y(TXT81B-TXT81A)        ENTRY LENGTH          @Z40LB64
         DC    H'0'                                          @Z40LB64
         SPACE 1                                             @Z40LB64
* STATIC TEXT SUB-STRUCTURE                                  @Z40LB64
TXT81A   DC    X'8400'                 STATIC TEXT FLAGS     @Z40LB64
         DC    Y(STE81B-STE81A)        TEXT LENGTH           @Z40LB64
         DC    Y(STE81A-TXT81A)        TEXT OFFSET           @Z40LB64
         DC    H'1'                    PRINT COLUMN          @Z40LB64
         DC    Y(STE81B-STE81A)        PRINT FIELD LENGTH    @Z40LB64
         DC    H'0'                    CONVERSION FLAGS      @Z40LB64
         SPACE 1                                             @Z40LB64
* STATIC TEXT ENTRY                                          @Z40LB64
STE81A   DC    YL1(STE81B-MSG81)       TABLE NAME LENGTH     @Z40LB64
         DC    FL1'3'                  TABLE INDEX COUNT     @Z40LB64
         DC    FL1'0'                  RESERVED              @Z40LB64
         DC    FL1'0'                  RESERVED              @Z40LB64
         DC    X'1084'                 TABLE INDEX FLAGS     @Z40LB64
MSG81    DC    C'MSC CELL MAP'                               @Z40LB64
STE81B   EQU   *                                             @Z40LB64
TXT81B   EQU   *                                             @Z40LB64
         EJECT                                               @Z40LB64
************************************************************ @Z40LB64
*                                                          * @Z40LB64
* 'MSC MANUFACTURER'S ID CONVERSION TABLE' (TABLE NAME)    * @Z40LB64
*                                                          * @Z40LB64
************************************************************ @Z40LB64
         SPACE 1                                             @Z40LB64
TXT82    DC    Y(TXT82B-TXT82A)        ENTRY LENGTH          @Z40LB64
         DC    H'0'                                          @Z40LB64
         SPACE 1                                             @Z40LB64
* STATIC TEXT SUB-STRUCTURE                                  @Z40LB64
TXT82A   DC    X'8400'                 STATIC TEXT FLAGS     @Z40LB64
         DC    Y(STE82B-STE82A)        TEXT LENGTH           @Z40LB64
         DC    Y(STE82A-TXT82A)        TEXT OFFSET           @Z40LB64
         DC    H'1'                    PRINT COLUMN          @Z40LB64
         DC    Y(STE82B-STE82A)        PRINT FIELD LENGTH    @Z40LB64
         DC    H'0'                    CONVERSION FLAGS      @Z40LB64
         SPACE 1                                             @Z40LB64
* STATIC TEXT ENTRY                                          @Z40LB64
STE82A   DC    YL1(STE82B-MSG82)       TABLE NAME LENGTH     @Z40LB64
         DC    FL1'2'                  TABLE INDEX COUNT     @Z40LB64
         DC    FL1'0'                  RESERVED              @Z40LB64
         DC    FL1'0'                  RESERVED              @Z40LB64
         DC    X'0804'                 TABLE INDEX FLAGS     @Z40LB64
MSG82    DC    C'MSC MANUFACTURER''S ID CONVERSION TABLE'    @Z40LB64
STE82B   EQU   *                                             @Z40LB64
TXT82B   EQU   *                                             @Z40LB64
         EJECT                                               @Z40LB64
************************************************************ @Z40LB64
*                                                          * @Z40LB64
* 'SA VIRTUAL ADDRESS DIRECTORY' (TABLE NAME)              * @Z40LB64
*                                                          * @Z40LB64
************************************************************ @Z40LB64
         SPACE 1                                             @Z40LB64
TXT83    DC    Y(TXT83B-TXT83A)        ENTRY LENGTH          @Z40LB64
         DC    H'0'                                          @Z40LB64
         SPACE 1                                             @Z40LB64
* STATIC TEXT SUB-STRUCTURE                                  @Z40LB64
TXT83A   DC    X'8400'                 STATIC TEXT FLAGS     @Z40LB64
         DC    Y(STE83B-STE83A)        TEXT LENGTH           @Z40LB64
         DC    Y(STE83A-TXT83A)        TEXT OFFSET           @Z40LB64
         DC    H'1'                    PRINT COLUMN          @Z40LB64
         DC    Y(STE83B-STE83A)        PRINT FIELD LENGTH    @Z40LB64
         DC    H'0'                    CONVERSION FLAGS      @Z40LB64
         SPACE 1                                             @Z40LB64
* STATIC TEXT ENTRY                                          @Z40LB64
STE83A   DC    YL1(STE83B-MSG83)       TABLE NAME LENGTH     @Z40LB64
         DC    FL1'3'                  TABLE INDEX COUNT     @Z40LB64
         DC    FL1'0'                  RESERVED              @Z40LB64
         DC    FL1'0'                  RESERVED              @Z40LB64
         DC    X'0510'                 TABLE INDEX FLAGS     @Z40LB64
MSG83    DC    C'SA VIRTUAL ADDRESS DIRECTORY'               @Z40LB64
STE83B   EQU   *                                             @Z40LB64
TXT83B   EQU   *                                             @Z40LB64
         EJECT                                               @Z40LB64
************************************************************ @Z40LB64
*                                                          * @Z40LB64
* 'SA PAGE STATUS TABLE' (TABLE NAME)                      * @Z40LB64
*                                                          * @Z40LB64
************************************************************ @Z40LB64
         SPACE 1                                             @Z40LB64
TXT84    DC    Y(TXT84B-TXT84A)        ENTRY LENGTH          @Z40LB64
         DC    H'0'                                          @Z40LB64
         SPACE 1                                             @Z40LB64
* STATIC TEXT SUB-STRUCTURE                                  @Z40LB64
TXT84A   DC    X'8400'                 STATIC TEXT FLAGS     @Z40LB64
         DC    Y(STE84B-STE84A)        TEXT LENGTH           @Z40LB64
         DC    Y(STE84A-TXT84A)        TEXT OFFSET           @Z40LB64
         DC    H'1'                    PRINT COLUMN          @Z40LB64
         DC    Y(STE84B-STE84A)        PRINT FIELD LENGTH    @Z40LB64
         DC    H'0'                    CONVERSION FLAGS      @Z40LB64
         SPACE 1                                             @Z40LB64
* STATIC TEXT ENTRY                                          @Z40LB64
STE84A   DC    YL1(STE84B-MSG84)       TABLE NAME LENGTH     @Z40LB64
         DC    FL1'3'                  TABLE INDEX COUNT     @Z40LB64
         DC    FL1'0'                  RESERVED              @Z40LB64
         DC    FL1'0'                  RESERVED              @Z40LB64
         DC    X'0448'                 TABLE INDEX FLAGS     @Z40LB64
MSG84    DC    C'SA PAGE STATUS TABLE'                       @Z40LB64
STE84B   EQU   *                                             @Z40LB64
TXT84B   EQU   *                                             @Z40LB64
         EJECT                                               @Z40LB64
************************************************************ @Z40LB64
*                                                          * @Z40LB64
* 'SA LOGICAL TO REAL TABLE' (TABLE NAME)                  * @Z40LB64
*                                                          * @Z40LB64
************************************************************ @Z40LB64
         SPACE 1                                             @Z40LB64
TXT85    DC    Y(TXT85B-TXT85A)        ENTRY LENGTH          @Z40LB64
         DC    H'0'                                          @Z40LB64
         SPACE 1                                             @Z40LB64
* STATIC TEXT SUB-STRUCTURE                                  @Z40LB64
TXT85A   DC    X'8400'                 STATIC TEXT FLAGS     @Z40LB64
         DC    Y(STE85B-STE85A)        TEXT LENGTH           @Z40LB64
         DC    Y(STE85A-TXT85A)        TEXT OFFSET           @Z40LB64
         DC    H'1'                    PRINT COLUMN          @Z40LB64
         DC    Y(STE85B-STE85A)        PRINT FIELD LENGTH    @Z40LB64
         DC    H'0'                    CONVERSION FLAGS      @Z40LB64
         SPACE 1                                             @Z40LB64
* STATIC TEXT ENTRY                                          @Z40LB64
STE85A   DC    YL1(STE85B-MSG85)       TABLE NAME LENGTH     @Z40LB64
         DC    FL1'2'                  TABLE INDEX COUNT     @Z40LB64
         DC    FL1'0'                  RESERVED              @Z40LB64
         DC    FL1'0'                  RESERVED              @Z40LB64
         DC    X'0440'                 TABLE INDEX FLAGS     @Z40LB64
MSG85    DC    C'SA LOGICAL TO REAL TABLE'                   @Z40LB64
STE85B   EQU   *                                             @Z40LB64
TXT85B   EQU   *                                             @Z40LB64
         EJECT                                               @Z40LB64
************************************************************ @Z40LB64
*                                                          * @Z40LB64
* 'SA VIRTUAL VOLUME INFORMATION TABLE' (TABLE NAME)       * @Z40LB64
*                                                          * @Z40LB64
************************************************************ @Z40LB64
         SPACE 1                                             @Z40LB64
TXT86    DC    Y(TXT86B-TXT86A)        ENTRY LENGTH          @Z40LB64
         DC    H'0'                                          @Z40LB64
         SPACE 1                                             @Z40LB64
* STATIC TEXT SUB-STRUCTURE                                  @Z40LB64
TXT86A   DC    X'8400'                 STATIC TEXT FLAGS     @Z40LB64
         DC    Y(STE86B-STE86A)        TEXT LENGTH           @Z40LB64
         DC    Y(STE86A-TXT86A)        TEXT OFFSET           @Z40LB64
         DC    H'1'                    PRINT COLUMN          @Z40LB64
         DC    Y(STE86B-STE86A)        PRINT FIELD LENGTH    @Z40LB64
         DC    H'0'                    CONVERSION FLAGS      @Z40LB64
         SPACE 1                                             @Z40LB64
* STATIC TEXT ENTRY                                          @Z40LB64
STE86A   DC    YL1(STE86B-MSG86)       TABLE NAME LENGTH     @Z40LB64
         DC    FL1'2'                  TABLE INDEX COUNT     @Z40LB64
         DC    FL1'0'                  RESERVED              @Z40LB64
         DC    FL1'0'                  RESERVED              @Z40LB64
         DC    X'0420'                 TABLE INDEX FLAGS     @Z40LB64
MSG86    DC    C'SA VIRTUAL VOLUME INFORMATION TABLE'        @Z40LB64
STE86B   EQU   *                                             @Z40LB64
TXT86B   EQU   *                                             @Z40LB64
         EJECT                                               @Z40LB64
************************************************************ @Z40LB64
*                                                          * @Z40LB64
* 'MSC SDG PAGE AVAILABILITY BLOCK' (TABLE NAME)           * @Z40LB64
*                                                          * @Z40LB64
************************************************************ @Z40LB64
         SPACE 1                                             @Z40LB64
TXT87    DC    Y(TXT87B-TXT87A)        ENTRY LENGTH          @Z40LB64
         DC    H'0'                                          @Z40LB64
         SPACE 1                                             @Z40LB64
* STATIC TEXT SUB-STRUCTURE                                  @Z40LB64
TXT87A   DC    X'8400'                 STATIC TEXT FLAGS     @Z40LB64
         DC    Y(STE87B-STE87A)        TEXT LENGTH           @Z40LB64
         DC    Y(STE87A-TXT87A)        TEXT OFFSET           @Z40LB64
         DC    H'1'                    PRINT COLUMN          @Z40LB64
         DC    Y(STE87B-STE87A)        PRINT FIELD LENGTH    @Z40LB64
         DC    H'0'                    CONVERSION FLAGS      @Z40LB64
         SPACE 1                                             @Z40LB64
* STATIC TEXT ENTRY                                          @Z40LB64
STE87A   DC    YL1(STE87B-MSG87)       TABLE NAME LENGTH     @Z40LB64
         DC    FL1'3'                  TABLE INDEX COUNT     @Z40LB64
         DC    FL1'0'                  RESERVED              @Z40LB64
         DC    FL1'0'                  RESERVED              @Z40LB64
         DC    X'0244'                 TABLE INDEX FLAGS     @Z40LB64
MSG87    DC    C'MSC SDG PAGE AVAILABILITY BLOCK'            @Z40LB64
STE87B   EQU   *                                             @Z40LB64
TXT87B   EQU   *                                             @Z40LB64
         EJECT                                               @Z40LB64
************************************************************ @Z40LB64
*                                                          * @Z40LB64
* 'MSC SDG DEMOUNTED VOLUME BLOCK' (TABLE NAME)            * @Z40LB64
*                                                          * @Z40LB64
************************************************************ @Z40LB64
         SPACE 1                                             @Z40LB64
TXT88    DC    Y(TXT88B-TXT88A)        ENTRY LENGTH          @Z40LB64
         DC    H'0'                                          @Z40LB64
         SPACE 1                                             @Z40LB64
* STATIC TEXT SUB-STRUCTURE                                  @Z40LB64
TXT88A   DC    X'8400'                 STATIC TEXT FLAGS     @Z40LB64
         DC    Y(STE88B-STE88A)        TEXT LENGTH           @Z40LB64
         DC    Y(STE88A-TXT88A)        TEXT OFFSET           @Z40LB64
         DC    H'1'                    PRINT COLUMN          @Z40LB64
         DC    Y(STE88B-STE88A)        PRINT FIELD LENGTH    @Z40LB64
         DC    H'0'                    CONVERSION FLAGS      @Z40LB64
         SPACE 1                                             @Z40LB64
* STATIC TEXT ENTRY                                          @Z40LB64
STE88A   DC    YL1(STE88B-MSG88)       TABLE NAME LENGTH     @Z40LB64
         DC    FL1'2'                  TABLE INDEX COUNT     @Z40LB64
         DC    FL1'0'                  RESERVED              @Z40LB64
         DC    FL1'0'                  RESERVED              @Z40LB64
         DC    X'0204'                 TABLE INDEX FLAGS     @Z40LB64
MSG88    DC    C'MSC SDG DEMOUNTED VOLUME BLOCK'             @Z40LB64
STE88B   EQU   *                                             @Z40LB64
TXT88B   EQU   *                                             @Z40LB64
         EJECT                                               @Z40LB64
************************************************************ @Z40LB64
*                                                          * @Z40LB64
* 'MSC SDG LRU PAGES BLOCK' (TABLE NAME)                   * @Z40LB64
*                                                          * @Z40LB64
************************************************************ @Z40LB64
         SPACE 1                                             @Z40LB64
TXT89    DC    Y(TXT89B-TXT89A)        ENTRY LENGTH          @Z40LB64
         DC    H'0'                                          @Z40LB64
         SPACE 1                                             @Z40LB64
* STATIC TEXT SUB-STRUCTURE                                  @Z40LB64
TXT89A   DC    X'8400'                 STATIC TEXT FLAGS     @Z40LB64
         DC    Y(STE89B-STE89A)        TEXT LENGTH           @Z40LB64
         DC    Y(STE89A-TXT89A)        TEXT OFFSET           @Z40LB64
         DC    H'1'                    PRINT COLUMN          @Z40LB64
         DC    Y(STE89B-STE89A)        PRINT FIELD LENGTH    @Z40LB64
         DC    H'0'                    CONVERSION FLAGS      @Z40LB64
         SPACE 1                                             @Z40LB64
* STATIC TEXT ENTRY                                          @Z40LB64
STE89A   DC    YL1(STE89B-MSG89)       TABLE NAME LENGTH     @Z40LB64
         DC    FL1'2'                  TABLE INDEX COUNT     @Z40LB64
         DC    FL1'0'                  RESERVED              @Z40LB64
         DC    FL1'0'                  RESERVED              @Z40LB64
         DC    X'0204'                 TABLE INDEX FLAGS     @Z40LB64
MSG89    DC    C'MSC SDG LRU PAGES BLOCK'                    @Z40LB64
STE89B   EQU   *                                             @Z40LB64
TXT89B   EQU   *                                             @Z40LB64
         EJECT                                               @Z40LB64
************************************************************ @Z40LB64
*                                                          * @Z40LB64
* 'MSC SDG REAL PAGE MAP' (TABLE NAME)                     * @Z40LB64
*                                                          * @Z40LB64
************************************************************ @Z40LB64
         SPACE 1                                             @Z40LB64
TXT90    DC    Y(TXT90B-TXT90A)        ENTRY LENGTH          @Z40LB64
         DC    H'0'                                          @Z40LB64
         SPACE 1                                             @Z40LB64
* STATIC TEXT SUB-STRUCTURE                                  @Z40LB64
TXT90A   DC    X'8400'                 STATIC TEXT FLAGS     @Z40LB64
         DC    Y(STE90B-STE90A)        TEXT LENGTH           @Z40LB64
         DC    Y(STE90A-TXT90A)        TEXT OFFSET           @Z40LB64
         DC    H'1'                    PRINT COLUMN          @Z40LB64
         DC    Y(STE90B-STE90A)        PRINT FIELD LENGTH    @Z40LB64
         DC    H'0'                    CONVERSION FLAGS      @Z40LB64
         SPACE 1                                             @Z40LB64
* STATIC TEXT ENTRY                                          @Z40LB64
STE90A   DC    YL1(STE90B-MSG90)       TABLE NAME LENGTH     @Z40LB64
         DC    FL1'4'                  TABLE INDEX COUNT     @Z40LB64
         DC    FL1'0'                  RESERVED              @Z40LB64
         DC    FL1'0'                  RESERVED              @Z40LB64
         DC    X'024C'                 TABLE INDEX FLAGS     @Z40LB64
MSG90    DC    C'MSC SDG REAL PAGE MAP'                      @Z40LB64
STE90B   EQU   *                                             @Z40LB64
TXT90B   EQU   *                                             @Z40LB64
         EJECT                                               @Z40LB64
************************************************************ @Z40LB64
*                                                          * @Z40LB64
* 'MSC VVA/MVT CROSS-REFERENCE' (TABLE NAME)               * @Z40LB64
*                                                          * @Z40LB64
************************************************************ @Z40LB64
         SPACE 1                                             @Z40LB64
TXT91    DC    Y(TXT91B-TXT91A)        ENTRY LENGTH          @Z40LB64
         DC    H'0'                                          @Z40LB64
         SPACE 1                                             @Z40LB64
* STATIC TEXT SUB-STRUCTURE                                  @Z40LB64
TXT91A   DC    X'8400'                 STATIC TEXT FLAGS     @Z40LB64
         DC    Y(STE91B-STE91A)        TEXT LENGTH           @Z40LB64
         DC    Y(STE91A-TXT91A)        TEXT OFFSET           @Z40LB64
         DC    H'1'                    PRINT COLUMN          @Z40LB64
         DC    Y(STE91B-STE91A)        PRINT FIELD LENGTH    @Z40LB64
         DC    H'0'                    CONVERSION FLAGS      @Z40LB64
         SPACE 1                                             @Z40LB64
* STATIC TEXT ENTRY                                          @Z40LB64
STE91A   DC    YL1(STE91B-MSG91)       TABLE NAME LENGTH     @Z40LB64
         DC    FL1'3'                  TABLE INDEX COUNT     @Z40LB64
         DC    FL1'0'                  RESERVED              @Z40LB64
         DC    FL1'0'                  RESERVED              @Z40LB64
         DC    X'0424'                 TABLE INDEX FLAGS     @Z40LB64
MSG91    DC    C'MSC VVA/VOLID CROSS-REFERENCE'              @VS41107
STE91B   EQU   *                                             @Z40LB64
TXT91B   EQU   *                                             @Z40LB64
         EJECT                                               @Z40LB64
************************************************************ @Z40LB64
*                                                          * @Z40LB64
* 'MSC VIRTUAL VOLUME ADDRESS TABLE' (TABLE NAME)          * @Z40LB64
*                                                          * @Z40LB64
************************************************************ @Z40LB64
         SPACE 1                                             @Z40LB64
TXT92    DC    Y(TXT92B-TXT92A)        ENTRY LENGTH          @Z40LB64
         DC    H'0'                                          @Z40LB64
         SPACE 1                                             @Z40LB64
* STATIC TEXT SUB-STRUCTURE                                  @Z40LB64
TXT92A   DC    X'8400'                 STATIC TEXT FLAGS     @Z40LB64
         DC    Y(STE92B-STE92A)        TEXT LENGTH           @Z40LB64
         DC    Y(STE92A-TXT92A)        TEXT OFFSET           @Z40LB64
         DC    H'1'                    PRINT COLUMN          @Z40LB64
         DC    Y(STE92B-STE92A)        PRINT FIELD LENGTH    @Z40LB64
         DC    H'0'                    CONVERSION FLAGS      @Z40LB64
         SPACE 1                                             @Z40LB64
* STATIC TEXT ENTRY                                          @Z40LB64
STE92A   DC    YL1(STE92B-MSG92)       TABLE NAME LENGTH     @Z40LB64
         DC    FL1'3'                  TABLE INDEX COUNT     @Z40LB64
         DC    FL1'0'                  RESERVED              @Z40LB64
         DC    FL1'0'                  RESERVED              @Z40LB64
         DC    X'0424'                 TABLE INDEX FLAGS     @Z40LB64
MSG92    DC    C'MSC VIRTUAL VOLUME ADDRESS TABLE'           @Z40LB64
STE92B   EQU   *                                             @Z40LB64
TXT92B   EQU   *                                             @Z40LB64
         EJECT                                               @Z40LB64
************************************************************ @Z40LB64
*                                                          * @Z40LB64
* 'MSC CONFIGURATION INDEX' (TABLE NAME)                   * @Z40LB64
*                                                          * @Z40LB64
************************************************************ @Z40LB64
         SPACE 1                                             @Z40LB64
TXT93    DC    Y(TXT93B-TXT93A)        ENTRY LENGTH          @Z40LB64
         DC    H'0'                                          @Z40LB64
         SPACE 1                                             @Z40LB64
* STATIC TEXT SUB-STRUCTURE                                  @Z40LB64
TXT93A   DC    X'8400'                 STATIC TEXT FLAGS     @Z40LB64
         DC    Y(STE93B-STE93A)        TEXT LENGTH           @Z40LB64
         DC    Y(STE93A-TXT93A)        TEXT OFFSET           @Z40LB64
         DC    H'1'                    PRINT COLUMN          @Z40LB64
         DC    Y(STE93B-STE93A)        PRINT FIELD LENGTH    @Z40LB64
         DC    H'0'                    CONVERSION FLAGS      @Z40LB64
         SPACE 1                                             @Z40LB64
* STATIC TEXT ENTRY                                          @Z40LB64
STE93A   DC    YL1(STE93B-MSG93)       TABLE NAME LENGTH     @Z40LB64
         DC    FL1'3'                  TABLE INDEX COUNT     @Z40LB64
         DC    FL1'0'                  RESERVED              @Z40LB64
         DC    FL1'0'                  RESERVED              @Z40LB64
         DC    X'0414'                 TABLE INDEX FLAGS     @Z40LB64
MSG93    DC    C'MSC CONFIGURATION INDEX'                    @Z40LB64
STE93B   EQU   *                                             @Z40LB64
TXT93B   EQU   *                                             @Z40LB64
         EJECT                                               @Z40LB64
************************************************************ @Z40LB64
*                                                          * @Z40LB64
* 'MSC CONFIGURATION DATA BLOCK' (TABLE NAME)              * @Z40LB64
*                                                          * @Z40LB64
************************************************************ @Z40LB64
         SPACE 1                                             @Z40LB64
TXT94    DC    Y(TXT94B-TXT94A)        ENTRY LENGTH          @Z40LB64
         DC    H'0'                                          @Z40LB64
         SPACE 1                                             @Z40LB64
* STATIC TEXT SUB-STRUCTURE                                  @Z40LB64
TXT94A   DC    X'8400'                 STATIC TEXT FLAGS     @Z40LB64
         DC    Y(STE94B-STE94A)        TEXT LENGTH           @Z40LB64
         DC    Y(STE94A-TXT94A)        TEXT OFFSET           @Z40LB64
         DC    H'1'                    PRINT COLUMN          @Z40LB64
         DC    Y(STE94B-STE94A)        PRINT FIELD LENGTH    @Z40LB64
         DC    H'0'                    CONVERSION FLAGS      @Z40LB64
         SPACE 1                                             @Z40LB64
* STATIC TEXT ENTRY                                          @Z40LB64
STE94A   DC    YL1(STE94B-MSG94)       TABLE NAME LENGTH     @Z40LB64
         DC    FL1'4'                  TABLE INDEX COUNT     @Z40LB64
         DC    FL1'0'                  RESERVED              @Z40LB64
         DC    FL1'0'                  RESERVED              @Z40LB64
         DC    X'0514'                 TABLE INDEX FLAGS     @Z40LB64
MSG94    DC    C'MSC CONFIGURATION DATA BLOCK'               @Z40LB64
STE94B   EQU   *                                             @Z40LB64
TXT94B   EQU   *                                             @Z40LB64
         EJECT                                               @Z40LB64
************************************************************ @Z40LB64
*                                                          * @Z40LB64
* 'MSC MOUNT EQUALIZATION RECORD' (TABLE NAME)             * @Z40LB64
*                                                          * @Z40LB64
************************************************************ @Z40LB64
         SPACE 1                                             @Z40LB64
TXT95    DC    Y(TXT95B-TXT95A)        ENTRY LENGTH          @Z40LB64
         DC    H'0'                                          @Z40LB64
         SPACE 1                                             @Z40LB64
* STATIC TEXT SUB-STRUCTURE                                  @Z40LB64
TXT95A   DC    X'8400'                 STATIC TEXT FLAGS     @Z40LB64
         DC    Y(STE95B-STE95A)        TEXT LENGTH           @Z40LB64
         DC    Y(STE95A-TXT95A)        TEXT OFFSET           @Z40LB64
         DC    H'1'                    PRINT COLUMN          @Z40LB64
         DC    Y(STE95B-STE95A)        PRINT FIELD LENGTH    @Z40LB64
         DC    H'0'                    CONVERSION FLAGS      @Z40LB64
         SPACE 1                                             @Z40LB64
* STATIC TEXT ENTRY                                          @Z40LB64
STE95A   DC    YL1(STE95B-MSG95)       TABLE NAME LENGTH     @Z40LB64
         DC    FL1'1'                  TABLE INDEX COUNT     @Z40LB64
         DC    FL1'0'                  RESERVED              @Z40LB64
         DC    FL1'0'                  RESERVED              @Z40LB64
         DC    X'0200'                 TABLE INDEX FLAGS     @Z40LB64
MSG95    DC    C'MSC MOUNT EQUALIZATION RECORD'              @Z40LB64
STE95B   EQU   *                                             @Z40LB64
TXT95B   EQU   *                                             @Z40LB64
         EJECT                                               @Z40LB64
************************************************************ @Z40LB64
*                                                          * @Z40LB64
* 'MSC CONFIGURATION BIT MAP' (TABLE NAME)                 * @Z40LB64
*                                                          * @Z40LB64
************************************************************ @Z40LB64
         SPACE 1                                             @Z40LB64
TXT96    DC    Y(TXT96B-TXT96A)        ENTRY LENGTH          @Z40LB64
         DC    H'0'                                          @Z40LB64
         SPACE 1                                             @Z40LB64
* STATIC TEXT SUB-STRUCTURE                                  @Z40LB64
TXT96A   DC    X'8400'                 STATIC TEXT FLAGS     @Z40LB64
         DC    Y(STE96B-STE96A)        TEXT LENGTH           @Z40LB64
         DC    Y(STE96A-TXT96A)        TEXT OFFSET           @Z40LB64
         DC    H'1'                    PRINT COLUMN          @Z40LB64
         DC    Y(STE96B-STE96A)        PRINT FIELD LENGTH    @Z40LB64
         DC    H'0'                    CONVERSION FLAGS      @Z40LB64
         SPACE 1                                             @Z40LB64
* STATIC TEXT ENTRY                                          @Z40LB64
STE96A   DC    YL1(STE96B-MSG96)       TABLE NAME LENGTH     @Z40LB64
         DC    FL1'2'                  TABLE INDEX COUNT     @Z40LB64
         DC    FL1'0'                  RESERVED              @Z40LB64
         DC    FL1'0'                  RESERVED              @Z40LB64
         DC    X'0240'                 TABLE INDEX FLAGS     @Z40LB64
MSG96    DC    C'MSC CONFIGURATION BIT MAP'                  @Z40LB64
STE96B   EQU   *                                             @Z40LB64
TXT96B   EQU   *                                             @Z40LB64
         EJECT                                               @Z40LB64
************************************************************ @Z40LB64
*                                                          * @Z40LB64
* 'MSC VI, MSC TVL, OR MSC SCL' (TABLE NAME)               * @Z40LB64
*                                                          * @Z40LB64
************************************************************ @Z40LB64
         SPACE 1                                             @Z40LB64
TXT97    DC    Y(TXT97B-TXT97A)        ENTRY LENGTH          @Z40LB64
         DC    H'0'                                          @Z40LB64
         SPACE 1                                             @Z40LB64
* STATIC TEXT SUB-STRUCTURE                                  @Z40LB64
TXT97A   DC    X'8400'                 STATIC TEXT FLAGS     @Z40LB64
         DC    Y(STE97B-STE97A)        TEXT LENGTH           @Z40LB64
         DC    Y(STE97A-TXT97A)        TEXT OFFSET           @Z40LB64
         DC    H'1'                    PRINT COLUMN          @Z40LB64
         DC    Y(STE97B-STE97A)        PRINT FIELD LENGTH    @Z40LB64
         DC    H'0'                    CONVERSION FLAGS      @Z40LB64
         SPACE 1                                             @Z40LB64
* STATIC TEXT ENTRY                                          @Z40LB64
STE97A   DC    YL1(STE97B-MSG97)       TABLE NAME LENGTH     @Z40LB64
         DC    FL1'0'                  TABLE INDEX COUNT     @Z40LB64
         DC    FL1'0'                  RESERVED              @Z40LB64
         DC    FL1'0'                  RESERVED              @Z40LB64
         DC    X'0000'                 TABLE INDEX FLAGS     @Z40LB64
MSG97    DC    C'MSC VI, MSC TVL, OR MSC SCL'                @Z40LB64
STE97B   EQU   *                                             @Z40LB64
TXT97B   EQU   *                                             @Z40LB64
         EJECT                                               @Z40LB64
************************************************************ @Z40LB64
*                                                          * @Z40LB64
* TABLE INDEX NAME STATIC TEXT ENTRIES.                    * @Z40LB64
*                                                          * @Z40LB64
* EACH ENTRY CONTAINS THE NAME OF THE TABLE INDEX, THE     * @Z40LB64
* LENGTH OF THE TABLE INDEX NAME, THE LENGTH OF THE        * @Z40LB64
* CORRESPONDING TABLE INDEX VALUE, THE CONVERSION TO BE    * @Z40LB64
* PERFORMED ON THE TABLE INDEX VALUE FOR PRINTING, AND     * @Z40LB64
* THE RESULTANT LENGTH TO BE PRINTED AFTER CONVERSION.     * @Z40LB64
*                                                          * @Z40LB64
************************************************************ @Z40LB64
         SPACE 1                                             @Z40LB64
************************************************************ @Z40LB64
*                                                          * @Z40LB64
* 'CSN' (TABLE INDEX NAME)                                 * @Z40LB64
*                                                          * @Z40LB64
************************************************************ @Z40LB64
         SPACE 1                                             @Z40LB64
TXT101   DC    Y(TXT101B-TXT101A)      ENTRY LENGTH          @Z40LB64
         DC    H'0'                                          @Z40LB64
         SPACE 1                                             @Z40LB64
* STATIC TEXT SUB-STRUCTURE                                  @Z40LB64
TXT101A  DC    X'8400'                 STATIC TEXT FLAGS     @Z40LB64
         DC    Y(STE101B-STE101A)      TEXT LENGTH           @Z40LB64
         DC    Y(STE101A-TXT101A)      TEXT OFFSET           @Z40LB64
         DC    H'1'                    PRINT COLUMN          @Z40LB64
         DC    Y(STE101B-STE101A)      PRINT FIELD LENGTH    @Z40LB64
         DC    H'0'                    CONVERSION FLAGS      @Z40LB64
         SPACE 1                                             @Z40LB64
* STATIC TEXT ENTRY                                          @Z40LB64
STE101A  DC    YL1(STE101B-MSG101)     TABLE INDEX LENGTH    @Z40LB64
         DC    FL1'0'                  RESERVED              @Z40LB64
         DC    FL1'12'                 VALUE INPUT LENGTH    @Z40LB64
         DC    FL1'12'                 VALUE OUTPUT LENGTH   @Z40LB64
         DC    X'0000'                 VALUE CONVERSION      @Z40LB64
MSG101   DC    C'CSN'                                        @Z40LB64
STE101B  EQU   *                                             @Z40LB64
TXT101B  EQU   *                                             @Z40LB64
         EJECT                                               @Z40LB64
************************************************************ @Z40LB64
*                                                          * @Z40LB64
* 'VOL' (TABLE INDEX NAME)                                 * @Z40LB64
*                                                          * @Z40LB64
************************************************************ @Z40LB64
         SPACE 1                                             @Z40LB64
TXT102   DC    Y(TXT102B-TXT102A)      ENTRY LENGTH          @Z40LB64
         DC    H'0'                                          @Z40LB64
         SPACE 1                                             @Z40LB64
* STATIC TEXT SUB-STRUCTURE                                  @Z40LB64
TXT102A  DC    X'8400'                 STATIC TEXT FLAGS     @Z40LB64
         DC    Y(STE102B-STE102A)      TEXT LENGTH           @Z40LB64
         DC    Y(STE102A-TXT102A)      TEXT OFFSET           @Z40LB64
         DC    H'1'                    PRINT COLUMN          @Z40LB64
         DC    Y(STE102B-STE102A)      PRINT FIELD LENGTH    @Z40LB64
         DC    H'0'                    CONVERSION FLAGS      @Z40LB64
         SPACE 1                                             @Z40LB64
* STATIC TEXT ENTRY                                          @Z40LB64
STE102A  DC    YL1(STE102B-MSG102)     TABLE INDEX LENGTH    @Z40LB64
         DC    FL1'0'                  RESERVED              @Z40LB64
         DC    FL1'6'                  VALUE INPUT LENGTH    @Z40LB64
         DC    FL1'6'                  VALUE OUTPUT LENGTH   @Z40LB64
         DC    X'0000'                 VALUE CONVERSION      @Z40LB64
MSG102   DC    C'VOL'                                        @Z40LB64
STE102B  EQU   *                                             @Z40LB64
TXT102B  EQU   *                                             @Z40LB64
         EJECT                                               @Z40LB64
************************************************************ @Z40LB64
*                                                          * @Z40LB64
* 'KEY' (TABLE INDEX NAME)                                 * @Z40LB64
*                                                          * @Z40LB64
************************************************************ @Z40LB64
         SPACE 1                                             @Z40LB64
TXT103   DC    Y(TXT103B-TXT103A)      ENTRY LENGTH          @Z40LB64
         DC    H'0'                                          @Z40LB64
         SPACE 1                                             @Z40LB64
* STATIC TEXT SUB-STRUCTURE                                  @Z40LB64
TXT103A  DC    X'8400'                 STATIC TEXT FLAGS     @Z40LB64
         DC    Y(STE103B-STE103A)      TEXT LENGTH           @Z40LB64
         DC    Y(STE103A-TXT103A)      TEXT OFFSET           @Z40LB64
         DC    H'1'                    PRINT COLUMN          @Z40LB64
         DC    Y(STE103B-STE103A)      PRINT FIELD LENGTH    @Z40LB64
         DC    H'0'                    CONVERSION FLAGS      @Z40LB64
         SPACE 1                                             @Z40LB64
* STATIC TEXT ENTRY                                          @Z40LB64
STE103A  DC    YL1(STE103B-MSG103)     TABLE INDEX LENGTH    @Z40LB64
         DC    FL1'0'                  RESERVED              @Z40LB64
         DC    FL1'13'                 VALUE INPUT LENGTH    @Z40LB64
         DC    FL1'25'                 VALUE OUTPUT LENGTH   @Z40LB64
         DC    X'40A0'                 VALUE CONVERSION      @Z40LB64
MSG103   DC    C'KEY'                                        @Z40LB64
STE103B  EQU   *                                             @Z40LB64
TXT103B  EQU   *                                             @Z40LB64
         EJECT                                               @Z40LB64
************************************************************ @Z40LB64
*                                                          * @Z40LB64
* 'MSF' (TABLE INDEX NAME)                                 * @Z40LB64
*                                                          * @Z40LB64
************************************************************ @Z40LB64
         SPACE 1                                             @Z40LB64
TXT104   DC    Y(TXT104B-TXT104A)      ENTRY LENGTH          @Z40LB64
         DC    H'0'                                          @Z40LB64
         SPACE 1                                             @Z40LB64
* STATIC TEXT SUB-STRUCTURE                                  @Z40LB64
TXT104A  DC    X'8400'                 STATIC TEXT FLAGS     @Z40LB64
         DC    Y(STE104B-STE104A)      TEXT LENGTH           @Z40LB64
         DC    Y(STE104A-TXT104A)      TEXT OFFSET           @Z40LB64
         DC    H'1'                    PRINT COLUMN          @Z40LB64
         DC    Y(STE104B-STE104A)      PRINT FIELD LENGTH    @Z40LB64
         DC    H'0'                    CONVERSION FLAGS      @Z40LB64
         SPACE 1                                             @Z40LB64
* STATIC TEXT ENTRY                                          @Z40LB64
STE104A  DC    YL1(STE104B-MSG104)     TABLE INDEX LENGTH    @Z40LB64
         DC    FL1'0'                  RESERVED              @Z40LB64
         DC    FL1'1'                  VALUE INPUT LENGTH    @Z40LB64
         DC    FL1'1'                  VALUE OUTPUT LENGTH   @Z40LB64
         DC    X'10A0'                 VALUE CONVERSION      @Z40LB64
MSG104   DC    C'MSF'                                        @Z40LB64
STE104B  EQU   *                                             @Z40LB64
TXT104B  EQU   *                                             @Z40LB64
         EJECT                                               @Z40LB64
************************************************************ @Z40LB64
*                                                          * @Z40LB64
* 'CPU' (TABLE INDEX NAME)                                 * @Z40LB64
*                                                          * @Z40LB64
************************************************************ @Z40LB64
         SPACE 1                                             @Z40LB64
TXT105   DC    Y(TXT105B-TXT105A)      ENTRY LENGTH          @Z40LB64
         DC    H'0'                                          @Z40LB64
         SPACE 1                                             @Z40LB64
* STATIC TEXT SUB-STRUCTURE                                  @Z40LB64
TXT105A  DC    X'8400'                 STATIC TEXT FLAGS     @Z40LB64
         DC    Y(STE105B-STE105A)      TEXT LENGTH           @Z40LB64
         DC    Y(STE105A-TXT105A)      TEXT OFFSET           @Z40LB64
         DC    H'1'                    PRINT COLUMN          @Z40LB64
         DC    Y(STE105B-STE105A)      PRINT FIELD LENGTH    @Z40LB64
         DC    H'0'                    CONVERSION FLAGS      @Z40LB64
         SPACE 1                                             @Z40LB64
* STATIC TEXT ENTRY                                          @Z40LB64
STE105A  DC    YL1(STE105B-MSG105)     TABLE INDEX LENGTH    @Z40LB64
         DC    FL1'0'                  RESERVED              @Z40LB64
         DC    FL1'1'                  VALUE INPUT LENGTH    @Z40LB64
         DC    FL1'2'                  VALUE OUTPUT LENGTH   @Z40LB64
         DC    X'10A0'                 VALUE CONVERSION      @Z40LB64
MSG105   DC    C'CPU'                                        @Z40LB64
STE105B  EQU   *                                             @Z40LB64
TXT105B  EQU   *                                             @Z40LB64
         EJECT                                               @Z40LB64
************************************************************ @Z40LB64
*                                                          * @Z40LB64
* 'SA' (TABLE INDEX NAME)                                  * @Z40LB64
*                                                          * @Z40LB64
************************************************************ @Z40LB64
         SPACE 1                                             @Z40LB64
TXT106   DC    Y(TXT106B-TXT106A)      ENTRY LENGTH          @Z40LB64
         DC    H'0'                                          @Z40LB64
         SPACE 1                                             @Z40LB64
* STATIC TEXT SUB-STRUCTURE                                  @Z40LB64
TXT106A  DC    X'8400'                 STATIC TEXT FLAGS     @Z40LB64
         DC    Y(STE106B-STE106A)      TEXT LENGTH           @Z40LB64
         DC    Y(STE106A-TXT106A)      TEXT OFFSET           @Z40LB64
         DC    H'1'                    PRINT COLUMN          @Z40LB64
         DC    Y(STE106B-STE106A)      PRINT FIELD LENGTH    @Z40LB64
         DC    H'0'                    CONVERSION FLAGS      @Z40LB64
         SPACE 1                                             @Z40LB64
* STATIC TEXT ENTRY                                          @Z40LB64
STE106A  DC    YL1(STE106B-MSG106)     TABLE INDEX LENGTH    @Z40LB64
         DC    FL1'0'                  RESERVED              @Z40LB64
         DC    FL1'1'                  VALUE INPUT LENGTH    @Z40LB64
         DC    FL1'2'                  VALUE OUTPUT LENGTH   @Z40LB64
         DC    X'10A0'                 VALUE CONVERSION      @Z40LB64
MSG106   DC    C'SA'                                         @Z40LB64
STE106B  EQU   *                                             @Z40LB64
TXT106B  EQU   *                                             @Z40LB64
         EJECT                                               @Z40LB64
************************************************************ @Z40LB64
*                                                          * @Z40LB64
* 'SDG' (TABLE INDEX NAME)                                 * @Z40LB64
*                                                          * @Z40LB64
************************************************************ @Z40LB64
         SPACE 1                                             @Z40LB64
TXT107   DC    Y(TXT107B-TXT107A)      ENTRY LENGTH          @Z40LB64
         DC    H'0'                                          @Z40LB64
         SPACE 1                                             @Z40LB64
* STATIC TEXT SUB-STRUCTURE                                  @Z40LB64
TXT107A  DC    X'8400'                 STATIC TEXT FLAGS     @Z40LB64
         DC    Y(STE107B-STE107A)      TEXT LENGTH           @Z40LB64
         DC    Y(STE107A-TXT107A)      TEXT OFFSET           @Z40LB64
         DC    H'1'                    PRINT COLUMN          @Z40LB64
         DC    Y(STE107B-STE107A)      PRINT FIELD LENGTH    @Z40LB64
         DC    H'0'                    CONVERSION FLAGS      @Z40LB64
         SPACE 1                                             @Z40LB64
* STATIC TEXT ENTRY                                          @Z40LB64
STE107A  DC    YL1(STE107B-MSG107)     TABLE INDEX LENGTH    @Z40LB64
         DC    FL1'0'                  RESERVED              @Z40LB64
         DC    FL1'1'                  VALUE INPUT LENGTH    @Z40LB64
         DC    FL1'2'                  VALUE OUTPUT LENGTH   @Z40LB64
         DC    X'10A0'                 VALUE CONVERSION      @Z40LB64
MSG107   DC    C'SDG'                                        @Z40LB64
STE107B  EQU   *                                             @Z40LB64
TXT107B  EQU   *                                             @Z40LB64
         EJECT                                               @Z40LB64
************************************************************ @Z40LB64
*                                                          * @Z40LB64
* 'VUA' (TABLE INDEX NAME)                                 * @Z40LB64
*                                                          * @Z40LB64
************************************************************ @Z40LB64
         SPACE 1                                             @Z40LB64
TXT108   DC    Y(TXT108B-TXT108A)      ENTRY LENGTH          @Z40LB64
         DC    H'0'                                          @Z40LB64
         SPACE 1                                             @Z40LB64
* STATIC TEXT SUB-STRUCTURE                                  @Z40LB64
TXT108A  DC    X'8400'                 STATIC TEXT FLAGS     @Z40LB64
         DC    Y(STE108B-STE108A)      TEXT LENGTH           @Z40LB64
         DC    Y(STE108A-TXT108A)      TEXT OFFSET           @Z40LB64
         DC    H'1'                    PRINT COLUMN          @Z40LB64
         DC    Y(STE108B-STE108A)      PRINT FIELD LENGTH    @Z40LB64
         DC    H'0'                    CONVERSION FLAGS      @Z40LB64
         SPACE 1                                             @Z40LB64
* STATIC TEXT ENTRY                                          @Z40LB64
STE108A  DC    YL1(STE108B-MSG108)     TABLE INDEX LENGTH    @Z40LB64
         DC    FL1'0'                  RESERVED              @Z40LB64
         DC    FL1'1'                  VALUE INPUT LENGTH    @Z40LB64
         DC    FL1'2'                  VALUE OUTPUT LENGTH   @Z40LB64
         DC    X'10A0'                 VALUE CONVERSION      @Z40LB64
MSG108   DC    C'VUA'                                        @Z40LB64
STE108B  EQU   *                                             @Z40LB64
TXT108B  EQU   *                                             @Z40LB64
         EJECT                                               @Z40LB64
************************************************************ @Z40LB64
*                                                          * @Z40LB64
* 'XYZ' (TABLE INDEX NAME)                                 * @Z40LB64
*                                                          * @Z40LB64
************************************************************ @Z40LB64
         SPACE 1                                             @Z40LB64
TXT109   DC    Y(TXT109B-TXT109A)      ENTRY LENGTH          @Z40LB64
         DC    H'0'                                          @Z40LB64
         SPACE 1                                             @Z40LB64
* STATIC TEXT SUB-STRUCTURE                                  @Z40LB64
TXT109A  DC    X'8400'                 STATIC TEXT FLAGS     @Z40LB64
         DC    Y(STE109B-STE109A)      TEXT LENGTH           @Z40LB64
         DC    Y(STE109A-TXT109A)      TEXT OFFSET           @Z40LB64
         DC    H'1'                    PRINT COLUMN          @Z40LB64
         DC    Y(STE109B-STE109A)      PRINT FIELD LENGTH    @Z40LB64
         DC    H'0'                    CONVERSION FLAGS      @Z40LB64
         SPACE 1                                             @Z40LB64
* STATIC TEXT ENTRY                                          @Z40LB64
STE109A  DC    YL1(STE109B-MSG109)     TABLE INDEX LENGTH    @Z40LB64
         DC    FL1'0'                  RESERVED              @Z40LB64
         DC    FL1'8'                  VALUE INPUT LENGTH    @Z40LB64
         DC    FL1'8'                  VALUE OUTPUT LENGTH   @Z40LB64
         DC    X'0000'                 VALUE CONVERSION      @Z40LB64
MSG109   DC    C'XYZ'                                        @Z40LB64
STE109B  EQU   *                                             @Z40LB64
TXT109B  EQU   *                                             @Z40LB64
         EJECT                                               @Z40LB64
************************************************************ @Z40LB64
*                                                          * @Z40LB64
* 'LUA' (TABLE INDEX NAME)                                 * @Z40LB64
*                                                          * @Z40LB64
************************************************************ @Z40LB64
         SPACE 1                                             @Z40LB64
TXT110   DC    Y(TXT110B-TXT110A)      ENTRY LENGTH          @Z40LB64
         DC    H'0'                                          @Z40LB64
         SPACE 1                                             @Z40LB64
* STATIC TEXT SUB-STRUCTURE                                  @Z40LB64
TXT110A  DC    X'8400'                 STATIC TEXT FLAGS     @Z40LB64
         DC    Y(STE110B-STE110A)      TEXT LENGTH           @Z40LB64
         DC    Y(STE110A-TXT110A)      TEXT OFFSET           @Z40LB64
         DC    H'1'                    PRINT COLUMN          @Z40LB64
         DC    Y(STE110B-STE110A)      PRINT FIELD LENGTH    @Z40LB64
         DC    H'0'                    CONVERSION FLAGS      @Z40LB64
         SPACE 1                                             @Z40LB64
* STATIC TEXT ENTRY                                          @Z40LB64
STE110A  DC    YL1(STE110B-MSG110)     TABLE INDEX LENGTH    @Z40LB64
         DC    FL1'0'                  RESERVED              @Z40LB64
         DC    FL1'1'                  VALUE INPUT LENGTH    @Z40LB64
         DC    FL1'2'                  VALUE OUTPUT LENGTH   @Z40LB64
         DC    X'10A0'                 VALUE CONVERSION      @Z40LB64
MSG110   DC    C'LUA'                                        @Z40LB64
STE110B  EQU   *                                             @Z40LB64
TXT110B  EQU   *                                             @Z40LB64
         EJECT                                               @Z40LB64
************************************************************ @Z40LB64
*                                                          * @Z40LB64
* 'VVA' (TABLE INDEX NAME)                                 * @Z40LB64
*                                                          * @Z40LB64
************************************************************ @Z40LB64
         SPACE 1                                             @Z40LB64
TXT111   DC    Y(TXT111B-TXT111A)      ENTRY LENGTH          @Z40LB64
         DC    H'0'                                          @Z40LB64
         SPACE 1                                             @Z40LB64
* STATIC TEXT SUB-STRUCTURE                                  @Z40LB64
TXT111A  DC    X'8400'                 STATIC TEXT FLAGS     @Z40LB64
         DC    Y(STE111B-STE111A)      TEXT LENGTH           @Z40LB64
         DC    Y(STE111A-TXT111A)      TEXT OFFSET           @Z40LB64
         DC    H'1'                    PRINT COLUMN          @Z40LB64
         DC    Y(STE111B-STE111A)      PRINT FIELD LENGTH    @Z40LB64
         DC    H'0'                    CONVERSION FLAGS      @Z40LB64
         SPACE 1                                             @Z40LB64
* STATIC TEXT ENTRY                                          @Z40LB64
STE111A  DC    YL1(STE111B-MSG111)     TABLE INDEX LENGTH    @Z40LB64
         DC    FL1'0'                  RESERVED              @Z40LB64
         DC    FL1'1'                  VALUE INPUT LENGTH    @Z40LB64
         DC    FL1'3'                  VALUE OUTPUT LENGTH   @Z40LB64
         DC    X'10A0'                 VALUE CONVERSION      @Z40LB64
MSG111   DC    C'VVA'                                        @Z40LB64
STE111B  EQU   *                                             @Z40LB64
TXT111B  EQU   *                                             @Z40LB64
         EJECT                                               @Z40LB64
************************************************************ @Z40LB64
*                                                          * @Z40LB64
* 'INTERFACE' (TABLE INDEX NAME)                           * @Z40LB64
*                                                          * @Z40LB64
************************************************************ @Z40LB64
         SPACE 1                                             @Z40LB64
TXT112   DC    Y(TXT112B-TXT112A)      ENTRY LENGTH          @Z40LB64
         DC    H'0'                                          @Z40LB64
         SPACE 1                                             @Z40LB64
* STATIC TEXT SUB-STRUCTURE                                  @Z40LB64
TXT112A  DC    X'8400'                 STATIC TEXT FLAGS     @Z40LB64
         DC    Y(STE112B-STE112A)      TEXT LENGTH           @Z40LB64
         DC    Y(STE112A-TXT112A)      TEXT OFFSET           @Z40LB64
         DC    H'1'                    PRINT COLUMN          @Z40LB64
         DC    Y(STE112B-STE112A)      PRINT FIELD LENGTH    @Z40LB64
         DC    H'0'                    CONVERSION FLAGS      @Z40LB64
         SPACE 1                                             @Z40LB64
* STATIC TEXT ENTRY                                          @Z40LB64
STE112A  DC    YL1(STE112B-MSG112)     TABLE INDEX LENGTH    @Z40LB64
         DC    FL1'0'                  RESERVED              @Z40LB64
         DC    FL1'1'                  VALUE INPUT LENGTH    @Z40LB64
         DC    FL1'1'                  VALUE OUTPUT LENGTH   @Z40LB64
         DC    X'0000'                 VALUE CONVERSION      @Z40LB64
MSG112   DC    C'INTERFACE'                                  @Z40LB64
STE112B  EQU   *                                             @Z40LB64
TXT112B  EQU   *                                             @Z40LB64
         EJECT                                               @Z40LB64
************************************************************ @Z40LB64
*                                                          * @Z40LB64
* 'REALPAGE' (TABLE INDEX NAME)                            * @Z40LB64
*                                                          * @Z40LB64
************************************************************ @Z40LB64
         SPACE 1                                             @Z40LB64
TXT113   DC    Y(TXT113B-TXT113A)      ENTRY LENGTH          @Z40LB64
         DC    H'0'                                          @Z40LB64
         SPACE 1                                             @Z40LB64
* STATIC TEXT SUB-STRUCTURE                                  @Z40LB64
TXT113A  DC    X'8400'                 STATIC TEXT FLAGS     @Z40LB64
         DC    Y(STE113B-STE113A)      TEXT LENGTH           @Z40LB64
         DC    Y(STE113A-TXT113A)      TEXT OFFSET           @Z40LB64
         DC    H'1'                    PRINT COLUMN          @Z40LB64
         DC    Y(STE113B-STE113A)      PRINT FIELD LENGTH    @Z40LB64
         DC    H'0'                    CONVERSION FLAGS      @Z40LB64
         SPACE 1                                             @Z40LB64
* STATIC TEXT ENTRY                                          @Z40LB64
STE113A  DC    YL1(STE113B-MSG113)     TABLE INDEX LENGTH    @Z40LB64
         DC    FL1'0'                  RESERVED              @Z40LB64
         DC    FL1'1'                  VALUE INPUT LENGTH    @Z40LB64
         DC    FL1'2'                  VALUE OUTPUT LENGTH   @Z40LB64
         DC    X'10A0'                 VALUE CONVERSION      @Z40LB64
MSG113   DC    C'REALPAGE'                                   @Z40LB64
STE113B  EQU   *                                             @Z40LB64
TXT113B  EQU   *                                             @Z40LB64
         EJECT                                               @Z40LB64
************************************************************ @Z40LB64
*                                                          * @Z40LB64
* 'CHR' (TABLE INDEX NAME)                                 * @Z40LB64
*                                                          * @Z40LB64
************************************************************ @Z40LB64
         SPACE 1                                             @Z40LB64
TXT114   DC    Y(TXT114B-TXT114A)      ENTRY LENGTH          @Z40LB64
         DC    H'0'                                          @Z40LB64
         SPACE 1                                             @Z40LB64
* STATIC TEXT SUB-STRUCTURE                                  @Z40LB64
TXT114A  DC    X'8400'                 STATIC TEXT FLAGS     @Z40LB64
         DC    Y(STE114B-STE114A)      TEXT LENGTH           @Z40LB64
         DC    Y(STE114A-TXT114A)      TEXT OFFSET           @Z40LB64
         DC    H'1'                    PRINT COLUMN          @Z40LB64
         DC    Y(STE114B-STE114A)      PRINT FIELD LENGTH    @Z40LB64
         DC    H'0'                    CONVERSION FLAGS      @Z40LB64
         SPACE 1                                             @Z40LB64
* STATIC TEXT ENTRY                                          @Z40LB64
STE114A  DC    YL1(STE114B-MSG114)     TABLE INDEX LENGTH    @Z40LB64
         DC    FL1'0'                  RESERVED              @Z40LB64
         DC    FL1'3'                  VALUE INPUT LENGTH    @Z40LB64
         DC    FL1'5'                  VALUE OUTPUT LENGTH   @Z40LB64
         DC    X'40A0'                 VALUE CONVERSION      @Z40LB64
MSG114   DC    C'CHR'                                        @Z40LB64
STE114B  EQU   *                                             @Z40LB64
TXT114B  EQU   *                                             @Z40LB64
         EJECT                                               @Z40LB64
         END   IDCTSCH0                                      @Z40LB64
