***********************************************************************
*                                                                     *
* MODULE NAME - IDCTSCK0 - STATIC TEXT MODULE FOR CHKLIST MESSAGES    *
*                          AND REPORT DETAIL LINES                    *
*                                                                     *
* DESCRIPTIVE NAME - STATIC TEXT MODULE FOR THE CHECKPOINT LIST       *
*                    UTILITY FUNCTION MESSAGES AND DETAIL LINES       *
*                                                                     *
* COPYRIGHT - NONE                                                    *
*                                                                     *
* STATUS - RELEASE 0  LEVEL 0                                         *
*                                                                     *
* FUNCTION - CONTAINS NO EXECUTABLE CODE, ONLY STATIC TEXT ENTRIES    *
*            FOR THE CHECKPOINT LIST UTILITY (CHKLIST) FUNCTION       *
*            THIS MODULE IS LOADED BY IDCTP05 WHEN A STATIC TEXT      *
*            REQUEST IS MADE                                          *
*                                                                     *
* NOTES - NONE                                                        *
*                                                                     *
*    DEPENDENCIES - NONE                                              *
*    RESTRICTIONS - NONE                                              *
*    REGISTER CONVENTIONS - NA                                        *
*    PATCH AREA - NA                                                  *
*                                                                     *
* MODULE TYPE - TABLES                                                *
*                                                                     *
*    PROCESSER - ASSEMBLER                                            *
*    MODULE SIZE -                                                    *
*    ATTRIBUTES - READ ONLY                                           *
*                                                                     *
* ENTRY POINT - NA                                                    *
*                                                                     *
* EXIT NORMAL - NA                                                    *
*                                                                     *
* EXIT ERROR - NA                                                     *
*                                                                     *
* EXTERNAL REFERENCES - NA                                            *
*                                                                     *
* TABLES - NA                                                         *
*                                                                     *
* MACROS - NA                                                         *
*                                                                     *
* CHANGE ACTIVITY - NONE                                              *
*                                                                     *
***********************************************************************
*                                                                     *
***********************************************************************
*                                                                     *
* THIS MODULE IS THE FIRST MODULE OF STATIC TEXT REQUIRED BY THE      *
* CHECKPOINT LIST (CHKLIST) FUNCTION SUPORT ROUTINE                   *
*                                                                     *
***********************************************************************
*                                                                     *
IDCTSCK0 CSECT
*                                                                     *
***********************************************************************
         EJECT
***********************************************************************
*                                                                     *
* INDEXES TO CHKLIST STATIC TEXT ENTRIES                              *
*                                                                     *
***********************************************************************
         SPACE 1
INDEX    DC    H'12'                    COUNT OF ENTRIES
INDEX1   DC    Y(TXT1-INDEX)            HEADER INFORMATION
INDEX2   DC    Y(TXT2-INDEX)            CHECKID DETAIL LINE
INDEX3   DC    Y(TXT3-INDEX)            DATA SET INFO DETAIL LINE
INDEX4   DC    Y(TXT4-INDEX)            VOLUME SERIALS DETAIL LINE
INDEX5   DC    Y(TXT5-INDEX)            SELECTED CHECKID NOT FOUND
INDEX6   DC    Y(TXT6-INDEX)            NO TAPE DATA SETS OPEN
INDEX7   DC    Y(TXT7-INDEX)            DUPLICATE SELECTED CHECKID
INDEX8   DC    Y(TXT8-INDEX)            DUPLICATE CKPOINT ENTRY
INDEX9   DC    Y(TXT9-INDEX)            NO CHECKPOINTS ON DATA SET
INDEX10  DC    Y(TXT10-INDEX)           ADDITIONAL VOLSERS NOT FOUND
INDEX11  DC    Y(TXT11-INDEX)           UNEXPECTED EOF ON CHKPT DS
INDEX12  DC    Y(TXT12-INDEX)           CURRENT VOLUME NOT FOUND
         EJECT
***********************************************************************
*                                                                     *
* CHKLIST PAGE HEADINGS                                               *
*                                                                     *
***********************************************************************
         SPACE 1
TXT1     DC    Y(TXT1B-TXT1A)           ENTRY LENGTH
         DC    X'4000'                  HEADER FLAG
HDLI11   DC    H'2'                     HEADER LINE COUNT
HDLSP1   DC    H'4'                     HEADER SPACE COUNT
* SPACING CONTROL SUB-STRUCTURE
TXT1A    DC    X'4000'                  SPACE CONTROL FLAG
         DC    H'2'                     SPACING FACTOR
         DC    C'E '                    SPACING TYPE (EJECT)
* STATIC TEXT SUB-STRUCTURE
         DC    X'0400'                  STATIC TEXT FLAG
         DC    Y(STE11B-STE11A)         TEXT LENGTH
         DC    Y(STE11A-TXT1A)          TEXT OFFSET
         DC    H'1'                     PRINT COLUMN
         DC    Y(STE11B-STE11A)         PRINT LENGTH
         DC    H'0'                     CONVERSION FLAGS (CHAR)
* STATIC TEXT ENTRIES
STE11A   DC    C'OPEN TAPE DATA SET LIST FROM CHECKPOINT DATA SET -   '
         DC    C'                                                     '
         DC    C'              '
         DC    C'2CHECKID         DSNAME                              '
         DC    C'         DDNAME   UNIT      VOLUMES - * INDICATES CUR'
         DC    C'RENT VOLUME    '
STE11B   EQU   *
TXT1B    EQU   *
         EJECT
***********************************************************************
*                                                                     *
* CHECKID DETAIL LINE                                                 *
*                                                                     *
***********************************************************************
         SPACE 1
TXT2     DC    Y(TXT2B-TXT2A)           ENTRY LENGTH
         DC    H'0'                     NO FLAGS
* SPACING SUB-STRUCTURE
TXT2A    DC    X'4000'                  SPACE CONTROL FLAG
         DC    H'2'                     SPACING FACTOR
         DC    C'R '                    SPACING TYPE (RELATIVE)
* BLOCK DATA SUB-STRUCTURE
         DC    X'9000'                  BLOCK DATA FLAG
         DC    H'16'                    MAXIMUM DATA LENGTH
         DC    H'0'                     OFFSET TO DATA
         DC    H'1'                     PRINT COLUMN
         DC    H'16'                    MAXIMUM PRINT LENGTH
         DC    H'0'                     CONVERSION FLAGS (CHAR)
TXT2B    EQU   *
         EJECT
***********************************************************************
*                                                                     *
* TAPE DATA SET INFORMATION DETAIL LINE                               *
*                                                                     *
***********************************************************************
         SPACE 1
TXT3     DC    Y(TXT3B-TXT3A)           ENTRY LENGTH
         DC    H'0'                     NO FLAGS
* SPACING CONTROL SUB-STRUCTURE
TXT3A    DC    X'4000'                  SPACE CONTROL FLAG
         DC    H'2'                     SPACING FACTOR
         DC    C'R '                    SPACING TYPE (RELATIVE)
* BLOCK DATA SUB-STRUCTURE - DSNAME
         DC    X'1000'                  BLOCK DATA FLAG
         DC    H'44'                    DATA LENGTH
         DC    H'0'                     DATA OFFSET
         DC    H'17'                    PRINT COLUMN
         DC    H'44'                    PRINT LENGTH
         DC    H'0'                     CONVERSION FLAGS (CHAR)
* BLOCK DATA SUB-STRUCTURE - DDNAME
         DC    X'1000'                  BLOCK DATA FLAG
         DC    H'8'                     DATA LENGTH
         DC    H'44'                    DATA OFFSET
         DC    H'62'                    PRINT COLUMN
         DC    H'8'                     PRINT LENGTH
         DC    H'0'                     CONVERSION FLAGS (CHAR)
* BLOCK DATA SUBSTRUCTURE - UNIT
         DC    X'1000'                  BLOCK DATA FLAGS
         DC    H'4'                     DATA LENGTH
         DC    H'52'                    DATA OFFSET
         DC    H'71'                    PRINT COLUMN
         DC    H'4'                     PRINT LENGTH
         DC    H'0'                    CONVERSION FLAGS (CHAR)
* BLOCK DATA SUBSTRUCTURE - TRKS
         DC    X'1000'                  BLOCK DATA FLAG
         DC    H'5'                     DATA LENGTH
         DC    H'56'                    DATA OFFSET
         DC    H'75'                    PRINT COLUMN
         DC    H'5'                     PRINT LENGTH
         DC    H'0'                     CONVERSION FLAGS (CHAR)
* STATIC TEXT SUB-STRUCTURE
         DC    X'0400'                 STATIC TEXT FLAG
         DC    Y(STE31B-STE31A)        TEXT LENGTH
         DC    Y(STE31A-TXT3A)         TEXT OFFSET
         DC    H'81'                   PRINT COLUMN
         DC    Y(STE31B-STE31A)        PRINT LENGTH
         DC    H'0'                    CONVERSION FLAGS (CHAR)
* BLOCK DATA SUB-STRUCTURE
         DC    X'1000'                 BLOCK DATA FLAG
         DC    H'1'                    DATA LENGTH
         DC    H'61'                   DATA OFFSET
         DC    H'88'                   PRINT COLUMN
         DC    H'3'                     MAXIMUM PRINT LENGTH
         DC    X'10A0'                  CONVERSION FLAGS (BD,ZS,SS)
* STATIC TEXT SUB-STRUCTURE
         DC    X'0400'                  STATIC TEXT FLAG
         DC    Y(STE32B-STE32A)         TEXT LENGTH
         DC    Y(STE32A-TXT3A)          TEXT OFFSET
         DC    H'92'                    PRINT COLUMN OFFSET
         DC    Y(STE32B-STE32A)         PRINT LENGTH
         DC    H'0'                     CONVERSION FLAGS (BS)
* BLOCK DATA SUB-STRUCTURE
         DC    X'1000'                  BLOCK DATA FLAG
         DC    H'1'                     MAXIMUM DATA LENGTH
         DC    H'62'                    DATA OFFSET
         DC    H'95'                    PRINT COLUMN OFFSET
         DC    H'3'                     MAXIMUM PRINT LENGTH
         DC    X'10A0'                  CONVERSION FLAGS (BD,ZS,SS)
* STATIC TEXT SUB-STRUCTURE
         DC    X'8400'                  STATIC TEXT FLAG
         DC    Y(STE33B-STE33A)         TEXT LENGTH
         DC    Y(STE33A-TXT3A)          TEXT OFFSET
         DC    H'99'                    PRINT COLUMN OFFSET
         DC    Y(STE33B-STE33A)         PRINT LENGTH
         DC    H'0'                     CONVERSION FLAGS (BD,ZS,SS,BS)
* STATIC TEXT ENTRIES
STE31A   DC    C'VOLUME'
STE31B   EQU   *
STE32A   DC    C'OF'
STE32B   EQU   *
STE33A   DC    C'IS CURRENT'
STE33B   EQU   *
TXT3B    EQU   *
         EJECT
***********************************************************************
*                                                                     *
* VOLUME SERIAL NUMBER LIST                                           *
*                                                                     *
***********************************************************************
         SPACE 1
TXT4     DC    Y(TXT4B-TXT4A)           ENTRY LENGTH
         DC    H'0'                     NO FLAGS
* SPACING CONTROL SUBSTRUCUTRE
TXT4A    DC    X'4000'                  SPACE CONTROL FLAG
         DC    H'1'                     SPACING FACTOR
         DC    C'R '                    SPACING TYPE (RELATIVE)
* BLOCK DATA SUB-STRUCTURE
         DC    X'1000'                  BLOCK DATA FLAG
         DC    H'7'                     DATA LENGTH
         DC    H'0'                     OFFSET TO DATA
         DC    H'81'                    PRINT COLUMN
         DC    H'7'                     PRINT LENGTH
         DC    H'0'                     CONVERSION FLAGS  (CHAR)
* BLOCK DATA SUB-STRUCTURE
         DC    X'1000'                  BLOCK DATA FLAGS
         DC    H'7'                     DATA LENGTH
         DC    H'7'                     OFFSET TO DATA
         DC    H'89'                    PRINT COLUMN
         DC    H'7'                     PRINT LENGTH
         DC    H'0'                     CONVERSION FLAGS (CHAR)
* BLOCK DATA SUB-STRUCTURE
         DC    X'1000'                  BLOCK DATA FLAGS
         DC    H'7'                     DATA LENGTH
         DC    H'14'                    OFFSET TO DATA
         DC    H'97'                    PRINT COLUMN
         DC    H'7'                     PRINT LENGTH
         DC    H'0'                     CONVERSION FLAGS (CHAR)
* BLOCK DATA SUB-STRUCTURE
         DC    X'1000'                  BLOCK DATA FLAGS
         DC    H'7'                     DATA LENGTH
         DC    H'21'                    OFFSET TO DATA
         DC    H'105'                   PRINT COLUMN
         DC    H'7'                     PRINT LENGTH
         DC    H'0'                     CONVERSION FLAGS (CHAR)
* BLOCK DATA SUB-STRUCTURE
         DC    X'9000'                  BLOCK DATA FLAGS
         DC    H'7'                     DATA LENGTH
         DC    H'28'                    OFFSET TO DATA
         DC    H'113'                   PRINT COLUMN
         DC    H'7'                     PRINT LENGTH
         DC    H'0'                     CONVERSION FLAGS (CHAR)
TXT4B    EQU   *
         EJECT
***********************************************************************
*                                                                     *
* IDC1860I SELECTED CHECKID XXXXXXXXXXXXXXXX NOT FOUND                *
*                                                                     *
***********************************************************************
         SPACE 1
TXT5     DC    Y(TXT5B-TXT5A)           ENTRY LENGTH
         DC    X'8000'                  MESSAGE FLAG
* SPACING CONTROL SUB-STRUCTURE
TXT5A    DC    X'4000'                  SPACE CONTROL FLAG
         DC    H'1'                     SPACING FACTOR
         DC    C'R '                    SPACING TYPE (RELATIVE)
* STATIC TEXT SUB-STRUCTURE
         DC    X'0400'                  STATIC TEXT FLAG
         DC    Y(STE51B-STE51A)         TEXT LENGTH
         DC    Y(STE51A-TXT5A)          TEXT OFFSET
         DC    H'1'                     PRINT COLUMN
         DC    Y(STE51B-STE51A)         PRINT LENGTH
         DC    H'0'                     CONVERSION FLAGS (CHAR)
* BLOCK DATA SUB-STRUCTURE
         DC    X'1000'                  BLOCK DATA FLAG
         DC    H'16'                    MAXIMUM LENGTH OF DATA
         DC    H'0'                     OFFSET TO DATA
         DC    H'27'                    PRINT COLUMN
         DC    H'16'                    MAXIMUM PRINT LENGTH
         DC    H'0'                     CONVERSION FLAGS (CHAR)
* STATIC TEXT SUB-STRUCTURE
         DC    X'8400'                  STATIC TEXT FLAG
         DC    Y(STE52B-STE52A)         TEXT LENGTH
         DC    Y(STE52A-TXT5A)          TEXT OFFSET
         DC    H'1'                     PRINT COLUMN OFFSET
         DC    Y(STE52B-STE52A)         PRINT LENGTH
         DC    X'0010'                  CONVERSION FLAGS (BS)
* STATIC TEXT ENTRIES
STE51A   DC    C'IDC1860I SELECTED CHECKID'
STE51B   EQU   *
STE52A   DC    C'NOT FOUND'
STE52B   EQU   *
TXT5B    EQU   *
         EJECT
***********************************************************************
*                                                                     *
* IDC0861I NO TAPE DATA SETS OPEN FOR THIS CHECKPOINT                 *
*                                                                     *
***********************************************************************
         SPACE 1
TXT6     DC    Y(TXT6B-TXT6A)           ENTRY LENGTH
         DC    X'8000'                  MESSAGE FLAG
* SPACING CONTROL SUB-STRUCTURE
TXT6A    DC    X'4000'                  SPACE CONTROL FLAG
         DC    H'1'                     SPACING FACTOR
         DC    C'R '                    SPACING TYPE (RELATIVE)
* STATIC TEXT SUB-STRUCTURE
         DC    X'8400'                  STATIC TEXT FLAG
         DC    Y(STE61B-STE61A)         TEXT LENGTH
         DC    Y(STE61A-TXT6A)          TEXT OFFSET
         DC    H'1'                     PRINT COLUMN
         DC    Y(STE61B-STE61A)         PRINT LENGTH
         DC    H'0'                     CONVERSION FLAGS (CHAR)
* STATIC TEXT ENTRIES
STE61A   DC    C'IDC0861I NO TAPE DATA SETS OPEN FOR THIS CHECKPOINT'
STE61B   EQU   *
TXT6B    EQU   *
         EJECT
***********************************************************************
*                                                                     *
* IDC0862I DUPLICATE SELECTED CHECKID XXXXXXXXXXXXXXXX                *
*                                                                     *
***********************************************************************
         SPACE 1
TXT7     DC    Y(TXT7B-TXT7A)           ENTRY LENGTH
         DC    X'8000'                  MESSAGE FLAG
* SPACING CONTROL SUB-STRUCTURE
TXT7A    DC    X'4000'                  SPACE CONTROL FLAG
         DC    H'1'                     SPACING FACTOR
         DC    C'R '                    SPACING TYP (RELATIVE)
* STATIC TEXT SUB-STRUCTURE
         DC    X'0400'                  STATIC TEXT FLAG
         DC    Y(STE71B-STE71A)         TEXT LENGTH
         DC    Y(STE71A-TXT7A)          TEXT OFFSET
         DC    H'1'                     PRINT COLUMN
         DC    Y(STE71B-STE71A)         PRINT LENGTH
         DC    H'0'                     CONVERSION FLAG (CHAR)
* BLOCK DATA SUB-STRUCTURE
         DC    X'9000'                  BLOCK DATA FLAG
         DC    H'16'                    MAXIMUM DATA LENGTH
         DC    H'0'                     OFFSET TO DATA
         DC    H'41'                    PRINT COLUMN
         DC    H'16'                    MAXIMUM PRINT LENGTH
         DC    H'0'                     CONVERSION FLAGS (CHAR)
* STATIC TEXT ENTRIES
STE71A   DC    C'IDC0862I DUPLICATE SELECTED CHECKID'
STE71B   EQU   *
TXT7B    EQU   *
         EJECT
***********************************************************************
*                                                                     *
* IDC0863I DUPLICATE CHECKPOINT ENTRY XXXXXXXXXXXXXXXX                *
*                                                                     *
***********************************************************************
         SPACE 1
TXT8     DC    Y(TXT8B-TXT8A)           ENTRY LENGTH
         DC    X'8000'                  MESSAGE FLAGS
* SPACING CONTROL SUBSTRUCTURE
TXT8A    DC    X'4000'                  SPACE CONTROL FLAG
         DC    H'2'                     SPACING FACTOR
         DC    C'R '                    SPACING TYPE (RELATIVE)
* STATIC TEXT SUB-STRUCTURE
         DC    X'0400'                  STATIC TEXT FLAG
         DC    Y(STE81B-STE81A)         TEXT LENGTH
         DC    Y(STE81A-TXT8A)          TEXT OFFSET
         DC    H'1'                     PRINT COLUMN
         DC    Y(STE81B-STE81A)         PRINT LENGTH
         DC    H'0'                     CONVERSION FLAGS (CHAR)
* BLOCK DATA SUB-STRUCTURE
         DC    X'9000'                  BLOCK DATA FLAG
         DC    H'16'                    MAXIMUM DATA LENGTH
         DC    H'0'                     OFFSET TO DATA
         DC    H'37'                    PRINT COLUMN
         DC    H'16'                    MAXIMUM PRINT LENGTH
         DC    H'0'                     CONVERSION FLAGS (CHAR)
* STATIC TEXT ENTRIES
STE81A   DC    C'IDC0863I DUPLICATE CHECKPOINT ENTRY'
STE81B   EQU   *
TXT8B    EQU   *
         EJECT
***********************************************************************
*                                                                     *
* IDC1864I NO CHECKPOINTS FOUND ON DATA SET                           *
*                                                                     *
***********************************************************************
         SPACE 1
TXT9     DC    Y(TXT9B-TXT9A)           ENTRY LENGTH
         DC    X'8000'                  MESSAGE FLAG
* SPACING CONTROL SUBSTRUCTURE
TXT9A    DC    X'4000'                  SPACE CONTROL FLAG
         DC    H'2'                     SPACING FACTOR
         DC    C'R '                    SPACING TYPE (RELATIVE)
* STATIC TEXT SUB-STRUCTURE
         DC    X'8400'                  STATIC TEXT FLAG
         DC    Y(STE91B-STE91A)         TEXT LENGTH
         DC    Y(STE91A-TXT9A)          TEXT OFFSET
         DC    H'1'                     PRINT COLUMN
         DC    Y(STE91B-STE91A)         PRINT LENGTH
         DC    H'0'                     CONVERSION FLAGS (CHAR)
* STATIC TEXT ENTRIES
STE91A   DC    C'IDC1864I NO CHECKPOINTS FOUND ON DATA SET'
STE91B   EQU   *
TXT9B    EQU   *
         EJECT
***********************************************************************
*                                                                     *
* IDC1865I XXXXXXXX ADDITIONAL VOLUME SERIALS NOT FOUND IN CHKPT DATA *
*          DATA SET                                                   *
*                                                                     *
***********************************************************************
         SPACE 1
TXT10    DC    Y(TXT10B-TXT10A)         ENTRY LENGTH
         DC    X'8000'                  MESSAGE FLAG
* SPACING CONTROL SUBSTRUCTURE
TXT10A   DC    X'4000'                  SPACE CONTROL FLAG
         DC    H'1'                     SPACING FACTOR
         DC    C'R '                    SPACING TYPE (RELATIVE)
* STATIC TEXT CONTROL SUB-STRUCTURE
         DC    X'0400'                  STATIC TEXT FLAG
         DC    Y(STE101B-STE101A)       TEXT LENGTH
         DC    Y(STE101A-TXT10A)        TEXT OFFSET
         DC    H'1'                     PRINT COLUMN
         DC    Y(STE101B-STE101A)       PRINT LENGTH
         DC    H'0'                     CONVERSION FLAGS (CHAR)
* BLOCK DATA SUB-STRUCTURE
         DC    X'1000'                  BLOCK DATA FLAG
         DC    H'8'                     MAXIMUM DATA LENGTH
         DC    H'0'                     OFFSET TO DATA
         DC    H'10'                    PRINT COLUMN
         DC    H'8'                     MAXIMUM PRINT LENGTH
         DC    H'0'                     CONVERSION FLAGS (CHAR)
* STATIC TEXT SUB-STRUCTURE
         DC    X'8400'                  STATIC TEXT FLAGS
         DC    Y(STE102B-STE102A)       TEXT LENGTH
         DC    Y(STE102A-TXT10A)        TEXT OFFSET
         DC    H'1'                     PRINT COLUMN OFFSET
         DC    Y(STE102B-STE102A)       PRINT LENGTH
         DC    X'0010'                  CONVERSION FLAGS (BS)
* STATIC TEXT ENTRIES
STE101A  DC    C'IDC1865I'
STE101B  EQU   *
STE102A  DC    C'ADDITIONAL VOLUME SERIALS NOT FOUND IN CHKPT DATA SET'
STE102B  EQU   *
TXT10B   EQU   *
         EJECT
***********************************************************************
*                                                                     *
* IDC1866I UNEXPECTED EOF ON CHECKPOINT DATA SET                      *
*                                                                     *
***********************************************************************
         SPACE 1
TXT11    DC    Y(TXT11B-TXT11A)         ENTRY LENGTH
         DC    X'8000'                  MESSAGE FLAG
* SPACING CONTROL SUB-STRUCTURE
TXT11A   DC    X'4000'                  SPACE CONTROL FLAG
         DC    H'2'                     SPACING FACTOR
         DC    C'R '                    SPACING TYPE (RELATIVE)
* STATIC TEXT SUB-STRUCTURE
         DC    X'8400'                  STATIC TEXT FLAG
         DC    Y(STE111B-STE111A)       TEXT LENGTH
         DC    Y(STE111A-TXT11A)        TEXT OFFSET
         DC    H'1'                     PRINT COLUMN
         DC    Y(STE111B-STE111A)       PRINT LENGTH
         DC    H'0'                     CONVERSION FLAGS (CHAR)
* STATIC TEXT ENTRIES
STE111A  DC    C'IDC1866I UNEXPECTED EOF ON CHECKPOINT DATA SET'
STE111B  EQU   *
TXT11B   EQU   *
         EJECT
***********************************************************************
*                                                                     *
* IDC1867I CURRENT VOLUME NOT FOUND XXXXXXXX                          *
*                                                                     *
***********************************************************************
         SPACE 1
TXT12    DC    Y(TXT12B-TXT12A)         ENTRY LENGTH
         DC    X'8000'                  MESSAGE FLAG
* SPACING CONTROL SUB-STRUCTURE
TXT12A   DC    X'4000'                  SPACING CONTROL FLAG
         DC    H'1'                     SPACING FACTOR
         DC    C'R '                    SPACING TYPE (RELATIVE)
* STATIC TEXT SUB-STRUCTURE
         DC    X'0400'                  STATIC TEXT FLAG
         DC    Y(STE121B-STE121A)       TEXT LENGTH
         DC    Y(STE121A-TXT12A)        TEXT OFFSET
         DC    H'1'                     PRINT COLUMN
         DC    Y(STE121B-STE121A)       PRINT LENGTH
         DC    H'0'                     CONVERSION FLAGS (CHAR)
* BLOCK DATA SUB-STRUCTURE
         DC    X'9000'                  BLOCK DATA FLAG
         DC    H'8'                     MAXIMUM DATA LENGTH
         DC    H'0'                     OFFSET TO DATA
         DC    H'35'                    PRINT COLUMN
         DC    H'8'                     MAXIMUM PRINT LENGTH
         DC    H'0'                     CONVERSION FLAGS (CHAR)
* STATIC TEXT ENTRIES
STE121A  DC    C'IDC1867I CURRENT VOLUME NOT FOUND'
STE121B  EQU   *
TXT12B   EQU   *
         END
