         TITLE '***** IDCTSCO0 - COPYV STATIC TEXT *****'
************************************************************
*                                                          *
* MODULE NAME -  IDCTSCO0                                  *
*                                                          *
*                                                          *
* DESCRIPTIVE NAME - STATIC TEXT MODULE FOR THE COPY       *
*        VOLUME FUNCTION                                   *
*                                                          *
* COPYRIGHT - NONE                                         *
*                                                          *
* STATUS - RELEASE 0  LEVEL 0                              *
*                                                          *
* FUNCTION - CONTAINS NO EXECTABLE CODE, ONLY STATIC TEXT  *
*        ENTRIES FOR THE FUNCTION COPY VOLUME              *
*        THIS MODULE IS LOADED BY IDCTP05 WHEN A STATIC    *
*        TEXT REQUEST IS MADE.                             *
*                                                          *
* NOTES - NONE                                             *
*                                                          *
*        DEPENDENCIES - NONE                               *
*        RESTRICTIONS - NONE                               *
*        REGISTER CONVENTIONS - NA                         *
*        PATCH AREA - NA                                   *
*                                                          *
* MODULE TYPE - TABLES                                     *
*                                                          *
*        PROCESSOR - ASSEMBLER                             *
*        MODULE SIZE - 979                                 *
*        ATTRIBUTES - READ-ONLY                            *
*                                                          *
* ENTRY POINT - NA                                         *
*                                                          *
* EXIT NORMAL - NA                                         *
*                                                          *
* EXIT ERROR - NA                                          *
*                                                          *
* EXTERNAL REFERENCES - NA                                 *
*                                                          *
* TABLES - NA                                              *
*                                                          *
* MACROS - NA                                              *
*                                                          *
* CHANGE ACTIVITY - NONE                                   *
*                                                          *
************************************************************
         EJECT
************************************************************
*                                                          *
* THIS MODULE IS THE FIRST MODULE OF STATIC TEXT REQUIRED  *
* BY THE COPY VOLUME FUNCTION                              *
*                                                          *
************************************************************
*
IDCTSCO0 CSECT
*
INDEX    DC    Y((INDEXEND-INDEX1)/2)  COUNT OF ENTRIES
INDEX1   DC    Y(TXT1-INDEX)
INDEX2   DC    Y(TXT2-INDEX)
INDEX3   DC    Y(TXT3-INDEX)
INDEX4   DC    Y(TXT4-INDEX)
INDEX5   DC    Y(TXT5-INDEX)
INDEX6   DC    Y(TXT6-INDEX)
INDEX7   DC    Y(TXT7-INDEX)
INDEX8   DC    Y(TXT8-INDEX)
INDEX9   DC    Y(TXT9-INDEX)
INDEX10  DC    Y(TXT10-INDEX)
INDEXEND DS    0H
         EJECT
**********************************************************
*                                                        *
* IDC3700I ** LATEST COPY RECORD CANNOT BE RETRIEVED     *
*          FROM INVENTORY                                *
*                                                        *
**********************************************************
         SPACE 3
TXT1     DC    Y(TXT1B-TXT1A)          ENTRY LENGTH
         DC    X'8000'                 MESSAGE FLAG
         SPACE 1
* SPACING CONTROL SUB-STRUCTURE
TXT1A    DC    X'4000'                 SPACE CONTROL FLAG
         DC    H'1'                    SPACING FACTOR
         DC    C'R '                   SPACING TYPE
         SPACE 1
* STATIC TEXT SUB-STRUCTURE
         DC    X'8400'                 STATIC TEXT FLAG
         DC    Y(STE11B-STE11A)        TEXT LENGTH
         DC    Y(STE11A-TXT1A)         TEXT OFFSET
         DC    H'1'                    PRINT COLUMN
         DC    Y(STE11B-STE11A)        PRINT FIELD LENGTH
         DC    X'0000'                 CONVERSION FLAGS
         SPACE 1
* STATIC TEXT ENTRIES
STE11A   DC    C'IDC3700I ** LATEST COPY RECORD CANNOT BE'
         DC    C' RETRIEVED FROM INVENTORY'
STE11B   EQU   *
TXT1B    EQU   *
         EJECT
**********************************************************
*                                                        *
* IDC3701I ** OLDEST BACKUP COPY RECORD CANNOT BE        *
*          RETRIEVED FROM INVENTORY                      *
*                                                        *
**********************************************************
         SPACE 3
TXT2     DC    Y(TXT2B-TXT2A)          ENTRY LENGTH
         DC    X'8000'                 MESSAGE FLAG
         SPACE 1
* SPACING CONTROL SUB-STRUCTURE
TXT2A    DC    X'4000'                 SPACE CONTROL FLAG
         DC    H'1'                    SPACING FACTOR
         DC    C'R '                   SPACING TYPE
         SPACE 1
* STATIC TEXT SUB-STRUCTURE
         DC    X'8400'                 STATIC TEXT FLAG
         DC    Y(STE21B-STE21A)        TEXT LENGTH
         DC    Y(STE21A-TXT2A)         TEXT OFFSET
         DC    H'1'                    PRINT COLUMN
         DC    Y(STE21B-STE21A)        PRINT FIELD LENGTH
         DC    X'0000'                 CONVERSION FLAGS
         SPACE 1
* STATIC TEXT ENTRIES
STE21A   DC    C'IDC3701I ** OLDEST BACKUP RECORD CANNOT '
         DC    C'BE RETRIEVED FROM INVENTORY'
STE21B   EQU   *
TXT2B    EQU   *
         EJECT
**********************************************************
*                                                        *
* IDC3702I TARGET COPY (YYDDD) CANNOT BE USED            *
*                                                        *
**********************************************************
         SPACE 3
TXT3     DC    Y(TXT3B-TXT3A)          ENTRY LENGTH
         DC    X'8000'                 MESSAGE FLAG
         SPACE 1
* SPACING CONTROL SUB-STRUCTURE
TXT3A    DC    X'4000'                 SPACE CONTROL FLAG
         DC    H'2'                    SPACING FACTOR
         DC    C'R '                   SPACING TYPE
         SPACE 1
* STATIC TEXT SUB-STRUCTURE
         DC    X'0400'                 STATIC TEXT FLAG
         DC    Y(STE31B-STE31A)        TEXT LENGTH
         DC    Y(STE31A-TXT3A)         TEXT OFFSET
         DC    H'1'                    PRINT COLUMN
         DC    Y(STE31B-STE31A)        PRINT FIELD LENGTH
         DC    X'0000'                 CONVERSION FLAGS
         SPACE 1
* BLOCK DATA SUB-STRUCTURE
         DC    X'1000'                 STRUCTURE TYPE FLG
         DC    H'05,00,22,05'          LNG,OFST,PC,LNG
         DC    X'08E0'                 CONVERSION FLGS
         SPACE 1
* STATIC TEXT SUB-STRUCTURE
         DC    X'8400'                 STATIC TEXT FLAG
         DC    Y(STE32B-STE32A)        TEXT LENGTH
         DC    Y(STE32A-TXT3A)         TEXT OFFSET
         DC    H'28'                   PRINT COLUMN
         DC    Y(STE32B-STE32A)        PRINT FIELD LENGTH
         DC    X'0000'                 CONVERSION FLAGS
         SPACE 1
* STATIC TEXT ENTRIES
STE31A   DC    C'IDC3702I TARGET COPY'
STE31B   EQU   *
STE32A   DC    C'CANNOT BE USED'
STE32B   EQU   *
TXT3B    EQU   *
         EJECT
**********************************************************
*                                                        *
* IDC0703I VOL (VOLSER) COPIED TO CART (CSN) (CSN) ;     *
*          DATE (YYDDD)                                  *
*                                                        *
**********************************************************
         SPACE 3
TXT4     DC    Y(TXT4B-TXT4A)          ENTRY LENGTH
         DC    X'8000'                 MESSAGE FLAG
         SPACE 1
* SPACING CONTROL SUB-STRUCTURE
TXT4A    DC    X'4000'                 SPACE CONTROL FLAG
         DC    H'2'                    SPACING FACTOR
         DC    C'R '                   SPACING TYPE
         SPACE 1
* STATIC TEXT SUB-STRUCTURE
         DC    X'0400'                 STATIC TEXT FLAG
         DC    Y(STE41B-STE41A)        TEXT LENGTH
         DC    Y(STE41A-TXT4A)         TEXT OFFSET
         DC    H'1'                    PRINT COLUMN
         DC    Y(STE41B-STE41A)        PRINT FIELD LENGTH
         DC    X'0000'                 CONVERSION FLAGS
         SPACE 1
* BLOCK DATA SUB-STRUCTURE
         DC    X'1000'                 STRUCTURE TYPE FLG
         DC    H'06,00,14,06'          LNG,OFST,PC,LNG
         DC    X'0000'                 CONVERSION FLGS
         SPACE 1
* STATIC TEXT SUB-STRUCTURE
         DC    X'0400'                 STATIC TEXT FLAG
         DC    Y(STE42B-STE42A)        TEXT LENGTH
         DC    Y(STE42A-TXT4A)         TEXT OFFSET
         DC    H'21'                   PRINT COLUMN
         DC    Y(STE42B-STE42A)        PRINT FIELD LENGTH
         DC    X'0000'                 CONVERSION FLAGS
         SPACE 1
* INSERT DATA SUB-STRUCTURE
         DC    X'2000'                 STRUCTURE TYPE FLG
         DC    H'01,00,36,12'          LNG,OFST,PC,LNG
         DC    X'0000'                 CONVERSION FLGS
         SPACE 1
* INSERT DATA SUB-STRUCTURE
         DC    X'2000'                 STRUCTURE TYPE FLG
         DC    H'02,00,49,12'          LNG,OFST,PC,LNG
         DC    X'0000'                 CONVERSION FLGS
         SPACE 1
* STATIC TEXT SUB-STRUCTURE
         DC    X'0400'                 STATIC TEXT FLAG
         DC    Y(STE43B-STE43A)        TEXT LENGTH
         DC    Y(STE43A-TXT4A)         TEXT OFFSET
         DC    H'61'                   PRINT COLUMN
         DC    Y(STE43B-STE43A)        PRINT FIELD LENGTH
         DC    X'0000'                 CONVERSION FLAGS
         SPACE 1
* INSERT DATA SUB-STRUCTURE
         DC    X'A000'                 STRUCTURE TYPE FLG
         DC    H'03,00,68,05'          LNG,OFST,PC,LNG
         DC    X'08E0'                 CONVERSION FLGS
         SPACE 1
* STATIC TEXT ENTRIES
STE41A   DC    C'IDC0703I VOL'
STE41B   EQU   *
STE42A   DC    C'COPIED TO CART'
STE42B   EQU   *
STE43A   DC    C'; DATE'
STE43B   EQU   *
TXT4B    EQU   *
         EJECT
**********************************************************
*                                                        *
* IDC0704I ** CARTRIDGES OF OLDEST BACKUP COPY (YYDDD)   *
*          SELECTED FOR REUSE                            *
*                                                        *
**********************************************************
         SPACE 3
TXT5     DC    Y(TXT5B-TXT5A)          ENTRY LENGTH
         DC    X'8000'                 MESSAGE FLAG
         SPACE 1
* SPACING CONTROL SUB-STRUCTURE
TXT5A    DC    X'4000'                 SPACE CONTROL FLAG
         DC    H'1'                    SPACING FACTOR
         DC    C'R '                   SPACING TYPE
         SPACE 1
* STATIC TEXT SUB-STRUCTURE
         DC    X'0400'                 STATIC TEXT FLAG
         DC    Y(STE51B-STE51A)        TEXT LENGTH
         DC    Y(STE51A-TXT5A)         TEXT OFFSET
         DC    H'1'                    PRINT COLUMN
         DC    Y(STE51B-STE51A)        PRINT FIELD LENGTH
         DC    X'0000'                 CONVERSION FLAGS
         SPACE 1
* BLOCK DATA SUB-STRUCTURE
         DC    X'1000'                 STRUCTURE TYPE FLG
         DC    H'05,00,46,05'          LNG,OFST,PC,LNG
         DC    X'08E0'                 CONVERSION FLGS
         SPACE 1
* STATIC TEXT SUB-STRUCTURE
         DC    X'8400'                 STATIC TEXT FLAG
         DC    Y(STE52B-STE52A)        TEXT LENGTH
         DC    Y(STE52A-TXT5A)         TEXT OFFSET
         DC    H'52'                   PRINT COLUMN
         DC    Y(STE52B-STE52A)        PRINT FIELD LENGTH
         DC    X'0000'                 CONVERSION FLAGS
         SPACE 1
* STATIC TEXT ENTRIES
STE51A   DC    C'IDC0704I ** CARTRIDGES OF OLDEST BACKUP '
         DC    C'COPY'
STE51B   EQU   *
STE52A   DC    C'SELECTED FOR REUSE'
STE52B   EQU   *
TXT5B    EQU   *
         EJECT
**********************************************************
*                                                        *
* IDC0705I ** CARTRIDGES OF AN INCOMPLETE COPY VOLUME    *
*          SELECTED FOR REUSE                            *
*                                                        *
**********************************************************
         SPACE 3
TXT6     DC    Y(TXT6B-TXT6A)          ENTRY LENGTH
         DC    X'8000'                 MESSAGE FLAG
         SPACE 1
* SPACING CONTROL SUB-STRUCTURE
TXT6A    DC    X'4000'                 SPACE CONTROL FLAG
         DC    H'1'                    SPACING FACTOR
         DC    C'R '                   SPACING TYPE
         SPACE 1
* STATIC TEXT SUB-STRUCTURE
         DC    X'8400'                 STATIC TEXT FLAG
         DC    Y(STE61B-STE61A)        TEXT LENGTH
         DC    Y(STE61A-TXT6A)         TEXT OFFSET
         DC    H'1'                    PRINT COLUMN
         DC    Y(STE61B-STE61A)        PRINT FIELD LENGTH
         DC    X'0000'                 CONVERSION FLAGS
         SPACE 1
* STATIC TEXT ENTRIES
STE61A   DC    C'IDC0705I ** CARTRIDGES OF AN INCOMPLETE'
         DC    C' COPY VOLUME SELECTED FOR REUSE'
STE61B   EQU   *
TXT6B    EQU   *
         EJECT
************************************************************
*                                                          *
* IDC3706I ** COPY TO CARTRIDGES (CSN) (CSN) IS INCOMPLETE *
*                                                          *
************************************************************
         SPACE 3
TXT7     DC    Y(TXT7B-TXT7A)          ENTRY LENGTH
         DC    X'8000'                 MESSAGE FLAG
         SPACE 1
* SPACING CONTROL SUB-STRUCTURE
TXT7A    DC    X'4000'                 SPACE CONTROL FLAG
         DC    H'1'                    SPACING FACTOR
         DC    C'R '                   SPACING TYPE
         SPACE 1
* STATIC TEXT SUB-STRUCTURE
         DC    X'0400'                 STATIC TEXT FLAG
         DC    Y(STE71B-STE71A)        TEXT LENGTH
         DC    Y(STE71A-TXT7A)         TEXT OFFSET
         DC    H'1'                    PRINT COLUMN
         DC    Y(STE71B-STE71A)        PRINT FIELD LENGTH
         DC    X'0000'                 CONVERSION FLAGS
         SPACE 1
* BLOCK DATA SUB-STRUCTURE
         DC    X'1000'                 STRUCTURE TYPE FLG
         DC    H'12,00,32,12'          LNG,OFST,PC,LNG
         DC    X'0000'                 CONVERSION FLGS
         SPACE 1
* INSERT DATA SUB-STRUCTURE
         DC    X'2000'                 STRUCTURE TYPE FLG
         DC    H'01,00,45,12'          LNG,OFST,PC,LNG
         DC    X'0000'                 CONVERSION FLGS
         SPACE 1
* STATIC TEXT SUB-STRUCTURE
         DC    X'8400'                 STATIC TEXT FLAG
         DC    Y(STE72B-STE72A)        TEXT LENGTH
         DC    Y(STE72A-TXT7A)         TEXT OFFSET
         DC    H'58'                   PRINT COLUMN
         DC    Y(STE72B-STE72A)        PRINT FIELD LENGTH
         DC    X'0000'                 CONVERSION FLAGS
         SPACE 1
* STATIC TEXT ENTRIES
STE71A   DC    C'IDC3706I ** COPY TO CARTRIDGES'
STE71B   EQU   *
STE72A   DC    C'IS INCOMPLETE'
STE72B   EQU   *
TXT7B    EQU   *
         EJECT
**********************************************************
*                                                        *
* IDC1707I ** OWNER (OWNERID) NOT UPDATED IN INVENTORY   *
*           FOR NEW COPY (YYDDD)                         *
*                                                        *
**********************************************************
         SPACE 3
TXT8     DC    Y(TXT8B-TXT8A)          ENTRY LENGTH
         DC    X'8000'                 MESSAGE FLAG
         SPACE 1
* SPACING CONTROL SUB-STRUCTURE
TXT8A    DC    X'4000'                 SPACE CONTROL FLAG
         DC    H'1'                    SPACING FACTOR
         DC    C'R '                   SPACING TYPE
         SPACE 1
* STATIC TEXT SUB-STRUCTURE
         DC    X'0400'                 STATIC TEXT FLAG
         DC    Y(STE81B-STE81A)        TEXT LENGTH
         DC    Y(STE81A-TXT8A)         TEXT OFFSET
         DC    H'1'                    PRINT COLUMN
         DC    Y(STE81B-STE81A)        PRINT FIELD LENGTH
         DC    X'0000'                 CONVERSION FLAGS
         SPACE 1
* BLOCK DATA SUB-STRUCTURE
         DC    X'1000'                 STRUCTURE TYPE FLG
         DC    H'10,00,19,10'          LNG,OFST,PC,LNG
         DC    X'0000'                 CONVERSION FLGS
         SPACE 1
* STATIC TEXT SUB-STRUCTURE
         DC    X'0400'                 STATIC TEXT FLAG
         DC    Y(STE82B-STE82A)        TEXT LENGTH
         DC    Y(STE82A-TXT8A)         TEXT OFFSET
         DC    H'30'                   PRINT COLUMN
         DC    Y(STE82B-STE82A)        PRINT FIELD LENGTH
         DC    X'0000'                 CONVERSION FLAGS
         SPACE 1
* INSERT DATA SUB-STRUCTURE
         DC    X'2000'                 STRUCTURE TYPE FLG
         DC    H'01,00,43,05'          LNG,OFST,PC,LNG
         DC    X'08E0'                 CONVERSION FLGS
         SPACE 1
* STATIC TEXT ENTRIES
STE81A   DC    C'IDC1707I ** OWNER'
STE81B   EQU   *
STE82A   DC    C'NOT UPDATED IN INVENTORY FOR NEW COPY'
STE82B   EQU   *
TXT8B    EQU   *
         EJECT
**********************************************************
*                                                        *
* IDC3708I ** COPY VOLUME COULD NOT BE CREATED           *
*                                                        *
**********************************************************
         SPACE 3
TXT9     DC    Y(TXT9B-TXT9A)          ENTRY LENGTH
         DC    X'8000'                 MESSAGE FLAG
         SPACE 1
* SPACING CONTROL SUB-STRUCTURE
TXT9A    DC    X'4000'                 SPACE CONTROL FLAG
         DC    H'1'                    SPACING FACTOR
         DC    C'R '                   SPACING TYPE
         SPACE 1
* STATIC TEXT SUB-STRUCTURE
         DC    X'8400'                 STATIC TEXT FLAG
         DC    Y(STE91B-STE91A)        TEXT LENGTH
         DC    Y(STE91A-TXT9A)         TEXT OFFSET
         DC    H'1'                    PRINT COLUMN
         DC    Y(STE91B-STE91A)        PRINT FIELD LENGTH
         DC    X'0000'                 CONVERSION FLAGS
         SPACE 1
* STATIC TEXT ENTRIES
STE91A   DC    C'IDC3708I ** COPY VOLUME COULD NOT BE '
         DC    C'CREATED'
STE91B   EQU   *
TXT9B    EQU   *
         EJECT
****************************************************************
*                                                              *
* IDC3709I ** COPY TO CARTRIDGES (CSN) (CSN) NOT PERFORMED     *
*                                                              *
****************************************************************
         SPACE 3
TXT10    DC    Y(TXT10B-TXT10A)        ENTRY LENGTH
         DC    X'8000'                 MESSAGE FLAG
         SPACE 1
* SPACING CONTROL SUB-STRUCTURE
TXT10A   DC    X'4000'                 SPACE CONTROL FLAG
         DC    H'1'                    SPACING FACTOR
         DC    C'R '                   SPACING TYPE
         SPACE 1
* STATIC TEXT SUB-STRUCTURE
         DC    X'0400'                 STATIC TEXT FLAG
         DC    Y(STE101B-STE101A)      TEXT LENGTH
         DC    Y(STE101A-TXT10A)       TEXT OFFSET
         DC    H'1'                    PRINT COLUMN
         DC    Y(STE101B-STE101A)      PRINT FIELD LENGTH
         DC    X'0000'                 CONVERSION FLAGS
         SPACE 1
* BLOCK DATA SUB-STRUCTURE
         DC    X'1000'                 STRUCTURE TYPE FLG
         DC    H'12,00,32,12'          LNG,OFST,PC,LNG
         DC    X'0000'                 CONVERSION FLGS
         SPACE 1
* INSERT DATA SUB-STRUCTURE
         DC    X'2000'                 STRUCTURE TYPE FLG
         DC    H'01,00,45,12'          LNG,OFST,PC,LNG
         DC    X'0000'                 CONVERSION FLGS
         SPACE 1
* STATIC TEXT SUB-STRUCTURE
         DC    X'8400'                 STATIC TEXT FLAG
         DC    Y(STE102B-STE102A)      TEXT LENGTH
         DC    Y(STE102A-TXT10A)       TEXT OFFSET
         DC    H'58'                   PRINT COLUMN
         DC    Y(STE102B-STE102A)      PRINT FIELD LENGTH
         DC    X'0000'                 CONVERSION FLAGS
         SPACE 1
* STATIC TEXT ENTRIES
STE101A   DC    C'IDC3709I ** COPY TO CARTRIDGES'
STE101B   EQU   *
STE102A   DC    C'NOT PERFORMED'
STE102B   EQU   *
TXT10B    EQU   *
         END
