* /* START OF SPECIFICATIONS ****                            @Y30SSFR
*
*01*  MODULE-NAME = IDCTSDL0
*01*  MODULE-TYPE = MODULE
*02*    PROCESSOR = ASSEMBLER
*
**** END OF SPECIFICATIONS **                                @Y30SSFR*/
         TITLE '***** IDCTSDL0 - DELETE STATIC TEXT *****'
**********************************************************************
*                                                                    *
* MODULE NAME - IDCTSDL0 - STATIC TEXT MODULE FOR DELETE             *
*                                                                    *
* DESCRIPTIVE NAME - STATIC TEXT MODULE FOR THE FUNCTION DELETE      *
*                                                                    *
* COPYRIGHT - NONE                                                   *
*                                                                    *
* STATUS - RELEASE 2  LEVEL 0                                        *
* RELEASE 3 MODIFICATIONS                                      @Z40RSSA
*     ADD TXT12 AND TXT13 ENTRIES                              @Z40RSSA
*                                                                    *
* FUNCTION - CONTAINS NO EXECUTIBLE CODE, ONLY STATIC TEXT ENTRIES   *
*        FOR THE FUNCTION DELETE                                     *
*        THIS MODULE IS LOADED BY IDCTP05 WHEN A STATIC TEXT         *
*        REQUEST IS MADE.                                            *
*                                                                    *
* NOTES - NONE                                                       *
*                                                                    *
*    DEPENDENCIES - NONE                                             *
*    RESTRICTIONS - NONE                                             *
*    REGISTER CONVENTIONS - NA                                       *
*    PATCH AREA - NA                                                 *
*                                                                    *
* MODULE TYPE - TABLES                                               *
*                                                                    *
*    PROCESSOR - ASSEMBLER                                           *
*    MODULE SIZE - 76                                                *
*    ATTRIBUTES - READ-ONLY                                          *
*                                                                    *
*  ENTRY POINT - NA                                                  *
*                                                                    *
*  EXIT NORMAL - NA                                                  *
*                                                                    *
*  EXIT ERROR - NA                                                   *
*                                                                    *
*  EXTERNAL REFERENCES - NA                                          *
*                                                                    *
*  TABLES - NA                                                       *
*                                                                    *
*  MACROS - NA                                                       *
*                                                                    *
*                                                                    *
**********************************************************************
*
***********************************************************************
*
* THIS MODULE IS THE FIRST MODULE OF STATIC TEXT REQUIRED BY THE
* DELETE MODULES.
*
***********************************************************************
*
*
IDCTSDL0 CSECT
*
* THIS SECTION CONTAINS THE INDICES.
*
INDEX    DC  H'13'                     COUNT OF ENTRIES.       @Z40RSSA
INDEX1   DC  Y(TXT1-INDEX)             ENTRY DELETED
INDEX2   DC  Y(TXT2-INDEX)             INVALID ENTRY TYPE
INDEX3   DC  Y(TXT3-INDEX)             ERASE OPTION NOT ALLOWED
INDEX4   DC  Y(TXT4-INDEX)             FILE PARM REQUIRED
INDEX5   DC  Y(TXT5-INDEX)             NULL ENTRY
INDEX6   DC  H'-1'                     NULL ENTRY
INDEX7   DC  Y(TXT7-INDEX)             SCRATCH OPTION NOT ALLOWED
INDEX8   DC  Y(TXT8-INDEX)             NO ENTRIES DELETED
INDEX9   DC  Y(TXT9-INDEX)             INVALID * WITH MEMBER
INDEX10  DC  Y(TXT10-INDEX)            MEMBER NOT DELETED
INDEX11  DC  Y(TXT11-INDEX)            MEMBER DELETED
INDEX12  DC  Y(TXT12-INDEX)            PROFILE NOT DELETEABLE  @Z40RSSA
INDEX13  DC  Y(TXT13-INDEX)            PROFILE NOT FOUND       @Z40RSSA
         EJECT
**********************************************************************
*
* THIS SECTION CONTAINS THE ENTRIES.
*
**********************************************************************
*
         DS  0F
*
* ENTRY DELETED.
*
TXT1     DC  Y(TXT1B-TXT1A)            ENTRY LENGTH.
         DC  X'8000'                   MESSAGE FLAG.
* SPACING CONTROL SUB-STRUCTURE.
TXT1A    DC  X'4000'                   SPACE CONTROL FLAG.
         DC  H'2'                      SPACING FACTOR.
         DC  C'R '                     SPACINT TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC TEXT SUB-STRUCTURE.
         DC  Y(STE11B-STE11A)          STATIC TEXT LENGTH.
         DC  Y(STE11A-TXT1A)           STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE11B-STE11A)          PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* BLOCK DATA SUB-STRUCTURE.
         DC  X'1000'                    BLOCK DATA FLAG.
         DC  H'1'                      ENTRY LENGTH.
         DC  H'0'                      ENTRY OFFSET.
         DC  H'17'                     PRINT COLUMN.
         DC  H'1'                      PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* BLOCK DATA SUB-STRUCTURE.
         DC  X'1000'                   BLOCK DATA FLAGS.
         DC  H'44'                     INPUT LENGTH.
         DC  H'1'                      INPUT OFFSET.
         DC  H'20'                     PRINT COLUMN.
         DC  H'44'                     PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* STATIC TEXT SUB-STRUCTURE.
         DC  X'8400'                   EOF & STATIC DATA FLAGS.
         DC  Y(STE12B-STE12A)          STATIC TEXT LENGTH.
         DC  Y(STE12A-TXT1A)           STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE12B-STE12A)          PRINT FIELD LENGTH.
         DC  X'0010'                   CONVERSION FLAGS.  (CHAR,BS)
* STATIC TEXT ENTRIES.
STE11A   DC  C'IDC0550I ENTRY ( )'
STE11B   EQU *
STE12A   DC  C'DELETED'
STE12B   EQU *
TXT1B    EQU *
         EJECT
*
* ENTRY TYPE IS INVALID FOR DELETE
*
TXT2     DC  Y(TXT2B-TXT2A)            ENTRY LENGTH.
         DC  X'8000'                   MESSAGE FLAG.
* SPACING CONTROL SUB-STRUCTURE.
TXT2A    DC  X'4000'                   SPACE CONTROL FLAG.
         DC  H'2'                      SPACING FACTOR.
         DC  C'R '                     SPACINT TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'8400'                   STATIC TEXT SUB-STRUCTURE.
         DC  Y(STE21B-STE21A)          STATIC TEXT LENGTH.
         DC  Y(STE21A-TXT2A)           STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE21B-STE21A)          PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* STATIC TEXT ENTRIES.
STE21A   DC  C'IDC2552I ENTRY TYPE IS INVALID FOR DELETE'
STE21B   EQU *
TXT2B    EQU *
         EJECT
*
* ERASE OPTION IS ONLY ALLOWED CLUSTER OR AIX.                 @Y30SSFR
*
TXT3     DC  Y(TXT3B-TXT3A)            ENTRY LENGTH.
         DC  X'8000'                   MESSAGE FLAG.
* SPACING CONTROL SUB-STRUCTURE.
TXT3A    DC  X'4000'                   SPACE CONTROL FLAG.
         DC  H'2'                      SPACING FACTOR.
         DC  C'R '                     SPACINT TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'8400'                   STATIC TEXT SUB-STRUCTURE.
         DC  Y(STE31B-STE31A)          STATIC TEXT LENGTH.
         DC  Y(STE31A-TXT3A)           STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE31B-STE31A)          PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* STATIC TEXT ENTRIES.
STE31A   DC  C'IDC2553I ERASE OPTION IS INVALID FOR ENTRY '    @Y30SSFR
         DC  C'TYPE'                                           @Y30SSFR
STE31B   EQU *
TXT3B    EQU *
         EJECT
*
* FILE PARAMETER IS REQUIRED FOR SCRATCH OPTION OR BAD DYNALLOC.
*
TXT4     DC  Y(TXT4B-TXT4A)            ENTRY LENGTH.
         DC  X'8000'                   MESSAGE FLAG.
* SPACING CONTROL SUB-STRUCTURE.
TXT4A    DC  X'4000'                   SPACE CONTROL FLAG.
         DC  H'2'                      SPACING FACTOR.
         DC  C'R '                     SPACINT TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'8400'                   STATIC TEXT SUB-STRUCTURE.
         DC  Y(STE41B-STE41A)          STATIC TEXT LENGTH.
         DC  Y(STE41A-TXT4A)           STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE41B-STE41A)          PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* STATIC TEXT ENTRIES.
STE41A   DC  C'IDC2554I DYNAMIC ALLOCATION FAILED OR FILE'
         DC  C' WAS NOT CODED WITH SCRATCH'
STE41B   EQU *
TXT4B    EQU *
         EJECT
*
* DELETION OF SPACE OBJECT DID NOT CAUSE (VOLUME) TO BE DELETED.
*
TXT5     DC  Y(TXT5B-TXT5A)            ENTRY LENGTH.
         DC  X'8000'                   MESSAGE FLAG.
* SPACING CONTROL SUB-STRUCTURE.
TXT5A    DC  X'4000'                   SPACE CONTROL FLAG.
         DC  H'2'                      SPACING FACTOR.
         DC  C'R '                     SPACINT TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC TEXT SUB-STRUCTURE.
         DC  Y(STE51B-STE51A)          STATIC TEXT LENGTH.
         DC  Y(STE51A-TXT5A)           STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE51B-STE51A)          PRINT FIELD LENGTH.
         DC  H'0000'                   CONVERSION FLAGS.  (CHAR)
* BLOCK DATA SUB-STRUCTURE.
         DC  X'9000'                   BLOCK DATA FLAG.
         DC  H'6'                      ENTRY LENGTH.
         DC  H'0'                      ENTRY OFFSET.
         DC  H'49'                     PRINT COLUMN.
         DC  H'6'                      PRINT FIELD LENGTH.
         DC  H'0000'                   CONVERSION FLAGS.  (CHAR)
* STATIC TEXT ENTRIES.
STE51A   DC  C'IDC0555I DELETION OF SPACE OBJECT DID NOT CAUSE XXXXXX'
         DC C' TO BE DELETED'
STE51B   EQU *
TXT5B    EQU *
*
         EJECT
*
* ENTRY 6 DOES NOT EXIST
*
         EJECT
*
* SCRATCH OPTION NOT ALLOWED                                   @Y30SSFR
*
TXT7     DC  Y(TXT7B-TXT7A)            ENTRY LENGTH.
         DC  X'8000'                   MESSAGE FLAG.
* SPACING CONTROL SUB-STRUCTURE.
TXT7A    DC  X'4000'                   SPACE CONTROL FLAG.
         DC  H'2'                      SPACING FACTOR.
         DC  C'R '                     SPACINT TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'8400'                   STATIC TEXT SUB-STRUCTURE.
         DC  Y(STE71B-STE71A)          STATIC TEXT LENGTH.
         DC  Y(STE71A-TXT7A)           STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE71B-STE71A)          PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* STATIC TEXT ENTRIES.
STE71A   DC  C'IDC2557I SCRATCH NOT ALLOWED FOR TYPE OF '      @Y30SSFR
         DC  C'OBJECT TO BE DELETED'                           @Y30SSFR
STE71B   EQU *
TXT7B    EQU *
         EJECT
*
* NO ENTRIES DELETED.
*
TXT8     DC  Y(TXT8B-TXT8A)            ENTRY LENGTH.
         DC  X'A000'                   MESSAGE FLAG.
* STATIC TEXT SUBSTRUCTURE.
TXT8A    DC  X'0400'                   STATIC FLAG
         DC  Y(STE81B-STE81A)          STATIC TEXT LENGTH
         DC  Y(STE81A-TXT8A)           STATIC TEXT OFFSET
         DC  H'1'                      PRINT COLUMN
         DC  Y(STE81B-STE81A)          PRINT FIELD LENGTH
         DC  H'0'                      CONVERSION FLAGS  (CHAR)
* BLOCK DATA SUB-STRUCTURE.
         DC  X'1000'                   BLOCK DATA FLAG.
         DC  H'44'                     INPUT FIELD LENGTH.
         DC  H'0'                      INPUT OFFSET.
         DC  H'18'                     PRINT COLUMN.
         DC  H'44'                     PRINT FIELD LENGTH.
         DC  H'0'                      COMVERSION FLAGS.  (CHAR)
* STATIC TEXT SUB-STRUCTURE.
         DC  X'8400'                   STATIC TEXT & EOF FLAGS.
         DC  Y(STE82B-STE82A)          STATIC TEXT LENGTH.
         DC  Y(STE82A-TXT8A)           STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE82B-STE82A)          PRINT FIELD LENGTH.
         DC  X'0010'                   CONVERSION FLAGS. (CHAR)
* STATIC TEXT ENTRY.
STE81A   DC  C'IDC0551I **ENTRY'
STE81B   EQU *
STE82A   DC  C'NOT DELETED'
STE82B   EQU *
TXT8B    EQU *
         EJECT
*
* MEMBER CAN NOT BE SPECIFIED WITH A GENERIC NAME
*
TXT9     DC  Y(TXT9B-TXT9A)            ENTRY LENGTH.
         DC  X'8000'                   MESSAGE FLAG.
* SPACING CONTROL SUB-STRUCTURE.
TXT9A    DC  X'4000'                   SPACE CONTROL FLAG.
         DC  H'2'                      SPACING FACTOR.
         DC  C'R '                     SPACINT TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'8400'                   STATIC TEXT SUB-STRUCTURE.
         DC  Y(STE91B-STE91A)          STATIC TEXT LENGTH.
         DC  Y(STE91A-TXT9A)           STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE91B-STE91A)          PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* STATIC TEXT ENTRIES.
STE91A   DC  C'IDC2559I MEMBER CAN NOT BE SPECIFIED WITH A GENERIC'
         DC  C' NAME'
STE91B   EQU *
TXT9B    EQU *
         EJECT
*
* MEMBER NOT DELETED.
*
TXT10    DC  Y(TXT10B-TXT10A)          ENTRY LENGTH.
         DC  X'A000'                   MESSAGE FLAG.
* STATIC TEXT SUBSTRUCTURE.
TXT10A   DC  X'0400'                   STATIC FLAG
         DC  Y(STE101B-STE101A)        STATIC TEXT LENGTH
         DC  Y(STE101A-TXT10A)         STATIC TEXT OFFSET
         DC  H'1'                      PRINT COLUMN
         DC  Y(STE101B-STE101A)        PRINT FIELD LENGTH
         DC  H'0'                      CONVERSION FLAGS  (CHAR)
* BLOCK DATA SUB-STRUCTURE.
         DC  X'1000'                   BLOCK DATA FLAG.
         DC  H'8'                      INPUT FIELD LENGTH.
         DC  H'0'                      INPUT OFFSET.
         DC  H'19'                     PRINT COLUMN.
         DC  H'8'                      PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* STATIC TEXT SUB-STRUCTURE.
         DC  X'8400'                   STATIC TEXT & EOF FLAGS.
         DC  Y(STE102B-STE102A)        STATIC TEXT LENGTH.
         DC  Y(STE102A-TXT10A)         STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE102B-STE102A)        PRINT FIELD LENGTH.
         DC  X'0010'                   CONVERSION FLAGS. (CHAR,BS)
* STATIC TEXT ENTRY.
STE101A  DC  C'IDC0548I **MEMBER'
STE101B  EQU *
STE102A  DC  C'NOT DELETED'
STE102B  EQU *
TXT10B   EQU *
         EJECT
*
* MEMBER DELETED.
*
TXT11    DC  Y(TXT11B-TXT11A)          ENTRY LENGTH.
         DC  X'8000'                   MESSAGE FLAG.
* SPACING CONTROL SUB-STRUCTURE.
TXT11A   DC  X'4000'                   SPACE CONTROL FLAG.
         DC  H'2'                      SPACING FACTOR.
         DC  C'R '                     SPACINT TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC TEXT SUB-STRUCTURE.
         DC  Y(STE111B-STE111A)        STATIC TEXT LENGTH.
         DC  Y(STE111A-TXT11A)         STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE111B-STE111A)        PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* BLOCK DATA SUB-STRUCTURE.
         DC  X'1000'                   BLOCK DATA FLAGS.
         DC  H'8'                      INPUT LENGTH.
         DC  H'0'                      INPUT OFFSET.
         DC  H'17'                     PRINT COLUMN.
         DC  H'8'                      PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* STATIC TEXT SUB-STRUCTURE.
         DC  X'8400'                   EOF & STATIC DATA FLAGS.
         DC  Y(STE112B-STE112A)        STATIC TEXT LENGTH.
         DC  Y(STE112A-TXT11A)         STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE112B-STE112A)        PRINT FIELD LENGTH.
         DC  X'0010'                   CONVERSION FLAGS.  (CHAR,BS)
* STATIC TEXT ENTRIES.
STE111A  DC  C'IDC0549I MEMBER'
STE111B  EQU *
STE112A  DC  C'DELETED'
STE112B  EQU *
TXT11B   EQU *
*                                                              @Z40RSSA
*         RAC PROFILE COULD NOT BE DELETED - NOT ELIGIBLE.     @Z40RSSA
*                                                              @Z40RSSA
TXT12    DC  Y(TXT12B-TXT12A)          ENTRY LENGTH.           @Z40RSSA
         DC  X'8000'                   MESSAGE FLAG.           @Z40RSSA
* SPACING CONTROL SUBSTRUCTURE                                 @Z40RSSA
TXT12A   DC  X'4000'                   SPACE CONTROL FLAG      @Z40RSSA
         DC  H'2'                      SPACING FACTOR          @Z40RSSA
         DC  C'R '                     SPACING TYPE            @Z40RSSA
* STATIC TEXT SUB-STRUCTURE.                                   @Z40RSSA
         DC  X'8400'                                           @Z40RSSA
         DC  Y(STE121B-STE121A)        STATIC TEXT LENGTH      @Z40RSSA
         DC  Y(STE121A-TXT12A)         STATIC TEXT OFFSET      @Z40RSSA
         DC  H'1'                      PRINT COLUMN            @Z40RSSA
         DC  Y(STE121B-STE121A)        PRINT FIELD LENGTH      @Z40RSSA
         DC  H'0'                      CONVERSION FLAGS        @Z40RSSA
*                                        (CHARACTER)           @Z40RSSA
*STATIC TEXT ENTRIES                                           @Z40RSSA
STE121A  DC  C'IDC1890I RACF PROFILE COULD NOT BE DELETED - NOT'
         DC  C' ELIGIBLE'
STE121B  EQU *                                                 @Z40RSSA
TXT12B   EQU *                                                 @Z40RSSA
*                                                              @Z40RSSA
*         RAC PROFILE COULD NOT BE DELETED - NOT FOUND.        @Z40RSSA
*                                                              @Z40RSSA
TXT13    DC  Y(TXT13B-TXT13A)          ENTRY LENGTH.           @Z40RSSA
         DC  X'8000'                   MESSAGE FLAG.           @Z40RSSA
* SPACING CONTROL SUBSTRUCTURE                                 @Z40RSSA
TXT13A   DC  X'4000'                   SPACE CONTROL FLAG      @Z40RSSA
         DC  H'2'                      SPACING FACTOR          @Z40RSSA
         DC  C'R '                     SPACING TYPE            @Z40RSSA
* STATIC TEXT SUB-STRUCTURE.                                   @Z40RSSA
         DC  X'8400'                                           @Z40RSSA
         DC  Y(STE131B-STE131A)        STATIC TEXT LENGTH      @Z40RSSA
         DC  Y(STE131A-TXT13A)         STATIC TEXT OFFSET      @Z40RSSA
         DC  H'1'                      PRINT COLUMN            @Z40RSSA
         DC  Y(STE131B-STE131A)        PRINT FIELD LENGTH      @Z40RSSA
         DC  H'0'                      CONVERSION FLAGS        @Z40RSSA
*                                        (CHARACTER)           @Z40RSSA
*STATIC TEXT ENTRIES                                           @Z40RSSA
STE131A  DC  C'IDC1891I RACF PROFILE COULD NOT BE DELETED - NOT'
         DC  C' FOUND'                                         @Z40RSSA
STE131B  EQU *                                                 @Z40RSSA
TXT13B   EQU *                                                 @Z40RSSA
         END
