         TITLE '***** IDCTSEC0 - EJECTC STATIC TEXT *****'
************************************************************
*                                                          *  @Y30LB32
* MODULE NAME -  IDCTSEC0                                  *  @Y30LB32
*                                                          *  @Y30LB32
*                                                          *  @Y30LB32
* DESCRIPTIVE NAME - STATIC TEXT MODULE FOR THE EJECT      *  @Y30LB32
*        CARTRIDGE FUNCTION                                *  @Y30LB32
*                                                          *  @Y30LB32
*                                                          *  @Y30LB32
* COPYRIGHT - NONE                                         *  @Y30LB32
*                                                          *  @Y30LB32
* STATUS - RELEASE 0  LEVEL 0                              *  @Y30LB32
*                                                          *  @Y30LB32
* FUNCTION - CONTAINS NO EXECTABLE CODE, ONLY STATIC TEXT  *  @Y30LB32
*        ENTRIES FOR THE FUNCTION EJECT CARTRIDGE          *  @Y30LB32
*        THIS MODULE IS LOADED BY IDCTP05 WHEN A STATIC    *  @Y30LB32
*        TEXT REQUEST IS MADE.                             *  @Y30LB32
*                                                          *  @Y30LB32
* NOTES - NONE                                             *  @Y30LB32
*                                                          *  @Y30LB32
*        DEPENDENCIES - NONE                               *  @Y30LB32
*        RESTRICTIONS - NONE                               *  @Y30LB32
*        REGISTER CONVENTIONS - NA                         *  @Y30LB32
*        PATCH AREA - NA                                   *  @Y30LB32
*                                                          *  @Y30LB32
* MODULE TYPE - TABLES                                     *  @Y30LB32
*                                                          *  @Y30LB32
*        PROCESSOR - ASSEMBLER                             *  @Y30LB32
*        MODULE SIZE - 357                                 *  @Y30LB32
*        ATTRIBUTES - READ-ONLY                            *  @Y30LB32
*                                                          *  @Y30LB32
* ENTRY POINT - NA                                         *  @Y30LB32
*                                                          *  @Y30LB32
* EXIT NORMAL - NA                                         *  @Y30LB32
*                                                          *  @Y30LB32
* EXIT ERROR - NA                                          *  @Y30LB32
*                                                          *  @Y30LB32
* EXTERNAL REFERENCES - NA                                 *  @Y30LB32
*                                                          *  @Y30LB32
* TABLES - NA                                              *  @Y30LB32
*                                                          *  @Y30LB32
* MACROS - NA                                              *  @Y30LB32
*                                                          *  @Y30LB32
* CHANGE ACTIVITY - NONE                                   *  @Y30LB32
*                                                          *  @Y30LB32
************************************************************  @Y30LB32
         EJECT                                                @Y30LB32
************************************************************  @Y30LB32
*                                                          *  @Y30LB32
* THIS MODULE IS THE FIRST MODULE OF STATIC TEXT REQUIRED  *  @Y30LB32
* BY THE EJECT CARTRIDGE FUNCTION                          *  @Y30LB32
*                                                          *  @Y30LB32
************************************************************  @Y30LB32
*                                                             @Y30LB32
IDCTSEC0 CSECT                                                @Y30LB32
*                                                             @Y30LB32
INDEX    DC    Y((INDEXEND-INDEX1)/2)  COUNT OF ENTRIES       @Y30LB32
INDEX1   DC    Y(TXT1-INDEX)           ONE SCRATCH EJECTED    @Y30LB32
INDEX2   DC    Y(TXT2-INDEX)           MULTIPLE CARTS EJECTED @Y30LB32
INDEX3   DC    Y(TXT3-INDEX)           CARTRDG NOT EJECTED    @Y30LB32
INDEX4   DC    Y(TXT4-INDEX)           CARTRIDGE EJECTED MSG  @Y30LB32
INDEX5   DC    Y(TXT5-INDEX)           NO CARTRIDGES FOUND    @Y30LB32
INDEXEND DS    0H                                             @Y30LB32
         EJECT                                                @Y30LB32
**********************************************************    @Y30LB32
*                                                        *    @Y30LB32
* IDC0780I SCRATCH CARTRIDGE (CSN) EJECTED               *    @Y30LB32
*                                                        *    @Y30LB32
**********************************************************    @Y30LB32
         SPACE 3                                              @Y30LB32
TXT1     DC    Y(TXT1B-TXT1A)          ENTRY LENGTH           @Y30LB32
         DC    X'8000'                 MESSAGE FLAG           @Y30LB32
         SPACE 1                                              @Y30LB32
* SPACING CONTROL SUB-STRUCTURE                               @Y30LB32
TXT1A    DC    X'4000'                 SPACE CONTROL FLAG     @Y30LB32
         DC    H'2'                    SPACING FACTOR         @Y30LB32
         DC    C'R '                   SPACING TYPE           @Y30LB32
         SPACE 1                                              @Y30LB32
* STATIC TEXT SUB-STRUCTURE                                   @Y30LB32
         DC    X'0400'                 STATIC TEXT FLAG       @Y30LB32
         DC    Y(STE11B-STE11A)        TEXT LENGTH            @Y30LB32
         DC    Y(STE11A-TXT1A)         TEXT OFFSET            @Y30LB32
         DC    H'1'                    PRINT COLUMN           @Y30LB32
         DC    Y(STE11B-STE11A)        PRINT FIELD LENGTH     @Y30LB32
         DC    H'0'                    CONVERSION FLAGS       @Y30LB32
         SPACE 1                                              @Y30LB32
* BLOCK DATA SUB-STRUCTURE                                    @Y30LB32
         DC    X'1000'                                        @Y30LB32
         DC    H'12,00,28,12,00'       LNG,OFST,PC,           @Y30LB32
*                                      LNG,FLG                @Y30LB32
         SPACE 1                                              @Y30LB32
* STATIC TEXT SUB-STRUCTURE                                   @Y30LB32
         DC    X'8400'                 STATIC TEXT FLAG       @Y30LB32
         DC    Y(STE12B-STE12A)        TEXT LENGTH            @Y30LB32
         DC    Y(STE12A-TXT1A)         TEXT OFFSET            @Y30LB32
         DC    H'41'                   PRINT COLUMN           @Y30LB32
         DC    Y(STE12B-STE12A)        PRINT FIELD LENGTH     @Y30LB32
         DC    H'0'                    CONVERSION FLAGS       @Y30LB32
         SPACE 1                                              @Y30LB32
* STATIC TEXT ENTRIES                                         @Y30LB32
STE11A   DC    C'IDC0780I SCRATCH CARTRIDGE'                  @Y30LB32
STE11B   EQU   *                                              @Y30LB32
STE12A   DC    C'EJECTED'                                     @Y30LB32
STE12B   EQU   *                                              @Y30LB32
TXT1B    EQU   *                                              @Y30LB32
         EJECT                                                @Y30LB32
**********************************************************    @Y30LB32
*                                                        *    @Y30LB32
* IDC0781I NUMBER OF SCRATCH CARTRIDGES EJECTED IS       *    @Y30LB32
* (NUMBER)                                              *    @Y30LB32
*                                                        *    @Y30LB32
**********************************************************    @Y30LB32
         SPACE 3                                              @Y30LB32
TXT2     DC    Y(TXT2B-TXT2A)          ENTRY LENGTH           @Y30LB32
         DC    X'8000'                 MESSAGE FLAG           @Y30LB32
         SPACE 1                                              @Y30LB32
* SPACING CONTROL SUB-STRUCTURE                               @Y30LB32
TXT2A    DC    X'4000'                 SPACE CONTROL FLAG     @Y30LB32
         DC    H'2'                    SPACING FACTOR         @Y30LB32
         DC    C'R '                   SPACING TYPE           @Y30LB32
         SPACE 1                                              @Y30LB32
* STATIC TEXT SUB-STRUCTURE                                   @Y30LB32
         DC    X'0400'                 STATIC TEXT FLAG       @Y30LB32
         DC    Y(STE21B-STE21A)        TEXT LENGTH            @Y30LB32
         DC    Y(STE21A-TXT2A)         TEXT OFFSET            @Y30LB32
         DC    H'1'                    PRINT COLUMN           @Y30LB32
         DC    Y(STE21B-STE21A)        PRINT FIELD LENGTH     @Y30LB32
         DC    H'0'                    CONVERSION FLAGS       @Y30LB32
         SPACE 1                                              @Y30LB32
* BLOCK DATA SUB-STRUCTURE                                    @Y30LB32
         DC    X'1000'                                        @Y30LB32
         DC    H'04,00,50,10'          LNG,OFST,PC,LNG        @Y30LB32
         DC    X'10E0'                 CONV FLGS              @Y30LB32
         SPACE 1                                              @Y30LB32
* STATIC TEXT ENTRIES                                         @Y30LB32
STE21A   DC    C'IDC0781I NUMBER OF SCRATCH CARTRIDGES'       @Y30LB32
         DC    C' EJECTED IS'                                 @Y30LB32
STE21B   EQU   *                                              @Y30LB32
TXT2B    EQU   *                                              @Y30LB32
         EJECT                                                @Y30LB32
**********************************************************    @Y30LB32
*                                                        *    @Y30LB32
* IDC2782I ** SCRATCH CARTRIDGE (CSN) NOT EJECTED        *    @Y30LB32
*                                                        *    @Y30LB32
**********************************************************    @Y30LB32
         SPACE 3                                              @Y30LB32
TXT3     DC    Y(TXT3B-TXT3A)          ENTRY LENGTH           @Y30LB32
         DC    X'8000'                 MESSAGE FLAG           @Y30LB32
         SPACE 1                                              @Y30LB32
* SPACING CONTROL SUB-STRUCTURE                               @Y30LB32
TXT3A    DC    X'4000'                 SPACE CONTROL FLAG     @Y30LB32
         DC    H'1'                    SPACING FACTOR         @Y30LB32
         DC    C'R '                   SPACING TYPE           @Y30LB32
         SPACE 1                                              @Y30LB32
* STATIC TEXT SUB-STRUCTURE                                   @Y30LB32
         DC    X'0400'                 STATIC TEXT FLAG       @Y30LB32
         DC    Y(STE31B-STE31A)        TEXT LENGTH            @Y30LB32
         DC    Y(STE31A-TXT3A)         TEXT OFFSET            @Y30LB32
         DC    H'1'                    PRINT COLUMN           @Y30LB32
         DC    Y(STE31B-STE31A)        PRINT FIELD LENGTH     @Y30LB32
         DC    H'0'                    CONVERSION FLAGS       @Y30LB32
         SPACE 1                                              @Y30LB32
* BLOCK DATA SUB-STRUCTURE                                    @Y30LB32
         DC    X'1000'                                        @Y30LB32
         DC    H'12,00,31,12,00'       LNG,OFST,PC,           @Y30LB32
*                                      LNG,FLG                @Y30LB32
         SPACE 1                                              @Y30LB32
* STATIC TEXT SUB-STRUCTURE                                   @Y30LB32
         DC    X'8400'                 STATIC TEXT FLAG       @Y30LB32
         DC    Y(STE32B-STE32A)        TEXT LENGTH            @Y30LB32
         DC    Y(STE32A-TXT3A)         TEXT OFFSET            @Y30LB32
         DC    H'44'                   PRINT COLUMN           @Y30LB32
         DC    Y(STE32B-STE32A)        PRINT FIELD LENGTH     @Y30LB32
         DC    H'0'                    CONVERSION FLAGS       @Y30LB32
         SPACE 1                                              @Y30LB32
* STATIC TEXT ENTRIES                                         @Y30LB32
STE31A   DC    C'IDC2782I ** SCRATCH CARTRIDGE'               @Y30LB32
STE31B   EQU   *                                              @Y30LB32
STE32A   DC    C'NOT EJECTED'                                 @Y30LB32
STE32B   EQU   *                                              @Y30LB32
TXT3B    EQU   *                                              @Y30LB32
         EJECT                                                @Y30LB32
**********************************************************    @Y30LB32
*                                                        *    @Y30LB32
* IDC783E SCRATCH CARTRIDGE (CSN) EJECTED; (JJJ SSS)     *    @Y30LB32
*                                                        *    @Y30LB32
**********************************************************    @Y30LB32
         SPACE 3                                              @Y30LB32
TXT4     DC    Y(TXT4B-TXT4A)          ENTRY LENGTH           @Y30LB32
         DC    X'8000'                 MESSAGE FLAG           @Y30LB32
         SPACE 1                                              @Y30LB32
* SPACING CONTROL SUB-STRUCTURE                               @Y30LB32
TXT4A    DC    X'4000'                 SPACE CONTROL FLAG     @Y30LB32
         DC    H'2'                    SPACING FACTOR         @Y30LB32
         DC    C'R '                   SPACING TYPE           @Y30LB32
         SPACE 1                                              @Y30LB32
* STATIC TEXT SUB-STRUCTURE                                   @Y30LB32
         DC    X'0400'                 STATIC TEXT FLAG       @Y30LB32
         DC    Y(STE41B-STE41A)        TEXT LENGTH            @Y30LB32
         DC    Y(STE41A-TXT4A)         TEXT OFFSET            @Y30LB32
         DC    H'1'                    PRINT COLUMN           @Y30LB32
         DC    Y(STE41B-STE41A)        PRINT FIELD LENGTH     @Y30LB32
         DC    H'0'                    CONVERSION FLAGS       @Y30LB32
         SPACE 1                                              @Y30LB32
* BLOCK DATA SUB-STRUCTURE                                    @Y30LB32
         DC    X'1000'                                        @Y30LB32
         DC    H'12,00,27,12,00'       LNG,OFST,PC,           @Y30LB32
*                                      LNG,FLG                @Y30LB32
         SPACE 1                                              @Y30LB32
* STATIC TEXT SUB-STRUCTURE                                   @Y30LB32
         DC    X'0400'                 STATIC TEXT FLAG       @Y30LB32
         DC    Y(STE42B-STE42A)        TEXT LENGTH            @Y30LB32
         DC    Y(STE42A-TXT4A)         TEXT OFFSET            @Y30LB32
         DC    H'40'                   PRINT COLUMN           @Y30LB32
         DC    Y(STE42B-STE42A)        PRINT FIELD LENGTH     @Y30LB32
         DC    H'0'                    CONVERSION FLAGS       @Y30LB32
         SPACE 1                                              @Y30LB32
* BLOCK DATA SUB-STRUCTURE                                    @Y30LB32
         DC    X'1000'                                        @Y30LB32
         DC    H'08,12,01,08,16'       LNG,OFST,PC,           @Y30LB32
*                                      LNG,FLG                @Y30LB32
          SPACE 1                                             @Y30LB32
* BLOCK DATA SUB-STRUCTURE                                    @Y30LB32
         DC    X'9000'                                        @Y30LB32
         DC    H'08,20,01,08,16'       LNG,OFST,PC,           @Y30LB32
*                                      LNG,FLG                @Y30LB32
         SPACE 1                                              @Y30LB32
* STATIC TEXT ENTRIES                                         @Y30LB32
STE41A   DC    C'IDC783E SCRATCH CARTRIDGE'                   @Y30LB32
STE41B   EQU   *                                              @Y30LB32
STE42A   DC    C'EJECTED;'                                    @Y30LB32
STE42B   EQU   *                                              @Y30LB32
TXT4B    EQU   *                                              @Y30LB32
         EJECT                                                @Y30LB32
**********************************************************    @Y30LB32
*                                                        *    @Y30LB32
* IDC1784I NO SCRATCH CARTRIDGES FOUND IN MSF            *    @Y30LB32
*                                                        *    @Y30LB32
**********************************************************    @Y30LB32
         SPACE 3                                              @Y30LB32
TXT5     DC    Y(TXT5B-TXT5A)          ENTRY LENGTH           @Y30LB32
         DC    X'8000'                 MESSAGE FLAG           @Y30LB32
         SPACE 1                                              @Y30LB32
* SPACING CONTROL SUB-STRUCTURE                               @Y30LB32
TXT5A    DC    X'4000'                 SPACE CONTROL FLAG     @Y30LB32
         DC    H'2'                    SPACING FACTOR         @Y30LB32
         DC    C'R '                   SPACING TYPE           @Y30LB32
         SPACE 1                                              @Y30LB32
* STATIC TEXT SUB-STRUCTURE                                   @Y30LB32
         DC    X'0400'                 STATIC TEXT FLAG       @Y30LB32
         DC    Y(STE51B-STE51A)        TEXT LENGTH            @Y30LB32
         DC    Y(STE51A-TXT5A)         TEXT OFFSET            @Y30LB32
         DC    H'1'                    PRINT COLUMN           @Y30LB32
         DC    Y(STE51B-STE51A)        PRINT FIELD LENGTH     @Y30LB32
         DC    H'0'                    CONVERSION FLAGS       @Y30LB32
         SPACE 1                                              @Y30LB32
* STATIC TEXT ENTRIES                                         @Y30LB32
STE51A   DC    C'IDC1784I NO SCRATCH CARTRIDGES FOUND'        @Y30LB32
         DC    C' IN MSF'                                     @Y30LB32
STE51B   EQU   *                                              @Y30LB32
TXT5B    EQU   *                                              @Y30LB32
         END
