* /* START OF SPECIFICATIONS ****                            @Y30LSMK
*
*01* MODULE-NAME = IDCTSIO0
*01* MODULE-TYPE = MODULE
*02*   PROCESSOR = ASSEMBLER
*
**** END OF SPECIFICATIONS **                                @Y30LSMK*/
         TITLE  '***** IDCTSIO0 - IO ADAPTOR STATIC TEXT *****'
**********************************************************************
*                                                                    *
* MODULE NAME - IDCTSIO0 - STATIC TEXT MODULE FOR IO ADAPTER         *
*               AND SYS ADAPTER                                      *
*                                                                    *
* DESCRIPTIVE NAME - STATIC TEXT MODULE FOR THE IO ADAPTER           *
*                    AND SYS ADAPTER                                 *
*                                                                    *
* COPYRIGHT - NONE                                                   *
*                                                                    *
* STATUS - RELEASE 0  LEVEL 0                                        *
*                                                                    *
* FUNCTION - CONTAINS NO EXECUTABLE CODE, ONLY STATIC TEXT ENTRIES   *
*        FOR THE IO ADAPTER AND SYS ADAPTER                          *
*        THIS MODULE IS LOADED BY IDCTP05 WHEN A STATIC TEXT         *
*        REQUEST IS MADE.                                            *
*                                                                    *
* NOTES - NONE                                                       *
*                                                                    *
*    DEPENDENCIES - NONE                                             *
*    RESTRICTIONS - NONE                                             *
*    REGISTER CONVENTIONS - NA                                       *
*    PATCH AREA - NA                                                 *
*                                                                    *
* MODULE TYPE - TABLES                                               *
*                                                                    *
*    PROCESSOR - ASSEMBLER                                           *
*    MODULE SIZE - 2600                                              *
*    ATTRIBUTES - READ-ONLY                                          *
*                                                                    *
*  ENTRY POINT - NA                                                  *
*                                                                    *
*  EXIT NORMAL - NA                                                  *
*                                                                    *
*  EXIT ERROR - NA                                                   *
*                                                                    *
*  EXTERNAL REFERENCES - NA                                          *
*                                                                    *
*  TABLES - NA                                                       *
*                                                                    *
*  MACROS - NA                                                       *
*                                                                    *
* CHANGE ACTIVITY -                                                  *
*                                                                    *
*             VS/2 RELEASE 3.0 DELETIONS AND CHANGES                 *
*0000                                                        @Z30LSBS*
*0000                                                        @ZM41551*
* C230192                                                    @OZ26756*
*                                                                    *
**********************************************************************
*
**********************************************************************
*                                                                    *
* THIS MODULE IS THE FIRST MODULE OF STATIC TEXT REQUIRED BY THE     *
* I/O SERVICE ROUTINE.                                               *
*                                                                    *
**********************************************************************
*
IDCTSIO0  CSECT
*
* THIS SECTION CONTAINS THE INDICES TO REACH AN ENTRY.               *
*
INDEX     DC  AL2((LASTINDX-INDEX1)/2)  COUNT OF ENTRIES       @ZM41551
INDEX1    DC  Y(TXT1-INDEX)             OPEN ERROR
INDEX2    DC  Y(TXT2-INDEX)             CLOSE ERROR
INDEX3    DC  Y(TXT3-INDEX)             ACTION ERROR
INDEX4    DC  Y(TXT4-INDEX)             OPEN ERROR (NON-AM0 UPDATE)
INDEX5    DC  Y(TXT5-INDEX)             DD CARD MISSING.
INDEX6    DC  Y(TXT6-INDEX)             OPEN ERROR (ISAM OUTPUT)
INDEX7    DC  Y(TXT7-INDEX)             OPEN ERROR (ISAM CHRON)
INDEX8    DC  Y(TXT8-INDEX)             OPEN ERROR (ISAM KEY)
INDEX9    DC  Y(TXT9-INDEX)             VSAM CONDITION CODE.
INDEX10   DC  Y(TXT10-INDEX)            DUPLICATE RECORD MSG.
INDEX11   DC  Y(TXT11-INDEX)            VSAM SYNAD
INDEX12   DC  Y(TXT12-INDEX)            SEQUENTIAL RECORD TOO LONG
INDEX13   DC  Y(TXT13-INDEX)            KEY TOO LONG.
INDEX14   DC  Y(TXT14-INDEX)            ILLEGAL POSITIONING.
INDEX15   DC  Y(TXT15-INDEX)            OPEN FAILURE.
INDEX16   DC  Y(TXT16-INDEX)            NON-VSAM SYNAD MESSAGE.
INDEX17   DC  Y(TXT17-INDEX)            RECORD OUT OF SEQUENCE
INDEX18   DC  Y(TXT18-INDEX)            ENTRY DOESN'T EXIST
INDEX19   DC  Y(TXT19-INDEX)            DS NOT USER CATALOG
INDEX20   DC  Y(TXT20-INDEX)            PERM I/O ERROR
INDEX21   DC  Y(TXT21-INDEX)            INVALID OPNAGL
INDEX22   DC  Y(TXT22-INDEX)            ENTRY ALREADY EXISTS
INDEX23   DC  H'-1'                                            @Y30SSFY
INDEX24   DC  Y(TXT24-INDEX)            ABEND EXIT TAKEN.
INDEX25   DC  Y(TXT25-INDEX)            ORG NOT VSAM
INDEX26   DC  Y(TXT26-INDEX)            INSUFFICIENT STORAGE  @YL026UE
INDEX27   DC  Y(TXT27-INDEX)            ERROR ALLOCATING DSNAME
INDEX28   DC  Y(TXT28-INDEX)            ERROR UNALLOCATING     @YL026UE
INDEX29   DC  Y(TXT29-INDEX)            DYNAMIC ALLOCATION RETURN CODE
INDEX30   DC  Y(TXT30-INDEX)            ERROR ALLOCATING VOLUME(S)
INDEX31   DC  Y(TXT31-INDEX)            ERROR IN DYNAMIC CONCATENATION
INDEX32   DC  Y(TXT32-INDEX)            TARGET CAT NOT EMPTY
INDEX33   DC  Y(TXT33-INDEX)            INVALID CI NUMBER
INDEX34   DC  H'-1'                                            @Y30SSFY
INDEX35   DC  Y(TXT35-INDEX)           DUP.RELATIVE RECORD NO. @Y30SSFY
INDEX36   DC  Y(TXT36-INDEX)            DNAME NOT FOUND IN SYS @Y30LSMK
INDEX37   DC  Y(TXT37-INDEX)            UNABLE TO SCRATCH DSN  @Y30LSMK
INDEX38   DC  Y(TXT38-INDEX)            NO VOLUME MOUNTED      @Y30LSMK
INDEX39   DC  Y(TXT39-INDEX)            DSN NOT ON VOLUME      @Y30LSMK
INDEX40   DC  Y(TXT40-INDEX)            BAD PASSWORD           @Y30LSMK
INDEX41   DC  Y(TXT41-INDEX)            NON-EXPIRED DSN ON VOL @Y30LSMK
INDEX42   DC  Y(TXT42-INDEX)            PERM I/O ERROR ON VOL  @Y30LSMK
INDEX43   DC  Y(TXT43-INDEX)            UNABLE TO MOUNT VOL    @Y30LSMK
INDEX44   DC  Y(TXT44-INDEX)            RECORD SIZE > 32K      @Y30SSFY
INDEX45   DC  Y(TXT45-INDEX)           INCORRECT BLOCKSIZE FOR @Y30SSFY
*                                       IMPORTRA               @Y30SSFY
INDEX46   DC  Y(TXT46-INDEX)            REPLACE THRU PATH      @Y30SSFY
INDEX47   DC  Y(TXT47-INDEX)            DUP. IN UPGRADE SET    @Y30SSFY
INDEX48   DC  Y(TXT48-INDEX)            DATA SET WAS IN USE    @Z30LSBS
**********************************************************************
*                                       INSERT ALL INDEX       @ZM41551
LASTINDX EQU   *                        NUMBERS BEFORE THIS    @ZM41551
*                                       BOX                    @ZM41551
**********************************************************************
          EJECT                                                @Y30SSFY
**********************************************************************
*                                                                    *
* THIS SECTION CONTAINS THE ENTRIES.                                 *
*                                                                    *
**********************************************************************
*
* OPEN ERROR MESSAGE.
*
TXT1      DC    Y(TXT1B-TXT1A)          ENTRY LENGTH.
FLG1A     DC    X'8000'                 MESSAGE FLAG.
* DOUBLE SPACE SUB-STRUCTURE.
TXT1A     DC    X'4000'                 SPACE SUB-STRUCTURE FLAG.
          DC    H'2'                    SPACING FACTOR.
          DC    C'R '                   SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
          DC    X'0400'                 STATIC TEXT FLAG.
          DC    Y(STE11B-STE11A)        STATIC TEXT LENGTH.
          DC    Y(STE11A-TXT1A)         STATIC TEXT OFFSET.
          DC    H'1'                    PRINT COLUMN NO.
          DC    Y(STE11B-STE11A)        OUTPUT LENGTH.
          DC    H'0'                    CONVERSION FLAGS (EBCDIC)
* BLOCK DATA SUB-STRUCTURE.
          DC    X'9000'                 EOF & BLOCK DATA FLAGS.
          DC    H'44'                   MAXIMUM INPUT LENGTH.
          DC    H'0'                    INPUT OFFSET
          DC    H'25'                   PRINT COLUMN.
          DC    H'0'                    PRINT FIELD LENGTH
          DC    H'0'                    CONVERSION FLAGS (EBCDIC)
* STATIC ENTRY.
STE11A    DC    C'IDC3300I  ERROR OPENING'
STE11B    EQU *
TXT1B     EQU *
          EJECT
*
* ERROR ON CLOSING MESSAGE.
*
TXT2      DC    Y(TXT2B-TXT2A)          ENTRY LENGTH.
FLG2A     DC    X'8000'                 MESSAGE FLAG.
* DOUBLE SPACE SUB-STRUCTURE.
TXT2A     DC    X'4000'                 SPACE SUB-STRUCTURE FLAG.
          DC    H'2'                    SPACING FACTOR.
          DC    C'R '                   SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
          DC    X'0400'                 STATIC TEXT FLAG.
          DC    Y(STE21B-STE21A)        STATIC TEXT LENGTH.
          DC    Y(STE21A-TXT2A)         STATIC TEXT OFFSET.
          DC    H'1'                    PRINT COLUMN NO.
          DC    Y(STE21B-STE21A)        OUTPUT LENGTH.
          DC    H'0'                    CONVERSION FLAGS (EBCDIC)
* BLOCK DATA SUB-STRUCTURE.
          DC    X'9000'                 EOF & BLOCK DATA FLAGS.
          DC    H'44'                   MAXIMUM INPUT LENGTH.
          DC    H'0'                    INPUT OFFSET
          DC    H'25'                   PRINT COLUMN.
          DC    H'0'                    PRINT FIELD LENGTH
          DC    H'0'                    CONVERSION FLAGS (EBCDIC)
* STATIC ENTRY.
STE21A    DC    C'IDC3301I ERROR CLOSING'
STE21B    EQU *
TXT2B     EQU *
          EJECT
*
* IO ERROR MESSAGE.
*
TXT3      DC    Y(TXT3B-TXT3A)          ENTRY LENGTH.
FLG3A     DC    X'8000'                 MESSAGE FLAG.
* DOUBLE SPACE SUB-STRUCTURE.
TXT3A     DC    X'4000'                 SPACE SUB-STRUCTURE FLAG.
          DC    H'2'                    SPACING FACTOR.
          DC    C'R '                   SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
          DC    X'0400'                 STATIC TEXT FLAG.
          DC    Y(STE31B-STE31A)        STATIC TEXT LENGTH.
          DC    Y(STE31A-TXT3A)         STATIC TEXT OFFSET.
          DC    H'1'                    PRINT COLUMN NO.
          DC    Y(STE31B-STE31A)        OUTPUT LENGTH.
          DC    H'0'                    CONVERSION FLAGS (EBCDIC)
* BLOCK DATA SUB-STRUCTURE.
          DC    X'9000'                 EOF & BLOCK DATA FLAGS.
          DC    H'44'                   MAXIMUM INPUT LENGTH.
          DC    H'0'                    INPUT OFFSET
          DC    H'27'                   PRINT COLUMN.
          DC    H'0'                    PRINT FIELD LENGTH
          DC    H'0'                    CONVERSION FLAGS (EBCDIC)
* STATIC ENTRY.
STE31A    DC    C'IDC3302I  ACTION ERROR ON'
STE31B    EQU *
TXT3B     EQU *
          EJECT
*
* NON-AM/0 OPEN FOR UPDATE ERROR MESSAGE.
*
TXT4      DC    Y(TXT4B-TXT4A)          ENTRY LENGTH.
FLG4A     DC    X'A000'                 MESSAGE FLAG.
* STATIC TEXT SUB-STRUCTURE.
TXT4A     DC    X'8400'                 STATIC SUB-STRUCTURE FLAG.
          DC    Y(STE41B-STE41A)        STATIC TEXT LENGTH.
          DC    Y(STE41A-TXT4A)         STATIC TEXT OFFSET.
          DC    H'1'                    PRINT COLUMN.
          DC    Y(STE41B-STE41A)        PRINT FIELD LENGTH.
          DC    H'0'                    CONVERSION FLAGS. (EBCDIC)
* STATIC TEXT ENTRY.
STE41A    DC  C'IDC3303I ** CANNOT OPEN FOR UPDATE'
STE41B    EQU *
TXT4B     EQU *
          EJECT
*
* DD CARD MISSING ERROR MESSAGE.
*
TXT5      DC    Y(TXT5B-TXT5A)          ENTRY LENGTH.
FLG5A     DC    X'A000'                 MESSAGE FLAG.
* STATIC TEXT SUB-STRUCTURE.
TXT5A     DC    X'8400'                 STATIC SUB-STRUCTURE FLAG.
          DC    Y(STE51B-STE51A)        STATIC TEXT LENGTH.
          DC    Y(STE51A-TXT5A)         STATIC TEXT OFFSET.
          DC    H'1'                    PRINT COLUMN.
          DC    Y(STE51B-STE51A)        PRINT FIELD LENGTH.
          DC    H'0'                    CONVERSION FLAGS. (EBCDIC)
* STATIC TEXT ENTRY.
STE51A    DC  C'IDC3304I ** JCL STATEMENT MISSING'
STE51B    EQU *
TXT5B     EQU *
          EJECT
*
* ISAM OPEN FOR UPDATE ERROR MESSAGE.
*
TXT6      DC    Y(TXT6B-TXT6A)          ENTRY LENGTH.
FLG6A     DC    X'A000'                 MESSAGE FLAG.
* STATIC TEXT SUB-STRUCTURE.
TXT6A     DC    X'8400'                 STATIC SUB-STRUCTURE FLAG.
          DC    Y(STE61B-STE61A)        STATIC TEXT LENGTH.
          DC    Y(STE61A-TXT6A)         STATIC TEXT OFFSET.
          DC    H'1'                    PRINT COLUMN.
          DC    Y(STE61B-STE61A)        PRINT FIELD LENGTH.
          DC    H'0'                    CONVERSION FLAGS. (EBCDIC)
* STATIC TEXT ENTRY.
STE61A    DC  C'IDC3305I ** CANNOT BE OPENED FOR OUTPUT'
STE61B    EQU *
TXT6B     EQU *
          EJECT
*
* ISAM OPEN CHRONOLOGICAL ERROR MESSAGE.
*
TXT7      DC    Y(TXT7B-TXT7A)          ENTRY LENGTH.
FLG7A     DC    X'A000'                 MESSAGE FLAG.
* STATIC TEXT SUB-STRUCTURE.
TXT7A     DC    X'8400'                 STATIC SUB-STRUCTURE FLAG.
          DC    Y(STE71B-STE71A)        STATIC TEXT LENGTH.
          DC    Y(STE71A-TXT7A)         STATIC TEXT OFFSET.
          DC    H'1'                    PRINT COLUMN.
          DC    Y(STE71B-STE71A)        PRINT FIELD LENGTH.
          DC    H'0'                    CONVERSION FLAGS. (EBCDIC)
* STATIC TEXT ENTRY.
STE71A    DC    C'IDC3306I ** PS PROCESSING INVALID FOR KEYED DATA SET'
STE71B    EQU *
TXT7B     EQU *
          EJECT
*
* CHRONOLOGICAL DATA SET CANNOT BE OPENED FOR KEYED OUTPUT.
*
TXT8      DC    Y(TXT8B-TXT8A)          ENTRY LENGTH.
FLG8A     DC    X'A000'                 MESSAGE FLAG.
* STATIC TEXT SUB-STRUCTURE.
TXT8A     DC    X'8400'                 STATIC SUB-STRUCTURE FLAG.
          DC    Y(STE81B-STE81A)        STATIC TEXT LENGTH.
          DC    Y(STE81A-TXT8A)         STATIC TEXT OFFSET.
          DC    H'1'                    PRINT COLUMN.
          DC    Y(STE81B-STE81A)        PRINT FIELD LENGTH.
          DC    H'0'                    CONVERSION FLAGS. (EBCDIC)
* STATIC TEXT ENTRY.
STE81A    DC  C'IDC3307I ** DATA SET CANNOT BE OPENED FOR '
          DC    C'KEYED PROCESSING'
STE81B    EQU *
TXT8B     EQU *
          EJECT
*
* VSAM RETURN CODE
*
TXT9     DC  Y(TXT9B-TXT9A)            ENTRY LENGTH.           @Z40GSFY
FLG9A    DC  X'A000'                   MESSAGE FLAG.           @Z40GSFY
* STATIC TEXT SUB-STRUCTURE.                                   @Z40GSFY
TXT9A    DC  X'0400'                   STATIC FLAG.            @Z40GSFY
         DC  Y(STE91B-STE91A)          STATIC TEXT LENGTH.     @Z40GSFY
         DC  Y(STE91A-TXT9A)           STATIC TEXT OFFSET.     @Z40GSFY
         DC  H'1'                      PRINT COLUMN.           @Z40GSFY
         DC  Y(STE91B-STE91A)          PRINT FIELD LENGTH.     @Z40GSFY
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* INSERT DATA SUB-STRUCTURE                                    @Z40GSFY
         DC  X'2000'                   INSERT DATA FLAG        @Z40GSFY
         DC  H'1'                      REFERENCE NUMBER        @Z40GSFY
         DC  H'0'                      UNUSED                  @Z40GSFY
         DC  H'18'                     PRINT COLUMN            @Z40GSFY
         DC  H'5'                      PRINT FIELD LENGTH      @Z40GSFY
         DC  H'0'                      CONVERSION FLAGS (CHAR) @Z40GSFY
* STATIC TEXT SUB-STRUCTURE.                                   @Z40GSFY
         DC  X'0400'                   STATIC FLAG.            @Z40GSFY
         DC  Y(STE92B-STE92A)          STATIC TEXT LENGTH.     @Z40GSFY
         DC  Y(STE92A-TXT9A)           STATIC TEXT OFFSET.     @Z40GSFY
         DC  H'1'                      PRINT COLUMN.           @Z40GSFY
         DC  Y(STE92B-STE92A)          PRINT FIELD LENGTH.     @Z40GSFY
         DC  X'0010'                   CONVERSION FLAGS.  (CHAR,BS)
* INSERT DATA SUB-STRUCTURE                                    @Z40GSFY
         DC  X'A000'                   INSERT DATA FLAG        @Z40GSFY
         DC  H'2'                      REFERENCE NUMBER        @Z40GSFY
         DC  H'0'                      UNUSED                  @Z40GSFY
         DC  H'1'                      PRINT COLUMN            @Z40GSFY
         DC  H'3'                      PRINT FIELD LENGTH      @Z40GSFY
         DC  X'1070'                   CONVERSION FLAGS (BD,AL,SS,BS)
STE91A   DC  C'IDC3351I ** VSAM'                               @Z40GSFY
STE91B   EQU *                                                 @Z40GSFY
STE92A   DC  C'RETURN CODE IS'                                 @Z40GSFY
STE92B   EQU *                                                 @Z40GSFY
TXT9B    EQU *                                                 @Z40GSFY
          EJECT
*
* DUPLICATE RECORD MESSAGE.
*
TXT10    DC  Y(TXT10B-TXT10A)          ENTRY LENGTH.
         DC  X'A000'                   MESSAGE FLAG.
* STATIC TEXT SUB-STRUCTURE.
TXT10A   DC  X'0400'                   STATIC TEXT FLAG.
         DC  Y(STE101B-STE101A)        TEXT LENGTH.
         DC  Y(STE101A-TXT10A)         TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE101B-STE101A)        PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* BLOCK DATA SUB-STRUCTURE.
         DC  X'9000'                   EOF & BLOCK FLAGS.
         DC  H'5'                      INPUT LENGTH.
         DC  H'0'                      INPUT OFFSET.
         DC  H'30'                     PRINT COLUMN.
         DC  H'10'                     PRINT FIELD LENGTH.
         DC  X'4000'                   CONVERSION FLAGS.  (BHA)
* STATIC TEXT ENTRIES.
STE101A  DC  C'IDC3308I ** DUPLICATE RECORD'
STE101B  EQU *
TXT10B   EQU *
          EJECT
*
* VSAM SYNAD ERROR MESSAGE.
*
TXT11    DC  Y(TXT11B-TXT11A)          ENTRY LENGTH.
         DC  X'8000'                   MESSAGE FLAG.
* SPACING CONTROL SUB-STRUCTURE.
TXT11A   DC  X'4000'                   SPACE CONTROL FLAG.
         DC  H'2'                      SPACING FACTOR.
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC FLAG.
         DC  Y(STE111B-STE111A)        TEXT LENGTH.
         DC  Y(STE111A-TXT11A)         TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE111B-STE111A)        PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* BLOCK DATA SUB-STRUCTURE.
         DC  X'1000'                   BLOCK DATA FLAG.
         DC  H'56'                     INPUT LENGTH.
         DC  H'0'                      INPUT OFFSET.
         DC  H'10'                     PRINT COLUMN.
         DC  H'56'                     PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* SPACING CONTROL SUB-STRUCTURE.
         DC  X'4000'                   SPACE CONTROL FLAG.
         DC  H'1'                      SPACING FACTOR.
         DC  C'R '                     SPACING TYPE.
* BLOCK DATA SUB-STRUCTURE.
         DC  X'1000'                   BLOCK DATA FLAG.
         DC  H'60'                     INPUT LENGTH.
         DC  H'56'                     INPUT OFFSET.
         DC  H'10'                     PRINT COLUMN.
         DC  H'60'                     PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* STATIC TEXT ENTRIES.
STE111A  DC  C'IDC3350I'
STE111B  EQU *
TXT11B   EQU *
               EJECT
*
* NON-KEYED RECORD TOO LONG FOR DATA SET ERROR MESSAGE.
*
TXT12     DC    Y(TXT12B-TXT12A)        ENTRY LENGTH.
FLG12B    DC    X'A000'                 MESSAGE FLAG.
* STATIC TEXT SUB-STRUCTURE.
TXT12A    DC    X'0400'                 STATIC SUB-STRUCTURE FLAG.
          DC    Y(STE121B-STE121A)      STATIC TEXT LENGTH.
          DC    Y(STE121A-TXT12A)       STATIC TEXT OFFSET.
          DC    H'1'                    PRINT COLUMN.
          DC    Y(STE121B-STE121A)      PRINT FIELD LENGTH.
          DC    H'0'                    CONVERSION FLAGS. (EBCDIC)
* BLOCK DATA SUB-STRUCTURE.
         DC  X'1000'                   BLOCK DATA FLAG.
         DC  H'5'                      INPUT LENGTH.
         DC  H'0'                      INPUT OFFSET.
         DC  H'20'                     PRINT COLUMN.
         DC  H'10'                     OUTPUT LENGTH.
         DC  X'4000'                   CONVERSION FLAGS.  (BHA)
* STATIC TEXT SUB-STRUCTURE.
         DC  X'8400'                   EOF AND STATIC FLAGS.
         DC  Y(STE122B-STE122A)        STATIC TEXT LENGTH.
         DC  Y(STE122A-TXT12A)         STATIC TEXT OFFSET.
         DC  H'34'                     PRINT COLUMN.
         DC  Y(STE122B-STE122A)        PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* STATIC TEXT ENTRY.
STE121A   DC  C'IDC3309I ** RECORD'
STE121B   EQU *
STE122A  DC  C'NOT WRITTEN.  LENGTH INVALID'
STE122B  EQU *
TXT12B    EQU *
          EJECT
*
* KEY TOO LARGE ERROR MESSAGE.
*
TXT13     DC    Y(TXT13B-TXT13A)        ENTRY LENGTH.
FLG13B    DC    X'A000'                 MESSAGE FLAG.
* STATIC TEXT SUB-STRUCTURE.
TXT13A    DC    X'8400'                 STATIC SUB-STRUCTURE FLAG.
          DC    Y(STE131B-STE131A)      STATIC TEXT LENGTH.
          DC    Y(STE131A-TXT13A)       STATIC TEXT OFFSET.
          DC    H'1'                    PRINT COLUMN.
          DC    Y(STE131B-STE131A)      PRINT FIELD LENGTH.
          DC    H'0'                    CONVERSION FLAGS. (EBCDIC)
* STATIC TEXT ENTRY.
STE131A   DC  C'IDC3310I ** KEY SUPPLIED IS LONGER THAN '
          DC    C'KEY LENGTH OF DATA SET'
STE131B   EQU *
TXT13B    EQU *
          EJECT
*
* NON-AM/0 POSITIONING ERROR MESSAGE.
*
TXT14     DC    Y(TXT14B-TXT14A)        ENTRY LENGTH.
FLG14B    DC    X'A000'                 MESSAGE FLAG.
* STATIC TEXT SUB-STRUCTURE.
TXT14A    DC    X'8400'                 STATIC SUB-STRUCTURE FLAG.
          DC    Y(STE141B-STE141A)      STATIC TEXT LENGTH.
          DC    Y(STE141A-TXT14A)       STATIC TEXT OFFSET.
          DC    H'1'                    PRINT COLUMN.
          DC    Y(STE141B-STE141A)      PRINT FIELD LENGTH.
          DC    H'0'                    CONVERSION FLAGS. (EBCDIC)
* STATIC TEXT ENTRY.
STE141A   DC  C'IDC3311I ** TYPE OF POSITIONING NOT SUPPORTED'
STE141B   EQU *
TXT14B    EQU *
          EJECT
*
* DCBOFLGS NOT SET AFTER OPEN REQUEST.
*
TXT15     DC  Y(TXT15B-TXT15A)          ENTRY LENGTH.
FLG15A    DC  X'A000'                   MESSAGE FLAGS.
* STATIC TEXT SUB-STRUCTURE.
TXT15A    DC  X'8400'                   STATIC TEXT FLAG.
          DC  Y(STE151B-STE151A)        STATIC TEXT LENGTH.
          DC  Y(STE151A-TXT15A)         STATIC TEXT OFFSET.
          DC  H'1'                      PRINT COLUMN.
          DC  Y(STE151B-STE151A)        PRINT LENGTH.
          DC  H'0'                      CONVERSION FLAGS. (CHAR)
*STATIC TEXT ENTRY.
STE151A   DC  C'IDC3312I ** SYSTEM UNABLE TO OPEN'
STE151B   EQU *
TXT15B    EQU *
          EJECT
*
* SYNAD MESSAGE.  STATIC TEXT CONSISTS OF MESSAGE NUMBER ONLY.
*
TXT16     DC  Y(TXT16B-TXT16A)          ENTRY LENGTH.
FLG16A    DC  X'A000'                   MESSAGE FLAG.
* STATIC TEXT SUB-STRUCTURE.
TXT16A    DC  X'0400'                   STATIC FLAG.
          DC  Y(STE161B-STE161A)        STATIC TEXT LENGTH.
          DC  Y(STE161A-TXT16A)         STATIC TEXT OFFSET.
          DC  H'1'                      PRINT COLUMN.
          DC  Y(STE161B-STE161A)        PRINT LENGTH.
          DC  H'0'                      CONVERSION FLAGS. (CHAR)
* BLOCK DATA SUB-STRUCTURE.
          DC  X'1000'                   EOF & BLOCK DATA FLAG.
          DC  H'36'                     INPUT LENGTH.
          DC  H'0'                      INPUT OFFSET
          DC  H'14'                     PRINT COLUMN.
          DC  H'36'                     PRINT FIELD LENGTH.
          DC  H'0'                      CONVERSION FLAG. (CHAR)
* SPACING CONTROL SUB-STRUCTURE.
         DC  X'4000'                   SPACE CONTROL SUB-STRUCTURE.
         DC  H'1'                      SPACING FACTOR.
         DC  C'R '                     SPACING TYPE.
* BLOCK DATA SUB-STRUCTURE.
          DC  X'9000'                   EOF & BLOCK DATA FLAG.
          DC  H'44'                     INPUT LENGTH.
          DC  H'36'                     INPUT OFFSET
          DC  H'11'                     PRINT COLUMN.
          DC  H'44'                     PRINT FIELD LENGTH.
          DC  H'0'                      CONVERSION FLAG. (CHAR)
* STATIC TEXT ENTRY
STE161A   DC  C'IDC3313I **'
STE161B   EQU *
TXT16B    EQU *
          EJECT
*
* RECORD OUT OF SEQUENCE MESSAGE.
*
TXT17    DC  Y(TXT17B-TXT17A)          ENTRY LENGTH.
         DC  X'A000'                   MESSAGE FLAG.
* SPACING CONTROL SUB-STRUCTURE.
TXT17A   DC  X'4000'                   SPACE CONTROL FLAG.
         DC  H'2'                      SPACING FACTOR.
         DC  C'R '                     SPACINT TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC TEXT FLAG.
         DC  Y(STE171B-STE171A)        TEXT LENGTH.
         DC  Y(STE171A-TXT17A)         TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE171B-STE171A)        PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* BLOCK DATA SUB-STRUCTURE.
         DC  X'9000'                   EOF & BLOCK FLAGS.
         DC  H'32767'                  INPUT LENGTH.           @ZA02666
         DC  H'0'                      INPUT OFFSET.           @ZA02666
         DC  H'19'                     PRINT COLUMN.
         DC  H'10'                     PRINT FIELD LENGTH.
         DC  X'4000'                   CONVERSION FLAGS.  (BHA)
* STATIC TEXT ENTRIES.
STE171A  DC  C'IDC3314I **RECORD               OUT OF SEQUENCE' ZA02666
STE171B  EQU *
TXT17B   EQU *
         EJECT
*
* ENTRY DOES NOT EXIST IN DIRECTORY
*
TXT18    DC  Y(TXT18B-TXT18A)          ENTRY LENGTH.           @YL026UE
         DC  X'A000'                   MESSAGE FLAG.           @YL026UE
* STATIC TEXT SUB-STRUCTURE.
TXT18A   DC  X'0400'                   STATIC TEXT FLAG.       @YL026UE
         DC  Y(STE181B-STE181A)        TEXT LENGTH.            @YL026UE
         DC  Y(STE181A-TXT18A)         TEXT OFFSET.            @YL026UE
         DC  H'1'                      PRINT COLUMN.           @YL026UE
         DC  Y(STE181B-STE181A)        PRINT FIELD LENGTH.     @YL026UE
         DC  H'0'                      CONVERSION FLAGS (CHAR) @YL026UE
* BLOCK DATA SUB-STRUCTURE.
         DC  X'9000'                   EOF & BLOCK FLAGS.      @YL026UE
         DC  H'8'                      INPUT LENGTH.           @YL026UE
         DC  H'0'                      INPUT OFFSET.           @YL026UE
         DC  H'13'                     PRINT COLUMN.           @YL026UE
         DC  H'8'                      PRINT FIELD LENGTH.     @YL026UE
         DC  X'0000'                   CONVERSION FLAGS (CHAR) @YL026UE
* STATIC TEXT ENTRIES.
STE181A  DC  C'IDC3330I ** XXXXXXXX NOT FOUND'                 @YL026UE
STE181B  EQU *                                                 @YL026UE
TXT18B   EQU *                                                 @YL026UE
         EJECT
*
* DATA SET IS NOT USER CATALOG
*
TXT19     DC  Y(TXT19B-TXT19A)          ENTRY LENGTH.
FLG19A    DC  X'A000'                   MESSAGE FLAG.
* STATIC TEXT SUB-STRUCTURE.
TXT19A    DC  X'8400'                   EOF & STATIC FLAGS.
          DC  Y(STE191B-STE191A)        STATIC TEXT LENGTH.
          DC  Y(STE191A-TXT19A)         STATIC TEXT OFFSET.
          DC  H'1'                      PRINT COLUMN.
          DC  Y(STE191B-STE191A)        OUTPUT LENGTH.
          DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* STATIC TEXT ENTRY.
STE191A   DC  C'IDC3316I ** DATA SET IS NOT VSAM CATALOG'      @YL026UE
STE191B   EQU *
TXT19B    EQU *
         EJECT
*
* PERMANENT I/O ERROR
*
TXT20     DC  Y(TXT20B-TXT20A)          ENTRY LENGTH.
FLG20A    DC  X'A000'                   MESSAGE FLAG.
* STATIC TEXT SUB-STRUCTURE.
TXT20A    DC  X'8400'                   EOF & STATIC FLAGS.
          DC  Y(STE201B-STE201A)        STATIC TEXT LENGTH.
          DC  Y(STE201A-TXT20A)         STATIC TEXT OFFSET.
          DC  H'1'                      PRINT COLUMN.
          DC  Y(STE201B-STE201A)        OUTPUT LENGTH.
          DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* STATIC TEXT ENTRY.
STE201A   DC  C'IDC3317I ** PERMANENT I/O ERROR'
STE201B   EQU *
TXT20B    EQU *
         EJECT
*
* INVALID OPNAGL
*
TXT21     DC  Y(TXT21B-TXT21A)          ENTRY LENGTH.
FLG21A    DC  X'A000'                   MESSAGE FLAG.
* STATIC TEXT SUB-STRUCTURE.
TXT21A    DC  X'8400'                   EOF & STATIC FLAGS.
          DC  Y(STE211B-STE211A)        STATIC TEXT LENGTH.
          DC  Y(STE211A-TXT21A)         STATIC TEXT OFFSET.
          DC  H'1'                      PRINT COLUMN.
          DC  Y(STE211B-STE211A)        OUTPUT LENGTH.
          DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* STATIC TEXT ENTRY.
STE211A  DC  C'IDC3318I ** INVALID DATA SET SPECIFICATION'
STE211B  EQU *
TXT21B   EQU *
         EJECT
*
* ENTRY WITH NEW NAME EXISTS IN DIRECTORY
*
TXT22    DC  Y(TXT22B-TXT22A)          ENTRY LENGTH.           @YL026UE
         DC  X'A000'                   MESSAGE FLAG.           @YL026UE
* STATIC TEXT SUB-STRUCTURE.
TXT22A   DC  X'0400'                   STATIC TEXT FLAG.       @YL026UE
         DC  Y(STE221B-STE221A)        TEXT LENGTH.            @YL026UE
         DC  Y(STE221A-TXT22A)         TEXT OFFSET.            @YL026UE
         DC  H'1'                      PRINT COLUMN.           @YL026UE
         DC  Y(STE221B-STE221A)        PRINT FIELD LENGTH.     @YL026UE
         DC  H'0'                      CONVERSION FLAGS (CHAR) @YL026UE
* BLOCK DATA SUB-STRUCTURE.
         DC  X'9000'                   EOF & BLOCK FLAGS.      @YL026UE
         DC  H'8'                      INPUT LENGTH.           @YL026UE
         DC  H'0'                      INPUT OFFSET.           @YL026UE
         DC  H'13'                     PRINT COLUMN.           @YL026UE
         DC  H'8'                      PRINT FIELD LENGTH.     @YL026UE
         DC  X'0000'                   CONVERSION FLAGS (CHAR) @YL026UE
* STATIC TEXT ENTRIES.
STE221A  DC  C'IDC3331I ** xxxxxxxx ALREADY EXISTS'            @YL026UE
STE221B  EQU *                                                 @YL026UE
TXT22B   EQU *                                                 @YL026UE
         EJECT
*
* STATIC TEXT ENTRY 23 IS UNUSED.                              @Y30SSFY
*
         EJECT
*
* ABEND EXIT TAKEN.
*
TXT24     DC  Y(TXT24B-TXT24A)          ENTRY LENGTH.
FLG24A    DC  X'A000'                   MESSAGE FLAG.
* STATIC TEXT SUB-STRUCTURE.
TXT24A    DC  X'8400'                   EOF & STATIC FLAGS.
          DC  Y(STE241B-STE241A)        STATIC TEXT LENGTH.
          DC  Y(STE241A-TXT24A)         STATIC TEXT OFFSET.
          DC  H'1'                      PRINT COLUMN.
          DC  Y(STE241B-STE241A)        OUTPUT LENGTH.
          DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* STATIC TEXT ENTRY.
STE241A  DC  C'IDC3321I ** OPEN/CLOSE/EOV ABEND EXIT TAKEN'    @YM07860
STE241B  EQU *
TXT24B   EQU *
          EJECT
*
* DATA SET ORGANIZATION IS NOT VSAM
*
TXT25     DC  Y(TXT25B-TXT25A)          ENTRY LENGTH.
FLG25A    DC  X'A000'                   MESSAGE FLAG.
* STATIC TEXT SUB-STRUCTURE.
TXT25A    DC  X'8400'                   EOF & STATIC FLAGS.
          DC  Y(STE251B-STE251A)        STATIC TEXT LENGTH.
          DC  Y(STE251A-TXT25A)         STATIC TEXT OFFSET.
          DC  H'1'                      PRINT COLUMN.
          DC  Y(STE251B-STE251A)        OUTPUT LENGTH.
          DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* STATIC TEXT ENTRY.
STE251A   DC  C'IDC3322I ** DATA SET ORGANIZATION IS NOT VSAM'
STE251B   EQU *
TXT25B    EQU *
         EJECT                                                 @YL026UE
*                                                              @YL026UE
* INSUFFICIENT MAIN STORAGE                                    @YL026UE
*                                                              @YL026UE
TXT26     DC  Y(TXT26B-TXT26A)          ENTRY LENGTH.          @YL026UE
FLG26A    DC  X'A000'                   MESSAGE FLAG.          @YL026UE
* STATIC TEXT SUB-STRUCTURE.                                   @YL026UE
TXT26A    DC  X'8400'                   EOF & STATIC FLAGS.    @YL026UE
          DC  Y(STE261B-STE261A)        STATIC TEXT LENGTH.    @YL026UE
          DC  Y(STE261A-TXT26A)         STATIC TEXT OFFSET.    @YL026UE
          DC  H'1'                      PRINT COLUMN.          @YL026UE
          DC  Y(STE261B-STE261A)        OUTPUT LENGTH.         @YL026UE
          DC  H'0'                      CONVERSION FLAG (CHAR) @YL026UE
* STATIC TEXT ENTRY.                                           @YL026UE
STE261A   DC  C'IDC3332I ** INSUFFICIENT MAIN STORAGE'         @YLO26UE
STE261B   EQU *                                                @YL026UE
TXT26B    EQU *                                                @YL026UE
         EJECT
*                                                              @YL026UE
* ERROR ALLOCATING DSNAME                                      @YL026UE
*                                                              @YL026UE
TXT27    DC    Y(TXT27B-TXT27A)        ENTRY LENGTH.           @YL026UE
         DC    X'8000'                 MESSAGE FLAG.           @YL026UE
* STATIC TEXT SUB-STRUCTURE.                                   @YL026UE
TXT27A   DC    X'0400'                 STATIC TEXT FLAG.       @YL026UE
         DC    Y(STE271B-STE271A)      TEXT LENGTH.            @YL026UE
         DC    Y(STE271A-TXT27A)       TEXT OFFSET.            @YL026UE
         DC    H'1'                    PRINT COLUMN.           @YL026UE
         DC    Y(STE271B-STE271A)      PRINT FIELD LENGTH.     @YL026UE
         DC    H'0'                    CONVERSION FLAGS. (CHAR)
* BLOCK DATA SUB-STRUCTURE.                                    @YL026UE
         DC    X'9000'                 EOF AND BLOCK DATA FLAGS.
         DC    H'44'                   INPUT LENGTH.           @YL026UE
         DC    H'0'                    INPUT OFFSET.           @YL026UE
         DC    H'27'                   PRINT COLUMN.           @YL026UE
         DC    H'44'                   PRINT FIELD LENGTH.     @YL026UE
         DC    X'0000'                 CONVERSION FLAGS. (CHAR)
* STATIC TEXT ENTRIES.                                         @YL026UE
STE271A  DC    C'IDC3903I ERROR ALLOCATING'                    @YL026UE
STE271B  EQU   *                                               @YL026UE
TXT27B   EQU   *                                               @YL026UE
         EJECT                                                 @YL026UE
*                                                              @YL026UE
* ERROR UNALLOCATING                                           @YL026UE
*                                                              @YL026UE
TXT28    DC    Y(TXT28B-TXT28A)        ENTRY LENGTH.           @YL026UE
         DC    X'8000'                 MESSAGE FLAG.           @YL026UE
* STATIC TEXT SUB-STRUCTURE.                                   @YL026UE
TXT28A   DC    X'0400'                 STATIC TEXT FLAG.       @YL026UE
         DC    Y(STE281B-STE281A)      TEXT LENGTH.            @YL026UE
         DC    Y(STE281A-TXT28A)       TEXT OFFSET.            @YL026UE
         DC    H'1'                    PRINT COLUMN.           @YL026UE
         DC    Y(STE281B-STE281A)      PRINT FIELD LENGTH.     @YL026UE
         DC    H'0'                    CONVERSION FLAGS. (CHAR)
* BLOCK DATA SUB-STRUCTURE.                                    @YL026UE
         DC    X'9000'                 EOF AND BLOCK DATA FLAGS.
         DC    H'44'                   INPUT LENGTH.           @YL026UE
         DC    H'0'                    INPUT OFFSET.           @YL026UE
         DC    H'29'                   PRINT COLUMN.           @YL026UE
         DC    H'44'                   PRINT FIELD LENGTH.     @YL026UE
         DC    X'0000'                 CONVERSION FLAGS. (CHAR)
* STATIC TEXT ENTRIES.                                         @YL026UE
STE281A  DC    C'IDC3904I ERROR UNALLOCATING'                  @YL026UE
STE281B  EQU   *                                               @YL026UE
TXT28B   EQU   *                                               @YL026UE
         EJECT                                                 @YL026UE
*                                                              @YL026UE
* DYNAMIC ALLOCATION RETURN CODES                              @YL026UE
*                                                              @YL026UE
TXT29    DC    Y(TXT29B-TXT29A)        ENTRY LENGTH.           @YL026UE
         DC    X'A000'                 MESSAGE FLAG.           @YL026UE
* STATIC TEXT SUB-STRUCTURE.                                   @YL026UE
TXT29A   DC    X'0400'                 STATIC TEXT FLAG.       @YL026UE
         DC    Y(STE291B-STE291A)      TEXT LENGTH.            @YL026UE
         DC    Y(STE291A-TXT29A)       TEXT OFFSET.            @YL026UE
         DC    H'1'                    PRINT COLUMN.           @YL026UE
         DC    Y(STE291B-STE291A)      PRINT FIELD LENGTH.     @YL026UE
         DC    H'0'                    CONVERSION FLAGS. (CHAR)
* BLOCK DATA SUB-STRUCTURE.                                    @YL026UE
         DC    X'1000'                 BLOCK DATA FLAGS.       @YL026UE
         DC    H'2'                    INPUT LENGTH.           @YL026UE
         DC    H'0'                    INPUT OFFSET.           @YL026UE
         DC    H'27'                   PRINT COLUMN.           @YL026UE
         DC    H'2'                    PRINT FIELD LENGTH.     @YL026UE
         DC    X'1020'                 CONVERSION FLAGS. (BD,SS)
* BLOCK DATA SUB-STRUCTURE.                                    @YL026UE
         DC    X'1000'                 BLOCK DATA FLAGS.       @YL026UE
         DC    H'2'                    INPUT LENGTH.           @YL026UE
         DC    H'2'                    INPUT OFFSET.           @YL026UE
         DC    H'42'                   PRINT COLUMN.           @YL026UE
         DC    H'4'                    PRINT FIELD LENGTH.     @YL026UE
         DC    X'4000'                 CONVERSION FLAGS. (BHA)
* BLOCK DATA SUB-STRUCTURE.                                    @YL026UE
         DC    X'9000'                 EOF AND BLOCK DATA FLAGS.
         DC    H'2'                    INPUT LENGTH.           @YL026UE
         DC    H'4'                    INPUT OFFSET.           @YL026UE
         DC    H'61'                   PRINT COLUMN.           @YL026UE
         DC    H'4'                    PRINT FIELD LENGTH.     @YL026UE
         DC    X'4000'                 CONVERSION FLAGS. (BHA)
* STATIC TEXT ENTRIES.                                         @YL026UE
STE291A  DC    C'IDC3905I ** ALLOCATION RC   , ERROR '         @YL026UE
         DC    C'CODE        , INFO CODE'                      @YL026UE
STE291B  EQU   *                                               @YL026UE
TXT29B   EQU   *                                               @YL026UE
         EJECT                                                 @YL026UE
*                                                              @YL026UE
* ERROR ALLOCATING VOLUME(S)                                   @YL026UE
*                                                              @YL026UE
TXT30    DC    Y(TXT30B-TXT30A)        ENTRY LENGTH.           @YL026UE
         DC    X'8000'                 MESSAGE FLAG.           @YL026UE
* STATIC TEXT SUB-STRUCTURE.                                   @YL026UE
TXT30A   DC    X'8400'                 EOF AND STATIC TEXT FLAG.
         DC    Y(STE301B-STE301A)      TEXT LENGTH.            @YL026UE
         DC    Y(STE301A-TXT30A)       TEXT OFFSET.            @YL026UE
         DC    H'1'                    PRINT COLUMN.           @YL026UE
         DC    Y(STE301B-STE301A)      PRINT FIELD LENGTH.
         DC    H'0'                    CONVERSION FLAGS. (CHAR)
* STATIC TEXT ENTRIES.                                         @YL026UE
STE301A  DC    C'IDC3906I ERROR DURING DYNAMIC ALLOCATION OF '
         DC    C'VOLUMES'                                      @YL026UE
STE301B  EQU   *                                               @YL026UE
TXT30B   EQU   *                                               @YL026UE
         EJECT                                                 @YL026UE
*                                                              @YL026UE
* ERROR IN DYNAMIC CONCATENATION                               @YL026UE
*                                                              @YL026UE
TXT31    DC    Y(TXT31B-TXT31A)        ENTRY LENGTH.           @YL026UE
         DC    X'8000'                 MESSAGE FLAG.           @YL026UE
* STATIC TEXT SUB-STRUCTURE.                                   @YL026UE
TXT31A   DC    X'8400'                 EOF AND STATIC TEXT FLAG.
         DC    Y(STE311B-STE311A)      TEXT LENGTH.            @YL026UE
         DC    Y(STE311A-TXT31A)       TEXT OFFSET.            @YL026UE
         DC    H'1'                    PRINT COLUMN.           @YL026UE
         DC    Y(STE311B-STE311A)      PRINT FIELD LENGTH.     @YL026UE
         DC    H'0'                    CONVERSION FLAGS. (CHAR)
* STATIC TEXT ENTRIES.                                         @YL026UE
STE311A  DC    C'IDC3907I ERROR DURING DYNAMIC CONCATENATION'
STE311B  EQU   *                                               @YL026UE
TXT31B   EQU   *                                               @YL026UE
         EJECT
*
* TARGET CATALOG IS NOT EMPTY
*
TXT32    DC    Y(TXT32B-TXT32A)        ENTRY LENGTH            @YL026UH
FLG32A   DC    X'A000'                 MESSAGE FLAG            @YL026UH
* STATIC TEXT SUB-STRUCTURE.
TXT32A   DC    X'8400'                 SUB STRUCTURE FLAG      @YL026UH
         DC    Y(STE321B-STE321A)      STATIC TEXT LENGTH      @YL026UH
         DC    Y(STE321A-TXT32A)       STATIC TEXT OFFSET      @YL026UH
         DC    H'1'                    PRINT COLUMN            @YL026UH
         DC    Y(STE321B-STE321A)      PRINT FIELD LENGTH      @YL026UH
         DC    H'0'                    CONVERSION FLAGS        @YL026UH
* STATIC TEXT ENTRY
STE321A  DC    C'IDC3333I ** CATALOG IS NOT EMPTY'
STE321B  EQU   *
TXT32B   EQU   *
         EJECT
*
* INVALID CI NUMBER IS SOURCE CATALOG
*
TXT33    DC    Y(TXT33B-TXT33A)        ENTRY LENGTH            @YL026UH
FLG33A   DC    X'A000'                 MESSAGE FLAG            @YL026UH
* STATIC TEXT SUB-STRUCTURE
TXT33A   DC    X'8400'                 SUB-STRUCTURE FLAG      @YL026UH
         DC    Y(STE331B-STE331A)      STATIC TEXT LENGTH      @YL026UH
         DC    Y(STE331A-TXT33A)       STATIC TEXT OFFSET      @YL026UH
         DC    H'1'                    PRINT COLUMN            @YL026UH
         DC    Y(STE331B-STE331A)      PRINT FIELD LENGTH      @YL026UH
         DC    H'0'                    CONVERSION FLAGS        @YL026UH
* STATIC TEXT ENTRY
STE331A  DC    C'IDC3334I ** INVALID CI NUMBER'
STE331B  EQU   *
TXT33B   EQU   *
         EJECT                                                 @Y30LSMK
*                                                              @Y30SSFY
* STATIC TEXT ENTRY 34 IS UNUSED.                              @Y30SSFY
*                                                              @Y30SSFY
          EJECT                                                @Y30SSFY
*                                                              @Y30SSFY
* DUPLICATE RECORD MESSAGE (RRDS)                              @Y30SSFY
*                                                              @Y30SSFY
TXT35    DC  Y(TXT35B-TXT35A)          ENTRY LENGTH.           @Y30SSFY
         DC  X'A000'                   MESSAGE FLAG.           @Y30SSFY
* STATIC TEXT SUB-STRUCTURE.                                   @Y30SSFY
TXT35A   DC  X'0400'                   STATIC TEXT FLAG.       @Y30SSFY
         DC  Y(STE351B-STE351A)        TEXT LENGTH.            @Y30SSFY
         DC  Y(STE351A-TXT35A)         TEXT OFFSET.            @Y30SSFY
         DC  H'1'                      PRINT COLUMN.           @Y30SSFY
         DC  Y(STE351B-STE351A)        PRINT FIELD LENGTH.     @Y30SSFY
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* BLOCK DATA SUB-STRUCTURE.                                    @Y30SSFY
         DC  X'9000'                   EOF & BLOCK FLAGS.      @Y30SSFY
         DC  H'4'                      INPUT LENGTH.           @Y30SSFY
         DC  H'0'                      INPUT OFFSET.           @Y30SSFY
         DC  H'01'                     PRINT COLUMN.           @Y30SSFY
         DC  H'10'                     PRINT FIELD LENGTH.     @Y30SSFY
         DC  X'1070'                   CONV.FLAGS(BD,AL,SS,BS) @Y30SSFY
* STATIC TEXT ENTRIES.                                         @Y30SSFY
STE351A  DC  C'IDC3308I ** DUPLICATE RECORD'                   @Y30SSFY
STE351B  EQU *                                                 @Y30SSFY
TXT35B   EQU *                                                 @Y30SSFY
*                                                              #Y30LSMK
         EJECT                                                 @Y30LSMK
*                                                              @Y30LSMK
* DNAME NOT FOUND IN SYSTEM.                                   @Y30LSMK
*                                                              @Y30LSMK
TXT36    DC  Y(TXT36B-TXT36A)          ENTRY LENGTH.           @Y30LSMK
         DC  X'8000'                   MESSAGE FLAG.           @Y30LSMK
* DOUBLE SPACE SUB-STRUCTURE.                                  @Y30LSMK
TXT36A   DC  X'4000'                   SPACE CONTROL FLAG.     @Y30LSMK
         DC  H'2'                      SPACING FACTOR.         @Y30LSMK
         DC  C'R '                     SPACING TYPE.           @Y30LSMK
* STATIC TEXT SUB-STRUCTURE.                                   #Y30LSMK
         DC  X'0400'                   STATIC TEXT FLAG.       @Y30LSMK
         DC  Y(STE361B-STE361A)        STATIC TEXT LENGTH.     #Y30LSMK
         DC  Y(STE361A-TXT36A)         STATIC TEXT OFFSET.     #Y30LSMK
         DC  H'1'                      PRINT COLUMN.           #Y30LSMK
         DC  Y(STE361B-STE361A)        PRINT FIELD LENGTH.     @Y30LSMK
         DC  X'0000'                   CONVERSION FLAGS (CHAR) @Y30LSMK
* BLOCK DATA SUB-STRUCTURE.                                    @Y30LSMK
         DC  X'1000'                   BLOCK DATA FLAG.        @Y30LSMK
         DC  H'8'                      INPUT DATA LENGTH.      @Y30LSMK
         DC  H'0'                      INPUT DATA OFFSET.      @Y30LSMK
         DC  H'10'                     PRINT COLUMN.           @Y30LSMK
         DC  H'8'                      PRINT FIELD LENGTH.     @Y30LSMK
         DC  H'0'                      CONVERSION FLAGS (CHAR) @Y30LSMK
* STATIC TEXT SUB-STRUCTURE.                                   @Y30LSMK
         DC  X'8400'                   EOF & STATIC TEXT FLAGS @Y30LSMK
         DC  Y(STE362B-STE362A)        STATIC TEXT LENGTH.     @Y30LSMK
         DC  Y(STE362A-TXT36A)         STATIC TEXT OFFSET.     @Y30LSMK
         DC  H'1'                      PRINT COLUMN OFFSET.    @Y30LSMK
         DC  Y(STE362B-STE362A)        PRINT FIELD LENGTH.     @Y30LSMK
         DC  X'0010'                   CONV FLAGS.  (CHAR,BS)  @Y30LSMK
* STATIC TEXT ENTRIES.                                         @Y30LSMK
STE361A  DC  C'IDC2908I'                                       @Y30LSMK
STE361B  EQU *                                                 @Y30LSMK
STE362A  DC  C'NOT FOUND IN SYSTEM'                            @Y30LSMK
STE362B  EQU *                                                 @Y30LSMK
TXT36B   EQU *                                                 @Y30LSMK
         EJECT                                                 @Y30LSMK
*                                                              @Y30LSMK
* DATA SET COULD NOT BE SCRATCHED MESSAGE.                     @Y30LSMK
*                                                              @Y30LSMK
TXT37     DC    Y(TXT37B-TXT37A)        ENTRY LENGTH.          @Y30LSMK
          DC    X'8000'                 MESSAGE FLAG.          @Y30LSMK
* DOUBLE SPACE SUB-STRUCTURE.                                  @Y30LSMK
TXT37A    DC    X'4000'                 SPACE CONTROL FLAG.    @Y30LSMK
          DC    H'2'                    SPACING FACTOR.        @Y30LSMK
          DC    C'R '                   SPACING TYPE.          @Y30LSMK
* STATIC TEXT SUB-STRUCTURE.                                   @Y30LSMK
          DC    X'0400'                 STATIC TEXT FLAG.      @Y30LSMK
          DC    Y(STE371B-STE371A)      STATIC TEXT LENGTH.    @Y30LSMK
          DC    Y(STE371A-TXT37A)       STATIC TEXT OFFSET.    @Y30LSMK
          DC    H'1'                    PRINT COLUMN NO.       @Y30LSMK
          DC    Y(STE371B-STE371A)      PRINT FIELD LENGTH     @Y30LSMK
          DC    H'0'                    CONVERSION FLAGS(CHAR) @Y30LSMK
* BLOCK DATA SUB-STRUCTURE.                                    @Y30LSMK
          DC    X'9000'                 EOF & BLOCK DATA FLAGS @Y30LSMK
          DC    H'44'                   INPUT DATA LENGTH.     @Y30LSMK
          DC    H'0'                    INPUT DATA OFFSET      @Y30LSMK
          DC    H'28'                   PRINT COLUMN.          @Y30LSMK
          DC    H'44'                   PRINT FIELD LENGTH     @Y30LSMK
          DC    H'0'                    CONVERSION FLAGS(CHAR) @Y30LSMK
* STATIC ENTRY.                                                @Y30LSMK
STE371A   DC    C'IDC2909I UNABLE TO SCRATCH'                  @Y30LSMK
STE371B   EQU *                                                @Y30LSMK
TXT37B    EQU *                                                @Y30LSMK
          EJECT                                                @Y30LSMK
*                                                              @Y30LSMK
* NO VOLUME MOUNTED MESSAGE.                                   @Y30LSMK
*                                                              @Y30LSMK
TXT38     DC    Y(TXT38B-TXT38A)        ENTRY LENGTH.          @Y30LSMK
          DC    X'A000'                 MESSAGE FLAG.          @Y30LSMK
* STATIC TEXT SUB-STRUCTURE.                                   @Y30LSMK
TXT38A    DC    X'8400'                 STATIC TEXT FLAG.      @Y30LSMK
          DC    Y(STE381B-STE381A)      STATIC TEXT LENGTH.    @Y30LSMK
          DC    Y(STE381A-TXT38A)       STATIC TEXT OFFSET.    @Y30LSMK
          DC    H'1'                    PRINT COLUMN.          @Y30LSMK
          DC    Y(STE381B-STE381A)      PRINT FIELD LENGTH.    @Y30LSMK
          DC    H'0'                    CONVERSION FLAGS(CHAR) @Y30LSMK
* STATIC TEXT ENTRY.                                           @Y30LSMK
STE381A   DC  C'IDC2910I ** NO VOLUME MOUNTED'                 @Y30LSMK
STE381B   EQU *                                                @Y30LSMK
TXT38B    EQU *                                                @Y30LSMK
          EJECT                                                @Y30LSMK
*                                                              @Y30LSMK
* DATA SET NOT ON VOLUME MESSAGE.                              @Y30LSMK
*                                                              @Y30LSMK
TXT39     DC    Y(TXT39B-TXT39A)        ENTRY LENGTH.          @Y30LSMK
          DC    X'A000'                 MESSAGE FLAG.          @Y30LSMK
* STATIC TEXT SUB-STRUCTURE.                                   @Y30LSMK
TXT39A    DC    X'0400'                 STATIC TEXT FLAG.      @Y30LSMK
          DC    Y(STE391B-STE391A)      STATIC TEXT LENGTH.    @Y30LSMK
          DC    Y(STE391A-TXT39A)       STATIC TEXT OFFSET.    @Y30LSMK
          DC    H'1'                    PRINT COLUMN NO.       @Y30LSMK
          DC    Y(STE391B-STE391A)      PRINT FIELD LENGTH     @Y30LSMK
          DC    H'0'                    CONVERSION FLAGS(CHAR) @Y30LSMK
* BLOCK DATA SUB-STRUCTURE.                                    @Y30LSMK
          DC    X'9000'                 EOF & BLOCK DATA FLAGS @Y30LSMK
          DC    H'6'                    INPUT DATA LENGTH.     @Y30LSMK
          DC    H'0'                    INPUT DATA OFFSET      @Y30LSMK
          DC    H'36'                   PRINT COLUMN.          @Y30LSMK
          DC    H'6'                    PRINT FIELD LENGTH     @Y30LSMK
          DC    H'0'                    CONVERSION FLAGS(CHAR) @Y30LSMK
* STATIC ENTRY.                                                @Y30LSMK
STE391A   DC    C'IDC2911I ** DATA SET NOT ON VOLUME'          @Y30LSMK
STE391B   EQU *                                                @Y30LSMK
TXT39B    EQU *                                                @Y30LSMK
          EJECT                                                @Y30LSMK
*                                                              @Y30LSMK
* PASSWORD VERIFICATION FAILED MESSAGE.                        @Y30LSMK
*                                                              @Y30LSMK
TXT40     DC    Y(TXT40B-TXT40A)        ENTRY LENGTH.          @Y30LSMK
          DC    X'A000'                 MESSAGE FLAG.          @Y30LSMK
* STATIC TEXT SUB-STRUCTURE.                                   @Y30LSMK
TXT40A    DC    X'8400'                 STATIC TEXT FLAG.      @Y30LSMK
          DC    Y(STE401B-STE401A)      STATIC TEXT LENGTH.    @Y30LSMK
          DC    Y(STE401A-TXT40A)       STATIC TEXT OFFSET.    @Y30LSMK
          DC    H'1'                    PRINT COLUMN.          @Y30LSMK
          DC    Y(STE401B-STE401A)      PRINT FIELD LENGTH.    @Y30LSMK
          DC    H'0'                    CONVERSION FLAGS(CHAR) @Y30LSMK
* STATIC TEXT ENTRY.                                           @Y30LSMK
STE401A   DC  C'IDC2912I ** PASSWORD VERIFICATION FAILED'      @Y30LSMK
STE401B   EQU *                                                @Y30LSMK
TXT40B    EQU *                                                @Y30LSMK
          EJECT                                                @Y30LSMK
*                                                              @Y30LSMK
* NON-EXPIRED DATA SET ON VOLUME MESSAGE.                      @Y30LSMK
*                                                              @Y30LSMK
TXT41     DC    Y(TXT41B-TXT41A)        ENTRY LENGTH.          @Y30LSMK
          DC    X'A000'                 MESSAGE FLAG.          @Y30LSMK
* STATIC TEXT SUB-STRUCTURE.                                   @Y30LSMK
TXT41A    DC    X'0400'                 STATIC TEXT FLAG.      @Y30LSMK
          DC    Y(STE411B-STE411A)      STATIC TEXT LENGTH.    @Y30LSMK
          DC    Y(STE411A-TXT41A)       STATIC TEXT OFFSET.    @Y30LSMK
          DC    H'1'                    PRINT COLUMN NO.       @Y30LSMK
          DC    Y(STE411B-STE411A)      PRINT FIELD LENGTH     @Y30LSMK
          DC    H'0'                    CONVERSION FLAGS(CHAR) @Y30LSMK
* BLOCK DATA SUB-STRUCTURE.                                    @Y30LSMK
          DC    X'9000'                 EOF & BLOCK DATA FLAGS @Y30LSMK
          DC    H'6'                    INPUT DATA LENGTH.     @Y30LSMK
          DC    H'0'                    INPUT DATA OFFSET      @Y30LSMK
          DC    H'48'                   PRINT COLUMN.          @Y30LSMK
          DC    H'6'                    PRINT FIELD LENGTH     @Y30LSMK
          DC    H'0'                    CONVERSION FLAGS(CHAR) @Y30LSMK
* STATIC ENTRY.                                                @Y30LSMK
STE411A   DC    C'IDC2913I ** DATA SET HAS NOT EXPIRED ON '    @Y30LSMK
          DC    C'VOLUME'                                      @Y30LSMK
STE411B   EQU *                                                @Y30LSMK
TXT41B    EQU *                                                @Y30LSMK
          EJECT                                                @Y30LSMK
*                                                              @Y30LSMK
* PERMANENT I/O ERROR ON VOLUME MESSAGE.                       @Y30LSMK
*                                                              @Y30LSMK
TXT42     DC    Y(TXT42B-TXT42A)        ENTRY LENGTH.          @Y30LSMK
          DC    X'A000'                 MESSAGE FLAG.          @Y30LSMK
* STATIC TEXT SUB-STRUCTURE.                                   @Y30LSMK
TXT42A    DC    X'0400'                 STATIC TEXT FLAG.      @Y30LSMK
          DC    Y(STE421B-STE421A)      STATIC TEXT LENGTH.    @Y30LSMK
          DC    Y(STE421A-TXT42A)       STATIC TEXT OFFSET.    @Y30LSMK
          DC    H'1'                    PRINT COLUMN NO.       @Y30LSMK
          DC    Y(STE421B-STE421A)      PRINT FIELD LENGTH     @Y30LSMK
          DC    H'0'                    CONVERSION FLAGS(CHAR) @Y30LSMK
* BLOCK DATA SUB-STRUCTURE.                                    @Y30LSMK
          DC    X'9000'                 EOF & BLOCK DATA FLAGS @Y30LSMK
          DC    H'6'                    INPUT DATA LENGTH.     @Y30LSMK
          DC    H'0'                    INPUT DATA OFFSET      @Y30LSMK
          DC    H'43'                   PRINT COLUMN.          @Y30LSMK
          DC    H'6'                    PRINT FIELD LENGTH     @Y30LSMK
          DC    H'0'                    CONVERSION FLAGS(CHAR) @Y30LSMK
* STATIC ENTRY.                                                @Y30LSMK
STE421A   DC    C'IDC2914I ** PERMANENT I/O ERROR ON VOLUME'   @Y30LSMK
STE421B   EQU *                                                @Y30LSMK
TXT42B    EQU *                                                @Y30LSMK
          EJECT                                                @Y30LSMK
*                                                              @Y30LSMK
* UNABLE TO MOUNT VOLUME MESSAGE.                              @Y30LSMK
*                                                              @Y30LSMK
TXT43     DC    Y(TXT43B-TXT43A)        ENTRY LENGTH.          @Y30LSMK
          DC    X'A000'                 MESSAGE FLAG.          @Y30LSMK
* STATIC TEXT SUB-STRUCTURE.                                   @Y30LSMK
TXT43A    DC    X'0400'                 STATIC TEXT FLAG.      @Y30LSMK
          DC    Y(STE431B-STE431A)      STATIC TEXT LENGTH.    @Y30LSMK
          DC    Y(STE431A-TXT43A)       STATIC TEXT OFFSET.    @Y30LSMK
          DC    H'1'                    PRINT COLUMN NO.       @Y30LSMK
          DC    Y(STE431B-STE431A)      PRINT FIELD LENGTH     @Y30LSMK
          DC    H'0'                    CONVERSION FLAGS(CHAR) @Y30LSMK
* BLOCK DATA SUB-STRUCTURE.                                    @Y30LSMK
          DC    X'9000'                 EOF & BLOCK DATA FLAGS @Y30LSMK
          DC    H'6'                    INPUT DATA LENGTH.     @Y30LSMK
          DC    H'0'                    INPUT DATA OFFSET      @Y30LSMK
          DC    H'36'                   PRINT COLUMN.          @Y30LSMK
          DC    H'6'                    PRINT FIELD LENGTH     @Y30LSMK
          DC    H'0'                    CONVERSION FLAGS(CHAR) @Y30LSMK
* STATIC ENTRY.                                                @Y30LSMK
STE431A   DC    C'IDC2915I ** UNABLE TO MOUNT VOLUME'          @Y30LSMK
STE431B   EQU *                                                @Y30LSMK
TXT43B    EQU *                                                @Y30LSMK
          EJECT                                                @Y30SSFY
*                                                              @Y30SSFY
* RECORD SIZE GREATER THAN 32767                               @Y30SSFY
*                                                              @Y30SSFY
TXT44     DC    Y(TXT44B-TXT44A)        ENTRY LENGTH.          @Y30SSFY
FLG44B    DC    X'A000'                 MESSAGE FLAG.          @Y30SSFY
* STATIC TEXT SUB-STRUCTURE.                                   @Y30SSFY
TXT44A    DC    X'8400'                 STATIC SUB-STRUCTURE FLAG.
          DC    Y(STE441B-STE441A)      STATIC TEXT LENGTH.    @Y30SSFY
          DC    Y(STE441A-TXT44A)       STATIC TEXT OFFSET.    @Y30SSFY
          DC    H'1'                    PRINT COLUMN.          @Y30SSFY
          DC    Y(STE441B-STE441A)      PRINT FIELD LENGTH.    @Y30SSFY
          DC    H'0'                    CONVERSION FLAGS. (EBCDIC)
* STATIC TEXT ENTRY.                                           @Y30SSFY
STE441A   DC  C'IDC3315I ** RECORD SIZE GREATER THAN 32760 NOT SUPPORTE*
               D'                                              @OZ26756
STE441B   EQU *                                                @Y30SSFY
TXT44B    EQU *                                                @Y30SSFY
         EJECT                                                 @Y30SSFY
*                                                              @Y30SSFY
* INCORRECT BLOCK-SIZE SPECIFIED FOR IMPORTRA                  @Y30SSFY
*                                                              @Y30SSFY
TXT45     DC  Y(TXT45B-TXT45A)          ENTRY LENGTH.          @Y30SSFY
FLG45A    DC  X'A000'                   MESSAGE FLAG.          @Y30SSFY
* STATIC TEXT SUB-STRUCTURE.                                   @Y30SSFY
TXT45A    DC  X'8400'                   EOF & STATIC FLAGS.    @Y30SSFY
          DC  Y(STE451B-STE451A)        STATIC TEXT LENGTH.    @Y30SSFY
          DC  Y(STE451A-TXT45A)         STATIC TEXT OFFSET.    @Y30SSFY
          DC  H'1'                      PRINT COLUMN.          @Y30SSFY
          DC  Y(STE451B-STE451A)        OUTPUT LENGTH.         @Y30SSFY
          DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* STATIC TEXT ENTRY.                                           @Y30SSFY
STE451A  DC  C'IDC3325I ** INCORRECT BLOCK-SIZE SPECIFIED FOR IMPORTRA'
STE451B  EQU *                                                 @Y30SSFY
TXT45B   EQU *                                                 @Y30SSFY
         EJECT                                                 @Y30SSFY
*                                                              @Y30SSFY
* CANNOT REPLACE THROUGH PATH                                  @Y30SSFY
*                                                              @Y30SSFY
TXT46     DC  Y(TXT46B-TXT46A)          ENTRY LENGTH.          @Y30SSFY
FLG46A    DC  X'A000'                   MESSAGE FLAG.          @Y30SSFY
* STATIC TEXT SUB-STRUCTURE.                                   @Y30SSFY
TXT46A    DC  X'8400'                   EOF & STATIC FLAGS.    @Y30SSFY
          DC  Y(STE461B-STE461A)        STATIC TEXT LENGTH.    @Y30SSFY
          DC  Y(STE461A-TXT46A)         STATIC TEXT OFFSET.    @Y30SSFY
          DC  H'1'                      PRINT COLUMN.          @Y30SSFY
          DC  Y(STE461B-STE461A)        OUTPUT LENGTH.         @Y30SSFY
          DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* STATIC TEXT ENTRY.                                           @Y30SSFY
STE461A  DC  C'IDC3326I ** REPLACE INVALID FOR OUTPUT THROUGH A PATH'
STE461B  EQU *                                                 @Y30SSFY
TXT46B   EQU *                                                 @Y30SSFY
         EJECT                                                 @Y30SSFY
*                                                              @Y30SSFY
* DUPLICATE RECORD IN UPGRADE SET                              @Y30SSFY
*                                                              @Y30SSFY
TXT47    DC  Y(TXT47B-TXT47A)          ENTRY LENGTH.           @Y30SSFY
         DC  X'A000'                   MESSAGE FLAG.           @Y30SSFY
* STATIC TEXT SUB-STRUCTURE.                                   @Y30SSFY
TXT47A   DC  X'0400'                   STATIC TEXT FLAG.       @Y30SSFY
         DC  Y(STE471B-STE471A)        TEXT LENGTH.            @Y30SSFY
         DC  Y(STE471A-TXT47A)         TEXT OFFSET.            @Y30SSFY
         DC  H'1'                      PRINT COLUMN.           @Y30SSFY
         DC  Y(STE471B-STE471A)        PRINT FIELD LENGTH.     @Y30SSFY
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* BLOCK DATA SUB-STRUCTURE.                                    @Y30SSFY
         DC  X'9000'                   EOF & BLOCK FLAGS.      @Y30SSFY
         DC  H'5'                      INPUT LENGTH.           @Y30SSFY
         DC  H'0'                      INPUT OFFSET.           @Y30SSFY
         DC  H'59'                     PRINT COLUMN.           @Y30SSFY
         DC  H'10'                     PRINT FIELD LENGTH.     @Y30SSFY
         DC  X'4000'                   CONVERSION FLAGS.  (BHA)
* STATIC TEXT ENTRIES.                                         @Y30SSFY
STE471A  DC  C'IDC3327I ** DUPLICATE RECORD IN UPGRADE SET - BASE RECOR*
               D'                                              @Y30SSFY
STE471B  EQU *                                                 @Y30SSFY
TXT47B   EQU *                                                 @Y30SSFY
          EJECT                                                @Y30SSFY
*                                                              @Z30LSBS
* DATA SET WAS IN USE MESSAGE.                                 @Z30LSBS
*                                                              @Z30LSBS
TXT48     DC    Y(TXT48B-TXT48A)        ENTRY LENGTH.          @Z30LSBS
          DC    X'A000'                 MESSAGE FLAG.          @Z30LSBS
* STATIC TEXT SUB-STRUCTURE.                                   @Z30LSBS
TXT48A    DC    X'8400'                 STATIC TEXT FLAG.      @Z30LSBS
          DC    Y(STE481B-STE481A)      STATIC TEXT LENGTH.    @Z30LSBS
          DC    Y(STE481A-TXT48A)       STATIC TEXT OFFSET.    @Z30LSBS
          DC    H'1'                    PRINT COLUMN NO.       @Z30LSBS
          DC    Y(STE481B-STE481A)      PRINT FIELD LENGTH     @Z30LSBS
          DC    H'0'                    CONVERSION FLAGS(CHAR) @Z30LSBS
* STATIC ENTRY.                                                @Z30LSBS
STE481A   DC    C'IDC2916I ** DATA SET WAS IN USE'             @Z30LSBS
STE481B   EQU *                                                @Z30LSBS
TXT48B    EQU *                                                @Z30LSBS
          EJECT                                                @Z30LSBS
          END
