* /* START OF SPECIFICATIONS ****                            @Y30LSMK
*
*01* MODULE-NAME = IDCTSLC0
*01* MODULE-TYPE = MODULE
*02*   PROCESSOR = ASSEMBLER
*
**** END OF SPECIFICATIONS **                                @Y30LSMK*/
         TITLE '***** IDCTSLC0 - LIST CATALOG STATIC TEXT *****'
**********************************************************************
*                                                                    *
* MODULE NAME - IDCTSLC0 - STATIC TEXT MODULE FOR LIST CATALOG       *
*                                                                    *
* DESCRIPTIVE NAME - STATIC TEXT MODULE FOR THE FUNCTION LIST        *
*          CATALOG                                                   *
*                                                                    *
* COPYRIGHT - NONE                                                   *
*                                                                    *
* STATUS - RELEASE 3  LEVEL 0                                        *
*                                                                    *
* FUNCTION - CONTAINS NO EXECUTABLE CODE, ONLY STATIC TEXT ENTRIES   *
*        FOR THE FUNCTION LIST CATALOG                               *
*        THIS MODULE IS LOADED BY IDCTP05 WHEN A STATIC TEXT         *
*        REQUEST IS MADE.                                            *
*                                                                    *
* NOTES - NONE                                                       *
*                                                                    *
*    DEPENDENCIES - NONE                                             *
*    RESTRICTIONS - NONE                                             *
*    REGISTER CONVENTIONS - NA                                       *
*    PATCH AREA - NA                                                 *
*                                                                    *
* MODULE TYPE - TABLES                                               *
*                                                                    *
*    PROCESSOR - ASSEMBLER                                           *
*    MODULE SIZE - 8830                                      @Z40WSMK*
*    ATTRIBUTES - READ-ONLY                                          *
*                                                                    *
*  ENTRY POINT - NA                                                  *
*                                                                    *
*  EXIT NORMAL - NA                                                  *
*                                                                    *
*  EXIT ERROR - NA                                                   *
*                                                                    *
*  EXTERNAL REFERENCES - NA                                          *
*                                                                    *
*  TABLES - NA                                                       *
*                                                                    *
*  MACROS - NA                                                       *
*                                                                    *
**********************************************************************
*
**********************************************************************
*                                                                    *
* THIS MODULE IS THE FIRST MODULE OF STATIC TEXT REQUIRED BY THE     *
* LIST CATALOG FUNCTIONAL SERVICE ROUTINE.                           *
*                                                                    *
**********************************************************************
*                                                                    *
IDCTSLC0 CSECT
*
**********************************************************************
*                                                                    *
* THIS SECTION CONTAINS THE INDICES TO REACH AN ENTRY.
*
INDEX    DC  H'60'                     COUNT OF ENTRIES.       @Y30SSMK
INDEX1   DC  Y(TXT1-INDEX)             FIRST INDEX ENTRY
INDEX2   DC  Y(TXT2-INDEX)
INDEX3   DC  Y(TXT3-INDEX)
INDEX4   DC  Y(TXT4-INDEX)
INDEX5   DC  Y(TXT5-INDEX)
INDEX6   DC  Y(TXT6-INDEX)
INDEX7   DC  Y(TXT7-INDEX)
INDEX8   DC  Y(TXT8-INDEX)
INDEX9   DC  Y(TXT9-INDEX)                                     @Y30SSMK
INDEX10  DC  Y(TXT10-INDEX)
INDEX11  DC  Y(TXT11-INDEX)
INDEX12  DC  Y(TXT12-INDEX)
INDEX13  DC  Y(TXT13-INDEX)
INDEX14  DC  Y(TXT14-INDEX)
INDEX15  DC  Y(TXT15-INDEX)
INDEX16  DC  Y(TXT16-INDEX)
INDEX17  DC  Y(TXT17-INDEX)
INDEX18  DC  Y(TXT18-INDEX)
INDEX19  DC  Y(TXT19-INDEX)
INDEX20  DC  Y(TXT20-INDEX)
INDEX21  DC  Y(TXT21-INDEX)
INDEX22  DC  Y(TXT22-INDEX)
INDEX23  DC  H'-1'                                             @ZA05939
INDEX24  DC  Y(TXT24-INDEX)
INDEX25  DC  Y(TXT25-INDEX)
INDEX26  DC  Y(TXT26-INDEX)
INDEX27  DC  Y(TXT27-INDEX)
INDEX28  DC  Y(TXT28-INDEX)
INDEX29  DC  Y(TXT29-INDEX)
INDEX30  DC  Y(TXT30-INDEX)
INDEX31  DC  Y(TXT31-INDEX)
INDEX32  DC  Y(TXT32-INDEX)
INDEX33  DC  Y(TXT33-INDEX)
INDEX34  DC  Y(TXT34-INDEX)
INDEX35  DC  Y(TXT35-INDEX)
INDEX36  DC  Y(TXT36-INDEX)
INDEX37  DC  Y(TXT37-INDEX)
INDEX38  DC  Y(TXT38-INDEX)
INDEX39  DC  Y(TXT39-INDEX)                                    @YL026UE
INDEX40  DC  Y(TXT40-INDEX)                                    @YL026UE
INDEX41  DC  Y(TXT41-INDEX)                                    @YL026UE
INDEX42  DC  Y(TXT42-INDEX)                                    @YL026UE
INDEX43  DC  Y(TXT43-INDEX)                                    @YL026UE
INDEX44  DC  Y(TXT44-INDEX)                                    @YL026UE
INDEX45  DC  Y(TXT45-INDEX)                                    @YL026UE
INDEX46  DC  Y(TXT46-INDEX)                                    @Y30SSMK
INDEX47  DC  Y(TXT47-INDEX)                                    @Y30SSMK
INDEX48  DC  Y(TXT48-INDEX)                                    @Y30SSMK
INDEX49  DC  Y(TXT49-INDEX)                                    @Y30SSMK
INDEX50  DC  Y(TXT50-INDEX)                                    @Y30SSMK
INDEX51  DC  Y(TXT51-INDEX)                                    @Y30SSMK
INDEX52  DC  Y(TXT52-INDEX)                                    @Y30SSMK
INDEX53  DC  Y(TXT53-INDEX)                                    @Y30SSMK
INDEX54  DC  H'-1'                                             @ZA05939
INDEX55  DC  H'-1'                                             @ZA05939
INDEX56  DC  Y(TXT56-INDEX)                                    @Y30SSMK
INDEX57  DC  Y(TXT57-INDEX)                                    @ZA01484
INDEX58  DC  Y(TXT58-INDEX)                                    @Y30SSMK
INDEX59  DC  Y(TXT59-INDEX)                                    @Y30SSMK
INDEX60  DC  Y(TXT60-INDEX)            LAST INDEX ENTRY        @Y30SSMK
         EJECT
**********************************************************************
*                                                                    *
* THIS SECTION CONTAINS THE ENTRIES.                                 *
*                                                                    *
**********************************************************************
*
TXT1     DC  Y(TXT1B-TXT1A)            ENTRY LENGTH.
         DC  H'0'                      FLAG FIELD.
* STATIC TEXT SUB-STRUCTURE.
TXT1A    DC  X'8400'                   STATIC FLAG.
         DC  Y(STE11B-STE11A)          STATIC TEXT LENGTH.
         DC  Y(STE11A-TXT1A)           STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE11B-STE11A)          PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* STATIC TEXT ENTRY.
STE11A   DC  C'PRIME     CANDIDATE OVERFLOW  AUTOMATIC EXPLICIT  '
         DC  C'DATA      INDEX     CLUSTER   SPEED     RECOVERY  '
         DC  C'UNIQUE    SUBALLOC  ERASE     NOERASE   INDEXED   '
         DC  C'NONINDEXEDWRITECHECKNOWRITECHKIMBED     NOIMBED   '
         DC  C'REPLICATE NOREPLICATORDERED   UNORDERED RECORD    '
         DC  C'TRACK     CYLINDER  (SUPP)    (NULL)    INH-UPDATE'
         DC  C'TEMP-EXP  USERCAT   MASTERCAT SHROPTNS  ( , )     '
         DC  C'1         2         3         4         TRKOVFL   '
         DC  C'NOTRKOVFL SCRATCH   NOSCRATCH EMPTY     NOEMPTY   '
         DC  C'NONVSAM   GDG       ALIAS     PGSPC     NUMBERED  '
         DC  C'REUSE     NOREUSE   PATH      SPANNED   NONSPANNED'
         DC  C'AIX       UPGRADE   NOUPGRADE UPDATE    NOUPDATE  '
         DC  C'UNIQUEKEY NONUNIQKEYRECVABLE  NOTUSABLE CYLFAULT  '
         DC  C'BIND      DSTGWAIT  SWAP      NOSWAP    (YES)     '
         DC  C'(NO)      '                                     @Z40RSSA
STE11B   EQU *
TXT1B    EQU *
         EJECT
*
* LIST CATALOG SUB-TITLE LINE.
*
TXT2     DC  Y(TXT2B-TXT2A)            ENTRY LENGTH.
         DC  H'0'                      FLAGS.
* STATIC TEXT SUB-STRUCTURE.
TXT2A    DC  X'0400'                   STATIC TEXT ID FLAG.
         DC  Y(STE21B-STE21A)          STATIC TEXT LENGTH.
         DC  Y(STE21A-TXT2A)           STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE21B-STE21A)          PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC TEXT ID FLAG.
         DC  Y(STE22B-STE22A)          STATIC TEXT LENGTH.
         DC  Y(STE22A-TXT2A)           STATIC TEXT OFFSET.
         DC  H'31'                     PRINT COLUMN.
         DC  Y(STE22B-STE22A)          PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* INSERT DATA SUB-STRUCTURE.
         DC  X'A000'                   INSERT DATA FLAG.
         DC  H'10'                     INSERT REF NO.
         DC  H'0'                      UNUSED.
         DC  H'55'                     PRINT COLUMN.
         DC  H'44'                     PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* STATIC TEXT ENTRY.
STE21A   DC  C'-'
STE21B   EQU *
STE22A   DC  C'LISTING FROM CATALOG --'
STE22B   EQU *
TXT2B    EQU *
         EJECT
*
* ALIEN ENTRY HEADING.
*
TXT3     DC  Y(TXT3B-TXT3A)            ENTRY LENGTH.
         DC  X'0000'                   FLAGS.
* SPACING CONTROL SUB-STRUCTURE.
TXT3A    DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
         DC  H'2'                      SPACING FACTOR.
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC TEXT FLAG.
         DC  Y(STE31B-STE31A)          STATIC TEXT LENGTH.
         DC  Y(STE31A-TXT3A)           STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE31B-STE31A)          PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* BLOCK DATA SUB-STRUCTURE.
         DC  X'9000'                   INSERT DATA FLAG.
         DC  H'44'                     INPUT LENGTH.
         DC  H'0'                      INPUT OFFSET
         DC  H'17'                     PRINT COLUMN.           @ZA05939
         DC  H'44'                     PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* STATIC TEXT ENTRY.
STE31A   DC  C'NONVSAM ------- '                               @ZA05939
STE31B   EQU *
TXT3B    EQU *
         EJECT
*
* USERCATALOG ENTRY HEADER.
*
TXT4     DC  Y(TXT4B-TXT4A)            ENTRY LENGTH.
         DC  X'0000'                   FLAGS.
* SPACING CONTROL SUB-STRUCTURE.
TXT4A    DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
         DC  H'2'                      SPACING FACTOR.
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC TEXT FLAG.
         DC  Y(STE41B-STE41A)          STATIC TEXT LENGTH.
         DC  Y(STE41A-TXT4A)           STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE41B-STE41A)          PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* BLOCK DATA SUB-STRUCTURE.
         DC  X'9000'                   INSERT DATA FLAG.
         DC  H'44'                     INPUT LENGTH.
         DC  H'0'                      INPUT OFFSET
         DC  H'17'                     PRINT COLUMN.           @ZA05939
         DC  H'44'                     PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* STATIC TEXT ENTRY.
STE41A   DC  C'USERCATALOG --- '                               @ZA05939
STE41B   EQU *
TXT4B    EQU *
         EJECT
*
* VOLUME ENTRY HEADER.
*
TXT5     DC  Y(TXT5B-TXT5A)            ENTRY LENGTH.
         DC  X'0000'                   FLAGS .
* SPACING CONTROL SUB-STRUCTURE.
TXT5A    DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
         DC  H'2'                      SPACING FACTOR.
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC TEXT FLAG.
         DC  Y(STE51B-STE51A)          STATIC TEXT LENGTH.
         DC  Y(STE51A-TXT5A)           STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE51B-STE51A)          PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* BLOCK DATA SUB-STRUCTURE.
         DC  X'9000'                   INSERT DATA FLAG.
         DC  H'44'                     INPUT LENGTH.
         DC  H'0'                      INPUT OFFSET
         DC  H'17'                     PRINT COLUMN.           @ZA05939
         DC  H'44'                     PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* STATIC TEXT ENTRY.
STE51A   DC  C'VOLUME -------- '                               @ZA05939
STE51B   EQU *
TXT5B    EQU *
         EJECT
*
* CLUSTER ENTRY HEADER
*
TXT6     DC  Y(TXT6B-TXT6A)            ENTRY LENGTH.
         DC  X'0000'                   FLAGS.
* SPACING CONTROL SUB-STRUCTURE.
TXT6A    DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
         DC  H'2'                      SPACING FACTOR.
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC TEXT FLAG.
         DC  Y(STE61B-STE61A)          STATIC TEXT LENGTH.
         DC  Y(STE61A-TXT6A)           STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE61B-STE61A)          PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* BLOCK DATA SUB-STRUCTURE.
         DC  X'9000'                   INSERT DATA FLAG.
         DC  H'44'                     INPUT LENGTH.
         DC  H'0'                      INPUT OFFSET
         DC  H'17'                     PRINT COLUMN.           @ZA05939
         DC  H'44'                     PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* STATIC TEXT ENTRY.
STE61A   DC  C'CLUSTER ------- '                               @ZA05939
STE61B   EQU *
TXT6B    EQU *
         EJECT
*
* DATA ENTRY HEADER.
*
TXT7     DC  Y(TXT7B-TXT7A)            ENTRY LENGTH.
         DC  X'0000'                   FLAGS.
* SPACING CONTROL SUB-STRUCTURE.
TXT7A    DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
         DC  H'2'                      SPACING FACTOR.
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC TEXT FLAG.
         DC  Y(STE71B-STE71A)          STATIC TEXT LENGTH.
         DC  Y(STE71A-TXT7A)           STATIC TEXT OFFSET.
         DC  H'4'                      PRINT COLUMN.
         DC  Y(STE71B-STE71A)          PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* BLOCK DATA SUB-STRUCTURE.
         DC  X'9000'                   INSERT DATA FLAG.
         DC  H'44'                     INPUT LENGTH.
         DC  H'0'                      INPUT OFFSET
         DC  H'17'                     PRINT COLUMN.           @ZA05939
         DC  H'44'                     PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* STATIC TEXT ENTRY.
STE71A   DC  C'DATA ------- '                                  @ZA05939
STE71B   EQU *
TXT7B    EQU *
         EJECT
*
* INDEX ENTRY HEADER.
*
TXT8     DC  Y(TXT8B-TXT8A)            ENTRY LENGTH.
         DC  X'0000'                   FLAGS.
* SPACING CONTROL SUB-STRUCTURE.
TXT8A    DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
         DC  H'2'                      SPACING FACTOR.
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC TEXT FLAG.
         DC  Y(STE81B-STE81A)          STATIC TEXT LENGTH.
         DC  Y(STE81A-TXT8A)           STATIC TEXT OFFSET.
         DC  H'4'                      PRINT COLUMN.
         DC  Y(STE81B-STE81A)          PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* BLOCK DATA SUB-STRUCTURE.
         DC  X'9000'                   INSERT DATA FLAG.
         DC  H'44'                     INPUT LENGTH.
         DC  H'0'                      INPUT OFFSET
         DC  H'17'                     PRINT COLUMN.           @ZA05939
         DC  H'44'                     PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* STATIC TEXT ENTRY.
STE81A   DC  C'INDEX ------ '                                  @ZA05939
STE81B   EQU *
TXT8B    EQU *
         EJECT
*                                                              @Y30SSMK
* PATH ENTRY HEADER.                                           @Y30SSMK
*                                                              @Y30SSMK
TXT9     DC  Y(TXT9B-TXT9A)            ENTRY LENGTH.           @Y30SSMK
         DC  X'0000'                   FLAGS.                  @Y30SSMK
* SPACING CONTROL SUB-STRUCTURE.                               @Y30SSMK
TXT9A    DC  X'4000'                   SPACE SUB-STRUCTURE FLG @Y30SSMK
         DC  H'2'                      SPACING FACTOR.         @Y30SSMK
         DC  C'R '                     SPACING TYPE.           @Y30SSMK
* STATIC TEXT SUB-STRUCTURE.                                   @Y30SSMK
         DC  X'0400'                   STATIC TEXT FLAG.       @Y30SSMK
         DC  Y(STE91B-STE91A)          STATIC TEXT LENGTH.     @Y30SSMK
         DC  Y(STE91A-TXT9A)           STATIC TEXT OFFSET.     @Y30SSMK
         DC  H'4'                      PRINT COLUMN.           @Y30SSMK
         DC  Y(STE91B-STE91A)          PRINT FIELD LENGTH.     @Y30SSMK
         DC  H'0'                      CONVERSION FLAGS (CHAR) @Y30SSMK
* BLOCK DATA SUB-STRUCTURE.                                    @Y30SSMK
         DC  X'9000'                   INSERT DATA FLAG.       @Y30SSMK
         DC  H'44'                     INPUT LENGTH.           @Y30SSMK
         DC  H'0'                      INPUT OFFSET            @Y30SSMK
         DC  H'17'                     PRINT COLUMN.           @ZA05939
         DC  H'44'                     PRINT FIELD LENGTH.     @Y30SSMK
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* STATIC TEXT ENTRY.                                           @Y30SSMK
STE91A   DC  C'PATH ------- '                                  @ZA05939
STE91B   EQU *                                                 @Y30SSMK
TXT9B    EQU *                                                 @Y30SSMK
         EJECT
*
* VOLSER DEVTYPE FILE-NO HEADER AND DATA LINES.                @ZA05939
*
TXT10    DC  Y(TXT10B-TXT10A)          ENTRY LENGTH.
         DC  X'0000'                   HEADER FLAG.
* SPACE CONTROL SUB-STRUCTURE.
TXT10A   DC  X'4000'                   SPACE CONTROL FLAGS.
         DC  H'1'                      SPACING FACTOR.
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   SPACE CONTROL FLAG.     @ZA05939
         DC  Y(STE101B-STE101A)        TEXT LENGTH.
         DC  Y(STE101A-TXT10A)         TEXT OFFSET.
         DC  H'8'                      PRINT COLUMN.           @ZA05939
         DC  Y(STE101B-STE101A)        PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* BLOCK DATA SUB-STRUCTURE.                                    @ZA05939
         DC  X'1000'                   BLOCK DATA FLAG.        @ZA05939
         DC  H'6'                      INPUT LENGTH.           @ZA05939
         DC  H'6'                      INPUT OFFSET.           @ZA05939
         DC  H'26'                     PRINT COLUMN.           @ZA05939
         DC  H'6'                      PRINT FIELD LENGTH.     @ZA05939
         DC  X'0008'                   CONV FLAGS.  (CHAR,AR)  @ZA05939
* BLOCK DATA SUB-STRUCTURE.                                    @ZA05939
         DC  X'1000'                   BLOCK FLAGS.            @ZA05939
         DC  H'4'                      INPUT LENGTH.           @ZA05939
         DC  H'2'                      INPUT OFFSET.           @ZA05939
         DC  H'50'                     PRINT COLUMN.           @ZA05939
         DC  H'8'                      PRINT FIELD LENGTH.     @ZA05939
         DC  X'4000'                   CONVERSION FLAGS.  (BHA)
* INSERT DATA SUB-STRUCTURE.                                   @ZA05939
         DC  X'A000'                   INSERT & EOF FLAG.      @ZA05939
         DC  H'10'                     REFERENCE NUMBER.       @ZA05939
         DC  H'0'                      UNUSED.                 @ZA05939
         DC  H'85'                     PRINT COLUMN.           @ZA05939
         DC  H'5'                      PRINT FIELD LENGTH.     @ZA05939
         DC  X'10A0'                   CONV FLAGS.  (BD,ZS,SS) @ZA05939
* STATIC TEXT ENTRIES.
STE101A  DC  C'VOLSER------------------     DEVTYPE-----------------'
         DC  C'     FSEQN-------------------'                  @ZA05939
STE101B  EQU *
TXT10B   EQU *
         EJECT
*
* VOLSER DEVTYPE VOLFLAG HEADER AND DATA LINE.                 @ZA05939
*
TXT11    DC  Y(TXT11B-TXT11A)          ENTRY LENGTH.
         DC  X'0000'                   2ND OF 2 HEADER LINES.
* SPACE CONTROL SUB-STRUCTURE.
TXT11A   DC  X'4000'                   SPACE CONTROL FLAG.
         DC  H'1'                      SPACING FACTOR.
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC TEXT FLAG.       @ZA05939
         DC  Y(STE111B-STE111A)        STATIC TEXT LENGTH.
         DC  Y(STE111A-TXT11A)         STATIC TEXT OFFSET.
         DC  H'8'                      PRINT COLUMN.           @ZA05939
         DC  Y(STE111B-STE111A)        PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* BLOCK DATA SUB-STRUCTURE.                                    @ZA05939
         DC  X'1000'                   BLOCK DATA FLAG.        @ZA05939
         DC  H'6'                      INPUT LENGTH.           @ZA05939
         DC  H'6'                      INPUT OFFSET.           @ZA05939
         DC  H'26'                     PRINT COLUMN.           @ZA05939
         DC  H'6'                      PRINT FIELD LENGTH.     @ZA05939
         DC  X'0008'                   CONV FLAGS.  (CHAR,AR)  @ZA05939
* BLOCK DATA SUB-STRUCTURE.                                    @ZA05939
         DC  X'1000'                   BLOCK FLAGS.            @ZA05939
         DC  H'4'                      INPUT LENGTH.           @ZA05939
         DC  H'2'                      INPUT OFFSET.           @ZA05939
         DC  H'50'                     PRINT COLUMN.           @ZA05939
         DC  H'8'                      PRINT FIELD LENGTH.     @ZA05939
         DC  X'4000'                   CONVERSION FLAGS.  (BHA)
* INSERT DATA SUB-STRUCTURE.                                   @ZA05939
         DC  X'A000'                   INSERT & EOF FLAG.      @ZA05939
         DC  H'10'                     REFERENCE NUMBER.       @ZA05939
         DC  H'0'                      UNUSED.                 @ZA05939
         DC  H'80'                     PRINT COLUMN.           @ZA05939
         DC  H'10'                     PRINT FIELD LENGTH.     @ZA05939
         DC  X'0008'                   CONV FLAGS.  (CHAR,AR)  @ZA05939
* STATIC TEXT ENTRY.
STE111A  DC  C'VOLSER------------------     DEVTYPE-----------------'
         DC  C'     VOLFLAG-----------------'                  @ZA05939
STE111B  EQU *
TXT11B   EQU *
         EJECT
*
* VOLSER, DEVTYPE, HEADER AND DATA LINES.                      @ZA05939
*
TXT12    DC  Y(TXT12B-TXT12A)          ENTRY LENGTH.
         DC  H'0'                      FLAGS.
* SPACE CONTROL SUB-STRUCTURE.                                 @ZA05939
TXT12A   DC  X'4000'                   SPACE CONTROL FLAG.     @ZA05939
         DC  H'1'                      SPACING FACTOR.         @ZA05939
         DC  C'R '                     SPACING TYPE.           @ZA05939
* STATIC TEXT SUB-STRUCTURE.                                   @ZA05939
         DC  X'0400'                   STATIC TEXT FLAG.       @ZA05939
         DC  Y(STE121B-STE121A)        STATIC TEXT LENGTH.     @ZA05939
         DC  Y(STE121A-TXT12A)         STATIC TEXT OFFSET.     @ZA05939
         DC  H'8'                      PRINT COLUMN.           @ZA05939
         DC  Y(STE121B-STE121A)        PRINT FIELD LENGTH.     @ZA05939
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* INSERT DATA SUB-STRUCTURE.
         DC  X'2000'                   INSERT DATA FLAG.       @ZA05939
         DC  H'10'                     INSERT REF NO.
         DC  H'0'                      UNUSED.
         DC  H'26'                     PRINT COLUMN.           @ZA05939
         DC  H'6'                      PRINT FIELD LENGTH.     @ZA05939
         DC  X'0008'                   CONV FLAGS.  (CHAR,AR)  @ZA05939
* INSERT DATA SUB-STRUCTURE.
         DC  X'A000'                   INSERT FLAG.            @ZA05939
         DC  H'20'                     REFERENCE NUMBER.
         DC  H'0'                      UNUSED.
         DC  H'50'                     PRINT COLUMN.           @ZA05939
         DC  H'8'                      PRINT FIELD LENGTH.     @ZA05939
         DC  X'4000'                   CONVERSION FLAGS.  (BHA)
* STATIC TEXT ENTRY.                                           @ZA05939
STE121A  DC  C'VOLSER------------------     DEVTYPE-----------------'
STE121B  EQU *                                                 @ZA05939
TXT12B   EQU *
         EJECT
*
* OWNER ID, CREATION,  EXPIRATION, AND RELEASE  ENTRY HEADER 2 @Y30SSMK
* AND DATA LINES.                                              @Y30SSMK
*
TXT13    DC  Y(TXT13B-TXT13A)          ENTRY LENGTH.
         DC  X'0000'                   HEADER FLAG.
* SPACING SUB-STRUCTURE.
TXT13A   DC  X'4000'                   SPACE FLAG.
         DC  H'1'                      SPACING FLAG.
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.                                   @Y30LSMK
         DC  X'0400'                   STATIC FLAG.            @Y30LSMK
         DC  Y(STE133B-STE133A)        STATIC TEXT LENGTH.     @Y30LSMK
         DC  Y(STE133A-TXT13A)         STATIC TEXT OFFSET.     @Y30LSMK
         DC  H'6'                      PRINT COLUMN.           @ZA05939
         DC  Y(STE133B-STE133A)        PRINT FIELD LENGTH.     @Y30LSMK
         DC  H'0'                      CONVERSION FLAGS (CHAR) @Y30LSMK
* SPACE CONTROL SUB-STRUCTURE.                                 @Y30LSMK
         DC  X'4000'                   SPACE FLAG.             @Y30LSMK
         DC  H'1'                      SPACING FACTOR.         @Y30LSMK
         DC  C'R '                     SPACING TYPE.           @Y30LSMK
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC FLAG.
         DC  Y(STE131B-STE131A)        STATIC TEXT LENGTH.
         DC  Y(STE131A-TXT13A)         STATIC TEXT OFFSET.
         DC  H'8'                      PRINT COLUMN.           @ZA05939
         DC  Y(STE131B-STE131A)        PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* INSERT DATA SUB-STRUCTURE.
         DC  X'2000'                   INSERT FLAG.
         DC  H'10'                     REFERENCE NUMBER.
         DC  H'0'                      UNUSED.
         DC  H'24'                     PRINT COLUMN.           @ZA05939
         DC  H'8'                      PRINT FIELD LENGTH.
         DC  X'0008'                   CONV FLAGS.  (CHAR,AR)  @ZA05939
* INSERT DATA SUB-STRUCTURE.
         DC  X'2000'                   INSERT FLAG.
         DC  H'20'                     REFERENCE NUMBER.
         DC  H'0'                      UNUSED.
         DC  H'55'                     PRINT COLUMN.           @ZA05939
         DC  H'5'                      PRINT FIELD LENGTH.
         DC  X'0820'                   CONVERSION FLAGS.  (PU,SS)
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC TEXT FLAGS.
         DC  Y(STE132B-STE132A)        TEXT LENGTH.
         DC  Y(STE132A-TXT13A)         TEXT OFFSET.
         DC  H'57'                     PRINT COLUMN.           @ZA05939
         DC  Y(STE132B-STE132A)        PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* INSERT DATA SUB-STRUCTURE.
         DC  X'2000'                   INSERT FLAG.
         DC  H'20'                     REFERENCE NUMBER.
         DC  H'0'                      UNUSED.
         DC  H'58'                     PRINT COLUMN.           @ZA05939
         DC  H'3'                      PRINT FIELD LENGTH.
         DC  X'0820'                   CONVERSION FLAGS.  (PU,SS)
* SPACE CONTROL SUB-STRUCTURE.                                 @ZA05939
         DC  X'4000'                   SPACE FLAG.             @ZA05939
         DC  H'1'                      SPACING FACTOR.         @ZA05939
         DC  C'R '                     SPACING TYPE.           @ZA05939
* STATIC TEXT SUB-STRUCTURE.                                   @ZA05939
         DC  X'0400'                   STATIC FLAG.            @ZA05939
         DC  Y(STE134B-STE134A)        STATIC TEXT LENGTH.     @ZA05939
         DC  Y(STE134A-TXT13A)         STATIC TEXT OFFSET.     @ZA05939
         DC  H'8'                      PRINT COLUMN.           @ZA05939
         DC  Y(STE134B-STE134A)        PRINT FIELD LENGTH.     @ZA05939
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* BLOCK DATA SUB-STRUCTURE.                                    @ZA05939
         DC  X'1000'                   BLOCK FLAG.             @ZA05939
         DC  H'1'                      INPUT LENGTH.           @ZA05939
         DC  H'0'                      INPUT OFFSET.           @ZA05939
         DC  H'30'                     PRINT COLUMN.           @ZA05939
         DC  H'2'                      PRINT FIELD LENGTH.     @ZA05939
         DC  X'10A0'                   CNVRSN FLGS (BD,ZS,SS)  @ZA05939
* INSERT DATA SUB-STRUCTURE.
         DC  X'2000'                   INSERT FLAG.
         DC  H'30'                     REFERENCE NUMBER.
         DC  H'0'                      UNUSED.
         DC  H'55'                     PRINT COLUMN.           @ZA05939
         DC  H'5'                      PRINT FIELD LENGTH.
         DC  X'0820'                   CONVERSION FLAGS.  (PU,SS)
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC TEXT FLAGS.
         DC  Y(STE132B-STE132A)        TEXT LENGTH.
         DC  Y(STE132A-TXT13A)         TEXT OFFSET.
         DC  H'57'                     PRINT COLUMN.           @ZA05939
         DC  Y(STE132B-STE132A)        PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* INSERT DATA SUB-STRUCTURE.
         DC  X'A000'                   INSERT FLAG.            @ZA05939
         DC  H'30'                     REFERENCE NUMBER.
         DC  H'0'                      UNUSED.
         DC  H'58'                     PRINT COLUMN.           @ZA05939
         DC  H'3'                      PRINT FIELD LENGTH.
         DC  X'0820'                   CONVERSION FLAGS.  (PU,SS)
* STATIC TEXT ENTRY.
STE131A  DC  C'OWNER-IDENT-------------     CREATION----------------'
STE131B  EQU *                                                 @ZA05939
STE132A  DC  C'.'
STE132B  EQU *
STE133A  DC  C'HISTORY'                                        @Y30LSMK
STE133B  EQU *                                                 @Y30LSMK
STE134A  DC  C'RELEASE-----------------     EXPIRATION--------------'
STE134B  EQU *                                                 @ZA05939
TXT13B   EQU *
         EJECT
*
* PROTECTION (NON-INITIALIZED OR SUPPRESSED) HEADER AND DATA LINES.
*
TXT14    DC  Y(TXT14B-TXT14A)          ENTRY LENGTH.
         DC  X'0000'                   2ND OF 2 HEADER LINE.
* SPACE CONTROL SUB-STRUCTURE.
TXT14A   DC  X'4000'                   SPACE FLAG.
         DC  H'1'                      SPACING FACTOR.
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC FLAG.
         DC  Y(STE141B-STE141A)        STATIC TEXT LENGTH.
         DC  Y(STE141A-TXT14A)         STATIC TEXT OFFSET.
         DC  H'6'                      PRINT COLUMN.           @ZA05939
         DC  Y(STE141B-STE141A)        PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS  (CHAR)
* INSERT DATA SUB-STRUCTURE FOR (YES) OR (NO)                  @Z40RSSA
         DC  X'2000'                   EOF AND INSERT FLAGS.   @Z40RSSA
         DC  H'10'                     INSERT REF NO.          @Z40RSSA
         DC  H'0'                      UNUSED.                 @Z40RSSA
         DC  H'51'                     PRINT COLUMN.           @Z40RSSA
         DC  H'10'                     PRINT FIELD LENGTH.     @Z40RSSA
         DC  X'0008'                   CONV FLAGS. (CHAR,AR)   @Z40RSSA
* INSERT DATA SUB-STRUCTURE FOR (NULL) OR (SUPP)               @Z40RSSA
         DC  X'A000'                   EOF AND INSERT FLAGS.   @Z40RSSA
         DC  H'20'                     INSERT REF NO.          @Z40RSSA
         DC  H'0'                      UNUSED.                 @Z40RSSA
         DC  H'22'                     PRINT COLUMN.           @Z40RSSA
         DC  H'10'                     PRINT FIELD LENGTH.     @Z40RSSA
         DC  X'0008'                   CONV FLAGS. (CHAR,AR)   @Z40RSSA
* STATIC TEXT ENTRY.                                           @Z40RSSA
STE141A  DC C'PROTECTION-PSWD-----------     RACF--------------------' *
                                                               @Z40RSRC
STE141B  EQU *
TXT14B   EQU *
         EJECT
*
* PROTECTION (INITIALIZED) HEADER AND DATA LINE.               @ZA05939
*
TXT15    DC  Y(TXT15B-TXT15A)          ENTRY LENGTH.
         DC  H'0'                      FLAGS.
* STATIC TEXT SUB-STRUCTURE.
TXT15A   DC  X'0400'                   STATIC FLAG.
         DC  Y(STE151B-STE151A)        STATIC TEXT LENGTH.
         DC  Y(STE151A-TXT15A)         STATIC TEXT OFFSET.
         DC  H'6'                      PRINT COLUMN.           @ZA05939
         DC  Y(STE151B-STE151A)        PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* SPACE CONTROL SUB-STRUCTURE.
         DC  X'4000'                   SPACE CONTROL FLAG.
         DC  H'1'                      SPACING FACTOR
         DC  C'R '                     SPACING TYPE
* STATIC TEXT SUB-STRUCTURE.                                   @ZA05939
         DC  X'0400'                   STATIC FLAG.            @ZA05939
         DC  Y(STE152B-STE152A)        STATIC TEXT LENGTH.     @ZA05939
         DC  Y(STE152A-TXT15A)         STATIC TEXT OFFSET.     @ZA05939
         DC  H'8'                      PRINT COLUMN.           @ZA05939
         DC  Y(STE152B-STE152A)        PRINT FIELD LENGTH.     @ZA05939
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* BLOCK DATA SUB-STRUCTURE.
         DC  X'1000'                   BLOCK FLAG.
         DC  H'8'                      INPUT LENGTH.
         DC  H'0'                      INPUT OFFSET.
         DC  H'24'                     PRINT COLUMN.           @ZA05939
         DC  H'8'                      OUTPUT LENGTH.
         DC  X'0008'                   CONV FLAGS.  (CHAR,AR)  @ZA05939
* BLOCK DATA SUB-STRUCTURE.
         DC  X'1000'                   BLOCK FLAG.
         DC  H'8'                      INPUT LENGTH.
         DC  H'16'                     INPUT OFFSET.           @ZA05939
         DC  H'53'                     PRINT COLUMN.           @ZA05939
         DC  H'8'                      OUTPUT LENGTH.
         DC  X'0008'                   CONV FLAGS.  (CHAR,AR)  @ZA05939
* BLOCK DATA SUB-STRUCTURE.
         DC  X'1000'                   BLOCK FLAG.
         DC  H'8'                      INPUT LENGTH.
         DC  H'32'                     INPUT OFFSET.           @ZA05939
         DC  H'82'                     PRINT COLUMN.           @ZA05939
         DC  H'8'                      OUTPUT LENGTH.
         DC  X'0008'                   CONV FLAGS.  (CHAR,AR)  @ZA05939
*  INSERT DATA SUB-STRUCTURE.                                  @Z40RSSA
         DC  X'2000'                   INSERT FLAG             @Z40RSSA
         DC  H'10'                     INSERT REF NO.          @Z40RSSA
         DC  H'0'                      UNUSED.                 @Z40RSSA
         DC  H'109'                    PRINT COLUMN            @Z40RSSA
         DC  H'10'                     PRINT FIELD LENGTH.     @Z40RSSA
         DC  X'0008'                   CONV FLAGS  (CHAR,AR)   @Z40RSSA
* SPACE CONTROL SUB-STRUCTURE.                                 @ZA05939
         DC  X'4000'                   SPACE CONTROL FLAG.     @ZA05939
         DC  H'1'                      SPACING FACTOR          @ZA05939
         DC  C'R '                     SPACING TYPE            @ZA05939
* STATIC TEXT SUB-STRUCTURE.                                   @ZA05939
         DC  X'0400'                   STATIC FLAG.            @ZA05939
         DC  Y(STE153B-STE153A)        STATIC TEXT LENGTH.     @ZA05939
         DC  Y(STE153A-TXT15A)         STATIC TEXT OFFSET.     @ZA05939
         DC  H'8'                      PRINT COLUMN.           @ZA05939
         DC  Y(STE153B-STE153A)        PRINT FIELD LENGTH.     @ZA05939
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* BLOCK DATA SUB-STRUCTURE.
         DC  X'1000'                   BLOCK FLAG.
         DC  H'8'                      INPUT LENGTH.
         DC  H'8'                      INPUT OFFSET.           @ZA05939
         DC  H'24'                     PRINT COLUMN.           @ZA05939
         DC  H'8'                      OUTPUT LENGTH.
         DC  X'0008'                   CONV FLAGS.  (CHAR,AR)  @ZA05939
* BLOCK DATA SUB-STRUCTURE.
         DC  X'1000'                   BLOCK FLAG.
         DC  H'8'                      INPUT LENGTH.
         DC  H'24'                     INPUT OFFSET.           @ZA05939
         DC  H'53'                     PRINT COLUMN.           @ZA05939
         DC  H'8'                      OUTPUT LENGTH.
         DC  X'0008'                   CONV FLAGS.  (CHAR,AR)  @ZA05939
* BLOCK DATA SUB-STRUCTURE.
         DC  X'1000'                   BLOCK FLAG.
         DC  H'2'                      INPUT LENGTH.
         DC  H'40'                     INPUT OFFSET.
         DC  H'89'                     PRINT COLUMN.           @ZA05939
         DC  H'1'                      OUTPUT LENGTH.
         DC  X'10A0'                   CONVERSION FLAGS.  (BD,ZS,SS)
* BLOCK DATA SUB-STRUCTURE.
         DC  X'9000'                   BLOCK FLAG.
         DC  H'8'                      INPUT LENGTH.
         DC  H'42'                     INPUT OFFSET.
         DC  H'111'                    PRINT COLUMN.           @ZA05939
         DC  H'8'                      OUTPUT LENGTH.
         DC  X'0008'                   CONV FLAGS.  (CHAR,AR)  @ZA05939
* STATIC TEXT ENTRY.
STE151A  DC  C'PROTECTION'                                     @ZA05939
STE151B  EQU *
STE152A  DC  C'MASTERPW----------------     UPDATEPW----------------'
         DC  C'     CODE--------------------     RACF----------------'
STE152B  EQU *                                                 @ZA05939
         DC  C'----'                                           @Z40RSSA
STE153A  DC  C'CONTROLPW---------------     READPW------------------'
         DC  C'     ATTEMPTS----------------     USVR----------------'
         DC  C'----'                                           @ZA05939
STE153B  EQU *                                                 @ZA05939
TXT15B   EQU *
         EJECT
*
* USER AUTHORIZATION RECORD HEADER AND DATA.
*
TXT16    DC  Y(TXT16B-TXT16A)          ENTRY LENGTH.
         DC  X'0000'                   FLAGS.
* SPACE CONTROL SUB-STRUCTURE.
TXT16A   DC  X'4000'                   SPACE FLAG.
         DC  H'1'                      SPACING FACTOR.
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC FLAG.
         DC  Y(STE161B-STE161A)        STATIC TEXT LENGTH.
         DC  Y(STE161A-TXT16A)         STATIC TEXT OFFSET.
         DC  H'8'                      PRINT COLUMN.           @ZA05939
         DC  Y(STE161B-STE161A)        PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* INSERT DATA SUB-STRUCTURE.
         DC  X'2000'                   INSERT FLAG.
         DC  H'10'                     INSERT REF NO.
         DC  H'0'                      UNUSED.
         DC  H'26'                     PRINT COLUMN.           @ZA05939
         DC  H'255'                    MAX PRINT LENGTH.
         DC  H'0'                      CONVERSION FLAGS  (CHAR)
* DEFAULT DATA SUB-STRUCTURE.
         DC  X'8200'                   DEFAULT FLAG.
         DC  Y(STE162B-STE162A)        STATIC TEXT LENGTH.
         DC  Y(STE162A-TXT16A)         STATIC TEXT OFFSET.
         DC  H'26'                     PRINT COLUMN.           @ZA05939
         DC  Y(STE162B-STE162A)        PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* STATIC TEXT ENTRIES.
STE161A  DC  C'USAR--------------'                             @ZA05939
STE161B  EQU *
STE162A  DC  C'(NONE)'
STE162B  EQU *
TXT16B   EQU *
         EJECT
*
* NULL ASSOCIATIONS HEADER LINE.                               @ZA05939
*
TXT17    DC  Y(TXT17B-TXT17A)          ENTRY LENGTH.
         DC  X'0000'                   HEADER FLAG.
* SPACE CONTROL SUB-STRUCTURE.
TXT17A   DC  X'4000'                   SPACE FLAG.
         DC  H'1'                      SPACING FACTOR.
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC FLAG.
         DC  Y(STE171B-STE171A)        STATIC TEXT LENGTH.
         DC  Y(STE171A-TXT17A)         STATIC TEXT OFFSET.
         DC  H'6'                      PRINT COLUMN.           @ZA05939
         DC  Y(STE171B-STE171A)        PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* INSERT DATA SUB-STRUCTURE.                                   @YL026UE
         DC  X'A000'                   EOF AND INSERT FLAGS.   @YL026UE
         DC  H'10'                     INSERT REF NO.          @YL026UE
         DC  H'0'                      UNUSED.                 @YL026UE
         DC  H'22'                     PRINT COLUMN.           @ZA05939
         DC  H'10'                     PRINT FIELD LENGTH.     @ZA05939
         DC  X'0008'                   CONV FLAGS.  (CHAR,AR)  @ZA05939
* STATIC TEXT ENTRIES.
STE171A  DC  C'ASSOCIATIONS--------------'                     @ZA05939
STE171B  EQU *
TXT17B   EQU *
         EJECT
*
* ASSOCIATIONS DATA LINE.
*
TXT18    DC  Y(TXT18B-TXT18A)          ENTRY LENGTH.
         DC  H'0'                      FLAGS.
* INSERT DATA SUB-STRUCTURE.
TXT18A   DC  X'2000'                   INSERT FLAG.
         DC  H'10'                     REFNO
         DC  H'0'                      UNUSED.
         DC  H'8'                      PRINT COLUMN.           @ZA05939
         DC  H'10'                     PRINT FIELD LENGTH.     @ZA05939
         DC  H'0'                      CONVERSION FLAGS  (CHAR)
* STATIC TEXT SUB-STRUCTURE.                                   @ZA05939
         DC  X'0400'                   STATIC FLAG.            @ZA05939
         DC  Y(STE181B-STE181A)        STATIC TEXT LENGTH.     @ZA05939
         DC  Y(STE181A-TXT18A)         STATIC TEXT OFFSET.     @ZA05939
         DC  H'0'                      PRINT COLUMN.           @ZA05939
         DC  Y(STE181B-STE181A)        PRINT FIELD LENGTH.     @ZA05939
         DC  X'0010'                   CONV FLAGS.  (CHAR,BS)  @ZA05939
* INSERT DATA SUB-STRUCTURE.
         DC  X'A000'                   EOF AND INSERT FLAGS.
         DC  H'20'                     INSERT REF NO.
         DC  H'0'                      UNUSED.
         DC  H'17'                     PRINT COLUMN.           @ZA05939
         DC  H'44'                     PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* STATIC TEXT ENTRIES.                                         @ZA05939
STE181A  DC  C'---------'                                      @ZA05939
STE181B  EQU *                                                 @ZA05939
TXT18B   EQU *
         EJECT
*
* ATTRIBUTES HEADING AND DATA LINES.                           @Y30LSMK
*
TXT19    DC  Y(TXT19B-TXT19A)          ENTRY LENGTH.
         DC  X'0000'                   HEADER FLAG.
* SPACE CONTROL SUB-STRUCTURE.
TXT19A   DC  X'4000'                   SPACE FLAG.
         DC  H'1'                      SPACING FACTOR.
         DC  C'R '                     SPACING TYPE.
* INSERT DATA SUB-STRUCTURE.
         DC  X'2000'                   INSERT FLAG.
         DC  H'10'                     INSERT REF NO.
         DC  H'0'                      UNUSED.
         DC  H'8'                      PRINT COLUMN.           @ZA05939
         DC  H'10'                     PRINT FIELD LENGTH.     @ZA05939
         DC  H'0'                      CONVERSION FLAGS.
* INSERT DATA SUB-STRUCTURE.                                   @ZA05939
         DC  X'2000'                   INSERT FLAG.            @ZA05939
         DC  H'20'                     INSERT REF NO.          @ZA05939
         DC  H'0'                      UNUSED.                 @ZA05939
         DC  H'16'                     PRINT COLUMN.           @ZA05939
         DC  H'10'                     PRINT FIELD LENGTH.     @ZA05939
         DC  H'0'                      CONVERSION FLAGS.       @ZA05939
* INSERT DATA SUB-STRUCTURE.
         DC  X'2000'                   INSERT FLAG.
         DC  H'30'                     INSERT REF NO.          @ZA05939
         DC  H'0'                      UNUSED.
         DC  H'17'                     PRINT COLUMN.           @ZA05939
         DC  H'1'                      PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.
* INSERT DATA SUB-STRUCTURE.
         DC  X'2000'                   INSERT FLAG.
         DC  H'40'                     INSERT REF NO.          @ZA05939
         DC  H'0'                      UNUSED.
         DC  H'19'                     PRINT COLUMN.           @ZA05939
         DC  H'1'                      PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.
* INSERT DATA SUB-STRUCTURE.
         DC  X'2000'                   INSERT FLAG.
         DC  H'50'                     INSERT REF NO.          @ZA05939
         DC  H'0'                      UNUSED.
         DC  H'22'                     PRINT COLUMN.           @ZA05939
         DC  H'10'                     PRINT FIELD LENGTH.     @ZA05939
         DC  X'0008'                   CONV FLAGS. (CHAR,AR)   @ZA05939
* INSERT DATA SUB-STRUCTURE.
         DC  X'2000'                   INSERT FLAG.
         DC  H'60'                     INSERT REF NO.          @ZA05939
         DC  H'0'                      UNUSED.
         DC  H'37'                     PRINT COLUMN.           @ZA05939
         DC  H'10'                     PRINT FIELD LENGTH.     @ZA05939
         DC  H'0'                      CONVERSION FLAGS.
* INSERT DATA SUB-STRUCTURE.
         DC  X'2000'                   INSERT FLAG.
         DC  H'70'                     INSERT REF NO.          @ZA05939
         DC  H'0'                      UNUSED.
         DC  H'51'                     PRINT COLUMN.           @ZA05939
         DC  H'10'                     PRINT FIELD LENGTH.     @ZA05939
         DC  X'0008'                   CONV FLAGS. (CHAR,AR)   @ZA05939
* INSERT DATA SUB-STRUCTURE.
         DC  X'2000'                   INSERT FLAG.
         DC  H'80'                     INSERT REF NO.          @ZA05939
         DC  H'0'                      UNUSED.
         DC  H'66'                     PRINT COLUMN.           @ZA05939
         DC  H'10'                     PRINT FIELD LENGTH.     @ZA05939
         DC  H'0'                      CONVERSION FLAGS.
* INSERT DATA SUB-STRUCTURE.
         DC  X'2000'                   INSERT FLAG.
         DC  H'90'                     INSERT REF NO.          @ZA05939
         DC  H'0'                      UNUSED.
         DC  H'80'                     PRINT COLUMN.           @ZA05939
         DC  H'10'                     PRINT FIELD LENGTH.     @ZA05939
         DC  X'0008'                   CONV FLAGS.  (CHAR,AR)  @ZA05939
* INSERT DATA SUB-STRUCTURE.
         DC  X'2000'                   INSERT FLAG.
         DC  H'100'                    INSERT REF NO.          @ZA05939
         DC  H'0'                      UNUSED.
         DC  H'95'                     PRINT COLUMN.           @ZA05939
         DC  H'10'                     PRINT FIELD LENGTH.     @ZA05939
         DC  H'0'                      CONVERSION FLAGS.
* INSERT DATA SUB-STRUCTURE.
         DC  X'2000'                   INSERT FLAG.
         DC  H'110'                    INSERT REF NO.          @ZA05939
         DC  H'0'                      UNUSED.
         DC  H'109'                    PRINT COLUMN.           @ZA05939
         DC  H'10'                     PRINT FIELD LENGTH.     @ZA05939
         DC  X'0008'                   CONV FLAGS. (CHAR,AR)   @ZA05939
* SPACE CONTROL SUB-STRUCTURE.                                 @ZA05939
         DC  X'4000'                   SPACE FLAG.             @ZA05939
         DC  H'1'                      SPACING FACTOR.         @ZA05939
         DC  C'R '                     SPACING TYPE.           @ZA05939
* INSERT DATA SUB-STRUCTURE.
         DC  X'2000'                   INSERT FLAG.
         DC  H'120'                    INSERT REF NO.          @ZA05939
         DC  H'0'                      UNUSED.
         DC  H'8'                      PRINT COLUMN.           @ZA05939
         DC  H'10'                     PRINT FIELD LENGTH.     @ZA05939
         DC  H'0'                      CONVERSION FLAGS.
* INSERT DATA SUB-STRUCTURE.
         DC  X'2000'                   INSERT FLAG.
         DC  H'130'                    INSERT REF NO.          @ZA05939
         DC  H'0'                      UNUSED.
         DC  H'22'                     PRINT COLUMN.           @ZA05939
         DC  H'10'                     PRINT FIELD LENGTH.     @ZA05939
         DC  X'0008'                   CONV FLAGS.  (CHAR,AR)  @ZA05939
* INSERT DATA SUB-STRUCTURE.
         DC  X'2000'                   INSERT FLAG.            @Y30LSMK
         DC  H'140'                    INSERT REF NO.          @ZA05939
         DC  H'0'                      UNUSED.
         DC  H'37'                     PRINT COLUMN.           @ZA05939
         DC  H'10'                     PRINT FIELD LENGTH.     @ZA05939
         DC  H'0'                      CONVERSION FLAGS.
* INSERT DATA SUB-STRUCTURE.                                   @Y30SSMK
         DC  X'2000'                   INSERT FLAG.            @Y30SSMK
         DC  H'150'                    INSERT REF NO.          @ZA05939
         DC  H'0'                      UNUSED.                 @Y30SSMK
         DC  H'51'                     PRINT COLUMN.           @ZA05939
         DC  H'10'                     PRINT FIELD LENGTH.     @ZA05939
         DC  X'0008'                   CONV FLAGS.  (CHAR,AR)  @ZA05939
* INSERT DATA SUB-STRUCTURE.                                   @Y30SSMK
         DC  X'2000'                   INSERT FLAG.            @Y30SSMK
         DC  H'160'                    INSERT REF NO.          @ZA05939
         DC  H'0'                      UNUSED.                 @Y30SSMK
         DC  H'66'                     PRINT COLUMN.           @ZA05939
         DC  H'10'                     PRINT FIELD LENGTH.     @ZA05939
         DC  H'0'                      CONVERSION FLAGS.       @Y30SSMK
* INSERT DATA SUB-STRUCTURE.                                   @Y30SSMK
         DC  X'2000'                   INSERT FLAG.            @Y30SSMK
         DC  H'170'                    INSERT REF NO.          @ZA05939
         DC  H'0'                      UNUSED.                 @Y30SSMK
         DC  H'80'                     PRINT COLUMN.           @ZA05939
         DC  H'10'                     PRINT FIELD LENGTH.     @ZA05939
         DC  X'0008'                   CONV FLAGS.  (CHAR,AR)  @ZA05939
* INSERT DATA SUB-STRUCTURE.                                   @Y30SSMK
         DC  X'2000'                   INSERT FLAG.            @Y30SSMK
         DC  H'180'                    INSERT REF NO.          @ZA05939
         DC  H'0'                      UNUSED.                 @Y30SSMK
         DC  H'95'                     PRINT COLUMN.           @ZA05939
         DC  H'10'                     PRINT FIELD LENGTH.     @ZA05939
         DC  H'0'                      CONVERSION FLAGS.       @Y30SSMK
* INSERT DATA SUB-STRUCTURE.                                   @Y30SSMK
         DC  X'2000'                   INSERT FLAG.            @Y30SSMK
         DC  H'190'                    INSERT REF NO.          @ZA05939
         DC  H'0'                      UNUSED.                 @Y30SSMK
         DC  H'109'                    PRINT COLUMN.           @ZA05939
         DC  H'10'                     PRINT FIELD LENGTH.     @ZA05939
         DC  X'0008'                   CONV FLAGS.  (CHAR,AR)  @ZA05939
* SPACE CONTROL SUB-STRUCTURE.                                 @ZA05939
         DC  X'4000'                   SPACE FLAG.             @ZA05939
         DC  H'1'                      SPACING FACTOR.         @ZA05939
         DC  C'R '                     SPACING TYPE.           @ZA05939
* INSERT DATA SUB-STRUCTURE.                                   @Y30LSMK
         DC  X'2000'                   INSERT FLAG.            @Y30LSMK
         DC  H'200'                    INSERT REF NO.          @ZA05939
         DC  H'0'                      UNUSED.                 @Y30LSMK
         DC  H'8'                      PRINT COLUMN.           @ZA05939
         DC  H'10'                     PRINT FIELD LENGTH.     @ZA05939
         DC  H'0'                      CONVERSION FLAGS.       @Y30LSMK
* INSERT DATA SUB-STRUCTURE.                                   @Y30LSMK
         DC  X'2000'                   INSERT FLAG.            @Y30LSMK
         DC  H'210'                    INSERT REF NO.          @ZA05939
         DC  H'0'                      UNUSED.                 @Y30LSMK
         DC  H'22'                     PRINT COLUMN.           @ZA05939
         DC  H'10'                     PRINT FIELD LENGTH.     @ZA05939
         DC  X'0008'                   CONV FLAGS.  (CHAR,AR)  @ZA05939
* INSERT DATA SUB-STRUCTURE.                                   @Y30LSMK
         DC  X'2000'                   INSERT FLAG.            @Z40WSMK
         DC  H'220'                    INSERT REF NO.          @ZA05939
         DC  H'0'                      UNUSED.                 @Y30LSMK
         DC  H'37'                     PRINT COLUMN.           @ZA05939
         DC  H'10'                     PRINT FIELD LENGTH.     @ZA05939
         DC  H'0'                      CONVERSION FLAGS.       @Y30LSMK
* INSERT DATA SUB-STRUCTURE.                                   @Z40WSMK
         DC  X'A000'                   INSERT FLAG.            @Z40WSMK
         DC  H'230'                    INSERT REF NO.          @Z40WSMK
         DC  H'0'                      UNUSED.                 @Z40WSMK
         DC  H'51'                     PRINT COLUMN.           @Z40WSMK
         DC  H'10'                     PRINT FIELD LENGTH.     @Z40WSMK
         DC  X'0008'                   CONV FLAGS. (CHAR,AR)   @Z40WSMK
* STATIC TEXT ENTRIES.
TXT19B   EQU *
         EJECT
*
* DATA SET CHARACTERISTICS HEADER AND DATA LINE.
*
TXT20    DC  Y(TXT20B-TXT20A)          ENTRY LENGTH.
         DC  X'0000'                   HEADER FLAG.
* SPACING CONTROL SUB-STRUCTURE.
TXT20A   DC  X'4000'                   SPACE FLAG.
         DC  H'1'                      SPACING FACTOR.
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC FLAG.
         DC  Y(STE201B-STE201A)        STATIC TEXT LENGTH.
         DC  Y(STE201A-TXT20A)         STATIC TEXT OFFSET.
         DC  H'6'                      PRINT COLUMN.           @ZA05939
         DC  Y(STE201B-STE201A)        PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* SPACE CONTROL SUB-STRUCTURE.
         DC  X'4000'                   SPACE CONTROL FLAG
         DC  H'1'                      SPACING FACTOR
         DC  C'R '                     SPACING TYPE
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC FLAG.
         DC  Y(STE202B-STE202A)        STATIC TEXT LENGTH.
         DC  Y(STE202A-TXT20A)         STATIC TEXT OFFSET.
         DC  H'8'                      PRINT COLUMN.           @ZA05939
         DC  Y(STE202B-STE202A)        PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* BLOCK DATA SUB-STRUCTURE.                                    @ZA05939
         DC  X'1000'                   BLOCK FLAG.             @ZA05939
         DC  H'2'                      INPUT LENGTH.           @ZA05939
         DC  H'8'                      INPUT OFFSET.           @ZA05939
         DC  H'29'                     PRINT COLUMN.           @ZA05939
         DC  H'3'                      PRINT FIELD LENGTH.     @ZA05939
         DC  X'10A0'                   CONVERSION FLAGS.  (BD,ZS,SS)
* INSERT DATA SUB-STRUCTURE.                                   @ZA05939
         DC  X'2000'                   INSERT FLAG.            @ZA05939
         DC  H'10'                     INSERT REF NO.          @ZA05939
         DC  H'0'                      UNUSED.                 @ZA05939
         DC  H'51'                     PRINT COLUMN.           @ZA05939
         DC  H'10'                     PRINT FIELD LENGTH.     @ZA05939
         DC  X'10A0'                   CONVERSION FLAGS.  (BD,ZS,SS)
* INSERT DATA SUB-STRUCTURE.                                   @ZA05939
         DC  X'2000'                   INSERT FLAG.            @ZA05939
         DC  H'20'                     INSERT REF NO.          @ZA05939
         DC  H'0'                      UNUSED.                 @ZA05939
         DC  H'80'                     PRINT COLUMN.           @ZA05939
         DC  H'10'                     PRINT FIELD LENGTH.     @ZA05939
         DC  X'10A0'                   CONVERSION FLAGS.  (BD,ZS,SS)
* BLOCK DATA SUB-STRUCTURE.                                    @ZA05939
         DC  X'1000'                   BLOCK FLAG.             @ZA05939
         DC  H'4'                      INPUT LENGTH.           @ZA05939
         DC  H'20'                     INPUT OFFSET.           @ZA05939
         DC  H'109'                    PRINT COLUMN.           @ZA05939
         DC  H'10'                     PRINT FIELD LENGTH.     @ZA05939
         DC  X'10A0'                   CONVERSION FLAGS.  (BD,ZS,SS)
* SPACING CONTROL SUB-STRUCTURE.
         DC  X'4000'                   SPACE FLAG.
         DC  H'1'                      SPACING FACTOR.
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.                                   @ZA05939
         DC  X'0400'                   STATIC FLAG.            @ZA05939
         DC  Y(STE203B-STE203A)        STATIC TEXT LENGTH.     @ZA05939
         DC  Y(STE203A-TXT20A)         STATIC TEXT OFFSET.     @ZA05939
         DC  H'8'                      PRINT COLUMN.           @ZA05939
         DC  Y(STE203B-STE203A)        PRINT FIELD LENGTH.     @ZA05939
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* BLOCK DATA SUB-STRUCTURE.
         DC  X'1000'                   BLOCK FLAG.
         DC  H'2'                      INPUT LENGTH.
         DC  H'6'                      INPUT OFFSET.           @ZA05939
         DC  H'27'                     PRINT COLUMN.           @ZA05939
         DC  H'5'                      PRINT FIELD LENGTH.     @ZA05939
         DC  X'10A0'                   CONVERSION FLAGS.  (BD,ZS,SS)
* BLOCK DATA SUB-STRUCTURE.
         DC  X'1000'                   BLOCK FLAG.
         DC  H'4'                      INPUT LENGTH.
         DC  H'24'                     INPUT OFFSET.
         DC  H'51'                     PRINT COLUMN.           @ZA05939
         DC  H'10'                     PRINT FIELD LENGTH.
         DC  X'10A0'                   CONVERSION FLAGS.  (BD,ZS,SS)
* INSERT DATA SUB-STRUCTURE.                                   @ZA05939
         DC  X'2000'                   INSERT FLAG.            @ZA05939
         DC  H'30'                     INSERT REF NO.          @ZA05939
         DC  H'0'                      UNUSED.                 @ZA05939
         DC  H'82'                     PRINT COLUMN.           @ZA05939
         DC  H'8'                      PRINT FIELD LENGTH.     @ZA05939
         DC  X'0008'                   CONV FLAGS (CHAR,AR)    @ZA05939
* BLOCK DATA SUB-STRUCTURE.
         DC  X'9000'                   BLOCK FLAG.             @ZA05939
         DC  H'2'                      INPUT LENGTH.
         DC  H'12'                     INPUT OFFSET.
         DC  H'114'                    PRINT COLUMN.           @ZA05939
         DC  H'5'                      PRINT FIELD LENGTH.
         DC  X'10A0'                   CONVERSION FLAGS.  (BD,ZS,SS)
* STATIC TEXT ENTRIES.
STE201A  DC  C'ATTRIBUTES'
STE201B  EQU *
STE202A  DC  C'KEYLEN------------------     AVGLRECL----------------'
         DC  C'     BUFSPACE----------------     CISIZE--------------'
         DC  C'----'                                           @ZA05939
STE202B  EQU *
STE203A  DC  C'RKP---------------------     MAXLRECL----------------'
         DC  C'     EXCPEXIT----------------     CI/CA---------------'
         DC  C'----'                                           @ZA05939
STE203B  EQU *                                                 @ZA05939
TXT20B   EQU *
         EJECT
*
* DATA ENTRY STATISTICS HEADER AND DATA LINES.                 @ZA05939
*
TXT21    DC  Y(TXT21B-TXT21A)          ENTRY LENGTH.
         DC  X'0000'                   HEADER FLAG.
* SPACING CONTROL SUB-STRUCTURE.
TXT21A   DC  X'4000'                   SPACE FLAG.
         DC  H'1'                      SPACING FACTOR.
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC FLAG.
         DC  Y(STE211B-STE211A)        STATIC TEXT LENGTH.
         DC  Y(STE211A-TXT21A)         STATIC TEXT OFFSET.
         DC  H'6'                      PRINT COLUMN.           @ZA05939
         DC  Y(STE211B-STE211A)        PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* SPACING CONTROL SUB-STRUCTURE.
         DC  X'4000'                   SPACE FLAG.
         DC  H'1'                      SPACING FACTOR.
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC FLAG.
         DC  Y(STE212B-STE212A)        STATIC TEXT LENGTH.
         DC  Y(STE212A-TXT21A)         STATIC TEXT OFFSET.
         DC  H'8'                      PRINT COLUMN.           @ZA05939
         DC  Y(STE212B-STE212A)        PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* BLOCK DATA SUB-STRUCTURE.                                    @ZA05939
         DC  X'1000'                   BLOCK FLAG.             @ZA05939
         DC  H'4'                      INPUT LENGTH.           @ZA05939
         DC  H'60'                     INPUT OFFSET.           @ZA05939
         DC  H'22'                     PRINT COLUMN.           @ZA05939
         DC  H'10'                     PRINT FIELD LENGTH.     @ZA05939
         DC  X'10A0'                   CONVERSION FLAGS  (BD,ZS,SS)
* BLOCK DATA SUB-STRUCTURE.                                    @ZA05939
         DC  X'1000'                   BLOCK FLAG.             @ZA05939
         DC  H'4'                      INPUT LENGTH.           @ZA05939
         DC  H'84'                     INPUT OFFSET.           @ZA05939
         DC  H'51'                     PRINT COLUMN.           @ZA05939
         DC  H'10'                     PRINT FIELD LENGTH.     @ZA05939
         DC  X'10A0'                   CONVERSION FLAGS  (BD,ZS,SS)
* BLOCK DATA SUB-STRUCTURE.                                    @ZA05939
         DC  X'1000'                   BLOCK FLAG.             @ZA05939
         DC  H'4'                      INPUT LENGTH.           @ZA05939
         DC  H'92'                     INPUT OFFSET.           @ZA05939
         DC  H'80'                     PRINT COLUMN.           @ZA05939
         DC  H'10'                     PRINT FIELD LENGTH.     @ZA05939
         DC  X'10A0'                   CONVERSION FLAGS  (BD,ZS,SS)
* SPACING CONTROL SUB-STRUCTURE.
         DC  X'4000'                   SPACE FLAG.
         DC  H'1'                      SPACING FACTOR.
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.                                   @ZA05939
         DC  X'0400'                   STATIC FLAG.            @ZA05939
         DC  Y(STE213B-STE213A)        STATIC TEXT LENGTH.     @ZA05939
         DC  Y(STE213A-TXT21A)         STATIC TEXT OFFSET.     @ZA05939
         DC  H'8'                      PRINT COLUMN.           @ZA05939
         DC  Y(STE213B-STE213A)        PRINT FIELD LENGTH.     @ZA05939
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* BLOCK DATA SUB-STRUCTURE.                                    @ZA05939
         DC  X'1000'                   BLOCK FLAG.             @ZA05939
         DC  H'4'                      INPUT LENGTH.           @ZA05939
         DC  H'64'                     INPUT OFFSET.           @ZA05939
         DC  H'22'                     PRINT COLUMN.           @ZA05939
         DC  H'10'                     PRINT FIELD LENGTH.     @ZA05939
         DC  X'10A0'                   CONVERSION FLAGS  (BD,ZS,SS)
* BLOCK DATA SUB-STRUCTURE.                                    @ZA05939
         DC  X'1000'                   BLOCK FLAG.             @ZA05939
         DC  H'4'                      INPUT LENGTH.           @ZA05939
         DC  H'88'                     INPUT OFFSET.           @ZA05939
         DC  H'51'                     PRINT COLUMN.           @ZA05939
         DC  H'10'                     PRINT FIELD LENGTH.     @ZA05939
         DC  X'10A0'                   CONVERSION FLAGS  (BD,ZS,SS)
* BLOCK DATA SUB-STRUCTURE.                                    @ZA05939
         DC  X'1000'                   BLOCK FLAG.             @ZA05939
         DC  H'2'                      INPUT LENGTH.           @ZA05939
         DC  H'58'                     INPUT OFFSET.           @ZA05939
         DC  H'85'                     PRINT COLUMN.           @ZA05939
         DC  H'5'                      PRINT FIELD LENGTH.     @ZA05939
         DC  X'10A0'                   CONVERSION FLAGS  (BD,ZS,SS)
* SPACING CONTROL SUB-STRUCTURE.                               @ZA05939
         DC  X'4000'                   SPACE FLAG.             @ZA05939
         DC  H'1'                      SPACING FACTOR.         @ZA05939
         DC  C'R '                     SPACING TYPE.           @ZA05939
* STATIC TEXT SUB-STRUCTURE.                                   @ZA05939
         DC  X'0400'                   STATIC FLAG.            @ZA05939
         DC  Y(STE214B-STE214A)        STATIC TEXT LENGTH.     @ZA05939
         DC  Y(STE214A-TXT21A)         STATIC TEXT OFFSET.     @ZA05939
         DC  H'8'                      PRINT COLUMN.           @ZA05939
         DC  Y(STE214B-STE214A)        PRINT FIELD LENGTH.     @ZA05939
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* BLOCK DATA SUB-STRUCTURE.                                    @ZA05939
         DC  X'1000'                   BLOCK FLAG.             @ZA05939
         DC  H'4'                      INPUT LENGTH.           @ZA05939
         DC  H'68'                     INPUT OFFSET.           @ZA05939
         DC  H'22'                     PRINT COLUMN.           @ZA05939
         DC  H'10'                     PRINT FIELD LENGTH.     @ZA05939
         DC  X'10A0'                   CONVERSION FLAGS  (BD,ZS,SS)
* BLOCK DATA SUB-STRUCTURE.                                    @ZA05939
         DC  X'1000'                   BLOCK FLAG.             @ZA05939
         DC  H'1'                      INPUT LENGTH.           @ZA05939
         DC  H'11'                     INPUT OFFSET.           @ZA05939
         DC  H'58'                     PRINT COLUMN.           @ZA05939
         DC  H'3'                      PRINT FIELD LENGTH.     @ZA05939
         DC  X'10A0'                   CONVERSION FLAGS.  (BD,ZS,SS)
* SPACING CONTROL SUB-STRUCTURE.                               @ZA05939
         DC  X'4000'                   SPACE FLAG.             @ZA05939
         DC  H'1'                      SPACING FACTOR.         @ZA05939
         DC  C'R '                     SPACING TYPE.           @ZA05939
* STATIC TEXT SUB-STRUCTURE.                                   @ZA05939
         DC  X'0400'                   STATIC FLAG.            @ZA05939
         DC  Y(STE215B-STE215A)        STATIC TEXT LENGTH.     @ZA05939
         DC  Y(STE215A-TXT21A)         STATIC TEXT OFFSET.     @ZA05939
         DC  H'8'                      PRINT COLUMN.           @ZA05939
         DC  Y(STE215B-STE215A)        PRINT FIELD LENGTH.     @ZA05939
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* BLOCK DATA SUB-STRUCTURE.                                    @ZA05939
         DC  X'1000'                   BLOCK FLAG.             @ZA05939
         DC  H'4'                      INPUT LENGTH.           @ZA05939
         DC  H'72'                     INPUT OFFSET.           @ZA05939
         DC  H'22'                     PRINT COLUMN.           @ZA05939
         DC  H'10'                     PRINT FIELD LENGTH.     @ZA05939
         DC  X'10A0'                   CONVERSION FLAGS  (BD,ZS,SS)
* BLOCK DATA SUB-STRUCTURE.                                    @ZA05939
         DC  X'1000'                   BLOCK FLAG.             @ZA05939
         DC  H'1'                      INPUT LENGTH.           @ZA05939
         DC  H'10'                     INPUT OFFSET.           @ZA05939
         DC  H'58'                     PRINT COLUMN.           @ZA05939
         DC  H'3'                      PRINT FIELD LENGTH.     @ZA05939
         DC  X'10A0'                   CONVERSION FLAGS.  (BD,ZS,SS)
* BLOCK DATA SUB-STRUCTURE.                                    @ZA05939
         DC  X'1000'                   BLOCK FLAG.             @ZA05939
         DC  H'8'                      INPUT LENGTH.           @ZA05939
         DC  H'48'                     INPUT OFFSET.           @ZA05939
         DC  H'71'                     PRINT COLUMN.           @ZA05939
         DC  H'16'                     PRINT FIELD LENGTH.     @ZA05939
         DC  X'4000'                   CONVERSION FLAGS.  (BHA)
* SPACING CONTROL SUB-STRUCTURE.                               @ZA05939
         DC  X'4000'                   SPACE FLAG.             @ZA05939
         DC  H'1'                      SPACING FACTOR.         @ZA05939
         DC  C'R '                     SPACING TYPE.           @ZA05939
* STATIC TEXT SUB-STRUCTURE.                                   @ZA05939
         DC  X'0400'                   STATIC FLAG.            @ZA05939
         DC  Y(STE216B-STE216A)        STATIC TEXT LENGTH.     @ZA05939
         DC  Y(STE216A-TXT21A)         STATIC TEXT OFFSET.     @ZA05939
         DC  H'8'                      PRINT COLUMN.           @ZA05939
         DC  Y(STE216B-STE216A)        PRINT FIELD LENGTH.     @ZA05939
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* BLOCK DATA SUB-STRUCTURE.                                    @ZA05939
         DC  X'1000'                   BLOCK FLAG.             @ZA05939
         DC  H'4'                      INPUT LENGTH.           @ZA05939
         DC  H'76'                     INPUT OFFSET.           @ZA05939
         DC  H'22'                     PRINT COLUMN.           @ZA05939
         DC  H'10'                     PRINT FIELD LENGTH.     @ZA05939
         DC  X'10A0'                   CONVERSION FLAGS  (BD,ZS,SS)
* BLOCK DATA SUB-STRUCTURE.                                    @ZA05939
         DC  X'9000'                   BLOCK FLAG.             @ZA05939
         DC  H'4'                      INPUT LENGTH.           @ZA05939
         DC  H'80'                     INPUT OFFSET.           @ZA05939
         DC  H'51'                     PRINT COLUMN.           @ZA05939
         DC  H'10'                     PRINT FIELD LENGTH.     @ZA05939
         DC  X'10A0'                   CONVERSION FLAGS.  (BD,ZS,SS)
* STATIC TEXT ENTRIES.
STE211A  DC  C'STATISTICS'                                     @ZA05939
STE211B  EQU *
STE212A  DC  C'REC-TOTAL---------------     SPLITS-CI---------------'
         DC  C'     EXCPS-------------------'                  @ZA05939
STE212B  EQU *
STE213A  DC  C'REC-DELETED-------------     SPLITS-CA---------------'
         DC  C'     EXTENTS-----------------'                  @ZA05939
STE213B  EQU *                                                 @ZA05939
STE214A  DC  C'REC-INSERTED------------     FREESPACE-%CI-----------'
         DC  C'     SYSTEM-TIMESTAMP:'                         @ZA05939
STE214B  EQU *                                                 @ZA05939
STE215A  DC  C'REC-UPDATED-------------     FREESPACE-%CA-----------'
STE215B  EQU *                                                 @ZA05939
STE216A  DC  C'REC-RETRIEVED-----------     FREESPC-BYTES-----------'
STE216B  EQU *                                                 @ZA05939
TXT21B   EQU *
         EJECT
*
* INDEX ENTRY STATISTICS HEADER AND DATA LINES.                @ZA05939
*
TXT22    DC  Y(TXT22B-TXT22A)          ENTRY LENGTH.
         DC  X'0000'                   HEADER FLAG.
* SPACING CONTROL SUB-STRUCTURE.
TXT22A   DC  X'4000'                   SPACE FLAG.
         DC  H'1'                      SPACING FACTOR.
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC FLAG.
         DC  Y(STE221B-STE221A)        STATIC TEXT LENGTH.
         DC  Y(STE221A-TXT22A)         STATIC TEXT OFFSET.
         DC  H'6'                      PRINT COLUMN.           @ZA05939
         DC  Y(STE221B-STE221A)        PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* SPACING CONTROL SUB-STRUCTURE.
         DC  X'4000'                   SPACE FLAG.
         DC  H'1'                      SPACING FACTOR.
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC FLAG.
         DC  Y(STE222B-STE222A)        STATIC TEXT LENGTH.
         DC  Y(STE222A-TXT22A)         STATIC TEXT OFFSET.
         DC  H'8'                      PRINT COLUMN.           @ZA05939
         DC  Y(STE222B-STE222A)        PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* BLOCK DATA SUB-STRUCTURE.                                    @ZA05939
         DC  X'1000'                   BLOCK FLAG.             @ZA05939
         DC  H'4'                      INPUT LENGTH.           @ZA05939
         DC  H'60'                     INPUT OFFSET.           @ZA05939
         DC  H'22'                     PRINT COLUMN.           @ZA05939
         DC  H'10'                     PRINT FIELD LENGTH.     @ZA05939
         DC  X'10A0'                   CONVERSION FLAGS  (BD,ZS,SS)
* BLOCK DATA SUB-STRUCTURE.                                    @ZA05939
         DC  X'1000'                   BLOCK FLAG.             @ZA05939
         DC  H'4'                      INPUT LENGTH.           @ZA05939
         DC  H'84'                     INPUT OFFSET.           @ZA05939
         DC  H'51'                     PRINT COLUMN.           @ZA05939
         DC  H'10'                     PRINT FIELD LENGTH.     @ZA05939
         DC  X'10A0'                   CONVERSION FLAGS  (BD,ZS,SS)
* BLOCK DATA SUB-STRUCTURE.                                    @ZA05939
         DC  X'1000'                   BLOCK FLAG.             @ZA05939
         DC  H'4'                      INPUT LENGTH.           @ZA05939
         DC  H'92'                     INPUT OFFSET.           @ZA05939
         DC  H'80'                     PRINT COLUMN.           @ZA05939
         DC  H'10'                     PRINT FIELD LENGTH.     @ZA05939
         DC  X'10A0'                   CONVERSION FLAGS  (BD,ZS,SS)
* SPACING CONTROL SUB-STRUCTURE.                               @ZA05939
         DC  X'4000'                   SPACE FLAG.             @ZA05939
         DC  H'1'                      SPACING FACTOR.         @ZA05939
         DC  C'R '                     SPACING TYPE.           @ZA05939
* STATIC TEXT SUB-STRUCTURE.                                   @ZA05939
         DC  X'0400'                   STATIC FLAG.            @ZA05939
         DC  Y(STE223B-STE223A)        STATIC TEXT LENGTH.     @ZA05939
         DC  Y(STE223A-TXT22A)         STATIC TEXT OFFSET.     @ZA05939
         DC  H'8'                      PRINT COLUMN.           @ZA05939
         DC  Y(STE223B-STE223A)        PRINT FIELD LENGTH.     @ZA05939
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* BLOCK DATA SUB-STRUCTURE.                                    @ZA05939
         DC  X'1000'                   BLOCK FLAG.             @ZA05939
         DC  H'4'                      INPUT LENGTH.           @ZA05939
         DC  H'64'                     INPUT OFFSET.           @ZA05939
         DC  H'22'                     PRINT COLUMN.           @ZA05939
         DC  H'10'                     PRINT FIELD LENGTH.     @ZA05939
         DC  X'10A0'                   CONVERSION FLAGS  (BD,ZS,SS)
* BLOCK DATA SUB-STRUCTURE.                                    @ZA05939
         DC  X'1000'                   BLOCK FLAG.             @ZA05939
         DC  H'4'                      INPUT LENGTH.           @ZA05939
         DC  H'88'                     INPUT OFFSET.           @ZA05939
         DC  H'51'                     PRINT COLUMN.           @ZA05939
         DC  H'10'                     PRINT FIELD LENGTH.     @ZA05939
         DC  X'10A0'                   CONVERSION FLAGS  (BD,ZS,SS)
* BLOCK DATA SUB-STRUCTURE.                                    @ZA05939
         DC  X'1000'                   BLOCK FLAG.             @ZA05939
         DC  H'2'                      INPUT LENGTH.           @ZA05939
         DC  H'58'                     INPUT OFFSET.           @ZA05939
         DC  H'85'                     PRINT COLUMN.           @ZA05939
         DC  H'5'                      PRINT FIELD LENGTH.     @ZA05939
         DC  X'10A0'                   CONVERSION FLAGS  (BD,ZS,SS)
* BLOCK DATA SUB-STRUCTURE.                                    @ZA05939
         DC  X'1000'                   BLOCK DATA FLAG.        @ZA05939
         DC  H'2'                      INPUT DATA LENGTH.      @ZA05939
         DC  H'56'                     INPUT DATA OFFSET.      @ZA05939
         DC  H'114'                    PRINT COLUMN.           @ZA05939
         DC  H'5'                      PRINT FIELD LENGTH.     @ZA05939
         DC  X'10A0'                   CONVERSION FLAGS.  (BD,ZS,SS)
* SPACING CONTROL SUB-STRUCTURE.                               @ZA05939
         DC  X'4000'                   SPACE FLAG.             @ZA05939
         DC  H'1'                      SPACING FACTOR.         @ZA05939
         DC  C'R '                     SPACING TYPE.           @ZA05939
* STATIC TEXT SUB-STRUCTURE.                                   @ZA05939
         DC  X'0400'                   STATIC FLAG.            @ZA05939
         DC  Y(STE224B-STE224A)        STATIC TEXT LENGTH.     @ZA05939
         DC  Y(STE224A-TXT22A)         STATIC TEXT OFFSET.     @ZA05939
         DC  H'8'                      PRINT COLUMN.           @ZA05939
         DC  Y(STE224B-STE224A)        PRINT FIELD LENGTH.     @ZA05939
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* BLOCK DATA SUB-STRUCTURE.                                    @ZA05939
         DC  X'1000'                   BLOCK FLAG.             @ZA05939
         DC  H'4'                      INPUT LENGTH.           @ZA05939
         DC  H'68'                     INPUT OFFSET.           @ZA05939
         DC  H'22'                     PRINT COLUMN.           @ZA05939
         DC  H'10'                     PRINT FIELD LENGTH.     @ZA05939
         DC  X'10A0'                   CONVERSION FLAGS  (BD,ZS,SS)
* BLOCK DATA SUB-STRUCTURE.                                    @ZA05939
         DC  X'1000'                   BLOCK FLAG.             @ZA05939
         DC  H'1'                      INPUT LENGTH.           @ZA05939
         DC  H'11'                     INPUT OFFSET.           @ZA05939
         DC  H'58'                     PRINT COLUMN.           @ZA05939
         DC  H'3'                      PRINT FIELD LENGTH.     @ZA05939
         DC  X'10A0'                   CONVERSION FLAGS.  (BD,ZS,SS)
* BLOCK DATA SUB-STRUCTURE.                                    @ZA05939
         DC  X'1000'                   BLOCK DATA FLAG.        @ZA05939
         DC  H'2'                      INPUT DATA LENGTH.      @ZA05939
         DC  H'4'                      INPUT DATA OFFSET.      @ZA05939
         DC  H'114'                    PRINT COLUMN.           @ZA05939
         DC  H'5'                      PRINT FIELD LENGTH.     @ZA05939
         DC  X'10A0'                   CONVERSION FLAGS.  (BD,ZS,SS)
* SPACING CONTROL SUB-STRUCTURE.                               @ZA05939
         DC  X'4000'                   SPACE FLAG.             @ZA05939
         DC  H'1'                      SPACING FACTOR.         @ZA05939
         DC  C'R '                     SPACING TYPE.           @ZA05939
* STATIC TEXT SUB-STRUCTURE.                                   @ZA05939
         DC  X'0400'                   STATIC FLAG.            @ZA05939
         DC  Y(STE225B-STE225A)        STATIC TEXT LENGTH.     @ZA05939
         DC  Y(STE225A-TXT22A)         STATIC TEXT OFFSET.     @ZA05939
         DC  H'8'                      PRINT COLUMN.           @ZA05939
         DC  Y(STE225B-STE225A)        PRINT FIELD LENGTH.     @ZA05939
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* BLOCK DATA SUB-STRUCTURE.                                    @ZA05939
         DC  X'1000'                   BLOCK FLAG.             @ZA05939
         DC  H'4'                      INPUT LENGTH.           @ZA05939
         DC  H'72'                     INPUT OFFSET.           @ZA05939
         DC  H'22'                     PRINT COLUMN.           @ZA05939
         DC  H'10'                     PRINT FIELD LENGTH.     @ZA05939
         DC  X'10A0'                   CONVERSION FLAGS  (BD,ZS,SS)
* BLOCK DATA SUB-STRUCTURE.                                    @ZA05939
         DC  X'1000'                   BLOCK FLAG.             @ZA05939
         DC  H'1'                      INPUT LENGTH.           @ZA05939
         DC  H'10'                     INPUT OFFSET.           @ZA05939
         DC  H'58'                     PRINT COLUMN.           @ZA05939
         DC  H'3'                      PRINT FIELD LENGTH.     @ZA05939
         DC  X'10A0'                   CONVERSION FLAGS.  (BD,ZS,SS)
* BLOCK DATA SUB-STRUCTURE.                                    @ZA05939
         DC  X'1000'                   BLOCK FLAG.             @ZA05939
         DC  H'8'                      INPUT LENGTH.           @ZA05939
         DC  H'48'                     INPUT OFFSET.           @ZA05939
         DC  H'71'                     PRINT COLUMN.           @ZA05939
         DC  H'16'                     PRINT FIELD LENGTH.     @ZA05939
         DC  X'4000'                   CONVERSION FLAGS.  (BHA)
* BLOCK DATA SUB-STRUCTURE.                                    @ZA05939
         DC  X'1000'                   BLOCK DATA FLAG.        @ZA05939
         DC  H'4'                      INPUT DATA LENGTH.      @ZA05939
         DC  H'32'                     INPUT DATA OFFSET.      @ZA05939
         DC  H'109'                    PRINT COLUMN.           @ZA04219
         DC  H'10'                     PRINT FIELD LENGTH.     @ZA04219
         DC  X'10A0'                   CONV FLAGS.  (BD,ZS,SS) @ZA04219
* SPACING CONTROL SUB-STRUCTURE.                               @ZA05939
         DC  X'4000'                   SPACE FLAG.             @ZA05939
         DC  H'1'                      SPACING FACTOR.         @ZA05939
         DC  C'R '                     SPACING TYPE.           @ZA05939
* STATIC TEXT SUB-STRUCTURE.                                   @ZA05939
         DC  X'0400'                   STATIC FLAG.            @ZA05939
         DC  Y(STE226B-STE226A)        STATIC TEXT LENGTH.     @ZA05939
         DC  Y(STE226A-TXT22A)         STATIC TEXT OFFSET.     @ZA05939
         DC  H'8'                      PRINT COLUMN.           @ZA05939
         DC  Y(STE226B-STE226A)        PRINT FIELD LENGTH.     @ZA05939
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* BLOCK DATA SUB-STRUCTURE.                                    @ZA05939
         DC  X'1000'                   BLOCK FLAG.             @ZA05939
         DC  H'4'                      INPUT LENGTH.           @ZA05939
         DC  H'76'                     INPUT OFFSET.           @ZA05939
         DC  H'22'                     PRINT COLUMN.           @ZA05939
         DC  H'10'                     PRINT FIELD LENGTH.     @ZA05939
         DC  X'10A0'                   CONVERSION FLAGS  (BD,ZS,SS)
* BLOCK DATA SUB-STRUCTURE.                                    @ZA05939
         DC  X'1000'                   BLOCK FLAG.             @ZA05939
         DC  H'4'                      INPUT LENGTH.           @ZA05939
         DC  H'80'                     INPUT OFFSET.           @ZA05939
         DC  H'51'                     PRINT COLUMN.           @ZA05939
         DC  H'10'                     PRINT FIELD LENGTH.     @ZA05939
         DC  X'10A0'                   CONVERSION FLAGS.  (BD,ZS,SS)
* BLOCK DATA SUB-STRUCTURE.                                    @ZA05939
         DC  X'9000'                   BLOCK DATA & EOF FLAGS. @ZA05939
         DC  H'4'                      INPUT LENGTH.           @ZA05939
         DC  H'28'                     INPUT OFFSET.           @ZA05939
         DC  H'109'                    PRINT COLUMN.           @ZA05939
         DC  H'10'                     PRINT FIELD LENGTH.     @ZA04219
         DC  X'10A0'                   CONV FLAGS.  (BD,ZS,SS) @ZA04219
* STATIC TEXT ENTRIES.                                         @ZA05939
STE221A  DC  C'STATISTICS'                                     @ZA05939
STE221B  EQU *                                                 @ZA05939
STE222A  DC  C'REC-TOTAL---------------     SPLITS-CI---------------'
         DC  C'     EXCPS-------------------     INDEX:'       @ZA05939
STE222B  EQU *                                                 @ZA05939
STE223A  DC  C'REC-DELETED-------------     SPLITS-CA---------------'
         DC  C'     EXTENTS-----------------     LEVELS--------------'
         DC  C'----'                                           @ZA05939
STE223B  EQU *                                                 @ZA05939
STE224A  DC  C'REC-INSERTED------------     FREESPACE-%CI-----------'
         DC  C'     SYSTEM-TIMESTAMP:            ENTRIES/SECT--------'
         DC  C'----'                                           @ZA05939
STE224B  EQU *                                                 @ZA05939
STE225A  DC  C'REC-UPDATED-------------     FREESPACE-%CA-----------'
         DC  C'                                  SEQ-SET-RBA---------'
         DC  C'----'                                           @ZA05939
STE225B  EQU *                                                 @ZA05939
STE226A  DC  C'REC-RETRIEVED-----------     FREESPC-BYTES-----------'
         DC  C'                                  HI-LEVEL-RBA--------'
         DC  C'----'                                           @ZA05939
STE226B  EQU *                                                 @ZA05939
TXT22B   EQU *
         EJECT
*
* STATIC TEXT ENTRY 23 IS UNUSED.                              @ZA05939
*
         EJECT
*
* ALLOCATION HEADER AND DATA LINES.
*
TXT24    DC  Y(TXT24B-TXT24A)          ENTRY LENGTH.
         DC  X'0000'                   HEADER FLAG.
* SPACING CONTROL SUB-STRUCTURE.
TXT24A   DC  X'4000'                   SPACE CONTROL FLAG.
         DC  H'1'                      SPACING FACTOR.
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC TEXT FLAG.
         DC  Y(STE241B-STE241A)        STATIC TEXT LENGTH.
         DC  Y(STE241A-TXT24A)         STATIC TEXT OFFSET.
         DC  H'6'                      PRINT COLUMN.           @ZA05939
         DC  Y(STE241B-STE241A)        PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* SPACING CONTROL SUB-STRUCTURE.
         DC  X'4000'                   SPACE CONTROL FLAG.
         DC  H'1'                      SPACING FACTOR.
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC TEXT FLAG.
         DC  Y(STE242B-STE242A)        STATIC TEXT LENGTH.
         DC  Y(STE242A-TXT24A)         STATIC TEXT OFFSET.
         DC  H'8'                      PRINT COLUMN.           @ZA05939
         DC  Y(STE242B-STE242A)        PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* INSERT DATA SUB-STRUCTURE.                                   @ZA05939
         DC  X'2000'                   INSERT DATA FLAG.       @ZA05939
         DC  H'10'                     REFERENCE NUMBER.       @ZA05939
         DC  H'0'                      UNUSED.                 @ZA05939
         DC  H'22'                     PRINT COLUMN.           @ZA05939
         DC  H'10'                     PRINT FIELD LENGTH.     @ZA05939
         DC  X'0008'                   CONV FLAGS.  (CHAR,AR)  @ZA05939
* INSERT DATA SUB-STRUCTURE.
         DC  X'2000'                   INSERT DATA FLAGS.
         DC  H'20'                     REFERENCE NUMBER.       @ZA05939
         DC  H'0'                      UNUSED.
         DC  H'51'                     PRINT COLUMN.           @ZA04219
         DC  H'10'                     PRINT FIELD LENGTH.     @ZA04219
         DC  X'10A0'                   CONV FLAGS.  (BD,ZS,SS) @ZA04219
* SPACING CONTROL SUB-STRUCTURE.                               @ZA05939
         DC  X'4000'                   SPACE CONTROL FLAG.     @ZA05939
         DC  H'1'                      SPACING FACTOR.         @ZA05939
         DC  C'R '                     SPACING TYPE.           @ZA05939
* STATIC TEXT SUB-STRUCTURE.                                   @ZA05939
         DC  X'0400'                   STATIC TEXT FLAG.       @ZA05939
         DC  Y(STE243B-STE243A)        STATIC TEXT LENGTH.     @ZA05939
         DC  Y(STE243A-TXT24A)         STATIC TEXT OFFSET.     @ZA05939
         DC  H'8'                      PRINT COLUMN.           @ZA05939
         DC  Y(STE243B-STE243A)        PRINT FIELD LENGTH.     @ZA05939
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* BLOCK DATA SUB-STRUCTURE.                                    @ZA05939
         DC  X'1000'                   BLOCK DATA FLAG.        @ZA05939
         DC  H'3'                      INPUT DATA LENGTH.      @ZA05939
         DC  H'0'                      INPUT DATA OFFSET.      @ZA05939
         DC  H'24'                     PRINT COLUMN.           @ZA05939
         DC  H'8'                      PRINT FIELD LENGTH.     @ZA05939
         DC  X'10A0'                   CONVERSION FLAGS.  (BD,ZS,SS)
* INSERT DATA SUB-STRUCTURE.                                   @ZA05939
         DC  X'2000'                   INSERT DATA FLAG.       @ZA05939
         DC  H'30'                     REFERENCE NUMBER.       @ZA05939
         DC  H'0'                      UNUSED.                 @ZA05939
         DC  H'51'                     PRINT COLUMN.           @ZA05939
         DC  H'10'                     PRINT FIELD LENGTH.     @ZA05939
         DC  X'10A0'                   CONV FLAGS.  (BD,ZS,SS) @ZA05939
* SPACING CONTROL SUB-STRUCTURE.                               @ZA05939
         DC  X'4000'                   SPACE CONTROL FLAG.     @ZA05939
         DC  H'1'                      SPACING FACTOR.         @ZA05939
         DC  C'R '                     SPACING TYPE.           @ZA05939
* STATIC TEXT SUB-STRUCTURE.                                   @ZA05939
         DC  X'0400'                   STATIC TEXT FLAG.       @ZA05939
         DC  Y(STE244B-STE244A)        STATIC TEXT LENGTH.     @ZA05939
         DC  Y(STE244A-TXT24A)         STATIC TEXT OFFSET.     @ZA05939
         DC  H'8'                      PRINT COLUMN.           @ZA05939
         DC  Y(STE244B-STE244A)        PRINT FIELD LENGTH.     @ZA05939
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* BLOCK DATA SUB-STRUCTURE.                                    @ZA05939
         DC  X'9000'                   BLOCK DATA & EOF FLAGS. @ZA05939
         DC  H'3'                      INPUT DATA LENGTH.      @ZA05939
         DC  H'3'                      INPUT DATA OFFSET.      @ZA05939
         DC  H'24'                     PRINT COLUMN.           @ZA05939
         DC  H'8'                      PRINT FIELD LENGTH.     @ZA05939
         DC  X'10A0'                   CONVERSION FLAGS.  (BD,ZS,SS)
* STATIC TEXT ENTRIES.
STE241A  DC  C'ALLOCATION'                                     @ZA05939
STE241B  EQU *
STE242A  DC  C'SPACE-TYPE--------------     HI-ALLOC-RBA------------'
STE242B  EQU *
STE243A  DC  C'SPACE-PRI---------------     HI-USED-RBA-------------'
STE243B  EQU *                                                 @ZA05939
STE244A  DC  C'SPACE-SEC---------------'                       @ZA05939
STE244B  EQU *                                                 @ZA05939
TXT24B   EQU *
         EJECT
*
* VOLUMES HEADER AND DATA LINES.
*
TXT25    DC  Y(TXT25B-TXT25A)          ENTRY LENGTH.
         DC  X'0000'                   HEADER FLAG.
* SPACING CONTROL SUB-STRUCTURE.                               @ZA05939
TXT25A   DC  X'4000'                   SPACE CONTROL FLAG.     @ZA05939
         DC  H'1'                      SPACING FACTOR.         @ZA05939
         DC  C'R '                     SPACING TYPE.           @ZA05939
* STATIC TEXT SUB-STRUCTURE.                                   @ZA05939
         DC  X'0400'                   STATIC TEXT FLAG.       @ZA05939
         DC  Y(STE254B-STE254A)        STATIC TEXT LENGTH.     @ZA05939
         DC  Y(STE254A-TXT25A)         STATIC TEXT OFFSET.     @ZA05939
         DC  H'6'                      PRINT COLUMN.           @ZA05939
         DC  Y(STE254B-STE254A)        PRINT FIELD LENGTH.     @ZA05939
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* SPACING CONTROL SUB-STRUCTURE.
         DC  X'4000'                   SPACE CONTROL FLAG.     @ZA05939
         DC  H'1'                      SPACING FACTOR.
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC TEXT FLAG.
         DC  Y(STE251B-STE251A)        STATIC TEXT LENGTH.
         DC  Y(STE251A-TXT25A)         STATIC TEXT OFFSET.
         DC  H'8'                      PRINT COLUMN.           @ZA05939
         DC  Y(STE251B-STE251A)        PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* BLOCK DATA SUB-STRUCTURE.
         DC  X'1000'                   BLOCK DATA FLAG.
         DC  H'6'                      INPUT DATA LENGTH.
         DC  H'6'                      INPUT DATA OFFSET.
         DC  H'26'                     PRINT COLUMN.           @ZA05939
         DC  H'6'                      PRINT FIELD LENGTH.
         DC  X'0008'                   CONV FLAGS.  (CHAR,AR)  @ZA05939
* BLOCK DATA SUB-STRUCTURE.                                    @ZA05939
         DC  X'1000'                   BLOCK DATA FLAG.        @ZA05939
         DC  H'4'                      INPUT DATA LENGTH.      @ZA05939
         DC  H'28'                     INPUT DATA OFFSET.      @ZA05939
         DC  H'51'                     PRINT COLUMN.           @ZA05939
         DC  H'10'                     PRINT FIELD LENGTH.     @ZA04219
         DC  X'10A0'                   CONV FLAGS.  (BD,ZS,SS) @ZA04219
* BLOCK DATA SUB-STRUCTURE.
         DC  X'1000'                   BLOCK DATA FLAG.
         DC  H'4'                      INPUT DATA LENGTH.      @ZA05939
         DC  H'24'                     INPUT DATA OFFSET.      @ZA05939
         DC  H'80'                     PRINT COLUMN.           @ZA05939
         DC  H'10'                     PRINT FIELD LENGTH.     @ZA05939
         DC  X'10A0'                   CONVERSION FLAGS.  (BD,ZS,SS)
* BLOCK DATA SUB-STRUCTURE.                                    @ZA05939
         DC  X'1000'                   BLOCK DATA FLAG.        @ZA05939
         DC  H'1'                      INPUT DATA LENGTH.      @ZA05939
         DC  H'15'                     INPUT DATA OFFSET.      @ZA05939
         DC  H'116'                    PRINT COLUMN.           @ZA05939
         DC  H'3'                      PRINT FIELD LENGTH.     @ZA05939
         DC  X'10A0'                   CONV FLAGS.  (BD,ZS,SS) @ZA05939
* SPACE CONTROL SUB-STRUCTURE.                                 @ZA05939
         DC  X'4000'                   SPACE CONTROL FLAG.     @ZA05939
         DC  H'1'                      SPACING FACTOR.         @ZA05939
         DC  C'R '                     SPACING TYPE.           @ZA05939
* STATIC TEXT SUB-STRUCTURE.                                   @ZA05939
         DC  X'0400'                   STATIC TEXT FLAG.       @ZA05939
         DC  Y(STE252B-STE252A)        STATIC TEXT LENGTH.     @ZA05939
         DC  Y(STE252A-TXT25A)         STATIC TEXT OFFSET.     @ZA05939
         DC  H'8'                      PRINT COLUMN.           @ZA05939
         DC  Y(STE252B-STE252A)        PRINT FIELD LENGTH.     @ZA05939
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* BLOCK DATA SUB-STRUCTURE.
         DC  X'1000'                   BLOCK DATA FLAGS.
         DC  H'4'                      INPUT DATA LENGTH.
         DC  H'2'                      INPUT DATA OFFSET.      @ZA05939
         DC  H'21'                     PRINT COLUMN.           @ZA05939
         DC  H'8'                      PRINT FIELD LENGTH.     @ZA05939
         DC  X'4000'                   CONV FLAGS.  (BHA)      @ZA05939
* BLOCK DATA SUB-STRUCTURE.                                    @ZA05939
         DC  X'1000'                   BLOCK DATA SUB-STRUCTURE.
         DC  H'2'                      INPUT DATA LENGTH.      @ZA05939
         DC  H'32'                     INPUT DATA OFFSET.      @ZA05939
         DC  H'56'                     PRINT COLUMN.           @ZA05939
         DC  H'5'                      PRINT FIELD LENGTH.     @ZA05939
         DC  X'10A0'                   CONVERSION FLAGS.  (BD,ZS,SS)
* BLOCK DATA SUB-STRUCTURE.
         DC  X'1000'                   BLOCK DATA SUB-STRUCTURE.
         DC  H'4'                      INPUT DATA LENGTH.      @ZA05939
         DC  H'20'                     INPUT DATA OFFSET.      @ZA05939
         DC  H'80'                     PRINT COLUMN.           @ZA05939
         DC  H'10'                     PRINT FIELD LENGHT.     @ZA05939
         DC  X'10A0'                   CONVERSION FLAGS.  (BD,ZS,SS)
* BLOCK DATA SUB-STRUCTURE.                                    @ZA05939
         DC  X'1000'                   BLOCK DATA FLAG.        @ZA05939
         DC  H'1'                      INPUT DATA LENGTH.      @ZA05939
         DC  H'36'                     INPUT DATA OFFSET.      @ZA05939
         DC  H'114'                    PRINT COLUMN.           @ZA05939
         DC  H'2'                      PRINT FIELD LENGTH.     @ZA05939
         DC  X'4000'                   CONVERSION FLAGS.  (BHA)
* SPACING CONTROL SUB-STRUCTURE.                               @ZA05939
         DC  X'4000'                   SPACE CONTROL FLAG.     @ZA05939
         DC  H'1'                      SPACING FACTOR.         @ZA05939
         DC  C'R '                     SPACING TYPE.           @ZA05939
* STATIC TEXT SUB-STRUCTURE.                                   @ZA05939
         DC  X'0400'                   STATIC TEXT FLAG.       @ZA05939
         DC  Y(STE253B-STE253A)        STATIC TEXT LENGTH.     @ZA05939
         DC  Y(STE253A-TXT25A)         STATIC TEXT OFFSET.     @ZA05939
         DC  H'8'                      PRINT COLUMN.           @ZA05939
         DC  Y(STE253B-STE253A)        PRINT FIELD LENGTH.     @ZA05939
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* INSERT DATA SUB-STRUCTURE.                                   @ZA05939
         DC  X'2000'                   INSERT DATA FLAG.       @ZA05939
         DC  H'10'                     REFERENCE NUMBER.       @ZA05939
         DC  H'0'                      UNUSED.                 @ZA05939
         DC  H'22'                     PRINT COLUMN.           @ZA05939
         DC  H'10'                     PRINT FIELD LENGTH.     @ZA05939
         DC  X'0008'                   CONV FLAGS.  (CHAR,AR)  @ZA05939
* BLOCK DATA SUB-STRUCTURE.
         DC  X'9000'                   BLOCK DATA FLAG.        @ZA05939
         DC  H'2'                      DATA LENGTH.            @ZA05939
         DC  H'34'                     DATA OFFSET.            @ZA05939
         DC  H'56'                     PRINT COLUMN.           @ZA05939
         DC  H'5'                      PRINT FIELD LENGTH.     @ZA05939
         DC  X'10A0'                   CONV FLAGS.  (BD,ZS,SS) @ZA05939
* STATIC TEXT ENTRIES.
STE251A  DC  C'VOLSER------------------     PHYREC-SIZE-------------'
         DC  C'     HI-ALLOC-RBA------------     EXTENT-NUMBER-------'
         DC  C'----'                                           @ZA05939
STE251B  EQU *
STE252A  DC  C'DEVTYPE-----------------     PHYRECS/TRK-------------'
         DC  C'     HI-USED-RBA-------------     EXTENT-TYPE---------'
         DC  C'----'                                           @ZA05939
STE252B  EQU *
STE253A  DC  C'VOLFLAG-----------------     TRACKS/CA---------------'
STE253B  EQU *                                                 @ZA05939
STE254A  DC  C'VOLUME'                                         @ZA05939
STE254B  EQU *                                                 @ZA05939
TXT25B   EQU *
         EJECT
*
* LOKEYV HEADER AND DATA LINES.
*
TXT26    DC  Y(TXT26B-TXT26A)          ENTRY LENGTH.
         DC  X'0000'                   HEADER FLAG.
* SPACING CONTROL SUB-STRUCTURE.
TXT26A   DC  X'4000'                   SPACE FLAG.
         DC  H'1'                      SPACING FACTOR.
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC TEXT FLAG.
         DC  Y(STE261B-STE261A)        STATIC TEXT LENGTH.
         DC  Y(STE261A-TXT26A)         STATIC TEXT OFFSET.
         DC  H'8'                      PRINT COLUMN.           @ZA05939
         DC  Y(STE261B-STE261A)        PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* BLOCK DATA SUB-STRUCTURE.
         DC  X'9000'                   BLOCK & EOF FLAGS.
         DC  H'255'                    INPUT DATA LENGTH.
         DC  H'0'                      INPUT DATA OFFSET.
         DC  H'30'                     PRINT COLUMN.           @ZA05939
         DC  H'255'                    PRINT FIELD LENGTH.
         DC  X'8000'                   CONVERSION FLAGS.  (BH)
* STATIC TEXT ENTRY.
STE261A  DC  C'LOW-KEY-----------------'                       @ZA05939
STE261B  EQU *
TXT26B   EQU *
         EJECT
*
* HIKEYV HEADER AND DATA LINES.
*
TXT27    DC  Y(TXT27B-TXT27A)          ENTRY LENGTH.
         DC  X'0000'                   HEADER FLAG.
* SPACING CONTROL SUB-STRUCTURE.
TXT27A   DC  X'4000'                   SPACE FLAG.
         DC  H'1'                      SPACING FACTOR.
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC TEXT FLAG.
         DC  Y(STE271B-STE271A)        STATIC TEXT LENGTH.
         DC  Y(STE271A-TXT27A)         STATIC TEXT OFFSET.
         DC  H'8'                      PRINT COLUMN.           @ZA05939
         DC  Y(STE271B-STE271A)        PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* BLOCK DATA SUB-STRUCTURE.
         DC  X'9000'                   BLOCK & EOF FLAGS.
         DC  H'255'                    INPUT DATA LENGTH.
         DC  H'0'                      INPUT DATA OFFSET.
         DC  H'30'                     PRINT COLUMN.           @ZA05939
         DC  H'255'                    PRINT FIELD LENGTH.
         DC  X'8000'                   CONVERSION FLAGS.  (BH)
* STATIC TEXT ENTRY.
STE271A  DC  C'HIGH-KEY----------------'                       @ZA05939
STE271B  EQU *
TXT27B   EQU *
         EJECT
*
* INDEX ENTRY ONLY.
*
TXT28    DC  Y(TXT28B-TXT28A)          ENTRY LENGTH.
         DC  X'0000'                   HEADER FLAG.
* SPACING SUB-STRUCTURE.
TXT28A   DC  X'4000'                   SPACE CONTROL FLAG.
         DC  H'1'                      SPACING FACTOR.
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC TEXT FLAG.
         DC  Y(STE281B-STE281A)        STATIC TEXT LENGTH.
         DC  Y(STE281A-TXT28A)         STATIC TEXT OFFSET.
         DC  H'8'                      PRINT COLUMN.           @ZA05939
         DC  Y(STE281B-STE281A)        PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* BLOCK DATA SUB-STRUCTURE.
         DC  X'9000'                   BLOCK DATA FLAG.
         DC  H'4'                      INPUT FIELD LENGTH.
         DC  H'0'                      INPUT DATA OFFSET.
         DC  H'22'                     OUTPUT COLUMN.          @ZA05939
         DC  H'10'                     PRINT FIELD LENGTH.     @ZA04219
         DC  X'10A0'                   CONV FLAGS.  (BD,ZS,SS) @ZA04219
* STATIC TEXT ENTRY.
STE281A  DC  C'HI-KEY-RBA--------------'                       @ZA05939
STE281B  EQU *
TXT28B   EQU *
         EJECT
*
* EXTENTS HEADER AND DATA LINES.
*
TXT29    DC  Y(TXT29B-TXT29A)          ENTRY LENGTH.
         DC  X'0000'                   HEADER FLAG.
* SPACING CONTROL SUB-STRUCTURE.
TXT29A   DC  X'4000'                   SPACE CONTROL FLAG.
         DC  H'1'                      SPACING FACTOR.
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC TEXT FLAG.
         DC  Y(STE291B-STE291A)        STATIC TEXT LENGTH.
         DC  Y(STE291A-TXT29A)         STATIC TEXT OFFSET.
         DC  H'8'                      PRINT COLUMN.           @ZA05939
         DC  Y(STE291B-STE291A)        PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* REDO SUB-STRUCTURE.
         DC  X'0800'                   REDO FLAG.
         DC  H'10'                     REFERENCE NUMBER.
         DC  H'7'                      STRU COUNT.             @ZA05939
         DC  H'20'                     INPUT OFFSET.
* SPACING CONTROL SUB-STRUCTURE.                               @ZA05939
         DC  X'4000'                   SPACE CONTROL FLAG.     @ZA05939
         DC  H'1'                      SPACING FACTOR.         @ZA05939
         DC  C'R '                     SPACING TYPE.           @ZA05939
* STATIC TEXT SUB-STRUCTURE.                                   @ZA05939
         DC  X'0400'                   STATIC TEXT FLAG.       @ZA05939
         DC  Y(STE292B-STE292A)        STATIC TEXT LENGTH.     @ZA05939
         DC  Y(STE292A-TXT29A)         STATIC TEXT OFFSET.     @ZA05939
         DC  H'8'                      PRINT COLUMN.           @ZA05939
         DC  Y(STE292B-STE292A)        PRINT FIELD LENGTH.     @ZA05939
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* BLOCK DATA SUB-STRUCTURE.
         DC  X'1000'                   BLOCK DATA FLAG.
         DC  H'4'                      INPUT DATA LENGTH.
         DC  H'2'                      INPUT DATA OFFSET.
         DC  H'21'                     PRINT COLUMN.           @ZA05939
         DC  H'8'                      PRINT FIELD LENGTH.
         DC  X'4000'                   CONVERSION FLAGS.  (BHA)
* BLOCK DATA SUB-STRUCTURE.                                    @ZA05939
         DC  X'1000'                   BLOCK DATA FLAG.        @ZA05939
         DC  H'4'                      INPUT DATA LENGTH.      @ZA05939
         DC  H'12'                     INPUT DATA OFFSET.      @ZA05939
         DC  H'51'                     PRINT COLUMN.           @ZA04219
         DC  H'10'                     PRINT FIELD LENGTH.     @ZA04219
         DC  X'10A0'                   CONV FLAGS.  (BD,ZS,SS) @ZA04219
* BLOCK DATA SUB-STRUCTURE.                                    @ZA05939
         DC  X'1000'                   BLOCK DATA FLAG.        @ZA05939
         DC  H'2'                      INPUT DATA LENGTH.      @ZA05939
         DC  H'10'                     INPUT DATA OFFSET.      @ZA05939
         DC  H'85'                     PRINT COLUMN.           @ZA05939
         DC  H'5'                      PRINT FIELD LENGTH.     @ZA05939
         DC  X'10A0'                   CONVERSION FLAGS.  (BD,ZS,SS)
* SPACING CONTROL SUB-STRUCTURE.                               @ZA05939
         DC  X'4000'                   SPACE CONTROL FLAG.     @ZA05939
         DC  H'1'                      SPACING FACTOR.         @ZA05939
         DC  C'R '                     SPACING TYPE.           @ZA05939
* STATIC TEXT SUB-STRUCTURE.                                   @ZA05939
         DC  X'0400'                   STATIC TEXT FLAG.       @ZA05939
         DC  Y(STE293B-STE293A)        STATIC TEXT LENGTH.     @ZA05939
         DC  Y(STE293A-TXT29A)         STATIC TEXT OFFSET.     @ZA05939
         DC  H'8'                      PRINT COLUMN.           @ZA05939
         DC  Y(STE293B-STE293A)        PRINT FIELD LENGTH.     @ZA05939
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* BLOCK DATA SUB-STRUCTURE.
         DC  X'1000'                   BLOCK DATA FLAG.
         DC  H'4'                      INPUT DATA LENGTH.
         DC  H'6'                      INPUT DATA OFFSET.
         DC  H'21'                     PRINT COLUMN.           @ZA05939
         DC  H'8'                      PRINT FIELD LENGTH.
         DC  X'4000'                   CONVERSION FLAGS.  (BHA)
* BLOCK DATA SUB-STRUCTURE.
         DC  X'9000'                   BLOCK DATA FLAG.
         DC  H'4'                      INPUT DATA LENGTH.
         DC  H'16'                     INPUT DATA OFFSET.
         DC  H'51'                     PRINT COLUMN.           @ZA04219
         DC  H'10'                     PRINT FIELD LENGTH.     @ZA04219
         DC  X'10A0'                   CONV FLAGS.  (BD,ZS,SS) @ZA04219
* STATIC TEXT ENTRIES.
STE291A  DC  C'EXTENTS:'                                       @ZA05939
STE291B  EQU *
STE292A  DC  C'LOW-CCHH----------------     LOW-RBA-----------------'
         DC  C'     TRACKS------------------'                  @ZA05939
STE292B  EQU *                                                 @ZA05939
STE293A  DC  C'HIGH-CCHH---------------     HIGH-RBA----------------'
STE293B  EQU *                                                 @ZA05939
TXT29B   EQU *
         EJECT
*
* VOLUME ENTRY DETAIL.
*
TXT30    DC  Y(TXT30B-TXT30A)          ENTRY LENGTH.
         DC  X'0000'                   HEADER FLAG.
* SPACING CONTROL SUB-STRUCTURE.
TXT30A   DC  X'4000'                   SPACE CONTROL FLAG.
         DC  H'1'                      SPACING FACTOR.
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC CONTROL FLAG.
         DC  Y(STE301B-STE301A)        TEXT LENGTH.
         DC  Y(STE301A-TXT30A)         TEXT OFFSET.
         DC  H'6'                      PRINT COLUMN.           @ZA05939
         DC  Y(STE301B-STE301A)        PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* SPACE CONTROL SUB-STRUCTURE.                                 @ZA05939
         DC  X'4000'                   SPACE CONTROL FLAG.     @ZA05939
         DC  H'1'                      SPACING FACTOR.         @ZA05939
         DC  C'R '                     SPACING TYPE.           @ZA05939
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC CONTROL FLAG.
         DC  Y(STE302B-STE302A)        TEXT LENGTH.
         DC  Y(STE302A-TXT30A)         TEXT OFFSET.
         DC  H'8'                      PRINT COLUMN.           @ZA05939
         DC  Y(STE302B-STE302A)        PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* BLOCK DATA SUB-STRUCTURE.                                    @ZA05939
         DC  X'1000'                   BLOCK DATA FLAG.        @ZA05939
         DC  H'2'                      INPUT LENGTH.           @ZA05939
         DC  H'12'                     INPUT OFFSET.           @ZA05939
         DC  H'27'                     PRINT COLUMN.           @ZA05939
         DC  H'5'                      PRINT FIELD LENGTH.     @ZA05939
         DC  X'10A0'                   CONVERSION FLAGS.  (BD,ZS,SS)
* BLOCK DATA SUB-STRUCTURE.                                    @ZA05939
         DC  X'1000'                   BLOCK DATA FLAG.        @ZA05939
         DC  H'4'                      INPUT LENGTH.           @ZA05939
         DC  H'0'                      INPUT OFFSET.           @ZA05939
         DC  H'50'                     PRINT COLUMN.           @ZA05939
         DC  H'8'                      PRINT FIELD LENGTH.     @ZA05939
         DC  X'4000'                   CONVERSION FLAGS.  (BHA)
* BLOCK DATA SUB-STRUCTURE.                                    @ZA05939
         DC  X'1000'                   BLOCK DATA FLAG.        @ZA05939
         DC  H'4'                      INPUT LENGTH.           @ZA05939
         DC  H'4'                      INPUT OFFSET.           @ZA05939
         DC  H'80'                     PRINT COLUMN.           @ZA05939
         DC  H'10'                     PRINT FIELD LENGTH.     @ZA05939
         DC  X'10A0'                   CONVERSION FLAGS.  (BD,ZS,SS)
* INSERT DATA SUB-STRUCTURE.                                   @ZA05939
         DC  X'2000'                   INSERT CONTROL FLAG.    @ZA05939
         DC  H'30'                     REFERENCE NUMBER.       @ZA05939
         DC  H'0'                      UNUSED.                 @ZA05939
         DC  H'114'                    PRINT COLUMN.           @ZA05939
         DC  H'5'                      PRINT FIELD LENGTH.     @ZA05939
         DC  X'10A0'                   CONVERSION FLAGS.  (BD,ZS,SS)
* SPACE CONTROL SUB-STRUCTURE.                                 @ZA05939
         DC  X'4000'                   SPACE CONTROL FLAG.     @ZA05939
         DC  H'1'                      SPACING FACTOR.         @ZA05939
         DC  C'R '                     SPACING TYPE.           @ZA05939
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC CONTROL FLAG.
         DC  Y(STE303B-STE303A)        TEXT LENGTH.
         DC  Y(STE303A-TXT30A)         TEXT OFFSET.
         DC  H'8'                      PRINT COLUMN.           @ZA05939
         DC  Y(STE303B-STE303A)        PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* BLOCK DATA SUB-STRUCTURE.                                    @ZA05939
         DC  X'1000'                   BLOCK DATA FLAG.        @ZA05939
         DC  H'2'                      INPUT LENGTH.           @ZA05939
         DC  H'10'                     INPUT OFFSET.           @ZA05939
         DC  H'27'                     PRINT COLUMN.           @ZA05939
         DC  H'5'                      PRINT FIELD LENGTH.     @ZA05939
         DC  X'10A0'                   CONVERSION FLAGS.  (BD,ZS,SS)
* INSERT DATA SUB-STRUCTURE.                                   @ZA05939
         DC  X'2000'                   INSERT CONTROL FLAG.    @ZA05939
         DC  H'20'                     REFERENCE NUMBER.       @ZA05939
         DC  H'0'                      UNUSED.                 @ZA05939
         DC  H'87'                     PRINT COLUMN.           @ZA05939
         DC  H'3'                      PRINT FIELD LENGTH.     @ZA05939
         DC  X'10A0'                   CONVERSION FLAGS.  (BD,ZS,SS)
* INSERT DATA SUB-STRUCTURE.                                   @ZA05939
         DC  X'2000'                   INSERT CONTROL FLAG.    @ZA05939
         DC  H'40'                     REFERENCE NUMBER.       @ZA05939
         DC  H'0'                      UNUSED.                 @ZA05939
         DC  H'114'                    PRINT COLUMN.           @ZA05939
         DC  H'5'                      PRINT FIELD LENGTH.     @ZA05939
         DC  X'10A0'                   CONVERSION FLAGS.  (BD,ZS,SS)
* SPACE CONTROL SUB-STRUCTURE.
         DC  X'4000'                   SPACE CONTROL FLAG.
         DC  H'1'                      SPACING FACTOR.
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.                                   @ZA05939
         DC  X'0400'                   STATIC CONTROL FLAG.    @ZA05939
         DC  Y(STE304B-STE304A)        TEXT LENGTH.            @ZA05939
         DC  Y(STE304A-TXT30A)         TEXT OFFSET.            @ZA05939
         DC  H'8'                      PRINT COLUMN.           @ZA05939
         DC  Y(STE304B-STE304A)        PRINT FIELD LENGTH.     @ZA05939
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* BLOCK DATA SUB-STRUCTURE.
         DC  X'1000'                   BLOCK DATA FLAG.
         DC  H'2'                      INPUT LENGTH.
         DC  H'8'                      INPUT OFFSET.
         DC  H'27'                     PRINT COLUMN.           @ZA05939
         DC  H'5'                      PRINT FIELD LENGTH.
         DC  X'10A0'                   CONVERSION FLAGS.  (BD,ZS,SS)
* INSERT DATA SUB-STRUCTURE.
         DC  X'A000'                   INSERT CONTROL FLAG.    @ZA05939
         DC  H'10'                     REFERENCE NUMBER.
         DC  H'0'                      UNUSED.
         DC  H'42'                     PRINT COLUMN.           @ZA05939
         DC  H'16'                     PRINT FIELD LENGTH.
         DC  X'4000'                   CONVERSION FLAGS.  (BHA)
* STATIC TEXT ENTRIES.
STE301A  DC  C'CHARACTERISTICS'                                @ZA05939
STE301B  EQU *
STE302A  DC  C'BYTES/TRK---------------     DEVTYPE-----------------'
         DC  C'     MAX-PHYREC-SZ-----------     DATASETS-ON-VOL-----'
         DC  C'----'                                           @ZA05939
STE302B  EQU *
STE303A  DC  C'TRKS/CYL----------------     VOLUME-TIMESTAMP:       '
         DC  C'     MAX-EXT/ALLOC-----------     DATASPCS-ON-VOL-----'
         DC  C'----'                                           @ZA05939
STE303B  EQU *
STE304A  DC  C'CYLS/VOL----------------'                       @ZA05939
STE304B  EQU *                                                 @ZA05939
TXT30B   EQU *
         EJECT
*
* FORMAT 1 DSCB ATTRIBUTES.
*
TXT31    DC  Y(TXT31B-TXT31A)          ENTRY LENGTH.
         DC  X'0000'                   HEADER FLAG.
* SPACING CONTROL SUB-STRUCTURE.
TXT31A   DC  X'4000'                   SPACE CONTROL FLAG.
         DC  H'1'                      SPACING FACTOR.
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC TEXT FLAG.
         DC  Y(STE311B-STE311A)        STATIC TEXT LENGTH.
         DC  Y(STE311A-TXT31A)         STATIC TEXT OFFSET.
         DC  H'6'                      PRINT COLUMN.           @ZA05939
         DC  Y(STE311B-STE311A)        PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* SPACING CONTROL SUB-STRUCTURE.
         DC  X'4000'                   SPACE CONTROL FLAG.
         DC  H'1'                      SPACING FACTOR.
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC TEXT FLAG.
         DC  Y(STE312B-STE312A)        STATIC TEXT LENGTH.
         DC  Y(STE312A-TXT31A)         STATIC TEXT OFFSET.
         DC  H'8'                      PRINT COLUMN.           @ZA05939
         DC  Y(STE312B-STE312A)        PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* BLOCK DATA SUB-STRUCTURE.                                    @ZA05939
         DC  X'1000'                   BLOCK DATA FLAG.        @ZA05939
         DC  H'2'                      INPUT LENGTH.           @ZA05939
         DC  H'16'                     INPUT OFFSET.           @ZA05939
         DC  H'27'                     PRINT COLUMN.           @ZA05939
         DC  H'5'                      PRINT FIELD LENGTH.     @ZA05939
         DC  X'10A0'                   CONVERSION FLAGS.  (BD,ZS,SS)
* SPACING CONTROL SUB-STRUCTURE.
         DC  X'4000'                   SPACE CONTROL FLAG.
         DC  H'1'                      SPACING FACTOR.
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC TEXT FLAG.
         DC  Y(STE313B-STE313A)        STATIC TEXT LENGTH.
         DC  Y(STE313A-TXT31A)         STATIC TEXT OFFSET.
         DC  H'8'                      PRINT COLUMN.           @ZA05939
         DC  Y(STE313B-STE313A)        PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* BLOCK DATA SUB-STRUCTURE.                                    @ZA05939
         DC  X'1000'                   BLOCK DATA FLAG.        @ZA05939
         DC  H'1'                      INPUT LENGTH.           @ZA05939
         DC  H'18'                     INPUT OFFSET.           @ZA05939
         DC  H'29'                     PRINT COLUMN.           @ZA05939
         DC  H'3'                      PRINT FIELD LENGTH.     @ZA05939
         DC  X'10A0'                   CONVERSION FLAGS.  (BD,ZS,SS)
* BLOCK DATA SUB-STRUCTURE.                                    @ZA05939
         DC  X'1000'                   BLOCK DATA FLAG.        @ZA05939
         DC  H'5'                      INPUT LENGTH.           @ZA05939
         DC  H'10'                     INPUT OFFSET.           @ZA05939
         DC  H'48'                     PRINT COLUMN.           @ZA05939
         DC  H'10'                     PRINT FIELD LENGTH.     @ZA05939
         DC  X'4000'                   CONVERSION FLAGS.  (BHA)
* INSERT DATA SUB-STRUCTURE.                                   @ZA05939
         DC  X'2000'                   INSERT DATA FLAG.       @ZA05939
         DC  H'20'                     REFERENCE NUMBER.       @ZA05939
         DC  H'0'                      UNUSED.                 @ZA05939
         DC  H'66'                     PRINT COLUMN.           @ZA05939
         DC  H'10'                     PRINT FIELD LENGTH.     @ZA05939
         DC  X'0000'                   CONVERSION FLAGS.  (CHAR)
* SPACING CONTROL SUB-STRUCTURE.                               @ZA05939
         DC  X'4000'                   SPACE CONTROL FLAG.     @ZA05939
         DC  H'1'                      SPACING FACTOR.         @ZA05939
         DC  C'R '                     SPACING TYPE.           @ZA05939
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC TEXT FLAG.
         DC  Y(STE314B-STE314A)        STATIC TEXT LENGTH.
         DC  Y(STE314A-TXT31A)         STATIC TEXT OFFSET.
         DC  H'8'                      PRINT COLUMN.           @ZA05939
         DC  Y(STE314B-STE314A)        PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* BLOCK DATA SUB-STRUCTURE.                                    @ZA05939
         DC  X'1000'                   BLOCK DATA FLAG.        @ZA05939
         DC  H'3'                      INPUT LENGTH.           @ZA05939
         DC  H'20'                     INPUT OFFSET.           @ZA05939
         DC  H'24'                     PRINT COLUMN.           @ZA05939
         DC  H'8'                      PRINT FIELD LENGTH.     @ZA05939
         DC  X'10A0'                   CONVERSION FLAGS.  (BD,ZS,SS)
* INSERT DATA SUB-STRUCTURE.                                   @ZA05939
         DC  X'2000'                   INSERT DATA FLAG.       @ZA05939
         DC  H'30'                     REFERENCE NUMBER.       @ZA05939
         DC  H'0'                      UNUSED.                 @ZA05939
         DC  H'66'                     PRINT COLUMN.           @ZA05939
         DC  H'10'                     PRINT FIELD LENGTH.     @ZA05939
         DC  X'0000'                   CONVERSION FLAGS.  (CHAR)
* SPACING CONTROL SUB-STRUCTURE.                               @ZA05939
         DC  X'4000'                   SPACE CONTROL FLAG.     @ZA05939
         DC  H'1'                      SPACING FACTOR.         @ZA05939
         DC  C'R '                     SPACING TYPE.           @ZA05939
* STATIC TEXT SUB-STRUCTURE.                                   @ZA05939
         DC  X'0400'                   STATIC TEXT FLAG.       @ZA05939
         DC  Y(STE315B-STE315A)        STATIC TEXT LENGTH.     @ZA05939
         DC  Y(STE315A-TXT31A)         STATIC TEXT OFFSET.     @ZA05939
         DC  H'8'                      PRINT COLUMN.           @ZA05939
         DC  Y(STE315B-STE315A)        PRINT FIELD LENGTH.     @ZA05939
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* INSERT DATA SUB-STRUCTURE.                                   @ZA05939
         DC  X'2000'                   INSERT DATA FLAG.       @ZA05939
         DC  H'10'                     REFERENCE NUMBER.       @ZA05939
         DC  H'0'                      UNUSED.                 @ZA05939
         DC  H'22'                     PRINT COLUMN.           @ZA05939
         DC  H'10'                     PRINT FIELD LENGTH.     @ZA05939
         DC  X'0008'                   CONV FLAGS.  (CHAR,AR)  @ZA05939
* BLOCK DATA SUB-STRUCTURE.
         DC  X'1000'                   BLOCK DATA FLAG.
         DC  H'8'                      INPUT LENGTH.
         DC  H'2'                      INPUT OFFSET.
         DC  H'42'                     PRINT COLUMN.           @ZA05939
         DC  H'16'                     PRINT FIELD LENGTH.
         DC  X'4000'                   CONVERSION FLAGS.  (BHA)
* INSERT DATA SUB-STRUCTURE.
         DC  X'A000'                   INSERT DATA FLAG.
         DC  H'40'                     REFERENCE NUMBER.
         DC  H'0'                      UNUSED.
         DC  H'66'                     PRINT COLUMN.           @ZA05939
         DC  H'10'                     PRINT FIELD LENGTH.     @ZA05939
         DC  X'0000'                   CONVERSION FLAGS.  (CHAR)
* STATIC TEXT ENTRIES.
STE311A  DC  C'DATASPACE'
STE311B  EQU *
STE312A  DC  C'DATASETS----------------     FORMAT-1-DSCB:          '
         DC  C'     ATTRIBUTES:'                               @ZA05939
STE312B  EQU *
STE313A  DC  C'EXTENTS-----------------     CCHHR-------------------'
STE313B  EQU *
STE314A  DC  C'SEC-ALLOC---------------     TIMESTAMP'         @ZA05939
STE314B  EQU *
STE315A  DC  C'TYPE--------------------'                       @ZA05939
STE315B  EQU *                                                 @ZA05939
TXT31B   EQU *
         EJECT
*
* EXTENT DESCRIPTOR HEADING LINES.
*
TXT32    DC  Y(TXT32B-TXT32A)          ENTRY LENGTH.
         DC  X'0000'                   HEADER FLAG.
* SPACE CONTROL SUB-STRUCTURE.
TXT32A   DC  X'4000'                   SPACE CONTROL FLAG.
         DC  H'1'                      SPACING FACTOR.
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC TEXT FLAG.
         DC  Y(STE321B-STE321A)        STATIC TEXT LENGTH.
         DC  Y(STE321A-TXT32A)         STATIC TEXT OFFSET.
         DC  H'8'                      PRINT COLUMN.           @ZA05939
         DC  Y(STE321B-STE321A)        PRINT FIELD LENGTH.
         DC  X'0000'                   CONVERSION FLAGS.  (CHAR)
* STATIC TEXT ENTRIES.
STE321A  DC  C'EXTENT-DESCRIPTOR:'                             @ZA05939
STE321B  EQU *
TXT32B   EQU *
         EJECT
*
* DATA SET DIRECTORY HEADING LINES.
*
TXT33    DC  Y(TXT33B-TXT33A)          ENTRY LENGTH.
         DC  X'0000'                   HEADER FLAGS.
* SPACE CONTROL SUB-STRUCTURE.
TXT33A   DC  X'4000'                   SPACE CONTROL FLAG.
         DC  H'1'                      SPACING FACTOR.
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCUTRE.
         DC  X'0400'                   STATIC TEXT FLAG.
         DC  Y(STE331B-STE331A)        STATIC TEXT LENGTH.
         DC  Y(STE331A-TXT33A)         STATIC TEXT OFFSET.
         DC  H'8'                      PRINT COLUMN.           @ZA05939
         DC  Y(STE331B-STE331A)        PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* STATIC TEXT ENTRIES.
STE331A  DC  C'DATASET-DIRECTORY:'                             @ZA05939
STE331B  EQU *
TXT33B   EQU *
         EJECT
*
* VOLUMES HEADER LINE.                                         @ZA05939
*
TXT34    DC  Y(TXT34B-TXT34A)          ENTRY LENGTH.
         DC  X'0000'                   HEADER FLAGS.
* SPACING CONTROL SUB-STRUCTURE.
TXT34A   DC  X'4000'                   SPACE CONTROL FLAG.
         DC  H'1'                      SPACING FACTOR
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'8400'                   STATIC TEXT FLAG.
         DC  Y(STE341B-STE341A)        TEXT LENGTH.
         DC  Y(STE341A-TXT34A)         TEXT OFFSET.
         DC  H'6'                      PRINT COLUMN.           @ZA05939
         DC  Y(STE341B-STE341A)        PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* STATIC TEXT ENTRIES.
STE341A  DC  C'VOLUMES'                                        @ZA05939
STE341B  EQU *
TXT34B   EQU *
         EJECT
*
* ASSOCIATIONS HEADER LINE.                                    @ZA05939
*
TXT35    DC  Y(TXT35B-TXT35A)          ENTRY LENGTH
         DC  H'0'                      FLAG FIELD
* SPACING CONTROL SUB-STRUCTURE.                               @ZA05939
TXT35A   DC  X'4000'                   SPACE CONTROL FLAG.     @ZA05939
         DC  H'1'                      SPACING FACTOR          @ZA05939
         DC  C'R '                     SPACING TYPE.           @ZA05939
* STATIC TEXT SUB-STRUCTURE.                                   @ZA05939
         DC  X'8400'                   STATIC TEXT FLAG.       @ZA05939
         DC  Y(STE351B-STE351A)        TEXT LENGTH.            @ZA05939
         DC  Y(STE351A-TXT35A)         TEXT OFFSET.            @ZA05939
         DC  H'6'                      PRINT COLUMN.           @ZA05939
         DC  Y(STE351B-STE351A)        PRINT FIELD LENGTH.     @ZA05939
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* STATIC TEXT ENTRIES.                                         @ZA05939
STE351A  DC  C'ASSOCIATIONS'                                   @ZA05939
STE351B  EQU *                                                 @ZA05939
TXT35B   EQU *
         EJECT
*
* EXTENT DESCRIPTOR DATA LINES.
*
TXT36    DC  Y(TXT36B-TXT36A)          ENTRY LENGTH.
         DC  X'0000'                   FLAGS.
* SPACING CONTROL SUB-STRUCTURE.                               @ZA05939
TXT36A   DC  X'4000'                   SPACE CONTROL FLAG.     @ZA05939
         DC  H'1'                      SPACING FACTOR          @ZA05939
         DC  C'R '                     SPACING TYPE.           @ZA05939
* STATIC TEXT SUB-STRUCTURE.                                   @ZA05939
         DC  X'0400'                   STATIC TEXT FLAG.       @ZA05939
         DC  Y(STE361B-STE361A)        TEXT LENGTH.            @ZA05939
         DC  Y(STE361A-TXT36A)         TEXT OFFSET.            @ZA05939
         DC  H'8'                      PRINT COLUMN.           @ZA05939
         DC  Y(STE361B-STE361A)        PRINT FIELD LENGTH.     @ZA05939
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* BLOCK DATA SUB-STRUCTURE.
         DC  X'1000'                   BLOCK DATA FLAG.        @ZA05939
         DC  H'2'                      INPUT LENGTH.
         DC  H'8'                      INPUT OFFSET.
         DC  H'27'                     PRINT COLUMN.
         DC  H'5'                      PRINT FIELD LENGTH.
         DC  X'10A0'                   CONVERSION FLAGS.  (BD,ZS,SS)
* BLOCK DATA SUB-STRUCTURE.                                    @ZA05939
         DC  X'1000'                   BLOCK DATA FLAG.        @ZA05939
         DC  H'4'                      INPUT LENGTH.           @ZA05939
         DC  H'4'                      INPUT OFFSET.           @ZA05939
         DC  H'50'                     PRINT COLUMN.           @ZA05939
         DC  H'8'                      PRINT FIELD LENGTH.     @ZA05939
         DC  X'4000'                   CONVERSION FLAGS.  (BHA)
* INSERT DATA SUB-STRUCTURE.                                   @ZA05939
         DC  X'2000'                   INSERT FLAG.            @ZA05939
         DC  H'10'                     INSERT REF NO.          @ZA05939
         DC  H'0'                      UNUSED.                 @ZA05939
         DC  H'86'                     PRINT COLUMN.           @ZA05939
         DC  H'32757'                  PRINT FIELD LENGTH.     @ZA05939
         DC  X'8000'                   CNVRSN FLGS (BH)        @ZA05939
* SPACING CONTROL SUB-STRUCTURE.                               @ZA05939
         DC  X'4000'                   SPACE CONTROL FLAG.     @ZA05939
         DC  H'1'                      SPACING FACTOR          @ZA05939
         DC  C'R '                     SPACING TYPE.           @ZA05939
* STATIC TEXT SUB-STRUCTURE.                                   @ZA05939
         DC  X'0400'                   STATIC TEXT FLAG.       @ZA05939
         DC  Y(STE362B-STE362A)        TEXT LENGTH.            @ZA05939
         DC  Y(STE362A-TXT36A)         TEXT OFFSET.            @ZA05939
         DC  H'8'                      PRINT COLUMN.           @ZA05939
         DC  Y(STE362B-STE362A)        PRINT FIELD LENGTH.     @ZA05939
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* BLOCK DATA SUB-STRUCTURE.
         DC  X'9000'                   BLOCK DATA FLAG.        @ZA05939
         DC  H'2'                      INPUT LENGTH.
         DC  H'2'                      INPUT OFFSET.
         DC  H'27'                     PRINT COLUMN.           @ZA05939
         DC  H'5'                      PRINT FIELD LENGTH.
         DC  X'10A0'                   CONVERSION FLAGS.  (BD,ZS,SS)
* STATIC TEXT ENTRIES.                                         @ZA05939
STE361A  DC  C'TRACKS-TOTAL------------     BEG-CCHH----------------'
         DC  C'     SPACE-MAP-----------'                      @ZA05939
STE361B  EQU *                                                 @ZA05939
STE362A  DC  C'TRACKS-USED-------------'                       @ZA05939
STE362B  EQU *                                                 @ZA05939
TXT36B   EQU *
         EJECT
*
* DATA SET DIRECTORY DATA LINES.
*
TXT37    DC  Y(TXT37B-TXT37A)          ENTRY LENGTH.
         DC  X'0000'                   FLAGS.
* SPACING CONTROL SUB-STRUCTURE.                               @ZA05939
TXT37A   DC  X'4000'                   SPACE CONTROL FLAG.     @ZA05939
         DC  H'1'                      SPACING FACTOR          @ZA05939
         DC  C'R '                     SPACING TYPE.           @ZA05939
* STATIC TEXT SUB-STRUCTURE.                                   @ZA05939
         DC  X'0400'                   STATIC TEXT FLAG.       @ZA05939
         DC  Y(STE371B-STE371A)        TEXT LENGTH.            @ZA05939
         DC  Y(STE371A-TXT37A)         TEXT OFFSET.            @ZA05939
         DC  H'10'                     PRINT COLUMN.           @ZA05939
         DC  Y(STE371B-STE371A)        PRINT FIELD LENGTH.     @ZA05939
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* INSERT DATA SUB-STRUCTURE.
         DC  X'2000'                   INSERT DATA FLAG.       @ZA05939
         DC  H'10'                     REFERENCE NUMBER.
         DC  H'0'                      UNUSED.
         DC  H'17'                     PRINT COLUMN.           @ZA05939
         DC  H'44'                     PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* INSERT DATA SUB-STRUCTURE.
         DC  X'2000'                   INSERT DATA FLAG.
         DC  H'20'                     REFERENCE NUMBER.
         DC  H'0'                      UNUSED.
         DC  H'80'                     PRINT COLUMN.           @ZA05939
         DC  H'10'                     PRINT FIELD LENGTH.     @ZA05939
         DC  X'0008'                   CONV FLAGS.  (CHAR,AR)  @ZA05939
* INSERT DATA SUB-STRUCTURE.
         DC  X'A000'                   INSERT DATA FLAG.
         DC  H'30'                     REFERENCE NUMBER.
         DC  H'0'                      UNUSED.
         DC  H'116'                    PRINT COLUMN.           @ZA05939
         DC  H'3'                      PRINT FIELD LENGTH.
         DC  X'10A0'                   CONVERSION FLAGS.  (BD,ZS,SS)
* STATIC TEXT ENTRY.                                           @ZA05939
STE371A  DC  C'DSN----                                            '
         DC  C'     ATTRIBUTES--------------     EXTENTS-------------'
         DC  C'----'                                           @ZA05939
STE371B  EQU *                                                 @ZA05939
TXT37B   EQU *
         EJECT
*
* DATA ENTRY HEADER - NON-IDENT.
*
TXT38    DC  Y(TXT38B-TXT38A)          ENTRY LENGTH.
         DC  X'0000'                   FLAGS.
* SPACING CONTROL SUB-STRUCTURE.
TXT38A   DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
         DC  H'2'                      SPACING FACTOR.
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC TEXT FLAG.
         DC  Y(STE381B-STE381A)        STATIC TEXT LENGTH.
         DC  Y(STE381A-TXT38A)         STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE381B-STE381A)        PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* BLOCK DATA SUB-STRUCTURE.
         DC  X'9000'                   INSERT DATA FLAG.
         DC  H'44'                     INPUT LENGTH.
         DC  H'0'                      INPUT OFFSET
         DC  H'17'                     PRINT COLUMN.           @ZA05939
         DC  H'44'                     PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* STATIC TEXT ENTRY.
STE381A  DC  C'DATA ---------- '                               @ZA05939
STE381B  EQU *
TXT38B   EQU *
         EJECT
*
* INDEX ENTRY HEADER - NON-IDENT.
*
TXT39    DC  Y(TXT39B-TXT39A)          ENTRY LENGTH.
         DC  X'0000'                   FLAGS.
* SPACING CONTROL SUB-STRUCTURE.
TXT39A   DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
         DC  H'2'                      SPACING FACTOR.
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC TEXT FLAG.
         DC  Y(STE391B-STE391A)        STATIC TEXT LENGTH.
         DC  Y(STE391A-TXT39A)         STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE391B-STE391A)        PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* BLOCK DATA SUB-STRUCTURE.
         DC  X'9000'                   INSERT DATA FLAG.
         DC  H'44'                     INPUT LENGTH.
         DC  H'0'                      INPUT OFFSET
         DC  H'17'                     PRINT COLUMN.           @ZA05939
         DC  H'44'                     PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* STATIC TEXT ENTRY.
STE391A  DC  C'INDEX --------- '                               @ZA05939
STE391B  EQU *
TXT39B   EQU *
         EJECT                                                 @YL026UE
*                                                              @YL026UE
* IN CATALOG HEADER AND DATA LINE.                             @YL026U
*                                                              @YL026UE
TXT40    DC  Y(TXT40B-TXT40A)          ENTRY LENGTH.           @YL026UE
         DC  X'0000'                   FLAGS.                  @YL026UE
* SPACING CONTROL SUB-STRUCTURE.                               @YL026UE
TXT40A   DC  X'4000'                   SPACE SUBSTRUCTURE FLG  @YL026UE
         DC  H'1'                      SPACING FACTOR.         @YL026UE
         DC  C'R '                     SPACING TYPE.           @YL026UE
* STATIC TEXT SUB-STRUCTURE.                                   @YL026UE
         DC  X'0400'                   STATIC TEXT FLAG.       @YL026UE
         DC  Y(STE401B-STE401A)        STATIC TEXT LENGTH.     @YL026UE
         DC  Y(STE401A-TXT40A)         STATIC TEXT OFFSET.     @YL026UE
         DC  H'6'                      PRINT COLUMN.           @ZA05939
         DC  Y(STE401B-STE401A)        PRINT FIELD LENGTH.     @YL026UE
         DC  H'0'                      CONVERSION FLAGS (CHAR) @YL026UE
* BLOCK DATA SUB-STRUCTURE.                                    @YL026UE
         DC  X'9000'                   EOB & BLOCK  DATA FLAG  @YL026UE
         DC  H'44'                     INPUT LENGTH            @YL026UE
         DC  H'0'                      INPUT OFFSET            @YL026UE
         DC  H'17'                     PRINT COLUMN.           @ZA05939
         DC  H'44'                     PRINT FIELD LENGTH.     @YL026UE
         DC  H'0'                      CONVERSION FLAGS (CHAR) @Y30LSMK
* STATIC TEXT ENTRY.                                           @YL026UE
STE401A  DC  C'IN-CAT --- '                                    @ZA05939
STE401B  EQU *                                                 @YL026UE
TXT40B   EQU *                                                 @YL026UE
         EJECT                                                 @YL026UE
*                                                              @YL026UE
* PAGESPACE ENTRY HEADER.                                      @ZA05939
*                                                              @YL026UE
TXT41    DC  Y(TXT41B-TXT41A)          ENTRY LENGTH.           @YL026UE
         DC  X'0000'                   FLAGS.                  @YL026UE
* SPACING CONTROL SUB-STRUCTURE.                               @YL026UE
TXT41A   DC  X'4000'                   SPACE SUBSTRUCTURE FLG  @YL026UE
         DC  H'2'                      SPACING FACTOR.         @YL026UE
         DC  C'R '                     SPACING TYPE.           @YL026UE
* STATIC TEXT SUB-STRUCTURE.                                   @YL026UE
         DC  X'0400'                   STATIC TEXT FLAG.       @YL026UE
         DC  Y(STE411B-STE411A)        STATIC TEXT LENGTH.     @YL026UE
         DC  Y(STE411A-TXT41A)         STATIC TEXT OFFSET.     @YL026UE
         DC  H'1'                      PRINT COLUMN.           @YL026UE
         DC  Y(STE411B-STE411A)        PRINT FIELD LENGTH.     @YL026UE
         DC  H'0'                      CONVERSION FLAGS (CHAR) @YL026UE
* BLOCK  DATA SUB-STRUCTURE.                                   @YL026UE
         DC  X'9000'                   EOB & BLOCK  DATA FLAG  @YL026UE
         DC  H'44'                     INPUT LENGTH            @YL026UE
         DC  H'0'                      INPUT OFFSET            @YL026UE
         DC  H'17'                     PRINT COLUMN.           @ZA05939
         DC  H'44'                     PRINT FIELD LENGTH.     @YL026UE
         DC  H'0'                      CONVERSION FLAGS (CHAR) @YL026UE
* STATIC TEXT ENTRY.                                           @YL026UE
STE411A  DC  C'PAGESPACE ----- '                               @ZA05939
STE411B  EQU *                                                 @YL026UE
TXT41B   EQU *                                                 @YL026UE
         EJECT                                                 @YL026UE
*                                                              @YL026UE
* GDG BASE ENTRY HEADER.                                       @YL026UE
*                                                              @YL026UE
TXT42    DC  Y(TXT42B-TXT42A)          ENTRY LENGTH.           @YL026UE
         DC  X'0000'                   FLAGS.                  @YL026UE
* SPACING CONTROL SUB-STRUCTURE.                               @YL026UE
TXT42A   DC  X'4000'                   SPACE SUBSTRUCTURE FLG  @YL026UE
         DC  H'2'                      SPACING FACTOR.         @YL026UE
         DC  C'R '                     SPACING TYPE.           @YL026UE
* STATIC TEXT SUB-STRUCTURE.                                   @YL026UE
         DC  X'0400'                   STATIC TEXT FLAG.       @YL026UE
         DC  Y(STE421B-STE421A)        STATIC TEXT LENGTH.     @YL026UE
         DC  Y(STE421A-TXT42A)         STATIC TEXT OFFSET.     @YL026UE
         DC  H'1'                      PRINT COLUMN.           @YL026UE
         DC  Y(STE421B-STE421A)        PRINT FIELD LENGTH.     @YL026UE
         DC  H'0'                      CONVERSION FLAGS (CHAR) @YL026UE
* BLOCK  DATA SUB-STRUCTURE.                                   @YL026UE
         DC  X'9000'                   EOB & BLOCK  DATA FLAG  @YL026UE
         DC  H'44'                     INPUT LENGTH            @YL026UE
         DC  H'0'                      INPUT OFFSET            @YL026UE
         DC  H'17'                     PRINT COLUMN.           @ZA05939
         DC  H'44'                     PRINT FIELD LENGTH.     @YL026UE
         DC  H'0'                      CONVERSION FLAGS (CHAR) @Y30LSMK
* STATIC TEXT ENTRY.                                           @YL026UE
STE421A  DC  C'GDG BASE ------ '                               @ZA05939
STE421B  EQU *                                                 @YL026UE
TXT42B   EQU *                                                 @YL026UE
         EJECT                                                 @YL026UE
*                                                              @YL026UE
* ALIAS ENTRY HEADER - NON - INDENTED.                         @YL026UE
*                                                              @YL026UE
TXT43    DC  Y(TXT43B-TXT43A)          ENTRY LENGTH.           @YL026UE
         DC  X'0000'                   FLAGS.                  @YL026UE
* SPACING CONTROL SUB-STRUCTURE.                               @YL026UE
TXT43A   DC  X'4000'                   SPACE SUBSTRUCTURE FLG  @YL026UE
         DC  H'2'                      SPACING FACTOR.         @YL026UE
         DC  C'R '                     SPACING TYPE.           @YL026UE
* STATIC TEXT SUB-STRUCTURE.                                   @YL026UE
         DC  X'0400'                   STATIC TEXT FLAG.       @YL026UE
         DC  Y(STE431B-STE431A)        STATIC TEXT LENGTH.     @YL026UE
         DC  Y(STE431A-TXT43A)         STATIC TEXT OFFSET.     @YL026UE
         DC  H'1'                      PRINT COLUMN.           @YL026UE
         DC  Y(STE431B-STE431A)        PRINT FIELD LENGTH.     @YL026UE
         DC  H'0'                      CONVERSION FLAGS (CHAR) @YL026UE
* BLOCK  DATA SUB-STRUCTURE.                                   @YL026UE
         DC  X'9000'                   EOB & BLOCK  DATA FLAG  @YL026UE
         DC  H'44'                     INPUT LENGTH            @YL026UE
         DC  H'0'                      INPUT OFFSET            @YL026UE
         DC  H'17'                     PRINT COLUMN.           @ZA05939
         DC  H'44'                     PRINT FIELD LENGTH.     @YL026UE
         DC  H'0'                      CONVERSION FLAGS (CHAR) @Y30LSMK
* STATIC TEXT ENTRY.                                           @YL026UE
STE431A  DC  C'ALIAS --------- '                               @ZA05939
STE431B  EQU *                                                 @YL026UE
TXT43B   EQU *                                                 @YL026UE
         EJECT                                                 @YL026UE
*                                                              @YL026UE
* NON-VSAM ENTRY HEADER - INDENTED.                            @YL026UE
*                                                              @YL026UE
TXT44    DC  Y(TXT44B-TXT44A)          ENTRY LENGTH.           @YL026UE
         DC  X'0000'                   FLAGS.                  @YL026UE
* SPACING CONTROL SUB-STRUCTURE.                               @YL026UE
TXT44A   DC  X'4000'                   SPACE SUBSTRUCTURE FLG  @YL026UE
         DC  H'2'                      SPACING FACTOR.         @YL026UE
         DC  C'R '                     SPACING TYPE.           @YL026UE
* STATIC TEXT SUB-STRUCTURE.                                   @YL026UE
         DC  X'0400'                   STATIC TEXT FLAG.       @YL026UE
         DC  Y(STE441B-STE441A)        STATIC TEXT LENGTH.     @YL026UE
         DC  Y(STE441A-TXT44A)         STATIC TEXT OFFSET.     @YL026UE
         DC  H'4'                      PRINT COLUMN.           @YL026UE
         DC  Y(STE441B-STE441A)        PRINT FIELD LENGTH.     @YL026UE
         DC  H'0'                      CONVERSION FLAGS (CHAR) @YL026UE
* BLOCK  DATA SUB-STRUCTURE.                                   @YL026UE
         DC  X'9000'                   EOB & BLOCK  DATA FLAG  @YL026UE
         DC  H'44'                     INPUT LENGTH            @YL026UE
         DC  H'0'                      INPUT OFFSET            @YL026UE
         DC  H'17'                     PRINT COLUMN.           @ZA05939
         DC  H'44'                     PRINT FIELD LENGTH.     @ZA05939
         DC  H'0'                      CONVERSION FLAGS (CHAR) @Y30LSMK
* STATIC TEXT ENTRY.                                           @YL026UE
STE441A  DC  C'NONVSAM ---- '                                  @ZA05939
STE441B  EQU *                                                 @YL026UE
TXT44B   EQU *                                                 @YL026UE
         EJECT                                                 @YL026UE
*                                                              @YL026UE
* GDG ATTRIBUTES HEADER AND DATA LINES.                        @YL026UE
*                                                              @YL026UE
TXT45    DC  Y(TXT45B-TXT45A)          ENTRY LENGTH.           @YL026UE
         DC  X'0000'                   FLAGS.                  @YL026UE
* SPACING CONTROL SUB-STRUCTURE.                               @YL026UE
TXT45A   DC  X'4000'                   SPACE SUBSTRUCTURE FLG  @YL026UE
         DC  H'1'                      SPACING FACTOR.         @YL026UE
         DC  C'R '                     SPACING TYPE.           @YL026UE
* STATIC TEXT SUB-STRUCTURE.                                   @YL026UE
         DC  X'0400'                   STATIC TEXT FLAG.       @YL026UE
         DC  Y(STE451B-STE451A)        STATIC TEXT LENGTH.     @YL026UE
         DC  Y(STE451A-TXT45A)         STATIC TEXT OFFSET.     @YL026UE
         DC  H'6'                      PRINT COLUMN.           @ZA05939
         DC  Y(STE451B-STE451A)        PRINT FIELD LENGTH.     @YL026UE
         DC  H'0'                      CONVERSION FLAGS (CHAR) @YL026UE
* SPACING CONTROL SUB-STRUCTURE.                               @YL026UE
         DC  X'4000'                   SPACE SUBSTRUCTURE FLG  @YL026UE
         DC  H'1'                      SPACING FACTOR.         @YL026UE
         DC  C'R '                     SPACING TYPE.           @YL026UE
* STATIC TEXT SUB-STRUCTURE.                                   @YL026UE
         DC  X'0400'                   STATIC TEXT FLAG.       @YL026UE
         DC  Y(STE452B-STE452A)        STATIC TEXT LENGTH.     @YL026UE
         DC  Y(STE452A-TXT45A)         STATIC TEXT OFFSET.     @YL026UE
         DC  H'8'                      PRINT COLUMN.           @ZA05939
         DC  Y(STE452B-STE452A)        PRINT FIELD LENGTH.     @YL026UE
         DC  H'0'                      CONVERSION FLAGS (CHAR) @YL026UE
* BLOCK DATA SUB-STRUCTURE.                                    @YL026UE
         DC  X'1000'                   INSERT DATA FLAG.       @YL026UE
         DC  H'1'                      INPUT LENGTH.           @YL026UE
         DC  H'0'                      INPUT OFFSET            @YL026UE
         DC  H'29'                     PRINT COLUMN.           @ZA05939
         DC  H'3'                      PRINT FIELD LENGTH.     @YL026UE
         DC  X'10A0'                   CNVRSN FLGS (BD,ZS,SS)  @YL026UE
* INSERT DATA SUB-STRUCTURE.                                   @YL026UE
         DC  X'2000'                   EOB & INSERT DATA FLAG  @YL026UE
         DC  H'10'                     REFERENCE NUMBER.       @YL026UE
         DC  H'0'                      UNUSED.                 @YL026UE
         DC  H'37'                     PRINT COLUMN.           @ZA05939
         DC  H'10'                     PRINT FIELD LENGTH.     @ZA05939
         DC  X'0000'                   CONVERSION FLAGS (CHAR) @YL026UE
* INSERT DATA SUB-STRUCTURE.                                   @YL026UE
         DC  X'A000'                   EOB & INSERT DATA FLAG  @YL026UE
         DC  H'20'                     REFERENCE NUMBER.       @YL026UE
         DC  H'0'                      UNUSED.                 @YL026UE
         DC  H'51'                     PRINT COLUMN.           @ZA05939
         DC  H'10'                     PRINT FIELD LENGTH.     @ZA05939
         DC  X'0008'                   CONV FLAGS (CHAR,AR)    @ZA05939
* STATIC TEXT ENTRY.                                           @YL026UE
STE451A  DC  C'ATTRIBUTES'                                     @YL026UE
STE451B  EQU *                                                 @YL026UE
STE452A  DC  C'LIMIT-------------------'                       @ZA05939
STE452B  EQU *                                                 @YL026UE
TXT45B   EQU *                                                 @YL026UE
         EJECT                                                 @YL026UE
*                                                              @YL026UE
* PAGESPACE TRACKS-PER-BYTE.                                   @YL026UE
*                                                              @YL026UE
TXT46    DC  Y(TXT46B-TXT46A)          ENTRY LENGTH.           @YL026UE
         DC  X'0000'                   FLAGS.                  @YL026UE
* SPACING CONTROL SUB-STRUCTURE.                               @YL026UE
TXT46A   DC  X'4000'                   SPACE SUBSTRUCTURE FLG  @YL026UE
         DC  H'1'                      SPACING FACTOR.         @YL026UE
         DC  C'R '                     SPACING TYPE.           @YL026UE
* STATIC TEXT SUB-STRUCTURE.                                   @YL026UE
         DC  X'0400'                   STATIC TEXT FLAG.       @YL026UE
         DC  Y(STE461B-STE461A)        STATIC TEXT LENGTH.     @YL026UE
         DC  Y(STE461A-TXT46A)         STATIC TEXT OFFSET.     @YL026UE
         DC  H'8'                      PRINT COLUMN.           @ZA05939
         DC  Y(STE461B-STE461A)        PRINT FIELD LENGTH.     @YL026UE
         DC  H'0'                      CONVERSION FLAGS (CHAR) @YL026UE
* BLOCK DATA SUB-STRUCTURE.                                    @YL026UE
         DC  X'9000'                   INSERT DATA FLAG.       @ZA05939
         DC  H'4'                      INPUT LENGTH.           @YL026UE
         DC  H'0'                      INPUT OFFSET            @YL026UE
         DC  H'22'                     PRINT COLUMN.           @ZA05939
         DC  H'10'                     PRINT FIELD LENGTH.     @YL026UE
         DC  X'10A0'                   CNVRSN FLG (BD,ZS,SS)   @YL026UE
* STATIC TEXT ENTRY.                                           @YL026UE
STE461A  DC  C'BYTES/TRACK-------------'                       @ZA05939
STE461B  EQU *                                                 @YL026UE
TXT46B   EQU *                                                 @YL026UE
         EJECT                                                 @Y30SSMK
*                                                              @Y30SSMK
* RELEASE INDICATOR (INDENTED).                                @Y30SSMK
*                                                              @Y30SSMK
TXT47    DC  Y(TXT47B-TXT47A)          ENTRY LENGTH.           @Y30SSMK
         DC  X'0000'                   HEADER FLAG.            @Y30SSMK
* SPACING SUB-STRUCTURE.                                       @Y30SSMK
TXT47A   DC  X'4000'                   SPACE FLAG.             @Y30SSMK
         DC  H'1'                      SPACING FLAG.           @Y30SSMK
         DC  C'R '                     SPACING TYPE.           @Y30SSMK
* STATIC TEXT SUB-STRUCTURE.                                   @ZA05939
         DC  X'0400'                   STATIC FLAG.            @ZA05939
         DC  Y(STE472B-STE472A)        STATIC TEXT LENGTH.     @ZA05939
         DC  Y(STE472A-TXT47A)         STATIC TEXT OFFSET.     @ZA05939
         DC  H'6'                      PRINT COLUMN.           @ZA05939
         DC  Y(STE472B-STE472A)        PRINT FIELD LENGTH.     @ZA05939
         DC  H'0'                      CONVERSION FLAGS (CHAR) @ZA05939
* SPACING SUB-STRUCTURE.                                       @ZA05939
         DC  X'4000'                   SPACE FLAG.             @ZA05939
         DC  H'1'                      SPACING FLAG.           @ZA05939
         DC  C'R '                     SPACING TYPE.           @ZA05939
* STATIC TEXT SUB-STRUCTURE.                                   @Y30SSMK
         DC  X'0400'                   STATIC FLAG.            @Y30SSMK
         DC  Y(STE471B-STE471A)        STATIC TEXT LENGTH.     @Y30SSMK
         DC  Y(STE471A-TXT47A)         STATIC TEXT OFFSET.     @Y30SSMK
         DC  H'8'                      PRINT COLUMN.           @ZA05939
         DC  Y(STE471B-STE471A)        PRINT FIELD LENGTH.     @Y30SSMK
         DC  H'0'                      CONVERSION FLAGS (CHAR) @Y30SSMK
* BLOCK DATA SUB-STRUCTURE.                                    @Y30SSMK
         DC  X'9000'                   BLOCK FLAG.             @Y30SSMK
         DC  H'1'                      INPUT LENGTH.           @Y30SSMK
         DC  H'0'                      INPUT OFFSET.           @Y30SSMK
         DC  H'30'                     PRINT COLUMN.           @ZA05939
         DC  H'2'                      PRINT FIELD LENGTH.     @Y30SSMK
         DC  X'10A0'                   CNVRSN FLGS (BD,ZS,SS)  @Y30SSMK
* STATIC TEXT ENTRY.                                           @Y30SSMK
STE471A  DC  C'RELEASE-----------------'                       @ZA05939
STE471B  EQU *                                                 @Y30SSMK
STE472A  DC  C'HISTORY'                                        @ZA05939
STE472B  EQU *                                                 @ZA05939
TXT47B   EQU *                                                 @Y30SSMK
         EJECT                                                 @Y30SSMK
*                                                              @Y30SSMK
* ALTERNATEINDEX ENTRY HEADER                                  @Y30SSMK
*                                                              @Y30SSMK
TXT48    DC  Y(TXT48B-TXT48A)          ENTRY LENGTH.           @Y30SSMK
         DC  X'0000'                   FLAGS.                  @Y30SSMK
* SPACING CONTROL SUB-STRUCTURE.                               @Y30SSMK
TXT48A   DC  X'4000'                   SPACE SUB-STRUCTURE FLG @Y30SSMK
         DC  H'2'                      SPACING FACTOR.         @Y30SSMK
         DC  C'R '                     SPACING TYPE.           @Y30SSMK
* STATIC TEXT SUB-STRUCTURE.                                   @Y30SSMK
         DC  X'0400'                   STATIC TEXT FLAG.       @Y30SSMK
         DC  Y(STE481B-STE481A)        STATIC TEXT LENGTH.     @Y30SSMK
         DC  Y(STE481A-TXT48A)         STATIC TEXT OFFSET.     @Y30SSMK
         DC  H'1'                      PRINT COLUMN.           @Y30SSMK
         DC  Y(STE481B-STE481A)        PRINT FIELD LENGTH.     @Y30SSMK
         DC  H'0'                      CONVERSION FLAGS (CHAR) @Y30SSMK
* BLOCK DATA SUB-STRUCTURE.                                    @Y30SSMK
         DC  X'9000'                   INSERT DATA FLAG.       @Y30SSMK
         DC  H'44'                     INPUT LENGTH.           @Y30SSMK
         DC  H'0'                      INPUT OFFSET            @Y30SSMK
         DC  H'17'                     PRINT COLUMN.           @ZA05939
         DC  H'44'                     PRINT FIELD LENGTH.     @Y30SSMK
         DC  H'0'                      CONVERSION FLAGS (CHAR) @Y30SSMK
* STATIC TEXT ENTRY.                                           @Y30SSMK
STE481A  DC  C'AIX ----------- '                               @ZA05939
STE481B  EQU *                                                 @Y30SSMK
TXT48B   EQU *                                                 @Y30SSMK
         EJECT                                                 @Y30SSMK
*                                                              @Y30SSMK
* ALTERNATEINDEX DATA SET ONLY CHARACTERISTICS HEADER AND DATA @ZA05939
* LINE.                                                        @Y30SSMK
*                                                              @Y30SSMK
TXT49    DC  Y(TXT49B-TXT49A)          ENTRY LENGTH.           @Y30SSMK
         DC  X'0000'                   HEADER FLAG.            @Y30SSMK
* SPACING CONTROL SUB-STRUCTURE.                               @Y30SSMK
TXT49A   DC  X'4000'                   SPACE FLAG.             @Y30SSMK
         DC  H'1'                      SPACING FACTOR.         @Y30SSMK
         DC  C'R '                     SPACING TYPE.           @Y30SSMK
* STATIC TEXT SUB-STRUCTURE.                                   @Y30SSMK
         DC  X'0400'                   STATIC FLAG.            @Y30SSMK
         DC  Y(STE491B-STE491A)        STATIC TEXT LENGTH.     @Y30SSMK
         DC  Y(STE491A-TXT49A)         STATIC TEXT OFFSET.     @Y30SSMK
         DC  H'8'                      PRINT COLUMN.           @ZA05939
         DC  Y(STE491B-STE491A)        PRINT FIELD LENGTH.     @Y30SSMK
         DC  H'0'                      CONVERSION FLAGS (CHAR) @Y30SSMK
* BLOCK DATA SUB-STRUCTURE.                                    @Y30SSMK
         DC  X'9000'                   BLOCK FLAG.             @ZA05939
         DC  H'2'                      INPUT LENGTH.           @Y30SSMK
         DC  H'4'                      INPUT OFFSET.           @Y30SSMK
         DC  H'27'                     PRINT COLUMN.           @ZA05939
         DC  H'5'                      PRINT FIELD LENGTH.     @Y30SSMK
         DC  X'10A0'                   CNVRSN FLGS (BD,ZS,SS)  @Y30SSMK
* STATIC TEXT ENTRIES.                                         @Y30SSMK
STE491A  DC  C'AXRKP-------------------'                       @ZA05939
STE491B  EQU *                                                 @Y30SSMK
TXT49B   EQU *                                                 @Y30SSMK
         EJECT                                                 @Y30SSMK
*                                                              @Y30SSMK
* OWNER ID, CREATION, EXPIRATION, RELEASE, RECOVERY VOLUME,    @Y30SSMK
* DEVICE AND C.I. NUMBER ENTRY HEADER 2 AND DATA LINE.         @Y30SSMK
*                                                              @Y30SSMK
TXT50    DC  Y(TXT50B-TXT50A)          ENTRY LENGTH.           @Y30SSMK
         DC  X'0000'                   HEADER FLAG.            @Y30SSMK
* SPACING SUB-STRUCTURE.                                       @Y30SSMK
TXT50A   DC  X'4000'                   SPACE FLAG.             @Y30SSMK
         DC  H'1'                      SPACING FLAG.           @Y30SSMK
         DC  C'R '                     SPACING TYPE.           @Y30SSMK
* STATIC TEXT SUB-STRUCTURE.                                   @Y30SSMK
         DC  X'0400'                   STATIC FLAG.            @Y30SSMK
         DC  Y(STE503B-STE503A)        STATIC TEXT LENGTH.     @Y30SSMK
         DC  Y(STE503A-TXT50A)         STATIC TEXT OFFSET.     @Y30SSMK
         DC  H'6'                      PRINT COLUMN.           @ZA05939
         DC  Y(STE503B-STE503A)        PRINT FIELD LENGTH.     @Y30SSMK
         DC  H'0'                      CONVERSION FLAGS (CHAR) @Y30SSMK
* SPACE CONTROL SUB-STRUCTURE.                                 @Y30SSMK
         DC  X'4000'                   SPACE FLAG.             @Y30SSMK
         DC  H'1'                      SPACING FACTOR.         @Y30SSMK
         DC  C'R '                     SPACING TYPE.           @Y30SSMK
* STATIC TEXT SUB-STRUCTURE.                                   @Y30SSMK
         DC  X'0400'                   STATIC FLAG.            @Y30SSMK
         DC  Y(STE501B-STE501A)        STATIC TEXT LENGTH.     @Y30SSMK
         DC  Y(STE501A-TXT50A)         STATIC TEXT OFFSET.     @Y30SSMK
         DC  H'8'                      PRINT COLUMN.           @ZA05939
         DC  Y(STE501B-STE501A)        PRINT FIELD LENGTH.     @Y30SSMK
         DC  H'0'                      CONVERSION FLAGS (CHAR) @Y30SSMK
* INSERT DATA SUB-STRUCTURE.                                   @Y30SSMK
         DC  X'2000'                   INSERT FLAG.            @Y30SSMK
         DC  H'10'                     REFERENCE NUMBER.       @Y30SSMK
         DC  H'0'                      UNUSED.                 @Y30SSMK
         DC  H'24'                     PRINT COLUMN.           @ZA05939
         DC  H'8'                      PRINT FIELD LENGTH.     @Y30SSMK
         DC  X'0008'                   CONV FLAGS (CHAR,AR)    @ZA05939
* INSERT DATA SUB-STRUCTURE.                                   @Y30SSMK
         DC  X'2000'                   INSERT FLAG.            @Y30SSMK
         DC  H'20'                     REFERENCE NUMBER.       @Y30SSMK
         DC  H'0'                      UNUSED.                 @Y30SSMK
         DC  H'55'                     PRINT COLUMN.           @ZA05939
         DC  H'5'                      PRINT FIELD LENGTH.     @Y30SSMK
         DC  X'0820'                   CONVERSION FLGS (PU,SS) @Y30SSMK
* STATIC TEXT SUB-STRUCTURE.                                   @Y30SSMK
         DC  X'0400'                   STATIC TEXT FLAGS.      @Y30SSMK
         DC  Y(STE502B-STE502A)        TEXT LENGTH.            @Y30SSMK
         DC  Y(STE502A-TXT50A)         TEXT OFFSET.            @Y30SSMK
         DC  H'57'                     PRINT COLUMN.           @ZA05939
         DC  Y(STE502B-STE502A)        PRINT FIELD LENGTH.     @Y30SSMK
         DC  H'0'                      CONVERSION FLAGS (CHAR) @Y30SSMK
* INSERT DATA SUB-STRUCTURE.                                   @Y30SSMK
         DC  X'2000'                   INSERT FLAG.            @Y30SSMK
         DC  H'20'                     REFERENCE NUMBER.       @Y30SSMK
         DC  H'0'                      UNUSED.                 @Y30SSMK
         DC  H'58'                     PRINT COLUMN.           @ZA05939
         DC  H'3'                      PRINT FIELD LENGTH.     @Y30SSMK
         DC  X'0820'                   CONVERSION FLGS (PU,SS) @Y30SSMK
* BLOCK DATA SUB-STRUCTURE.                                    @ZA05939
         DC  X'1000'                   BLOCK FLAG.             @ZA05939
         DC  H'6'                      INPUT LENGTH.           @ZA05939
         DC  H'1'                      INPUT OFFSET.           @ZA05939
         DC  H'84'                     PRINT COLUMN.           @ZA05939
         DC  H'6'                      PRINT FIELD LENGTH.     @ZA05939
         DC  X'0008'                   CONV FLAGS (CHAR,AR)    @ZA05939
* BLOCK DATA SUB-STRUCTURE.                                    @ZA05939
         DC  X'1000'                   BLOCK FLAG.             @ZA05939
         DC  H'3'                      INPUT LENGTH.           @ZA05939
         DC  H'7'                      INPUT OFFSET.           @ZA05939
         DC  H'110'                    PRINT COLUMN.           @ZA05939
         DC  H'6'                      PRINT FIELD LENGTH.     @ZA05939
         DC  X'4000'                   CONVERSION FLAGS (BHA)  @ZA05939
* SPACE CONTROL SUB-STRUCTURE.                                 @ZA05939
         DC  X'4000'                   SPACE FLAG.             @ZA05939
         DC  H'1'                      SPACING FACTOR.         @ZA05939
         DC  C'R '                     SPACING TYPE.           @ZA05939
* STATIC TEXT SUB-STRUCTURE.                                   @ZA05939
         DC  X'0400'                   STATIC FLAG.            @ZA05939
         DC  Y(STE504B-STE504A)        STATIC TEXT LENGTH.     @ZA05939
         DC  Y(STE504A-TXT50A)         TEXT OFFSET.            @ZA05939
         DC  H'8'                      PRINT COLUMN.           @ZA05939
         DC  Y(STE504B-STE504A)        PRINT FIELD LENGTH.     @ZA05939
         DC  H'0'                      CONVERSION FLAGS (CHAR) @ZA05939
* BLOCK DATA SUB-STRUCTURE.                                    @ZA05939
         DC  X'1000'                   BLOCK FLAG.             @ZA05939
         DC  H'1'                      INPUT LENGTH.           @ZA05939
         DC  H'0'                      INPUT OFFSET.           @ZA05939
         DC  H'30'                     PRINT COLUMN.           @ZA05939
         DC  H'2'                      PRINT FIELD LENGTH.     @ZA05939
         DC  X'10A0'                   CNVRSN FLGS (BD,ZS,SS)  @ZA05939
* INSERT DATA SUB-STRUCTURE.                                   @Y30SSMK
         DC  X'2000'                   INSERT FLAG.            @Y30SSMK
         DC  H'30'                     REFERENCE NUMBER.       @Y30SSMK
         DC  H'0'                      UNUSED.                 @Y30SSMK
         DC  H'55'                     PRINT COLUMN.           @ZA05939
         DC  H'5'                      PRINT FIELD LENGTH.     @Y30SSMK
         DC  X'0820'                   CONVERSION FLGS (PU,SS) @Y30SSMK
* STATIC TEXT SUB-STRUCTURE.                                   @Y30SSMK
         DC  X'0400'                   STATIC TEXT FLAGS.      @Y30SSMK
         DC  Y(STE502B-STE502A)        TEXT LENGTH.            @Y30SSMK
         DC  Y(STE502A-TXT50A)         TEXT OFFSET.            @Y30SSMK
         DC  H'57'                     PRINT COLUMN.           @ZA05939
         DC  Y(STE502B-STE502A)        PRINT FIELD LENGTH.     @Y30SSMK
         DC  H'0'                      CONVERSION FLAGS (CHAR) @Y30SSMK
* INSERT DATA SUB-STRUCTURE.                                   @Y30SSMK
         DC  X'2000'                   INSERT FLAG.            @Y30SSMK
         DC  H'30'                     REFERENCE NUMBER.       @Y30SSMK
         DC  H'0'                      UNUSED.                 @Y30SSMK
         DC  H'58'                     PRINT COLUMN.           @ZA05939
         DC  H'3'                      PRINT FIELD LENGTH.     @Y30SSMK
         DC  X'0820'                   CONVERSION FLGS (PU,SS) @Y30SSMK
* BLOCK DATA SUB-STRUCTURE.                                    @Y30SSMK
         DC  X'9000'                   BLOCK FLAG.             @ZA05939
         DC  H'4'                      INPUT LENGTH.           @Y30SSMK
         DC  H'10'                     INPUT OFFSET.           @Y30SSMK
         DC  H'79'                     PRINT COLUMN.           @ZA05939
         DC  H'8'                      PRINT FIELD LENGTH.     @Y30SSMK
         DC  X'4000'                   CONVERSION FLAGS (BHA)  @Y30SSMK
* STATIC TEXT ENTRY.                                           @Y30SSMK
STE501A  DC  C'OWNER-IDENT-------------     CREATION----------------'
         DC  C'     RCVY-VOL----------------     RCVY-CI-------------'
         DC  C'----'                                           @ZA05939
STE501B  EQU *                                                 @Y30SSMK
STE502A  DC  C'.'                                              @Y30SSMK
STE502B  EQU *                                                 @Y30SSMK
STE503A  DC  C'HISTORY'                                        @Y30SSMK
STE503B  EQU *                                                 @Y30SSMK
STE504A  DC  C'RELEASE-----------------     EXPIRATION--------------'
         DC  C'     RCVY-DEVT---------------'                  @ZA05939
STE504B  EQU *                                                 @ZA05939
TXT50B   EQU *                                                 @Y30SSMK
         EJECT                                                 @Y30SSMK
*                                                              @Y30SSMK
* ALTERNATEINDEX AND PATH ATTRIBUTES HEADER AND DATA LINE.     @Y30SSMK
*                                                              @Y30SSMK
TXT51    DC  Y(TXT51B-TXT51A)          ENTRY LENGTH.           @Y30SSMK
         DC  X'0000'                   HEADER FLAG.            @Y30SSMK
* SPACING SUB-STRUCTURE.                                       @Y30SSMK
TXT51A   DC  X'4000'                   SPACE FLAG.             @Y30SSMK
         DC  H'1'                      SPACING FLAG.           @Y30SSMK
         DC  C'R '                     SPACING TYPE.           @Y30SSMK
* STATIC TEXT SUB-STRUCTURE.                                   @Y30SSMK
         DC  X'0400'                   STATIC FLAG.            @Y30SSMK
         DC  Y(STE511B-STE511A)        STATIC TEXT LENGTH.     @Y30SSMK
         DC  Y(STE511A-TXT51A)         STATIC TEXT OFFSET.     @Y30SSMK
         DC  H'6'                      PRINT COLUMN.           @ZA05939
         DC  Y(STE511B-STE511A)        PRINT FIELD LENGTH.     @Y30SSMK
         DC  H'0'                      CONVERSION FLAGS (CHAR) @Y30SSMK
* SPACE CONTROL SUB-STRUCTURE.                                 @Y30SSMK
         DC  X'4000'                   SPACE FLAG.             @Y30SSMK
         DC  H'1'                      SPACING FACTOR.         @Y30SSMK
         DC  C'R '                     SPACING TYPE.           @Y30SSMK
* INSERT DATA SUB-STRUCTURE.                                   @Y30SSMK
         DC  X'A000'                   INSERT FLAG.            @Y30SSMK
         DC  H'10'                     REFERENCE NUMBER.       @Y30SSMK
         DC  H'0'                      UNUSED.                 @Y30SSMK
         DC  H'8'                      PRINT COLUMN.           @ZA05939
         DC  H'10'                     PRINT FIELD LENGTH.     @ZA05939
         DC  H'0'                      CONVERSION FLAGS (CHAR) @Y30SSMK
* STATIC TEXT ENTRIES.                                         @Y30SSMK
STE511A  DC  C'ATTRIBUTES'                                     @Y30SSMK
STE511B  EQU *                                                 @Y30SSMK
TXT51B   EQU *                                                 @Y30SSMK
         EJECT                                                 @Y30SSMK
*                                                              @Y30SSMK
* RELATIVE RECORD DATA SET ONLY CHARACTERISTICS HEADER AND DATA@ZA05939
* LINE.                                                        @Y30SSMK
*                                                              @Y30SSMK
TXT52    DC  Y(TXT52B-TXT52A)          ENTRY LENGTH.           @Y30SSMK
         DC  X'0000'                   HEADER FLAG.            @Y30SSMK
* SPACING CONTROL SUB-STRUCTURE.                               @Y30SSMK
TXT52A   DC  X'4000'                   SPACE FLAG.             @Y30SSMK
         DC  H'1'                      SPACING FACTOR.         @Y30SSMK
         DC  C'R '                     SPACING TYPE.           @Y30SSMK
* STATIC TEXT SUB-STRUCTURE.                                   @Y30SSMK
         DC  X'0400'                   STATIC FLAG.            @Y30SSMK
         DC  Y(STE521B-STE521A)        STATIC TEXT LENGTH.     @Y30SSMK
         DC  Y(STE521A-TXT52A)         STATIC TEXT OFFSET.     @Y30SSMK
         DC  H'8'                      PRINT COLUMN.           @ZA05939
         DC  Y(STE521B-STE521A)        PRINT FIELD LENGTH.     @Y30SSMK
         DC  H'0'                      CONVERSION FLAGS (CHAR) @Y30SSMK
* BLOCK DATA SUB-STRUCTURE.                                    @Y30SSMK
         DC  X'1000'                   BLOCK FLAG.             @Y30SSMK
         DC  H'4'                      INPUT LENGTH.           @ZA05939
         DC  H'28'                     INPUT OFFSET.           @ZA05939
         DC  H'22'                     PRINT COLUMN.           @ZA05939
         DC  H'10'                     PRINT FIELD LENGTH.     @ZA05939
         DC  X'10A0'                   CNVRSN FLGS (BD,ZS,SS)  @Y30SSMK
* BLOCK DATA SUB-STRUCTURE.                                    @Y30SSMK
         DC  X'9000'                   BLOCK FLAG.             @ZA05939
         DC  H'4'                      INPUT LENGTH.           @ZA05939
         DC  H'32'                     INPUT OFFSET.           @ZA05939
         DC  H'51'                     PRINT COLUMN.           @ZA05939
         DC  H'10'                     PRINT FIELD LENGTH.     @ZA05939
         DC  X'10A0'                   CNVRSN FLGS (BD,ZS,SS)  @Y30SSMK
* STATIC TEXT ENTRIES.                                         @Y30SSMK
STE521A  DC  C'RECORDS/CI--------------     MAXRECS-----------------'
STE521B  EQU *                                                 @Y30SSMK
TXT52B   EQU *                                                 @Y30SSMK
         EJECT                                                 @Y30SSMK
*                                                              @Y30SSMK
* PATH ENTRY HEADER - NON-IDENT.                               @Y30SSMK
*                                                              @Y30SSMK
TXT53    DC  Y(TXT53B-TXT53A)          ENTRY LENGTH.           @Y30SSMK
         DC  X'0000'                   FLAGS.                  @Y30SSMK
* SPACING CONTROL SUB-STRUCTURE.                               @Y30SSMK
TXT53A   DC  X'4000'                   SPACE SUB-STRUCTURE FLG @Y30SSMK
         DC  H'2'                      SPACING FACTOR.         @Y30SSMK
         DC  C'R '                     SPACING TYPE.           @Y30SSMK
* STATIC TEXT SUB-STRUCTURE.                                   @Y30SSMK
         DC  X'0400'                   STATIC TEXT FLAG.       @Y30SSMK
         DC  Y(STE531B-STE531A)        STATIC TEXT LENGTH.     @Y30SSMK
         DC  Y(STE531A-TXT53A)         STATIC TEXT OFFSET.     @Y30SSMK
         DC  H'1'                      PRINT COLUMN.           @Y30SSMK
         DC  Y(STE531B-STE531A)        PRINT FIELD LENGTH.     @Y30SSMK
         DC  H'0'                      CONVERSION FLAGS (CHAR) @Y30SSMK
* BLOCK DATA SUB-STRUCTURE.                                    @Y30SSMK
         DC  X'9000'                   INSERT DATA FLAG.       @Y30SSMK
         DC  H'44'                     INPUT LENGTH.           @Y30SSMK
         DC  H'0'                      INPUT OFFSET            @Y30SSMK
         DC  H'17'                     PRINT COLUMN.           @ZA05939
         DC  H'44'                     PRINT FIELD LENGTH.     @Y30SSMK
         DC  H'0'                      CONVERSION FLAGS (CHAR) @Y30SSMK
* STATIC TEXT ENTRY.                                           @Y30SSMK
STE531A  DC  C'PATH ---------- '                               @ZA05939
STE531B  EQU *                                                 @Y30SSMK
TXT53B   EQU *                                                 @Y30SSMK
         EJECT                                                 @Y30SSMK
*                                                              @Y30SSMK
* STATIC TEXT ENTRY 54 IS UNUSED.                              @ZA05939
*                                                              @ZA05939
         EJECT                                                 @Y30SSMK
*                                                              @Y30SSMK
* STATIC TEXT ENTRY 55 IS UNUSED.                              @ZA05939
*                                                              @Y30SSMK
         EJECT                                                 @Y30SSMK
*                                                              @Y30SSMK
* RELEASE, RECOVERY VOLUME, DEVICE, AND C.I. NUMBER            @Y30SSMK
* (INDENTED).                                                  @Y30SSMK
*                                                              @Y30SSMK
TXT56    DC  Y(TXT56B-TXT56A)          ENTRY LENGTH.           @Y30SSMK
         DC  X'0000'                   HEADER FLAG.            @Y30SSMK
* SPACING SUB-STRUCTURE.                                       @Y30SSMK
TXT56A   DC  X'4000'                   SPACE FLAG.             @Y30SSMK
         DC  H'1'                      SPACING FLAG.           @Y30SSMK
         DC  C'R '                     SPACING TYPE.           @Y30SSMK
* STATIC TEXT SUB-STRUCTURE.                                   @ZA05939
         DC  X'0400'                   STATIC TEXT FLAG.       @ZA05939
         DC  Y(STE562B-STE562A)        STATIC TEXT LENGTH.     @ZA05939
         DC  Y(STE562A-TXT56A)         STATIC TEXT OFFSET.     @ZA05939
         DC  H'6'                      PRINT COLUMN.           @ZA05939
         DC  Y(STE562B-STE562A)        PRINT FIELD LENGTH.     @ZA05939
         DC  H'0'                      CONVERSION FLAGS (CHAR) @ZA05939
* SPACE CONTROL SUB-STRUCTURE.                                 @ZA05939
         DC  X'4000'                   SPACE FLAG.             @ZA05939
         DC  H'1'                      SPACING FACTOR.         @ZA05939
         DC  C'R '                     SPACING TYPE.           @ZA05939
* STATIC TEXT SUB-STRUCTURE.                                   @Y30SSMK
         DC  X'0400'                   STATIC FLAG.            @Y30SSMK
         DC  Y(STE561B-STE561A)        STATIC TEXT LENGTH.     @Y30SSMK
         DC  Y(STE561A-TXT56A)         STATIC TEXT OFFSET.     @Y30SSMK
         DC  H'8'                      PRINT COLUMN.           @ZA05939
         DC  Y(STE561B-STE561A)        PRINT FIELD LENGTH.     @Y30SSMK
         DC  H'0'                      CONVERSION FLAGS (CHAR) @Y30SSMK
* BLOCK DATA SUB-STRUCTURE.                                    @Y30SSMK
         DC  X'1000'                   BLOCK FLAG.             @Y30SSMK
         DC  H'1'                      INPUT LENGTH.           @Y30SSMK
         DC  H'0'                      INPUT OFFSET.           @Y30SSMK
         DC  H'30'                     PRINT COLUMN.           @ZA05939
         DC  H'2'                      PRINT FIELD LENGTH.     @Y30SSMK
         DC  X'10A0'                   CNVRSN FLGS (BD,ZS,SS)  @Y30SSMK
* BLOCK DATA SUB-STRUCTURE.                                    @Y30SSMK
         DC  X'1000'                   BLOCK FLAG.             @Y30SSMK
         DC  H'6'                      INPUT LENGTH.           @Y30SSMK
         DC  H'1'                      INPUT OFFSET.           @Y30SSMK
         DC  H'55'                     PRINT COLUMN.           @ZA05939
         DC  H'6'                      PRINT FIELD LENGTH.     @Y30SSMK
         DC  X'0008'                   CONV FLAGS (CHAR,AR)    @ZA05939
* BLOCK DATA SUB-STRUCTURE.                                    @Y30SSMK
         DC  X'1000'                   BLOCK FLAG.             @Y30SSMK
         DC  H'4'                      INPUT LENGTH.           @Y30SSMK
         DC  H'10'                     INPUT OFFSET.           @Y30SSMK
         DC  H'79'                     PRINT COLUMN.           @ZA05939
         DC  H'8'                      PRINT FIELD LENGTH.     @Y30SSMK
         DC  X'4000'                   CONVERSION FLAGS (BHA)  @Y30SSMK
* BLOCK DATA SUB-STRUCTURE.                                    @Y30SSMK
         DC  X'9000'                   BLOCK FLAG.             @Y30SSMK
         DC  H'3'                      INPUT LENGTH.           @Y30SSMK
         DC  H'7'                      INPUT OFFSET.           @Y30SSMK
         DC  H'110'                    PRINT COLUMN.           @ZA05939
         DC  H'6'                      PRINT FIELD LENGTH.     @Y30SSMK
         DC  X'4000'                   CONVERSION FLAGS (BHA)  @Y30SSMK
* STATIC TEXT ENTRY.                                           @Y30SSMK
STE561A  DC  C'RELEASE-----------------     RCVY-VOL----------------'
         DC  C'     RCVY-DEVT---------------     RCVY-CI-------------'
         DC  C'----'                                           @ZA05939
STE561B  EQU *                                                 @Y30SSMK
STE562A  DC  C'HISTORY'                                        @ZA05939
STE562B  EQU *                                                 @ZA05939
TXT56B   EQU *                                                 @Y30SSMK
         EJECT                                                 @ZA01484
*                                                              @ZA01484
* SHORT LIST OF ENTRY NAMES                                    @ZA01484
*                                                              @ZA01484
TXT57    DC  Y(TXT57B-TXT57A)          ENTRY LENGTH.           @ZA01484
         DC  X'0000'                   FLAGS.                  @ZA01484
* SPACING CONTROL SUB-STRUCTURE.                               @ZA01484
TXT57A   DC  X'4000'                   SPACE SUBSTRUCTURE FLG  @ZA01484
         DC  H'1'                      SPACING FACTOR.         @ZA01484
         DC  C'R '                     SPACING TYPE.           @ZA01484
* STATIC TEXT SUB-STRUCTURE.                                   @ZA01484
         DC  X'0400'                   STATIC TEXT FLAG.       @ZA01484
         DC  Y(STE571B-STE571A)        STATIC TEXT LENGTH.     @ZA01484
         DC  Y(STE571A-TXT57A)         STATIC TEXT OFFSET.     @ZA01484
         DC  H'1'                      PRINT COLUMN.           @ZA01484
         DC  Y(STE571B-STE571A)        PRINT FIELD LENGTH.     @ZA01484
         DC  H'0'                      CONVERSION FLAGS (CHAR) @ZA01484
* BLOCK DATA SUB-STRUCTURE.                                    @ZA01484
         DC  X'1000'                   BLOCK DATA FLG          @ZA01484
         DC  H'45'                     INPUT LENGTH.           @ZA01484
         DC  H'1'                      INPUT OFFSET            @ZA01484
         DC  H'12'                     PRINT COLUMN            @ZA01484
         DC  H'44'                     PRINT FIELD LENGTH.     @ZA01484
         DC  H'0'                      CONVERSION FLAG (CHAR)  @ZA01484
* SPACING CONTROL SUB-STRUCTURE.                               @ZA01484
         DC  X'4000'                   SPACE SUBSTRUCTURE FLG  @ZA01484
         DC  H'1'                      SPACING FACTOR.         @ZA01484
         DC  C'R '                     SPACING TYPE.           @ZA01484
* REPLICATION SUB-STRUCTURE.                                   @ZA01484
         DC  X'0800'                   REDO FLAG               @ZA01484
         DC  H'10'                     REDO REF NUMBER         @ZA01484
         DC  H'1'                      REDO SUB-STRUC COUNT    @ZA01484
         DC  H'45'                     OFFSET BETWEEN FIELDS   @ZA01484
* BLOCK DATA SUB-STRUCTURE.                                    @ZA01484
         DC  X'9000'                   BLOCK DATA FLG & EOB    @ZA01484
         DC  H'90'                     INPUT LENGTH.           @ZA01484
         DC  H'46'                     INPUT OFFSET            @ZA01484
         DC  H'1'                      PRINT COLUMN            @ZA01484
         DC  H'44'                     PRINT FIELD LENGTH.     @ZA01484
         DC  H'0'                      CONVERSION FLAG (CHAR)  @ZA01484
* STATIC TEXT ENTRY.                                           @ZA01484
STE571A  DC  C'IN CATALOG:'                                    @ZA01484
STE571B  EQU *                                                 @ZA01484
TXT57B   EQU *                                                 @ZA01484
         EJECT                                                 @Y30SSMK
*                                                              @Y30SSMK
* TSO DATA SET NAMES DATA LINE.                                @Y30SSMK
*                                                              @Y30SSMK
TXT58    DC  Y(TXT58B-TXT58A)          ENTRY LENGTH.           @Y30SSMK
         DC  X'0000'                   FLAGS.                  @Y30SSMK
* SPACING CONTROL SUB-STRUCTURE.                               @Y30SSMK
TXT58A   DC  X'4000'                   SPACE FLAG.             @Y30SSMK
         DC  H'1'                      SPACING FACTOR.         @Y30SSMK
         DC  C'R '                     SPACING TYPE.           @Y30SSMK
* BLOCK DATA SUB-STRUCTURE.                                    @Y30SSMK
         DC  X'9000'                   BLOCK & EOF FLAGS.      @Y30SSMK
         DC  H'44'                     INPUT DATA LENGTH.      @Y30SSMK
         DC  H'0'                      INPUT DATA OFFSET.      @Y30SSMK
         DC  H'1'                      PRINT COLUMN.           @Y30SSMK
         DC  H'44'                     PRINT FIELD LENGTH.     @Y30SSMK
         DC  H'0'                      CONVERSION FLAGS (CHAR) @Y30SSMK
TXT58B   EQU *                                                 @Y30SSMK
         EJECT                                                 @Y30SSMK
*                                                              @Y30SSMK
* TSO VOLUME HEADER LINE.                                      @Y30SSMK
*                                                              @Y30SSMK
TXT59    DC  Y(TXT59B-TXT59A)          ENTRY LENGTH.           @Y30SSMK
         DC  X'0000'                   FLAGS.                  @Y30SSMK
* SPACE CONTROL SUB-STRUCTURE.                                 @Y30SSMK
TXT59A   DC  X'4000'                   SPACE CONTROL FLAG.     @Y30SSMK
         DC  H'1'                      SPACING FACTOR.         @Y30SSMK
         DC  C'R '                     SPACING TYPE.           @Y30SSMK
* STATIC TEXT SUB-STRUCTURE.                                   @Y30SSMK
         DC  X'8400'                   STATIC TEXT FLAG.       @Y30SSMK
         DC  Y(STE591B-STE591A)        STATIC TEXT LENGTH.     @Y30SSMK
         DC  Y(STE591A-TXT59A)         STATIC TEXT OFFSET.     @Y30SSMK
         DC  H'3'                      PRINT COLUMN.           @Y30SSMK
         DC  Y(STE591B-STE591A)        PRINT FIELD LENGTH.     @Y30SSMK
         DC  H'0'                      CONVERSION FLAGS (CHAR) @Y30SSMK
* STATIC TEXT ENTRY.                                           @Y30SSMK
STE591A  DC  C'--VOLUMES--'                                    @Y30SSMK
STE591B  EQU *                                                 @Y30SSMK
TXT59B   EQU *                                                 @Y30SSMK
         EJECT                                                 @Y30SSMK
*                                                              @Y30SSMK
* TSO VOLUME DATA LINE.                                        @Y30SSMK
*                                                              @Y30SSMK
TXT60    DC  Y(TXT60B-TXT60A)          ENTRY LENGTH.           @Y30SSMK
         DC  X'0000'                   FLAGS.                  @Y30SSMK
* SPACING CONTROL SUB-STRUCTURE.                               @Y30SSMK
TXT60A   DC  X'4000'                   SPACE FLAG.             @Y30SSMK
         DC  H'1'                      SPACING FACTOR.         @Y30SSMK
         DC  C'R '                     SPACING TYPE.           @Y30SSMK
* BLOCK DATA SUB-STRUCTURE.                                    @Y30SSMK
         DC  X'9000'                   BLOCK & EOF FLAGS.      @Y30SSMK
         DC  H'6'                      INPUT DATA LENGTH.      @Y30SSMK
         DC  H'0'                      INPUT DATA OFFSET.      @Y30SSMK
         DC  H'5'                      PRINT COLUMN.           @Y30SSMK
         DC  H'6'                      PRINT FIELD LENGTH.     @Y30SSMK
         DC  H'0'                      CONVERSION FLAGS (CHAR) @Y30SSMK
TXT60B   EQU *                                                 @Y30SSMK
         END
