* /* START OF SPECIFICATIONS ****                            @Y30LSMK
*
*01* MODULE-NAME = IDCTSLC1
*01* MODULE-TYPE = MODULE
*02*   PROCESSOR = ASSEMBLER
*
**** END OF SPECIFICATIONS **                                @Y30LSMK*/
         TITLE '***** IDCTSLC1 - LIST CATALOG STATIC TEXT *****'
**********************************************************************
*                                                                    *
* MODULE NAME - IDCTSLC1 - STATIC TEXT MODULE FOR LIST CATALOG       *
*                                      MESSAGES.                     *
*                                                                    *
* DESCRIPTIVE NAME - STATIC TEXT MODULE FOR THE FUNCTION LIST        *
*          CATALOG MESSAGES                                          *
*                                                                    *
* COPYRIGHT - NONE                                                   *
*                                                                    *
* STATUS - RELEASE 2  LEVEL 0                                        *
*                                                                    *
* FUNCTION - CONTAINS NO EXECUTABLE CODE, ONLY STATIC TEXT ENTRIES   *
*        FOR THE FUNCTION LIST CATALOG                               *
*        THIS MODULE IS LOADED BY IDCTP05 WHEN A STATIC TEXT         *
*        REQUEST IS MADE.                                            *
*                                                                    *
* NOTES - NONE                                                       *
*                                                                    *
*    DEPENDENCIES - NONE                                             *
*    RESTRICTIONS - NONE                                             *
*    REGISTER CONVENTIONS - NA                                       *
*    PATCH AREA - NA                                                 *
*                                                                    *
* MODULE TYPE - TABLES                                               *
*                                                                    *
*    PROCESSOR - ASSEMBLER                                           *
*    MODULE SIZE - 1480                                              *
*    ATTRIBUTES - READ-ONLY                                          *
*                                                                    *
*  ENTRY POINT - NA                                                  *
*                                                                    *
*  EXIT NORMAL - NA                                                  *
*                                                                    *
*  EXIT ERROR - NA                                                   *
*                                                                    *
*  EXTERNAL REFERENCES - NA                                          *
*                                                                    *
*  TABLES - NA                                                       *
*                                                                    *
*  MACROS - NA                                                       *
*                                                                    *
**********************************************************************
*
**********************************************************************
*                                                                    *
* THIS MODULE IS THE SECOND MODULE OF STATIC TEXT REQUIRED BY THE    *
* LIST CATALOG FUNCTIONAL SERVICE ROUTINE.                           *
*                                                                    *
**********************************************************************
*                                                                    *
IDCTSLC1 CSECT
*
**********************************************************************
*                                                                    *
* THIS SECTION CONTAINS THE INDICES TO REACH AN ENTRY.
*
INDEX    DC  H'12'                     COUNT OF ENTRIES.       @Y30LSMK
INDEX1   DC  H'-1'                     UNUSED                  @Y30SSMK
INDEX2   DC  Y(TXT2-INDEX)             LOW MAIN CORE
INDEX3   DC  Y(TXT3-INDEX)             VOL SER TOO LONG
INDEX4   DC  Y(TXT4-INDEX)             CONFLICTING FIELDS
INDEX5   DC  Y(TXT5-INDEX)             UNKNOWN TYPE
INDEX6   DC  Y(TXT6-INDEX)             NOT REQUESTED TYPE
INDEX7   DC  Y(TXT7-INDEX)             ENTRIES PROCESSED MESSAGE
INDEX8   DC  Y(TXT8-INDEX)             COULD NOT BE LISTED.
INDEX9   DC  Y(TXT9-INDEX)             INVALID ASSOCIATIONS.
INDEX10  DC  Y(TXT10-INDEX)            SUPPRESSED ENTRY MSG.
INDEX11  DC  Y(TXT11-INDEX)            SUPPRESSED ENTRY MSG.   @YL026UE
INDEX12  DC  Y(TXT12-INDEX)            EXPIR DATE WARNING      @Y30LSMK
         EJECT
**********************************************************************
*                                                                    *
* THIS SECTION CONTAINS THE ENTRIES.                                 *
*                                                                    *
**********************************************************************
*
*
* STATIC TEXT ENTRY 1 IS UNUSED.                               @Y30SSMK
*
*                                                              @Y30SSMK
         EJECT
*
* LACKING WORKSPACE FOR CATALOG ENTRY.
*
TXT2     DC  Y(TXT2B-TXT2A)            ENTRY LENGTH.
         DC  X'8000'                   MESSAGE FLAG.
* SPACING CONTROL SUB-STRUCTURE.
TXT2A    DC  X'4000'                   SPACE CONTROL FLAG.
         DC  H'2'                      SPACING FACTOR.
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC TEXT FLAG.
         DC  Y(STE21B-STE21A)          TEXT LENGTH.
         DC  Y(STE21A-TXT2A)           TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE21B-STE21A)          PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* BLOCK DATA SUB-STRUCTURE.
         DC  X'9000'                   BLOCK DATA FLAG.
         DC  H'44'                     MAXIMUM LENGTH.
         DC  H'0'                      OFFSET
         DC  H'28'                     PRINT COLUMN.
         DC  H'44'                     MAXIMUM LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* STATIC TEXT ENTRIES.
STE21A   DC  C'IDC1561I WKSPC LACKING FOR'
STE21B   EQU *
TXT2B    EQU *
         EJECT
*
* VOLUME SERIAL NUMBER TOO LONG.
*
TXT3     DC  Y(TXT3B-TXT3A)            ENTRY LENGTH.
         DC  X'8000'                   MESSAGE FLAG.
* SPACING CONTROL SUB-STRUCTURE.
TXT3A    DC  X'4000'                   SPACE CONTROL FLAG.
         DC  H'2'                      SPACING FACTOR.
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC TEXT FLAG.
         DC  Y(STE31B-STE31A)          TEXT LENGTH.
         DC  Y(STE31A-TXT3A)           TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE31B-STE31A)          PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* BLOCK DATA SUB-STRUCTURE.
         DC  X'1000'                   BLOCK DATA FLAG.
         DC  H'20'                     MAXIMUM LENGTH.
         DC  H'0'                      OFFSET
         DC  H'10'                     PRINT COLUMN.
         DC  H'20'                     MAXIMUM LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* STATIC TEXT SUB-STRUCTURE.
         DC  X'8400'                   STATIC TEXT FLAG.
         DC  Y(STE32B-STE32A)          TEXT LENGTH.
         DC  Y(STE32A-TXT3A)           TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN OFFSET.
         DC  Y(STE32B-STE32A)          PRINT FIELD LENGTH.
         DC  X'0010'                   CONVERSION FLAGS.  (CHAR,BS)
* STATIC TEXT ENTRIES.
STE31A   DC  C'IDC1562I'
STE31B   EQU *
STE32A   DC  C'VOLUME SERIAL NUMBER TOO LONG'
STE32B   EQU *
TXT3B    EQU *
         EJECT
*
* FIELDS CONFLICT FOR CATALOG DSNAME.
*
TXT4     DC  Y(TXT4B-TXT4A)            ENTRY LENGTH.
         DC  X'8000'                   MESSAGE FLAG.
* SPACING CONTROL SUB-STRUCTURE.
TXT4A    DC  X'4000'                   SPACE CONTROL FLAG.
         DC  H'2'                      SPACING FACTOR.
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'8400'                   STATIC TEXT FLAG.
         DC  Y(STE41B-STE41A)          TEXT LENGTH.
         DC  Y(STE41A-TXT4A)           TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE41B-STE41A)          PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* STATIC TEXT ENTRIES.
STE41A   DC  C'IDC2563I ALLOCATION/VOLUME PARAMETER IS INVALID FOR '
         DC  C'ENTRY TYPE(S)'
STE41B   EQU *
TXT4B    EQU *
         EJECT
*
* UNKNOWN TYPE MESSAGE.
*
TXT5     DC  Y(TXT5B-TXT5A)            ENTRY LENGTH.
         DC  X'8000'                   MESSAGE FLAG.
* SPACING CONTROL SUB-STRUCTURE.
TXT5A    DC  X'4000'                   SPACE CONTROL FLAG.
         DC  H'2'                      SPACING FACTOR.
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC TEXT FLAG.
         DC  Y(STE51B-STE51A)          TEXT LENGTH.
         DC  Y(STE51A-TXT5A)           TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE51B-STE51A)          PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* BLOCK DATA SUB-STRUCTURE.
         DC  X'9000'                   BLOCK DATA FLAG.
         DC  H'1'                      MAXIMUM LENGTH.
         DC  H'0'                      OFFSET
         DC  H'11'                     PRINT COLUMN.
         DC  H'1'                      MAXIMUM LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* STATIC TEXT ENTRIES.
STE51A   DC  C'IDC1564I '' '' IS AN UNKNOWN TYPE'
STE51B   EQU *
TXT5B    EQU *
         EJECT
*
* NOT REQUESTED TYPE MESSAGE.
*
TXT6     DC  Y(TXT6B-TXT6A)            ENTRY LENGTH.
         DC  X'8000'                   MESSAGE FLAG.
* SPACING CONTROL SUB-STRUCTURE.
TXT6A    DC  X'4000'                   SPACE CONTROL FLAG.
         DC  H'2'                      SPACING FACTOR.
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC TEXT FLAG.
         DC  Y(STE61B-STE61A)          TEXT LENGTH.
         DC  Y(STE61A-TXT6A)           TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE61B-STE61A)          PRINT FIELD LENGTH.
         DC  X'0000'                   CONVERSION FLAGS.  (CHAR)
* BLOCK DATA SUB-STRUCTURE.
         DC  X'1000'                   BLOCK DATA FLAG.
         DC  H'44'                     MAXIMUM DATA LENGTH.
         DC  H'0'                      DATA OFFSET.
         DC  H'10'                     PRINT COLUMN.
         DC  H'44'                     MAXIMUM DATA LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* STATIC TEXT SUB-STRUCTURE.
         DC  X'8400'                   EOF & STATIC TEXT FLAGS.
         DC  Y(STE62B-STE62A)          TEXT LENGTH.
         DC  Y(STE62A-TXT6A)           TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN OFFSET.
         DC  Y(STE62B-STE62A)          PRINT FIELD LENGTH.
         DC  X'0010'                   CONVERSION FLAGS.  (CHAR,BS)
* STATIC TEXT ENTRIES.
STE61A   DC  C'IDC1565I'
STE61B   EQU *
STE62A   DC  C'NOT A REQUESTED TYPE'
STE62B   EQU *
TXT6B    EQU *
         EJECT
*
* ENTRIES PROCESSED MESSAGE.
*
TXT7     DC  Y(TXT7B-TXT7A)            ENTRY LENGTH.
         DC  X'4000'                   HEADER FLAG.
HDLI71   DC  H'1'                      HEADER LINE COUNT.
HDSP71   DC  H'3'                      HEADER SPACE COUNT.
* SPACING CONTROL SUB-STRUCTURE.
TXT7A    DC  X'4000'                   SPACE CONTROL FLAG.
         DC  H'2'                      SPACING FACTOR.
         DC  C'E '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC FLAG.
         DC  Y(STE71B-STE71A)          TEXT LENGTH.
         DC  Y(STE71A-TXT7A)           TEXT OFFSET.
         DC  H'10'                     PRINT COLUMN.
         DC  Y(STE71B-STE71A)          PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.
* SPACING CONTROL SUB-STRUCTURE.                               @YL026UE
         DC  X'4000'                   SPACE CONTROL FLAG.     @YL026UE
         DC  H'1'                      SPACING FACTOR          @YL026UE
         DC  C'R '                     SPACING TYPE.           @YL026UE
* STATIC TEXT SUB-STRUCTURE.                                   @YL026UE
         DC  X'0400'                   STATIC TEXT FLAG.       @YL026UE
         DC  Y(STE712B-STE712A)        ENTRY LENGTH.           @ZA05939
         DC  Y(STE712A-TXT7A)          ENTRY OFFSET.           @ZA05939
         DC  H'20'                     PRINT COLUMN.           @YL026UE
         DC  Y(STE712B-STE712A)        PRINT FIELD LENGTH.     @ZA05939
         DC  H'0'                      CONVERSION FLAGS (CHAR) @YL026UE
* BLOCK DATA SUB-STRUCTURE.                                    @YL026UE
         DC  X'1000'                   BLOCK DATA FLAG.        @YL026UE
         DC  H'4'                      INPUT DATA LENGTH.      @YL026UE
         DC  H'36'                     INPUT OFFSET.           @ZA05939
         DC  H'34'                     PRINT COLUMN.           @YL026UE
         DC  H'10'                     PRINT FIELD LENGTH.     @YL026UE
         DC  X'10A0'                   CNVRSN FLAGS (BD,ZS,SS) @YL026UE
* SPACING CONTROL SUB-STRUCTURE.
         DC  X'4000'                   SPACE CONTROL FLAG.
         DC  H'1'                      SPACING FACTOR
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC TEXT FLAG.
         DC  Y(STE711B-STE711A)        ENTRY LENGTH.           @ZA05939
         DC  Y(STE711A-TXT7A)          ENTRY OFFSET.           @ZA05939
         DC  H'20'                     PRINT COLUMN.
         DC  Y(STE711B-STE711A)        PRINT FIELD LENGTH.     @ZA05939
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* BLOCK DATA SUB-STRUCTURE.
         DC  X'1000'                   BLOCK DATA FLAG.
         DC  H'4'                      INPUT DATA LENGTH.
         DC  H'24'                     INPUT OFFSET.           @ZA05939
         DC  H'34'                     PRINT COLUMN.
         DC  H'10'                     PRINT FIELD LENGTH.
         DC  X'10A0'                   CONVERSION FLAGS.  (BD,ZS,SS)
* SPACING CONTROL SUB-STRUCTURE.
         DC  X'4000'                   SPACE CONTROL FLAG.
         DC  H'1'                      SPACING FACTOR
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC TEXT FLAG.
         DC  Y(STE72B-STE72A)          ENTRY LENGTH.           @ZA05939
         DC  Y(STE72A-TXT7A)           ENTRY OFFSET.           @ZA05939
         DC  H'20'                     PRINT COLUMN.
         DC  Y(STE72B-STE72A)          PRINT FIELD LENGTH.     @ZA05939
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* BLOCK DATA SUB-STRUCTURE.
         DC  X'1000'                   BLOCK DATA FLAG.
         DC  H'4'                      INPUT DATA LENGTH.
         DC  H'0'                      INPUT OFFSET.           @ZA05939
         DC  H'34'                     PRINT COLUMN.
         DC  H'10'                     PRINT FIELD LENGTH.
         DC  X'10A0'                   CONVERSION FLAGS.  (BD,ZS,SS)
* SPACING CONTROL SUB-STRUCTURE.                               @YL026UE
         DC  X'4000'                   SPACE CONTROL FLAG.     @YL026UE
         DC  H'1'                      SPACING FACTOR          @YL026UE
         DC  C'R '                     SPACING TYPE.           @YL026UE
* STATIC TEXT SUB-STRUCTURE.                                   @YL026UE
         DC  X'0400'                   STATIC TEXT FLAG.       @YL026UE
         DC  Y(STE73B-STE73A)          ENTRY LENGTH.           @ZA05939
         DC  Y(STE73A-TXT7A)           ENTRY OFFSET.           @ZA05939
         DC  H'20'                     PRINT COLUMN.           @YL026UE
         DC  Y(STE73B-STE73A)          PRINT FIELD LENGTH.     @ZA05939
         DC  H'0'                      CONVERSION FLAGS (CHAR) @YL026UE
* BLOCK DATA SUB-STRUCTURE.                                    @YL026UE
         DC  X'1000'                   BLOCK DATA FLAG.        @YL026UE
         DC  H'4'                      INPUT DATA LENGTH.      @YL026UE
         DC  H'4'                      INPUT OFFSET.           @ZA05939
         DC  H'34'                     PRINT COLUMN.           @YL026UE
         DC  H'10'                     PRINT FIELD LENGTH.     @YL026UE
         DC  X'10A0'                   CVRSN FLAGS (BD,ZS,SS)  @YL026UE
* SPACING CONTROL SUB-STRUCTURE.
         DC  X'4000'                   SPACE CONTROL FLAG.
         DC  H'1'                      SPACING FACTOR
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC TEXT FLAG.
         DC  Y(STE710B-STE710A)        ENTRY LENGTH.           @ZA05939
         DC  Y(STE710A-TXT7A)          ENTRY OFFSET.           @ZA05939
         DC  H'20'                     PRINT COLUMN.
         DC  Y(STE710B-STE710A)        PRINT FIELD LENGTH.     @ZA05939
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* BLOCK DATA SUB-STRUCTURE.
         DC  X'1000'                   BLOCK DATA FLAG.
         DC  H'4'                      INPUT DATA LENGTH.
         DC  H'28'                     INPUT OFFSET.           @ZA05939
         DC  H'34'                     PRINT COLUMN.
         DC  H'10'                     PRINT FIELD LENGTH.
         DC  X'10A0'                   CONVERSION FLAGS.  (BD,ZS,SS)
* SPACING CONTROL SUB-STRUCTURE.
         DC  X'4000'                   SPACE CONTROL FLAG.
         DC  H'1'                      SPACING FACTOR
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.                                   @Y30SSMK
         DC  X'0400'                   STATIC TEXT FLAG.       @Y30SSMK
         DC  Y(STE74B-STE74A)          ENTRY LENGTH.           @ZA05939
         DC  Y(STE74A-TXT7A)           ENTRY OFFSET.           @ZA05939
         DC  H'20'                     PRINT COLUMN.           @Y30SSMK
         DC  Y(STE74B-STE74A)          PRINT FIELD LENGTH.     @ZA05939
         DC  H'0'                      CONVERSION FLAGS (CHAR) @Y30SSMK
* BLOCK DATA SUB-STRUCTURE.                                    @Y30SSMK
         DC  X'1000'                   BLOCK DATA FLAG.        @Y30SSMK
         DC  H'4'                      INPUT DATA LENGTH.      @Y30SSMK
         DC  H'8'                      INPUT OFFSET.           @ZA05939
         DC  H'34'                     PRINT COLUMN.           @Y30SSMK
         DC  H'10'                     PRINT FIELD LENGTH.     @Y30SSMK
         DC  X'10A0'                   CNVRSN FLGS (BD,ZS,SS)  @Y30SSMK
* SPACING CONTROL SUB-STRUCTURE.                               @Y30SSMK
         DC  X'4000'                   SPACE CONTROL FLAG.     @Y30SSMK
         DC  H'1'                      SPACING FACTOR          @Y30SSMK
         DC  C'R '                     SPACING TYPE.           @Y30SSMK
* STATIC TEXT SUB-STRUCTURE.                                   @Y30SSMK
         DC  X'0400'                   STATIC TEXT FLAG.       @Y30SSMK
         DC  Y(STE75B-STE75A)          ENTRY LENGTH.           @ZA05939
         DC  Y(STE75A-TXT7A)           ENTRY OFFSET.           @ZA05939
         DC  H'20'                     PRINT COLUMN.           @Y30SSMK
         DC  Y(STE75B-STE75A)          PRINT FIELD LENGTH.     @ZA05939
         DC  H'0'                      CONVERSION FLAGS (CHAR) @Y30SSMK
* BLOCK DATA SUB-STRUCTURE.                                    @Y30SSMK
         DC  X'1000'                   BLOCK DATA FLAG.        @Y30SSMK
         DC  H'4'                      INPUT DATA LENGTH.      @Y30SSMK
         DC  H'12'                     INPUT OFFSET.           @ZA05939
         DC  H'34'                     PRINT COLUMN.           @Y30SSMK
         DC  H'10'                     PRINT FIELD LENGTH.     @Y30SSMK
         DC  X'10A0'                   CNVRSN FLGS (BD,ZS,SS)  @Y30SSMK
* SPACING CONTROL SUB-STRUCTURE.                               @Y30SSMK
         DC  X'4000'                   SPACE CONTROL FLAG.     @Y30SSMK
         DC  H'1'                      SPACING FACTOR          @Y30SSMK
         DC  C'R '                     SPACING TYPE.           @Y30SSMK
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC TEXT FLAG.
         DC  Y(STE79B-STE79A)          ENTRY LENGTH.           @ZA05939
         DC  Y(STE79A-TXT7A)           ENTRY OFFSET.           @ZA05939
         DC  H'20'                     PRINT COLUMN.
         DC  Y(STE79B-STE79A)          PRINT FIELD LENGTH.     @ZA05939
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* BLOCK DATA SUB-STRUCTURE.
         DC  X'1000'                   BLOCK DATA FLAG.
         DC  H'4'                      INPUT DATA LENGTH.
         DC  H'32'                     INPUT OFFSET.           @ZA05939
         DC  H'34'                     PRINT COLUMN.
         DC  H'10'                     PRINT FIELD LENGTH.
         DC  X'10A0'                   CONVERSION FLAGS.  (BD,ZS,SS)
* SPACING CONTROL SUB-STRUCTURE.                               @YL026UE
         DC  X'4000'                   SPACE CONTROL FLAG.     @YL026UE
         DC  H'1'                      SPACING FACTOR          @YL026UE
         DC  C'R '                     SPACING TYPE.           @YL026UE
* STATIC TEXT SUB-STRUCTURE.                                   @YL026UE
         DC  X'0400'                   STATIC TEXT FLAG.       @YL026UE
         DC  Y(STE713B-STE713A)        ENTRY LENGTH.           @ZA05939
         DC  Y(STE713A-TXT7A)          ENTRY OFFSET.           @ZA05939
         DC  H'20'                     PRINT COLUMN.           @YL026UE
         DC  Y(STE713B-STE713A)        PRINT FIELD LENGTH.     @ZA05939
         DC  H'0'                      CONVERSION FLAGS (CHAR) @YL026UE
* BLOCK DATA SUB-STRUCTURE.                                    @YL026UE
         DC  X'1000'                   BLOCK DATA FLAG.        @YL026UE
         DC  H'4'                      INPUT DATA LENGTH.      @YL026UE
         DC  H'40'                     INPUT OFFSET.           @ZA05939
         DC  H'34'                     PRINT COLUMN.           @YL026UE
         DC  H'10'                     PRINT FIELD LENGTH.     @YL026UE
         DC  X'10A0'                   CNVRSN FLAGS (BD,ZS,SS) @YL026UE
* SPACING CONTROL SUB-STRUCTURE.
         DC  X'4000'                   SPACE CONTROL FLAG.
         DC  H'1'                      SPACING FACTOR
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC TEXT FLAG.
         DC  Y(STE77B-STE77A)          ENTRY LENGTH.
         DC  Y(STE77A-TXT7A)           ENTRY OFFSET.
         DC  H'20'                     PRINT COLUMN.
         DC  Y(STE77B-STE77A)          PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* BLOCK DATA SUB-STRUCTURE.
         DC  X'1000'                   BLOCK DATA FLAG.
         DC  H'4'                      INPUT DATA LENGTH.
         DC  H'20'                     INPUT OFFSET.
         DC  H'34'                     PRINT COLUMN.
         DC  H'10'                     PRINT FIELD LENGTH.
         DC  X'10A0'                   CONVERSION FLAGS.  (BD,ZS,SS)
* SPACING CONTROL SUB-STRUCTURE.                               @YL026UE
         DC  X'4000'                   SPACE CONTROL FLAG.     @YL026UE
         DC  H'1'                      SPACING FACTOR          @YL026UE
         DC  C'R '                     SPACING TYPE.           @YL026UE
* STATIC TEXT SUB-STRUCTURE.                                   @YL026UE
         DC  X'0400'                   STATIC TEXT FLAG.       @YL026UE
         DC  Y(STE76B-STE76A)          ENTRY LENGTH.           @YL026UE
         DC  Y(STE76A-TXT7A)           ENTRY OFFSET.           @YL026UE
         DC  H'20'                     PRINT COLUMN.           @YL026UE
         DC  Y(STE76B-STE76A)          PRINT FIELD LENGTH.     @YL026UE
         DC  H'0'                      CONVERSION FLAGS (CHAR) @YL026UE
* BLOCK DATA SUB-STRUCTURE.                                    @YL026UE
         DC  X'1000'                   BLOCK DATA FLAG.        @YL026UE
         DC  H'4'                      INPUT DATA LENGTH.      @YL026UE
         DC  H'16'                     INPUT OFFSET.           @YL026UE
         DC  H'34'                     PRINT COLUMN.           @YL026UE
         DC  H'10'                     PRINT FIELD LENGTH.     @YL026UE
         DC  X'10A0'                   CNVRSN FLAGS (BD,ZS,SS) @YL026UE
* SPACING CONTROL SUB-STRUCTURE.
         DC  X'4000'                   SPACE CONTROL FLAG.
         DC  H'1'                      SPACING FACTOR
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC TEXT FLAG.
         DC  Y(STE78B-STE78A)          ENTRY LENGTH.
         DC  Y(STE78A-TXT7A)           ENTRY OFFSET.
         DC  H'20'                     PRINT COLUMN.
         DC  Y(STE78B-STE78A)          PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* BLOCK DATA SUB-STRUCTURE.
         DC  X'9000'                   BLOCK DATA FLAG.
         DC  H'4'                      INPUT DATA LENGTH.
         DC  H'44'                     INPUT OFFSET.           @Y30SSMK
         DC  H'34'                     PRINT COLUMN.
         DC  H'10'                     PRINT FIELD LENGTH.
         DC  X'10A0'                   CONVERSION FLAGS.  (BD,ZS,SS)
* STATIC TEXT ENTRIES.
STE71A   DC  C'THE NUMBER OF ENTRIES PROCESSED WAS:'
STE71B   EQU *
STE72A   DC  C'CLUSTER ----------------'                       @ZA05939
STE72B   EQU *
STE73A   DC  C'DATA -------------------'                       @ZA05939
STE73B   EQU *
STE74A   DC  C'INDEX ------------------'                       @ZA05939
STE74B   EQU *
STE75A   DC  C'NONVSAM ----------------'                       @ZA05939
STE75B   EQU *
STE76A   DC  C'USERCATALOG ------------'                       @ZA05939
STE76B   EQU *
STE77A   DC  C'SPACE ------------------'                       @ZA05939
STE77B   EQU *
STE78A   DC  C'TOTAL ------------------'                       @ZA05939
STE78B   EQU *
STE79A   DC  C'PAGESPACE --------------'                       @ZA05939
STE79B   EQU *                                                 @YL026UE
STE710A  DC  C'GDG --------------------'                       @ZA05939
STE710B  EQU *                                                 @YL026UE
STE711A  DC  C'ALIAS ------------------'                       @ZA05939
STE711B  EQU *                                                 @YL026UE
STE712A  DC  C'AIX --------------------'                       @ZA05939
STE712B  EQU *                                                 @Y30SSMK
STE713A  DC  C'PATH -------------------'                       @ZA05939
STE713B  EQU *                                                 @Y30SSMK
TXT7B    EQU *
         EJECT
*
* DATA SET COULD NOT BE LISTED.
*
TXT8     DC  Y(TXT8B-TXT8A)            ENTRY LENGTH.
         DC  X'A000'                   MESSAGE FLAG.
* STATIC TEXT SUB-STRUCTURE.
TXT8A    DC  X'0400'                   STATIC TEXT FLAG.
         DC  Y(STE81B-STE81A)          TEXT LENGTH.
         DC  Y(STE81A-TXT8A)           TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE81B-STE81A)          PRINT FIELD LENGTH.
         DC  X'0000'                   CONVERSION FLAGS.  (CHAR)
* BLOCK DATA SUB-STRUCTURE.
         DC  X'1000'                   BLOCK DATA FLAG.
         DC  H'44'                     MAXIMUM DATA LENGTH.
         DC  H'0'                      DATA OFFSET.
         DC  H'13'                     PRINT COLUMN.
         DC  H'44'                     MAXIMUM DATA LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* STATIC TEXT SUB-STRUCTURE.
         DC  X'8400'                   EOF & STATIC TEXT FLAGS.
         DC  Y(STE82B-STE82A)          TEXT LENGTH.
         DC  Y(STE82A-TXT8A)           TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN OFFSET.
         DC  Y(STE82B-STE82A)          PRINT FIELD LENGTH.
         DC  X'0010'                   CONVERSION FLAGS.  (CHAR,BS)
* STATIC TEXT ENTRIES.
STE81A   DC  C'IDC1566I **'
STE81B   EQU *
STE82A   DC  C'NOT LISTED'                                       YM4831
STE82B   EQU *
TXT8B    EQU *
         EJECT
*
* INVALID ASSOCIATIONS
*
TXT9     DC  Y(TXT9B-TXT9A)            ENTRY LENGTH.
         DC  X'A000'                   MESSAGE FLAG.
* STATIC TEXT SUB-STRUCTURE.
TXT9A    DC  X'0400'                   STATIC TEXT FLAG.
         DC  Y(STE91B-STE91A)          TEXT LENGTH.
         DC  Y(STE91A-TXT9A)           TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE91B-STE91A)          PRINT FIELD LENGTH.
         DC  X'0000'                   CONVERSION FLAGS.  (CHAR)
* BLOCK DATA SUB-STRUCTURE.
         DC  X'9000'                   BLOCK DATA FLAG.
         DC  H'3'                      INPUT DATA LENGTH
         DC  H'0'                      DATA OFFSET.
         DC  H'45'                     PRINT COLUMN.
         DC  H'6'                      MAXIMUM DATA LENGTH.
         DC  X'4000'                   CONVERSION FLAGS.  (BHA)
* STATIC TEXT ENTRIES.
STE91A   DC  C'IDC1567I ** INVALID CONTROL INTERVAL NUMBER'
STE91B   EQU *
TXT9B    EQU *
         EJECT
*
* PASSWORD PROTECTED ENTRIES SUPPRESSED.
*
TXT10    DC  Y(TXT10B-TXT10A)          ENTRY LENGTH.
         DC  X'0000'                   NO FLAG.
* SPACING CONTROL SUB-STRUCTURE.
TXT10A   DC  X'4000'                   SPACE CONTROL FLAG.
         DC  H'2'                      SPACING FACTOR.
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC TEXT FLAG.
         DC  Y(STE101B-STE101A)        TEXT LENGTH.
         DC  Y(STE101A-TXT10A)         TEXT OFFSET.
         DC  H'10'                     PRINT COLUMN.
         DC  Y(STE101B-STE101A)        PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* BLOCK DATA SUB-STRUCTURE.
         DC  X'9000'                   EOF & BLOCK DATA FLAG.
         DC  H'4'                      MAXIMUM LENGTH.
         DC  H'0'                      OFFSET
         DC  H'57'                     PRINT COLUMN.
         DC  H'10'                     MAXIMUM LENGTH.
         DC  X'1060'                   CONVERSION FLAGS.  (BD,AL,SS)
* STATIC TEXT ENTRIES.
STE101A  DC  C'THE NUMBER OF PROTECTED ENTRIES SUPPRESSED WAS '
STE101B  EQU *
TXT10B   EQU *
         EJECT                                                 @YL026UE
*                                                              @YL026UE
* INVALID * FIRST OR LAST CHARACTER.                           @YL026UE
*                                                              @YL026UE
TXT11    DC  Y(TXT11B-TXT11A)          ENTRY LENGTH.           @YL026UE
         DC  X'8000'                   MESSAGE FLAG.           @YL026UE
* SPACING CONTROL SUB-STRUCTURE.                               @YL026UE
TXT11A   DC  X'4000'                   SPACE CONTROL FLAG.     @YL026UE
         DC  H'2'                      SPACING FACTOR.         @YL026UE
         DC  C'R '                     SPACING TYPE.           @YL026UE
* STATIC TEXT SUB-STRUCTURE.                                   @YL026UE
         DC  X'0400'                   STATIC TEXT FLAG.       @YL026UE
         DC  Y(STE111B-STE111A)        TEXT LENGTH.            @YL026UE
         DC  Y(STE111A-TXT11A)         TEXT OFFSET.            @YL026UE
         DC  H'1'                      PRINT COLUMN.           @YL026UE
         DC  Y(STE111B-STE111A)        PRINT FIELD LENGTH.     @YL026UE
         DC  H'0'                      CONVERSION FLAGS (CHAR) @YL026UE
* BLOCK DATA SUB-STRUCTURE.                                    @YL026UE
         DC  X'1000'                   BLOCK DATA FLAG.        @YL026UE
         DC  H'44'                     MAXIMUM LENGTH.         @YL026UE
         DC  H'0'                      OFFSET                  @YL026UE
         DC  H'10'                     PRINT COLUMN.           @YL026UE
         DC  H'44'                     MAXIMUM LENGTH.         @YL026UE
         DC  H'0'                      CONVERSION FLAGS (CHAR) @YL026UE
* STATIC TEXT SUB-STRUCTURE.                                   @YL026UE
         DC  X'8400'                   STATIC TEXT FLAG.       @YL026UE
         DC  Y(STE112B-STE112A)        TEXT LENGTH.            @YL026UE
         DC  Y(STE112A-TXT11A)         TEXT OFFSET.            @YL026UE
         DC  H'1'                      PRINT COLUMN OFFSET.    @YL026UE
         DC  Y(STE112B-STE112A)        PRINT FIELD LENGTH.     @YL026UE
         DC  X'0010'                   CNVRSN FLAGS (CHAR,BS)  @YL026UE
* STATIC TEXT ENTRIES.                                         @YL026UE
STE111A  DC  C'IDC3568I'                                       @YL026UE
STE111B  EQU *                                                 @YL026UE
STE112A  DC  C'INVALID USE OF *'                               @YL026UE
STE112B  EQU *                                                 @YL026UE
TXT11B   EQU *                                                 @YL026UE
         EJECT                                                 @Y30LSMK
*                                                              @Y30LSMK
* EXPIRATION DATE WARNING.                                     @Y30LSMK
*                                                              @Y30LSMK
TXT12    DC  Y(TXT12B-TXT12A)          ENTRY LENGTH.           @Y30LSMK
         DC  X'8000'                   MESSAGE FLAG.           @Y30LSMK
* SPACING CONTROL SUB-STRUCTURE.                               @Y30LSMK
TXT12A   DC  X'4000'                   SPACE CONTROL FLAG.     @Y30LSMK
         DC  H'2'                      SPACING FACTOR.         @Y30LSMK
         DC  C'R '                     SPACING TYPE.           @Y30LSMK
* STATIC TEXT SUB-STRUCTURE.                                   @Y30LSMK
         DC  X'8400'                   STATIC TEXT FLAG.       @Y30LSMK
         DC  Y(STE121B-STE121A)        TEXT LENGTH.            @Y30LSMK
         DC  Y(STE121A-TXT12A)         TEXT OFFSET.            @Y30LSMK
         DC  H'1'                      PRINT COLUMN.           @Y30LSMK
         DC  Y(STE121B-STE121A)        PRINT FIELD LENGTH.     @Y30LSMK
         DC  H'0'                      CONVERSION FLAGS (CHAR) @Y30LSMK
* STATIC TEXT ENTRIES.                                         @Y30LSMK
STE121A  DC  C'IDC1569I EXPIRATION PARAMETER DOES NOT APPLY '  @Y30LSMK
         DC  C'TO ENTRY TYPE(S)'                               @Y30LSMK
STE121B  EQU *                                                 @Y30LSMK
TXT12B   EQU *                                                 @Y30LSMK
         END
