         TITLE '***** IDCTSLD0 - LISTDSET STATIC TEXT *****'
* /* START OF SPECIFICATIONS ****
*01* PROCESSOR = ASSEM
**** END OF SPECIFICATIONS****
************************************************************** @Z40LB26
*                                                            * @Z40LB26
* MODULE NAME - IDCTSLD0                                     * @Z40LB26
*                                                            * @Z40LB26
* DESCRIPTIVE NAME - VS/2 STATIC TEXT MODULE FOR LISTDSET    * @G24LB31
*                                                            * @Z40LB26
* COPYRIGHT - NONE                                           * @Z40LB26
*                                                            * @Z40LB26
* STATUS - MSS RELEASE 3, CHANGE LEVEL = 3                   * @ZA29215
*                                                            * @Z40LB26
* FUNCTION - CONTAINS NO EXECUTABLE CODE - ONLY STATIC TEXT  * @Z40LB26
*        ENTRIES FOR THE LISTDSET FUNCTION                   * @Z40LB26
*                                                            * @Z40LB26
* NOTES - THIS MODULE IS LOADED BY IDCTP05 WHEN A STATIC     * @Z40LB26
*        TEXT REQUEST IS MADE                                * @Z40LB26
*                                                            * @Z40LB26
* DEPENDENCIES - NONE                                        * @Z40LB26
*                                                            * @Z40LB26
* RESTRICTIONS - NONE                                        * @Z40LB26
*                                                            * @Z40LB26
* REGISTER CONVENTIONS - NA                                  * @Z40LB26
*                                                            * @Z40LB26
* PATCH AREA - NA                                            * @Z40LB26
*                                                            * @Z40LB26
* MODULE TYPE - TABLES                                       * @Z40LB26
*                                                            * @Z40LB26
* PROCESSOR - ASSEMBLER                                      * @Z40LB26
*                                                            * @Z40LB26
* MODULE SIZE - 4352 DECIMAL BYTES                           * @G24LB31
*                                                            * @Z40LB26
* ATTRIBUTES - READ ONLY                                     * @Z40LB26
*                                                            * @Z40LB26
* CHANGE ACTIVITY -                                          * @Z40LB26
*   01 04/05/76 - RACF D.S. PROTECTION INFO IN STATUS REPORT * @G24LB31
*   02 08/11/76 - @G24LB31 CHANGE OFFSET IN USAGE RPT        * @ZM44011
*   03 01/30/78 - FIX FOR FREE SPACE IN USAGE REPORT         * @ZA29215
*                                                            * @Z40LB26
************************************************************** @Z40LB26
         EJECT                                                 @Z40LB26
IDCTSLD0 CSECT                                                 @Z40LB26
************************************************************** @Z40LB26
*                                                            * @Z40LB26
*  THIS SECTION CONTAINS THE INDICES TO ADDRESS THE TEXT     * @Z40LB26
*  ENTRIES                                                   * @Z40LB26
*                                                            * @Z40LB26
************************************************************** @Z40LB26
INDEX    DC    Y((INDEXEND-INDEX1)/2)  COUNT OF ENTRIES        @Z40LB26
INDEX1   DC    Y(TXT01-INDEX)          USAGE RTP VOL SUBTITLE  @Z40LB26
INDEX2   DC    Y(TXT02-INDEX)          USAGE RPT GRP SUBTITLE  @Z40LB26
INDEX3   DC    Y(TXT03-INDEX)          STATUS RPT VOL SUBTITLE @Z40LB26
INDEX4   DC    Y(TXT04-INDEX)          STATUS RPT GRP SUBTITLE @Z40LB26
INDEX5   DC    Y(TXT05-INDEX)          GRP OWNER-ADDR LINES    @Z40LB26
INDEX6   DC    Y(TXT06-INDEX)          USAGE RPT DATA LINES    @Z40LB26
INDEX7   DC    Y(TXT07-INDEX)          STATUS RPT DATA LINES   @Z40LB26
INDEX8   DC    Y(TXT08-INDEX)          USAGE RPT SUMMARY LINES @Z40LB26
INDEX9   DC    Y(TXT09-INDEX)          STATUS RPT SUMMARY LINE @Z40LB26
INDEX10  DC    Y(TXT10-INDEX)          USAGE RPT LEGEND LINES  @Z40LB26
INDEX11  DC    Y(TXT11-INDEX)          STATUS RPT LEGEND LINES @Z40LB26
INDEX12  DC    Y(TXT12-INDEX)          PRINT CONSTANTS         @Z40LB26
*                                      USED AS INSERT          @Z40LB26
INDEX13  DC    Y(TXT13-INDEX)          SUB-TITLE LINE FOR      @Z40LB26
*                                      LEGENDS                 @Z40LB26
INDEXEND DS    0H                                              @Z40LB26
         EJECT                                                 @Z40LB26
************************************************************** @Z40LB26
*                                                            * @Z40LB26
*  USAGE REPORT - VOLUME SUBTITLE                            * @Z40LB26
*                                                            * @Z40LB26
************************************************************** @Z40LB26
TXT01    DC    Y(TXT01B-TXT01A)        ENTRY LENGTH            @Z40LB26
         DC    X'0000'                 FLAGS                   @Z40LB26
         SPACE 1                                               @Z40LB26
************************************************************** @Z40LB26
*                                                            * @Z40LB26
*  STATIC TEXT SUB-STRUCTURE                                 * @Z40LB26
*                                                            * @Z40LB26
************************************************************** @Z40LB26
TXT01A   DC    X'8400'                 STATIC TEXT FLAG        @Z40LB26
         DC    Y(STE01B-STE01A)        TEXT LENGTH             @Z40LB26
         DC    Y(STE01A-TXT01A)        TEXT OFFSET             @Z40LB26
         DC    H'1'                    PRINT COLUMN            @Z40LB26
         DC    Y(STE01B-STE01A)        PRINT FIELD LENGTH      @Z40LB26
         DC    H'0'                    CONVERSION FLAGS        @Z40LB26
************************************************************** @Z40LB26
*                                                            * @Z40LB26
*  STATIC TEXT ENTRY                                         * @Z40LB26
*                                                            * @Z40LB26
************************************************************** @Z40LB26
STE01A   DC    C'0'                    SPACE ONE LINE          @Z40LB26
         DC    C'               NON VSAM SPACE USAGE REPORT'   @Z40LB26
         DC    C' FOR VOLUME       '                           @Z40LB26
STE01B   EQU   *                                               @Z40LB26
TXT01B   EQU   *                                               @Z40LB26
         EJECT                                                 @Z40LB26
************************************************************** @Z40LB26
*                                                            * @Z40LB26
*  USAGE REPORT - GROUP SUBTITLE                             * @Z40LB26
*                                                            * @Z40LB26
************************************************************** @Z40LB26
TXT02    DC    Y(TXT02B-TXT02A)        ENTRY LENGTH            @Z40LB26
         DC    X'0000'                 FLAGS                   @Z40LB26
         SPACE 1                                               @Z40LB26
************************************************************** @Z40LB26
*                                                            * @Z40LB26
*  STATIC TEXT SUB-STRUCTURE                                 * @Z40LB26
*                                                            * @Z40LB26
************************************************************** @Z40LB26
TXT02A   DC    X'8400'                 STATIC TEXT FLAG        @Z40LB26
         DC    Y(STE02B-STE02A)        TEXT LENGTH             @Z40LB26
         DC    Y(STE02A-TXT02A)        TEXT OFFSET             @Z40LB26
         DC    H'1'                    PRINT COLUMN            @Z40LB26
         DC    Y(STE02B-STE02A)        PRINT FIELD LENGTH      @Z40LB26
         DC    H'0'                    CONVERSION FLAGS        @Z40LB26
************************************************************** @Z40LB26
*                                                            * @Z40LB26
*  STATIC TEXT ENTRY                                         * @Z40LB26
*                                                            * @Z40LB26
************************************************************** @Z40LB26
STE02A   DC    C'0'                    SKIP ONE LINE           @Z40LB26
         DC    C'        NON VSAM SPACE USAGE REPORT'          @Z40LB26
         DC    C' FOR GROUP          - VOLUME       '          @Z40LB26
STE02B   EQU   *                                               @Z40LB26
TXT02B   EQU   *                                               @Z40LB26
         EJECT                                                 @Z40LB26
************************************************************** @Z40LB26
*                                                            * @Z40LB26
*  STATUS REPORT - VOLUME SUBTITLE                           * @Z40LB26
*                                                            * @Z40LB26
************************************************************** @Z40LB26
TXT03    DC    Y(TXT03B-TXT03A)        ENTRY LENGTH            @Z40LB26
         DC    X'0000'                 FLAGS                   @Z40LB26
         SPACE 1                                               @Z40LB26
************************************************************** @Z40LB26
*                                                            * @Z40LB26
*  STATIC TEXT SUB-STRUCTURE                                 * @Z40LB26
*                                                            * @Z40LB26
************************************************************** @Z40LB26
TXT03A   DC    X'8400'                 STATIC TEXT FLAG        @Z40LB26
         DC    Y(STE03B-STE03A)        TEXT LENGTH             @Z40LB26
         DC    Y(STE03A-TXT03A)        TEXT OFFSET             @Z40LB26
         DC    H'1'                    PRINT COLUMN            @Z40LB26
         DC    Y(STE03B-STE03A)        PRINT FIELD LENGTH      @Z40LB26
         DC    H'0'                    CONVERSION FLAGS        @Z40LB26
************************************************************** @Z40LB26
*                                                            * @Z40LB26
*  STATIC TEXT ENTRY                                         * @Z40LB26
*                                                            * @Z40LB26
************************************************************** @Z40LB26
STE03A   DC    C'0'                    SPACE ONE LINE          @Z40LB26
         DC    C'                  NON VSAM STATUS REPORT'     @Z40LB26
         DC    C' FOR VOLUME       '                           @Z40LB26
STE03B   EQU   *                                               @Z40LB26
TXT03B   EQU   *                                               @Z40LB26
         EJECT                                                 @Z40LB26
************************************************************** @Z40LB26
*                                                            * @Z40LB26
*  STATUS REPORT - GROUP SUBTITLE                            * @Z40LB26
*                                                            * @Z40LB26
************************************************************** @Z40LB26
TXT04    DC    Y(TXT04B-TXT04A)        ENTRY LENGTH            @Z40LB26
         DC    X'0000'                 FLAGS                   @Z40LB26
         SPACE 1                                               @Z40LB26
************************************************************** @Z40LB26
*                                                            * @Z40LB26
*  STATIC TEXT SUB-STRUCTURE                                 * @Z40LB26
*                                                            * @Z40LB26
************************************************************** @Z40LB26
TXT04A   DC    X'8400'                 STATIC TEXT FLAG        @Z40LB26
         DC    Y(STE04B-STE04A)        TEXT LENGTH             @Z40LB26
         DC    Y(STE04A-TXT04A)        TEXT OFFSET             @Z40LB26
         DC    H'1'                    PRINT LOCATION          @Z40LB26
         DC    Y(STE04B-STE04A)        PRINT FIELD LENGTH      @Z40LB26
         DC    H'0'                    CONVERSION FLAGS        @Z40LB26
************************************************************** @Z40LB26
*                                                            * @Z40LB26
*  STATIC TEXT ENTRY                                         * @Z40LB26
*                                                            * @Z40LB26
************************************************************** @Z40LB26
STE04A   DC    C'0'                    SPACE ONE LINE          @Z40LB26
         DC    C'          NON VSAM STATUS REPORT FOR GROUP'   @Z40LB26
         DC    C'          - VOLUME       '                    @Z40LB26
STE04B   EQU   *                                               @Z40LB26
TXT04B   EQU   *                                               @Z40LB26
         EJECT                                                 @Z40LB26
************************************************************** @Z40LB26
*                                                            * @Z40LB26
*  OWNER & ADDRESS LINES FOR GROUP REPORT                    * @Z40LB26
*                                                            * @Z40LB26
************************************************************** @Z40LB26
TXT05    DC    Y(TXT05B-TXT05A)        ENTRY LENGTH            @Z40LB26
         DC    X'0000'                 FLAGS                   @Z40LB26
         SPACE 1                                               @Z40LB26
************************************************************** @Z40LB26
*                                                            * @Z40LB26
*  SPACING SUB-STRUCTURE                                     * @Z40LB26
*                                                            * @Z40LB26
************************************************************** @Z40LB26
TXT05A   DC    X'4000'                 SPACING CONTROL FLAG    @Z40LB26
         DC    H'2'                    DOUBLE SPACE            @Z40LB26
         DC    C'R '                   RELATIVE SPACING TYPE   @Z40LB26
************************************************************** @Z40LB26
*                                                            * @Z40LB26
*  STATIC TEXT SUB-STRUCTURE                                 * @Z40LB26
*                                                            * @Z40LB26
************************************************************** @Z40LB26
         DC    X'0400'                 STATIC TEXT FLAG        @Z40LB26
         DC    Y(STE05B-STE05A)        TEXT LENGTH             @Z40LB26
         DC    Y(STE05A-TXT05A)        TEXT OFFSET             @Z40LB26
         DC    H'1'                    PRINT COLUMN            @Z40LB26
         DC    Y(STE05B-STE05A)        PRINT FIELD LENGTH      @Z40LB26
         DC    H'0'                    CONVERSION FLAGS        @Z40LB26
************************************************************** @Z40LB26
*                                                            * @Z40LB26
*  INSERT DATA SUB-STRUCTURE - GROUP OWNER NAME              * @Z40LB26
*                                                            * @Z40LB26
************************************************************** @Z40LB26
         DC    X'2000'                 INSERT DATA FLAG        @Z40LB26
         DC    H'10'                   INSERT REFERENCE NUMBER @Z40LB26
         DC    H'0'                    RESERVED                @Z40LB26
         DC    H'15'                   PRINT COLUMN            @Z40LB26
         DC    H'10'                   PRINT FIELD LENGTH      @Z40LB26
         DC    H'0'                    CONVERSION (NONE)       @Z40LB26
************************************************************** @Z40LB26
*                                                            * @Z40LB26
*  SPACING SUB-STRUCTURE                                     * @Z40LB26
*                                                            * @Z40LB26
************************************************************** @Z40LB26
         DC    X'4000'                 SPACING CONTROL FLAG    @Z40LB26
         DC    H'2'                    DOUBLE SPACE            @Z40LB26
         DC    C'R '                   RELATIVE SPACING TYPE   @Z40LB26
************************************************************** @Z40LB26
*                                                            * @Z40LB26
*  STATIC TEXT SUB-STRUCTURE                                 * @Z40LB26
*                                                            * @Z40LB26
************************************************************** @Z40LB26
         DC    X'0400'                 STATIC TEXT FLAG        @Z40LB26
         DC    Y(STE05D-STE05C)        TEXT LENGTH             @Z40LB26
         DC    Y(STE05C-TXT05A)        TEXT OFFSET             @Z40LB26
         DC    H'1'                    PRINT COLUMN            @Z40LB26
         DC    Y(STE05D-STE05C)        PRINT FIELD LENGTH      @Z40LB26
         DC    H'0'                    CONVERSION FLAGS        @Z40LB26
************************************************************** @Z40LB26
*                                                            * @Z40LB26
*  INSERT DATA SUB-STRUCTURE - ADDRESS                       * @Z40LB26
*                                                            * @Z40LB26
************************************************************** @Z40LB26
         DC    X'A000'                 INSERT DATA FLAG        @Z40LB26
         DC    H'20'                   INSERT REFERENCE NUMBER @Z40LB26
         DC    H'0'                    RESERVED                @Z40LB26
         DC    H'11'                   PRINT COLUMN            @Z40LB26
         DC    H'30'                   PRINT FIELD LENGTH      @Z40LB26
         DC    H'0'                    CONVERSION (NONE)       @Z40LB26
************************************************************** @Z40LB26
*                                                            * @Z40LB26
*  STATIC TEXT ENTRIES                                       * @Z40LB26
*                                                            * @Z40LB26
************************************************************** @Z40LB26
STE05A   DC    C'GROUP OWNER:'                                 @Z40LB26
STE05B   EQU   *                                               @Z40LB26
STE05C   DC    C'ADDRESS:'                                     @Z40LB26
STE05D   EQU   *                                               @Z40LB26
TXT05B   EQU   *                                               @Z40LB26
         EJECT                                                 @Z40LB26
************************************************************** @Z40LB26
*                                                            * @Z40LB26
*  HEADER AND DATA LINES FOR SPACE USAGE REPORT              * @Z40LB26
*                                                            * @Z40LB26
************************************************************** @Z40LB26
TXT06    DC    Y(TXT06B-TXT06A)        ENTRY LENGTH            @Z40LB26
         DC    X'4000'                 HEADER FLAG             @Z40LB26
         DC    H'3'                    HEADER LINE COUNT       @Z40LB26
         DC    H'4'                    HEADER PLUS FIRST       @Z40LB26
*                                      DATA LINE               @Z40LB26
************************************************************** @Z40LB26
*                                                            * @Z40LB26
*  STATIC TEXT SUB-STRUCTURE                                 * @Z40LB26
*                                                            * @Z40LB26
************************************************************** @Z40LB26
TXT06A   DC    X'0400'                 STATIC TEXT FLAG        @Z40LB26
         DC    Y(STE06B-STE06A)        TEXT LENGTH             @Z40LB26
         DC    Y(STE06A-TXT06A)        TEXT OFFSET             @Z40LB26
         DC    H'46'                   PRINT COLUMN            @Z40LB26
         DC    Y(STE06B-STE06A)        PRINT FIELD LENGTH      @Z40LB26
         DC    H'0'                    CONVERSION FLAGS        @Z40LB26
************************************************************** @Z40LB26
*                                                            * @Z40LB26
*  SPACING SUB-STRUCTURE                                     * @Z40LB26
*                                                            * @Z40LB26
************************************************************** @Z40LB26
         DC    X'4000'                 SPACING CONTROL FLAG    @Z40LB26
         DC    H'1'                    SINGLE SPACE            @Z40LB26
         DC    C'R '                   RELATIVE SPACING TYPE   @Z40LB26
************************************************************** @Z40LB26
*                                                            * @Z40LB26
*  STATIC TEXT SUB-STRUCTURE                                 * @Z40LB26
*                                                            * @Z40LB26
************************************************************** @Z40LB26
         DC    X'0400'                 STATIC TEXT FLAG        @Z40LB26
         DC    Y(STE06D-STE06C)        TEXT LENGTH             @Z40LB26
         DC    Y(STE06C-TXT06A)        TEXT OFFSET             @Z40LB26
         DC    H'1'                    PRINT COLUMN            @Z40LB26
         DC    Y(STE06D-STE06C)        PRINT FIELD LENGTH      @Z40LB26
         DC    H'0'                    CONVERSION FLAGS        @Z40LB26
************************************************************** @Z40LB26
*                                                            * @Z40LB26
*  SPACING SUB-STRUCTURE                                     * @Z40LB26
*                                                            * @Z40LB26
************************************************************** @Z40LB26
         DC    X'4000'                 SPACING CONTROL FLAG    @Z40LB26
         DC    H'1'                    DOUBLE SPACE            @Z40LB26
         DC    C'R '                   RELATIVE SPAING TYPE    @Z40LB26
************************************************************** @Z40LB26
*                                                            * @Z40LB26
*  STATIC TEXT SUB-STRUCTURE                                 * @Z40LB26
*                                                            * @Z40LB26
************************************************************** @Z40LB26
         DC    X'0400'                 STATIC TEXT FLAG        @Z40LB26
         DC    Y(STE06E-STE06D)        TEXT LENGTH             @Z40LB26
         DC    Y(STE06D-TXT06A)        TEXT OFFSET             @Z40LB26
         DC    H'1'                    PRINT COLUMN            @Z40LB26
         DC    Y(STE06E-STE06D)        PRINT FIELD LENGTH      @Z40LB26
         DC    H'0'                    CONVERSION FLAGS        @Z40LB26
************************************************************** @Z40LB26
*                                                            * @Z40LB26
*  SPACING SUB-STRUCTURE                                     * @Z40LB26
*                                                            * @Z40LB26
************************************************************** @Z40LB26
         DC    X'4000'                 SPACING CONTROL FLAG    @Z40LB26
         DC    H'1'                    DOUBLE SPACE            @Z40LB26
         DC    C'R '                   RELATIVE SPAING TYPE    @Z40LB26
************************************************************** @Z40LB26
*                                                            * @Z40LB26
*  REPLICATION SUB-STRUCTURE                                 * @Z40LB26
*                                                            * @Z40LB26
************************************************************** @Z40LB26
         DC    X'0800'                 REPLICATION FLAG        @Z40LB26
         DC    H'10'                   ARGUMENT REFERENCE NO.  @Z40LB26
         DC    H'7'                    REPLICATED SUB-STRUC-   @Z40LB26
*                                      TURE COUNT              @Z40LB26
         DC    H'80'                   BLOCK FORMAT OFFSET     @ZM44011
*                                      VALUE                   @Z40LB26
************************************************************** @Z40LB26
*                                                            * @Z40LB26
*  BLOCK DATA SUB-STRUCTURE - DATA SET NAME                  * @Z40LB26
*                                                            * @Z40LB26
************************************************************** @Z40LB26
         DC    X'1000'                 BLOCK DATA FLAG         @Z40LB26
         DC    H'44'                   INPUT DATA LENGTH       @Z40LB26
         DC    H'4'                    INPUT DATA OFFSET       @Z40LB26
         DC    H'1'                    PRINT COLUMN            @Z40LB26
         DC    H'44'                   PRINT FIELD LENGTH      @Z40LB26
         DC    H'0'                    CONVERSION (NONE)       @Z40LB26
************************************************************** @Z40LB26
*                                                            * @Z40LB26
*  BLOCK DATA SUB-STRUCTURE - DATA SET ORGAINIZATION         * @Z40LB26
*                                                            * @Z40LB26
************************************************************** @Z40LB26
         DC    X'1000'                 BLOCK DATA FLAG         @Z40LB26
         DC    H'3'                    INPUT DATA LENGTH       @Z40LB26
         DC    H'64'                   INPUT DATA OFFSET       @Z40LB26
         DC    H'46'                   PRINT COLUMN            @Z40LB26
         DC    H'3'                    PRINT FIELD LENGTH      @Z40LB26
         DC    H'0'                    CONVERSION (NONE)       @Z40LB26
************************************************************** @Z40LB26
*                                                            * @Z40LB26
*  BLOCK DATA SUB-STRUCTURE - ALLOCATION UNIT                * @Z40LB26
*                                                            * @Z40LB26
************************************************************** @Z40LB26
         DC    X'1000'                 BLOCK DATA FLAG         @Z40LB26
         DC    H'5'                    INPUT DATA LENGTH       @Z40LB26
         DC    H'67'                   INPUT DATA OFFSET       @Z40LB26
         DC    H'51'                   PRINT COLUMN            @Z40LB26
         DC    H'5'                    PRINT FIELD LENGTH      @Z40LB26
         DC    H'0'                    CONVERSION (NONE)       @Z40LB26
************************************************************** @Z40LB26
*                                                            * @Z40LB26
*  BLOCK DATA SUB-STRUCTURE - NUMBER OF EXTENTS              * @Z40LB26
*                                                            * @Z40LB26
************************************************************** @Z40LB26
         DC    X'1000'                 BLOCK DATA FLAG         @Z40LB26
         DC    H'1'                    INPUT DATA LENGTH       @Z40LB26
         DC    H'56'                   INPUT DATA OFFSET       @Z40LB26
         DC    H'59'                   PRINT COLUMN            @Z40LB26
         DC    H'3'                    PRINT FIELD LENGTH      @Z40LB26
         DC    X'10A0'                 CONVERSION - BINARY TO  @Z40LB26
*                                      DECIMAL, SUPPRESS       @Z40LB26
*                                      LEADING ZEROES AND SIGN @Z40LB26
************************************************************** @Z40LB26
*                                                            * @Z40LB26
*  BLOCK DATA SUB-STRUCTURE - SECONDARY ALLOCATION           * @Z40LB26
*                                                            * @Z40LB26
************************************************************** @Z40LB26
         DC    X'1000'                 BLOCK DATA FLAG         @Z40LB26
         DC    H'4'                    INPUT DATA LENGTH       @Z40LB26
         DC    H'60'                   INPUT DATA OFFSET       @Z40LB26
         DC    H'64'                   PRINT COLUMN            @Z40LB26
         DC    H'4'                    PRINT FIELD LENGTH      @Z40LB26
         DC    H'0'                    CONVERSION - NONE       @Z40LB26
************************************************************** @Z40LB26
*                                                            * @Z40LB26
*  BLOCK DATA SUB-STRUCTURE - TOTAL TRACKS                   * @Z40LB26
*                                                            * @Z40LB26
************************************************************** @Z40LB26
         DC    X'1000'                 BLOCK DATA FLAG         @Z40LB26
         DC    H'2'                    INPUT DATA LENGTH       @Z40LB26
         DC    H'48'                   INPUT DATA OFFSET       @Z40LB26
         DC    H'70'                   PRINT COLUMN            @Z40LB26
         DC    H'5'                    PRINT FIELD LENGTH      @Z40LB26
         DC    X'10A0'                 CONVERSION - BINARY TO  @Z40LB26
*                                      DECIMAL, SUPPRESS       @Z40LB26
*                                      LEADING ZEROES AND SIGN @Z40LB26
************************************************************** @Z40LB26
*                                                            * @Z40LB26
*  BLOCK DATA SUB-STRUCTURE - FREE TRACKS                    * @Z40LB26
*                                                            * @Z40LB26
************************************************************** @Z40LB26
         DC    X'9000'                 BLOCK DATA FLAG         @Z40LB26
         DC    H'4'                    INPUT DATA LENGTH       @Z40LB26
         DC    H'72'                   INPUT DATA OFFSET       @Z40LB26
         DC    H'77'                   PRINT COLUMN            @Z40LB26
         DC    H'4'                    PRINT FIELD LENGTH      @Z40LB26
         DC    H'0'                    CONVERSION - NONE       @Z40LB26
************************************************************** @Z40LB26
*                                                            * @Z40LB26
*  STATIC TEXT ENTRIES                                       * @Z40LB26
*                                                            * @Z40LB26
************************************************************** @Z40LB26
STE06A   DC    C'DS   ALLOC  NO.   SEC    TOTAL FREE'          @Z40LB26
STE06B   EQU   *                                               @Z40LB26
STE06C   DC    C'DATA SET                                '     @Z40LB26
         DC    C'     ORG  UNIT   EXTS  ALLOC  TRKS  TRKS'     @Z40LB26
STE06D   DC    C'  '                                           @Z40LB26
STE06E   EQU   *                                               @Z40LB26
TXT06B   EQU   *                                               @Z40LB26
         EJECT                                                 @Z40LB26
************************************************************** @Z40LB26
*                                                            * @Z40LB26
*  HEADER AND DATA LINES FOR STATUS REPORT                   * @Z40LB26
*                                                            * @Z40LB26
************************************************************** @Z40LB26
TXT07    DC     Y(TXT07B-TXT07A)        ENTRY LENGTH           @Z40LB26
         DC    X'4000'                 HEADER FLAG             @Z40LB26
         DC    H'3'                    HEADER LINE COUNT       @Z40LB26
         DC    H'4'                    HEADER PLUS FIRST       @Z40LB26
*                                      DATA LINE               @Z40LB26
************************************************************** @Z40LB26
*                                                            * @Z40LB26
*  STATIC TEXT SUB-STRUCTURE                                 * @Z40LB26
*                                                            * @Z40LB26
************************************************************** @Z40LB26
TXT07A   DC    X'0400'                 STATIC TEXT FLAG        @Z40LB26
         DC    Y(STE07B-STE07A)        TEXT LENGTH             @Z40LB26
         DC    Y(STE07A-TXT07A)        TEXT OFFSET             @Z40LB26
         DC    H'46'                   PRINT COLUMN            @Z40LB26
         DC    Y(STE07B-STE07A)        PRINT FIELD LENGTH      @Z40LB26
         DC    H'0'                    CONVERSION FLAGS        @Z40LB26
************************************************************** @Z40LB26
*                                                            * @Z40LB26
*  SPACING SUB-STRUCTURE                                     * @Z40LB26
*                                                            * @Z40LB26
************************************************************** @Z40LB26
         DC    X'4000'                 SPACING CONTROL FLAG    @Z40LB26
         DC    H'1'                    SINGLE SPACE            @Z40LB26
         DC    C'R '                   RELATIVE SPACING TYPE   @Z40LB26
************************************************************** @Z40LB26
*                                                            * @Z40LB26
*  STATIC TEXT SUB-STRUCTURE                                 * @Z40LB26
*                                                            * @Z40LB26
************************************************************** @Z40LB26
         DC    X'0400'                 STATIC TEXT FLAG        @Z40LB26
         DC    Y(STE07D-STE07C)        TEXT LENGTH             @Z40LB26
         DC    Y(STE07C-TXT07A)        TEXT OFFSET             @Z40LB26
         DC    H'1'                    PRINT COLUMN            @Z40LB26
         DC    Y(STE07D-STE07C)        PRINT FIELD LENGTH      @Z40LB26
         DC    H'0'                    CONVERSION FLAGS        @Z40LB26
************************************************************** @Z40LB26
*                                                            * @Z40LB26
*  SPACING CONTROL SUB-STRUCTURE                             * @Z40LB26
*                                                            * @Z40LB26
************************************************************** @Z40LB26
         DC    X'4000'                 SPACING CONTROL FLAG    @Z40LB26
         DC    H'1'                    SINGLE SPACE            @Z40LB26
         DC    C'R '                   RELATIVE SPACING TYPE   @Z40LB26
************************************************************** @Z40LB26
*                                                            * @Z40LB26
*  STATIC TEXT SUB-STRUCTURE                                 * @Z40LB26
*                                                            * @Z40LB26
************************************************************** @Z40LB26
         DC    X'0400'                 STATIC TEXT FLAG        @Z40LB26
         DC    Y(STE07E-STE07D)        TEXT LENGTH             @Z40LB26
         DC    Y(STE07D-TXT07A)        TEXT OFFSET             @Z40LB26
         DC    H'1'                    PRINT COLUMN            @Z40LB26
         DC    Y(STE07E-STE07D)        PRINT FIELD LENGTH      @Z40LB26
         DC    H'0'                    CONVERSION FLAGS        @Z40LB26
************************************************************** @Z40LB26
*                                                            * @Z40LB26
*  SPACING CONTROL SUB-STRUCTURE                             * @Z40LB26
*                                                            * @Z40LB26
************************************************************** @Z40LB26
         DC    X'4000'                 SPACING CONTROL FLAG    @Z40LB26
         DC    H'1'                    SINGLE SPACE            @Z40LB26
         DC    C'R '                   RELATIVE SPACING TYPE   @Z40LB26
************************************************************** @Z40LB26
*                                                            * @Z40LB26
*  REPLICATION SUB-STRUCTURE                                 * @Z40LB26
*                                                            * @Z40LB26
************************************************************** @Z40LB26
         DC    X'0800'                 REPLICATION FLAG        @Z40LB26
         DC    H'10'                   ARGUMENT REFERENCE NO.  @Z40LB26
         DC    H'10'                   REPLICATED SUB-STRUC-   @Z40LB26
*                                      TURE COUNT              @Z40LB2
         DC    H'80'                   BLOCK FORMAT OFFSET     @G24LB31
*                                      VALUE                   @Z40LB26
************************************************************** @Z40LB26
*                                                            * @Z40LB26
*  BLOCK DATA SUB-STRUCTURE - DATA SET NAME                  * @Z40LB26
*                                                            * @Z40LB26
************************************************************** @Z40LB26
         DC    X'1000'                 BLOCK DATA FLAG         @Z40LB26
         DC    H'44'                   INPUT DATA LENGTH       @Z40LB26
         DC    H'4'                    INPUT DATA OFFSET       @Z40LB26
         DC    H'1'                    PRINT COLUMN            @Z40LB26
         DC    H'44'                   PRINT FIELD LENGTH      @Z40LB26
         DC    H'0'                    CONVERSION (NONE)       @Z40LB26
************************************************************** @Z40LB26
*                                                            * @Z40LB26
*  BLOCK DATA SUB-STRUCTURE - CREATE DATE, YEAR              * @Z40LB26
*                                                            * @Z40LB26
************************************************************** @Z40LB26
         DC    X'1000'                 BLOCK DATA FLAG         @Z40LB26
         DC    H'2'                    INPUT DATA LENGTH       @Z40LB26
         DC    H'48'                   INPUT DATA OFFSET       @Z40LB26
         DC    H'46'                   PRINT COLUMN            @Z40LB26
         DC    H'2'                    PRINT FIELD LENGTH      @Z40LB26
         DC    X'1020'                 CONVERT BINARY TO       @Z40LB26
*                                      DECIMAL, SUPPRESS SIGN  @Z40LB26
************************************************************** @Z40LB26
*                                                            * @Z40LB26
*  BLOCK DATA SUB-STRUCTURE - CREATE DATE, DAY               * @Z40LB26
*                                                            * @Z40LB26
************************************************************** @Z40LB26
         DC    X'1000'                 BLOCK DATA FLAG         @Z40LB26
         DC    H'2'                    INPUT DATA LENGTH       @Z40LB26
         DC    H'50'                   INPUT DATA OFFSET       @Z40LB26
         DC    H'48'                   PRINT COLUMN            @Z40LB26
         DC    H'3'                    PRINT FIELD LENGTH      @Z40LB26
         DC    X'1020'                 CONVER  BINARY TO       @Z40LB26
*                                      DECIMAL, SUPPRESS SIGN  @Z40LB26
************************************************************** @Z40LB26
*                                                            * @Z40LB26
*  BLOCK DATA SUB-STRUCTURE - CREATE DATE, CATALOG OR        * @Z40LB26
*  VTOC INDICATOR                                            * @Z40LB26
*                                                            * @Z40LB26
************************************************************** @Z40LB26
         DC    X'1000'                 BLOCK DATA FLAG         @Z40LB26
         DC    H'2'                    INPUT DATA LENGTH       @Z40LB26
         DC    H'66'                   INPUT DATA OFFSET       @Z40LB26
         DC    H'51'                   PRINT COLUMN            @Z40LB26
         DC    H'2'                    PRINT FIELD LENGTH      @Z40LB26
         DC    H'0'                    CONVERSION (NONE)       @Z40LB26
************************************************************** @Z40LB26
*                                                            * @Z40LB26
*  BLOCK DATA SUB-STRUCTURE - EXPIRATION DATE, YEAR          * @Z40LB26
*                                                            * @Z40LB26
************************************************************** @Z40LB26
         DC    X'1000'                 BLOCK DATA FLAG         @Z40LB26
         DC    H'2'                    INPUT DATA LENGTH       @Z40LB26
         DC    H'52'                   INPUT DATA OFFSET       @Z40LB26
         DC    H'54'                   PRINT COLUMN            @Z40LB26
         DC    H'2'                    PRINT FIELD LENGTH      @Z40LB26
         DC    X'1020'                 CONVERT BINARY TO       @Z40LB26
*                                      DECIMAL, SUPPRESS SIGN  @Z40LB26
************************************************************** @Z40LB26
*                                                            * @Z40LB26
*  BLOCK DATA SUB-STRUCTURE - EXPIRATION DATE, DAY           * @Z40LB26
*                                                            * @Z40LB26
************************************************************** @Z40LB26
         DC    X'1000'                 BLOCK DATA FLAG         @Z40LB26
         DC    H'2'                    INPUT DATA LENGTH       @Z40LB26
         DC    H'54'                   INPUT DATA OFFSET       @Z40LB26
         DC    H'56'                   PRINT COLUMN            @Z40LB26
         DC    H'3'                    PRINT FIELD LENGTH      @Z40LB26
         DC    X'1020'                 CONVERT BINARY TO       @Z40LB26
*                                      DECIMAL, SUPPRESS SIGN  @Z40LB26
************************************************************** @Z40LB26
*                                                            * @Z40LB26
*  BLOCK DATA STRUCTURE - EXPIRATION DATE, CATALOG OR        * @Z40LB26
*  VTOC INDICATOR                                            * @Z40LB26
*                                                            * @Z40LB26
************************************************************** @Z40LB26
         DC    X'1000'                 BLOCK DATA FLAG         @Z40LB26
         DC    H'2'                    INPUT DATA LENGTH       @Z40LB26
         DC    H'68'                   INPUT DATA OFFSET       @Z40LB26
         DC    H'59'                   PRINT COLUMN            @Z40LB26
         DC    H'2'                    PRINT FIELD LENGTH      @Z40LB26
         DC    H'0'                    CONVERSION (NONE)       @Z40LB26
************************************************************** @Z40LB26
*                                                            * @Z40LB26
*  BLOCK DATA STRUCTURE - CATALOGED STATUS                   * @Z40LB26
*                                                            * @Z40LB26
************************************************************** @Z40LB26
         DC    X'1000'                 BLOCK DATA FLAG         @Z40LB26
         DC    H'3'                    INPUT DATA LENGTH       @Z40LB26
         DC    H'70'                   INPUT DATA OFFSET       @Z40LB26
         DC    H'62'                   PRINT COLUMN            @Z40LB26
         DC    H'3'                    PRINT FIELD LENGTH      @Z40LB26
         DC    H'0'                    CONVERSION (NONE)       @Z40LB26
************************************************************** @Z40LB26
*                                                            * @Z40LB26
*  BLOCK DATA STRUCTURE - PROTECTION                         * @Z40LB26
*                                                            * @Z40LB26
************************************************************** @Z40LB26
         DC    X'1000'                 BLOCK DATA FLAG         @Z40LB26
         DC    H'4'                    INPUT DATA LENGTH       @Z40LB26
         DC    H'73'                   INPUT DATA OFFSET       @Z40LB26
         DC    H'66'                   PRINT COLUMN            @Z40LB26
         DC    H'4'                    PRINT FIELD LENGTH      @Z40LB26
         DC    H'0'                    CONVERSION (NONE)       @Z40LB26
************************************************************** @Z40LB26
*                                                            * @Z40LB26
*  BLOCK DATA SUB-STRUCTURE - OWNER NAME                     * @Z40LB26
*                                                            * @Z40LB26
************************************************************** @Z40LB26
         DC    X'9000'                 BLOCK DATA FLAG         @Z40LB26
         DC    H'8'                    INPUT DATA LENGTH       @Z40LB26
         DC    H'56'                   INPUT DATA OFFSET       @Z40LB26
         DC    H'71'                   PRINT COLUMN            @Z40LB26
         DC    H'8'                    PRINT FIELD LENGTH      @Z40LB26
         DC    H'0'                    CONVERSION (NONE)       @Z40LB26
************************************************************** @Z40LB26
*                                                            * @Z40LB26
*  STATIC TEXT ENTRIES                                       * @Z40LB26
*                                                            * @Z40LB26
************************************************************** @Z40LB26
STE07A   DC    C'CREATE  EXPIR'                                @Z40LB26
STE07B   EQU   *                                               @Z40LB26
STE07C   DC    C'DATA SET                                '     @Z40LB26
         DC    C'     DATE    DATE    CAT PROT OWNER     '     @Z40LB26
STE07D   DC    C'  '                                           @Z40LB26
STE07E   EQU   *                                               @Z40LB26
TXT07B   EQU   *                                               @Z40LB26
         EJECT                                                 @Z40LB26
************************************************************** @Z40LB26
*                                                            * @Z40LB26
*  SPACE USAGE REPORT SUMMARY                                * @Z40LB26
*                                                            * @Z40LB26
************************************************************** @Z40LB26
TXT08    DC    Y(TXT08B-TXT08A)        ENTRY LENGTH            @Z40LB26
         DC    X'4000'                 HEADER FLAG             @Z40LB26
         DC    H'0'                    HEADER LINE COUNT       @Z40LB26
         DC    H'10'                   HEADER PLUS FIRST       @Z40LB26
*                                      DATA LINE               @Z40LB26
************************************************************** @Z40LB26
*                                                            * @Z40LB26
*  SPACING SUB-STRUCTURE                                     * @Z40LB26
*                                                            * @Z40LB26
************************************************************** @Z40LB26
TXT08A   DC    X'4100'                 SPACING CONTROL FLAG    @Z40LB26
         DC    H'2'                    DOUBLE SPACE            @Z40LB26
         DC    C'R '                   RELATIVE SPACING TYPE   @Z40LB26
************************************************************** @Z40LB26
*                                                            * @Z40LB26
*  STATIC TEXT SUB-STRUCTURE                                 * @Z40LB26
*                                                            * @Z40LB26
************************************************************** @Z40LB26
         DC    X'0400'                 STATIC TEXT FLAG        @Z40LB26
         DC    Y(STE08B-STE08A)        TEXT LENGTH             @Z40LB26
         DC    Y(STE08A-TXT08A)        TEXT OFFSET             @Z40LB26
         DC    H'1'                    PRINT COLUMN            @Z40LB26
         DC    Y(STE08B-STE08A)        PRINT FIELD LENGTH      @Z40LB26
         DC    H'0'                    CONVERSION FLAGS        @Z40LB26
************************************************************** @Z40LB26
*                                                            * @Z40LB26
*  INSERT DATA SUB-STRUCTURE - LISTED DATA SET TRACKS        * @Z40LB26
*                                                            * @Z40LB26
************************************************************** @Z40LB26
         DC    X'2000'                 INSERT DATA FLAG        @Z40LB26
         DC    H'10'                   INSERT REFERENCE NO.    @Z40LB26
         DC    H'0'                    RESERVED                @Z40LB26
         DC    H'40'                   PRINT COLUMN            @Z40LB26
         DC    H'4'                    PRINT FIELD LENGTH      @Z40LB26
         DC    X'10A0'                 CONVERSION - BINARY TO  @Z40LB26
*                                      DECIMAL SUPPRESS        @Z40LB26
*                                      LEADING ZEROES AND SIGN @Z40LB26
************************************************************** @Z40LB26
*                                                            * @Z40LB26
*  SPACING SUB-STRUCTURE                                     * @Z40LB26
*                                                            * @Z40LB26
************************************************************** @Z40LB26
         DC    X'4000'                 SPACING CONTROL FLAG    @Z40LB26
         DC    H'2'                    DOUBLE SPACE            @Z40LB26
         DC    C'R '                   RELATIVE SPACING TYPE   @Z40LB26
************************************************************** @Z40LB26
*                                                            * @Z40LB26
*  STATIC TEXT SUB-STRUCTURE                                 * @Z40LB26
*                                                            * @Z40LB26
************************************************************** @Z40LB26
         DC    X'0400'                 STATIC TEXT FLAG        @Z40LB26
         DC    Y(STE08D-STE08C)        TEXT LENGTH             @Z40LB26
         DC    Y(STE08C-TXT08A)        TEXT OFFSET             @Z40LB26
         DC    H'1'                    PRINT COLUMN            @Z40LB26
         DC    Y(STE08D-STE08C)        PRINT FIELD LENGTH      @Z40LB26
         DC    H'0'                    CONVERSION FLAGS        @Z40LB26
************************************************************** @Z40LB26
*                                                            * @Z40LB26
*  INSERT DATA SUB-STRUCTURE - VTOC TRACKS ALLOCATED         * @Z40LB26
*                                                            * @Z40LB26
************************************************************** @Z40LB26
         DC    X'2000'                 INSERT DATA FLAG        @Z40LB26
         DC    H'20'                   INSERT REFERNECE NO.    @Z40LB26
         DC    H'0'                    RESERVED                @Z40LB26
         DC    H'40'                   PRINT COLUMN            @Z40LB26
         DC    H'4'                    PRINT FIELD LENGTH      @Z40LB26
         DC    X'10A0'                 CONVERSION - BINARY TO  @Z40LB26
*                                      DECIMAL SUPPRESS        @Z40LB26
*                                      LEADING ZEROES AND SIGN @Z40LB26
************************************************************** @Z40LB26
*                                                            * @Z40LB26
*  SPACING SUB-STRUCTURE                                     * @Z40LB26
*                                                            * @Z40LB26
************************************************************** @Z40LB26
         DC    X'4000'                 SPACING CONTROL FLAG    @Z40LB26
         DC    H'1'                    SINGLE SPACE            @Z40LB26
         DC    C'R '                   RELATIVE SPACING TYPE   @Z40LB26
************************************************************** @Z40LB26
*                                                            * @Z40LB26
*  STATIC TEXT SUB-STRUCTURE                                 * @Z40LB26
*                                                            * @Z40LB26
************************************************************** @Z40LB26
         DC    X'0400'                 STATIC TEXT FLAG        @Z40LB26
         DC    Y(STE08F-STE08E)        TEXT LENGTH             @Z40LB26
         DC    Y(STE08E-TXT08A)        TEXT OFFSET             @Z40LB26
         DC    H'1'                    PRINT COLUMN            @Z40LB26
         DC    Y(STE08F-STE08E)        PRINT FIELD LENGTH      @Z40LB26
         DC    H'0'                    CONVERSION FLAGS        @Z40LB26
************************************************************** @Z40LB26
*                                                            * @Z40LB26
*  INSERT DATA SUB-STRUCTURE - FREE DSCBS                    * @Z40LB26
*                                                            * @Z40LB26
************************************************************** @Z40LB26
         DC    X'2000'                 INSERT DATA FLAG        @Z40LB26
         DC    H'30'                   INSERT REFERENCE NO.    @Z40LB26
         DC    H'0'                    RESERVED                @Z40LB26
         DC    H'40'                   PRINT COLUMN            @Z40LB26
         DC    H'4'                    PRINT FIELD LENGTH      @Z40LB26
         DC    X'10A0'                 CONVERSION - BINARY TO  @Z40LB26
*                                      DECIMAL SUPPRESS        @Z40LB26
*                                      LEADING ZEROES AND SIGN @Z40LB26
************************************************************** @Z40LB26
*                                                            * @Z40LB26
*  SPACING SUB-STRUCTURE                                     * @Z40LB26
*                                                            * @Z40LB26
************************************************************** @Z40LB26
         DC    X'4000'                 SPACING CONTROL FLAG    @Z40LB26
         DC    H'2'                    DOUBLE SPACE            @Z40LB26
         DC    C'R '                   RELATIVE SPACING TYPE   @Z40LB26
************************************************************** @Z40LB26
*                                                            * @Z40LB26
*  STATIC TEXT SUB-STRUCTURE                                 * @Z40LB26
*                                                            * @Z40LB26
************************************************************** @Z40LB26
         DC    X'0400'                 STATIC TEXT FLAG        @Z40LB26
         DC    Y(STE08H-STE08G)        TEXT LENGTH             @Z40LB26
         DC    Y(STE08G-TXT08A)        TEXT OFFSET             @Z40LB26
         DC    H'1'                    PRINT COLUMN            @Z40LB26
         DC    Y(STE08H-STE08G)        PRINT FIELD LENGTH      @Z40LB26
         DC    H'0'                    CONVERSION FLAGS        @Z40LB26
************************************************************** @Z40LB26
*                                                            * @Z40LB26
*  INSERT DATA SUB-STRUCTURE - FREE CYLINDERS                * @Z40LB26
*                                                            * @Z40LB26
************************************************************** @Z40LB26
         DC    X'2000'                 INSERT DATA FLAG        @Z40LB26
         DC    H'40'                   INSERT REFERENCE NO.    @Z40LB26
         DC    H'0'                    RESERVED                @Z40LB26
         DC    H'40'                   PRINT COLUMN            @Z40LB26
         DC    H'4'                    PRINT FIELD LENGTH      @Z40LB26
         DC    H'0'                    CONVERSION - NONE       @Z40LB26
************************************************************** @Z40LB26
*                                                            * @Z40LB26
*  SPACING SUB-STRUCTURE                                     * @Z40LB26
*                                                            * @Z40LB26
************************************************************** @Z40LB26
         DC    X'4000'                 SPACING CONTROL FLAG    @Z40LB26
         DC    H'1'                    SINGLE SPACE            @Z40LB26
         DC    C'R '                   RELATIVE SPACING TYPE   @Z40LB26
************************************************************** @Z40LB26
*                                                            * @Z40LB26
*  STATIC TEXT SUB-STRUCTURE                                 * @Z40LB26
*                                                            * @Z40LB26
************************************************************** @Z40LB26
         DC    X'0400'                 STATIC TEXT FLAG        @Z40LB26
         DC    Y(STE08K-STE08J)        TEXT LENGTH             @Z40LB26
         DC    Y(STE08J-TXT08A)        TEXT OFFSET             @Z40LB26
         DC    H'1'                    PRINT COLUMN            @Z40LB26
         DC    Y(STE08K-STE08J)        PRINT FIELD LENGTH      @Z40LB26
         DC    H'0'                    CONVERSION FLAGS        @Z40LB26
************************************************************** @Z40LB26
*                                                            * @Z40LB26
*  INSERT DATA SUB-STRUCTURE - FREE TRACKS                   * @Z40LB26
*                                                            * @Z40LB26
************************************************************** @Z40LB26
         DC    X'2000'                 INSERT DATA FLAG        @Z40LB26
         DC    H'50'                   INSERT REFERENCE NO.    @Z40LB26
         DC    H'0'                    RESERVED                @Z40LB26
         DC    H'40'                   PRINT COLUMN            @Z40LB26
         DC    H'4'                    PRINT FIELD LENGTH      @Z40LB26
         DC    H'0'                    CONVERSION - NONE       @Z40LB26
************************************************************** @Z40LB26
*                                                            * @Z40LB26
*  SPACING SUB-STRUCTURE                                     * @Z40LB26
*                                                            * @Z40LB26
************************************************************** @Z40LB26
         DC    X'4000'                 SPACING CONTROL FLAG    @Z40LB26
         DC    H'1'                    SINGLE SPACE            @Z40LB26
         DC    C'R '                   RELATIVE SPACING TYPE   @Z40LB26
************************************************************** @Z40LB26
*                                                            * @Z40LB26
*  STATIC TEXT SUB-STRUCTURE                                 * @Z40LB26
*                                                            * @Z40LB26
************************************************************** @Z40LB26
         DC    X'0400'                 STATIC TEXT FLAG        @Z40LB26
         DC    Y(STE08M-STE08L)        TEXT LENGTH             @Z40LB26
         DC    Y(STE08L-TXT08A)        TEXT OFFSET             @Z40LB26
         DC    H'1'                    PRINT COLUMN            @Z40LB26
         DC    Y(STE08M-STE08L)        PRINT FIELD LENGTH      @Z40LB26
         DC    H'0'                    CONVERSION FLAGS        @Z40LB26
************************************************************** @Z40LB26
*                                                            * @Z40LB26
*  INSERT DATA SUB-STRUCTURE - FREE EXTENTS                    @Z40LB26
*                                                            * @Z40LB26
************************************************************** @Z40LB26
         DC    X'2000'                 INSERT DATA FLAG        @Z40LB26
         DC    H'60'                   INSERT REFERENCE NO.    @Z40LB26
         DC    H'0'                    RESERVED                @Z40LB26
         DC    H'40'                   PRINT COLUMN            @Z40LB26
         DC    H'4'                    PRINT FIELD LENGTH      @Z40LB26
         DC    H'0'                    CONVERSION - NONE       @Z40LB26
************************************************************** @Z40LB26
*                                                            * @Z40LB26
*  SPACING SUB-STRUCTURE                                     * @Z40LB26
*                                                            * @Z40LB26
************************************************************** @Z40LB26
         DC    X'4000'                 SPACING CONTROL FLAG    @Z40LB26
         DC    H'1'                    SINGLE SPACE            @Z40LB26
         DC    C'R '                   RELATIVE SPACING TYPE   @Z40LB26
************************************************************** @Z40LB26
*                                                            * @Z40LB26
*  STATIC TEXT SUB-STRUCTURE                                 * @Z40LB26
*                                                            * @Z40LB26
************************************************************** @Z40LB26
         DC    X'0400'                 STATIC TEXT FLAG        @Z40LB26
         DC    Y(STE08Q-STE08P)        TEXT LENGTH             @Z40LB26
         DC    Y(STE08P-TXT08A)        TEXT OFFSET             @Z40LB26
         DC    H'1'                    PRINT COLUMN            @Z40LB26
         DC    Y(STE08Q-STE08P)        PRINT FIELD LENGTH      @Z40LB26
         DC    H'0'                    CONVERSION FLAGS        @Z40LB26
************************************************************** @Z40LB26
*                                                            * @Z40LB26
*  INSERT DATA SUB-STRUCTURE - LARGEST FREE EXTENT           * @Z40LB26
*                                                            * @Z40LB26
************************************************************** @Z40LB26
         DC    X'A000'                 INSERT DATA FLAG        @Z40LB26
         DC    H'70'                   INSERT REFERENCE NO.    @Z40LB26
         DC    H'0'                    RESERVED                @Z40LB26
         DC    H'40'                   PRINT COLUMN            @Z40LB26
         DC    H'4'                    PRINT FIELD LENGTH      @Z40LB26
         DC    H'0'                    CONVERSION - NONE       @Z40LB26
************************************************************** @Z40LB26
*                                                            * @Z40LB26
*  STATIC TEXT ENTRIES                                       * @Z40LB26
*                                                            * @Z40LB26
************************************************************** @Z40LB26
STE08A   DC    C'TRACKS ALLOCATED TO LISTED DATA SETS:'        @Z40LB26
STE08B   EQU   *                                               @Z40LB26
STE08C   DC    C'TRACKS ALLOCATED TO VTOC:'                    @Z40LB26
STE08D   EQU   *                                               @Z40LB26
STE08E   DC    C'FREE DSCBS IN VTOC:'                          @Z40LB26
STE08F   EQU   *                                               @Z40LB26
STE08G   DC    C'FREE CYLINDERS:'                              @Z40LB26
STE08H   EQU   *                                               @Z40LB26
STE08J   DC    C'FREE TRACKS:'                                 @Z40LB26
STE08K   EQU   *                                               @Z40LB26
STE08L   DC    C'NUMBER OF FREE EXTENTS:'                      @Z40LB26
STE08M   EQU   *                                               @Z40LB26
STE08P   DC    C'LARGEST FREE EXTENT IN CYLINDERS:'            @Z40LB26
STE08Q   EQU   *                                               @Z40LB26
TXT08B   EQU   *                                               @Z40LB26
         EJECT                                                 @Z40LB26
************************************************************** @Z40LB26
*                                                            * @Z40LB26
*  STATUS REPORT SUMMARY                                     * @Z40LB26
*                                                            * @Z40LB26
************************************************************** @Z40LB26
TXT09    DC    Y(TXT09B-TXT09A)        ENTRY LENGTH            @Z40LB26
         DC    X'4000'                 HEADER FLAG             @Z40LB26
         DC    H'0'                    HEADER LINE COUNT       @Z40LB26
         DC    H'2'                    HEADER PLUS FIRST       @Z40LB26
*                                      DATA LINE               @Z40LB26
************************************************************** @Z40LB26
*                                                            * @Z40LB26
*  SPACING SUB-STRUCTURE                                     * @Z40LB26
*                                                            * @Z40LB26
************************************************************** @Z40LB26
TXT09A   DC    X'4100'                 SPACING CONTROL FLAG    @Z40LB26
         DC    H'2'                    DOUBLE SPACE            @Z40LB26
         DC    C'R '                   RELATIVE SPACING TYPE   @Z40LB26
************************************************************** @Z40LB26
*                                                            * @Z40LB26
*  STATIC TEXT SUB-STRUCTURE                                 * @Z40LB26
*                                                            * @Z40LB26
************************************************************** @Z40LB26
         DC    X'0400'                 STATIC TEXT FLAG        @Z40LB26
         DC    Y(STE09B-STE09A)        TEXT LENGTH             @Z40LB26
         DC    Y(STE09A-TXT09A)        TEXT OFFSET             @Z40LB26
         DC    H'1'                    PRINT COLUMN            @Z40LB26
         DC    Y(STE09B-STE09A)        PRINT FIELD LENGTH      @Z40LB26
         DC    H'0'                    CONVERSION FLAGS        @Z40LB26
************************************************************** @Z40LB26
*                                                            * @Z40LB26
*  BLOCK DATA SUB-STRUCTURE                                  * @Z40LB26
*                                                            * @Z40LB26
************************************************************** @Z40LB26
         DC    X'9000'                 BLOCK DATA FLAG         @Z40LB26
         DC    H'4'                    INPUT DATA LENGTH       @Z40LB26
         DC    H'0'                    INPUT DATA OFFSET       @Z40LB26
         DC    H'20'                   PRINT COLUMN            @Z40LB26
         DC    H'4'                    PRINT FIELD LENGTH      @Z40LB26
         DC    X'10A0'                 CONVERSION - BINARY TO  @Z40LB26
*                                      DECIMAL, SUPPRESS       @Z40LB26
*                                      LEADING ZEROES AND SIGN @Z40LB26
************************************************************** @Z40LB26
*                                                            * @Z40LB26
* STATIC TEXT ENTRIES                                        * @Z40LB26
*                                                            * @Z40LB26
************************************************************** @Z40LB26
STE09A   DC    C'DATA SETS LISTED:'                            @Z40LB26
STE09B   EQU   *                                               @Z40LB26
TXT09B   EQU   *                                               @Z40LB26
         EJECT                                                 @Z40LB26
************************************************************** @Z40LB26
*                                                            * @Z40LB26
*  LEGEND FOR STATUS REPORT                                  * @Z40LB26
*                                                            * @Z40LB26
************************************************************** @Z40LB26
TXT10    DC    Y(TXT10B-TXT10A)        ENTRY LENGTH            @Z40LB26
         DC    H'0'                    FLAGS                   @Z40LB26
************************************************************** @Z40LB26
*                                                            * @Z40LB26
*  SPACING SUB-STRUCTURE                                     * @Z40LB26
*                                                            * @Z40LB26
************************************************************** @Z40LB26
TXT10A   DC    X'4000'                 SPACING CONTROL FLAG    @Z40LB26
         DC    H'2'                    IGNORE                  @Z40LB26
         DC    C'R '                   EJECT PAGE              @Z40LB26
************************************************************** @Z40LB26
*                                                            * @Z40LB26
*  STATIC TEXT SUB-STRUCTURE - FIELD DESCRIPTION             * @Z40LB26
*                                                            * @Z40LB26
************************************************************** @Z40LB26
         DC    X'0400'                 STATIC TEXT FLAG        @Z40LB26
         DC    Y(STE10C-STE10B)        TEXT LENGTH             @Z40LB26
         DC    Y(STE10B-TXT10A)        TEXT OFFSET             @Z40LB26
         DC    H'1'                    PRINT COLUMN            @Z40LB26
         DC    Y(STE10C-STE10B)        PRINT FIELD LENGTH      @Z40LB26
         DC    H'0'                    CONVERSION FLAGS        @Z40LB26
************************************************************** @Z40LB26
*                                                            * @Z40LB26
*  SPACING SUB-STRUCTURE                                     * @Z40LB26
*                                                            * @Z40LB26
************************************************************** @Z40LB26
         DC    X'4000'                 SPACING CONTROL FLAG    @Z40LB26
         DC    H'2'                    DOUBLE SPACE            @Z40LB26
         DC    C'R '                   RELATIVE SPACING TYPE   @Z40LB26
************************************************************** @Z40LB26
*                                                            * @Z40LB26
*  STATIC TEXT SUB-STRUCTURE - CAT                           * @Z40LB26
*                                                            * @Z40LB26
************************************************************** @Z40LB26
         DC    X'0400'                 STATIC TEXT FLAG        @Z40LB26
         DC    Y(STE10D-STE10C)        TEXT LENGTH             @Z40LB26
         DC    Y(STE10C-TXT10A)        TEXT OFFSET             @Z40LB26
         DC    H'1'                    PRINT COLUMN            @Z40LB26
         DC    Y(STE10D-STE10C)        PRINT FIELD LENGTH      @Z40LB26
         DC    H'0'                    CONVERSION FLAGS        @Z40LB26
************************************************************** @Z40LB26
*                                                            * @Z40LB26
*  SPACING SUB-STRUCTURE                                     * @Z40LB26
*                                                            * @Z40LB26
************************************************************** @Z40LB26
         DC    X'4000'                 SPACING CONTROL FLAG    @Z40LB26
         DC    H'1'                    SINGLE SPACE            @Z40LB26
         DC    C'R '                   RELATIVE SPACING TYPE   @Z40LB26
************************************************************** @Z40LB26
*                                                            * @Z40LB26
*  STATIC TEXT SUB-STRUCTURE                                 * @Z40LB26
*                                                            * @Z40LB26
************************************************************** @Z40LB26
         DC    X'0400'                 STATIC TEXT FLAG        @Z40LB26
         DC    Y(STE10D1-STE10D)       TEXT LENGTH             @Z40LB26
         DC    Y(STE10D-TXT10A)        TEXT OFFSET             @Z40LB26
         DC    H'15'                   PRINT COLUMN            @Z40LB26
         DC    Y(STE10D1-STE10D)       PRINT FIELD LENGTH      @Z40LB26
         DC    H'0'                    CONVERSION FLAGS        @Z40LB26
************************************************************** @Z40LB26
*                                                            * @Z40LB26
*  SPACING SUB-STRUCTURE                                     * @Z40LB26
*                                                            * @Z40LB26
************************************************************** @Z40LB26
         DC    X'4000'                 SPACING CONTROL FLAG    @Z40LB26
         DC    H'1'                    SINGLE SPACE            @Z40LB26
         DC    C'R '                   RELATIVE SPACING TYPE   @Z40LB26
************************************************************** @Z40LB26
*                                                            * @Z40LB26
*  STATIC TEXT SUB-STRUCTURE                                 * @Z40LB26
*                                                            * @Z40LB26
************************************************************** @Z40LB26
         DC    X'0400'                 STATIC TEXT FLAG        @Z40LB26
         DC    Y(STE10E-STE10D1)       TEXT LENGTH             @Z40LB26
         DC    Y(STE10D1-TXT10A)       TEXT OFFSET             @Z40LB26
         DC    H'15'                   PRINT COLUMN            @Z40LB26
         DC    Y(STE10E-STE10D1)       PRINT FIELD LENGTH      @Z40LB26
         DC    H'0'                    CONVERSION FLAGS        @Z40LB26
************************************************************** @Z40LB26
*                                                            * @Z40LB26
*  SPACING SUB-STRUCTURE                                     * @Z40LB26
*                                                            * @Z40LB26
************************************************************** @Z40LB26
         DC    X'4000'                 SPACING CONTROL FLAG    @Z40LB26
         DC    H'1'                    SINGLE SPACE            @Z40LB26
         DC    C'R '                   RELATIVE SPACING TYPE   @Z40LB26
************************************************************** @Z40LB26
*                                                            * @Z40LB26
*  STATIC TEXT SUB-STRUCTURE                                 * @Z40LB26
*                                                            * @Z40LB26
************************************************************** @Z40LB26
         DC    X'0400'                 STATIC TEXT FLAG        @Z40LB26
         DC    Y(STE10F-STE10E)        TEXT LENGTH             @Z40LB26
         DC    Y(STE10E-TXT10A)        TEXT OFFSET             @Z40LB26
         DC    H'18'                   PRINT COLUMN            @Z40LB26
         DC    Y(STE10F-STE10E)        PRINT FIELD LENGTH      @Z40LB26
         DC    H'0'                    CONVERSION FLAGS        @Z40LB26
************************************************************** @Z40LB26
*                                                            * @Z40LB26
*  SPACING SUB-STRUCTURE                                     * @Z40LB26
*                                                            * @Z40LB26
************************************************************** @Z40LB26
         DC    X'4000'                 SPACING CONTROL FLAG    @Z40LB26
         DC    H'1'                    SINGLE SPACE            @Z40LB26
         DC    C'R '                   RELATIVE SPACING TYPE   @Z40LB26
************************************************************** @Z40LB26
*                                                            * @Z40LB26
*  STATIC TEXT SUB-STRUCTURE                                 * @Z40LB26
*                                                            * @Z40LB26
************************************************************** @Z40LB26
         DC    X'0400'                 STATIC TEXT FLAG        @Z40LB26
         DC    Y(STE10G-STE10F)        TEXT LENGTH             @Z40LB26
         DC    Y(STE10F-TXT10A)        TEXT OFFSET             @Z40LB26
         DC    H'18'                   PRINT COLUMN            @Z40LB26
         DC    Y(STE10G-STE10F)        PRINT FIELD LENGTH      @Z40LB26
         DC    H'0'                    CONVERSION FLAGS        @Z40LB26
************************************************************** @Z40LB26
*                                                            * @Z40LB26
*  SPACING SUB-STRUCTURE                                     * @Z40LB26
*                                                            * @Z40LB26
************************************************************** @Z40LB26
         DC    X'4000'                 SPACING CONTROL FLAG    @Z40LB26
         DC    H'2'                    DOUBLE SPACE            @Z40LB26
         DC    C'R '                   RELATIVE SPACING TYPE   @Z40LB26
************************************************************** @Z40LB26
*                                                            * @Z40LB26
*  STATIC TEXT SUB-STRUCTURE - CREATE DATE                   * @Z40LB26
*                                                            * @Z40LB26
************************************************************** @Z40LB26
         DC    X'0400'                 STATIC TEXT FLAG        @Z40LB26
         DC    Y(STE10H-STE10G)        TEXT LENGTH             @Z40LB26
         DC    Y(STE10G-TXT10A)        TEXT OFFSET             @Z40LB26
         DC    H'1'                    PRINT COLUMN            @Z40LB26
         DC    Y(STE10H-STE10G)        PRINT FIELD LENGTH      @Z40LB26
         DC    H'0'                    CONVERSION FLAGS        @Z40LB26
************************************************************** @Z40LB26
*                                                            * @Z40LB26
*  SPACING SUB-STRUCTURE                                     * @Z40LB26
*                                                            * @Z40LB26
************************************************************** @Z40LB26
         DC    X'4000'                 SPACING CONTROL FLAG    @Z40LB26
         DC    H'1'                    SINGLE SPACE            @Z40LB26
         DC    C'R '                   RELATIVE SPACING TYPE   @Z40LB26
************************************************************** @Z40LB26
*                                                            * @Z40LB26
*  STATIC TEXT SUB-STRUCTURE                                 * @Z40LB26
*                                                            * @Z40LB26
************************************************************** @Z40LB26
         DC    X'0400'                 STATIC TEXT FLAG        @Z40LB26
         DC    Y(STE10J-STE10H)        TEXT LENGTH             @Z40LB26
         DC    Y(STE10H-TXT10A)        TEXT OFFSET             @Z40LB26
         DC    H'15'                   PRINT COLUMN            @Z40LB26
         DC    Y(STE10J-STE10H)        PRINT FIELD LENGTH      @Z40LB26
         DC    H'0'                    CONVERSION FLAGS        @Z40LB26
************************************************************** @Z40LB26
*                                                            * @Z40LB26
*  SPACING SUB-STRUCTURE                                     * @Z40LB26
*                                                            * @Z40LB26
************************************************************** @Z40LB26
         DC    X'4000'                 SPACING CONTROL FLAG    @Z40LB26
         DC    H'1'                    SINGLE SPACE            @Z40LB26
         DC    C'R '                   RELATIVE SPACING TYPE   @Z40LB26
************************************************************** @Z40LB26
*                                                            * @Z40LB26
*  STATIC TEXT SUB-STRUCTURE                                 * @Z40LB26
*                                                            * @Z40LB26
************************************************************** @Z40LB26
         DC    X'0400'                 STATIC TEXT FLAG        @Z40LB26
         DC    Y(STE10K-STE10J)        TEXT LENGTH             @Z40LB26
         DC    Y(STE10J-TXT10A)        TEXT OFFSET             @Z40LB26
         DC    H'18'                   PRINT COLUMN            @Z40LB26
         DC    Y(STE10K-STE10J)        PRINT FIELD LENGTH      @Z40LB26
         DC    H'0'                    CONVERSION FLAGS        @Z40LB26
************************************************************** @Z40LB26
*                                                            * @Z40LB26
*  SPACING SUB-STRUCTURE                                     * @Z40LB26
*                                                            * @Z40LB26
************************************************************** @Z40LB26
         DC    X'4000'                 SPACING CONTROL FLAG    @Z40LB26
         DC    H'1'                    SINGLE SPACE            @Z40LB26
         DC    C'R '                   RELATIVE SPACING TYPE   @Z40LB26
************************************************************** @Z40LB26
*                                                            * @Z40LB26
*  STATIC TEXT SUB-STRUCTURE                                 * @Z40LB26
*                                                            * @Z40LB26
************************************************************** @Z40LB26
         DC    X'0400'                 STATIC TEXT FLAG        @Z40LB26
         DC    Y(STE10L-STE10K)        TEXT LENGTH             @Z40LB26
         DC    Y(STE10K-TXT10A)        TEXT OFFSET             @Z40LB26
         DC    H'18'                   PRINT COLUMN            @Z40LB26
         DC    Y(STE10L-STE10K)        PRINT FIELD LENGTH      @Z40LB26
         DC    H'0'                    CONVERSION FLAGS        @Z40LB26
************************************************************** @Z40LB26
*                                                            * @Z40LB26
*  SPACING SUB-STRUCTURE                                     * @Z40LB26
*                                                            * @Z40LB26
************************************************************** @Z40LB26
         DC    X'4000'                 SPACING CONTROL FLAG    @Z40LB26
         DC    H'2'                    DOUBLE SPACE            @Z40LB26
         DC    C'R '                   RELATIVE SPACING TYPE   @Z40LB26
************************************************************** @Z40LB26
*                                                            * @Z40LB26
*  STATIC TEXT SUB-STRUCTURE - DATA SET                      * @Z40LB26
*                                                            * @Z40LB26
************************************************************** @Z40LB26
         DC    X'0400'                 STATIC TEXT FLAG        @Z40LB26
         DC    Y(STE10M-STE10L)        TEXT LENGTH             @Z40LB26
         DC    Y(STE10L-TXT10A)        TEXT OFFSET             @Z40LB26
         DC    H'1'                    PRINT COLUMN            @Z40LB26
         DC    Y(STE10M-STE10L)        PRINT FIELD LENGTH      @Z40LB26
         DC    H'0'                    CONVERSION FLAGS        @Z40LB26
************************************************************** @Z40LB26
*                                                            * @Z40LB26
*  SPACING SUB-STRUCTURE                                     * @Z40LB26
*                                                            * @Z40LB26
************************************************************** @Z40LB26
         DC    X'4000'                 STATIC TEXT FLAG        @Z40LB26
         DC    H'2'                    DOUBLE SPACE            @Z40LB26
         DC    C'R '                   RELATIVE SPACING TYPE   @Z40LB26
************************************************************** @Z40LB26
*                                                            * @Z40LB26
*  STATIC TEXT SUB-STRUCTURE - EXPIR DATE                    * @Z40LB26
*                                                            * @Z40LB26
************************************************************** @Z40LB26
         DC    X'0400'                 STATIC TEXT FLAG        @Z40LB26
         DC    Y(STE10N-STE10M)        TEXT LENGTH             @Z40LB26
         DC    Y(STE10M-TXT10A)        TEXT OFFSET             @Z40LB26
         DC    H'1'                    PRINT COLUMN            @Z40LB26
         DC    Y(STE10N-STE10M)        PRINT FIELD LENGTH      @Z40LB26
         DC    H'0'                    CONVERSION FLAGS        @Z40LB26
************************************************************** @Z40LB26
*                                                            * @Z40LB26
*  SPACING SUB-STRUCTURE                                     * @Z40LB26
*                                                            * @Z40LB26
************************************************************** @Z40LB26
         DC    X'4000'                 SPACING CONTROL FLAG    @Z40LB26
         DC    H'1'                    SINGLE SPACE            @Z40LB26
         DC    C'R '                   RELATIVE SPACING TYPE   @Z40LB26
************************************************************** @Z40LB26
*                                                            * @Z40LB26
*  STATIC TEXT SUB-STRUCTURE                                 * @Z40LB26
*                                                            * @Z40LB26
************************************************************** @Z40LB26
         DC    X'0400'                 STATIC TEXT FLAG        @Z40LB26
         DC    Y(STE10P-STE10N)        TEXT LENGTH             @Z40LB26
         DC    Y(STE10N-TXT10A)        TEXT OFFSET             @Z40LB26
         DC    H'15'                   PRINT COLUMN            @Z40LB26
         DC    Y(STE10P-STE10N)        PRINT FIELD LENGTH      @Z40LB26
         DC    H'0'                    CONVERSION FLAGS        @Z40LB26
************************************************************** @Z40LB26
*                                                            * @Z40LB26
*  SPACING SUB-STRUCTURE                                     * @Z40LB26
*                                                            * @Z40LB26
************************************************************** @Z40LB26
         DC    X'4000'                 SPACING CONTROL FLAG    @Z40LB26
         DC    H'1'                    SINGLE SPACE            @Z40LB26
         DC    C'R '                   RELATIVE SPACING TYPE   @Z40LB26
************************************************************** @Z40LB26
*                                                            * @Z40LB26
*  STATIC TEXT SUB-STRUCTURE                                 * @Z40LB26
*                                                            * @Z40LB26
************************************************************** @Z40LB26
         DC    X'0400'                 STATIC TEXT FLAG        @Z40LB26
         DC    Y(STE10Q-STE10P)        TEXT LENGTH             @Z40LB26
         DC    Y(STE10P-TXT10A)        TEXT OFFSET             @Z40LB26
         DC    H'18'                   PRINT COLUMN            @Z40LB26
         DC    Y(STE10Q-STE10P)        PRINT FIELD LENGTH      @Z40LB26
         DC    H'0'                    CONVERSION FLAGS        @Z40LB26
************************************************************** @Z40LB26
*                                                            * @Z40LB26
*  SPACING SUB-STRUCTURE                                     * @Z40LB26
*                                                            * @Z40LB26
************************************************************** @Z40LB26
         DC    X'4000'                 SPACING CONTROL FLAG    @Z40LB26
         DC    H'1'                    SINGLE SPACE            @Z40LB26
         DC    C'R '                   RELATIVE SPACING TYPE   @Z40LB26
************************************************************** @Z40LB26
*                                                            * @Z40LB26
*  STATIC TEXT SUB-STRUCTURE                                 * @Z40LB26
*                                                            * @Z40LB26
************************************************************** @Z40LB26
         DC    X'0400'                 STATIC TEXT FLAG        @Z40LB26
         DC    Y(STE10R-STE10Q)        TEXT LENGTH             @Z40LB26
         DC    Y(STE10Q-TXT10A)        TEXT OFFSET             @Z40LB26
         DC    H'18'                   PRINT COLUMN            @Z40LB26
         DC    Y(STE10R-STE10Q)        PRINT FIELD LENGTH      @Z40LB26
         DC    H'0'                    CONVERSION FLAGS        @Z40LB26
************************************************************** @Z40LB26
*                                                            * @Z40LB26
*  SPACING SUB-STRUCTURE                                     * @Z40LB26
*                                                            * @Z40LB26
************************************************************** @Z40LB26
         DC    X'4000'                 SPACING CONTROL FLAG    @Z40LB26
         DC    H'2'                    DOUBLE SPACE            @Z40LB26
         DC    C'R '                   RELATIVE SPACING TYPE   @Z40LB26
************************************************************** @Z40LB26
*                                                            * @Z40LB26
*  STATIC TEXT SUB-STRUCTURE - OWNER                         * @Z40LB26
*                                                            * @Z40LB26
************************************************************** @Z40LB26
         DC    X'0400'                 STATIC TEXT FLAG        @Z40LB26
         DC    Y(STE10S-STE10R)        TEXT LENGTH             @Z40LB26
         DC    Y(STE10R-TXT10A)        TEXT OFFSET             @Z40LB26
         DC    H'1'                    PRINT COLUMN            @Z40LB26
         DC    Y(STE10S-STE10R)        PRINT FIELD LENGTH      @Z40LB26
         DC    H'0'                    CONVERSION FLAGS        @Z40LB26
************************************************************** @Z40LB26
*                                                            * @Z40LB26
*  SPACING SUB-STRUCTURE                                     * @Z40LB26
*                                                            * @Z40LB26
************************************************************** @Z40LB26
         DC    X'4000'                 SPACING CONTROL FLAG    @Z40LB26
         DC    H'2'                    DOUBLE SPACE            @Z40LB26
         DC    C'R '                   RELATIVE SPACING TYPE   @Z40LB26
************************************************************** @Z40LB26
*                                                            * @Z40LB26
*  STATIC TEXT SUB-STRUCTURE - PROT                          * @Z40LB26
*                                                            * @Z40LB26
************************************************************** @Z40LB26
         DC    X'0400'                 STATIC TEXT FLAG        @Z40LB26
         DC    Y(STE10T-STE10S)        TEXT LENGTH             @Z40LB26
         DC    Y(STE10S-TXT10A)        TEXT OFFSET             @Z40LB26
         DC    H'1'                    PRINT COLUMN            @Z40LB26
         DC    Y(STE10T-STE10S)        PRINT FIELD LENGTH      @Z40LB26
         DC    H'0'                    CONVERSION FLAGS        @Z40LB26
************************************************************** @Z40LB26
*                                                            * @Z40LB26
*  SPACING SUB-STRUCTURE                                     * @Z40LB26
*                                                            * @Z40LB26
************************************************************** @Z40LB26
         DC    X'4000'                 SPACING CONTROL FLAG    @Z40LB26
         DC    H'1'                    SINGLE SPACE            @Z40LB26
         DC    C'R '                   RELATIVE SPACING TYPE   @Z40LB26
************************************************************** @Z40LB26
*                                                            * @Z40LB26
*  STATIC TEXT SUB-STRUCTURE FOR NO PROTECTION               * @G24LB31
*                                                            * @Z40LB26
************************************************************** @Z40LB26
         DC    X'0400'                 STATIC TEXT FLAG        @Z40LB26
         DC    Y(STE10T1-STE10T)       TEXT LENGTH             @G24LB31
         DC    Y(STE10T-TXT10A)        TEXT OFFSET             @Z40LB26
         DC    H'15'                   PRINT COLUMN            @Z40LB26
         DC    Y(STE10T1-STE10T)       PRINT FIELD LENGTH      @G24LB31
         DC    H'0'                    CONVERSION FLAGS        @Z40LB26
************************************************************** @G24LB31
*                                                            * @G24LB31
*  SPACING SUB-STRUCTURE                                     * @G24LB31
*                                                            * @G24LB31
************************************************************** @G24LB31
         DC    X'4000'                 SPACING CONTROL FLAG    @G24LB31
         DC    H'1'                    SINGLE SPACE            @G24LB31
         DC    C'R '                   RELATIVE SPACING TYPE   @G24LB31
************************************************************** @G24LB31
*                                                            * @G24LB31
*  STATIC TEXT SUB-STRUCTURE FOR RACF                        * @G24LB31
*                                                            * @G24LB31
************************************************************** @G24LB31
         DC    X'0400'                 STATIC TEXT FLAG        @G24LB31
         DC    Y(STE10T2-STE10T1)      TEXT LENGTH             @G24LB31
         DC    Y(STE10T1-TXT10A)       TEXT OFFSET             @G24LB31
         DC    H'18'                   PRINT COLUMN            @G24LB31
         DC    Y(STE10T2-STE10T1)      PRINT FIELD LENGTH      @G24LB31
         DC    H'0'                    CONVERSION FLAGS        @G24LB31
************************************************************** @G24LB31
*                                                            * @G24LB31
*  SPACING SUB-STRUCTURE                                     * @G24LB31
*                                                            * @G24LB31
************************************************************** @G24LB31
         DC    X'4000'                 SPACING CONTROL FLAG    @G24LB31
         DC    H'1'                    SINGLE SPACE            @G24LB31
         DC    C'R '                   RELATIVE SPACING TYPE   @G24LB31
************************************************************** @G24LB31
*                                                            * @G24LB31
*  STATIC TEXT SUB-STRUCTURE FOR RF,R                        * @G24LB31
*                                                            * @G24LB31
************************************************************** @G24LB31
         DC    X'0400'                 STATIC TEXT FLAG        @G24LB31
         DC    Y(STE10T3-STE10T2)      TEXT LENGTH             @G24LB31
         DC    Y(STE10T2-TXT10A)       TEXT OFFSET             @G24LB31
         DC    H'18'                   PRINT COLUMN            @G24LB31
         DC    Y(STE10T3-STE10T2)      PRINT FIELD LENGTH      @G24LB31
         DC    H'0'                    CONVERSION FLAGS        @G24LB31
************************************************************** @G24LB31
*                                                            * @G24LB31
*  SPACING SUB-STRUCTURE                                     * @G24LB31
*                                                            * @G24LB31
************************************************************** @G24LB31
         DC    X'4000'                 SPACING CONTROL FLAG    @G24LB31
         DC    H'1'                    SINGLE SPACE            @G24LB31
         DC    C'R '                   RELATIVE SPACING TYPE   @G24LB31
************************************************************** @G24LB31
*                                                            * @G24LB31
*  STATIC TEXT SUB-STRUCTURE FOR RF,W                        * @G24LB31
*                                                            * @G24LB31
************************************************************** @G24LB31
         DC    X'0400'                 STATIC TEXT FLAG        @G24LB31
         DC    Y(STE10U-STE10T3)       TEXT LENGTH             @G24LB31
         DC    Y(STE10T3-TXT10A)       TEXT OFFSET             @G24LB31
         DC    H'18'                   PRINT COLUMN            @G24LB31
         DC    Y(STE10U-STE10T3)       PRINT FIELD LENGTH      @G24LB31
         DC    H'0'                    CONVERSION FLAGS        @Z40LB26
************************************************************** @Z40LB26
*                                                            * @Z40LB26
*  SPACING SUB-STRUCTURE                                     * @Z40LB26
*                                                            * @Z40LB26
************************************************************** @Z40LB26
         DC    X'4000'                 SPACING CONTROL FLAG    @Z40LB26
         DC    H'1'                    SINGLE SPACE            @Z40LB26
         DC    C'R '                   RELATIVE SPACING TYPE   @Z40LB26
************************************************************** @Z40LB26
*                                                            * @Z40LB26
*  STATIC TEXT SUB-STRUCTURE                                 * @Z40LB26
*                                                            * @Z40LB26
************************************************************** @Z40LB26
         DC    X'0400'                 STATIC TEXT FLAG        @Z40LB26
         DC    Y(STE10V-STE10U)        TEXT LENGTH             @Z40LB26
         DC    Y(STE10U-TXT10A)        TEXT OFFSET             @Z40LB26
         DC    H'18'                   PRINT COLUMN            @Z40LB26
         DC    Y(STE10V-STE10U)        PRINT FIELD LENGTH      @Z40LB26
         DC    H'0'                    CONVERSION FLAGS        @Z40LB26
************************************************************** @Z40LB26
*                                                            * @Z40LB26
*  SPACING SUB-STRUCTURE                                     * @Z40LB26
*                                                            * @Z40LB26
************************************************************** @Z40LB26
         DC    X'4000'                 SPACING CONTROL FLAG    @Z40LB26
         DC    H'1'                    SINGLE SPACE            @Z40LB26
         DC    C'R '                   RELATIVE SPACING TYPE   @Z40LB26
************************************************************** @Z40LB26
*                                                            * @Z40LB26
*  STATIC TEXT SUB-STRUCTURE                                 * @Z40LB26
*                                                            * @Z40LB26
************************************************************** @Z40LB26
         DC    X'8400'                 STATIC TEXT FLAG        @Z40LB26
         DC    Y(STE10W-STE10V)        TEXT LENGTH             @Z40LB26
         DC    Y(STE10V-TXT10A)        TEXT OFFSET             @Z40LB26
         DC    H'18'                   PRINT COLUMN            @Z40LB26
         DC    Y(STE10W-STE10V)        PRINT FIELD LENGTH      @Z40LB26
         DC    H'0'                    CONVERSION FLAGS        @Z40LB26
************************************************************** @Z40LB26
*                                                            * @Z40LB26
*  STATIC TEXT ENTRIES                                       * @Z40LB26
*                                                            * @Z40LB26
************************************************************** @Z40LB26
STE10B   DC    C'-FIELD-       -DESCRIPTION-'                  @Z40LB26
STE10C   DC    C'CAT           CATALOGED STATUS OF DATA SET.'  @Z40LB26
         DC    C' A BLANK INDICATES CATALOGED.'                @Z40LB26
STE10D   DC    C'A NUMBER INDICATES A CATALOGED MULTI-VOLUME'  @Z40LB26
         DC    C' DATA SET ON A GIVEN'                         @Z40LB26
STE10D1  DC    C'NUMBER OF VOLUMES.'                           @Z40LB26
STE10E   DC    C'ERR  - A CATALOG ERROR MESSAGE HAS BEEN'      @Z40LB26
         DC    C' PRINTED'                                     @Z40LB26
STE10F   DC    C'NO   - NOT CATALOGED'                         @Z40LB26
STE10G   DC    C'CREATE DATE   LATEST CREATION DATE, WITH'     @Z40LB26
         DC    C' THE FOLLOWING SUFFIX.'                       @Z40LB26
STE10H   DC    C'IF NO SUFFIX IS SPECIFIED, DATE IN CATALOG'   @Z40LB26
         DC    C' AND VTOC ARE THE SAME.'                      @Z40LB26
STE10J   DC    C'C    - DATE OBTAINED FROM CATALOG'            @Z40LB26
STE10K   DC    C'V    - DATE OBTAINED FROM VTOC'               @Z40LB26
STE10L   DC    C'DATA SET      DATA SET NAME'                  @Z40LB26
STE10M   DC    C'EXPIR DATE    LATEST EXPIRATION DATE, WITH'   @Z40LB26
         DC    C' THE FOLLOWING SUFFIX.'                       @Z40LB26
STE10N   DC    C'IF NO SUFFIX IS SPECIFIED, DATE IN CATALOG'   @Z40LB26
         DC    C' AND VTOC ARE THE SAME.'                      @Z40LB26
STE10P   DC    C'C    -DATE OBTAINED FROM CATALOG'             @Z40LB26
STE10Q   DC    C'V    -DATE OBTAINED FROM VTOC'                @Z40LB26
STE10R   DC    C'OWNER         OWNER OF THE DATA SET'          @Z40LB26
STE10S   DC    C'PROT          TYPE OF PROTECTION ASSIGNED'    @Z40LB26
         DC    C' TO DATA SET'                                 @Z40LB26
STE10T   DC    C'A BLANK INDICATES NO PROTECTION.'             @Z40LB26
STE10T1  DC    C'RACF  -RACF PROTECTION'                       @G24LB31
STE10T2  DC    C'RF,R  -RACF PLUS READ AND WRITE PASSWORD '    @G24LB31
         DC    C'PROTECTION'                                   @G24LB31
STE10T3  DC    C'RF,W  -RACF PLUS WRITE PASSWORD PROTECTION'   @G24LB31
STE10U   DC    C'R/W   -READ AND WRITE PASSWORD PROTECTION'    @Z40LB26
STE10V   DC    C'W     -WRITE PASSWORD PROTECTION'             @Z40LB26
STE10W   EQU   *                                               @Z40LB26
TXT10B   EQU   *                                               @Z40LB26
         EJECT                                                 @Z40LB26
************************************************************** @Z40LB26
*                                                            * @Z40LB26
*  LEGEND FOR SPACE USAGE REPORT                             * @Z40LB26
*                                                            * @Z40LB26
************************************************************** @Z40LB26
TXT11    DC    Y(TXT11B-TXT11A)        ENTRY LENGTH            @Z40LB26
         DC    H'0'                    FLAGS                   @Z40LB26
************************************************************** @Z40LB26
*                                                            * @Z40LB26
*  SPACING SUB-STRUCTURE                                     * @Z40LB26
*                                                            * @Z40LB26
************************************************************** @Z40LB26
TXT11A   DC    X'4000'                 SPACING CONTROL FLAG    @Z40LB26
         DC    H'2'                    IGNORED                 @Z40LB26
         DC    C'R '                   RELATIVE SPACING TYPE   @Z40LB26
************************************************************** @Z40LB26
*                                                            * @Z40LB26
*  STATIC TEXT SUB-STRUCTURE - FIELD DESCRIPTION             * @Z40LB26
*                                                            * @Z40LB26
************************************************************** @Z40LB26
         DC    X'0400'                 STATIC TEXT FLAG        @Z40LB26
         DC    Y(STE11C-STE11B)        TEXT LENGTH             @Z40LB26
         DC    Y(STE11B-TXT11A)        TEXT OFFSET             @Z40LB26
         DC    H'1'                    PRINT COLUMN            @Z40LB26
         DC    Y(STE11C-STE11B)        PRINT FIELD LENGTH      @Z40LB26
         DC    H'0'                    CONVERSION FLAGS        @Z40LB26
************************************************************** @Z40LB26
*                                                            * @Z40LB26
*  SPACING SUB-STRUCTURE                                     * @Z40LB26
*                                                            * @Z40LB26
************************************************************** @Z40LB26
         DC    X'4000'                 SPACING CONTROL FLAG    @Z40LB26
         DC    H'2'                    DOUBLE SPACE            @Z40LB26
         DC    C'R '                   RELATIVE SPACING TYPE   @Z40LB26
************************************************************** @Z40LB26
*                                                            * @Z40LB26
*  STATIC TEXT SUB-STRUCTURE - ALLOC UNIT                    * @Z40LB26
*                                                            * @Z40LB26
************************************************************** @Z40LB26
         DC    X'0400'                 STATIC TEXT FLAG        @Z40LB26
         DC    Y(STE11D-STE11C)        TEXT LENGTH             @Z40LB26
         DC    Y(STE11C-TXT11A)        TEXT OFFSET             @Z40LB26
         DC    H'1'                    PRINT COLUMN            @Z40LB26
         DC    Y(STE11D-STE11C)        PRINT FIELD LENGTH      @Z40LB26
         DC    H'0'                    CONVERSION FLAGS        @Z40LB26
************************************************************** @Z40LB26
*                                                            * @Z40LB26
*  SPACING SUB-STRUCTURE                                     * @Z40LB26
*                                                            * @Z40LB26
************************************************************** @Z40LB26
         DC    X'4000'                 SPACING CONTROL FLAG    @Z40LB26
         DC    H'1'                    SINGLE SPACE            @Z40LB26
         DC    C'R '                   RELATIVE SPACING TYPE   @Z40LB26
************************************************************** @Z40LB26
*                                                            * @Z40LB26
*  STATIC TEXT SUB-STRUCTURE - ABSTR                         * @Z40LB26
*                                                            * @Z40LB26
************************************************************** @Z40LB26
         DC    X'0400'                 STATIC TEXT FLAG        @Z40LB26
         DC    Y(STE11E-STE11D)        TEXT LENGTH             @Z40LB26
         DC    Y(STE11D-TXT11A)        TEXT OFFSET             @Z40LB26
         DC    H'18'                   PRINT COLUMN            @Z40LB26
         DC    Y(STE11E-STE11D)        PRINT FIELD LENGTH      @Z40LB26
         DC    H'0'                    CONVERSION FLAGS        @Z40LB26
************************************************************** @Z40LB26
*                                                            * @Z40LB26
*  SPACING SUB-STRUCTURE                                     * @Z40LB26
*                                                            * @Z40LB26
************************************************************** @Z40LB26
         DC    X'4000'                 SPACING CONTROL FLAG    @Z40LB26
         DC    H'1'                    SINGLE SPACE            @Z40LB26
         DC    C'R '                   RELATIVE SPACING TYPE   @Z40LB26
************************************************************** @Z40LB26
*                                                            * @Z40LB26
*  STATIC TEXT SUB-STRUCTURE - BLK                           * @Z40LB26
*                                                            * @Z40LB26
************************************************************** @Z40LB26
         DC    X'0400'                 STATIC TEXT FLAG        @Z40LB26
         DC    Y(STE11F-STE11E)        TEXT LENGTH             @Z40LB26
         DC    Y(STE11E-TXT11A)        TEXT OFFSET             @Z40LB26
         DC    H'18'                   PRINT COLUMN            @Z40LB26
         DC    Y(STE11F-STE11E)        PRINT FIELD LENGTH      @Z40LB26
         DC    H'0'                    CONVERSION FLAGS        @Z40LB26
************************************************************** @Z40LB26
*                                                            * @Z40LB26
*  SPACING SUB-STRUCTURE                                     * @Z40LB26
*                                                            * @Z40LB26
************************************************************** @Z40LB26
         DC    X'4000'                 SPACING CONTROL FLAG    @Z40LB26
         DC    H'1'                    SINGLE SPACE            @Z40LB26
         DC    C'R '                   RELATIVE SPACING TYPE   @Z40LB26
************************************************************** @Z40LB26
*                                                            * @Z40LB26
*  STATIC TEXT SUB-STRUCTURE - CYL                           * @Z40LB26
*                                                            * @Z40LB26
************************************************************** @Z40LB26
         DC    X'0400'                 STATIC TEXT FLAG        @Z40LB26
         DC    Y(STE11G-STE11F)        TEXT LENGTH             @Z40LB26
         DC    Y(STE11F-TXT11A)        TEXT OFFSET             @Z40LB26
         DC    H'18'                   PRINT COLUMN            @Z40LB26
         DC    Y(STE11G-STE11F)        PRINT FIELD LENGTH      @Z40LB26
         DC    H'0'                    CONVERSION FLAGS        @Z40LB26
************************************************************** @Z40LB26
*                                                            * @Z40LB26
*  SPACING SUB-STRUCTURE                                     * @Z40LB26
*                                                            * @Z40LB26
************************************************************** @Z40LB26
         DC    X'4000'                 SPACING CONTROL FLAG    @Z40LB26
         DC    H'1'                    SINGLE SPACE            @Z40LB26
         DC    C'R '                   RELATIVE SPACING TYPE   @Z40LB26
************************************************************** @Z40LB26
*                                                            * @Z40LB26
*  STATIC TEXT SUB-STRUCTURE - TRK                           * @Z40LB26
*                                                            * @Z40LB26
************************************************************** @Z40LB26
         DC    X'0400'                 STATIC TEXT FLAG        @Z40LB26
         DC    Y(STE11H-STE11G)        TEXT LENGTH             @Z40LB26
         DC    Y(STE11G-TXT11A)        TEXT OFFSET             @Z40LB26
         DC    H'18'                   PRINT COLUMN            @Z40LB26
         DC    Y(STE11H-STE11G)        PRINT FIELD LENGTH      @Z40LB26
         DC    H'0'                    CONVERSION FLAGS        @Z40LB26
************************************************************** @Z40LB26
*                                                            * @Z40LB26
*  SPACING SUB-STRUCTURE                                     * @Z40LB26
*                                                            * @Z40LB26
************************************************************** @Z40LB26
         DC    X'4000'                 SPACING CONTROL FLAG    @Z40LB26
         DC    H'2'                    DOUBLE SPACE            @Z40LB26
         DC    C'R '                   RELATIVE SPACING TYPE   @Z40LB26
************************************************************** @Z40LB26
*                                                            * @Z40LB26
*  STATIC TEXT SUB-STRUCTURE - DATA SET                      * @Z40LB26
*                                                            * @Z40LB26
************************************************************** @Z40LB26
         DC    X'0400'                 STATIC TEXT FLAG        @Z40LB26
         DC    Y(STE11I-STE11H)        TEXT LENGTH             @Z40LB26
         DC    Y(STE11H-TXT11A)        TEXT OFFSET             @Z40LB26
         DC    H'1'                    PRINT COLUMN            @Z40LB26
         DC    Y(STE11I-STE11H)        PRINT FIELD LENGTH      @Z40LB26
         DC    H'0'                    CONVERSION FLAGS        @Z40LB26
************************************************************** @Z40LB26
*                                                            * @Z40LB26
*  SPACING SUB-STRUCTURE                                     * @Z40LB26
*                                                            * @Z40LB26
************************************************************** @Z40LB26
         DC    X'4000'                 SPACING CONTROL FLAG    @Z40LB26
         DC    H'2'                    DOUBLE SPACE            @Z40LB26
         DC    C'R '                   RELATIVE SPACING TYPE   @Z40LB26
************************************************************** @Z40LB26
*                                                            * @Z40LB26
*  STATIC TEXT SUB-STRUCTURE - DS ORG                        * @Z40LB26
*                                                            * @Z40LB26
************************************************************** @Z40LB26
         DC    X'0400'                 STATIC TEXT FLAG        @Z40LB26
         DC    Y(STE11J-STE11I)        TEXT LENGTH             @Z40LB26
         DC    Y(STE11I-TXT11A)        TEXT OFFSET             @Z40LB26
         DC    H'1'                    PRINT COLUMN            @Z40LB26
         DC    Y(STE11J-STE11I)        PRINT FIELD LENGTH      @Z40LB26
         DC    H'0'                    CONVERSION FLAGS        @Z40LB26
************************************************************** @Z40LB26
*                                                            * @Z40LB26
*  SPACING SUB-STRUCTURE                                     * @Z40LB26
*                                                            * @Z40LB26
************************************************************** @Z40LB26
         DC    X'4000'                 SPACING CONTROL FLAG    @Z40LB26
         DC    H'1'                    SINGLE SPACE            @Z40LB26
         DC    C'R '                   RELATIVE SPACING TYPE   @Z40LB26
************************************************************** @Z40LB26
*                                                            * @Z40LB26
*  STATIC TEXT SUB-STRUCTURE - DA                            * @Z40LB26
*                                                            * @Z40LB26
************************************************************** @Z40LB26
         DC    X'0400'                 STATIC TEXT FLAG        @Z40LB26
         DC    Y(STE11K-STE11J)        TEXT LENGTH             @Z40LB26
         DC    Y(STE11J-TXT11A)        TEXT OFFSET             @Z40LB26
         DC    H'18'                   PRINT COLUMN            @Z40LB26
         DC    Y(STE11K-STE11J)        PRINT FIELD LENGTH      @Z40LB26
         DC    H'0'                    CONVERSION FLAGS        @Z40LB26
************************************************************** @Z40LB26
*                                                            * @Z40LB26
*  SPACING SUB-STRUCTURE                                     * @Z40LB26
*                                                            * @Z40LB26
************************************************************** @Z40LB26
         DC    X'4000'                 SPACING CONTROL FLAG    @Z40LB26
         DC    H'1'                    SINGLE SPACE            @Z40LB26
         DC    C'R '                   RELATIVE SPACING TYPE   @Z40LB26
************************************************************** @Z40LB26
*                                                            * @Z40LB26
*  STATIC TEXT SUB-STRUCTURE - DAU                           * @Z40LB26
*                                                            * @Z40LB26
************************************************************** @Z40LB26
         DC    X'0400'                 STATIC TEXT FLAG        @Z40LB26
         DC    Y(STE11L-STE11K)        TEXT LENGTH             @Z40LB26
         DC    Y(STE11K-TXT11A)        TEXT OFFSET             @Z40LB26
         DC    H'18'                   PRINT COLUMN            @Z40LB26
         DC    Y(STE11L-STE11K)        PRINT FIELD LENGTH      @Z40LB26
         DC    H'0'                    CONVERSION FLAGS        @Z40LB26
************************************************************** @Z40LB26
*                                                            * @Z40LB26
*  SPACING SUB-STRUCTURE                                     * @Z40LB26
*                                                            * @Z40LB26
************************************************************** @Z40LB26
         DC    X'4000'                 SPACING CONTROL FLAG    @Z40LB26
         DC    H'1'                    SINGLE SPACE            @Z40LB26
         DC    C'R '                   RELATIVE SPACING TYPE   @Z40LB26
************************************************************** @Z40LB26
*                                                            * @Z40LB26
*  STATIC TEXT SUB-STRUCTURE - IS                            * @Z40LB26
*                                                            * @Z40LB26
************************************************************** @Z40LB26
         DC    X'0400'                 STATIC TEXT FLAG        @Z40LB26
         DC    Y(STE11M-STE11L)        TEXT LENGTH             @Z40LB26
         DC    Y(STE11L-TXT11A)        TEXT OFFSET             @Z40LB26
         DC    H'18'                   PRINT COLUMN            @Z40LB26
         DC    Y(STE11M-STE11L)        PRINT FIELD LENGTH      @Z40LB26
         DC    H'0'                    CONVERSION FLAGS        @Z40LB26
************************************************************** @Z40LB26
*                                                            * @Z40LB26
*  SPACING SUB-STRUCTURE                                     * @Z40LB26
*                                                            * @Z40LB26
************************************************************** @Z40LB26
         DC    X'4000'                 SPACING CONTROL FLAG    @Z40LB26
         DC    H'1'                    SINGLE SPACE            @Z40LB26
         DC    C'R '                   RELATIVE SPACING TYPE   @Z40LB26
************************************************************** @Z40LB26
*                                                            * @Z40LB26
*  STATIC TEXT SUB-STRUCTURE - ISU                           * @Z40LB26
*                                                            * @Z40LB26
************************************************************** @Z40LB26
         DC    X'0400'                 STATIC TEXT FLAG        @Z40LB26
         DC    Y(STE11N-STE11M)        TEXT LENGTH             @Z40LB26
         DC    Y(STE11M-TXT11A)        TEXT OFFSET             @Z40LB26
         DC    H'18'                   PRINT COLUMN            @Z40LB26
         DC    Y(STE11N-STE11M)        PRINT FIELD LENGTH      @Z40LB26
         DC    H'0'                    CONVERSION FLAGS        @Z40LB26
************************************************************** @Z40LB26
*                                                            * @Z40LB26
*  SPACING SUB-STRUCTURE                                     * @Z40LB26
*                                                            * @Z40LB26
************************************************************** @Z40LB26
         DC    X'4000'                 SPACING CONTROL FLAG    @Z40LB26
         DC    H'1'                    SINGLE SPACE            @Z40LB26
         DC    C'R '                   RELATIVE SPACING TYPE   @Z40LB26
************************************************************** @Z40LB26
*                                                            * @Z40LB26
*  STATIC TEXT SUB-STRUCTURE - PO                            * @Z40LB26
*                                                            * @Z40LB26
************************************************************** @Z40LB26
         DC    X'0400'                 STATIC TEXT FLAG        @Z40LB26
         DC    Y(STE11O-STE11N)        TEXT LENGTH             @Z40LB26
         DC    Y(STE11N-TXT11A)        TEXT OFFSET             @Z40LB26
         DC    H'18'                   PRINT COLUMN            @Z40LB26
         DC    Y(STE11O-STE11N)        PRINT FIELD LENGTH      @Z40LB26
         DC    H'0'                    CONVERSION FLAGS        @Z40LB26
************************************************************** @Z40LB26
*                                                            * @Z40LB26
*  SPACING SUB-STRUCTURE                                     * @Z40LB26
*                                                            * @Z40LB26
************************************************************** @Z40LB26
         DC    X'4000'                 SPACING CONTROL FLAG    @Z40LB26
         DC    H'1'                    SINGLE SPACE            @Z40LB26
         DC    C'R '                   RELATIVE SPACING TYPE   @Z40LB26
************************************************************** @Z40LB26
*                                                            * @Z40LB26
*  STATIC TEXT SUB-STRUCTURE - POU                           * @Z40LB26
*                                                            * @Z40LB26
************************************************************** @Z40LB26
         DC    X'0400'                 STATIC TEXT FLAG        @Z40LB26
         DC    Y(STE11P-STE11O)        TEXT LENGTH             @Z40LB26
         DC    Y(STE11O-TXT11A)        TEXT OFFSET             @Z40LB26
         DC    H'18'                   PRINT COLUMN            @Z40LB26
         DC    Y(STE11P-STE11O)        PRINT FIELD LENGTH      @Z40LB26
         DC    H'0'                    CONVERSION FLAGS        @Z40LB26
************************************************************** @Z40LB26
*                                                            * @Z40LB26
*  SPACING SUB-STRUCTURE                                     * @Z40LB26
*                                                            * @Z40LB26
************************************************************** @Z40LB26
         DC    X'4000'                 SPACING CONTROL FLAG    @Z40LB26
         DC    H'1'                    SINGLE SPACE            @Z40LB26
         DC    C'R '                   RELATIVE SPACING TYPE   @Z40LB26
************************************************************** @Z40LB26
*                                                            * @Z40LB26
*  STATIC TEXT SUB-STRUCTURE - PS                            * @Z40LB26
*                                                            * @Z40LB26
************************************************************** @Z40LB26
         DC    X'0400'                 STATIC TEXT FLAG        @Z40LB26
         DC    Y(STE11Q-STE11P)        TEXT LENGTH             @Z40LB26
         DC    Y(STE11P-TXT11A)        TEXT OFFSET             @Z40LB26
         DC    H'18'                   PRINT COLUMN            @Z40LB26
         DC    Y(STE11Q-STE11P)        PRINT FIELD LENGTH      @Z40LB26
         DC    H'0'                    CONVERSION FLAGS        @Z40LB26
************************************************************** @Z40LB26
*                                                            * @Z40LB26
*  SPACING SUB-STRUCTURE                                     * @Z40LB26
*                                                            * @Z40LB26
************************************************************** @Z40LB26
         DC    X'4000'                 SPACING CONTROL FLAG    @Z40LB26
         DC    H'1'                    SINGLE SPACE            @Z40LB26
         DC    C'R '                   RELATIVE SPACING TYPE   @Z40LB26
************************************************************** @Z40LB26
*                                                            * @Z40LB26
*  STATIC TEXT SUB-STRUCTURE - PSU                           * @Z40LB26
*                                                            * @Z40LB26
************************************************************** @Z40LB26
         DC    X'0400'                 STATIC TEXT FLAG        @Z40LB26
         DC    Y(STE11R-STE11Q)        TEXT LENGTH             @Z40LB26
         DC    Y(STE11Q-TXT11A)        TEXT OFFSET             @Z40LB26
         DC    H'18'                   PRINT COLUMN            @Z40LB26
         DC    Y(STE11R-STE11Q)        PRINT FIELD LENGTH      @Z40LB26
         DC    H'0'                    CONVERSION FLAGS        @Z40LB26
************************************************************** @Z40LB26
*                                                            * @Z40LB26
*  SPACING SUB-STRUCTURE                                     * @Z40LB26
*                                                            * @Z40LB26
************************************************************** @Z40LB26
         DC    X'4000'                 SPACING CONTROL FLAG    @Z40LB26
         DC    H'1'                    SINGLE SPACE            @Z40LB26
         DC    C'R '                   RELATIVE SPACING TYPE   @Z40LB26
************************************************************** @Z40LB26
*                                                            * @Z40LB26
*  STATIC TEXT SUB-STRUCTURE - UN                            * @Z40LB26
*                                                            * @Z40LB26
************************************************************** @Z40LB26
         DC    X'0400'                 STATIC TEXT FLAG        @Z40LB26
         DC    Y(STE11S-STE11R)        TEXT LENGTH             @Z40LB26
         DC    Y(STE11R-TXT11A)        TEXT OFFSET             @Z40LB26
         DC    H'18'                   PRINT COLUMN            @Z40LB26
         DC    Y(STE11S-STE11R)        PRINT FIELD LENGTH      @Z40LB26
         DC    H'0'                    CONVERSION FLAGS        @Z40LB26
************************************************************** @Z40LB26
*                                                            * @Z40LB26
*  SPACING SUB-STRUCTURE                                     * @Z40LB26
*                                                            * @Z40LB26
************************************************************** @Z40LB26
         DC    X'4000'                 SPACING CONTROL FLAG    @Z40LB26
         DC    H'1'                    SINGLE SPACE            @Z40LB26
         DC    C'R '                   RELATIVE SPACING TYPE   @Z40LB26
************************************************************** @Z40LB26
*                                                            * @Z40LB26
*  STATIC TEXT SUB-STRUCTURE                                 * @Z40LB26
*                                                            * @Z40LB26
************************************************************** @Z40LB26
         DC    X'0400'                 STATIC TEXT FLAG        @Z40LB26
         DC    Y(STE11T-STE11S)        TEXT LENGTH             @Z40LB26
         DC    Y(STE11S-TXT11A)        TEXT OFFSET             @Z40LB26
         DC    H'24'                   PRINT COLUMN            @Z40LB26
         DC    Y(STE11T-STE11S)        PRINT FIELD LENGTH      @Z40LB26
         DC    H'0'                    CONVERSION FLAGS        @Z40LB26
************************************************************** @Z40LB26
*                                                            * @Z40LB26
*  SPACING SUB-STRUCTURE                                     * @Z40LB26
*                                                            * @Z40LB26
************************************************************** @Z40LB26
         DC    X'4000'                 SPACING CONTROL FLAG    @Z40LB26
         DC    H'2'                    DOUBLE SPACE            @Z40LB26
         DC    C'R '                   RELATIVE SPACING TYPE   @Z40LB26
************************************************************** @Z40LB26
*                                                            * @Z40LB26
*  STATIC TEXT SUB-STRUCTURE - FREE TRKS                     * @Z40LB26
*                                                            * @Z40LB26
************************************************************** @Z40LB26
         DC    X'0400'                 STATIC TEXT FLAG        @Z40LB26
         DC    Y(STE11U-STE11T)        TEXT LENGTH             @Z40LB26
         DC    Y(STE11T-TXT11A)        TEXT OFFSET             @Z40LB26
         DC    H'1'                    PRINT COLUMN            @Z40LB26
         DC    Y(STE11U-STE11T)        PRINT FIELD LENGTH      @Z40LB26
         DC    H'0'                    CONVERSION FLAGS        @Z40LB26
************************************************************** @Z40LB26
*                                                            * @Z40LB26
*  SPACING SUB-STRUCTURE                                     * @Z40LB26
*                                                            * @Z40LB26
************************************************************** @Z40LB26
         DC    X'4000'                 SPACING CONTROL FLAG    @Z40LB26
         DC    H'1'                    SINGLE SPACE            @Z40LB26
         DC    C'R '                   RELATIVE SPACING TYPE   @Z40LB26
************************************************************** @Z40LB26
*                                                            * @Z40LB26
*  STATIC TEXT SUB-STRUCTURE                                 * @Z40LB26
*                                                            * @Z40LB26
************************************************************** @Z40LB26
         DC    X'0400'                 STATIC TEXT FLAG        @Z40LB26
         DC    Y(STE11U1-STE11U)        TEXT LENGTH            @Z40LB26
         DC    Y(STE11U-TXT11A)        TEXT OFFSET             @Z40LB26
         DC    H'15'                   PRINT COLUMN            @Z40LB26
         DC    Y(STE11U1-STE11U)        PRINT FIELD LENGTH     @Z40LB26
         DC    H'0'                    CONVERSION FLAGS        @Z40LB26
************************************************************** @Z40LB26
*                                                            * @Z40LB26
*  SPACING SUB-STRUCTURE                                     * @Z40LB26
*                                                            * @Z40LB26
************************************************************** @Z40LB26
         DC    X'4000'                 SPACING CONTROL FLAG    @Z40LB26
         DC    H'1'                    SINGLE SPACE            @Z40LB26
         DC    C'R '                   RELATIVE SPACING TYPE   @Z40LB26
************************************************************** @Z40LB26
*                                                            * @Z40LB26
*  STATIC TEXT SUB-STRUCTURE                                 * @Z40LB26
*                                                            * @Z40LB26
************************************************************** @Z40LB26
         DC    X'0400'                 STATIC TEXT FLAG        @Z40LB26
         DC    Y(STE11U2-STE11U1)       TEXT LENGTH            @ZA29215
         DC    Y(STE11U1-TXT11A)        TEXT OFFSET            @Z40LB26
         DC    H'15'                   PRINT COLUMN            @Z40LB26
         DC    Y(STE11U2-STE11U1)       PRINT FIELD LENGTH     @ZA29215
         DC    H'0'                    CONVERSION FLAGS        @Z40LB26
************************************************************** @ZA29215
*                                                            * @ZA29215
*  SPACING SUB-STRUCTURE                                     * @ZA29215
*                                                            * @ZA29215
************************************************************** @ZA29215
         DC    X'4000'                 SPACING CONTROL FLAG    @ZA29215
         DC    H'1'                    SINGLE SPACE            @ZA29215
         DC    C'R '                   RELATIVE SPACING TYPE   @ZA29215
************************************************************** @ZA29215
*                                                            * @ZA29215
*  STATIC TEXT SUB-STRUCTURE                                 * @ZA29215
*                                                            * @ZA29215
************************************************************** @ZA29215
         DC    X'0400'                 STATIC TEXT FLAG        @ZA29215
         DC    Y(STE11V-STE11U2)        TEXT LENGTH            @ZA29215
         DC    Y(STE11U2-TXT11A)        TEXT OFFSET            @ZA29215
         DC    H'15'                   PRINT COLUMN            @ZA29215
         DC    Y(STE11V-STE11U2)        PRINT FIELD LENGTH     @ZA29215
         DC    H'0'                    CONVERSION FLAGS        @ZA29215
************************************************************** @Z40LB26
*                                                            * @Z40LB26
*  SPACING SUB-STRUCTURE                                     * @Z40LB26
*                                                            * @Z40LB26
************************************************************** @Z40LB26
         DC    X'4000'                 SPACING CONTROL FLAG    @Z40LB26
         DC    H'2'                    DOUBLE SPACE            @Z40LB26
         DC    C'R '                   RELATIVE SPACING TYPE   @Z40LB26
************************************************************** @Z40LB26
*                                                            * @Z40LB26
*  STATIC TEXT SUB-STRUCTURE - NO EXTS                       * @Z40LB26
*                                                            * @Z40LB26
************************************************************** @Z40LB26
         DC    X'0400'                 STATIC TEXT FLAG        @Z40LB26
         DC    Y(STE11W-STE11V)        TEXT LENGTH             @Z40LB26
         DC    Y(STE11V-TXT11A)        TEXT OFFSET             @Z40LB26
         DC    H'1'                    PRINT COLUMN            @Z40LB26
         DC    Y(STE11W-STE11V)        PRINT FIELD LENGTH      @Z40LB26
         DC    H'0'                    CONVERSION FLAGS        @Z40LB26
************************************************************** @Z40LB26
*                                                            * @Z40LB26
*  SPACING SUB-STRUCTURE                                     * @Z40LB26
*                                                            * @Z40LB26
************************************************************** @Z40LB26
         DC    X'4000'                 SPACING CONTROL FLAG    @Z40LB26
         DC    H'2'                    DOUBLE SPACE            @Z40LB26
         DC    C'R '                   RELATIVE SPACING TYPE   @Z40LB26
************************************************************** @Z40LB26
*                                                            * @Z40LB26
*  STATIC TEXT SUB-STRUCTURE - SEC ALLOC                     * @Z40LB26
*                                                            * @Z40LB26
************************************************************** @Z40LB26
         DC    X'0400'                 STATIC TEXT FLAG        @Z40LB26
         DC    Y(STE11X-STE11W)        TEXT LENGTH             @Z40LB26
         DC    Y(STE11W-TXT11A)        TEXT OFFSET             @Z40LB26
         DC    H'1'                    PRINT COLUMN            @Z40LB26
         DC    Y(STE11X-STE11W)        PRINT FIELD LENGTH      @Z40LB26
         DC    H'0'                    CONVERSION FLAGS        @Z40LB26
************************************************************** @Z40LB26
*                                                            * @Z40LB26
*  SPACING SUB-STRUCTURE                                     * @Z40LB26
*                                                            * @Z40LB26
************************************************************** @Z40LB26
         DC    X'4000'                 SPACING CONTROL FLAG    @Z40LB26
         DC    H'1'                    SINGLE SPACE            @Z40LB26
         DC    C'R '                   RELATIVE SPACING TYPE   @Z40LB26
************************************************************** @Z40LB26
*                                                            * @Z40LB26
*  STATIC TEXT SUB-STRUCTURE                                 * @Z40LB26
*                                                            * @Z40LB26
************************************************************** @Z40LB26
         DC    X'0400'                 STATIC TEXT FLAG        @Z40LB26
         DC    Y(STE11Y-STE11X)        TEXT LENGTH             @Z40LB26
         DC    Y(STE11X-TXT11A)        TEXT OFFSET             @Z40LB26
         DC    H'15'                   PRINT COLUMN            @Z40LB26
         DC    Y(STE11Y-STE11X)        PRINT FIELD LENGTH      @Z40LB26
         DC    H'0'                    CONVERSION FLAGS        @Z40LB26
************************************************************** @Z40LB26
*                                                            * @Z40LB26
*  SPACING SUB-STRUCTURE                                     * @Z40LB26
*                                                            * @Z40LB26
************************************************************** @Z40LB26
         DC    X'4000'                 SPACING CONTROL FLAG    @Z40LB26
         DC    H'2'                    DOUBLE SPACE            @Z40LB26
         DC    C'R '                   RELATIVE SPACING TYPE   @Z40LB26
************************************************************** @Z40LB26
*                                                            * @Z40LB26
*  STATIC TEXT SUB-STRUCTURE - TOTAL TRKS                    * @Z40LB26
*                                                            * @Z40LB26
************************************************************** @Z40LB26
         DC    X'8400'                 STATIC TEXT FLAG        @Z40LB26
         DC    Y(TXT11B-STE11Y)        TEXT LENGTH             @Z40LB26
         DC    Y(STE11Y-TXT11A)        TEXT OFFSET             @Z40LB26
         DC    H'1'                    PRINT COLUMN            @Z40LB26
         DC    Y(TXT11B-STE11Y)        PRINT FIELD LENGTH      @Z40LB26
         DC    H'0'                    CONVERSION FLAGS        @Z40LB26
************************************************************** @Z40LB26
*                                                            * @Z40LB26
*  STATIC TEXT ENTRIES                                       * @Z40LB26
*                                                            * @Z40LB26
************************************************************** @Z40LB26
STE11B   DC    C'-FIELD-       -DESCRIPTION-'                  @Z40LB26
STE11C   DC    C'ALLOC UNIT    TYPE OF UNIT IN WHICH SPACE'    @Z40LB26
         DC    C' WAS ALLOCATED'                               @Z40LB26
STE11D   DC    C'ABSTR - ABSOLUTE TRACKS'                      @Z40LB26
STE11E   DC    C'BLK   - BLOCKS'                               @Z40LB26
STE11F   DC    C'CYL   - CYLINDERS'                            @Z40LB26
STE11G   DC    C'TRK   - TRACKS'                               @Z40LB26
STE11H   DC    C'DATA SET      DATA SET NAME'                  @Z40LB26
STE11I   DC    C'DS ORG        DATA SET ORGANIZATION'          @Z40LB26
STE11J   DC    C'DA  - DIRECT ACCESS'                          @Z40LB26
STE11K   DC    C'DAU - DIRECT ACCESS UNMOVABLE'                @Z40LB26
STE11L   DC    C'IS  - INDEXED SEQUENTIAL'                     @Z40LB26
STE11M   DC    C'ISU - INDEXED SEQUENTIAL UNMOVABLE'           @Z40LB26
STE11N   DC    C'PO  - PARTITIONED'                            @Z40LB26
STE11O   DC    C'POU - PARTITIONED UNMOVABLE'                  @Z40LB26
STE11P   DC    C'PS  - PHYSICAL SEQUENTIAL'                    @Z40LB26
STE11Q   DC    C'PSU - PHYSICAL SEQUENTIAL UNMOVABLE'          @Z40LB26
STE11R   DC    C'UN  - UNDEFINED. EITHER NO DATA SET'          @Z40LB26
         DC    C' ORGANIZATION SPECIFIED,'                     @Z40LB26
STE11S   DC    C' OR OTHER THAN THE ABOVE.'                    @Z40LB26
STE11T   DC    C'FREE TRKS     NUMBER OF UNUSED TRACKS IN THE' @Z40LB26
         DC    C' DATA SET.  BLANK IF THE FREE SPACE'          @Z40LB26
STE11U   DC    C'CANNOT BE CALCULATED BECAUSE DSORG IS'        @Z40LB26
         DC    C' DA, IS, OR UN, OR BECAUSE'                   @Z40LB26
STE11U1  DC    C'DSORG IS PS OR PO AND THE DATA SET HAS TRACK' @Z40LB26
         DC    C' OVERFLOW OR'                                 @ZA29215
STE11U2  DC    C'THE END OF DATA SET POINTERS IN THE FORMAT'   @ZA29215
         DC    C' ONE DSCB ARE INCONSISTENT.'                  @ZA29215
STE11V   DC    C'NO. EXTS      TOTAL NUMBER OF EXTENTS'        @Z40LB26
STE11W   DC    C'SEC ALLOC     NUMBER OF BLOCKS, TRACKS, OR'   @Z40LB26
         DC    C' CYLINDERS TO BE ALLOCATED IF MORE'           @Z40LB26
STE11X   DC    C'SPACE IS REQUIRED FOR THE DATA SET.  BLANK'   @Z40LB26
         DC    C' IF GREATER THAN 9999.'                       @Z40LB26
STE11Y   DC    C'TOTAL TRKS    NUMBER OF TRACKS ALLOCATED TO'  @Z40LB26
         DC    C' A DATA SET, USED AND UNUSED.'                @Z40LB26
TXT11B   EQU   *                                               @Z40LB26
         EJECT                                                 @Z40LB26
************************************************************** @Z40LB26
*                                                            * @Z40LB26
*  MISC PRINT CONSTANTS                                      * @Z40LB26
*                                                            * @Z40LB26
************************************************************** @Z40LB26
TXT12    DC    Y(TXT12B-TXT12A)        ENTRY LENGTH            @Z40LB26
         DC    H'0'                                            @Z40LB26
************************************************************** @Z40LB26
*                                                            * @Z40LB26
*  STATIC TEXT SUB-STRUCTURE                                 * @Z40LB26
*                                                            * @Z40LB26
************************************************************** @Z40LB26
TXT12A   DC    X'8400'                 STATIC TEXT FLAG        @Z40LB26
         DC    Y(STE12B-STE12A)        TEXT LENGTH             @Z40LB26
         DC    Y(STE12A-TXT12A)        TEXT OFFSET             @Z40LB26
         DC    H'1'                    PRINT COLUMN            @Z40LB26
         DC    Y(STE12B-STE12A)        PRINT FIELD LENGTH      @Z40LB26
         DC    H'0'                    NO CONVERSION           @Z40LB26
************************************************************** @Z40LB26
*                                                            * @Z40LB26
*  STATIC TEXT ENTRIES                                       * @Z40LB26
*                                                            * @Z40LB26
************************************************************** @Z40LB26
STE12A   DC    C'-V-CR/W W    NOERRPO PS UN DA IS UCYL'        @G24LB31
         DC    C'  TRK  BLK  ABSTRRACFRF,RRF,W'                @G24LB31
STE12B   EQU   *                                               @Z40LB26
TXT12B   EQU   *                                               @Z40LB26
         EJECT                                                 @Z40LB26
************************************************************** @Z40LB26
*                                                            * @Z40LB26
*  LEGENDS - LEGENDS SUB-TITLE                               * @Z40LB26
*                                                            * @Z40LB26
************************************************************** @Z40LB26
TXT13    DC    Y(TXT13B-TXT13A)        ENTRY LENGTH            @Z40LB26
         DC    H'0'                    FLAGS                   @Z40LB26
************************************************************** @Z40LB26
*                                                            * @Z40LB26
*  STATIC TEXT SUB-STRUCTURE                                 * @Z40LB26
*                                                            * @Z40LB26
************************************************************** @Z40LB26
TXT13A   DC    X'8400'                 STATIC TEXT FLAG        @Z40LB26
         DC    Y(STE13B-STE13A)        TEXT LENGTH             @Z40LB26
         DC    Y(STE13A-TXT13A)        TEXT OFFSET             @Z40LB26
         DC    H'1'                    PRINT COLUMN            @Z40LB26
         DC    Y(STE13B-STE13A)        PRINT FIELD LENGTH      @Z40LB26
         DC    H'0'                    CONVERSION FLAG         @Z40LB26
************************************************************** @Z40LB26
*                                                            * @Z40LB26
*  STATIC TEXT ENTRIES                                       * @Z40LB26
*                                                            * @Z40LB26
************************************************************** @Z40LB26
STE13A   DC    C'0'                                            @Z40LB26
         DC    C'                            LEGEND'           @Z40LB26
STE13B   EQU   *                                               @Z40LB26
TXT13B   EQU   *                                               @Z40LB26
         END
