     TITLE  '***** IDCTSLR0 - LISTCRA STATIC TEXT *****'
* /* START OF SPECIFICATIONS ****
*
*01*  MODULE-NAME = IDCTSLR0
*01*  MODULE-TYPE = MODULE
*02*    PROCESSOR = ASSEMBLER
*
**** END OF SPECIFICATIONS ****/
**********************************************************************
*                                                                    *
* MODULE NAME - IDCTSLR0 - STATIC TEXT MODULE FOR LISTCRA            *
*                                                                    *
* DESCRIPTIVE NAME - TEXT PROCESSOR CONTROL FOR LISTCRA LISTINGS     *
*                                                                    *
* COPYRIGHT - NONE                                                   *
*                                                                    *
* STATUS - RELEASE 2  LEVEL 0                                        *
*                                                                    *
* FUNCTION - CONTAINS NO EXECUTABLE CODE, ONLY STATIC TEXT ENTRIES   *
*        FOR THE FUNCTION EXPORT                                     *
*        THIS MODULE IS LOADED BY IDCTP05 WHEN A STATIC TEXT         *
*        REQUEST IS MADE.                                            *
*        ALL OF THE FORMAT CONTROL ENTRIES ARE IN THIS MODULE        *
*        THE MESSAGES MODULE IS IDCTSLR1                             *
*                                                                    *
* NOTES - NONE                                                       *
*                                                                    *
*    DEPENDENCIES - NONE                                             *
*    RESTRICTIONS - NONE                                             *
*    REGISTER CONVENTIONS - NA                                       *
*    PATCH AREA - NA                                                 *
*                                                                    *
* MODULE TYPE - TABLES                                               *
*                                                                    *
*    PROCESSOR - ASSEMBLER                                           *
*    MODULE SIZE - 1200 BYTES                                        *
*                                                                    *
*  ENTRY POINT - NA                                                  *
*                                                                    *
*  EXIT NORMAL - NA                                                  *
*                                                                    *
*  EXIT ERROR - NA                                                   *
*                                                                    *
*  EXTERNAL REFERENCES - NA                                          *
*                                                                    *
*  TABLES - NA                                                       *
*                                                                    *
*  MACROS - NA                                                       *
*                                                                    *
*  CHANGE ACTIVITY SUMMARY -                                         *
*    D008600-008700,D054000,D056600-056984                   @OZ12892*
*                                                                    *
**********************************************************************
*
**********************************************************************
*                                                                    *
* THIS MODULE IS THE FIRST MODULE OF STATIC TEXT REQUIRED BY THE     *
*  LISTCRA FUNCTIONAL SUPPORT ROUTINES.                              *
*                                                                    *
**********************************************************************
*
IDCTSLR0 CSECT
*
* THIS SECTIONS CONTAINS THE INDICES TO REACH AN ENTRY.
*
INDEX    DC  H'13'                     COUNT OF ENTRIES
INDEX1   DC  Y(TXT1-INDEX)             OBJECT HEADER
INDEX2   DC  Y(TXT2-INDEX)             VOLUME HEADER
INDEX3   DC  Y(TXT3-INDEX)             VOLSER AND HI KEY
INDEX4   DC  Y(TXT4-INDEX)             TIMESTAMP HEADER
INDEX5   DC  Y(TXT5-INDEX)             TIMESTAMPS
INDEX6   DC  Y(TXT6-INDEX)             ASOC AIX NAMES
INDEX7   DC  Y(TXT7-INDEX)             MISCOMPARES
INDEX8   DC  Y(TXT8-INDEX)             DUMP FIRST LINE
INDEX9   DC  Y(TXT9-INDEX)             DUMP FOLLOWING LINES
INDEX10  DC  Y(TXT10-INDEX)            DUMP CATALOG RECORD
INDEX11  DC  Y(TXT11-INDEX)            MISCOMPARES
INDEX12  DC  Y(TXT12-INDEX)            NUMBER OF ENTRIES HEADER
INDEX13  DC  Y(TXT13-INDEX)            NUMBER OF ENTRIES
         EJECT
**********************************************************************
*                                                                    *
* THIS SECTION CONTAINS THE ENTRIES.                                 *
*                                                                    *
**********************************************************************
*
* OBJECT HEADER
*
TXT1     DC  Y(TXT1B-TXT1A)            ENTRY LENGTH.
         DC  X'0000'                   MESSAGE FLAG.
* DOUBLE SPACE SUB-STRUCTURE.
TXT1A    DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
         DC  H'2'                      SPACING FACTOR
         DC  C'R '                     SPACING TYPE.
* INSERT DATA SUB-STRUCTURE.
         DC  X'2000'                   INSERT DATA FLAG.
         DC  H'1'                      REFERENCE NUMBER
         DC  H'0'                      UNUSED
         DC  H'1'                      PRINT COLUMN.
         DC  H'4'                      PRINT FIELD LENGTH.
         DC  X'0000'                   CONVERSION FLAG.  (CHAR)
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC FLAGS.
         DC  Y(STE11B-STE11A)          STATIC TEXT LENGTH.
         DC  Y(STE11A-TXT1A)           STATIC TEXT OFFSET.
         DC  H'5'                      PRINT COLUMN OFFSET.
         DC  Y(STE11B-STE11A)          PRINT FIELD LENGTH.
         DC  X'0000'                   CONVERSION FLAG.  (CHAR)
* INSERT DATA SUB-STRUCTURE.
         DC  X'A000'                   INSERT DATA AND EOF FLAG.
         DC  H'2'                      REFERENCE NUMBER
         DC  H'0'                      UNUSED
         DC  H'8'                      PRINT COLUMN.
         DC  H'44'                     PRINT FIELD LENGTH.
         DC  X'0000'                   CONVERSION FLAGS.  (CHAR)
* STATIC TEXT ENTRY.
STE11A   DC  C' - '
STE11B   EQU *
TXT1B    EQU *
         EJECT
*
* VOLUME HEADER
*
TXT2     DC  Y(TXT2B-TXT2A)            ENTRY LENGTH.
         DC  X'0000'                   MESSAGE FLAG.
* DOUBLE SPACE SUB-STRUCTURE.
TXT2A    DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
         DC  H'1'                      SPACING FACTOR
         DC  C'R '                     SPACING TYPE.
* INSERT DATA SUB-STRUCTURE.
         DC  X'2000'                   INSERT DATA FLAG.
         DC  H'1'                      REFERENCE NUMBER
         DC  H'0'                      UNUSED
         DC  H'1'                      PRINT COLUMN.
         DC  H'4'                      PRINT FIELD LENGTH.
         DC  X'0000'                   CONVERSION FLAG.  (CHAR)
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC FLAGS.
         DC  Y(STE21B-STE21A)          STATIC TEXT LENGTH.
         DC  Y(STE21A-TXT2A)           STATIC TEXT OFFSET.
         DC  H'5'                      PRINT COLUMN OFFSET.
         DC  Y(STE21B-STE21A)          PRINT FIELD LENGTH.
         DC  X'0000'                   CONVERSION FLAG.  (CHAR)
* INSERT DATA SUB-STRUCTURE.
         DC  X'2000'                   INSERT DATA FLAG.
         DC  H'2'                      REFERENCE NUMBER
         DC  H'0'                      UNUSED
         DC  H'9'                      PRINT COLUMN.
         DC  H'3'                      PRINT FIELD LENGTH.
         DC  X'0000'                   CONVERSION FLAGS.  (CHAR)
* INSERT DATA SUB-STRUCTURE.
         DC  X'A000'                   INSERT DATA AND EOF FLAG.
         DC  H'3'                      REFERENCE NUMBER
         DC  H'0'                      UNUSED
         DC  H'12'                     PRINT COLUMN.
         DC  H'0'                      PRINT FIELD LENGTH.
         DC  X'0000'                   CONVERSION FLAGS.  (CHAR)
* STATIC TEXT ENTRY.
STE21A   DC  C' VOL'
STE21B   EQU *
TXT2B    EQU *
         EJECT
*
* VOLUME AND HI KEY
*
TXT3     DC  Y(TXT3B-TXT3A)            ENTRY LENGTH.
         DC  X'0000'                   MESSAGE FLAG.
* DOUBLE SPACE SUB-STRUCTURE.
TXT3A    DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
         DC  H'1'                      SPACING FACTOR
         DC  C'R '                     SPACING TYPE.
* INSERT DATA SUB-STRUCTURE.
         DC  X'2000'                   INSERT DATA FLAG.
         DC  H'1'                      REFERENCE NUMBER
         DC  H'0'                      UNUSED
         DC  H'1'                      PRINT COLUMN.
         DC  H'6'                      PRINT FIELD LENGTH.
         DC  X'0000'                   CONVERSION FLAG.  (CHAR)
* INSERT DATA SUB-STRUCTURE.
         DC  X'2000'                   INSERT DATA FLAG.
         DC  H'2'                      REFERENCE NUMBER
         DC  H'0'                      UNUSED
         DC  H'7'                      PRINT COLUMN.
         DC  H'3'                      PRINT FIELD LENGTH.
         DC  X'0000'                   CONVERSION FLAG.  (CHAR)
* INSERT DATA SUB-STRUCTURE.
         DC  X'A000'                   INSERT DATA AND EOF FLAG.
         DC  H'3'                      REFERENCE NUMBER
         DC  H'0'                      UNUSED
         DC  H'10'                     PRINT COLUMN.
         DC  H'64'                     PRINT FIELD LENGTH.
         DC  X'8000'                   CONVERSION FLAGS.  (BH)
TXT3B    EQU *
         EJECT
*
* TIMESTAMP HEADER
*
TXT4     DC  Y(TXT4B-TXT4A)            ENTRY LENGTH.
         DC  X'0000'                   MESSAGE FLAG.
* DOUBLE SPACE SUB-STRUCTURE.
TXT4A    DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
         DC  H'1'                      SPACING FACTOR
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'8400'                   STATIC FLAGS.
         DC  Y(STE41B-STE41A)          STATIC TEXT LENGTH.
         DC  Y(STE41A-TXT4A)           STATIC TEXT OFFSET.
         DC  H'3'                      PRINT COLUMN OFFSET.
         DC  Y(STE41B-STE41A)          PRINT FIELD LENGTH.
         DC  X'0000'                   CONVERSION FLAG.  (CHAR)
* STATIC TEXT ENTRY.
STE41A   DC  C'TIMESTAMPS -'
STE41B   EQU *
TXT4B    EQU *
         EJECT
*
* TIMESTAMPS
*
TXT5     DC  Y(TXT5B-TXT5A)            ENTRY LENGTH.
         DC  X'0000'                   MESSAGE FLAG.
* SINGLE SPACE SUB-STRUCTURE.
TXT5A    DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
         DC  H'1'                      SPACING FACTOR
         DC  C'R '                     SPACING TYPE.
* INSERT DATA SUB-STRUCTURE.
         DC  X'2000'                   INSERT DATA FLAG.
         DC  H'1'                      REFERENCE NUMBER
         DC  H'0'                      UNUSED
         DC  H'5'                      PRINT COLUMN.
         DC  H'10'                     PRINT FIELD LENGTH.
         DC  X'0000'                   CONVERSION FLAG.  (CHAR)
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC FLAGS.
         DC  Y(STE51B-STE51A)          STATIC TEXT LENGTH.
         DC  Y(STE51A-TXT5A)           STATIC TEXT OFFSET.
         DC  H'16'                     PRINT COLUMN OFFSET.
         DC  Y(STE51B-STE51A)          PRINT FIELD LENGTH.
         DC  X'0000'                   CONVERSION FLAG.
* INSERT DATA SUB-STRUCTURE.
         DC  X'2000'                   INSERT DATA AND EOF FLAG.
         DC  H'2'                      REFERENCE NUMBER
         DC  H'0'                      UNUSED
         DC  H'19'                     PRINT COLUMN.
         DC  H'2'                      PRINT FIELD LENGTH.
         DC  X'1020'                   CONVERSION FLAGS.  (BD)
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC FLAGS.
         DC  Y(STE52B-STE52A)          STATIC TEXT LENGTH.
         DC  Y(STE52A-TXT5A)           STATIC TEXT OFFSET.
         DC  H'21'                     PRINT COLUMN OFFSET.
         DC  Y(STE52B-STE52A)          PRINT FIELD LENGTH.
         DC  X'0000'                   CONVERSION FLAG.
* INSERT DATA SUB-STRUCTURE.
         DC  X'2000'                   INSERT DATA AND EOF FLAG.
         DC  H'3'                      REFERENCE NUMBER
         DC  H'0'                      UNUSED
         DC  H'22'                     PRINT COLUMN.
         DC  H'2'                      PRINT FIELD LENGTH.
         DC  X'1020'                   CONVERSION FLAGS.  (BD)
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC FLAGS.
         DC  Y(STE53B-STE53A)          STATIC TEXT LENGTH.
         DC  Y(STE53A-TXT5A)           STATIC TEXT OFFSET.
         DC  H'24'                     PRINT COLUMN OFFSET.
         DC  Y(STE53B-STE53A)          PRINT FIELD LENGTH.
         DC  X'0000'                   CONVERSION FLAG.  (CHAR)
* INSERT DATA SUB-STRUCTURE.
         DC  X'2000'                   INSERT DATA AND EOF FLAG.
         DC  H'4'                      REFERENCE NUMBER
         DC  H'0'                      UNUSED
         DC  H'25'                     PRINT COLUMN.
         DC  H'2'                      PRINT FIELD LENGTH.
         DC  X'1020'                   CONVERSION FLAGS.  (BD)
* INSERT DATA SUB-STRUCTURE.
         DC  X'2000'                   INSERT DATA FLAG.
         DC  H'5'                      REFERENCE NUMBER
         DC  H'0'                      UNUSED
         DC  H'30'                     PRINT COLUMN.
         DC  H'2'                      PRINT FIELD LENGTH.
         DC  X'1020'                   CONVERSION FLAGS.  (BD)
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC FLAGS.
         DC  Y(STE54B-STE54A)          STATIC TEXT LENGTH.
         DC  Y(STE54A-TXT5A)           STATIC TEXT OFFSET.
         DC  H'32'                     PRINT COLUMN OFFSET.
         DC  Y(STE54B-STE54A)          PRINT FIELD LENGTH.
         DC  X'0000'                   CONVERSION FLAG.  (CHAR)
* INSERT DATA SUB-STRUCTURE.
         DC  X'2000'                   INSERT DATA AND EOF FLAG.
         DC  H'6'                      REFERENCE NUMBER
         DC  H'0'                      UNUSED
         DC  H'33'                     PRINT COLUMN.
         DC  H'2'                      PRINT FIELD LENGTH.
         DC  X'1020'                   CONVERSION FLAGS.  (BD)
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC FLAGS.
         DC  Y(STE55B-STE55A)          STATIC TEXT LENGTH.
         DC  Y(STE55A-TXT5A)           STATIC TEXT OFFSET.
         DC  H'35'                     PRINT COLUMN OFFSET.
         DC  Y(STE55B-STE55A)          PRINT FIELD LENGTH.
         DC  X'0000'                   CONVERSION FLAG.  (CHAR)
* INSERT DATA SUB-STRUCTURE.
         DC  X'A000'                   INSERT DATA AND EOF FLAG.
         DC  H'7'                      REFERENCE NUMBER
         DC  H'0'                      UNUSED
         DC  H'36'                     PRINT COLUMN.
         DC  H'2'                      PRINT FIELD LENGTH.
         DC  X'1020'                   CONVERSION FLAGS.  (BD)
* STATIC TEXT ENTRY.
STE51A   DC  C'-'
STE51B   EQU *
STE52A   DC  C'/'
STE52B   EQU *
STE53A   DC  C'/'
STE53B   EQU *
STE54A   DC  C':'
STE54B   EQU *
STE55A   DC  C':'
STE55B   EQU *
TXT5B    EQU *
         EJECT
*
* ASOC AIX NAMES
*
TXT6     DC  Y(TXT6B-TXT6A)            ENTRY LENGTH.
         DC  X'0000'                   MESSAGE FLAG.
* SINGLE SPACE SUB-STRUCTURE.
TXT6A    DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
         DC  H'1'                      SPACING FACTOR
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC FLAGS.
         DC  Y(STE61B-STE61A)          STATIC TEXT LENGTH.
         DC  Y(STE61A-TXT6A)           STATIC TEXT OFFSET.
         DC  H'3'                      PRINT COLUMN OFFSET.
         DC  Y(STE61B-STE61A)          PRINT FIELD LENGTH.
         DC  X'0000'                   CONVERSION FLAG.  (CHAR)
* INSERT DATA SUB-STRUCTURE.
         DC  X'A000'                   INSERT DATA AND EOF FLAG.
         DC  H'1'                      REFERENCE NUMBER
         DC  H'0'                      UNUSED
         DC  H'14'                     PRINT COLUMN.
         DC  H'44'                     PRINT FIELD LENGTH.
         DC  X'0000'                   CONVERSION FLAGS.  (CHAR)
* STATIC TEXT ENTRY.
STE61A   DC  C'ASOC AIX -'
STE61B   EQU *
TXT6B    EQU *
         EJECT
*
* MISCOMPARES
*
TXT7     DC  Y(TXT7B-TXT7A)            ENTRY LENGTH.
         DC  X'0000'                   MESSAGE FLAG.
* DOUBLE SPACE SUB-STRUCTURE.
TXT7A    DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
         DC  H'2'                      SPACING FACTOR
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC FLAGS.
         DC  Y(STE71B-STE71A)          STATIC TEXT LENGTH.
         DC  Y(STE71A-TXT7A)           STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN OFFSET.
         DC  Y(STE71B-STE71A)          PRINT FIELD LENGTH.
         DC  X'0000'                   CONVERSION FLAG.  (CHAR)
* INSERT DATA SUB-STRUCTURE.
         DC  X'A000'                   INSERT DATA FLAG.
         DC  H'1'                      REFERENCE NUMBER
         DC  H'0'                      UNUSED
         DC  H'17'                     PRINT COLUMN.
         DC  H'0'                      PRINT FIELD LENGTH.
         DC  X'0000'                   CONVERSION FLAGS.  (CHAR)
* STATIC TEXT ENTRY.
STE71A   DC  C'* MISCOMPARES - '
STE71B   EQU *
TXT7B    EQU *
         EJECT
*
* DUMP FIRST LINE
*
TXT8     DC  Y(TXT8B-TXT8A)            ENTRY LENGTH.
         DC  X'0000'                   MESSAGE FLAG.
* DOUBLE SPACE SUB-STRUCTURE.
TXT8A    DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
         DC  H'2'                      SPACING FACTOR
         DC  C'R '                     SPACING TYPE.
* INSERT DATA SUB-STRUCTURE.
         DC  X'2000'                   INSERT DATA FLAG.
         DC  H'1'                      REFERENCE NUMBER
         DC  H'0'                      UNUSED
         DC  H'1'                      PRINT COLUMN.
         DC  H'6'                      PRINT FIELD LENGTH.
         DC  X'8000'                   CONVERSION FLAGS.  (BH)
* INSERT DATA SUB-STRUCTURE.
         DC  X'2000'                   INSERT DATA FLAG.
         DC  H'2'                      REFERENCE NUMBER
         DC  H'0'                      UNUSED
         DC  H'8'                      PRINT COLUMN.
         DC  H'8'                      PRINT FIELD LENGTH.
         DC  X'8000'                   CONVERSION FLAGS.  (BH)
* INSERT DATA SUB-STRUCTURE.
         DC  X'2000'                   INSERT DATA FLAG.
         DC  H'3'                      REFERENCE NUMBER
         DC  H'0'                      UNUSED
         DC  H'17'                     PRINT COLUMN.
         DC  H'8'                      PRINT FIELD LENGTH.
         DC  X'8000'                   CONVERSION FLAGS.  (BH)
* INSERT DATA SUB-STRUCTURE.
         DC  X'2000'                   INSERT DATA FLAG.
         DC  H'4'                      REFERENCE NUMBER
         DC  H'0'                      UNUSED
         DC  H'26'                     PRINT COLUMN.
         DC  H'8'                      PRINT FIELD LENGTH.
         DC  X'8000'                   CONVERSION FLAGS.  (BH)
* INSERT DATA SUB-STRUCTURE.
         DC  X'2000'                   INSERT DATA FLAG.
         DC  H'5'                      REFERENCE NUMBER
         DC  H'0'                      UNUSED
         DC  H'35'                     PRINT COLUMN.
         DC  H'8'                      PRINT FIELD LENGTH.
         DC  X'8000'                   CONVERSION FLAGS.  (BH)
* INSERT DATA SUB-STRUCTURE.
         DC  X'2000'                   INSERT DATA FLAG.
         DC  H'6'                      REFERENCE NUMBER
         DC  H'0'                      UNUSED
         DC  H'45'                     PRINT COLUMN.
         DC  H'8'                      PRINT FIELD LENGTH.
         DC  X'8000'                   CONVERSION FLAGS.  (BH)
* INSERT DATA SUB-STRUCTURE.
         DC  X'2000'                   INSERT DATA FLAG.
         DC  H'7'                      REFERENCE NUMBER
         DC  H'0'                      UNUSED
         DC  H'54'                     PRINT COLUMN.
         DC  H'8'                      PRINT FIELD LENGTH.
         DC  X'8000'                   CONVERSION FLAGS.  (BH)
* INSERT DATA SUB-STRUCTURE.
         DC  X'2000'                   INSERT DATA FLAG.
         DC  H'8'                      REFERENCE NUMBER
         DC  H'0'                      UNUSED
         DC  H'63'                     PRINT COLUMN.
         DC  H'8'                      PRINT FIELD LENGTH.
         DC  X'8000'                   CONVERSION FLAGS.  (BH)
* INSERT DATA SUB-STRUCTURE.
         DC  X'2000'                   INSERT DATA FLAG.
         DC  H'9'                      REFERENCE NUMBER
         DC  H'0'                      UNUSED
         DC  H'72'                     PRINT COLUMN.
         DC  H'8'                      PRINT FIELD LENGTH.
         DC  X'8000'                   CONVERSION FLAGS.  (BH)
* INSERT DATA SUB-STRUCTURE.
         DC  X'A000'                   INSERT DATA FLAG.
         DC  H'10'                     REFERENCE NUMBER
         DC  H'0'                      UNUSED
         DC  H'82'                     PRINT COLUMN.
         DC  H'32'                     PRINT FIELD LENGTH.
         DC  X'0000'                   CONVERSION FLAGS.  (CHAR)
TXT8B    EQU *
         EJECT
*
* DUMP FOLLOWING LINES
*
TXT9     DC  Y(TXT9B-TXT9A)            ENTRY LENGTH.
         DC  X'0000'                   MESSAGE FLAG.
* SINGLE SPACE SUB-STRUCTURE.
TXT9A    DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
         DC  H'1'                      SPACING FACTOR
         DC  C'R '                     SPACING TYPE.
* INSERT DATA SUB-STRUCTURE.
         DC  X'2000'                   INSERT DATA FLAG.
         DC  H'1'                      REFERENCE NUMBER
         DC  H'0'                      UNUSED
         DC  H'1'                      PRINT COLUMN.
         DC  H'6'                      PRINT FIELD LENGTH.
         DC  X'0000'                   CONVERSION FLAGS.  (CHAR)
* INSERT DATA SUB-STRUCTURE.
         DC  X'2000'                   INSERT DATA FLAG.
         DC  H'2'                      REFERENCE NUMBER
         DC  H'0'                      UNUSED
         DC  H'8'                      PRINT COLUMN.
         DC  H'8'                      PRINT FIELD LENGTH.
         DC  X'8000'                   CONVERSION FLAGS.  (BH)
* INSERT DATA SUB-STRUCTURE.
         DC  X'2000'                   INSERT DATA FLAG.
         DC  H'3'                      REFERENCE NUMBER
         DC  H'0'                      UNUSED
         DC  H'17'                     PRINT COLUMN.
         DC  H'8'                      PRINT FIELD LENGTH.
         DC  X'8000'                   CONVERSION FLAGS.  (BH)
* INSERT DATA SUB-STRUCTURE.
         DC  X'2000'                   INSERT DATA FLAG.
         DC  H'4'                      REFERENCE NUMBER
         DC  H'0'                      UNUSED
         DC  H'26'                     PRINT COLUMN.
         DC  H'8'                      PRINT FIELD LENGTH.
         DC  X'8000'                   CONVERSION FLAGS.  (BH)
* INSERT DATA SUB-STRUCTURE.
         DC  X'2000'                   INSERT DATA FLAG.
         DC  H'5'                      REFERENCE NUMBER
         DC  H'0'                      UNUSED
         DC  H'35'                     PRINT COLUMN.
         DC  H'8'                      PRINT FIELD LENGTH.
         DC  X'8000'                   CONVERSION FLAGS.  (BH)
* INSERT DATA SUB-STRUCTURE.
         DC  X'2000'                   INSERT DATA FLAG.
         DC  H'6'                      REFERENCE NUMBER
         DC  H'0'                      UNUSED
         DC  H'45'                     PRINT COLUMN.
         DC  H'8'                      PRINT FIELD LENGTH.
         DC  X'8000'                   CONVERSION FLAGS.  (BH)
* INSERT DATA SUB-STRUCTURE.
         DC  X'2000'                   INSERT DATA FLAG.
         DC  H'7'                      REFERENCE NUMBER
         DC  H'0'                      UNUSED
         DC  H'54'                     PRINT COLUMN.
         DC  H'8'                      PRINT FIELD LENGTH.
         DC  X'8000'                   CONVERSION FLAGS.  (BH)
* INSERT DATA SUB-STRUCTURE.
         DC  X'2000'                   INSERT DATA FLAG.
         DC  H'8'                      REFERENCE NUMBER
         DC  H'0'                      UNUSED
         DC  H'63'                     PRINT COLUMN.
         DC  H'8'                      PRINT FIELD LENGTH.
         DC  X'8000'                   CONVERSION FLAGS.  (BH)
* INSERT DATA SUB-STRUCTURE.
         DC  X'2000'                   INSERT DATA FLAG.
         DC  H'9'                      REFERENCE NUMBER
         DC  H'0'                      UNUSED
         DC  H'72'                     PRINT COLUMN.
         DC  H'8'                      PRINT FIELD LENGTH.
         DC  X'8000'                   CONVERSION FLAGS.  (BH)
* INSERT DATA SUB-STRUCTURE.
         DC  X'A000'                   INSERT DATA FLAG.
         DC  H'10'                     REFERENCE NUMBER
         DC  H'0'                      UNUSED
         DC  H'82'                     PRINT COLUMN.
         DC  H'32'                     PRINT FIELD LENGTH.
         DC  X'0000'                   CONVERSION FLAGS.  (CHAR)
TXT9B    EQU *
         EJECT
*
* DUMP CATALOG RECORD
*
TXT10    DC  Y(TXT10B-TXT10A)          ENTRY LENGTH.
         DC  X'0000'                   MESSAGE FLAG.
* SINGLE SPACE SUB-STRUCTURE.
TXT10A   DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
         DC  H'1'                      SPACING FACTOR
         DC  C'R '                     SPACING TYPE.
* INSERT DATA SUB-STRUCTURE.
         DC  X'2000'                   INSERT DATA FLAG.
         DC  H'1'                      REFERENCE NUMBER
         DC  H'0'                      UNUSED
         DC  H'3'                      PRINT COLUMN.
         DC  H'4'                      PRINT FIELD LENGTH.
         DC  X'8000'                   CONVERSION FLAGS.  (BH)
* INSERT DATA SUB-STRUCTURE.
         DC  X'2000'                   INSERT DATA FLAG.
         DC  H'2'                      REFERENCE NUMBER
         DC  H'0'                      UNUSED
         DC  H'8'                      PRINT COLUMN.
         DC  H'8'                      PRINT FIELD LENGTH.
         DC  X'8000'                   CONVERSION FLAGS.  (BH)
* INSERT DATA SUB-STRUCTURE.
         DC  X'2000'                   INSERT DATA FLAG.
         DC  H'3'                      REFERENCE NUMBER
         DC  H'0'                      UNUSED
         DC  H'17'                     PRINT COLUMN.
         DC  H'8'                      PRINT FIELD LENGTH.
         DC  X'8000'                   CONVERSION FLAGS.  (BH)
* INSERT DATA SUB-STRUCTURE.
         DC  X'2000'                   INSERT DATA FLAG.
         DC  H'4'                      REFERENCE NUMBER
         DC  H'0'                      UNUSED
         DC  H'26'                     PRINT COLUMN.
         DC  H'8'                      PRINT FIELD LENGTH.
         DC  X'8000'                   CONVERSION FLAGS.  (BH)
* INSERT DATA SUB-STRUCTURE.
         DC  X'2000'                   INSERT DATA FLAG.
         DC  H'5'                      REFERENCE NUMBER
         DC  H'0'                      UNUSED
         DC  H'35'                     PRINT COLUMN.
         DC  H'8'                      PRINT FIELD LENGTH.
         DC  X'8000'                   CONVERSION FLAGS.  (BH)
* INSERT DATA SUB-STRUCTURE.
         DC  X'2000'                   INSERT DATA FLAG.
         DC  H'6'                      REFERENCE NUMBER
         DC  H'0'                      UNUSED
         DC  H'45'                     PRINT COLUMN.
         DC  H'8'                      PRINT FIELD LENGTH.
         DC  X'8000'                   CONVERSION FLAGS.  (BH)
* INSERT DATA SUB-STRUCTURE.
         DC  X'2000'                   INSERT DATA FLAG.
         DC  H'7'                      REFERENCE NUMBER
         DC  H'0'                      UNUSED
         DC  H'54'                     PRINT COLUMN.
         DC  H'8'                      PRINT FIELD LENGTH.
         DC  X'8000'                   CONVERSION FLAGS.  (BH)
* INSERT DATA SUB-STRUCTURE.
         DC  X'2000'                   INSERT DATA FLAG.
         DC  H'8'                      REFERENCE NUMBER
         DC  H'0'                      UNUSED
         DC  H'63'                     PRINT COLUMN.
         DC  H'8'                      PRINT FIELD LENGTH.
         DC  X'8000'                   CONVERSION FLAGS.  (BH)
* INSERT DATA SUB-STRUCTURE.
         DC  X'2000'                   INSERT DATA FLAG.
         DC  H'9'                      REFERENCE NUMBER
         DC  H'0'                      UNUSED
         DC  H'72'                     PRINT COLUMN.
         DC  H'8'                      PRINT FIELD LENGTH.
         DC  X'8000'                   CONVERSION FLAGS.  (BH)
* INSERT DATA SUB-STRUCTURE.
         DC  X'A000'                   INSERT DATA FLAG.
         DC  H'10'                     REFERENCE NUMBER
         DC  H'0'                      UNUSED
         DC  H'82'                     PRINT COLUMN.
         DC  H'32'                     PRINT FIELD LENGTH.
         DC  X'0000'                   CONVERSION FLAGS.  (CHAR)
TXT10B   EQU *
         EJECT
*
* UNDERSCORES
*
TXT11    DC  Y(TXT11B-TXT11A)          ENTRY LENGTH.
         DC  X'0000'                   MESSAGE FLAG.
* SINGLE SPACE SUB-STRUCTURE.
TXT11A   DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
         DC  H'1'                      SPACING FACTOR
         DC  C'R '                     SPACING TYPE.
* INSERT DATA SUB-STRUCTURE.
         DC  X'2000'                   INSERT DATA FLAG.
         DC  H'1'                      REFERENCE NUMBER
         DC  H'0'                      UNUSED
         DC  H'1'                      PRINT COLUMN.
         DC  H'1'                      PRINT FIELD LENGTH.
         DC  X'0000'                   CONVERSION FLAGS.  (CHAR)
* INSERT DATA SUB-STRUCTURE.
         DC  X'2000'                   INSERT DATA FLAG.
         DC  H'2'                      REFERENCE NUMBER
         DC  H'0'                      UNUSED
         DC  H'8'                      PRINT COLUMN.
         DC  H'8'                      PRINT FIELD LENGTH.
         DC  X'0000'                   CONVERSION FLAGS.  (CHAR)
* INSERT DATA SUB-STRUCTURE.
         DC  X'2000'                   INSERT DATA FLAG.
         DC  H'3'                      REFERENCE NUMBER
         DC  H'0'                      UNUSED
         DC  H'17'                     PRINT COLUMN.
         DC  H'8'                      PRINT FIELD LENGTH.
         DC  X'0000'                   CONVERSION FLAGS.  (CHAR)
* INSERT DATA SUB-STRUCTURE.
         DC  X'2000'                   INSERT DATA FLAG.
         DC  H'4'                      REFERENCE NUMBER
         DC  H'0'                      UNUSED
         DC  H'26'                     PRINT COLUMN.
         DC  H'8'                      PRINT FIELD LENGTH.
         DC  X'0000'                   CONVERSION FLAGS.  (CHAR)
* INSERT DATA SUB-STRUCTURE.
         DC  X'2000'                   INSERT DATA FLAG.
         DC  H'5'                      REFERENCE NUMBER
         DC  H'0'                      UNUSED
         DC  H'35'                     PRINT COLUMN.
         DC  H'8'                      PRINT FIELD LENGTH.
         DC  X'0000'                   CONVERSION FLAGS.  (CHAR)
* INSERT DATA SUB-STRUCTURE.
         DC  X'2000'                   INSERT DATA FLAG.
         DC  H'6'                      REFERENCE NUMBER
         DC  H'0'                      UNUSED
         DC  H'45'                     PRINT COLUMN.
         DC  H'8'                      PRINT FIELD LENGTH.
         DC  X'0000'                   CONVERSION FLAGS.  (CHAR)
* INSERT DATA SUB-STRUCTURE.
         DC  X'2000'                   INSERT DATA FLAG.
         DC  H'7'                      REFERENCE NUMBER
         DC  H'0'                      UNUSED
         DC  H'54'                     PRINT COLUMN.
         DC  H'8'                      PRINT FIELD LENGTH.
         DC  X'0000'                   CONVERSION FLAGS.  (CHAR)
* INSERT DATA SUB-STRUCTURE.
         DC  X'2000'                   INSERT DATA FLAG.
         DC  H'8'                      REFERENCE NUMBER
         DC  H'0'                      UNUSED
         DC  H'63'                     PRINT COLUMN.
         DC  H'8'                      PRINT FIELD LENGTH.
         DC  X'0000'                   CONVERSION FLAGS.  (CHAR)
* INSERT DATA SUB-STRUCTURE.
         DC  X'A000'                   INSERT DATA FLAG.
         DC  H'9'                      REFERENCE NUMBER
         DC  H'0'                      UNUSED
         DC  H'72'                     PRINT COLUMN.
         DC  H'8'                      PRINT FIELD LENGTH.
         DC  X'0000'                   CONVERSION FLAGS.  (CHAR)
TXT11B   EQU *
         EJECT
*
* NUMBER OF ENTRIES HEADER
*
TXT12    DC  Y(TXT12B-TXT12A)          ENTRY LENGTH.
         DC  X'0000'                   MESSAGE FLAG.
* DOUBLE SPACE SUB-STRUCTURE.
TXT12A   DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
         DC  H'2'                      SPACING FACTOR
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'8400'                   STATIC FLAGS.
         DC  Y(STE121B-STE121A)        STATIC TEXT LENGTH.
         DC  Y(STE121A-TXT12A)         STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN OFFSET.
         DC  Y(STE121B-STE121A)        PRINT FIELD LENGTH.
         DC  X'0000'                   CONVERSION FLAG.  (CHAR)
* STATIC TEXT ENTRY.
STE121A  DC  C'NUMBER OF ENTRIES PROCESSED'
STE121B  EQU *
TXT12B   EQU *
         EJECT
*
* NUMBER OF ENTRIES
*
TXT13    DC  Y(TXT13B-TXT13A)          ENTRY LENGTH.
         DC  X'0000'                   MESSAGE FLAG.
* DOUBLE SPACE SUB-STRUCTURE.
TXT13A   DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
         DC  H'1'                      SPACING FACTOR
         DC  C'R '                     SPACING TYPE.
* INSERT DATA SUB-STRUCTURE.
         DC  X'2000'                   INSERT DATA FLAG.
         DC  H'1'                      REFERENCE NUMBER
         DC  H'0'                      UNUSED
         DC  H'2'                      PRINT COLUMN.
         DC  H'4'                      PRINT FIELD LENGTH.
         DC  X'0000'                   CONVERSION FLAG.  (CHAR)
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC FLAGS.
         DC  Y(STE131B-STE131A)        STATIC TEXT LENGTH.
         DC  Y(STE131A-TXT13A)         STATIC TEXT OFFSET.
         DC  H'6'                      PRINT COLUMN OFFSET.
         DC  Y(STE131B-STE131A)        PRINT FIELD LENGTH.
         DC  X'0000'                   CONVERSION FLAG.  (CHAR)
* INSERT DATA SUB-STRUCTURE.
         DC  X'A000'                   INSERT DATA FLAG.
         DC  H'2'                      REFERENCE NUMBER
         DC  H'0'                      UNUSED
         DC  H'9'                      PRINT COLUMN.
         DC  H'4'                      PRINT FIELD LENGTH.
         DC  X'10A0'                   CONVERSION FLAGS.  (CHAR)
* STATIC TEXT ENTRY.
STE131A  DC  C' - '
STE131B  EQU *
TXT13B   EQU *
         EJECT
         END
