     TITLE  '***** IDCTSLR1 - LISTCRA STATIC TEXT *****'
* /* START OF SPECIFICATIONS ****
*
*01*  MODULE-NAME = IDCTSLR1
*01*  MODULE-TYPE = MODULE
*02*    PROCESSOR = ASSEMBLER
*
**** END OF SPECIFICATIONS ****/
**********************************************************************
*                                                                    *
* MODULE NAME - IDCTSLR1 - STATIC TEXT MODULE FOR LISTCRA            *
*                                                                    *
* DESCRIPTIVE NAME - SECOND STATIC TEXT MODULE FOR LISTCRA           *
*                                                                    *
* COPYRIGHT - NONE                                                   *
*                                                                    *
* STATUS - RELEASE 2  LEVEL 0                                        *
*                                                                    *
* FUNCTION - CONTAINS NO EXECUTABLE CODE, ONLY STATIC TEXT ENTRIES   *
*        FOR THE FUNCTION EXPORT                                     *
*        THIS MODULE IS LOADED BY IDCTP05 WHEN A STATIC TEXT         *
*        REQUEST IS MADE.                                            *
*                                                                    *
* NOTES - NONE                                                       *
*                                                                    *
*    DEPENDENCIES - NONE                                             *
*    RESTRICTIONS - NONE                                             *
*    REGISTER CONVENTIONS - NA                                       *
*    PATCH AREA - NA                                                 *
*                                                                    *
* MODULE TYPE - TABLES                                               *
*                                                                    *
*    PROCESSOR - ASSEMBLER                                           *
*    MODULE SIZE - 1200 BYTES                                        *
*                                                                    *
*  ENTRY POINT - NA                                                  *
*                                                                    *
*  EXIT NORMAL - NA                                                  *
*                                                                    *
*  EXIT ERROR - NA                                                   *
*                                                                    *
*  EXTERNAL REFERENCES - NA                                          *
*                                                                    *
*  TABLES - NA                                                       *
*                                                                    *
*  MACROS - NA                                                       *
*                                                                    *
*                                                                    *
**********************************************************************
*
**********************************************************************
*                                                                    *
* THIS MODULE IS THE SECOND MODULE OF STATIC TEXT REQUIRED BY THE    *
*  LISTCRA FUNCTIONAL SUPPORT ROUTINES.                              *
*                                                                    *
**********************************************************************
*
IDCTSLR1 CSECT
*
* THIS SECTIONS CONTAINS THE INDICES TO REACH AN ENTRY.
*
INDEX    DC  H'16'                     COUNT OF ENTRIES
INDEX1   DC  Y(TXT1-INDEX)             VSAM ERROR READING CRA-CI
INDEX2   DC  Y(TXT2-INDEX)             VSAM ERROR READING CATALOG - CI
INDEX3   DC  Y(TXT3-INDEX)             CRA OWNED BY CATALOG
INDEX4   DC  Y(TXT4-INDEX)             COMPARE OPTION IGNORED
INDEX5   DC  Y(TXT5-INDEX)             NOT ALPHABETIC LISTING
INDEX6   DC  Y(TXT6-INDEX)             VERIFY FAILURE FOR CRA
INDEX7   DC  Y(TXT7-INDEX)             VERIFY FAILURE FOR CATALOG
INDEX8   DC  Y(TXT8-INDEX)             NUMBER OF MISCOMPARES IN CRA
INDEX9   DC  Y(TXT9-INDEX)             FIELD MGMT ERROR IGNORED
INDEX10  DC  Y(TXT10-INDEX)            FIELD MGMT ERROR
INDEX11  DC  Y(TXT11-INDEX)            I/O ERROR READING F4DSCB
INDEX12  DC  Y(TXT12-INDEX)            IGNORED ERROR FOR ALTERNATE OUT
INDEX13  DC  Y(TXT13-INDEX)            ERROR READING CATLOG CTL RCD
INDEX14  DC  Y(TXT14-INDEX)            ERROR READING CATLOG CTL RCD
INDEX15  DC  Y(TXT15-INDEX)            ERROR TRANSLATING CAT - CRA CI
INDEX16  DC  Y(TXT16-INDEX)            NUMBER OF ENTRIES IN CRA
         EJECT
**********************************************************************
*                                                                    *
* THIS SECTION CONTAINS THE ENTRIES.                                 *
*                                                                    *
**********************************************************************
*
* IGNORED VSAM ERROR READING CRA
*
TXT1     DC  Y(TXT1B-TXT1A)            ENTRY LENGTH.
         DC  X'8000'                   MESSAGE FLAG.
* DOUBLE SPACE SUB-STRUCTURE.
TXT1A   DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
         DC  H'1'                      SPACING FACTOR
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC TEXT FLAG.
         DC  Y(STE11B-STE11A)          STATIC TEXT LENGTH.
         DC  Y(STE11A-TXT1A)           STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE11B-STE11A)          PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS. (CHAR)
* INSERT TEXT SUB-STRUCTURE.
         DC  X'A000'                   INSERT TEXT AND EOF FLAG.
         DC  H'1'                      REFERENCE NUMBER
         DC  H'0'                      UNUSED
         DC  H'49'                     PRINT COLUMN.
         DC  H'0'                      DEFAULT
         DC  X'4000'                   CONVERSION FLAGS. (BH)
* STATIC TEXT ENTRY.
STE11A   DC  C'IDC1870I ** IGNORED VSAM ERROR READING CRA - CI '
STE11B   EQU *
TXT1B    EQU *
         EJECT
*
* IGNORED VSAM ERROR READING CATALOG
*
TXT2     DC  Y(TXT2B-TXT2A)            ENTRY LENGTH.
         DC  X'8000'                   MESSAGE FLAG.
* DOUBLE SPACE SUB-STRUCTURE.
TXT2A   DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
         DC  H'1'                      SPACING FACTOR
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC TEXT FLAG.
         DC  Y(STE21B-STE21A)          STATIC TEXT LENGTH.
         DC  Y(STE21A-TXT2A)           STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE21B-STE21A)          PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS. (CHAR)
* INSERT TEXT SUB-STRUCTURE.
         DC  X'A000'                   INSERT TEXT AND EOF FLAG.
         DC  H'1'                      REFERENCE NUMBER
         DC  H'0'                      UNUSED
         DC  H'53'                     PRINT COLUMN.
         DC  H'0'                      DEFAULT
         DC  X'4000'                   CONVERSION FLAGS. (BH)
* STATIC TEXT ENTRY.
STE21A   DC  C'IDC1871I ** IGNORED VSAM ERROR READING CATALOG - CI '
STE21B   EQU *
TXT2B    EQU *
         EJECT
*
* CRA OWNED BY CATALOG ( NAME )
*
TXT3     DC  Y(TXT3B-TXT3A)            ENTRY LENGTH.
         DC  X'8000'                   MESSAGE FLAG.
* DOUBLE SPACE SUB-STRUCTURE.
TXT3A    DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
         DC  H'2'                      SPACING FACTOR
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC TEXT FLAG.
         DC  Y(STE31B-STE31A)          STATIC TEXT LENGTH.
         DC  Y(STE31A-TXT3A)           STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE31B-STE31A)          PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS. (CHAR)
* INSERT TEXT SUB-STRUCTURE.
         DC  X'A000'                   INSERT TEXT AND EOF FLAG.
         DC  H'1'                      REFERENCE NUMBER
         DC  H'0'                      UNUSED
         DC  H'26'                     PRINT COLUMN.
         DC  H'0'                      DEFAULT
         DC  H'0'                      CONVERSION FLAGS. (CHAR)
* STATIC TEXT ENTRY.
STE31A   DC  C'IDC2872I CRA IS OWNED BY '
STE31B   EQU *
TXT3B    EQU *
         EJECT
*
* COMPARE OPTION IGNORED
*
TXT4     DC  Y(TXT4B-TXT4A)            ENTRY LENGTH.
         DC  X'8000'                   MESSAGE FLAG.
* DOUBLE SPACE SUB-STRUCTURE.
TXT4A    DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
         DC  H'1'                      SPACING FACTOR
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'8400'                   STATIC TEXT AND EOF FLAG.
         DC  Y(STE41B-STE41A)          STATIC TEXT LENGTH.
         DC  Y(STE41A-TXT4A)           STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE41B-STE41A)          PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS. (CHAR)
* STATIC TEXT ENTRY.
STE41A   DC  C'IDC2873I ** COMPARE OPTION IGNORED'
STE41B   EQU *
TXT4B    EQU *
         EJECT
*
* NON ALPHABETIC LIST-WORKSPACE LACKING
*
TXT5     DC  Y(TXT5B-TXT5A)            ENTRY LENGTH.
         DC  X'8000'                   MESSAGE FLAG.
* DOUBLE SPACE SUB-STRUCTURE.
TXT5A   DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
         DC  H'2'                      SPACING FACTOR
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'8400'                   STATIC TEXT AND EOF FLAG.
         DC  Y(STE51B-STE51A)          STATIC TEXT LENGTH.
         DC  Y(STE51A-TXT5A)           STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE51B-STE51A)          PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS. (CHAR)
* STATIC TEXT ENTRY.
STE51A   DC  C'IDC0874I FOLLOWING NOT ALPHABETIC - INSUFFICIENT WORK'
         DC  C' SPACE FOR SORT'
STE51B   EQU *
TXT5B    EQU *
         EJECT
*
* IGNORED VERIFY FAILURE FOR CRA
*
TXT6     DC  Y(TXT6B-TXT6A)            ENTRY LENGTH.
         DC  X'8000'                   MESSAGE FLAG.
* DOUBLE SPACE SUB-STRUCTURE.
TXT6A   DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
         DC  H'2'                      SPACING FACTOR
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'8400'                   STATIC TEXT AND EOF FLAG.
         DC  Y(STE61B-STE61A)          STATIC TEXT LENGTH.
         DC  Y(STE61A-TXT6A)           STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE61B-STE61A)          PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS. (CHAR)
* STATIC TEXT ENTRY.
STE61A   DC  C'IDC2876I IGNORED VERIFY FAILURE FOR CRA'
STE61B   EQU *
TXT6B    EQU *
         EJECT
*
* IGNORED VERIFY FAILURE FOR CATALOG
*
TXT7     DC  Y(TXT7B-TXT7A)            ENTRY LENGTH.
         DC  X'8000'                   MESSAGE FLAG.
* DOUBLE SPACE SUB-STRUCTURE.
TXT7A    DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
         DC  H'2'                      SPACING FACTOR
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'8400'                   STATIC TEXT AND EOF FLAG.
         DC  Y(STE71B-STE71A)          STATIC TEXT LENGTH.
         DC  Y(STE71A-TXT7A)           STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE71B-STE71A)          PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS. (CHAR)
* STATIC TEXT ENTRY.
STE71A   DC  C'IDC2884I IGNORED VERIFY FAILURE FOR CATALOG'
STE71B   EQU *
TXT7B    EQU *
         EJECT
*
* NUMBER OF CRA RECORDS THAT MISCOMPARED
*
TXT8     DC  Y(TXT8B-TXT8A)            ENTRY LENGTH.
         DC  X'8000'                   MESSAGE FLAG.
* DOUBLE SPACE SUB-STRUCTURE.
TXT8A    DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
         DC  H'2'                      SPACING FACTOR
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC TEXT FLAG.
         DC  Y(STE81B-STE81A)          STATIC TEXT LENGTH.
         DC  Y(STE81A-TXT8A)           STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE81B-STE81A)          PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS. (CHAR)
* INSERT TEXT SUB-STRUCTURE.
         DC  X'A000'                   INSERT TEXT AND EOF FLAG.
         DC  H'1'                      REFERENCE NUMBER
         DC  H'0'                      UNUSED
         DC  H'59'                     PRINT COLUMN.
         DC  H'0'                      DEFAULT
         DC  X'1060'                   CONVERSION FLAGS. (BD)
* STATIC TEXT ENTRY.
STE81A   DC  C'IDC0877I NUMBER OF RECORDS THAT MISCOMPARED '
         DC  C'IN THIS CRA - '
STE81B   EQU *
TXT8B    EQU *
         EJECT
*
* FIELD MANAGEMENT ERROR ( IGNORED )
*
TXT9     DC  Y(TXT9B-TXT9A)            ENTRY LENGTH.
         DC  X'8000'                   MESSAGE FLAG.
* DOUBLE SPACE SUB-STRUCTURE.
TXT9A    DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
         DC  H'2'                      SPACING FACTOR
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC TEXT FLAG.
         DC  Y(STE91B-STE91A)          STATIC TEXT LENGTH.
         DC  Y(STE91A-TXT9A)           STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE91B-STE91A)          PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS. (CHAR)
* INSERT TEXT SUB-STRUCTURE.
         DC  X'A000'                   INSERT TEXT AND EOF FLAG.
         DC  H'1'                      REFERENCE NUMBER
         DC  H'0'                      UNUSED
         DC  H'54'                     PRINT COLUMN.
         DC  H'0'                      DEFAULT
         DC  H'0'                      CONVERSION FLAGS. (CHAR)
* STATIC TEXT ENTRY.
STE91A   DC  C'IDC1878I IGNORED ERROR FROM IDCRC04, '
         DC  C'DUMP POINT ID - '
STE91B   EQU *
TXT9B    EQU *
         EJECT
*
*  CATALOG NOT LOCKED UP
*
TXT10    DC  Y(TXT10B-TXT10A)          ENTRY LENGTH.
         DC  X'8000'                   MESSAGE FLAG.
* DOUBLE SPACE SUB-STRUCTURE.
TXT10A   DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
         DC  H'2'                      SPACING FACTOR
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'8400'                   STATIC TEXT FLAG.
         DC  Y(STE101B-STE101A)        STATIC TEXT LENGTH.
         DC  Y(STE101A-TXT10A)         STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE101B-STE101A)        PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS. (CHAR)
* STATIC TEXT ENTRY.
STE101A  DC  C'IDC2879I CATALOG NOT LOCKED UP FOR THIS EXECUTION'
STE101B  EQU *
TXT10B   EQU *
         EJECT
*
*   I/O ERROR READING F4DSCB
*
TXT11    DC  Y(TXT11B-TXT11A)          ENTRY LENGTH.
         DC  X'8000'                   MESSAGE FLAG.
* DOUBLE SPACE SUB-STRUCTURE.
TXT11A   DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
         DC  H'2'                      SPACING FACTOR
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'8400'                   STATIC TEXT AND EOF FLAG.
         DC  Y(STE111B-STE111A)        STATIC TEXT LENGTH.
         DC  Y(STE111A-TXT11A)         STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE111B-STE111A)        PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS. (CHAR)
* STATIC TEXT ENTRY.
STE111A  DC  C'IDC1880I IGNORED I/O ERROR READING VOLUME LABEL'
STE111B  EQU *
TXT11B   EQU *
         EJECT
*
* IGNORED OPEN FAILURE FOR ALTERNATE OUTPUT
*
TXT12    DC  Y(TXT12B-TXT12A)          ENTRY LENGTH.
         DC  X'8000'                   MESSAGE FLAG.
* DOUBLE SPACE SUB-STRUCTURE.
TXT12A   DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
         DC  H'2'                      SPACING FACTOR
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'8400'                   STATIC TEXT AND EOF FLAG.
         DC  Y(STE121B-STE121A)        STATIC TEXT LENGTH.
         DC  Y(STE121A-TXT12A)         STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE121B-STE121A)        PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS. (CHAR)
* STATIC TEXT ENTRY.
STE121A  DC  C'IDC1881I IGNORED OPEN FAILURE FOR ALTERNATE OUTPUT '
         DC  C'DATA SET'
STE121B  EQU *
TXT12B   EQU *
         EJECT
*
* VSAM ERROR READING CRA CONTROL RECORD
*
TXT13    DC  Y(TXT13B-TXT13A)          ENTRY LENGTH.
         DC  X'8000'                   MESSAGE FLAG.
* DOUBLE SPACE SUB-STRUCTURE.
TXT13A   DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
         DC  H'2'                      SPACING FACTOR
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'8400'                   STATIC TEXT AND EOF FLAG.
         DC  Y(STE131B-STE131A)        STATIC TEXT LENGTH.
         DC  Y(STE131A-TXT13A)         STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE131B-STE131A)        PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS. (CHAR)
* STATIC TEXT ENTRY.
STE131A  DC  C'IDC2882I VSAM ERROR READING CRA CONTROL RECORD'
STE131B  EQU *
TXT13B   EQU *
         EJECT
*
* ERROR COUNT EXCEEDED
*
TXT14    DC  Y(TXT14B-TXT14A)          ENTRY LENGTH.
         DC  X'8000'                   MESSAGE FLAG.
* DOUBLE SPACE SUB-STRUCTURE.
TXT14A   DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
         DC  H'2'                      SPACING FACTOR
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'8400'                   STATIC TEXT AND EOF FLAG.
         DC  Y(STE141B-STE141A)        STATIC TEXT LENGTH.
         DC  Y(STE141A-TXT14A)         STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE141B-STE141A)        PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS. (CHAR)
* STATIC TEXT ENTRY.
STE141A  DC  C'IDC3883I ERROR COUNT EXCEEDED UPPER LIMIT,'
         DC  C' FUNCTION TERMINATED'
STE141B  EQU *
TXT14B   EQU *
         EJECT
*
* ERROR DURING CATALOG TO CRA TRANSLATE
*
TXT15    DC  Y(TXT15B-TXT15A)          ENTRY LENGTH.
         DC  X'8000'                   MESSAGE FLAG.
* DOUBLE SPACE SUB-STRUCTURE.
TXT15A   DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
         DC  H'2'                      SPACING FACTOR
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC TEXT AND EOF FLAG.
         DC  Y(STE151B-STE151A)        STATIC TEXT LENGTH.
         DC  Y(STE151A-TXT15A)         STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE151B-STE151A)        PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS. (CHAR)
* INSERT TEXT SUB-STRUCTURE.
         DC  X'A000'                   INSERT TEXT AND EOF FLAG.
         DC  H'1'                      REFERENCE NUMBER
         DC  H'0'                      UNUSED
         DC  H'53'                     PRINT COLUMN.
         DC  H'0'                      DEFAULT
         DC  X'4000'                   CONVERSION FLAGS. (CHAR)
* STATIC TEXT ENTRY.
STE151A  DC  C'IDC1875I ERROR TRANSLATING CRA CI FROM CATALOG CI - '
STE151B  EQU *
TXT15B   EQU *
         EJECT
*
* NUMBER OF CRA ENTRIES THAT MISCOMPARED
*
TXT16    DC  Y(TXT16B-TXT16A)          ENTRY LENGTH.
         DC  X'8000'                   MESSAGE FLAG.
* DOUBLE SPACE SUB-STRUCTURE.
TXT16A   DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
         DC  H'2'                      SPACING FACTOR
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC TEXT FLAG.
         DC  Y(STE161B-STE161A)        STATIC TEXT LENGTH.
         DC  Y(STE161A-TXT16A)         STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE161B-STE161A)        PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS. (CHAR)
* INSERT TEXT SUB-STRUCTURE.
         DC  X'A000'                   INSERT TEXT AND EOF FLAG.
         DC  H'1'                      REFERENCE NUMBER
         DC  H'0'                      UNUSED
         DC  H'59'                     PRINT COLUMN.
         DC  H'0'                      DEFAULT
         DC  X'1060'                   CONVERSION FLAGS. (BD)
* STATIC TEXT ENTRY.
STE161A  DC  C'IDC0665I NUMBER OF ENTRIES THAT MISCOMPARED '
         DC  C'IN THIS CRA - '
STE161B  EQU *
TXT16B   EQU *
         EJECT
         END
