         TITLE '***** IDCTSMP0 - IMPORT STATIC TEXT *****'
* /* START OF SPECIFICATIONS ****                            @Y30SSFR
*
*01*  MODULE-NAME = IDCTSMP0
*01*  MODULE-TYPE = MODULE
*02*    PROCESSOR = ASSEMBLER
*
**** END OF SPECIFICATIONS **                                @Y30SSFR*/
**********************************************************************
*                                                                    *
* MODULE NAME - IDCTSMP0 - STATIC TEXT MODULE FOR IMPORT             *
*                                                                    *
* DESCRIPTIVE NAME - STATIC TEXT MODULE FOR THE FUNCTION IMPORT      *
*                                                                    *
* COPYRIGHT - NONE                                                   *
*                                                                    *
* STATUS - RELEASE 2  LEVEL 0                                        *
* CHANGES FOR RELEASE 3                                        @Z40RSSA
*     ADD TXT25 ENTRY                                          @Z40RSSA
*                                                                    *
* FUNCTION - CONTAINS NO EXECUTABLE CODE, ONLY STATIC TEXT ENTRIES   *
*        FOR THE FUNCTION IMPORT                                     *
*        THIS MODULE IS LOADED BY IDCTP05 WHEN A STATIC TEXT         *
*        REQUEST IS MADE.                                            *
*                                                                    *
* NOTES - NONE                                                       *
*                                                                    *
*    DEPENDENCIES - NONE                                             *
*    RESTRICTIONS - NONE                                             *
*    REGISTER CONVENTIONS - NA                                       *
*    PATCH AREA - NA                                                 *
*                                                                    *
* MODULE TYPE - TABLES                                               *
*                                                                    *
*    PROCESSOR - ASSEMBLER                                           *
*    MODULE SIZE - 1550 BYTES                                @Y30SSFR*
*    ATTRIBUTES - READ-ONLY                                          *
*                                                                    *
*  ENTRY POINT - NA                                                  *
*                                                                    *
*  EXIT NORMAL - NA                                                  *
*                                                                    *
*  EXIT ERROR - NA                                                   *
*                                                                    *
*  EXTERNAL REFERENCES - NA                                          *
*                                                                    *
*  TABLES - NA                                                       *
*                                                                    *
*  MACROS - NA                                                       *
*                                                                    *
*  CHANGE ACTIVITY -                                         @OZ17068*
*    C010000 A015833-015913,275893-875893                    @OZ17068*
*                                                                    *
**********************************************************************
*
**********************************************************************
*                                                                    *
* THIS MODULE IS THE FIRST MODULE OF STATIC TEXT REQUIRED BY THE     *
* IMPORT FUNCTIONAL SUPPORT ROUTINES.                                *
*                                                                    *
**********************************************************************
*
IDCTSMP0 CSECT
*
* THIS SECTIONS CONTAINS THE INDICES TO REACH AN ENTRY.
*
INDEX    DC  H'26'                     COUNT OF ENTRIES        @Z40RSSA
INDEX1   DC  Y(TXT1-INDEX)             PORTABILITY DATA SET ERR
INDEX2   DC  Y(TXT2-INDEX)             DUPLICATE DELETE FAILED.
INDEX3   DC  H'-1'                     NULL
INDEX4   DC  H'-1'                     NULL
INDEX5   DC  Y(TXT5-INDEX)             MISSING VOL SPECIFICATION
INDEX6   DC  Y(TXT6-INDEX)             DEV TYPE REQUIRED.
INDEX7   DC  Y(TXT7-INDEX)             INVALID OBJECTS NAME
INDEX8   DC  Y(TXT8-INDEX)             DUP ENTRY NOT CLUSTER
INDEX9   DC  Y(TXT9-INDEX)             CLUSTER DELETE UNCCESSFUL
INDEX10  DC  Y(TXT10-INDEX)            CAT CONNECT FAILED.
INDEX11  DC  Y(TXT11-INDEX)            CAT CONNECT SUCCESSFUL
INDEX12  DC  Y(TXT12-INDEX)            DATA SET EXPORTED.
INDEX13  DC  Y(TXT13-INDEX)            DUPLICATE NOT TEMPORARY
INDEX14  DC  Y(TXT14-INDEX)            BAD OPEN OF PORTABILITY DATA SET
INDEX15  DC  Y(TXT15-INDEX)            OUTFILE JCL STATEMENT INCORRECT
INDEX16  DC  Y(TXT16-INDEX)            BAD PATH IMPORT         @Y30SSFR
INDEX17  DC  Y(TXT17-INDEX)            ATTRIBUTES OF EMPTY     @Y30SSFR
*                                      DATA SET AND EXPORTED   @Y30SSFR
*                                      DATA SET DON'T MATCH    @Y30SSFR
INDEX18  DC  Y(TXT18-INDEX)            BAD OBJECTS SUB-        @Y30SSFR
*                                      PARAMETER FOR PATH      @Y30SSFR
INDEX19  DC  Y(TXT19-INDEX)            ALTER RENAME FAILURE    @Y30SSFR
INDEX20  DC  Y(TXT20-INDEX)            OBJECT NOT SUPPORTED    #Y30SSFR
INDEX21  DC  Y(TXT21-INDEX)            IMPORTRA FAILED FOR     #Y30SSFR
*                                      OBJECT                  @Y30SSFR
INDEX22  DC  Y(TXT22-INDEX)            CATALOG DISCONNECTED    @Y30SSFR
INDEX23  DC  H'-1'                     NULL                    @Y30SSFR
INDEX24  DC  Y(TXT24-INDEX)            UIOINFO FAILED          @Y30SSFR
INDEX25  DC  Y(TXT25-INDEX)            'INTOEMPTY' KEYWORD     @Z40RSSA
*                                        NEEDED                @Z40RSSA
INDEX26  DC  Y(TXT26-INDEX)            IMPORTRA SUCCEEDED      @Y30SSFR
INDEX27  DC  H'-1'                     NULL                    @OZ17068
INDEX28  DC  Y(TXT28-INDEX)            IDC3628I DUMMY NAME IN  @OZ17068
*                                      CATALOG                 @OZ17068
         EJECT
**********************************************************************
*                                                                    *
* THIS SECTION CONTAINS THE ENTRIES.                                 *
*                                                                    *
**********************************************************************
*
* THE PORTABILITY DATA SET IS IN ERROR.
*
TXT1     DC  Y(TXT1B-TXT1A)            ENTRY LENGTH.
         DC  X'8000'                   MESSAGE FLAG.
* DOUBLE SPACE SUB-STRUCUTRE.
TXT1A    DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
         DC  H'2'                      SPACING FACTOR
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'8400'                   STATIC TEXT FLAG.
         DC  Y(STE11B-STE11A)          STATIC TEXT LENGTH.
         DC  Y(STE11A-TXT1A)           STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE11B-STE11A)          PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS. (CHAR)
* STATIC TEXT ENTRY.
STE11A   DC  C'IDC3606I  PORTABILITY DATA SET IN ERROR'
STE11B   EQU *
TXT1B    EQU *
         EJECT
*
* DATA SET TO BE IMPORTED ALREADY EXISTS- DELETE ATTEMPTED
*
TXT2     DC  Y(TXT2B-TXT2A)            ENTRY LENGTH.
         DC  X'8000'                   MESSAGE FLAG.
* SPACING CONTROL SUB-STRUCTURE.
TXT2A    DC  X'4000'                   SPACE CONTROL FLAG.
         DC  H'2'                      SPACING FACTOR.
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'8400'                   EOF & STATIC FLAGS.
         DC  Y(STE21B-STE21A)          ENTRY LENGTH.
         DC  Y(STE21A-TXT2A)           STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE21B-STE21A)          PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* STATIC TEXT ENTRIES.
STE21A   DC  C'IDC0611I DATA SET TO BE IMPORTED ALREADY EXISTS - DELETEx
                ATTEMPTED'
STE21B   EQU *
TXT2B    EQU *
         EJECT
*
* VOLUME SPECIFICATION NECESSARY FOR IMPORT OF CLUSTER.
*
TXT5     DC  Y(TXT5B-TXT5A)            ENTRY LENGTH.
         DC  X'8000'                   MESSAGE FLAG.
* DOUBLE SPACE SUB-STRUCTURE.
TXT5A    DC  X'4000'                   SPACING FLAG.
         DC  H'2'                      SPACING FACTOR.
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC FLAG.            @Y30SSFR
         DC  Y(STE51B-STE51A)          ENTRY LENGTH.
         DC  Y(STE51A-TXT5A)           TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  H'0'                      PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* BLOCK DATA SUBSTRUCTURE.                                     @Y30SSFR
         DC  X'9000'                   BLOCK DATA FLAG.        @Y30SSFR
         DC  H'44'                     INPUT LENGTH.           @Y30SSFR
         DC  H'0'                      INPUT OFFSET.           @Y30SSFR
         DC  H'42'                     PRINT COLUMN.           @Y30SSFR
         DC  H'44'                     PRINT LENGTH.           @Y30SSFR
         DC  H'0'                      CONVERSION FLAGS (CHAR).@Y30SSFR
* STATIC TEXT ENTRIES.
STE51A   DC  C'IDC3609I VOLUME SPECIFICATION NEEDED FOR '      @Y30SSFR
STE51B   EQU *
TXT5B    EQU *
         EJECT
*
* SPECIFICATION OF DEVICE TYPES, VOLUMES REQUIRED FOR CONNECT.
*
TXT6     DC  Y(TXT6B-TXT6A)            ENTRY LENGTH.
         DC  X'8000'                   MESSAGE FLAG.
* DOUBLE SPACE SUB-STRUCTURE.
TXT6A    DC  X'4000'                   SPACING FLAG.
         DC  H'2'                      SPACING FACTOR.
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'8400'                   STATIC FLAG.
         DC  Y(STE61B-STE61A)          ENTRY LENGTH.
         DC  Y(STE61A-TXT6A)           TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  H'0'                      PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* STATIC TEXT ENTRIES.
STE61A   DC  C'IDC3610I SPECIFICATION OF DEVICE TYPES, VOLUMES '
         DC  C'REQUIRED FOR CONNECT'
STE61B   EQU *
TXT6B    EQU *
         EJECT
*
* INVALID NAME IN OBJECTS PARAMETER: CCCCCCCCCCC.
*
TXT7     DC  Y(TXT7B-TXT7A)            ENTRY LENGTH.
         DC  X'8000'                   MESSAGE FLAG.
* DOUBLE SPACE SUB-STRUCTURE.
TXT7A    DC  X'4000'                   SPACING FLAG.
         DC  H'2'                      SPACING FACTOR.
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC FLAG.
         DC  Y(STE71B-STE71A)          ENTRY LENGTH.
         DC  Y(STE71A-TXT7A)           TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  H'0'                      PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* BLOCK DATA SUB-STRUCTURE.
         DC  X'9000'                   BLOCK DATA FLAG.
         DC  H'44'                     INPUT LENGTH.
         DC  H'0'                      INPUT OFFSET.
         DC  H'45'                     PRINT COLUMN.
         DC  H'44'                     PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* STATIC TEXT ENTRIES.
STE71A   DC  C'IDC3614I INVALID NAME IN OBJECTS PARAMETER:'
STE71B   EQU *
TXT7B    EQU *
         EJECT
*
* DUPLICATE ENTRY IS NOT A CLUSTER OR AIX.                     @Y30SSFR
*
TXT8     DC  Y(TXT8B-TXT8A)            ENTRY LENGTH.
         DC  X'A000'                   MESSAGE FLAG.
* DOUBLE SPACE SUB-STRUCTURE.
TXT8A    DC  X'4000'                   SPACING FLAG.
         DC  H'2'                      SPACING FACTOR.
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'8400'                   STATIC FLAG.
         DC  Y(STE81B-STE81A)          ENTRY LENGTH.
         DC  Y(STE81A-TXT8A)           TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  H'0'                      PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* STATIC TEXT ENTRIES.
STE81A   DC  C'IDC3612I DELETE UNSUCCESSFUL - NOT A CLUSTER'   @Y30SSFR
         DC  C' OR AIX'                                        @Y30SSFR
STE81B   EQU *
TXT8B    EQU *
         EJECT
*
* IMPORT OF DATA SET FAILED AFTER DEFINE- DELETE ATTEMPTED
*
TXT9     DC  Y(TXT9B-TXT9A)            ENTRY LENGTH.
         DC  X'8000'                   MESSAGE FLAG.
* DOUBLE SPACE SUB-STRUCUTRE.
TXT9A    DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
         DC  H'2'                      SPACING FACTOR
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'8400'                   STATIC TEXT FLAG.
         DC  Y(STE91B-STE91A)          STATIC TEXT LENGTH.
         DC  Y(STE91A-TXT9A)           STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE91B-STE91A)          PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS. (CHAR)
* STATIC TEXT ENTRY.
STE91A   DC  C'IDC3602I  IMPORT OF DATA SET FAILED AFTER DEFINE - '
         DC  C'DELETE ATTEMPTED'
STE91B   EQU *
TXT9B    EQU *
         EJECT
*
* CONNECT FOR USER CATALOG FAILED.
*
TXT10    DC  Y(TXT10B-TXT10A)          ENTRY LENGTH.
         DC  X'8000'                   MESSAGE FLAG.
* DOUBLE SPACE SUB-STRUCUTRE.
TXT10A   DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
         DC  H'2'                      SPACING FACTOR
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC TEXT FLAG.
         DC  Y(STE101B-STE101A)        STATIC TEXT LENGTH.
         DC  Y(STE101A-TXT10A)         STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE101B-STE101A)        PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS. (CHAR)
* BLOCK DATA SUB-STRUCTURE.
         DC  X'1000'                   BLOCK DATA FLAG.
         DC  H'44'                     INPUT DATA LENGTH.
         DC  H'0'                      INPUT DATA OFFSET.
         DC  H'23'                     PRINT COLUMN.
         DC  H'44'                     PRINT FIELD LENGTH.
         DC  X'0000'                   CONVERSION FLAG.  (CHAR)
* STATIC TEXT SUB-STRUCTURE.
         DC  X'8400'                   STATIC & EOF FLAGS.
         DC  Y(STE102B-STE102A)        STATIC TEXT LENGTH.
         DC  Y(STE102A-TXT10A)         STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN OFFSET.
         DC  Y(STE102B-STE102A)        PRINT FIELD LENGTH.
         DC  X'0010'                   CONVERSION FLAG.  (CHAR,BS)
* STATIC TEXT ENTRY.
STE101A  DC  C'IDC3608I  CONNECT FOR '
STE101B  EQU *
STE102A  DC  C'FAILED'
STE102B  EQU *
TXT10B   EQU *
         EJECT
*
* CONNECT FOR USER CATALOG SUCCESSFUL
*
TXT11    DC  Y(TXT11B-TXT11A)          ENTRY LENGTH.
         DC  X'8000'                   MESSAGE FLAG.
* DOUBLE SPACE SUB-STRUCUTRE.
TXT11A   DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
         DC  H'2'                      SPACING FACTOR
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC TEXT FLAG.
         DC  Y(STE111B-STE111A)        STATIC TEXT LENGTH.
         DC  Y(STE111A-TXT11A)         STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE111B-STE111A)        PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS. (CHAR)
* BLOCK DATA SUB-STRUCTURE.
         DC  X'1000'                   BLOCK DATA FLAG.
         DC  H'44'                     INPUT DATA LENGTH.
         DC  H'0'                      INPUT DATA OFFSET.
         DC  H'37'                     PRINT COLUMN.
         DC  H'44'                     PRINT FIELD LENGTH.
         DC  X'0000'                   CONVERSION FLAG.  (CHAR)
* STATIC TEXT SUB-STRUCTURE.
         DC  X'8400'                   STATIC & EOF FLAGS.
         DC  Y(STE112B-STE112A)        STATIC TEXT LENGTH.
         DC  Y(STE112A-TXT11A)         STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN OFFSET.
         DC  Y(STE112B-STE112A)        PRINT FIELD LENGTH.
         DC  X'0010'                   CONVERSION FLAG.  (CHAR,BS)
* STATIC TEXT ENTRY.
STE111A  DC  C'IDC0603I  CONNECT FOR USER CATALOG'
STE111B  EQU *
STE112A  DC  C'SUCCESSFUL'
STE112B  EQU *
TXT11B   EQU *
         EJECT
*
* DATA SET BEING IMPORTED WAS EXP0RTED ON DATE AT TIME.
*
TXT12    DC  Y(TXT12B-TXT12A)          ENTRY LENGTH.
         DC  X'8000'                   MESSAGE FLAG.
* DOUBLE SPACE SUB-STRUCUTRE.
TXT12A   DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
         DC  H'2'                      SPACING FACTOR
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC TEXT FLAG.
         DC  Y(STE121B-STE121A)        STATIC TEXT LENGTH.
         DC  Y(STE121A-TXT12A)         STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE121B-STE121A)        PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS. (CHAR)
* INSERT DATA SUB-STRUCTURE.
         DC  X'2000'                   BLOCK DATA FLAG.
         DC  H'1'                      REFERENCE NUMBER
         DC  H'0'                      UNUSED
         DC  H'52'                     PRINT COLUMN.
         DC  H'8'                      PRINT FIELD LENGTH.
         DC  X'0000'                   CONVERSION FLAG.  (CHAR)
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC & EOF FLAGS.
         DC  Y(STE122B-STE122A)        STATIC TEXT LENGTH.
         DC  Y(STE122A-TXT12A)         STATIC TEXT OFFSET.
         DC  H'61'                     PRINT COLUMN OFFSET.
         DC  Y(STE122B-STE122A)        PRINT FIELD LENGTH.
         DC  X'0000'                   CONVERSION FLAG.  (CHAR)
* BLOCK DATA SUB-STRUCTURE.
         DC  X'A000'                   BLOCK DATA FLAG.
         DC  H'2'                      REFERENCE NUMBER
         DC  H'0'                      UNUSED
         DC  H'64'                     PRINT COLUMN.
         DC  H'8'                      PRINT FIELD LENGTH.
         DC  X'0000'                   CONVERSION FLAGS.  (CHAR)
* STATIC TEXT ENTRY.
STE121A  DC  C'IDC0604I DATA SET BEING IMPORTED WAS EXPORTED ON'
STE121B  EQU *
STE122A  DC  C'AT'
STE122B  EQU *
TXT12B   EQU *
         EJECT
*
* DELETE UNSUCCESSFUL - NOT A TEMPORARY DATA SET
*
TXT13    DC  Y(TXT13B-TXT13A)          ENTRY LENGTH.
         DC  X'A000'                   MESSAGE FLAG.
* STATIC TEXT SUB-STRUCTURE.
TXT13A   DC  X'8400'                   STATIC TEXT FLAG.
         DC  Y(STE131B-STE131A)        STATIC TEXT LENGTH.
         DC  Y(STE131A-TXT13A)         STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE131B-STE131A)        PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS. (CHAR)
* STATIC TEXT ENTRY.
STE131A  DC  C'IDC3607I DELETE UNSUCCESSFUL - NOT A TEMPORARY' @Y30SSFR
         DC  C' DATA SET'
STE131B  EQU *
TXT13B   EQU *
         EJECT
*
* ERROR ENCOUNTERED OPENING PORTABILITY DATA SET
*
TXT14    DC  Y(TXT14B-TXT14A)          ENTRY LENGTH.
         DC  X'8000'                   MESSAGE FLAG.
* DOUBLE SPACE SUB-STRUCUTRE.
TXT14A   DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
         DC  H'2'                      SPACING FACTOR
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'8400'                   STATIC TEXT FLAG.
         DC  Y(STE141B-STE141A)        STATIC TEXT LENGTH.
         DC  Y(STE141A-TXT14A)         STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE141B-STE141A)        PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS. (CHAR)
* STATIC TEXT ENTRY.
STE141A  DC  C'IDC3613I ERROR ENCOUNTERED OPENING PORTABILITY DATA SET'
STE141B  EQU *
TXT14B   EQU *
         EJECT
*
* DSNAME ON OUTFILE JCL STATEMENT INCORRECT
*
TXT15    DC  Y(TXT15B-TXT15A)          ENTRY LENGTH.
         DC  X'8000'                   MESSAGE FLAG.
* DOUBLE SPACE SUB-STRUCUTRE.
TXT15A   DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
         DC  H'2'                      SPACING FACTOR
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'8400'                   STATIC TEXT FLAG.
         DC  Y(STE151B-STE151A)        STATIC TEXT LENGTH.
         DC  Y(STE151A-TXT15A)         STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE151B-STE151A)        PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS. (CHAR)
* STATIC TEXT ENTRY.
STE151A  DC  C'IDC3615I DSNAME ON OUTFILE JCL STATEMENT INCORRECT'
STE151B  EQU *
TXT15B   EQU *
         EJECT                                                 @Y30SSFR
*                                                              @Y30SSFR
* PATH IMPORT FAILED                                           @Y30SSFR
*                                                              @Y30SSFR
TXT16    DC  Y(TXT16B-TXT16A)          ENTRY LENGTH.           @Y30SSFR
         DC  X'8000'                   MESSAGE FLAG.           @Y30SSFR
* DOUBLE SPACE SUB-STRUCUTRE.                                  @Y30SSFR
TXT16A   DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
         DC  H'2'                      SPACING FACTOR          @Y30SSFR
         DC  C'R '                     SPACING TYPE.           @Y30SSFR
* STATIC TEXT SUB-STRUCTURE.                                   @Y30SSFR
         DC  X'0400'                   STATIC TEXT FLAG.       @Y30SSFR
         DC  Y(STE161B-STE161A)        STATIC TEXT LENGTH.     @Y30SSFR
         DC  Y(STE161A-TXT16A)         STATIC TEXT OFFSET.     @Y30SSFR
         DC  H'1'                      PRINT COLUMN.           @Y30SSFR
         DC  Y(STE161B-STE161A)        PRINT FIELD LENGTH.     @Y30SSFR
         DC  H'0'                      CONVERSION FLAGS. (CHAR)
* BLOCK DATA SUB-STRUCTURE.                                    @Y30SSFR
         DC  X'1000'                   BLOCK DATA FLAG.        @Y30SSFR
         DC  H'44'                     INPUT DATA LENGTH.      @Y30SSFR
         DC  H'0'                      INPUT DATA OFFSET.      @Y30SSFR
         DC  H'15'                     PRINT COLUMN.           @Y30SSFR
         DC  H'44'                     PRINT FIELD LENGTH.     @Y30SSFR
         DC  X'0000'                   CONVERSION FLAG.  (CHAR)
* STATIC TEXT SUB-STRUCTURE.                                   @Y30SSFR
         DC  X'8400'                   STATIC & EOF FLAGS.     @Y30SSFR
         DC  Y(STE162B-STE162A)        STATIC TEXT LENGTH.     @Y30SSFR
         DC  Y(STE162A-TXT16A)         STATIC TEXT OFFSET.     @Y30SSFR
         DC  H'1'                      PRINT COLUMN OFFSET.    @Y30SSFR
         DC  Y(STE162B-STE162A)        PRINT FIELD LENGTH.     @Y30SSFR
         DC  X'0010'                   CONVERSION FLAG.  (CHAR,BS)
* STATIC TEXT ENTRY.                                           @Y30SSFR
STE161A  DC  C'IDC2616I PATH'                                  @Y30SSFR
STE161B  EQU *                                                 @Y30SSFR
STE162A  DC  C'WAS NOT SUCCESSFULLY IMPORTED'                  @Y30SSFR
STE162B  EQU *                                                 @Y30SSFR
TXT16B   EQU *                                                 @Y30SSFR
         EJECT                                                 @Y30SSFR
*                                                              @Y30SSFR
* ATTRIBUTES OF PRE-DEFINED EMPTY DATA SET CONFLICT WITH THOSE @Y30SSFR
* OF THE EXPORTED DATA SET                                     @Y30SSFR
*                                                              @Y30SSFR
TXT17    DC  Y(TXT17B-TXT17A)          ENTRY LENGTH.           @Y30SSFR
         DC  X'8000'                   MESSAGE FLAG.           @Y30SSFR
* DOUBLE SPACE SUB-STRUCUTRE.                                  @Y30SSFR
TXT17A   DC  X'4000'                   SPACE SUB-STRUCTURE     @Y30SSFR
*                                      FLAG.                   @Y30SSFR
         DC  H'2'                      SPACING FACTOR          @Y30SSFR
         DC  C'R '                     SPACING TYPE.           @Y30SSFR
* STATIC TEXT SUB-STRUCTURE.                                   @Y30SSFR
         DC  X'8400'                   STATIC TEXT FLAG.       @Y30SSFR
         DC  Y(STE171B-STE171A)        STATIC TEXT LENGTH.     @Y30SSFR
         DC  Y(STE171A-TXT17A)         STATIC TEXT OFFSET.     @Y30SSFR
         DC  H'1'                      PRINT COLUMN.           @Y30SSFR
         DC  Y(STE171B-STE171A)        PRINT FIELD LENGTH.     @Y30SSFR
         DC  H'0'                      CONVERSION FLAGS. (CHAR)
* STATIC TEXT ENTRY.                                           @Y30SSFR
STE171A  DC  C'IDC3617I ATTRIBUTES OF PREDEFINED ENTRY '       @Y30SSFR
         DC  C'INCOMPATIBLE WITH THOSE EXPORTED'               @Y30SSFR
STE171B  EQU *                                                 @Y30SSFR
TXT17B   EQU *                                                 @Y30SSFR
         EJECT                                                 @Y30SSFR
*                                                              @Y30SSFR
* INVALID OBJECTS SUBPARAMETER FOR A PATH                      @Y30SSFR
*                                                              @Y30SSFR
TXT18    DC  Y(TXT18B-TXT18A)          ENTRY LENGTH.           @Y30SSFR
         DC  X'8000'                   MESSAGE FLAG.           @Y30SSFR
* DOUBLE SPACE SUB-STRUCTURE.                                  @Y30SSFR
TXT18A   DC  X'4000'                   SPACING FLAG.           @Y30SSFR
         DC  H'2'                      SPACING FACTOR.         @Y30SSFR
         DC  C'R '                     SPACING TYPE.           @Y30SSFR
* STATIC TEXT SUB-STRUCTURE.                                   @Y30SSFR
         DC  X'0400'                   STATIC FLAG.            @Y30SSFR
         DC  Y(STE181B-STE181A)        ENTRY LENGTH.           @Y30SSFR
         DC  Y(STE181A-TXT18A)         TEXT OFFSET.            @Y30SSFR
         DC  H'1'                      PRINT COLUMN.           @Y30SSFR
         DC  H'0'                      PRINT FIELD LENGTH.     @Y30SSFR
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* BLOCK DATA SUB-STRUCTURE.                                    @Y30SSFR
         DC  X'9000'                   BLOCK DATA FLAG.        @Y30SSFR
         DC  H'44'                     INPUT LENGTH.           @Y30SSFR
         DC  H'0'                      INPUT OFFSET.           @Y30SSFR
         DC  H'49'                     PRINT COLUMN.           @Y30SSFR
         DC  H'44'                     PRINT FIELD LENGTH.     @Y30SSFR
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* STATIC TEXT ENTRIES.                                         @Y30SSFR
STE181A  DC  C'IDC2618I INVALID OBJECTS SUBPARAMETER FOR '     @Y30SSFR
         DC    C'PATH'                                         @Y30SSFR
STE181B  EQU *                                                 @Y30SSFR
TXT18B   EQU *                                                 @Y30SSFR
         EJECT                                                 @Y30SSFR
*                                                              @Y30SSFR
TXT19    DC  Y(TXT19B-TXT19A)          ENTRY LENGTH.           @Y30SSFR
         DC  X'8000'                   MESSAGE FLAG.           @Y30SSFR
* DOUBLE SPACE SUB-STRUCUTRE.                                  @Y30SSFR
TXT19A   DC  X'4000'                   SPACE SUB-STRUCTURE     @Y30SSFR
*                                      FLAG.                   @Y30SSFR
         DC  H'2'                      SPACING FACTOR          @Y30SSFR
         DC  C'R '                     SPACING TYPE.           @Y30SSFR
* STATIC TEXT SUB-STRUCTURE.                                   @Y30SSFR
         DC  X'8400'                   STATIC TEXT FLAG.       @Y30SSFR
         DC  Y(STE191B-STE191A)        STATIC TEXT LENGTH.     @Y30SSFR
         DC  Y(STE191A-TXT19A)         STATIC TEXT OFFSET.     @Y30SSFR
         DC  H'1'                      PRINT COLUMN.           @Y30SSFR
         DC  Y(STE191B-STE191A)        PRINT FIELD LENGTH.     @Y30SSFR
         DC  H'0'                      CONVERSION FLAGS        @Y30SSFR
* STATIC TEXT ENTRY.                                           @Y30SSFR
STE191A  DC  C'IDC3619I ALTER RENAME FOR IMPORTRA FAILED '     @Y30SSFR
STE191B  EQU *                                                 @Y30SSFR
TXT19B   EQU *                                                 @Y30SSFR
*                                                              @Y30SSFR
* OBJECT NOT SUPPORTED IN THE SYSTEM                           @Y30SSFR
*                                                              @Y30SSFR
TXT20    DC  Y(TXT20B-TXT20A)          ENTRY LENGTH.           @Y30SSFR
         DC  X'8000'                   MESSAGE FLAG.           @Y30SSFR
* DOUBLE SPACE SUB-STRUCTURE.                                  @Y30SSFR
TXT20A   DC  X'4000'                   SPACING FLAG.           @Y30SSFR
         DC  H'2'                      SPACING FACTOR.         @Y30SSFR
         DC  C'R '                     SPACING TYPE.           @Y30SSFR
* STATIC TEXT SUB-STRUCTURE.                                   @Y30SSFR
         DC  X'0400'                   STATIC FLAG.            @Y30SSFR
         DC  Y(STE201B-STE201A)        ENTRY LENGTH.           @Y30SSFR
         DC  Y(STE201A-TXT20A)         TEXT OFFSET.            @Y30SSFR
         DC  H'1'                      PRINT COLUMN.           @Y30SSFR
         DC  H'0'                      PRINT FIELD LENGTH.     @Y30SSFR
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* BLOCK DATA SUB-STRUCTURE.                                    @Y30SSFR
         DC  X'9000'                   BLOCK DATA FLAG.        @Y30SSFR
         DC  H'44'                     INPUT LENGTH.           @Y30SSFR
         DC  H'0'                      INPUT OFFSET.           @Y30SSFR
         DC  H'46'                     PRINT COLUMN.           @Y30SSFR
         DC  H'44'                     PRINT FIELD LENGTH.     @Y30SSFR
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* STATIC TEXT ENTRIES.                                         @Y30SSFR
STE201A  DC  C'IDC2620I OBJECT TYPE NOT SUPPORTED FOR '        @Y30SSFR
         DC    C'OBJECT'                                       @Y30SSFR
STE201B  EQU *                                                 @Y30SSFR
TXT20B   EQU *                                                 @Y30SSFR
         EJECT                                                 @Y30SSFR
*                                                              @Y30SSFR
* IMPORTRA FAILED FOR THE OBJECT                               @Y30SSFR
*                                                              @Y30SSFR
TXT21    DC  Y(TXT21B-TXT21A)          ENTRY LENGTH.           @Y30SSFR
         DC  X'8000'                   MESSAGE FLAG.           @Y30SSFR
* DOUBLE SPACE SUB-STRUCTURE.                                  @Y30SSFR
TXT21A   DC  X'4000'                   SPACING FLAG.           @Y30SSFR
         DC  H'2'                      SPACING FACTOR.         @Y30SSFR
         DC  C'R '                     SPACING TYPE.           @Y30SSFR
* STATIC TEXT SUB-STRUCTURE.                                   @Y30SSFR
         DC  X'0400'                   STATIC FLAG.            @Y30SSFR
         DC  Y(STE211B-STE211A)        ENTRY LENGTH.           @Y30SSFR
         DC  Y(STE211A-TXT21A)         TEXT OFFSET.            @Y30SSFR
         DC  H'1'                      PRINT COLUMN.           @Y30SSFR
         DC  H'0'                      PRINT FIELD LENGTH.     @Y30SSFR
         DC  H'0'                      CONVERSION FLAGS.       @Y30SSFR
* BLOCK DATA SUB-STRUCTURE.                                    @Y30SSFR
         DC  X'9000'                   BLOCK DATA FLAG.        @Y30SSFR
         DC  H'44'                     INPUT LENGTH.           @Y30SSFR
         DC  H'0'                      INPUT OFFSET.           @Y30SSFR
         DC  H'31'                     PRINT COLUMN.           @Y30SSFR
         DC  H'44'                     PRINT FIELD LENGTH.     @Y30SSFR
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* STATIC TEXT ENTRIES.                                         @Y30SSFR
STE211A  DC  C'IDC2621I IMPORTRA FAILED FOR '                  @Y30SSFR
STE211B  EQU *                                                 @Y30SSFR
TXT21B   EQU *                                                 @Y30SSFR
         EJECT                                                 @Y30SSFR
*                                                              @Y30SSFR
* USERCATALOG DISCONNECTED                                     @Y30SSFR
*                                                              @Y30SSFR
TXT22    DC  Y(TXT22B-TXT22A)          ENTRY LENGTH.           @Y30SSFR
         DC  X'8000'                   MESSAGE FLAG.           @Y30SSFR
* DOUBLE SPACE SUB-STRUCUTRE.                                  @Y30SSFR
TXT22A   DC  X'4000'                   SPACE SUB-STRUCTURE     @Y30SSFR
         DC  H'2'                      SPACING FACTOR          @Y30SSFR
         DC  C'R '                     SPACING TYPE.           @Y30SSFR
* STATIC TEXT SUB-STRUCTURE.                                   @Y30SSFR
         DC  X'0400'                   STATIC TEXT FLAG.       @Y30SSFR
         DC  Y(STE221B-STE221A)        STATIC TEXT LENGTH.     @Y30SSFR
         DC  Y(STE221A-TXT22A)         STATIC TEXT OFFSET.     @Y30SSFR
         DC  H'1'                      PRINT COLUMN.           @Y30SSFR
         DC  Y(STE221B-STE221A)        PRINT FIELD LENGTH.     @Y30SSFR
         DC  H'0'                      CONVERSION FLAGS. (CHAR)
* BLOCK DATA SUB-STRUCTURE.                                    @Y30SSFR
         DC  X'1000'                   BLOCK DATA FLAG.        @Y30SSFR
         DC  H'44'                     INPUT DATA LENGTH.      @Y30SSFR
         DC  H'0'                      INPUT DATA OFFSET.      @Y30SSFR
         DC  H'22'                     PRINT COLUMN.           @Y30SSFR
         DC  H'44'                     PRINT FIELD LENGTH.     @Y30SSFR
         DC  X'0000'                   CONVERSION FLAG.  (CHAR)
* STATIC TEXT SUB-STRUCTURE.                                   @Y30SSFR
         DC  X'8400'                   STATIC & EOF FLAGS.     @Y30SSFR
         DC  Y(STE222B-STE222A)        STATIC TEXT LENGTH.     @Y30SSFR
         DC  Y(STE222A-TXT22A)         STATIC TEXT OFFSET.     @Y30SSFR
         DC  H'1'                      PRINT COLUMN OFFSET.    @Y30SSFR
         DC  Y(STE222B-STE222A)        PRINT FIELD LENGTH.     @Y30SSFR
         DC  X'0010'                   CONVERSION FLAG.  (CHAR,BS)
* STATIC TEXT ENTRY.                                           @Y30SSFR
STE221A  DC  C'IDC0622I  USERCATALOG '                         @Y30SSFR
STE221B  EQU *                                                 @Y30SSFR
STE222A  DC  C'DISCONNECTED'                                   @Y30SSFR
STE222B  EQU *                                                 @Y30SSFR
TXT22B   EQU *                                                 @Y30SSFR
         EJECT                                                 @Y30SSFR
*                                                              @Y30SSFR
* UIONINFO FAILED TO RETURN THE DUMMY DATA SET NAME            @Y30SSFR
*                                                              @Y30SSFR
TXT24    DC  Y(TXT24B-TXT24A)          ENTRY LENGTH.           @Y30SSFR
         DC  X'8000'                   MESSAGE FLAG.           @Y30SSFR
* DOUBLE SPACE SUB-STRUCUTRE.                                  @Y30SSFR
TXT24A   DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
         DC  H'2'                      SPACING FACTOR          @Y30SSFR
         DC  C'R '                     SPACING TYPE.           @Y30SSFR
* STATIC TEXT SUB-STRUCTURE.                                   @Y30SSFR
         DC  X'8400'                   STATIC TEXT FLAG.       @Y30SSFR
         DC  Y(STE241B-STE241A)        STATIC TEXT LENGTH.     @Y30SSFR
         DC  Y(STE241A-TXT24A)         STATIC TEXT OFFSET.     @Y30SSFR
         DC  H'1'                      PRINT COLUMN.           @Y30SSFR
         DC  Y(STE241B-STE241A)        PRINT FIELD LENGTH.     @Y30SSFR
         DC  H'0'                      CONVERSION FLAGS. (CHAR)
* STATIC TEXT ENTRY.                                           @Y30SSFR
STE241A  DC  C'IDC3624I UNABLE TO OBTAIN OUTPUT DATA SET NAME' @Y30SSFR
STE241B  EQU *                                                 @Y30SSFR
TXT24B   EQU *                                                 @Y30SSFR
*                                                              @Z40RSSA
* 'INTOEMPTY'  KEYWORD NEEDED TO IMPORT INTO AN EMPTY DATA SET @Z40RSSA
*                                                              @Z40RSSA
*                                                              @Z40RSSA
TXT25    DC    Y(TXT25B-TXT25A)         ENTRY LENGTH.          @Z40RSSA
         DC    X'8000'                  MESSAGE FLAG.          @Z40RSSA
* SPACING CONTROL SUB-STRUCTURE                                @Z40RSSA
TXT25A   DC    X'4000'                  SPACE CONTROL FLAG     @Z40RSSA
         DC    H'2'                     SPACING FACTOR         @Z40RSSA
         DC    C'R '                     SPACING TYPE          @Z40RSSA
* STATIC TEXT SUB-STRUCTURE.                                   @Z40RSSA
*                                                              @Z40RSSA
         DC    X'8400'                  STATIC TEXT FLAG       @Z40RSSA
         DC    Y(STE125B-STE125A)       STATIC TEXT LENGTH     @Z40RSSA
         DC    Y(STE125A-TXT25A)        STATIC TEXT OFFSET     @Z40RSSA
         DC    H'1'                     PRINT COLUMN           @Z40RSSA
         DC    Y(STE125B-STE125A)       PRINT FIELD LENGTH     @Z40RSSA
* ALTER RENAMED FAILED FOR IMPORTRA                            @Z40RSSA
         DC    H'0'                     CONVERSION FLAGS (CHAR)
* STATIC TEXT ENTRIES                                          @Z40RSSA
STE125A  DC    C'IDC3625I ''INTOEMPTY'' KEYWORD NEEDED TO IMPORT INTO'
         DC    C' AN EMPTY DATA SET'                           @Z40RSSA
STE125B  EQU   *                                               @Z40RSSA
TXT25B   EQU   *                                               @Z40RSSA
         EJECT                                                 #Y30SSFR
*                                                              #Y30SSFR
* IMPORTRA SUCCEEDED FOR THE OBJECT                            @Y30SSFR
*                                                              @Y30SSFR
TXT26    DC  Y(TXT26B-TXT26A)          ENTRY LENGTH.           @Y30SSFR
         DC  X'8000'                   MESSAGE FLAG.           @Y30SSFR
* DOUBLE SPACE SUB-STRUCTURE.                                  @Y30SSFR
TXT26A   DC  X'4000'                   SPACING FLAG.           @Y30SSFR
         DC  H'2'                      SPACING FACTOR.         @Y30SSFR
         DC  C'R '                     SPACING TYPE.           @Y30SSFR
* STATIC TEXT SUB-STRUCTURE.                                   @Y30SSFR
         DC  X'0400'                   STATIC FLAG.            @Y30SSFR
         DC  Y(STE261B-STE261A)        ENTRY LENGTH.           @Y30SSFR
         DC  Y(STE261A-TXT26A)         TEXT OFFSET.            @Y30SSFR
         DC  H'1'                      PRINT COLUMN.           @Y30SSFR
         DC  H'0'                      PRINT FIELD LENGTH.     @Y30SSFR
         DC  H'0'                      CONVERSION FLAGS.       @Y30SSFR
* BLOCK DATA SUB-STRUCTURE.                                    @Y30SSFR
         DC  X'9000'                   BLOCK DATA FLAG.        @Y30SSFR
         DC  H'44'                     INPUT LENGTH.           @Y30SSFR
         DC  H'0'                      INPUT OFFSET.           @Y30SSFR
         DC  H'34'                     PRINT COLUMN.           @Y30SSFR
         DC  H'44'                     PRINT FIELD LENGTH.     @Y30SSFR
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* STATIC TEXT ENTRIES.                                         @Y30SSFR
STE261A  DC  C'IDC0626I IMPORTRA SUCCEEDED FOR '               @Y30SSFR
STE261B  EQU *                                                 @Y30SSFR
TXT26B   EQU *                                                 @Y30SSFR
         EJECT                                                 @OZ17068
*                                                              @OZ17068
* ENTRY 27 RESERVED FOR FUTURE USE                             @OZ17068
*                                                              @OZ17068
         EJECT                                                 @OZ17068
*                                                              @OZ17068
* DUMMY NAME REMAINS IN CATALOG                                @OZ17068
*                                                              @OZ17068
TXT28    DC  Y(TXT28B-TXT28A)          ENTRY LENGTH.           @OZ17068
         DC  X'8000'                   MESSAGE FLAG.           @OZ17068
* DOUBLE SPACE SUB-STRUCTURE.                                  @OZ17068
TXT28A   DC  X'4000'                   SPACING FLAG.           @OZ17068
         DC  H'2'                      SPACING FACTOR.         @OZ17068
         DC  C'R '                     SPACING TYPE.           @OZ17068
* STATIC TEXT SUB-STRUCTURE.                                   @OZ17068
         DC  X'8400'                   STATIC FLAG.            @OZ17068
         DC  Y(STE281B-STE281A)        ENTRY LENGTH.           @OZ17068
         DC  Y(STE281A-TXT28A)         TEXT OFFSET.            @OZ17068
         DC  H'1'                      PRINT COLUMN.           @OZ17068
         DC  Y(STE281B-STE281A)        PRINT FIELD LENGTH.     @OZ17068
         DC  H'0'                      CONVERSION FLAGS.       @OZ17068
* STATIC TEXT ENTRIES.                                         @OZ17068
STE281A  DC  C'IDC3628I DUMMY NAME REMAINS IN CATALOG'         @OZ17068
STE281B  EQU *                                                 @OZ17068
TXT28B   EQU *                                                 @OZ17068
         END
