* /* START OF SPECIFICATIONS ****
*
*01*  MODULE-NAME = IDCTSPR0
*02* PROCESSOR = ASSEMBLER
*
**** END OF SPECIFICATIONS ***/
         TITLE '***** IDCTSPR0 - PRINT STATIC TEXT *****'
**********************************************************************
*                                                                    *
* MODULE NAME - IDCTSPR0 - STATIC TEXT MODULE FOR PRINT              *
*                                                                    *
* DESCRIPTIVE NAME - STATIC TEXT MODULE FOR THE FUNCTION PRINT       *
*                                                                    *
* COPYRIGHT - NONE                                                   *
*                                                                    *
* STATUS - RELEASE 2  LEVEL 0                                        *
*                                                                    *
* FUNCTION - CONTAINS NO EXECUTABLE CODE, ONLY STATIC TEXT ENTRIES   *
*        FOR THE FUNCTION PRINT                                      *
*        THIS MODULE IS LOADED BY IDCTP05 WHEN A STATIC TEXT         *
*        REQUEST IS MADE.                                            *
*                                                                    *
* NOTES - NONE                                                       *
*                                                                    *
*    DEPENDENCIES - NONE                                             *
*    RESTRICTIONS - NONE                                             *
*    REGISTER CONVENTIONS - NA                                       *
*    PATCH AREA - NA                                                 *
*                                                                    *
* MODULE TYPE - TABLES                                               *
*                                                                    *
*    PROCESSOR - ASSEMBLER                                           *
*    MODULE SIZE - 1702                                              *
*    ATTRIBUTES - READ-ONLY                                          *
*                                                                    *
*  ENTRY POINT - NA                                                  *
*                                                                    *
*  EXIT NORMAL - NA                                                  *
*                                                                    *
*  EXIT ERROR - NA                                                   *
*                                                                    *
*  EXTERNAL REFERENCES - NA                                          *
*                                                                    *
*  TABLES - NA                                                       *
*                                                                    *
*  MACROS - NA                                                       *
*                                                                    *
* CHANGE ACTIVITY - CHANGED FORMAT OF ENT 21 9/13/74         @Y30LSEC*
*                 - DELETED ENTRY 15 9/27/74                 @Y30LSEC*
*                 - READDED ENTRY 16                         @Y30LSEC*
*                 - ADDED ENTRY 24 1/7/75                    @Y30SSEC*
*                                                                    *
**********************************************************************
*                                                                    *
**********************************************************************
*                                                                    *
* THIS MODULE IS THE FIRST MODULE OF STATIC TEXT REQUIRED BY THE     *
* PRINT FUNCTION SUB-ROUTINE MODULE.                                 *
*                                                                    *
**********************************************************************
*
*
IDCTSPR0  CSECT
*
* THIS SECTION CONTAINS THE INDICES TO REACH AN ENTRY.               *
*
INDEX     DC    H'24'                   NULL INDEX VALUE.      @Y30SSEC
INDEX1    DC    Y(TXT1-INDEX)           LINE PRINT SUB-TITLE.
INDEX2    DC    Y(TXT2-INDEX)           KEY OF REC FMT ENTRY.  (CHAR)
INDEX3    DC    Y(TXT3-INDEX)           CCHHR OF RECORD FMT EN.(CHAR)
INDEX4    DC    Y(TXT4-INDEX)           RBA OF RECORD FMT ENT. (CHAR)
INDEX5    DC    Y(TXT5-INDEX)           RELATIVE RECORD ENTRY. (CHAR)
INDEX6    DC    Y(TXT6-INDEX)           KEY OF REC FMT ENT.   (HEX)
INDEX7    DC    Y(TXT7-INDEX)           CCHHR OF REC FMT ENT. (HEX)
INDEX8    DC    Y(TXT8-INDEX)           RBA OF REC ENT. (HEX)  @Y30SVLO
INDEX9    DC    Y(TXT9-INDEX)           REL. RECORD ENT.(HEX)  @Y30SVLO
INDEX10   DC    Y(TXT10-INDEX)          KEY OF REC FMT  (DUMP) @Y30SVLO
INDEX11   DC    Y(TXT11-INDEX)          CCHHR OF RECORD (DUMP) @Y30SVLO
INDEX12   DC    Y(TXT12-INDEX)          RBA OF REC ENT. (DUMP) @Y30SVLO
INDEX13   DC    Y(TXT13-INDEX)          REL. RECORD ENT.(DUMP) @Y30SVLO
INDEX14   DC    Y(TXT14-INDEX)          INVALID DS TYPES.      @Y30SVLO
INDEX15   DC    H'-1'                   NULL ENTRY             @Y30SVLO
INDEX16   DC    Y(TXT16-INDEX)          COPY CAT DELIM  ERR    @Y30LSEC
INDEX17   DC    Y(TXT17-INDEX)          INVALID DELIMITER.     @Y30SVLO
INDEX18   DC    Y(TXT18-INDEX)          CAT. RELOAD DELIM ERR  @YA04583
INDEX19   DC    Y(TXT19-INDEX)          CAT. RELOAD INVOKE     @YA04583
INDEX20   DC    Y(TXT20-INDEX)          TARGET CAT. SIZE ERR.  @YA04583
INDEX21   DC    Y(TXT21-INDEX)          CAT. NAME ERR.         @YA04583
INDEX22   DC    Y(TXT22-INDEX)          NO CAT. COMPARE        @YA04583
INDEX23   DC    Y(TXT23-INDEX)          TRUENAME COMPARE MSG   @YA04583
INDEX24   DC    Y(TXT24-INDEX)          RECOV ATTR ON COPY CAT @Y30SSEC
          EJECT
********************************************************************
*                                                                    *
* THIS SECTION CONTAINS THE ENTRIES.                                 *
*                                                                    *
********************************************************************
*
* IDC PRINT FSR LISTING OF DATA SET ENTRY. (PR01)
*
          DS    0F                      ALIGN TO A FULL WORD.
TXT1      DC    Y(TXT1B-TXT1A)          LENGTH.
FLG1A     DC    X'0000'                 FLAG BYTE.
*  STATIC TEXT SUB-STRUCTURE.
TXT1A     DC    X'8400'                 STATIC TEXT SUB-STRU FLAG.
          DC    Y(STE11B-STE11A)        STATIC TEXT LENGTH.
          DC    Y(STE11A-TXT1A)         STATIC TEXT OFFSET.
          DC    H'1'                    PRINT LINE OFFSET.
          DC    Y(STE11B-STE11A)        PRINT LINE LENGTH.
          DC    H'0'                    CONVERSION FLAGS.
STE11A    DC    C'-'                    TRIPLE SPACE CHARACTER.
          DC    C'LISTING OF DATA SET - '
STE11B    EQU   *
TXT1B     EQU   *
          EJECT
*
* PRINT CHARACTER FORMAT STRUCTURE KEY OF RECORD ENTRY.
*
          DS    0F
TXT2      DC    Y(TXT2B-TXT2A)          LENGTH.
FLG2A     DC    X'0000'                 FLAG FIELD.
* DOUBLE SPACE SUB-STRUCTURE.
TXT2A     DC    X'4000'                 SPACE SUB-STRUCTURE FLAG.
          DC    H'2'                    DOUBLE SPACE COUNT.
          DC    C'R '                   RELATIVE SPACE INDICATOR.
* STATIC TEXT SUB-STRUCTURE.
          DC    X'0400'                 STATIC TEXT SUB-STRUCTURE.
          DC    Y(STE21B-STE21A)        STATIC TEXT LENGTH.
          DC    Y(STE21A-TXT2A)         STATIC TEXT OFFSET.
          DC    H'1'                    PRINT COLUMN.
          DC    Y(STE21B-STE21A)        PRINT FIELD LENGTH.
          DC    H'0'                    CONVERSION FLAGS.
* INSERT DATA SUB-STRUCTURE.
          DC    X'2000'                 INSERT DATA SUB-STRUCTURE.
          DC    H'1'                    INSERT REFERENCE NUMBER.
          DC    H'0'                    UNUSED
          DC    H'17'                   PRINT COLUMN.
          DC    H'0'                    DEFAULT
          DC    X'0000'                 CONVERSION FLAG.  (CHAR)
* DOUBLE SPACE SUB-STRUCTURE.
          DC    X'4000'                 SPACE SUB-STRUCTURE FLAG.
          DC    H'1'                    SPACING FACTOR.
          DC    C'R '                   SPACING TYPE.
* BLOCK DATA SUBSTRUCTURE.
          DC    X'9000'                 BLOCK DATA EOS FLAGS.
          DC    H'32767'                MAXIMUM INPUT LENGTH.
          DC    H'0'                    INPUT OFFSET.
          DC    H'1'                    PRINT COLUMN.
          DC    H'0'                    DEFAULT
          DC    X'0000'                 CONVERSION TYPE.  (CHAR)
* STATIC TEXT ENTRY.
STE21A    DC    C'KEY OF RECORD -'
STE21B    EQU   *
TXT2B     EQU   *
          EJECT
*
* PRINT CHARACTER FORMAT STRUCTURE RECORD SEQUENCE ENTRY.
*
          DS    0F
TXT3      DC    Y(TXT3B-TXT3A)          LENGTH.
FLG3A     DC    X'0000'                 FLAG FIELD.
* DOUBLE SPACE SUB-STRUCTURE.
TXT3A     DC    X'4000'                 SPACE SUB-STRUCTURE FLAG.
          DC    H'2'                    DOUBLE SPACE COUNT.
          DC    C'R '                   RELATIVE SPACE INDICATOR.
* STATIC TEXT SUB-STRUCTURE.
          DC    X'0400'                 STATIC TEXT SUB-STRUCTURE.
          DC    Y(STE31B-STE31A)        STATIC TEXT LENGTH.
          DC    Y(STE31A-TXT3A)         STATIC TEXT OFFSET.
          DC    H'1'                    PRINT COLUMN.
          DC    Y(STE31B-STE31A)        PRINT FIELD LENGTH.
          DC    H'0'                    CONVERSION FLAGS.  (EBCDIC)
* INSERT DATA SUB-STRUCTURE.
          DC    X'2000'                 INSERT DATA SUB-STRUCTURE.
          DC    H'1'                    INSERT REFERENCE NUMBER.
          DC    H'0'                    UNUSED
          DC    H'26'                   PRINT COLUMN.
          DC    H'0'                    DEFAULT
          DC    X'1060'                 CONVERSION FLAG.  (BD)
* DOUBLE SPACE SUB-STRUCTURE.
          DC    X'4000'                 SPACE SUB-STRUCTURE FLAG.
          DC    H'1'                    SPACING FACTOR.
          DC    C'R '                   SPACING TYPE.
* BLOCK DATA SUBSTRUCTURE.
          DC    X'9000'                 BLOCK DATA EOS FLAGS.
          DC    H'32767'                MAXIMUM INPUT LENGTH.
          DC    H'0'                    INPUT OFFSET.
          DC    H'1'                    PRINT COLUMN.
          DC    H'0'
          DC    X'0000'                 EBCDIC CONVERSION TYPE.
* STATIC TEXT ENTRY.
STE31A    DC    C'RECORD SEQUENCE NUMBER -'
STE31B    EQU   *
TXT3B     EQU   *
          EJECT
*
* PRINT CHARACTER FORMAT STRUCTURE RBA OF RECORD ENTRY.
*
TXT4      DC    Y(TXT4B-TXT4A)          LENGTH.
FLG4A     DC    X'0000'                 FLAG FIELD.
* DOUBLE SPACE SUB-STRUCTURE.
TXT4A     DC    X'4000'                 SPACE SUB-STRUCTURE FLAG.
          DC    H'2'                    DOUBLE SPACE COUNT.
          DC    C'R '                   RELATIVE SPACE INDICATOR.
* STATIC TEXT SUB-STRUCTURE.
          DC    X'0400'                 STATIC TEXT SUB-STRUCTURE.
          DC    Y(STE41B-STE41A)        STATIC TEXT LENGTH.
          DC    Y(STE41A-TXT4A)         STATIC TEXT OFFSET.
          DC    H'1'                    PRINT COLUMN.
          DC    Y(STE41B-STE41A)        PRINT FIELD LENGTH.
          DC    H'0'                    CONVERSION FLAGS.
* INSERT DATA SUB-STRUCTURE.
          DC    X'2000'                 INSERT DATA SUB-STRUCTURE.
          DC    H'1'                    INSERT REFERENCE NUMBER.
          DC    H'0'                    UNUSED
          DC    H'17'                   PRINT COLUMN.
          DC    H'0'                    DEFAULT
          DC    X'1060'                 CONVERSION FLAG.  (BD,AL,SS)
* DOUBLE SPACE SUB-STRUCTURE.
          DC    X'4000'                 SPACE SUB-STRUCTURE FLAG.
          DC    H'1'                    SPACING FACTOR.
          DC    C'R '                   SPACING TYPE.
* BLOCK DATA SUBSTRUCTURE.
          DC    X'9000'                 BLOCK DATA EOS FLAGS.
          DC    H'32767'                MAXIMUM INPUT LENGTH.
          DC    H'0'                    INPUT OFFSET.
          DC    H'1'                    PRINT COLUMN.
          DC    H'0'                    DEFAULT
          DC    X'0000'                 EBCDIC CONVERSION TYPE.
* STATIC TEXT ENTRY.
STE41A    DC    C'RBA OF RECORD -'
STE41B    EQU   *
TXT4B     EQU *
          EJECT
*                                                              @Y30DSLO
* PRINT CHARACTER FORMAT STRUCTURE RELATIVE RECORD ENTRY.      @Y30DSLO
*                                                              @Y30DSLO
TXT5      DC    Y(TXT5B-TXT5A)          LENGTH.                @Y30DSLO
FLG5A     DC    X'0000'                 FLAG FIELD.            @Y30DSLO
* DOUBLE SPACE SUB-STRUCTURE.                                  @Y30DSLO
TXT5A     DC    X'4000'                 SPACE SUB-STRUCTURE FLAG.
          DC    H'2'                    DOUBLE SPACE COUNT.    @Y30DSLO
          DC    C'R '                   RELATIVE SPACE INDICATOR.
* STATIC TEXT SUB-STRUCTURE.                                   @Y30DSLO
          DC    X'0400'                 STATIC TEXT SUB-STRUCTURE.
          DC    Y(STE51B-STE51A)      STATIC TEXT LENGTH.      @Y30DSLO
          DC    Y(STE51A-TXT5A)       STATIC TEXT OFFSET.      @Y30DSLO
          DC    H'1'                    PRINT COLUMN.          @Y30DSLO
          DC    Y(STE51B-STE51A)      PRINT FIELD LENGTH.      @Y30DSLO
          DC    H'0'                    CONVERSION FLAGS.      @Y30DSLO
* INSERT DATA SUB-STRUCTURE.                                   @Y30DSLO
          DC    X'2000'                 INSERT DATA SUB-STRUCTURE.
          DC    H'1'                    INSERT REFERENCE NUMBER.
          DC    H'0'                    UNUSED                 @Y30DSLO
          DC    H'26'                   PRINT COLUMN.          @Y30DSLO
          DC    H'0'                    DEFAULT                @Y30DSLO
          DC    X'1060'                 CONVERSION FLAG.  (BD,AL,SS)
* DOUBLE SPACE SUB-STRUCTURE.                                  @Y30DSLO
          DC    X'4000'                 SPACE SUB-STRUCTURE FLAG.
          DC    H'1'                    SPACING FACTOR.        @Y30DSLO
          DC    C'R '                   SPACING TYPE.          @Y30DSLO
* BLOCK DATA SUBSTRUCTURE.                                     @Y30DSLO
          DC    X'9000'                 BLOCK DATA EOS FLAGS.  @Y30DSLO
          DC    H'32767'                MAXIMUM INPUT LENGTH.  @Y30DSLO
          DC    H'0'                    INPUT OFFSET.          @Y30DSLO
          DC    H'1'                    PRINT COLUMN.          @Y30DSLO
          DC    H'0'                    DEFAULT                @Y30DSLO
          DC    X'0000'                 EBCDIC CONVERSION TYPE.
* STATIC TEXT ENTRY.                                           @Y30DSLO
STE51A    DC    C'RELATIVE RECORD NUMBER -'                    @Y30DSLO
STE51B    EQU   *                                              @Y30DSLO
TXT5B     EQU *                                                @Y30DSLO
          EJECT                                                @Y30DSLO
*
* PRINT HEX FORMAT STRUCTURE KEY OF RECORD ENTRY.
*
TXT6      DC    Y(TXT6B-TXT6A)          LENGTH.
FLG6A     DC    X'0000'                 FLAG FIELD.
* DOUBLE SPACE SUB-STRUCTURE.
TXT6A     DC    X'4000'                 SPACE SUB-STRUCTURE FLAG.
          DC    H'2'                    DOUBLE SPACE COUNT.
          DC    C'R '                   RELATIVE SPACE INDICATOR.
* STATIC TEXT SUB-STRUCTURE.
          DC    X'0400'                 STATIC TEXT SUB-STRUCTURE FLAG.
          DC    Y(STE61B-STE61A)        STATIC TEXT LENGTH.
          DC    Y(STE61A-TXT6A)         STATIC TEXT OFFSET.
          DC    H'1'                    PRINT COLUMN.
          DC    Y(STE61B-STE61A)        OUTPUT LENGTH.
          DC    H'0'                    CONVERSION FLAGS. (CHAR)
* INSERT DATA SUB-STRUCTURE.
          DC    X'2000'                 INSERT DATA FLAGS.
          DC    H'1'                    INSERT REFERENCE NUMBER.
          DC    H'0'                    UNUSED
          DC    H'17'                   PRINT COLUMN.
          DC    H'0'                    DEFAULT
          DC    X'8000'                 CONVERSION FLAGS. (BH)
* DOUBLE SPACE SUB-STRUCTURE.
          DC    X'4000'                 SPACE SUB-STRUCTURE FLAG.
          DC    H'1'                    DOUBLE SPACING FACTOR.
          DC    C'R '                   RELATIVE SPACING TYPE.
* BLOCK DATA SUB-STRUCTURE.
          DC    X'9000'                 EOF & BLOCK FLAGS.
          DC    H'32767'                MAXIMUM INPUT LENGTH.
          DC    H'0'                    INPUT OFFSET.
          DC    H'1'                    PRINT COLUMN.
          DC    H'0'                    DEFAULT
          DC    X'8000'                 CONVERSION FLAGS. (HEX)
* STATIC TEXT ENTRY.
STE61A    DC    C'KEY OF RECORD -'
STE61B    EQU   *
TXT6B     EQU   *
          EJECT
*
* PRINT HEX FORMAT STRUCTURE RECORD SEQUENCE ENTRY.
*
TXT7      DC    Y(TXT7B-TXT7A)          LENGTH.
FLG7A     DC    X'0000'                 FLAG FIELD.
* DOUBLE SPACE SUB-STRUCTURE.
TXT7A     DC    X'4000'                 SPACE SUB-STRUCTURE FLAG.
          DC    H'2'                    DOUBLE SPACE COUNT.
          DC    C'R '                   RELATIVE SPACE INDICATOR.
* STATIC TEXT SUB-STRUCTURE.
          DC    X'0400'                 STATIC TEXT SUB-STRUCTURE FLAG.
          DC    Y(STE71B-STE71A)        STATIC TEXT LENGTH.
          DC    Y(STE71A-TXT7A)         STATIC TEXT OFFSET.
          DC    H'1'                    PRINT COLUMN.
          DC    Y(STE71B-STE71A)        OUTPUT LENGTH.
          DC    H'0'                    CONVERSION FLAGS. (CHAR)
* INSERT DATA SUB-STRUCTURE.
          DC    X'2000'                 INSERT DATA FLAGS.
          DC    H'1'                    INSERT REFERENCE NUMBER.
          DC    H'0'                    UNUSED
          DC    H'26'                   PRINT COLUMN.
          DC    H'0'                    DEFAULT
          DC    X'1060'                 CONVERSION FLAGS. (BD)
* DOUBLE SPACE SUB-STRUCTURE.
          DC    X'4000'                 SPACE SUB-STRUCTURE FLAG.
          DC    H'1'                    DOUBLE SPACING FACTOR.
          DC    C'R '                   RELATIVE SPACING TYPE.
* BLOCK DATA SUB-STRUCTURE.
          DC    X'9000'                 EOF & BLOCK FLAGS.
          DC    H'32767'                MAXIMUM INPUT LENGTH.
          DC    H'0'                    INPUT OFFSET.
          DC    H'1'                    PRINT COLUMN.
          DC    H'0'
          DC    X'8000'                 CONVERSION FLAGS. (HEX)
* STATIC TEXT ENTRY.
STE71A    DC    C'RECORD SEQUENCE NUMBER -'
STE71B    EQU   *
TXT7B     EQU   *
          EJECT
*
* PRINT HEX FORMAT STRUCTURE RBA OF RECORD ENTRY.
*
TXT8      DC    Y(TXT8B-TXT8A)          LENGTH.
FLG8A     DC    X'0000'                 FLAG FIELD.
* DOUBLE SPACE SUB-STRUCTURE.
TXT8A     DC    X'4000'                 SPACE SUB-STRUCTURE FLAG.
          DC    H'2'                    DOUBLE SPACE COUNT.
          DC    C'R '                   RELATIVE SPACE INDICATOR.
* STATIC TEXT SUB-STRUCTURE.
          DC    X'0400'                 STATIC TEXT SUB-STRUCTURE FLAG.
          DC    Y(STE81B-STE81A)        STATIC TEXT LENGTH.
          DC    Y(STE81A-TXT8A)         STATIC TEXT OFFSET.
          DC    H'1'                    PRINT COLUMN.
          DC    Y(STE81B-STE81A)        OUTPUT LENGTH.
          DC    H'0'                    CONVERSION FLAGS. (CHAR)
* INSERT DATA SUB-STRUCTURE.
          DC    X'2000'                 INSERT DATA FLAGS.
          DC    H'1'                    INSERT REFERENCE NUMBER.
          DC    H'0'                    UNUSED
          DC    H'17'                   PRINT COLUMN.
          DC    H'0'                    DEFAULT
          DC    X'1060'                 CONVERSION FLAGS. (BD,AL,SS)
* DOUBLE SPACE SUB-STRUCTURE.
          DC    X'4000'                 SPACE SUB-STRUCTURE FLAG.
          DC    H'1'                    DOUBLE SPACING FACTOR.
          DC    C'R '                   RELATIVE SPACING TYPE.
* BLOCK DATA SUB-STRUCTURE.
          DC    X'9000'                 EOF & BLOCK FLAGS.
          DC    H'32767'                MAXIMUM INPUT LENGTH.
          DC    H'0'                    INPUT OFFSET.
          DC    H'1'                    PRINT COLUMN.
          DC    H'0'
          DC    X'8000'                 CONVERSION FLAGS. (HEX)
* STATIC TEXT ENTRY.
STE81A    DC    C'RBA OF RECORD -'
STE81B    EQU   *
TXT8B     EQU   *
          EJECT
*
* PRINT HEX FORMAT STRUCTURE RELATIVE RECORD ENTRY.            @Y30DSLO
*                                                              @Y30DSLO
TXT9      DC   Y(TXT9B-TXT9A)          LENGTH.                 @Y30DSLO
FLG9A     DC   X'0000'                 FLAG FIELD.             @Y30DSLO
* DOUBLE SPACE SUB-STRUCTURE.                                  @Y30DSLO
TXT9A     DC    X'4000'                 SPACE SUB-STRUCTURE FLAG.
          DC    H'2'                    DOUBLE SPACE COUNT.    @Y30DSLO
          DC    C'R '                   RELATIVE SPACE INDICATOR.
* STATIC TEXT SUB-STRUCTURE.                                   @Y30DSLO
          DC    X'0400'                 STATIC TEXT SUB-STRUCTURE.
          DC    Y(STE91B-STE91A)      STATIC TEXT LENGTH.      @Y30DSLO
          DC    Y(STE91A-TXT9A)       STATIC TEXT OFFSET.      @Y30DSLO
          DC    H'1'                    PRINT COLUMN.          @Y30DSLO
          DC    Y(STE91B-STE91A)      PRINT FIELD LENGTH.      @Y30DSLO
          DC    H'0'                    CONVERSION FLAGS.      @Y30DSLO
* INSERT DATA SUB-STRUCTURE.                                   @Y30DSLO
          DC    X'2000'                 INSERT DATA SUB-STRUCTURE.
          DC    H'1'                    INSERT REFERENCE NUMBER.
          DC    H'0'                    UNUSED                 @Y30DSLO
          DC    H'26'                   PRINT COLUMN.          @Y30DSLO
          DC    H'0'                    DEFAULT                @Y30DSLO
          DC    X'1060'                 CONVERSION FLAG.  (BD,AL,SS)
* DOUBLE SPACE SUB-STRUCTURE.                                  @Y30DSLO
          DC    X'4000'                 SPACE SUB-STRUCTURE FLAG.
          DC    H'1'                    SPACING FACTOR.        @Y30DSLO
          DC    C'R '                   SPACING TYPE.          @Y30DSLO
* BLOCK DATA SUBSTRUCTURE.                                     @Y30DSLO
          DC    X'9000'                 BLOCK DATA EOS FLAGS.  @Y30DSLO
          DC    H'32767'                MAXIMUM INPUT LENGTH.  @Y30DSLO
          DC    H'0'                    INPUT OFFSET.          @Y30DSLO
          DC    H'1'                    PRINT COLUMN.          @Y30DSLO
          DC    H'0'                    DEFAULT                @Y30DSLO
          DC    X'8000'                 CONVERSION FLAGS. (HEX)
* STATIC TEXT ENTRY.                                           @Y30DSLO
STE91A    DC    C'RELATIVE RECORD NUMBER -'                    @Y30DSLO
STE91B    EQU   *                                              @Y30DSLO
TXT9B     EQU *                                                @Y30DSLO
          EJECT                                                @Y30DSLO
*
* PRINT DUMP FORMAT STRUCTURE KEY OF RECORD ENTRY.
*
TXT10     DC    Y(TXT10B-TXT10A)        LENGTH.
FLG10A    DC    X'0000'                 FLAG FIELD.
* DOUBLE SPACE SUB-STRUCTURE.
TXT10A    DC    X'4000'                 SPACE SUB-STRUCTURE FLAG.
          DC    H'2'                    DOUBLE SPACE COUNT.
          DC    C'R '                   RELATIVE SPACE INDICATOR.
* STATIC TEXT SUB-STRUCTURE.
          DC    X'0400'                 STATIC TEXT SUB-STRUCTURE FLAG.
          DC    Y(STE101B-STE101A)        STATIC TEXT LENGTH.
          DC    Y(STE101A-TXT10A)         STATIC TEXT OFFSET.
          DC    H'1'                    PRINT COLUMN.
          DC    Y(STE101B-STE101A)      OUTPUT LENGTH.
          DC    H'0'                    CONVERSION FLAGS. (CHAR)
* INSERT DATA SUB-STRUCTURE.
          DC    X'2000'                 INSERT DATA FLAGS.
          DC    H'1'                    INSERT REFERENCE NUMBER.
          DC    H'0'                    UNUSED
          DC    H'17'                   PRINT COLUMN.
          DC    H'0'                    DEFAULT
          DC    X'8000'                 CONVERSION FLAGS. (BH)
* DOUBLE SPACE SUB-STRUCTURE.
          DC    X'4000'                 SPACE SUB-STRUCTURE FLAG.
          DC    H'1'                    DOUBLE SPACING FACTOR.
          DC    C'R '                   RELATIVE SPACING TYPE.
* BLOCK DATA SUB-STRUCTURE.
          DC    X'9000'                 EOF & BLOCK FLAGS.
          DC    H'32767'                MAXIMUM INPUT LENGTH.
          DC    H'0'                    INPUT OFFSET.
          DC    H'1'                    PRINT COLUMN.
          DC    H'0'
          DC    X'2000'                 CONVERSION FLAGS. (DUMP)
* STATIC TEXT ENTRY.
STE101A   DC    C'KEY OF RECORD -'
STE101B   EQU   *
TXT10B    EQU   *
          EJECT
*
* PRINT DUMP FORMAT STRUCTURE RECORD SEQUENCE ENTRY.
*
TXT11     DC    Y(TXT11B-TXT11A)          LENGTH.
FLG11A    DC    X'0000'                 FLAG FIELD.
* DOUBLE SPACE SUB-STRUCTURE.
TXT11A    DC    X'4000'                 SPACE SUB-STRUCTURE FLAG.
          DC    H'2'                    DOUBLE SPACE COUNT.
          DC    C'R '                   RELATIVE SPACE INDICATOR.
* STATIC TEXT SUB-STRUCTURE.
          DC    X'0400'                 STATIC TEXT SUB-STRUCTURE FLAG.
          DC    Y(STE111B-STE111A)      STATIC TEXT LENGTH.
          DC    Y(STE111A-TXT11A)       STATIC TEXT OFFSET.
          DC    H'1'                    PRINT COLUMN.
          DC    Y(STE111B-STE111A)      OUTPUT LENGTH.
          DC    H'0'                    CONVERSION FLAGS. (CHAR)
* INSERT DATA SUB-STRUCTURE.
          DC    X'2000'                 INSERT DATA FLAGS.
          DC    H'1'                    INSERT REFERENCE NUMBER.
          DC    H'0'                    UNUSED
          DC    H'26'                   PRINT COLUMN.
          DC    H'0'                    DEFAULT
          DC    X'1060'                 CONVERSION FLAGS. (BD,AL,SS)
* DOUBLE SPACE SUB-STRUCTURE.
          DC    X'4000'                 SPACE SUB-STRUCTURE FLAG.
          DC    H'1'                    DOUBLE SPACING FACTOR.
          DC    C'R '                   RELATIVE SPACING TYPE.
* BLOCK DATA SUB-STRUCTURE.
          DC    X'9000'                 EOF & BLOCK FLAGS.
          DC    H'32767'                MAXIMUM INPUT LENGTH.
          DC    H'0'                    INPUT OFFSET.
          DC    H'1'                    PRINT COLUMN.
          DC    H'0'                    DEFAULT
          DC    X'2000'                 CONVERSION FLAGS. (DUMP)
* STATIC TEXT ENTRY.
STE111A   DC    C'RECORD SEQUENCE NUMBER -'
STE111B   EQU   *
TXT11B    EQU   *
          EJECT
*
* PRINT DUMP FORMAT STRUCTURE RBA OF RECORD ENTRY.
*
TXT12     DC    Y(TXT12B-TXT12A)        LENGTH.
FLG12A    DC    X'0000'                 FLAG FIELD.
* DOUBLE SPACE SUB-STRUCTURE.
TXT12A    DC    X'4000'                 SPACE SUB-STRUCTURE FLAG.
          DC    H'2'                    DOUBLE SPACE COUNT.
          DC    C'R '                   RELATIVE SPACE INDICATOR.
* STATIC TEXT SUB-STRUCTURE.
          DC    X'0400'                 STATIC TEXT SUB-STRUCTURE FLAG.
          DC    Y(STE121B-STE121A)      STATIC TEXT LENGTH.
          DC    Y(STE121A-TXT12A)       STATIC TEXT OFFSET.
          DC    H'1'                    PRINT COLUMN.
          DC    Y(STE121B-STE121A)      OUTPUT LENGTH.
          DC    H'0'                    CONVERSION FLAGS. (CHAR)
* INSERT DATA SUB-STRUCTURE.
          DC    X'2000'                 INSERT DATA FLAGS.
          DC    H'1'                    INSERT REFERENCE NUMBER.
          DC    H'0'                    UNUSED
          DC    H'17'                   PRINT COLUMN.
          DC    H'0'                    DEFAULT
          DC    X'1060'                 CONVERSION FLAGS. (BD,AL,SS)
* DOUBLE SPACE SUB-STRUCTURE.
          DC    X'4000'                 SPACE SUB-STRUCTURE FLAG.
          DC    H'1'                    DOUBLE SPACING FACTOR.
          DC    C'R '                   RELATIVE SPACING TYPE.
* BLOCK DATA SUB-STRUCTURE.
          DC    X'9000'                 EOF & BLOCK FLAGS.
          DC    H'32767'                MAXIMUM INPUT LENGTH.
          DC    H'0'                    INPUT OFFSET.
          DC    H'1'                    PRINT COLUMN.
          DC    H'0'
          DC    X'2000'                 CONVERSION FLAGS. (DUMP)
* STATIC TEXT ENTRY.
STE121A   DC    C'RBA OF RECORD -'
STE121B   EQU   *
TXT12B    EQU   *
          EJECT
*                                                              @Y30DSLO
* PRINT DUMP FORMAT STRUCTURE OF RELATIVE RECORD ENTRY.        @Y30DSLO
*                                                              @Y30DSLO
TXT13     DC    Y(TXT13B-TXT13A)        LENGTH.                @Y30DSLO
FLG13A    DC    X'0000'                 FLAG FIELD.            @Y30DSLO
* DOUBLE SPACE SUB-STRUCTURE.                                  @Y30DSLO
TXT13A    DC    X'4000'                 SPACE SUB-STRUCTURE FLAG.
          DC    H'2'                    DOUBLE SPACE COUNT.    @Y30DSLO
          DC    C'R '                   RELATIVE SPACE INDICATOR.
* STATIC TEXT SUB-STRUCTURE.                                   @Y30DSLO
          DC    X'0400'                 STATIC TEXT SUB-STRUCTURE FLAG.
          DC    Y(STE131B-STE131A)      STATIC TEXT LENGTH.    @Y30DSLO
          DC    Y(STE131A-TXT13A)       STATIC TEXT OFFSET.    @Y30DSLO
          DC    H'1'                    PRINT COLUMN.          @Y30DSLO
          DC    Y(STE131B-STE131A)      OUTPUT LENGTH.         @Y30DSLO
          DC    H'0'                    CONVERSION FLAGS. (CHAR)
* INSERT DATA SUB-STRUCTURE.                                   @Y30DSLO
          DC    X'2000'                 INSERT DATA FLAGS.     @Y30DSLO
          DC    H'1'                    INSERT REFERENCE NUMBER.
          DC    H'0'                    UNUSED                 @Y30DSLO
          DC    H'26'                   PRINT COLUMN.          @Y30DSLO
          DC    H'0'                    DEFAULT                @Y30DSLO
          DC    X'1060'                 CONVERSION FLAGS. (BD,AL,SS)
* DOUBLE SPACE SUB-STRUCTURE.                                  @Y30DSLO
          DC    X'4000'                 SPACE SUB-STRUCTURE FLAG.
          DC    H'1'                    DOUBLE SPACING FACTOR. @Y30DSLO
          DC    C'R '                   RELATIVE SPACING TYPE. @Y30DSLO
* BLOCK DATA SUB-STRUCTURE.                                    @Y30DSLO
          DC    X'9000'                 EOF & BLOCK FLAGS.     @Y30DSLO
          DC    H'32767'                MAXIMUM INPUT LENGTH.  @Y30DSLO
          DC    H'0'                    INPUT OFFSET.          @Y30DSLO
          DC    H'1'                    PRINT COLUMN.          @Y30DSLO
          DC    H'0'                                           @Y30DSLO
          DC    X'2000'                 CONVERSION FLAGS. (DUMP)
* STATIC TEXT ENTRY.                                           @Y30DSLO
STE131A   DC    C'RELATIVE RECORD NUMBER -'                    @Y30DSLO
STE131B   EQU   *                                              @Y30DSLO
TXT13B    EQU   *                                              @Y30DSLO
          EJECT                                                @Y30SVLO
*                                                              @Y30SVLO
* REPRO INCOMPATIBLE DATA SETS MESSAGE.                        @Y30SVLO
*                                                              @Y30SVLO
TXT14     DC  Y(TXT14B-TXT14A)          LENGTH.                @Y30SVLO
FLG14A    DC  X'8000'                   MESSAGE FLAG.          @Y30SVLO
* DOUBLE SPACE SUB-STRUCTURE.                                  @Y30SVLO
TXT14A    DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
          DC  H'2'                      SPACING FACTOR.        @Y30SVLO
          DC  C'R '                     SPACING TYPE.          @Y30SVLO
* STATIC TEXT SUB-STRUCTURE.                                   @Y30SVLO
          DC  X'8400'                   EOF AND STATIC FLAGS.  @Y30SVLO
          DC  Y(STE141B-STE141A)        STATIC TEXT LENGTH.    @Y30SVLO
          DC  Y(STE141A-TXT14A)         STATIC TEXT OFFSET.    @Y30SVLO
          DC  H'1'                      PRINT COLUMN.          @Y30SVLO
          DC  Y(STE141B-STE141A)        PRINT FIELD LENGTH.    @Y30SVLO
          DC  H'0'                      CONVERSION FLAGS (CHAR)
* STATIC TEXT ENTRY.                                           @Y30SVLO
STE141A   DC  C'IDC3582I INPUT DATA SET ORGANIZATION'          @Y30SVLO
          DC  C' INCOMPATIBLE WITH OUTPUT DATA SET'            @Y30SVLO
STE141B   EQU *                                                @Y30SVLO
TXT14B    EQU *                                                @Y30SVLO
          EJECT                                                @Y30DSLO
          EJECT
*                                                              @Y30LSEC
* ENTRY 15 IS NULL                                             @Y30LSEC
*                                                              @Y30SVLO
          EJECT
*
* COPY CATALOG DELIMITERS SPECIFIED ERROR                      @Y30LSEC
*                                                              @Y30LSEC
TXT16     DC    Y(TXT16B-TXT16A)        LENGTH                 @Y30LSEC
FLG16A    DC    X'8000'                 MESSAGE FLAG.          @Y30LSEC
* DOUBLE SPACE SUB-STRUCTURE.                                  @Y30LSEC
TXT16A    DC    X'4000'                 SPACE SUB-STRUCTURE FLAG.
          DC    H'2'                    DOUBLE SPACE COUNT.    @Y30LSEC
          DC    C'R '                   SPACING TYPE INDICATOR.
* STATIC TEXT SUB-STRUCTURE.                                   @Y30LSEC
          DC    X'8400'                 EOF AND STATIC FLAGS.  @Y30LSEC
          DC    Y(STE161B-STE161A)      STATIC TEXT LENGTH.    @Y30LSEC
          DC    Y(STE161A-TXT16A)       STATIC TEXT OFFSET.    @Y30LSEC
          DC    H'1'                    PRINT COLUMN.          @Y30LSEC
          DC    Y(STE161B-STE161A)      PRINT FIELD LENGTH.    @Y30LSEC
          DC    H'0'                    CONVERSION FLAGS  (CHAR)
* STATIC TEXT ENTRY.                                           @Y30LSEC
STE161A   DC    C'IDC3581I REPRO OF CATALOGS CANNOT SPECIFY DELIMITERS'
STE161B   EQU   *                                              @Y30LSEC
TXT16B    EQU   *                                              @Y30LSEC
          EJECT
*
* INVALID BEGINNING/ENDING DELIMITER.                          @Y30DSLO
*                                                              @Y30DSLO
TXT17     DC   Y(TXT17B-TXT17A)         LENGTH                 @Y30DSLO
FLG17A    DC   X'8000'                  MESSAGE FLAG.          @Y30DSLO
* DOUBLE SPACE SUB-STRUCTURE.                                  @Y30DSLO
TXT17A    DC   X'4000'                  SPACE SUB-STRUCTURE FLAG.
          DC   H'2'                     DOUBLE SPACING FACTOR. @Y30DSLO
          DC   C'R '                    RELATIVE SPACING TYPE. @Y30DSLO
* STATIC TEXT SUB-STRUCTURE.                                   @Y30DSLO
          DC   X'0400'                  STATIC TEXT SUB-STRUCTURE.
          DC   Y(STE171B-STE171A)       STATIC TEXT LENGTH.    @Y30DSLO
          DC   Y(STE171A-TXT17A)        STATIC TEXT OFFSET.    @Y30DSLO
          DC   H'1'                     PRINT COLUMN.          @Y30DSLO
          DC   Y(STE171B-STE171A)       OUTPUT LENGTH.         @Y30DSLO
          DC   H'0'                     CONVERSION FLAGS.      @Y30DSLO
* INSERT DATA SUB-STRUCTURE.                                   @Y30DSLO
          DC   X'2000'                  INSERT DATA FLAGS.     @Y30DSLO
          DC   H'1'                     INSERT REFERENCE NUMBER.
          DC   H'0'                     UNUSED                 @Y30DSLO
          DC   H'11'                    PRINT COLUMN           @Y30DSLO
          DC   H'11'                    OUTPUT FIELD LENGTH.   @Y30DSLO
          DC   H'0'                     CONVERSION FLAGS.      @Y30DSLO
* STATIC TEXT SUB-STRUCTURE.                                   @Y30DSLO
          DC   X'8400'                  STATIC TEXT & EOF FLAGS.
          DC   Y(STE172B-STE172A)       STATIC TEXT LENGTH.    @Y30DSLO
          DC   Y(STE172A-TXT17A)        STATIC TEXT OFFSET.    @Y30DSLO
          DC   H'0'                     PRINT COLUMN.          @Y30DSLO
          DC   Y(STE172B-STE172A)       OUTPUT LENGTH.         @Y30DSLO
          DC   X'0010'                  CONVERSION FLAGS.      @Y30DSLO
* STATIC TEXT ENTRY.                                           @Y30DSLO
STE171A   DC   C'IDC3583I '''                                  @Y30DSLO
STE171B   EQU  *                                               @Y30DSLO
STE172A   DC   C''' INCOMPATIBLE WITH INFILE DATA SET TYPE'    @Y30DSLO
STE172B   EQU  *                                               @Y30DSLO
TXT17B    EQU  *                                               @Y30DSLO
          EJECT
*                                                              @YA04583
* REPRO FSR CATALOG RELOAD DELIMITER SPEC ERROR                @YA04583
*                                                              @YA04583
TXT18     DC    Y(TXT18B-TXT18A)        LENGTH                 @YA04583
FLG18A    DC    X'8000'                 MESSAGE FLAG.          @YA04583
* DOUBLE SPACE SUB-STRUCTURE.                                  @YA04583
TXT18A    DC    X'4000'                 SPACE SUB-STRUCTURE FLAG.
          DC    H'2'                    DOUBLE SPACE COUNT.    @YA04583
          DC    C'R '                   SPACING TYPE INDICATOR.
* STATIC TEXT SUB-STRUCTURE.                                   @YA04583
          DC    X'8400'                 EOF AND STATIC FLAGS.  @YA04583
          DC    Y(STE181B-STE181A)      STATIC TEXT LENGTH.    @YA04583
          DC    Y(STE181A-TXT18A)       STATIC TEXT OFFSET.    @YA04583
          DC    H'1'                    PRINT COLUMN.          @YA04583
          DC    Y(STE181B-STE181A)      PRINT FIELD LENGTH.    @YA04583
          DC    H'0'                    CONVERSION FLAGS  (CHAR)
* STATIC TEXT ENTRY.                                           @YA04583
STE181A   DC    C'IDC3570I DELIMITERS MUST NOT BE SPECIFIED'   @YA04583
          DC    C' WHEN RELOADING A CATALOG'                   @YA04583
STE181B   EQU   *                                              @YA04583
TXT18B    EQU   *                                              @YA04583
          EJECT                                                @YA04583
*                                                              @YA04583
* REPRO FSR SUCCESSFUL INITIATION MESSAGE.                     @YA04583
*                                                              @YA04583
TXT19     DC    Y(TXT19B-TXT19A)        LENGTH                 @YA04583
FLG19A    DC    X'8000'                 MESSAGE FLAG.          @YA04583
* DOUBLE SPACE SUB-STRUCTURE.                                  @YA04583
TXT19A    DC    X'4000'                 SPACE SUB-STRUCTURE FLAG.
          DC    H'2'                    DOUBLE SPACE COUNT.    @YA04583
          DC    C'R '                   SPACING TYPE INDICATOR.
* STATIC TEXT SUB-STRUCTURE.                                   @YA04583
          DC    X'8400'                 EOF AND STATIC FLAGS.  @YA04583
          DC    Y(STE191B-STE191A)      STATIC TEXT LENGTH.    @YA04583
          DC    Y(STE191A-TXT19A)       STATIC TEXT OFFSET.    @YA04583
          DC    H'1'                    PRINT COLUMN.          @YA04583
          DC    Y(STE191B-STE191A)      PRINT FIELD LENGTH.    @YA04583
          DC    H'0'                    CONVERSION FLAGS  (CHAR)
* STATIC TEXT ENTRY.                                           @YA04583
STE191A   DC    C'IDC0571I CATALOG RELOAD HAS BEEN INVOKED'    @YA04583
STE191B   EQU   *                                              @YA04583
TXT19B    EQU   *                                              @YA04583
          EJECT                                                @YA04583
*                                                              @YA04583
* REPRO FSR CATALOG SIZE MESSAGE                               @YA04583
*                                                              @YA04583
TXT20     DC    Y(TXT20B-TXT20A)        LENGTH                 @YA04583
FLG20A    DC    X'8000'                 MESSAGE FLAG.          @YA04583
* DOUBLE SPACE SUB-STRUCTURE.                                  @YA04583
TXT20A    DC    X'4000'                 SPACE SUB-STRUCTURE FLAG.
          DC    H'2'                    DOUBLE SPACE COUNT.    @YA04583
          DC    C'R '                   SPACING TYPE INDICATOR.
* STATIC TEXT SUB-STRUCTURE.                                   @YA04583
          DC    X'8400'                 EOF AND STATIC FLAGS.  @YA04583
          DC    Y(STE201B-STE201A)      STATIC TEXT LENGTH.    @YA04583
          DC    Y(STE201A-TXT20A)       STATIC TEXT OFFSET.    @YA04583
          DC    H'1'                    PRINT COLUMN.          @YA04583
          DC    Y(STE201B-STE201A)      PRINT FIELD LENGTH.    @YA04583
          DC    H'0'                    CONVERSION FLAGS  (CHAR)
* STATIC TEXT ENTRY.                                           @YA04583
STE201A   DC    C'IDC3572I TARGET CATALOG IS TO SMALL TO CONTAIN TH'
          DC    C'E BACKUP CATALOG'                            @YA04583
STE201B   EQU   *                                              @YA04583
TXT20B    EQU   *                                              @YA04583
          EJECT                                                @YA04583
*                                                              @YA04583
* REPRO FSR CATALOG AGREEMENT MESSAGE                          @YA04583
*                                                              @YA04583
TXT21     DC    Y(TXT21B-TXT21A)        LENGTH                 @YA04583
FLG21A    DC    X'8000'                 MESSAGE FLAG.          @YA04583
* DOUBLE SPACE SUB-STRUCTURE.                                  @YA04583
TXT21A    DC    X'4000'                 SPACE SUB-STRUCTURE FLAG.
          DC    H'2'                    DOUBLE SPACE COUNT.    @YA04583
          DC    C'R '                   SPACING TYPE INDICATOR.
* STATIC TEXT SUB-STRUCTURE.                                   @YA04583
          DC    X'0400'                 STATIC FLAGS.          @Y30SSEC
          DC    Y(STE211B-STE211A)      STATIC TEXT LENGTH.    @YA04583
          DC    Y(STE211A-TXT21A)       STATIC TEXT OFFSET.    @YA04583
          DC    H'1'                    PRINT COLUMN.          @YA04583
          DC    Y(STE211B-STE211A)      PRINT FIELD LENGTH.    @YA04583
          DC    H'0'                    CONVERSION FLAGS  (CHAR)
* BLOCK DATA SUB-STRUCTURE.                                    @Y30LSEC
          DC    X'1000'                 BLOCK FLAGS.           @Y30LSEC
          DC    H'6'                    BLOCK DATA LENGTH      @Y30LSEC
          DC    H'0'                    INPUT OFFSET.          @Y30LSEC
          DC    H'10'                   PRINT COLUMN.          @Y30LSEC
          DC    H'6'                    PRINT FIELD LENGTH     @Y30LSEC
          DC    H'0'                    CONVERSION FLAGS(CHAR) @Y30LSEC
* STATIC TEXT SUB-STRUCTURE.                                   @Y30LSEC
          DC    X'8400'                 STATIC FLAGS.          @Y30LSEC
          DC    Y(STE212B-STE212A)      STATIC TEXT LENGTH.    @Y30LSEC
          DC    Y(STE212A-TXT21A)       STATIC TEXT OFFSET.    @Y30LSEC
          DC    H'1'                    PRINT COLUMN OFFSET.   @Y30LSEC
          DC    Y(STE212B-STE212A)      PRINT FIELD LENGTH.    @Y30LSEC
          DC    X'0010'                 CONVERSION FLAGS  (CHAR,BS)
* STATIC TEXT ENTRY.                                           @YA04583
STE211A   DC    C'IDC3573I '                                   @Y30LSEC
STE211B   EQU   *                                              @Y30LSEC
STE212A   DC    C' OF BACKUP AND TARGET CATALOG DO NOT AGREE'  @Y30LSEC
STE212B   EQU   *                                              @Y30LSEC
TXT21B    EQU   *                                              @YA04583
          EJECT                                                @YA04583
*                                                              @YA04583
* REPRO FSR COMPARE FUNCTION TERMINATION MESSAGE               @YA04583
*                                                              @YA04583
TXT22     DC    Y(TXT22B-TXT22A)        LENGTH                 @YA04583
FLG22A    DC    X'8000'                 MESSAGE FLAG.          @YA04583
* DOUBLE SPACE SUB-STRUCTURE.                                  @YA04583
TXT22A    DC    X'4000'                 SPACE SUB-STRUCTURE FLAG.
          DC    H'1'                    SINGLE SPACE COUNT.    @YA04583
          DC    C'R '                   SPACING TYPE INDICATOR.
* STATIC TEXT SUB-STRUCTURE.                                   @YA04583
          DC    X'8400'                 EOF AND STATIC FLAGS.  @YA04583
          DC    Y(STE221B-STE221A)      STATIC TEXT LENGTH.    @YA04583
          DC    Y(STE221A-TXT22A)       STATIC TEXT OFFSET.    @YA04583
          DC    H'1'                    PRINT COLUMN.          @YA04583
          DC    Y(STE221B-STE221A)      PRINT FIELD LENGTH.    @YA04583
          DC    H'0'                    CONVERSION FLAGS  (CHAR)
* STATIC TEXT ENTRY.                                           @YA04583
STE221A   DC    C'IDC1574I CATALOG ENTRY COMPARISO'            @YA04583
          DC    C'N NO LONGER FUNCTIONING'                     @YA04583
STE221B   EQU   *                                              @YA04583
TXT22B    EQU   *                                              @YA04583
          EJECT                                                @YA04583
*                                                              @YA04583
* REPRO FSR TRUENAME COMPARISON MESSAGE                        @YA04583
*                                                              @YA04583
TXT23     DC    Y(TXT23B-TXT23A)        LENGTH                 @YA04583
FLG23A    DC    X'8000'                 MESSAGE FLAG.          @YA04583
* DOUBLE SPACE SUB-STRUCTURE.                                  @YA04583
TXT23A    DC    X'4000'                 SPACE SUB-STRUCTURE FLAG.
          DC    H'1'                    SINGLE SPACE COUNT.    @YA04583
          DC    C'R '                   SPACING TYPE INDICATOR.
* STATIC TEXT SUB-STRUCTURE.                                   @YA04583
          DC    X'0400'                 EOF AND STATIC FLAGS.  @YA04583
          DC    Y(STE231B-STE231A)      STATIC TEXT LENGTH.    @YA04583
          DC    Y(STE231A-TXT23A)       STATIC TEXT OFFSET.    @YA04583
          DC    H'1'                    PRINT COLUMN.          @YA04583
          DC    Y(STE231B-STE231A)      PRINT FIELD LENGTH.    @YA04583
          DC    H'0'                    CONVERSION FLAGS  (CHAR)
*                                                              @YA04583
*INSERT DATA SUB STRUCTURE                                     @YA04583
*                                                              @YA04583
          DC    X'2000'                 INSERT DATA FLAGS      @YA04583
          DC    H'1'                    INSERT REFERENCE       @YA04583
          DC    H'0'                    UNUSED                 @YA04583
          DC    H'31'                   PRINT COLUMN           @YA04583
          DC    H'0'                    DEFAULT                @YA04583
          DC    X'0000'                 CONVERSION FLAGS       @YA04583
*                                                              @YA04583
*INSERT DATA SUB STRUCTURE                                     @YA04583
*                                                              @YA04583
          DC    X'A000'                 INSERT DATA FLAGS      @YA04583
          DC    H'2'                    INSERT REFERENCE       @YA04583
          DC    H'0'                    UNUSED                 @YA04583
          DC    H'15'                   PRINT COLUMN           @YA04583
          DC    H'0'                    DEFAULT                @YA04583
          DC    X'0000'                 CONVERSION FLAGS       @YA04583
* STATIC TEXT ENTRY.                                           @YA04583
STE231A   DC    C'IDC1575I ONLY XXXXXX DEFINES'                @YA04583
STE231B   EQU   *                                              @YA04583
TXT23B    EQU   *                                              @YA04583
          EJECT                                                @Y30SSEC
*                                                              @Y30SSEC
* REPRO CATALOG COPY FUNCTION TERMINATION MESSAGE              @Y30SSEC
*                                                              @Y30SSEC
TXT24     DC    Y(TXT24B-TXT24A)        LENGTH                 @Y30SSEC
FLG24A    DC    X'8000'                 MESSAGE FLAG.          @Y30SSEC
* DOUBLE SPACE SUB-STRUCTURE.                                  @Y30SSEC
TXT24A    DC    X'4000'                 SPACE SUB-STRUCTURE FLAG.
          DC    H'1'                    SINGLE SPACE COUNT.    @Y30SSEC
          DC    C'R '                   SPACING TYPE INDICATOR.
* STATIC TEXT SUB-STRUCTURE.                                   @Y30SSEC
          DC    X'8400'                 EOF AND STATIC FLAGS.  @Y30SSEC
          DC    Y(STE241B-STE241A)      STATIC TEXT LENGTH.    @Y30SSEC
          DC    Y(STE241A-TXT24A)       STATIC TEXT OFFSET.    @Y30SSEC
          DC    H'1'                    PRINT COLUMN.          @Y30SSEC
          DC    Y(STE241B-STE241A)      PRINT FIELD LENGTH.    @Y30SSEC
          DC    H'0'                    CONVERSION FLAGS  (CHAR)
* STATIC TEXT ENTRY.                                           @Y30SSEC
STE241A   DC    C'IDC3584I RECOVERABLE CATALOGS CAN NOT BE '   @Y30SSEC
          DC    C'COPIED.'                                     @Y30SSEC
STE241B   EQU   *                                              @Y30SSEC
TXT24B    EQU   *                                              @Y30SSEC
          END
