     TITLE  '***** IDCTSRC0 - EXPORTRA STATIC TEXT *****'
* /* START OF SPECIFICATIONS ****
*
*01*  MODULE-NAME = IDCTSRC0
*01*  MODULE-TYPE = MODULE
*02*    PROCESSOR = ASSEMBLER
*
**** END OF SPECIFICATIONS ****/
**********************************************************************
*                                                                    *
* MODULE NAME - IDCTSRC0 - STATIC TEXT MODULE FOR EXPORTRA           *
*                                                                    *
* DESCRIPTIVE NAME - STATIC TEXT MODULE FOR THE FUNCTION EXPORTRA    *
*                                                                    *
* COPYRIGHT - NONE                                                   *
*                                                                    *
* STATUS - RELEASE 2  LEVEL 0                                        *
*                                                                    *
* FUNCTION - CONTAINS NO EXECUTABLE CODE, ONLY STATIC TEXT ENTRIES   *
*        FOR THE FUNCTION EXPORT                                     *
*        THIS MODULE IS LOADED BY IDCTP05 WHEN A STATIC TEXT         *
*        REQUEST IS MADE.                                            *
*                                                                    *
* NOTES - NONE                                                       *
*                                                                    *
*    DEPENDENCIES - NONE                                             *
*    RESTRICTIONS - NONE                                             *
*    REGISTER CONVENTIONS - NA                                       *
*    PATCH AREA - NA                                                 *
*                                                                    *
* MODULE TYPE - TABLES                                               *
*                                                                    *
*    PROCESSOR - ASSEMBLER                                           *
*    MODULE SIZE - 1800 BYTES                                        *
*                                                                    *
*  ENTRY POINT - NA                                                  *
*                                                                    *
*  EXIT NORMAL - NA                                                  *
*                                                                    *
*  EXIT ERROR - NA                                                   *
*                                                                    *
*  EXTERNAL REFERENCES - NA                                          *
*                                                                    *
*  TABLES - NA                                                       *
*                                                                    *
*  MACROS - NA                                                       *
*                                                                    *
* CHANGE ACTIVITY                                                    *
* A031000,042640-043130,376000,405000                        @OZ25036*
*                                                                    *
*                                                                    *
**********************************************************************
*
**********************************************************************
*                                                                    *
* THIS MODULE IS THE FIRST MODULE OF STATIC TEXT REQUIRED BY THE     *
* EXPORTRA FUNCTIONAL SUPPORT ROUTINES.                              *
*                                                                    *
**********************************************************************
*
IDCTSRC0 CSECT
*
* THIS SECTIONS CONTAINS THE INDICES TO REACH AN ENTRY.
*
INDEX    DC  AL2((LASTINDX-INDEX1)/2)  COUNT OF ENTRIES       @OZ25036
INDEX1   DC  Y(TXT1-INDEX)             DATA SET NOT EXPORTED
INDEX2   DC  Y(TXT2-INDEX)             DATA SET EXPORTED(MINOR ERRORS)
INDEX3   DC  Y(TXT3-INDEX)             ENTRY TYPE NOT VALID
INDEX4   DC  Y(TXT3-INDEX)             OUT OF SYNC EXPORT(MINOR ERRORS)
INDEX5   DC  Y(TXT5-INDEX)             GOOD PORTABLE DATA SET
INDEX6   DC  Y(TXT6-INDEX)             OUT-OF-SYNC DATA SET EXPORTED
INDEX7   DC  Y(TXT7-INDEX)             OUT-OF-SYNC DATA SET BYPASSED
INDEX8   DC  Y(TXT8-INDEX)             PATH, ALIAS, ASSOCIATION ERROR
INDEX9   DC  Y(TXT9-INDEX)             CATALOG ASSOCIATION FIELD ERROR
INDEX10  DC  Y(TXT10-INDEX)            UNUSED
INDEX11  DC  Y(TXT11-INDEX)            ENTRY NAME CANNOT BE FOUND
INDEX12  DC  Y(TXT12-INDEX)            VOLUME OUT-OF-SYNC
INDEX13  DC  Y(TXT13-INDEX)            REQUIRED VOLUME NOT SUPPLIED
INDEX14  DC  Y(TXT14-INDEX)            EXPORTING FROM CRA ON VOLUME
INDEX15  DC  Y(TXT15-INDEX)            DATA SET SUCCESSFULLY EXPORTED
INDEX16  DC  Y(TXT16-INDEX)            CRA NOT PROCESSED
INDEX17  DC  Y(TXT17-INDEX)            LOCKED ON CATALOG
INDEX18  DC  Y(TXT18-INDEX)            UNABLE TO REFERENCE CRA
INDEX19  DC  Y(TXT19-INDEX)            CONFLICTING JCL SPECIFICATIONS
INDEX20  DC  Y(TXT20-INDEX)            DSNAME
INDEX21  DC  Y(TXT21-INDEX)            DUPLICATE NAME ENCOUNTERED
INDEX22  DC  Y(TXT22-INDEX)            ERROR REFERENCIND CRA
INDEX23  DC  Y(TXT23-INDEX)            EMPTY DATA SET
INDEX24  DC  Y(TXT24-INDEX)            UNUSEABLE DATA SET     @OZ25036
INDEX25  DC  Y(TXT25-INDEX)            VOLUME REFER NO OBJECT REFER
*                                                             @OZ25036
**********************************************************************
*                                      INSERT ALL INDEX       @OZ25036
LASTINDX EQU  *                        NUMBERS BEFORE THIS    @OZ25036
*                                      BOX                    @OZ25036
**********************************************************************
*
         EJECT
*
**********************************************************************
*                                                                    *
* THIS SECTION CONTAINS THE ENTRIES.                                 *
*                                                                    *
**********************************************************************
*
* DATA SET NOT EXPORTED
*
TXT1     DC  Y(TXT1B-TXT1A)            ENTRY LENGTH.
         DC  X'8000'                   MESSAGE FLAG.
* DOUBLE SPACE SUB-STRUCTURE.
TXT1A    DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
         DC  H'1'                      SPACING FACTOR
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'8400'                   STATIC TEXT FLAG.
         DC  Y(STE11B-STE11A)          STATIC TEXT LENGTH.
         DC  Y(STE11A-TXT1A)           STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE11B-STE11A)          PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS. (CHAR)
* STATIC TEXT ENTRY.
STE11A   DC  C'IDC2677I ** DATA SET NOT EXPORTED'
STE11B   EQU *
TXT1B    EQU *
         EJECT
*
* DATA SET EXPORTED WITH MINOR ERRORS
*
TXT2     DC  Y(TXT2B-TXT2A)            ENTRY LENGTH.
         DC  X'8000'                   MESSAGE FLAG.
* DOUBLE SPACE SUB-STRUCTURE.
TXT2A    DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
         DC  H'1'                      SPACING FACTOR
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'8400'                   STATIC TEXT FLAG.
         DC  Y(STE21B-STE21A)          STATIC TEXT LENGTH.
         DC  Y(STE21A-TXT2A)           STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE21B-STE21A)          PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS. (CHAR)
* STATIC TEXT ENTRY.
STE21A   DC  C'IDC1678I ** DATA SET EXPORTED WITH MINOR ERRORS'
STE21B   EQU *
TXT2B    EQU *
         EJECT
*
* CATALOG ENTRY TYPE IS INVALID.
*
TXT3     DC  Y(TXT3B-TXT3A)            ENTRY LENGTH.
         DC  X'8000'                   MESSAGE FLAG.
* DOUBLE SPACE SUB-STRUCTURE.
TXT3A    DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
         DC  H'2'                      SPACING FACTOR
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'8400'                   STATIC TEXT FLAG.
         DC  Y(STE31B-STE31A)          STATIC TEXT LENGTH.
         DC  Y(STE31A-TXT3A)           STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE31B-STE31A)          PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS. (CHAR)
* STATIC TEXT ENTRY.
STE31A   DC  C'IDC2660I INVALID ENTRY TYPE IN CATALOG, OBJECT BYPASSED'
STE31B   EQU *
TXT3B    EQU *
         EJECT
*
* OUT OF SYNC DATA SET EXPORTED WITH MINOR ERRORS
*
TXT4     DC  Y(TXT4B-TXT4A)            ENTRY LENGTH.
         DC  X'8000'                   MESSAGE FLAG.
* DOUBLE SPACE SUB-STRUCTURE.
TXT4A    DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
         DC  H'1'                      SPACING FACTOR
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'8400'                   STATIC TEXT FLAG.
         DC  Y(STE41B-STE41A)          STATIC TEXT LENGTH.
         DC  Y(STE41A-TXT4A)           STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE41B-STE41A)          PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS. (CHAR)
* STATIC TEXT ENTRY.
STE41A   DC  C'IDC1679I ** OUT-OF-SYNC DATA SET EXPORTED WITH MINOR '
         DC  C'ERRORS'
STE41B   EQU *
TXT4B    EQU *
         EJECT
*
* PORTABLE DATA SET CREATED SUCCESSFULLY ON DATE AT TIME.
*
TXT5     DC  Y(TXT5B-TXT5A)            ENTRY LENGTH.
         DC  X'8000'                   MESSAGE FLAG.
* DOUBLE SPACE SUB-STRUCTURE.
TXT5A   DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
         DC  H'2'                      SPACING FACTOR
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC TEXT FLAG.
         DC  Y(STE51B-STE51A)          STATIC TEXT LENGTH.
         DC  Y(STE51A-TXT5A)           STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE51B-STE51A)          PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS. (CHAR)
* INSERT DATA SUB-STRUCTURE.
         DC  X'2000'                   BLOCK DATA FLAG.
         DC  H'1'                      REFERENCE NUMBER
         DC  H'0'                      UNUSED
         DC  H'52'                     PRINT COLUMN.
         DC  H'8'                      PRINT FIELD LENGTH.
         DC  X'0000'                   CONVERSION FLAG.  (CHAR)
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC & EOF FLAGS.
         DC  Y(STE52B-STE52A)          STATIC TEXT LENGTH.
         DC  Y(STE52A-TXT5A)           STATIC TEXT OFFSET.
         DC  H'61'                     PRINT COLUMN OFFSET.
         DC  Y(STE52B-STE52A)          PRINT FIELD LENGTH.
         DC  X'0000'                   CONVERSION FLAG.  (CHAR)
* BLOCK DATA SUB-STRUCTURE.
         DC  X'A000'                   BLOCK DATA FLAG.
         DC  H'2'                      REFERENCE NUMBER
         DC  H'0'                      UNUSED
         DC  H'64'                     PRINT COLUMN.
         DC  H'8'                      PRINT FIELD LENGTH.
         DC  X'0000'                   CONVERSION FLAGS.  (CHAR)
* STATIC TEXT ENTRY.
STE51A   DC  C'IDC0676I PORTABLE DATA SET CREATED SUCCESSFULLY ON'
STE51B   EQU *
STE52A   DC  C'AT'
STE52B   EQU *
TXT5B    EQU *
         EJECT
*
* OUT-OF-SYNC DATA SET SUCCESSFULLY EXPORTED
*
TXT6     DC  Y(TXT6B-TXT6A)            ENTRY LENGTH.
         DC  X'8000'                   MESSAGE FLAG.
* DOUBLE SPACE SUB-STRUCTURE.
TXT6A    DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
         DC  H'2'                      SPACING FACTOR
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'8400'                   STATIC TEXT FLAG.
         DC  Y(STE61B-STE61A)          STATIC TEXT LENGTH.
         DC  Y(STE61A-TXT6A)           STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE61B-STE61A)          PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS. (CHAR)
* STATIC TEXT ENTRY.
STE61A   DC  C'IDC1661I OUT-OF-SYNC DATA SET SUCCESSFULLY EXPORTED '
         DC  C'( BY FORCE )'
STE61B   EQU *
TXT6B    EQU *
         EJECT
*
* OUT-OF-SYNC DATA SET NOT EXPORTED
*
TXT7     DC  Y(TXT7B-TXT7A)            ENTRY LENGTH.
         DC  X'8000'                   MESSAGE FLAG.
* DOUBLE SPACE SUB-STRUCTURE.
TXT7A    DC  X'4000'                   SPACE SUB-STRUCTURE
         DC  H'1'                      SPACING FACTOR
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'8400'                   STATIC TEXT FLAG.
         DC  Y(STE71B-STE71A)          STATIC TEXT LENGTH.
         DC  Y(STE71A-TXT7A)           STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE71B-STE71A)          PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS. (CHAR)
* STATIC TEXT ENTRY.
STE71A   DC  C'IDC1662I ** OUT-OF-SYNC DATA SET NOT EXPORTED'
STE71B   EQU *
TXT7B    EQU *
         EJECT
*
* ERROR PROCESSING A PATH, OR ALIAS, OR GENERATION DATA SET
*
TXT8     DC  Y(TXT8B-TXT8A)            ENTRY LENGTH.
         DC  X'8000'                   MESSAGE FLAG.
* DOUBLE SPACE SUB-STRUCTURE.
TXT8A   DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
         DC  H'2'                      SPACING FACTOR
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC TEXT FLAG.
         DC  Y(STE81B-STE81A)          STATIC TEXT LENGTH.
         DC  Y(STE81A-TXT8A)           STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE81B-STE81A)          PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS. (CHAR)
* BLOCK DATA SUB-STRUCTURE.
         DC  X'9000'                   BLOCK DATA FLAG.
         DC  H'44'                     INPUT LENGTH
         DC  H'0'                      INPUT OFFSET
         DC  H'28'                     PRINT COLUMN.
         DC  H'44'                     PRINT FIELD LENGTH.
         DC  X'0000'                   CONVERSION FLAG.  (CHAR)
* STATIC TEXT ENTRY.
STE81A   DC  C'IDC1663I BYPASSED RELATION'
STE81B   EQU *
TXT8B    EQU *
         EJECT
*
* INVALID OR NO ASSOCIATION FIELD IN CATALOG
*
TXT9     DC  Y(TXT9B-TXT9A)            ENTRY LENGTH.
         DC  X'8000'                   MESSAGE FLAG.
* DOUBLE SPACE SUB-STRUCTURE.
TXT9A   DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
         DC  H'2'                      SPACING FACTOR
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC TEXT FLAG.
         DC  Y(STE91B-STE91A)          STATIC TEXT LENGTH.
         DC  Y(STE91A-TXT9A)           STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE91B-STE91A)          PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS. (CHAR)
* BLOCK DATA SUB-STRUCTURE.
         DC  X'9000'                   BLOCK DATA FLAG.
         DC  H'44'                     INPUT LENGTH
         DC  H'0'                      INPUT OFFSET
         DC  H'28'                     PRINT COLUMN.
         DC  H'44'                     PRINT FIELD LENGTH.
         DC  X'0000'                   CONVERSION FLAG.  (CHAR)
* STATIC TEXT ENTRY.
STE91A   DC  C'IDC1664I ASSOCIATION ERROR '
STE91B   EQU *
TXT9B    EQU *
         EJECT
*
* UNUSED
*
TXT10    DC  Y(TXT10B-TXT10A)          ENTRY LENGTH.
         DC  X'8000'                   MESSAGE FLAG.
* DOUBLE SPACE SUB-STRUCTURE.
TXT10A   DC  X'4000'                   SPACE SUB-STRUCTURE
*                                      FLAG.
         DC  H'2'                      SPACING FACTOR
         DC  C'R '                     SPACING TYPE.
TXT10B   EQU *
         EJECT
*
* ENTRY NAME SPECIFIED CANNOT BE FOUND
*
TXT11    DC  Y(TXT11B-TXT11A)          ENTRY LENGTH.
         DC  X'8000'                   MESSAGE FLAG.
* DOUBLE SPACE SUB-STRUCTURE.
TXT11A   DC  X'4000'                   SPACE SUB-STRUCTURE
*                                      FLAG.
         DC  H'2'                      SPACING FACTOR
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'8400'                   STATIC TEXT FLAG.
         DC  Y(STE111B-STE111A)        STATIC TEXT LENGTH.
         DC  Y(STE111A-TXT11A)         STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE111B-STE111A)        PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS. (CHAR)
* STATIC TEXT ENTRY.
STE111A  DC  C'IDC2666I ENTRY NAME SPECIFIED CANNOT BE FOUND IN '
         DC  C'SPECIFIED CRA '
STE111B  EQU *
TXT11B   EQU *
         EJECT
*
* VOLUME OUT OF SYNC WITH VOLUME
*
TXT12    DC  Y(TXT12B-TXT12A)          ENTRY LENGTH.
         DC  X'8000'                   MESSAGE FLAG.
* DOUBLE SPACE SUB-STRUCTURE.
TXT12A   DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
         DC  H'2'                      SPACING FACTOR
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC TEXT FLAG.
         DC  Y(STE121B-STE121A)        STATIC TEXT LENGTH.
         DC  Y(STE121A-TXT12A)         STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE121B-STE121A)        PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS. (CHAR)
* INSERT DATA SUB-STRUCTURE.
         DC  X'2000'                   BLOCK DATA FLAG.
         DC  H'1'                      REFERENCE NUMBER
         DC  H'0'                      UNUSED
         DC  H'17'                     PRINT COLUMN.
         DC  H'6'                      PRINT FIELD LENGTH.
         DC  X'0000'                   CONVERSION FLAG.  (CHAR)
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC TEXT FLAG.
         DC  Y(STE122B-STE122A)        STATIC TEXT LENGTH.
         DC  Y(STE122A-TXT12A)         STATIC TEXT OFFSET.
         DC  H'23'                     PRINT COLUMN.
         DC  Y(STE122B-STE122A)        PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS. (CHAR)
* INSERT DATA SUB-STRUCTURE.
         DC  X'A000'                   BLOCK DATA FLAG.
         DC  H'2'                      REFERENCE NUMBER
         DC  H'0'                      UNUSED
         DC  H'61'                     PRINT COLUMN.
         DC  H'6'                      PRINT FIELD LENGTH.
         DC  X'0000'                   CONVERSION FLAG.  (CHAR)
* STATIC TEXT ENTRY.
STE121A  DC  C'IDC1667I VOLUME '
STE121B  EQU *
STE122A  DC  C' IS OUT-OF-SYNC AND LATER THAN VOLUME '
STE122B  EQU *
TXT12B   EQU *
         EJECT
*
* REQUIRED VOLUME NOT SUPPLIED
*
TXT13    DC  Y(TXT13B-TXT13A)          ENTRY LENGTH.
         DC  X'8000'                   MESSAGE FLAG.
* DOUBLE SPACE SUB-STRUCTURE.
TXT13A   DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
         DC  H'2'                      SPACING FACTOR
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC TEXT FLAG.
         DC  Y(STE131B-STE131A)        STATIC TEXT LENGTH.
         DC  Y(STE131A-TXT13A)         STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE131B-STE131A)        PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS. (CHAR)
* BLOCK DATA SUB-STRUCTURE.
         DC  X'1000'                   BLOCK DATA FLAG.
         DC  H'6'                      INPUT LENGTH
         DC  H'0'                      INPUT OFFSET
         DC  H'40'                     PRINT COLUMN.
         DC  H'6'                      PRINT FIELD LENGTH.
         DC  X'0000'                   CONVERSION FLAG.  (CHAR)
* STATIC TEXT SUB-STRUCTURE.
         DC  X'8400'                   STATIC TEXT FLAG.
         DC  Y(STE132B-STE132A)        STATIC TEXT LENGTH.
         DC  Y(STE132A-TXT13A)         STATIC TEXT OFFSET.
         DC  H'46'                     PRINT COLUMN.
         DC  Y(STE132B-STE132A)        PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS. (CHAR)
* STATIC TEXT ENTRY.
STE131A  DC  C'IDC2668I DATA SET NOT EXPORTED, VOLUME '
STE131B  EQU *
STE132A  DC  C' REQUIRED BUT NOT SUPPLIED '
STE132B  EQU *
TXT13B   EQU *
         EJECT
*
* EXPORTING FROM CRA ON VOLUME
*
TXT14    DC  Y(TXT14B-TXT14A)          ENTRY LENGTH.
         DC  X'8000'                   MESSAGE FLAG.
* DOUBLE SPACE SUB-STRUCTURE.
TXT14A  DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
         DC  H'2'                      SPACING FACTOR
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC TEXT FLAG.
         DC  Y(STE141B-STE141A)        STATIC TEXT LENGTH.
         DC  Y(STE141A-TXT14A)         STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE141B-STE141A)        PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS. (CHAR)
* BLOCK DATA SUB-STRUCTURE.
         DC  X'9000'                   BLOCK DATA FLAG.
         DC  H'6'                      INPUT LENGTH
         DC  H'0'                      INPUT OFFSET
         DC  H'39'                     PRINT COLUMN.
         DC  H'6'                      PRINT FIELD LENGTH.
         DC  X'0000'                   CONVERSION FLAG.  (CHAR)
* STATIC TEXT ENTRY.
STE141A  DC  C'IDC0669I EXPORTING FROM CRA ON VOLUME '
STE141B  EQU *
TXT14B   EQU *
         EJECT
*
* DATA SET SUCCESSFULLY EXPORTED
*
TXT15    DC  Y(TXT15B-TXT15A)          ENTRY LENGTH.
         DC  X'8000'                   MESSAGE FLAG.
* DOUBLE SPACE SUB-STRUCTURE.
TXT15A   DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
         DC  H'2'                      SPACING FACTOR
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'8400'                   STATIC TEXT FLAG.
         DC  Y(STE151B-STE151A)        STATIC TEXT LENGTH.
         DC  Y(STE151A-TXT15A)         STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE151B-STE151A)        PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS. (CHAR)
* STATIC TEXT ENTRY.
STE151A  DC  C'IDC0670I DATA SET SUCCESSFULLY EXPORTED'
STE151B  EQU *
TXT15B   EQU *
         EJECT
*
* CRA NOT PROCESSED, DIFFERENT CATALOG NAME
*
TXT16    DC  Y(TXT16B-TXT16A)          ENTRY LENGTH.
         DC  X'8000'                   MESSAGE FLAG.
* DOUBLE SPACE SUB-STRUCTURE.
TXT16A   DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
         DC  H'2'                      SPACING FACTOR
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC TEXT FLAG.
         DC  Y(STE161B-STE161A)        STATIC TEXT LENGTH.
         DC  Y(STE161A-TXT16A)         STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE161B-STE161A)        PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS. (CHAR)
* BLOCK DATA SUB-STRUCTURE.
         DC  X'1000'                   BLOCK DATA FLAG.
         DC  H'6'                      INPUT LENGTH
         DC  H'0'                      INPUT OFFSET
         DC  H'41'                     PRINT COLUMN.
         DC  H'6'                      PRINT FIELD LENGTH.
         DC  X'0000'                   CONVERSION FLAG.  (CHAR)
* STATIC TEXT SUB-STRUCTURE.
         DC  X'8400'                   STATIC TEXT FLAG.
         DC  Y(STE162B-STE162A)        STATIC TEXT LENGTH.
         DC  Y(STE162A-TXT16A)         STATIC TEXT OFFSET.
         DC  H'47'                     PRINT COLUMN.
         DC  Y(STE162B-STE162A)        PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS. (CHAR)
* STATIC TEXT ENTRY.
STE161A  DC  C'IDC2671I WILL NOT PROCESS CRA ON VOLUME '
STE161B  EQU *
STE162A  DC  C', DIFFERENT CATALOG NAME '
STE162B  EQU *
TXT16B   EQU *
         EJECT
*
* LOCKED ON CATALOG
*
TXT17    DC  Y(TXT17B-TXT17A)          ENTRY LENGTH.
         DC  X'8000'                   MESSAGE FLAG.
* DOUBLE SPACE SUB-STRUCTURE.
TXT17A   DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
         DC  H'2'                      SPACING FACTOR
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC TEXT FLAG.
         DC  Y(STE171B-STE171A)        STATIC TEXT LENGTH.
         DC  Y(STE171A-TXT17A)         STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE171B-STE171A)        PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS. (CHAR)
* BLOCK DATA SUB-STRUCTURE.
         DC  X'9000'                   BLOCK DATA FLAG.
         DC  H'44'                     INPUT LENGTH
         DC  H'0'                      INPUT OFFSET
         DC  H'31'                     PRINT COLUMN.
         DC  H'44'                     PRINT FIELD LENGTH.
         DC  X'0000'                   CONVERSION FLAG.  (CHAR)
* STATIC TEXT ENTRY.
STE171A  DC  C'IDC0672I ** LOCKED ON CATALOG '
STE171B  EQU *
TXT17B   EQU *
         EJECT
*
* UNABLE TO REFERENCE CRA
*
TXT18    DC  Y(TXT18B-TXT18A)          ENTRY LENGTH.
         DC  X'8000'                   MESSAGE FLAG.
* DOUBLE SPACE SUB-STRUCTURE.
TXT18A   DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
         DC  H'2'                      SPACING FACTOR
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC TEXT FLAG.
         DC  Y(STE181B-STE181A)        STATIC TEXT LENGTH.
         DC  Y(STE181A-TXT18A)         STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE181B-STE181A)        PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS. (CHAR)
* INSERT DATA SUB-STRUCTURE.
         DC  X'2000'                   INSERT DATA FLAG.
         DC  H'1'                      REFERENCE NUMBER
         DC  H'0'                      UNUSED
         DC  H'44'                     PRINT COLUMN.
         DC  H'6'                      PRINT FIELD LENGTH.
         DC  X'0000'                   CONVERSION FLAG.  (CHAR)
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC TEXT FLAG.
         DC  Y(STE182B-STE182A)        STATIC TEXT LENGTH.
         DC  Y(STE182A-TXT18A)         STATIC TEXT OFFSET.
         DC  H'50'                     PRINT COLUMN.
         DC  Y(STE182B-STE182A)        PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS. (CHAR)
* INSERT DATA SUB-STRUCTURE.
         DC  X'A000'                   INSERT AND EOF DATA FLAG.
         DC  H'2'                      REFERENCE NUMBER
         DC  H'0'                      UNUSED
         DC  H'65'                     PRINT COLUMN.
         DC  H'2'                      PRINT FIELD LENGTH.
         DC  X'0000'                   CONVERSION FLAG.  (CHAR)
* STATIC TEXT ENTRY.
STE181A  DC  C'IDC2886I UNABLE TO REFERENCE CRA ON VOLUME '
STE181B  EQU *
STE182A  DC  C' - REASON CODE '
STE182B  EQU *
TXT18B   EQU *
         EJECT
*
* CONFLICTING JCL SPECIFICATIONS
*
TXT19    DC  Y(TXT19B-TXT19A)          ENTRY LENGTH.
         DC  X'8000'                   MESSAGE FLAG.
* DOUBLE SPACE SUB-STRUCTURE.
TXT19A   DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
         DC  H'2'                      SPACING FACTOR
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC TEXT FLAG.
         DC  Y(STE191B-STE191A)        STATIC TEXT LENGTH.
         DC  Y(STE191A-TXT19A)         STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE191B-STE191A)        PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS. (CHAR)
* BLOCK DATA SUB-STRUCTURE.
         DC  X'9000'                   BLOCK DATA FLAG.
         DC  H'44'                     INPUT LENGTH
         DC  H'0'                      INPUT OFFSET
         DC  H'51'                     PRINT COLUMN.
         DC  H'8'                      PRINT FIELD LENGTH.
         DC  X'0000'                   CONVERSION FLAG.  (CHAR)
* STATIC TEXT ENTRY.
STE191A  DC  C'IDC2673I CONFLICTING JCL SPECIFICATIONS FOR DNAME '
STE191B  EQU *
TXT19B   EQU *
         EJECT
*
* NAME
*
TXT20    DC  Y(TXT20B-TXT20A)          ENTRY LENGTH.
         DC  X'8000'                   MESSAGE FLAG.
* DOUBLE SPACE SUB-STRUCTURE.
TXT20A   DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
         DC  H'1'                      SPACING FACTOR
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC TEXT FLAG.
         DC  Y(STE201B-STE201A)        STATIC TEXT LENGTH.
         DC  Y(STE201A-TXT20A)         STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE201B-STE201A)        PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS. (CHAR)
* BLOCK DATA SUB-STRUCTURE.
         DC  X'9000'                   BLOCK DATA FLAG.
         DC  H'44'                     INPUT LENGTH
         DC  H'0'                      INPUT OFFSET
         DC  H'21'                     PRINT COLUMN.
         DC  H'44'                     PRINT FIELD LENGTH.
         DC  X'0000'                   CONVERSION FLAG.  (CHAR)
* STATIC TEXT ENTRY.
STE201A  DC  C'IDC0674I ** NAME IS '
STE201B  EQU *
TXT20B   EQU *
         EJECT
*
* DUPLICATE NAME
*
TXT21    DC  Y(TXT21B-TXT21A)          ENTRY LENGTH.
         DC  X'8000'                   MESSAGE FLAG.
* DOUBLE SPACE SUB-STRUCTURE.
TXT21A   DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
         DC  H'2'                      SPACING FACTOR
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC TEXT FLAG.
         DC  Y(STE211B-STE211A)        STATIC TEXT LENGTH.
         DC  Y(STE211A-TXT21A)         STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE211B-STE211A)        PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS. (CHAR)
* BLOCK DATA SUB-STRUCTURE.
         DC  X'1000'                   BLOCK DATA FLAG.
         DC  H'6'                      INPUT LENGTH
         DC  H'0'                      INPUT OFFSET
         DC  H'53'                     PRINT COLUMN.
         DC  H'6'                      PRINT FIELD LENGTH.
         DC  X'0000'                   CONVERSION FLAG.  (CHAR)
* STATIC TEXT SUB-STRUCTURE.
         DC  X'8400'                   STATIC TEXT FLAG.
         DC  Y(STE212B-STE212A)        STATIC TEXT LENGTH.
         DC  Y(STE212A-TXT21A)         STATIC TEXT OFFSET.
         DC  H'59'                     PRINT COLUMN.
         DC  Y(STE212B-STE212A)        PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS. (CHAR)
* STATIC TEXT ENTRY.
STE211A  DC  C'IDC2675I DUPLICATE NAME ENCOUNTERED, NAME ON VOLUME '
STE211B  EQU *
STE212A  DC  C' BYPASSED'
STE212B  EQU *
TXT21B   EQU *
         EJECT
*
* ERROR REFERENCING CRA
*
TXT22    DC  Y(TXT22B-TXT22A)          ENTRY LENGTH.
         DC  X'8000'                   MESSAGE FLAG.
* DOUBLE SPACE SUB-STRUCTURE.
TXT22A   DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
         DC  H'2'                      SPACING FACTOR
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC TEXT FLAG.
         DC  Y(STE221B-STE221A)        STATIC TEXT LENGTH.
         DC  Y(STE221A-TXT22A)         STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE221B-STE221A)        PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS. (CHAR)
* INSERT DATA SUB-STRUCTURE.
         DC  X'2000'                   INSERT DATA FLAG.
         DC  H'1'                      REFERENCE NUMBER
         DC  H'0'                      UNUSED
         DC  H'42'                     PRINT COLUMN.
         DC  H'6'                      PRINT FIELD LENGTH.
         DC  X'0000'                   CONVERSION FLAG.  (CHAR)
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC TEXT FLAG.
         DC  Y(STE222B-STE222A)        STATIC TEXT LENGTH.
         DC  Y(STE222A-TXT22A)         STATIC TEXT OFFSET.
         DC  H'48'                     PRINT COLUMN.
         DC  Y(STE222B-STE222A)        PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS. (CHAR)
* INSERT DATA SUB-STRUCTURE.
         DC  X'A000'                   INSERT AND EOF DATA FLAG.
         DC  H'2'                      REFERENCE NUMBER
         DC  H'0'                      UNUSED
         DC  H'63'                     PRINT COLUMN.
         DC  H'2'                      PRINT FIELD LENGTH.
         DC  X'0000'                   CONVERSION FLAG.  (CHAR)
* STATIC TEXT ENTRY.
STE221A  DC  C'IDC1887I ERROR REFERENCING CRA ON VOLUME '
STE221B  EQU *
STE222A  DC  C' - REASON CODE '
STE222B  EQU *
TXT22B   EQU *
         EJECT
*
* EMPTY DATA SET
*
TXT23    DC  Y(TXT23B-TXT23A)          ENTRY LENGTH.
         DC  X'8000'                   MESSAGE FLAG.
* DOUBLE SPACE SUB-STRUCTURE.
TXT23A   DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
         DC  H'1'                      SPACING FACTOR
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'8400'                   STATIC TEXT FLAG.
         DC  Y(STE231B-STE231A)        STATIC TEXT LENGTH.
         DC  Y(STE231A-TXT23A)         STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE231B-STE231A)        PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS. (CHAR)
* STATIC TEXT ENTRY.
STE231A  DC  C'IDC0888I ** ENTRY CONTAINS NO DATA RECORDS '
STE231B  EQU *
TXT23B   EQU *
         EJECT
*                                                              @OZ25036
* UNUSABLE DATA SET NOT EXPORTED                               @OZ25036
*                                                              @OZ25036
TXT24    DC  Y(TXT24B-TXT24A)          ENTRY LENGTH.           @OZ25036
         DC  X'8000'                   MESSAGE FLAG.           @OZ25036
* DOUBLE SPACE SUB-STRUCTURE.                                  @OZ25036
TXT24A   DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
*                                                              @OZ25036
         DC  H'2'                      SPACING FACTOR          @OZ25036
         DC  C'R '                     SPACING TYPE.           @OZ25036
* STATIC TEXT SUB-STRUCTURE.                                   @OZ25036
         DC  X'8400'                   STATIC TEXT FLAG.       @OZ25036
         DC  Y(STE241B-STE241A)        STATIC TEXT LENGTH.     @OZ25036
         DC  Y(STE241A-TXT24A)         STATIC TEXT OFFSET.     @OZ25036
         DC  H'1'                      PRINT COLUMN.           @OZ25036
         DC  Y(STE241B-STE241A)        PRINT FIELD LENGTH.     @OZ25036
         DC  H'0'                      CONVERSION FLAGS.(CHAR) @OZ25036
* STATIC TEXT ENTRY.                                           @OZ25036
STE241A  DC  C'IDC2889I UNUSEABLE DATA SET NOT EXPORTED'       @OZ25036
STE241B  EQU *                                                 @OZ25036
TXT24B   EQU *                                                 @OZ25036
         EJECT                                                 @OZ25036
*                                                              @OZ25036
* INVALID REFERENCE TO VOLUME XXXXXX OBJECT BYPASSED           @OZ25036
*                                                              @OZ25036
TXT25    DC  Y(TXT25B-TXT25A)          ENTRY LENGTH.           @OZ25036
         DC  X'8000'                   MESSAGE FLAG.           @OZ25036
* DOUBLE SPACE SUB-STRUCTURE.                                  @OZ25036
TXT25A   DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
*                                                              @OZ25036
         DC  H'2'                      SPACING FACTOR          @OZ25036
         DC  C'R '                     SPACING TYPE.           @OZ25036
* STATIC TEXT SUB-STRUCTURE.                                   @OZ25036
         DC  X'0400'                   STATIC TEXT FLAG.       @OZ25036
         DC  Y(STE251B-STE251A)        STATIC TEXT LENGTH.     @OZ25036
         DC  Y(STE251A-TXT25A)         STATIC TEXT OFFSET.     @OZ25036
         DC  H'1'                      PRINT COLUMN.           @OZ25036
         DC  Y(STE251B-STE251A)        PRINT FIELD LENGTH.     @OZ25036
         DC  H'0'                      CONVERSION FLAGS.(CHAR) @OZ25036
* BLOCK DATA SUB-STRUCTURE.                                    @OZ25036
         DC  X'1000'                   BLOCK DATA FLAG.        @OZ25036
         DC  H'6'                      INPUT LENGTH            @OZ25036
         DC  H'0'                      INPUT OFFSET            @OZ25036
         DC  H'38'                     PRINT COLUMN.           @OZ25036
         DC  H'6'                      PRINT FIELD LENGTH.     @OZ25036
         DC  X'0000'                   CONVERSION FLAG.(CHAR)  @OZ25036
* STATIC TEXT SUB-STRUCTURE.                                   @OZ25036
         DC  X'8400'                   STATIC TEXT FLAG.       @OZ25036
         DC  Y(STE252B-STE252A)        STATIC TEXT LENGTH.     @OZ25036
         DC  Y(STE252A-TXT25A)         STATIC TEXT OFFSET.     @OZ25036
         DC  H'44'                     PRINT COLUMN.           @OZ25036
         DC  Y(STE252B-STE252A)        PRINT FIELD LENGTH.     @OZ25036
         DC  H'0'                      CONVERSION FLAGS.(CHAR) @OZ25036
* STATIC TEXT ENTRY.                                           @OZ25036
STE251A  DC  C'IDC2160I INVALID REFERENCE TO VOLUME '          @OZ25036
STE251B  EQU *                                                 @OZ25036
STE252A  DC  C', OBJECT BYPASSED '                             @OZ25036
STE252B  EQU *                                                 @OZ25036
TXT25B   EQU *                                                 @OZ25036
         EJECT                                                 @OZ25036
         END
