* /* START OF SPECIFICATIONS ****
*
*01*  MODULE-NAME = IDCTSRI1
*01*  MODULE-TYPE = MODULE
*02*    PROCESSOR = ASSEMBLER
*
**** END OF SPECIFICATIONS ***/
*
       TITLE '*** IDCTSRI1 - R/I S/A STATIC TEXT FOR TSO ***'  @Y30SSFR
**********************************************************************
*                                                                    *
* MODULE NAME - IDCTSRI1                                       @YL026UL
*                                                                    *
* DESCRIPTIVE NAME - STATIC TEXT MODULE FOR THE READER         @YL026UL
*                    INTERPRETER AND THE SYSTEM ADAPTER TO     @YL026UL
*                    BE USED IN THE TSO ENVIRONMENT            @YL026UL
*                                                                    *
* COPYRIGHT - NONE                                                   *
*                                                                    *
* STATUS - RELEASE=1.5  LEVEL 0                                @YL026UL
*                                                                    *
* FUNCTION - CONTAINS NO EXECUTABLE CODE, ONLY STATIC TEXT     @YL026UL
*        ENTRIES FOR THE R/I AND S/A USED IN THE TSO           @YL026UL
*        ENVIRONMENT. THIS MODULE IS LOADED BY IDCTP05 WHEN    @YL026UL
*        A STATIC TEXT REQUEST IS MADE.                        @YL026UL
*                                                                    *
* NOTES - NONE                                                       *
*                                                                    *
*    DEPENDENCIES - NONE                                             *
*    RESTRICTIONS - NONE                                             *
*    REGISTER CONVENTIONS - NA                                       *
*    PATCH AREA - NA                                                 *
*                                                                    *
* MODULE TYPE - TABLES                                               *
*                                                                    *
*    PROCESSOR - ASSEMBLER                                           *
*    MODULE SIZE - 1250 DECIMAL BYTES                          @YL026UL
*    ATTRIBUTES - READ-ONLY                                          *
*                                                                    *
*  ENTRY POINT - NA                                                  *
*                                                                    *
*  EXIT NORMAL - NA                                                  *
*                                                                    *
*  EXIT ERROR - NA                                                   *
*                                                                    *
*  EXTERNAL REFERENCES - NA                                          *
*                                                                    *
*  TABLES - NA                                                       *
*                                                                    *
*  MACROS - NA                                                       *
*                                                                    *
* CHANGE ACTIVITY - NONE                                             *
*                                                                    *
**********************************************************************
*
*********************************************************************
*                                                                    *
* THIS MODULE IS THE ONLY MODULE OF STATIC TEXT REQUIRED BY    @YL026UL
* THE READER INTERPRETER USED IN THE TSO ENVIRONMENT. THIS     @YL026UL
* MODULE IS THE ONLY MODULE OF STATIC TEXT REQUIRED BY THE     @YL026UL
* TSO PORTION OF THE SYSTEM ADAPTER.                           @YL026UL
*                                                                    *
*********************************************************************
*
*
IDCTSRI1  CSECT                                                @YL026UL
*
*********************************************************************
*                                                                    *
* THIS SECTION OF CODE CONTAINS THE INDICIES REQUIRED TO REACH       *
* THE STATIC TEXT ENTRIES.                                           *
*                                                                    *
*********************************************************************
*                                                              @YL026UL
INDEX    DC H'17'                      NUMBER OF ENTRIES       @Y30SSFR
INDEX1   DC Y(TXT1-INDEX)              NUMBER OUT OF RANGE     @YL026UL
INDEX2   DC Y(TXT2-INDEX)              INVALID NAME            @YL026UL
INDEX3   DC Y(TXT3-INDEX)              STRING TOO LONG         @YL026UL
INDEX4   DC Y(TXT4-INDEX)              STRING LIST TOO LONG    @YL026UL
INDEX5   DC Y(TXT5-INDEX)              CONFLICTING PARMS #1    @YL026UL
INDEX6   DC Y(TXT6-INDEX)              MISSING PARAMETER       @YL026UL
INDEX7   DC Y(TXT7-INDEX)              NUMERIC LIST TOO LONG   @YL026UL
INDEX8   DC Y(TXT8-INDEX)              PARM CONFLICT PROMPT    @YL026UL
INDEX9   DC Y(TXT9-INDEX)              BAD DATA ITEM PROMPT    @YL026UL
INDEX10  DC Y(TXT10-INDEX)             TOO LONG A LIST PROMPT  @YL026UL
INDEX11  DC Y(TXT11-INDEX)             CONFLICTING PARMS #2    @YL026UL
INDEX12  DC Y(TXT12-INDEX)             PUTGET ERROR            @YL026UL
INDEX13  DC Y(TXT13-INDEX)             DSN QUALIFYING ERROR    @YL026UL
INDEX14  DC Y(TXT14-INDEX)             TSO DEFAULT ERROR       @YL026UL
INDEX15  DC Y(TXT15-INDEX)             REPETITION IDENT.       @YL026UL
INDEX16  DC Y(TXT16-INDEX)             EXTRANEOUS DATA CODED   @YL026UL
INDEX17  DC Y(TXT17-INDEX)             MISSING PARAMETER       @Y30SSFR
         EJECT                                                 @YL026UL
**********************************************************************
*                                                                    *
* THIS SECTION OF CODE CONTAINS THE TEXT STRUCTURE ENTRIES           *
*                                                                    *
**********************************************************************
*                                                              @YL026UL
*                                                              @YL026UL
* NUMERIC VALUE NOT WITHIN ALLOWABLE VALUE RANGE               @YL026UL
*                                                              @YL026UL
TXT1     DC Y(TXT1B-TXT1A)             ENTRY LENGTH            @YL026UL
FLG1A    DC X'8000'                    MESSAGE FLAG            @YL026UL
* STATIC TEXT SUBSTRUCTURE                                     @YL026UL
TXT1A    DC X'0400'                    STATIC TEXT FLAG        @YL026UL
         DC Y(STE11B-STE11A)           STATIC TEXT LENGTH      @YL026UL
         DC Y(STE11A-TXT1A)            STATIC TEXT OFFSET      @YL026UL
         DC H'1'                                               @YL026UL
         DC Y(STE11B-STE11A)           PRINT FIELD LENGTH      @YL026UL
         DC H'0'                                               @YL026UL
* BLOCK DATA SUBSTRUCTURE                                      @YL026UL
         DC X'1000'                    BLOCK DATA FLAG         @YL026UL
         DC H'20'                      INPUT DATA LENGTH       @YL026UL
         DC H'0'                       INPUT DATA OFFSET       @YL026UL
         DC H'0'                       OUTPUT PRINT OFFSET     @YL026UL
         DC H'20'                      OUTPUT PRINT LENGTH     @YL026UL
         DC X'0010'                    CONVERSION (CHAR,BS)    @YL026UL
* STATIC TEXT SUBSTRUCTURE                                     @YL026UL
         DC X'0400'                    STATIC TEXT FLAG        @YL026UL
         DC Y(STE12B-STE12A)           STATIC TEXT LENGTH      @YL026UL
         DC Y(STE12A-TXT1A)            STATIC TEXT OFFSET      @YL026UL
         DC H'0'                                               @YL026UL
         DC Y(STE12B-STE12A)           PRINT FIELD LENGTH      @YL026UL
         DC X'0010'                    CONVERSION (CHAR,BS)    @YL026UL
* BLOCK DATA SUBSTRUCTURE                                      @YL026UL
         DC X'1000'                    BLOCK DATA FLAG         @YL026UL
         DC H'4'                       INPUT DATA LENGTH       @YL026UL
         DC H'20'                      INPUT DATA OFFSET       @YL026UL
         DC H'0'                       OUTPUT PRINT OFFSET     @YL026UL
         DC H'11'                      OUTPUT PRINT LENGTH     @YL026UL
         DC X'1050'                    CONVERT FLAGS (BD,BS)   @YL026UL
* STATIC TEXT SUBSTRUCTURE                                     @YL026UL
         DC X'8400'                    STATIC TEXT FLAG        @YL026UL
         DC Y(STE13B-STE13A)           STATIC TEXT LENGTH      @YL026UL
         DC Y(STE13A-TXT1A)            STATIC TEXT OFFSET      @YL026UL
         DC H'0'                                               @Y30SSFR
         DC Y(STE13B-STE13A)           PRINT FIELD LENGTH      @YL026UL
         DC X'0010'                    CONVERSION (CHAR,BS)    @YL026UL
* STATIC TEXT ENTRY                                            @YL026UL
STE11A   DC C'IDC3240I '''                                     @YL026UL
STE11B   EQU *                                                 @YL026UL
STE12A   DC C''' VALUE OF '''                                  @YL026UL
STE12B   EQU *                                                 @YL026UL
STE13A   DC C''' OUT OF RANGE'                                 @YL026UL
STE13B   EQU *                                                 @YL026UL
TXT1B    EQU *                                                 @YL026UL
         EJECT                                                 @YL026UL
*                                                              @YL026UL
*                                                              @YL026UL
* NAME DOES NOT ADHERE TO NAMING RESTRICTIONS                  @YL026UL
*                                                              @YL026UL
TXT2     DC Y(TXT2B-TXT2A)             ENTRY LENGTH            @YL026UL
FLG2A    DC X'8000'                    MESSAGE FLAG            @YL026UL
* STATIC TEXT SUBSTRUCTURE                                     @YL026UL
TXT2A    DC X'0400'                    STATIC TEXT FLAG        @YL026UL
         DC Y(STE21B-STE21A)           STATIC TEXT LENGTH      @YL026UL
         DC Y(STE21A-TXT2A)            STATIC TEXT OFFSET      @YL026UL
         DC H'1'                                               @YL026UL
         DC Y(STE21B-STE21A)           PRINT FIELD LENGTH      @YL026UL
         DC H'0'                                               @YL026UL
* BLOCK DATA SUBSTRUCTURE                                      @YL026UL
         DC X'1000'                    BLOCK DATA FLAG         @YL026UL
         DC H'20'                      INPUT DATA LENGTH       @YL026UL
         DC H'0'                       INPUT DATA OFFSET       @YL026UL
         DC H'0'                       OUTPUT PRINT OFFSET     @YL026UL
         DC H'20'                      OUTPUT PRINT LENGTH     @YL026UL
         DC X'0010'                    CONVERSION (CHAR,BS)    @YL026UL
* STATIC TEXT SUBSTRUCTURE                                     @YL026UL
         DC X'0400'                    STATIC TEXT FLAG        @YL026UL
         DC Y(STE22B-STE22A)           STATIC TEXT LENGTH      @YL026UL
         DC Y(STE22A-TXT2A)            STATIC TEXT OFFSET      @YL026UL
         DC H'0'                                               @YL026UL
         DC Y(STE22B-STE22A)           PRINT FIELD LENGTH      @YL026UL
         DC X'0010'                    CONVERSION (CHAR,BS)    @YL026UL
* BLOCK DATA SUBSTRUCTURE                                      @YL026UL
         DC X'9000'                    BLOCK DATA FLAG         @YL026UL
         DC H'64'                      INPUT DATA LENGTH       @YL026UL
         DC H'20'                      INPUT DATA OFFSET       @YL026UL
         DC H'0'                       OUTPUT PRINT OFFSET     @YL026UL
         DC H'64'                      OUTPUT PRINT LENGTH     @YL026UL
         DC X'0010'                    CONVERSION (CHAR,BS)    @YL026UL
* STATIC TEXT ENTRY                                            @YL026UL
STE21A   DC C'IDC3241I INVALID '''                             @YL026UL
STE21B   EQU *                                                 @YL026UL
STE22A   DC C''' NAME - '''                                    @YL026UL
STE22B   EQU *                                                 @YL026UL
TXT2B    EQU *                                                 @YL026UL
         EJECT                                                 @YL026UL
*                                                              @YL026UL
*                                                              @YL026UL
* STRING CONSTANT EXCEEDS LENGTH LIMIT                         @YL026UL
*                                                              @YL026UL
TXT3     DC Y(TXT3B-TXT3A)             ENTRY LENGTH            @YL026UL
FLG3A    DC X'8000'                    MESSAGE FLAG            @YL026UL
* STATIC TEXT SUBSTRUCTURE                                     @YL026UL
TXT3A    DC X'0400'                    STATIC TEXT FLAG        @YL026UL
         DC Y(STE31B-STE31A)           STATIC TEXT LENGTH      @YL026UL
         DC Y(STE31A-TXT3A)            STATIC TEXT OFFSET      @YL026UL
         DC H'1'                                               @YL026UL
         DC Y(STE31B-STE31A)           PRINT FIELD LENGTH      @YL026UL
         DC H'0'                                               @YL026UL
* BLOCK DATA SUBSTRUCTURE                                      @YL026UL
         DC X'1000'                    BLOCK DATA FLAG         @YL026UL
         DC H'20'                      INPUT DATA LENGTH       @YL026UL
         DC H'0'                       INPUT DATA OFFSET       @YL026UL
         DC H'0'                       OUTPUT PRINT OFFSET     @YL026UL
         DC H'20'                      OUTPUT PRINT LENGTH     @YL026UL
         DC X'0010'                    CONVERSION (CHAR,BS)    @YL026UL
* STATIC TEXT SUBSTRUCTURE                                     @YL026UL
         DC X'0400'                    STATIC TEXT FLAG        @YL026UL
         DC Y(STE32B-STE32A)           STATIC TEXT LENGTH      @YL026UL
         DC Y(STE32A-TXT3A)            STATIC TEXT OFFSET      @YL026UL
         DC H'0'                                               @YL026UL
         DC Y(STE32B-STE32A)           PRINT FIELD LENGTH      @YL026UL
         DC X'0010'                    CONVERSION (CHAR,BS)    @YL026UL
* BLOCK DATA SUBSTRUCTURE                                      @YL026UL
         DC X'9000'                    BLOCK DATA FLAG         @YL026UL
         DC H'64'                      INPUT DATA LENGTH       @YL026UL
         DC H'20'                      INPUT DATA OFFSET       @YL026UL
         DC H'1'                       OUTPUT PRINT OFFSET     @YL026UL
         DC H'64'                      OUTPUT PRINT LENGTH     @YL026UL
         DC X'0010'                    CONVERSION (CHAR,BS)    @YL026UL
* STATIC TEXT ENTRY                                            @YL026UL
STE31A   DC C'IDC3242I '''                                     @YL026UL
STE31B   EQU *                                                 @YL026UL
STE32A   DC C''' VALUE HAS INVALID LENGTH - '                  @YL026UL
STE32B   EQU *                                                 @YL026UL
TXT3B    EQU *                                                 @YL026UL
         EJECT                                                 @YL026UL
*                                                              @YL026UL
*                                                              @YL026UL
* TOO MANY ELEMENTS IN A NON-NUMERIC LIST                      @YL026UL
*                                                              @YL026UL
TXT4     DC Y(TXT4B-TXT4A)             ENTRY LENGTH            @YL026UL
FLG4A    DC X'8000'                    MESSAGE FLAG            @YL026UL
* STATIC TEXT SUBSTRUCTURE                                     @YL026UL
TXT4A    DC X'0400'                    STATIC TEXT FLAG        @YL026UL
         DC Y(STE41B-STE41A)           STATIC TEXT LENGTH      @YL026UL
         DC Y(STE41A-TXT4A)            STATIC TEXT OFFSET      @YL026UL
         DC H'1'                                               @YL026UL
         DC Y(STE41B-STE41A)           PRINT FIELD LENGTH      @YL026UL
         DC H'0'                                               @YL026UL
* BLOCK DATA SUBSTRUCTURE                                      @YL026UL
         DC X'1000'                    BLOCK DATA FLAG         @YL026UL
         DC H'20'                      INPUT DATA LENGTH       @YL026UL
         DC H'0'                       INPUT DATA OFFSET       @YL026UL
         DC H'0'                       OUTPUT PRINT OFFSET     @YL026UL
         DC H'20'                      OUTPUT PRINT LENGTH     @YL026UL
         DC X'0010'                    CONVERSION (CHAR,BS)    @YL026UL
* STATIC TEXT SUBSTRUCTURE                                     @YL026UL
         DC X'0400'                    STATIC TEXT FLAG        @YL026UL
         DC Y(STE42B-STE42A)           STATIC TEXT LENGTH      @YL026UL
         DC Y(STE42A-TXT4A)            STATIC TEXT OFFSET      @YL026UL
         DC H'0'                                               @YL026UL
         DC Y(STE42B-STE42A)           PRINT FIELD LENGTH      @YL026UL
         DC X'0010'                    CONVERSION (CHAR,BS)    @YL026UL
* BLOCK DATA SUBSTRUCTURE                                      @YL026UL
         DC X'9000'                    BLOCK DATA FLAG         @YL026UL
         DC H'64'                      INPUT DATA LENGTH       @YL026UL
         DC H'20'                      INPUT DATA OFFSET       @YL026UL
         DC H'1'                       OUTPUT PRINT OFFSET     @YL026UL
         DC H'64'                      OUTPUT PRINT LENGTH     @YL026UL
         DC X'0010'                    CONVERSION (CHAR,BS)    @YL026UL
* STATIC TEXT ENTRY                                            @YL026UL
STE41A   DC C'IDC3243I '''                                     @YL026UL
STE41B   EQU *                                                 @YL026UL
STE42A   DC C''' LIST TOO LONG BEGINNING AT - '                @YL026UL
STE42B   EQU *                                                 @YL026UL
TXT4B    EQU *                                                 @YL026UL
         EJECT                                                 @YL026UL
*                                                              @YL026UL
*                                                              @YL026UL
* TWO PARAMETERS ARE IN CONFLICT                               @YL026UL
*                                                              @YL026UL
TXT5     DC Y(TXT5B-TXT5A)             ENTRY LENGTH            @YL026UL
FLG5A    DC X'8000'                    MESSAGE FLAG            @YL026UL
* STATIC TEXT SUBSTRUCTURE                                     @YL026UL
TXT5A    DC X'0400'                    STATIC TEXT FLAG        @YL026UL
         DC Y(STE51B-STE51A)           STATIC TEXT LENGTH      @YL026UL
         DC Y(STE51A-TXT5A)            STATIC TEXT OFFSET      @YL026UL
         DC H'1'                                               @YL026UL
         DC Y(STE51B-STE51A)           PRINT FIELD LENGTH      @YL026UL
         DC H'0'                                               @YL026UL
* BLOCK DATA SUBSTRUCTURE                                      @YL026UL
         DC X'1000'                    BLOCK DATA FLAG         @YL026UL
         DC H'20'                      INPUT DATA LENGTH       @YL026UL
         DC H'0'                       INPUT DATA OFFSET       @YL026UL
         DC H'0'                       OUTPUT PRINT OFFSET     @YL026UL
         DC H'20'                      OUTPUT PRINT LENGTH     @YL026UL
         DC X'0010'                    CONVERSION (CHAR,BS)    @YL026UL
* STATIC TEXT SUBSTRUCTURE                                     @YL026UL
         DC X'8400'                    STATIC TEXT FLAG        @YL026UL
         DC Y(STE52B-STE52A)           STATIC TEXT LENGTH      @YL026UL
         DC Y(STE52A-TXT5A)            STATIC TEXT OFFSET      @YL026UL
         DC H'0'                                               @YL026UL
         DC Y(STE52B-STE52A)           PRINT FIELD LENGTH      @YL026UL
         DC X'0010'                    CONVERSION (CHAR,BS)    @YL026UL
* STATIC TEXT ENTRY                                            @YL026UL
STE51A   DC C'IDC3244I '''                                     @YL026UL
STE51B   EQU *                                                 @YL026UL
STE52A   DC C''' (REPLY ''1'') AND '                           @YL026UL
STE52B   EQU *                                                 @YL026UL
TXT5B    EQU *                                                 @YL026UL
         EJECT                                                 @YL026UL
*                                                              @YL026UL
*                                                              @YL026UL
* A PARAMETER IS MISSING                                       @YL026UL
*                                                              @YL026UL
TXT6     DC Y(TXT6B-TXT6A)             ENTRY LENGTH            @YL026UL
FLG6A    DC X'8000'                    MESSAGE FLAG            @YL026UL
* STATIC TEXT SUBSTRUCTURE                                     @YL026UL
TXT6A    DC X'0400'                    STATIC TEXT FLAG        @YL026UL
         DC Y(STE61B-STE61A)           STATIC TEXT LENGTH      @YL026UL
         DC Y(STE61A-TXT6A)            STATIC TEXT OFFSET      @YL026UL
         DC H'1'                                               @YL026UL
         DC Y(STE61B-STE61A)           PRINT FIELD LENGTH      @YL026UL
         DC H'0'                                               @YL026UL
* BLOCK DATA SUBSTRUCTURE                                      @YL026UL
         DC X'1000'                    BLOCK DATA FLAG         @YL026UL
         DC H'20'                      INPUT DATA LENGTH       @YL026UL
         DC H'0'                       INPUT DATA OFFSET       @YL026UL
         DC H'0'                       OUTPUT PRINT OFFSET     @YL026UL
         DC H'20'                      OUTPUT PRINT LENGTH     @YL026UL
         DC X'0010'                    CONVERSION (CHAR,BS)    @YL026UL
* STATIC TEXT SUBSTRUCTURE                                     @YL026UL
         DC X'8400'                    STATIC TEXT FLAG        @YL026UL
         DC Y(STE62B-STE62A)           STATIC TEXT LENGTH      @YL026UL
         DC Y(STE62A-TXT6A)            STATIC TEXT OFFSET      @YL026UL
         DC H'0'                                               @YL026UL
         DC Y(STE62B-STE62A)           PRINT FIELD LENGTH      @YL026UL
         DC X'0010'                    CONVERSION (CHAR,BS)    @YL026UL
* STATIC TEXT ENTRY                                            @YL026UL
STE61A   DC C'IDC3247I ENTER SUBFIELD OF KEYWORD '''           @YL026UL
STE61B   EQU *                                                 @YL026UL
STE62A   DC C''' - '                                           @YL026UL
STE62B   EQU *                                                 @YL026UL
TXT6B    EQU *                                                 @YL026UL
         EJECT                                                 @YL026UL
*                                                              @YL026UL
*                                                              @YL026UL
* TOO MANY ELEMENTS IN A NUMERIC LIST                          @YL026UL
*                                                              @YL026UL
TXT7     DC Y(TXT7B-TXT7A)             ENTRY LENGTH            @YL026UL
FLG7A    DC X'8000'                    MESSAGE FLAG            @YL026UL
* STATIC TEXT SUBSTRUCTURE                                     @YL026UL
TXT7A    DC X'0400'                    STATIC TEXT FLAG        @YL026UL
         DC Y(STE71B-STE71A)           STATIC TEXT LENGTH      @YL026UL
         DC Y(STE71A-TXT7A)            STATIC TEXT OFFSET      @YL026UL
         DC H'1'                                               @YL026UL
         DC Y(STE71B-STE71A)           PRINT FIELD LENGTH      @YL026UL
         DC H'0'                                               @YL026UL
* BLOCK DATA SUBSTRUCTURE                                      @YL026UL
         DC X'1000'                    BLOCK DATA FLAG         @YL026UL
         DC H'20'                      INPUT DATA LENGTH       @YL026UL
         DC H'0'                       INPUT DATA OFFSET       @YL026UL
         DC H'0'                       OUTPUT PRINT OFFSET     @YL026UL
         DC H'20'                      OUTPUT PRINT LENGTH     @YL026UL
         DC X'0010'                    CONVERSION (CHAR,BS)    @YL026UL
* STATIC TEXT SUBSTRUCTURE                                     @YL026UL
         DC X'0400'                    STATIC TEXT FLAG        @YL026UL
         DC Y(STE72B-STE72A)           STATIC TEXT LENGTH      @YL026UL
         DC Y(STE72A-TXT7A)            STATIC TEXT OFFSET      @YL026UL
         DC H'0'                                               @YL026UL
         DC Y(STE72B-STE72A)           PRINT FIELD LENGTH      @YL026UL
         DC X'0010'                    CONVERSION (CHAR,BS)    @YL026UL
* BLOCK DATA SUBSTRUCTURE                                      @YL026UL
         DC X'9000'                    BLOCK DATA FLAG         @YL026UL
         DC H'4'                       INPUT DATA LENGTH       @YL026UL
         DC H'20'                      INPUT DATA OFFSET       @YL026UL
         DC H'1'                       OUTPUT PRINT OFFSET     @YL026UL
         DC H'10'                      OUTPUT PRINT LENGTH     @YL026UL
         DC X'1050'                    CONVERSION (BD,BS)      @YL026UL
* STATIC TEXT ENTRY                                            @YL026UL
STE71A   DC C'IDC3248I '''                                     @YL026UL
STE71B   EQU *                                                 @YL026UL
STE72A   DC C''' LIST TOO LONG BEGINNING AT '                  @YL026UL
STE72B   EQU *                                                 @YL026UL
TXT7B    EQU *                                                 @YL026UL
         EJECT                                                 @YL026UL
*                                                              @YL026UL
*                                                              @YL026UL
* CONFLICTING PARAMETERS PROMPT MESSAGE                        @YL026UL
*                                                              @YL026UL
TXT8     DC Y(TXT8B-TXT8A)             ENTRY LENGTH            @YL026UL
FLG8A    DC X'8000'                    MESSAGE FLAG            @YL026UL
* STATIC TEXT SUBSTRUCTURE                                     @YL026UL
TXT8A    DC X'8400'                    STATIC TEXT FLAG        @YL026UL
         DC Y(STE81B-STE81A)           STATIC TEXT LENGTH      @YL026UL
         DC Y(STE81A-TXT8A)            STATIC TEXT OFFSET      @YL026UL
         DC H'1'                                               @YL026UL
         DC Y(STE81B-STE81A)           PRINT FIELD LENGTH      @YL026UL
         DC H'0'                                               @YL026UL
* STATIC TEXT ENTRY                                            @YL026UL
STE81A   DC C'IDC3246I ENTER REPLY NUMBER OF PARAMETER TO '    @YL026UL
         DC C'BE RETAINED - '                                  @YL026UL
STE81B   EQU *                                                 @YL026UL
TXT8B    EQU *                                                 @YL026UL
         EJECT                                                 @YL026UL
*                                                              @YL026UL
*                                                              @YL026UL
* BAD DATA ITEM PROMPT MESSAGE                                 @YL026UL
*                                                              @YL026UL
TXT9     DC Y(TXT9B-TXT9A)             ENTRY LENGTH            @YL026UL
FLG9A    DC X'8000'                    MESSAGE FLAG            @YL026UL
* STATIC TEXT SUBSTRUCTURE                                     @YL026UL
TXT9A    DC X'8400'                    STATIC TEXT FLAG        @YL026UL
         DC Y(STE91B-STE91A)           STATIC TEXT LENGTH      @YL026UL
         DC Y(STE91A-TXT9A)            STATIC TEXT OFFSET      @YL026UL
         DC H'1'                                               @YL026UL
         DC Y(STE91B-STE91A)           PRINT FIELD LENGTH      @YL026UL
         DC H'0'                                               @YL026UL
* STATIC TEXT ENTRY                                            @YL026UL
STE91A   DC C'IDC3249I REENTER - '                             @YL026UL
STE91B   EQU *                                                 @YL026UL
TXT9B    EQU *                                                 @YL026UL
         EJECT                                                 @YL026UL
*                                                              @YL026UL
*                                                              @YL026UL
* STRING CONSTANT EXCEEDS LENGTH LIMIT                         @YL026UL
*                                                              @YL026UL
TXT10    DC Y(TXT10B-TXT10A)           ENTRY LENGTH            @YL026UL
FLG10A   DC X'8000'                    MESSAGE FLAG            @YL026UL
* STATIC TEXT SUBSTRUCTURE                                     @YL026UL
TXT10A   DC X'8400'                    STATIC TEXT FLAG        @YL026UL
         DC Y(STE101B-STE101A)         STATIC TEXT LENGTH      @YL026UL
         DC Y(STE101A-TXT10A)          STATIC TEXT OFFSET      @YL026UL
         DC H'1'                                               @YL026UL
         DC Y(STE101B-STE101A)         PRINT FIELD LENGTH      @YL026UL
         DC H'0'                                               @YL026UL
* STATIC TEXT ENTRY                                            @YL026UL
STE101A  DC C'IDC3250I REPLY ''OK'' TO IGNORE EXCESS AND '     @YL026UL
         DC C'CONTINUE - '                                     @YL026UL
STE101B  EQU *                                                 @YL026UL
TXT10B   EQU *                                                 @YL026UL
         EJECT                                                 @YL026UL
*                                                              @YL026UL
*                                                              @YL026UL
* CONFLICTING PARAMETERS (PART 2 OF MESSAGE)                   @YL026UL
*                                                              @YL026UL
TXT11    DC Y(TXT11B-TXT11A)           ENTRY LENGTH            @YL026UL
FLG11A   DC X'A000'                    MESSAGE FLAG            @YL026UL
* STATIC TEXT SUBSTRUCTURE                                     @YL026UL
TXT11A   DC X'0400'                    STATIC TEXT FLAG        @YL026UL
         DC Y(STE111B-STE111A)         STATIC TEXT LENGTH      @YL026UL
         DC Y(STE111A-TXT11A)          STATIC TEXT OFFSET      @YL026UL
         DC H'1'                                               @YL026UL
         DC Y(STE111B-STE111A)         PRINT FIELD LENGTH      @YL026UL
         DC H'0'                                               @YL026UL
* BLOCK DATA SUBSTRUCTURE                                      @YL026UL
         DC X'1000'                    BLOCK DATA FLAG         @YL026UL
         DC H'20'                      INPUT DATA LENGTH       @YL026UL
         DC H'0'                       INPUT DATA OFFSET       @YL026UL
         DC H'0'                       OUTPUT PRINT OFFSET     @YL026UL
         DC H'20'                      OUTPUT PRINT LENGTH     @YL026UL
         DC X'0010'                    CONVERSION (CHAR,BS)    @YL026UL
* STATIC TEXT SUBSTRUCTURE                                     @YL026UL
         DC X'8400'                    STATIC TEXT FLAG        @YL026UL
         DC Y(STE112B-STE112A)         STATIC TEXT LENGTH      @YL026UL
         DC Y(STE112A-TXT11A)          STATIC TEXT OFFSET      @YL026UL
         DC H'0'                                               @YL026UL
         DC Y(STE112B-STE112A)         PRINT FIELD LENGTH      @YL026UL
         DC X'0010'                    CONVERSION (CHAR,BS)    @YL026UL
* STATIC TEXT ENTRY                                            @YL026UL
STE111A  DC C'IDC3244I '''                                     @YL026UL
STE111B  EQU *                                                 @YL026UL
STE112A  DC C''' (REPLY ''2'') ARE IN CONFLICT'                @YL026UL
STE112B  EQU *                                                 @YL026UL
TXT11B   EQU *                                                 @YL026UL
         EJECT                                                 @YL026UL
*                                                              @YL026UL
*                                                              @YL026UL
* PUTGET ERROR CODE                                            @YL026UL
*                                                              @YL026UL
TXT12    DC    Y(TXT12B-TXT12A)        ENTRY LENGTH.           @YL026UL
         DC    X'8000'                 MESSAGE FLAG.           @YL026UL
* STATIC TEXT SUB-STRUCTURE.                                   @YL026UL
TXT12A   DC    X'0400'                 STATIC TEXT FLAG.       @YL026UL
         DC    Y(STE121B-STE121A)      TEXT LENGTH.            @YL026UL
         DC    Y(STE121A-TXT12A)       TEXT OFFSET.            @YL026UL
         DC    H'1'                    PRINT COLUMN.           @YL026UL
         DC    Y(STE121B-STE121A)      PRINT FIELD LENGTH.     @YL026UL
         DC    H'0'                    CONVERSION FLAGS. (CHAR)
* BLOCK DATA SUB-STRUCTURE.                                    @YL026UL
         DC    X'9000'                 EOF AND BLOCK DATA FLAGS.
         DC    H'2'                    INPUT LENGTH.           @YL026UL
         DC    H'0'                    INPUT OFFSET.           @YL026UL
         DC    H'31'                   PRINT COLUMN.           @YL026UL
         DC    H'2'                    PRINT FIELD LENGTH.     @YL026UL
         DC    X'1060'                 CONVERSION FLAGS. (BD,AL,SS)
* STATIC TEXT ENTRIES.                                         @YL026UL
STE121A  DC    C'IDC3900I PUTGET ERROR CODE IS'                @YL026UL
STE121B  EQU   *                                               @YL026UL
TXT12B   EQU   *                                               @YL026UL
         EJECT                                                 @YL026UL
*                                                              @YL026UL
*                                                              @YL026UL
* DSN QUALIFYING ERROR                                         @YL026UL
*                                                              @YL026UL
TXT13    DC    Y(TXT13B-TXT13A)        ENTRY LENGTH.           @YL026UL
         DC    X'8000'                 MESSAGE FLAG.           @YL026UL
* STATIC TEXT SUB-STRUCTURE.                                   @YL026UL
TXT13A   DC    X'0400'                 STATIC TEXT FLAG.       @YL026UL
         DC    Y(STE131B-STE131A)      TEXT LENGTH.            @YL026UL
         DC    Y(STE131A-TXT13A)       TEXT OFFSET.            @YL026UL
         DC    H'1'                    PRINT COLUMN.           @YL026UL
         DC    Y(STE131B-STE131A)      PRINT FIELD LENGTH.     @YL026UL
         DC    H'0'                    CONVERSION FLAGS. (CHAR)
* BLOCK DATA SUB-STRUCTURE.                                    @YL026UL
         DC    X'9000'                 EOF AND BLOCK DATA FLAGS.
         DC    H'44'                   INPUT LENGTH.           @YL026UL
         DC    H'0'                    INPUT OFFSET.           @YL026UL
         DC    H'27'                   PRINT COLUMN.           @YL026UL
         DC    H'44'                   PRINT FIELD LENGTH.     @YL026UL
         DC    X'0000'                 CONVERSION FLAGS. (CHAR)
* STATIC TEXT ENTRIES.                                         @YL026UL
STE131A  DC    C'IDC3901I ERROR QUALIFYING'                    @YL026UL
STE131B  EQU   *                                               @YL026UL
TXT13B   EQU   *                                               @YL026UL
         EJECT                                                 @YL026UL
*                                                              @YL026UL
*                                                              @YL026UL
* TSO DEFAULT ERROR                                            @YL026UL
*                                                              @YL026UL
TXT14    DC    Y(TXT14B-TXT14A)        ENTRY LENGTH.           @YL026UL
         DC    X'A000'                 MESSAGE FLAG.           @YL026UL
* STATIC TEXT SUB-STRUCTURE.                                   @YL026UL
TXT14A   DC    X'0400'                 STATIC TEXT FLAG.       @YL026UL
         DC    Y(STE141B-STE141A)      TEXT LENGTH.            @YL026UL
         DC    Y(STE141A-TXT14A)       TEXT OFFSET.            @YL026UL
         DC    H'1'                    PRINT COLUMN.           @YL026UL
         DC    Y(STE141B-STE141A)      PRINT FIELD LENGTH.     @YL026UL
         DC    H'0'                    CONVERSION FLAGS. (CHAR)
* BLOCK DATA SUB-STRUCTURE.                                    @YL026UL
         DC    X'1000'                 BLOCK DATA FLAGS.       @YL026UL
         DC    H'2'                    INPUT LENGTH.           @YL026UL
         DC    H'0'                    INPUT OFFSET.           @YL026UL
         DC    H'48'                   PRINT COLUMN.           @YL026UL
         DC    H'2'                    PRINT FIELD LENGTH.     @YL026UL
         DC    X'1020'                 CONVERSION FLAGS. (BD,SS)
* BLOCK DATA SUB-STRUCTURE.                                    @YL026UL
         DC    X'9000'                 EOF AND BLOCK DATA FLAGS.
         DC    H'2'                    INPUT LENGTH.           @YL026UL
         DC    H'2'                    INPUT OFFSET.           @YL026UL
         DC    H'70'                   PRINT COLUMN.           @YL026UL
         DC    H'2'                    PRINT FIELD LENGTH.     @YL026UL
         DC    X'1060'                 CONVERSION FLAGS. (BD,AL,SS)
* STATIC TEXT ENTRIES.                                         @YL026UL
STE141A  DC    C'IDC3902I ** DEFAULT SERVICE ROUTINE ERROR '   @YL026UL
         DC    C'CODE   , LOCATE ERROR CODE'                   @YL026UL
STE141B  EQU   *                                               @YL026UL
TXT14B   EQU   *                                               @YL026UL
         EJECT                                                 @YL026UL
*                                                              @YL026UL
*                                                              @YL026UL
* SUBPARM LIST REPETITION IN WHICH ERROR IS FOUND              @YL026UL
*                                                              @YL026UL
TXT15    DC Y(TXT15B-TXT15A)           ENTRY LENGTH            @YL026UL
FLG15A   DC X'8000'                    MESSAGE FLAG            @YL026UL
* STATIC TEXT SUBSTRUCTURE                                     @YL026UL
TXT15A   DC X'0400'                    STATIC TEXT FLAG        @YL026UL
         DC Y(STE151B-STE151A)         STATIC TEXT LENGTH      @YL026UL
         DC Y(STE151A-TXT15A)          STATIC TEXT OFFSET      @YL026UL
         DC H'1'                                               @YL026UL
         DC Y(STE151B-STE151A)         PRINT FIELD LENGTH      @YL026UL
         DC H'0'                                               @YL026UL
* BLOCK DATA SUBSTRUCTURE                                      @YL026UL
         DC X'9000'                    BLOCK DATA FLAG         @YL026UL
         DC H'4'                       INPUT DATA LENGTH       @YL026UL
         DC H'0'                       INPUT DATA OFFSET       @YL026UL
         DC H'1'                       OUTPUT PRINT OFFSET     @YL026UL
         DC H'10'                      OUTPUT PRINT LENGTH     @YL026UL
         DC X'1070'                    CONVERSION (BD,BS)      @YL026UL
* STATIC TEXT ENTRY                                            @YL026UL
STE151A  DC C'IDC3251I FOR SUBFIELD REPETITION '               @YL026UL
STE151B  EQU *                                                 @YL026UL
TXT15B   EQU *                                                 @YL026UL
         EJECT                                                 @YL026UL
*                                                              @YL026UL
*                                                              @YL026UL
* EXTRANEOUS PARAMETERS WERE CODED                             @YL026UL
*                                                              @YL026UL
TXT16    DC Y(TXT16B-TXT16A)           ENTRY LENGTH            @YL026UL
FLG16A   DC X'8000'                    MESSAGE FLAG            @YL026UL
* STATIC TEXT SUBSTRUCTURE                                     @YL026UL
TXT16A   DC X'8400'                    STATIC TEXT FLAG        @YL026UL
         DC Y(STE161B-STE161A)         STATIC TEXT LENGTH      @YL026UL
         DC Y(STE161A-TXT16A)          STATIC TEXT OFFSET      @YL026UL
         DC H'1'                                               @YL026UL
         DC Y(STE161B-STE161A)         PRINT FIELD LENGTH      @YL026UL
         DC H'0'                                               @YL026UL
* STATIC TEXT ENTRY                                            @YL026UL
STE161A  DC C'IDC1252I COMMAND ALLOWS NO PARAMETERS - '        @YL026UL
         DC C'PARAMETERS IGNORED'                              @YL026UL
STE161B  EQU *                                                 @YL026UL
TXT16B   EQU *                                                 @YL026UL
         EJECT                                                 @Y30SSFR
*                                                              @Y30SSFR
*                                                              @Y30SSFR
* A PARAMETER IS MISSING (NO PROMPTING)                        @Y30SSFR
*                                                              @Y30SSFR
TXT17    DC Y(TXT17B-TXT17A)           ENTRY LENGTH            @Y30SSFR
FLG17A   DC X'8000'                    MESSAGE FLAG            @Y30SSFR
* STATIC TEXT SUBSTRUCTURE                                     @Y30SSFR
TXT17A   DC X'0400'                    STATIC TEXT FLAG        @Y30SSFR
         DC Y(STE171B-STE171A)         STATIC TEXT LENGTH      @Y30SSFR
         DC Y(STE171A-TXT17A)          STATIC TEXT OFFSET      @Y30SSFR
         DC H'1'                                               @Y30SSFR
         DC Y(STE171B-STE171A)         PRINT FIELD LENGTH      @Y30SSFR
         DC H'0'                                               @Y30SSFR
* BLOCK DATA SUBSTRUCTURE                                      @Y30SSFR
         DC X'1000'                    BLOCK DATA FLAG         @Y30SSFR
         DC H'20'                      INPUT DATA LENGTH       @Y30SSFR
         DC H'0'                       INPUT DATA OFFSET       @Y30SSFR
         DC H'0'                       OUTPUT PRINT OFFSET     @Y30SSFR
         DC H'20'                      OUTPUT PRINT LENGTH     @Y30SSFR
         DC X'0010'                    CONVERSION (CHAR,BS)    @Y30SSFR
* STATIC TEXT ENTRY                                            @Y30SSFR
STE171A  DC C'IDC3253I MISSING SUBFIELD OF KEYWORD '''         @Y30SSFR
STE171B  EQU *                                                 @Y30SSFR
TXT17B   EQU *                                                 @Y30SSFR
         END IDCTSRI1
