         TITLE '***** IDCTSRS0 - RESETCAT STATIC TEXT *****'
**********************************************************************
*                                                                    *
* MODULE NAME - IDCTSRS0 - STATIC TEXT MODULE FOR RESETCAT           *
*                                                                    *
* DESCRIPTIVE NAME - STATIC TEXT MODULE FOR THE FUNCTION RESETCAT    *
*                                                                    *
* COPYRIGHT - NONE                                                   *
*                                                                    *
* STATUS -                                                           *
*                                                                    *
* FUNCTION - CONTAINS NO EXECUTIBLE CODE, ONLY STATIC TEXT ENTRIES   *
*            FOR THE FUNCTION RESETCAT.                              *
*            THIS MODULE IS LOADED BY IDCTP05 WHEN A STATIC TEXT     *
*            REQUEST IS MADE.                                        *
*                                                                    *
* NOTES - NONE                                                       *
*                                                                    *
*    DEPENDENCIES - NONE                                             *
*    RESTRICTIONS - NONE                                             *
*    REGISTER CONVENTIONS - NA                                       *
*    PATCH AREA - NA                                                 *
*                                                                    *
* MODULE TYPE - TABLES                                               *
*                                                                    *
*    PROCESSOR - ASSEMBLER                                           *
*    MODULE SIZE -                                                   *
*    ATTRIBUTES - READ ONLY                                          *
*                                                                    *
* ENTRY POINT - NA                                                   *
*                                                                    *
*  EXIT NORMAL - NA                                                  *
*                                                                    *
*  EXIT ERROR - NA                                                   *
*                                                                    *
* EXTERNAL REFERENCES - NA                                           *
*                                                                    *
* TABLES - NA                                                        *
*                                                                    *
* MACROS - NA                                                        *
*                                                                    *
* CHANGE ACTIVITY - DELETE ENTRY 30                          @ZM43016*
*  NONVSAM/USERCATALOG MOVE                                  @ZA18274*
**********************************************************************
IDCTSRS0 CSECT
*
* THIS SECTION CONTAINS THE INDICES TO REACH AN ENTRY.               *
*
INDEX    DC  H'52'                     COUNT OF ENTRIES.       @ZA18274
INDEX1   DC  Y(TXT1-INDEX)             CAT NOT A RECOVERABLE CAT
INDEX2   DC  Y(TXT2-INDEX)             MASTER CAT SPECIFIED FOR RESET
INDEX3   DC  Y(TXT3-INDEX)             INFO- CAT SPECIFIED FOR RESET
INDEX4   DC  Y(TXT4-INDEX)             I/O ERROR ON CRA- IGNORE
INDEX5   DC  Y(TXT5-INDEX)             DEFINE OF WORKFILE FAILED
INDEX6   DC  Y(TXT6-INDEX)             W/F DEFINED IN CAT TO BE RESET
INDEX7   DC  Y(TXT7-INDEX)             PHYSICAL I/O ERROR ON THE CAT
INDEX8   DC  Y(TXT8-INDEX)             LOGICAL I/O ERROR ON THE CAT
INDEX9   DC  Y(TXT9-INDEX)             ERROR ACCESSING THE CATALOG
INDEX10  DC  Y(TXT10-INDEX)            D OR I COMPONENT DOES NOT EXIST
INDEX11  DC  Y(TXT11-INDEX)            CRA DOES NOT BELONG TO CATALOG
INDEX12  DC  Y(TXT12-INDEX)            INFO- CRA CHOSEN FOR RESET
INDEX13  DC  Y(TXT13-INDEX)            MAXIMUM RRN EXCEEDED IN W/F
INDEX14  DC  Y(TXT14-INDEX)            COULD NOT MERGE A CRA
INDEX15  DC  Y(TXT15-INDEX)            DELETE OF WORKFILE FAILED
INDEX16  DC  Y(TXT16-INDEX)            PHY I/O ERROR IN CAT - IGNORED
INDEX17  DC  Y(TXT17-INDEX)            NO CRA SPECIFIED FOR RESET
INDEX18  DC  Y(TXT18-INDEX)            UNABLE TO GET EXCL USE OF CATLG
INDEX19  DC  Y(TXT19-INDEX)            CRA VOL UNAVAILABLE
INDEX20  DC  Y(TXT20-INDEX)            CRA SPECIFIED MORE THAN ONCE
INDEX21  DC  Y(TXT21-INDEX)            UNABLE TO ALLOCATE
INDEX22  DC  Y(TXT22-INDEX)            INVALID RECORD IN SET OF RECORDS
INDEX23  DC  Y(TXT23-INDEX)            INVALID ASSOC IN SET OF RECORDS
INDEX24  DC  Y(TXT24-INDEX)            ERROR FOR ASSOCIATION
INDEX25  DC  Y(TXT25-INDEX)            INVALID ALIAS CHAIN
INDEX26  DC  Y(TXT26-INDEX)            INVALID GDG DATA SET ASSOC
INDEX27  DC  Y(TXT27-INDEX)            ENTRY DELETED
INDEX28  DC  Y(TXT28-INDEX)            CRA SPACE NOT DEFINED ON VOL
INDEX29  DC  Y(TXT29-INDEX)            CAT SPACE NOT DEFINED ON VOL
INDEX30  DC  H'-1'                     NULL ENTRY              @ZM43016
INDEX31  DC  Y(TXT31-INDEX)            SPACE MAP CORRECTED
INDEX32  DC  Y(TXT32-INDEX)            D OR I WITH INVALID SPC REQUEST
INDEX33  DC  Y(TXT33-INDEX)            UNIQUE D OR I HAS LESS EXTENTS
INDEX34  DC  Y(TXT34-INDEX)            INVALID RECORD
INDEX35  DC  Y(TXT35-INDEX)            UNIQUE DATA SET NOT SCRATCHED
INDEX36  DC  Y(TXT36-INDEX)            SPACE MAP WRONG SIZE
INDEX37  DC  Y(TXT37-INDEX)            BAD VOLUME RECORDS
INDEX38  DC  Y(TXT38-INDEX)            NO SPACE HEADER FOR DSCB
INDEX39  DC  Y(TXT39-INDEX)            SPACE HEADER CORRECTED
INDEX40  DC  Y(TXT40-INDEX)            SPACE HEADER DELETED
INDEX41  DC  Y(TXT41-INDEX)            TIMESTAMP FOR VOL RCD CORRECTED
INDEX42  DC  Y(TXT42-INDEX)            UNABLE TO SCRATCH DSCB
INDEX43  DC  Y(TXT43-INDEX)            DATA SET RENAMED
INDEX44  DC  Y(TXT44-INDEX)            UNIQUE RENAMED
INDEX45  DC  Y(TXT45-INDEX)            UNIQUE NOT RENAMED-ERROR
INDEX46  DC  Y(TXT46-INDEX)            BAD SUM TT
INDEX47  DC  Y(TXT47-INDEX)            INFO- CAT HAS BEEN RESET
INDEX48  DC  Y(TXT48-INDEX)            INVALID RECORD IN SET OF RECORDS
INDEX49  DC  Y(TXT49-INDEX)            COULD NOT UPDATE A CRA
INDEX50  DC  H'-1'                     NULL ENTRY              @ZA18274
INDEX51  DC  H'-1'                     NULL ENTRY              @ZA18274
INDEX52  DC  Y(TXT52-INDEX)            ENTRIES MOVED TO NEW CRA@ZA18274
         EJECT
*********************************************************************
*                                                                    *
* THIS SECTION CONTAINS THE ENTRIES.                                 *
*                                                                    *
*********************************************************************
*                                                                    *
* CATALOG NOT A RECOVERABLE CATALOG
*                                                                    *
TXT1     DC  Y(TXT1B-TXT1A)            ENTRY LENGTH.
         DC  X'8000'                   MESSAGE FLAG.
* SPACING CONTROL SUB-STRUCTURE.
TXT1A    DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
         DC  H'2'                      SPACING FACTOR.
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'8400'                   STATIC FLAG.
         DC  Y(STE11B-STE11A)          STATIC TEXT LENGTH.
         DC  Y(STE11A-TXT1A)           STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE11B-STE11A)          PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* STATIC TEXT ENTRIES
STE11A   DC  C'IDC31000I CATALOG NOT A RECOVERABLE CATALOG'
STE11B   EQU *
TXT1B    EQU *
         EJECT
*                                                                    *
* SYSTEM MASTER CATALOG SPECIFIED FOR RESET
*                                                                    *
TXT2     DC  Y(TXT2B-TXT2A)            ENTRY LENGTH.
         DC  X'8000'                   MESSAGE FLAG.
* SPACING CONTROL SUB-STRUCTURE.
TXT2A    DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
         DC  H'2'                      SPACING FACTOR.
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'8400'                   STATIC FLAG.
         DC  Y(STE21B-STE21A)          STATIC TEXT LENGTH.
         DC  Y(STE21A-TXT2A)           STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE21B-STE21A)          PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* STATIC TEXT ENTRIES
STE21A   DC  C'IDC31001I SYSTEM MASTER CATALOG SPECIFIED FOR RESET'
STE21B   EQU *
TXT2B    EQU *
         EJECT
*                                                                    *
* INFORMATIONAL - CATALOG SPECIFIED FOR RESET
*                                                                    *
TXT3     DC  Y(TXT3B-TXT3A)            ENTRY LENGTH.
         DC  X'8000'                   MESSAGE FLAG.
* SPACING CONTROL SUB-STRUCTURE.
TXT3A    DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
         DC  H'2'                      SPACING FACTOR.
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC FLAG.
         DC  Y(STE31B-STE31A)          STATIC TEXT LENGTH.
         DC  Y(STE31A-TXT3A)           STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE31B-STE31A)          PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* INSERT DATA SUB-STRUCTURE
         DC  X'2000'                   INSERT DATA FLAG
         DC  H'1'                      REFERENCE NUMBER
         DC  H'0'                      UNUSED
         DC  H'28'                     PRINT COLUMN
         DC  H'44'                     PRINT FIELD LENGTH
         DC  H'0'                      CONVERSION FLAGS  (CHAR)
* SPACING CONTROL SUB-STRUCTURE.
         DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
         DC  H'0'                      SPACING FACTOR.
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC FLAG.
         DC  Y(STE32B-STE32A)          STATIC TEXT LENGTH.
         DC  Y(STE32A-TXT3A)           STATIC TEXT OFFSET.
         DC  H'11'                     PRINT COLUMN.
         DC  Y(STE32B-STE32A)          PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* INSERT DATA SUB-STRUCTURE
         DC  X'2000'                   INSERT DATA FLAG
         DC  H'2'                      REFERENCE NUMBER
         DC  H'0'                      UNUSED
         DC  H'15'                     PRINT COLUMN
         DC  H'6'                      PRINT FIELD LENGTH
         DC  H'0'                      CONVERSION FLAGS  (CHAR)
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC FLAG.
         DC  Y(STE33B-STE33A)          STATIC TEXT LENGTH.
         DC  Y(STE33A-TXT3A)           STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN. (INCR)
         DC  Y(STE33B-STE33A)          PRINT FIELD LENGTH.
         DC  X'0010'                   CONVERSION FLAGS.  (CHAR,BS)
* INSERT DATA SUB-STRUCTURE
         DC  X'2000'                   INSERT DATA FLAG
         DC  H'3'                      REFERENCE NUMBER
         DC  H'0'                      UNUSED
         DC  H'1'                      PRINT COLUMN (INCR)
         DC  H'2'                      PRINT FIELD LENGTH
         DC  X'1030'                   CONVERSION FLAGS  (BD,SS,BS)
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC FLAG.
         DC  Y(STE34B-STE34A)          STATIC TEXT LENGTH.
         DC  Y(STE34A-TXT3A)           STATIC TEXT OFFSET.
         DC  H'0'                      PRINT COLUMN. (INCR)
         DC  Y(STE34B-STE34A)          PRINT FIELD LENGTH.
         DC  X'0010'                   CONVERSION FLAGS.  (CHAR,BS)
* INSERT DATA SUB-STRUCTURE
         DC  X'2000'                   INSERT DATA FLAG
         DC  H'4'                      REFERENCE NUMBER
         DC  H'0'                      UNUSED
         DC  H'0'                      PRINT COLUMN (INCR)
         DC  H'2'                      PRINT FIELD LENGTH
         DC  X'1030'                   CONVERSION FLAGS  (BD,SS,BS)
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC FLAG.
         DC  Y(STE35B-STE35A)          STATIC TEXT LENGTH.
         DC  Y(STE35A-TXT3A)           STATIC TEXT OFFSET.
         DC  H'0'                      PRINT COLUMN. (INCR)
         DC  Y(STE35B-STE35A)          PRINT FIELD LENGTH.
         DC  X'0010'                   CONVERSION FLAGS.  (CHAR,BS)
* INSERT DATA SUB-STRUCTURE
         DC  X'2000'                   INSERT DATA FLAG
         DC  H'5'                      REFERENCE NUMBER
         DC  H'0'                      UNUSED
         DC  H'0'                      PRINT COLUMN (INCR)
         DC  H'2'                      PRINT FIELD LENGTH
         DC  X'1030'                   CONVERSION FLAGS  (BD,SS,BS)
* INSERT DATA SUB-STRUCTURE
         DC  X'2000'                   INSERT DATA FLAG
         DC  H'6'                      REFERENCE NUMBER
         DC  H'0'                      UNUSED
         DC  H'1'                      PRINT COLUMN (INCR)
         DC  H'2'                      PRINT FIELD LENGTH
         DC  X'1030'                   CONVERSION FLAGS  (BD,SS,BS)
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC FLAG.
         DC  Y(STE36B-STE36A)          STATIC TEXT LENGTH.
         DC  Y(STE36A-TXT3A)           STATIC TEXT OFFSET.
         DC  H'0'                      PRINT COLUMN. (INCR)
         DC  Y(STE36B-STE36A)          PRINT FIELD LENGTH.
         DC  X'0010'                   CONVERSION FLAGS.  (CHAR,BS)
* INSERT DATA SUB-STRUCTURE
         DC  X'2000'                   INSERT DATA FLAG
         DC  H'7'                      REFERENCE NUMBER
         DC  H'0'                      UNUSED
         DC  H'0'                      PRINT COLUMN (INCR)
         DC  H'2'                      PRINT FIELD LENGTH
         DC  X'1030'                   CONVERSION FLAGS  (BD,SS,BS)
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC FLAG.
         DC  Y(STE37B-STE37A)          STATIC TEXT LENGTH.
         DC  Y(STE37A-TXT3A)           STATIC TEXT OFFSET.
         DC  H'0'                      PRINT COLUMN. (INCR)
         DC  Y(STE37B-STE37A)          PRINT FIELD LENGTH.
         DC  X'0010'                   CONVERSION FLAGS.  (CHAR,BS)
* INSERT DATA SUB-STRUCTURE
         DC  X'A000'                   INSERT DATA FLAG
         DC  H'8'                      REFERENCE NUMBER
         DC  H'0'                      UNUSED
         DC  H'0'                      PRINT COLUMN (INCR)
         DC  H'2'                      PRINT FIELD LENGTH
         DC  X'1030'                   CONVERSION FLAGS  (BD,SS,BS)
* STATIC TEXT ENTRIES
STE31A   DC  C'IDC01002I RESETCAT CATALOG'
STE31B   EQU *
STE32A   DC  C'VOL'
STE32B   EQU *
STE33A   DC  C'LEVEL'
STE33B   EQU *
STE34A   DC  C'/'
STE34B   EQU *
STE35A   DC  C'/'
STE35B   EQU *
STE36A   DC  C':'
STE36B   EQU *
STE37A   DC  C':'
STE37B   EQU *
TXT3B    EQU *
         EJECT
*                                                                    *
* I/O ERROR ON CRA - IGNORE
*                                                                    *
TXT4     DC  Y(TXT4B-TXT4A)            ENTRY LENGTH.
         DC  X'8000'                   MESSAGE FLAG.
* SPACING CONTROL SUB-STRUCTURE.
TXT4A    DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
         DC  H'2'                      SPACING FACTOR.
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC FLAG.
         DC  Y(STE41B-STE41A)          STATIC TEXT LENGTH.
         DC  Y(STE41A-TXT4A)           STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE41B-STE41A)          PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* INSERT DATA SUB-STRUCTURE
         DC  X'2000'                   INSERT DATA FLAG
         DC  H'1'                      REFERENCE NUMBER
         DC  H'0'                      UNUSED
         DC  H'28'                     PRINT COLUMN
         DC  H'6'                      PRINT FIELD LENGTH
         DC  X'8000'                   CONVERSION FLAGS  (BH)
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC FLAG.
         DC  Y(STE42B-STE42A)          STATIC TEXT LENGTH.
         DC  Y(STE42A-TXT4A)           STATIC TEXT OFFSET.
         DC  H'35'                     PRINT COLUMN.
         DC  Y(STE42B-STE42A)          PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* INSERT DATA SUB-STRUCTURE
         DC  X'A000'                   INSERT DATA FLAG
         DC  H'2'                      REFERENCE NUMBER
         DC  H'0'                      UNUSED
         DC  H'51'                     PRINT COLUMN
         DC  H'6'                      PRINT FIELD LENGTH
         DC  H'0'                      CONVERSION FLAGS  (CHAR)
* STATIC TEXT ENTRIES
STE41A   DC  C'IDC11003I CONTROL INTERVAL'
STE41B   EQU *
STE42A   DC  C'BYPASSED IN CRA'
STE42B   EQU *
TXT4B    EQU *
         EJECT
*                                                                    *
* DEFINE OF WORKFILE FAILED
*                                                                    *
TXT5     DC  Y(TXT5B-TXT5A)            ENTRY LENGTH.
         DC  X'8000'                   MESSAGE FLAG.
* SPACING CONTROL SUB-STRUCTURE.
TXT5A    DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
         DC  H'2'                      SPACING FACTOR.
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'8400'                   STATIC FLAG.
         DC  Y(STE51B-STE51A)          STATIC TEXT LENGTH.
         DC  Y(STE51A-TXT5A)           STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE51B-STE51A)          PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* STATIC TEXT ENTRIES
STE51A   DC  C'IDC31004I DEFINE OF WORKFILE FAILED'
STE51B   EQU *
TXT5B    EQU *
         EJECT
*                                                                    *
* WORKFILE DEFINED IN CATALOG TO BE RESET
*                                                                    *
TXT6     DC  Y(TXT6B-TXT6A)            ENTRY LENGTH.
         DC  X'8000'                   MESSAGE FLAG.
* SPACING CONTROL SUB-STRUCTURE.
TXT6A    DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
         DC  H'2'                      SPACING FACTOR.
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'8400'                   STATIC FLAG.
         DC  Y(STE61B-STE61A)          STATIC TEXT LENGTH.
         DC  Y(STE61A-TXT6A)           STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE61B-STE61A)          PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* STATIC TEXT ENTRIES
STE61A   DC  C'IDC31005I WORKFILE DEFINED IN THE CATALOG TO BE RESET'
STE61B   EQU *
TXT6B    EQU *
         EJECT
*                                                                    *
* PHYSICAL I/O ERROR ON THE CATALOG
*                                                                    *
TXT7     DC  Y(TXT7B-TXT7A)            ENTRY LENGTH.
         DC  X'8000'                   MESSAGE FLAG.
* SPACING CONTROL SUB-STRUCTURE.
TXT7A    DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
         DC  H'2'                      SPACING FACTOR.
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC FLAG.
         DC  Y(STE71B-STE71A)          STATIC TEXT LENGTH.
         DC  Y(STE71A-TXT7A)           STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE71B-STE71A)          PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* INSERT DATA SUB-STRUCTURE
         DC  X'2000'                   INSERT DATA FLAG
         DC  H'1'                      REFERENCE NUMBER
         DC  H'0'                      UNUSED
         DC  H'50'                     PRINT COLUMN
         DC  H'2'                      PRINT FIELD LENGTH
         DC  X'1060'                   CONVERSION FLAGS  (BD,AL,SS)
* STATIC TEXT SUB-STRUCTURE.
         DC  X'8400'                   STATIC FLAG.
         DC  Y(STE72B-STE72A)          STATIC TEXT LENGTH.
         DC  Y(STE72A-TXT7A)           STATIC TEXT OFFSET.
         DC  H'52'                     PRINT COLUMN.
         DC  Y(STE72B-STE72A)          PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* STATIC TEXT ENTRIES
STE71A   DC  C'IDC31006I PHYSICAL I/O ERROR - VSAM ACTION CODE ('
STE71B   EQU *
STE72A   DC  C')'
STE72B   EQU *
TXT7B    EQU *
         EJECT
*                                                                    *
* LOGICAL I/O ERROR ON THE CATALOG
*                                                                    *
TXT8     DC  Y(TXT8B-TXT8A)            ENTRY LENGTH.
         DC  X'8000'                   MESSAGE FLAG.
* SPACING CONTROL SUB-STRUCTURE.
TXT8A    DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
         DC  H'2'                      SPACING FACTOR.
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC FLAG.
         DC  Y(STE81B-STE81A)          STATIC TEXT LENGTH.
         DC  Y(STE81A-TXT8A)           STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE81B-STE81A)          PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* INSERT DATA SUB-STRUCTURE
         DC  X'2000'                   INSERT DATA FLAG
         DC  H'1'                      REFERENCE NUMBER
         DC  H'0'                      UNUSED
         DC  H'49'                     PRINT COLUMN
         DC  H'2'                      PRINT FIELD LENGTH
         DC  X'1060'                   CONVERSION FLAGS  (BD,AL,SS)
* STATIC TEXT SUB-STRUCTURE.
         DC  X'8400'                   STATIC FLAG.
         DC  Y(STE82B-STE82A)          STATIC TEXT LENGTH.
         DC  Y(STE82A-TXT8A)           STATIC TEXT OFFSET.
         DC  H'51'                     PRINT COLUMN.
         DC  Y(STE82B-STE82A)          PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* STATIC TEXT ENTRIES
STE81A   DC  C'IDC31007I LOGICAL I/O ERROR - VSAM ACTION CODE ('
STE81B   EQU *
STE82A   DC  C')'
STE82B   EQU *
TXT8B    EQU *
         EJECT
*                                                                    *
* ERROR ACCESSING THE CATALOG
*                                                                    *
TXT9     DC  Y(TXT9B-TXT9A)            ENTRY LENGTH.
         DC  X'8000'                   MESSAGE FLAG.
* SPACING CONTROL SUB-STRUCTURE.
TXT9A    DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
         DC  H'2'                      SPACING FACTOR.
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'8400'                   STATIC FLAG.
         DC  Y(STE91B-STE91A)          STATIC TEXT LENGTH.
         DC  Y(STE91A-TXT9A)           STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE91B-STE91A)          PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* STATIC TEXT ENTRIES
STE91A   DC  C'IDC31008I ERROR ACCESSING THE CATALOG'
STE91B   EQU *
TXT9B    EQU *
         EJECT
*                                                                    *
* D OR I COMPONENT DOES NOT EXIST ON VOLUME
*                                                                    *
TXT10    DC  Y(TXT10B-TXT10A)          ENTRY LENGTH.
         DC  X'8000'                   MESSAGE FLAG.
* SPACING CONTROL SUB-STRUCTURE.
TXT10A   DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
         DC  H'2'                      SPACING FACTOR.
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC FLAG.
         DC  Y(STE101B-STE101A)        STATIC TEXT LENGTH.
         DC  Y(STE101A-TXT10A)         STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE101B-STE101A)        PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* INSERT DATA SUB-STRUCTURE
         DC  X'2000'                   INSERT DATA FLAG
         DC  H'1'                      REFERENCE NUMBER
         DC  H'0'                      UNUSED
         DC  H'11'                     PRINT COLUMN
         DC  H'44'                     PRINT FIELD LENGTH
         DC  H'0'                      CONVERSION FLAGS  (CHAR)
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC FLAG.
         DC  Y(STE102B-STE102A)        STATIC TEXT LENGTH.
         DC  Y(STE102A-TXT10A)         STATIC TEXT OFFSET.
         DC  H'0'                      PRINT COLUMN. (INCR)
         DC  Y(STE102B-STE102A)        PRINT FIELD LENGTH.
         DC  X'0010'                   CONVERSION FLAGS.  (CHAR,BS)
* INSERT DATA SUB-STRUCTURE
         DC  X'2000'                   INSERT DATA FLAG
         DC  H'2'                      REFERENCE NUMBER
         DC  H'0'                      UNUSED
         DC  H'0'                      PRINT COLUMN
         DC  H'14'                     PRINT FIELD LENGTH
         DC  X'0010'                   CONVERSION FLAGS  (CHAR,BS)
* SPACING CONTROL SUB-STRUCTURE.
         DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
         DC  H'0'                      SPACING FACTOR.
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC FLAG.
         DC  Y(STE103B-STE103A)        STATIC TEXT LENGTH.
         DC  Y(STE103A-TXT10A)         STATIC TEXT OFFSET.
         DC  H'11'                     PRINT COLUMN.
         DC  Y(STE103B-STE103A)        PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* INSERT DATA SUB-STRUCTURE
         DC  X'A000'                   INSERT DATA FLAG
         DC  H'3'                      REFERENCE NUMBER
         DC  H'0'                      UNUSED
         DC  H'36'                     PRINT COLUMN
         DC  H'6'                      PRINT FIELD LENGTH
         DC  H'0'                      CONVERSION FLAGS  (CHAR)
* STATIC TEXT ENTRIES
STE101A  DC  C'IDC21009I'
STE101B  EQU *
STE102A  DC  C','
STE102B  EQU *
STE103A  DC  C'DOES NOT EXIST ON VOLUME'
STE103B  EQU *
TXT10B   EQU *
         EJECT
*                                                                    *
* CRA DOES NOT BELONG TO CATALOG
*                                                                    *
TXT11    DC  Y(TXT11B-TXT11A)          ENTRY LENGTH.
         DC  X'8000'                   MESSAGE FLAG.
* SPACING CONTROL SUB-STRUCTURE.
TXT11A   DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
         DC  H'2'                      SPACING FACTOR.
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC FLAG.
         DC  Y(STE111B-STE111A)        STATIC TEXT LENGTH.
         DC  Y(STE111A-TXT11A)         STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE111B-STE111A)        PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* INSERT DATA SUB-STRUCTURE
         DC  X'A000'                   INSERT DATA FLAG
         DC  H'1'                      REFERENCE NUMBER
         DC  H'0'                      UNUSED
         DC  H'48'                     PRINT COLUMN
         DC  H'6'                      PRINT FIELD LENGTH
         DC  H'0'                      CONVERSION FLAGS  (CHAR)
* STATIC TEXT ENTRIES
STE111A  DC  C'IDC31010I CRA DOES NOT BELONG TO CATALOG - VOL'
STE111B  EQU *
TXT11B   EQU *
         EJECT
*                                                                    *
* INFORMATIONAL - CRA CHOSEN FOR RESET
*                                                                    *
TXT12    DC  Y(TXT12B-TXT12A)          ENTRY LENGTH.
         DC  X'8000'                   MESSAGE FLAG.
* SPACING CONTROL SUB-STRUCTURE.
TXT12A   DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
         DC  H'2'                      SPACING FACTOR.
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC FLAG.
         DC  Y(STE121B-STE121A)        STATIC TEXT LENGTH.
         DC  Y(STE121A-TXT12A)         STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE121B-STE121A)        PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* INSERT DATA SUB-STRUCTURE
         DC  X'2000'                   INSERT DATA FLAG
         DC  H'1'                      REFERENCE NUMBER
         DC  H'0'                      UNUSED
         DC  H'38'                     PRINT COLUMN
         DC  H'6'                      PRINT FIELD LENGTH
         DC  H'0'                      CONVERSION FLAGS  (CHAR)
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC FLAG.
         DC  Y(STE122B-STE122A)        STATIC TEXT LENGTH.
         DC  Y(STE122A-TXT12A)         STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE122B-STE122A)        PRINT FIELD LENGTH.
         DC  X'0010'                   CONVERSION FLAGS.  (CHAR,BS)
* INSERT DATA SUB-STRUCTURE
         DC  X'2000'                   INSERT DATA FLAG
         DC  H'2'                      REFERENCE NUMBER
         DC  H'0'                      UNUSED
         DC  H'1'                      PRINT COLUMN
         DC  H'2'                      PRINT FIELD LENGTH
         DC  X'1030'                   CONVERSION FLAGS  (BD,SS,BS)
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC FLAG.
         DC  Y(STE123B-STE123A)        STATIC TEXT LENGTH.
         DC  Y(STE123A-TXT12A)         STATIC TEXT OFFSET.
         DC  H'0'                      PRINT COLUMN.
         DC  Y(STE123B-STE123A)        PRINT FIELD LENGTH.
         DC  X'0010'                   CONVERSION FLAGS.  (CHAR,BS)
* INSERT DATA SUB-STRUCTURE
         DC  X'2000'                   INSERT DATA FLAG
         DC  H'3'                      REFERENCE NUMBER
         DC  H'0'                      UNUSED
         DC  H'0'                      PRINT COLUMN
         DC  H'2'                      PRINT FIELD LENGTH
         DC  X'1030'                   CONVERSION FLAGS  (BD,SS,BS)
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC FLAG.
         DC  Y(STE124B-STE124A)        STATIC TEXT LENGTH.
         DC  Y(STE124A-TXT12A)         STATIC TEXT OFFSET.
         DC  H'0'                      PRINT COLUMN.
         DC  Y(STE124B-STE124A)        PRINT FIELD LENGTH.
         DC  X'0010'                   CONVERSION FLAGS.  (CHAR,BS)
* INSERT DATA SUB-STRUCTURE
         DC  X'2000'                   INSERT DATA FLAG
         DC  H'4'                      REFERENCE NUMBER
         DC  H'0'                      UNUSED
         DC  H'0'                      PRINT COLUMN
         DC  H'2'                      PRINT FIELD LENGTH
         DC  X'1030'                   CONVERSION FLAGS  (BD,SS,BS)
* INSERT DATA SUB-STRUCTURE
         DC  X'2000'                   INSERT DATA FLAG
         DC  H'5'                      REFERENCE NUMBER
         DC  H'0'                      UNUSED
         DC  H'1'                      PRINT COLUMN
         DC  H'2'                      PRINT FIELD LENGTH
         DC  X'1030'                   CONVERSION FLAGS  (BD,SS,BS)
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC FLAG.
         DC  Y(STE125B-STE125A)        STATIC TEXT LENGTH.
         DC  Y(STE125A-TXT12A)         STATIC TEXT OFFSET.
         DC  H'0'                      PRINT COLUMN.
         DC  Y(STE125B-STE125A)        PRINT FIELD LENGTH.
         DC  X'0010'                   CONVERSION FLAGS.  (CHAR,BS)
* INSERT DATA SUB-STRUCTURE
         DC  X'2000'                   INSERT DATA FLAG
         DC  H'6'                      REFERENCE NUMBER
         DC  H'0'                      UNUSED
         DC  H'0'                      PRINT COLUMN
         DC  H'2'                      PRINT FIELD LENGTH
         DC  X'1030'                   CONVERSION FLAGS  (BD,SS,BS)
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC FLAG.
         DC  Y(STE126B-STE126A)        STATIC TEXT LENGTH.
         DC  Y(STE126A-TXT12A)         STATIC TEXT OFFSET.
         DC  H'0'                      PRINT COLUMN.
         DC  Y(STE126B-STE126A)        PRINT FIELD LENGTH.
         DC  X'0010'                   CONVERSION FLAGS.  (CHAR,BS)
* INSERT DATA SUB-STRUCTURE
         DC  X'A000'                   INSERT DATA FLAG
         DC  H'7'                      REFERENCE NUMBER
         DC  H'0'                      UNUSED
         DC  H'0'                      PRINT COLUMN
         DC  H'2'                      PRINT FIELD LENGTH
         DC  X'1030'                   CONVERSION FLAGS  (BD,SS,BS)
* STATIC TEXT ENTRIES
STE121A  DC  C'IDC01011I CRA CHOSEN FOR RESET - VOL'
STE121B  EQU *
STE122A  DC  C'LEVEL'
STE122B  EQU *
STE123A  DC  C'/'
STE123B  EQU *
STE124A  DC  C'/'
STE124B  EQU *
STE125A  DC  C':'
STE125B  EQU *
STE126A  DC  C':'
STE126B  EQU *
TXT12B   EQU *
         EJECT
*                                                                    *
* MAXIMUM RRN EXCEED IN WORKFILE
*                                                                    *
TXT13    DC  Y(TXT13B-TXT13A)          ENTRY LENGTH.
         DC  X'8000'                   MESSAGE FLAG.
* SPACING CONTROL SUB-STRUCTURE.
TXT13A   DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
         DC  H'2'                      SPACING FACTOR.
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'8400'                   STATIC FLAG.
         DC  Y(STE131B-STE131A)        STATIC TEXT LENGTH.
         DC  Y(STE131A-TXT13A)         STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE131B-STE131A)        PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* STATIC TEXT ENTRIES
STE131A  DC  C'IDC31012I MAXIMUM RELATIVE RECORD NUMBER EXCEEDED IN WOR*
               KFILE'
STE131B  EQU *
TXT13B   EQU *
         EJECT
*                                                                    *
* COULD NOT MERGE ONE OR MORE CRAS
*                                                                    *
TXT14    DC  Y(TXT14B-TXT14A)          ENTRY LENGTH.
         DC  X'8000'                   MESSAGE FLAG.
* SPACING CONTROL SUB-STRUCTURE.
TXT14A   DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
         DC  H'2'                      SPACING FACTOR.
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'8400'                   STATIC FLAG.
         DC  Y(STE141B-STE141A)        STATIC TEXT LENGTH.
         DC  Y(STE141A-TXT14A)         STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE141B-STE141A)        PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* STATIC TEXT ENTRIES
STE141A  DC  C'IDC31013I COULD NOT MERGE ONE OR MORE CRAS'
STE141B  EQU *
TXT14B   EQU *
         EJECT
*                                                                    *
* DELETE OF WORKFILE FAILED
*                                                                    *
TXT15    DC  Y(TXT15B-TXT15A)          ENTRY LENGTH.
         DC  X'8000'                   MESSAGE FLAG.
* SPACING CONTROL SUB-STRUCTURE.
TXT15A   DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
         DC  H'2'                      SPACING FACTOR.
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'8400'                   STATIC FLAG.
         DC  Y(STE151B-STE151A)        STATIC TEXT LENGTH.
         DC  Y(STE151A-TXT15A)         STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE151B-STE151A)        PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* STATIC TEXT ENTRIES
STE151A  DC  C'IDC31014I DELETE OF WORKFILE FAILED'
STE151B  EQU *
TXT15B   EQU *
         EJECT
*                                                                    *
* PHYSICAL I/O ERROR IN CATALOG - IGNORED
*                                                                    *
TXT16    DC  Y(TXT16B-TXT16A)          ENTRY LENGTH.
         DC  X'8000'                   MESSAGE FLAG.
* SPACING CONTROL SUB-STRUCTURE.
TXT16A   DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
         DC  H'2'                      SPACING FACTOR.
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC FLAG.
         DC  Y(STE161B-STE161A)        STATIC TEXT LENGTH.
         DC  Y(STE161A-TXT16A)         STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE161B-STE161A)        PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* INSERT DATA SUB-STRUCTURE
         DC  X'2000'                   INSERT DATA FLAG
         DC  H'1'                      REFERENCE NUMBER
         DC  H'0'                      UNUSED
         DC  H'28'                     PRINT COLUMN
         DC  H'6'                      PRINT FIELD LENGTH
         DC  X'8000'                   CONVERSION FLAGS  (BH)
* STATIC TEXT SUB-STRUCTURE.
         DC  X'8400'                   STATIC FLAG.
         DC  Y(STE162B-STE162A)        STATIC TEXT LENGTH.
         DC  Y(STE162A-TXT16A)         STATIC TEXT OFFSET.
         DC  H'35'                     PRINT COLUMN.
         DC  Y(STE162B-STE162A)        PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* STATIC TEXT ENTRIES
STE161A  DC  C'IDC11015I CONTROL INTERVAL'
STE161B  EQU *
STE162A  DC  C'BYPASSED IN CATALOG'
STE162B  EQU *
TXT16B   EQU *
         EJECT
*                                                                    *
* NO CRA SPECIFIED FOR RESET
*                                                                    *
TXT17    DC  Y(TXT17B-TXT17A)          ENTRY LENGTH.
         DC  X'8000'                   MESSAGE FLAG.
* SPACING CONTROL SUB-STRUCTURE.
TXT17A   DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
         DC  H'2'                      SPACING FACTOR.
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'8400'                   STATIC FLAG.
         DC  Y(STE171B-STE171A)        STATIC TEXT LENGTH.
         DC  Y(STE171A-TXT17A)         STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE171B-STE171A)        PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* STATIC TEXT ENTRIES
STE171A  DC  C'IDC31016I NO CRA SPECIFIED FOR RESET'
STE171B  EQU *
TXT17B   EQU *
         EJECT
*                                                                    *
* UNABLE TO GET EXCLUSIVE USE OF THE CATALOG
*                                                                    *
TXT18    DC  Y(TXT18B-TXT18A)          ENTRY LENGTH.
         DC  X'8000'                   MESSAGE FLAG.
* SPACING CONTROL SUB-STRUCTURE.
TXT18A   DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
         DC  H'2'                      SPACING FACTOR.
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'8400'                   STATIC FLAG.
         DC  Y(STE181B-STE181A)        STATIC TEXT LENGTH.
         DC  Y(STE181A-TXT18A)         STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE181B-STE181A)        PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* STATIC TEXT ENTRIES
STE181A  DC  C'IDC31017I UNABLE TO GET EXCLUSIVE USE OF THE CATALOG'
STE181B  EQU *
TXT18B   EQU *
         EJECT
*                                                                    *
* CRA VOL NOT AVAILABLE
*                                                                    *
TXT19    DC  Y(TXT19B-TXT19A)          ENTRY LENGTH.
         DC  X'8000'                   MESSAGE FLAG.
* SPACING CONTROL SUB-STRUCTURE.
TXT19A   DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
         DC  H'2'                      SPACING FACTOR.
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'8400'                   STATIC FLAG.
         DC  Y(STE191B-STE191A)        STATIC TEXT LENGTH.
         DC  Y(STE191A-TXT19A)         STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE191B-STE191A)        PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* STATIC TEXT ENTRIES
STE191A  DC  C'IDC31018I CRA UNAVAILABLE'
STE191B  EQU *
TXT19B   EQU *
         EJECT
*                                                                    *
* CRA SPECIFIED FOR RESET MORE THAN ONCE
*                                                                    *
TXT20    DC  Y(TXT20B-TXT20A)          ENTRY LENGTH.
         DC  X'8000'                   MESSAGE FLAG.
* SPACING CONTROL SUB-STRUCTURE.
TXT20A   DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
         DC  H'2'                      SPACING FACTOR.
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC FLAG.
         DC  Y(STE201B-STE201A)        STATIC TEXT LENGTH.
         DC  Y(STE201A-TXT20A)         STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE201B-STE201A)        PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* INSERT DATA SUB-STRUCTURE
         DC  X'2000'                   INSERT DATA FLAG
         DC  H'1'                      REFERENCE NUMBER
         DC  H'0'                      UNUSED
         DC  H'15'                     PRINT COLUMN
         DC  H'6'                      PRINT FIELD LENGTH
         DC  H'0'                      CONVERSION FLAGS  (CHAR)
* STATIC TEXT SUB-STRUCTURE.
         DC  X'8400'                   STATIC FLAG.
         DC  Y(STE202B-STE202A)        STATIC TEXT LENGTH.
         DC  Y(STE202A-TXT20A)         STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE202B-STE202A)        PRINT FIELD LENGTH.
         DC  X'0010'                   CONVERSION FLAGS.  (CHAR,BS)
* STATIC TEXT ENTRIES
STE201A  DC  C'IDC31019I CRA'
STE201B  EQU *
STE202A  DC  C'SPECIFIED FOR RESET MORE THAN ONCE'
STE202B  EQU *
TXT20B   EQU *
         EJECT
*                                                                    *
* UNABLE TO ALLOCATE
*                                                                    *
TXT21    DC  Y(TXT21B-TXT21A)          ENTRY LENGTH.
         DC  X'8000'                   MESSAGE FLAG.
* SPACING CONTROL SUB-STRUCTURE.
TXT21A   DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
         DC  H'2'                      SPACING FACTOR.
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC FLAG.
         DC  Y(STE211B-STE211A)        STATIC TEXT LENGTH.
         DC  Y(STE211A-TXT21A)         STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE211B-STE211A)        PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* INSERT DATA SUB-STRUCTURE
         DC  X'A000'                   INSERT DATA FLAG
         DC  H'1'                      REFERENCE NUMBER
         DC  H'0'                      UNUSED
         DC  H'30'                     PRINT COLUMN
         DC  H'6'                      PRINT FIELD LENGTH
         DC  H'0'                      CONVERSION FLAGS  (CHAR)
* STATIC TEXT ENTRIES
STE211A  DC  C'IDC21020I UNABLE TO ALLOCATE'
STE211B  EQU *
TXT21B   EQU *
         EJECT
*                                                                    *
* INVALID RECORD IN A SET OF RECORDS
*                                                                    *
TXT22    DC  Y(TXT22B-TXT22A)          ENTRY LENGTH.
         DC  X'8000'                   MESSAGE FLAG.
* SPACING CONTROL SUB-STRUCTURE.
TXT22A   DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
         DC  H'2'                      SPACING FACTOR.
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC FLAG.
         DC  Y(STE221B-STE221A)        STATIC TEXT LENGTH.
         DC  Y(STE221A-TXT22A)         STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE221B-STE221A)        PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* INSERT DATA SUB-STRUCTURE
         DC  X'2000'                   INSERT DATA FLAG
         DC  H'1'                      REFERENCE NUMBER
         DC  H'0'                      UNUSED
         DC  H'11'                     PRINT COLUMN
         DC  H'44'                     PRINT FIELD LENGTH
         DC  H'0'                      CONVERSION FLAGS  (CHAR)
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC FLAG.
         DC  Y(STE222B-STE222A)        STATIC TEXT LENGTH.
         DC  Y(STE222A-TXT22A)         STATIC TEXT OFFSET.
         DC  H'0'                      PRINT COLUMN.
         DC  Y(STE222B-STE222A)        PRINT FIELD LENGTH.
         DC  X'0010'                   CONVERSION FLAGS.  (CHAR,BS)
* INSERT DATA SUB-STRUCTURE
         DC  X'2000'                   INSERT DATA FLAG
         DC  H'2'                      REFERENCE NUMBER
         DC  H'0'                      UNUSED
         DC  H'0'                      PRINT COLUMN
         DC  H'14'                     PRINT FIELD LENGTH
         DC  X'0010'                   CONVERSION FLAGS  (CHAR,BS)
* SPACING CONTROL SUB-STRUCTURE.
         DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
         DC  H'0'                      SPACING FACTOR.
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC FLAG.
         DC  Y(STE223B-STE223A)        STATIC TEXT LENGTH.
         DC  Y(STE223A-TXT22A)         STATIC TEXT OFFSET.
         DC  H'11'                     PRINT COLUMN.
         DC  Y(STE223B-STE223A)        PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* INSERT DATA SUB-STRUCTURE
         DC  X'2000'                   INSERT DATA FLAG
         DC  H'3'                      REFERENCE NUMBER
         DC  H'0'                      UNUSED
         DC  H'50'                     PRINT COLUMN
         DC  H'6'                      PRINT FIELD LENGTH
         DC  X'8000'                   CONVERSION FLAGS  (BH)
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC FLAG.
         DC  Y(STE224B-STE224A)        STATIC TEXT LENGTH.
         DC  Y(STE224A-TXT22A)         STATIC TEXT OFFSET.
         DC  H'56'                     PRINT COLUMN.
         DC  Y(STE224B-STE224A)        PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* INSERT DATA SUB-STRUCTURE
         DC  X'A000'                   INSERT DATA FLAG
         DC  H'4'                      REFERENCE NUMBER
         DC  H'0'                      UNUSED
         DC  H'57'                     PRINT COLUMN
         DC  H'14'                     PRINT FIELD LENGTH
         DC  H'0'                      CONVERSION FLAGS  (CHAR)
* STATIC TEXT ENTRIES
STE221A  DC  C'IDC11022I'
STE221B  EQU *
STE222A  DC  C','
STE222B  EQU *
STE223A  DC  C'CONTAINS A CONNECTOR TO INVALID RECORD'
STE223B  EQU *
STE224A  DC  C','
STE224B  EQU *
TXT22B   EQU *
         EJECT
*                                                                    *
* INVALID ASSOCIATIONS IN A SET OF RECORDS
*                                                                    *
TXT23    DC  Y(TXT23B-TXT23A)          ENTRY LENGTH.
         DC  X'8000'                   MESSAGE FLAG.
* SPACING CONTROL SUB-STRUCTURE.
TXT23A   DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
         DC  H'2'                      SPACING FACTOR.
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC FLAG.
         DC  Y(STE231B-STE231A)        STATIC TEXT LENGTH.
         DC  Y(STE231A-TXT23A)         STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE231B-STE231A)        PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* INSERT DATA SUB-STRUCTURE
         DC  X'2000'                   INSERT DATA FLAG
         DC  H'1'                      REFERENCE NUMBER
         DC  H'0'                      UNUSED
         DC  H'11'                     PRINT COLUMN
         DC  H'44'                     PRINT FIELD LENGTH
         DC  H'0'                      CONVERSION FLAGS  (CHAR)
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC FLAG.
         DC  Y(STE232B-STE232A)        STATIC TEXT LENGTH.
         DC  Y(STE232A-TXT23A)         STATIC TEXT OFFSET.
         DC  H'0'                      PRINT COLUMN.
         DC  Y(STE232B-STE232A)        PRINT FIELD LENGTH.
         DC  X'0010'                   CONVERSION FLAGS.  (CHAR,BS)
* INSERT DATA SUB-STRUCTURE
         DC  X'2000'                   INSERT DATA FLAG
         DC  H'2'                      REFERENCE NUMBER
         DC  H'0'                      UNUSED
         DC  H'0'                      PRINT COLUMN
         DC  H'14'                     PRINT FIELD LENGTH
         DC  X'0010'                   CONVERSION FLAGS  (CHAR,BS)
* SPACING CONTROL SUB-STRUCTURE.
         DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
         DC  H'0'                      SPACING FACTOR.
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC FLAG.
         DC  Y(STE233B-STE233A)        STATIC TEXT LENGTH.
         DC  Y(STE233A-TXT23A)         STATIC TEXT OFFSET.
         DC  H'11'                     PRINT COLUMN.
         DC  Y(STE233B-STE233A)        PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* INSERT DATA SUB-STRUCTURE
         DC  X'2000'                   INSERT DATA FLAG
         DC  H'3'                      REFERENCE NUMBER
         DC  H'0'                      UNUSED
         DC  H'33'                     PRINT COLUMN
         DC  H'6'                      PRINT FIELD LENGTH
         DC  X'8000'                   CONVERSION FLAGS  (BH)
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC FLAG.
         DC  Y(STE234B-STE234A)        STATIC TEXT LENGTH.
         DC  Y(STE234A-TXT23A)         STATIC TEXT OFFSET.
         DC  H'39'                     PRINT COLUMN.
         DC  Y(STE234B-STE234A)        PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* INSERT DATA SUB-STRUCTURE
         DC  X'A000'                   INSERT DATA FLAG
         DC  H'4'                      REFERENCE NUMBER
         DC  H'0'                      UNUSED
         DC  H'40'                     PRINT COLUMN
         DC  H'14'                     PRINT FIELD LENGTH
         DC  H'0'                      CONVERSION FLAGS  (CHAR)
* STATIC TEXT ENTRIES
STE231A  DC  C'IDC11023I'
STE231B  EQU *
STE232A  DC  C','
STE232B  EQU *
STE233A  DC  C'ERROR FOR ASSOCIATION'
STE233B  EQU *
STE234A  DC  C','
STE234B  EQU *
TXT23B   EQU *
         EJECT
*                                                                    *
*  ERROR FOR ASSOCIATION
*                                                                    *
TXT24    DC  Y(TXT24B-TXT24A)          ENTRY LENGTH.
         DC  X'8000'                   MESSAGE FLAG.
* SPACING CONTROL SUB-STRUCTURE.
TXT24A   DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
         DC  H'2'                      SPACING FACTOR.
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC FLAG.
         DC  Y(STE241B-STE241A)        STATIC TEXT LENGTH.
         DC  Y(STE241A-TXT24A)         STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE241B-STE241A)        PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* INSERT DATA SUB-STRUCTURE
         DC  X'2000'                   INSERT DATA FLAG
         DC  H'1'                      REFERENCE NUMBER
         DC  H'0'                      UNUSED
         DC  H'11'                     PRINT COLUMN
         DC  H'44'                     PRINT FIELD LENGTH
         DC  H'0'                      CONVERSION FLAGS  (CHAR)
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC FLAG.
         DC  Y(STE242B-STE242A)        STATIC TEXT LENGTH.
         DC  Y(STE242A-TXT24A)         STATIC TEXT OFFSET.
         DC  H'0'                      PRINT COLUMN.
         DC  Y(STE242B-STE242A)        PRINT FIELD LENGTH.
         DC  X'0010'                   CONVERSION FLAGS.  (CHAR,BS)
* INSERT DATA SUB-STRUCTURE
         DC  X'2000'                   INSERT DATA FLAG
         DC  H'2'                      REFERENCE NUMBER
         DC  H'0'                      UNUSED
         DC  H'0'                      PRINT COLUMN
         DC  H'14'                     PRINT FIELD LENGTH
         DC  X'0010'                   CONVERSION FLAGS  (CHAR,BS)
* SPACING CONTROL SUB-STRUCTURE.
         DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
         DC  H'0'                      SPACING FACTOR.
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC FLAG.
         DC  Y(STE243B-STE243A)        STATIC TEXT LENGTH.
         DC  Y(STE243A-TXT24A)         STATIC TEXT OFFSET.
         DC  H'11'                     PRINT COLUMN.
         DC  Y(STE243B-STE243A)        PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* INSERT DATA SUB-STRUCTURE
         DC  X'A000'                   INSERT DATA FLAG
         DC  H'3'                      REFERENCE NUMBER
         DC  H'0'                      UNUSED
         DC  H'33'                     PRINT COLUMN
         DC  H'14'                     PRINT FIELD LENGTH
         DC  H'0'                      CONVERSION FLAGS  (CHAR)
* STATIC TEXT ENTRIES
STE241A  DC  C'IDC11023I'
STE241B  EQU *
STE242A  DC  C','
STE242B  EQU *
STE243A  DC  C'ERROR FOR ASSOCIATION'
STE243B  EQU *
TXT24B   EQU *
         EJECT
*                                                                    *
* INVALID ALIAS CHAIN
*                                                                    *
TXT25    DC  Y(TXT25B-TXT25A)          ENTRY LENGTH.
         DC  X'8000'                   MESSAGE FLAG.
* SPACING CONTROL SUB-STRUCTURE.
TXT25A   DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
         DC  H'2'                      SPACING FACTOR.
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC FLAG.
         DC  Y(STE251B-STE251A)        STATIC TEXT LENGTH.
         DC  Y(STE251A-TXT25A)         STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE251B-STE251A)        PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* INSERT DATA SUB-STRUCTURE
         DC  X'2000'                   INSERT DATA FLAG
         DC  H'1'                      REFERENCE NUMBER
         DC  H'0'                      UNUSED
         DC  H'11'                     PRINT COLUMN
         DC  H'44'                     PRINT FIELD LENGTH
         DC  H'0'                      CONVERSION FLAGS  (CHAR)
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC FLAG.
         DC  Y(STE252B-STE252A)        STATIC TEXT LENGTH.
         DC  Y(STE252A-TXT25A)         STATIC TEXT OFFSET.
         DC  H'0'                      PRINT COLUMN.
         DC  Y(STE252B-STE252A)        PRINT FIELD LENGTH.
         DC  X'0010'                   CONVERSION FLAGS.  (CHAR,BS)
* INSERT DATA SUB-STRUCTURE
         DC  X'2000'                   INSERT DATA FLAG
         DC  H'2'                      REFERENCE NUMBER
         DC  H'0'                      UNUSED
         DC  H'0'                      PRINT COLUMN
         DC  H'14'                     PRINT FIELD LENGTH
         DC  X'0010'                   CONVERSION FLAGS  (CHAR,BS)
* SPACING CONTROL SUB-STRUCTURE.
         DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
         DC  H'0'                      SPACING FACTOR.
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'8400'                   STATIC FLAG.
         DC  Y(STE253B-STE253A)        STATIC TEXT LENGTH.
         DC  Y(STE253A-TXT25A)         STATIC TEXT OFFSET.
         DC  H'11'                     PRINT COLUMN.
         DC  Y(STE253B-STE253A)        PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* STATIC TEXT ENTRIES
STE251A  DC  C'IDC21024I'
STE251B  EQU *
STE252A  DC  C','
STE252B  EQU *
STE253A  DC  C'CONTAINS AN INVALID ALIAS CHAIN'
STE253B  EQU *
TXT25B   EQU *
         EJECT
*                                                                    *
* INVALID GDG DATA SET ASSOCIATION
*                                                                    *
TXT26    DC  Y(TXT26B-TXT26A)          ENTRY LENGTH.
         DC  X'8000'                   MESSAGE FLAG.
* SPACING CONTROL SUB-STRUCTURE.
TXT26A   DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
         DC  H'2'                      SPACING FACTOR.
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC FLAG.
         DC  Y(STE261B-STE261A)        STATIC TEXT LENGTH.
         DC  Y(STE261A-TXT26A)         STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE261B-STE261A)        PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* INSERT DATA SUB-STRUCTURE
         DC  X'2000'                   INSERT DATA FLAG
         DC  H'1'                      REFERENCE NUMBER
         DC  H'0'                      UNUSED
         DC  H'11'                     PRINT COLUMN
         DC  H'44'                     PRINT FIELD LENGTH
         DC  H'0'                      CONVERSION FLAGS  (CHAR)
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC FLAG.
         DC  Y(STE262B-STE262A)        STATIC TEXT LENGTH.
         DC  Y(STE262A-TXT26A)         STATIC TEXT OFFSET.
         DC  H'0'                      PRINT COLUMN.
         DC  Y(STE262B-STE262A)        PRINT FIELD LENGTH.
         DC  X'0010'                   CONVERSION FLAGS.  (CHAR,BS)
* INSERT DATA SUB-STRUCTURE
         DC  X'2000'                   INSERT DATA FLAG
         DC  H'2'                      REFERENCE NUMBER
         DC  H'0'                      UNUSED
         DC  H'0'                      PRINT COLUMN
         DC  H'14'                     PRINT FIELD LENGTH
         DC  X'0010'                   CONVERSION FLAGS  (CHAR,BS)
* SPACING CONTROL SUB-STRUCTURE.
         DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
         DC  H'0'                      SPACING FACTOR.
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'8400'                   STATIC FLAG.
         DC  Y(STE263B-STE263A)        STATIC TEXT LENGTH.
         DC  Y(STE263A-TXT26A)         STATIC TEXT OFFSET.
         DC  H'11'                     PRINT COLUMN.
         DC  Y(STE263B-STE263A)        PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* STATIC TEXT ENTRIES
STE261A  DC  C'IDC21025I'
STE261B  EQU *
STE262A  DC  C','
STE262B  EQU *
STE263A  DC  C'HAS AN INVALID GDG DATA SET ASSOCIATION'
STE263B  EQU *
TXT26B   EQU *
         EJECT
*                                                                    *
* ENTRY DELETED
*                                                                    *
TXT27    DC  Y(TXT27B-TXT27A)          ENTRY LENGTH.
         DC  X'8000'                   MESSAGE FLAG.
* SPACING CONTROL SUB-STRUCTURE.
TXT27A   DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
         DC  H'2'                      SPACING FACTOR.
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC FLAG.
         DC  Y(STE271B-STE271A)        STATIC TEXT LENGTH.
         DC  Y(STE271A-TXT27A)         STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE271B-STE271A)        PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* INSERT DATA SUB-STRUCTURE
         DC  X'2000'                   INSERT DATA FLAG
         DC  H'1'                      REFERENCE NUMBER
         DC  H'0'                      UNUSED
         DC  H'11'                     PRINT COLUMN
         DC  H'44'                     PRINT FIELD LENGTH
         DC  H'0'                      CONVERSION FLAGS  (CHAR)
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC FLAG.
         DC  Y(STE272B-STE272A)        STATIC TEXT LENGTH.
         DC  Y(STE272A-TXT27A)         STATIC TEXT OFFSET.
         DC  H'0'                      PRINT COLUMN.
         DC  Y(STE272B-STE272A)        PRINT FIELD LENGTH.
         DC  X'0010'                   CONVERSION FLAGS.  (CHAR,BS)
* INSERT DATA SUB-STRUCTURE
         DC  X'2000'                   INSERT DATA FLAG
         DC  H'2'                      REFERENCE NUMBER
         DC  H'0'                      UNUSED
         DC  H'0'                      PRINT COLUMN
         DC  H'14'                     PRINT FIELD LENGTH
         DC  X'0010'                   CONVERSION FLAGS  (CHAR,BS)
* SPACING CONTROL SUB-STRUCTURE.
         DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
         DC  H'0'                      SPACING FACTOR.
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'8400'                   STATIC FLAG.
         DC  Y(STE273B-STE273A)        STATIC TEXT LENGTH.
         DC  Y(STE273A-TXT27A)         STATIC TEXT OFFSET.
         DC  H'11'                     PRINT COLUMN.
         DC  Y(STE273B-STE273A)        PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* STATIC TEXT ENTRIES
STE271A  DC  C'IDC21026I'
STE271B  EQU *
STE272A  DC  C','
STE272B  EQU *
STE273A  DC  C'DELETED'
STE273B  EQU *
TXT27B   EQU *
         EJECT
*                                                                    *
* CRA SPACE NOT DEFINED ON VOL
*                                                                    *
TXT28    DC  Y(TXT28B-TXT28A)          ENTRY LENGTH.
         DC  X'8000'                   MESSAGE FLAG.
* SPACING CONTROL SUB-STRUCTURE.
TXT28A   DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
         DC  H'2'                      SPACING FACTOR.
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC FLAG.
         DC  Y(STE281B-STE281A)        STATIC TEXT LENGTH.
         DC  Y(STE281A-TXT28A)         STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE281B-STE281A)        PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* INSERT DATA SUB-STRUCTURE
         DC  X'2000'                   INSERT DATA FLAG
         DC  H'1'                      REFERENCE NUMBER
         DC  H'0'                      UNUSED
         DC  H'31'                     PRINT COLUMN
         DC  H'6'                      PRINT FIELD LENGTH
         DC  H'0'                      CONVERSION FLAGS  (CHAR)
* STATIC TEXT SUB-STRUCTURE.
         DC  X'8400'                   STATIC FLAG.
         DC  Y(STE282B-STE282A)        STATIC TEXT LENGTH.
         DC  Y(STE282A-TXT28A)         STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE282B-STE282A)        PRINT FIELD LENGTH.
         DC  X'0010'                   CONVERSION FLAGS.  (CHAR,BS)
* STATIC TEXT ENTRIES
STE281A  DC  C'IDC21027I CRA SPACE ON VOLUME'
STE281B  EQU *
STE282A  DC  C'NOT OWNED BY CATALOG'
STE282B  EQU *
TXT28B   EQU *
         EJECT
*                                                                    *
* CATALOG SPACE NOT DEFINED ON VOL
*                                                                    *
TXT29    DC  Y(TXT29B-TXT29A)          ENTRY LENGTH.
         DC  X'8000'                   MESSAGE FLAG.
* SPACING CONTROL SUB-STRUCTURE.
TXT29A   DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
         DC  H'2'                      SPACING FACTOR.
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC FLAG.
         DC  Y(STE291B-STE291A)        STATIC TEXT LENGTH.
         DC  Y(STE291A-TXT29A)         STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE291B-STE291A)        PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* INSERT DATA SUB-STRUCTURE
         DC  X'2000'                   INSERT DATA FLAG
         DC  H'1'                      REFERENCE NUMBER
         DC  H'0'                      UNUSED
         DC  H'35'                     PRINT COLUMN
         DC  H'6'                      PRINT FIELD LENGTH
         DC  H'0'                      CONVERSION FLAGS  (CHAR)
* STATIC TEXT SUB-STRUCTURE.
         DC  X'8400'                   STATIC FLAG.
         DC  Y(STE292B-STE292A)        STATIC TEXT LENGTH.
         DC  Y(STE292A-TXT29A)         STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE292B-STE292A)        PRINT FIELD LENGTH.
         DC  X'0010'                   CONVERSION FLAGS.  (CHAR,BS)
* STATIC TEXT ENTRIES
STE291A  DC  C'IDC21027I CATALOG SPACE ON VOLUME'
STE291B  EQU *
STE292A  DC  C'NOT OWNED BY CATALOG'
STE292B  EQU *
TXT29B   EQU *
         EJECT
*                                                                    *
* ENTRY 30 IS NULL                                             @ZM43016
*                                                                    *
         EJECT
*                                                                    *
* SPACE MAP CORRECTED
*                                                                    *
TXT31    DC  Y(TXT31B-TXT31A)          ENTRY LENGTH.
         DC  X'8000'                   MESSAGE FLAG.
* SPACING CONTROL SUB-STRUCTURE.
TXT31A   DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
         DC  H'2'                      SPACING FACTOR.
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC FLAG.
         DC  Y(STE311B-STE311A)        STATIC TEXT LENGTH.
         DC  Y(STE311A-TXT31A)         STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE311B-STE311A)        PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* INSERT DATA SUB-STRUCTURE
         DC  X'2000'                   INSERT DATA FLAG
         DC  H'1'                      REFERENCE NUMBER
         DC  H'0'                      UNUSED
         DC  H'32'                     PRINT COLUMN
         DC  H'6'                      PRINT FIELD LENGTH
         DC  H'0'                      CONVERSION FLAGS  (CHAR)
* STATIC TEXT SUB-STRUCTURE.
         DC  X'8400'                   STATIC FLAG.
         DC  Y(STE312B-STE312A)        STATIC TEXT LENGTH.
         DC  Y(STE312A-TXT31A)         STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE312B-STE312A)        PRINT FIELD LENGTH.
         DC  X'0010'                   CONVERSION FLAGS.  (CHAR,BS)
* STATIC TEXT ENTRIES
STE311A  DC  C'IDC11029I SPACE MAP FOR VOLUME'
STE311B  EQU *
STE312A  DC  C'CORRECTED'
STE312B  EQU *
TXT31B   EQU *
         EJECT
*                                                                    *
* D OR I WITH INVALID SPACE REQUEST
*                                                                    *
TXT32    DC  Y(TXT32B-TXT32A)          ENTRY LENGTH.
         DC  X'8000'                   MESSAGE FLAG.
* SPACING CONTROL SUB-STRUCTURE.
TXT32A   DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
         DC  H'2'                      SPACING FACTOR.
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC FLAG.
         DC  Y(STE321B-STE321A)        STATIC TEXT LENGTH.
         DC  Y(STE321A-TXT32A)         STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE321B-STE321A)        PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* INSERT DATA SUB-STRUCTURE
         DC  X'2000'                   INSERT DATA FLAG
         DC  H'1'                      REFERENCE NUMBER
         DC  H'0'                      UNUSED
         DC  H'11'                     PRINT COLUMN
         DC  H'44'                     PRINT FIELD LENGTH
         DC  H'0'                      CONVERSION FLAGS  (CHAR)
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC FLAG.
         DC  Y(STE322B-STE322A)        STATIC TEXT LENGTH.
         DC  Y(STE322A-TXT32A)         STATIC TEXT OFFSET.
         DC  H'0'                      PRINT COLUMN.
         DC  Y(STE322B-STE322A)        PRINT FIELD LENGTH.
         DC  X'0010'                   CONVERSION FLAGS.  (CHAR,BS)
* INSERT DATA SUB-STRUCTURE
         DC  X'2000'                   INSERT DATA FLAG
         DC  H'2'                      REFERENCE NUMBER
         DC  H'0'                      UNUSED
         DC  H'0'                      PRINT COLUMN
         DC  H'14'                     PRINT FIELD LENGTH
         DC  X'0010'                   CONVERSION FLAGS  (CHAR,BS)
* SPACING CONTROL SUB-STRUCTURE.
         DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
         DC  H'0'                      SPACING FACTOR.
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC FLAG.
         DC  Y(STE323B-STE323A)        STATIC TEXT LENGTH.
         DC  Y(STE323A-TXT32A)         STATIC TEXT OFFSET.
         DC  H'11'                     PRINT COLUMN.
         DC  Y(STE323B-STE323A)        PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* INSERT DATA SUB-STRUCTURE
         DC  X'A000'                   INSERT DATA FLAG
         DC  H'3'                      REFERENCE NUMBER
         DC  H'0'                      UNUSED
         DC  H'52'                     PRINT COLUMN
         DC  H'6'                      PRINT FIELD LENGTH
         DC  H'0'                      CONVERSION FLAGS  (CHAR)
* STATIC TEXT ENTRIES
STE321A  DC  C'IDC21030I'
STE321B  EQU *
STE322A  DC  C','
STE322B  EQU *
STE323A  DC  C'HAS INVALID SPACE DESCRIPTION FOR VOLUME'
STE323B  EQU *
TXT32B   EQU *
         EJECT
*                                                                    *
* UNIQUE D OR I WITH LESS EXTENTS THAN DATA SPACE
*                                                                    *
TXT33    DC  Y(TXT33B-TXT33A)          ENTRY LENGTH.
         DC  X'8000'                   MESSAGE FLAG.
* SPACING CONTROL SUB-STRUCTURE.
TXT33A   DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
         DC  H'2'                      SPACING FACTOR.
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC FLAG.
         DC  Y(STE331B-STE331A)        STATIC TEXT LENGTH.
         DC  Y(STE331A-TXT33A)         STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE331B-STE331A)        PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* INSERT DATA SUB-STRUCTURE
         DC  X'2000'                   INSERT DATA FLAG
         DC  H'1'                      REFERENCE NUMBER
         DC  H'0'                      UNUSED
         DC  H'27'                     PRINT COLUMN
         DC  H'44'                     PRINT FIELD LENGTH
         DC  H'0'                      CONVERSION FLAGS  (CHAR)
* SPACING CONTROL SUB-STRUCTURE.
         DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
         DC  H'0'                      SPACING FACTOR.
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'8400'                   STATIC FLAG.
         DC  Y(STE332B-STE332A)        STATIC TEXT LENGTH.
         DC  Y(STE332A-TXT33A)         STATIC TEXT OFFSET.
         DC  H'11'                     PRINT COLUMN.
         DC  Y(STE332B-STE332A)        PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* STATIC TEXT ENTRIES
STE331A  DC  C'IDC11031I UNIQUE DATA SET'
STE331B  EQU *
STE332A  DC  C'HAS FEWER EXTENTS THAN THE DATA SPACE'
STE332B  EQU *
TXT33B   EQU *
         EJECT
*                                                                    *
*  INVALID RECORD
*                                                                    *
TXT34    DC  Y(TXT34B-TXT34A)          ENTRY LENGTH.
         DC  X'8000'                   MESSAGE FLAG.
* SPACING CONTROL SUB-STRUCTURE.
TXT34A   DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
         DC  H'2'                      SPACING FACTOR.
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC FLAG.
         DC  Y(STE341B-STE341A)        STATIC TEXT LENGTH.
         DC  Y(STE341A-TXT34A)         STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE341B-STE341A)        PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* INSERT DATA SUB-STRUCTURE
         DC  X'2000'                   INSERT DATA FLAG
         DC  H'1'                      REFERENCE NUMBER
         DC  H'0'                      UNUSED
         DC  H'11'                     PRINT COLUMN
         DC  H'14'                     PRINT FIELD LENGTH
         DC  H'0'                      CONVERSION FLAGS  (CHAR)
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC FLAG.
         DC  Y(STE342B-STE342A)        STATIC TEXT LENGTH.
         DC  Y(STE342A-TXT34A)         STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE342B-STE342A)        PRINT FIELD LENGTH.
         DC  X'0010'                   CONVERSION FLAGS.  (CHAR,BS)
* SPACING CONTROL SUB-STRUCTURE.
         DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
         DC  H'0'                      SPACING FACTOR.
         DC  C'R '                     SPACING TYPE.
* INSERT DATA SUB-STRUCTURE
         DC  X'2000'                   INSERT DATA FLAG
         DC  H'2'                      REFERENCE NUMBER
         DC  H'0'                      UNUSED
         DC  H'11'                     PRINT COLUMN
         DC  H'44'                     PRINT FIELD LENGTH
         DC  H'0'                      CONVERSION FLAGS  (CHAR,BS)
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC FLAG.
         DC  Y(STE343B-STE343A)        STATIC TEXT LENGTH.
         DC  Y(STE343A-TXT34A)         STATIC TEXT OFFSET.
         DC  H'0'                      PRINT COLUMN.
         DC  Y(STE343B-STE343A)        PRINT FIELD LENGTH.
         DC  X'0010'                   CONVERSION FLAGS.  (CHAR,BS)
* INSERT DATA SUB-STRUCTURE
         DC  X'A000'                   INSERT DATA FLAG
         DC  H'3'                      REFERENCE NUMBER
         DC  H'0'                      UNUSED
         DC  H'0'                      PRINT COLUMN
         DC  H'14'                     PRINT FIELD LENGTH
         DC  X'0010'                   CONVERSION FLAGS  (CHAR,BS)
* STATIC TEXT ENTRIES
STE341A  DC  C'IDC21032I'
STE341B  EQU *
STE342A  DC  C'DELETED FROM'
STE342B  EQU *
STE343A  DC  C','
STE343B  EQU *
TXT34B   EQU *
         EJECT
*                                                                    *
* UNIQUE DATA SET NOT SCRATCHED
*                                                                    *
TXT35    DC  Y(TXT35B-TXT35A)          ENTRY LENGTH.
         DC  X'8000'                   MESSAGE FLAG.
* SPACING CONTROL SUB-STRUCTURE.
TXT35A   DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
         DC  H'2'                      SPACING FACTOR.
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC FLAG.
         DC  Y(STE351B-STE351A)        STATIC TEXT LENGTH.
         DC  Y(STE351A-TXT35A)         STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE351B-STE351A)        PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* INSERT DATA SUB-STRUCTURE
         DC  X'2000'                   INSERT DATA FLAG
         DC  H'1'                      REFERENCE NUMBER
         DC  H'0'                      UNUSED
         DC  H'11'                     PRINT COLUMN
         DC  H'44'                     PRINT FIELD LENGTH
         DC  H'0'                      CONVERSION FLAGS  (CHAR)
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC FLAG.
         DC  Y(STE352B-STE352A)        STATIC TEXT LENGTH.
         DC  Y(STE352A-TXT35A)         STATIC TEXT OFFSET.
         DC  H'0'                      PRINT COLUMN.
         DC  Y(STE352B-STE352A)        PRINT FIELD LENGTH.
         DC  X'0010'                   CONVERSION FLAGS.  (CHAR,BS)
* INSERT DATA SUB-STRUCTURE
         DC  X'2000'                   INSERT DATA FLAG
         DC  H'2'                      REFERENCE NUMBER
         DC  H'0'                      UNUSED
         DC  H'0'                      PRINT COLUMN
         DC  H'6'                      PRINT FIELD LENGTH
         DC  X'0010'                   CONVERSION FLAGS  (CHAR,BS)
* SPACING CONTROL SUB-STRUCTURE.
         DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
         DC  H'0'                      SPACING FACTOR.
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'8400'                   STATIC FLAG.
         DC  Y(STE353B-STE353A)        STATIC TEXT LENGTH.
         DC  Y(STE353A-TXT35A)         STATIC TEXT OFFSET.
         DC  H'11'                     PRINT COLUMN.
         DC  Y(STE353B-STE353A)        PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* STATIC TEXT ENTRIES
STE351A  DC  C'IDC11033I'
STE351B  EQU *
STE352A  DC  C','
STE352B  EQU *
STE353A  DC  C'NOT DELETED'
STE353B  EQU *
TXT35B   EQU *
         EJECT
*                                                                    *
* SPACE MAP WRONG SIZE
*                                                                    *
TXT36    DC  Y(TXT36B-TXT36A)          ENTRY LENGTH.
         DC  X'8000'                   MESSAGE FLAG.
* SPACING CONTROL SUB-STRUCTURE.
TXT36A   DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
         DC  H'2'                      SPACING FACTOR.
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC FLAG.
         DC  Y(STE361B-STE361A)        STATIC TEXT LENGTH.
         DC  Y(STE361A-TXT36A)         STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE361B-STE361A)        PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* INSERT DATA SUB-STRUCTURE
         DC  X'A000'                   INSERT DATA FLAG
         DC  H'1'                      REFERENCE NUMBER
         DC  H'0'                      UNUSED
         DC  H'31'                     PRINT COLUMN
         DC  H'6'                      PRINT FIELD LENGTH
         DC  H'0'                      CONVERSION FLAGS  (CHAR)
* STATIC TEXT ENTRIES
STE361A  DC  C'IDC21034I SPACE MAP ERROR FOR'
STE361B  EQU *
TXT36B   EQU *
         EJECT
*                                                                    *
* BAD VOLUME RECORDS
*                                                                    *
TXT37    DC  Y(TXT37B-TXT37A)          ENTRY LENGTH.
         DC  X'8000'                   MESSAGE FLAG.
* SPACING CONTROL SUB-STRUCTURE.
TXT37A   DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
         DC  H'2'                      SPACING FACTOR.
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC FLAG.
         DC  Y(STE371B-STE371A)        STATIC TEXT LENGTH.
         DC  Y(STE371A-TXT37A)         STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE371B-STE371A)        PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* INSERT DATA SUB-STRUCTURE
         DC  X'A000'                   INSERT DATA FLAG
         DC  H'1'                      REFERENCE NUMBER
         DC  H'0'                      UNUSED
         DC  H'34'                     PRINT COLUMN
         DC  H'6'                      PRINT FIELD LENGTH
         DC  H'0'                      CONVERSION FLAGS  (CHAR)
* STATIC TEXT ENTRIES
STE371A  DC  C'IDC31035I BAD VOLUME RECORDS FOR'
STE371B  EQU *
TXT37B   EQU *
         EJECT
*                                                                    *
* NO SPACE HEADER FOR DSCB
*                                                                    *
TXT38    DC  Y(TXT38B-TXT38A)          ENTRY LENGTH.
         DC  X'8000'                   MESSAGE FLAG.
* SPACING CONTROL SUB-STRUCTURE.
TXT38A   DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
         DC  H'2'                      SPACING FACTOR.
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC FLAG.
         DC  Y(STE381B-STE381A)        STATIC TEXT LENGTH.
         DC  Y(STE381A-TXT38A)         STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE381B-STE381A)        PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* INSERT DATA SUB-STRUCTURE
         DC  X'2000'                   INSERT DATA FLAG
         DC  H'1'                      REFERENCE NUMBER
         DC  H'0'                      UNUSED
         DC  H'11'                     PRINT COLUMN
         DC  H'44'                     PRINT FIELD LENGTH
         DC  H'0'                      CONVERSION FLAGS  (CHAR)
* STATIC TEXT SUB-STRUCTURE.
         DC  X'8400'                   STATIC FLAG.
         DC  Y(STE382B-STE382A)        STATIC TEXT LENGTH.
         DC  Y(STE382A-TXT38A)         STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE382B-STE382A)        PRINT FIELD LENGTH.
         DC  X'0010'                   CONVERSION FLAGS.  (CHAR,BS)
* STATIC TEXT ENTRIES
STE381A  DC  C'IDC11040I'
STE381B  EQU *
STE382A  DC  C'UNKNOWN'
STE382B  EQU *
TXT38B   EQU *
         EJECT
*                                                                    *
* SPACE HEADER CORRECTED
*                                                                    *
TXT39    DC  Y(TXT39B-TXT39A)          ENTRY LENGTH.
         DC  X'8000'                   MESSAGE FLAG.
* SPACING CONTROL SUB-STRUCTURE.
TXT39A   DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
         DC  H'2'                      SPACING FACTOR.
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC FLAG.
         DC  Y(STE391B-STE391A)        STATIC TEXT LENGTH.
         DC  Y(STE391A-TXT39A)         STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE391B-STE391A)        PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* INSERT DATA SUB-STRUCTURE
         DC  X'2000'                   INSERT DATA FLAG
         DC  H'1'                      REFERENCE NUMBER
         DC  H'0'                      UNUSED
         DC  H'11'                     PRINT COLUMN
         DC  H'44'                     PRINT FIELD LENGTH
         DC  H'0'                      CONVERSION FLAGS  (CHAR)
* STATIC TEXT SUB-STRUCTURE.
         DC  X'8400'                   STATIC FLAG.
         DC  Y(STE392B-STE392A)        STATIC TEXT LENGTH.
         DC  Y(STE392A-TXT39A)         STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE392B-STE392A)        PRINT FIELD LENGTH.
         DC  X'0010'                   CONVERSION FLAGS.  (CHAR,BS)
* STATIC TEXT ENTRIES
STE391A  DC  C'IDC11041I'
STE391B  EQU *
STE392A  DC  C'SPACE CORRECTED'
STE392B  EQU *
TXT39B   EQU *
         EJECT
*                                                                    *
* SPACE HEADER DELETED
*                                                                    *
TXT40    DC  Y(TXT40B-TXT40A)          ENTRY LENGTH.
         DC  X'8000'                   MESSAGE FLAG.
* SPACING CONTROL SUB-STRUCTURE.
TXT40A   DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
         DC  H'2'                      SPACING FACTOR.
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC FLAG.
         DC  Y(STE401B-STE401A)        STATIC TEXT LENGTH.
         DC  Y(STE401A-TXT40A)         STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE401B-STE401A)        PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* INSERT DATA SUB-STRUCTURE
         DC  X'2000'                   INSERT DATA FLAG
         DC  H'1'                      REFERENCE NUMBER
         DC  H'0'                      UNUSED
         DC  H'11'                     PRINT COLUMN
         DC  H'44'                     PRINT FIELD LENGTH
         DC  H'0'                      CONVERSION FLAGS  (CHAR)
* STATIC TEXT SUB-STRUCTURE.
         DC  X'8400'                   STATIC FLAG.
         DC  Y(STE402B-STE402A)        STATIC TEXT LENGTH.
         DC  Y(STE402A-TXT40A)         STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN. (INCR)
         DC  Y(STE402B-STE402A)        PRINT FIELD LENGTH.
         DC  X'0010'                   CONVERSION FLAGS.  (CHAR,BS)
* STATIC TEXT ENTRIES
STE401A  DC  C'IDC11042I'
STE401B  EQU *
STE402A  DC  C'SPACE DELETED'
STE402B  EQU *
TXT40B   EQU *
         EJECT
*                                                                    *
*  TIMESTAMP FOR VOLUME RECORD CORRECTED
*                                                                    *
TXT41    DC  Y(TXT41B-TXT41A)          ENTRY LENGTH.
         DC  X'8000'                   MESSAGE FLAG.
* SPACING CONTROL SUB-STRUCTURE.
TXT41A   DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
         DC  H'2'                      SPACING FACTOR.
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC FLAG.
         DC  Y(STE411B-STE411A)        STATIC TEXT LENGTH.
         DC  Y(STE411A-TXT41A)         STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE411B-STE411A)        PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* INSERT DATA SUB-STRUCTURE
         DC  X'2000'                   INSERT DATA FLAG
         DC  H'1'                      REFERENCE NUMBER
         DC  H'0'                      UNUSED
         DC  H'46'                     PRINT COLUMN
         DC  H'6'                      PRINT FIELD LENGTH
         DC  H'0'                      CONVERSION FLAGS  (CHAR)
* STATIC TEXT SUB-STRUCTURE.
         DC  X'8400'                   STATIC FLAG.
         DC  Y(STE412B-STE412A)        STATIC TEXT LENGTH.
         DC  Y(STE412A-TXT41A)         STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE412B-STE412A)        PRINT FIELD LENGTH.
         DC  X'0010'                   CONVERSION FLAGS.  (CHAR,BS)
* STATIC TEXT ENTRIES
STE411A  DC  C'IDC11043I TIMESTAMP FOR VOLUME RECORD ON VOL'
STE411B  EQU *
STE412A  DC  C'WAS CORRECTED'
STE412B  EQU *
TXT41B   EQU *
         EJECT
*                                                                    *
* UNABLE TO SCRATCH DSCB
*                                                                    *
TXT42    DC  Y(TXT42B-TXT42A)          ENTRY LENGTH.
         DC  X'8000'                   MESSAGE FLAG.
* SPACING CONTROL SUB-STRUCTURE.
TXT42A   DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
         DC  H'2'                      SPACING FACTOR.
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC FLAG.
         DC  Y(STE421B-STE421A)        STATIC TEXT LENGTH.
         DC  Y(STE421A-TXT42A)         STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE421B-STE421A)        PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* INSERT DATA SUB-STRUCTURE
         DC  X'2000'                   INSERT DATA FLAG
         DC  H'1'                      REFERENCE NUMBER
         DC  H'0'                      UNUSED
         DC  H'11'                     PRINT COLUMN
         DC  H'44'                     PRINT FIELD LENGTH
         DC  H'0'                      CONVERSION FLAGS  (CHAR)
* STATIC TEXT SUB-STRUCTURE.
         DC  X'8400'                   STATIC FLAG.
         DC  Y(STE422B-STE422A)        STATIC TEXT LENGTH.
         DC  Y(STE422A-TXT42A)         STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN. (INCR)
         DC  Y(STE422B-STE422A)        PRINT FIELD LENGTH.
         DC  X'0010'                   CONVERSION FLAGS.  (CHAR,BS)
* STATIC TEXT ENTRIES
STE421A  DC  C'IDC11044I'
STE421B  EQU *
STE422A  DC  C'NOT SCRATCHED'
STE422B  EQU *
TXT42B   EQU *
         EJECT
*                                                                    *
* DATA SET RENAMED
*                                                                    *
TXT43    DC  Y(TXT43B-TXT43A)          ENTRY LENGTH.
         DC  X'8000'                   MESSAGE FLAG.
* SPACING CONTROL SUB-STRUCTURE.
TXT43A   DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
         DC  H'2'                      SPACING FACTOR.
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC FLAG.
         DC  Y(STE431B-STE431A)        STATIC TEXT LENGTH.
         DC  Y(STE431A-TXT43A)         STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE431B-STE431A)        PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* INSERT DATA SUB-STRUCTURE
         DC  X'2000'                   INSERT DATA FLAG
         DC  H'1'                      REFERENCE NUMBER
         DC  H'0'                      UNUSED
         DC  H'11'                     PRINT COLUMN
         DC  H'44'                     PRINT FIELD LENGTH
         DC  H'0'                      CONVERSION FLAGS  (CHAR)
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC FLAG.
         DC  Y(STE432B-STE432A)        STATIC TEXT LENGTH.
         DC  Y(STE432A-TXT43A)         STATIC TEXT OFFSET.
         DC  H'0'                      PRINT COLUMN.
         DC  Y(STE432B-STE432A)        PRINT FIELD LENGTH.
         DC  X'0010'                   CONVERSION FLAGS.  (CHAR,BS)
* INSERT DATA SUB-STRUCTURE
         DC  X'2000'                   INSERT DATA FLAG
         DC  H'2'                      REFERENCE NUMBER
         DC  H'0'                      UNUSED
         DC  H'0'                      PRINT COLUMN
         DC  H'14'                     PRINT FIELD LENGTH
         DC  X'0010'                   CONVERSION FLAGS  (CHAR,BS)
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC FLAG.
         DC  Y(STE433B-STE433A)        STATIC TEXT LENGTH.
         DC  Y(STE433A-TXT43A)         STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE433B-STE433A)        PRINT FIELD LENGTH.
         DC  X'0010'                   CONVERSION FLAGS.  (CHAR,BS)
* SPACING CONTROL SUB-STRUCTURE.
         DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
         DC  H'0'                      SPACING FACTOR.
         DC  C'R '                     SPACING TYPE.
* INSERT DATA SUB-STRUCTURE
         DC  X'2000'                   INSERT DATA FLAG
         DC  H'3'                      REFERENCE NUMBER
         DC  H'0'                      UNUSED
         DC  H'11'                     PRINT COLUMN
         DC  H'6'                      PRINT FIELD LENGTH
         DC  H'0'                      CONVERSION FLAGS  (CHAR)
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC FLAG.
         DC  Y(STE434B-STE434A)        STATIC TEXT LENGTH.
         DC  Y(STE434A-TXT43A)         STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE434B-STE434A)        PRINT FIELD LENGTH.
         DC  X'0010'                   CONVERSION FLAGS.  (CHAR,BS)
* INSERT DATA SUB-STRUCTURE
         DC  X'A000'                   INSERT DATA FLAG
         DC  H'4'                      REFERENCE NUMBER
         DC  H'0'                      UNUSED
         DC  H'1'                      PRINT COLUMN
         DC  H'44'                     PRINT FIELD LENGTH
         DC  X'0010'                   CONVERSION FLAGS  (CHAR,BS)
* STATIC TEXT ENTRIES
STE431A  DC  C'IDC21045I'
STE431B  EQU *
STE432A  DC  C','
STE432B  EQU *
STE433A  DC  C'ON'
STE433B  EQU *
STE434A  DC  C'RENAMED'
STE434B  EQU *
TXT43B   EQU *
         EJECT
*                                                                    *
* UNIQUE RENAMED
*                                                                    *
TXT44    DC  Y(TXT44B-TXT44A)          ENTRY LENGTH.
         DC  X'8000'                   MESSAGE FLAG.
* SPACING CONTROL SUB-STRUCTURE.
TXT44A   DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
         DC  H'2'                      SPACING FACTOR.
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC FLAG.
         DC  Y(STE441B-STE441A)        STATIC TEXT LENGTH.
         DC  Y(STE441A-TXT44A)         STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE441B-STE441A)        PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* INSERT DATA SUB-STRUCTURE
         DC  X'2000'                   INSERT DATA FLAG
         DC  H'1'                      REFERENCE NUMBER
         DC  H'0'                      UNUSED
         DC  H'11'                     PRINT COLUMN
         DC  H'44'                     PRINT FIELD LENGTH
         DC  H'0'                      CONVERSION FLAGS  (CHAR)
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC FLAG.
         DC  Y(STE442B-STE442A)        STATIC TEXT LENGTH.
         DC  Y(STE442A-TXT44A)         STATIC TEXT OFFSET.
         DC  H'0'                      PRINT COLUMN.
         DC  Y(STE442B-STE442A)        PRINT FIELD LENGTH.
         DC  X'0010'                   CONVERSION FLAGS.  (CHAR,BS)
* INSERT DATA SUB-STRUCTURE
         DC  X'2000'                   INSERT DATA FLAG
         DC  H'2'                      REFERENCE NUMBER
         DC  H'0'                      UNUSED
         DC  H'0'                      PRINT COLUMN
         DC  H'14'                     PRINT FIELD LENGTH
         DC  X'0010'                   CONVERSION FLAGS  (CHAR,BS)
* SPACING CONTROL SUB-STRUCTURE.
         DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
         DC  H'0'                      SPACING FACTOR.
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC FLAG.
         DC  Y(STE443B-STE443A)        STATIC TEXT LENGTH.
         DC  Y(STE443A-TXT44A)         STATIC TEXT OFFSET.
         DC  H'11'                     PRINT COLUMN.
         DC  Y(STE443B-STE443A)        PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* INSERT DATA SUB-STRUCTURE
         DC  X'2000'                   INSERT DATA FLAG
         DC  H'3'                      REFERENCE NUMBER
         DC  H'0'                      UNUSED
         DC  H'14'                     PRINT COLUMN
         DC  H'6'                      PRINT FIELD LENGTH
         DC  H'0'                      CONVERSION FLAGS  (CHAR)
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC FLAG.
         DC  Y(STE444B-STE444A)        STATIC TEXT LENGTH.
         DC  Y(STE444A-TXT44A)         STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE444B-STE444A)        PRINT FIELD LENGTH.
         DC  X'0010'                   CONVERSION FLAGS.  (CHAR,BS)
* INSERT DATA SUB-STRUCTURE
         DC  X'A000'                   INSERT DATA FLAG
         DC  H'4'                      REFERENCE NUMBER
         DC  H'0'                      UNUSED
         DC  H'1'                      PRINT COLUMN
         DC  H'44'                     PRINT FIELD LENGTH
         DC  X'0010'                   CONVERSION FLAGS  (CHAR,BS)
* STATIC TEXT ENTRIES
STE441A  DC  C'IDC21046I'
STE441B  EQU *
STE442A  DC  C','
STE442B  EQU *
STE443A  DC  C'ON'
STE443B  EQU *
STE444A  DC  C'RENAMED'
STE444B  EQU *
TXT44B   EQU *
         EJECT
*                                                                    *
* UNIQUE NOT RENAMED BECAUSE OF ERROR
*                                                                    *
TXT45    DC  Y(TXT45B-TXT45A)          ENTRY LENGTH.
         DC  X'8000'                   MESSAGE FLAG.
* SPACING CONTROL SUB-STRUCTURE.
TXT45A   DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
         DC  H'2'                      SPACING FACTOR.
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC FLAG.
         DC  Y(STE451B-STE451A)        STATIC TEXT LENGTH.
         DC  Y(STE451A-TXT45A)         STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE451B-STE451A)        PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* INSERT DATA SUB-STRUCTURE
         DC  X'2000'                   INSERT DATA FLAG
         DC  H'1'                      REFERENCE NUMBER
         DC  H'0'                      UNUSED
         DC  H'11'                     PRINT COLUMN
         DC  H'44'                     PRINT FIELD LENGTH
         DC  H'0'                      CONVERSION FLAGS  (CHAR)
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC FLAG.
         DC  Y(STE452B-STE452A)        STATIC TEXT LENGTH.
         DC  Y(STE452A-TXT45A)         STATIC TEXT OFFSET.
         DC  H'0'                      PRINT COLUMN.
         DC  Y(STE452B-STE452A)        PRINT FIELD LENGTH.
         DC  X'0010'                   CONVERSION FLAGS.  (CHAR,BS)
* INSERT DATA SUB-STRUCTURE
         DC  X'2000'                   INSERT DATA FLAG
         DC  H'2'                      REFERENCE NUMBER
         DC  H'0'                      UNUSED
         DC  H'0'                      PRINT COLUMN
         DC  H'14'                     PRINT FIELD LENGTH
         DC  X'0010'                   CONVERSION FLAGS  (CHAR,BS)
* SPACING CONTROL SUB-STRUCTURE.
         DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
         DC  H'0'                      SPACING FACTOR.
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC FLAG.
         DC  Y(STE453B-STE453A)        STATIC TEXT LENGTH.
         DC  Y(STE453A-TXT45A)         STATIC TEXT OFFSET.
         DC  H'11'                     PRINT COLUMN.
         DC  Y(STE453B-STE453A)        PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* INSERT DATA SUB-STRUCTURE
         DC  X'2000'                   INSERT DATA FLAG
         DC  H'3'                      REFERENCE NUMBER
         DC  H'0'                      UNUSED
         DC  H'14'                     PRINT COLUMN
         DC  H'6'                      PRINT FIELD LENGTH
         DC  H'0'                      CONVERSION FLAGS  (CHAR)
* STATIC TEXT SUB-STRUCTURE.
         DC  X'8400'                   STATIC FLAG.
         DC  Y(STE454B-STE454A)        STATIC TEXT LENGTH.
         DC  Y(STE454A-TXT45A)         STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE454B-STE454A)        PRINT FIELD LENGTH.
         DC  X'0010'                   CONVERSION FLAGS.  (CHAR,BS)
* STATIC TEXT ENTRIES
STE451A  DC  C'IDC21047I'
STE451B  EQU *
STE452A  DC  C','
STE452B  EQU *
STE453A  DC  C'ON'
STE453B  EQU *
STE454A  DC  C'MAY NOT BE ACCESSED BY NAME'
STE454B  EQU *
TXT45B   EQU *
         EJECT
*                                                                    *
* BAD SUM TT
*                                                                    *
TXT46    DC  Y(TXT46B-TXT46A)          ENTRY LENGTH.
         DC  X'8000'                   MESSAGE FLAG.
* SPACING CONTROL SUB-STRUCTURE.
TXT46A   DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
         DC  H'2'                      SPACING FACTOR.
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC FLAG.
         DC  Y(STE461B-STE461A)        STATIC TEXT LENGTH.
         DC  Y(STE461A-TXT46A)         STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE461B-STE461A)        PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* INSERT DATA SUB-STRUCTURE
         DC  X'2000'                   INSERT DATA FLAG
         DC  H'1'                      REFERENCE NUMBER
         DC  H'0'                      UNUSED
         DC  H'11'                     PRINT COLUMN
         DC  H'44'                     PRINT FIELD LENGTH
         DC  H'0'                      CONVERSION FLAGS  (CHAR)
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC FLAG.
         DC  Y(STE462B-STE462A)        STATIC TEXT LENGTH.
         DC  Y(STE462A-TXT46A)         STATIC TEXT OFFSET.
         DC  H'0'                      PRINT COLUMN.
         DC  Y(STE462B-STE462A)        PRINT FIELD LENGTH.
         DC  X'0010'                   CONVERSION FLAGS.  (CHAR,BS)
* INSERT DATA SUB-STRUCTURE
         DC  X'2000'                   INSERT DATA FLAG
         DC  H'2'                      REFERENCE NUMBER
         DC  H'0'                      UNUSED
         DC  H'0'                      PRINT COLUMN
         DC  H'14'                     PRINT FIELD LENGTH
         DC  X'0010'                   CONVERSION FLAGS  (CHAR,BS)
* SPACING CONTROL SUB-STRUCTURE.
         DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
         DC  H'0'                      SPACING FACTOR.
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC FLAG.
         DC  Y(STE463B-STE463A)        STATIC TEXT LENGTH.
         DC  Y(STE463A-TXT46A)         STATIC TEXT OFFSET.
         DC  H'11'                     PRINT COLUMN.
         DC  Y(STE463B-STE463A)        PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* INSERT DATA SUB-STRUCTURE
         DC  X'A000'                   INSERT DATA FLAG
         DC  H'3'                      REFERENCE NUMBER
         DC  H'0'                      UNUSED
         DC  H'26'                     PRINT COLUMN
         DC  H'6'                      PRINT FIELD LENGTH
         DC  H'0'                      CONVERSION FLAGS  (CHAR)
* STATIC TEXT ENTRIES
STE461A  DC  C'IDC11036I'
STE461B  EQU *
STE462A  DC  C','
STE462B  EQU *
STE463A  DC  C'OUT-OF-SYNC ON'
STE463B  EQU *
TXT46B   EQU *
         EJECT
*                                                                    *
* INFO- CATALOG HAS BEEN RESET
*                                                                    *
TXT47    DC  Y(TXT47B-TXT47A)          ENTRY LENGTH.
         DC  X'8000'                   MESSAGE FLAG.
* SPACING CONTROL SUB-STRUCTURE.
TXT47A   DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
         DC  H'2'                      SPACING FACTOR.
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC FLAG.
         DC  Y(STE471B-STE471A)        STATIC TEXT LENGTH.
         DC  Y(STE471A-TXT47A)         STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE471B-STE471A)        PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* INSERT DATA SUB-STRUCTURE
         DC  X'2000'                   INSERT DATA FLAG
         DC  H'1'                      REFERENCE NUMBER
         DC  H'0'                      UNUSED
         DC  H'11'                     PRINT COLUMN
         DC  H'44'                     PRINT FIELD LENGTH
         DC  H'0'                      CONVERSION FLAGS  (CHAR)
* STATIC TEXT SUB-STRUCTURE.
         DC  X'8400'                   STATIC FLAG.
         DC  Y(STE472B-STE472A)        STATIC TEXT LENGTH.
         DC  Y(STE472A-TXT47A)         STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE472B-STE472A)        PRINT FIELD LENGTH.
         DC  X'0010'                   CONVERSION FLAGS.  (CHAR,BS)
* STATIC TEXT ENTRIES
STE471A  DC  C'IDC01037I'
STE471B  EQU *
STE472A  DC  C'HAS BEEN RESET'
STE472B  EQU *
TXT47B   EQU *
         EJECT
*                                                                    *
* INVALID RECORD IN A SET OF RECORDS
*                                                                    *
TXT48    DC  Y(TXT48B-TXT48A)          ENTRY LENGTH.
         DC  X'8000'                   MESSAGE FLAG.
* SPACING CONTROL SUB-STRUCTURE.
TXT48A   DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
         DC  H'2'                      SPACING FACTOR.
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC FLAG.
         DC  Y(STE481B-STE481A)        STATIC TEXT LENGTH.
         DC  Y(STE481A-TXT48A)         STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE481B-STE481A)        PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* INSERT DATA SUB-STRUCTURE
         DC  X'2000'                   INSERT DATA FLAG
         DC  H'1'                      REFERENCE NUMBER
         DC  H'0'                      UNUSED
         DC  H'11'                     PRINT COLUMN
         DC  H'6'                      PRINT FIELD LENGTH
         DC  H'0'                      CONVERSION FLAGS  (CHAR)
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC FLAG.
         DC  Y(STE482B-STE482A)        STATIC TEXT LENGTH.
         DC  Y(STE482A-TXT48A)         STATIC TEXT OFFSET.
         DC  H'0'                      PRINT COLUMN.
         DC  Y(STE482B-STE482A)        PRINT FIELD LENGTH.
         DC  X'0010'                   CONVERSION FLAGS.  (CHAR,BS)
* INSERT DATA SUB-STRUCTURE
         DC  X'2000'                   INSERT DATA FLAG
         DC  H'2'                      REFERENCE NUMBER
         DC  H'0'                      UNUSED
         DC  H'0'                      PRINT COLUMN
         DC  H'14'                     PRINT FIELD LENGTH
         DC  X'0010'                   CONVERSION FLAGS  (CHAR,BS)
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC FLAG.
         DC  Y(STE483B-STE483A)        STATIC TEXT LENGTH.
         DC  Y(STE483A-TXT48A)         STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE483B-STE483A)        PRINT FIELD LENGTH.
         DC  X'0010'                   CONVERSION FLAGS.  (CHAR,BS)
* SPACING CONTROL SUB-STRUCTURE.
         DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
         DC  H'0'                      SPACING FACTOR.
         DC  C'R '                     SPACING TYPE.
* INSERT DATA SUB-STRUCTURE
         DC  X'2000'                   INSERT DATA FLAG
         DC  H'3'                      REFERENCE NUMBER
         DC  H'0'                      UNUSED
         DC  H'11'                     PRINT COLUMN
         DC  H'6'                      PRINT FIELD LENGTH
         DC  X'8000'                   CONVERSION FLAGS  (BH)
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC FLAG.
         DC  Y(STE484B-STE484A)        STATIC TEXT LENGTH.
         DC  Y(STE484A-TXT48A)         STATIC TEXT OFFSET.
         DC  H'17'                     PRINT COLUMN.
         DC  Y(STE484B-STE484A)        PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* INSERT DATA SUB-STRUCTURE
         DC  X'A000'                   INSERT DATA FLAG
         DC  H'4'                      REFERENCE NUMBER
         DC  H'0'                      UNUSED
         DC  H'18'                     PRINT COLUMN
         DC  H'14'                     PRINT FIELD LENGTH
         DC  H'0'                      CONVERSION FLAGS  (CHAR)
* STATIC TEXT ENTRIES
STE481A  DC  C'IDC11022I'
STE481B  EQU *
STE482A  DC  C','
STE482B  EQU *
STE483A  DC  C'CONTAINS A CONNECTOR TO INVALID RECORD'
STE483B  EQU *
STE484A  DC  C','
STE484B  EQU *
TXT48B   EQU *
         EJECT
*                                                                    *
* COULD NOT UPDATE ONE OR MORE CRAS
*                                                                    *
TXT49    DC  Y(TXT49B-TXT49A)          ENTRY LENGTH.
         DC  X'8000'                   MESSAGE FLAG.
* SPACING CONTROL SUB-STRUCTURE.
TXT49A   DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
         DC  H'2'                      SPACING FACTOR.
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'8400'                   STATIC FLAG.
         DC  Y(STE491B-STE491A)        STATIC TEXT LENGTH.
         DC  Y(STE491A-TXT49A)         STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE491B-STE491A)        PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* STATIC TEXT ENTRIES
STE491A  DC  C'IDC31038I COULD NOT UPDATE ONE OR MORE CRAS'
STE491B  EQU *
TXT49B   EQU *
         EJECT                                                 @ZA18274
*                                                              @ZA18274
* ENTRY 50 IS NULL                                             @ZA18274
*                                                              @ZA18274
*                                                              @ZA18274
* ENTRY 51 IS NULL                                             @ZA18274
*                                                              @ZA18274
         EJECT                                                 @ZA18274
*                                                              @ZA18274
* CRA ENTRIES MOVED FROM OLD CATALOG'S CRA TO NEW CATALOG'S CRA@ZA18274
*                                                              @ZA18274
TXT52    DC  Y(TXT52B-TXT52A)          ENTRY LENGTH.           @ZA18274
         DC  X'8000'                   MESSAGE FLAG.           @ZA18274
* SPACING CONTROL SUB-STRUCTURE.                               @ZA18274
TXT52A   DC  X'4000'                   SPACE SUB-STRUCTURE FLAG@ZA18274
         DC  H'2'                      SPACING FACTOR.         @ZA18274
         DC  C'R '                     SPACING TYPE.           @ZA18274
* STATIC TEXT SUB-STRUCTURE.                                   @ZA18274
         DC  X'8400'                   STATIC FLAG.            @ZA18274
         DC  Y(STE521B-STE521A)        STATIC TEXT LENGTH.     @ZA18274
         DC  Y(STE521A-TXT52A)         STATIC TEXT OFFSET.     @ZA18274
         DC  H'1'                      PRINT COLUMN.           @ZA18274
         DC  Y(STE521B-STE521A)        PRINT FIELD LENGTH.     @ZA18274
         DC  H'0'                      CONVERSION FLAGS.(CHAR) @ZA18274
* STATIC TEXT ENTRIES                                          @ZA18274
STE521A  DC  C'IDC01049I NONVSAM/USERCATALOG ENTRIES MOVED TO NEW CATALX
               OG''S CRA'                                      @ZA18274
STE521B  EQU *                                                 @ZA18274
TXT52B   EQU *                                                 @ZA18274
         END

