         TITLE '***** IDCTSRV0 - RECOVERV STATIC TEXT *****'
************************************************************
*                                                          *
* MODULE NAME -   IDCTSRV0                                 *
*                                                          *
*                                                          *
* DESCRIPTIVE NAME - STATIC TEXT MODULE FOR THE RECOVER    *
*         VOLUME FUNCTION                                  *
*                                                          *
*                                                          *
* COPYRIGHT - NONE                                         *
*                                                          *
* STATUS - RELEASE 0  LEVEL 0                              *
*                                                          *
* FUNCTION - CONTAINS NO EXECTABLE CODE, ONLY STATIC TEXT  *
*        ENTRIES FOR THE FUNCTION RECOVER VOLUME           *
*        THIS MODULE IS LOADED BY IDCTP05 WHEN A STATIC    *
*        TEXT REQUEST IS MADE.                             *
*                                                          *
* NOTES - NONE                                             *
*                                                          *
*        DEPENDENCIES - NONE                               *
*        RESTRICTIONS - NONE                               *
*        REGISTER CONVENTIONS - NA                         *
*        PATCH AREA - NA                                   *
*                                                          *
* MODULE TYPE - TABLES                                     *
*                                                          *
*        PROCESSOR - ASSEMBLER                             *
*        MODULE SIZE - 585                                 *
*        ATTRIBUTES - READ-ONLY                            *
*                                                          *
* ENTRY POINT - NA                                         *
*                                                          *
* EXIT NORMAL - NA                                         *
*                                                          *
* EXIT ERROR - NA                                          *
*                                                          *
* EXTERNAL REFERENCES - NA                                 *
*                                                          *
* TABLES - NA                                              *
*                                                          *
* MACROS - NA                                              *
*                                                          *
* CHANGE ACTIVITY - NONE                                   *
*                                                          *
************************************************************
         EJECT
************************************************************
*                                                          *
* THIS MODULE IS THE FIRST MODULE OF STATIC TEXT REQUIRED  *
* BY THE RECOVER VOLUME FSR                                *
*                                                          *
************************************************************
*
IDCTSRV0 CSECT
*
INDEX    DC    Y((INDEXEND-INDEX1)/2)  COUNT OF ENTRIES
INDEX1   DC    Y(TXT1-INDEX)           MSG IDC3710I
INDEX2   DC    Y(TXT2-INDEX)           MSG IDC0711I
INDEX3   DC    Y(TXT3-INDEX)           MSG IDC3712I
INDEXEND DS    0H
         EJECT
**********************************************************
*                                                        *
* IDC3710I ** NO BACKUP COPY VOLUMES EXITS FOR VOLUME    *
*         (VOLSER)                                       *
*                                                        *
**********************************************************
         SPACE 3
TXT1     DC    Y(TXT1B-TXT1A)          ENTRY LENGTH
         DC    X'8000'                 MESSAGE FLAG
         SPACE 1
* SPACING CONTROL SUB-STRUCTURE
TXT1A    DC    X'4000'                 SPACE CONTROL FLAG
         DC    H'1'                    SPACING FACTOR
         DC    C'R '                   SPACING TYPE
         SPACE 1
* STATIC TEXT SUB-STRUCTURE
         DC    X'0400'                 STATIC TEXT FLAG
         DC    Y(STE11B-STE11A)        TEXT LENGTH
         DC    Y(STE11A-TXT1A)         TEXT OFFSET
         DC    H'1'                    PRINT COLUMN
         DC    Y(STE11B-STE11A)        PRINT FIELD LENGTH
         DC    H'0'                    CONVERSION FLAGS
         SPACE 1
* BLOCK DATA SUB-STRUCTURE
         DC    X'9000'
         DC    H'06,00,53,06,00'       FLG,LNG,OFST,PC,
*                                      LNG,FLG
         SPACE 1
* STATIC TEXT ENTRIES
STE11A   DC    C'IDC3710I ** NO BACKUP COPY VOLUMES EXIST'
         DC    C' FOR VOLUME'
STE11B   EQU   *
TXT1B    EQU   *
         EJECT
**********************************************************
*                                                        *
* IDC0711I VOLUME (VOLSER) RESTORED FROM COPY VOLUME     *
*         (VOLSER), COPY DATE (YYDDD)                    *
*                                                        *
**********************************************************
         SPACE 3
TXT2     DC    Y(TXT2B-TXT2A)          ENTRY LENGTH
         DC    X'8000'                 MESSAGE FLAG
         SPACE 1
* SPACING CONTROL SUB-STRUCTURE
TXT2A    DC    X'4000'                 SPACE CONTROL FLAG
         DC    H'2'                    SPACING FACTOR
         DC    C'R '                   SPACING TYPE
         SPACE 1
* STATIC TEXT SUB-STRUCTURE
         DC    X'0400'                 STATIC TEXT FLAG
         DC    Y(STE21B-STE21A)        TEXT LENGTH
         DC    Y(STE21A-TXT2A)         TEXT OFFSET
         DC    H'1'                    PRINT COLUMN
         DC    Y(STE21B-STE21A)        PRINT FIELD LENGTH
         DC    H'0'                    CONVERSION FLAGS
         SPACE 1
* BLOCK DATA SUB-STRUCTURE
         DC    X'1000'
         DC    H'06,00,17,06,00'       LNG,OFST,PC,
*                                      LNG,FLG
         SPACE 1
* STATIC TEXT SUB-STRUCTURE
         DC    X'0400'                 STATIC TEXT FLAG
         DC    Y(STE22B-STE22A)        TEXT LENGTH
         DC    Y(STE22A-TXT2A)         TEXT OFFSET
         DC    H'1'                    PRINT COLUMN
         DC    Y(STE22B-STE22A)        PRINT FIELD LENGTH
         DC    X'0010'                 CONVERSION FLAGS
         SPACE 1
* INSERT DATA SUB-STRUCTURE
         DC    X'2000'
         DC    H'01,00,01,06'          FLG,LNG,OFST,PC,
*                                      LNG
         DC    X'0010'                 CONVERSION FLAGS
         SPACE 1
* STATIC TEXT SUB-STRUCTURE
         DC    X'0400'                 STATIC TEXT FLAG
         DC    Y(STE23B-STE23A)        TEXT LENGTH
         DC    Y(STE23A-TXT2A)         TEXT OFFSET
         DC    H'1'                    PRINT COLUMN
         DC    Y(STE23B-STE23A)        PRINT FIELD LENGTH
         DC    X'0010'                 CONVERSION FLAGS
         SPACE 1
* INSERT DATA SUB-STRUCTURE
         DC    X'A000'
         DC    H'02,00,01,05'          LNG,OFST,PC,LNG
         DC    X'08F0'                 CONVERSION FLGS
         SPACE 1
* STATIC TEXT ENTRIES
STE21A  DC    C'IDC0711I VOLUME'
STE21B  EQU   *
STE22A  DC    C'RESTORED FROM'
STE22B  EQU   *
STE23A  DC    C', COPY DATE'
STE23B  EQU   *
TXT2B   EQU   *
         EJECT
**********************************************************
*                                                        *
* IDC3712I ** LATEST BACKUP COPY RECORD CANNOT BE        *
*          RETRIEVED FROM INVENTORY                      *
*                                                        *
**********************************************************
         SPACE 3
TXT3     DC    Y(TXT3B-TXT3A)          ENTRY LENGTH
         DC    X'8000'                 MESSAGE FLAG
         SPACE 1
* SPACING CONTROL SUB-STRUCTURE
TXT3A    DC    X'4000'                 SPACE CONTROL FLAG
         DC    H'1'                    SPACING FACTOR
         DC    C'R '                   SPACING TYPE
         SPACE 1
* STATIC TEXT SUB-STRUCTURE
         DC    X'8400'                 STATIC TEXT FLAG
         DC    Y(STE31B-STE31A)        TEXT LENGTH
         DC    Y(STE31A-TXT3A)         TEXT OFFSET
         DC    H'1'                    PRINT COLUMN
         DC    Y(STE31B-STE31A)        PRINT FIELD LENGTH
         DC    H'0'                    CONVERSION FLAGS
         SPACE 1
* STATIC TEXT ENTRIES
STE31A   DC    C'IDC3712I ** LATEST BACKUP COPY RECORD '
         DC    C'CANNOT BE RETRIEVED FROM INVENTORY'
STE31B   EQU   *
TXT3B    EQU   *
         END
