* /* START OF SPECIFICATIONS ****
*
*01* MODULE-NAME = IDCTSSA0
*01* MODULE-TYPE = MODULE
*02*   PROCESSOR = ASSEMBLER
*
**** END OF SPECIFICATIONS **
         TITLE  '***** IDCTSSA0 - SYS ADAPTER STATIC TEXT VS/2  *****'
**********************************************************************
*                                                                    *
* MODULE NAME - IDCTSSA0 - STATIC TEXT MODULE FOR SYSTEM ADAPTER     *
*                                                                    *
*                                                                    *
* DESCRIPTIVE NAME - STATIC TEXT MODULE FOR THE SYSTEM ADAPTER       *
*                                                                    *
*                                                                    *
* COPYRIGHT - NONE                                                   *
*                                                                    *
* STATUS - RELEASE 3  LEVEL 0                                        *
*                                                                    *
* FUNCTION - CONTAINS NO EXECUTABLE CODE, ONLY STATIC TEXT ENTRIES   *
*                                                                    *
*        THIS MODULE IS LOADED BY IDCTP05 WHEN A STATIC TEXT         *
*        REQUEST IS MADE.                                            *
*                                                                    *
* NOTES - NONE                                                       *
*                                                                    *
*    DEPENDENCIES - NONE                                             *
*    RESTRICTIONS - NONE                                             *
*    REGISTER CONVENTIONS - NA                                       *
*    PATCH AREA - NA                                                 *
*                                                                    *
* MODULE TYPE - TABLES                                               *
*                                                                    *
*    PROCESSOR - ASSEMBLER                                           *
*    MODULE SIZE - 0800                                              *
*    ATTRIBUTES - READ-ONLY                                          *
*                                                                    *
*  ENTRY POINT - NA                                                  *
*                                                                    *
*  EXIT NORMAL - NA                                                  *
*                                                                    *
*  EXIT ERROR - NA                                                   *
*                                                                    *
*  EXTERNAL REFERENCES - NA                                          *
*                                                                    *
*  TABLES - NA                                                       *
*                                                                    *
*  MACROS - NA                                                       *
*                                                                    *
* CHANGE ACTIVITY -                                                  *
*                                                                    *
*             VS/2 RELEASE 3.824 ADDITIONS                           *
* RACHECK MESSAGES WERE ADDED.                               @G24LSBS*
*                                                                    *
*                                                                    *
**********************************************************************
*
**********************************************************************
*                                                                    *
* THIS MODULE IS THE FIRST MODULE OF STATIC TEXT REQUIRED BY THE     *
* SYSTEM SERVICE ROUTINE.                                            *
*                                                                    *
**********************************************************************
*
IDCTSSA0  CSECT
*
**********************************************************************
*                                                                    *
* THIS SECTION CONTAINS THE INDICES TO REACH AN ENTRY.               *
*                                                                    *
**********************************************************************
*
INDEX     DC  AL2((LASTINDX-INDEX1)/2)  COUNT OF ENTRIES
INDEX1    DC  Y(TXT1-INDEX)             UNABLE TO SCRATCH DSN
INDEX2    DC  Y(TXT2-INDEX)             NO VOLUME MOUNTED
INDEX3    DC  H'-1'                     DSN NOT ON VOLUME (DELETED)
INDEX4    DC  Y(TXT4-INDEX)             BAD PASSWORD
INDEX5    DC  Y(TXT5-INDEX)             NON-EXPIRED DSN ON VOLUME
INDEX6    DC  Y(TXT6-INDEX)             PERM I/O ERROR ON VOLUME
INDEX7    DC  Y(TXT7-INDEX)             UNABLE TO MOUNT VOLUME
INDEX8    DC  Y(TXT8-INDEX)             DATA SET WAS IN USE
INDEX9    DC  Y(TXT9-INDEX)             NO RACF PROFILE ON 'ENTITY'
INDEX10   DC  Y(TXT10-INDEX)            URACHECK FAILED FOR 'ENTITY'
INDEX11   DC  Y(TXT11-INDEX)            INVALID RACF PARM LIST
INDEX12   DC  Y(TXT12-INDEX)            INVALID RACF AUTHORIZATION
*                                                                    *
**********************************************************************
*                                       INSERT ALL INDEX             *
LASTINDX EQU   *                        NUMBERS BEFORE THIS          *
*                                       BOX                          *
**********************************************************************
          EJECT
**********************************************************************
*                                                                    *
* THIS SECTION CONTAINS THE ENTRIES.                                 *
*                                                                    *
**********************************************************************
          EJECT
*
* DATA SET COULD NOT BE SCRATCHED MESSAGE.
*
TXT1      DC    Y(TXT1B-TXT1A)          ENTRY LENGTH.
          DC    X'8000'                 MESSAGE FLAG.
* DOUBLE SPACE SUB-STRUCTURE.
TXT1A     DC    X'4000'                 SPACE CONTROL FLAG.
          DC    H'2'                    SPACING FACTOR.
          DC    C'R '                   SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
          DC    X'0400'                 STATIC TEXT FLAG.
          DC    Y(STE11B-STE11A)        STATIC TEXT LENGTH.
          DC    Y(STE11A-TXT1A)         STATIC TEXT OFFSET.
          DC    H'1'                    PRINT COLUMN NO.
          DC    Y(STE11B-STE11A)        PRINT FIELD LENGTH
          DC    H'0'                    CONVERSION FLAGS(CHAR)
* BLOCK DATA SUB-STRUCTURE.
          DC    X'9000'                 EOF & BLOCK DATA FLAGS
          DC    H'44'                   INPUT DATA LENGTH.
          DC    H'0'                    INPUT DATA OFFSET
          DC    H'28'                   PRINT COLUMN.
          DC    H'44'                   PRINT FIELD LENGTH
          DC    H'0'                    CONVERSION FLAGS(CHAR)
* STATIC ENTRY.
STE11A    DC    C'IDC2909I UNABLE TO SCRATCH '
STE11B    EQU *
TXT1B     EQU *
          EJECT
*
* NO VOLUME MOUNTED MESSAGE.
*
TXT2      DC    Y(TXT2B-TXT2A)          ENTRY LENGTH.
          DC    X'A000'                 MESSAGE FLAG.
* STATIC TEXT SUB-STRUCTURE.
TXT2A     DC    X'8400'                 STATIC TEXT FLAG.
          DC    Y(STE21B-STE21A)        STATIC TEXT LENGTH.
          DC    Y(STE21A-TXT2A)         STATIC TEXT OFFSET.
          DC    H'1'                    PRINT COLUMN.
          DC    Y(STE21B-STE21A)        PRINT FIELD LENGTH.
          DC    H'0'                    CONVERSION FLAGS(CHAR)
* STATIC TEXT ENTRY.
STE21A    DC  C'IDC2910I ** NO VOLUME MOUNTED'
STE21B    EQU *
TXT2B     EQU *
          EJECT
*
* DATA SET NOT ON VOLUME MESSAGE.NO LONGER ISSUED
*
          EJECT
*
* PASSWORD VERIFICATION FAILED MESSAGE.
*
TXT4      DC    Y(TXT4B-TXT4A)          ENTRY LENGTH.
          DC    X'A000'                 MESSAGE FLAG.
* STATIC TEXT SUB-STRUCTURE.
TXT4A     DC    X'8400'                 STATIC TEXT FLAG.
          DC    Y(STE41B-STE41A)        STATIC TEXT LENGTH.
          DC    Y(STE41A-TXT4A)         STATIC TEXT OFFSET.
          DC    H'1'                    PRINT COLUMN.
          DC    Y(STE41B-STE41A)        PRINT FIELD LENGTH.
          DC    H'0'                    CONVERSION FLAGS(CHAR)
* STATIC TEXT ENTRY.
STE41A    DC  C'IDC2912I ** PASSWORD VERIFICATION FAILED'
STE41B    EQU *
TXT4B     EQU *
          EJECT
*
* NON-EXPIRED DATA SET ON VOLUME MESSAGE.
*
TXT5      DC    Y(TXT5B-TXT5A)          ENTRY LENGTH.
          DC    X'A000'                 MESSAGE FLAG.
* STATIC TEXT SUB-STRUCTURE.
TXT5A     DC    X'0400'                 STATIC TEXT FLAG.
          DC    Y(STE51B-STE51A)        STATIC TEXT LENGTH.
          DC    Y(STE51A-TXT5A)         STATIC TEXT OFFSET.
          DC    H'1'                    PRINT COLUMN NO.
          DC    Y(STE51B-STE51A)        PRINT FIELD LENGTH
          DC    H'0'                    CONVERSION FLAGS(CHAR)
* BLOCK DATA SUB-STRUCTURE.
          DC    X'9000'                 EOF & BLOCK DATA FLAGS
          DC    H'6'                    INPUT DATA LENGTH.
          DC    H'0'                    INPUT DATA OFFSET
          DC    H'48'                   PRINT COLUMN.
          DC    H'6'                    PRINT FIELD LENGTH
          DC    H'0'                    CONVERSION FLAGS(CHAR)
* STATIC ENTRY.
STE51A    DC    C'IDC2913I ** DATA SET HAS NOT EXPIRED ON '
          DC    C'VOLUME '
STE51B    EQU *
TXT5B     EQU *
          EJECT
*
* PERMANENT I/O ERROR ON VOLUME MESSAGE.
*
TXT6      DC    Y(TXT6B-TXT6A)          ENTRY LENGTH.
          DC    X'A000'                 MESSAGE FLAG.
* STATIC TEXT SUB-STRUCTURE.
TXT6A     DC    X'0400'                 STATIC TEXT FLAG.
          DC    Y(STE61B-STE61A)        STATIC TEXT LENGTH.
          DC    Y(STE61A-TXT6A)         STATIC TEXT OFFSET.
          DC    H'1'                    PRINT COLUMN NO.
          DC    Y(STE61B-STE61A)        PRINT FIELD LENGTH
          DC    H'0'                    CONVERSION FLAGS(CHAR)
* BLOCK DATA SUB-STRUCTURE.
          DC    X'9000'                 EOF & BLOCK DATA FLAGS
          DC    H'6'                    INPUT DATA LENGTH.
          DC    H'0'                    INPUT DATA OFFSET
          DC    H'43'                   PRINT COLUMN.
          DC    H'6'                    PRINT FIELD LENGTH
          DC    H'0'                    CONVERSION FLAGS(CHAR)
* STATIC ENTRY.
STE61A    DC    C'IDC2914I ** PERMANENT I/O ERROR ON VOLUME '
STE61B    EQU *
TXT6B     EQU *
          EJECT
*
* UNABLE TO MOUNT VOLUME MESSAGE.
*
TXT7      DC    Y(TXT7B-TXT7A)          ENTRY LENGTH.
          DC    X'A000'                 MESSAGE FLAG.
* STATIC TEXT SUB-STRUCTURE.
TXT7A     DC    X'0400'                 STATIC TEXT FLAG.
          DC    Y(STE71B-STE71A)        STATIC TEXT LENGTH.
          DC    Y(STE71A-TXT7A)         STATIC TEXT OFFSET.
          DC    H'1'                    PRINT COLUMN NO.
          DC    Y(STE71B-STE71A)        PRINT FIELD LENGTH
          DC    H'0'                    CONVERSION FLAGS(CHAR)
* BLOCK DATA SUB-STRUCTURE.
          DC    X'9000'                 EOF & BLOCK DATA FLAGS
          DC    H'6'                    INPUT DATA LENGTH.
          DC    H'0'                    INPUT DATA OFFSET
          DC    H'36'                   PRINT COLUMN.
          DC    H'6'                    PRINT FIELD LENGTH
          DC    H'0'                    CONVERSION FLAGS(CHAR)
* STATIC ENTRY.
STE71A    DC    C'IDC2915I ** UNABLE TO MOUNT VOLUME '
STE71B    EQU *
TXT7B     EQU *
          EJECT
*
* DATA SET WAS IN USE MESSAGE.
*
TXT8      DC    Y(TXT8B-TXT8A)          ENTRY LENGTH.
          DC    X'A000'                 MESSAGE FLAG.
* STATIC TEXT SUB-STRUCTURE.
TXT8A    DC    X'8400'                  STATIC TEXT FLAG.
          DC    Y(STE81B-STE81A)        STATIC TEXT LENGTH.
          DC    Y(STE81A-TXT8A)         STATIC TEXT OFFSET.
          DC    H'1'                    PRINT COLUMN NO.
          DC    Y(STE81B-STE81A)        PRINT FIELD LENGTH
          DC    H'0'                    CONVERSION FLAGS(CHAR)
* STATIC ENTRY.
STE81A    DC    C'IDC2916I ** DATA SET WAS IN USE'
STE81B    EQU *
TXT8B     EQU *
          EJECT
*                                                              @G24LSBS
* NO RACF PROFILE NO 'ENTITY' MESSAGE.                         @G24LSBS
*                                                              @G24LSBS
TXT9      DC    Y(TXT9B-TXT9A)          ENTRY LENGTH.          @G24LSBS
          DC    X'8000'                 MESSAGE FLAG.          @G24LSBS
* DOUBLE SPACE SUB-STRUCTURE.                                  @G24LSBS
TXT9A     DC    X'4000'                 SPACE CONTROL FLAG.    @G24LSBS
          DC    H'2'                    SPACING FACTOR.        @G24LSBS
          DC    C'R '                   SPACING TYPE.          @G24LSBS
* STATIC TEXT SUB-STRUCTURE.                                   @G24LSBS
          DC    X'0400'                 STATIC TEXT FLAG.      @G24LSBS
          DC    Y(STE91B-STE91A)        STATIC TEXT LENGTH.    @G24LSBS
          DC    Y(STE91A-TXT9A)         STATIC TEXT OFFSET.    @G24LSBS
          DC    H'1'                    PRINT COLUMN NO.       @G24LSBS
          DC    Y(STE91B-STE91A)        PRINT FIELD LENGTH     @G24LSBS
          DC    H'0'                    CONVERSION FLAGS(CHAR) @G24LSBS
* BLOCK DATA SUB-STRUCTURE.                                    @G24LSBS
          DC    X'9000'                 EOF & BLOCK DATA FLAGS @G24LSBS
          DC    H'44'                   INPUT DATA LENGTH.     @G24LSBS
          DC    H'0'                    INPUT DATA OFFSET      @G24LSBS
          DC    H'29'                   PRINT COLUMN.          @G24LSBS
          DC    H'44'                   PRINT FIELD LENGTH     @G24LSBS
          DC    H'0'                    CONVERSION FLAGS(CHAR) @G24LSBS
* STATIC ENTRY.                                                @G24LSBS
STE91A    DC    C'IDC2917I NO RACF PROFILE ON '                @G24LSBS
STE91B    EQU *                                                @G24LSBS
TXT9B     EQU *                                                @G24LSBS
          EJECT
*                                                              @G24LSBS
* RACHECK FAILED FOR 'ENTITY' MESSAGE.                         @G24LSBS
*                                                              @G24LSBS
TXT10     DC    Y(TXT10B-TXT10A)        ENTRY LENGTH.          @G24LSBS
          DC    X'8000'                 MESSAGE FLAG.          @G24LSBS
* DOUBLE SPACE SUB-STRUCTURE.                                  @G24LSBS
TXT10A    DC    X'4000'                 SPACE CONTROL FLAG.    @G24LSBS
          DC    H'2'                    SPACING FACTOR.        @G24LSBS
          DC    C'R '                   SPACING TYPE.          @G24LSBS
* STATIC TEXT SUB-STRUCTURE.                                   @G24LSBS
          DC    X'0400'                 STATIC TEXT FLAG.      @G24LSBS
          DC    Y(STE101B-STE101A)      STATIC TEXT LENGTH.    @G24LSBS
          DC    Y(STE101A-TXT10A)       STATIC TEXT OFFSET.    @G24LSBS
          DC    H'1'                    PRINT COLUMN NO.       @G24LSBS
          DC    Y(STE101B-STE101A)      PRINT FIELD LENGTH     @G24LSBS
          DC    H'0'                    CONVERSION FLAGS(CHAR) @G24LSBS
* BLOCK DATA SUB-STRUCTURE.                                    @G24LSBS
          DC    X'9000'                 EOF & BLOCK DATA FLAGS @G24LSBS
          DC    H'44'                   INPUT DATA LENGTH.     @G24LSBS
          DC    H'0'                    INPUT DATA OFFSET      @G24LSBS
          DC    H'29'                   PRINT COLUMN.          @G24LSBS
          DC    H'44'                   PRINT FIELD LENGTH     @G24LSBS
          DC    H'0'                    CONVERSION FLAGS(CHAR) @G24LSBS
* STATIC ENTRY.                                                @G24LSBS
STE101A   DC    C'IDC2918I RACHECK FAILED FOR '                @G24LSBS
STE101B   EQU *                                                @G24LSBS
TXT10B    EQU *                                                @G24LSBS
          EJECT
*                                                              @G24LSBS
* INVALID URACHECK PARAMETER LIST MESSAGE.                     @G24LSBS
*                                                              @G24LSBS
TXT11     DC    Y(TXT11B-TXT11A)        ENTRY LENGTH.          @G24LSBS
          DC    X'A000'                 MESSAGE FLAG.          @G24LSBS
* STATIC TEXT SUB-STRUCTURE.                                   @G24LSBS
TXT11A    DC    X'8400'                 STATIC TEXT FLAG.      @G24LSBS
          DC    Y(STE111B-STE111A)      STATIC TEXT LENGTH.    @G24LSBS
          DC    Y(STE111A-TXT11A)       STATIC TEXT OFFSET.    @G24LSBS
          DC    H'1'                    PRINT COLUMN.          @G24LSBS
          DC    Y(STE111B-STE111A)      PRINT FIELD LENGTH.    @G24LSBS
          DC    H'0'                    CONVERSION FLAGS(CHAR) @G24LSBS
* STATIC TEXT ENTRY.                                           @G24LSBS
STE111A   DC  C'IDC2919I INVALID URACHECK PARAMETER LIST'      @G24LSBS
STE111B   EQU *                                                @G24LSBS
TXT11B    EQU *                                                @G24LSBS
          EJECT
*                                                              @G24LSBS
* INVALID RACF AUTHORIZATION   MESSAGE.                        @G24LSBS
*                                                              @G24LSBS
TXT12     DC    Y(TXT12B-TXT12A)        ENTRY LENGTH.          @G24LSBS
          DC    X'A000'                 MESSAGE FLAG.          @G24LSBS
* STATIC TEXT SUB-STRUCTURE.                                   @G24LSBS
TXT12A    DC    X'8400'                 STATIC TEXT FLAG.      @G24LSBS
          DC    Y(STE121B-STE121A)      STATIC TEXT LENGTH.    @G24LSBS
          DC    Y(STE121A-TXT12A)       STATIC TEXT OFFSET.    @G24LSBS
          DC    H'1'                    PRINT COLUMN.          @G24LSBS
          DC    Y(STE121B-STE121A)      PRINT FIELD LENGTH.    @G24LSBS
          DC    H'0'                    CONVERSION FLAGS(CHAR) @G24LSBS
* STATIC TEXT ENTRY.                                           @G24LSBS
STE121A   DC  C'IDC2930I ** INVALID RACF AUTHORIZATION'        @G24LSBS
STE121B   EQU *                                                @G24LSBS
TXT12B    EQU *                                                @G24LSBS
          EJECT
          END
