         TITLE '***** IDCTSSR0 - STOREV STATIC TEXT *****'     @Y30LB31
************************************************************   @Y30LB31
*                                                          *   @Y30LB31
* MODULE NAME -   IDCTSSR0                                 *   @Y30LB31
*                                                          *   @Y30LB31
*                                                          *   @Y30LB31
* DESCRIPTIVE NAME - STATIC TEXT MODULE FOR THE STORE      *   @Y30LB31
*        VOLUME FUNCTION                                   *   @Y30LB31
*                                                          *   @Y30LB31
*                                                          *   @Y30LB31
* COPYRIGHT - NONE                                         *   @Y30LB31
*                                                          *   @Y30LB31
* STATUS - RELEASE 1  LEVEL 0                              *   @Y30LB31
*                                                          *   @Y30LB31
* FUNCTION - CONTAINS NO EXECTABLE CODE, ONLY STATIC TEXT  *   @Y30LB31
*        ENTRIES FOR THE FUNCTION STORE VOLUME             *   @Y30LB31
*        THIS MODULE IS LOADED BY IDCTP05 WHEN A STATIC    *   @Y30LB31
*        TEXT REQUEST IS MADE.                             *   @Y30LB31
*                                                          *   @Y30LB31
* NOTES - NONE                                             *   @Y30LB31
*                                                          *   @Y30LB31
*        DEPENDENCIES - NONE                               *   @Y30LB31
*        RESTRICTIONS - NONE                               *   @Y30LB31
*        REGISTER CONVENTIONS - NA                         *   @Y30LB31
*        PATCH AREA - NA                                   *   @Y30LB31
*                                                          *   @Y30LB31
* MODULE TYPE - TABLES                                     *   @Y30LB31
*                                                          *   @Y30LB31
*        PROCESSOR - ASSEMBLER                             *   @Y30LB31
*        MODULE SIZE - 500                                 *   @Y30LB31
*        ATTRIBUTES - READ-ONLY                            *   @Y30LB31
*                                                          *   @Y30LB31
* ENTRY POINT - NA                                         *   @Y30LB31
*                                                          *   @Y30LB31
* EXIT NORMAL - NA                                         *   @Y30LB31
*                                                          *   @Y30LB31
* EXIT ESROR - NA                                          *   @Y30LB31
*                                                          *   @Y30LB31
* EXTERNAL REFERENCES - NA                                 *   @Y30LB31
*                                                          *   @Y30LB31
* TABLES - NA                                              *   @Y30LB31
*                                                          *   @Y30LB31
* MACROS - NA                                              *   @Y30LB31
*                                                          *   @Y30LB31
* CHANGE ACTIVITY = AS FOLLOWS:                            *   @Y30LB31
*  CHANGE 01 05/06/75 - MESSAGES 3744 AND 3745             *   @ZM31051
*                                                          *   @Y30LB31
************************************************************   @Y30LB31
         EJECT                                                 @Y30LB31
************************************************************   @Y30LB31
*                                                          *   @Y30LB31
* THIS MODULE IS THE FIRST MODULE OF STATIC TEXT REQUIRED  *   @Y30LB31
* BY THE STORE VOLUME FSR                                  *   @Y30LB31
*                                                          *   @Y30LB31
************************************************************   @Y30LB31
*                                                              @Y30LB31
IDCTSSR0 CSECT                                                 @Y30LB31
*                                                              @Y30LB31
INDEX    DC    Y((INDEXEND-INDEX1)/2)  COUNT OF ENTRIES        @Y30LB31
INDEX1   DC    Y(TXT1-INDEX)           MSG IDC3730I            @Y30LB31
INDEX2   DC    Y(TXT2-INDEX)           MSG IDC0731I            @Y30LB31
INDEX3   DC    Y(TXT3-INDEX)           MSG IDC3732I            @Y30LB31
INDEX4   DC    Y(TXT4-INDEX)           MSG IDC0733I            @Y30LB31
INDEX5   DC    Y(TXT5-INDEX)           MSG IDC3734I            @Y30LB31
INDEX6   DC    Y(TXT6-INDEX)           MSG IDC3744I            @ZM31051
INDEX7   DC    Y(TXT7-INDEX)           MSG IDC3745I            @ZM31051
INDEXEND DS    0H                                              @Y30LB31
         EJECT                                                 @Y30LB31
**********************************************************     @Y30LB31
*                                                        *     @Y30LB31
* IDC3730I VOLUME (VOLSER) CANNOT BE RELABELED;          *     @Y30LB31
*          COPIES EXIST                                  *     @Y30LB31
*                                                        *     @Y30LB31
**********************************************************     @Y30LB31
         SPACE 3                                               @Y30LB31
TXT1     DC    Y(TXT1B-TXT1A)          ENTRY LENGTH            @Y30LB31
         DC    X'8000'                 MESSAGE FLAG            @Y30LB31
         SPACE 1                                               @Y30LB31
* SPACING CONTROL SUB-STRUCTURE                                @Y30LB31
TXT1A    DC    X'4000'                 SPACE CONTROL FLAG      @Y30LB31
         DC    H'2'                    SPACING FACTOR          @Y30LB31
         DC    C'R '                   SPACING TYPE            @Y30LB31
         SPACE 1                                               @Y30LB31
* STATIC TEXT SUB-STRUCTURE                                    @Y30LB31
         DC    X'0400'                 STATIC TEXT FLAG        @Y30LB31
         DC    Y(STE11B-STE11A)        TEXT LENGTH             @Y30LB31
         DC    Y(STE11A-TXT1A)         TEXT OFFSET             @Y30LB31
         DC    H'1'                    PRINT COLUMN            @Y30LB31
         DC    Y(STE11B-STE11A)        PRINT FIELD LENGTH      @Y30LB31
         DC    H'0'                    CONVERSION FLAGS        @Y30LB31
         SPACE 1                                               @Y30LB31
* BLOCK DATA SUB-STRUCTURE                                     @Y30LB31
         DC    X'1000'                                         @Y30LB31
         DC    H'06,00,17,06,00'       FLG,LNG,OFST,PC,        @Y30LB31
*                                      LNG,FLG                 @Y30LB31
         SPACE 1                                               @Y30LB31
* STATIC TEXT SUB-STRUCTURE                                    @Y30LB31
         DC    X'8400'                 STATIC TEXT FLAG        @Y30LB31
         DC    Y(STE12B-STE12A)        TEXT LENGTH             @Y30LB31
         DC    Y(STE12A-TXT1A)         TEXT OFFSET             @Y30LB31
         DC    H'1'                    PRINT COLUMN            @Y30LB31
         DC    Y(STE12B-STE12A)        PRINT FIELD LENGTH      @Y30LB31
         DC    X'0010'                 CONVERSION FLAGS        @Y30LB31
         SPACE 1                                               @Y30LB31
* STATIC TEXT ENTRIES                                          @Y30LB31
STE11A   DC    C'IDC3730I VOLUME'                              @Y30LB31
STE11B   EQU   *                                               @Y30LB31
STE12A   DC    C'CANNOT BE RELABELED; COPIES EXIST'            @Y30LB31
STE12B   EQU   *                                               @Y30LB31
TXT1B    EQU   *                                               @Y30LB31
         EJECT                                                 @Y30LB31
**********************************************************     @Y30LB31
*                                                        *     @Y30LB31
* IDC0731I VOLUME (VOLSER) HAS BEEN MADE INACTIVE        *     @Y30LB31
*                                                        *     @Y30LB31
**********************************************************     @Y30LB31
         SPACE 3                                               @Y30LB31
TXT2     DC    Y(TXT2B-TXT2A)          ENTRY LENGTH            @Y30LB31
         DC    X'8000'                 MESSAGE FLAG            @Y30LB31
         SPACE 1                                               @Y30LB31
* SPACING CONTROL SUB-STRUCTURE                                @Y30LB31
TXT2A    DC    X'4000'                 SPACE CONTROL FLAG      @Y30LB31
         DC    H'2'                    SPACING FACTOR          @Y30LB31
         DC    C'R '                   SPACING TYPE            @Y30LB31
         SPACE 1                                               @Y30LB31
* STATIC TEXT SUB-STRUCTURE                                    @Y30LB31
         DC    X'0400'                 STATIC TEXT FLAG        @Y30LB31
         DC    Y(STE21B-STE21A)        TEXT LENGTH             @Y30LB31
         DC    Y(STE21A-TXT2A)         TEXT OFFSET             @Y30LB31
         DC    H'1'                    PRINT COLUMN            @Y30LB31
         DC    Y(STE21B-STE21A)        PRINT FIELD LENGTH      @Y30LB31
         DC    H'0'                    CONVERSION FLAGS        @Y30LB31
         SPACE 1                                               @Y30LB31
* BLOCK DATA SUB-STRUCTURE                                     @Y30LB31
         DC    X'1000'                                         @Y30LB31
         DC    H'06,00,17,06,00'       FLG,LNG,OFST,PC,        @Y30LB31
*                                      LNG,FLG                 @Y30LB31
         SPACE 1                                               @Y30LB31
* STATIC TEXT SUB-STRUCTURE                                    @Y30LB31
         DC    X'8400'                 STATIC TEXT FLAG        @Y30LB31
         DC    Y(STE22B-STE22A)        TEXT LENGTH             @Y30LB31
         DC    Y(STE22A-TXT2A)         TEXT OFFSET             @Y30LB31
         DC    H'1'                    PRINT COLUMN            @Y30LB31
         DC    Y(STE22B-STE22A)        PRINT FIELD LENGTH      @Y30LB31
         DC    X'0010'                 CONVERSION FLAGS        @Y30LB31
         SPACE 1                                               @Y30LB31
* STATIC TEXT ENTRIES                                          @Y30LB31
STE21A   DC    C'IDC0731I VOLUME'                              @Y30LB31
STE21B   EQU   *                                               @Y30LB31
STE22A   DC    C'HAS BEEN MADE INACTIVE'                       @Y30LB31
STE22B   EQU   *                                               @Y30LB31
TXT2B    EQU   *                                               @Y30LB31
         EJECT                                                 @Y30LB31
**********************************************************     @Y30LB31
*                                                        *     @Y30LB31
* IDC3732I ** VOLUME (VOLSER) COULD NOT BE MADE INACTIVE *     @Y30LB31
*                                                        *     @Y30LB31
**********************************************************     @Y30LB31
         SPACE 3                                               @Y30LB31
TXT3     DC    Y(TXT3B-TXT3A)          ENTRY LENGTH            @Y30LB31
         DC    X'8000'                 MESSAGE FLAG            @Y30LB31
         SPACE 1                                               @Y30LB31
* SPACING CONTROL SUB-STRUCTURE                                @Y30LB31
TXT3A    DC    X'4000'                 SPACE CONTROL FLAG      @Y30LB31
         DC    H'1'                    SPACING FACTOR          @Y30LB31
         DC    C'R '                   SPACING TYPE            @Y30LB31
         SPACE 1                                               @Y30LB31
* STATIC TEXT SUB-STRUCTURE                                    @Y30LB31
         DC    X'0400'                 STATIC TEXT FLAG        @Y30LB31
         DC    Y(STE31B-STE31A)        TEXT LENGTH             @Y30LB31
         DC    Y(STE31A-TXT3A)         TEXT OFFSET             @Y30LB31
         DC    H'1'                    PRINT COLUMN            @Y30LB31
         DC    Y(STE31B-STE31A)        PRINT FIELD LENGTH      @Y30LB31
         DC    H'0'                    CONVERSION FLAGS        @Y30LB31
         SPACE 1                                               @Y30LB31
* BLOCK DATA SUB-STRUCTURE                                     @Y30LB31
         DC    X'1000'                                         @Y30LB31
         DC    H'06,00,20,06,00'       FLG,LNG,OFST,PC,        @Y30LB31
*                                      LNG,FLG                 @Y30LB31
         SPACE 1                                               @Y30LB31
* STATIC TEXT SUB-STRUCTURE                                    @Y30LB31
         DC    X'8400'                 STATIC TEXT FLAG        @Y30LB31
         DC    Y(STE32B-STE32A)        TEXT LENGTH             @Y30LB31
         DC    Y(STE32A-TXT3A)         TEXT OFFSET             @Y30LB31
         DC    H'1'                    PRINT COLUMN            @Y30LB31
         DC    Y(STE32B-STE32A)        PRINT FIELD LENGTH      @Y30LB31
         DC    X'0010'                 CONVERSION FLAGS        @Y30LB31
         SPACE 1                                               @Y30LB31
* STATIC TEXT ENTRIES                                          @Y30LB31
STE31A   DC    C'IDC3732I ** VOLUME'                           @Y30LB31
STE31B   EQU   *                                               @Y30LB31
STE32A   DC    C'COULD NOT BE MADE INACTIVE'                   @Y30LB31
STE32B   EQU   *                                               @Y30LB31
TXT3B    EQU   *                                               @Y30LB31
         EJECT                                                 @Y30LB31
**********************************************************     @Y30LB31
*                                                        *     @Y30LB31
* IDC0733I VOLUME LABEL RESTORED TO ORIGINAL STATUS     *      @Y30LB31
*                                                        *     @Y30LB31
**********************************************************     @Y30LB31
         SPACE 3                                               @Y30LB31
TXT4     DC    Y(TXT4B-TXT4A)          ENTRY LENGTH            @Y30LB31
         DC    X'8000'                 MESSAGE FLAG            @Y30LB31
         SPACE 1                                               @Y30LB31
* SPACING CONTROL SUB-STRUCTURE                                @Y30LB31
TXT4A    DC    X'4000'                 SPACE CONTROL FLAG      @Y30LB31
         DC    H'2'                    SPACING FACTOR          @Y30LB31
         DC    C'R '                   SPACING TYPE            @Y30LB31
         SPACE 1                                               @Y30LB31
* STATIC TEXT SUB-STRUCTURE                                    @Y30LB31
         DC    X'8400'                 STATIC TEXT FLAG        @Y30LB31
         DC    Y(STE41B-STE41A)        TEXT LENGTH             @Y30LB31
         DC    Y(STE41A-TXT4A)         TEXT OFFSET             @Y30LB31
         DC    H'1'                    PRINT COLUMN            @Y30LB31
         DC    Y(STE41B-STE41A)        PRINT FIELD LENGTH      @Y30LB31
         DC    H'0'                    CONVERSION FLAGS        @Y30LB31
         SPACE 1                                               @Y30LB31
* STATIC TEXT ENTRIES                                          @Y30LB31
STE41A   DC    C'IDC0733I VOLUME LABEL RESTORED TO '           @Y30LB31
         DC    C'ORIGINAL STATUS'                              @Y30LB31
STE41B   EQU   *                                               @Y30LB31
TXT4B    EQU   *                                               @Y30LB31
         EJECT                                                 @Y30LB31
**********************************************************     @Y30LB31
*                                                        *     @Y30LB31
* IDC3734I ** VOLUME LABEL COULD NOT BE RESTORED TO      *     @Y30LB31
*          ORIGINAL STATUS                               *     @Y30LB31
*                                                        *     @Y30LB31
**********************************************************     @Y30LB31
         SPACE 3                                               @Y30LB31
TXT5     DC    Y(TXT5B-TXT5A)          ENTRY LENGTH            @Y30LB31
         DC    X'8000'                 MESSAGE FLAG            @Y30LB31
         SPACE 1                                               @Y30LB31
* SPACING CONTROL SUB-STRUCTURE                                @Y30LB31
TXT5A    DC    X'4000'                 SPACE CONTROL FLAG      @Y30LB31
         DC    H'1'                    SPACING FACTOR          @Y30LB31
         DC    C'R '                   SPACING TYPE            @Y30LB31
         SPACE 1                                               @Y30LB31
* STATIC TEXT SUB-STRUCTURE                                    @Y30LB31
         DC    X'8400'                 STATIC TEXT FLAG        @Y30LB31
         DC    Y(STE51B-STE51A)        TEXT LENGTH             @Y30LB31
         DC    Y(STE51A-TXT5A)         TEXT OFFSET             @Y30LB31
         DC    H'1'                    PRINT COLUMN            @Y30LB31
         DC    Y(STE51B-STE51A)        PRINT FIELD LENGTH      @Y30LB31
         DC    H'0'                    CONVERSION FLAGS        @Y30LB31
         SPACE 1                                               @Y30LB31
* STATIC TEXT ENTRIES                                          @Y30LB31
STE51A   DC    C'IDC3734I ** VOLUME LABEL COULD NOT BE '       @Y30LB31
         DC    C'RESTORED TO ORIGINAL STATUS'                  @Y30LB31
STE51B   EQU   *                                               @Y30LB31
TXT5B    EQU   *                                               @Y30LB31
         EJECT                                                 @ZM31051
**********************************************************     @ZM31051
*                                                        *     @ZM31051
* IDC3744I JOBCAT/STEPCAT MUST NOT BE SPECIFIED FOR      *     @ZM31051
*          VSAM CATALOG ON VOLUME                        *     @ZM31051
*                                                        *     @ZM31051
**********************************************************     @ZM31051
         SPACE 3                                               @ZM31051
TXT6     DC    Y(TXT6B-TXT6A)          ENTRY LENGTH            @ZM31051
         DC    X'8000'                 MESSAGE FLAG            @ZM31051
         SPACE 1                                               @ZM31051
* SPACING CONTROL SUB-STRUCTURE                                @ZM31051
TXT6A    DC    X'4000'                 SPACE CONTROL FLAG      @ZM31051
         DC    H'2'                    SPACING FACTOR          @ZM31051
         DC    C'R '                   SPACING TYPE            @ZM31051
         SPACE 1                                               @ZM31051
* STATIC TEXT SUB-STRUCTURE                                    @ZM31051
         DC    X'8400'                 STATIC TEXT FLAG        @ZM31051
         DC    Y(STE61B-STE61A)        TEXT LENGTH             @ZM31051
         DC    Y(STE61A-TXT6A)         TEXT OFFSET             @ZM31051
         DC    H'1'                    PRINT COLUMN            @ZM31051
         DC    Y(STE61B-STE61A)        PRINT FIELD LENGTH      @ZM31051
         DC    H'0'                    CONVERSION FLAGS        @ZM31051
         SPACE 1                                               @ZM31051
* STATIC TEXT ENTRIES                                          @ZM31051
STE61A   DC    C'IDC3744I JOBCAT/STEPCAT MUST NOT BE '         @ZM31051
         DC    C'SPECIFIED FOR VSAM CATALOG ON VOLUME'         @ZM31051
STE61B   EQU   *                                               @ZM31051
TXT6B    EQU   *                                               @ZM31051
         EJECT                                                 @ZM31051
**********************************************************     @ZM31051
*                                                        *     @ZM31051
* IDC3745I DD NAME MUST BE SPECIFIED FOR VSAM USER       *     @ZM31051
*          CATALOG ON VOLUME                             *     @ZM31051
*                                                        *     @ZM31051
**********************************************************     @ZM31051
         SPACE 3                                               @ZM31051
TXT7     DC    Y(TXT7B-TXT7A)          ENTRY LENGTH            @ZM31051
         DC    X'8000'                 MESSAGE FLAG            @ZM31051
         SPACE 1                                               @ZM31051
* SPACING CONTROL SUB-STRUCTURE                                @ZM31051
TXT7A    DC    X'4000'                 SPACE CONTROL FLAG      @ZM31051
         DC    H'2'                    SPACING FACTOR          @ZM31051
         DC    C'R '                   SPACING TYPE            @ZM31051
         SPACE 1                                               @ZM31051
* STATIC TEXT SUB-STRUCTURE                                    @ZM31051
         DC    X'8400'                 STATIC TEXT FLAG        @ZM31051
         DC    Y(STE71B-STE71A)        TEXT LENGTH             @ZM31051
         DC    Y(STE71A-TXT7A)         TEXT OFFSET             @ZM31051
         DC    H'1'                    PRINT COLUMN            @ZM31051
         DC    Y(STE71B-STE71A)        PRINT FIELD LENGTH      @ZM31051
         DC    H'0'                    CONVERSION FLAGS        @ZM31051
         SPACE 1                                               @ZM31051
* STATIC TEXT ENTRIES                                          @ZM31051
STE71A   DC    C'IDC3745I DD NAME MUST BE SPECIFIED '          @ZM31051
         DC    C'FOR VSAM USER CATALOG ON VOLUME'              @ZM31051
STE71B   EQU   *                                               @ZM31051
TXT7B    EQU   *                                               @ZM31051
         END
