         TITLE '***** IDCTSTP0 - TEXT PROCESSOR STATIC TEXT *****'
**********************************************************************
*                                                                    *
* MODULE NAME - IDCTSTP0 - STATIC TEXT MODULE FOR TEXT PROCESSOR.    *
*                                                                    *
* DESCRIPTIVE NAME - STATIC TEXT MODULE CONTAINING THE TRANSLATE     *
*        TABLES USED IN PRINT LINE TRANSLATION                       *
*                                                                    *
* COPYRIGHT - NONE                                                   *
*                                                                    *
* STATUS - RELEASE 0  LEVEL 0                                        *
*                                                                    *
* FUNCTION - CONTAINS NO EXECUTABLE CODE, ONLY STATIC TEXT ENTRIES   *
*        FOR THE FUNCTION TEXT PROCESSOR                             *
*        THIS MODULE IS LOADED BY IDCTP05 WHEN A STATIC TEXT         *
*        REQUEST IS MADE.                                            *
*                                                                    *
* NOTES - NONE                                                       *
*                                                                    *
*    DEPENDENCIES - NONE                                             *
*    RESTRICTIONS - NONE                                             *
*    REGISTER CONVENTIONS - NONE                                     *
*    PATCH AREA - NONE                                               *
*                                                                    *
* MODULE TYPE - TABLES                                               *
*                                                                    *
*    PROCESSOR - ASSEMBLER                                           *
*    MODULE SIZE - 1056                                              *
*    ATTRIBUTES - READ-ONLY                                          *
*                                                                    *
*  ENTRY POINT - NA                                                  *
*                                                                    *
*  EXIT NORMAL - NA                                                  *
*                                                                    *
*  EXIT ERROR - NA                                                   *
*                                                                    *
*  EXTERNAL REFERENCES - NA                                          *
*                                                                    *
*  TABLES - NA                                                       *
*                                                                    *
*  MACROS - NA                                                       *
*                                                                    *
* CHANGE ACTIVITY - NONE                                             *
*                                                                    *
**********************************************************************
*01*  MODULE-NAME = IDCTSTP0
**********************************************************************
*                                                                    *
* THIS MODULE IS THE FIRST STATIC TEXT MODULE FOR TEXT OUTPUT        *
* PROCESSING.  IT CONTAINS THE STANDARD TRANSLATE TABLES.            *
*                                                                    *
********************************************************************
*
IDCTSTP0  CSECT
*
*         THIS SECTION CONTAINS THE INDICES TO REACH THE ENTRY.      *
*
INDEX     DC  H'7'                      NULL INDEX VALUE.
INDEX1    DC  Y(TXT1-INDEX)             AN PRINT CHAIN TEXT.
INDEX2    DC  Y(TXT2-INDEX)             PN PRINT CHAIN TEXT.
INDEX3    DC  Y(TXT3-INDEX)             QN PRINT CHAIN TEXT.
INDEX4    DC  Y(TXT4-INDEX)             SN PRINT CHAIN TEXT.
INDEX5    DC  Y(TXT5-INDEX)             TN PRINT CHAIN TEXT.
INDEX6    DC  Y(TXT6-INDEX)             HN PRINT CHAIN TEXT.
INDEX7    DC  Y(TXT7-INDEX)             RN PRINT CHAIN TEXT.
*
* THE BEGINNING OF THE TEXT SECTION.
*
*         THE FOLLOWING IS THE AN PRINT CHAIN TRANSLATE TABLE.
*
          DS  0F
TXT1      DC  Y(TXT1B-TXT1A)            TRAN TABLE LENGTH.
FLG1      DC  H'0'                      FLAG BYTE.
TXT1A     DC  64C'.'
          DC  C' ...........<.+.&&..........$*...-/.........,%'
          DC  C'..............#@..'
          DC  66C'.'
          DC  C'ABCDEFGHI.......JKLMNOPQR........STUVWXYZ......'
          DC  C'0123456789......'
TXT1B     EQU *
*
*         THE FOLLOWING IS THE PN PRINT CHAIN TRANSLATE TABLE
*
          DS  0F
TXT2      DC  Y(TXT2B-TXT2A)            TRAN TABLE LENGTH.
FLG2      DC  H'0'                      FLAG BYTE.
TXT2A     DC  64C'.'
          DC  C' ...........<(+|&&..........$*);^-/.........,%'
          DC  C'_>?..........:#@''="'
          DC  65C'.'
          DC  C'ABCDEFGHI.......JKLMNOPQR........STUVWXYZ......'
          DC  C'0123456789......'
TXT2B     EQU *
*
*         THE FOLLOWING IS THE QN CHAIN TRANSLATE TABLE              *
*
          DS  0F
TXT3      DC  Y(TXT3B-TXT3A)            TRAN TABLE LENGTH.
FLG3      DC  H'0'                      FLAG BYTE.
TXT3A     DC  64C'.'
          DC  C' ...........<(+|&&..........$*);^-/.........,%'
          DC  C'_>?..........:#@''="'
          DC  65C'.'
          DC  C'ABCDEFGHI.......JKLMNOPQR........STUVWXYZ......'
          DC  C'0123456789......'
TXT3B     EQU *
*
*         THE FOLLOWING IS THE SN CHAIN TRANSLATE TABLE.             *
*
          DS  0F
TXT4      DC  Y(TXT4B-TXT4A)            TRAN TABLE LENGTH.
FLG4      DC  H'0'                      FLAG BYTE.
TXT4A     DC  64C'.'
          DC  C' .........[.<(+|&&.........]$*);.-/.........,%'
          DC  C'..?..........:.@''."'
          DC  C'.abcdefghi.......jklmnopqr........stuvwxyz........'
          DC  C'.............',X'BF',C'.'
          DC  C'ABCDEFGHI.......JKLMNOPQR........STUVWXYZ......'
          DC  C'0123456789......'
TXT4B     EQU *
*
*         THE FOLLOWING IS THE TN PRINT CHAIN TRANSLATE TABLE
*
          DS  0F
TXT5      DC  Y(TXT5B-TXT5A)            TRAN TABLE LENGTH.
FLG5      DC  H'0'                      FLAG BYTE.
TXT5A     DC   64C'.'
          DC  C' '
          DC  9C'.'
          DC  X'4A',C'.<(+|&&'
          DC  9C'.'
          DC  C'!$*);^-/'
          DC  9C'.'
          DC  C',%_>?'
          DC  10C'.'
          DC  X'7A7B7C7D7E7F4B8182838485868788894B8B8C8D8E8F'
          DC  X'4B9192939495969798994B9B9C9D9E9F'
          DC  X'A0A1A2A3A4A5A6A7A8A94BABACADAE4B'
          DC  X'B0B1B2B3B4B5B6B7B8B94BBBBCBDBEBF'
          DC  C'.ABCDEFGHI......'
          DC  C'.JKLMNOPQR......'
          DC  C'..STUVWXYZ......'
          DC  C'0123456789......'
TXT5B     EQU *
*
*         THE FOLLOWING IS THE HN PRINT CHAIN TRANSLATE TABLE.
*
          DS  0F
TXT6      DC  Y(TXT6B-TXT6A)            TRAN TABLE LENGTH.
FLG6      DC  H'0'                      FLAG BYTE.
TXT6A     DC  64C'.'
          DC  C' ............(+.&&..........$*)..-/.........,.'
          DC  C'................''='
          DC  66C'.'
          DC  C'ABCDEFGHI.......JKLMNOPQR........STUVWXYZ......'
          DC  C'0123456789......'
TXT6B     EQU *
*
*         THE FOLLOWING IS THE RN PRINT CHAIN TRANSLATE TABLE.
*
          DS  0F
TXT7      DC  Y(TXT7B-TXT7A)            TRAN TABLE LENGTH.
FLG7      DC  H'0'                      FLAG BYTE.
TXT7A     DC  64C'.'
          DC  C' ...........<(+.&&..........$*)..-/.........,%'
          DC  C'..............#@''='
          DC  66C'.'
          DC  C'ABCDEFGHI.......JKLMNOPQR........STUVWXYZ......'
          DC  C'0123456789......'
TXT7B     EQU *
          END
