* /* START OF SPECIFICATIONS ****                            @Y30LSMK
*
*01* MODULE-NAME = IDCTSUV0
*01* MODULE-TYPE = MODULE
*02*   PROCESSOR = ASSEMBLER
*
**** END OF SPECIFICATIONS **                                @Y30LSMK*/
         TITLE '***** IDCTSUV0 - UNIVERSAL STATIC TEXT *****'
**********************************************************************
*                                                                    *
* MODULE NAME - IDCTSUV0 - UNIVERSAL STATIC TEXT MODULE              *
*                                                                    *
* DESCRIPTIVE NAME - UNIVERSALLY USED STATIC TEXT.                   *
*                                                                    *
* COPYRIGHT - NONE                                                   *
*                                                                    *
* STATUS - RELEASE 2  LEVEL 0                                @Y30SSMK*
*                                                                    *
* FUNCTION - CONTAINS NO EXECUTABLE CODE, ONLY STATIC TEXT ENTRIES   *
*        USED BY MORE THAN ONE MODULE.                               *
*        THIS MODULE IS LOADED BY IDCTP05 WHEN A STATIC TEXT         *
*        REQUEST IS MADE.                                            *
*                                                                    *
* NOTES - NONE                                                       *
*                                                                    *
*    DEPENDENCIES - NONE                                             *
*    RESTRICTIONS - NONE                                             *
*    REGISTER CONVENTIONS - NA                                       *
*    PATCH AREA - NA                                                 *
*                                                                    *
* MODULE TYPE - TABLES                                               *
*                                                                    *
*    PROCESSOR - ASSEMBLER                                           *
*    MODULE SIZE - 1240                                      @Y30SSMK*
*    ATTRIBUTES - READ-ONLY                                          *
*                                                                    *
*  ENTRY POINT - NA                                                  *
*                                                                    *
*  EXIT NORMAL - NA                                                  *
*                                                                    *
*  EXIT ERROR - NA                                                   *
*                                                                    *
*  EXTERNAL REFERENCES - NA                                          *
*                                                                    *
*  TABLES - NA                                                       *
*                                                                    *
*  MACROS - NA                                                       *
*                                                                    *
**********************************************************************
*                                                                    *
**********************************************************************
*                                                                    *
* THIS MODULE CONTAINS THOSE MESSAGES THAT ARE COMMON TO ALL FSR'S   *
* AND IN SOME CASES OTHER SERVICE ROUTINES.                          *
*                                                                    *
**********************************************************************
*
IDCTSUV0 CSECT
*
* THIS SECTION CONTAINS THE INDICES TO REACH AN ENTRY.
*
INDEX    DC  H'15'                     COUNT OF ENTRIES.       @Y30SSMK
INDEX1   DC  Y(TXT1-INDEX)             FUNCTION CMPLTD NOPRINT @YL026UE
INDEX2   DC  Y(TXT2-INDEX)             PROCESSING COMPLETE.
INDEX3   DC  Y(TXT3-INDEX)             FUNCTION TERMINATED.
INDEX4   DC  Y(TXT4-INDEX)             INSUFF STORAGE.
INDEX5   DC  Y(TXT5-INDEX)             RECORDS PROCESSED.
INDEX6   DC  Y(TXT6-INDEX)             POSITIONING ERROR.
INDEX7   DC  Y(TXT7-INDEX)             CATALOG ERROR MESSAGE.
INDEX8   DC  Y(TXT8-INDEX)             FUNCT NOT SUPPORTED.    @YL026UE
INDEX9   DC  Y(TXT9-INDEX)             FUNCTION COMPLETED.     @YL026UE
INDEX10  DC  Y(TXT10-INDEX)            CATALOG R.C. AND REASON @Y30SSMK
INDEX11  DC  Y(TXT11-INDEX)            UNABLE TO OPEN CATALOG  @Y30LSMK
INDEX12  DC  Y(TXT12-INDEX)            INSUFF MAIN STORAGE     @Y30LSMK
INDEX13  DC  Y(TXT13-INDEX)            ENTRY XXXX NOT FOUND    @ZA01484
INDEX14  DC  Y(TXT14-INDEX)            DUPLICATE DATA SET      @ZA01484
INDEX15  DC  Y(TXT15-INDEX)            TSO LASTCC MSG          @Y30SSMK
         EJECT
**********************************************************************
*                                                                    *
* THIS SECTION CONTAINS THE ENTRIES.                                 *
*                                                                    *
**********************************************************************
*
* FUNCTION COMPLETED NORMALLY MESSAGE, NOT PRINTED IN TSO.     @YL026UE
*
TXT1     DC  Y(TXT1B-TXT1A)            ENTRY LENGTH.
         DC  X'9000'                   MESSAGE FLAG.           @YL026UE
* SPACING CONTROL SUB-STRUCTURE.
TXT1A    DC  X'4000'                   SPACE CONTROL FLAG.
         DC  H'2'                      SPACING FACTOR.
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC TEXT FLAG.
         DC  Y(STE11B-STE11A)          STATIC TEXT LENGTH.
         DC  Y(STE11A-TXT1A)           STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE11B-STE11A)          PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* BLOCK DATA SUBSTRUCTURE.
         DC  X'9000'                   BLOCK AND EOF FLAGS.
         DC  H'2'                      INPUT LENGTH.
         DC  H'0'                      INPUT OFFSET.
         DC  H'57'                     PRINT COLUMN.
         DC  H'3'                      PRINT FIELD LENGTH.
         DC  X'1060'                   CONVERSION FLAGS.  (BD,AL,SS)
* STATIC TEXT ENTRIES.
STE11A   DC  C'IDC0001I FUNCTION COMPLETED, HIGHEST CONDITION CODE WAS'
STE11B   EQU *
TXT1B    EQU *
         EJECT
*
* IDCAMS PROCESSING COMPLETED MESSAGE. NOT PRINTED IN TSO      @YL026UE
*
TXT2     DC  Y(TXT2B-TXT2A)            ENTRY LENGTH.
         DC  X'9000'                   MESSAGE FLAG.           @YL026UE
* SPACING CONTROL SUB-STRUCTURE.
TXT2A    DC  X'4000'                   SPACE CONTROL FLAG.
         DC  H'2'                      SPACING FACTOR.
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC TEXT FLAG.
         DC  Y(STE21B-STE21A)          STATIC TEXT LENGTH.
         DC  Y(STE21A-TXT2A)           STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE21B-STE21A)          PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* BLOCK DATA SUBSTRUCTURE.
         DC  X'9000'                   BLOCK AND EOF FLAGS.
         DC  H'2'                      INPUT LENGTH.
         DC  H'0'                      INPUT OFFSET.
         DC  H'65'                     PRINT COLUMN.
         DC  H'3'                      PRINT FIELD LENGTH.
         DC  X'1060'                   CONVERSION FLAGS.  (BD,AL,SS)
* STATIC TEXT ENTRIES.
STE21A   DC  C'IDC0002I IDCAMS PROCESSING COMPLETE. MAXIMUM CONDITION C*
               ODE WAS'
STE21B   EQU *
TXT2B    EQU *
         EJECT
*
* FUNCTION TERMINATED ABNORMALLY.
*
TXT3     DC  Y(TXT3B-TXT3A)            ENTRY LENGTH.
         DC  X'8000'                   MESSAGE FLAG.
* SPACING CONTROL SUB-STRUCTURE.
TXT3A    DC  X'4000'                   MESSAGE FLAG.
         DC  H'2'                      SPACING FACTOR.
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC TEXT FLAG.
         DC  Y(STE31B-STE31A)          STATIC TEXT LENGTH.
         DC  Y(STE31A-TXT3A)           STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE31B-STE31A)          PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* BLOCK DATA SUB-STRUCTURE.
         DC  X'9000'                   EOF & BLOCK FLAGS.
         DC  H'2'                      INPUT LENGTH
         DC  H'0'                      INPUT OFFSET.
         DC  H'49'                     PRINT COLUMN.
         DC  H'3'                      PRINT FIELD LENGTH.
         DC  X'1060'                   CONVERSION FLAGS.  (BD,AL,SS)
* STATIC TEXT ENTRIES.
STE31A   DC  C'IDC3003I FUNCTION TERMINATED. CONDITION CODE IS'
STE31B   EQU *
TXT3B    EQU *
         EJECT
*
* FUNCTION TERMINATED, INSUFFICIENT STORAGE.
*
TXT4     DC  Y(TXT4B-TXT4A)            ENTRY LENGTH.
         DC  X'8000'                   MESSAGE FLAG.
* SPACING CONTROL SUB-STRUCTURE.
TXT4A    DC  X'4000'                   SPACE CONTROL FLAG.
         DC  H'2'                      SPACING FACTOR.
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC TEXT FLAG.
         DC  Y(STE41B-STE41A)          STATIC TEXT LENGTH.
         DC  Y(STE41A-TXT4A)           STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE41B-STE41A)          PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* STATIC TEXT ENTRIES.
STE41A   DC  C'IDC3004I FUNCTION TERMINATED. INSUFFICIENT MAIN STORAGE'
STE41B   EQU *
TXT4B    EQU *
         EJECT
*
* NUMBER OF RECORDS PROCESSED.
*
TXT5     DC  Y(TXT5B-TXT5A)            ENTRY LENGTH.
         DC  X'8000'                   MESSAGE FLAG.
* SPACING SUB-STRUCTURE.
TXT5A    DC  X'4000'                   MESSAGE FLAG.
         DC  H'2'                      SPACING FACTOR.
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC TEXT FLAG.
         DC  Y(STE51B-STE51A)          TEXT LENGTH.
         DC  Y(STE51A-TXT5A)           TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE51B-STE51A)          PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* BLOCK DATA SUB-STRUCTURE.
         DC  X'9000'                   BLOCK & EOF FLAGS.
         DC  H'4'                      INPUT LENGTH.
         DC  H'0'                      INPUT OFFSET.
         DC  H'42'                     PRINT COLUMN.
         DC  H'9'                      PRINT LENGTH.
         DC  X'1060'                   CONVERSION FLAGS.  (BD,AL,SS)
* STATIC TEXT ENTRY.
STE51A   DC  C'IDC0005I NUMBER OF RECORDS PROCESSED WAS'
STE51B   EQU *
TXT5B    EQU *
         EJECT
*
* DATA SET BEGINNING POSITIONING ERROR.
*
TXT6     DC  Y(TXT6B-TXT6A)            ENTRY LENGTH.
         DC  X'8000'                   MESSAGE FLAG.
* SPACING CONTROL ENTRY.
TXT6A    DC  X'4000'                   SPACE CONTROL FLAG.
         DC  H'2'                      SPACING FACTOR
         DC  C'R '                     SPACING TYPE
* STATIC TEXT SUB-STRUCTURE.
         DC  X'8400'                   EOF AND STATIC FLAGS.
         DC  Y(STE61B-STE61A)          TEXT LENGTH.
         DC  Y(STE61A-TXT6A)           TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE61B-STE61A)          PRINT FIELD LENGTH.
         DC  X'0000'                   CONVERSION FLAGS.  (CHAR)
* STATIC TEXT ENTRIES.
STE61A   DC  C'IDC3006I FUNCTION TERMINATED DUE TO BEGINNING POSITIONIN*
               G ERROR'
STE61B   EQU *
TXT6B    EQU *
         EJECT
*
* COMMON CATALOG ERROR RETURN MESSAGE.
*
TXT7     DC  Y(TXT7B-TXT7A)            ENTRY LENGTH.
         DC  X'8000'                   MESSAGE FLAG.
* SPACE CONTROL SUB-STRUCTURE.
TXT7A    DC  X'4000'                   SPACING FLAG.
         DC  H'2'                      SPACING FLAG.
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT CONTROL SUB-STRUCTURE.
         DC  X'0400'                   STATIC TEXT FLAG.
         DC  Y(STE71B-STE71A)          ENTRY LENGTH.
         DC  Y(STE71A-TXT7A)           ENTRY OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE71B-STE71A)          PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAG.
* BLOCK DATA SUB-STRUCTURE.
         DC  X'9000'                   EOF & BLOCK DATA FLAG.
         DC  H'2'                      INPUT LENGTH.
         DC  H'0'                      INPUT OFFSET.
         DC  H'38'                     PRINT COLUMN.
         DC  H'3'                      PRINT FIELD LENGTH.
         DC  X'1060'                   CONVERSION FLAGS.  (BD,AL,ZS)
* STATIC TEXT ENTRY.
STE71A   DC  C'IDC3007I VSAM CATALOG RETURN-CODE IS'
STE71B   EQU *
TXT7B    EQU *
         EJECT
*
* FUNCTION NOT SUPPORTED IN THIS ENVIROMENT
*
TXT8     DC  Y(TXT8B-TXT8A)            ENTRY LENGTH.           @YL026UE
         DC  X'8000'                   MESSAGE FLAG.           @YL026UE
* SPACING CONTROL SUB-STRUCTURE.
TXT8A    DC  X'4000'                   SPACE CONTROL FLAG.     @YL026UE
         DC  H'2'                      SPACING FACTOR.         @YL026UE
         DC  C'R '                     SPACING TYPE.           @YL026UE
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC TEXT FLAG.       @YL026UE
         DC  Y(STE81B-STE81A)          STATIC TEXT LENGTH.     @YL026UE
         DC  Y(STE81A-TXT8A)           STATIC TEXT OFFSET.     @YL026UE
         DC  H'1'                      PRINT COLUMN.           @YL026UE
         DC  Y(STE81B-STE81A)          PRINT FIELD LENGTH.     @YL026UE
         DC  H'0'                      CONVERSION FLAG (CHAR)  @YL026UE
* STATIC TEXT ENTRIES.
STE81A   DC  C'IDC3008I FUNCTION IS NOT SUPPORTED IN THIS ENVIROMENT'
STE81B   EQU *                                                 @YL026UE
TXT8B    EQU *                                                 @YL026UE
         EJECT                                                 @YL026UE
*                                                              @YL026UE
* FUNCTION COMPLETED NORMALLY MESSAGE.                         @YL026UE
*                                                              @YL026UE
TXT9     DC  Y(TXT9B-TXT9A)            ENTRY LENGTH.           @YL026UE
         DC  X'9000'                   MESSAGE FLAG.           @ZA01484
* SPACING CONTROL SUB-STRUCTURE.                               @YL026UE
TXT9A    DC  X'4000'                   SPACE CONTROL FLAG.     @YL026UE
         DC  H'2'                      SPACING FACTOR.         @YL026UE
         DC  C'R '                     SPACING TYPE.           @YL026UE
* STATIC TEXT SUB-STRUCTURE.                                   @YL026UE
         DC  X'0400'                   STATIC TEXT FLAG.       @YL026UE
         DC  Y(STE91B-STE91A)          STATIC TEXT LENGTH.     @YL026UE
         DC  Y(STE91A-TXT9A)           STATIC TEXT OFFSET.     @YL026UE
         DC  H'1'                      PRINT COLUMN.           @YL026UE
         DC  Y(STE91B-STE91A)          PRINT FIELD LENGTH.     @YL026UE
         DC  H'0'                      CONVERSION FLAGS.  (CHAR)
* BLOCK DATA SUBSTRUCTURE.                                     @YL026UE
         DC  X'9000'                   BLOCK AND EOF FLAGS.    @YL026UE
         DC  H'2'                      INPUT LENGTH.           @YL026UE
         DC  H'0'                      INPUT OFFSET.           @YL026UE
         DC  H'57'                     PRINT COLUMN.           @YL026UE
         DC  H'3'                      PRINT FIELD LENGTH.     @YL026UE
         DC  X'1060'                   CONVERSION FLAGS.  (BD,AL,SS)
* STATIC TEXT ENTRIES.                                         @YL026UE
STE91A   DC  C'IDC0001I FUNCTION COMPLETED, HIGHEST CONDITION CODE WAS'
STE91B   EQU *                                                 @YL026UE
TXT9B    EQU *                                                 @YL026UE
         EJECT                                                 @Y30SSMK
*                                                              @Y30SSMK
* CATALOG ERROR AND REASON CODE MESSAGE.                       @Y30SSMK
*                                                              @Y30SSMK
TXT10    DC  Y(TXT10B-TXT10A)          ENTRY LENGTH.           @Y30SSMK
         DC  X'A000'                   MESSAGE FLAG.           @Y30SSMK
* SPACING CONTROL SUB-STRUCTURE.                               @Y30SSMK
TXT10A   DC  X'4000'                   SPACING CONTROL FLAG.   @Y30SSMK
         DC  H'1'                      SPACING FACTOR.         @Y30SSMK
         DC  C'R '                     SPACING TYPE.           @Y30SSMK
* STATIC TEXT SUB-STRUCTURE.                                   @Y30SSMK
         DC  X'0400'                   STATIC TEXT FLAG.       @Y30SSMK
         DC  Y(STE101B-STE101A)        STATIC TEXT LENGTH.     @Y30SSMK
         DC  Y(STE101A-TXT10A)         STATIC TEXT OFFSET.     @Y30SSMK
         DC  H'1'                      PRINT COLUMN.           @Y30SSMK
         DC  Y(STE101B-STE101A)        PRINT FIELD LENGTH.     @Y30SSMK
         DC  H'0'                      CONVERSION FLAGS (CHAR) @Y30SSMK
* INSERT DATA SUB-STRUCTURE.                                   @Y30SSMK
         DC  X'2000'                   INSERT DATA FLAG.       @Y30SSMK
         DC  H'1'                      REFERENCE NUMBER.       @Y30SSMK
         DC  H'0'                      UNUSED.                 @Y30SSMK
         DC  H'1'                      PRINT COLUMN.           @Y30SSMK
         DC  H'3'                      PRINT FIELD LENGTH.     @Y30SSMK
         DC  X'1070'                   CONV FLAGS(BD,AL,SS,BS) @Y30SSMK
* STATIC TEXT SUB-STRUCTURE.                                   @Y30SSMK
         DC  X'0400'                   STATIC TEXT FLAG.       @Y30SSMK
         DC  Y(STE102B-STE102A)        STATIC TEXT LENGTH.     @Y30SSMK
         DC  Y(STE102A-TXT10A)         STATIC TEXT OFFSET.     @Y30SSMK
         DC  H'45'                     PRINT COLUMN.           @Y30SSMK
         DC  Y(STE102B-STE102A)        PRINT FIELD LENGTH.     @Y30SSMK
         DC  X'0000'                   CONVERSION FLAGS (CHAR) @Y30SSMK
* INSERT DATA SUB-STRUCTURE.                                   @Y30SSMK
         DC  X'2000'                   INSERT DATA FLAG.       @Y30SSMK
         DC  H'2'                      REFERENCE NUMBER.       @Y30SSMK
         DC  H'0'                      UNUSED.                 @Y30SSMK
         DC  H'0'                      PRINT COLUMN.           @Y30SSMK
         DC  H'2'                      PRINT FIELD LENGTH.     @Y30SSMK
         DC  X'0010'                   CONVERSION FLAGS (BS)   @Y30SSMK
* STATIC TEXT SUB-STRUCTURE.                                   @Y30SSMK
         DC  X'0400'                   STATIC TEXT FLAG.       @Y30SSMK
         DC  Y(STE103B-STE103A)        STATIC TEXT LENGTH.     @Y30SSMK
         DC  Y(STE103A-TXT10A)         STATIC TEXT OFFSET.     @Y30SSMK
         DC  H'0'                      PRINT COLUMN.           @Y30SSMK
         DC  Y(STE103B-STE103A)        PRINT FIELD LENGTH.     @Y30SSMK
         DC  X'0010'                   CONVERSION FLAGS (BS)   @Y30SSMK
* INSERT DATA SUB-STRUCTURE.                                   @Y30SSMK
         DC  X'A000'                   INSERT DATA FLAG.       @Y30SSMK
         DC  H'3'                      REFERENCE NUMBER.       @Y30SSMK
         DC  H'0'                      UNUSED.                 @Y30SSMK
         DC  H'0'                      PRINT COLUMN.           @Y30SSMK
         DC  H'3'                      PRINT FIELD LENGTH.     @Y30SSMK
         DC  X'1070'                   CONV FLAGS(BD,AL,SS,BS) @Y30SSMK
* STATIC TEXT ENTRIES.                                         @Y30SSMK
STE101A  DC  C'IDC3009I ** VSAM CATALOG RETURN CODE IS'        @Y30SSMK
STE101B  EQU *                                                 @Y30SSMK
STE102A  DC  C'- REASON CODE IS IGG0CL'                        @Y30SSMK
STE102B  EQU *                                                 @Y30SSMK
STE103A  DC  C'-'                                              @Y30SSMK
STE103B  EQU *                                                 @Y30SSMK
TXT10B   EQU *                                                 @Y30SSMK
         EJECT                                                 @Y30LSMK
*                                                              @Y30LSMK
* UNABLE TO OPEN CATALOG NAME                                  @Y30LSMK
*                                                              @Y30LSMK
TXT11    DC  Y(TXT11B-TXT11A)          ENTRY LENGTH.           @Y30LSMK
         DC  X'8000'                   MESSAGE FLAG.           @Y30LSMK
* SPACING CONTROL SUB-STRUCTURE.                               @Y30LSMK
TXT11A   DC  X'4000'                   SPACE CONTROL FLAG.     @Y30LSMK
         DC  H'2'                      SPACING FACTOR.         @Y30LSMK
         DC  C'R '                     SPACING TYPE.           @Y30LSMK
* STATIC TEXT SUB-STRUCTURE.                                   @Y30LSMK
         DC  X'0400'                   STATIC TEXT FLAG.       @Y30LSMK
         DC  Y(STE111B-STE111A)        STATIC TEXT LENGTH.     @Y30LSMK
         DC  Y(STE111A-TXT11A)         STATIC TEXT OFFSET.     @Y30LSMK
         DC  H'1'                      PRINT COLUMN.           @Y30SSMK
         DC  Y(STE111B-STE111A)        PRINT FIELD LENGTH.     @Y30LSMK
         DC  H'0'                      CONVERSION FLAGS (CHAR) @Y30LSMK
* BLOCK DATA SUB-STRUCTURE.                                    @Y30LSMK
         DC  X'9000'                   BLOCK AND EOF FLAGS.    @Y30LSMK
         DC  H'44'                     INPUT LENGTH.           @Y30LSMK
         DC  H'0'                      INPUT OFFSET.           @Y30LSMK
         DC  H'25'                     PRINT COLUMN.           @Y30LSMK
         DC  H'44'                     PRINT FIELD LENGTH.     @Y30LSMK
         DC  H'0'                      CONVERSION FLAGS (CHAR) @Y30LSMK
* STATIC TEXT ENTRIES.                                         @Y30LSMK
STE111A  DC  C'IDC3010I UNABLE TO OPEN'                        @Y30LSMK
STE111B  EQU *                                                 @Y30LSMK
TXT11B   EQU *                                                 @Y30LSMK
         EJECT                                                 @Y30LSMK
*                                                              @Y30LSMK
* FUNCTION CANNOT BE EXECUTED, INSUFFICIENT MAIN STORAGE       @Y30LSMK
*                                                              @Y30LSMK
TXT12    DC  Y(TXT12B-TXT12A)          ENTRY LENGTH.           @Y30LSMK
         DC  X'8000'                   MESSAGE FLAG.           @Y30LSMK
* SPACING CONTROL SUB-STRUCTURE.                               @Y30LSMK
TXT12A   DC  X'4000'                   SPACE CONTROL FLAG.     @Y30LSMK
         DC  H'2'                      SPACING FACTOR.         @Y30LSMK
         DC  C'R '                     SPACING TYPE.           @Y30LSMK
* STATIC TEXT SUB-STRUCTURE.                                   @Y30LSMK
         DC  X'0400'                   STATIC TEXT FLAG.       @Y30LSMK
         DC  Y(STE121B-STE121A)        STATIC TEXT LENGTH.     @Y30LSMK
         DC  Y(STE121A-TXT12A)         STATIC TEXT OFFSET.     @Y30LSMK
         DC  H'1'                      PRINT COLUMN.           @Y30LSMK
         DC  Y(STE121B-STE121A)        PRINT FIELD LENGTH.     @Y30LSMK
         DC  H'0'                      CONVERSION FLAGS.(CHAR) @Y30LSMK
* STATIC TEXT ENTRIES.                                         @Y30LSMK
STE121A  DC  C'IDC2011I FUNCTION CANNOT BE EXECUTED. '         @Y30LSMK
         DC  C'INSUFFICIENT MAIN STORAGE'                      @Y30LSMK
STE121B  EQU *                                                 @Y30LSMK
TXT12B   EQU *                                                 @Y30LSMK
         EJECT                                                 @ZA01484
*                                                              @ZA01484
* ENTRY XXXX NOT FOUND                                         @ZA01484
*                                                              @ZA01484
TXT13    DC   Y(TXT13B-TXT13A)         ENTRY LENGTH.           @ZA01484
         DC   X'8000'                  MESSAGE FLAG.           @ZA01484
* SPACING CONTROL SUB-STRUCTURE.                               @ZA01484
TXT13A   DC   X'4000'                  SPACE CONTROL FLAG.     @ZA01484
         DC   H'2'                     SPACING FACTOR.         @ZA01484
         DC   C'R '                    SPACING TYPE.           @ZA01484
* STATIC TEXT SUB-STRUCTURE.                                   @ZA01484
         DC   X'0400'                  STATIC TEXT FLAG.       @ZA01484
         DC   Y(STE131B-STE131A)       STATIC TEXT LENGTH.     @ZA01484
         DC   Y(STE131A-TXT13A)        STATIC TEXT OFFSET.     @ZA01484
         DC   H'1'                     PRINT COLUMN.           @ZA01484
         DC   Y(STE131B-STE131A)       PRINT FIELD LENGTH.     @ZA01484
         DC   H'0'                     CONVERSION FLAGS.       @ZA01484
* BLOCK DATA SUBSTRUCTURE.                                     @ZA01484
         DC  X'1000'                   BLOCK  FLAGS.           @ZA01484
         DC  H'44'                     INPUT LENGTH.           @ZA01484
         DC  H'0'                      INPUT OFFSET.           @ZA01484
         DC  H'16'                     PRINT COLUMN.           @ZA01484
         DC  H'44'                     PRINT FIELD LENGTH.     @ZA01484
         DC  H'0'                      CONVERSION FLAGS.(CHAR) @ZA01484
* STATIC TEXT SUB-STRUCTURE.                                   @ZA01484
         DC   X'8400'                  EOB & STATIC TEXT FLAG. @ZA01484
         DC   Y(STE132B-STE132A)       STATIC TEXT LENGTH.     @ZA01484
         DC   Y(STE132A-TXT13A)        STATIC TEXT OFFSET.     @ZA01484
         DC   H'1'                     PRINT COLUMN.           @ZA01484
         DC   Y(STE132B-STE132A)       PRINT FIELD LENGTH.     @ZA01484
         DC   X'0010'                  CONVERSION FLAGS.(BS,CHAR)
* STATIC TEXT ENTRY.                                           @ZA01484
STE131A  DC   C'IDC3012I ENTRY'                                @ZA01484
STE131B  EQU  *                                                @ZA01484
STE132A  DC   C'NOT FOUND'                                     @ZA01484
STE132B  EQU  *                                                @ZA01484
TXT13B   EQU  *                                                @ZA01484
         EJECT                                                 @ZA01484
*                                                              @ZA01484
* DUPLICATE DATA SET NAME                                      @ZA01484
*                                                              @ZA01484
TXT14    DC   Y(TXT14B-TXT14A)         ENTRY LENGTH.           @ZA01484
         DC   X'8000'                  MESSAGE FLAG.           @ZA01484
* SPACING CONTROL SUB-STRUCTURE.                               @ZA01484
TXT14A   DC   X'4000'                  SPACE CONTROL FLAG.     @ZA01484
         DC   H'2'                     SPACING FACTOR.         @ZA01484
         DC   C'R '                    SPACING TYPE.           @ZA01484
* STATIC TEXT SUB-STRUCTURE.                                   @ZA01484
         DC   X'8400'                  EOB & STATIC TEXT FLAG. @ZA01484
         DC   Y(STE14B-STE14A)         STATIC TEXT LENGTH.     @ZA01484
         DC   Y(STE14A-TXT14A)         STATIC TEXT OFFSET.     @ZA01484
         DC   H'1'                     PRINT COLUMN.           @ZA01484
         DC   Y(STE14B-STE14A)         PRINT FIELD LENGTH.     @ZA01484
         DC   H'0'                                             @ZA01484
* STATIC TEXT ENTRY.                                           @ZA01484
STE14A   DC   C'IDC3013I DUPLICATE DATA SET NAME'              @ZA01484
STE14B   EQU  *                                                @ZA01484
TXT14B   EQU  *                                                @ZA01484
         EJECT                                                 @Y30SSMK
*                                                              @Y30SSMK
* TSO LASTCC MESSAGE.                                          @Y30SSMK
*                                                              @Y30SSMK
TXT15    DC  Y(TXT15B-TXT15A)          ENTRY LENGTH.           @Y30SSMK
         DC  X'8000'                   MESSAGE FLAG.           @ZA01484
* SPACING CONTROL SUB-STRUCTURE.                               @Y30SSMK
TXT15A   DC  X'4000'                   SPACE CONTROL FLAG.     @Y30SSMK
         DC  H'2'                      SPACING FACTOR.         @Y30SSMK
         DC  C'R '                     SPACING TYPE.           @Y30SSMK
* STATIC TEXT SUB-STRUCTURE.                                   @Y30SSMK
         DC  X'0400'                   STATIC TEXT FLAG.       @Y30SSMK
         DC  Y(STE151B-STE151A)        STATIC TEXT LENGTH.     @Y30SSMK
         DC  Y(STE151A-TXT15A)         STATIC TEXT OFFSET.     @Y30SSMK
         DC  H'1'                      PRINT COLUMN.           @Y30SSMK
         DC  Y(STE151B-STE151A)        PRINT FIELD LENGTH.     @Y30SSMK
         DC  H'0'                      CONVERSION FLAGS (CHAR) @Y30SSMK
* BLOCK DATA SUBSTRUCTURE.                                     @Y30SSMK
         DC  X'9000'                   BLOCK AND EOF FLAGS.    @Y30SSMK
         DC  H'2'                      INPUT LENGTH.           @Y30SSMK
         DC  H'0'                      INPUT OFFSET.           @Y30SSMK
         DC  H'17'                     PRINT COLUMN.           @Y30SSMK
         DC  H'3'                      PRINT FIELD LENGTH.     @Y30SSMK
         DC  X'1060'                   CONV FLAGS.  (BD,AL,SS) @Y30SSMK
* STATIC TEXT ENTRIES.                                         @Y30SSMK
STE151A  DC  C'IDC0014I LASTCC='                               @Y30SSMK
STE151B  EQU *                                                 @Y30SSMK
TXT15B   EQU *                                                 @Y30SSMK
         END
