     TITLE  '***** IDCTSXP0 - EXPORT STATIC TEXT *****'
* /* START OF SPECIFICATIONS ****                            @Y30SSFR
*
*01*  MODULE-NAME = IDCTSXP0
*01*  MODULE-TYPE = MODULE
*02*    PROCESSOR = ASSEMBLER
*
**** END OF SPECIFICATIONS **                                @Y30SSFR*/
**********************************************************************
*                                                                    *
* MODULE NAME - IDCTSXP0 - STATIC TEXT MODULE FOR EXPORT             *
*                                                                    *
* DESCRIPTIVE NAME - STATIC TEXT MODULE FOR THE FUNCTION EXPORT      *
*                                                                    *
* COPYRIGHT - NONE                                                   *
*                                                                    *
* STATUS - RELEASE 2  LEVEL 0                                        *
*                                                                    *
* FUNCTION - CONTAINS NO EXECUTABLE CODE, ONLY STATIC TEXT ENTRIES   *
*        FOR THE FUNCTION EXPORT                                     *
*        THIS MODULE IS LOADED BY IDCTP05 WHEN A STATIC TEXT         *
*        REQUEST IS MADE.                                            *
*                                                                    *
* NOTES - NONE                                                       *
*                                                                    *
*    DEPENDENCIES - NONE                                             *
*    RESTRICTIONS - NONE                                             *
*    REGISTER CONVENTIONS - NA                                       *
*    PATCH AREA - NA                                                 *
*                                                                    *
* MODULE TYPE - TABLES                                               *
*                                                                    *
*    PROCESSOR - ASSEMBLER                                           *
*    MODULE SIZE - 630 BYTES                                         *
*    ATTRIBUTES - READ-ONLY                                          *
*                                                                    *
*  ENTRY POINT - NA                                                  *
*                                                                    *
*  EXIT NORMAL - NA                                                  *
*                                                                    *
*  EXIT ERROR - NA                                                   *
*                                                                    *
*  EXTERNAL REFERENCES - NA                                          *
*                                                                    *
*  TABLES - NA                                                       *
*                                                                    *
*  MACROS - NA                                                       *
*                                                                    *
*                                                                    *
**********************************************************************
*
**********************************************************************
*                                                                    *
* THIS MODULE IS THE FIRST MODULE OF STATIC TEXT REQUIRED BY THE     *
* EXPORT FUNCTIONAL SUPPORT ROUTINES.                                *
*                                                                    *
**********************************************************************
*
IDCTSXP0 CSECT
*
* THIS SECTIONS CONTAINS THE INDICES TO REACH AN ENTRY.
*
INDEX    DC  H'10'                     COUNT OF ENTRIES
INDEX1   DC  H'-1'                     NULL
INDEX2   DC  H'-1'                     NULL
INDEX3   DC  Y(TXT3-INDEX)             ENTRY NAME NOT CLUSTER
INDEX4   DC  Y(TXT4-INDEX)             REQUIRED CAT FIELD NOT FOUND
INDEX5   DC  Y(TXT5-INDEX)             GOOD PORTABLE DATA SET
INDEX6   DC  Y(TXT6-INDEX)             PASSWORDS SUPPRESSED.
INDEX7   DC  Y(TXT7-INDEX)             DATA SET NOT USABLE     @Y30SSFR
         EJECT
**********************************************************************
*                                                                    *
* THIS SECTION CONTAINS THE ENTRIES.                                 *
*                                                                    *
**********************************************************************
*
* ENTRY NAME SPECIFIED IN ENTRY PARAMETER IS NOT CLUSTER       @Y30SSFR
* OR ALTERNATE INDEX.                                          @Y30SSFR
*
TXT3     DC  Y(TXT3B-TXT3A)            ENTRY LENGTH.
         DC  X'8000'                   MESSAGE FLAG.
* DOUBLE SPACE SUB-STRUCUTRE.
TXT3A    DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
         DC  H'2'                      SPACING FACTOR
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'8400'                   STATIC TEXT FLAG.
         DC  Y(STE31B-STE31A)          STATIC TEXT LENGTH.
         DC  Y(STE31A-TXT3A)           STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE31B-STE31A)          PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS. (CHAR)
* STATIC TEXT ENTRY.
STE31A   DC  C'IDC3592I THE ENTRY NAME '                       @Y30SSFR
         DC  C'IS NOT CLUSTER OR ALTERNATE INDEX'              @Y30SSFR
STE31B   EQU *
TXT3B    EQU *
         EJECT
*
* A REQUIRED CATALOG FIELD WAS NOT LOCATED.
*
TXT4     DC  Y(TXT4B-TXT4A)            ENTRY LENGTH.
         DC  X'8000'                   MESSAGE FLAG.
* DOUBLE SPACE SUB-STRUCUTRE.
TXT4A    DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
         DC  H'2'                      SPACING FACTOR
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'8400'                   STATIC TEXT FLAG.
         DC  Y(STE41B-STE41A)          STATIC TEXT LENGTH.
         DC  Y(STE41A-TXT4A)           STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE41B-STE41A)          PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS. (CHAR)
* STATIC TEXT ENTRY.
STE41A   DC  C'IDC3593I A REQUIRED CATALOG FIELD WAS NOT LOCATED'
STE41B   EQU *
TXT4B    EQU *
         EJECT
*
* PORTABLE DATA SET CREATED SUCCESSFULLY ON DATE AT TIME.
*
TXT5     DC  Y(TXT5B-TXT5A)            ENTRY LENGTH.
         DC  X'8000'                   MESSAGE FLAG.
* DOUBLE SPACE SUB-STRUCUTRE.
TXT5A   DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
         DC  H'2'                      SPACING FACTOR
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC TEXT FLAG.
         DC  Y(STE51B-STE51A)          STATIC TEXT LENGTH.
         DC  Y(STE51A-TXT5A)           STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE51B-STE51A)          PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS. (CHAR)
* INSERT DATA SUB-STRUCTURE.
         DC  X'2000'                   BLOCK DATA FLAG.
         DC  H'1'                      REFERENCE NUMBER
         DC  H'0'                      UNUSED
         DC  H'52'                     PRINT COLUMN.
         DC  H'8'                      PRINT FIELD LENGTH.
         DC  X'0000'                   CONVERSION FLAG.  (CHAR)
* STATIC TEXT SUB-STRUCTURE.
         DC  X'0400'                   STATIC & EOF FLAGS.
         DC  Y(STE52B-STE52A)          STATIC TEXT LENGTH.
         DC  Y(STE52A-TXT5A)           STATIC TEXT OFFSET.
         DC  H'61'                     PRINT COLUMN OFFSET.
         DC  Y(STE52B-STE52A)          PRINT FIELD LENGTH.
         DC  X'0000'                   CONVERSION FLAG.  (CHAR)
* BLOCK DATA SUB-STRUCTURE.
         DC  X'A000'                   BLOCK DATA FLAG.
         DC  H'2'                      REFERENCE NUMBER
         DC  H'0'                      UNUSED
         DC  H'64'                     PRINT COLUMN.
         DC  H'8'                      PRINT FIELD LENGTH.
         DC  X'0000'                   CONVERSION FLAGS.  (CHAR)
* STATIC TEXT ENTRY.
STE51A   DC  C'IDC0594I PORTABLE DATA SET CREATED SUCCESSFULLY ON'
STE51B   EQU *
STE52A   DC  C'AT'
STE52B   EQU *
TXT5B    EQU *
         EJECT
*
* PASSWORDS SUPPRESSED FOR EXPORTED DATA SET.
*
TXT6     DC  Y(TXT6B-TXT6A)            ENTRY LENGTH.
         DC  X'8000'                   MESSAGE FLAG.
* DOUBLE SPACE SUB-STRUCUTRE.
TXT6A    DC  X'4000'                   SPACE SUB-STRUCTURE FLAG.
         DC  H'2'                      SPACING FACTOR
         DC  C'R '                     SPACING TYPE.
* STATIC TEXT SUB-STRUCTURE.
         DC  X'8400'                   STATIC TEXT FLAG.
         DC  Y(STE61B-STE61A)          STATIC TEXT LENGTH.
         DC  Y(STE61A-TXT6A)           STATIC TEXT OFFSET.
         DC  H'1'                      PRINT COLUMN.
         DC  Y(STE61B-STE61A)          PRINT FIELD LENGTH.
         DC  H'0'                      CONVERSION FLAGS. (CHAR)
* STATIC TEXT ENTRY.
STE61A   DC  C'IDC1595I PASSWORDS SUPPRESSED FOR THE EXPORTED DATA '
         DC  C'SET'
STE61B   EQU *
TXT6B    EQU *
         EJECT                                                 @Y30SSFR
*                                                              @Y30SSFR
* DATA SET TO BE EXPORTED MARKED NOT USABLE                    @Y30SSFR
*                                                              @Y30SSFR
TXT7     DC  Y(TXT7B-TXT7A)            ENTRY LENGTH.           @Y30SSFR
         DC  X'8000'                   MESSAGE FLAG.           @Y30SSFR
* DOUBLE SPACE SUB-STRUCUTRE.                                  @Y30SSFR
TXT7A    DC  X'4000'                   SPACE SUB-STRUCTURE     @Y30SSFR
*                                      FLAG.                   @Y30SSFR
         DC  H'2'                      SPACING FACTOR          @Y30SSFR
         DC  C'R '                     SPACING TYPE.           @Y30SSFR
* STATIC TEXT SUB-STRUCTURE.                                   @Y30SSFR
         DC  X'8400'                   STATIC TEXT FLAG.       @Y30SSFR
         DC  Y(STE71B-STE71A)          STATIC TEXT LENGTH.     @Y30SSFR
         DC  Y(STE71A-TXT7A)           STATIC TEXT OFFSET.     @Y30SSFR
         DC  H'1'                      PRINT COLUMN.           @Y30SSFR
         DC  Y(STE71B-STE71A)          PRINT FIELD LENGTH.     @Y30SSFR
         DC  H'0'                      CONVERSION FLAGS. (CHAR)
* STATIC TEXT ENTRY.                                           @Y30SSFR
STE71A   DC  C'IDC3596I THE DATA SET SPECIFIED '               @Y30SSFR
         DC  C'IN THE EXPORT PARAMETER IS NOT USABLE'          @Y30SSFR
STE71B   EQU *                                                 @Y30SSFR
TXT7B    EQU *                                                 @Y30SSFR
         END
