*        %GOTO WICB1;  /*
         MACRO
         IDDWICB
WICB     DSECT ,                        */
*%WICB1:;
*
*/* *************************************************************** */
*/*                                                                 */
*/*           ***** WINDOW INTERCEPT CONTROL BLOCK *****            */
*/*                                                                 */
*/*   VS2 RELEASE 4.1 7/8/75                                @Z40WSSR*/
*/*                                                                 */
*/*   METHOD OF ACCESS                                              */
*/*      PL/S - DCL WICBPTR PTR                                     */
*/*           - % IDDSWAPP = 'YES'  - INCLUDES THE EXCP INTERCEPT   */
*/*             FRR PARAMETER LIST.                                 */
*/*           - % IDDSWJRN = 'YES'  - INCLUDES WIJOURN FRR          */
*/*             PARAMETER LIST.                                     */
*/*           - % IDDCLSSW = 'YES'  - INCLUDES WICLOSE FRR          */
*/*             PARAMETER LIST.                                     */
*/*      BAL - ONE DSECT PRODUCED. DO USING ON WICB                 */
*/*                                                                 */
*/*   FUNCTION                                                      */
*/*      THE WINDOW INTERCEPT CONTROL BLOCK CONTAINS THE ACTIVE     */
*/*      FIELDS OF THE VAM DATA SET. IT IS ACQUIRED,RELEASED        */
*/*      AND MANIPULATED BY THE WINDOW INTERCEPT.                   */
*/*     IT ALSO CONTAINS STATUS AND CONTROL INFORMATION             */
*/*     THAT IS USED IN INTERPRETING AND SIMULATING EXECUTION       */
*/*     OF THE CHANNEL PROGRAM ASSOCIATED WITH THE EXCP REQUEST     */
*/*     THAT INITIATED VIO PROCESSING.                              */
*/*                                                                 */
*/* VS2 RELEASE 4.1 CHANGES:                                @Z40WSSR*/
*/* C511000, A511100                                        @Z40WSSR*/
*/* *************************************************************** */
*
*%GOTO WICB2;  /*
WICB     DSECT ,                        BOUNDARY
WICSEEKA DS    0CL8                     SEEK ADDRESS OF THE TRACK TO
*                                       BE PLACED IN THE WINDOW.
WICSKAM  DS    CL1                      M - EXTENT NUMBER
WICSKBCH DS    0CL6                     BBCCHH - SEEK ADDRESS
WICSKABB DS    CL2                      BB - BIN NUMBER
WICSKACH DS    0CL4                     CCHH - SEEK ADDRESS
WICSKACC DS    CL2                      CC - CYLINDER NUMBER
WICSKAHH DS    CL2                      HH - HEAD NUMBER
WICSKAR  DS    CL1                      R - RECORD NUMBER
*
WICSTART DS    A                        ADDRESS OF THE FIRST CCW TO BE
*                                       INTERPRETED.
WICAUDIT DS    AL3                      AUDIT TRAIL FLAGS.
*
WICPRT   DS    AL1                      PROTECT KEY FROM UCB
WICRSTCP DS    0CL16                    RESTART CHANNEL PROGRAM EXT
WICCCW1  DS    D                        DATA TRANSFER CCW
WICCCW2  DS    D                        TIC TO NEXT CCW
WICERPSW DS    CL1                      ERP CONTROL SWITCHES
WICERPOV EQU   X'80'                    OVERRUN INCOMPLETE RESTARTED
WICERPWR EQU   X'40'                    WRITE CCW RESTARTED-
*                                       WILL BE RESET BY THE CPI
*                                       USED TO TEST FOR WRITE
*                                       PREREQUISITES
WICERPSV DS    AL3                      ADDRESS OF CCW THAT WAS
*                                        RESTARTED. USED TO INTERPRET
*                                        THE CSW.
WICCAM   DS    A                        ADDRESS OF THE COUNT FIELD OF
*                                       THE CURRENT RECORD.(CURSOR)
WICRELTP DS    H                        POSITION INDICATOR.
WICBFCNT EQU   1                        BEFORE COUNT
WICBFKEY EQU   2                        BEFORE KEY
WICBFDAT EQU   3                        BEFORE DATA
WICAFDAT EQU   4                        AFTER DATA
WICBFHA  EQU   5                        BEFORE HOME ADDRESS
WICBFR0  EQU   6                        BEFORE RECORD ZERO
WICAFR0  EQU   7                        AFTER RECORD ZERO
*
WICKL    DS    H                        CURRENT KEY LENGTH
WICDL    DS    F                        CURRENT DATA LENGTH
*
WICAVXFR DS    F                        NUMBER OF BYTES AVAILABLE FOR
*                                       A READ OR NON-FORMATTED WRITE.
WICREQXF DS    F                        ACCUMULATED BYTES TRANSFERRED
*                                       FOR AN AREA(COUNT, KEY OR DATA)
*                                       DURING A READ OF NON-FORMATTING
*                                       WRITE CCW.
WICOFLG1 DS    CL1                      FLAGS FOR CURRENT OP CODE
*
WICWCKD  EQU   X'80'                    WRITE COUNT KEY DATA
WICWSCKD EQU   X'40'                    WRITE SPECIAL COUN KEY DATA
WICERASE EQU   X'20'                    ERASE
WICFMTW  EQU   X'10'                    FORMAT WRITE SET FOR WCKD,
*                                       WSPCKD, AND ERASE
WICOVFOP EQU   X'08'                    SET FOR RD, RKD, RCKD, WD, WKD
*                                       QUALIFIES FOR OVERFLOW
*                                       PROCESSING
WICSCHTC EQU   X'04'                    SEARCH TIC COMBINATION
WICSID   EQU   X'02'                    SEARCH ID OP CODE
*
WICOFLG2 DS    CL1                      FLAGS FOR CURRENT OP CODE
*
WICXFCOM EQU   X'80'                    TRANSFER COMPLETE OR NOT
*                                       DESIRED
WICDATAX EQU   X'40'                    INDICATE THAT TRANSFER HAS
*                                       BEEN INITIATED
WICINTRP EQU   X'20'                    INDICATE THAT A CONDITION
*                                       EXEIST FOR ENDING THE CHANNEL
*                                       PROGRAM INTERPRETATION
WICERROR EQU   X'10'                    INDICATE THAT AN ERROR HAS
*                                       BEEN DETECTED AFTER THE
*                                       OPERATION HAS STARTED
WICSCHEQ EQU   X'08'                    SET WHEN SID EQUAL OR SK
*                                       EQUAL OP CODE IS USED.
*                                       IF SEARCH IS A FULL SEARCH
*                                       THEN FLAG WICFSIDE OR
*                                       WICFSKE IS SET
WICDC    EQU   X'04'                    DATA CHAINING REQUESTED
WICWRTIP EQU   X'02'                    WRITE IN PROCESS
*
WICSEQFG DS    CL1                      FLAGS FOR SEQUENCE CHECKING
*
WICLWCKD EQU   X'80'                    LAST OPERATION A WCKD
WICFSIDE EQU   X'40'                    A FULL SID EQUAL HAS BEEN
*                                       SATISFIED
WICFSKE  EQU   X'20'                    A FULL SK EQUAL HAS BEEN
*                                       SATISFIED
WICTICFG EQU   X'10'                    TIC BEING PROCESSED
*
WICXOFLG DS    CL1                      ACCROSS OP CODE FLAG
*
WICNDXPT EQU   X'80'                    INDEX POINT SWITCH
WICRCSKT EQU   X'40'                    READ COUNT SEARCH KEY TIC
*                                       COMBINATION DETECTED
WICWORK  DS    A                        GENERAL WORK AREA.
WICERDSP DS    H                        DISPLACEMNT INTO ERROR TABLE
WICLSTOP DS    AL1                      OPCODE OF LAST CCW.
WICCUROP DS    AL1                      CURRENT OP CODE
WICRESTA DS    CL1                      FLAG TO RESTART CONDITIONS
WICPCIRS EQU   X'80'                    RESTARTING FROM PCI EXIT
WICOVFIP EQU   X'40'                    RESTARTING FROM OVERFLOW
*                                       RECORD PROCESSING
WICSEKRS EQU   X'20'                    SEEK ROUTINE CALLED THE TRK
*                                       ROUTINE
WICTRKRS EQU   X'10'                    TRACK REQUEST RESTART FLAG
WICTRMSK EQU   X'08'                    TRACK MANAGER DETECTED AN
*                                       INVALID SEEK ARGGUMENT
WICRSTRT EQU   X'01'                    FOR ALL RESTART SITUATIONS
WICFMASK DS    CL1                      FILE MASK.
*
WICFMVAL EQU   B'00100110'              MASK FOR CHECKING FILE MASK
*                                       BITS 2, 5, AND 6 MUST BE ZERO
WICFMWRT EQU   B'11000000'              BITS 0-1 DESCRIBE THE WRITE
*                                       BITS OF THE FILE MASK
WICFMW00 EQU   B'00000000'              '00' INHIBIT WHA AND WR0
WICFMW01 EQU   B'01000000'              '01' INHIBIT ALL WRITES
WICFMW10 EQU   B'10000000'              '10' INHIBIT WHA,WR0, FORMAT
*                                            WRITES
WICFMW11 EQU   B'11000000'              '11' PERMIT ALL WRITES
*
WICFMSEK EQU   B'00011000'              BITS 3-5 DESCRIBE THE SEEK
*                                       BITS OF THE FILE MASK
WICFMS00 EQU   B'00000000'              '00' PERMIT ALL SEEK
WICFMS01 EQU   B'00001000'              '01' PERMIT CYL AND HEAD SEEKS
WICFMS10 EQU   B'00010000'              '10' PERMIT HEAD SEEKS
WICFMS11 EQU   B'00011000'              '11' INHIBIT ALL SEEKS
WICDVTAB DS    0CL16                    CONDENSED FORM OF DEVICE TABLE
WICMAXCC DS    H                        HIGHEST CYLINDER
WICMAXHH DS    H                        HIGHEST HEAD
WICTRKCP DS    H                        TRACK CAPACITY
WICIGAP  DS    H                        NORMAL-KEYED RECORD OVERHEAD
WICLGAP  DS    H                        LAST-KEYED RECORD OVERHEAD
WICKEYGP DS    H                        KEYED-RECORD OVERHEAD
WICTOL   DS    H                        TOLERANCE
WICTOLSW EQU   WICTOL+1                 SECOND BYTE OF TOLERANCE
*                                       SERVES AS SWITCH AND IF ZERO
*                                       INDICATES TOLERANCE DOES NOT
WICTOLAP EQU   X'00'                    APPLY
WICSECT  DS    AL1                      0-RPS NOT SUPPORTED,
*                                       ^0-HIGHEST POSSIBLE SECTOR
WICNORPS EQU   X'00'                    NOT AN RPS DEVICE IF ZERO
WICDEVTP DS    CL1                      DEVICE TYPE FROM UCB
*
WIC2314  EQU   X'08'                    2314 DEVICE
WICSENSE DS    CL2                      SAVE AREA FOR SENSE BYTES
WICEXPTR DS    A                        POINTER TO DEB EXTENT
*
WICREGSV DS    0CL24                    REGISTER SAVE AREA .
WICCSWSV DS    0CL7                     SAVE AREA FOR CSW
WICCCWER DS    0CL8                     FAKE ERROR CCW
WICRGSV0 DS    F                        FIRST SLOT
WICRGSV1 DS    F                        SECOND SLOT
WICRGSV2 DS    F                        THIRD SLOT
WICRGSV3 DS    F                        FOURTH SLOT
WICRGSV4 DS    F                        FIFTH SLOT
WICRGSV5 DS    F                        SIXTH SLOT
WICDATND DS    A                        ADDRESS OF THE END OF CURRENT
*                                       TRACK.
WICTCB   DS    A                   ADDR OF TCB GETMAINED UNDER VS05944
*
WICCPINT EQU   WICFMASK-WICAVXFR        FIELDS WHICH WILL BE ZEROED OUT
*                                       AT THE BEGINNING OF EACH CHAN-
*                                       NEL PROGRAM AND ARE THE FOLLOW-
*                                       ING
*                                       WICAVXFR
*                                       WICREQXF
*                                       WICOFLG1
*                                       WICOFLG2
*                                       WICSEQFG
*                                       WICXOFLG
*                                       WICWORK
*                                       WICERDSP
*                                       WICLSTOP
*                                       WICCUROP
*                                       WICRESTA
WICOPINT EQU   WICSEQFG-WICAVXFR        FIELD WHICH WILL BE ZEROED OUT
*                                       AT THE BEGINNING OF EACH OP
*                                       CODE PROCESS AND ARE THE
*                                       FOLLOWING
*                                       WICAVXFR
*                                       WICREQXF
*                                       WICOFLG1
*                                       WICOFLG2
         MEND  ,                        */
         %WICB2: ;
* DECLARE 1 WICB BASED(VDSWICB) BDY(DWORD),
*        2  WICSEEKA CHAR(8),           /*SEEK ADDRESS ADDRESS OF THE
*                                       TRACK TO BE PLACED IN THE
*                                       WINDOW */
*          3 WICSKAM CHAR(1),           /* EXTENT NUMBER */
*          3 WICSKBCH CHAR(6),          /* BBCCHH */
*            4 WICSKABB CHAR(2),        /* BB */
*            4 WICSKACH CHAR(4),        /* CCHH */
*              5 WICSKACC CHAR(2),      /* CC */
*              5 WICSKAHH CHAR(2),      /* HH */
*          3 WICSKAR CHAR(1),           /* R */
*        2 WICSTART PTR(31),            /* STARTING ADDRESS OF CHANNEL
*                                       PROGRAM */
*        2 WICAUDIT CHAR(3),            /* AUDIT FLAGS */
*        2 WICPRT FIXED(8),             /* PROTECTION KEY OF CURRENT
*                                       USER AND WICB AND WINDOW */
*        2 WICRSTCP CHAR(16) BDY(DWORD), /* RESTART CHANNEL PROGRAM
*                                       USED BY ERP FUNCTION */
*          3 WICCCW1 CHAR(8) BDY(DWORD), /* FIRST CCW */
*          3 WICCCW2 CHAR(8) BDY(DWORD), /* SECOND CCW */
*        2 WICERPSW CHAR(1),            /* ERP CONTROL SWITCHES */
*          3 WICERPOV BIT(1),           /* ERP RESTART OF OVERFLOW
*                                       INCOMPLETE IN PROGRESS */
*          3 WICERPWR BIT(1),           /* WRITE CCW RESTART - WILL BE
*                                       USED AND RESET BY THE CPI TO
*                                       SATISFY THE WRITE PREREQUISITES
*                                       FOR RESTARTED OVERFLOW
*                                       INCOMPLETE WRITE CCWS */
*          3 * BIT(6),                  /* UNUSED */
*        2 WICERPSV PTR(24) BDY(WORD,2), /* ADDRESS OF CCW THAT WAS
*                                       RESTARTED */
*        2 WICCAM PTR(31),              /* ADDRESS OF THE COUNT FIELD
*                                       OF THE CURRENT RECORD */
*        2 WICRELTP FIXED(15),          /* POSITON IN CURRENT RECORD
*                                       -COUNT KEY OR DATA R0 OR HA */
*        2 WICKL FIXED(15),             /* CURRENT KEY LENGTH */
*        2 WICDL FIXED(31),             /* CURRENT DATA LENGTH */
*        2 WICAVXFR FIXED(31),          /* NUMBER OF BYTES AVAILABLE
*                                       FOR A READ OR NON-FORMATTED
*                                       WRITE */
*        2 WICREQXF FIXED(31),          /* ACCUMULATED BYTES
*                                       TRANSFERRED FOR AN AREA */
*        2 WICOFLG1 BIT(8),             /* FLAGS FOR CURRENT OPCODE */
*          3 WICWCKD BIT(1),            /* WRITE CKD */
*          3 WICWSCKD BIT(1),           /* WRITE SPECIALIAL CKD */
*          3 WICERASE BIT(1),           /* ERASE */
*          3 WICFMTW BIT(1),            /* FORMAT WRITE SET FOR WCKD */
*          3 WICOVFOP BIT(1),           /* SET FOR RD, RKD ,RCKD, WD,
*                                       WKD QUALIFIES FOR OVERFLOW
*                                       PROCESSING */
*          3 WICSCHTC BIT(1),           /* SRCHID TIC *-8 */
*          3 WICSID BIT(1),             /* SEARCH ID IN PROGRESS */
*          3 * BIT(1),                  /* UNUSED */
*        2 WICOFLG2 BIT(8),             /* FLAGS FOR CURRENT OPCODE
*                                       CONTINUED */
*          3 WICXFCOM BIT(1),           /* TRANSFER COMPLETE OR NOT
*                                       DESIRED */
*          3 WICDATAX BIT(1),           /* TRANSFER HAS BEEN INITIATED
*                                       */
*          3 WICINTRP BIT(1),           /* INDICATES THAT A CONDITION
*                                       EXISTS FOR ENDING THE CP
*                                       INTERPRETATION */
*          3 WICERROR BIT(1),           /* ERROR DETECTED AFTER THE
*                                       OPERATION WAS INITIATED */
*          3 WICSCHEQ BIT(1),           /* INDICATES SID OR SRCH KEY IS
*                                       USED. */
*          3 WICDC BIT(1),              /* DATA CHAINING REQUESTED */
*          3 WICWRTIP BIT(1),           /* WRITE OPERATION IN PROGRESS
*                                       */
*        2 WICSEQFG BIT(8),             /* FLAGS FOR SEQUENCE CHECKING
*                                       */
*          3 WICLWCKD BIT(1),           /* LAST OPERATION WAS A WCKD */
*          3 WICFSIDE BIT(1),           /* A FULL SID EQUAL HAS BEEN
*                                       SATISFIED */
*          3 WICFSKE BIT(1),            /* A FULL SRCH KEY EQ HAS BEEN
*                                       SATISFIED */
*          3 WICTICFG BIT(1),           /* TIC PROCESSING IN PROGRESS
*                                       */
*        2 WICXOFLG BIT(8),             /* ACROSS OP CODE PROCESSING */
*          3 WICNDXPT BIT(1),           /* INDEX POINT SWITCH */
*          3 WICRCSKT BIT(1),           /* READ COUNT SRCH KEY TIC *-16
*                                       COMBINATION IN PROGRESS */
*        2 WICWORK FIXED(31),           /* GENERAL WORK AREA */
*        2 WICERDSP  FIXED (15),        /* ERROR TABLE DISPLACEMENT */
*        2 WICLSTOP FIXED(8),           /* OPCODE OF THE LAST CCW */
*        2 WICCUROP FIXED(8),           /* OPCODE OF THE CURRENT CCW */
*        2 WICRESTA BIT(8),             /* RESTART FLAGS */
*          3 WICPCIRS BIT(1),           /* PCI RESTART */
*          3 WICOVFIP BIT(1),           /* OVERFLOW INCOMPLETE RESTART
*                                       */
*          3 WICSEKRS BIT(1),           /* SEEK ROUTINE CALLED THE
*                                       TRACK MANAGER */
*          3 WICTRKRS BIT(1),           /* TRACK REQUEST RESTART FLAG
*                                       */
*          3 WICTRMSK BIT(1),           /* INVVALID SEEK DETECTED
*                                       BY THE TRACK MANAGER */
*          3 *        BIT(2),           /* UNUSED */
*          3 WICRSTRT BIT(1),           /* FOR ALL RESTARTS */
*        2 WICFMASK FIXED(8),           /* FILE MASK */
*        2 WICDVTAB,                    /* DEVICE TABLE INFORMATION */
*          3 WICMAXCC FIXED(15),        /* MAXIMUM CYLINDER NUMBER */
*          3 WICMAXHH FIXED(15),        /* MAXIMUM HEAD NUMBER */
*          3 WICTRKCP FIXED(15),        /* TRACK CAPACITY */
*          3 WICIGAP FIXED(15),         /* INTER RECORD OVERHEAD */
*            4 WICIGP CHAR(2),        /* SAME */
*          3 WICLGAP FIXED(15),         /* LAST RECORD OVERHEAD */
*            4 WICLGP CHAR(2),          /* SAME */
*          3 WICKEYGP FIXED(15),        /* KEYED RECORD OVERHEAD */
*            4 WICKYGP CHAR(2),         /* SAME */
*          3 WICTOL FIXED(15),          /* TOLERANCE */
*          3 WICSECT FIXED(8),          /* HIGH PERMISSABLE SECTOR - =0
*                                       RPS NOT SUPPORTED */
*          3 WICDEVTP FIXED(8),         /* DEVICE TYPE */
*        2 WICSENSE CHAR(2),            /* SAVE AREA FOR SENSE
*                                       INFORMATION */
*        2 WICEXPTR PTR(31),            /* POINTER TO THE EXTENT IN THE
*                                       DEB */
*        2 WICREGSV,                    /* REGISTER SAVE AREA */
*          3 WICRGSV0 FIXED(31),        /* FIRST SLOT */
*          3 WICRGSV1 FIXED(31),        /* SECOND SLOT */
*          3 WICRGSV2 FIXED(31),        /* THIRD SLOT */
*          3 WICRGSV3 FIXED(31),        /* FOURTH SLOT */
*          3 WICRGSV4 FIXED(31),        /* FIFTH SLOT */
*          3 WICRGSV5 FIXED(31),        /* SIXTH SLOT */
*        2 WICDATND PTR(31),            /* ADDRESS OF THE END OF THE
*                                       CURRENT TRACK */
*        2 WICTCB   PTR(31),            /* ADDR OF TCB GETMAINED
*                                         UNDER              @VS05944*/
*        WICCSWSV CHAR(7) DEFINED WICREGSV, /* SAVE AREA FOR CSW */
*        WICCCWER CHAR(8) DEFINED WICREGSV; /* FAKE ERROR CCW */
 % IF IDDSWAPP^='YES' %THEN
     %GOTO WICBXX01;
       DCL  /* PARAMETER LIST EXCP INTERCEPT */
          1 EIFRRPRM BASED(SDWAPARM), /* EXCP INTERCEPT FRR PARAMETER
                                        LIST */
               2 EIRQEPTR PTR(31),      /* RQE ADDRESS */
               2 EIREG5 PTR(31),        /* REGISTER 5 SAVED FOR RETURN
               TO IOS */
               2 EIREG14 PTR(31),       /* REGISTER 14 SAVED FOR RETURN
               TO IOS */
               2 * CHAR(4),             /* FLAGS */
                3 * CHAR(1),              /* FLAG BYTE 1 */
                 4 EIRECUR BIT(1);      /* RECURSIVE ERROR */
 %WICBXX01:;
 %IF IDDSWJRN ^= 'YES' %THEN
     %GOTO WICBXX02;
         @EJECT;
          DCL /* PARAMETERS PASSED TO JOURNAL FRR FROM IDDWIJRN */
          1 JRFRRPRM BASED(SDWAPARM),  /* BASE */
               2 JRTCBPTR PTR(31),      /* A(TCB) PASSED TO WIJOURN */
               2 JRUCBPTR PTR(31);      /* A(CURRENT UCB) */
       DCL  /* PARAMETERS PASSED TO WIJOURN ESTAE ROUTINE */
 % IF IDDIN = 'YES' %THEN
     % GOTO WICBYY01;
         1 ESTJPRMS BASED(SDWAPARM),  /* START */
    % GOTO WICBYY02;
 %WICBYY01:;
         1 ESTJPRMS, /* START */
 %WICBYY02:;
               2 ESJTCB PTR(31), /* ADDRESS OF TCB */
               2 ESJUCB PTR(31), /* ADDRESS OF UCB */
               2 ESJSAVE PTR(31), /* ADDRESS OF SAVE AREA */
               2 ESJBASE PTR(31), /* BASE REGISTER IN WIJOURN */
               2 ESJDATA PTR(31),/* DATA REGISTER IN WIJOURN @Z40WSSR*/
               2 ESJTRFLG FIXED(31); /* ESTAE TRACE FLAG     @Z40WSSR*/
 %WICBXX02:;
 %IF IDDCLSSW ^= 'YES' %THEN
    % GO TO WICBXX03;
         DCL /* PARAMETERS PASSED TO WICLOSE FRR ROUTINE */
         1 CLSFRRPR BASED(SDWAPARM), /* START */
               2 CLVDSCB PTR(31),     /* ADDRESS OF VDSCB */
               2 * CHAR(4),
                 3 * FIXED(8),
                   4 CLSTRMSW BIT(1);  /* =1 TRACK MANAGER IN CONTROL
                   */
 %WICBXX03:;
