         TITLE 'IEAFTIHS-IHSA-FRRS CONTROL BLOCK FORMAT MODULE         *
                        '
IEAFTIHS CSECT ,                                                   0001
@MAINENT DS    0H                                                  0001
         USING *,@15                                               0001
         B     @PROLOG                                             0001
         DC    AL2(@EP00001-@MAINENT)
         DC    AL1(16)                                             0001
         DC    C'IEAFTIHS  78.033'                                 0001
IEAFTFRR DS    0H                                                  0001
         USING *,@15                                               0001
         B     @PROLOG                                             0001
         DC    AL2(@EP00203-IEAFTFRR)
         ENTRY IEAFTFRR
         DROP  @15
@PROLOG  STM   @14,@12,12(@13)                                     0001
         BALR  @11,0                                               0001
@PSTART  LA    @12,4095(,@11)                                      0001
         USING @PSTART,@11                                         0001
         USING @PSTART+4095,@12                                    0001
         L     @00,@SIZDATD                                        0001
         GETMAIN  R,LV=(0)
         LR    @10,@01                                             0001
         USING @DATD,@10                                           0001
         ST    @13,@SA00001+4                                      0001
         LM    @15,@01,16(@13)                                     0001
         ST    @10,8(,@13)                                         0001
         LR    @13,@10                                             0001
         AH    @15,4(,@15)                                         0001
         BR    @15                                                 0001
@EP00001 DS    0H                                                  0002
*                                                                  0120
*/********************************************************************/
*/* FUNCTION -                                                     0120
*      ROUTINE WHICH FORMATS THE INTERRUPT HANDLER SAVE AREA.      0120
*      IT SETS UP THE NEEDED POINTERS TO BE PASSED TO THE FORMAT   0120
*      ROUTINE SENT IN THE PARAMETER LIST.  FOR ANY ERROR ACCESSING
*      A NEEDED FIELD IN THE IHSA OR RT1W OR FOR NON-ZERO RETURN CODE
*      FROM THE FORMATTING SERVICE, THE FOLLOWING MESSAGE WILL BE  0120
*      PRINTED:                                                    0120
*               *** FORMATTING SERVICE ROUTINE ERROR DURING        0120
*               IHSA FORMATTING(POSSIBLE CAUSE:  DATA NOT IN       0120
*               DUMP) ***                                          0120
*      AT THIS POINT PROCESSING WOULD TERMINATE. IF THE IHSA IS    0120
*      FORMATTED WITHOUT ERROR, A BIT SUMMARY OF THE RT1W IS PRINTED
*      USING THE ANALYZE INTERNAL PROCEDURE.                       0120
*                                                                  0120
*   INPUT -                                                        0120
*      REGISTER 1 POINTS TO THE PARMLIST WHICH CONTAINS THE        0120
*      ADDRESS OF THE CONTROL BLOCK TO BE FORMATTED IN ADPLFMT2.   0120
*      ADPLFMT1, ALSO DEFINED AS START, CONTAINS THE OFFSET TO BE  0120
*      PLACED ALONG THE FIRST FIELD IN THE CONTROL BLOCK AND ADPLCOM1
*      CONTAINS THE ADDRESS OF THE ESTAE PARAMETER LIST.           0120
*                                                                  0120
*   CALLS -                                                        0120
*      CALLS CONVERT, FMTRTN, PRINT, AND RT1RTN                    0120
*                                                                  0120
*   CALLED BY -                                                    0120
*       IEAVTFMT TO FORMAT IHSA                                    0120
*                                                                  0120
*   RETURNS TO -                                                   0120
*       IEAVTFMT WITH RETURN CODE SET BY THE ACCESS OR FORMAT SERVICE
*       ROUTINES OR BY RT1RTN.                                       */
*/********************************************************************/
*                                                                  0120
*   ESTAPTR=ADPLCOM1;               /* PTR TO ESTAE PARM LIST        */
         L     ESTAPTR,ADPLCOM1(,ABDPLPTR)                         0120
*   STM(VADR,RCREG,LCALREGS);       /* SAVE REGS FOR RETRY           */
         STM   VADR,RCREG,LCALREGS(ESTAPTR)                        0121
*   ADPLCOM1=ADDR(IHSAFMT);         /* FORMAT ROUTINE ERROR MSG      */
         LA    @14,IHSAFMT                                         0122
         ST    @14,ADPLCOM1(,ABDPLPTR)                             0122
*   IHSAPTR=ADPLFMT2;               /* PTR TO IHSA                   */
         L     IHSAPTR,ADPLFMT2(,ABDPLPTR)                         0123
*   BITS=BITS&&BITS;                /* ZERO ALL INTERNAL BITS        */
*                                                                  0124
         XC    BITS(1),BITS                                        0124
*   /*****************************************************************/
*   /*                                                               */
*   /* IN RELEASE 2 THE POINTER TO THE SUBITS WAS NOT DEFINED.       */
*   /* THEREFORE BEFORE ACCESSING THE SUBIT POINTER, CHECK FOR       */
*   /* RELEASE 2                                                     */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0125
*   VADR=ADDR(CVTNUMB);             /* RELEASE NUMBER                */
         L     @14,CVTPTR(,ABDPLPTR)                               0125
         AL    @14,@CF02109                                        0125
         LR    VADR,@14                                            0125
*   CALL ACCESRTN;                  /* ACCESS IT                     */
         BAL   @14,ACCESRTN                                        0126
*   IF RCREG^=ZERO THEN             /* ACCESS ERROR                  */
         LTR   RCREG,RCREG                                         0127
         BZ    @RF00127                                            0127
*     BUFFER(1:LENGTH(IHSAFMT))=IHSAFMT;/* ERROR MESSAGE             */
         L     @14,ADPLBUF(,ABDPLPTR)                              0128
         MVC   BUFFER(120,@14),IHSAFMT                             0128
*   ELSE                            /* FOUND RELEASE NUMBER          */
*     DO;                                                          0129
         B     @RC00127                                            0129
@RF00127 DS    0H                                                  0130
*       IF DATAHALF^=REL2 THEN      /* NOT A RELEASE 2 MVS SYSTEM    */
         CLC   DATAHALF(2,DATAPTR),REL2                            0130
         BE    @RF00130                                            0130
*         DO;                                                      0131
*                                                                  0131
*           /*********************************************************/
*           /*                                                       */
*           /* FIND WHICH SUS ARE ON SYSTEM                          */
*           /*                                                       */
*           /*********************************************************/
*                                                                  0132
*           VADR=ADDR(CVTIHASU);    /* SUBIT PTR                     */
         L     @14,CVTPTR(,ABDPLPTR)                               0132
         LA    VADR,CVTIHASU(,@14)                                 0132
*           CALL ACCESRTN;          /* ACCESS IT                     */
         BAL   @14,ACCESRTN                                        0133
*           IF RCREG^=ZERO THEN     /* ACCESS ERROR                  */
         LTR   RCREG,RCREG                                         0134
         BZ    @RF00134                                            0134
*             DO;                                                  0135
*               BUFFER(1:LENGTH(IHSAFMT))=IHSAFMT;                 0136
         L     @14,ADPLBUF(,ABDPLPTR)                              0136
         MVC   BUFFER(120,@14),IHSAFMT                             0136
*               ERRSW=ON;           /* INDICATE ACCESS ERROR         */
         OI    ERRSW,B'01000000'                                   0137
*             END;                  /* END ACCESS ERROR              */
*           ELSE                    /* FOUND SUBIT PTR               */
*             DO;                                                  0139
         B     @RC00134                                            0139
@RF00134 DS    0H                                                  0140
*               IF DATAWORD^=ZERO THEN/* THIS IS AN SU SYSTEM        */
         L     @14,DATAWORD(,DATAPTR)                              0140
         LTR   @14,@14                                             0140
         BZ    @RF00140                                            0140
*                 DO;                                              0141
*                   VADR=DATAWORD;  /* ADDRESS OF SUBIT STRING       */
         LR    VADR,@14                                            0142
*                   CALL ACCESRTN;  /* ACCESS IT                     */
         BAL   @14,ACCESRTN                                        0143
*                   IF RCREG^=ZERO THEN/* ACCESS ERROR               */
         LTR   RCREG,RCREG                                         0144
         BZ    @RF00144                                            0144
*                     DO;                                          0145
*                       BUFFER(1:LENGTH(IHSAFMT))=IHSAFMT;         0146
         L     @14,ADPLBUF(,ABDPLPTR)                              0146
         MVC   BUFFER(120,@14),IHSAFMT                             0146
*                       ERRSW=ON;   /* INDICATE ERROR HAS OCCURED    */
         OI    ERRSW,B'01000000'                                   0147
*                     END;          /* END ACCESS ERROR              */
*                   ELSE            /* FOUND SUBITS                  */
*                     DO;                                          0149
         B     @RC00144                                            0149
@RF00144 DS    0H                                                  0150
*                       IF SU50BIT=ON THEN                         0150
         TM    SU50BIT(DATAPTR),B'00100000'                        0150
         BNO   @RF00150                                            0150
*                         SU50SAVE=ON;/* INDICATE SU50 ON SYSTEM     */
         OI    SU50SAVE,B'10000000'                                0151
*                       ELSE                                       0152
*                         ;         /* SU50 NOT ON SYSTEM            */
@RF00150 DS    0H                                                  0153
*                     END;          /* END FOUND SUBITS              */
*                 END;              /* END THIS IS AN SU SYSTEM      */
*               ELSE                                               0155
*                 ;                 /* PRE SU SYSTEM -NO BIT NEEDED  */
@RF00140 DS    0H                                                  0156
*             END;                  /* END COULD ACCESS SUBIT POINTER*/
*         END;                      /* END NOT A RELEASE 2 MVS SYSTEM*/
*       ELSE                                                       0158
*         ;                         /* IS A RELEASE 2 MVS SYSTEM, NO
*                                      SU                            */
@RF00130 DS    0H                                                  0159
*       IF ERRSW=OFF THEN           /* FOUND SYSTEM OK               */
@RC00130 TM    ERRSW,B'01000000'                                   0159
         BNZ   @RF00159                                            0159
*         DO;                                                      0160
*                                                                  0160
*           /*********************************************************/
*           /*                                                       */
*           /* PUT OUT IHSA HEADER                                   */
*           /*                                                       */
*           /*********************************************************/
*                                                                  0161
*           SAVEPTR=ADPLFMT2-START; /* VALUE FOR OFFSET GENERATION   */
         L     @14,ADPLFMT2(,ABDPLPTR)                             0161
         SL    @14,START(,ABDPLPTR)                                0161
         ST    @14,SAVEPTR                                         0161
*           BUFFER(1:LENGTH(IHSAHDR))=IHSAHDR;/* TITLE LINE          */
         L     @14,ADPLBUF(,ABDPLPTR)                              0162
         MVC   BUFFER(54,@14),IHSAHDR                              0162
*           PACKAREA=IHSAPTR;       /* PLACE ADDR IN CHAR AREA       */
         ST    IHSAPTR,PACKAREA                                    0163
*           GARBAGE='04'X;          /* GARBAGE BYTE FOR UNPACK       */
         MVI   GARBAGE,X'04'                                       0164
*           UNPK(ADDRESS,UNPACK);   /* PLACE INTO BUFFER             */
         UNPK  ADDRESS(9,@14),UNPACK(5)                            0165
*           TR(ADDRESS,TRANS);      /* TRANSLATE TO PRINTABLE HEX    */
         TR    ADDRESS(9,@14),TRANS                                0166
*           CALL PRINT;             /* PRINT TITLE LINE              */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0167
         BALR  @14,@15                                             0167
*           BUFFER(1:LENGTH(IHSAUS))=IHSAUS;/* UNDERSCORE            */
         L     @14,ADPLBUF(,ABDPLPTR)                              0168
         MVC   BUFFER(28,@14),IHSAUS                               0168
*           CALL PRINT;             /* PRINT IT                      */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0169
         BALR  @14,@15                                             0169
*           CALL PRINT;             /* BLANK                         */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0170
         BALR  @14,@15                                             0170
*           CALL PRINT;             /* BLANK                         */
*                                                                  0171
         L     @15,ADPLPRNT(,ABDPLPTR)                             0171
         BALR  @14,@15                                             0171
*           /*********************************************************/
*           /*                                                       */
*           /* SECTION UNIQUE TO IHSA                                */
*           /*                                                       */
*           /*********************************************************/
*                                                                  0172
*           DO ARRAYCNT=1 TO DIM(IHSANAME) WHILE(ERRSW=OFF);/* FORMAT
*                                      IHSA UP TO FRRS               */
         LA    ARRAYCNT,1                                          0172
@DL00172 TM    ERRSW,B'01000000'                                   0172
         BNZ   @DC00172                                            0172
*             LINEPTR=IHSANAME(ARRAYCNT);/* FORMAT PATTERN           */
         LR    @14,ARRAYCNT                                        0173
         SLA   @14,2                                               0173
         L     LINEPTR,IHSANAME-4(@14)                             0173
*             CALL CONVERT;         /* OFFSET GENERATOR              */
         BAL   @14,CONVERT                                         0174
*             CALL FMTRTN;          /* FORMAT                        */
         BAL   @14,FMTRTN                                          0175
*           END;                    /* END FORMAT LOOP               */
         AH    ARRAYCNT,@CH00041                                   0176
         CH    ARRAYCNT,@CH00080                                   0176
         BNH   @DL00172                                            0176
@DC00172 DS    0H                                                  0177
*           IF ERRSW=OFF THEN       /* NO ERRORS SO FAR              */
         TM    ERRSW,B'01000000'                                   0177
         BNZ   @RF00177                                            0177
*             DO;                                                  0178
*               CALL PRINT;         /* BLANK                         */
*                                                                  0179
         L     @15,ADPLPRNT(,ABDPLPTR)                             0179
         BALR  @14,@15                                             0179
*               /*****************************************************/
*               /*                                                   */
*               /* IHSA SECTION WHICH CHANGES WITH SU50              */
*               /*                                                   */
*               /*****************************************************/
*                                                                  0180
*               BUFFER(31:(LENGTH(IHSAFMSG)+30))=IHSAFMSG;/* FRRS  0180
*                                      STACK HDR                     */
         L     @14,ADPLBUF(,ABDPLPTR)                              0180
         MVC   BUFFER+30(9,@14),IHSAFMSG                           0180
*               CALL PRINT;         /* PRINT IT                      */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0181
         BALR  @14,@15                                             0181
*               BUFFER(31:(LENGTH(IHSAFRUS)+30))=IHSAFRUS;/*       0182
*                                      UNDERSCORE                    */
         L     @14,ADPLBUF(,ABDPLPTR)                              0182
         MVC   BUFFER+30(9,@14),IHSAFRUS                           0182
*               CALL PRINT;         /* PRINT IT                      */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0183
         BALR  @14,@15                                             0183
*               CALL PRINT;         /* BLANK                         */
*                                                                  0184
         L     @15,ADPLPRNT(,ABDPLPTR)                             0184
         BALR  @14,@15                                             0184
*               /*****************************************************/
*               /*                                                   */
*               /* THIS LINE OF THE FRRS IS FORMATTED HERE BECAUSE   */
*               /* SU50 CHANGED THE CONTENTS OF THIS AREA            */
*               /*                                                   */
*               /*****************************************************/
*                                                                  0185
*               FRRSPTR=ADPLFMT2;   /* SET PTR FOR FIGURING NUM    0185
*                                      ENTRIES                       */
         MVC   FRRSPTR(4),ADPLFMT2(ABDPLPTR)                       0185
*               ARRAYCNT=1;                                        0186
         LA    ARRAYCNT,1                                          0186
*               IF SU50SAVE=ON THEN /* SU50 ON SYSTEM                */
         TM    SU50SAVE,B'10000000'                                0187
         BNO   @RF00187                                            0187
*                 LINEPTR=IHSASU50(ARRAYCNT);/* SU50 VERSION         */
         LR    @14,ARRAYCNT                                        0188
         SLA   @14,2                                               0188
         L     LINEPTR,IHSASU50-4(@14)                             0188
*               ELSE                /* NON SU50 VERSION              */
*                 LINEPTR=FRRNAMES(ARRAYCNT);/* COMMON FRRS LINE     */
         B     @RC00187                                            0189
@RF00187 LR    @14,ARRAYCNT                                        0189
         SLA   @14,2                                               0189
         L     LINEPTR,FRRNAMES-4(@14)                             0189
*               CALL CONVERT;       /* OFFSET                        */
@RC00187 BAL   @14,CONVERT                                         0190
*               CALL FMTRTN;        /* FORMAT                        */
         BAL   @14,FMTRTN                                          0191
*               IF ERRSW=OFF THEN                                  0192
         TM    ERRSW,B'01000000'                                   0192
         BNZ   @RF00192                                            0192
*                 CALL RT1RTN;      /* IF STILL NO ERRORS FINISH   0193
*                                      PROCESSING                    */
         BAL   @14,RT1RTN                                          0193
*               ELSE                                               0194
*                 ;                 /* FRRS ERROR                    */
@RF00192 DS    0H                                                  0195
*             END;                  /* END NO IHSA ERROR             */
*           ELSE                                                   0196
*             ;                     /* IHSA ERROR                    */
@RF00177 DS    0H                                                  0197
*         END;                      /* END FOUND SYSTEM              */
*       ELSE                                                       0198
*         ;                         /* ERROR FINDING SYSTEM          */
@RF00159 DS    0H                                                  0199
*     END;                          /* END COULD ACCESS REL NUMBER   */
*   CALL PRINT;                     /* ERROR MSG OR BLANK            */
@RC00127 L     @15,ADPLPRNT(,ABDPLPTR)                             0200
         BALR  @14,@15                                             0200
*   LCALREGS=RTYREGS;               /* RESTORE RETRY REGS OF CALLER  */
         MVC   LCALREGS(64,ESTAPTR),RTYREGS(ESTAPTR)               0201
*   RETURN CODE(RCCODE);            /* DO NOT ENTER FRR CODE         */
         L     @09,RCCODE                                          0202
         L     @13,4(,@13)                                         0202
         L     @00,@SIZDATD                                        0202
         LR    @01,@10                                             0202
         FREEMAIN R,LV=(0),A=(1)
         LR    @15,@09                                             0202
         L     @14,12(,@13)                                        0202
         LM    @00,@12,20(@13)                                     0202
         BR    @14                                                 0202
*IEAFTFRR:                                                         0203
*   ENTRY;                                                         0203
*                                                                  0203
@EP00203 DS    0H                                                  0204
*/********************************************************************/
*/* FUNCTION-                                                      0204
*       ROUTINE WHICH FORMATS THE FRR STACK TITLE AND LINES WHICH ARE
*     DIFFERENT THAN THOSE IN THE INTERRUPT HANDLER SAVE AREA.     0204
*     IT SETS UP THE NEEDED POINTERS TO BE PASSED TO THE FORMAT ROUTINE
*     SENT IN THE PARAMETER LIST.  FOR ANY ERROR ACCESSING A NEEDED
*     FIELD IN THE FRRS OR FOR NON-ZERO RETURN CODE FROM THE       0204
*     FORMATTING SERVICE, THE FOLLOWING MESSAGES WILL BE PRINTED:  0204
*                       *** FORMATTING SERVICE ROUTINE ERROR DURING FRR
*                           FORMATTING (POSSIBLE CAUSE: DATA NOT IN
*                           DUMP ) ***.                            0204
*     AT THIS POINT, FOR EITHER REASON, THE FRR PROCESSING WOULD   0204
*     TERMINATE. IF THE FRR LINES ARE FORMATTED WITHOUT AN ACCESS  0204
*     ERROR, THE ROUTINE TO FORMAT THE FRRS-IHSA COMMON AREAS IS   0204
*     CALLED.                                                      0204
*                                                                  0204
*   INPUT-                                                         0204
*       REGISTER 1 POINTS TO THE PARMLIST WHICH CONTAINS THE ADDRESS
*     OF THE CONTROL BLOCK TO BE FORMATTED IN ADPLFMT2. ADPLFMT1 ALSO
*     DEFINED AS START, CONTAINS THE OFFSET TO BE PLACED ALONG SIDE
*     THE FIRST FIELD IN THE CONTROL BLOCK AND ADPLCOM1 CONTAINS THE
*     ADDRESS OF THE ESTAE PARAMETER LIST.                         0204
*                                                                  0204
*   CALLS-                                                         0204
*       CALLS ACCESRTN,CONVERT,FMTRTN,RT1RTN,AND PRINT             0204
*                                                                  0204
*   CALLED BY -                                                    0204
*       IEAVTFMT TO FORMAT FRRS AND RT1W.                          0204
*                                                                  0204
*   RETURNS TO -                                                   0204
*       CALLER WITH A RETURN CODE SET BY THE ACCESS OR FORMAT      0204
*       SERVICE ROUTINES OR BY RT1RTN.                               */
*/********************************************************************/
*                                                                  0204
*   ESTAPTR=ADPLCOM1;               /* PTR TO ESTAE PARM LIST        */
         L     ESTAPTR,ADPLCOM1(,ABDPLPTR)                         0204
*   STM(VADR,RCREG,LCALREGS);       /* SAVE REGS FOR RETRY           */
         STM   VADR,RCREG,LCALREGS(ESTAPTR)                        0205
*   ADPLCOM1=ADDR(FRRSFMT);         /* FORMAT ROUTINE ERROR MESSAGE  */
         LA    @14,FRRSFMT                                         0206
         ST    @14,ADPLCOM1(,ABDPLPTR)                             0206
*   FRRSPTR=ADPLFMT2;               /* PTR TO FRRS CONTROL BLOCK     */
         L     @14,ADPLFMT2(,ABDPLPTR)                             0207
         ST    @14,FRRSPTR                                         0207
*   BITS=BITS&&BITS;                /* ZERO THE INTERNAL BITS        */
         XC    BITS(1),BITS                                        0208
*   SAVEPTR=ADPLFMT2-START;         /* VALUE FOR DYNAMIC OFFSET    0209
*                                      GENERATOR                     */
         LR    @08,@14                                             0209
         SL    @08,START(,ABDPLPTR)                                0209
         ST    @08,SAVEPTR                                         0209
*   BUFFER(1:LENGTH(FRRHDR))=FRRHDR;/* TITLE LINE                    */
         L     @08,ADPLBUF(,ABDPLPTR)                              0210
         MVC   BUFFER(54,@08),FRRHDR                               0210
*   PACKAREA=FRRSPTR;               /* PLACE ADDR INTO CHAR AREA     */
         ST    @14,PACKAREA                                        0211
*   GARBAGE='04'X;                  /* GARBAGE BYTE FOR THE UNPACK   */
         MVI   GARBAGE,X'04'                                       0212
*   UNPK(ADDRESS,UNPACK);           /* PLACE ADDRESS INTO BUFFER LINE*/
         UNPK  ADDRESS(9,@08),UNPACK(5)                            0213
*   TR(ADDRESS,TRANS);              /* TRANSLATE TO PRINTABLE HEX    */
         TR    ADDRESS(9,@08),TRANS                                0214
*   CALL PRINT;                     /* PRINT TITLE                   */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0215
         BALR  @14,@15                                             0215
*   BUFFER(1:LENGTH(FRRSUS))=FRRSUS;/* UNDERSCORE                    */
         L     @14,ADPLBUF(,ABDPLPTR)                              0216
         MVC   BUFFER(18,@14),FRRSUS                               0216
*   CALL PRINT;                     /* PRINT IT                      */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0217
         BALR  @14,@15                                             0217
*   CALL PRINT;                     /* BLANK                         */
*                                                                  0218
         L     @15,ADPLPRNT(,ABDPLPTR)                             0218
         BALR  @14,@15                                             0218
*   /*****************************************************************/
*   /*                                                               */
*   /* SECTION OF THE FRR STACK PRECEDING THE FRR ENTRIES            */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0219
*   ARRAYCNT=1;                     /* FIRST FORMAT PATTERN          */
         LA    ARRAYCNT,1                                          0219
*   LINEPTR=FRRNAMES(ARRAYCNT);     /* ADDRESS OF FIRST FORMAT     0220
*                                      PATTERN                       */
         LR    @14,ARRAYCNT                                        0220
         SLA   @14,2                                               0220
         L     LINEPTR,FRRNAMES-4(@14)                             0220
*   CALL CONVERT;                   /* GENERATE OFFSET               */
         BAL   @14,CONVERT                                         0221
*   CALL FMTRTN;                    /* FORMAT                        */
         BAL   @14,FMTRTN                                          0222
*   IF ERRSW=OFF THEN               /* CONTINUE ONLY IF FORMATTED OK */
         TM    ERRSW,B'01000000'                                   0223
         BNZ   @RF00223                                            0223
*     CALL RT1RTN;                  /* ROUTINE TO FORMAT FRR IHSA  0224
*                                      COMMON AREAS                  */
         BAL   @14,RT1RTN                                          0224
*   ELSE                                                           0225
*     ;                             /* DID NOT FORMAT OK             */
@RF00223 DS    0H                                                  0226
*   LCALREGS=RTYREGS;               /* RESTORE RETRY REGS OF CALLER  */
         MVC   LCALREGS(64,ESTAPTR),RTYREGS(ESTAPTR)               0226
*   RETURN CODE(RCCODE);            /* END ENTRY POINT IEAFTFRR      */
         L     @09,RCCODE                                          0227
         L     @13,4(,@13)                                         0227
         L     @00,@SIZDATD                                        0227
         LR    @01,@10                                             0227
         FREEMAIN R,LV=(0),A=(1)
         LR    @15,@09                                             0227
         L     @14,12(,@13)                                        0227
         LM    @00,@12,20(@13)                                     0227
         BR    @14                                                 0227
*RT1RTN:                                                           0228
*   PROC OPTIONS(SAVE(14));                                        0228
*                                                                  0228
@EL00001 L     @13,4(,@13)                                         0228
@EF00001 L     @00,@SIZDATD                                        0228
         LR    @01,@10                                             0228
         FREEMAIN R,LV=(0),A=(1)
@ER00001 LM    @14,@12,12(@13)                                     0228
         BR    @14                                                 0228
RT1RTN   ST    @14,@SA00002                                        0228
*/********************************************************************/
*/* FUNCTION-                                                      0229
*       ROUTINE WHICH FORMATS THE FRR STACK FROM THE RT1W ON.      0229
*     THIS SECTION OF THE CONTROL BLOCK IS COMMON BETWEEN THE IHSA 0229
*     AND FRR STACK.                                               0229
*     IT SETS UP THE NEEDED POINTERS TO BE PASSED TO THE FORMAT ROUTINE
*     SENT IN THE PARAMETER LIST.  FOR ANY ERROR ACCESSING A NEEDED
*     FIELD IN THE RT1W OR FRRS OR FOR NON-ZERO RETURN CODE FROM THE
*     FORMATTING SERVICE, THE FOLLOWING MESSAGES WILL BE PRINTED:  0229
*                       *** FORMATTING SERVICE ROUTINE ERROR DURING FRR
*                           FORMATTING (POSSIBLE CAUSE: DATA NOT IN
*                           DUMP ) ***.                            0229
*     IF THE NEEDED FIELDS FOR DETERMINING THE NUMBER OF ENTRIES COULD
*     BE ACCESSED BUT THE NUMBER OF ENTRIES IS NOT BETWEEN 0 AND 16-THE
*     VALUES MUST BE IN ERROR AND THE FOLLOWING MESSAGE WILL BE    0229
*     PRINTED:                                                     0229
*                       *** ERROR IN THE FIELDS USED TO DETERMINE  0229
*                           THE NUMBER OF FRR ENTRIES ***          0229
*     AT THIS POINT, FOR EITHER REASON, THE FRR PROCESSING WOULD   0229
*     TERMINATE. IF THE FRR STACK IS FORMATTED WITHOUT AN ACCESS   0229
*     ERROR, A BIT SUMMARY OF THE RT1W IS PRINTED USING THE ANALYZE
*     PROC.                                                        0229
*                                                                  0229
*                                                                  0229
*   CALLS-                                                         0229
*       CALLS ACCESRTN,CONVERT,FMTRTN,RT1BITS,AND PRINT            0229
*                                                                  0229
*   CALLED BY -                                                    0229
*             IEAFTFRR AND IEAFTIHS TO FORMAT THE IHSA FRRS COMMON 0229
*             AREAS.                                               0229
*                                                                  0229
*   RETURNS TO -                                                   0229
*              CALLER WITH A RETURN CODE SET BY THE ACCESS OR FORMAT
*             SERVICE ROUTINES.                                      */
*/********************************************************************/
*                                                                  0229
*   ERRSW=OFF;                                                     0229
         NI    ERRSW,B'10111111'                                   0229
*   CALL PRINT;                     /* BLANK LINE                    */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0230
         BALR  @14,@15                                             0230
*   RT1PTR=ADPLFMT2;                /* RT1W ADDRESS                  */
         MVC   RT1PTR(4),ADPLFMT2(ABDPLPTR)                        0231
*                                                                  0232
*   /*****************************************************************/
*   /*                                                               */
*   /* FIGURE OUT THE NUMBER OF POSSIBLE ENTRIES IN THE FRR STACK.   */
*   /* FOR RELEASE 2 OF MVS THE NUMBER OF ENTRIES WAS 8. FOR RELEASE */
*   /* 3 THIS NUMBER CHANGED TO 16. THE NUMBER CAN BE DETERMINED BY  */
*   /* TAKING THE LAST POSSIBLE ENTRY ADDRESS AND SUBTRACTING FROM IT*/
*   /* THE FIRST POSSIBLE ADDRESS AND THEN DIVIDING BY THE LENGTH OF */
*   /* OF THE ENTRY.                                                 */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0232
*   IF SU50SAVE=ON THEN             /* SET NUMBER OF FRR ENTRIES -16 */
         TM    SU50SAVE,B'10000000'                                0232
         BNO   @RF00232                                            0232
*     ENTRYMAX=SU50MAX;                                            0233
         LA    ENTRYMAX,16                                         0233
*   ELSE                            /* DYNAMICALLY FIGURE NUM ENTRIES*/
*     DO;                                                          0234
         B     @RC00232                                            0234
@RF00232 DS    0H                                                  0235
*       VADR=ADDR(FRRSLAST);        /* LAST POSSIBLE ENTRY ADDRESS   */
         L     @14,FRRSPTR                                         0235
         LA    VADR,FRRSLAST(,@14)                                 0235
*       CALL ACCESRTN;              /* ACCESS IT                     */
         BAL   @14,ACCESRTN                                        0236
*       IF RCREG^=ZERO THEN         /* ERROR ACCESSING THE FRR SATCK */
         LTR   RCREG,RCREG                                         0237
         BZ    @RF00237                                            0237
*         DO;                                                      0238
*           BUFFER(1:LENGTH(FRRSFMT))=FRRSFMT;/* ERROR MESSAGE       */
         L     @14,ADPLBUF(,ABDPLPTR)                              0239
         MVC   BUFFER(120,@14),FRRSFMT                             0239
*           CALL PRINT;             /* PRINT IT                      */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0240
         BALR  @14,@15                                             0240
*           ERRSW=ON;               /* ERROR INDICATOR               */
         OI    ERRSW,B'01000000'                                   0241
*         END;                      /* END ERROR ACCESSING           */
*       ELSE                        /* FOUND LAST ENTRY ADDRESS      */
*         DO;                                                      0243
         B     @RC00237                                            0243
@RF00237 DS    0H                                                  0244
*           ENTRYMAX=DATAWORD;      /* SAVE LAST ADDRESS             */
         L     ENTRYMAX,DATAWORD(,DATAPTR)                         0244
*           VADR=ADDR(FRRSEMP);     /* FIRST POSSIBLE ADDRESS        */
         L     VADR,FRRSPTR                                        0245
*           CALL ACCESRTN;          /* ACCESS IT                     */
         BAL   @14,ACCESRTN                                        0246
*           IF RCREG^=ZERO THEN     /* ERROR ACCESSING FIRST POSSIBLE
*                                      ADR                           */
         LTR   RCREG,RCREG                                         0247
         BZ    @RF00247                                            0247
*             DO;                                                  0248
*               BUFFER(1:LENGTH(FRRSFMT))=FRRSFMT;/* ERROR MSG       */
         L     @14,ADPLBUF(,ABDPLPTR)                              0249
         MVC   BUFFER(120,@14),FRRSFMT                             0249
*               CALL PRINT;         /* PRINT IT                      */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0250
         BALR  @14,@15                                             0250
*               ERRSW=ON;           /* ERROR INDICATOR               */
         OI    ERRSW,B'01000000'                                   0251
*             END;                  /* ERROR ACCESSING               */
*           ELSE                    /* FOUND FIRST POSSIBLE ADDRESS  */
*             DO;                                                  0253
         B     @RC00247                                            0253
@RF00247 DS    0H                                                  0254
*               ENTRYMAX=ENTRYMAX-DATAWORD;/* LENGTH OF SPACE FOR  0254
*                                      ENTRIES                       */
         SL    ENTRYMAX,DATAWORD(,DATAPTR)                         0254
*               VADR=ADDR(FRRSELEN);/* LENGTH OF EACH ENTRY          */
         L     @14,FRRSPTR                                         0255
         LA    VADR,FRRSELEN(,@14)                                 0255
*               CALL ACCESRTN;      /* ACCESS IT                     */
         BAL   @14,ACCESRTN                                        0256
*               IF RCREG^=ZERO THEN /* ERROR ACCESSING LENGTH        */
         LTR   RCREG,RCREG                                         0257
         BZ    @RF00257                                            0257
*                 DO;                                              0258
*                   BUFFER(1:LENGTH(FRRSFMT))=FRRSFMT;/* ERROR MSG   */
         L     @14,ADPLBUF(,ABDPLPTR)                              0259
         MVC   BUFFER(120,@14),FRRSFMT                             0259
*                   CALL PRINT;     /* PRINT IT                      */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0260
         BALR  @14,@15                                             0260
*                   ERRSW=ON;       /* ERROR INDICATOR               */
         OI    ERRSW,B'01000000'                                   0261
*                 END;              /* END ACCESS ERROR              */
*               ELSE                /* FOUND ENTRY LENGTH            */
*                 IF DATAWORD=ZERO THEN/* TEST FOR ZERO STACK      0263
*                                                            @ZA27290*/
         B     @RC00257                                            0263
@RF00257 ICM   @14,15,DATAWORD(DATAPTR)                            0263
         BNZ   @RF00263                                            0263
*                   DO;                                            0264
*                     BUFFER(1:LENGTH(FRRLZERO))=FRRLZERO;/* ERROR 0265
*                                      MSG                   @ZA27290*/
         L     @14,ADPLBUF(,ABDPLPTR)                              0265
         MVC   BUFFER(64,@14),FRRLZERO                             0265
*                     CALL PRINT;   /* PRINT IT              @ZA27290*/
         L     @15,ADPLPRNT(,ABDPLPTR)                             0266
         BALR  @14,@15                                             0266
*                     ERRSW=ON;     /* SET UP FOR ERROR EXIT @ZA27290*/
         OI    ERRSW,B'01000000'                                   0267
*                   END;            /* END.... ERROR RTN     @ZA27290*/
*                 ELSE              /* STACK NOT ZERO        @ZA27290*/
*                   DO;             /*                       @ZA27290*/
         B     @RC00263                                            0269
@RF00263 DS    0H                                                  0270
*                     ENTRYMAX=ENTRYMAX/DATAWORD;/* NUMBER OF ENTRIES*/
         LR    @02,ENTRYMAX                                        0270
         SRDA  @02,32                                              0270
         D     @02,DATAWORD(,DATAPTR)                              0270
         LR    ENTRYMAX,@03                                        0270
*                     IF(ENTRYMAX>16)|(ENTRYMAX<1) THEN/* SOMETHING
*                                      WRONG WITH VALUES FOUND       */
         CH    ENTRYMAX,@CH00718                                   0271
         BH    @RT00271                                            0271
         LTR   ENTRYMAX,ENTRYMAX                                   0271
         BP    @RF00271                                            0271
@RT00271 DS    0H                                                  0272
*                       DO;                                        0272
*                         BUFFER(1:LENGTH(BADMAX))=BADMAX;/* ERROR 0273
*                                      MSG                           */
         L     @14,ADPLBUF(,ABDPLPTR)                              0273
         MVC   BUFFER(72,@14),BADMAX                               0273
*                         CALL PRINT;/* PRINT IT                     */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0274
         BALR  @14,@15                                             0274
*                         ERRSW=ON; /* ERROR INDICATOR               */
         OI    ERRSW,B'01000000'                                   0275
*                         RCCODE=4; /* INHIBIT EED SEARCHING IN MAIN
*                                      RTN                           */
         MVC   RCCODE(4),@CF00080                                  0276
*                       END;        /* END WRONG VALUES              */
*                   END;            /* FOUND ENTRY LENGTH            */
@RF00271 DS    0H                                                  0279
*             END;                  /* END FOUND FIRST ADR           */
@RC00263 DS    0H                                                  0279
@RC00257 DS    0H                                                  0280
*         END;                      /* END FOUND LAST ADR            */
@RC00247 DS    0H                                                  0281
*     END;                          /* END DYNAMICALLY FIGURE ENTRIES*/
@RC00237 DS    0H                                                  0282
*   IF ERRSW=OFF THEN               /* FIGURED NUM ENTRIES OK        */
@RC00232 TM    ERRSW,B'01000000'                                   0282
         BNZ   @RF00282                                            0282
*     DO;                                                          0283
*                                                                  0284
*       /*************************************************************/
*       /*                                                           */
*       /* CONTINUE PROCESSING AT RT1W                               */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0284
*       BUFFER(16:(LENGTH(RT1MSG)+15))=RT1MSG;/* RT1W TO FOLLOW    0284
*                                      MESSAGE                       */
         L     @14,ADPLBUF(,ABDPLPTR)                              0284
         MVC   BUFFER+15(38,@14),RT1MSG                            0284
*       CALL CONVERT;               /* GENERATE OFFSET               */
         BAL   @14,CONVERT                                         0285
*       OFFSET=CONVERTD;            /* FILL IN OFFSET                */
         L     @14,ADPLBUF(,ABDPLPTR)                              0286
         MVC   OFFSET(6,@14),CONVERTD                              0286
*       CALL PRINT;                 /* PRINT TITLE                   */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0287
         BALR  @14,@15                                             0287
*       CALL PRINT;                 /* BLANK                         */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0288
         BALR  @14,@15                                             0288
*       BUFFER(31:(LENGTH(FRREHDR)+30))=FRREHDR;/* FRR ENTRY TITLE   */
         L     @14,ADPLBUF(,ABDPLPTR)                              0289
         MVC   BUFFER+30(11,@14),FRREHDR                           0289
*       CALL PRINT;                 /* PRINT IT                      */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0290
         BALR  @14,@15                                             0290
*       BUFFER(31:(LENGTH(FRREUS)+30))=FRREUS;/* UNDERSCORE          */
         L     @14,ADPLBUF(,ABDPLPTR)                              0291
         MVC   BUFFER+30(11,@14),FRREUS                            0291
*       CALL PRINT;                 /* PRINT IT                      */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0292
         BALR  @14,@15                                             0292
*       CALL PRINT;                 /* BLANK                         */
*                                                                  0293
         L     @15,ADPLPRNT(,ABDPLPTR)                             0293
         BALR  @14,@15                                             0293
*       /*************************************************************/
*       /*                                                           */
*       /* SINCE THE RT1W IS TO BE FORMATTED AFTER THE FRR ENTRIES,  */
*       /* INCREMENT THE CONTROL BLOCK ADDRESS TO FRR ENTRIES.       */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0294
*       ADPLFMT2=ADPLFMT2+LENGTH(RT1W);/* INCREMENT AROUND RT1W      */
         LA    @14,68                                              0294
         AL    @14,ADPLFMT2(,ABDPLPTR)                             0294
         ST    @14,ADPLFMT2(,ABDPLPTR)                             0294
*       ARRAYCNT=ARRAYCNT+1;        /* NEXT FORMAT PATTERN           */
         LA    @14,1                                               0295
         ALR   ARRAYCNT,@14                                        0295
*       DO LOOPCNTR=1 TO ENTRYMAX WHILE(ERRSW=OFF);/* FORMAT LOOP    */
         B     @DE00296                                            0296
@DL00296 TM    ERRSW,B'01000000'                                   0296
         BNZ   @DC00296                                            0296
*         LINEPTR=FRRNAMES(ARRAYCNT);/* FORMAT PATTERN               */
         LR    @14,ARRAYCNT                                        0297
         SLA   @14,2                                               0297
         L     LINEPTR,FRRNAMES-4(@14)                             0297
*         CALL CONVERT;             /* OFFSET GENERATOR              */
         BAL   @14,CONVERT                                         0298
*         CALL FMTRTN;              /* FORMAT                        */
         BAL   @14,FMTRTN                                          0299
*       END;                        /* END LOOP                      */
         LA    @14,1                                               0300
         AL    @14,LOOPCNTR                                        0300
@DE00296 ST    @14,LOOPCNTR                                        0300
         CR    @14,ENTRYMAX                                        0300
         BNH   @DL00296                                            0300
@DC00296 DS    0H                                                  0301
*       CALL PRINT;                 /* 2 BLANKS                      */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0301
         BALR  @14,@15                                             0301
*       CALL PRINT;                 /* BLANK                         */
*                                                                  0302
         L     @15,ADPLPRNT(,ABDPLPTR)                             0302
         BALR  @14,@15                                             0302
*       /*************************************************************/
*       /*                                                           */
*       /* FRR ENTRIES FORMATTED OK NOW FORMAT THE RT1 WORK AREA     */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0303
*       IF ERRSW=OFF THEN           /* OK SO FAR                     */
         TM    ERRSW,B'01000000'                                   0303
         BNZ   @RF00303                                            0303
*         DO;                                                      0304
*           BUFFER(31:(LENGTH(RT1HDR)+30))=RT1HDR;/* RT1W TITLE      */
         L     @14,ADPLBUF(,ABDPLPTR)                              0305
         MVC   BUFFER+30(14,@14),RT1HDR                            0305
*           CALL PRINT;             /* PRINT IT                      */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0306
         BALR  @14,@15                                             0306
*           BUFFER(31:(LENGTH(RT1US)+30))=RT1US;/* UNDERSCORE        */
         L     @14,ADPLBUF(,ABDPLPTR)                              0307
         MVC   BUFFER+30(14,@14),RT1US                             0307
*           CALL PRINT;             /* PRINT IT                      */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0308
         BALR  @14,@15                                             0308
*           CALL PRINT;             /* BLANK                         */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0309
         BALR  @14,@15                                             0309
*           VADR=ADDR(RT1TLPN);     /* LOGICAL PHASE #               */
         L     VADR,RT1PTR                                         0310
*           CALL ACCESRTN;          /* ACCESS                        */
         BAL   @14,ACCESRTN                                        0311
*           IF RCREG=ZERO THEN      /* COULD ACCESS LPN              */
         LTR   RCREG,RCREG                                         0312
         BNZ   @RF00312                                            0312
*             DO;                                                  0313
*               SAVEPTR=RT1PTR;     /* START OFFSETS AT 0            */
         L     @14,RT1PTR                                          0314
         ST    @14,SAVEPTR                                         0314
*               ADPLFMT2=RT1PTR;    /* BEGINNING OF RT1W             */
         ST    @14,ADPLFMT2(,ABDPLPTR)                             0315
*               IF DATABYTE=ZEROBYTE THEN/* UNPREDICTABLE RT1W       */
         CLC   DATABYTE(1,DATAPTR),ZEROBYTE                        0316
         BNE   @RF00316                                            0316
*                 DO;                                              0317
*                   BUFFER(8:(LENGTH(RT1WARN)+7))=RT1WARN;/* WARNING
*                                      MSG                           */
         L     @14,ADPLBUF(,ABDPLPTR)                              0318
         MVC   BUFFER+7(49,@14),RT1WARN                            0318
*                   CALL PRINT;     /* PRINT IT                      */
*                                                                  0319
         L     @15,ADPLPRNT(,ABDPLPTR)                             0319
         BALR  @14,@15                                             0319
*                   /*************************************************/
*                   /*                                               */
*                   /* FORMAT RT1W WITH ONLY THE OFFSETS             */
*                   /*                                               */
*                   /*************************************************/
*                                                                  0320
*                   DO ARRAYCNT=1 TO DIM(RT1ENAME) WHILE(ERRSW=OFF);
         LA    ARRAYCNT,1                                          0320
@DL00320 TM    ERRSW,B'01000000'                                   0320
         BNZ   @DC00320                                            0320
*                                   /* FORMAT LOOP                   */
*                     LINEPTR=RT1ENAME(ARRAYCNT);/* FORMAT PATTERN   */
         LR    @14,ARRAYCNT                                        0321
         SLA   @14,2                                               0321
         L     LINEPTR,RT1ENAME-4(@14)                             0321
*                     CALL CONVERT; /* OFFSET GENERATOR              */
         BAL   @14,CONVERT                                         0322
*                     CALL FMTRTN;  /* FORMAT                        */
         BAL   @14,FMTRTN                                          0323
*                   END;            /* END FORMAT LOOP               */
         AH    ARRAYCNT,@CH00041                                   0324
         CH    ARRAYCNT,@CH00080                                   0324
         BNH   @DL00320                                            0324
@DC00320 DS    0H                                                  0325
*                   RCCODE=4;       /* INHIBIT EED SEARCH IN MAIN RTN*/
         MVC   RCCODE(4),@CF00080                                  0325
*                 END;              /* END UNPREDICTABLE RT1W        */
*               ELSE                /* NORMAL RT1W                   */
*                 DO;                                              0327
         B     @RC00316                                            0327
@RF00316 DS    0H                                                  0328
*                   LPN=DATABYTE;   /* SAVE LOGICAL PHASE NUM        */
*                                                                  0328
         SLR   LPN,LPN                                             0328
         IC    LPN,DATABYTE(,DATAPTR)                              0328
*                   /*************************************************/
*                   /*                                               */
*                   /* FORMAT THE RT1W WITH ALL THE HEADINGS         */
*                   /*                                               */
*                   /*************************************************/
*                                                                  0329
*                   DO ARRAYCNT=1 TO DIM(RT1WNAME) WHILE(ERRSW=OFF);
         LA    ARRAYCNT,1                                          0329
@DL00329 TM    ERRSW,B'01000000'                                   0329
         BNZ   @DC00329                                            0329
*                                   /* FORMAT LOOP                   */
*                     LINEPTR=RT1WNAME(ARRAYCNT);                  0330
         LR    @14,ARRAYCNT                                        0330
         SLA   @14,2                                               0330
         L     LINEPTR,RT1WNAME-4(@14)                             0330
*                     CALL CONVERT;                                0331
         BAL   @14,CONVERT                                         0331
*                     CALL FMTRTN;                                 0332
         BAL   @14,FMTRTN                                          0332
*                   END;            /* END FORMAT LOOP               */
         AH    ARRAYCNT,@CH00041                                   0333
         CH    ARRAYCNT,@CH00080                                   0333
         BNH   @DL00329                                            0333
@DC00329 DS    0H                                                  0334
*                   IF ERRSW=OFF THEN/* RT1W FORMATTED FINE          */
         TM    ERRSW,B'01000000'                                   0334
         BNZ   @RF00334                                            0334
*                     DO;                                          0335
*                       CALL RT1BITS;/* CALL BIT SUMMARY             */
*                                                                  0336
         BAL   @14,RT1BITS                                         0336
*                       /*********************************************/
*                       /*                                           */
*                       /* IF ALL PARTS FORMATTED WITHOUT PROBLEM,   */
*                       /* SEND THE ADDRESS OF THE EED CHAIN HEADER  */
*                       /* TO THE MAINLINE CODE                      */
*                       /*                                           */
*                       /*********************************************/
*                                                                  0337
*                       VADR=ADDR(RT1WEED);/* GET ADDR OF EED QUEUE  */
         L     @14,RT1PTR                                          0337
         LA    VADR,RT1WEED(,@14)                                  0337
*                       CALL ACCESRTN;/* ACCESS IT                   */
         BAL   @14,ACCESRTN                                        0338
*                       IF RCREG=ZERO THEN/* FOUND EED QUEUE OK      */
         SLR   @14,@14                                             0339
         CR    RCREG,@14                                           0339
         BNE   @RF00339                                            0339
*                         DO;                                      0340
*                           ADPLFMT2=DATAWORD;/* FILL IN PARMLIST    */
         MVC   ADPLFMT2(4,ABDPLPTR),DATAWORD(DATAPTR)              0341
*                           START=ZERO;                            0342
         ST    @14,START(,ABDPLPTR)                                0342
*                         END;      /* END FOUND EED QUEUE OK        */
*                       ELSE                                       0344
*                         ;         /* DID NOT FIND EED QUEUE        */
@RF00339 DS    0H                                                  0345
*                     END;          /* END RT1W FORMATTED OK         */
*                   ELSE                                           0346
*                     ;             /* ERROR ABOVE IN RT1W           */
@RF00334 DS    0H                                                  0347
*                 END;              /* END NORMAL RT1W               */
*             END;                  /* END COULD ACCESS LPN          */
*           ELSE                                                   0349
*             ;                     /* COULD NOT ACCESS LPN          */
@RF00312 DS    0H                                                  0350
*         END;                      /* END FORMATTED FRR ENTRIES OK  */
*       ELSE                                                       0351
*         ;                         /* FRR ENTRIES NOT FORMATTED OK  */
@RF00303 DS    0H                                                  0352
*     END;                          /* END FIGURED ENTRIES OK        */
*   ELSE                                                           0353
*     ;                             /* ERROR FIGURING FRR ENTRIES    */
@RF00282 DS    0H                                                  0354
*   RETURN CODE(RCCODE);                                           0354
@RC00282 L     @15,RCCODE                                          0354
@EL00002 DS    0H                                                  0354
@EF00002 DS    0H                                                  0354
@ER00002 L     @14,@SA00002                                        0354
         BR    @14                                                 0354
*   END RT1RTN;                                                    0355
*RT1BITS:                                                          0356
*   PROC OPTIONS(SAVE(14));                                        0356
*                                                                  0356
RT1BITS  ST    @14,@SA00003                                        0356
*/****************************************************************** */
*/* FUNCTION -                                                     0357
*      ROUTINE TO SUMMARIZE THE BITS FOR THE RT1W WORK AREA.  IT   0357
*      LOOKS FOR ANY OF THE BIT FLAGS BEING ON AND OUTPUTS THE     0357
*      SUMMARY HEADER AND THE BIT SUMMARY.  IF NO FLAGS ARE ON,    0357
*      NO TITLE NOR ANY MESSAGES WILL BE PRINTED.                  0357
*                                                                  0357
*   INPUT -                                                        0357
*      THE RT1W POINTER MUST HAVE THE ADDRESS OF THE RT1W CONTROL  0357
*      BLOCK IN IT AND REGISTER 1 MUST POINT TO THE PARAMETER LIST 0357
*      PASSED BY THE CALLER.                                       0357
*                                                                  0357
*   CALLS -                                                        0357
*      ACCESRTN, BYTEMODE, CONVERT, ENTRYRT1, AND PRINT            0357
*                                                                  0357
*   CALLED BY -                                                    0357
*      IEAFTFRR TO PUT OUT THE BIT FLAG SUMMARY FOR RT1W           0357
*                                                                  0357
*    RETURNS TO -                                                  0357
*      IEAFTFRR WITH RETURN CODE SET BY ACCESS SERVICE             0357
*      ROUTINES.                                                     */
*/********************************************************************/
*                                                                  0357
*   CALL PRINT;                     /* PRINT BLANK LINE              */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0357
         BALR  @14,@15                                             0357
*   CALL PRINT;                     /* PRINT BLANK LINE              */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0358
         BALR  @14,@15                                             0358
*   BUFFER(31:(LENGTH(RT1SUM)+30))=RT1SUM;/* SUMMARY TITLE           */
         L     @14,ADPLBUF(,ABDPLPTR)                              0359
         MVC   BUFFER+30(21,@14),RT1SUM                            0359
*   CALL PRINT;                     /* PRINT IT                      */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0360
         BALR  @14,@15                                             0360
*   BUFFER(31:(LENGTH(RT1SUS)+30))=RT1SUS;/* UNDERSCORE              */
         L     @14,ADPLBUF(,ABDPLPTR)                              0361
         MVC   BUFFER+30(21,@14),RT1SUS                            0361
*   CALL PRINT;                     /* PRINT IT                      */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0362
         BALR  @14,@15                                             0362
*   CALL PRINT;                     /* BLANK                         */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0363
         BALR  @14,@15                                             0363
*   CALL PRINT;                     /* BLANK                         */
*                                                                  0364
         L     @15,ADPLPRNT(,ABDPLPTR)                             0364
         BALR  @14,@15                                             0364
*   /*****************************************************************/
*   /*                                                               */
*   /* ANALYZE LOGICAL PHASE NUMBER                                  */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0365
*   ADPLFMT2=ADDR(RT1TLPN);                                        0365
         MVC   ADPLFMT2(4,ABDPLPTR),RT1PTR                         0365
*   CALL CONVERT;                   /* GENERATE OFFSET               */
         BAL   @14,CONVERT                                         0366
*   OFFSET=CONVERTD;                /* FILL IN GENERATED OFFSET      */
         L     @14,ADPLBUF(,ABDPLPTR)                              0367
         MVC   OFFSET(6,@14),CONVERTD                              0367
*   BUFFER(8:(LENGTH(LPNSTART)+7))=LPNSTART;/* BEGINNING OF MSG      */
         MVC   BUFFER+7(24,@14),LPNSTART                           0368
*   PACKAREA(4:4)=LPN;              /* PLACE LOGICAL PHASE NUM IN  0369
*                                      CHAR AREA                     */
         STC   LPN,PACKAREA+3                                      0369
*   GARBAGE='04'X;                  /* GARBAGE BYTE FOR THE UNPK     */
         MVI   GARBAGE,X'04'                                       0370
*   UNPK(BUFFER(LENGTH(LPNSTART)+8:LENGTH(LPNSTART)+10),UNPACK(4:5));
         UNPK  BUFFER+31(3,@14),UNPACK+3(2)                        0371
*                                   /* UNPACK LPN INTO BUFFER        */
*   TR(BUFFER(LENGTH(LPNSTART)+8:LENGTH(LPNSTART)+10),TRANS);/* MAKE
*                                      MAKE PRINTABLE                */
         TR    BUFFER+31(3,@14),TRANS                              0372
*   RFY                                                            0373
*     ENDMSG BASED(ADDR(BUFFER)+LENGTH(LPNSTART)+10);              0373
*   IF LPN<MCHCK THEN               /* MGMT FUNCTION                 */
         SLR   @09,@09                                             0374
         IC    @09,MCHCK                                           0374
         CR    LPN,@09                                             0374
         BNL   @RF00374                                            0374
*     ENDMSG=LPNARRAY(1);                                          0375
         MVI   ENDMSG+74(@14),C' '                                 0375
         MVC   ENDMSG+75(29,@14),ENDMSG+74(@14)                    0375
         MVC   ENDMSG+34(40,@14),LPNARRAY                          0375
*   ELSE                                                           0376
*     IF LPN<SRMCK THEN             /* MACHINE CHECK FUNCTION        */
         B     @RC00374                                            0376
@RF00374 SLR   @14,@14                                             0376
         IC    @14,SRMCK                                           0376
         CR    LPN,@14                                             0376
         BNL   @RF00376                                            0376
*       ENDMSG=LPNARRAY(2);                                        0377
         L     @14,ADPLBUF(,ABDPLPTR)                              0377
         MVI   ENDMSG+74(@14),C' '                                 0377
         MVC   ENDMSG+75(29,@14),ENDMSG+74(@14)                    0377
         MVC   ENDMSG+34(40,@14),LPNARRAY+40                       0377
*     ELSE                                                         0378
*       IF LPN<RTRYCK THEN          /* SRM FUNCTION                  */
         B     @RC00376                                            0378
@RF00376 SLR   @14,@14                                             0378
         IC    @14,RTRYCK                                          0378
         CR    LPN,@14                                             0378
         BNL   @RF00378                                            0378
*         ENDMSG=LPNARRAY(3);                                      0379
         L     @14,ADPLBUF(,ABDPLPTR)                              0379
         MVI   ENDMSG+74(@14),C' '                                 0379
         MVC   ENDMSG+75(29,@14),ENDMSG+74(@14)                    0379
         MVC   ENDMSG+34(40,@14),LPNARRAY+80                       0379
*       ELSE                                                       0380
*         IF LPN<RESCHDCK THEN      /* RESCHEDULE WITH RETRY         */
         B     @RC00378                                            0380
@RF00378 SLR   @14,@14                                             0380
         IC    @14,RESCHDCK                                        0380
         CR    LPN,@14                                             0380
         BNL   @RF00380                                            0380
*           ENDMSG=LPNARRAY(4);                                    0381
         L     @14,ADPLBUF(,ABDPLPTR)                              0381
         MVI   ENDMSG+74(@14),C' '                                 0381
         MVC   ENDMSG+75(29,@14),ENDMSG+74(@14)                    0381
         MVC   ENDMSG+34(40,@14),LPNARRAY+120                      0381
*         ELSE                                                     0382
*           IF LPN<EXITCK THEN      /* RESCHEDULE                    */
         B     @RC00380                                            0382
@RF00380 SLR   @14,@14                                             0382
         IC    @14,EXITCK                                          0382
         CR    LPN,@14                                             0382
         BNL   @RF00382                                            0382
*             ENDMSG=LPNARRAY(5);                                  0383
         L     @14,ADPLBUF(,ABDPLPTR)                              0383
         MVI   ENDMSG+74(@14),C' '                                 0383
         MVC   ENDMSG+75(29,@14),ENDMSG+74(@14)                    0383
         MVC   ENDMSG+34(40,@14),LPNARRAY+160                      0383
*           ELSE                                                   0384
*             IF LPN<RECURCK THEN   /* EXIT FUNCTION                 */
         B     @RC00382                                            0384
@RF00382 SLR   @14,@14                                             0384
         IC    @14,RECURCK                                         0384
         CR    LPN,@14                                             0384
         BNL   @RF00384                                            0384
*               ENDMSG=LPNARRAY(6);                                0385
         L     @14,ADPLBUF(,ABDPLPTR)                              0385
         MVI   ENDMSG+74(@14),C' '                                 0385
         MVC   ENDMSG+75(29,@14),ENDMSG+74(@14)                    0385
         MVC   ENDMSG+34(40,@14),LPNARRAY+200                      0385
*             ELSE                                                 0386
*               ENDMSG=LPNARRAY(7); /* RECURSION                     */
         B     @RC00384                                            0386
@RF00384 L     @14,ADPLBUF(,ABDPLPTR)                              0386
         MVI   ENDMSG+74(@14),C' '                                 0386
         MVC   ENDMSG+75(29,@14),ENDMSG+74(@14)                    0386
         MVC   ENDMSG+34(40,@14),LPNARRAY+240                      0386
*   CALL PRINT;                     /* PRINT THE LPN MESSAGE         */
*                                                                  0387
@RC00384 DS    0H                                                  0387
@RC00382 DS    0H                                                  0387
@RC00380 DS    0H                                                  0387
@RC00378 DS    0H                                                  0387
@RC00376 DS    0H                                                  0387
@RC00374 L     @15,ADPLPRNT(,ABDPLPTR)                             0387
         BALR  @14,@15                                             0387
*   /*****************************************************************/
*   /*                                                               */
*   /* RESOLVE THE RTM1 ENTRY REASON                                 */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0388
*   VADR=ADDR(RT1TENPT);            /* RTM1 ENTRY REASON             */
         L     @14,RT1PTR                                          0388
         LA    VADR,RT1TENPT(,@14)                                 0388
*   CALL ACCESRTN;                  /* ACCESS IT                     */
         BAL   @14,ACCESRTN                                        0389
*   IF RCREG=ZERO&DATABYTE^=ZEROBYTE THEN/* IT NEEDS TO BE RESOLVED  */
         LTR   RCREG,RCREG                                         0390
         BNZ   @RF00390                                            0390
         CLC   DATABYTE(1,DATAPTR),ZEROBYTE                        0390
         BE    @RF00390                                            0390
*     DO;                                                          0391
*       ADPLFMT2=ADDR(RT1TENPT);    /* ADDRESS TO GEN OFFSET         */
         L     @14,RT1PTR                                          0392
         LA    @14,RT1TENPT(,@14)                                  0392
         ST    @14,ADPLFMT2(,ABDPLPTR)                             0392
*       CALL ENTRYRT1;              /* ROUTINE TO ANALYZE            */
         BAL   @14,ENTRYRT1                                        0393
*       CALL PRINT;                                                0394
         L     @15,ADPLPRNT(,ABDPLPTR)                             0394
         BALR  @14,@15                                             0394
*     END;                          /* END NEEDS TO BE RESOLVED      */
*   ELSE                                                           0396
*     ;                             /* DID NOT NEED TO BE RESOLVED   */
*                                                                  0396
@RF00390 DS    0H                                                  0397
*   /*****************************************************************/
*   /*                                                               */
*   /* RESOLVE MODE BYTE                                             */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0397
*   VADR=ADDR(RT1WMODE);            /* MODE BYTE                     */
         L     @14,RT1PTR                                          0397
         LA    VADR,RT1WMODE(,@14)                                 0397
*   CALL ACCESRTN;                  /* ACCESS IT                     */
         BAL   @14,ACCESRTN                                        0398
*   IF RCREG=ZERO&DATABYTE^=ZEROBYTE THEN/* NEEDS TO BE ANALYZED     */
         LTR   RCREG,RCREG                                         0399
         BNZ   @RF00399                                            0399
         CLC   DATABYTE(1,DATAPTR),ZEROBYTE                        0399
         BE    @RF00399                                            0399
*     DO;                                                          0400
*       ADPLFMT2=ADDR(RT1WMODE);    /* ADDRESS NEEDED TO GEN OFFSET  */
         L     @14,RT1PTR                                          0401
         LA    @14,RT1WMODE(,@14)                                  0401
         ST    @14,ADPLFMT2(,ABDPLPTR)                             0401
*       CALL BYTEMODE;              /* ROUTINE TO ANALYZE            */
         BAL   @14,BYTEMODE                                        0402
*     END;                          /* END NEEDED TO BE ANALYZED     */
*   ELSE                                                           0404
*     ;                             /* DID NOT NEED TO BE ANALYZED   */
@RF00399 DS    0H                                                  0405
*   RETURN CODE(RCCODE);                                           0405
         L     @15,RCCODE                                          0405
@EL00003 DS    0H                                                  0405
@EF00003 DS    0H                                                  0405
@ER00003 L     @14,@SA00003                                        0405
         BR    @14                                                 0405
*   END RT1BITS;                                                   0406
*                                                                  0407
*/********************************************************************/
*/*                                                                  */
*/*         THE FOLLOWING CODE HAS BEEN INCLUDED FROM SYSLIB MEMBER  */
*/*     IHAFTCD1 INTO THE MODULE. THE CODE IS INCLUDED ONLY FROM     */
*/*     THE EED FORMATTER AND THE IHSA-FRRS FORMATTER. THE INCLUDED  */
*/*     CODE CONSISTS OF THE BYTEMODE AND ENTRYRT1 ROUTINES.         */
*/*         THE CODE HAS BEEN INCLUDED IN ORDER TO SIMPLIFY          */
*/*     MAINTENANCE BY HAVING THE CODE IN ONLY ONE PLACE INSTEAD     */
*/*     OF DUPLICATING IT IN EACH MODULE.                            */
*/********************************************************************/
*                                                                  0407
*                                                                  0407
*   /*****************************************************************/
*   /*                                                               */
*   /* WORK AREAS UNIQUE TO THE INCLUDED CODE FROM IHAFTCD1          */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0407
*   DCL                                                            0407
*     ENDMSG CHAR(70) BASED;        /* AREA TO FINISH MSG IN         */
*                                                                  0407
*   /*****************************************************************/
*   /*                                                               */
*   /* MESSAGES UNIQUE TO THE INCLUDED CODE                          */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0408
*   DCL                                                            0408
*     EXITMSG CHAR(34) INIT('FIELD CONTAINS INTERNAL EXIT FLAGS'); 0408
*   DCL                                                            0409
*     MODEMSG(8) CHAR(25) INIT('SUPERVISOR CONTROL MODE',          0409
*         'PHYSICALLY DISABLED STATE','GLOBAL SPIN LOCK HELD',     0409
*         'GLOBAL SUSPEND LOCK HELD','LOCALLY LOCKED MODE',        0409
*         'TYPE 1 SVC MODE','SRB MODE','TASK MODE');               0409
*   DCL                                                            0410
*     RTARRAY(14) CHAR(50) INIT('PROGRAM CHECK','RESTART','SVC ERROR',
*         'DAT ERROR','MACHINE CHECK REENTRY',                     0410
*         'RESCHEDULE OF PAGE I/O ERROR',                          0410
*         'RESCHEDULE OF ABNORMAL TERMINATION',                    0410
*         'RESCHEDULE OF ABNORMAL TERMINATION THROUGH CVTBTRM',    0410
*         'RESCHEDULE OF CROSS MEMORY ABNORMAL TERMINATION',       0410
*         'RESCHEDULE OF ABNORMAL TERMINATION OF CURRENT TCB',     0410
*         'MEMORY TERMINATION','CROSS MEMORY ABNORMAL TERMINATION',
*         'RESCHEDULE OF RTM1 ON OTHER CPU','MACHINE CHECK');      0410
*   DCL                                                            0411
*     RTSTART CHAR(17) INIT('RTM1 ENTERED FOR ');                  0411
*   DCL                                                            0412
*     SYSTATE CHAR(13) INIT('SYSTEM STATE:');                      0412
*BYTEMODE:                                                         0413
*   PROC OPTIONS(SAVE(14));                                        0413
*                                                                  0413
BYTEMODE ST    @14,@SA00004                                        0413
*/********************************************************************/
*/* FUNCTION-                                                      0414
*       ROUTINE TO ANALYZE THE SYSTEM MODE BYTE AND PLACE THE      0414
*     CORRESPONDING MESSAGE IN THE BUFFER AND PRINT OUT THE DATA.  0414
*                                                                  0414
*                                                                  0414
*   INPUT -                                                        0414
*       DATAPTR MUST CONTAIN THE ADDRESS OF THE BYTE TO BE ANALYZED
*     AND REGISTER 1 POINTS TO THE PARMLIST.                       0414
*                                                                  0414
*    CALLS-                                                        0414
*       ANALYZE AND CONVERT                                        0414
*                                                                  0414
*    CALLED BY -                                                   0414
*        EEDBITS, IEAFTESA, RT1BITS TO ANALYZE THE MODE BYTE       0414
*                                                                  0414
*    RETURNS TO -                                                  0414
*        CALLER WITHOUT SETTING A RETURN CODE                      0414
*                                                                  0414
*   THIS PROCEDURE HAS BEEN INCLUDED FROM SYSLIB(IHAFTCD1) ------  0414
*                                                                    */
*/********************************************************************/
*                                                                  0414
*   BUFFER(8:(LENGTH(SYSTATE)+7))=SYSTATE;/* BEGINNING OF MESSAGE    */
         L     @14,ADPLBUF(,ABDPLPTR)                              0414
         MVC   BUFFER+7(13,@14),SYSTATE                            0414
*   ADPLCOM2=ADDR(SUMMARY);         /* SUMMARY PTR IN PARMLIST       */
         LA    @14,SUMMARY                                         0415
         ST    @14,ADPLCOM2(,ABDPLPTR)                             0415
*   BYTEADDR=ADDR(DATABYTE);        /* ADDR OF BYTE TO BE RESOLVED   */
         ST    DATAPTR,BYTEADDR                                    0416
*   MSGADDR=ADDR(MODEMSG);          /* MESSAGE ARRAY                 */
         LA    @14,MODEMSG                                         0417
         ST    @14,MSGADDR                                         0417
*   MSGLNGTH=LENGTH(MODEMSG);       /* MSG ARRAY LENGTH              */
         MVC   MSGLNGTH(4),@CF01445                                0418
*   CALL CONVERT;                   /* GENERATE OFFSET               */
         BAL   @14,CONVERT                                         0419
*   OFFSET=CONVERTD;                /* PUT OFFSET IN BUFFER          */
         L     @14,ADPLBUF(,ABDPLPTR)                              0420
         MVC   OFFSET(6,@14),CONVERTD                              0420
*   COLNUM=22;                      /* WHERE IN BUFFER TO START      */
         MVC   COLNUM(4),@CF01486                                  0421
*   CALL ANALYZE;                   /* ANALYZE THE BYTE ANALYZE BYTE */
         BAL   @14,ANALYZE                                         0422
*   END BYTEMODE;                                                  0423
@EL00004 DS    0H                                                  0423
@EF00004 DS    0H                                                  0423
@ER00004 L     @14,@SA00004                                        0423
         BR    @14                                                 0423
*ENTRYRT1:                                                         0424
*   PROC OPTIONS(SAVE(14));                                        0424
*                                                                  0424
ENTRYRT1 ST    @14,@SA00005                                        0424
*/********************************************************************/
*/* FUNCTION-                                                      0425
*       ROUTINE TO ANALYZE THE RTM1 ENTRY POINT CODE AND FILL IN   0425
*     THE BUFFER WITH THE APPROPRIATE MESSAGE. IT ALSO FILLS IN    0425
*     THE OFFSET TO BE PLACED ALONG SIDE THE MESSAGE.              0425
*                                                                  0425
*                                                                  0425
*   INPUT -                                                        0425
*       DATAPTR MUST CONTAIN THE ADDRESS OF THE BYTE TO BE ANALYZED
*     AND REGISTER 1 POINTS TO THE PARMLIST PASSED BY THE CALLER.  0425
*                                                                  0425
*    CALLS-                                                        0425
*       CONVERT                                                    0425
*                                                                  0425
*    CALLED BY -                                                   0425
*        EEDBITS, RT1BITS TO ANALYZE ENTRY TO RT1 REASON BYTE      0425
*                                                                  0425
*    RETURNS TO -                                                  0425
*        CALLER WITHOUT SETTING A RETURN CODE                      0425
*                                                                  0425
*   THIS PROCEDURE HAS BEEN INCLUDED FROM SYSLIB(IHAFTCD1) ------  0425
*                                                                    */
*/********************************************************************/
*                                                                  0425
*   CALL CONVERT;                   /* GENERATE OFFSET               */
         BAL   @14,CONVERT                                         0425
*   OFFSET=CONVERTD;                /* PLACE IN BUFFER               */
         L     @14,ADPLBUF(,ABDPLPTR)                              0426
         MVC   OFFSET(6,@14),CONVERTD                              0426
*   IF DATABYTE>RT1WMACH THEN       /* FIELD CONTAINS EXIT FLAGS     */
         CLI   DATABYTE(DATAPTR),20                                0427
         BNH   @RF00427                                            0427
*     BUFFER(8:(LENGTH(EXITMSG)+7))=EXITMSG;                       0428
         MVC   BUFFER+7(34,@14),EXITMSG                            0428
*   ELSE                                                           0429
*     DO;                           /* WAS NOT EXIT FLAGS            */
         B     @RC00427                                            0429
@RF00427 DS    0H                                                  0430
*       BUFFER(8:(LENGTH(RTSTART)+7))=RTSTART;/* FILL IN BEGINNING OF
*                                      BUFFER                        */
         L     @14,ADPLBUF(,ABDPLPTR)                              0430
         MVC   BUFFER+7(17,@14),RTSTART                            0430
*       RFY                                                        0431
*         ENDMSG BASED(ADDR(BUFFER)+LENGTH(RTSTART)+8);            0431
*       IF DATABYTE<=RT1WMCHR THEN  /* FIRST 5 CORRESPOND TO ARRAY   */
         CLI   DATABYTE(DATAPTR),5                                 0432
         BH    @RF00432                                            0432
*         ENDMSG=RTARRAY(DATABYTE); /* END OF MESSAGE                */
         MVI   ENDMSG+75(@14),C' '                                 0433
         MVC   ENDMSG+76(19,@14),ENDMSG+75(@14)                    0433
         SLR   @06,@06                                             0433
         IC    @06,DATABYTE(,DATAPTR)                              0433
         MH    @06,@CH02004                                        0433
         LA    @04,RTARRAY-50(@06)                                 0433
         MVC   ENDMSG+25(50,@14),0(@04)                            0433
*       ELSE                        /* NOT OF FIRST 5                */
*         IF DATABYTE<=RSCHDCPU THEN/* NEXT BATCH OF VALUES          */
         B     @RC00432                                            0434
@RF00432 CLI   DATABYTE(DATAPTR),17                                0434
         BH    @RF00434                                            0434
*           ENDMSG=RTARRAY(DATABYTE-'04'X);/* CORRESPONDING ARRAY  0435
*                                      VALUE                         */
         L     @14,ADPLBUF(,ABDPLPTR)                              0435
         MVI   ENDMSG+75(@14),C' '                                 0435
         MVC   ENDMSG+76(19,@14),ENDMSG+75(@14)                    0435
         SLR   @06,@06                                             0435
         IC    @06,DATABYTE(,DATAPTR)                              0435
         MH    @06,@CH02004                                        0435
         LA    @04,RTARRAY-250(@06)                                0435
         MVC   ENDMSG+25(50,@14),0(@04)                            0435
*         ELSE                                                     0436
*           ENDMSG=RTARRAY(DIM(RTARRAY));/* LAST MESSAGE             */
         B     @RC00434                                            0436
@RF00434 L     @14,ADPLBUF(,ABDPLPTR)                              0436
         MVI   ENDMSG+75(@14),C' '                                 0436
         MVC   ENDMSG+76(19,@14),ENDMSG+75(@14)                    0436
         MVC   ENDMSG+25(50,@14),RTARRAY+650                       0436
*     END;                          /* END DID NOT CONTAIN EXIT FLAGS*/
*   END ENTRYRT1;                                                  0438
@EL00005 DS    0H                                                  0438
@EF00005 DS    0H                                                  0438
@ER00005 L     @14,@SA00005                                        0438
         BR    @14                                                 0438
*                                                                  0439
*/********************************************************************/
*/*                                                                  */
*/*         THE FOLLOWING CODE HAS BEEN INCLUDED FROM SYSLIB MEMBER  */
*/*     IHAFTCDE INTO THE MODULE. THE CODE IS COMMON AMONG ALL THE   */
*/*     CONTROL BLOCK FORMAT MODULES FOR THE RTM FORMATTER. THE      */
*/*     INCLUDED CODE CONSISTS OF THE ACCESS, FORMAT, CONVERT,       */
*/*     AND ANALYZE ROUTINES USED BY ALL THE MODULES.                */
*/*         THE CODE HAS BEEN INCLUDED IN ORDER TO SIMPLIFY          */
*/*     MAINTENANCE BY HAVING THE CODE IN ONLY ONE PLACE INSTEAD     */
*/*     OF DUPLICATING IT IN EACH MODULE.                            */
*/********************************************************************/
*                                                                  0439
*                                                                  0439
*   /*****************************************************************/
*   /*                                                               */
*   /* WORK AREAS UNIQUE TO THE INCLUDED CODE FROM IHAFTCDE          */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0439
*   DCL                                                            0439
*     BITSTR BIT(8) BASED(BYTEADDR);/* BYTE TO BE ANALYZED           */
*   DCL                                                            0440
*     BLANKS CHAR(120) INIT(' ');   /* USED TO BLANK OUT DIGIT FIELD
*                                      OR TO COMPARE WITH THE MESSAGE
*                                      ARRAYS FOR BLANK LINES        */
*   DCL                                                            0441
*     BYTELNTH FIXED(31) CONSTANT(8);/* NUM BITS IN A BYTE           */
*   DCL                                                            0442
*     CONVRT FIXED(31);             /* VALUE OF OFFSET               */
*   DCL                                                            0443
*     INDEX FIXED(31);              /* LOOP COUNTER FOR ANALYZE    0443
*                                      ROUTINE                       */
*   DCL                                                            0444
*     LNGTHEQU FIXED(31);           /* CALCULATE SUBSTRING ADR FOR 0444
*                                      PROPER MSG                    */
*   DCL                                                            0445
*     MSG CHAR(120) BASED(ADPLCOM1);/* ERROR MSG TO BE PUT OUT BY  0445
*                                      FORMAT ROUTINE ERROR          */
*   DCL                                                            0446
*     MSGARY CHAR(*) BASED(MSGADDR);/* MESSAGES PASSED TO BE OUTPUT  */
*   DCL                                                            0447
*     NEGBIT BIT(1);                /* FLAG TO INDICATE NEG OFFSET   */
*   DCL                                                            0448
*     NEGCHAR CHAR(1) CONSTANT('-');/* CONSTANT '-' TO BE PUT IN   0448
*                                      OFFSET                        */
*   DCL                                                            0449
*     PLUSCHAR CHAR(1) CONSTANT('+');/* CONSTANT '+' TO BE PUT IN  0449
*                                      OFFSET                        */
*   DCL                                                            0450
*     TESTBITS(8) BIT(8) INIT('80'X,'40'X,'20'X,'10'X,'08'X,'04'X,'02'X
*         ,'01'X);                  /* TO TELL WHICH BIT IS ON       */
*   DCL                                                            0451
*     TWODGT FIXED(31) CONSTANT(16);/* FIRST OF 2 HEX DIGITS         */
*   DCL                                                            0452
*     THREDGT FIXED(31) CONSTANT(256);/* FIRST OF 3 HEX DIGITS       */
*   DCL                                                            0453
*     FOURDGT FIXED(31) CONSTANT(4096);/* FIRST OF 4 HEX DIGITS      */
*CONVERT:                                                          0454
*   PROC OPTIONS(SAVE(14));                                        0454
*                                                                  0454
CONVERT  ST    @14,12(,@13)                                        0454
*/********************************************************************/
*/* FUNCTION -                                                     0455
*      ROUTINE TO DYNAMICALLY GENERATE THE OFFSETS TO BE PUT ALONGSIDE
*      THE CONTROL BLOCK LINE.  IT FIGURES THE OFFSET FROM THE     0455
*      BEGINNING OF THE CONTROL BLOCK, CONVERTS IT TO PRINTABLE HEX,
*      PLACES IT INTO A BUFFER AREA AND PUTS THE ADDRESS OF THIS   0455
*      BUFFER AREA INTO THE PARAMETER LIST TO BE PICKED UP IN THE  0455
*      FORMAT PATTERNS BY THE FORMAT SERVICE ROUTINE.              0455
*                                                                  0455
*   INPUT -                                                        0455
*      SAVEPTR MUST HAVE THE ADDRESS OF THE BEGINNING OF THE CONTROL
*      BLOCK, REGISTER 1 POINTS TO THE PARMLIST WHICH CONTAINS THE 0455
*      CURRENT CONTROL BLOCK ADDRESS IN ADPLFMT2.                  0455
*                                                                  0455
*   CALLS -                                                        0455
*      MAKES NO OUTSIDE CALLS                                      0455
*                                                                  0455
*   CALLED BY -                                                    0455
*      BYTEMODE, EEDBITS, ENTRYRT1, IEAFTEED, IEAFTESA, IEAFTFRR,  0455
*      IEAFTIHS, IEAFTRTC, IEAFTRT2, IEAFTSCB, IEAFTSDW, RT1BITS,  0455
*      RT2BITS, RT2SUM, AND SPECIAL                                0455
*                                                                  0455
*   RETURNS TO -                                                   0455
*      CALLER.                                                     0455
*                                                                  0455
*   THIS PROCEDURE HAS BEEN INCLUDED FROM SYSLIB(IHAFTCDE) ------  0455
*                                                                    */
*/********************************************************************/
*                                                                  0455
*   IF SAVEPTR>ADPLFMT2 THEN        /* THIS WILL OCCUR FOR A PREFIX
*                                      WITH A NEGATIVE OFFSET        */
         L     @14,SAVEPTR                                         0455
         L     @04,ADPLFMT2(,ABDPLPTR)                             0455
         CR    @14,@04                                             0455
         BNH   @RF00455                                            0455
*     DO;                                                          0456
*       NEGBIT=ON;                  /* INDICATE NEGATIVE OFFSET      */
         OI    NEGBIT,B'10000000'                                  0457
*       CONVRT=SAVEPTR-ADPLFMT2;    /* NEGATIVE OFFSET VALUE         */
         SLR   @14,@04                                             0458
         ST    @14,CONVRT                                          0458
*     END;                          /* END NEGATIVE OFFSET           */
*   ELSE                            /* POSITIVE OR ZERO OFFSET       */
*     DO;                                                          0460
         B     @RC00455                                            0460
@RF00455 DS    0H                                                  0461
*       NEGBIT=OFF;                 /* INDICATE POS VALUE            */
         NI    NEGBIT,B'01111111'                                  0461
*       CONVRT=ADPLFMT2-SAVEPTR;    /* RELATIVE OFFSET IN CONTROL  0462
*                                      BLOCK                         */
         L     @14,ADPLFMT2(,ABDPLPTR)                             0462
         SL    @14,SAVEPTR                                         0462
         ST    @14,CONVRT                                          0462
*     END;                          /* END POS VALUE                 */
*   DIGIT=BLANKS(1:5);              /* BLANK OUT DIGITS              */
@RC00455 MVC   DIGIT(5),BLANKS                                     0464
*   PACKAREA=CONVRT;                /* PLACE OFFSET INTO CHAR AREA 0465
*                                      FOR THE UNPACK                */
         L     @14,CONVRT                                          0465
         ST    @14,PACKAREA                                        0465
*   GARBAGE='04'X;                  /* GARBAGE BYTE SO OFFSET WILL 0466
*                                      UNPACK OK                     */
*                                                                  0466
         MVI   GARBAGE,X'04'                                       0466
*   /*****************************************************************/
*   /*                                                               */
*   /* FOR AN ODD NUMBER OF DIGITS THE OUTPUT SHOULD LOOK LIKE +C OR */
*   /* +13C. IF THE VALUE WAS UNPACKED DIRECTLY INTO DIGITS THE      */
*   /* OUTPUT WOULD HAVE UNWANTED LEADING ZEROS SUCH AS +0C. TO      */
*   /* ELIMINATE THIS(ONLY FOR AN ODD NUMBER OF DIGITS) UNPACK ODD   */
*   /* NUMBER OF DIGITS INTO CONVERTD WHERE THE LEADING ZERO WILL BE */
*   /* OVERWRITTEN BY THE '+' OR '-' SIGN                            */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0467
*   IF CONVRT<TWODGT THEN           /* ONLY 1 DIGIT TO OFFSET        */
         CH    @14,@CH00718                                        0467
         BNL   @RF00467                                            0467
*     UNPK(CONVERTD(1:3),UNPACK(4:5));/* UNPACK ONLY 1 DIGIT AND   0468
*                                      DUMMY                         */
         UNPK  CONVERTD(3),UNPACK+3(2)                             0468
*   ELSE                                                           0469
*     IF CONVRT<THREDGT THEN        /* 2 DIGITS TO OFFSET            */
         B     @RC00467                                            0469
@RF00467 L     @14,CONVRT                                          0469
         CH    @14,@CH00707                                        0469
         BNL   @RF00469                                            0469
*       UNPK(DIGIT(1:3),UNPACK(4:5));/* UNPACK LAST 2 DIGITS & DUMMY */
         UNPK  DIGIT(3),UNPACK+3(2)                                0470
*     ELSE                                                         0471
*       IF CONVRT<FOURDGT THEN      /* 3 DIGITS TO OFFSET            */
         B     @RC00469                                            0471
@RF00469 L     @14,CONVRT                                          0471
         CH    @14,@CH02080                                        0471
         BNL   @RF00471                                            0471
*         UNPK(CONVERTD(1:5),UNPACK(3:5));/* UNPACK LAST 3 DIGITS &
*                                      DUMMY                         */
         UNPK  CONVERTD(5),UNPACK+2(3)                             0472
*       ELSE                        /* 4 DIGITS (MAX)                */
*         UNPK(DIGIT(1:5),UNPACK(3:5));/* LAST 4 DIGITS & DUMMY BYTE */
         B     @RC00471                                            0473
@RF00471 UNPK  DIGIT(5),UNPACK+2(3)                                0473
*   TR(DIGIT,TRANS);                /* MAKE PRINTABLE                */
@RC00471 DS    0H                                                  0474
@RC00469 DS    0H                                                  0474
@RC00467 TR    DIGIT(5),TRANS                                      0474
*   IF NEGBIT=ON THEN               /* WAS A NEGATIVE OFFSET         */
         TM    NEGBIT,B'10000000'                                  0475
         BNO   @RF00475                                            0475
*     PLUS=NEGCHAR;                 /* MINUS SIGN                    */
         MVI   PLUS,C'-'                                           0476
*   ELSE                            /* POSITIVE OFFSET               */
*     PLUS=PLUSCHAR;                /* MOVE IN PLUS SIGN             */
         B     @RC00475                                            0477
@RF00475 MVI   PLUS,C'+'                                           0477
*   ADPLFMT1=ADDR(CONVERTD);        /* SET UP FOR FORMAT             */
@RC00475 LA    @14,CONVERTD                                        0478
         ST    @14,ADPLFMT1(,ABDPLPTR)                             0478
*   END CONVERT;                                                   0479
@EL00006 DS    0H                                                  0479
@EF00006 DS    0H                                                  0479
@ER00006 L     @14,12(,@13)                                        0479
         BR    @14                                                 0479
*FMTRTN:                                                           0480
*   PROC OPTIONS(SAVE(14));                                        0480
*                                                                  0480
FMTRTN   ST    @14,@SA00007                                        0480
*/****************************************************************** */
*/* FUNCTION                                                       0481
*       ROUTINE TO SET UP CALLING OF THE FORMAT SERVICE ROUTINE PASSED
*     IN THE PARMLIST AND CHECKS RETURN CODE.  IF A RETURN CODE IS BAD
*     IT TAKES THE MESSAGE WHOSE ADDRESS IS IN ADPLCOM1. AND PUTS IT
*     IN THE BUFFER AND PRINTS IT. IT SETS THE ERRSW TO INDICATE BAD
*     RETURN CODE AND RETURNS. IF THE RETURN CODE WAS GOOD, IT PRINTS
*     THE FORMATTED LINE.                                          0481
*                                                                  0481
*   CALLS-                                                         0481
*       CALLS FORMAT AND PRINT                                     0481
*                                                                  0481
*   INPUT -                                                        0481
*     LINEPTR(REGISTER 0) HAS THE ADDRESS OF THE FORMAT PATTERN TO BE
*    PASSED TO THE FORMAT SERVICE ROUTINE. ADPLFMT2 CONTAINS THE CURREN
*    ADDRESS OF THE CONTROL BLOCK TO BE FORMATTED AND ,IN MOST CASES,
*    ADPLFMT1 CONTAINS THE ADDRESS OF THE FIELD 'CONVERTD' WHICH IS
*    THE EBCDIC REPRESENTATION OF THE OFFSET TO BE PLACED ALONG SIDE
*    THE OUTPUT LINE.                                              0481
*                                                                  0481
*   CALLED BY -                                                    0481
*     IEAFTEED,IEAFTFRR,IEAFTIHS,IEAFTRTC,IEAFTRT2,IEAFTSCB,       0481
*     IEAFTSDW, RT2SUM,AND SPECIAL                                 0481
*                                                                  0481
*   RETURNS CONTROL TO -                                           0481
*     CALLER WITH RETURN CODE RECIEVED FROM FORMAT                 0481
*     SERVICE ROUTINE                                              0481
*                                                                  0481
*   THIS PROCEDURE HAS BEEN INCLUDED FROM SYSLIB(IHAFTCDE) ------  0481
*                                                                    */
*/****************************************************************** */
*                                                                  0481
*   IF ADPLSNPR=OFF THEN            /* IF SNAP IS THE CALLER, AN   0481
*                                      ACCESS ERROR CAN BE EXPECTED  */
         TM    ADPLSNPR(ABDPLPTR),B'10000000'                      0481
         BNZ   @RF00481                                            0481
*     DO;                                                          0482
*       RTYADR=ADDR(FMTRTY);        /* WHERE TO RETRY                */
         LA    @14,FMTRTY                                          0483
         ST    @14,RTYADR(,ESTAPTR)                                0483
*       ERREXP=ON;                  /* INDICATE AN ERROR IS EXPECTED */
         OI    ERREXP(ESTAPTR),B'10000000'                         0484
*     END;                          /* END SNAP IS THE CALLER        */
*   ELSE                                                           0486
*     ;                             /* SNAP WAS NOT INVOKER          */
@RF00481 DS    0H                                                  0487
*   CALL FORMAT;                    /* FORMAT ROUTINE PASSED BY    0487
*                                      CALLER                        */
         L     @15,ADPLFRMT(,ABDPLPTR)                             0487
         BALR  @14,@15                                             0487
*   ERREXP=OFF;                     /* ERROR IS NO LONGER EXPECTED   */
         NI    ERREXP(ESTAPTR),B'01111111'                         0488
*   IF RCREG^=ZERO THEN                                            0489
         LTR   RCREG,RCREG                                         0489
         BZ    @RF00489                                            0489
*     DO;                           /* FORMAT ROUTINE ERROR          */
*FMTRTY:                            /* RETRY POINT FROM ERROR        */
*       ERRSW=ON;                   /* SET ERROR INDICATOR           */
FMTRTY   OI    ERRSW,B'01000000'                                   0491
*       CALL PRINT;                 /* SPACE A LINE                  */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0492
         BALR  @14,@15                                             0492
*       BUFFER=MSG;                 /* ERROR MSG PASSED BY CALLER  0493
*                                      WHOSE ADDR IS PLACED IN     0493
*                                      ADPLCOM1                      */
         L     @14,ADPLBUF(,ABDPLPTR)                              0493
         L     @04,ADPLCOM1(,ABDPLPTR)                             0493
         MVC   BUFFER(120,@14),MSG(@04)                            0493
*       RCREG=4;                    /* INDICATE BAD RETURN CODE FROM
*                                      FORMATTER                     */
         LA    RCREG,4                                             0494
*     END;                          /* END FORMAT ROUTINE ERROR      */
*   ELSE                                                           0496
*     ;                             /* FORMATTED LINE IS IN BUFFER   */
@RF00489 DS    0H                                                  0497
*   RCCODE=RCREG;                   /* SAVE RETURN CODE FROM FORMAT
*                                      SERVICE ROUTINE               */
         ST    RCREG,RCCODE                                        0497
*   CALL PRINT;                     /* PRINT THE ERROR MSG OR      0498
*                                      FORMATTED LINE                */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0498
         BALR  @14,@15                                             0498
*   RETURN CODE(RCCODE);                                           0499
         L     @15,RCCODE                                          0499
@EL00007 DS    0H                                                  0499
@EF00007 DS    0H                                                  0499
@ER00007 L     @14,@SA00007                                        0499
         BR    @14                                                 0499
*   END FMTRTN;                                                    0500
*ANALYZE:                                                          0501
*   PROC OPTIONS(SAVE(14));                                        0501
*                                                                  0501
ANALYZE  ST    @14,@SA00008                                        0501
*/****************************************************************** */
*/* FUNCTION                                                       0502
*     ROUTINE TO ANALYZE THE BITS IN THE BYTE PASSED AND PRINT OUT 0502
*     THE MESSAGE THAT CORRESPONDS TO THE BITS THAT ARE ON. IF A BLANK
*     LINE IS PASSED IN THE MESSAGE ARRAY (INDICATING A RESERVED BIT)
*     NO OUTPUT WILL CORRESPOND TO THAT BIT.                       0502
*                                                                  0502
*   INPUT-                                                         0502
*     AN ARRAY (SUMMARY) POINTED TO BY THE PARMLIST FIELD          0502
*     ADPLCOM2 WHICH CONTAINS THE ADDRESS OF THE BYTE TO BE        0502
*     ANALYZED, THE ADDRESS OF THE ARRAY OF CORRESPONDING          0502
*     MESSAGES, THE COLUMN NUMBER THE MESSAGE IS TO BEGIN IN,      0502
*     AND THE LENGTH OF THE MESSAGE ARRAY PASSED.                  0502
*                                                                  0502
*   NOTE- COLNUM + MSGLNGTH MUST BE LESS THAN OR EQUAL TO 120 BYTES
*         WHICH IS THE OUTPUT BUFFER LENGTH.                       0502
*                                                                  0502
*                                                                  0502
*   CALLS-                                                         0502
*       CALLS PRINT                                                0502
*                                                                  0502
*   CALLED BY -                                                    0502
*       BYTEMODE,EEDBITS,IEAFTESA,IEAFTSCB,RT2BITS                 0502
*                                                                  0502
*   RETURNS CONTROL TO -                                           0502
*       CALLER WITHOUT SETTING A RETURN CODE                       0502
*                                                                  0502
*   THIS PROCEDURE HAS BEEN INCLUDED FROM SYSLIB(IHAFTCDE)-------  0502
*                                                                    */
*/****************************************************************** */
*                                                                  0502
*   DO INDEX=1 TO BYTELNTH;         /* LOOP TO FIND WHICH BITS ARE ON*/
         LA    INDEX,1                                             0502
@DL00502 DS    0H                                                  0503
*     LNGTHEQU=((INDEX-1)*(MSGLNGTH)+1);/* OFFSET INTO MSGARY OF   0503
*                                      CORRESPONDING MESSAGE         */
         L     @14,MSGLNGTH                                        0503
         LR    @03,INDEX                                           0503
         BCTR  @03,0                                               0503
         MR    @02,@14                                             0503
         AH    @03,@CH00041                                        0503
         LR    LNGTHEQU,@03                                        0503
*     IF(BITSTR&TESTBITS(INDEX))^=ZEROBYTE&/* FOUND A BIT ON         */
*         MSGARY(LNGTHEQU:MSGLNGTH+LNGTHEQU-1)^=BLANKS(1:MSGLNGTH) THEN
         L     @09,BYTEADDR                                        0504
         SLR   @04,@04                                             0504
         IC    @04,BITSTR(,@09)                                    0504
         SLR   @09,@09                                             0504
         IC    @09,TESTBITS-1(INDEX)                               0504
         NR    @04,@09                                             0504
         SLR   @09,@09                                             0504
         IC    @09,ZEROBYTE                                        0504
         CR    @04,@09                                             0504
         BE    @RF00504                                            0504
         L     @09,MSGADDR                                         0504
         LR    @04,@14                                             0504
         BCTR  @04,0                                               0504
         LR    @03,@09                                             0504
         ALR   @03,LNGTHEQU                                        0504
         BCTR  @03,0                                               0504
         EX    @04,@SC02114                                        0504
         BE    @RF00504                                            0504
*       DO;                         /* CORRESPONDING MESSAGE WAS NOT
*                                      BLANK(RESERVED)               */
*         BUFFER(COLNUM:(MSGLNGTH+COLNUM-1))=MSGARY(LNGTHEQU:LNGTHEQU+
*             MSGLNGTH-1);          /* PLACE MSG IN BUFFER           */
         L     @04,COLNUM                                          0506
         L     @03,ADPLBUF(,ABDPLPTR)                              0506
         ALR   @03,@04                                             0506
         BCTR  @03,0                                               0506
         ALR   @14,@04                                             0506
         SLR   @14,@04                                             0506
         BCTR  @14,0                                               0506
         ALR   @09,LNGTHEQU                                        0506
         BCTR  @09,0                                               0506
         EX    @14,@SM02116                                        0506
*         CALL PRINT;               /* PRINT IT                      */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0507
         BALR  @14,@15                                             0507
*       END;                        /* END FOUND THE MESSAGE         */
*     ELSE                                                         0509
*       ;                           /* EITHER BIT NOT ON OR RESERVED
*                                      BIT-NO MESSAGE                */
@RF00504 DS    0H                                                  0510
*   END;                            /* END SEARCH LOOP               */
         AH    INDEX,@CH00041                                      0510
         CH    INDEX,@CH00086                                      0510
         BNH   @DL00502                                            0510
*   END ANALYZE;                                                   0511
@EL00008 DS    0H                                                  0511
@EF00008 DS    0H                                                  0511
@ER00008 L     @14,@SA00008                                        0511
         BR    @14                                                 0511
*ACCESRTN:                                                         0512
*   PROC OPTIONS(SAVE(14));                                        0512
*                                                                  0512
ACCESRTN ST    @14,@SA00009                                        0512
*/********************************************************************/
*/* FUNCTION-                                                      0513
*       ROUTINE WHICH CALLS THE ACCESS SERVICE ROUTINE AND MOVES THE
*     VALUE RETURNED IN R0 INTO DATAPTR.                           0513
*                                                                  0513
*                                                                  0513
*   INPUT -                                                        0513
*         VADR(REGISTER 0) CONTAINS THE VIRTUAL ADDRESS OF THE FIELD
*         TO BE ACCESSED.                                          0513
*                                                                  0513
*    CALLS-                                                        0513
*         ACCESS SERVICE ROUTINE PASSED IN PARMLIST                0513
*                                                                  0513
*    CALLED BY -                                                   0513
*         EEDBITS, IEAFTEED, IEAFTFRR, IEAFTRTC, IEAFTRT2,         0513
*         IEAFTSCB, RT1BITS, AND RT2BITS                           0513
*                                                                  0513
*    RETURNS TO -                                                  0513
*         CALLER WITH THE RETURN CODE SET BY THE ACCESS            0513
*         SERVICE ROUTINE.                                         0513
*                                                                  0513
*   THIS PROCEDURE HAS BEEN INCLUDED FROM SYSLIB(IHAFTCDE) ------  0513
*                                                                    */
*/********************************************************************/
*                                                                  0513
*   IF ADPLSNPR=OFF THEN            /* SNAP WAS INVOKER              */
         TM    ADPLSNPR(ABDPLPTR),B'10000000'                      0513
         BNZ   @RF00513                                            0513
*     DO;                                                          0514
*       RTYADR=ADDR(RETRY);         /* RETRY ADDR FOR ESTAE IN THE 0515
*                                      CASE OF EXPECTED ERRORS       */
         LA    @14,RETRY                                           0515
         ST    @14,RTYADR(,ESTAPTR)                                0515
*       DATAPTR=VADR;               /* USED TO BASE THE STORAGE ON   */
         LR    DATAPTR,VADR                                        0516
*       RCREG=ZERO;                 /* SUCCESS UNLESS AN ABEND OCCURS
*                                      DURING THE MOVE INTO A BUFFER */
         SLR   RCREG,RCREG                                         0517
*       ERREXP=ON;                  /* AN ERROR IS EXPECTED          */
         OI    ERREXP(ESTAPTR),B'10000000'                         0518
*       VERIFY=DATADWRD;            /* MOVE A DOUBLE WORD INTO     0519
*                                      INTERNAL BUFFER               */
*                                                                  0519
         MVC   VERIFY(8),DATADWRD(DATAPTR)                         0519
*       /*************************************************************/
*       /*                                                           */
*       /* THIS MOVE WILL CAUSE AN ABEND IF THE DUMP DOES NOT CONTAIN*/
*       /* THE AREA REFERENCED OR IF THE AREA IS PROTECTED. IF AN    */
*       /* ABEND OCCURS, THE ESTAE WILL GET CONTROL AND RETRY AT THE */
*       /* POINT WHICH SETS A BAD RETURN CODE AND RETURNS TO THE     */
*       /* CALLER. THIS THEN SIMULATES THE PRINT DUMP ACCESS ROUTINE.*/
*       /* IF THE AREA ASKED FOR IS IN THE DUMP, A DOUBLE WORD IS    */
*       /* MOVED INTO AN INTERNAL BUFFER TO PREVENT AN UNEXPECTED    */
*       /* ERROR WHEN REFERENCING THE AREA AGAIN                     */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0520
*       ERREXP=OFF;                 /* AN ERROR IS NO LONGER EXPECTED*/
         NI    ERREXP(ESTAPTR),B'01111111'                         0520
*       DATAPTR=ADDR(VERIFY);       /* REBASE DATA OFF INTERNAL    0521
*                                      BUFFER                        */
         LA    DATAPTR,VERIFY                                      0521
*     END;                          /* END SNAP WAS THE INVOKER      */
*   ELSE                            /* CALLER HAS OWN ACCESS ROUTINE
*                                      LIKE PRINT DUMP               */
*     DO;                                                          0523
         B     @RC00513                                            0523
@RF00513 DS    0H                                                  0524
*       CALL ACCESS;                /* ACCESS SERVICE ROUTINE PASSED
*                                      BY CALLER                     */
         L     @15,ADPLMEMA(,ABDPLPTR)                             0524
         BALR  @14,@15                                             0524
*       IF RCREG=ZERO THEN                                         0525
         LTR   RCREG,RCREG                                         0525
         BNZ   @RF00525                                            0525
*         DATAPTR=VADR;             /* SAVE PTR RETURNED BY ACCESS 0526
*                                      SERVICE ROUTINE               */
         LR    DATAPTR,VADR                                        0526
*       ELSE                        /* BAD RETURN CODE               */
*RETRY:                             /* RETRY ADDR FOR THE ESTAE      */
*         RCREG=4;                  /* SET A BAD RETURN CODE         */
         B     @RC00525                                            0527
@RF00525 DS    0H                                                  0527
RETRY    LA    RCREG,4                                             0527
*     END;                          /* END CALLER WAS NOT SNAP       */
@RC00525 DS    0H                                                  0529
*   RCCODE=RCREG;                   /* SAVE RETURN CODE FROM ACCESS
*                                      SERVICE RTN                   */
@RC00513 ST    RCREG,RCCODE                                        0529
*   RETURN CODE(RCCODE);                                           0530
         L     @04,RCCODE                                          0530
         LR    @15,@04                                             0530
@EL00009 DS    0H                                                  0530
@EF00009 DS    0H                                                  0530
@ER00009 L     @14,@SA00009                                        0530
         BR    @14                                                 0530
*   END ACCESRTN;                                                  0531
*   DCL                                                            0532
*     IHSPATCH CHAR(200) INIT(                                     0532
*         'PATCH AREA FOR IEAFTIHS - IT IS 200 BYTES LONG');       0532
*   END IEAFTIHS                                                   0533
*                                                                  0533
*/* THE FOLLOWING INCLUDE STATEMENTS WERE FOUND IN THIS PROGRAM.     */
*/*%INCLUDE SYSLIB  (IHAABDPL)                                       */
*/*%INCLUDE SYSLIB  (CVT     )                                       */
*/*%INCLUDE SYSLIB  (IHAFRRS )                                       */
*/*%INCLUDE SYSLIB  (IHAIHSA )                                       */
*/*%INCLUDE SYSLIB  (IHART1W )                                       */
*/*%INCLUDE SYSLIB  (IHASUBIT)                                       */
*/*%INCLUDE SYSLIB  (IHAFTCD1)                                       */
*/*%INCLUDE SYSLIB  (IHAFTCDE)                                       */
*                                                                  0533
*       ;                                                          0533
@DATA    DS    0H
@CH00041 DC    H'1'
@CH00086 DC    H'8'
@CH00718 DC    H'16'
@CH02004 DC    H'50'
@CH00707 DC    H'256'
@CH02080 DC    H'4096'
@SC02114 CLC   MSGARY(0,@03),BLANKS
@SM02116 MVC   BUFFER(0,@03),MSGARY(@09)
@DATD    DSECT
         DS    0F
@SA00001 DS    18F
@SA00009 DS    1F
@SA00007 DS    1F
@SA00002 DS    1F
@SA00003 DS    1F
@SA00005 DS    1F
@SA00004 DS    1F
@SA00008 DS    1F
IEAFTIHS CSECT
         DS    0F
@CF00080 DC    F'4'
@CH00080 EQU   @CF00080+2
@CF01486 DC    F'22'
@CF01445 DC    F'25'
@CF02109 DC    F'-4'
@DATD    DSECT
         DS    0D
FRRSPTR  DS    A
FRREPTR  DS    A
LOOPCNTR DS    F
RCCODE   DS    F
RT1PTR   DS    A
SAVEPTR  DS    A
CONVRT   DS    F
BITS     DS    BL1
         ORG   BITS
SU50SAVE DS    BL1
ERRSW    EQU   BITS+0
@NM00536 EQU   BITS+0
         ORG   BITS+1
CONVERTD DS    CL6
         ORG   CONVERTD
PLUS     DS    CL1
DIGIT    DS    CL5
         ORG   CONVERTD+6
         DS    CL1
SUMMARY  DS    CL16
         ORG   SUMMARY
BYTEADDR DS    AL4
MSGADDR  DS    AL4
COLNUM   DS    FL4
MSGLNGTH DS    FL4
         ORG   SUMMARY+16
         DS    CL4
UNPACK   DS    CL5
         ORG   UNPACK
PACKAREA DS    CL4
GARBAGE  DS    CL1
         ORG   UNPACK+5
         DS    CL3
VERIFY   DS    CL8
NEGBIT   DS    BL1
         ORG   *+1-(*-@DATD)/(*-@DATD) INSURE DSECT DATA
@ENDDATD EQU   *
IEAFTIHS CSECT
         DS    0F
@SIZDATD DC    AL1(0)
         DC    AL3(@ENDDATD-@DATD)
         DS    0D
EXITCK   DC    XL1'78'
MCHCK    DC    XL1'1E'
RECURCK  DC    XL1'FF'
RESCHDCK DC    XL1'5E'
RTRYCK   DC    XL1'5A'
SRMCK    DC    XL1'3C'
ZEROBYTE DC    XL1'00'
IHSAL1   DS    CL18
         ORG   IHSAL1
@NM00017 DC    CL4'CPUT'
@NM00018 DC    CL5'NTCBP'
@NM00019 DC    CL5'OTCBP'
@NM00020 DC    CL4'CPSW'
         ORG   IHSAL1+18
         DS    CL3
IHSAFMT1 DS    CL36
         ORG   IHSAFMT1
@NM00021 DS    CL4
         ORG   @NM00021
@NM00022 DC    X'01'
@NM00023 DC    X'40'
@NM00024 DC    AL1(0)
@NM00025 DC    AL1(0)
         ORG   IHSAFMT1+4
@NM00026 DS    CL8
         ORG   @NM00026
@NM00027 DC    X'07'
@NM00028 DC    X'33'
@NM00029 DC    AL1(8)
@NM00030 DC    AL1(14)
@NM00031 DC    AL4(IHSAL1)
         ORG   IHSAFMT1+12
@NM00032 DS    CL4
         ORG   @NM00032
@NM00033 DC    X'04'
@NM00034 DC    X'03'
@NM00035 DC    AL1(0)
@NM00036 DC    AL1(23)
         ORG   IHSAFMT1+16
@NM00037 DS    CL4
         ORG   @NM00037
@NM00038 DC    X'05'
@NM00039 DC    X'43'
@NM00040 DC    AL1(32)
@NM00041 DC    AL1(38)
         ORG   IHSAFMT1+20
@NM00042 DS    CL4
         ORG   @NM00042
@NM00043 DC    X'05'
@NM00044 DC    X'43'
@NM00045 DC    AL1(47)
@NM00046 DC    AL1(56)
         ORG   IHSAFMT1+24
@NM00047 DS    CL4
         ORG   @NM00047
@NM00048 DC    X'05'
@NM00049 DC    X'33'
@NM00050 DC    AL1(65)
@NM00051 DC    AL1(74)
         ORG   IHSAFMT1+28
@NM00052 DS    CL4
         ORG   @NM00052
@NM00053 DC    X'04'
@NM00054 DC    X'03'
@NM00055 DC    AL1(0)
@NM00056 DC    AL1(83)
         ORG   IHSAFMT1+32
@NM00057 DS    CL4
         ORG   @NM00057
@NM00058 DC    F'0'
         ORG   IHSAFMT1+36
IHSAL2   DS    CL26
         ORG   IHSAL2
@NM00059 DC    CL8'FLOATING'
@NM00060 DC    CL5'POINT'
@NM00061 DC    CL13'REGS(0,2,4,6)'
         ORG   IHSAL2+26
         DS    CL2
IHSAFMT2 DS    CL44
         ORG   IHSAFMT2
@NM00062 DS    CL4
         ORG   @NM00062
@NM00063 DC    X'01'
@NM00064 DC    X'40'
@NM00065 DC    AL1(0)
@NM00066 DC    AL1(0)
         ORG   IHSAFMT2+4
@NM00067 DS    CL8
         ORG   @NM00067
@NM00068 DC    X'07'
@NM00069 DC    X'73'
@NM00070 DC    AL1(8)
@NM00071 DC    AL1(38)
@NM00072 DC    AL4(IHSAL2)
         ORG   IHSAFMT2+12
@NM00073 DS    CL4
         ORG   @NM00073
@NM00074 DC    X'05'
@NM00075 DC    X'43'
@NM00076 DC    AL1(17)
@NM00077 DC    AL1(47)
         ORG   IHSAFMT2+16
@NM00078 DS    CL4
         ORG   @NM00078
@NM00079 DC    X'05'
@NM00080 DC    X'C3'
@NM00081 DC    AL1(23)
@NM00082 DC    AL1(56)
         ORG   IHSAFMT2+20
@NM00083 DS    CL4
         ORG   @NM00083
@NM00084 DC    X'04'
@NM00085 DC    X'03'
@NM00086 DC    AL1(0)
@NM00087 DC    AL1(65)
         ORG   IHSAFMT2+24
@NM00088 DS    CL4
         ORG   @NM00088
@NM00089 DC    X'04'
@NM00090 DC    X'03'
@NM00091 DC    AL1(0)
@NM00092 DC    AL1(74)
         ORG   IHSAFMT2+28
@NM00093 DS    CL4
         ORG   @NM00093
@NM00094 DC    X'04'
@NM00095 DC    X'03'
@NM00096 DC    AL1(0)
@NM00097 DC    AL1(83)
         ORG   IHSAFMT2+32
@NM00098 DS    CL4
         ORG   @NM00098
@NM00099 DC    X'04'
@NM00100 DC    X'03'
@NM00101 DC    AL1(0)
@NM00102 DC    AL1(92)
         ORG   IHSAFMT2+36
@NM00103 DS    CL4
         ORG   @NM00103
@NM00104 DC    X'04'
@NM00105 DC    X'03'
@NM00106 DC    AL1(0)
@NM00107 DC    AL1(101)
         ORG   IHSAFMT2+40
@NM00108 DS    CL4
         ORG   @NM00108
@NM00109 DC    F'0'
         ORG   IHSAFMT2+44
IHSAL3   DS    CL16
         ORG   IHSAL3
@NM00110 DC    CL7'GENERAL'
@NM00111 DC    CL9'REGS(0-F)'
         ORG   IHSAL3+16
IHSAFMT3 DS    CL44
         ORG   IHSAFMT3
@NM00112 DS    CL4
         ORG   @NM00112
@NM00113 DC    X'01'
@NM00114 DC    X'40'
@NM00115 DC    AL1(0)
@NM00116 DC    AL1(0)
         ORG   IHSAFMT3+4
@NM00117 DS    CL8
         ORG   @NM00117
@NM00118 DC    X'07'
@NM00119 DC    X'63'
@NM00120 DC    AL1(8)
@NM00121 DC    AL1(38)
@NM00122 DC    AL4(IHSAL3)
         ORG   IHSAFMT3+12
@NM00123 DS    CL4
         ORG   @NM00123
@NM00124 DC    X'05'
@NM00125 DC    X'83'
@NM00126 DC    AL1(16)
@NM00127 DC    AL1(47)
         ORG   IHSAFMT3+16
@NM00128 DS    CL4
         ORG   @NM00128
@NM00129 DC    X'04'
@NM00130 DC    X'03'
@NM00131 DC    AL1(0)
@NM00132 DC    AL1(56)
         ORG   IHSAFMT3+20
@NM00133 DS    CL4
         ORG   @NM00133
@NM00134 DC    X'04'
@NM00135 DC    X'03'
@NM00136 DC    AL1(0)
@NM00137 DC    AL1(65)
         ORG   IHSAFMT3+24
@NM00138 DS    CL4
         ORG   @NM00138
@NM00139 DC    X'04'
@NM00140 DC    X'03'
@NM00141 DC    AL1(0)
@NM00142 DC    AL1(74)
         ORG   IHSAFMT3+28
@NM00143 DS    CL4
         ORG   @NM00143
@NM00144 DC    X'04'
@NM00145 DC    X'03'
@NM00146 DC    AL1(0)
@NM00147 DC    AL1(83)
         ORG   IHSAFMT3+32
@NM00148 DS    CL4
         ORG   @NM00148
@NM00149 DC    X'04'
@NM00150 DC    X'03'
@NM00151 DC    AL1(0)
@NM00152 DC    AL1(92)
         ORG   IHSAFMT3+36
@NM00153 DS    CL4
         ORG   @NM00153
@NM00154 DC    X'04'
@NM00155 DC    X'03'
@NM00156 DC    AL1(0)
@NM00157 DC    AL1(101)
         ORG   IHSAFMT3+40
@NM00158 DS    CL4
         ORG   @NM00158
@NM00159 DC    F'0'
         ORG   IHSAFMT3+44
IHSAFMT4 DS    CL40
         ORG   IHSAFMT4
@NM00160 DS    CL4
         ORG   @NM00160
@NM00161 DC    X'01'
@NM00162 DC    X'40'
@NM00163 DC    AL1(0)
@NM00164 DC    AL1(0)
         ORG   IHSAFMT4+4
@NM00165 DS    CL4
         ORG   @NM00165
@NM00166 DC    X'04'
@NM00167 DC    X'03'
@NM00168 DC    AL1(0)
@NM00169 DC    AL1(38)
         ORG   IHSAFMT4+8
@NM00170 DS    CL4
         ORG   @NM00170
@NM00171 DC    X'04'
@NM00172 DC    X'03'
@NM00173 DC    AL1(0)
@NM00174 DC    AL1(47)
         ORG   IHSAFMT4+12
@NM00175 DS    CL4
         ORG   @NM00175
@NM00176 DC    X'04'
@NM00177 DC    X'03'
@NM00178 DC    AL1(0)
@NM00179 DC    AL1(56)
         ORG   IHSAFMT4+16
@NM00180 DS    CL4
         ORG   @NM00180
@NM00181 DC    X'04'
@NM00182 DC    X'03'
@NM00183 DC    AL1(0)
@NM00184 DC    AL1(65)
         ORG   IHSAFMT4+20
@NM00185 DS    CL4
         ORG   @NM00185
@NM00186 DC    X'04'
@NM00187 DC    X'03'
@NM00188 DC    AL1(0)
@NM00189 DC    AL1(74)
         ORG   IHSAFMT4+24
@NM00190 DS    CL4
         ORG   @NM00190
@NM00191 DC    X'04'
@NM00192 DC    X'03'
@NM00193 DC    AL1(0)
@NM00194 DC    AL1(83)
         ORG   IHSAFMT4+28
@NM00195 DS    CL4
         ORG   @NM00195
@NM00196 DC    X'04'
@NM00197 DC    X'03'
@NM00198 DC    AL1(0)
@NM00199 DC    AL1(92)
         ORG   IHSAFMT4+32
@NM00200 DS    CL4
         ORG   @NM00200
@NM00201 DC    X'04'
@NM00202 DC    X'03'
@NM00203 DC    AL1(0)
@NM00204 DC    AL1(101)
         ORG   IHSAFMT4+36
@NM00205 DS    CL4
         ORG   @NM00205
@NM00206 DC    F'0'
         ORG   IHSAFMT4+40
SU50L1   DS    CL19
         ORG   SU50L1
@NM00207 DC    CL8'RESERVED'
@NM00208 DC    CL4'FRRL'
@NM00209 DC    CL7'CURRENT'
         ORG   SU50L1+19
         DS    CL1
SU50FMT1 DS    CL28
         ORG   SU50FMT1
@NM00210 DS    CL4
         ORG   @NM00210
@NM00211 DC    X'01'
@NM00212 DC    X'40'
@NM00213 DC    AL1(0)
@NM00214 DC    AL1(0)
         ORG   SU50FMT1+4
@NM00215 DS    CL8
         ORG   @NM00215
@NM00216 DC    X'07'
@NM00217 DC    X'73'
@NM00218 DC    AL1(8)
@NM00219 DC    AL1(17)
@NM00220 DC    AL4(SU50L1)
         ORG   SU50FMT1+12
@NM00221 DS    CL4
         ORG   @NM00221
@NM00222 DC    X'04'
@NM00223 DC    X'03'
@NM00224 DC    AL1(0)
@NM00225 DC    AL1(26)
         ORG   SU50FMT1+16
@NM00226 DS    CL4
         ORG   @NM00226
@NM00227 DC    X'05'
@NM00228 DC    X'33'
@NM00229 DC    AL1(35)
@NM00230 DC    AL1(44)
         ORG   SU50FMT1+20
@NM00231 DS    CL4
         ORG   @NM00231
@NM00232 DC    X'05'
@NM00233 DC    X'63'
@NM00234 DC    AL1(53)
@NM00235 DC    AL1(62)
         ORG   SU50FMT1+24
@NM00236 DS    CL4
         ORG   @NM00236
@NM00237 DC    F'0'
         ORG   SU50FMT1+28
FRRSL1   DS    CL24
         ORG   FRRSL1
@NM00238 DC    CL7'FRRSEMP'
@NM00239 DC    CL4'LAST'
@NM00240 DC    CL6'LENGTH'
@NM00241 DC    CL7'CURRENT'
         ORG   FRRSL1+24
FRRFMT1  DS    CL28
         ORG   FRRFMT1
@NM00242 DS    CL4
         ORG   @NM00242
@NM00243 DC    X'01'
@NM00244 DC    X'40'
@NM00245 DC    AL1(0)
@NM00246 DC    AL1(0)
         ORG   FRRFMT1+4
@NM00247 DS    CL8
         ORG   @NM00247
@NM00248 DC    X'07'
@NM00249 DC    X'63'
@NM00250 DC    AL1(8)
@NM00251 DC    AL1(16)
@NM00252 DC    AL4(FRRSL1)
         ORG   FRRFMT1+12
@NM00253 DS    CL4
         ORG   @NM00253
@NM00254 DC    X'05'
@NM00255 DC    X'33'
@NM00256 DC    AL1(25)
@NM00257 DC    AL1(30)
         ORG   FRRFMT1+16
@NM00258 DS    CL4
         ORG   @NM00258
@NM00259 DC    X'05'
@NM00260 DC    X'53'
@NM00261 DC    AL1(39)
@NM00262 DC    AL1(46)
         ORG   FRRFMT1+20
@NM00263 DS    CL4
         ORG   @NM00263
@NM00264 DC    X'05'
@NM00265 DC    X'63'
@NM00266 DC    AL1(55)
@NM00267 DC    AL1(63)
         ORG   FRRFMT1+24
@NM00268 DS    CL4
         ORG   @NM00268
@NM00269 DC    F'0'
         ORG   FRRFMT1+28
FRRSL2   DS    CL17
         ORG   FRRSL2
@NM00270 DC    CL4'FRRP'
@NM00271 DC    CL5'FLAGS'
@NM00272 DC    CL8'PARMAREA'
         ORG   FRRSL2+17
         DS    CL3
FRRFMT2  DS    CL44
         ORG   FRRFMT2
@NM00273 DS    CL4
         ORG   @NM00273
@NM00274 DC    X'01'
@NM00275 DC    X'40'
@NM00276 DC    AL1(0)
@NM00277 DC    AL1(0)
         ORG   FRRFMT2+4
@NM00278 DS    CL8
         ORG   @NM00278
@NM00279 DC    X'07'
@NM00280 DC    X'33'
@NM00281 DC    AL1(8)
@NM00282 DC    AL1(13)
@NM00283 DC    AL4(FRRSL2)
         ORG   FRRFMT2+12
@NM00284 DS    CL4
         ORG   @NM00284
@NM00285 DC    X'05'
@NM00286 DC    X'43'
@NM00287 DC    AL1(22)
@NM00288 DC    AL1(28)
         ORG   FRRFMT2+16
@NM00289 DS    CL4
         ORG   @NM00289
@NM00290 DC    X'05'
@NM00291 DC    X'73'
@NM00292 DC    AL1(37)
@NM00293 DC    AL1(46)
         ORG   FRRFMT2+20
@NM00294 DS    CL4
         ORG   @NM00294
@NM00295 DC    X'04'
@NM00296 DC    X'03'
@NM00297 DC    AL1(0)
@NM00298 DC    AL1(55)
         ORG   FRRFMT2+24
@NM00299 DS    CL4
         ORG   @NM00299
@NM00300 DC    X'04'
@NM00301 DC    X'03'
@NM00302 DC    AL1(0)
@NM00303 DC    AL1(64)
         ORG   FRRFMT2+28
@NM00304 DS    CL4
         ORG   @NM00304
@NM00305 DC    X'04'
@NM00306 DC    X'03'
@NM00307 DC    AL1(0)
@NM00308 DC    AL1(73)
         ORG   FRRFMT2+32
@NM00309 DS    CL4
         ORG   @NM00309
@NM00310 DC    X'04'
@NM00311 DC    X'03'
@NM00312 DC    AL1(0)
@NM00313 DC    AL1(82)
         ORG   FRRFMT2+36
@NM00314 DS    CL4
         ORG   @NM00314
@NM00315 DC    X'04'
@NM00316 DC    X'03'
@NM00317 DC    AL1(0)
@NM00318 DC    AL1(91)
         ORG   FRRFMT2+40
@NM00319 DS    CL4
         ORG   @NM00319
@NM00320 DC    F'0'
         ORG   FRRFMT2+44
RT1WL1   DS    CL33
         ORG   RT1WL1
@NM00321 DC    CL7'LPHASEN'
@NM00322 DC    CL10'REC RTN ID'
@NM00323 DC    CL8'ORIGENPT'
@NM00324 DC    CL8'RESOURCE'
         ORG   RT1WL1+33
         DS    CL3
RT1WFMT1 DS    CL28
         ORG   RT1WFMT1
@NM00325 DS    CL4
         ORG   @NM00325
@NM00326 DC    X'01'
@NM00327 DC    X'40'
@NM00328 DC    AL1(0)
@NM00329 DC    AL1(0)
         ORG   RT1WFMT1+4
@NM00330 DS    CL8
         ORG   @NM00330
@NM00331 DC    X'07'
@NM00332 DC    X'60'
@NM00333 DC    AL1(8)
@NM00334 DC    AL1(16)
@NM00335 DC    AL4(RT1WL1)
         ORG   RT1WFMT1+12
@NM00336 DS    CL4
         ORG   @NM00336
@NM00337 DC    X'05'
@NM00338 DC    X'90'
@NM00339 DC    AL1(23)
@NM00340 DC    AL1(39)
         ORG   RT1WFMT1+16
@NM00341 DS    CL4
         ORG   @NM00341
@NM00342 DC    X'05'
@NM00343 DC    X'70'
@NM00344 DC    AL1(48)
@NM00345 DC    AL1(57)
         ORG   RT1WFMT1+20
@NM00346 DS    CL4
         ORG   @NM00346
@NM00347 DC    X'05'
@NM00348 DC    X'70'
@NM00349 DC    AL1(66)
@NM00350 DC    AL1(75)
         ORG   RT1WFMT1+24
@NM00351 DS    CL4
         ORG   @NM00351
@NM00352 DC    F'0'
         ORG   RT1WFMT1+28
RT1WL2   DS    CL16
         ORG   RT1WL2
@NM00353 DC    CL5'CHECK'
@NM00354 DC    CL7'POINTED'
@NM00355 DC    CL4'REGS'
         ORG   RT1WL2+16
RT1WFMT2 DS    CL40
         ORG   RT1WFMT2
@NM00356 DS    CL4
         ORG   @NM00356
@NM00357 DC    X'01'
@NM00358 DC    X'40'
@NM00359 DC    AL1(0)
@NM00360 DC    AL1(0)
         ORG   RT1WFMT2+4
@NM00361 DS    CL8
         ORG   @NM00361
@NM00362 DC    X'07'
@NM00363 DC    X'43'
@NM00364 DC    AL1(8)
@NM00365 DC    AL1(30)
@NM00366 DC    AL4(RT1WL2)
         ORG   RT1WFMT2+12
@NM00367 DS    CL4
         ORG   @NM00367
@NM00368 DC    X'01'
@NM00369 DC    X'60'
@NM00370 DC    AL1(14)
@NM00371 DC    AL1(0)
         ORG   RT1WFMT2+16
@NM00372 DS    CL4
         ORG   @NM00372
@NM00373 DC    X'01'
@NM00374 DC    X'30'
@NM00375 DC    AL1(23)
@NM00376 DC    AL1(0)
         ORG   RT1WFMT2+20
@NM00377 DS    CL4
         ORG   @NM00377
@NM00378 DC    X'04'
@NM00379 DC    X'03'
@NM00380 DC    AL1(0)
@NM00381 DC    AL1(39)
         ORG   RT1WFMT2+24
@NM00382 DS    CL4
         ORG   @NM00382
@NM00383 DC    X'04'
@NM00384 DC    X'03'
@NM00385 DC    AL1(0)
@NM00386 DC    AL1(48)
         ORG   RT1WFMT2+28
@NM00387 DS    CL4
         ORG   @NM00387
@NM00388 DC    X'04'
@NM00389 DC    X'03'
@NM00390 DC    AL1(0)
@NM00391 DC    AL1(57)
         ORG   RT1WFMT2+32
@NM00392 DS    CL4
         ORG   @NM00392
@NM00393 DC    X'04'
@NM00394 DC    X'03'
@NM00395 DC    AL1(0)
@NM00396 DC    AL1(66)
         ORG   RT1WFMT2+36
@NM00397 DS    CL4
         ORG   @NM00397
@NM00398 DC    F'0'
         ORG   RT1WFMT2+40
RT1WL3   DS    CL18
         ORG   RT1WL3
@NM00399 DC    CL5'PSW1P'
@NM00400 DC    CL5'PSW2P'
@NM00401 DC    CL8'VARIABLE'
         ORG   RT1WL3+18
         DS    CL2
RT1WFMT3 DS    CL40
         ORG   RT1WFMT3
@NM00402 DS    CL4
         ORG   @NM00402
@NM00403 DC    X'01'
@NM00404 DC    X'40'
@NM00405 DC    AL1(0)
@NM00406 DC    AL1(0)
         ORG   RT1WFMT3+4
@NM00407 DS    CL8
         ORG   @NM00407
@NM00408 DC    X'07'
@NM00409 DC    X'43'
@NM00410 DC    AL1(8)
@NM00411 DC    AL1(14)
@NM00412 DC    AL4(RT1WL3)
         ORG   RT1WFMT3+12
@NM00413 DS    CL4
         ORG   @NM00413
@NM00414 DC    X'05'
@NM00415 DC    X'43'
@NM00416 DC    AL1(23)
@NM00417 DC    AL1(30)
         ORG   RT1WFMT3+16
@NM00418 DS    CL4
         ORG   @NM00418
@NM00419 DC    X'05'
@NM00420 DC    X'73'
@NM00421 DC    AL1(39)
@NM00422 DC    AL1(48)
         ORG   RT1WFMT3+20
@NM00423 DS    CL4
         ORG   @NM00423
@NM00424 DC    X'04'
@NM00425 DC    X'03'
@NM00426 DC    AL1(0)
@NM00427 DC    AL1(57)
         ORG   RT1WFMT3+24
@NM00428 DS    CL4
         ORG   @NM00428
@NM00429 DC    X'04'
@NM00430 DC    X'03'
@NM00431 DC    AL1(0)
@NM00432 DC    AL1(66)
         ORG   RT1WFMT3+28
@NM00433 DS    CL4
         ORG   @NM00433
@NM00434 DC    X'04'
@NM00435 DC    X'03'
@NM00436 DC    AL1(0)
@NM00437 DC    AL1(75)
         ORG   RT1WFMT3+32
@NM00438 DS    CL4
         ORG   @NM00438
@NM00439 DC    X'04'
@NM00440 DC    X'03'
@NM00441 DC    AL1(0)
@NM00442 DC    AL1(84)
         ORG   RT1WFMT3+36
@NM00443 DS    CL4
         ORG   @NM00443
@NM00444 DC    F'0'
         ORG   RT1WFMT3+40
RT1WL4   DS    CL22
         ORG   RT1WL4
@NM00445 DC    CL5'SDWAP'
@NM00446 DC    CL6'PSDWAP'
@NM00447 DC    CL4'EEDQ'
@NM00448 DC    CL7'EP DATA'
         ORG   RT1WL4+22
         DS    CL2
RT1WFMT4 DS    CL28
         ORG   RT1WFMT4
@NM00449 DS    CL4
         ORG   @NM00449
@NM00450 DC    X'01'
@NM00451 DC    X'40'
@NM00452 DC    AL1(0)
@NM00453 DC    AL1(0)
         ORG   RT1WFMT4+4
@NM00454 DS    CL8
         ORG   @NM00454
@NM00455 DC    X'07'
@NM00456 DC    X'43'
@NM00457 DC    AL1(8)
@NM00458 DC    AL1(14)
@NM00459 DC    AL4(RT1WL4)
         ORG   RT1WFMT4+12
@NM00460 DS    CL4
         ORG   @NM00460
@NM00461 DC    X'05'
@NM00462 DC    X'53'
@NM00463 DC    AL1(23)
@NM00464 DC    AL1(30)
         ORG   RT1WFMT4+16
@NM00465 DS    CL4
         ORG   @NM00465
@NM00466 DC    X'05'
@NM00467 DC    X'33'
@NM00468 DC    AL1(39)
@NM00469 DC    AL1(48)
         ORG   RT1WFMT4+20
@NM00470 DS    CL4
         ORG   @NM00470
@NM00471 DC    X'05'
@NM00472 DC    X'63'
@NM00473 DC    AL1(57)
@NM00474 DC    AL1(66)
         ORG   RT1WFMT4+24
@NM00475 DS    CL4
         ORG   @NM00475
@NM00476 DC    F'0'
         ORG   RT1WFMT4+28
RT1EFMT1 DS    CL24
         ORG   RT1EFMT1
@NM00477 DS    CL4
         ORG   @NM00477
@NM00478 DC    X'01'
@NM00479 DC    X'40'
@NM00480 DC    AL1(0)
@NM00481 DC    AL1(0)
         ORG   RT1EFMT1+4
@NM00482 DS    CL4
         ORG   @NM00482
@NM00483 DC    X'04'
@NM00484 DC    X'03'
@NM00485 DC    AL1(0)
@NM00486 DC    AL1(8)
         ORG   RT1EFMT1+8
@NM00487 DS    CL4
         ORG   @NM00487
@NM00488 DC    X'04'
@NM00489 DC    X'03'
@NM00490 DC    AL1(0)
@NM00491 DC    AL1(17)
         ORG   RT1EFMT1+12
@NM00492 DS    CL4
         ORG   @NM00492
@NM00493 DC    X'04'
@NM00494 DC    X'03'
@NM00495 DC    AL1(0)
@NM00496 DC    AL1(26)
         ORG   RT1EFMT1+16
@NM00497 DS    CL4
         ORG   @NM00497
@NM00498 DC    X'04'
@NM00499 DC    X'03'
@NM00500 DC    AL1(0)
@NM00501 DC    AL1(35)
         ORG   RT1EFMT1+20
@NM00502 DS    CL4
         ORG   @NM00502
@NM00503 DC    F'0'
         ORG   RT1EFMT1+24
RT1EFMT2 DS    CL28
         ORG   RT1EFMT2
@NM00504 DS    CL4
         ORG   @NM00504
@NM00505 DC    X'01'
@NM00506 DC    X'40'
@NM00507 DC    AL1(0)
@NM00508 DC    AL1(0)
         ORG   RT1EFMT2+4
@NM00509 DS    CL4
         ORG   @NM00509
@NM00510 DC    X'04'
@NM00511 DC    X'03'
@NM00512 DC    AL1(0)
@NM00513 DC    AL1(8)
         ORG   RT1EFMT2+8
@NM00514 DS    CL4
         ORG   @NM00514
@NM00515 DC    X'04'
@NM00516 DC    X'03'
@NM00517 DC    AL1(0)
@NM00518 DC    AL1(17)
         ORG   RT1EFMT2+12
@NM00519 DS    CL4
         ORG   @NM00519
@NM00520 DC    X'04'
@NM00521 DC    X'03'
@NM00522 DC    AL1(0)
@NM00523 DC    AL1(26)
         ORG   RT1EFMT2+16
@NM00524 DS    CL4
         ORG   @NM00524
@NM00525 DC    X'04'
@NM00526 DC    X'03'
@NM00527 DC    AL1(0)
@NM00528 DC    AL1(35)
         ORG   RT1EFMT2+20
@NM00529 DS    CL4
         ORG   @NM00529
@NM00530 DC    X'04'
@NM00531 DC    X'03'
@NM00532 DC    AL1(0)
@NM00533 DC    AL1(44)
         ORG   RT1EFMT2+24
@NM00534 DS    CL4
         ORG   @NM00534
@NM00535 DC    F'0'
         ORG   RT1EFMT2+28
REL2     DC    CL2'02'
TRANS    DS    CL256
         ORG   TRANS
@NM00540 DS    CL64
BL       DC    CL1' '
@NM00541 DS    CL175
NUMS     DC    CL16'0123456789ABCDEF'
         ORG   TRANS+256
BADMAX   DC    CL72'*** ERROR IN THE FIELDS USED TO DETERMINE THE NUMBEC
               R OF FRR ENTRIES ***'
FRRSFMT  DC    CL120'*** FORMATTING ROUTINE ERROR DURING FRRS FORMATTINC
               G (POSSIBLE CAUSE: DATA NOT IN DUMP) ***'
FRRHDR   DC    CL54'-CURRENT FRR STACK------------------------AT LOCATIC
               ON '
IHSAUS   DC    CL28' ---------------------------'
         ORG   IHSAUS
@NM00542 DS    CL1
UNDRSC   DS    CL27
         ORG   IHSAUS+28
FRREHDR  DC    CL11'FRR ENTRIES'
IHSAFMT  DC    CL120'*** FORMATTING ROUTINE ERROR DURING IHSA FORMATTINC
               G (POSSIBLE CAUSE: DATA NOT IN DUMP) ***'
IHSAFMSG DC    CL9'FRR STACK'
IHSAHDR  DC    CL54'-INTERRUPT HANDLER SAVE AREA--------------AT LOCATIC
               ON '
FRRLZERO DC    CL64'*** WARNING, ZERO LENGTH STACK FOUND - FORMATTING TC
               ERMINATED ***'
LPNSTART DC    CL24'LOGICAL PHASE NUMBER IS '
RT1MSG   DC    CL38'( RT1W WORK AREA FOLLOWS FRR ENTRIES )'
RT1HDR   DC    CL14'RT1W WORK AREA'
RT1SUM   DC    CL21'RT1W BIT FLAG SUMMARY'
RT1WARN  DC    CL49'*** WARNING, RT1W MAY NOT BE CURRENT OR VALID ***'
EXITMSG  DC    CL34'FIELD CONTAINS INTERNAL EXIT FLAGS'
RTSTART  DC    CL17'RTM1 ENTERED FOR '
SYSTATE  DC    CL13'SYSTEM STATE:'
BLANKS   DC    CL120' '
IHSPATCH DC    CL200'PATCH AREA FOR IEAFTIHS - IT IS 200 BYTES LONG'
IHSANAME DC    AL4(IHSAFMT1)
         DC    AL4(IHSAFMT2)
         DC    AL4(IHSAFMT3)
         DC    AL4(IHSAFMT4)
IHSASU50 DC    AL4(SU50FMT1)
FRRNAMES DC    AL4(FRRFMT1)
         DC    AL4(FRRFMT2)
RT1WNAME DC    AL4(RT1WFMT1)
         DC    AL4(RT1WFMT2)
         DC    AL4(RT1WFMT3)
         DC    AL4(RT1WFMT4)
RT1ENAME DC    AL4(RT1EFMT1)
         DC    AL4(RT1EFMT1)
         DC    AL4(RT1EFMT1)
         DC    AL4(RT1EFMT2)
LPNARRAY DC    CL40',MANAGEMENT FUNCTION'
         DC    CL40',MACHINE CHECK FUNCTION'
         DC    CL40',SRM FUNCTION'
         DC    CL40',RESCHEDULE FUNCTION WITH POSSIBLE RETRY'
         DC    CL40',RESCHEDULE FUNCTION'
         DC    CL40',EXIT FUNCTION'
         DC    CL40',ANTICIPATED RECURSION'
MODEMSG  DC    CL25'SUPERVISOR CONTROL MODE'
         DC    CL25'PHYSICALLY DISABLED STATE'
         DC    CL25'GLOBAL SPIN LOCK HELD'
         DC    CL25'GLOBAL SUSPEND LOCK HELD'
         DC    CL25'LOCALLY LOCKED MODE'
         DC    CL25'TYPE 1 SVC MODE'
         DC    CL25'SRB MODE'
         DC    CL25'TASK MODE'
RTARRAY  DC    CL50'PROGRAM CHECK'
         DC    CL50'RESTART'
         DC    CL50'SVC ERROR'
         DC    CL50'DAT ERROR'
         DC    CL50'MACHINE CHECK REENTRY'
         DC    CL50'RESCHEDULE OF PAGE I/O ERROR'
         DC    CL50'RESCHEDULE OF ABNORMAL TERMINATION'
         DC    CL50'RESCHEDULE OF ABNORMAL TERMINATION THROUGH CVTBTRM'
         DC    CL50'RESCHEDULE OF CROSS MEMORY ABNORMAL TERMINATION'
         DC    CL50'RESCHEDULE OF ABNORMAL TERMINATION OF CURRENT TCB'
         DC    CL50'MEMORY TERMINATION'
         DC    CL50'CROSS MEMORY ABNORMAL TERMINATION'
         DC    CL50'RESCHEDULE OF RTM1 ON OTHER CPU'
         DC    CL50'MACHINE CHECK'
TESTBITS DC    X'80'
         DC    X'40'
         DC    X'20'
         DC    X'10'
         DC    X'08'
         DC    X'04'
         DC    X'02'
         DC    X'01'
@00      EQU   00                      EQUATES FOR REGISTERS 0-15
@01      EQU   01
@02      EQU   02
@03      EQU   03
@04      EQU   04
@05      EQU   05
@06      EQU   06
@07      EQU   07
@08      EQU   08
@09      EQU   09
@10      EQU   10
@11      EQU   11
@12      EQU   12
@13      EQU   13
@14      EQU   14
@15      EQU   15
LNGTHEQU EQU   @06
INDEX    EQU   @08
IHSAPTR  EQU   @08
LPN      EQU   @08
ESTAPTR  EQU   @07
ENTRYMAX EQU   @09
DATAPTR  EQU   @05
ARRAYCNT EQU   @06
ABDPLPTR EQU   @01
LINEPTR  EQU   @00
VADR     EQU   @00
RCREG    EQU   @15
ABDPL    EQU   0
ADPLFLAG EQU   ABDPL+7
ADPLSNPR EQU   ADPLFLAG
ADPLBUF  EQU   ABDPL+8
ADPLPRNT EQU   ABDPL+12
ADPLCVT  EQU   ABDPL+16
ADPLMEMA EQU   ABDPL+20
ADPLFRMT EQU   ABDPL+24
ADPLCOM1 EQU   ABDPL+28
ADPLCOM2 EQU   ABDPL+32
ADPLFMT1 EQU   ABDPL+44
ADPLFMT2 EQU   ABDPL+48
CVTMAP   EQU   0
CVTBTERM EQU   CVTMAP+52
CVTDAR   EQU   CVTMAP+72
CVTFLGS1 EQU   CVTDAR
CVTDCB   EQU   CVTMAP+116
CVTIOQET EQU   CVTMAP+120
CVTIERLC EQU   CVTMAP+144
CVTHEAD  EQU   CVTMAP+160
CVTSV76C EQU   CVTHEAD
CVTOPTA  EQU   CVTMAP+182
CVTOPTB  EQU   CVTMAP+183
CVTGTF   EQU   CVTMAP+236
CVTGTFST EQU   CVTGTF
CVTGTFS  EQU   CVTGTFST
CVTSTATE EQU   CVTGTFST
CVTTMODE EQU   CVTGTFST
CVTFORM  EQU   CVTGTFST
CVTAQAVT EQU   CVTMAP+240
CVTTCMFG EQU   CVTAQAVT
CVTVOLM2 EQU   CVTMAP+244
CVTTATA  EQU   CVTVOLM2
CVTTSKS  EQU   CVTTATA
CVTVOLF2 EQU   CVTTSKS
CVTTAT   EQU   CVTTATA+1
CVTATER  EQU   CVTMAP+248
CVTEXT1  EQU   CVTMAP+252
CVTPURG  EQU   CVTMAP+260
CVTQMSG  EQU   CVTMAP+268
CVTDMSR  EQU   CVTMAP+272
CVTRSV37 EQU   CVTDMSR
CVTDMSRF EQU   CVTRSV37
CVTERPV  EQU   CVTMAP+316
CVTINTLA EQU   CVTMAP+320
CVTAPF   EQU   CVTMAP+324
CVTEXT2  EQU   CVTMAP+328
CVTHJES  EQU   CVTMAP+332
CVTPGSIA EQU   CVTMAP+348
CVTA1F1  EQU   CVTMAP+356
CVTSYSK  EQU   CVTMAP+357
CVTVOLM1 EQU   CVTMAP+380
CVTVOLF1 EQU   CVTVOLM1
CVTXTNT1 EQU   0
CVTXTNT2 EQU   0
CVTDSSV  EQU   CVTXTNT2
CVTFLGBT EQU   CVTXTNT2+5
CVTQID   EQU   CVTXTNT2+24
CVTRV400 EQU   CVTXTNT2+52
CVTRV409 EQU   CVTXTNT2+53
CVTATCVT EQU   CVTXTNT2+64
CVTRV429 EQU   CVTXTNT2+84
CVTRV438 EQU   CVTXTNT2+85
CVTRV457 EQU   CVTXTNT2+112
CVTRV466 EQU   CVTXTNT2+113
CVTFIX   EQU   0
CVTRELNO EQU   CVTFIX+252
CVTNUMB  EQU   CVTRELNO
FRRS     EQU   0
FRRSHEAD EQU   FRRS
FRRSEMP  EQU   FRRSHEAD
FRRSLAST EQU   FRRSHEAD+4
FRRSELEN EQU   FRRSHEAD+8
FRRSRTMW EQU   FRRS+16
FRRSENTR EQU   0
FRRSFLGS EQU   FRRSENTR+4
FRRSFLG1 EQU   FRRSFLGS
IHSA     EQU   0
IHSAFPRS EQU   IHSA+24
RT1W     EQU   0
RT1WNPRS EQU   RT1W
RT1WPRSV EQU   RT1W+52
RT1WEED  EQU   RT1WPRSV+8
RT1WENTR EQU   RT1WPRSV+12
RT1WMODE EQU   RT1WENTR
RT1WCOVR EQU   RT1WENTR+2
RT1RTRN  EQU   0
RT1RTRRG EQU   RT1RTRN+4
RT1TRACK EQU   0
RT1TRECC EQU   RT1TRACK
RT1TLPN  EQU   RT1TRECC
RT1TENPT EQU   RT1TRECC+2
RT1TACQR EQU   RT1TRECC+3
RTMBRTAB EQU   0
RTMBTERM EQU   RTMBRTAB
MODEBYTE EQU   0
EED      EQU   0
EEDDES   EQU   EED+4
EEDFLAGS EQU   EEDDES+1
EEDERROR EQU   EED+8
EEDVARBL EQU   EED+12
EEDERMAP EQU   0
EEDERRID EQU   EEDERMAP+70
SUBITS   EQU   0
SUBYTE1  EQU   SUBITS
SUBYTE2  EQU   SUBITS+1
SUBYTE3  EQU   SUBITS+2
SUBYTE4  EQU   SUBITS+3
SUBYTE5  EQU   SUBITS+4
SUBYTE6  EQU   SUBITS+5
SUBYTE7  EQU   SUBITS+6
SU50BIT  EQU   SUBYTE7
SUBYTE8  EQU   SUBITS+7
SUBYTE9  EQU   SUBITS+8
SUBYTE10 EQU   SUBITS+9
SUBYTE11 EQU   SUBITS+10
SUBYTE12 EQU   SUBITS+11
SUBYTE13 EQU   SUBITS+12
ACCESS   EQU   0
FORMAT   EQU   0
PRINT    EQU   0
BUFFER   EQU   0
OFFSET   EQU   BUFFER
ADDRESS  EQU   BUFFER+55
DATABYTE EQU   0
DATADWRD EQU   0
DATAHALF EQU   0
DATAWORD EQU   0
ESTAPARM EQU   0
ESTAERR  EQU   ESTAPARM
ERREXP   EQU   ESTAERR
RTYADR   EQU   ESTAPARM+4
RTYREGS  EQU   ESTAPARM+8
LCALREGS EQU   ESTAPARM+72
ENDMSG   EQU   0
BITSTR   EQU   0
MSG      EQU   0
MSGARY   EQU   0
CVTPTR   EQU   ADPLCVT
CVTS01   EQU   CVTPGSIA
CVTLPDIA EQU   CVTS01+12
CVTDIRST EQU   CVTLPDIA
CVTSLIDA EQU   CVTS01+24
CVTCTLFG EQU   CVTS01+50
CVTRV210 EQU   CVTS01+424
CVTRV219 EQU   CVTS01+425
CVTRV228 EQU   CVTS01+426
CVTRV237 EQU   CVTS01+427
CVTMFRTR EQU   CVTS01+452
CVTRV262 EQU   CVTS01+468
CVTRV271 EQU   CVTS01+469
CVTRV280 EQU   CVTS01+470
CVTRV289 EQU   CVTS01+471
CVTGSDA  EQU   CVTS01+600
CVTIHASU EQU   CVTS01+696
EEDREGSP EQU   EEDVARBL
EEDREGS  EQU   EEDREGSP
EEDPSW   EQU   EEDREGSP+64
EEDPSW1  EQU   EEDPSW
EEDPSW2  EQU   EEDPSW+8
EEDINILC EQU   EEDPSW2
EEDDUMPO EQU   EEDVARBL
EEDSCDMP EQU   EEDDUMPO
EEDSDDAT EQU   EEDSCDMP+4
EEDHWREP EQU   EEDVARBL
EEDHMCHS EQU   EEDHWREP+8
EEDHMCHD EQU   EEDHWREP+9
EEDHRSRS EQU   EEDHWREP+12
EEDHRSR1 EQU   EEDHRSRS
EEDHRSR2 EQU   EEDHRSRS+1
START    EQU   ADPLFMT1
FRRSUS   EQU   IHSAUS
FRREUS   EQU   UNDRSC
IHSAFRUS EQU   UNDRSC
RT1SUS   EQU   UNDRSC
RT1US    EQU   UNDRSC
         AGO   .@UNREFD                START UNREFERENCED COMPONENTS
EEDHTIME EQU   EEDHWREP+20
EEDHRFSA EQU   EEDHWREP+16
@NM00015 EQU   EEDHWREP+14
EEDHVERQ EQU   EEDHRSR2
EEDHPGFX EQU   EEDHRSR2
EEDHFLSQ EQU   EEDHRSR2
EEDHFSQA EQU   EEDHRSR2
EEDHNUCL EQU   EEDHRSR2
EEDHSPER EQU   EEDHRSR2
EEDHINTC EQU   EEDHRSR2
EEDHOFLN EQU   EEDHRSR2
EEDHCHNG EQU   EEDHRSR1
EEDHMSER EQU   EEDHRSR1
@NM00014 EQU   EEDHRSR1
EEDHCPID EQU   EEDHWREP+10
EEDHTERR EQU   EEDHMCHD
EEDHSOFT EQU   EEDHMCHD
EEDHINSF EQU   EEDHMCHD
EEDHACR  EQU   EEDHMCHD
EEDHSCK  EQU   EEDHMCHD
EEDHPSWU EQU   EEDHMCHD
EEDHREGU EQU   EEDHMCHD
EEDHSKYF EQU   EEDHMCHD
@NM00013 EQU   EEDHMCHS
@NM00012 EQU   EEDHMCHS
EEDHRSRF EQU   EEDHMCHS
EEDRSRC  EQU   EEDHMCHS
EEDINVP  EQU   EEDHMCHS
EEDHTSVL EQU   EEDHMCHS
EEDHRCDF EQU   EEDHMCHS
EEDHSRVL EQU   EEDHMCHS
EEDHSCKE EQU   EEDHWREP+4
EEDHSCKB EQU   EEDHWREP
EEDSDPSL EQU   EEDDUMPO+8
EEDSPDAT EQU   EEDSDDAT+2
EEDSSDAT EQU   EEDSDDAT
EEDSDUMP EQU   EEDSCDMP
EEDTRANS EQU   EEDPSW2+4
EEDINTCD EQU   EEDINILC+2
EEDILC   EQU   EEDINILC+1
@NM00011 EQU   EEDINILC
EEDPSWIC EQU   EEDPSW1+4
EEDPSWMK EQU   EEDPSW1
EEDREG15 EQU   EEDREGS+60
EEDREG14 EQU   EEDREGS+56
EEDREG13 EQU   EEDREGS+52
EEDREG12 EQU   EEDREGS+48
EEDREG11 EQU   EEDREGS+44
EEDREG10 EQU   EEDREGS+40
EEDREG9  EQU   EEDREGS+36
EEDREG8  EQU   EEDREGS+32
EEDREG7  EQU   EEDREGS+28
EEDREG6  EQU   EEDREGS+24
EEDREG5  EQU   EEDREGS+20
EEDREG4  EQU   EEDREGS+16
EEDREG3  EQU   EEDREGS+12
EEDREG2  EQU   EEDREGS+8
EEDREG1  EQU   EEDREGS+4
EEDREG0  EQU   EEDREGS
CVTRV628 EQU   CVTS01+728
CVTRV627 EQU   CVTS01+724
CVTRV626 EQU   CVTS01+720
CVTRV625 EQU   CVTS01+716
CVTRV624 EQU   CVTS01+712
CVTRV623 EQU   CVTS01+708
CVTRV622 EQU   CVTS01+704
CVTRV621 EQU   CVTS01+700
CVTSUSP  EQU   CVTS01+692
CVTT6SVC EQU   CVTS01+688
CVTCDAL  EQU   CVTS01+684
CVTTCTL  EQU   CVTS01+680
CVTRSUME EQU   CVTS01+676
CVTJTERM EQU   CVTS01+672
CVTASMRM EQU   CVTS01+668
CVTTCASP EQU   CVTS01+664
CVT0PT03 EQU   CVTS01+660
CVT0PT0E EQU   CVTS01+656
CVTRV609 EQU   CVTS01+652
CVTCGK   EQU   CVTS01+648
CVTRAC   EQU   CVTS01+644
CVTHSM   EQU   CVTS01+640
CVTRV605 EQU   CVTS01+636
CVTRV604 EQU   CVTS01+632
CVTEFF02 EQU   CVTS01+628
CVTCBBR  EQU   CVTS01+624
CVTSSCR  EQU   CVTS01+620
CVTEVENT EQU   CVTS01+616
CVTCRCA  EQU   CVTS01+612
CVTTPIO  EQU   CVTS01+608
CVTADV   EQU   CVTS01+604
CVTGSDAB EQU   CVTGSDA
CVTQV3   EQU   CVTS01+596
CVTQV2   EQU   CVTS01+592
CVTQV1   EQU   CVTS01+588
CVTRPT   EQU   CVTS01+584
CVTSSRB  EQU   CVTS01+580
CVTCSDRL EQU   CVTS01+576
CVTEXP1  EQU   CVTS01+572
CVTRMPMT EQU   CVTS01+568
CVTRMPTT EQU   CVTS01+564
CVTVPSA  EQU   CVTS01+560
CVTVSTOP EQU   CVTS01+556
CVTGTFR8 EQU   CVTS01+552
CVTQUIT  EQU   CVTS01+548
CVTVACR  EQU   CVTS01+544
CVTWTCB  EQU   CVTS01+540
CVTSTPRS EQU   CVTS01+536
CVT0PT02 EQU   CVTS01+532
CVTDARCM EQU   CVTS01+528
CVTIRECM EQU   CVTS01+524
CVTJRECM EQU   CVTS01+520
CVTVEMS0 EQU   CVTS01+516
CVTSPFRR EQU   CVTS01+512
CVTRLSTG EQU   CVTS01+508
CVT0TC0A EQU   CVTS01+504
CVTGMBR  EQU   CVTS01+500
CVTLFRM  EQU   CVTS01+496
CVTRMBR  EQU   CVTS01+492
CVTVIOP  EQU   CVTS01+488
CVTRV307 EQU   CVTS01+486
CVTRV306 EQU   CVTS01+484
CVTRV305 EQU   CVTS01+482
CVTRV304 EQU   CVTS01+480
CVTRV303 EQU   CVTS01+478
CVTRV302 EQU   CVTS01+476
CVTTRCA  EQU   CVTS01+472
CVTRV297 EQU   CVTRV289
CVTRV296 EQU   CVTRV289
CVTRV295 EQU   CVTRV289
CVTRV294 EQU   CVTRV289
CVTRV293 EQU   CVTRV289
CVTRV292 EQU   CVTRV289
CVTRV291 EQU   CVTRV289
CVTRV290 EQU   CVTRV289
CVTRV288 EQU   CVTRV280
CVTRV287 EQU   CVTRV280
CVTRV286 EQU   CVTRV280
CVTRV285 EQU   CVTRV280
CVTRV284 EQU   CVTRV280
CVTRV283 EQU   CVTRV280
CVTRV282 EQU   CVTRV280
CVTRV281 EQU   CVTRV280
CVTRV279 EQU   CVTRV271
CVTRV278 EQU   CVTRV271
CVTRV277 EQU   CVTRV271
CVTRV276 EQU   CVTRV271
CVTRV275 EQU   CVTRV271
CVTRV274 EQU   CVTRV271
CVTRV273 EQU   CVTRV271
CVTRV272 EQU   CVTRV271
CVTRV270 EQU   CVTRV262
CVTRV269 EQU   CVTRV262
CVTRV268 EQU   CVTRV262
CVTRV267 EQU   CVTRV262
CVTRV266 EQU   CVTRV262
CVTRV265 EQU   CVTRV262
CVTRV264 EQU   CVTRV262
CVTRV263 EQU   CVTRV262
CVTVFP   EQU   CVTS01+464
CVTVSI   EQU   CVTS01+460
CVTVPSIB EQU   CVTS01+456
CVTMFACT EQU   CVTMFRTR
CVTMFCTL EQU   CVTS01+448
CVTPVBP  EQU   CVTS01+444
CVTPWI   EQU   CVTS01+440
CVTRV254 EQU   CVTS01+438
CVTRV253 EQU   CVTS01+436
CVTRV252 EQU   CVTS01+434
CVTRV251 EQU   CVTS01+433
CVTRV250 EQU   CVTS01+432
CVTRV249 EQU   CVTS01+431
CVTRV248 EQU   CVTS01+430
CVTRV247 EQU   CVTS01+429
CVTRV246 EQU   CVTS01+428
CVTRV245 EQU   CVTRV237
CVTRV244 EQU   CVTRV237
CVTRV243 EQU   CVTRV237
CVTRV242 EQU   CVTRV237
CVTRV241 EQU   CVTRV237
CVTRV240 EQU   CVTRV237
CVTRV239 EQU   CVTRV237
CVTRV238 EQU   CVTRV237
CVTRV236 EQU   CVTRV228
CVTRV235 EQU   CVTRV228
CVTRV234 EQU   CVTRV228
CVTRV233 EQU   CVTRV228
CVTRV232 EQU   CVTRV228
CVTRV231 EQU   CVTRV228
CVTRV230 EQU   CVTRV228
CVTRV229 EQU   CVTRV228
CVTRV227 EQU   CVTRV219
CVTRV226 EQU   CVTRV219
CVTRV225 EQU   CVTRV219
CVTRV224 EQU   CVTRV219
CVTRV223 EQU   CVTRV219
CVTRV222 EQU   CVTRV219
CVTRV221 EQU   CVTRV219
CVTRV220 EQU   CVTRV219
CVTRV218 EQU   CVTRV210
CVTRV217 EQU   CVTRV210
CVTRV216 EQU   CVTRV210
CVTRV215 EQU   CVTRV210
CVTRV214 EQU   CVTRV210
CVTRV213 EQU   CVTRV210
CVTRV212 EQU   CVTRV210
CVTRV211 EQU   CVTRV210
CVTLCCAT EQU   CVTS01+420
CVTPCCAT EQU   CVTS01+416
CVTIPCRP EQU   CVTS01+412
CVTIPCRI EQU   CVTS01+408
CVTIPCDS EQU   CVTS01+404
CVTAIDVT EQU   CVTS01+400
CVTSSAP  EQU   CVTS01+396
CVTEHCIR EQU   CVTS01+392
CVTEHDEF EQU   CVTS01+388
CVTDAIR  EQU   CVTS01+384
CVTPERFM EQU   CVTS01+380
CVT044R2 EQU   CVTS01+376
CVTFETCH EQU   CVTS01+372
CVTRSTWD EQU   CVTS01+368
CVTSPOST EQU   CVTS01+364
CVTIOBP  EQU   CVTS01+360
CVTASMVT EQU   CVTS01+356
CVTRECRQ EQU   CVTS01+352
CVTWSAC  EQU   CVTS01+348
CVTRV149 EQU   CVTS01+344
CVTWSAL  EQU   CVTS01+340
CVTSPSA  EQU   CVTS01+336
CVTGLMN  EQU   CVTS01+332
CVTVEAC0 EQU   CVTS01+328
CVT062R1 EQU   CVTS01+324
CVTRPOST EQU   CVTS01+320
CVTDQIQE EQU   CVTS01+316
CVTCSD   EQU   CVTS01+312
CVTLKRMA EQU   CVTS01+308
CVTRSPIE EQU   CVTS01+304
CVTRENQ  EQU   CVTS01+300
CVTLQCB  EQU   CVTS01+296
CVTFQCB  EQU   CVTS01+292
CVTQCS01 EQU   CVTS01+288
CVTAPFT  EQU   CVTS01+284
CVTPARRL EQU   CVTS01+280
CVTVWAIT EQU   CVTS01+276
CVTGSPL  EQU   CVTS01+272
CVTLSMQ  EQU   CVTS01+268
CVTGSMQ  EQU   CVTS01+264
CVTEXPRO EQU   CVTS01+260
CVTOPCTP EQU   CVTS01+256
CVTSIC   EQU   CVTS01+252
CVTTPIOS EQU   CVTS01+248
CVTRTMS  EQU   CVTS01+244
CVTSDBF  EQU   CVTS01+240
CVTSCBP  EQU   CVTS01+236
CVTSDMP  EQU   CVTS01+232
CVTSV60  EQU   CVTS01+228
CVTRTMCT EQU   CVTS01+224
CVTASCBL EQU   CVTS01+220
CVTASCBH EQU   CVTS01+216
CVTGDA   EQU   CVTS01+212
CVTASVT  EQU   CVTS01+208
CVTVVMDI EQU   CVTS01+204
CVTAQTOP EQU   CVTS01+200
CVTIOSCS EQU   CVTS01+196
CVTSDRM  EQU   CVTS01+192
CVTOPTE  EQU   CVTS01+188
CVTSTXU  EQU   CVTS01+184
CVTQUIS  EQU   CVTS01+180
CVTPARS  EQU   CVTS01+176
CVTS1EE  EQU   CVTS01+172
CVTFRAS  EQU   CVTS01+168
CVTQSAS  EQU   CVTS01+164
CVTCRAS  EQU   CVTS01+160
CVTCRMN  EQU   CVTS01+156
CVTDELCP EQU   CVTS01+152
CVTFRECL EQU   CVTS01+148
CVTGETCL EQU   CVTS01+144
CVTBLDCP EQU   CVTS01+140
CVTAUTHL EQU   CVTS01+136
CVTSCAN  EQU   CVTS01+132
CVTRV144 EQU   CVTS01+130
CVTMAXMP EQU   CVTS01+128
CVTSTCK  EQU   CVTS01+124
CVTRV139 EQU   CVTS01+123
CVTDSSAC EQU   CVTS01+122
CVTRV513 EQU   CVTS01+121
CVTIOSPL EQU   CVTS01+120
CVTPTGT  EQU   CVTS01+116
CVTCSPIE EQU   CVTS01+112
CVTSMFEX EQU   CVTS01+108
CVTOLT0A EQU   CVTS01+104
CVTSRBRT EQU   CVTS01+100
CVTPUTL  EQU   CVTS01+96
CVTASCRL EQU   CVTS01+92
CVTASCRF EQU   CVTS01+88
CVTRV326 EQU   CVTS01+84
CVTRV325 EQU   CVTS01+80
CVTRV324 EQU   CVTS01+76
CVT0VL01 EQU   CVTS01+72
CVTSHRVM EQU   CVTS01+68
CVTRV332 EQU   CVTS01+64
CVTTAS   EQU   CVTS01+60
CVTRSCN  EQU   CVTS01+56
CVTTRAC2 EQU   CVTS01+54
CVTTRACE EQU   CVTS01+52
CVTAPG   EQU   CVTS01+51
CVTSDTRC EQU   CVTCTLFG
CVTGTRCE EQU   CVTCTLFG
CVTNOMP  EQU   CVTCTLFG
CVTRSV79 EQU   CVTCTLFG
CVTDSTAT EQU   CVTCTLFG
CVTRSV78 EQU   CVTCTLFG
CVTRV333 EQU   CVTCTLFG
CVTRV323 EQU   CVTCTLFG
CVTSPVLK EQU   CVTS01+49
CVTRSV77 EQU   CVTS01+48
CVTRV331 EQU   CVTS01+44
CVTRV330 EQU   CVTS01+40
CVTRV329 EQU   CVTS01+36
CVTRV328 EQU   CVTS01+32
CVTRV322 EQU   CVTS01+28
CVTSLID  EQU   CVTSLIDA+1
CVTSYLK  EQU   CVTSLIDA
CVTRV321 EQU   CVTS01+20
CVTRV320 EQU   CVTS01+16
CVTLPDIR EQU   CVTLPDIA+1
CVTRSV69 EQU   CVTDIRST
CVTRSV68 EQU   CVTDIRST
CVTRSV67 EQU   CVTDIRST
CVTRSV66 EQU   CVTDIRST
CVTRSV65 EQU   CVTDIRST
CVTRSV64 EQU   CVTDIRST
CVTRSV63 EQU   CVTDIRST
CVTDICOM EQU   CVTDIRST
CVTPVTP  EQU   CVTS01+8
CVTLPDSR EQU   CVTS01+4
CVTGETL  EQU   CVTS01
@NM00539 EQU   ESTAERR
UNEXP2   EQU   ESTAERR
LOCKHELD EQU   ESTAERR
@NM00538 EQU   BUFFER+64
@NM00537 EQU   BUFFER+6
SURV104  EQU   SUBITS+13
SURV103  EQU   SUBYTE13
SURV102  EQU   SUBYTE13
SURV101  EQU   SUBYTE13
SU100BT  EQU   SUBYTE13
SU99BIT  EQU   SUBYTE13
SU98BIT  EQU   SUBYTE13
SU97BIT  EQU   SUBYTE13
SU96BIT  EQU   SUBYTE13
SU95BIT  EQU   SUBYTE12
SU94BIT  EQU   SUBYTE12
SU93BIT  EQU   SUBYTE12
SU92BIT  EQU   SUBYTE12
SU91BIT  EQU   SUBYTE12
SU90BIT  EQU   SUBYTE12
SU89BIT  EQU   SUBYTE12
SU88BIT  EQU   SUBYTE12
SU87BIT  EQU   SUBYTE11
SU86BIT  EQU   SUBYTE11
SU85BIT  EQU   SUBYTE11
SU84BIT  EQU   SUBYTE11
SU83BIT  EQU   SUBYTE11
SU82BIT  EQU   SUBYTE11
SU81BIT  EQU   SUBYTE11
SU80BIT  EQU   SUBYTE11
SU79BIT  EQU   SUBYTE10
SU78BIT  EQU   SUBYTE10
SU77BIT  EQU   SUBYTE10
SU76BIT  EQU   SUBYTE10
SU75BIT  EQU   SUBYTE10
SU74BIT  EQU   SUBYTE10
SU73BIT  EQU   SUBYTE10
SU72BIT  EQU   SUBYTE10
SU71BIT  EQU   SUBYTE9
SU70BIT  EQU   SUBYTE9
SU69BIT  EQU   SUBYTE9
SU68BIT  EQU   SUBYTE9
SU67BIT  EQU   SUBYTE9
SU66BIT  EQU   SUBYTE9
SU65BIT  EQU   SUBYTE9
SU64BIT  EQU   SUBYTE9
SU63BIT  EQU   SUBYTE8
SU62BIT  EQU   SUBYTE8
SU61BIT  EQU   SUBYTE8
SU60BIT  EQU   SUBYTE8
SU59BIT  EQU   SUBYTE8
SU58BIT  EQU   SUBYTE8
SU57BIT  EQU   SUBYTE8
SU56BIT  EQU   SUBYTE8
SU55BIT  EQU   SUBYTE7
SU54BIT  EQU   SUBYTE7
SU53BIT  EQU   SUBYTE7
SU52BIT  EQU   SUBYTE7
SU51BIT  EQU   SUBYTE7
SU49BIT  EQU   SUBYTE7
SU48BIT  EQU   SUBYTE7
SU47BIT  EQU   SUBYTE6
SU46BIT  EQU   SUBYTE6
SU45BIT  EQU   SUBYTE6
SU44BIT  EQU   SUBYTE6
SU43BIT  EQU   SUBYTE6
SU42BIT  EQU   SUBYTE6
SU41BIT  EQU   SUBYTE6
SU40BIT  EQU   SUBYTE6
SU39BIT  EQU   SUBYTE5
SU38BIT  EQU   SUBYTE5
SU37BIT  EQU   SUBYTE5
SU36BIT  EQU   SUBYTE5
SU35BIT  EQU   SUBYTE5
SU34BIT  EQU   SUBYTE5
SU33BIT  EQU   SUBYTE5
SU32BIT  EQU   SUBYTE5
SU31BIT  EQU   SUBYTE4
SU30BIT  EQU   SUBYTE4
SU29BIT  EQU   SUBYTE4
SU28BIT  EQU   SUBYTE4
SU27BIT  EQU   SUBYTE4
SU26BIT  EQU   SUBYTE4
SU25BIT  EQU   SUBYTE4
SU24BIT  EQU   SUBYTE4
SU23BIT  EQU   SUBYTE3
SU22BIT  EQU   SUBYTE3
SU21BIT  EQU   SUBYTE3
SU20BIT  EQU   SUBYTE3
SU19BIT  EQU   SUBYTE3
SU18BIT  EQU   SUBYTE3
SU17BIT  EQU   SUBYTE3
SU16BIT  EQU   SUBYTE3
SU15BIT  EQU   SUBYTE2
SU14BIT  EQU   SUBYTE2
SU13BIT  EQU   SUBYTE2
SU12BIT  EQU   SUBYTE2
SU11BIT  EQU   SUBYTE2
SU10BIT  EQU   SUBYTE2
SU9BIT   EQU   SUBYTE2
SU8BIT   EQU   SUBYTE2
SU7BIT   EQU   SUBYTE1
SU6BIT   EQU   SUBYTE1
SU5BIT   EQU   SUBYTE1
SU4BIT   EQU   SUBYTE1
SU3BIT   EQU   SUBYTE1
SU2BIT   EQU   SUBYTE1
SU1BIT   EQU   SUBYTE1
SU0BIT   EQU   SUBYTE1
EEDETIME EQU   EEDERRID+6
EEDEASID EQU   EEDERRID+4
EEDECPUI EQU   EEDERRID+2
EEDESEQ# EQU   EEDERRID
@NM00016 EQU   EEDERMAP
EEDASID  EQU   EEDERROR+2
EEDERTYP EQU   EEDERROR+1
EEDMODE  EQU   EEDERROR
@NM00010 EQU   EEDDES+2
@NM00009 EQU   EEDFLAGS
EEDNODMP EQU   EEDFLAGS
EEDERFL  EQU   EEDFLAGS
EEDID    EQU   EEDDES
EEDFWRDP EQU   EED
MODETCB  EQU   MODEBYTE
MODESRB  EQU   MODEBYTE
MODETYP1 EQU   MODEBYTE
MODELOC  EQU   MODEBYTE
MODEGSUS EQU   MODEBYTE
MODEGSPN EQU   MODEBYTE
MODEDIS  EQU   MODEBYTE
MODESUPR EQU   MODEBYTE
RTMBXABT EQU   RTMBRTAB+44
RTMBACR  EQU   RTMBRTAB+40
RTMBPROG EQU   RTMBRTAB+36
RTMBMEMT EQU   RTMBRTAB+32
RTMBCABT EQU   RTMBRTAB+28
RTMBPGIO EQU   RTMBRTAB+24
RTMBSVC  EQU   RTMBRTAB+20
RTMBMACH EQU   RTMBRTAB+16
RTMBREST EQU   RTMBRTAB+12
RTMBDAT  EQU   RTMBRTAB+8
RTMBPAD2 EQU   RTMBTERM+6
RTMBBRAN EQU   RTMBTERM+2
RTMBBALR EQU   RTMBTERM
RT1TREGS EQU   RT1TRACK+4
RT1TRETY EQU   RT1TACQR
RT1TLLCK EQU   RT1TACQR
RT1TDISP EQU   RT1TACQR
RT1TLPID EQU   RT1TRECC+1
RT1RTYAD EQU   RT1RTRRG+60
RT1R0R14 EQU   RT1RTRRG
@NM00008 EQU   RT1RTRN
RT1WLPN  EQU   RT1WENTR+3
@NM00007 EQU   RT1WCOVR
RT1NODMP EQU   RT1WCOVR
RT1WEREX EQU   RT1WCOVR
RT1TRTCA EQU   RT1WCOVR
RT1TLOCL EQU   RT1WCOVR
RT1WRTM  EQU   RT1WCOVR
RT1WCLUP EQU   RT1WCOVR
RT1WSRMD EQU   RT1WENTR+1
RT1WSRBR EQU   RT1WPRSV+4
RT1WRTCA EQU   RT1WPRSV
RT1WVARI EQU   RT1WNPRS+32
RT1WPSW2 EQU   RT1WNPRS+28
RT1WPSW1 EQU   RT1WNPRS+24
RT1WLPTA EQU   RT1WNPRS
@NM00006 EQU   IHSA+720
IHSAFRRS EQU   IHSA+120
IHSAGPRS EQU   IHSA+56
IHSAFPR6 EQU   IHSAFPRS+24
IHSAFPR4 EQU   IHSAFPRS+16
IHSAFPR2 EQU   IHSAFPRS+8
IHSAFPR0 EQU   IHSAFPRS
IHSACPSW EQU   IHSA+16
IHSAOTCB EQU   IHSA+12
IHSANTCB EQU   IHSA+8
IHSACPUT EQU   IHSA
FRRSPARM EQU   FRRSENTR+8
@NM00005 EQU   FRRSFLGS+1
@NM00004 EQU   FRRSFLG1
FRRSNEST EQU   FRRSFLG1
FRRSRCUR EQU   FRRSFLG1
FRRSFRRA EQU   FRRSENTR
FRRSENTS EQU   FRRS+84
FRRSCURR EQU   FRRSHEAD+12
CVTLEVL  EQU   CVTRELNO+2
CVTMDL   EQU   CVTFIX+250
@NM00003 EQU   CVTFIX+248
@NM00002 EQU   CVTFIX
CVTRV482 EQU   CVTXTNT2+128
CVTRV481 EQU   CVTXTNT2+124
CVTRV480 EQU   CVTXTNT2+120
CVTRV479 EQU   CVTXTNT2+118
CVTRV478 EQU   CVTXTNT2+117
CVTRV477 EQU   CVTXTNT2+116
CVTRV476 EQU   CVTXTNT2+115
CVTRV475 EQU   CVTXTNT2+114
CVTRV474 EQU   CVTRV466
CVTRV473 EQU   CVTRV466
CVTRV472 EQU   CVTRV466
CVTRV471 EQU   CVTRV466
CVTRV470 EQU   CVTRV466
CVTRV469 EQU   CVTRV466
CVTRV468 EQU   CVTRV466
CVTRV467 EQU   CVTRV466
CVTRV465 EQU   CVTRV457
CVTRV464 EQU   CVTRV457
CVTRV463 EQU   CVTRV457
CVTRV462 EQU   CVTRV457
CVTRV461 EQU   CVTRV457
CVTRV460 EQU   CVTRV457
CVTRV459 EQU   CVTRV457
CVTRV458 EQU   CVTRV457
CVTRV456 EQU   CVTXTNT2+108
CVTRV455 EQU   CVTXTNT2+104
CVTRV454 EQU   CVTXTNT2+100
CVTRV453 EQU   CVTXTNT2+96
CVTRV452 EQU   CVTXTNT2+94
CVTRV451 EQU   CVTXTNT2+92
CVTRV450 EQU   CVTXTNT2+90
CVTRV449 EQU   CVTXTNT2+88
CVTRV448 EQU   CVTXTNT2+87
CVTRV447 EQU   CVTXTNT2+86
CVTRV446 EQU   CVTRV438
CVTRV445 EQU   CVTRV438
CVTRV444 EQU   CVTRV438
CVTRV443 EQU   CVTRV438
CVTRV442 EQU   CVTRV438
CVTRV441 EQU   CVTRV438
CVTRV440 EQU   CVTRV438
CVTRV439 EQU   CVTRV438
CVTRV437 EQU   CVTRV429
CVTRV436 EQU   CVTRV429
CVTRV435 EQU   CVTRV429
CVTRV434 EQU   CVTRV429
CVTRV433 EQU   CVTRV429
CVTRV432 EQU   CVTRV429
CVTRV431 EQU   CVTRV429
CVTRV430 EQU   CVTRV429
CVTRV428 EQU   CVTXTNT2+80
CVTRV427 EQU   CVTXTNT2+76
CVTRV426 EQU   CVTXTNT2+72
CVTRV425 EQU   CVTXTNT2+68
CVTATACT EQU   CVTATCVT
CVTRV423 EQU   CVTXTNT2+62
CVTRV422 EQU   CVTXTNT2+60
CVTRV421 EQU   CVTXTNT2+58
CVTRV420 EQU   CVTXTNT2+56
CVTRV419 EQU   CVTXTNT2+55
CVTRV418 EQU   CVTXTNT2+54
CVTRV417 EQU   CVTRV409
CVTRV416 EQU   CVTRV409
CVTRV415 EQU   CVTRV409
CVTRV414 EQU   CVTRV409
CVTRV413 EQU   CVTRV409
CVTRV412 EQU   CVTRV409
CVTRV411 EQU   CVTRV409
CVTRV410 EQU   CVTRV409
CVTRV408 EQU   CVTRV400
CVTRV407 EQU   CVTRV400
CVTRV406 EQU   CVTRV400
CVTRV405 EQU   CVTRV400
CVTRV404 EQU   CVTRV400
CVTRV403 EQU   CVTRV400
CVTRV402 EQU   CVTRV400
CVTRV401 EQU   CVTRV400
CVTICB   EQU   CVTXTNT2+48
CVTSKTA  EQU   CVTXTNT2+44
CVTCCVT  EQU   CVTXTNT2+40
CVTRSV98 EQU   CVTXTNT2+36
CVTRSV97 EQU   CVTXTNT2+34
CVTRSV96 EQU   CVTXTNT2+32
CVTOLTEP EQU   CVTXTNT2+28
CVTQIDA  EQU   CVTQID+1
CVTRSV95 EQU   CVTQID
CVTRSV94 EQU   CVTXTNT2+20
CVTRSV93 EQU   CVTXTNT2+16
CVTRSV92 EQU   CVTXTNT2+12
CVTDEBVR EQU   CVTXTNT2+8
CVTRSV91 EQU   CVTXTNT2+6
CVTRSV9H EQU   CVTFLGBT
CVTRSV9G EQU   CVTFLGBT
CVTRSV9F EQU   CVTFLGBT
CVTRSV9E EQU   CVTFLGBT
CVTRSV9D EQU   CVTFLGBT
CVTBAH   EQU   CVTFLGBT
CVTVME   EQU   CVTFLGBT
CVTNPE   EQU   CVTFLGBT
CVTNUCLS EQU   CVTXTNT2+4
CVTDSSVA EQU   CVTDSSV+1
CVTRSV89 EQU   CVTDSSV
CVTRSV88 EQU   CVTXTNT1+8
CVTRSV87 EQU   CVTXTNT1+4
CVTFACHN EQU   CVTXTNT1
CVTRV488 EQU   CVTMAP+412
CVTRV487 EQU   CVTMAP+408
CVTRV486 EQU   CVTMAP+404
CVTRV485 EQU   CVTMAP+400
CVTACTAP EQU   CVTMAP+396
CVTAUTH  EQU   CVTMAP+392
CVTRV490 EQU   CVTMAP+388
CVTSU    EQU   CVTMAP+384
CVTVOLT1 EQU   CVTVOLM1+1
CVTVOLI1 EQU   CVTVOLF1
CVTSTOA  EQU   CVTMAP+376
CVTRSV58 EQU   CVTMAP+374
CVTRSV57 EQU   CVTMAP+372
CVTDDCE  EQU   CVTMAP+368
CVTPNWFR EQU   CVTMAP+364
CVTSMF   EQU   CVTMAP+360
CVTSULK  EQU   CVTMAP+358
CVTSLKO  EQU   CVTSYSK
CVTSLKP  EQU   CVTSYSK
CVTSLKQ  EQU   CVTSYSK
CVTSLKR  EQU   CVTSYSK
CVTRSV56 EQU   CVTSYSK
CVTRSV55 EQU   CVTSYSK
CVTRSV54 EQU   CVTSYSK
CVTRSV53 EQU   CVTSYSK
CVTRSV52 EQU   CVTA1F1
CVTRSV51 EQU   CVTA1F1
CVTRSV50 EQU   CVTA1F1
CVTRSV49 EQU   CVTA1F1
CVTRSV48 EQU   CVTA1F1
CVTRSV47 EQU   CVTA1F1
CVTSRSW  EQU   CVTA1F1
CVTPFSW  EQU   CVTA1F1
CVTPCVT  EQU   CVTMAP+352
CVTRSV46 EQU   CVTMAP+344
CVTRSV45 EQU   CVTMAP+340
CVTRSV44 EQU   CVTMAP+338
CVTRSV43 EQU   CVTMAP+336
CVTHJESA EQU   CVTHJES+1
CVTRSV42 EQU   CVTHJES
CVTEXT2A EQU   CVTEXT2+1
CVTRSV41 EQU   CVTEXT2
CVTAPFA  EQU   CVTAPF+1
CVTRSV40 EQU   CVTAPF
CVTRV518 EQU   CVTINTLA
CVTRV517 EQU   CVTERPV
CVTEORM  EQU   CVTMAP+312
CVTMCHPR EQU   CVTMAP+308
CVTTZ    EQU   CVTMAP+304
CVTJEPS  EQU   CVTMAP+300
CVTJESCT EQU   CVTMAP+296
CVTMODE  EQU   CVTMAP+292
CVTPTRV  EQU   CVTMAP+288
CVTREAL  EQU   CVTMAP+284
CVTRSV39 EQU   CVTMAP+280
CVTRSV38 EQU   CVTMAP+276
CVTDMSRA EQU   CVTDMSR+1
CVTRV634 EQU   CVTDMSRF
CVTRV633 EQU   CVTDMSRF
CVTRV632 EQU   CVTDMSRF
CVTRV631 EQU   CVTDMSRF
CVTRV630 EQU   CVTDMSRF
CVTRV629 EQU   CVTDMSRF
CVTUDUMP EQU   CVTDMSRF
CVTSDUMP EQU   CVTDMSRF
CVTQMSGA EQU   CVTQMSG+1
CVTRSV36 EQU   CVTQMSG
CVTAMFF  EQU   CVTMAP+264
CVTPURGA EQU   CVTPURG+1
CVTRSV35 EQU   CVTPURG
CVTCBSP  EQU   CVTMAP+256
CVTATERA EQU   CVTATER+1
CVTSYST  EQU   CVTATER
CVTVOLT2 EQU   CVTTAT
CVTVOLI2 EQU   CVTVOLF2
CVTAQAVB EQU   CVTAQAVT+1
CVTRSV34 EQU   CVTTCMFG
CVTRSV33 EQU   CVTTCMFG
CVTRSV32 EQU   CVTTCMFG
CVTRSV31 EQU   CVTTCMFG
CVTRSV30 EQU   CVTTCMFG
CVTRSV29 EQU   CVTTCMFG
CVTLDEV  EQU   CVTTCMFG
CVTTCRDY EQU   CVTTCMFG
CVTGTFA  EQU   CVTGTF+1
CVTRSV27 EQU   CVTGTFST
CVTRNIO  EQU   CVTGTFST
CVTUSR   EQU   CVTGTFST
CVTRV318 EQU   CVTFORM
CVTRV317 EQU   CVTTMODE
CVTRV316 EQU   CVTSTATE
CVTRV315 EQU   CVTGTFS
CVTGTFAV EQU   CVTGTFS
CVT0SCR1 EQU   CVTMAP+232
CVTRV515 EQU   CVTMAP+228
CVTRMS   EQU   CVTMAP+224
CVTPATCH EQU   CVTMAP+220
CVTTSCE  EQU   CVTMAP+216
CVTLNKSC EQU   CVTMAP+214
CVTQABST EQU   CVTMAP+212
CVTMDLDS EQU   CVTMAP+208
CVTUSER  EQU   CVTMAP+204
CVTABEND EQU   CVTMAP+200
CVTSMCA  EQU   CVTMAP+196
CVTRSV18 EQU   CVTMAP+192
CVTQLPAQ EQU   CVTMAP+188
CVTQCDSR EQU   CVTMAP+184
CVTVS1B  EQU   CVTOPTB
CVTVS1A  EQU   CVTOPTB
CVTFP    EQU   CVTOPTB
CVTAPTHR EQU   CVTOPTB
CVTNLOG  EQU   CVTOPTB
CVTTOD   EQU   CVTOPTB
CVTCTIMS EQU   CVTOPTB
CVTPROT  EQU   CVTOPTB
CVTXPFP  EQU   CVTOPTA
CVTASCII EQU   CVTOPTA
CVTRSV13 EQU   CVTOPTA
CVTRSV12 EQU   CVTOPTA
CVTNIP   EQU   CVTOPTA
CVTDDR   EQU   CVTOPTA
CVTAPR   EQU   CVTOPTA
CVTCCH   EQU   CVTOPTA
CVTSNCTR EQU   CVTMAP+180
CVTQMWR  EQU   CVTMAP+176
CVTQOCR  EQU   CVTMAP+172
CVT1EF00 EQU   CVTMAP+168
CVTMZ00  EQU   CVTMAP+164
CVTSV76Q EQU   CVTSV76C
CVTRSV11 EQU   CVTMAP+156
CVT0PT01 EQU   CVTMAP+152
CVTMSER  EQU   CVTMAP+148
CVTRV516 EQU   CVTIERLC
CVTILCH  EQU   CVTMAP+140
CVT0DS   EQU   CVTMAP+136
CVTFBOSV EQU   CVTMAP+132
CVTNUCB  EQU   CVTMAP+128
CVTIXAVL EQU   CVTMAP+124
CVTSV76M EQU   CVTIOQET
CVTDCBA  EQU   CVTMAP+117
CVTMVS2  EQU   CVTDCB
CVT6DAT  EQU   CVTDCB
CVT4MPS  EQU   CVTDCB
CVTRSV09 EQU   CVTDCB
CVT4MS1  EQU   CVTDCB
CVT2SPS  EQU   CVTDCB
CVT1SSS  EQU   CVTDCB
CVTRSV08 EQU   CVTDCB
CVTSTB   EQU   CVTMAP+112
CVTQTD00 EQU   CVTMAP+108
CVTQTE00 EQU   CVTMAP+104
CVTCUCB  EQU   CVTMAP+100
CVTSJQ   EQU   CVTMAP+96
CVTPBLDL EQU   CVTMAP+92
CVTTPC   EQU   CVTMAP+88
CVTSVDCB EQU   CVTMAP+84
CVTBRET  EQU   CVTMAP+82
CVTEXIT  EQU   CVTMAP+80
CVT0FN00 EQU   CVTMAP+76
CVTDARA  EQU   CVTDAR+1
CVTRSV07 EQU   CVTFLGS1
CVTRSV06 EQU   CVTFLGS1
CVTRSV05 EQU   CVTFLGS1
CVTRSV04 EQU   CVTFLGS1
CVTRSV03 EQU   CVTFLGS1
CVTRSV02 EQU   CVTFLGS1
CVTRSV01 EQU   CVTFLGS1
CVTDMPLK EQU   CVTFLGS1
CVTXITP  EQU   CVTMAP+68
CVTZDTAB EQU   CVTMAP+64
CVTMSLT  EQU   CVTMAP+60
CVTDATE  EQU   CVTMAP+56
CVTSYSAD EQU   CVTMAP+48
CVTXTLER EQU   CVTMAP+44
CVTILK2  EQU   CVTMAP+40
CVTILK1  EQU   CVTMAP+36
CVTPRLTV EQU   CVTMAP+32
CVTPCNVT EQU   CVTMAP+28
CVT0VL00 EQU   CVTMAP+24
CVTXAPG  EQU   CVTMAP+20
CVTBUF   EQU   CVTMAP+16
CVTJOB   EQU   CVTMAP+12
CVTLINK  EQU   CVTMAP+8
CVT0EF00 EQU   CVTMAP+4
CVTTCBP  EQU   CVTMAP
CVT      EQU   CVTMAP
ADPLABDA EQU   ABDPL+56
ADPLEXT  EQU   ABDPL+52
ADPLCOM4 EQU   ABDPL+40
ADPLCOM3 EQU   ABDPL+36
@NM00001 EQU   ADPLFLAG
ADPLDMGT EQU   ADPLFLAG
ADPLSYTM EQU   ADPLFLAG
ADPLSBPL EQU   ABDPL+6
ADPLASID EQU   ABDPL+4
ADPLTCB  EQU   ABDPL
.@UNREFD ANOP                          END UNREFERENCED COMPONENTS
@RC00134 EQU   @RC00130
@RC00140 EQU   @RC00130
@RC00303 EQU   @RC00282
@RC00427 EQU   @EL00005
@RC00434 EQU   @EL00005
@RC00432 EQU   @EL00005
@RC00144 EQU   @RC00140
@RC00312 EQU   @RC00303
@RC00316 EQU   @RC00312
@ENDDATA EQU   *
         END   IEAFTIHS,(C'PLS1846',0701,78033)
