*/******************************************************************/
*/*                                                                */
*/*                         I E A P N P B                          */
*/*                     DATE=05/11/72,LEVEL=1                      */
*/*                                                                */
*/*   THIS BSL MACRO PROVIDES EXPANSIONS OF CONTROL BLOCKS         */
*/*   (IOB,ECB,DEB,DCB) INITIALIZED FOR I/O FOR DIRECT ACCESS      */
*/*   AND TAPE DATA SETS, INPUT OR OUTPUT CONSOLES OR FOR          */
*/*   CONSOLE TESTING.                                             */
*/*                                                                */
*/******************************************************************/
*
*
*     %IF  DASD ^= 'YES'
*       %THEN
*         %GOTO NPBNUC ;
*/******************************************************************/
*/*                                                                */
*/*              BLOCKS  FOR  DIRECT ACCESS I/O                    */
*/*                                                                */
*/******************************************************************/
*/*                                                                */
*/**                                                              **/
*/*               INPUT/OUTPUT  BLOCK   (IOB)                      */
*/**                                                              **/
*       DECLARE  1 * ,
*                  2 NPBNIOBF  CHAR(4) ,    /* IOB PREFIX BYTES    */
*                    /* BYTE 0 - MAX RETRY                         */
*                    3 NPBNIFB0  PTR(8) INIT(0) ,
*                    3 NPBNIFB1  CHAR(1) INIT('00'X) , /* BYTE 1 : */
*                      4 NIPDSTAT  BIT(1) , /*   DEVICE STATUS     */
*                      4 NIPDFEST  BIT(1) , /*   FEATURE TEST      */
*                      4 NIPDRTY   BIT(1) , /*   RETRY OPTION      */
*                      4 NIPDERR   BIT(1) , /*   REPORT ERROR      */
*                      4 NIPDMOD   BIT(1) , /*   TAPE MODE REQUIRED*/
*                      4 *         BIT(3) , /*   RESERVED          */
*                    3 NPBNIFB2  CHAR(1) INIT('00'X) , /* BYTE 2   */
*                    3 NPBNIFB3  CHAR(1) INIT('00'X) , /* BYTE 3 : */
*                      4 NIPDUNAV  BIT(1) , /*   UNAVAILABLE       */
*                      4 NIPDCREJ  BIT(1) , /*   COMMAND REJECT    */
*                      4 NIPDOFFL  BIT(1) , /*   OFF-LINE          */
*                      4 *         BIT(5) , /*   RESERVED          */
*                  2 NIPIOBSN ,
*                    3  NPBNIOB ,
*                      /* FLAG AND SENSE BYTES                     */
*                      4 NPBNFGSN  CHAR(4) INIT('42000000'X) ,
*                      /* IOBECBPT - ECB ADDRESS                   */
*                      4 NPBNECBA  PTR(31) INIT(ADDR(NPBNECB)) ,
*                      /* FLAGS AND CSW IMAGE                      */
*                      4 NPBNIOB1  CHAR(8) INIT('0000000000000000'X) ,
*                      /* IOBSTART - CHANNEL PROGRAM ADDRESS       */
*                      4 NPBNCPAD  PTR(31) INIT(0) ,
*                      /* IOBDCBPT - DCB ADDRESS                   */
*                      4 NPBNDCBP  PTR(31) INIT(ADDR(NPBNDCB1)-40) ,
*                      /*     REST OF IOB COMMON                   */
*                      4 NPBNREST  CHAR(8) INIT('0000000000000000'X) ,
*
*/**                     DASD  EXTENSION                          **/
*
*                      /* IOBSEEK - MBBCCHHR                       */
*                      4 NPBNSEEK  CHAR(8) INIT('0000000000000000'X) ;
*/**                                                              **/
*/*               EVENT  CONTROL  BLOCK   (ECB)                    */
*/**                                                              **/
*     DECLARE 1  NIPECBSN ,
*             2  NPBNECB ,
*               /* EVENT COMPLETION CODE                           */
*               3 NPBNCPCD  CHAR(1) INIT('00'X),
*               /* RB ADDR OR REST OF COMPLETION CODE              */
*               3 NPBNRBAD  PTR(24) INIT(0) ;
*     %GOTO NPBNDEBN ;
*%NPBNUC: ;
*     %IF  NUCLEUS ^= 'YES'
*       %THEN
*         %GOTO NPBNUCX ;
*/******************************************************************/
*/*                                                                */
*/*                   BLOCKS  FOR  SYS1.NUCLEUS                    */
*/*                                                                */
*/******************************************************************/
*/*                                                                */
*%NPBNDEBN: ;
*/**                                                              **/
*/*               DATA  EXTENT  BLOCK   (DEB)                      */
*/**                                                              **/
*/*                                                                */
*/**                    DEB  PREFIX                               **/
*
*     DECLARE 1  * BDY(DWORD,5) ,
*             /* DEBLNGTH - DEB LENGTH                             */
*             2  NPBNLNTH  CHAR(1) INIT('06'X) ,
*             2  NPBNRSVD  PTR(24) INIT(0) , /* RESERVED           */
*
*/**               DEB  BASIC  SECTION                            **/
*
*             2  NIPDEBSN ,
*               3  NPBNDEB ,
*                 /* TCB ADDR - UNUSED                             */
*                 4 NPBNDEB1  PTR(31) INIT(0) ,
*                 /* DEBAMLNG - ACSECT LENGTH                      */
*                 4 NPBNAMLN  CHAR(1) INIT('00'X) ,
*                 4 NPBNDEB2  PTR(24) INIT(0) , /* 3 BYTES - UNUSED*/
*                 /* DEBOFLGS - DATA SET STATUS                    */
*                 4 NPBNOFLG  CHAR(1) INIT('00'X) BDY(WORD) ,
*                 /* FLAGS,ETC - UNUSED                            */
*                 4 NPBNDEB3  CHAR(7) INIT('00000000000000'X) ,
*                 /* DEBNMEXT - NO. OF EXTENTS                     */
*                 4 NPBNNMXT  CHAR(1) INIT('01'X) ,
*                 /* IOB ADDRESS - UNUSED                          */
*                 4 NPBNDEB4  PTR(24) INIT(0) ,
*                 /* DEBPRIOR -TASK PRIORITY                       */
*                 4 NPBNPRTY  CHAR(1) INIT('00'X) ,
*                 /* ECB ADDRESS - UNUSED                          */
*                 4 NPBNDEB5  PTR(24) INIT(0) ,
*                 /* DEBPROTG,DEBDEBID                             */
*                 4 NPBNKYID  CHAR(1) INIT('0F'X) ,
*                 /* DEBDCBAD - DCB ADDRESS                        */
*                 4 NPBNDCBA  PTR(24) INIT(ADDR(NPBNDCB1)-40) ,
*                 /* DEBEXSCL - EXTENT SCALE                       */
*                 4 NPBNXSCL  CHAR(1) INIT('00'X) ,
*                 /* DEBAPPAD - APPENDAGE ADDRESS                  */
*                 4 NPBNAPAD  PTR(24) INIT(0) ,
*
*/**            DIRECT - ACCESS STORAGE DEVICE SECTION            **/
*
*                 /* DEBDVMOD - FILE MASK                          */
*                 4 NPBNDVMD  CHAR(1) INIT('18'X) ,
*                 /* DEBUCBAD - UCB ADDRESS                        */
*                 4 NPBNUCBA  PTR(24) INIT(0) ,
*                 /* DEBBINUM - BIN NUMBER                         */
*                 4 NPBNBINM  CHAR(2) INIT('0000'X) ,
*                 /* DEBSTRCC - START CYLINDER                     */
*                 4 NPBNSTCC  CHAR(2) INIT('0000'X) ,
*                 /* DEBSTRHH - START TRACK                        */
*                 4 NPBNSTHH  CHAR(2) INIT('0000'X) ,
*                 /* DEBENDCC - END CYLINDER                       */
*                 4 NPBNNDCC  CHAR(2) INIT('FFFF'X) ,
*                 /* DEBENDHH - END TRACK                          */
*                 4 NPBNNDHH  CHAR(2) INIT('FFFF'X) ,
*                 /* DEBNMTRK - NUMBER OF TRACKS                   */
*                 4 NPBNNTRK FIXED(15) INIT('7FFF'X) ,
*/**                                                              **/
*/*                DATA  CONTROL  BLOCK   (DCB)                    */
*/**                                                              **/
*                 4 NPBNDCB1 ,
*                   /* DCBMACRF - MACRO TYPE                       */
*                   5 NPBNMACR  CHAR(4) INIT('00008000'X) BDY(WORD) ,
*                   /* DCBIFLGS - FLAGS FOR IOS                    */
*                   5 NPBNIFGS  CHAR(1) INIT('00'X) ,
*                   /* DCBDEBAD - DEB ADDRESS                      */
*                   5 NPBNDEBA  PTR(24) INIT(ADDR(NPBNDEB)) ,
*                   /* DCBOFLGS - FLAGS FOR OPEN                   */
*                   5 NPBNOFGS  CHAR(4) INIT('12000000'X) ;
*
*/*              DATA CONTROL BLOCK BASE                           */
*     DECLARE 1  NIPDCBSN DEFINED(NPBNOFLG) ,
*               2  NPBNDCB ;
*
*%NPBNUCX: ;
*     %IF  NPBIOB ^= 'YES'
*       %THEN
*         %GOTO NPBIOBX ;
*/******************************************************************/
*/*                                                                */
*/*              NIP  CONTROL  BLOCKS  FOR  I/O                    */
*/*                                                                */
*/******************************************************************/
*/*                                                                */
*/**                                                              **/
*/*               INPUT/OUTPUT  BLOCK   (IOB)                      */
*/**                                                              **/
*       DECLARE  1 * ,
*                  2 NPBNIOBF  CHAR(4) ,    /* IOB PREFIX BYTES    */
*                    /* BYTE 0 - MAX RETRY                         */
*                    3 NPBNIFB0  PTR(8) INIT(0) ,
*                    3 NPBNIFB1  CHAR(1) INIT('00'X) , /* BYTE 1 : */
*                      4 NIPDSTAT  BIT(1) , /*   DEVICE STATUS     */
*                      4 NIPDFEST  BIT(1) , /*   FEATURE TEST      */
*                      4 NIPDRTY   BIT(1) , /*   RETRY OPTION      */
*                      4 NIPDERR   BIT(1) , /*   REPORT ERRORS     */
*                      4 NIPDMOD   BIT(1) , /*   TAPE MODE REQUIRED*/
*                      4 *         BIT(3) , /*   RESERVED          */
*                    3 NPBNIFB2  CHAR(1) INIT('00'X) , /* BYTE 2   */
*                    3 NPBNIFB3  CHAR(1) INIT('00'X) , /* BYTE 3 : */
*                      4 NIPDUNAV  BIT(1) , /*   UNAVAILABLE       */
*                      4 NIPDCREJ  BIT(1) , /*   COMMAND REJECT    */
*                      4 NIPDOFFL  BIT(1) , /*   OFF-LINE          */
*                      4 *         BIT(5) , /*   RESERVED          */
*                  2 NIPIOBSN ,
*                    3  NPBNIOB ,
*                      /* FLAG AND SENSE BYTES                     */
*                      4 NPBNFGSN  CHAR(4) INIT('42000000'X) ,
*                      /* IOBECBPT - ECB ADDRESS                   */
* % IF NPBECB ^= 'YES'
*   % THEN
*     %  GOTO NPBECBNA ;
*                      4 NPBNECBA  PTR(31) INIT(ADDR(NPBNECB)) ,
* % GOTO NPBECBYA ;
* %NPBECBNA:;
*                      4 NPBNECBA  PTR(31) INIT(0) ,
* %NPBECBYA:;
*                      /* FLAGS AND CSW IMAGE                      */
*                      4 NPBNIOB1  CHAR(8) INIT('0000000000000000'X) ,
*                      /* IOBSTART - CHANNEL PROGRAM ADDRESS       */
*                      4 NPBNCPAD  PTR(31) INIT(0) ,
*                      /* IOBDCBPT - DCB ADDRESS                   */
* % IF NPBDCB ^= 'YES'
*   % THEN
*     % GOTO NPBDCBNA ;
*                      4 NPBNDCBP  PTR(31) INIT(ADDR(NPBNDCB1)-40) ,
* %GOTO NPBDCBYA ;
* %NPBDCBNA:;
*                      4 NPBNDCBP  PTR(31) INIT(0) ,
* %NPBDCBYA:;
*                      /*    REST OF IOB COMMON                    */
*                      4 NPBNREST  CHAR(8) INIT('0000000000000000'X) ,
*
*/**                       DASD  EXTENSION                        **/
*
*                      /* IOBSEEK - MBBCCHHR                       */
*                      4 NPBNSEEK  CHAR(8) INIT('0000000000000000'X) ;
* %NPBIOBX:;
* % IF NPBECB ^= 'YES'
*   % THEN
*     % GOTO NPBECBX ;
*/**                                                              **/
*/*               EVENT  CONTROL  BLOCK   (ECB)                    */
*/**                                                              **/
*     DECLARE 1  NIPECBSN ,
*             2  NPBNECB ,
*               /* EVENT COMPLETION CODE                           */
*               3 NPBNCPCD  CHAR(1) INIT('00'X),
*               /* RB ADDRESS OR REST OF COMPLETION CODE           */
*               3 NPBNRBAD  PTR(24) INIT(0) ;
* %NPBECBX:;
* % IF NPBDEB ^= 'YES'
*   % THEN
*     % GOTO NPBDEBX ;
*/**                                                              **/
*/*               DATA  EXTENT  BLOCK   (DEB)                      */
*/**                                                              **/
*/*                                                                */
*/**                    DEB  PREFIX                               **/
*
*     DECLARE 1  * BDY(DWORD,5) ,
*              /* DEBLNGTH - DEB LENGTH                            */
*              2 NPBNLNTH  CHAR(1) INIT('06'X) ,
*              2 NPBNRSVD  PTR(24) INIT(0) , /* RESERVED           */
*
*/**               DEB  BASIC  SECTION                            **/
*
*              2 NIPDEBSN ,
*               3  NPBNDEB ,
*                 /* TCB ADDRESS - UNINITIALIZED                   */
*                 4 NPBNDEB1  PTR(31) INIT(0) ,
*                 /* DEBAMLNG - ACCESS METHOD SECTION LENGTH       */
*                 4 NPBNAMLN  CHAR(1) INIT('00'X) ,
*                 4 NPBNDEB2  PTR(24) INIT(0) , /* 3 BYTES - UNUSED*/
*                 /* DEBOFLGS - DATA SET STATUS                    */
*                 4 NPBNOFLG  CHAR(1) INIT('00'X) BDY(WORD) ,
*                 /* FLAGS,ETC - UNINITIALIZED                     */
*                 4 NPBNDEB3  CHAR(7) INIT('00000000000000'X) ,
*                 /* DEBNMEXT - NUMBER OF EXTENTS                  */
*                 4 NPBNNMXT  CHAR(1) INIT('01'X) ,
*                 /* IOB ADDRESS - UNINITIALIZED                   */
*                 4 NPBNDEB4  PTR(24) INIT(0) ,
*                 /* DEBPRIOR - TASK PRIORITY                      */
*                 4 NPBNPRTY  CHAR(1) INIT('00'X) ,
*                 /* AN ECB ADDRESS - UNINITIALIZED                */
*                 4 NPBNDEB5  PTR(24) INIT(0) ,
*                 /* DEBPROTG,DEBDEBID                             */
*                 4 NPBNKYID  CHAR(1) INIT('0F'X) ,
*                 /* DEBDCBAD - DCB ADDRESS                        */
* % IF NPBDCB ^= 'YES'
*   % THEN
*     % GOTO NPBDCBN1 ;
*                 4 NPBNDCBA  PTR(24) INIT(ADDR(NPBNDCB1)-40) ,
* % GOTO NPBDCBY1 ;
* %NPBDCBN1:;
*                 4 NPBNDCBA  PTR(24) INIT(0) ,
* %NPBDCBY1:;
*                 /* DEBEXSCL - EXTENT SCALE                       */
*                 4 NPBNXSCL  CHAR(1) INIT('00'X) ,
*                 /* DEBAPPAD - APPENDAGE ADDRESS                  */
*                 4 NPBNAPAD  PTR(24) INIT(0) ,
*
*/**            DIRECT - ACCESS STORAGE DEVICE SECTION            **/
*
* % IF DEB16 ^= 'YES'
*   % THEN
*     % GOTO NPBDEB1 ;
*                 /* 16 DASD EXTENTS                               */
*                 4 *    (64) FIXED(31) INIT((64)0) ;
*% GOTO NPBDEBX ;
*%NPBDEB1: ;
*                 /* DEBDVMOD - FILE MASK                          */
*                 4 NPBNDVMD  CHAR(1) INIT('18'X) ,
*                 /* DEBUCBAD - UCB ADDRESS                        */
*                 4 NPBNUCBA  PTR(24) INIT(0) ,
*                 /* DEBBINUM - BIN NUMBER                         */
*                 4 NPBNBINM  CHAR(2) INIT('0000'X) ,
*                 /* DEBSTRCC - START CYL                          */
*                 4 NPBNSTCC  CHAR(2) INIT('0000'X) ,
*                 /* DEBSTRHH - START TRACK                        */
*                 4 NPBNSTHH  CHAR(2) INIT('0000'X) ,
*                 /* DEBENDCC - END CYL                            */
*                 4 NPBNNDCC  CHAR(2) INIT('FFFF'X) ,
*                 /* DEBENDHH - END TRACK                          */
*                 4 NPBNNDHH  CHAR(2) INIT('FFFF'X) ,
*                 /* DEBNMTRK - NUMBER OF TRACKS                   */
*                 4 NPBNNTRK FIXED(15) INIT('7FFF'X) ;
* %NPBDEBX:;
* % IF NPBDCB ^= 'YES'
*   % THEN
*     % GOTO NPBDCBX ;
*/**                                                              **/
*/*                DATA  CONTROL  BLOCK   (DCB)                    */
*/**                                                              **/
*     DECLARE 1 * ,
*               2 NPBNDCB1 ,
*                 /* DCBMACRF - MACRO TYPE                         */
*                 4 NPBNMACR  CHAR(4) INIT('00008000'X) BDY(WORD) ,
*                 /* DCBIFLGS - FLAGS FOR IOS                      */
*                 4 NPBNIFGS  CHAR(1) INIT('00'X) ,
*                 /* DCBDEBAD - DEB ADDRESS                        */
* % IF NPBDEB ^= 'YES'
*   % THEN
*     % GOTO NPBDEBNA ;
*                 4 NPBNDEBA  PTR(24) INIT(ADDR(NPBNDEB)) ,
* % GOTO NPBDEBYA ;
* %NPBDEBNA:;
*                 4 NPBNDEBA  PTR(24) INIT(0) ,
* %NPBDEBYA:;
*                 /* DCBOFLGS - FLAGS FOR OPEN                     */
*                 4 NPBNOFGS  CHAR(4) INIT('12000000'X) ;
*
*/*                     DATA CONTROL BLOCK BASE                    */
*     DECLARE 1  NIPDCBSN BASED(ADDR(NPBNMACR) - 40) ,
*             2  NPBNDCB ;
*
*%NPBDCBX: ;
*     %IF  INC ^= 'YES'
*       %THEN
*         %GOTO NPBOUTC ;
*/******************************************************************/
*/*                                                                */
*/*               BLOCKS  FOR  INPUT  CONSOLE                      */
*/*                                                                */
*/******************************************************************/
*/*                                                                */
*/**                                                              **/
*/*               INPUT/OUTPUT  BLOCK   (IOB)                      */
*/**                                                              **/
*       DECLARE  1 * ,
*                  2 NPBIIOBF  CHAR(4) ,
*                    3 NPBIRSV1  CHAR(2) INIT('0000'X) ,
*                                       /* RESERVED BYTES          */
*                    3 NPBIIFB1  CHAR(1) INIT('00'X) ,
*                                       /* IOB PREFIX FLAG BYTE 1  */
*                    3 NPBIIFB2  CHAR(1) INIT('00'X) ,
*                                       /* IOB PREFIX FLAG BYTE 2  */
*                  2 NIPIOBIC ,
*                    3  NPBIIOB ,
*                      4 NPBIFGSN  CHAR(4) INIT('42000000'X) ,
*                                       /* FLAG AND SENSE BYTES    */
*                      4 NPBIECBA  PTR(31) INIT(ADDR(NPBIECB)) ,
*                                       /* IOBECBPT - ECB ADDRESS  */
*                      4 NPBIIOB1  CHAR(8) INIT('0000000000000000'X) ,
*                                       /* FLAGS AND CSW IMAGE     */
*                      4 NPBICPAD  PTR(31) INIT(0) ,
*                                       /* IOBSTART -CHAN PROG ADDR*/
*                      4 NPBIDCBP  PTR(31) INIT(ADDR(NPBIDCB1)-40) ,
*                                       /* IOBDCBPT - DCB ADDRESS  */
*                      4 NPBIREST  CHAR(8) INIT('0000000000000000'X) ;
*/**                                                              **/
*/*               EVENT  CONTROL  BLOCK   (ECB)                    */
*/**                                                              **/
*     DECLARE 1  NIPECBIC ,
*             2  NPBIECB ,
*               3 NPBICPCD  CHAR(1) INIT('00'X),
*                                       /* EVENT COMPLETION CODE   */
*               3 NPBIRBAD  PTR(24) INIT(0) ;
*                                       /* RB ADDR OR REST OF C.C. */
*/**                                                              **/
*/*               DATA  EXTENT  BLOCK   (DEB)                      */
*/**                                                              **/
*/*                                                                */
*/**                    DEB  PREFIX                               **/
*     DECLARE 1  * BDY(DWORD,5) ,
*             2  NPBILNTH  CHAR(1) INIT('06'X) BDY(WORD) ,
*                                       /* DEBLNGTH - DEB LENGTH   */
*             2  NPBIRSVD  PTR(24) INIT(0) ,
*                                       /* RESERVED                */
*/**               DEB  BASIC  SECTION                            **/
*             2  NIPDEBIC ,
*               3  NPBIDEB ,
*                 4 NPBIDEB1  PTR(31) INIT(0) ,
*                                       /* TCB ADDR - UNUSED       */
*                 4 NPBIAMLN  CHAR(1) INIT('00'X) ,
*                                       /* DEBAMLNG - ACSECT LENGTH*/
*                 4 NPBIDEB2  PTR(24) INIT(0) ,
*                 4 NPBIOFLG  CHAR(1) INIT('00'X) ,
*                                       /* DEBOFLGS - D.S. STATUS  */
*                 4 NPBIDEB3  CHAR(7) INIT('00000000000000'X) ,
*                                       /* FLAGS,ETC - UNUSED      */
*                 4 NPBINMXT  CHAR(1) INIT('00'X) ,
*                                       /* DEBNMEXT -NO.OF EXTENTS */
*                 4 NPBIDEB4  PTR(24) INIT(0) ,
*                                       /* IOB ADDRESS - UNUSED    */
*                 4 NPBIPRTY  CHAR(1) INIT('00'X) ,
*                                       /* DEBPRIOR -TASK PRIORITY */
*                 4 NPBIDEB5  PTR(24) INIT(0) ,
*                                       /* AN ECB ADDR - UNUSED    */
*                 4 NPBIKYID  CHAR(1) INIT('0F'X) ,
*                                       /* DEBPROTG,DEBDEBID       */
*                 4 NPBIDCBA  PTR(24) INIT(ADDR(NPBIDCB1)-40) ,
*                                       /* DEBDCBAD - DCB ADDRESS  */
*                 4 NPBIXSCL  CHAR(1) INIT('00'X) ,
*                                       /* DEBEXSCL - EXTENT SCALE */
*                 4 NPBIAPAD  PTR(24) INIT(0) ,
*                                       /* DEBAPPAD -APPENDAGE ADDR*/
*/**                  UNIT RECORD DEVICE SECTION                  **/
*                 4 NPBIDVMD  CHAR(1) INIT('00'X) ,
*                                       /* DEBDVMOD - FILE MASK    */
*                 4 NPBIUCBA  PTR(24) INIT(0) ,
*                                       /* DEBUCBAD - UCB ADDRESS  */
*/**                                                              **/
*/*                DATA  CONTROL  BLOCK   (DCB)                    */
*/**                                                              **/
*                 4 NPBIDCB1 ,
*                   5 NPBIMACR  CHAR(4) INIT('00008000'X) ,
*                                       /* DCBMACRF - MACRO TYPE   */
*                   5 NPBIIFGS  CHAR(1) INIT('0C'X) ,
*                                       /* DCBIFLGS - FOR IOS      */
*                   5 NPBIDEBA  PTR(24) INIT(ADDR(NPBIDEB)) ,
*                                       /* DCBDEBAD - DEB ADDRESS  */
*                   5 NPBIOFGS  CHAR(4) INIT('12000000'X) ;
*                                       /* DCBOFLGS - FOR OPEN     */
*     DECLARE 1  NIPDCBIC DEFINED(NPBILNTH) ,
*             2  NPBIDCB ;
*
*%NPBOUTC: ;
*     %IF  OUTC ^= 'YES'
*       %THEN
*         %GOTO NPBTSTC ;
*/******************************************************************/
*/*                                                                */
*/*               BLOCKS  FOR  OUTPUT  CONSOLE                     */
*/*                                                                */
*/******************************************************************/
*/*                                                                */
*/**                                                              **/
*/*               INPUT/OUTPUT  BLOCK   (IOB)                      */
*/**                                                              **/
*       DECLARE  1 * ,
*                  2 NPBOIOBF  CHAR(4) ,
*                    3 NPBORSV1  CHAR(2) INIT('0000'X) ,
*                                       /* RESERVED BYTES          */
*                    3 NPBOIFB1  CHAR(1) INIT('00'X) ,
*                                       /* IOB PREFIX FLAG BYTE 1  */
*                    3 NPBOIFB2  CHAR(1) INIT('00'X) ,
*                                       /* IOB PREFIX FLAG BYTE 2  */
*                  2 NIPIOBOC ,
*                    3  NPBOIOB ,
*                      4 NPBOFGSN  CHAR(4) INIT('42000000'X) ,
*                                       /* FLAG AND SENSE BYTES    */
*                      4 NPBOECBA  PTR(31) INIT(ADDR(NPBOECB)) ,
*                                       /* IOBECBPT - ECB ADDRESS  */
*                      4 NPBOIOB1  CHAR(8) INIT('0000000000000000'X) ,
*                                       /* FLAGS AND CSW IMAGE     */
*                      4 NPBOCPAD  PTR(31) INIT(0) ,
*                                       /* IOBSTART -CHAN PROG ADDR*/
*                      4 NPBODCBP  PTR(31) INIT(ADDR(NPBODCB1)-40) ,
*                                       /* IOBDCBPT - DCB ADDRESS  */
*                      4 NPBOREST  CHAR(8) INIT('0000000000000000'X) ;
*/**                                                              **/
*/*               EVENT  CONTROL  BLOCK   (ECB)                    */
*/**                                                              **/
*     DECLARE 1  NIPECBOC ,
*             2  NPBOECB ,
*               3 NPBOCPCD  CHAR(1) INIT('00'X),
*                                       /* EVENT COMPLETION CODE   */
*               3 NPBORBAD  PTR(24) INIT(0) ;
*                                       /* RB ADDR OR REST OF C.C. */
*/**                                                              **/
*/*               DATA  EXTENT  BLOCK   (DEB)                      */
*/**                                                              **/
*/*                                                                */
*/**                    DEB  PREFIX                               **/
*     DECLARE 1  * BDY(DWORD,5) ,
*             2  NPBOLNTH  CHAR(1) INIT('06'X) BDY(WORD) ,
*                                       /* DEBLNGTH - DEB LENGTH   */
*             2  NPBORSVD  PTR(24) INIT(0) ,
*                                       /* RESERVED                */
*/**               DEB  BASIC  SECTION                            **/
*             2  NIPDEBOC ,
*               3  NPBODEB ,
*                 4 NPBODEB1  PTR(31) INIT(0) ,
*                                       /* TCB ADDR - UNUSED       */
*                 4 NPBOAMLN  CHAR(1) INIT('00'X) ,
*                                       /* DEBAMLNG - ACSECT LENGTH*/
*                 4 NPBODEB2  PTR(24) INIT(0) ,
*                 4 NPBOOFLG  CHAR(1) INIT('00'X) ,
*                                       /* DEBOFLGS - D.S. STATUS  */
*                 4 NPBODEB3  CHAR(7) INIT('00000000000000'X) ,
*                                       /* FLAGS,ETC - UNUSED      */
*                 4 NPBONMXT  CHAR(1) INIT('00'X) ,
*                                       /* DEBNMEXT -NO.OF EXTENTS */
*                 4 NPBODEB4  PTR(24) INIT(0) ,
*                                       /* IOB ADDRESS - UNUSED    */
*                 4 NPBOPRTY  CHAR(1) INIT('00'X) ,
*                                       /* DEBPRIOR -TASK PRIORITY */
*                 4 NPBODEB5  PTR(24) INIT(0) ,
*                                       /* AN ECB ADDR - UNUSED    */
*                 4 NPBOKYID  CHAR(1) INIT('0F'X) ,
*                                       /* DEBPROTG,DEBDEBID       */
*                 4 NPBODCBA  PTR(24) INIT(ADDR(NPBODCB1)-40) ,
*                                       /* DEBDCBAD - DCB ADDRESS  */
*                 4 NPBOXSCL  CHAR(1) INIT('00'X) ,
*                                       /* DEBEXSCL - EXTENT SCALE */
*                 4 NPBOAPAD  PTR(24) INIT(0) ,
*                                       /* DEBAPPAD -APPENDAGE ADDR*/
*/**                  UNIT RECORD DEVICE SECTION                  **/
*                 4 NPBODVMD  CHAR(1) INIT('00'X) ,
*                                       /* DEBDVMOD - FILE MASK    */
*                 4 NPBOUCBA  PTR(24) INIT(0) ,
*                                       /* DEBUCBAD - UCB ADDRESS  */
*/**                                                              **/
*/*                DATA  CONTROL  BLOCK   (DCB)                    */
*/**                                                              **/
*                 4 NPBODCB1 ,
*                   5 NPBOMACR  CHAR(4) INIT('00008000'X) ,
*                                       /* DCBMACRF - MACRO TYPE   */
*                   5 NPBOIFGS  CHAR(1) INIT('0C'X) ,
*                                       /* DCBIFLGS - FOR IOS      */
*                   5 NPBODEBA  PTR(24) INIT(ADDR(NPBODEB)) ,
*                                       /* DCBDEBAD - DEB ADDRESS  */
*                   5 NPBOOFGS  CHAR(4) INIT('12000000'X) ;
*                                       /* DCBOFLGS - FOR OPEN     */
*     DECLARE 1  NIPDCBOC DEFINED(NPBOLNTH) ,
*             2  NPBODCB ;
*
*%NPBTSTC: ;
*     %IF  TESTC ^= 'YES'
*       %THEN
*         %GOTO NPBEND ;
*/******************************************************************/
*/*                                                                */
*/*               BLOCKS  FOR  CONSOLE  TESTING                    */
*/*                                                                */
*/******************************************************************/
*/*                                                                */
*/**                                                              **/
*/*               INPUT/OUTPUT  BLOCK   (IOB)                      */
*/**                                                              **/
*       DECLARE  1 * ,
*                  2 NIPIOBTC ,
*                    3  NPBTIOB ,
*                      4 NPBTFGSN  CHAR(4) INIT('42000000'X) ,
*                                       /* FLAG AND SENSE BYTES    */
*                      4 NPBTECBA  PTR(31) INIT(ADDR(NPBTECB)) ,
*                                       /* IOBECBPT - ECB ADDRESS  */
*                      4 NPBTIOB1  CHAR(8) INIT('0000000000000000'X) ,
*                                       /* FLAGS AND CSW IMAGE     */
*                      4 NPBTCPAD  PTR(31) INIT(0) ,
*                                       /* IOBSTART -CHAN PROG ADDR*/
*                      4 NPBTDCBP  PTR(31) INIT(ADDR(NPBTDCB1)-40) ,
*                                       /* IOBDCBPT - DCB ADDRESS  */
*                      4 NPBTREST  CHAR(8) INIT('0000000000000000'X) ;
*/**                                                              **/
*/*               EVENT  CONTROL  BLOCK   (ECB)                    */
*/**                                                              **/
*     DECLARE 1  NIPECBTC ,
*             2  NPBTECB ,
*               3 NPBTCPCD  CHAR(1) INIT('00'X),
*                                       /* EVENT COMPLETION CODE   */
*               3 NPBTRBAD  PTR(24) INIT(0) ;
*                                       /* RB ADDR OR REST OF C.C. */
*/**                                                              **/
*/*               DATA  EXTENT  BLOCK   (DEB)                      */
*/**                                                              **/
*/*                                                                */
*/**                    DEB  PREFIX                               **/
*     DECLARE 1  * BDY(DWORD,5) ,
*             2  NPBTLNTH  CHAR(1) INIT('06'X) BDY(WORD) ,
*                                       /* DEBLNGTH - DEB LENGTH   */
*             2  NPBTRSVD  PTR(24) INIT(0) ,
*                                       /* RESERVED                */
*/**               DEB  BASIC  SECTION                            **/
*             2  NIPDEBTC ,
*               3  NPBTDEB ,
*                 4 NPBTDEB1  PTR(31) INIT(0) ,
*                                       /* TCB ADDR - UNUSED       */
*                 4 NPBTAMLN  CHAR(1) INIT('00'X) ,
*                                       /* DEBAMLNG - ACSECT LENGTH*/
*                 4 NPBTDEB2  PTR(24) INIT(0) ,
*                 4 NPBTOFLG  CHAR(1) INIT('00'X) ,
*                                       /* DEBOFLGS - D.S. STATUS  */
*                 4 NPBTDEB3  CHAR(7) INIT('00000000000000'X) ,
*                                       /* FLAGS,ETC - UNUSED      */
*                 4 NPBTNMXT  CHAR(1) INIT('00'X) ,
*                                       /* DEBNMEXT -NO.OF EXTENTS */
*                 4 NPBTDEB4  PTR(24) INIT(0) ,
*                                       /* IOB ADDRESS - UNUSED    */
*                 4 NPBTPRTY  CHAR(1) INIT('00'X) ,
*                                       /* DEBPRIOR -TASK PRIORITY */
*                 4 NPBTDEB5  PTR(24) INIT(0) ,
*                                       /* AN ECB ADDR - UNUSED    */
*                 4 NPBTKYID  CHAR(1) INIT('0F'X) ,
*                                       /* DEBPROTG,DEBDEBID       */
*                 4 NPBTDCBA  PTR(24) INIT(ADDR(NPBTDCB1)-40) ,
*                                       /* DEBDCBAD - DCB ADDRESS  */
*                 4 NPBTXSCL  CHAR(1) INIT('00'X) ,
*                                       /* DEBEXSCL - EXTENT SCALE */
*                 4 NPBTAPAD  PTR(24) INIT(0) ,
*                                       /* DEBAPPAD -APPENDAGE ADDR*/
*/**                  UNIT RECORD DEVICE SECTION                  **/
*                 4 NPBTDVMD  CHAR(1) INIT('00'X) ,
*                                       /* DEBDVMOD - FILE MASK    */
*                 4 NPBTUCBA  PTR(24) INIT(0) ,
*                                       /* DEBUCBAD - UCB ADDRESS  */
*/**                                                              **/
*/*                DATA  CONTROL  BLOCK   (DCB)                    */
*/**                                                              **/
*                 4 NPBTDCB1 ,
*                   5 NPBTMACR  CHAR(4) INIT('00008000'X) ,
*                                       /* DCBMACRF - MACRO TYPE   */
*                   5 NPBTIFGS  CHAR(1) INIT('0C'X) ,
*                                       /* DCBIFLGS - FOR IOS      */
*                   5 NPBTDEBA  PTR(24) INIT(ADDR(NPBTDEB)) ,
*                                       /* DCBDEBAD - DEB ADDRESS  */
*                   5 NPBTOFGS  CHAR(4) INIT('12000000'X) ;
*                                       /* DCBOFLGS - FOR OPEN     */
*     DECLARE 1  NIPDCBTC DEFINED(NPBTLNTH) ,
*             2  NPBTDCB ;
*
*%NPBEND: ;
