         TITLE 'IEAVAD05 - CONTROL BLOCKS II                           *
                        '
IEAVAD05 CSECT ,                                                   0001
@MAINENT DS    0H                                                  0001
         USING *,@15                                               0001
         B     @PROLOG                                             0001
         DC    AL1(16)                                             0001
         DC    C'IEAVAD05  77.049'                                 0001
         DROP  @15
@PROLOG  ST    @14,12(,@13)                                        0001
         STM   @00,@12,20(@13)                                     0001
         BALR  @11,0                                               0001
@PSTART  DS    0H                                                  0001
         USING @PSTART,@11                                         0001
*                                                                  0080
*   /*****************************************************************/
*   /*                                                               */
*   /* INITIALIZATION ON ENTRY FIRST THE ADDRESSING REGISTERS ARE    */
*   /* INITIALIZED, THEN A SAVE AREA FOR THE REGISTER SAVE AREA AND  */
*   /* AUTOMATIC DATA AREA IS OBTAINED FROM LSQA. THE ADDRESS OF THE */
*   /* AREA IS RETURNED IN ABDGMA, AND THE ADDRESS OF THE GETMAIN    */
*   /* PARAMETER LIST IS PASSED IN REGISTER 1. NEXT THE SAVE AREAS   */
*   /* ARE CHAINED, AND THE TEMPORARY WORK AREA IS CLEARED TO ZEROS  */
*   /* SO THAT THE BOUNDARY ADJUSTMENT MOVES CAN BE DONE PROPERLY.   */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0080
*   ABDARPTR=PARMPTR;               /* THE ABDAREA POINTER IS      0080
*                                      INITIALIZED FROM THE VALUE IN
*                                      REGISTER 1                    */
         LR    ABDARPTR,PARMPTR                                    0080
*   PARMPTR=ADDR(ABDASIZE);         /* REGISTER 1 IS SET TO POINT TO
*                                      THE GETMAIN PARAMETER LIST    */
         LA    PARMPTR,ABDASIZE(,ABDARPTR)                         0081
*   GENERATE;                                                      0082
         GETMAIN EC,LV=@ENDDATD-@DATD+72,                              *
               SP=253,                                                 *
               A=ABDGMA(ABDARPTR),                                     *
               MF=(E,(1))
*   IF RETCODE^=0                   /* IF GETMAIN IS UNSUCCESSFUL    */
*     THEN                          /* RETURN IMMEDIATELY.           */
         LTR   RETCODE,RETCODE                                     0083
         BZ    @RF00083                                            0083
*     DO;                           /*                        @Y02705*/
*       RETCODE=8;                  /* NO CORE AVAIL.         @Y02705*/
         LA    RETCODE,8                                           0085
*       RETURN;                     /* OTHERWISE CONTINUE            */
@EL00001 DS    0H                                                  0086
@EF00001 DS    0H                                                  0086
@ER00001 L     @14,12(,@13)                                        0086
         LM    @00,@12,20(@13)                                     0086
         BR    @14                                                 0086
*     END;                          /*                        @Y02705*/
*   ELSE                            /*                        @Y02705*/
*     DO;                           /*                        @Y02705*/
@RF00083 DS    0H                                                  0089
*       PARMPTR=ABDAAREA;           /* USE PARMPTR AS TEMPORARY    0089
*                                      POINTER TO SAVE AREA          */
         L     PARMPTR,ABDAAREA(,ABDARPTR)                         0089
*       NEXSAPTR=PARMPTR;           /* INITIALIZE NEXT SAVE AREA   0090
*                                      POINTER IN OLD SAVE AREA      */
         ST    PARMPTR,NEXSAPTR(,SAVEPTR)                          0090
*       PRESAPTR=SAVEPTR;           /* INITIALIZE PREVIOUS SAVE AREA
*                                      POINTER IN NEW AREA           */
         ST    SAVEPTR,PRESAPTR(,PARMPTR)                          0091
*       SAVEPTR=PARMPTR;            /* SET SAVE REGISTER TO NEW SAVE
*                                      AREA ADDRESS                  */
         LR    SAVEPTR,PARMPTR                                     0092
*       AUTOPTR=SAVEPTR+72;         /* SET UP AUTOMATIC DATA       0093
*                                      ADDRESSABILITY BEYOND SAVE  0093
*                                      AREA                          */
         LA    AUTOPTR,72(,SAVEPTR)                                0093
*       GENERATE;                                                  0094
         USING @DATD,AUTOPTR           ESTABLISH ADDRESSABILITY
         XC    0(@ENDDATD-@DATD,AUTOPTR),0(AUTOPTR)       0 SPACE
*       PARMPTR=ABDARPTR;           /* SET ADDR OF WORK AREA @YM04767*/
         LR    PARMPTR,ABDARPTR                                    0095
*       SAVERET=0;                  /* INIT. RETCODE REG     @YM04767*/
         SLR   SAVERET,SAVERET                                     0096
*                                                                  0097
*       /*************************************************************/
*       /*                                                           */
*       /* THE FIRST TIME THROUGH THE LOOP, THE IQES ARE      @Y02705*/
*       /* FORMATTED AND PRINTED. THE SEARCH OF THE QUEUE IS  @Y02705*/
*       /* WITH THE LOCAL LOCK RUN DISABLED DUE TO            @Y02705*/
*       /* ITS VOLATILE NATURE. THOSE IQES TO BE DISPLAYED    @Y02705*/
*       /* HAVE A PURGE BIT ON TO INDICATE THAT THE BLOCK     @Y02705*/
*       /* WILL NOT BE FREED WHILE IT IS BEING DISPLAYED. IN THE MAIN*/
*       /* LOOP, THE NEXT BLOCK POINTER IS GOTTEN. IF THE HIGH ORDER */
*       /* BYTE CONTAINS A HEX FF THE END OF THE QUEUE HAS BEEN      */
*       /* REACHED.                                           @Y02705*/
*       /* IF THERE WAS ANOTHER BLOCK STILL ON THE QUEUE, THE PURGE  */
*       /* BIT IS CHECKED. IF THE BIT IS OFF THE NEXT BLOCK IS       */
*       /* OBTAINED. IF THE BIT IS ON THE TCB FIELD IS CHECKED. IF   */
*       /* THE TCB ADDRESS IS THE TCB BEING DISPLAYED, THE BLOCK IS  */
*       /* FORMATTED AND PRINTED. THE FORMATTING AND PRINTING IS     */
*       /* NATURALLY DONE ENABLED.                                   */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0097
*       TCBPTR=ABDTCB;              /* PICK UP TCB ADDRESS           */
         L     TCBPTR,ABDTCB(,ABDARPTR)                            0097
*IQEDISLP:                          /* OBTAIN LOCK BEFORE SEARCH     */
*       GENERATE REFS(PSALITA,ABDWORK);                            0098
IQEDISLP DS    0H                                                  0098
*                                       /*                    @Y02705*/
         STM   11,14,ABDWORK(ABDARPTR)
         SETLOCK OBTAIN,TYPE=LOCAL,MODE=UNCOND,RELATED=(IQE,           C
               IEAVAD05(IQEDISLP))
         LM    11,14,ABDWORK(ABDARPTR)
*       ASCBPTR=PSAAOLD;            /* GET ADDR OF CURRENT ASCB    0099
*                                                             @Y02705*/
         L     ASCBPTR,PSAAOLD                                     0099
*       ASXBPTR=ASCBASXB;           /* GET ADDR OF ASXB       @Y02705*/
         L     ASXBPTR,ASCBASXB(,ASCBPTR)                          0100
*       IF ASXBFIQE=0 THEN          /* DOES AN IQE EXIST      @Y02705*/
         ICM   @14,15,ASXBFIQE(ASXBPTR)                            0101
         BNZ   @RF00101                                            0101
*         DO;                       /* NO, FREE LOCK          @Y02705*/
*           GENERATE REFS(PSALITA,ABDWORK);                        0103
*                                         /*                  @Y02705*/
         STM    11,14,ABDWORK(ABDARPTR)
         SETLOCK RELEASE,TYPE=LOCAL,RELATED=(IQE,IEAVAD05(IEQDISLP))
         LM     11,14,ABDWORK(ABDARPTR)
*           GOTO VSMOUT;            /* FMT VSM BLKS          @Z40WPXH*/
         B     VSMOUT                                              0104
*         END;                      /*                        @Y02705*/
*       IQEPTR=ASXBFIQE;            /* POINT TO FIRST IQE ADDRESS    */
@RF00101 L     IQEPTR,ASXBFIQE(,ASXBPTR)                           0106
*       ABDLINEA(1:4)=IQEMSG;       /* SET UP IQE MESSAGE TEXT       */
         MVC   ABDLINEA(4,ABDARPTR),IQEMSG                         0107
*       HEADBIT='1'B;               /* SET UP TO DO IQE HEADER       */
         OI    HEADBIT,B'10000000'                                 0108
*       GOTO CHPURGE;               /* CHECK PURGE INDICTR    @Y02705*/
         B     CHPURGE                                             0109
*IQELP:                             /* SEARCH LOOP FOR IQE           */
*       IQEPTR=IQELNKA;             /* PICK UP NEXT BLOCK TO TEST  0110
*                                                            @YM06701*/
IQELP    SLR   @14,@14                                             0110
         ICM   @14,7,IQELNKA(IQEPTR)                               0110
         LR    IQEPTR,@14                                          0110
*       IF IQEPTR=0                 /* IF END OF Q INDICATD  @YM06701*/
*         THEN                                                     0111
         LTR   IQEPTR,IQEPTR                                       0111
         BNZ   @RF00111                                            0111
*         DO;                                                      0112
*           GENERATE REFS(ABDWORK,PSALITA);                        0113
*                                      /*                     @Y02705*/
         STM   11,14,ABDWORK(ABDARPTR)
         SETLOCK RELEASE,TYPE=LOCAL,RELATED=(IQE,IEAVAD05(IQELP))
         LM    11,14,ABDWORK(ABDARPTR)
*           PARMPTR=ABDARPTR;       /* RESET PARAMETER REG           */
         LR    PARMPTR,ABDARPTR                                    0114
*           ABDLINEA(1:4)=' ';      /* BLANK OUT POSS HEADER         */
         MVI   ABDLINEA+1(ABDARPTR),C' '                           0115
         MVC   ABDLINEA+2(2,ABDARPTR),ABDLINEA+1(ABDARPTR)         0115
         MVI   ABDLINEA(ABDARPTR),C' '                             0115
*           GOTO VSMOUT;            /* DO VSM BLOCKS         @Z40WPXH*/
         B     VSMOUT                                              0116
*         END;                                                     0117
*CHPURGE:                           /*                        @Y02705*/
*       IF IQEPURGE='0'B            /* IF BLOCK NOT FIXED            */
*         THEN                      /* IGNORE IT                     */
@RF00111 DS    0H                                                  0118
CHPURGE  TM    IQEPURGE(IQEPTR),B'10000000'                        0118
         BZ    @RT00118                                            0118
*         GOTO IQELP;               /* CONTINUE DISABLE SEARCH       */
*       IF TCBPTR^=IQETCB           /* IF NOT OWNED BY OUR TCB       */
*         THEN                      /* IGNORE IT                     */
         C     TCBPTR,IQETCB(,IQEPTR)                              0120
         BNE   @RT00120                                            0120
*         GOTO IQELP;               /* CONTINUE DISABLED SEARCH      */
*       ABDLLINE=ADDR(IQELLINE);    /* POINT TO IQE LAYOUT           */
         LA    @14,IQELLINE                                        0122
         ST    @14,ABDLLINE(,ABDARPTR)                             0122
*IQEHDR:                                                           0123
*       GENERATE REFS(PSALITA,ABDWORK);                            0123
IQEHDR   DS    0H                                                  0123
*                                       /*                    @Y02705*/
         STM   11,14,ABDWORK(ABDARPTR)
          SETLOCK RELEASE,TYPE=LOCAL,RELATED=(IQE,IEAVAD05(IQEHDR))
         LM    11,14,ABDWORK(ABDARPTR)
*       IF HEADBIT='1'B             /* IF HEADING TO BE PRINTED      */
*         THEN                      /* PRINT IT                      */
         TM    HEADBIT,B'10000000'                                 0124
         BNO   @RF00124                                            0124
*         DO;                                                      0125
*           CALL IEAVAD11;          /* OUTPUT THE HEADING            */
         L     @15,@CV00114                                        0126
         BALR  @14,@15                                             0126
*           IF RETCODE^=0           /* IF ERRED                      */
*             THEN                  /* LEAVE WITH                    */
         LTR   RETCODE,RETCODE                                     0127
         BNZ   @RT00127                                            0127
*             GOTO FREERET;         /* BAD CODE                      */
*           HEADBIT='0'B;           /* INDICATE HEADING PRINTED      */
         NI    HEADBIT,B'01111111'                                 0129
*           ABDCC='0';              /* DOUBLE SPACE FIRST BLOCK      */
         MVI   ABDCC(ABDARPTR),C'0'                                0130
*         END;                                                     0131
*       ABDWORKA=IQEPTR;            /* POINT TO IQE TO FORMAT        */
@RF00124 ST    IQEPTR,ABDWORKA(,ABDARPTR)                          0132
*       ABDBPTR=ADDR(ABDWORKB);     /* POINT TO ADDRESS              */
         LA    @14,ABDWORKB(,ABDARPTR)                             0133
         ST    @14,ABDBPTR(,ABDARPTR)                              0133
*       CALL IEAVAD31;              /* FORMAT THE ADDRESS            */
         L     @15,@CV00115                                        0134
         BALR  @14,@15                                             0134
*       IF RETCODE^=0               /* IF ERRED                      */
*         THEN                      /* LEAVE WITH                    */
         LTR   RETCODE,RETCODE                                     0135
         BNZ   @RT00135                                            0135
*         GOTO FREERET;             /* BAD CODE                      */
*       ABDBPTR=IQEPTR;             /* POINT TO BLOCK TO FORMAT      */
         ST    IQEPTR,ABDBPTR(,ABDARPTR)                           0137
*       CALL IEAVAD31;              /* FORMAT THE IQE                */
         L     @15,@CV00115                                        0138
         BALR  @14,@15                                             0138
*       IF RETCODE^=0               /* IF ERRED                      */
*         THEN                      /* LEAVE WITH                    */
         LTR   RETCODE,RETCODE                                     0139
         BNZ   @RT00139                                            0139
*         GOTO FREERET;             /* BAD CODE                      */
*       CALL IEAVAD11;              /* OUTPUT THE IQE                */
         L     @15,@CV00114                                        0141
         BALR  @14,@15                                             0141
*       IF RETCODE^=0               /* IF ERRED                      */
*         THEN                      /* LEAVE WITH                    */
         LTR   RETCODE,RETCODE                                     0142
         BNZ   @RT00142                                            0142
*         GOTO FREERET;             /* BAD CODE                      */
*       GENERATE REFS(PSALITA,ABDWORK);                            0144
*                                       /*                    @Y02705*/
         STM   11,14,ABDWORK(ABDARPTR)
         SETLOCK OBTAIN,TYPE=LOCAL,MODE=UNCOND,RELATED=(IQE,           C
               IEAVAD05(IQEHDR))
         LM    11,14,ABDWORK(ABDARPTR)
*       GOTO IQELP;                 /* CONTINUE THE LOOP             */
         B     IQELP                                               0145
*VSMOUT:                            /*                       @Z40WPXH*/
*       IF TCBFC='1'B               /* IF TASK IS COMPLETE           */
*         THEN                      /* DONT PRINT                    */
VSMOUT   TM    TCBFC(TCBPTR),B'10000000'                           0146
         BO    @RT00146                                            0146
*         GOTO PQEOUT;              /* VMM BLOCK                     */
*       HEADBIT='1'B;               /* PRINT HEADERS FIRST SPQE      */
         OI    HEADBIT,B'10000000'                                 0148
*       IF TCBPTR=ABDCTCB           /* IF CURRENT TASK DUMPED        */
*         THEN                      /* SET NON-DISPATCHABLE          */
         C     TCBPTR,ABDCTCB(,ABDARPTR)                           0149
         BNE   @RF00149                                            0149
*         DO;                                                      0150
*           IF TCBLTC^=0&           /* DOES TASK HAVE DAU.    @Y02705*/
*               TCBLTC->TCBJSTCB=TCBLTC/* WHICH IS A JS TASK  @Y02705*/
*             THEN                                                 0151
         L     @14,TCBLTC(,TCBPTR)                                 0151
         LTR   @14,@14                                             0151
         BZ    @RF00151                                            0151
         C     @14,TCBJSTCB(,@14)                                  0151
         BE    @RT00151                                            0151
*             ;                     /* YES, DO NOT SET ND     @Y02705*/
*           ELSE                                                   0153
*             DO;                                                  0153
@RF00151 DS    0H                                                  0154
*               TCBADMP='1'B;       /* INDICATE GOING TO SET BIT     */
         OI    TCBADMP(TCBPTR),B'00000010'                         0154
*               GEN(STATUS SET,ND,STEP,(1));/* SET NON-DISP          */
         STATUS SET,ND,STEP,(1)
*               ABDSTAT='1'B;       /* IND STATUS ISSUED     @YM06195*/
         OI    ABDSTAT(ABDARPTR),B'00000010'                       0156
*             END;                  /*                        @Y02705*/
*         END;                                                     0158
@RT00151 DS    0H                                                  0159
*       SPQESPTR=ADDR(TCBMSS);      /* POINT TO FIRST SPQE ADDR      */
@RF00149 LA    SPQESPTR,TCBMSS(,TCBPTR)                            0159
*       PARMPTR=ABDARPTR;           /* RESET PARAMETER REG           */
         LR    PARMPTR,ABDARPTR                                    0160
*NEXTSPQE:                          /* GET NEXT SPQE                 */
*       SPQESPTR=SPQEPTR;           /* PICK UP NEXT SPQE ADDR        */
NEXTSPQE L     SPQESPTR,SPQEPTR(,SPQESPTR)                         0161
*       IF SPQESPTR=0               /* IF NON LEFT LEAVE             */
*         THEN                      /* AFTER CHECKING DISPACHABLE    */
         SLR   @14,@14                                             0162
         CR    SPQESPTR,@14                                        0162
         BNE   @RF00162                                            0162
*         DO;                                                      0163
*           IF TCBPTR=ABDCTCB       /* IF SET NON-DISP               */
*             THEN                  /* RESET TO DISPACHABLE          */
         C     TCBPTR,ABDCTCB(,ABDARPTR)                           0164
         BNE   @RF00164                                            0164
*             DO;                                                  0165
*               IF TCBLTC^=0&       /* DOES TASK HAVE DAU.    @Y02705*/
*                   TCBLTC->TCBJSTCB=TCBLTC/* WHICH IS A JS TASK   0166
*                                                             @Y02705*/
*                 THEN                                             0166
         L     @10,TCBLTC(,TCBPTR)                                 0166
         CR    @10,@14                                             0166
         BE    @RF00166                                            0166
         C     @10,TCBJSTCB(,@10)                                  0166
         BE    @RT00166                                            0166
*                 ;                 /* YES, DO NOT SET ND     @Y02705*/
*               ELSE                                               0168
*                 DO;                                              0168
@RF00166 DS    0H                                                  0169
*                   ABDSTAT='0'B;   /* IND STATUS RESET      @YM06195*/
         NI    ABDSTAT(ABDARPTR),B'11111101'                       0169
*                   GEN(STATUS RESET,ND,STEP,(1));/* RESET DISP      */
         STATUS RESET,ND,STEP,(1)
*                   TCBADMP='0'B;   /* RESET INDICATOR               */
         NI    TCBADMP(TCBPTR),B'11111101'                         0171
*                 END;              /*                        @Y02705*/
*             END;                  /* BLANK OUT ENTIRE MESS         */
@RT00166 DS    0H                                                  0174
*           PARMPTR=ABDARPTR;       /* RESET PARAMETER REG           */
@RF00164 LR    PARMPTR,ABDARPTR                                    0174
*           ABDLINEA(1:121)=' ';    /* CLEAR LAYOUT LINE     @YM03351*/
         MVI   ABDLINEA+1(ABDARPTR),C' '                           0175
         MVC   ABDLINEA+2(119,ABDARPTR),ABDLINEA+1(ABDARPTR)       0175
         MVI   ABDLINEA(ABDARPTR),C' '                             0175
*           GOTO PQEOUT;            /* GO TO NEXT FUNCTION           */
         B     PQEOUT                                              0176
*         END;                                                     0177
*       IF HEADBIT='1'B             /* IF HEADER TO BE PRINTED       */
*         THEN                      /* PRINT THEM                    */
@RF00162 TM    HEADBIT,B'10000000'                                 0178
         BNO   @RF00178                                            0178
*         DO;                                                      0179
*           ABDLINEA(1:4)=VSMMSG;   /* SET UP VSM LABEL      @Z40WPXH*/
         MVC   ABDLINEA(4,ABDARPTR),VSMMSG                         0180
*           CALL IEAVAD11;          /* OUTPUT THE FIRST HEADER       */
         L     @15,@CV00114                                        0181
         BALR  @14,@15                                             0181
*           IF RETCODE^=0           /* IF ERRED                      */
*             THEN                  /* CHECK DISP AND LEAVE          */
         LTR   RETCODE,RETCODE                                     0182
         BZ    @RF00182                                            0182
*             DO;                   /* WITH BAD CODE                 */
*DISPACHK:                          /* CHECK IF CURRENT TASK         */
*               SAVERET=RETCODE;    /* SAVE THE RETURN CODE          */
DISPACHK LR    SAVERET,RETCODE                                     0184
*               IF TCBPTR=ABDCTCB   /* IF CURRENT TASK               */
*                 THEN              /* RESET DISP                    */
         C     TCBPTR,ABDCTCB(,ABDARPTR)                           0185
         BNE   @RF00185                                            0185
*                 DO;                                              0186
*                   IF TCBLTC^=0&   /* DOES TASK HAVE DAU.    @Y02705*/
*                       TCBLTC->TCBJSTCB=TCBLTC/* WHICH IS JS TASK 0187
*                                                             @Y02705*/
*                     THEN                                         0187
         L     @14,TCBLTC(,TCBPTR)                                 0187
         LTR   @14,@14                                             0187
         BZ    @RF00187                                            0187
         C     @14,TCBJSTCB(,@14)                                  0187
         BE    @RT00187                                            0187
*                     ;             /* YES, DO NOT SET ND     @Y02705*/
*                   ELSE            /*                        @Y02705*/
*                     DO;           /*                        @Y02705*/
@RF00187 DS    0H                                                  0190
*                       GEN(STATUS RESET,ND,STEP,(1));/* RESET DISP  */
         STATUS RESET,ND,STEP,(1)
*                       PARMPTR=ABDARPTR;/* RESTORE PARAMETER REG    */
         LR    PARMPTR,ABDARPTR                                    0191
*                       TCBADMP='0'B;/* TURN OFF INDICATOR           */
         NI    TCBADMP(TCBPTR),B'11111101'                         0192
*                     END;          /*                        @Y02705*/
*                 END;                                             0194
*               GOTO FREEBAD;       /* LEAVE WITH BAD CODE IN SAVE   */
         B     FREEBAD                                             0195
*             END;                                                 0196
*           HEADBIT='0'B;           /* SET HEAD INDICATOR OFF        */
@RF00182 NI    HEADBIT,B'01111111'                                 0197
*         END;                                                     0198
*       SAVESPQE=SPQESPTR;          /* SAVE THE SPQE ADRESS          */
@RF00178 ST    SPQESPTR,SAVESPQE                                   0199
*       ABDLINEA(1:121)=' ';        /* BLANK OUT VMM LINE     @Y02705*/
         MVI   ABDLINEA+1(ABDARPTR),C' '                           0200
         MVC   ABDLINEA+2(119,ABDARPTR),ABDLINEA+1(ABDARPTR)       0200
         MVI   ABDLINEA(ABDARPTR),C' '                             0200
*FMSPQE:                            /* FORMAT THE SPQE               */
*       CONVERT=SPQEID;             /* PUT ID INTO REG TO CONVERT    */
FMSPQE   SLR   CONVERT,CONVERT                                     0201
         IC    CONVERT,SPQEID(,SPQESPTR)                           0201
*       GEN(CVD CONVERT,ABDWORK1(ABDARPTR));/* TO DECIMAL            */
         CVD CONVERT,ABDWORK1(ABDARPTR)
*       SPIDN=CVDID;                /* PUT ID IN FRMT AREA    @Y02705*/
         MVC   SPIDN(2,ABDARPTR),CVDID(ABDARPTR)                   0203
*       FLAGRES=SPQEFLGS;           /* MOVE FLAGS IN AREA     @Y02705*/
         MVI   FLAGRES+1(ABDARPTR),X'00'                           0204
         MVC   FLAGRES(1,ABDARPTR),SPQEFLGS(SPQESPTR)              0204
*       SPQEAFLD=SPQESPTR;          /* MOVE IN SPQE ADDR             */
         ST    SPQESPTR,SPQEAFLD(,ABDARPTR)                        0205
*       NSPQEFLD=SPQEAD;            /* MOVE IN NSPQE          @Y02705*/
         MVC   NSPQEFLD(4,ABDARPTR),SPQEAD(SPQESPTR)               0206
*       DQEWORD=SPDQEAD;            /* MOVE IN DQE ADDRESS           */
         MVC   DQEWORD(4,ABDARPTR),SPDQEAD(SPQESPTR)               0207
*       ABDBPTR=ADDR(SPQEAFLD);     /* SET UP ADDRESS OF FIELDS      */
         LA    @14,SPQEAFLD(,ABDARPTR)                             0208
         ST    @14,ABDBPTR(,ABDARPTR)                              0208
*       ABDLLINE=ADDR(SPQELLIN);    /* SET UP LAYOUT ADDRESS         */
         LA    @14,SPQELLIN                                        0209
         ST    @14,ABDLLINE(,ABDARPTR)                             0209
*       CALL IEAVAD61;              /* FORMAT SPQE FROM WORK AREA    */
         L     @15,@CV00116                                        0210
         BALR  @14,@15                                             0210
*       IF RETCODE^=0               /* IF ERRED                      */
*         THEN                      /* CHECK DISP AND LEAVE          */
         LTR   RETCODE,RETCODE                                     0211
         BNZ   @RT00211                                            0211
*         GOTO DISPACHK;            /* WITH BAD CODE                 */
*       ABDLINEA(70)=' ';           /* BLANK GARBAGE FLAG BYTE       */
         MVI   ABDLINEA+69(ABDARPTR),C' '                          0213
*       ABDLINEA(78)=' ';                                          0214
         MVI   ABDLINEA+77(ABDARPTR),C' '                          0214
*       CONVERT=SPQEKEY/16;         /* OBTAIN SPQE KEY IN LOW 4 BITS
*                                                            @YM06192*/
         SLR   CONVERT,CONVERT                                     0215
         IC    CONVERT,SPQEKEY(,SPQESPTR)                          0215
         SRL   CONVERT,4                                           0215
*       IF CONVERT>9                /* KEY = A THRU F?       @YM06192*/
*         THEN                      /* YES                   @YM06192*/
         CH    CONVERT,@CH00060                                    0216
         BNH   @RF00216                                            0216
*         CONVERT=CONVERT+183;      /* CONVERT TO EBCDIC     @YM06192*/
         LA    CONVERT,183(,CONVERT)                               0217
*       ELSE                        /* KEY = 0 THRU 9        @YM06192*/
*         CONVERT=CONVERT+240;      /* CONVERT TO EBCDIC     @YM06192*/
         B     @RC00216                                            0218
@RF00216 LA    CONVERT,240(,CONVERT)                               0218
*       GEN(STC CONVERT,ABDLINEA+76(ABDARPTR));/* STORE IN LINE      */
@RC00216 DS    0H                                                  0219
         STC CONVERT,ABDLINEA+76(ABDARPTR)
*       ABDLINEA(4:7)=SPQEL;        /* SPQE LABEL             @Y02705*/
         MVC   ABDLINEA+3(4,ABDARPTR),SPQEL                        0220
*       ABDLINEA(19:23)=NSPQEL;     /* NSPQE LABEL            @Y02705*/
         MVC   ABDLINEA+18(5,ABDARPTR),NSPQEL                      0221
*       ABDLINEA(35:37)=DQEL;       /* DQE LABEL              @Y02705*/
         MVC   ABDLINEA+34(3,ABDARPTR),DQEL                        0222
*       ABDLINEA(49:53)=FLRSL;      /* FLAGS/RESV LABEL       @Y02705*/
         MVC   ABDLINEA+48(5,ABDARPTR),FLRSL                       0223
*       ABDLINEA(61:64)=SPIDL;      /* SUBPOOL ID LABEL       @Y02705*/
         MVC   ABDLINEA+60(4,ABDARPTR),SPIDL                       0224
*       ABDLINEA(72:74)=KEYL;       /* PROTECT KEY LABEL      @Y02705*/
         MVC   ABDLINEA+71(3,ABDARPTR),KEYL                        0225
*       IF SPSHARE='1'B             /* IF SHARED SUBPOOL             */
*         THEN                      /* GET OWNER AND CONTINUE        */
         TM    SPSHARE(SPQESPTR),B'10000000'                       0226
         BNO   @RF00226                                            0226
*         DO;                                                      0227
*           SPQESPTR=SPDQEAD;       /* PICK UP OWNER SPQE            */
         L     SPQESPTR,SPDQEAD(,SPQESPTR)                         0228
*           IF TCBFLAG='0000'B      /* IF KEY ZERO USER              */
*             THEN                  /* VALIDITY CHECK TASK           */
         TM    TCBFLAG(TCBPTR),B'11110000'                         0229
         BNZ   @RF00229                                            0229
*             DO;                                                  0230
*               OTCTCB=TCBPTR;      /* SET UP MOTHER POINTER         */
         LR    OTCTCB,TCBPTR                                       0231
*OTCLOOP:                                                          0232
*               OTCTCB=OTCTCB->TCBOTC;/* GET MOTHER ADDRESS          */
OTCLOOP  L     OTCTCB,TCBOTC(,OTCTCB)                              0232
*               IF OTCTCB=0         /* IF NO MOTHER TEST FAILS       */
*                 THEN              /* GO TO GET NEXT SPQE           */
         LTR   OTCTCB,OTCTCB                                       0233
         BNZ   @RF00233                                            0233
*                 DO;                                              0234
*OUTSLOOP:                          /* GET ORIGINAL SPQE AND LOOP    */
*                   SPQESPTR=SAVESPQE;/* PICK UP ORIGINAL SPQE       */
OUTSLOOP L     SPQESPTR,SAVESPQE                                   0235
*                   GOTO NEXTSPQE;  /* GET NEXT SPQE AFTER ORIG.     */
         B     NEXTSPQE                                            0236
*                 END;                                             0237
*               OTCSPQE=OTCTCB->TCBMSS;/* GET MOTHER SPQE CHAIN      */
@RF00233 L     OTCSPQE,TCBMSS(,OTCTCB)                             0238
*CHKOTS:                            /* CHECK OTC SPQE FIELD          */
*               IF OTCSPQE=0        /* IF NO MORE SPQES              */
*                 THEN              /* TRY NEXT OTCTCB IF ANY        */
CHKOTS   LTR   OTCSPQE,OTCSPQE                                     0239
         BZ    @RT00239                                            0239
*                 GOTO OTCLOOP;     /* GET NEXT OTCTCB               */
*               IF OTCSPQE^=SPQESPTR/* IF NOT EQUAL OWNER            */
*                 THEN              /* GET NEXT SPQE AND TEST IT     */
         CR    OTCSPQE,SPQESPTR                                    0241
         BE    @RF00241                                            0241
*                 DO;                                              0242
*                   OTCSPQE=OTCSPQE->SPQEPTR;/* GET NEXT SPQE        */
         L     OTCSPQE,SPQEPTR(,OTCSPQE)                           0243
*                   GOTO CHKOTS;    /* CHECK IF ITS THE ONE          */
         B     CHKOTS                                              0244
*                 END;                                             0245
*               IF TCBJSTCB^=OTCTCB->TCBJSTCB/* IF NOT IN SAME JOBSTP*/
*                 THEN              /* DONT DO THIS SPQE             */
@RF00241 CLC   TCBJSTCB(4,TCBPTR),TCBJSTCB(OTCTCB)                 0246
         BNE   @RT00246                                            0246
*                 GOTO OUTSLOOP;    /* GET NEXT SPQE                 */
*             END;                                                 0248
*           CALL IEAVAD11;          /* OWNER IS OK PRINT SHARED      */
@RF00229 L     @15,@CV00114                                        0249
         BALR  @14,@15                                             0249
*           IF RETCODE^=0           /* IF ERRED                      */
*             THEN                  /* CHECK DISP AND LEAVE          */
         LTR   RETCODE,RETCODE                                     0250
         BNZ   @RT00250                                            0250
*             GOTO DISPACHK;        /* WITH BAD CODE                 */
*           GOTO FMSPQE;            /* FORMAT THE OWNER SPQE         */
         B     FMSPQE                                              0252
*         END;                                                     0253
*       ELSE                        /*                        @Y02705*/
*         CALL IEAVAD11;            /* OUTPUT SHARED SUBPL    @Y02705*/
@RF00226 L     @15,@CV00114                                        0254
         BALR  @14,@15                                             0254
*       DQESEPTR=SPDQEAD;           /* GET DQE ADDRESS               */
         L     DQESEPTR,SPDQEAD(,SPQESPTR)                         0255
*       IF DQESEPTR=0               /* IF NONE ON QUEUE              */
*         THEN                      /* PRINT SPQE AND GET NEXT SPQ   */
         LTR   DQESEPTR,DQESEPTR                                   0256
         BNZ   @RF00256                                            0256
*         DO;                                                      0257
*           CALL IEAVAD11;          /* OUTPUT THE SPQE               */
         L     @15,@CV00114                                        0258
         BALR  @14,@15                                             0258
*           IF RETCODE^=0           /* IF ERRED                      */
*             THEN                  /* CHECK DISP AND LEAVE          */
         LTR   RETCODE,RETCODE                                     0259
         BNZ   @RT00259                                            0259
*             GOTO DISPACHK;        /* WITH BAD CODE                 */
*           GOTO OUTSLOOP;          /* GET NEXT SPQE                 */
         B     OUTSLOOP                                            0261
*         END;                                                     0262
*FMDQE:                             /* FORMAT THE DQE                */
*       ABDBLNKS='82'X;             /* OVERRIDE 3 BLKS       @YM03351
*                                      BETWEEN LABELS        @YM03351*/
@RF00256 DS    0H                                                  0263
FMDQE    MVI   ABDBLNKS(ABDARPTR),X'82'                            0263
*       ABDWORKA=DQESEPTR;          /* GET DQE ADDR           @Y02705*/
         ST    DQESEPTR,ABDWORKA(,ABDARPTR)                        0264
*       ABDBPTR=ADDR(ABDWORKB);     /* POINT TO DQE                  */
         LA    @14,ABDWORKB(,ABDARPTR)                             0265
         ST    @14,ABDBPTR(,ABDARPTR)                              0265
*       ABDLLINE=ADDR(DQELLINE);    /* GET DQE LAYOUT LINE    @Y02705*/
         LA    @14,DQELLINE                                        0266
         ST    @14,ABDLLINE(,ABDARPTR)                             0266
*       CALL IEAVAD31;              /* FORMAT THE DQE ADDR           */
         L     @15,@CV00115                                        0267
         BALR  @14,@15                                             0267
*       IF RETCODE^=0               /* IF ERRED                      */
*         THEN                      /* CHECK DISP AND LEAVE          */
         LTR   RETCODE,RETCODE                                     0268
         BNZ   @RT00268                                            0268
*         GOTO DISPACHK;            /* WITH BAD CODE                 */
*       ABDBPTR=DQESEPTR;           /* GET DQE ADDR          @YM03351*/
         ST    DQESEPTR,ABDBPTR(,ABDARPTR)                         0270
*       CALL IEAVAD31;              /* FORMAT THE DQE                */
         L     @15,@CV00115                                        0271
         BALR  @14,@15                                             0271
*       IF RETCODE^=0               /* IF ERRED                      */
*         THEN                      /* CHECK DISP AND LEAVE          */
         SLR   @14,@14                                             0272
         CR    RETCODE,@14                                         0272
         BNE   @RT00272                                            0272
*         GOTO DISPACHK;            /* WITH BAD CODE                 */
*       FQESEPTR=DQFQEPTR;          /* POINT TO FIRST FQE            */
         L     FQESEPTR,DQFQEPTR(,DQESEPTR)                        0274
*       IF FQESEPTR=0               /* IF NO FQE                     */
*         THEN                      /* PRINT SPQE DQE AND LOOP       */
         CR    FQESEPTR,@14                                        0275
         BNE   @RF00275                                            0275
*         DO;                                                      0276
*           CALL IEAVAD11;          /* OUTPUT SPQE DQE               */
         L     @15,@CV00114                                        0277
         BALR  @14,@15                                             0277
*           IF RETCODE^=0           /* IF ERRED                      */
*             THEN                  /* CKECK DISP AND LEAVE          */
         LTR   RETCODE,RETCODE                                     0278
         BNZ   @RT00278                                            0278
*             GOTO DISPACHK;        /* WITH BAD CODE                 */
*NXTDQE:                            /* GET NEXT DQE                  */
*           DQESEPTR=DQEPTR;        /* PICK UP NEXT DQE              */
NXTDQE   L     DQESEPTR,DQEPTR(,DQESEPTR)                          0280
*           IF DQESEPTR^=0          /* IF NO MORE DQES GET SPQE      */
*             THEN                  /* AND LOOP                      */
         LTR   DQESEPTR,DQESEPTR                                   0281
         BNZ   @RT00281                                            0281
*             GOTO FMDQE;           /* FORMAT THE DQE                */
*           ELSE                                                   0283
*             GOTO OUTSLOOP;        /* PICK UP NEXT SPQE             */
         B     OUTSLOOP                                            0283
*           ABDLLINE=ADDR(DQELLINE);/* POINT TO DQE LAYOUT LINE      */
*           ABDBPTR=ADDR(ABDWORKB); /* POINT TO DQE TO FORMAT        */
*         END;                                                     0286
*FMFQE:                             /* FORMAT THE FQE                */
*       ABDWORKA=FQESEPTR;          /* GET ADDR OF FQE        @Y02705*/
@RF00275 DS    0H                                                  0287
FMFQE    ST    FQESEPTR,ABDWORKA(,ABDARPTR)                        0287
*       ABDBPTR=ADDR(ABDWORKB);     /* POINT TO ADDR                 */
         LA    @14,ABDWORKB(,ABDARPTR)                             0288
         ST    @14,ABDBPTR(,ABDARPTR)                              0288
*       ABDLLINE=ADDR(FQE1LINE);    /* GET FQE LAYOUT LINE    @Y02705*/
         LA    @14,FQE1LINE                                        0289
         ST    @14,ABDLLINE(,ABDARPTR)                             0289
*       CALL IEAVAD31;              /* FORMAT THE FQE ADDR           */
         L     @15,@CV00115                                        0290
         BALR  @14,@15                                             0290
*       IF RETCODE^=0               /* IF ERRED                      */
*         THEN                      /* CHECK DISP AND LEAVE          */
         LTR   RETCODE,RETCODE                                     0291
         BNZ   @RT00291                                            0291
*         GOTO DISPACHK;            /* WITH BAD CODE                 */
*       ABDBPTR=FQESEPTR;           /* GET FQE ADDR          @YM03351*/
         ST    FQESEPTR,ABDBPTR(,ABDARPTR)                         0293
*       CALL IEAVAD31;              /* FORMAT THE FQE                */
         L     @15,@CV00115                                        0294
         BALR  @14,@15                                             0294
*       IF RETCODE^=0               /* IF ERRED                      */
*         THEN                      /* CHECK DISP AND LEAVE          */
         LTR   RETCODE,RETCODE                                     0295
         BNZ   @RT00295                                            0295
*         GOTO DISPACHK;            /* WITH BAD CODE                 */
*       IF FQERGNFL='1'B            /* IF 16 BYTE FQE                */
*         THEN                      /* FORMAT 8 BYTES MORE           */
         TM    FQERGNFL(FQESEPTR),B'10000000'                      0297
         BNO   @RF00297                                            0297
*         DO;                                                      0298
*           ABDBPTR=FQESEPTR+8;     /* GET ADDR OF AREA      @YM03351*/
         LA    @14,8                                               0299
         ALR   @14,FQESEPTR                                        0299
         ST    @14,ABDBPTR(,ABDARPTR)                              0299
*           ABDLLINE=ADDR(FQE2LINE);/*                        @Y02705*/
         LA    @14,FQE2LINE                                        0300
         ST    @14,ABDLLINE(,ABDARPTR)                             0300
*           CALL IEAVAD31;          /* FORMAT 8 MORE BYTES           */
         L     @15,@CV00115                                        0301
         BALR  @14,@15                                             0301
*           IF RETCODE^=0           /* IF ERRED                      */
*             THEN                  /* CHECK DISP AND LEAVE          */
         LTR   RETCODE,RETCODE                                     0302
         BNZ   @RT00302                                            0302
*             GOTO DISPACHK;        /* CHECK DISPACHABILITY          */
*         END;                                                     0304
*       CALL IEAVAD11;              /* OUTPUT FQE LINE               */
@RF00297 L     @15,@CV00114                                        0305
         BALR  @14,@15                                             0305
*       IF RETCODE^=0               /* IF ERRED                      */
*         THEN                      /* LEAVE AND CHECK DISP          */
         SLR   @14,@14                                             0306
         CR    RETCODE,@14                                         0306
         BNE   @RT00306                                            0306
*         GOTO DISPACHK;            /* WITH BAD CODE                 */
*       FQESEPTR=FQEPTRA;           /* GET NEXT FQE                  */
         SLR   @10,@10                                             0308
         ICM   @10,7,FQEPTRA(FQESEPTR)                             0308
         LR    FQESEPTR,@10                                        0308
*       IF FQESEPTR=0               /* IF NONE LEFT                  */
*         THEN                      /* CHECK DQES                    */
         CR    FQESEPTR,@14                                        0309
         BE    @RT00309                                            0309
*         GOTO NXTDQE;              /* LEFT                          */
*       ABDLLINE=ADDR(FQE1LINE);    /* POINT TO FQE LAYOUT LINE      */
         LA    @14,FQE1LINE                                        0311
         ST    @14,ABDLLINE(,ABDARPTR)                             0311
*       GOTO FMFQE;                 /* CONTINUE WITH THIS FQE        */
         B     FMFQE                                               0312
*PQEOUT:                                                           0313
*       ABDBLNKS='00'X;             /* ELEMINATE OVERRIDE    @YM03351*/
PQEOUT   MVI   ABDBLNKS(ABDARPTR),X'00'                            0313
*       ABDCC='0';                  /* SET TO DOUBLE SPACE LINE      */
         MVI   ABDCC(ABDARPTR),C'0'                                0314
*       PQESEPTR=TCBPQE;            /* PICK UP PQE ADDRESS           */
         L     PQESEPTR,TCBPQE(,TCBPTR)                            0315
*       ABDWORKA=PQESEPTR;          /* SET UP ADDRESS TO FORMAT      */
         ST    PQESEPTR,ABDWORKA(,ABDARPTR)                        0316
*       ABDBPTR=ADDR(ABDWORKB);     /* POINT TO ADDRESS              */
         LA    @14,ABDWORKB(,ABDARPTR)                             0317
         ST    @14,ABDBPTR(,ABDARPTR)                              0317
*       ABDLLINE=ADDR(DPQELINE);    /* POINT TO DPQE LAYOUT LINE     */
         LA    @14,DPQELINE                                        0318
         ST    @14,ABDLLINE(,ABDARPTR)                             0318
*       CALL IEAVAD31;              /* FORMAT THE ADDRESS            */
         L     @15,@CV00115                                        0319
         BALR  @14,@15                                             0319
*       IF RETCODE^=0               /* IF ERRED                      */
*         THEN                      /* LEAVE WITH                    */
         LTR   RETCODE,RETCODE                                     0320
         BNZ   @RT00320                                            0320
*         GOTO FREERET;             /* BAD CODE                      */
*       ABDBPTR=PQESEPTR+8;         /* SET UP DPQE ADDRESS           */
         LA    @14,8                                               0322
         ALR   @14,PQESEPTR                                        0322
         ST    @14,ABDBPTR(,ABDARPTR)                              0322
*       CALL IEAVAD31;              /* FORMAT THE DPQE               */
         L     @15,@CV00115                                        0323
         BALR  @14,@15                                             0323
*       IF RETCODE^=0               /* IF ERRED                      */
*         THEN                      /* LEAVE WITH                    */
         LTR   RETCODE,RETCODE                                     0324
         BNZ   @RT00324                                            0324
*         GOTO FREERET;             /* BAD CODE                      */
*       CALL IEAVAD11;              /* OUTPUT THE DPQE               */
         L     @15,@CV00114                                        0326
         BALR  @14,@15                                             0326
*       IF RETCODE^=0               /* IF ERRED                      */
*         THEN                      /* LEAVE WITH                    */
         LTR   RETCODE,RETCODE                                     0327
         BNZ   @RT00327                                            0327
*         GOTO FREERET;             /* BAD CODE                      */
*NEXTPQE:                           /* GET NEXT PQE TO FORMAT        */
*       ABDCC='0';                  /* SET TO DOUBLE SPACE LINE      */
NEXTPQE  MVI   ABDCC(ABDARPTR),C'0'                                0329
*       PQESEPTR=PQEFPQE;           /* GET NEXT PQE                  */
         L     PQESEPTR,PQEFPQE(,PQESEPTR)                         0330
*       IF PQESEPTR^=0              /* IF PQE LEFT FORMAT IT AND     */
*         THEN                      /* ITS FBQES                     */
         LTR   PQESEPTR,PQESEPTR                                   0331
         BZ    @RF00331                                            0331
*         DO;                                                      0332
*           ABDWORKA=PQESEPTR;      /* SET UP ADDRESS OF PQE         */
         ST    PQESEPTR,ABDWORKA(,ABDARPTR)                        0333
*           ABDBPTR=ADDR(ABDWORKB); /* POINT TO ADDRESS              */
         LA    @14,ABDWORKB(,ABDARPTR)                             0334
         ST    @14,ABDBPTR(,ABDARPTR)                              0334
*           ABDLLINE=ADDR(PQELLINE);/* POINT TO PQE LAYOUT LINE      */
         LA    @14,PQELLINE                                        0335
         ST    @14,ABDLLINE(,ABDARPTR)                             0335
*           CALL IEAVAD31;          /* FORMAT THE PQE ADDRESS        */
         L     @15,@CV00115                                        0336
         BALR  @14,@15                                             0336
*           IF RETCODE^=0           /* IF ERRED                      */
*             THEN                  /* LEAVE WITH                    */
         LTR   RETCODE,RETCODE                                     0337
         BNZ   @RT00337                                            0337
*             GOTO FREERET;         /* BAD CODE                      */
*           ABDBPTR=PQESEPTR;       /* POINT TO PQE                  */
         ST    PQESEPTR,ABDBPTR(,ABDARPTR)                         0339
*           CALL IEAVAD31;          /* FORMAT THE PQE 1              */
         L     @15,@CV00115                                        0340
         BALR  @14,@15                                             0340
*           IF RETCODE^=0           /* IF ERRED                      */
*             THEN                  /* LEAVE WITH                    */
         LTR   RETCODE,RETCODE                                     0341
         BNZ   @RT00341                                            0341
*             GOTO FREERET;         /* BAD CODE                      */
*           CALL IEAVAD11;          /* OUTPUT THE PQE 1              */
         L     @15,@CV00114                                        0343
         BALR  @14,@15                                             0343
*           IF RETCODE^=0           /* IF ERRED                      */
*             THEN                  /* LEAVE WITH                    */
         LTR   RETCODE,RETCODE                                     0344
         BNZ   @RT00344                                            0344
*             GOTO FREERET;         /* BAD CODE                      */
*           CALL IEAVAD31;          /* FORMAT THE PQE 2              */
         L     @15,@CV00115                                        0346
         BALR  @14,@15                                             0346
*           IF RETCODE^=0           /* IF ERRED                      */
*             THEN                  /* LEAVE WITH                    */
         LTR   RETCODE,RETCODE                                     0347
         BNZ   @RT00347                                            0347
*             GOTO FREERET;         /* BAD CODE                      */
*           CALL IEAVAD11;          /* OUTPUT THE PQE 2              */
         L     @15,@CV00114                                        0349
         BALR  @14,@15                                             0349
*           IF RETCODE^=0           /* IF ERRED                      */
*             THEN                  /* LEAVE WITH                    */
         LTR   RETCODE,RETCODE                                     0350
         BNZ   @RT00350                                            0350
*             GOTO FREERET;         /* BAD CODE                      */
*           FBQESPTR=PQESEPTR;      /* POINT TO FBQE FIELD           */
         LR    FBQESPTR,PQESEPTR                                   0352
*           HIGH=0;                 /* INITIALIZE HIGH COMPARE       */
         SLR   HIGH,HIGH                                           0353
*NEXTFBQE:                          /* FORMAT NEXT FBQE              */
*           GENERATE REFS(PSALITA,ABDWORK);                        0354
NEXTFBQE DS    0H                                                  0354
*                                      /*                     @Y02705*/
         STM   11,14,ABDWORK(ABDARPTR)
         SETLOCK OBTAIN,TYPE=LOCAL,MODE=UNCOND,                        C
               RELATED=(FBQE,IEAVAD05(NEXTFBQE))
         LM    11,14,ABDWORK(ABDARPTR)
*GETFBQE:                           /* PICK UP NEXT FBQE             */
*           FBQESPTR=FWDPTR;        /* GET FBQE                      */
GETFBQE  L     FBQESPTR,FWDPTR(,FBQESPTR)                          0355
*           IF FBQESPTR=PQESEPTR    /* IF NONE LEFT                  */
*               |FBQESPTR=0         /* OR ZERO CHAIN PTR     @ZA02570*/
*             THEN                  /* GET NEXT PQE                  */
         CR    FBQESPTR,PQESEPTR                                   0356
         BE    @RT00356                                            0356
         LTR   FBQESPTR,FBQESPTR                                   0356
         BNZ   @RF00356                                            0356
@RT00356 DS    0H                                                  0357
*             DO;                                                  0357
*               GENERATE REFS(PSALITA,ABDWORK);                    0358
*                                      /*                     @Y02705*/
         STM   11,14,ABDWORK(ABDARPTR)
         SETLOCK RELEASE,TYPE=LOCAL,RELATED=(FBQE,IEAVAD05,(GETFBQE))
         LM    11,14,ABDWORK(ABDARPTR)
*               GOTO NEXTPQE;       /* DO NEXT PQE                   */
         B     NEXTPQE                                             0359
*             END;                                                 0360
*           IF HIGH>FBQAREA         /* IF NOT NEXT FBQE              */
*             THEN                                                 0361
@RF00356 L     @14,FBQAREA(,FBQESPTR)                              0361
         CR    HIGH,@14                                            0361
         BH    @RT00361                                            0361
*             GOTO GETFBQE;         /* GET ANOTHER FBQE              */
*           ABDWORK(5:20)=FBQESECT; /* MOVE FBQE TO FORMAT IT        */
         MVC   ABDWORK+4(16,ABDARPTR),FBQESECT(FBQESPTR)           0363
*           ABDWORKA=FBQESPTR;      /* MOVE IN FBQE ADDRESS          */
         ST    FBQESPTR,ABDWORKA(,ABDARPTR)                        0364
*           ABDBPTR=ADDR(ABDWORKB); /* SET UP POINTER TO FBQE        */
         LA    @10,ABDWORKB(,ABDARPTR)                             0365
         ST    @10,ABDBPTR(,ABDARPTR)                              0365
*           ABDLLINE=ADDR(FBQELINE);/* SET UP LAYOUT LINE            */
         LA    @10,FBQELINE                                        0366
         ST    @10,ABDLLINE(,ABDARPTR)                             0366
*           HIGH=SIZE+FBQAREA;      /* CALCULATE NEXT HIGHER ADDR    */
         AL    @14,SIZE(,FBQESPTR)                                 0367
         LR    HIGH,@14                                            0367
*FBQEFRMT:                          /*                        @Y02705*/
*           GENERATE REFS(ABDWORK,PSALITA);                        0368
FBQEFRMT DS    0H                                                  0368
*                                      /*                     @Y02705*/
         STM   11,14,ABDWORK+20(ABDARPTR)                      @YM04767
         SETLOCK RELEASE,TYPE=LOCAL,RELATED=(FBQE,IEAVAD05,(GETFBQE))
         LM    11,14,ABDWORK+20(ABDARPTR)                      @YM04767
*           CALL IEAVAD31;          /* FORMAT THE FBQE               */
         L     @15,@CV00115                                        0369
         BALR  @14,@15                                             0369
*           IF RETCODE^=0           /* IF ERRED                      */
*             THEN                  /* LEAVE WITH                    */
         LTR   RETCODE,RETCODE                                     0370
         BNZ   @RT00370                                            0370
*             GOTO FREERET;         /* BAD CODE                      */
*           CALL IEAVAD11;          /* OUTPUT THE FBQE               */
         L     @15,@CV00114                                        0372
         BALR  @14,@15                                             0372
*           IF RETCODE^=0           /* IF ERRED                      */
*             THEN                  /* LEAVE WITH                    */
         LTR   RETCODE,RETCODE                                     0373
         BNZ   @RT00373                                            0373
*             GOTO FREERET;         /* BAD CODE                      */
*           FBQESPTR=PQESEPTR;      /* MUST START AT TOP OF QUEUE  0375
*                                      EACH TIME LOCK IS RELEASED  0375
*                                                            @ZA10826*/
         LR    FBQESPTR,PQESEPTR                                   0375
*           GOTO NEXTFBQE;          /* GET NEXT FBQE AFTER DISABLE   */
         B     NEXTFBQE                                            0376
*         END;                                                     0377
*       RETCODE=0;                  /* INDICATE GOOD RETURN          */
@RF00331 SLR   RETCODE,RETCODE                                     0378
*                                                                  0379
*       /*************************************************************/
*       /*                                                           */
*       /* FORMAT THE TCB SUMMARY                            @G33SPHW*/
*       /*                                                           */
*       /*************************************************************/
*                                                                  0379
*AD05SUMM:                                                         0379
*       ASCBPTR=PSAAOLD;            /* GET CURRENT ASCB      @G33SPHW*/
AD05SUMM L     ASCBPTR,PSAAOLD                                     0379
*       ASXBPTR=ASCBASXB;           /* GET ASXB FROM ASCB    @G33SPHW*/
         L     ASXBPTR,ASCBASXB(,ASCBPTR)                          0380
*       TCBPTR=ASXBFTCB;            /* GET TCB ANCHOR TCB    @G33SPHW*/
         L     TCBPTR,ASXBFTCB(,ASXBPTR)                           0381
*       ABDLINEA(1)='0';            /* DOUBLE SPACE          @G33SPHW*/
         MVI   ABDLINEA(ABDARPTR),C'0'                             0382
*       ABDLINEA(40:56)=SUMHEAD;    /* PUT SUMMARY HEADING IN OUTPUT
*                                      BUFFER                @G33SPHW*/
         MVC   ABDLINEA+39(17,ABDARPTR),SUMHEAD                    0383
*       PARMPTR=ABDARPTR;           /* PUT IHAABDA ADDRESS IN R1.  0384
*                                                            @G33SPHW*/
         LR    PARMPTR,ABDARPTR                                    0384
*       CALL IEAVAD11;              /* OUTPUT HEADER         @G33SPHW*/
         L     @15,@CV00114                                        0385
         BALR  @14,@15                                             0385
*       ABDLINEA(43:53)=SUMUNDER;   /* PUT SUMMARY HEADING UNDERLINE
*                                      IN BUF                @G33SPHW*/
         MVC   ABDLINEA+42(11,ABDARPTR),SUMUNDER                   0386
*       PARMPTR=ABDARPTR;           /* PUT IHAABDA ADDRESS IN R1.  0387
*                                                            @G33SPHW*/
         LR    PARMPTR,ABDARPTR                                    0387
*       CALL IEAVAD11;              /* OUTPUT HEADER         @G33SPHW*/
         L     @15,@CV00114                                        0388
         BALR  @14,@15                                             0388
*       DO WHILE TCBPTR^=0;         /* PUT A SUMMARY OUT FOR ALL   0389
*                                      JOBSTEP TCB'S         @G33SPHW*/
         B     @DE00389                                            0389
@DL00389 DS    0H                                                  0390
*         ENTRYTCB=TCBPTR;          /* PUT TCB ADDRESS IN WORKAREA.
*                                                            @G33SPHW*/
         ST    TCBPTR,ENTRYTCB                                     0390
*         ENTRYCMP=TCBCMP;          /* PUT COMPLETION CODE IN      0391
*                                      WORKAREA.             @G33SPHW*/
         MVC   ENTRYCMP(4),TCBCMP(TCBPTR)                          0391
*         ENTRYPKF=TCBPKF;          /* PUT PROTECTION FLAGS IN     0392
*                                      WORKAREA.             @G33SPHW*/
         MVC   ENTRYPKF(1),TCBPKF(TCBPTR)                          0392
*         ENTRYFLG=TCBFLGS;         /* PUT FLAG BYTES IN ENTRY     0393
*                                                            @G33SPHW*/
         MVC   ENTRYFLG(5),TCBFLGS(TCBPTR)                         0393
*         ENTRYLMP=TCBLMP;          /* LIMIT PRIORITY        @G33SPHW*/
         MVC   ENTRYLMP(1),TCBLMP(TCBPTR)                          0394
*         ENTRYDS=TCBDSP;           /* PUT DISPATCHABILITY FLAGS IN
*                                      WORKAREA.             @G33SPHW*/
         MVC   ENTRYDS(1),TCBDSP(TCBPTR)                           0395
*         ENTRYSDY=TCBSCNDY;        /* PUT SECONDARY DISPATCH FLAGS
*                                      IN WORKAREA           @G33SPHW*/
         MVC   ENTRYSDY(4),TCBSCNDY(TCBPTR)                        0396
*         ENTRYRTM=TCBRTWA;         /* PUT RTM2WA ADDRESS IN       0397
*                                      WORKAREA.             @G33SPHW*/
         MVC   ENTRYRTM(4),TCBRTWA(TCBPTR)                         0397
*         ENTFBYT1=TCBFBYT1;        /* PUT TCB FLAGS IN WORKAREA.  0398
*                                                            @G33SPHW*/
         MVC   ENTFBYT1(1),TCBFBYT1(TCBPTR)                        0398
*         ENTFBYT2=TCBFBYT2;        /* FLAG BYTE ONE         @G33SPHW*/
         MVC   ENTFBYT2(1),TCBFBYT2(TCBPTR)                        0399
*         ENTRESV=0;                /* RESERVED              @G33SPHW*/
         SLR   @14,@14                                             0400
         STH   @14,ENTRESV                                         0400
*         ABDWORK(1:28)=TCBENTRY;   /* PUT TCB ENTRY INTO WORKAREA 0401
*                                                            @G33SPHW*/
         MVC   ABDWORK(28,ABDARPTR),TCBENTRY                       0401
*         ABDBPTR=ADDR(ABDWORKB);   /* POINT TO ADDRESS      @G33SPHW*/
         LA    @14,ABDWORKB(,ABDARPTR)                             0402
         ST    @14,ABDBPTR(,ABDARPTR)                              0402
*         ABDLLINE=ADDR(SUMLINE);   /* FORMAT PATTERN        @G33SPHW*/
         LA    @14,SUMLINE                                         0403
         ST    @14,ABDLLINE(,ABDARPTR)                             0403
*         PARMPTR=ABDARPTR;         /* POINT R1 TO PARMLIST  @G33SPHW*/
         LR    PARMPTR,ABDARPTR                                    0404
*         CALL IEAVAD31;            /* FORMAT THE SUMMARY    @G33SPHW*/
         L     @15,@CV00115                                        0405
         BALR  @14,@15                                             0405
*         IF RETCODE^=0 THEN        /* FORMAT ERROR          @G33SPHW*/
         LTR   RETCODE,RETCODE                                     0406
         BNZ   @RT00406                                            0406
*           GOTO FREERET;           /* CLEANUP AND EXIT      @G33SPHW*/
*         CALL IEAVAD11;            /* PRINT LINE            @G33SPHW*/
         L     @15,@CV00114                                        0408
         BALR  @14,@15                                             0408
*         TCBPTR=TCBTCB;            /* GET NEXT TCB ADDR     @G33SPHW*/
         L     TCBPTR,TCBTCB(,TCBPTR)                              0409
*       END;                        /* END DO WHILE          @G33SPHW*/
@DE00389 LTR   TCBPTR,TCBPTR                                       0410
         BNZ   @DL00389                                            0410
*FREERET:                                                          0411
*       SAVERET=RETCODE;            /* SET UP RETURN CODE            */
*                                                                  0411
FREERET  LR    SAVERET,RETCODE                                     0411
*       /*************************************************************/
*       /*                                                           */
*       /* SET UP FREEMAIN LIST REGISTER                             */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0412
*FREEBAD:                           /* BAD CODE IN SAVERET           */
*       PARMPTR=ADDR(ABDASIZE);                                    0412
FREEBAD  LA    PARMPTR,ABDASIZE(,ABDARPTR)                         0412
*       ABDAAREA=SAVEPTR;           /* SET UP ADDRESS TO FREE        */
         ST    SAVEPTR,ABDAAREA(,ABDARPTR)                         0413
*       SAVEPTR=SAVEPTR->PRESAPTR;  /* SET UP PREVIOUS SAVE AREA     */
         L     SAVEPTR,PRESAPTR(,SAVEPTR)                          0414
*       NEXSAPTR=0;                 /* CLEAR POINTER TO AREA TO BE 0415
*                                      FREED                         */
         SLR   @14,@14                                             0415
         ST    @14,NEXSAPTR(,SAVEPTR)                              0415
*       GENERATE;                                                  0416
         FREEMAIN E,LV=@ENDDATD-@DATD+72,                              *
               SP=253,                                                 *
               A=ABDGMA(ABDARPTR),                                     *
               MF=(E,(1))
*       RETCODE=SAVERET;            /* SET UP RETURN CODE            */
         LR    RETCODE,SAVERET                                     0417
*     END;                          /*                        @Y02705*/
*   DCL                                                            0419
*     PATCHLOC FIXED(31) STATIC;                                   0419
*   GEN DATA DEFS(PATCHLOC);                                       0420
*   DECLARE                         /* COMMON VARIABLES              */
*     I256C CHAR(256) BASED,                                       0421
*     I031F FIXED(31) BASED,                                       0421
*     I031P PTR(31) BASED,                                         0421
*     I015F FIXED(15) BASED,                                       0421
*     I015P PTR(15) BASED,                                         0421
*     I008P PTR(8) BASED,                                          0421
*     I001C CHAR(1) BASED;                                         0421
*   END IEAVAD05                                                   0422
*                                                                  0422
*/* THE FOLLOWING INCLUDE STATEMENTS WERE FOUND IN THIS PROGRAM.     */
*/*%INCLUDE SYSLIB  (IHAABDA )                                       */
*/*%INCLUDE SYSLIB  (IHAASCB )                                       */
*/*%INCLUDE SYSLIB  (IHAASXB )                                       */
*/*%INCLUDE SYSLIB  (CVT     )                                       */
*/*%INCLUDE SYSLIB  (IHAPSA  )                                       */
*/*%INCLUDE SYSLIB  (IHARTCT )                                       */
*/*%INCLUDE SYSLIB  (IKJTCB  )                                       */
*/*%INCLUDE SYSLIB  (IHAIQE  )                                       */
*/*%INCLUDE SYSLIB  (IHASPQE )                                       */
*/*%INCLUDE SYSLIB  (IHADQE  )                                       */
*/*%INCLUDE SYSLIB  (IHAFQE  )                                       */
*/*%INCLUDE SYSLIB  (IHAPQE  )                                       */
*/*%INCLUDE SYSLIB  (IHAFBQE )                                       */
*                                                                  0422
*       ;                                                          0422
         B     @EL00001                                            0422
@DATA    DS    0H
@CH00060 DC    H'9'
@DATD    DSECT
         DS    0F
IEAVAD05 CSECT
         DS    0F
@DATD    DSECT
         DS    0D
SAVESPQE DS    A
TCBENTRY DS    CL28
         ORG   TCBENTRY
ENTRYTCB DS    FL4
ENTRYCMP DS    CL4
ENTRYDSP DS    CL8
         ORG   ENTRYDSP
ENTRYPKF DS    CL1
ENTRYFLG DS    CL5
ENTRYLMP DS    AL1
ENTRYDS  DS    AL1
         ORG   TCBENTRY+16
ENTRYSDY DS    CL4
ENTRYRTM DS    FL4
ENTRYFBY DS    CL4
         ORG   ENTRYFBY
ENTFBYT1 DS    CL1
ENTFBYT2 DS    CL1
ENTRESV  DS    CL2
         ORG   TCBENTRY+28
TESTBITS DS    CL1
         ORG   TESTBITS
HEADBIT  DS    BL1
DFHDR    EQU   TESTBITS+0
         ORG   TESTBITS+1
IEAVAD05 CSECT
         DS    0F
@SIZDATD DC    AL1(0)
         DC    AL3(@ENDDATD-@DATD)
@CV00114 DC    V(IEAVAD11)
@CV00115 DC    V(IEAVAD31)
@CV00116 DC    V(IEAVAD61)
         DS    0D
SUMLINE  DS    CL45
         ORG   SUMLINE
@NM00001 DC    X'005201'
@NM00002 DC    CL6'TCB AT'
@NM00003 DC    X'2331'
@NM00004 DC    CL3'CMP'
@NM00005 DC    X'6341'
@NM00006 DC    CL7'PKF-FLG'
@NM00007 DC    X'2341'
@NM00008 DC    CL3'DSP'
@NM00009 DC    X'2341'
@NM00010 DC    CL3'SDY'
@NM00011 DC    X'2341'
@NM00012 DC    CL3'RTM'
@NM00013 DC    X'3341'
@NM00014 DC    CL4'FBYT'
@NM00015 DC    X'FF'
         ORG   SUMLINE+45
SUMHEAD  DC    CL17'***TCB SUMMARY***'
SUMUNDER DC    CL11'-----------'
IQEMSG   DC    CL4'-IQE'
VSMMSG   DC    CL4'-VSM'
SPQEL    DC    CL4'SPQE'
DQEL     DC    CL3'DQE'
NSPQEL   DC    CL5'NSPQE'
FLRSL    DC    CL5'FL/RS'
SPIDL    DC    CL4'SPID'
KEYL     DC    CL3'KEY'
RESVL    DC    CL4'RESV'
IQELLINE DS    CL41
         ORG   IQELLINE
@NM00016 DC    X'030200'
@NM00017 DC    CL1' '
@NM00018 DC    X'FF'
@NM00019 DC    X'0D3301'
@NM00020 DC    CL4'LINK'
@NM00021 DC    X'3341'
@NM00022 DC    CL4'PARM'
@NM00023 DC    X'2342'
@NM00024 DC    CL3'IRB'
@NM00025 DC    X'2342'
@NM00026 DC    CL3'TCB'
@NM00027 DC    X'3341'
@NM00028 DC    CL4'DCB '
@NM00029 DC    X'3341'
@NM00030 DC    CL4'OTLM'
@NM00031 DC    X'FF'
         ORG   IQELLINE+41
SPQELLIN DS    CL13
         ORG   SPQELLIN
@NM00032 DC    X'0803'
@NM00033 DC    X'1703'
@NM00034 DC    X'2503'
@NM00035 DC    X'3501'
@NM00036 DC    X'4101FF'
         ORG   SPQELLIN+13
DQELLINE DS    CL57
         ORG   DQELLINE
@NM00037 DC    X'003200'
@NM00038 DC    CL4'DQE '
@NM00039 DC    X'FF'
@NM00040 DC    X'0B2211'
@NM00041 DC    CL3'FQE'
@NM00042 DC    X'3241'
@NM00043 DC    CL4'NDQE'
@NM00044 DC    X'2331'
@NM00045 DC    CL3'BLK'
@NM00046 DC    X'1341'
@NM00047 DC    CL2'LN'
@NM00048 DC    X'FF'
FQE1LINE DS    CL19
         ORG   FQE1LINE
@NM00049 DC    X'3F3200'
@NM00050 DC    CL4'FQE '
@NM00051 DC    X'FF'
@NM00052 DC    X'4B2301'
@NM00053 DC    CL3'FQE'
@NM00054 DC    X'1341'
@NM00055 DC    CL2'LN'
@NM00056 DC    X'FF'
         ORG   DQELLINE+49
FQE2LINE DS    CL8
         ORG   FQE2LINE
@NM00057 DC    X'663301'
@NM00058 DC    CL4'AREA'
@NM00059 DC    X'FF'
         ORG   DQELLINE+57
DPQELINE DS    CL24
         ORG   DPQELINE
@NM00060 DC    X'004202'
@NM00061 DC    CL5'D-PQE'
@NM00062 DC    X'FF'
@NM00063 DC    X'134301'
@NM00064 DC    CL5'FIRST'
@NM00065 DC    X'FF'
         ORG   DPQELINE+24
PQELLINE DS    CL51
         ORG   PQELLINE
@NM00066 DC    X'002202'
@NM00067 DC    CL3'PQE'
@NM00068 DC    X'FF'
@NM00069 DC    X'0E2301'
@NM00070 DC    CL3'FFB'
@NM00071 DC    X'2341'
@NM00072 DC    CL3'LFB'
@NM00073 DC    X'2341'
@NM00074 DC    CL3'NPQ'
@NM00075 DC    X'2341'
@NM00076 DC    CL3'PPQ'
@NM00077 DC    X'FF'
@NM00078 DC    X'0E2341'
@NM00079 DC    CL3'TCB'
@NM00080 DC    X'2341'
@NM00081 DC    CL3'RSI'
@NM00082 DC    X'2341'
@NM00083 DC    CL3'RAD'
@NM00084 DC    X'2341'
@NM00085 DC    CL3'FLG'
@NM00086 DC    X'FF'
         ORG   PQELLINE+51
FBQELINE DS    CL29
         ORG   FBQELINE
@NM00087 DC    X'003201'
@NM00088 DC    CL4'FBQE'
@NM00089 DC    X'2331'
@NM00090 DC    CL3'NFB'
@NM00091 DC    X'2341'
@NM00092 DC    CL3'PFB'
@NM00093 DC    X'1342'
@NM00094 DC    CL2'SZ'
@NM00095 DC    X'3341'
@NM00096 DC    CL4'AREA'
@NM00097 DC    X'FF'
         ORG   FBQELINE+29
IEAVAD05 CSECT
         DS   0H
PATCHLOC DC ((@DATA-@PSTART)/20)X'00'
@DATD    DSECT
         ORG   *+1-(*-@DATD)/(*-@DATD) INSURE DSECT DATA
@ENDDATD EQU   *
IEAVAD05 CSECT
@00      EQU   00                      EQUATES FOR REGISTERS 0-15
@01      EQU   01
@02      EQU   02
@03      EQU   03
@04      EQU   04
@05      EQU   05
@06      EQU   06
@07      EQU   07
@08      EQU   08
@09      EQU   09
@10      EQU   10
@11      EQU   11
@12      EQU   12
@13      EQU   13
@14      EQU   14
@15      EQU   15
PARMPTR  EQU   @01
ABDARPTR EQU   @02
IQEPTR   EQU   @03
IQEPTR31 EQU   @03
ASCBPTR  EQU   @03
ASXBPTR  EQU   @03
SPQESPTR EQU   @03
PQESEPTR EQU   @03
DQESEPTR EQU   @04
CONVERT  EQU   @04
FBQESPTR EQU   @04
TCBPTR   EQU   @05
FQESEPTR EQU   @06
HIGH     EQU   @06
SAVERET  EQU   @07
OTCSPQE  EQU   @07
OTCTCB   EQU   @08
CVTPTR   EQU   @09
AUTOPTR  EQU   @12
SAVEPTR  EQU   @13
RETCODE  EQU   @15
RETERN   EQU   @14
PSA      EQU   0
FLCRNPSW EQU   PSA
FLCROPSW EQU   PSA+8
FLCICCW2 EQU   PSA+16
PSAEEPSW EQU   PSA+132
PSAESPSW EQU   PSA+136
FLCSVILC EQU   PSAESPSW+1
PSAEPPSW EQU   PSA+140
FLCPIILC EQU   PSAEPPSW+1
FLCPICOD EQU   PSAEPPSW+2
PSAPICOD EQU   FLCPICOD+1
FLCTEA   EQU   PSAEPPSW+4
FLCPER   EQU   PSA+152
FLCMCLA  EQU   PSA+168
FLCIOEL  EQU   FLCMCLA+4
FLCIOA   EQU   FLCMCLA+16
FLCFSA   EQU   FLCMCLA+80
PSAAOLD  EQU   PSA+548
PSASUPER EQU   PSA+552
PSASUP1  EQU   PSASUPER
PSASUP2  EQU   PSASUPER+1
PSASUP3  EQU   PSASUPER+2
PSASUP4  EQU   PSASUPER+3
PSACLHT  EQU   PSA+640
PSALKSA  EQU   PSA+696
PSAHLHI  EQU   PSA+760
PSALITA  EQU   PSA+764
PSADSSFL EQU   PSA+836
PSADSSF1 EQU   PSADSSFL
PSADSSF3 EQU   PSADSSFL+2
PSADSSF4 EQU   PSADSSFL+3
PSARSVT  EQU   PSA+896
NEXSAPTR EQU   8
PRESAPTR EQU   4
ABDAREA  EQU   0
ABDTCB   EQU   ABDAREA
ABDCTCB  EQU   ABDAREA+4
ABDPARMS EQU   ABDAREA+12
ABDFLAG  EQU   ABDPARMS+1
APFSDATA EQU   ABDPARMS+4
APFSDAT1 EQU   ABDPARMS+5
APFPDATA EQU   ABDPARMS+6
ABDPTRS  EQU   ABDAREA+84
ABDWORK1 EQU   ABDAREA+120
ABDFLAG1 EQU   ABDAREA+136
ABDFLAG2 EQU   ABDAREA+137
ABDSTAT  EQU   ABDFLAG2
ABDRES1  EQU   ABDAREA+139
ABDWORK  EQU   ABDAREA+140
ABDBPTR  EQU   ABDAREA+244
ABDLLINE EQU   ABDAREA+248
ABDUPRF  EQU   ABDAREA+265
ABDUPRFN EQU   ABDAREA+266
ABDBLNKS EQU   ABDAREA+267
ABDBUFFS EQU   ABDAREA+308
ABDGMA   EQU   ABDAREA+316
ABDAAREA EQU   ABDGMA
ABDASIZE EQU   ABDGMA+4
ESPARM   EQU   ABDAREA+340
ESTAEFLG EQU   ESPARM+28
ABDLINEA EQU   ABDAREA+384
ABDCC    EQU   ABDLINEA
ASCB     EQU   0
ASCBSUPC EQU   ASCB+16
ASCBFW1  EQU   ASCB+100
ASCBRCTF EQU   ASCBFW1+2
ASCBFLG1 EQU   ASCBFW1+3
ASCBASXB EQU   ASCB+108
ASCBDSP1 EQU   ASCB+114
ASCBFLG2 EQU   ASCB+115
ASCBLKGP EQU   ASCB+128
ASCBSRQ  EQU   ASCB+180
ASCBSRQ1 EQU   ASCBSRQ
ASCBSRQ2 EQU   ASCBSRQ+1
ASCBSRQ3 EQU   ASCBSRQ+2
ASCBSRQ4 EQU   ASCBSRQ+3
ASXB     EQU   0
ASXBFTCB EQU   ASXB+4
ASXBAEQ  EQU   ASXB+168
ASXBFIQE EQU   ASXBAEQ
ASXBSECR EQU   ASXB+199
ASCBSFLG EQU   ASXBSECR
ASXBCASW EQU   ASXB+216
ASXBCRB1 EQU   ASXBCASW
CVTMAP   EQU   0
CVTDAR   EQU   CVTMAP+72
CVTFLGS1 EQU   CVTDAR
CVTDCB   EQU   CVTMAP+116
CVTIERLC EQU   CVTMAP+144
CVTOPTA  EQU   CVTMAP+182
CVTOPTB  EQU   CVTMAP+183
CVTGTF   EQU   CVTMAP+236
CVTGTFST EQU   CVTGTF
CVTGTFS  EQU   CVTGTFST
CVTSTATE EQU   CVTGTFST
CVTTMODE EQU   CVTGTFST
CVTFORM  EQU   CVTGTFST
CVTAQAVT EQU   CVTMAP+240
CVTTCMFG EQU   CVTAQAVT
CVTVOLM2 EQU   CVTMAP+244
CVTTATA  EQU   CVTVOLM2
CVTTSKS  EQU   CVTTATA
CVTVOLF2 EQU   CVTTSKS
CVTTAT   EQU   CVTTATA+1
CVTATER  EQU   CVTMAP+248
CVTEXT1  EQU   CVTMAP+252
CVTPURG  EQU   CVTMAP+260
CVTQMSG  EQU   CVTMAP+268
CVTDMSR  EQU   CVTMAP+272
CVTRSV37 EQU   CVTDMSR
CVTDMSRF EQU   CVTRSV37
CVTERPV  EQU   CVTMAP+316
CVTINTLA EQU   CVTMAP+320
CVTAPF   EQU   CVTMAP+324
CVTEXT2  EQU   CVTMAP+328
CVTHJES  EQU   CVTMAP+332
CVTPGSIA EQU   CVTMAP+348
CVTA1F1  EQU   CVTMAP+356
CVTSYSK  EQU   CVTMAP+357
CVTVOLM1 EQU   CVTMAP+380
CVTVOLF1 EQU   CVTVOLM1
CVTXTNT1 EQU   0
CVTXTNT2 EQU   0
CVTDSSV  EQU   CVTXTNT2
CVTFLGBT EQU   CVTXTNT2+5
CVTQID   EQU   CVTXTNT2+24
CVTRV400 EQU   CVTXTNT2+52
CVTRV409 EQU   CVTXTNT2+53
CVTATCVT EQU   CVTXTNT2+64
CVTRV429 EQU   CVTXTNT2+84
CVTRV438 EQU   CVTXTNT2+85
CVTRV457 EQU   CVTXTNT2+112
CVTRV466 EQU   CVTXTNT2+113
CVTFIX   EQU   0
CVTRELNO EQU   CVTFIX+252
RTCT     EQU   0
RTCTPLIB EQU   RTCT+4
RTCTSAP  EQU   RTCTPLIB
RTCTSAP1 EQU   RTCTSAP
RTCTSAP2 EQU   RTCTSAP+1
RTCTSAP3 EQU   RTCTSAP+2
RTCTSUP  EQU   RTCTPLIB+4
RTCTSUP1 EQU   RTCTSUP
RTCTSUP2 EQU   RTCTSUP+1
RTCTSUP3 EQU   RTCTSUP+2
RTCTSYD  EQU   RTCTPLIB+8
RTCTSY01 EQU   RTCTSYD
RTCTSDDS EQU   RTCT+36
RTCTFLG  EQU   RTCTSDDS+3
RTCTSDPL EQU   RTCT+156
RTCTRFLG EQU   RTCT+176
RTCTERID EQU   RTCT+224
RTCTOPT  EQU   RTCT+236
RTCTASO  EQU   RTCT+252
RTCTASO1 EQU   RTCTASO
RTCTASO2 EQU   RTCTASO+1
RTCTSDI  EQU   RTCT+254
RTCTSDF  EQU   RTCT+264
RTCTSDF1 EQU   RTCTSDF
RTCTSDF2 EQU   RTCTSDF+1
RTCTSDF3 EQU   RTCT+268
RTCTSDF4 EQU   RTCTSDF3+2
RTCTMOPT EQU   0
RTCTMSAO EQU   RTCTMOPT
RTCTSASD EQU   RTCTMSAO
RTCTSAO1 EQU   RTCTSASD
RTCTSAO2 EQU   RTCTSASD+1
RTCTSAPD EQU   RTCTMSAO+2
RTCTSAO3 EQU   RTCTSAPD
RTCTSAO4 EQU   RTCTSAPD+1
RTCTSAMG EQU   RTCTSAO4
RTCTMSUO EQU   RTCTMOPT+4
RTCTSUSD EQU   RTCTMSUO
RTCTSUO1 EQU   RTCTSUSD
RTCTSUO2 EQU   RTCTSUSD+1
RTCTSUPD EQU   RTCTMSUO+2
RTCTSUO3 EQU   RTCTSUPD
RTCTSUO4 EQU   RTCTSUPD+1
RTCTSUMG EQU   RTCTSUO4
RTCTMSYO EQU   RTCTMOPT+8
RTCTSD01 EQU   RTCTMSYO
RTCTSD04 EQU   RTCTMSYO+3
RTCTSMMG EQU   RTCTSD04
RTCTMSDO EQU   RTCTMOPT+12
RTCTSDOD EQU   RTCTMSDO
RTCTSDO1 EQU   RTCTSDOD
RTCTSDO2 EQU   RTCTSDOD+1
RTCTSDO3 EQU   RTCTMSDO+2
RTCTSDO4 EQU   RTCTMSDO+3
RTCTSDMG EQU   RTCTSDO4
TCBFIX   EQU   0
TCBFRS   EQU   TCBFIX
TCB      EQU   0
TCBPIE   EQU   TCB+4
TCBPMASK EQU   TCBPIE
TCBCMP   EQU   TCB+16
TCBCMPF  EQU   TCBCMP
TCBCPP   EQU   TCBCMPF
TCBSTCC  EQU   TCBCMPF
TCBCDBL  EQU   TCBCMPF
TCBCWTO  EQU   TCBCMPF
TCBCIND  EQU   TCBCMPF
TCBCMSG  EQU   TCBCMPF
TCBTRN   EQU   TCB+20
TCBABF   EQU   TCBTRN
TCBMSS   EQU   TCB+24
TCBPKF   EQU   TCB+28
TCBFLAG  EQU   TCBPKF
TCBFLGS  EQU   TCB+29
TCBFLGS1 EQU   TCBFLGS
TCBFLGS2 EQU   TCBFLGS+1
TCBFLGS3 EQU   TCBFLGS+2
TCBFLGS4 EQU   TCBFLGS+3
TCBFLGS5 EQU   TCBFLGS+4
TCBFC    EQU   TCBFLGS5
TCBABWF  EQU   TCBFLGS5
TCBLMP   EQU   TCB+34
TCBDSP   EQU   TCB+35
TCBJPQ   EQU   TCB+44
TCBPURGE EQU   TCBJPQ
TCBGRS   EQU   TCB+48
TCBFSA   EQU   TCB+112
TCBTCB   EQU   TCB+116
TCBTME   EQU   TCB+120
TCBJSTCB EQU   TCB+124
TCBOTC   EQU   TCB+132
TCBLTC   EQU   TCB+136
TCBTSFLG EQU   TCB+148
TCBTSTSK EQU   TCBTSFLG
TCBPQE   EQU   TCB+152
TCBSTAB  EQU   TCB+160
TCBNSTAE EQU   TCBSTAB
TCBTCT   EQU   TCB+164
TCBTCTGF EQU   TCBTCT
TCBSCNDY EQU   TCB+172
TCBNDSP  EQU   TCBSCNDY
TCBNDSP1 EQU   TCBNDSP+1
TCBNDSP2 EQU   TCBNDSP+2
TCBNDSP3 EQU   TCBNDSP+3
TCBJSCB  EQU   TCB+180
TCBRECDE EQU   TCBJSCB
TCBEXT1  EQU   TCB+196
TCBBITS  EQU   TCB+200
TCBNDSP4 EQU   TCBBITS
TCBNDSP5 EQU   TCBBITS+1
TCBFLGS6 EQU   TCBBITS+2
TCBFLGS7 EQU   TCBBITS+3
TCBADMP  EQU   TCBFLGS7
TCBDAR   EQU   TCB+204
TCBDARC  EQU   TCBDAR
TCBEXT2  EQU   TCB+208
TCBRTWA  EQU   TCB+224
TCBXSCT  EQU   TCB+240
TCBXSCT1 EQU   TCBXSCT
TCBFOE   EQU   TCB+244
TCBESTAE EQU   TCB+264
TCBESTRM EQU   TCBESTAE+1
TCBFBYT1 EQU   TCB+276
TCBFBYT2 EQU   TCB+277
TCBRV124 EQU   TCB+278
TCBRV133 EQU   TCB+279
TCBXTNT2 EQU   0
TCBGTF   EQU   TCBXTNT2
TCBTFLG  EQU   TCBGTF
TCBRV146 EQU   TCBXTNT2+28
TCBRV155 EQU   TCBXTNT2+29
TCBRV164 EQU   TCBXTNT2+30
TCBRV173 EQU   TCBXTNT2+31
IQESECT  EQU   0
IQELNK   EQU   IQESECT
IQELNKA  EQU   IQELNK+1
IQEIRB   EQU   IQESECT+8
IQEFLAGS EQU   IQEIRB
IQEPURGE EQU   IQEFLAGS
IQETCB   EQU   IQESECT+12
SPQESECT EQU   0
SPQEAD   EQU   SPQESECT
SPQEPTR  EQU   SPQEAD
SPDQEPTR EQU   SPQESECT+4
SPDQEAD  EQU   SPDQEPTR
SPQEFLGS EQU   SPQESECT+8
SPSHARE  EQU   SPQEFLGS
SPQEID   EQU   SPQESECT+10
SPQEKEY  EQU   SPQESECT+11
DQESECT  EQU   0
DQFQEPTR EQU   DQESECT
DQEPTR   EQU   DQESECT+4
DQEBLKAD EQU   DQESECT+8
FQESECT  EQU   0
FQEPTR   EQU   FQESECT
FQTYPE   EQU   FQEPTR
FQERGNFL EQU   FQTYPE
FQEPTRA  EQU   FQEPTR+1
PQESECT  EQU   0
PQEFPQE  EQU   PQESECT+8
VMMFLGS  EQU   PQESECT+30
FBQESECT EQU   0
FWDPTR   EQU   FBQESECT
SIZE     EQU   FBQESECT+8
FBQAREA  EQU   FBQESECT+12
IQEEND   EQU   0
I001C    EQU   0
I008P    EQU   0
I015F    EQU   0
I015P    EQU   0
I031F    EQU   0
I031P    EQU   0
I256C    EQU   0
CVDID    EQU   ABDWORK1+6
ABDWORKA EQU   ABDWORK
ABDWORKB EQU   ABDWORK+1
SPQEWORK EQU   ABDWORK
SPQEAFLD EQU   SPQEWORK
NSPQEFLD EQU   SPQEWORK+4
DQEWORD  EQU   SPQEWORK+8
@NM00124 EQU   SPQEWORK+12
FLAGRES  EQU   @NM00124
SPIDN    EQU   @NM00124+2
CVTS01   EQU   CVTPGSIA
CVTLPDIA EQU   CVTS01+12
CVTDIRST EQU   CVTLPDIA
CVTSLIDA EQU   CVTS01+24
CVTCTLFG EQU   CVTS01+50
CVTRTMCT EQU   CVTS01+224
CVTRV210 EQU   CVTS01+424
CVTRV219 EQU   CVTS01+425
CVTRV228 EQU   CVTS01+426
CVTRV237 EQU   CVTS01+427
CVTMFRTR EQU   CVTS01+452
CVTRV262 EQU   CVTS01+468
CVTRV271 EQU   CVTS01+469
CVTRV280 EQU   CVTS01+470
CVTRV289 EQU   CVTS01+471
CVTGSDA  EQU   CVTS01+600
PSARSVTE EQU   PSARSVT
ABDWRK11 EQU   ABDWORK1
CVDKEY   EQU   ABDWORK1+7
FLC      EQU   PSA
         AGO   .@UNREFD                START UNREFERENCED COMPONENTS
PSARSAV  EQU   PSARSVTE+60
PSARSTK  EQU   PSARSVTE+56
PSAESAV3 EQU   PSARSVTE+52
PSAESTK3 EQU   PSARSVTE+48
PSAESAV2 EQU   PSARSVTE+44
PSAESTK2 EQU   PSARSVTE+40
PSAESAV1 EQU   PSARSVTE+36
PSAESTK1 EQU   PSARSVTE+32
PSAPSAV  EQU   PSARSVTE+28
PSAPSTK  EQU   PSARSVTE+24
PSAMSAV  EQU   PSARSVTE+20
PSAMSTK  EQU   PSARSVTE+16
PSASSAV  EQU   PSARSVTE+12
PSASSTK  EQU   PSARSVTE+8
PSANSTK  EQU   PSARSVTE+4
PSACSTK  EQU   PSARSVTE
CVTRV628 EQU   CVTS01+728
CVTRV627 EQU   CVTS01+724
CVTRV626 EQU   CVTS01+720
CVTRV625 EQU   CVTS01+716
CVTRV624 EQU   CVTS01+712
CVTRV623 EQU   CVTS01+708
CVTRV622 EQU   CVTS01+704
CVTRV621 EQU   CVTS01+700
CVTIHASU EQU   CVTS01+696
CVTSUSP  EQU   CVTS01+692
CVTT6SVC EQU   CVTS01+688
CVTCDAL  EQU   CVTS01+684
CVTTCTL  EQU   CVTS01+680
CVTRSUME EQU   CVTS01+676
CVTJTERM EQU   CVTS01+672
CVTASMRM EQU   CVTS01+668
CVTTCASP EQU   CVTS01+664
CVT0PT03 EQU   CVTS01+660
CVT0PT0E EQU   CVTS01+656
CVTRV609 EQU   CVTS01+652
CVTCGK   EQU   CVTS01+648
CVTRAC   EQU   CVTS01+644
CVTRV606 EQU   CVTS01+640
CVTRV605 EQU   CVTS01+636
CVTRV604 EQU   CVTS01+632
CVTEFF02 EQU   CVTS01+628
CVTCBBR  EQU   CVTS01+624
CVTSSCR  EQU   CVTS01+620
CVTEVENT EQU   CVTS01+616
CVTCRCA  EQU   CVTS01+612
CVTTPIO  EQU   CVTS01+608
CVTADV   EQU   CVTS01+604
CVTGSDAB EQU   CVTGSDA
CVTQV3   EQU   CVTS01+596
CVTQV2   EQU   CVTS01+592
CVTQV1   EQU   CVTS01+588
CVTRPT   EQU   CVTS01+584
CVTSSRB  EQU   CVTS01+580
CVTCSDRL EQU   CVTS01+576
CVTEXP1  EQU   CVTS01+572
CVTRMPMT EQU   CVTS01+568
CVTRMPTT EQU   CVTS01+564
CVTVPSA  EQU   CVTS01+560
CVTVSTOP EQU   CVTS01+556
CVTGTFR8 EQU   CVTS01+552
CVTQUIT  EQU   CVTS01+548
CVTVACR  EQU   CVTS01+544
CVTWTCB  EQU   CVTS01+540
CVTSTPRS EQU   CVTS01+536
CVT0PT02 EQU   CVTS01+532
CVTDARCM EQU   CVTS01+528
CVTIRECM EQU   CVTS01+524
CVTJRECM EQU   CVTS01+520
CVTVEMS0 EQU   CVTS01+516
CVTSPFRR EQU   CVTS01+512
CVTRLSTG EQU   CVTS01+508
CVT0TC0A EQU   CVTS01+504
CVTGMBR  EQU   CVTS01+500
CVTLFRM  EQU   CVTS01+496
CVTRMBR  EQU   CVTS01+492
CVTVIOP  EQU   CVTS01+488
CVTRV307 EQU   CVTS01+486
CVTRV306 EQU   CVTS01+484
CVTRV305 EQU   CVTS01+482
CVTRV304 EQU   CVTS01+480
CVTRV303 EQU   CVTS01+478
CVTRV302 EQU   CVTS01+476
CVTTRCA  EQU   CVTS01+472
CVTRV297 EQU   CVTRV289
CVTRV296 EQU   CVTRV289
CVTRV295 EQU   CVTRV289
CVTRV294 EQU   CVTRV289
CVTRV293 EQU   CVTRV289
CVTRV292 EQU   CVTRV289
CVTRV291 EQU   CVTRV289
CVTRV290 EQU   CVTRV289
CVTRV288 EQU   CVTRV280
CVTRV287 EQU   CVTRV280
CVTRV286 EQU   CVTRV280
CVTRV285 EQU   CVTRV280
CVTRV284 EQU   CVTRV280
CVTRV283 EQU   CVTRV280
CVTRV282 EQU   CVTRV280
CVTRV281 EQU   CVTRV280
CVTRV279 EQU   CVTRV271
CVTRV278 EQU   CVTRV271
CVTRV277 EQU   CVTRV271
CVTRV276 EQU   CVTRV271
CVTRV275 EQU   CVTRV271
CVTRV274 EQU   CVTRV271
CVTRV273 EQU   CVTRV271
CVTRV272 EQU   CVTRV271
CVTRV270 EQU   CVTRV262
CVTRV269 EQU   CVTRV262
CVTRV268 EQU   CVTRV262
CVTRV267 EQU   CVTRV262
CVTRV266 EQU   CVTRV262
CVTRV265 EQU   CVTRV262
CVTRV264 EQU   CVTRV262
CVTRV263 EQU   CVTRV262
CVTVFP   EQU   CVTS01+464
CVTVSI   EQU   CVTS01+460
CVTVPSIB EQU   CVTS01+456
CVTMFACT EQU   CVTMFRTR
CVTMFCTL EQU   CVTS01+448
CVTPVBP  EQU   CVTS01+444
CVTPWI   EQU   CVTS01+440
CVTRV254 EQU   CVTS01+438
CVTRV253 EQU   CVTS01+436
CVTRV252 EQU   CVTS01+434
CVTRV251 EQU   CVTS01+433
CVTRV250 EQU   CVTS01+432
CVTRV249 EQU   CVTS01+431
CVTRV248 EQU   CVTS01+430
CVTRV247 EQU   CVTS01+429
CVTRV246 EQU   CVTS01+428
CVTRV245 EQU   CVTRV237
CVTRV244 EQU   CVTRV237
CVTRV243 EQU   CVTRV237
CVTRV242 EQU   CVTRV237
CVTRV241 EQU   CVTRV237
CVTRV240 EQU   CVTRV237
CVTRV239 EQU   CVTRV237
CVTRV238 EQU   CVTRV237
CVTRV236 EQU   CVTRV228
CVTRV235 EQU   CVTRV228
CVTRV234 EQU   CVTRV228
CVTRV233 EQU   CVTRV228
CVTRV232 EQU   CVTRV228
CVTRV231 EQU   CVTRV228
CVTRV230 EQU   CVTRV228
CVTRV229 EQU   CVTRV228
CVTRV227 EQU   CVTRV219
CVTRV226 EQU   CVTRV219
CVTRV225 EQU   CVTRV219
CVTRV224 EQU   CVTRV219
CVTRV223 EQU   CVTRV219
CVTRV222 EQU   CVTRV219
CVTRV221 EQU   CVTRV219
CVTRV220 EQU   CVTRV219
CVTRV218 EQU   CVTRV210
CVTRV217 EQU   CVTRV210
CVTRV216 EQU   CVTRV210
CVTRV215 EQU   CVTRV210
CVTRV214 EQU   CVTRV210
CVTRV213 EQU   CVTRV210
CVTRV212 EQU   CVTRV210
CVTRV211 EQU   CVTRV210
CVTLCCAT EQU   CVTS01+420
CVTPCCAT EQU   CVTS01+416
CVTIPCRP EQU   CVTS01+412
CVTIPCRI EQU   CVTS01+408
CVTIPCDS EQU   CVTS01+404
CVTAIDVT EQU   CVTS01+400
CVTSSAP  EQU   CVTS01+396
CVTEHCIR EQU   CVTS01+392
CVTEHDEF EQU   CVTS01+388
CVTDAIR  EQU   CVTS01+384
CVTPERFM EQU   CVTS01+380
CVT044R2 EQU   CVTS01+376
CVTFETCH EQU   CVTS01+372
CVTRSTWD EQU   CVTS01+368
CVTSPOST EQU   CVTS01+364
CVTIOBP  EQU   CVTS01+360
CVTASMVT EQU   CVTS01+356
CVTRECRQ EQU   CVTS01+352
CVTWSAC  EQU   CVTS01+348
CVTRV149 EQU   CVTS01+344
CVTWSAL  EQU   CVTS01+340
CVTSPSA  EQU   CVTS01+336
CVTGLMN  EQU   CVTS01+332
CVTVEAC0 EQU   CVTS01+328
CVT062R1 EQU   CVTS01+324
CVTRPOST EQU   CVTS01+320
CVTDQIQE EQU   CVTS01+316
CVTCSD   EQU   CVTS01+312
CVTLKRMA EQU   CVTS01+308
CVTRSPIE EQU   CVTS01+304
CVTRENQ  EQU   CVTS01+300
CVTLQCB  EQU   CVTS01+296
CVTFQCB  EQU   CVTS01+292
CVTQCS01 EQU   CVTS01+288
CVTAPFT  EQU   CVTS01+284
CVTPARRL EQU   CVTS01+280
CVTVWAIT EQU   CVTS01+276
CVTGSPL  EQU   CVTS01+272
CVTLSMQ  EQU   CVTS01+268
CVTGSMQ  EQU   CVTS01+264
CVTEXPRO EQU   CVTS01+260
CVTOPCTP EQU   CVTS01+256
CVTSIC   EQU   CVTS01+252
CVTTPIOS EQU   CVTS01+248
CVTRTMS  EQU   CVTS01+244
CVTSDBF  EQU   CVTS01+240
CVTSCBP  EQU   CVTS01+236
CVTSDMP  EQU   CVTS01+232
CVTSV60  EQU   CVTS01+228
CVTASCBL EQU   CVTS01+220
CVTASCBH EQU   CVTS01+216
CVTGDA   EQU   CVTS01+212
CVTASVT  EQU   CVTS01+208
CVTVVMDI EQU   CVTS01+204
CVTAQTOP EQU   CVTS01+200
CVTIOSCS EQU   CVTS01+196
CVTSDRM  EQU   CVTS01+192
CVTOPTE  EQU   CVTS01+188
CVTSTXU  EQU   CVTS01+184
CVTQUIS  EQU   CVTS01+180
CVTPARS  EQU   CVTS01+176
CVTS1EE  EQU   CVTS01+172
CVTFRAS  EQU   CVTS01+168
CVTQSAS  EQU   CVTS01+164
CVTCRAS  EQU   CVTS01+160
CVTCRMN  EQU   CVTS01+156
CVTDELCP EQU   CVTS01+152
CVTFRECL EQU   CVTS01+148
CVTGETCL EQU   CVTS01+144
CVTBLDCP EQU   CVTS01+140
CVTAUTHL EQU   CVTS01+136
CVTSCAN  EQU   CVTS01+132
CVTRV144 EQU   CVTS01+130
CVTMAXMP EQU   CVTS01+128
CVTSTCK  EQU   CVTS01+124
CVTRV139 EQU   CVTS01+123
CVTDSSAC EQU   CVTS01+122
CVTRV513 EQU   CVTS01+121
CVTIOSPL EQU   CVTS01+120
CVTPTGT  EQU   CVTS01+116
CVTCSPIE EQU   CVTS01+112
CVTSMFEX EQU   CVTS01+108
CVTOLT0A EQU   CVTS01+104
CVTSRBRT EQU   CVTS01+100
CVTPUTL  EQU   CVTS01+96
CVTASCRL EQU   CVTS01+92
CVTASCRF EQU   CVTS01+88
CVTRV326 EQU   CVTS01+84
CVTRV325 EQU   CVTS01+80
CVTRV324 EQU   CVTS01+76
CVT0VL01 EQU   CVTS01+72
CVTSHRVM EQU   CVTS01+68
CVTRV332 EQU   CVTS01+64
CVTTAS   EQU   CVTS01+60
CVTRSCN  EQU   CVTS01+56
CVTTRAC2 EQU   CVTS01+54
CVTTRACE EQU   CVTS01+52
CVTAPG   EQU   CVTS01+51
CVTSDTRC EQU   CVTCTLFG
CVTGTRCE EQU   CVTCTLFG
CVTNOMP  EQU   CVTCTLFG
CVTRSV79 EQU   CVTCTLFG
CVTDSTAT EQU   CVTCTLFG
CVTRSV78 EQU   CVTCTLFG
CVTRV333 EQU   CVTCTLFG
CVTRV323 EQU   CVTCTLFG
CVTSPVLK EQU   CVTS01+49
CVTRSV77 EQU   CVTS01+48
CVTRV331 EQU   CVTS01+44
CVTRV330 EQU   CVTS01+40
CVTRV329 EQU   CVTS01+36
CVTRV328 EQU   CVTS01+32
CVTRV322 EQU   CVTS01+28
CVTSLID  EQU   CVTSLIDA+1
CVTSYLK  EQU   CVTSLIDA
CVTRV321 EQU   CVTS01+20
CVTRV320 EQU   CVTS01+16
CVTLPDIR EQU   CVTLPDIA+1
CVTRSV69 EQU   CVTDIRST
CVTRSV68 EQU   CVTDIRST
CVTRSV67 EQU   CVTDIRST
CVTRSV66 EQU   CVTDIRST
CVTRSV65 EQU   CVTDIRST
CVTRSV64 EQU   CVTDIRST
CVTRSV63 EQU   CVTDIRST
CVTDICOM EQU   CVTDIRST
CVTPVTP  EQU   CVTS01+8
CVTLPDSR EQU   CVTS01+4
CVTGETL  EQU   CVTS01
KEY      EQU   @NM00124+4
BCKPTR   EQU   FBQESECT+4
PQERSVD  EQU   PQESECT+31
VVVRFLG  EQU   VMMFLGS
@NM00176 EQU   VMMFLGS
PQEHRID  EQU   PQESECT+29
PQERFLGS EQU   PQESECT+28
PQEREGN  EQU   PQESECT+24
PQESIZE  EQU   PQESECT+20
PQETCB   EQU   PQESECT+16
PQEBPQE  EQU   PQESECT+12
PQEBFBQE EQU   PQESECT+4
PQEFFBQE EQU   PQESECT
FQERSVD  EQU   FQESECT+12
FQAREA   EQU   FQESECT+8
FQELNTH  EQU   FQESECT+4
FQECPB   EQU   FQTYPE
DQELNTH  EQU   DQESECT+12
DQEHRID  EQU   DQEBLKAD
SPQERES2 EQU   SPQESECT+12
SPQERES1 EQU   SPQESECT+9
SPQEOWN  EQU   SPQEFLGS
LASTSPQE EQU   SPQEFLGS
IQEOUTLM EQU   IQESECT+20
IQEDCB   EQU   IQESECT+16
IQETCBA  EQU   IQETCB+1
IQESTAT2 EQU   IQETCB
IQEIRBA  EQU   IQEIRB+1
@NM00175 EQU   IQEFLAGS
@NM00174 EQU   IQEFLAGS
@NM00173 EQU   IQEFLAGS
@NM00172 EQU   IQEFLAGS
@NM00171 EQU   IQEFLAGS
@NM00170 EQU   IQEFLAGS
@NM00169 EQU   IQEFLAGS
IQEPARAM EQU   IQESECT+4
IQESTAT1 EQU   IQELNK
@NM00168 EQU   TCBXTNT2+32
TCBRV181 EQU   TCBRV173
TCBRV180 EQU   TCBRV173
TCBRV179 EQU   TCBRV173
TCBRV178 EQU   TCBRV173
TCBRV177 EQU   TCBRV173
TCBRV176 EQU   TCBRV173
TCBRV175 EQU   TCBRV173
TCBRV174 EQU   TCBRV173
TCBRV172 EQU   TCBRV164
TCBRV171 EQU   TCBRV164
TCBRV170 EQU   TCBRV164
TCBRV169 EQU   TCBRV164
TCBRV168 EQU   TCBRV164
TCBRV167 EQU   TCBRV164
TCBRV166 EQU   TCBRV164
TCBRV165 EQU   TCBRV164
TCBRV163 EQU   TCBRV155
TCBRV162 EQU   TCBRV155
TCBRV161 EQU   TCBRV155
TCBRV160 EQU   TCBRV155
TCBRV159 EQU   TCBRV155
TCBRV158 EQU   TCBRV155
TCBRV157 EQU   TCBRV155
TCBRV156 EQU   TCBRV155
TCBRV154 EQU   TCBRV146
TCBRV153 EQU   TCBRV146
TCBRV152 EQU   TCBRV146
TCBRV151 EQU   TCBRV146
TCBRV150 EQU   TCBRV146
TCBRV149 EQU   TCBRV146
TCBRV148 EQU   TCBRV146
TCBRV147 EQU   TCBRV146
TCBRV145 EQU   TCBXTNT2+26
TCBRV144 EQU   TCBXTNT2+24
TCBRV143 EQU   TCBXTNT2+20
TCBRV142 EQU   TCBXTNT2+16
TCBRSV49 EQU   TCBXTNT2+12
TCBEVENT EQU   TCBXTNT2+8
TCBRCMP  EQU   TCBXTNT2+5
TCBRSVAB EQU   TCBXTNT2+4
TCBGTFA  EQU   TCBGTF+1
TCBRSV47 EQU   TCBTFLG
TCBRSV46 EQU   TCBTFLG
TCBRSV45 EQU   TCBTFLG
TCBRSV44 EQU   TCBTFLG
TCBRSV43 EQU   TCBTFLG
TCBDSPIT EQU   TCBTFLG
TCBERRTN EQU   TCBTFLG
TCBASYNC EQU   TCBTFLG
@NM00167 EQU   TCB+296
TCBSVCA2 EQU   TCB+292
TCBSWASA EQU   TCB+288
TCBDBTB  EQU   TCB+284
TCBRPT   EQU   TCB+280
TCBRV141 EQU   TCBRV133
TCBRV140 EQU   TCBRV133
TCBRV139 EQU   TCBRV133
TCBRV138 EQU   TCBRV133
TCBRV137 EQU   TCBRV133
TCBRV136 EQU   TCBRV133
TCBRV135 EQU   TCBRV133
TCBRV134 EQU   TCBRV133
TCBRV132 EQU   TCBRV124
TCBRV131 EQU   TCBRV124
TCBRV130 EQU   TCBRV124
TCBRV129 EQU   TCBRV124
TCBRV128 EQU   TCBRV124
TCBRV127 EQU   TCBRV124
TCBRV126 EQU   TCBRV124
TCBRV125 EQU   TCBRV124
TCBRV123 EQU   TCBFBYT2
TCBRV122 EQU   TCBFBYT2
TCBECBNV EQU   TCBFBYT2
TCBSSSYN EQU   TCBFBYT2
TCBFPRAP EQU   TCBFBYT2
TCBFDW   EQU   TCBFBYT2
TCBFMW   EQU   TCBFBYT2
TCBCNCB  EQU   TCBFBYT2
TCBLLH   EQU   TCBFBYT1
TCBRV113 EQU   TCBFBYT1
TCBEOT   EQU   TCBFBYT1
TCBRTM2  EQU   TCBFBYT1
TCBPGNLY EQU   TCBFBYT1
TCBNDIOS EQU   TCBFBYT1
TCBRV327 EQU   TCBFBYT1
TCBEOTFM EQU   TCBFBYT1
TCBAFFN  EQU   TCB+274
TCBRV326 EQU   TCB+272
TCBUKYSP EQU   TCB+268
TCBMODE  EQU   TCBESTAE+3
TCBERTYP EQU   TCBESTAE+2
TCBRV314 EQU   TCBESTRM
TCBRV313 EQU   TCBESTRM
TCBRV312 EQU   TCBESTRM
TCBRV311 EQU   TCBESTRM
TCBRV310 EQU   TCBESTRM
TCBRV309 EQU   TCBESTRM
TCBRV308 EQU   TCBESTRM
TCBETERM EQU   TCBESTRM
TCBSCBKY EQU   TCBESTAE
TCBRTM12 EQU   TCB+260
TCBTCBID EQU   TCB+256
TCBSTAWA EQU   TCB+252
TCBSWA   EQU   TCB+248
TCBFOEA  EQU   TCBFOE+1
TCBRSV42 EQU   TCBFOE
TCBCCPVI EQU   TCBXSCT+2
TCBRV325 EQU   TCBXSCT+1
TCBRV324 EQU   TCBXSCT1
TCBRV323 EQU   TCBXSCT1
TCBRV322 EQU   TCBXSCT1
TCBRV321 EQU   TCBXSCT1
TCBRV320 EQU   TCBXSCT1
TCBRV319 EQU   TCBXSCT1
TCBS3A   EQU   TCBXSCT1
TCBACTIV EQU   TCBXSCT1
TCBRSV41 EQU   TCB+239
TCBTID   EQU   TCB+238
TCBRSVAA EQU   TCB+237
TCBABCUR EQU   TCB+236
TCBTMSAV EQU   TCB+232
TCBIOTIM EQU   TCB+228
TCBBACK  EQU   TCB+220
TCBTIRB  EQU   TCB+216
TCBAECB  EQU   TCB+212
TCBEXT2A EQU   TCBEXT2+1
TCBRSV39 EQU   TCBEXT2
TCBSTMCT EQU   TCB+207
TCBSYSCT EQU   TCB+206
TCBRSV37 EQU   TCB+205
TCBEXSVC EQU   TCBDAR
TCBDARMS EQU   TCBDAR
TCBDARWT EQU   TCBDAR
TCBDARO  EQU   TCBDAR
TCBDARMC EQU   TCBDARC
TCBDARD  EQU   TCBDAR
TCBDARS  EQU   TCBDAR
TCBDARP  EQU   TCBDAR
TCBGTOFM EQU   TCBFLGS7
TCBRSTSK EQU   TCBFLGS7
TCBSVCS  EQU   TCBFLGS7
TCBSTACK EQU   TCBFLGS7
TCBRSV34 EQU   TCBFLGS7
TCBRSV33 EQU   TCBFLGS7
TCBGPECB EQU   TCBFLGS7
TCBNTJS  EQU   TCBFLGS6
TCBAPG   EQU   TCBFLGS6
TCBMIGR  EQU   TCBFLGS6
TCBRV303 EQU   TCBFLGS6
TCBSPVLK EQU   TCBFLGS6
TCBCPU   EQU   TCBFLGS6
TCBPIE17 EQU   TCBFLGS6
TCBRV    EQU   TCBFLGS6
TCBRSV79 EQU   TCBNDSP5
TCBRSV78 EQU   TCBNDSP5
TCBRSV77 EQU   TCBNDSP5
TCBRSV76 EQU   TCBNDSP5
TCBRSV75 EQU   TCBNDSP5
TCBRSV74 EQU   TCBNDSP5
TCBRSV95 EQU   TCBNDSP5
TCBRSV94 EQU   TCBNDSP5
TCBRSV93 EQU   TCBNDSP4
TCBRSV92 EQU   TCBNDSP4
TCBRSV91 EQU   TCBNDSP4
TCBRSV90 EQU   TCBNDSP4
TCBRSV89 EQU   TCBNDSP4
TCBRSV88 EQU   TCBNDSP4
TCBRSV87 EQU   TCBNDSP4
TCBRSV86 EQU   TCBNDSP4
TCBEXT1A EQU   TCBEXT1+1
TCBRSV32 EQU   TCBEXT1
TCBEXCPD EQU   TCB+192
TCBIOBRC EQU   TCB+188
TCBDDWTC EQU   TCB+186
TCBDDEXC EQU   TCB+184
TCBJSCBB EQU   TCBJSCB+1
@NM00166 EQU   TCBRECDE
TCBREC   EQU   TCBRECDE
TCBMDIDS EQU   TCB+176
TCBNDINT EQU   TCBNDSP3
TCBRSV27 EQU   TCBNDSP3
TCBRSV26 EQU   TCBNDSP3
TCBRSV25 EQU   TCBNDSP3
TCBRSV24 EQU   TCBNDSP3
TCBSRBND EQU   TCBNDSP3
TCBRV302 EQU   TCBNDSP3
TCBLJSND EQU   TCBNDSP3
TCBABE   EQU   TCBNDSP2
TCBDSS   EQU   TCBNDSP2
TCBOWAIT EQU   TCBNDSP2
TCBIWAIT EQU   TCBNDSP2
TCBNDTS  EQU   TCBNDSP2
TCBNDSVC EQU   TCBNDSP2
TCBSTPP  EQU   TCBNDSP2
TCBABD   EQU   TCBNDSP2
TCBRSV22 EQU   TCBNDSP1
TCBPIEND EQU   TCBNDSP1
TCBTPSP  EQU   TCBNDSP1
TCBDDRND EQU   TCBNDSP1
TCBRSPND EQU   TCBNDSP1
TCBRSTND EQU   TCBNDSP1
TCBDARPN EQU   TCBNDSP1
TCBDARTN EQU   TCBNDSP1
TCBNDSP0 EQU   TCBNDSP
TCBUSER  EQU   TCB+168
TCBTCTB  EQU   TCBTCT+1
TCBRSV9C EQU   TCBTCTGF
TCBRSV9B EQU   TCBTCTGF
TCBRSV9A EQU   TCBTCTGF
TCBRSV99 EQU   TCBTCTGF
TCBRSV98 EQU   TCBTCTGF
TCBRSV97 EQU   TCBTCTGF
TCBRSV20 EQU   TCBTCTGF
TCBSMFGF EQU   TCBTCTGF
TCBSTABB EQU   TCBSTAB+1
TCBSTCUR EQU   TCBNSTAE
TCBRV301 EQU   TCBNSTAE
TCBSYNCH EQU   TCBNSTAE
TCBHALT  EQU   TCBNSTAE
TCBPPSUP EQU   TCBNSTAE
TCB33E   EQU   TCBNSTAE
TCBQUIES EQU   TCBNSTAE
TCBSTABE EQU   TCBNSTAE
TCBAQE   EQU   TCB+156
TCBTSDP  EQU   TCB+151
TCBTSLP  EQU   TCB+150
TCBSTPCT EQU   TCB+149
TCBCPUBN EQU   TCBTSFLG
TCBDYDSP EQU   TCBTSFLG
TCBRSV18 EQU   TCBTSFLG
TCBRSV17 EQU   TCBTSFLG
TCBTIOTG EQU   TCBTSFLG
TCBATT   EQU   TCBTSFLG
TCBSTPPR EQU   TCBTSFLG
TCBRV300 EQU   TCBTSTSK
TCBECB   EQU   TCB+144
TCBIQE   EQU   TCB+140
TCBNTC   EQU   TCB+128
TCBJSTCA EQU   TCBJSTCB+1
TCBRSV16 EQU   TCBJSTCB
TCBTQET  EQU   TCBTME
TCBFSAB  EQU   TCBFSA+1
TCBQEL   EQU   TCBFSA
TCBGRS15 EQU   TCBGRS+60
TCBGRS14 EQU   TCBGRS+56
TCBGRS13 EQU   TCBGRS+52
TCBGRS12 EQU   TCBGRS+48
TCBGRS11 EQU   TCBGRS+44
TCBGRS10 EQU   TCBGRS+40
TCBGRS9  EQU   TCBGRS+36
TCBGRS8  EQU   TCBGRS+32
TCBGRS7  EQU   TCBGRS+28
TCBGRS6  EQU   TCBGRS+24
TCBGRS5  EQU   TCBGRS+20
TCBGRS4  EQU   TCBGRS+16
TCBGRS3  EQU   TCBGRS+12
TCBGRS2  EQU   TCBGRS+8
TCBGRS1  EQU   TCBGRS+4
TCBGRS0  EQU   TCBGRS
TCBJPQB  EQU   TCBJPQ+1
TCBRSV15 EQU   TCBPURGE
TCBRSV14 EQU   TCBPURGE
TCBRSV13 EQU   TCBPURGE
TCBRSV12 EQU   TCBPURGE
TCBRSV11 EQU   TCBPURGE
TCBRSV10 EQU   TCBPURGE
TCBRSV09 EQU   TCBPURGE
TCBJPQF  EQU   TCBPURGE
TCBJLB   EQU   TCB+40
TCBLLS   EQU   TCB+36
TCBPNDSP EQU   TCBFLGS5
TCBFCD1  EQU   TCBFLGS5
TCBSTP   EQU   TCBFLGS5
TCBSYS   EQU   TCBFLGS5
TCBANDSP EQU   TCBFLGS5
TCBPAGE  EQU   TCBFLGS5
TCBUXNDF EQU   TCBABWF
TCBONDSP EQU   TCBFLGS4
TCBMPCND EQU   TCBFLGS4
TCBMPCVQ EQU   TCBFLGS4
TCBUXNDV EQU   TCBFLGS4
TCBHNDSP EQU   TCBFLGS4
TCBRQENA EQU   TCBFLGS4
TCBSER   EQU   TCBFLGS4
TCBNDUMP EQU   TCBFLGS4
TCBDWSTA EQU   TCBFLGS3
TCBRSV08 EQU   TCBFLGS3
TCBRSV07 EQU   TCBFLGS3
TCBRSV06 EQU   TCBFLGS3
TCBABGM  EQU   TCBFLGS3
TCBABTRM EQU   TCBFLGS3
TCBADINP EQU   TCBFLGS3
TCBFSM   EQU   TCBFLGS3
TCBFTS   EQU   TCBFLGS2
TCBFETXR EQU   TCBFLGS2
TCBFDSOP EQU   TCBFLGS2
TCBFJMC  EQU   TCBFLGS2
TCBFSMC  EQU   TCBFLGS2
TCBFABOP EQU   TCBFLGS2
TCBFSTI  EQU   TCBFLGS2
TCBFOINP EQU   TCBFLGS2
TCBFX    EQU   TCBFLGS1
TCBFS    EQU   TCBFLGS1
TCBFT    EQU   TCBFLGS1
TCBPDUMP EQU   TCBFLGS1
TCBNONPR EQU   TCBFLGS1
TCBFERA  EQU   TCBFLGS1
TCBFE    EQU   TCBFLGS1
TCBFA    EQU   TCBFLGS1
TCBZERO  EQU   TCBPKF
TCBMSSB  EQU   TCBMSS+1
TCBRSV03 EQU   TCBMSS
TCBTRNB  EQU   TCBTRN+1
TCBRSV02 EQU   TCBABF
TCBOLTEP EQU   TCBABF
TCBTCP   EQU   TCBABF
TCBTCPP  EQU   TCBABF
TCBRSV01 EQU   TCBABF
TCBGRPH  EQU   TCBABF
TCBNOCHK EQU   TCBABF
TCBMOD91 EQU   TCBABF
TCBCMPC  EQU   TCBCMP+1
TCBRV318 EQU   TCBCMSG
TCBRV317 EQU   TCBCIND
TCBRV316 EQU   TCBCWTO
TCBCASID EQU   TCBCDBL
TCBNOCC  EQU   TCBSTCC
TCBDMPO  EQU   TCBCPP
TCBCSTEP EQU   TCBCMPF
TCBCREQ  EQU   TCBCMPF
TCBTIO   EQU   TCB+12
TCBDEB   EQU   TCB+8
TCBPIEA  EQU   TCBPIE+1
TCBPM    EQU   TCBPMASK
@NM00165 EQU   TCBPMASK
TCBRBP   EQU   TCB
TCBFRS6  EQU   TCBFRS+24
TCBFRS4  EQU   TCBFRS+16
TCBFRS2  EQU   TCBFRS+8
TCBFRS0  EQU   TCBFRS
RTCTISVC EQU   RTCTSDO4
RTCTSDOV EQU   RTCTSDMG
@NM00164 EQU   RTCTSDO4
@NM00163 EQU   RTCTSDO3
RTCTSDPH EQU   RTCTSDO3
RTCTSDPG EQU   RTCTSDO3
@NM00162 EQU   RTCTSDO2
RTCTSDPD EQU   RTCTSDO2
RTCTSDPC EQU   RTCTSDO2
RTCTSDPB EQU   RTCTSDO2
RTCTSDPA EQU   RTCTSDO2
RTCTSDP9 EQU   RTCTSDO2
RTCTSDP8 EQU   RTCTSDO2
RTCTSDP7 EQU   RTCTSDO1
RTCTSDP6 EQU   RTCTSDO1
RTCTSDP5 EQU   RTCTSDO1
RTCTSDP4 EQU   RTCTSDO1
RTCTSDP3 EQU   RTCTSDO1
RTCTSDP2 EQU   RTCTSDO1
RTCTSDP1 EQU   RTCTSDO1
RTCTSDP0 EQU   RTCTSDO1
RTCTISYM EQU   RTCTSD04
RTCTSMOV EQU   RTCTSMMG
@NM00161 EQU   RTCTSD04
RTCTSD03 EQU   RTCTMSYO+2
RTCTSD02 EQU   RTCTMSYO+1
RTCTSDS7 EQU   RTCTSD01
RTCTSDS6 EQU   RTCTSD01
RTCTSDS5 EQU   RTCTSD01
RTCTSDS4 EQU   RTCTSD01
RTCTSDS3 EQU   RTCTSD01
RTCTSDS2 EQU   RTCTSD01
RTCTSDS1 EQU   RTCTSD01
RTCTSDS0 EQU   RTCTSD01
RTCTISYU EQU   RTCTSUO4
RTCTSUOV EQU   RTCTSUMG
@NM00160 EQU   RTCTSUO4
RTCTSYDF EQU   RTCTSUO3
RTCTSYDE EQU   RTCTSUO3
RTCTSYDD EQU   RTCTSUO3
RTCTSYDC EQU   RTCTSUO3
RTCTSYDB EQU   RTCTSUO3
RTCTSYDA EQU   RTCTSUO3
RTCTSYD9 EQU   RTCTSUO3
RTCTSYD8 EQU   RTCTSUO3
@NM00159 EQU   RTCTSUO2
RTCTSYDH EQU   RTCTSUO2
RTCTSYDG EQU   RTCTSUO2
RTCTSYD7 EQU   RTCTSUO1
RTCTSYD6 EQU   RTCTSUO1
RTCTSYD5 EQU   RTCTSUO1
RTCTSYD4 EQU   RTCTSUO1
RTCTSYD3 EQU   RTCTSUO1
RTCTSYD2 EQU   RTCTSUO1
RTCTSYD1 EQU   RTCTSUO1
RTCTSYD0 EQU   RTCTSUO1
RTCTISAB EQU   RTCTSAO4
RTCTSAOV EQU   RTCTSAMG
@NM00158 EQU   RTCTSAO4
RTCTSADF EQU   RTCTSAO3
RTCTSADE EQU   RTCTSAO3
RTCTSADD EQU   RTCTSAO3
RTCTSADC EQU   RTCTSAO3
RTCTSADB EQU   RTCTSAO3
RTCTSADA EQU   RTCTSAO3
RTCTSAD9 EQU   RTCTSAO3
RTCTSAD8 EQU   RTCTSAO3
@NM00157 EQU   RTCTSAO2
RTCTSADH EQU   RTCTSAO2
RTCTSADG EQU   RTCTSAO2
RTCTSAD7 EQU   RTCTSAO1
RTCTSAD6 EQU   RTCTSAO1
RTCTSAD5 EQU   RTCTSAO1
RTCTSAD4 EQU   RTCTSAO1
RTCTSAD3 EQU   RTCTSAO1
RTCTSAD2 EQU   RTCTSAO1
RTCTSAD1 EQU   RTCTSAO1
RTCTSAD0 EQU   RTCTSAO1
RTCTZZZ5 EQU   RTCT+340
RTCTZZZ4 EQU   RTCT+336
RTCTMRMQ EQU   RTCT+332
RTCTSDF5 EQU   RTCTSDF3+3
RTCTSDDO EQU   RTCTSDF4
RTCTSDEN EQU   RTCTSDF4
RTCTSDEQ EQU   RTCTSDF4
RTCTSDTR EQU   RTCTSDF4
RTCTSDRM EQU   RTCTSDF4
RTCTSDAN EQU   RTCTSDF4
RTCTSDNC EQU   RTCTSDF4
RTCTSDSS EQU   RTCTSDF4
RTCTSDAS EQU   RTCTSDF3
RTCTZZZ3 EQU   RTCT+266
@NM00156 EQU   RTCTSDF2
RTCTSDRW EQU   RTCTSDF2
RTCTSDSL EQU   RTCTSDF2
RTCTSDWF EQU   RTCTSDF2
RTCTSDLA EQU   RTCTSDF2
RTCTSDDI EQU   RTCTSDF2
RTCTSDTQ EQU   RTCTSDF2
RTCTSDMR EQU   RTCTSDF2
RTCTSDSC EQU   RTCTSDF1
RTCTSDRS EQU   RTCTSDF1
RTCTSDSD EQU   RTCTSDF1
RTCTSDEP EQU   RTCTSDF1
RTCTSDMA EQU   RTCTSDF1
RTCTSDSH EQU   RTCTSDF1
RTCTSDND EQU   RTCTSDF1
RTCTSDNO EQU   RTCTSDF1
RTCTZZZ2 EQU   RTCT+257
RTCTSDPR EQU   RTCTSDI+2
RTCTINDX EQU   RTCTSDI+1
RTCTSDNA EQU   RTCTSDI
@NM00155 EQU   RTCTASO2
RTCTASNQ EQU   RTCTASO2
RTCTASNA EQU   RTCTASO2
RTCTASNS EQU   RTCTASO2
RTCTASSU EQU   RTCTASO2
RTCTASSW EQU   RTCTASO2
RTCTASCS EQU   RTCTASO2
RTCTASTR EQU   RTCTASO1
RTCTASLP EQU   RTCTASO1
RTCTASRG EQU   RTCTASO1
RTCTASLS EQU   RTCTASO1
RTCTASSQ EQU   RTCTASO1
RTCTASNU EQU   RTCTASO1
RTCTASPS EQU   RTCTASO1
RTCTASAL EQU   RTCTASO1
RTCTSDO  EQU   RTCTOPT+12
RTCTSYO  EQU   RTCTOPT+8
RTCTSUO  EQU   RTCTOPT+4
RTCTSAO  EQU   RTCTOPT
RTCTXXX2 EQU   RTCT+234
RTCTETIM EQU   RTCTERID+6
RTCTEASD EQU   RTCTERID+4
RTCTECPU EQU   RTCTERID+2
RTCTESEQ EQU   RTCTERID
RTCTSDWK EQU   RTCT+220
RTCTTDCB EQU   RTCT+184
RTCTSDSW EQU   RTCT+180
RTCTSEQ# EQU   RTCT+178
RTCTXXX1 EQU   RTCT+177
@NM00154 EQU   RTCTRFLG
RTCTRSTF EQU   RTCTRFLG
RTCTRPER EQU   RTCTRFLG
RTCTRTER EQU   RTCTRFLG
RTCTTEST EQU   RTCT+172
RTCTMSRB EQU   RTCT+168
RTCTMLCK EQU   RTCT+164
RTCTFMT  EQU   RTCT+160
RTCTSDIP EQU   RTCTSDPL
RTCTDEV  EQU   RTCTSDDS+8
RTCTDCB  EQU   RTCTSDDS+4
@NM00153 EQU   RTCTFLG
RTCTDETP EQU   RTCTFLG
RTCTDSUS EQU   RTCTFLG
RTCTDSST EQU   RTCTFLG
RTCTDSNM EQU   RTCTSDDS
RTCTRCB  EQU   RTCT+32
RTCTRECB EQU   RTCT+28
RTCTFASB EQU   RTCT+24
RTCTMECB EQU   RTCT+20
RTCTSDID EQU   RTCT+18
RTCTYYY1 EQU   RTCT+16
RTCTSY04 EQU   RTCTSYD+3
RTCTSY03 EQU   RTCTSYD+2
RTCTSY02 EQU   RTCTSYD+1
RTCTSYM7 EQU   RTCTSY01
RTCTSYM6 EQU   RTCTSY01
RTCTSYM5 EQU   RTCTSY01
RTCTSYM4 EQU   RTCTSY01
RTCTSYM3 EQU   RTCTSY01
RTCTSYM2 EQU   RTCTSY01
RTCTSYM1 EQU   RTCTSY01
RTCTSYM0 EQU   RTCTSY01
RTCTSUP4 EQU   RTCTSUP+3
RTCTSUDF EQU   RTCTSUP3
RTCTSUDE EQU   RTCTSUP3
RTCTSUDD EQU   RTCTSUP3
RTCTSUDC EQU   RTCTSUP3
RTCTSUDB EQU   RTCTSUP3
RTCTSUDA EQU   RTCTSUP3
RTCTSUD9 EQU   RTCTSUP3
RTCTSUD8 EQU   RTCTSUP3
@NM00152 EQU   RTCTSUP2
RTCTSUDH EQU   RTCTSUP2
RTCTSUDG EQU   RTCTSUP2
RTCTSUD7 EQU   RTCTSUP1
RTCTSUD6 EQU   RTCTSUP1
RTCTSUD5 EQU   RTCTSUP1
RTCTSUD4 EQU   RTCTSUP1
RTCTSUD3 EQU   RTCTSUP1
RTCTSUD2 EQU   RTCTSUP1
RTCTSUD1 EQU   RTCTSUP1
RTCTSUD0 EQU   RTCTSUP1
RTCTSAP4 EQU   RTCTSAP+3
RTCTSABF EQU   RTCTSAP3
RTCTSABE EQU   RTCTSAP3
RTCTSABD EQU   RTCTSAP3
RTCTSABC EQU   RTCTSAP3
RTCTSABB EQU   RTCTSAP3
RTCTSABA EQU   RTCTSAP3
RTCTSAB9 EQU   RTCTSAP3
RTCTSAB8 EQU   RTCTSAP3
@NM00151 EQU   RTCTSAP2
RTCTSABH EQU   RTCTSAP2
RTCTSABG EQU   RTCTSAP2
RTCTSAB7 EQU   RTCTSAP1
RTCTSAB6 EQU   RTCTSAP1
RTCTSAB5 EQU   RTCTSAP1
RTCTSAB4 EQU   RTCTSAP1
RTCTSAB3 EQU   RTCTSAP1
RTCTSAB2 EQU   RTCTSAP1
RTCTSAB1 EQU   RTCTSAP1
RTCTSAB0 EQU   RTCTSAP1
RTCTNAME EQU   RTCT
CVTLEVL  EQU   CVTRELNO+2
CVTNUMB  EQU   CVTRELNO
CVTMDL   EQU   CVTFIX+250
@NM00126 EQU   CVTFIX+248
@NM00125 EQU   CVTFIX
CVTRV482 EQU   CVTXTNT2+128
CVTRV481 EQU   CVTXTNT2+124
CVTRV480 EQU   CVTXTNT2+120
CVTRV479 EQU   CVTXTNT2+118
CVTRV478 EQU   CVTXTNT2+117
CVTRV477 EQU   CVTXTNT2+116
CVTRV476 EQU   CVTXTNT2+115
CVTRV475 EQU   CVTXTNT2+114
CVTRV474 EQU   CVTRV466
CVTRV473 EQU   CVTRV466
CVTRV472 EQU   CVTRV466
CVTRV471 EQU   CVTRV466
CVTRV470 EQU   CVTRV466
CVTRV469 EQU   CVTRV466
CVTRV468 EQU   CVTRV466
CVTRV467 EQU   CVTRV466
CVTRV465 EQU   CVTRV457
CVTRV464 EQU   CVTRV457
CVTRV463 EQU   CVTRV457
CVTRV462 EQU   CVTRV457
CVTRV461 EQU   CVTRV457
CVTRV460 EQU   CVTRV457
CVTRV459 EQU   CVTRV457
CVTRV458 EQU   CVTRV457
CVTRV456 EQU   CVTXTNT2+108
CVTRV455 EQU   CVTXTNT2+104
CVTRV454 EQU   CVTXTNT2+100
CVTRV453 EQU   CVTXTNT2+96
CVTRV452 EQU   CVTXTNT2+94
CVTRV451 EQU   CVTXTNT2+92
CVTRV450 EQU   CVTXTNT2+90
CVTRV449 EQU   CVTXTNT2+88
CVTRV448 EQU   CVTXTNT2+87
CVTRV447 EQU   CVTXTNT2+86
CVTRV446 EQU   CVTRV438
CVTRV445 EQU   CVTRV438
CVTRV444 EQU   CVTRV438
CVTRV443 EQU   CVTRV438
CVTRV442 EQU   CVTRV438
CVTRV441 EQU   CVTRV438
CVTRV440 EQU   CVTRV438
CVTRV439 EQU   CVTRV438
CVTRV437 EQU   CVTRV429
CVTRV436 EQU   CVTRV429
CVTRV435 EQU   CVTRV429
CVTRV434 EQU   CVTRV429
CVTRV433 EQU   CVTRV429
CVTRV432 EQU   CVTRV429
CVTRV431 EQU   CVTRV429
CVTRV430 EQU   CVTRV429
CVTRV428 EQU   CVTXTNT2+80
CVTRV427 EQU   CVTXTNT2+76
CVTRV426 EQU   CVTXTNT2+72
CVTRV425 EQU   CVTXTNT2+68
CVTATACT EQU   CVTATCVT
CVTRV423 EQU   CVTXTNT2+62
CVTRV422 EQU   CVTXTNT2+60
CVTRV421 EQU   CVTXTNT2+58
CVTRV420 EQU   CVTXTNT2+56
CVTRV419 EQU   CVTXTNT2+55
CVTRV418 EQU   CVTXTNT2+54
CVTRV417 EQU   CVTRV409
CVTRV416 EQU   CVTRV409
CVTRV415 EQU   CVTRV409
CVTRV414 EQU   CVTRV409
CVTRV413 EQU   CVTRV409
CVTRV412 EQU   CVTRV409
CVTRV411 EQU   CVTRV409
CVTRV410 EQU   CVTRV409
CVTRV408 EQU   CVTRV400
CVTRV407 EQU   CVTRV400
CVTRV406 EQU   CVTRV400
CVTRV405 EQU   CVTRV400
CVTRV404 EQU   CVTRV400
CVTRV403 EQU   CVTRV400
CVTRV402 EQU   CVTRV400
CVTRV401 EQU   CVTRV400
CVTICB   EQU   CVTXTNT2+48
CVTSKTA  EQU   CVTXTNT2+44
CVTRSV99 EQU   CVTXTNT2+40
CVTRSV98 EQU   CVTXTNT2+36
CVTRSV97 EQU   CVTXTNT2+34
CVTRSV96 EQU   CVTXTNT2+32
CVTOLTEP EQU   CVTXTNT2+28
CVTQIDA  EQU   CVTQID+1
CVTRSV95 EQU   CVTQID
CVTRSV94 EQU   CVTXTNT2+20
CVTRSV93 EQU   CVTXTNT2+16
CVTRSV92 EQU   CVTXTNT2+12
CVTDEBVR EQU   CVTXTNT2+8
CVTRSV91 EQU   CVTXTNT2+6
CVTRSV9H EQU   CVTFLGBT
CVTRSV9G EQU   CVTFLGBT
CVTRSV9F EQU   CVTFLGBT
CVTRSV9E EQU   CVTFLGBT
CVTRSV9D EQU   CVTFLGBT
CVTBAH   EQU   CVTFLGBT
CVTVME   EQU   CVTFLGBT
CVTNPE   EQU   CVTFLGBT
CVTNUCLS EQU   CVTXTNT2+4
CVTDSSVA EQU   CVTDSSV+1
CVTRSV89 EQU   CVTDSSV
CVTRSV88 EQU   CVTXTNT1+8
CVTRSV87 EQU   CVTXTNT1+4
CVTFACHN EQU   CVTXTNT1
CVTRV488 EQU   CVTMAP+412
CVTRV487 EQU   CVTMAP+408
CVTRV486 EQU   CVTMAP+404
CVTRV485 EQU   CVTMAP+400
CVTACTAP EQU   CVTMAP+396
CVTAUTH  EQU   CVTMAP+392
CVTRV490 EQU   CVTMAP+388
CVTRSV61 EQU   CVTMAP+384
CVTVOLT1 EQU   CVTVOLM1+1
CVTVOLI1 EQU   CVTVOLF1
CVTSTOA  EQU   CVTMAP+376
CVTRSV58 EQU   CVTMAP+374
CVTRSV57 EQU   CVTMAP+372
CVTDDCE  EQU   CVTMAP+368
CVTPNWFR EQU   CVTMAP+364
CVTSMF   EQU   CVTMAP+360
CVTSULK  EQU   CVTMAP+358
CVTSLKO  EQU   CVTSYSK
CVTSLKP  EQU   CVTSYSK
CVTSLKQ  EQU   CVTSYSK
CVTSLKR  EQU   CVTSYSK
CVTRSV56 EQU   CVTSYSK
CVTRSV55 EQU   CVTSYSK
CVTRSV54 EQU   CVTSYSK
CVTRSV53 EQU   CVTSYSK
CVTRSV52 EQU   CVTA1F1
CVTRSV51 EQU   CVTA1F1
CVTRSV50 EQU   CVTA1F1
CVTRSV49 EQU   CVTA1F1
CVTRSV48 EQU   CVTA1F1
CVTRSV47 EQU   CVTA1F1
CVTSRSW  EQU   CVTA1F1
CVTPFSW  EQU   CVTA1F1
CVTPCVT  EQU   CVTMAP+352
CVTRSV46 EQU   CVTMAP+344
CVTRSV45 EQU   CVTMAP+340
CVTRSV44 EQU   CVTMAP+338
CVTRSV43 EQU   CVTMAP+336
CVTHJESA EQU   CVTHJES+1
CVTRSV42 EQU   CVTHJES
CVTEXT2A EQU   CVTEXT2+1
CVTRSV41 EQU   CVTEXT2
CVTAPFA  EQU   CVTAPF+1
CVTRSV40 EQU   CVTAPF
CVTRV518 EQU   CVTINTLA
CVTRV517 EQU   CVTERPV
CVTEORM  EQU   CVTMAP+312
CVTMCHPR EQU   CVTMAP+308
CVTTZ    EQU   CVTMAP+304
CVTJEPS  EQU   CVTMAP+300
CVTJESCT EQU   CVTMAP+296
CVTMODE  EQU   CVTMAP+292
CVTPTRV  EQU   CVTMAP+288
CVTREAL  EQU   CVTMAP+284
CVTRSV39 EQU   CVTMAP+280
CVTRSV38 EQU   CVTMAP+276
CVTDMSRA EQU   CVTDMSR+1
CVTRV634 EQU   CVTDMSRF
CVTRV633 EQU   CVTDMSRF
CVTRV632 EQU   CVTDMSRF
CVTRV631 EQU   CVTDMSRF
CVTRV630 EQU   CVTDMSRF
CVTRV629 EQU   CVTDMSRF
CVTUDUMP EQU   CVTDMSRF
CVTSDUMP EQU   CVTDMSRF
CVTQMSGA EQU   CVTQMSG+1
CVTRSV36 EQU   CVTQMSG
CVTAMFF  EQU   CVTMAP+264
CVTPURGA EQU   CVTPURG+1
CVTRSV35 EQU   CVTPURG
CVTCBSP  EQU   CVTMAP+256
CVTATERA EQU   CVTATER+1
CVTSYST  EQU   CVTATER
CVTVOLT2 EQU   CVTTAT
CVTVOLI2 EQU   CVTVOLF2
CVTAQAVB EQU   CVTAQAVT+1
CVTRSV34 EQU   CVTTCMFG
CVTRSV33 EQU   CVTTCMFG
CVTRSV32 EQU   CVTTCMFG
CVTRSV31 EQU   CVTTCMFG
CVTRSV30 EQU   CVTTCMFG
CVTRSV29 EQU   CVTTCMFG
CVTLDEV  EQU   CVTTCMFG
CVTTCRDY EQU   CVTTCMFG
CVTGTFA  EQU   CVTGTF+1
CVTRSV27 EQU   CVTGTFST
CVTRNIO  EQU   CVTGTFST
CVTUSR   EQU   CVTGTFST
CVTRV318 EQU   CVTFORM
CVTRV317 EQU   CVTTMODE
CVTRV316 EQU   CVTSTATE
CVTRV315 EQU   CVTGTFS
CVTGTFAV EQU   CVTGTFS
CVT0SCR1 EQU   CVTMAP+232
CVTRV515 EQU   CVTMAP+228
CVTRMS   EQU   CVTMAP+224
CVTPATCH EQU   CVTMAP+220
CVTTSCE  EQU   CVTMAP+216
CVTLNKSC EQU   CVTMAP+214
CVTQABST EQU   CVTMAP+212
CVTMDLDS EQU   CVTMAP+208
CVTUSER  EQU   CVTMAP+204
CVTABEND EQU   CVTMAP+200
CVTSMCA  EQU   CVTMAP+196
CVTRSV18 EQU   CVTMAP+192
CVTQLPAQ EQU   CVTMAP+188
CVTQCDSR EQU   CVTMAP+184
CVTRSV17 EQU   CVTOPTB
CVTVS1A  EQU   CVTOPTB
CVTFP    EQU   CVTOPTB
CVTAPTHR EQU   CVTOPTB
CVTNLOG  EQU   CVTOPTB
CVTTOD   EQU   CVTOPTB
CVTCTIMS EQU   CVTOPTB
CVTPROT  EQU   CVTOPTB
CVTXPFP  EQU   CVTOPTA
CVTASCII EQU   CVTOPTA
CVTRSV13 EQU   CVTOPTA
CVTRSV12 EQU   CVTOPTA
CVTNIP   EQU   CVTOPTA
CVTDDR   EQU   CVTOPTA
CVTAPR   EQU   CVTOPTA
CVTCCH   EQU   CVTOPTA
CVTSNCTR EQU   CVTMAP+180
CVTQMWR  EQU   CVTMAP+176
CVTQOCR  EQU   CVTMAP+172
CVT1EF00 EQU   CVTMAP+168
CVTMZ00  EQU   CVTMAP+164
CVTHEAD  EQU   CVTMAP+160
CVTRSV11 EQU   CVTMAP+156
CVT0PT01 EQU   CVTMAP+152
CVTMSER  EQU   CVTMAP+148
CVTRV516 EQU   CVTIERLC
CVTILCH  EQU   CVTMAP+140
CVT0DS   EQU   CVTMAP+136
CVTFBOSV EQU   CVTMAP+132
CVTNUCB  EQU   CVTMAP+128
CVTIXAVL EQU   CVTMAP+124
CVTIOQET EQU   CVTMAP+120
CVTDCBA  EQU   CVTMAP+117
CVTMVS2  EQU   CVTDCB
CVT6DAT  EQU   CVTDCB
CVT4MPS  EQU   CVTDCB
CVTRSV09 EQU   CVTDCB
CVT4MS1  EQU   CVTDCB
CVT2SPS  EQU   CVTDCB
CVT1SSS  EQU   CVTDCB
CVTRSV08 EQU   CVTDCB
CVTSTB   EQU   CVTMAP+112
CVTQTD00 EQU   CVTMAP+108
CVTQTE00 EQU   CVTMAP+104
CVTCUCB  EQU   CVTMAP+100
CVTSJQ   EQU   CVTMAP+96
CVTPBLDL EQU   CVTMAP+92
CVTTPC   EQU   CVTMAP+88
CVTSVDCB EQU   CVTMAP+84
CVTBRET  EQU   CVTMAP+82
CVTEXIT  EQU   CVTMAP+80
CVT0FN00 EQU   CVTMAP+76
CVTDARA  EQU   CVTDAR+1
CVTRSV07 EQU   CVTFLGS1
CVTRSV06 EQU   CVTFLGS1
CVTRSV05 EQU   CVTFLGS1
CVTRSV04 EQU   CVTFLGS1
CVTRSV03 EQU   CVTFLGS1
CVTRSV02 EQU   CVTFLGS1
CVTRSV01 EQU   CVTFLGS1
CVTDMPLK EQU   CVTFLGS1
CVTXITP  EQU   CVTMAP+68
CVTZDTAB EQU   CVTMAP+64
CVTMSLT  EQU   CVTMAP+60
CVTDATE  EQU   CVTMAP+56
CVTBTERM EQU   CVTMAP+52
CVTSYSAD EQU   CVTMAP+48
CVTXTLER EQU   CVTMAP+44
CVTILK2  EQU   CVTMAP+40
CVTILK1  EQU   CVTMAP+36
CVTPRLTV EQU   CVTMAP+32
CVTPCNVT EQU   CVTMAP+28
CVT0VL00 EQU   CVTMAP+24
CVTXAPG  EQU   CVTMAP+20
CVTBUF   EQU   CVTMAP+16
CVTJOB   EQU   CVTMAP+12
CVTLINK  EQU   CVTMAP+8
CVT0EF00 EQU   CVTMAP+4
CVTTCBP  EQU   CVTMAP
CVT      EQU   CVTMAP
ASXBEND  EQU   ASXB+232
ASXBRV25 EQU   ASXB+228
ASXBRV24 EQU   ASXB+224
ASXBPT0E EQU   ASXB+220
ASXBCRB4 EQU   ASXBCASW+3
ASXBCRB3 EQU   ASXBCASW+2
ASXBCRB2 EQU   ASXBCASW+1
ASXBCR06 EQU   ASXBCRB1
ASXBCR05 EQU   ASXBCRB1
ASXBCR04 EQU   ASXBCRB1
ASXBCR03 EQU   ASXBCRB1
ASXBCR02 EQU   ASXBCRB1
ASXBCR01 EQU   ASXBCRB1
ASXBTFD  EQU   ASXBCRB1
ASXBPIP  EQU   ASXBCRB1
ASXBCTDC EQU   ASXB+212
ASXBTDCB EQU   ASXB+208
ASXBRV19 EQU   ASXB+204
ASXBSENV EQU   ASXBSECR+1
ASXBRV34 EQU   ASCBSFLG
ASXBRV33 EQU   ASCBSFLG
ASXBRV32 EQU   ASCBSFLG
ASXBRV31 EQU   ASCBSFLG
ASXBRV30 EQU   ASCBSFLG
ASXBRV29 EQU   ASCBSFLG
ASXBRV28 EQU   ASCBSFLG
ASXBRV27 EQU   ASCBSFLG
ASXBUSER EQU   ASXB+192
ASXBLSRB EQU   ASXBAEQ+20
ASXBFSRB EQU   ASXBAEQ+16
ASXBLRQE EQU   ASXBAEQ+12
ASXBFRQE EQU   ASXBAEQ+8
ASXBLIQE EQU   ASXBAEQ+4
ASXBETSK EQU   ASXB+164
ASXBSIRB EQU   ASXB+160
ASXBPSWD EQU   ASXB+152
ASXBPRG  EQU   ASXB+136
ASXBRV26 EQU   ASXB+132
ASXBOUSB EQU   ASXB+128
ASXBDDR  EQU   ASXB+124
ASXBRCTD EQU   ASXB+120
ASXBRSMD EQU   ASXB+116
ASXBSPSA EQU   ASXB+112
ASXBFRWA EQU   ASXB+108
ASXBFLSA EQU   ASXB+36
ASXBIHSA EQU   ASXB+32
ASXBRV15 EQU   ASXB+28
ASXBRV14 EQU   ASXB+24
ASXBLWA  EQU   ASXB+20
ASXBMPST EQU   ASXB+16
ASXBRS00 EQU   ASXB+14
ASXBTCBS EQU   ASXB+12
ASXBLTCB EQU   ASXB+8
ASXBASXB EQU   ASXB
ASXBEGIN EQU   ASXB
ASCBEND  EQU   ASCB+208
ASCBSRBT EQU   ASCB+200
ASCBSWTL EQU   ASCB+196
ASCBRS14 EQU   ASCB+195
ASCBSMCT EQU   ASCB+194
ASCBRS12 EQU   ASCB+192
ASCBPCTT EQU   ASCB+188
ASCBVGTT EQU   ASCB+184
ASCBRV43 EQU   ASCBSRQ4
ASCBRV42 EQU   ASCBSRQ4
ASCBRV41 EQU   ASCBSRQ4
ASCBRV40 EQU   ASCBSRQ4
ASCBRV39 EQU   ASCBSRQ4
ASCBRV38 EQU   ASCBSRQ4
ASCBRV37 EQU   ASCBSRQ4
ASCBRV36 EQU   ASCBSRQ4
ASCBRV35 EQU   ASCBSRQ3
ASCBRV34 EQU   ASCBSRQ3
ASCBRV33 EQU   ASCBSRQ3
ASCBRV32 EQU   ASCBSRQ3
ASCBRV31 EQU   ASCBSRQ3
ASCBRV30 EQU   ASCBSRQ3
ASCBRV29 EQU   ASCBSRQ3
ASCBRV28 EQU   ASCBSRQ3
ASCBRV27 EQU   ASCBSRQ2
ASCBRV26 EQU   ASCBSRQ2
ASCBRV25 EQU   ASCBSRQ2
ASCBRV24 EQU   ASCBSRQ2
ASCBRV23 EQU   ASCBSRQ2
ASCBRV22 EQU   ASCBSRQ2
ASCBRV21 EQU   ASCBSRQ2
ASCBRV20 EQU   ASCBSRQ2
ASCBRV19 EQU   ASCBSRQ1
ASCBRV18 EQU   ASCBSRQ1
ASCBRV17 EQU   ASCBSRQ1
ASCBRV16 EQU   ASCBSRQ1
ASCBRV15 EQU   ASCBSRQ1
ASCBRV14 EQU   ASCBSRQ1
ASCBRV13 EQU   ASCBSRQ1
ASCBSTA  EQU   ASCBSRQ1
ASCBJBNS EQU   ASCB+176
ASCBJBNI EQU   ASCB+172
ASCBMCC  EQU   ASCB+168
ASCBRTWA EQU   ASCB+164
ASCBIQEA EQU   ASCB+160
ASCBXMPQ EQU   ASCB+156
ASCBRS01 EQU   ASCB+154
ASCBFMCT EQU   ASCB+152
ASCBOUXB EQU   ASCB+148
ASCBOUCB EQU   ASCB+144
ASCBMECB EQU   ASCB+140
ASCBQECB EQU   ASCB+136
ASCBLSQH EQU   ASCBLKGP+4
ASCBLOCK EQU   ASCBLKGP
ASCBTCBS EQU   ASCB+124
ASCBNVSC EQU   ASCB+122
ASCBVSC  EQU   ASCB+120
ASCBSRBS EQU   ASCB+118
ASCBSSRB EQU   ASCB+116
ASCBRV06 EQU   ASCBFLG2
ASCBRV05 EQU   ASCBFLG2
ASCBRV04 EQU   ASCBFLG2
ASCBSNQS EQU   ASCBFLG2
ASCBS2S  EQU   ASCBFLG2
ASCBCEXT EQU   ASCBFLG2
ASCBPXMT EQU   ASCBFLG2
ASCBXMPT EQU   ASCBFLG2
ASCBRF07 EQU   ASCBDSP1
ASCBRF06 EQU   ASCBDSP1
ASCBRF05 EQU   ASCBDSP1
ASCBRF04 EQU   ASCBDSP1
ASCBRF03 EQU   ASCBDSP1
ASCBRF02 EQU   ASCBDSP1
ASCBFAIL EQU   ASCBDSP1
ASCBNOQ  EQU   ASCBDSP1
ASCBSWCT EQU   ASCB+112
ASCBTMCH EQU   ASCB+104
ASCBNSWP EQU   ASCBFLG1
ASCBTYP1 EQU   ASCBFLG1
ASCBSTND EQU   ASCBFLG1
ASCBABNT EQU   ASCBFLG1
ASCBTERM EQU   ASCBFLG1
ASCBS3S  EQU   ASCBFLG1
ASCBCMSH EQU   ASCBFLG1
ASCBTOFF EQU   ASCBFLG1
ASCBRF01 EQU   ASCBRCTF
ASCBTMLW EQU   ASCBRCTF
ASCBOUT  EQU   ASCBRCTF
ASCBWAIT EQU   ASCBRCTF
ASCBRV08 EQU   ASCBRCTF
ASCBFQU  EQU   ASCBRCTF
ASCBFRS  EQU   ASCBRCTF
ASCBTMNO EQU   ASCBRCTF
ASCBAFFN EQU   ASCBFW1
ASCBDUMP EQU   ASCB+96
ASCBRV44 EQU   ASCB+92
ASCBUBET EQU   ASCB+88
ASCBECB  EQU   ASCB+84
ASCBJSTL EQU   ASCB+80
ASCBEWST EQU   ASCB+72
ASCBEJST EQU   ASCB+64
ASCBTSB  EQU   ASCB+60
ASCBCSCB EQU   ASCB+56
ASCBRSM  EQU   ASCB+52
ASCBLDA  EQU   ASCB+48
ASCBSTOR EQU   ASCB+44
ASCBDP   EQU   ASCB+43
ASCBRV07 EQU   ASCB+42
ASCBIOSM EQU   ASCB+40
ASCBSEQN EQU   ASCB+38
ASCBASID EQU   ASCB+36
ASCBCPUS EQU   ASCB+32
ASCBSPL  EQU   ASCB+28
ASCBIOSP EQU   ASCB+24
ASCBSYNC EQU   ASCBSUPC+4
ASCBSVRB EQU   ASCBSUPC
ASCBCMSF EQU   ASCB+12
ASCBBWDP EQU   ASCB+8
ASCBFWDP EQU   ASCB+4
ASCBASCB EQU   ASCB
ASCBEGIN EQU   ASCB
ABDSAVE1 EQU   ABDAREA+672
ABDSAVHD EQU   ABDAREA+592
ABDPADC  EQU   ABDAREA+589
ABDLINE  EQU   ABDLINEA+1
ABDSRC2  EQU   ABDAREA+382
ABDLOG   EQU   ABDAREA+380
ABDSRC1  EQU   ABDAREA+378
ABDPHY   EQU   ABDAREA+376
ABDLCNT  EQU   ABDAREA+372
@NM00123 EQU   ESPARM+29
@NM00122 EQU   ESTAEFLG
EDCB     EQU   ESTAEFLG
ETCB     EQU   ESTAEFLG
ESUBSYT  EQU   ESTAEFLG
ERESTART EQU   ESPARM+24
EMODNAME EQU   ESPARM+16
EABDAREA EQU   ESPARM+12
ESAUTOP  EQU   ESPARM+8
ESBSREG2 EQU   ESPARM+4
ESBSREG  EQU   ESPARM
ABDRTRN  EQU   ABDAREA+336
ABDSVCB  EQU   ABDAREA+332
@NM00121 EQU   ABDGMA+14
ABDCDID  EQU   ABDGMA+12
ABDPAREA EQU   ABDGMA+8
ABDBUFSZ EQU   ABDBUFFS+4
ABDBUFAD EQU   ABDBUFFS
ABSLCTSV EQU   ABDAREA+304
ABDSTADS EQU   ABDAREA+300
ABDUPRID EQU   ABDAREA+296
ABDPCAP  EQU   ABDAREA+295
ABDLLNGH EQU   ABDAREA+294
ABDINCPL EQU   ABDAREA+292
ABDFWORK EQU   ABDAREA+288
ABDIDENT EQU   ABDAREA+286
ABDIND   EQU   ABDAREA+284
ABDSIZE  EQU   ABDAREA+280
ABDLENTH EQU   ABDAREA+276
ABDBLOCK EQU   ABDAREA+272
ABDSTAD  EQU   ABDAREA+268
@NM00120 EQU   ABDBLNKS
@NM00119 EQU   ABDBLNKS
@NM00118 EQU   ABDBLNKS
@NM00117 EQU   ABDBLNKS
@NM00116 EQU   ABDBLNKS
@NM00115 EQU   ABDBLNKS
@NM00114 EQU   ABDBLNKS
ABDBLKN3 EQU   ABDBLNKS
@NM00113 EQU   ABDUPRFN
@NM00112 EQU   ABDUPRFN
@NM00111 EQU   ABDUPRFN
@NM00110 EQU   ABDUPRFN
@NM00109 EQU   ABDUPRFN
@NM00108 EQU   ABDUPRFN
ABDUPRSL EQU   ABDUPRFN
ABDUPRPM EQU   ABDUPRFN
@NM00107 EQU   ABDUPRF
@NM00106 EQU   ABDUPRF
@NM00105 EQU   ABDUPRF
@NM00104 EQU   ABDUPRF
@NM00103 EQU   ABDUPRF
UPRFMT20 EQU   ABDUPRF
UPRFMET  EQU   ABDUPRF
UPRFMAT  EQU   ABDUPRF
ABDFMTWK EQU   ABDAREA+256
ABDLPTR  EQU   ABDAREA+252
ABDSSPAR EQU   ABDAREA+188
@NM00102 EQU   ABDRES1
ABDPGHD  EQU   ABDRES1
ABDFMTLD EQU   ABDRES1
ABDSQA   EQU   ABDRES1
ABDOLSQA EQU   ABDRES1
ABDREGS  EQU   ABDRES1
ABDPSW   EQU   ABDRES1
ABDKEY   EQU   ABDAREA+138
ABDLSQA  EQU   ABDFLAG2
ABDSWAP  EQU   ABDFLAG2
ABDGTFCL EQU   ABDFLAG2
ABDTRNAV EQU   ABDFLAG2
ABDTRBIT EQU   ABDFLAG2
ABDGTF   EQU   ABDFLAG2
ABDSUPER EQU   ABDFLAG2
ABDIDX   EQU   ABDFLAG1
ABDSPHD  EQU   ABDFLAG1
ABDSVCHD EQU   ABDFLAG1
ABDSQSDM EQU   ABDFLAG1
ABDLSTHD EQU   ABDFLAG1
ABDQCBMN EQU   ABDFLAG1
ABDQCBMJ EQU   ABDFLAG1
ABDQCBHD EQU   ABDFLAG1
ABDPGWK  EQU   ABDAREA+128
ABDRESV3 EQU   ABDAREA+116
ABDUPRXT EQU   ABDAREA+112
ABDCP1   EQU   ABDAREA+108
ABDLP    EQU   ABDAREA+104
ABDFP    EQU   ABDAREA+100
ABDCP    EQU   ABDAREA+96
ABDPTRS3 EQU   ABDPTRS+8
ABDPTRS2 EQU   ABDPTRS+4
ABDPTRS1 EQU   ABDPTRS
ABDPCTR  EQU   ABDAREA+82
ABDLCTR  EQU   ABDAREA+80
ABDIOBP  EQU   ABDAREA+76
ABDPTR   EQU   ABDAREA+72
ABDDCB   EQU   ABDAREA+68
ABDLEN   EQU   ABDAREA+66
ABDTYPE  EQU   ABDAREA+64
ABDECB   EQU   ABDAREA+60
ABDSAVE  EQU   ABDAREA+56
ABDDECB  EQU   ABDAREA+52
ABDPARA  EQU   ABDAREA+48
ABDTABPT EQU   ABDAREA+44
ABDINXPT EQU   ABDAREA+40
ABDCTR   EQU   ABDAREA+38
ABDTRLN  EQU   ABDAREA+36
ABDHDRAD EQU   ABDPARMS+20
ABDSNAPP EQU   ABDPARMS+16
ABDPTCBP EQU   ABDPARMS+12
ABDPDCBP EQU   ABDPARMS+8
@NM00101 EQU   ABDPARMS+7
@NM00100 EQU   APFPDATA
APFSPALL EQU   APFPDATA
APFPSW   EQU   APFPDATA
APFJPA   EQU   APFPDATA
APFLPA   EQU   APFPDATA
APFREGS  EQU   APFPDATA
APFSAVE2 EQU   APFPDATA
APFSAVE  EQU   APFPDATA
@NM00099 EQU   APFSDAT1
APFERR   EQU   APFSDAT1
APFIO    EQU   APFSDAT1
APFDM    EQU   APFSDATA
APFQCB   EQU   APFSDATA
APFSUPDA EQU   APFSDATA
APFTRACE EQU   APFSDATA
APFSWA   EQU   APFSDATA
APFLSQA  EQU   APFSDATA
APFSQA   EQU   APFSDATA
APFNUC   EQU   APFSDATA
@NM00098 EQU   ABDPARMS+2
APFHDR   EQU   ABDFLAG
APFSNAPP EQU   ABDFLAG
APFTCB   EQU   ABDFLAG
APFID    EQU   ABDFLAG
APFABEND EQU   ABDFLAG
APFENVS2 EQU   ABDFLAG
APFVS2   EQU   ABDFLAG
APFSNAP  EQU   ABDFLAG
ABDPID   EQU   ABDPARMS
ABDCRB   EQU   ABDAREA+8
@NM00150 EQU   PSA+3668
PSASTAK  EQU   PSA+3072
@NM00149 EQU   PSA+1048
PSAUSEND EQU   PSA+1048
PSARV062 EQU   PSA+1044
PSACDAL  EQU   PSA+1040
PSAWTCOD EQU   PSA+1036
PSAATCVT EQU   PSA+1032
PSAPCPSW EQU   PSA+1024
PSAPIR2  EQU   PSA+1020
PSARV059 EQU   PSA+1018
PSASVC13 EQU   PSA+1016
PSALSFCC EQU   PSA+1012
PSASFACC EQU   PSA+1008
PSASTOP  EQU   PSA+992
PSASTART EQU   PSA+976
PSARSPSW EQU   PSA+968
PSASRPSW EQU   PSA+960
PSARV045 EQU   PSA+892
PSARV044 EQU   PSA+888
PSARV043 EQU   PSA+884
PSARV042 EQU   PSA+880
PSARV041 EQU   PSA+876
PSARV040 EQU   PSA+872
PSARV025 EQU   PSA+868
PSADSSED EQU   PSA+868
PSADSSPR EQU   PSA+864
PSADSSFW EQU   PSA+860
PSADSS14 EQU   PSA+856
PSADSSPP EQU   PSA+848
PSADSSRP EQU   PSA+840
PSADSS05 EQU   PSADSSF4
PSADSS10 EQU   PSADSSF4
PSADSSVE EQU   PSADSSF4
PSADSSDE EQU   PSADSSF4
PSADSSC0 EQU   PSADSSF4
PSADSSIE EQU   PSADSSF4
PSADSS12 EQU   PSADSSF4
PSADSSRC EQU   PSADSSF4
PSARV057 EQU   PSADSSF3
PSARV056 EQU   PSADSSF3
PSARV055 EQU   PSADSSF3
PSADSSMC EQU   PSADSSF3
PSADSSRW EQU   PSADSSF3
PSADSSNM EQU   PSADSSF3
PSADSSES EQU   PSADSSF3
PSADSSGP EQU   PSADSSF3
PSADSSF2 EQU   PSADSSFL+1
PSADSSPI EQU   PSADSSF1
PSADSSOI EQU   PSADSSF1
PSADSSSP EQU   PSADSSF1
PSADSSTP EQU   PSADSSF1
PSADSSDW EQU   PSADSSF1
PSADSSDD EQU   PSADSSF1
PSADSSDM EQU   PSADSSF1
PSADSSMV EQU   PSADSSF1
PSADSSTS EQU   PSA+816
PSADSSWK EQU   PSA+812
PSADSSR3 EQU   PSA+808
PSADSSR2 EQU   PSA+804
PSADSSRS EQU   PSA+800
PSASTOR  EQU   PSA+796
PSACPUSA EQU   PSA+794
PSAVSTAP EQU   PSA+792
PSAWKVAP EQU   PSA+788
PSAWKRAP EQU   PSA+784
PSAMCHIC EQU   PSA+783
PSARV061 EQU   PSA+782
PSASYMSK EQU   PSA+781
PSAMCHFL EQU   PSA+780
PSACR0   EQU   PSA+776
PSAPSWSV EQU   PSA+768
PSACLHS  EQU   PSAHLHI
PSALKR15 EQU   PSALKSA+60
PSALKR14 EQU   PSALKSA+56
PSALKR13 EQU   PSALKSA+52
PSALKR12 EQU   PSALKSA+48
PSALKR11 EQU   PSALKSA+44
PSALKR10 EQU   PSALKSA+40
PSALKR9  EQU   PSALKSA+36
PSALKR8  EQU   PSALKSA+32
PSALKR7  EQU   PSALKSA+28
PSALKR6  EQU   PSALKSA+24
PSALKR5  EQU   PSALKSA+20
PSALKR4  EQU   PSALKSA+16
PSALKR3  EQU   PSALKSA+12
PSALKR2  EQU   PSALKSA+8
PSALKR1  EQU   PSALKSA+4
PSALKR0  EQU   PSALKSA
PSARV023 EQU   PSACLHT+52
PSALOCAL EQU   PSACLHT+48
PSACMSL  EQU   PSACLHT+44
PSAOPTL  EQU   PSACLHT+40
PSATPACL EQU   PSACLHT+36
PSATPDNL EQU   PSACLHT+32
PSATPNCL EQU   PSACLHT+28
PSAIOSLL EQU   PSACLHT+24
PSAIOSUL EQU   PSACLHT+20
PSAIOSCL EQU   PSACLHT+16
PSAIOSSL EQU   PSACLHT+12
PSASALCL EQU   PSACLHT+8
PSAASML  EQU   PSACLHT+4
PSADISPL EQU   PSACLHT
PSASRSA  EQU   PSA+636
PSARV050 EQU   PSA+634
PSADSSGO EQU   PSA+633
PSARECUR EQU   PSA+632
PSAHLHIS EQU   PSA+628
PSAIPCSA EQU   PSA+624
@NM00148 EQU   PSA+621
PSAIPCDM EQU   PSA+620
PSAIPCD  EQU   PSA+616
@NM00147 EQU   PSA+613
PSAIPCRM EQU   PSA+612
PSAIPCR  EQU   PSA+608
PSAMCHEX EQU   PSA+600
PSAMPSW  EQU   PSA+592
PSAEXPS2 EQU   PSA+584
PSAEXPS1 EQU   PSA+576
PSAPIREG EQU   PSA+572
PSARSREG EQU   PSA+568
PSAGPREG EQU   PSA+556
PSARV022 EQU   PSASUP4
PSARV021 EQU   PSASUP4
PSARV020 EQU   PSASUP4
PSARV019 EQU   PSASUP4
PSARV018 EQU   PSASUP4
PSARV017 EQU   PSASUP4
PSARV016 EQU   PSASUP4
PSARV015 EQU   PSASUP4
PSARV014 EQU   PSASUP3
PSARV013 EQU   PSASUP3
PSARV012 EQU   PSASUP3
PSAESTA  EQU   PSASUP3
PSASPR   EQU   PSASUP3
PSAPSREG EQU   PSASUP3
PSAPI2   EQU   PSASUP3
PSAIOSUP EQU   PSASUP3
PSALCR   EQU   PSASUP2
PSARTM   EQU   PSASUP2
PSAACR   EQU   PSASUP2
PSAIPCE2 EQU   PSASUP2
PSAIPCES EQU   PSASUP2
PSAIPCEC EQU   PSASUP2
PSAGTF   EQU   PSASUP2
PSAIPCRI EQU   PSASUP2
PSATYPE6 EQU   PSASUP1
PSATCTL  EQU   PSASUP1
PSADISP  EQU   PSASUP1
PSALOCK  EQU   PSASUP1
PSAPI    EQU   PSASUP1
PSAEXT   EQU   PSASUP1
PSASVC   EQU   PSASUP1
PSAIO    EQU   PSASUP1
PSAANEW  EQU   PSA+544
PSATOLD  EQU   PSA+540
PSATNEW  EQU   PSA+536
PSALCCAR EQU   PSA+532
PSALCCAV EQU   PSA+528
PSAPCCAR EQU   PSA+524
PSAPCCAV EQU   PSA+520
PSACPULA EQU   PSA+518
PSACPUPA EQU   PSA+516
PSAPSA   EQU   PSA+512
FLCHDEND EQU   PSA+512
FLCCRSAV EQU   FLCMCLA+280
FLCGRSAV EQU   FLCMCLA+216
FLCFPSAV EQU   FLCMCLA+184
FLCFLA   EQU   FLCMCLA+88
FLCRGNCD EQU   FLCMCLA+84
FLCFSAA  EQU   FLCFSA+1
@NM00146 EQU   FLCFSA
@NM00145 EQU   FLCMCLA+72
FLCMCIC  EQU   FLCMCLA+64
@NM00144 EQU   FLCMCLA+20
FLCIOAA  EQU   FLCIOA+1
@NM00143 EQU   FLCIOA
@NM00142 EQU   FLCMCLA+15
@NM00141 EQU   FLCMCLA+14
@NM00140 EQU   FLCMCLA+12
FLCLCL   EQU   FLCMCLA+8
FLCIOELA EQU   FLCIOEL+1
@NM00139 EQU   FLCIOEL
FLCCHNID EQU   FLCMCLA
@NM00138 EQU   PSA+160
FLCMTRCD EQU   PSA+157
@NM00137 EQU   PSA+156
FLCPERA  EQU   FLCPER+1
@NM00136 EQU   FLCPER
@NM00135 EQU   PSA+151
FLCPERCD EQU   PSA+150
FLCMCNUM EQU   PSA+149
@NM00134 EQU   PSA+148
FLCTEAA  EQU   FLCTEA+1
@NM00133 EQU   FLCTEA
PSAPIPC  EQU   PSAPICOD
PSAPIMC  EQU   PSAPICOD
PSAPIPER EQU   PSAPICOD
PSARV049 EQU   FLCPICOD
FLCPILCB EQU   FLCPIILC
@NM00132 EQU   FLCPIILC
@NM00131 EQU   PSAEPPSW
FLCSVCN  EQU   PSAESPSW+2
FLCSILCB EQU   FLCSVILC
@NM00130 EQU   FLCSVILC
@NM00129 EQU   PSAESPSW
FLCEICOD EQU   PSAEEPSW+2
PSASPAD  EQU   PSAEEPSW
@NM00128 EQU   PSA+128
FLCINPSW EQU   PSA+120
FLCMNPSW EQU   PSA+112
FLCPNPSW EQU   PSA+104
FLCSNPSW EQU   PSA+96
FLCENPSW EQU   PSA+88
FLCTRACE EQU   PSA+84
FLCTIMER EQU   PSA+80
FLCCVT2  EQU   PSA+76
FLCCAW   EQU   PSA+72
FLCCSW   EQU   PSA+64
FLCIOPSW EQU   PSA+56
FLCMOPSW EQU   PSA+48
FLCPOPSW EQU   PSA+40
FLCSOPSW EQU   PSA+32
FLCEOPSW EQU   PSA+24
@NM00127 EQU   FLCICCW2+4
FLCCVT   EQU   FLCICCW2
FLCICCW1 EQU   FLCROPSW
FLCIPPSW EQU   FLCRNPSW
.@UNREFD ANOP                          END UNREFERENCED COMPONENTS
@RT00118 EQU   IQELP
@RT00120 EQU   IQELP
@RT00127 EQU   FREERET
@RT00135 EQU   FREERET
@RT00139 EQU   FREERET
@RT00142 EQU   FREERET
@RT00146 EQU   PQEOUT
@RF00185 EQU   FREEBAD
@RT00187 EQU   FREEBAD
@RT00211 EQU   DISPACHK
@RT00239 EQU   OTCLOOP
@RT00246 EQU   OUTSLOOP
@RT00250 EQU   DISPACHK
@RT00259 EQU   DISPACHK
@RT00268 EQU   DISPACHK
@RT00272 EQU   DISPACHK
@RT00278 EQU   DISPACHK
@RT00281 EQU   FMDQE
@RF00281 EQU   OUTSLOOP
@RT00291 EQU   DISPACHK
@RT00295 EQU   DISPACHK
@RT00302 EQU   DISPACHK
@RT00306 EQU   DISPACHK
@RT00309 EQU   NXTDQE
@RT00320 EQU   FREERET
@RT00324 EQU   FREERET
@RT00327 EQU   FREERET
@RT00337 EQU   FREERET
@RT00341 EQU   FREERET
@RT00344 EQU   FREERET
@RT00347 EQU   FREERET
@RT00350 EQU   FREERET
@RT00361 EQU   GETFBQE
@RT00370 EQU   FREERET
@RT00373 EQU   FREERET
@RT00406 EQU   FREERET
@ENDDATA EQU   *
         END   IEAVAD05,(C'PLS1910',0701,77049)
