         TITLE 'IEAVAD06 - QCBS                                        *
                        '
IEAVAD06 CSECT ,                                                   0001
@MAINENT DS    0H                                                  0001
         USING *,@15                                               0001
         B     @PROLOG                                             0001
         DC    AL1(16)                                             0001
         DC    C'IEAVAD06  78.086'                                 0001
         DROP  @15
@PROLOG  ST    @14,12(,@13)                                        0001
         STM   @00,@12,20(@13)                                     0001
         BALR  @11,0                                               0001
@PSTART  DS    0H                                                  0001
         USING @PSTART,@11                                         0001
*                                                                  0056
*   /*****************************************************************/
*   /*                                                               */
*   /* THE ROUTINE ISSUES A CONDITIONAL GETMAIN FOR SPACE FOR A      */
*   /* REGISTER SAVE AREA AND FOR AUTOMATIC STORAGE. IF THE GETMAIN  */
*   /* FAILS, A RETURN CODE OF EIGHT IS PASSED TO THE CALLER.        */
*   /* OTHERWISE, SAVE AREA CHAINING IS PERFORMED                    */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0056
*   ABDARPTR=PARMPTR;               /* ESTABLISH PERMANENT BASE FOR
*                                      ABDUMP WORK AREA              */
         LR    ABDARPTR,PARMPTR                                    0056
*   PARMPTR=ADDR(ABDASIZE);         /* ESTABLISH INPUT PARAM FOR   0057
*                                      GETMAIN                       */
         LA    PARMPTR,ABDASIZE(,ABDARPTR)                         0057
*   GENERATE;                                                      0058
*                                                                  0058
*                                      /* ISSUE GETMAIN              */
         GETMAIN EC,LV=@ENDDATD-@DATD+72,SP=253,A=ABDGMA(ABDARPTR),    *
               MF=(E,(1))
*   /*****************************************************************/
*   /*                                                               */
*   /* IF GETMAIN FAILED, RETURN TO CALLER WITH CODE OF EIGHT        */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0059
*   IF RETCODE^=0                   /* GETMAIN FAIL                  */
*     THEN                          /* YES                           */
         LTR   RETCODE,RETCODE                                     0059
         BZ    @RF00059                                            0059
*     DO;                           /* EXIT                          */
*       RETCODE=8;                  /* SET RETURN CODE        @Y02705*/
         LA    RETCODE,8                                           0061
*       RETURN;                     /* BACK TO CALLER                */
@EL00001 DS    0H                                                  0062
@EF00001 DS    0H                                                  0062
@ER00001 L     @14,12(,@13)                                        0062
         LM    @00,@12,20(@13)                                     0062
         BR    @14                                                 0062
*     END;                                                         0063
*   ELSE                                                           0064
*     ;                             /* CHAIN SAVE AREAS      @YM03623*/
@RF00059 DS    0H                                                  0065
*   PARMPTR=ABDAAREA;               /* GET PTR TO SAVE AREA          */
         L     PARMPTR,ABDAAREA(,ABDARPTR)                         0065
*   AUTOPTR=PARMPTR+72;             /* SET ADDRESS OF AUTOMATIC    0066
*                                      STORAGE                       */
         LA    AUTOPTR,72                                          0066
         ALR   AUTOPTR,PARMPTR                                     0066
*   GENERATE;                                                      0067
*                                      /* INITIALIZE AUTO SPACE      */
         USING @DATD,AUTOPTR
         XC    0(@ENDDATD-@DATD,AUTOPTR),0(AUTOPTR)   0 SPACE
*   NEXTSAVE=PARMPTR;               /* SET ADDR OF NEW SAVE AREA IN
*                                      CALERS SAVE AREA              */
         ST    PARMPTR,NEXTSAVE(,SAVEAREA)                         0068
*   PREVSAVE=SAVEAREA;              /* SET ADDR OF CALLERS SAVE AREA
*                                      IN NEW SAVE AREA              */
         ST    SAVEAREA,PREVSAVE(,PARMPTR)                         0069
*   SAVEAREA=PARMPTR;               /* SET R13 TO NEW SAVE AREA      */
         LR    SAVEAREA,PARMPTR                                    0070
*   TCBPTR=ABDCTCB;                 /* SET TCB BASE TO CURRENT TASKS
*                                      TCB                           */
*                                                                  0071
         L     TCBPTR,ABDCTCB(,ABDARPTR)                           0071
*   /*****************************************************************/
*   /*                                                               */
*   /* THE TASK STRUCTURE MUST BE FROZEN FOR THE DURATION OF QCB     */
*   /* PROCESSING. MAINLINE SET THE TREE NONDISPATCHABLE IF THE DUMP */
*   /* IS OF THE CURRENT TASK. THEREFORE, THIS LOGIC IF DUMP IS NOT  */
*   /* OF THE CURRENT TASK                                           */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0072
*   IF TCBPTR=ABDTCB                /* DUMP OF CURRENT TASK          */
*     THEN                          /* YES                           */
         C     TCBPTR,ABDTCB(,ABDARPTR)                            0072
         BNE   @RF00072                                            0072
*     DO;                           /* FREEZE TREE                   */
*       IF TCBLTC^=0&               /* DOES TASK LEAVE DAU.          */
*           TCBLTC->TCBJSTCB=TCBLTC /* WHICH IS A JS TASK            */
*         THEN                                                     0074
         L     @14,TCBLTC(,TCBPTR)                                 0074
         LTR   @14,@14                                             0074
         BZ    @RF00074                                            0074
         C     @14,TCBJSTCB(,@14)                                  0074
         BE    @RT00074                                            0074
*         ;                         /* YES, DO NOT SET ND            */
*       ELSE                                                       0076
*         DO;                                                      0076
@RF00074 DS    0H                                                  0077
*           TCBADMP='1'B;           /* INDICATE TASK THAT SET TREE 0077
*                                      NONDISPATCHABLE               */
         OI    TCBADMP(TCBPTR),B'00000010'                         0077
*           ABDSTAT='1'B;           /* IND STATUS ISSUED     @YM06195*/
         OI    ABDSTAT(ABDARPTR),B'00000010'                       0078
*           GENERATE;                                              0079
*                                      /* SET TREE NONDISPATCHABLE   */
         STATUS SET,ND,STEP,(1)
*         END;                                                     0080
*     END;                                                         0081
*   ELSE                                                           0082
*     ;                             /* BYPASS STATUS LOGIC           */
*                                                                  0082
@RF00072 DS    0H                                                  0083
*   /*****************************************************************/
*   /*                                                               */
*   /* SINCE THE QCB QUEUE IS ON A SYSTEM BASIS THE ROUTINE MUST BE  */
*   /* LOCKED WHILE SEARCHING FOR A QCB TO DISPLAY THEREFORE, THE    */
*   /* LOCAL AND CMS LOCKS ARE OBTAINED                              */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0083
*QCBEGIN:                                                          0083
*   GENERATE REFS(PSALITA,ABDWORK);                                0083
*                                                                  0083
@RC00072 DS    0H                                                  0083
QCBEGIN  DS    0H                                                  0083
*                                        /*                   @Y02705*/
         STM   11,14,ABDWORK(ABDARPTR)                        @Y02705
         SETLOCK OBTAIN,MODE=UNCOND,TYPE=LOCAL,               @Y02705  C
               RELATED=(QCB,IEAVAD06(QCBEGIN))                @Y02705
         SETLOCK OBTAIN,MODE=UNCOND,TYPE=CMS,                 @Y02705  C
               RELATED=(QCB,IEAVAD06(QCBEGIN))                @Y02705
         LM    11,14,ABDWORK(ABDARPTR)                        @Y02705
*   /*****************************************************************/
*   /*                                                               */
*   /* FIND THE ORIGIN OF THE QCB QUEUE                              */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0084
*   CVTPTR=FLCCVT;                  /* GET ADDRESS OF THE CVT        */
         L     CVTPTR,FLCCVT                                       0084
*   QCBMAPTR=CVTFQCB;               /* GET ADDR OF FIRST QCB ON QUEUE*/
         L     QCBMAPTR,CVTFQCB(,CVTPTR)                           0085
*MOREQCB:                           /* REENTER FOR EACH MAJOR QCB    */
*                                                                  0086
*   /*****************************************************************/
*   /*                                                               */
*   /* WHEN THE LAST MAJOR QCB HAS BEEN PROCESSED WITHOUT            */
*   /* ENCOUNTERING ANY ERRORS, THE ROUTINE SETS THE RETURN CODE TO  */
*   /* ZERO AND ENABLES INTERRUPTS.                                  */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0086
*   IF QCBMAPTR=0                   /* ALL QCBS PROCESSED            */
*     THEN                          /* YES                           */
MOREQCB  LTR   QCBMAPTR,QCBMAPTR                                   0086
         BNZ   @RF00086                                            0086
*     DO;                           /* NORMAL EXIT                   */
*       SAVERET=0;                  /* SET RETURN CODE               */
         SLR   SAVERET,SAVERET                                     0088
*       GENERATE REFS(PSALITA,ABDWORK);                            0089
*                                      /*                     @Y02705*/
         STM   11,14,ABDWORK(ABDARPTR)                        @Y02705
         SETLOCK RELEASE,TYPE=CMS,RELATED=(QCB,IEAVAD06(MOREQCB))
         SETLOCK RELEASE,TYPE=LOCAL,RELATED=(QCB,IEAVAD06(MOREQCB))
         LM    11,14,ABDWORK(ABDARPTR)                        @Y02705
*COMEXIT:                           /* COMMON EXIT LOGIC FOR BOTH  0090
*                                      NORMAL AND ABNORMAL END       */
*                                                                  0090
*       /*************************************************************/
*       /*                                                           */
*       /* IF ROUTINE SET TREE OF TASKS NONDISPATCHABLE IT MUST RESET*/
*       /* THEM                                                      */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0090
*       IF TCBPTR=ABDTCB            /* DUMP OF CURRENT TASK          */
*         THEN                      /* YES, TREE WAS SET             */
COMEXIT  C     TCBPTR,ABDTCB(,ABDARPTR)                            0090
         BNE   @RF00090                                            0090
*         DO;                       /* RESET TREE                    */
*           IF TCBLTC^=0&           /* DOES TASK HAVE DAU     @Y02705*/
*               TCBLTC->TCBJSTCB=TCBLTC/* WHICH IS A JS TASK         */
*             THEN                                                 0092
         L     @14,TCBLTC(,TCBPTR)                                 0092
         LTR   @14,@14                                             0092
         BZ    @RF00092                                            0092
         C     @14,TCBJSTCB(,@14)                                  0092
         BE    @RT00092                                            0092
*             ;                     /* YES DO NOT SET ND             */
*           ELSE                    /*                        @Y02705*/
*             DO;                                                  0094
@RF00092 DS    0H                                                  0095
*               ABDSTAT='0'B;       /* IND STAT RESET        @YM06195*/
         NI    ABDSTAT(ABDARPTR),B'11111101'                       0095
*               GENERATE;                                          0096
*                                      /* ISSUE STATUS SVC           */
         STATUS RESET,ND,STEP,(1)
*               TCBADMP='0'B;       /* RESET BIT INDICATING THAT TASK
*                                      SET TREE NONDISPATCHABLE      */
         NI    TCBADMP(TCBPTR),B'11111101'                         0097
*             END;                                                 0098
*         END;                                                     0099
*       ELSE                                                       0100
*         ;                         /* BYPASS STATUS LOGIC           */
@RF00090 DS    0H                                                  0101
*       PARMPTR=SAVEAREA;           /* SET ADDR OF DYNAMIC STORAGE 0101
*                                      FOR FREEMAIN                  */
@RC00090 LR    PARMPTR,SAVEAREA                                    0101
*       SAVEAREA=PREVSAVE;          /* SET ADDR OF CALLERS SAVE AREA
*                                      IN R13                        */
         L     SAVEAREA,PREVSAVE(,PARMPTR)                         0102
*       GENERATE;                                                  0103
*                                      /* FREE DYNAMIC STORAGE       */
         L     R0,SIZECON              GET SIZE AND SP FOR 10
         SVC   10                FREE SPACE
         B     LABL                    BYPASS CONSTANT
         DS    0F
SIZECON  DC    AL1(253)                SUBPOOL NUMBER
         DC    AL3(@ENDDATD-@DATD+72)   SIZE OF SPACE
LABL     EQU   *
*       RETCODE=SAVERET;            /* PUT RETURN CODE IN RIGHT    0104
*                                      REGISTER                      */
         LR    RETCODE,SAVERET                                     0104
*       RETURN;                     /* BACK TO CALLER                */
         B     @EL00001                                            0105
*     END;                                                         0106
*   ELSE                                                           0107
*     ;                             /* PROCESS THIS MAJOR QCB        */
*                                                                  0107
@RF00086 DS    0H                                                  0108
*   /*****************************************************************/
*   /*                                                               */
*   /* GET ADDR OF MINOR QCB FROM MAJOR QCB                          */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0108
*   QCBMIPTR=MAJFMIN;                                              0108
         L     QCBMIPTR,MAJFMIN(,QCBMAPTR)                         0108
*MOREMIN:                           /* ENTERED FOR EACH MINOR ON A 0109
*                                      MAJOR QCB                     */
*                                                                  0109
*   /*****************************************************************/
*   /*                                                               */
*   /* WHEN THE LAST MINOR HAS BEEN PROCESSED, GET THE ADDRESS OF THE*/
*   /* NEXT MAJOR QCB, INDICATE THAT NEW MAJOR NOT DISPLAYED AND LOOP*/
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0109
*   IF QCBMIPTR=0                   /* LAST MINOR PROCESSED          */
*     THEN                          /* YES                           */
MOREMIN  LTR   QCBMIPTR,QCBMIPTR                                   0109
         BNZ   @RF00109                                            0109
*     DO;                           /* GET NEXT MAJOR                */
*       QCBMAPTR=MAJNMAJ;           /* GET ADDRESS NEXT MAJOR        */
         L     QCBMAPTR,MAJNMAJ(,QCBMAPTR)                         0111
*       ABDQCBMJ='0'B;              /* SET MAJOR NOT DISPLAYED       */
         NI    ABDQCBMJ(ABDARPTR),B'10111111'                      0112
*       GOTO MOREQCB;               /* PROCESS MAJOR                 */
         B     MOREQCB                                             0113
*     END;                                                         0114
*   ELSE                                                           0115
*     ;                             /* PROCESS MINOR                 */
@RF00109 DS    0H                                                  0116
*   QELSEPTR=MINFQEL;               /* GET ADDRESS OF FIRST QEL ON 0116
*                                      MINOR QCB                     */
         L     QELSEPTR,MINFQEL(,QCBMIPTR)                         0116
*MOREQEL:                           /* ENTERED FOR EACH QEL ON A   0117
*                                      MINOR QCB                     */
*                                                                  0117
*   /*****************************************************************/
*   /*                                                               */
*   /* WHEN THE LAST QEL HAS BEEN PROCESSED, SET TO HANDLE THE NEXT  */
*   /* MINOR QCB                                                     */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0117
*   IF QELSEPTR=0                   /* LAST QEL PROCESSED            */
*     THEN                          /* YES                           */
MOREQEL  LTR   QELSEPTR,QELSEPTR                                   0117
         BNZ   @RF00117                                            0117
*     DO;                           /* SET UP FOR NEXT MINOR         */
*       QCBMIPTR=MINNMIN;           /* GET ADDRESS NEXT MINOR        */
         L     QCBMIPTR,MINNMIN(,QCBMIPTR)                         0119
*       ABDQCBMN='0'B;              /* SET TO SHOW THAT MINOR NOT  0120
*                                      DISPLAYED                     */
         NI    ABDQCBMN(ABDARPTR),B'11011111'                      0120
*       GOTO MOREMIN;               /* PROCESS NEW MINOR             */
         B     MOREMIN                                             0121
*     END;                                                         0122
*   ELSE                                                           0123
*     ;                             /* PROCESS QEL                   */
*                                                                  0123
@RF00117 DS    0H                                                  0124
*   /*****************************************************************/
*   /*                                                               */
*   /* DETERMINE IF THE QEL BELONGS TO THE JOBSTEP CONTAINING THE    */
*   /* TASK BEING DISPLAYED. THIS IS THE CASE IF EITHER THE QEL WAS  */
*   /* CREATED FOR A REQUEST BY ANY TASK IN THE JOBSTEP OR IF THE QEL*/
*   /* WAS CREATED BY THE INITIATOR OF A NON KEY 0 NON TSO TASK CHECK*/
*   /* IF QEL CREATED FOR TASK IN THE SAME JOBSTEP AS THE TASK BEING */
*   /* DISPLAYED                                                     */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0124
*   RFY                                                            0124
*     R0 RSTD;                      /*                       @YM06194*/
*   R0=QELSEPTR;                    /* SAVE QEL PTR          @YM06194*/
         LR    R0,QELSEPTR                                         0125
*   IF QELXLIST='1'B                /* IS IT A SUB QEL?      @YM06194*/
*     THEN                          /* YES                   @YM06194*/
         TM    QELXLIST(QELSEPTR),B'10000000'                      0126
         BNO   @RF00126                                            0126
*     QELSEPTR=QELLQEL;             /* USE LIST QEL          @YM06194*/
         L     QELSEPTR,QELLQEL(,QELSEPTR)                         0127
*   IF QELASID=ASCBASID&            /* SAME ADDRESS SPACE    @YM06194*/
*       QELTCB->TCBJSTCA=TCBJSTCA   /* AND SAME JOBSTEP      @YM06194*/
*     THEN                          /* IF IT IS              @YM06194*/
@RF00126 L     @14,ASCBPTR                                         0128
         CLC   QELASID(2,QELSEPTR),ASCBASID(@14)                   0128
         BNE   @RF00128                                            0128
         L     @14,QELTCB(,QELSEPTR)                               0128
         CLC   TCBJSTCA(3,@14),TCBJSTCA(TCBPTR)                    0128
         BNE   @RF00128                                            0128
*     DO;                                                          0129
*       QELSEPTR=R0;                /* RESTORE QEL PTR       @YM06194*/
         LR    QELSEPTR,R0                                         0130
*       GOTO DISPLAY;               /* DISPLAY CONTROL BLOCKS      0131
*                                                            @YM06194*/
         B     DISPLAY                                             0131
*     END;                                                         0132
*   ELSE                                                           0133
*     ;                             /* CONTINUE CHECKS               */
*                                                                  0133
@RF00128 DS    0H                                                  0134
*   /*****************************************************************/
*   /*                                                               */
*   /* CHECK IF QEL CREATED BY INITIATOR OF A NON KEY 0 TASK. THIS   */
*   /* WOULD BE A PROBLEM PROGRAM TASK WITHIN THE USUAL MEANING OF   */
*   /* THE TERM                                                      */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0134
*   IF QELASID=ASCBASID&            /* SAME ASID?            @YM06194*/
*       TCBFLAG^='0000'B&           /* TASK NOT KEY 0        @YM06194*/
*       QELTCB=TCBJSTCB->TCBOTC     /* CREATING TASK IS THE INITIATOR
*                                      OF THE JOBSTEP                */
*     THEN                          /* OKAY TO DISPLAY CB            */
         L     @14,ASCBPTR                                         0134
         CLC   QELASID(2,QELSEPTR),ASCBASID(@14)                   0134
         BNE   @RF00134                                            0134
         TM    TCBFLAG(TCBPTR),B'11110000'                         0134
         BZ    @RF00134                                            0134
         L     @14,TCBJSTCB(,TCBPTR)                               0134
         CLC   QELTCB(4,QELSEPTR),TCBOTC(@14)                      0134
         BNE   @RF00134                                            0134
*     DO;                           /* YES                   @YM06194*/
*       QELSEPTR=R0;                /* RESTORE QEL PTR       @YM06194*/
         LR    QELSEPTR,R0                                         0136
*       GOTO DISPLAY;               /* DISPLAY CONTROL BLOCKS        */
         B     DISPLAY                                             0137
*     END;                                                         0138
*   ELSE                            /* TRY NEXT QEL                  */
*     QELSEPTR=R0;                  /* RESTORE QEL PTR       @YM06194*/
@RF00134 LR    QELSEPTR,R0                                         0139
*   RFY                                                            0140
*     R0 UNRSTD;                    /*                       @YM06194*/
*NEXTQEL:                           /* ENTERED TO GET ADDR OF NEXT 0141
*                                      QEL                           */
*   QELSEPTR=QELNQEL;               /* GET ADDRESS NEXT QEL          */
NEXTQEL  L     QELSEPTR,QELNQEL(,QELSEPTR)                         0141
*   GOTO MOREQEL;                   /* PROCESS NEW QEL               */
         B     MOREQEL                                             0142
*DISPLAY:                           /* ENTERED TO DISPLAY THE MAJOR
*                                      AND MINOR QCB AND THE QEL     */
*                                                                  0143
*   /*****************************************************************/
*   /*                                                               */
*   /* ROUTINE MUST ENABLE WHILE DISPLAYING CONTROL BLOCKS           */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0143
*   GENERATE REFS(PSALITA,ABDWORK);                                0143
*                                                                  0143
DISPLAY  DS    0H                                                  0143
*                                        /*                   @Y02705*/
         STM   11,14,ABDWORK(ABDARPTR)
         SETLOCK RELEASE,TYPE=CMS,RELATED=(QCB,IEAVAD06(DISPLAY))
         SETLOCK RELEASE,TYPE=LOCAL,RELATED=(QCB,IEAVAD06(DISPLAY))
         LM    11,14,ABDWORK(ABDARPTR)
*   /*****************************************************************/
*   /*                                                               */
*   /* FREEZE GR 1 TO CONTAIN INPUT VALUE FOR ALL SUBROUTINE CALLS   */
*   /* USED IN THE FORMATTING LOGIC                                  */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0144
*   RESPECIFY                                                      0144
*     PARMPTR RESTRICTED;                                          0144
*   PARMPTR=ABDARPTR;               /* ESTABLISH INPUT FOR SUBROUTINE
*                                      CALLS                         */
*                                                                  0145
         LR    PARMPTR,ABDARPTR                                    0145
*   /*****************************************************************/
*   /*                                                               */
*   /* SINCE IT IS POSSIBLE TO HAVE MORE THAN ONE QEL BELONGING TO A */
*   /* SINGLE JOBSTEP ON A MINOR QCB AND SINCE THE MINOR IS ONLY     */
*   /* DISPLAYED ONCE, A SWITCH IS ESTABLISHED TO INDICATE WHETHER   */
*   /* THE CURRENT MINOR HAS BEEN DISPLAYED. AN ANALOGOUS SITUATION  */
*   /* EXISTS FOR MAJOR QCBS BYPASS DISPLAY OF MAJOR QCB IF ALREADY  */
*   /* DISPLAYED                                                     */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0146
*   IF ABDQCBMJ='0'B                /* WAS MAJOR PREVIOUSLY DISPLAYED*/
*     THEN                          /* NO                            */
         TM    ABDQCBMJ(ABDARPTR),B'01000000'                      0146
         BNZ   @RF00146                                            0146
*     DO;                           /* DISPLAY THE MAJOR             */
*                                                                  0147
*       /*************************************************************/
*       /*                                                           */
*       /* IF THIS IS THE FIRST MAJOR QCB TO BE DISPLAYED THEN WRITE */
*       /* THE HEADING FOR THE RESOURCE PORTION OF THE DUMP          */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0148
*       IF ABDQCBHD='0'B            /* IS THIS THE FIRST MAJOR TO BE
*                                      DISPLAYED                     */
*         THEN                      /* YES                           */
         TM    ABDQCBHD(ABDARPTR),B'10000000'                      0148
         BNZ   @RF00148                                            0148
*         DO;                       /* WRITE HEADING                 */
*           HEAD=HEADING;           /* MOVE HEADING TO LINE          */
         MVC   HEAD(10,ABDARPTR),HEADING                           0150
*           PARMPTR=ABDARPTR;       /* PASS WORK AREA ADDR           */
         LR    PARMPTR,ABDARPTR                                    0151
*           CALL IEAVAD11;          /* CALL OUTPUT                   */
*                                                                  0152
         L     @15,@CV02226                                        0152
         BALR  @14,@15                                             0152
*           /*********************************************************/
*           /*                                                       */
*           /* IF OUTPUT FAILED RETURN TO CALLER                     */
*           /*                                                       */
*           /*********************************************************/
*                                                                  0153
*           IF RETCODE^=0           /* DID FAILURE OCCUR             */
*             THEN                  /* YES                           */
         LTR   RETCODE,RETCODE                                     0153
         BNZ   @RT00153                                            0153
*             GOTO COMEXIT;         /* START EXITING                 */
*           ELSE                                                   0155
*             ;                     /* KEEP GOING                    */
*           ABDQCBHD='1'B;          /* INDICATE HEADING HAS BEEN   0156
*                                      WRITTEN                       */
         OI    ABDQCBHD(ABDARPTR),B'10000000'                      0156
*         END;                                                     0157
*       ELSE                                                       0158
*         ;                         /* FORMAT THE MAJOR              */
@RF00148 DS    0H                                                  0159
*       ABDCC='F0'X;                /* SET TO DOUBLE SPACE LINE      */
         MVI   ABDCC(ABDARPTR),X'F0'                               0159
*       WORK=QCBMAPTR;              /* SET TO PUT MAJOR ADDR INTO  0160
*                                      LINE                          */
         ST    QCBMAPTR,WORK(,ABDARPTR)                            0160
*       ABDLLINE=ADDR(MAJLINE);     /* SET LAYOUT LINE ADDR          */
         LA    @14,MAJLINE                                         0161
         ST    @14,ABDLLINE(,ABDARPTR)                             0161
*       ABDBPTR=ADDR(WORK)+1;       /* SET ADDR OF DATA              */
         LA    @14,WORK(,ABDARPTR)                                 0162
         AH    @14,@CH00076                                        0162
         ST    @14,ABDBPTR(,ABDARPTR)                              0162
*       CALL IEAVAD31;              /* CALL FORMAT                   */
*                                                                  0163
         L     @15,@CV02227                                        0163
         BALR  @14,@15                                             0163
*       /*************************************************************/
*       /*                                                           */
*       /* IF ROUTINE FAILED FOR ANY REASON RETURN TO CALLER WITH    */
*       /* CODE                                                      */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0164
*       IF RETCODE^=0               /* ROUTINE FAILED                */
*         THEN                      /* YES                           */
         LTR   RETCODE,RETCODE                                     0164
         BNZ   @RT00164                                            0164
*         GOTO COMEXIT;             /* START EXITING                 */
*       ELSE                                                       0166
*         ;                         /* CONTINUE PROCESSING           */
*       ABDBPTR=QCBMAPTR;           /* SET TO FORMAT MAJOR QCB       */
         ST    QCBMAPTR,ABDBPTR(,ABDARPTR)                         0167
*       CALL IEAVAD41;              /* CALL FORMAT WITH NO         0168
*                                      INDENTATION FACTOR            */
*                                                                  0168
         L     @15,@CV02228                                        0168
         BALR  @14,@15                                             0168
*       /*************************************************************/
*       /*                                                           */
*       /* IF ROUTINE FAILED FOR ANY REASON RETURN TO CALLER WITH    */
*       /* CODE                                                      */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0169
*       IF RETCODE^=0               /* ROUTINE FAILED                */
*         THEN                      /* YES                           */
         LTR   RETCODE,RETCODE                                     0169
         BNZ   @RT00169                                            0169
*         GOTO COMEXIT;             /* START EXITING                 */
*       ELSE                                                       0171
*         ;                         /* CONTINUE PROCESSING           */
*       MAJORNM=MAJNAME;            /* INIT MAJOR NAME FLD           */
         MVC   MAJORNM(8,ABDARPTR),MAJNAME(QCBMAPTR)               0172
*       DO I=1 TO 8 BY 1;           /* MAX LENGTH OF MAJOR NAME      */
         LA    @14,1                                               0173
         ST    @14,I                                               0173
@DL00173 DS    0H                                                  0174
*         IF MAJNAME(I)>='C1'X&     /* IS CHARACTER IN PRINTABLE     */
*             MAJNAME(I)<='C9'X|    /* RANGE                  @Y02705*/
*             MAJNAME(I)>='D1'X&    /*                        @Y02705*/
*             MAJNAME(I)<='D9'X|    /*                        @Y02705*/
*             MAJNAME(I)>='E2'X&    /*                        @Y02705*/
*             MAJNAME(I)<='E9'X|    /*                        @Y02705*/
*             MAJNAME(I)>='F0'X&    /*                        @Y02705*/
*             MAJNAME(I)<='F9'X|    /*                       @YM06188*/
*             MAJNAME(I)='40'X|     /*                       @YM06188*/
*             MAJNAME(I)='4B'X      /*                       @YM08178*/
*           THEN                                                   0174
         ALR   @14,QCBMAPTR                                        0174
         CLI   MAJNAME-1(@14),X'C1'                                0174
         BL    @GL00010                                            0174
         L     @14,I                                               0174
         ALR   @14,QCBMAPTR                                        0174
         CLI   MAJNAME-1(@14),X'C9'                                0174
         BNH   @RT00174                                            0174
@GL00010 L     @14,I                                               0174
         ALR   @14,QCBMAPTR                                        0174
         CLI   MAJNAME-1(@14),X'D1'                                0174
         BL    @GL00009                                            0174
         L     @14,I                                               0174
         ALR   @14,QCBMAPTR                                        0174
         CLI   MAJNAME-1(@14),X'D9'                                0174
         BNH   @RT00174                                            0174
@GL00009 L     @14,I                                               0174
         ALR   @14,QCBMAPTR                                        0174
         CLI   MAJNAME-1(@14),X'E2'                                0174
         BL    @GL00008                                            0174
         L     @14,I                                               0174
         ALR   @14,QCBMAPTR                                        0174
         CLI   MAJNAME-1(@14),X'E9'                                0174
         BNH   @RT00174                                            0174
@GL00008 L     @14,I                                               0174
         ALR   @14,QCBMAPTR                                        0174
         CLI   MAJNAME-1(@14),X'F0'                                0174
         BL    @GL00007                                            0174
         L     @14,I                                               0174
         ALR   @14,QCBMAPTR                                        0174
         CLI   MAJNAME-1(@14),X'F9'                                0174
         BNH   @RT00174                                            0174
@GL00007 L     @14,I                                               0174
         ALR   @14,QCBMAPTR                                        0174
         CLI   MAJNAME-1(@14),X'40'                                0174
         BE    @RT00174                                            0174
         L     @14,I                                               0174
         ALR   @14,QCBMAPTR                                        0174
         CLI   MAJNAME-1(@14),X'4B'                                0174
         BE    @RT00174                                            0174
*           ;                       /* YES                    @Y02705*/
*         ELSE                                                     0176
*           DO;                                                    0176
*             GENERATE REFS(ABDFMTWK);                             0177
*                                /* CONVERT HEX MAJOR NAME.  @YM06188*/
         LA    15,8                     MAXIMUM OF 8 CHARS.    @YM06188
         LA    14,MAJNAME(5)            START OF MAJOR NAME.   @YM06188
         LA    10,MAJORNM(,ABDARPTR)    OUTPUT BUFFER LOCATION @YM06188
CONV1    EQU   *                                               @YM06188
         MVC   ABDFMTWK(1,2),0(14)     GET SINGLE INPUT BYTE.  @YM06188
         UNPK  ABDFMTWK(3,2),ABDFMTWK(2,2) CONVERT 1 BYTE + GARBAGE.
         MVC   0(2,10),ABDFMTWK(2)     PUT CONV BYTE IN BUF    @YM06188
         TR    0(2,10),TRNTBL-C'0'     MAKE IT PRINTABLE HEX.  @YM06188
         LA    14,1(0,14)               NEXT INPUT BYTE.       @YM06188
         LA    10,2(0,10)               NEXT LOC IN INPUT BUF  @YM06188
         BCT   15,CONV1                 PROCESS 8 CHARS.       @YM06188
         B     ENDCONV1                                        @YM06188
*                                                              @YM06188
K12      DC    H'12'                                           @YM06188
TRNTBL   DC    C'0123456789ABCDEF'      SHORT TRANSLATE TABLE. @YM06188
ENDCONV1 DS    0H                                              @YM06188
*             GOTO PMAJNME;         /*                        @Y02705*/
         B     PMAJNME                                             0178
*           END;                    /*                       @YM06188*/
*       END;                        /*                       @YM06188*/
@RT00174 LA    @14,1                                               0180
         AL    @14,I                                               0180
         ST    @14,I                                               0180
         CH    @14,@CH00205                                        0180
         BNH   @DL00173                                            0180
*PMAJNME:                           /*                       @YM06188*/
*       CALL IEAVAD11;              /* OUTPUT THE LINE       @YM06188*/
*                                                                  0181
PMAJNME  L     @15,@CV02226                                        0181
         BALR  @14,@15                                             0181
*       /*************************************************************/
*       /*                                                           */
*       /* IF ROUTINE FAILED FOR ANY REASON RETURN TO CALLER WITH    */
*       /* CODE                                                      */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0182
*       IF RETCODE^=0               /* ROUTINE FAILED                */
*         THEN                      /* YES                           */
         LTR   RETCODE,RETCODE                                     0182
         BNZ   @RT00182                                            0182
*         GOTO COMEXIT;             /* START EXITING                 */
*       ELSE                                                       0184
*         ;                         /* CONTINUE PROCESSING           */
*       ABDQCBMJ='1'B;              /* INDICATE CURRENT MAJOR HAS  0185
*                                      BEEN DISPLAYED                */
         OI    ABDQCBMJ(ABDARPTR),B'01000000'                      0185
*       GOTO FORMMIN;               /* GO DISPLAY MINOR              */
         B     FORMMIN                                             0186
*     END;                                                         0187
*   ELSE                                                           0188
*     ;                             /* CHECK MINOR                   */
*                                                                  0188
@RF00146 DS    0H                                                  0189
*   /*****************************************************************/
*   /*                                                               */
*   /* IF MINOR HAS NOT BEEN DISPLAYED THEN DISPLAY IT.              */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0189
*   IF ABDQCBMN='0'B                /* HAS MINOR BEEN DISPLAYED      */
*     THEN                          /* NO                            */
         TM    ABDQCBMN(ABDARPTR),B'00100000'                      0189
         BNZ   @RF00189                                            0189
*     DO;                           /* DISPLAY THE MINOR             */
*FORMMIN:                           /* ENTERED AFTER FORMATTING THE
*                                      MAJOR                         */
*       ABDCC='F0'X;                /* SET TO DOUBLE SPACE LINE      */
FORMMIN  MVI   ABDCC(ABDARPTR),X'F0'                               0191
*       WORK=QCBMIPTR;              /* SET TO DISPLAY ADDR OF MINOR
*                                      QCB                           */
         ST    QCBMIPTR,WORK(,ABDARPTR)                            0192
*       ABDLLINE=ADDR(MINLINE1);    /* SET LAYOUT LINE ADDR          */
         LA    @14,MINLINE1                                        0193
         ST    @14,ABDLLINE(,ABDARPTR)                             0193
*       ABDBPTR=ADDR(WORK)+1;       /* SET DATA ADDRESS              */
         LA    @14,WORK(,ABDARPTR)                                 0194
         AH    @14,@CH00076                                        0194
         ST    @14,ABDBPTR(,ABDARPTR)                              0194
*       CALL IEAVAD31;              /* FORMAT DATA                   */
*                                                                  0195
         L     @15,@CV02227                                        0195
         BALR  @14,@15                                             0195
*       /*************************************************************/
*       /*                                                           */
*       /* IF ROUTINE FAILED FOR ANY REASON RETURN TO CALLER WITH    */
*       /* CODE                                                      */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0196
*       IF RETCODE^=0               /* ROUTINE FAILED                */
*         THEN                      /* YES                           */
         LTR   RETCODE,RETCODE                                     0196
         BNZ   @RT00196                                            0196
*         GOTO COMEXIT;             /* START EXITING                 */
*       ELSE                                                       0198
*         ;                         /* CONTINUE PROCESSING           */
*       ABDBPTR=QCBMIPTR;           /* SET TO FORMAT MINOR QCB       */
         ST    QCBMIPTR,ABDBPTR(,ABDARPTR)                         0199
*       CALL IEAVAD41;              /* CONTINUE ON SAME LINE         */
*                                                                  0200
         L     @15,@CV02228                                        0200
         BALR  @14,@15                                             0200
*       /*************************************************************/
*       /*                                                           */
*       /* IF ROUTINE FAILED FOR ANY REASON RETURN TO CALLER WITH    */
*       /* CODE                                                      */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0201
*       IF RETCODE^=0               /* ROUTINE FAILED                */
*         THEN                      /* YES                           */
         LTR   RETCODE,RETCODE                                     0201
         BNZ   @RT00201                                            0201
*         GOTO COMEXIT;             /* START EXITING                 */
*       ELSE                                                       0203
*         ;                         /* CONTINUE PROCESSING           */
*       LENTH=MINNAMEL;             /* GET LENGTH OF MINOR NAME      */
*                                                                  0204
         SLR   LENTH,LENTH                                         0204
         IC    LENTH,MINNAMEL(,QCBMIPTR)                           0204
*       /*************************************************************/
*       /*                                                           */
*       /* THE MAXIMUM PRINTABLE LENGTH IS 24 CHAR           @YM06188*/
*       /*                                                           */
*       /*************************************************************/
*                                                                  0205
*       IF LENTH>24                 /* BIGGER THAN MAX       @YM06188*/
*         THEN                      /* YES                           */
         LA    @14,24                                              0205
         CR    LENTH,@14                                           0205
         BNH   @RF00205                                            0205
*         LENTH=24;                 /* SET TO MAX LEN        @YM06188*/
         LR    LENTH,@14                                           0206
*       DO I=1 TO LENTH BY 1;       /* MAX LENGTH OF MINOR           */
@RF00205 LA    @14,1                                               0207
         ST    @14,I                                               0207
         B     @DE00207                                            0207
@DL00207 DS    0H                                                  0208
*         IF MINNAMER(I)>='C1'X&    /* IS CHARACTER IN               */
*             MINNAMER(I)<='C9'X|   /* PRINTABLE RANGE               */
*             MINNAMER(I)>='D1'X&   /*                        @Y02705*/
*             MINNAMER(I)<='D9'X|   /*                        @Y02705*/
*             MINNAMER(I)>='E2'X&   /*                        @Y02705*/
*             MINNAMER(I)<='E9'X|   /*                        @Y02705*/
*             MINNAMER(I)>='F0'X&   /*                        @Y02705*/
*             MINNAMER(I)<='F9'X|   /*                       @YM06188*/
*             MINNAMER(I)='40'X|    /*                       @YM06188*/
*             MINNAMER(I)='4B'X|    /*                       @YM08178*/
*             MINNAMER(I)='5B'X|    /*                       @ZA15795*/
*             MINNAMER(I)='7B'X|    /*                       @ZA15795*/
*             MINNAMER(I)='7C'X     /*                       @ZA15795*/
*           THEN                                                   0208
         ALR   @14,QCBMIPTR                                        0208
         CLI   MINNAMER-1(@14),X'C1'                               0208
         BL    @GL00022                                            0208
         L     @14,I                                               0208
         ALR   @14,QCBMIPTR                                        0208
         CLI   MINNAMER-1(@14),X'C9'                               0208
         BNH   @RT00208                                            0208
@GL00022 L     @14,I                                               0208
         ALR   @14,QCBMIPTR                                        0208
         CLI   MINNAMER-1(@14),X'D1'                               0208
         BL    @GL00021                                            0208
         L     @14,I                                               0208
         ALR   @14,QCBMIPTR                                        0208
         CLI   MINNAMER-1(@14),X'D9'                               0208
         BNH   @RT00208                                            0208
@GL00021 L     @14,I                                               0208
         ALR   @14,QCBMIPTR                                        0208
         CLI   MINNAMER-1(@14),X'E2'                               0208
         BL    @GL00020                                            0208
         L     @14,I                                               0208
         ALR   @14,QCBMIPTR                                        0208
         CLI   MINNAMER-1(@14),X'E9'                               0208
         BNH   @RT00208                                            0208
@GL00020 L     @14,I                                               0208
         ALR   @14,QCBMIPTR                                        0208
         CLI   MINNAMER-1(@14),X'F0'                               0208
         BL    @GL00019                                            0208
         L     @14,I                                               0208
         ALR   @14,QCBMIPTR                                        0208
         CLI   MINNAMER-1(@14),X'F9'                               0208
         BNH   @RT00208                                            0208
@GL00019 L     @14,I                                               0208
         ALR   @14,QCBMIPTR                                        0208
         CLI   MINNAMER-1(@14),X'40'                               0208
         BE    @RT00208                                            0208
         L     @14,I                                               0208
         ALR   @14,QCBMIPTR                                        0208
         CLI   MINNAMER-1(@14),X'4B'                               0208
         BE    @RT00208                                            0208
         L     @14,I                                               0208
         ALR   @14,QCBMIPTR                                        0208
         CLI   MINNAMER-1(@14),X'5B'                               0208
         BE    @RT00208                                            0208
         L     @14,I                                               0208
         ALR   @14,QCBMIPTR                                        0208
         CLI   MINNAMER-1(@14),X'7B'                               0208
         BE    @RT00208                                            0208
         L     @14,I                                               0208
         ALR   @14,QCBMIPTR                                        0208
         CLI   MINNAMER-1(@14),X'7C'                               0208
         BE    @RT00208                                            0208
*           ;                       /* YES                    @Y02705*/
*         ELSE                                                     0210
*           DO;                                                    0210
*             GENERATE;                                            0211
*                            /* CONVERT HEX MINOR NAME.      @YM06188*/
         CH    8,K12                    MAX INPUT LENGTH MAY   @YM06188
*                                       BE ONLY 12 BYTES (TO OCCUPY
*                                       24 OUTPUT BUFFER POSITIONS).
         BNH   SETUP                    LEN IS .LE. 12, BRANCH @YM06188
         LH    8,K12                    ENFORCE MAXIMUM LENGTH @YM06188
SETUP    EQU   *                                               @YM06188
         LA    14,MINNAME(6)            START OF MINOR NAME.   @YM06188
         LA    10,ABDLINE+96(2)         START OUTPUT LINE LOC. @YM06188
CONV2    EQU   *                                               @YM06188
         MVC   ABDFMTWK(1,2),0(14)     GET SINGLE INPUT BYTE.  @YM06188
         UNPK  ABDFMTWK(3,2),ABDFMTWK(2,2) CONV 1 BYTE + GARB  @YM06188
         MVC   0(2,10),ABDFMTWK(2)         PUT CON BYTE IN BUF @YM06188
         TR    0(2,10),TRNTBL-C'0'         MAKE PRINTABLE HEX. @YM06188
         LA    14,1(0,14)               NEXT INPUT BYTE.       @YM06188
         LA    10,2(0,10)               NEXT OUTPUT LINE LOC   @YM06188
         BCT   8,CONV2                  PROCESS ALL BYTES.     @YM06188
*             GOTO PRINTMIN;        /* PRINT LINE                    */
         B     PRINTMIN                                            0212
*           END;                                                   0213
*       END;                                                       0214
@RT00208 LA    @14,1                                               0214
         AL    @14,I                                               0214
         ST    @14,I                                               0214
@DE00207 CR    @14,LENTH                                           0214
         BNH   @DL00207                                            0214
*MOVENAME:                          /* NAME IS NOT AN ADDRESS. NO  0215
*                                      CONVERSION NECESSARY. MOVE TO
*                                      OUTPUT LINE                   */
*       GENERATE;                                                  0215
MOVENAME DS    0H                                                  0215
*                                      /* DO EXECUTED MOVE           */
         BCTR  LENTH,0              DECR LENGTH BY 1
         MVI   ABDLINE+97(ABDARPTR),C' '   EXTRA CHAR = BLANK @ZA30621
         EX    LENTH,MOVE1             MOVE NAME TO LINE
         B     DONEMOVE                BYPASS EXECUTED INSTRUCTION
MOVE1    MVC   ABDLINE+96(1,ABDARPTR),MINNAME(QCBMIPTR)      @YM04767
DONEMOVE EQU   *
*PRINTMIN:                          /* OUTPUT THE MINOR QCB LINE     */
*       CALL IEAVAD11;              /* PRINT                         */
*                                                                  0216
PRINTMIN L     @15,@CV02226                                        0216
         BALR  @14,@15                                             0216
*       /*************************************************************/
*       /*                                                           */
*       /* IF ROUTINE FAILED FOR ANY REASON RETURN TO CALLER WITH    */
*       /* CODE                                                      */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0217
*       IF RETCODE^=0               /* ROUTINE FAILED                */
*         THEN                      /* YES                           */
         LTR   RETCODE,RETCODE                                     0217
         BNZ   @RT00217                                            0217
*         GOTO COMEXIT;             /* START EXITING                 */
*       ELSE                                                       0219
*         ;                         /* CONTINUE PROCESSING           */
*       ABDQCBMN='1'B;              /* INDICATE CURRENT MINOR HAS  0220
*                                      BEEN DISPLAYED                */
         OI    ABDQCBMN(ABDARPTR),B'00100000'                      0220
*     END;                                                         0221
*   ELSE                                                           0222
*     ;                             /* DISPLAY QEL                   */
*                                                                  0222
@RF00189 DS    0H                                                  0223
*   /*****************************************************************/
*   /*                                                               */
*   /* THIS SECTION OF CODE FORMATS THE QELS. QELS MAY BE FOUR, FIVE,*/
*   /* SIX, OR SEVEN WORDS IN LENGTH. FOUR WORDS ARE NON-RESERVE SUB */
*   /* QELS. FIVE WORDS ARE RESERVE SUB-QELS. SIX WORDS ARE NON-     */
*   /* RESERVE LIST QELS. SEVEN WORDS ARE RESERVE LIST QELS.         */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0223
*   IF QELLIST='0'B&                /* IS THIS A SUB QEL AND         */
*       QELRESV='1'B THEN           /* IS THIS A RESERVE REQUEST YES
*                                      FORMAT 5 WORD QEL             */
         TM    QELRESV(QELSEPTR),B'00010000'                       0223
         BNO   @RF00223                                            0223
         TM    QELLIST(QELSEPTR),B'00100000'                       0223
         BNZ   @RF00223                                            0223
*     ABDLLINE=ADDR(QEL5UCLN);      /* YES, GET LAYOUT LINE ADDR     */
         LA    @14,QEL5UCLN                                        0224
         ST    @14,ABDLLINE(,ABDARPTR)                             0224
*   ELSE                                                           0225
*     IF QELLIST='0'B THEN          /* IS THIS A SUB QEL             */
         B     @RC00223                                            0225
@RF00223 TM    QELLIST(QELSEPTR),B'00100000'                       0225
         BNZ   @RF00225                                            0225
*       ABDLLINE=ADDR(QEL4LQLN);    /* YES, GET ADDR OF LAYOUT LINE  */
         LA    @14,QEL4LQLN                                        0226
         ST    @14,ABDLLINE(,ABDARPTR)                             0226
*     ELSE                          /* CHECK FOR ECB REQUEST         */
*       IF QELRESV='1'B&            /* IS THIS AN ECB REQUEST        */
*           QELECBF='1'B THEN       /* IS THERE A UCB PTR            */
         B     @RC00225                                            0227
@RF00225 TM    QELRESV(QELSEPTR),B'00010000'                       0227
         BNO   @RF00227                                            0227
         TM    QELECBF(QELSEPTR),B'01000000'                       0227
         BNO   @RF00227                                            0227
*         ABDLLINE=ADDR(QEL7ECLN);  /* YES, GET ADDR OF LAYOUT LN.   */
         LA    @14,QEL7ECLN                                        0228
         ST    @14,ABDLLINE(,ABDARPTR)                             0228
*       ELSE                        /* CHECK FOR RESERVE REQUEST     */
*         IF QELECBF='1'B THEN      /* IS THERE AN ECB POINTER       */
         B     @RC00227                                            0229
@RF00227 TM    QELECBF(QELSEPTR),B'01000000'                       0229
         BNO   @RF00229                                            0229
*           ABDLLINE=ADDR(QEL6ECLN);/* YES, GET ADDR OF LAYOUT LN.   */
         LA    @14,QEL6ECLN                                        0230
         ST    @14,ABDLLINE(,ABDARPTR)                             0230
*         ELSE                      /* CHECK FOR RESERVE LIST REQ.   */
*           IF QELRESV='1'B THEN    /* IS THIS A RESERVE LIST        */
         B     @RC00229                                            0231
@RF00229 TM    QELRESV(QELSEPTR),B'00010000'                       0231
         BNO   @RF00231                                            0231
*             ABDLLINE=ADDR(QEL7SVLN);/* GET ADDR OF LAYOUT LINE     */
         LA    @14,QEL7SVLN                                        0232
         ST    @14,ABDLLINE(,ABDARPTR)                             0232
*           ELSE                                                   0233
*             IF QELTCB^=0 THEN     /* IS THERE A TCB ADDR           */
         B     @RC00231                                            0233
@RF00231 ICM   @14,15,QELTCB(QELSEPTR)                             0233
         BZ    @RF00233                                            0233
*               ABDLLINE=ADDR(QEL6SVLN);/* GET ADDR OF LAYOUT LINE   */
         LA    @14,QEL6SVLN                                        0234
         ST    @14,ABDLLINE(,ABDARPTR)                             0234
*             ELSE                                                 0235
*               GOTO NEXTQEL;       /* PROCESS NEXT QEL              */
*   ABDBPTR=QELSEPTR;               /* SET ADDR OF DATA              */
@RC00231 DS    0H                                                  0236
@RC00229 DS    0H                                                  0236
@RC00227 DS    0H                                                  0236
@RC00225 DS    0H                                                  0236
@RC00223 ST    QELSEPTR,ABDBPTR(,ABDARPTR)                         0236
*DQEL:                                                             0237
*   GENERATE REFS(PSALITA,ABDWORK);                                0237
DQEL     DS    0H                                                  0237
*                                        /*                   @Y02705*/
         STM 11,14,ABDWORK(ABDARPTR)                          @Y02705
         SETLOCK RELEASE,TYPE=CMS,                            @Y02705  C
               RELATED=(QEL,IEAVAD06(DQEL))                   @Y02705
         SETLOCK RELEASE,TYPE=LOCAL,                          @Y02705  C
               RELATED=(QEL,IEAVAD06(DQEL))                   @Y02705
         LM    11,14,ABDWORK(ABDARPTR)                        @Y02705
*   CALL IEAVAD31;                  /* FORMAT THE QEL                */
*                                                                  0238
         L     @15,@CV02227                                        0238
         BALR  @14,@15                                             0238
*   /*****************************************************************/
*   /*                                                               */
*   /* IF ROUTINE FAILED FOR ANY REASON RETURN TO CALLER WITH THE    */
*   /* CODE                                                          */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0239
*   IF RETCODE^=0                   /* ROUTINE FAILED                */
*     THEN                          /* YES                           */
         LTR   RETCODE,RETCODE                                     0239
         BNZ   @RT00239                                            0239
*     GOTO COMEXIT;                 /* START EXITING                 */
*   ELSE                                                           0241
*     ;                             /* CONTINUE PROCESSING           */
*   CALL IEAVAD11;                  /* OUTPUT THE LINE               */
*                                                                  0242
         L     @15,@CV02226                                        0242
         BALR  @14,@15                                             0242
*   /*****************************************************************/
*   /*                                                               */
*   /* IF ROUTINE FAILED FOR ANY REASON RETURN TO CALLER WITH THE    */
*   /* CODE                                                          */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0243
*   IF RETCODE^=0                   /* ROUTINE FAILED                */
*     THEN                          /* YES                           */
         LTR   RETCODE,RETCODE                                     0243
         BNZ   @RT00243                                            0243
*     GOTO COMEXIT;                 /* START EXITING                 */
*   ELSE                                                           0245
*     ;                             /* CONTINUE PROCESSING           */
*   RESPECIFY                                                      0246
*     PARMPTR UNRESTRICTED;                                        0246
*                                                                  0246
*   /*****************************************************************/
*   /*                                                               */
*   /* DISABLE INTERRUPTS BEFORE CONTINUING SEARCH                   */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0247
*NQEL:                                                             0247
*   GENERATE REFS(ABDWORK,PSALITA);                                0247
NQEL     DS    0H                                                  0247
*                                                             @Y02705
         STM 11,14,ABDWORK(ABDARPTR)                          @Y02705
         SETLOCK OBTAIN,TYPE=LOCAL,MODE=UNCOND,               @Y02705  C
               RELATED=(QEL,IEAVAD06(NQEL))                   @Y02705
         SETLOCK OBTAIN,TYPE=CMS,MODE=UNCOND,                 @Y02705  C
               RELATED=(QEL,IEAVAD06(NQEL))                   @Y02705
         LM    11,14,ABDWORK(ABDARPTR)                        @Y02705
*   GOTO NEXTQEL;                   /* PROCESS NEXT QEL              */
         B     NEXTQEL                                             0248
*   END IEAVAD06                    /* END OF ROUTINE                */
*                                                                  0249
*/* THE FOLLOWING INCLUDE STATEMENTS WERE FOUND IN THIS PROGRAM.     */
*/*%INCLUDE SYSLIB  (IHAQCB  )                                       */
*/*%INCLUDE SYSLIB  (IHAQEL  )                                       */
*/*%INCLUDE SYSLIB  (IHAABDA )                                       */
*/*%INCLUDE SYSLIB  (CVT     )                                       */
*/*%INCLUDE SYSLIB  (IHAPSA  )                                       */
*/*%INCLUDE SYSLIB  (IHARTCT )                                       */
*/*%INCLUDE SYSLIB  (IKJTCB  )                                       */
*/*%INCLUDE SYSLIB  (IHAASCB )                                       */
*                                                                  0249
*       ;                                                          0249
@DATA    DS    0H
@CH00076 DC    H'1'
@CH00205 DC    H'8'
@DATD    DSECT
         DS    0F
IEAVAD06 CSECT
         DS    0F
@DATD    DSECT
         DS    0D
I        DS    F
         ORG   *+1-(*-@DATD)/(*-@DATD) INSURE DSECT DATA
@ENDDATD EQU   *
IEAVAD06 CSECT
         DS    0F
@SIZDATD DC    AL1(0)
         DC    AL3(@ENDDATD-@DATD)
@CV02226 DC    V(IEAVAD11)
@CV02227 DC    V(IEAVAD31)
@CV02228 DC    V(IEAVAD41)
         DS    0D
MAJLINE  DS    CL36
         ORG   MAJLINE
@NM00001 DC    X'002201'
@NM00002 DC    CL3'MAJ'
@NM00003 DC    X'FF3301'
@NM00004 DC    CL4'NMAJ'
@NM00005 DC    X'3341'
@NM00006 DC    CL4'PMAJ'
@NM00007 DC    X'3341'
@NM00008 DC    CL4'FMIN'
@NM00009 DC    X'3341'
@NM00010 DC    CL4'LMIN'
@NM00011 DC    X'1043'
@NM00012 DC    CL2'NM'
@NM00013 DC    X'FF'
         ORG   MAJLINE+36
MINLINE1 DS    CL42
         ORG   MINLINE1
@NM00014 DC    X'002201'
@NM00015 DC    CL3'MIN'
@NM00016 DC    X'FF3301'
@NM00017 DC    CL4'NMIN'
@NM00018 DC    X'3341'
@NM00019 DC    CL4'PMIN'
@NM00020 DC    X'3341'
@NM00021 DC    CL4'FQEL'
@NM00022 DC    X'3341'
@NM00023 DC    CL4'LQEL'
@NM00024 DC    X'3341'
@NM00025 DC    CL4'FLID'
@NM00026 DC    X'1051'
@NM00027 DC    CL2'NM'
@NM00028 DC    X'FF'
         ORG   MINLINE1+42
QEL4LQLN DS    CL26
         ORG   QEL4LQLN
@NM00029 DC    X'0D3301'
@NM00030 DC    CL4'NQEL'
@NM00031 DC    X'3341'
@NM00032 DC    CL4'PQEL'
@NM00033 DC    X'3341'
@NM00034 DC    CL4'LQEL'
@NM00035 DC    X'3341'
@NM00036 DC    CL4'FLID'
@NM00037 DC    X'FF'
         ORG   QEL4LQLN+26
QEL6SVLN DS    CL37
         ORG   QEL6SVLN
@NM00038 DC    X'0D3301'
@NM00039 DC    CL4'NQEL'
@NM00040 DC    X'3341'
@NM00041 DC    CL4'PQEL'
@NM00042 DC    X'3341'
@NM00043 DC    CL4'TCB '
@NM00044 DC    X'3341'
@NM00045 DC    CL4'FLID'
@NM00046 DC    X'3341'
@NM00047 DC    CL4'SVRB'
@NM00048 DC    X'2341'
@NM00049 DC    CL3'CNT'
@NM00050 DC    X'FF'
         ORG   QEL6SVLN+37
QEL6ECLN DS    CL37
         ORG   QEL6ECLN
@NM00051 DC    X'0D3301'
@NM00052 DC    CL4'NQEL'
@NM00053 DC    X'3341'
@NM00054 DC    CL4'PQEL'
@NM00055 DC    X'3341'
@NM00056 DC    CL4'TCB '
@NM00057 DC    X'3341'
@NM00058 DC    CL4'FLID'
@NM00059 DC    X'3341'
@NM00060 DC    CL4'ECB '
@NM00061 DC    X'2341'
@NM00062 DC    CL3'CNT'
@NM00063 DC    X'FF'
         ORG   QEL6ECLN+37
QEL5UCLN DS    CL31
         ORG   QEL5UCLN
@NM00064 DC    X'0D3301'
@NM00065 DC    CL4'NQEL'
@NM00066 DC    X'3341'
@NM00067 DC    CL4'PQEL'
@NM00068 DC    X'3341'
@NM00069 DC    CL4'LQEL'
@NM00070 DC    X'3341'
@NM00071 DC    CL4'FLID'
@NM00072 DC    X'2341'
@NM00073 DC    CL3'UCB'
@NM00074 DC    X'FF'
         ORG   QEL5UCLN+31
QEL7SVLN DS    CL42
         ORG   QEL7SVLN
@NM00075 DC    X'0D3301'
@NM00076 DC    CL4'NQEL'
@NM00077 DC    X'3341'
@NM00078 DC    CL4'PQEL'
@NM00079 DC    X'3341'
@NM00080 DC    CL4'TCB '
@NM00081 DC    X'3341'
@NM00082 DC    CL4'FLID'
@NM00083 DC    X'3341'
@NM00084 DC    CL4'SVRB'
@NM00085 DC    X'2341'
@NM00086 DC    CL3'CNT'
@NM00087 DC    X'2341'
@NM00088 DC    CL3'UCB'
@NM00089 DC    X'FF'
         ORG   QEL7SVLN+42
QEL7ECLN DS    CL42
         ORG   QEL7ECLN
@NM00090 DC    X'0D3301'
@NM00091 DC    CL4'NQEL'
@NM00092 DC    X'3341'
@NM00093 DC    CL4'PQEL'
@NM00094 DC    X'3341'
@NM00095 DC    CL4'TCB '
@NM00096 DC    X'3341'
@NM00097 DC    CL4'FLID'
@NM00098 DC    X'3341'
@NM00099 DC    CL4'ECB '
@NM00100 DC    X'2341'
@NM00101 DC    CL3'CNT'
@NM00102 DC    X'2341'
@NM00103 DC    CL3'UCB'
@NM00104 DC    X'FF'
         ORG   QEL7ECLN+42
HEADING  DC    CL10'0QCB TRACE'
@00      EQU   00                      EQUATES FOR REGISTERS 0-15
@01      EQU   01
@02      EQU   02
@03      EQU   03
@04      EQU   04
@05      EQU   05
@06      EQU   06
@07      EQU   07
@08      EQU   08
@09      EQU   09
@10      EQU   10
@11      EQU   11
@12      EQU   12
@13      EQU   13
@14      EQU   14
@15      EQU   15
R0       EQU   @00
PARMPTR  EQU   @01
ABDARPTR EQU   @02
CVTPTR   EQU   @03
TCBPTR   EQU   @04
QCBMAPTR EQU   @05
QCBMIPTR EQU   @06
QELSEPTR EQU   @07
LENTH    EQU   @08
SAVERET  EQU   @09
AUTOPTR  EQU   @12
SAVEAREA EQU   @13
RETCODE  EQU   @15
PSA      EQU   0
FLCRNPSW EQU   PSA
FLCROPSW EQU   PSA+8
FLCICCW2 EQU   PSA+16
FLCCVT   EQU   FLCICCW2
PSAEEPSW EQU   PSA+132
PSAESPSW EQU   PSA+136
FLCSVILC EQU   PSAESPSW+1
PSAEPPSW EQU   PSA+140
FLCPIILC EQU   PSAEPPSW+1
FLCPICOD EQU   PSAEPPSW+2
PSAPICOD EQU   FLCPICOD+1
FLCTEA   EQU   PSAEPPSW+4
FLCPER   EQU   PSA+152
FLCMCLA  EQU   PSA+168
FLCIOEL  EQU   FLCMCLA+4
FLCIOA   EQU   FLCMCLA+16
FLCFSA   EQU   FLCMCLA+80
PSAAOLD  EQU   PSA+548
PSASUPER EQU   PSA+552
PSASUP1  EQU   PSASUPER
PSASUP2  EQU   PSASUPER+1
PSASUP3  EQU   PSASUPER+2
PSASUP4  EQU   PSASUPER+3
PSACLHT  EQU   PSA+640
PSALKSA  EQU   PSA+696
PSAHLHI  EQU   PSA+760
PSALITA  EQU   PSA+764
PSADSSFL EQU   PSA+836
PSADSSF1 EQU   PSADSSFL
PSADSSF3 EQU   PSADSSFL+2
PSADSSF4 EQU   PSADSSFL+3
PSARSVT  EQU   PSA+896
MAJ      EQU   0
MAJNMAJ  EQU   MAJ
MAJFMIN  EQU   MAJ+8
MAJNAME  EQU   MAJ+16
MIN      EQU   0
MINNMIN  EQU   MIN
MINFQEL  EQU   MIN+8
MINNAMEL EQU   MIN+16
MINFLGS  EQU   MIN+17
MINNAME  EQU   MIN+20
QEL      EQU   0
QELNQEL  EQU   QEL
QELTCB   EQU   QEL+8
QELLQEL  EQU   QELTCB
QELXLIST EQU   QELLQEL
QELQFLGS EQU   QEL+12
QELLIST  EQU   QELQFLGS
QELRESV  EQU   QELQFLGS
QELLFLGS EQU   QEL+13
QELECBF  EQU   QELLFLGS
QELASID  EQU   QEL+14
QELSVRB  EQU   QEL+16
QELECB   EQU   QELSVRB
ABDAREA  EQU   0
ABDTCB   EQU   ABDAREA
ABDCTCB  EQU   ABDAREA+4
ABDPARMS EQU   ABDAREA+12
ABDFLAG  EQU   ABDPARMS+1
APFSDATA EQU   ABDPARMS+4
APFSDAT1 EQU   ABDPARMS+5
APFPDATA EQU   ABDPARMS+6
ABDPTRS  EQU   ABDAREA+84
ABDFLAG1 EQU   ABDAREA+136
ABDQCBHD EQU   ABDFLAG1
ABDQCBMJ EQU   ABDFLAG1
ABDQCBMN EQU   ABDFLAG1
ABDFLAG2 EQU   ABDAREA+137
ABDSTAT  EQU   ABDFLAG2
ABDRES1  EQU   ABDAREA+139
ABDWORK  EQU   ABDAREA+140
ABDBPTR  EQU   ABDAREA+244
ABDLLINE EQU   ABDAREA+248
ABDFMTWK EQU   ABDAREA+256
ABDUPRF  EQU   ABDAREA+265
ABDUPRFN EQU   ABDAREA+266
ABDBLNKS EQU   ABDAREA+267
ABDBUFFS EQU   ABDAREA+308
ABDGMA   EQU   ABDAREA+316
ABDAAREA EQU   ABDGMA
ABDASIZE EQU   ABDGMA+4
ESPARM   EQU   ABDAREA+340
ESTAEFLG EQU   ESPARM+28
ABDLINEA EQU   ABDAREA+384
ABDCC    EQU   ABDLINEA
ABDLINE  EQU   ABDLINEA+1
CVTMAP   EQU   0
CVTDAR   EQU   CVTMAP+72
CVTFLGS1 EQU   CVTDAR
CVTDCB   EQU   CVTMAP+116
CVTIOQET EQU   CVTMAP+120
CVTIERLC EQU   CVTMAP+144
CVTHEAD  EQU   CVTMAP+160
CVTSV76C EQU   CVTHEAD
CVTOPTA  EQU   CVTMAP+182
CVTOPTB  EQU   CVTMAP+183
CVTGTF   EQU   CVTMAP+236
CVTGTFST EQU   CVTGTF
CVTGTFS  EQU   CVTGTFST
CVTSTATE EQU   CVTGTFST
CVTTMODE EQU   CVTGTFST
CVTFORM  EQU   CVTGTFST
CVTAQAVT EQU   CVTMAP+240
CVTTCMFG EQU   CVTAQAVT
CVTVOLM2 EQU   CVTMAP+244
CVTTATA  EQU   CVTVOLM2
CVTTSKS  EQU   CVTTATA
CVTVOLF2 EQU   CVTTSKS
CVTTAT   EQU   CVTTATA+1
CVTATER  EQU   CVTMAP+248
CVTEXT1  EQU   CVTMAP+252
CVTPURG  EQU   CVTMAP+260
CVTQMSG  EQU   CVTMAP+268
CVTDMSR  EQU   CVTMAP+272
CVTRSV37 EQU   CVTDMSR
CVTDMSRF EQU   CVTRSV37
CVTERPV  EQU   CVTMAP+316
CVTINTLA EQU   CVTMAP+320
CVTAPF   EQU   CVTMAP+324
CVTEXT2  EQU   CVTMAP+328
CVTHJES  EQU   CVTMAP+332
CVTPGSIA EQU   CVTMAP+348
CVTA1F1  EQU   CVTMAP+356
CVTSYSK  EQU   CVTMAP+357
CVTVOLM1 EQU   CVTMAP+380
CVTVOLF1 EQU   CVTVOLM1
CVTXTNT1 EQU   0
CVTXTNT2 EQU   0
CVTDSSV  EQU   CVTXTNT2
CVTFLGBT EQU   CVTXTNT2+5
CVTQID   EQU   CVTXTNT2+24
CVTRV400 EQU   CVTXTNT2+52
CVTRV409 EQU   CVTXTNT2+53
CVTATCVT EQU   CVTXTNT2+64
CVTRV429 EQU   CVTXTNT2+84
CVTRV438 EQU   CVTXTNT2+85
CVTRV457 EQU   CVTXTNT2+112
CVTRV466 EQU   CVTXTNT2+113
CVTFIX   EQU   0
CVTRELNO EQU   CVTFIX+252
RTCT     EQU   0
RTCTPLIB EQU   RTCT+4
RTCTSAP  EQU   RTCTPLIB
RTCTSAP1 EQU   RTCTSAP
RTCTSAP2 EQU   RTCTSAP+1
RTCTSAP3 EQU   RTCTSAP+2
RTCTSUP  EQU   RTCTPLIB+4
RTCTSUP1 EQU   RTCTSUP
RTCTSUP2 EQU   RTCTSUP+1
RTCTSUP3 EQU   RTCTSUP+2
RTCTSYD  EQU   RTCTPLIB+8
RTCTSY01 EQU   RTCTSYD
RTCTSDDS EQU   RTCT+36
RTCTFLG  EQU   RTCTSDDS+3
RTCTSDPL EQU   RTCT+156
RTCTRFLG EQU   RTCT+176
RTCTERID EQU   RTCT+224
RTCTOPT  EQU   RTCT+236
RTCTASO  EQU   RTCT+252
RTCTASO1 EQU   RTCTASO
RTCTASO2 EQU   RTCTASO+1
RTCTSDI  EQU   RTCT+254
RTCTSDF  EQU   RTCT+264
RTCTSDF1 EQU   RTCTSDF
RTCTSDF2 EQU   RTCTSDF+1
RTCTSDF3 EQU   RTCT+268
RTCTSDF4 EQU   RTCTSDF3+2
RTCTMOPT EQU   0
RTCTMSAO EQU   RTCTMOPT
RTCTSASD EQU   RTCTMSAO
RTCTSAO1 EQU   RTCTSASD
RTCTSAO2 EQU   RTCTSASD+1
RTCTSAPD EQU   RTCTMSAO+2
RTCTSAO3 EQU   RTCTSAPD
RTCTSAO4 EQU   RTCTSAPD+1
RTCTSAMG EQU   RTCTSAO4
RTCTMSUO EQU   RTCTMOPT+4
RTCTSUSD EQU   RTCTMSUO
RTCTSUO1 EQU   RTCTSUSD
RTCTSUO2 EQU   RTCTSUSD+1
RTCTSUPD EQU   RTCTMSUO+2
RTCTSUO3 EQU   RTCTSUPD
RTCTSUO4 EQU   RTCTSUPD+1
RTCTSUMG EQU   RTCTSUO4
RTCTMSYO EQU   RTCTMOPT+8
RTCTSD01 EQU   RTCTMSYO
RTCTSD04 EQU   RTCTMSYO+3
RTCTSMMG EQU   RTCTSD04
RTCTMSDO EQU   RTCTMOPT+12
RTCTSDOD EQU   RTCTMSDO
RTCTSDO1 EQU   RTCTSDOD
RTCTSDO2 EQU   RTCTSDOD+1
RTCTSDO3 EQU   RTCTMSDO+2
RTCTSDO4 EQU   RTCTMSDO+3
RTCTSDMG EQU   RTCTSDO4
TCBFIX   EQU   0
TCBFRS   EQU   TCBFIX
TCB      EQU   0
TCBPIE   EQU   TCB+4
TCBPMASK EQU   TCBPIE
TCBCMP   EQU   TCB+16
TCBCMPF  EQU   TCBCMP
TCBCPP   EQU   TCBCMPF
TCBSTCC  EQU   TCBCMPF
TCBCDBL  EQU   TCBCMPF
TCBCWTO  EQU   TCBCMPF
TCBCIND  EQU   TCBCMPF
TCBCMSG  EQU   TCBCMPF
TCBTRN   EQU   TCB+20
TCBABF   EQU   TCBTRN
TCBMSS   EQU   TCB+24
TCBPKF   EQU   TCB+28
TCBFLAG  EQU   TCBPKF
TCBFLGS  EQU   TCB+29
TCBFLGS1 EQU   TCBFLGS
TCBFLGS2 EQU   TCBFLGS+1
TCBFLGS3 EQU   TCBFLGS+2
TCBFLGS4 EQU   TCBFLGS+3
TCBFLGS5 EQU   TCBFLGS+4
TCBABWF  EQU   TCBFLGS5
TCBJPQ   EQU   TCB+44
TCBPURGE EQU   TCBJPQ
TCBGRS   EQU   TCB+48
TCBFSA   EQU   TCB+112
TCBTME   EQU   TCB+120
TCBJSTCB EQU   TCB+124
TCBJSTCA EQU   TCBJSTCB+1
TCBOTC   EQU   TCB+132
TCBLTC   EQU   TCB+136
TCBTSFLG EQU   TCB+148
TCBTSTSK EQU   TCBTSFLG
TCBSTAB  EQU   TCB+160
TCBNSTAE EQU   TCBSTAB
TCBTCT   EQU   TCB+164
TCBTCTGF EQU   TCBTCT
TCBSCNDY EQU   TCB+172
TCBNDSP  EQU   TCBSCNDY
TCBNDSP1 EQU   TCBNDSP+1
TCBNDSP2 EQU   TCBNDSP+2
TCBNDSP3 EQU   TCBNDSP+3
TCBJSCB  EQU   TCB+180
TCBRECDE EQU   TCBJSCB
TCBEXT1  EQU   TCB+196
TCBBITS  EQU   TCB+200
TCBNDSP4 EQU   TCBBITS
TCBNDSP5 EQU   TCBBITS+1
TCBFLGS6 EQU   TCBBITS+2
TCBFLGS7 EQU   TCBBITS+3
TCBADMP  EQU   TCBFLGS7
TCBDAR   EQU   TCB+204
TCBDARC  EQU   TCBDAR
TCBEXT2  EQU   TCB+208
TCBXSCT  EQU   TCB+240
TCBXSCT1 EQU   TCBXSCT
TCBFOE   EQU   TCB+244
TCBESTAE EQU   TCB+264
TCBESTRM EQU   TCBESTAE+1
TCBFBYT1 EQU   TCB+276
TCBFBYT2 EQU   TCB+277
TCBRV124 EQU   TCB+278
TCBRV133 EQU   TCB+279
TCBXTNT2 EQU   0
TCBGTF   EQU   TCBXTNT2
TCBTFLG  EQU   TCBGTF
TCBRV146 EQU   TCBXTNT2+28
TCBRV155 EQU   TCBXTNT2+29
TCBRV164 EQU   TCBXTNT2+30
TCBRV173 EQU   TCBXTNT2+31
ASCB     EQU   0
ASCBSUPC EQU   ASCB+16
ASCBASID EQU   ASCB+36
ASCBRSM  EQU   ASCB+52
ASCBRSMF EQU   ASCBRSM
ASCBFW1  EQU   ASCB+100
ASCBRCTF EQU   ASCBFW1+2
ASCBFLG1 EQU   ASCBFW1+3
ASCBDSP1 EQU   ASCB+114
ASCBFLG2 EQU   ASCB+115
ASCBLKGP EQU   ASCB+128
ASCBSRQ  EQU   ASCB+180
ASCBSRQ1 EQU   ASCBSRQ
ASCBSRQ2 EQU   ASCBSRQ+1
ASCBSRQ3 EQU   ASCBSRQ+2
ASCBSRQ4 EQU   ASCBSRQ+3
PREVSAVE EQU   4
NEXTSAVE EQU   8
CVTS01   EQU   CVTPGSIA
CVTLPDIA EQU   CVTS01+12
CVTDIRST EQU   CVTLPDIA
CVTSLIDA EQU   CVTS01+24
CVTCTLFG EQU   CVTS01+50
CVTRTMCT EQU   CVTS01+224
CVTFQCB  EQU   CVTS01+292
CVTRV210 EQU   CVTS01+424
CVTRV219 EQU   CVTS01+425
CVTRV228 EQU   CVTS01+426
CVTRV237 EQU   CVTS01+427
CVTMFRTR EQU   CVTS01+452
CVTRV262 EQU   CVTS01+468
CVTRV271 EQU   CVTS01+469
CVTRV280 EQU   CVTS01+470
CVTRV289 EQU   CVTS01+471
CVTGSDA  EQU   CVTS01+600
PSARSVTE EQU   PSARSVT
ASCBPTR  EQU   PSAAOLD
HEAD     EQU   ABDLINEA
MAJORNM  EQU   ABDLINE+81
MINNAMER EQU   MINNAME
WORK     EQU   ABDGMA
FLC      EQU   PSA
         AGO   .@UNREFD                START UNREFERENCED COMPONENTS
PSARSAV  EQU   PSARSVTE+60
PSARSTK  EQU   PSARSVTE+56
PSAESAV3 EQU   PSARSVTE+52
PSAESTK3 EQU   PSARSVTE+48
PSAESAV2 EQU   PSARSVTE+44
PSAESTK2 EQU   PSARSVTE+40
PSAESAV1 EQU   PSARSVTE+36
PSAESTK1 EQU   PSARSVTE+32
PSAPSAV  EQU   PSARSVTE+28
PSAPSTK  EQU   PSARSVTE+24
PSAMSAV  EQU   PSARSVTE+20
PSAMSTK  EQU   PSARSVTE+16
PSASSAV  EQU   PSARSVTE+12
PSASSTK  EQU   PSARSVTE+8
PSANSTK  EQU   PSARSVTE+4
PSACSTK  EQU   PSARSVTE
CVTRV628 EQU   CVTS01+728
CVTRV627 EQU   CVTS01+724
CVTRV626 EQU   CVTS01+720
CVTRV625 EQU   CVTS01+716
CVTRV624 EQU   CVTS01+712
CVTRV623 EQU   CVTS01+708
CVTRV622 EQU   CVTS01+704
CVTRV621 EQU   CVTS01+700
CVTIHASU EQU   CVTS01+696
CVTSUSP  EQU   CVTS01+692
CVTT6SVC EQU   CVTS01+688
CVTCDAL  EQU   CVTS01+684
CVTTCTL  EQU   CVTS01+680
CVTRSUME EQU   CVTS01+676
CVTJTERM EQU   CVTS01+672
CVTASMRM EQU   CVTS01+668
CVTTCASP EQU   CVTS01+664
CVT0PT03 EQU   CVTS01+660
CVT0PT0E EQU   CVTS01+656
CVTRV609 EQU   CVTS01+652
CVTCGK   EQU   CVTS01+648
CVTRAC   EQU   CVTS01+644
CVTHSM   EQU   CVTS01+640
CVTRV605 EQU   CVTS01+636
CVTRV604 EQU   CVTS01+632
CVTEFF02 EQU   CVTS01+628
CVTCBBR  EQU   CVTS01+624
CVTSSCR  EQU   CVTS01+620
CVTEVENT EQU   CVTS01+616
CVTCRCA  EQU   CVTS01+612
CVTTPIO  EQU   CVTS01+608
CVTADV   EQU   CVTS01+604
CVTGSDAB EQU   CVTGSDA
CVTQV3   EQU   CVTS01+596
CVTQV2   EQU   CVTS01+592
CVTQV1   EQU   CVTS01+588
CVTRPT   EQU   CVTS01+584
CVTSSRB  EQU   CVTS01+580
CVTCSDRL EQU   CVTS01+576
CVTEXP1  EQU   CVTS01+572
CVTRMPMT EQU   CVTS01+568
CVTRMPTT EQU   CVTS01+564
CVTVPSA  EQU   CVTS01+560
CVTVSTOP EQU   CVTS01+556
CVTGTFR8 EQU   CVTS01+552
CVTQUIT  EQU   CVTS01+548
CVTVACR  EQU   CVTS01+544
CVTWTCB  EQU   CVTS01+540
CVTSTPRS EQU   CVTS01+536
CVT0PT02 EQU   CVTS01+532
CVTDARCM EQU   CVTS01+528
CVTIRECM EQU   CVTS01+524
CVTJRECM EQU   CVTS01+520
CVTVEMS0 EQU   CVTS01+516
CVTSPFRR EQU   CVTS01+512
CVTRLSTG EQU   CVTS01+508
CVT0TC0A EQU   CVTS01+504
CVTGMBR  EQU   CVTS01+500
CVTLFRM  EQU   CVTS01+496
CVTRMBR  EQU   CVTS01+492
CVTVIOP  EQU   CVTS01+488
CVTRV307 EQU   CVTS01+486
CVTRV306 EQU   CVTS01+484
CVTRV305 EQU   CVTS01+482
CVTRV304 EQU   CVTS01+480
CVTRV303 EQU   CVTS01+478
CVTRV302 EQU   CVTS01+476
CVTTRCA  EQU   CVTS01+472
CVTRV297 EQU   CVTRV289
CVTRV296 EQU   CVTRV289
CVTRV295 EQU   CVTRV289
CVTRV294 EQU   CVTRV289
CVTRV293 EQU   CVTRV289
CVTRV292 EQU   CVTRV289
CVTRV291 EQU   CVTRV289
CVTRV290 EQU   CVTRV289
CVTRV288 EQU   CVTRV280
CVTRV287 EQU   CVTRV280
CVTRV286 EQU   CVTRV280
CVTRV285 EQU   CVTRV280
CVTRV284 EQU   CVTRV280
CVTRV283 EQU   CVTRV280
CVTRV282 EQU   CVTRV280
CVTRV281 EQU   CVTRV280
CVTRV279 EQU   CVTRV271
CVTRV278 EQU   CVTRV271
CVTRV277 EQU   CVTRV271
CVTRV276 EQU   CVTRV271
CVTRV275 EQU   CVTRV271
CVTRV274 EQU   CVTRV271
CVTRV273 EQU   CVTRV271
CVTRV272 EQU   CVTRV271
CVTRV270 EQU   CVTRV262
CVTRV269 EQU   CVTRV262
CVTRV268 EQU   CVTRV262
CVTRV267 EQU   CVTRV262
CVTRV266 EQU   CVTRV262
CVTRV265 EQU   CVTRV262
CVTRV264 EQU   CVTRV262
CVTRV263 EQU   CVTRV262
CVTVFP   EQU   CVTS01+464
CVTVSI   EQU   CVTS01+460
CVTVPSIB EQU   CVTS01+456
CVTMFACT EQU   CVTMFRTR
CVTMFCTL EQU   CVTS01+448
CVTPVBP  EQU   CVTS01+444
CVTPWI   EQU   CVTS01+440
CVTRV254 EQU   CVTS01+438
CVTRV253 EQU   CVTS01+436
CVTRV252 EQU   CVTS01+434
CVTRV251 EQU   CVTS01+433
CVTRV250 EQU   CVTS01+432
CVTRV249 EQU   CVTS01+431
CVTRV248 EQU   CVTS01+430
CVTRV247 EQU   CVTS01+429
CVTRV246 EQU   CVTS01+428
CVTRV245 EQU   CVTRV237
CVTRV244 EQU   CVTRV237
CVTRV243 EQU   CVTRV237
CVTRV242 EQU   CVTRV237
CVTRV241 EQU   CVTRV237
CVTRV240 EQU   CVTRV237
CVTRV239 EQU   CVTRV237
CVTRV238 EQU   CVTRV237
CVTRV236 EQU   CVTRV228
CVTRV235 EQU   CVTRV228
CVTRV234 EQU   CVTRV228
CVTRV233 EQU   CVTRV228
CVTRV232 EQU   CVTRV228
CVTRV231 EQU   CVTRV228
CVTRV230 EQU   CVTRV228
CVTRV229 EQU   CVTRV228
CVTRV227 EQU   CVTRV219
CVTRV226 EQU   CVTRV219
CVTRV225 EQU   CVTRV219
CVTRV224 EQU   CVTRV219
CVTRV223 EQU   CVTRV219
CVTRV222 EQU   CVTRV219
CVTRV221 EQU   CVTRV219
CVTRV220 EQU   CVTRV219
CVTRV218 EQU   CVTRV210
CVTRV217 EQU   CVTRV210
CVTRV216 EQU   CVTRV210
CVTRV215 EQU   CVTRV210
CVTRV214 EQU   CVTRV210
CVTRV213 EQU   CVTRV210
CVTRV212 EQU   CVTRV210
CVTRV211 EQU   CVTRV210
CVTLCCAT EQU   CVTS01+420
CVTPCCAT EQU   CVTS01+416
CVTIPCRP EQU   CVTS01+412
CVTIPCRI EQU   CVTS01+408
CVTIPCDS EQU   CVTS01+404
CVTAIDVT EQU   CVTS01+400
CVTSSAP  EQU   CVTS01+396
CVTEHCIR EQU   CVTS01+392
CVTEHDEF EQU   CVTS01+388
CVTDAIR  EQU   CVTS01+384
CVTPERFM EQU   CVTS01+380
CVT044R2 EQU   CVTS01+376
CVTFETCH EQU   CVTS01+372
CVTRSTWD EQU   CVTS01+368
CVTSPOST EQU   CVTS01+364
CVTIOBP  EQU   CVTS01+360
CVTASMVT EQU   CVTS01+356
CVTRECRQ EQU   CVTS01+352
CVTWSAC  EQU   CVTS01+348
CVTRV149 EQU   CVTS01+344
CVTWSAL  EQU   CVTS01+340
CVTSPSA  EQU   CVTS01+336
CVTGLMN  EQU   CVTS01+332
CVTVEAC0 EQU   CVTS01+328
CVT062R1 EQU   CVTS01+324
CVTRPOST EQU   CVTS01+320
CVTDQIQE EQU   CVTS01+316
CVTCSD   EQU   CVTS01+312
CVTLKRMA EQU   CVTS01+308
CVTRSPIE EQU   CVTS01+304
CVTRENQ  EQU   CVTS01+300
CVTLQCB  EQU   CVTS01+296
CVTQCS01 EQU   CVTS01+288
CVTAPFT  EQU   CVTS01+284
CVTPARRL EQU   CVTS01+280
CVTVWAIT EQU   CVTS01+276
CVTGSPL  EQU   CVTS01+272
CVTLSMQ  EQU   CVTS01+268
CVTGSMQ  EQU   CVTS01+264
CVTEXPRO EQU   CVTS01+260
CVTOPCTP EQU   CVTS01+256
CVTSIC   EQU   CVTS01+252
CVTTPIOS EQU   CVTS01+248
CVTRTMS  EQU   CVTS01+244
CVTSDBF  EQU   CVTS01+240
CVTSCBP  EQU   CVTS01+236
CVTSDMP  EQU   CVTS01+232
CVTSV60  EQU   CVTS01+228
CVTASCBL EQU   CVTS01+220
CVTASCBH EQU   CVTS01+216
CVTGDA   EQU   CVTS01+212
CVTASVT  EQU   CVTS01+208
CVTVVMDI EQU   CVTS01+204
CVTAQTOP EQU   CVTS01+200
CVTIOSCS EQU   CVTS01+196
CVTSDRM  EQU   CVTS01+192
CVTOPTE  EQU   CVTS01+188
CVTSTXU  EQU   CVTS01+184
CVTQUIS  EQU   CVTS01+180
CVTPARS  EQU   CVTS01+176
CVTS1EE  EQU   CVTS01+172
CVTFRAS  EQU   CVTS01+168
CVTQSAS  EQU   CVTS01+164
CVTCRAS  EQU   CVTS01+160
CVTCRMN  EQU   CVTS01+156
CVTDELCP EQU   CVTS01+152
CVTFRECL EQU   CVTS01+148
CVTGETCL EQU   CVTS01+144
CVTBLDCP EQU   CVTS01+140
CVTAUTHL EQU   CVTS01+136
CVTSCAN  EQU   CVTS01+132
CVTRV144 EQU   CVTS01+130
CVTMAXMP EQU   CVTS01+128
CVTSTCK  EQU   CVTS01+124
CVTRV139 EQU   CVTS01+123
CVTDSSAC EQU   CVTS01+122
CVTRV513 EQU   CVTS01+121
CVTIOSPL EQU   CVTS01+120
CVTPTGT  EQU   CVTS01+116
CVTCSPIE EQU   CVTS01+112
CVTSMFEX EQU   CVTS01+108
CVTOLT0A EQU   CVTS01+104
CVTSRBRT EQU   CVTS01+100
CVTPUTL  EQU   CVTS01+96
CVTASCRL EQU   CVTS01+92
CVTASCRF EQU   CVTS01+88
CVTRV326 EQU   CVTS01+84
CVTRV325 EQU   CVTS01+80
CVTRV324 EQU   CVTS01+76
CVT0VL01 EQU   CVTS01+72
CVTSHRVM EQU   CVTS01+68
CVTRV332 EQU   CVTS01+64
CVTTAS   EQU   CVTS01+60
CVTRSCN  EQU   CVTS01+56
CVTTRAC2 EQU   CVTS01+54
CVTTRACE EQU   CVTS01+52
CVTAPG   EQU   CVTS01+51
CVTSDTRC EQU   CVTCTLFG
CVTGTRCE EQU   CVTCTLFG
CVTNOMP  EQU   CVTCTLFG
CVTRSV79 EQU   CVTCTLFG
CVTDSTAT EQU   CVTCTLFG
CVTRSV78 EQU   CVTCTLFG
CVTRV333 EQU   CVTCTLFG
CVTRV323 EQU   CVTCTLFG
CVTSPVLK EQU   CVTS01+49
CVTRSV77 EQU   CVTS01+48
CVTRV331 EQU   CVTS01+44
CVTRV330 EQU   CVTS01+40
CVTRV329 EQU   CVTS01+36
CVTRV328 EQU   CVTS01+32
CVTRV322 EQU   CVTS01+28
CVTSLID  EQU   CVTSLIDA+1
CVTSYLK  EQU   CVTSLIDA
CVTRV321 EQU   CVTS01+20
CVTRV320 EQU   CVTS01+16
CVTLPDIR EQU   CVTLPDIA+1
CVTRSV69 EQU   CVTDIRST
CVTRSV68 EQU   CVTDIRST
CVTRSV67 EQU   CVTDIRST
CVTRSV66 EQU   CVTDIRST
CVTRSV65 EQU   CVTDIRST
CVTRSV64 EQU   CVTDIRST
CVTRSV63 EQU   CVTDIRST
CVTDICOM EQU   CVTDIRST
CVTPVTP  EQU   CVTS01+8
CVTLPDSR EQU   CVTS01+4
CVTGETL  EQU   CVTS01
ASCBEND  EQU   ASCB+208
ASCBSRBT EQU   ASCB+200
ASCBSWTL EQU   ASCB+196
ASCBRS14 EQU   ASCB+195
ASCBSMCT EQU   ASCB+194
ASCBRS12 EQU   ASCB+192
ASCBPCTT EQU   ASCB+188
ASCBVGTT EQU   ASCB+184
ASCBRV43 EQU   ASCBSRQ4
ASCBRV42 EQU   ASCBSRQ4
ASCBRV41 EQU   ASCBSRQ4
ASCBRV40 EQU   ASCBSRQ4
ASCBRV39 EQU   ASCBSRQ4
ASCBRV38 EQU   ASCBSRQ4
ASCBRV37 EQU   ASCBSRQ4
ASCBRV36 EQU   ASCBSRQ4
ASCBRV35 EQU   ASCBSRQ3
ASCBRV34 EQU   ASCBSRQ3
ASCBRV33 EQU   ASCBSRQ3
ASCBRV32 EQU   ASCBSRQ3
ASCBRV31 EQU   ASCBSRQ3
ASCBRV30 EQU   ASCBSRQ3
ASCBRV29 EQU   ASCBSRQ3
ASCBRV28 EQU   ASCBSRQ3
ASCBRV27 EQU   ASCBSRQ2
ASCBRV26 EQU   ASCBSRQ2
ASCBRV25 EQU   ASCBSRQ2
ASCBRV24 EQU   ASCBSRQ2
ASCBRV23 EQU   ASCBSRQ2
ASCBRV22 EQU   ASCBSRQ2
ASCBRV21 EQU   ASCBSRQ2
ASCBRV20 EQU   ASCBSRQ2
ASCBRV19 EQU   ASCBSRQ1
ASCBRV18 EQU   ASCBSRQ1
ASCBRV17 EQU   ASCBSRQ1
ASCBRV16 EQU   ASCBSRQ1
ASCBRV15 EQU   ASCBSRQ1
ASCBRV14 EQU   ASCBSRQ1
ASCBRV13 EQU   ASCBSRQ1
ASCBSTA  EQU   ASCBSRQ1
ASCBJBNS EQU   ASCB+176
ASCBJBNI EQU   ASCB+172
ASCBMCC  EQU   ASCB+168
ASCBRTWA EQU   ASCB+164
ASCBIQEA EQU   ASCB+160
ASCBXMPQ EQU   ASCB+156
ASCBRS01 EQU   ASCB+154
ASCBFMCT EQU   ASCB+152
ASCBOUXB EQU   ASCB+148
ASCBOUCB EQU   ASCB+144
ASCBMECB EQU   ASCB+140
ASCBQECB EQU   ASCB+136
ASCBLSQH EQU   ASCBLKGP+4
ASCBLOCK EQU   ASCBLKGP
ASCBTCBS EQU   ASCB+124
ASCBNVSC EQU   ASCB+122
ASCBVSC  EQU   ASCB+120
ASCBSRBS EQU   ASCB+118
ASCBSSRB EQU   ASCB+116
ASCBRV06 EQU   ASCBFLG2
ASCBRV05 EQU   ASCBFLG2
ASCBRV04 EQU   ASCBFLG2
ASCBSNQS EQU   ASCBFLG2
ASCBS2S  EQU   ASCBFLG2
ASCBCEXT EQU   ASCBFLG2
ASCBPXMT EQU   ASCBFLG2
ASCBXMPT EQU   ASCBFLG2
ASCBRF07 EQU   ASCBDSP1
ASCBRF06 EQU   ASCBDSP1
ASCBRF05 EQU   ASCBDSP1
ASCBRF04 EQU   ASCBDSP1
ASCBRF03 EQU   ASCBDSP1
ASCBRF02 EQU   ASCBDSP1
ASCBFAIL EQU   ASCBDSP1
ASCBNOQ  EQU   ASCBDSP1
ASCBSWCT EQU   ASCB+112
ASCBASXB EQU   ASCB+108
ASCBTMCH EQU   ASCB+104
ASCBNSWP EQU   ASCBFLG1
ASCBTYP1 EQU   ASCBFLG1
ASCBSTND EQU   ASCBFLG1
ASCBABNT EQU   ASCBFLG1
ASCBTERM EQU   ASCBFLG1
ASCBS3S  EQU   ASCBFLG1
ASCBCMSH EQU   ASCBFLG1
ASCBTOFF EQU   ASCBFLG1
ASCBRF01 EQU   ASCBRCTF
ASCBTMLW EQU   ASCBRCTF
ASCBOUT  EQU   ASCBRCTF
ASCBWAIT EQU   ASCBRCTF
ASCBRV08 EQU   ASCBRCTF
ASCBFQU  EQU   ASCBRCTF
ASCBFRS  EQU   ASCBRCTF
ASCBTMNO EQU   ASCBRCTF
ASCBAFFN EQU   ASCBFW1
ASCBDUMP EQU   ASCB+96
ASCBRV44 EQU   ASCB+92
ASCBUBET EQU   ASCB+88
ASCBECB  EQU   ASCB+84
ASCBJSTL EQU   ASCB+80
ASCBEWST EQU   ASCB+72
ASCBEJST EQU   ASCB+64
ASCBTSB  EQU   ASCB+60
ASCBCSCB EQU   ASCB+56
ASCBRSMA EQU   ASCBRSM+1
ASCBRV54 EQU   ASCBRSMF
ASCBRV53 EQU   ASCBRSMF
ASCBRV52 EQU   ASCBRSMF
ASCBRV51 EQU   ASCBRSMF
ASCBVEQR EQU   ASCBRSMF
ASCBN2LP EQU   ASCBRSMF
ASCB1LPU EQU   ASCBRSMF
ASCB2LPU EQU   ASCBRSMF
ASCBLDA  EQU   ASCB+48
ASCBSTOR EQU   ASCB+44
ASCBDP   EQU   ASCB+43
ASCBRV07 EQU   ASCB+42
ASCBIOSM EQU   ASCB+40
ASCBSEQN EQU   ASCB+38
ASCBCPUS EQU   ASCB+32
ASCBSPL  EQU   ASCB+28
ASCBIOSP EQU   ASCB+24
ASCBSYNC EQU   ASCBSUPC+4
ASCBSVRB EQU   ASCBSUPC
ASCBCMSF EQU   ASCB+12
ASCBBWDP EQU   ASCB+8
ASCBFWDP EQU   ASCB+4
ASCBASCB EQU   ASCB
ASCBEGIN EQU   ASCB
@NM00187 EQU   TCBXTNT2+32
TCBRV181 EQU   TCBRV173
TCBRV180 EQU   TCBRV173
TCBRV179 EQU   TCBRV173
TCBRV178 EQU   TCBRV173
TCBRV177 EQU   TCBRV173
TCBRV176 EQU   TCBRV173
TCBRV175 EQU   TCBRV173
TCBRV174 EQU   TCBRV173
TCBRV172 EQU   TCBRV164
TCBRV171 EQU   TCBRV164
TCBRV170 EQU   TCBRV164
TCBRV169 EQU   TCBRV164
TCBRV168 EQU   TCBRV164
TCBRV167 EQU   TCBRV164
TCBRV166 EQU   TCBRV164
TCBRV165 EQU   TCBRV164
TCBRV163 EQU   TCBRV155
TCBRV162 EQU   TCBRV155
TCBRV161 EQU   TCBRV155
TCBRV160 EQU   TCBRV155
TCBRV159 EQU   TCBRV155
TCBRV158 EQU   TCBRV155
TCBRV157 EQU   TCBRV155
TCBRV156 EQU   TCBRV155
TCBRV154 EQU   TCBRV146
TCBRV153 EQU   TCBRV146
TCBRV152 EQU   TCBRV146
TCBRV151 EQU   TCBRV146
TCBRV150 EQU   TCBRV146
TCBRV149 EQU   TCBRV146
TCBRV148 EQU   TCBRV146
TCBRV147 EQU   TCBRV146
TCBRV145 EQU   TCBXTNT2+26
TCBRV144 EQU   TCBXTNT2+24
TCBRV143 EQU   TCBXTNT2+20
TCBRV142 EQU   TCBXTNT2+16
TCBRSV49 EQU   TCBXTNT2+12
TCBEVENT EQU   TCBXTNT2+8
TCBRCMP  EQU   TCBXTNT2+5
TCBRSVAB EQU   TCBXTNT2+4
TCBGTFA  EQU   TCBGTF+1
TCBRSV47 EQU   TCBTFLG
TCBRSV46 EQU   TCBTFLG
TCBRSV45 EQU   TCBTFLG
TCBRSV44 EQU   TCBTFLG
TCBRSV43 EQU   TCBTFLG
TCBDSPIT EQU   TCBTFLG
TCBERRTN EQU   TCBTFLG
TCBASYNC EQU   TCBTFLG
@NM00186 EQU   TCB+296
TCBSVCA2 EQU   TCB+292
TCBSWASA EQU   TCB+288
TCBDBTB  EQU   TCB+284
TCBRPT   EQU   TCB+280
TCBRV141 EQU   TCBRV133
TCBRV140 EQU   TCBRV133
TCBRV139 EQU   TCBRV133
TCBRV138 EQU   TCBRV133
TCBRV137 EQU   TCBRV133
TCBRV136 EQU   TCBRV133
TCBRV135 EQU   TCBRV133
TCBRV134 EQU   TCBRV133
TCBRV132 EQU   TCBRV124
TCBRV131 EQU   TCBRV124
TCBRV130 EQU   TCBRV124
TCBRV129 EQU   TCBRV124
TCBRV128 EQU   TCBRV124
TCBRV127 EQU   TCBRV124
TCBRV126 EQU   TCBRV124
TCBRV125 EQU   TCBRV124
TCBRV123 EQU   TCBFBYT2
TCBRV122 EQU   TCBFBYT2
TCBECBNV EQU   TCBFBYT2
TCBSSSYN EQU   TCBFBYT2
TCBFPRAP EQU   TCBFBYT2
TCBFDW   EQU   TCBFBYT2
TCBFMW   EQU   TCBFBYT2
TCBCNCB  EQU   TCBFBYT2
TCBLLH   EQU   TCBFBYT1
TCBRV113 EQU   TCBFBYT1
TCBEOT   EQU   TCBFBYT1
TCBRTM2  EQU   TCBFBYT1
TCBPGNLY EQU   TCBFBYT1
TCBNDIOS EQU   TCBFBYT1
TCBRV327 EQU   TCBFBYT1
TCBEOTFM EQU   TCBFBYT1
TCBAFFN  EQU   TCB+274
TCBRV326 EQU   TCB+272
TCBUKYSP EQU   TCB+268
TCBMODE  EQU   TCBESTAE+3
TCBERTYP EQU   TCBESTAE+2
TCBRV314 EQU   TCBESTRM
TCBRV313 EQU   TCBESTRM
TCBRV312 EQU   TCBESTRM
TCBRV311 EQU   TCBESTRM
TCBRV310 EQU   TCBESTRM
TCBRV309 EQU   TCBESTRM
TCBRV308 EQU   TCBESTRM
TCBETERM EQU   TCBESTRM
TCBSCBKY EQU   TCBESTAE
TCBRTM12 EQU   TCB+260
TCBTCBID EQU   TCB+256
TCBSTAWA EQU   TCB+252
TCBSWA   EQU   TCB+248
TCBFOEA  EQU   TCBFOE+1
TCBRSV42 EQU   TCBFOE
TCBCCPVI EQU   TCBXSCT+2
TCBRV325 EQU   TCBXSCT+1
TCBRV324 EQU   TCBXSCT1
TCBRV323 EQU   TCBXSCT1
TCBRV322 EQU   TCBXSCT1
TCBRV321 EQU   TCBXSCT1
TCBRV320 EQU   TCBXSCT1
TCBRV319 EQU   TCBXSCT1
TCBS3A   EQU   TCBXSCT1
TCBACTIV EQU   TCBXSCT1
TCBRSV41 EQU   TCB+239
TCBTID   EQU   TCB+238
TCBRSVAA EQU   TCB+237
TCBABCUR EQU   TCB+236
TCBTMSAV EQU   TCB+232
TCBIOTIM EQU   TCB+228
TCBRTWA  EQU   TCB+224
TCBBACK  EQU   TCB+220
TCBTIRB  EQU   TCB+216
TCBAECB  EQU   TCB+212
TCBEXT2A EQU   TCBEXT2+1
TCBRSV39 EQU   TCBEXT2
TCBSTMCT EQU   TCB+207
TCBSYSCT EQU   TCB+206
TCBRSV37 EQU   TCB+205
TCBEXSVC EQU   TCBDAR
TCBDARMS EQU   TCBDAR
TCBDARWT EQU   TCBDAR
TCBDARO  EQU   TCBDAR
TCBDARMC EQU   TCBDARC
TCBDARD  EQU   TCBDAR
TCBDARS  EQU   TCBDAR
TCBDARP  EQU   TCBDAR
TCBGTOFM EQU   TCBFLGS7
TCBRSTSK EQU   TCBFLGS7
TCBSVCS  EQU   TCBFLGS7
TCBSTACK EQU   TCBFLGS7
TCBRSV34 EQU   TCBFLGS7
TCBRSV33 EQU   TCBFLGS7
TCBGPECB EQU   TCBFLGS7
TCBNTJS  EQU   TCBFLGS6
TCBAPG   EQU   TCBFLGS6
TCBMIGR  EQU   TCBFLGS6
TCBRV303 EQU   TCBFLGS6
TCBSPVLK EQU   TCBFLGS6
TCBCPU   EQU   TCBFLGS6
TCBPIE17 EQU   TCBFLGS6
TCBRV    EQU   TCBFLGS6
TCBRSV79 EQU   TCBNDSP5
TCBRSV78 EQU   TCBNDSP5
TCBRSV77 EQU   TCBNDSP5
TCBRSV76 EQU   TCBNDSP5
TCBRSV75 EQU   TCBNDSP5
TCBRSV74 EQU   TCBNDSP5
TCBRSV95 EQU   TCBNDSP5
TCBRSV94 EQU   TCBNDSP5
TCBRSV93 EQU   TCBNDSP4
TCBRSV92 EQU   TCBNDSP4
TCBRSV91 EQU   TCBNDSP4
TCBRSV90 EQU   TCBNDSP4
TCBRSV89 EQU   TCBNDSP4
TCBRSV88 EQU   TCBNDSP4
TCBRSV87 EQU   TCBNDSP4
TCBRSV86 EQU   TCBNDSP4
TCBEXT1A EQU   TCBEXT1+1
TCBRSV32 EQU   TCBEXT1
TCBEXCPD EQU   TCB+192
TCBIOBRC EQU   TCB+188
TCBDDWTC EQU   TCB+186
TCBDDEXC EQU   TCB+184
TCBJSCBB EQU   TCBJSCB+1
@NM00185 EQU   TCBRECDE
TCBREC   EQU   TCBRECDE
TCBMDIDS EQU   TCB+176
TCBNDINT EQU   TCBNDSP3
TCBRSV27 EQU   TCBNDSP3
TCBRSV26 EQU   TCBNDSP3
TCBRSV25 EQU   TCBNDSP3
TCBRSV24 EQU   TCBNDSP3
TCBSRBND EQU   TCBNDSP3
TCBRV302 EQU   TCBNDSP3
TCBLJSND EQU   TCBNDSP3
TCBABE   EQU   TCBNDSP2
TCBDSS   EQU   TCBNDSP2
TCBOWAIT EQU   TCBNDSP2
TCBIWAIT EQU   TCBNDSP2
TCBNDTS  EQU   TCBNDSP2
TCBNDSVC EQU   TCBNDSP2
TCBSTPP  EQU   TCBNDSP2
TCBABD   EQU   TCBNDSP2
TCBRSV22 EQU   TCBNDSP1
TCBPIEND EQU   TCBNDSP1
TCBTPSP  EQU   TCBNDSP1
TCBDDRND EQU   TCBNDSP1
TCBRSPND EQU   TCBNDSP1
TCBRSTND EQU   TCBNDSP1
TCBDARPN EQU   TCBNDSP1
TCBDARTN EQU   TCBNDSP1
TCBNDSP0 EQU   TCBNDSP
TCBUSER  EQU   TCB+168
TCBTCTB  EQU   TCBTCT+1
TCBRSV9C EQU   TCBTCTGF
TCBRSV9B EQU   TCBTCTGF
TCBRSV9A EQU   TCBTCTGF
TCBRSV99 EQU   TCBTCTGF
TCBRSV98 EQU   TCBTCTGF
TCBRSV97 EQU   TCBTCTGF
TCBRSV20 EQU   TCBTCTGF
TCBSMFGF EQU   TCBTCTGF
TCBSTABB EQU   TCBSTAB+1
TCBSTCUR EQU   TCBNSTAE
TCBRV301 EQU   TCBNSTAE
TCBSYNCH EQU   TCBNSTAE
TCBHALT  EQU   TCBNSTAE
TCBPPSUP EQU   TCBNSTAE
TCB33E   EQU   TCBNSTAE
TCBQUIES EQU   TCBNSTAE
TCBSTABE EQU   TCBNSTAE
TCBAQE   EQU   TCB+156
TCBPQE   EQU   TCB+152
TCBTSDP  EQU   TCB+151
TCBTSLP  EQU   TCB+150
TCBSTPCT EQU   TCB+149
TCBCPUBN EQU   TCBTSFLG
TCBDYDSP EQU   TCBTSFLG
TCBRSV18 EQU   TCBTSFLG
TCBRSV17 EQU   TCBTSFLG
TCBTIOTG EQU   TCBTSFLG
TCBATT   EQU   TCBTSFLG
TCBSTPPR EQU   TCBTSFLG
TCBRV300 EQU   TCBTSTSK
TCBECB   EQU   TCB+144
TCBIQE   EQU   TCB+140
TCBNTC   EQU   TCB+128
TCBRSV16 EQU   TCBJSTCB
TCBTQET  EQU   TCBTME
TCBTCB   EQU   TCB+116
TCBFSAB  EQU   TCBFSA+1
TCBQEL   EQU   TCBFSA
TCBGRS15 EQU   TCBGRS+60
TCBGRS14 EQU   TCBGRS+56
TCBGRS13 EQU   TCBGRS+52
TCBGRS12 EQU   TCBGRS+48
TCBGRS11 EQU   TCBGRS+44
TCBGRS10 EQU   TCBGRS+40
TCBGRS9  EQU   TCBGRS+36
TCBGRS8  EQU   TCBGRS+32
TCBGRS7  EQU   TCBGRS+28
TCBGRS6  EQU   TCBGRS+24
TCBGRS5  EQU   TCBGRS+20
TCBGRS4  EQU   TCBGRS+16
TCBGRS3  EQU   TCBGRS+12
TCBGRS2  EQU   TCBGRS+8
TCBGRS1  EQU   TCBGRS+4
TCBGRS0  EQU   TCBGRS
TCBJPQB  EQU   TCBJPQ+1
TCBRSV15 EQU   TCBPURGE
TCBRSV14 EQU   TCBPURGE
TCBRSV13 EQU   TCBPURGE
TCBRSV12 EQU   TCBPURGE
TCBRSV11 EQU   TCBPURGE
TCBRSV10 EQU   TCBPURGE
TCBRSV09 EQU   TCBPURGE
TCBJPQF  EQU   TCBPURGE
TCBJLB   EQU   TCB+40
TCBLLS   EQU   TCB+36
TCBDSP   EQU   TCB+35
TCBLMP   EQU   TCB+34
TCBPNDSP EQU   TCBFLGS5
TCBFCD1  EQU   TCBFLGS5
TCBSTP   EQU   TCBFLGS5
TCBSYS   EQU   TCBFLGS5
TCBANDSP EQU   TCBFLGS5
TCBPAGE  EQU   TCBFLGS5
TCBUXNDF EQU   TCBABWF
TCBFC    EQU   TCBFLGS5
TCBONDSP EQU   TCBFLGS4
TCBMPCND EQU   TCBFLGS4
TCBMPCVQ EQU   TCBFLGS4
TCBUXNDV EQU   TCBFLGS4
TCBHNDSP EQU   TCBFLGS4
TCBRQENA EQU   TCBFLGS4
TCBSER   EQU   TCBFLGS4
TCBNDUMP EQU   TCBFLGS4
TCBDWSTA EQU   TCBFLGS3
TCBRSV08 EQU   TCBFLGS3
TCBRSV07 EQU   TCBFLGS3
TCBRSV06 EQU   TCBFLGS3
TCBABGM  EQU   TCBFLGS3
TCBABTRM EQU   TCBFLGS3
TCBADINP EQU   TCBFLGS3
TCBFSM   EQU   TCBFLGS3
TCBFTS   EQU   TCBFLGS2
TCBFETXR EQU   TCBFLGS2
TCBFDSOP EQU   TCBFLGS2
TCBFJMC  EQU   TCBFLGS2
TCBFSMC  EQU   TCBFLGS2
TCBFABOP EQU   TCBFLGS2
TCBFSTI  EQU   TCBFLGS2
TCBFOINP EQU   TCBFLGS2
TCBFX    EQU   TCBFLGS1
TCBFS    EQU   TCBFLGS1
TCBFT    EQU   TCBFLGS1
TCBPDUMP EQU   TCBFLGS1
TCBNONPR EQU   TCBFLGS1
TCBFERA  EQU   TCBFLGS1
TCBFE    EQU   TCBFLGS1
TCBFA    EQU   TCBFLGS1
TCBZERO  EQU   TCBPKF
TCBMSSB  EQU   TCBMSS+1
TCBRSV03 EQU   TCBMSS
TCBTRNB  EQU   TCBTRN+1
TCBRSV02 EQU   TCBABF
TCBOLTEP EQU   TCBABF
TCBTCP   EQU   TCBABF
TCBTCPP  EQU   TCBABF
TCBRSV01 EQU   TCBABF
TCBGRPH  EQU   TCBABF
TCBNOCHK EQU   TCBABF
TCBMOD91 EQU   TCBABF
TCBCMPC  EQU   TCBCMP+1
TCBRV318 EQU   TCBCMSG
TCBRV317 EQU   TCBCIND
TCBRV316 EQU   TCBCWTO
TCBCASID EQU   TCBCDBL
TCBNOCC  EQU   TCBSTCC
TCBDMPO  EQU   TCBCPP
TCBCSTEP EQU   TCBCMPF
TCBCREQ  EQU   TCBCMPF
TCBTIO   EQU   TCB+12
TCBDEB   EQU   TCB+8
TCBPIEA  EQU   TCBPIE+1
TCBPM    EQU   TCBPMASK
@NM00184 EQU   TCBPMASK
TCBRBP   EQU   TCB
TCBFRS6  EQU   TCBFRS+24
TCBFRS4  EQU   TCBFRS+16
TCBFRS2  EQU   TCBFRS+8
TCBFRS0  EQU   TCBFRS
RTCTISVC EQU   RTCTSDO4
RTCTSDOV EQU   RTCTSDMG
@NM00183 EQU   RTCTSDO4
@NM00182 EQU   RTCTSDO3
RTCTSDPH EQU   RTCTSDO3
RTCTSDPG EQU   RTCTSDO3
@NM00181 EQU   RTCTSDO2
RTCTSDPD EQU   RTCTSDO2
RTCTSDPC EQU   RTCTSDO2
RTCTSDPB EQU   RTCTSDO2
RTCTSDPA EQU   RTCTSDO2
RTCTSDP9 EQU   RTCTSDO2
RTCTSDP8 EQU   RTCTSDO2
RTCTSDP7 EQU   RTCTSDO1
RTCTSDP6 EQU   RTCTSDO1
RTCTSDP5 EQU   RTCTSDO1
RTCTSDP4 EQU   RTCTSDO1
RTCTSDP3 EQU   RTCTSDO1
RTCTSDP2 EQU   RTCTSDO1
RTCTSDP1 EQU   RTCTSDO1
RTCTSDP0 EQU   RTCTSDO1
RTCTISYM EQU   RTCTSD04
RTCTSMOV EQU   RTCTSMMG
@NM00180 EQU   RTCTSD04
RTCTSD03 EQU   RTCTMSYO+2
RTCTSD02 EQU   RTCTMSYO+1
RTCTSDS7 EQU   RTCTSD01
RTCTSDS6 EQU   RTCTSD01
RTCTSDS5 EQU   RTCTSD01
RTCTSDS4 EQU   RTCTSD01
RTCTSDS3 EQU   RTCTSD01
RTCTSDS2 EQU   RTCTSD01
RTCTSDS1 EQU   RTCTSD01
RTCTSDS0 EQU   RTCTSD01
RTCTISYU EQU   RTCTSUO4
RTCTSUOV EQU   RTCTSUMG
@NM00179 EQU   RTCTSUO4
RTCTSYDF EQU   RTCTSUO3
RTCTSYDE EQU   RTCTSUO3
RTCTSYDD EQU   RTCTSUO3
RTCTSYDC EQU   RTCTSUO3
RTCTSYDB EQU   RTCTSUO3
RTCTSYDA EQU   RTCTSUO3
RTCTSYD9 EQU   RTCTSUO3
RTCTSYD8 EQU   RTCTSUO3
@NM00178 EQU   RTCTSUO2
RTCTSYDH EQU   RTCTSUO2
RTCTSYDG EQU   RTCTSUO2
RTCTSYD7 EQU   RTCTSUO1
RTCTSYD6 EQU   RTCTSUO1
RTCTSYD5 EQU   RTCTSUO1
RTCTSYD4 EQU   RTCTSUO1
RTCTSYD3 EQU   RTCTSUO1
RTCTSYD2 EQU   RTCTSUO1
RTCTSYD1 EQU   RTCTSUO1
RTCTSYD0 EQU   RTCTSUO1
RTCTISAB EQU   RTCTSAO4
RTCTSAOV EQU   RTCTSAMG
@NM00177 EQU   RTCTSAO4
RTCTSADF EQU   RTCTSAO3
RTCTSADE EQU   RTCTSAO3
RTCTSADD EQU   RTCTSAO3
RTCTSADC EQU   RTCTSAO3
RTCTSADB EQU   RTCTSAO3
RTCTSADA EQU   RTCTSAO3
RTCTSAD9 EQU   RTCTSAO3
RTCTSAD8 EQU   RTCTSAO3
@NM00176 EQU   RTCTSAO2
RTCTSADH EQU   RTCTSAO2
RTCTSADG EQU   RTCTSAO2
RTCTSAD7 EQU   RTCTSAO1
RTCTSAD6 EQU   RTCTSAO1
RTCTSAD5 EQU   RTCTSAO1
RTCTSAD4 EQU   RTCTSAO1
RTCTSAD3 EQU   RTCTSAO1
RTCTSAD2 EQU   RTCTSAO1
RTCTSAD1 EQU   RTCTSAO1
RTCTSAD0 EQU   RTCTSAO1
RTCTZZZ5 EQU   RTCT+340
RTCTZZZ4 EQU   RTCT+336
RTCTMRMQ EQU   RTCT+332
RTCTSDF5 EQU   RTCTSDF3+3
RTCTSDDO EQU   RTCTSDF4
RTCTSDEN EQU   RTCTSDF4
RTCTSDEQ EQU   RTCTSDF4
RTCTSDTR EQU   RTCTSDF4
RTCTSDRM EQU   RTCTSDF4
RTCTSDAN EQU   RTCTSDF4
RTCTSDNC EQU   RTCTSDF4
RTCTSDSS EQU   RTCTSDF4
RTCTSDAS EQU   RTCTSDF3
RTCTZZZ3 EQU   RTCT+266
RTCTSDFX EQU   RTCTSDF2
RTCTSDRW EQU   RTCTSDF2
RTCTSDSL EQU   RTCTSDF2
RTCTSDWF EQU   RTCTSDF2
RTCTSDLA EQU   RTCTSDF2
RTCTSDDI EQU   RTCTSDF2
RTCTSDTQ EQU   RTCTSDF2
RTCTSDMR EQU   RTCTSDF2
RTCTSDSC EQU   RTCTSDF1
RTCTSDRS EQU   RTCTSDF1
RTCTSDSD EQU   RTCTSDF1
RTCTSDEP EQU   RTCTSDF1
RTCTSDMA EQU   RTCTSDF1
RTCTSDSH EQU   RTCTSDF1
RTCTSDND EQU   RTCTSDF1
RTCTSDNO EQU   RTCTSDF1
RTCTZZZ2 EQU   RTCT+257
RTCTSDPR EQU   RTCTSDI+2
RTCTINDX EQU   RTCTSDI+1
RTCTSDNA EQU   RTCTSDI
@NM00175 EQU   RTCTASO2
RTCTASNQ EQU   RTCTASO2
RTCTASNA EQU   RTCTASO2
RTCTASNS EQU   RTCTASO2
RTCTASSU EQU   RTCTASO2
RTCTASSW EQU   RTCTASO2
RTCTASCS EQU   RTCTASO2
RTCTASTR EQU   RTCTASO1
RTCTASLP EQU   RTCTASO1
RTCTASRG EQU   RTCTASO1
RTCTASLS EQU   RTCTASO1
RTCTASSQ EQU   RTCTASO1
RTCTASNU EQU   RTCTASO1
RTCTASPS EQU   RTCTASO1
RTCTASAL EQU   RTCTASO1
RTCTSDO  EQU   RTCTOPT+12
RTCTSYO  EQU   RTCTOPT+8
RTCTSUO  EQU   RTCTOPT+4
RTCTSAO  EQU   RTCTOPT
RTCTXXX2 EQU   RTCT+234
RTCTETIM EQU   RTCTERID+6
RTCTEASD EQU   RTCTERID+4
RTCTECPU EQU   RTCTERID+2
RTCTESEQ EQU   RTCTERID
RTCTSDWK EQU   RTCT+220
RTCTTDCB EQU   RTCT+184
RTCTSDSW EQU   RTCT+180
RTCTSEQ# EQU   RTCT+178
RTCTXXX1 EQU   RTCT+177
@NM00174 EQU   RTCTRFLG
RTCTRSTF EQU   RTCTRFLG
RTCTRPER EQU   RTCTRFLG
RTCTRTER EQU   RTCTRFLG
RTCTTEST EQU   RTCT+172
RTCTMSRB EQU   RTCT+168
RTCTMLCK EQU   RTCT+164
RTCTFMT  EQU   RTCT+160
RTCTSDIP EQU   RTCTSDPL
RTCTDEV  EQU   RTCTSDDS+8
RTCTDCB  EQU   RTCTSDDS+4
RTCTDTND EQU   RTCTFLG
@NM00173 EQU   RTCTFLG
RTCTDETP EQU   RTCTFLG
RTCTDSUS EQU   RTCTFLG
RTCTDSST EQU   RTCTFLG
RTCTDSNM EQU   RTCTSDDS
RTCTRCB  EQU   RTCT+32
RTCTRECB EQU   RTCT+28
RTCTFASB EQU   RTCT+24
RTCTMECB EQU   RTCT+20
RTCTSDID EQU   RTCT+18
RTCTYYY1 EQU   RTCT+16
RTCTSY04 EQU   RTCTSYD+3
RTCTSY03 EQU   RTCTSYD+2
RTCTSY02 EQU   RTCTSYD+1
RTCTSYM7 EQU   RTCTSY01
RTCTSYM6 EQU   RTCTSY01
RTCTSYM5 EQU   RTCTSY01
RTCTSYM4 EQU   RTCTSY01
RTCTSYM3 EQU   RTCTSY01
RTCTSYM2 EQU   RTCTSY01
RTCTSYM1 EQU   RTCTSY01
RTCTSYM0 EQU   RTCTSY01
RTCTSUP4 EQU   RTCTSUP+3
RTCTSUDF EQU   RTCTSUP3
RTCTSUDE EQU   RTCTSUP3
RTCTSUDD EQU   RTCTSUP3
RTCTSUDC EQU   RTCTSUP3
RTCTSUDB EQU   RTCTSUP3
RTCTSUDA EQU   RTCTSUP3
RTCTSUD9 EQU   RTCTSUP3
RTCTSUD8 EQU   RTCTSUP3
@NM00172 EQU   RTCTSUP2
RTCTSUDH EQU   RTCTSUP2
RTCTSUDG EQU   RTCTSUP2
RTCTSUD7 EQU   RTCTSUP1
RTCTSUD6 EQU   RTCTSUP1
RTCTSUD5 EQU   RTCTSUP1
RTCTSUD4 EQU   RTCTSUP1
RTCTSUD3 EQU   RTCTSUP1
RTCTSUD2 EQU   RTCTSUP1
RTCTSUD1 EQU   RTCTSUP1
RTCTSUD0 EQU   RTCTSUP1
RTCTSAP4 EQU   RTCTSAP+3
RTCTSABF EQU   RTCTSAP3
RTCTSABE EQU   RTCTSAP3
RTCTSABD EQU   RTCTSAP3
RTCTSABC EQU   RTCTSAP3
RTCTSABB EQU   RTCTSAP3
RTCTSABA EQU   RTCTSAP3
RTCTSAB9 EQU   RTCTSAP3
RTCTSAB8 EQU   RTCTSAP3
@NM00171 EQU   RTCTSAP2
RTCTSABH EQU   RTCTSAP2
RTCTSABG EQU   RTCTSAP2
RTCTSAB7 EQU   RTCTSAP1
RTCTSAB6 EQU   RTCTSAP1
RTCTSAB5 EQU   RTCTSAP1
RTCTSAB4 EQU   RTCTSAP1
RTCTSAB3 EQU   RTCTSAP1
RTCTSAB2 EQU   RTCTSAP1
RTCTSAB1 EQU   RTCTSAP1
RTCTSAB0 EQU   RTCTSAP1
RTCTNAME EQU   RTCT
CVTLEVL  EQU   CVTRELNO+2
CVTNUMB  EQU   CVTRELNO
CVTMDL   EQU   CVTFIX+250
@NM00146 EQU   CVTFIX+248
@NM00145 EQU   CVTFIX
CVTRV482 EQU   CVTXTNT2+128
CVTRV481 EQU   CVTXTNT2+124
CVTRV480 EQU   CVTXTNT2+120
CVTRV479 EQU   CVTXTNT2+118
CVTRV478 EQU   CVTXTNT2+117
CVTRV477 EQU   CVTXTNT2+116
CVTRV476 EQU   CVTXTNT2+115
CVTRV475 EQU   CVTXTNT2+114
CVTRV474 EQU   CVTRV466
CVTRV473 EQU   CVTRV466
CVTRV472 EQU   CVTRV466
CVTRV471 EQU   CVTRV466
CVTRV470 EQU   CVTRV466
CVTRV469 EQU   CVTRV466
CVTRV468 EQU   CVTRV466
CVTRV467 EQU   CVTRV466
CVTRV465 EQU   CVTRV457
CVTRV464 EQU   CVTRV457
CVTRV463 EQU   CVTRV457
CVTRV462 EQU   CVTRV457
CVTRV461 EQU   CVTRV457
CVTRV460 EQU   CVTRV457
CVTRV459 EQU   CVTRV457
CVTRV458 EQU   CVTRV457
CVTRV456 EQU   CVTXTNT2+108
CVTRV455 EQU   CVTXTNT2+104
CVTRV454 EQU   CVTXTNT2+100
CVTRV453 EQU   CVTXTNT2+96
CVTRV452 EQU   CVTXTNT2+94
CVTRV451 EQU   CVTXTNT2+92
CVTRV450 EQU   CVTXTNT2+90
CVTRV449 EQU   CVTXTNT2+88
CVTRV448 EQU   CVTXTNT2+87
CVTRV447 EQU   CVTXTNT2+86
CVTRV446 EQU   CVTRV438
CVTRV445 EQU   CVTRV438
CVTRV444 EQU   CVTRV438
CVTRV443 EQU   CVTRV438
CVTRV442 EQU   CVTRV438
CVTRV441 EQU   CVTRV438
CVTRV440 EQU   CVTRV438
CVTRV439 EQU   CVTRV438
CVTRV437 EQU   CVTRV429
CVTRV436 EQU   CVTRV429
CVTRV435 EQU   CVTRV429
CVTRV434 EQU   CVTRV429
CVTRV433 EQU   CVTRV429
CVTRV432 EQU   CVTRV429
CVTRV431 EQU   CVTRV429
CVTRV430 EQU   CVTRV429
CVTRV428 EQU   CVTXTNT2+80
CVTRV427 EQU   CVTXTNT2+76
CVTRV426 EQU   CVTXTNT2+72
CVTRV425 EQU   CVTXTNT2+68
CVTATACT EQU   CVTATCVT
CVTRV423 EQU   CVTXTNT2+62
CVTRV422 EQU   CVTXTNT2+60
CVTRV421 EQU   CVTXTNT2+58
CVTRV420 EQU   CVTXTNT2+56
CVTRV419 EQU   CVTXTNT2+55
CVTRV418 EQU   CVTXTNT2+54
CVTRV417 EQU   CVTRV409
CVTRV416 EQU   CVTRV409
CVTRV415 EQU   CVTRV409
CVTRV414 EQU   CVTRV409
CVTRV413 EQU   CVTRV409
CVTRV412 EQU   CVTRV409
CVTRV411 EQU   CVTRV409
CVTRV410 EQU   CVTRV409
CVTRV408 EQU   CVTRV400
CVTRV407 EQU   CVTRV400
CVTRV406 EQU   CVTRV400
CVTRV405 EQU   CVTRV400
CVTRV404 EQU   CVTRV400
CVTRV403 EQU   CVTRV400
CVTRV402 EQU   CVTRV400
CVTRV401 EQU   CVTRV400
CVTICB   EQU   CVTXTNT2+48
CVTSKTA  EQU   CVTXTNT2+44
CVTCCVT  EQU   CVTXTNT2+40
CVTRSV98 EQU   CVTXTNT2+36
CVTRSV97 EQU   CVTXTNT2+34
CVTRSV96 EQU   CVTXTNT2+32
CVTOLTEP EQU   CVTXTNT2+28
CVTQIDA  EQU   CVTQID+1
CVTRSV95 EQU   CVTQID
CVTRSV94 EQU   CVTXTNT2+20
CVTRSV93 EQU   CVTXTNT2+16
CVTRSV92 EQU   CVTXTNT2+12
CVTDEBVR EQU   CVTXTNT2+8
CVTRSV91 EQU   CVTXTNT2+6
CVTRSV9H EQU   CVTFLGBT
CVTRSV9G EQU   CVTFLGBT
CVTRSV9F EQU   CVTFLGBT
CVTRSV9E EQU   CVTFLGBT
CVTRSV9D EQU   CVTFLGBT
CVTBAH   EQU   CVTFLGBT
CVTVME   EQU   CVTFLGBT
CVTNPE   EQU   CVTFLGBT
CVTNUCLS EQU   CVTXTNT2+4
CVTDSSVA EQU   CVTDSSV+1
CVTRSV89 EQU   CVTDSSV
CVTRSV88 EQU   CVTXTNT1+8
CVTRSV87 EQU   CVTXTNT1+4
CVTFACHN EQU   CVTXTNT1
CVTRV488 EQU   CVTMAP+412
CVTRV487 EQU   CVTMAP+408
CVTRV486 EQU   CVTMAP+404
CVTRV485 EQU   CVTMAP+400
CVTACTAP EQU   CVTMAP+396
CVTAUTH  EQU   CVTMAP+392
CVTRV490 EQU   CVTMAP+388
CVTSU    EQU   CVTMAP+384
CVTVOLT1 EQU   CVTVOLM1+1
CVTVOLI1 EQU   CVTVOLF1
CVTSTOA  EQU   CVTMAP+376
CVTRSV58 EQU   CVTMAP+374
CVTRSV57 EQU   CVTMAP+372
CVTDDCE  EQU   CVTMAP+368
CVTPNWFR EQU   CVTMAP+364
CVTSMF   EQU   CVTMAP+360
CVTSULK  EQU   CVTMAP+358
CVTSLKO  EQU   CVTSYSK
CVTSLKP  EQU   CVTSYSK
CVTSLKQ  EQU   CVTSYSK
CVTSLKR  EQU   CVTSYSK
CVTRSV56 EQU   CVTSYSK
CVTRSV55 EQU   CVTSYSK
CVTRSV54 EQU   CVTSYSK
CVTRSV53 EQU   CVTSYSK
CVTRSV52 EQU   CVTA1F1
CVTRSV51 EQU   CVTA1F1
CVTRSV50 EQU   CVTA1F1
CVTRSV49 EQU   CVTA1F1
CVTRSV48 EQU   CVTA1F1
CVTRSV47 EQU   CVTA1F1
CVTSRSW  EQU   CVTA1F1
CVTPFSW  EQU   CVTA1F1
CVTPCVT  EQU   CVTMAP+352
CVTRSV46 EQU   CVTMAP+344
CVTRSV45 EQU   CVTMAP+340
CVTRSV44 EQU   CVTMAP+338
CVTRSV43 EQU   CVTMAP+336
CVTHJESA EQU   CVTHJES+1
CVTRSV42 EQU   CVTHJES
CVTEXT2A EQU   CVTEXT2+1
CVTRSV41 EQU   CVTEXT2
CVTAPFA  EQU   CVTAPF+1
CVTRSV40 EQU   CVTAPF
CVTRV518 EQU   CVTINTLA
CVTRV517 EQU   CVTERPV
CVTEORM  EQU   CVTMAP+312
CVTMCHPR EQU   CVTMAP+308
CVTTZ    EQU   CVTMAP+304
CVTJEPS  EQU   CVTMAP+300
CVTJESCT EQU   CVTMAP+296
CVTMODE  EQU   CVTMAP+292
CVTPTRV  EQU   CVTMAP+288
CVTREAL  EQU   CVTMAP+284
CVTRSV39 EQU   CVTMAP+280
CVTRSV38 EQU   CVTMAP+276
CVTDMSRA EQU   CVTDMSR+1
CVTRV634 EQU   CVTDMSRF
CVTRV633 EQU   CVTDMSRF
CVTRV632 EQU   CVTDMSRF
CVTRV631 EQU   CVTDMSRF
CVTRV630 EQU   CVTDMSRF
CVTRV629 EQU   CVTDMSRF
CVTUDUMP EQU   CVTDMSRF
CVTSDUMP EQU   CVTDMSRF
CVTQMSGA EQU   CVTQMSG+1
CVTRSV36 EQU   CVTQMSG
CVTAMFF  EQU   CVTMAP+264
CVTPURGA EQU   CVTPURG+1
CVTRSV35 EQU   CVTPURG
CVTCBSP  EQU   CVTMAP+256
CVTATERA EQU   CVTATER+1
CVTSYST  EQU   CVTATER
CVTVOLT2 EQU   CVTTAT
CVTVOLI2 EQU   CVTVOLF2
CVTAQAVB EQU   CVTAQAVT+1
CVTRSV34 EQU   CVTTCMFG
CVTRSV33 EQU   CVTTCMFG
CVTRSV32 EQU   CVTTCMFG
CVTRSV31 EQU   CVTTCMFG
CVTRSV30 EQU   CVTTCMFG
CVTRSV29 EQU   CVTTCMFG
CVTLDEV  EQU   CVTTCMFG
CVTTCRDY EQU   CVTTCMFG
CVTGTFA  EQU   CVTGTF+1
CVTRSV27 EQU   CVTGTFST
CVTRNIO  EQU   CVTGTFST
CVTUSR   EQU   CVTGTFST
CVTRV318 EQU   CVTFORM
CVTRV317 EQU   CVTTMODE
CVTRV316 EQU   CVTSTATE
CVTRV315 EQU   CVTGTFS
CVTGTFAV EQU   CVTGTFS
CVT0SCR1 EQU   CVTMAP+232
CVTRV515 EQU   CVTMAP+228
CVTRMS   EQU   CVTMAP+224
CVTPATCH EQU   CVTMAP+220
CVTTSCE  EQU   CVTMAP+216
CVTLNKSC EQU   CVTMAP+214
CVTQABST EQU   CVTMAP+212
CVTMDLDS EQU   CVTMAP+208
CVTUSER  EQU   CVTMAP+204
CVTABEND EQU   CVTMAP+200
CVTSMCA  EQU   CVTMAP+196
CVTRSV18 EQU   CVTMAP+192
CVTQLPAQ EQU   CVTMAP+188
CVTQCDSR EQU   CVTMAP+184
CVTVS1B  EQU   CVTOPTB
CVTVS1A  EQU   CVTOPTB
CVTFP    EQU   CVTOPTB
CVTAPTHR EQU   CVTOPTB
CVTNLOG  EQU   CVTOPTB
CVTTOD   EQU   CVTOPTB
CVTCTIMS EQU   CVTOPTB
CVTPROT  EQU   CVTOPTB
CVTXPFP  EQU   CVTOPTA
CVTASCII EQU   CVTOPTA
CVTRSV13 EQU   CVTOPTA
CVTRSV12 EQU   CVTOPTA
CVTNIP   EQU   CVTOPTA
CVTDDR   EQU   CVTOPTA
CVTAPR   EQU   CVTOPTA
CVTCCH   EQU   CVTOPTA
CVTSNCTR EQU   CVTMAP+180
CVTQMWR  EQU   CVTMAP+176
CVTQOCR  EQU   CVTMAP+172
CVT1EF00 EQU   CVTMAP+168
CVTMZ00  EQU   CVTMAP+164
CVTSV76Q EQU   CVTSV76C
CVTRSV11 EQU   CVTMAP+156
CVT0PT01 EQU   CVTMAP+152
CVTMSER  EQU   CVTMAP+148
CVTRV516 EQU   CVTIERLC
CVTILCH  EQU   CVTMAP+140
CVT0DS   EQU   CVTMAP+136
CVTFBOSV EQU   CVTMAP+132
CVTNUCB  EQU   CVTMAP+128
CVTIXAVL EQU   CVTMAP+124
CVTSV76M EQU   CVTIOQET
CVTDCBA  EQU   CVTMAP+117
CVTMVS2  EQU   CVTDCB
CVT6DAT  EQU   CVTDCB
CVT4MPS  EQU   CVTDCB
CVTRSV09 EQU   CVTDCB
CVT4MS1  EQU   CVTDCB
CVT2SPS  EQU   CVTDCB
CVT1SSS  EQU   CVTDCB
CVTRSV08 EQU   CVTDCB
CVTSTB   EQU   CVTMAP+112
CVTQTD00 EQU   CVTMAP+108
CVTQTE00 EQU   CVTMAP+104
CVTCUCB  EQU   CVTMAP+100
CVTSJQ   EQU   CVTMAP+96
CVTPBLDL EQU   CVTMAP+92
CVTTPC   EQU   CVTMAP+88
CVTSVDCB EQU   CVTMAP+84
CVTBRET  EQU   CVTMAP+82
CVTEXIT  EQU   CVTMAP+80
CVT0FN00 EQU   CVTMAP+76
CVTDARA  EQU   CVTDAR+1
CVTRSV07 EQU   CVTFLGS1
CVTRSV06 EQU   CVTFLGS1
CVTRSV05 EQU   CVTFLGS1
CVTRSV04 EQU   CVTFLGS1
CVTRSV03 EQU   CVTFLGS1
CVTRSV02 EQU   CVTFLGS1
CVTRSV01 EQU   CVTFLGS1
CVTDMPLK EQU   CVTFLGS1
CVTXITP  EQU   CVTMAP+68
CVTZDTAB EQU   CVTMAP+64
CVTMSLT  EQU   CVTMAP+60
CVTDATE  EQU   CVTMAP+56
CVTBTERM EQU   CVTMAP+52
CVTSYSAD EQU   CVTMAP+48
CVTXTLER EQU   CVTMAP+44
CVTILK2  EQU   CVTMAP+40
CVTILK1  EQU   CVTMAP+36
CVTPRLTV EQU   CVTMAP+32
CVTPCNVT EQU   CVTMAP+28
CVT0VL00 EQU   CVTMAP+24
CVTXAPG  EQU   CVTMAP+20
CVTBUF   EQU   CVTMAP+16
CVTJOB   EQU   CVTMAP+12
CVTLINK  EQU   CVTMAP+8
CVT0EF00 EQU   CVTMAP+4
CVTTCBP  EQU   CVTMAP
CVT      EQU   CVTMAP
ABDTRLN  EQU   ABDAREA+676
ABDSAVE1 EQU   ABDAREA+672
ABDSAVHD EQU   ABDAREA+592
ABDPADC  EQU   ABDAREA+589
ABDSRC2  EQU   ABDAREA+382
ABDLOG   EQU   ABDAREA+380
ABDSRC1  EQU   ABDAREA+378
ABDPHY   EQU   ABDAREA+376
ABDLCNT  EQU   ABDAREA+372
@NM00144 EQU   ESPARM+29
@NM00143 EQU   ESTAEFLG
EDCB     EQU   ESTAEFLG
ETCB     EQU   ESTAEFLG
ESUBSYT  EQU   ESTAEFLG
ERESTART EQU   ESPARM+24
EMODNAME EQU   ESPARM+16
EABDAREA EQU   ESPARM+12
ESAUTOP  EQU   ESPARM+8
ESBSREG2 EQU   ESPARM+4
ESBSREG  EQU   ESPARM
ABDRTRN  EQU   ABDAREA+336
ABDSVCB  EQU   ABDAREA+332
@NM00142 EQU   ABDGMA+14
ABDCDID  EQU   ABDGMA+12
ABDPAREA EQU   ABDGMA+8
ABDBUFSZ EQU   ABDBUFFS+4
ABDBUFAD EQU   ABDBUFFS
ABSLCTSV EQU   ABDAREA+304
ABDSTADS EQU   ABDAREA+300
ABDUPRID EQU   ABDAREA+296
ABDPCAP  EQU   ABDAREA+295
ABDLLNGH EQU   ABDAREA+294
ABDINCPL EQU   ABDAREA+292
ABDFWORK EQU   ABDAREA+288
ABDIDENT EQU   ABDAREA+286
ABDIND   EQU   ABDAREA+284
ABDSIZE  EQU   ABDAREA+280
ABDLENTH EQU   ABDAREA+276
ABDBLOCK EQU   ABDAREA+272
ABDSTAD  EQU   ABDAREA+268
@NM00141 EQU   ABDBLNKS
@NM00140 EQU   ABDBLNKS
@NM00139 EQU   ABDBLNKS
@NM00138 EQU   ABDBLNKS
@NM00137 EQU   ABDBLNKS
@NM00136 EQU   ABDBLNKS
@NM00135 EQU   ABDBLNKS
ABDBLKN3 EQU   ABDBLNKS
@NM00134 EQU   ABDUPRFN
@NM00133 EQU   ABDUPRFN
@NM00132 EQU   ABDUPRFN
@NM00131 EQU   ABDUPRFN
@NM00130 EQU   ABDUPRFN
@NM00129 EQU   ABDUPRFN
ABDUPRSL EQU   ABDUPRFN
ABDUPRPM EQU   ABDUPRFN
@NM00128 EQU   ABDUPRF
@NM00127 EQU   ABDUPRF
@NM00126 EQU   ABDUPRF
@NM00125 EQU   ABDUPRF
@NM00124 EQU   ABDUPRF
UPRFMT20 EQU   ABDUPRF
UPRFMET  EQU   ABDUPRF
UPRFMAT  EQU   ABDUPRF
ABDLPTR  EQU   ABDAREA+252
ABDSSPAR EQU   ABDAREA+188
@NM00123 EQU   ABDRES1
ABDTRSV  EQU   ABDRES1
ABDPGHD  EQU   ABDRES1
ABDFMTLD EQU   ABDRES1
ABDSQA   EQU   ABDRES1
ABDOLSQA EQU   ABDRES1
ABDREGS  EQU   ABDRES1
ABDPSW   EQU   ABDRES1
ABDKEY   EQU   ABDAREA+138
ABDLSQA  EQU   ABDFLAG2
ABDSWAP  EQU   ABDFLAG2
ABDGTFCL EQU   ABDFLAG2
ABDTRNAV EQU   ABDFLAG2
ABDTRBIT EQU   ABDFLAG2
ABDGTF   EQU   ABDFLAG2
ABDSUPER EQU   ABDFLAG2
ABDIDX   EQU   ABDFLAG1
ABDSPHD  EQU   ABDFLAG1
ABDSVCHD EQU   ABDFLAG1
ABDSQSDM EQU   ABDFLAG1
ABDLSTHD EQU   ABDFLAG1
ABDPGWK  EQU   ABDAREA+128
ABDWORK1 EQU   ABDAREA+120
ABDRESV3 EQU   ABDAREA+116
ABDUPRXT EQU   ABDAREA+112
ABDCP1   EQU   ABDAREA+108
ABDLP    EQU   ABDAREA+104
ABDFP    EQU   ABDAREA+100
ABDCP    EQU   ABDAREA+96
ABDPTRS3 EQU   ABDPTRS+8
ABDPTRS2 EQU   ABDPTRS+4
ABDPTRS1 EQU   ABDPTRS
ABDPCTR  EQU   ABDAREA+82
ABDLCTR  EQU   ABDAREA+80
ABDIOBP  EQU   ABDAREA+76
ABDPTR   EQU   ABDAREA+72
ABDDCB   EQU   ABDAREA+68
ABDLEN   EQU   ABDAREA+66
ABDTYPE  EQU   ABDAREA+64
ABDECB   EQU   ABDAREA+60
ABDSAVE  EQU   ABDAREA+56
ABDDECB  EQU   ABDAREA+52
ABDPARA  EQU   ABDAREA+48
ABDTABPT EQU   ABDAREA+44
ABDINXPT EQU   ABDAREA+40
ABDCTR   EQU   ABDAREA+38
@NM00122 EQU   ABDAREA+36
ABDHDRAD EQU   ABDPARMS+20
ABDSNAPP EQU   ABDPARMS+16
ABDPTCBP EQU   ABDPARMS+12
ABDPDCBP EQU   ABDPARMS+8
@NM00121 EQU   ABDPARMS+7
@NM00120 EQU   APFPDATA
APFSPALL EQU   APFPDATA
APFPSW   EQU   APFPDATA
APFJPA   EQU   APFPDATA
APFLPA   EQU   APFPDATA
APFREGS  EQU   APFPDATA
APFSAVE2 EQU   APFPDATA
APFSAVE  EQU   APFPDATA
@NM00119 EQU   APFSDAT1
APFERR   EQU   APFSDAT1
APFIO    EQU   APFSDAT1
APFDM    EQU   APFSDATA
APFQCB   EQU   APFSDATA
APFSUPDA EQU   APFSDATA
APFTRACE EQU   APFSDATA
APFSWA   EQU   APFSDATA
APFLSQA  EQU   APFSDATA
APFSQA   EQU   APFSDATA
APFNUC   EQU   APFSDATA
@NM00118 EQU   ABDPARMS+2
APFHDR   EQU   ABDFLAG
APFSNAPP EQU   ABDFLAG
APFTCB   EQU   ABDFLAG
APFID    EQU   ABDFLAG
APFABEND EQU   ABDFLAG
APFENVS2 EQU   ABDFLAG
APFVS2   EQU   ABDFLAG
APFSNAP  EQU   ABDFLAG
ABDPID   EQU   ABDPARMS
ABDCRB   EQU   ABDAREA+8
QELWCNT  EQU   QEL+22
QELLCNT  EQU   QEL+20
QELXECB  EQU   QELECB
@NM00117 EQU   QELLFLGS
@NM00116 EQU   QELLFLGS
@NM00115 EQU   QELLFLGS
@NM00114 EQU   QELLFLGS
@NM00113 EQU   QELLFLGS
@NM00112 EQU   QELLFLGS
QELPOST  EQU   QELLFLGS
@NM00111 EQU   QELQFLGS
@NM00110 EQU   QELQFLGS
@NM00109 EQU   QELQFLGS
QELAUTH  EQU   QELQFLGS
QELMC    EQU   QELQFLGS
QELSHARE EQU   QELQFLGS
QELPQEL  EQU   QEL+4
MINASID  EQU   MIN+18
@NM00108 EQU   MINFLGS
@NM00107 EQU   MINFLGS
@NM00106 EQU   MINFLGS
@NM00105 EQU   MINFLGS
MINNOENQ EQU   MINFLGS
MINSTEP  EQU   MINFLGS
MINSYSS  EQU   MINFLGS
MINSYS   EQU   MINFLGS
MINLQEL  EQU   MIN+12
MINPMIN  EQU   MIN+4
MAJLMIN  EQU   MAJ+12
MAJPMAJ  EQU   MAJ+4
@NM00170 EQU   PSA+3668
PSASTAK  EQU   PSA+3072
@NM00169 EQU   PSA+1048
PSAUSEND EQU   PSA+1048
PSARV062 EQU   PSA+1044
PSACDAL  EQU   PSA+1040
PSAWTCOD EQU   PSA+1036
PSAATCVT EQU   PSA+1032
PSAPCPSW EQU   PSA+1024
PSAPIR2  EQU   PSA+1020
PSARV059 EQU   PSA+1018
PSASVC13 EQU   PSA+1016
PSALSFCC EQU   PSA+1012
PSASFACC EQU   PSA+1008
PSASTOP  EQU   PSA+992
PSASTART EQU   PSA+976
PSARSPSW EQU   PSA+968
PSASRPSW EQU   PSA+960
PSARV045 EQU   PSA+892
PSARV044 EQU   PSA+888
PSARV043 EQU   PSA+884
PSARV042 EQU   PSA+880
PSARV041 EQU   PSA+876
PSARV040 EQU   PSA+872
PSARV025 EQU   PSA+868
PSADSSED EQU   PSA+868
PSADSSPR EQU   PSA+864
PSADSSFW EQU   PSA+860
PSADSS14 EQU   PSA+856
PSADSSPP EQU   PSA+848
PSADSSRP EQU   PSA+840
PSADSS05 EQU   PSADSSF4
PSADSS10 EQU   PSADSSF4
PSADSSVE EQU   PSADSSF4
PSADSSDE EQU   PSADSSF4
PSADSSC0 EQU   PSADSSF4
PSADSSIE EQU   PSADSSF4
PSADSS12 EQU   PSADSSF4
PSADSSRC EQU   PSADSSF4
PSARV057 EQU   PSADSSF3
PSARV056 EQU   PSADSSF3
PSARV055 EQU   PSADSSF3
PSADSSMC EQU   PSADSSF3
PSADSSRW EQU   PSADSSF3
PSADSSNM EQU   PSADSSF3
PSADSSES EQU   PSADSSF3
PSADSSGP EQU   PSADSSF3
PSADSSF2 EQU   PSADSSFL+1
PSADSSPI EQU   PSADSSF1
PSADSSOI EQU   PSADSSF1
PSADSSSP EQU   PSADSSF1
PSADSSTP EQU   PSADSSF1
PSADSSDW EQU   PSADSSF1
PSADSSDD EQU   PSADSSF1
PSADSSDM EQU   PSADSSF1
PSADSSMV EQU   PSADSSF1
PSADSSTS EQU   PSA+816
PSADSSWK EQU   PSA+812
PSADSSR3 EQU   PSA+808
PSADSSR2 EQU   PSA+804
PSADSSRS EQU   PSA+800
PSASTOR  EQU   PSA+796
PSACPUSA EQU   PSA+794
PSAVSTAP EQU   PSA+792
PSAWKVAP EQU   PSA+788
PSAWKRAP EQU   PSA+784
PSAMCHIC EQU   PSA+783
PSARV061 EQU   PSA+782
PSASYMSK EQU   PSA+781
PSAMCHFL EQU   PSA+780
PSACR0   EQU   PSA+776
PSAPSWSV EQU   PSA+768
PSACLHS  EQU   PSAHLHI
PSALKR15 EQU   PSALKSA+60
PSALKR14 EQU   PSALKSA+56
PSALKR13 EQU   PSALKSA+52
PSALKR12 EQU   PSALKSA+48
PSALKR11 EQU   PSALKSA+44
PSALKR10 EQU   PSALKSA+40
PSALKR9  EQU   PSALKSA+36
PSALKR8  EQU   PSALKSA+32
PSALKR7  EQU   PSALKSA+28
PSALKR6  EQU   PSALKSA+24
PSALKR5  EQU   PSALKSA+20
PSALKR4  EQU   PSALKSA+16
PSALKR3  EQU   PSALKSA+12
PSALKR2  EQU   PSALKSA+8
PSALKR1  EQU   PSALKSA+4
PSALKR0  EQU   PSALKSA
PSARV023 EQU   PSACLHT+52
PSALOCAL EQU   PSACLHT+48
PSACMSL  EQU   PSACLHT+44
PSAOPTL  EQU   PSACLHT+40
PSATPACL EQU   PSACLHT+36
PSATPDNL EQU   PSACLHT+32
PSATPNCL EQU   PSACLHT+28
PSAIOSLL EQU   PSACLHT+24
PSAIOSUL EQU   PSACLHT+20
PSAIOSCL EQU   PSACLHT+16
PSAIOSSL EQU   PSACLHT+12
PSASALCL EQU   PSACLHT+8
PSAASML  EQU   PSACLHT+4
PSADISPL EQU   PSACLHT
PSASRSA  EQU   PSA+636
PSARV050 EQU   PSA+634
PSADSSGO EQU   PSA+633
PSARECUR EQU   PSA+632
PSAHLHIS EQU   PSA+628
PSAIPCSA EQU   PSA+624
@NM00168 EQU   PSA+621
PSAIPCDM EQU   PSA+620
PSAIPCD  EQU   PSA+616
@NM00167 EQU   PSA+613
PSAIPCRM EQU   PSA+612
PSAIPCR  EQU   PSA+608
PSAMCHEX EQU   PSA+600
PSAMPSW  EQU   PSA+592
PSAEXPS2 EQU   PSA+584
PSAEXPS1 EQU   PSA+576
PSAPIREG EQU   PSA+572
PSARSREG EQU   PSA+568
PSAGPREG EQU   PSA+556
PSARV022 EQU   PSASUP4
PSARV021 EQU   PSASUP4
PSARV020 EQU   PSASUP4
PSARV019 EQU   PSASUP4
PSARV018 EQU   PSASUP4
PSARV017 EQU   PSASUP4
PSARV016 EQU   PSASUP4
PSARV015 EQU   PSASUP4
PSARV014 EQU   PSASUP3
PSAULCMS EQU   PSASUP3
PSARV012 EQU   PSASUP3
PSAESTA  EQU   PSASUP3
PSASPR   EQU   PSASUP3
PSAPSREG EQU   PSASUP3
PSAPI2   EQU   PSASUP3
PSAIOSUP EQU   PSASUP3
PSALCR   EQU   PSASUP2
PSARTM   EQU   PSASUP2
PSAACR   EQU   PSASUP2
PSAIPCE2 EQU   PSASUP2
PSAIPCES EQU   PSASUP2
PSAIPCEC EQU   PSASUP2
PSAGTF   EQU   PSASUP2
PSAIPCRI EQU   PSASUP2
PSATYPE6 EQU   PSASUP1
PSATCTL  EQU   PSASUP1
PSADISP  EQU   PSASUP1
PSALOCK  EQU   PSASUP1
PSAPI    EQU   PSASUP1
PSAEXT   EQU   PSASUP1
PSASVC   EQU   PSASUP1
PSAIO    EQU   PSASUP1
PSAANEW  EQU   PSA+544
PSATOLD  EQU   PSA+540
PSATNEW  EQU   PSA+536
PSALCCAR EQU   PSA+532
PSALCCAV EQU   PSA+528
PSAPCCAR EQU   PSA+524
PSAPCCAV EQU   PSA+520
PSACPULA EQU   PSA+518
PSACPUPA EQU   PSA+516
PSAPSA   EQU   PSA+512
FLCHDEND EQU   PSA+512
FLCCRSAV EQU   FLCMCLA+280
FLCGRSAV EQU   FLCMCLA+216
FLCFPSAV EQU   FLCMCLA+184
FLCFLA   EQU   FLCMCLA+88
FLCRGNCD EQU   FLCMCLA+84
FLCFSAA  EQU   FLCFSA+1
@NM00166 EQU   FLCFSA
@NM00165 EQU   FLCMCLA+72
FLCMCIC  EQU   FLCMCLA+64
@NM00164 EQU   FLCMCLA+20
FLCIOAA  EQU   FLCIOA+1
@NM00163 EQU   FLCIOA
@NM00162 EQU   FLCMCLA+15
@NM00161 EQU   FLCMCLA+14
@NM00160 EQU   FLCMCLA+12
FLCLCL   EQU   FLCMCLA+8
FLCIOELA EQU   FLCIOEL+1
@NM00159 EQU   FLCIOEL
FLCCHNID EQU   FLCMCLA
@NM00158 EQU   PSA+160
FLCMTRCD EQU   PSA+157
@NM00157 EQU   PSA+156
FLCPERA  EQU   FLCPER+1
@NM00156 EQU   FLCPER
@NM00155 EQU   PSA+151
FLCPERCD EQU   PSA+150
FLCMCNUM EQU   PSA+149
@NM00154 EQU   PSA+148
FLCTEAA  EQU   FLCTEA+1
@NM00153 EQU   FLCTEA
PSAPIPC  EQU   PSAPICOD
PSAPIMC  EQU   PSAPICOD
PSAPIPER EQU   PSAPICOD
PSARV049 EQU   FLCPICOD
FLCPILCB EQU   FLCPIILC
@NM00152 EQU   FLCPIILC
@NM00151 EQU   PSAEPPSW
FLCSVCN  EQU   PSAESPSW+2
FLCSILCB EQU   FLCSVILC
@NM00150 EQU   FLCSVILC
@NM00149 EQU   PSAESPSW
FLCEICOD EQU   PSAEEPSW+2
PSASPAD  EQU   PSAEEPSW
@NM00148 EQU   PSA+128
FLCINPSW EQU   PSA+120
FLCMNPSW EQU   PSA+112
FLCPNPSW EQU   PSA+104
FLCSNPSW EQU   PSA+96
FLCENPSW EQU   PSA+88
FLCTRACE EQU   PSA+84
FLCTIMER EQU   PSA+80
FLCCVT2  EQU   PSA+76
FLCCAW   EQU   PSA+72
FLCCSW   EQU   PSA+64
FLCIOPSW EQU   PSA+56
FLCMOPSW EQU   PSA+48
FLCPOPSW EQU   PSA+40
FLCSOPSW EQU   PSA+32
FLCEOPSW EQU   PSA+24
@NM00147 EQU   FLCICCW2+4
FLCICCW1 EQU   FLCROPSW
FLCIPPSW EQU   FLCRNPSW
.@UNREFD ANOP                          END UNREFERENCED COMPONENTS
@RT00074 EQU   @RC00072
@RT00092 EQU   @RC00090
@RT00153 EQU   COMEXIT
@RT00164 EQU   COMEXIT
@RT00169 EQU   COMEXIT
@RT00182 EQU   COMEXIT
@RT00196 EQU   COMEXIT
@RT00201 EQU   COMEXIT
@RT00217 EQU   COMEXIT
@RF00233 EQU   NEXTQEL
@RT00239 EQU   COMEXIT
@RT00243 EQU   COMEXIT
@ENDDATA EQU   *
         END   IEAVAD06,(C'PLS1932',0701,78086)
