         TITLE 'IEAVAR03, REGION CONTROL TASK RESTORE ROUTINE          *
                        '
IEAVAR03 CSECT ,                                                   0001
@MAINENT DS    0H                                                  0001
         USING *,@15                                               0001
         B     @PROLOG                                             0001
         DC    AL1(16)                                             0001
         DC    C'IEAVAR03  76.264'                                 0001
         DROP  @15
@PROLOG  STM   @14,@12,12(@13)                                     0001
   USING  IEAVAR03,R15              ESTABLISH ADDRESSABILITY
   L      R10,ENTRYPT               TO THE MODULE AT ITS
   DROP   R15                       ENTRY POINT
   USING  IEAVAR03,R10
RBPRFXLN EQU 64
RBPRFLNA EQU 32
PRBLEN   EQU 136
SIRBLEN  EQU 200
TIRBLEN  EQU 136
IRBLEN   EQU 128
SVRBLEN  EQU 200
*                                                                  0096
*/********************************************************************/
*/*                                                                  */
*/*      EXECUTABLE CODE BEGINS HERE.                                */
*/*        - ESTABLISH ADDRESSABILITY TO THE RCTD                    */
*/*          FOR BETTER OPTIMIZATION.                                */
*/*        - SET THE RESTORE PROCESSING RECOVERY                     */
*/*          FOOTPRINT AND CLEAR THE OTHER                           */
*/*          MODULE/FUNCTION FOOTPRINTS.                             */
*/*                                                                  */
*/********************************************************************/
*                                                                  0096
*   R2=R13;                                                        0096
         LR    R2,R13                                              0096
*   RFY                                                            0097
*     RCTD BASED(R2);                                              0097
*   RCTDRCTR=INITMASK;                                             0098
         MVC   RCTDRCTR(4,R2),@CB00037                             0098
*                                                                  0099
*/********************************************************************/
*/*                                                                  */
*/*    THIS SECTION OF CODE WILL DO THE FOLLOWING PROCESSING TO      */
*/*    RESCHEDULE PURGED I/O FOR ALL TASKS IN THE ADDRESS SPACE:     */
*/*      - DETERMINE IF THERE WAS I/O PURGED AT QUIESCE TIME.        */
*/*          - IF THERE WAS, DO THE FOLLOWING:                       */
*/*             - SET UP REGISTER 1 POINTING TO THE                  */
*/*               PURGE I/O REQUEST LIST (PIRL).                     */
*/*             - SET THE RECOVERY FOOTPRINT TO INDICATE             */
*/*               SVC 17 IS BEING INVOKED.                           */
*/*             - ISSUE SVC 17 TO RESTORE I/O FOR                    */
*/*               THIS ADDRESS SPACE.                                */
*/*             - INDICATE NO I/O TO BE RESTORED. THIS               */
*/*               IS NECESSARY TO INSURE SVC 17 IS NOT               */
*/*               RE-INVOKED.                                        */
*/*             - SET THE RECOVERY FOOTPRINT TO INDICATE I/O         */
*/*               PROCESSING IS COMPLETE.                            */
*/*                                                                  */
*/********************************************************************/
*                                                                  0099
*   IF RCTDBASE^=PRGNOIO THEN                                      0099
         CLC   RCTDBASE(3,R2),@CF00065+1                           0099
         BE    @RF00099                                            0099
*     DO;                                                          0100
*       R1=ADDR(RCTDPIRL);                                         0101
         LA    R1,RCTDPIRL(,R2)                                    0101
*       RCTDRS17='1'B;                                             0102
         OI    RCTDRS17(R2),B'10000000'                            0102
*       GEN( SVC 17);                                              0103
          SVC 17
*       RCTDBASE=PRGNOIO;                                          0104
         MVC   RCTDBASE(3,R2),@CF00065+1                           0104
*       RCTDRIOC='1'B;                                             0105
         OI    RCTDRIOC(R2),B'10000000'                            0105
*     END;                                                         0106
*                                                                  0107
*/********************************************************************/
*/*                                                                  */
*/*    THIS SECTION OF CODE WILL DO THE FOLLOWING PROCESSING         */
*/*    TO OBTAIN THE LOCAL LOCK AND ESTABLISH THE RECOVERY EXIT      */
*/*    FOR THE LOCKED CODE:                                          */
*/*      - SET THE RECOVERY FOOTPRINT TO INDICATE THE SETLOCK        */
*/*        MACRO IS BEING INVOKED TO OBTAIN THE LOCAL LOCK.          */
*/*      - ISSUE THE SETLOCK MACRO.                                  */
*/*      - INVOKE THE SETCHECK SUBROUTINE TO CHECK THE RETURN        */
*/*        CODE FROM SETLOCK.                                        */
*/*      - SET UP A REGISTER WITH RESTORE'S FRR ADDRESS.             */
*/*      - ISSUE THE SETFRR MACRO TO ESTABLISH THE RECOVERY          */
*/*        ROUTINE FOR THE LOCKED CODE. THIS PLACES RESTORE'S        */
*/*        FRR ADDRESS ON THE FRR LIFO STACK.                        */
*/*    THE LOCK IS HELD PRIOR TO RESETTING RCT'S SUBTASKS            */
*/*    DISPATCHABLE TO INSURE THAT NO TASKS WILL BE DISPATCHED       */
*/*    UNTIL AFTER THE LONG WAIT PROCESSING CHECK.                   */
*/*                                                                  */
*/********************************************************************/
*                                                                  0107
*   RCTDOBLK='1'B;                                                 0107
@RF00099 OI    RCTDOBLK(R2),B'01000000'                            0107
*OLOCLK:                                                           0108
*   GENERATE;                                                      0108
OLOCLK   DS    0H                                                  0108
     SETLOCK   OBTAIN,TYPE=LOCAL,MODE=UNCOND,                          X
               RELATED=(TCB-PRIORITY-QUEUE,IEAVAR03(RLOCLK))
*   CALL SETCHECK;                                                 0109
         BAL   @14,SETCHECK                                        0109
*   RFY                                                            0110
*     R3 RSTD;                                                     0110
*   R3=ADDR(IEAVAFR3);                                             0111
         LA    R3,IEAVAFR3                                         0111
*   GEN( SETFRR A,FRRAD=(R3),WRKREGS=(FRRSPTR,FRREPTR));           0112
          SETFRR A,FRRAD=(R3),WRKREGS=(FRRSPTR,FRREPTR)
*   RFY                                                            0113
*     R3 UNRSTD;                                                   0113
*                                                                  0114
*/********************************************************************/
*/*                                                                  */
*/*    THIS SECTION OF CODE WILL DO THE FOLLOWING PROCESSING         */
*/*    TO RESET RCT'S SUBTASKS DISPATCHABLE:                         */
*/*      - SET UP THE FOLLOWING REGISTERS FOR THE BRANCH ENTRY       */
*/*        TO STATUS:                                                */
*/*         - REGISTER 0                                             */
*/*             BYTES 2-3    ENTRY CODE 10 INDICATING A              */
*/*                          SECONDARY NON-DISPATCHABILITY           */
*/*                          FLAG IS TO BE RESET IN ALL OF           */
*/*                          RCT'S SUBTASKS.                         */
*/*         - REGISTER 1                                             */
*/*             BIT   0      1 - RESET IS BEING REQUESTED.           */
*/*             BYTES 1-3    ADDRESS OF RCT'S TCB.                   */
*/*         - REGISTER 13                                            */
*/*             X'00001000'  INDICATES THE TCBNDTS BIT OF THE        */
*/*                          TCBNDSP2 FLAG IS TO BE RESET.           */
*/*      - SET THE RECOVERY FOOTPRINT TO INDICATE STATUS IS          */
*/*        BEING INVOKED.                                            */
*/*      - ISSUE A CALL TO THE STATUS ROUTINE USING ITS              */
*/*        BRANCH ENTRY TO RESTART SUBTASKS.                         */
*/*      - SET THE FOLLOWING RECOVERY FOOTPRINTS TO INDICATE:        */
*/*         - STATUS PROCESSING COMPLETED.                           */
*/*         - RCT'S SUBTASKS HAVE BEEN RESTARTED.                    */
*/*                                                                  */
*/********************************************************************/
*                                                                  0114
*   RFY                                                            0114
*     R0 RSTD;                                                     0114
*   R0=TCBMASK;                                                    0115
         LA    R0,10                                               0115
*   R1=RESETMSK|R4;                                                0116
         LR    R1,R4                                               0116
         O     R1,@CF00060                                         0116
*   R13=NDISPMSK;                                                  0117
         L     R13,@CF00078                                        0117
*   RCTDSTAT='1'B;                                                 0118
         OI    RCTDSTAT(R2),B'00100000'                            0118
*   CALL STATUSBR;                                                 0119
         L     @12,CVTPTR                                          0119
         L     @12,CVTABEND(,@12)                                  0119
         L     @15,SCVTSTAT(,@12)                                  0119
         BALR  @14,@15                                             0119
*   RFY                                                            0120
*     R0 UNRSTD;                                                   0120
*   RCTDSTAC='1'B;                                                 0121
         OI    RCTDSTAC(R2),B'00100000'                            0121
*   RCTDSUBN='0'B;                                                 0122
         NI    RCTDSUBN(R2),B'10111111'                            0122
*                                                                  0123
*/********************************************************************/
*/*                                                                  */
*/*    IF RESTORE WAS ENTERED TO HANDLE QUIESCE BACKOUT, THE         */
*/*    FOLLOWING PROCESSING WILL BE PERFORMED IN THIS SECTION:       */
*/*      - INVOKE THE LOCKREL SUBROUTINE TO RELEASE THE              */
*/*        LOCAL LOCK AND DELETE ITS RECOVERY EXIT.                  */
*/*      - SET THE RECOVERY FOOTPRINT TO INDICATE SYSEVENT 18        */
*/*        IS BEING INVOKED.                                         */
*/*      - ISSUE THE SYSEVENT 18 MACRO TO INFORM THE SYSTEM          */
*/*        RESOURCES MANAGER (SRM) OF QUIESCE BACKOUT.               */
*/*      - SET THE RECOVERY FOOTPRINT TO INDICATE SRM                */
*/*        PROCESSING COMPLETED.                                     */
*/*      - RESET THE RECOVERY FOOTPRINT INDICATING                   */
*/*        QUIESCE BACKOUT.                                          */
*/*                                                                  */
*/********************************************************************/
*                                                                  0123
*   IF RCTDRSBO='1'B THEN                                          0123
         TM    RCTDRSBO(R2),B'10000000'                            0123
         BNO   @RF00123                                            0123
*     DO;                                                          0124
*       CALL LOCKREL;                                              0125
         BAL   @14,LOCKREL                                         0125
*       RCTDSY18='1'B;                                             0126
         OI    RCTDSY18(R2),B'00000100'                            0126
*       GEN( SYSEVENT QSCEFL);                                     0127
          SYSEVENT QSCEFL
*       RCTDOPTC='1'B;                                             0128
         OI    RCTDOPTC(R2),B'00100000'                            0128
*       RCTDRSBO='0'B;                                             0129
         NI    RCTDRSBO(R2),B'01111111'                            0129
*     END;                                                         0130
*   ELSE                                                           0131
*     DO;                                                          0131
         B     @RC00123                                            0131
@RF00123 DS    0H                                                  0132
*                                                                  0132
*/********************************************************************/
*/*                                                                  */
*/*     IF RESTORE WAS ENTERED DUE TO AN ADDRESS SPACE BEING         */
*/*     SWAPPED IN, THE FOLLOWING SECTIONS OF CODE WILL DO THE       */
*/*     PROCESSING NECESSARY TO PREPARE THE ADDRESS SPACE FOR        */
*/*     EXECUTION.                                                   */
*/*                                                                  */
*/********************************************************************/
*/********************************************************************/
*/*                                                                  */
*/*      THIS SECTION OF CODE WILL DO THE FOLLOWING FOR LONG         */
*/*      WAIT PROCESSING:                                            */
*/*        - SET THE RECOVERY FOOTPRINT TO INDICATE LONG             */
*/*          WAIT PROCESSING BEGINNING.                              */
*/*        - CHECK THE RECOVERY FOOTPRINT TO DETERMINE               */
*/*          IF THE RESTORE SVC (SVC 17) WAS INVOKED TO              */
*/*          RESTORE PURGED I/O. IF IT WAS, THEN THE                 */
*/*          ADDRESS SPACE IS NOT IN LONG WAIT AND FURTHER           */
*/*          TESTING IS UNNECESSARY.                                 */
*/*        - TO CONTINUE LONG WAIT TESTING, CHECK FOR                */
*/*          ANY ASYNCHRONOUS EXITS (IQES AND/OR RQES).              */
*/*          IF ANY ARE QUEUED BUT NOT PROCESSED, THEN               */
*/*          THE ADDRESS SPACE IS NOT IN LONG WAIT AND               */
*/*          FURTHER TESTING IS UNNECESSARY.                         */
*/*        - TO CONTINUE LONG WAIT TESTING, DETERMINE IF             */
*/*          A TSB EXISTS. IF ONE EXISTS, ESTABLISH                  */
*/*          ADDRESSABILITY TO IT AND CHECK FOR ANY                  */
*/*          ATTENTION REQUESTS.  IF ANY EXIST, THEN THE             */
*/*          ADDRESS SPACE IS NOT IN LONG WAIT AND FURTHER           */
*/*          TESTING IS UNNECESSARY. ADDRESSABILITY TO THE           */
*/*          TSB IS DELETED.                                         */
*/*        - TO CONTINUE TESTING WHEN A TSB DOES NOT                 */
*/*          EXIST OR THERE ARE NO ATTENTION REQUESTS,               */
*/*          INVOKE THE TCBCHECK SUBROUTINE. THIS WILL               */
*/*          SCAN THE TCB PRIORITY QUEUE LOOKING AT THE              */
*/*          WAIT COUNT IN THE RBS AND THE NON-DISPATCHABILITY       */
*/*          FLAGS IN EACH TCB IN SEARCH FOR A READY TASK.           */
*/*          LONG WAIT TESTING IS COMPLETED HERE. IF THE             */
*/*          READY STATUS WAS NOT FOUND, THEN THIS SUBROUTINE        */
*/*          WILL SET THE RECOVERY FOOTPRINT TO INDICATE             */
*/*          THE ADDRESS SPACE IS IN LONG WAIT.                      */
*/*        - SET THE RECOVERY FOOTPRINT TO INDICATE LONG             */
*/*          WAIT PROCESSING COMPLETE.                               */
*/*        - INVOKE THE LOCKREL SUBROUTINE TO RELEASE                */
*/*          THE LOCAL LOCK AND DELETE ITS RECOVERY EXIT.            */
*/*                                                                  */
*/********************************************************************/
*                                                                  0132
*       RCTDRLWB='1'B;                                             0132
         OI    RCTDRLWB(R2),B'00001000'                            0132
*       IF RCTDRS17='0'B THEN       /*                       @YM01902*/
         TM    RCTDRS17(R2),B'10000000'                            0133
         BNZ   @RF00133                                            0133
*         IF ASCBS2S='0'B THEN                                     0134
         TM    ASCBS2S(R7),B'00010000'                             0134
         BNZ   @RF00134                                            0134
*           IF ASCBSRBS=0 THEN      /* IF ANY SRBS STARTED,NOT LONG
*                                      WAIT                  @ZA10830*/
         SLR   @15,@15                                             0135
         CH    @15,ASCBSRBS(,R7)                                   0135
         BNE   @RF00135                                            0135
*             IF ASCBTSB^=0 THEN                                   0136
         L     @12,ASCBTSB(,R7)                                    0136
         CR    @12,@15                                             0136
         BE    @RF00136                                            0136
*               DO;                                                0137
*                 RFY                                              0138
*                   R5 RSTD;                                       0138
*                 R5=ASCBTSB;                                      0139
         LR    R5,@12                                              0139
*                 GEN( USING TSB,R5);                              0140
          USING TSB,R5
*                 IF TSBATTNC=0 THEN                               0141
         CLI   TSBATTNC,0                                          0141
         BNE   @RF00141                                            0141
*                   CALL TCBCHECK;                                 0142
         BAL   @14,TCBCHECK                                        0142
*                 ELSE                                             0143
*                   ;                                              0143
@RF00141 DS    0H                                                  0144
*                 GEN( DROP R5);                                   0144
          DROP R5
*                 RFY                                              0145
*                   R5 RSTD;                                       0145
*               END;                                               0146
*             ELSE                                                 0147
*               CALL TCBCHECK;                                     0147
         B     @RC00136                                            0147
@RF00136 BAL   @14,TCBCHECK                                        0147
*       RCTDRLWC='1'B;                                             0148
@RC00136 DS    0H                                                  0148
@RF00135 DS    0H                                                  0148
@RF00134 DS    0H                                                  0148
@RF00133 OI    RCTDRLWC(R2),B'00010000'                            0148
*       CALL LOCKREL;                                              0149
         BAL   @14,LOCKREL                                         0149
*                                                                  0150
*/********************************************************************/
*/*                                                                  */
*/*      THIS SECTION OF CODE WILL DO THE FOLLOWING PROCESSING       */
*/*      FOR TIMER WAIT LIMIT SUPPORT:                               */
*/*        - SET THE RECOVERY FOOTPRINT TO INDICATE                  */
*/*          WAIT LIMIT PROCESSING BEGINNING.                        */
*/*        - IF THE ADDRESS SPACE IS NOT IN LONG WAIT AT RESTORE     */
*/*          TIME AND THE CPU CLOCK IS NOT BAD, THEN CONTINUE        */
*/*          TESTING TO PERFORM WAIT LIMIT SUPPORT.                  */
*/*           - IF THE ADDRESS SPACE WAS NOT IN LONG WAIT WHEN       */
*/*             SWAPPED OUT (AT QUIESCE TIME), THE FOLLOWING         */
*/*             PROCESSING IS DONE SO THAT THE USER'S WAIT           */
*/*             TIME LIMIT IS NOT CHARGED WITH THE SWAPPED           */
*/*             OUT TIME:                                            */
*/*               - ISSUE THE STORE CLOCK INSTRUCTION TO             */
*/*                 GET THE CURRENT TIME.                            */
*/*               - SUBTRACT THE TIME THE ADDRESS SPACE WAS          */
*/*                 SWAPPED OUT FROM THE CURRENT TIME. THIS          */
*/*                 AMOUNT IS THEN ADDED TO THE WAIT STATE           */
*/*                 TIME STAMP FIELD.                                */
*/*           - IF THE ADDRESS SPACE WAS IN LONG WAIT                */
*/*             WHEN SWAPPED OUT (AT QUIESCE TIME), THE STORE        */
*/*             CLOCK INSTRUCTION IS ISSUED TO STORE THE             */
*/*             CURRENT TIME IN THE WAIT STATE TIME STAMP FIELD.     */
*/*           IN EITHER CASE, THE WAIT STATE TIME STAMP FIELD        */
*/*           IS UPDATED. TIMER SUPERVISION SUBTRACTS THIS           */
*/*           FROM THE CURRENT TIME TO DETERMINE IF THE              */
*/*           WAIT TIME LIMIT HAS ELAPSED FOR THIS ADDRESS           */
*/*           SPACE.                                                 */
*/*        - SET THE RECOVERY FOOTPRINT TO INDICATE WAIT             */
*/*          LIMIT PROCESSING COMPLETED.                             */
*/*                                                                  */
*/********************************************************************/
*                                                                  0150
*       RCTDWTLB='1'B;                                             0150
         OI    RCTDWTLB(R2),B'01000000'                            0150
*       IF RCTDRSLW='0'B&PCCANUTD='0'B THEN                        0151
         TM    RCTDRSLW(R2),B'00000001'                            0151
         BNZ   @RF00151                                            0151
         L     @15,PSAPCCAV                                        0151
         TM    PCCANUTD(@15),B'10000000'                           0151
         BNZ   @RF00151                                            0151
*         DO;                                                      0152
*           IF ASCBWAIT='0'B THEN                                  0153
         TM    ASCBWAIT(R7),B'00001000'                            0153
         BNZ   @RF00153                                            0153
*             DO;                                                  0154
*               GEN( STCK  RCTDTIME(R2));                          0155
          STCK  RCTDTIME(R2)
*               ASCBEWLH=EVAL(RCTDTMLH-ASCBUBET)+ASCBEWLH;         0156
         L     @15,RCTDTMLH(,R2)                                   0156
         SL    @15,ASCBUBET(,R7)                                   0156
         AL    @15,ASCBEWLH(,R7)                                   0156
         ST    @15,ASCBEWLH(,R7)                                   0156
*             END;                                                 0157
*           ELSE                                                   0158
*             GEN( STCK  ASCBEWST(R7));                            0158
         B     @RC00153                                            0158
@RF00153 DS    0H                                                  0158
          STCK  ASCBEWST(R7)
*         END;                                                     0159
@RC00153 DS    0H                                                  0160
*       RCTDWTLC='1'B;                                             0160
@RF00151 OI    RCTDWTLC(R2),B'01000000'                            0160
*                                                                  0161
*/********************************************************************/
*/*                                                                  */
*/*      THIS SECTION OF CODE WILL DO THE FOLLOWING PROCESSING       */
*/*      TO COMMUNICATE WITH THE SYSTEM RESOURCES MANAGER            */
*/*      (SRM) TO INDICATE RESTORE PROCESSING IS COMPLETE            */
*/*      AND THE ADDRESS SPACE IS READY TO RUN OR RESTORE            */
*/*      PROCESSING IS COMPLETE AND THE ADDRESS SPACE IS             */
*/*      CONSIDERED TO BE IN LONG WAIT:                              */
*/*        - REGISTER 1 IS SET UP TO INDICATE THE STATE              */
*/*          OF THE ADDRESS SPACE WHICH WAS DETERMINED               */
*/*          IN THE LONG WAIT PROCESSING CHECKS.                     */
*/*        - SET THE RECOVERY FOOTPRINT TO INDICATE SYSEVENT 19      */
*/*          IS BEING INVOKED.                                       */
*/*        - ISSUE THE SYSEVENT 19 MACRO TO COMMUNICATE WITH         */
*/*          SRM.                                                    */
*/*        - SET THE RECOVERY FOOTPRINT TO INDICATE SRM              */
*/*          PROCESSING COMPLETED.                                   */
*/*                                                                  */
*/********************************************************************/
*                                                                  0161
*IEAVAR3A:                                                         0161
*       IF RCTDRSLW='1'B THEN                                      0161
IEAVAR3A TM    RCTDRSLW(R2),B'00000001'                            0161
         BNO   @RF00161                                            0161
*         R1=LWAITMSK;                                             0162
         L     R1,@CF00060                                         0162
*       ELSE                                                       0163
*         R1=0;                                                    0163
         B     @RC00161                                            0163
@RF00161 SLR   R1,R1                                               0163
*       RCTDSY19='1'B;                                             0164
@RC00161 OI    RCTDSY19(R2),B'00001000'                            0164
*       GEN( SYSEVENT RSTORCMP);                                   0165
          SYSEVENT RSTORCMP
*       RCTDOPTC='1'B;                                             0166
         OI    RCTDOPTC(R2),B'00100000'                            0166
*     END;                                                         0167
*                                                                  0168
*/********************************************************************/
*/*                                                                  */
*/*    THIS SECTION OF CODE WILL DO THE FOLLOWING PROCESSING         */
*/*    FOR THE NORMAL EXIT FROM RESTORE'S MAINLINE:                  */
*/*      - SET THE FOLLOWING FLAGS OFF (0):                          */
*/*         - THE MEMORY MAY BE IN LONG WAIT INDICATOR.              */
*/*         - THE MEMORY IS BEING QUIESCED, IS QUIESCED, OR          */
*/*           IS BEING RESTORED INDICATOR.                           */
*/*         - THE QUIESCE LONG WAIT INDICATOR.                       */
*/*         - THE RESTORE REQUEST FLAG.                              */
*/*        IT IS NECESSARY TO USE COMPARE AND SWAP HERE TO           */
*/*        INSURE SERIALIZATION OF THESE FIELDS.                     */
*/*     -  RESTORE THE POINTER TO THE CALLER'S SAVEAREA.             */
*/*     -  RETURN CONTROL TO THE COMMON PROCESSING ROUTINE.          */
*/*                                                                  */
*/********************************************************************/
*                                                                  0168
*   RFY                                                            0168
*    (R6,                                                          0168
*     R8) RSTD;                                                    0168
@RC00123 DS    0H                                                  0169
*   R6=CSFIELD;                                                    0169
         L     R6,CSFIELD(,R7)                                     0169
*LOOP1:                                                            0170
*   R8=R6&TMLWOFF&TMNOOFF&WAITOFF&FRSOFF;                          0170
LOOP1    LR    R8,R6                                               0170
         N     R8,@CF02732                                         0170
*   CS(R6,R8,CSFIELD);                                             0171
         CS    R6,@08,CSFIELD(R7)                                  0171
*   BC(7,LOOP1);                                                   0172
         BC    7,LOOP1                                             0172
*   RFY                                                            0173
*    (R6,                                                          0173
*     R8) UNRSTD;                                                  0173
*   R13=R2;                                                        0174
         LR    R13,R2                                              0174
*R03EXIT:                                                          0175
*   RETURN;                                                        0175
@EL00001 DS    0H                                                  0175
@EF00001 DS    0H                                                  0175
@ER00001 LM    @14,@12,12(@13)                                     0175
         BR    @14                                                 0175
*                                                                  0176
*/********************************************************************/
*/*                                                                  */
*/*    THIS SECTION OF CODE IS THE LOCKREL SUBROUTINE WHICH          */
*/*    WILL DO THE FOLLOWING PROCESSING TO RELEASE THE               */
*/*    LOCAL LOCK AND DELETE ITS RECOVERY ENVIRONMENT:               */
*/*      - SAVE THE RETURN ADDRESS.                                  */
*/*      - ISSUE THE SETFRR MACRO TO DELETE THE RECOVERY             */
*/*        EXIT FOR THE LOCKED CODE. THIS REMOVES RESTORE'S          */
*/*        FRR ADDRESS FROM THE LIFO STACK.                          */
*/*      - SET THE RECOVERY FOOTPRINT TO INDICATE THE                */
*/*        SETLOCK MACRO IS BEING INVOKED TO RELEASE THE             */
*/*        LOCAL LOCK.                                               */
*/*      - ISSUE THE SETLOCK MACRO.                                  */
*/*      - INVOKE THE SETCHECK SUBROUTINE TO CHECK THE               */
*/*        RETURN CODE FROM SETLOCK.                                 */
*/*      - RESTORE THE RETURN ADDRESS.                               */
*/*      - RETURN CONTROL TO RESTORE'S MAINLINE.                     */
*/*                                                                  */
*/********************************************************************/
*                                                                  0176
*LOCKREL:                                                          0176
*   PROC OPTIONS(NOSAVE NOSAVEAREA);                               0176
         B     @EL00001                                            0176
LOCKREL  DS    0H                                                  0177
*   RFY                                                            0177
*     R3 RSTD;                                                     0177
*   R3=R14;                                                        0178
         LR    R3,R14                                              0178
*   GEN( SETFRR D,WRKREGS=(FRRSPTR,FRREPTR));                      0179
          SETFRR D,WRKREGS=(FRRSPTR,FRREPTR)
*   RCTDRLLK='1'B;                                                 0180
         OI    RCTDRLLK(R2),B'00010000'                            0180
*RLOCLK:                                                           0181
*   GENERATE;                                                      0181
RLOCLK   DS    0H                                                  0181
     SETLOCK   RELEASE,TYPE=LOCAL,                                     X
               RELATED=(TCB-PRIORITY-QUEUE,IEAVAR03(OLOCLK))
*   CALL SETCHECK;                                                 0182
         BAL   @14,SETCHECK                                        0182
*   R14=R3;                                                        0183
         LR    R14,R3                                              0183
*   RFY                                                            0184
*     R3 UNRSTD;                                                   0184
*   END LOCKREL;                                                   0185
@EL00002 DS    0H                                                  0185
@EF00002 DS    0H                                                  0185
@ER00002 BR    @14                                                 0185
*                                                                  0186
*/********************************************************************/
*/*                                                                  */
*/*    THIS SECTION OF CODE IS THE TCBCHECK SUBROUTINE WHICH         */
*/*    WILL DO THE FOLLOWING PROCESSING TO DETERMINE IF THE          */
*/*    ADDRESS SPACE IS IN LONG WAIT BY SCANNING THE TCB             */
*/*    PRIORITY QUEUE FOR A READY TASK:                              */
*/*      - ACCESS RCT'S FIRST SUBTASK.                               */
*/*      - EXAMINE THE WAIT COUNT OF THE ASSOCIATED RB.              */
*/*         - A ZERO WAIT COUNT MEANS THE RB IS READY TO RUN,        */
*/*           SO EXAMINE THE TCB'S PRIMARY NON-DISPATCHABILITY       */
*/*           FLAGS FOR A READY TASK. IF A READY TCB IS FOUND,       */
*/*           THEN THE ADDRESS SPACE IS NOT IN LONG WAIT.            */
*/*           IT IS UNNECESSARY TO CONTINUE TESTING SO THE           */
*/*           FOLLOWING IS DONE:                                     */
*/*             - RESTORE THE POINTER TO RCT'S TCB.                  */
*/*             - RETURN CONTROL TO THE MAINLINE.                    */
*/*         - FOR A NON-ZERO RB WAIT COUNT OR A NOT READY            */
*/*           TCB, THEN IT IS NECESSARY TO CONTINUE SCANNING         */
*/*           THE TCB PRIORITY QUEUE AND THE NEXT TCB IS             */
*/*           ACCESSED. IF THE LAST TCB HAS BEEN EXAMINED            */
*/*           WITHOUT A READY ONE BEING FOUND, THE FOLLOWING         */
*/*           IS DONE:                                               */
*/*             - SET THE RECOVERY FOOTPRINT TO INDICATE THE         */
*/*               ADDRESS SPACE IS IN LONG WAIT.                     */
*/*             - RESTORE THE POINTER TO RCT'S TCB.                  */
*/*             - RETURN CONTROL TO THE MAINLINE.                    */
*/*                                                                  */
*/********************************************************************/
*                                                                  0186
*TCBCHECK:                                                         0186
*   PROC OPTIONS(NOSAVE NOSAVEAREA);                               0186
TCBCHECK DS    0H                                                  0187
*   DO WHILE(TCBTCB^=0);                                           0187
         B     @DE00187                                            0187
@DL00187 DS    0H                                                  0188
*     R4=TCBTCB;                                                   0188
         L     R4,TCBTCB(,R4)                                      0188
*     IF RBWCF=0 THEN                                              0189
         L     @15,TCBRBP(,R4)                                     0189
         CLI   RBWCF(@15),0                                        0189
         BNE   @RF00189                                            0189
*       IF NONDISP1=0 THEN                                         0190
         LH    @15,NONDISP1(,R4)                                   0190
         N     @15,@CF02742                                        0190
         LTR   @15,@15                                             0190
         BNZ   @RF00190                                            0190
*         DO;                                                      0191
*           R4=ASXBFTCB;                                           0192
         L     @15,ASCBASXB(,R7)                                   0192
         L     R4,ASXBFTCB(,@15)                                   0192
*           RETURN;                                                0193
@EL00003 DS    0H                                                  0193
@EF00003 DS    0H                                                  0193
@ER00003 BR    @14                                                 0193
*         END;                                                     0194
*   END;                                                           0195
@RF00190 DS    0H                                                  0195
@RF00189 DS    0H                                                  0195
@DE00187 L     @15,TCBTCB(,R4)                                     0195
         LTR   @15,@15                                             0195
         BNZ   @DL00187                                            0195
*   RCTDRSLW='1'B;                                                 0196
         OI    RCTDRSLW(R2),B'00000001'                            0196
*   R4=ASXBFTCB;                                                   0197
         L     @15,ASCBASXB(,R7)                                   0197
         L     R4,ASXBFTCB(,@15)                                   0197
*   END TCBCHECK;                                                  0198
         B     @EL00003                                            0198
*                                                                  0199
*/********************************************************************/
*/*                                                                  */
*/*    THIS SECTION OF CODE IS THE ABENDEXT SUBROUTINE. WHEN         */
*/*    RESTORE RECEIVES AN UNEXPECTED RETURN CODE FROM A             */
*/*    ROUTINE IT HAS INVOKED, THIS SUBROUTINE IS CALLED TO          */
*/*    DO THE FOLLOWING PROCESSING:                                  */
*/*      - ISSUE THE ABEND MACRO THEREBY CAUSING RTM TO              */
*/*        RECEIVE CONTROL AND ROUTE CONTROL TO EITHER               */
*/*        RESTORE'S FRR OR RCT'S ESTAE ERROR EXIT TO HAVE           */
*/*        THE ERROR RECORDED AND THE APPROPRIATE ACTION TAKEN.      */
*/*                                                                  */
*/********************************************************************/
*                                                                  0199
*ABENDEXT:                                                         0199
*   PROC OPTIONS(NOSAVE NOSAVEAREA);                               0199
ABENDEXT DS    0H                                                  0200
*R03ABEND:                                                         0200
*   GEN( ABEND X'078',,,SYSTEM);    /*                       @YM01757*/
R03ABEND  ABEND X'078',,,SYSTEM
*   END ABENDEXT;                                                  0201
@EL00004 DS    0H                                                  0201
@EF00004 DS    0H                                                  0201
@ER00004 BR    @14                                                 0201
*                                                                  0202
*/********************************************************************/
*/*                                                                  */
*/*    THIS SECTION OF CODE IS THE SETCHECK SUBROUTINE WHICH         */
*/*    WILL DO THE FOLLOWING PROCESSING TO CHECK THE RETURN          */
*/*    CODE FROM SETLOCK:                                            */
*/*      - FOR A ZERO (SUCCESSFUL) RETURN CODE FROM SETLOCK,         */
*/*        RETURN CONTROL TO THE CALLER.                             */
*/*      - FOR A NON-ZERO (FAILING) RETURN CODE FROM SETLOCK:        */
*/*         - SET THE RECOVERY FOOTPRINT TO INDICATE SETLOCK         */
*/*           FAILED.                                                */
*/*         - SAVE THE RETURN CODE.                                  */
*/*         - INVOKE THE ABENDEXT SUBROUTINE TO HANDLE THE           */
*/*           DETECTED ERROR.                                        */
*/*                                                                  */
*/********************************************************************/
*                                                                  0202
*SETCHECK:                                                         0202
*   PROC OPTIONS(NOSAVE NOSAVEAREA);                               0202
SETCHECK DS    0H                                                  0203
*   IF R13=0 THEN                                                  0203
         LTR   R13,R13                                             0203
         BZ    @RT00203                                            0203
*     RETURN;                                                      0204
*   RCTDFAIL='1'B;                                                 0205
         OI    RCTDFAIL(R2),B'00000010'                            0205
*   RCTDRC=R13;                                                    0206
         ST    R13,RCTDRC(,R2)                                     0206
*   CALL ABENDEXT;                                                 0207
         BAL   @14,ABENDEXT                                        0207
*   END SETCHECK;                                                  0208
@EL00005 DS    0H                                                  0208
@EF00005 DS    0H                                                  0208
@ER00005 BR    @14                                                 0208
*                                                                  0209
*/********************************************************************/
*/*                                                                  */
*/*           RESTORE'S FRR ROUTINE                                  */
*/*                                                                  */
*/*    THIS SECTION OF CODE WILL GET CONTROL IN THE EVENT            */
*/*    OF ANY ERROR ENCOUNTERED DURING LOCKED CODE PROCESSING        */
*/*    FROM RTM VIA A LOAD PSW. REGISTERS AT INPUT ARE AS            */
*/*    FOLLOWS:                                                      */
*/*        REGISTER  0       ADDRESS OF A 200 BYTE WORK AREA         */
*/*        REGISTER  1       ADDRESS OF THE SDWA                     */
*/*        REGISTERS 2 - 13  INVALID                                 */
*/*        REGISTER  14      RETURN ADDRESS                          */
*/*        REGISTER  15      ENTRY POINT ADDRESS                     */
*/*                                                                  */
*/********************************************************************/
*/*                                                                  */
*/*    THE FOLLOWING INITIAL PROCESSING IS PERFORMED TO:             */
*/*      - ESTABLISH ADDRESSABILITY FOR THIS ROUTINE.                */
*/*      - LOAD THE BASE REGISTER WITH THE ENTRY POINT               */
*/*        ADDRESS.                                                  */
*/*      - ESTABLISH ADDRESSABILITY TO THE SDWA.                     */
*/*      - CHECK THE SDWA INDICATOR TO DETERMINE IF THE              */
*/*        ERROR WAS IN THIS ADDRESS SPACE.                          */
*/*          - NON-ZERO INDICATES NOT THIS ADDRESS SPACE,            */
*/*            SO ISSUE THE SETRP MACRO SPECIFYING THE               */
*/*            FOLLOWING WHEN RETURNING TO RTM:                      */
*/*              - ADDRESS OF THE SDWA.                              */
*/*              - CONTINUE WITH TERMINATION.                        */
*/*          - ZERO INDICATES THIS ADDRESS SPACE, SO                 */
*/*            CONTINUE FRR PROCESSING.                              */
*/*                                                                  */
*/********************************************************************/
*                                                                  0209
*IEAVAFR3:                                                         0209
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);                               0209
IEAVAFR3 DS    0H                                                  0210
*   RFY                                                            0210
*    (R9,                                                          0210
*     R6) RSTD;                                                    0210
*   GEN( USING  IEAVAFR3,R9);                                      0211
          USING  IEAVAFR3,R9
*   R9=R15;                                                        0212
         LR    R9,R15                                              0212
*   R6=R1;                                                         0213
         LR    R6,R1                                               0213
*   IF SDWAFMID^=0 THEN                                            0214
         LH    @15,SDWAFMID(,R6)                                   0214
         N     @15,@CF02742                                        0214
         LTR   @15,@15                                             0214
         BZ    @RF00214                                            0214
*     DO;                           /* SETRP WKAREA(R6)RC(0)         */
*       RESPECIFY                                                  0216
*        (GPR00P,                                                  0216
*         GPR01P,                                                  0216
*         GPR14P,                                                  0216
*         GPR15P) RSTD;                                            0216
*       GPR01P=R6;                                                 0217
         LR    GPR01P,R6                                           0217
*       GPR01P->SDWARCDE=0;         /* SAVE RC VALUE                 */
         MVI   SDWARCDE(GPR01P),X'00'                              0218
*       RESPECIFY                                                  0219
*        (GPR00P,                                                  0219
*         GPR01P,                                                  0219
*         GPR14P,                                                  0219
*         GPR15P) UNRSTD;                                          0219
*     END;                                                         0220
*   ELSE                                                           0221
*     DO;                                                          0221
         B     @RC00214                                            0221
@RF00214 DS    0H                                                  0222
*                                                                  0222
*/********************************************************************/
*/*                                                                  */
*/*      THE ERROR WAS IN THIS ADDRESS SPACE.                        */
*/*                                                                  */
*/********************************************************************/
*/*                                                                  */
*/*      THIS SECTION OF CODE WILL DO THE FOLLOWING PROCESSING       */
*/*      TO SET UP FOR RECORDING AND DIAGNOSING THE ERROR:           */
*/*        - RE-ESTABLISH THE POINTER TO THE RCTD.                   */
*/*        - CHECK THE LENGTH OF THE SDWA'S VARIABLE                 */
*/*          RECORDING AREA TO INSURE THAT THE LENGTH                */
*/*          OF THE INFORMATION TO BE RECORDED WILL NOT              */
*/*          CAUSE OVERFLOW.                                         */
*/*            - IF NO OVERFLOW WILL OCCUR, THEN THE                 */
*/*              FOLLOWING PROCESSING IS DONE:                       */
*/*                - CLEAR THE SDWA'S VARIABLE RECORDING             */
*/*                  AREA.                                           */
*/*                - GET THE LENGTH OF THE RECORDING AREA            */
*/*                  USED.                                           */
*/*                - RECORD RCT'S RECOVERY FOOTPRINTS.               */
*/*                - RECORD ANY UNACCEPTABLE RETURN CODE             */
*/*                  DETECTED IN RESTORE'S PROCESSING.               */
*/*                - RECORD RCT'S CROSS COMMUNICATIONS FLAGS.        */
*/*                - RECORD THE ASCB FLAGS FOR RCT.                  */
*/*            - IF OVERFLOW WILL OCCUR, DO NOT                      */
*/*              PERFORM ANY RECORDING.                              */
*/*                                                                  */
*/********************************************************************/
*                                                                  0222
*       R2=PSAAOLD->ASCBASXB->ASXBRCTD;                            0222
         L     @15,PSAAOLD                                         0222
         L     @12,ASCBASXB(,@15)                                  0222
         L     R2,ASXBRCTD(,@12)                                   0222
*       IF SDWAVRAL>=LENGTH(RVRSTATE) THEN/*                 @YM02727*/
         CLC   SDWAVRAL(2,R6),@CH00912                             0223
         BL    @RF00223                                            0223
*         DO;                                                      0224
*           SDWAVRA=''B;            /*                       @YM02727*/
         XC    SDWAVRA(108,R6),SDWAVRA(R6)                         0225
*           SDWAURAL=LENGTH(RVRSTATE);/*                     @YM02727*/
         MVI   SDWAURAL(R6),X'0C'                                  0226
*           RVRRF=RCTDRCTR;         /*                       @YM02727*/
         MVC   RVRRF(4,R6),RCTDRCTR(R2)                            0227
*           RVRRC=RCTDRC;           /*                       @YM02727*/
         L     @12,RCTDRC(,R2)                                     0228
         ST    @12,RVRRC(,R6)                                      0228
*           RVRXF=RCTDRCTF;         /*                       @YM02727*/
         MVC   RVRXF(1,R6),RCTDRCTF(R2)                            0229
*           RVRAF=PSAAOLD->ASCBRCTF;/*                       @YM02727*/
         MVC   RVRAF(1,R6),ASCBRCTF(@15)                           0230
*         END;                                                     0231
*                                                                  0232
*/********************************************************************/
*/*                                                                  */
*/*      THIS SECTION OF CODE WILL DO THE FOLLOWING PROCESSING       */
*/*      TO DIAGNOSE THE ERROR:                                      */
*/*        - IF THE RESTART KEY WAS NOT THE CAUSE OF THE ERROR       */
*/*          ERROR, THEN CONTINUE CHECKING.                          */
*/*        - IF THE RECOVERY FOOTPRINT INDICATES THAT STATUS         */
*/*          PROCESSING WAS NOT COMPLETED, THEN CONTINUE             */
*/*          CHECKING.                                               */
*/*        - IF THE RECOVERY FOOTPRINT INDICATES THAT STATUS         */
*/*          WAS INVOKED, THEN CONTINUE CHECKING.                    */
*/*        - IF THE ERROR WAS NOT DUE TO PERCOLATION OR              */
*/*          THERE WAS AN ERROR IN THE PREVIOUS EXIT,                */
*/*          THEN SET THE RECOVERY FOOTPRINT TO                      */
*/*          INDICATE DUMP IS DESIRED.                               */
*/*                                                                  */
*/********************************************************************/
*                                                                  0232
*       IF SDWARKEY='0'B THEN                                      0232
@RF00223 TM    SDWARKEY(R6),B'00100000'                            0232
         BNZ   @RF00232                                            0232
*         IF RCTDSTAC='0'B THEN                                    0233
         TM    RCTDSTAC(R2),B'00100000'                            0233
         BNZ   @RF00233                                            0233
*           IF RCTDSTAT='1'B THEN                                  0234
         TM    RCTDSTAT(R2),B'00100000'                            0234
         BNO   @RF00234                                            0234
*             IF SDWAPERC='0'B|SDWASTAF='1'B THEN                  0235
         TM    SDWASTAF(R6),B'10000000'                            0235
         BNZ   @RT00235                                            0235
         TM    SDWAPERC(R6),B'00010000'                            0235
         BO    @RF00235                                            0235
@RT00235 DS    0H                                                  0236
*               RCTDDUMP='1'B;                                     0236
         OI    RCTDDUMP(R2),B'00000010'                            0236
*                                                                  0237
*/********************************************************************/
*/*                                                                  */
*/*      THIS SECTION OF CODE WILL DO THE FOLLOWING PROCESSING       */
*/*      PRIOR TO EXITING FROM THE FRR:                              */
*/*        - ISSUE THE SETRP MACRO SPECIFYING THE                    */
*/*          FOLLOWING WHEN RETURNING TO RTM:                        */
*/*            - MODULE, CSECT, AND FRR ID.                          */
*/*            - RECORD.                                             */
*/*            - FREE THE LOCAL LOCK.                                */
*/*            - ADDRESS OF THE SDWA.                                */
*/*            - PERCOLATE.                                          */
*/*        - RELEASE THE REGISTER USED AS THE BASE FOR THIS          */
*/*          FRR SINCE IT IS NO LONGER NEEDED.                       */
*/*                                                                  */
*/********************************************************************/
*                                                                  0237
*       DO;                         /* SETRP RECPARM(FRRMODID)RECORD(
*                                      YES)FRELOCK(LOCAL)WKAREA(R6)RC
*                                      (0)                           */
@RF00235 DS    0H                                                  0237
@RF00234 DS    0H                                                  0237
@RF00233 DS    0H                                                  0237
@RF00232 DS    0H                                                  0238
*         RESPECIFY                                                0238
*          (GPR00P,                                                0238
*           GPR01P,                                                0238
*           GPR14P,                                                0238
*           GPR15P) RSTD;                                          0238
*         GPR01P=R6;                                               0239
         LR    GPR01P,R6                                           0239
*         GPR01P->SDWARCDE=0;       /* SAVE RC VALUE                 */
         MVI   SDWARCDE(GPR01P),X'00'                              0240
*         GPR01P->SDWARCRD='1'B;    /* TURN ON RECORD INDICATOR      */
         OI    SDWARCRD(GPR01P),B'10000000'                        0241
*         GPR15P=ADDR(FRRMODID);    /* ACCESS RECORD PARAMETER LIST  */
         LA    GPR15P,FRRMODID                                     0242
*         GPR01P->SDWARECP=GPR15P->I256C(1:24);/* COPY RECORD      0243
*                                      PARAMETERS                    */
         MVC   SDWARECP(24,GPR01P),I256C(GPR15P)                   0243
*         GPR01P->SDWAACF4=GPR01P->SDWAACF4|'00000001'B;/* INITIALIZE
*                                      LOCK FLAGS                    */
         OI    SDWAACF4(GPR01P),B'00000001'                        0244
*         RESPECIFY                                                0245
*          (GPR00P,                                                0245
*           GPR01P,                                                0245
*           GPR14P,                                                0245
*           GPR15P) UNRSTD;                                        0245
*       END;                                                       0246
*     END;                                                         0247
*   GEN( DROP R9);                                                 0248
@RC00214 DS    0H                                                  0248
          DROP R9
*   RFY                                                            0249
*    (R9,                                                          0249
*     R6) UNRSTD;                                                  0249
*FR3EXIT:                                                          0250
*   END IEAVAFR3;                                                  0250
@EL00006 DS    0H                                                  0250
@EF00006 DS    0H                                                  0250
@ER00006 BR    @14                                                 0250
*   DECLARE                         /* GENERAL PURPOSE REGISTERS     */
*     GPR00P PTR(31) REG(0),                                       0251
*     GPR01P PTR(31) REG(1),                                       0251
*     GPR14P PTR(31) REG(14),                                      0251
*     GPR15P PTR(31) REG(15);                                      0251
*   DECLARE                         /* COMMON VARIABLES              */
*     I256C CHAR(256) BASED,                                       0252
*     I031F FIXED(31) BASED,                                       0252
*     I031P PTR(31) BASED,                                         0252
*     I015F FIXED(15) BASED,                                       0252
*     I015P PTR(15) BASED,                                         0252
*     I008P PTR(8) BASED,                                          0252
*     I001C CHAR(1) BASED;                                         0252
*   END IEAVAR03                                                   0253
*                                                                  0253
*/* THE FOLLOWING INCLUDE STATEMENTS WERE FOUND IN THIS PROGRAM.     */
*/*%INCLUDE SYSLIB  (IHAASCB )                                       */
*/*%INCLUDE SYSLIB  (IHAASXB )                                       */
*/*%INCLUDE SYSLIB  (CVT     )                                       */
*/*%INCLUDE SYSLIB  (IHAPCCA )                                       */
*/*%INCLUDE SYSLIB  (IHAPSA  )                                       */
*/*%INCLUDE SYSLIB  (IHARB   )                                       */
*/*%INCLUDE SYSLIB  (IKJRB   )                                       */
*/*%INCLUDE SYSLIB  (IEARCTD )                                       */
*/*%INCLUDE SYSLIB  (IHASCVT )                                       */
*/*%INCLUDE SYSLIB  (IHASDWA )                                       */
*/*%INCLUDE SYSLIB  (IHASPL  )                                       */
*/*%INCLUDE SYSLIB  (IKJTCB  )                                       */
*/*%INCLUDE SYSLIB  (IHAFRRS )                                       */
*/*%INCLUDE SYSLIB  (IEARVR  )                                       */
*                                                                  0253
*       ;                                                          0253
@DATA    DS    0H
@CH00912 DC    H'12'
@DATD    DSECT
         DS    0F
IEAVAR03 CSECT
         DS    0F
@CF02732 DC    F'-51713'
@CF00060 DC    XL4'80000000'
@CF00078 DC    XL4'00001000'
@CF02742 DC    XL4'0000FFFF'
@CF00065 DC    XL4'FFFFFF'
@DATD    DSECT
         DS    0D
IEAVAR03 CSECT
         NOPR  ((@ENDDATD-@DATD)*16)
         DS    0F
@SIZDATD DC    AL1(0)
         DC    AL3(@ENDDATD-@DATD)
         DS    0D
@CB00037 DC    X'10000000'
         DS    CL4
PATCHR03 DC    XL50'0'
FRRMODID DC    CL24'IEAVAR03IEAVAR03IEAVAFR3'
IEAVAR03 CSECT
ENTRYPT  DC  A(IEAVAR03)
@DATD    DSECT
   IKJTSB  LIST=YES
@DATD    DSECT
@ENDDATD EQU   *
IEAVAR03 CSECT
@00      EQU   00                      EQUATES FOR REGISTERS 0-15
@01      EQU   01
@02      EQU   02
@03      EQU   03
@04      EQU   04
@05      EQU   05
@06      EQU   06
@07      EQU   07
@08      EQU   08
@09      EQU   09
@10      EQU   10
@11      EQU   11
@12      EQU   12
@13      EQU   13
@14      EQU   14
@15      EQU   15
R0       EQU   @00
R1       EQU   @01
R2       EQU   @02
R3       EQU   @03
R4       EQU   @04
R5       EQU   @05
R6       EQU   @06
FRRSPTR  EQU   @06
R7       EQU   @07
R8       EQU   @08
FRREPTR  EQU   @08
R9       EQU   @09
R13      EQU   @13
R14      EQU   @14
R15      EQU   @15
GPR00P   EQU   @00
GPR01P   EQU   @01
GPR14P   EQU   @14
GPR15P   EQU   @15
R10      EQU   @10
         ENTRY IEAVAR3A
CVTPTR   EQU   16
PSA      EQU   0
FLCRNPSW EQU   PSA
FLCROPSW EQU   PSA+8
FLCICCW2 EQU   PSA+16
PSAEEPSW EQU   PSA+132
PSAESPSW EQU   PSA+136
FLCSVILC EQU   PSAESPSW+1
PSAEPPSW EQU   PSA+140
FLCPIILC EQU   PSAEPPSW+1
FLCPICOD EQU   PSAEPPSW+2
PSAPICOD EQU   FLCPICOD+1
FLCTEA   EQU   PSAEPPSW+4
FLCPER   EQU   PSA+152
FLCMCLA  EQU   PSA+168
FLCIOEL  EQU   FLCMCLA+4
FLCIOA   EQU   FLCMCLA+16
FLCFSA   EQU   FLCMCLA+80
PSAPCCAV EQU   PSA+520
PSAAOLD  EQU   PSA+548
PSASUPER EQU   PSA+552
PSASUP1  EQU   PSASUPER
PSASUP2  EQU   PSASUPER+1
PSASUP3  EQU   PSASUPER+2
PSASUP4  EQU   PSASUPER+3
PSACLHT  EQU   PSA+640
PSALKSA  EQU   PSA+696
PSAHLHI  EQU   PSA+760
PSADSSFL EQU   PSA+836
PSADSSF1 EQU   PSADSSFL
PSADSSF3 EQU   PSADSSFL+2
PSADSSF4 EQU   PSADSSFL+3
PSARSVT  EQU   PSA+896
STATUSBR EQU   0
ASCB     EQU   0
ASCBSPL  EQU   ASCB+28
ASCBTSB  EQU   ASCB+60
ASCBEWST EQU   ASCB+72
ASCBUBET EQU   ASCB+88
ASCBFW1  EQU   ASCB+100
ASCBAFFN EQU   ASCBFW1
ASCBRCTF EQU   ASCBFW1+2
ASCBWAIT EQU   ASCBRCTF
ASCBFLG1 EQU   ASCBFW1+3
ASCBASXB EQU   ASCB+108
ASCBDSP1 EQU   ASCB+114
ASCBFLG2 EQU   ASCB+115
ASCBS2S  EQU   ASCBFLG2
ASCBSRBS EQU   ASCB+118
ASXB     EQU   0
ASXBFTCB EQU   ASXB+4
ASXBRCTD EQU   ASXB+120
ASXBAEQ  EQU   ASXB+168
ASXBSECR EQU   ASXB+199
ASCBSFLG EQU   ASXBSECR
ASXBCASW EQU   ASXB+216
ASXBCRB1 EQU   ASXBCASW
CVTMAP   EQU   0
CVTDAR   EQU   CVTMAP+72
CVTFLGS1 EQU   CVTDAR
CVTDCB   EQU   CVTMAP+116
CVTIERLC EQU   CVTMAP+144
CVTOPTA  EQU   CVTMAP+182
CVTOPTB  EQU   CVTMAP+183
CVTABEND EQU   CVTMAP+200
CVTGTF   EQU   CVTMAP+236
CVTGTFST EQU   CVTGTF
CVTGTFS  EQU   CVTGTFST
CVTSTATE EQU   CVTGTFST
CVTTMODE EQU   CVTGTFST
CVTFORM  EQU   CVTGTFST
CVTAQAVT EQU   CVTMAP+240
CVTTCMFG EQU   CVTAQAVT
CVTVOLM2 EQU   CVTMAP+244
CVTTATA  EQU   CVTVOLM2
CVTTSKS  EQU   CVTTATA
CVTVOLF2 EQU   CVTTSKS
CVTTAT   EQU   CVTTATA+1
CVTATER  EQU   CVTMAP+248
CVTEXT1  EQU   CVTMAP+252
CVTPURG  EQU   CVTMAP+260
CVTQMSG  EQU   CVTMAP+268
CVTDMSR  EQU   CVTMAP+272
CVTRSV37 EQU   CVTDMSR
CVTDMSRF EQU   CVTRSV37
CVTERPV  EQU   CVTMAP+316
CVTINTLA EQU   CVTMAP+320
CVTAPF   EQU   CVTMAP+324
CVTEXT2  EQU   CVTMAP+328
CVTHJES  EQU   CVTMAP+332
CVTPGSIA EQU   CVTMAP+348
CVTA1F1  EQU   CVTMAP+356
CVTSYSK  EQU   CVTMAP+357
CVTVOLM1 EQU   CVTMAP+380
CVTVOLF1 EQU   CVTVOLM1
CVTATMCT EQU   CVTMAP+388
CVTXTNT1 EQU   0
CVTXTNT2 EQU   0
CVTDSSV  EQU   CVTXTNT2
CVTFLGBT EQU   CVTXTNT2+5
CVTQID   EQU   CVTXTNT2+24
CVTRV400 EQU   CVTXTNT2+52
CVTRV409 EQU   CVTXTNT2+53
CVTATCVT EQU   CVTXTNT2+64
CVTRV429 EQU   CVTXTNT2+84
CVTRV438 EQU   CVTXTNT2+85
CVTRV457 EQU   CVTXTNT2+112
CVTRV466 EQU   CVTXTNT2+113
CVTFIX   EQU   0
CVTRELNO EQU   CVTFIX+252
PCCA     EQU   0
PCCATMST EQU   PCCA+128
PCCATMFL EQU   PCCATMST
PCCATODE EQU   PCCATMST+1
PCCANUTD EQU   PCCATODE
PCCACCE  EQU   PCCATMST+2
PCCAINTE EQU   PCCATMST+3
PCCAEMSB EQU   PCCA+136
PCCAEMSI EQU   PCCAEMSB
PCCARISP EQU   PCCAEMSI
PCCAEMS2 EQU   PCCAEMSI+1
PCCAEMS3 EQU   PCCAEMSI+2
PCCARMSB EQU   PCCAEMSI+3
PCCAWERP EQU   PCCA+280
PCCACHPF EQU   PCCAWERP+4
PCCACHBL EQU   PCCAWERP+5
PCCACHVA EQU   PCCAWERP+6
PCCACHTS EQU   PCCAWERP+7
PCCACHS1 EQU   PCCA+288
PCCACHS2 EQU   PCCA+289
PCCACHRB EQU   PCCA+290
PCCACHF1 EQU   PCCA+308
PCCACHF2 EQU   PCCA+309
PCCACHF3 EQU   PCCA+310
PCCACHF4 EQU   PCCA+311
RBPRFX   EQU   0
RBBASIC  EQU   0
RBEXRTNM EQU   RBBASIC
RBTMFLD  EQU   RBEXRTNM
RBSTAB   EQU   RBBASIC+10
XSTAB    EQU   RBSTAB
RBSTAB1  EQU   XSTAB
XSTAB1   EQU   RBSTAB1
RBFTCKPT EQU   XSTAB1
RBSTAB2  EQU   XSTAB+1
XSTAB2   EQU   RBSTAB2
RBTCBNXT EQU   XSTAB2
RBFACTV  EQU   XSTAB2
RBFDYN   EQU   XSTAB2
RBECBWT  EQU   XSTAB2
RBOPSW   EQU   RBBASIC+16
XRBPSW   EQU   RBOPSW
RBOPSWB2 EQU   XRBPSW+1
RBLINK   EQU   RBBASIC+28
XRBLNK   EQU   RBLINK
RBWCF    EQU   XRBLNK
RBLINKB  EQU   XRBLNK+1
RBGRSAVE EQU   RBBASIC+32
XRBREG   EQU   RBGRSAVE
RBGRS0   EQU   XRBREG
RBGRS1   EQU   XRBREG+4
RBGRS2   EQU   XRBREG+8
RBGRS3   EQU   XRBREG+12
RBGRS4   EQU   XRBREG+16
RBGRS5   EQU   XRBREG+20
RBGRS6   EQU   XRBREG+24
RBGRS7   EQU   XRBREG+28
RBGRS8   EQU   XRBREG+32
RBGRS9   EQU   XRBREG+36
RBGRS10  EQU   XRBREG+40
RBGRS11  EQU   XRBREG+44
RBGRS12  EQU   XRBREG+48
RBGRS13  EQU   XRBREG+52
RBGRS14  EQU   XRBREG+56
RBGRS15  EQU   XRBREG+60
XRBESA   EQU   RBBASIC+96
RBPREFIX EQU   0
RBRSV019 EQU   RBPREFIX+14
RBRSV028 EQU   RBPREFIX+15
RBRSV041 EQU   RBPREFIX+27
RBRSV054 EQU   RBPREFIX+39
RBRTOPSW EQU   RBPREFIX+40
RBRTPSW2 EQU   RBRTOPSW+8
RBRTICIL EQU   RBRTPSW2
RBFLAGS1 EQU   RBPREFIX+56
RBINTCDA EQU   RBPREFIX+61
RBSECT   EQU   0
RBPPSAV  EQU   RBSECT
@NM00039 EQU   RBSECT+10
@NM00040 EQU   @NM00039
RBTRSVRB EQU   @NM00040
@NM00042 EQU   @NM00039+1
RBETXR   EQU   @NM00042
RBEP     EQU   RBSECT+12
RBPGMQ   EQU   RBSECT+24
@NM00049 EQU   RBSECT+28
IRBEND   EQU   RBSECT+96
@NM00053 EQU   RBSECT+96
RBRSV138 EQU   @NM00053+7
RBRSV150 EQU   RBSECT+167
RCTD     EQU   0
RCTDWORK EQU   RCTD+80
RCTDLMAC EQU   RCTDWORK
RCTDCLRL EQU   RCTDLMAC
RCTDTIME EQU   RCTDCLRL
RCTDTMLH EQU   RCTDTIME
RCTDECBS EQU   RCTD+156
RCTDWPTR EQU   RCTDECBS+4
RCTDTECB EQU   RCTD+164
RCTDPIRL EQU   RCTD+176
RCTDBASE EQU   RCTDPIRL+1
RCTDRC   EQU   RCTD+180
RCTDSLST EQU   RCTD+192
RCTDRCTR EQU   RCTD+216
RCTDMOID EQU   RCTDRCTR
RCTDDUMP EQU   RCTDMOID
RCTDFLGS EQU   RCTDRCTR+1
RCTDINTF EQU   RCTD+220
RCTDRCTF EQU   RCTDINTF
RCTDRSBO EQU   RCTDRCTF
RCTDSUBN EQU   RCTDRCTF
SCVTSECT EQU   0
SCVTSTAT EQU   SCVTSECT+148
SDWA     EQU   0
SDWAFIOB EQU   SDWA+4
SDWAABCC EQU   SDWAFIOB
SDWACMPF EQU   SDWAABCC
SDWACTL1 EQU   SDWA+8
SDWACMKA EQU   SDWACTL1
SDWAMWPA EQU   SDWACTL1+1
SDWAPMKA EQU   SDWACTL1+4
SDWACTL2 EQU   SDWA+16
SDWACMKP EQU   SDWACTL2
SDWAMWPP EQU   SDWACTL2+1
SDWAPMKP EQU   SDWACTL2+4
SDWAGRSV EQU   SDWA+24
SDWANAME EQU   SDWA+88
SDWAEC1  EQU   SDWA+104
SDWAEMK1 EQU   SDWAEC1
SDWAMWP1 EQU   SDWAEC1+1
SDWAINT1 EQU   SDWAEC1+2
SDWANXT1 EQU   SDWAEC1+4
SDWAAEC1 EQU   SDWA+112
SDWAILC1 EQU   SDWAAEC1+1
SDWAINC1 EQU   SDWAAEC1+2
SDWAICD1 EQU   SDWAINC1+1
SDWAEC2  EQU   SDWA+120
SDWAEMK2 EQU   SDWAEC2
SDWAMWP2 EQU   SDWAEC2+1
SDWAINT2 EQU   SDWAEC2+2
SDWANXT2 EQU   SDWAEC2+4
SDWAAEC2 EQU   SDWA+128
SDWAILC2 EQU   SDWAAEC2+1
SDWAINC2 EQU   SDWAAEC2+2
SDWAICD2 EQU   SDWAINC2+1
SDWASRSV EQU   SDWA+136
SDWAIDNT EQU   SDWA+200
SDWAMCH  EQU   SDWA+204
SDWASTCK EQU   SDWAMCH
SDWAMCHI EQU   SDWAMCH+8
SDWAMCHS EQU   SDWAMCHI
SDWAMCHD EQU   SDWAMCHI+1
SDWARSR1 EQU   SDWAMCH+12
SDWARSR2 EQU   SDWAMCH+13
SDWAFLGS EQU   SDWA+232
SDWAERRA EQU   SDWAFLGS
SDWARKEY EQU   SDWAERRA
SDWAERRB EQU   SDWAFLGS+1
SDWAERRC EQU   SDWAFLGS+2
SDWASTAF EQU   SDWAERRC
SDWAPERC EQU   SDWAERRC
SDWAERRD EQU   SDWAFLGS+3
SDWAFMID EQU   SDWA+236
SDWAIOFS EQU   SDWA+238
SDWACPUA EQU   SDWA+248
SDWAPARQ EQU   SDWA+252
SDWARCDE EQU   SDWAPARQ
SDWAACF2 EQU   SDWAPARQ+1
SDWARCRD EQU   SDWAACF2
SDWAACF3 EQU   SDWAPARQ+2
SDWAACF4 EQU   SDWAPARQ+3
SDWALKWA EQU   SDWA+256
SDWALKWS EQU   SDWALKWA
SDWARECP EQU   SDWA+292
SDWASNPA EQU   SDWA+320
SDWADUMP EQU   SDWASNPA
SDWADPFS EQU   SDWADUMP+1
SDWADDAT EQU   SDWASNPA+4
SDWASDAT EQU   SDWADDAT
SDWAPDAT EQU   SDWADDAT+2
SDWADPSA EQU   SDWA+328
SDWADPSL EQU   SDWADPSA
SDWARA   EQU   SDWA+400
SDWAVRAL EQU   SDWARA
SDWADPVA EQU   SDWARA+2
SDWAURAL EQU   SDWARA+3
SDWAVRA  EQU   SDWARA+4
SPLENTRY EQU   0
GSPL     EQU   0
GSPLNQ   EQU   GSPL
GSPLSYS  EQU   GSPL+8
LSPL     EQU   0
LSPLNQ   EQU   LSPL
LSPLSYS  EQU   LSPL+8
TCBFIX   EQU   0
TCBFRS   EQU   TCBFIX
TCB      EQU   0
TCBRBP   EQU   TCB
TCBPIE   EQU   TCB+4
TCBPMASK EQU   TCBPIE
TCBCMP   EQU   TCB+16
TCBCMPF  EQU   TCBCMP
TCBCPP   EQU   TCBCMPF
TCBSTCC  EQU   TCBCMPF
TCBCDBL  EQU   TCBCMPF
TCBCWTO  EQU   TCBCMPF
TCBCIND  EQU   TCBCMPF
TCBCMSG  EQU   TCBCMPF
TCBTRN   EQU   TCB+20
TCBABF   EQU   TCBTRN
TCBMSS   EQU   TCB+24
TCBPKF   EQU   TCB+28
TCBFLGS  EQU   TCB+29
TCBFLGS1 EQU   TCBFLGS
TCBFLGS2 EQU   TCBFLGS+1
TCBFLGS3 EQU   TCBFLGS+2
TCBFLGS4 EQU   TCBFLGS+3
TCBFLGS5 EQU   TCBFLGS+4
TCBABWF  EQU   TCBFLGS5
TCBJPQ   EQU   TCB+44
TCBPURGE EQU   TCBJPQ
TCBGRS   EQU   TCB+48
TCBFSA   EQU   TCB+112
TCBTCB   EQU   TCB+116
TCBTME   EQU   TCB+120
TCBJSTCB EQU   TCB+124
TCBTSFLG EQU   TCB+148
TCBTSTSK EQU   TCBTSFLG
TCBSTAB  EQU   TCB+160
TCBNSTAE EQU   TCBSTAB
TCBTCT   EQU   TCB+164
TCBTCTGF EQU   TCBTCT
TCBSCNDY EQU   TCB+172
TCBNDSP  EQU   TCBSCNDY
TCBNDSP1 EQU   TCBNDSP+1
TCBNDSP2 EQU   TCBNDSP+2
TCBNDSP3 EQU   TCBNDSP+3
TCBJSCB  EQU   TCB+180
TCBRECDE EQU   TCBJSCB
TCBEXT1  EQU   TCB+196
TCBBITS  EQU   TCB+200
TCBNDSP4 EQU   TCBBITS
TCBNDSP5 EQU   TCBBITS+1
TCBFLGS6 EQU   TCBBITS+2
TCBFLGS7 EQU   TCBBITS+3
TCBDAR   EQU   TCB+204
TCBDARC  EQU   TCBDAR
TCBEXT2  EQU   TCB+208
TCBFOE   EQU   TCB+244
TCBESTAE EQU   TCB+264
TCBESTRM EQU   TCBESTAE+1
TCBFBYT1 EQU   TCB+276
TCBFBYT2 EQU   TCB+277
TCBRV124 EQU   TCB+278
TCBRV133 EQU   TCB+279
TCBXTNT2 EQU   0
TCBGTF   EQU   TCBXTNT2
TCBTFLG  EQU   TCBGTF
TCBRV146 EQU   TCBXTNT2+28
TCBRV155 EQU   TCBXTNT2+29
TCBRV164 EQU   TCBXTNT2+30
TCBRV173 EQU   TCBXTNT2+31
FRRS     EQU   0
FRRSHEAD EQU   FRRS
FRRSENTR EQU   0
FRRSFLGS EQU   FRRSENTR+4
FRRSFLG1 EQU   FRRSFLGS
I256C    EQU   0
I001C    EQU   0
I008P    EQU   0
I015F    EQU   0
I015P    EQU   0
I031F    EQU   0
I031P    EQU   0
NONDISP1 EQU   TCBFLGS4
ASCBEWLH EQU   ASCBEWST
CSFIELD  EQU   ASCBAFFN
CVTS01   EQU   CVTPGSIA
CVTLPDIA EQU   CVTS01+12
CVTDIRST EQU   CVTLPDIA
CVTSLIDA EQU   CVTS01+24
CVTCTLFG EQU   CVTS01+50
CVTRV210 EQU   CVTS01+424
CVTRV219 EQU   CVTS01+425
CVTRV228 EQU   CVTS01+426
CVTRV237 EQU   CVTS01+427
CVTMFRTR EQU   CVTS01+452
CVTRV262 EQU   CVTS01+468
CVTRV271 EQU   CVTS01+469
CVTRV280 EQU   CVTS01+470
CVTRV289 EQU   CVTS01+471
CVTGSDA  EQU   CVTS01+600
PSARSVTE EQU   PSARSVT
RBSECS03 EQU   RBEP
RBCDE    EQU   RBSECS03
RBCDFLGS EQU   RBCDE
RBSECS05 EQU   RBPGMQ
RBSQE    EQU   RBSECS05
RBSECS06 EQU   RBPGMQ
RBIQE    EQU   RBSECS06
RBSECS07 EQU   RBPGMQ
RBIQE2   EQU   RBSECS07
RBSECS08 EQU   IRBEND
RBSECS09 EQU   IRBEND
@NM00062 EQU   RCTDFLGS
@NM00064 EQU   RCTDFLGS
@NM00066 EQU   RCTDFLGS
@NM00068 EQU   RCTDFLGS
@NM00070 EQU   RCTDFLGS
RCTDRS17 EQU   @NM00070
RCTDOBLK EQU   @NM00070
RCTDSTAT EQU   @NM00070
RCTDRLLK EQU   @NM00070
RCTDSY19 EQU   @NM00070
RCTDSY18 EQU   @NM00070
RCTDFAIL EQU   @NM00070
RCTDRSLW EQU   @NM00070
RCTDRIOC EQU   @NM00070+1
RCTDWTLB EQU   @NM00070+1
RCTDSTAC EQU   @NM00070+1
RCTDRLWC EQU   @NM00070+1
RCTDRLWB EQU   @NM00070+1
RCTDWTLC EQU   @NM00070+2
RCTDOPTC EQU   @NM00070+2
RVR      EQU   SDWAVRA
RVRSTATE EQU   RVR
RVRRF    EQU   RVRSTATE
RVRRC    EQU   RVRSTATE+4
RVRXF    EQU   RVRSTATE+8
RVRAF    EQU   RVRSTATE+9
RVRDUMP  EQU   RVR+12
FLC      EQU   PSA
*                                      START UNREFERENCED COMPONENTS
RVRDTEXT EQU   RVRDUMP+4
RVRDMPRC EQU   RVRDUMP
RVRRES2  EQU   RVRSTATE+11
RVRRES1  EQU   RVRSTATE+10
@NM00073 EQU   @NM00070+2
@NM00072 EQU   @NM00070+2
@NM00071 EQU   @NM00070+1
@NM00069 EQU   @NM00068+2
RCTDRGL1 EQU   @NM00068+2
RCTDOGL1 EQU   @NM00068+2
RCTDRLL2 EQU   @NM00068+2
RCTDOLL2 EQU   @NM00068+2
RCTDSWPF EQU   @NM00068+2
RCTDSYBC EQU   @NM00068+1
RCTDPRGF EQU   @NM00068+1
RCTDSLFL EQU   @NM00068+1
RCTDQWAI EQU   @NM00068+1
RCTDSWOT EQU   @NM00068+1
RCTDSSRB EQU   @NM00068+1
RCTDSSUB EQU   @NM00068+1
RCTDSY13 EQU   @NM00068+1
RCTDPSRB EQU   @NM00068
RCTDDEQ  EQU   @NM00068
RCTDSV16 EQU   @NM00068
RCTDSY12 EQU   @NM00068
RCTDPSUB EQU   @NM00068
RCTDRLL1 EQU   @NM00068
RCTDOLL1 EQU   @NM00068
RCTDENQ  EQU   @NM00068
@NM00067 EQU   @NM00066
RCTDPMSG EQU   @NM00066
RCTDAFPC EQU   @NM00066
RCTDAFPE EQU   @NM00066
@NM00065 EQU   @NM00064
RCTDCANE EQU   @NM00064
RCTDDETD EQU   @NM00064
RCTDDETS EQU   @NM00064
RCTDRES4 EQU   @NM00064
@NM00063 EQU   @NM00062
RCTDBR2A EQU   @NM00062
RCTDBR2R EQU   @NM00062
RCTDBR2Q EQU   @NM00062
RCTDBR2T EQU   @NM00062
RCTDLOOP EQU   @NM00062
RCTDWAIT EQU   @NM00062
RBRSV161 EQU   RBSECS09+64
RBSIRBWA EQU   RBSECS09
RBIQEWRK EQU   RBSECS08+4
RBNEXAV  EQU   RBSECS08
RBIQEA   EQU   RBIQE2
RBIQE1   EQU   RBIQE+1
RBUSE    EQU   RBIQE
RBSQEA   EQU   RBSQE+1
@NM00054 EQU   RBSQE
RBCDE1   EQU   RBCDE+1
RBCDLOAD EQU   RBCDFLGS
RBCDXCTL EQU   RBCDFLGS
RBCDSYNC EQU   RBCDFLGS
RBCDNODE EQU   RBCDFLGS
RBRSV010 EQU   RBCDFLGS
RBCDATCH EQU   RBCDFLGS
RBRSV009 EQU   RBCDFLGS
RBNOCELL EQU   RBCDFLGS
PSARSAV  EQU   PSARSVTE+60
PSARSTK  EQU   PSARSVTE+56
PSAESAV3 EQU   PSARSVTE+52
PSAESTK3 EQU   PSARSVTE+48
PSAESAV2 EQU   PSARSVTE+44
PSAESTK2 EQU   PSARSVTE+40
PSAESAV1 EQU   PSARSVTE+36
PSAESTK1 EQU   PSARSVTE+32
PSAPSAV  EQU   PSARSVTE+28
PSAPSTK  EQU   PSARSVTE+24
PSAMSAV  EQU   PSARSVTE+20
PSAMSTK  EQU   PSARSVTE+16
PSASSAV  EQU   PSARSVTE+12
PSASSTK  EQU   PSARSVTE+8
PSANSTK  EQU   PSARSVTE+4
PSACSTK  EQU   PSARSVTE
CVTRV628 EQU   CVTS01+728
CVTRV627 EQU   CVTS01+724
CVTRV626 EQU   CVTS01+720
CVTRV625 EQU   CVTS01+716
CVTRV624 EQU   CVTS01+712
CVTRV623 EQU   CVTS01+708
CVTRV622 EQU   CVTS01+704
CVTRV621 EQU   CVTS01+700
CVTIHASU EQU   CVTS01+696
CVTRV619 EQU   CVTS01+692
CVTRV618 EQU   CVTS01+688
CVTRV617 EQU   CVTS01+684
CVTRV616 EQU   CVTS01+680
CVTRV615 EQU   CVTS01+676
CVTRV614 EQU   CVTS01+672
CVTRV613 EQU   CVTS01+668
CVTTCASP EQU   CVTS01+664
CVT0PT03 EQU   CVTS01+660
CVT0PT0E EQU   CVTS01+656
CVTRV609 EQU   CVTS01+652
CVTCGK   EQU   CVTS01+648
CVTRAC   EQU   CVTS01+644
CVTRV606 EQU   CVTS01+640
CVTRV605 EQU   CVTS01+636
CVTRV604 EQU   CVTS01+632
CVTEFF02 EQU   CVTS01+628
CVTCBBR  EQU   CVTS01+624
CVTSSCR  EQU   CVTS01+620
CVTEVENT EQU   CVTS01+616
CVTCRCA  EQU   CVTS01+612
CVTTPIO  EQU   CVTS01+608
CVTADV   EQU   CVTS01+604
CVTGSDAB EQU   CVTGSDA
CVTQV3   EQU   CVTS01+596
CVTQV2   EQU   CVTS01+592
CVTQV1   EQU   CVTS01+588
CVTRPT   EQU   CVTS01+584
CVTSSRB  EQU   CVTS01+580
CVTCSDRL EQU   CVTS01+576
CVTEXP1  EQU   CVTS01+572
CVTRMPMT EQU   CVTS01+568
CVTRMPTT EQU   CVTS01+564
CVTVPSA  EQU   CVTS01+560
CVTVSTOP EQU   CVTS01+556
CVTGTFR8 EQU   CVTS01+552
CVTQUIT  EQU   CVTS01+548
CVTVACR  EQU   CVTS01+544
CVTWTCB  EQU   CVTS01+540
CVTSTPRS EQU   CVTS01+536
CVT0PT02 EQU   CVTS01+532
CVTDARCM EQU   CVTS01+528
CVTIRECM EQU   CVTS01+524
CVTJRECM EQU   CVTS01+520
CVTVEMS0 EQU   CVTS01+516
CVTSPFRR EQU   CVTS01+512
CVTRLSTG EQU   CVTS01+508
CVT0TC0A EQU   CVTS01+504
CVTGMBR  EQU   CVTS01+500
CVTLFRM  EQU   CVTS01+496
CVTRMBR  EQU   CVTS01+492
CVTVIOP  EQU   CVTS01+488
CVTRV307 EQU   CVTS01+486
CVTRV306 EQU   CVTS01+484
CVTRV305 EQU   CVTS01+482
CVTRV304 EQU   CVTS01+480
CVTRV303 EQU   CVTS01+478
CVTRV302 EQU   CVTS01+476
CVTTRCA  EQU   CVTS01+472
CVTRV297 EQU   CVTRV289
CVTRV296 EQU   CVTRV289
CVTRV295 EQU   CVTRV289
CVTRV294 EQU   CVTRV289
CVTRV293 EQU   CVTRV289
CVTRV292 EQU   CVTRV289
CVTRV291 EQU   CVTRV289
CVTRV290 EQU   CVTRV289
CVTRV288 EQU   CVTRV280
CVTRV287 EQU   CVTRV280
CVTRV286 EQU   CVTRV280
CVTRV285 EQU   CVTRV280
CVTRV284 EQU   CVTRV280
CVTRV283 EQU   CVTRV280
CVTRV282 EQU   CVTRV280
CVTRV281 EQU   CVTRV280
CVTRV279 EQU   CVTRV271
CVTRV278 EQU   CVTRV271
CVTRV277 EQU   CVTRV271
CVTRV276 EQU   CVTRV271
CVTRV275 EQU   CVTRV271
CVTRV274 EQU   CVTRV271
CVTRV273 EQU   CVTRV271
CVTRV272 EQU   CVTRV271
CVTRV270 EQU   CVTRV262
CVTRV269 EQU   CVTRV262
CVTRV268 EQU   CVTRV262
CVTRV267 EQU   CVTRV262
CVTRV266 EQU   CVTRV262
CVTRV265 EQU   CVTRV262
CVTRV264 EQU   CVTRV262
CVTRV263 EQU   CVTRV262
CVTVFP   EQU   CVTS01+464
CVTVSI   EQU   CVTS01+460
CVTVPSIB EQU   CVTS01+456
CVTMFACT EQU   CVTMFRTR
CVTMFCTL EQU   CVTS01+448
CVTPVBP  EQU   CVTS01+444
CVTPWI   EQU   CVTS01+440
CVTRV254 EQU   CVTS01+438
CVTRV253 EQU   CVTS01+436
CVTRV252 EQU   CVTS01+434
CVTRV251 EQU   CVTS01+433
CVTRV250 EQU   CVTS01+432
CVTRV249 EQU   CVTS01+431
CVTRV248 EQU   CVTS01+430
CVTRV247 EQU   CVTS01+429
CVTRV246 EQU   CVTS01+428
CVTRV245 EQU   CVTRV237
CVTRV244 EQU   CVTRV237
CVTRV243 EQU   CVTRV237
CVTRV242 EQU   CVTRV237
CVTRV241 EQU   CVTRV237
CVTRV240 EQU   CVTRV237
CVTRV239 EQU   CVTRV237
CVTRV238 EQU   CVTRV237
CVTRV236 EQU   CVTRV228
CVTRV235 EQU   CVTRV228
CVTRV234 EQU   CVTRV228
CVTRV233 EQU   CVTRV228
CVTRV232 EQU   CVTRV228
CVTRV231 EQU   CVTRV228
CVTRV230 EQU   CVTRV228
CVTRV229 EQU   CVTRV228
CVTRV227 EQU   CVTRV219
CVTRV226 EQU   CVTRV219
CVTRV225 EQU   CVTRV219
CVTRV224 EQU   CVTRV219
CVTRV223 EQU   CVTRV219
CVTRV222 EQU   CVTRV219
CVTRV221 EQU   CVTRV219
CVTRV220 EQU   CVTRV219
CVTRV218 EQU   CVTRV210
CVTRV217 EQU   CVTRV210
CVTRV216 EQU   CVTRV210
CVTRV215 EQU   CVTRV210
CVTRV214 EQU   CVTRV210
CVTRV213 EQU   CVTRV210
CVTRV212 EQU   CVTRV210
CVTRV211 EQU   CVTRV210
CVTLCCAT EQU   CVTS01+420
CVTPCCAT EQU   CVTS01+416
CVTIPCRP EQU   CVTS01+412
CVTIPCRI EQU   CVTS01+408
CVTIPCDS EQU   CVTS01+404
CVTAIDVT EQU   CVTS01+400
CVTSSAP  EQU   CVTS01+396
CVTEHCIR EQU   CVTS01+392
CVTEHDEF EQU   CVTS01+388
CVTDAIR  EQU   CVTS01+384
CVTPERFM EQU   CVTS01+380
CVT044R2 EQU   CVTS01+376
CVTFETCH EQU   CVTS01+372
CVTRSTWD EQU   CVTS01+368
CVTSPOST EQU   CVTS01+364
CVTIOBP  EQU   CVTS01+360
CVTASMVT EQU   CVTS01+356
CVTRECRQ EQU   CVTS01+352
CVTWSAC  EQU   CVTS01+348
CVTRV149 EQU   CVTS01+344
CVTWSAL  EQU   CVTS01+340
CVTSPSA  EQU   CVTS01+336
CVTGLMN  EQU   CVTS01+332
CVTVEAC0 EQU   CVTS01+328
CVT062R1 EQU   CVTS01+324
CVTRPOST EQU   CVTS01+320
CVTDQIQE EQU   CVTS01+316
CVTCSD   EQU   CVTS01+312
CVTLKRMA EQU   CVTS01+308
CVTRSPIE EQU   CVTS01+304
CVTRENQ  EQU   CVTS01+300
CVTLQCB  EQU   CVTS01+296
CVTFQCB  EQU   CVTS01+292
CVTQCS01 EQU   CVTS01+288
CVTAPFT  EQU   CVTS01+284
CVTPARRL EQU   CVTS01+280
CVTVWAIT EQU   CVTS01+276
CVTGSPL  EQU   CVTS01+272
CVTLSMQ  EQU   CVTS01+268
CVTGSMQ  EQU   CVTS01+264
CVTEXPRO EQU   CVTS01+260
CVTOPCTP EQU   CVTS01+256
CVTSIC   EQU   CVTS01+252
CVTTPIOS EQU   CVTS01+248
CVTRTMS  EQU   CVTS01+244
CVTSDBF  EQU   CVTS01+240
CVTSCBP  EQU   CVTS01+236
CVTSDMP  EQU   CVTS01+232
CVTSV60  EQU   CVTS01+228
CVTRTMCT EQU   CVTS01+224
CVTASCBL EQU   CVTS01+220
CVTASCBH EQU   CVTS01+216
CVTGDA   EQU   CVTS01+212
CVTASVT  EQU   CVTS01+208
CVTVVMDI EQU   CVTS01+204
CVTAQTOP EQU   CVTS01+200
CVTIOSCS EQU   CVTS01+196
CVTSDRM  EQU   CVTS01+192
CVTOPTE  EQU   CVTS01+188
CVTSTXU  EQU   CVTS01+184
CVTQUIS  EQU   CVTS01+180
CVTPARS  EQU   CVTS01+176
CVTS1EE  EQU   CVTS01+172
CVTFRAS  EQU   CVTS01+168
CVTQSAS  EQU   CVTS01+164
CVTCRAS  EQU   CVTS01+160
CVTCRMN  EQU   CVTS01+156
CVTDELCP EQU   CVTS01+152
CVTFRECL EQU   CVTS01+148
CVTGETCL EQU   CVTS01+144
CVTBLDCP EQU   CVTS01+140
CVTAUTHL EQU   CVTS01+136
CVTSCAN  EQU   CVTS01+132
CVTRV144 EQU   CVTS01+130
CVTMAXMP EQU   CVTS01+128
CVTSTCK  EQU   CVTS01+124
CVTRV139 EQU   CVTS01+123
CVTDSSAC EQU   CVTS01+122
CVTRV513 EQU   CVTS01+121
CVTIOSPL EQU   CVTS01+120
CVTPTGT  EQU   CVTS01+116
CVTCSPIE EQU   CVTS01+112
CVTSMFEX EQU   CVTS01+108
CVTOLT0A EQU   CVTS01+104
CVTSRBRT EQU   CVTS01+100
CVTPUTL  EQU   CVTS01+96
CVTASCRL EQU   CVTS01+92
CVTASCRF EQU   CVTS01+88
CVTRV326 EQU   CVTS01+84
CVTRV325 EQU   CVTS01+80
CVTRV324 EQU   CVTS01+76
CVT0VL01 EQU   CVTS01+72
CVTSHRVM EQU   CVTS01+68
CVTRV332 EQU   CVTS01+64
CVTTAS   EQU   CVTS01+60
CVTRSCN  EQU   CVTS01+56
CVTTRAC2 EQU   CVTS01+54
CVTTRACE EQU   CVTS01+52
CVTAPG   EQU   CVTS01+51
CVTSDTRC EQU   CVTCTLFG
CVTGTRCE EQU   CVTCTLFG
CVTNOMP  EQU   CVTCTLFG
CVTRSV79 EQU   CVTCTLFG
CVTDSTAT EQU   CVTCTLFG
CVTRSV78 EQU   CVTCTLFG
CVTRV333 EQU   CVTCTLFG
CVTRV323 EQU   CVTCTLFG
CVTSPVLK EQU   CVTS01+49
CVTRSV77 EQU   CVTS01+48
CVTRV331 EQU   CVTS01+44
CVTRV330 EQU   CVTS01+40
CVTRV329 EQU   CVTS01+36
CVTRV328 EQU   CVTS01+32
CVTRV322 EQU   CVTS01+28
CVTSLID  EQU   CVTSLIDA+1
CVTSYLK  EQU   CVTSLIDA
CVTRV321 EQU   CVTS01+20
CVTRV320 EQU   CVTS01+16
CVTLPDIR EQU   CVTLPDIA+1
CVTRSV69 EQU   CVTDIRST
CVTRSV68 EQU   CVTDIRST
CVTRSV67 EQU   CVTDIRST
CVTRSV66 EQU   CVTDIRST
CVTRSV65 EQU   CVTDIRST
CVTRSV64 EQU   CVTDIRST
CVTRSV63 EQU   CVTDIRST
CVTDICOM EQU   CVTDIRST
CVTPVTP  EQU   CVTS01+8
CVTLPDSR EQU   CVTS01+4
CVTGETL  EQU   CVTS01
FRRSPARM EQU   FRRSENTR+8
@NM00154 EQU   FRRSFLGS+1
@NM00153 EQU   FRRSFLG1
FRRSNEST EQU   FRRSFLG1
FRRSRCUR EQU   FRRSFLG1
FRRSFRRA EQU   FRRSENTR
FRRSENTS EQU   FRRS+84
FRRSRTMW EQU   FRRS+16
FRRSCURR EQU   FRRSHEAD+12
FRRSELEN EQU   FRRSHEAD+8
FRRSLAST EQU   FRRSHEAD+4
FRRSEMP  EQU   FRRSHEAD
@NM00152 EQU   TCBXTNT2+32
TCBRV181 EQU   TCBRV173
TCBRV180 EQU   TCBRV173
TCBRV179 EQU   TCBRV173
TCBRV178 EQU   TCBRV173
TCBRV177 EQU   TCBRV173
TCBRV176 EQU   TCBRV173
TCBRV175 EQU   TCBRV173
TCBRV174 EQU   TCBRV173
TCBRV172 EQU   TCBRV164
TCBRV171 EQU   TCBRV164
TCBRV170 EQU   TCBRV164
TCBRV169 EQU   TCBRV164
TCBRV168 EQU   TCBRV164
TCBRV167 EQU   TCBRV164
TCBRV166 EQU   TCBRV164
TCBRV165 EQU   TCBRV164
TCBRV163 EQU   TCBRV155
TCBRV162 EQU   TCBRV155
TCBRV161 EQU   TCBRV155
TCBRV160 EQU   TCBRV155
TCBRV159 EQU   TCBRV155
TCBRV158 EQU   TCBRV155
TCBRV157 EQU   TCBRV155
TCBRV156 EQU   TCBRV155
TCBRV154 EQU   TCBRV146
TCBRV153 EQU   TCBRV146
TCBRV152 EQU   TCBRV146
TCBRV151 EQU   TCBRV146
TCBRV150 EQU   TCBRV146
TCBRV149 EQU   TCBRV146
TCBRV148 EQU   TCBRV146
TCBRV147 EQU   TCBRV146
TCBRV145 EQU   TCBXTNT2+26
TCBRV144 EQU   TCBXTNT2+24
TCBRV143 EQU   TCBXTNT2+20
TCBRV142 EQU   TCBXTNT2+16
TCBRSV49 EQU   TCBXTNT2+12
TCBEVENT EQU   TCBXTNT2+8
TCBRCMP  EQU   TCBXTNT2+5
TCBRSVAB EQU   TCBXTNT2+4
TCBGTFA  EQU   TCBGTF+1
TCBRSV47 EQU   TCBTFLG
TCBRSV46 EQU   TCBTFLG
TCBRSV45 EQU   TCBTFLG
TCBRSV44 EQU   TCBTFLG
TCBRSV43 EQU   TCBTFLG
TCBDSPIT EQU   TCBTFLG
TCBERRTN EQU   TCBTFLG
TCBASYNC EQU   TCBTFLG
@NM00151 EQU   TCB+296
TCBSVCA2 EQU   TCB+292
TCBSWASA EQU   TCB+288
TCBDBTB  EQU   TCB+284
TCBRPT   EQU   TCB+280
TCBRV141 EQU   TCBRV133
TCBRV140 EQU   TCBRV133
TCBRV139 EQU   TCBRV133
TCBRV138 EQU   TCBRV133
TCBRV137 EQU   TCBRV133
TCBRV136 EQU   TCBRV133
TCBRV135 EQU   TCBRV133
TCBRV134 EQU   TCBRV133
TCBRV132 EQU   TCBRV124
TCBRV131 EQU   TCBRV124
TCBRV130 EQU   TCBRV124
TCBRV129 EQU   TCBRV124
TCBRV128 EQU   TCBRV124
TCBRV127 EQU   TCBRV124
TCBRV126 EQU   TCBRV124
TCBRV125 EQU   TCBRV124
TCBRV123 EQU   TCBFBYT2
TCBRV122 EQU   TCBFBYT2
TCBECBNV EQU   TCBFBYT2
TCBSSSYN EQU   TCBFBYT2
TCBFPRAP EQU   TCBFBYT2
TCBFDW   EQU   TCBFBYT2
TCBFMW   EQU   TCBFBYT2
TCBCNCB  EQU   TCBFBYT2
TCBLLH   EQU   TCBFBYT1
TCBRV113 EQU   TCBFBYT1
TCBEOT   EQU   TCBFBYT1
TCBRTM2  EQU   TCBFBYT1
TCBPGNLY EQU   TCBFBYT1
TCBNDIOS EQU   TCBFBYT1
TCBACTIV EQU   TCBFBYT1
TCBEOTFM EQU   TCBFBYT1
TCBAFFN  EQU   TCB+274
TCBCCPVI EQU   TCB+272
TCBUKYSP EQU   TCB+268
TCBMODE  EQU   TCBESTAE+3
TCBERTYP EQU   TCBESTAE+2
TCBRV314 EQU   TCBESTRM
TCBRV313 EQU   TCBESTRM
TCBRV312 EQU   TCBESTRM
TCBRV311 EQU   TCBESTRM
TCBRV310 EQU   TCBESTRM
TCBRV309 EQU   TCBESTRM
TCBRV308 EQU   TCBESTRM
TCBETERM EQU   TCBESTRM
TCBSCBKY EQU   TCBESTAE
TCBRTM12 EQU   TCB+260
TCBTCBID EQU   TCB+256
TCBRSV96 EQU   TCB+252
TCBSWA   EQU   TCB+248
TCBFOEA  EQU   TCBFOE+1
TCBRSV42 EQU   TCBFOE
TCBRV306 EQU   TCB+240
TCBRSV41 EQU   TCB+239
TCBTID   EQU   TCB+238
TCBRSVAA EQU   TCB+237
TCBABCUR EQU   TCB+236
TCBTMSAV EQU   TCB+232
TCBIOTIM EQU   TCB+228
TCBRTWA  EQU   TCB+224
TCBBACK  EQU   TCB+220
TCBTIRB  EQU   TCB+216
TCBAECB  EQU   TCB+212
TCBEXT2A EQU   TCBEXT2+1
TCBRSV39 EQU   TCBEXT2
TCBSTMCT EQU   TCB+207
TCBSYSCT EQU   TCB+206
TCBRSV37 EQU   TCB+205
TCBEXSVC EQU   TCBDAR
TCBDARMS EQU   TCBDAR
TCBDARWT EQU   TCBDAR
TCBDARO  EQU   TCBDAR
TCBDARMC EQU   TCBDARC
TCBDARD  EQU   TCBDAR
TCBDARS  EQU   TCBDAR
TCBDARP  EQU   TCBDAR
TCBGTOFM EQU   TCBFLGS7
TCBADMP  EQU   TCBFLGS7
TCBRSTSK EQU   TCBFLGS7
TCBSVCS  EQU   TCBFLGS7
TCBSTACK EQU   TCBFLGS7
TCBRSV34 EQU   TCBFLGS7
TCBRSV33 EQU   TCBFLGS7
TCBGPECB EQU   TCBFLGS7
TCBNTJS  EQU   TCBFLGS6
TCBAPG   EQU   TCBFLGS6
TCBMIGR  EQU   TCBFLGS6
TCBRV303 EQU   TCBFLGS6
TCBSPVLK EQU   TCBFLGS6
TCBCPU   EQU   TCBFLGS6
TCBPIE17 EQU   TCBFLGS6
TCBRV    EQU   TCBFLGS6
TCBRSV79 EQU   TCBNDSP5
TCBRSV78 EQU   TCBNDSP5
TCBRSV77 EQU   TCBNDSP5
TCBRSV76 EQU   TCBNDSP5
TCBRSV75 EQU   TCBNDSP5
TCBRSV74 EQU   TCBNDSP5
TCBRSV95 EQU   TCBNDSP5
TCBRSV94 EQU   TCBNDSP5
TCBRSV93 EQU   TCBNDSP4
TCBRSV92 EQU   TCBNDSP4
TCBRSV91 EQU   TCBNDSP4
TCBRSV90 EQU   TCBNDSP4
TCBRSV89 EQU   TCBNDSP4
TCBRSV88 EQU   TCBNDSP4
TCBRSV87 EQU   TCBNDSP4
TCBRSV86 EQU   TCBNDSP4
TCBEXT1A EQU   TCBEXT1+1
TCBRSV32 EQU   TCBEXT1
TCBEXCPD EQU   TCB+192
TCBIOBRC EQU   TCB+188
TCBDDWTC EQU   TCB+186
TCBDDEXC EQU   TCB+184
TCBJSCBB EQU   TCBJSCB+1
@NM00150 EQU   TCBRECDE
TCBREC   EQU   TCBRECDE
TCBMDIDS EQU   TCB+176
TCBNDINT EQU   TCBNDSP3
TCBRSV27 EQU   TCBNDSP3
TCBRSV26 EQU   TCBNDSP3
TCBRSV25 EQU   TCBNDSP3
TCBRSV24 EQU   TCBNDSP3
TCBSRBND EQU   TCBNDSP3
TCBRV302 EQU   TCBNDSP3
TCBLJSND EQU   TCBNDSP3
TCBABE   EQU   TCBNDSP2
TCBDSS   EQU   TCBNDSP2
TCBOWAIT EQU   TCBNDSP2
TCBIWAIT EQU   TCBNDSP2
TCBNDTS  EQU   TCBNDSP2
TCBNDSVC EQU   TCBNDSP2
TCBSTPP  EQU   TCBNDSP2
TCBABD   EQU   TCBNDSP2
TCBRSV22 EQU   TCBNDSP1
TCBPIEND EQU   TCBNDSP1
TCBTPSP  EQU   TCBNDSP1
TCBDDRND EQU   TCBNDSP1
TCBRSPND EQU   TCBNDSP1
TCBRSTND EQU   TCBNDSP1
TCBDARPN EQU   TCBNDSP1
TCBDARTN EQU   TCBNDSP1
TCBNDSP0 EQU   TCBNDSP
TCBUSER  EQU   TCB+168
TCBTCTB  EQU   TCBTCT+1
TCBRSV9C EQU   TCBTCTGF
TCBRSV9B EQU   TCBTCTGF
TCBRSV9A EQU   TCBTCTGF
TCBRSV99 EQU   TCBTCTGF
TCBRSV98 EQU   TCBTCTGF
TCBRSV97 EQU   TCBTCTGF
TCBRSV20 EQU   TCBTCTGF
TCBSMFGF EQU   TCBTCTGF
TCBSTABB EQU   TCBSTAB+1
TCBSTCUR EQU   TCBNSTAE
TCBRV301 EQU   TCBNSTAE
TCBSYNCH EQU   TCBNSTAE
TCBHALT  EQU   TCBNSTAE
TCBPPSUP EQU   TCBNSTAE
TCB33E   EQU   TCBNSTAE
TCBQUIES EQU   TCBNSTAE
TCBSTABE EQU   TCBNSTAE
TCBAQE   EQU   TCB+156
TCBPQE   EQU   TCB+152
TCBTSDP  EQU   TCB+151
TCBTSLP  EQU   TCB+150
TCBSTPCT EQU   TCB+149
TCBCPUBN EQU   TCBTSFLG
TCBDYDSP EQU   TCBTSFLG
TCBRSV18 EQU   TCBTSFLG
TCBRSV17 EQU   TCBTSFLG
TCBTIOTG EQU   TCBTSFLG
TCBATT   EQU   TCBTSFLG
TCBSTPPR EQU   TCBTSFLG
TCBRV300 EQU   TCBTSTSK
TCBECB   EQU   TCB+144
TCBIQE   EQU   TCB+140
TCBLTC   EQU   TCB+136
TCBOTC   EQU   TCB+132
TCBNTC   EQU   TCB+128
TCBJSTCA EQU   TCBJSTCB+1
TCBRSV16 EQU   TCBJSTCB
TCBTQET  EQU   TCBTME
TCBFSAB  EQU   TCBFSA+1
TCBQEL   EQU   TCBFSA
TCBGRS15 EQU   TCBGRS+60
TCBGRS14 EQU   TCBGRS+56
TCBGRS13 EQU   TCBGRS+52
TCBGRS12 EQU   TCBGRS+48
TCBGRS11 EQU   TCBGRS+44
TCBGRS10 EQU   TCBGRS+40
TCBGRS9  EQU   TCBGRS+36
TCBGRS8  EQU   TCBGRS+32
TCBGRS7  EQU   TCBGRS+28
TCBGRS6  EQU   TCBGRS+24
TCBGRS5  EQU   TCBGRS+20
TCBGRS4  EQU   TCBGRS+16
TCBGRS3  EQU   TCBGRS+12
TCBGRS2  EQU   TCBGRS+8
TCBGRS1  EQU   TCBGRS+4
TCBGRS0  EQU   TCBGRS
TCBJPQB  EQU   TCBJPQ+1
TCBRSV15 EQU   TCBPURGE
TCBRSV14 EQU   TCBPURGE
TCBRSV13 EQU   TCBPURGE
TCBRSV12 EQU   TCBPURGE
TCBRSV11 EQU   TCBPURGE
TCBRSV10 EQU   TCBPURGE
TCBRSV09 EQU   TCBPURGE
TCBJPQF  EQU   TCBPURGE
TCBJLB   EQU   TCB+40
TCBLLS   EQU   TCB+36
TCBDSP   EQU   TCB+35
TCBLMP   EQU   TCB+34
TCBPNDSP EQU   TCBFLGS5
TCBFCD1  EQU   TCBFLGS5
TCBSTP   EQU   TCBFLGS5
TCBSYS   EQU   TCBFLGS5
TCBANDSP EQU   TCBFLGS5
TCBPAGE  EQU   TCBFLGS5
TCBUXNDF EQU   TCBABWF
TCBFC    EQU   TCBFLGS5
TCBONDSP EQU   TCBFLGS4
TCBMPCND EQU   TCBFLGS4
TCBMPCVQ EQU   TCBFLGS4
TCBUXNDV EQU   TCBFLGS4
TCBHNDSP EQU   TCBFLGS4
TCBRQENA EQU   TCBFLGS4
TCBSER   EQU   TCBFLGS4
TCBNDUMP EQU   TCBFLGS4
TCBDWSTA EQU   TCBFLGS3
TCBRSV08 EQU   TCBFLGS3
TCBRSV07 EQU   TCBFLGS3
TCBRSV06 EQU   TCBFLGS3
TCBABGM  EQU   TCBFLGS3
TCBABTRM EQU   TCBFLGS3
TCBADINP EQU   TCBFLGS3
TCBFSM   EQU   TCBFLGS3
TCBFTS   EQU   TCBFLGS2
TCBFETXR EQU   TCBFLGS2
TCBFDSOP EQU   TCBFLGS2
TCBFJMC  EQU   TCBFLGS2
TCBFSMC  EQU   TCBFLGS2
TCBFABOP EQU   TCBFLGS2
TCBFSTI  EQU   TCBFLGS2
TCBFOINP EQU   TCBFLGS2
TCBFX    EQU   TCBFLGS1
TCBFS    EQU   TCBFLGS1
TCBFT    EQU   TCBFLGS1
TCBPDUMP EQU   TCBFLGS1
TCBNONPR EQU   TCBFLGS1
TCBFERA  EQU   TCBFLGS1
TCBFE    EQU   TCBFLGS1
TCBFA    EQU   TCBFLGS1
TCBZERO  EQU   TCBPKF
TCBFLAG  EQU   TCBPKF
TCBMSSB  EQU   TCBMSS+1
TCBRSV03 EQU   TCBMSS
TCBTRNB  EQU   TCBTRN+1
TCBRSV02 EQU   TCBABF
TCBOLTEP EQU   TCBABF
TCBTCP   EQU   TCBABF
TCBTCPP  EQU   TCBABF
TCBRSV01 EQU   TCBABF
TCBGRPH  EQU   TCBABF
TCBNOCHK EQU   TCBABF
TCBMOD91 EQU   TCBABF
TCBCMPC  EQU   TCBCMP+1
TCBRV318 EQU   TCBCMSG
TCBRV317 EQU   TCBCIND
TCBRV316 EQU   TCBCWTO
TCBCASID EQU   TCBCDBL
TCBNOCC  EQU   TCBSTCC
TCBDMPO  EQU   TCBCPP
TCBCSTEP EQU   TCBCMPF
TCBCREQ  EQU   TCBCMPF
TCBTIO   EQU   TCB+12
TCBDEB   EQU   TCB+8
TCBPIEA  EQU   TCBPIE+1
TCBPM    EQU   TCBPMASK
@NM00149 EQU   TCBPMASK
TCBFRS6  EQU   TCBFRS+24
TCBFRS4  EQU   TCBFRS+16
TCBFRS2  EQU   TCBFRS+8
TCBFRS0  EQU   TCBFRS
LSPLEND  EQU   LSPL+16
LSPLSYSL EQU   LSPLSYS+4
LSPLSYSF EQU   LSPLSYS
LSPLNQL  EQU   LSPLNQ+4
LSPLNQF  EQU   LSPLNQ
GSPLEND  EQU   GSPL+16
GSPLSYSL EQU   GSPLSYS+4
GSPLSYSF EQU   GSPLSYS
GSPLNQL  EQU   GSPLNQ+4
GSPLNQF  EQU   GSPLNQ
SPLLSRB  EQU   SPLENTRY+4
SPLFSRB  EQU   SPLENTRY
@NM00148 EQU   SDWA+512
@NM00147 EQU   SDWADPVA
SDWAEBC  EQU   SDWADPVA
SDWAHEX  EQU   SDWADPVA
@NM00146 EQU   SDWA+396
SDWACOMP EQU   SDWA+392
SDWARCPL EQU   SDWA+364
@NM00145 EQU   SDWADPSA+32
SDWATO4  EQU   SDWADPSL+28
SDWAFRM4 EQU   SDWADPSL+24
SDWATO3  EQU   SDWADPSL+20
SDWAFRM3 EQU   SDWADPSL+16
SDWATO2  EQU   SDWADPSL+12
SDWAFRM2 EQU   SDWADPSL+8
SDWATO1  EQU   SDWADPSL+4
SDWAFRM1 EQU   SDWADPSL
@NM00144 EQU   SDWADDAT+3
@NM00143 EQU   SDWAPDAT
SDWAUSPL EQU   SDWAPDAT
SDWADPSW EQU   SDWAPDAT
SDWATJPA EQU   SDWAPDAT
SDWATLPA EQU   SDWAPDAT
SDWADREG EQU   SDWAPDAT
SDWADSAH EQU   SDWAPDAT
SDWADSAS EQU   SDWAPDAT
@NM00142 EQU   SDWADDAT+1
@NM00141 EQU   SDWASDAT
SDWAQQS  EQU   SDWASDAT
SDWACBS  EQU   SDWASDAT
SDWAGTF  EQU   SDWASDAT
SDWASWA  EQU   SDWASDAT
SDWALSQA EQU   SDWASDAT
SDWASQA  EQU   SDWASDAT
SDWANUC  EQU   SDWASDAT
@NM00140 EQU   SDWADUMP+2
@NM00139 EQU   SDWADPFS
SDWASLST EQU   SDWADPFS
@NM00138 EQU   SDWADPFS
SDWADLST EQU   SDWADPFS
SDWADPT  EQU   SDWADPFS
SDWADPID EQU   SDWADUMP
SDWADPLA EQU   SDWA+316
SDWAREXN EQU   SDWARECP+16
SDWACSCT EQU   SDWARECP+8
SDWAMODN EQU   SDWARECP
@NM00137 EQU   SDWA+290
SDWAASID EQU   SDWA+288
SDWATALW EQU   SDWALKWS+28
SDWATDLW EQU   SDWALKWS+24
SDWATNLW EQU   SDWALKWS+20
SDWAAPLW EQU   SDWALKWS+16
SDWAIPLW EQU   SDWALKWS+12
SDWAILLW EQU   SDWALKWS+8
SDWAIULW EQU   SDWALKWS+4
SDWAICLW EQU   SDWALKWS
SDWAFLLK EQU   SDWAACF4
SDWACMS  EQU   SDWAACF4
SDWAOPTM EQU   SDWAACF4
SDWATADB EQU   SDWAACF4
SDWATDNB EQU   SDWAACF4
SDWATNCB EQU   SDWAACF4
SDWAILCH EQU   SDWAACF4
SDWAIUCB EQU   SDWAACF4
SDWAICAT EQU   SDWAACF3
SDWAIPRG EQU   SDWAACF3
SDWASALL EQU   SDWAACF3
SDWAASMP EQU   SDWAACF3
SDWADISP EQU   SDWAACF3
@NM00136 EQU   SDWAACF3
@NM00135 EQU   SDWAACF2
SDWAFREE EQU   SDWAACF2
SDWAUPRG EQU   SDWAACF2
@NM00134 EQU   SDWAACF2
SDWASPIN EQU   SDWAACF2
@NM00133 EQU   SDWAACF2
SDWALCPU EQU   SDWACPUA+2
@NM00132 EQU   SDWACPUA
SDWARECA EQU   SDWA+244
SDWARTYA EQU   SDWA+240
@NM00131 EQU   SDWA+239
@NM00130 EQU   SDWAIOFS
SDWANIOP EQU   SDWAIOFS
SDWANOIO EQU   SDWAIOFS
SDWAIOHT EQU   SDWAIOFS
SDWAIOQR EQU   SDWAIOFS
@NM00129 EQU   SDWAERRD
SDWAMCIV EQU   SDWAERRD
SDWARPIV EQU   SDWAERRD
SDWAMABD EQU   SDWAERRD
SDWACTS  EQU   SDWAERRD
SDWASTAE EQU   SDWAERRD
SDWANRBE EQU   SDWAERRD
SDWACLUP EQU   SDWAERRD
@NM00128 EQU   SDWAERRC
SDWAEAS  EQU   SDWAERRC
SDWAIRB  EQU   SDWAERRC
SDWASTAI EQU   SDWAERRC
SDWASRBM EQU   SDWAERRB
SDWALDIS EQU   SDWAERRB
SDWAENRB EQU   SDWAERRB
SDWATYP1 EQU   SDWAERRB
@NM00127 EQU   SDWAERRB
SDWAPGIO EQU   SDWAERRA
SDWATEXC EQU   SDWAERRA
SDWASVCE EQU   SDWAERRA
SDWAABTM EQU   SDWAERRA
SDWASVCD EQU   SDWAERRA
SDWAPCHK EQU   SDWAERRA
SDWAMCHK EQU   SDWAERRA
SDWATIME EQU   SDWAMCH+20
SDWARFSA EQU   SDWAMCH+16
@NM00126 EQU   SDWAMCH+14
SDWAVEQR EQU   SDWARSR2
SDWAPGFX EQU   SDWARSR2
SDWAFLSQ EQU   SDWARSR2
SDWAFSQA EQU   SDWARSR2
SDWANUCL EQU   SDWARSR2
SDWASPER EQU   SDWARSR2
SDWAINTC EQU   SDWARSR2
SDWAOFLN EQU   SDWARSR2
SDWACHNG EQU   SDWARSR1
SDWAMSER EQU   SDWARSR1
@NM00125 EQU   SDWARSR1
SDWACPID EQU   SDWAMCH+10
SDWATERR EQU   SDWAMCHD
SDWAFPRX EQU   SDWAMCHD
SDWAINSF EQU   SDWAMCHD
SDWAACR  EQU   SDWAMCHD
SDWASCK  EQU   SDWAMCHD
SDWAPSWU EQU   SDWAMCHD
SDWAREGU EQU   SDWAMCHD
SDWASKYF EQU   SDWAMCHD
@NM00124 EQU   SDWAMCHS
SDWARSRF EQU   SDWAMCHS
SDWARSRC EQU   SDWAMCHS
SDWAINVP EQU   SDWAMCHS
SDWATSVL EQU   SDWAMCHS
SDWARCDF EQU   SDWAMCHS
SDWASRVL EQU   SDWAMCHS
SDWASCKE EQU   SDWASTCK+4
SDWASCKB EQU   SDWASTCK
SDWALNTH EQU   SDWAIDNT+1
SDWASPID EQU   SDWAIDNT
SDWASR15 EQU   SDWASRSV+60
SDWASR14 EQU   SDWASRSV+56
SDWASR13 EQU   SDWASRSV+52
SDWASR12 EQU   SDWASRSV+48
SDWASR11 EQU   SDWASRSV+44
SDWASR10 EQU   SDWASRSV+40
SDWASR09 EQU   SDWASRSV+36
SDWASR08 EQU   SDWASRSV+32
SDWASR07 EQU   SDWASRSV+28
SDWASR06 EQU   SDWASRSV+24
SDWASR05 EQU   SDWASRSV+20
SDWASR04 EQU   SDWASRSV+16
SDWASR03 EQU   SDWASRSV+12
SDWASR02 EQU   SDWASRSV+8
SDWASR01 EQU   SDWASRSV+4
SDWASR00 EQU   SDWASRSV
SDWATRN2 EQU   SDWAAEC2+4
SDWAIPC2 EQU   SDWAICD2
SDWAIMC2 EQU   SDWAICD2
SDWAIPR2 EQU   SDWAICD2
@NM00123 EQU   SDWAINC2
@NM00122 EQU   SDWAILC2
SDWAIL2  EQU   SDWAILC2
@NM00121 EQU   SDWAILC2
@NM00120 EQU   SDWAAEC2
SDWAADD2 EQU   SDWANXT2+1
@NM00119 EQU   SDWANXT2
@NM00118 EQU   SDWAEC2+3
SDWASGN2 EQU   SDWAINT2
SDWAEXP2 EQU   SDWAINT2
SDWADEC2 EQU   SDWAINT2
SDWAFPO2 EQU   SDWAINT2
SDWACC2  EQU   SDWAINT2
@NM00117 EQU   SDWAINT2
SDWAPGM2 EQU   SDWAMWP2
SDWAWAT2 EQU   SDWAMWP2
SDWAMCK2 EQU   SDWAMWP2
SDWAECT2 EQU   SDWAMWP2
SDWAKEY2 EQU   SDWAMWP2
SDWAEXT2 EQU   SDWAEMK2
SDWAIO2  EQU   SDWAEMK2
SDWATRM2 EQU   SDWAEMK2
@NM00116 EQU   SDWAEMK2
SDWAPER2 EQU   SDWAEMK2
@NM00115 EQU   SDWAEMK2
SDWATRAN EQU   SDWAAEC1+4
SDWAIPC1 EQU   SDWAICD1
SDWAIMC1 EQU   SDWAICD1
SDWAIPR1 EQU   SDWAICD1
@NM00114 EQU   SDWAINC1
@NM00113 EQU   SDWAILC1
SDWAIL1  EQU   SDWAILC1
@NM00112 EQU   SDWAILC1
@NM00111 EQU   SDWAAEC1
SDWAADD1 EQU   SDWANXT1+1
@NM00110 EQU   SDWANXT1
@NM00109 EQU   SDWAEC1+3
SDWASGN1 EQU   SDWAINT1
SDWAEXP1 EQU   SDWAINT1
SDWADEC1 EQU   SDWAINT1
SDWAFPO1 EQU   SDWAINT1
SDWACC1  EQU   SDWAINT1
@NM00108 EQU   SDWAINT1
SDWAPGM1 EQU   SDWAMWP1
SDWAWAT1 EQU   SDWAMWP1
SDWAMCK1 EQU   SDWAMWP1
SDWAECT1 EQU   SDWAMWP1
SDWAKEY1 EQU   SDWAMWP1
SDWAEXT1 EQU   SDWAEMK1
SDWAIO1  EQU   SDWAEMK1
SDWATRM1 EQU   SDWAEMK1
@NM00107 EQU   SDWAEMK1
SDWAPER1 EQU   SDWAEMK1
@NM00106 EQU   SDWAEMK1
SDWAIOBR EQU   SDWA+100
SDWAEPA  EQU   SDWA+96
@NM00105 EQU   SDWANAME+4
SDWARBAD EQU   SDWANAME
SDWAGR15 EQU   SDWAGRSV+60
SDWAGR14 EQU   SDWAGRSV+56
SDWAGR13 EQU   SDWAGRSV+52
SDWAGR12 EQU   SDWAGRSV+48
SDWAGR11 EQU   SDWAGRSV+44
SDWAGR10 EQU   SDWAGRSV+40
SDWAGR09 EQU   SDWAGRSV+36
SDWAGR08 EQU   SDWAGRSV+32
SDWAGR07 EQU   SDWAGRSV+28
SDWAGR06 EQU   SDWAGRSV+24
SDWAGR05 EQU   SDWAGRSV+20
SDWAGR04 EQU   SDWAGRSV+16
SDWAGR03 EQU   SDWAGRSV+12
SDWAGR02 EQU   SDWAGRSV+8
SDWAGR01 EQU   SDWAGRSV+4
SDWAGR00 EQU   SDWAGRSV
SDWANXTP EQU   SDWACTL2+5
SDWASGP  EQU   SDWAPMKP
SDWAEUP  EQU   SDWAPMKP
SDWADOP  EQU   SDWAPMKP
SDWAFPP  EQU   SDWAPMKP
SDWACCP  EQU   SDWAPMKP
SDWAILP  EQU   SDWAPMKP
SDWAINTP EQU   SDWACTL2+2
SDWASPVP EQU   SDWAMWPP
SDWAWATP EQU   SDWAMWPP
SDWAMCKP EQU   SDWAMWPP
@NM00104 EQU   SDWAMWPP
SDWAKEYP EQU   SDWAMWPP
SDWAEXTP EQU   SDWACMKP
SDWAIOP  EQU   SDWACMKP
SDWANXTA EQU   SDWACTL1+5
SDWASGA  EQU   SDWAPMKA
SDWAEUA  EQU   SDWAPMKA
SDWADOA  EQU   SDWAPMKA
SDWAFPA  EQU   SDWAPMKA
SDWACCA  EQU   SDWAPMKA
SDWAILA  EQU   SDWAPMKA
SDWAINTA EQU   SDWACTL1+2
SDWASPVA EQU   SDWAMWPA
SDWAWATA EQU   SDWAMWPA
SDWAMCKA EQU   SDWAMWPA
@NM00103 EQU   SDWAMWPA
SDWAKEYA EQU   SDWAMWPA
SDWAEXTA EQU   SDWACMKA
SDWAIOA  EQU   SDWACMKA
SDWACMPC EQU   SDWAABCC+1
@NM00102 EQU   SDWACMPF
SDWASTCC EQU   SDWACMPF
@NM00101 EQU   SDWACMPF
SDWASTEP EQU   SDWACMPF
SDWAREQ  EQU   SDWACMPF
SDWAPARM EQU   SDWA
@NM00100 EQU   SCVTSECT+180
@NM00099 EQU   SCVTSECT+176
SCVTPIQE EQU   SCVTSECT+172
@NM00098 EQU   SCVTSECT+168
SCVTPTRM EQU   SCVTSECT+164
@NM00097 EQU   SCVTSECT+160
@NM00096 EQU   SCVTSECT+156
SCVTQCBR EQU   SCVTSECT+152
@NM00095 EQU   SCVTSECT+144
SCVTTQE  EQU   SCVTSECT+140
@NM00094 EQU   SCVTSECT+136
SCVTSVCT EQU   SCVTSECT+132
@NM00093 EQU   SCVTSECT+128
@NM00092 EQU   SCVTSECT+124
SCVTRXLQ EQU   SCVTSECT+120
@NM00091 EQU   SCVTSECT+116
SCVTCTCB EQU   SCVTSECT+112
@NM00090 EQU   SCVTSECT+108
@NM00089 EQU   SCVTSECT+104
@NM00088 EQU   SCVTSECT+100
@NM00087 EQU   SCVTSECT+96
SCVTCOMM EQU   SCVTSECT+92
@NM00086 EQU   SCVTSECT+88
@NM00085 EQU   SCVTSECT+84
@NM00084 EQU   SCVTSECT+80
@NM00083 EQU   SCVTSECT+76
@NM00082 EQU   SCVTSECT+72
SCVTGMBR EQU   SCVTSECT+68
SCVTRPTR EQU   SCVTSECT+64
SCVTHSKP EQU   SCVTSECT+60
@NM00081 EQU   SCVTSECT+56
@NM00080 EQU   SCVTSECT+52
SCVTLFRM EQU   SCVTSECT+48
SCVTCDCL EQU   SCVTSECT+44
@NM00079 EQU   SCVTSECT+40
SCVTRACE EQU   SCVTSECT+36
@NM00078 EQU   SCVTSECT+32
SCVTRMBR EQU   SCVTSECT+28
@NM00077 EQU   SCVTSECT+24
@NM00076 EQU   SCVTSECT+20
@NM00075 EQU   SCVTSECT+16
@NM00074 EQU   SCVTSECT+14
SCVTBR14 EQU   SCVTSECT+12
SCVTSPET EQU   SCVTSECT+8
SCVTPGWR EQU   SCVTSECT+4
SCVTPGTM EQU   SCVTSECT
RCTDEND  EQU   RCTD+240
RCTDRES1 EQU   RCTD+224
RCTDRES5 EQU   RCTDINTF+1
@NM00061 EQU   RCTDRCTF
RCTDDLCK EQU   RCTDRCTF
RCTDSRBN EQU   RCTDRCTF
RCTDPRGR EQU   RCTDRCTF
@NM00060 EQU   RCTDFLGS
RCTDBRCP EQU   RCTDFLGS
RCTDATTS EQU   RCTDFLGS
RCTDRES3 EQU   RCTDFLGS
RCTDATTD EQU   RCTDFLGS
@NM00059 EQU   RCTDMOID
RCTDTERM EQU   RCTDMOID
RCTDATTN EQU   RCTDMOID
RCTDREST EQU   RCTDMOID
RCTDQUIS EQU   RCTDMOID
RCTDCOMN EQU   RCTDMOID
RCTDINIT EQU   RCTDMOID
RCTDSCLR EQU   RCTDSLST
RCTDRTY@ EQU   RCTD+188
RCTDRTRY EQU   RCTD+184
@NM00058 EQU   RCTDPIRL
RCTDTAXE EQU   RCTD+172
RCTDRET@ EQU   RCTD+168
@NM00057 EQU   RCTDTECB
RCTDPOST EQU   RCTDTECB
@NM00056 EQU   RCTDTECB
RCTDECBE EQU   RCTDWPTR
RCTDTPTR EQU   RCTDECBS
RCTDCLST EQU   RCTD+154
RCTDRES2 EQU   RCTD+152
RCTDPRG  EQU   RCTDCLRL+8
@NM00055 EQU   RCTDTIME+4
RCTDTCBS EQU   RCTD+76
RCTDTCBD EQU   RCTD+72
RCTDISAV EQU   RCTD
RCTDBEGN EQU   RCTD
SIRBEND  EQU   RBSECT+168
SVRBEND  EQU   RBSECT+168
RBRSV158 EQU   RBRSV150
RBRSV157 EQU   RBRSV150
RBRSV156 EQU   RBRSV150
RBRSV155 EQU   RBRSV150
RBRSV154 EQU   RBRSV150
RBRSV153 EQU   RBRSV150
RBRSV152 EQU   RBRSV150
RBRSV151 EQU   RBRSV150
RBRSV149 EQU   RBSECT+166
RBRSV148 EQU   RBSECT+164
RBSCBB   EQU   RBSECT+144
TIRBEND  EQU   @NM00053+8
PRBEND   EQU   @NM00053+8
RBRSV146 EQU   RBRSV138
RBRSV145 EQU   RBRSV138
RBRSV144 EQU   RBRSV138
RBRSV143 EQU   RBRSV138
RBRSV142 EQU   RBRSV138
RBRSV141 EQU   RBRSV138
RBRSV140 EQU   RBRSV138
RBRSV139 EQU   RBRSV138
RBRSV137 EQU   @NM00053+6
RBRSV136 EQU   @NM00053+4
RBRSV135 EQU   @NM00053
@NM00052 EQU   RBSECT+32
@NM00051 EQU   @NM00049+1
@NM00050 EQU   @NM00049
RBPGMQ1  EQU   RBPGMQ+1
@NM00048 EQU   RBPGMQ
@NM00047 EQU   RBSECT+16
@NM00046 EQU   @NM00042
@NM00045 EQU   @NM00042
RBIQETP  EQU   @NM00042
RBUSIQE  EQU   RBETXR
RBATTN   EQU   @NM00042
@NM00044 EQU   @NM00042
@NM00043 EQU   @NM00042
RBPMSVRB EQU   @NM00040
RBATNXIT EQU   @NM00040
@NM00041 EQU   @NM00040
RBWAITP  EQU   @NM00040
RBFNSVRB EQU   RBTRSVRB
RBFTP    EQU   @NM00040
RBSIZE   EQU   RBSECT+8
RBABOPSW EQU   RBSECT+4
RBPPSAV1 EQU   RBPPSAV+1
@NM00038 EQU   RBPPSAV
RBPRFXND EQU   RBPREFIX+64
RBINTCOD EQU   RBINTCDA+1
RBINLNTH EQU   RBINTCDA
RBWCSA   EQU   RBPREFIX+60
RBRSV004 EQU   RBPREFIX+57
RBSSSYN  EQU   RBFLAGS1
RBSCB    EQU   RBFLAGS1
RBLONGWT EQU   RBFLAGS1
RBASIR   EQU   RBFLAGS1
RBRSV159 EQU   RBFLAGS1
RBABEND  EQU   RBFLAGS1
RBXWAIT  EQU   RBFLAGS1
RBSLOCK  EQU   RBFLAGS1
RBRTRAN  EQU   RBRTPSW2+4
RBRTINCD EQU   RBRTICIL+2
RBRTILC  EQU   RBRTICIL+1
RBRSV160 EQU   RBRTICIL
RBRTPSW1 EQU   RBRTOPSW
RBRSV062 EQU   RBRSV054
RBRSV061 EQU   RBRSV054
RBRSV060 EQU   RBRSV054
RBRSV059 EQU   RBRSV054
RBRSV058 EQU   RBRSV054
RBRSV057 EQU   RBRSV054
RBRSV056 EQU   RBRSV054
RBRSV055 EQU   RBRSV054
RBRSV053 EQU   RBPREFIX+38
RBRSV052 EQU   RBPREFIX+36
RBRSV051 EQU   RBPREFIX+32
RBPRFXST EQU   RBPREFIX+32
RBRSV050 EQU   RBPREFIX+28
RBRSV049 EQU   RBRSV041
RBRSV048 EQU   RBRSV041
RBRSV047 EQU   RBRSV041
RBRSV046 EQU   RBRSV041
RBRSV045 EQU   RBRSV041
RBRSV044 EQU   RBRSV041
RBRSV043 EQU   RBRSV041
RBRSV042 EQU   RBRSV041
RBRSV040 EQU   RBPREFIX+26
RBRSV039 EQU   RBPREFIX+24
RBRSV038 EQU   RBPREFIX+20
RBRSV037 EQU   RBPREFIX+16
RBRSV036 EQU   RBRSV028
RBRSV035 EQU   RBRSV028
RBRSV034 EQU   RBRSV028
RBRSV033 EQU   RBRSV028
RBRSV032 EQU   RBRSV028
RBRSV031 EQU   RBRSV028
RBRSV030 EQU   RBRSV028
RBRSV029 EQU   RBRSV028
RBRSV027 EQU   RBRSV019
RBRSV026 EQU   RBRSV019
RBRSV025 EQU   RBRSV019
RBRSV024 EQU   RBRSV019
RBRSV023 EQU   RBRSV019
RBRSV022 EQU   RBRSV019
RBRSV021 EQU   RBRSV019
RBRSV020 EQU   RBRSV019
RBRSV018 EQU   RBPREFIX+13
RBRSV017 EQU   RBPREFIX+12
RBSRV016 EQU   RBPREFIX+11
RBRSV015 EQU   RBPREFIX+10
RBRSV014 EQU   RBPREFIX+8
RBRSV013 EQU   RBPREFIX+4
RBRSV012 EQU   RBPREFIX
RBEXSAVE EQU   XRBESA
XRBREG15 EQU   RBGRS15
XRBREG14 EQU   RBGRS14
XRBREG13 EQU   RBGRS13
XRBREG12 EQU   RBGRS12
XRBREG11 EQU   RBGRS11
XRBREG10 EQU   RBGRS10
XRBREG9  EQU   RBGRS9
XRBREG8  EQU   RBGRS8
XRBREG7  EQU   RBGRS7
XRBREG6  EQU   RBGRS6
XRBREG5  EQU   RBGRS5
XRBREG4  EQU   RBGRS4
XRBREG3  EQU   RBGRS3
XRBREG2  EQU   RBGRS2
XRBREG1  EQU   RBGRS1
XRBREG0  EQU   RBGRS0
XRBLNKA  EQU   RBLINKB
XRBWT    EQU   RBWCF
@NM00037 EQU   RBBASIC+24
RBOPSWPS EQU   RBOPSWB2
@NM00036 EQU   RBOPSWB2
@NM00035 EQU   XRBPSW
@NM00034 EQU   RBBASIC+12
XRBWAIT  EQU   RBECBWT
XRBFRRB  EQU   RBFDYN
@NM00033 EQU   XSTAB2
XRBACTV  EQU   RBFACTV
XRBTCBP  EQU   RBTCBNXT
@NM00032 EQU   XSTAB1
XRBCKPT  EQU   RBFTCKPT
@NM00031 EQU   XSTAB1
@NM00030 EQU   RBBASIC+8
@NM00029 EQU   RBEXRTNM+1
RBTMIND3 EQU   RBTMFLD
RBTMIND2 EQU   RBTMFLD
RBTMCMP  EQU   RBTMFLD
RBWLIM   EQU   RBTMFLD
RBRSV005 EQU   RBTMFLD
RBTMTOD  EQU   RBTMFLD
RBTMQUE  EQU   RBTMFLD
@NM00028 EQU   RBPRFX
@NM00003 EQU   PCCA+512
PCCACAT  EQU   PCCA+384
PCCARV36 EQU   PCCA+380
PCCARV35 EQU   PCCA+378
PCCARV01 EQU   PCCA+377
PCCACPUM EQU   PCCA+376
PCCARV63 EQU   PCCA+372
PCCARV62 EQU   PCCA+368
PCCARV61 EQU   PCCA+364
PCCARV60 EQU   PCCA+360
PCCARV59 EQU   PCCA+356
PCCARV58 EQU   PCCA+352
PCCARV57 EQU   PCCA+348
PCCARV56 EQU   PCCA+344
PCCARV55 EQU   PCCA+340
PCCARV54 EQU   PCCA+336
PCCALOGA EQU   PCCA+332
PCCACHID EQU   PCCA+324
PCCACHSV EQU   PCCA+312
PCCARV79 EQU   PCCACHF4
PCCARV78 EQU   PCCACHF4
PCCARV77 EQU   PCCACHF4
PCCARV76 EQU   PCCACHF4
PCCARV75 EQU   PCCACHF4
PCCARV74 EQU   PCCACHF4
PCCARV73 EQU   PCCACHF4
PCCARV72 EQU   PCCACHF4
PCCARV71 EQU   PCCACHF3
PCCARV70 EQU   PCCACHF3
PCCARV69 EQU   PCCACHF3
PCCARV68 EQU   PCCACHF3
PCCARV67 EQU   PCCACHF3
PCCARV66 EQU   PCCACHF3
PCCARV65 EQU   PCCACHF3
PCCARV64 EQU   PCCACHF3
PCCACF28 EQU   PCCACHF2
PCCACF27 EQU   PCCACHF2
PCCACF26 EQU   PCCACHF2
PCCACF25 EQU   PCCACHF2
PCCACF24 EQU   PCCACHF2
PCCACF23 EQU   PCCACHF2
PCCACF22 EQU   PCCACHF2
PCCACF21 EQU   PCCACHF2
PCCACF18 EQU   PCCACHF1
PCCACF17 EQU   PCCACHF1
PCCACF16 EQU   PCCACHF1
PCCACF15 EQU   PCCACHF1
PCCACF14 EQU   PCCACHF1
PCCACF13 EQU   PCCACHF1
PCCACF12 EQU   PCCACHF1
PCCACF11 EQU   PCCACHF1
PCCARV05 EQU   PCCA+306
PCCACHPB EQU   PCCA+305
PCCALGP2 EQU   PCCA+304
PCCALGP1 EQU   PCCA+303
PCCALOGL EQU   PCCA+302
PCCARV80 EQU   PCCA+300
PCCACHW2 EQU   PCCA+296
PCCACHW1 EQU   PCCA+292
PCCAIOSI EQU   PCCA+291
PCCACNRB EQU   PCCACHRB
PCCACCVB EQU   PCCACHRB
PCCACSNB EQU   PCCACHRB
PCCARV52 EQU   PCCACHRB
PCCACHIB EQU   PCCACHRB
PCCACTIB EQU   PCCACHRB
PCCACINB EQU   PCCACHRB
PCCACSIB EQU   PCCACHRB
PCCARV51 EQU   PCCACHS2
PCCARV50 EQU   PCCACHS2
PCCACCRA EQU   PCCACHS2
PCCACURC EQU   PCCACHS2
PCCACNLG EQU   PCCACHS2
PCCACMOD EQU   PCCACHS2
PCCACALT EQU   PCCACHS2
PCCACIOR EQU   PCCACHS2
PCCARV47 EQU   PCCACHS1
PCCACUCB EQU   PCCACHS1
PCCACIBC EQU   PCCACHS1
PCCACAND EQU   PCCACHS1
PCCACNLS EQU   PCCACHS1
PCCACFRR EQU   PCCACHS1
PCCACNRE EQU   PCCACHS1
PCCACCMP EQU   PCCACHS1
PCCACSEQ EQU   PCCACHTS
PCCACDIN EQU   PCCACHTS
PCCARV44 EQU   PCCACHTS
PCCARV43 EQU   PCCACHTS
PCCACTEC EQU   PCCACHTS
PCCACDAV EQU   PCCACHVA
PCCACCHV EQU   PCCACHVA
PCCACCMD EQU   PCCACHVA
PCCACUNS EQU   PCCACHVA
PCCACSQV EQU   PCCACHVA
PCCARV42 EQU   PCCACHVA
PCCARV41 EQU   PCCACHVA
PCCACITF EQU   PCCACHVA
PCCARV40 EQU   PCCACHBL
PCCARV39 EQU   PCCACHBL
PCCARV38 EQU   PCCACHBL
PCCACCUE EQU   PCCACHBL
PCCACSTG EQU   PCCACHBL
PCCACSCU EQU   PCCACHBL
PCCACCHA EQU   PCCACHBL
PCCACCPU EQU   PCCACHBL
PCCACNOR EQU   PCCACHPF
PCCACCNT EQU   PCCACHPF
PCCACSNS EQU   PCCACHPF
PCCARV37 EQU   PCCACHPF
PCCACHIO EQU   PCCACHPF
PCCACTIO EQU   PCCACHPF
PCCACINT EQU   PCCACHPF
PCCACSIO EQU   PCCACHPF
PCCACHUB EQU   PCCAWERP
PCCACHEL EQU   PCCA+168
PCCALRBR EQU   PCCA+164
PCCALRBV EQU   PCCA+160
PCCAPWAR EQU   PCCA+156
PCCAPWAV EQU   PCCA+152
PCCAEMSA EQU   PCCAEMSB+12
PCCAEMSE EQU   PCCAEMSB+8
PCCAEMSP EQU   PCCAEMSB+4
PCCARMS  EQU   PCCARMSB
PCCARV34 EQU   PCCARMSB
PCCARV33 EQU   PCCARMSB
PCCARV32 EQU   PCCARMSB
PCCARV31 EQU   PCCARMSB
PCCARV30 EQU   PCCARMSB
PCCARV29 EQU   PCCARMSB
PCCARV28 EQU   PCCARMSB
PCCARV27 EQU   PCCAEMS3
PCCARV26 EQU   PCCAEMS3
PCCARV25 EQU   PCCAEMS3
PCCARV24 EQU   PCCAEMS3
PCCARV23 EQU   PCCAEMS3
PCCARV22 EQU   PCCAEMS3
PCCARV21 EQU   PCCAEMS3
PCCARV20 EQU   PCCAEMS3
PCCARV19 EQU   PCCAEMS2
PCCARV18 EQU   PCCAEMS2
PCCARV17 EQU   PCCAEMS2
PCCARV16 EQU   PCCAEMS2
PCCARV15 EQU   PCCAEMS2
PCCARV14 EQU   PCCAEMS2
PCCARV13 EQU   PCCAEMS2
PCCARV12 EQU   PCCAEMS2
PCCARV11 EQU   PCCARISP
PCCARV10 EQU   PCCARISP
PCCARV09 EQU   PCCARISP
PCCARV08 EQU   PCCARISP
PCCARV07 EQU   PCCARISP
PCCARV06 EQU   PCCARISP
PCCASERL EQU   PCCARISP
PCCAPARL EQU   PCCARISP
PCCARPB  EQU   PCCA+132
PCCACTIN EQU   PCCAINTE
PCCANFIN EQU   PCCAINTE
PCCANUIN EQU   PCCAINTE
PCCACTCC EQU   PCCACCE
PCCANFCC EQU   PCCACCE
PCCANUCC EQU   PCCACCE
PCCACTTD EQU   PCCATODE
PCCANFTD EQU   PCCATODE
PCCARV04 EQU   PCCATMFL
PCCARV03 EQU   PCCATMFL
PCCARV02 EQU   PCCATMFL
PCCAMINT EQU   PCCATMFL
PCCAMCC  EQU   PCCATMFL
PCCAVKIL EQU   PCCATMFL
PCCASYNC EQU   PCCATMFL
PCCAINIT EQU   PCCATMFL
PCCARV9E EQU   PCCA+124
PCCARV9D EQU   PCCA+120
PCCARV9C EQU   PCCA+116
PCCARV9B EQU   PCCA+112
PCCARV9A EQU   PCCA+108
PCCARV99 EQU   PCCA+104
PCCARV98 EQU   PCCA+100
PCCARV97 EQU   PCCA+96
PCCARV96 EQU   PCCA+92
PCCARV95 EQU   PCCA+88
PCCARV94 EQU   PCCA+84
PCCARV93 EQU   PCCA+80
PCCARV92 EQU   PCCA+76
PCCARV91 EQU   PCCA+72
PCCARV90 EQU   PCCA+68
PCCARV89 EQU   PCCA+64
PCCARV88 EQU   PCCA+60
PCCARV87 EQU   PCCA+56
PCCARV86 EQU   PCCA+52
PCCARV85 EQU   PCCA+48
PCCARV84 EQU   PCCA+44
PCCARV83 EQU   PCCA+40
PCCARV82 EQU   PCCA+36
PCCARV81 EQU   PCCA+32
PCCAPSAR EQU   PCCA+28
PCCAPSAV EQU   PCCA+24
PCCATQEP EQU   PCCA+20
PCCACAFM EQU   PCCA+18
PCCACPUA EQU   PCCA+16
PCCACPID EQU   PCCA+4
PCCAPCCA EQU   PCCA
CVTLEVL  EQU   CVTRELNO+2
CVTNUMB  EQU   CVTRELNO
CVTMDL   EQU   CVTFIX+250
@NM00002 EQU   CVTFIX+248
@NM00001 EQU   CVTFIX
CVTRV482 EQU   CVTXTNT2+128
CVTRV481 EQU   CVTXTNT2+124
CVTRV480 EQU   CVTXTNT2+120
CVTRV479 EQU   CVTXTNT2+118
CVTRV478 EQU   CVTXTNT2+117
CVTRV477 EQU   CVTXTNT2+116
CVTRV476 EQU   CVTXTNT2+115
CVTRV475 EQU   CVTXTNT2+114
CVTRV474 EQU   CVTRV466
CVTRV473 EQU   CVTRV466
CVTRV472 EQU   CVTRV466
CVTRV471 EQU   CVTRV466
CVTRV470 EQU   CVTRV466
CVTRV469 EQU   CVTRV466
CVTRV468 EQU   CVTRV466
CVTRV467 EQU   CVTRV466
CVTRV465 EQU   CVTRV457
CVTRV464 EQU   CVTRV457
CVTRV463 EQU   CVTRV457
CVTRV462 EQU   CVTRV457
CVTRV461 EQU   CVTRV457
CVTRV460 EQU   CVTRV457
CVTRV459 EQU   CVTRV457
CVTRV458 EQU   CVTRV457
CVTRV456 EQU   CVTXTNT2+108
CVTRV455 EQU   CVTXTNT2+104
CVTRV454 EQU   CVTXTNT2+100
CVTRV453 EQU   CVTXTNT2+96
CVTRV452 EQU   CVTXTNT2+94
CVTRV451 EQU   CVTXTNT2+92
CVTRV450 EQU   CVTXTNT2+90
CVTRV449 EQU   CVTXTNT2+88
CVTRV448 EQU   CVTXTNT2+87
CVTRV447 EQU   CVTXTNT2+86
CVTRV446 EQU   CVTRV438
CVTRV445 EQU   CVTRV438
CVTRV444 EQU   CVTRV438
CVTRV443 EQU   CVTRV438
CVTRV442 EQU   CVTRV438
CVTRV441 EQU   CVTRV438
CVTRV440 EQU   CVTRV438
CVTRV439 EQU   CVTRV438
CVTRV437 EQU   CVTRV429
CVTRV436 EQU   CVTRV429
CVTRV435 EQU   CVTRV429
CVTRV434 EQU   CVTRV429
CVTRV433 EQU   CVTRV429
CVTRV432 EQU   CVTRV429
CVTRV431 EQU   CVTRV429
CVTRV430 EQU   CVTRV429
CVTRV428 EQU   CVTXTNT2+80
CVTRV427 EQU   CVTXTNT2+76
CVTRV426 EQU   CVTXTNT2+72
CVTRV425 EQU   CVTXTNT2+68
CVTATACT EQU   CVTATCVT
CVTRV423 EQU   CVTXTNT2+62
CVTRV422 EQU   CVTXTNT2+60
CVTRV421 EQU   CVTXTNT2+58
CVTRV420 EQU   CVTXTNT2+56
CVTRV419 EQU   CVTXTNT2+55
CVTRV418 EQU   CVTXTNT2+54
CVTRV417 EQU   CVTRV409
CVTRV416 EQU   CVTRV409
CVTRV415 EQU   CVTRV409
CVTRV414 EQU   CVTRV409
CVTRV413 EQU   CVTRV409
CVTRV412 EQU   CVTRV409
CVTRV411 EQU   CVTRV409
CVTRV410 EQU   CVTRV409
CVTRV408 EQU   CVTRV400
CVTRV407 EQU   CVTRV400
CVTRV406 EQU   CVTRV400
CVTRV405 EQU   CVTRV400
CVTRV404 EQU   CVTRV400
CVTRV403 EQU   CVTRV400
CVTRV402 EQU   CVTRV400
CVTRV401 EQU   CVTRV400
CVTICB   EQU   CVTXTNT2+48
CVTSKTA  EQU   CVTXTNT2+44
CVTRSV99 EQU   CVTXTNT2+40
CVTRSV98 EQU   CVTXTNT2+36
CVTRSV97 EQU   CVTXTNT2+34
CVTRSV96 EQU   CVTXTNT2+32
CVTOLTEP EQU   CVTXTNT2+28
CVTQIDA  EQU   CVTQID+1
CVTRSV95 EQU   CVTQID
CVTRSV94 EQU   CVTXTNT2+20
CVTRSV93 EQU   CVTXTNT2+16
CVTRSV92 EQU   CVTXTNT2+12
CVTDEBVR EQU   CVTXTNT2+8
CVTRSV91 EQU   CVTXTNT2+6
CVTRSV9H EQU   CVTFLGBT
CVTRSV9G EQU   CVTFLGBT
CVTRSV9F EQU   CVTFLGBT
CVTRSV9E EQU   CVTFLGBT
CVTRSV9D EQU   CVTFLGBT
CVTRSV9C EQU   CVTFLGBT
CVTVME   EQU   CVTFLGBT
CVTNPE   EQU   CVTFLGBT
CVTNUCLS EQU   CVTXTNT2+4
CVTDSSVA EQU   CVTDSSV+1
CVTRSV89 EQU   CVTDSSV
CVTRSV88 EQU   CVTXTNT1+8
CVTRSV87 EQU   CVTXTNT1+4
CVTFACHN EQU   CVTXTNT1
CVTRV488 EQU   CVTMAP+412
CVTRV487 EQU   CVTMAP+408
CVTRV486 EQU   CVTMAP+404
CVTRV485 EQU   CVTMAP+400
CVTACTAP EQU   CVTMAP+396
CVTAUTH  EQU   CVTMAP+392
CVTATMCA EQU   CVTATMCT+1
CVTATMST EQU   CVTATMCT
CVTRSV61 EQU   CVTMAP+384
CVTVOLT1 EQU   CVTVOLM1+1
CVTVOLI1 EQU   CVTVOLF1
CVTSTOA  EQU   CVTMAP+376
CVTRSV58 EQU   CVTMAP+374
CVTRSV57 EQU   CVTMAP+372
CVTDDCE  EQU   CVTMAP+368
CVTPNWFR EQU   CVTMAP+364
CVTSMF   EQU   CVTMAP+360
CVTSULK  EQU   CVTMAP+358
CVTSLKO  EQU   CVTSYSK
CVTSLKP  EQU   CVTSYSK
CVTSLKQ  EQU   CVTSYSK
CVTSLKR  EQU   CVTSYSK
CVTRSV56 EQU   CVTSYSK
CVTRSV55 EQU   CVTSYSK
CVTRSV54 EQU   CVTSYSK
CVTRSV53 EQU   CVTSYSK
CVTRSV52 EQU   CVTA1F1
CVTRSV51 EQU   CVTA1F1
CVTRSV50 EQU   CVTA1F1
CVTRSV49 EQU   CVTA1F1
CVTRSV48 EQU   CVTA1F1
CVTRSV47 EQU   CVTA1F1
CVTSRSW  EQU   CVTA1F1
CVTPFSW  EQU   CVTA1F1
CVTPCVT  EQU   CVTMAP+352
CVTRSV46 EQU   CVTMAP+344
CVTRSV45 EQU   CVTMAP+340
CVTRSV44 EQU   CVTMAP+338
CVTRSV43 EQU   CVTMAP+336
CVTHJESA EQU   CVTHJES+1
CVTRSV42 EQU   CVTHJES
CVTEXT2A EQU   CVTEXT2+1
CVTRSV41 EQU   CVTEXT2
CVTAPFA  EQU   CVTAPF+1
CVTRSV40 EQU   CVTAPF
CVTRV518 EQU   CVTINTLA
CVTRV517 EQU   CVTERPV
CVTEORM  EQU   CVTMAP+312
CVTMCHPR EQU   CVTMAP+308
CVTTZ    EQU   CVTMAP+304
CVTJEPS  EQU   CVTMAP+300
CVTJESCT EQU   CVTMAP+296
CVTMODE  EQU   CVTMAP+292
CVTPTRV  EQU   CVTMAP+288
CVTREAL  EQU   CVTMAP+284
CVTRSV39 EQU   CVTMAP+280
CVTRSV38 EQU   CVTMAP+276
CVTDMSRA EQU   CVTDMSR+1
CVTRV634 EQU   CVTDMSRF
CVTRV633 EQU   CVTDMSRF
CVTRV632 EQU   CVTDMSRF
CVTRV631 EQU   CVTDMSRF
CVTRV630 EQU   CVTDMSRF
CVTRV629 EQU   CVTDMSRF
CVTUDUMP EQU   CVTDMSRF
CVTSDUMP EQU   CVTDMSRF
CVTQMSGA EQU   CVTQMSG+1
CVTRSV36 EQU   CVTQMSG
CVTAMFF  EQU   CVTMAP+264
CVTPURGA EQU   CVTPURG+1
CVTRSV35 EQU   CVTPURG
CVTCBSP  EQU   CVTMAP+256
CVTATERA EQU   CVTATER+1
CVTSYST  EQU   CVTATER
CVTVOLT2 EQU   CVTTAT
CVTVOLI2 EQU   CVTVOLF2
CVTAQAVB EQU   CVTAQAVT+1
CVTRSV34 EQU   CVTTCMFG
CVTRSV33 EQU   CVTTCMFG
CVTRSV32 EQU   CVTTCMFG
CVTRSV31 EQU   CVTTCMFG
CVTRSV30 EQU   CVTTCMFG
CVTRSV29 EQU   CVTTCMFG
CVTRSV28 EQU   CVTTCMFG
CVTTCRDY EQU   CVTTCMFG
CVTGTFA  EQU   CVTGTF+1
CVTRSV27 EQU   CVTGTFST
CVTRNIO  EQU   CVTGTFST
CVTUSR   EQU   CVTGTFST
CVTRV318 EQU   CVTFORM
CVTRV317 EQU   CVTTMODE
CVTRV316 EQU   CVTSTATE
CVTRV315 EQU   CVTGTFS
CVTGTFAV EQU   CVTGTFS
CVT0SCR1 EQU   CVTMAP+232
CVTRV515 EQU   CVTMAP+228
CVTRMS   EQU   CVTMAP+224
CVTPATCH EQU   CVTMAP+220
CVTTSCE  EQU   CVTMAP+216
CVTLNKSC EQU   CVTMAP+214
CVTQABST EQU   CVTMAP+212
CVTMDLDS EQU   CVTMAP+208
CVTUSER  EQU   CVTMAP+204
CVTSMCA  EQU   CVTMAP+196
CVTRSV18 EQU   CVTMAP+192
CVTQLPAQ EQU   CVTMAP+188
CVTQCDSR EQU   CVTMAP+184
CVTRSV17 EQU   CVTOPTB
CVTRSV16 EQU   CVTOPTB
CVTFP    EQU   CVTOPTB
CVTAPTHR EQU   CVTOPTB
CVTNLOG  EQU   CVTOPTB
CVTTOD   EQU   CVTOPTB
CVTCTIMS EQU   CVTOPTB
CVTPROT  EQU   CVTOPTB
CVTXPFP  EQU   CVTOPTA
CVTASCII EQU   CVTOPTA
CVTRSV13 EQU   CVTOPTA
CVTRSV12 EQU   CVTOPTA
CVTNIP   EQU   CVTOPTA
CVTDDR   EQU   CVTOPTA
CVTAPR   EQU   CVTOPTA
CVTCCH   EQU   CVTOPTA
CVTSNCTR EQU   CVTMAP+180
CVTQMWR  EQU   CVTMAP+176
CVTQOCR  EQU   CVTMAP+172
CVT1EF00 EQU   CVTMAP+168
CVTMZ00  EQU   CVTMAP+164
CVTHEAD  EQU   CVTMAP+160
CVTRSV11 EQU   CVTMAP+156
CVT0PT01 EQU   CVTMAP+152
CVTMSER  EQU   CVTMAP+148
CVTRV516 EQU   CVTIERLC
CVTILCH  EQU   CVTMAP+140
CVT0DS   EQU   CVTMAP+136
CVTFBOSV EQU   CVTMAP+132
CVTNUCB  EQU   CVTMAP+128
CVTIXAVL EQU   CVTMAP+124
CVTIOQET EQU   CVTMAP+120
CVTDCBA  EQU   CVTMAP+117
CVTMVS2  EQU   CVTDCB
CVT6DAT  EQU   CVTDCB
CVT4MPS  EQU   CVTDCB
CVTRSV09 EQU   CVTDCB
CVT4MS1  EQU   CVTDCB
CVT2SPS  EQU   CVTDCB
CVT1SSS  EQU   CVTDCB
CVTRSV08 EQU   CVTDCB
CVTSTB   EQU   CVTMAP+112
CVTQTD00 EQU   CVTMAP+108
CVTQTE00 EQU   CVTMAP+104
CVTCUCB  EQU   CVTMAP+100
CVTSJQ   EQU   CVTMAP+96
CVTPBLDL EQU   CVTMAP+92
CVTTPC   EQU   CVTMAP+88
CVTSVDCB EQU   CVTMAP+84
CVTBRET  EQU   CVTMAP+82
CVTEXIT  EQU   CVTMAP+80
CVT0FN00 EQU   CVTMAP+76
CVTDARA  EQU   CVTDAR+1
CVTRSV07 EQU   CVTFLGS1
CVTRSV06 EQU   CVTFLGS1
CVTRSV05 EQU   CVTFLGS1
CVTRSV04 EQU   CVTFLGS1
CVTRSV03 EQU   CVTFLGS1
CVTRSV02 EQU   CVTFLGS1
CVTRSV01 EQU   CVTFLGS1
CVTDMPLK EQU   CVTFLGS1
CVTXITP  EQU   CVTMAP+68
CVTZDTAB EQU   CVTMAP+64
CVTMSLT  EQU   CVTMAP+60
CVTDATE  EQU   CVTMAP+56
CVTBTERM EQU   CVTMAP+52
CVTSYSAD EQU   CVTMAP+48
CVTXTLER EQU   CVTMAP+44
CVTILK2  EQU   CVTMAP+40
CVTILK1  EQU   CVTMAP+36
CVTPRLTV EQU   CVTMAP+32
CVTPCNVT EQU   CVTMAP+28
CVT0VL00 EQU   CVTMAP+24
CVTXAPG  EQU   CVTMAP+20
CVTBUF   EQU   CVTMAP+16
CVTJOB   EQU   CVTMAP+12
CVTLINK  EQU   CVTMAP+8
CVT0EF00 EQU   CVTMAP+4
CVTTCBP  EQU   CVTMAP
CVT      EQU   CVTMAP
ASXBEND  EQU   ASXB+232
ASXBRV25 EQU   ASXB+228
ASXBRV24 EQU   ASXB+224
ASXBPT0E EQU   ASXB+220
ASXBCRB4 EQU   ASXBCASW+3
ASXBCRB3 EQU   ASXBCASW+2
ASXBCRB2 EQU   ASXBCASW+1
ASXBCR06 EQU   ASXBCRB1
ASXBCR05 EQU   ASXBCRB1
ASXBCR04 EQU   ASXBCRB1
ASXBCR03 EQU   ASXBCRB1
ASXBCR02 EQU   ASXBCRB1
ASXBCR01 EQU   ASXBCRB1
ASXBTFD  EQU   ASXBCRB1
ASXBPIP  EQU   ASXBCRB1
ASXBCTDC EQU   ASXB+212
ASXBTDCB EQU   ASXB+208
ASXBRV19 EQU   ASXB+204
ASXBSENV EQU   ASXBSECR+1
ASXBRV34 EQU   ASCBSFLG
ASXBRV33 EQU   ASCBSFLG
ASXBRV32 EQU   ASCBSFLG
ASXBRV31 EQU   ASCBSFLG
ASXBRV30 EQU   ASCBSFLG
ASXBRV29 EQU   ASCBSFLG
ASXBRV28 EQU   ASCBSFLG
ASXBRV27 EQU   ASCBSFLG
ASXBUSER EQU   ASXB+192
ASXBLSRB EQU   ASXBAEQ+20
ASXBFSRB EQU   ASXBAEQ+16
ASXBLRQE EQU   ASXBAEQ+12
ASXBFRQE EQU   ASXBAEQ+8
ASXBLIQE EQU   ASXBAEQ+4
ASXBFIQE EQU   ASXBAEQ
ASXBETSK EQU   ASXB+164
ASXBSIRB EQU   ASXB+160
ASXBPSWD EQU   ASXB+152
ASXBPRG  EQU   ASXB+136
ASXBRV26 EQU   ASXB+132
ASXBOUSB EQU   ASXB+128
ASXBDDR  EQU   ASXB+124
ASXBRSMD EQU   ASXB+116
ASXBSPSA EQU   ASXB+112
ASXBFRWA EQU   ASXB+108
ASXBFLSA EQU   ASXB+36
ASXBIHSA EQU   ASXB+32
ASXBRV15 EQU   ASXB+28
ASXBRV14 EQU   ASXB+24
ASXBLWA  EQU   ASXB+20
ASXBMPST EQU   ASXB+16
ASXBRS00 EQU   ASXB+14
ASXBTCBS EQU   ASXB+12
ASXBLTCB EQU   ASXB+8
ASXBASXB EQU   ASXB
ASXBEGIN EQU   ASXB
ASCBEND  EQU   ASCB+208
ASCBSRBT EQU   ASCB+200
ASCBSWTL EQU   ASCB+196
ASCBRS14 EQU   ASCB+195
ASCBSMCT EQU   ASCB+194
ASCBRS12 EQU   ASCB+192
ASCBPCTT EQU   ASCB+188
ASCBVGTT EQU   ASCB+184
ASCBLGCB EQU   ASCB+180
ASCBJBNS EQU   ASCB+176
ASCBJBNI EQU   ASCB+172
ASCBMCC  EQU   ASCB+168
ASCBRTWA EQU   ASCB+164
ASCBIQEA EQU   ASCB+160
ASCBXMPQ EQU   ASCB+156
ASCBRS01 EQU   ASCB+154
ASCBFMCT EQU   ASCB+152
ASCBOUXB EQU   ASCB+148
ASCBOUCB EQU   ASCB+144
ASCBMECB EQU   ASCB+140
ASCBQECB EQU   ASCB+136
ASCBCMSB EQU   ASCB+132
ASCBCMSF EQU   ASCB+128
ASCBTCBS EQU   ASCB+124
ASCBNVSC EQU   ASCB+122
ASCBVSC  EQU   ASCB+120
ASCBSSRB EQU   ASCB+116
ASCBRV06 EQU   ASCBFLG2
ASCBRV05 EQU   ASCBFLG2
ASCBRV04 EQU   ASCBFLG2
ASCBSNQS EQU   ASCBFLG2
ASCBCEXT EQU   ASCBFLG2
ASCBPXMT EQU   ASCBFLG2
ASCBXMPT EQU   ASCBFLG2
ASCBRF07 EQU   ASCBDSP1
ASCBRF06 EQU   ASCBDSP1
ASCBRF05 EQU   ASCBDSP1
ASCBRF04 EQU   ASCBDSP1
ASCBRF03 EQU   ASCBDSP1
ASCBRF02 EQU   ASCBDSP1
ASCBFAIL EQU   ASCBDSP1
ASCBNOQ  EQU   ASCBDSP1
ASCBSWCT EQU   ASCB+112
ASCBTMCH EQU   ASCB+104
ASCBNSWP EQU   ASCBFLG1
ASCBTYP1 EQU   ASCBFLG1
ASCBSTND EQU   ASCBFLG1
ASCBABNT EQU   ASCBFLG1
ASCBTERM EQU   ASCBFLG1
ASCBS3S  EQU   ASCBFLG1
ASCBCMSH EQU   ASCBFLG1
ASCBTOFF EQU   ASCBFLG1
ASCBRF01 EQU   ASCBRCTF
ASCBTMLW EQU   ASCBRCTF
ASCBOUT  EQU   ASCBRCTF
ASCBRV08 EQU   ASCBRCTF
ASCBFQU  EQU   ASCBRCTF
ASCBFRS  EQU   ASCBRCTF
ASCBTMNO EQU   ASCBRCTF
ASCBDUMP EQU   ASCB+96
ASCBQSVC EQU   ASCB+92
ASCBECB  EQU   ASCB+84
ASCBJSTL EQU   ASCB+80
ASCBEJST EQU   ASCB+64
ASCBCSCB EQU   ASCB+56
ASCBRSM  EQU   ASCB+52
ASCBLDA  EQU   ASCB+48
ASCBSTOR EQU   ASCB+44
ASCBDP   EQU   ASCB+43
ASCBRV07 EQU   ASCB+42
ASCBIOSM EQU   ASCB+40
ASCBSEQN EQU   ASCB+38
ASCBASID EQU   ASCB+36
ASCBCPUS EQU   ASCB+32
ASCBLSLQ EQU   ASCB+24
ASCBFSLQ EQU   ASCB+20
ASCBIOSP EQU   ASCB+16
ASCBLOCK EQU   ASCB+12
ASCBBWDP EQU   ASCB+8
ASCBFWDP EQU   ASCB+4
ASCBASCB EQU   ASCB
ASCBEGIN EQU   ASCB
@NM00027 EQU   PSA+3668
PSASTAK  EQU   PSA+3072
@NM00026 EQU   PSA+1048
PSAUSEND EQU   PSA+1048
PSARV062 EQU   PSA+1044
PSACDAL  EQU   PSA+1040
PSAWTCOD EQU   PSA+1036
PSAATCVT EQU   PSA+1032
PSAPCPSW EQU   PSA+1024
PSAPIR2  EQU   PSA+1020
PSARV059 EQU   PSA+1018
PSASVC13 EQU   PSA+1016
PSALSFCC EQU   PSA+1012
PSASFACC EQU   PSA+1008
PSASTOP  EQU   PSA+992
PSASTART EQU   PSA+976
PSARSPSW EQU   PSA+968
PSASRPSW EQU   PSA+960
PSARV045 EQU   PSA+892
PSARV044 EQU   PSA+888
PSARV043 EQU   PSA+884
PSARV042 EQU   PSA+880
PSARV041 EQU   PSA+876
PSARV040 EQU   PSA+872
PSARV025 EQU   PSA+868
PSADSSED EQU   PSA+868
PSADSSPR EQU   PSA+864
PSADSSFW EQU   PSA+860
PSADSS14 EQU   PSA+856
PSADSSPP EQU   PSA+848
PSADSSRP EQU   PSA+840
PSADSS05 EQU   PSADSSF4
PSADSS10 EQU   PSADSSF4
PSADSSVE EQU   PSADSSF4
PSADSSDE EQU   PSADSSF4
PSADSSC0 EQU   PSADSSF4
PSADSSIE EQU   PSADSSF4
PSADSS12 EQU   PSADSSF4
PSADSSRC EQU   PSADSSF4
PSARV057 EQU   PSADSSF3
PSARV056 EQU   PSADSSF3
PSARV055 EQU   PSADSSF3
PSADSSMC EQU   PSADSSF3
PSADSSRW EQU   PSADSSF3
PSADSSNM EQU   PSADSSF3
PSADSSES EQU   PSADSSF3
PSADSSGP EQU   PSADSSF3
PSADSSF2 EQU   PSADSSFL+1
PSADSSPI EQU   PSADSSF1
PSADSSOI EQU   PSADSSF1
PSADSSSP EQU   PSADSSF1
PSADSSTP EQU   PSADSSF1
PSADSSDW EQU   PSADSSF1
PSADSSDD EQU   PSADSSF1
PSADSSDM EQU   PSADSSF1
PSADSSMV EQU   PSADSSF1
PSADSSTS EQU   PSA+816
PSADSSWK EQU   PSA+812
PSADSSR3 EQU   PSA+808
PSADSSR2 EQU   PSA+804
PSADSSRS EQU   PSA+800
PSASTOR  EQU   PSA+796
PSACPUSA EQU   PSA+794
PSAVSTAP EQU   PSA+792
PSAWKVAP EQU   PSA+788
PSAWKRAP EQU   PSA+784
PSAMCHIC EQU   PSA+783
PSARV061 EQU   PSA+782
PSASYMSK EQU   PSA+781
PSAMCHFL EQU   PSA+780
PSACR0   EQU   PSA+776
PSAPSWSV EQU   PSA+768
PSALITA  EQU   PSA+764
PSACLHS  EQU   PSAHLHI
PSALKR15 EQU   PSALKSA+60
PSALKR14 EQU   PSALKSA+56
PSALKR13 EQU   PSALKSA+52
PSALKR12 EQU   PSALKSA+48
PSALKR11 EQU   PSALKSA+44
PSALKR10 EQU   PSALKSA+40
PSALKR9  EQU   PSALKSA+36
PSALKR8  EQU   PSALKSA+32
PSALKR7  EQU   PSALKSA+28
PSALKR6  EQU   PSALKSA+24
PSALKR5  EQU   PSALKSA+20
PSALKR4  EQU   PSALKSA+16
PSALKR3  EQU   PSALKSA+12
PSALKR2  EQU   PSALKSA+8
PSALKR1  EQU   PSALKSA+4
PSALKR0  EQU   PSALKSA
PSARV023 EQU   PSACLHT+52
PSALOCAL EQU   PSACLHT+48
PSACMSL  EQU   PSACLHT+44
PSAOPTL  EQU   PSACLHT+40
PSATPACL EQU   PSACLHT+36
PSATPDNL EQU   PSACLHT+32
PSATPNCL EQU   PSACLHT+28
PSAIOSLL EQU   PSACLHT+24
PSAIOSUL EQU   PSACLHT+20
PSAIOSCL EQU   PSACLHT+16
PSAIOSSL EQU   PSACLHT+12
PSASALCL EQU   PSACLHT+8
PSAASML  EQU   PSACLHT+4
PSADISPL EQU   PSACLHT
PSASRSA  EQU   PSA+636
PSARV050 EQU   PSA+634
PSADSSGO EQU   PSA+633
PSARECUR EQU   PSA+632
PSAHLHIS EQU   PSA+628
PSAIPCSA EQU   PSA+624
@NM00025 EQU   PSA+621
PSAIPCDM EQU   PSA+620
PSAIPCD  EQU   PSA+616
@NM00024 EQU   PSA+613
PSAIPCRM EQU   PSA+612
PSAIPCR  EQU   PSA+608
PSAMCHEX EQU   PSA+600
PSAMPSW  EQU   PSA+592
PSAEXPS2 EQU   PSA+584
PSAEXPS1 EQU   PSA+576
PSAPIREG EQU   PSA+572
PSARSREG EQU   PSA+568
PSAGPREG EQU   PSA+556
PSARV022 EQU   PSASUP4
PSARV021 EQU   PSASUP4
PSARV020 EQU   PSASUP4
PSARV019 EQU   PSASUP4
PSARV018 EQU   PSASUP4
PSARV017 EQU   PSASUP4
PSARV016 EQU   PSASUP4
PSARV015 EQU   PSASUP4
PSARV014 EQU   PSASUP3
PSARV013 EQU   PSASUP3
PSARV012 EQU   PSASUP3
PSAESTA  EQU   PSASUP3
PSASPR   EQU   PSASUP3
PSAPSREG EQU   PSASUP3
PSAPI2   EQU   PSASUP3
PSAIOSUP EQU   PSASUP3
PSALCR   EQU   PSASUP2
PSARTM   EQU   PSASUP2
PSAACR   EQU   PSASUP2
PSAIPCE2 EQU   PSASUP2
PSAIPCES EQU   PSASUP2
PSAIPCEC EQU   PSASUP2
PSAGTF   EQU   PSASUP2
PSAIPCRI EQU   PSASUP2
PSATYPE6 EQU   PSASUP1
PSATCTL  EQU   PSASUP1
PSADISP  EQU   PSASUP1
PSALOCK  EQU   PSASUP1
PSAPI    EQU   PSASUP1
PSAEXT   EQU   PSASUP1
PSASVC   EQU   PSASUP1
PSAIO    EQU   PSASUP1
PSAANEW  EQU   PSA+544
PSATOLD  EQU   PSA+540
PSATNEW  EQU   PSA+536
PSALCCAR EQU   PSA+532
PSALCCAV EQU   PSA+528
PSAPCCAR EQU   PSA+524
PSACPULA EQU   PSA+518
PSACPUPA EQU   PSA+516
PSAPSA   EQU   PSA+512
FLCHDEND EQU   PSA+512
FLCCRSAV EQU   FLCMCLA+280
FLCGRSAV EQU   FLCMCLA+216
FLCFPSAV EQU   FLCMCLA+184
FLCFLA   EQU   FLCMCLA+88
FLCRGNCD EQU   FLCMCLA+84
FLCFSAA  EQU   FLCFSA+1
@NM00023 EQU   FLCFSA
@NM00022 EQU   FLCMCLA+72
FLCMCIC  EQU   FLCMCLA+64
@NM00021 EQU   FLCMCLA+20
FLCIOAA  EQU   FLCIOA+1
@NM00020 EQU   FLCIOA
@NM00019 EQU   FLCMCLA+15
@NM00018 EQU   FLCMCLA+14
@NM00017 EQU   FLCMCLA+12
FLCLCL   EQU   FLCMCLA+8
FLCIOELA EQU   FLCIOEL+1
@NM00016 EQU   FLCIOEL
FLCCHNID EQU   FLCMCLA
@NM00015 EQU   PSA+160
FLCMTRCD EQU   PSA+157
@NM00014 EQU   PSA+156
FLCPERA  EQU   FLCPER+1
@NM00013 EQU   FLCPER
@NM00012 EQU   PSA+151
FLCPERCD EQU   PSA+150
FLCMCNUM EQU   PSA+149
@NM00011 EQU   PSA+148
FLCTEAA  EQU   FLCTEA+1
@NM00010 EQU   FLCTEA
PSAPIPC  EQU   PSAPICOD
PSAPIMC  EQU   PSAPICOD
PSAPIPER EQU   PSAPICOD
PSARV049 EQU   FLCPICOD
FLCPILCB EQU   FLCPIILC
@NM00009 EQU   FLCPIILC
@NM00008 EQU   PSAEPPSW
FLCSVCN  EQU   PSAESPSW+2
FLCSILCB EQU   FLCSVILC
@NM00007 EQU   FLCSVILC
@NM00006 EQU   PSAESPSW
FLCEICOD EQU   PSAEEPSW+2
PSASPAD  EQU   PSAEEPSW
@NM00005 EQU   PSA+128
FLCINPSW EQU   PSA+120
FLCMNPSW EQU   PSA+112
FLCPNPSW EQU   PSA+104
FLCSNPSW EQU   PSA+96
FLCENPSW EQU   PSA+88
FLCTRACE EQU   PSA+84
FLCTIMER EQU   PSA+80
FLCCVT2  EQU   PSA+76
FLCCAW   EQU   PSA+72
FLCCSW   EQU   PSA+64
FLCIOPSW EQU   PSA+56
FLCMOPSW EQU   PSA+48
FLCPOPSW EQU   PSA+40
FLCSOPSW EQU   PSA+32
FLCEOPSW EQU   PSA+24
@NM00004 EQU   FLCICCW2+4
FLCCVT   EQU   FLCICCW2
FLCICCW1 EQU   FLCROPSW
FLCIPPSW EQU   FLCRNPSW
*                                      END UNREFERENCED COMPONENTS
R03EXIT  EQU   @EL00001
@RT00203 EQU   @EL00005
FR3EXIT  EQU   @EL00006
@ENDDATA EQU   *
         END   IEAVAR03,(C'PLS1718',0701,76264)
