         TITLE 'IEAVAR04 - ATTENTION EXIT SCHEDULER ROUTINE            *
                        '
IEAVAR04 CSECT ,                                                   0001
@MAINENT DS    0H                                                  0001
         USING *,@15                                               0001
         B     @PROLOG                                             0001
         DC    AL1(16)                                             0001
         DC    C'IEAVAR04  76.030'                                 0001
         DROP  @15
@PROLOG  STM   @14,@12,12(@13)                                     0001
         BALR  @08,0                                               0001
@PSTART  DS    0H                                                  0001
         USING @PSTART,@08                                         0001
RBPRFXLN EQU 64
RBPRFLNA EQU 32
PRBLEN   EQU 136
SIRBLEN  EQU 200
TIRBLEN  EQU 136
IRBLEN   EQU 128
SVRBLEN  EQU 200
DECREG   DS    0H                                                  0051
*                                                                  0097
*/********************************************************************/
*/*                                                                  */
*/*  START  OF EXECUTABLE CODE                                       */
*/*                                                                  */
*/********************************************************************/
*                                                                  0097
*   RCTDRCTR='08000000'X;           /* SET MODULE FLAG(RCTDATTN)   0097
*                                      WHILE RESETTING ALL OTHER   0097
*                                      FLAGS IN THE RCTDRCTR         */
         L     @15,ASXBRCTD(,ASXBPTR)                              0097
         MVC   RCTDRCTR(4,@15),@CB02427                            0097
*/********************************************************************/
*/*                                                                  */
*/*  THE FOLLOWING SEGMENT WILL OBTAIN THE LOCAL LOCK                */
*/*  UNCONDITIONALLY. IF A NON-ZERO RETURN CODE IS RETURNED          */
*/*  AN ABEND WILL BE ISSUED. THE ABEND WILL BE PROCESSED            */
*/*  BY RCT'S ESTAE ROUTINE.                                         */
*/*                                                                  */
*/********************************************************************/
*                                                                  0098
*   RESPECIFY                                                      0098
*     SETLK11 RESTRICTED;           /* REGISTERS 11,12,13            */
*   RESPECIFY                                                      0099
*     SETLK12 RESTRICTED;           /* AND 14 ARE USED BY            */
*   RESPECIFY                                                      0100
*     SETLK13 RESTRICTED;           /* THE SETLOCK MACRO.            */
*   RESPECIFY                                                      0101
*     SETLK14 RESTRICTED;           /* SETLOCK DOES NOT SAVE THE   0101
*                                      REGISTERS                     */
*SETLKO1:                                                          0102
*   GENERATE CODE NOSETS NOFLOWS NODEFS REFS(PSALITA);             0102
SETLKO1  DS    0H                                                  0102
        SETLOCK  OBTAIN,TYPE=LOCAL,MODE=UNCOND,                        X
               RELATED=(TAXE-TCB-QUEUE,IEAVAR04(SETLKR1))
*   IF SETLK13^=ZERO THEN           /* WAS SETLOCK SUCCESSFUL        */
         LTR   SETLK13,SETLK13                                     0103
         BZ    @RF00103                                            0103
*     DO;                                                          0104
*R04ABEND:                                                         0105
*       RCTDRC=SETLK13;             /* SAVE THE RETURN CODE FROM   0105
*                                      SETLOCK FOR LOGREC            */
R04ABEND L     @15,ASXBRCTD(,ASXBPTR)                              0105
         ST    SETLK13,RCTDRC(,@15)                                0105
*       GENERATE CODE NOFLOWS NOREFS NODEFS NOSETS;                0106
                 ABEND  X'079',,,SYSTEM
*     END;                                                         0107
*   RESPECIFY                                                      0108
*     SETLK11 UNRESTRICTED;                                        0108
@RF00103 DS    0H                                                  0109
*   RESPECIFY                                                      0109
*     SETLK12 UNRESTRICTED;                                        0109
*   RESPECIFY                                                      0110
*     SETLK13 UNRESTRICTED;                                        0110
*   RESPECIFY                                                      0111
*     SETLK14 UNRESTRICTED;                                        0111
*                                                                  0112
*/********************************************************************/
*/*                                                                  */
*/*  THE FOLLOWING SEGMENT WILL ESTABLISH A RECOVERY                 */
*/*  ENVIRONMENT FOR THE LOCKED CODE OF THIS ROUTINE                 */
*/*                                                                  */
*/********************************************************************/
*                                                                  0112
*   RESPECIFY                                                      0112
*     FRRSPTR RESTRICTED;                                          0112
*   RESPECIFY                                                      0113
*     FRREPTR RESTRICTED;                                          0113
*   FRRSPTR=ADDR(IEAVAFR4);         /* ENTRY POINT TO FRR            */
         LA    FRRSPTR,IEAVAFR4                                    0114
*   GENERATE CODE NODEFS NOSETS NOFLOWS REFS(FRRWKAP,FRRSPTR,FRREPTR,
*       PSACSTK,FRRSCURR,FRRSLAST,FRRSELEN,FRRSFRRA,FRRSPARM,PSALSFCC);
        SETFRR  A,FRRAD=(FRRSPTR),PARMAD=(FRRWKAP),                    X
               WRKREGS=(FRRWKAP,FRREPTR)
*   RESPECIFY                                                      0116
*     FRRSPTR UNRESTRICTED;                                        0116
*   RESPECIFY                                                      0117
*     FRREPTR UNRESTRICTED;                                        0117
*   RCTDAFPE='1'B;                  /* SET FOOTPRINT INDICATING THAT
*                                      THE FRR HAS BEEN ESTABLISHED  */
         L     @15,ASXBRCTD(,ASXBPTR)                              0118
         OI    RCTDAFPE(@15),B'10000000'                           0118
*                                                                  0119
*/********************************************************************/
*/*                                                                  */
*/* THE FOLLOWING SEGMENT WILL SEARCH FOR ANY PREVIOUSLY             */
*/* SCHEDULED ATTENTION EXITS THAT HAVE NOT YET ENTERED THE          */
*/* ATTENTION EXIT. IF ANY ARE FOUND THE ATTENTION EXIT              */
*/* WILL BE CANCELLED.                                               */
*/*                                                                  */
*/********************************************************************/
*                                                                  0119
*   RESPECIFY                                                      0119
*     TSBPTR RESTRICTED;                                           0119
*   RESPECIFY                                                      0120
*     PTAXETBS RESTRICTED;                                         0120
*   RESPECIFY                                                      0121
*     TAXEPTR RESTRICTED;                                          0121
*   RESPECIFY                                                      0122
*     SWAPVAL RESTRICTED;                                          0122
*   RESPECIFY                                                      0123
*     ATTNCNT RESTRICTED;                                          0123
*   RESPECIFY                                                      0124
*     STAXCNT RESTRICTED;                                          0124
*   TSBPTR=ASCBTSB;                 /* LOAD BASE REG OF TSB          */
         L     TSBPTR,ASCBTSB(,ASCBPTR)                            0125
*   GENERATE CODE NOSETS NOFLOWS NODEFS REFS(TSBPTR);              0126
        USING  TSB,TSBPTR
*   PTAXETBS=PTAXETBS-PTAXETBS;     /* INITIALIZE PTR OF TAXE TO BE
*                                      SCHED                         */
         SLR   PTAXETBS,PTAXETBS                                   0127
*   SWAPVAL=TSBATTNC;               /* VALUE IN TSB AT START OF    0128
*                                      COMPARE AND SWAP LOOP         */
         L     SWAPVAL,TSBATTNC                                    0128
*   STAXCNT=SWAPVAL&'00FF0000'X;    /* AVAILABLE TAXE CNT            */
         LR    STAXCNT,SWAPVAL                                     0129
         N     STAXCNT,@CF02435                                    0129
*   ATTNCNT=SWAPVAL&'FF000000'X;    /* REQUESTED ATTN LEVEL          */
         LR    ATTNCNT,SWAPVAL                                     0130
         N     ATTNCNT,@CF02436                                    0130
*   IF RCTDCLST>OFF THEN                                           0131
         L     @15,ASXBRCTD(,ASXBPTR)                              0131
         CLC   RCTDCLST(2,@15),@CH00036                            0131
         BNH   @RF00131                                            0131
*     DO;                           /* IF > 0 THEN SET ATTNCNT=    0132
*                                      AVAILABLE TAXE COUNT FOR THE
*                                      TMP EXIT              @ZA08100*/
*       ATTNCNT=STAXCNT;            /* WILL FORCE THE TMP ATTN EXIT
*                                                            @ZA08100*/
         LR    ATTNCNT,STAXCNT                                     0133
*       SLL(ATTNCNT,8);             /* SHIFT COUNT TO CORRECT BYTE 0134
*                                                            @ZA08100*/
         SLL   ATTNCNT,8                                           0134
*     END;                          /*                       @ZA08100*/
*   TAXEPTR=RCTDTAXE;               /* INITIALIZE TAXE SEARCH      0136
*                                      ARGUMENT                      */
@RF00131 L     @15,ASXBRCTD(,ASXBPTR)                              0136
         L     TAXEPTR,RCTDTAXE(,@15)                              0136
*LOOP:                                                             0137
*   DO WHILE TAXEPTR^=ZERO;         /* ANY MORE TAXES?               */
LOOP     B     @DE00137                                            0137
@DL00137 DS    0H                                                  0138
*     IF ATTNCNT=ZERO THEN          /* HIGHER LEVEL REQ?             */
         LTR   ATTNCNT,ATTNCNT                                     0138
         BNZ   @RF00138                                            0138
*       DO;                         /* NO                            */
*         GO TO UPDCNT;             /* UPDATE THE COUNTS             */
         B     UPDCNT                                              0140
*       END;                                                       0141
*     IF TAXEFREQ='0'B THEN         /* IS TAXE AVAILABLE             */
@RF00138 TM    TAXEFREQ(TAXEPTR),B'00100000'                       0142
         BNZ   @RF00142                                            0142
*       DO;                                                        0143
*         TAXEFREQ='1'B;            /* MARK TAXE UNAVAIL             */
         OI    TAXEFREQ(TAXEPTR),B'00100000'                       0144
*         ATTNCNT=ATTNCNT-'01000000'X;/* DECREMENT THE ATTENTION CNT */
         SL    ATTNCNT,@CF02442                                    0145
*         STAXCNT=STAXCNT-'00010000'X;/* DECREMENT THE AVAIL TAXE CNT*/
         SL    STAXCNT,@CF02443                                    0146
*         PTAXETBS=TAXEPTR;         /* SAVE TAXE ADDRESS             */
         LR    PTAXETBS,TAXEPTR                                    0147
*       END;                                                       0148
*     ELSE                          /* NO                            */
*       IF TAXELNK=ZERO THEN        /* LAST TAXE                     */
         B     @RC00142                                            0149
@RF00142 L     @15,TAXELNK(,TAXEPTR)                               0149
         LTR   @15,@15                                             0149
         BNZ   @RF00149                                            0149
*         DO;                                                      0150
*           PTAXETBS=PTAXETBS-PTAXETBS;/* NO TAXE TO BE SCHED.       */
         SLR   PTAXETBS,PTAXETBS                                   0151
*           ATTNCNT=ATTNCNT-ATTNCNT;/* CLEAR ATTN COUNT              */
         SLR   ATTNCNT,ATTNCNT                                     0152
*           STAXCNT=STAXCNT-STAXCNT;/* CLEAR STAX COUNT              */
         SLR   STAXCNT,STAXCNT                                     0153
*         END;                                                     0154
*       ELSE                        /* NO                            */
*         IF TAXESCHD='1'B THEN     /* TAXE SCHEDULED                */
         B     @RC00149                                            0155
@RF00149 TM    TAXESCHD(TAXEPTR),B'00001000'                       0155
         BNO   @RF00155                                            0155
*           DO;                                                    0156
*             IF TAXERESM='0'B THEN /* WAS TAXE CANCELLED            */
         TM    TAXERESM(TAXEPTR),B'00010000'                       0157
         BNZ   @RF00157                                            0157
*               DO;                                                0158
*                 FRRSTRF='1'B;     /* SET CANCEL PRINT              */
         OI    FRRSTRF(FRRWKAP),B'10000000'                        0159
*                 FRRTRESM=TAXEPTR; /* PTR TO CANCELLED TAXE         */
         ST    TAXEPTR,FRRTRESM(,FRRWKAP)                          0160
*                 TAXERESM='1'B;    /* CANCEL THE TAXE               */
         OI    TAXERESM(TAXEPTR),B'00010000'                       0161
*               END;                                               0162
*           END;                                                   0163
@RF00157 DS    0H                                                  0164
*     TAXEPTR=TAXELNK;              /* UPDATE SEARCH ARGU            */
@RF00155 DS    0H                                                  0164
@RC00149 DS    0H                                                  0164
@RC00142 L     TAXEPTR,TAXELNK(,TAXEPTR)                           0164
*   END;                                                           0165
@DE00137 LTR   TAXEPTR,TAXEPTR                                     0165
         BNZ   @DL00137                                            0165
*   STAXCNT=STAXCNT-STAXCNT;        /* CLEAR THE STAX CNT            */
         SLR   STAXCNT,STAXCNT                                     0166
*   ATTNCNT=ATTNCNT-ATTNCNT;        /* CLEAR THE ATTN CNT            */
         SLR   ATTNCNT,ATTNCNT                                     0167
*/********************************************************************/
*/*                                                                  */
*/* SET UP THE COMPARE AND SWAP LOOP TO UPDATE THE TSB WITH          */
*/* THE NEW VALUES FOR THE TSBSTAX AND THE TSBATTNC FIELDS           */
*/*                                                                  */
*/********************************************************************/
*                                                                  0168
*   RESPECIFY                                                      0168
*     NSWAPVAL RESTRICTED;                                         0168
*UPDCNT:                                                           0169
*   NSWAPVAL=SWAPVAL&'0000FFFF'X;   /* CLEAR ORIGINAL COUNTS         */
UPDCNT   LR    NSWAPVAL,SWAPVAL                                    0169
         N     NSWAPVAL,@CF02444                                   0169
*   NSWAPVAL=NSWAPVAL|STAXCNT;      /* INSERT NEW STAX COUNT         */
         OR    NSWAPVAL,STAXCNT                                    0170
*   NSWAPVAL=NSWAPVAL|ATTNCNT;      /* INSERT NEW ATTN COUNT         */
         OR    NSWAPVAL,ATTNCNT                                    0171
*   ATTNCNT=SWAPVAL;                /* SAVE ORIGINAL VALUE FROM THE
*                                      TSB                           */
         LR    ATTNCNT,SWAPVAL                                     0172
*   CS(SWAPVAL,NSWAPVAL,TSBATTNC);                                 0173
*                                                                  0173
         CS    SWAPVAL,@09,TSBATTNC                                0173
*   /*****************************************************************/
*   /*                                                               */
*   /* PERFORM ACTUAL UPDATE OF THE VALUES                           */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0174
*   BC(8,STSTOP);                   /* DID THE UPDATE WORK? IF IT  0174
*                                      DID,BRANCH                    */
         BC    8,STSTOP                                            0174
*/* THE UPDATE WAS NOT SUCCESSFUL. THE COUNTS MUST BE SET            */
*/* UP SO THAT THE LOOP CAN BE RE-ENTERED SO THAT THE MORE           */
*/* CURRENT TAXE CAN BE SCHEDULED.                                   */
*                                                                  0175
*   NSWAPVAL=ATTNCNT;               /* MOVE THE ORIGINAL TSB VALUE 0175
*                                      FOR FURTHER USE               */
         LR    NSWAPVAL,ATTNCNT                                    0175
*   STAXCNT=SWAPVAL&'00FF0000'X;    /* NEW AVAILABLE TAXE CNT FROM 0176
*                                      THE TSB                       */
         L     @15,@CF02435                                        0176
         LR    STAXCNT,SWAPVAL                                     0176
         NR    STAXCNT,@15                                         0176
*   STAXCNT=STAXCNT-(NSWAPVAL&'00FF0000'X);                        0177
*                                                                  0177
         NR    @15,NSWAPVAL                                        0177
         SLR   STAXCNT,@15                                         0177
*   /*****************************************************************/
*   /*                                                               */
*   /* DECREMENT THE NEW AVAIL TAXE COUNT BY THE VALUE FROM THE      */
*   /* PREVIOUS TIME THROUGH THE LOOP                                */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0178
*   ATTNCNT=SWAPVAL&'FF000000'X;    /* NEW ATTN COUNT FROM TSB       */
         L     @15,@CF02436                                        0178
         LR    ATTNCNT,SWAPVAL                                     0178
         NR    ATTNCNT,@15                                         0178
*   ATTNCNT=ATTNCNT-(NSWAPVAL&'FF000000'X);                        0179
*                                                                  0179
         NR    @15,NSWAPVAL                                        0179
         SLR   ATTNCNT,@15                                         0179
*   /*****************************************************************/
*   /*                                                               */
*   /* DECREMENT NEW ATTN CNT BY THE NUMBER OF ATTNS FROM THE        */
*   /* PREVIOUS TIME THROUGH THE LOOP                                */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0180
*   GO TO LOOP;                     /* CONTINUE SEARCH               */
         B     LOOP                                                0180
*STSTOP:                            /* COMPLETED                     */
*   GENERATE CODE NOSETS NODEFS NOFLOWS REFS(TSBPTR);              0181
STSTOP   DS    0H                                                  0181
        DROP  TSBPTR
*   RESPECIFY                                                      0182
*     TSBPTR UNRESTRICTED;                                         0182
*   RESPECIFY                                                      0183
*     ATTNCNT UNRESTRICTED;                                        0183
*   RESPECIFY                                                      0184
*     STAXCNT UNRESTRICTED;                                        0184
*   RESPECIFY                                                      0185
*     SWAPVAL UNRESTRICTED;                                        0185
*   RESPECIFY                                                      0186
*     NSWAPVAL UNRESTRICTED;                                       0186
*                                                                  0187
*/********************************************************************/
*/*                                                                  */
*/* THE FOLLOWING SEGMENT OF CODE WILL STATUS STOP THE SUB-          */
*/* TASKS OF THE TCB THAT IS HAVING THE ATTENTION EXIT SCHD.         */
*/* IF THERE IS NO TAXE TO BE SCHEDULED A BRANCH AROUND THIS         */
*/* SEGMENT WILL OCCUR. THE FIRST TEST WILL DETERMINE THE            */
*/* ACTION THAT WILL BE TAKEN                                        */
*/*                                                                  */
*/********************************************************************/
*                                                                  0187
*   IF PTAXETBS^=ZERO THEN          /* IF THERE IS AN ATTN EXIT TO BE
*                                      SCHEDULED THE SUBTASKS OF THE
*                                      TCB THAT IS HAVING THE ATTN 0187
*                                      EXIT SCHEDULED WILL BE STATUS
*                                      STOPPED                       */
         LTR   PTAXETBS,PTAXETBS                                   0187
         BZ    @RF00187                                            0187
*     DO;                                                          0188
*       FRRATTS='1'B;               /* SET FOOTPRINT THAT AN ATTN  0189
*                                      EXIT WILL BE SCHD             */
         OI    FRRATTS(FRRWKAP),B'01000000'                        0189
*       FRRSTAXE=PTAXETBS;          /* SAVE THE ADDRESS OF THE TAXE
*                                      TO BE SCHEDULED               */
         ST    PTAXETBS,FRRSTAXE(,FRRWKAP)                         0190
*       TAXEPTR=PTAXETBS;           /* INITIALIZE BASE REG FOR THE 0191
*                                      TAXE                          */
         LR    TAXEPTR,PTAXETBS                                    0191
*       IF RCTDCLST>OFF THEN                                       0192
         L     @15,ASXBRCTD(,ASXBPTR)                              0192
         CLC   RCTDCLST(2,@15),@CH00036                            0192
         BNH   @RF00192                                            0192
*         TAXEATTN='1'B;            /* IF >0 THEN SET FLAG FOR ATTN
*                                      PROLOGUE(IEAVAR05)    @ZA08100*/
         OI    TAXEATTN(TAXEPTR),B'00000100'                       0193
*       TCBPTR=TAXETCB;             /* INITIALIZE THE TCB BASE     0194
*                                      REGISTER                      */
@RF00192 L     TCBPTR,TAXETCB(,TAXEPTR)                            0194
*       IF TCBLTC^=ZERO THEN        /* IF A DAUGHER EXITS SEARCH   0195
*                                      SUBTASK QUEUE                 */
         L     @15,TCBLTC(,TCBPTR)                                 0195
         LTR   @15,@15                                             0195
         BZ    @RF00195                                            0195
*         DO;                                                      0196
*           RESPECIFY                                              0197
*             PTCBPTR RESTRICTED;                                  0197
*           RESPECIFY                                              0198
*             STATST0 RESTRICTED;                                  0198
*           RESPECIFY                                              0199
*             STATST1 RESTRICTED;                                  0199
*           RESPECIFY                                              0200
*             STATST13 RESTRICTED;                                 0200
*           TCBPTR=TCBLTC;          /* ESTABLISH TCB BASE            */
         LR    TCBPTR,@15                                          0201
*STSTOP1:                                                          0202
*           DO WHILE TCBPTR^=ZERO;  /* TCB BASE ZERO                 */
STSTOP1  B     @DE00202                                            0202
@DL00202 DS    0H                                                  0203
*/* SET UP THE INTERFACE FOR STATUS STOP TCB                         */
*                                                                  0203
*             FRRGTSS='1'B;         /* SET FOOTPRINT INDICATING GOING
*                                      TO STATUS STOP                */
         OI    FRRGTSS(FRRWKAP),B'00100000'                        0203
*             FRRSSTCB=TCBPTR;      /* SAVE THE ADDRESS OF THE TCB TO
*                                      BE STOPPED                    */
         ST    TCBPTR,FRRSSTCB(,FRRWKAP)                           0204
*             STATST0='00000006'X;  /* PLACE A SIX IN PARM REG       */
         LA    STATST0,6                                           0205
*             STATST1=TCBPTR;       /* PLACE ADDRESS OF TCB TO BE  0206
*                                      STOPPED IN PARM REG           */
         LR    STATST1,TCBPTR                                      0206
*             STATST13=ZERO;        /* CLEAR PARM REG FOR MASK       */
         SLR   STATST13,STATST13                                   0207
*             CALL STATENT;         /* GO TO STATUS STOP TCB         */
         L     @10,SCVTSPTR(,CVTPTR)                               0208
         L     @15,SCVTSTAT(,@10)                                  0208
         BALR  @14,@15                                             0208
*             FRRGTSS='0'B;         /* RESET THE FOOTPRINT IND THAT
*                                      STATUS HAS BEEN ENTERED       */
         NI    FRRGTSS(FRRWKAP),B'11011111'                        0209
*             PTCBPTR=TCBPTR;       /* SAVE PREV TCB PTR             */
         LR    PTCBPTR,TCBPTR                                      0210
*             TCBPTR=TCBLTC;        /* UPDATE TCB SEARCH ARG         */
         L     TCBPTR,TCBLTC(,TCBPTR)                              0211
*           END;                                                   0212
@DE00202 LTR   TCBPTR,TCBPTR                                       0212
         BNZ   @DL00202                                            0212
*           TCBPTR=PTCBPTR;         /* REESTABLISH TCB BASE          */
         LR    TCBPTR,PTCBPTR                                      0213
*           DO WHILE TCBPTR^=TAXETCB;/* CONTINUE SEARCHING TCB CHAIN
*                                      UNTIL THE ORIGINAL TCB        */
         B     @DE00214                                            0214
@DL00214 DS    0H                                                  0215
*             IF TCBNTC^=ZERO THEN  /* IF THERE IS A SISTER TCB USE
*                                      IT AS NEW SEARCH ARGUMENT TCB */
         L     @15,TCBNTC(,TCBPTR)                                 0215
         LTR   @15,@15                                             0215
         BZ    @RF00215                                            0215
*               DO;                                                0216
*                 TCBPTR=TCBNTC;    /* UPDATE NEW SEARCH ARG TCB   0217
*                                      ADDRESS TO SISTER OF CURRENT
*                                      SEARCH TCB                    */
         LR    TCBPTR,@15                                          0217
*                 GO TO STSTOP1;    /* GO STOP SISTER                */
         B     STSTOP1                                             0218
*               END;                                               0219
*             ELSE                  /* NO                            */
*               DO;                                                0220
@RF00215 DS    0H                                                  0221
*                 TCBPTR=TCBOTC;    /* UPDATE NEW SEARCH ARG TCB   0221
*                                      ADDRESS TO MOTHER OF CURRENT
*                                      SEARCH TCB                    */
         L     TCBPTR,TCBOTC(,TCBPTR)                              0221
*               END;                                               0222
*           END;                                                   0223
@DE00214 C     TCBPTR,TAXETCB(,TAXEPTR)                            0223
         BNE   @DL00214                                            0223
*           RESPECIFY                                              0224
*             STATST0 UNRESTRICTED;                                0224
*           RESPECIFY                                              0225
*             STATST1 UNRESTRICTED;                                0225
*           RESPECIFY                                              0226
*             STATST13 UNRESTRICTED;                               0226
*           RESPECIFY                                              0227
*             PTCBPTR UNRESTRICTED;                                0227
*         END;                                                     0228
*       FRRGTST='1'B;               /* SET FOOTPRINT INDICATING GOING
*                                      TO STAGE TWO EXIT EFFECTOR    */
@RF00195 OI    FRRGTST(FRRWKAP),B'00010000'                        0229
*       TAXESCHD='1'B;              /* SET FOOTPRINT INDICATING TAXE
*                                      HAS BEEN SCHEDULED            */
         OI    TAXESCHD(TAXEPTR),B'00001000'                       0230
*       RBEP=ADDR(IEAVAR05);        /* PLACE ENTRY POINT OF R05 IN 0231
*                                      THE RB (TAXE)                 */
         L     @15,@CV02426                                        0231
         ST    @15,RBEP(,RBSECPTR)                                 0231
*       RPSWFLD='070C0000'X;        /* INITIALIZE THE RESUME PSW TO
*                                      KEY 0 AND SUPERVISOR STATE  0232
*                                                            @YM05190*/
         MVC   RPSWFLD(4,RBSECPTR),@CF02453                        0232
*/* SET UP THE INTERFACE FOR THE STAGE TWO EXIT EFFECTOR             */
*/* THIS WILL PLACE THE ATTN EXIT ON THE IQE QUEUE                   */
*                                                                  0233
*       RESPECIFY                                                  0233
*         STGTWO1 RESTRICTED;                                      0233
*       RESPECIFY                                                  0234
*         STGTWO10 RESTRICTED;                                     0234
*       STGTWO1=ADDR(TIQELNK);      /* PLACE THE ADDRESS OF THE IQE
*                                      IN THE PARAMETER REGISTER     */
         LA    STGTWO1,TIQELNK(,TAXEPTR)                           0235
*       STGTWO1=-(STGTWO1);         /* COMPLIMENT THE IQE ADDR       */
         LCR   STGTWO1,STGTWO1                                     0236
*       CALL STGTENT;               /* GO TO STAGE TWO EXIT EFFECTOR */
         L     @15,CVT0EF00(,CVTPTR)                               0237
         BALR  @14,@15                                             0237
*       RESPECIFY                                                  0238
*         STGTWO1 UNRESTRICTED;                                    0238
*       RESPECIFY                                                  0239
*         STGTWO10 UNRESTRICTED;                                   0239
*       FRRCFST='1'B;               /* SET THE COMING FROM THE STAGE
*                                      TWO EXIT EFFECTOR FOOTPRINT   */
         OI    FRRCFST(FRRWKAP),B'00001000'                        0240
*     END;                                                         0241
*   RESPECIFY                                                      0242
*     PTAXETBS UNRESTRICTED;                                       0242
@RF00187 DS    0H                                                  0243
*   RESPECIFY                                                      0243
*     TAXEPTR UNRESTRICTED;                                        0243
*                                                                  0244
*/********************************************************************/
*/*                                                                  */
*/* THIS SEGMENT WILL SCAN THE ENTIRE TCB RB QUEUE SEARCHING         */
*/* FOR ANY TGET/TPUT SVRBS THAT ARE IN IWAIT OR OWAIT. IF           */
*/* AN SVRB IS FOUND THE TCBTIOTG FLAG IS SET AND THE IWAIT          */
*/* OR OWAIT CONDITION IS RESET USING STATUS RESET.                  */
*/*                                                                  */
*/********************************************************************/
*                                                                  0244
*   RESPECIFY                                                      0244
*     RBSECPTR RESTRICTED;                                         0244
*   FRRSTSTP='1'B;                  /* SET THE FOOTPRINT IND THAT  0245
*                                      TCAM SUPPORT HAS BEGUN        */
         OI    FRRSTSTP(FRRWKAP),B'00000100'                       0245
*   TCBPTR=ASXBFTCB;                /* INITIALIZE THE SEARCH ARGUMENT
*                                      TCB BASE REG.                 */
         L     TCBPTR,ASXBFTCB(,ASXBPTR)                           0246
*   DO WHILE TCBPTR^=ZERO;          /* SCAN THE ENTIRE TCB Q         */
         B     @DE00247                                            0247
@DL00247 DS    0H                                                  0248
*     RBSECPTR=TCBRBP;              /* INITIALIZE THE SEARCH ARGUMENT
*                                      RB BASE REG                   */
         L     RBSECPTR,TCBRBP(,TCBPTR)                            0248
*     IF RBSECPTR^=ZERO THEN        /* SCAN THE ENTIRE RB Q BUT CHECK
*                                      TO SEE IF AN RB EXISTS        */
         LTR   RBSECPTR,RBSECPTR                                   0249
         BZ    @RF00249                                            0249
*       DO;                                                        0250
*         DO WHILE RBSECPTR^=TCBPTR;/* SCAN WHOLE RB Q               */
         B     @DE00251                                            0251
@DL00251 DS    0H                                                  0252
*           IF RBFTP='110'B THEN    /* IF THIS RB IS AN SVRB CHECK 0252
*                                      FOR TGET/TPUT RB              */
         TM    RBFTP(RBSECPTR),B'11000000'                         0252
         BNO   @RF00252                                            0252
         TM    RBFTP(RBSECPTR),B'00100000'                         0252
         BNZ   @RF00252                                            0252
*             DO;                                                  0253
*               RBSECPTR=RBLINKB;   /* UPDATE RB SEARCH ARGU @YM01671*/
         L     @15,RBLINKB-1(,RBSECPTR)                            0254
         LA    @15,0(,@15)                                         0254
         LR    RBSECPTR,@15                                        0254
*               IF RBINTCOD='005D'X THEN/* SVC 93                    */
         LR    @15,RBSECPTR                                        0255
         BCTR  @15,0                                               0255
         BCTR  @15,0                                               0255
         CLC   RBINTCOD-62(2,@15),@CB02455                         0255
         BNE   @RF00255                                            0255
*                 DO;               /* IF THIS IS A TGET/TPUT SVC  0256
*                                      RESET THE IWAIT/ OWAIT      0256
*                                      CONDITION AND SET THE TCBTIOTG
*                                      FLAG                          */
*                   TCBTIOTG='1'B;  /* SET THE FLAG FOR THE THE    0257
*                                      TGET/TPUT SVC                 */
         OI    TCBTIOTG(TCBPTR),B'00010000'                        0257
*                   FRRGTSST='1'B;  /* SET FOOTPRINT INDICATING GOING
*                                      TO STATUS SET                 */
         OI    FRRGTSST(FRRWKAP),B'00000010'                       0258
*                   FRRSRTCB=TCBPTR;/* SAVE THE ADDRESS OF THE LAST
*                                      TCB THAT WAS SET DISPATCHABLE
*                                      BY STATUS                     */
         ST    TCBPTR,FRRSRTCB(,FRRWKAP)                           0259
*/* SET UP THE INTERFACE FOR STATUS RESET                            */
*                                                                  0260
*                   RESPECIFY                                      0260
*                     STRSET0 RESTRICTED;                          0260
*                   RESPECIFY                                      0261
*                     STRSET1 RESTRICTED;                          0261
*                   RESPECIFY                                      0262
*                     STRSET13 RESTRICTED;                         0262
*                   STRSET0='0000000B'X;/* SET ENTRY CODE FOR THE  0263
*                                      STATUS SET ROUTINE TO A HEX B */
         LA    STRSET0,11                                          0263
*                   STRSET1=TCBPTR; /* ADDRESS OF THE TCB TO BE    0264
*                                      STATUS STOPPED                */
         LR    STRSET1,TCBPTR                                      0264
*                   STRSET1=STRSET1|'80000000'X;/* OR ON THE HIGH  0265
*                                      ORDER BIT FOR STATUS          */
         O     STRSET1,@CF02457                                    0265
*                   STRSET13='00000C00'X;/* SET MASK FOR THE NON   0266
*                                      DISPATCHABILITY BIT           */
         LA    STRSET13,3072                                       0266
*                   CALL STATENT;   /* GO TO STATUS RESET            */
         L     @12,SCVTSPTR(,CVTPTR)                               0267
         L     @15,SCVTSTAT(,@12)                                  0267
         BALR  @14,@15                                             0267
*                   RESPECIFY                                      0268
*                     STRSET0 UNRESTRICTED;                        0268
*                   RESPECIFY                                      0269
*                     STRSET1 UNRESTRICTED;                        0269
*                   RESPECIFY                                      0270
*                     STRSET13 UNRESTRICTED;                       0270
*                   FRRGTSST='0'B;  /* RESET THE FOOTPRINT FOR     0271
*                                      INDICATING THAT STATUS HAS  0271
*                                      BEEN ENTERED                  */
         NI    FRRGTSST(FRRWKAP),B'11111101'                       0271
*                 END;                                             0272
*             END;                                                 0273
*           ELSE                    /* NO                            */
*             DO;                                                  0274
         B     @RC00252                                            0274
@RF00252 DS    0H                                                  0275
*               RBSECPTR=RBLINKB;   /* UPDATE RB SEARCH ARGU @YM01561*/
         L     @15,RBLINKB-1(,RBSECPTR)                            0275
         LA    @15,0(,@15)                                         0275
         LR    RBSECPTR,@15                                        0275
*             END;                                                 0276
*         END;                                                     0277
@RC00252 DS    0H                                                  0277
@DE00251 CR    RBSECPTR,TCBPTR                                     0277
         BNE   @DL00251                                            0277
*       END;                                                       0278
*     TCBPTR=TCBTCB;                /* UPDATE TCB SEARCH ARGU        */
@RF00249 L     TCBPTR,TCBTCB(,TCBPTR)                              0279
*   END;                                                           0280
@DE00247 LTR   TCBPTR,TCBPTR                                       0280
         BNZ   @DL00247                                            0280
*   RESPECIFY                                                      0281
*     RBSECPTR UNRESTRICTED;                                       0281
*                                                                  0281
*/********************************************************************/
*/*                                                                  */
*/* THE FOLLOWING SEGMENT WILL COMPLETE THE PROCESSING THAT          */
*/* IS REQUIRED IN ORDER TO COMPLETE THE FUNCTIONS OF THIS           */
*/* MODULE. THIS SEGMENT WILL DELETE THE FRR AND RELEASE             */
*/* THE LOCAL LOCK.                                                  */
*/*                                                                  */
*/********************************************************************/
*                                                                  0282
*   FRRSTCMP='1'B;                  /* SET THE FOOTPRINT IND. THAT 0282
*                                      TGET/TPUT SUPPORT IS COMPLETE */
         OI    FRRSTCMP(FRRWKAP),B'00000001'                       0282
*   RCTDAFPC='1'B;                  /* SET FOOTPRINT FOR ESTAE     0283
*                                      INDICATING THAT ALL CRITICAL
*                                      PROCESSING HAS COMPLETED      */
         L     @15,ASXBRCTD(,ASXBPTR)                              0283
         OI    RCTDAFPC(@15),B'01000000'                           0283
*/* SET UP THE INTERFACE FOR DELETION OF THE FRR                     */
*                                                                  0284
*   RESPECIFY                                                      0284
*     FRRSPTR RESTRICTED;                                          0284
*   RESPECIFY                                                      0285
*     FRREPTR RESTRICTED;                                          0285
*   GENERATE CODE NODEFS NOSETS NOFLOWS REFS(FRRSPTR,FRREPTR,PSACSTK,
*       FRRSCURR,FRRSEMP,FRRSELEN);                                0286
         SETFRR  D,WRKREGS=(FRRSPTR,FRREPTR)
*   RESPECIFY                                                      0287
*     FRRSPTR UNRESTRICTED;                                        0287
*   RESPECIFY                                                      0288
*     FRREPTR UNRESTRICTED;                                        0288
*                                                                  0289
*/********************************************************************/
*/*                                                                  */
*/* THE FOLLOWING WILL RELEASE THE LOCAL LOCK AND IF A NON-          */
*/* ZERO RETURN CODE IS RECEIVED FROM THE SETLOCK MACRO AN           */
*/* ABEND WILL BE ISSUED THAT WILL BE PROCESSED BY RCTS              */
*/* ESTAE ROUTINE                                                    */
*/*                                                                  */
*/********************************************************************/
*                                                                  0289
*   RESPECIFY                                                      0289
*     SETLK11 RESTRICTED;           /* REGISTERS 11,12,13            */
*   RESPECIFY                                                      0290
*     SETLK12 RESTRICTED;           /* AND 14 ARE USED BY            */
*   RESPECIFY                                                      0291
*     SETLK13 RESTRICTED;           /* THE SETLOCK MACRO.            */
*   RESPECIFY                                                      0292
*     SETLK14 RESTRICTED;           /* SETLOCK DOES NOT SAVE THE   0292
*                                      CONTENTS                      */
*SETLKR1:                                                          0293
*   GENERATE CODE NOSETS NOFLOWS NODEFS REFS(PSALITA);             0293
SETLKR1  DS    0H                                                  0293
         SETLOCK RELEASE,TYPE=LOCAL,                                   X
               RELATED=(TAXE-TCB-QUEUE,IEAVAR04(SETLKO1))
*   IF SETLK13^=ZERO THEN           /* SETLOCK UNSUCCESSFUL          */
         LTR   SETLK13,SETLK13                                     0294
         BZ    @RF00294                                            0294
*     DO;                                                          0295
*R04ABEN1:                                                         0296
*       RCTDRC=SETLK13;             /* SAVE THE RETURN CODE FROM   0296
*                                      SETLOCK FOR LOGREC            */
R04ABEN1 L     @15,ASXBRCTD(,ASXBPTR)                              0296
         ST    SETLK13,RCTDRC(,@15)                                0296
*       GENERATE CODE NOREFS NOFLOWS NOSETS NODEFS;                0297
           ABEND  X'079',,,SYSTEM
*     END;                                                         0298
*   RESPECIFY                                                      0299
*     SETLK11 UNRESTRICTED;                                        0299
@RF00294 DS    0H                                                  0300
*   RESPECIFY                                                      0300
*     SETLK12 UNRESTRICTED;                                        0300
*   RESPECIFY                                                      0301
*     SETLK13 UNRESTRICTED;                                        0301
*   RESPECIFY                                                      0302
*     SETLK14 UNRESTRICTED;                                        0302
*   RESPECIFY                                                      0303
*     PARMRG13 RESTRICTED;                                         0303
*R04EXIT:                                                          0304
*   PARMRG13=ADDR(RCTDISAV);        /* RELOAD ADD OF SAVE AREA       */
R04EXIT  L     PARMRG13,ASXBRCTD(,ASXBPTR)                         0304
*                                                                  0305
*/********************************************************************/
*/*                                                                  */
*/* THIS ROUTINE WILL RECEIVE CONTROL IN THE EVENT OF AN ERROR IN    */
*/* THE ATTENTION SCHEDULING ROUTINE. CONTROL WILL BE RECEIVED FROM  */
*/* RTM VIA A LOAD PSW. REGISTERS UPON ENTRY ARE AS FOLLOWS:         */
*/*        REGISTER 0 UNPREDICTABLE                                  */
*/*                 1 ADDRESS OF SDWA                                */
*/*              2-13 UNPREDICTABLE                                  */
*/*                14 RETURN ADDRESS                                 */
*/*                15 ENTRY POINT ADDRESS                            */
*/********************************************************************/
*                                                                  0305
*IEAVAFR4:                                                         0305
*   PROCEDURE OPTIONS(NOSAVE,NOSAVEAREA,NOPARMREG,RETREG);         0305
@EL00001 DS    0H                                                  0305
@EF00001 DS    0H                                                  0305
@ER00001 LM    @14,@12,12(@13)                                     0305
         BR    @14                                                 0305
IEAVAFR4 DS    0H                                                  0306
*   GENERATE CODE NOSETS NODEFS NOFLOWS REFS(IEAVAFR4);            0306
        USING IEAVAFR4,8
        LR    8,15
*   RESPECIFY                                                      0307
*     SDWAPTR RESTRICTED;           /* RESTRICT SDWA BASE REGISTER   */
*   RESPECIFY                                                      0308
*     TEMPPR14 RESTRICTED;          /* RESTRICT RETURN ADDR REG      */
*   TEMPPR14=PARMRG14;              /* SAVE RETURN ADDRESS           */
         LR    TEMPPR14,PARMRG14                                   0309
*   RESPECIFY                                                      0310
*     PARMRG14 UNRESTRICTED;                                       0310
*   FRRWKAP=SDWAPARM;               /* ESTABLISH BASE REG FOR FRR  0311
*                                      WORK AREA                     */
         L     FRRWKAP,SDWAPARM(,SDWAPTR)                          0311
*   IF SDWAFMID=ZERO THEN           /* WAS ERROR IN THIS ADDRESS   0312
*                                      SPACE                         */
         LH    @12,SDWAFMID(,SDWAPTR)                              0312
         N     @12,@CF02444                                        0312
         LTR   @12,@12                                             0312
         BNZ   @RF00312                                            0312
*     DO;                           /* YES                           */
*       RESPECIFY                                                  0314
*         TEMPSDWA RESTRICTED;                                     0314
*       TEMPSDWA=SDWAPTR;           /* SAVE SDWA PTR FOR LATER       */
         LR    TEMPSDWA,SDWAPTR                                    0315
*       ASCBPTR=PSAAOLD;            /* ESTABLISH ASCB BASE REGISTER  */
         L     ASCBPTR,PSAAOLD                                     0316
*       ASXBPTR=ASCBASXB;           /* ESTABLISH ASXB BASE REGISTER  */
         L     ASXBPTR,ASCBASXB(,ASCBPTR)                          0317
*       CVTPTR=LOC16;               /* ESTABLISH CVT BASE REGISTER   */
         L     CVTPTR,LOC16                                        0318
*       IF FRRGTSS='1'B THEN        /* WAS ERROR IN STATUS STOP      */
         TM    FRRGTSS(FRRWKAP),B'00100000'                        0319
         BNO   @RF00319                                            0319
*         DO;                       /* YES                           */
*           RCTDDUMP='1'B;          /* REQUEST A DUMP TO BE TAKEN BY
*                                      RCTS ESTAE                    */
         L     @12,ASXBRCTD(,ASXBPTR)                              0321
         OI    RCTDDUMP(@12),B'00000010'                           0321
*           GO TO FR4RTN;           /* RETURN TO RTM VIA SETRP       */
         B     FR4RTN                                              0322
*         END;                                                     0323
*       IF FRRGTST='1'B&FRRCFST='0'B THEN/* WAS ERROR IN STAGE TWO   */
@RF00319 TM    FRRGTST(FRRWKAP),B'00010000'                        0324
         BNO   @RF00324                                            0324
         TM    FRRCFST(FRRWKAP),B'00001000'                        0324
         BNZ   @RF00324                                            0324
*         DO;                       /* YES                           */
*           RCTDDUMP='1'B;          /* REQUEST A DUMP TO BE TAKEN BY
*                                      RCTS ESTAE                    */
         L     @12,ASXBRCTD(,ASXBPTR)                              0326
         OI    RCTDDUMP(@12),B'00000010'                           0326
*           GO TO FR4RTN;           /* RETURN TO RTM VIA SETRP       */
         B     FR4RTN                                              0327
*         END;                                                     0328
*       IF FRRGTSST='1'B THEN       /* WAS ERROR IN STATUS SET       */
@RF00324 TM    FRRGTSST(FRRWKAP),B'00000010'                       0329
         BNO   @RF00329                                            0329
*         DO;                       /* YES                           */
*           RCTDDUMP='1'B;          /* REQUEST A DUMP TO BE TAKEN BY
*                                      RCTS ESTAE                    */
         L     @12,ASXBRCTD(,ASXBPTR)                              0331
         OI    RCTDDUMP(@12),B'00000010'                           0331
*           GO TO FR4RTN;           /* RETURN TO RTM VIA SETRP       */
         B     FR4RTN                                              0332
*         END;                                                     0333
*       IF RCTDAFPC='1'B THEN       /* WAS ALL NECESSARY PROCESSING
*                                      COMPLETED                     */
@RF00329 L     @12,ASXBRCTD(,ASXBPTR)                              0334
         TM    RCTDAFPC(@12),B'01000000'                           0334
         BNO   @RF00334                                            0334
*         DO;                       /* YES                           */
*           GO TO FR4RTN;           /* RETURN TO RTM VIA SETRP       */
         B     FR4RTN                                              0336
*         END;                                                     0337
*       IF FRRCFST='1'B THEN        /* WAS AN EXIT SCHEDULED         */
@RF00334 TM    FRRCFST(FRRWKAP),B'00001000'                        0338
         BNO   @RF00338                                            0338
*         DO;                       /* YES                           */
*           RCTDAFPC='1'B;          /* INDICATE FUNCTION COMPLETE    */
         L     @12,ASXBRCTD(,ASXBPTR)                              0340
         OI    RCTDAFPC(@12),B'01000000'                           0340
*           GO TO FR4TGTP;          /* GO PROVIDE TGET/TPUT SUPPORT  */
         B     FR4TGTP                                             0341
*         END;                                                     0342
*       IF FRRATTS='1'B THEN        /* WAS A TAXE TO BE SCHEDULED    */
@RF00338 TM    FRRATTS(FRRWKAP),B'01000000'                        0343
         BNO   @RF00343                                            0343
*         DO;                       /* YES                           */
*           IF FRRSSTCB^=ZERO THEN  /* WERE ANY TCBS STOPPED         */
         L     @12,FRRSSTCB(,FRRWKAP)                              0345
         LTR   @12,@12                                             0345
         BZ    @RF00345                                            0345
*             DO;                   /* YES                           */
*               RESPECIFY                                          0347
*                 PTAXETBS RESTRICTED;                             0347
*               RESPECIFY                                          0348
*                 PTCBPTR RESTRICTED;                              0348
*               RESPECIFY                                          0349
*                 TAXEPTR RESTRICTED;                              0349
*               TAXEPTR=FRRSTAXE;   /* ESTABLISH TAXE BASE REGISTER  */
         L     TAXEPTR,FRRSTAXE(,FRRWKAP)                          0350
*               TCBPTR=TAXETCB;     /* ESTABLISH TCB BASE REGISTER   */
         L     TCBPTR,TAXETCB(,TAXEPTR)                            0351
*               TCBPTR=TCBLTC;      /* LOAD DAUGHTER OF ATTN TCB     */
         L     TCBPTR,TCBLTC(,TCBPTR)                              0352
*               RESPECIFY                                          0353
*                 STATST0 RESTRICTED;                              0353
*               RESPECIFY                                          0354
*                 STATST1 RESTRICTED;                              0354
*               RESPECIFY                                          0355
*                 STATST13 RESTRICTED;                             0355
*               DO WHILE TCBPTR^=ZERO;/* LAST TCB ON SUBTASK QUEUE   */
         B     @DE00356                                            0356
@DL00356 DS    0H                                                  0357
*FR4ATTN2:                                                         0357
*                 STATST0=SEVEN;    /* INDICATE STATUS START         */
FR4ATTN2 LA    STATST0,7                                           0357
*                 STATST1=TCBPTR;   /* PLACE ADDRESS OF TCB TO BE  0358
*                                      STARTED IN PARM REG           */
         LR    STATST1,TCBPTR                                      0358
*                 STATST13=ZERO;    /* CLEAR PARM REG FOR MASK       */
         SLR   STATST13,STATST13                                   0359
*                 CALL STATENT;     /* GO TO STATUS START TCB        */
         L     @14,SCVTSPTR(,CVTPTR)                               0360
         L     @15,SCVTSTAT(,@14)                                  0360
         BALR  @14,@15                                             0360
*                 PTCBPTR=TCBPTR;   /* SAVE PREVIOUS TCB PTR         */
         LR    PTCBPTR,TCBPTR                                      0361
*                 TCBPTR=TCBLTC;    /* INDEX TCB BASE TO NEXT        */
         L     TCBPTR,TCBLTC(,TCBPTR)                              0362
*                 IF PTCBPTR=FRRSSTCB THEN/* HAVE ALL STOPPED TCBS 0363
*                                      BEEN STARTED                  */
         C     PTCBPTR,FRRSSTCB(,FRRWKAP)                          0363
         BNE   @RF00363                                            0363
*                   DO;             /* YES                           */
*                     GO TO FR4ATTN1;/* STOP STARTING TCBS           */
         B     FR4ATTN1                                            0365
*                   END;                                           0366
*               END;                                               0367
@RF00363 DS    0H                                                  0367
@DE00356 LTR   TCBPTR,TCBPTR                                       0367
         BNZ   @DL00356                                            0367
*               TCBPTR=PTCBPTR;     /* RE-ESTABLISH TCB BASE         */
         LR    TCBPTR,PTCBPTR                                      0368
*               DO WHILE TCBNTC=ZERO;/* IS THERE A SISTER TCB        */
         B     @DE00369                                            0369
@DL00369 DS    0H                                                  0370
*                 TCBPTR=TCBOTC;    /* UPDATE TCB BASE REG           */
         L     TCBPTR,TCBOTC(,TCBPTR)                              0370
*               END;                                               0371
@DE00369 L     @15,TCBNTC(,TCBPTR)                                 0371
         LTR   @15,@15                                             0371
         BZ    @DL00369                                            0371
*               TCBPTR=TCBNTC;      /* LOAD SISTER TCB               */
         LR    TCBPTR,@15                                          0372
*               GO TO FR4ATTN2;     /* CONTINUE STARTING TCBS        */
         B     FR4ATTN2                                            0373
*             END;                                                 0374
*           RESPECIFY                                              0375
*             PTCBPTR UNRESTRICTED;                                0375
@RF00345 DS    0H                                                  0376
*           RESPECIFY                                              0376
*             STATST0 UNRESTRICTED;                                0376
*           RESPECIFY                                              0377
*             STATST1 UNRESTRICTED;                                0377
*           RESPECIFY                                              0378
*             STATST13 UNRESTRICTED;                               0378
*FR4ATTN1:                                                         0379
*           IF FRRSTRF='1'B THEN    /* HAS A TAXE BEEN CANCELLED     */
FR4ATTN1 TM    FRRSTRF(FRRWKAP),B'10000000'                        0379
         BNO   @RF00379                                            0379
*             DO;                   /* YES                           */
*               TAXEPTR=FRRTRESM;   /* ESTABLISH NEW TAXE BASE       */
         L     TAXEPTR,FRRTRESM(,FRRWKAP)                          0381
*               TAXERESM='0'B;      /* RESET CANCELLATION FLAG       */
         NI    TAXERESM(TAXEPTR),B'11101111'                       0382
*             END;                                                 0383
*         END;                                                     0384
@RF00379 DS    0H                                                  0385
*                                                                  0385
*/********************************************************************/
*/*                                                                  */
*/* THE FOLLOWING SEGMENT OF CODE WILL CHECK TO SEE IF THERE         */
*/* ARE ANY TAXES ON THE QUEUE. IF THERE ARE THE ENTIRE TAXE         */
*/* QUEUE WILL BE SEARCHED LOCKING FOR THE HIGHEST LEVEL TAXE        */
*/* THAT HAS BEEN SCHEDULED.                                         */
*/*                                                                  */
*/********************************************************************/
*                                                                  0385
*       TAXEPTR=RCTDTAXE;           /* INITIALIZE SEARCH ARGU        */
@RF00343 L     @12,ASXBRCTD(,ASXBPTR)                              0385
         L     TAXEPTR,RCTDTAXE(,@12)                              0385
*       PTAXETBS=PTAXETBS-PTAXETBS; /* CLEAR PREVIOUS ACTIVE TAXE PTR*/
         SLR   PTAXETBS,PTAXETBS                                   0386
*       DO WHILE TAXEPTR^=ZERO;     /* ANY MORE TAXES                */
         B     @DE00387                                            0387
@DL00387 DS    0H                                                  0388
*         IF RBFACTV='1'B|TAXESCHD='1'B THEN/* IS THE TAXE ACTIVE    */
         TM    RBFACTV(RBSECPTR),B'01000000'                       0388
         BO    @RT00388                                            0388
         TM    TAXESCHD(TAXEPTR),B'00001000'                       0388
         BNO   @RF00388                                            0388
@RT00388 DS    0H                                                  0389
*           DO;                     /* YES                           */
*             PTAXETBS=TAXEPTR;     /* SAVE ACTIVE TAXE PTR          */
         LR    PTAXETBS,TAXEPTR                                    0390
*           END;                                                   0391
*         TAXEPTR=TAXELNK;          /* UPDATE SEARCH ARGUMENT        */
@RF00388 L     TAXEPTR,TAXELNK(,TAXEPTR)                           0392
*       END;                                                       0393
@DE00387 SLR   @12,@12                                             0393
         CR    TAXEPTR,@12                                         0393
         BNE   @DL00387                                            0393
*                                                                  0394
*/********************************************************************/
*/*                                                                  */
*/* THE TAXES FOLLOWING THE HIGHEST ACTIVE TAXE MUST BE MARKED       */
*/* AVAILABLE FOR USE AND THEY MUST BE REFLECTED IN THE TSBSTAX      */
*/* COUNT. THIS SEGMENT OF CODE WILL SEARCH THE ENTIRE TAXE QUEUE    */
*/* STARTING WITH THE HIGHEST SCHEDULED TAXE AND PERFORM THE         */
*/* OPERATION                                                        */
*/*                                                                  */
*/********************************************************************/
*                                                                  0394
*       RESPECIFY                                                  0394
*         STAXCNT RESTRICTED;                                      0394
*       STAXCNT=STAXCNT-STAXCNT;    /* CLEAR NEW STAX COUNT          */
         SLR   STAXCNT,STAXCNT                                     0395
*       IF RCTDTAXE^=ZERO THEN      /* ARE THERE ANY TAXES           */
         L     @15,ASXBRCTD(,ASXBPTR)                              0396
         C     @12,RCTDTAXE(,@15)                                  0396
         BE    @RF00396                                            0396
*         DO;                                                      0397
*           IF PTAXETBS^=ZERO THEN  /* IS THIS HEAD OF QUEUE         */
         CR    PTAXETBS,@12                                        0398
         BE    @RF00398                                            0398
*             DO;                   /* NO                            */
*               TAXEPTR=PTAXETBS;   /* ESTABLISH BASE FOR TAXE       */
         LR    TAXEPTR,PTAXETBS                                    0400
*               TAXEPTR=TAXELNK;    /* START WITH NEXT TAXE          */
         L     TAXEPTR,TAXELNK(,TAXEPTR)                           0401
*             END;                                                 0402
*           ELSE                    /* YES                           */
*             DO;                                                  0403
         B     @RC00398                                            0403
@RF00398 DS    0H                                                  0404
*               TAXEPTR=RCTDTAXE;   /* SET BASE TO LOWEST            */
         L     @12,ASXBRCTD(,ASXBPTR)                              0404
         L     TAXEPTR,RCTDTAXE(,@12)                              0404
*             END;                                                 0405
*           DO WHILE TAXEPTR^=ZERO; /* SEARCH THE REMAINDER OF THE 0406
*                                      TAXE QUEUE                    */
@RC00398 B     @DE00406                                            0406
@DL00406 DS    0H                                                  0407
*             TAXEFREQ='0'B;        /* MARK TAXE AVAILABLE           */
         NI    TAXEFREQ(TAXEPTR),B'11011111'                       0407
*             STAXCNT=STAXCNT+'00010000'X;/* INCREMENT COUNT BY ONE  */
         AL    STAXCNT,@CF02443                                    0408
*             TAXEPTR=TAXELNK;      /* UPDATE SEARCH ARGUMENT        */
         L     TAXEPTR,TAXELNK(,TAXEPTR)                           0409
*           END;                                                   0410
@DE00406 LTR   TAXEPTR,TAXEPTR                                     0410
         BNZ   @DL00406                                            0410
*         END;                                                     0411
*       RESPECIFY                                                  0412
*         PTAXETBS UNRESTRICTED;                                   0412
@RF00396 DS    0H                                                  0413
*                                                                  0413
*/********************************************************************/
*/*                                                                  */
*/* UPDATE THE STAX COUNT IN THE TSB AND CLEAR THE ATTN              */
*/* COUNT. THE COUNT IS UPDATED USING COMPARE AND SWAP               */
*/* THE COUNT WILL NOT BE ALLOWED TO BE GREATER THAN 255             */
*/* EVEN IF MORE TAXES EXIST.                                        */
*/*                                                                  */
*/********************************************************************/
*                                                                  0413
*       RESPECIFY                                                  0413
*         TEMPR142 RESTRICTED;                                     0413
*       RESPECIFY                                                  0414
*         TSBPTR RESTRICTED;                                       0414
*       RESPECIFY                                                  0415
*         NSWAPVAL RESTRICTED;                                     0415
*       RESPECIFY                                                  0416
*         SWAPVAL RESTRICTED;                                      0416
*       TEMPR142=TEMPPR14;          /* SAVE R14 SOMEWHERE ELSE       */
         LR    TEMPR142,TEMPPR14                                   0417
*       SDWAPTR=TEMPSDWA;           /* RELOAD SDWA BASE REGISTER     */
         LR    SDWAPTR,TEMPSDWA                                    0418
*       TSBPTR=ASCBTSB;             /* SET BASE REG FOR TSB          */
         L     TSBPTR,ASCBTSB(,ASCBPTR)                            0419
*       GENERATE CODE NODEFS NOSETS NOFLOWS REFS(TSBPTR);          0420
       USING TSB,TSBPTR
*       IF STAXCNT>'00FF0000'X THEN /* IS STAX COUNT > 255           */
         L     @12,@CF02435                                        0421
         CLR   STAXCNT,@12                                         0421
         BNH   @RF00421                                            0421
*         DO;                       /* YES                           */
*           STAXCNT='00FF0000'X;    /* SET COUNT TO 255              */
         LR    STAXCNT,@12                                         0423
*         END;                                                     0424
*       SWAPVAL=TSBATTNC;           /* LOAD ORIG COUNT               */
@RF00421 L     SWAPVAL,TSBATTNC                                    0425
*FR4ATTN3:                                                         0426
*       NSWAPVAL=SWAPVAL&'0000FFFF'X;/* LOAD AND CLEAR TSB CNT       */
FR4ATTN3 LR    NSWAPVAL,SWAPVAL                                    0426
         N     NSWAPVAL,@CF02444                                   0426
*       NSWAPVAL=NSWAPVAL|STAXCNT;  /* INSERT NEW COUNT              */
         OR    NSWAPVAL,STAXCNT                                    0427
*       CS(SWAPVAL,NSWAPVAL,TSBATTNC);/* UPDATE THE COUNT            */
         CS    SWAPVAL,@09,TSBATTNC                                0428
*       BC(7,FR4ATTN3);             /* TRY AGAIN IF NEC              */
         BC    7,FR4ATTN3                                          0429
*       GENERATE CODE NODEFS NOSETS NOFLOWS REFS(TSBPTR);          0430
           DROP  TSBPTR
*       RESPECIFY                                                  0431
*         TSBPTR UNRESTRICTED;                                     0431
*       RESPECIFY                                                  0432
*         NSWAPVAL UNRESTRICTED;                                   0432
*       RESPECIFY                                                  0433
*         SWAPVAL UNRESTRICTED;                                    0433
*       RESPECIFY                                                  0434
*         STAXCNT UNRESTRICTED;                                    0434
*       TEMPSDWA=SDWAPTR;           /* SAVE SDWA PTR FOR LATER       */
         LR    TEMPSDWA,SDWAPTR                                    0435
*       TEMPPR14=TEMPR142;          /* SAVE R14 IN ORIGINAL SPOT     */
         LR    TEMPPR14,TEMPR142                                   0436
*       RESPECIFY                                                  0437
*         TEMPR142 UNRESTRICTED;                                   0437
*                                                                  0437
*/********************************************************************/
*/*                                                                  */
*/* SET THE FLAG REQUESTING ERROR MESSAGE TO BE ISSUED               */
*/*                                                                  */
*/********************************************************************/
*                                                                  0438
*       RCTDPMSG='1'B;              /* INDICATE MESSAGE TO BE ISSUED
*                                      BY ESTAE                      */
         L     @12,ASXBRCTD(,ASXBPTR)                              0438
         OI    RCTDPMSG(@12),B'00100000'                           0438
*                                                                  0439
*/********************************************************************/
*/*                                                                  */
*/* THIS SEGMENT OF CODE WILL SCAN THE TCB PRIORITY QUEUE            */
*/* SEARCHING FOR ANY TGET/TPUT SURBS THAT ARE IN IWAIT OR           */
*/* OWAIT. IF AN SVRB IS FOUND THE TCBTIOTG FLAG IS SET AND          */
*/* THE IWAIT OR OWAIT CONDITION IS RESET USING STATUS RESET         */
*/* THIS CODE IS ALMOST IDENTICAL TO THE MAINLINE CODE FOR           */
*/* THIS FUNCTION.                                                   */
*/*                                                                  */
*/********************************************************************/
*                                                                  0439
*FR4TGTP:                                                          0439
*       RESPECIFY                                                  0439
*         RBSECPTR RESTRICTED;                                     0439
FR4TGTP  DS    0H                                                  0440
*       TCBPTR=ASXBFTCB;            /* INITIALIZE THE SEARCH ARGUMENT
*                                      TCB BASE REG                  */
         L     TCBPTR,ASXBFTCB(,ASXBPTR)                           0440
*       DO WHILE TCBPTR^=ZERO;      /* SCAN THE ENTIRE TCB Q         */
         B     @DE00441                                            0441
@DL00441 DS    0H                                                  0442
*         RBSECPTR=TCBRBP;          /* INITIALIZE THE SEARCH ARGUMENT
*                                      RB BASE REG.                  */
         L     RBSECPTR,TCBRBP(,TCBPTR)                            0442
*         IF RBSECPTR^=ZERO THEN    /* SCAN THE ENTIRE RB Q BUT CHECK
*                                      TO SEE IF AN RB EXISTS        */
         LTR   RBSECPTR,RBSECPTR                                   0443
         BZ    @RF00443                                            0443
*           DO;                                                    0444
*             DO WHILE RBSECPTR^=TCBPTR;/* SCAN WHOLE RB QUEUE       */
         B     @DE00445                                            0445
@DL00445 DS    0H                                                  0446
*               IF RBFTP='110'B THEN/* IF THIS RB IS AN SVRB CHECK 0446
*                                      FOR TGET/TPUT RB              */
         TM    RBFTP(RBSECPTR),B'11000000'                         0446
         BNO   @RF00446                                            0446
         TM    RBFTP(RBSECPTR),B'00100000'                         0446
         BNZ   @RF00446                                            0446
*                 DO;                                              0447
*                   RBSECPTR=RBLINK;/* UPDATE RB SEARCH ARGU         */
         L     RBSECPTR,RBLINK(,RBSECPTR)                          0448
*                   IF RBINTCOD='005D'X THEN/* IF THIS IS A TGET/TPUT
*                                      SVC RESET THE IWAIT/OWAIT   0449
*                                      CONDITION AND SET THE TCBTIOTG
*                                      FLAG                          */
         LR    @12,RBSECPTR                                        0449
         BCTR  @12,0                                               0449
         BCTR  @12,0                                               0449
         CLC   RBINTCOD-62(2,@12),@CB02455                         0449
         BNE   @RF00449                                            0449
*                     DO;                                          0450
*                       TCBTIOTG='1'B;/* SET THE FLAG FOR THE      0451
*                                      TGET/TPUT SVC                 */
         OI    TCBTIOTG(TCBPTR),B'00010000'                        0451
*                       RESPECIFY                                  0452
*                         STRSET0 RESTRICTED;                      0452
*                       RESPECIFY                                  0453
*                         STRSET1 RESTRICTED;                      0453
*                       RESPECIFY                                  0454
*                         STRSET13 RESTRICTED;                     0454
*                       STRSET0='0000000B'X;/* SET ENTRY CODE FOR THE
*                                      STATUS SET ROUTINE TO A HEX B */
         LA    STRSET0,11                                          0455
*                       STRSET1=TCBPTR;/* ADDRESS OF THE TCB TO BE 0456
*                                      STATUS RESET                  */
         LR    STRSET1,TCBPTR                                      0456
*                       STRSET1=STRSET1|'80000000'X;/* OR ON THE HIGH
*                                      ORDER BIT                     */
         O     STRSET1,@CF02457                                    0457
*                       STRSET13='00000C00'X;/* SET MASK FOR THE NON
*                                      DISPATCHABILITY BIT           */
         LA    STRSET13,3072                                       0458
*                       CALL STATENT;/* GO TO STATUS RESET           */
         L     @12,SCVTSPTR(,CVTPTR)                               0459
         L     @15,SCVTSTAT(,@12)                                  0459
         BALR  @14,@15                                             0459
*                       RESPECIFY                                  0460
*                         STRSET0 UNRESTRICTED;                    0460
*                       RESPECIFY                                  0461
*                         STRSET1 UNRESTRICTED;                    0461
*                       RESPECIFY                                  0462
*                         STRSET13 UNRESTRICTED;                   0462
*                     END;                                         0463
*                 END;                                             0464
*               ELSE                /* NO                            */
*                 DO;                                              0465
         B     @RC00446                                            0465
@RF00446 DS    0H                                                  0466
*                   RBSECPTR=RBLINKB;/* UPDATE RB SEARCH ARGUMENT    */
         L     @12,RBLINKB-1(,RBSECPTR)                            0466
         LA    @12,0(,@12)                                         0466
         LR    RBSECPTR,@12                                        0466
*                 END;                                             0467
*             END;                                                 0468
@RC00446 DS    0H                                                  0468
@DE00445 CR    RBSECPTR,TCBPTR                                     0468
         BNE   @DL00445                                            0468
*           END;                                                   0469
*         TCBPTR=TCBTCB;            /* UPDATE TCB SEARCH ARGUMENT    */
@RF00443 L     TCBPTR,TCBTCB(,TCBPTR)                              0470
*       END;                                                       0471
@DE00441 LTR   TCBPTR,TCBPTR                                       0471
         BNZ   @DL00441                                            0471
*       RESPECIFY                                                  0472
*         RBSECPTR UNRESTRICTED;                                   0472
*                                                                  0473
*/********************************************************************/
*/*                                                                  */
*/* THIS SEGMENT OF CODE WILL MOVE THE NECESSARY INFORMATION         */
*/* INTO THE SDWA AND WILL COMMUNICATE WITH RTM                      */
*/*                                                                  */
*/********************************************************************/
*                                                                  0473
*FR4RTN:                                                           0473
*       SDWAPTR=TEMPSDWA;           /* RELOAD SDWA PTR               */
FR4RTN   LR    SDWAPTR,TEMPSDWA                                    0473
*       RESPECIFY                                                  0474
*         TEMPSDWA UNRESTRICTED;                                   0474
*       IF SDWAVRAL<LENGTH(FRRWKA) THEN/* CHECK IF VARIABLE AREA WILL
*                                      HOLD THE ENTIRE FRR WORK AREA */
         LH    @12,SDWAVRAL(,SDWAPTR)                              0475
         N     @12,@CF02444                                        0475
         C     @12,@CF00166                                        0475
         BNL   @RF00475                                            0475
*         DO;                                                      0476
*           SDWAVRA(1:SDWAVRAL)=FRRWKA;/* MOVE FRR WORK AREA INTO  0477
*                                      RECORDING AREA                */
         BCTR  @12,0                                               0477
         EX    @12,@SM02503                                        0477
*           SDWAURAL=SDWAVRAL(2:2); /* MOVE LENGTH OF RECORD INTO  0478
*                                      SDWA                          */
         MVC   SDWAURAL(1,SDWAPTR),SDWAVRAL+1(SDWAPTR)             0478
*         END;                                                     0479
*       ELSE                        /* NO                            */
*         DO;                                                      0480
         B     @RC00475                                            0480
@RF00475 DS    0H                                                  0481
*           SDWAVRA(1:LENGTH(FRRWKA))=FRRWKA;/* MOVE FRR WORK AREA 0481
*                                      INTO RECORDING AREA           */
         MVC   SDWAVRA(24,SDWAPTR),FRRWKA(FRRWKAP)                 0481
*           SDWAURAL=LENGTH(FRRWKA);/* MOVE LENGTH OF RECORD INTO  0482
*                                      SDWA                          */
         MVI   SDWAURAL(SDWAPTR),X'18'                             0482
*         END;                                                     0483
*       DO;                         /* SETRP RECORD(YES)WKAREA(SDWAPT
*                                      R)RECPARM(FRRMODID)RC(0)      */
@RC00475 DS    0H                                                  0485
*         RESPECIFY                                                0485
*          (GPR00P,                                                0485
*           GPR01P,                                                0485
*           GPR14P,                                                0485
*           GPR15P) RSTD;                                          0485
*         GPR01P=SDWAPTR;                                          0486
*         GPR01P->SDWARCDE=0;       /* SAVE RC VALUE                 */
         MVI   SDWARCDE(GPR01P),X'00'                              0487
*         GPR01P->SDWARCRD='1'B;    /* TURN ON RECORD INDICATOR      */
         OI    SDWARCRD(GPR01P),B'10000000'                        0488
*         GPR15P=ADDR(FRRMODID);    /* ACCESS RECORD PARAMETER LIST  */
         LA    GPR15P,FRRMODID                                     0489
*         GPR01P->SDWARECP=GPR15P->I256C(1:24);/* COPY RECORD      0490
*                                      PARAMETERS                    */
         MVC   SDWARECP(24,GPR01P),I256C(GPR15P)                   0490
*         RESPECIFY                                                0491
*          (GPR00P,                                                0491
*           GPR01P,                                                0491
*           GPR14P,                                                0491
*           GPR15P) UNRSTD;                                        0491
*       END;                                                       0492
*     END;                                                         0493
*   ELSE                            /* NO                            */
*     DO;                                                          0494
         B     @RC00312                                            0494
@RF00312 DS    0H                                                  0495
*       DO;                         /* SETRP WKAREA(SDWAPTR)RC(0)    */
*         RESPECIFY                                                0496
*          (GPR00P,                                                0496
*           GPR01P,                                                0496
*           GPR14P,                                                0496
*           GPR15P) RSTD;                                          0496
*         GPR01P=SDWAPTR;                                          0497
*         GPR01P->SDWARCDE=0;       /* SAVE RC VALUE                 */
         MVI   SDWARCDE(GPR01P),X'00'                              0498
*         RESPECIFY                                                0499
*          (GPR00P,                                                0499
*           GPR01P,                                                0499
*           GPR14P,                                                0499
*           GPR15P) UNRSTD;                                        0499
*       END;                                                       0500
*     END;                                                         0501
*   RESPECIFY                                                      0502
*     PARMRG14 RESTRICTED;                                         0502
@RC00312 DS    0H                                                  0503
*FR4EXIT:                                                          0503
*   PARMRG14=TEMPPR14;              /* RESTORE RETURN ADDRESS        */
FR4EXIT  LR    PARMRG14,TEMPPR14                                   0503
*   RESPECIFY                                                      0504
*     TEMPPR14 UNRESTRICTED;                                       0504
*   END IEAVAFR4;                                                  0505
@EL00002 DS    0H                                                  0505
@EF00002 DS    0H                                                  0505
@ER00002 BR    @14                                                 0505
*   DECLARE                         /* GENERAL PURPOSE REGISTERS     */
*     GPR00P PTR(31) REG(0),                                       0506
*     GPR01P PTR(31) REG(1),                                       0506
*     GPR14P PTR(31) REG(14),                                      0506
*     GPR15P PTR(31) REG(15);                                      0506
*   DECLARE                         /* COMMON VARIABLES              */
*     I256C CHAR(256) BASED,                                       0507
*     I031F FIXED(31) BASED,                                       0507
*     I031P PTR(31) BASED,                                         0507
*     I015F FIXED(15) BASED,                                       0507
*     I015P PTR(15) BASED,                                         0507
*     I008P PTR(8) BASED,                                          0507
*     I001C CHAR(1) BASED;                                         0507
*   END IEAVAR04                                                   0508
*                                                                  0508
*/* THE FOLLOWING INCLUDE STATEMENTS WERE FOUND IN THIS PROGRAM.     */
*/*%INCLUDE SYSLIB  (IHAASCB )                                       */
*/*%INCLUDE SYSLIB  (IHAASXB )                                       */
*/*%INCLUDE SYSLIB  (CVT     )                                       */
*/*%INCLUDE SYSLIB  (IHAFRRS )                                       */
*/*%INCLUDE SYSLIB  (IHAPSA  )                                       */
*/*%INCLUDE SYSLIB  (IHARB   )                                       */
*/*%INCLUDE SYSLIB  (IKJRB   )                                       */
*/*%INCLUDE SYSLIB  (IEARCTD )                                       */
*/*%INCLUDE SYSLIB  (IHASCVT )                                       */
*/*%INCLUDE SYSLIB  (IHASDWA )                                       */
*/*%INCLUDE SYSLIB  (IKJTAXE )                                       */
*/*%INCLUDE SYSLIB  (IKJTCB  )                                       */
*                                                                  0508
*       ;                                                          0508
@DATA    DS    0H
@CH00036 DC    H'0'
@SM02503 MVC   SDWAVRA(0,SDWAPTR),FRRWKA(FRRWKAP)
@DATD    DSECT
         DS    0F
IEAVAR04 CSECT
         DS    0F
@CF00166 DC    F'24'
@CF02435 DC    XL4'00FF0000'
@CF02436 DC    XL4'FF000000'
@CF02442 DC    XL4'01000000'
@CF02443 DC    XL4'00010000'
@CF02444 DC    XL4'0000FFFF'
@CF02453 DC    XL4'070C0000'
@CF02457 DC    XL4'80000000'
@DATD    DSECT
         DS    0D
IEAVAR04 CSECT
         DS    0F
@SIZDATD DC    AL1(0)
         DC    AL3(@ENDDATD-@DATD)
@CV02426 DC    V(IEAVAR05)
         DS    0D
@CB02427 DC    X'08000000'
@CB02455 DC    X'005D'
FRRMODID DC    CL24'IEAVAR04IEAVAR04IEAVAFR4'
         DS    CL2
MAINAREA DC    XL50'0'
@DATD    DSECT
     IKJTSB  LIST=YES
@DATD    DSECT
         ORG   *+1-(*-@DATD)/(*-@DATD) INSURE DSECT DATA
@ENDDATD EQU   *
IEAVAR04 CSECT
@00      EQU   00                      EQUATES FOR REGISTERS 0-15
@01      EQU   01
@02      EQU   02
@03      EQU   03
@04      EQU   04
@05      EQU   05
@06      EQU   06
@07      EQU   07
@08      EQU   08
@09      EQU   09
@10      EQU   10
@11      EQU   11
@12      EQU   12
@13      EQU   13
@14      EQU   14
@15      EQU   15
ASCBPTR  EQU   @07
ASXBPTR  EQU   @02
CVTPTR   EQU   @03
FRRSPTR  EQU   @11
FRREPTR  EQU   @12
RBSECPTR EQU   @05
SDWAPTR  EQU   @01
TAXEPTR  EQU   @05
TCBPTR   EQU   @04
FRRWKAP  EQU   @06
STATST0  EQU   @00
STRSET0  EQU   @00
STATST1  EQU   @01
STRSET1  EQU   @01
STGTWO1  EQU   @01
BASEREG  EQU   @08
NSWAPVAL EQU   @09
TEMPPR14 EQU   @09
STGTWO10 EQU   @10
TSBPTR   EQU   @10
TEMPSDWA EQU   @10
SETLK11  EQU   @11
PTAXETBS EQU   @11
SETLK12  EQU   @12
ATTNCNT  EQU   @12
PTCBPTR  EQU   @12
SETLK13  EQU   @13
STAXCNT  EQU   @13
STATST13 EQU   @13
STRSET13 EQU   @13
PARMRG13 EQU   @13
SETLK14  EQU   @14
SWAPVAL  EQU   @14
PARMRG14 EQU   @14
TEMPR142 EQU   @15
GPR00P   EQU   @00
GPR01P   EQU   @01
GPR14P   EQU   @14
GPR15P   EQU   @15
PSA      EQU   0
FLCRNPSW EQU   PSA
FLCROPSW EQU   PSA+8
FLCICCW2 EQU   PSA+16
PSAEEPSW EQU   PSA+132
PSAESPSW EQU   PSA+136
FLCSVILC EQU   PSAESPSW+1
PSAEPPSW EQU   PSA+140
FLCPIILC EQU   PSAEPPSW+1
FLCPICOD EQU   PSAEPPSW+2
PSAPICOD EQU   FLCPICOD+1
FLCTEA   EQU   PSAEPPSW+4
FLCPER   EQU   PSA+152
FLCMCLA  EQU   PSA+168
FLCIOEL  EQU   FLCMCLA+4
FLCIOA   EQU   FLCMCLA+16
FLCFSA   EQU   FLCMCLA+80
PSAAOLD  EQU   PSA+548
PSASUPER EQU   PSA+552
PSASUP1  EQU   PSASUPER
PSASUP2  EQU   PSASUPER+1
PSASUP3  EQU   PSASUPER+2
PSASUP4  EQU   PSASUPER+3
PSACLHT  EQU   PSA+640
PSALKSA  EQU   PSA+696
PSAHLHI  EQU   PSA+760
PSALITA  EQU   PSA+764
PSADSSFL EQU   PSA+836
PSADSSF1 EQU   PSADSSFL
PSADSSF3 EQU   PSADSSFL+2
PSADSSF4 EQU   PSADSSFL+3
PSARSVT  EQU   PSA+896
PSALSFCC EQU   PSA+1012
LOC16    EQU   16
ASCB     EQU   0
ASCBTSB  EQU   ASCB+60
ASCBFW1  EQU   ASCB+100
ASCBRCTF EQU   ASCBFW1+2
ASCBFLG1 EQU   ASCBFW1+3
ASCBASXB EQU   ASCB+108
ASCBDSP1 EQU   ASCB+114
ASCBFLG2 EQU   ASCB+115
ASXB     EQU   0
ASXBFTCB EQU   ASXB+4
ASXBRCTD EQU   ASXB+120
ASXBAEQ  EQU   ASXB+168
CVTMAP   EQU   0
CVT0EF00 EQU   CVTMAP+4
CVTDAR   EQU   CVTMAP+72
CVTFLGS1 EQU   CVTDAR
CVTDCB   EQU   CVTMAP+116
CVTIERLC EQU   CVTMAP+144
CVTOPTA  EQU   CVTMAP+182
CVTOPTB  EQU   CVTMAP+183
CVTABEND EQU   CVTMAP+200
CVTGTF   EQU   CVTMAP+236
CVTGTFST EQU   CVTGTF
CVTGTFS  EQU   CVTGTFST
CVTSTATE EQU   CVTGTFST
CVTTMODE EQU   CVTGTFST
CVTFORM  EQU   CVTGTFST
CVTAQAVT EQU   CVTMAP+240
CVTTCMFG EQU   CVTAQAVT
CVTVOLM2 EQU   CVTMAP+244
CVTTATA  EQU   CVTVOLM2
CVTTSKS  EQU   CVTTATA
CVTVOLF2 EQU   CVTTSKS
CVTTAT   EQU   CVTTATA+1
CVTATER  EQU   CVTMAP+248
CVTEXT1  EQU   CVTMAP+252
CVTPURG  EQU   CVTMAP+260
CVTQMSG  EQU   CVTMAP+268
CVTDMSR  EQU   CVTMAP+272
CVTERPV  EQU   CVTMAP+316
CVTINTLA EQU   CVTMAP+320
CVTAPF   EQU   CVTMAP+324
CVTEXT2  EQU   CVTMAP+328
CVTHJES  EQU   CVTMAP+332
CVTPGSIA EQU   CVTMAP+348
CVTA1F1  EQU   CVTMAP+356
CVTSYSK  EQU   CVTMAP+357
CVTVOLM1 EQU   CVTMAP+380
CVTVOLF1 EQU   CVTVOLM1
CVTATMCT EQU   CVTMAP+388
CVTXTNT1 EQU   0
CVTXTNT2 EQU   0
CVTDSSV  EQU   CVTXTNT2
CVTFLGBT EQU   CVTXTNT2+5
CVTQID   EQU   CVTXTNT2+24
CVTRV400 EQU   CVTXTNT2+52
CVTRV409 EQU   CVTXTNT2+53
CVTATCVT EQU   CVTXTNT2+64
CVTRV429 EQU   CVTXTNT2+84
CVTRV438 EQU   CVTXTNT2+85
CVTRV457 EQU   CVTXTNT2+112
CVTRV466 EQU   CVTXTNT2+113
CVTFIX   EQU   0
CVTRELNO EQU   CVTFIX+252
FRRS     EQU   0
FRRSHEAD EQU   FRRS
FRRSEMP  EQU   FRRSHEAD
FRRSLAST EQU   FRRSHEAD+4
FRRSELEN EQU   FRRSHEAD+8
FRRSCURR EQU   FRRSHEAD+12
FRRSENTR EQU   0
FRRSFRRA EQU   FRRSENTR
FRRSFLGS EQU   FRRSENTR+4
FRRSFLG1 EQU   FRRSFLGS
FRRSPARM EQU   FRRSENTR+8
RBPRFX   EQU   0
RBBASIC  EQU   0
RBEXRTNM EQU   RBBASIC
RBTMFLD  EQU   RBEXRTNM
RBSTAB   EQU   RBBASIC+10
XSTAB    EQU   RBSTAB
RBSTAB1  EQU   XSTAB
XSTAB1   EQU   RBSTAB1
RBFTCKPT EQU   XSTAB1
RBSTAB2  EQU   XSTAB+1
XSTAB2   EQU   RBSTAB2
RBTCBNXT EQU   XSTAB2
RBFACTV  EQU   XSTAB2
RBFDYN   EQU   XSTAB2
RBECBWT  EQU   XSTAB2
RBOPSW   EQU   RBBASIC+16
RBLINK   EQU   RBBASIC+28
XRBLNK   EQU   RBLINK
RBWCF    EQU   XRBLNK
RBLINKB  EQU   XRBLNK+1
RBGRSAVE EQU   RBBASIC+32
XRBREG   EQU   RBGRSAVE
RBGRS0   EQU   XRBREG
RBGRS1   EQU   XRBREG+4
RBGRS2   EQU   XRBREG+8
RBGRS3   EQU   XRBREG+12
RBGRS4   EQU   XRBREG+16
RBGRS5   EQU   XRBREG+20
RBGRS6   EQU   XRBREG+24
RBGRS7   EQU   XRBREG+28
RBGRS8   EQU   XRBREG+32
RBGRS9   EQU   XRBREG+36
RBGRS10  EQU   XRBREG+40
RBGRS11  EQU   XRBREG+44
RBGRS12  EQU   XRBREG+48
RBGRS13  EQU   XRBREG+52
RBGRS14  EQU   XRBREG+56
RBGRS15  EQU   XRBREG+60
XRBESA   EQU   RBBASIC+96
RBPREFIX EQU   0
RBRSV019 EQU   RBPREFIX+14
RBRSV028 EQU   RBPREFIX+15
RBRSV041 EQU   RBPREFIX+27
RBRSV054 EQU   RBPREFIX+39
RBRTOPSW EQU   RBPREFIX+40
RBRTPSW2 EQU   RBRTOPSW+8
RBRTICIL EQU   RBRTPSW2
RBFLAGS1 EQU   RBPREFIX+56
RBINTCDA EQU   RBPREFIX+61
RBINTCOD EQU   RBINTCDA+1
RBSECT   EQU   0
RBPPSAV  EQU   RBSECT
@NM00038 EQU   RBSECT+10
@NM00039 EQU   @NM00038
RBFTP    EQU   @NM00039
RBTRSVRB EQU   @NM00039
@NM00041 EQU   @NM00038+1
RBETXR   EQU   @NM00041
RBEP     EQU   RBSECT+12
RBPGMQ   EQU   RBSECT+24
@NM00048 EQU   RBSECT+28
IRBEND   EQU   RBSECT+96
@NM00052 EQU   RBSECT+96
RBRSV138 EQU   @NM00052+7
RBRSV150 EQU   RBSECT+167
RCTD     EQU   0
RCTDISAV EQU   RCTD
RCTDWORK EQU   RCTD+80
RCTDLMAC EQU   RCTDWORK
RCTDCLRL EQU   RCTDLMAC
RCTDTIME EQU   RCTDCLRL
RCTDCLST EQU   RCTD+154
RCTDECBS EQU   RCTD+156
RCTDWPTR EQU   RCTDECBS+4
RCTDTECB EQU   RCTD+164
RCTDTAXE EQU   RCTD+172
RCTDPIRL EQU   RCTD+176
RCTDRC   EQU   RCTD+180
RCTDSLST EQU   RCTD+192
RCTDRCTR EQU   RCTD+216
RCTDMOID EQU   RCTDRCTR
RCTDDUMP EQU   RCTDMOID
RCTDFLGS EQU   RCTDRCTR+1
RCTDINTF EQU   RCTD+220
RCTDRCTF EQU   RCTDINTF
SCVTSECT EQU   0
SCVTSTAT EQU   SCVTSECT+148
SDWA     EQU   0
SDWAPARM EQU   SDWA
SDWAFIOB EQU   SDWA+4
SDWAABCC EQU   SDWAFIOB
SDWACMPF EQU   SDWAABCC
SDWACTL1 EQU   SDWA+8
SDWACMKA EQU   SDWACTL1
SDWAMWPA EQU   SDWACTL1+1
SDWAPMKA EQU   SDWACTL1+4
SDWACTL2 EQU   SDWA+16
SDWACMKP EQU   SDWACTL2
SDWAMWPP EQU   SDWACTL2+1
SDWAPMKP EQU   SDWACTL2+4
SDWAGRSV EQU   SDWA+24
SDWANAME EQU   SDWA+88
SDWAEC1  EQU   SDWA+104
SDWAEMK1 EQU   SDWAEC1
SDWAMWP1 EQU   SDWAEC1+1
SDWAINT1 EQU   SDWAEC1+2
SDWANXT1 EQU   SDWAEC1+4
SDWAAEC1 EQU   SDWA+112
SDWAILC1 EQU   SDWAAEC1+1
SDWAINC1 EQU   SDWAAEC1+2
SDWAICD1 EQU   SDWAINC1+1
SDWAEC2  EQU   SDWA+120
SDWAEMK2 EQU   SDWAEC2
SDWAMWP2 EQU   SDWAEC2+1
SDWAINT2 EQU   SDWAEC2+2
SDWANXT2 EQU   SDWAEC2+4
SDWAAEC2 EQU   SDWA+128
SDWAILC2 EQU   SDWAAEC2+1
SDWAINC2 EQU   SDWAAEC2+2
SDWAICD2 EQU   SDWAINC2+1
SDWASRSV EQU   SDWA+136
SDWAIDNT EQU   SDWA+200
SDWAMCH  EQU   SDWA+204
SDWASTCK EQU   SDWAMCH
SDWAMCHI EQU   SDWAMCH+8
SDWAMCHS EQU   SDWAMCHI
SDWAMCHD EQU   SDWAMCHI+1
SDWARSR1 EQU   SDWAMCH+12
SDWARSR2 EQU   SDWAMCH+13
SDWAFLGS EQU   SDWA+232
SDWAERRA EQU   SDWAFLGS
SDWAERRB EQU   SDWAFLGS+1
SDWAERRC EQU   SDWAFLGS+2
SDWAERRD EQU   SDWAFLGS+3
SDWAFMID EQU   SDWA+236
SDWAIOFS EQU   SDWA+238
SDWACPUA EQU   SDWA+248
SDWAPARQ EQU   SDWA+252
SDWARCDE EQU   SDWAPARQ
SDWAACF2 EQU   SDWAPARQ+1
SDWARCRD EQU   SDWAACF2
SDWAACF3 EQU   SDWAPARQ+2
SDWAACF4 EQU   SDWAPARQ+3
SDWALKWA EQU   SDWA+256
SDWALKWS EQU   SDWALKWA
SDWARECP EQU   SDWA+292
SDWASNPA EQU   SDWA+320
SDWADUMP EQU   SDWASNPA
SDWADPFS EQU   SDWADUMP+1
SDWADDAT EQU   SDWASNPA+4
SDWASDAT EQU   SDWADDAT
SDWAPDAT EQU   SDWADDAT+2
SDWADPSA EQU   SDWA+328
SDWADPSL EQU   SDWADPSA
SDWARA   EQU   SDWA+400
SDWAVRAL EQU   SDWARA
SDWADPVA EQU   SDWARA+2
SDWAURAL EQU   SDWARA+3
SDWAVRA  EQU   SDWARA+4
TAXE     EQU   0
TAXEWORK EQU   TAXE+100
TIQELNK  EQU   TAXEWORK
TAXETCB  EQU   TAXEWORK+12
TAXELNK  EQU   TAXEWORK+16
TAXEPARM EQU   TAXEWORK+28
TAXESTAT EQU   TAXEPARM
TAXEFREQ EQU   TAXESTAT
TAXERESM EQU   TAXESTAT
TAXESCHD EQU   TAXESTAT
TAXEATTN EQU   TAXESTAT
TCBFIX   EQU   0
TCBFRS   EQU   TCBFIX
TCB      EQU   0
TCBRBP   EQU   TCB
TCBPIE   EQU   TCB+4
TCBPMASK EQU   TCBPIE
TCBCMP   EQU   TCB+16
TCBCMPF  EQU   TCBCMP
TCBCPP   EQU   TCBCMPF
TCBSTCC  EQU   TCBCMPF
TCBCDBL  EQU   TCBCMPF
TCBCWTO  EQU   TCBCMPF
TCBCIND  EQU   TCBCMPF
TCBCMSG  EQU   TCBCMPF
TCBTRN   EQU   TCB+20
TCBABF   EQU   TCBTRN
TCBMSS   EQU   TCB+24
TCBPKF   EQU   TCB+28
TCBFLGS  EQU   TCB+29
TCBFLGS1 EQU   TCBFLGS
TCBFLGS2 EQU   TCBFLGS+1
TCBFLGS3 EQU   TCBFLGS+2
TCBFLGS4 EQU   TCBFLGS+3
TCBFLGS5 EQU   TCBFLGS+4
TCBABWF  EQU   TCBFLGS5
TCBJPQ   EQU   TCB+44
TCBPURGE EQU   TCBJPQ
TCBGRS   EQU   TCB+48
TCBFSA   EQU   TCB+112
TCBTCB   EQU   TCB+116
TCBTME   EQU   TCB+120
TCBJSTCB EQU   TCB+124
TCBNTC   EQU   TCB+128
TCBOTC   EQU   TCB+132
TCBLTC   EQU   TCB+136
TCBTSFLG EQU   TCB+148
TCBTSTSK EQU   TCBTSFLG
TCBTIOTG EQU   TCBTSFLG
TCBSTAB  EQU   TCB+160
TCBNSTAE EQU   TCBSTAB
TCBTCT   EQU   TCB+164
TCBTCTGF EQU   TCBTCT
TCBSCNDY EQU   TCB+172
TCBNDSP  EQU   TCBSCNDY
TCBNDSP1 EQU   TCBNDSP+1
TCBNDSP2 EQU   TCBNDSP+2
TCBNDSP3 EQU   TCBNDSP+3
TCBJSCB  EQU   TCB+180
TCBRECDE EQU   TCBJSCB
TCBEXT1  EQU   TCB+196
TCBBITS  EQU   TCB+200
TCBNDSP4 EQU   TCBBITS
TCBNDSP5 EQU   TCBBITS+1
TCBFLGS6 EQU   TCBBITS+2
TCBFLGS7 EQU   TCBBITS+3
TCBDAR   EQU   TCB+204
TCBDARC  EQU   TCBDAR
TCBEXT2  EQU   TCB+208
TCBFOE   EQU   TCB+244
TCBESTAE EQU   TCB+264
TCBESTRM EQU   TCBESTAE+1
TCBFBYT1 EQU   TCB+276
TCBFBYT2 EQU   TCB+277
TCBRV124 EQU   TCB+278
TCBRV133 EQU   TCB+279
TCBXTNT2 EQU   0
TCBGTF   EQU   TCBXTNT2
TCBTFLG  EQU   TCBGTF
TCBRV146 EQU   TCBXTNT2+28
TCBRV155 EQU   TCBXTNT2+29
TCBRV164 EQU   TCBXTNT2+30
TCBRV173 EQU   TCBXTNT2+31
FRRWKA   EQU   0
FRRFLAGS EQU   FRRWKA
FRRSTRF  EQU   FRRFLAGS
FRRATTS  EQU   FRRFLAGS
FRRGTSS  EQU   FRRFLAGS
FRRGTST  EQU   FRRFLAGS
FRRCFST  EQU   FRRFLAGS
FRRSTSTP EQU   FRRFLAGS
FRRGTSST EQU   FRRFLAGS
FRRSTCMP EQU   FRRFLAGS
FRRTRESM EQU   FRRWKA+4
FRRSTAXE EQU   FRRWKA+8
FRRSSTCB EQU   FRRWKA+12
FRRSRTCB EQU   FRRWKA+16
STGTENT  EQU   0
STATENT  EQU   0
I256C    EQU   0
I001C    EQU   0
I008P    EQU   0
I015F    EQU   0
I015P    EQU   0
I031F    EQU   0
I031P    EQU   0
CVTS01   EQU   CVTPGSIA
CVTLPDIA EQU   CVTS01+12
CVTDIRST EQU   CVTLPDIA
CVTSLIDA EQU   CVTS01+24
CVTCTLFG EQU   CVTS01+50
CVTRV210 EQU   CVTS01+424
CVTRV219 EQU   CVTS01+425
CVTRV228 EQU   CVTS01+426
CVTRV237 EQU   CVTS01+427
CVTMFRTR EQU   CVTS01+452
CVTRV262 EQU   CVTS01+468
CVTRV271 EQU   CVTS01+469
CVTRV280 EQU   CVTS01+470
CVTRV289 EQU   CVTS01+471
CVTGSDA  EQU   CVTS01+600
PSARSVTE EQU   PSARSVT
PSACSTK  EQU   PSARSVTE
RBSECS03 EQU   RBEP
RBCDE    EQU   RBSECS03
RBCDFLGS EQU   RBCDE
RBSECS05 EQU   RBPGMQ
RBSQE    EQU   RBSECS05
RBSECS06 EQU   RBPGMQ
RBIQE    EQU   RBSECS06
RBSECS07 EQU   RBPGMQ
RBIQE2   EQU   RBSECS07
RBSECS08 EQU   IRBEND
RBSECS09 EQU   IRBEND
@NM00061 EQU   RCTDFLGS
@NM00063 EQU   RCTDFLGS
@NM00065 EQU   RCTDFLGS
RCTDAFPE EQU   @NM00065
RCTDAFPC EQU   @NM00065
RCTDPMSG EQU   @NM00065
@NM00067 EQU   RCTDFLGS
@NM00069 EQU   RCTDFLGS
SCVTSPTR EQU   CVTABEND
RPSWFLD  EQU   RBOPSW
FLC      EQU   PSA
         AGO   .@UNREFD                START UNREFERENCED COMPONENTS
@NM00072 EQU   @NM00069+2
RCTDOPTC EQU   @NM00069+2
RCTDWTLC EQU   @NM00069+2
@NM00071 EQU   @NM00069+2
@NM00070 EQU   @NM00069+1
RCTDRLWB EQU   @NM00069+1
RCTDRLWC EQU   @NM00069+1
RCTDSTAC EQU   @NM00069+1
RCTDWTLB EQU   @NM00069+1
RCTDRIOC EQU   @NM00069+1
RCTDRSLW EQU   @NM00069
RCTDFAIL EQU   @NM00069
RCTDSY18 EQU   @NM00069
RCTDSY19 EQU   @NM00069
RCTDRLLK EQU   @NM00069
RCTDSTAT EQU   @NM00069
RCTDOBLK EQU   @NM00069
RCTDRS17 EQU   @NM00069
@NM00068 EQU   @NM00067+2
RCTDRGL1 EQU   @NM00067+2
RCTDOGL1 EQU   @NM00067+2
RCTDRLL2 EQU   @NM00067+2
RCTDOLL2 EQU   @NM00067+2
RCTDSWPF EQU   @NM00067+2
RCTDSYBC EQU   @NM00067+1
RCTDPRGF EQU   @NM00067+1
RCTDSLFL EQU   @NM00067+1
RCTDQWAI EQU   @NM00067+1
RCTDSWOT EQU   @NM00067+1
RCTDSSRB EQU   @NM00067+1
RCTDSSUB EQU   @NM00067+1
RCTDSY13 EQU   @NM00067+1
RCTDPSRB EQU   @NM00067
RCTDDEQ  EQU   @NM00067
RCTDSV16 EQU   @NM00067
RCTDSY12 EQU   @NM00067
RCTDPSUB EQU   @NM00067
RCTDRLL1 EQU   @NM00067
RCTDOLL1 EQU   @NM00067
RCTDENQ  EQU   @NM00067
@NM00066 EQU   @NM00065
@NM00064 EQU   @NM00063
RCTDCANE EQU   @NM00063
RCTDDETD EQU   @NM00063
RCTDDETS EQU   @NM00063
RCTDRES4 EQU   @NM00063
@NM00062 EQU   @NM00061
RCTDBR2A EQU   @NM00061
RCTDBR2R EQU   @NM00061
RCTDBR2Q EQU   @NM00061
RCTDBR2T EQU   @NM00061
RCTDLOOP EQU   @NM00061
RCTDWAIT EQU   @NM00061
RBRSV161 EQU   RBSECS09+64
RBSIRBWA EQU   RBSECS09
RBIQEWRK EQU   RBSECS08+4
RBNEXAV  EQU   RBSECS08
RBIQEA   EQU   RBIQE2
RBIQE1   EQU   RBIQE+1
RBUSE    EQU   RBIQE
RBSQEA   EQU   RBSQE+1
@NM00053 EQU   RBSQE
RBCDE1   EQU   RBCDE+1
RBCDLOAD EQU   RBCDFLGS
RBCDXCTL EQU   RBCDFLGS
RBCDSYNC EQU   RBCDFLGS
RBCDNODE EQU   RBCDFLGS
RBRSV010 EQU   RBCDFLGS
RBCDATCH EQU   RBCDFLGS
RBRSV009 EQU   RBCDFLGS
RBNOCELL EQU   RBCDFLGS
PSARSAV  EQU   PSARSVTE+60
PSARSTK  EQU   PSARSVTE+56
PSAESAV3 EQU   PSARSVTE+52
PSAESTK3 EQU   PSARSVTE+48
PSAESAV2 EQU   PSARSVTE+44
PSAESTK2 EQU   PSARSVTE+40
PSAESAV1 EQU   PSARSVTE+36
PSAESTK1 EQU   PSARSVTE+32
PSAPSAV  EQU   PSARSVTE+28
PSAPSTK  EQU   PSARSVTE+24
PSAMSAV  EQU   PSARSVTE+20
PSAMSTK  EQU   PSARSVTE+16
PSASSAV  EQU   PSARSVTE+12
PSASSTK  EQU   PSARSVTE+8
PSANSTK  EQU   PSARSVTE+4
CVTRV628 EQU   CVTS01+728
CVTRV627 EQU   CVTS01+724
CVTRV626 EQU   CVTS01+720
CVTRV625 EQU   CVTS01+716
CVTRV624 EQU   CVTS01+712
CVTRV623 EQU   CVTS01+708
CVTRV622 EQU   CVTS01+704
CVTRV621 EQU   CVTS01+700
CVTRV620 EQU   CVTS01+696
CVTRV619 EQU   CVTS01+692
CVTRV618 EQU   CVTS01+688
CVTRV617 EQU   CVTS01+684
CVTRV616 EQU   CVTS01+680
CVTRV615 EQU   CVTS01+676
CVTRV614 EQU   CVTS01+672
CVTRV613 EQU   CVTS01+668
CVTRV612 EQU   CVTS01+664
CVTRV611 EQU   CVTS01+660
CVTRV610 EQU   CVTS01+656
CVTRV609 EQU   CVTS01+652
CVTRV608 EQU   CVTS01+648
CVTRV607 EQU   CVTS01+644
CVTRV606 EQU   CVTS01+640
CVTRV605 EQU   CVTS01+636
CVTRV604 EQU   CVTS01+632
CVTEFF02 EQU   CVTS01+628
CVTCBBR  EQU   CVTS01+624
CVTSSCR  EQU   CVTS01+620
CVTEVENT EQU   CVTS01+616
CVTCRCA  EQU   CVTS01+612
CVTTPIO  EQU   CVTS01+608
CVTADV   EQU   CVTS01+604
CVTGSDAB EQU   CVTGSDA
CVTQV3   EQU   CVTS01+596
CVTQV2   EQU   CVTS01+592
CVTQV1   EQU   CVTS01+588
CVTRPT   EQU   CVTS01+584
CVTSSRB  EQU   CVTS01+580
CVTCSDRL EQU   CVTS01+576
CVTEXP1  EQU   CVTS01+572
CVTRMPMT EQU   CVTS01+568
CVTRMPTT EQU   CVTS01+564
CVTVPSA  EQU   CVTS01+560
CVTVSTOP EQU   CVTS01+556
CVTGTFR8 EQU   CVTS01+552
CVTQUIT  EQU   CVTS01+548
CVTVACR  EQU   CVTS01+544
CVTWTCB  EQU   CVTS01+540
CVTSTPRS EQU   CVTS01+536
CVT0PT02 EQU   CVTS01+532
CVTDARCM EQU   CVTS01+528
CVTIRECM EQU   CVTS01+524
CVTJRECM EQU   CVTS01+520
CVTVEMS0 EQU   CVTS01+516
CVTSPFRR EQU   CVTS01+512
CVTRLSTG EQU   CVTS01+508
CVT0TC0A EQU   CVTS01+504
CVTGMBR  EQU   CVTS01+500
CVTLFRM  EQU   CVTS01+496
CVTRMBR  EQU   CVTS01+492
CVTVIOP  EQU   CVTS01+488
CVTRV307 EQU   CVTS01+486
CVTRV306 EQU   CVTS01+484
CVTRV305 EQU   CVTS01+482
CVTRV304 EQU   CVTS01+480
CVTRV303 EQU   CVTS01+478
CVTRV302 EQU   CVTS01+476
CVTTRCA  EQU   CVTS01+472
CVTRV297 EQU   CVTRV289
CVTRV296 EQU   CVTRV289
CVTRV295 EQU   CVTRV289
CVTRV294 EQU   CVTRV289
CVTRV293 EQU   CVTRV289
CVTRV292 EQU   CVTRV289
CVTRV291 EQU   CVTRV289
CVTRV290 EQU   CVTRV289
CVTRV288 EQU   CVTRV280
CVTRV287 EQU   CVTRV280
CVTRV286 EQU   CVTRV280
CVTRV285 EQU   CVTRV280
CVTRV284 EQU   CVTRV280
CVTRV283 EQU   CVTRV280
CVTRV282 EQU   CVTRV280
CVTRV281 EQU   CVTRV280
CVTRV279 EQU   CVTRV271
CVTRV278 EQU   CVTRV271
CVTRV277 EQU   CVTRV271
CVTRV276 EQU   CVTRV271
CVTRV275 EQU   CVTRV271
CVTRV274 EQU   CVTRV271
CVTRV273 EQU   CVTRV271
CVTRV272 EQU   CVTRV271
CVTRV270 EQU   CVTRV262
CVTRV269 EQU   CVTRV262
CVTRV268 EQU   CVTRV262
CVTRV267 EQU   CVTRV262
CVTRV266 EQU   CVTRV262
CVTRV265 EQU   CVTRV262
CVTRV264 EQU   CVTRV262
CVTRV263 EQU   CVTRV262
CVTVFP   EQU   CVTS01+464
CVTVSI   EQU   CVTS01+460
CVTVPSIB EQU   CVTS01+456
CVTMFACT EQU   CVTMFRTR
CVTMFCTL EQU   CVTS01+448
CVTPVBP  EQU   CVTS01+444
CVTPWI   EQU   CVTS01+440
CVTRV254 EQU   CVTS01+438
CVTRV253 EQU   CVTS01+436
CVTRV252 EQU   CVTS01+434
CVTRV251 EQU   CVTS01+433
CVTRV250 EQU   CVTS01+432
CVTRV249 EQU   CVTS01+431
CVTRV248 EQU   CVTS01+430
CVTRV247 EQU   CVTS01+429
CVTRV246 EQU   CVTS01+428
CVTRV245 EQU   CVTRV237
CVTRV244 EQU   CVTRV237
CVTRV243 EQU   CVTRV237
CVTRV242 EQU   CVTRV237
CVTRV241 EQU   CVTRV237
CVTRV240 EQU   CVTRV237
CVTRV239 EQU   CVTRV237
CVTRV238 EQU   CVTRV237
CVTRV236 EQU   CVTRV228
CVTRV235 EQU   CVTRV228
CVTRV234 EQU   CVTRV228
CVTRV233 EQU   CVTRV228
CVTRV232 EQU   CVTRV228
CVTRV231 EQU   CVTRV228
CVTRV230 EQU   CVTRV228
CVTRV229 EQU   CVTRV228
CVTRV227 EQU   CVTRV219
CVTRV226 EQU   CVTRV219
CVTRV225 EQU   CVTRV219
CVTRV224 EQU   CVTRV219
CVTRV223 EQU   CVTRV219
CVTRV222 EQU   CVTRV219
CVTRV221 EQU   CVTRV219
CVTRV220 EQU   CVTRV219
CVTRV218 EQU   CVTRV210
CVTRV217 EQU   CVTRV210
CVTRV216 EQU   CVTRV210
CVTRV215 EQU   CVTRV210
CVTRV214 EQU   CVTRV210
CVTRV213 EQU   CVTRV210
CVTRV212 EQU   CVTRV210
CVTRV211 EQU   CVTRV210
CVTLCCAT EQU   CVTS01+420
CVTPCCAT EQU   CVTS01+416
CVTIPCRP EQU   CVTS01+412
CVTIPCRI EQU   CVTS01+408
CVTIPCDS EQU   CVTS01+404
CVTAIDVT EQU   CVTS01+400
CVTSSAP  EQU   CVTS01+396
CVTEHCIR EQU   CVTS01+392
CVTEHDEF EQU   CVTS01+388
CVTDAIR  EQU   CVTS01+384
CVTPERFM EQU   CVTS01+380
CVT044R2 EQU   CVTS01+376
CVTFETCH EQU   CVTS01+372
CVTRSTWD EQU   CVTS01+368
CVTSPOST EQU   CVTS01+364
CVTIOBP  EQU   CVTS01+360
CVTASMVT EQU   CVTS01+356
CVTRECRQ EQU   CVTS01+352
CVTWSAC  EQU   CVTS01+348
CVTRV149 EQU   CVTS01+344
CVTWSAL  EQU   CVTS01+340
CVTSPSA  EQU   CVTS01+336
CVTGLMN  EQU   CVTS01+332
CVTVEAC0 EQU   CVTS01+328
CVT062R1 EQU   CVTS01+324
CVTRPOST EQU   CVTS01+320
CVTDQIQE EQU   CVTS01+316
CVTCSD   EQU   CVTS01+312
CVTLKRMA EQU   CVTS01+308
CVTRSPIE EQU   CVTS01+304
CVTRENQ  EQU   CVTS01+300
CVTLQCB  EQU   CVTS01+296
CVTFQCB  EQU   CVTS01+292
CVTQCS01 EQU   CVTS01+288
CVTAPFT  EQU   CVTS01+284
CVTPARRL EQU   CVTS01+280
CVTVWAIT EQU   CVTS01+276
CVTGSPL  EQU   CVTS01+272
CVTLSMQ  EQU   CVTS01+268
CVTGSMQ  EQU   CVTS01+264
CVTEXPRO EQU   CVTS01+260
CVTOPCTP EQU   CVTS01+256
CVTSIC   EQU   CVTS01+252
CVTTPIOS EQU   CVTS01+248
CVTRTMS  EQU   CVTS01+244
CVTSDBF  EQU   CVTS01+240
CVTSCBP  EQU   CVTS01+236
CVTSDMP  EQU   CVTS01+232
CVTSV60  EQU   CVTS01+228
CVTRTMCT EQU   CVTS01+224
CVTASCBL EQU   CVTS01+220
CVTASCBH EQU   CVTS01+216
CVTGDA   EQU   CVTS01+212
CVTASVT  EQU   CVTS01+208
CVTVVMDI EQU   CVTS01+204
CVTAQTOP EQU   CVTS01+200
CVTIOSCS EQU   CVTS01+196
CVTSDRM  EQU   CVTS01+192
CVTOPTE  EQU   CVTS01+188
CVTSTXU  EQU   CVTS01+184
CVTQUIS  EQU   CVTS01+180
CVTPARS  EQU   CVTS01+176
CVTS1EE  EQU   CVTS01+172
CVTFRAS  EQU   CVTS01+168
CVTQSAS  EQU   CVTS01+164
CVTCRAS  EQU   CVTS01+160
CVTCRMN  EQU   CVTS01+156
CVTDELCP EQU   CVTS01+152
CVTFRECL EQU   CVTS01+148
CVTGETCL EQU   CVTS01+144
CVTBLDCP EQU   CVTS01+140
CVTAUTHL EQU   CVTS01+136
CVTSCAN  EQU   CVTS01+132
CVTRV144 EQU   CVTS01+130
CVTMAXMP EQU   CVTS01+128
CVTSTCK  EQU   CVTS01+124
CVTRV139 EQU   CVTS01+123
CVTDSSAC EQU   CVTS01+122
CVTRV513 EQU   CVTS01+121
CVTIOSPL EQU   CVTS01+120
CVTPTGT  EQU   CVTS01+116
CVTCSPIE EQU   CVTS01+112
CVTSMFEX EQU   CVTS01+108
CVTOLT0A EQU   CVTS01+104
CVTSRBRT EQU   CVTS01+100
CVTPUTL  EQU   CVTS01+96
CVTRV519 EQU   CVTS01+92
CVTRV327 EQU   CVTS01+88
CVTRV326 EQU   CVTS01+84
CVTRV325 EQU   CVTS01+80
CVTRV324 EQU   CVTS01+76
CVT0VL01 EQU   CVTS01+72
CVTSHRVM EQU   CVTS01+68
CVTRV332 EQU   CVTS01+64
CVTTAS   EQU   CVTS01+60
CVTRSCN  EQU   CVTS01+56
CVTTRAC2 EQU   CVTS01+54
CVTTRACE EQU   CVTS01+52
CVTAPG   EQU   CVTS01+51
CVTSDTRC EQU   CVTCTLFG
CVTGTRCE EQU   CVTCTLFG
CVTNOMP  EQU   CVTCTLFG
CVTRSV79 EQU   CVTCTLFG
CVTDSTAT EQU   CVTCTLFG
CVTRSV78 EQU   CVTCTLFG
CVTRV333 EQU   CVTCTLFG
CVTRV323 EQU   CVTCTLFG
CVTSPVLK EQU   CVTS01+49
CVTRSV77 EQU   CVTS01+48
CVTRV331 EQU   CVTS01+44
CVTRV330 EQU   CVTS01+40
CVTRV329 EQU   CVTS01+36
CVTRV328 EQU   CVTS01+32
CVTRV322 EQU   CVTS01+28
CVTSLID  EQU   CVTSLIDA+1
CVTSYLK  EQU   CVTSLIDA
CVTRV321 EQU   CVTS01+20
CVTRV320 EQU   CVTS01+16
CVTLPDIR EQU   CVTLPDIA+1
CVTRSV69 EQU   CVTDIRST
CVTRSV68 EQU   CVTDIRST
CVTRSV67 EQU   CVTDIRST
CVTRSV66 EQU   CVTDIRST
CVTRSV65 EQU   CVTDIRST
CVTRSV64 EQU   CVTDIRST
CVTRSV63 EQU   CVTDIRST
CVTDICOM EQU   CVTDIRST
CVTPVTP  EQU   CVTS01+8
CVTLPDSR EQU   CVTS01+4
CVTGETL  EQU   CVTS01
@NM00155 EQU   FRRWKA+20
@NM00154 EQU   FRRFLAGS+1
@NM00153 EQU   TCBXTNT2+32
TCBRV181 EQU   TCBRV173
TCBRV180 EQU   TCBRV173
TCBRV179 EQU   TCBRV173
TCBRV178 EQU   TCBRV173
TCBRV177 EQU   TCBRV173
TCBRV176 EQU   TCBRV173
TCBRV175 EQU   TCBRV173
TCBRV174 EQU   TCBRV173
TCBRV172 EQU   TCBRV164
TCBRV171 EQU   TCBRV164
TCBRV170 EQU   TCBRV164
TCBRV169 EQU   TCBRV164
TCBRV168 EQU   TCBRV164
TCBRV167 EQU   TCBRV164
TCBRV166 EQU   TCBRV164
TCBRV165 EQU   TCBRV164
TCBRV163 EQU   TCBRV155
TCBRV162 EQU   TCBRV155
TCBRV161 EQU   TCBRV155
TCBRV160 EQU   TCBRV155
TCBRV159 EQU   TCBRV155
TCBRV158 EQU   TCBRV155
TCBRV157 EQU   TCBRV155
TCBRV156 EQU   TCBRV155
TCBRV154 EQU   TCBRV146
TCBRV153 EQU   TCBRV146
TCBRV152 EQU   TCBRV146
TCBRV151 EQU   TCBRV146
TCBRV150 EQU   TCBRV146
TCBRV149 EQU   TCBRV146
TCBRV148 EQU   TCBRV146
TCBRV147 EQU   TCBRV146
TCBRV145 EQU   TCBXTNT2+26
TCBRV144 EQU   TCBXTNT2+24
TCBRV143 EQU   TCBXTNT2+20
TCBRV142 EQU   TCBXTNT2+16
TCBRSV49 EQU   TCBXTNT2+12
TCBEVENT EQU   TCBXTNT2+8
TCBRCMP  EQU   TCBXTNT2+5
TCBRSVAB EQU   TCBXTNT2+4
TCBGTFA  EQU   TCBGTF+1
TCBRSV47 EQU   TCBTFLG
TCBRSV46 EQU   TCBTFLG
TCBRSV45 EQU   TCBTFLG
TCBRSV44 EQU   TCBTFLG
TCBRSV43 EQU   TCBTFLG
TCBDSPIT EQU   TCBTFLG
TCBERRTN EQU   TCBTFLG
TCBASYNC EQU   TCBTFLG
@NM00152 EQU   TCB+296
TCBRV185 EQU   TCB+292
TCBSWASA EQU   TCB+288
TCBDBTB  EQU   TCB+284
TCBRPT   EQU   TCB+280
TCBRV141 EQU   TCBRV133
TCBRV140 EQU   TCBRV133
TCBRV139 EQU   TCBRV133
TCBRV138 EQU   TCBRV133
TCBRV137 EQU   TCBRV133
TCBRV136 EQU   TCBRV133
TCBRV135 EQU   TCBRV133
TCBRV134 EQU   TCBRV133
TCBRV132 EQU   TCBRV124
TCBRV131 EQU   TCBRV124
TCBRV130 EQU   TCBRV124
TCBRV129 EQU   TCBRV124
TCBRV128 EQU   TCBRV124
TCBRV127 EQU   TCBRV124
TCBRV126 EQU   TCBRV124
TCBRV125 EQU   TCBRV124
TCBRV123 EQU   TCBFBYT2
TCBRV122 EQU   TCBFBYT2
TCBECBNV EQU   TCBFBYT2
TCBSSSYN EQU   TCBFBYT2
TCBFPRAP EQU   TCBFBYT2
TCBFDW   EQU   TCBFBYT2
TCBFMW   EQU   TCBFBYT2
TCBCNCB  EQU   TCBFBYT2
TCBLLH   EQU   TCBFBYT1
TCBRV113 EQU   TCBFBYT1
TCBEOT   EQU   TCBFBYT1
TCBRTM2  EQU   TCBFBYT1
TCBPGNLY EQU   TCBFBYT1
TCBNDIOS EQU   TCBFBYT1
TCBACTIV EQU   TCBFBYT1
TCBEOTFM EQU   TCBFBYT1
TCBAFFN  EQU   TCB+274
TCBCCPVI EQU   TCB+272
TCBUKYSP EQU   TCB+268
TCBMODE  EQU   TCBESTAE+3
TCBERTYP EQU   TCBESTAE+2
TCBRV314 EQU   TCBESTRM
TCBRV313 EQU   TCBESTRM
TCBRV312 EQU   TCBESTRM
TCBRV311 EQU   TCBESTRM
TCBRV310 EQU   TCBESTRM
TCBRV309 EQU   TCBESTRM
TCBRV308 EQU   TCBESTRM
TCBETERM EQU   TCBESTRM
TCBSCBKY EQU   TCBESTAE
TCBRTM12 EQU   TCB+260
TCBTCBID EQU   TCB+256
TCBRSV96 EQU   TCB+252
TCBSWA   EQU   TCB+248
TCBFOEA  EQU   TCBFOE+1
TCBRSV42 EQU   TCBFOE
TCBRV306 EQU   TCB+240
TCBRSV41 EQU   TCB+239
TCBTID   EQU   TCB+238
TCBRSVAA EQU   TCB+237
TCBABCUR EQU   TCB+236
TCBTMSAV EQU   TCB+232
TCBIOTIM EQU   TCB+228
TCBRTWA  EQU   TCB+224
TCBBACK  EQU   TCB+220
TCBTIRB  EQU   TCB+216
TCBAECB  EQU   TCB+212
TCBEXT2A EQU   TCBEXT2+1
TCBRSV39 EQU   TCBEXT2
TCBSTMCT EQU   TCB+207
TCBSYSCT EQU   TCB+206
TCBRSV37 EQU   TCB+205
TCBEXSVC EQU   TCBDAR
TCBDARMS EQU   TCBDAR
TCBDARWT EQU   TCBDAR
TCBDARO  EQU   TCBDAR
TCBDARMC EQU   TCBDARC
TCBDARD  EQU   TCBDAR
TCBDARS  EQU   TCBDAR
TCBDARP  EQU   TCBDAR
TCBGTOFM EQU   TCBFLGS7
TCBADMP  EQU   TCBFLGS7
TCBRSTSK EQU   TCBFLGS7
TCBRSV35 EQU   TCBFLGS7
TCBSTACK EQU   TCBFLGS7
TCBRSV34 EQU   TCBFLGS7
TCBRSV33 EQU   TCBFLGS7
TCBGPECB EQU   TCBFLGS7
TCBNTJS  EQU   TCBFLGS6
TCBAPG   EQU   TCBFLGS6
TCBMIGR  EQU   TCBFLGS6
TCBRV303 EQU   TCBFLGS6
TCBSPVLK EQU   TCBFLGS6
TCBCPU   EQU   TCBFLGS6
TCBPIE17 EQU   TCBFLGS6
TCBRV    EQU   TCBFLGS6
TCBRSV79 EQU   TCBNDSP5
TCBRSV78 EQU   TCBNDSP5
TCBRSV77 EQU   TCBNDSP5
TCBRSV76 EQU   TCBNDSP5
TCBRSV75 EQU   TCBNDSP5
TCBRSV74 EQU   TCBNDSP5
TCBRSV95 EQU   TCBNDSP5
TCBRSV94 EQU   TCBNDSP5
TCBRSV93 EQU   TCBNDSP4
TCBRSV92 EQU   TCBNDSP4
TCBRSV91 EQU   TCBNDSP4
TCBRSV90 EQU   TCBNDSP4
TCBRSV89 EQU   TCBNDSP4
TCBRSV88 EQU   TCBNDSP4
TCBRSV87 EQU   TCBNDSP4
TCBRSV86 EQU   TCBNDSP4
TCBEXT1A EQU   TCBEXT1+1
TCBRSV32 EQU   TCBEXT1
TCBEXCPD EQU   TCB+192
TCBIOBRC EQU   TCB+188
TCBDDWTC EQU   TCB+186
TCBDDEXC EQU   TCB+184
TCBJSCBB EQU   TCBJSCB+1
@NM00151 EQU   TCBRECDE
TCBREC   EQU   TCBRECDE
TCBMDIDS EQU   TCB+176
TCBNDINT EQU   TCBNDSP3
TCBRSV27 EQU   TCBNDSP3
TCBRSV26 EQU   TCBNDSP3
TCBRSV25 EQU   TCBNDSP3
TCBRSV24 EQU   TCBNDSP3
TCBSRBND EQU   TCBNDSP3
TCBRV302 EQU   TCBNDSP3
TCBLJSND EQU   TCBNDSP3
TCBABE   EQU   TCBNDSP2
TCBDSS   EQU   TCBNDSP2
TCBOWAIT EQU   TCBNDSP2
TCBIWAIT EQU   TCBNDSP2
TCBNDTS  EQU   TCBNDSP2
TCBNDSVC EQU   TCBNDSP2
TCBSTPP  EQU   TCBNDSP2
TCBABD   EQU   TCBNDSP2
TCBRSV22 EQU   TCBNDSP1
TCBPIEND EQU   TCBNDSP1
TCBTPSP  EQU   TCBNDSP1
TCBDDRND EQU   TCBNDSP1
TCBRSPND EQU   TCBNDSP1
TCBRSTND EQU   TCBNDSP1
TCBDARPN EQU   TCBNDSP1
TCBDARTN EQU   TCBNDSP1
TCBNDSP0 EQU   TCBNDSP
TCBUSER  EQU   TCB+168
TCBTCTB  EQU   TCBTCT+1
TCBRSV9C EQU   TCBTCTGF
TCBRSV9B EQU   TCBTCTGF
TCBRSV9A EQU   TCBTCTGF
TCBRSV99 EQU   TCBTCTGF
TCBRSV98 EQU   TCBTCTGF
TCBRSV97 EQU   TCBTCTGF
TCBRSV20 EQU   TCBTCTGF
TCBSMFGF EQU   TCBTCTGF
TCBSTABB EQU   TCBSTAB+1
TCBSTCUR EQU   TCBNSTAE
TCBRV301 EQU   TCBNSTAE
TCBSYNCH EQU   TCBNSTAE
TCBHALT  EQU   TCBNSTAE
TCBPPSUP EQU   TCBNSTAE
TCB33E   EQU   TCBNSTAE
TCBQUIES EQU   TCBNSTAE
TCBSTABE EQU   TCBNSTAE
TCBAQE   EQU   TCB+156
TCBPQE   EQU   TCB+152
TCBTSDP  EQU   TCB+151
TCBTSLP  EQU   TCB+150
TCBSTPCT EQU   TCB+149
TCBCPUBN EQU   TCBTSFLG
TCBDYDSP EQU   TCBTSFLG
TCBRSV18 EQU   TCBTSFLG
TCBRSV17 EQU   TCBTSFLG
TCBATT   EQU   TCBTSFLG
TCBSTPPR EQU   TCBTSFLG
TCBRV300 EQU   TCBTSTSK
TCBECB   EQU   TCB+144
TCBIQE   EQU   TCB+140
TCBJSTCA EQU   TCBJSTCB+1
TCBRSV16 EQU   TCBJSTCB
TCBTQET  EQU   TCBTME
TCBFSAB  EQU   TCBFSA+1
TCBQEL   EQU   TCBFSA
TCBGRS15 EQU   TCBGRS+60
TCBGRS14 EQU   TCBGRS+56
TCBGRS13 EQU   TCBGRS+52
TCBGRS12 EQU   TCBGRS+48
TCBGRS11 EQU   TCBGRS+44
TCBGRS10 EQU   TCBGRS+40
TCBGRS9  EQU   TCBGRS+36
TCBGRS8  EQU   TCBGRS+32
TCBGRS7  EQU   TCBGRS+28
TCBGRS6  EQU   TCBGRS+24
TCBGRS5  EQU   TCBGRS+20
TCBGRS4  EQU   TCBGRS+16
TCBGRS3  EQU   TCBGRS+12
TCBGRS2  EQU   TCBGRS+8
TCBGRS1  EQU   TCBGRS+4
TCBGRS0  EQU   TCBGRS
TCBJPQB  EQU   TCBJPQ+1
TCBRSV15 EQU   TCBPURGE
TCBRSV14 EQU   TCBPURGE
TCBRSV13 EQU   TCBPURGE
TCBRSV12 EQU   TCBPURGE
TCBRSV11 EQU   TCBPURGE
TCBRSV10 EQU   TCBPURGE
TCBRSV09 EQU   TCBPURGE
TCBJPQF  EQU   TCBPURGE
TCBJLB   EQU   TCB+40
TCBLLS   EQU   TCB+36
TCBDSP   EQU   TCB+35
TCBLMP   EQU   TCB+34
TCBPNDSP EQU   TCBFLGS5
TCBFCD1  EQU   TCBFLGS5
TCBSTP   EQU   TCBFLGS5
TCBSYS   EQU   TCBFLGS5
TCBANDSP EQU   TCBFLGS5
TCBPAGE  EQU   TCBFLGS5
TCBUXNDF EQU   TCBABWF
TCBFC    EQU   TCBFLGS5
TCBONDSP EQU   TCBFLGS4
TCBMPCND EQU   TCBFLGS4
TCBMPCVQ EQU   TCBFLGS4
TCBUXNDV EQU   TCBFLGS4
TCBHNDSP EQU   TCBFLGS4
TCBRQENA EQU   TCBFLGS4
TCBSER   EQU   TCBFLGS4
TCBNDUMP EQU   TCBFLGS4
TCBDWSTA EQU   TCBFLGS3
TCBRSV08 EQU   TCBFLGS3
TCBRSV07 EQU   TCBFLGS3
TCBRSV06 EQU   TCBFLGS3
TCBABGM  EQU   TCBFLGS3
TCBABTRM EQU   TCBFLGS3
TCBADINP EQU   TCBFLGS3
TCBFSM   EQU   TCBFLGS3
TCBFTS   EQU   TCBFLGS2
TCBFETXR EQU   TCBFLGS2
TCBFDSOP EQU   TCBFLGS2
TCBFJMC  EQU   TCBFLGS2
TCBFSMC  EQU   TCBFLGS2
TCBFABOP EQU   TCBFLGS2
TCBFSTI  EQU   TCBFLGS2
TCBFOINP EQU   TCBFLGS2
TCBFX    EQU   TCBFLGS1
TCBFS    EQU   TCBFLGS1
TCBFT    EQU   TCBFLGS1
TCBPDUMP EQU   TCBFLGS1
TCBRSV04 EQU   TCBFLGS1
TCBFERA  EQU   TCBFLGS1
TCBFE    EQU   TCBFLGS1
TCBFA    EQU   TCBFLGS1
TCBZERO  EQU   TCBPKF
TCBFLAG  EQU   TCBPKF
TCBMSSB  EQU   TCBMSS+1
TCBRSV03 EQU   TCBMSS
TCBTRNB  EQU   TCBTRN+1
TCBRSV02 EQU   TCBABF
TCBOLTEP EQU   TCBABF
TCBTCP   EQU   TCBABF
TCBTCPP  EQU   TCBABF
TCBRSV01 EQU   TCBABF
TCBGRPH  EQU   TCBABF
TCBNOCHK EQU   TCBABF
TCBMOD91 EQU   TCBABF
TCBCMPC  EQU   TCBCMP+1
TCBRV318 EQU   TCBCMSG
TCBRV317 EQU   TCBCIND
TCBRV316 EQU   TCBCWTO
TCBCASID EQU   TCBCDBL
TCBNOCC  EQU   TCBSTCC
TCBDMPO  EQU   TCBCPP
TCBCSTEP EQU   TCBCMPF
TCBCREQ  EQU   TCBCMPF
TCBTIO   EQU   TCB+12
TCBDEB   EQU   TCB+8
TCBPIEA  EQU   TCBPIE+1
TCBPM    EQU   TCBPMASK
@NM00150 EQU   TCBPMASK
TCBFRS6  EQU   TCBFRS+24
TCBFRS4  EQU   TCBFRS+16
TCBFRS2  EQU   TCBFRS+8
TCBFRS0  EQU   TCBFRS
TAXEEND  EQU   TAXE+144
TAXEUSER EQU   TAXEWORK+40
TAXEIBUF EQU   TAXEWORK+36
TAXETAIE EQU   TAXEWORK+32
TAXESTAX EQU   TAXEPARM+1
@NM00149 EQU   TAXESTAT
TAXEFMOD EQU   TAXESTAT
TAXEFKEY EQU   TAXESTAT
TAXEEXIT EQU   TAXEWORK+24
@NM00148 EQU   TAXEWORK+20
TIQEIRB  EQU   TAXEWORK+8
TIQEPARM EQU   TAXEWORK+4
TAXENIQE EQU   TAXE+96
TAXEIRB  EQU   TAXE
@NM00147 EQU   SDWA+512
@NM00146 EQU   SDWADPVA
SDWAEBC  EQU   SDWADPVA
SDWAHEX  EQU   SDWADPVA
@NM00145 EQU   SDWA+396
SDWACOMP EQU   SDWA+392
SDWARCPL EQU   SDWA+364
@NM00144 EQU   SDWADPSA+32
SDWATO4  EQU   SDWADPSL+28
SDWAFRM4 EQU   SDWADPSL+24
SDWATO3  EQU   SDWADPSL+20
SDWAFRM3 EQU   SDWADPSL+16
SDWATO2  EQU   SDWADPSL+12
SDWAFRM2 EQU   SDWADPSL+8
SDWATO1  EQU   SDWADPSL+4
SDWAFRM1 EQU   SDWADPSL
@NM00143 EQU   SDWADDAT+3
@NM00142 EQU   SDWAPDAT
SDWAUSPL EQU   SDWAPDAT
SDWADPSW EQU   SDWAPDAT
SDWATJPA EQU   SDWAPDAT
SDWATLPA EQU   SDWAPDAT
SDWADREG EQU   SDWAPDAT
SDWADSAH EQU   SDWAPDAT
SDWADSAS EQU   SDWAPDAT
@NM00141 EQU   SDWADDAT+1
@NM00140 EQU   SDWASDAT
SDWAQQS  EQU   SDWASDAT
SDWACBS  EQU   SDWASDAT
SDWAGTF  EQU   SDWASDAT
SDWASWA  EQU   SDWASDAT
SDWALSQA EQU   SDWASDAT
SDWASQA  EQU   SDWASDAT
SDWANUC  EQU   SDWASDAT
@NM00139 EQU   SDWADUMP+2
@NM00138 EQU   SDWADPFS
SDWASLST EQU   SDWADPFS
@NM00137 EQU   SDWADPFS
SDWADLST EQU   SDWADPFS
SDWADPT  EQU   SDWADPFS
SDWADPID EQU   SDWADUMP
SDWADPLA EQU   SDWA+316
SDWAREXN EQU   SDWARECP+16
SDWACSCT EQU   SDWARECP+8
SDWAMODN EQU   SDWARECP
@NM00136 EQU   SDWA+290
SDWAASID EQU   SDWA+288
SDWATALW EQU   SDWALKWS+28
SDWATDLW EQU   SDWALKWS+24
SDWATNLW EQU   SDWALKWS+20
SDWAAPLW EQU   SDWALKWS+16
SDWAIPLW EQU   SDWALKWS+12
SDWAILLW EQU   SDWALKWS+8
SDWAIULW EQU   SDWALKWS+4
SDWAICLW EQU   SDWALKWS
SDWAFLLK EQU   SDWAACF4
SDWACMS  EQU   SDWAACF4
SDWAOPTM EQU   SDWAACF4
SDWATADB EQU   SDWAACF4
SDWATDNB EQU   SDWAACF4
SDWATNCB EQU   SDWAACF4
SDWAILCH EQU   SDWAACF4
SDWAIUCB EQU   SDWAACF4
SDWAICAT EQU   SDWAACF3
SDWAIPRG EQU   SDWAACF3
SDWASALL EQU   SDWAACF3
SDWAASMP EQU   SDWAACF3
SDWADISP EQU   SDWAACF3
@NM00135 EQU   SDWAACF3
@NM00134 EQU   SDWAACF2
SDWAFREE EQU   SDWAACF2
SDWAUPRG EQU   SDWAACF2
@NM00133 EQU   SDWAACF2
SDWASPIN EQU   SDWAACF2
@NM00132 EQU   SDWAACF2
SDWALCPU EQU   SDWACPUA+2
@NM00131 EQU   SDWACPUA
SDWARECA EQU   SDWA+244
SDWARTYA EQU   SDWA+240
@NM00130 EQU   SDWA+239
@NM00129 EQU   SDWAIOFS
SDWANIOP EQU   SDWAIOFS
SDWANOIO EQU   SDWAIOFS
SDWAIOHT EQU   SDWAIOFS
SDWAIOQR EQU   SDWAIOFS
@NM00128 EQU   SDWAERRD
SDWAMCIV EQU   SDWAERRD
SDWARPIV EQU   SDWAERRD
SDWAMABD EQU   SDWAERRD
SDWACTS  EQU   SDWAERRD
SDWASTAE EQU   SDWAERRD
SDWANRBE EQU   SDWAERRD
SDWACLUP EQU   SDWAERRD
@NM00127 EQU   SDWAERRC
SDWAEAS  EQU   SDWAERRC
SDWAPERC EQU   SDWAERRC
SDWAIRB  EQU   SDWAERRC
SDWASTAI EQU   SDWAERRC
SDWASTAF EQU   SDWAERRC
SDWASRBM EQU   SDWAERRB
SDWALDIS EQU   SDWAERRB
SDWAENRB EQU   SDWAERRB
SDWATYP1 EQU   SDWAERRB
@NM00126 EQU   SDWAERRB
SDWAPGIO EQU   SDWAERRA
SDWATEXC EQU   SDWAERRA
SDWASVCE EQU   SDWAERRA
SDWAABTM EQU   SDWAERRA
SDWASVCD EQU   SDWAERRA
SDWARKEY EQU   SDWAERRA
SDWAPCHK EQU   SDWAERRA
SDWAMCHK EQU   SDWAERRA
SDWATIME EQU   SDWAMCH+20
SDWARFSA EQU   SDWAMCH+16
@NM00125 EQU   SDWAMCH+14
SDWAVEQR EQU   SDWARSR2
SDWAPGFX EQU   SDWARSR2
SDWAFLSQ EQU   SDWARSR2
SDWAFSQA EQU   SDWARSR2
SDWANUCL EQU   SDWARSR2
SDWASPER EQU   SDWARSR2
SDWAINTC EQU   SDWARSR2
SDWAOFLN EQU   SDWARSR2
SDWACHNG EQU   SDWARSR1
SDWAMSER EQU   SDWARSR1
@NM00124 EQU   SDWARSR1
SDWACPID EQU   SDWAMCH+10
SDWATERR EQU   SDWAMCHD
SDWAFPRX EQU   SDWAMCHD
SDWAINSF EQU   SDWAMCHD
SDWAACR  EQU   SDWAMCHD
SDWASCK  EQU   SDWAMCHD
SDWAPSWU EQU   SDWAMCHD
SDWAREGU EQU   SDWAMCHD
SDWASKYF EQU   SDWAMCHD
@NM00123 EQU   SDWAMCHS
SDWARSRF EQU   SDWAMCHS
SDWARSRC EQU   SDWAMCHS
SDWAINVP EQU   SDWAMCHS
SDWATSVL EQU   SDWAMCHS
SDWARCDF EQU   SDWAMCHS
SDWASRVL EQU   SDWAMCHS
SDWASCKE EQU   SDWASTCK+4
SDWASCKB EQU   SDWASTCK
SDWALNTH EQU   SDWAIDNT+1
SDWASPID EQU   SDWAIDNT
SDWASR15 EQU   SDWASRSV+60
SDWASR14 EQU   SDWASRSV+56
SDWASR13 EQU   SDWASRSV+52
SDWASR12 EQU   SDWASRSV+48
SDWASR11 EQU   SDWASRSV+44
SDWASR10 EQU   SDWASRSV+40
SDWASR09 EQU   SDWASRSV+36
SDWASR08 EQU   SDWASRSV+32
SDWASR07 EQU   SDWASRSV+28
SDWASR06 EQU   SDWASRSV+24
SDWASR05 EQU   SDWASRSV+20
SDWASR04 EQU   SDWASRSV+16
SDWASR03 EQU   SDWASRSV+12
SDWASR02 EQU   SDWASRSV+8
SDWASR01 EQU   SDWASRSV+4
SDWASR00 EQU   SDWASRSV
SDWATRN2 EQU   SDWAAEC2+4
SDWAIPC2 EQU   SDWAICD2
SDWAIMC2 EQU   SDWAICD2
SDWAIPR2 EQU   SDWAICD2
@NM00122 EQU   SDWAINC2
@NM00121 EQU   SDWAILC2
SDWAIL2  EQU   SDWAILC2
@NM00120 EQU   SDWAILC2
@NM00119 EQU   SDWAAEC2
SDWAADD2 EQU   SDWANXT2+1
@NM00118 EQU   SDWANXT2
@NM00117 EQU   SDWAEC2+3
SDWASGN2 EQU   SDWAINT2
SDWAEXP2 EQU   SDWAINT2
SDWADEC2 EQU   SDWAINT2
SDWAFPO2 EQU   SDWAINT2
SDWACC2  EQU   SDWAINT2
@NM00116 EQU   SDWAINT2
SDWAPGM2 EQU   SDWAMWP2
SDWAWAT2 EQU   SDWAMWP2
SDWAMCK2 EQU   SDWAMWP2
SDWAECT2 EQU   SDWAMWP2
SDWAKEY2 EQU   SDWAMWP2
SDWAEXT2 EQU   SDWAEMK2
SDWAIO2  EQU   SDWAEMK2
SDWATRM2 EQU   SDWAEMK2
@NM00115 EQU   SDWAEMK2
SDWAPER2 EQU   SDWAEMK2
@NM00114 EQU   SDWAEMK2
SDWATRAN EQU   SDWAAEC1+4
SDWAIPC1 EQU   SDWAICD1
SDWAIMC1 EQU   SDWAICD1
SDWAIPR1 EQU   SDWAICD1
@NM00113 EQU   SDWAINC1
@NM00112 EQU   SDWAILC1
SDWAIL1  EQU   SDWAILC1
@NM00111 EQU   SDWAILC1
@NM00110 EQU   SDWAAEC1
SDWAADD1 EQU   SDWANXT1+1
@NM00109 EQU   SDWANXT1
@NM00108 EQU   SDWAEC1+3
SDWASGN1 EQU   SDWAINT1
SDWAEXP1 EQU   SDWAINT1
SDWADEC1 EQU   SDWAINT1
SDWAFPO1 EQU   SDWAINT1
SDWACC1  EQU   SDWAINT1
@NM00107 EQU   SDWAINT1
SDWAPGM1 EQU   SDWAMWP1
SDWAWAT1 EQU   SDWAMWP1
SDWAMCK1 EQU   SDWAMWP1
SDWAECT1 EQU   SDWAMWP1
SDWAKEY1 EQU   SDWAMWP1
SDWAEXT1 EQU   SDWAEMK1
SDWAIO1  EQU   SDWAEMK1
SDWATRM1 EQU   SDWAEMK1
@NM00106 EQU   SDWAEMK1
SDWAPER1 EQU   SDWAEMK1
@NM00105 EQU   SDWAEMK1
SDWAIOBR EQU   SDWA+100
SDWAEPA  EQU   SDWA+96
@NM00104 EQU   SDWANAME+4
SDWARBAD EQU   SDWANAME
SDWAGR15 EQU   SDWAGRSV+60
SDWAGR14 EQU   SDWAGRSV+56
SDWAGR13 EQU   SDWAGRSV+52
SDWAGR12 EQU   SDWAGRSV+48
SDWAGR11 EQU   SDWAGRSV+44
SDWAGR10 EQU   SDWAGRSV+40
SDWAGR09 EQU   SDWAGRSV+36
SDWAGR08 EQU   SDWAGRSV+32
SDWAGR07 EQU   SDWAGRSV+28
SDWAGR06 EQU   SDWAGRSV+24
SDWAGR05 EQU   SDWAGRSV+20
SDWAGR04 EQU   SDWAGRSV+16
SDWAGR03 EQU   SDWAGRSV+12
SDWAGR02 EQU   SDWAGRSV+8
SDWAGR01 EQU   SDWAGRSV+4
SDWAGR00 EQU   SDWAGRSV
SDWANXTP EQU   SDWACTL2+5
SDWASGP  EQU   SDWAPMKP
SDWAEUP  EQU   SDWAPMKP
SDWADOP  EQU   SDWAPMKP
SDWAFPP  EQU   SDWAPMKP
SDWACCP  EQU   SDWAPMKP
SDWAILP  EQU   SDWAPMKP
SDWAINTP EQU   SDWACTL2+2
SDWASPVP EQU   SDWAMWPP
SDWAWATP EQU   SDWAMWPP
SDWAMCKP EQU   SDWAMWPP
@NM00103 EQU   SDWAMWPP
SDWAKEYP EQU   SDWAMWPP
SDWAEXTP EQU   SDWACMKP
SDWAIOP  EQU   SDWACMKP
SDWANXTA EQU   SDWACTL1+5
SDWASGA  EQU   SDWAPMKA
SDWAEUA  EQU   SDWAPMKA
SDWADOA  EQU   SDWAPMKA
SDWAFPA  EQU   SDWAPMKA
SDWACCA  EQU   SDWAPMKA
SDWAILA  EQU   SDWAPMKA
SDWAINTA EQU   SDWACTL1+2
SDWASPVA EQU   SDWAMWPA
SDWAWATA EQU   SDWAMWPA
SDWAMCKA EQU   SDWAMWPA
@NM00102 EQU   SDWAMWPA
SDWAKEYA EQU   SDWAMWPA
SDWAEXTA EQU   SDWACMKA
SDWAIOA  EQU   SDWACMKA
SDWACMPC EQU   SDWAABCC+1
@NM00101 EQU   SDWACMPF
SDWASTCC EQU   SDWACMPF
@NM00100 EQU   SDWACMPF
SDWASTEP EQU   SDWACMPF
SDWAREQ  EQU   SDWACMPF
@NM00099 EQU   SCVTSECT+180
@NM00098 EQU   SCVTSECT+176
SCVTPIQE EQU   SCVTSECT+172
@NM00097 EQU   SCVTSECT+168
SCVTPTRM EQU   SCVTSECT+164
@NM00096 EQU   SCVTSECT+160
@NM00095 EQU   SCVTSECT+156
SCVTQCBR EQU   SCVTSECT+152
@NM00094 EQU   SCVTSECT+144
SCVTTQE  EQU   SCVTSECT+140
@NM00093 EQU   SCVTSECT+136
SCVTSVCT EQU   SCVTSECT+132
@NM00092 EQU   SCVTSECT+128
@NM00091 EQU   SCVTSECT+124
SCVTRXLQ EQU   SCVTSECT+120
@NM00090 EQU   SCVTSECT+116
SCVTCTCB EQU   SCVTSECT+112
@NM00089 EQU   SCVTSECT+108
@NM00088 EQU   SCVTSECT+104
@NM00087 EQU   SCVTSECT+100
@NM00086 EQU   SCVTSECT+96
SCVTCOMM EQU   SCVTSECT+92
@NM00085 EQU   SCVTSECT+88
@NM00084 EQU   SCVTSECT+84
@NM00083 EQU   SCVTSECT+80
@NM00082 EQU   SCVTSECT+76
@NM00081 EQU   SCVTSECT+72
SCVTGMBR EQU   SCVTSECT+68
SCVTRPTR EQU   SCVTSECT+64
SCVTHSKP EQU   SCVTSECT+60
@NM00080 EQU   SCVTSECT+56
@NM00079 EQU   SCVTSECT+52
SCVTLFRM EQU   SCVTSECT+48
SCVTCDCL EQU   SCVTSECT+44
@NM00078 EQU   SCVTSECT+40
SCVTRACE EQU   SCVTSECT+36
@NM00077 EQU   SCVTSECT+32
SCVTRMBR EQU   SCVTSECT+28
@NM00076 EQU   SCVTSECT+24
@NM00075 EQU   SCVTSECT+20
@NM00074 EQU   SCVTSECT+16
@NM00073 EQU   SCVTSECT+14
SCVTBR14 EQU   SCVTSECT+12
SCVTSPET EQU   SCVTSECT+8
SCVTPGWR EQU   SCVTSECT+4
SCVTPGTM EQU   SCVTSECT
RCTDEND  EQU   RCTD+240
RCTDRES1 EQU   RCTD+224
RCTDRES5 EQU   RCTDINTF+1
@NM00060 EQU   RCTDRCTF
RCTDDLCK EQU   RCTDRCTF
RCTDSRBN EQU   RCTDRCTF
RCTDPRGR EQU   RCTDRCTF
RCTDSUBN EQU   RCTDRCTF
RCTDRSBO EQU   RCTDRCTF
@NM00059 EQU   RCTDFLGS
RCTDBRCP EQU   RCTDFLGS
RCTDATTS EQU   RCTDFLGS
RCTDRES3 EQU   RCTDFLGS
RCTDATTD EQU   RCTDFLGS
@NM00058 EQU   RCTDMOID
RCTDTERM EQU   RCTDMOID
RCTDATTN EQU   RCTDMOID
RCTDREST EQU   RCTDMOID
RCTDQUIS EQU   RCTDMOID
RCTDCOMN EQU   RCTDMOID
RCTDINIT EQU   RCTDMOID
RCTDSCLR EQU   RCTDSLST
RCTDRTY@ EQU   RCTD+188
RCTDRTRY EQU   RCTD+184
RCTDBASE EQU   RCTDPIRL+1
@NM00057 EQU   RCTDPIRL
RCTDRET@ EQU   RCTD+168
@NM00056 EQU   RCTDTECB
RCTDPOST EQU   RCTDTECB
@NM00055 EQU   RCTDTECB
RCTDECBE EQU   RCTDWPTR
RCTDTPTR EQU   RCTDECBS
RCTDRES2 EQU   RCTD+152
RCTDPRG  EQU   RCTDCLRL+8
@NM00054 EQU   RCTDTIME+4
RCTDTMLH EQU   RCTDTIME
RCTDTCBS EQU   RCTD+76
RCTDTCBD EQU   RCTD+72
RCTDBEGN EQU   RCTD
SIRBEND  EQU   RBSECT+168
SVRBEND  EQU   RBSECT+168
RBRSV158 EQU   RBRSV150
RBRSV157 EQU   RBRSV150
RBRSV156 EQU   RBRSV150
RBRSV155 EQU   RBRSV150
RBRSV154 EQU   RBRSV150
RBRSV153 EQU   RBRSV150
RBRSV152 EQU   RBRSV150
RBRSV151 EQU   RBRSV150
RBRSV149 EQU   RBSECT+166
RBRSV148 EQU   RBSECT+164
RBSCBB   EQU   RBSECT+144
TIRBEND  EQU   @NM00052+8
PRBEND   EQU   @NM00052+8
RBRSV146 EQU   RBRSV138
RBRSV145 EQU   RBRSV138
RBRSV144 EQU   RBRSV138
RBRSV143 EQU   RBRSV138
RBRSV142 EQU   RBRSV138
RBRSV141 EQU   RBRSV138
RBRSV140 EQU   RBRSV138
RBRSV139 EQU   RBRSV138
RBRSV137 EQU   @NM00052+6
RBRSV136 EQU   @NM00052+4
RBRSV135 EQU   @NM00052
@NM00051 EQU   RBSECT+32
@NM00050 EQU   @NM00048+1
@NM00049 EQU   @NM00048
RBPGMQ1  EQU   RBPGMQ+1
@NM00047 EQU   RBPGMQ
@NM00046 EQU   RBSECT+16
@NM00045 EQU   @NM00041
@NM00044 EQU   @NM00041
RBIQETP  EQU   @NM00041
RBUSIQE  EQU   RBETXR
RBATTN   EQU   @NM00041
@NM00043 EQU   @NM00041
@NM00042 EQU   @NM00041
RBPMSVRB EQU   @NM00039
RBATNXIT EQU   @NM00039
@NM00040 EQU   @NM00039
RBWAITP  EQU   @NM00039
RBFNSVRB EQU   RBTRSVRB
RBSIZE   EQU   RBSECT+8
RBABOPSW EQU   RBSECT+4
RBPPSAV1 EQU   RBPPSAV+1
@NM00037 EQU   RBPPSAV
RBPRFXND EQU   RBPREFIX+64
RBINLNTH EQU   RBINTCDA
RBWCSA   EQU   RBPREFIX+60
RBRSV004 EQU   RBPREFIX+57
RBSSSYN  EQU   RBFLAGS1
RBSCB    EQU   RBFLAGS1
RBLONGWT EQU   RBFLAGS1
RBASIR   EQU   RBFLAGS1
RBRSV159 EQU   RBFLAGS1
RBABEND  EQU   RBFLAGS1
RBXWAIT  EQU   RBFLAGS1
RBSLOCK  EQU   RBFLAGS1
RBRTRAN  EQU   RBRTPSW2+4
RBRTINCD EQU   RBRTICIL+2
RBRTILC  EQU   RBRTICIL+1
RBRSV160 EQU   RBRTICIL
RBRTPSW1 EQU   RBRTOPSW
RBRSV062 EQU   RBRSV054
RBRSV061 EQU   RBRSV054
RBRSV060 EQU   RBRSV054
RBRSV059 EQU   RBRSV054
RBRSV058 EQU   RBRSV054
RBRSV057 EQU   RBRSV054
RBRSV056 EQU   RBRSV054
RBRSV055 EQU   RBRSV054
RBRSV053 EQU   RBPREFIX+38
RBRSV052 EQU   RBPREFIX+36
RBRSV051 EQU   RBPREFIX+32
RBPRFXST EQU   RBPREFIX+32
RBRSV050 EQU   RBPREFIX+28
RBRSV049 EQU   RBRSV041
RBRSV048 EQU   RBRSV041
RBRSV047 EQU   RBRSV041
RBRSV046 EQU   RBRSV041
RBRSV045 EQU   RBRSV041
RBRSV044 EQU   RBRSV041
RBRSV043 EQU   RBRSV041
RBRSV042 EQU   RBRSV041
RBRSV040 EQU   RBPREFIX+26
RBRSV039 EQU   RBPREFIX+24
RBRSV038 EQU   RBPREFIX+20
RBRSV037 EQU   RBPREFIX+16
RBRSV036 EQU   RBRSV028
RBRSV035 EQU   RBRSV028
RBRSV034 EQU   RBRSV028
RBRSV033 EQU   RBRSV028
RBRSV032 EQU   RBRSV028
RBRSV031 EQU   RBRSV028
RBRSV030 EQU   RBRSV028
RBRSV029 EQU   RBRSV028
RBRSV027 EQU   RBRSV019
RBRSV026 EQU   RBRSV019
RBRSV025 EQU   RBRSV019
RBRSV024 EQU   RBRSV019
RBRSV023 EQU   RBRSV019
RBRSV022 EQU   RBRSV019
RBRSV021 EQU   RBRSV019
RBRSV020 EQU   RBRSV019
RBRSV018 EQU   RBPREFIX+13
RBRSV017 EQU   RBPREFIX+12
RBSRV016 EQU   RBPREFIX+11
RBRSV015 EQU   RBPREFIX+10
RBRSV014 EQU   RBPREFIX+8
RBRSV013 EQU   RBPREFIX+4
RBRSV012 EQU   RBPREFIX
RBEXSAVE EQU   XRBESA
XRBREG15 EQU   RBGRS15
XRBREG14 EQU   RBGRS14
XRBREG13 EQU   RBGRS13
XRBREG12 EQU   RBGRS12
XRBREG11 EQU   RBGRS11
XRBREG10 EQU   RBGRS10
XRBREG9  EQU   RBGRS9
XRBREG8  EQU   RBGRS8
XRBREG7  EQU   RBGRS7
XRBREG6  EQU   RBGRS6
XRBREG5  EQU   RBGRS5
XRBREG4  EQU   RBGRS4
XRBREG3  EQU   RBGRS3
XRBREG2  EQU   RBGRS2
XRBREG1  EQU   RBGRS1
XRBREG0  EQU   RBGRS0
XRBLNKA  EQU   RBLINKB
XRBWT    EQU   RBWCF
@NM00036 EQU   RBBASIC+24
XRBPSW   EQU   RBOPSW
@NM00035 EQU   RBBASIC+12
XRBWAIT  EQU   RBECBWT
XRBFRRB  EQU   RBFDYN
@NM00034 EQU   XSTAB2
XRBACTV  EQU   RBFACTV
XRBTCBP  EQU   RBTCBNXT
@NM00033 EQU   XSTAB1
XRBCKPT  EQU   RBFTCKPT
@NM00032 EQU   XSTAB1
@NM00031 EQU   RBBASIC+8
@NM00030 EQU   RBEXRTNM+1
RBTMIND3 EQU   RBTMFLD
RBTMIND2 EQU   RBTMFLD
RBTMCMP  EQU   RBTMFLD
RBWLIM   EQU   RBTMFLD
RBRSV005 EQU   RBTMFLD
RBTMTOD  EQU   RBTMFLD
RBTMQUE  EQU   RBTMFLD
@NM00029 EQU   RBPRFX
@NM00004 EQU   FRRSFLGS+1
@NM00003 EQU   FRRSFLG1
FRRSNEST EQU   FRRSFLG1
FRRSRCUR EQU   FRRSFLG1
FRRSENTS EQU   FRRS+84
FRRSRTMW EQU   FRRS+16
CVTLEVL  EQU   CVTRELNO+2
CVTNUMB  EQU   CVTRELNO
CVTMDL   EQU   CVTFIX+250
@NM00002 EQU   CVTFIX+248
@NM00001 EQU   CVTFIX
CVTRV482 EQU   CVTXTNT2+128
CVTRV481 EQU   CVTXTNT2+124
CVTRV480 EQU   CVTXTNT2+120
CVTRV479 EQU   CVTXTNT2+118
CVTRV478 EQU   CVTXTNT2+117
CVTRV477 EQU   CVTXTNT2+116
CVTRV476 EQU   CVTXTNT2+115
CVTRV475 EQU   CVTXTNT2+114
CVTRV474 EQU   CVTRV466
CVTRV473 EQU   CVTRV466
CVTRV472 EQU   CVTRV466
CVTRV471 EQU   CVTRV466
CVTRV470 EQU   CVTRV466
CVTRV469 EQU   CVTRV466
CVTRV468 EQU   CVTRV466
CVTRV467 EQU   CVTRV466
CVTRV465 EQU   CVTRV457
CVTRV464 EQU   CVTRV457
CVTRV463 EQU   CVTRV457
CVTRV462 EQU   CVTRV457
CVTRV461 EQU   CVTRV457
CVTRV460 EQU   CVTRV457
CVTRV459 EQU   CVTRV457
CVTRV458 EQU   CVTRV457
CVTRV456 EQU   CVTXTNT2+108
CVTRV455 EQU   CVTXTNT2+104
CVTRV454 EQU   CVTXTNT2+100
CVTRV453 EQU   CVTXTNT2+96
CVTRV452 EQU   CVTXTNT2+94
CVTRV451 EQU   CVTXTNT2+92
CVTRV450 EQU   CVTXTNT2+90
CVTRV449 EQU   CVTXTNT2+88
CVTRV448 EQU   CVTXTNT2+87
CVTRV447 EQU   CVTXTNT2+86
CVTRV446 EQU   CVTRV438
CVTRV445 EQU   CVTRV438
CVTRV444 EQU   CVTRV438
CVTRV443 EQU   CVTRV438
CVTRV442 EQU   CVTRV438
CVTRV441 EQU   CVTRV438
CVTRV440 EQU   CVTRV438
CVTRV439 EQU   CVTRV438
CVTRV437 EQU   CVTRV429
CVTRV436 EQU   CVTRV429
CVTRV435 EQU   CVTRV429
CVTRV434 EQU   CVTRV429
CVTRV433 EQU   CVTRV429
CVTRV432 EQU   CVTRV429
CVTRV431 EQU   CVTRV429
CVTRV430 EQU   CVTRV429
CVTRV428 EQU   CVTXTNT2+80
CVTRV427 EQU   CVTXTNT2+76
CVTRV426 EQU   CVTXTNT2+72
CVTRV425 EQU   CVTXTNT2+68
CVTATACT EQU   CVTATCVT
CVTRV423 EQU   CVTXTNT2+62
CVTRV422 EQU   CVTXTNT2+60
CVTRV421 EQU   CVTXTNT2+58
CVTRV420 EQU   CVTXTNT2+56
CVTRV419 EQU   CVTXTNT2+55
CVTRV418 EQU   CVTXTNT2+54
CVTRV417 EQU   CVTRV409
CVTRV416 EQU   CVTRV409
CVTRV415 EQU   CVTRV409
CVTRV414 EQU   CVTRV409
CVTRV413 EQU   CVTRV409
CVTRV412 EQU   CVTRV409
CVTRV411 EQU   CVTRV409
CVTRV410 EQU   CVTRV409
CVTRV408 EQU   CVTRV400
CVTRV407 EQU   CVTRV400
CVTRV406 EQU   CVTRV400
CVTRV405 EQU   CVTRV400
CVTRV404 EQU   CVTRV400
CVTRV403 EQU   CVTRV400
CVTRV402 EQU   CVTRV400
CVTRV401 EQU   CVTRV400
CVTICB   EQU   CVTXTNT2+48
CVTSKTA  EQU   CVTXTNT2+44
CVTRSV99 EQU   CVTXTNT2+40
CVTRSV98 EQU   CVTXTNT2+36
CVTRSV97 EQU   CVTXTNT2+34
CVTRSV96 EQU   CVTXTNT2+32
CVTOLTEP EQU   CVTXTNT2+28
CVTQIDA  EQU   CVTQID+1
CVTRSV95 EQU   CVTQID
CVTRSV94 EQU   CVTXTNT2+20
CVTRSV93 EQU   CVTXTNT2+16
CVTRSV92 EQU   CVTXTNT2+12
CVTDEBVR EQU   CVTXTNT2+8
CVTRSV91 EQU   CVTXTNT2+6
CVTRSV9H EQU   CVTFLGBT
CVTRSV9G EQU   CVTFLGBT
CVTRSV9F EQU   CVTFLGBT
CVTRSV9E EQU   CVTFLGBT
CVTRSV9D EQU   CVTFLGBT
CVTRSV9C EQU   CVTFLGBT
CVTVME   EQU   CVTFLGBT
CVTNPE   EQU   CVTFLGBT
CVTNUCLS EQU   CVTXTNT2+4
CVTDSSVA EQU   CVTDSSV+1
CVTRSV89 EQU   CVTDSSV
CVTRSV88 EQU   CVTXTNT1+8
CVTRSV87 EQU   CVTXTNT1+4
CVTFACHN EQU   CVTXTNT1
CVTRV488 EQU   CVTMAP+412
CVTRV487 EQU   CVTMAP+408
CVTRV486 EQU   CVTMAP+404
CVTRV485 EQU   CVTMAP+400
CVTACTAP EQU   CVTMAP+396
CVTAUTH  EQU   CVTMAP+392
CVTATMCA EQU   CVTATMCT+1
CVTATMST EQU   CVTATMCT
CVTRSV61 EQU   CVTMAP+384
CVTVOLT1 EQU   CVTVOLM1+1
CVTVOLI1 EQU   CVTVOLF1
CVTSTOA  EQU   CVTMAP+376
CVTRSV58 EQU   CVTMAP+374
CVTRSV57 EQU   CVTMAP+372
CVTDDCE  EQU   CVTMAP+368
CVTPNWFR EQU   CVTMAP+364
CVTSMF   EQU   CVTMAP+360
CVTSULK  EQU   CVTMAP+358
CVTSLKO  EQU   CVTSYSK
CVTSLKP  EQU   CVTSYSK
CVTSLKQ  EQU   CVTSYSK
CVTSLKR  EQU   CVTSYSK
CVTRSV56 EQU   CVTSYSK
CVTRSV55 EQU   CVTSYSK
CVTRSV54 EQU   CVTSYSK
CVTRSV53 EQU   CVTSYSK
CVTRSV52 EQU   CVTA1F1
CVTRSV51 EQU   CVTA1F1
CVTRSV50 EQU   CVTA1F1
CVTRSV49 EQU   CVTA1F1
CVTRSV48 EQU   CVTA1F1
CVTRSV47 EQU   CVTA1F1
CVTSRSW  EQU   CVTA1F1
CVTPFSW  EQU   CVTA1F1
CVTPCVT  EQU   CVTMAP+352
CVTRSV46 EQU   CVTMAP+344
CVTRSV45 EQU   CVTMAP+340
CVTRSV44 EQU   CVTMAP+338
CVTRSV43 EQU   CVTMAP+336
CVTHJESA EQU   CVTHJES+1
CVTRSV42 EQU   CVTHJES
CVTEXT2A EQU   CVTEXT2+1
CVTRSV41 EQU   CVTEXT2
CVTAPFA  EQU   CVTAPF+1
CVTRSV40 EQU   CVTAPF
CVTRV518 EQU   CVTINTLA
CVTRV517 EQU   CVTERPV
CVTEORM  EQU   CVTMAP+312
CVTMCHPR EQU   CVTMAP+308
CVTTZ    EQU   CVTMAP+304
CVTJEPS  EQU   CVTMAP+300
CVTJESCT EQU   CVTMAP+296
CVTMODE  EQU   CVTMAP+292
CVTPTRV  EQU   CVTMAP+288
CVTREAL  EQU   CVTMAP+284
CVTRSV39 EQU   CVTMAP+280
CVTRSV38 EQU   CVTMAP+276
CVTDMSRA EQU   CVTDMSR+1
CVTRSV37 EQU   CVTDMSR
CVTQMSGA EQU   CVTQMSG+1
CVTRSV36 EQU   CVTQMSG
CVTAMFF  EQU   CVTMAP+264
CVTPURGA EQU   CVTPURG+1
CVTRSV35 EQU   CVTPURG
CVTCBSP  EQU   CVTMAP+256
CVTATERA EQU   CVTATER+1
CVTSYST  EQU   CVTATER
CVTVOLT2 EQU   CVTTAT
CVTVOLI2 EQU   CVTVOLF2
CVTAQAVB EQU   CVTAQAVT+1
CVTRSV34 EQU   CVTTCMFG
CVTRSV33 EQU   CVTTCMFG
CVTRSV32 EQU   CVTTCMFG
CVTRSV31 EQU   CVTTCMFG
CVTRSV30 EQU   CVTTCMFG
CVTRSV29 EQU   CVTTCMFG
CVTRSV28 EQU   CVTTCMFG
CVTTCRDY EQU   CVTTCMFG
CVTGTFA  EQU   CVTGTF+1
CVTRSV27 EQU   CVTGTFST
CVTRNIO  EQU   CVTGTFST
CVTUSR   EQU   CVTGTFST
CVTRV318 EQU   CVTFORM
CVTRV317 EQU   CVTTMODE
CVTRV316 EQU   CVTSTATE
CVTRV315 EQU   CVTGTFS
CVTGTFAV EQU   CVTGTFS
CVT0SCR1 EQU   CVTMAP+232
CVTRV515 EQU   CVTMAP+228
CVTRMS   EQU   CVTMAP+224
CVTPATCH EQU   CVTMAP+220
CVTTSCE  EQU   CVTMAP+216
CVTLNKSC EQU   CVTMAP+214
CVTQABST EQU   CVTMAP+212
CVTMDLDS EQU   CVTMAP+208
CVTUSER  EQU   CVTMAP+204
CVTSMCA  EQU   CVTMAP+196
CVTRSV18 EQU   CVTMAP+192
CVTQLPAQ EQU   CVTMAP+188
CVTQCDSR EQU   CVTMAP+184
CVTRSV17 EQU   CVTOPTB
CVTRSV16 EQU   CVTOPTB
CVTFP    EQU   CVTOPTB
CVTAPTHR EQU   CVTOPTB
CVTNLOG  EQU   CVTOPTB
CVTTOD   EQU   CVTOPTB
CVTCTIMS EQU   CVTOPTB
CVTPROT  EQU   CVTOPTB
CVTXPFP  EQU   CVTOPTA
CVTASCII EQU   CVTOPTA
CVTRSV13 EQU   CVTOPTA
CVTRSV12 EQU   CVTOPTA
CVTNIP   EQU   CVTOPTA
CVTDDR   EQU   CVTOPTA
CVTAPR   EQU   CVTOPTA
CVTCCH   EQU   CVTOPTA
CVTSNCTR EQU   CVTMAP+180
CVTQMWR  EQU   CVTMAP+176
CVTQOCR  EQU   CVTMAP+172
CVT1EF00 EQU   CVTMAP+168
CVTMZ00  EQU   CVTMAP+164
CVTHEAD  EQU   CVTMAP+160
CVTRSV11 EQU   CVTMAP+156
CVT0PT01 EQU   CVTMAP+152
CVTMSER  EQU   CVTMAP+148
CVTRV516 EQU   CVTIERLC
CVTILCH  EQU   CVTMAP+140
CVT0DS   EQU   CVTMAP+136
CVTFBOSV EQU   CVTMAP+132
CVTNUCB  EQU   CVTMAP+128
CVTIXAVL EQU   CVTMAP+124
CVTIOQET EQU   CVTMAP+120
CVTDCBA  EQU   CVTMAP+117
CVTMVS2  EQU   CVTDCB
CVT6DAT  EQU   CVTDCB
CVT4MPS  EQU   CVTDCB
CVTRSV09 EQU   CVTDCB
CVT4MS1  EQU   CVTDCB
CVT2SPS  EQU   CVTDCB
CVT1SSS  EQU   CVTDCB
CVTRSV08 EQU   CVTDCB
CVTSTB   EQU   CVTMAP+112
CVTQTD00 EQU   CVTMAP+108
CVTQTE00 EQU   CVTMAP+104
CVTCUCB  EQU   CVTMAP+100
CVTSJQ   EQU   CVTMAP+96
CVTPBLDL EQU   CVTMAP+92
CVTTPC   EQU   CVTMAP+88
CVTSVDCB EQU   CVTMAP+84
CVTBRET  EQU   CVTMAP+82
CVTEXIT  EQU   CVTMAP+80
CVT0FN00 EQU   CVTMAP+76
CVTDARA  EQU   CVTDAR+1
CVTRSV07 EQU   CVTFLGS1
CVTRSV06 EQU   CVTFLGS1
CVTRSV05 EQU   CVTFLGS1
CVTRSV04 EQU   CVTFLGS1
CVTRSV03 EQU   CVTFLGS1
CVTRSV02 EQU   CVTFLGS1
CVTRSV01 EQU   CVTFLGS1
CVTDMPLK EQU   CVTFLGS1
CVTXITP  EQU   CVTMAP+68
CVTZDTAB EQU   CVTMAP+64
CVTMSLT  EQU   CVTMAP+60
CVTDATE  EQU   CVTMAP+56
CVTBTERM EQU   CVTMAP+52
CVTSYSAD EQU   CVTMAP+48
CVTXTLER EQU   CVTMAP+44
CVTILK2  EQU   CVTMAP+40
CVTILK1  EQU   CVTMAP+36
CVTPRLTV EQU   CVTMAP+32
CVTPCNVT EQU   CVTMAP+28
CVT0VL00 EQU   CVTMAP+24
CVTXAPG  EQU   CVTMAP+20
CVTBUF   EQU   CVTMAP+16
CVTJOB   EQU   CVTMAP+12
CVTLINK  EQU   CVTMAP+8
CVTTCBP  EQU   CVTMAP
CVT      EQU   CVTMAP
ASXBEND  EQU   ASXB+232
ASXBRV25 EQU   ASXB+228
ASXBRV24 EQU   ASXB+224
ASXBRV23 EQU   ASXB+220
ASXBRV22 EQU   ASXB+216
ASXBRV21 EQU   ASXB+212
ASXBRV20 EQU   ASXB+208
ASXBRV19 EQU   ASXB+204
ASXBRV18 EQU   ASXB+200
ASXBRV17 EQU   ASXB+196
ASXBRV16 EQU   ASXB+192
ASXBLSRB EQU   ASXBAEQ+20
ASXBFSRB EQU   ASXBAEQ+16
ASXBLRQE EQU   ASXBAEQ+12
ASXBFRQE EQU   ASXBAEQ+8
ASXBLIQE EQU   ASXBAEQ+4
ASXBFIQE EQU   ASXBAEQ
ASXBETSK EQU   ASXB+164
ASXBSIRB EQU   ASXB+160
ASXBPSWD EQU   ASXB+152
ASXBPRG  EQU   ASXB+136
ASXBRV26 EQU   ASXB+132
ASXBOUSB EQU   ASXB+128
ASXBDDR  EQU   ASXB+124
ASXBRSMD EQU   ASXB+116
ASXBSPSA EQU   ASXB+112
ASXBFRWA EQU   ASXB+108
ASXBFLSA EQU   ASXB+36
ASXBIHSA EQU   ASXB+32
ASXBRV15 EQU   ASXB+28
ASXBRV14 EQU   ASXB+24
ASXBLWA  EQU   ASXB+20
ASXBMPST EQU   ASXB+16
ASXBRS00 EQU   ASXB+14
ASXBTCBS EQU   ASXB+12
ASXBLTCB EQU   ASXB+8
ASXBASXB EQU   ASXB
ASXBEGIN EQU   ASXB
ASCBEND  EQU   ASCB+208
ASCBSRBT EQU   ASCB+200
ASCBSWTL EQU   ASCB+196
ASCBRS14 EQU   ASCB+195
ASCBSMCT EQU   ASCB+194
ASCBRS12 EQU   ASCB+192
ASCBPCTT EQU   ASCB+188
ASCBVGTT EQU   ASCB+184
ASCBLGCB EQU   ASCB+180
ASCBJBNS EQU   ASCB+176
ASCBJBNI EQU   ASCB+172
ASCBMCC  EQU   ASCB+168
ASCBRTWA EQU   ASCB+164
ASCBIQEA EQU   ASCB+160
ASCBXMPQ EQU   ASCB+156
ASCBRS01 EQU   ASCB+154
ASCBFMCT EQU   ASCB+152
ASCBOUXB EQU   ASCB+148
ASCBOUCB EQU   ASCB+144
ASCBMECB EQU   ASCB+140
ASCBQECB EQU   ASCB+136
ASCBCMSB EQU   ASCB+132
ASCBCMSF EQU   ASCB+128
ASCBTCBS EQU   ASCB+124
ASCBNVSC EQU   ASCB+122
ASCBVSC  EQU   ASCB+120
ASCBSRBS EQU   ASCB+118
ASCBSSRB EQU   ASCB+116
ASCBRV06 EQU   ASCBFLG2
ASCBRV05 EQU   ASCBFLG2
ASCBRV04 EQU   ASCBFLG2
ASCBSNQS EQU   ASCBFLG2
ASCBS2S  EQU   ASCBFLG2
ASCBCEXT EQU   ASCBFLG2
ASCBPXMT EQU   ASCBFLG2
ASCBXMPT EQU   ASCBFLG2
ASCBRF07 EQU   ASCBDSP1
ASCBRF06 EQU   ASCBDSP1
ASCBRF05 EQU   ASCBDSP1
ASCBRF04 EQU   ASCBDSP1
ASCBRF03 EQU   ASCBDSP1
ASCBRF02 EQU   ASCBDSP1
ASCBFAIL EQU   ASCBDSP1
ASCBNOQ  EQU   ASCBDSP1
ASCBSWCT EQU   ASCB+112
ASCBTMCH EQU   ASCB+104
ASCBNSWP EQU   ASCBFLG1
ASCBTYP1 EQU   ASCBFLG1
ASCBSTND EQU   ASCBFLG1
ASCBABNT EQU   ASCBFLG1
ASCBTERM EQU   ASCBFLG1
ASCBS3S  EQU   ASCBFLG1
ASCBCMSH EQU   ASCBFLG1
ASCBTOFF EQU   ASCBFLG1
ASCBRF01 EQU   ASCBRCTF
ASCBTMLW EQU   ASCBRCTF
ASCBOUT  EQU   ASCBRCTF
ASCBWAIT EQU   ASCBRCTF
ASCBRV08 EQU   ASCBRCTF
ASCBFQU  EQU   ASCBRCTF
ASCBFRS  EQU   ASCBRCTF
ASCBTMNO EQU   ASCBRCTF
ASCBAFFN EQU   ASCBFW1
ASCBDUMP EQU   ASCB+96
ASCBQSVC EQU   ASCB+92
ASCBUBET EQU   ASCB+88
ASCBECB  EQU   ASCB+84
ASCBJSTL EQU   ASCB+80
ASCBEWST EQU   ASCB+72
ASCBEJST EQU   ASCB+64
ASCBCSCB EQU   ASCB+56
ASCBRSM  EQU   ASCB+52
ASCBLDA  EQU   ASCB+48
ASCBSTOR EQU   ASCB+44
ASCBDP   EQU   ASCB+43
ASCBRV07 EQU   ASCB+42
ASCBIOSM EQU   ASCB+40
ASCBSEQN EQU   ASCB+38
ASCBASID EQU   ASCB+36
ASCBCPUS EQU   ASCB+32
ASCBSPL  EQU   ASCB+28
ASCBLSLQ EQU   ASCB+24
ASCBFSLQ EQU   ASCB+20
ASCBIOSP EQU   ASCB+16
ASCBLOCK EQU   ASCB+12
ASCBBWDP EQU   ASCB+8
ASCBFWDP EQU   ASCB+4
ASCBASCB EQU   ASCB
ASCBEGIN EQU   ASCB
@NM00028 EQU   PSA+3668
PSASTAK  EQU   PSA+3072
@NM00027 EQU   PSA+1040
PSAUSEND EQU   PSA+1040
PSARV062 EQU   PSA+1036
PSAATCVT EQU   PSA+1032
PSAPCPSW EQU   PSA+1024
PSAPIR2  EQU   PSA+1020
PSARV059 EQU   PSA+1018
PSASVC13 EQU   PSA+1016
PSASFACC EQU   PSA+1008
PSASTOP  EQU   PSA+992
PSASTART EQU   PSA+976
PSARSPSW EQU   PSA+968
PSASRPSW EQU   PSA+960
PSARV045 EQU   PSA+892
PSARV044 EQU   PSA+888
PSARV043 EQU   PSA+884
PSARV042 EQU   PSA+880
PSARV041 EQU   PSA+876
PSARV040 EQU   PSA+872
PSARV025 EQU   PSA+868
PSADSSED EQU   PSA+868
PSADSSPR EQU   PSA+864
PSADSSFW EQU   PSA+860
PSADSS14 EQU   PSA+856
PSADSSPP EQU   PSA+848
PSADSSRP EQU   PSA+840
PSADSS05 EQU   PSADSSF4
PSADSS10 EQU   PSADSSF4
PSADSSVE EQU   PSADSSF4
PSADSSDE EQU   PSADSSF4
PSADSSC0 EQU   PSADSSF4
PSADSSIE EQU   PSADSSF4
PSADSS12 EQU   PSADSSF4
PSADSSRC EQU   PSADSSF4
PSARV057 EQU   PSADSSF3
PSARV056 EQU   PSADSSF3
PSARV055 EQU   PSADSSF3
PSADSSMC EQU   PSADSSF3
PSADSSRW EQU   PSADSSF3
PSADSSNM EQU   PSADSSF3
PSADSSES EQU   PSADSSF3
PSADSSGP EQU   PSADSSF3
PSADSSF2 EQU   PSADSSFL+1
PSADSSPI EQU   PSADSSF1
PSADSSOI EQU   PSADSSF1
PSADSSSP EQU   PSADSSF1
PSADSSTP EQU   PSADSSF1
PSADSSDW EQU   PSADSSF1
PSADSSDD EQU   PSADSSF1
PSADSSDM EQU   PSADSSF1
PSADSSMV EQU   PSADSSF1
PSADSSTS EQU   PSA+816
PSADSSWK EQU   PSA+812
PSADSSR3 EQU   PSA+808
PSADSSR2 EQU   PSA+804
PSADSSRS EQU   PSA+800
PSASTOR  EQU   PSA+796
PSACPUSA EQU   PSA+794
PSAVSTAP EQU   PSA+792
PSAWKVAP EQU   PSA+788
PSAWKRAP EQU   PSA+784
PSAMCHIC EQU   PSA+783
PSARV061 EQU   PSA+782
PSASYMSK EQU   PSA+781
PSAMCHFL EQU   PSA+780
PSACR0   EQU   PSA+776
PSAPSWSV EQU   PSA+768
PSACLHS  EQU   PSAHLHI
PSALKR15 EQU   PSALKSA+60
PSALKR14 EQU   PSALKSA+56
PSALKR13 EQU   PSALKSA+52
PSALKR12 EQU   PSALKSA+48
PSALKR11 EQU   PSALKSA+44
PSALKR10 EQU   PSALKSA+40
PSALKR9  EQU   PSALKSA+36
PSALKR8  EQU   PSALKSA+32
PSALKR7  EQU   PSALKSA+28
PSALKR6  EQU   PSALKSA+24
PSALKR5  EQU   PSALKSA+20
PSALKR4  EQU   PSALKSA+16
PSALKR3  EQU   PSALKSA+12
PSALKR2  EQU   PSALKSA+8
PSALKR1  EQU   PSALKSA+4
PSALKR0  EQU   PSALKSA
PSARV023 EQU   PSACLHT+52
PSALOCAL EQU   PSACLHT+48
PSACMSL  EQU   PSACLHT+44
PSAOPTL  EQU   PSACLHT+40
PSATPACL EQU   PSACLHT+36
PSATPDNL EQU   PSACLHT+32
PSATPNCL EQU   PSACLHT+28
PSAIOSLL EQU   PSACLHT+24
PSAIOSUL EQU   PSACLHT+20
PSAIOSCL EQU   PSACLHT+16
PSAIOSSL EQU   PSACLHT+12
PSASALCL EQU   PSACLHT+8
PSAASML  EQU   PSACLHT+4
PSADISPL EQU   PSACLHT
PSASRSA  EQU   PSA+636
PSARV050 EQU   PSA+634
PSADSSGO EQU   PSA+633
PSARECUR EQU   PSA+632
PSAHLHIS EQU   PSA+628
PSAIPCSA EQU   PSA+624
@NM00026 EQU   PSA+621
PSAIPCDM EQU   PSA+620
PSAIPCD  EQU   PSA+616
@NM00025 EQU   PSA+613
PSAIPCRM EQU   PSA+612
PSAIPCR  EQU   PSA+608
PSAMCHEX EQU   PSA+600
PSAMPSW  EQU   PSA+592
PSAEXPS2 EQU   PSA+584
PSAEXPS1 EQU   PSA+576
PSAPIREG EQU   PSA+572
PSARSREG EQU   PSA+568
PSAGPREG EQU   PSA+556
PSARV022 EQU   PSASUP4
PSARV021 EQU   PSASUP4
PSARV020 EQU   PSASUP4
PSARV019 EQU   PSASUP4
PSARV018 EQU   PSASUP4
PSARV017 EQU   PSASUP4
PSARV016 EQU   PSASUP4
PSARV015 EQU   PSASUP4
PSARV014 EQU   PSASUP3
PSARV013 EQU   PSASUP3
PSARV012 EQU   PSASUP3
PSARV011 EQU   PSASUP3
PSARV010 EQU   PSASUP3
PSAPSREG EQU   PSASUP3
PSAPI2   EQU   PSASUP3
PSAIOSUP EQU   PSASUP3
PSALCR   EQU   PSASUP2
PSARTM   EQU   PSASUP2
PSAACR   EQU   PSASUP2
PSAIPCE2 EQU   PSASUP2
PSAIPCES EQU   PSASUP2
PSAIPCEC EQU   PSASUP2
PSAGTF   EQU   PSASUP2
PSAIPCRI EQU   PSASUP2
PSAIPCRP EQU   PSASUP1
PSAIPCDR EQU   PSASUP1
PSADISP  EQU   PSASUP1
PSALOCK  EQU   PSASUP1
PSAPI    EQU   PSASUP1
PSAEXT   EQU   PSASUP1
PSASVC   EQU   PSASUP1
PSAIO    EQU   PSASUP1
PSAANEW  EQU   PSA+544
PSATOLD  EQU   PSA+540
PSATNEW  EQU   PSA+536
PSALCCAR EQU   PSA+532
PSALCCAV EQU   PSA+528
PSAPCCAR EQU   PSA+524
PSAPCCAV EQU   PSA+520
PSACPULA EQU   PSA+518
PSACPUPA EQU   PSA+516
PSAPSA   EQU   PSA+512
FLCHDEND EQU   PSA+512
FLCCRSAV EQU   FLCMCLA+280
FLCGRSAV EQU   FLCMCLA+216
FLCFPSAV EQU   FLCMCLA+184
FLCFLA   EQU   FLCMCLA+88
FLCRGNCD EQU   FLCMCLA+84
FLCFSAA  EQU   FLCFSA+1
@NM00024 EQU   FLCFSA
@NM00023 EQU   FLCMCLA+72
FLCMCIC  EQU   FLCMCLA+64
@NM00022 EQU   FLCMCLA+20
FLCIOAA  EQU   FLCIOA+1
@NM00021 EQU   FLCIOA
@NM00020 EQU   FLCMCLA+15
@NM00019 EQU   FLCMCLA+14
@NM00018 EQU   FLCMCLA+12
FLCLCL   EQU   FLCMCLA+8
FLCIOELA EQU   FLCIOEL+1
@NM00017 EQU   FLCIOEL
FLCCHNID EQU   FLCMCLA
@NM00016 EQU   PSA+160
FLCMTRCD EQU   PSA+157
@NM00015 EQU   PSA+156
FLCPERA  EQU   FLCPER+1
@NM00014 EQU   FLCPER
@NM00013 EQU   PSA+151
FLCPERCD EQU   PSA+150
FLCMCNUM EQU   PSA+149
@NM00012 EQU   PSA+148
FLCTEAA  EQU   FLCTEA+1
@NM00011 EQU   FLCTEA
PSAPIPC  EQU   PSAPICOD
PSAPIMC  EQU   PSAPICOD
PSAPIPER EQU   PSAPICOD
PSARV049 EQU   FLCPICOD
FLCPILCB EQU   FLCPIILC
@NM00010 EQU   FLCPIILC
@NM00009 EQU   PSAEPPSW
FLCSVCN  EQU   PSAESPSW+2
FLCSILCB EQU   FLCSVILC
@NM00008 EQU   FLCSVILC
@NM00007 EQU   PSAESPSW
FLCEICOD EQU   PSAEEPSW+2
PSASPAD  EQU   PSAEEPSW
@NM00006 EQU   PSA+128
FLCINPSW EQU   PSA+120
FLCMNPSW EQU   PSA+112
FLCPNPSW EQU   PSA+104
FLCSNPSW EQU   PSA+96
FLCENPSW EQU   PSA+88
FLCTRACE EQU   PSA+84
FLCTIMER EQU   PSA+80
FLCCVT2  EQU   PSA+76
FLCCAW   EQU   PSA+72
FLCCSW   EQU   PSA+64
FLCIOPSW EQU   PSA+56
FLCMOPSW EQU   PSA+48
FLCPOPSW EQU   PSA+40
FLCSOPSW EQU   PSA+32
FLCEOPSW EQU   PSA+24
@NM00005 EQU   FLCICCW2+4
FLCCVT   EQU   FLCICCW2
FLCICCW1 EQU   FLCROPSW
FLCIPPSW EQU   FLCRNPSW
.@UNREFD ANOP                          END UNREFERENCED COMPONENTS
@RF00255 EQU   @RC00252
@RF00449 EQU   @RC00446
@PB00002 EQU   @EL00001
@ENDDATA EQU   *
         END   IEAVAR04,(C'PLS2113',0701,76030)
