         TITLE 'IEAVAR06 - ATTENTION EXIT EPILOGUE ROUTINE             *
                        '
IEAVAR06 CSECT ,                                                   0001
@MAINENT DS    0H                                                  0001
         USING *,@15                                               0001
         B     @PROLOG                                             0001
         DC    AL1(16)                                             0001
         DC    C'IEAVAR06  77.133'                                 0001
         DROP  @15
@PROLOG  STM   @14,@12,12(@13)                                     0001
         BALR  @08,0                                               0001
@PSTART  DS    0H                                                  0001
         USING @PSTART,@08                                         0001
RBPRFXLN EQU 64
RBPRFLNA EQU 32
PRBLEN   EQU 136
SIRBLEN  EQU 200
TIRBLEN  EQU 136
IRBLEN   EQU 128
SVRBLEN  EQU 200
DECREG   DS    0H                                                  0049
*                                                                  0087
*/********************************************************************/
*/*                                                                  */
*/*  START OF EXECUTABLE CODE                                        */
*/*                                                                  */
*/*  THE LOCAL LOCK IS HELD AT ENTRY FROM EXIT.                      */
*/*                                                                  */
*/*  THIS SEGMENT OF CODE WILL ESTABLISH A RECOVERY                  */
*/*  ENVIRONMENT FOR THE LOCKED CODE OF THIS ROUTINE.                */
*/*                                                                  */
*/********************************************************************/
*                                                                  0087
*   ENTREG13=RTNREG13;              /* SAVE ADDR OF SAVE AREA        */
         LR    ENTREG13,RTNREG13                                   0087
*   RESPECIFY                                                      0088
*     RTNREG13 UNRESTRICTED;                                       0088
*   RESPECIFY                                                      0089
*     FRRSPTR RESTRICTED;                                          0089
*   RESPECIFY                                                      0090
*     FRREPTR RESTRICTED;                                          0090
*   FRRSPTR=ADDR(IEAVAFR6);         /* ENTRY POINT TO FRR            */
         LA    FRRSPTR,IEAVAFR6                                    0091
*   GENERATE CODE NODEFS NOSETS NOFLOWS REFS(FRRWKAP,FRRSPTR,FRREPTR,
*       PSACSTK,FRRSCURR,FRRSLAST,FRRSELEN,FRRSFRRA,FRRSPARM,PSALSFCC);
        SETFRR A,FRRAD=(FRRSPTR),PARMAD=(FRRWKAP),                     X
               WRKREGS=(FRRWKAP,FRREPTR)
*   RESPECIFY                                                      0093
*     FRRSPTR UNRESTRICTED;                                        0093
*   RESPECIFY                                                      0094
*     FRREPTR UNRESTRICTED;                                        0094
*                                                                  0095
*/********************************************************************/
*/*                                                                  */
*/* THE FOLLOWING SEGMENT OF CODE WILL RESET THE FLAGS IN            */
*/* THE TAXE AND WILL SAVE THE ADDRESS OF THE TAXE IN THE            */
*/* FRR WORK AREA.                                                   */
*/*                                                                  */
*/********************************************************************/
*                                                                  0095
*   TAXEPTR=RBSECPTR;               /* ESTABLISH BASE REG FOR THE  0095
*                                      TAXE                          */
         LR    TAXEPTR,RBSECPTR                                    0095
*   FRRTAXE=TAXEPTR;                /* SAVE THE TAXE POINTER         */
         ST    TAXEPTR,FRRTAXE(,FRRWKAP)                           0096
*   TAXESCHD='0'B;                  /* RESET SCHEDULED FLAG          */
*   TAXERESM='0'B;                  /* RESET CANCELLED FLAG          */
         NI    TAXESCHD(TAXEPTR),B'11100111'                       0098
*                                                                  0099
*/********************************************************************/
*/*                                                                  */
*/* THE FOLLOWING SEGMENT OF CODE WILL FREE THE TAIE IF              */
*/* ONE WAS GOTTEN BY THE ATTENTION PROLOGUE ROUTINE                 */
*/*                                                                  */
*/********************************************************************/
*                                                                  0099
*   IF TAXETAIE^='00000000'X THEN   /* IF THERE IS A TAIE FREE IT    */
         L     @12,TAXETAIE(,TAXEPTR)                              0099
         LTR   @12,@12                                             0099
         BZ    @RF00099                                            0099
*     DO;                                                          0100
*       RESPECIFY                                                  0101
*         FREMPR0 RESTRICTED;                                      0101
*       RESPECIFY                                                  0102
*         FREMPR1 RESTRICTED;                                      0102
*       RESPECIFY                                                  0103
*         FREMPR3 RESTRICTED;                                      0103
*       RESPECIFY                                                  0104
*         FREMPR15 RESTRICTED;                                     0104
*       FRRGTFTI='1'B;              /* SET FOOTPRINT FOR FRR         */
         OI    FRRGTFTI(FRRWKAP),B'10000000'                       0105
*       FREMPR0=LENGTH(TAIE);       /* LENGTH OF TAIE                */
         LA    FREMPR0,72                                          0106
*       FREMPR1=TAXETAIE;           /* ADDR OF TAIE                  */
         LR    FREMPR1,@12                                         0107
*       GENERATE CODE NOSETS NOFLOWS NODEFS REFS(CVTCRMN,CVTMAP);  0108
*                                                                  0108
         FREEMAIN RC,SP=250,BRANCH=YES,LV=(0),A=(1)            @ZA07753
*/* THE RETURN CODE FROM FREEMAIN WILL NOT BE CHECKED                */
*/* BECAUSE THIS WAS A CONDITIONAL FREEMAIN                          */
*                                                                  0109
*       RESPECIFY                                                  0109
*         FREMPR0 UNRESTRICTED;                                    0109
*       RESPECIFY                                                  0110
*         FREMPR1 UNRESTRICTED;                                    0110
*       RESPECIFY                                                  0111
*         FREMPR3 UNRESTRICTED;                                    0111
*       RESPECIFY                                                  0112
*         FREMPR15 UNRESTRICTED;                                   0112
*       TAXETAIE='00000000'X;       /* CLEAR POINTER TO TAIE         */
         SLR   @12,@12                                             0113
         ST    @12,TAXETAIE(,TAXEPTR)                              0113
*       FRRCFFTI='1'B;              /* SET TRACKING FOOTPRINT        */
         OI    FRRCFFTI(FRRWKAP),B'01000000'                       0114
*     END;                                                         0115
*                                                                  0116
*/********************************************************************/
*/*                                                                  */
*/* THE FOLLOWING SEGMENT OF CODE WILL CHECK TO SEE IF THE           */
*/* TAXE IS TO BE FREED. IF IT IS THE TAXE WILL BE FREED             */
*/* BY EXIT. THE TAXE MUST, HOWEVER BE DEQUEUED FROM THE             */
*/* TAXE QUEUE                                                       */
*/*                                                                  */
*/********************************************************************/
*                                                                  0116
*   IF RBFDYN='1'B THEN             /* IS TAXE TO BE FREED           */
@RF00099 TM    RBFDYN(RBSECPTR),B'00000010'                        0116
         BNO   @RF00116                                            0116
*     DO;                           /* YES                           */
*       RESPECIFY                                                  0118
*         PTAXEPTR RESTRICTED;                                     0118
*       RESPECIFY                                                  0119
*         NTAXEPTR RESTRICTED;                                     0119
*       PTAXEPTR=PTAXEPTR-PTAXEPTR; /* CLEAR PREVIOUS PTR            */
         SLR   PTAXEPTR,PTAXEPTR                                   0120
*       TAXEPTR=RCTDTAXE;           /* LOAD TAXE SEARCH ARGU         */
         L     @01,ASXBPTR(,ASCBPTR)                               0121
         L     @01,ASXBRCTD(,@01)                                  0121
         L     TAXEPTR,RCTDTAXE(,@01)                              0121
*       DO WHILE TAXEPTR^='00000000'X;/* SEARCH WHOLE QUEUE          */
         B     @DE00122                                            0122
@DL00122 DS    0H                                                  0123
*         IF TAXEPTR=RBSECPTR THEN  /* CURRENT TAXE FOUND            */
         CR    TAXEPTR,RBSECPTR                                    0123
         BNE   @RF00123                                            0123
*           DO;                     /* YES                           */
*             FRRTTBDQ='1'B;        /* SET A FOOTPRINT THAT A TAXE IS
*                                      TO BE DEQUEUED                */
         OI    FRRTTBDQ(FRRWKAP),B'00100000'                       0125
*             IF PTAXEPTR='00000000'X THEN/* FIRST TAXE ON QUEUE     */
         LTR   PTAXEPTR,PTAXEPTR                                   0126
         BNZ   @RF00126                                            0126
*               DO;                 /* YES                           */
*                 RCTDTAXE=TAXELNK; /* DEQUEUE FIRST TAXE            */
         L     @01,ASXBPTR(,ASCBPTR)                               0128
         L     @01,ASXBRCTD(,@01)                                  0128
         L     @00,TAXELNK-1(,TAXEPTR)                             0128
         ICM   @00,8,@CB02095                                      0128
         ST    @00,RCTDTAXE(,@01)                                  0128
*               END;                                               0129
*             ELSE                  /* NO                            */
*               DO;                                                0130
         B     @RC00126                                            0130
@RF00126 DS    0H                                                  0131
*                 NTAXEPTR=TAXELNK; /* SAVE NEXT TAXE PTR            */
         L     NTAXEPTR,TAXELNK-1(,TAXEPTR)                        0131
         LA    NTAXEPTR,0(,NTAXEPTR)                               0131
*                 TAXEPTR=PTAXEPTR; /* UPDATE BASE REG               */
         LR    TAXEPTR,PTAXEPTR                                    0132
*                 FRRPTAXE=PTAXEPTR;/* SAVE PREVIOUS TAXE            */
         ST    PTAXEPTR,FRRPTAXE(,FRRWKAP)                         0133
*                 FRRNTAXE=NTAXEPTR;/* SAVE NEXT TAXE                */
         ST    NTAXEPTR,FRRNTAXE(,FRRWKAP)                         0134
*                 TAXELNK=NTAXEPTR; /* DEQUEUE THE TAXE              */
         STCM  NTAXEPTR,7,TAXELNK(TAXEPTR)                         0135
*               END;                                               0136
*             FRRTHBDQ='1'B;        /* SET FOOTPRINT FOR FRR         */
@RC00126 OI    FRRTHBDQ(FRRWKAP),B'00010000'                       0137
*             GO TO STATST;         /* GO START SUBTASKS             */
         B     STATST                                              0138
*           END;                                                   0139
*         PTAXEPTR=TAXEPTR;         /* SAVE PREVIOUS TAXE PTR        */
@RF00123 LR    PTAXEPTR,TAXEPTR                                    0140
*         TAXEPTR=TAXELNK;          /* UPDATE BASE FOR TAXE          */
         L     @15,TAXELNK-1(,TAXEPTR)                             0141
         LA    @15,0(,@15)                                         0141
         LR    TAXEPTR,@15                                         0141
*       END;                                                       0142
@DE00122 LTR   TAXEPTR,TAXEPTR                                     0142
         BNZ   @DL00122                                            0142
*       RESPECIFY                                                  0143
*         NTAXEPTR UNRESTRICTED;                                   0143
*       RESPECIFY                                                  0144
*         PTAXEPTR UNRESTRICTED;                                   0144
*     END;                                                         0145
*                                                                  0146
*/********************************************************************/
*/*                                                                  */
*/* THE SUBTASKS OF THE TCB THAT HAS THE EXITING TAXE ARE            */
*/* RESTARTED USING THE BRANCH ENTRY TO STATUS START TCB             */
*/*                                                                  */
*/********************************************************************/
*                                                                  0146
*STATST:                                                           0146
*   FRRGTSS='1'B;                   /* SET FOOTPRINT IND. THAT GOING
*                                      TO STATUS START               */
@RF00116 DS    0H                                                  0146
STATST   OI    FRRGTSS(FRRWKAP),B'00001000'                        0146
*/* SET UP INTERFACE FOR STATUS START ALL SUBTASKS                   */
*                                                                  0147
*   RESPECIFY                                                      0147
*     STATPR0 RESTRICTED;                                          0147
*   RESPECIFY                                                      0148
*     STATPR1 RESTRICTED;                                          0148
*   RESPECIFY                                                      0149
*     STATPR13 RESTRICTED;                                         0149
*   RESPECIFY                                                      0150
*     STATPR15 RESTRICTED;                                         0150
*   STATPR0='00000007'X;            /* INDICATE START TCBS           */
         LA    STATPR0,7                                           0151
*   STATPR1=STATPR1-STATPR1;        /* INDICATE ALL SUBTASKS         */
         SLR   STATPR1,STATPR1                                     0152
*   STATPR13=STATPR13-STATPR13;     /* INDICATE NO MASK              */
         SLR   STATPR13,STATPR13                                   0153
*   CALL STATENT;                   /* GO TO STATUS START            */
         L     @12,CVTPTR                                          0154
         L     @12,SCVTSPTR(,@12)                                  0154
         L     @15,SCVTSTAT(,@12)                                  0154
         BALR  @14,@15                                             0154
*   FRRCFSS='1'B;                   /* SET FOOTPRINT FOR FRR         */
*   RESPECIFY                                                      0156
*     STATPR0 UNRESTRICTED;                                        0156
*   RESPECIFY                                                      0157
*     STATPR1 UNRESTRICTED;                                        0157
*   RESPECIFY                                                      0158
*     STATPR13 UNRESTRICTED;                                       0158
*   RESPECIFY                                                      0159
*     STATPR15 UNRESTRICTED;                                       0159
*                                                                  0160
*/********************************************************************/
*/*                                                                  */
*/* THE FOLLOWING SEGMENT OF CODE WILL CHECK TO SEE IF               */
*/* THERE ARE ANY TAXES ON THE QUEUE. IF THERE ARE THE               */
*/* ENTIRE TAXE QUEUE WILL BE SEARCHED LOOKING FOR THE               */
*/* HIGHEST LEVEL TAXE THAT HAS BEEN SCHEDULED.                      */
*/*                                                                  */
*/********************************************************************/
*                                                                  0160
*   RESPECIFY                                                      0160
*     PTAXEPTR RESTRICTED;                                         0160
*   RESPECIFY                                                      0161
*     ORIGTAXE RESTRICTED;                                         0161
*   FRRSTS='1'B;                    /* SET FOOTPRINT FOR FRR         */
         OI    FRRCFSS(FRRWKAP),B'00000110'                        0162
*   PTAXEPTR=PTAXEPTR-PTAXEPTR;     /* CLEAR PREV PTR                */
         SLR   PTAXEPTR,PTAXEPTR                                   0163
*   TAXEPTR=RCTDTAXE;               /* INITIALIZE SEARCH ARGU        */
         L     @12,ASXBPTR(,ASCBPTR)                               0164
         L     @12,ASXBRCTD(,@12)                                  0164
         L     TAXEPTR,RCTDTAXE(,@12)                              0164
*   ORIGTAXE=RBSECPTR;              /* SAVE ORIGINAL TAXE PTR        */
         LR    ORIGTAXE,RBSECPTR                                   0165
*   DO WHILE TAXEPTR^='00000000'X;  /* ANY MORE TAXES                */
         B     @DE00166                                            0166
@DL00166 DS    0H                                                  0167
*     IF TAXEPTR^=ORIGTAXE THEN     /* IS THIS EXITING TAXE          */
         CR    TAXEPTR,ORIGTAXE                                    0167
         BE    @RF00167                                            0167
*       DO;                         /* NO                            */
*         IF RBFACTV='1'B|TAXESCHD='1'B THEN/* IS THE TAXE ACTIVE    */
         TM    RBFACTV(RBSECPTR),B'01000000'                       0169
         BO    @RT00169                                            0169
         TM    TAXESCHD(TAXEPTR),B'00001000'                       0169
         BNO   @RF00169                                            0169
@RT00169 DS    0H                                                  0170
*           DO;                     /* YES                           */
*             PTAXEPTR=TAXEPTR;     /* SAVE ACTIVE TAXE PTR          */
         LR    PTAXEPTR,TAXEPTR                                    0171
*           END;                                                   0172
*       END;                                                       0173
@RF00169 DS    0H                                                  0174
*     TAXEPTR=TAXELNK;              /* CONTINUE SEARCH               */
@RF00167 L     @12,TAXELNK-1(,TAXEPTR)                             0174
         LA    @12,0(,@12)                                         0174
         LR    TAXEPTR,@12                                         0174
*     RBSECPTR=TAXEPTR;             /* RESTORE RB BASE REG           */
         LR    RBSECPTR,TAXEPTR                                    0175
*   END;                                                           0176
@DE00166 SLR   @12,@12                                             0176
         CR    TAXEPTR,@12                                         0176
         BNE   @DL00166                                            0176
*   RBSECPTR=ORIGTAXE;              /* RESTORE ORIG RB BASE          */
         LR    RBSECPTR,ORIGTAXE                                   0177
*   RESPECIFY                                                      0178
*     ORIGTAXE UNRESTRICTED;                                       0178
*                                                                  0179
*/********************************************************************/
*/*                                                                  */
*/* THE TAXES FOLLOWING THE HIGHEST ACTIVE TAXE MUST BE              */
*/* MARKED AVAILABLE FOR USE AND THEY MUST BE REFLECTED              */
*/* IN THE TSBSTAX COUNT. THIS SEGMENT OF CODE WILL                  */
*/* SEARCH THE ENTIRE TAXE QUEUE STARTING WITH THE HIGHEST           */
*/* SCHEDULED TAXE AND PERFORM THE OPERATION.                        */
*/*                                                                  */
*/********************************************************************/
*                                                                  0179
*   RESPECIFY                                                      0179
*     STAXCNT RESTRICTED;                                          0179
*   STAXCNT=STAXCNT-STAXCNT;        /* INITIALIZE STAX COUNT         */
         SLR   STAXCNT,STAXCNT                                     0180
*   IF RCTDTAXE^='00000000'X THEN   /* ARE THERE ANY TAXES           */
         SLR   @15,@15                                             0181
         L     @01,ASXBPTR(,ASCBPTR)                               0181
         L     @01,ASXBRCTD(,@01)                                  0181
         C     @15,RCTDTAXE(,@01)                                  0181
         BE    @RF00181                                            0181
*     DO;                           /* YES                           */
*       IF PTAXEPTR^='00000000'X THEN/* IS THIS HEAD OF QUEUE        */
         CR    PTAXEPTR,@15                                        0183
         BE    @RF00183                                            0183
*         DO;                       /* NO                            */
*           TAXEPTR=PTAXEPTR;       /* ESTABLISH BASE                */
         LR    TAXEPTR,PTAXEPTR                                    0185
*           TAXEPTR=TAXELNK;        /* SET BASE TO FIRST TAXE TO BE
*                                      MADE AVAILABLE                */
         L     @15,TAXELNK-1(,TAXEPTR)                             0186
         LA    @15,0(,@15)                                         0186
         LR    TAXEPTR,@15                                         0186
*         END;                                                     0187
*       ELSE                        /* YES                           */
*         DO;                                                      0188
         B     @RC00183                                            0188
@RF00183 DS    0H                                                  0189
*           TAXEPTR=RCTDTAXE;       /* SET BASE TO LOWEST POSSIBLE 0189
*                                      TAXE                          */
         L     @01,ASXBPTR(,ASCBPTR)                               0189
         L     @01,ASXBRCTD(,@01)                                  0189
         L     TAXEPTR,RCTDTAXE(,@01)                              0189
*         END;                                                     0190
*       DO WHILE TAXEPTR^='00000000'X;/* SEARCH THE REMAINDER OF THE
*                                      QUEUE                         */
@RC00183 B     @DE00191                                            0191
@DL00191 DS    0H                                                  0192
*         TAXEFREQ='0'B;            /* MARK TAXE AVAILABLE           */
         NI    TAXEFREQ(TAXEPTR),B'11011111'                       0192
*         STAXCNT=STAXCNT+'00010000'X;/* INCREMENT COUNT BY ONE      */
         AL    STAXCNT,@CF02063                                    0193
*         TAXEPTR=TAXELNK;          /* UPDATE TAXE PTR TO NEXT       */
         L     @15,TAXELNK-1(,TAXEPTR)                             0194
         LA    @15,0(,@15)                                         0194
         LR    TAXEPTR,@15                                         0194
*       END;                                                       0195
@DE00191 LTR   TAXEPTR,TAXEPTR                                     0195
         BNZ   @DL00191                                            0195
*     END;                                                         0196
*   RESPECIFY                                                      0197
*     PTAXEPTR UNRESTRICTED;                                       0197
@RF00181 DS    0H                                                  0198
*                                                                  0198
*/********************************************************************/
*/*                                                                  */
*/* UPDATE THE STAX COUNT IN THE TSB                                 */
*/*                                                                  */
*/* THE COUNT IS UPDATED USING COMPARE AND SWAP.                     */
*/*                                                                  */
*/* THE COUNT WILL NOT BE ALLOWED TO BE GREATER THAN 256             */
*/* EVEN IF MORE TAXES EXIST.                                        */
*/*                                                                  */
*/********************************************************************/
*                                                                  0198
*   RESPECIFY                                                      0198
*     TSBPTR RESTRICTED;                                           0198
*   RESPECIFY                                                      0199
*     PSTAXCNT RESTRICTED;                                         0199
*   RESPECIFY                                                      0200
*     NSTAXCNT RESTRICTED;                                         0200
*   TSBPTR=ASCBTSB;                 /* LOAD THE TSB BASE REG         */
         L     TSBPTR,ASCBTSB(,ASCBPTR)                            0201
*   GENERATE CODE NODEFS NOSETS NOFLOWS REFS(TSBPTR);              0202
         USING TSB,TSBPTR
*   IF STAXCNT>'00FF0000'X THEN     /* IS STAX COUNT > 255           */
         L     @15,@CF02064                                        0203
         CLR   STAXCNT,@15                                         0203
         BNH   @RF00203                                            0203
*     DO;                           /* YES                           */
*       STAXCNT='00FF0000'X;        /* SET TO 255                    */
         LR    STAXCNT,@15                                         0205
*     END;                                                         0206
*   NSTAXCNT=STAXCNT;               /* SAVE NEW STAX COUNT           */
@RF00203 LR    NSTAXCNT,STAXCNT                                    0207
*   PSTAXCNT=TSBATTNC;              /* LOAD ORIG SWAP VALUE          */
         L     PSTAXCNT,TSBATTNC                                   0208
*LOOP:                                                             0209
*   STAXCNT=PSTAXCNT;               /* LOAD PREVIOUS STAX CNT        */
LOOP     LR    STAXCNT,PSTAXCNT                                    0209
*   STAXCNT=STAXCNT&'FF00FFFF'X;    /* CLEAR OLD STAX COUNT          */
         N     STAXCNT,@CF02067                                    0210
*   STAXCNT=STAXCNT|NSTAXCNT;       /* INSERT NEW STAX COUNT LOAD  0211
*                                      ORIGINAL STAX CNT             */
         OR    STAXCNT,NSTAXCNT                                    0211
*   CS(PSTAXCNT,STAXCNT,TSBATTNC);  /* PERFORM UPDATE                */
         CS    PSTAXCNT,@12,TSBATTNC                               0212
*   BC(7,LOOP);                     /* DID THE UPDATE WORK? IF IT DID
*                                      CONTINUE                      */
         BC    7,LOOP                                              0213
*   GENERATE CODE NODEFS NOSETS NOFLOWS REFS(TSBPTR);              0214
         DROP TSBPTR
*   RESPECIFY                                                      0215
*     PSTAXCNT UNRESTRICTED;                                       0215
*   RESPECIFY                                                      0216
*     NSTAXCNT UNRESTRICTED;                                       0216
*   RESPECIFY                                                      0217
*     STAXCNT UNRESTRICTED;                                        0217
*   RESPECIFY                                                      0218
*     TSBPTR UNRESTRICTED;                                         0218
*                                                                  0219
*/********************************************************************/
*/*                                                                  */
*/* THE FOLLOWING SEGMENT OF CODE WILL DELETE THE RECOVERY           */
*/* ENVIRONMENT PRIOR TO RETURNING CONTROL TO EXIT(SVC?)             */
*/*                                                                  */
*/********************************************************************/
*                                                                  0219
*   RESPECIFY                                                      0219
*     FRRSPTR RESTRICTED;                                          0219
*   RESPECIFY                                                      0220
*     FRREPTR RESTRICTED;                                          0220
*   GENERATE CODE NOSETS NODEFS NOFLOWS REFS(FRRSPTR,FRREPTR,PSACSTK,
*       FRRSCURR,FRRSEMP,FRRSELEN);                                0221
        SETFRR D,WRKREGS=(FRRSPTR,FRREPTR)
*   RESPECIFY                                                      0222
*     FRRSPTR RESTRICTED;                                          0222
*   RESPECIFY                                                      0223
*     FRREPTR RESTRICTED;                                          0223
*                                                                  0223
*/********************************************************************/
*/*                                                                  */
*/* RE-ESTABLISH POINTER TO SAVE AREA.                               */
*/*                                                                  */
*/********************************************************************/
*                                                                  0224
*   RESPECIFY                                                      0224
*     RTNREG13 RESTRICTED;                                         0224
*   RTNREG13=ENTREG13;              /* RELOAD R13 POINTER            */
         LR    RTNREG13,ENTREG13                                   0225
*   RESPECIFY                                                      0226
*     ENTREG13 UNRESTRICTED;                                       0226
*                                                                  0227
*/********************************************************************/
*/*                                                                  */
*/* THIS ROUTINE WILL RECEIVE CONTROL IN THE EVENT OF AN ERROR IN    */
*/* THE ATTENTION EPILOGUE ROUTINE. CONTROL WILL BE RECEIVED FROM    */
*/* RTM VIA A LOAD PSW. REGISTERS UPON ENTRY ARE AS FOLLOWS          */
*/*                   REGISTER  0  UNPREDICTABLE                     */
*/*                             1  ADDRESS OF SDWA                   */
*/*                           2-13 UNPREDICTABLE                     */
*/*                             14 RETURN ADDRESS                    */
*/*                             15 ENTRY POINT ADDRESS               */
*/*                                                                  */
*/****************************************************************** */
*                                                                  0227
*IEAVAFR6:                                                         0227
*   PROCEDURE OPTIONS(NOSAVE,NOSAVEAREA,NOPARMREG,RETREG);         0227
@EL00001 DS    0H                                                  0227
@EF00001 DS    0H                                                  0227
@ER00001 LM    @14,@12,12(@13)                                     0227
         BR    @14                                                 0227
IEAVAFR6 DS    0H                                                  0228
*   GENERATE CODE NOSETS NODEFS NOFLOWS REFS(IEAVAFR6);            0228
      USING  IEAVAFR6,8
      LR     8,15
*   RESPECIFY                                                      0229
*     RTNREG14 RESTRICTED;                                         0229
*   RESPECIFY                                                      0230
*     SDWAPTR RESTRICTED;                                          0230
*   FRRWKAP=SDWAPARM;               /* ESTABLISH BASE REG FOR FRR  0231
*                                      WORK AREA                     */
         L     FRRWKAP,SDWAPARM(,SDWAPTR)                          0231
*   IF SDWAFMID='00000000'X THEN    /* ERROR IN THIS ADDRESS SPACE   */
         CLC   SDWAFMID(2,SDWAPTR),@CB02058                        0232
         BNE   @RF00232                                            0232
*     DO;                           /* YES                           */
*       ASCBPTR=PSAAOLD;            /* INITIALIZE ASCB BASE REG      */
         L     ASCBPTR,PSAAOLD                                     0234
*       TAXEPTR=RCTDTAXE;           /* INITIALIZE ASXB BASE REG      */
         L     @15,ASXBPTR(,ASCBPTR)                               0235
         L     @15,ASXBRCTD(,@15)                                  0235
         L     TAXEPTR,RCTDTAXE(,@15)                              0235
*       RESPECIFY                                                  0236
*         PTAXEPTR RESTRICTED;                                     0236
*       RESPECIFY                                                  0237
*         NTAXEPTR RESTRICTED;                                     0237
*       PTAXEPTR=PTAXEPTR-PTAXEPTR; /* INITIALIZE PREV TAXE BASE     */
         SLR   PTAXEPTR,PTAXEPTR                                   0238
*       DO WHILE TAXEPTR^='00000000'X;/* SEARCH WHOLE QUEUE          */
         B     @DE00239                                            0239
@DL00239 DS    0H                                                  0240
*         IF TAXEPTR=FRRTAXE THEN   /* IS THIS EXITING TAXE          */
         C     TAXEPTR,FRRTAXE(,FRRWKAP)                           0240
         BNE   @RF00240                                            0240
*           DO;                                                    0241
*             IF PTAXEPTR='00000000'X THEN/* FIRST TAXE ON QUEUE     */
         LTR   PTAXEPTR,PTAXEPTR                                   0242
         BNZ   @RF00242                                            0242
*               DO;                 /* YES                           */
*                 RCTDTAXE=TAXELNK; /* DEQUEUE FIRST TAXE            */
         L     @15,ASXBPTR(,ASCBPTR)                               0244
         L     @15,ASXBRCTD(,@15)                                  0244
         L     @10,TAXELNK-1(,TAXEPTR)                             0244
         LA    @10,0(,@10)                                         0244
         ST    @10,RCTDTAXE(,@15)                                  0244
*               END;                                               0245
*             ELSE                  /* NO                            */
*               DO;                                                0246
         B     @RC00242                                            0246
@RF00242 DS    0H                                                  0247
*                 NTAXEPTR=TAXELNK; /* SAVE NEXT TAXE PTR            */
         L     NTAXEPTR,TAXELNK-1(,TAXEPTR)                        0247
         LA    NTAXEPTR,0(,NTAXEPTR)                               0247
*                 TAXEPTR=PTAXEPTR; /* LOAD PREVIOUS TAXE ADDR       */
         LR    TAXEPTR,PTAXEPTR                                    0248
*                 TAXELNK=NTAXEPTR; /* DEQUEUE THE TAXE              */
         STCM  NTAXEPTR,7,TAXELNK(TAXEPTR)                         0249
*               END;                                               0250
*           END;                                                   0251
@RC00242 DS    0H                                                  0252
*         PTAXEPTR=TAXEPTR;         /* UPDATE PREVIOUS TAXE PTR      */
@RF00240 LR    PTAXEPTR,TAXEPTR                                    0252
*         TAXEPTR=TAXELNK;          /* UPDATE TAXE BASE REG          */
         L     @15,TAXELNK-1(,TAXEPTR)                             0253
         LA    @15,0(,@15)                                         0253
         LR    TAXEPTR,@15                                         0253
*       END;                                                       0254
@DE00239 LTR   TAXEPTR,TAXEPTR                                     0254
         BNZ   @DL00239                                            0254
*       PTAXEPTR=PTAXEPTR-PTAXEPTR; /* CLEAR PREVIOUS TAXE PTR       */
         SLR   PTAXEPTR,PTAXEPTR                                   0255
*       TAXEPTR=RCTDTAXE;           /* LOAD TAXE BASE REG            */
         L     @15,ASXBPTR(,ASCBPTR)                               0256
         L     @15,ASXBRCTD(,@15)                                  0256
         L     TAXEPTR,RCTDTAXE(,@15)                              0256
*       RBSECPTR=TAXEPTR;           /* LOAD RB BASE REG              */
         LR    RBSECPTR,TAXEPTR                                    0257
*       DO WHILE TAXEPTR^='00000000'X;/* SEARCH WHOLE QUEUE          */
         B     @DE00258                                            0258
@DL00258 DS    0H                                                  0259
*         IF RBFACTV='1'B|TAXESCHD='1'B THEN/* IS THE TAXE ACTIVE    */
         TM    RBFACTV(RBSECPTR),B'01000000'                       0259
         BO    @RT00259                                            0259
         TM    TAXESCHD(TAXEPTR),B'00001000'                       0259
         BNO   @RF00259                                            0259
@RT00259 DS    0H                                                  0260
*           DO;                     /* YES                           */
*             PTAXEPTR=TAXEPTR;     /* SAVE ACTIVE TAXE              */
         LR    PTAXEPTR,TAXEPTR                                    0261
*           END;                                                   0262
*         TAXEPTR=TAXELNK;          /* UPDATE SEARCH ARGUMENT        */
@RF00259 L     @15,TAXELNK-1(,TAXEPTR)                             0263
         LA    @15,0(,@15)                                         0263
         LR    TAXEPTR,@15                                         0263
*         RBSECPTR=TAXEPTR;         /* UPDATE RB BASE REG            */
         LR    RBSECPTR,TAXEPTR                                    0264
*       END;                                                       0265
@DE00258 SLR   @15,@15                                             0265
         CR    TAXEPTR,@15                                         0265
         BNE   @DL00258                                            0265
*       RESPECIFY                                                  0266
*         NTAXEPTR UNRESTRICTED;                                   0266
*       RESPECIFY                                                  0267
*         STAXCNT RESTRICTED;                                      0267
*       STAXCNT=STAXCNT-STAXCNT;    /* CLEAR STAX COUNT              */
         SLR   STAXCNT,STAXCNT                                     0268
*       IF RCTDTAXE^='00000000'X THEN/* ARE THERE ANY TAXES          */
         L     @10,ASXBPTR(,ASCBPTR)                               0269
         L     @10,ASXBRCTD(,@10)                                  0269
         C     @15,RCTDTAXE(,@10)                                  0269
         BE    @RF00269                                            0269
*         DO;                                                      0270
*           IF PTAXEPTR^='00000000'X THEN/* IS THIS HEAD OF QUEUE    */
         CR    PTAXEPTR,@15                                        0271
         BE    @RF00271                                            0271
*             DO;                                                  0272
*               TAXEPTR=PTAXEPTR;   /* ESTABLISH BASE                */
         LR    TAXEPTR,PTAXEPTR                                    0273
*               TAXEPTR=TAXELNK;    /* SET BASE TO FIRST TAXE TO BE
*                                      MADE AVAILABLE                */
         L     @15,TAXELNK-1(,TAXEPTR)                             0274
         LA    @15,0(,@15)                                         0274
         LR    TAXEPTR,@15                                         0274
*             END;                                                 0275
*           ELSE                    /* YES                           */
*             DO;                                                  0276
         B     @RC00271                                            0276
@RF00271 DS    0H                                                  0277
*               TAXEPTR=RCTDTAXE;   /* ESTABLISH BASE TO FIRST TAXE
*                                      TO BE AVAILABLE               */
         L     @15,ASXBPTR(,ASCBPTR)                               0277
         L     @15,ASXBRCTD(,@15)                                  0277
         L     TAXEPTR,RCTDTAXE(,@15)                              0277
*             END;                                                 0278
*           DO WHILE TAXEPTR^='00000000'X;/* SEARCH REMAINDER OF   0279
*                                      QUEUE                         */
@RC00271 B     @DE00279                                            0279
@DL00279 DS    0H                                                  0280
*             TAXEFREQ='0'B;        /* MARK TAXE AVAILABLE           */
         NI    TAXEFREQ(TAXEPTR),B'11011111'                       0280
*             STAXCNT=STAXCNT+'00010000'X;/* INCREMENT STAX COUNT    */
         AL    STAXCNT,@CF02063                                    0281
*             TAXEPTR=TAXELNK;      /* UPDATE TAXE BASE              */
         L     @15,TAXELNK-1(,TAXEPTR)                             0282
         LA    @15,0(,@15)                                         0282
         LR    TAXEPTR,@15                                         0282
*           END;                                                   0283
@DE00279 LTR   TAXEPTR,TAXEPTR                                     0283
         BNZ   @DL00279                                            0283
*         END;                                                     0284
*       RESPECIFY                                                  0285
*         PTAXEPTR UNRESTRICTED;                                   0285
@RF00269 DS    0H                                                  0286
*       RESPECIFY                                                  0286
*         TSBPTR RESTRICTED;                                       0286
*       RESPECIFY                                                  0287
*         PSTAXCNT RESTRICTED;                                     0287
*       RESPECIFY                                                  0288
*         NSTAXCNT RESTRICTED;                                     0288
*       TSBPTR=ASCBTSB;             /* LOAD THE TSB BASE REG         */
         L     TSBPTR,ASCBTSB(,ASCBPTR)                            0289
*       GENERATE CODE NODEFS NOSETS NOFLOWS REFS(TSBPTR);          0290
     USING TSB,TSBPTR
*       IF STAXCNT>'00FF0000'X THEN /* IS THE STAX COUNT >255        */
         L     @15,@CF02064                                        0291
         CLR   STAXCNT,@15                                         0291
         BNH   @RF00291                                            0291
*         DO;                       /* YES                           */
*           STAXCNT='00FF0000'X;    /* SET COUNT TO 255              */
         LR    STAXCNT,@15                                         0293
*         END;                                                     0294
*       NSTAXCNT=STAXCNT;           /* SAVE NEW STAX COUNT           */
@RF00291 LR    NSTAXCNT,STAXCNT                                    0295
*       PSTAXCNT=TSBATTNC;          /* LOAD ORIG SWAP VALUE          */
         L     PSTAXCNT,TSBATTNC                                   0296
*RTYU:                                                             0297
*       STAXCNT=PSTAXCNT;           /* LOAD PREVIOUS STAX COUNT      */
RTYU     LR    STAXCNT,PSTAXCNT                                    0297
*       STAXCNT=STAXCNT&'FF00FFFF'X;/* CLEAR OLD COUNT               */
         N     STAXCNT,@CF02067                                    0298
*       STAXCNT=STAXCNT|NSTAXCNT;   /* INSERT NEW STAX COUNT         */
         OR    STAXCNT,NSTAXCNT                                    0299
*       CS(PSTAXCNT,STAXCNT,TSBATTNC);/* PERFORM UPDATE              */
         CS    PSTAXCNT,@12,TSBATTNC                               0300
*       BC(7,RTYU);                 /* CONTINUE IF THE UPDATE WORKED */
         BC    7,RTYU                                              0301
*       GENERATE CODE NODEFS NOSETS NOFLOWS REFS(TSBPTR);          0302
      DROP TSBPTR
*       RESPECIFY                                                  0303
*         PSTAXCNT UNRESTRICTED;                                   0303
*       RESPECIFY                                                  0304
*         NSTAXCNT UNRESTRICTED;                                   0304
*       RESPECIFY                                                  0305
*         STAXCNT UNRESTRICTED;                                    0305
*       RESPECIFY                                                  0306
*         TSBPTR UNRESTRICTED;                                     0306
*       IF FRRCFSS='0'B THEN        /* WAS STATUS START PERFORMED    */
         TM    FRRCFSS(FRRWKAP),B'00000100'                        0307
         BNZ   @RF00307                                            0307
*         DO;                       /* NO                            */
*           RESPECIFY                                              0309
*             TSDWAPTR RESTRICTED;                                 0309
*           RESPECIFY                                              0310
*             STATPR0 RESTRICTED;                                  0310
*           RESPECIFY                                              0311
*             STATPR1 RESTRICTED;                                  0311
*           RESPECIFY                                              0312
*             STATPR13 RESTRICTED;                                 0312
*           RESPECIFY                                              0313
*             STATPR15 RESTRICTED;                                 0313
*           RESPECIFY                                              0314
*             ENTREG14 RESTRICTED;                                 0314
*           ENTREG14=RTNREG14;      /* SAVE REGISTER 14              */
         LR    ENTREG14,RTNREG14                                   0315
*           TSDWAPTR=SDWAPTR;       /* SAVE SDWAPTR                  */
         LR    TSDWAPTR,SDWAPTR                                    0316
*           STATPR0='00000007'X;    /* IDICATE START TCBS            */
         LA    STATPR0,7                                           0317
*           STATPR1=STATPR1-STATPR1;/* INDICATE ALL SUBTASKS         */
         SLR   STATPR1,STATPR1                                     0318
*           STATPR13=STATPR13-STATPR13;/* INDICATE NO MASK           */
         SLR   STATPR13,STATPR13                                   0319
*           CALL STATENT;           /* GO TO STATUS                  */
         L     @03,CVTPTR                                          0320
         L     @03,SCVTSPTR(,@03)                                  0320
         L     @15,SCVTSTAT(,@03)                                  0320
         BALR  @14,@15                                             0320
*           SDWAPTR=TSDWAPTR;       /* RESTORE SDWA BASE             */
         LR    SDWAPTR,TSDWAPTR                                    0321
*           RTNREG14=ENTREG14;      /* RESTORE RETURN REGISTER       */
         LR    RTNREG14,ENTREG14                                   0322
*         END;                                                     0323
*       RESPECIFY                                                  0324
*         TSDWAPTR UNRESTRICTED;                                   0324
@RF00307 DS    0H                                                  0325
*       RESPECIFY                                                  0325
*         STATPR0 UNRESTRICTED;                                    0325
*       RESPECIFY                                                  0326
*         STATPR1 UNRESTRICTED;                                    0326
*       RESPECIFY                                                  0327
*         STATPR13 UNRESTRICTED;                                   0327
*       RESPECIFY                                                  0328
*         STATPR15 UNRESTRICTED;                                   0328
*       RESPECIFY                                                  0329
*         ENTREG14 UNRESTRICTED;                                   0329
*       IF SDWAVRAL<LENGTH(FRRWKA) THEN/* CHECK IF VARIABLE AREA WILL
*                                      HOLD THE ENTIRE FRR WORK AREA */
         LH    @15,SDWAVRAL(,SDWAPTR)                              0330
         N     @15,@CF02099                                        0330
         C     @15,@CF00166                                        0330
         BNL   @RF00330                                            0330
*         DO;                       /* NO                            */
*           SDWAVRA(1:SDWAVRAL)=FRRWKA;/* MOVE AS MUCH AS POSSIBLE   */
         BCTR  @15,0                                               0332
         EX    @15,@SM02100                                        0332
*           SDWAURAL=SDWAVRAL(2:2); /* MOVE LENGTH OF RECORD INTO  0333
*                                      SDWA                          */
         MVC   SDWAURAL(1,SDWAPTR),SDWAVRAL+1(SDWAPTR)             0333
*         END;                                                     0334
*       ELSE                        /* YES                           */
*         DO;                                                      0335
         B     @RC00330                                            0335
@RF00330 DS    0H                                                  0336
*           SDWAVRA(1:LENGTH(FRRWKA))=FRRWKA;/* MOVE FRR WORK AREA 0336
*                                      INTO RECORDING AREA           */
         MVC   SDWAVRA(24,SDWAPTR),FRRWKA(FRRWKAP)                 0336
*           SDWAURAL=LENGTH(FRRWKA);/* MOVE LENGTH OF RECORD INTO  0337
*                                      SDWA                          */
         MVI   SDWAURAL(SDWAPTR),X'18'                             0337
*         END;                                                     0338
*       SDWAHEX='1'B;               /* DUMP VARIABLE RECORDING AREA
*                                      IN HEX                        */
@RC00330 OI    SDWAHEX(SDWAPTR),B'10000000'                        0339
*       DO;                         /* SETRP RECORD(YES)WKAREA(SDWAPT
*                                      R)RECPARM(FRRMODID)RC(0)      */
*         RESPECIFY                                                0341
*          (GPR00P,                                                0341
*           GPR01P,                                                0341
*           GPR14P,                                                0341
*           GPR15P) RSTD;                                          0341
*         GPR01P=SDWAPTR;                                          0342
*         GPR01P->SDWARCDE=0;       /* SAVE RC VALUE                 */
         MVI   SDWARCDE(GPR01P),X'00'                              0343
*         GPR01P->SDWARCRD='1'B;    /* TURN ON RECORD INDICATOR      */
         OI    SDWARCRD(GPR01P),B'10000000'                        0344
*         GPR15P=ADDR(FRRMODID);    /* ACCESS RECORD PARAMETER LIST  */
         LA    GPR15P,FRRMODID                                     0345
*         GPR01P->SDWARECP=GPR15P->I256C(1:24);/* COPY RECORD      0346
*                                      PARAMETERS                    */
         MVC   SDWARECP(24,GPR01P),I256C(GPR15P)                   0346
*         RESPECIFY                                                0347
*          (GPR00P,                                                0347
*           GPR01P,                                                0347
*           GPR14P,                                                0347
*           GPR15P) UNRSTD;                                        0347
*       END;                                                       0348
*     END;                                                         0349
*   ELSE                            /* NO                            */
*     DO;                                                          0350
         B     @RC00232                                            0350
@RF00232 DS    0H                                                  0351
*       DO;                         /* SETRP WKAREA(SDWAPTR)RC(0)    */
*         RESPECIFY                                                0352
*          (GPR00P,                                                0352
*           GPR01P,                                                0352
*           GPR14P,                                                0352
*           GPR15P) RSTD;                                          0352
*         GPR01P=SDWAPTR;                                          0353
*         GPR01P->SDWARCDE=0;       /* SAVE RC VALUE                 */
         MVI   SDWARCDE(GPR01P),X'00'                              0354
*         RESPECIFY                                                0355
*          (GPR00P,                                                0355
*           GPR01P,                                                0355
*           GPR14P,                                                0355
*           GPR15P) UNRSTD;                                        0355
*       END;                                                       0356
*     END;                                                         0357
*   DECLARE                         /* GENERAL PURPOSE REGISTERS     */
*     GPR00P PTR(31) REG(0),                                       0358
*     GPR01P PTR(31) REG(1),                                       0358
*     GPR14P PTR(31) REG(14),                                      0358
*     GPR15P PTR(31) REG(15);                                      0358
*   DECLARE                         /* COMMON VARIABLES              */
*     I256C CHAR(256) BASED,                                       0359
*     I031F FIXED(31) BASED,                                       0359
*     I031P PTR(31) BASED,                                         0359
*     I015F FIXED(15) BASED,                                       0359
*     I015P PTR(15) BASED,                                         0359
*     I008P PTR(8) BASED,                                          0359
*     I001C CHAR(1) BASED;                                         0359
*FR6EXIT:                                                          0360
*   END IEAVAFR6;                   /* END OF THE FRR                */
@EL00002 DS    0H                                                  0360
@EF00002 DS    0H                                                  0360
@ER00002 BR    @14                                                 0360
*R06EXIT:                                                          0361
*   END IEAVAR06                    /* END OF THE MAINLINE           */
*                                                                  0361
*/* THE FOLLOWING INCLUDE STATEMENTS WERE FOUND IN THIS PROGRAM.     */
*/*%INCLUDE SYSLIB  (IHAASCB )                                       */
*/*%INCLUDE SYSLIB  (IHAASXB )                                       */
*/*%INCLUDE SYSLIB  (CVT     )                                       */
*/*%INCLUDE SYSLIB  (IHAFRRS )                                       */
*/*%INCLUDE SYSLIB  (IHAPSA  )                                       */
*/*%INCLUDE SYSLIB  (IHARB   )                                       */
*/*%INCLUDE SYSLIB  (IKJRB   )                                       */
*/*%INCLUDE SYSLIB  (IEARCTD )                                       */
*/*%INCLUDE SYSLIB  (IHASCVT )                                       */
*/*%INCLUDE SYSLIB  (IHASDWA )                                       */
*/*%INCLUDE SYSLIB  (IKJTAIE )                                       */
*/*%INCLUDE SYSLIB  (IKJTAXE )                                       */
*                                                                  0361
*       ;                                                          0361
@DATA    DS    0H
@SM02100 MVC   SDWAVRA(0,SDWAPTR),FRRWKA(FRRWKAP)
@DATD    DSECT
         DS    0F
IEAVAR06 CSECT
         DS    0F
@CF00166 DC    F'24'
@CF02063 DC    XL4'00010000'
@CF02064 DC    XL4'00FF0000'
@CF02067 DC    XL4'FF00FFFF'
@CF02099 DC    XL4'0000FFFF'
@DATD    DSECT
         DS    0D
IEAVAR06 CSECT
         DS    0F
@SIZDATD DC    AL1(0)
         DC    AL3(@ENDDATD-@DATD)
         DS    0D
@CB02058 DC    X'00000000'
@CB02095 EQU   @CB02058
FRRMODID DC    CL24'IEAVAR06IEAVAR06IEAVAFR6'
@DATD    DSECT
  IKJTSB LIST=YES
IEAVAR06 CSECT
         DS   0H
PATCHR06 DC ((@DATA-@PSTART)/20)X'00'
@DATD    DSECT
         ORG   *+1-(*-@DATD)/(*-@DATD) INSURE DSECT DATA
@ENDDATD EQU   *
IEAVAR06 CSECT
@00      EQU   00                      EQUATES FOR REGISTERS 0-15
@01      EQU   01
@02      EQU   02
@03      EQU   03
@04      EQU   04
@05      EQU   05
@06      EQU   06
@07      EQU   07
@08      EQU   08
@09      EQU   09
@10      EQU   10
@11      EQU   11
@12      EQU   12
@13      EQU   13
@14      EQU   14
@15      EQU   15
ASCBPTR  EQU   @07
FRRSPTR  EQU   @11
FRREPTR  EQU   @12
RBSECPTR EQU   @05
SDWAPTR  EQU   @01
TAXEPTR  EQU   @09
FRRWKAP  EQU   @06
STATPR0  EQU   @00
FREMPR0  EQU   @00
STATPR1  EQU   @01
FREMPR1  EQU   @01
TSBPTR   EQU   @02
TSDWAPTR EQU   @02
FREMPR3  EQU   @03
NSTAXCNT EQU   @03
ORIGTAXE EQU   @03
TCBPTR   EQU   @04
BASEREG  EQU   @08
ENTREG13 EQU   @10
ENTREG14 EQU   @10
PSTAXCNT EQU   @11
PTAXEPTR EQU   @11
NTAXEPTR EQU   @12
STAXCNT  EQU   @12
STATPR13 EQU   @13
RTNREG13 EQU   @13
RTNREG14 EQU   @14
FREMPR15 EQU   @15
STATPR15 EQU   @15
GPR00P   EQU   @00
GPR01P   EQU   @01
GPR14P   EQU   @14
GPR15P   EQU   @15
CVTPTR   EQU   16
PSA      EQU   0
FLCRNPSW EQU   PSA
FLCROPSW EQU   PSA+8
FLCICCW2 EQU   PSA+16
PSAEEPSW EQU   PSA+132
PSAESPSW EQU   PSA+136
FLCSVILC EQU   PSAESPSW+1
PSAEPPSW EQU   PSA+140
FLCPIILC EQU   PSAEPPSW+1
FLCPICOD EQU   PSAEPPSW+2
PSAPICOD EQU   FLCPICOD+1
FLCTEA   EQU   PSAEPPSW+4
FLCPER   EQU   PSA+152
FLCMCLA  EQU   PSA+168
FLCIOEL  EQU   FLCMCLA+4
FLCIOA   EQU   FLCMCLA+16
FLCFSA   EQU   FLCMCLA+80
PSAAOLD  EQU   PSA+548
PSASUPER EQU   PSA+552
PSASUP1  EQU   PSASUPER
PSASUP2  EQU   PSASUPER+1
PSASUP3  EQU   PSASUPER+2
PSASUP4  EQU   PSASUPER+3
PSACLHT  EQU   PSA+640
PSALKSA  EQU   PSA+696
PSAHLHI  EQU   PSA+760
PSADSSFL EQU   PSA+836
PSADSSF1 EQU   PSADSSFL
PSADSSF3 EQU   PSADSSFL+2
PSADSSF4 EQU   PSADSSFL+3
PSARSVT  EQU   PSA+896
PSALSFCC EQU   PSA+1012
ASCB     EQU   0
ASCBTSB  EQU   ASCB+60
ASCBFW1  EQU   ASCB+100
ASCBRCTF EQU   ASCBFW1+2
ASCBFLG1 EQU   ASCBFW1+3
ASCBASXB EQU   ASCB+108
ASCBDSP1 EQU   ASCB+114
ASCBFLG2 EQU   ASCB+115
ASXB     EQU   0
ASXBRCTD EQU   ASXB+120
ASXBAEQ  EQU   ASXB+168
ASXBSECR EQU   ASXB+199
ASCBSFLG EQU   ASXBSECR
ASXBCASW EQU   ASXB+216
ASXBCRB1 EQU   ASXBCASW
CVTMAP   EQU   0
CVTDAR   EQU   CVTMAP+72
CVTFLGS1 EQU   CVTDAR
CVTDCB   EQU   CVTMAP+116
CVTIOQET EQU   CVTMAP+120
CVTIERLC EQU   CVTMAP+144
CVTHEAD  EQU   CVTMAP+160
CVTSV76C EQU   CVTHEAD
CVTOPTA  EQU   CVTMAP+182
CVTOPTB  EQU   CVTMAP+183
CVTABEND EQU   CVTMAP+200
CVTGTF   EQU   CVTMAP+236
CVTGTFST EQU   CVTGTF
CVTGTFS  EQU   CVTGTFST
CVTSTATE EQU   CVTGTFST
CVTTMODE EQU   CVTGTFST
CVTFORM  EQU   CVTGTFST
CVTAQAVT EQU   CVTMAP+240
CVTTCMFG EQU   CVTAQAVT
CVTVOLM2 EQU   CVTMAP+244
CVTTATA  EQU   CVTVOLM2
CVTTSKS  EQU   CVTTATA
CVTVOLF2 EQU   CVTTSKS
CVTTAT   EQU   CVTTATA+1
CVTATER  EQU   CVTMAP+248
CVTEXT1  EQU   CVTMAP+252
CVTPURG  EQU   CVTMAP+260
CVTQMSG  EQU   CVTMAP+268
CVTDMSR  EQU   CVTMAP+272
CVTRSV37 EQU   CVTDMSR
CVTDMSRF EQU   CVTRSV37
CVTERPV  EQU   CVTMAP+316
CVTINTLA EQU   CVTMAP+320
CVTAPF   EQU   CVTMAP+324
CVTEXT2  EQU   CVTMAP+328
CVTHJES  EQU   CVTMAP+332
CVTPGSIA EQU   CVTMAP+348
CVTA1F1  EQU   CVTMAP+356
CVTSYSK  EQU   CVTMAP+357
CVTVOLM1 EQU   CVTMAP+380
CVTVOLF1 EQU   CVTVOLM1
CVTATMCT EQU   CVTMAP+388
CVTXTNT1 EQU   0
CVTXTNT2 EQU   0
CVTDSSV  EQU   CVTXTNT2
CVTFLGBT EQU   CVTXTNT2+5
CVTQID   EQU   CVTXTNT2+24
CVTRV400 EQU   CVTXTNT2+52
CVTRV409 EQU   CVTXTNT2+53
CVTATCVT EQU   CVTXTNT2+64
CVTRV429 EQU   CVTXTNT2+84
CVTRV438 EQU   CVTXTNT2+85
CVTRV457 EQU   CVTXTNT2+112
CVTRV466 EQU   CVTXTNT2+113
CVTFIX   EQU   0
CVTRELNO EQU   CVTFIX+252
FRRS     EQU   0
FRRSHEAD EQU   FRRS
FRRSEMP  EQU   FRRSHEAD
FRRSLAST EQU   FRRSHEAD+4
FRRSELEN EQU   FRRSHEAD+8
FRRSCURR EQU   FRRSHEAD+12
FRRSENTR EQU   0
FRRSFRRA EQU   FRRSENTR
FRRSFLGS EQU   FRRSENTR+4
FRRSFLG1 EQU   FRRSFLGS
FRRSPARM EQU   FRRSENTR+8
RBPRFX   EQU   0
RBBASIC  EQU   0
RBEXRTNM EQU   RBBASIC
RBTMFLD  EQU   RBEXRTNM
RBSTAB   EQU   RBBASIC+10
XSTAB    EQU   RBSTAB
RBSTAB1  EQU   XSTAB
XSTAB1   EQU   RBSTAB1
RBFTCKPT EQU   XSTAB1
RBSTAB2  EQU   XSTAB+1
XSTAB2   EQU   RBSTAB2
RBTCBNXT EQU   XSTAB2
RBFACTV  EQU   XSTAB2
RBFDYN   EQU   XSTAB2
RBECBWT  EQU   XSTAB2
RBOPSW   EQU   RBBASIC+16
XRBPSW   EQU   RBOPSW
RBOPSWB2 EQU   XRBPSW+1
RBLINK   EQU   RBBASIC+28
XRBLNK   EQU   RBLINK
RBWCF    EQU   XRBLNK
RBLINKB  EQU   XRBLNK+1
RBGRSAVE EQU   RBBASIC+32
XRBREG   EQU   RBGRSAVE
RBGRS0   EQU   XRBREG
RBGRS1   EQU   XRBREG+4
RBGRS2   EQU   XRBREG+8
RBGRS3   EQU   XRBREG+12
RBGRS4   EQU   XRBREG+16
RBGRS5   EQU   XRBREG+20
RBGRS6   EQU   XRBREG+24
RBGRS7   EQU   XRBREG+28
RBGRS8   EQU   XRBREG+32
RBGRS9   EQU   XRBREG+36
RBGRS10  EQU   XRBREG+40
RBGRS11  EQU   XRBREG+44
RBGRS12  EQU   XRBREG+48
RBGRS13  EQU   XRBREG+52
RBGRS14  EQU   XRBREG+56
RBGRS15  EQU   XRBREG+60
XRBESA   EQU   RBBASIC+96
RBPREFIX EQU   0
RBRSV019 EQU   RBPREFIX+14
RBRSV028 EQU   RBPREFIX+15
RBRSV041 EQU   RBPREFIX+27
RBRSV054 EQU   RBPREFIX+39
RBRTOPSW EQU   RBPREFIX+40
RBRTPSW2 EQU   RBRTOPSW+8
RBRTICIL EQU   RBRTPSW2
RBFLAGS1 EQU   RBPREFIX+56
RBINTCDA EQU   RBPREFIX+61
RBSECT   EQU   0
RBPPSAV  EQU   RBSECT
@NM00040 EQU   RBSECT+10
@NM00041 EQU   @NM00040
RBTRSVRB EQU   @NM00041
@NM00043 EQU   @NM00040+1
RBETXR   EQU   @NM00043
RBEP     EQU   RBSECT+12
RBPGMQ   EQU   RBSECT+24
@NM00050 EQU   RBSECT+28
IRBEND   EQU   RBSECT+96
@NM00054 EQU   RBSECT+96
RBRSV138 EQU   @NM00054+7
RBRSV150 EQU   RBSECT+167
RCTD     EQU   0
RCTDWORK EQU   RCTD+80
RCTDLMAC EQU   RCTDWORK
RCTDCLRL EQU   RCTDLMAC
RCTDTIME EQU   RCTDCLRL
RCTDECBS EQU   RCTD+156
RCTDWPTR EQU   RCTDECBS+4
RCTDTECB EQU   RCTD+164
RCTDTAXE EQU   RCTD+172
RCTDPIRL EQU   RCTD+176
RCTDSLST EQU   RCTD+192
RCTDRCTR EQU   RCTD+216
RCTDMOID EQU   RCTDRCTR
RCTDFLGS EQU   RCTDRCTR+1
RCTDINTF EQU   RCTD+220
RCTDRCTF EQU   RCTDINTF
SCVTSECT EQU   0
SCVTSTAT EQU   SCVTSECT+148
SDWA     EQU   0
SDWAPARM EQU   SDWA
SDWAFIOB EQU   SDWA+4
SDWAABCC EQU   SDWAFIOB
SDWACMPF EQU   SDWAABCC
SDWACTL1 EQU   SDWA+8
SDWACMKA EQU   SDWACTL1
SDWAMWPA EQU   SDWACTL1+1
SDWAPMKA EQU   SDWACTL1+4
SDWACTL2 EQU   SDWA+16
SDWACMKP EQU   SDWACTL2
SDWAMWPP EQU   SDWACTL2+1
SDWAPMKP EQU   SDWACTL2+4
SDWAGRSV EQU   SDWA+24
SDWANAME EQU   SDWA+88
SDWAEC1  EQU   SDWA+104
SDWAEMK1 EQU   SDWAEC1
SDWAMWP1 EQU   SDWAEC1+1
SDWAINT1 EQU   SDWAEC1+2
SDWANXT1 EQU   SDWAEC1+4
SDWAAEC1 EQU   SDWA+112
SDWAILC1 EQU   SDWAAEC1+1
SDWAINC1 EQU   SDWAAEC1+2
SDWAICD1 EQU   SDWAINC1+1
SDWAEC2  EQU   SDWA+120
SDWAEMK2 EQU   SDWAEC2
SDWAMWP2 EQU   SDWAEC2+1
SDWAINT2 EQU   SDWAEC2+2
SDWANXT2 EQU   SDWAEC2+4
SDWAAEC2 EQU   SDWA+128
SDWAILC2 EQU   SDWAAEC2+1
SDWAINC2 EQU   SDWAAEC2+2
SDWAICD2 EQU   SDWAINC2+1
SDWASRSV EQU   SDWA+136
SDWAIDNT EQU   SDWA+200
SDWAMCH  EQU   SDWA+204
SDWASTCK EQU   SDWAMCH
SDWAMCHI EQU   SDWAMCH+8
SDWAMCHS EQU   SDWAMCHI
SDWAMCHD EQU   SDWAMCHI+1
SDWARSR1 EQU   SDWAMCH+12
SDWARSR2 EQU   SDWAMCH+13
SDWAFLGS EQU   SDWA+232
SDWAERRA EQU   SDWAFLGS
SDWAERRB EQU   SDWAFLGS+1
SDWAERRC EQU   SDWAFLGS+2
SDWAERRD EQU   SDWAFLGS+3
SDWAFMID EQU   SDWA+236
SDWAIOFS EQU   SDWA+238
SDWACPUA EQU   SDWA+248
SDWAPARQ EQU   SDWA+252
SDWARCDE EQU   SDWAPARQ
SDWAACF2 EQU   SDWAPARQ+1
SDWARCRD EQU   SDWAACF2
SDWAACF3 EQU   SDWAPARQ+2
SDWAACF4 EQU   SDWAPARQ+3
SDWALKWA EQU   SDWA+256
SDWALKWS EQU   SDWALKWA
SDWARECP EQU   SDWA+292
SDWASNPA EQU   SDWA+320
SDWADUMP EQU   SDWASNPA
SDWADPFS EQU   SDWADUMP+1
SDWADDAT EQU   SDWASNPA+4
SDWASDAT EQU   SDWADDAT
SDWAPDAT EQU   SDWADDAT+2
SDWADPSA EQU   SDWA+328
SDWADPSL EQU   SDWADPSA
SDWARA   EQU   SDWA+400
SDWAVRAL EQU   SDWARA
SDWADPVA EQU   SDWARA+2
SDWAHEX  EQU   SDWADPVA
SDWAURAL EQU   SDWARA+3
SDWAVRA  EQU   SDWARA+4
TAIE     EQU   0
TAXE     EQU   0
TAXEWORK EQU   TAXE+100
TAXELNK  EQU   TAXEWORK+17
TAXEPARM EQU   TAXEWORK+28
TAXESTAT EQU   TAXEPARM
TAXEFREQ EQU   TAXESTAT
TAXERESM EQU   TAXESTAT
TAXESCHD EQU   TAXESTAT
TAXETAIE EQU   TAXEWORK+32
FRRWKA   EQU   0
FRRFLAGS EQU   FRRWKA
FRRGTFTI EQU   FRRFLAGS
FRRCFFTI EQU   FRRFLAGS
FRRTTBDQ EQU   FRRFLAGS
FRRTHBDQ EQU   FRRFLAGS
FRRGTSS  EQU   FRRFLAGS
FRRCFSS  EQU   FRRFLAGS
FRRSTS   EQU   FRRFLAGS
FRRTAXE  EQU   FRRWKA+4
FRRPTAXE EQU   FRRWKA+8
FRRNTAXE EQU   FRRWKA+12
STATENT  EQU   0
I256C    EQU   0
I001C    EQU   0
I008P    EQU   0
I015F    EQU   0
I015P    EQU   0
I031F    EQU   0
I031P    EQU   0
ASXBPTR  EQU   ASCBASXB
CVTS01   EQU   CVTPGSIA
CVTLPDIA EQU   CVTS01+12
CVTDIRST EQU   CVTLPDIA
CVTSLIDA EQU   CVTS01+24
CVTCTLFG EQU   CVTS01+50
CVTCRMN  EQU   CVTS01+156
CVTRV210 EQU   CVTS01+424
CVTRV219 EQU   CVTS01+425
CVTRV228 EQU   CVTS01+426
CVTRV237 EQU   CVTS01+427
CVTMFRTR EQU   CVTS01+452
CVTRV262 EQU   CVTS01+468
CVTRV271 EQU   CVTS01+469
CVTRV280 EQU   CVTS01+470
CVTRV289 EQU   CVTS01+471
CVTGSDA  EQU   CVTS01+600
PSARSVTE EQU   PSARSVT
PSACSTK  EQU   PSARSVTE
RBSECS03 EQU   RBEP
RBCDE    EQU   RBSECS03
RBCDFLGS EQU   RBCDE
RBSECS05 EQU   RBPGMQ
RBSQE    EQU   RBSECS05
RBSECS06 EQU   RBPGMQ
RBIQE    EQU   RBSECS06
RBSECS07 EQU   RBPGMQ
RBIQE2   EQU   RBSECS07
RBSECS08 EQU   IRBEND
RBSECS09 EQU   IRBEND
@NM00063 EQU   RCTDFLGS
@NM00065 EQU   RCTDFLGS
@NM00067 EQU   RCTDFLGS
@NM00069 EQU   RCTDFLGS
@NM00071 EQU   RCTDFLGS
SCVTSPTR EQU   CVTABEND
TAIEPTR  EQU   TAXETAIE
FLC      EQU   PSA
RCTDPTR  EQU   ASXBRCTD
         AGO   .@UNREFD                START UNREFERENCED COMPONENTS
@NM00074 EQU   @NM00071+2
RCTDOPTC EQU   @NM00071+2
RCTDWTLC EQU   @NM00071+2
@NM00073 EQU   @NM00071+2
@NM00072 EQU   @NM00071+1
RCTDRLWB EQU   @NM00071+1
RCTDRLWC EQU   @NM00071+1
RCTDSTAC EQU   @NM00071+1
RCTDWTLB EQU   @NM00071+1
RCTDRIOC EQU   @NM00071+1
RCTDRSLW EQU   @NM00071
RCTDFAIL EQU   @NM00071
RCTDSY18 EQU   @NM00071
RCTDSY19 EQU   @NM00071
RCTDRLLK EQU   @NM00071
RCTDSTAT EQU   @NM00071
RCTDOBLK EQU   @NM00071
RCTDRS17 EQU   @NM00071
@NM00070 EQU   @NM00069+2
RCTDRGL1 EQU   @NM00069+2
RCTDOGL1 EQU   @NM00069+2
RCTDRLL2 EQU   @NM00069+2
RCTDOLL2 EQU   @NM00069+2
RCTDSWPF EQU   @NM00069+2
RCTDSYBC EQU   @NM00069+1
RCTDPRGF EQU   @NM00069+1
RCTDSLFL EQU   @NM00069+1
RCTDQWAI EQU   @NM00069+1
RCTDSWOT EQU   @NM00069+1
RCTDSSRB EQU   @NM00069+1
RCTDSSUB EQU   @NM00069+1
RCTDSY13 EQU   @NM00069+1
RCTDPSRB EQU   @NM00069
RCTDDEQ  EQU   @NM00069
RCTDSV16 EQU   @NM00069
RCTDSY12 EQU   @NM00069
RCTDPSUB EQU   @NM00069
RCTDRLL1 EQU   @NM00069
RCTDOLL1 EQU   @NM00069
RCTDENQ  EQU   @NM00069
@NM00068 EQU   @NM00067
RCTDPMSG EQU   @NM00067
RCTDAFPC EQU   @NM00067
RCTDAFPE EQU   @NM00067
@NM00066 EQU   @NM00065
RCTDCANE EQU   @NM00065
RCTDDETD EQU   @NM00065
RCTDDETS EQU   @NM00065
RCTDRES4 EQU   @NM00065
@NM00064 EQU   @NM00063
RCTDBR2A EQU   @NM00063
RCTDBR2R EQU   @NM00063
RCTDBR2Q EQU   @NM00063
RCTDBR2T EQU   @NM00063
RCTDLOOP EQU   @NM00063
RCTDWAIT EQU   @NM00063
RBRSV161 EQU   RBSECS09+64
RBSIRBWA EQU   RBSECS09
RBIQEWRK EQU   RBSECS08+4
RBNEXAV  EQU   RBSECS08
RBIQEA   EQU   RBIQE2
RBIQE1   EQU   RBIQE+1
RBUSE    EQU   RBIQE
RBSQEA   EQU   RBSQE+1
@NM00055 EQU   RBSQE
RBCDE1   EQU   RBCDE+1
RBCDLOAD EQU   RBCDFLGS
RBCDXCTL EQU   RBCDFLGS
RBCDSYNC EQU   RBCDFLGS
RBCDNODE EQU   RBCDFLGS
RBRSV010 EQU   RBCDFLGS
RBCDATCH EQU   RBCDFLGS
RBRSV009 EQU   RBCDFLGS
RBNOCELL EQU   RBCDFLGS
PSARSAV  EQU   PSARSVTE+60
PSARSTK  EQU   PSARSVTE+56
PSAESAV3 EQU   PSARSVTE+52
PSAESTK3 EQU   PSARSVTE+48
PSAESAV2 EQU   PSARSVTE+44
PSAESTK2 EQU   PSARSVTE+40
PSAESAV1 EQU   PSARSVTE+36
PSAESTK1 EQU   PSARSVTE+32
PSAPSAV  EQU   PSARSVTE+28
PSAPSTK  EQU   PSARSVTE+24
PSAMSAV  EQU   PSARSVTE+20
PSAMSTK  EQU   PSARSVTE+16
PSASSAV  EQU   PSARSVTE+12
PSASSTK  EQU   PSARSVTE+8
PSANSTK  EQU   PSARSVTE+4
CVTRV628 EQU   CVTS01+728
CVTRV627 EQU   CVTS01+724
CVTRV626 EQU   CVTS01+720
CVTRV625 EQU   CVTS01+716
CVTRV624 EQU   CVTS01+712
CVTRV623 EQU   CVTS01+708
CVTRV622 EQU   CVTS01+704
CVTRV621 EQU   CVTS01+700
CVTIHASU EQU   CVTS01+696
CVTRV619 EQU   CVTS01+692
CVTRV618 EQU   CVTS01+688
CVTRV617 EQU   CVTS01+684
CVTRV616 EQU   CVTS01+680
CVTRV615 EQU   CVTS01+676
CVTRV614 EQU   CVTS01+672
CVTRV613 EQU   CVTS01+668
CVTTCASP EQU   CVTS01+664
CVT0PT03 EQU   CVTS01+660
CVT0PT0E EQU   CVTS01+656
CVTRV609 EQU   CVTS01+652
CVTCGK   EQU   CVTS01+648
CVTRAC   EQU   CVTS01+644
CVTRV606 EQU   CVTS01+640
CVTRV605 EQU   CVTS01+636
CVTRV604 EQU   CVTS01+632
CVTEFF02 EQU   CVTS01+628
CVTCBBR  EQU   CVTS01+624
CVTSSCR  EQU   CVTS01+620
CVTEVENT EQU   CVTS01+616
CVTCRCA  EQU   CVTS01+612
CVTTPIO  EQU   CVTS01+608
CVTADV   EQU   CVTS01+604
CVTGSDAB EQU   CVTGSDA
CVTQV3   EQU   CVTS01+596
CVTQV2   EQU   CVTS01+592
CVTQV1   EQU   CVTS01+588
CVTRPT   EQU   CVTS01+584
CVTSSRB  EQU   CVTS01+580
CVTCSDRL EQU   CVTS01+576
CVTEXP1  EQU   CVTS01+572
CVTRMPMT EQU   CVTS01+568
CVTRMPTT EQU   CVTS01+564
CVTVPSA  EQU   CVTS01+560
CVTVSTOP EQU   CVTS01+556
CVTGTFR8 EQU   CVTS01+552
CVTQUIT  EQU   CVTS01+548
CVTVACR  EQU   CVTS01+544
CVTWTCB  EQU   CVTS01+540
CVTSTPRS EQU   CVTS01+536
CVT0PT02 EQU   CVTS01+532
CVTDARCM EQU   CVTS01+528
CVTIRECM EQU   CVTS01+524
CVTJRECM EQU   CVTS01+520
CVTVEMS0 EQU   CVTS01+516
CVTSPFRR EQU   CVTS01+512
CVTRLSTG EQU   CVTS01+508
CVT0TC0A EQU   CVTS01+504
CVTGMBR  EQU   CVTS01+500
CVTLFRM  EQU   CVTS01+496
CVTRMBR  EQU   CVTS01+492
CVTVIOP  EQU   CVTS01+488
CVTRV307 EQU   CVTS01+486
CVTRV306 EQU   CVTS01+484
CVTRV305 EQU   CVTS01+482
CVTRV304 EQU   CVTS01+480
CVTRV303 EQU   CVTS01+478
CVTRV302 EQU   CVTS01+476
CVTTRCA  EQU   CVTS01+472
CVTRV297 EQU   CVTRV289
CVTRV296 EQU   CVTRV289
CVTRV295 EQU   CVTRV289
CVTRV294 EQU   CVTRV289
CVTRV293 EQU   CVTRV289
CVTRV292 EQU   CVTRV289
CVTRV291 EQU   CVTRV289
CVTRV290 EQU   CVTRV289
CVTRV288 EQU   CVTRV280
CVTRV287 EQU   CVTRV280
CVTRV286 EQU   CVTRV280
CVTRV285 EQU   CVTRV280
CVTRV284 EQU   CVTRV280
CVTRV283 EQU   CVTRV280
CVTRV282 EQU   CVTRV280
CVTRV281 EQU   CVTRV280
CVTRV279 EQU   CVTRV271
CVTRV278 EQU   CVTRV271
CVTRV277 EQU   CVTRV271
CVTRV276 EQU   CVTRV271
CVTRV275 EQU   CVTRV271
CVTRV274 EQU   CVTRV271
CVTRV273 EQU   CVTRV271
CVTRV272 EQU   CVTRV271
CVTRV270 EQU   CVTRV262
CVTRV269 EQU   CVTRV262
CVTRV268 EQU   CVTRV262
CVTRV267 EQU   CVTRV262
CVTRV266 EQU   CVTRV262
CVTRV265 EQU   CVTRV262
CVTRV264 EQU   CVTRV262
CVTRV263 EQU   CVTRV262
CVTVFP   EQU   CVTS01+464
CVTVSI   EQU   CVTS01+460
CVTVPSIB EQU   CVTS01+456
CVTMFACT EQU   CVTMFRTR
CVTMFCTL EQU   CVTS01+448
CVTPVBP  EQU   CVTS01+444
CVTPWI   EQU   CVTS01+440
CVTRV254 EQU   CVTS01+438
CVTRV253 EQU   CVTS01+436
CVTRV252 EQU   CVTS01+434
CVTRV251 EQU   CVTS01+433
CVTRV250 EQU   CVTS01+432
CVTRV249 EQU   CVTS01+431
CVTRV248 EQU   CVTS01+430
CVTRV247 EQU   CVTS01+429
CVTRV246 EQU   CVTS01+428
CVTRV245 EQU   CVTRV237
CVTRV244 EQU   CVTRV237
CVTRV243 EQU   CVTRV237
CVTRV242 EQU   CVTRV237
CVTRV241 EQU   CVTRV237
CVTRV240 EQU   CVTRV237
CVTRV239 EQU   CVTRV237
CVTRV238 EQU   CVTRV237
CVTRV236 EQU   CVTRV228
CVTRV235 EQU   CVTRV228
CVTRV234 EQU   CVTRV228
CVTRV233 EQU   CVTRV228
CVTRV232 EQU   CVTRV228
CVTRV231 EQU   CVTRV228
CVTRV230 EQU   CVTRV228
CVTRV229 EQU   CVTRV228
CVTRV227 EQU   CVTRV219
CVTRV226 EQU   CVTRV219
CVTRV225 EQU   CVTRV219
CVTRV224 EQU   CVTRV219
CVTRV223 EQU   CVTRV219
CVTRV222 EQU   CVTRV219
CVTRV221 EQU   CVTRV219
CVTRV220 EQU   CVTRV219
CVTRV218 EQU   CVTRV210
CVTRV217 EQU   CVTRV210
CVTRV216 EQU   CVTRV210
CVTRV215 EQU   CVTRV210
CVTRV214 EQU   CVTRV210
CVTRV213 EQU   CVTRV210
CVTRV212 EQU   CVTRV210
CVTRV211 EQU   CVTRV210
CVTLCCAT EQU   CVTS01+420
CVTPCCAT EQU   CVTS01+416
CVTIPCRP EQU   CVTS01+412
CVTIPCRI EQU   CVTS01+408
CVTIPCDS EQU   CVTS01+404
CVTAIDVT EQU   CVTS01+400
CVTSSAP  EQU   CVTS01+396
CVTEHCIR EQU   CVTS01+392
CVTEHDEF EQU   CVTS01+388
CVTDAIR  EQU   CVTS01+384
CVTPERFM EQU   CVTS01+380
CVT044R2 EQU   CVTS01+376
CVTFETCH EQU   CVTS01+372
CVTRSTWD EQU   CVTS01+368
CVTSPOST EQU   CVTS01+364
CVTIOBP  EQU   CVTS01+360
CVTASMVT EQU   CVTS01+356
CVTRECRQ EQU   CVTS01+352
CVTWSAC  EQU   CVTS01+348
CVTRV149 EQU   CVTS01+344
CVTWSAL  EQU   CVTS01+340
CVTSPSA  EQU   CVTS01+336
CVTGLMN  EQU   CVTS01+332
CVTVEAC0 EQU   CVTS01+328
CVT062R1 EQU   CVTS01+324
CVTRPOST EQU   CVTS01+320
CVTDQIQE EQU   CVTS01+316
CVTCSD   EQU   CVTS01+312
CVTLKRMA EQU   CVTS01+308
CVTRSPIE EQU   CVTS01+304
CVTRENQ  EQU   CVTS01+300
CVTLQCB  EQU   CVTS01+296
CVTFQCB  EQU   CVTS01+292
CVTQCS01 EQU   CVTS01+288
CVTAPFT  EQU   CVTS01+284
CVTPARRL EQU   CVTS01+280
CVTVWAIT EQU   CVTS01+276
CVTGSPL  EQU   CVTS01+272
CVTLSMQ  EQU   CVTS01+268
CVTGSMQ  EQU   CVTS01+264
CVTEXPRO EQU   CVTS01+260
CVTOPCTP EQU   CVTS01+256
CVTSIC   EQU   CVTS01+252
CVTTPIOS EQU   CVTS01+248
CVTRTMS  EQU   CVTS01+244
CVTSDBF  EQU   CVTS01+240
CVTSCBP  EQU   CVTS01+236
CVTSDMP  EQU   CVTS01+232
CVTSV60  EQU   CVTS01+228
CVTRTMCT EQU   CVTS01+224
CVTASCBL EQU   CVTS01+220
CVTASCBH EQU   CVTS01+216
CVTGDA   EQU   CVTS01+212
CVTASVT  EQU   CVTS01+208
CVTVVMDI EQU   CVTS01+204
CVTAQTOP EQU   CVTS01+200
CVTIOSCS EQU   CVTS01+196
CVTSDRM  EQU   CVTS01+192
CVTOPTE  EQU   CVTS01+188
CVTSTXU  EQU   CVTS01+184
CVTQUIS  EQU   CVTS01+180
CVTPARS  EQU   CVTS01+176
CVTS1EE  EQU   CVTS01+172
CVTFRAS  EQU   CVTS01+168
CVTQSAS  EQU   CVTS01+164
CVTCRAS  EQU   CVTS01+160
CVTDELCP EQU   CVTS01+152
CVTFRECL EQU   CVTS01+148
CVTGETCL EQU   CVTS01+144
CVTBLDCP EQU   CVTS01+140
CVTAUTHL EQU   CVTS01+136
CVTSCAN  EQU   CVTS01+132
CVTRV144 EQU   CVTS01+130
CVTMAXMP EQU   CVTS01+128
CVTSTCK  EQU   CVTS01+124
CVTRV139 EQU   CVTS01+123
CVTDSSAC EQU   CVTS01+122
CVTRV513 EQU   CVTS01+121
CVTIOSPL EQU   CVTS01+120
CVTPTGT  EQU   CVTS01+116
CVTCSPIE EQU   CVTS01+112
CVTSMFEX EQU   CVTS01+108
CVTOLT0A EQU   CVTS01+104
CVTSRBRT EQU   CVTS01+100
CVTPUTL  EQU   CVTS01+96
CVTASCRL EQU   CVTS01+92
CVTASCRF EQU   CVTS01+88
CVTRV326 EQU   CVTS01+84
CVTRV325 EQU   CVTS01+80
CVTRV324 EQU   CVTS01+76
CVT0VL01 EQU   CVTS01+72
CVTSHRVM EQU   CVTS01+68
CVTRV332 EQU   CVTS01+64
CVTTAS   EQU   CVTS01+60
CVTRSCN  EQU   CVTS01+56
CVTTRAC2 EQU   CVTS01+54
CVTTRACE EQU   CVTS01+52
CVTAPG   EQU   CVTS01+51
CVTSDTRC EQU   CVTCTLFG
CVTGTRCE EQU   CVTCTLFG
CVTNOMP  EQU   CVTCTLFG
CVTRSV79 EQU   CVTCTLFG
CVTDSTAT EQU   CVTCTLFG
CVTRSV78 EQU   CVTCTLFG
CVTRV333 EQU   CVTCTLFG
CVTRV323 EQU   CVTCTLFG
CVTSPVLK EQU   CVTS01+49
CVTRSV77 EQU   CVTS01+48
CVTRV331 EQU   CVTS01+44
CVTRV330 EQU   CVTS01+40
CVTRV329 EQU   CVTS01+36
CVTRV328 EQU   CVTS01+32
CVTRV322 EQU   CVTS01+28
CVTSLID  EQU   CVTSLIDA+1
CVTSYLK  EQU   CVTSLIDA
CVTRV321 EQU   CVTS01+20
CVTRV320 EQU   CVTS01+16
CVTLPDIR EQU   CVTLPDIA+1
CVTRSV69 EQU   CVTDIRST
CVTRSV68 EQU   CVTDIRST
CVTRSV67 EQU   CVTDIRST
CVTRSV66 EQU   CVTDIRST
CVTRSV65 EQU   CVTDIRST
CVTRSV64 EQU   CVTDIRST
CVTRSV63 EQU   CVTDIRST
CVTDICOM EQU   CVTDIRST
CVTPVTP  EQU   CVTS01+8
CVTLPDSR EQU   CVTS01+4
CVTGETL  EQU   CVTS01
@NM00155 EQU   FRRWKA+20
@NM00154 EQU   FRRWKA+16
@NM00153 EQU   FRRFLAGS
TAXEEND  EQU   TAXE+144
TAXEUSER EQU   TAXEWORK+40
TAXEIBUF EQU   TAXEWORK+36
TAXESTAX EQU   TAXEPARM+1
@NM00152 EQU   TAXESTAT
TAXEATTN EQU   TAXESTAT
TAXEFMOD EQU   TAXESTAT
TAXEFKEY EQU   TAXESTAT
TAXEEXIT EQU   TAXEWORK+24
@NM00151 EQU   TAXEWORK+20
@NM00150 EQU   TAXEWORK+16
TAXETCB  EQU   TAXEWORK+12
TIQEIRB  EQU   TAXEWORK+8
TIQEPARM EQU   TAXEWORK+4
TIQELNK  EQU   TAXEWORK
TAXENIQE EQU   TAXE+96
TAXEIRB  EQU   TAXE
TAIERSAV EQU   TAIE+8
TAIEIAD  EQU   TAIE+4
TAIEATTN EQU   TAIE+3
TAIETGET EQU   TAIE+2
TAIEMSGL EQU   TAIE
@NM00149 EQU   SDWA+512
@NM00148 EQU   SDWADPVA
SDWAEBC  EQU   SDWADPVA
@NM00147 EQU   SDWA+396
SDWACOMP EQU   SDWA+392
SDWARCPL EQU   SDWA+364
@NM00146 EQU   SDWADPSA+32
SDWATO4  EQU   SDWADPSL+28
SDWAFRM4 EQU   SDWADPSL+24
SDWATO3  EQU   SDWADPSL+20
SDWAFRM3 EQU   SDWADPSL+16
SDWATO2  EQU   SDWADPSL+12
SDWAFRM2 EQU   SDWADPSL+8
SDWATO1  EQU   SDWADPSL+4
SDWAFRM1 EQU   SDWADPSL
@NM00145 EQU   SDWADDAT+3
@NM00144 EQU   SDWAPDAT
SDWAUSPL EQU   SDWAPDAT
SDWADPSW EQU   SDWAPDAT
SDWATJPA EQU   SDWAPDAT
SDWATLPA EQU   SDWAPDAT
SDWADREG EQU   SDWAPDAT
SDWADSAH EQU   SDWAPDAT
SDWADSAS EQU   SDWAPDAT
@NM00143 EQU   SDWADDAT+1
@NM00142 EQU   SDWASDAT
SDWAQQS  EQU   SDWASDAT
SDWACBS  EQU   SDWASDAT
SDWAGTF  EQU   SDWASDAT
SDWASWA  EQU   SDWASDAT
SDWALSQA EQU   SDWASDAT
SDWASQA  EQU   SDWASDAT
SDWANUC  EQU   SDWASDAT
@NM00141 EQU   SDWADUMP+2
@NM00140 EQU   SDWADPFS
SDWASLST EQU   SDWADPFS
@NM00139 EQU   SDWADPFS
SDWADLST EQU   SDWADPFS
SDWADPT  EQU   SDWADPFS
SDWADPID EQU   SDWADUMP
SDWADPLA EQU   SDWA+316
SDWAREXN EQU   SDWARECP+16
SDWACSCT EQU   SDWARECP+8
SDWAMODN EQU   SDWARECP
@NM00138 EQU   SDWA+290
SDWAASID EQU   SDWA+288
SDWATALW EQU   SDWALKWS+28
SDWATDLW EQU   SDWALKWS+24
SDWATNLW EQU   SDWALKWS+20
SDWAAPLW EQU   SDWALKWS+16
SDWAIPLW EQU   SDWALKWS+12
SDWAILLW EQU   SDWALKWS+8
SDWAIULW EQU   SDWALKWS+4
SDWAICLW EQU   SDWALKWS
SDWAFLLK EQU   SDWAACF4
SDWACMS  EQU   SDWAACF4
SDWAOPTM EQU   SDWAACF4
SDWATADB EQU   SDWAACF4
SDWATDNB EQU   SDWAACF4
SDWATNCB EQU   SDWAACF4
SDWAILCH EQU   SDWAACF4
SDWAIUCB EQU   SDWAACF4
SDWAICAT EQU   SDWAACF3
SDWAIPRG EQU   SDWAACF3
SDWASALL EQU   SDWAACF3
SDWAASMP EQU   SDWAACF3
SDWADISP EQU   SDWAACF3
@NM00137 EQU   SDWAACF3
@NM00136 EQU   SDWAACF2
SDWAFREE EQU   SDWAACF2
SDWAUPRG EQU   SDWAACF2
@NM00135 EQU   SDWAACF2
SDWASPIN EQU   SDWAACF2
@NM00134 EQU   SDWAACF2
SDWALCPU EQU   SDWACPUA+2
@NM00133 EQU   SDWACPUA
SDWARECA EQU   SDWA+244
SDWARTYA EQU   SDWA+240
@NM00132 EQU   SDWA+239
@NM00131 EQU   SDWAIOFS
SDWANIOP EQU   SDWAIOFS
SDWANOIO EQU   SDWAIOFS
SDWAIOHT EQU   SDWAIOFS
SDWAIOQR EQU   SDWAIOFS
@NM00130 EQU   SDWAERRD
SDWAMCIV EQU   SDWAERRD
SDWARPIV EQU   SDWAERRD
SDWAMABD EQU   SDWAERRD
SDWACTS  EQU   SDWAERRD
SDWASTAE EQU   SDWAERRD
SDWANRBE EQU   SDWAERRD
SDWACLUP EQU   SDWAERRD
@NM00129 EQU   SDWAERRC
SDWAEAS  EQU   SDWAERRC
SDWAPERC EQU   SDWAERRC
SDWAIRB  EQU   SDWAERRC
SDWASTAI EQU   SDWAERRC
SDWASTAF EQU   SDWAERRC
SDWASRBM EQU   SDWAERRB
SDWALDIS EQU   SDWAERRB
SDWAENRB EQU   SDWAERRB
SDWATYP1 EQU   SDWAERRB
@NM00128 EQU   SDWAERRB
SDWAPGIO EQU   SDWAERRA
SDWATEXC EQU   SDWAERRA
SDWASVCE EQU   SDWAERRA
SDWAABTM EQU   SDWAERRA
SDWASVCD EQU   SDWAERRA
SDWARKEY EQU   SDWAERRA
SDWAPCHK EQU   SDWAERRA
SDWAMCHK EQU   SDWAERRA
SDWATIME EQU   SDWAMCH+20
SDWARFSA EQU   SDWAMCH+16
@NM00127 EQU   SDWAMCH+14
SDWAVEQR EQU   SDWARSR2
SDWAPGFX EQU   SDWARSR2
SDWAFLSQ EQU   SDWARSR2
SDWAFSQA EQU   SDWARSR2
SDWANUCL EQU   SDWARSR2
SDWASPER EQU   SDWARSR2
SDWAINTC EQU   SDWARSR2
SDWAOFLN EQU   SDWARSR2
SDWACHNG EQU   SDWARSR1
SDWAMSER EQU   SDWARSR1
@NM00126 EQU   SDWARSR1
SDWACPID EQU   SDWAMCH+10
SDWATERR EQU   SDWAMCHD
SDWAFPRX EQU   SDWAMCHD
SDWAINSF EQU   SDWAMCHD
SDWAACR  EQU   SDWAMCHD
SDWASCK  EQU   SDWAMCHD
SDWAPSWU EQU   SDWAMCHD
SDWAREGU EQU   SDWAMCHD
SDWASKYF EQU   SDWAMCHD
@NM00125 EQU   SDWAMCHS
SDWARSRF EQU   SDWAMCHS
SDWARSRC EQU   SDWAMCHS
SDWAINVP EQU   SDWAMCHS
SDWATSVL EQU   SDWAMCHS
SDWARCDF EQU   SDWAMCHS
SDWASRVL EQU   SDWAMCHS
SDWASCKE EQU   SDWASTCK+4
SDWASCKB EQU   SDWASTCK
SDWALNTH EQU   SDWAIDNT+1
SDWASPID EQU   SDWAIDNT
SDWASR15 EQU   SDWASRSV+60
SDWASR14 EQU   SDWASRSV+56
SDWASR13 EQU   SDWASRSV+52
SDWASR12 EQU   SDWASRSV+48
SDWASR11 EQU   SDWASRSV+44
SDWASR10 EQU   SDWASRSV+40
SDWASR09 EQU   SDWASRSV+36
SDWASR08 EQU   SDWASRSV+32
SDWASR07 EQU   SDWASRSV+28
SDWASR06 EQU   SDWASRSV+24
SDWASR05 EQU   SDWASRSV+20
SDWASR04 EQU   SDWASRSV+16
SDWASR03 EQU   SDWASRSV+12
SDWASR02 EQU   SDWASRSV+8
SDWASR01 EQU   SDWASRSV+4
SDWASR00 EQU   SDWASRSV
SDWATRN2 EQU   SDWAAEC2+4
SDWAIPC2 EQU   SDWAICD2
SDWAIMC2 EQU   SDWAICD2
SDWAIPR2 EQU   SDWAICD2
@NM00124 EQU   SDWAINC2
@NM00123 EQU   SDWAILC2
SDWAIL2  EQU   SDWAILC2
@NM00122 EQU   SDWAILC2
@NM00121 EQU   SDWAAEC2
SDWAADD2 EQU   SDWANXT2+1
@NM00120 EQU   SDWANXT2
@NM00119 EQU   SDWAEC2+3
SDWASGN2 EQU   SDWAINT2
SDWAEXP2 EQU   SDWAINT2
SDWADEC2 EQU   SDWAINT2
SDWAFPO2 EQU   SDWAINT2
SDWACC2  EQU   SDWAINT2
@NM00118 EQU   SDWAINT2
SDWAPGM2 EQU   SDWAMWP2
SDWAWAT2 EQU   SDWAMWP2
SDWAMCK2 EQU   SDWAMWP2
SDWAECT2 EQU   SDWAMWP2
SDWAKEY2 EQU   SDWAMWP2
SDWAEXT2 EQU   SDWAEMK2
SDWAIO2  EQU   SDWAEMK2
SDWATRM2 EQU   SDWAEMK2
@NM00117 EQU   SDWAEMK2
SDWAPER2 EQU   SDWAEMK2
@NM00116 EQU   SDWAEMK2
SDWATRAN EQU   SDWAAEC1+4
SDWAIPC1 EQU   SDWAICD1
SDWAIMC1 EQU   SDWAICD1
SDWAIPR1 EQU   SDWAICD1
@NM00115 EQU   SDWAINC1
@NM00114 EQU   SDWAILC1
SDWAIL1  EQU   SDWAILC1
@NM00113 EQU   SDWAILC1
@NM00112 EQU   SDWAAEC1
SDWAADD1 EQU   SDWANXT1+1
@NM00111 EQU   SDWANXT1
@NM00110 EQU   SDWAEC1+3
SDWASGN1 EQU   SDWAINT1
SDWAEXP1 EQU   SDWAINT1
SDWADEC1 EQU   SDWAINT1
SDWAFPO1 EQU   SDWAINT1
SDWACC1  EQU   SDWAINT1
@NM00109 EQU   SDWAINT1
SDWAPGM1 EQU   SDWAMWP1
SDWAWAT1 EQU   SDWAMWP1
SDWAMCK1 EQU   SDWAMWP1
SDWAECT1 EQU   SDWAMWP1
SDWAKEY1 EQU   SDWAMWP1
SDWAEXT1 EQU   SDWAEMK1
SDWAIO1  EQU   SDWAEMK1
SDWATRM1 EQU   SDWAEMK1
@NM00108 EQU   SDWAEMK1
SDWAPER1 EQU   SDWAEMK1
@NM00107 EQU   SDWAEMK1
SDWAIOBR EQU   SDWA+100
SDWAEPA  EQU   SDWA+96
@NM00106 EQU   SDWANAME+4
SDWARBAD EQU   SDWANAME
SDWAGR15 EQU   SDWAGRSV+60
SDWAGR14 EQU   SDWAGRSV+56
SDWAGR13 EQU   SDWAGRSV+52
SDWAGR12 EQU   SDWAGRSV+48
SDWAGR11 EQU   SDWAGRSV+44
SDWAGR10 EQU   SDWAGRSV+40
SDWAGR09 EQU   SDWAGRSV+36
SDWAGR08 EQU   SDWAGRSV+32
SDWAGR07 EQU   SDWAGRSV+28
SDWAGR06 EQU   SDWAGRSV+24
SDWAGR05 EQU   SDWAGRSV+20
SDWAGR04 EQU   SDWAGRSV+16
SDWAGR03 EQU   SDWAGRSV+12
SDWAGR02 EQU   SDWAGRSV+8
SDWAGR01 EQU   SDWAGRSV+4
SDWAGR00 EQU   SDWAGRSV
SDWANXTP EQU   SDWACTL2+5
SDWASGP  EQU   SDWAPMKP
SDWAEUP  EQU   SDWAPMKP
SDWADOP  EQU   SDWAPMKP
SDWAFPP  EQU   SDWAPMKP
SDWACCP  EQU   SDWAPMKP
SDWAILP  EQU   SDWAPMKP
SDWAINTP EQU   SDWACTL2+2
SDWASPVP EQU   SDWAMWPP
SDWAWATP EQU   SDWAMWPP
SDWAMCKP EQU   SDWAMWPP
@NM00105 EQU   SDWAMWPP
SDWAKEYP EQU   SDWAMWPP
SDWAEXTP EQU   SDWACMKP
SDWAIOP  EQU   SDWACMKP
SDWANXTA EQU   SDWACTL1+5
SDWASGA  EQU   SDWAPMKA
SDWAEUA  EQU   SDWAPMKA
SDWADOA  EQU   SDWAPMKA
SDWAFPA  EQU   SDWAPMKA
SDWACCA  EQU   SDWAPMKA
SDWAILA  EQU   SDWAPMKA
SDWAINTA EQU   SDWACTL1+2
SDWASPVA EQU   SDWAMWPA
SDWAWATA EQU   SDWAMWPA
SDWAMCKA EQU   SDWAMWPA
@NM00104 EQU   SDWAMWPA
SDWAKEYA EQU   SDWAMWPA
SDWAEXTA EQU   SDWACMKA
SDWAIOA  EQU   SDWACMKA
SDWACMPC EQU   SDWAABCC+1
@NM00103 EQU   SDWACMPF
SDWASTCC EQU   SDWACMPF
@NM00102 EQU   SDWACMPF
SDWASTEP EQU   SDWACMPF
SDWAREQ  EQU   SDWACMPF
@NM00101 EQU   SCVTSECT+180
@NM00100 EQU   SCVTSECT+176
SCVTPIQE EQU   SCVTSECT+172
@NM00099 EQU   SCVTSECT+168
SCVTPTRM EQU   SCVTSECT+164
@NM00098 EQU   SCVTSECT+160
@NM00097 EQU   SCVTSECT+156
SCVTQCBR EQU   SCVTSECT+152
@NM00096 EQU   SCVTSECT+144
SCVTTQE  EQU   SCVTSECT+140
@NM00095 EQU   SCVTSECT+136
SCVTSVCT EQU   SCVTSECT+132
@NM00094 EQU   SCVTSECT+128
@NM00093 EQU   SCVTSECT+124
SCVTRXLQ EQU   SCVTSECT+120
@NM00092 EQU   SCVTSECT+116
SCVTCTCB EQU   SCVTSECT+112
@NM00091 EQU   SCVTSECT+108
@NM00090 EQU   SCVTSECT+104
@NM00089 EQU   SCVTSECT+100
@NM00088 EQU   SCVTSECT+96
SCVTCOMM EQU   SCVTSECT+92
@NM00087 EQU   SCVTSECT+88
@NM00086 EQU   SCVTSECT+84
@NM00085 EQU   SCVTSECT+80
@NM00084 EQU   SCVTSECT+76
@NM00083 EQU   SCVTSECT+72
SCVTGMBR EQU   SCVTSECT+68
SCVTRPTR EQU   SCVTSECT+64
SCVTHSKP EQU   SCVTSECT+60
@NM00082 EQU   SCVTSECT+56
@NM00081 EQU   SCVTSECT+52
SCVTLFRM EQU   SCVTSECT+48
SCVTCDCL EQU   SCVTSECT+44
@NM00080 EQU   SCVTSECT+40
SCVTRACE EQU   SCVTSECT+36
@NM00079 EQU   SCVTSECT+32
SCVTRMBR EQU   SCVTSECT+28
@NM00078 EQU   SCVTSECT+24
@NM00077 EQU   SCVTSECT+20
@NM00076 EQU   SCVTSECT+16
@NM00075 EQU   SCVTSECT+14
SCVTBR14 EQU   SCVTSECT+12
SCVTSPET EQU   SCVTSECT+8
SCVTPGWR EQU   SCVTSECT+4
SCVTPGTM EQU   SCVTSECT
RCTDEND  EQU   RCTD+240
RCTDRES1 EQU   RCTD+224
RCTDRES5 EQU   RCTDINTF+1
@NM00062 EQU   RCTDRCTF
RCTDDLCK EQU   RCTDRCTF
RCTDSRBN EQU   RCTDRCTF
RCTDPRGR EQU   RCTDRCTF
RCTDSUBN EQU   RCTDRCTF
RCTDRSBO EQU   RCTDRCTF
@NM00061 EQU   RCTDFLGS
RCTDBRCP EQU   RCTDFLGS
RCTDATTS EQU   RCTDFLGS
RCTDRES3 EQU   RCTDFLGS
RCTDATTD EQU   RCTDFLGS
@NM00060 EQU   RCTDMOID
RCTDDUMP EQU   RCTDMOID
RCTDTERM EQU   RCTDMOID
RCTDATTN EQU   RCTDMOID
RCTDREST EQU   RCTDMOID
RCTDQUIS EQU   RCTDMOID
RCTDCOMN EQU   RCTDMOID
RCTDINIT EQU   RCTDMOID
RCTDSCLR EQU   RCTDSLST
RCTDRTY@ EQU   RCTD+188
RCTDRTRY EQU   RCTD+184
RCTDRC   EQU   RCTD+180
RCTDBASE EQU   RCTDPIRL+1
@NM00059 EQU   RCTDPIRL
RCTDRET@ EQU   RCTD+168
@NM00058 EQU   RCTDTECB
RCTDPOST EQU   RCTDTECB
@NM00057 EQU   RCTDTECB
RCTDECBE EQU   RCTDWPTR
RCTDTPTR EQU   RCTDECBS
RCTDCLST EQU   RCTD+154
RCTDRES2 EQU   RCTD+152
RCTDPRG  EQU   RCTDCLRL+8
@NM00056 EQU   RCTDTIME+4
RCTDTMLH EQU   RCTDTIME
RCTDTCBS EQU   RCTD+76
RCTDTCBD EQU   RCTD+72
RCTDISAV EQU   RCTD
RCTDBEGN EQU   RCTD
SIRBEND  EQU   RBSECT+168
SVRBEND  EQU   RBSECT+168
RBRSV158 EQU   RBRSV150
RBRSV157 EQU   RBRSV150
RBRSV156 EQU   RBRSV150
RBRSV155 EQU   RBRSV150
RBRSV154 EQU   RBRSV150
RBRSV153 EQU   RBRSV150
RBRSV152 EQU   RBRSV150
RBRSV151 EQU   RBRSV150
RBRSV149 EQU   RBSECT+166
RBRSV148 EQU   RBSECT+164
RBSCBB   EQU   RBSECT+144
TIRBEND  EQU   @NM00054+8
PRBEND   EQU   @NM00054+8
RBRSV146 EQU   RBRSV138
RBRSV145 EQU   RBRSV138
RBRSV144 EQU   RBRSV138
RBRSV143 EQU   RBRSV138
RBRSV142 EQU   RBRSV138
RBRSV141 EQU   RBRSV138
RBRSV140 EQU   RBRSV138
RBRSV139 EQU   RBRSV138
RBRSV137 EQU   @NM00054+6
RBRSV136 EQU   @NM00054+4
RBRSV135 EQU   @NM00054
@NM00053 EQU   RBSECT+32
@NM00052 EQU   @NM00050+1
@NM00051 EQU   @NM00050
RBPGMQ1  EQU   RBPGMQ+1
@NM00049 EQU   RBPGMQ
@NM00048 EQU   RBSECT+16
@NM00047 EQU   @NM00043
@NM00046 EQU   @NM00043
RBIQETP  EQU   @NM00043
RBUSIQE  EQU   RBETXR
RBATTN   EQU   @NM00043
@NM00045 EQU   @NM00043
@NM00044 EQU   @NM00043
RBPMSVRB EQU   @NM00041
RBATNXIT EQU   @NM00041
@NM00042 EQU   @NM00041
RBWAITP  EQU   @NM00041
RBFNSVRB EQU   RBTRSVRB
RBFTP    EQU   @NM00041
RBSIZE   EQU   RBSECT+8
RBABOPSW EQU   RBSECT+4
RBPPSAV1 EQU   RBPPSAV+1
@NM00039 EQU   RBPPSAV
RBPRFXND EQU   RBPREFIX+64
RBINTCOD EQU   RBINTCDA+1
RBINLNTH EQU   RBINTCDA
RBWCSA   EQU   RBPREFIX+60
RBRSV004 EQU   RBPREFIX+57
RBSSSYN  EQU   RBFLAGS1
RBSCB    EQU   RBFLAGS1
RBLONGWT EQU   RBFLAGS1
RBASIR   EQU   RBFLAGS1
RBRSV159 EQU   RBFLAGS1
RBABEND  EQU   RBFLAGS1
RBXWAIT  EQU   RBFLAGS1
RBSLOCK  EQU   RBFLAGS1
RBRTRAN  EQU   RBRTPSW2+4
RBRTINCD EQU   RBRTICIL+2
RBRTILC  EQU   RBRTICIL+1
RBRSV160 EQU   RBRTICIL
RBRTPSW1 EQU   RBRTOPSW
RBRSV062 EQU   RBRSV054
RBRSV061 EQU   RBRSV054
RBRSV060 EQU   RBRSV054
RBRSV059 EQU   RBRSV054
RBRSV058 EQU   RBRSV054
RBRSV057 EQU   RBRSV054
RBRSV056 EQU   RBRSV054
RBRSV055 EQU   RBRSV054
RBRSV053 EQU   RBPREFIX+38
RBRSV052 EQU   RBPREFIX+36
RBRSV051 EQU   RBPREFIX+32
RBPRFXST EQU   RBPREFIX+32
RBRSV050 EQU   RBPREFIX+28
RBRSV049 EQU   RBRSV041
RBRSV048 EQU   RBRSV041
RBRSV047 EQU   RBRSV041
RBRSV046 EQU   RBRSV041
RBRSV045 EQU   RBRSV041
RBRSV044 EQU   RBRSV041
RBRSV043 EQU   RBRSV041
RBRSV042 EQU   RBRSV041
RBRSV040 EQU   RBPREFIX+26
RBRSV039 EQU   RBPREFIX+24
RBRSV038 EQU   RBPREFIX+20
RBRSV037 EQU   RBPREFIX+16
RBRSV036 EQU   RBRSV028
RBRSV035 EQU   RBRSV028
RBRSV034 EQU   RBRSV028
RBRSV033 EQU   RBRSV028
RBRSV032 EQU   RBRSV028
RBRSV031 EQU   RBRSV028
RBRSV030 EQU   RBRSV028
RBRSV029 EQU   RBRSV028
RBRSV027 EQU   RBRSV019
RBRSV026 EQU   RBRSV019
RBRSV025 EQU   RBRSV019
RBRSV024 EQU   RBRSV019
RBRSV023 EQU   RBRSV019
RBRSV022 EQU   RBRSV019
RBRSV021 EQU   RBRSV019
RBRSV020 EQU   RBRSV019
RBRSV018 EQU   RBPREFIX+13
RBRSV017 EQU   RBPREFIX+12
RBSRV016 EQU   RBPREFIX+11
RBRSV015 EQU   RBPREFIX+10
RBRSV014 EQU   RBPREFIX+8
RBRSV013 EQU   RBPREFIX+4
RBRSV012 EQU   RBPREFIX
RBEXSAVE EQU   XRBESA
XRBREG15 EQU   RBGRS15
XRBREG14 EQU   RBGRS14
XRBREG13 EQU   RBGRS13
XRBREG12 EQU   RBGRS12
XRBREG11 EQU   RBGRS11
XRBREG10 EQU   RBGRS10
XRBREG9  EQU   RBGRS9
XRBREG8  EQU   RBGRS8
XRBREG7  EQU   RBGRS7
XRBREG6  EQU   RBGRS6
XRBREG5  EQU   RBGRS5
XRBREG4  EQU   RBGRS4
XRBREG3  EQU   RBGRS3
XRBREG2  EQU   RBGRS2
XRBREG1  EQU   RBGRS1
XRBREG0  EQU   RBGRS0
XRBLNKA  EQU   RBLINKB
XRBWT    EQU   RBWCF
@NM00038 EQU   RBBASIC+24
RBOPSWPS EQU   RBOPSWB2
@NM00037 EQU   RBOPSWB2
@NM00036 EQU   XRBPSW
@NM00035 EQU   RBBASIC+12
XRBWAIT  EQU   RBECBWT
XRBFRRB  EQU   RBFDYN
@NM00034 EQU   XSTAB2
XRBACTV  EQU   RBFACTV
XRBTCBP  EQU   RBTCBNXT
@NM00033 EQU   XSTAB1
XRBCKPT  EQU   RBFTCKPT
@NM00032 EQU   XSTAB1
@NM00031 EQU   RBBASIC+8
@NM00030 EQU   RBEXRTNM+1
RBTMIND3 EQU   RBTMFLD
RBTMIND2 EQU   RBTMFLD
RBTMCMP  EQU   RBTMFLD
RBWLIM   EQU   RBTMFLD
RBRSV005 EQU   RBTMFLD
RBTMTOD  EQU   RBTMFLD
RBTMQUE  EQU   RBTMFLD
@NM00029 EQU   RBPRFX
@NM00004 EQU   FRRSFLGS+1
@NM00003 EQU   FRRSFLG1
FRRSNEST EQU   FRRSFLG1
FRRSRCUR EQU   FRRSFLG1
FRRSENTS EQU   FRRS+84
FRRSRTMW EQU   FRRS+16
CVTLEVL  EQU   CVTRELNO+2
CVTNUMB  EQU   CVTRELNO
CVTMDL   EQU   CVTFIX+250
@NM00002 EQU   CVTFIX+248
@NM00001 EQU   CVTFIX
CVTRV482 EQU   CVTXTNT2+128
CVTRV481 EQU   CVTXTNT2+124
CVTRV480 EQU   CVTXTNT2+120
CVTRV479 EQU   CVTXTNT2+118
CVTRV478 EQU   CVTXTNT2+117
CVTRV477 EQU   CVTXTNT2+116
CVTRV476 EQU   CVTXTNT2+115
CVTRV475 EQU   CVTXTNT2+114
CVTRV474 EQU   CVTRV466
CVTRV473 EQU   CVTRV466
CVTRV472 EQU   CVTRV466
CVTRV471 EQU   CVTRV466
CVTRV470 EQU   CVTRV466
CVTRV469 EQU   CVTRV466
CVTRV468 EQU   CVTRV466
CVTRV467 EQU   CVTRV466
CVTRV465 EQU   CVTRV457
CVTRV464 EQU   CVTRV457
CVTRV463 EQU   CVTRV457
CVTRV462 EQU   CVTRV457
CVTRV461 EQU   CVTRV457
CVTRV460 EQU   CVTRV457
CVTRV459 EQU   CVTRV457
CVTRV458 EQU   CVTRV457
CVTRV456 EQU   CVTXTNT2+108
CVTRV455 EQU   CVTXTNT2+104
CVTRV454 EQU   CVTXTNT2+100
CVTRV453 EQU   CVTXTNT2+96
CVTRV452 EQU   CVTXTNT2+94
CVTRV451 EQU   CVTXTNT2+92
CVTRV450 EQU   CVTXTNT2+90
CVTRV449 EQU   CVTXTNT2+88
CVTRV448 EQU   CVTXTNT2+87
CVTRV447 EQU   CVTXTNT2+86
CVTRV446 EQU   CVTRV438
CVTRV445 EQU   CVTRV438
CVTRV444 EQU   CVTRV438
CVTRV443 EQU   CVTRV438
CVTRV442 EQU   CVTRV438
CVTRV441 EQU   CVTRV438
CVTRV440 EQU   CVTRV438
CVTRV439 EQU   CVTRV438
CVTRV437 EQU   CVTRV429
CVTRV436 EQU   CVTRV429
CVTRV435 EQU   CVTRV429
CVTRV434 EQU   CVTRV429
CVTRV433 EQU   CVTRV429
CVTRV432 EQU   CVTRV429
CVTRV431 EQU   CVTRV429
CVTRV430 EQU   CVTRV429
CVTRV428 EQU   CVTXTNT2+80
CVTRV427 EQU   CVTXTNT2+76
CVTRV426 EQU   CVTXTNT2+72
CVTRV425 EQU   CVTXTNT2+68
CVTATACT EQU   CVTATCVT
CVTRV423 EQU   CVTXTNT2+62
CVTRV422 EQU   CVTXTNT2+60
CVTRV421 EQU   CVTXTNT2+58
CVTRV420 EQU   CVTXTNT2+56
CVTRV419 EQU   CVTXTNT2+55
CVTRV418 EQU   CVTXTNT2+54
CVTRV417 EQU   CVTRV409
CVTRV416 EQU   CVTRV409
CVTRV415 EQU   CVTRV409
CVTRV414 EQU   CVTRV409
CVTRV413 EQU   CVTRV409
CVTRV412 EQU   CVTRV409
CVTRV411 EQU   CVTRV409
CVTRV410 EQU   CVTRV409
CVTRV408 EQU   CVTRV400
CVTRV407 EQU   CVTRV400
CVTRV406 EQU   CVTRV400
CVTRV405 EQU   CVTRV400
CVTRV404 EQU   CVTRV400
CVTRV403 EQU   CVTRV400
CVTRV402 EQU   CVTRV400
CVTRV401 EQU   CVTRV400
CVTICB   EQU   CVTXTNT2+48
CVTSKTA  EQU   CVTXTNT2+44
CVTRSV99 EQU   CVTXTNT2+40
CVTRSV98 EQU   CVTXTNT2+36
CVTRSV97 EQU   CVTXTNT2+34
CVTRSV96 EQU   CVTXTNT2+32
CVTOLTEP EQU   CVTXTNT2+28
CVTQIDA  EQU   CVTQID+1
CVTRSV95 EQU   CVTQID
CVTRSV94 EQU   CVTXTNT2+20
CVTRSV93 EQU   CVTXTNT2+16
CVTRSV92 EQU   CVTXTNT2+12
CVTDEBVR EQU   CVTXTNT2+8
CVTRSV91 EQU   CVTXTNT2+6
CVTRSV9H EQU   CVTFLGBT
CVTRSV9G EQU   CVTFLGBT
CVTRSV9F EQU   CVTFLGBT
CVTRSV9E EQU   CVTFLGBT
CVTRSV9D EQU   CVTFLGBT
CVTRSV9C EQU   CVTFLGBT
CVTVME   EQU   CVTFLGBT
CVTNPE   EQU   CVTFLGBT
CVTNUCLS EQU   CVTXTNT2+4
CVTDSSVA EQU   CVTDSSV+1
CVTRSV89 EQU   CVTDSSV
CVTRSV88 EQU   CVTXTNT1+8
CVTRSV87 EQU   CVTXTNT1+4
CVTFACHN EQU   CVTXTNT1
CVTRV488 EQU   CVTMAP+412
CVTRV487 EQU   CVTMAP+408
CVTRV486 EQU   CVTMAP+404
CVTRV485 EQU   CVTMAP+400
CVTACTAP EQU   CVTMAP+396
CVTAUTH  EQU   CVTMAP+392
CVTATMCA EQU   CVTATMCT+1
CVTATMST EQU   CVTATMCT
CVTRSV61 EQU   CVTMAP+384
CVTVOLT1 EQU   CVTVOLM1+1
CVTVOLI1 EQU   CVTVOLF1
CVTSTOA  EQU   CVTMAP+376
CVTRSV58 EQU   CVTMAP+374
CVTRSV57 EQU   CVTMAP+372
CVTDDCE  EQU   CVTMAP+368
CVTPNWFR EQU   CVTMAP+364
CVTSMF   EQU   CVTMAP+360
CVTSULK  EQU   CVTMAP+358
CVTSLKO  EQU   CVTSYSK
CVTSLKP  EQU   CVTSYSK
CVTSLKQ  EQU   CVTSYSK
CVTSLKR  EQU   CVTSYSK
CVTRSV56 EQU   CVTSYSK
CVTRSV55 EQU   CVTSYSK
CVTRSV54 EQU   CVTSYSK
CVTRSV53 EQU   CVTSYSK
CVTRSV52 EQU   CVTA1F1
CVTRSV51 EQU   CVTA1F1
CVTRSV50 EQU   CVTA1F1
CVTRSV49 EQU   CVTA1F1
CVTRSV48 EQU   CVTA1F1
CVTRSV47 EQU   CVTA1F1
CVTSRSW  EQU   CVTA1F1
CVTPFSW  EQU   CVTA1F1
CVTPCVT  EQU   CVTMAP+352
CVTRSV46 EQU   CVTMAP+344
CVTRSV45 EQU   CVTMAP+340
CVTRSV44 EQU   CVTMAP+338
CVTRSV43 EQU   CVTMAP+336
CVTHJESA EQU   CVTHJES+1
CVTRSV42 EQU   CVTHJES
CVTEXT2A EQU   CVTEXT2+1
CVTRSV41 EQU   CVTEXT2
CVTAPFA  EQU   CVTAPF+1
CVTRSV40 EQU   CVTAPF
CVTRV518 EQU   CVTINTLA
CVTRV517 EQU   CVTERPV
CVTEORM  EQU   CVTMAP+312
CVTMCHPR EQU   CVTMAP+308
CVTTZ    EQU   CVTMAP+304
CVTJEPS  EQU   CVTMAP+300
CVTJESCT EQU   CVTMAP+296
CVTMODE  EQU   CVTMAP+292
CVTPTRV  EQU   CVTMAP+288
CVTREAL  EQU   CVTMAP+284
CVTRSV39 EQU   CVTMAP+280
CVTRSV38 EQU   CVTMAP+276
CVTDMSRA EQU   CVTDMSR+1
CVTRV634 EQU   CVTDMSRF
CVTRV633 EQU   CVTDMSRF
CVTRV632 EQU   CVTDMSRF
CVTRV631 EQU   CVTDMSRF
CVTRV630 EQU   CVTDMSRF
CVTRV629 EQU   CVTDMSRF
CVTUDUMP EQU   CVTDMSRF
CVTSDUMP EQU   CVTDMSRF
CVTQMSGA EQU   CVTQMSG+1
CVTRSV36 EQU   CVTQMSG
CVTAMFF  EQU   CVTMAP+264
CVTPURGA EQU   CVTPURG+1
CVTRSV35 EQU   CVTPURG
CVTCBSP  EQU   CVTMAP+256
CVTATERA EQU   CVTATER+1
CVTSYST  EQU   CVTATER
CVTVOLT2 EQU   CVTTAT
CVTVOLI2 EQU   CVTVOLF2
CVTAQAVB EQU   CVTAQAVT+1
CVTRSV34 EQU   CVTTCMFG
CVTRSV33 EQU   CVTTCMFG
CVTRSV32 EQU   CVTTCMFG
CVTRSV31 EQU   CVTTCMFG
CVTRSV30 EQU   CVTTCMFG
CVTRSV29 EQU   CVTTCMFG
CVTRSV28 EQU   CVTTCMFG
CVTTCRDY EQU   CVTTCMFG
CVTGTFA  EQU   CVTGTF+1
CVTRSV27 EQU   CVTGTFST
CVTRNIO  EQU   CVTGTFST
CVTUSR   EQU   CVTGTFST
CVTRV318 EQU   CVTFORM
CVTRV317 EQU   CVTTMODE
CVTRV316 EQU   CVTSTATE
CVTRV315 EQU   CVTGTFS
CVTGTFAV EQU   CVTGTFS
CVT0SCR1 EQU   CVTMAP+232
CVTRV515 EQU   CVTMAP+228
CVTRMS   EQU   CVTMAP+224
CVTPATCH EQU   CVTMAP+220
CVTTSCE  EQU   CVTMAP+216
CVTLNKSC EQU   CVTMAP+214
CVTQABST EQU   CVTMAP+212
CVTMDLDS EQU   CVTMAP+208
CVTUSER  EQU   CVTMAP+204
CVTSMCA  EQU   CVTMAP+196
CVTRSV18 EQU   CVTMAP+192
CVTQLPAQ EQU   CVTMAP+188
CVTQCDSR EQU   CVTMAP+184
CVTRSV17 EQU   CVTOPTB
CVTRSV16 EQU   CVTOPTB
CVTFP    EQU   CVTOPTB
CVTAPTHR EQU   CVTOPTB
CVTNLOG  EQU   CVTOPTB
CVTTOD   EQU   CVTOPTB
CVTCTIMS EQU   CVTOPTB
CVTPROT  EQU   CVTOPTB
CVTXPFP  EQU   CVTOPTA
CVTASCII EQU   CVTOPTA
CVTRSV13 EQU   CVTOPTA
CVTRSV12 EQU   CVTOPTA
CVTNIP   EQU   CVTOPTA
CVTDDR   EQU   CVTOPTA
CVTAPR   EQU   CVTOPTA
CVTCCH   EQU   CVTOPTA
CVTSNCTR EQU   CVTMAP+180
CVTQMWR  EQU   CVTMAP+176
CVTQOCR  EQU   CVTMAP+172
CVT1EF00 EQU   CVTMAP+168
CVTMZ00  EQU   CVTMAP+164
CVTSV76Q EQU   CVTSV76C
CVTRSV11 EQU   CVTMAP+156
CVT0PT01 EQU   CVTMAP+152
CVTMSER  EQU   CVTMAP+148
CVTRV516 EQU   CVTIERLC
CVTILCH  EQU   CVTMAP+140
CVT0DS   EQU   CVTMAP+136
CVTFBOSV EQU   CVTMAP+132
CVTNUCB  EQU   CVTMAP+128
CVTIXAVL EQU   CVTMAP+124
CVTSV76M EQU   CVTIOQET
CVTDCBA  EQU   CVTMAP+117
CVTMVS2  EQU   CVTDCB
CVT6DAT  EQU   CVTDCB
CVT4MPS  EQU   CVTDCB
CVTRSV09 EQU   CVTDCB
CVT4MS1  EQU   CVTDCB
CVT2SPS  EQU   CVTDCB
CVT1SSS  EQU   CVTDCB
CVTRSV08 EQU   CVTDCB
CVTSTB   EQU   CVTMAP+112
CVTQTD00 EQU   CVTMAP+108
CVTQTE00 EQU   CVTMAP+104
CVTCUCB  EQU   CVTMAP+100
CVTSJQ   EQU   CVTMAP+96
CVTPBLDL EQU   CVTMAP+92
CVTTPC   EQU   CVTMAP+88
CVTSVDCB EQU   CVTMAP+84
CVTBRET  EQU   CVTMAP+82
CVTEXIT  EQU   CVTMAP+80
CVT0FN00 EQU   CVTMAP+76
CVTDARA  EQU   CVTDAR+1
CVTRSV07 EQU   CVTFLGS1
CVTRSV06 EQU   CVTFLGS1
CVTRSV05 EQU   CVTFLGS1
CVTRSV04 EQU   CVTFLGS1
CVTRSV03 EQU   CVTFLGS1
CVTRSV02 EQU   CVTFLGS1
CVTRSV01 EQU   CVTFLGS1
CVTDMPLK EQU   CVTFLGS1
CVTXITP  EQU   CVTMAP+68
CVTZDTAB EQU   CVTMAP+64
CVTMSLT  EQU   CVTMAP+60
CVTDATE  EQU   CVTMAP+56
CVTBTERM EQU   CVTMAP+52
CVTSYSAD EQU   CVTMAP+48
CVTXTLER EQU   CVTMAP+44
CVTILK2  EQU   CVTMAP+40
CVTILK1  EQU   CVTMAP+36
CVTPRLTV EQU   CVTMAP+32
CVTPCNVT EQU   CVTMAP+28
CVT0VL00 EQU   CVTMAP+24
CVTXAPG  EQU   CVTMAP+20
CVTBUF   EQU   CVTMAP+16
CVTJOB   EQU   CVTMAP+12
CVTLINK  EQU   CVTMAP+8
CVT0EF00 EQU   CVTMAP+4
CVTTCBP  EQU   CVTMAP
CVT      EQU   CVTMAP
ASXBEND  EQU   ASXB+232
ASXBRV25 EQU   ASXB+228
ASXBRV24 EQU   ASXB+224
ASXBPT0E EQU   ASXB+220
ASXBCRB4 EQU   ASXBCASW+3
ASXBCRB3 EQU   ASXBCASW+2
ASXBCRB2 EQU   ASXBCASW+1
ASXBCR06 EQU   ASXBCRB1
ASXBCR05 EQU   ASXBCRB1
ASXBCR04 EQU   ASXBCRB1
ASXBCR03 EQU   ASXBCRB1
ASXBCR02 EQU   ASXBCRB1
ASXBCR01 EQU   ASXBCRB1
ASXBTFD  EQU   ASXBCRB1
ASXBPIP  EQU   ASXBCRB1
ASXBCTDC EQU   ASXB+212
ASXBTDCB EQU   ASXB+208
ASXBRV19 EQU   ASXB+204
ASXBSENV EQU   ASXBSECR+1
ASXBRV34 EQU   ASCBSFLG
ASXBRV33 EQU   ASCBSFLG
ASXBRV32 EQU   ASCBSFLG
ASXBRV31 EQU   ASCBSFLG
ASXBRV30 EQU   ASCBSFLG
ASXBRV29 EQU   ASCBSFLG
ASXBRV28 EQU   ASCBSFLG
ASXBRV27 EQU   ASCBSFLG
ASXBUSER EQU   ASXB+192
ASXBLSRB EQU   ASXBAEQ+20
ASXBFSRB EQU   ASXBAEQ+16
ASXBLRQE EQU   ASXBAEQ+12
ASXBFRQE EQU   ASXBAEQ+8
ASXBLIQE EQU   ASXBAEQ+4
ASXBFIQE EQU   ASXBAEQ
ASXBETSK EQU   ASXB+164
ASXBSIRB EQU   ASXB+160
ASXBPSWD EQU   ASXB+152
ASXBPRG  EQU   ASXB+136
ASXBRV26 EQU   ASXB+132
ASXBOUSB EQU   ASXB+128
ASXBDDR  EQU   ASXB+124
ASXBRSMD EQU   ASXB+116
ASXBSPSA EQU   ASXB+112
ASXBFRWA EQU   ASXB+108
ASXBFLSA EQU   ASXB+36
ASXBIHSA EQU   ASXB+32
ASXBRV15 EQU   ASXB+28
ASXBRV14 EQU   ASXB+24
ASXBLWA  EQU   ASXB+20
ASXBMPST EQU   ASXB+16
ASXBRS00 EQU   ASXB+14
ASXBTCBS EQU   ASXB+12
ASXBLTCB EQU   ASXB+8
ASXBFTCB EQU   ASXB+4
ASXBASXB EQU   ASXB
ASXBEGIN EQU   ASXB
ASCBEND  EQU   ASCB+208
ASCBSRBT EQU   ASCB+200
ASCBSWTL EQU   ASCB+196
ASCBRS14 EQU   ASCB+195
ASCBSMCT EQU   ASCB+194
ASCBRS12 EQU   ASCB+192
ASCBPCTT EQU   ASCB+188
ASCBVGTT EQU   ASCB+184
ASCBLGCB EQU   ASCB+180
ASCBJBNS EQU   ASCB+176
ASCBJBNI EQU   ASCB+172
ASCBMCC  EQU   ASCB+168
ASCBRTWA EQU   ASCB+164
ASCBIQEA EQU   ASCB+160
ASCBXMPQ EQU   ASCB+156
ASCBRS01 EQU   ASCB+154
ASCBFMCT EQU   ASCB+152
ASCBOUXB EQU   ASCB+148
ASCBOUCB EQU   ASCB+144
ASCBMECB EQU   ASCB+140
ASCBQECB EQU   ASCB+136
ASCBCMSB EQU   ASCB+132
ASCBCMSF EQU   ASCB+128
ASCBTCBS EQU   ASCB+124
ASCBNVSC EQU   ASCB+122
ASCBVSC  EQU   ASCB+120
ASCBSRBS EQU   ASCB+118
ASCBSSRB EQU   ASCB+116
ASCBRV06 EQU   ASCBFLG2
ASCBRV05 EQU   ASCBFLG2
ASCBRV04 EQU   ASCBFLG2
ASCBSNQS EQU   ASCBFLG2
ASCBS2S  EQU   ASCBFLG2
ASCBCEXT EQU   ASCBFLG2
ASCBPXMT EQU   ASCBFLG2
ASCBXMPT EQU   ASCBFLG2
ASCBRF07 EQU   ASCBDSP1
ASCBRF06 EQU   ASCBDSP1
ASCBRF05 EQU   ASCBDSP1
ASCBRF04 EQU   ASCBDSP1
ASCBRF03 EQU   ASCBDSP1
ASCBRF02 EQU   ASCBDSP1
ASCBFAIL EQU   ASCBDSP1
ASCBNOQ  EQU   ASCBDSP1
ASCBSWCT EQU   ASCB+112
ASCBTMCH EQU   ASCB+104
ASCBNSWP EQU   ASCBFLG1
ASCBTYP1 EQU   ASCBFLG1
ASCBSTND EQU   ASCBFLG1
ASCBABNT EQU   ASCBFLG1
ASCBTERM EQU   ASCBFLG1
ASCBS3S  EQU   ASCBFLG1
ASCBCMSH EQU   ASCBFLG1
ASCBTOFF EQU   ASCBFLG1
ASCBRF01 EQU   ASCBRCTF
ASCBTMLW EQU   ASCBRCTF
ASCBOUT  EQU   ASCBRCTF
ASCBWAIT EQU   ASCBRCTF
ASCBRV08 EQU   ASCBRCTF
ASCBFQU  EQU   ASCBRCTF
ASCBFRS  EQU   ASCBRCTF
ASCBTMNO EQU   ASCBRCTF
ASCBAFFN EQU   ASCBFW1
ASCBDUMP EQU   ASCB+96
ASCBQSVC EQU   ASCB+92
ASCBUBET EQU   ASCB+88
ASCBECB  EQU   ASCB+84
ASCBJSTL EQU   ASCB+80
ASCBEWST EQU   ASCB+72
ASCBEJST EQU   ASCB+64
ASCBCSCB EQU   ASCB+56
ASCBRSM  EQU   ASCB+52
ASCBLDA  EQU   ASCB+48
ASCBSTOR EQU   ASCB+44
ASCBDP   EQU   ASCB+43
ASCBRV07 EQU   ASCB+42
ASCBIOSM EQU   ASCB+40
ASCBSEQN EQU   ASCB+38
ASCBASID EQU   ASCB+36
ASCBCPUS EQU   ASCB+32
ASCBSPL  EQU   ASCB+28
ASCBLSLQ EQU   ASCB+24
ASCBFSLQ EQU   ASCB+20
ASCBIOSP EQU   ASCB+16
ASCBLOCK EQU   ASCB+12
ASCBBWDP EQU   ASCB+8
ASCBFWDP EQU   ASCB+4
ASCBASCB EQU   ASCB
ASCBEGIN EQU   ASCB
@NM00028 EQU   PSA+3668
PSASTAK  EQU   PSA+3072
@NM00027 EQU   PSA+1048
PSAUSEND EQU   PSA+1048
PSARV062 EQU   PSA+1044
PSACDAL  EQU   PSA+1040
PSAWTCOD EQU   PSA+1036
PSAATCVT EQU   PSA+1032
PSAPCPSW EQU   PSA+1024
PSAPIR2  EQU   PSA+1020
PSARV059 EQU   PSA+1018
PSASVC13 EQU   PSA+1016
PSASFACC EQU   PSA+1008
PSASTOP  EQU   PSA+992
PSASTART EQU   PSA+976
PSARSPSW EQU   PSA+968
PSASRPSW EQU   PSA+960
PSARV045 EQU   PSA+892
PSARV044 EQU   PSA+888
PSARV043 EQU   PSA+884
PSARV042 EQU   PSA+880
PSARV041 EQU   PSA+876
PSARV040 EQU   PSA+872
PSARV025 EQU   PSA+868
PSADSSED EQU   PSA+868
PSADSSPR EQU   PSA+864
PSADSSFW EQU   PSA+860
PSADSS14 EQU   PSA+856
PSADSSPP EQU   PSA+848
PSADSSRP EQU   PSA+840
PSADSS05 EQU   PSADSSF4
PSADSS10 EQU   PSADSSF4
PSADSSVE EQU   PSADSSF4
PSADSSDE EQU   PSADSSF4
PSADSSC0 EQU   PSADSSF4
PSADSSIE EQU   PSADSSF4
PSADSS12 EQU   PSADSSF4
PSADSSRC EQU   PSADSSF4
PSARV057 EQU   PSADSSF3
PSARV056 EQU   PSADSSF3
PSARV055 EQU   PSADSSF3
PSADSSMC EQU   PSADSSF3
PSADSSRW EQU   PSADSSF3
PSADSSNM EQU   PSADSSF3
PSADSSES EQU   PSADSSF3
PSADSSGP EQU   PSADSSF3
PSADSSF2 EQU   PSADSSFL+1
PSADSSPI EQU   PSADSSF1
PSADSSOI EQU   PSADSSF1
PSADSSSP EQU   PSADSSF1
PSADSSTP EQU   PSADSSF1
PSADSSDW EQU   PSADSSF1
PSADSSDD EQU   PSADSSF1
PSADSSDM EQU   PSADSSF1
PSADSSMV EQU   PSADSSF1
PSADSSTS EQU   PSA+816
PSADSSWK EQU   PSA+812
PSADSSR3 EQU   PSA+808
PSADSSR2 EQU   PSA+804
PSADSSRS EQU   PSA+800
PSASTOR  EQU   PSA+796
PSACPUSA EQU   PSA+794
PSAVSTAP EQU   PSA+792
PSAWKVAP EQU   PSA+788
PSAWKRAP EQU   PSA+784
PSAMCHIC EQU   PSA+783
PSARV061 EQU   PSA+782
PSASYMSK EQU   PSA+781
PSAMCHFL EQU   PSA+780
PSACR0   EQU   PSA+776
PSAPSWSV EQU   PSA+768
PSALITA  EQU   PSA+764
PSACLHS  EQU   PSAHLHI
PSALKR15 EQU   PSALKSA+60
PSALKR14 EQU   PSALKSA+56
PSALKR13 EQU   PSALKSA+52
PSALKR12 EQU   PSALKSA+48
PSALKR11 EQU   PSALKSA+44
PSALKR10 EQU   PSALKSA+40
PSALKR9  EQU   PSALKSA+36
PSALKR8  EQU   PSALKSA+32
PSALKR7  EQU   PSALKSA+28
PSALKR6  EQU   PSALKSA+24
PSALKR5  EQU   PSALKSA+20
PSALKR4  EQU   PSALKSA+16
PSALKR3  EQU   PSALKSA+12
PSALKR2  EQU   PSALKSA+8
PSALKR1  EQU   PSALKSA+4
PSALKR0  EQU   PSALKSA
PSARV023 EQU   PSACLHT+52
PSALOCAL EQU   PSACLHT+48
PSACMSL  EQU   PSACLHT+44
PSAOPTL  EQU   PSACLHT+40
PSATPACL EQU   PSACLHT+36
PSATPDNL EQU   PSACLHT+32
PSATPNCL EQU   PSACLHT+28
PSAIOSLL EQU   PSACLHT+24
PSAIOSUL EQU   PSACLHT+20
PSAIOSCL EQU   PSACLHT+16
PSAIOSSL EQU   PSACLHT+12
PSASALCL EQU   PSACLHT+8
PSAASML  EQU   PSACLHT+4
PSADISPL EQU   PSACLHT
PSASRSA  EQU   PSA+636
PSARV050 EQU   PSA+634
PSADSSGO EQU   PSA+633
PSARECUR EQU   PSA+632
PSAHLHIS EQU   PSA+628
PSAIPCSA EQU   PSA+624
@NM00026 EQU   PSA+621
PSAIPCDM EQU   PSA+620
PSAIPCD  EQU   PSA+616
@NM00025 EQU   PSA+613
PSAIPCRM EQU   PSA+612
PSAIPCR  EQU   PSA+608
PSAMCHEX EQU   PSA+600
PSAMPSW  EQU   PSA+592
PSAEXPS2 EQU   PSA+584
PSAEXPS1 EQU   PSA+576
PSAPIREG EQU   PSA+572
PSARSREG EQU   PSA+568
PSAGPREG EQU   PSA+556
PSARV022 EQU   PSASUP4
PSARV021 EQU   PSASUP4
PSARV020 EQU   PSASUP4
PSARV019 EQU   PSASUP4
PSARV018 EQU   PSASUP4
PSARV017 EQU   PSASUP4
PSARV016 EQU   PSASUP4
PSARV015 EQU   PSASUP4
PSARV014 EQU   PSASUP3
PSARV013 EQU   PSASUP3
PSARV012 EQU   PSASUP3
PSAESTA  EQU   PSASUP3
PSASPR   EQU   PSASUP3
PSAPSREG EQU   PSASUP3
PSAPI2   EQU   PSASUP3
PSAIOSUP EQU   PSASUP3
PSALCR   EQU   PSASUP2
PSARTM   EQU   PSASUP2
PSAACR   EQU   PSASUP2
PSAIPCE2 EQU   PSASUP2
PSAIPCES EQU   PSASUP2
PSAIPCEC EQU   PSASUP2
PSAGTF   EQU   PSASUP2
PSAIPCRI EQU   PSASUP2
PSATYPE6 EQU   PSASUP1
PSATCTL  EQU   PSASUP1
PSADISP  EQU   PSASUP1
PSALOCK  EQU   PSASUP1
PSAPI    EQU   PSASUP1
PSAEXT   EQU   PSASUP1
PSASVC   EQU   PSASUP1
PSAIO    EQU   PSASUP1
PSAANEW  EQU   PSA+544
PSATOLD  EQU   PSA+540
PSATNEW  EQU   PSA+536
PSALCCAR EQU   PSA+532
PSALCCAV EQU   PSA+528
PSAPCCAR EQU   PSA+524
PSAPCCAV EQU   PSA+520
PSACPULA EQU   PSA+518
PSACPUPA EQU   PSA+516
PSAPSA   EQU   PSA+512
FLCHDEND EQU   PSA+512
FLCCRSAV EQU   FLCMCLA+280
FLCGRSAV EQU   FLCMCLA+216
FLCFPSAV EQU   FLCMCLA+184
FLCFLA   EQU   FLCMCLA+88
FLCRGNCD EQU   FLCMCLA+84
FLCFSAA  EQU   FLCFSA+1
@NM00024 EQU   FLCFSA
@NM00023 EQU   FLCMCLA+72
FLCMCIC  EQU   FLCMCLA+64
@NM00022 EQU   FLCMCLA+20
FLCIOAA  EQU   FLCIOA+1
@NM00021 EQU   FLCIOA
@NM00020 EQU   FLCMCLA+15
@NM00019 EQU   FLCMCLA+14
@NM00018 EQU   FLCMCLA+12
FLCLCL   EQU   FLCMCLA+8
FLCIOELA EQU   FLCIOEL+1
@NM00017 EQU   FLCIOEL
FLCCHNID EQU   FLCMCLA
@NM00016 EQU   PSA+160
FLCMTRCD EQU   PSA+157
@NM00015 EQU   PSA+156
FLCPERA  EQU   FLCPER+1
@NM00014 EQU   FLCPER
@NM00013 EQU   PSA+151
FLCPERCD EQU   PSA+150
FLCMCNUM EQU   PSA+149
@NM00012 EQU   PSA+148
FLCTEAA  EQU   FLCTEA+1
@NM00011 EQU   FLCTEA
PSAPIPC  EQU   PSAPICOD
PSAPIMC  EQU   PSAPICOD
PSAPIPER EQU   PSAPICOD
PSARV049 EQU   FLCPICOD
FLCPILCB EQU   FLCPIILC
@NM00010 EQU   FLCPIILC
@NM00009 EQU   PSAEPPSW
FLCSVCN  EQU   PSAESPSW+2
FLCSILCB EQU   FLCSVILC
@NM00008 EQU   FLCSVILC
@NM00007 EQU   PSAESPSW
FLCEICOD EQU   PSAEEPSW+2
PSASPAD  EQU   PSAEEPSW
@NM00006 EQU   PSA+128
FLCINPSW EQU   PSA+120
FLCMNPSW EQU   PSA+112
FLCPNPSW EQU   PSA+104
FLCSNPSW EQU   PSA+96
FLCENPSW EQU   PSA+88
FLCTRACE EQU   PSA+84
FLCTIMER EQU   PSA+80
FLCCVT2  EQU   PSA+76
FLCCAW   EQU   PSA+72
FLCCSW   EQU   PSA+64
FLCIOPSW EQU   PSA+56
FLCMOPSW EQU   PSA+48
FLCPOPSW EQU   PSA+40
FLCSOPSW EQU   PSA+32
FLCEOPSW EQU   PSA+24
@NM00005 EQU   FLCICCW2+4
FLCCVT   EQU   FLCICCW2
FLCICCW1 EQU   FLCROPSW
FLCIPPSW EQU   FLCRNPSW
.@UNREFD ANOP                          END UNREFERENCED COMPONENTS
FR6EXIT  EQU   @EL00002
@RC00232 EQU   @EL00002
R06EXIT  EQU   @EL00001
@PB00002 EQU   @EL00001
@ENDDATA EQU   *
         END   IEAVAR06,(C'PLS1729',0701,77133)
