         TITLE 'IEAVEEER -- STAGE 3 EXIT EFFECTOR RECOVERY ROUTINE     *
                        '
IEAVEEER CSECT ,                                                01S0001
@MAINENT DS    0H                                               01S0001
         USING *,@15                                            01S0001
         B     @PROLOG                                          01S0001
         DC    AL2(@EP00001-@MAINENT)
         DC    AL1(16)                                          01S0001
         DC    C'IEAVEEER  73.285'                              01S0001
IQEVER   DS    0H                                               01S0001
         USING *,@15                                            01S0001
         B     @PROLOG                                          01S0001
         DC    AL2(@EP00124-IQEVER)
         ENTRY IQEVER
RQEVER   DS    0H                                               01S0001
         USING *,@15                                            01S0001
         B     @PROLOG                                          01S0001
         DC    AL2(@EP00153-RQEVER)
         ENTRY RQEVER
SRBVER   DS    0H                                               01S0001
         USING *,@15                                            01S0001
         B     @PROLOG                                          01S0001
         DC    AL2(@EP00180-SRBVER)
         ENTRY SRBVER
         DROP  @15
@PROLOG  BALR  @05,0                                            01S0001
@PSTART  DS    0H                                               01S0001
         USING @PSTART,@05                                      01S0001
         AH    @15,4(,@15)                                      01S0001
         BR    @15                                              01S0001
@EP00001 DS    0H                                               01S0002
RBPRFXLN EQU 64
RBPRFLNA EQU 32
PRBLEN   EQU 136
SIRBLEN  EQU 200
TIRBLEN  EQU 136
IRBLEN   EQU 128
SVRBLEN  EQU 200
*   RETADDR=R14;                    /* SAVE RETURN ADDRESS           */
         LR    RETADDR,R14                                      02S0066
*   RFY                                                         02S0067
*     R14 UNRSTD;                                               02S0067
*   R7SAVE=R7;                      /* SAVE REG 7                    */
         LR    R7SAVE,R7                                        02S0068
*   RFY                                                         02S0069
*     R7 UNRSTD;                                                02S0069
*                                   /* INITIALIZATION FOR IEAVEEER   */
*/********************************************************************/
*/*                                                                  */
*/*     PURPOSE = THIS SEGMENT PERFORMS INITIALIZATION FOR THE       */
*/*           EXIT EFFECTOR RECOVERY MODULE.                         */
*/*                                                                  */
*/*     INPUT =                                                      */
*/*           R0 = ADDRESS 200-BYTE WORK AREA                        */
*/*           R1 = ADDRESS SDWA                                      */
*/*           R5 = BASE REGISTER                                     */
*/*                                                                  */
*/*     OUTPUT =                                                     */
*/*           R0 = ADDRESS SDWA                                      */
*/*           R1 = ADDRESS QVPL                                      */
*/*           R7 = ADDRESS OF SDWA                                   */
*/*           R13= 72-BYTE REGISTER SAVE AREA                        */
*/*                                                                  */
*/********************************************************************/
*                                                               02S0070
*   SDWAPTR=PARMREG1;               /* SAVE SDWA POINTER             */
         LR    SDWAPTR,PARMREG1                                 02S0070
*   QVPLPTR=PARMREG0;               /* REG 1 = ADDR QVPL             */
         LR    QVPLPTR,PARMREG0                                 02S0071
*   QVPL='00'X;                     /* ZERO THE QVPL                 */
         XC    QVPL+1(39,QVPLPTR),QVPL+1(QVPLPTR)               02S0072
         MVI   QVPL(QVPLPTR),X'00'                              02S0072
*   SDWAADR=SDWAPTR;                /* RESET REG 0 = ADDR SDWA       */
         LR    SDWAADR,SDWAPTR                                  02S0073
*   QVPLODA=ADDR(SDWARA);           /* QUEUE VERIFY OUTPUT IN SDWA   */
         LA    @15,SDWARA(,SDWAPTR)                             02S0074
         ST    @15,QVPLODA(,QVPLPTR)                            02S0074
*   QVPLWKA=QVPLPTR+LENGTH(QVPL);   /* ADDR QUEUE VERIFY WORK AREA   */
         LA    @15,40                                           02S0075
         LR    @14,QVPLPTR                                      02S0075
         ALR   @14,@15                                          02S0075
         ST    @14,QVPLWKA(,QVPLPTR)                            02S0075
*   SAVEPTR=QVPLWKA+40;             /* ADDR 72 BYTE REG SAVE AREA
*                                                                    */
         ALR   @14,@15                                          02S0076
         LR    SAVEPTR,@14                                      02S0076
*                                                               02S0077
*/********************************************************************/
*/*                                                                  */
*/*     PURPOSE = VERIFY IQE QUEUE AND STORE A WORD OF ZEROS IN THE  */
*/*           SDWA RECORDING AREA TO MARK THE END OF IQE             */
*/*           VERIFICATION.                                          */
*/*                                                                  */
*/*     INPUT =                                                      */
*/*           R0 = ADDRESS SDWA                                      */
*/*           R1 = ADDRESS QVPL                                      */
*/*           R5 = BASE REGISTER                                     */
*/*           R7 = ADDRESS SDWA                                      */
*/*           R13= 72-BYTE REG SAVE AREA                             */
*/*                                                                  */
*/*     OUTPUT =                                                     */
*/*           R2-R4 = VOLITILE                                       */
*/*           R12 = ADDRESS ASXB                                     */
*/*           R14-R15 = VOLITILE                                     */
*/*           ALL OTHER REGISTERS UNCHANGED                          */
*/*                                                                  */
*/********************************************************************/
*                                                               02S0077
*   ASXBPTR=PSAAOLD->ASCBASXB;      /* ADDRESSABILITY TO ASXB        */
         L     @15,PSAAOLD                                      02S0077
         L     ASXBPTR,ASCBASXB(,@15)                           02S0077
*   IQEPTR=ASXBFIQE;                /* FIRST IQE ON CHAIN            */
         L     IQEPTR,ASXBFIQE(,ASXBPTR)                        02S0078
*   QVPLHDR=ADDR(ASXBFIQE);         /* HEADER IQE CHAIN              */
         LA    @15,ASXBFIQE(,ASXBPTR)                           02S0079
         ST    @15,QVPLHDR(,QVPLPTR)                            02S0079
*   QVPLTRLR=ADDR(ASXBLIQE);        /* TRAILER IQE CHAIN             */
         LA    @15,ASXBLIQE(,ASXBPTR)                           02S0080
         ST    @15,QVPLTRLR(,QVPLPTR)                           02S0080
*   QVPLFPTR=ADDR(IQELNK)-ADDR(IQESECT);/* OFFSET OF FORWARD POINTER */
         LR    @15,IQEPTR                                       02S0081
         SLR   @15,IQEPTR                                       02S0081
         STH   @15,QVPLFPTR(,QVPLPTR)                           02S0081
*   QVPLFP3='1'B;                   /* FWD PTR = 3 BYTE FIELD        */
         OI    QVPLFP3(QVPLPTR),B'10000000'                     02S0082
*   QVPLEVR=ADDR(IQEVER);           /* ADDR IQE VERIFICATION RTN     */
         L     @15,@CA01630                                     02S0083
         ST    @15,QVPLEVR(,QVPLPTR)                            02S0083
*   CALL IEAVEQV2;                  /* QUEUE VERIFICATION ROUTINE    */
         L     @15,@CV01625                                     02S0084
         BALR  @14,@15                                          02S0084
*   RFY                                                         02S0085
*     TEMPREG RSTD;                                             02S0085
*   TEMPREG=SDWAURAL;               /* GET USED BYTE COUNT           */
         SLR   TEMPREG,TEMPREG                                  02S0086
         IC    TEMPREG,SDWAURAL(,SDWAPTR)                       02S0086
*   TEMPREG=TEMPREG+4;              /* UPDATE COUNT BY FOUR          */
         AH    TEMPREG,@CH00070                                 02S0087
*   IF TEMPREG<=SDWAVRAL            /* CHECK IF SPACE IN RECORD STORE
*                                      A WORD OF ZEROS TO MARK END OF
*                                      IQE VERIFICAT'N               */
*     THEN                          /* INCREMENT USED BYTE COUNT     */
         SLR   @02,@02                                          02S0088
         ICM   @02,3,SDWAVRAL(SDWAPTR)                          02S0088
         CR    TEMPREG,@02                                      02S0088
         BH    @RF00088                                         02S0088
*     SDWAURAL=TEMPREG;             /* UPDATE SDWAURAL               */
         STC   TEMPREG,SDWAURAL(,SDWAPTR)                       02S0089
*   RFY                                                         02S0090
*     TEMPREG UNRSTD;                                           02S0090
@RF00088 DS    0H                                               02S0091
*                                                               02S0091
*/********************************************************************/
*/*                                                                  */
*/*     PURPOSE = VERIFY RQE QUEUE AND STORE A WORD OF ZEROS IN THE  */
*/*           SDWA RECORDING AREA TO MARK THE END OF RQE             */
*/*           VERIFICATION.                                          */
*/*                                                                  */
*/*     INPUT =                                                      */
*/*           R0 = ADDRESS SDWA                                      */
*/*           R1 = ADDRESS QVPL                                      */
*/*           R5 = BASE REGISTER                                     */
*/*           R7 = ADDRESS SDWA                                      */
*/*           R12= ADDRESS ASXB                                      */
*/*           R13= 72-BYTE REG SAVE AREA                             */
*/*                                                                  */
*/*     OUTPUT =                                                     */
*/*           R2-R4 = VOLITILE                                       */
*/*           R14-R15 = VOLITILE                                     */
*/*           ALL OTHER REGISTERS UNCHANGED                          */
*/*                                                                  */
*/********************************************************************/
*                                                               02S0091
*   RQEPTR=ASXBFRQE;                /* FIRST RQE ON CHAIN            */
         L     RQEPTR,ASXBFRQE(,ASXBPTR)                        02S0091
*   QVPLHDR=ADDR(ASXBFRQE);         /* HEADER RQE CHAIN              */
         LA    @15,ASXBFRQE(,ASXBPTR)                           02S0092
         ST    @15,QVPLHDR(,QVPLPTR)                            02S0092
*   QVPLTRLR=ADDR(ASXBLRQE);        /* TRAILER RQE CHAIN             */
         LA    @15,ASXBLRQE(,ASXBPTR)                           02S0093
         ST    @15,QVPLTRLR(,QVPLPTR)                           02S0093
*   QVPLFPTR=ADDR(RQENRQE)-ADDR(RQE);/* OFFSET OF FORWARD POINTER    */
         LA    @15,RQENRQE(,RQEPTR)                             02S0094
         SLR   @15,RQEPTR                                       02S0094
         STH   @15,QVPLFPTR(,QVPLPTR)                           02S0094
*   QVPLFP3='0'B;                   /* FWD PTR = 4 BYTE FIELD        */
         NI    QVPLFP3(QVPLPTR),B'01111111'                     02S0095
*   QVPLEVR=ADDR(RQEVER);           /* ADDR RQE VERIFICATION RTN     */
         L     @15,@CA01632                                     02S0096
         ST    @15,QVPLEVR(,QVPLPTR)                            02S0096
*   CALL IEAVEQV2;                  /* QUEUE VERIFICATION ROUTINE    */
         L     @15,@CV01625                                     02S0097
         BALR  @14,@15                                          02S0097
*   RFY                                                         02S0098
*     TEMPREG RSTD;                                             02S0098
*   TEMPREG=SDWAURAL;               /* GET USED BYTE COUNT           */
         SLR   TEMPREG,TEMPREG                                  02S0099
         IC    TEMPREG,SDWAURAL(,SDWAPTR)                       02S0099
*   TEMPREG=TEMPREG+4;              /* UPDATE COUNT BY FOUR          */
         AH    TEMPREG,@CH00070                                 02S0100
*   IF TEMPREG<=SDWAVRAL            /* CHECK IF SPACE IN RECORD STORE
*                                      A WORD OF ZEROS TO MARK END OF
*                                      RQE VERIFICAT'N               */
*     THEN                          /* INCREMENT USED BYTE COUNT     */
         SLR   @02,@02                                          02S0101
         ICM   @02,3,SDWAVRAL(SDWAPTR)                          02S0101
         CR    TEMPREG,@02                                      02S0101
         BH    @RF00101                                         02S0101
*     SDWAURAL=TEMPREG;             /* UPDATE SDWAURAL               */
         STC   TEMPREG,SDWAURAL(,SDWAPTR)                       02S0102
*   RFY                                                         02S0103
*     TEMPREG UNRSTD;                                           02S0103
@RF00101 DS    0H                                               02S0104
*                                                               02S0104
*/********************************************************************/
*/*                                                                  */
*/*     PURPOSE = VERIFY SRB QUEUE AND STORE A WORD OF ZEROS IN THE  */
*/*           SDWA RECORDING AREA TO MARK THE END OF SRB             */
*/*           VERIFICATION.                                          */
*/*                                                                  */
*/*     INPUT =                                                      */
*/*           R0 = ADDRESS SDWA                                      */
*/*           R1 = ADDRESS QVPL                                      */
*/*           R5 = BASE REGISTER                                     */
*/*           R7 = ADDRESS SDWA                                      */
*/*           R12= ADDRESS ASXB                                      */
*/*           R13= 72-BYTE REG SAVE AREA                             */
*/*                                                                  */
*/*                                                                  */
*/*     OUTPUT =                                                     */
*/*           R2-R4 = VOLITILE                                       */
*/*           R14-R15 = VOLITILE                                     */
*/*           ALL OTHERS UNCHANGED                                   */
*/*                                                                  */
*/********************************************************************/
*                                                               02S0104
*   SRBPTR=ASXBFSRB;                /* FIRST SRB ON CHAIN            */
         L     SRBPTR,ASXBFSRB(,ASXBPTR)                        02S0104
*   QVPLHDR=ADDR(ASXBFSRB);         /* HEADER SRB CHAIN              */
         LA    @15,ASXBFSRB(,ASXBPTR)                           02S0105
         ST    @15,QVPLHDR(,QVPLPTR)                            02S0105
*   QVPLTRLR=ADDR(ASXBLSRB);        /* TRAILER SRB CHAIN             */
         LA    @15,ASXBLSRB(,ASXBPTR)                           02S0106
         ST    @15,QVPLTRLR(,QVPLPTR)                           02S0106
*   QVPLFPTR=ADDR(SRBFLNK)-ADDR(SRB);/* OFFSET OF FORWARD POINTER    */
         LA    @15,SRBFLNK(,SRBPTR)                             02S0107
         SLR   @15,SRBPTR                                       02S0107
         STH   @15,QVPLFPTR(,QVPLPTR)                           02S0107
*   QVPLFP3='0'B;                   /* FWD PTR = 4 BYTE FIELD        */
         NI    QVPLFP3(QVPLPTR),B'01111111'                     02S0108
*   QVPLEVR=ADDR(SRBVER);           /* ADDR SRB VERIFICATION RTN     */
         L     @15,@CA01633                                     02S0109
         ST    @15,QVPLEVR(,QVPLPTR)                            02S0109
*   CALL IEAVEQV2;                  /* QUEUE VERIFICATION ROUTINE    */
         L     @15,@CV01625                                     02S0110
         BALR  @14,@15                                          02S0110
*   RFY                                                         02S0111
*     TEMPREG RSTD;                                             02S0111
*   TEMPREG=SDWAURAL;               /* GET USED BYTE COUNT           */
         SLR   TEMPREG,TEMPREG                                  02S0112
         IC    TEMPREG,SDWAURAL(,SDWAPTR)                       02S0112
*   TEMPREG=TEMPREG+4;              /* UPDATE COUNT BY FOUR          */
         AH    TEMPREG,@CH00070                                 02S0113
*   IF TEMPREG<=SDWAVRAL            /* CHECK IF SPACE IN RECORD STORE
*                                      A WORD OF ZEROS TO MARK END OF
*                                      IQE VERIFICAT'N               */
*     THEN                          /* INCREMENT USED BYTE COUNT     */
         SLR   @02,@02                                          02S0114
         ICM   @02,3,SDWAVRAL(SDWAPTR)                          02S0114
         CR    TEMPREG,@02                                      02S0114
         BH    @RF00114                                         02S0114
*     SDWAURAL=TEMPREG;             /* UPDATE SDWAURAL               */
         STC   TEMPREG,SDWAURAL(,SDWAPTR)                       02S0115
*   RFY                                                         02S0116
*     TEMPREG UNRSTD;                                           02S0116
@RF00114 DS    0H                                               02S0117
*                                                               02S0117
*/********************************************************************/
*/*                                                                  */
*/*     PURPOSE = RESTORE REGISTERS 0, 1 7-10 TO THEIR CONTENTS      */
*/*           AS THE MODULE WAS ORIGINALLY ENTERED, AND RETURN       */
*/*           TO THE CALLER.                                         */
*/*                                                                  */
*/*     INPUT =                                                      */
*/*           R0 = ADDRESS SDWA                                      */
*/*           R1 = ADDRESS QVPL                                      */
*/*           R5 = BASE REGISTER                                     */
*/*           R6 = RETURN ADDRESS TO CALLER                          */
*/*           R7 = ADDRESS SDWA                                      */
*/*           R8-R10 = UNCHANGED FROM WHEN MODULE WAS ENTERED        */
*/*           R11= ORIGINAL CONTENTS R7                              */
*/*                                                                  */
*/*     OUTPUT =                                                     */
*/*           R0 = ADDRESS 200 BYTE WORK AREA                        */
*/*           R1 = ADDRESS SDWA                                      */
*/*           R7-R10 = ORIGINAL CONTENTS AS UPON ENTRY               */
*/*           R14= RETURN ADDRESS TO CALLER                          */
*/*           ALL OTHER REGISTERS UNCHANGED                          */
*/*                                                                  */
*/********************************************************************/
*                                                               02S0117
*   RFY                                                         02S0117
*    (R7,                                                       02S0117
*     R14,                                                      02S0117
*     PARMREG0,                                                 02S0117
*     PARMREG1) RSTD;                                           02S0117
*   PARMREG0=QVPLPTR;               /* RESTORE REG 0 AS ENTERED      */
         LR    PARMREG0,QVPLPTR                                 02S0118
*   PARMREG1=SDWAPTR;               /* RESTORE REG 1 AS ENTERED      */
         LR    PARMREG1,SDWAPTR                                 02S0119
*   R7=R7SAVE;                      /* RESTORE REG 7 AS ENTERED      */
         LR    R7,R7SAVE                                        02S0120
*   R14=RETADDR;                    /* PLACE RETURN ADDRESS IN R14   */
         LR    R14,RETADDR                                      02S0121
*   RFY                                                         02S0122
*    (R7,                                                       02S0122
*     R14,                                                      02S0122
*     PARMREG0,                                                 02S0122
*     PARMREG1) UNRSTD;                                         02S0122
*   RETURN;                         /* RETURN TO CALLER         02S0123
*                                                                    */
@EL00001 DS    0H                                               02S0123
@EF00001 DS    0H                                               02S0123
@ER00001 BR    @14                                              02S0123
*                                                               02S0124
*/********************************************************************/
*/*                                                                  */
*/*     PURPOSE = IQE VERIFICATION SUBROUTINE.  IT'S FUNCTION IS TO  */
*/*           DETERMINE WHETHER A PIECE OF STORAGE IS REALLY AN IQE  */
*/*           OR NOT.  IT IS ENTERED AS A SUBROUTINE OF QUEUE VERI-  */
*/*           FIER, WHEN IT IS THE PROCESS OF VERIFYING THE IQE QUEUE*/
*/*                                                                  */
*/*     INPUT =                                                      */
*/*           R0 = THE VIRTUAL STORAGE ADDRESS TO BE VERIFIED        */
*/*           R1 = THE ADDRESS OF THE SDWA                           */
*/*           R14= RETURN ADDRESS TO CALLER                          */
*/*           R15= ENTRY POINT ADDRESS OF RQEVER                     */
*/*                                                                  */
*/*      OUTPUT =                                                    */
*/*           R0,R1,R8-R14 = UNCHANGED                               */
*/*           R2-R7 = VOLITILE                                       */
*/*           R15 = CONTAINS A RETURN CODE AS FOLLOWS:               */
*/*                 0 = THE STORAGE IS AN IQE WITH GOOD DATA         */
*/*                 8 = THE STORAGE DOES NOT CONTAIN AN IQE          */
*/*                                                                  */
*/********************************************************************/
*                                                               02S0124
*IQEVER:                                                        02S0124
*   ENTRY;                                                      02S0124
@EP00124 DS    0H                                               02S0125
*   RFY                                                         02S0125
*     ASXBPTR UNRSTD;                                           02S0125
*   RFY                                                         02S0126
*    (ADDREG,                                                   02S0126
*     RETCODE,                                                  02S0126
*     R14) RSTD;                    /* IQE VERIFICATION ROUTINE      */
*   RETADDR=R14;                    /* SAVE RETURN ADDRESS           */
         LR    RETADDR,R14                                      02S0127
*   RFY                                                         02S0128
*     R14 UNRSTD;                                               02S0128
*   IQEPTR=PARMREG0;                /* SET UP BASE FOR IQE           */
         LR    IQEPTR,PARMREG0                                  02S0129
*   ADDREG=PARMREG0;                /* REG 2 = IQE ADDRESS           */
         LR    ADDREG,PARMREG0                                  02S0130
*   LENREG=LENGTH(IQESECT);         /* REG 0 = LENGTH IQE            */
         LA    LENREG,24                                        02S0131
*   CALL IEAVEADV;                  /* ADDRESS VERIFICATION RTN      */
         L     @15,@CV01626                                     02S0132
         BALR  @14,@15                                          02S0132
*   IF RETCODE=0                    /* CHECK RETURN CODE             */
*     THEN                          /* IQE ADDRESS IS VALID          */
         LTR   RETCODE,RETCODE                                  02S0133
         BNZ   @RF00133                                         02S0133
*     DO;                           /* VERIFY ADDR IN IQETCB FIELD   */
*       LENREG=LENGTH(TCB);         /* REG 0 = LENGTH TCB            */
         LA    LENREG,296                                       02S0135
*       RFY                                                     02S0136
*        (TCBPTR,                                               02S0136
*         RBSECPTR,                                             02S0136
*         RETCODE) RSTD;                                        02S0136
*       TCBPTR=IQETCB;              /* REG 2 = IQETCB                */
         L     TCBPTR,IQETCB(,IQEPTR)                           02S0137
*       CALL IEAVEADV;              /* ADDFRESS VERIFICATION RTN     */
         L     @15,@CV01626                                     02S0138
         BALR  @14,@15                                          02S0138
*       IF RETCODE=0                /* CHECK RETURN CODE             */
*         THEN                      /* TCB ADDRESS IS VALID          */
         LTR   RETCODE,RETCODE                                  02S0139
         BNZ   @RF00139                                         02S0139
*         DO;                       /* VERIFY ADDRESS OF IRB         */
*           LENREG=ADDR(IRBLEN)-ADDR(RBPRFLNA);/* REG 0 = LENGTH IRB */
         LA    LENREG,IRBLEN                                    02S0141
         LA    @14,RBPRFLNA                                     02S0141
         SLR   LENREG,@14                                       02S0141
*           RBSECPTR=IQEIRBA;       /* REG 2 = CONTENTS IQEIRBA      */
         SLR   RBSECPTR,RBSECPTR                                02S0142
         ICM   RBSECPTR,7,IQEIRBA(IQEPTR)                       02S0142
*           CALL IEAVEADV;          /* ADDRESS VERIFICATION RTN      */
         L     @15,@CV01626                                     02S0143
         BALR  @14,@15                                          02S0143
*         END;                                                  02S0144
*     END;                                                      02S0145
*   ELSE                                                        02S0146
*     ;                             /* ORIGINAL ADDRESS INVALID OR   */
@RF00133 DS    0H                                               02S0147
*   IF RETCODE>0                    /* IF ANY FIELDS INVALID         */
*     THEN                          /* SET RETURN CODE = 8 TO        */
@RC00133 LTR   RETCODE,RETCODE                                  02S0147
         BNP   @RF00147                                         02S0147
*     RETCODE=8;                    /* INDICATE STORAGE NOT AN IQE   */
         LA    RETCODE,8                                        02S0148
*   PARMREG0=IQEPTR;                /* RESTORE REG 0 AS ENTERED      */
@RF00147 LR    PARMREG0,IQEPTR                                  02S0149
*   RFY                                                         02S0150
*     R14 RSTD;                                                 02S0150
*   R14=RETADDR;                    /* RESTORE RETURN ADDRESS        */
         LR    R14,RETADDR                                      02S0151
*   RETURN;                         /* RETURN TO QUEUE VERIFY RTN
*                                                                    */
         B     @EL00001                                         02S0152
*                                                               02S0153
*/********************************************************************/
*/*                                                                  */
*/*     PURPOSE = RQE VERIFICATION SUBROUTINE.  IT'S FUNCTION IS TO  */
*/*           DETERMINE WHETHER A PIECE OF STORAGE IS REALLY AN RQE  */
*/*           OR NOT.  IT IS ENTERED AS A SUBROUTINE OF QUEUE VERI-  */
*/*           FIER, WHEN IT IS THE PROCESS OF VERIFYING THE RQE QUEUE*/
*/*                                                                  */
*/*     INPUT =                                                      */
*/*           R0 = THE VIRTUAL STORAGE ADDRESS TO BE VERIFIED        */
*/*           R1 = THE ADDRESS OF THE SDWA                           */
*/*           R14= RETURN ADDRESS TO CALLER                          */
*/*           R15= ENTRY POINT ADDRESS OF RQEVER                     */
*/*                                                                  */
*/*      OUTPUT =                                                    */
*/*           R0,R1,R8-R14 = UNCHANGED                               */
*/*           R2-R7 = VOLITILE                                       */
*/*           R15 = CONTAINS A RETURN CODE AS FOLLOWS:               */
*/*                 0 = THE STORAGE IS AN RQE WITH GOOD DATA         */
*/*                 8 = THE STORAGE DOES NOT CONTAIN AN RQE          */
*/*                                                                  */
*/********************************************************************/
*                                                               02S0153
*RQEVER:                                                        02S0153
*   ENTRY;                          /* RQE VERIFICATION ROUTINE      */
@EP00153 DS    0H                                               02S0154
*   RETADDR=R14;                    /* SAVE RETURN ADDRESS           */
         LR    RETADDR,R14                                      02S0154
*   RFY                                                         02S0155
*     R14 UNRSTD;                                               02S0155
*   RQEPTR=PARMREG0;                /* SET UP BASE FOR RQE           */
         LR    RQEPTR,PARMREG0                                  02S0156
*   ADDREG=PARMREG0;                /* REG 2 = IQE ADDRESS           */
         LR    ADDREG,PARMREG0                                  02S0157
*   LENREG=LENGTH(RQE);             /* REG 0 = LENGTH RQE            */
         LA    LENREG,40                                        02S0158
*   CALL IEAVEADV;                  /* ADDRESS VERIFICATION RTN      */
         L     @15,@CV01626                                     02S0159
         BALR  @14,@15                                          02S0159
*   IF RETCODE=0                    /* CHECK RETURN CODE             */
*     THEN                          /* RQE ADDRESS IS VALID          */
         LTR   RETCODE,RETCODE                                  02S0160
         BNZ   @RF00160                                         02S0160
*     DO;                           /* VERIFY ADDR IN RQETCB FIELD   */
*       LENREG=LENGTH(TCB);         /* REG 0 = LENGTH TCB            */
         LA    LENREG,296                                       02S0162
*       TCBPTR=RQETCB;              /* REG 2 = CONTENTS RQETCB       */
         L     TCBPTR,RQETCB(,RQEPTR)                           02S0163
*       CALL IEAVEADV;              /* ADDRESS VERIFICATION RTN      */
         L     @15,@CV01626                                     02S0164
         BALR  @14,@15                                          02S0164
*       IF RETCODE=0                /* CHECK RETURN CODE             */
*         THEN                      /* TCB ADDRESS IS VALID          */
         LTR   RETCODE,RETCODE                                  02S0165
         BNZ   @RF00165                                         02S0165
*         DO;                       /* VERIFY THE IRB ADDRESS        */
*           LENREG=ADDR(IRBLEN)-ADDR(RBPRFLNA);/* REG 0 = LENGTH IRB */
         LA    LENREG,IRBLEN                                    02S0167
         LA    @14,RBPRFLNA                                     02S0167
         SLR   LENREG,@14                                       02S0167
*           RBSECPTR=RQERRQ;        /* REG 2 = RQERRQ                */
         L     RBSECPTR,RQERRQ(,RQEPTR)                         02S0168
*           CALL IEAVEADV;          /* ADDRESS VERIFICATION ROUTINE  */
         L     @15,@CV01626                                     02S0169
         BALR  @14,@15                                          02S0169
*         END;                                                  02S0170
*       ELSE                                                    02S0171
*         ;                         /* ORIGINAL ADDRESS INVALID      */
@RF00165 DS    0H                                               02S0172
*     END;                                                      02S0172
*   ELSE                                                        02S0173
*     ;                             /* OR RQETCB FIELD INVALID       */
@RF00160 DS    0H                                               02S0174
*   IF RETCODE>0                    /* OR RQERRQ FIELD INVALID       */
*     THEN                          /* SET RETURN CODE TO 8 TO       */
         LTR   RETCODE,RETCODE                                  02S0174
         BNP   @RF00174                                         02S0174
*     RETCODE=8;                    /* INDICATE STORAGE NOT AN RQE   */
         LA    RETCODE,8                                        02S0175
*   PARMREG0=RQEPTR;                /* RESTORE REG 0 AS ENTERED      */
@RF00174 LR    PARMREG0,RQEPTR                                  02S0176
*   RFY                                                         02S0177
*     R14 RSTD;                                                 02S0177
*   R14=RETADDR;                    /* RESTORE RETURN ADDRESS        */
         LR    R14,RETADDR                                      02S0178
*   RETURN;                         /* RETURN TO QUEUE VERIFY RTN
*                                                                    */
         B     @EL00001                                         02S0179
*                                                               02S0180
*/********************************************************************/
*/*                                                                  */
*/*     PURPOSE = SRB VERIFICATION SUBROUTINE.  IT'S FUNCTION IS TO  */
*/*           DETERMINE WHETHER A PIECE OF STORAGE IS REALLY AN SRB  */
*/*           OR NOT.  IT IS ENTERED AS A SUBROUTINE OF QUEUE VERI-  */
*/*           FIER, WHEN IT IS THE PROCESS OF VERIFYING THE SRB QUEUE*/
*/*                                                                  */
*/*     INPUT =                                                      */
*/*           R0 = THE VIRTUAL STORAGE ADDRESS TO BE VERIFIED        */
*/*           R1 = THE ADDRESS OF THE SDWA                           */
*/*           R14= RETURN ADDRESS TO CALLER                          */
*/*           R15= ENTRY POINT ADDRESS OF SRBVER                     */
*/*                                                                  */
*/*      OUTPUT =                                                    */
*/*           R0,R1,R8-R14 = UNCHANGED                               */
*/*           R2-R7 = VOLITILE                                       */
*/*           R15 = CONTAINS A RETURN CODE AS FOLLOWS:               */
*/*                 0 = THE STORAGE IS AN SRB                        */
*/*                 8 = THE STORAGE DOES NOT CONTAIN AN SRB          */
*/*                                                                  */
*/********************************************************************/
*                                                               02S0180
*SRBVER:                                                        02S0180
*   ENTRY;                          /* SRB VERIFICATION ROUTINE      */
@EP00180 DS    0H                                               02S0181
*   RETADDR=R14;                    /* SAVE RETURN ADDRESS           */
         LR    RETADDR,R14                                      02S0181
*   RFY                                                         02S0182
*     R14 UNRSTD;                                               02S0182
*   SRBPTR=PARMREG0;                /* SET UP BASE FOR SRB           */
         LR    SRBPTR,PARMREG0                                  02S0183
*   ADDREG=PARMREG0;                /* REG 2 = SRB ADDRESS           */
         LR    ADDREG,PARMREG0                                  02S0184
*   LENREG=LENGTH(SRB);             /* REG 0 = LENGTH SRB            */
         LA    LENREG,44                                        02S0185
*   CALL IEAVEADV;                  /* ADDRESS VERIFICATION RTN      */
         L     @15,@CV01626                                     02S0186
         BALR  @14,@15                                          02S0186
*   IF RETCODE>0                    /* CHECK RETURN CODE             */
*     THEN                          /* ORIGINAL ADDRESS INVALID      */
         LTR   RETCODE,RETCODE                                  02S0187
         BNP   @RF00187                                         02S0187
*     RETCODE=8;                    /* INDICATE STORAGE NOT AN SRB   */
         LA    RETCODE,8                                        02S0188
*   PARMREG0=SRBPTR;                /* RESTORE REG 0 AS ENTERED      */
@RF00187 LR    PARMREG0,SRBPTR                                  02S0189
*   RFY                                                         02S0190
*     R14 RSTD;                                                 02S0190
*   R14=RETADDR;                    /* RESTORE RETURN ADDRESS        */
         LR    R14,RETADDR                                      02S0191
*   RETURN;                         /* RETURN TO QUEUE VERIFY RTN    */
         B     @EL00001                                         02S0192
*   END IEAVEEER                                                02S0193
*                                                               02S0193
*/* THE FOLLOWING INCLUDE STATEMENTS WERE FOUND IN THIS PROGRAM.     */
*/*%INCLUDE SYSUT5  (PROLOG  )                                       */
*/*%INCLUDE SYSUT5  (EERFL1  )                                       */
*/*%INCLUDE SYSLIB  (IHARB   )                                       */
*/*%INCLUDE SYSLIB  (IEZXRB  )                                       */
*/*%INCLUDE SYSLIB  (IKJRB   )                                       */
*/*%INCLUDE SYSLIB  (IKJTCB  )                                       */
*/*%INCLUDE SYSLIB  (IHAIQE  )                                       */
*/*%INCLUDE SYSLIB  (IHASDWA )                                       */
*/*%INCLUDE SYSLIB  (IECDRQE )                                       */
*/*%INCLUDE SYSLIB  (IHASRB  )                                       */
*/*%INCLUDE SYSLIB  (IHAASXB )                                       */
*/*%INCLUDE SYSLIB  (IHAASCB )                                       */
*/*%INCLUDE SYSLIB  (IHAPSA  )                                       */
*/*%INCLUDE SYSLIB  (IHAQVPL )                                       */
*/*%INCLUDE SYSUT5  (DCLEER  )                                       */
*/*%INCLUDE SYSUT5  (INITR   )                                       */
*                                                               02S0193
*       ;                                                       02S0193
@DATA    DS    0H
@CH00070 DC    H'4'
@DATD    DSECT
         DS    0F
IEAVEEER CSECT
         DS    0F
@DATD    DSECT
         DS    0D
@ENDDATD EQU   *
IEAVEEER CSECT
         NOPR  ((@ENDDATD-@DATD)*16)
         DS    0F
@SIZDATD DC    AL1(0)
         DC    AL3(@ENDDATD-@DATD)
@CA01630 DC    A(IQEVER)
@CA01632 DC    A(RQEVER)
@CA01633 DC    A(SRBVER)
@CV01625 DC    V(IEAVEQV2)
@CV01626 DC    V(IEAVEADV)
         DS    0D
@00      EQU   00                      EQUATES FOR REGISTERS 0-15
@01      EQU   01
@02      EQU   02
@03      EQU   03
@04      EQU   04
@05      EQU   05
@06      EQU   06
@07      EQU   07
@08      EQU   08
@09      EQU   09
@10      EQU   10
@11      EQU   11
@12      EQU   12
@13      EQU   13
@14      EQU   14
@15      EQU   15
RBSECPTR EQU   @02
TCBPTR   EQU   @02
IQEPTR   EQU   @04
SDWAPTR  EQU   @07
RQEPTR   EQU   @04
SRBPTR   EQU   @04
ASXBPTR  EQU   @12
QVPLPTR  EQU   @01
R0       EQU   @00
R1       EQU   @01
R7       EQU   @07
R8       EQU   @08
R9       EQU   @09
R10      EQU   @10
R14      EQU   @14
R15      EQU   @15
R7SAVE   EQU   @11
RETADDR  EQU   @06
WAPTR    EQU   @00
SDWAADR  EQU   @00
TEMPREG  EQU   @03
PARMREG0 EQU   @00
PARMREG1 EQU   @01
SAVEPTR  EQU   @13
LENREG   EQU   @00
ADDREG   EQU   @02
RETCODE  EQU   @15
BASEREG  EQU   @05
PSA      EQU   0
FLCRNPSW EQU   PSA
FLCROPSW EQU   PSA+8
FLCICCW2 EQU   PSA+16
PSAEEPSW EQU   PSA+132
PSAESPSW EQU   PSA+136
FLCSVILC EQU   PSAESPSW+1
PSAEPPSW EQU   PSA+140
FLCPIILC EQU   PSAEPPSW+1
FLCPICOD EQU   PSAEPPSW+2
PSAPICOD EQU   FLCPICOD+1
FLCTEA   EQU   PSAEPPSW+4
FLCPER   EQU   PSA+152
FLCMCLA  EQU   PSA+168
FLCIOEL  EQU   FLCMCLA+4
FLCIOA   EQU   FLCMCLA+16
FLCFSA   EQU   FLCMCLA+80
PSAAOLD  EQU   PSA+548
PSASUPER EQU   PSA+552
PSASUP1  EQU   PSASUPER
PSASUP2  EQU   PSASUPER+1
PSASUP3  EQU   PSASUPER+2
PSASUP4  EQU   PSASUPER+3
PSACLHT  EQU   PSA+640
PSALKSA  EQU   PSA+696
PSAHLHI  EQU   PSA+760
PSADSSFL EQU   PSA+836
PSADSSF1 EQU   PSADSSFL
PSADSSF3 EQU   PSADSSFL+2
PSADSSF4 EQU   PSADSSFL+3
PSARSVT  EQU   PSA+896
RBPRFX   EQU   0
RBBASIC  EQU   0
RBEXRTNM EQU   RBBASIC
RBTMFLD  EQU   RBEXRTNM
RBSTAB   EQU   RBBASIC+10
XSTAB    EQU   RBSTAB
RBSTAB1  EQU   XSTAB
XSTAB1   EQU   RBSTAB1
RBFTCKPT EQU   XSTAB1
RBSTAB2  EQU   XSTAB+1
XSTAB2   EQU   RBSTAB2
RBTCBNXT EQU   XSTAB2
RBFACTV  EQU   XSTAB2
RBFDYN   EQU   XSTAB2
RBECBWT  EQU   XSTAB2
RBOPSW   EQU   RBBASIC+16
RBLINK   EQU   RBBASIC+28
XRBLNK   EQU   RBLINK
RBWCF    EQU   XRBLNK
RBLINKB  EQU   XRBLNK+1
RBGRSAVE EQU   RBBASIC+32
XRBREG   EQU   RBGRSAVE
RBGRS0   EQU   XRBREG
RBGRS1   EQU   XRBREG+4
RBGRS2   EQU   XRBREG+8
RBGRS3   EQU   XRBREG+12
RBGRS4   EQU   XRBREG+16
RBGRS5   EQU   XRBREG+20
RBGRS6   EQU   XRBREG+24
RBGRS7   EQU   XRBREG+28
RBGRS8   EQU   XRBREG+32
RBGRS9   EQU   XRBREG+36
RBGRS10  EQU   XRBREG+40
RBGRS11  EQU   XRBREG+44
RBGRS12  EQU   XRBREG+48
RBGRS13  EQU   XRBREG+52
RBGRS14  EQU   XRBREG+56
RBGRS15  EQU   XRBREG+60
XRBESA   EQU   RBBASIC+96
RBPREFIX EQU   0
RBRSV019 EQU   RBPREFIX+14
RBRSV028 EQU   RBPREFIX+15
RBRSV041 EQU   RBPREFIX+27
RBRSV054 EQU   RBPREFIX+39
RBRTOPSW EQU   RBPREFIX+40
RBRTPSW2 EQU   RBRTOPSW+8
RBRTICIL EQU   RBRTPSW2
RBFLAGS1 EQU   RBPREFIX+56
RBINTCDA EQU   RBPREFIX+61
RBSECT   EQU   0
RBPPSAV  EQU   RBSECT
@NM00010 EQU   RBSECT+10
@NM00011 EQU   @NM00010
RBTRSVRB EQU   @NM00011
@NM00013 EQU   @NM00010+1
RBETXR   EQU   @NM00013
RBEP     EQU   RBSECT+12
RBPGMQ   EQU   RBSECT+24
@NM00020 EQU   RBSECT+28
IRBEND   EQU   RBSECT+96
@NM00024 EQU   RBSECT+96
RBRSV138 EQU   @NM00024+7
RBRSV150 EQU   RBSECT+167
TCBFIX   EQU   0
TCBFRS   EQU   TCBFIX
TCB      EQU   0
TCBPIE   EQU   TCB+4
TCBPMASK EQU   TCBPIE
TCBCMP   EQU   TCB+16
TCBCMPF  EQU   TCBCMP
TCBCPP   EQU   TCBCMPF
TCBSTCC  EQU   TCBCMPF
TCBCDBL  EQU   TCBCMPF
TCBCWTO  EQU   TCBCMPF
TCBCIND  EQU   TCBCMPF
TCBCMSG  EQU   TCBCMPF
TCBTRN   EQU   TCB+20
TCBABF   EQU   TCBTRN
TCBMSS   EQU   TCB+24
TCBPKF   EQU   TCB+28
TCBFLGS  EQU   TCB+29
TCBFLGS1 EQU   TCBFLGS
TCBFLGS2 EQU   TCBFLGS+1
TCBFLGS3 EQU   TCBFLGS+2
TCBFLGS4 EQU   TCBFLGS+3
TCBFLGS5 EQU   TCBFLGS+4
TCBABWF  EQU   TCBFLGS5
TCBJPQ   EQU   TCB+44
TCBPURGE EQU   TCBJPQ
TCBGRS   EQU   TCB+48
TCBFSA   EQU   TCB+112
TCBTME   EQU   TCB+120
TCBJSTCB EQU   TCB+124
TCBTSFLG EQU   TCB+148
TCBTSTSK EQU   TCBTSFLG
TCBSTAB  EQU   TCB+160
TCBNSTAE EQU   TCBSTAB
TCBTCT   EQU   TCB+164
TCBTCTGF EQU   TCBTCT
TCBSCNDY EQU   TCB+172
TCBNDSP  EQU   TCBSCNDY
TCBNDSP1 EQU   TCBNDSP+1
TCBNDSP2 EQU   TCBNDSP+2
TCBNDSP3 EQU   TCBNDSP+3
TCBJSCB  EQU   TCB+180
TCBRECDE EQU   TCBJSCB
TCBEXT1  EQU   TCB+196
TCBBITS  EQU   TCB+200
TCBNDSP4 EQU   TCBBITS
TCBNDSP5 EQU   TCBBITS+1
TCBFLGS6 EQU   TCBBITS+2
TCBFLGS7 EQU   TCBBITS+3
TCBDAR   EQU   TCB+204
TCBDARC  EQU   TCBDAR
TCBEXT2  EQU   TCB+208
TCBFOE   EQU   TCB+244
TCBESTAE EQU   TCB+264
TCBESTRM EQU   TCBESTAE+1
TCBFBYT1 EQU   TCB+276
TCBFBYT2 EQU   TCB+277
TCBRV124 EQU   TCB+278
TCBRV133 EQU   TCB+279
TCBXTNT2 EQU   0
TCBGTF   EQU   TCBXTNT2
TCBTFLG  EQU   TCBGTF
TCBRV146 EQU   TCBXTNT2+28
TCBRV155 EQU   TCBXTNT2+29
TCBRV164 EQU   TCBXTNT2+30
TCBRV173 EQU   TCBXTNT2+31
IQESECT  EQU   0
IQELNK   EQU   IQESECT
IQEIRB   EQU   IQESECT+8
IQEFLAGS EQU   IQEIRB
IQEIRBA  EQU   IQEIRB+1
IQETCB   EQU   IQESECT+12
SDWA     EQU   0
SDWAFIOB EQU   SDWA+4
SDWAABCC EQU   SDWAFIOB
SDWACMPF EQU   SDWAABCC
SDWACTL1 EQU   SDWA+8
SDWACMKA EQU   SDWACTL1
SDWAMWPA EQU   SDWACTL1+1
SDWAPMKA EQU   SDWACTL1+4
SDWACTL2 EQU   SDWA+16
SDWACMKP EQU   SDWACTL2
SDWAMWPP EQU   SDWACTL2+1
SDWAPMKP EQU   SDWACTL2+4
SDWAGRSV EQU   SDWA+24
SDWANAME EQU   SDWA+88
SDWAEC1  EQU   SDWA+104
SDWAEMK1 EQU   SDWAEC1
SDWAMWP1 EQU   SDWAEC1+1
SDWAINT1 EQU   SDWAEC1+2
SDWANXT1 EQU   SDWAEC1+4
SDWAAEC1 EQU   SDWA+112
SDWAILC1 EQU   SDWAAEC1+1
SDWAINC1 EQU   SDWAAEC1+2
SDWAICD1 EQU   SDWAINC1+1
SDWAEC2  EQU   SDWA+120
SDWAEMK2 EQU   SDWAEC2
SDWAMWP2 EQU   SDWAEC2+1
SDWAINT2 EQU   SDWAEC2+2
SDWANXT2 EQU   SDWAEC2+4
SDWAAEC2 EQU   SDWA+128
SDWAILC2 EQU   SDWAAEC2+1
SDWAINC2 EQU   SDWAAEC2+2
SDWAICD2 EQU   SDWAINC2+1
SDWASRSV EQU   SDWA+136
SDWAIDNT EQU   SDWA+200
SDWAMCH  EQU   SDWA+204
SDWASTCK EQU   SDWAMCH
SDWAMCHI EQU   SDWAMCH+8
SDWAMCHS EQU   SDWAMCHI
SDWAMCHD EQU   SDWAMCHI+1
SDWARSR1 EQU   SDWAMCH+12
SDWARSR2 EQU   SDWAMCH+13
SDWAFLGS EQU   SDWA+232
SDWAERRA EQU   SDWAFLGS
SDWAERRB EQU   SDWAFLGS+1
SDWAERRC EQU   SDWAFLGS+2
SDWAERRD EQU   SDWAFLGS+3
SDWAIOFS EQU   SDWA+238
SDWACPUA EQU   SDWA+248
SDWAPARQ EQU   SDWA+252
SDWAACF2 EQU   SDWAPARQ+1
SDWAACF3 EQU   SDWAPARQ+2
SDWAACF4 EQU   SDWAPARQ+3
SDWALKWA EQU   SDWA+256
SDWALKWS EQU   SDWALKWA
SDWARECP EQU   SDWA+292
SDWASNPA EQU   SDWA+320
SDWADUMP EQU   SDWASNPA
SDWADPFS EQU   SDWADUMP+1
SDWADDAT EQU   SDWASNPA+4
SDWASDAT EQU   SDWADDAT
SDWAPDAT EQU   SDWADDAT+2
SDWADPSA EQU   SDWA+328
SDWADPSL EQU   SDWADPSA
SDWARA   EQU   SDWA+400
SDWAVRAL EQU   SDWARA
SDWADPVA EQU   SDWARA+2
SDWAURAL EQU   SDWARA+3
RQE      EQU   0
RQETCB   EQU   RQE+12
RQENRQE  EQU   RQE+20
RQERRQ   EQU   RQE+24
RQEPRT   EQU   RQE+36
RQETYPE  EQU   RQE+37
RQETYP3  EQU   RQETYPE
RQEFLAG  EQU   RQE+38
SRBSECT  EQU   0
SRB      EQU   SRBSECT
SRBFLNK  EQU   SRB+4
SRBFLC   EQU   SRB+12
ASXB     EQU   0
ASXBAEQ  EQU   ASXB+168
ASXBFIQE EQU   ASXBAEQ
ASXBLIQE EQU   ASXBAEQ+4
ASXBFRQE EQU   ASXBAEQ+8
ASXBLRQE EQU   ASXBAEQ+12
ASXBFSRB EQU   ASXBAEQ+16
ASXBLSRB EQU   ASXBAEQ+20
ASCB     EQU   0
ASCBFW1  EQU   ASCB+100
ASCBRCTF EQU   ASCBFW1+2
ASCBFLG1 EQU   ASCBFW1+3
ASCBASXB EQU   ASCB+108
ASCBDSP1 EQU   ASCB+114
ASCBFLG2 EQU   ASCB+115
QVPL     EQU   0
QVPLTYP3 EQU   QVPL
QVPLTYP2 EQU   QVPLTYP3
QVPLTYP1 EQU   QVPLTYP2
QVPLEVR  EQU   QVPLTYP1
QVPLODA  EQU   QVPLTYP1+4
QVPLWKA  EQU   QVPLTYP1+8
QVPLHDR  EQU   QVPLTYP1+16
QVPLHF   EQU   QVPLTYP1+20
QVPLFLGH EQU   QVPLHF
QVPLFLGF EQU   QVPLHF+1
QVPLFP3  EQU   QVPLFLGF
QVPLFPTR EQU   QVPLHF+2
QVPLTRLR EQU   QVPLTYP2+28
QVPLTB   EQU   QVPLTYP2+32
QVPLFLGT EQU   QVPLTB
QVPLFLGB EQU   QVPLTB+1
IQEEND   EQU   0
RBSECS03 EQU   RBEP
RBCDE    EQU   RBSECS03
RBCDFLGS EQU   RBCDE
RBSECS05 EQU   RBPGMQ
RBSQE    EQU   RBSECS05
RBSECS06 EQU   RBPGMQ
RBIQE    EQU   RBSECS06
RBSECS07 EQU   RBPGMQ
RBIQE2   EQU   RBSECS07
RBSECS08 EQU   IRBEND
RBSECS09 EQU   IRBEND
ASCBPTR  EQU   PSAAOLD
PSARSVTE EQU   PSARSVT
FLC      EQU   PSA
*                                      START UNREFERENCED COMPONENTS
PSARSAV  EQU   PSARSVTE+60
PSARSTK  EQU   PSARSVTE+56
PSAESAV3 EQU   PSARSVTE+52
PSAESTK3 EQU   PSARSVTE+48
PSAESAV2 EQU   PSARSVTE+44
PSAESTK2 EQU   PSARSVTE+40
PSAESAV1 EQU   PSARSVTE+36
PSAESTK1 EQU   PSARSVTE+32
PSAPSAV  EQU   PSARSVTE+28
PSAPSTK  EQU   PSARSVTE+24
PSAMSAV  EQU   PSARSVTE+20
PSAMSTK  EQU   PSARSVTE+16
PSASSAV  EQU   PSARSVTE+12
PSASSTK  EQU   PSARSVTE+8
PSANSTK  EQU   PSARSVTE+4
PSACSTK  EQU   PSARSVTE
RBRSV161 EQU   RBSECS09+64
RBSIRBWA EQU   RBSECS09
RBIQEWRK EQU   RBSECS08+4
RBNEXAV  EQU   RBSECS08
RBIQEA   EQU   RBIQE2
RBIQE1   EQU   RBIQE+1
RBUSE    EQU   RBIQE
RBSQEA   EQU   RBSQE+1
@NM00025 EQU   RBSQE
RBCDE1   EQU   RBCDE+1
RBCDLOAD EQU   RBCDFLGS
RBCDXCTL EQU   RBCDFLGS
RBCDSYNC EQU   RBCDFLGS
RBCDNODE EQU   RBCDFLGS
RBRSV010 EQU   RBCDFLGS
RBCDATCH EQU   RBCDFLGS
RBRSV009 EQU   RBCDFLGS
RBNOCELL EQU   RBCDFLGS
QVPLFELM EQU   QVPLTYP2+36
QVPLBPTR EQU   QVPLTB+2
QVPLRES4 EQU   QVPLFLGB
QVPLBP3  EQU   QVPLFLGB
QVPLRES3 EQU   QVPLFLGT
QVPLTR3  EQU   QVPLFLGT
QVPLLELM EQU   QVPLTYP1+24
QVPLRES2 EQU   QVPLFLGF
QVPLRES1 EQU   QVPLFLGH
QVPLHD3  EQU   QVPLFLGH
QVPLNOEL EQU   QVPLTYP1+12
ASCBEND  EQU   ASCB+208
ASCBSRBT EQU   ASCB+200
ASCBSWTL EQU   ASCB+196
ASCBRS14 EQU   ASCB+195
ASCBSMCT EQU   ASCB+194
ASCBRS12 EQU   ASCB+192
ASCBPCTT EQU   ASCB+188
ASCBVGTT EQU   ASCB+184
ASCBLGCB EQU   ASCB+180
ASCBJBNS EQU   ASCB+176
ASCBJBNI EQU   ASCB+172
ASCBMCC  EQU   ASCB+168
ASCBRTWA EQU   ASCB+164
ASCBIQEA EQU   ASCB+160
ASCBXMPQ EQU   ASCB+156
ASCBRS01 EQU   ASCB+154
ASCBFMCT EQU   ASCB+152
ASCBOUXB EQU   ASCB+148
ASCBOUCB EQU   ASCB+144
ASCBMECB EQU   ASCB+140
ASCBQECB EQU   ASCB+136
ASCBCMSB EQU   ASCB+132
ASCBCMSF EQU   ASCB+128
ASCBTCBS EQU   ASCB+124
ASCBNVSC EQU   ASCB+122
ASCBVSC  EQU   ASCB+120
ASCBSRBS EQU   ASCB+118
ASCBSSRB EQU   ASCB+116
ASCBRV06 EQU   ASCBFLG2
ASCBRV05 EQU   ASCBFLG2
ASCBRV04 EQU   ASCBFLG2
ASCBSNQS EQU   ASCBFLG2
ASCBS2S  EQU   ASCBFLG2
ASCBCEXT EQU   ASCBFLG2
ASCBPXMT EQU   ASCBFLG2
ASCBXMPT EQU   ASCBFLG2
ASCBRF07 EQU   ASCBDSP1
ASCBRF06 EQU   ASCBDSP1
ASCBRF05 EQU   ASCBDSP1
ASCBRF04 EQU   ASCBDSP1
ASCBRF03 EQU   ASCBDSP1
ASCBRF02 EQU   ASCBDSP1
ASCBFAIL EQU   ASCBDSP1
ASCBNOQ  EQU   ASCBDSP1
ASCBSWCT EQU   ASCB+112
ASCBTMCH EQU   ASCB+104
ASCBNSWP EQU   ASCBFLG1
ASCBTYP1 EQU   ASCBFLG1
ASCBSTND EQU   ASCBFLG1
ASCBABNT EQU   ASCBFLG1
ASCBTERM EQU   ASCBFLG1
ASCBS3S  EQU   ASCBFLG1
ASCBCMSH EQU   ASCBFLG1
ASCBTOFF EQU   ASCBFLG1
ASCBRF01 EQU   ASCBRCTF
ASCBTMLW EQU   ASCBRCTF
ASCBOUT  EQU   ASCBRCTF
ASCBWAIT EQU   ASCBRCTF
ASCBRV08 EQU   ASCBRCTF
ASCBFQU  EQU   ASCBRCTF
ASCBFRS  EQU   ASCBRCTF
ASCBTMNO EQU   ASCBRCTF
ASCBAFFN EQU   ASCBFW1
ASCBDUMP EQU   ASCB+96
ASCBQSVC EQU   ASCB+92
ASCBUBET EQU   ASCB+88
ASCBECB  EQU   ASCB+84
ASCBJSTL EQU   ASCB+80
ASCBEWST EQU   ASCB+72
ASCBEJST EQU   ASCB+64
ASCBTSB  EQU   ASCB+60
ASCBCSCB EQU   ASCB+56
ASCBRSM  EQU   ASCB+52
ASCBLDA  EQU   ASCB+48
ASCBSTOR EQU   ASCB+44
ASCBDP   EQU   ASCB+43
ASCBRV07 EQU   ASCB+42
ASCBIOSM EQU   ASCB+40
ASCBSEQN EQU   ASCB+38
ASCBASID EQU   ASCB+36
ASCBCPUS EQU   ASCB+32
ASCBSPL  EQU   ASCB+28
ASCBLSLQ EQU   ASCB+24
ASCBFSLQ EQU   ASCB+20
ASCBIOSP EQU   ASCB+16
ASCBLOCK EQU   ASCB+12
ASCBBWDP EQU   ASCB+8
ASCBFWDP EQU   ASCB+4
ASCBASCB EQU   ASCB
ASCBEGIN EQU   ASCB
ASXBEND  EQU   ASXB+232
ASXBRV25 EQU   ASXB+228
ASXBRV24 EQU   ASXB+224
ASXBRV23 EQU   ASXB+220
ASXBRV22 EQU   ASXB+216
ASXBRV21 EQU   ASXB+212
ASXBRV20 EQU   ASXB+208
ASXBRV19 EQU   ASXB+204
ASXBRV18 EQU   ASXB+200
ASXBRV17 EQU   ASXB+196
ASXBRV16 EQU   ASXB+192
ASXBETSK EQU   ASXB+164
ASXBSIRB EQU   ASXB+160
ASXBPSWD EQU   ASXB+152
ASXBPRG  EQU   ASXB+136
ASXBRV26 EQU   ASXB+132
ASXBOUSB EQU   ASXB+128
ASXBDDR  EQU   ASXB+124
ASXBRCTD EQU   ASXB+120
ASXBRSMD EQU   ASXB+116
ASXBSPSA EQU   ASXB+112
ASXBFRWA EQU   ASXB+108
ASXBFLSA EQU   ASXB+36
ASXBIHSA EQU   ASXB+32
ASXBRV15 EQU   ASXB+28
ASXBRV14 EQU   ASXB+24
ASXBLWA  EQU   ASXB+20
ASXBMPST EQU   ASXB+16
ASXBRS00 EQU   ASXB+14
ASXBTCBS EQU   ASXB+12
ASXBLTCB EQU   ASXB+8
ASXBFTCB EQU   ASXB+4
ASXBASXB EQU   ASXB
ASXBEGIN EQU   ASXB
@NM00089 EQU   SRB+40
@NM00088 EQU   SRB+38
SRBPRIOR EQU   SRB+37
SRBPKF   EQU   SRB+36
SRBSAVE  EQU   SRB+32
SRBPARM  EQU   SRB+28
SRBRMTR  EQU   SRB+24
SRBEP    EQU   SRB+20
SRBPTCB  EQU   SRBFLC+4
SRBPASID EQU   SRBFLC+2
SRBCPAFF EQU   SRBFLC
SRBASCB  EQU   SRB+8
SRBID    EQU   SRB
RQEEND   EQU   RQE+40
@NM00087 EQU   RQE+39
RQECHEAC EQU   RQEFLAG
RQEPURGE EQU   RQEFLAG
RQESRBS  EQU   RQEFLAG
RQESTBL  EQU   RQEFLAG
RQEFIXST EQU   RQEFLAG
RQENOFRE EQU   RQEFLAG
RQENOPST EQU   RQEFLAG
RQERETRY EQU   RQEFLAG
RQETYP1  EQU   RQETYP3
RQETYP2  EQU   RQETYP3
@NM00086 EQU   RQETYPE
RQEVAM   EQU   RQETYPE
RQE1TO1  EQU   RQETYPE
RQEVIRT  EQU   RQETYPE
RQE114   EQU   RQETYPE
@NM00085 EQU   RQEPRT
RQEPKEY  EQU   RQEPRT
RQEIPIB  EQU   RQE+32
RQESRB   EQU   RQE+28
RQETCCW  EQU   RQE+16
RQEDEB   EQU   RQE+8
RQEIOB   EQU   RQE+4
RQEUCB   EQU   RQE
@NM00084 EQU   SDWA+512
SDWAVRA  EQU   SDWARA+4
@NM00083 EQU   SDWADPVA
SDWAEBC  EQU   SDWADPVA
SDWAHEX  EQU   SDWADPVA
@NM00082 EQU   SDWA+396
SDWACOMP EQU   SDWA+392
SDWARCPL EQU   SDWA+364
@NM00081 EQU   SDWADPSA+32
SDWATO4  EQU   SDWADPSL+28
SDWAFRM4 EQU   SDWADPSL+24
SDWATO3  EQU   SDWADPSL+20
SDWAFRM3 EQU   SDWADPSL+16
SDWATO2  EQU   SDWADPSL+12
SDWAFRM2 EQU   SDWADPSL+8
SDWATO1  EQU   SDWADPSL+4
SDWAFRM1 EQU   SDWADPSL
@NM00080 EQU   SDWADDAT+3
@NM00079 EQU   SDWAPDAT
SDWAUSPL EQU   SDWAPDAT
SDWADPSW EQU   SDWAPDAT
SDWATJPA EQU   SDWAPDAT
SDWATLPA EQU   SDWAPDAT
SDWADREG EQU   SDWAPDAT
SDWADSAH EQU   SDWAPDAT
SDWADSAS EQU   SDWAPDAT
@NM00078 EQU   SDWADDAT+1
@NM00077 EQU   SDWASDAT
SDWAQQS  EQU   SDWASDAT
SDWACBS  EQU   SDWASDAT
SDWAGTF  EQU   SDWASDAT
SDWASWA  EQU   SDWASDAT
SDWALSQA EQU   SDWASDAT
SDWASQA  EQU   SDWASDAT
SDWANUC  EQU   SDWASDAT
@NM00076 EQU   SDWADUMP+2
@NM00075 EQU   SDWADPFS
SDWASLST EQU   SDWADPFS
@NM00074 EQU   SDWADPFS
SDWADLST EQU   SDWADPFS
SDWADPT  EQU   SDWADPFS
SDWADPID EQU   SDWADUMP
SDWADPLA EQU   SDWA+316
SDWAREXN EQU   SDWARECP+16
SDWACSCT EQU   SDWARECP+8
SDWAMODN EQU   SDWARECP
@NM00073 EQU   SDWALKWA+32
SDWATALW EQU   SDWALKWS+28
SDWATDLW EQU   SDWALKWS+24
SDWATNLW EQU   SDWALKWS+20
SDWAAPLW EQU   SDWALKWS+16
SDWAIPLW EQU   SDWALKWS+12
SDWAILLW EQU   SDWALKWS+8
SDWAIULW EQU   SDWALKWS+4
SDWAICLW EQU   SDWALKWS
SDWAFLLK EQU   SDWAACF4
SDWACMS  EQU   SDWAACF4
SDWAOPTM EQU   SDWAACF4
SDWATADB EQU   SDWAACF4
SDWATDNB EQU   SDWAACF4
SDWATNCB EQU   SDWAACF4
SDWAILCH EQU   SDWAACF4
SDWAIUCB EQU   SDWAACF4
SDWAICAT EQU   SDWAACF3
SDWAIPRG EQU   SDWAACF3
SDWASALL EQU   SDWAACF3
SDWAASMP EQU   SDWAACF3
SDWADISP EQU   SDWAACF3
@NM00072 EQU   SDWAACF3
@NM00071 EQU   SDWAACF2
SDWAFREE EQU   SDWAACF2
SDWAUPRG EQU   SDWAACF2
@NM00070 EQU   SDWAACF2
SDWASPIN EQU   SDWAACF2
@NM00069 EQU   SDWAACF2
SDWARCRD EQU   SDWAACF2
SDWARCDE EQU   SDWAPARQ
SDWALCPU EQU   SDWACPUA+2
@NM00068 EQU   SDWACPUA
SDWARECA EQU   SDWA+244
SDWARTYA EQU   SDWA+240
@NM00067 EQU   SDWA+239
@NM00066 EQU   SDWAIOFS
SDWANIOP EQU   SDWAIOFS
SDWANOIO EQU   SDWAIOFS
SDWAIOHT EQU   SDWAIOFS
SDWAIOQR EQU   SDWAIOFS
SDWAFMID EQU   SDWA+236
@NM00065 EQU   SDWAERRD
SDWAMCIV EQU   SDWAERRD
SDWARPIV EQU   SDWAERRD
SDWAMABD EQU   SDWAERRD
SDWACTS  EQU   SDWAERRD
SDWASTAE EQU   SDWAERRD
SDWANRBE EQU   SDWAERRD
SDWACLUP EQU   SDWAERRD
@NM00064 EQU   SDWAERRC
SDWAEAS  EQU   SDWAERRC
SDWAPERC EQU   SDWAERRC
SDWAIRB  EQU   SDWAERRC
SDWASTAI EQU   SDWAERRC
SDWASTAF EQU   SDWAERRC
SDWASRBM EQU   SDWAERRB
SDWALDIS EQU   SDWAERRB
SDWAENRB EQU   SDWAERRB
SDWATYP1 EQU   SDWAERRB
@NM00063 EQU   SDWAERRB
SDWAPGIO EQU   SDWAERRA
SDWATEXC EQU   SDWAERRA
SDWASVCE EQU   SDWAERRA
SDWAABTM EQU   SDWAERRA
SDWASVCD EQU   SDWAERRA
SDWARKEY EQU   SDWAERRA
SDWAPCHK EQU   SDWAERRA
SDWAMCHK EQU   SDWAERRA
SDWATIME EQU   SDWAMCH+20
SDWARFSA EQU   SDWAMCH+16
@NM00062 EQU   SDWAMCH+14
SDWAVEQR EQU   SDWARSR2
SDWAPGFX EQU   SDWARSR2
SDWAFLSQ EQU   SDWARSR2
SDWAFSQA EQU   SDWARSR2
SDWANUCL EQU   SDWARSR2
SDWASPER EQU   SDWARSR2
SDWAINTC EQU   SDWARSR2
SDWAOFLN EQU   SDWARSR2
SDWACHNG EQU   SDWARSR1
SDWAMSER EQU   SDWARSR1
@NM00061 EQU   SDWARSR1
SDWACPID EQU   SDWAMCH+10
SDWATERR EQU   SDWAMCHD
SDWAFPRX EQU   SDWAMCHD
SDWAINSF EQU   SDWAMCHD
SDWAACR  EQU   SDWAMCHD
SDWASCK  EQU   SDWAMCHD
SDWAPSWU EQU   SDWAMCHD
SDWAREGU EQU   SDWAMCHD
SDWASKYF EQU   SDWAMCHD
@NM00060 EQU   SDWAMCHS
SDWARSRF EQU   SDWAMCHS
SDWARSRC EQU   SDWAMCHS
SDWAINVP EQU   SDWAMCHS
SDWATSVL EQU   SDWAMCHS
SDWARCDF EQU   SDWAMCHS
SDWASRVL EQU   SDWAMCHS
SDWASCKE EQU   SDWASTCK+4
SDWASCKB EQU   SDWASTCK
SDWALNTH EQU   SDWAIDNT+1
SDWASPID EQU   SDWAIDNT
SDWASR15 EQU   SDWASRSV+60
SDWASR14 EQU   SDWASRSV+56
SDWASR13 EQU   SDWASRSV+52
SDWASR12 EQU   SDWASRSV+48
SDWASR11 EQU   SDWASRSV+44
SDWASR10 EQU   SDWASRSV+40
SDWASR09 EQU   SDWASRSV+36
SDWASR08 EQU   SDWASRSV+32
SDWASR07 EQU   SDWASRSV+28
SDWASR06 EQU   SDWASRSV+24
SDWASR05 EQU   SDWASRSV+20
SDWASR04 EQU   SDWASRSV+16
SDWASR03 EQU   SDWASRSV+12
SDWASR02 EQU   SDWASRSV+8
SDWASR01 EQU   SDWASRSV+4
SDWASR00 EQU   SDWASRSV
SDWATRN2 EQU   SDWAAEC2+4
SDWAIPC2 EQU   SDWAICD2
SDWAIMC2 EQU   SDWAICD2
SDWAIPR2 EQU   SDWAICD2
@NM00059 EQU   SDWAINC2
@NM00058 EQU   SDWAILC2
SDWAIL2  EQU   SDWAILC2
@NM00057 EQU   SDWAILC2
@NM00056 EQU   SDWAAEC2
SDWAADD2 EQU   SDWANXT2+1
@NM00055 EQU   SDWANXT2
@NM00054 EQU   SDWAEC2+3
SDWASGN2 EQU   SDWAINT2
SDWAEXP2 EQU   SDWAINT2
SDWADEC2 EQU   SDWAINT2
SDWAFPO2 EQU   SDWAINT2
SDWACC2  EQU   SDWAINT2
@NM00053 EQU   SDWAINT2
SDWAPGM2 EQU   SDWAMWP2
SDWAWAT2 EQU   SDWAMWP2
SDWAMCK2 EQU   SDWAMWP2
SDWAECT2 EQU   SDWAMWP2
SDWAKEY2 EQU   SDWAMWP2
SDWAEXT2 EQU   SDWAEMK2
SDWAIO2  EQU   SDWAEMK2
SDWATRM2 EQU   SDWAEMK2
@NM00052 EQU   SDWAEMK2
SDWAPER2 EQU   SDWAEMK2
@NM00051 EQU   SDWAEMK2
SDWATRAN EQU   SDWAAEC1+4
SDWAIPC1 EQU   SDWAICD1
SDWAIMC1 EQU   SDWAICD1
SDWAIPR1 EQU   SDWAICD1
@NM00050 EQU   SDWAINC1
@NM00049 EQU   SDWAILC1
SDWAIL1  EQU   SDWAILC1
@NM00048 EQU   SDWAILC1
@NM00047 EQU   SDWAAEC1
SDWAADD1 EQU   SDWANXT1+1
@NM00046 EQU   SDWANXT1
@NM00045 EQU   SDWAEC1+3
SDWASGN1 EQU   SDWAINT1
SDWAEXP1 EQU   SDWAINT1
SDWADEC1 EQU   SDWAINT1
SDWAFPO1 EQU   SDWAINT1
SDWACC1  EQU   SDWAINT1
@NM00044 EQU   SDWAINT1
SDWAPGM1 EQU   SDWAMWP1
SDWAWAT1 EQU   SDWAMWP1
SDWAMCK1 EQU   SDWAMWP1
SDWAECT1 EQU   SDWAMWP1
SDWAKEY1 EQU   SDWAMWP1
SDWAEXT1 EQU   SDWAEMK1
SDWAIO1  EQU   SDWAEMK1
SDWATRM1 EQU   SDWAEMK1
@NM00043 EQU   SDWAEMK1
SDWAPER1 EQU   SDWAEMK1
@NM00042 EQU   SDWAEMK1
SDWAIOBR EQU   SDWA+100
SDWAEPA  EQU   SDWA+96
@NM00041 EQU   SDWANAME+4
SDWARBAD EQU   SDWANAME
SDWAGR15 EQU   SDWAGRSV+60
SDWAGR14 EQU   SDWAGRSV+56
SDWAGR13 EQU   SDWAGRSV+52
SDWAGR12 EQU   SDWAGRSV+48
SDWAGR11 EQU   SDWAGRSV+44
SDWAGR10 EQU   SDWAGRSV+40
SDWAGR09 EQU   SDWAGRSV+36
SDWAGR08 EQU   SDWAGRSV+32
SDWAGR07 EQU   SDWAGRSV+28
SDWAGR06 EQU   SDWAGRSV+24
SDWAGR05 EQU   SDWAGRSV+20
SDWAGR04 EQU   SDWAGRSV+16
SDWAGR03 EQU   SDWAGRSV+12
SDWAGR02 EQU   SDWAGRSV+8
SDWAGR01 EQU   SDWAGRSV+4
SDWAGR00 EQU   SDWAGRSV
SDWANXTP EQU   SDWACTL2+5
SDWASGP  EQU   SDWAPMKP
SDWAEUP  EQU   SDWAPMKP
SDWADOP  EQU   SDWAPMKP
SDWAFPP  EQU   SDWAPMKP
SDWACCP  EQU   SDWAPMKP
SDWAILP  EQU   SDWAPMKP
SDWAINTP EQU   SDWACTL2+2
SDWASPVP EQU   SDWAMWPP
SDWAWATP EQU   SDWAMWPP
SDWAMCKP EQU   SDWAMWPP
@NM00040 EQU   SDWAMWPP
SDWAKEYP EQU   SDWAMWPP
SDWAEXTP EQU   SDWACMKP
SDWAIOP  EQU   SDWACMKP
SDWANXTA EQU   SDWACTL1+5
SDWASGA  EQU   SDWAPMKA
SDWAEUA  EQU   SDWAPMKA
SDWADOA  EQU   SDWAPMKA
SDWAFPA  EQU   SDWAPMKA
SDWACCA  EQU   SDWAPMKA
SDWAILA  EQU   SDWAPMKA
SDWAINTA EQU   SDWACTL1+2
SDWASPVA EQU   SDWAMWPA
SDWAWATA EQU   SDWAMWPA
SDWAMCKA EQU   SDWAMWPA
@NM00039 EQU   SDWAMWPA
SDWAKEYA EQU   SDWAMWPA
SDWAEXTA EQU   SDWACMKA
SDWAIOA  EQU   SDWACMKA
SDWACMPC EQU   SDWAABCC+1
@NM00038 EQU   SDWACMPF
SDWASTCC EQU   SDWACMPF
@NM00037 EQU   SDWACMPF
SDWASTEP EQU   SDWACMPF
SDWAREQ  EQU   SDWACMPF
SDWAPARM EQU   SDWA
IQEOUTLM EQU   IQESECT+20
IQEDCB   EQU   IQESECT+16
IQETCBA  EQU   IQETCB+1
IQESTAT2 EQU   IQETCB
@NM00036 EQU   IQEFLAGS
@NM00035 EQU   IQEFLAGS
@NM00034 EQU   IQEFLAGS
@NM00033 EQU   IQEFLAGS
@NM00032 EQU   IQEFLAGS
@NM00031 EQU   IQEFLAGS
@NM00030 EQU   IQEFLAGS
IQEPURGE EQU   IQEFLAGS
IQEPARAM EQU   IQESECT+4
IQELNKA  EQU   IQELNK+1
IQESTAT1 EQU   IQELNK
@NM00029 EQU   TCBXTNT2+32
TCBRV181 EQU   TCBRV173
TCBRV180 EQU   TCBRV173
TCBRV179 EQU   TCBRV173
TCBRV178 EQU   TCBRV173
TCBRV177 EQU   TCBRV173
TCBRV176 EQU   TCBRV173
TCBRV175 EQU   TCBRV173
TCBRV174 EQU   TCBRV173
TCBRV172 EQU   TCBRV164
TCBRV171 EQU   TCBRV164
TCBRV170 EQU   TCBRV164
TCBRV169 EQU   TCBRV164
TCBRV168 EQU   TCBRV164
TCBRV167 EQU   TCBRV164
TCBRV166 EQU   TCBRV164
TCBRV165 EQU   TCBRV164
TCBRV163 EQU   TCBRV155
TCBRV162 EQU   TCBRV155
TCBRV161 EQU   TCBRV155
TCBRV160 EQU   TCBRV155
TCBRV159 EQU   TCBRV155
TCBRV158 EQU   TCBRV155
TCBRV157 EQU   TCBRV155
TCBRV156 EQU   TCBRV155
TCBRV154 EQU   TCBRV146
TCBRV153 EQU   TCBRV146
TCBRV152 EQU   TCBRV146
TCBRV151 EQU   TCBRV146
TCBRV150 EQU   TCBRV146
TCBRV149 EQU   TCBRV146
TCBRV148 EQU   TCBRV146
TCBRV147 EQU   TCBRV146
TCBRV145 EQU   TCBXTNT2+26
TCBRV144 EQU   TCBXTNT2+24
TCBRV143 EQU   TCBXTNT2+20
TCBRV142 EQU   TCBXTNT2+16
TCBRSV49 EQU   TCBXTNT2+12
TCBRSV48 EQU   TCBXTNT2+8
TCBRCMP  EQU   TCBXTNT2+5
TCBRSVAB EQU   TCBXTNT2+4
TCBGTFA  EQU   TCBGTF+1
TCBRSV47 EQU   TCBTFLG
TCBRSV46 EQU   TCBTFLG
TCBRSV45 EQU   TCBTFLG
TCBRSV44 EQU   TCBTFLG
TCBRSV43 EQU   TCBTFLG
TCBDSPIT EQU   TCBTFLG
TCBERRTN EQU   TCBTFLG
TCBASYNC EQU   TCBTFLG
@NM00028 EQU   TCB+296
TCBRV185 EQU   TCB+292
TCBSWASA EQU   TCB+288
TCBDBTB  EQU   TCB+284
TCBRPT   EQU   TCB+280
TCBRV141 EQU   TCBRV133
TCBRV140 EQU   TCBRV133
TCBRV139 EQU   TCBRV133
TCBRV138 EQU   TCBRV133
TCBRV137 EQU   TCBRV133
TCBRV136 EQU   TCBRV133
TCBRV135 EQU   TCBRV133
TCBRV134 EQU   TCBRV133
TCBRV132 EQU   TCBRV124
TCBRV131 EQU   TCBRV124
TCBRV130 EQU   TCBRV124
TCBRV129 EQU   TCBRV124
TCBRV128 EQU   TCBRV124
TCBRV127 EQU   TCBRV124
TCBRV126 EQU   TCBRV124
TCBRV125 EQU   TCBRV124
TCBRV123 EQU   TCBFBYT2
TCBRV122 EQU   TCBFBYT2
TCBECBNV EQU   TCBFBYT2
TCBSSSYN EQU   TCBFBYT2
TCBFPRAP EQU   TCBFBYT2
TCBFDW   EQU   TCBFBYT2
TCBFMW   EQU   TCBFBYT2
TCBCNCB  EQU   TCBFBYT2
TCBLLH   EQU   TCBFBYT1
TCBRV113 EQU   TCBFBYT1
TCBEOT   EQU   TCBFBYT1
TCBRTM2  EQU   TCBFBYT1
TCBPGNLY EQU   TCBFBYT1
TCBNDIOS EQU   TCBFBYT1
TCBACTIV EQU   TCBFBYT1
TCBEOTFM EQU   TCBFBYT1
TCBAFFN  EQU   TCB+274
TCBCCPVI EQU   TCB+272
TCBUKYSP EQU   TCB+268
TCBMODE  EQU   TCBESTAE+3
TCBERTYP EQU   TCBESTAE+2
TCBRV314 EQU   TCBESTRM
TCBRV313 EQU   TCBESTRM
TCBRV312 EQU   TCBESTRM
TCBRV311 EQU   TCBESTRM
TCBRV310 EQU   TCBESTRM
TCBRV309 EQU   TCBESTRM
TCBRV308 EQU   TCBESTRM
TCBETERM EQU   TCBESTRM
TCBSCBKY EQU   TCBESTAE
TCBRTM12 EQU   TCB+260
TCBTCBID EQU   TCB+256
TCBRSV96 EQU   TCB+252
TCBSWA   EQU   TCB+248
TCBFOEA  EQU   TCBFOE+1
TCBRSV42 EQU   TCBFOE
TCBRV306 EQU   TCB+240
TCBRSV41 EQU   TCB+239
TCBTID   EQU   TCB+238
TCBRSVAA EQU   TCB+237
TCBABCUR EQU   TCB+236
TCBTMSAV EQU   TCB+232
TCBIOTIM EQU   TCB+228
TCBRTWA  EQU   TCB+224
TCBBACK  EQU   TCB+220
TCBTIRB  EQU   TCB+216
TCBAECB  EQU   TCB+212
TCBEXT2A EQU   TCBEXT2+1
TCBRSV39 EQU   TCBEXT2
TCBSTMCT EQU   TCB+207
TCBSYSCT EQU   TCB+206
TCBRSV37 EQU   TCB+205
TCBEXSVC EQU   TCBDAR
TCBRSV36 EQU   TCBDAR
TCBDARWT EQU   TCBDAR
TCBDARO  EQU   TCBDAR
TCBDARMC EQU   TCBDARC
TCBDARD  EQU   TCBDAR
TCBDARS  EQU   TCBDAR
TCBDARP  EQU   TCBDAR
TCBGTOFM EQU   TCBFLGS7
TCBADMP  EQU   TCBFLGS7
TCBRSTSK EQU   TCBFLGS7
TCBRSV35 EQU   TCBFLGS7
TCBSTACK EQU   TCBFLGS7
TCBRSV34 EQU   TCBFLGS7
TCBRSV33 EQU   TCBFLGS7
TCBGPECB EQU   TCBFLGS7
TCBNTJS  EQU   TCBFLGS6
TCBAPG   EQU   TCBFLGS6
TCBMIGR  EQU   TCBFLGS6
TCBRV303 EQU   TCBFLGS6
TCBSPVLK EQU   TCBFLGS6
TCBCPU   EQU   TCBFLGS6
TCBPIE17 EQU   TCBFLGS6
TCBRV    EQU   TCBFLGS6
TCBRSV79 EQU   TCBNDSP5
TCBRSV78 EQU   TCBNDSP5
TCBRSV77 EQU   TCBNDSP5
TCBRSV76 EQU   TCBNDSP5
TCBRSV75 EQU   TCBNDSP5
TCBRSV74 EQU   TCBNDSP5
TCBRSV95 EQU   TCBNDSP5
TCBRSV94 EQU   TCBNDSP5
TCBRSV93 EQU   TCBNDSP4
TCBRSV92 EQU   TCBNDSP4
TCBRSV91 EQU   TCBNDSP4
TCBRSV90 EQU   TCBNDSP4
TCBRSV89 EQU   TCBNDSP4
TCBRSV88 EQU   TCBNDSP4
TCBRSV87 EQU   TCBNDSP4
TCBRSV86 EQU   TCBNDSP4
TCBEXT1A EQU   TCBEXT1+1
TCBRSV32 EQU   TCBEXT1
TCBRSV30 EQU   TCB+192
TCBIOBRC EQU   TCB+188
TCBDDWTC EQU   TCB+186
TCBDDEXC EQU   TCB+184
TCBJSCBB EQU   TCBJSCB+1
@NM00027 EQU   TCBRECDE
TCBREC   EQU   TCBRECDE
TCBMDIDS EQU   TCB+176
TCBNDINT EQU   TCBNDSP3
TCBRSV27 EQU   TCBNDSP3
TCBRSV26 EQU   TCBNDSP3
TCBRSV25 EQU   TCBNDSP3
TCBRSV24 EQU   TCBNDSP3
TCBSRBND EQU   TCBNDSP3
TCBRV302 EQU   TCBNDSP3
TCBLJSND EQU   TCBNDSP3
TCBABE   EQU   TCBNDSP2
TCBDSS   EQU   TCBNDSP2
TCBOWAIT EQU   TCBNDSP2
TCBIWAIT EQU   TCBNDSP2
TCBNDTS  EQU   TCBNDSP2
TCBNDSVC EQU   TCBNDSP2
TCBSTPP  EQU   TCBNDSP2
TCBABD   EQU   TCBNDSP2
TCBRSV22 EQU   TCBNDSP1
TCBPIEND EQU   TCBNDSP1
TCBTPSP  EQU   TCBNDSP1
TCBDDRND EQU   TCBNDSP1
TCBRSPND EQU   TCBNDSP1
TCBRSTND EQU   TCBNDSP1
TCBDARPN EQU   TCBNDSP1
TCBDARTN EQU   TCBNDSP1
TCBNDSP0 EQU   TCBNDSP
TCBUSER  EQU   TCB+168
TCBTCTB  EQU   TCBTCT+1
TCBRSV9C EQU   TCBTCTGF
TCBRSV9B EQU   TCBTCTGF
TCBRSV9A EQU   TCBTCTGF
TCBRSV99 EQU   TCBTCTGF
TCBRSV98 EQU   TCBTCTGF
TCBRSV97 EQU   TCBTCTGF
TCBRSV20 EQU   TCBTCTGF
TCBSMFGF EQU   TCBTCTGF
TCBSTABB EQU   TCBSTAB+1
TCBSTCUR EQU   TCBNSTAE
TCBRV301 EQU   TCBNSTAE
TCBSYNCH EQU   TCBNSTAE
TCBHALT  EQU   TCBNSTAE
TCBPPSUP EQU   TCBNSTAE
TCB33E   EQU   TCBNSTAE
TCBQUIES EQU   TCBNSTAE
TCBSTABE EQU   TCBNSTAE
TCBAQE   EQU   TCB+156
TCBPQE   EQU   TCB+152
TCBTSDP  EQU   TCB+151
TCBTSLP  EQU   TCB+150
TCBSTPCT EQU   TCB+149
TCBCPUBN EQU   TCBTSFLG
TCBDYDSP EQU   TCBTSFLG
TCBRSV18 EQU   TCBTSFLG
TCBRSV17 EQU   TCBTSFLG
TCBTIOTG EQU   TCBTSFLG
TCBATT   EQU   TCBTSFLG
TCBSTPPR EQU   TCBTSFLG
TCBRV300 EQU   TCBTSTSK
TCBECB   EQU   TCB+144
TCBIQE   EQU   TCB+140
TCBLTC   EQU   TCB+136
TCBOTC   EQU   TCB+132
TCBNTC   EQU   TCB+128
TCBJSTCA EQU   TCBJSTCB+1
TCBRSV16 EQU   TCBJSTCB
TCBTQET  EQU   TCBTME
TCBTCB   EQU   TCB+116
TCBFSAB  EQU   TCBFSA+1
TCBQEL   EQU   TCBFSA
TCBGRS15 EQU   TCBGRS+60
TCBGRS14 EQU   TCBGRS+56
TCBGRS13 EQU   TCBGRS+52
TCBGRS12 EQU   TCBGRS+48
TCBGRS11 EQU   TCBGRS+44
TCBGRS10 EQU   TCBGRS+40
TCBGRS9  EQU   TCBGRS+36
TCBGRS8  EQU   TCBGRS+32
TCBGRS7  EQU   TCBGRS+28
TCBGRS6  EQU   TCBGRS+24
TCBGRS5  EQU   TCBGRS+20
TCBGRS4  EQU   TCBGRS+16
TCBGRS3  EQU   TCBGRS+12
TCBGRS2  EQU   TCBGRS+8
TCBGRS1  EQU   TCBGRS+4
TCBGRS0  EQU   TCBGRS
TCBJPQB  EQU   TCBJPQ+1
TCBRSV15 EQU   TCBPURGE
TCBRSV14 EQU   TCBPURGE
TCBRSV13 EQU   TCBPURGE
TCBRSV12 EQU   TCBPURGE
TCBRSV11 EQU   TCBPURGE
TCBRSV10 EQU   TCBPURGE
TCBRSV09 EQU   TCBPURGE
TCBJPQF  EQU   TCBPURGE
TCBJLB   EQU   TCB+40
TCBLLS   EQU   TCB+36
TCBDSP   EQU   TCB+35
TCBLMP   EQU   TCB+34
TCBPNDSP EQU   TCBFLGS5
TCBFCD1  EQU   TCBFLGS5
TCBSTP   EQU   TCBFLGS5
TCBSYS   EQU   TCBFLGS5
TCBANDSP EQU   TCBFLGS5
TCBPAGE  EQU   TCBFLGS5
TCBUXNDF EQU   TCBABWF
TCBFC    EQU   TCBFLGS5
TCBONDSP EQU   TCBFLGS4
TCBMPCND EQU   TCBFLGS4
TCBMPCVQ EQU   TCBFLGS4
TCBUXNDV EQU   TCBFLGS4
TCBHNDSP EQU   TCBFLGS4
TCBRQENA EQU   TCBFLGS4
TCBSER   EQU   TCBFLGS4
TCBNDUMP EQU   TCBFLGS4
TCBDWSTA EQU   TCBFLGS3
TCBRSV08 EQU   TCBFLGS3
TCBRSV07 EQU   TCBFLGS3
TCBRSV06 EQU   TCBFLGS3
TCBABGM  EQU   TCBFLGS3
TCBABTRM EQU   TCBFLGS3
TCBADINP EQU   TCBFLGS3
TCBFSM   EQU   TCBFLGS3
TCBFTS   EQU   TCBFLGS2
TCBFETXR EQU   TCBFLGS2
TCBFDSOP EQU   TCBFLGS2
TCBFJMC  EQU   TCBFLGS2
TCBFSMC  EQU   TCBFLGS2
TCBFABOP EQU   TCBFLGS2
TCBFSTI  EQU   TCBFLGS2
TCBFOINP EQU   TCBFLGS2
TCBFX    EQU   TCBFLGS1
TCBFS    EQU   TCBFLGS1
TCBFT    EQU   TCBFLGS1
TCBPDUMP EQU   TCBFLGS1
TCBRSV04 EQU   TCBFLGS1
TCBFERA  EQU   TCBFLGS1
TCBFE    EQU   TCBFLGS1
TCBFA    EQU   TCBFLGS1
TCBZERO  EQU   TCBPKF
TCBFLAG  EQU   TCBPKF
TCBMSSB  EQU   TCBMSS+1
TCBRSV03 EQU   TCBMSS
TCBTRNB  EQU   TCBTRN+1
TCBRSV02 EQU   TCBABF
TCBOLTEP EQU   TCBABF
TCBTCP   EQU   TCBABF
TCBTCPP  EQU   TCBABF
TCBRSV01 EQU   TCBABF
TCBGRPH  EQU   TCBABF
TCBNOCHK EQU   TCBABF
TCBMOD91 EQU   TCBABF
TCBCMPC  EQU   TCBCMP+1
TCBRV318 EQU   TCBCMSG
TCBRV317 EQU   TCBCIND
TCBRV316 EQU   TCBCWTO
TCBCASID EQU   TCBCDBL
TCBNOCC  EQU   TCBSTCC
TCBDMPO  EQU   TCBCPP
TCBCSTEP EQU   TCBCMPF
TCBCREQ  EQU   TCBCMPF
TCBTIO   EQU   TCB+12
TCBDEB   EQU   TCB+8
TCBPIEA  EQU   TCBPIE+1
TCBPM    EQU   TCBPMASK
@NM00026 EQU   TCBPMASK
TCBRBP   EQU   TCB
TCBFRS6  EQU   TCBFRS+24
TCBFRS4  EQU   TCBFRS+16
TCBFRS2  EQU   TCBFRS+8
TCBFRS0  EQU   TCBFRS
SIRBEND  EQU   RBSECT+168
SVRBEND  EQU   RBSECT+168
RBRSV158 EQU   RBRSV150
RBRSV157 EQU   RBRSV150
RBRSV156 EQU   RBRSV150
RBRSV155 EQU   RBRSV150
RBRSV154 EQU   RBRSV150
RBRSV153 EQU   RBRSV150
RBRSV152 EQU   RBRSV150
RBRSV151 EQU   RBRSV150
RBRSV149 EQU   RBSECT+166
RBRSV148 EQU   RBSECT+164
RBSCBB   EQU   RBSECT+144
TIRBEND  EQU   @NM00024+8
PRBEND   EQU   @NM00024+8
RBRSV146 EQU   RBRSV138
RBRSV145 EQU   RBRSV138
RBRSV144 EQU   RBRSV138
RBRSV143 EQU   RBRSV138
RBRSV142 EQU   RBRSV138
RBRSV141 EQU   RBRSV138
RBRSV140 EQU   RBRSV138
RBRSV139 EQU   RBRSV138
RBRSV137 EQU   @NM00024+6
RBRSV136 EQU   @NM00024+4
RBRSV135 EQU   @NM00024
@NM00023 EQU   RBSECT+32
@NM00022 EQU   @NM00020+1
@NM00021 EQU   @NM00020
RBPGMQ1  EQU   RBPGMQ+1
@NM00019 EQU   RBPGMQ
@NM00018 EQU   RBSECT+16
@NM00017 EQU   @NM00013
@NM00016 EQU   @NM00013
RBIQETP  EQU   @NM00013
RBUSIQE  EQU   RBETXR
RBATTN   EQU   @NM00013
@NM00015 EQU   @NM00013
@NM00014 EQU   @NM00013
RBRSV007 EQU   @NM00011
RBATNXIT EQU   @NM00011
@NM00012 EQU   @NM00011
RBWAITP  EQU   @NM00011
RBFNSVRB EQU   RBTRSVRB
RBFTP    EQU   @NM00011
RBSIZE   EQU   RBSECT+8
RBABOPSW EQU   RBSECT+4
RBPPSAV1 EQU   RBPPSAV+1
@NM00009 EQU   RBPPSAV
RBPRFXND EQU   RBPREFIX+64
RBINTCOD EQU   RBINTCDA+1
RBINLNTH EQU   RBINTCDA
RBWCSA   EQU   RBPREFIX+60
RBRSV004 EQU   RBPREFIX+57
RBSSSYN  EQU   RBFLAGS1
RBSCB    EQU   RBFLAGS1
RBLONGWT EQU   RBFLAGS1
RBASIR   EQU   RBFLAGS1
RBRSV159 EQU   RBFLAGS1
RBABEND  EQU   RBFLAGS1
RBXWAIT  EQU   RBFLAGS1
RBSLOCK  EQU   RBFLAGS1
RBRTRAN  EQU   RBRTPSW2+4
RBRTINCD EQU   RBRTICIL+2
RBRTILC  EQU   RBRTICIL+1
RBRSV160 EQU   RBRTICIL
RBRTPSW1 EQU   RBRTOPSW
RBRSV062 EQU   RBRSV054
RBRSV061 EQU   RBRSV054
RBRSV060 EQU   RBRSV054
RBRSV059 EQU   RBRSV054
RBRSV058 EQU   RBRSV054
RBRSV057 EQU   RBRSV054
RBRSV056 EQU   RBRSV054
RBRSV055 EQU   RBRSV054
RBRSV053 EQU   RBPREFIX+38
RBRSV052 EQU   RBPREFIX+36
RBRSV051 EQU   RBPREFIX+32
RBPRFXST EQU   RBPREFIX+32
RBRSV050 EQU   RBPREFIX+28
RBRSV049 EQU   RBRSV041
RBRSV048 EQU   RBRSV041
RBRSV047 EQU   RBRSV041
RBRSV046 EQU   RBRSV041
RBRSV045 EQU   RBRSV041
RBRSV044 EQU   RBRSV041
RBRSV043 EQU   RBRSV041
RBRSV042 EQU   RBRSV041
RBRSV040 EQU   RBPREFIX+26
RBRSV039 EQU   RBPREFIX+24
RBRSV038 EQU   RBPREFIX+20
RBRSV037 EQU   RBPREFIX+16
RBRSV036 EQU   RBRSV028
RBRSV035 EQU   RBRSV028
RBRSV034 EQU   RBRSV028
RBRSV033 EQU   RBRSV028
RBRSV032 EQU   RBRSV028
RBRSV031 EQU   RBRSV028
RBRSV030 EQU   RBRSV028
RBRSV029 EQU   RBRSV028
RBRSV027 EQU   RBRSV019
RBRSV026 EQU   RBRSV019
RBRSV025 EQU   RBRSV019
RBRSV024 EQU   RBRSV019
RBRSV023 EQU   RBRSV019
RBRSV022 EQU   RBRSV019
RBRSV021 EQU   RBRSV019
RBRSV020 EQU   RBRSV019
RBRSV018 EQU   RBPREFIX+13
RBRSV017 EQU   RBPREFIX+12
RBSRV016 EQU   RBPREFIX+11
RBRSV015 EQU   RBPREFIX+10
RBRSV014 EQU   RBPREFIX+8
RBRSV013 EQU   RBPREFIX+4
RBRSV012 EQU   RBPREFIX
RBEXSAVE EQU   XRBESA
XRBREG15 EQU   RBGRS15
XRBREG14 EQU   RBGRS14
XRBREG13 EQU   RBGRS13
XRBREG12 EQU   RBGRS12
XRBREG11 EQU   RBGRS11
XRBREG10 EQU   RBGRS10
XRBREG9  EQU   RBGRS9
XRBREG8  EQU   RBGRS8
XRBREG7  EQU   RBGRS7
XRBREG6  EQU   RBGRS6
XRBREG5  EQU   RBGRS5
XRBREG4  EQU   RBGRS4
XRBREG3  EQU   RBGRS3
XRBREG2  EQU   RBGRS2
XRBREG1  EQU   RBGRS1
XRBREG0  EQU   RBGRS0
XRBLNKA  EQU   RBLINKB
XRBWT    EQU   RBWCF
@NM00008 EQU   RBBASIC+24
XRBPSW   EQU   RBOPSW
@NM00007 EQU   RBBASIC+12
XRBWAIT  EQU   RBECBWT
XRBFRRB  EQU   RBFDYN
@NM00006 EQU   XSTAB2
XRBACTV  EQU   RBFACTV
XRBTCBP  EQU   RBTCBNXT
@NM00005 EQU   XSTAB1
XRBCKPT  EQU   RBFTCKPT
@NM00004 EQU   XSTAB1
@NM00003 EQU   RBBASIC+8
@NM00002 EQU   RBEXRTNM+1
RBTMIND3 EQU   RBTMFLD
RBTMIND2 EQU   RBTMFLD
RBTMCMP  EQU   RBTMFLD
RBWLIM   EQU   RBTMFLD
RBRSV005 EQU   RBTMFLD
RBTMTOD  EQU   RBTMFLD
RBTMQUE  EQU   RBTMFLD
@NM00001 EQU   RBPRFX
@NM00113 EQU   PSA+3412
PSASTAK  EQU   PSA+3072
@NM00112 EQU   PSA+1032
PSAUSEND EQU   PSA+1032
PSAPCPSW EQU   PSA+1024
PSARV060 EQU   PSA+1020
PSARV059 EQU   PSA+1018
PSASVC13 EQU   PSA+1016
PSALSFCC EQU   PSA+1012
PSASFACC EQU   PSA+1008
PSASTOP  EQU   PSA+992
PSASTART EQU   PSA+976
PSARSPSW EQU   PSA+968
PSASRPSW EQU   PSA+960
PSARV045 EQU   PSA+892
PSARV044 EQU   PSA+888
PSARV043 EQU   PSA+884
PSARV042 EQU   PSA+880
PSARV041 EQU   PSA+876
PSARV040 EQU   PSA+872
PSARV025 EQU   PSA+868
PSADSSED EQU   PSA+868
PSADSSPR EQU   PSA+864
PSADSSFW EQU   PSA+860
PSADSS14 EQU   PSA+856
PSADSSPP EQU   PSA+848
PSADSSRP EQU   PSA+840
PSADSS05 EQU   PSADSSF4
PSADSS10 EQU   PSADSSF4
PSADSSVE EQU   PSADSSF4
PSADSSDE EQU   PSADSSF4
PSADSSC0 EQU   PSADSSF4
PSADSSIE EQU   PSADSSF4
PSADSS12 EQU   PSADSSF4
PSADSSRC EQU   PSADSSF4
PSARV057 EQU   PSADSSF3
PSARV056 EQU   PSADSSF3
PSARV055 EQU   PSADSSF3
PSARV054 EQU   PSADSSF3
PSADSSRW EQU   PSADSSF3
PSADSSNM EQU   PSADSSF3
PSADSSES EQU   PSADSSF3
PSADSSGP EQU   PSADSSF3
PSADSSF2 EQU   PSADSSFL+1
PSADSSPI EQU   PSADSSF1
PSADSSOI EQU   PSADSSF1
PSADSSSP EQU   PSADSSF1
PSADSSTP EQU   PSADSSF1
PSADSSDW EQU   PSADSSF1
PSADSSDD EQU   PSADSSF1
PSADSSDM EQU   PSADSSF1
PSADSSMV EQU   PSADSSF1
PSADSSTS EQU   PSA+816
PSADSSWK EQU   PSA+812
PSADSSR3 EQU   PSA+808
PSADSSR2 EQU   PSA+804
PSADSSRS EQU   PSA+800
PSASTOR  EQU   PSA+796
PSARV058 EQU   PSA+794
PSAVSTAP EQU   PSA+792
PSAWKVAP EQU   PSA+788
PSAWKRAP EQU   PSA+784
PSAMCHIC EQU   PSA+783
PSAMODE  EQU   PSA+782
PSASYMSK EQU   PSA+781
PSAMCHFL EQU   PSA+780
PSACR0   EQU   PSA+776
PSAPSWSV EQU   PSA+768
PSALITA  EQU   PSA+764
PSACLHS  EQU   PSAHLHI
PSALKR15 EQU   PSALKSA+60
PSALKR14 EQU   PSALKSA+56
PSALKR13 EQU   PSALKSA+52
PSALKR12 EQU   PSALKSA+48
PSALKR11 EQU   PSALKSA+44
PSALKR10 EQU   PSALKSA+40
PSALKR9  EQU   PSALKSA+36
PSALKR8  EQU   PSALKSA+32
PSALKR7  EQU   PSALKSA+28
PSALKR6  EQU   PSALKSA+24
PSALKR5  EQU   PSALKSA+20
PSALKR4  EQU   PSALKSA+16
PSALKR3  EQU   PSALKSA+12
PSALKR2  EQU   PSALKSA+8
PSALKR1  EQU   PSALKSA+4
PSALKR0  EQU   PSALKSA
PSARV023 EQU   PSACLHT+52
PSALOCAL EQU   PSACLHT+48
PSACMSL  EQU   PSACLHT+44
PSAOPTL  EQU   PSACLHT+40
PSATPACL EQU   PSACLHT+36
PSATPDNL EQU   PSACLHT+32
PSATPNCL EQU   PSACLHT+28
PSAIOSLL EQU   PSACLHT+24
PSAIOSUL EQU   PSACLHT+20
PSAIOSCL EQU   PSACLHT+16
PSAIOSSL EQU   PSACLHT+12
PSASALCL EQU   PSACLHT+8
PSAASML  EQU   PSACLHT+4
PSADISPL EQU   PSACLHT
PSASRSA  EQU   PSA+636
PSARV050 EQU   PSA+634
PSADSSGO EQU   PSA+633
PSARECUR EQU   PSA+632
PSAHLHIS EQU   PSA+628
PSAIPCSA EQU   PSA+624
@NM00111 EQU   PSA+621
PSAIPCDM EQU   PSA+620
PSAIPCD  EQU   PSA+616
@NM00110 EQU   PSA+613
PSAIPCRM EQU   PSA+612
PSAIPCR  EQU   PSA+608
PSAMCHEX EQU   PSA+600
PSAMPSW  EQU   PSA+592
PSAEXPS2 EQU   PSA+584
PSAEXPS1 EQU   PSA+576
PSAPIREG EQU   PSA+572
PSARSREG EQU   PSA+568
PSAGPREG EQU   PSA+556
PSARV022 EQU   PSASUP4
PSARV021 EQU   PSASUP4
PSARV020 EQU   PSASUP4
PSARV019 EQU   PSASUP4
PSARV018 EQU   PSASUP4
PSARV017 EQU   PSASUP4
PSARV016 EQU   PSASUP4
PSARV015 EQU   PSASUP4
PSARV014 EQU   PSASUP3
PSARV013 EQU   PSASUP3
PSARV012 EQU   PSASUP3
PSARV011 EQU   PSASUP3
PSARV010 EQU   PSASUP3
PSARV009 EQU   PSASUP3
PSARV008 EQU   PSASUP3
PSAIOSUP EQU   PSASUP3
PSALCR   EQU   PSASUP2
PSARTM   EQU   PSASUP2
PSAACR   EQU   PSASUP2
PSAIPCE2 EQU   PSASUP2
PSAIPCES EQU   PSASUP2
PSAIPCEC EQU   PSASUP2
PSAGTF   EQU   PSASUP2
PSAIPCRI EQU   PSASUP2
PSAIPCRP EQU   PSASUP1
PSAIPCDR EQU   PSASUP1
PSADISP  EQU   PSASUP1
PSALOCK  EQU   PSASUP1
PSAPI    EQU   PSASUP1
PSAEXT   EQU   PSASUP1
PSASVC   EQU   PSASUP1
PSAIO    EQU   PSASUP1
PSAANEW  EQU   PSA+544
PSATOLD  EQU   PSA+540
PSATNEW  EQU   PSA+536
PSALCCAR EQU   PSA+532
PSALCCAV EQU   PSA+528
PSAPCCAR EQU   PSA+524
PSAPCCAV EQU   PSA+520
PSACPULA EQU   PSA+518
PSACPUPA EQU   PSA+516
PSAPSA   EQU   PSA+512
FLCHDEND EQU   PSA+512
FLCCRSAV EQU   FLCMCLA+280
FLCGRSAV EQU   FLCMCLA+216
FLCFPSAV EQU   FLCMCLA+184
FLCFLA   EQU   FLCMCLA+88
FLCRGNCD EQU   FLCMCLA+84
FLCFSAA  EQU   FLCFSA+1
@NM00109 EQU   FLCFSA
@NM00108 EQU   FLCMCLA+72
FLCMCIC  EQU   FLCMCLA+64
@NM00107 EQU   FLCMCLA+20
FLCIOAA  EQU   FLCIOA+1
@NM00106 EQU   FLCIOA
@NM00105 EQU   FLCMCLA+15
@NM00104 EQU   FLCMCLA+14
@NM00103 EQU   FLCMCLA+12
FLCLCL   EQU   FLCMCLA+8
FLCIOELA EQU   FLCIOEL+1
@NM00102 EQU   FLCIOEL
FLCCHNID EQU   FLCMCLA
@NM00101 EQU   PSA+160
FLCMTRCD EQU   PSA+157
@NM00100 EQU   PSA+156
FLCPERA  EQU   FLCPER+1
@NM00099 EQU   FLCPER
@NM00098 EQU   PSA+151
FLCPERCD EQU   PSA+150
FLCMCNUM EQU   PSA+149
@NM00097 EQU   PSA+148
FLCTEAA  EQU   FLCTEA+1
@NM00096 EQU   FLCTEA
PSAPIPC  EQU   PSAPICOD
PSAPIMC  EQU   PSAPICOD
PSAPIPER EQU   PSAPICOD
PSARV049 EQU   FLCPICOD
FLCPILCB EQU   FLCPIILC
@NM00095 EQU   FLCPIILC
@NM00094 EQU   PSAEPPSW
FLCSVCN  EQU   PSAESPSW+2
FLCSILCB EQU   FLCSVILC
@NM00093 EQU   FLCSVILC
@NM00092 EQU   PSAESPSW
FLCEICOD EQU   PSAEEPSW+2
PSASPAD  EQU   PSAEEPSW
@NM00091 EQU   PSA+128
FLCINPSW EQU   PSA+120
FLCMNPSW EQU   PSA+112
FLCPNPSW EQU   PSA+104
FLCSNPSW EQU   PSA+96
FLCENPSW EQU   PSA+88
FLCTRACE EQU   PSA+84
FLCTIMER EQU   PSA+80
FLCCVT2  EQU   PSA+76
FLCCAW   EQU   PSA+72
FLCCSW   EQU   PSA+64
FLCIOPSW EQU   PSA+56
FLCMOPSW EQU   PSA+48
FLCPOPSW EQU   PSA+40
FLCSOPSW EQU   PSA+32
FLCEOPSW EQU   PSA+24
@NM00090 EQU   FLCICCW2+4
FLCCVT   EQU   FLCICCW2
FLCICCW1 EQU   FLCROPSW
FLCIPPSW EQU   FLCRNPSW
*                                      END UNREFERENCED COMPONENTS
@RF00139 EQU   @RC00133
@ENDDATA EQU   *
         END   IEAVEEER
