         TITLE 'IEAVEUPC - IPC SIGNAL SERVICE ROUTINE'
*/*IEAVEUPC: CHART IPC SIGNAL SERVICE ROUTINE */
*/* HEADER
*/*
*/*
*/*
*/*                                                  ID: 3.1.7.13.10.1
*/* IPC SIGNAL SERVICE ROUTINE
*/*                                                  PAGE # */
*/*IEAVEUPC: E (,%MAIN) IEAVEDR */
*/* E (,%MAIN) IEAVERI */
*/* E (,%MAIN) IEAVERP */
*/*%MAIN: P LOAD REG 15 WITH UNI-PROCESSOR RETURN CODE */
*/* R RETURN BR 14 */
*/* FOOTING
*/*
*/*  */
*/*IEAVEUPC: END IPC SIGNAL SERVICE ROUTINE */
*MODULE NAME= IEAVEUPC
*
*DESCRIPTIVE NAME= INTERPROCESSOR COMMUNICATION  SIGNAL ROUTINE
*
*COPYRIGHT= N/A
*
*STATUS= REL. 02.0
*
*FUNCTION= THIS ROUTINE IS INCLUDE IN THE SYSTEM WHENEVER THE
*          SYSTEM IS GENERATED WITH THE 'ACRCODE=NO' OPTION.
*          THE SYSTEM THUS DEFAULTS TO A UNI-PROCESSOR SYSTEM.
*          ANY CALLER OF ANY IPC FUNCTION, IEAVEDR, IEAVERI, OR
*          IEAVERP WILL BE GIVEN THE PROPER RETURN CODE, 16,
*          INDICATING A UNI-PROCESSOR SYSTEM.
*
*  OPERATION= THIS ROUTINE IS ENTERED FOR ANY CALLS OF IEAVEDR,
*             IEAVERI, OR IEAVERP.  A RETURN CODE OF 16 WILL BE
*             PLACED IN REGISTER 15 AND CONTROL WILL BE RETURNED
*             TO THE CALLER VIA BR 14.
*
*NOTES
*  DEPENDENCIES=  NONE.
*    CHARACTER-CODE DEPENDENCIES= NONE
*  RESTRICTIONS=NONE.
*  REGISTER-CONVENTIONS= REFERENCE EQUATE SECTION
*  PATCH-LABEL= NONE, THIS IS A RESIDENT NUCLEUS MODULE.
*
*MODULE TYPE= PROCEDURE
*  PROCESSOR= ASSEM
*  MODULE SIZE= N/A
*  ATTRIBUTES= NUCLEUS,ZERO PROTECT KEY,REFRESHABLE,
*              SUPERVISOR MODE,ADDRSPC=FIXED.
*
*ENTRY POINT= IEAVEDR, IEAVERI AND IEAVERP.
*  PURPOSE= TO SIGNAL ANOTHER OR ONES OWN CPU.
*  LINKAGE= THE DSGNL, RPSGNL AND RISGNL MACROS EXPAND INTO A BAL 14,15
*  INPUT= REGISTER 1 - CONTAINS THE PCCA ADDRESS.
*         REGISTER 0 - CONTAINS THE REQUESTED ORDER CODE.
*         REGISTER 14 - CONTAINS THE RETURN ADDRESS.
*         REGISTER 15 - CONTAINS THE ENTRY POINT ADDRESS.
*         NOTE: FOR IEAVERI ONLY..
*         REGISTER 11 - CONTAINS THE PARAMETER ADDRESS..
*         REGISTER 12 - CONTAINS THE SERVICE RTN'S ENTRY POINT ADDRESS.
*  REGISTERS SAVED= NONE.
*  REGISTER USAGE= REGISTER 14 IS RETURN REGISTER.
*                  REGISTER 15 IS RETURN CODE REGISTER.
*  REGISTERS RESTORED= NONE.
*
*EXIT - NORMAL= IEAVEDR, IEAVERI AND IEAVERP.
*  CONDITIONS= BECAUSE THE SYSTEM HAS BEEN SYSGENED AS A
*             UNIPROCESSOR, NO FUNCTION IS PERFORMED..
*  OUTPUT= A RETURN CODE OF 16 IS RETURNED TO CALLER.
*  RETURN CODES= AS LISTED BELOW.
*  R.C. - 16 - SIGP FUNCTION UNSUCCESSFUL.  CPU IS AN UNIPROCESSOR
*              AND DOES NOT HAVE SIGP SENDING AND RECEIVING
*              CAPABILITIES.
*
*EXIT - ERROR= NONE.
*  RETURN CODES= NONE.
*
*EXTERNAL REFERENCES=
*  ROUTINES= NONE
*  DATA AREAS= NONE.
*  CONTROL BLOCKS= NONE.
*
*TABLES= NONE.
*
*MACROS= NONE.
*  SERIALIZATION= NONE.
*
*CHANGE ACTIVITY= N/A
*
*MESSAGES= XXXXXXX - MSG. TEXT
*
*ABEND CODES= NONE.
*
***********************************************************************
IEAVEUPC CSECT
R14      EQU   14                  RETURN REGISTER
R15      EQU   15                  RETURN CODE REGISTER
RC16     EQU   16                  UNI-PROCESSOR RETURN CODE
         ENTRY IEAVEDR
         ENTRY IEAVERI
         ENTRY IEAVERP
IEAVEDR  DC    0H'0'
IEAVERI  DC    0H'0'
IEAVERP  DC    0H'0'
         LA    R15,RC16            SET RET CODE 16 - UNI-PROCESSOR
         BR    R14                 RETURN TO CALLER
         END   IEAVEUPC
