         TITLE 'IEAVIOCP--PAGE I/O COMPLETION PROCESSOR                *
                        '
IEAVIOCP CSECT
         USING *,15                REG 15 CONTAINS ENTRY PT. ADDR
         MODID BRANCH=NO
IEAVIOC2 DS    0H
         ENTRY IEAVIOC2
         BALR  CPBASE10,0
         USING *,CPBASE10
*   PVTPTR=CVTPVTP;                 /* GET THE ADDR OF PVT IN REG 3  */
         L     @12,CVTPTR                                          0067
         L     PVTPTR,CVTPVTP(,@12)                                0067
*   GENERATE REFS(PVTPRCV,CPWRKRG4,CPWRKRG5) SETS(RCAPTR);         0068
LBGETFRR SETFRR A,FRRAD=PVTPRCV(PVTPTR),PARMAD=(RCAPTR),              **
               WRKREGS=(CPWRKRG4,CPWRKRG5),                           **
               RELATED=(RSM,IEAVIOCP(LBFREFRR))
*   RCACSECT=RCACCOMP;              /* SET CSECT ID IN RCA           */
         MVI   RCACSECT(RCAPTR),X'14'                              0069
*   RCAIOCP='1'B;                   /* SET IEAVIOCP ENTRY POINT FLAG */
         OI    RCAIOCP(RCAPTR),B'10000000'                         0070
*   RESPECIFY                                                      0071
*     CPWRKRG5 RESTRICTED;                                         0071
*   CPWRKRG5=CPARMRG1;              /* SAVE INPUT PARM ACCROSS     0072
*                                      FREEING OF SRB                */
         LR    CPWRKRG5,CPARMRG1                                   0072
*   CPARMRG1=CPARMRG0;              /* TRANSFER SRB ADDR TO REG 1    */
         LR    CPARMRG1,CPARMRG0                                   0073
*   CPARMRG0=PVTSRBID;              /* PLACE CELL POOL ID IN REG 0   */
         L     CPARMRG0,PVTSRBID(,PVTPTR)                          0074
*   GEN(FREECELL CPID=(0),CELL=(1),BRANCH=YES,SAVE=NO)             0075
*   REFS(CPARMRG0,CPARMRG1);        /* RETURN SRB TO CELL POOL. THIS
*                                      MACRO DESTROYS REGISTERS    0075
*                                      0-4,14,15                     */
         FREECELL CPID=(0),CELL=(1),BRANCH=YES,SAVE=NO
*   PVTPTR=CVTPVTP;                 /* RESTORE PVT REGISTER          */
         L     @12,CVTPTR                                          0076
         L     PVTPTR,CVTPVTP(,@12)                                0076
*   RESPECIFY                                                      0077
*    (CPARMRG0,                                                    0077
*     CPARMRG1) UNRESTRICTED;                                      0077
*   IF CPWRKRG5^=0 THEN             /* IF INPUT PARM NOT 0, ASK FOR
*                                      LOCAL LOCK UNCONDITIONALLY    */
         LTR   CPWRKRG5,CPWRKRG5                                   0078
         BZ    @RF00078                                            0078
*     DO;                                                          0079
*       GENERATE;                                                  0080
LBGETLL1 SETLOCK OBTAIN,TYPE=LOCAL,MODE=UNCOND,                       **
               RELATED=(RSM,IEAVIOCP(LBFREELL))
*       RCALL='1'B;                 /* THE LOCAL LOCK HAS BEEN     0081
*                                      OBTAINED WHEN AND IF THIS   0081
*                                      INSTRUCTION IS EXECUTED       */
         OI    RCALL(RCAPTR),B'01000000'                           0081
*     END;                                                         0082
*   ELSE                                                           0083
*     ;                             /* OTHERWISE, NO LOCK REQUIRED   */
@RF00078 DS    0H                                                  0084
*   GENERATE;                                                      0084
LBGTSALC SETLOCK OBTAIN,TYPE=SALLOC,MODE=UNCOND,                      **
               RELATED=(RSM,IEAVIOCP(LBFRSALC))
*   RCASAL='1'B;                    /* IF THIS MODULE REMAINS IN   0085
*                                      CONTROL, THE SALLOC LOCK HAS
*                                      BEEN OBTAINED.                */
         OI    RCASAL(RCAPTR),B'10000000'                          0085
*   PVTPRCA=RCAPTR;                 /* THE RCA ADDR IS STORED IN PVT */
         ST    RCAPTR,PVTPRCA(,PVTPTR)                             0086
*   RSMHDPTR=ASCBRSM;               /* REG 2 IS INITIALIZED WITH THE
*                                      CORRECT RSM HEADER ADDRESS    */
         L     @12,ASCBPTR                                         0087
         L     RSMHDPTR,ASCBRSM(,@12)                              0087
*   CPFLAGS=CPINITFL;               /* THE INTERNAL FLAGS ARE SET OFF*/
         MVI   CPFLAGS(PVTPTR),X'00'                               0088
*   IF CPWRKRG5^=0 THEN             /* IF THE LOCAL LOCK WAS       0089
*                                      OBTAINED, THE INTERNAL LOCAL
*                                      LOCK HELD FLAG IS SET AND THE
*                                      OBTAIN LOCAL LOCK FLAG IN   0089
*                                      RSMHD IS RESET                */
         LTR   CPWRKRG5,CPWRKRG5                                   0089
         BZ    @RF00089                                            0089
*     DO;                                                          0090
*       CPLLHELD='1'B;                                             0091
         OI    CPLLHELD(PVTPTR),B'10000000'                        0091
*       RSMIOCPU='0'B;                                             0092
         NI    RSMIOCPU(RSMHDPTR),B'01111111'                      0092
*     END;                                                         0093
*   ELSE                            /* OTHERWISE, THE LOCAL LOCK WAS
*                                      NOT REQUESTED AND THE RUN   0094
*                                      WITHOUT LOCAL LOCK FLAG IN  0094
*                                      RSMHD IS RESET                */
*     DO;                                                          0094
         B     @RC00089                                            0094
@RF00089 DS    0H                                                  0095
*       RSMIOCPC='0'B;                                             0095
         NI    RSMIOCPC(RSMHDPTR),B'10111111'                      0095
*     END;                                                         0096
*   RESPECIFY                                                      0097
*     CPWRKRG5 UNRESTRICTED;                                       0097
@RC00089 DS    0H                                                  0098
*                                                                  0098
*   /*****************************************************************/
*   /*                                                               */
*   /* THIS SECOND SEGMENT CALLS THE SQSEARCH SUBROUTINE TO PROCESS  */
*   /* ANY AND ALL PCB'S THAT CAN BE PROCESSED ON THIS CALL TO THE   */
*   /* MODULE. ANY RETURN CODE SET BY PCB PROCESSING IS IGNORED. THE */
*   /* LOCKS OBTAINED IN THE FIRST SEGMENT ARE FREED, THE RECOVERY   */
*   /* ENVIRONMENT CANCELLED AND EXIT MADE TO THE DISPATCHER USING   */
*   /* THE RETURN ADDRESS PROVIDED IN THE CVT.                       */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0098
*   CALL SQSEARCH;                  /* THE SQSEARCH SUBRTN. IS CALLED*/
         BAL   @14,SQSEARCH                                        0098
*   GENERATE;                                                      0099
LBFRSALC SETLOCK RELEASE,TYPE=SALLOC,                                 **
               RELATED=(RSM,IEAVIOCP(LBGTSALC))
*   IF RCALL='1'B THEN              /* IF THE LOCAL LOCK WAS       0100
*                                      OBTAINED, FREE IT.            */
         TM    RCALL(RCAPTR),B'01000000'                           0100
         BNO   @RF00100                                            0100
*     GENERATE;                                                    0101
LBFREELL SETLOCK RELEASE,TYPE=LOCAL,                                  **
               RELATED=(RSM,IEAVIOCP(LBGETLL1))
*   ELSE                                                           0102
*     ;                             /* DO NOTHING IF LOCAL LOCK NOT
*                                      REQUESTED                     */
@RF00100 DS    0H                                                  0103
*   GENERATE REFS(CPWRKRG4,CPWRKRG5);                              0103
LBFREFRR SETFRR D,WRKREGS=(CPWRKRG4,CPWRKRG5),                        **
               RELATED=(RSM,IEAVIOCP(LBGETFRR))
*   CPRETREG=CVTSRBRT;              /* GET EXIT ADDR FROM CVT        */
         L     @12,CVTPTR                                          0104
         L     CPRETREG,CVTSRBRT(,@12)                             0104
*   GOTO CPRETREG;                  /* EXIT TO THE DISPATCHER        */
         BR    CPRETREG                                            0105
*                                                                  0106
*   /*****************************************************************/
*   /*                                                               */
*   /* THE SQSEARCH SUBROUTINE IS CALLED FROM BOTH ENTRY POINTS. ITS */
*   /* ONLY JOB IS TO FIND PCB'S ON THE LOCAL I/O ACTIVE Q FOR THE   */
*   /* CURRENT ADDRESS SPACE OR THE COMMON I/O ACTIVE Q THAT HAVE    */
*   /* BEEN MARKED I/O COMPLETE AND PASS THESE PCB'S TO THE SUBNORML */
*   /* OR SUBIOERR SUBROUTINES. THE QUEUES ARE SEARCHED USING THE    */
*   /* BACK POINTERS OF EACH PCB BECAUSE PROCESSING OF A PCB MAY     */
*   /* CAUSE A RELATED PCB TO BE ENQUEUED TO THE END OF THE Q BEING  */
*   /* PROCESSED. BY FOLLOWING THE BACK Q POINTERS, WE ARE ASSURED OF*/
*   /* NOT PROCESSING NEWLY ENQUEUED PCB'S AGAIN AFTER THEY HAVE     */
*   /* ALREADY BEEN PROCESSED.                                       */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0106
*SQSEARCH:                                                         0106
*   PROC OPTIONS(NOSAVE NOSAVEAREA);                               0106
SQSEARCH DS    0H                                                  0107
*   CPSBRET1=CPRETREG;              /* SAVE THE RETURN ADDRESS       */
         ST    CPRETREG,CPSBRET1(,PVTPTR)                          0107
*   PCBPTR=RSMLIOQL;                /* INIT THE PCB REG WITH THE ADDR
*                                      OF THE LAST PCB ON THE LOCAL
*                                      I/O ACTIVE QUEUE.             */
         L     PCBPTR,RSMLIOQL(,RSMHDPTR)                          0108
*   DO WHILE(PCBPTR^=0);            /* PROCESS ALL PCB'S ON Q MARKED
*                                      I/O COMPLETE                  */
         B     @DE00109                                            0109
@DL00109 DS    0H                                                  0110
*     IF PCBIOCMP='1'B THEN         /* IS I/O COMPLETE FOR PCB       */
         TM    PCBIOCMP(PCBPTR),B'00000001'                        0110
         BNO   @RF00110                                            0110
*       DO;                         /* YES                           */
*         CPBAKSAV=PCBBQPA;         /* SAVE BACK PTR TO NEXT PCB     */
         L     @12,PCBBQPA(,PCBPTR)                                0112
         ST    @12,CPBAKSAV(,PVTPTR)                               0112
*         IF PCBIOERR='0'B THEN     /* CALL THE I/O ERROR OR NORMAL
*                                      PCB PROCESSOR SUBROUTINE    0113
*                                      ACCORDING TO THE I/O ERROR PCB
*                                      FLAG                          */
         TM    PCBIOERR(PCBPTR),B'00100000'                        0113
         BNZ   @RF00113                                            0113
*           CALL SUBNORML;          /* NORMAL PROCESSOR GETS CONTROL */
         BAL   @14,SUBNORML                                        0114
*         ELSE                      /* I/O ERROR OCCURRED            */
*           CALL SUBIOERR;          /* ERROR PROCESSOR GETS CONTROL  */
         B     @RC00113                                            0115
@RF00113 BAL   @14,SUBIOERR                                        0115
*         PCBPTR=CPBAKSAV;          /* PREPARE FOR NEXT PCB          */
@RC00113 L     PCBPTR,CPBAKSAV(,PVTPTR)                            0116
*       END;                                                       0117
*     ELSE                          /* IF I/O IS NOT COMPLETE FOR  0118
*                                      PCB, GET ADDR OF NEXT PCB TO
*                                      PROCESS                       */
*       PCBPTR=PCBBQPA;                                            0118
         B     @RC00110                                            0118
@RF00110 L     PCBPTR,PCBBQPA(,PCBPTR)                             0118
*   END;                            /* END LOCAL Q DO WHILE          */
@RC00110 DS    0H                                                  0119
@DE00109 LTR   PCBPTR,PCBPTR                                       0119
         BNZ   @DL00109                                            0119
*   PCBPTR=PVTCIOQL;                /* ONCE THE LOCAL Q IS PROCESSED,
*                                      GET THE ADDR OF THE LAST PCB
*                                      ON THE COMMON I/O Q AND     0120
*                                      PROCESS THAT Q                */
         L     PCBPTR,PVTCIOQL(,PVTPTR)                            0120
*   DO WHILE(PCBPTR^=0);            /* PROCESS THOSE PCB'S THAT ARE
*                                      FOR THE ADDRESS SPACE WE ARE
*                                      RUNNING IN AND ARE MARKED I/O
*                                      COMPLETE                      */
         B     @DE00121                                            0121
@DL00121 DS    0H                                                  0122
*     IF PCBASCB=PSAAOLD&PCBIOCMP='1'B THEN/* PCB FOR CURRENT A.S. 0122
*                                      AND I/O COMPLETE              */
         CLC   PCBASCB(4,PCBPTR),PSAAOLD                           0122
         BNE   @RF00122                                            0122
         TM    PCBIOCMP(PCBPTR),B'00000001'                        0122
         BNO   @RF00122                                            0122
*       DO;                         /* YES                           */
*         CPBAKSAV=PCBBQPA;         /* SAVE BACK PTR TO NEXT PCB     */
         L     @12,PCBBQPA(,PCBPTR)                                0124
         ST    @12,CPBAKSAV(,PVTPTR)                               0124
*         IF PCBIOERR='0'B THEN     /* CALL THE I/O ERROR OR NORMAL
*                                      PCB PROCESSOR SUBROUTINE    0125
*                                      ACCORDING TO THE I/O ERROR PCB
*                                      FLAG                          */
         TM    PCBIOERR(PCBPTR),B'00100000'                        0125
         BNZ   @RF00125                                            0125
*           CALL SUBNORML;          /* NORMAL PROCESSOR GETS CONTROL */
         BAL   @14,SUBNORML                                        0126
*         ELSE                      /* I/O ERROR OCCURRED            */
*           CALL SUBIOERR;          /* ERROR PROCESSOR GETS CONTROL  */
         B     @RC00125                                            0127
@RF00125 BAL   @14,SUBIOERR                                        0127
*         PCBPTR=CPBAKSAV;          /* PREPARE FOR NEXT PCB          */
@RC00125 L     PCBPTR,CPBAKSAV(,PVTPTR)                            0128
*       END;                                                       0129
*     ELSE                          /* OTHERWISE, GET ADDR OF NEXT 0130
*                                      PCB TO PROCESS                */
*       PCBPTR=PCBBQPA;                                            0130
         B     @RC00122                                            0130
@RF00122 L     PCBPTR,PCBBQPA(,PCBPTR)                             0130
*   END;                            /* END COMMON Q DO WHILE         */
@RC00122 DS    0H                                                  0131
@DE00121 LTR   PCBPTR,PCBPTR                                       0131
         BNZ   @DL00121                                            0131
*   CPRETREG=CPSBRET1;              /* RESTORE RETURN ADDRESS AND  0132
*                                      RETURN TO THE CALLER WHEN BOTH
*                                      QUEUES HAVE BEEN PROCESSED    */
         L     CPRETREG,CPSBRET1(,PVTPTR)                          0132
*   END;                            /* END QSEARCH INTERNAL PROC     */
@EL00002 DS    0H                                                  0133
@EF00002 DS    0H                                                  0133
@ER00002 BR    @14                                                 0133
*                                                                  0134
*   /*****************************************************************/
*   /*                                                               */
*   /* THE SUBNORML SUBROUTINE IS CALLED BY THE SQSEARCH SUBROUTINE. */
*   /* IT PROCESSES ALL PCB'S FOR WHICH I/O HAS COMPLETED            */
*   /* SUCCESSFULLY. THE INPUT PCB ADDRESS IS PASSED IN THE STANDARD */
*   /* PCB REGISTER FOR THIS MODULE. FIRST, ANY SPECIAL SWAP-IN      */
*   /* PROCESSING IS PERFORMED IF NECESSARY TO NORMALIZE THE PGTE FOR*/
*   /* ALL PROCESSING BELOW. FOR STAGE 2 SWAP-IN PCB'S, THE CORRECT  */
*   /* RBN IS PLACED IN THE PGTE FOR THE PAGE AND THE FORCE RELATE   */
*   /* FLAG RESET IN THE XPTE. NOTE THAT THIS DONE ONLY FOR PCB'S    */
*   /* WITH NON-ZERO VBN'S AND THE FREE REAL FLAG OFF AS THAT IS THE */
*   /* ONLY TIME THE PGTE/XPTE ADDRESSES IN THE PCB ARE VALID. NOTE  */
*   /* ALSO THAT STAGE 2 PCB'S CAN APPEAR ONLY AS QUEUED PCB'S, NEVER*/
*   /* AS RELATED PCB'S. THE SWAP-IN TEST ASSUMES IEAVPIOP REMOVES   */
*   /* ALL STAGE 1 PCB'S FROM A Q AS SOON AS THEIR PAGE-IN COMPLETES.*/
*   /* ONCE PGTE NORMALIZATION IS COMPLETE, ANY AND ALL RELATED PCB'S*/
*   /* ARE PROCESSED FIRST BY CALLING THE SPCBNORM SUBROUTINE FOR    */
*   /* EACH PCB. UPON RETURN, IF A PCB IS NOT TO BE FREED, IT IS     */
*   /* REMOVED FROM ITS RELATED Q AND SENT TO THE I/O ACTIVE Q ITS   */
*   /* PRIMARY PCB (INPUT PCB) IS ON. THE VBN FIELD IN THE PCB IS SET*/
*   /* TO ZERO AND THE FREE REAL FRAME FLAG TURNED OFF AS IT NO      */
*   /* LONGER HAS ANY MEANING. PIOCP IS SCHEDULED TO RUN AT A LATER  */
*   /* TIME WHEN THE LOCAL LOCK CAN BE OBTAINED BY CALLING A         */
*   /* SUBROUTINE OF PIOP. THIS SUBROUTINE ASSURES THAT MULTIPLE     */
*   /* SCHEDULES ARE NOT PERFORMED WHERE NOT NECESSARY. OTHERWISE,   */
*   /* THE RELATED PCB IS RETURNED TO THE FREE Q. PROCESSING         */
*   /* CONTINUES AT THE NEXT SEGMENT WITH THE PRIMARY PCB. NOTE THAT */
*   /* UNQUEUED PCB'S PASSED ON A BRANCH ENTRY (IEAVCPBR) MUST SET   */
*   /* PCB'S TO ALWAYS ALLOW THE PCB TO BE DISPOSED OF AS STATED IN  */
*   /* THE DEPENDENCY SECTION OF THE PROLOGUE.                       */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0134
*SUBNORML:                                                         0134
*   PROC OPTIONS(NOSAVE NOSAVEAREA);                               0134
SUBNORML DS    0H                                                  0135
*   CPSBRET2=CPRETREG;              /* SAVE THE RETURN ADDRESS       */
*                                                                  0135
         ST    CPRETREG,CPSBRET2(,PVTPTR)                          0135
*   /*****************************************************************/
*   /*                                                               */
*   /* WHEN THE PCB TRACE IS ACTIVE, THE BRANCH INSTRUCTION BELOW    */
*   /* MUST BE NOOPED                                        @Z40WPYD*/
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0136
*TRACEZC1:                                                         0136
*   GENERATE REFS(PCBPTR) SETS(CPWRKRG5);                          0136
TRACEZC1 DS    0H                                                  0136
         B     TRACEZC1+16
         L     CPWRKRG5,64(PCBPTR)
*   CPWRKRG5=CPWRKRG5+MYID;                                        0137
         AL    CPWRKRG5,@CF02093                                   0137
*   GENERATE;                                                      0138
         ST    CPWRKRG5,64(PCBPTR)
*   IF PCBSWPS2='1'B&PCBFREAL='0'B&PCBVBN^=0 THEN/* IS PCB FOR STAGE
*                                      2 SWAP-IN AND UNPURGED      0139
*                                                            @Z40WPYD*/
         TM    PCBSWPS2(PCBPTR),B'00000001'                        0139
         BNO   @RF00139                                            0139
         TM    PCBFREAL(PCBPTR),B'10000000'                        0139
         BNZ   @RF00139                                            0139
         LH    @12,PCBVBN(,PCBPTR)                                 0139
         N     @12,@CF02180                                        0139
         LTR   @12,@12                                             0139
         BZ    @RF00139                                            0139
*     DO;                           /* YES                           */
*       PGTRSA=CPGTFLGS;            /* THE PGTE IS INITIALIZED TO  0141
*                                      ZERO, INVALID, AND GETMAIN  0141
*                                      ASSIGNED                      */
         L     @12,PTEPTR(,PCBPTR)                                 0141
         MVC   PGTRSA(2,@12),@CB02091                              0141
*       PGTRSA=PGTRSA|PCBRBN;       /* THE REMAINDER OF THE PGTE IS
*                                      THEN SET EQUAL TO THE PCBRBN
*                                      FIELD                         */
         OC    PGTRSA(2,@12),PCBRBN(PCBPTR)                        0142
*     END;                                                         0143
*   ELSE                                                           0144
*     ;                             /* DO NOTHING IF PCB IS NOT    0144
*                                      SWAP-IN OR SWAP-IN PCB WAS  0144
*                                      PURGED                        */
@RF00139 DS    0H                                                  0145
*   CPFREREL='1'B;                  /* SET INTERNAL FLAG TO FREE   0145
*                                      FRAME VALUE                   */
         OI    CPFREREL(PVTPTR),B'00100000'                        0145
*   DO WHILE(PCBRLPA^=0);           /* PROCESS EACH RELATED PCB      */
         B     @DE00146                                            0146
@DL00146 DS    0H                                                  0147
*     RESPECIFY                                                    0147
*       CPCURPCB RESTRICTED;        /* THIS REG WILL BE THE PARM REG
*                                      FOR CPNORMP                   */
*     CPCURPCB=PCBRLPA;             /* INIT PARM REG FOR CPNORMP     */
         L     CPCURPCB,PCBRLPA-1(,PCBPTR)                         0148
         LA    CPCURPCB,0(,CPCURPCB)                               0148
*     CALL SPCBNORM;                /* PROCESS A RELATED PCB         */
         BAL   @14,SPCBNORM                                        0149
*     PCBRLPA=CPCURPCB->PCBRLPA;    /* REMOVE PROCESSED PCB FROM THE
*                                      RELATED CHAIN.                */
         MVC   PCBRLPA(3,PCBPTR),PCBRLPA(CPCURPCB)                 0150
*     CPCURPCB->PCBFQP=CPRPFRST;    /* RESET THE FIRST WORD OF THE 0151
*                                      RELATED PCB TO ZERO WITH A Q
*                                      NUMBER INDICATING THE UNQUEUED
*                                      STATE                         */
         L     @12,CPRPFRST                                        0151
         ST    @12,PCBFQP(,CPCURPCB)                               0151
*     RESPECIFY                                                    0152
*      (CPARMRG0,                                                  0152
*       CPARMRG1) RESTRICTED;                                      0152
*     IF CPKEEPCB='1'B THEN         /* IF THE PCB IS TO BE KEPT,   0153
*                                      SCHEDULE PIOCP TO RUN LATER 0153
*                                      AND SET THE TO Q NUMBER FOR 0153
*                                      PCB MANAGER TO THE Q NUMBER IN
*                                      THE PRIMARY PCB               */
         TM    CPKEEPCB(PVTPTR),B'01000000'                        0153
         BNO   @RF00153                                            0153
*       DO;                                                        0154
*         CPCURPCB->PCBVBN=0;       /* ZERO THE PCBVBN SO PFTE AND 0155
*                                      PGTE PROCESSING WON'T BE    0155
*                                      ATTEMPTED AGAIN BY THIS     0155
*                                      MODULE.                       */
         SLR   @12,@12                                             0155
         STH   @12,PCBVBN(,CPCURPCB)                               0155
*         CPCURPCB->PCBFREAL='0'B;  /* THIS FLAG NO LONGER HAS     0156
*                                      MEANING                       */
         NI    PCBFREAL(CPCURPCB),B'01111111'                      0156
*         CPCURPCB->PCBRLPA=0;      /* ZERO THE RELATED PTR IN THE 0157
*                                      PCB TO BE ENQUEUED TO AN I/O
*                                      Q.                            */
         STCM  @12,7,PCBRLPA(CPCURPCB)                             0157
*         CPARMRG1=CPCURPCB;        /* SET UP PARM FOR SCHED SUBRTN. */
         LR    CPARMRG1,CPCURPCB                                   0158
*         CALL EPSCHED;             /* CALL SCHEDULE SUBRTN OF PIOP  */
         L     @15,PVTPOPBR(,PVTPTR)                               0159
         BALR  @14,@15                                             0159
*         CPARMRG0=PCBCQN;          /* INIT Q NUMBER PARM TO PCB MGR */
         SLR   CPARMRG0,CPARMRG0                                   0160
         IC    CPARMRG0,PCBCQN(,PCBPTR)                            0160
*       END;                                                       0161
*     ELSE                          /* OTHERWISE, SET Q NUMBER FOR 0162
*                                      THE FREE Q                    */
*       DO;                                                        0162
         B     @RC00153                                            0162
@RF00153 DS    0H                                                  0163
*         CPARMRG0=PCBFREQN;                                       0163
         LA    CPARMRG0,16                                         0163
*       END;                                                       0164
*     CPARMRG1=CPCURPCB;            /* SET REG 1 FOR CALL            */
@RC00153 LR    CPARMRG1,CPCURPCB                                   0165
*     CALL EPPCBMGR;                /* CALL THE PCB MANAGER TO PLACE
*                                      THE PCB ON THE PROPER Q       */
         L     @15,PVTPCB(,PVTPTR)                                 0166
         BALR  @14,@15                                             0166
*     RESPECIFY                                                    0167
*      (CPARMRG0,                                                  0167
*       CPARMRG1) UNRESTRICTED;                                    0167
*   END;                            /* END THE RELATED PCB DO WHILE  */
@DE00146 L     @12,PCBRLPA-1(,PCBPTR)                              0168
         LA    @12,0(,@12)                                         0168
         LTR   @12,@12                                             0168
         BNZ   @DL00146                                            0168
*                                                                  0169
*   /*****************************************************************/
*   /*                                                               */
*   /* THIS SEGMENT PROCESSES THE INPUT PCB ONCE ALL RELATED PCB'S   */
*   /* HAVE BEEN PROCESSED. THE SPCBNORM SUBROUTINE IS CALLED TO     */
*   /* PROCESS THIS PCB. ONCE ALL PCB'S HAVE BEEN PROCESSED, THE     */
*   /* DISPOSITION OF THE REAL FRAME ASSIGNED TO THE VIRTUAL PAGE    */
*   /* REPRESENTED IN THE PCB IS DETERMINED. IF THE INTERNAL FLAG IS */
*   /* SET TO FREE THE REAL FRAME, IT IS FREED BY SENDING IT TO THE  */
*   /* AVAILABLE FRAME QUEUE (AFQ). THE PROPER FRAME COUNT IS ALSO   */
*   /* DECREMENTED. OTHERWISE, THE VIRTUAL PAGE HAS BEEN VALIDATED.  */
*   /* IF THE PAGE HAS BEEN VALIDATED, ALL PGTE AND STORAGE KEY      */
*   /* SETTING HAS BEEN DONE IN SPCBNORM. NOTE THAT THE PAGE MAY     */
*   /* ALREADY BE VALID ON ENTRY TO THIS MODULE. IN THIS CASE, THE   */
*   /* VBN IN THE PCB WAS ZERO AND THE PCBFREAL FLAG WAS OFF CAUSING */
*   /* THE INTERNAL FREE REAL FLAG TO BE TURNED OFF.                 */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0169
*   CPCURPCB=PCBPTR;                /* SET PARM REG FOR CPNORMP      */
         LR    CPCURPCB,PCBPTR                                     0169
*   CALL SPCBNORM;                  /* PROCESS THE PRIMARY PCB       */
         BAL   @14,SPCBNORM                                        0170
*   RESPECIFY                                                      0171
*     CPCURPCB UNRESTRICTED;                                       0171
*   IF CPFREREL='1'B THEN           /* IS FRAME FOR PCB TO BE FREED  */
         TM    CPFREREL(PVTPTR),B'00100000'                        0172
         BNO   @RF00172                                            0172
*     DO;                           /* YES                           */
*       RESPECIFY                                                  0174
*         PFTEPTR RESTRICTED;                                      0174
*       PFTEPTR=PVTPFTP+PCBRBN;     /* OBTAIN THE ADDRESS OF THE PFTE
*                                      ASSIGNED TO THE VIRTUAL PAGE  */
         LH    @12,PCBRBN(,PCBPTR)                                 0175
         N     @12,@CF02180                                        0175
         L     PFTEPTR,PVTPFTP(,PVTPTR)                            0175
         ALR   PFTEPTR,@12                                         0175
*       PFTPCBSI='0'B;              /* TURN OFF THE PCB DEFINED FLAG */
         NI    PFTPCBSI(PFTEPTR),B'11110111'                       0176
*       RESPECIFY                                                  0177
*         PFTEPTR UNRESTRICTED;                                    0177
*       CPHI2BYT=CPINITHI;          /* THE PFTE IS FREED. PARM REG 0
*                                      IS CONSTRUCTED IN THE WORK  0178
*                                      AREA TO SEND THE PFTE TO THE
*                                      FRONT OF THE AFQ              */
         LH    @11,CPINITHI                                        0178
         N     @11,@CF02180                                        0178
         STH   @11,CPHI2BYT(,PVTPTR)                               0178
*       CPRBNPRM=PCBRBN;            /* THE PFTE INDEX IS PLACED IN 0179
*                                      THE LOW 2 BYTES OF REG 0      */
         STH   @12,CPRBNPRM(,PVTPTR)                               0179
*       RESPECIFY                                                  0180
*        (CPARMRG0,                                                0180
*         CPARMRG1) RESTRICTED;                                    0180
*       CPARMRG0=CPENQDEQ;          /* REG 0 IS INITIALIZED FROM THE
*                                      WORK AREA                     */
         L     CPARMRG0,CPENQDEQ(,PVTPTR)                          0181
*       CPARMRG1=PSAAOLD;           /* REG 1 CONTAINS THE ASCB ADDR
*                                      FOR THE CURRENT ADDRESS SPACE */
         L     CPARMRG1,PSAAOLD                                    0182
*       CALL EPFTENDQ;              /* PFTE ENQ/DEQ IS CALLED        */
         L     @15,PVTPFTE(,PVTPTR)                                0183
         BALR  @14,@15                                             0183
*     END;                          /* END FREE FRAME PROCESSING     */
*   ELSE                                                           0185
*     ;                             /* DO NOTHING IF FRAME IS NOT TO
*                                      BE FREED                      */
@RF00172 DS    0H                                                  0186
*                                                                  0186
*   /*****************************************************************/
*   /*                                                               */
*   /* FINALLY, THE DISPOSITION OF THE INPUT PCB IS DETERMINED AND   */
*   /* THE PCB SENT TO THE FREE Q IF NECESSARY. EXIT IS THEN MADE TO */
*   /* THE CALLER. IF THE PCB IS TO BE KEPT, PIOCP IS SCHEDULED AS   */
*   /* DISCUSSED IN THE FIRST SEGMENT. EXIT IS THEN MADE TO THE      */
*   /* CALLER.                                                       */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0186
*LBFINPCB:                                                         0186
*   IF CPKEEPCB='0'B THEN           /* IF CPNORMP INDICATED THE PCB
*                                      IS TO BE FREED, IT IS FREED   */
LBFINPCB TM    CPKEEPCB(PVTPTR),B'01000000'                        0186
         BNZ   @RF00186                                            0186
*     DO;                                                          0187
*       CPARMRG0=PCBFREQN;          /* SET Q NUMBER PARM TO FREE Q   */
         LA    CPARMRG0,16                                         0188
*       CPARMRG1=PCBPTR;            /* PUT PCB ADDR IN REG 1         */
         LR    CPARMRG1,PCBPTR                                     0189
*       CALL EPPCBMGR;              /* THE PCB MANAGER IS CALLED     */
         L     @15,PVTPCB(,PVTPTR)                                 0190
         BALR  @14,@15                                             0190
*     END;                                                         0191
*   ELSE                            /* THE PCB IS TO BE KEPT, THE VBN
*                                      IS SET TO ZERO, AND PCBFREAL
*                                      SET OFF. THE SCHEDULE       0192
*                                      SUBROUTINE OF PIOP CALLED TO
*                                      SCHEDULE PIOCP TO RUN LATER.  */
*     DO;                                                          0192
         B     @RC00186                                            0192
@RF00186 DS    0H                                                  0193
*       PCBVBN=0;                   /* ZERO THE PCBVBN SO PFTE AND 0193
*                                      PGTE PROCESSING WON'T BE    0193
*                                      ATTEMPTED AGAIN BY THIS MODULE*/
         SLR   @12,@12                                             0193
         STH   @12,PCBVBN(,PCBPTR)                                 0193
*       PCBFREAL='0'B;              /* THIS FLAG NO LONGER HAS     0194
*                                      MEANING                       */
         NI    PCBFREAL(PCBPTR),B'01111111'                        0194
*       CPARMRG1=PCBPTR;            /* SET UP PARM FOR SCHED SUBRTN. */
         LR    CPARMRG1,PCBPTR                                     0195
*       CALL EPSCHED;               /* CALL SCHEDULE SUBRTN OF PIOP  */
         L     @15,PVTPOPBR(,PVTPTR)                               0196
         BALR  @14,@15                                             0196
*       RESPECIFY                                                  0197
*        (CPARMRG0,                                                0197
*         CPARMRG1) UNRESTRICTED;                                  0197
*     END;                                                         0198
*   CPRETREG=CPSBRET2;              /* RESTORE CALLER'S RETURN ADDR
*                                      AND RETURN TO THE CALLER      */
@RC00186 L     CPRETREG,CPSBRET2(,PVTPTR)                          0199
*   END;                            /* END SUBNORML INTERNAL PROC    */
@EL00003 DS    0H                                                  0200
@EF00003 DS    0H                                                  0200
@ER00003 BR    @14                                                 0200
*                                                                  0201
*   /*****************************************************************/
*   /*                                                               */
*   /* THE I/O ERROR SUBROUTINE IS CALLED BY THE SQSEARCH SUBROUTINE.*/
*   /* IT GETS ALL PCB'S FOR WHICH A PAGE-IN HAS NOT COMPLETED       */
*   /* SUCCESSFULLY PROCESSED BY CALLING THE SPCBERR SUBROUTINE.     */
*   /* SUBIOERR WORKS A LITTLE DIFFERENTLY THAN SUBNORML IN THAT     */
*   /* RELATED PCB'S THAT CAN NOT BE PROCESSED ARE RETAINED AND NOT  */
*   /* ENQUEUED SEPARATELY. THE REAL FRAME ASSOCIATED WITH PAGE-IN   */
*   /* OPERATION IS NOT FREED UNTIL THE LAST PCB HAS BEEN PROCESSED. */
*   /* INPUT TO THIS SUBROUTINE IS THE ADDRESS OF THE QUEUED OR      */
*   /* PRIMARY PCB TO BE PROCESSED. THIS FIRST SEGMENT PROCESSES ALL */
*   /* RELATED PCB'S, LEAVING THOSE THAT WERE NOT FOR THE CURRENT    */
*   /* ADDRESS SPACE OR THAT SPCBERR COULD NOT PROCESS QUEUED AS     */
*   /* RELATED PCB'S. PROCESSING CONTINUES WITH THE SECOND SEGMENT   */
*   /* ONCE AN ATTEMPT HAS BEEN MADE TO PROCESS EACH RELATED PCB.    */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0201
*SUBIOERR:                                                         0201
*   PROC OPTIONS(NOSAVE NOSAVEAREA);                               0201
SUBIOERR DS    0H                                                  0202
*   CPSBRET2=CPRETREG;              /* SAVE RETURN ADDRESS           */
         ST    CPRETREG,CPSBRET2(,PVTPTR)                          0202
*   CPREVREL=PCBPTR;                /* INIT BASE PCB ADDR FOR RELATED
*                                      LOOP THAT FOLLOWS             */
         STCM  PCBPTR,7,CPREVREL(PVTPTR)                           0203
*   DO WHILE(CPREVREL->PCBRLPA^=0); /* ATTEMPT TO PROCESS EACH     0204
*                                      RELATED PCB.                  */
         B     @DE00204                                            0204
@DL00204 DS    0H                                                  0205
*     RESPECIFY                                                    0205
*       CPCURPCB RESTRICTED;                                       0205
*     CPCURPCB=CPREVREL->PCBRLPA;   /* GET ADDR OF PCB TO BE       0206
*                                      PROCESSED                     */
         L     @12,CPREVREL-1(,PVTPTR)                             0206
         L     CPCURPCB,PCBRLPA-1(,@12)                            0206
         LA    CPCURPCB,0(,CPCURPCB)                               0206
*     IF CPCURPCB->PCBASCB=PCBASCB THEN/* IS RELATED PCB FOR SAME  0207
*                                      ADDRESS SPACE                 */
         CLC   PCBASCB(4,CPCURPCB),PCBASCB(PCBPTR)                 0207
         BNE   @RF00207                                            0207
*       DO;                         /* PROCESS ONLY PCB'S FOR THE  0208
*                                      CURRENT ADDRESS               */
*         CALL SPCBERR;             /* PROCESS THE RELATED PCB       */
         BAL   @14,SPCBERR                                         0209
*         IF CPKEEPCB='0'B THEN     /* IF THE PCB CAN BE FREED,    0210
*                                      REMOVE THE PCB FROM THE     0210
*                                      RELATED CHAIN AND RETURN IT TO
*                                      THE FREE Q                    */
         TM    CPKEEPCB(PVTPTR),B'01000000'                        0210
         BNZ   @RF00210                                            0210
*           DO;                                                    0211
*             CPREVREL->PCBRLPA=CPCURPCB->PCBRLPA;                 0212
         L     @12,CPREVREL-1(,PVTPTR)                             0212
         MVC   PCBRLPA(3,@12),PCBRLPA(CPCURPCB)                    0212
*             CPCURPCB->PCBFQP=CPRPFRST;/* RESET THE FIRST WORD OF 0213
*                                      THE RELATED PCB TO ZERO WITH A
*                                      Q NUMBER INDICATING THE     0213
*                                      UNQUEUED STATE                */
         L     @12,CPRPFRST                                        0213
         ST    @12,PCBFQP(,CPCURPCB)                               0213
*             RESPECIFY                                            0214
*              (CPARMRG0,                                          0214
*               CPARMRG1) RESTRICTED;                              0214
*             CPARMRG0=PCBFREQN;                                   0215
         LA    CPARMRG0,16                                         0215
*             CPARMRG1=CPCURPCB;                                   0216
         LR    CPARMRG1,CPCURPCB                                   0216
*             CALL EPPCBMGR;        /* CALL THE PCB MANAGER TO SEND
*                                      PCB TO THE FREE Q             */
         L     @15,PVTPCB(,PVTPTR)                                 0217
         BALR  @14,@15                                             0217
*             RESPECIFY                                            0218
*              (CPARMRG0,                                          0218
*               CPARMRG1) UNRESTRICTED;                            0218
*           END;                                                   0219
*         ELSE                      /* OTHERWISE, UPDATE THE BASE PCB
*                                      PTR FOR THE RELATED CHAIN     */
*           DO;                                                    0220
         B     @RC00210                                            0220
@RF00210 DS    0H                                                  0221
*             CPREVREL=CPCURPCB;                                   0221
         STCM  CPCURPCB,7,CPREVREL(PVTPTR)                         0221
*           END;                                                   0222
*       END;                                                       0223
*     ELSE                          /* IF RELATED PCB IS FOR       0224
*                                      DIFFERENT ADDRESS SPACE,    0224
*                                      UPDATE THE BASE PCB PTR FOR 0224
*                                      THE RELATED CHAIN             */
*       DO;                                                        0224
         B     @RC00207                                            0224
@RF00207 DS    0H                                                  0225
*         CPREVREL=CPCURPCB;                                       0225
         STCM  CPCURPCB,7,CPREVREL(PVTPTR)                         0225
*       END;                                                       0226
*   END;                            /* END RELATED PCB DO WHILE LOOP */
@RC00207 DS    0H                                                  0227
@DE00204 L     @12,CPREVREL-1(,PVTPTR)                             0227
         L     @12,PCBRLPA-1(,@12)                                 0227
         LA    @12,0(,@12)                                         0227
         LTR   @12,@12                                             0227
         BNZ   @DL00204                                            0227
*                                                                  0228
*   /*****************************************************************/
*   /*                                                               */
*   /* THE SECOND SEGMENT OF SUBIOERR GETS THE INPUT PCB PROCESSED BY*/
*   /* CALLING SPCBERR. IF ALL PCBS ASSOCIATED WITH THE PAGE-IN      */
*   /* OPERATION HAVE BEEN PROCESSED, THE PFTE FOR THE REAL FRAME    */
*   /* ASSOCIATED WITH THE PAGE-IN IS READY TO BE FREED. IF THE FIX  */
*   /* COUNT IS ZERO AND THE DEFERED RELEASE FLAG IS SET, THE DEFERED*/
*   /* RELEASE ENTRY POINT OF IEAVRELS IS CALLED. THE LOCAL LOCK     */
*   /* REQUIRED BY THIS CALL IS GUARANTEED FOR THIS FUNCTION BECAUSE */
*   /* THE SPCBERR SUBRTN. DOES NOT PROCESS FIX PCB'S UNTIL THE LOCAL*/
*   /* LOCK IS HELD. THE PFTE IS THEN FREED REGARDLESS OF THE ABOVE  */
*   /* CONDITIONS. OTHERWISE, THE INPUT PCB IS LEFT QUEUED OR ANY    */
*   /* RELATED PCB'S ARE ENQUEUED TO THE SAME I/O ACTIVE Q AS THE    */
*   /* INPUT PCB (THE INPUT PCB BEING SENT TO THE FREE Q) AND PIOCP  */
*   /* SCHEDULED TO RUN LATER BY CALLING THE SCHEDULE SUBROUTINE OF  */
*   /* PIOP AS DISCUSSED IN SUBNORML.                                */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0228
*   CPCURPCB=PCBPTR;                /* INIT PARM REG FOR SPCBERR     */
         LR    CPCURPCB,PCBPTR                                     0228
*   CALL SPCBERR;                   /* PROCESS THE INPUT PCB         */
         BAL   @14,SPCBERR                                         0229
*   RESPECIFY                                                      0230
*     CPCURPCB UNRESTRICTED;                                       0230
*   IF CPKEEPCB='0'B THEN           /* IF THE INPUT PCB IS TO BE   0231
*                                      FREED AND THERE ARE NO RELATED
*                                      PCB'S, THE REAL FRAME IS FREED*/
         TM    CPKEEPCB(PVTPTR),B'01000000'                        0231
         BNZ   @RF00231                                            0231
*     DO;                                                          0232
*       IF PCBRLPA=0 THEN           /* DO RELATED PCBS STILL EXIST   */
         L     @12,PCBRLPA-1(,PCBPTR)                              0233
         LA    @12,0(,@12)                                         0233
         LTR   @12,@12                                             0233
         BNZ   @RF00233                                            0233
*         DO;                       /* YES                           */
*           RESPECIFY                                              0235
*             PFTEPTR RESTRICTED;                                  0235
*           PFTEPTR=PVTPFTP+PCBRBN; /* GET PFTE ADDR, USING PCBRBN   */
         LH    PFTEPTR,PCBRBN(,PCBPTR)                             0236
         N     PFTEPTR,@CF02180                                    0236
         AL    PFTEPTR,PVTPFTP(,PVTPTR)                            0236
*           PFTPCBSI='0'B;          /* TURN OFF PCB DEFINED FLAG     */
         NI    PFTPCBSI(PFTEPTR),B'11110111'                       0237
*           IF PFTFXCT=0 THEN       /* IS FIX COUNT IN PFTE ZERO     */
         LH    @12,PFTFXCT(,PFTEPTR)                               0238
         LTR   @12,@12                                             0238
         BNZ   @RF00238                                            0238
*             DO;                   /* FOR PFTES WITH ZERO FIX COUNTS
*                                      CHECK FOR DEFERED RELEASE     */
*               IF PFTDFRLS='1'B THEN/* IS FRAME IN DEFERRED RELEASE
*                                      CONDITION                     */
         TM    PFTDFRLS(PFTEPTR),B'10000000'                       0240
         BNO   @RF00240                                            0240
*                 DO;               /* YES                           */
*                   RESPECIFY                                      0242
*                    (CPARMRG0,                                    0242
*                     CPARMRG1) RESTRICTED;                        0242
*                   CPARMRG1=PFTVBN*256;/* SET UP INPUT VSA FOR    0243
*                                      IEAVRELF                      */
         LH    CPARMRG1,PFTVBN(,PFTEPTR)                           0243
         N     CPARMRG1,@CF02180                                   0243
         SLA   CPARMRG1,8                                          0243
*                   CALL EPDEFREL;  /* CALL DEFERED RELEASE PROCESSOR*/
         L     @15,PVTPRELF(,PVTPTR)                               0244
         BALR  @14,@15                                             0244
*                   RCACSECT=RCACCOMP;/* RESET CSECT ID IN RCA       */
         MVI   RCACSECT(RCAPTR),X'14'                              0245
*                 END;                                             0246
*               ELSE                                               0247
*                 ;                 /* FRAME NOT DEFERRED RELEASED   */
@RF00240 DS    0H                                                  0248
*             END;                                                 0248
*           ELSE                    /* IF PFTE FIX COUNT NOT ZERO, 0249
*                                      RECORD THE ERROR AND FORCE THE
*                                      COUNT TO ZERO                 */
*             DO;                                                  0249
         B     @RC00238                                            0249
@RF00238 DS    0H                                                  0250
*               RCARCRD='0A'X;      /* SET REASON CODE               */
         MVI   RCARCRD(RCAPTR),X'0A'                               0250
*               GEN(ABEND X'C0D',,,SYSTEM) ;                       0251
         ABEND X'C0D',,,SYSTEM
*               PFTFXCT=0;                                         0252
         SLR   @12,@12                                             0252
         STH   @12,PFTFXCT(,PFTEPTR)                               0252
*               IF PFTVBN>=PVTLCSA THEN/* IS FRAME IN COMMON AREA    */
         CLC   PFTVBN(2,PFTEPTR),PVTLCSA(PVTPTR)                   0253
         BL    @RF00253                                            0253
*                 PVTCOMFX=PVTCOMFX-1;/* YES, A COMMON AREA FRAME  0254
*                                      DECREMENT COMMON AREA COUNT 0254
*                                                            @YA01572*/
         LH    @12,PVTCOMFX(,PVTPTR)                               0254
         BCTR  @12,0                                               0254
         STH   @12,PVTCOMFX(,PVTPTR)                               0254
*               ELSE                /* NOT COMMON AREA               */
*                 RSMCNTFX=RSMCNTFX-1;/* DECREMENT COUNT FOR THIS  0255
*                                      ADDRESS SPACE         @YA01572*/
         B     @RC00253                                            0255
@RF00253 LH    @12,RSMCNTFX(,RSMHDPTR)                             0255
         BCTR  @12,0                                               0255
         STH   @12,RSMCNTFX(,RSMHDPTR)                             0255
*               PVTCNTFX=PVTCNTFX-1;/* DECREMENT SYSTEM COUNT      0256
*                                                            @YA01572*/
@RC00253 LH    @12,PVTCNTFX(,PVTPTR)                               0256
         BCTR  @12,0                                               0256
         STH   @12,PVTCNTFX(,PVTPTR)                               0256
*             END;                                                 0257
*           PFTPGID=0;              /* ZERO ASID, VBN IN PFTE TO   0258
*                                      PREVENT RECLAIM               */
@RC00238 SLR   @12,@12                                             0258
         ST    @12,PFTPGID(,PFTEPTR)                               0258
*           RESPECIFY                                              0259
*             PFTEPTR UNRESTRICTED;                                0259
*           CPHI2BYT=CPINITHI;      /* INIT HIGH 2 BYTES OF REG 0  0260
*                                      PARM FOR PFTE ENQ/DEQ TO PLACE
*                                      PFTE ON FRONT OF AFQ          */
         LH    @12,CPINITHI                                        0260
         N     @12,@CF02180                                        0260
         STH   @12,CPHI2BYT(,PVTPTR)                               0260
*           CPRBNPRM=PCBRBN;        /* LOW 2 BYTES IS PFTE INDEX     */
         LH    @12,PCBRBN(,PCBPTR)                                 0261
         N     @12,@CF02180                                        0261
         STH   @12,CPRBNPRM(,PVTPTR)                               0261
*           CPARMRG0=CPENQDEQ;      /* LOAD INITIALIZED PARM FIELD 0262
*                                      INTO REGISTER 0               */
         L     CPARMRG0,CPENQDEQ(,PVTPTR)                          0262
*           CPARMRG1=PSAAOLD;       /* REG 1 IS CURRENT ASCB ADDR    */
         L     CPARMRG1,PSAAOLD                                    0263
*           CALL EPFTENDQ;          /* CALL PFTE ENQ/DEQ TO PLACE  0264
*                                      PFTE ON FRONT OF AFQ          */
         L     @15,PVTPFTE(,PVTPTR)                                0264
         BALR  @14,@15                                             0264
*         END;                      /* END FREE FRAME PROCESSING     */
*       ELSE                        /* IF RELATED PCB'S STILL REMAIN,
*                                      THE FIRST IS ENQUEUED TO THE Q
*                                      OF THE INPUT PCB AND THE INPUT
*                                      PCB FREED BELOW               */
*         DO;                                                      0266
         B     @RC00233                                            0266
@RF00233 DS    0H                                                  0267
*           PCBVBN=0;               /* THE VBN IN THE INPUT PCB IS 0267
*                                      SET TO ZERO TO PREVENT HAVING
*                                      TWO PCB'S WITH THE SAME VBN ON
*                                      A Q AT THE SAME TIME.         */
         SLR   @12,@12                                             0267
         STH   @12,PCBVBN(,PCBPTR)                                 0267
*           CPARMRG0=PCBCQN;        /* SET UP PARM FOR PCB MGR       */
         SLR   CPARMRG0,CPARMRG0                                   0268
         IC    CPARMRG0,PCBCQN(,PCBPTR)                            0268
*           CPARMRG1=PCBRLPA;       /* FIRST RELATED TO BE ENQUEUED  */
         L     CPARMRG1,PCBRLPA-1(,PCBPTR)                         0269
         LA    CPARMRG1,0(,CPARMRG1)                               0269
*           CALL EPPCBMGR;          /* CALL THE PCB MANAGER          */
         L     @15,PVTPCB(,PVTPTR)                                 0270
         BALR  @14,@15                                             0270
*           CALL EPSCHED;           /* CALL SCHEDULE SUBRTN OF PIOP.
*                                      REG 1 STILL HAS PCB ADDR    0271
*                                      BECAUSE PCB MGR DOESN'T     0271
*                                      DESTROY IT.                   */
         L     @15,PVTPOPBR(,PVTPTR)                               0271
         BALR  @14,@15                                             0271
*         END;                                                     0272
*     END;                          /* END FREE INPUT PCB PROCESSING */
*   ELSE                            /* IF THE INPUT PCB CAN NOT BE 0274
*                                      FREED, PIOCP MUST BE SCHEDULED*/
*     DO;                                                          0274
         B     @RC00231                                            0274
@RF00231 DS    0H                                                  0275
*       CPARMRG1=PCBPTR;                                           0275
         LR    CPARMRG1,PCBPTR                                     0275
*       CALL EPSCHED;               /* CALL SCHEDULE SUBRTN OF PIOP  */
         L     @15,PVTPOPBR(,PVTPTR)                               0276
         BALR  @14,@15                                             0276
*       GOTO LBEXIT;                /* SKIP FREEING OF INPUT PCB     */
         B     LBEXIT                                              0277
*     END;                                                         0278
*   CPARMRG0=PCBFREQN;              /* THE INPUT PCB IS NOW FREED BY
*                                      CALLING THE PCB MANAGER     0279
*                                      BECAUSE CPKEEPCB=0.           */
@RC00231 LA    CPARMRG0,16                                         0279
*   CPARMRG1=PCBPTR;                /* SET UP PARM REG WITH PCB ADDR */
         LR    CPARMRG1,PCBPTR                                     0280
*   CALL EPPCBMGR;                  /* CALL THE PCB MANAGER          */
         L     @15,PVTPCB(,PVTPTR)                                 0281
         BALR  @14,@15                                             0281
*   RESPECIFY                                                      0282
*    (CPARMRG0,                                                    0282
*     CPARMRG1) UNRESTRICTED;                                      0282
*LBEXIT:                                                           0283
*   CPRETREG=CPSBRET2;              /* RESTORE RETURN ADDR AND EXIT
*                                      TO THE CALLER                 */
LBEXIT   L     CPRETREG,CPSBRET2(,PVTPTR)                          0283
*   END;                            /* END SUBIOERR INT PROC         */
@EL00004 DS    0H                                                  0284
@EF00004 DS    0H                                                  0284
@ER00004 BR    @14                                                 0284
*                                                                  0285
*   /*****************************************************************/
*   /*                                                               */
*   /* THE SPCBNORM SUBROUTINE IS CALLED FOR EACH RELATED OR QUEUED  */
*   /* PCB FOUND BY THE SUBNORML SUBROUTINE. SPCBNORM'S JOB IS TO    */
*   /* VALIDATE A PAGE AND SET ITS PROTECT KEY IN REAL STORAGE. NOTE */
*   /* THAT THIS PROCESSING IS SKIPPED IF THE PCBVBN IS ZERO OR IF   */
*   /* THE PAGE IS ALREADY VALID. THE PAGE COULD ALREADY BE VALID ON */
*   /* ENTRY TO THIS MODULE OR WAS VALIDATED WHEN PROCESSING ANOTHER */
*   /* PCB RELATED TO THE PRIMARY PCB. THE SNOTIFY SUBROUTINE IS THEN*/
*   /* CALLED. THE ADDRESS OF THE PCB TO BE PROCESSED BY SPCBNORM IS */
*   /* PASSED IN REG 8 (CPCURPCB). NOTE THAT THE ADDR OF THE PRIMARY */
*   /* PCB BEING PROCESSED BY THE MODULE IS IN REG 7 AND MUST NOT BE */
*   /* DISTURBED. OTHER REGISTERS WHICH MUST NOT CHANGE ACROSS THIS  */
*   /* SUBROUTINE ARE 2, 3, AND 10.                                  */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0285
*SPCBNORM:                                                         0285
*   PROC OPTIONS(NOSAVE NOSAVEAREA);                               0285
SPCBNORM DS    0H                                                  0286
*   CPSBRET3=CPRETREG;              /* SAVE THE RETURN ADDRESS       */
         ST    CPRETREG,CPSBRET3(,PVTPTR)                          0286
*   RESPECIFY                                                      0287
*     CPCURPCB RESTRICTED;                                         0287
*   RESPECIFY                                                      0288
*     PCB BASED(CPCURPCB);          /* THE PCB BASE PTR FOR THIS   0288
*                                      SUBROUTINE IS THE INPUT     0288
*                                      PARAMETER REG, NOT THE      0288
*                                      STANDARD PCB REG FOR THE    0288
*                                      MODULE                        */
*   IF PCBFREAL='0'B THEN           /* IF THE FREE REAL FLAG IS NOT
*                                      SET IN THE PCB, PERFORM THE 0289
*                                      NEXT TWO TESTS BEFORE       0289
*                                      VALIDATING THE PAGE           */
         TM    PCBFREAL(CPCURPCB),B'10000000'                      0289
         BNZ   @RF00289                                            0289
*     DO;                                                          0290
*       CPFREREL='0'B;              /* THE INTERNAL FREE REAL FLAG IS
*                                      RESET TO PREVENT SUBNORML FROM
*                                      FREEING THE REAL FRAME        */
         NI    CPFREREL(PVTPTR),B'11011111'                        0291
*       IF PCBVBN^=0 THEN           /* IF THE PCB VBN IS NOT ZERO, 0292
*                                      THEN DO A LRA ON THE VIRTUAL
*                                      ADDR DEVELOPED FROM THIS VBN
*                                      TO SEE IF THE PAGE HAS ALREADY
*                                      BEEN VALIDATED                */
         LH    @12,PCBVBN(,CPCURPCB)                               0292
         N     @12,@CF02180                                        0292
         LTR   @12,@12                                             0292
         BZ    @RF00292                                            0292
*         DO;                                                      0293
*           RESPECIFY                                              0294
*            (CPWRKRG4,                                            0294
*             CPWRKRG5) RESTRICTED;                                0294
*           CPWRKRG4=PCBVBN*256;    /* SHIFT VBN LEFT 8 BITS FOR VSA */
         SLA   @12,8                                               0295
         LR    CPWRKRG4,@12                                        0295
*           GEN(LRA   CPWRKRG5,0(CPWRKRG4))                        0296
*           REFS(CPWRKRG4) SETS(CPWRKRG5);/* PERFORM LRA             */
         LRA   CPWRKRG5,0(CPWRKRG4)
*           BC(8,LBNOTIFY);         /* IF THE PAGE IS VALID, SKIP TO
*                                      NOTIFICATION PROCESSING IN THE
*                                      NEXT SEGMENT                  */
         BC    8,LBNOTIFY                                          0297
*           RESPECIFY                                              0298
*             PFTEPTR RESTRICTED;                                  0298
*           PFTEPTR=PVTPFTP+PCBRBN; /* OBTAIN THE ADDRESS OF THE PFTE
*                                      ASSIGNED TO THE VIRTUAL PAGE  */
         LH    @12,PCBRBN(,CPCURPCB)                               0299
         N     @12,@CF02180                                        0299
         L     PFTEPTR,PVTPFTP(,PVTPTR)                            0299
         ALR   PFTEPTR,@12                                         0299
*           PFTPCBSI='0'B;          /* TURN OFF THE PCB DEFINED FLAG */
         NI    PFTPCBSI(PFTEPTR),B'11110111'                       0300
*           RESPECIFY                                              0301
*             PFTEPTR UNRESTRICTED;                                0301
*           CPWRKRG4=XPTPROT;       /* GET THE KEY IN THE XPTE IN A
*                                      REG FOR THE SSK INSTRUCTIONS  */
         L     @11,XPTEPTR(,CPCURPCB)                              0302
         SLR   CPWRKRG4,CPWRKRG4                                   0302
         IC    CPWRKRG4,XPTPROT(,@11)                              0302
*           CPWRKRG5=PCBRBN*256;    /* SHIFT THE PCB RBN LEFT 8 BITS
*                                      TO FORM A 24 BIT REAL ADDRESS */
         SLA   @12,8                                               0303
         LR    CPWRKRG5,@12                                        0303
*           GENERATE REFS(CPWRKRG4,CPWRKRG5) SETS(CPWRKRG5);       0304
         SSK   CPWRKRG4,CPWRKRG5        SET THE STORAGE KEY OF 1ST 2K
         LA    CPWRKRG5,2048(CPWRKRG5)  INCREMENT REAL ADDR BY 2048
         SSK   CPWRKRG4,CPWRKRG5        SET THE STORAGE KEY OF 2ND 2K
*           RESPECIFY                                              0305
*            (CPWRKRG4,                                            0305
*             CPWRKRG5) UNRESTRICTED;                              0305
*           PGTPVM='0'B;            /* VALIDATE THE PGTE. NOTE THIS
*                                      SHOULD NOT BE DONE UNTIL THE
*                                      KEYS ARE SET PROPERLY FOR THE
*                                      REAL FRAME                    */
         L     @12,PTEPTR(,CPCURPCB)                               0306
         NI    PGTPVM(@12),B'11110111'                             0306
*         END;                      /* END VALIDATION PROCESSING     */
*       ELSE                                                       0308
*         ;                         /* PCBVBN WAS ZERO               */
@RF00292 DS    0H                                                  0309
*     END;                                                         0309
*   ELSE                                                           0310
*     ;                             /* PCBFREAL WAS 1                */
@RF00289 DS    0H                                                  0311
*LBNOTIFY:                                                         0311
*   CALL SNOTIFY;                   /* CALL THE NOTIFY SUBROUTINE TO
*                                      COMPLETE PROCESSING OF THE  0311
*                                      INPUT PCB                     */
LBNOTIFY BAL   @14,SNOTIFY                                         0311
*   CPRETREG=CPSBRET3;              /* RESTORE RETURN ADDR AND RETURN
*                                      TO THE CALLER                 */
         L     CPRETREG,CPSBRET3(,PVTPTR)                          0312
*   RESPECIFY                                                      0313
*     PCB BASED(PCBPTR);            /* RESTORE PCB BASE PTR TO THE 0313
*                                      STANDARD PCB REG              */
*   RESPECIFY                                                      0314
*     CPCURPCB UNRESTRICTED;                                       0314
*   END;                            /* END SPCBNORM INTERNAL PROC    */
@EL00005 DS    0H                                                  0315
@EF00005 DS    0H                                                  0315
@ER00005 BR    @14                                                 0315
*                                                                  0316
*   /*****************************************************************/
*   /*                                                               */
*   /* THE SPCBERR SUBROUTINE IS CALLED BY SUBIOERR WHEN A PCB THAT  */
*   /* HAS SUFFERED AN I/O FAILURE IS TO BE PROCESSED. THE PCB       */
*   /* ADDRESS IS PASSED IN REGISTER 8(CPCURPCB). REGISTERS THAT ARE */
*   /* NOT TO BE CHANGED BY THIS SUBROUTINE ARE REGS 2, 3, 7(PCBPTR),*/
*   /* AND 10. THIS SUBROUTINE DOES PROCESSING FOR PCB'S WITH A ROOT */
*   /* PCB. THE I/O FAILURE FLAG IS SET IN THE ROOT PCB AND FOE      */
*   /* PROCESSING IS PERFORMED IF THE FIX COUNT IN THE INPUT PCB IS  */
*   /* NOT ZERO AND THE TCB ADDRESS IN THE ROOT PCB IS NOT ZERO. IF  */
*   /* THE STAGE 1 FLAG IS SET IN THE INPUT PCB, A SPECIAL FLAG FOR  */
*   /* THE SWAP-IN ROOT EXIT IS SET AND FOE PROCESSING BYPASSED. FOE */
*   /* PROCESSING CONSISTS OF DECREMENTING THE FOE FIX COUNT BY THE  */
*   /* PCB FIX COUNT. THE FOE IS NOT FREED AT THIS TIME IF THE COUNT */
*   /* GOES TO ZERO AS IT MAY GET REUSED AND WILL BE FREED AT TASK   */
*   /* TERMINATION TIME. THE PCB COUNT IS THEN SUBTRACTED FROM THE   */
*   /* PFTE FIX COUNT OF THE PFTE IDENTIFIED BY THE PCBRBN FIELD AND */
*   /* THE PCB FIX COUNT SET TO ZERO. NO FOE OR PFTE PROCESSING IS   */
*   /* DONE IF THE LOCAL LOCK IS NOT HELD AND SNOTIFY IS ALSO        */
*   /* BYPASSED. ALL INPUT PCB'S ARE THEN PASSED TO THE SNOTIFY      */
*   /* SUBROUTINE FOR FINAL PROCESSING.                              */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0316
*SPCBERR:                                                          0316
*   PROC OPTIONS(NOSAVE NOSAVEAREA);                               0316
SPCBERR  DS    0H                                                  0317
*   CPSBRET3=CPRETREG;              /* SAVE RETURN ADDRESS           */
         ST    CPRETREG,CPSBRET3(,PVTPTR)                          0317
*   RESPECIFY                                                      0318
*     CPCURPCB RESTRICTED;                                         0318
*   RESPECIFY                                                      0319
*     PCB BASED(CPCURPCB);          /* THE PCB BASE PTR FOR THIS   0319
*                                      SUBROUTINE IS THE INPUT     0319
*                                      PARAMETER REG, NOT THE      0319
*                                      STANDARD PCB REG FOR THE    0319
*                                      MODULE                        */
*   IF PCBROOT='1'B THEN            /* THIS FLAG INDICATES A ROOT PCB*/
         TM    PCBROOT(CPCURPCB),B'00000100'                       0320
         BNO   @RF00320                                            0320
*     DO;                                                          0321
*       PCBRFAIL='1'B;              /* SET THE I/O FAILURE FLAG IN 0322
*                                      ALL ROOT PCB'S                */
         L     @12,PCBRPTR(,CPCURPCB)                              0322
         OI    PCBRFAIL(@12),B'00001000'                           0322
*       IF PCBSWPS1='1'B THEN       /* IS PCB FOR STAGE 1 SWAP       */
         TM    PCBSWPS1(CPCURPCB),B'00100000'                      0323
         BNO   @RF00323                                            0323
*         DO;                                                      0324
*           PCBRPB='1'B;            /* SET SPECIAL FLAG FOR STAGE 1  */
         OI    PCBRPB(@12),B'00100000'                             0325
*           GOTO LBPFTFXC;          /* BYPASS FOE PROCESSING         */
         B     LBPFTFXC                                            0326
*         END;                                                     0327
*       IF PCBFXC^=0 THEN           /* IF THE PCB IS FOR A PGFIX   0328
*                                      REQ., FOE PROCESSING MUST BE
*                                      DONE                          */
@RF00323 CLI   PCBFXC(CPCURPCB),0                                  0328
         BE    @RF00328                                            0328
*         DO;                                                      0329
*           IF CPLLHELD='0'B THEN   /* NO FIX PCB PROCESSING IS DONE
*                                      UNLESS THE LOCAL LOCK IS HELD
*                                      IN ORDER THAT ANY PFTE DEFERED
*                                      RELEASE PROCESSING WILL BE  0330
*                                      DONE ONLY WITH THE LOCAL LOCK
*                                      HELD AND TO GUARANTEE TCB   0330
*                                      SERIALIZATION.                */
         TM    CPLLHELD(PVTPTR),B'10000000'                        0330
         BNZ   @RF00330                                            0330
*             DO;                                                  0331
*               CPKEEPCB='1'B;      /* SET INDICATOR ON TO KEEP PCB  */
         OI    CPKEEPCB(PVTPTR),B'01000000'                        0332
*               GOTO LBERRETN;      /* BYPASS ALL PCB PROCESSING     */
         B     LBERRETN                                            0333
*             END;                                                 0334
*           ELSE                                                   0335
*             ;                     /* CONTINUE IF LOCAL LOCK HELD   */
@RF00330 DS    0H                                                  0336
*           IF PCBRTCBA^=0 THEN     /* FOE PROCESSING IS DONE ONLY IF
*                                      A NON-ZERO TCB ADDR IS IN ROOT*/
         L     @12,PCBRPTR(,CPCURPCB)                              0336
         L     @11,PCBRTCBA-1(,@12)                                0336
         LA    @11,0(,@11)                                         0336
         LTR   @11,@11                                             0336
         BZ    @RF00336                                            0336
*             DO;                                                  0337
*               RESPECIFY                                          0338
*                 FOEPTR RESTRICTED;                               0338
*               FOEPTR=TCBFOEA;     /* GET THE ADDR OF FIRST FOE     */
         L     @12,TCBPTR(,@12)                                    0339
         L     FOEPTR,TCBFOEA-1(,@12)                              0339
         LA    FOEPTR,0(,FOEPTR)                                   0339
*               DO WHILE(FOEPTR^=0&FOEVINDX<=PCBVBN);/* SEARCH FOE 0340
*                                      CHAIN AND PROCESS THE FOE WITH
*                                      A MATCHING VBN. WHEN AND IF A
*                                      MATCH IS FOUND, THE LOOP IS 0340
*                                      EXITED IMMEDIATELY            */
         B     @DE00340                                            0340
@DL00340 DS    0H                                                  0341
*                 IF FOEVINDX=PCBVBN THEN/* ARE VBNS EQUAL           */
         CLC   FOEVINDX(2,FOEPTR),PCBVBN(CPCURPCB)                 0341
         BNE   @RF00341                                            0341
*                   DO;             /* YES                           */
*                     FOEFXCT=FOEFXCT-PCBFXC;                      0343
         LH    @12,FOEFXCT(,FOEPTR)                                0343
         SLR   @11,@11                                             0343
         IC    @11,PCBFXC(,CPCURPCB)                               0343
         SLR   @12,@11                                             0343
         STH   @12,FOEFXCT(,FOEPTR)                                0343
*                     GOTO LBPFTFXC;/* WHEN AN FOE IS FOUND, EXIT  0344
*                                      LOOP                          */
         B     LBPFTFXC                                            0344
*                   END;                                           0345
*                 ELSE              /* VBNS NOT EQUAL, KEEP LOOKING  */
*                   FOEPTR=FOEFLINK;/* GET NEXT FOE                  */
@RF00341 L     @12,FOEFLINK-1(,FOEPTR)                             0346
         LA    @12,0(,@12)                                         0346
         LR    FOEPTR,@12                                          0346
*                 RESPECIFY                                        0347
*                   FOEPTR UNRESTRICTED;                           0347
*               END;                /* END FOE DO WHILE              */
@DE00340 LTR   FOEPTR,FOEPTR                                       0348
         BZ    @DC00340                                            0348
         CLC   FOEVINDX(2,FOEPTR),PCBVBN(CPCURPCB)                 0348
         BNH   @DL00340                                            0348
@DC00340 DS    0H                                                  0349
*               RCARCRD='10'X;      /* IF NO FOE IS FOUND, SET THE 0349
*                                      REASON CODE AND ISSUE ABEND TO
*                                      RECORD ERROR BEFORE         0349
*                                      CONTINUING.                   */
         MVI   RCARCRD(RCAPTR),X'10'                               0349
*               GEN(ABEND X'C0D',,,SYSTEM) ;/* GO TO FRR TO RECORD 0350
*                                      ERROR                         */
         ABEND X'C0D',,,SYSTEM
*             END;                  /* END NON-ZERO TCB PROCESSING   */
*           ELSE                                                   0352
*             ;                     /* TCB ADDR IN ROOT WAS ZERO     */
@RF00336 DS    0H                                                  0353
*LBPFTFXC:                          /* REGARDLESS OF TCB ADDR, THE 0353
*                                      PFTE FIX COUNT IS DECREMENTED
*                                      BY THE VALUE OF PCBFXC AND  0353
*                                      PCBFXC THEN SET TO ZERO.      */
*           RESPECIFY                                              0353
*             PFTEPTR RESTRICTED;                                  0353
LBPFTFXC DS    0H                                                  0354
*           PFTEPTR=PVTPFTP+PCBRBN; /* DEVELOP THE ADDR OF THE PFTE  */
         LH    PFTEPTR,PCBRBN(,CPCURPCB)                           0354
         N     PFTEPTR,@CF02180                                    0354
         AL    PFTEPTR,PVTPFTP(,PVTPTR)                            0354
*           PFTFXCT=PFTFXCT-PCBFXC;                                0355
         LH    @12,PFTFXCT(,PFTEPTR)                               0355
         SLR   @11,@11                                             0355
         IC    @11,PCBFXC(,CPCURPCB)                               0355
         SLR   @12,@11                                             0355
         STH   @12,PFTFXCT(,PFTEPTR)                               0355
*           RESPECIFY                                              0356
*             PFTEPTR UNRESTRICTED;                                0356
*           PCBFXC=0;                                              0357
         MVI   PCBFXC(CPCURPCB),X'00'                              0357
*           IF PFTFXCT=0 THEN       /* IS FRAME FIX COUNT NOW EQUAL
*                                      ZERO                          */
         LTR   @12,@12                                             0358
         BNZ   @RF00358                                            0358
*             DO;                   /* YES, DECREMENT COUNTS @YA01572*/
*               IF PCBVBN>=PVTLCSA THEN/* IS FRAME IN COMMON AREA    */
         CLC   PCBVBN(2,CPCURPCB),PVTLCSA(PVTPTR)                  0360
         BL    @RF00360                                            0360
*                 PVTCOMFX=PVTCOMFX-1;/* YES, COMMON AREA, DECREMENT
*                                      COMMON AREA COUNT     @YA01572*/
         LH    @12,PVTCOMFX(,PVTPTR)                               0361
         BCTR  @12,0                                               0361
         STH   @12,PVTCOMFX(,PVTPTR)                               0361
*               ELSE                /* NOT COMMON AREA               */
*                 RSMCNTFX=RSMCNTFX-1;/* DECREMENT COUNT FOR THIS  0362
*                                      ADDRESS SPACE         @YA01572*/
         B     @RC00360                                            0362
@RF00360 LH    @12,RSMCNTFX(,RSMHDPTR)                             0362
         BCTR  @12,0                                               0362
         STH   @12,RSMCNTFX(,RSMHDPTR)                             0362
*               PVTCNTFX=PVTCNTFX-1;/* DECREMENT SYSTEM COUNT      0363
*                                                            @YA01572*/
@RC00360 LH    @12,PVTCNTFX(,PVTPTR)                               0363
         BCTR  @12,0                                               0363
         STH   @12,PVTCNTFX(,PVTPTR)                               0363
*             END;                                                 0364
*           ELSE                                                   0365
*             ;                     /* FRAME FIX COUNT IS NOT ZERO   */
@RF00358 DS    0H                                                  0366
*         END;                      /* END NON-ZERO PCBFXC PROCESSING*/
*       ELSE                                                       0367
*         ;                         /* THE PCB FIX CNT WAS ZERO      */
@RF00328 DS    0H                                                  0368
*     END;                          /* END ROOT PCB PROCESSING       */
*   ELSE                                                           0369
*     ;                             /* NO ROOT EXISTED, NO SPECIAL 0369
*                                      PCB PROCESSING IS NECESSARY   */
@RF00320 DS    0H                                                  0370
*   CALL SNOTIFY;                   /* CALL SNOTIFY FOR ALL INPT   0370
*                                      PCB'S                         */
*                                                                  0370
         BAL   @14,SNOTIFY                                         0370
*   /*****************************************************************/
*   /*                                                               */
*   /* EXIT CODE                                                     */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0371
*LBERRETN:                                                         0371
*   CPRETREG=CPSBRET3;              /* RESTORE THE CALLERS RETURN  0371
*                                      ADDRESS AND RETURN TO THE   0371
*                                      CALLER                        */
LBERRETN L     CPRETREG,CPSBRET3(,PVTPTR)                          0371
*   RESPECIFY                                                      0372
*     PCB BASED(PCBPTR);            /* RESTORE PCB BASE PTR TO THE 0372
*                                      STANDARD PCB REG              */
*   RESPECIFY                                                      0373
*     CPCURPCB UNRESTRICTED;                                       0373
*   END;                            /* END SPCBERR INTERNAL PROC     */
@EL00006 DS    0H                                                  0374
@EF00006 DS    0H                                                  0374
@ER00006 BR    @14                                                 0374
*                                                                  0375
*   /*****************************************************************/
*   /*                                                               */
*   /* THE SNOTIFY SUBROUTINE IS CALLED BY THE SPCBNORM OR SPCBERR   */
*   /* SUBROUTINES TO PERFORM ANY NECESSARY NOTIFICATION OF ROUTINES */
*   /* WAITING FOR PAGING I/O TO COMPLETE. THE INPUT PARAMETER IS THE*/
*   /* ADDRESS OF THE PCB TO BE PROCESSED IN REGISTER 8(CPCURPCB).   */
*   /* REGISTERS 2, 3, 7(PCBPTR), AND 10 CAN NOT BE DESTROYED BY THIS*/
*   /* SUBROUTINE. THIS FIRST SEGMENT PROCESSES ANY PCB THAT HAS THE */
*   /* RESET FLAG ON. THE RESET SUBROUTINE OF PCFLIH IS CALLED IF THE*/
*   /* PCB WAS FOR AN SRB MODE ROUTINE OR AN UNLOCKED ROUTINE FOR    */
*   /* WHICH PIOCP HOLDS THE LOCAL LOCK. OTHERWISE, THE INTERNAL KEEP*/
*   /* PCB FLAG IS SET ON AND A RETURN CODE OF 4 SET INTERNALLY FOR  */
*   /* BRANCH ENTRY CALLERS.                                         */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0375
*SNOTIFY:                                                          0375
*   PROC OPTIONS(NOSAVE NOSAVEAREA);                               0375
SNOTIFY  DS    0H                                                  0376
*   CPSBRET4=CPRETREG;              /* SAVE THE RETURN ADDRESS       */
         ST    CPRETREG,CPSBRET4(,PVTPTR)                          0376
*   CPKEEPCB='0'B;                  /* RESET THE KEEP PCB INDICATOR
*                                      TO THE FREE PCB VALUE         */
         NI    CPKEEPCB(PVTPTR),B'10111111'                        0377
*   RESPECIFY                                                      0378
*     CPCURPCB RESTRICTED;                                         0378
*   RESPECIFY                                                      0379
*     PCB BASED(CPCURPCB);          /* THE PCB BASE PTR FOR THIS   0379
*                                      SUBROUTINE IS THE INPUT     0379
*                                      PARAMETER REG, NOT THE      0379
*                                      STANDARD PCB REG FOR THE    0379
*                                      MODULE                        */
*   IF PCBRESET='1'B THEN           /* IS RESET TO BE CALLED         */
         TM    PCBRESET(CPCURPCB),B'00010000'                      0380
         BNO   @RF00380                                            0380
*     DO;                           /* YES                           */
*       IF PCBSRBMD='1'B THEN       /* IF THE PCB IS IN SRB MODE,  0382
*                                      THEN PREPARE THE INPUT REGS TO
*                                      RESET SUBROUTINE.             */
         TM    PCBSRBMD(CPCURPCB),B'00100000'                      0382
         BNO   @RF00382                                            0382
*         DO;                                                      0383
*           RESPECIFY                                              0384
*            (CPRSETR4,                                            0384
*             CPRSETR5,                                            0384
*             CPRSETR6) RESTRICTED;                                0384
*           CPRSETR4=PCBSRB;        /* REG 4 GETS THE SRB ADDR       */
         L     CPRSETR4,PCBSRB(,CPCURPCB)                          0385
*           CPRSETR5=0;             /* REG 5 IS ZERO TO SHOW SRB     */
         SLR   CPRSETR5,CPRSETR5                                   0386
*         END;                                                     0387
*       ELSE                        /* PCB IN TCB MODE               */
*         DO;                                                      0388
         B     @RC00382                                            0388
@RF00382 DS    0H                                                  0389
*           IF PCBLLHLD='0'B&CPLLHELD='0'B THEN/* IF A TASK PAGE   0389
*                                      FAULTED WITHOUT THE LOCAL LOCK
*                                      AND THE LOCAL LOCK IS NOT HELD
*                                      CURRENTLY, THE PCB MUST BE  0389
*                                      KEPT.                         */
         TM    PCBLLHLD(CPCURPCB),B'00010000'                      0389
         BNZ   @RF00389                                            0389
         TM    CPLLHELD(PVTPTR),B'10000000'                        0389
         BNZ   @RF00389                                            0389
*             DO;                                                  0390
*LBKEEPCB:                          /* THIS CODE MAY ALSO GET CONTROL
*                                      FROM THE ROOT PROCESSING    0391
*                                      SEGMENT                       */
*               CPRCODE='1'B;       /* SET INTERNAL RETURN CODE FLAG
*                                      SO THE BRANCH ENTRY CALLER  0391
*                                      WILL GET A RETURN CODE 4      */
LBKEEPCB DS    0H                                                  0392
*               CPKEEPCB='1'B;      /* TELL CALLER NOT TO FREE PCB   */
         OI    CPRCODE(PVTPTR),B'01010000'                         0392
*               GOTO LBNRMEXT;      /* GO TO EXIT PROCESSING         */
         B     LBNRMEXT                                            0393
*             END;                                                 0394
*           ELSE                    /* OTHERWISE, RESET MAY BE CALLED*/
*             DO;                                                  0395
@RF00389 DS    0H                                                  0396
*               CPRSETR4=PCBRTPA;   /* REG 4 GETS THE TCB ADDR FOR 0396
*                                      NON-SRB PCB'S                 */
         L     CPRSETR4,PCBRTPA-1(,CPCURPCB)                       0396
         LA    CPRSETR4,0(,CPRSETR4)                               0396
*               CPRSETR5=PCBSRB;    /* REG 5 GETS THE RB ADDR. NOTE
*                                      THAT THE PCBSRB FIELD CONTAINS
*                                      AN RB ADDR IF RESET IS ON AND
*                                      SRBMD IS OFF                  */
         L     CPRSETR5,PCBSRB(,CPCURPCB)                          0397
*             END;                                                 0398
*         END;                      /* END NON-SRB PROCESSING        */
*       IF PCBIOERR='0'B THEN       /* SET COMPLETION CODE FOR RESET
*                                      ACCORDING TO PCB I/O ERROR  0400
*                                      FLAG                          */
@RC00382 TM    PCBIOERR(CPCURPCB),B'00100000'                      0400
         BNZ   @RF00400                                            0400
*         CPRSETR6=0;               /* SUCCESSFUL COMPLETION         */
         SLR   CPRSETR6,CPRSETR6                                   0401
*       ELSE                        /* I/O ERROR                     */
*         CPRSETR6=4;               /* UNSUCCESSFUL COMPLETION       */
         B     @RC00400                                            0402
@RF00400 LA    CPRSETR6,4                                          0402
*       RESPECIFY                                                  0403
*         CPSAVREG RESTRICTED;                                     0403
@RC00400 DS    0H                                                  0404
*       CPSAVREG=ADDR(PVTSAVE);     /* SET UP SAVE AREA ADDR         */
         LA    CPSAVREG,PVTSAVE(,PVTPTR)                           0404
*       CALL EPRESET;               /* CALL RESET SUBRTN OF PCFLIH   */
         L     @15,PVTPRSET(,PVTPTR)                               0405
         BALR  @14,@15                                             0405
*       RESPECIFY                                                  0406
*        (CPRSETR4,                                                0406
*         CPRSETR5,                                                0406
*         CPRSETR6,                                                0406
*         CPSAVREG) UNRESTRICTED;                                  0406
*     END;                                                         0407
*                                                                  0408
*   /*****************************************************************/
*   /*                                                               */
*   /* THIS SEGMENT PROCESSES ANY ROOT PCB ASSOCIATED WITH THE INPUT */
*   /* PCB. THE ROOT EXIT ROUTINE ADDRESSED IN THE ROOT IS CALLED IF */
*   /* THE PCB COUNT IN THE ROOT GOES TO ZERO AND THE LOCAL LOCK IS  */
*   /* HELD BY PIOCP OR IF THE PCB IS A STAGE 1 SWAP PCB FOR A COMMON*/
*   /* AREA FIXED PAGE. THIS LATTER CASE WILL ONLY OCCUR FOR A       */
*   /* RELATED PCB AS IEAVPIOP HANDLES QUEUED PCB'S OF THIS TYPE. IF */
*   /* THE LOCAL LOCK IS NOT HELD, THE INTERNAL KEEP PCB FLAG IS SET */
*   /* BY THE LBKEEPCB CODE IN THE FIRST SEGMENT. IF THE COUNT DOES  */
*   /* NOT GO TO ZERO, NO SPECIAL ACTION IS TAKEN ON BEHALF OF THE   */
*   /* ROOT PCB. THE PCBRFAIL ROOT PCB FLAG IS SET BY THE SPCBERR    */
*   /* SUBROUTINE IF NECESSARY. THEREFORE, THIS CODE DOES NOT HAVE TO*/
*   /* DISTINGUISH BETWEEN NORMAL AND I/O ERROR PCB'S. IF NO ROOT PCB*/
*   /* EXISTS, NO NOTIFICATION PROCESSING IS NECESSARY. THIS SEGMENT */
*   /* ALSO CONTAINS THE EXIT LOGIC FOR ALL OF SNOTIFY.              */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0408
*   ELSE                                                           0408
*     DO;                                                          0408
         B     @RC00380                                            0408
@RF00380 DS    0H                                                  0409
*       IF PCBROOT='1'B THEN        /* THIS FLAG INDICATES THE     0409
*                                      PRESENCE OF A ROOT PCB        */
         TM    PCBROOT(CPCURPCB),B'00000100'                       0409
         BNO   @RF00409                                            0409
*         DO;                                                      0410
*           RESPECIFY                                              0411
*             CPWRKRG4 RESTRICTED;                                 0411
*           CPWRKRG4=PCBRCNT-1;     /* GET THE PCB COUNT IN THE ROOT
*                                      INTO A REGISTER AND DECREMENT
*                                      IT                            */
         L     @12,PCBRPTR(,CPCURPCB)                              0412
         LH    CPWRKRG4,PCBRCNT(,@12)                              0412
         BCTR  CPWRKRG4,0                                          0412
*           IF CPWRKRG4=0 THEN      /* IF THE COUNT GOES TO ZERO,  0413
*                                      CHECK FOR LOCAL LOCK HELD.    */
         LTR   CPWRKRG4,CPWRKRG4                                   0413
         BNZ   @RF00413                                            0413
*             DO;                                                  0414
*               IF CPLLHELD='1'B|PCBSWPS1='1'B THEN/* CALL THE ROOT
*                                      EXIT ROUTINE IF THE LOCAL LOCK
*                                      IS HELD OR THE PCB IS A STAGE
*                                      1 SWAP PCB.                   */
         TM    CPLLHELD(PVTPTR),B'10000000'                        0415
         BO    @RT00415                                            0415
         TM    PCBSWPS1(CPCURPCB),B'00100000'                      0415
         BNO   @RF00415                                            0415
@RT00415 DS    0H                                                  0416
*                 DO;                                              0416
*                   PCBRCNT=CPWRKRG4;/* SET PCB COUNT IN ROOT TO ZERO*/
         L     @12,PCBRPTR(,CPCURPCB)                              0417
         STH   CPWRKRG4,PCBRCNT(,@12)                              0417
*                   RESPECIFY                                      0418
*                     CPARMRG1 RESTRICTED;                         0418
*                   CPARMRG1=PCBRTPA;/* IF ROOT FLAG ON, THIS FIELD
*                                      CONTAINS THE ROOT PCB ADDRESS
*                                      THAT IS PASSED AS A PARAMETER */
         L     CPARMRG1,PCBRTPA-1(,CPCURPCB)                       0419
         LA    CPARMRG1,0(,CPARMRG1)                               0419
*                   CALL EPROOTEX;  /* CALL THE ROOT EXIT ROUTINE  0420
*                                      ADDRESSED IN THE ROOT PCB     */
         L     @15,PCBRGOTO(,@12)                                  0420
         BALR  @14,@15                                             0420
*                   RCACSECT=RCACCOMP;/* RESET MODULE ID IN RCA      */
         MVI   RCACSECT(RCAPTR),X'14'                              0421
*                   RESPECIFY                                      0422
*                     CPARMRG1 UNRESTRICTED;                       0422
*                 END;                                             0423
*               ELSE                /* ROOT EXIT CAN NOT BE CALLED   */
*                 GOTO LBKEEPCB;    /* IF THE ROOT EXIT CAN NOT BE 0424
*                                      CALLED, TURN ON THE KEEP PCB
*                                      FLAG.                         */
*             END;                  /* END PCB CNT ZERO PROCESSING   */
*           ELSE                    /* IF THE PCB COUNT DID NOT GO TO
*                                      ZERO, STORE DECREMENTED COUNT
*                                      BACK INTO THE ROOT PCB        */
*             DO;                                                  0426
         B     @RC00413                                            0426
@RF00413 DS    0H                                                  0427
*               PCBRCNT=CPWRKRG4;                                  0427
         L     @12,PCBRPTR(,CPCURPCB)                              0427
         STH   CPWRKRG4,PCBRCNT(,@12)                              0427
*               RESPECIFY                                          0428
*                 CPWRKRG4 UNRESTRICTED;                           0428
*             END;                                                 0429
*         END;                      /* END ROOT PCB PROCESSING       */
*       ELSE                                                       0431
*         ;                         /* DO NOTHING IF NO ROOT PCB     */
@RF00409 DS    0H                                                  0432
*     END;                          /* END RESET=0 PROCESSING        */
*                                                                  0432
@RC00409 DS    0H                                                  0433
*   /*****************************************************************/
*   /*                                                               */
*   /* EXIT PROCESSING IS NOW PERFORMED.                             */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0433
*LBNRMEXT:                                                         0433
*   CPRETREG=CPSBRET4;              /* RESTORE RETURN ADDRESS AND  0433
*                                      RETURN TO THE CALLER          */
@RC00380 DS    0H                                                  0433
LBNRMEXT L     CPRETREG,CPSBRET4(,PVTPTR)                          0433
*   RESPECIFY                                                      0434
*     PCB BASED(PCBPTR);            /* RESTORE PCB BASE PTR TO THE 0434
*                                      STANDARD PCB REG              */
*   RESPECIFY                                                      0435
*     CPCURPCB UNRESTRICTED;                                       0435
*   END;                            /* END SNOTIFY INTERNAL PROC     */
@EL00007 DS    0H                                                  0436
@EF00007 DS    0H                                                  0436
@ER00007 BR    @14                                                 0436
*   END                             /* END THE EXTERNAL PROC         */
*                                                                  0437
*/* THE FOLLOWING INCLUDE STATEMENTS WERE FOUND IN THIS PROGRAM.     */
*/*%INCLUDE SYSLIB  (IHAPSA  )                                       */
*/*%INCLUDE SYSLIB  (CVT     )                                       */
*/*%INCLUDE SYSLIB  (IHAASCB )                                       */
*/*%INCLUDE SYSLIB  (IKJTCB  )                                       */
*/*%INCLUDE SYSLIB  (IHAPVT  )                                       */
*/*%INCLUDE SYSLIB  (IHARSMHD)                                       */
*/*%INCLUDE SYSLIB  (IHAPCB  )                                       */
*/*%INCLUDE SYSLIB  (IHAPCBR )                                       */
*/*%INCLUDE SYSLIB  (IHAPFTE )                                       */
*/*%INCLUDE SYSLIB  (IHAFOE  )                                       */
*/*%INCLUDE SYSLIB  (IHAPGTE )                                       */
*/*%INCLUDE SYSLIB  (IHAXPTE )                                       */
*/*%INCLUDE SYSLIB  (IHARCA  )                                       */
*/*%INCLUDE SYSLIB  (IHAFRRS )                                       */
*                                                                  0437
*       ;                                                          0437
@DATA    DS    0H
@DATD    DSECT
         DS    0F
IEAVIOCP CSECT
         DS    0F
@CF02093 DC    XL4'00000010'
@CF02180 DC    XL4'0000FFFF'
@DATD    DSECT
         DS    0D
@ENDDATD EQU   *
IEAVIOCP CSECT
         NOPR  ((@ENDDATD-@DATD)*16)
         DS    0F
@SIZDATD DC    AL1(0)
         DC    AL3(@ENDDATD-@DATD)
         DS    0D
CPRPFRST DS    FL4
         ORG   CPRPFRST
CPCURQN  DC    X'FF'
CPCBFQPA DC    AL3(0)
         ORG   CPRPFRST+4
CPINITHI DS    AL2
         ORG   CPINITHI
CPFRONTQ DC    X'80'
CPTQID   DC    X'00'
         ORG   CPINITHI+2
@CB02091 DC    X'0009'
@00      EQU   00                      EQUATES FOR REGISTERS 0-15
@01      EQU   01
@02      EQU   02
@03      EQU   03
@04      EQU   04
@05      EQU   05
@06      EQU   06
@07      EQU   07
@08      EQU   08
@09      EQU   09
@10      EQU   10
@11      EQU   11
@12      EQU   12
@13      EQU   13
@14      EQU   14
@15      EQU   15
PVTPTR   EQU   @03
RSMHDPTR EQU   @02
PCBPTR   EQU   @07
PFTEPTR  EQU   @06
FOEPTR   EQU   @06
RCAPTR   EQU   @09
CPARMRG0 EQU   @00
CPARMRG1 EQU   @01
CPRSETR4 EQU   @04
CPWRKRG4 EQU   @04
CPRSETR5 EQU   @05
CPWRKRG5 EQU   @05
CPRSETR6 EQU   @06
CPCURPCB EQU   @08
CPBASE10 EQU   @10
CPSAVREG EQU   @13
CPRETREG EQU   @14
CPRETCOD EQU   @15
CPLKCODE EQU   @13
PSA      EQU   0
FLCRNPSW EQU   PSA
FLCROPSW EQU   PSA+8
FLCICCW2 EQU   PSA+16
FLCCVT   EQU   FLCICCW2
PSAEEPSW EQU   PSA+132
PSAESPSW EQU   PSA+136
FLCSVILC EQU   PSAESPSW+1
PSAEPPSW EQU   PSA+140
FLCPIILC EQU   PSAEPPSW+1
FLCPICOD EQU   PSAEPPSW+2
PSAPICOD EQU   FLCPICOD+1
FLCTEA   EQU   PSAEPPSW+4
FLCPER   EQU   PSA+152
FLCMCLA  EQU   PSA+168
FLCIOEL  EQU   FLCMCLA+4
FLCIOA   EQU   FLCMCLA+16
FLCFSA   EQU   FLCMCLA+80
PSAAOLD  EQU   PSA+548
PSASUPER EQU   PSA+552
PSASUP1  EQU   PSASUPER
PSASUP2  EQU   PSASUPER+1
PSASUP3  EQU   PSASUPER+2
PSASUP4  EQU   PSASUPER+3
PSACLHT  EQU   PSA+640
PSALKSA  EQU   PSA+696
PSAHLHI  EQU   PSA+760
PSADSSFL EQU   PSA+836
PSADSSF1 EQU   PSADSSFL
PSADSSF3 EQU   PSADSSFL+2
PSADSSF4 EQU   PSADSSFL+3
PSARSVT  EQU   PSA+896
CVTMAP   EQU   0
CVTDAR   EQU   CVTMAP+72
CVTFLGS1 EQU   CVTDAR
CVTDCB   EQU   CVTMAP+116
CVTIERLC EQU   CVTMAP+144
CVTOPTA  EQU   CVTMAP+182
CVTOPTB  EQU   CVTMAP+183
CVTGTF   EQU   CVTMAP+236
CVTGTFST EQU   CVTGTF
CVTGTFS  EQU   CVTGTFST
CVTSTATE EQU   CVTGTFST
CVTTMODE EQU   CVTGTFST
CVTFORM  EQU   CVTGTFST
CVTAQAVT EQU   CVTMAP+240
CVTTCMFG EQU   CVTAQAVT
CVTVOLM2 EQU   CVTMAP+244
CVTTATA  EQU   CVTVOLM2
CVTTSKS  EQU   CVTTATA
CVTVOLF2 EQU   CVTTSKS
CVTTAT   EQU   CVTTATA+1
CVTATER  EQU   CVTMAP+248
CVTEXT1  EQU   CVTMAP+252
CVTPURG  EQU   CVTMAP+260
CVTQMSG  EQU   CVTMAP+268
CVTDMSR  EQU   CVTMAP+272
CVTRSV37 EQU   CVTDMSR
CVTDMSRF EQU   CVTRSV37
CVTERPV  EQU   CVTMAP+316
CVTINTLA EQU   CVTMAP+320
CVTAPF   EQU   CVTMAP+324
CVTEXT2  EQU   CVTMAP+328
CVTHJES  EQU   CVTMAP+332
CVTPGSIA EQU   CVTMAP+348
CVTA1F1  EQU   CVTMAP+356
CVTSYSK  EQU   CVTMAP+357
CVTVOLM1 EQU   CVTMAP+380
CVTVOLF1 EQU   CVTVOLM1
CVTXTNT1 EQU   0
CVTXTNT2 EQU   0
CVTDSSV  EQU   CVTXTNT2
CVTFLGBT EQU   CVTXTNT2+5
CVTQID   EQU   CVTXTNT2+24
CVTRV400 EQU   CVTXTNT2+52
CVTRV409 EQU   CVTXTNT2+53
CVTATCVT EQU   CVTXTNT2+64
CVTRV429 EQU   CVTXTNT2+84
CVTRV438 EQU   CVTXTNT2+85
CVTRV457 EQU   CVTXTNT2+112
CVTRV466 EQU   CVTXTNT2+113
CVTFIX   EQU   0
CVTRELNO EQU   CVTFIX+252
ASCB     EQU   0
ASCBSUPC EQU   ASCB+16
ASCBRSM  EQU   ASCB+52
ASCBFW1  EQU   ASCB+100
ASCBRCTF EQU   ASCBFW1+2
ASCBFLG1 EQU   ASCBFW1+3
ASCBDSP1 EQU   ASCB+114
ASCBFLG2 EQU   ASCB+115
ASCBLKGP EQU   ASCB+128
ASCBSRQ  EQU   ASCB+180
ASCBSRQ1 EQU   ASCBSRQ
ASCBSRQ2 EQU   ASCBSRQ+1
ASCBSRQ3 EQU   ASCBSRQ+2
ASCBSRQ4 EQU   ASCBSRQ+3
TCBFIX   EQU   0
TCBFRS   EQU   TCBFIX
TCB      EQU   0
TCBPIE   EQU   TCB+4
TCBPMASK EQU   TCBPIE
TCBCMP   EQU   TCB+16
TCBCMPF  EQU   TCBCMP
TCBCPP   EQU   TCBCMPF
TCBSTCC  EQU   TCBCMPF
TCBCDBL  EQU   TCBCMPF
TCBCWTO  EQU   TCBCMPF
TCBCIND  EQU   TCBCMPF
TCBCMSG  EQU   TCBCMPF
TCBTRN   EQU   TCB+20
TCBABF   EQU   TCBTRN
TCBMSS   EQU   TCB+24
TCBPKF   EQU   TCB+28
TCBFLGS  EQU   TCB+29
TCBFLGS1 EQU   TCBFLGS
TCBFLGS2 EQU   TCBFLGS+1
TCBFLGS3 EQU   TCBFLGS+2
TCBFLGS4 EQU   TCBFLGS+3
TCBFLGS5 EQU   TCBFLGS+4
TCBABWF  EQU   TCBFLGS5
TCBJPQ   EQU   TCB+44
TCBPURGE EQU   TCBJPQ
TCBGRS   EQU   TCB+48
TCBFSA   EQU   TCB+112
TCBTME   EQU   TCB+120
TCBJSTCB EQU   TCB+124
TCBTSFLG EQU   TCB+148
TCBTSTSK EQU   TCBTSFLG
TCBSTAB  EQU   TCB+160
TCBNSTAE EQU   TCBSTAB
TCBTCT   EQU   TCB+164
TCBTCTGF EQU   TCBTCT
TCBSCNDY EQU   TCB+172
TCBNDSP  EQU   TCBSCNDY
TCBNDSP1 EQU   TCBNDSP+1
TCBNDSP2 EQU   TCBNDSP+2
TCBNDSP3 EQU   TCBNDSP+3
TCBJSCB  EQU   TCB+180
TCBRECDE EQU   TCBJSCB
TCBEXT1  EQU   TCB+196
TCBBITS  EQU   TCB+200
TCBNDSP4 EQU   TCBBITS
TCBNDSP5 EQU   TCBBITS+1
TCBFLGS6 EQU   TCBBITS+2
TCBFLGS7 EQU   TCBBITS+3
TCBDAR   EQU   TCB+204
TCBDARC  EQU   TCBDAR
TCBEXT2  EQU   TCB+208
TCBXSCT  EQU   TCB+240
TCBXSCT1 EQU   TCBXSCT
TCBFOE   EQU   TCB+244
TCBFOEA  EQU   TCBFOE+1
TCBESTAE EQU   TCB+264
TCBESTRM EQU   TCBESTAE+1
TCBFBYT1 EQU   TCB+276
TCBFBYT2 EQU   TCB+277
TCBRV124 EQU   TCB+278
TCBRV133 EQU   TCB+279
TCBXTNT2 EQU   0
TCBGTF   EQU   TCBXTNT2
TCBTFLG  EQU   TCBGTF
TCBRV146 EQU   TCBXTNT2+28
TCBRV155 EQU   TCBXTNT2+29
TCBRV164 EQU   TCBXTNT2+30
TCBRV173 EQU   TCBXTNT2+31
PVT      EQU   0
PVTFLAG1 EQU   PVT
PVTPFTP  EQU   PVT+12
PVTLCSA  EQU   PVT+26
PVTPRCA  EQU   PVT+52
PVTSRBID EQU   PVT+68
PVTPCB   EQU   PVT+104
PVTPFTE  EQU   PVT+108
PVTPRCV  EQU   PVT+156
PVTPRELF EQU   PVT+216
PVTPOPBR EQU   PVT+220
PVTPRSET EQU   PVT+244
PVTQS    EQU   PVT+304
PVTWSAX  EQU   PVT+344
PVTWSA10 EQU   PVTWSAX+672
PVTSAVE  EQU   PVTWSAX+1328
PVTCNTFX EQU   PVT+1830
PVTCOMFX EQU   PVT+1834
PVTPCBQS EQU   PVT+1852
PVTCIOQL EQU   PVTPCBQS+36
RSMHD    EQU   0
RSMFLG1  EQU   RSMHD+12
RSMIOCPU EQU   RSMFLG1
RSMIOCPC EQU   RSMFLG1
RSMCNTFX EQU   RSMHD+14
RSMQS    EQU   RSMHD+20
RSMLFQ   EQU   RSMQS
RSMLSQA  EQU   RSMQS+4
RSMLIOQ  EQU   RSMQS+8
RSMLIOQL EQU   RSMLIOQ+4
PCB      EQU   0
PCBFQP   EQU   PCB
PCBCQN   EQU   PCBFQP
PCBBQP   EQU   PCB+4
PCBBQPA  EQU   PCBBQP
PCBRTP   EQU   PCB+8
PCBFL1   EQU   PCBRTP
PCBSRBMD EQU   PCBFL1
PCBLLHLD EQU   PCBFL1
PCBROOT  EQU   PCBFL1
PCBIOCMP EQU   PCBFL1
PCBRTPA  EQU   PCBRTP+1
PCBRLP   EQU   PCB+12
PCBFXC   EQU   PCBRLP
PCBRLPA  EQU   PCBRLP+1
PCBXPT   EQU   PCB+16
PCBFL2   EQU   PCBXPT
PCBFREAL EQU   PCBFL2
PCBIOERR EQU   PCBFL2
PCBRESET EQU   PCBFL2
PCBPGT   EQU   PCB+20
PCBFL3   EQU   PCBPGT
PCBSWPS1 EQU   PCBFL3
PCBSWPS2 EQU   PCBFL3
PCBRBN   EQU   PCB+24
PCBVBN   EQU   PCB+26
PCBBLOCK EQU   PCB+28
PCBSRB   EQU   PCBBLOCK
PCBRB    EQU   PCBSRB
PCBASCB  EQU   PCB+32
PCBR     EQU   0
PCBRTCB  EQU   PCBR
PCBRFLAG EQU   PCBRTCB
PCBRPB   EQU   PCBRFLAG
PCBRFAIL EQU   PCBRFLAG
PCBRTCBA EQU   PCBRTCB+1
PCBRGOTO EQU   PCBR+4
PCBRCNT  EQU   PCBR+16
PFTE     EQU   0
PFTPGID  EQU   PFTE
PFTVBN   EQU   PFTPGID+2
PFTQPTRS EQU   PFTE+4
PFTFXCT  EQU   PFTE+8
PFTFLAGS EQU   PFTE+12
PFTFLAG1 EQU   PFTFLAGS
PFTPCBSI EQU   PFTFLAG1
PFTFLAG2 EQU   PFTFLAGS+1
PFTDFRLS EQU   PFTFLAG2
FOE      EQU   0
FOEFLNKF EQU   FOE
FOEFLAG  EQU   FOEFLNKF
FOEFLINK EQU   FOEFLNKF+1
FOEVINDX EQU   FOE+4
FOEFXCT  EQU   FOE+6
PGTPTE   EQU   0
PGTRSA   EQU   PGTPTE
PGTBITS  EQU   PGTRSA+1
PGTPVM   EQU   PGTBITS
XPTE     EQU   0
XPTPROT  EQU   XPTE
XPTFLAGS EQU   XPTE+2
XPTFLAG2 EQU   XPTE+3
XPTLPID  EQU   XPTE+4
XPTLGN   EQU   XPTLPID
XPTLPN   EQU   XPTLPID+4
RCA      EQU   0
RCANAME7 EQU   RCA+8
RCACSECT EQU   RCA+9
RCAFLAGS EQU   RCA+10
RCASAL   EQU   RCAFLAGS
RCALL    EQU   RCAFLAGS
RCARCRD  EQU   RCA+11
RCANAMES EQU   RCA+12
RCANAME1 EQU   RCANAMES
RCANAME2 EQU   RCANAMES+1
RCAIOCP  EQU   RCANAME2
RCANAME3 EQU   RCANAMES+2
RCANAME4 EQU   RCANAMES+3
RCANAME5 EQU   RCANAMES+4
RCANAME6 EQU   RCANAMES+5
FRRS     EQU   0
FRRSHEAD EQU   FRRS
FRRSCURR EQU   FRRSHEAD+12
FRRSENTR EQU   0
FRRSFLGS EQU   FRRSENTR+4
FRRSFLG1 EQU   FRRSFLGS
EPPCBMGR EQU   0
EPFTENDQ EQU   0
EPSCHED  EQU   0
EPDEFREL EQU   0
EPROOTEX EQU   0
EPRESET  EQU   0
FOEEND   EQU   0
PGTEND   EQU   0
PSARSVTE EQU   PSARSVT
PSACSTK  EQU   PSARSVTE
CVTPTR   EQU   FLCCVT
CVTS01   EQU   CVTPGSIA
CVTPVTP  EQU   CVTS01+8
CVTLPDIA EQU   CVTS01+12
CVTDIRST EQU   CVTLPDIA
CVTSLIDA EQU   CVTS01+24
CVTCTLFG EQU   CVTS01+50
CVTSRBRT EQU   CVTS01+100
CVTRV210 EQU   CVTS01+424
CVTRV219 EQU   CVTS01+425
CVTRV228 EQU   CVTS01+426
CVTRV237 EQU   CVTS01+427
CVTMFRTR EQU   CVTS01+452
CVTRV262 EQU   CVTS01+468
CVTRV271 EQU   CVTS01+469
CVTRV280 EQU   CVTS01+470
CVTRV289 EQU   CVTS01+471
CVTGSDA  EQU   CVTS01+600
ASCBPTR  EQU   PSAAOLD
TCBPTR   EQU   PCBRTCB
PCBRPTR  EQU   PCBRTP
PTEPTR   EQU   PCBPGT
XPTEPTR  EQU   PCBXPT
FRRSPTR  EQU   PSACSTK
FRREPTR  EQU   FRRSCURR
CPWSA10  EQU   PVTWSA10
CPWKAREA EQU   CPWSA10+52
CPSBRET1 EQU   CPWKAREA
CPSBRET2 EQU   CPWKAREA+4
CPSBRET3 EQU   CPWKAREA+8
CPSBRET4 EQU   CPWKAREA+12
CPBAKSAV EQU   CPWKAREA+16
@NM00057 EQU   CPWKAREA+20
CPFLAGS  EQU   @NM00057
CPLLHELD EQU   CPFLAGS
CPKEEPCB EQU   CPFLAGS
CPFREREL EQU   CPFLAGS
CPRCODE  EQU   CPFLAGS
CPREVREL EQU   @NM00057+1
CPENQDEQ EQU   CPWKAREA+24
CPHI2BYT EQU   CPENQDEQ
CPRBNPRM EQU   CPENQDEQ+2
FLC      EQU   PSA
*                                      START UNREFERENCED COMPONENTS
@NM00058 EQU   CPFLAGS
CPSVREGS EQU   CPWSA10
CVTRV628 EQU   CVTS01+728
CVTRV627 EQU   CVTS01+724
CVTRV626 EQU   CVTS01+720
CVTRV625 EQU   CVTS01+716
CVTRV624 EQU   CVTS01+712
CVTRV623 EQU   CVTS01+708
CVTRV622 EQU   CVTS01+704
CVTRV621 EQU   CVTS01+700
CVTIHASU EQU   CVTS01+696
CVTSUSP  EQU   CVTS01+692
CVTT6SVC EQU   CVTS01+688
CVTCDAL  EQU   CVTS01+684
CVTTCTL  EQU   CVTS01+680
CVTRSUME EQU   CVTS01+676
CVTJTERM EQU   CVTS01+672
CVTASMRM EQU   CVTS01+668
CVTTCASP EQU   CVTS01+664
CVT0PT03 EQU   CVTS01+660
CVT0PT0E EQU   CVTS01+656
CVTRV609 EQU   CVTS01+652
CVTCGK   EQU   CVTS01+648
CVTRAC   EQU   CVTS01+644
CVTRV606 EQU   CVTS01+640
CVTRV605 EQU   CVTS01+636
CVTRV604 EQU   CVTS01+632
CVTEFF02 EQU   CVTS01+628
CVTCBBR  EQU   CVTS01+624
CVTSSCR  EQU   CVTS01+620
CVTEVENT EQU   CVTS01+616
CVTCRCA  EQU   CVTS01+612
CVTTPIO  EQU   CVTS01+608
CVTADV   EQU   CVTS01+604
CVTGSDAB EQU   CVTGSDA
CVTQV3   EQU   CVTS01+596
CVTQV2   EQU   CVTS01+592
CVTQV1   EQU   CVTS01+588
CVTRPT   EQU   CVTS01+584
CVTSSRB  EQU   CVTS01+580
CVTCSDRL EQU   CVTS01+576
CVTEXP1  EQU   CVTS01+572
CVTRMPMT EQU   CVTS01+568
CVTRMPTT EQU   CVTS01+564
CVTVPSA  EQU   CVTS01+560
CVTVSTOP EQU   CVTS01+556
CVTGTFR8 EQU   CVTS01+552
CVTQUIT  EQU   CVTS01+548
CVTVACR  EQU   CVTS01+544
CVTWTCB  EQU   CVTS01+540
CVTSTPRS EQU   CVTS01+536
CVT0PT02 EQU   CVTS01+532
CVTDARCM EQU   CVTS01+528
CVTIRECM EQU   CVTS01+524
CVTJRECM EQU   CVTS01+520
CVTVEMS0 EQU   CVTS01+516
CVTSPFRR EQU   CVTS01+512
CVTRLSTG EQU   CVTS01+508
CVT0TC0A EQU   CVTS01+504
CVTGMBR  EQU   CVTS01+500
CVTLFRM  EQU   CVTS01+496
CVTRMBR  EQU   CVTS01+492
CVTVIOP  EQU   CVTS01+488
CVTRV307 EQU   CVTS01+486
CVTRV306 EQU   CVTS01+484
CVTRV305 EQU   CVTS01+482
CVTRV304 EQU   CVTS01+480
CVTRV303 EQU   CVTS01+478
CVTRV302 EQU   CVTS01+476
CVTTRCA  EQU   CVTS01+472
CVTRV297 EQU   CVTRV289
CVTRV296 EQU   CVTRV289
CVTRV295 EQU   CVTRV289
CVTRV294 EQU   CVTRV289
CVTRV293 EQU   CVTRV289
CVTRV292 EQU   CVTRV289
CVTRV291 EQU   CVTRV289
CVTRV290 EQU   CVTRV289
CVTRV288 EQU   CVTRV280
CVTRV287 EQU   CVTRV280
CVTRV286 EQU   CVTRV280
CVTRV285 EQU   CVTRV280
CVTRV284 EQU   CVTRV280
CVTRV283 EQU   CVTRV280
CVTRV282 EQU   CVTRV280
CVTRV281 EQU   CVTRV280
CVTRV279 EQU   CVTRV271
CVTRV278 EQU   CVTRV271
CVTRV277 EQU   CVTRV271
CVTRV276 EQU   CVTRV271
CVTRV275 EQU   CVTRV271
CVTRV274 EQU   CVTRV271
CVTRV273 EQU   CVTRV271
CVTRV272 EQU   CVTRV271
CVTRV270 EQU   CVTRV262
CVTRV269 EQU   CVTRV262
CVTRV268 EQU   CVTRV262
CVTRV267 EQU   CVTRV262
CVTRV266 EQU   CVTRV262
CVTRV265 EQU   CVTRV262
CVTRV264 EQU   CVTRV262
CVTRV263 EQU   CVTRV262
CVTVFP   EQU   CVTS01+464
CVTVSI   EQU   CVTS01+460
CVTVPSIB EQU   CVTS01+456
CVTMFACT EQU   CVTMFRTR
CVTMFCTL EQU   CVTS01+448
CVTPVBP  EQU   CVTS01+444
CVTPWI   EQU   CVTS01+440
CVTRV254 EQU   CVTS01+438
CVTRV253 EQU   CVTS01+436
CVTRV252 EQU   CVTS01+434
CVTRV251 EQU   CVTS01+433
CVTRV250 EQU   CVTS01+432
CVTRV249 EQU   CVTS01+431
CVTRV248 EQU   CVTS01+430
CVTRV247 EQU   CVTS01+429
CVTRV246 EQU   CVTS01+428
CVTRV245 EQU   CVTRV237
CVTRV244 EQU   CVTRV237
CVTRV243 EQU   CVTRV237
CVTRV242 EQU   CVTRV237
CVTRV241 EQU   CVTRV237
CVTRV240 EQU   CVTRV237
CVTRV239 EQU   CVTRV237
CVTRV238 EQU   CVTRV237
CVTRV236 EQU   CVTRV228
CVTRV235 EQU   CVTRV228
CVTRV234 EQU   CVTRV228
CVTRV233 EQU   CVTRV228
CVTRV232 EQU   CVTRV228
CVTRV231 EQU   CVTRV228
CVTRV230 EQU   CVTRV228
CVTRV229 EQU   CVTRV228
CVTRV227 EQU   CVTRV219
CVTRV226 EQU   CVTRV219
CVTRV225 EQU   CVTRV219
CVTRV224 EQU   CVTRV219
CVTRV223 EQU   CVTRV219
CVTRV222 EQU   CVTRV219
CVTRV221 EQU   CVTRV219
CVTRV220 EQU   CVTRV219
CVTRV218 EQU   CVTRV210
CVTRV217 EQU   CVTRV210
CVTRV216 EQU   CVTRV210
CVTRV215 EQU   CVTRV210
CVTRV214 EQU   CVTRV210
CVTRV213 EQU   CVTRV210
CVTRV212 EQU   CVTRV210
CVTRV211 EQU   CVTRV210
CVTLCCAT EQU   CVTS01+420
CVTPCCAT EQU   CVTS01+416
CVTIPCRP EQU   CVTS01+412
CVTIPCRI EQU   CVTS01+408
CVTIPCDS EQU   CVTS01+404
CVTAIDVT EQU   CVTS01+400
CVTSSAP  EQU   CVTS01+396
CVTEHCIR EQU   CVTS01+392
CVTEHDEF EQU   CVTS01+388
CVTDAIR  EQU   CVTS01+384
CVTPERFM EQU   CVTS01+380
CVT044R2 EQU   CVTS01+376
CVTFETCH EQU   CVTS01+372
CVTRSTWD EQU   CVTS01+368
CVTSPOST EQU   CVTS01+364
CVTIOBP  EQU   CVTS01+360
CVTASMVT EQU   CVTS01+356
CVTRECRQ EQU   CVTS01+352
CVTWSAC  EQU   CVTS01+348
CVTRV149 EQU   CVTS01+344
CVTWSAL  EQU   CVTS01+340
CVTSPSA  EQU   CVTS01+336
CVTGLMN  EQU   CVTS01+332
CVTVEAC0 EQU   CVTS01+328
CVT062R1 EQU   CVTS01+324
CVTRPOST EQU   CVTS01+320
CVTDQIQE EQU   CVTS01+316
CVTCSD   EQU   CVTS01+312
CVTLKRMA EQU   CVTS01+308
CVTRSPIE EQU   CVTS01+304
CVTRENQ  EQU   CVTS01+300
CVTLQCB  EQU   CVTS01+296
CVTFQCB  EQU   CVTS01+292
CVTQCS01 EQU   CVTS01+288
CVTAPFT  EQU   CVTS01+284
CVTPARRL EQU   CVTS01+280
CVTVWAIT EQU   CVTS01+276
CVTGSPL  EQU   CVTS01+272
CVTLSMQ  EQU   CVTS01+268
CVTGSMQ  EQU   CVTS01+264
CVTEXPRO EQU   CVTS01+260
CVTOPCTP EQU   CVTS01+256
CVTSIC   EQU   CVTS01+252
CVTTPIOS EQU   CVTS01+248
CVTRTMS  EQU   CVTS01+244
CVTSDBF  EQU   CVTS01+240
CVTSCBP  EQU   CVTS01+236
CVTSDMP  EQU   CVTS01+232
CVTSV60  EQU   CVTS01+228
CVTRTMCT EQU   CVTS01+224
CVTASCBL EQU   CVTS01+220
CVTASCBH EQU   CVTS01+216
CVTGDA   EQU   CVTS01+212
CVTASVT  EQU   CVTS01+208
CVTVVMDI EQU   CVTS01+204
CVTAQTOP EQU   CVTS01+200
CVTIOSCS EQU   CVTS01+196
CVTSDRM  EQU   CVTS01+192
CVTOPTE  EQU   CVTS01+188
CVTSTXU  EQU   CVTS01+184
CVTQUIS  EQU   CVTS01+180
CVTPARS  EQU   CVTS01+176
CVTS1EE  EQU   CVTS01+172
CVTFRAS  EQU   CVTS01+168
CVTQSAS  EQU   CVTS01+164
CVTCRAS  EQU   CVTS01+160
CVTCRMN  EQU   CVTS01+156
CVTDELCP EQU   CVTS01+152
CVTFRECL EQU   CVTS01+148
CVTGETCL EQU   CVTS01+144
CVTBLDCP EQU   CVTS01+140
CVTAUTHL EQU   CVTS01+136
CVTSCAN  EQU   CVTS01+132
CVTRV144 EQU   CVTS01+130
CVTMAXMP EQU   CVTS01+128
CVTSTCK  EQU   CVTS01+124
CVTRV139 EQU   CVTS01+123
CVTDSSAC EQU   CVTS01+122
CVTRV513 EQU   CVTS01+121
CVTIOSPL EQU   CVTS01+120
CVTPTGT  EQU   CVTS01+116
CVTCSPIE EQU   CVTS01+112
CVTSMFEX EQU   CVTS01+108
CVTOLT0A EQU   CVTS01+104
CVTPUTL  EQU   CVTS01+96
CVTASCRL EQU   CVTS01+92
CVTASCRF EQU   CVTS01+88
CVTRV326 EQU   CVTS01+84
CVTRV325 EQU   CVTS01+80
CVTRV324 EQU   CVTS01+76
CVT0VL01 EQU   CVTS01+72
CVTSHRVM EQU   CVTS01+68
CVTRV332 EQU   CVTS01+64
CVTTAS   EQU   CVTS01+60
CVTRSCN  EQU   CVTS01+56
CVTTRAC2 EQU   CVTS01+54
CVTTRACE EQU   CVTS01+52
CVTAPG   EQU   CVTS01+51
CVTSDTRC EQU   CVTCTLFG
CVTGTRCE EQU   CVTCTLFG
CVTNOMP  EQU   CVTCTLFG
CVTRSV79 EQU   CVTCTLFG
CVTDSTAT EQU   CVTCTLFG
CVTRSV78 EQU   CVTCTLFG
CVTRV333 EQU   CVTCTLFG
CVTRV323 EQU   CVTCTLFG
CVTSPVLK EQU   CVTS01+49
CVTRSV77 EQU   CVTS01+48
CVTRV331 EQU   CVTS01+44
CVTRV330 EQU   CVTS01+40
CVTRV329 EQU   CVTS01+36
CVTRV328 EQU   CVTS01+32
CVTRV322 EQU   CVTS01+28
CVTSLID  EQU   CVTSLIDA+1
CVTSYLK  EQU   CVTSLIDA
CVTRV321 EQU   CVTS01+20
CVTRV320 EQU   CVTS01+16
CVTLPDIR EQU   CVTLPDIA+1
CVTRSV69 EQU   CVTDIRST
CVTRSV68 EQU   CVTDIRST
CVTRSV67 EQU   CVTDIRST
CVTRSV66 EQU   CVTDIRST
CVTRSV65 EQU   CVTDIRST
CVTRSV64 EQU   CVTDIRST
CVTRSV63 EQU   CVTDIRST
CVTDICOM EQU   CVTDIRST
CVTLPDSR EQU   CVTS01+4
CVTGETL  EQU   CVTS01
PSARSAV  EQU   PSARSVTE+60
PSARSTK  EQU   PSARSVTE+56
PSAESAV3 EQU   PSARSVTE+52
PSAESTK3 EQU   PSARSVTE+48
PSAESAV2 EQU   PSARSVTE+44
PSAESTK2 EQU   PSARSVTE+40
PSAESAV1 EQU   PSARSVTE+36
PSAESTK1 EQU   PSARSVTE+32
PSAPSAV  EQU   PSARSVTE+28
PSAPSTK  EQU   PSARSVTE+24
PSAMSAV  EQU   PSARSVTE+20
PSAMSTK  EQU   PSARSVTE+16
PSASSAV  EQU   PSARSVTE+12
PSASSTK  EQU   PSARSVTE+8
PSANSTK  EQU   PSARSVTE+4
FRRSPARM EQU   FRRSENTR+8
@NM00056 EQU   FRRSFLGS+1
@NM00055 EQU   FRRSFLG1
FRRSNEST EQU   FRRSFLG1
FRRSRCUR EQU   FRRSFLG1
FRRSFRRA EQU   FRRSENTR
FRRSENTS EQU   FRRS+84
FRRSRTMW EQU   FRRS+16
FRRSELEN EQU   FRRSHEAD+8
FRRSLAST EQU   FRRSHEAD+4
FRRSEMP  EQU   FRRSHEAD
RCARETAD EQU   RCA+20
RCATASID EQU   RCA+18
RCAREP1  EQU   RCANAME6
RCAPSIF  EQU   RCANAME6
RCAPSIX  EQU   RCANAME6
RCAVEQRP EQU   RCANAME6
RCARCFC  EQU   RCANAME6
RCACSGB  EQU   RCANAME6
RCAFXL   EQU   RCANAME6
RCAPS113 EQU   RCANAME6
RCAFREE  EQU   RCANAME5
RCARFR2  EQU   RCANAME5
RCACPBR  EQU   RCANAME5
RCAOPBR  EQU   RCANAME5
RCASORT  EQU   RCANAME5
RCASIRT  EQU   RCANAME5
RCARELV  EQU   RCANAME5
RCARELF  EQU   RCANAME5
RCAGFAD  EQU   RCANAME4
RCAVEQRI EQU   RCANAME4
RCAVEQRF EQU   RCANAME4
RCAVEQRC EQU   RCANAME4
RCATERM  EQU   RCANAME4
RCASQA   EQU   RCANAME4
RCASWIN  EQU   RCANAME4
RCASOUT  EQU   RCANAME4
RCARFR   EQU   RCANAME3
RCARELS  EQU   RCANAME3
RCARCFI  EQU   RCANAME3
RCARCF   EQU   RCANAME3
RCAPSII  EQU   RCANAME3
RCAPSIB  EQU   RCANAME3
RCAPS112 EQU   RCANAME3
RCAPIX   EQU   RCANAME3
RCAPIOP  EQU   RCANAME2
RCASWPC  EQU   RCANAME2
RCASWPP  EQU   RCANAME2
RCAPFTE  EQU   RCANAME2
RCAPCB   EQU   RCANAME2
RCAOUT   EQU   RCANAME2
RCAITAS  EQU   RCANAME2
RCAINV   EQU   RCANAME1
RCAGFA   EQU   RCANAME1
RCAFXLD  EQU   RCANAME1
RCAVEQR  EQU   RCANAME1
RCADSEG  EQU   RCANAME1
RCADLAS  EQU   RCANAME1
RCACSEG  EQU   RCANAME1
RCAVAMSI EQU   RCANAME1
@NM00054 EQU   RCAFLAGS
RCAQS    EQU   RCAFLAGS
RCAPSIER EQU   RCAFLAGS
RCAABEND EQU   RCAFLAGS
@NM00053 EQU   RCANAME7
RCAPRSS  EQU   RCANAME7
RCAPRSR  EQU   RCANAME7
RCAPRSB  EQU   RCANAME7
RCAPSIY  EQU   RCANAME7
RCAPIOI  EQU   RCANAME7
RCAPARM1 EQU   RCA+4
RCAPARM0 EQU   RCA
XPTLSID2 EQU   XPTLPN
XPTLSID  EQU   XPTLGN
@NM00052 EQU   XPTFLAG2
XPTIOERR EQU   XPTFLAG2
XPTPOINP EQU   XPTFLAG2
XPTRES1  EQU   XPTFLAG2
XPTVALID EQU   XPTFLAG2
XPTRSV4  EQU   XPTFLAGS
XPTDEFER EQU   XPTFLAGS
XPTRES2  EQU   XPTFLAGS
XPTVIO   EQU   XPTFLAGS
@NM00051 EQU   XPTFLAGS
XPTCKF   EQU   XPTFLAGS
XPTXAV   EQU   XPTFLAGS
XPTVIOLP EQU   XPTFLAGS
XPTRSV1  EQU   XPTE+1
PGTPAM   EQU   PGTBITS
@NM00050 EQU   PGTBITS
@NM00049 EQU   PGTBITS
@NM00048 EQU   PGTBITS
@NM00047 EQU   PGTBITS
@NM00046 EQU   PGTBITS
@NM00045 EQU   PGTBITS
PGTREAL  EQU   PGTRSA
@NM00044 EQU   FOEFLAG
@NM00043 EQU   FOEFLAG
@NM00042 EQU   FOEFLAG
@NM00041 EQU   FOEFLAG
@NM00040 EQU   FOEFLAG
@NM00039 EQU   FOEFLAG
@NM00038 EQU   FOEFLAG
FOEINT   EQU   FOEFLAG
PFTUIC   EQU   PFTE+15
PFTQNDX  EQU   PFTE+14
@NM00037 EQU   PFTFLAG2
@NM00036 EQU   PFTFLAG2
PFTPREF  EQU   PFTFLAG2
PFTSTEAL EQU   PFTFLAG2
PFTIRRG  EQU   PFTFLAG2
PFTVR    EQU   PFTFLAG2
PFTOFFLN EQU   PFTFLAG2
PFTOFINT EQU   PFTFLAG1
PFTVRALC EQU   PFTFLAG1
PFTBADPG EQU   PFTFLAG1
PFTLNGFX EQU   PFTFLAG1
PFTLSQA  EQU   PFTFLAG1
PFTVRINT EQU   PFTFLAG1
PFTONAVQ EQU   PFTFLAG1
PFTRSV1  EQU   PFTE+10
PFTBQPTR EQU   PFTQPTRS+2
PFTFQPTR EQU   PFTQPTRS
PFTASID  EQU   PFTPGID
PCBRWRKB EQU   PCBR+60
PCBRWRKA EQU   PCBR+56
PCBRWRK9 EQU   PCBR+52
PCBRWRK8 EQU   PCBR+48
PCBRWRK7 EQU   PCBR+44
PCBRWRK6 EQU   PCBR+40
PCBRWRK5 EQU   PCBR+36
PCBRWRK4 EQU   PCBR+32
PCBRWRK3 EQU   PCBR+28
PCBRWRK2 EQU   PCBR+24
PCBRWRK1 EQU   PCBR+20
PCBRRSV1 EQU   PCBR+18
PCBRASCB EQU   PCBR+12
PCBRECB  EQU   PCBR+8
PCBRPOF  EQU   PCBRFLAG
PCBRFECB EQU   PCBRFLAG
PCBRLOAD EQU   PCBRFLAG
PCBRFPCB EQU   PCBRFLAG
PCBRETRY EQU   PCBRFLAG
PCBRINT  EQU   PCBRFLAG
PCBEND   EQU   PCB+64
PCBAIA   EQU   PCB+36
PCBSPCTE EQU   PCBRB
PCBPGTA  EQU   PCBPGT+1
@NM00035 EQU   PCBFL3
PCBNOREC EQU   PCBFL3
PCBDFRLS EQU   PCBFL3
PCBSWPLS EQU   PCBFL3
PCBSWPIN EQU   PCBFL3
PCBSWPOT EQU   PCBFL3
PCBXPTA  EQU   PCBXPT+1
@NM00034 EQU   PCBFL2
@NM00033 EQU   PCBFL2
PCBVIO   EQU   PCBFL2
PCBSUPRS EQU   PCBFL2
PCBGFAD  EQU   PCBFL2
PCBIOI   EQU   PCBFL1
PCBLFR   EQU   PCBFL1
PCBPEX   EQU   PCBFL1
@NM00032 EQU   PCBFL1
PCBFQPA  EQU   PCBFQP+1
RSMASMHD EQU   RSMHD+40
RSMFOEQ  EQU   RSMHD+36
RSMLIOQF EQU   RSMLIOQ
RSMLSQAL EQU   RSMLSQA+2
RSMLSQAF EQU   RSMLSQA
RSMLFQL  EQU   RSMLFQ+2
RSMLFQF  EQU   RSMLFQ
RSMRSV2  EQU   RSMHD+16
RSMRSV1  EQU   RSMHD+13
@NM00031 EQU   RSMFLG1
RSMFAIL  EQU   RSMFLG1
RSMGFADD EQU   RSMFLG1
RSMCPNC  EQU   RSMFLG1
RSMCPNU  EQU   RSMFLG1
RSMGFAD  EQU   RSMFLG1
RSMASCB  EQU   RSMHD+8
RSMSPCT  EQU   RSMHD+4
RSMVSTO  EQU   RSMHD
PVTEND   EQU   PVT+1936
PVTVCONS EQU   PVT+1896
PVTPRSB  EQU   PVT+1892
PVTCIOQF EQU   PVTPCBQS+32
PVTGFADL EQU   PVTPCBQS+28
PVTGFADF EQU   PVTPCBQS+24
PVTFPCBL EQU   PVTPCBQS+20
PVTFPCBF EQU   PVTPCBQS+16
PVTPCBQR EQU   PVTPCBQS
PVTLPAFX EQU   PVT+1850
PVTLSQAF EQU   PVT+1848
PVTLPAR  EQU   PVT+1844
PVTLPAI  EQU   PVT+1840
PVTLPAFC EQU   PVT+1838
PVTCHUIC EQU   PVT+1836
PVTSQAFX EQU   PVT+1832
PVTDEFFX EQU   PVT+1828
PVTFIXOK EQU   PVT+1826
PVTPEROK EQU   PVT+1824
PVTMAXFX EQU   PVT+1822
PVTPERFX EQU   PVT+1820
PVTRSRB  EQU   PVT+1776
PVTRESV5 EQU   PVT+1773
PVTSRBS  EQU   PVT+1772
PVTSSRB  EQU   PVT+1768
PVTACA   EQU   PVTWSAX+1400
PVTWSA18 EQU   PVTWSAX+1256
PVTWSA17 EQU   PVTWSAX+1184
PVTWSA16 EQU   PVTWSAX+1112
PVTWSA15 EQU   PVTWSAX+1040
PVTWSA14 EQU   PVTWSAX+968
PVTWSA13 EQU   PVTWSAX+896
PVTWSA12 EQU   PVTWSAX+824
PVTWSA11 EQU   PVTWSAX+752
PVTWSA9  EQU   PVTWSAX+592
PVTWSA8  EQU   PVTWSAX+504
PVTWSA7  EQU   PVTWSAX+432
PVTWSA6  EQU   PVTWSAX+360
PVTWSA5  EQU   PVTWSAX+288
PVTWSA4  EQU   PVTWSAX+216
PVTWSA3  EQU   PVTWSAX+144
PVTWSA2  EQU   PVTWSAX+72
PVTWSA1  EQU   PVTWSAX
PVTPFTQR EQU   PVTQS+20
PVTRSBQL EQU   PVTQS+18
PVTRSBQF EQU   PVTQS+16
PVTSQAQL EQU   PVTQS+14
PVTSQAQF EQU   PVTQS+12
PVTCFQL  EQU   PVTQS+10
PVTCFQF  EQU   PVTQS+8
PVTRSRVL EQU   PVTQS+6
PVTRSRVF EQU   PVTQS+4
PVTAFQL  EQU   PVTQS+2
PVTAFQF  EQU   PVTQS
PVTSPFR  EQU   PVT+302
PVTCFMCT EQU   PVT+300
PVTSPREC EQU   PVT+296
PVTCAREC EQU   PVT+292
PVTCAOUT EQU   PVT+288
PVTCAIN  EQU   PVT+284
PVTNSWPS EQU   PVT+280
PVTNPREC EQU   PVT+276
PVTSPOUT EQU   PVT+272
PVTSPIN  EQU   PVT+268
PVTVAMR  EQU   PVT+264
PVTVAMO  EQU   PVT+260
PVTVAMI  EQU   PVT+256
PVTNPOUT EQU   PVT+252
PVTNPIN  EQU   PVT+248
PVTFRSLT EQU   PVT+240
PVTPAGIO EQU   PVT+236
PVTSWPIO EQU   PVT+232
PVTPSWPP EQU   PVT+228
PVTPPREF EQU   PVT+224
PVTPRELV EQU   PVT+212
PVTPFREE EQU   PVT+208
PVTPRELS EQU   PVT+204
PVTPOUT  EQU   PVT+200
PVTPFXLD EQU   PVT+196
PVTPITAS EQU   PVT+192
PVTPSRBP EQU   PVT+188
PVTPDSEG EQU   PVT+184
PVTPCSGB EQU   PVT+180
PVTPCSEG EQU   PVT+176
PVTPINV  EQU   PVT+172
PVTPSWPC EQU   PVT+168
PVTPSOUT EQU   PVT+164
PVTPSWIN EQU   PVT+160
PVTPRCFI EQU   PVT+152
PVTPRCF  EQU   PVT+148
PVTPVRC  EQU   PVT+144
PVTPVRIN EQU   PVT+140
PVTPVRLS EQU   PVT+136
PVTPVEQR EQU   PVT+132
PVTPPIOI EQU   PVT+128
PVTPVRPO EQU   PVT+124
PVTPRFR  EQU   PVT+120
PVTPFP2  EQU   PVT+116
PVTPFP   EQU   PVT+112
PVTREP2  EQU   PVT+100
PVTPIOCP EQU   PVT+96
PVTPIOP  EQU   PVT+92
PVTPGFAD EQU   PVT+88
PVTPGFA  EQU   PVT+84
PVTPSQA  EQU   PVT+80
PVTPSINT EQU   PVT+76
PVTPSIB  EQU   PVT+72
PVTPCIWA EQU   PVT+64
PVTHQSA  EQU   PVT+62
PVTLQSA  EQU   PVT+60
PVTOROOT EQU   PVT+56
PVTREUS  EQU   PVT+48
PVTRESV4 EQU   PVT+47
PVTVRDFC EQU   PVT+46
PVTRSUS  EQU   PVT+44
PVTVROOT EQU   PVT+40
PVTPCBLO EQU   PVT+38
PVTPCBCT EQU   PVT+36
PVTDFRS  EQU   PVT+34
PVTRSQA  EQU   PVT+32
PVTPTLB  EQU   PVT+31
PVTPCBNO EQU   PVT+30
PVTSRBNO EQU   PVT+29
PVTSQDC  EQU   PVT+28
PVTLPRIV EQU   PVT+24
PVTLVR   EQU   PVT+22
PVTFVR   EQU   PVT+20
PVTLPFN  EQU   PVT+18
PVTFPFN  EQU   PVT+16
PVTSSPIN EQU   PVT+11
PVTPCBS  EQU   PVT+10
PVTPOOL  EQU   PVT+8
PVTAFCOK EQU   PVT+6
PVTAFCLO EQU   PVT+4
PVTAFC   EQU   PVT+2
PVTFLAG2 EQU   PVT+1
PVTDUMP  EQU   PVTFLAG1
PVTSIT   EQU   PVTFLAG1
PVTLSI   EQU   PVTFLAG1
PVTRESV1 EQU   PVTFLAG1
PVTPCBLT EQU   PVTFLAG1
PVTSRBIU EQU   PVTFLAG1
PVTBGMS  EQU   PVTFLAG1
PVTPMSG  EQU   PVTFLAG1
@NM00030 EQU   TCBXTNT2+32
TCBRV181 EQU   TCBRV173
TCBRV180 EQU   TCBRV173
TCBRV179 EQU   TCBRV173
TCBRV178 EQU   TCBRV173
TCBRV177 EQU   TCBRV173
TCBRV176 EQU   TCBRV173
TCBRV175 EQU   TCBRV173
TCBRV174 EQU   TCBRV173
TCBRV172 EQU   TCBRV164
TCBRV171 EQU   TCBRV164
TCBRV170 EQU   TCBRV164
TCBRV169 EQU   TCBRV164
TCBRV168 EQU   TCBRV164
TCBRV167 EQU   TCBRV164
TCBRV166 EQU   TCBRV164
TCBRV165 EQU   TCBRV164
TCBRV163 EQU   TCBRV155
TCBRV162 EQU   TCBRV155
TCBRV161 EQU   TCBRV155
TCBRV160 EQU   TCBRV155
TCBRV159 EQU   TCBRV155
TCBRV158 EQU   TCBRV155
TCBRV157 EQU   TCBRV155
TCBRV156 EQU   TCBRV155
TCBRV154 EQU   TCBRV146
TCBRV153 EQU   TCBRV146
TCBRV152 EQU   TCBRV146
TCBRV151 EQU   TCBRV146
TCBRV150 EQU   TCBRV146
TCBRV149 EQU   TCBRV146
TCBRV148 EQU   TCBRV146
TCBRV147 EQU   TCBRV146
TCBRV145 EQU   TCBXTNT2+26
TCBRV144 EQU   TCBXTNT2+24
TCBRV143 EQU   TCBXTNT2+20
TCBRV142 EQU   TCBXTNT2+16
TCBRSV49 EQU   TCBXTNT2+12
TCBEVENT EQU   TCBXTNT2+8
TCBRCMP  EQU   TCBXTNT2+5
TCBRSVAB EQU   TCBXTNT2+4
TCBGTFA  EQU   TCBGTF+1
TCBRSV47 EQU   TCBTFLG
TCBRSV46 EQU   TCBTFLG
TCBRSV45 EQU   TCBTFLG
TCBRSV44 EQU   TCBTFLG
TCBRSV43 EQU   TCBTFLG
TCBDSPIT EQU   TCBTFLG
TCBERRTN EQU   TCBTFLG
TCBASYNC EQU   TCBTFLG
@NM00029 EQU   TCB+296
TCBSVCA2 EQU   TCB+292
TCBSWASA EQU   TCB+288
TCBDBTB  EQU   TCB+284
TCBRPT   EQU   TCB+280
TCBRV141 EQU   TCBRV133
TCBRV140 EQU   TCBRV133
TCBRV139 EQU   TCBRV133
TCBRV138 EQU   TCBRV133
TCBRV137 EQU   TCBRV133
TCBRV136 EQU   TCBRV133
TCBRV135 EQU   TCBRV133
TCBRV134 EQU   TCBRV133
TCBRV132 EQU   TCBRV124
TCBRV131 EQU   TCBRV124
TCBRV130 EQU   TCBRV124
TCBRV129 EQU   TCBRV124
TCBRV128 EQU   TCBRV124
TCBRV127 EQU   TCBRV124
TCBRV126 EQU   TCBRV124
TCBRV125 EQU   TCBRV124
TCBRV123 EQU   TCBFBYT2
TCBRV122 EQU   TCBFBYT2
TCBECBNV EQU   TCBFBYT2
TCBSSSYN EQU   TCBFBYT2
TCBFPRAP EQU   TCBFBYT2
TCBFDW   EQU   TCBFBYT2
TCBFMW   EQU   TCBFBYT2
TCBCNCB  EQU   TCBFBYT2
TCBLLH   EQU   TCBFBYT1
TCBRV113 EQU   TCBFBYT1
TCBEOT   EQU   TCBFBYT1
TCBRTM2  EQU   TCBFBYT1
TCBPGNLY EQU   TCBFBYT1
TCBNDIOS EQU   TCBFBYT1
TCBRV327 EQU   TCBFBYT1
TCBEOTFM EQU   TCBFBYT1
TCBAFFN  EQU   TCB+274
TCBRV326 EQU   TCB+272
TCBUKYSP EQU   TCB+268
TCBMODE  EQU   TCBESTAE+3
TCBERTYP EQU   TCBESTAE+2
TCBRV314 EQU   TCBESTRM
TCBRV313 EQU   TCBESTRM
TCBRV312 EQU   TCBESTRM
TCBRV311 EQU   TCBESTRM
TCBRV310 EQU   TCBESTRM
TCBRV309 EQU   TCBESTRM
TCBRV308 EQU   TCBESTRM
TCBETERM EQU   TCBESTRM
TCBSCBKY EQU   TCBESTAE
TCBRTM12 EQU   TCB+260
TCBTCBID EQU   TCB+256
TCBSTAWA EQU   TCB+252
TCBSWA   EQU   TCB+248
TCBRSV42 EQU   TCBFOE
TCBCCPVI EQU   TCBXSCT+2
TCBRV325 EQU   TCBXSCT+1
TCBRV324 EQU   TCBXSCT1
TCBRV323 EQU   TCBXSCT1
TCBRV322 EQU   TCBXSCT1
TCBRV321 EQU   TCBXSCT1
TCBRV320 EQU   TCBXSCT1
TCBRV319 EQU   TCBXSCT1
TCBS3A   EQU   TCBXSCT1
TCBACTIV EQU   TCBXSCT1
TCBRSV41 EQU   TCB+239
TCBTID   EQU   TCB+238
TCBRSVAA EQU   TCB+237
TCBABCUR EQU   TCB+236
TCBTMSAV EQU   TCB+232
TCBIOTIM EQU   TCB+228
TCBRTWA  EQU   TCB+224
TCBBACK  EQU   TCB+220
TCBTIRB  EQU   TCB+216
TCBAECB  EQU   TCB+212
TCBEXT2A EQU   TCBEXT2+1
TCBRSV39 EQU   TCBEXT2
TCBSTMCT EQU   TCB+207
TCBSYSCT EQU   TCB+206
TCBRSV37 EQU   TCB+205
TCBEXSVC EQU   TCBDAR
TCBDARMS EQU   TCBDAR
TCBDARWT EQU   TCBDAR
TCBDARO  EQU   TCBDAR
TCBDARMC EQU   TCBDARC
TCBDARD  EQU   TCBDAR
TCBDARS  EQU   TCBDAR
TCBDARP  EQU   TCBDAR
TCBGTOFM EQU   TCBFLGS7
TCBADMP  EQU   TCBFLGS7
TCBRSTSK EQU   TCBFLGS7
TCBSVCS  EQU   TCBFLGS7
TCBSTACK EQU   TCBFLGS7
TCBRSV34 EQU   TCBFLGS7
TCBRSV33 EQU   TCBFLGS7
TCBGPECB EQU   TCBFLGS7
TCBNTJS  EQU   TCBFLGS6
TCBAPG   EQU   TCBFLGS6
TCBMIGR  EQU   TCBFLGS6
TCBRV303 EQU   TCBFLGS6
TCBSPVLK EQU   TCBFLGS6
TCBCPU   EQU   TCBFLGS6
TCBPIE17 EQU   TCBFLGS6
TCBRV    EQU   TCBFLGS6
TCBRSV79 EQU   TCBNDSP5
TCBRSV78 EQU   TCBNDSP5
TCBRSV77 EQU   TCBNDSP5
TCBRSV76 EQU   TCBNDSP5
TCBRSV75 EQU   TCBNDSP5
TCBRSV74 EQU   TCBNDSP5
TCBRSV95 EQU   TCBNDSP5
TCBRSV94 EQU   TCBNDSP5
TCBRSV93 EQU   TCBNDSP4
TCBRSV92 EQU   TCBNDSP4
TCBRSV91 EQU   TCBNDSP4
TCBRSV90 EQU   TCBNDSP4
TCBRSV89 EQU   TCBNDSP4
TCBRSV88 EQU   TCBNDSP4
TCBRSV87 EQU   TCBNDSP4
TCBRSV86 EQU   TCBNDSP4
TCBEXT1A EQU   TCBEXT1+1
TCBRSV32 EQU   TCBEXT1
TCBEXCPD EQU   TCB+192
TCBIOBRC EQU   TCB+188
TCBDDWTC EQU   TCB+186
TCBDDEXC EQU   TCB+184
TCBJSCBB EQU   TCBJSCB+1
@NM00028 EQU   TCBRECDE
TCBREC   EQU   TCBRECDE
TCBMDIDS EQU   TCB+176
TCBNDINT EQU   TCBNDSP3
TCBRSV27 EQU   TCBNDSP3
TCBRSV26 EQU   TCBNDSP3
TCBRSV25 EQU   TCBNDSP3
TCBRSV24 EQU   TCBNDSP3
TCBSRBND EQU   TCBNDSP3
TCBRV302 EQU   TCBNDSP3
TCBLJSND EQU   TCBNDSP3
TCBABE   EQU   TCBNDSP2
TCBDSS   EQU   TCBNDSP2
TCBOWAIT EQU   TCBNDSP2
TCBIWAIT EQU   TCBNDSP2
TCBNDTS  EQU   TCBNDSP2
TCBNDSVC EQU   TCBNDSP2
TCBSTPP  EQU   TCBNDSP2
TCBABD   EQU   TCBNDSP2
TCBRSV22 EQU   TCBNDSP1
TCBPIEND EQU   TCBNDSP1
TCBTPSP  EQU   TCBNDSP1
TCBDDRND EQU   TCBNDSP1
TCBRSPND EQU   TCBNDSP1
TCBRSTND EQU   TCBNDSP1
TCBDARPN EQU   TCBNDSP1
TCBDARTN EQU   TCBNDSP1
TCBNDSP0 EQU   TCBNDSP
TCBUSER  EQU   TCB+168
TCBTCTB  EQU   TCBTCT+1
TCBRSV9C EQU   TCBTCTGF
TCBRSV9B EQU   TCBTCTGF
TCBRSV9A EQU   TCBTCTGF
TCBRSV99 EQU   TCBTCTGF
TCBRSV98 EQU   TCBTCTGF
TCBRSV97 EQU   TCBTCTGF
TCBRSV20 EQU   TCBTCTGF
TCBSMFGF EQU   TCBTCTGF
TCBSTABB EQU   TCBSTAB+1
TCBSTCUR EQU   TCBNSTAE
TCBRV301 EQU   TCBNSTAE
TCBSYNCH EQU   TCBNSTAE
TCBHALT  EQU   TCBNSTAE
TCBPPSUP EQU   TCBNSTAE
TCB33E   EQU   TCBNSTAE
TCBQUIES EQU   TCBNSTAE
TCBSTABE EQU   TCBNSTAE
TCBAQE   EQU   TCB+156
TCBPQE   EQU   TCB+152
TCBTSDP  EQU   TCB+151
TCBTSLP  EQU   TCB+150
TCBSTPCT EQU   TCB+149
TCBCPUBN EQU   TCBTSFLG
TCBDYDSP EQU   TCBTSFLG
TCBRSV18 EQU   TCBTSFLG
TCBRSV17 EQU   TCBTSFLG
TCBTIOTG EQU   TCBTSFLG
TCBATT   EQU   TCBTSFLG
TCBSTPPR EQU   TCBTSFLG
TCBRV300 EQU   TCBTSTSK
TCBECB   EQU   TCB+144
TCBIQE   EQU   TCB+140
TCBLTC   EQU   TCB+136
TCBOTC   EQU   TCB+132
TCBNTC   EQU   TCB+128
TCBJSTCA EQU   TCBJSTCB+1
TCBRSV16 EQU   TCBJSTCB
TCBTQET  EQU   TCBTME
TCBTCB   EQU   TCB+116
TCBFSAB  EQU   TCBFSA+1
TCBQEL   EQU   TCBFSA
TCBGRS15 EQU   TCBGRS+60
TCBGRS14 EQU   TCBGRS+56
TCBGRS13 EQU   TCBGRS+52
TCBGRS12 EQU   TCBGRS+48
TCBGRS11 EQU   TCBGRS+44
TCBGRS10 EQU   TCBGRS+40
TCBGRS9  EQU   TCBGRS+36
TCBGRS8  EQU   TCBGRS+32
TCBGRS7  EQU   TCBGRS+28
TCBGRS6  EQU   TCBGRS+24
TCBGRS5  EQU   TCBGRS+20
TCBGRS4  EQU   TCBGRS+16
TCBGRS3  EQU   TCBGRS+12
TCBGRS2  EQU   TCBGRS+8
TCBGRS1  EQU   TCBGRS+4
TCBGRS0  EQU   TCBGRS
TCBJPQB  EQU   TCBJPQ+1
TCBRSV15 EQU   TCBPURGE
TCBRSV14 EQU   TCBPURGE
TCBRSV13 EQU   TCBPURGE
TCBRSV12 EQU   TCBPURGE
TCBRSV11 EQU   TCBPURGE
TCBRSV10 EQU   TCBPURGE
TCBRSV09 EQU   TCBPURGE
TCBJPQF  EQU   TCBPURGE
TCBJLB   EQU   TCB+40
TCBLLS   EQU   TCB+36
TCBDSP   EQU   TCB+35
TCBLMP   EQU   TCB+34
TCBPNDSP EQU   TCBFLGS5
TCBFCD1  EQU   TCBFLGS5
TCBSTP   EQU   TCBFLGS5
TCBSYS   EQU   TCBFLGS5
TCBANDSP EQU   TCBFLGS5
TCBPAGE  EQU   TCBFLGS5
TCBUXNDF EQU   TCBABWF
TCBFC    EQU   TCBFLGS5
TCBONDSP EQU   TCBFLGS4
TCBMPCND EQU   TCBFLGS4
TCBMPCVQ EQU   TCBFLGS4
TCBUXNDV EQU   TCBFLGS4
TCBHNDSP EQU   TCBFLGS4
TCBRQENA EQU   TCBFLGS4
TCBSER   EQU   TCBFLGS4
TCBNDUMP EQU   TCBFLGS4
TCBDWSTA EQU   TCBFLGS3
TCBRSV08 EQU   TCBFLGS3
TCBRSV07 EQU   TCBFLGS3
TCBRSV06 EQU   TCBFLGS3
TCBABGM  EQU   TCBFLGS3
TCBABTRM EQU   TCBFLGS3
TCBADINP EQU   TCBFLGS3
TCBFSM   EQU   TCBFLGS3
TCBFTS   EQU   TCBFLGS2
TCBFETXR EQU   TCBFLGS2
TCBFDSOP EQU   TCBFLGS2
TCBFJMC  EQU   TCBFLGS2
TCBFSMC  EQU   TCBFLGS2
TCBFABOP EQU   TCBFLGS2
TCBFSTI  EQU   TCBFLGS2
TCBFOINP EQU   TCBFLGS2
TCBFX    EQU   TCBFLGS1
TCBFS    EQU   TCBFLGS1
TCBFT    EQU   TCBFLGS1
TCBPDUMP EQU   TCBFLGS1
TCBNONPR EQU   TCBFLGS1
TCBFERA  EQU   TCBFLGS1
TCBFE    EQU   TCBFLGS1
TCBFA    EQU   TCBFLGS1
TCBZERO  EQU   TCBPKF
TCBFLAG  EQU   TCBPKF
TCBMSSB  EQU   TCBMSS+1
TCBRSV03 EQU   TCBMSS
TCBTRNB  EQU   TCBTRN+1
TCBRSV02 EQU   TCBABF
TCBOLTEP EQU   TCBABF
TCBTCP   EQU   TCBABF
TCBTCPP  EQU   TCBABF
TCBRSV01 EQU   TCBABF
TCBGRPH  EQU   TCBABF
TCBNOCHK EQU   TCBABF
TCBMOD91 EQU   TCBABF
TCBCMPC  EQU   TCBCMP+1
TCBRV318 EQU   TCBCMSG
TCBRV317 EQU   TCBCIND
TCBRV316 EQU   TCBCWTO
TCBCASID EQU   TCBCDBL
TCBNOCC  EQU   TCBSTCC
TCBDMPO  EQU   TCBCPP
TCBCSTEP EQU   TCBCMPF
TCBCREQ  EQU   TCBCMPF
TCBTIO   EQU   TCB+12
TCBDEB   EQU   TCB+8
TCBPIEA  EQU   TCBPIE+1
TCBPM    EQU   TCBPMASK
@NM00027 EQU   TCBPMASK
TCBRBP   EQU   TCB
TCBFRS6  EQU   TCBFRS+24
TCBFRS4  EQU   TCBFRS+16
TCBFRS2  EQU   TCBFRS+8
TCBFRS0  EQU   TCBFRS
ASCBEND  EQU   ASCB+208
ASCBSRBT EQU   ASCB+200
ASCBSWTL EQU   ASCB+196
ASCBRS14 EQU   ASCB+195
ASCBSMCT EQU   ASCB+194
ASCBRS12 EQU   ASCB+192
ASCBPCTT EQU   ASCB+188
ASCBVGTT EQU   ASCB+184
ASCBRV43 EQU   ASCBSRQ4
ASCBRV42 EQU   ASCBSRQ4
ASCBRV41 EQU   ASCBSRQ4
ASCBRV40 EQU   ASCBSRQ4
ASCBRV39 EQU   ASCBSRQ4
ASCBRV38 EQU   ASCBSRQ4
ASCBRV37 EQU   ASCBSRQ4
ASCBRV36 EQU   ASCBSRQ4
ASCBRV35 EQU   ASCBSRQ3
ASCBRV34 EQU   ASCBSRQ3
ASCBRV33 EQU   ASCBSRQ3
ASCBRV32 EQU   ASCBSRQ3
ASCBRV31 EQU   ASCBSRQ3
ASCBRV30 EQU   ASCBSRQ3
ASCBRV29 EQU   ASCBSRQ3
ASCBRV28 EQU   ASCBSRQ3
ASCBRV27 EQU   ASCBSRQ2
ASCBRV26 EQU   ASCBSRQ2
ASCBRV25 EQU   ASCBSRQ2
ASCBRV24 EQU   ASCBSRQ2
ASCBRV23 EQU   ASCBSRQ2
ASCBRV22 EQU   ASCBSRQ2
ASCBRV21 EQU   ASCBSRQ2
ASCBRV20 EQU   ASCBSRQ2
ASCBRV19 EQU   ASCBSRQ1
ASCBRV18 EQU   ASCBSRQ1
ASCBRV17 EQU   ASCBSRQ1
ASCBRV16 EQU   ASCBSRQ1
ASCBRV15 EQU   ASCBSRQ1
ASCBRV14 EQU   ASCBSRQ1
ASCBRV13 EQU   ASCBSRQ1
ASCBSTA  EQU   ASCBSRQ1
ASCBJBNS EQU   ASCB+176
ASCBJBNI EQU   ASCB+172
ASCBMCC  EQU   ASCB+168
ASCBRTWA EQU   ASCB+164
ASCBIQEA EQU   ASCB+160
ASCBXMPQ EQU   ASCB+156
ASCBRS01 EQU   ASCB+154
ASCBFMCT EQU   ASCB+152
ASCBOUXB EQU   ASCB+148
ASCBOUCB EQU   ASCB+144
ASCBMECB EQU   ASCB+140
ASCBQECB EQU   ASCB+136
ASCBLSQH EQU   ASCBLKGP+4
ASCBLOCK EQU   ASCBLKGP
ASCBTCBS EQU   ASCB+124
ASCBNVSC EQU   ASCB+122
ASCBVSC  EQU   ASCB+120
ASCBSRBS EQU   ASCB+118
ASCBSSRB EQU   ASCB+116
ASCBRV06 EQU   ASCBFLG2
ASCBRV05 EQU   ASCBFLG2
ASCBRV04 EQU   ASCBFLG2
ASCBSNQS EQU   ASCBFLG2
ASCBS2S  EQU   ASCBFLG2
ASCBCEXT EQU   ASCBFLG2
ASCBPXMT EQU   ASCBFLG2
ASCBXMPT EQU   ASCBFLG2
ASCBRF07 EQU   ASCBDSP1
ASCBRF06 EQU   ASCBDSP1
ASCBRF05 EQU   ASCBDSP1
ASCBRF04 EQU   ASCBDSP1
ASCBRF03 EQU   ASCBDSP1
ASCBRF02 EQU   ASCBDSP1
ASCBFAIL EQU   ASCBDSP1
ASCBNOQ  EQU   ASCBDSP1
ASCBSWCT EQU   ASCB+112
ASCBASXB EQU   ASCB+108
ASCBTMCH EQU   ASCB+104
ASCBNSWP EQU   ASCBFLG1
ASCBTYP1 EQU   ASCBFLG1
ASCBSTND EQU   ASCBFLG1
ASCBABNT EQU   ASCBFLG1
ASCBTERM EQU   ASCBFLG1
ASCBS3S  EQU   ASCBFLG1
ASCBCMSH EQU   ASCBFLG1
ASCBTOFF EQU   ASCBFLG1
ASCBRF01 EQU   ASCBRCTF
ASCBTMLW EQU   ASCBRCTF
ASCBOUT  EQU   ASCBRCTF
ASCBWAIT EQU   ASCBRCTF
ASCBRV08 EQU   ASCBRCTF
ASCBFQU  EQU   ASCBRCTF
ASCBFRS  EQU   ASCBRCTF
ASCBTMNO EQU   ASCBRCTF
ASCBAFFN EQU   ASCBFW1
ASCBDUMP EQU   ASCB+96
ASCBRV44 EQU   ASCB+92
ASCBUBET EQU   ASCB+88
ASCBECB  EQU   ASCB+84
ASCBJSTL EQU   ASCB+80
ASCBEWST EQU   ASCB+72
ASCBEJST EQU   ASCB+64
ASCBTSB  EQU   ASCB+60
ASCBCSCB EQU   ASCB+56
ASCBLDA  EQU   ASCB+48
ASCBSTOR EQU   ASCB+44
ASCBDP   EQU   ASCB+43
ASCBRV07 EQU   ASCB+42
ASCBIOSM EQU   ASCB+40
ASCBSEQN EQU   ASCB+38
ASCBASID EQU   ASCB+36
ASCBCPUS EQU   ASCB+32
ASCBSPL  EQU   ASCB+28
ASCBIOSP EQU   ASCB+24
ASCBSYNC EQU   ASCBSUPC+4
ASCBSVRB EQU   ASCBSUPC
ASCBCMSF EQU   ASCB+12
ASCBBWDP EQU   ASCB+8
ASCBFWDP EQU   ASCB+4
ASCBASCB EQU   ASCB
ASCBEGIN EQU   ASCB
CVTLEVL  EQU   CVTRELNO+2
CVTNUMB  EQU   CVTRELNO
CVTMDL   EQU   CVTFIX+250
@NM00026 EQU   CVTFIX+248
@NM00025 EQU   CVTFIX
CVTRV482 EQU   CVTXTNT2+128
CVTRV481 EQU   CVTXTNT2+124
CVTRV480 EQU   CVTXTNT2+120
CVTRV479 EQU   CVTXTNT2+118
CVTRV478 EQU   CVTXTNT2+117
CVTRV477 EQU   CVTXTNT2+116
CVTRV476 EQU   CVTXTNT2+115
CVTRV475 EQU   CVTXTNT2+114
CVTRV474 EQU   CVTRV466
CVTRV473 EQU   CVTRV466
CVTRV472 EQU   CVTRV466
CVTRV471 EQU   CVTRV466
CVTRV470 EQU   CVTRV466
CVTRV469 EQU   CVTRV466
CVTRV468 EQU   CVTRV466
CVTRV467 EQU   CVTRV466
CVTRV465 EQU   CVTRV457
CVTRV464 EQU   CVTRV457
CVTRV463 EQU   CVTRV457
CVTRV462 EQU   CVTRV457
CVTRV461 EQU   CVTRV457
CVTRV460 EQU   CVTRV457
CVTRV459 EQU   CVTRV457
CVTRV458 EQU   CVTRV457
CVTRV456 EQU   CVTXTNT2+108
CVTRV455 EQU   CVTXTNT2+104
CVTRV454 EQU   CVTXTNT2+100
CVTRV453 EQU   CVTXTNT2+96
CVTRV452 EQU   CVTXTNT2+94
CVTRV451 EQU   CVTXTNT2+92
CVTRV450 EQU   CVTXTNT2+90
CVTRV449 EQU   CVTXTNT2+88
CVTRV448 EQU   CVTXTNT2+87
CVTRV447 EQU   CVTXTNT2+86
CVTRV446 EQU   CVTRV438
CVTRV445 EQU   CVTRV438
CVTRV444 EQU   CVTRV438
CVTRV443 EQU   CVTRV438
CVTRV442 EQU   CVTRV438
CVTRV441 EQU   CVTRV438
CVTRV440 EQU   CVTRV438
CVTRV439 EQU   CVTRV438
CVTRV437 EQU   CVTRV429
CVTRV436 EQU   CVTRV429
CVTRV435 EQU   CVTRV429
CVTRV434 EQU   CVTRV429
CVTRV433 EQU   CVTRV429
CVTRV432 EQU   CVTRV429
CVTRV431 EQU   CVTRV429
CVTRV430 EQU   CVTRV429
CVTRV428 EQU   CVTXTNT2+80
CVTRV427 EQU   CVTXTNT2+76
CVTRV426 EQU   CVTXTNT2+72
CVTRV425 EQU   CVTXTNT2+68
CVTATACT EQU   CVTATCVT
CVTRV423 EQU   CVTXTNT2+62
CVTRV422 EQU   CVTXTNT2+60
CVTRV421 EQU   CVTXTNT2+58
CVTRV420 EQU   CVTXTNT2+56
CVTRV419 EQU   CVTXTNT2+55
CVTRV418 EQU   CVTXTNT2+54
CVTRV417 EQU   CVTRV409
CVTRV416 EQU   CVTRV409
CVTRV415 EQU   CVTRV409
CVTRV414 EQU   CVTRV409
CVTRV413 EQU   CVTRV409
CVTRV412 EQU   CVTRV409
CVTRV411 EQU   CVTRV409
CVTRV410 EQU   CVTRV409
CVTRV408 EQU   CVTRV400
CVTRV407 EQU   CVTRV400
CVTRV406 EQU   CVTRV400
CVTRV405 EQU   CVTRV400
CVTRV404 EQU   CVTRV400
CVTRV403 EQU   CVTRV400
CVTRV402 EQU   CVTRV400
CVTRV401 EQU   CVTRV400
CVTICB   EQU   CVTXTNT2+48
CVTSKTA  EQU   CVTXTNT2+44
CVTRSV99 EQU   CVTXTNT2+40
CVTRSV98 EQU   CVTXTNT2+36
CVTRSV97 EQU   CVTXTNT2+34
CVTRSV96 EQU   CVTXTNT2+32
CVTOLTEP EQU   CVTXTNT2+28
CVTQIDA  EQU   CVTQID+1
CVTRSV95 EQU   CVTQID
CVTRSV94 EQU   CVTXTNT2+20
CVTRSV93 EQU   CVTXTNT2+16
CVTRSV92 EQU   CVTXTNT2+12
CVTDEBVR EQU   CVTXTNT2+8
CVTRSV91 EQU   CVTXTNT2+6
CVTRSV9H EQU   CVTFLGBT
CVTRSV9G EQU   CVTFLGBT
CVTRSV9F EQU   CVTFLGBT
CVTRSV9E EQU   CVTFLGBT
CVTRSV9D EQU   CVTFLGBT
CVTBAH   EQU   CVTFLGBT
CVTVME   EQU   CVTFLGBT
CVTNPE   EQU   CVTFLGBT
CVTNUCLS EQU   CVTXTNT2+4
CVTDSSVA EQU   CVTDSSV+1
CVTRSV89 EQU   CVTDSSV
CVTRSV88 EQU   CVTXTNT1+8
CVTRSV87 EQU   CVTXTNT1+4
CVTFACHN EQU   CVTXTNT1
CVTRV488 EQU   CVTMAP+412
CVTRV487 EQU   CVTMAP+408
CVTRV486 EQU   CVTMAP+404
CVTRV485 EQU   CVTMAP+400
CVTACTAP EQU   CVTMAP+396
CVTAUTH  EQU   CVTMAP+392
CVTRV490 EQU   CVTMAP+388
CVTRSV61 EQU   CVTMAP+384
CVTVOLT1 EQU   CVTVOLM1+1
CVTVOLI1 EQU   CVTVOLF1
CVTSTOA  EQU   CVTMAP+376
CVTRSV58 EQU   CVTMAP+374
CVTRSV57 EQU   CVTMAP+372
CVTDDCE  EQU   CVTMAP+368
CVTPNWFR EQU   CVTMAP+364
CVTSMF   EQU   CVTMAP+360
CVTSULK  EQU   CVTMAP+358
CVTSLKO  EQU   CVTSYSK
CVTSLKP  EQU   CVTSYSK
CVTSLKQ  EQU   CVTSYSK
CVTSLKR  EQU   CVTSYSK
CVTRSV56 EQU   CVTSYSK
CVTRSV55 EQU   CVTSYSK
CVTRSV54 EQU   CVTSYSK
CVTRSV53 EQU   CVTSYSK
CVTRSV52 EQU   CVTA1F1
CVTRSV51 EQU   CVTA1F1
CVTRSV50 EQU   CVTA1F1
CVTRSV49 EQU   CVTA1F1
CVTRSV48 EQU   CVTA1F1
CVTRSV47 EQU   CVTA1F1
CVTSRSW  EQU   CVTA1F1
CVTPFSW  EQU   CVTA1F1
CVTPCVT  EQU   CVTMAP+352
CVTRSV46 EQU   CVTMAP+344
CVTRSV45 EQU   CVTMAP+340
CVTRSV44 EQU   CVTMAP+338
CVTRSV43 EQU   CVTMAP+336
CVTHJESA EQU   CVTHJES+1
CVTRSV42 EQU   CVTHJES
CVTEXT2A EQU   CVTEXT2+1
CVTRSV41 EQU   CVTEXT2
CVTAPFA  EQU   CVTAPF+1
CVTRSV40 EQU   CVTAPF
CVTRV518 EQU   CVTINTLA
CVTRV517 EQU   CVTERPV
CVTEORM  EQU   CVTMAP+312
CVTMCHPR EQU   CVTMAP+308
CVTTZ    EQU   CVTMAP+304
CVTJEPS  EQU   CVTMAP+300
CVTJESCT EQU   CVTMAP+296
CVTMODE  EQU   CVTMAP+292
CVTPTRV  EQU   CVTMAP+288
CVTREAL  EQU   CVTMAP+284
CVTRSV39 EQU   CVTMAP+280
CVTRSV38 EQU   CVTMAP+276
CVTDMSRA EQU   CVTDMSR+1
CVTRV634 EQU   CVTDMSRF
CVTRV633 EQU   CVTDMSRF
CVTRV632 EQU   CVTDMSRF
CVTRV631 EQU   CVTDMSRF
CVTRV630 EQU   CVTDMSRF
CVTRV629 EQU   CVTDMSRF
CVTUDUMP EQU   CVTDMSRF
CVTSDUMP EQU   CVTDMSRF
CVTQMSGA EQU   CVTQMSG+1
CVTRSV36 EQU   CVTQMSG
CVTAMFF  EQU   CVTMAP+264
CVTPURGA EQU   CVTPURG+1
CVTRSV35 EQU   CVTPURG
CVTCBSP  EQU   CVTMAP+256
CVTATERA EQU   CVTATER+1
CVTSYST  EQU   CVTATER
CVTVOLT2 EQU   CVTTAT
CVTVOLI2 EQU   CVTVOLF2
CVTAQAVB EQU   CVTAQAVT+1
CVTRSV34 EQU   CVTTCMFG
CVTRSV33 EQU   CVTTCMFG
CVTRSV32 EQU   CVTTCMFG
CVTRSV31 EQU   CVTTCMFG
CVTRSV30 EQU   CVTTCMFG
CVTRSV29 EQU   CVTTCMFG
CVTLDEV  EQU   CVTTCMFG
CVTTCRDY EQU   CVTTCMFG
CVTGTFA  EQU   CVTGTF+1
CVTRSV27 EQU   CVTGTFST
CVTRNIO  EQU   CVTGTFST
CVTUSR   EQU   CVTGTFST
CVTRV318 EQU   CVTFORM
CVTRV317 EQU   CVTTMODE
CVTRV316 EQU   CVTSTATE
CVTRV315 EQU   CVTGTFS
CVTGTFAV EQU   CVTGTFS
CVT0SCR1 EQU   CVTMAP+232
CVTRV515 EQU   CVTMAP+228
CVTRMS   EQU   CVTMAP+224
CVTPATCH EQU   CVTMAP+220
CVTTSCE  EQU   CVTMAP+216
CVTLNKSC EQU   CVTMAP+214
CVTQABST EQU   CVTMAP+212
CVTMDLDS EQU   CVTMAP+208
CVTUSER  EQU   CVTMAP+204
CVTABEND EQU   CVTMAP+200
CVTSMCA  EQU   CVTMAP+196
CVTRSV18 EQU   CVTMAP+192
CVTQLPAQ EQU   CVTMAP+188
CVTQCDSR EQU   CVTMAP+184
CVTRSV17 EQU   CVTOPTB
CVTVS1A  EQU   CVTOPTB
CVTFP    EQU   CVTOPTB
CVTAPTHR EQU   CVTOPTB
CVTNLOG  EQU   CVTOPTB
CVTTOD   EQU   CVTOPTB
CVTCTIMS EQU   CVTOPTB
CVTPROT  EQU   CVTOPTB
CVTXPFP  EQU   CVTOPTA
CVTASCII EQU   CVTOPTA
CVTRSV13 EQU   CVTOPTA
CVTRSV12 EQU   CVTOPTA
CVTNIP   EQU   CVTOPTA
CVTDDR   EQU   CVTOPTA
CVTAPR   EQU   CVTOPTA
CVTCCH   EQU   CVTOPTA
CVTSNCTR EQU   CVTMAP+180
CVTQMWR  EQU   CVTMAP+176
CVTQOCR  EQU   CVTMAP+172
CVT1EF00 EQU   CVTMAP+168
CVTMZ00  EQU   CVTMAP+164
CVTHEAD  EQU   CVTMAP+160
CVTRSV11 EQU   CVTMAP+156
CVT0PT01 EQU   CVTMAP+152
CVTMSER  EQU   CVTMAP+148
CVTRV516 EQU   CVTIERLC
CVTILCH  EQU   CVTMAP+140
CVT0DS   EQU   CVTMAP+136
CVTFBOSV EQU   CVTMAP+132
CVTNUCB  EQU   CVTMAP+128
CVTIXAVL EQU   CVTMAP+124
CVTIOQET EQU   CVTMAP+120
CVTDCBA  EQU   CVTMAP+117
CVTMVS2  EQU   CVTDCB
CVT6DAT  EQU   CVTDCB
CVT4MPS  EQU   CVTDCB
CVTRSV09 EQU   CVTDCB
CVT4MS1  EQU   CVTDCB
CVT2SPS  EQU   CVTDCB
CVT1SSS  EQU   CVTDCB
CVTRSV08 EQU   CVTDCB
CVTSTB   EQU   CVTMAP+112
CVTQTD00 EQU   CVTMAP+108
CVTQTE00 EQU   CVTMAP+104
CVTCUCB  EQU   CVTMAP+100
CVTSJQ   EQU   CVTMAP+96
CVTPBLDL EQU   CVTMAP+92
CVTTPC   EQU   CVTMAP+88
CVTSVDCB EQU   CVTMAP+84
CVTBRET  EQU   CVTMAP+82
CVTEXIT  EQU   CVTMAP+80
CVT0FN00 EQU   CVTMAP+76
CVTDARA  EQU   CVTDAR+1
CVTRSV07 EQU   CVTFLGS1
CVTRSV06 EQU   CVTFLGS1
CVTRSV05 EQU   CVTFLGS1
CVTRSV04 EQU   CVTFLGS1
CVTRSV03 EQU   CVTFLGS1
CVTRSV02 EQU   CVTFLGS1
CVTRSV01 EQU   CVTFLGS1
CVTDMPLK EQU   CVTFLGS1
CVTXITP  EQU   CVTMAP+68
CVTZDTAB EQU   CVTMAP+64
CVTMSLT  EQU   CVTMAP+60
CVTDATE  EQU   CVTMAP+56
CVTBTERM EQU   CVTMAP+52
CVTSYSAD EQU   CVTMAP+48
CVTXTLER EQU   CVTMAP+44
CVTILK2  EQU   CVTMAP+40
CVTILK1  EQU   CVTMAP+36
CVTPRLTV EQU   CVTMAP+32
CVTPCNVT EQU   CVTMAP+28
CVT0VL00 EQU   CVTMAP+24
CVTXAPG  EQU   CVTMAP+20
CVTBUF   EQU   CVTMAP+16
CVTJOB   EQU   CVTMAP+12
CVTLINK  EQU   CVTMAP+8
CVT0EF00 EQU   CVTMAP+4
CVTTCBP  EQU   CVTMAP
CVT      EQU   CVTMAP
@NM00024 EQU   PSA+3668
PSASTAK  EQU   PSA+3072
@NM00023 EQU   PSA+1048
PSAUSEND EQU   PSA+1048
PSARV062 EQU   PSA+1044
PSACDAL  EQU   PSA+1040
PSAWTCOD EQU   PSA+1036
PSAATCVT EQU   PSA+1032
PSAPCPSW EQU   PSA+1024
PSAPIR2  EQU   PSA+1020
PSARV059 EQU   PSA+1018
PSASVC13 EQU   PSA+1016
PSALSFCC EQU   PSA+1012
PSASFACC EQU   PSA+1008
PSASTOP  EQU   PSA+992
PSASTART EQU   PSA+976
PSARSPSW EQU   PSA+968
PSASRPSW EQU   PSA+960
PSARV045 EQU   PSA+892
PSARV044 EQU   PSA+888
PSARV043 EQU   PSA+884
PSARV042 EQU   PSA+880
PSARV041 EQU   PSA+876
PSARV040 EQU   PSA+872
PSARV025 EQU   PSA+868
PSADSSED EQU   PSA+868
PSADSSPR EQU   PSA+864
PSADSSFW EQU   PSA+860
PSADSS14 EQU   PSA+856
PSADSSPP EQU   PSA+848
PSADSSRP EQU   PSA+840
PSADSS05 EQU   PSADSSF4
PSADSS10 EQU   PSADSSF4
PSADSSVE EQU   PSADSSF4
PSADSSDE EQU   PSADSSF4
PSADSSC0 EQU   PSADSSF4
PSADSSIE EQU   PSADSSF4
PSADSS12 EQU   PSADSSF4
PSADSSRC EQU   PSADSSF4
PSARV057 EQU   PSADSSF3
PSARV056 EQU   PSADSSF3
PSARV055 EQU   PSADSSF3
PSADSSMC EQU   PSADSSF3
PSADSSRW EQU   PSADSSF3
PSADSSNM EQU   PSADSSF3
PSADSSES EQU   PSADSSF3
PSADSSGP EQU   PSADSSF3
PSADSSF2 EQU   PSADSSFL+1
PSADSSPI EQU   PSADSSF1
PSADSSOI EQU   PSADSSF1
PSADSSSP EQU   PSADSSF1
PSADSSTP EQU   PSADSSF1
PSADSSDW EQU   PSADSSF1
PSADSSDD EQU   PSADSSF1
PSADSSDM EQU   PSADSSF1
PSADSSMV EQU   PSADSSF1
PSADSSTS EQU   PSA+816
PSADSSWK EQU   PSA+812
PSADSSR3 EQU   PSA+808
PSADSSR2 EQU   PSA+804
PSADSSRS EQU   PSA+800
PSASTOR  EQU   PSA+796
PSACPUSA EQU   PSA+794
PSAVSTAP EQU   PSA+792
PSAWKVAP EQU   PSA+788
PSAWKRAP EQU   PSA+784
PSAMCHIC EQU   PSA+783
PSARV061 EQU   PSA+782
PSASYMSK EQU   PSA+781
PSAMCHFL EQU   PSA+780
PSACR0   EQU   PSA+776
PSAPSWSV EQU   PSA+768
PSALITA  EQU   PSA+764
PSACLHS  EQU   PSAHLHI
PSALKR15 EQU   PSALKSA+60
PSALKR14 EQU   PSALKSA+56
PSALKR13 EQU   PSALKSA+52
PSALKR12 EQU   PSALKSA+48
PSALKR11 EQU   PSALKSA+44
PSALKR10 EQU   PSALKSA+40
PSALKR9  EQU   PSALKSA+36
PSALKR8  EQU   PSALKSA+32
PSALKR7  EQU   PSALKSA+28
PSALKR6  EQU   PSALKSA+24
PSALKR5  EQU   PSALKSA+20
PSALKR4  EQU   PSALKSA+16
PSALKR3  EQU   PSALKSA+12
PSALKR2  EQU   PSALKSA+8
PSALKR1  EQU   PSALKSA+4
PSALKR0  EQU   PSALKSA
PSARV023 EQU   PSACLHT+52
PSALOCAL EQU   PSACLHT+48
PSACMSL  EQU   PSACLHT+44
PSAOPTL  EQU   PSACLHT+40
PSATPACL EQU   PSACLHT+36
PSATPDNL EQU   PSACLHT+32
PSATPNCL EQU   PSACLHT+28
PSAIOSLL EQU   PSACLHT+24
PSAIOSUL EQU   PSACLHT+20
PSAIOSCL EQU   PSACLHT+16
PSAIOSSL EQU   PSACLHT+12
PSASALCL EQU   PSACLHT+8
PSAASML  EQU   PSACLHT+4
PSADISPL EQU   PSACLHT
PSASRSA  EQU   PSA+636
PSARV050 EQU   PSA+634
PSADSSGO EQU   PSA+633
PSARECUR EQU   PSA+632
PSAHLHIS EQU   PSA+628
PSAIPCSA EQU   PSA+624
@NM00022 EQU   PSA+621
PSAIPCDM EQU   PSA+620
PSAIPCD  EQU   PSA+616
@NM00021 EQU   PSA+613
PSAIPCRM EQU   PSA+612
PSAIPCR  EQU   PSA+608
PSAMCHEX EQU   PSA+600
PSAMPSW  EQU   PSA+592
PSAEXPS2 EQU   PSA+584
PSAEXPS1 EQU   PSA+576
PSAPIREG EQU   PSA+572
PSARSREG EQU   PSA+568
PSAGPREG EQU   PSA+556
PSARV022 EQU   PSASUP4
PSARV021 EQU   PSASUP4
PSARV020 EQU   PSASUP4
PSARV019 EQU   PSASUP4
PSARV018 EQU   PSASUP4
PSARV017 EQU   PSASUP4
PSARV016 EQU   PSASUP4
PSARV015 EQU   PSASUP4
PSARV014 EQU   PSASUP3
PSARV013 EQU   PSASUP3
PSARV012 EQU   PSASUP3
PSAESTA  EQU   PSASUP3
PSASPR   EQU   PSASUP3
PSAPSREG EQU   PSASUP3
PSAPI2   EQU   PSASUP3
PSAIOSUP EQU   PSASUP3
PSALCR   EQU   PSASUP2
PSARTM   EQU   PSASUP2
PSAACR   EQU   PSASUP2
PSAIPCE2 EQU   PSASUP2
PSAIPCES EQU   PSASUP2
PSAIPCEC EQU   PSASUP2
PSAGTF   EQU   PSASUP2
PSAIPCRI EQU   PSASUP2
PSATYPE6 EQU   PSASUP1
PSATCTL  EQU   PSASUP1
PSADISP  EQU   PSASUP1
PSALOCK  EQU   PSASUP1
PSAPI    EQU   PSASUP1
PSAEXT   EQU   PSASUP1
PSASVC   EQU   PSASUP1
PSAIO    EQU   PSASUP1
PSAANEW  EQU   PSA+544
PSATOLD  EQU   PSA+540
PSATNEW  EQU   PSA+536
PSALCCAR EQU   PSA+532
PSALCCAV EQU   PSA+528
PSAPCCAR EQU   PSA+524
PSAPCCAV EQU   PSA+520
PSACPULA EQU   PSA+518
PSACPUPA EQU   PSA+516
PSAPSA   EQU   PSA+512
FLCHDEND EQU   PSA+512
FLCCRSAV EQU   FLCMCLA+280
FLCGRSAV EQU   FLCMCLA+216
FLCFPSAV EQU   FLCMCLA+184
FLCFLA   EQU   FLCMCLA+88
FLCRGNCD EQU   FLCMCLA+84
FLCFSAA  EQU   FLCFSA+1
@NM00020 EQU   FLCFSA
@NM00019 EQU   FLCMCLA+72
FLCMCIC  EQU   FLCMCLA+64
@NM00018 EQU   FLCMCLA+20
FLCIOAA  EQU   FLCIOA+1
@NM00017 EQU   FLCIOA
@NM00016 EQU   FLCMCLA+15
@NM00015 EQU   FLCMCLA+14
@NM00014 EQU   FLCMCLA+12
FLCLCL   EQU   FLCMCLA+8
FLCIOELA EQU   FLCIOEL+1
@NM00013 EQU   FLCIOEL
FLCCHNID EQU   FLCMCLA
@NM00012 EQU   PSA+160
FLCMTRCD EQU   PSA+157
@NM00011 EQU   PSA+156
FLCPERA  EQU   FLCPER+1
@NM00010 EQU   FLCPER
@NM00009 EQU   PSA+151
FLCPERCD EQU   PSA+150
FLCMCNUM EQU   PSA+149
@NM00008 EQU   PSA+148
FLCTEAA  EQU   FLCTEA+1
@NM00007 EQU   FLCTEA
PSAPIPC  EQU   PSAPICOD
PSAPIMC  EQU   PSAPICOD
PSAPIPER EQU   PSAPICOD
PSARV049 EQU   FLCPICOD
FLCPILCB EQU   FLCPIILC
@NM00006 EQU   FLCPIILC
@NM00005 EQU   PSAEPPSW
FLCSVCN  EQU   PSAESPSW+2
FLCSILCB EQU   FLCSVILC
@NM00004 EQU   FLCSVILC
@NM00003 EQU   PSAESPSW
FLCEICOD EQU   PSAEEPSW+2
PSASPAD  EQU   PSAEEPSW
@NM00002 EQU   PSA+128
FLCINPSW EQU   PSA+120
FLCMNPSW EQU   PSA+112
FLCPNPSW EQU   PSA+104
FLCSNPSW EQU   PSA+96
FLCENPSW EQU   PSA+88
FLCTRACE EQU   PSA+84
FLCTIMER EQU   PSA+80
FLCCVT2  EQU   PSA+76
FLCCAW   EQU   PSA+72
FLCCSW   EQU   PSA+64
FLCIOPSW EQU   PSA+56
FLCMOPSW EQU   PSA+48
FLCPOPSW EQU   PSA+40
FLCSOPSW EQU   PSA+32
FLCEOPSW EQU   PSA+24
@NM00001 EQU   FLCICCW2+4
FLCICCW1 EQU   FLCROPSW
FLCIPPSW EQU   FLCRNPSW
*                                      END UNREFERENCED COMPONENTS
@RC00210 EQU   @RC00207
@RC00233 EQU   @RC00231
@RF00415 EQU   LBKEEPCB
@RC00413 EQU   @RC00409
@ENDDATA EQU   *
         END   IEAVIOCP,(C'PLS2214',0701,77004)
