         TITLE 'IEAVMFRR - FRR/ESTAE CONTROLLER                        *
                        '
*                           /*SET UP MODULE INDENTIFIER   */
IEAVMFRR CSECT                MAIN ENTRY POINT
        USING     *,R15     ENTRY FROM RTM
        MODID     BR=YES    MODULE ID
        DROP      R15       RELEASE REG 15 AS BASE
        BALR      BASEREG,0 SET REG12 AS BASE
L1      DS        0H        BOUNDARY ALIGNMENT
        USING     *,BASEREG ADDRESSABILITY
*   R8=R14;                         /* SAVE RETURN REGISTER          */
*                                                                  0077
         LR    R8,R14                                              0077
*   /*****************************************************************/
*   /*                                                               */
*   /* EXAMINE THE CONTENTS OF REGISTER 0 TO DETERMINE IF THIS IS AN */
*   /* ESTAE OR FRR ENTRY. IF REGISTER 0 IS GREATER THAN 16, THIS    */
*   /* MODULE WAS ENTERED FOR FRR RECOVERY.                          */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0078
*   IF R0>16 THEN                   /* FRR ENTRY ?                   */
         C     R0,@CF00065                                         0078
         BNH   @RF00078                                            0078
*     DO;                           /* IF YES,                       */
*                                                                  0079
*       /*************************************************************/
*       /*                                                           */
*       /* TEST FOR ENTRY IN SRB MODE                                */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0080
*       IF PSATOLD=0 THEN           /* SRB MODE IF ZERO              */
         L     @07,PSATOLD                                         0080
         LTR   @07,@07                                             0080
         BNZ   @RF00080                                            0080
*         DO;                       /* IF YES                        */
*           R4=SRBMDTCB;            /* GET TCB FROM LCCA             */
         L     @07,LCCAPTR                                         0082
         L     R4,SRBMDTCB(,@07)                                   0082
*         END;                      /* END IF SRB MODE               */
*       ELSE                        /* IF NOT SRB MODE               */
*         R4=PSATOLD;               /* GET CURRENT TCB ADDRESS       */
         B     @RC00080                                            0084
@RF00080 L     R4,PSATOLD                                          0084
*       R6=R1;                      /* SAVE REG1 ACROSS GETMAIN      */
@RC00080 LR    R6,R1                                               0085
*       R5=R0;                      /* SAVE REG0 ACROSS GETMAIN      */
         LR    R5,R0                                               0086
*       R7=PSAAOLD;                 /* GET CURRENT ASCB ADDRESS      */
         L     R7,PSAAOLD                                          0087
*       R1=0;                       /* GETMAIN INTERFACE             */
         SLR   R1,R1                                               0088
*       GEN REFS(CVTCRMN);                                         0089
*                                     /*GET CORE FOR DATA AREA */
        L     R2,@SIZDATD         SET SIZE OF GETMAIN
           GETMAIN  RU,LV=(R2),SP=229,BRANCH=YES ISSUE GETMAIN
        LR        R9,R1     SET DATA REGISTER
        USING     @DATD,R9  ADDRESSABILITY FOR DATA AREA
        GETMAIN  RU,LV=64,SP=229,BRANCH=YES GET SAVEAREA
*       R13=R1;                     /* SET SAVEAREA ADDRESS          */
         LR    R13,R1                                              0090
*       SAVTCB=R4;                  /* SAVE CONTENT OF REG 4         */
         ST    R4,SAVTCB                                           0091
*       R1=R6;                      /* RESTORE REGISTER 1            */
         LR    R1,R6                                               0092
*       R0=R5;                      /* RESTORE REGISTER 0            */
         LR    R0,R5                                               0093
*/********************************************************************/
*/*                INITIAL  FRR  SEGMENT                             */
*/* THE FOLLOWING WILL CREATE A RECOVERY ENVIRONMENT TO              */
*/* PROTECT THIS FRR ROUTINE FROM ERROR SITUATIONS WITHIN ITS        */
*/* OWN CODE.                                                        */
*/****************************************************************   */
*                                                                  0094
*       RECEXADD=ADDR(RECOVEX);     /* SET ADDR OF RECOVERY EXIT     */
         LA    @07,RECOVEX                                         0094
         ST    @07,RECEXADD                                        0094
*       GEN REFS(PSACSTK,FRRSCURR,FRRSLAST,PSALSFCC,FRRSENTR,FRRSELEN,
*           FRRSFRRA);                                             0095
*                                     /*ISSUE SETFRR                */
        SETFRR  A,FRRAD=RECEXADD,WRKREGS=(R5,R6),PARMAD=(R5) FRR EXIT
*       PARMPTR=R5;                 /* GET ADDR OF PARM AREA         */
         LR    PARMPTR,R5                                          0096
*       PARMSYSR=0;                 /* INDICATE NO XMPOST ENTRY      */
         MVI   PARMSYSR(PARMPTR),X'00'                             0097
*       PARMID='MFRR';              /* SET FRR ID                    */
         MVC   PARMID(4,PARMPTR),@CC02075                          0098
*       PARMRTAD=BASEREG;           /* SET BASE REGISTER             */
         ST    BASEREG,PARMRTAD(,PARMPTR)                          0099
*       PARMRGAD=R9;                /* SET DATA REGISTER             */
         ST    R9,PARMRGAD(,PARMPTR)                               0100
*       PARMPTR=SDWAPARM;           /* GET ADDR OF PARM LIST         */
         L     PARMPTR,SDWAPARM(,SDWAPTR)                          0101
*       PARMFRID='1'B;              /* INDICATE FRR ENTRY            */
         OI    PARMFRID(PARMPTR),B'00010000'                       0102
*       IF PARMNDMP^='1'B THEN      /* IS NO-DUMP IND SET?   @ZA19994*/
         TM    PARMNDMP(PARMPTR),B'00000100'                       0103
         BO    @RF00103                                            0103
*         DO;                       /* IF NOT SET.           @ZA19994*/
*                                                                  0104
*           /*********************************************************/
*           /*                                                       */
*           /* FRR ENTRY SDUMP SEGMENT                       @ZA10488*/
*           /* THIS SEGMENT ISSUES A BRANCH ENTRY SDUMP MACRO TO     */
*           /*                                               @ZA10488*/
*           /* OBTAIN A DUMP OF THE PROBLEM CAUSING ENTRY TO @ZA10488*/
*           /* IEAVMFRR.                                     @ZA10488*/
*           /*                                                       */
*           /*********************************************************/
*                                                                  0105
*           RFY                                                    0105
*            (R5,                                                  0105
*             R6,                                                  0105
*             R10) RSTD;            /* RESTRICT REGS         @ZA10488*/
*           R5=R0;                  /* SAVE R0 ACROSS SDUMP  @ZA10488*/
         LR    R5,R0                                               0106
*           R6=R1;                  /* SAVE R1 SDWA PTR      @ZA10488*/
         LR    R6,R1                                               0107
*           DUMPBUF(1:DUMPLEN)=DUMPHEAD(1:DUMPLEN);/* MOVE DUMP    0108
*                                                            @ZA10488*/
         SLR   @11,@11                                             0108
         IC    @11,DUMPLEN                                         0108
         BCTR  @11,0                                               0108
         EX    @11,@SM02104                                        0108
*           R10=ADDR(DUMPBUF);      /* BUFFER                @ZA10488*/
         LA    R10,DUMPBUF                                         0109
*           GEN REFS(R10,ASID0,CVTSDMP);                           0110
*                                   /* EXECUTE SDUMP MACRO  @ZA10488*/
         SDUMP HDR='IEAVMFRR FRR COMMUNICATIONS TASK DUMP',           XX
               BRANCH=YES,ASID=ASID0,MF=(E,(10))              @ZA10488
*           RFY                                                    0111
*            (R5,                                                  0111
*             R6,                                                  0111
*             R10) UNRSTD;          /* RELEASE REGS          @ZA10488*/
*           R0=R5;                  /* RESTORE R0 VALUE      @ZA10488*/
         LR    R0,R5                                               0112
*           R1=R6;                  /* RESTORE R1 SDWA PTR   @ZA10488*/
         LR    R1,R6                                               0113
*         END;                      /* END PROCESSING DUMP   @ZA19994*/
*     END;                          /* END IF FRR ENTRY              */
*   ELSE                            /* ESTAE ENTRY ?                 */
*     DO;                           /* IF YES,                       */
         B     @RC00078                                            0116
@RF00078 DS    0H                                                  0117
*       R6=R1;                      /* SAVE REG 1 ACROSS GETMAIN     */
         LR    R6,R1                                               0117
*       R5=R0;                      /* SAVE REG 0 ACROSS GETMAIN     */
         LR    R5,R0                                               0118
*       GEN;                                                       0119
*                                     /*PREPARE TO ISSUE GETMAIN  */
           L    R3,@SIZDATD            SIZE OF AREA
           GETMAIN  R,LV=(R3),SP=229   ISSUE GETMAIN
           LR   R9,R1                SET DATA REGISTER
           USING @DATD,R9            ADDRESSABILITY FOR DATA AREA
        GETMAIN  RU,LV=64,SP=229       GET SAVEAREA
*       R13=R1;                     /* SET SAVEAREA ADDRESS          */
         LR    R13,R1                                              0120
*       R1=R6;                      /* RESTORE REGISTER 1            */
         LR    R1,R6                                               0121
*       R0=R5;                      /* RESTORE REGISTER 0            */
         LR    R0,R5                                               0122
*/********************************************************************/
*/*                INITIAL  ESTAE  SEGMENT                           */
*/* THE FOLLOWING SEGMENT WILL CREATE A RECURSION COUNTER TO PROTECT */
*/* THIS ESTAE ROUTINE FROM ERRORS WITHIN ITS OWN CODE.              */
*/********************************************************************/
*                                                                  0123
*       IF R0=12 THEN               /* SDWA PRESENT ?                */
         C     R0,@CF01033                                         0123
         BNE   @RF00123                                            0123
*         DO;                       /* IF NO,                        */
*           PARMSDWA='1'B;          /* INDICATE NO SDWA              */
         OI    PARMSDWA(PARMPTR),B'10000000'                       0125
*         END;                      /* END IF NO SDWA                */
*       ELSE                        /* IF SDWA IS PRESENT            */
*         DO;                       /* SET UP ADDRESSABILITY         */
         B     @RC00123                                            0127
@RF00123 DS    0H                                                  0128
*           PARMPTR=SDWAPARM;       /* GET ADDRESS OF PARM LIST      */
         L     PARMPTR,SDWAPARM(,SDWAPTR)                          0128
*         END;                      /* END IF SDWA PRESENT           */
*                                                                  0129
*       /*************************************************************/
*       /*                                                           */
*       /* TEST USERS PARAMETER TO DETERMINE IF THIS IS A PERCOLATED */
*       /* ERROR FROM A LOWER LEVEL FRR RECOVERY.                    */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0130
*       IF PARMFRID='1'B THEN       /* FRR INDICATOR SET             */
@RC00123 TM    PARMFRID(PARMPTR),B'00010000'                       0130
         BNO   @RF00130                                            0130
*         DO;                       /* IF YES,                       */
*           PARMCWT='1'B;           /* SET CONTINUE WITH TERMINATIO  */
*           PARMSDWA='1'B;          /* SET NO SDWA (TO BYPASS REC)   */
*           PARMFRID='0'B;          /* TURN FRR INDIC. OFF    YM05436*/
         OI    PARMCWT(PARMPTR),B'11000000'                        0134
         NI    PARMFRID(PARMPTR),B'11101111'                       0134
*         END;                      /* END IF PERCOLATED ERROR       */
*       ELSE                        /* IF NOT PERCOLATED             */
*         DO;                       /* TEST FOR RECURSION            */
*                                                                  0136
         B     @RC00130                                            0136
@RF00130 DS    0H                                                  0137
*           /*********************************************************/
*           /*                                                       */
*           /* EXAMINE RECURSION BIT IN USER'S PARAMETER AREA TO TEST*/
*           /* FOR RECOVERY RECURSION                                */
*           /*                                                       */
*           /*********************************************************/
*                                                                  0137
*           IF PARMRECU='1'B THEN   /* RECURSION BIT ON ?            */
         TM    PARMRECU(PARMPTR),B'00100000'                       0137
         BNO   @RF00137                                            0137
*             DO;                   /* IF YES,                       */
*               PARMCWT='1'B;       /* INDICATE CONT. WITH TERM.     */
         OI    PARMCWT(PARMPTR),B'01000000'                        0139
*             END;                  /* END IF RECURSION BIT SET      */
*           ELSE                    /* IF RECURSION IS NOT SET       */
*             DO;                   /* SETUP FOR RECURSION ERROR     */
         B     @RC00137                                            0141
@RF00137 DS    0H                                                  0142
*               PARMRECU='1'B;      /* TURN RECURSION BIT ON         */
         OI    PARMRECU(PARMPTR),B'00100000'                       0142
*               IF PARMNDMP^='1'B THEN/* IS NO-DUMP IND SET? @ZA19994*/
         TM    PARMNDMP(PARMPTR),B'00000100'                       0143
         BO    @RF00143                                            0143
*                 DO;               /* IF NOT SET.           @ZA19994*/
*                                                                  0144
*                   /*************************************************/
*                   /*                                               */
*                   /* ESTAE ENTRY SDUMP SEGMENT             @ZA10488*/
*                   /* THIS SEGMENT ISSUES AN SVC ENTRY SDUMP        */
*                   /*                                       @ZA10488*/
*                   /* MACRO TO OBTAIN A DUMP OF THE PROBLEM @ZA10488*/
*                   /* CAUSING ENTRY TO IEAVMFRR IF THIS IS NOT      */
*                   /*                                       @ZA10488*/
*                   /* A PERCOLATED OR RECURSIVE ENTRY.      @ZA10488*/
*                   /*                                               */
*                   /*************************************************/
*                                                                  0145
*                   RFY                                            0145
*                    (R6,                                          0145
*                     R10) RSTD;    /* RESTRICT REGS         @ZA10488*/
*                   R6=R1;          /* SAVE R1 SDWA PTR SDUMP      0146
*                                                            @ZA10488*/
         LR    R6,R1                                               0146
*                   DUMPBUF(1:DUMPLEN)=DUMPHEAD(1:DUMPLEN);/* MOVE 0147
*                                      DUMP                  @ZA10488*/
         SLR   @11,@11                                             0147
         IC    @11,DUMPLEN                                         0147
         BCTR  @11,0                                               0147
         EX    @11,@SM02104                                        0147
*                   R10=ADDR(DUMPBUF);/* BUFFER              @ZA10488*/
         LA    R10,DUMPBUF                                         0148
*                   GEN REFS(R10);                                 0149
*                                   /* EXECUTE SDUMP MACRO  @ZA10488*/
         SDUMP HDR='IEAVMFRR ESTAE COMMUNICATIONS TASK DUMP',         XX
               MF=(E,(10))                                    @ZA10488
*                   RFY                                            0150
*                    (R6,                                          0150
*                     R10) UNRSTD;  /* RELEASE REGS          @ZA10488*/
*                   R1=R6;          /* RESTORE R1 SDWA PTR   @ZA10488*/
         LR    R1,R6                                               0151
*                 END;              /* END PROCESSING DUMP   @ZA19994*/
*             END;                  /* END IF RECURSION BIT SET      */
@RF00143 DS    0H                                                  0154
*         END;                      /* END IF NOT PERC. ERROR        */
@RC00137 DS    0H                                                  0155
*     END;                          /* END IF ESTEA RETRY            */
*                                                                  0155
@RC00130 DS    0H                                                  0156
*   /*****************************************************************/
*   /*                                                               */
*   /* TEST TO DETERMINE IF CONTINUE WITH TERMINATION HAS BEEN       */
*   /* INDICATED.                                                    */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0156
*   SAVRTN=R8;                      /* SAVE RETURN ADDRESS           */
@RC00078 ST    R8,SAVRTN                                           0156
*   RFY                                                            0157
*    (R8) UNRSTD;                   /* RELEASE REG 8                 */
*   IF PARMCWT='1'B THEN            /* CONT. WITH TERMINATION SET ?  */
         TM    PARMCWT(PARMPTR),B'01000000'                        0158
         BNO   @RF00158                                            0158
*     DO;                           /* PROCESS USER CLEANUP          */
*/********************************************************************/
*/*                USER  CLEANUP SEGMENT                             */
*/* THE FOLLOWING SEGMENT WILL DETERMINE IF THE DEVELOPER            */
*/* HAS SPECIFIED THE ADDRESS OF A USER CLEANUP ROUTINE IN THE       */
*/* RECOVERY PARAMETER LIST. IF ONE IS SPECIFIED, THIS ROUTINE       */
*/*WILL CALL THE USER'S CLEANUP ROUTINE TO PERFORM MODULE CLEANUP.   */
*/****************************************************************** */
*                                                                  0160
*       IF PARMCLAD^=0 THEN         /* CLEANUP RTN SPECIFIED         */
         SLR   @08,@08                                             0160
         L     @05,PARMCLAD(,PARMPTR)                              0160
         CR    @05,@08                                             0160
         BE    @RF00160                                            0160
*         DO;                       /* IF YES,                       */
*           RFY                                                    0162
*            (R15) RSTD;            /* RESTRICT R15                  */
*           R15=PARMCLAD;           /* GET ADDR OF CLEANUP RTN       */
         LR    R15,@05                                             0163
*           PARMCLAD=0;             /* ZERO CLEANUP ADDRESS          */
         ST    @08,PARMCLAD(,PARMPTR)                              0164
*           GEN(BALR  R14,R15);     /* BRANCH TO CLEANUP RTN         */
         BALR  R14,R15
*           RFY                                                    0166
*            (R15) UNRSTD;          /* RELEASE R15                   */
*         END;                      /* END IF ADDRESS PRESENT        */
*     END;                          /* END CLEANUP PROCESSING        */
*   ELSE                            /* IF NO,                        */
*     DO;                           /* TEST FOR SDWA                 */
*                                                                  0169
         B     @RC00158                                            0169
@RF00158 DS    0H                                                  0170
*       /*************************************************************/
*       /*                                                           */
*       /* TEST FOR PRESENCE OF SDWA BEFORE CHECKING FOR RESTART     */
*       /* CONDITION.                                                */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0170
*       IF PARMSDWA^='1'B THEN      /* SDWA PRESENT ?                */
         TM    PARMSDWA(PARMPTR),B'10000000'                       0170
         BO    @RF00170                                            0170
*         DO;                       /* IF YES,                       */
*                                                                  0171
*           /*********************************************************/
*           /*                                                       */
*           /* TEST TO DETERMINE IF RECOVERY ROUTINE WAS ENTERED     */
*           /* BECAUSE OF A RESTART CONDITION.                       */
*           /*                                                       */
*           /*********************************************************/
*                                                                  0172
*           IF SDWARKEY='1'B THEN   /* RESTART CONDITION PRESENT ?   */
         TM    SDWARKEY(SDWAPTR),B'00100000'                       0172
         BNO   @RF00172                                            0172
*             DO;                   /* IF YES,                       */
*               PARMCWT='1'B;       /* SET CONT. WITH TERMINATION    */
         OI    PARMCWT(PARMPTR),B'01000000'                        0174
*             END;                  /* END OF RESTART CONDITION      */
*         END;                      /* IF NO SDWA                    */
*                                                                  0176
@RF00172 DS    0H                                                  0177
*       /*************************************************************/
*       /*                                                           */
*       /* TEST TO DETERMINE IF CONTINUE WITH TERMINATION HAS BEEN   */
*       /* INDICATED.                                                */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0177
*       IF PARMCWT='1'B THEN        /* CONT. WITH TERMINATION SET ?  */
@RF00170 TM    PARMCWT(PARMPTR),B'01000000'                        0177
         BNO   @RF00177                                            0177
*         DO;                       /* PROCESS USER CLEANUP          */
*/********************************************************************/
*/*                USER  CLEANUP SEGMENT                             */
*/* THE FOLLOWING SEGMENT WILL DETERMINE IF THE DEVELOPER            */
*/* HAS SPECIFIED THE ADDRESS OF A USER CLEANUP ROUTINE IN THE       */
*/* RECOVERY PARAMETER LIST. IF ONE IS SPECIFIED, THIS ROUTINE       */
*/*WILL CALL THE USER'S CLEANUP ROUTINE TO PERFORM MODULE CLEANUP.   */
*/****************************************************************** */
*                                                                  0179
*           IF PARMCLAD^=0 THEN     /* CLEANUP RTN SPECIFIED         */
         SLR   @08,@08                                             0179
         L     @05,PARMCLAD(,PARMPTR)                              0179
         CR    @05,@08                                             0179
         BE    @RF00179                                            0179
*             DO;                   /* IF YES,                       */
*               RFY                                                0181
*                (R15) RSTD;        /* RESTRICT R15                  */
*               R15=PARMCLAD;       /* GET ADDR OF CLEANUP RTN       */
         LR    R15,@05                                             0182
*               PARMCLAD=0;         /* ZERO CLEANUP ADDRESS          */
         ST    @08,PARMCLAD(,PARMPTR)                              0183
*               GEN(BALR  R14,R15); /* BRANCH TO CLEANUP RTN         */
         BALR  R14,R15
*               RFY                                                0185
*                (R15) UNRSTD;      /* RELEASE R15                   */
*             END;                  /* END IF ADDRESS PRESENT        */
*         END;                      /* END CLEANUP PROCESSING        */
*       ELSE                        /* IF CONT.WITH TERM. NOT SET    */
*         DO;                       /* CONTINUE PROCESSING           */
         B     @RC00177                                            0188
@RF00177 DS    0H                                                  0189
*           ERRCDE=0;               /* ZERO ERROR INDICATOR          */
         SLR   ERRCDE,ERRCDE                                       0189
*/********************************************************************/
*/*                ERROR  HANDLER  SEGMENT                           */
*/* THE FOLLOWING SEGMENT WILL CHECK FOR SPECIFIC ABEND CODES        */
*/* FROM THE INTERRUPT HANDLER. IF AN INTERRUPT ABEND IS PRESENT,    */
*/* A RETRY OF THE NEXT INSTRUCTION TO BE EXECUTED AT THE TIME       */
*/* OF THE INTERRUPT WILL BE ATTEMPTED. IF THE USER HAS SPECIFIED    */
*/* THE ADDRESS OF A SYSTEM SERVICE ROUTINE, THIS ROUTINE WILL       */
*/* CALL THE SERVICE ROUTINE TO DO SERVICE PROCESSING.               */
*/****************************************************************** */
*                                                                  0190
*           IF PARMSDWA^='1'B THEN  /* SDWA PRESENT ?                */
         TM    PARMSDWA(PARMPTR),B'10000000'                       0190
         BO    @RF00190                                            0190
*             DO;                   /* IF YES,                       */
*                                                                  0191
*               /*****************************************************/
*               /*                                                   */
*               /* TEST FOR ESTAE ENTRY                              */
*               /*                                                   */
*               /*****************************************************/
*                                                                  0192
*               IF PARMFRID^='1'B THEN/* ESTAE ENTRY                 */
         TM    PARMFRID(PARMPTR),B'00010000'                       0192
         BO    @RF00192                                            0192
*                 DO;               /* IF YES                        */
*                                                                  0193
*                   /*************************************************/
*                   /*                                               */
*                   /* TEST FOR SPECIFIC ABEND CODES (1FC - 6FC)     */
*                   /*                                               */
*                   /*************************************************/
*                                                                  0194
*                   DO I=1 TO 6 BY 1 WHILE(ERRCDE=0);              0194
*                                                                  0194
         LA    I,1                                                 0194
@DL00194 SLR   @08,@08                                             0194
         CR    ERRCDE,@08                                          0194
         BNE   @DC00194                                            0194
*                     /***********************************************/
*                     /*                                             */
*                     /* ABEND CODE MATCH ?                          */
*                     /*                                             */
*                     /***********************************************/
*                                                                  0195
*                     IF ABENDCDE(I)=SDWACMPC THEN/* INTERRUPT ABEND
*                                      SPECIFIED                     */
         LR    @15,I                                               0195
         MH    @15,@CH00062                                        0195
         LA    @14,ABENDCDE-3(@15)                                 0195
         CLC   0(3,@14),SDWACMPC(SDWAPTR)                          0195
         BNE   @RF00195                                            0195
*                       DO;         /* IF YES,                       */
*                         ERRCDE=1; /* SET LOOP CONTROL TO END LOOP  */
*                                                                  0197
         LA    ERRCDE,1                                            0197
*                         /*******************************************/
*                         /*                                         */
*                         /* CHECK FOR ZERO RETRY ADDRESS IN @ZA12428*/
*                         /* SDWA. IF ZERO SET CONTINUE WITH @ZA12428*/
*                         /* TERMINATION. IF NOT ZERO        @ZA12428*/
*                         /* ATTEMPT TO RETRY.               @ZA12428*/
*                         /*                                         */
*                         /*******************************************/
*                                                                  0198
*                         IF SDWANXT2=0 THEN/*               @ZA12428*/
         C     @08,SDWANXT2(,SDWAPTR)                              0198
         BNE   @RF00198                                            0198
*                           PARMCWT='1'B;/* SET CONTINUE TERM      0199
*                                                            @ZA12428*/
         OI    PARMCWT(PARMPTR),B'01000000'                        0199
*                         ELSE      /*                       @ZA12428*/
*                           PARMWARG='1'B;/* INDICATE REGS RESTORED
*                                      FOR RETRY             @ZA12428*/
         B     @RC00198                                            0200
@RF00198 OI    PARMWARG(PARMPTR),B'00001000'                       0200
*                       END;        /* END IF INTERRUPT ABEND        */
@RC00198 DS    0H                                                  0202
*                   END;            /* END ABEND SCAN                */
@RF00195 AL    I,@CF00123                                          0202
         C     I,@CF00075                                          0202
         BNH   @DL00194                                            0202
@DC00194 DS    0H                                                  0203
*                 END;              /* END IF FRR ENTRY              */
*             END;                  /* END SDWA TEST                 */
*                                                                  0204
@RF00192 DS    0H                                                  0205
*           /*********************************************************/
*           /*                                                       */
*           /* TEST FOR ABEND CODE MATCH                             */
*           /*                                                       */
*           /*********************************************************/
*                                                                  0205
*           IF ERRCDE=0 THEN        /* INTERRUPT ABEND FOUND         */
@RF00190 SLR   @08,@08                                             0205
         CR    ERRCDE,@08                                          0205
         BNE   @RF00205                                            0205
*             DO;                   /* IF NO,                        */
*                                                                  0206
*               /*****************************************************/
*               /*                                                   */
*               /* TEST FOR SYSTEM SERVICE ADDRESS PRESENT           */
*               /*                                                   */
*               /*****************************************************/
*                                                                  0207
*               IF PARMSYAD^=0 THEN /* SYSTEM SERVICE ADDR PRESENT   */
         L     @05,PARMSYAD(,PARMPTR)                              0207
         CR    @05,@08                                             0207
         BE    @RF00207                                            0207
*                 DO;               /* IF YES,                       */
*                   RFY                                            0209
*                    (R15) RSTD;    /* RESTRICT REG 15               */
*                   R15=PARMSYAD;   /* GET ADDR OF SYSTEM SERVICE    */
         LR    R15,@05                                             0210
*                   PARMSYAD=0;     /* ZERO SERVICE ADDRESS          */
         ST    @08,PARMSYAD(,PARMPTR)                              0211
*                   GEN(BALR  R14,R15);/* BRANCH TO SERVICE ROUTINE  */
         BALR  R14,R15
*                 END;              /* END IF NO SYSTEM SERVICE      */
*                                                                  0213
*               /*****************************************************/
*               /*                                                   */
*               /* TEST FOR PRESENCE OF CLEANUP ROUTINE              */
*               /*                                                   */
*               /*****************************************************/
*                                                                  0214
*               IF PARMCLAD^=0 THEN /* CLEANUP ADDR SPECIFIED        */
@RF00207 SLR   @14,@14                                             0214
         L     @08,PARMCLAD(,PARMPTR)                              0214
         CR    @08,@14                                             0214
         BE    @RF00214                                            0214
*                 DO;               /* IF YES,                       */
*                   R15=PARMCLAD;   /* GET ADDR OF CLEANUP RTN       */
         LR    R15,@08                                             0216
*                   PARMCLAD=0;     /* ZERO CLEANUP ADDR             */
         ST    @14,PARMCLAD(,PARMPTR)                              0217
*                   GEN(BALR  R14,R15);/* BRANCH TO CLEANUP RTN      */
         BALR  R14,R15
*                   RFY                                            0219
*                    (R15) UNRSTD;  /* RELEASE REG 15                */
*                 END;              /* END IF ADDR PRESENT           */
*             END;                  /* END IF NOT INTERRUPT ABEND    */
@RF00214 DS    0H                                                  0222
*         END;                      /* END ERROR PROCESSING          */
@RF00205 DS    0H                                                  0223
*     END;                          /* END AFTER TAKING USER EXIT    */
@RC00177 DS    0H                                                  0224
*/********************************************************************/
*/*                RECORD AND RETURN SEGMENT                         */
*/* THE FOLLOWING CODE WILL HANDLE THE RECORDING OF THE ERROR        */
*/* ENVIRONMENT AND RETURN CONTROL TO RTM INDICATING CONTINUE        */
*/* WITH TERMINATION OR RETRY.                                       */
*/****************************************************************** */
*                                                                  0224
*   RFY                                                            0224
*    (R11) RSTD;                    /* RESTRICT REG 11               */
*                                                                  0224
@RC00158 DS    0H                                                  0225
*   /*****************************************************************/
*   /*                                                               */
*   /* TEST FOR FRR ENTRY                                            */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0225
*   IF PARMFRID='1'B THEN           /* FRR ENTRY ?                   */
         TM    PARMFRID(PARMPTR),B'00010000'                       0225
         BNO   @RF00225                                            0225
*     SAVFRR=1;                     /* SET FRR INDICATOR             */
         MVC   SAVFRR(4),@CF00123                                  0226
*   ELSE                            /* IF NOT FRR ENTRY              */
*     SAVFRR=0;                     /* INDICATE NO FRR ENTRY         */
*                                                                  0227
         B     @RC00225                                            0227
@RF00225 SLR   @10,@10                                             0227
         ST    @10,SAVFRR                                          0227
*   /*****************************************************************/
*   /*                                                               */
*   /* TEST FOR SDWA PASSED                                          */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0228
*   IF PARMSDWA^='1'B THEN          /* SDWA PRESENT ?                */
@RC00225 TM    PARMSDWA(PARMPTR),B'10000000'                       0228
         BO    @RF00228                                            0228
*     DO;                           /* IF YES                        */
*       SDWAHEX='1'B;               /* INDICATE HEX DATA             */
         OI    SDWAHEX(SDWAPTR),B'10000000'                        0230
*       SDWAURAL=24;                /* SET LENGTH OF DATA            */
         MVI   SDWAURAL(SDWAPTR),X'18'                             0231
*       SDWAVRA(1:24)=PARMLIST;     /* MOVE PARMLIST TO SDWA         */
         MVC   SDWAVRA(24,SDWAPTR),PARMLIST(PARMPTR)               0232
*       R5=PARMPTR;                 /* SAVE PARAMETER LIST PTR       */
         LR    R5,PARMPTR                                          0233
*       R6=PARMID;                  /* SAVE MODULE ID                */
         L     R6,PARMID(,PARMPTR)                                 0234
*       PARMPTR=ADDR(SDWAVRA)+70;   /* POINT TO AREA IN SDWA         */
         LA    PARMPTR,SDWAVRA(,SDWAPTR)                           0235
         AL    PARMPTR,@CF02078                                    0235
*       PARMSTAT='IEAV';            /* SET MODULE PREFIX             */
         MVC   PARMSTAT(4,PARMPTR),@CC02079                        0236
*       PARMSYAD=R6;                /* SET MODULE ID                 */
         ST    R6,PARMSYAD(,PARMPTR)                               0237
*       PARMCLAD=PARMSTAT;          /* DUPLICATE MOD ID              */
         L     @10,PARMSTAT(,PARMPTR)                              0238
         ST    @10,PARMCLAD(,PARMPTR)                              0238
*       PARMRTAD=PARMSYAD;          /* DUPLICATE MOD ID              */
         L     @10,PARMSYAD(,PARMPTR)                              0239
         ST    @10,PARMRTAD(,PARMPTR)                              0239
*       PARMRGAD='IEAV';            /* SET MODULE PREFIX             */
         MVC   PARMRGAD(4,PARMPTR),@CF02079                        0240
*       PARMID='MFRR';              /* SET FRR IF                    */
         MVC   PARMID(4,PARMPTR),@CC02075                          0241
*       DO;                         /* SETRP                       0242
*                                      RECORD(YES)RECPARM(PARMLIST)  */
*         RESPECIFY                                                0243
*          (GPR00P,                                                0243
*           GPR01P,                                                0243
*           GPR14P,                                                0243
*           GPR15P) RSTD;                                          0243
*         GPR01P->SDWARCDE=0;       /* SAVE RC VALUE                 */
         MVI   SDWARCDE(GPR01P),X'00'                              0244
*         GPR01P->SDWARCRD='1'B;    /* TURN ON RECORD INDICATOR      */
         OI    SDWARCRD(GPR01P),B'10000000'                        0245
*         GPR15P=ADDR(PARMLIST);    /* ACCESS RECORD PARAMETER LIST  */
         LR    GPR15P,PARMPTR                                      0246
*         GPR01P->SDWARECP=GPR15P->I256C(1:24);/* COPY RECORD      0247
*                                      PARAMETERS                    */
         MVC   SDWARECP(24,GPR01P),I256C(GPR15P)                   0247
*         RESPECIFY                                                0248
*          (GPR00P,                                                0248
*           GPR01P,                                                0248
*           GPR14P,                                                0248
*           GPR15P) UNRSTD;                                        0248
*       END;                        /* DUMP SDWA                     */
*       PARMPTR=R5;                 /* RESTORE PARMLIST POINTER      */
*                                                                  0250
         LR    PARMPTR,R5                                          0250
*       /*************************************************************/
*       /*                                                           */
*       /* TEST TO DETERMINE IF REGISTER MODIFICATION WAS DONE       */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0251
*       IF PARMWARG^='1'B THEN      /* REG UPDATE INDICATOR SET      */
         TM    PARMWARG(PARMPTR),B'00001000'                       0251
         BO    @RF00251                                            0251
*         DO;                       /* IF NO,                        */
*                                                                  0252
*           /*********************************************************/
*           /*                                                       */
*           /* TEST FOR CONTINUE WITH TERMINATION INDICATOR SET      */
*           /*                                                       */
*           /*********************************************************/
*                                                                  0253
*           IF PARMCWT^='1'B THEN   /* CONTINUE WITH TERMINATION     */
         TM    PARMCWT(PARMPTR),B'01000000'                        0253
         BO    @RF00253                                            0253
*             DO;                   /* IF NO,                        */
*                                                                  0254
*               /*****************************************************/
*               /*                                                   */
*               /* TEST FOR RETRY ADDRESS SPECIFIED                  */
*               /*                                                   */
*               /*****************************************************/
*                                                                  0255
*               IF PARMRTAD^=0 THEN /* RETRY ADDRESS SPECIFIED       */
         L     @10,PARMRTAD(,PARMPTR)                              0255
         LTR   @10,@10                                             0255
         BZ    @RF00255                                            0255
*                 DO;               /* IF YES,                       */
*                   R5=PARMRTAD;    /* LOAD RETRY ADDRESS            */
         LR    R5,@10                                              0257
*                   R6=PARMRGAD;    /* LOAD ADDRESS OF REGISTERS     */
*                                                                  0258
         L     @08,PARMRGAD(,PARMPTR)                              0258
         LR    R6,@08                                              0258
*                   /*************************************************/
*                   /*                                               */
*                   /* ISSUE SETRP MACRO                             */
*                   /*                                               */
*                   /*************************************************/
*                                                                  0259
*                   DO;             /* SETRP RETADDR(RETRYAD)RUB(REGU
*                                      PD)RC(4)RETREGS(YES)FRESDWA(YE
*                                      S)                            */
*                     RESPECIFY                                    0260
*                      (GPR00P,                                    0260
*                       GPR01P,                                    0260
*                       GPR14P,                                    0260
*                       GPR15P) RSTD;                              0260
*                     GPR01P->SDWARCDE=4;/* STORE RC INTO SDWA       */
         MVI   SDWARCDE(GPR01P),X'04'                              0261
*                     GPR01P->SDWARTYA=ADDR(RETRYAD);/* SAVE RETRY 0262
*                                      ADDRESS                       */
         ST    @10,SDWARTYA(,GPR01P)                               0262
*                     GPR01P->SDWAFREE='1'B;/* SET FLAG TO FREE SDWA */
*                     GPR01P->SDWAUPRG='1'B;/* TURN ON RETREGS     0264
*                                      INDICATOR                     */
         OI    SDWAFREE(GPR01P),B'00001100'                        0264
*                     GPR15P=ADDR(REGUPD);/* GET PTR TO REG UPDATE 0265
*                                      BLOCK                         */
         LR    GPR15P,@08                                          0265
*                     GPR00P=GPR15P->I015F;/* ACCESS REGISTER BIT  0266
*                                      PATTERN                       */
         LH    GPR00P,I015F(,GPR15P)                               0266
*                     GPR15P=GPR15P+2;/* CREATE PTR TO USER REG    0267
*                                      VALUES                        */
         AL    GPR15P,@CF00094                                     0267
*                     GPR14P=ADDR(GPR01P->SDWASRSV);/* CREATE PTR TO
*                                      SDWA SAVE AREA                */
         LA    GPR14P,SDWASRSV(,GPR01P)                            0268
*                     GEN(SLL   0,16);/* SHIFT BIT PATTERN TO HIGH 0269
*                                      ORDER                         */
         SLL   0,16
*R0004:                                                            0270
*                     GEN FLOWS(I0004);                            0270
R0004    DS    0H                                                  0270
        ALR   0,0                    SHIFT BIT TO SIGN POSITION
        BC    12,I0004               BRANCH IF BIT NOT ON
        MVC   0(4,14),0(15)          MODIFY REGISTER IN SDWA
        LA    15,4(15)               UPDATE POINTER
*I0004:                                                            0271
*                     GENERATE FLOWS(R0004);                       0271
I0004    DS    0H                                                  0271
        LA    14,4(14)               UPDATE PTR IN SDWA
        BC    5,R0004                TEST ALR CONDITION CODE TO TEST
*                                    IF ALL BITS EXHAUSTED
*                     RESPECIFY                                    0272
*                      (GPR00P,                                    0272
*                       GPR01P,                                    0272
*                       GPR14P,                                    0272
*                       GPR15P) UNRSTD;                            0272
*                   END;                                           0273
*                 END;              /* END IF RETRY ADDRESS          */
*               ELSE                                               0275
*                 ;                 /* IF RETRY ADDRESS              */
@RF00255 DS    0H                                                  0276
*             END;                  /* CONTINUE PROCESSING           */
*           ELSE                                                   0277
*             ;                     /* IF CONT.WITH TERM.            */
@RF00253 DS    0H                                                  0278
*         END;                      /* CONTINUE PROCESSING           */
*       ELSE                        /* IF REG UPDATE WAS DONE        */
*         DO;                       /* SET SDWA                      */
         B     @RC00251                                            0279
@RF00251 DS    0H                                                  0280
*           R5=SDWANXT2;            /* SET ADDR OF NEXT INST.        */
         L     @10,SDWANXT2(,SDWAPTR)                              0280
         LR    R5,@10                                              0280
*           DO;                     /* SETRP RETREGS(YES)RETADDR(RETR
*                                      YNT)RC(4)FRESDWA(YES)         */
*             RESPECIFY                                            0282
*              (GPR00P,                                            0282
*               GPR01P,                                            0282
*               GPR14P,                                            0282
*               GPR15P) RSTD;                                      0282
*             GPR01P->SDWARCDE=4;   /* STORE RC INTO SDWA            */
         MVI   SDWARCDE(GPR01P),X'04'                              0283
*             GPR01P->SDWARTYA=ADDR(RETRYNT);/* SAVE RETRY ADDRESS   */
         ST    @10,SDWARTYA(,GPR01P)                               0284
*             GPR01P->SDWAFREE='1'B;/* SET FLAG TO FREE SDWA         */
*             GPR01P->SDWAUPRG='1'B;/* TURN ON RETREGS INDICATOR     */
         OI    SDWAFREE(GPR01P),B'00001100'                        0286
*             RESPECIFY                                            0287
*              (GPR00P,                                            0287
*               GPR01P,                                            0287
*               GPR14P,                                            0287
*               GPR15P) UNRSTD;                                    0287
*           END;                                                   0288
*           PARMWARG='0'B;          /* TURN REG UPDATE BIT OFF       */
         NI    PARMWARG(PARMPTR),B'11110111'                       0289
*         END;                      /* END IF REG UPDATE             */
*     END;                          /* END IF SDWA                   */
*                                                                  0291
@RC00251 DS    0H                                                  0292
*   /*****************************************************************/
*   /*                                                               */
*   /* TEST FOR FRR ENTRY                                            */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0292
*   IF SAVFRR=1 THEN                /* IF FRR THEN LOCKS HELD        */
@RF00228 CLC   SAVFRR(4),@CF00123                                  0292
         BNE   @RF00292                                            0292
*     DO;                           /* IF YES                        */
*       R4=SAVTCB;                  /* GET TCB ADDR                  */
         L     R4,SAVTCB                                           0294
*       R7=PSAAOLD;                 /* GET ASCB ADDR                 */
         L     R7,PSAAOLD                                          0295
*       R1=R9;                      /* SET ADDR OF DATA AREA         */
         LR    R1,R9                                               0296
*       R11=SAVRTN;                 /* SAVE RETURN ADDR              */
         L     R11,SAVRTN                                          0297
*       GEN REFS(CVTRMBR);                                         0298
*                                     /*FREE DATA AREA              */
        L     R3,@SIZDATD             SET SIZE OF AREA
        FREEMAIN  R,LV=(R3),A=(R1),SP=229,BRANCH=YES  ISSUE FREEMAIN
        FREEMAIN  R,LV=64,A=(R13),SP=229,BRANCH=YES  FREE SAVEAREA
*       GEN(SETFRR  D,WRKREGS=(R5,R6));/* RELEASE FRR                */
         SETFRR  D,WRKREGS=(R5,R6)
*     END;                          /* END IF FRR ENTRY              */
*   ELSE                            /* IF NOT FRR ENTRY              */
*     DO;                           /* NO LOCKS ARE HELD             */
         B     @RC00292                                            0301
@RF00292 DS    0H                                                  0302
*       R1=R9;                      /* SET ADDR OF DATA AREA         */
         LR    R1,R9                                               0302
*       R11=SAVRTN;                 /* SAVE RETURN ADDR              */
         L     R11,SAVRTN                                          0303
*       GEN;                                                       0304
*                                     /*FREE DATA AREA              */
        L     R3,@SIZDATD             SET SIZE OF AREA
        FREEMAIN  R,LV=(R3),A=(R1),SP=229  ISSUE FREEMAIN
        FREEMAIN  R,LV=64,A=(R13),SP=229  FREE SAVEAREA
*     END;                          /* END IF NOT FRR                */
*   R14=R11;                        /* RESTORE RETURN ADDRESS        */
@RC00292 LR    R14,R11                                             0306
*   RFY                                                            0307
*    (R11) UNRSTD;                  /* RELEASE R11                   */
*   R15=0;                          /* SET CONT. WITH TERM           */
         SLR   R15,R15                                             0308
*   GEN(BR  R14);                   /* RETURN TO CALLER              */
         BR  R14
*/********************************************************************/
*/*          RECOVERY  EXIT                                          */
*/* THIS IS THE RECOVERY ENTRY POINT FOR THE FRR/ESTAE CONTROLLER    */
*/* MODULE. IT WILL BE ENTERED FOR FRR RECOVERY ONLY. UPON ENTRY,    */
*/* REGISTER ONE POINTS TO A SDWA WHERE THE ADDRESS OF A USER        */
*/* PARAMETER AREA CAN BE FOUND.                                     */
*/********************************************************************/
*                                                                  0310
*RECOVEX:                           /* REVOVERY ENTRY POINT          */
*   PARMPTR=SDWAPARM;               /* GET POINTER TO PARM LIST      */
RECOVEX  L     PARMPTR,SDWAPARM(,SDWAPTR)                          0310
*   BASEREG=PARMRTAD;               /* RESTORE BASE REG              */
         L     BASEREG,PARMRTAD(,PARMPTR)                          0311
*   R9=PARMRGAD;                    /* RESTORE DATA REG              */
         L     R9,PARMRGAD(,PARMPTR)                               0312
*   R5=R14;                         /* SAVE RETURN REG               */
*                                                                  0313
         LR    R5,R14                                              0313
*   /*****************************************************************/
*   /*                                                               */
*   /* TEST FOR XMPOST RECOVERY ENTRY                                */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0314
*   IF PARMSYSR='01'X THEN          /* POST INDICATOR SET            */
         CLI   PARMSYSR(PARMPTR),1                                 0314
         BNE   @RF00314                                            0314
*     DO;                           /* IF YES,                       */
*       SDWAHEX='1'B;               /* INDICATE HEX DATA             */
         OI    SDWAHEX(SDWAPTR),B'10000000'                        0316
*       SDWAURAL=4;                 /* SET LENGTH OF DATA            */
         MVI   SDWAURAL(SDWAPTR),X'04'                             0317
*       SDWAVRA(1:4)='MEST';        /* MOVE PARMLIST TO SDWA         */
         MVC   SDWAVRA(4,SDWAPTR),@CC02092                         0318
*       DO;                         /* SETRP RECORD(YES)             */
*         RESPECIFY                                                0320
*          (GPR00P,                                                0320
*           GPR01P,                                                0320
*           GPR14P,                                                0320
*           GPR15P) RSTD;                                          0320
*         GPR01P->SDWARCDE=0;       /* SAVE RC VALUE                 */
         MVI   SDWARCDE(GPR01P),X'00'                              0321
*         GPR01P->SDWARCRD='1'B;    /* TURN ON RECORD INDICATOR      */
         OI    SDWARCRD(GPR01P),B'10000000'                        0322
*         RESPECIFY                                                0323
*          (GPR00P,                                                0323
*           GPR01P,                                                0323
*           GPR14P,                                                0323
*           GPR15P) UNRSTD;                                        0323
*       END;                        /* DUMP SDWA                     */
*     END;                          /* END IF POST ENRET             */
*   ELSE                            /* IF NOT POST ENTRY             */
*     DO;                           /* SET UP FOR RTM                */
         B     @RC00314                                            0326
@RF00314 DS    0H                                                  0327
*       SDWAHEX='1'B;               /* INDICATE HEX DATA             */
         OI    SDWAHEX(SDWAPTR),B'10000000'                        0327
*       SDWAURAL=24;                /* SET LENGTH OF DATA            */
         MVI   SDWAURAL(SDWAPTR),X'18'                             0328
*       SDWAVRA(1:24)=PARMLIST;     /* MOVE PARMLIST TO SDWA         */
         MVC   SDWAVRA(24,SDWAPTR),PARMLIST(PARMPTR)               0329
*       PARMSTAT='IEAV';            /* SET MODULE PREFIX             */
         MVC   PARMSTAT(4,PARMPTR),@CC02079                        0330
*       PARMSYAD=PARMID;            /* SET MODULE ID                 */
         L     @08,PARMID(,PARMPTR)                                0331
         ST    @08,PARMSYAD(,PARMPTR)                              0331
*       PARMCLAD=PARMSTAT;          /* DUPLICATE MOD ID              */
         L     @05,PARMSTAT(,PARMPTR)                              0332
         ST    @05,PARMCLAD(,PARMPTR)                              0332
*       PARMRTAD=PARMSYAD;          /* DUPLICATE MOD ID              */
         ST    @08,PARMRTAD(,PARMPTR)                              0333
*       PARMRGAD='IEAV';            /* SET MODULE PREFIX             */
         MVC   PARMRGAD(4,PARMPTR),@CF02079                        0334
*       PARMID='MFRR';              /* SET FRR IF                    */
         MVC   PARMID(4,PARMPTR),@CC02075                          0335
*       R6=ADDR(PARMLIST);          /* GET ADDR OF PARMLIST          */
         LR    R6,PARMPTR                                          0336
*       DO;                         /* SETRP                       0337
*                                      RECORD(YES)RECPARM(PARMLIST)  */
*         RESPECIFY                                                0338
*          (GPR00P,                                                0338
*           GPR01P,                                                0338
*           GPR14P,                                                0338
*           GPR15P) RSTD;                                          0338
*         GPR01P->SDWARCDE=0;       /* SAVE RC VALUE                 */
         MVI   SDWARCDE(GPR01P),X'00'                              0339
*         GPR01P->SDWARCRD='1'B;    /* TURN ON RECORD INDICATOR      */
         OI    SDWARCRD(GPR01P),B'10000000'                        0340
*         GPR15P=ADDR(PARMLIST);    /* ACCESS RECORD PARAMETER LIST  */
         LR    GPR15P,PARMPTR                                      0341
*         GPR01P->SDWARECP=GPR15P->I256C(1:24);/* COPY RECORD      0342
*                                      PARAMETERS                    */
         MVC   SDWARECP(24,GPR01P),I256C(GPR15P)                   0342
*         RESPECIFY                                                0343
*          (GPR00P,                                                0343
*           GPR01P,                                                0343
*           GPR14P,                                                0343
*           GPR15P) UNRSTD;                                        0343
*       END;                        /* DUMP SDWA                     */
*       DECLARE                     /* GENERAL PURPOSE REGISTERS     */
*         GPR00P PTR(31) REG(0),                                   0345
*         GPR01P PTR(31) REG(1),                                   0345
*         GPR14P PTR(31) REG(14),                                  0345
*         GPR15P PTR(31) REG(15);                                  0345
*       DECLARE                     /* COMMON VARIABLES              */
*         I256C CHAR(256) BASED,                                   0346
*         I031F FIXED(31) BASED,                                   0346
*         I031P PTR(31) BASED,                                     0346
*         I015F FIXED(15) BASED,                                   0346
*         I015P PTR(15) BASED,                                     0346
*         I008P PTR(8) BASED,                                      0346
*         I001C CHAR(1) BASED;                                     0346
*     END;                          /* END IF NOT POST IND.          */
*   R14=R5;                         /* RESTORE RETURN REG            */
@RC00314 LR    R14,R5                                              0348
*   GEN(BR 14);                     /* RETURN TO CALLER              */
         BR 14
*/*           XMPOST RECOVERY ENTRY POINT                            */
*                                                                  0350
*   GEN;                                                           0350
*                                     /*SET UP ADDRESSABILITY       */
IEAVMEST EQU   *                SECONDARY ENTRY POINT
        ENTRY IEAVMEST                ENTRY
        USING *,R15                   ENTRY ADDRESSABILITY
        BALR  BASEREG,0
L2      DS    0H
        S     R12,LAB1                ADDRESSABILITY FOR SEC. ENTRY
        B     *+8                     BRANCH AROUND
LAB1    DC    A(L2-L1)                ENTRY OFFSET
        DROP  R15
*   R2=R14;                         /* SAVE RETURN REG               */
         LR    R2,R14                                              0351
*   R5=R12;                         /* SAVE BASE REGISTER            */
         LR    R5,R12                                              0352
*   GEN REFS(PSALITA,FLC);                                         0353
*                                     /*GET LOCKS                   */
MESTOLOC SETLOCK  OBTAIN,TYPE=LOCAL,MODE=UNCOND,                      **
               RELATED=(ORE,IEAVMFRR(MESTRLOC))
MESTOCMS SETLOCK  OBTAIN,TYPE=CMS,MODE=UNCOND,                        **
               RELATED=(ORE,IEAVMFRR(MESTRCMS))
*   R12=R5;                         /* RESTORE BASE REGISTER         */
         LR    R12,R5                                              0354
*   R9=ADDR(RECOVEX);               /* SET ADDR OF RECOVERY EXIT     */
         LA    R9,RECOVEX                                          0355
*   GEN REFS(PSACSTK,FRRSCURR,FRRSLAST,PSALSFCC,FRRSENTR,FRRSELEN, 0356
*       FRRSFRRA,FRRSPARM);                                        0356
*                                         /*ISSUE SETFRR            */
        SETFRR  A,FRRAD=(R9),WRKREGS=(R5,R6),PARMAD=(R5)
*   RFY                                                            0357
*    (PARMLIST) BASED(R5);          /* REBASE PARM LIST              */
*   PARMSYSR='01'X;                 /* INDICATE XMPOST RECOVERY      */
         MVI   PARMSYSR(R5),X'01'                                  0358
*   PARMRTAD=BASEREG;               /* STORE BASE REG                */
*                                                                  0359
         ST    BASEREG,PARMRTAD(,R5)                               0359
*   /*****************************************************************/
*   /*                                                               */
*   /* COMPARE ECB ADDRESSES TO DETERMINE IF COMM TASK ECB WAS BEING */
*   /* POSTED. IF SO, A LOCAL POST WILL BE                   @ZA05368*/
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0360
*/*         GENERATED TO GIVE THE COMMTASK CONTROL. IF A     @ZA05368*/
*/*         COMMTASK ECB WAS NOT BEING POSTED, AN A23 ABEND  @ZA05368*/
*/*         WILL BE ISSUED.                                  @ZA05368*/
*                                                                  0360
*   IF R0=ADDR(UCMOECB)|R0=ADDR(UCMDECB) THEN/* COMM TASK ECB        */
         L     @08,CVTPTR                                          0360
         L     @08,UCMBASPT(,@08)                                  0360
         LA    @05,UCMOECB(,@08)                                   0360
         CR    R0,@05                                              0360
         BE    @RT00360                                            0360
         LA    @08,UCMDECB(,@08)                                   0360
         CR    R0,@08                                              0360
         BNE   @RF00360                                            0360
@RT00360 DS    0H                                                  0361
*     DO;                           /* IF YES,                       */
*       R4=UCMPXA;                  /* SET COMTASK TCB ADDR  @ZA03242*/
         L     @08,CVTPTR                                          0362
         L     @03,UCMBASPT(,@08)                                  0362
         L     R4,UCMPXA(,@03)                                     0362
*       R6=UCMCTID;                 /* ASID OF COMMTASK              */
         LH    R6,UCMCTID(,@03)                                    0363
*       R11=R0;                     /* SET UP ECB REG        @ZA05368*/
         LR    R11,R0                                              0364
*       R15=CVT0PT01;               /* SET POST ADDRESS      @ZA05368*/
         L     R15,CVT0PT01(,@08)                                  0365
*       R13=0;                      /* POST INTERFACE REG    @ZA05368*/
         SLR   R13,R13                                             0366
*       R10=0;                      /* POST INTERFACE REG    @ZA05368*/
         SLR   R10,R10                                             0367
*       R5=R12;                     /* SAVE BASE REG         @ZA05368*/
         LR    R5,R12                                              0368
*       R12=0;                      /* POST INTERFACE REG    @ZA05368*/
         SLR   R12,R12                                             0369
*       GEN(BALR R14,R15);          /* LOCAL POST            @ZA05368*/
         BALR R14,R15
*       R12=R5;                     /* RESTORE BASE REG      @ZA05368*/
         LR    R12,R5                                              0371
*       R7=UCMASCB;                 /* SET COMTASK ASCB ADDR @ZA03242*/
         L     @08,CVTPTR                                          0372
         L     @08,UCMBASPT(,@08)                                  0372
         L     R7,UCMASCB(,@08)                                    0372
*     END;                          /* END IF COMMTASK ECB           */
*   ELSE                            /* IF NOT COMMTASK ECB           */
*     DO;                           /* ABEND WWB TASK WAITING        */
         B     @RC00360                                            0374
@RF00360 DS    0H                                                  0375
*/********************************************************************/
*/*                                                                  */
*/*  IF NEITHER UCMOECB NOR UCMDECB WAS POSTED THEN IT MUST HAVE     */
*/*  BEEN THE ECB IN THE WWB. IN THIS CASE THE XMPOST WAS SCHEDULED  */
*/*  BY IEAVVRP2. R0 POINTS TO THE ECB IN THE WWB.                   */
*/*                                                          @ZA03242*/
*/********************************************************************/
*                                                                  0375
*       WWBPTR=R0-20;               /* BACK UP TO BEGINNING OF WWB 0375
*                                                            @ZA03242*/
         LR    WWBPTR,R0                                           0375
         SL    WWBPTR,@CF02099                                     0375
*       R4=WWBTCBAD;                /* SET R4 TO POINT TO TCB      0376
*                                                            @ZA03242*/
         L     R4,WWBTCBAD(,WWBPTR)                                0376
*       R7=WWBASCB;                 /* SET R7 TO POINT TO ASCB     0377
*                                                            @ZA03242*/
         L     R7,WWBASCB(,WWBPTR)                                 0377
*       ASCBPTR=R7;                 /* SET UP ASCB BASE REG  @ZA03242*/
         LR    ASCBPTR,R7                                          0378
*       R6=ASCBASID;                /* GET ASID ADDR FOR CALLRTM   0379
*                                                            @ZA03242*/
         LH    R6,ASCBASID(,ASCBPTR)                               0379
         N     R6,@CF02111                                         0379
*       R1=0;                       /* GETMAIN INTERFACE             */
         SLR   R1,R1                                               0380
*       R8=R7;                      /* SAVE TCB ADDR AROUND BRANCH 0381
*                                      ENTRY TO GETMAIN      @ZA03242*/
         LR    R8,R7                                               0381
*       GEN REFS(FRRSEMP,CVTBTERM,ASCBASID);                       0382
*                                            /*ABEND POSTED TASK    */
        GETMAIN  R,LV=64,SP=229,BRANCH=YES     GET SAVAREA
        LR     R13,R1                 SET ADDR OF SAVEAREA
        LR   R5,R2                    SAVE RETURN REG ACROSS CALLRTM
        CALLRTM  TYPE=ABTERM,COMPCOD=X'A23',TCB=(R4),ASID=(R6)
        LR   R2,R5                    RESTORE RETURN REG
        LR   R7,R8                    RESTORE ASCB ADDRESS            **
                                      CLOBBERED BY GETMAIN   @ZA03242
        FREEMAIN R,LV=64,A=(R13),SP=229,BRANCH=YES RELEASE SAVEAREA
        SETFRR   D,WRKREGS=(R5,R6)    RELEASE FRR
        LR   R5,R12                   SAVE BASE REGISTER
MESTRCMS SETLOCK  RELEASE,TYPE=CMS,                                   **
               RELATED=(ORE,IEAVMFRR(MESTOCMS))
MESTRLOC SETLOCK  RELEASE,TYPE=LOCAL,                                 **
               RELATED=(ORE,IEAVMFRR(MESTOLOC))
*       R12=R5;                     /* RESTORE BASE REG              */
         LR    R12,R5                                              0383
*     END;                          /* END IF NOT COMMTASK   @ZA05368*/
*   R14=R2;                         /* RESTORE RETURN REG            */
@RC00360 LR    R14,R2                                              0385
*   GEN(BR  R14);                   /* RETURN TO CALLER              */
         BR  R14
*   END IEAVMFRR                    /* END PROCESSING                */
*                                                                  0387
*/* THE FOLLOWING INCLUDE STATEMENTS WERE FOUND IN THIS PROGRAM.     */
*/*%INCLUDE SYSUT5  (PROLOGUE)                                       */
*/*%INCLUDE SYSUT5  (DECLARES)                                       */
*/*%INCLUDE SYSLIB  (CVT     )                                       */
*/*%INCLUDE SYSLIB  (IHACTM  )                                       */
*/*%INCLUDE SYSLIB  (IHAASCB )                                       */
*/*%INCLUDE SYSLIB  (IHAFRRS )                                       */
*/*%INCLUDE SYSLIB  (IEECUCM )                                       */
*/*%INCLUDE SYSLIB  (IHASDWA )                                       */
*/*%INCLUDE SYSLIB  (IHAPSA  )                                       */
*/*%INCLUDE SYSLIB  (IHALCCA )                                       */
*/*%INCLUDE SYSUT5  (INITFRR )                                       */
*/*%INCLUDE SYSUT5  (INITESTA)                                       */
*/*%INCLUDE SYSUT5  (USERCLN )                                       */
*/*%INCLUDE SYSUT5  (USERCLN )                                       */
*/*%INCLUDE SYSUT5  (ERRORHAN)                                       */
*/*%INCLUDE SYSUT5  (RECDRETU)                                       */
*                                                                  0387
*       ;                                                          0387
@DATA    DS    0H
@CH00062 DC    H'3'
@SM02104 MVC   DUMPBUF(0),DUMPHEAD
@DATD    DSECT
         DS    0F
@SA00001 DS    18F
IEAVMFRR CSECT
         DS    0F
@CF00123 DC    F'1'
@CF00094 DC    F'2'
@CF00075 DC    F'6'
@CF01033 DC    F'12'
@CF00065 DC    F'16'
@CF02099 DC    F'20'
@CF02078 DC    F'70'
@CF02111 DC    XL4'0000FFFF'
@CF02079 DC    C'IEAV'
@DATD    DSECT
         DS    0D
SAVRTN   DS    A
SAVFRR   DS    A
SAVTCB   DS    A
RECEXADD DS    A
FRRSPTR  DS    A
FRREPTR  DS    A
UCMEXTPT DS    A
UCMMCSPT DS    A
UCMEILPT DS    A
UCMUEWPT DS    A
UCMDVEPT DS    A
UCMFXPTR DS    A
UCMPXPTR DS    A
DUMPBUF  DS    CL80
IEAVMFRR CSECT
         DS    0F
@SIZDATD DC    AL1(0)
         DC    AL3(@ENDDATD-@DATD)
         DS    0D
@CC02075 DC    C'MFRR'
@CC02079 DC    C'IEAV'
@CC02092 DC    C'MEST'
ASID0    DC    X'0000'
ABENDCDE DC    X'1FC000'
         DC    X'2FC000'
         DC    X'3FC000'
         DC    X'4FC000'
         DC    X'5FC000'
         DC    X'6FC000'
PATCHAR  DC    4CL25'** IEAVMFRR PATCH AREA'
IEAVMFRR CSECT
*                                                        /* @ZA10488*/
DUMPHEAD SDUMP HDR=' ',SDATA=(SQA,NUC,LSQA,LPA,SWA,CSA,ALLPSA,RGN,    XX
               TRT),MF=L                                      @ZA10488
DUMPLEN DC    AL1(*-DUMPHEAD)
@DATD    DSECT
         ORG   *+1-(*-@DATD)/(*-@DATD) INSURE DSECT DATA
@ENDDATD EQU   *
IEAVMFRR CSECT
@00      EQU   00                      EQUATES FOR REGISTERS 0-15
@01      EQU   01
@02      EQU   02
@03      EQU   03
@04      EQU   04
@05      EQU   05
@06      EQU   06
@07      EQU   07
@08      EQU   08
@09      EQU   09
@10      EQU   10
@11      EQU   11
@12      EQU   12
@13      EQU   13
@14      EQU   14
@15      EQU   15
I        EQU   @05
ERRCDE   EQU   @03
R0       EQU   @00
R1       EQU   @01
R2       EQU   @02
R4       EQU   @04
R5       EQU   @05
R6       EQU   @06
R7       EQU   @07
R8       EQU   @08
R9       EQU   @09
R10      EQU   @10
R11      EQU   @11
R12      EQU   @12
R13      EQU   @13
R14      EQU   @14
R15      EQU   @15
BASEREG  EQU   @12
SDWAPTR  EQU   @01
PARMPTR  EQU   @02
ASCBPTR  EQU   @09
WWBPTR   EQU   @06
GPR00P   EQU   @00
GPR01P   EQU   @01
GPR14P   EQU   @14
GPR15P   EQU   @15
R3       EQU   @03
CVTPTR   EQU   16
PSA      EQU   0
FLCRNPSW EQU   PSA
FLCROPSW EQU   PSA+8
FLCICCW2 EQU   PSA+16
PSAEEPSW EQU   PSA+132
PSAESPSW EQU   PSA+136
FLCSVILC EQU   PSAESPSW+1
PSAEPPSW EQU   PSA+140
FLCPIILC EQU   PSAEPPSW+1
FLCPICOD EQU   PSAEPPSW+2
PSAPICOD EQU   FLCPICOD+1
FLCTEA   EQU   PSAEPPSW+4
FLCPER   EQU   PSA+152
FLCMCLA  EQU   PSA+168
FLCIOEL  EQU   FLCMCLA+4
FLCIOA   EQU   FLCMCLA+16
FLCFSA   EQU   FLCMCLA+80
PSALCCAV EQU   PSA+528
PSATOLD  EQU   PSA+540
PSAAOLD  EQU   PSA+548
PSASUPER EQU   PSA+552
PSASUP1  EQU   PSASUPER
PSASUP2  EQU   PSASUPER+1
PSASUP3  EQU   PSASUPER+2
PSASUP4  EQU   PSASUPER+3
PSACLHT  EQU   PSA+640
PSALKSA  EQU   PSA+696
PSAHLHI  EQU   PSA+760
PSALITA  EQU   PSA+764
PSADSSFL EQU   PSA+836
PSADSSF1 EQU   PSADSSFL
PSADSSF3 EQU   PSADSSFL+2
PSADSSF4 EQU   PSADSSFL+3
PSARSVT  EQU   PSA+896
PSALSFCC EQU   PSA+1012
RETRYAD  EQU   0
REGUPD   EQU   0
RETRYNT  EQU   0
CVTMAP   EQU   0
CVTBTERM EQU   CVTMAP+52
CVTDAR   EQU   CVTMAP+72
CVTFLGS1 EQU   CVTDAR
CVTCUCB  EQU   CVTMAP+100
CVTDCB   EQU   CVTMAP+116
CVTIOQET EQU   CVTMAP+120
CVTIERLC EQU   CVTMAP+144
CVT0PT01 EQU   CVTMAP+152
CVTHEAD  EQU   CVTMAP+160
CVTSV76C EQU   CVTHEAD
CVTOPTA  EQU   CVTMAP+182
CVTOPTB  EQU   CVTMAP+183
CVTGTF   EQU   CVTMAP+236
CVTGTFST EQU   CVTGTF
CVTGTFS  EQU   CVTGTFST
CVTSTATE EQU   CVTGTFST
CVTTMODE EQU   CVTGTFST
CVTFORM  EQU   CVTGTFST
CVTAQAVT EQU   CVTMAP+240
CVTTCMFG EQU   CVTAQAVT
CVTVOLM2 EQU   CVTMAP+244
CVTTATA  EQU   CVTVOLM2
CVTTSKS  EQU   CVTTATA
CVTVOLF2 EQU   CVTTSKS
CVTTAT   EQU   CVTTATA+1
CVTATER  EQU   CVTMAP+248
CVTEXT1  EQU   CVTMAP+252
CVTPURG  EQU   CVTMAP+260
CVTQMSG  EQU   CVTMAP+268
CVTDMSR  EQU   CVTMAP+272
CVTRSV37 EQU   CVTDMSR
CVTDMSRF EQU   CVTRSV37
CVTERPV  EQU   CVTMAP+316
CVTINTLA EQU   CVTMAP+320
CVTAPF   EQU   CVTMAP+324
CVTEXT2  EQU   CVTMAP+328
CVTHJES  EQU   CVTMAP+332
CVTPGSIA EQU   CVTMAP+348
CVTA1F1  EQU   CVTMAP+356
CVTSYSK  EQU   CVTMAP+357
CVTVOLM1 EQU   CVTMAP+380
CVTVOLF1 EQU   CVTVOLM1
CVTATMCT EQU   CVTMAP+388
CVTXTNT1 EQU   0
CVTXTNT2 EQU   0
CVTDSSV  EQU   CVTXTNT2
CVTFLGBT EQU   CVTXTNT2+5
CVTQID   EQU   CVTXTNT2+24
CVTRV400 EQU   CVTXTNT2+52
CVTRV409 EQU   CVTXTNT2+53
CVTATCVT EQU   CVTXTNT2+64
CVTRV429 EQU   CVTXTNT2+84
CVTRV438 EQU   CVTXTNT2+85
CVTRV457 EQU   CVTXTNT2+112
CVTRV466 EQU   CVTXTNT2+113
CVTFIX   EQU   0
CVTRELNO EQU   CVTFIX+252
WWB      EQU   0
WWBASCB  EQU   WWB+8
WWBTCBAD EQU   WWB+12
WWBFLAGS EQU   WWB+16
PARMLIST EQU   0
PARMSTAT EQU   PARMLIST
PARMFLAG EQU   PARMSTAT+1
PARMSDWA EQU   PARMFLAG
PARMCWT  EQU   PARMFLAG
PARMRECU EQU   PARMFLAG
PARMFRID EQU   PARMFLAG
PARMWARG EQU   PARMFLAG
PARMNDMP EQU   PARMFLAG
PARMSYSR EQU   PARMSTAT+2
PARMSYAD EQU   PARMLIST+4
PARMCLAD EQU   PARMLIST+8
PARMRTAD EQU   PARMLIST+12
PARMRGAD EQU   PARMLIST+16
PARMID   EQU   PARMLIST+20
ASCB     EQU   0
ASCBASID EQU   ASCB+36
ASCBFW1  EQU   ASCB+100
ASCBRCTF EQU   ASCBFW1+2
ASCBFLG1 EQU   ASCBFW1+3
ASCBDSP1 EQU   ASCB+114
ASCBFLG2 EQU   ASCB+115
FRRS     EQU   0
FRRSHEAD EQU   FRRS
FRRSEMP  EQU   FRRSHEAD
FRRSLAST EQU   FRRSHEAD+4
FRRSELEN EQU   FRRSHEAD+8
FRRSCURR EQU   FRRSHEAD+12
FRRSENTR EQU   0
FRRSFRRA EQU   FRRSENTR
FRRSFLGS EQU   FRRSENTR+4
FRRSFLG1 EQU   FRRSFLGS
FRRSPARM EQU   FRRSENTR+8
UCM2EXT  EQU   0
UCM2STA  EQU   UCM2EXT+8
UCM2SFLG EQU   UCM2STA
UCMPRFX  EQU   0
UCMSAVE0 EQU   UCMPRFX+4
UCMSFLGS EQU   UCMPRFX+84
UCMSFLG1 EQU   UCMSFLGS
UCMSFLG2 EQU   UCMSFLGS+1
UCMXSA   EQU   UCMPRFX+104
UCMSDS1  EQU   UCMPRFX+156
UCM      EQU   0
UCMOECB  EQU   UCM+8
UCMDECB  EQU   UCM+12
UCMRPYI  EQU   UCM+32
UCMPXA   EQU   UCM+64
UCMPXB   EQU   UCM+68
UCMMODE  EQU   UCMPXB
UCMVDATA EQU   UCM+72
UCMCTID  EQU   UCM+250
UCMASCB  EQU   UCM+280
UCMRSV42 EQU   UCM+300
UCMRSV51 EQU   UCM+301
UCMEIL   EQU   0
UCMRECBA EQU   UCMEIL+24
UCMEXIT  EQU   0
UCMLIST  EQU   0
UCMSTS   EQU   UCMLIST+24
UCMATR   EQU   UCMLIST+25
UCMXA    EQU   UCMLIST+26
UCMAUTH  EQU   UCMLIST+40
UCMAUTHA EQU   UCMAUTH
UCMDISP  EQU   UCMLIST+42
UCMDISP1 EQU   UCMDISP
UCMDISP2 EQU   UCMDISP+1
UCMMSG   EQU   UCMLIST+60
UCMMSG1  EQU   UCMMSG
UCMDEVC  EQU   UCMLIST+63
UCMRCT   EQU   UCMLIST+68
UCMSDS5  EQU   UCMRCT
UCMFEXTA EQU   0
UCMFMGFS EQU   UCMFEXTA+8
UCMFFLG1 EQU   UCMFMGFS
UCMPEXTA EQU   0
UCMPDM1  EQU   UCMPEXTA+4
SDWA     EQU   0
SDWAPARM EQU   SDWA
SDWAFIOB EQU   SDWA+4
SDWAABCC EQU   SDWAFIOB
SDWACMPF EQU   SDWAABCC
SDWACMPC EQU   SDWAABCC+1
SDWACTL1 EQU   SDWA+8
SDWACMKA EQU   SDWACTL1
SDWAMWPA EQU   SDWACTL1+1
SDWAPMKA EQU   SDWACTL1+4
SDWACTL2 EQU   SDWA+16
SDWACMKP EQU   SDWACTL2
SDWAMWPP EQU   SDWACTL2+1
SDWAPMKP EQU   SDWACTL2+4
SDWAGRSV EQU   SDWA+24
SDWANAME EQU   SDWA+88
SDWAEC1  EQU   SDWA+104
SDWAEMK1 EQU   SDWAEC1
SDWAMWP1 EQU   SDWAEC1+1
SDWAINT1 EQU   SDWAEC1+2
SDWANXT1 EQU   SDWAEC1+4
SDWAAEC1 EQU   SDWA+112
SDWAILC1 EQU   SDWAAEC1+1
SDWAINC1 EQU   SDWAAEC1+2
SDWAICD1 EQU   SDWAINC1+1
SDWAEC2  EQU   SDWA+120
SDWAEMK2 EQU   SDWAEC2
SDWAMWP2 EQU   SDWAEC2+1
SDWAINT2 EQU   SDWAEC2+2
SDWANXT2 EQU   SDWAEC2+4
SDWAAEC2 EQU   SDWA+128
SDWAILC2 EQU   SDWAAEC2+1
SDWAINC2 EQU   SDWAAEC2+2
SDWAICD2 EQU   SDWAINC2+1
SDWASRSV EQU   SDWA+136
SDWAIDNT EQU   SDWA+200
SDWAMCH  EQU   SDWA+204
SDWASTCK EQU   SDWAMCH
SDWAMCHI EQU   SDWAMCH+8
SDWAMCHS EQU   SDWAMCHI
SDWAMCHD EQU   SDWAMCHI+1
SDWARSR1 EQU   SDWAMCH+12
SDWARSR2 EQU   SDWAMCH+13
SDWAFLGS EQU   SDWA+232
SDWAERRA EQU   SDWAFLGS
SDWARKEY EQU   SDWAERRA
SDWAERRB EQU   SDWAFLGS+1
SDWAERRC EQU   SDWAFLGS+2
SDWAERRD EQU   SDWAFLGS+3
SDWAIOFS EQU   SDWA+238
SDWARTYA EQU   SDWA+240
SDWACPUA EQU   SDWA+248
SDWAPARQ EQU   SDWA+252
SDWARCDE EQU   SDWAPARQ
SDWAACF2 EQU   SDWAPARQ+1
SDWARCRD EQU   SDWAACF2
SDWAUPRG EQU   SDWAACF2
SDWAFREE EQU   SDWAACF2
SDWAACF3 EQU   SDWAPARQ+2
SDWAACF4 EQU   SDWAPARQ+3
SDWALKWA EQU   SDWA+256
SDWALKWS EQU   SDWALKWA
SDWARECP EQU   SDWA+292
SDWASNPA EQU   SDWA+320
SDWADUMP EQU   SDWASNPA
SDWADPFS EQU   SDWADUMP+1
SDWADDAT EQU   SDWASNPA+4
SDWASDAT EQU   SDWADDAT
SDWAPDAT EQU   SDWADDAT+2
SDWADPSA EQU   SDWA+328
SDWADPSL EQU   SDWADPSA
SDWARA   EQU   SDWA+400
SDWADPVA EQU   SDWARA+2
SDWAHEX  EQU   SDWADPVA
SDWAURAL EQU   SDWARA+3
SDWAVRA  EQU   SDWARA+4
LCCA     EQU   0
LCCAIHRC EQU   LCCA+520
LCCAIHR1 EQU   LCCAIHRC
LCCAIHR2 EQU   LCCAIHRC+1
LCCAIHR3 EQU   LCCAIHRC+2
LCCAIHR4 EQU   LCCAIHRC+3
LCCASPIN EQU   LCCA+524
LCCASPN1 EQU   LCCASPIN
LCCASPN2 EQU   LCCASPIN+1
LCCASPN3 EQU   LCCASPIN+2
LCCASPN4 EQU   LCCASPIN+3
LCCADSF1 EQU   LCCA+540
LCCADSF2 EQU   LCCA+541
LCCASPSA EQU   LCCA+544
LCCACRFL EQU   LCCA+692
LCCACREX EQU   LCCA+693
LCCALKFG EQU   LCCA+694
LCCASRBF EQU   LCCA+720
LCCAPGTA EQU   LCCASRBF+2
I256C    EQU   0
I015F    EQU   0
I001C    EQU   0
I008P    EQU   0
I015P    EQU   0
I031F    EQU   0
I031P    EQU   0
UCMPRFXP EQU   0
UCM2PTR  EQU   0
LCCAPTR  EQU   PSALCCAV
SRBMDTCB EQU   LCCAPGTA+2
UCMBASPT EQU   CVTCUCB
CVTS01   EQU   CVTPGSIA
CVTLPDIA EQU   CVTS01+12
CVTDIRST EQU   CVTLPDIA
CVTSLIDA EQU   CVTS01+24
CVTCTLFG EQU   CVTS01+50
CVTCRMN  EQU   CVTS01+156
CVTSDMP  EQU   CVTS01+232
CVTRV210 EQU   CVTS01+424
CVTRV219 EQU   CVTS01+425
CVTRV228 EQU   CVTS01+426
CVTRV237 EQU   CVTS01+427
CVTMFRTR EQU   CVTS01+452
CVTRV262 EQU   CVTS01+468
CVTRV271 EQU   CVTS01+469
CVTRV280 EQU   CVTS01+470
CVTRV289 EQU   CVTS01+471
CVTRMBR  EQU   CVTS01+492
CVTGSDA  EQU   CVTS01+600
UCMIECBA EQU   UCMRECBA+4
FLC      EQU   PSA
PSARSVTE EQU   PSARSVT
PSACSTK  EQU   PSARSVTE
         AGO   .@UNREFD                START UNREFERENCED COMPONENTS
PSARSAV  EQU   PSARSVTE+60
PSARSTK  EQU   PSARSVTE+56
PSAESAV3 EQU   PSARSVTE+52
PSAESTK3 EQU   PSARSVTE+48
PSAESAV2 EQU   PSARSVTE+44
PSAESTK2 EQU   PSARSVTE+40
PSAESAV1 EQU   PSARSVTE+36
PSAESTK1 EQU   PSARSVTE+32
PSAPSAV  EQU   PSARSVTE+28
PSAPSTK  EQU   PSARSVTE+24
PSAMSAV  EQU   PSARSVTE+20
PSAMSTK  EQU   PSARSVTE+16
PSASSAV  EQU   PSARSVTE+12
PSASSTK  EQU   PSARSVTE+8
PSANSTK  EQU   PSARSVTE+4
UCMIECBP EQU   UCMIECBA+1
UCMIECBF EQU   UCMIECBA
CVTRV628 EQU   CVTS01+728
CVTRV627 EQU   CVTS01+724
CVTRV626 EQU   CVTS01+720
CVTRV625 EQU   CVTS01+716
CVTRV624 EQU   CVTS01+712
CVTRV623 EQU   CVTS01+708
CVTRV622 EQU   CVTS01+704
CVTRV621 EQU   CVTS01+700
CVTIHASU EQU   CVTS01+696
CVTRV619 EQU   CVTS01+692
CVTRV618 EQU   CVTS01+688
CVTRV617 EQU   CVTS01+684
CVTRV616 EQU   CVTS01+680
CVTRV615 EQU   CVTS01+676
CVTRV614 EQU   CVTS01+672
CVTRV613 EQU   CVTS01+668
CVTTCASP EQU   CVTS01+664
CVT0PT03 EQU   CVTS01+660
CVT0PT0E EQU   CVTS01+656
CVTRV609 EQU   CVTS01+652
CVTCGK   EQU   CVTS01+648
CVTRAC   EQU   CVTS01+644
CVTHSM   EQU   CVTS01+640
CVTRV605 EQU   CVTS01+636
CVTRV604 EQU   CVTS01+632
CVTEFF02 EQU   CVTS01+628
CVTCBBR  EQU   CVTS01+624
CVTSSCR  EQU   CVTS01+620
CVTEVENT EQU   CVTS01+616
CVTCRCA  EQU   CVTS01+612
CVTTPIO  EQU   CVTS01+608
CVTADV   EQU   CVTS01+604
CVTGSDAB EQU   CVTGSDA
CVTQV3   EQU   CVTS01+596
CVTQV2   EQU   CVTS01+592
CVTQV1   EQU   CVTS01+588
CVTRPT   EQU   CVTS01+584
CVTSSRB  EQU   CVTS01+580
CVTCSDRL EQU   CVTS01+576
CVTEXP1  EQU   CVTS01+572
CVTRMPMT EQU   CVTS01+568
CVTRMPTT EQU   CVTS01+564
CVTVPSA  EQU   CVTS01+560
CVTVSTOP EQU   CVTS01+556
CVTGTFR8 EQU   CVTS01+552
CVTQUIT  EQU   CVTS01+548
CVTVACR  EQU   CVTS01+544
CVTWTCB  EQU   CVTS01+540
CVTSTPRS EQU   CVTS01+536
CVT0PT02 EQU   CVTS01+532
CVTDARCM EQU   CVTS01+528
CVTIRECM EQU   CVTS01+524
CVTJRECM EQU   CVTS01+520
CVTVEMS0 EQU   CVTS01+516
CVTSPFRR EQU   CVTS01+512
CVTRLSTG EQU   CVTS01+508
CVT0TC0A EQU   CVTS01+504
CVTGMBR  EQU   CVTS01+500
CVTLFRM  EQU   CVTS01+496
CVTVIOP  EQU   CVTS01+488
CVTRV307 EQU   CVTS01+486
CVTRV306 EQU   CVTS01+484
CVTRV305 EQU   CVTS01+482
CVTRV304 EQU   CVTS01+480
CVTRV303 EQU   CVTS01+478
CVTRV302 EQU   CVTS01+476
CVTTRCA  EQU   CVTS01+472
CVTRV297 EQU   CVTRV289
CVTRV296 EQU   CVTRV289
CVTRV295 EQU   CVTRV289
CVTRV294 EQU   CVTRV289
CVTRV293 EQU   CVTRV289
CVTRV292 EQU   CVTRV289
CVTRV291 EQU   CVTRV289
CVTRV290 EQU   CVTRV289
CVTRV288 EQU   CVTRV280
CVTRV287 EQU   CVTRV280
CVTRV286 EQU   CVTRV280
CVTRV285 EQU   CVTRV280
CVTRV284 EQU   CVTRV280
CVTRV283 EQU   CVTRV280
CVTRV282 EQU   CVTRV280
CVTRV281 EQU   CVTRV280
CVTRV279 EQU   CVTRV271
CVTRV278 EQU   CVTRV271
CVTRV277 EQU   CVTRV271
CVTRV276 EQU   CVTRV271
CVTRV275 EQU   CVTRV271
CVTRV274 EQU   CVTRV271
CVTRV273 EQU   CVTRV271
CVTRV272 EQU   CVTRV271
CVTRV270 EQU   CVTRV262
CVTRV269 EQU   CVTRV262
CVTRV268 EQU   CVTRV262
CVTRV267 EQU   CVTRV262
CVTRV266 EQU   CVTRV262
CVTRV265 EQU   CVTRV262
CVTRV264 EQU   CVTRV262
CVTRV263 EQU   CVTRV262
CVTVFP   EQU   CVTS01+464
CVTVSI   EQU   CVTS01+460
CVTVPSIB EQU   CVTS01+456
CVTMFACT EQU   CVTMFRTR
CVTMFCTL EQU   CVTS01+448
CVTPVBP  EQU   CVTS01+444
CVTPWI   EQU   CVTS01+440
CVTRV254 EQU   CVTS01+438
CVTRV253 EQU   CVTS01+436
CVTRV252 EQU   CVTS01+434
CVTRV251 EQU   CVTS01+433
CVTRV250 EQU   CVTS01+432
CVTRV249 EQU   CVTS01+431
CVTRV248 EQU   CVTS01+430
CVTRV247 EQU   CVTS01+429
CVTRV246 EQU   CVTS01+428
CVTRV245 EQU   CVTRV237
CVTRV244 EQU   CVTRV237
CVTRV243 EQU   CVTRV237
CVTRV242 EQU   CVTRV237
CVTRV241 EQU   CVTRV237
CVTRV240 EQU   CVTRV237
CVTRV239 EQU   CVTRV237
CVTRV238 EQU   CVTRV237
CVTRV236 EQU   CVTRV228
CVTRV235 EQU   CVTRV228
CVTRV234 EQU   CVTRV228
CVTRV233 EQU   CVTRV228
CVTRV232 EQU   CVTRV228
CVTRV231 EQU   CVTRV228
CVTRV230 EQU   CVTRV228
CVTRV229 EQU   CVTRV228
CVTRV227 EQU   CVTRV219
CVTRV226 EQU   CVTRV219
CVTRV225 EQU   CVTRV219
CVTRV224 EQU   CVTRV219
CVTRV223 EQU   CVTRV219
CVTRV222 EQU   CVTRV219
CVTRV221 EQU   CVTRV219
CVTRV220 EQU   CVTRV219
CVTRV218 EQU   CVTRV210
CVTRV217 EQU   CVTRV210
CVTRV216 EQU   CVTRV210
CVTRV215 EQU   CVTRV210
CVTRV214 EQU   CVTRV210
CVTRV213 EQU   CVTRV210
CVTRV212 EQU   CVTRV210
CVTRV211 EQU   CVTRV210
CVTLCCAT EQU   CVTS01+420
CVTPCCAT EQU   CVTS01+416
CVTIPCRP EQU   CVTS01+412
CVTIPCRI EQU   CVTS01+408
CVTIPCDS EQU   CVTS01+404
CVTAIDVT EQU   CVTS01+400
CVTSSAP  EQU   CVTS01+396
CVTEHCIR EQU   CVTS01+392
CVTEHDEF EQU   CVTS01+388
CVTDAIR  EQU   CVTS01+384
CVTPERFM EQU   CVTS01+380
CVT044R2 EQU   CVTS01+376
CVTFETCH EQU   CVTS01+372
CVTRSTWD EQU   CVTS01+368
CVTSPOST EQU   CVTS01+364
CVTIOBP  EQU   CVTS01+360
CVTASMVT EQU   CVTS01+356
CVTRECRQ EQU   CVTS01+352
CVTWSAC  EQU   CVTS01+348
CVTRV149 EQU   CVTS01+344
CVTWSAL  EQU   CVTS01+340
CVTSPSA  EQU   CVTS01+336
CVTGLMN  EQU   CVTS01+332
CVTVEAC0 EQU   CVTS01+328
CVT062R1 EQU   CVTS01+324
CVTRPOST EQU   CVTS01+320
CVTDQIQE EQU   CVTS01+316
CVTCSD   EQU   CVTS01+312
CVTLKRMA EQU   CVTS01+308
CVTRSPIE EQU   CVTS01+304
CVTRENQ  EQU   CVTS01+300
CVTLQCB  EQU   CVTS01+296
CVTFQCB  EQU   CVTS01+292
CVTQCS01 EQU   CVTS01+288
CVTAPFT  EQU   CVTS01+284
CVTPARRL EQU   CVTS01+280
CVTVWAIT EQU   CVTS01+276
CVTGSPL  EQU   CVTS01+272
CVTLSMQ  EQU   CVTS01+268
CVTGSMQ  EQU   CVTS01+264
CVTEXPRO EQU   CVTS01+260
CVTOPCTP EQU   CVTS01+256
CVTSIC   EQU   CVTS01+252
CVTTPIOS EQU   CVTS01+248
CVTRTMS  EQU   CVTS01+244
CVTSDBF  EQU   CVTS01+240
CVTSCBP  EQU   CVTS01+236
CVTSV60  EQU   CVTS01+228
CVTRTMCT EQU   CVTS01+224
CVTASCBL EQU   CVTS01+220
CVTASCBH EQU   CVTS01+216
CVTGDA   EQU   CVTS01+212
CVTASVT  EQU   CVTS01+208
CVTVVMDI EQU   CVTS01+204
CVTAQTOP EQU   CVTS01+200
CVTIOSCS EQU   CVTS01+196
CVTSDRM  EQU   CVTS01+192
CVTOPTE  EQU   CVTS01+188
CVTSTXU  EQU   CVTS01+184
CVTQUIS  EQU   CVTS01+180
CVTPARS  EQU   CVTS01+176
CVTS1EE  EQU   CVTS01+172
CVTFRAS  EQU   CVTS01+168
CVTQSAS  EQU   CVTS01+164
CVTCRAS  EQU   CVTS01+160
CVTDELCP EQU   CVTS01+152
CVTFRECL EQU   CVTS01+148
CVTGETCL EQU   CVTS01+144
CVTBLDCP EQU   CVTS01+140
CVTAUTHL EQU   CVTS01+136
CVTSCAN  EQU   CVTS01+132
CVTRV144 EQU   CVTS01+130
CVTMAXMP EQU   CVTS01+128
CVTSTCK  EQU   CVTS01+124
CVTRV139 EQU   CVTS01+123
CVTDSSAC EQU   CVTS01+122
CVTRV513 EQU   CVTS01+121
CVTIOSPL EQU   CVTS01+120
CVTPTGT  EQU   CVTS01+116
CVTCSPIE EQU   CVTS01+112
CVTSMFEX EQU   CVTS01+108
CVTOLT0A EQU   CVTS01+104
CVTSRBRT EQU   CVTS01+100
CVTPUTL  EQU   CVTS01+96
CVTASCRL EQU   CVTS01+92
CVTASCRF EQU   CVTS01+88
CVTRV326 EQU   CVTS01+84
CVTRV325 EQU   CVTS01+80
CVTRV324 EQU   CVTS01+76
CVT0VL01 EQU   CVTS01+72
CVTSHRVM EQU   CVTS01+68
CVTRV332 EQU   CVTS01+64
CVTTAS   EQU   CVTS01+60
CVTRSCN  EQU   CVTS01+56
CVTTRAC2 EQU   CVTS01+54
CVTTRACE EQU   CVTS01+52
CVTAPG   EQU   CVTS01+51
CVTSDTRC EQU   CVTCTLFG
CVTGTRCE EQU   CVTCTLFG
CVTNOMP  EQU   CVTCTLFG
CVTRSV79 EQU   CVTCTLFG
CVTDSTAT EQU   CVTCTLFG
CVTRSV78 EQU   CVTCTLFG
CVTRV333 EQU   CVTCTLFG
CVTRV323 EQU   CVTCTLFG
CVTSPVLK EQU   CVTS01+49
CVTRSV77 EQU   CVTS01+48
CVTRV331 EQU   CVTS01+44
CVTRV330 EQU   CVTS01+40
CVTRV329 EQU   CVTS01+36
CVTRV328 EQU   CVTS01+32
CVTRV322 EQU   CVTS01+28
CVTSLID  EQU   CVTSLIDA+1
CVTSYLK  EQU   CVTSLIDA
CVTRV321 EQU   CVTS01+20
CVTRV320 EQU   CVTS01+16
CVTLPDIR EQU   CVTLPDIA+1
CVTRSV69 EQU   CVTDIRST
CVTRSV68 EQU   CVTDIRST
CVTRSV67 EQU   CVTDIRST
CVTRSV66 EQU   CVTDIRST
CVTRSV65 EQU   CVTDIRST
CVTRSV64 EQU   CVTDIRST
CVTRSV63 EQU   CVTDIRST
CVTDICOM EQU   CVTDIRST
CVTPVTP  EQU   CVTS01+8
CVTLPDSR EQU   CVTS01+4
CVTGETL  EQU   CVTS01
LCCAR125 EQU   LCCA+964
LCCAR124 EQU   LCCA+960
LCCASGPR EQU   LCCA+896
LCCADRT2 EQU   LCCA+888
LCCADRT1 EQU   LCCA+880
LCCAR103 EQU   LCCA+876
LCCAESS2 EQU   LCCA+872
LCCASPLJ EQU   LCCA+868
LCCASMQJ EQU   LCCA+864
LCCAIRT  EQU   LCCA+736
LCCAASID EQU   LCCA+732
LCCARV89 EQU   LCCA+728
LCCASAFN EQU   LCCASRBF
LCCAECSA EQU   LCCA+716
LCCAICR0 EQU   LCCA+712
LCCALWTM EQU   LCCA+704
LCCARV78 EQU   LCCA+700
LCCAPINV EQU   LCCA+696
LCCARV88 EQU   LCCA+695
LCCARV87 EQU   LCCALKFG
LCCARV86 EQU   LCCALKFG
LCCARV85 EQU   LCCALKFG
LCCARV84 EQU   LCCALKFG
LCCALKRD EQU   LCCALKFG
LCCALKAQ EQU   LCCALKFG
LCCALKSA EQU   LCCALKFG
LCCALKDP EQU   LCCALKFG
LCCACRST EQU   LCCACREX
LCCACRDP EQU   LCCACREX
LCCACRLM EQU   LCCACREX
LCCACRIN EQU   LCCACREX
LCCACRRT EQU   LCCACREX
LCCACRLE EQU   LCCACREX
LCCACRRM EQU   LCCACREX
LCCACREF EQU   LCCACREX
LCCAVARY EQU   LCCACRFL
LCCARV73 EQU   LCCACRFL
LCCARV72 EQU   LCCACRFL
LCCARV71 EQU   LCCACRFL
LCCARV70 EQU   LCCACRFL
LCCARV69 EQU   LCCACRFL
LCCACLMS EQU   LCCACRFL
LCCACRTM EQU   LCCACRFL
LCCALCR0 EQU   LCCA+688
LCCACRLC EQU   LCCA+684
LCCARCPU EQU   LCCA+680
LCCADCPU EQU   LCCA+676
LCCASRBJ EQU   LCCA+672
LCCADSSR EQU   LCCA+668
LCCADSSC EQU   LCCA+660
LCCADSS3 EQU   LCCA+648
LCCADSS2 EQU   LCCA+636
LCCADSS1 EQU   LCCA+624
LCCAWTIM EQU   LCCA+616
LCCAITOD EQU   LCCA+608
LCCADTOD EQU   LCCA+600
LCCASTOD EQU   LCCA+592
LCCARIR5 EQU   LCCASPSA+44
LCCARIR4 EQU   LCCASPSA+40
LCCARIR3 EQU   LCCASPSA+36
LCCARIR2 EQU   LCCASPSA+32
LCCARPR5 EQU   LCCASPSA+28
LCCARPR4 EQU   LCCASPSA+24
LCCARPR3 EQU   LCCASPSA+20
LCCARPR2 EQU   LCCASPSA+16
LCCADSR5 EQU   LCCASPSA+12
LCCADSR4 EQU   LCCASPSA+8
LCCADSR3 EQU   LCCASPSA+4
LCCADSR2 EQU   LCCASPSA
LCCARV68 EQU   LCCA+543
LCCAPSMK EQU   LCCA+542
LCCARV67 EQU   LCCADSF2
LCCARV66 EQU   LCCADSF2
LCCARV65 EQU   LCCADSF2
LCCARV64 EQU   LCCADSF2
LCCADSRW EQU   LCCADSF2
LCCADSPL EQU   LCCADSF2
LCCAGSRB EQU   LCCADSF2
LCCASRBM EQU   LCCADSF2
LCCARV61 EQU   LCCADSF1
LCCARV60 EQU   LCCADSF1
LCCARV59 EQU   LCCADSF1
LCCARV58 EQU   LCCADSF1
LCCATIMR EQU   LCCADSF1
LCCADSS  EQU   LCCADSF1
LCCAVCPU EQU   LCCADSF1
LCCAACR  EQU   LCCADSF1
LCCACPUS EQU   LCCA+536
LCCAASCP EQU   LCCA+532
LCCAESSA EQU   LCCA+528
LCCARV55 EQU   LCCASPN4
LCCARV54 EQU   LCCASPN4
LCCARV53 EQU   LCCASPN4
LCCARV52 EQU   LCCASPN4
LCCARV51 EQU   LCCASPN4
LCCARV50 EQU   LCCASPN4
LCCARV49 EQU   LCCASPN4
LCCARV48 EQU   LCCASPN4
LCCARV47 EQU   LCCASPN3
LCCARV46 EQU   LCCASPN3
LCCARV45 EQU   LCCASPN3
LCCARV44 EQU   LCCASPN3
LCCARV43 EQU   LCCASPN3
LCCARV42 EQU   LCCASPN3
LCCARV41 EQU   LCCASPN3
LCCARV40 EQU   LCCASPN3
LCCARV39 EQU   LCCASPN2
LCCARV38 EQU   LCCASPN2
LCCARV37 EQU   LCCASPN2
LCCARV36 EQU   LCCASPN2
LCCARV35 EQU   LCCASPN2
LCCARV34 EQU   LCCASPN2
LCCARV33 EQU   LCCASPN2
LCCARV32 EQU   LCCASPN2
LCCARV31 EQU   LCCASPN1
LCCARV30 EQU   LCCASPN1
LCCAMFIO EQU   LCCASPN1
LCCARSTR EQU   LCCASPN1
LCCATSPN EQU   LCCASPN1
LCCALOCK EQU   LCCASPN1
LCCASIGP EQU   LCCASPN1
LCCAPTLB EQU   LCCASPN1
LCCARV27 EQU   LCCAIHR4
LCCARV26 EQU   LCCAIHR4
LCCARV25 EQU   LCCAIHR4
LCCARV24 EQU   LCCAIHR4
LCCARV23 EQU   LCCAIHR4
LCCARV22 EQU   LCCAIHR4
LCCARV21 EQU   LCCAIHR4
LCCARV20 EQU   LCCAIHR4
LCCARV19 EQU   LCCAIHR3
LCCARV18 EQU   LCCAIHR3
LCCARV17 EQU   LCCAIHR3
LCCARV16 EQU   LCCAIHR3
LCCARV15 EQU   LCCAIHR3
LCCARV14 EQU   LCCAIHR3
LCCARV13 EQU   LCCAIHR3
LCCARV12 EQU   LCCAIHR3
LCCARV11 EQU   LCCAIHR2
LCCARV10 EQU   LCCAIHR2
LCCARV09 EQU   LCCAIHR2
LCCARV08 EQU   LCCAIHR2
LCCARV07 EQU   LCCAIHR2
LCCARV06 EQU   LCCAIHR2
LCCARV05 EQU   LCCAIHR2
LCCARV04 EQU   LCCAIHR2
LCCARV03 EQU   LCCAIHR1
LCCARV02 EQU   LCCAIHR1
LCCARV01 EQU   LCCAIHR1
LCCAPPIE EQU   LCCAIHR1
LCCAPSG1 EQU   LCCAIHR1
LCCAPDAT EQU   LCCAIHR1
LCCAXRC2 EQU   LCCAIHR1
LCCAXRC1 EQU   LCCAIHR1
LCCAIOPS EQU   LCCA+512
LCCAGPGR EQU   LCCA+448
LCCAR133 EQU   LCCA+444
LCCAR132 EQU   LCCA+440
LCCAR131 EQU   LCCA+436
LCCAR130 EQU   LCCA+432
LCCAR129 EQU   LCCA+428
LCCAR128 EQU   LCCA+424
LCCAR127 EQU   LCCA+420
LCCAR126 EQU   LCCA+416
LCCARSGR EQU   LCCA+352
LCCAXGR3 EQU   LCCA+288
LCCAXGR2 EQU   LCCA+224
LCCAXGR1 EQU   LCCA+160
LCCACR0  EQU   LCCA+156
LCCAMCR1 EQU   LCCA+152
LCCAPVAD EQU   LCCA+148
LCCAPINT EQU   LCCA+144
LCCAPPSW EQU   LCCA+136
LCCAPGR2 EQU   LCCA+72
LCCAPGR1 EQU   LCCA+8
LCCARV77 EQU   LCCA+6
LCCACPUA EQU   LCCA+4
LCCALCCA EQU   LCCA
@NM00057 EQU   SDWA+512
@NM00056 EQU   SDWADPVA
SDWAEBC  EQU   SDWADPVA
SDWAVRAL EQU   SDWARA
@NM00055 EQU   SDWA+396
SDWACOMP EQU   SDWA+392
SDWARCPL EQU   SDWA+364
@NM00054 EQU   SDWADPSA+32
SDWATO4  EQU   SDWADPSL+28
SDWAFRM4 EQU   SDWADPSL+24
SDWATO3  EQU   SDWADPSL+20
SDWAFRM3 EQU   SDWADPSL+16
SDWATO2  EQU   SDWADPSL+12
SDWAFRM2 EQU   SDWADPSL+8
SDWATO1  EQU   SDWADPSL+4
SDWAFRM1 EQU   SDWADPSL
@NM00053 EQU   SDWADDAT+3
@NM00052 EQU   SDWAPDAT
SDWAUSPL EQU   SDWAPDAT
SDWADPSW EQU   SDWAPDAT
SDWATJPA EQU   SDWAPDAT
SDWATLPA EQU   SDWAPDAT
SDWADREG EQU   SDWAPDAT
SDWADSAH EQU   SDWAPDAT
SDWADSAS EQU   SDWAPDAT
@NM00051 EQU   SDWADDAT+1
@NM00050 EQU   SDWASDAT
SDWAQQS  EQU   SDWASDAT
SDWACBS  EQU   SDWASDAT
SDWAGTF  EQU   SDWASDAT
SDWASWA  EQU   SDWASDAT
SDWALSQA EQU   SDWASDAT
SDWASQA  EQU   SDWASDAT
SDWANUC  EQU   SDWASDAT
@NM00049 EQU   SDWADUMP+2
@NM00048 EQU   SDWADPFS
SDWASLST EQU   SDWADPFS
@NM00047 EQU   SDWADPFS
SDWADLST EQU   SDWADPFS
SDWADPT  EQU   SDWADPFS
SDWADPID EQU   SDWADUMP
SDWADPLA EQU   SDWA+316
SDWAREXN EQU   SDWARECP+16
SDWACSCT EQU   SDWARECP+8
SDWAMODN EQU   SDWARECP
@NM00046 EQU   SDWA+290
SDWAASID EQU   SDWA+288
SDWATALW EQU   SDWALKWS+28
SDWATDLW EQU   SDWALKWS+24
SDWATNLW EQU   SDWALKWS+20
SDWAAPLW EQU   SDWALKWS+16
SDWAIPLW EQU   SDWALKWS+12
SDWAILLW EQU   SDWALKWS+8
SDWAIULW EQU   SDWALKWS+4
SDWAICLW EQU   SDWALKWS
SDWAFLLK EQU   SDWAACF4
SDWACMS  EQU   SDWAACF4
SDWAOPTM EQU   SDWAACF4
SDWATADB EQU   SDWAACF4
SDWATDNB EQU   SDWAACF4
SDWATNCB EQU   SDWAACF4
SDWAILCH EQU   SDWAACF4
SDWAIUCB EQU   SDWAACF4
SDWAICAT EQU   SDWAACF3
SDWAIPRG EQU   SDWAACF3
SDWASALL EQU   SDWAACF3
SDWAASMP EQU   SDWAACF3
SDWADISP EQU   SDWAACF3
@NM00045 EQU   SDWAACF3
@NM00044 EQU   SDWAACF2
@NM00043 EQU   SDWAACF2
SDWASPIN EQU   SDWAACF2
@NM00042 EQU   SDWAACF2
SDWALCPU EQU   SDWACPUA+2
@NM00041 EQU   SDWACPUA
SDWARECA EQU   SDWA+244
@NM00040 EQU   SDWA+239
@NM00039 EQU   SDWAIOFS
SDWANIOP EQU   SDWAIOFS
SDWANOIO EQU   SDWAIOFS
SDWAIOHT EQU   SDWAIOFS
SDWAIOQR EQU   SDWAIOFS
SDWAFMID EQU   SDWA+236
@NM00038 EQU   SDWAERRD
SDWAMCIV EQU   SDWAERRD
SDWARPIV EQU   SDWAERRD
SDWAMABD EQU   SDWAERRD
SDWACTS  EQU   SDWAERRD
SDWASTAE EQU   SDWAERRD
SDWANRBE EQU   SDWAERRD
SDWACLUP EQU   SDWAERRD
@NM00037 EQU   SDWAERRC
SDWAEAS  EQU   SDWAERRC
SDWAPERC EQU   SDWAERRC
SDWAIRB  EQU   SDWAERRC
SDWASTAI EQU   SDWAERRC
SDWASTAF EQU   SDWAERRC
SDWASRBM EQU   SDWAERRB
SDWALDIS EQU   SDWAERRB
SDWAENRB EQU   SDWAERRB
SDWATYP1 EQU   SDWAERRB
@NM00036 EQU   SDWAERRB
SDWAPGIO EQU   SDWAERRA
SDWATEXC EQU   SDWAERRA
SDWASVCE EQU   SDWAERRA
SDWAABTM EQU   SDWAERRA
SDWASVCD EQU   SDWAERRA
SDWAPCHK EQU   SDWAERRA
SDWAMCHK EQU   SDWAERRA
SDWATIME EQU   SDWAMCH+20
SDWARFSA EQU   SDWAMCH+16
@NM00035 EQU   SDWAMCH+14
SDWAVEQR EQU   SDWARSR2
SDWAPGFX EQU   SDWARSR2
SDWAFLSQ EQU   SDWARSR2
SDWAFSQA EQU   SDWARSR2
SDWANUCL EQU   SDWARSR2
SDWASPER EQU   SDWARSR2
SDWAINTC EQU   SDWARSR2
SDWAOFLN EQU   SDWARSR2
SDWACHNG EQU   SDWARSR1
SDWAMSER EQU   SDWARSR1
@NM00034 EQU   SDWARSR1
SDWACPID EQU   SDWAMCH+10
SDWATERR EQU   SDWAMCHD
SDWAFPRX EQU   SDWAMCHD
SDWAINSF EQU   SDWAMCHD
SDWAACR  EQU   SDWAMCHD
SDWASCK  EQU   SDWAMCHD
SDWAPSWU EQU   SDWAMCHD
SDWAREGU EQU   SDWAMCHD
SDWASKYF EQU   SDWAMCHD
@NM00033 EQU   SDWAMCHS
SDWARSRF EQU   SDWAMCHS
SDWARSRC EQU   SDWAMCHS
SDWAINVP EQU   SDWAMCHS
SDWATSVL EQU   SDWAMCHS
SDWARCDF EQU   SDWAMCHS
SDWASRVL EQU   SDWAMCHS
SDWASCKE EQU   SDWASTCK+4
SDWASCKB EQU   SDWASTCK
SDWALNTH EQU   SDWAIDNT+1
SDWASPID EQU   SDWAIDNT
SDWASR15 EQU   SDWASRSV+60
SDWASR14 EQU   SDWASRSV+56
SDWASR13 EQU   SDWASRSV+52
SDWASR12 EQU   SDWASRSV+48
SDWASR11 EQU   SDWASRSV+44
SDWASR10 EQU   SDWASRSV+40
SDWASR09 EQU   SDWASRSV+36
SDWASR08 EQU   SDWASRSV+32
SDWASR07 EQU   SDWASRSV+28
SDWASR06 EQU   SDWASRSV+24
SDWASR05 EQU   SDWASRSV+20
SDWASR04 EQU   SDWASRSV+16
SDWASR03 EQU   SDWASRSV+12
SDWASR02 EQU   SDWASRSV+8
SDWASR01 EQU   SDWASRSV+4
SDWASR00 EQU   SDWASRSV
SDWATRN2 EQU   SDWAAEC2+4
SDWAIPC2 EQU   SDWAICD2
SDWAIMC2 EQU   SDWAICD2
SDWAIPR2 EQU   SDWAICD2
@NM00032 EQU   SDWAINC2
@NM00031 EQU   SDWAILC2
SDWAIL2  EQU   SDWAILC2
@NM00030 EQU   SDWAILC2
@NM00029 EQU   SDWAAEC2
SDWAADD2 EQU   SDWANXT2+1
@NM00028 EQU   SDWANXT2
@NM00027 EQU   SDWAEC2+3
SDWASGN2 EQU   SDWAINT2
SDWAEXP2 EQU   SDWAINT2
SDWADEC2 EQU   SDWAINT2
SDWAFPO2 EQU   SDWAINT2
SDWACC2  EQU   SDWAINT2
@NM00026 EQU   SDWAINT2
SDWAPGM2 EQU   SDWAMWP2
SDWAWAT2 EQU   SDWAMWP2
SDWAMCK2 EQU   SDWAMWP2
SDWAECT2 EQU   SDWAMWP2
SDWAKEY2 EQU   SDWAMWP2
SDWAEXT2 EQU   SDWAEMK2
SDWAIO2  EQU   SDWAEMK2
SDWATRM2 EQU   SDWAEMK2
@NM00025 EQU   SDWAEMK2
SDWAPER2 EQU   SDWAEMK2
@NM00024 EQU   SDWAEMK2
SDWATRAN EQU   SDWAAEC1+4
SDWAIPC1 EQU   SDWAICD1
SDWAIMC1 EQU   SDWAICD1
SDWAIPR1 EQU   SDWAICD1
@NM00023 EQU   SDWAINC1
@NM00022 EQU   SDWAILC1
SDWAIL1  EQU   SDWAILC1
@NM00021 EQU   SDWAILC1
@NM00020 EQU   SDWAAEC1
SDWAADD1 EQU   SDWANXT1+1
@NM00019 EQU   SDWANXT1
@NM00018 EQU   SDWAEC1+3
SDWASGN1 EQU   SDWAINT1
SDWAEXP1 EQU   SDWAINT1
SDWADEC1 EQU   SDWAINT1
SDWAFPO1 EQU   SDWAINT1
SDWACC1  EQU   SDWAINT1
@NM00017 EQU   SDWAINT1
SDWAPGM1 EQU   SDWAMWP1
SDWAWAT1 EQU   SDWAMWP1
SDWAMCK1 EQU   SDWAMWP1
SDWAECT1 EQU   SDWAMWP1
SDWAKEY1 EQU   SDWAMWP1
SDWAEXT1 EQU   SDWAEMK1
SDWAIO1  EQU   SDWAEMK1
SDWATRM1 EQU   SDWAEMK1
@NM00016 EQU   SDWAEMK1
SDWAPER1 EQU   SDWAEMK1
@NM00015 EQU   SDWAEMK1
SDWAIOBR EQU   SDWA+100
SDWAEPA  EQU   SDWA+96
@NM00014 EQU   SDWANAME+4
SDWARBAD EQU   SDWANAME
SDWAGR15 EQU   SDWAGRSV+60
SDWAGR14 EQU   SDWAGRSV+56
SDWAGR13 EQU   SDWAGRSV+52
SDWAGR12 EQU   SDWAGRSV+48
SDWAGR11 EQU   SDWAGRSV+44
SDWAGR10 EQU   SDWAGRSV+40
SDWAGR09 EQU   SDWAGRSV+36
SDWAGR08 EQU   SDWAGRSV+32
SDWAGR07 EQU   SDWAGRSV+28
SDWAGR06 EQU   SDWAGRSV+24
SDWAGR05 EQU   SDWAGRSV+20
SDWAGR04 EQU   SDWAGRSV+16
SDWAGR03 EQU   SDWAGRSV+12
SDWAGR02 EQU   SDWAGRSV+8
SDWAGR01 EQU   SDWAGRSV+4
SDWAGR00 EQU   SDWAGRSV
SDWANXTP EQU   SDWACTL2+5
SDWASGP  EQU   SDWAPMKP
SDWAEUP  EQU   SDWAPMKP
SDWADOP  EQU   SDWAPMKP
SDWAFPP  EQU   SDWAPMKP
SDWACCP  EQU   SDWAPMKP
SDWAILP  EQU   SDWAPMKP
SDWAINTP EQU   SDWACTL2+2
SDWASPVP EQU   SDWAMWPP
SDWAWATP EQU   SDWAMWPP
SDWAMCKP EQU   SDWAMWPP
@NM00013 EQU   SDWAMWPP
SDWAKEYP EQU   SDWAMWPP
SDWAEXTP EQU   SDWACMKP
SDWAIOP  EQU   SDWACMKP
SDWANXTA EQU   SDWACTL1+5
SDWASGA  EQU   SDWAPMKA
SDWAEUA  EQU   SDWAPMKA
SDWADOA  EQU   SDWAPMKA
SDWAFPA  EQU   SDWAPMKA
SDWACCA  EQU   SDWAPMKA
SDWAILA  EQU   SDWAPMKA
SDWAINTA EQU   SDWACTL1+2
SDWASPVA EQU   SDWAMWPA
SDWAWATA EQU   SDWAMWPA
SDWAMCKA EQU   SDWAMWPA
@NM00012 EQU   SDWAMWPA
SDWAKEYA EQU   SDWAMWPA
SDWAEXTA EQU   SDWACMKA
SDWAIOA  EQU   SDWACMKA
@NM00011 EQU   SDWACMPF
SDWASTCC EQU   SDWACMPF
@NM00010 EQU   SDWACMPF
SDWASTEP EQU   SDWACMPF
SDWAREQ  EQU   SDWACMPF
UCMPRSV2 EQU   UCMPEXTA+20
UCMPRSV1 EQU   UCMPDM1+8
UCMPNMCC EQU   UCMPDM1+4
UCMPWQE  EQU   UCMPDM1
UCMPUCMP EQU   UCMPEXTA
UCMFRSV3 EQU   UCMFEXTA+20
UCMF80WQ EQU   UCMFEXTA+18
UCMF60WQ EQU   UCMFEXTA+16
UCMFRSV2 EQU   UCMFMGFS+4
UCMFRSV1 EQU   UCMFMGFS+2
UCMFFLG2 EQU   UCMFMGFS+1
UCMFBR07 EQU   UCMFFLG1
UCMFBR06 EQU   UCMFFLG1
UCMFBR05 EQU   UCMFFLG1
UCMFBR04 EQU   UCMFFLG1
UCMFBR03 EQU   UCMFFLG1
UCMFMSGN EQU   UCMFFLG1
UCMFMSGA EQU   UCMFFLG1
UCMFMSGE EQU   UCMFFLG1
UCMFPPTR EQU   UCMFEXTA+4
UCMFUCMF EQU   UCMFEXTA
UCMRCTA  EQU   UCMRCT+1
UCMRSV31 EQU   UCMSDS5
UCMSDS5G EQU   UCMSDS5
UCMSDS5F EQU   UCMSDS5
UCMRSV30 EQU   UCMSDS5
UCMRSV29 EQU   UCMSDS5
UCMSDS5C EQU   UCMSDS5
UCMSDS5B EQU   UCMSDS5
UCMSDS5A EQU   UCMSDS5
UCMMLAST EQU   UCMLIST+64
UCMVHRSN EQU   UCMDEVC
UCMDEVG  EQU   UCMDEVC
UCMDEVF  EQU   UCMDEVC
UCMDEVE  EQU   UCMDEVC
UCMDEVD  EQU   UCMDEVC
UCMDEVCC EQU   UCMDEVC
UCMDEVB  EQU   UCMDEVC
UCMDEVA  EQU   UCMDEVC
UCMXOR   EQU   UCMLIST+62
UCMMSG2  EQU   UCMMSG+1
UCMRSV27 EQU   UCMMSG1
UCMRSV26 EQU   UCMMSG1
UCMMSGF  EQU   UCMMSG1
UCMMSGE  EQU   UCMMSG1
UCMMSGD  EQU   UCMMSG1
UCMMSGC  EQU   UCMMSG1
UCMMSGB  EQU   UCMMSG1
UCMMSGA  EQU   UCMMSG1
UCMCOMPC EQU   UCMLIST+56
UCMWLAST EQU   UCMLIST+52
UCMOAOEN EQU   UCMLIST+48
UCMALTEN EQU   UCMLIST+44
UCMRV007 EQU   UCMDISP2
UCMRV006 EQU   UCMDISP2
UCMRV005 EQU   UCMDISP2
UCMRV004 EQU   UCMDISP2
UCMRV003 EQU   UCMDISP2
UCMDISPK EQU   UCMDISP2
UCMDISPJ EQU   UCMDISP2
UCMDISPI EQU   UCMDISP2
UCMDISPH EQU   UCMDISP1
UCMDISPG EQU   UCMDISP1
UCMDISPF EQU   UCMDISP1
UCMDISPE EQU   UCMDISP1
UCMDISPD EQU   UCMDISP1
UCMDISPC EQU   UCMDISP1
UCMDISPB EQU   UCMDISP1
UCMDISPA EQU   UCMDISP1
UCMAUTHB EQU   UCMAUTH+1
UCMRSV23 EQU   UCMAUTHA
UCMRSV22 EQU   UCMAUTHA
UCMRSV21 EQU   UCMAUTHA
UCMRSV20 EQU   UCMAUTHA
UCMRSV19 EQU   UCMAUTHA
UCMAUTH3 EQU   UCMAUTHA
UCMAUTH2 EQU   UCMAUTHA
UCMAUTH1 EQU   UCMAUTHA
UCMOUTQ  EQU   UCMLIST+36
UCMRSV18 EQU   UCMLIST+34
UCMRTCD  EQU   UCMLIST+32
UCMXB    EQU   UCMLIST+28
@NM00009 EQU   UCMXA+1
UCMID    EQU   UCMXA
UCMRSV17 EQU   UCMATR
UCMRSV16 EQU   UCMATR
UCMAT04  EQU   UCMATR
UCMLF    EQU   UCMATR
UCMUF    EQU   UCMATR
UCMXF    EQU   UCMATR
UCMIF    EQU   UCMATR
UCMOF    EQU   UCMATR
UCMTC    EQU   UCMSTS
UCMTD    EQU   UCMSTS
UCMTB    EQU   UCMSTS
UCMTA    EQU   UCMSTS
UCMCF    EQU   UCMSTS
UCMBF    EQU   UCMSTS
UCMPF    EQU   UCMSTS
UCMAF    EQU   UCMSTS
UCMNAME  EQU   UCMLIST+16
UCMUCB   EQU   UCMLIST+12
UCMDCB   EQU   UCMLIST+8
UCMSBR   EQU   UCMLIST+4
UCMECB   EQU   UCMLIST
UCMTPSAV EQU   UCMEXIT+208
UCMXTSAV EQU   UCMEXIT+136
UCMDESCD EQU   UCMEXIT+132
UCMROUTC EQU   UCMEXIT+128
UCMMSTXT EQU   UCMEXIT
UCMDECBA EQU   UCMEIL+20
UCMOECBA EQU   UCMEIL+16
UCMAECBA EQU   UCMEIL+12
UCMXECBA EQU   UCMEIL+8
UCMNIPTR EQU   UCMEIL+4
UCMRSV15 EQU   UCMEIL+3
UCMRTCT  EQU   UCMEIL+2
UCMRPYL  EQU   UCMEIL+1
@NM00008 EQU   UCMEIL
UCMRSV60 EQU   UCM+302
UCMRSV59 EQU   UCMRSV51
UCMRSV58 EQU   UCMRSV51
UCMRSV57 EQU   UCMRSV51
UCMRSV56 EQU   UCMRSV51
UCMRSV55 EQU   UCMRSV51
UCMRSV54 EQU   UCMRSV51
UCMRSV53 EQU   UCMRSV51
UCMRSV52 EQU   UCMRSV51
UCMRSV50 EQU   UCMRSV42
UCMRSV49 EQU   UCMRSV42
UCMRSV48 EQU   UCMRSV42
UCMRSV47 EQU   UCMRSV42
UCMRSV46 EQU   UCMRSV42
UCMRSV45 EQU   UCMRSV42
UCMRSV44 EQU   UCMRSV42
UCMRSV43 EQU   UCMRSV42
UCMJES3T EQU   UCM+296
UCMWAKUP EQU   UCM+292
UCMFRRAD EQU   UCM+288
UCMSWCH  EQU   UCM+284
UCMWQECP EQU   UCM+276
UCMORECP EQU   UCM+272
UCMOECBT EQU   UCM+268
UCMOECBH EQU   UCM+264
UCMWECBT EQU   UCM+260
UCMWECBH EQU   UCM+256
UCMMBEND EQU   UCM+252
UCMRSV61 EQU   UCM+248
UCMRP2AD EQU   UCM+244
UCMCRAAD EQU   UCM+240
UCMWQLM1 EQU   UCM+238
UCMRV001 EQU   UCM+237
UCMRQLM1 EQU   UCM+236
UCMMBPTR EQU   UCM+232
UCMMQNXT EQU   UCM+228
UCMMQEND EQU   UCM+224
UCMMQPTR EQU   UCM+220
UCMTRECB EQU   UCM+216
UCMMNECB EQU   UCM+212
UCMMNTR  EQU   UCM+208
UCMR9SV  EQU   UCM+204
UCMSAVE4 EQU   UCM+140
UCMSAVE3 EQU   UCM+84
UCMVEL   EQU   UCMVDATA+8
UCMVEZ   EQU   UCMVDATA+4
UCMVEA   EQU   UCMVDATA
UCMINCR  EQU   UCM+71
UCMMODEL EQU   UCM+70
UCMCORE  EQU   UCM+69
UCMFIX   EQU   UCMMODE
UCMMCS   EQU   UCMMODE
UCMOGCE  EQU   UCMMODE
UCMAMFA  EQU   UCMMODE
UCMRSV14 EQU   UCMMODE
UCMTPUTA EQU   UCMMODE
UCMNOCON EQU   UCMMODE
UCMRSV11 EQU   UCMMODE
UCMWQEND EQU   UCM+60
UCMWQNR  EQU   UCM+58
UCMRQNR  EQU   UCM+56
UCMWQECB EQU   UCM+52
UCMRQECB EQU   UCM+48
UCMWQLM  EQU   UCM+46
UCMRQLM  EQU   UCM+45
@NM00007 EQU   UCMRPYI
UCMRPYQ  EQU   UCM+28
UCMWTOQ  EQU   UCM+24
UCMLSTP  EQU   UCM+20
UCMARECB EQU   UCM+16
UCMLECB  EQU   UCMDECB
UCMAECB  EQU   UCM+4
UCMXECB  EQU   UCM
UCMGMCNT EQU   UCMPRFX+158
UCMSDS2  EQU   UCMPRFX+157
UCMRSV09 EQU   UCMSDS1
UCMRSV08 EQU   UCMSDS1
UCMRSV07 EQU   UCMSDS1
UCMRSV06 EQU   UCMSDS1
UCMRSV05 EQU   UCMSDS1
UCMRSV04 EQU   UCMSDS1
UCMSDS1B EQU   UCMSDS1
UCMSDS1A EQU   UCMSDS1
UCMDTINT EQU   UCMPRFX+152
UCMLOGAD EQU   UCMPRFX+148
UCMNPECB EQU   UCMPRFX+144
UCMTPPTR EQU   UCMPRFX+140
UCMDOMRT EQU   UCMPRFX+136
UCMRUTCK EQU   UCMPRFX+132
UCMQRTN  EQU   UCMPRFX+128
UCM6WD   EQU   UCMXSA+20
UCM5WD   EQU   UCMXSA+16
UCM4WD   EQU   UCMXSA+12
UCM3WD   EQU   UCMXSA+8
UCM2WD   EQU   UCMXSA+4
UCM1WD   EQU   UCMXSA
UCMRSV03 EQU   UCMPRFX+102
UCMHRDRT EQU   UCMPRFX+100
UCMUEXIT EQU   UCMPRFX+97
UCMXCT   EQU   UCMPRFX+96
UCMHCUCM EQU   UCMPRFX+92
UCMCMID  EQU   UCMPRFX+88
UCMOWTOR EQU   UCMPRFX+86
UCMRSV02 EQU   UCMSFLG2
UCMSYSO  EQU   UCMSFLG2
UCMSYSN  EQU   UCMSFLG2
UCMSYSM  EQU   UCMSFLG2
UCMSYSL  EQU   UCMSFLG2
UCMSYSK  EQU   UCMSFLG2
UCMSYSJ  EQU   UCMSFLG2
UCMSYSI  EQU   UCMSFLG2
UCMRSV35 EQU   UCMSFLG1
UCMSYSG  EQU   UCMSFLG1
UCMSYSF  EQU   UCMSFLG1
UCMSYSE  EQU   UCMSFLG1
UCMSYSD  EQU   UCMSFLG1
UCMSYSC  EQU   UCMSFLG1
UCMSYSB  EQU   UCMSFLG1
UCMRSV01 EQU   UCMSFLG1
UCMWTOX  EQU   UCMPRFX+80
UCMDOME  EQU   UCMPRFX+76
UCMSVR0  EQU   UCMSAVE0+68
UCMSVQ0  EQU   UCMSAVE0+64
UCMSVP0  EQU   UCMSAVE0+60
UCMSVO0  EQU   UCMSAVE0+56
UCMSVN0  EQU   UCMSAVE0+52
UCMSVM0  EQU   UCMSAVE0+48
UCMSVL0  EQU   UCMSAVE0+44
UCMSVK0  EQU   UCMSAVE0+40
UCMSVJ0  EQU   UCMSAVE0+36
UCMSVI0  EQU   UCMSAVE0+32
UCMSVH0  EQU   UCMSAVE0+28
UCMSVG0  EQU   UCMSAVE0+24
UCMSVF0  EQU   UCMSAVE0+20
UCMSVE0  EQU   UCMSAVE0+16
UCMSVD0  EQU   UCMSAVE0+12
UCMSVC0  EQU   UCMSAVE0+8
UCMSVB0  EQU   UCMSAVE0+4
UCMSVA0  EQU   UCMSAVE0
UCMMCENT EQU   UCMPRFX
UCM2FEXT EQU   UCM2EXT+12
UCM2STAA EQU   UCM2STA+1
UCMRV008 EQU   UCM2SFLG
UCMRSV34 EQU   UCM2SFLG
UCMRSV33 EQU   UCM2SFLG
UCM2WTOI EQU   UCM2SFLG
UCM2DSTR EQU   UCM2SFLG
UCM2DTAK EQU   UCM2SFLG
UCM2SENT EQU   UCM2SFLG
UCM2SDWA EQU   UCM2SFLG
UCM2PST  EQU   UCM2EXT+4
UCM2RID  EQU   UCM2EXT+2
UCM2WID  EQU   UCM2EXT
@NM00006 EQU   FRRSFLGS+1
@NM00005 EQU   FRRSFLG1
FRRSNEST EQU   FRRSFLG1
FRRSRCUR EQU   FRRSFLG1
FRRSENTS EQU   FRRS+84
FRRSRTMW EQU   FRRS+16
ASCBEND  EQU   ASCB+208
ASCBSRBT EQU   ASCB+200
ASCBSWTL EQU   ASCB+196
ASCBRS14 EQU   ASCB+195
ASCBSMCT EQU   ASCB+194
ASCBRS12 EQU   ASCB+192
ASCBPCTT EQU   ASCB+188
ASCBVGTT EQU   ASCB+184
ASCBLGCB EQU   ASCB+180
ASCBJBNS EQU   ASCB+176
ASCBJBNI EQU   ASCB+172
ASCBMCC  EQU   ASCB+168
ASCBRTWA EQU   ASCB+164
ASCBIQEA EQU   ASCB+160
ASCBXMPQ EQU   ASCB+156
ASCBRS01 EQU   ASCB+154
ASCBFMCT EQU   ASCB+152
ASCBOUXB EQU   ASCB+148
ASCBOUCB EQU   ASCB+144
ASCBMECB EQU   ASCB+140
ASCBQECB EQU   ASCB+136
ASCBCMSB EQU   ASCB+132
ASCBCMSF EQU   ASCB+128
ASCBTCBS EQU   ASCB+124
ASCBNVSC EQU   ASCB+122
ASCBVSC  EQU   ASCB+120
ASCBSRBS EQU   ASCB+118
ASCBSSRB EQU   ASCB+116
ASCBRV06 EQU   ASCBFLG2
ASCBRV05 EQU   ASCBFLG2
ASCBRV04 EQU   ASCBFLG2
ASCBSNQS EQU   ASCBFLG2
ASCBS2S  EQU   ASCBFLG2
ASCBCEXT EQU   ASCBFLG2
ASCBPXMT EQU   ASCBFLG2
ASCBXMPT EQU   ASCBFLG2
ASCBRF07 EQU   ASCBDSP1
ASCBRF06 EQU   ASCBDSP1
ASCBRF05 EQU   ASCBDSP1
ASCBRF04 EQU   ASCBDSP1
ASCBRF03 EQU   ASCBDSP1
ASCBRF02 EQU   ASCBDSP1
ASCBFAIL EQU   ASCBDSP1
ASCBNOQ  EQU   ASCBDSP1
ASCBSWCT EQU   ASCB+112
ASCBASXB EQU   ASCB+108
ASCBTMCH EQU   ASCB+104
ASCBNSWP EQU   ASCBFLG1
ASCBTYP1 EQU   ASCBFLG1
ASCBSTND EQU   ASCBFLG1
ASCBABNT EQU   ASCBFLG1
ASCBTERM EQU   ASCBFLG1
ASCBS3S  EQU   ASCBFLG1
ASCBCMSH EQU   ASCBFLG1
ASCBTOFF EQU   ASCBFLG1
ASCBRF01 EQU   ASCBRCTF
ASCBTMLW EQU   ASCBRCTF
ASCBOUT  EQU   ASCBRCTF
ASCBWAIT EQU   ASCBRCTF
ASCBRV08 EQU   ASCBRCTF
ASCBFQU  EQU   ASCBRCTF
ASCBFRS  EQU   ASCBRCTF
ASCBTMNO EQU   ASCBRCTF
ASCBAFFN EQU   ASCBFW1
ASCBDUMP EQU   ASCB+96
ASCBQSVC EQU   ASCB+92
ASCBUBET EQU   ASCB+88
ASCBECB  EQU   ASCB+84
ASCBJSTL EQU   ASCB+80
ASCBEWST EQU   ASCB+72
ASCBEJST EQU   ASCB+64
ASCBTSB  EQU   ASCB+60
ASCBCSCB EQU   ASCB+56
ASCBRSM  EQU   ASCB+52
ASCBLDA  EQU   ASCB+48
ASCBSTOR EQU   ASCB+44
ASCBDP   EQU   ASCB+43
ASCBRV07 EQU   ASCB+42
ASCBIOSM EQU   ASCB+40
ASCBSEQN EQU   ASCB+38
ASCBCPUS EQU   ASCB+32
ASCBSPL  EQU   ASCB+28
ASCBLSLQ EQU   ASCB+24
ASCBFSLQ EQU   ASCB+20
ASCBIOSP EQU   ASCB+16
ASCBLOCK EQU   ASCB+12
ASCBBWDP EQU   ASCB+8
ASCBFWDP EQU   ASCB+4
ASCBASCB EQU   ASCB
ASCBEGIN EQU   ASCB
PARMCTBK EQU   PARMSTAT+3
@NM00004 EQU   PARMFLAG
@NM00003 EQU   PARMFLAG
PARMFTPT EQU   PARMSTAT
WWBECB   EQU   WWB+20
WWBRESRV EQU   WWB+17
WWBPOSTD EQU   WWBFLAGS
WWBBCKPT EQU   WWB+4
WWBFWDPT EQU   WWB
CVTLEVL  EQU   CVTRELNO+2
CVTNUMB  EQU   CVTRELNO
CVTMDL   EQU   CVTFIX+250
@NM00002 EQU   CVTFIX+248
@NM00001 EQU   CVTFIX
CVTRV482 EQU   CVTXTNT2+128
CVTRV481 EQU   CVTXTNT2+124
CVTRV480 EQU   CVTXTNT2+120
CVTRV479 EQU   CVTXTNT2+118
CVTRV478 EQU   CVTXTNT2+117
CVTRV477 EQU   CVTXTNT2+116
CVTRV476 EQU   CVTXTNT2+115
CVTRV475 EQU   CVTXTNT2+114
CVTRV474 EQU   CVTRV466
CVTRV473 EQU   CVTRV466
CVTRV472 EQU   CVTRV466
CVTRV471 EQU   CVTRV466
CVTRV470 EQU   CVTRV466
CVTRV469 EQU   CVTRV466
CVTRV468 EQU   CVTRV466
CVTRV467 EQU   CVTRV466
CVTRV465 EQU   CVTRV457
CVTRV464 EQU   CVTRV457
CVTRV463 EQU   CVTRV457
CVTRV462 EQU   CVTRV457
CVTRV461 EQU   CVTRV457
CVTRV460 EQU   CVTRV457
CVTRV459 EQU   CVTRV457
CVTRV458 EQU   CVTRV457
CVTRV456 EQU   CVTXTNT2+108
CVTRV455 EQU   CVTXTNT2+104
CVTRV454 EQU   CVTXTNT2+100
CVTRV453 EQU   CVTXTNT2+96
CVTRV452 EQU   CVTXTNT2+94
CVTRV451 EQU   CVTXTNT2+92
CVTRV450 EQU   CVTXTNT2+90
CVTRV449 EQU   CVTXTNT2+88
CVTRV448 EQU   CVTXTNT2+87
CVTRV447 EQU   CVTXTNT2+86
CVTRV446 EQU   CVTRV438
CVTRV445 EQU   CVTRV438
CVTRV444 EQU   CVTRV438
CVTRV443 EQU   CVTRV438
CVTRV442 EQU   CVTRV438
CVTRV441 EQU   CVTRV438
CVTRV440 EQU   CVTRV438
CVTRV439 EQU   CVTRV438
CVTRV437 EQU   CVTRV429
CVTRV436 EQU   CVTRV429
CVTRV435 EQU   CVTRV429
CVTRV434 EQU   CVTRV429
CVTRV433 EQU   CVTRV429
CVTRV432 EQU   CVTRV429
CVTRV431 EQU   CVTRV429
CVTRV430 EQU   CVTRV429
CVTRV428 EQU   CVTXTNT2+80
CVTRV427 EQU   CVTXTNT2+76
CVTRV426 EQU   CVTXTNT2+72
CVTRV425 EQU   CVTXTNT2+68
CVTATACT EQU   CVTATCVT
CVTRV423 EQU   CVTXTNT2+62
CVTRV422 EQU   CVTXTNT2+60
CVTRV421 EQU   CVTXTNT2+58
CVTRV420 EQU   CVTXTNT2+56
CVTRV419 EQU   CVTXTNT2+55
CVTRV418 EQU   CVTXTNT2+54
CVTRV417 EQU   CVTRV409
CVTRV416 EQU   CVTRV409
CVTRV415 EQU   CVTRV409
CVTRV414 EQU   CVTRV409
CVTRV413 EQU   CVTRV409
CVTRV412 EQU   CVTRV409
CVTRV411 EQU   CVTRV409
CVTRV410 EQU   CVTRV409
CVTRV408 EQU   CVTRV400
CVTRV407 EQU   CVTRV400
CVTRV406 EQU   CVTRV400
CVTRV405 EQU   CVTRV400
CVTRV404 EQU   CVTRV400
CVTRV403 EQU   CVTRV400
CVTRV402 EQU   CVTRV400
CVTRV401 EQU   CVTRV400
CVTICB   EQU   CVTXTNT2+48
CVTSKTA  EQU   CVTXTNT2+44
CVTCCVT  EQU   CVTXTNT2+40
CVTRSV98 EQU   CVTXTNT2+36
CVTRSV97 EQU   CVTXTNT2+34
CVTRSV96 EQU   CVTXTNT2+32
CVTOLTEP EQU   CVTXTNT2+28
CVTQIDA  EQU   CVTQID+1
CVTRSV95 EQU   CVTQID
CVTRSV94 EQU   CVTXTNT2+20
CVTRSV93 EQU   CVTXTNT2+16
CVTRSV92 EQU   CVTXTNT2+12
CVTDEBVR EQU   CVTXTNT2+8
CVTRSV91 EQU   CVTXTNT2+6
CVTRSV9H EQU   CVTFLGBT
CVTRSV9G EQU   CVTFLGBT
CVTRSV9F EQU   CVTFLGBT
CVTRSV9E EQU   CVTFLGBT
CVTRSV9D EQU   CVTFLGBT
CVTRSV9C EQU   CVTFLGBT
CVTVME   EQU   CVTFLGBT
CVTNPE   EQU   CVTFLGBT
CVTNUCLS EQU   CVTXTNT2+4
CVTDSSVA EQU   CVTDSSV+1
CVTRSV89 EQU   CVTDSSV
CVTRSV88 EQU   CVTXTNT1+8
CVTRSV87 EQU   CVTXTNT1+4
CVTFACHN EQU   CVTXTNT1
CVTRV488 EQU   CVTMAP+412
CVTRV487 EQU   CVTMAP+408
CVTRV486 EQU   CVTMAP+404
CVTRV485 EQU   CVTMAP+400
CVTACTAP EQU   CVTMAP+396
CVTAUTH  EQU   CVTMAP+392
CVTATMCA EQU   CVTATMCT+1
CVTATMST EQU   CVTATMCT
CVTRSV61 EQU   CVTMAP+384
CVTVOLT1 EQU   CVTVOLM1+1
CVTVOLI1 EQU   CVTVOLF1
CVTSTOA  EQU   CVTMAP+376
CVTRSV58 EQU   CVTMAP+374
CVTRSV57 EQU   CVTMAP+372
CVTDDCE  EQU   CVTMAP+368
CVTPNWFR EQU   CVTMAP+364
CVTSMF   EQU   CVTMAP+360
CVTSULK  EQU   CVTMAP+358
CVTSLKO  EQU   CVTSYSK
CVTSLKP  EQU   CVTSYSK
CVTSLKQ  EQU   CVTSYSK
CVTSLKR  EQU   CVTSYSK
CVTRSV56 EQU   CVTSYSK
CVTRSV55 EQU   CVTSYSK
CVTRSV54 EQU   CVTSYSK
CVTRSV53 EQU   CVTSYSK
CVTRSV52 EQU   CVTA1F1
CVTRSV51 EQU   CVTA1F1
CVTRSV50 EQU   CVTA1F1
CVTRSV49 EQU   CVTA1F1
CVTRSV48 EQU   CVTA1F1
CVTRSV47 EQU   CVTA1F1
CVTSRSW  EQU   CVTA1F1
CVTPFSW  EQU   CVTA1F1
CVTPCVT  EQU   CVTMAP+352
CVTRSV46 EQU   CVTMAP+344
CVTRSV45 EQU   CVTMAP+340
CVTRSV44 EQU   CVTMAP+338
CVTRSV43 EQU   CVTMAP+336
CVTHJESA EQU   CVTHJES+1
CVTRSV42 EQU   CVTHJES
CVTEXT2A EQU   CVTEXT2+1
CVTRSV41 EQU   CVTEXT2
CVTAPFA  EQU   CVTAPF+1
CVTRSV40 EQU   CVTAPF
CVTRV518 EQU   CVTINTLA
CVTRV517 EQU   CVTERPV
CVTEORM  EQU   CVTMAP+312
CVTMCHPR EQU   CVTMAP+308
CVTTZ    EQU   CVTMAP+304
CVTJEPS  EQU   CVTMAP+300
CVTJESCT EQU   CVTMAP+296
CVTMODE  EQU   CVTMAP+292
CVTPTRV  EQU   CVTMAP+288
CVTREAL  EQU   CVTMAP+284
CVTRSV39 EQU   CVTMAP+280
CVTRSV38 EQU   CVTMAP+276
CVTDMSRA EQU   CVTDMSR+1
CVTRV634 EQU   CVTDMSRF
CVTRV633 EQU   CVTDMSRF
CVTRV632 EQU   CVTDMSRF
CVTRV631 EQU   CVTDMSRF
CVTRV630 EQU   CVTDMSRF
CVTRV629 EQU   CVTDMSRF
CVTUDUMP EQU   CVTDMSRF
CVTSDUMP EQU   CVTDMSRF
CVTQMSGA EQU   CVTQMSG+1
CVTRSV36 EQU   CVTQMSG
CVTAMFF  EQU   CVTMAP+264
CVTPURGA EQU   CVTPURG+1
CVTRSV35 EQU   CVTPURG
CVTCBSP  EQU   CVTMAP+256
CVTATERA EQU   CVTATER+1
CVTSYST  EQU   CVTATER
CVTVOLT2 EQU   CVTTAT
CVTVOLI2 EQU   CVTVOLF2
CVTAQAVB EQU   CVTAQAVT+1
CVTRSV34 EQU   CVTTCMFG
CVTRSV33 EQU   CVTTCMFG
CVTRSV32 EQU   CVTTCMFG
CVTRSV31 EQU   CVTTCMFG
CVTRSV30 EQU   CVTTCMFG
CVTRSV29 EQU   CVTTCMFG
CVTRSV28 EQU   CVTTCMFG
CVTTCRDY EQU   CVTTCMFG
CVTGTFA  EQU   CVTGTF+1
CVTRSV27 EQU   CVTGTFST
CVTRNIO  EQU   CVTGTFST
CVTUSR   EQU   CVTGTFST
CVTRV318 EQU   CVTFORM
CVTRV317 EQU   CVTTMODE
CVTRV316 EQU   CVTSTATE
CVTRV315 EQU   CVTGTFS
CVTGTFAV EQU   CVTGTFS
CVT0SCR1 EQU   CVTMAP+232
CVTRV515 EQU   CVTMAP+228
CVTRMS   EQU   CVTMAP+224
CVTPATCH EQU   CVTMAP+220
CVTTSCE  EQU   CVTMAP+216
CVTLNKSC EQU   CVTMAP+214
CVTQABST EQU   CVTMAP+212
CVTMDLDS EQU   CVTMAP+208
CVTUSER  EQU   CVTMAP+204
CVTABEND EQU   CVTMAP+200
CVTSMCA  EQU   CVTMAP+196
CVTRSV18 EQU   CVTMAP+192
CVTQLPAQ EQU   CVTMAP+188
CVTQCDSR EQU   CVTMAP+184
CVTRSV17 EQU   CVTOPTB
CVTRSV16 EQU   CVTOPTB
CVTFP    EQU   CVTOPTB
CVTAPTHR EQU   CVTOPTB
CVTNLOG  EQU   CVTOPTB
CVTTOD   EQU   CVTOPTB
CVTCTIMS EQU   CVTOPTB
CVTPROT  EQU   CVTOPTB
CVTXPFP  EQU   CVTOPTA
CVTASCII EQU   CVTOPTA
CVTRSV13 EQU   CVTOPTA
CVTRSV12 EQU   CVTOPTA
CVTNIP   EQU   CVTOPTA
CVTDDR   EQU   CVTOPTA
CVTAPR   EQU   CVTOPTA
CVTCCH   EQU   CVTOPTA
CVTSNCTR EQU   CVTMAP+180
CVTQMWR  EQU   CVTMAP+176
CVTQOCR  EQU   CVTMAP+172
CVT1EF00 EQU   CVTMAP+168
CVTMZ00  EQU   CVTMAP+164
CVTSV76Q EQU   CVTSV76C
CVTRSV11 EQU   CVTMAP+156
CVTMSER  EQU   CVTMAP+148
CVTRV516 EQU   CVTIERLC
CVTILCH  EQU   CVTMAP+140
CVT0DS   EQU   CVTMAP+136
CVTFBOSV EQU   CVTMAP+132
CVTNUCB  EQU   CVTMAP+128
CVTIXAVL EQU   CVTMAP+124
CVTSV76M EQU   CVTIOQET
CVTDCBA  EQU   CVTMAP+117
CVTMVS2  EQU   CVTDCB
CVT6DAT  EQU   CVTDCB
CVT4MPS  EQU   CVTDCB
CVTRSV09 EQU   CVTDCB
CVT4MS1  EQU   CVTDCB
CVT2SPS  EQU   CVTDCB
CVT1SSS  EQU   CVTDCB
CVTRSV08 EQU   CVTDCB
CVTSTB   EQU   CVTMAP+112
CVTQTD00 EQU   CVTMAP+108
CVTQTE00 EQU   CVTMAP+104
CVTSJQ   EQU   CVTMAP+96
CVTPBLDL EQU   CVTMAP+92
CVTTPC   EQU   CVTMAP+88
CVTSVDCB EQU   CVTMAP+84
CVTBRET  EQU   CVTMAP+82
CVTEXIT  EQU   CVTMAP+80
CVT0FN00 EQU   CVTMAP+76
CVTDARA  EQU   CVTDAR+1
CVTRSV07 EQU   CVTFLGS1
CVTRSV06 EQU   CVTFLGS1
CVTRSV05 EQU   CVTFLGS1
CVTRSV04 EQU   CVTFLGS1
CVTRSV03 EQU   CVTFLGS1
CVTRSV02 EQU   CVTFLGS1
CVTRSV01 EQU   CVTFLGS1
CVTDMPLK EQU   CVTFLGS1
CVTXITP  EQU   CVTMAP+68
CVTZDTAB EQU   CVTMAP+64
CVTMSLT  EQU   CVTMAP+60
CVTDATE  EQU   CVTMAP+56
CVTSYSAD EQU   CVTMAP+48
CVTXTLER EQU   CVTMAP+44
CVTILK2  EQU   CVTMAP+40
CVTILK1  EQU   CVTMAP+36
CVTPRLTV EQU   CVTMAP+32
CVTPCNVT EQU   CVTMAP+28
CVT0VL00 EQU   CVTMAP+24
CVTXAPG  EQU   CVTMAP+20
CVTBUF   EQU   CVTMAP+16
CVTJOB   EQU   CVTMAP+12
CVTLINK  EQU   CVTMAP+8
CVT0EF00 EQU   CVTMAP+4
CVTTCBP  EQU   CVTMAP
CVT      EQU   CVTMAP
@NM00081 EQU   PSA+3668
PSASTAK  EQU   PSA+3072
@NM00080 EQU   PSA+1048
PSAUSEND EQU   PSA+1048
PSARV062 EQU   PSA+1044
PSACDAL  EQU   PSA+1040
PSAWTCOD EQU   PSA+1036
PSAATCVT EQU   PSA+1032
PSAPCPSW EQU   PSA+1024
PSAPIR2  EQU   PSA+1020
PSARV059 EQU   PSA+1018
PSASVC13 EQU   PSA+1016
PSASFACC EQU   PSA+1008
PSASTOP  EQU   PSA+992
PSASTART EQU   PSA+976
PSARSPSW EQU   PSA+968
PSASRPSW EQU   PSA+960
PSARV045 EQU   PSA+892
PSARV044 EQU   PSA+888
PSARV043 EQU   PSA+884
PSARV042 EQU   PSA+880
PSARV041 EQU   PSA+876
PSARV040 EQU   PSA+872
PSARV025 EQU   PSA+868
PSADSSED EQU   PSA+868
PSADSSPR EQU   PSA+864
PSADSSFW EQU   PSA+860
PSADSS14 EQU   PSA+856
PSADSSPP EQU   PSA+848
PSADSSRP EQU   PSA+840
PSADSS05 EQU   PSADSSF4
PSADSS10 EQU   PSADSSF4
PSADSSVE EQU   PSADSSF4
PSADSSDE EQU   PSADSSF4
PSADSSC0 EQU   PSADSSF4
PSADSSIE EQU   PSADSSF4
PSADSS12 EQU   PSADSSF4
PSADSSRC EQU   PSADSSF4
PSARV057 EQU   PSADSSF3
PSARV056 EQU   PSADSSF3
PSARV055 EQU   PSADSSF3
PSADSSMC EQU   PSADSSF3
PSADSSRW EQU   PSADSSF3
PSADSSNM EQU   PSADSSF3
PSADSSES EQU   PSADSSF3
PSADSSGP EQU   PSADSSF3
PSADSSF2 EQU   PSADSSFL+1
PSADSSPI EQU   PSADSSF1
PSADSSOI EQU   PSADSSF1
PSADSSSP EQU   PSADSSF1
PSADSSTP EQU   PSADSSF1
PSADSSDW EQU   PSADSSF1
PSADSSDD EQU   PSADSSF1
PSADSSDM EQU   PSADSSF1
PSADSSMV EQU   PSADSSF1
PSADSSTS EQU   PSA+816
PSADSSWK EQU   PSA+812
PSADSSR3 EQU   PSA+808
PSADSSR2 EQU   PSA+804
PSADSSRS EQU   PSA+800
PSASTOR  EQU   PSA+796
PSACPUSA EQU   PSA+794
PSAVSTAP EQU   PSA+792
PSAWKVAP EQU   PSA+788
PSAWKRAP EQU   PSA+784
PSAMCHIC EQU   PSA+783
PSARV061 EQU   PSA+782
PSASYMSK EQU   PSA+781
PSAMCHFL EQU   PSA+780
PSACR0   EQU   PSA+776
PSAPSWSV EQU   PSA+768
PSACLHS  EQU   PSAHLHI
PSALKR15 EQU   PSALKSA+60
PSALKR14 EQU   PSALKSA+56
PSALKR13 EQU   PSALKSA+52
PSALKR12 EQU   PSALKSA+48
PSALKR11 EQU   PSALKSA+44
PSALKR10 EQU   PSALKSA+40
PSALKR9  EQU   PSALKSA+36
PSALKR8  EQU   PSALKSA+32
PSALKR7  EQU   PSALKSA+28
PSALKR6  EQU   PSALKSA+24
PSALKR5  EQU   PSALKSA+20
PSALKR4  EQU   PSALKSA+16
PSALKR3  EQU   PSALKSA+12
PSALKR2  EQU   PSALKSA+8
PSALKR1  EQU   PSALKSA+4
PSALKR0  EQU   PSALKSA
PSARV023 EQU   PSACLHT+52
PSALOCAL EQU   PSACLHT+48
PSACMSL  EQU   PSACLHT+44
PSAOPTL  EQU   PSACLHT+40
PSATPACL EQU   PSACLHT+36
PSATPDNL EQU   PSACLHT+32
PSATPNCL EQU   PSACLHT+28
PSAIOSLL EQU   PSACLHT+24
PSAIOSUL EQU   PSACLHT+20
PSAIOSCL EQU   PSACLHT+16
PSAIOSSL EQU   PSACLHT+12
PSASALCL EQU   PSACLHT+8
PSAASML  EQU   PSACLHT+4
PSADISPL EQU   PSACLHT
PSASRSA  EQU   PSA+636
PSARV050 EQU   PSA+634
PSADSSGO EQU   PSA+633
PSARECUR EQU   PSA+632
PSAHLHIS EQU   PSA+628
PSAIPCSA EQU   PSA+624
@NM00079 EQU   PSA+621
PSAIPCDM EQU   PSA+620
PSAIPCD  EQU   PSA+616
@NM00078 EQU   PSA+613
PSAIPCRM EQU   PSA+612
PSAIPCR  EQU   PSA+608
PSAMCHEX EQU   PSA+600
PSAMPSW  EQU   PSA+592
PSAEXPS2 EQU   PSA+584
PSAEXPS1 EQU   PSA+576
PSAPIREG EQU   PSA+572
PSARSREG EQU   PSA+568
PSAGPREG EQU   PSA+556
PSARV022 EQU   PSASUP4
PSARV021 EQU   PSASUP4
PSARV020 EQU   PSASUP4
PSARV019 EQU   PSASUP4
PSARV018 EQU   PSASUP4
PSARV017 EQU   PSASUP4
PSARV016 EQU   PSASUP4
PSARV015 EQU   PSASUP4
PSARV014 EQU   PSASUP3
PSAULCMS EQU   PSASUP3
PSARV012 EQU   PSASUP3
PSAESTA  EQU   PSASUP3
PSASPR   EQU   PSASUP3
PSAPSREG EQU   PSASUP3
PSAPI2   EQU   PSASUP3
PSAIOSUP EQU   PSASUP3
PSALCR   EQU   PSASUP2
PSARTM   EQU   PSASUP2
PSAACR   EQU   PSASUP2
PSAIPCE2 EQU   PSASUP2
PSAIPCES EQU   PSASUP2
PSAIPCEC EQU   PSASUP2
PSAGTF   EQU   PSASUP2
PSAIPCRI EQU   PSASUP2
PSATYPE6 EQU   PSASUP1
PSATCTL  EQU   PSASUP1
PSADISP  EQU   PSASUP1
PSALOCK  EQU   PSASUP1
PSAPI    EQU   PSASUP1
PSAEXT   EQU   PSASUP1
PSASVC   EQU   PSASUP1
PSAIO    EQU   PSASUP1
PSAANEW  EQU   PSA+544
PSATNEW  EQU   PSA+536
PSALCCAR EQU   PSA+532
PSAPCCAR EQU   PSA+524
PSAPCCAV EQU   PSA+520
PSACPULA EQU   PSA+518
PSACPUPA EQU   PSA+516
PSAPSA   EQU   PSA+512
FLCHDEND EQU   PSA+512
FLCCRSAV EQU   FLCMCLA+280
FLCGRSAV EQU   FLCMCLA+216
FLCFPSAV EQU   FLCMCLA+184
FLCFLA   EQU   FLCMCLA+88
FLCRGNCD EQU   FLCMCLA+84
FLCFSAA  EQU   FLCFSA+1
@NM00077 EQU   FLCFSA
@NM00076 EQU   FLCMCLA+72
FLCMCIC  EQU   FLCMCLA+64
@NM00075 EQU   FLCMCLA+20
FLCIOAA  EQU   FLCIOA+1
@NM00074 EQU   FLCIOA
@NM00073 EQU   FLCMCLA+15
@NM00072 EQU   FLCMCLA+14
@NM00071 EQU   FLCMCLA+12
FLCLCL   EQU   FLCMCLA+8
FLCIOELA EQU   FLCIOEL+1
@NM00070 EQU   FLCIOEL
FLCCHNID EQU   FLCMCLA
@NM00069 EQU   PSA+160
FLCMTRCD EQU   PSA+157
@NM00068 EQU   PSA+156
FLCPERA  EQU   FLCPER+1
@NM00067 EQU   FLCPER
@NM00066 EQU   PSA+151
FLCPERCD EQU   PSA+150
FLCMCNUM EQU   PSA+149
@NM00065 EQU   PSA+148
FLCTEAA  EQU   FLCTEA+1
@NM00064 EQU   FLCTEA
PSAPIPC  EQU   PSAPICOD
PSAPIMC  EQU   PSAPICOD
PSAPIPER EQU   PSAPICOD
PSARV049 EQU   FLCPICOD
FLCPILCB EQU   FLCPIILC
@NM00063 EQU   FLCPIILC
@NM00062 EQU   PSAEPPSW
FLCSVCN  EQU   PSAESPSW+2
FLCSILCB EQU   FLCSVILC
@NM00061 EQU   FLCSVILC
@NM00060 EQU   PSAESPSW
FLCEICOD EQU   PSAEEPSW+2
PSASPAD  EQU   PSAEEPSW
@NM00059 EQU   PSA+128
FLCINPSW EQU   PSA+120
FLCMNPSW EQU   PSA+112
FLCPNPSW EQU   PSA+104
FLCSNPSW EQU   PSA+96
FLCENPSW EQU   PSA+88
FLCTRACE EQU   PSA+84
FLCTIMER EQU   PSA+80
FLCCVT2  EQU   PSA+76
FLCCAW   EQU   PSA+72
FLCCSW   EQU   PSA+64
FLCIOPSW EQU   PSA+56
FLCMOPSW EQU   PSA+48
FLCPOPSW EQU   PSA+40
FLCSOPSW EQU   PSA+32
FLCEOPSW EQU   PSA+24
@NM00058 EQU   FLCICCW2+4
FLCCVT   EQU   FLCICCW2
FLCICCW1 EQU   FLCROPSW
FLCIPPSW EQU   FLCRNPSW
.@UNREFD ANOP                          END UNREFERENCED COMPONENTS
@RF00103 EQU   @RC00078
@RF00160 EQU   @RC00158
@RF00179 EQU   @RC00177
@ENDDATA EQU   *
         END   IEAVMFRR,(C'PLS2141',0701,78192)
