         TITLE ' -- IEAVPCB: PCB MANAGER --                            *
                        '
*                                                                  0076
IEAVPCB  CSECT
         USING  *,15
         MODID  BR=NO
IEAVPCB2 DS     0H
         ENTRY  IEAVPCB2
         STM     R0,R14,PVTWSA13(PVTPTR)     SAVE REGISTERS
BASE1    BALR    R9,R0             ESTABLISH ENTRY POINT VALUE
         USING   *,R9
*/********************************************************************/
*/* THIS IS THE START OF THE MAIN BODY OF CODE FOR THE PCB MANAGER.  */
*/* IF R1 IS ZERO, THE BUILD OPTION IS SELECTED AND CONTROL TRANSFERS*/
*/* TO THE BUILD ROUTINE. IF R1 IS NOT ZERO, THE ENTRY FLAG IS  SET  */
*/* AND THE PCBPTR LOADED FOR THE ENQ/DEQ OPERATION.                 */
*/********************************************************************/
*                                                                  0077
*MGRCODE:                                                          0077
*   IF R1^=0 THEN                   /* IF PARAMETER REG1 EQUALS 0, 0077
*                                      THE BUILD OPTION HAS BEEN   0077
*                                      CHOSEN                        */
MGRCODE  LTR   R1,R1                                               0077
         BZ    @RF00077                                            0077
*     DO;                                                          0078
*       RCAPTR=PVTPRCA;             /* LOAD POINTER REGISTER         */
         L     RCAPTR,PVTPRCA(,PVTPTR)                             0079
*       RCAPCB='1'B;                /* SET ENTRY POINT FLAG IN RCA   */
         OI    RCAPCB(RCAPTR),B'00010000'                          0080
*       PCBPTR=R1;                  /* ESTABLISH POINTER FOR PCB     */
         LR    PCBPTR,R1                                           0081
*                                                                  0082
*/********************************************************************/
*/* DEQUEUE OPERATION - THE FOLLOWING CODE IS EXECUTED WHEN IEAVPCB  */
*/* IS ENTERED WITH A REQUEST FOR A DEQUEUE OPERATION, THAT IS WHEN  */
*/* THE PCB POINTER IS NOT ZERO AND THE PCBCQN IS NOT EQUAL TO       */
*/* PCBDENQ. THE QUEUE ON WHICH THE DEQUEUE IS TO BE PERFORMED IS    */
*/* DETERMINED BY COMPARING THE PCBCQN TO QUEUE NUMBERS. ONLY ONE PCB*/
*/* MAY BE DEQUEUED PER REQUEST. AFTER THE PCB HAS BEEN DEQUEUED, THE*/
*/* PCBCQN IS SET TO INDICATE THAT IT IS DEQUEUED (EQUAL TO PCBDENQ).*/
*/********************************************************************/
*                                                                  0082
*       IF PCBCQN^=PCBDEQN THEN     /* IF PCBCQN IS NOT EQUAL TO   0082
*                                      PCBDENQ, DEQUEUE IS REQUIRED  */
         CLI   PCBCQN(PCBPTR),255                                  0082
         BE    @RF00082                                            0082
*         DO;                       /* NOT EQUAL, DEQUEUE IS REQUIRED*/
*           IF PCBCQN<LOCALCON THEN /* IF CQN IS LESS THAN LOCAL   0084
*                                      QUEUE NUMBERS, IT IS A GLOBAL
*                                      QUEUE                         */
         CLI   PCBCQN(PCBPTR),128                                  0084
         BNL   @RF00084                                            0084
*             QFSTPTR=ADDR(PVTPCBQS)+PCBCQN;/* GLOBAL QUEUE, SET UP
*                                      POINTER               @G33VPOD*/
         LA    QFSTPTR,PVTPCBQS(,PVTPTR)                           0085
         SLR   @12,@12                                             0085
         IC    @12,PCBCQN(,PCBPTR)                                 0085
         ALR   QFSTPTR,@12                                         0085
*           ELSE                    /* LOCAL QUEUE, SET UP POINTER   */
*             QFSTPTR=ADDR(RSMQS)+(PCBCQN-LOCALCON);               0086
         B     @RC00084                                            0086
@RF00084 LA    QFSTPTR,RSMQS(,RSMHDPTR)                            0086
         SLR   @12,@12                                             0086
         IC    @12,PCBCQN(,PCBPTR)                                 0086
         SL    @12,@CF01689                                        0086
         ALR   QFSTPTR,@12                                         0086
*           IF PCBBQPA=0 THEN       /* IF 0, THIS IS FIRST PCB ON  0087
*                                      QUEUE                         */
@RC00084 L     @12,PCBBQPA(,PCBPTR)                                0087
         LTR   @12,@12                                             0087
         BNZ   @RF00087                                            0087
*             QFIRST=PCBFQPA;       /* FIRST PCB, SO ADJUST THE QUEUE
*                                      FIRST POINTER                 */
         L     @12,PCBFQPA-1(,PCBPTR)                              0088
         LA    @12,0(,@12)                                         0088
         ST    @12,QFIRST(,QFSTPTR)                                0088
*           ELSE                    /* IF NOT 0, THIS IS NOT FIRST 0089
*                                      PCB                           */
*             PCBBQPA->PCBFQPA=PCBFQPA;/* ADJUST PREVIOUS POINTER    */
         B     @RC00087                                            0089
@RF00087 L     @12,PCBBQPA(,PCBPTR)                                0089
         MVC   PCBFQPA(3,@12),PCBFQPA(PCBPTR)                      0089
*           IF PCBFQPA=0 THEN       /* IF 0 THIS IS THE LAST PCB ON
*                                      QUEUE                         */
@RC00087 L     @12,PCBFQPA-1(,PCBPTR)                              0090
         LA    @12,0(,@12)                                         0090
         LTR   @12,@12                                             0090
         BNZ   @RF00090                                            0090
*             QLAST=PCBBQPA;        /* LAST PCB, SO ADJUST LAST    0091
*                                      POINTER                       */
         L     @12,PCBBQPA(,PCBPTR)                                0091
         ST    @12,QLAST(,QFSTPTR)                                 0091
*           ELSE                    /* IF NOT 0, THIS PCB IS NOT LAST*/
*             PCBFQPA->PCBBQPA=PCBBQPA;/* NOT LAST PCB, SO ADJUST  0092
*                                      BACK POINTER IN NEXT PCB      */
         B     @RC00090                                            0092
@RF00090 L     @12,PCBFQPA-1(,PCBPTR)                              0092
         L     @08,PCBBQPA(,PCBPTR)                                0092
         ST    @08,PCBBQPA(,@12)                                   0092
*           PCBCQN=PCBDEQN;         /* SET PCBCQN TO INDICATE NOT ON
*                                      A QUEUE                       */
@RC00090 MVI   PCBCQN(PCBPTR),X'FF'                                0093
*           PCBFQPA=0;              /* ZERO THE FORWARD POINTER      */
         SLR   @12,@12                                             0094
         STCM  @12,7,PCBFQPA(PCBPTR)                               0094
*           PCBBQPA=0;              /* ZERO THE BACKWARD POINTER     */
         ST    @12,PCBBQPA(,PCBPTR)                                0095
*         END;                                                     0096
*                                                                  0097
*/********************************************************************/
*/* ENQUEUE OPERATION - THE FOLLOWING CODE IS EXECUTED WHEN IEAVPCB  */
*/* IS ENTERED WITH A ENQUEUE REQUEST, THAT IS THE PCBPTR IS NOT ZERO*/
*/* AND MGRTQN IS NOT EQUAL TO PCBDENQ. THE QUEUE ON WHICH THE PCB IS*/
*/* TO BE ENQUEUED IS DETERMINED BY COMPARING THE MGRTQN TO THE QUEUE*/
*/* NUMBERS. IF MORE THAN ONE PCB IS TO BE ENQUEUED, IT IS ASSUMED   */
*/* THAT THE CALLER HAS MADE SURE THAT THE CHAIN IS NOT BROKEN, AND  */
*/* AND THAT THE END IS MARKED BY A ZERO FORWARD POINTER. THE PCBCQN */
*/* IS SET TO THE VALUE OF THE QUEUE NUMBER WHEN IT IS ENQUEUED, AND */
*/* IF THE ENQUEUE IS TO THE FREE QUEUE THE FREE QUEUE DEPTH IS      */
*/* ADJUSTED IN THE PVT.                                             */
*/********************************************************************/
*                                                                  0097
*       IF MGRTQN^=PCBDEQN THEN     /* IF NOT EQUAL, ENQUEUE       0097
*                                      REQUESTED                     */
@RF00082 CLI   MGRTQN(PVTPTR),255                                  0097
         BE    @RF00097                                            0097
*         DO;                       /* NOT EQUAL, EXECUTE ENQUEUE  0098
*                                      CODE                          */
*           IF MGRTQN<LOCALCON THEN /* IF LESS THEN LOCAL QUEUE    0099
*                                      NUMBER IT IS A GLOBAL QUEUE   */
         CLI   MGRTQN(PVTPTR),128                                  0099
         BNL   @RF00099                                            0099
*             QFSTPTR=ADDR(PVTPCBQS)+MGRTQN;/* LOAD ADDRESS OF QUEUE
*                                      ANCHOR OF GLOBAL QUEUE      0100
*                                                            @G33VPOD*/
         LA    QFSTPTR,PVTPCBQS(,PVTPTR)                           0100
         SLR   @12,@12                                             0100
         IC    @12,MGRTQN(,PVTPTR)                                 0100
         ALR   QFSTPTR,@12                                         0100
*           ELSE                    /* NOT LESS MEANS LOCAL QUEUE    */
*             QFSTPTR=ADDR(RSMQS)+(MGRTQN-LOCALCON);/* LOAD ADDRESS
*                                      OF QUEUE ANCHOR OF LOCAL QUE  */
         B     @RC00099                                            0101
@RF00099 LA    QFSTPTR,RSMQS(,RSMHDPTR)                            0101
         SLR   @12,@12                                             0101
         IC    @12,MGRTQN(,PVTPTR)                                 0101
         SL    @12,@CF01689                                        0101
         ALR   QFSTPTR,@12                                         0101
*           IF QLAST=0 THEN         /* IF ZERO THE QUEUE IS EMPTY    */
@RC00099 SLR   @12,@12                                             0102
         C     @12,QLAST(,QFSTPTR)                                 0102
         BNE   @RF00102                                            0102
*             DO;                   /* EMPTY QUEUE                   */
*               QFIRST=PCBPTR;      /* FILL ANCHOR FIRST POINTER     */
         ST    PCBPTR,QFIRST(,QFSTPTR)                             0104
*               PCBBQPA=0;          /* SET PCB BACKWARD PTR TO 0     */
         ST    @12,PCBBQPA(,PCBPTR)                                0105
*             END;                                                 0106
*           ELSE                    /* IF NOT 0, QUEUE IS NOT EMPTY  */
*             DO;                                                  0107
         B     @RC00102                                            0107
@RF00102 DS    0H                                                  0108
*               QLAST->PCBFQPA=PCBPTR;/* NOT EMPTY SO SET FORWARD  0108
*                                      POINTER OF LAST CURRENT PCB TO
*                                      POINT TO PCB BEING ADDED      */
         L     @12,QLAST(,QFSTPTR)                                 0108
         STCM  PCBPTR,7,PCBFQPA(@12)                               0108
*               PCBBQPA=QLAST;      /* SET NEW PCB BACKWARD POINTER
*                                      TO POINT TO PRECEEDING PCB    */
         ST    @12,PCBBQPA(,PCBPTR)                                0109
*             END;                                                 0110
*MGRENQLP:                                                         0111
*           PCBCQN=MGRTQN;          /* SET CQN TO CURRENT QUEUE    0111
*                                      NUMBER THAT PCB IS TAGGED TO  */
@RC00102 DS    0H                                                  0111
MGRENQLP IC    @12,MGRTQN(,PVTPTR)                                 0111
         STC   @12,PCBCQN(,PCBPTR)                                 0111
*           IF MGRTQN=PCBFREQN THEN /* IF EQUAL, PCB HAS BEEN PUT ON
*                                      THE FREE QUEUE                */
         CLI   MGRTQN(PVTPTR),16                                   0112
         BNE   @RF00112                                            0112
*             DO;                                                  0113
*CHAINFRQ:                          /* BEGINNING OF LOOP PLACING   0114
*                                      PCB'S ON THE FREE QUEUE.    0114
*                                                            @Z40WPYD*/
*                                                                  0114
*               /*****************************************************/
*               /*                                                   */
*               /* THE FOLLOWING SETS THE TRACE CSECT ID, IN THE PCB,*/
*               /* OF THE MODULE WHICH IS FREEING THE PCB. WHEN THE  */
*               /* TRACE IS ACTIVE, THE BRANCH INSTRUCTION MUST BE   */
*               /* NOPED.                                    @Z40WPYD*/
*               /*                                                   */
*               /*****************************************************/
*                                                                  0114
*TRACEZP3:                                                         0114
*               GENERATE;                                          0114
CHAINFRQ DS    0H                                                  0114
TRACEZP3 DS    0H                                                  0114
         B   TRACEZP3+10  NOPED WHEN TRACE ACTIVE
         MVC 65(1,PCBPTR),RCACSECT(RCAPTR)     MOVE IN CSECT ID OF
*                                              MODULE FREEING PCB
*               PVTPCBCT=PVTPCBCT+1;/* UPDATE FREE QUEUE COUNT       */
         LA    @12,1                                               0115
         AH    @12,PVTPCBCT(,PVTPTR)                               0115
         STH   @12,PVTPCBCT(,PVTPTR)                               0115
*               IF PCBFQPA=0 THEN   /* IF 0 THIS IS LAST PCB ON CHAIN*/
         L     @12,PCBFQPA-1(,PCBPTR)                              0116
         LA    @12,0(,@12)                                         0116
         LTR   @12,@12                                             0116
         BNZ   @RF00116                                            0116
*                 QLAST=PCBPTR;     /* SET LAST POINTER IN ANCHOR TO
*                                      POINT TO LAST PCB             */
         ST    PCBPTR,QLAST(,QFSTPTR)                              0117
*               ELSE                /* IF NOT 0, THIS IS NOT THE LAST
*                                      PCB ON CHAIN BEING ENQUEUED   */
*                 DO;                                              0118
         B     @RC00116                                            0118
@RF00116 DS    0H                                                  0119
*                   PCBPTR=PCBFQPA; /* UPDATE PCBPTR TO NEXT ON CHAIN
*                                                            @Z40WPYD*/
         L     @12,PCBFQPA-1(,PCBPTR)                              0119
         LA    @12,0(,@12)                                         0119
         LR    PCBPTR,@12                                          0119
*                   PCBCQN=MGRTQN;  /* SET CQN TO CURRENT QUEUE, FREE
*                                      QUEUE                 @Z40WPYD*/
         IC    @12,MGRTQN(,PVTPTR)                                 0120
         STC   @12,PCBCQN(,PCBPTR)                                 0120
*                   GOTO CHAINFRQ;  /* LOOP TO PROCESS EACH PCB ON 0121
*                                      THE FREE QUEUE        @Z40WPYD*/
         B     CHAINFRQ                                            0121
*                 END;                                             0122
*             END;                                                 0123
*           ELSE                                                   0124
*             DO;                                                  0124
         B     @RC00112                                            0124
@RF00112 DS    0H                                                  0125
*               IF PCBFQPA=0 THEN                                  0125
         L     @12,PCBFQPA-1(,PCBPTR)                              0125
         LA    @12,0(,@12)                                         0125
         LTR   @12,@12                                             0125
         BNZ   @RF00125                                            0125
*                 QLAST=PCBPTR;     /* IF ZERO, THIS IS LAST PCB ON
*                                      CHAIN                 @Z40WPYD*/
         ST    PCBPTR,QLAST(,QFSTPTR)                              0126
*               ELSE                                               0127
*                 DO;                                              0127
         B     @RC00125                                            0127
@RF00125 DS    0H                                                  0128
*                   PCBPTR=PCBFQPA; /* UPDATE PCBPTR TO NEXT ON CHAIN*/
         L     @12,PCBFQPA-1(,PCBPTR)                              0128
         LA    @12,0(,@12)                                         0128
         LR    PCBPTR,@12                                          0128
*                   GOTO MGRENQLP;  /* LOOP TO PROCESS EACH PCB ON 0129
*                                      THE CHAIN BEING ENQUEUED      */
         B     MGRENQLP                                            0129
*                 END;                                             0130
*             END;                                                 0131
@RC00125 DS    0H                                                  0132
*         END;                                                     0132
@RC00112 DS    0H                                                  0133
*                                                                  0133
*/********************************************************************/
*/* CODE COMMON TO ENQUEUE/DEQUEUE - IF EITHER THE ENQUEUE OPTION OR */
*/* THE DEQUEUE OPTION WERE REQUESTED THIS CODE WILL BE EXECUTED.    */
*/* IT MERELY SETS THE RETURN CODE TO ZERO AND THEN PASSES CONTROL   */
*/* TO THE RETURN PREPERATION ROUTINE VIA A BRANCH.                  */
*/********************************************************************/
*                                                                  0133
*       RETCODR=0;                  /* RETURN CODE IS ZERO AT THIS 0133
*                                      POINT IF ANY COMBINATION OF 0133
*                                      ENQ/DEQ FUNCTIONS WAS       0133
*                                      PERFORMED                     */
@RF00097 SLR   RETCODR,RETCODR                                     0133
*       GOTO MGRRTNCD;              /* AFTER ENQUEUE AND DEQUEUE   0134
*                                      DECISIONS ARE MADE, GO TO CODE
*                                      TO RESTORE REGISTERS AND    0134
*                                      RETURN TO CALLER              */
         B     MGRRTNCD                                            0134
*     END;                                                         0135
*                                                                  0136
*/********************************************************************/
*/* BUILD ROUTINE - THIS CODE MAKES UP THE BUILD ROUTINE. CONTROL IS */
*/* PASSED TO THIS POINT IF UPON ENTRY TO IEAVPCB THE PCBPTR IS ZERO */
*/* SPECIFYING THE BUILD OPTION. AN IMMEDIATE CHECK IS MADE TO SEE   */
*/* IF THE BUILD REQUEST IS FOR ZERO (0) PCBS. IF IT IS A ZERO       */
*/* REQUEST, CONTROL IMMEDIATELY TRANSFERS TO CODE FOR THAT PURPOSE. */
*/* IF IT IS NOT A ZERO REQUEST, AND THE NUMBER OF PCBS ON THE FREE  */
*/* QUEUE IS SUFFICIENT TO SATISFY THE REQUEST, THE CHAIN IS BUILT.  */
*/* IF ENOUGH PCBS ARE NOT AVAILABLE, IEAVPCB2 WILL BE CALLED TO     */
*/* CREATE MORE PCBS BEFORE THIS BUILD TAKES PLACE.                  */
*/*   THE PCBPTR AND MGRWD IN THE SAVE AREA ARE SET TO POINT TO THE  */
*/* FIRST PCB ON THE CHAIN BEING BUILT. SETTING THE MGRWD PROVIDES   */
*/* THE CALLER WITH THE CHAIN POINTER UPON RETURN. THE PCBCQN OF ALL */
*/* PCBS ON THE CHAIN ARE SET TO INDICATE DEQUEUED, AND THE PCBS ARE */
*/* CLEARED WITH THE EXCEPTION OF THE FORWARD AND BACKWARD POINTERS. */
*/* THE RETURN CODE IS SET TO ZERO. AFTER THE CHAIN HAS BEEN BUILT   */
*/* THE FREE QUEUE IS CHECKED FOR MINIMUM DEPTH LEVEL. IF PCBS ARE   */
*/* REQUIRED, THE REPLENISH ROUTINE IS CALLED IF POSSIBLE, AND THE   */
*/* RETURN PREPERATION ROUTINE IS GIVEN CONTROL VIA A BRANCH.        */
*/********************************************************************/
*                                                                  0136
*MGRBLD:                                                           0136
*   IF MGRQTY^=0 THEN               /* IF THIS IS NOT A ZERO BUILD 0136
*                                      REQ                           */
@RF00077 DS    0H                                                  0136
MGRBLD   L     @12,MGRQTY(,PVTPTR)                                 0136
         LTR   @12,@12                                             0136
         BZ    @RF00136                                            0136
*     DO;                                                          0137
*       RCAPTR=PVTPRCA;             /* LOAD POINTER REGISTER         */
         L     RCAPTR,PVTPRCA(,PVTPTR)                             0138
*       RCAPCB='1'B;                /* SET THE ENTERED FLAG          */
         OI    RCAPCB(RCAPTR),B'00010000'                          0139
*       IF PVTPCBCT^<MGRQTY THEN    /* IF FREE QUEUE HAS ENOUGH PCBS
*                                      BUILD THE CHAIN               */
         CH    @12,PVTPCBCT(,PVTPTR)                               0140
         BH    @RF00140                                            0140
*         DO;                                                      0141
*MGRBLD2:                                                          0142
*           PCBPTR=PVTFPCBF;        /* SET PCBPTR TO PCB ADDRESS     */
MGRBLD2  L     PCBPTR,PVTFPCBF(,PVTPTR)                            0142
*           MGRWD=PCBPTR;           /* PCB ADDRESS WILL BE PASSED TO
*                                      THE CALLER AS A PARAMETER. IT
*                                      MUST POINT TO THE PCB CHAIN   */
         ST    PCBPTR,MGRWD(,PVTPTR)                               0143
*           TEMPCTR=MGRQTY;         /* INITIALIZE COUNTER TO NUMBER
*                                      OF PCB'S TO BE PUT ON THE   0144
*                                      CHAIN                         */
         L     TEMPCTR,MGRQTY(,PVTPTR)                             0144
*MGRCHBLD:                                                         0145
*           PCBCQN=PCBDEQN;         /* PCB IS DEQUEUED NOW SO THE CQN
*                                      CODE MUST INDICATE SUCH       */
*                                                                  0145
MGRCHBLD MVI   PCBCQN(PCBPTR),X'FF'                                0145
*           /*********************************************************/
*           /*                                                       */
*           /* WHEN TRACE IS ACTIVE, THE INSTRUCTION ZEROING THE PCB */
*           /* AFTER THE QUEUE POINTERS MUST BE ZAPPED TO CLEAR NEW  */
*           /* PCB SIZE                                      @Z40WPYD*/
*           /*                                                       */
*           /*********************************************************/
*                                                                  0146
*TRACEZP4:                                                         0146
*           MGRCLEAR(9:LENGTH(PCB))=''B;/* ZERO PCB AFTER QUEUE    0146
*                                      POINTERS                      */
TRACEZP4 XC    MGRCLEAR+8(56,PCBPTR),MGRCLEAR+8(PCBPTR)            0146
*TRACEZP2:                                                         0147
*           GENERATE;                                              0147
TRACEZP2 DS    0H                                                  0147
         B   TRACEZP2+10                    NOPED WHEN TRACE ACTIVE
         MVC 64(1,PCBPTR),RCACSECT(RCAPTR)  MOVE IN CSECT ID OF MODULE
*                                           REQUESTING PCB BUILD
*           TEMPCTR=TEMPCTR-1;      /* PCB HAS BEEN ADDED TO THE   0148
*                                      CHAIN                         */
         BCTR  TEMPCTR,0                                           0148
*           IF TEMPCTR^=0 THEN      /* IF NOT ZERO, CHAIN IS       0149
*                                      INCOMPLETE                    */
         LTR   TEMPCTR,TEMPCTR                                     0149
         BZ    @RF00149                                            0149
*             DO;                                                  0150
*               PCBPTR=PCBFQPA;     /* POINT TO NEXT PCB ON CHAIN    */
         L     @12,PCBFQPA-1(,PCBPTR)                              0151
         LA    @12,0(,@12)                                         0151
         LR    PCBPTR,@12                                          0151
*               GOTO MGRCHBLD;      /* BUILD ANOTHER PCB ON THE CHAIN*/
         B     MGRCHBLD                                            0152
*             END;                                                 0153
*           PVTPCBCT=PVTPCBCT-MGRQTY;/* TAKE NUMBER OF PCBS REMOVED
*                                      FROM THE FREE QUEUE OFF IT'S
*                                      COUNT                         */
@RF00149 LH    @12,PVTPCBCT(,PVTPTR)                               0154
         SL    @12,MGRQTY(,PVTPTR)                                 0154
         STH   @12,PVTPCBCT(,PVTPTR)                               0154
*           PVTFPCBF=PCBFQPA;       /* SET FREE QUEUE FIRST POINTER
*                                      TO POINT TO THE NEW FIRST PCB */
         L     @12,PCBFQPA-1(,PCBPTR)                              0155
         LA    @12,0(,@12)                                         0155
         ST    @12,PVTFPCBF(,PVTPTR)                               0155
*           IF PVTFPCBF=0 THEN      /* IF FREE QUEUE INDICATES EMPTY */
         SLR   @08,@08                                             0156
         CR    @12,@08                                             0156
         BNE   @RF00156                                            0156
*             PVTFPCBL=0;           /* EMPTY QUEUE SO LAST POINTER =
*                                      0                             */
         ST    @08,PVTFPCBL(,PVTPTR)                               0157
*           ELSE                    /* IF FREE QUEUE NOT EMPTY       */
*             PCBFQPA->PCBBQPA=0;   /* QUEUE IS NOT EMPTY SO FIRST 0158
*                                      PCB ON CHAIN MUST HAVE A ZERO
*                                      BACK PTR                      */
         B     @RC00156                                            0158
@RF00156 L     @12,PCBFQPA-1(,PCBPTR)                              0158
         SLR   @08,@08                                             0158
         ST    @08,PCBBQPA(,@12)                                   0158
*           PCBFQPA=0;              /* SET FORWARD POINTER OF LAST 0159
*                                      PCB ON CHAIN TO ZERO          */
@RC00156 SLR   @12,@12                                             0159
         STCM  @12,7,PCBFQPA(PCBPTR)                               0159
*           RETCODR=0;              /* SUCCESSFUL OPERATION CODE     */
         SLR   RETCODR,RETCODR                                     0160
*           IF PVTPCBCT^<PVTPCBLO THEN/* IF REMAINING PCB COUNT IS 0161
*                                      ABOVE MINIMUM, RETURN TO    0161
*                                      CALLER                        */
         LH    @12,PVTPCBCT(,PVTPTR)                               0161
         CH    @12,PVTPCBLO(,PVTPTR)                               0161
         BNL   @RT00161                                            0161
*             GOTO MGRRTNCD;        /* GO TO RETURN ROUTINE          */
*           IF PVTBGMS='0'B THEN    /* IF GETMAIN IS NOT INHIBITED   */
         TM    PVTBGMS(PVTPTR),B'01000000'                         0163
         BNZ   @RF00163                                            0163
*             DO;                                                  0164
*               QTYRQDR=PVTPCBNO;   /* LOAD THE NUMBER OF PCBS TO BE
*                                      AQUIRED                       */
         SLR   QTYRQDR,QTYRQDR                                     0165
         IC    QTYRQDR,PVTPCBNO(,PVTPTR)                           0165
*               CALL IEAVPCB3;      /* CALL INTERNAL PROC TO GET   0166
*                                      PCB'S                         */
         BAL   @14,IEAVPCB3                                        0166
*               RETCODR=0;          /* CALLERS REQUEST WAS SATISFIED,
*                                      SO FORCE RETURN CODE TO ZERO
*                                      REGARDLESS OF OUTCOME OF    0167
*                                      REPLENISH                     */
         SLR   RETCODR,RETCODR                                     0167
*             END;                                                 0168
*           GOTO MGRRTNCD;          /* GO TO RETURN ROUTINE          */
         B     MGRRTNCD                                            0169
*         END;                                                     0170
*                                                                  0171
*/********************************************************************/
*/* THIS CODE WILL BE EXECUTED WHEN THE BUILD OPTION IS SELECTED AND */
*/* THE FREE QUEUE DOES NOT HAVE ENOUGH PCB'S ON THE CHAIN. IF       */
*/* GETMAIN IS NOT INHIBITED, THE NUMBER OF PCBS NEEDED TO FILL THE  */
*/* REQUEST IS ADDED TO THE NUMBER OF PCBS NORMALLY ACQUIRED DURING  */
*/* A REPLENISH, AND THE REPLENISH ROUTINE IS CALLED. IF GETMAIN IS  */
*/* INHIBITED A RETURN CODE OF FOUR IS SET.                          */
*/********************************************************************/
*                                                                  0171
*       ELSE                                                       0171
*         IF PVTBGMS^='1'B THEN     /* GET MORE SPACE IF GETMAINS ARE
*                                      NOT INHIBITED                 */
@RF00140 TM    PVTBGMS(PVTPTR),B'01000000'                         0171
         BO    @RF00171                                            0171
*           DO;                                                    0172
*             QTYRQDR=PVTPCBNO+(MGRQTY-PVTPCBCT);/* SET NUMBER OF  0173
*                                      PCBS TO BE ACQUIRED           */
         L     QTYRQDR,MGRQTY(,PVTPTR)                             0173
         SH    QTYRQDR,PVTPCBCT(,PVTPTR)                           0173
         SLR   @12,@12                                             0173
         IC    @12,PVTPCBNO(,PVTPTR)                               0173
         ALR   QTYRQDR,@12                                         0173
*             CALL IEAVPCB3;        /* CALL REPLENISH ROUTINE        */
         BAL   @14,IEAVPCB3                                        0174
*             IF RETCODR=0 THEN     /* IF REPLENISH WAS SUCCESSFUL   */
         LTR   RETCODR,RETCODR                                     0175
         BZ    @RT00175                                            0175
*               GOTO MGRBLD2;       /* SHOULD HAVE ENOUGH PCB'S NOW,
*                                      SO GO BACK TO BUILD ROUTINE   */
*             GOTO MGRRTNCD;        /* PREPARE TO RETURN TO CALLER   */
         B     MGRRTNCD                                            0177
*           END;                                                   0178
*       RETCODR=4;                  /* RETURN CODE 4, GM INHIBITED   */
@RF00171 LA    RETCODR,4                                           0179
*       GOTO MGRRTNCD;              /* PREPARE TO RETURN TO CALLER   */
         B     MGRRTNCD                                            0180
*     END;                                                         0181
*                                                                  0182
*/********************************************************************/
*/* THIS CODE IS EXECUTED ONLY ON A BUILD REQUEST FOR ZERO PCBS. A   */
*/* CHECK IS MADE TO SEE IF IT IS A REQUEST FROM NIP. IF SO, THE     */
*/* CALLS TO IEAVPCB2 AND IEAVREP3 ARE MADE,                         */
*/* OTHERWISE A RETURN CODE OF FOUR IS                               */
*/* SET. IF IEAVPCB2 RETURNS A CODE 0F 4,                            */
*/* THE PCBS FOR NIP FLAG IS NOT SET AND THE RETURN CODE             */
*/*  IS PASSED TO THE CALLER OF THE PCB MANAGER                      */
*/* IF THE RETURN CODE IS ZERO THE PVTPCBLT FLAG IS SET.             */
*/********************************************************************/
*                                                                  0182
*   IF PVTPCBLT='0'B THEN           /* IF THIS IS A NIP BUILD REQ    */
@RF00136 TM    PVTPCBLT(PVTPTR),B'00010000'                        0182
         BNZ   @RF00182                                            0182
*     DO;                                                          0183
*       QTYRQDR=PVTPCBS;            /* LOAD NIP QUANTITY INTO      0184
*                                      REGISTER                      */
         SLR   QTYRQDR,QTYRQDR                                     0184
         IC    QTYRQDR,PVTPCBS(,PVTPTR)                            0184
*       CALL IEAVPCB3;              /* CALL PCB REPLENISH ROUTINE    */
         BAL   @14,IEAVPCB3                                        0185
*       IF RETCODR=0 THEN           /* IF THE BUILD WAS SUCCESSFUL   */
         LTR   RETCODR,RETCODR                                     0186
         BNZ   @RF00186                                            0186
*         DO;                                                      0187
*           CALL IEAVREP3;          /* CALL SRB REPLENISH ROUTINE  0188
*                                                            @Z30GNYC*/
         L     @15,@CA01698                                        0188
         BALR  @14,@15                                             0188
*           IF RETCODR=0 THEN       /* WAS REPLENISH SUCCESFUL     0189
*                                                            @Z30GNYC*/
         LTR   RETCODR,RETCODR                                     0189
         BNZ   @RF00189                                            0189
*             DO;                   /* YES                   @Z30GNYC*/
*               PVTPCBLT='1'B;      /* TURN ON PCBS FOR NIP  @Z30GNYC*/
         OI    PVTPCBLT(PVTPTR),B'00010000'                        0191
*               GOTO RTNNIP;        /* DO NOT ALLOW RCA ACCESSING  0192
*                                                            @Z30GNYC*/
         B     RTNNIP                                              0192
*             END;                                                 0193
*           ELSE                                                   0194
*             ;                     /* REPLENISH UNSUCCESSFUL      0194
*                                                            @Z30GNYC*/
@RF00189 DS    0H                                                  0195
*         END;                                                     0195
*     END;                                                         0196
@RF00186 DS    0H                                                  0197
*   RETCODR=4;                      /* IF NOT A REQUEST FROM NIP,  0197
*                                      SIGNAL AN ERROR               */
@RF00182 LA    RETCODR,4                                           0197
*   GOTO RTNNIP;                    /* NO RCA POINTER, NO FLAGS SET  */
         B     RTNNIP                                              0198
*/********************************************************************/
*/* RETURN PREPERATION - THIS IS MERELY A COMMON RETURN ROUTINE FOR  */
*/* ALL OF THE ROUTINES OF IEAVPCB. NIP REQUESTS DO NOT RESET RCA.   */
*/********************************************************************/
*                                                                  0199
*MGRRTNCD:                                                         0199
*   RCAPCB='0'B;                    /* TURN OFF IN USE FLAG          */
MGRRTNCD NI    RCAPCB(RCAPTR),B'11101111'                          0199
*RTNNIP:                            /* LABEL FOR NIP TIME EXIT       */
*   GENERATE;                                                      0200
RTNNIP   DS    0H                                                  0200
        LM    R0,R14,PVTWSA13(PVTPTR)
        BR    R14                  RETURN TO CALLER
*                                                                  0201
*/********************************************************************/
*/* REPLENISH CODE PROCEDURE--                                       */
*/* THIS CODE CALCULATES THE AMOUNT OF CORE NEEDED TO BUILD PCBS     */
*/* THIS VALUE IS THEN USED TO PRIME THE GETMAIN MACRO. WHEN         */
*/* THE MACRO RETURNS THE CONDITION CODE IS CHECKED TO SEE IF THE    */
*/* OPERATION WAS SUCCESSFUL. IF UNSUCCESSFUL, THE CODE WILL TRY TO  */
*/* ACQUIRE A LESSER NUMBER OF PCBS. IF UNABLE TO ASK FOR LESS, OR   */
*/* IF GETMAIN IS STILL UNSUCCESSFUL, RETURN IS MADE TO THE CALLER   */
*/* WITH A RETURN CODE OF FOUR. IF THE GETMAIN WAS SUCCESSFUL,       */
*/* THE CORE IS FORMATTED AND THE PCBS CHAINED TO THE FREE QUEUE.    */
*/********************************************************************/
*                                                                  0201
*IEAVPCB3:                                                         0201
*   PROC OPTIONS(NOSAVE,NOSAVEAREA,RETREG);                        0201
         B     @PB00002                                            0201
IEAVPCB3 DS    0H                                                  0202
*   MGRRRTN=R14;                    /* BACK UP THE RETURN REGISTER   */
         ST    R14,MGRRRTN(,PVTPTR)                                0202
*   RFY                                                            0203
*    (R14) UNRSTD;                                                 0203
*   FGMFAILF='0'B;                  /* INIT GETMAIN FAIL FLAG TO OFF
*                                                            @YM08254*/
*                                                                  0204
         NI    FGMFAILF(PVTPTR),B'01111111'                        0204
*   /*****************************************************************/
*   /*                                                               */
*   /* WHEN TRACE IS ACTIVE, THE CONSTANT LABELLED PCBTRACE MUST BE  */
*   /* ZAPPED TO THE LARGER PCB SIZE                         @Z40WPYD*/
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0205
*REPLCALC:                                                         0205
*   GENERATE;                                                      0205
REPLCALC DS    0H                                                  0205
         LR    CORELNR,QTYRQDR    TOTAL AMOUNT OF CORE EQUALS THE
         MH    CORELNR,PCBTRACE   QUANTITY DESIRED TIMES PCB LENGTH
*   R5=PVTPTR;                      /* SAVE PVTPTR ACROSS MACRO      */
         LR    R5,PVTPTR                                           0206
*/********************************************************************/
*/* THE GETMAIN MACRO REFERANCES CORELENR AS REG 0 AND RETURNS THE   */
*/* STARTING ADDRESS OF THE CORE BLOCK IN REG 1(BEGINPTR). REG 1     */
*/* IS SUBSEQUENTLY USED BY BLDCPOOL AND MUST NOT BE CHANGED PRIOR   */
*/* TO THAT MACRO.                                                   */
*/********************************************************************/
*                                                                  0207
*   PVTRSMGM='1'B;                  /* INDICATE RSM GETMAIN TO PREF
*                                                            @ZA16816*/
         OI    PVTRSMGM(PVTPTR),B'10000000'                        0207
*   RFY                                                            0208
*     BEGINPTR RSTD;                                               0208
*   GENERATE NODEFS REFS(R0) SETS(R1,R3,R4,R15) NOFLOWS;           0209
SELF     GETMAIN RC,LV=(0),BNDRY=DBLWD,BRANCH=(YES,GLOBAL),SP=245,    **
               RELATED=(RSM,IEAVPCB(SELF)'CORE IS FREED ON NEXT IPL')
*   PVTPTR=R5;                      /* RESTORE PVTPTR AFTER MACRO    */
         LR    PVTPTR,R5                                           0210
*   PVTRSMGM='0'B;                  /* RESET RSM GETMAIN INDICATOR 0211
*                                                            @ZA16816*/
         NI    PVTRSMGM(PVTPTR),B'01111111'                        0211
*   PVTPRCA=RCAPTR;                 /* RESTORE PVTPRCA AFTER MACRO --
*                                      NOTE -- WHEN THIS MODULE IS 0212
*                                      CALLED BY NIP, THE VALUE    0212
*                                      STORED IN THIS FIELD IS     0212
*                                      IRRELEVANT, AS THE RCA HAS NOT
*                                      YET BEEN ESTABLISHED          */
         ST    RCAPTR,PVTPRCA(,PVTPTR)                             0212
*   IF R15^=0 THEN                  /* IF RETURN CODE FROM GETMAIN IS
*                                      NOT ZERO                      */
         LTR   R15,R15                                             0213
         BZ    @RF00213                                            0213
*     DO;                                                          0214
*       IF PVTPCBLT='0'B|FGMFAILF='1'B|QTYRQDR^>PVTPCBNO THEN/* IF A
*                                      NIP REQUEST OR THIS IS THE  0215
*                                      SECOND GETMAIN TO FAIL OR THE
*                                      QUANTITY REQUESTED IS NOT   0215
*                                      GREATER THEN THE NORMAL     0215
*                                      REQUEST NUMBER, GIVE AN ERROR
*                                      RETURN                @YM08254*/
         TM    PVTPCBLT(PVTPTR),B'00010000'                        0215
         BZ    @RT00215                                            0215
         TM    FGMFAILF(PVTPTR),B'10000000'                        0215
         BO    @RT00215                                            0215
         SLR   @14,@14                                             0215
         IC    @14,PVTPCBNO(,PVTPTR)                               0215
         CR    QTYRQDR,@14                                         0215
         BH    @RF00215                                            0215
@RT00215 DS    0H                                                  0216
*         DO;                                                      0216
*           RFY                                                    0217
*            (R14) RSTD;                                           0217
*           RETCODR=4;              /* SET THE RETURN CODE           */
         LA    RETCODR,4                                           0218
*           R14=MGRRRTN;            /* RESTORE RETURN REGISTER       */
         L     R14,MGRRRTN(,PVTPTR)                                0219
*           RETURN;                 /* RETURN TO CALLER              */
@EL00002 DS    0H                                                  0220
@EF00002 DS    0H                                                  0220
@ER00002 BR    @14                                                 0220
*           RFY                                                    0221
*            (R14) UNRSTD;                                         0221
*         END;                                                     0222
*       QTYRQDR=QTYRQDR-PVTPCBNO;   /* IF THIS WAS A REQUEST FOR MORE
*                                      THAN THE NORMAL NUMBER OF   0223
*                                      PCBS, SET QUANTITY TO THAT  0223
*                                      ACTUALLY NEEDED TO SATISFY THE
*                                      CURRENT REQUEST               */
@RF00215 SLR   @14,@14                                             0223
         IC    @14,PVTPCBNO(,PVTPTR)                               0223
         SLR   QTYRQDR,@14                                         0223
*       FGMFAILF='1'B;              /* THE FIRST GETMAIN FAILED, SET
*                                      A FLAG TO PREVENT A THIRD TRY
*                                                            @YM08254*/
         OI    FGMFAILF(PVTPTR),B'10000000'                        0224
*       GOTO REPLCALC;              /* RECALCULATE CORE AMOUNT, AND
*                                      TRY THE GETMAIN AGAIN         */
         B     REPLCALC                                            0225
*     END;                                                         0226
*                                                                  0227
*/********************************************************************/
*/* PCB BUILD ROUTINE- THIS CODE ZERO'S, FORMATS, AND CHAINS NEW PCBS*/
*/* TOGETHER. WHEN THE ENTIRE BLOCK OF CORE HAS BEEN FORMATTED,      */
*/* CONTROL FALLS THROUGH TO THE SUCCEEDING CODE.                    */
*/********************************************************************/
*                                                                  0227
*   /*****************************************************************/
*   /*                                                               */
*   /* WHEN TRACE IS ACTIVE, THE CONSTANT LABELLED PCBTRACE MUST BE  */
*   /* ZAPPED TO THE NEW PCB SIZE                            @Z40WPYD*/
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0227
*   GENERATE;                                                      0227
@RF00213 DS    0H                                                  0227
         LR    CORELNR,QTYRQDR    TOTAL AMOUNT OF CORE EQUALS THE
         MH    CORELNR,PCBTRACE   QUANTITY DESIRED TIMES PCB LENGTH
*   PCBPTR=BEGINPTR;                /* POINT TO NEW PCB BEING BUILT  */
*                                                                  0228
         LR    PCBPTR,BEGINPTR                                     0228
*   /*****************************************************************/
*   /*                                                               */
*   /* WHEN TRACE IS ACTIVE, THE INSTRUCTION CLEARING THE PCB MUST BE*/
*   /* ZAPPED TO HANDLE THE NEW PCB SIZE                     @Z40WPYD*/
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0229
*TRACEZP5:                                                         0229
*   ;                                                              0229
TRACEZP5 DS    0H                                                  0230
*REPLBLD:                                                          0230
*   PCB=PCB&&PCB;                   /* CLEAR THE NEW PCB             */
REPLBLD  XC    PCB(64,PCBPTR),PCB(PCBPTR)                          0230
*   PCBCQN=PCBFREQN;                /* MARK PCB ON THE FREE QUEUE    */
*                                                                  0231
         MVI   PCBCQN(PCBPTR),X'10'                                0231
*   /*****************************************************************/
*   /*                                                               */
*   /* WHEN TRACE IS ACTIVE, THE LA INSTRUCTION OF THE PCB SIZE MUST */
*   /* BE ZAPPED TO X'41E00048'                              @Z40WPYD*/
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0232
*TRACEZP6:                                                         0232
*   PCBFQPA=PCBPTR+LENGTH(PCB);     /* POINT TO NEXT PCB TO BE     0232
*                                      CHAINED                       */
TRACEZP6 LA    @14,64                                              0232
         LR    @12,PCBPTR                                          0232
         ALR   @12,@14                                             0232
         STCM  @12,7,PCBFQPA(PCBPTR)                               0232
*   PCBBQPA=PCBPTR-LENGTH(PCB);     /* POINT BACK TO PREVIOUS PCB    */
         LR    @08,PCBPTR                                          0233
         SLR   @08,@14                                             0233
         ST    @08,PCBBQPA(,PCBPTR)                                0233
*   IF PCBFQPA^=BEGINPTR+CORELNR THEN/* IF THIS IS NOT THE LAST PCB
*                                      TO BE BUILT                   */
         LR    @08,BEGINPTR                                        0234
         ALR   @08,CORELNR                                         0234
         CR    @12,@08                                             0234
         BE    @RF00234                                            0234
*     DO;                                                          0235
*       PCBPTR=PCBPTR+LENGTH(PCB);  /* UPDATE PCB POINTER TO NEXT PCB
*                                      ON CHAIN                      */
         ALR   PCBPTR,@14                                          0236
*       GOTO REPLBLD;               /* LOOP UNTIL ALL CORE IS      0237
*                                      FORMATTED                     */
         B     REPLBLD                                             0237
*     END;                                                         0238
*                                                                  0239
*/********************************************************************/
*/* THIS CODE ADJUSTS THE FORWARD AND BACKWARD POINTERS IN THE FREE  */
*/* QUEUE ANCHOR AS REQUIRED, TO ADD THE NEW PCB CHAIN TO THE QUEUE. */
*/* THE FREE QUEUE COUNT IS UPDATED AND RETURN IS MADE TO THE CALLER.*/
*/********************************************************************/
*                                                                  0239
*   PCBFQPA=0;                      /* LAST NEW PCB FORWARD POINTER =
*                                      0                             */
@RF00234 SLR   @14,@14                                             0239
         STCM  @14,7,PCBFQPA(PCBPTR)                               0239
*   IF PVTFPCBF=0 THEN              /* IF FREE QUEUE IS EMPTY        */
         C     @14,PVTFPCBF(,PVTPTR)                               0240
         BNE   @RF00240                                            0240
*     DO;                                                          0241
*       PVTFPCBF=BEGINPTR;          /* FREE QUEUE FIRST POINTER    0242
*                                      POINTS TO NEW PCB CHAIN       */
         ST    BEGINPTR,PVTFPCBF(,PVTPTR)                          0242
*       BEGINPTR->PCBBQPA=0;        /* FIRST NEW PCB BACKWARD PTR  0243
*                                      POINTS TO 0                   */
         ST    @14,PCBBQPA(,BEGINPTR)                              0243
*     END;                                                         0244
*   ELSE                            /* IF FREE QUEUE IS NOT EMPTY    */
*     DO;                                                          0245
         B     @RC00240                                            0245
@RF00240 DS    0H                                                  0246
*       PVTFPCBL->PCBFQPA=BEGINPTR; /* CHAIN NEW PCBS TO OLD CHAIN   */
         L     @14,PVTFPCBL(,PVTPTR)                               0246
         STCM  BEGINPTR,7,PCBFQPA(@14)                             0246
*       BEGINPTR->PCBBQPA=PVTFPCBL; /* BACK CHAIN THE FIRST NEW PCB  */
         ST    @14,PCBBQPA(,BEGINPTR)                              0247
*     END;                                                         0248
*   PVTFPCBL=PCBPTR;                /* SET FREE QUEUE LAST POINTER   */
@RC00240 ST    PCBPTR,PVTFPCBL(,PVTPTR)                            0249
*   PVTPCBCT=PVTPCBCT+QTYRQDR;      /* UPDATE FREE QUEUE COUNT       */
         LR    @14,QTYRQDR                                         0250
         AH    @14,PVTPCBCT(,PVTPTR)                               0250
         STH   @14,PVTPCBCT(,PVTPTR)                               0250
*   RFY                                                            0251
*    (R14) RSTD;                                                   0251
*   R14=MGRRRTN;                    /* RESTORE RETURN REGISTER       */
         L     R14,MGRRRTN(,PVTPTR)                                0252
*   RETCODR=0;                                                     0253
         SLR   RETCODR,RETCODR                                     0253
*   END IEAVPCB3;                                                  0254
         B     @EL00002                                            0254
@PB00002 DS    0H                                                  0254
*                                                                  0255
*/********************************************************************/
*/*                                                                  */
*/* SUBROUTINE - IEAVREP1 (ENTRY IEAVREP1, IEAVREP2 AND IEAVREP3)    */
*/*                                                                  */
*/* FUNCTION   - REPLENISH THE SRB POOL USED BY RSM ROUTINES. WHEN   */
*/*              ENTERED AT IEAVREP1, THIS ROUTINE WILL ALSO SCAN    */
*/*              THE RSMHDR'S FOR EACH MEMORY TO DETERMINE IF        */
*/*              IEAVIOCP SHOULD BE SCHEDULE. IF RSMCPNU OR RSMCPNC  */
*/*              IS SET TO 1, IEAVIOCP IS SCHEDULED TO THE MEMORY    */
*/*              REPRESENTED BY THE RSMHDR.                          */
*/*              SEE MODULE PROLOGUE FOR A DESCRIPTION OF EACH       */
*/*              ENTRY POINT                                         */
*/*                                                                  */
*/* INPUT      - SEE MODULE PROLOGUE                                 */
*/*                                                                  */
*/* OUTPUT     - SEE MODULE PROLOGUE                                 */
*/*                                                                  */
*/********************************************************************/
*                                                                  0255
*   GEN DEFS(IEAVREP1,BASE2) SETS(R9,R8);                          0255
        ENTRY IEAVREP1                                      @Z30GNYC
IEAVREP1 DS   0H                                            @Z30GNYC
BASE2    BALR R9,0                                          @Z30GNYC
        LA    R8,BASE2-BASE1     GET AMOUNT TO ADJUST BY    @Z30GNYC
        SR    R9,R8              ADJUST BASE REG            @Z30GNYC
*   PVTPTR=CVTPVTP;                 /* SET PVT BASE          @Z30GNYC*/
         L     @12,CVTPTR                                          0256
         L     PVTPTR,CVTPVTP(,@12)                                0256
*   RESPECIFY                                                      0257
*    (R8) RESTRICTED;                                              0257
*   R8=R14;                         /* SAVE RETURN ADDRESS   @Z30GNYC*/
*                                                                  0258
         LR    R8,R14                                              0258
*   /*****************************************************************/
*   /*                                                               */
*   /* SET FRR                                               @Z30GNYC*/
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0259
*   GENERATE NODEFS REFS(R3,PVTPRCV,PSACSTK,FRRSCURR,FRRSLAST,FRRSELEN,
*       FRRSENTR,FRRSFRRA,FRRSPARM) SETS(R4,R5,RCAPTR,R15) NOFLOWS;
*                                                                  0259
         SETFRR  A,FRRAD=PVTPRCV(R3),PARMAD=(RCAPTR),WRKREGS=(R4,R5), **
               RELATED=(RSM,IEAVREP1(EXIT))
*   /*****************************************************************/
*   /*                                                               */
*   /* OBTAIN SALLOC LOCK                                    @Z30GNYC*/
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0260
*GETLOCK:                                                          0260
*   GENERATE NODEFS REFS(PSALITA,FLC) SETS(R11,R12,R13,R14) NOFLOWS;
GETLOCK  DS    0H                                                  0260
         SETLOCK OBTAIN,TYPE=SALLOC,MODE=UNCOND,                      **
               RELATED=(RSM,IEAVREP1(FREELOCK))
*   PVTPRCA=RCAPTR;                 /* RECOVERY COMM. AREA   @Z30GNYC*/
         ST    RCAPTR,PVTPRCA(,PVTPTR)                             0261
*   RCAREP1='1'B;                   /* IEAVREP1 ENTERED      @Z30GNYC*/
         OI    RCAREP1(RCAPTR),B'00000001'                         0262
*   RCASAL='1'B;                    /* SALLOC LOCK OBTAINED  @Z30GNYC*/
         OI    RCASAL(RCAPTR),B'10000000'                          0263
*   RCACSECT=RCACREP;               /* CSECT IS IEAVPCB      @Z30GNYC*/
         MVI   RCACSECT(RCAPTR),X'0C'                              0264
*   PVTSRBIU='0'B;                  /* THIS SRB NO LONGER IN USE   0265
*                                                            @Z30GNYC*/
         NI    PVTSRBIU(PVTPTR),B'11011111'                        0265
*   SCANHEAD='1'B;                  /* RSM HEADERS IN ALL MEMORIES 0266
*                                      WILL BE SEARCHED TO DETERMINE
*                                      IF IEAVIOCP SHOULD BE       0266
*                                      SCHEDULED             @Z30GNYC*/
         OI    SCANHEAD(PVTPTR),B'10000000'                        0266
*   QTYRQDR=PVTSRBNO;               /* INDICATE THE NUMBER OF SRBS TO
*                                      BE INCLUDED IN POOL   @Z30GNYC*/
         SLR   QTYRQDR,QTYRQDR                                     0267
         IC    QTYRQDR,PVTSRBNO(,PVTPTR)                           0267
*   GOTO GETSPACE;                  /* GET STORAGE FOR SRB'S @Z30GNYC*/
         B     GETSPACE                                            0268
*   GEN DEFS(IEAVREP2,BASE3) SETS(R9,R8,PVTWSA17) REFS(R0,R14);    0269
*                                                                  0269
        ENTRY IEAVREP2                                      @Z30GNYC
IEAVREP2 DS   0H                                            @Z30GNYC
        STM   R0,R14,PVTWSA17(R3)   SAVE CALLERS REG        @Z30GNYC
BASE3   BALR  R9,0                                          @Z30GNYC
        LA    R8,BASE3-BASE1     GET AMOUNT TO ADJUST BY    @Z30GNYC
        SR    R9,R8              ADJUST BASE REG            @Z30GNYC
*   /*****************************************************************/
*   /*                                                               */
*   /* THIS IS THE BRANCH ENTRY FOR IEAVEQR AND IEAVRCF. THESE       */
*   /* ROUTINES MUST ENTER WITH SALLOC HELD                          */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0270
*   RCAPTR=PVTPRCA;                 /* SET BASE FOR RCA      @Z30GNYC*/
         L     RCAPTR,PVTPRCA(,PVTPTR)                             0270
*   QTYRQDR=PVTSRBNO;               /* NUMBER OF SRB'S TO BE INCLUDED
*                                      IN POOL               @Z30GNYC*/
         SLR   QTYRQDR,QTYRQDR                                     0271
         IC    QTYRQDR,PVTSRBNO(,PVTPTR)                           0271
*   SCANHEAD='0'B;                  /* RSMHDR'S WILL NOT BE SCANNED
*                                                            @Z30GNYC*/
         NI    SCANHEAD(PVTPTR),B'01111111'                        0272
*   GOTO GETSPACE;                  /* GET STORAGE FOR SRB'S @Z30GNYC*/
         B     GETSPACE                                            0273
*IEAVREP3:                                                         0274
*   ENTRY;                          /*                       @Z30GNYC*/
*   GEN;                                                           0275
*                                                                  0275
          ENTRY IEAVREP3                                    @Z30GNYC
IEAVREP3  DS    0H                                          @Z30GNYC
*   /*****************************************************************/
*   /*                                                               */
*   /* ENTERED HERE FROM IEAVPCB ON NIP CALL FOR PRIMARY ALLOCATION  */
*   /* OF SRB POOL                                                   */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0276
*   STM(R0,R14,PVTWSA17);           /* SAVE CALLERS REG      @Z30GNYC*/
         STM   R0,R14,PVTWSA17(PVTPTR)                             0276
*   QTYRQDR=PVTSRBS;                /* NUMBER OF SRB'S TO BE INCLUDED
*                                      IN SRB POOL           @Z30GNYC*/
         SLR   QTYRQDR,QTYRQDR                                     0277
         IC    QTYRQDR,PVTSRBS(,PVTPTR)                            0277
*   RCAPTR=PVTPRCA;                 /* SET BASE FOR RCA      @Z30GNYC*/
         L     RCAPTR,PVTPRCA(,PVTPTR)                             0278
*   SCANHEAD='0'B;                  /* RSMHDR'S ARE NOT TO BE      0279
*                                      SEARCHED              @Z30GNYC*/
         NI    SCANHEAD(PVTPTR),B'01111111'                        0279
*GETSPACE:                                                         0280
*   ERRLOOP='0'B;                   /* ERROR LOOP CONTROL SWITCH - 0280
*                                      WILL ONLY PERMIT ONE FAILURE
*                                      OF GETMAIN OF SRB'S   @Z30GNYC*/
GETSPACE NI    ERRLOOP(PVTPTR),B'10111111'                         0280
*   RESPECIFY                                                      0281
*    (R0,                                                          0281
*     R1,                                                          0281
*     R15,                                                         0281
*     R11) RESTRICTED;                                             0281
*RETRY:                                                            0282
*   R0=(QTYRQDR*(LENGTH(SRB)+4)+LENGTH(CPAB));/* COMPUTE SIZE OF   0282
*                                      GETMAIN               @Z30GNYC*/
RETRY    LR    R0,QTYRQDR                                          0282
         MH    R0,@CH00983                                         0282
         AL    R0,@CF00107                                         0282
*   R11=PVTPTR;                     /* SAVE PVTPTR           @Z30GNYC*/
         LR    R11,PVTPTR                                          0283
*   PVTRSMGM='1'B;                  /* INDICATE RSM GETMAIN TO PREF
*                                                            @ZA16816*/
*                                                                  0284
         OI    PVTRSMGM(PVTPTR),B'10000000'                        0284
*   /*****************************************************************/
*   /*                                                               */
*   /* GETMAIN STORAGE FOR SRB POOL                                  */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0285
*   GENERATE NODEFS REFS(R0,R4,R7) SETS(R1,R3,R14,R15) NOFLOWS;    0285
         GETMAIN RC,LV=(0),BRANCH=(YES,GLOBAL),SP=245,BNDRY=DBLWD,    **
               RELATED=(RSM,IEAVREP1(NOTFREED))
*   PVTPTR=R11;                     /* RESTORE PVTPTR AFTER GETMAIN
*                                                            @Z30GNYC*/
         LR    PVTPTR,R11                                          0286
*   PVTRSMGM='0'B;                  /* RESET RSM GETMAIN INDICATOR 0287
*                                                            @ZA16816*/
         NI    PVTRSMGM(PVTPTR),B'01111111'                        0287
*   RESPECIFY                                                      0288
*    (R11) UNRESTRICTED;                                           0288
*   PVTPRCA=RCAPTR;                 /* RESTORE RCAPTR AFTER GETMAIN
*                                                            @Z30GNYC*/
         ST    RCAPTR,PVTPRCA(,PVTPTR)                             0289
*   IF R15^=0 THEN                  /* WAS GETMAIN UNSUCCESSFUL    0290
*                                                            @Z30GNYC*/
         LTR   R15,R15                                             0290
         BZ    @RF00290                                            0290
*     DO;                           /* YES                   @Z30GNYC*/
*       IF ERRLOOP='0'B THEN        /* IS THIS THE FIRST TIME      0292
*                                                            @Z30GNYC*/
         TM    ERRLOOP(PVTPTR),B'01000000'                         0292
         BNZ   @RF00292                                            0292
*         DO;                       /* YES - TRY AGAIN       @Z30GNYC*/
*           ERRLOOP='1'B;           /* INDICATE SECOND PASS  @Z30GNYC*/
         OI    ERRLOOP(PVTPTR),B'01000000'                         0294
*           QTYRQDR=2;              /* DECREASE SIZE OF GETMAIN TO 2
*                                      SRB'S                 @Z30GNYC*/
         LA    QTYRQDR,2                                           0295
*           GOTO RETRY;             /* RETRY GETMAIN         @Z30GNYC*/
         B     RETRY                                               0296
*         END;                      /* END OF FIRST ERROR PASS     0297
*                                                            @Z30GNYC*/
*       ELSE                        /* NO - SECOND ATTEMPT FAILED  0298
*                                                            @Z30GNYC*/
*         DO;                       /* PROCESS ERROR         @Z30GNYC*/
@RF00292 DS    0H                                                  0299
*           R15=4;                  /* INDICATE GETMAIN FAILED     0299
*                                                            @Z30GNYC*/
         LA    R15,4                                               0299
*           GOTO CHKSCAN;           /* RETURN TO CALLER      @Z30GNYC*/
         B     CHKSCAN                                             0300
*         END;                      /* END SECOND ERROR      @Z30GNYC*/
*     END;                          /* END OF ERROR PROCESSING     0302
*                                                            @Z30GNYC*/
*   ELSE                                                           0303
*     ;                             /* GETMAIN SUCCESSFUL    @Z30GNYC*/
@RF00290 DS    0H                                                  0304
*   R0=PVTSRBID;                    /* SET CELLPOOL ID FOR BLDCPOOL
*                                                            @Z30GNYC*/
         L     R0,PVTSRBID(,PVTPTR)                                0304
*   R5=LENGTH(SRB);                 /* SET LENGTH FOR BLDCPOOL     0305
*                                                            @Z30GNYC*/
         LA    R5,44                                               0305
*   RESPECIFY                                                      0306
*    (R13) RESTRICTED;                                             0306
*   R13=ADDR(PVTSAVE);              /* SET SAVE AREA FOR BLDCPOOL  0307
*                                                            @Z30GNYC*/
         LA    R13,PVTSAVE(,PVTPTR)                                0307
*/* BUILD THE SRB POOL FROM ADDRESS RETURNED BY GETMAIN(R1)  @Z30GNYC*/
*                                                                  0308
*   GENERATE REFS(R0,R1,R5,QTYRQDR);                               0308
         BLDCPOOL CPID=(0),CSIZE=(5),CPADDR=(1),CELLCNT=(QTYRQDR),    **
               SP=245,BRANCH=YES,RELATED=(RSM,IEAVREP1(OWN))
*   RESPECIFY                                                      0309
*    (R0,                                                          0309
*     R4,                                                          0309
*     R5,                                                          0309
*     R13) UNRESTRICTED;                                           0309
*   IF R15^=0 THEN                  /* WAS BLDCPOOL SUCCESSFUL     0310
*                                                            @Z30GNYC*/
         LTR   R15,R15                                             0310
         BZ    @RF00310                                            0310
*     DO;                           /* NO - PROCESS AS ERROR @Z30GNYC*/
*       IF PVTPCBLT='1'B THEN       /* IF NOT NIP CALL,      @Z30GNYC*/
         TM    PVTPCBLT(PVTPTR),B'00010000'                        0312
         BNO   @RF00312                                            0312
*         RCARCRD='1'B;             /* CAN INIT REASON CODE. @Z30GNYC*/
         MVI   RCARCRD(RCAPTR),B'10000000'                         0313
*       ELSE                                                       0314
*         ;                         /* ON NIP CALL RCAPTR IS NOT   0314
*                                      INITIALIZED.          @Z30GNYC*/
@RF00312 DS    0H                                                  0315
*       GENERATE CODE SETS(R1);                                    0315
*                                /* ISSUE ABEND             @Z30GNYC*/
      ABEND X'C0D',,,SYSTEM         RECORD THE ERROR        @Z30GNYC
*       R15=4;                      /* SET ERROR RETURN CODE @Z30GNYC*/
         LA    R15,4                                               0316
*     END;                          /* END OF ERROR PROCESSING     0317
*                                                            @Z30GNYC*/
*   ELSE                                                           0318
*     ;                             /* SUCCESSFUL            @Z30GNYC*/
@RF00310 DS    0H                                                  0319
*CHKSCAN:                                                          0319
*   IF SCANHEAD='1'B THEN           /* SHOULD RSMHDR'S BE SCANNED  0319
*                                                            @Z30GNYC*/
CHKSCAN  TM    SCANHEAD(PVTPTR),B'10000000'                        0319
         BNO   @RF00319                                            0319
*     DO;                           /* YES                   @Z30GNYC*/
*                                                                  0320
*       /*************************************************************/
*       /*                                                           */
*       /* STARTING WITH MASTERS ASCB, SCAN THE RSMHDR'S IN EACH     */
*       /* MEMORY TO DETERMINE IF IEAVIOCP SHOULD BE SCHEDULED       */
*       /* (RSMCPNU OR RSMCPNC EQ 1)                         @Z30GNYC*/
*       /* OBTAIN DISPATCHER LOCK TO SCAN ASCB'S             @Z30GNYC*/
*       /*                                                           */
*       /*************************************************************/
*                                                                  0321
*GETD:                                                             0321
*       GENERATE NODEFS REFS(PSALITA,FLC) SETS(R11,R12,R13,R14) NOFLOWS
*           ;                                                      0321
GETD     DS    0H                                                  0321
         SETLOCK OBTAIN,TYPE=DISP,MODE=UNCOND,                        **
               RELATED=(RSM,IEAVPCB(RELD))
*       RCADISP='1'B;               /* NOTE DISP LOCK GOTTEN @ZA28519*/
         OI    RCADISP(RCAPTR),B'00000010'                         0322
*       RESPECIFY                                                  0323
*        (ASCBPTR) RESTRICTED;                                     0323
*       ASCBPTR=CVTASVT->ASVTENTY(1);/* SET PTR TO MASTER    @Z30GNYC*/
         L     @11,CVTPTR                                          0324
         L     @11,CVTASVT(,@11)                                   0324
         L     ASCBPTR,ASVTENTY(,@11)                              0324
*CHKBITS:                                                          0325
*       RSMHDPTR=ASCBRSM;           /* SET PTR TO RSMHDR     @Z30GNYC*/
CHKBITS  L     RSMHDPTR,ASCBRSM(,ASCBPTR)                          0325
*       RESPECIFY                                                  0326
*        (R0,                                                      0326
*         R13) RESTRICTED;                                         0326
*       DO WHILE RSMCPNU='1'B|RSMCPNC='1'B|RSMGFADD='1'B;          0327
*                                                                  0327
         B     @DE00327                                            0327
@DL00327 DS    0H                                                  0328
*         /***********************************************************/
*         /*                                                         */
*         /* CHECK IF IEAVIOCP OR IEAVGFAD SHOULD BE SCHEDULED       */
*         /*                                                         */
*         /***********************************************************/
*                                                                  0328
*         R0=PVTSRBID;              /* RESET SRB IDENTIFIER  @Z30GNYC*/
         L     R0,PVTSRBID(,PVTPTR)                                0328
*         R13=ADDR(PVTSAVE);        /* SET SAVEAREA FOR GETCLL     0329
*                                                            @Z30GNYC*/
         LA    R13,PVTSAVE(,PVTPTR)                                0329
*         GEN;                                                     0330
*                                /*  GET AN SRB             @Z30GNYC*/
        GETCELL CPID=(0),BRANCH=YES,SAVE=YES
*         RESPECIFY                                                0331
*          (R0,                                                    0331
*           R13) UNRESTRICTED;                                     0331
*         RESPECIFY                                                0332
*          (SRBPTR,                                                0332
*           R11) RESTRICTED;                                       0332
*         R11=0;                    /* INDICATE SRBPARM VALUE      0333
*                                                            @Z30GNYC*/
         SLR   R11,R11                                             0333
*         IF R15^=0 THEN            /* IF UNSUCCESSFUL THEN  @Z30GNYC*/
         LTR   R15,R15                                             0334
         BZ    @RF00334                                            0334
*           DO;                     /* SET UP TO REPLENISH SRB POOL
*                                                            @Z30GNYC*/
*             SRBPTR=ADDR(PVTRSRB); /* SET PTR TO SRB TO RESCHED.  0336
*                                      REP1                  @Z30GNYC*/
         LA    SRBPTR,PVTRSRB(,PVTPTR)                             0336
*             PVTSRBIU='1'B;        /* SRB IN USE            @Z30GNYC*/
         OI    PVTSRBIU(PVTPTR),B'00100000'                        0337
*             ASCBPTR=CVTASVT->ASVTENTY(1);/* GET PTR TO MASTER'S  0338
*                                      MEMORY                @Z40WPYD*/
         L     @10,CVTPTR                                          0338
         L     @10,CVTASVT(,@10)                                   0338
         L     ASCBPTR,ASVTENTY(,@10)                              0338
*             RESPECIFY                                            0339
*              (R0) RESTRICTED;                                    0339
*             R0=ADDR(IEAVREP1);    /* SRB E.P.              @Z30GNYC*/
         LA    R0,IEAVREP1                                         0340
*             CALL SCHEDSRB;        /* SCHEDULE THE SRB      @Z30GNYC*/
         BAL   @14,SCHEDSRB                                        0341
*             RESPECIFY                                            0342
*              (R0) UNRESTRICTED;                                  0342
*             GOTO NORMEXIT;        /* RETURN                @Z30GNYC*/
         B     NORMEXIT                                            0343
*           END;                    /* END OF UNSUCCESSFUL GETCELL 0344
*                                      PROCESSING            @Z30GNYC*/
*         ELSE                      /* GETCELL SUCCESSFUL    @Z30GNYC*/
*           DO;                     /* DETERMINE IF IEAVGFAD SHOULD
*                                      BE SCHEDULED TO RUN IN THIS 0345
*                                      MEMORY                @Z40WPYD*/
@RF00334 DS    0H                                                  0346
*             IF RSMGFADD='1'B THEN                                0346
         TM    RSMGFADD(RSMHDPTR),B'00000100'                      0346
         BNO   @RF00346                                            0346
*               DO;                                                0347
*                 RSMGFADD='0'B;    /* CLEAR THE FLAG BIT    @Z40WPYD*/
*                 RSMGFAD='1'B;     /* FLAG THE RSMHD AS HAVING HAD
*                                      GFA DEFER SCHEDULED FOR THIS
*                                      ADDRESS SPACE         @Z40WPYD*/
         OI    RSMGFAD(RSMHDPTR),B'00100000'                       0349
         NI    RSMGFADD(RSMHDPTR),B'11111011'                      0349
*                 R0=PVTPGFAD;      /* IEAVGFAD'S EP FOR SRB @Z40WPYD*/
         L     R0,PVTPGFAD(,PVTPTR)                                0350
*                 CALL SCHEDSRB;    /* INIT AND SCHED SRB    @Z40WPYD*/
         BAL   @14,SCHEDSRB                                        0351
*               END;                                               0352
*             ELSE                                                 0353
*               DO;                 /* DETERMINE IF IEAVIOCP SHOULD
*                                      BE SCHEDULED TO REQUEST THE 0353
*                                      LOCAL LOCK            @ZM43117*/
         B     @RC00346                                            0353
@RF00346 DS    0H                                                  0354
*                 IF RSMCPNC='1'B THEN/* NOT LOCAL LOCK REQUEST    0354
*                                                            @Z40WPYD*/
         TM    RSMCPNC(RSMHDPTR),B'00001000'                       0354
         BNO   @RF00354                                            0354
*                   DO;             /* YES                   @Z30GNYC*/
*                     RSMCPNC='0'B; /* CLEAR THE FLAG BIT    @Z30GNYC*/
*                     RSMIOCPC='1'B;/* INDICATE IEAVIOCP SCHEDULED TO
*                                      NOT REQUEST LOCAL LOCK      0357
*                                                            @Z40WPYD*/
         OI    RSMIOCPC(RSMHDPTR),B'01000000'                      0357
         NI    RSMCPNC(RSMHDPTR),B'11110111'                       0357
*                   END;            /* END OF NOT LOCAL LOCK REQUEST
*                                      PROCESS               @Z30GNYC*/
*                 ELSE              /* LOCAL LOCK REQUEST    @Z40WPYD*/
*                   DO;             /* IEAVIOCP RUNS WITH LOCAL LOCK
*                                                            @Z40WPYD*/
         B     @RC00354                                            0359
@RF00354 DS    0H                                                  0360
*                     R11=1;        /* VALUE FOR SRBPARM - LOCAL LOCK
*                                      SHOULD BE OBTAINED    @Z40WPYD*/
         LA    R11,1                                               0360
*                     RSMCPNU='0'B; /* CLEAR THE FLAG BIT    @Z40WPYD*/
*                     RSMIOCPU='1'B;/* INDICATE IEAVIOCP SCHEDULED TO
*                                      RUN WITH LOCAL LOCK   @Z40WPYD*/
         OI    RSMIOCPU(RSMHDPTR),B'10000000'                      0362
         NI    RSMCPNU(RSMHDPTR),B'11101111'                       0362
*                   END;            /* END LOCAL LOCK REQUEST      0363
*                                                            @Z40WPYD*/
*                 RESPECIFY                                        0364
*                  (R0) RESTRICTED;                                0364
@RC00354 DS    0H                                                  0365
*                 R0=PVTPIOCP;      /* IEAVIOCP'S EP FOR SRB @Z30GNYC*/
         L     R0,PVTPIOCP(,PVTPTR)                                0365
*                 CALL SCHEDSRB;    /* INIT AND SCHED THE SRB      0366
*                                                            @Z30GNYC*/
         BAL   @14,SCHEDSRB                                        0366
*               END;                /* END OF IEAVIOCP SCHEDULING  0367
*                                      PROCESS               @ZM43117*/
*             RESPECIFY                                            0368
*               R0 UNRESTRICTED;                                   0368
@RC00346 DS    0H                                                  0369
*           END;                    /* END OF SUCCESSFUL GETCELL   0369
*                                      PROCESSING            @Z30GNYC*/
*       END;                        /* END OF CHKBITS PROCESS      0370
*                                                            @Z30GNYC*/
@DE00327 TM    RSMCPNU(RSMHDPTR),B'00011100'                       0370
         BNZ   @DL00327                                            0370
*NXTMEMRY:                                                         0371
*       ASCBPTR=ASCBFWDP;           /* GET PTR TO NEXT MEMORY      0371
*                                                            @Z30GNYC*/
NXTMEMRY L     ASCBPTR,ASCBFWDP(,ASCBPTR)                          0371
*       IF ASCBPTR^=0 THEN          /* IS THERE ANOTHER MEMORY     0372
*                                                            @Z30GNYC*/
         SLR   @10,@10                                             0372
         CR    ASCBPTR,@10                                         0372
         BE    @RF00372                                            0372
*         DO;                       /* YES                   @Z30GNYC*/
*           IF ASCBRSM^=0 THEN      /* DETERMINE IF THERE EXITS AN 0374
*                                      RSMHD'R. THERE MAY NOT BE BE
*                                      ONE IF MEMORY IS TERMINATING.
*                                                            @Z30GNYC*/
         C     @10,ASCBRSM(,ASCBPTR)                               0374
         BNE   @RT00374                                            0374
*             GOTO CHKBITS;         /* YES - DETERMINE IF IEAVIOCP 0375
*                                      SHOULD BE SCHEDULED   @Z30GNYC*/
*           ELSE                    /* MEMORY DOES NOT EXIST @Z30GNYC*/
*             GOTO NXTMEMRY;        /* PROCESS NEXT ADDRESS SPACE  0376
*                                                            @Z30GNYC*/
         B     NXTMEMRY                                            0376
*         END;                      /* END OF ADDRESS SPACE        0377
*                                      PROCESSING            @Z30GNYC*/
*       ELSE                                                       0378
*         ;                         /* ALL ADDRESS SPACES PROCESSED
*                                                            @Z30GNYC*/
@RF00372 DS    0H                                                  0379
*     END;                          /* END OF SCANHEAD TEST  @Z30GNYC*/
*   RESPECIFY                                                      0380
*    (SRBPTR,                                                      0380
*     R11,                                                         0380
*     ASCBPTR) UNRESTRICTED;                                       0380
@RF00319 DS    0H                                                  0381
*NORMEXIT:                                                         0381
*   IF SCANHEAD='1'B THEN           /* IF ENTERED AT IEAVREP1 - MUST
*                                      RELEASE SALLOC, FREE FRR    0381
*                                                            @Z30GNYC*/
NORMEXIT TM    SCANHEAD(PVTPTR),B'10000000'                        0381
         BNO   @RF00381                                            0381
*     DO;                           /* ENTERED AT IEAVREP1   @Z30GNYC*/
*                                                                  0382
*       /*************************************************************/
*       /*                                                           */
*       /* RELEASE DISPATCHER LOCK                           @Z30GNYC*/
*       /*                                                           */
*       /*************************************************************/
*                                                                  0383
*RELD:                                                             0383
*       GENERATE NODEFS REFS(PSALITA,FLC) SETS(R11,R12,R13,R14) NOFLOWS
*           ;                                                      0383
RELD     DS    0H                                                  0383
      SETLOCK RELEASE,TYPE=DISP,RELATED=(RSM,IEAVPCB(GETD))
*       RCADISP='0'B;               /* NOTE DISP LOCK RELEASED     0384
*                                                            @ZA28519*/
*                                                                  0384
         NI    RCADISP(RCAPTR),B'11111101'                         0384
*       /*************************************************************/
*       /*                                                           */
*       /* RELEASE SALLOC LOCK                               @Z30GNYC*/
*       /*                                                           */
*       /*************************************************************/
*                                                                  0385
*FREELOCK:                                                         0385
*       GENERATE NODEFS REFS(PSALITA,FLC) SETS(R11,R12,R13,R14) NOFLOWS
*           ;                                                      0385
*                                                                  0385
FREELOCK DS    0H                                                  0385
      SETLOCK RELEASE,TYPE=SALLOC,RELATED=(RSM,IEAVPCB(GETLOCK))
*       /*************************************************************/
*       /*                                                           */
*       /* DELETE THE FRR                                    @Z30GNYC*/
*       /*                                                           */
*       /*************************************************************/
*                                                                  0386
*       GENERATE NODEFS REFS(PSACSTK,FRRSCURR,FRRSEMP,FRRSELEN,FRRS)
*           SETS(R11,R12);                                         0386
      SETFRR D,WRKREGS=(R11,R12),RELATED=(RSM,IEAVPCB(START))
*       R14=R8;                     /* RESTORE RETURN ADDR           */
         LR    R14,R8                                              0387
*       GEN NOFLOWS NOSETS NOSEQFLOW EXIT;                         0388
*                                      /* RETURN TO CALLER  @Z30GNYC*/
        BR R14                   RETURN
*     END;                          /* END OF EXIT PROCESSING      0389
*                                                            @Z30GNYC*/
*EXIT:                                                             0390
*   LM(R0,R14,PVTWSA17);            /* RESTORE CALLERS REG   @Z30GNYC*/
@RF00381 DS    0H                                                  0390
EXIT     LM    R0,R14,PVTWSA17(PVTPTR)                             0390
*   GEN NOFLOWS NOSETS NOSEQFLOW EXIT;                             0391
        BR R14                   RETURN
TRACEZP1 DS    0H                                             @Z40WPYD
PCBTRACE DC    H'64'                                          @Z40WPYD
*SCHEDSRB:                                                         0392
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);                               0392
*                                                                  0392
SCHEDSRB DS    0H                                                  0393
*/********************************************************************/
*/*                                                                  */
*/* SUBROUTINE - SCHEDSRB                                            */
*/*                                                                  */
*/* FUNCTION -   SET UP AND SCHEDULE AN SRB                          */
*/*                                                                  */
*/* INPUT -      R0: ADDRESS OF ROUTINE TO SCHEDULE                  */
*/*              R1: POINTER TO SRB                                  */
*/*             R11: VALUE FOR SRBPARM                               */
*/*             R12: POINTER TO ASCB WHERE SRB IS TO BE SCHEDULED    */
*/*                                                                  */
*/* OUTPUT -     SRB INITIALIZED AND SCHEDULED AS REQUESTED          */
*/*                                                                  */
*/********************************************************************/
*                                                                  0393
*   RESPECIFY                                                      0393
*    (R0,                                                          0393
*     R1,                                                          0393
*     R11,                                                         0393
*     R12) RESTRICTED;                                             0393
*   SRB=SRB&&SRB;                   /* ZERO THE SRB          @Z30GNYC*/
         XC    SRB(44,SRBPTR),SRB(SRBPTR)                          0394
*   SRBASCB=ASCBPTR;                /* SET ASCB ADDRESS      @Z30GNYC*/
         ST    ASCBPTR,SRBASCB(,SRBPTR)                            0395
*   SRBEP=R0;                       /* SET ENTRY POINT       @Z30GNYC*/
         ST    R0,SRBEP(,SRBPTR)                                   0396
*   SRBPASID=ASCBASID;              /* SET ASID              @Z30GNYC*/
         LH    @10,ASCBASID(,ASCBPTR)                              0397
         N     @10,@CF01845                                        0397
         STH   @10,SRBPASID(,SRBPTR)                               0397
*   SRBID='SRB ';                   /* SET SRB ID            @Z30GNYC*/
         MVC   SRBID(4,SRBPTR),@CC01828                            0398
*   SRBPRIOR=4;                     /* SET SRB PRIORITY, I.E.,     0399
*                                      NONQUIESCABLE         @Z30GNYC*/
         MVI   SRBPRIOR(SRBPTR),X'04'                              0399
*   SRBRMTR=PVTPSRBP;               /* PURGE RTN EP          @Z30GNYC*/
         L     @10,PVTPSRBP(,PVTPTR)                               0400
         ST    @10,SRBRMTR(,SRBPTR)                                0400
*   SRBPARM=R11;                    /* SET PARM VALUE AS REQUESTED 0401
*                                                            @Z30GNYC*/
         ST    R11,SRBPARM(,SRBPTR)                                0401
*   GENERATE;                                                      0402
*                                /* SCHEDULE THE SRB        @Z30GNYC*/
        SCHEDULE SRB=(1),SCOPE=LOCAL
*   RETURN;                         /* RETURN TO CALLER      @Z30GNYC*/
@EL00003 DS    0H                                                  0403
@EF00003 DS    0H                                                  0403
@ER00003 BR    @14                                                 0403
*   RESPECIFY                                                      0404
*    (R0,                                                          0404
*     R1,                                                          0404
*     R8,                                                          0404
*     R11,                                                         0404
*     R12) UNRESTRICTED;                                           0404
*   END SCHEDSRB;                   /* END OF SUBROUTINE     @Z30GNYC*/
*   END IEAVPCB                     /* END OF MODULE                 */
*                                                                  0406
*/* THE FOLLOWING INCLUDE STATEMENTS WERE FOUND IN THIS PROGRAM.     */
*/*%INCLUDE SYSLIB  (CVT     )                                       */
*/*%INCLUDE SYSLIB  (IHAPVT  )                                       */
*/*%INCLUDE SYSLIB  (IHAPCB  )                                       */
*/*%INCLUDE SYSLIB  (IHARSMHD)                                       */
*/*%INCLUDE SYSLIB  (IHARCA  )                                       */
*/*%INCLUDE SYSLIB  (IHAWSAVT)                                       */
*/*%INCLUDE SYSLIB  (IHAPSA  )                                       */
*/*%INCLUDE SYSLIB  (IHASRB  )                                       */
*/*%INCLUDE SYSLIB  (IHACPAB )                                       */
*/*%INCLUDE SYSLIB  (IHAASVT )                                       */
*/*%INCLUDE SYSLIB  (IHAFRRS )                                       */
*/*%INCLUDE SYSLIB  (IHAASCB )                                       */
*/*%INCLUDE SYSLIB  (ILRAIA  )                                       */
*                                                                  0406
*       ;                                                          0406
@DATA    DS    0H
@CH00983 DC    H'48'
         DS    0F
         DS    0F
@CF00107 DC    F'32'
@CF01689 DC    F'128'
@CF01845 DC    XL4'0000FFFF'
@CA01698 DC    A(IEAVREP3)
         DS    0D
@CC01828 DC    C'SRB '
@00      EQU   00                      EQUATES FOR REGISTERS 0-15
@01      EQU   01
@02      EQU   02
@03      EQU   03
@04      EQU   04
@05      EQU   05
@06      EQU   06
@07      EQU   07
@08      EQU   08
@09      EQU   09
@10      EQU   10
@11      EQU   11
@12      EQU   12
@13      EQU   13
@14      EQU   14
@15      EQU   15
PVTPTR   EQU   @03
PCBPTR   EQU   @04
RSMHDPTR EQU   @02
RCAPTR   EQU   @06
SRBPTR   EQU   @01
ASCBPTR  EQU   @12
R0       EQU   @00
CORELNR  EQU   @00
CPIDR    EQU   @00
R1       EQU   @01
BEGINPTR EQU   @01
R2       EQU   @02
R3       EQU   @03
R4       EQU   @04
R5       EQU   @05
QFSTPTR  EQU   @05
R7       EQU   @07
QTYRQDR  EQU   @07
TEMPCTR  EQU   @07
R8       EQU   @08
R9       EQU   @09
R11      EQU   @11
R12      EQU   @12
R13      EQU   @13
R14      EQU   @14
R15      EQU   @15
RETCODR  EQU   @15
R10      EQU   @10
R6       EQU   @06
PSA      EQU   0
FLCRNPSW EQU   PSA
FLCROPSW EQU   PSA+8
FLCICCW2 EQU   PSA+16
FLCCVT   EQU   FLCICCW2
PSAEEPSW EQU   PSA+132
PSAESPSW EQU   PSA+136
FLCSVILC EQU   PSAESPSW+1
PSAEPPSW EQU   PSA+140
FLCPIILC EQU   PSAEPPSW+1
FLCPICOD EQU   PSAEPPSW+2
PSAPICOD EQU   FLCPICOD+1
FLCTEA   EQU   PSAEPPSW+4
FLCPER   EQU   PSA+152
FLCMCLA  EQU   PSA+168
FLCIOEL  EQU   FLCMCLA+4
FLCIOA   EQU   FLCMCLA+16
FLCFSA   EQU   FLCMCLA+80
PSASUPER EQU   PSA+552
PSASUP1  EQU   PSASUPER
PSASUP2  EQU   PSASUPER+1
PSASUP3  EQU   PSASUPER+2
PSASUP4  EQU   PSASUPER+3
PSACLHT  EQU   PSA+640
PSALKSA  EQU   PSA+696
PSAHLHI  EQU   PSA+760
PSALITA  EQU   PSA+764
PSADSSFL EQU   PSA+836
PSADSSF1 EQU   PSADSSFL
PSADSSF3 EQU   PSADSSFL+2
PSADSSF4 EQU   PSADSSFL+3
PSARSVT  EQU   PSA+896
CVTMAP   EQU   0
CVTDAR   EQU   CVTMAP+72
CVTFLGS1 EQU   CVTDAR
CVTDCB   EQU   CVTMAP+116
CVTIOQET EQU   CVTMAP+120
CVTIERLC EQU   CVTMAP+144
CVTHEAD  EQU   CVTMAP+160
CVTSV76C EQU   CVTHEAD
CVTOPTA  EQU   CVTMAP+182
CVTOPTB  EQU   CVTMAP+183
CVTGTF   EQU   CVTMAP+236
CVTGTFST EQU   CVTGTF
CVTGTFS  EQU   CVTGTFST
CVTSTATE EQU   CVTGTFST
CVTTMODE EQU   CVTGTFST
CVTFORM  EQU   CVTGTFST
CVTAQAVT EQU   CVTMAP+240
CVTTCMFG EQU   CVTAQAVT
CVTVOLM2 EQU   CVTMAP+244
CVTTATA  EQU   CVTVOLM2
CVTTSKS  EQU   CVTTATA
CVTVOLF2 EQU   CVTTSKS
CVTTAT   EQU   CVTTATA+1
CVTATER  EQU   CVTMAP+248
CVTEXT1  EQU   CVTMAP+252
CVTPURG  EQU   CVTMAP+260
CVTQMSG  EQU   CVTMAP+268
CVTDMSR  EQU   CVTMAP+272
CVTRSV37 EQU   CVTDMSR
CVTDMSRF EQU   CVTRSV37
CVTERPV  EQU   CVTMAP+316
CVTINTLA EQU   CVTMAP+320
CVTAPF   EQU   CVTMAP+324
CVTEXT2  EQU   CVTMAP+328
CVTHJES  EQU   CVTMAP+332
CVTPGSIA EQU   CVTMAP+348
CVTA1F1  EQU   CVTMAP+356
CVTSYSK  EQU   CVTMAP+357
CVTVOLM1 EQU   CVTMAP+380
CVTVOLF1 EQU   CVTVOLM1
CVTXTNT1 EQU   0
CVTXTNT2 EQU   0
CVTDSSV  EQU   CVTXTNT2
CVTFLGBT EQU   CVTXTNT2+5
CVTQID   EQU   CVTXTNT2+24
CVTRV400 EQU   CVTXTNT2+52
CVTRV409 EQU   CVTXTNT2+53
CVTATCVT EQU   CVTXTNT2+64
CVTRV429 EQU   CVTXTNT2+84
CVTRV438 EQU   CVTXTNT2+85
CVTRV457 EQU   CVTXTNT2+112
CVTRV466 EQU   CVTXTNT2+113
CVTFIX   EQU   0
CVTRELNO EQU   CVTFIX+252
PVT      EQU   0
PVTFLAG1 EQU   PVT
PVTBGMS  EQU   PVTFLAG1
PVTSRBIU EQU   PVTFLAG1
PVTPCBLT EQU   PVTFLAG1
PVTFLAG2 EQU   PVT+1
PVTRSMGM EQU   PVTFLAG2
PVTPCBS  EQU   PVT+10
PVTSRBNO EQU   PVT+29
PVTPCBNO EQU   PVT+30
PVTPCBCT EQU   PVT+36
PVTPCBLO EQU   PVT+38
PVTPRCA  EQU   PVT+52
PVTSRBID EQU   PVT+68
PVTPGFAD EQU   PVT+88
PVTPIOCP EQU   PVT+96
PVTPRCV  EQU   PVT+156
PVTPSRBP EQU   PVT+188
PVTQS    EQU   PVT+304
PVTWSAX  EQU   PVT+344
PVTWSA13 EQU   PVTWSAX+896
PVTWSA17 EQU   PVTWSAX+1184
PVTSAVE  EQU   PVTWSAX+1328
PVTSRBS  EQU   PVT+1772
PVTRSRB  EQU   PVT+1776
PVTPCBQS EQU   PVT+1852
PVTFPCBF EQU   PVTPCBQS+16
PVTFPCBL EQU   PVTPCBQS+20
PCB      EQU   0
PCBFQP   EQU   PCB
PCBCQN   EQU   PCBFQP
PCBFQPA  EQU   PCBFQP+1
PCBBQP   EQU   PCB+4
PCBBQPA  EQU   PCBBQP
PCBRTP   EQU   PCB+8
PCBFL1   EQU   PCBRTP
PCBRLP   EQU   PCB+12
PCBXPT   EQU   PCB+16
PCBFL2   EQU   PCBXPT
PCBPGT   EQU   PCB+20
PCBFL3   EQU   PCBPGT
PCBBLOCK EQU   PCB+28
PCBSRB   EQU   PCBBLOCK
PCBRB    EQU   PCBSRB
PCBAIA   EQU   PCB+36
RSMHD    EQU   0
RSMFLG1  EQU   RSMHD+12
RSMIOCPU EQU   RSMFLG1
RSMIOCPC EQU   RSMFLG1
RSMGFAD  EQU   RSMFLG1
RSMCPNU  EQU   RSMFLG1
RSMCPNC  EQU   RSMFLG1
RSMGFADD EQU   RSMFLG1
RSMQS    EQU   RSMHD+20
RSMLFQ   EQU   RSMQS
RSMLSQA  EQU   RSMQS+4
RSMLIOQ  EQU   RSMQS+8
RCA      EQU   0
RCANAME7 EQU   RCA+8
RCACSECT EQU   RCA+9
RCAFLAGS EQU   RCA+10
RCASAL   EQU   RCAFLAGS
RCADISP  EQU   RCAFLAGS
RCARCRD  EQU   RCA+11
RCANAMES EQU   RCA+12
RCANAME1 EQU   RCANAMES
RCANAME2 EQU   RCANAMES+1
RCAPCB   EQU   RCANAME2
RCANAME3 EQU   RCANAMES+2
RCANAME4 EQU   RCANAMES+3
RCANAME5 EQU   RCANAMES+4
RCANAME6 EQU   RCANAMES+5
RCAREP1  EQU   RCANAME6
WSAL     EQU   0
ASXBSPSA EQU   0
WSAG     EQU   0
WSAC     EQU   0
LCCACPUS EQU   0
SRBSECT  EQU   0
SRB      EQU   SRBSECT
SRBID    EQU   SRB
SRBASCB  EQU   SRB+8
SRBFLC   EQU   SRB+12
SRBPASID EQU   SRBFLC+2
SRBEP    EQU   SRB+20
SRBRMTR  EQU   SRB+24
SRBPARM  EQU   SRB+28
SRBPRIOR EQU   SRB+37
CPAB     EQU   0
CPABFLGW EQU   CPAB+16
CPABFLGS EQU   CPABFLGW+1
CPABPTR  EQU   0
ASVT     EQU   0
ASVTFRST EQU   ASVT+524
ASVTENTY EQU   ASVT+528
ASVTPTR  EQU   0
FRRS     EQU   0
FRRSHEAD EQU   FRRS
FRRSEMP  EQU   FRRSHEAD
FRRSLAST EQU   FRRSHEAD+4
FRRSELEN EQU   FRRSHEAD+8
FRRSCURR EQU   FRRSHEAD+12
FRRSENTR EQU   0
FRRSFRRA EQU   FRRSENTR
FRRSFLGS EQU   FRRSENTR+4
FRRSFLG1 EQU   FRRSFLGS
FRRSPARM EQU   FRRSENTR+8
FRREPTR  EQU   0
ASCB     EQU   0
ASCBFWDP EQU   ASCB+4
ASCBSUPC EQU   ASCB+16
ASCBASID EQU   ASCB+36
ASCBRSM  EQU   ASCB+52
ASCBRSMF EQU   ASCBRSM
ASCBFW1  EQU   ASCB+100
ASCBRCTF EQU   ASCBFW1+2
ASCBFLG1 EQU   ASCBFW1+3
ASCBDSP1 EQU   ASCB+114
ASCBFLG2 EQU   ASCB+115
ASCBLKGP EQU   ASCB+128
ASCBSRQ  EQU   ASCB+180
ASCBSRQ1 EQU   ASCBSRQ
ASCBSRQ2 EQU   ASCBSRQ+1
ASCBSRQ3 EQU   ASCBSRQ+2
ASCBSRQ4 EQU   ASCBSRQ+3
QHEADER  EQU   0
QFIRST   EQU   QHEADER
QLAST    EQU   QHEADER+4
CVTPTR   EQU   FLCCVT
CVTS01   EQU   CVTPGSIA
CVTPVTP  EQU   CVTS01+8
CVTLPDIA EQU   CVTS01+12
CVTDIRST EQU   CVTLPDIA
CVTSLIDA EQU   CVTS01+24
CVTCTLFG EQU   CVTS01+50
CVTASVT  EQU   CVTS01+208
CVTSPSA  EQU   CVTS01+336
CVTRV210 EQU   CVTS01+424
CVTRV219 EQU   CVTS01+425
CVTRV228 EQU   CVTS01+426
CVTRV237 EQU   CVTS01+427
CVTMFRTR EQU   CVTS01+452
CVTRV262 EQU   CVTS01+468
CVTRV271 EQU   CVTS01+469
CVTRV280 EQU   CVTS01+470
CVTRV289 EQU   CVTS01+471
CVTGSDA  EQU   CVTS01+600
FLC      EQU   PSA
PSARSVTE EQU   PSARSVT
PSACSTK  EQU   PSARSVTE
FRRSPTR  EQU   PSACSTK
TQNQTY   EQU   PVTWSA13
MGRQTY   EQU   TQNQTY
MGRTQN   EQU   MGRQTY+3
MGRWD    EQU   TQNQTY+4
INTAREA  EQU   TQNQTY+64
FLAGS    EQU   INTAREA
FGMFAILF EQU   FLAGS
MGRRRTN  EQU   TQNQTY+68
MGRCLEAR EQU   PCB
SAVEREP1 EQU   PVTWSA17
@NM00045 EQU   SAVEREP1+64
SCANHEAD EQU   @NM00045
ERRLOOP  EQU   @NM00045
RSMAIA   EQU   PCBAIA
AIA      EQU   RSMAIA
AIAFLG1  EQU   AIA+9
AIAFLG2  EQU   AIA+10
AIAFLG3  EQU   AIA+11
AIANXAIA EQU   AIA+12
AIAID    EQU   AIA+16
AIALPID  EQU   AIAID
AIALGID  EQU   AIALPID
AIALSID  EQU   AIALGID
AIASSID  EQU   AIALSID+1
AIARPN   EQU   AIALPID+4
AIALSID2 EQU   AIARPN
AIALPMEP EQU   AIALSID2
AIAGRPSZ EQU   AIA+24
AIALGE   EQU   AIAGRPSZ
*                                      START UNREFERENCED COMPONENTS
AIADPXCT EQU   AIALGE
AIACEPTR EQU   AIALPMEP
AIASLOT  EQU   AIASSID+1
@NM00050 EQU   AIASSID
@NM00049 EQU   AIALSID
AIARCSN  EQU   AIANXAIA+2
AIACYL   EQU   AIANXAIA
AIARSV9  EQU   AIAFLG3
AIARSV8  EQU   AIAFLG3
AIARSV7  EQU   AIAFLG3
AIALPMEC EQU   AIAFLG3
AIARSV6  EQU   AIAFLG3
AIATRPSP EQU   AIAFLG3
AIAPRINO EQU   AIAFLG3
AIARSV5  EQU   AIAFLG3
AIABADID EQU   AIAFLG2
AIAERROR EQU   AIAFLG2
AIASECER EQU   AIAFLG2
AIAPRIER EQU   AIAFLG2
AIARSV4  EQU   AIAFLG2
AIAIORTY EQU   AIAFLG2
AIATERMR EQU   AIAFLG2
AIAFRAUX EQU   AIAFLG2
AIARSV1  EQU   AIAFLG1
AIASWPFX EQU   AIAFLG1
AIAPAGDS EQU   AIAFLG1
AIALSQA  EQU   AIAFLG1
AIADUPLX EQU   AIAFLG1
AIAVIO   EQU   AIAFLG1
AIAPRIV  EQU   AIAFLG1
AIAWRITE EQU   AIAFLG1
AIAOP    EQU   AIA+8
AIABQPA  EQU   AIA+4
AIAFQPA  EQU   AIA
@NM00048 EQU   SAVEREP1+68
@NM00047 EQU   @NM00045+1
@NM00046 EQU   @NM00045
SAVREGS  EQU   SAVEREP1
@NM00044 EQU   INTAREA+1
@NM00043 EQU   FLAGS
RETCOD   EQU   TQNQTY+60
@NM00042 EQU   TQNQTY+8
@NM00041 EQU   MGRQTY
PSARSAV  EQU   PSARSVTE+60
PSARSTK  EQU   PSARSVTE+56
PSAESAV3 EQU   PSARSVTE+52
PSAESTK3 EQU   PSARSVTE+48
PSAESAV2 EQU   PSARSVTE+44
PSAESTK2 EQU   PSARSVTE+40
PSAESAV1 EQU   PSARSVTE+36
PSAESTK1 EQU   PSARSVTE+32
PSAPSAV  EQU   PSARSVTE+28
PSAPSTK  EQU   PSARSVTE+24
PSAMSAV  EQU   PSARSVTE+20
PSAMSTK  EQU   PSARSVTE+16
PSASSAV  EQU   PSARSVTE+12
PSASSTK  EQU   PSARSVTE+8
PSANSTK  EQU   PSARSVTE+4
CVTRV628 EQU   CVTS01+728
CVTRV627 EQU   CVTS01+724
CVTRV626 EQU   CVTS01+720
CVTRV625 EQU   CVTS01+716
CVTRV624 EQU   CVTS01+712
CVTRV623 EQU   CVTS01+708
CVTRV622 EQU   CVTS01+704
CVTRV621 EQU   CVTS01+700
CVTIHASU EQU   CVTS01+696
CVTSUSP  EQU   CVTS01+692
CVTT6SVC EQU   CVTS01+688
CVTCDAL  EQU   CVTS01+684
CVTTCTL  EQU   CVTS01+680
CVTRSUME EQU   CVTS01+676
CVTJTERM EQU   CVTS01+672
CVTASMRM EQU   CVTS01+668
CVTTCASP EQU   CVTS01+664
CVT0PT03 EQU   CVTS01+660
CVT0PT0E EQU   CVTS01+656
CVTRV609 EQU   CVTS01+652
CVTCGK   EQU   CVTS01+648
CVTRAC   EQU   CVTS01+644
CVTHSM   EQU   CVTS01+640
CVTRV605 EQU   CVTS01+636
CVTRV604 EQU   CVTS01+632
CVTEFF02 EQU   CVTS01+628
CVTCBBR  EQU   CVTS01+624
CVTSSCR  EQU   CVTS01+620
CVTEVENT EQU   CVTS01+616
CVTCRCA  EQU   CVTS01+612
CVTTPIO  EQU   CVTS01+608
CVTADV   EQU   CVTS01+604
CVTGSDAB EQU   CVTGSDA
CVTQV3   EQU   CVTS01+596
CVTQV2   EQU   CVTS01+592
CVTQV1   EQU   CVTS01+588
CVTRPT   EQU   CVTS01+584
CVTSSRB  EQU   CVTS01+580
CVTCSDRL EQU   CVTS01+576
CVTEXP1  EQU   CVTS01+572
CVTRMPMT EQU   CVTS01+568
CVTRMPTT EQU   CVTS01+564
CVTVPSA  EQU   CVTS01+560
CVTVSTOP EQU   CVTS01+556
CVTGTFR8 EQU   CVTS01+552
CVTQUIT  EQU   CVTS01+548
CVTVACR  EQU   CVTS01+544
CVTWTCB  EQU   CVTS01+540
CVTSTPRS EQU   CVTS01+536
CVT0PT02 EQU   CVTS01+532
CVTDARCM EQU   CVTS01+528
CVTIRECM EQU   CVTS01+524
CVTJRECM EQU   CVTS01+520
CVTVEMS0 EQU   CVTS01+516
CVTSPFRR EQU   CVTS01+512
CVTRLSTG EQU   CVTS01+508
CVT0TC0A EQU   CVTS01+504
CVTGMBR  EQU   CVTS01+500
CVTLFRM  EQU   CVTS01+496
CVTRMBR  EQU   CVTS01+492
CVTVIOP  EQU   CVTS01+488
CVTRV307 EQU   CVTS01+486
CVTRV306 EQU   CVTS01+484
CVTRV305 EQU   CVTS01+482
CVTRV304 EQU   CVTS01+480
CVTRV303 EQU   CVTS01+478
CVTRV302 EQU   CVTS01+476
CVTTRCA  EQU   CVTS01+472
CVTRV297 EQU   CVTRV289
CVTRV296 EQU   CVTRV289
CVTRV295 EQU   CVTRV289
CVTRV294 EQU   CVTRV289
CVTRV293 EQU   CVTRV289
CVTRV292 EQU   CVTRV289
CVTRV291 EQU   CVTRV289
CVTRV290 EQU   CVTRV289
CVTRV288 EQU   CVTRV280
CVTRV287 EQU   CVTRV280
CVTRV286 EQU   CVTRV280
CVTRV285 EQU   CVTRV280
CVTRV284 EQU   CVTRV280
CVTRV283 EQU   CVTRV280
CVTRV282 EQU   CVTRV280
CVTRV281 EQU   CVTRV280
CVTRV279 EQU   CVTRV271
CVTRV278 EQU   CVTRV271
CVTRV277 EQU   CVTRV271
CVTRV276 EQU   CVTRV271
CVTRV275 EQU   CVTRV271
CVTRV274 EQU   CVTRV271
CVTRV273 EQU   CVTRV271
CVTRV272 EQU   CVTRV271
CVTRV270 EQU   CVTRV262
CVTRV269 EQU   CVTRV262
CVTRV268 EQU   CVTRV262
CVTRV267 EQU   CVTRV262
CVTRV266 EQU   CVTRV262
CVTRV265 EQU   CVTRV262
CVTRV264 EQU   CVTRV262
CVTRV263 EQU   CVTRV262
CVTVFP   EQU   CVTS01+464
CVTVSI   EQU   CVTS01+460
CVTVPSIB EQU   CVTS01+456
CVTMFACT EQU   CVTMFRTR
CVTMFCTL EQU   CVTS01+448
CVTPVBP  EQU   CVTS01+444
CVTPWI   EQU   CVTS01+440
CVTRV254 EQU   CVTS01+438
CVTRV253 EQU   CVTS01+436
CVTRV252 EQU   CVTS01+434
CVTRV251 EQU   CVTS01+433
CVTRV250 EQU   CVTS01+432
CVTRV249 EQU   CVTS01+431
CVTRV248 EQU   CVTS01+430
CVTRV247 EQU   CVTS01+429
CVTRV246 EQU   CVTS01+428
CVTRV245 EQU   CVTRV237
CVTRV244 EQU   CVTRV237
CVTRV243 EQU   CVTRV237
CVTRV242 EQU   CVTRV237
CVTRV241 EQU   CVTRV237
CVTRV240 EQU   CVTRV237
CVTRV239 EQU   CVTRV237
CVTRV238 EQU   CVTRV237
CVTRV236 EQU   CVTRV228
CVTRV235 EQU   CVTRV228
CVTRV234 EQU   CVTRV228
CVTRV233 EQU   CVTRV228
CVTRV232 EQU   CVTRV228
CVTRV231 EQU   CVTRV228
CVTRV230 EQU   CVTRV228
CVTRV229 EQU   CVTRV228
CVTRV227 EQU   CVTRV219
CVTRV226 EQU   CVTRV219
CVTRV225 EQU   CVTRV219
CVTRV224 EQU   CVTRV219
CVTRV223 EQU   CVTRV219
CVTRV222 EQU   CVTRV219
CVTRV221 EQU   CVTRV219
CVTRV220 EQU   CVTRV219
CVTRV218 EQU   CVTRV210
CVTRV217 EQU   CVTRV210
CVTRV216 EQU   CVTRV210
CVTRV215 EQU   CVTRV210
CVTRV214 EQU   CVTRV210
CVTRV213 EQU   CVTRV210
CVTRV212 EQU   CVTRV210
CVTRV211 EQU   CVTRV210
CVTLCCAT EQU   CVTS01+420
CVTPCCAT EQU   CVTS01+416
CVTIPCRP EQU   CVTS01+412
CVTIPCRI EQU   CVTS01+408
CVTIPCDS EQU   CVTS01+404
CVTAIDVT EQU   CVTS01+400
CVTSSAP  EQU   CVTS01+396
CVTEHCIR EQU   CVTS01+392
CVTEHDEF EQU   CVTS01+388
CVTDAIR  EQU   CVTS01+384
CVTPERFM EQU   CVTS01+380
CVT044R2 EQU   CVTS01+376
CVTFETCH EQU   CVTS01+372
CVTRSTWD EQU   CVTS01+368
CVTSPOST EQU   CVTS01+364
CVTIOBP  EQU   CVTS01+360
CVTASMVT EQU   CVTS01+356
CVTRECRQ EQU   CVTS01+352
CVTWSAC  EQU   CVTS01+348
CVTRV149 EQU   CVTS01+344
CVTWSAL  EQU   CVTS01+340
CVTGLMN  EQU   CVTS01+332
CVTVEAC0 EQU   CVTS01+328
CVT062R1 EQU   CVTS01+324
CVTRPOST EQU   CVTS01+320
CVTDQIQE EQU   CVTS01+316
CVTCSD   EQU   CVTS01+312
CVTLKRMA EQU   CVTS01+308
CVTRSPIE EQU   CVTS01+304
CVTRENQ  EQU   CVTS01+300
CVTLQCB  EQU   CVTS01+296
CVTFQCB  EQU   CVTS01+292
CVTQCS01 EQU   CVTS01+288
CVTAPFT  EQU   CVTS01+284
CVTPARRL EQU   CVTS01+280
CVTVWAIT EQU   CVTS01+276
CVTGSPL  EQU   CVTS01+272
CVTLSMQ  EQU   CVTS01+268
CVTGSMQ  EQU   CVTS01+264
CVTEXPRO EQU   CVTS01+260
CVTOPCTP EQU   CVTS01+256
CVTSIC   EQU   CVTS01+252
CVTTPIOS EQU   CVTS01+248
CVTRTMS  EQU   CVTS01+244
CVTSDBF  EQU   CVTS01+240
CVTSCBP  EQU   CVTS01+236
CVTSDMP  EQU   CVTS01+232
CVTSV60  EQU   CVTS01+228
CVTRTMCT EQU   CVTS01+224
CVTASCBL EQU   CVTS01+220
CVTASCBH EQU   CVTS01+216
CVTGDA   EQU   CVTS01+212
CVTVVMDI EQU   CVTS01+204
CVTAQTOP EQU   CVTS01+200
CVTIOSCS EQU   CVTS01+196
CVTSDRM  EQU   CVTS01+192
CVTOPTE  EQU   CVTS01+188
CVTSTXU  EQU   CVTS01+184
CVTQUIS  EQU   CVTS01+180
CVTPARS  EQU   CVTS01+176
CVTS1EE  EQU   CVTS01+172
CVTFRAS  EQU   CVTS01+168
CVTQSAS  EQU   CVTS01+164
CVTCRAS  EQU   CVTS01+160
CVTCRMN  EQU   CVTS01+156
CVTDELCP EQU   CVTS01+152
CVTFRECL EQU   CVTS01+148
CVTGETCL EQU   CVTS01+144
CVTBLDCP EQU   CVTS01+140
CVTAUTHL EQU   CVTS01+136
CVTSCAN  EQU   CVTS01+132
CVTRV144 EQU   CVTS01+130
CVTMAXMP EQU   CVTS01+128
CVTSTCK  EQU   CVTS01+124
CVTRV139 EQU   CVTS01+123
CVTDSSAC EQU   CVTS01+122
CVTRV513 EQU   CVTS01+121
CVTIOSPL EQU   CVTS01+120
CVTPTGT  EQU   CVTS01+116
CVTCSPIE EQU   CVTS01+112
CVTSMFEX EQU   CVTS01+108
CVTOLT0A EQU   CVTS01+104
CVTSRBRT EQU   CVTS01+100
CVTPUTL  EQU   CVTS01+96
CVTASCRL EQU   CVTS01+92
CVTASCRF EQU   CVTS01+88
CVTRV326 EQU   CVTS01+84
CVTRV325 EQU   CVTS01+80
CVTRV324 EQU   CVTS01+76
CVT0VL01 EQU   CVTS01+72
CVTSHRVM EQU   CVTS01+68
CVTRV332 EQU   CVTS01+64
CVTTAS   EQU   CVTS01+60
CVTRSCN  EQU   CVTS01+56
CVTTRAC2 EQU   CVTS01+54
CVTTRACE EQU   CVTS01+52
CVTAPG   EQU   CVTS01+51
CVTSDTRC EQU   CVTCTLFG
CVTGTRCE EQU   CVTCTLFG
CVTNOMP  EQU   CVTCTLFG
CVTRSV79 EQU   CVTCTLFG
CVTDSTAT EQU   CVTCTLFG
CVTRSV78 EQU   CVTCTLFG
CVTRV333 EQU   CVTCTLFG
CVTRV323 EQU   CVTCTLFG
CVTSPVLK EQU   CVTS01+49
CVTRSV77 EQU   CVTS01+48
CVTRV331 EQU   CVTS01+44
CVTRV330 EQU   CVTS01+40
CVTRV329 EQU   CVTS01+36
CVTRV328 EQU   CVTS01+32
CVTRV322 EQU   CVTS01+28
CVTSLID  EQU   CVTSLIDA+1
CVTSYLK  EQU   CVTSLIDA
CVTRV321 EQU   CVTS01+20
CVTRV320 EQU   CVTS01+16
CVTLPDIR EQU   CVTLPDIA+1
CVTRSV69 EQU   CVTDIRST
CVTRSV68 EQU   CVTDIRST
CVTRSV67 EQU   CVTDIRST
CVTRSV66 EQU   CVTDIRST
CVTRSV65 EQU   CVTDIRST
CVTRSV64 EQU   CVTDIRST
CVTRSV63 EQU   CVTDIRST
CVTDICOM EQU   CVTDIRST
CVTLPDSR EQU   CVTS01+4
CVTGETL  EQU   CVTS01
ASCBEND  EQU   ASCB+208
ASCBSRBT EQU   ASCB+200
ASCBSWTL EQU   ASCB+196
ASCBRS14 EQU   ASCB+195
ASCBSMCT EQU   ASCB+194
ASCBRS12 EQU   ASCB+192
ASCBPCTT EQU   ASCB+188
ASCBVGTT EQU   ASCB+184
ASCBRV43 EQU   ASCBSRQ4
ASCBRV42 EQU   ASCBSRQ4
ASCBRV41 EQU   ASCBSRQ4
ASCBRV40 EQU   ASCBSRQ4
ASCBRV39 EQU   ASCBSRQ4
ASCBRV38 EQU   ASCBSRQ4
ASCBRV37 EQU   ASCBSRQ4
ASCBRV36 EQU   ASCBSRQ4
ASCBRV35 EQU   ASCBSRQ3
ASCBRV34 EQU   ASCBSRQ3
ASCBRV33 EQU   ASCBSRQ3
ASCBRV32 EQU   ASCBSRQ3
ASCBRV31 EQU   ASCBSRQ3
ASCBRV30 EQU   ASCBSRQ3
ASCBRV29 EQU   ASCBSRQ3
ASCBRV28 EQU   ASCBSRQ3
ASCBRV27 EQU   ASCBSRQ2
ASCBRV26 EQU   ASCBSRQ2
ASCBRV25 EQU   ASCBSRQ2
ASCBRV24 EQU   ASCBSRQ2
ASCBRV23 EQU   ASCBSRQ2
ASCBRV22 EQU   ASCBSRQ2
ASCBRV21 EQU   ASCBSRQ2
ASCBRV20 EQU   ASCBSRQ2
ASCBRV19 EQU   ASCBSRQ1
ASCBRV18 EQU   ASCBSRQ1
ASCBRV17 EQU   ASCBSRQ1
ASCBRV16 EQU   ASCBSRQ1
ASCBRV15 EQU   ASCBSRQ1
ASCBRV14 EQU   ASCBSRQ1
ASCBRV13 EQU   ASCBSRQ1
ASCBSTA  EQU   ASCBSRQ1
ASCBJBNS EQU   ASCB+176
ASCBJBNI EQU   ASCB+172
ASCBMCC  EQU   ASCB+168
ASCBRTWA EQU   ASCB+164
ASCBIQEA EQU   ASCB+160
ASCBXMPQ EQU   ASCB+156
ASCBRS01 EQU   ASCB+154
ASCBFMCT EQU   ASCB+152
ASCBOUXB EQU   ASCB+148
ASCBOUCB EQU   ASCB+144
ASCBMECB EQU   ASCB+140
ASCBQECB EQU   ASCB+136
ASCBLSQH EQU   ASCBLKGP+4
ASCBLOCK EQU   ASCBLKGP
ASCBTCBS EQU   ASCB+124
ASCBNVSC EQU   ASCB+122
ASCBVSC  EQU   ASCB+120
ASCBSRBS EQU   ASCB+118
ASCBSSRB EQU   ASCB+116
ASCBRV06 EQU   ASCBFLG2
ASCBRV05 EQU   ASCBFLG2
ASCBRV04 EQU   ASCBFLG2
ASCBSNQS EQU   ASCBFLG2
ASCBS2S  EQU   ASCBFLG2
ASCBCEXT EQU   ASCBFLG2
ASCBPXMT EQU   ASCBFLG2
ASCBXMPT EQU   ASCBFLG2
ASCBRF07 EQU   ASCBDSP1
ASCBRF06 EQU   ASCBDSP1
ASCBRF05 EQU   ASCBDSP1
ASCBRF04 EQU   ASCBDSP1
ASCBRF03 EQU   ASCBDSP1
ASCBRF02 EQU   ASCBDSP1
ASCBFAIL EQU   ASCBDSP1
ASCBNOQ  EQU   ASCBDSP1
ASCBSWCT EQU   ASCB+112
ASCBASXB EQU   ASCB+108
ASCBTMCH EQU   ASCB+104
ASCBNSWP EQU   ASCBFLG1
ASCBTYP1 EQU   ASCBFLG1
ASCBSTND EQU   ASCBFLG1
ASCBABNT EQU   ASCBFLG1
ASCBTERM EQU   ASCBFLG1
ASCBS3S  EQU   ASCBFLG1
ASCBCMSH EQU   ASCBFLG1
ASCBTOFF EQU   ASCBFLG1
ASCBRF01 EQU   ASCBRCTF
ASCBTMLW EQU   ASCBRCTF
ASCBOUT  EQU   ASCBRCTF
ASCBWAIT EQU   ASCBRCTF
ASCBRV08 EQU   ASCBRCTF
ASCBFQU  EQU   ASCBRCTF
ASCBFRS  EQU   ASCBRCTF
ASCBTMNO EQU   ASCBRCTF
ASCBAFFN EQU   ASCBFW1
ASCBDUMP EQU   ASCB+96
ASCBRV44 EQU   ASCB+92
ASCBUBET EQU   ASCB+88
ASCBECB  EQU   ASCB+84
ASCBJSTL EQU   ASCB+80
ASCBEWST EQU   ASCB+72
ASCBEJST EQU   ASCB+64
ASCBTSB  EQU   ASCB+60
ASCBCSCB EQU   ASCB+56
ASCBRSMA EQU   ASCBRSM+1
ASCBRV54 EQU   ASCBRSMF
ASCBRV53 EQU   ASCBRSMF
ASCBRV52 EQU   ASCBRSMF
ASCBRV51 EQU   ASCBRSMF
ASCBVEQR EQU   ASCBRSMF
ASCBN2LP EQU   ASCBRSMF
ASCB1LPU EQU   ASCBRSMF
ASCB2LPU EQU   ASCBRSMF
ASCBLDA  EQU   ASCB+48
ASCBSTOR EQU   ASCB+44
ASCBDP   EQU   ASCB+43
ASCBRV07 EQU   ASCB+42
ASCBIOSM EQU   ASCB+40
ASCBSEQN EQU   ASCB+38
ASCBCPUS EQU   ASCB+32
ASCBSPL  EQU   ASCB+28
ASCBIOSP EQU   ASCB+24
ASCBSYNC EQU   ASCBSUPC+4
ASCBSVRB EQU   ASCBSUPC
ASCBCMSF EQU   ASCB+12
ASCBBWDP EQU   ASCB+8
ASCBASCB EQU   ASCB
ASCBEGIN EQU   ASCB
@NM00040 EQU   FRRSFLGS+1
@NM00039 EQU   FRRSFLG1
FRRSNEST EQU   FRRSFLG1
FRRSRCUR EQU   FRRSFLG1
FRRSENTS EQU   FRRS+84
FRRSRTMW EQU   FRRS+16
ASVTEND  EQU   ASVT+528
ASVTAVAL EQU   ASVTENTY
ASVTAVAI EQU   ASVTFRST
ASVTRS00 EQU   ASVT+520
ASVTMAXU EQU   ASVT+516
ASVTASVT EQU   ASVT+512
ASVTBEGN EQU   ASVT+512
@NM00038 EQU   ASVT
CPABNXTP EQU   CPAB+28
CPABENAD EQU   CPAB+24
CPABSTAD EQU   CPAB+20
CPABUSE# EQU   CPABFLGW+2
SERIAL   EQU   CPABFLGS
DELETELK EQU   CPABFLGS
CPABEXTN EQU   CPABFLGS
ADELCAND EQU   CPABFLGS
BLDDWORD EQU   CPABFLGS
NIPBLDCP EQU   CPABFLGS
CPABSPID EQU   CPABFLGW
CPABFACP EQU   CPAB+12
CPABDEQC EQU   CPAB+8
CPABCSZE EQU   CPAB+4
CPABCPID EQU   CPAB
@NM00037 EQU   SRB+40
@NM00036 EQU   SRB+38
SRBPKF   EQU   SRB+36
SRBSAVE  EQU   SRB+32
SRBPTCB  EQU   SRBFLC+4
SRBCPAFF EQU   SRBFLC
SRBFLNK  EQU   SRB+4
WSACASMS EQU   WSAC+60
WSACASMD EQU   WSAC+56
WSACCCH  EQU   WSAC+52
WSACRRSA EQU   WSAC+48
WSACREST EQU   WSAC+44
WSACRSTI EQU   WSAC+40
WSACABTM EQU   WSAC+36
WSACMF1  EQU   WSAC+32
WSACEDS0 EQU   WSAC+28
WSACIOS  EQU   WSAC+24
WSACRTMK EQU   WSAC+20
WSACACR  EQU   WSAC+16
WSACTIME EQU   WSAC+12
WSACOPTM EQU   WSAC+8
WSACGTF  EQU   WSAC+4
WSACCWSA EQU   WSAC
WSAGSCHE EQU   WSAG+40
WSAGREST EQU   WSAG+36
WSAGNQDQ EQU   WSAG+32
WSAGMEMT EQU   WSAG+28
WSAGOPTM EQU   WSAG+24
WSAGSTAT EQU   WSAG+20
WSAGEMS0 EQU   WSAG+16
WSAGSSRS EQU   WSAG+12
WSAGRSM  EQU   WSAG+8
WSAGGMFM EQU   WSAG+4
WSAGPGIO EQU   WSAG
WSALACHP EQU   WSAL+56
WSALRSM  EQU   WSAL+52
WSALEVNT EQU   WSAL+48
WSALSTAE EQU   WSAL+44
WSALSTAT EQU   WSAL+40
WSALWAIT EQU   WSAL+36
WSALPOST EQU   WSAL+32
WSALEXIT EQU   WSAL+28
WSALS2EE EQU   WSAL+24
WSALCIRB EQU   WSAL+20
WSALABTM EQU   WSAL+16
WSALSDMP EQU   WSAL+12
WSALRTM2 EQU   WSAL+8
WSALVALC EQU   WSAL+4
WSALCWSA EQU   WSAL
RCARETAD EQU   RCA+20
RCATASID EQU   RCA+18
RCAPSIF  EQU   RCANAME6
RCAPSIX  EQU   RCANAME6
RCAVEQRP EQU   RCANAME6
RCARCFC  EQU   RCANAME6
RCACSGB  EQU   RCANAME6
RCAFXL   EQU   RCANAME6
RCAPS113 EQU   RCANAME6
RCAFREE  EQU   RCANAME5
RCARFR2  EQU   RCANAME5
RCACPBR  EQU   RCANAME5
RCAOPBR  EQU   RCANAME5
RCASORT  EQU   RCANAME5
RCASIRT  EQU   RCANAME5
RCARELV  EQU   RCANAME5
RCARELF  EQU   RCANAME5
RCAGFAD  EQU   RCANAME4
RCAVEQRI EQU   RCANAME4
RCAVEQRF EQU   RCANAME4
RCAVEQRC EQU   RCANAME4
RCATERM  EQU   RCANAME4
RCASQA   EQU   RCANAME4
RCASWIN  EQU   RCANAME4
RCASOUT  EQU   RCANAME4
RCARFR   EQU   RCANAME3
RCARELS  EQU   RCANAME3
RCARCFI  EQU   RCANAME3
RCARCF   EQU   RCANAME3
RCAPSII  EQU   RCANAME3
RCAPSIB  EQU   RCANAME3
RCAPS112 EQU   RCANAME3
RCAPIX   EQU   RCANAME3
RCAPIOP  EQU   RCANAME2
RCASWPC  EQU   RCANAME2
RCASWPP  EQU   RCANAME2
RCAPFTE  EQU   RCANAME2
RCAOUT   EQU   RCANAME2
RCAITAS  EQU   RCANAME2
RCAIOCP  EQU   RCANAME2
RCAINV   EQU   RCANAME1
RCAGFA   EQU   RCANAME1
RCAFXLD  EQU   RCANAME1
RCAVEQR  EQU   RCANAME1
RCADSEG  EQU   RCANAME1
RCADLAS  EQU   RCANAME1
RCACSEG  EQU   RCANAME1
RCAVAMSI EQU   RCANAME1
@NM00011 EQU   RCAFLAGS
@NM00010 EQU   RCAFLAGS
RCAQS    EQU   RCAFLAGS
RCAPSIER EQU   RCAFLAGS
RCAABEND EQU   RCAFLAGS
RCALL    EQU   RCAFLAGS
@NM00009 EQU   RCANAME7
RCAPRSS  EQU   RCANAME7
RCAPRSR  EQU   RCANAME7
RCAPRSB  EQU   RCANAME7
RCAPSIY  EQU   RCANAME7
RCAPIOI  EQU   RCANAME7
RCAPARM1 EQU   RCA+4
RCAPARM0 EQU   RCA
RSMASMHD EQU   RSMHD+40
RSMFOEQ  EQU   RSMHD+36
RSMLIOQL EQU   RSMLIOQ+4
RSMLIOQF EQU   RSMLIOQ
RSMLSQAL EQU   RSMLSQA+2
RSMLSQAF EQU   RSMLSQA
RSMLFQL  EQU   RSMLFQ+2
RSMLFQF  EQU   RSMLFQ
RSMRSV2  EQU   RSMHD+16
RSMCNTFX EQU   RSMHD+14
RSMRSV1  EQU   RSMHD+13
@NM00008 EQU   RSMFLG1
RSMFAIL  EQU   RSMFLG1
RSMASCB  EQU   RSMHD+8
RSMSPCT  EQU   RSMHD+4
RSMVSTO  EQU   RSMHD
PCBEND   EQU   PCB+64
PCBASCB  EQU   PCB+32
PCBSPCTE EQU   PCBRB
PCBVBN   EQU   PCB+26
PCBRBN   EQU   PCB+24
PCBPGTA  EQU   PCBPGT+1
PCBSWPS2 EQU   PCBFL3
@NM00007 EQU   PCBFL3
PCBNOREC EQU   PCBFL3
PCBDFRLS EQU   PCBFL3
PCBSWPLS EQU   PCBFL3
PCBSWPS1 EQU   PCBFL3
PCBSWPIN EQU   PCBFL3
PCBSWPOT EQU   PCBFL3
PCBXPTA  EQU   PCBXPT+1
@NM00006 EQU   PCBFL2
@NM00005 EQU   PCBFL2
PCBVIO   EQU   PCBFL2
PCBSUPRS EQU   PCBFL2
PCBRESET EQU   PCBFL2
PCBIOERR EQU   PCBFL2
PCBGFAD  EQU   PCBFL2
PCBFREAL EQU   PCBFL2
PCBRLPA  EQU   PCBRLP+1
PCBFXC   EQU   PCBRLP
PCBRTPA  EQU   PCBRTP+1
PCBIOCMP EQU   PCBFL1
PCBIOI   EQU   PCBFL1
PCBROOT  EQU   PCBFL1
PCBLFR   EQU   PCBFL1
PCBLLHLD EQU   PCBFL1
PCBSRBMD EQU   PCBFL1
PCBPEX   EQU   PCBFL1
@NM00004 EQU   PCBFL1
PVTEND   EQU   PVT+1944
PVTTASID EQU   PVT+1942
PVTXXXXX EQU   PVT+1940
PVTMVCLC EQU   PVT+1936
PVTVCONS EQU   PVT+1896
PVTPRSB  EQU   PVT+1892
PVTCIOQL EQU   PVTPCBQS+36
PVTCIOQF EQU   PVTPCBQS+32
PVTGFADL EQU   PVTPCBQS+28
PVTGFADF EQU   PVTPCBQS+24
PVTPCBQR EQU   PVTPCBQS
PVTLPAFX EQU   PVT+1850
PVTLSQAF EQU   PVT+1848
PVTLPAR  EQU   PVT+1844
PVTLPAI  EQU   PVT+1840
PVTLPAFC EQU   PVT+1838
PVTCHUIC EQU   PVT+1836
PVTCOMFX EQU   PVT+1834
PVTSQAFX EQU   PVT+1832
PVTCNTFX EQU   PVT+1830
PVTDEFFX EQU   PVT+1828
PVTFIXOK EQU   PVT+1826
PVTPEROK EQU   PVT+1824
PVTMAXFX EQU   PVT+1822
PVTPERFX EQU   PVT+1820
PVTRESV5 EQU   PVT+1773
PVTSSRB  EQU   PVT+1768
PVTACA   EQU   PVTWSAX+1400
PVTWSA18 EQU   PVTWSAX+1256
PVTWSA16 EQU   PVTWSAX+1112
PVTWSA15 EQU   PVTWSAX+1040
PVTWSA14 EQU   PVTWSAX+968
PVTWSA12 EQU   PVTWSAX+824
PVTWSA11 EQU   PVTWSAX+752
PVTWSA10 EQU   PVTWSAX+672
PVTWSA9  EQU   PVTWSAX+592
PVTWSA8  EQU   PVTWSAX+504
PVTWSA7  EQU   PVTWSAX+432
PVTWSA6  EQU   PVTWSAX+360
PVTWSA5  EQU   PVTWSAX+288
PVTWSA4  EQU   PVTWSAX+216
PVTWSA3  EQU   PVTWSAX+144
PVTWSA2  EQU   PVTWSAX+72
PVTWSA1  EQU   PVTWSAX
PVTPFTQR EQU   PVTQS+20
PVTRSBQL EQU   PVTQS+18
PVTRSBQF EQU   PVTQS+16
PVTSQAQL EQU   PVTQS+14
PVTSQAQF EQU   PVTQS+12
PVTCFQL  EQU   PVTQS+10
PVTCFQF  EQU   PVTQS+8
PVTRSRVL EQU   PVTQS+6
PVTRSRVF EQU   PVTQS+4
PVTAFQL  EQU   PVTQS+2
PVTAFQF  EQU   PVTQS
PVTSPFR  EQU   PVT+302
PVTCFMCT EQU   PVT+300
PVTSPREC EQU   PVT+296
PVTCAREC EQU   PVT+292
PVTCAOUT EQU   PVT+288
PVTCAIN  EQU   PVT+284
PVTNSWPS EQU   PVT+280
PVTNPREC EQU   PVT+276
PVTSPOUT EQU   PVT+272
PVTSPIN  EQU   PVT+268
PVTVAMR  EQU   PVT+264
PVTVAMO  EQU   PVT+260
PVTVAMI  EQU   PVT+256
PVTNPOUT EQU   PVT+252
PVTNPIN  EQU   PVT+248
PVTPRSET EQU   PVT+244
PVTFRSLT EQU   PVT+240
PVTPAGIO EQU   PVT+236
PVTSWPIO EQU   PVT+232
PVTPSWPP EQU   PVT+228
PVTPPREF EQU   PVT+224
PVTPOPBR EQU   PVT+220
PVTPRELF EQU   PVT+216
PVTPRELV EQU   PVT+212
PVTPFREE EQU   PVT+208
PVTPRELS EQU   PVT+204
PVTPOUT  EQU   PVT+200
PVTPFXLD EQU   PVT+196
PVTPITAS EQU   PVT+192
PVTPDSEG EQU   PVT+184
PVTPCSGB EQU   PVT+180
PVTPCSEG EQU   PVT+176
PVTPINV  EQU   PVT+172
PVTPSWPC EQU   PVT+168
PVTPSOUT EQU   PVT+164
PVTPSWIN EQU   PVT+160
PVTPRCFI EQU   PVT+152
PVTPRCF  EQU   PVT+148
PVTPVRC  EQU   PVT+144
PVTPVRIN EQU   PVT+140
PVTPVRLS EQU   PVT+136
PVTPVEQR EQU   PVT+132
PVTPPIOI EQU   PVT+128
PVTPVRPO EQU   PVT+124
PVTPRFR  EQU   PVT+120
PVTPFP2  EQU   PVT+116
PVTPFP   EQU   PVT+112
PVTPFTE  EQU   PVT+108
PVTPCB   EQU   PVT+104
PVTREP2  EQU   PVT+100
PVTPIOP  EQU   PVT+92
PVTPGFA  EQU   PVT+84
PVTPSQA  EQU   PVT+80
PVTPSINT EQU   PVT+76
PVTPSIB  EQU   PVT+72
PVTPCIWA EQU   PVT+64
PVTHQSA  EQU   PVT+62
PVTLQSA  EQU   PVT+60
PVTOROOT EQU   PVT+56
PVTREUS  EQU   PVT+48
PVTSQNPC EQU   PVT+47
PVTSQVRC EQU   PVT+46
PVTRSUS  EQU   PVT+44
PVTVROOT EQU   PVT+40
PVTDFRS  EQU   PVT+34
PVTRSQA  EQU   PVT+32
PVTPTLB  EQU   PVT+31
PVTSQDC  EQU   PVT+28
PVTLCSA  EQU   PVT+26
PVTLPRIV EQU   PVT+24
PVTLVR   EQU   PVT+22
PVTFVR   EQU   PVT+20
PVTLPFN  EQU   PVT+18
PVTFPFN  EQU   PVT+16
PVTPFTP  EQU   PVT+12
PVTSSPIN EQU   PVT+11
PVTPOOL  EQU   PVT+8
PVTAFCOK EQU   PVT+6
PVTAFCLO EQU   PVT+4
PVTAFC   EQU   PVT+2
@NM00003 EQU   PVTFLAG2
PVTDUMP  EQU   PVTFLAG1
PVTSIT   EQU   PVTFLAG1
PVTLSI   EQU   PVTFLAG1
PVTAPREF EQU   PVTFLAG1
PVTPMSG  EQU   PVTFLAG1
CVTLEVL  EQU   CVTRELNO+2
CVTNUMB  EQU   CVTRELNO
CVTMDL   EQU   CVTFIX+250
@NM00002 EQU   CVTFIX+248
@NM00001 EQU   CVTFIX
CVTRV482 EQU   CVTXTNT2+128
CVTRV481 EQU   CVTXTNT2+124
CVTRV480 EQU   CVTXTNT2+120
CVTRV479 EQU   CVTXTNT2+118
CVTRV478 EQU   CVTXTNT2+117
CVTRV477 EQU   CVTXTNT2+116
CVTRV476 EQU   CVTXTNT2+115
CVTRV475 EQU   CVTXTNT2+114
CVTRV474 EQU   CVTRV466
CVTRV473 EQU   CVTRV466
CVTRV472 EQU   CVTRV466
CVTRV471 EQU   CVTRV466
CVTRV470 EQU   CVTRV466
CVTRV469 EQU   CVTRV466
CVTRV468 EQU   CVTRV466
CVTRV467 EQU   CVTRV466
CVTRV465 EQU   CVTRV457
CVTRV464 EQU   CVTRV457
CVTRV463 EQU   CVTRV457
CVTRV462 EQU   CVTRV457
CVTRV461 EQU   CVTRV457
CVTRV460 EQU   CVTRV457
CVTRV459 EQU   CVTRV457
CVTRV458 EQU   CVTRV457
CVTRV456 EQU   CVTXTNT2+108
CVTRV455 EQU   CVTXTNT2+104
CVTRV454 EQU   CVTXTNT2+100
CVTRV453 EQU   CVTXTNT2+96
CVTRV452 EQU   CVTXTNT2+94
CVTRV451 EQU   CVTXTNT2+92
CVTRV450 EQU   CVTXTNT2+90
CVTRV449 EQU   CVTXTNT2+88
CVTRV448 EQU   CVTXTNT2+87
CVTRV447 EQU   CVTXTNT2+86
CVTRV446 EQU   CVTRV438
CVTRV445 EQU   CVTRV438
CVTRV444 EQU   CVTRV438
CVTRV443 EQU   CVTRV438
CVTRV442 EQU   CVTRV438
CVTRV441 EQU   CVTRV438
CVTRV440 EQU   CVTRV438
CVTRV439 EQU   CVTRV438
CVTRV437 EQU   CVTRV429
CVTRV436 EQU   CVTRV429
CVTRV435 EQU   CVTRV429
CVTRV434 EQU   CVTRV429
CVTRV433 EQU   CVTRV429
CVTRV432 EQU   CVTRV429
CVTRV431 EQU   CVTRV429
CVTRV430 EQU   CVTRV429
CVTRV428 EQU   CVTXTNT2+80
CVTRV427 EQU   CVTXTNT2+76
CVTRV426 EQU   CVTXTNT2+72
CVTRV425 EQU   CVTXTNT2+68
CVTATACT EQU   CVTATCVT
CVTRV423 EQU   CVTXTNT2+62
CVTRV422 EQU   CVTXTNT2+60
CVTRV421 EQU   CVTXTNT2+58
CVTRV420 EQU   CVTXTNT2+56
CVTRV419 EQU   CVTXTNT2+55
CVTRV418 EQU   CVTXTNT2+54
CVTRV417 EQU   CVTRV409
CVTRV416 EQU   CVTRV409
CVTRV415 EQU   CVTRV409
CVTRV414 EQU   CVTRV409
CVTRV413 EQU   CVTRV409
CVTRV412 EQU   CVTRV409
CVTRV411 EQU   CVTRV409
CVTRV410 EQU   CVTRV409
CVTRV408 EQU   CVTRV400
CVTRV407 EQU   CVTRV400
CVTRV406 EQU   CVTRV400
CVTRV405 EQU   CVTRV400
CVTRV404 EQU   CVTRV400
CVTRV403 EQU   CVTRV400
CVTRV402 EQU   CVTRV400
CVTRV401 EQU   CVTRV400
CVTICB   EQU   CVTXTNT2+48
CVTSKTA  EQU   CVTXTNT2+44
CVTCCVT  EQU   CVTXTNT2+40
CVTRSV98 EQU   CVTXTNT2+36
CVTRSV97 EQU   CVTXTNT2+34
CVTRSV96 EQU   CVTXTNT2+32
CVTOLTEP EQU   CVTXTNT2+28
CVTQIDA  EQU   CVTQID+1
CVTRSV95 EQU   CVTQID
CVTRSV94 EQU   CVTXTNT2+20
CVTRSV93 EQU   CVTXTNT2+16
CVTRSV92 EQU   CVTXTNT2+12
CVTDEBVR EQU   CVTXTNT2+8
CVTRSV91 EQU   CVTXTNT2+6
CVTRSV9H EQU   CVTFLGBT
CVTRSV9G EQU   CVTFLGBT
CVTRSV9F EQU   CVTFLGBT
CVTRSV9E EQU   CVTFLGBT
CVTRSV9D EQU   CVTFLGBT
CVTBAH   EQU   CVTFLGBT
CVTVME   EQU   CVTFLGBT
CVTNPE   EQU   CVTFLGBT
CVTNUCLS EQU   CVTXTNT2+4
CVTDSSVA EQU   CVTDSSV+1
CVTRSV89 EQU   CVTDSSV
CVTRSV88 EQU   CVTXTNT1+8
CVTRSV87 EQU   CVTXTNT1+4
CVTFACHN EQU   CVTXTNT1
CVTRV488 EQU   CVTMAP+412
CVTRV487 EQU   CVTMAP+408
CVTRV486 EQU   CVTMAP+404
CVTRV485 EQU   CVTMAP+400
CVTACTAP EQU   CVTMAP+396
CVTAUTH  EQU   CVTMAP+392
CVTRV490 EQU   CVTMAP+388
CVTSU    EQU   CVTMAP+384
CVTVOLT1 EQU   CVTVOLM1+1
CVTVOLI1 EQU   CVTVOLF1
CVTSTOA  EQU   CVTMAP+376
CVTRSV58 EQU   CVTMAP+374
CVTRSV57 EQU   CVTMAP+372
CVTDDCE  EQU   CVTMAP+368
CVTPNWFR EQU   CVTMAP+364
CVTSMF   EQU   CVTMAP+360
CVTSULK  EQU   CVTMAP+358
CVTSLKO  EQU   CVTSYSK
CVTSLKP  EQU   CVTSYSK
CVTSLKQ  EQU   CVTSYSK
CVTSLKR  EQU   CVTSYSK
CVTRSV56 EQU   CVTSYSK
CVTRSV55 EQU   CVTSYSK
CVTRSV54 EQU   CVTSYSK
CVTRSV53 EQU   CVTSYSK
CVTRSV52 EQU   CVTA1F1
CVTRSV51 EQU   CVTA1F1
CVTRSV50 EQU   CVTA1F1
CVTRSV49 EQU   CVTA1F1
CVTRSV48 EQU   CVTA1F1
CVTRSV47 EQU   CVTA1F1
CVTSRSW  EQU   CVTA1F1
CVTPFSW  EQU   CVTA1F1
CVTPCVT  EQU   CVTMAP+352
CVTRSV46 EQU   CVTMAP+344
CVTRSV45 EQU   CVTMAP+340
CVTRSV44 EQU   CVTMAP+338
CVTRSV43 EQU   CVTMAP+336
CVTHJESA EQU   CVTHJES+1
CVTRSV42 EQU   CVTHJES
CVTEXT2A EQU   CVTEXT2+1
CVTRSV41 EQU   CVTEXT2
CVTAPFA  EQU   CVTAPF+1
CVTRSV40 EQU   CVTAPF
CVTRV518 EQU   CVTINTLA
CVTRV517 EQU   CVTERPV
CVTEORM  EQU   CVTMAP+312
CVTMCHPR EQU   CVTMAP+308
CVTTZ    EQU   CVTMAP+304
CVTJEPS  EQU   CVTMAP+300
CVTJESCT EQU   CVTMAP+296
CVTMODE  EQU   CVTMAP+292
CVTPTRV  EQU   CVTMAP+288
CVTREAL  EQU   CVTMAP+284
CVTRSV39 EQU   CVTMAP+280
CVTRSV38 EQU   CVTMAP+276
CVTDMSRA EQU   CVTDMSR+1
CVTRV634 EQU   CVTDMSRF
CVTRV633 EQU   CVTDMSRF
CVTRV632 EQU   CVTDMSRF
CVTRV631 EQU   CVTDMSRF
CVTRV630 EQU   CVTDMSRF
CVTRV629 EQU   CVTDMSRF
CVTUDUMP EQU   CVTDMSRF
CVTSDUMP EQU   CVTDMSRF
CVTQMSGA EQU   CVTQMSG+1
CVTRSV36 EQU   CVTQMSG
CVTAMFF  EQU   CVTMAP+264
CVTPURGA EQU   CVTPURG+1
CVTRSV35 EQU   CVTPURG
CVTCBSP  EQU   CVTMAP+256
CVTATERA EQU   CVTATER+1
CVTSYST  EQU   CVTATER
CVTVOLT2 EQU   CVTTAT
CVTVOLI2 EQU   CVTVOLF2
CVTAQAVB EQU   CVTAQAVT+1
CVTRSV34 EQU   CVTTCMFG
CVTRSV33 EQU   CVTTCMFG
CVTRSV32 EQU   CVTTCMFG
CVTRSV31 EQU   CVTTCMFG
CVTRSV30 EQU   CVTTCMFG
CVTRSV29 EQU   CVTTCMFG
CVTLDEV  EQU   CVTTCMFG
CVTTCRDY EQU   CVTTCMFG
CVTGTFA  EQU   CVTGTF+1
CVTRSV27 EQU   CVTGTFST
CVTRNIO  EQU   CVTGTFST
CVTUSR   EQU   CVTGTFST
CVTRV318 EQU   CVTFORM
CVTRV317 EQU   CVTTMODE
CVTRV316 EQU   CVTSTATE
CVTRV315 EQU   CVTGTFS
CVTGTFAV EQU   CVTGTFS
CVT0SCR1 EQU   CVTMAP+232
CVTRV515 EQU   CVTMAP+228
CVTRMS   EQU   CVTMAP+224
CVTPATCH EQU   CVTMAP+220
CVTTSCE  EQU   CVTMAP+216
CVTLNKSC EQU   CVTMAP+214
CVTQABST EQU   CVTMAP+212
CVTMDLDS EQU   CVTMAP+208
CVTUSER  EQU   CVTMAP+204
CVTABEND EQU   CVTMAP+200
CVTSMCA  EQU   CVTMAP+196
CVTRSV18 EQU   CVTMAP+192
CVTQLPAQ EQU   CVTMAP+188
CVTQCDSR EQU   CVTMAP+184
CVTVS1B  EQU   CVTOPTB
CVTVS1A  EQU   CVTOPTB
CVTFP    EQU   CVTOPTB
CVTAPTHR EQU   CVTOPTB
CVTNLOG  EQU   CVTOPTB
CVTTOD   EQU   CVTOPTB
CVTCTIMS EQU   CVTOPTB
CVTPROT  EQU   CVTOPTB
CVTXPFP  EQU   CVTOPTA
CVTASCII EQU   CVTOPTA
CVTRSV13 EQU   CVTOPTA
CVTRSV12 EQU   CVTOPTA
CVTNIP   EQU   CVTOPTA
CVTDDR   EQU   CVTOPTA
CVTAPR   EQU   CVTOPTA
CVTCCH   EQU   CVTOPTA
CVTSNCTR EQU   CVTMAP+180
CVTQMWR  EQU   CVTMAP+176
CVTQOCR  EQU   CVTMAP+172
CVT1EF00 EQU   CVTMAP+168
CVTMZ00  EQU   CVTMAP+164
CVTSV76Q EQU   CVTSV76C
CVTRSV11 EQU   CVTMAP+156
CVT0PT01 EQU   CVTMAP+152
CVTMSER  EQU   CVTMAP+148
CVTRV516 EQU   CVTIERLC
CVTILCH  EQU   CVTMAP+140
CVT0DS   EQU   CVTMAP+136
CVTFBOSV EQU   CVTMAP+132
CVTNUCB  EQU   CVTMAP+128
CVTIXAVL EQU   CVTMAP+124
CVTSV76M EQU   CVTIOQET
CVTDCBA  EQU   CVTMAP+117
CVTMVS2  EQU   CVTDCB
CVT6DAT  EQU   CVTDCB
CVT4MPS  EQU   CVTDCB
CVTRSV09 EQU   CVTDCB
CVT4MS1  EQU   CVTDCB
CVT2SPS  EQU   CVTDCB
CVT1SSS  EQU   CVTDCB
CVTRSV08 EQU   CVTDCB
CVTSTB   EQU   CVTMAP+112
CVTQTD00 EQU   CVTMAP+108
CVTQTE00 EQU   CVTMAP+104
CVTCUCB  EQU   CVTMAP+100
CVTSJQ   EQU   CVTMAP+96
CVTPBLDL EQU   CVTMAP+92
CVTTPC   EQU   CVTMAP+88
CVTSVDCB EQU   CVTMAP+84
CVTBRET  EQU   CVTMAP+82
CVTEXIT  EQU   CVTMAP+80
CVT0FN00 EQU   CVTMAP+76
CVTDARA  EQU   CVTDAR+1
CVTRSV07 EQU   CVTFLGS1
CVTRSV06 EQU   CVTFLGS1
CVTRSV05 EQU   CVTFLGS1
CVTRSV04 EQU   CVTFLGS1
CVTRSV03 EQU   CVTFLGS1
CVTRSV02 EQU   CVTFLGS1
CVTRSV01 EQU   CVTFLGS1
CVTDMPLK EQU   CVTFLGS1
CVTXITP  EQU   CVTMAP+68
CVTZDTAB EQU   CVTMAP+64
CVTMSLT  EQU   CVTMAP+60
CVTDATE  EQU   CVTMAP+56
CVTBTERM EQU   CVTMAP+52
CVTSYSAD EQU   CVTMAP+48
CVTXTLER EQU   CVTMAP+44
CVTILK2  EQU   CVTMAP+40
CVTILK1  EQU   CVTMAP+36
CVTPRLTV EQU   CVTMAP+32
CVTPCNVT EQU   CVTMAP+28
CVT0VL00 EQU   CVTMAP+24
CVTXAPG  EQU   CVTMAP+20
CVTBUF   EQU   CVTMAP+16
CVTJOB   EQU   CVTMAP+12
CVTLINK  EQU   CVTMAP+8
CVT0EF00 EQU   CVTMAP+4
CVTTCBP  EQU   CVTMAP
CVT      EQU   CVTMAP
@NM00035 EQU   PSA+3668
PSASTAK  EQU   PSA+3072
@NM00034 EQU   PSA+1048
PSAUSEND EQU   PSA+1048
PSARV062 EQU   PSA+1044
PSACDAL  EQU   PSA+1040
PSAWTCOD EQU   PSA+1036
PSAATCVT EQU   PSA+1032
PSAPCPSW EQU   PSA+1024
PSAPIR2  EQU   PSA+1020
PSARV059 EQU   PSA+1018
PSASVC13 EQU   PSA+1016
PSALSFCC EQU   PSA+1012
PSASFACC EQU   PSA+1008
PSASTOP  EQU   PSA+992
PSASTART EQU   PSA+976
PSARSPSW EQU   PSA+968
PSASRPSW EQU   PSA+960
PSARV045 EQU   PSA+892
PSARV044 EQU   PSA+888
PSARV043 EQU   PSA+884
PSARV042 EQU   PSA+880
PSARV041 EQU   PSA+876
PSARV040 EQU   PSA+872
PSARV025 EQU   PSA+868
PSADSSED EQU   PSA+868
PSADSSPR EQU   PSA+864
PSADSSFW EQU   PSA+860
PSADSS14 EQU   PSA+856
PSADSSPP EQU   PSA+848
PSADSSRP EQU   PSA+840
PSADSS05 EQU   PSADSSF4
PSADSS10 EQU   PSADSSF4
PSADSSVE EQU   PSADSSF4
PSADSSDE EQU   PSADSSF4
PSADSSC0 EQU   PSADSSF4
PSADSSIE EQU   PSADSSF4
PSADSS12 EQU   PSADSSF4
PSADSSRC EQU   PSADSSF4
PSARV057 EQU   PSADSSF3
PSARV056 EQU   PSADSSF3
PSARV055 EQU   PSADSSF3
PSADSSMC EQU   PSADSSF3
PSADSSRW EQU   PSADSSF3
PSADSSNM EQU   PSADSSF3
PSADSSES EQU   PSADSSF3
PSADSSGP EQU   PSADSSF3
PSADSSF2 EQU   PSADSSFL+1
PSADSSPI EQU   PSADSSF1
PSADSSOI EQU   PSADSSF1
PSADSSSP EQU   PSADSSF1
PSADSSTP EQU   PSADSSF1
PSADSSDW EQU   PSADSSF1
PSADSSDD EQU   PSADSSF1
PSADSSDM EQU   PSADSSF1
PSADSSMV EQU   PSADSSF1
PSADSSTS EQU   PSA+816
PSADSSWK EQU   PSA+812
PSADSSR3 EQU   PSA+808
PSADSSR2 EQU   PSA+804
PSADSSRS EQU   PSA+800
PSASTOR  EQU   PSA+796
PSACPUSA EQU   PSA+794
PSAVSTAP EQU   PSA+792
PSAWKVAP EQU   PSA+788
PSAWKRAP EQU   PSA+784
PSAMCHIC EQU   PSA+783
PSARV061 EQU   PSA+782
PSASYMSK EQU   PSA+781
PSAMCHFL EQU   PSA+780
PSACR0   EQU   PSA+776
PSAPSWSV EQU   PSA+768
PSACLHS  EQU   PSAHLHI
PSALKR15 EQU   PSALKSA+60
PSALKR14 EQU   PSALKSA+56
PSALKR13 EQU   PSALKSA+52
PSALKR12 EQU   PSALKSA+48
PSALKR11 EQU   PSALKSA+44
PSALKR10 EQU   PSALKSA+40
PSALKR9  EQU   PSALKSA+36
PSALKR8  EQU   PSALKSA+32
PSALKR7  EQU   PSALKSA+28
PSALKR6  EQU   PSALKSA+24
PSALKR5  EQU   PSALKSA+20
PSALKR4  EQU   PSALKSA+16
PSALKR3  EQU   PSALKSA+12
PSALKR2  EQU   PSALKSA+8
PSALKR1  EQU   PSALKSA+4
PSALKR0  EQU   PSALKSA
PSARV023 EQU   PSACLHT+52
PSALOCAL EQU   PSACLHT+48
PSACMSL  EQU   PSACLHT+44
PSAOPTL  EQU   PSACLHT+40
PSATPACL EQU   PSACLHT+36
PSATPDNL EQU   PSACLHT+32
PSATPNCL EQU   PSACLHT+28
PSAIOSLL EQU   PSACLHT+24
PSAIOSUL EQU   PSACLHT+20
PSAIOSCL EQU   PSACLHT+16
PSAIOSSL EQU   PSACLHT+12
PSASALCL EQU   PSACLHT+8
PSAASML  EQU   PSACLHT+4
PSADISPL EQU   PSACLHT
PSASRSA  EQU   PSA+636
PSARV050 EQU   PSA+634
PSADSSGO EQU   PSA+633
PSARECUR EQU   PSA+632
PSAHLHIS EQU   PSA+628
PSAIPCSA EQU   PSA+624
@NM00033 EQU   PSA+621
PSAIPCDM EQU   PSA+620
PSAIPCD  EQU   PSA+616
@NM00032 EQU   PSA+613
PSAIPCRM EQU   PSA+612
PSAIPCR  EQU   PSA+608
PSAMCHEX EQU   PSA+600
PSAMPSW  EQU   PSA+592
PSAEXPS2 EQU   PSA+584
PSAEXPS1 EQU   PSA+576
PSAPIREG EQU   PSA+572
PSARSREG EQU   PSA+568
PSAGPREG EQU   PSA+556
PSARV022 EQU   PSASUP4
PSARV021 EQU   PSASUP4
PSARV020 EQU   PSASUP4
PSARV019 EQU   PSASUP4
PSARV018 EQU   PSASUP4
PSARV017 EQU   PSASUP4
PSARV016 EQU   PSASUP4
PSARV015 EQU   PSASUP4
PSARV014 EQU   PSASUP3
PSAULCMS EQU   PSASUP3
PSARV012 EQU   PSASUP3
PSAESTA  EQU   PSASUP3
PSASPR   EQU   PSASUP3
PSAPSREG EQU   PSASUP3
PSAPI2   EQU   PSASUP3
PSAIOSUP EQU   PSASUP3
PSALCR   EQU   PSASUP2
PSARTM   EQU   PSASUP2
PSAACR   EQU   PSASUP2
PSAIPCE2 EQU   PSASUP2
PSAIPCES EQU   PSASUP2
PSAIPCEC EQU   PSASUP2
PSAGTF   EQU   PSASUP2
PSAIPCRI EQU   PSASUP2
PSATYPE6 EQU   PSASUP1
PSATCTL  EQU   PSASUP1
PSADISP  EQU   PSASUP1
PSALOCK  EQU   PSASUP1
PSAPI    EQU   PSASUP1
PSAEXT   EQU   PSASUP1
PSASVC   EQU   PSASUP1
PSAIO    EQU   PSASUP1
PSAAOLD  EQU   PSA+548
PSAANEW  EQU   PSA+544
PSATOLD  EQU   PSA+540
PSATNEW  EQU   PSA+536
PSALCCAR EQU   PSA+532
PSALCCAV EQU   PSA+528
PSAPCCAR EQU   PSA+524
PSAPCCAV EQU   PSA+520
PSACPULA EQU   PSA+518
PSACPUPA EQU   PSA+516
PSAPSA   EQU   PSA+512
FLCHDEND EQU   PSA+512
FLCCRSAV EQU   FLCMCLA+280
FLCGRSAV EQU   FLCMCLA+216
FLCFPSAV EQU   FLCMCLA+184
FLCFLA   EQU   FLCMCLA+88
FLCRGNCD EQU   FLCMCLA+84
FLCFSAA  EQU   FLCFSA+1
@NM00031 EQU   FLCFSA
@NM00030 EQU   FLCMCLA+72
FLCMCIC  EQU   FLCMCLA+64
@NM00029 EQU   FLCMCLA+20
FLCIOAA  EQU   FLCIOA+1
@NM00028 EQU   FLCIOA
@NM00027 EQU   FLCMCLA+15
@NM00026 EQU   FLCMCLA+14
@NM00025 EQU   FLCMCLA+12
FLCLCL   EQU   FLCMCLA+8
FLCIOELA EQU   FLCIOEL+1
@NM00024 EQU   FLCIOEL
FLCCHNID EQU   FLCMCLA
@NM00023 EQU   PSA+160
FLCMTRCD EQU   PSA+157
@NM00022 EQU   PSA+156
FLCPERA  EQU   FLCPER+1
@NM00021 EQU   FLCPER
@NM00020 EQU   PSA+151
FLCPERCD EQU   PSA+150
FLCMCNUM EQU   PSA+149
@NM00019 EQU   PSA+148
FLCTEAA  EQU   FLCTEA+1
@NM00018 EQU   FLCTEA
PSAPIPC  EQU   PSAPICOD
PSAPIMC  EQU   PSAPICOD
PSAPIPER EQU   PSAPICOD
PSARV049 EQU   FLCPICOD
FLCPILCB EQU   FLCPIILC
@NM00017 EQU   FLCPIILC
@NM00016 EQU   PSAEPPSW
FLCSVCN  EQU   PSAESPSW+2
FLCSILCB EQU   FLCSVILC
@NM00015 EQU   FLCSVILC
@NM00014 EQU   PSAESPSW
FLCEICOD EQU   PSAEEPSW+2
PSASPAD  EQU   PSAEEPSW
@NM00013 EQU   PSA+128
FLCINPSW EQU   PSA+120
FLCMNPSW EQU   PSA+112
FLCPNPSW EQU   PSA+104
FLCSNPSW EQU   PSA+96
FLCENPSW EQU   PSA+88
FLCTRACE EQU   PSA+84
FLCTIMER EQU   PSA+80
FLCCVT2  EQU   PSA+76
FLCCAW   EQU   PSA+72
FLCCSW   EQU   PSA+64
FLCIOPSW EQU   PSA+56
FLCMOPSW EQU   PSA+48
FLCPOPSW EQU   PSA+40
FLCSOPSW EQU   PSA+32
FLCEOPSW EQU   PSA+24
@NM00012 EQU   FLCICCW2+4
FLCICCW1 EQU   FLCROPSW
FLCIPPSW EQU   FLCRNPSW
*                                      END UNREFERENCED COMPONENTS
@RC00116 EQU   @RC00112
@RT00161 EQU   MGRRTNCD
@RF00163 EQU   MGRRTNCD
@RT00175 EQU   MGRBLD2
@RT00374 EQU   CHKBITS
@RF00374 EQU   NXTMEMRY
@ENDDATA EQU   *
         END   IEAVPCB,(C'PLS1318',0701,78164)
