         TITLE 'IEAVPIOI: SWAP-OUT INITIATOR                           *
                        '
IEAVPIOI CSECT
         USING *,R15
         MODID
         DROP R15
         BALR  BASEREG,R0          GET BASE REG VALUE
BASE1    DS   0H
         USING BASE1,BASEREG
*   SRBPTR=R0;                      /* SAVE REG 0 (PTR TO SRB)       */
         LR    SRBPTR,R0                                           0076
*   SOUTPPTR=R1;                    /* INITIALIZE POINTER TO SWAPOUT
*                                      PARAMETER LIST                */
         LR    SOUTPPTR,R1                                         0077
*   PVTPTR=CVTPVTP;                 /* GET THE ADDRESS OF THE PVT    */
         L     @12,CVTPTR                                          0078
         L     PVTPTR,CVTPVTP(,@12)                                0078
*   R0=PVTPRCV;                     /* GET ENTRY POINT ADDRESS FOR 0079
*                                      THE RECOVERY MODULE           */
         L     R0,PVTPRCV(,PVTPTR)                                 0079
*                                                                  0080
*/********************************************************************/
*/*                   ESTABLISH THE RSM FRR (SETFRR)                 */
*/*   INPUT:                                                         */
*/*    REG 0: RSM FRR ENTRY POINT                                    */
*/*    REG 1-REG 15: UNUSED                                          */
*/*   OUTPUT:                                                        */
*/*    REG 1-REG 2: UNPREDICTABLE                                    */
*/*    REG 7:   RSM RCA ADDRESS                                      */
*/*    THE OTHER 13 REGISTERS UNUSED.                                */
*/*    RSM FRR ESTABLISHED.                                          */
*/********************************************************************/
*                                                                  0080
*   RESPECIFY                                                      0080
*    (R2) RESTRICTED;                                              0080
*   GENERATE CODE REFS(PSACSTK,FRRS,FRRSCURR,FRRSLAST,FRRSELEN,FRRSFRRA
*       ,FRRSENTR,PVTPRCV,PVTPTR,FRRSPARM,PSALSFCC) SETS(R1,R2,RCAPTR);
        SETFRR A,FRRAD=(R0),PARMAD=(RCAPTR),WRKREGS=(R1,R2)  SET FRR
*   RCACSECT=RCACINIO;              /* SET IEAVPIOI CSECT FLAG IN RCA*/
         MVI   RCACSECT(RCAPTR),X'03'                              0082
*   RCAPIOI='1'B;                   /* SET RCA MODULE ENTERED FLAG   */
         OI    RCAPIOI(RCAPTR),B'10000000'                         0083
*   RESPECIFY                                                      0084
*    (ASCBPTR) RSTD;                                               0084
*   ASCBPTR=SRBASCB;                /* GET MASTER'S ASCB ADDRESS     */
         L     ASCBPTR,SRBASCB(,SRBPTR)                            0085
*   PCBPTR=LSQAPCBS;                /* INITIALIZE POINTER TO LSQA  0086
*                                      PCBS                          */
         L     PCBPTR,LSQAPCBS-1(,SOUTPPTR)                        0086
         LA    PCBPTR,0(,PCBPTR)                                   0086
*                                                                  0087
*/********************************************************************/
*/*                   OBTAIN LOCAL LOCK   (SETLOCK)                  */
*/*  INPUT:  REG 0-REG 10: UNUSED                                    */
*/*          REG 11-REG13: REGISTERS USED BY SETLOCK                 */
*/*          REG 14: RETURN ADDRESS                                  */
*/*          REG 15: UNUSED.                                         */
*/*  OUTPUT: REG 0-REG 10: RESTORED                                  */
*/*          REG 11-REG 12: UNPREDICTABLE                            */
*/*          REG 13: RETURN CODE                                     */
*/*               0: NORMAL RETURN                                   */
*/*               4: CALLER HOLDS LOCK                               */
*/*              12: INVALID REQUEST                                 */
*/*              20: UNABLE TO COMPLETE                              */
*/*          REG 14-REG 15: RESTORED                                 */
*/*          LOCAL LOCK OBTAINED                                     */
*/********************************************************************/
*                                                                  0087
*   RESPECIFY                                                      0087
*    (R11,                                                         0087
*     R12,                                                         0087
*     R13,                                                         0087
*     R14) RESTRICTED;                                             0087
*   GENERATE CODE REFS(PSALITA,FLC,R13) SETS(R11,R12,R13,R14);     0088
GETLLK   SETLOCK OBTAIN,TYPE=LOCAL,MODE=UNCOND,                       **
               RELATED=(LOCAL,IEAVPIOI(FRELLK1))
*   RCALL='1'B;                     /* SET RCA FLAG FOR LOCAL LOCK 0089
*                                      HELD                          */
         OI    RCALL(RCAPTR),B'01000000'                           0089
*   RESPECIFY                                                      0090
*    (R11,                                                         0090
*     R12,                                                         0090
*     R13,                                                         0090
*     R14) UNRESTRICTED;                                           0090
*   IF SOUTINT='1'B|LSQAPCBS->PCBASCB->ASCBTERM='1'B|LSQAPCBS->PCBASCB
*       ->ASCBABNT='1'B THEN        /* IF SWAPOUT HAS BEEN         0091
*                                      INTERCEPTED BY IEAVTERM OR THE
*                                      ADDRESS SPACE HAS TERMINATED
*                                      (NORMALLY OR ABNORMALLY), FREE
*                                      FRAMES AND PCBS               */
         TM    SOUTINT(SOUTPPTR),B'10000000'                       0091
         BO    @RT00091                                            0091
         L     @12,LSQAPCBS-1(,SOUTPPTR)                           0091
         L     @12,PCBASCB(,@12)                                   0091
         TM    ASCBTERM(@12),B'00011000'                           0091
         BZ    @RF00091                                            0091
@RT00091 DS    0H                                                  0092
*     DO;                           /* SWAPOUT HAS BEEN TERMINATED   */
*TERM:                              /* ENTER HERE WHEN ASCBCHAP FAILS
*                                      AND ASCB IS INVALID           */
*/********************************************************************/
*/*                 OBTAIN SALLOC LOCK  (SETLOCK)                    */
*/*  INPUT:  REG 0-REG 10: UNUSED                                    */
*/*          REG 11-REG 13: REGISTERS USED BY SETLOCK                */
*/*          REG 14: RETURN ADDRESS                                  */
*/*          REG 15: UNUSED                                          */
*/*  OUTPUT: REG 0-REG 10: RESTORED                                  */
*/*          REG 11-REG 12: UNPREDICTABLE                            */
*/*          REG 13: RETURN CODE                                     */
*/*            0: NORMAL RETURN                                      */
*/*            4: CALLER HOLD LOCK OR LOCK NOT OWNED                 */
*/*          REG 14-REG 15: RESTORED                                 */
*/*          SALLOC LOCK OBTAINED AND LOCAL LOCK RELEASED            */
*/********************************************************************/
*                                                                  0093
*       GENERATE CODE REFS(PSALITA,FLC,R13) SETS(R11,R12,R13,R14); 0093
TERM     DS    0H                                                  0093
GETSLK2  SETLOCK OBTAIN,TYPE=SALLOC,MODE=UNCOND,                      **
               RELATED=(SALLOC,IEAVPIOI(FREELOCK))
*       RCASAL='1'B;                /* SET SALLOC OBTAINED FLAG      */
         OI    RCASAL(RCAPTR),B'10000000'                          0094
*       RESPECIFY                                                  0095
*        (R11,                                                     0095
*         R12,                                                     0095
*         R14) UNRESTRICTED;                                       0095
*                                                                  0096
*/********************************************************************/
*/*                  TO PTLB ALL CPUS    (IEAVINV)                   */
*/*  INPUT:  REG 0: UNUSED                                           */
*/*          REG 1: 0                                                */
*/*          REG 2: UNUSED                                           */
*/*          REG 3: PVTPTR                                           */
*/*          REG 4-REG 13: UNUSED                                    */
*/*          REG 14: RETURN ADDRESS                                  */
*/*          REG 15: ENTRY POINT                                     */
*/*  OUTPUT: REG 0-REG 15: RESTORED                                  */
*/*          ALL CPUS PTLBED                                         */
*/********************************************************************/
*                                                                  0096
*       RSMHDPTR=PCBASCB->ASCBRSM;  /* OBTAIN PTR TO SWAPOUT RSMHDR  */
         L     @12,PCBASCB(,PCBPTR)                                0096
         L     RSMHDPTR,ASCBRSM(,@12)                              0096
*       R1=0;                       /* SET TO DO PTLB'S ONLY         */
         SLR   R1,R1                                               0097
*       CALL IEAVINV;               /* CALL IEAVINV TO ISSUE PTLB    */
         L     @15,PVTPINV(,PVTPTR)                                0098
         BALR  @14,@15                                             0098
*       RESPECIFY                                                  0099
*        (PCBPTR,                                                  0099
*         PFTEPTR) RESTRICTED;                                     0099
*       PCBPTR=LSQAPCBS;            /* OBTAIN PTR TO FIRST LSQA PCB  */
         L     PCBPTR,LSQAPCBS-1(,SOUTPPTR)                        0100
         LA    PCBPTR,0(,PCBPTR)                                   0100
*       DO WHILE PCBPTR^=0&AIALSQA='1'B;/* FREE LSQA PCBS/FRAMES     */
         B     @DE00101                                            0101
@DL00101 DS    0H                                                  0102
*         PFTEPTR=PVTPFTP+PCBRBN;   /* CALCULATE PFTE ADDRESS        */
         LH    @11,PCBRBN(,PCBPTR)                                 0102
         N     @11,@CF01913                                        0102
         L     PFTEPTR,PVTPFTP(,PVTPTR)                            0102
         ALR   PFTEPTR,@11                                         0102
*         PFTPCBSI='0'B;            /* TURN OFF PCB DEFINED          */
         NI    PFTPCBSI(PFTEPTR),B'11110111'                       0103
*         IF SOUTINT='1'B THEN      /* IF SWAPOUT HAS BEEN         0104
*                                      INTERCEPTED, THEN FREE THE  0104
*                                      PFTES                         */
         TM    SOUTINT(SOUTPPTR),B'10000000'                       0104
         BNO   @RF00104                                            0104
*           DO;                     /* SWAPOUT IS INTERCEPTED        */
*             R1=PCBASCB;           /* SET PTR TO SWAPOUT ASCB       */
         L     R1,PCBASCB(,PCBPTR)                                 0106
*             R0=PCBRBN;            /* SET RBN                       */
         LR    R0,@11                                              0107
*             R0=R0|PFTECON2;       /* INDICATE TO IEAVPFTE THAT   0108
*                                      FRAME SHOULD BE PLACED ON   0108
*                                      FRONT OF THE AFQ              */
         O     R0,@CF01876                                         0108
*             CALL IEAVPFTE;        /* SEND UNQUEUED FRAME TO THE  0109
*                                      AFQ. NOTE THAT              0109
*                                      RSMCNTFX/PVTCNTFX HAVE      0109
*                                      PREVIOUSLY BEEN DECREMENTED BY
*                                      IEAVDLAS                      */
         L     @15,PVTPFTE(,PVTPTR)                                0109
         BALR  @14,@15                                             0109
*           END;                    /* END OF FREE PFTES             */
*         ELSE                                                     0111
*           ;                       /* EITHER CASE FREE THE LSQA PCBS*/
@RF00104 DS    0H                                                  0112
*         R0=PCBFREQN;              /* SET THE FREE QUEUE ID         */
         LA    R0,16                                               0112
*         R1=PCBPTR;                /* SET PTR TO PCB TO BE FREED    */
         LR    R1,PCBPTR                                           0113
*         PCBPTR=PCBFQPA;           /* POINT TO NEXT LSQA PCB        */
         L     @11,PCBFQPA-1(,PCBPTR)                              0114
         LA    @11,0(,@11)                                         0114
         LR    PCBPTR,@11                                          0114
*         CALL IEAVPCB;             /* FREE THE CURRENT PCB          */
         L     @15,PVTPCB(,PVTPTR)                                 0115
         BALR  @14,@15                                             0115
*       END;                        /* END OF FREE LSQA PCBS/PFTES 0116
*                                      LOOP                          */
@DE00101 LTR   PCBPTR,PCBPTR                                       0116
         BZ    @DC00101                                            0116
         TM    AIALSQA(PCBPTR),B'00001000'                         0116
         BO    @DL00101                                            0116
@DC00101 DS    0H                                                  0117
*       R1=SOUTPPTR;                /* SET PTR TO FREE SWAPOUT     0117
*                                      PARMLST                       */
         LR    R1,SOUTPPTR                                         0117
*       R0=PCBFREQN;                /* SET TQN TO FREE QUEUE         */
         LA    R0,16                                               0118
*       CALL IEAVPCB;               /* FREE THE SWAPOUT PARAMETER  0119
*                                      LIST                          */
         L     @15,PVTPCB(,PVTPTR)                                 0119
         BALR  @14,@15                                             0119
*     END;                          /* END OF INTERCEPT PROCESSING   */
*   ELSE                            /* SWAPOUT IS NOT INTERCEPTED,   */
*     DO;                           /* DELETE THE ASCB FROM THE    0121
*                                      DISPATCHING QUEUE AND CALL ASM
*                                      TO START THE I/O FOR THE LSQA
*                                      PAGES                         */
         B     @RC00091                                            0121
@RF00091 DS    0H                                                  0122
*       RCAPARM0=LSQAPCBS;          /* SAVE INPUT IN CASE OF ABEND   */
         L     @11,LSQAPCBS-1(,SOUTPPTR)                           0122
         LA    @11,0(,@11)                                         0122
         ST    @11,RCAPARM0(,RCAPTR)                               0122
*       RCAPARM1=LSQAPCBS->PCBASCB->ASCBASID;/* GET THE ASID IN CASE
*                                      OF MEMTERM                    */
         L     @11,PCBASCB(,@11)                                   0123
         LH    @11,ASCBASID(,@11)                                  0123
         N     @11,@CF01913                                        0123
         ST    @11,RCAPARM1(,RCAPTR)                               0123
*       RCARETAD=ADDR(PIOIRTRY);    /* GET RETRY ADDRESS             */
*                                                                  0124
         LA    @11,PIOIRTRY                                        0124
         ST    @11,RCARETAD(,RCAPTR)                               0124
*       /*************************************************************/
*       /*                                                           */
*       /* NOTE THE FOLLOWING DEPENDENCY IN IEAVPIOI - IEAVTERM      */
*       /* RETAINS THE LOCAL LOCK UNTIL IEAVDLAS RUNS. IEAVTERM SETS */
*       /* SOUTINT HOLDING THE LOCAL LOCK. IEAVDLAS HOLDS THE SALLOC */
*       /* WHEN MOVING PFTE'S AND PCB'S TO MASTERS ADDRESS SPACE.    */
*       /* THEREFORE IEAVPIOI MUST HOLD THE LOCAL LOCK WHEN TESTING  */
*       /* SOUTINT AND WHEN OBTAINING THE ASCB ADDRESS FROM THE LSQA */
*       /* PCBS. THUS, WHEN SOUT=1, IEAVDLAS MAY OR MAY NOT HAVE RUN,*/
*       /* BUT IT MAKES NO DIFFERENCE. IF SOUTINT=1, THEN RCARETAD=0;*/
*       /* ALSO THE SALLOC IS OBTAINED BEFORE FREEING THE PCBS AND   */
*       /* FRAMES FROM EITHER MASTER OR THE SWAPOUT ADDRESS SPACE. IF*/
*       /* SOUTINT=0, THE VTERM/DLAS HAVE NOT RUN SO THE LOCAL LOCK  */
*       /* IS ACCEPTABLE SERIALIZATION FOR THE PCBASCB               */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0125
*/********************************************************************/
*/*        ASCBCHAP: TO STOP THE PROCESSING FOR AN ADDRESS SPACE.    */
*/*  INPUT:                                                          */
*/*     REG 0: ENTRY CODE LOADED BY MACRO                            */
*/*     REG 1: ADDRESS OF ASCB TO BE DELETED                         */
*/*     REG 2-REG 12: UNUSED                                         */
*/*     REG 13: SAVEAREA ADDRESS                                     */
*/*     REG 14: RETURN ADDRESS                                       */
*/*     REG 15: ENTRY POINT                                          */
*/*  OUTPUT:                                                         */
*/*     REG 0-REG 14: RESTORED                                       */
*/*     REG 15: RETURN CODE:  0 - ASCB FOUND AND REMOVED FROM        */
*/*                               DISPATCHING QUEUE                  */
*/*                           4 - ASCB NOT FOUND ON QUEUE            */
*/********************************************************************/
*                                                                  0125
*       RESPECIFY                                                  0125
*        (R13,                                                     0125
*         R15) RESTRICTED;                                         0125
*       R1=PCBASCB;                 /* GET ASCB OF SWAPPED-OUT AS. TO
*                                      DO THE ASCBCHAP (DELETES THE
*                                      A.S. FROM DISPATCHING QUEUE)  */
         L     R1,PCBASCB(,PCBPTR)                                 0126
*       R13=WSALACHP;               /* GET ADDRESS OF LOCAL SAVE AREA*/
         L     @14,ASXBPTR(,ASCBPTR)                               0127
         L     @14,ASXBSPSA(,@14)                                  0127
         L     R13,WSALACHP(,@14)                                  0127
*       GENERATE NODEFS             /* ISSUE ASCBCHAP FOR SWAPPED-OUT
*                                      ADDRESS SPACE                 */
*           REFS(CVTPTR,CVTVEAC0,CVTMAP) NOSETS NOFLOWS;           0128
           ASCBCHAP DELETE           ASCBCHAP FOR SWAPPED-OUT A.S.
*                                                                  0129
*/********************************************************************/
*/*  IF RETURN CODE IS NON-ZERO, THE ASCB COULD NOT BE FOUND ON THE  */
*/* DISPATCHING QUEUE AND IEAVSWPC WILL BE CALLED TO FREE THE        */
*/* PCBS.                                                            */
*/*  IF RETURN CODE IS 0, THE ASCB WAS FOUND ON THE DISPATCHING QUEUE*/
*/* AND WAS DEQUEUED. IEAVPIOI PROCESSING CONTINUES.                 */
*/********************************************************************/
*                                                                  0129
*       IF R15^=0 THEN              /* TEST IF R.C. IS GOOD          */
         LTR   R15,R15                                             0129
         BZ    @RF00129                                            0129
*         DO;                       /* R.C. IS BAD. ISSUE ABEND      */
*           RCARCRD='16'X;          /* SET ERROR REASON CODE         */
         MVI   RCARCRD(RCAPTR),X'16'                               0131
*ERROR:                                                            0132
*           GENERATE CODE NOREFS SETS(R1);                         0132
ERROR    DS    0H                                                  0132
            ABEND X'C0D',,,SYSTEM
*           RESPECIFY                                              0133
*            (R15) UNRSTD;                                         0133
*TERMEM:                                                           0134
*           IF PCBASCB->ASCBASCB='ASCB' THEN/* TEST IF ASCB IS A   0134
*                                      VALID ASCB                    */
TERMEM   L     @11,PCBASCB(,PCBPTR)                                0134
         CLC   ASCBASCB(4,@11),@CC01903                            0134
         BNE   @RF00134                                            0134
*             DO;                   /* VALID - SET FAILURE CODE AND
*                                      CALL IEAVSWPC                 */
*/********************************************************************/
*/*                 TO OBTAIN SALLOC LOCK  (SETLOCK)                 */
*/*  INPUT: REG 0-REG 10: UNUSED                                     */
*/*         REG 11-REG 13: REGISTERS USED BY SETLOCK                 */
*/*         REG 14: RETURN ADDRESS                                   */
*/*         REG 15: UNUSED                                           */
*/*  OUTPUT: REG 0-REG 10: RESTORED                                  */
*/*          REG 11-REG 12: UNPREDICTABLE                            */
*/*          REG 13: RETURN CODE                                     */
*/*            0: NORMAL RETURN                                      */
*/*            4: CALLER HOLDS LOCK                                  */
*/*          REG 14-REG 15: RESTORED                                 */
*/*          SALLOC LOCK OBTAINED                                    */
*/********************************************************************/
*                                                                  0136
*               RESPECIFY                                          0136
*                (R11,                                             0136
*                 R12,                                             0136
*                 R14) RSTD;                                       0136
*               GENERATE CODE REFS(PSALITA,FLC) SETS(R11,R12,R13,R14);
GETSLK1  SETLOCK OBTAIN,TYPE=SALLOC,MODE=UNCOND,                      **
               RELATED=(SALLOC,IEAVPIOI(FRESLK1))
*               RCASAL='1'B;        /* SET SALLOC OBTAINED FLAG      */
         OI    RCASAL(RCAPTR),B'10000000'                          0138
*               PVTPRCA=RCAPTR;     /* PUT RCA ADDR IN PVT-HAVE    0139
*                                                              SALLOC*/
         ST    RCAPTR,PVTPRCA(,PVTPTR)                             0139
*               RESPECIFY                                          0140
*                (R11,                                             0140
*                 R12,                                             0140
*                 R13,                                             0140
*                 R14) UNRSTD;                                     0140
*               R0=8;               /* SET SWAP FAILURE CODE FOR   0141
*                                      IEAVSWPC                      */
         LA    R0,8                                                0141
*               R1=ADDR(PCBAIA);    /* PASS LSQA AIAS TO IEAVSWPC    */
         LA    R1,PCBAIA(,PCBPTR)                                  0142
*               CALL IEAVSWPC;      /* FREE PCBS, TURN OFF PFTPCBSI  */
         L     @15,PVTPSWPC(,PVTPTR)                               0143
         BALR  @14,@15                                             0143
*               GOTO FREELCKS;      /* FREE FRR, RELEASE SALLOC AND
*                                      LOCAL LOCK, EXIT              */
         B     FREELCKS                                            0144
*             END;                  /* END OF ERROR ON VALID ASCB  0145
*                                      PROCESSING                    */
*           ELSE                                                   0146
*             ;                     /* PROCESS ERROR ON INVALID ASCB */
@RF00134 DS    0H                                                  0147
*           RCARETAD=0;             /* ZERO RETRY ADDRESS            */
         SLR   @11,@11                                             0147
         ST    @11,RCARETAD(,RCAPTR)                               0147
*           GOTO TERM;              /* START CLEANUP PROCESSING      */
         B     TERM                                                0148
*         END;                      /* ASCBCHAP SUCCESSFUL           */
*                                                                  0150
*/********************************************************************/
*/*     ASCBCHAP COMPLETED OK--ASCB ON QUEUE--START LSQA I/O         */
*/********************************************************************/
*/********************************************************************/
*/*                 TO OBTAIN SALLOC LOCK  (SETLOCK)                 */
*/*  INPUT: REG 0-REG 10: UNUSED                                     */
*/*         REG 11-REG 13: REGISTERS USED BY SETLOCK                 */
*/*         REG 14: RETURN ADDRESS                                   */
*/*         REG 15: UNUSED                                           */
*/*  OUTPUT: REG 0-REG 10: RESTORED                                  */
*/*          REG 11-REG 12: UNPREDICTABLE                            */
*/*          REG 13: RETURN CODE                                     */
*/*            0: NORMAL RETURN                                      */
*/*            4: CALLER HOLDS LOCK                                  */
*/*          REG 14-REG 15: RESTORED                                 */
*/*          SALLOC LOCK OBTAINED                                    */
*/********************************************************************/
*                                                                  0150
*       RESPECIFY                                                  0150
*        (R11,                                                     0150
*         R12,                                                     0150
*         R14) RSTD;                                               0150
@RF00129 DS    0H                                                  0151
*       GENERATE CODE REFS(PSALITA,FLC) SETS(R11,R12,R13,R14);     0151
         SETLOCK OBTAIN,TYPE=SALLOC,MODE=UNCOND,                      **
               RELATED=(SALLOC,IEAVPIOI(FRESLK1))
*       RCASAL='1'B;                /* SET SALLOC OBTAINED FLAG      */
         OI    RCASAL(RCAPTR),B'10000000'                          0152
*       PVTPRCA=RCAPTR;             /* PUT RCA ADDR IN PVT-HAVE    0153
*                                                              SALLOC*/
         ST    RCAPTR,PVTPRCA(,PVTPTR)                             0153
*       RESPECIFY                                                  0154
*        (R11,                                                     0154
*         R12,                                                     0154
*         R13,                                                     0154
*         R14) UNRSTD;                                             0154
*       RESPECIFY                                                  0155
*        (R15) RSTD;                                               0155
*       RCARETAD=0;                 /* REMOVE THE RETRY ADDRESS. SWAP
*                                      I/O WILL BE STARTED SO FRAMES
*                                      AND PCBS CANNOT BE RECLAIMED  */
         SLR   @14,@14                                             0156
         ST    @14,RCARETAD(,RCAPTR)                               0156
*       RSMHDPTR=PCBASCB->ASCBRSM;  /* OBTAIN RSMHD ADDRESS OF     0157
*                                      SWAPOUT ADDRESS SPACE (OR   0157
*                                      MASTERS IF ADDRESS SPACE HAS
*                                      BEEN TERMINATED.              */
*                                                                  0157
         L     @14,PCBASCB(,PCBPTR)                                0157
         L     RSMHDPTR,ASCBRSM(,@14)                              0157
*       /*************************************************************/
*       /*                                                           */
*       /* SET UP TO CALL ASM AT ILRSWAP                             */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0158
*       R1=ADDR(PCBAIA);            /* PASS FIRST LSQA AIA TO ASM    */
         LA    R1,PCBAIA(,PCBPTR)                                  0158
*       CALL ILRSWAP;               /* CALL ASM                      */
         L     @15,PVTSWPIO(,PVTPTR)                               0159
         BALR  @14,@15                                             0159
*/********************************************************************/
*/*  IF RETURN CODE=0, THEN I/O WAS STARTED FOR ALL PCBS. RELEASE THE*/
*/* FRR AND EXIT. IF RETURN CODE=NON-ZERO I/O FAILED FOR 1 OR MORE   */
*/* PCBS.                                                            */
*/********************************************************************/
*                                                                  0160
*       IF R15^=0 THEN              /* TEST IF I/O STARTED FOR ALL 0160
*                                      AIAS                          */
         LTR   R15,R15                                             0160
         BZ    @RF00160                                            0160
*         DO;                       /* I/O WAS NOT STARTED - PROCESS
*                                      ERROR                         */
*           R0=8;                   /* SET FAILURE RETURN CODE FOR 0162
*                                      IEAVSWPC                      */
         LA    R0,8                                                0162
*           CALL IEAVSWPC;          /* CALL THE SWAP COMPLETION    0163
*                                      PROCESSOR FOR CLEANUP         */
         L     @15,PVTPSWPC(,PVTPTR)                               0163
         BALR  @14,@15                                             0163
*           RESPECIFY                                              0164
*            (R15) UNRESTRICTED;                                   0164
*         END;                      /* END OF ERROR PROCESSING       */
*       ELSE                                                       0166
*         ;                         /* I/O SUCCESSFULLY STARTED      */
@RF00160 DS    0H                                                  0167
*     END;                          /* END OF NOT INTERCEPTED      0167
*                                      PROCESSING                    */
*FREELCKS:                                                         0168
*   RESPECIFY                                                      0168
*    (R11,                                                         0168
*     R12,                                                         0168
*     R13,                                                         0168
*     R14) RSTD;                                                   0168
*                                                                  0168
@RC00091 DS    0H                                                  0168
FREELCKS DS    0H                                                  0169
*/****************************************************************** */
*/*                  TO RELEASE SALLOC LOCK     (SETLOCK)            */
*/*  INPUT:   REG 0-REG 10: UNUSED                                   */
*/*           REG 11-REG 13: REGISTERS USED BY SETLOCK               */
*/*           REG 14: RETURN ADDRESS                                 */
*/*           REG 15: UNUSED                                         */
*/*  OUTPUT:  REG 0-REG 10: RESTORED                                 */
*/*           REG 11-REG 12: UNPREDICTABLE                           */
*/*           REG 13: RETURN CODE                                    */
*/*             0: NORMAL RETURN                                     */
*/*             4: LOCK NOT OWNED                                    */
*/*           REG 14-REG 15: RESTORED                                */
*/*           SALLOC LOCK RELEASED                                   */
*/****************************************************************** */
*                                                                  0169
*   GENERATE CODE REFS(PSALITA,FLC,R13) SETS(R11,R12,R13,R14);     0169
FRESLK1 SETLOCK RELEASE,TYPE=SALLOC,RELATED=(SALLOC,IEAVPIOI(GETSLK1))
*   RCASAL='0'B;                    /* SET SALLOC RELEASED FLAG      */
         NI    RCASAL(RCAPTR),B'01111111'                          0170
*                                                                  0171
*/********************************************************************/
*/*                RELEASE LOCAL LOCK (SETLOCK)                      */
*/*  INPUT:  REG 0-REG 10: UNUSED                                    */
*/*          REG 11-REG 13: REGISTERS USED BY SETLOCK                */
*/*          REG 14: RETURN ADDRESS                                  */
*/*          REG 15: UNUSED                                          */
*/*  OUTPUT: REG 0-REG 10: RESTORED                                  */
*/*          REG 11-REG 12: UNPREDICTABLE                            */
*/*          REG 13: RETURN CODE                                     */
*/*               0: NORMAL RETURN - LOCAL RELEASED                  */
*/*               4: LOCK NOT OWNED                                  */
*/*          REG 14-REG 15: RESTORED                                 */
*/********************************************************************/
*/********************************************************************/
*/*                  RELEASE FRR       (SETFRR)                      */
*/*  INPUT:  REG 1-REG 2: WORK REGISTERS                             */
*/*          REG 0,REG 3-REG 15: UNUSED                              */
*/*  OUTPUT: REG 1-REG 2: UNPREDICTABLE                              */
*/*          REG 0,REG 1-REG 15: RESTORED                            */
*/*          RSM FRR REMOVED                                         */
*/********************************************************************/
*                                                                  0171
*   RESPECIFY                                                      0171
*    (R2,                                                          0171
*     R11,                                                         0171
*     R12,                                                         0171
*     R14) RESTRICTED;                                             0171
*FREEFRR:                                                          0172
*   GENERATE CODE REFS(PSACSTK,FRRSCURR,FRRSEMP,FRRS,FRRSELEN) SETS(R1,
*       R2,R11,R12,R13,R14);                                       0172
FREEFRR  DS    0H                                                  0172
FRELLK1  SETLOCK RELEASE,TYPE=LOCAL,RELATED=(LOCAL,IEAVPIOI(GETLLK))
         SETFRR D,WRKREGS=(R1,R2)
*   R14=CVTSRBRT;                   /* GET RETURN ADDRESS            */
         L     @04,CVTPTR                                          0173
         L     R14,CVTSRBRT(,@04)                                  0173
*   GOTO R14;                       /* RETURN TO CALLER              */
         BR    R14                                                 0174
*PIOIRTRY:                          /* RETRY ENTRY                   */
*   RESPECIFY                                                      0175
*    (R11,                                                         0175
*     R13) RESTRICTED;                                             0175
PIOIRTRY DS    0H                                                  0176
*   R13=WSALRSM;                    /* SAVEAREA NEEDED FOR         0176
*                                      TERMINATION RTN.      @VS02689*/
         L     @15,ASXBPTR(,ASCBPTR)                               0176
         L     @15,ASXBSPSA(,@15)                                  0176
         L     R13,WSALRSM(,@15)                                   0176
*   R11=R0->PCBASCB->ASCBASID;      /* GET ASID FOR RTN INTERFACE    */
         LR    @15,R0                                              0177
         L     @15,PCBASCB(,@15)                                   0177
         LH    R11,ASCBASID(,@15)                                  0177
         N     R11,@CF01913                                        0177
*   IF R11^=PSAAOLD->ASCBASID THEN  /* IF EQUAL THEN DLAS HAS RUN AND
*                                      PCBASCB EQUALS MASTERS. BYPASS
*                                      MEMTERM                       */
         L     @15,PSAAOLD                                         0178
         LH    @15,ASCBASID(,@15)                                  0178
         N     @15,@CF01913                                        0178
         CR    R11,@15                                             0178
         BE    @RF00178                                            0178
*     DO;                           /* UNEQUAL, MUST BE FOR SWAPPED
*                                      OUT ADDRESS SPACE SINCE     0179
*                                      CURRENTLY RUNNING IN MASTERS  */
*       GENERATE CODE REFS(CVTBTERM,CVTMAP);                       0180
*                                             /* ISSUE MEMTERM */
         CALLRTM TYPE=MEMTERM,COMPCOD=X'028',ASID=(R11)
*     END;                          /* END OF MEMTERM PROCESSING     */
*   ELSE                                                           0182
*     ;                             /* PCBASCB = MASTERS ASCB        */
@RF00178 DS    0H                                                  0183
*   GOTO TERM;                      /* FREE PCBS AND FRAMES          */
         B     TERM                                                0183
*   END IEAVPIOI                                                   0184
*                                                                  0184
*/* THE FOLLOWING INCLUDE STATEMENTS WERE FOUND IN THIS PROGRAM.     */
*/*%INCLUDE SYSLIB  (ILRAIA  )                                       */
*/*%INCLUDE SYSLIB  (IHAASCB )                                       */
*/*%INCLUDE SYSLIB  (ILRASMVT)                                       */
*/*%INCLUDE SYSLIB  (IHAASXB )                                       */
*/*%INCLUDE SYSLIB  (CVT     )                                       */
*/*%INCLUDE SYSLIB  (IHAFRRS )                                       */
*/*%INCLUDE SYSLIB  (IHAPCB  )                                       */
*/*%INCLUDE SYSLIB  (IHAPFTE )                                       */
*/*%INCLUDE SYSLIB  (IHAPCBR )                                       */
*/*%INCLUDE SYSLIB  (IHAPSA  )                                       */
*/*%INCLUDE SYSLIB  (IHAPVT  )                                       */
*/*%INCLUDE SYSLIB  (IHARCA  )                                       */
*/*%INCLUDE SYSLIB  (IHASRB  )                                       */
*/*%INCLUDE SYSLIB  (IHAWSAVT)                                       */
*                                                                  0184
*       ;                                                          0184
@DATA    DS    0H
         DS    0F
         DS    0F
@CF01876 DC    XL4'80000000'
@CF01913 DC    XL4'0000FFFF'
         DS    0D
@CC01903 DC    C'ASCB'
@00      EQU   00                      EQUATES FOR REGISTERS 0-15
@01      EQU   01
@02      EQU   02
@03      EQU   03
@04      EQU   04
@05      EQU   05
@06      EQU   06
@07      EQU   07
@08      EQU   08
@09      EQU   09
@10      EQU   10
@11      EQU   11
@12      EQU   12
@13      EQU   13
@14      EQU   14
@15      EQU   15
ASCBPTR  EQU   @10
PCBPTR   EQU   @06
PFTEPTR  EQU   @12
PVTPTR   EQU   @03
RCAPTR   EQU   @07
SRBPTR   EQU   @05
R0       EQU   @00
R1       EQU   @01
AIAPTR   EQU   @01
R2       EQU   @02
RSMHDPTR EQU   @02
SOUTPPTR EQU   @08
BASEREG  EQU   @09
R11      EQU   @11
R12      EQU   @12
R13      EQU   @13
R14      EQU   @14
R15      EQU   @15
R10      EQU   @10
R3       EQU   @03
R4       EQU   @04
R5       EQU   @05
R6       EQU   @06
R7       EQU   @07
R8       EQU   @08
R9       EQU   @09
PSA      EQU   0
FLCRNPSW EQU   PSA
FLCROPSW EQU   PSA+8
FLCICCW2 EQU   PSA+16
FLCCVT   EQU   FLCICCW2
PSAEEPSW EQU   PSA+132
PSAESPSW EQU   PSA+136
FLCSVILC EQU   PSAESPSW+1
PSAEPPSW EQU   PSA+140
FLCPIILC EQU   PSAEPPSW+1
FLCPICOD EQU   PSAEPPSW+2
PSAPICOD EQU   FLCPICOD+1
FLCTEA   EQU   PSAEPPSW+4
FLCPER   EQU   PSA+152
FLCMCLA  EQU   PSA+168
FLCIOEL  EQU   FLCMCLA+4
FLCIOA   EQU   FLCMCLA+16
FLCFSA   EQU   FLCMCLA+80
PSAAOLD  EQU   PSA+548
PSASUPER EQU   PSA+552
PSASUP1  EQU   PSASUPER
PSASUP2  EQU   PSASUPER+1
PSASUP3  EQU   PSASUPER+2
PSASUP4  EQU   PSASUPER+3
PSACLHT  EQU   PSA+640
PSALKSA  EQU   PSA+696
PSAHLHI  EQU   PSA+760
PSALITA  EQU   PSA+764
PSADSSFL EQU   PSA+836
PSADSSF1 EQU   PSADSSFL
PSADSSF3 EQU   PSADSSFL+2
PSADSSF4 EQU   PSADSSFL+3
PSARSVT  EQU   PSA+896
PSALSFCC EQU   PSA+1012
ASCB     EQU   0
ASCBASCB EQU   ASCB
ASCBSUPC EQU   ASCB+16
ASCBASID EQU   ASCB+36
ASCBRSM  EQU   ASCB+52
ASCBFW1  EQU   ASCB+100
ASCBRCTF EQU   ASCBFW1+2
ASCBFLG1 EQU   ASCBFW1+3
ASCBTERM EQU   ASCBFLG1
ASCBABNT EQU   ASCBFLG1
ASCBASXB EQU   ASCB+108
ASCBDSP1 EQU   ASCB+114
ASCBFLG2 EQU   ASCB+115
ASCBLKGP EQU   ASCB+128
ASCBSRQ  EQU   ASCB+180
ASCBSRQ1 EQU   ASCBSRQ
ASCBSRQ2 EQU   ASCBSRQ+1
ASCBSRQ3 EQU   ASCBSRQ+2
ASCBSRQ4 EQU   ASCBSRQ+3
ASMVT    EQU   0
ASMFLAG1 EQU   ASMVT
ASMFLAG2 EQU   ASMVT+1
ASMSTAGQ EQU   ASMVT+32
ASMPCCWQ EQU   ASMVT+64
ASMLSAI  EQU   ASMVT+144
ASMGOSQS EQU   ASMVT+152
ASMWKSA1 EQU   ASMVT+368
ASMWKSA2 EQU   ASMVT+448
ASMWKSA3 EQU   ASMVT+528
ASMWKSA4 EQU   ASMVT+608
ASMWKSA5 EQU   ASMVT+688
ASMPOOLS EQU   0
ASMCPAVQ EQU   ASMPOOLS+8
ASMCPRSQ EQU   ASMPOOLS+16
ASXB     EQU   0
ASXBSPSA EQU   ASXB+112
ASXBAEQ  EQU   ASXB+168
ASXBSECR EQU   ASXB+199
ASCBSFLG EQU   ASXBSECR
ASXBCASW EQU   ASXB+216
ASXBCRB1 EQU   ASXBCASW
CVTMAP   EQU   0
CVTBTERM EQU   CVTMAP+52
CVTDAR   EQU   CVTMAP+72
CVTFLGS1 EQU   CVTDAR
CVTDCB   EQU   CVTMAP+116
CVTIERLC EQU   CVTMAP+144
CVTOPTA  EQU   CVTMAP+182
CVTOPTB  EQU   CVTMAP+183
CVTGTF   EQU   CVTMAP+236
CVTGTFST EQU   CVTGTF
CVTGTFS  EQU   CVTGTFST
CVTSTATE EQU   CVTGTFST
CVTTMODE EQU   CVTGTFST
CVTFORM  EQU   CVTGTFST
CVTAQAVT EQU   CVTMAP+240
CVTTCMFG EQU   CVTAQAVT
CVTVOLM2 EQU   CVTMAP+244
CVTTATA  EQU   CVTVOLM2
CVTTSKS  EQU   CVTTATA
CVTVOLF2 EQU   CVTTSKS
CVTTAT   EQU   CVTTATA+1
CVTATER  EQU   CVTMAP+248
CVTEXT1  EQU   CVTMAP+252
CVTPURG  EQU   CVTMAP+260
CVTQMSG  EQU   CVTMAP+268
CVTDMSR  EQU   CVTMAP+272
CVTRSV37 EQU   CVTDMSR
CVTDMSRF EQU   CVTRSV37
CVTERPV  EQU   CVTMAP+316
CVTINTLA EQU   CVTMAP+320
CVTAPF   EQU   CVTMAP+324
CVTEXT2  EQU   CVTMAP+328
CVTHJES  EQU   CVTMAP+332
CVTPGSIA EQU   CVTMAP+348
CVTA1F1  EQU   CVTMAP+356
CVTSYSK  EQU   CVTMAP+357
CVTVOLM1 EQU   CVTMAP+380
CVTVOLF1 EQU   CVTVOLM1
CVTATMCT EQU   CVTMAP+388
CVTXTNT1 EQU   0
CVTXTNT2 EQU   0
CVTDSSV  EQU   CVTXTNT2
CVTFLGBT EQU   CVTXTNT2+5
CVTQID   EQU   CVTXTNT2+24
CVTRV400 EQU   CVTXTNT2+52
CVTRV409 EQU   CVTXTNT2+53
CVTATCVT EQU   CVTXTNT2+64
CVTRV429 EQU   CVTXTNT2+84
CVTRV438 EQU   CVTXTNT2+85
CVTRV457 EQU   CVTXTNT2+112
CVTRV466 EQU   CVTXTNT2+113
CVTFIX   EQU   0
CVTRELNO EQU   CVTFIX+252
FRRS     EQU   0
FRRSHEAD EQU   FRRS
FRRSEMP  EQU   FRRSHEAD
FRRSLAST EQU   FRRSHEAD+4
FRRSELEN EQU   FRRSHEAD+8
FRRSCURR EQU   FRRSHEAD+12
FRRSENTR EQU   0
FRRSFRRA EQU   FRRSENTR
FRRSFLGS EQU   FRRSENTR+4
FRRSFLG1 EQU   FRRSFLGS
FRRSPARM EQU   FRRSENTR+8
PCB      EQU   0
PCBFQP   EQU   PCB
PCBFQPA  EQU   PCBFQP+1
PCBBQP   EQU   PCB+4
PCBRTP   EQU   PCB+8
PCBFL1   EQU   PCBRTP
PCBRTPA  EQU   PCBRTP+1
PCBRLP   EQU   PCB+12
PCBXPT   EQU   PCB+16
PCBFL2   EQU   PCBXPT
PCBPGT   EQU   PCB+20
PCBFL3   EQU   PCBPGT
PCBRBN   EQU   PCB+24
PCBBLOCK EQU   PCB+28
PCBSRB   EQU   PCBBLOCK
PCBRB    EQU   PCBSRB
PCBASCB  EQU   PCB+32
PCBAIA   EQU   PCB+36
PFTE     EQU   0
PFTPGID  EQU   PFTE
PFTQPTRS EQU   PFTE+4
PFTFLAG1 EQU   PFTE+12
PFTPCBSI EQU   PFTFLAG1
PFTFLAG2 EQU   PFTE+13
PCBR     EQU   0
PCBRTCB  EQU   PCBR
PCBRFLAG EQU   PCBRTCB
PVT      EQU   0
PVTFLAG1 EQU   PVT
PVTPFTP  EQU   PVT+12
PVTPRCA  EQU   PVT+52
PVTPCB   EQU   PVT+104
PVTPFTE  EQU   PVT+108
PVTPRCV  EQU   PVT+156
PVTPSWPC EQU   PVT+168
PVTPINV  EQU   PVT+172
PVTSWPIO EQU   PVT+232
PVTQS    EQU   PVT+304
PVTWSAX  EQU   PVT+344
RCA      EQU   0
RCAPARM0 EQU   RCA
RCAPARM1 EQU   RCA+4
RCACSECT EQU   RCA+9
RCAFLAGS EQU   RCA+10
RCASAL   EQU   RCAFLAGS
RCALL    EQU   RCAFLAGS
RCARCRD  EQU   RCA+11
RCANAMES EQU   RCA+12
RCANAME1 EQU   RCANAMES
RCANAME2 EQU   RCANAMES+1
RCANAME3 EQU   RCANAMES+2
RCANAME4 EQU   RCANAMES+3
RCANAME5 EQU   RCANAMES+4
RCANAME6 EQU   RCANAMES+5
RCAPIOI  EQU   RCA+18
RCARETAD EQU   RCA+20
SRBSECT  EQU   0
SRB      EQU   SRBSECT
SRBASCB  EQU   SRB+8
SRBFLC   EQU   SRB+12
WSAL     EQU   0
WSALRSM  EQU   WSAL+52
WSALACHP EQU   WSAL+56
SOUTPARM EQU   0
SOUTFLGS EQU   SOUTPARM+4
SOUTINT  EQU   SOUTFLGS
SOUTWRKA EQU   SOUTPARM+16
LSQAPCBS EQU   SOUTWRKA+1
IEAVINV  EQU   0
IEAVSWPC EQU   0
ILRSWAP  EQU   0
IEAVPCB  EQU   0
IEAVPFTE EQU   0
RSMAIA   EQU   PCBAIA
AIA      EQU   RSMAIA
AIAFLG1  EQU   AIA+9
AIALSQA  EQU   AIAFLG1
AIAFLG2  EQU   AIA+10
AIAFLG3  EQU   AIA+11
AIANXAIA EQU   AIA+12
AIAID    EQU   AIA+16
AIALPID  EQU   AIAID
AIALGID  EQU   AIALPID
AIALSID  EQU   AIALGID
AIASSID  EQU   AIALSID+1
AIARPN   EQU   AIALPID+4
AIALSID2 EQU   AIARPN
AIALPMEP EQU   AIALSID2
AIAGRPSZ EQU   AIA+24
AIALGE   EQU   AIAGRPSZ
CVTS01   EQU   CVTPGSIA
CVTPVTP  EQU   CVTS01+8
CVTLPDIA EQU   CVTS01+12
CVTDIRST EQU   CVTLPDIA
CVTSLIDA EQU   CVTS01+24
CVTCTLFG EQU   CVTS01+50
CVTSRBRT EQU   CVTS01+100
CVTVEAC0 EQU   CVTS01+328
CVTASMVT EQU   CVTS01+356
CVTRV210 EQU   CVTS01+424
CVTRV219 EQU   CVTS01+425
CVTRV228 EQU   CVTS01+426
CVTRV237 EQU   CVTS01+427
CVTMFRTR EQU   CVTS01+452
CVTRV262 EQU   CVTS01+468
CVTRV271 EQU   CVTS01+469
CVTRV280 EQU   CVTS01+470
CVTRV289 EQU   CVTS01+471
CVTGSDA  EQU   CVTS01+600
ASMVTPTR EQU   CVTASMVT
ASM1WKSV EQU   ASMWKSA1
ASM1RGSV EQU   ASM1WKSV
ASM1WRKA EQU   ASM1WKSV+60
ASM2WKSV EQU   ASMWKSA2
ASM2WRKA EQU   ASM2WKSV+52
ASM2FLGS EQU   ASM2WRKA+12
ASM3WKSV EQU   ASMWKSA3
ASM4WKSV EQU   ASMWKSA4
ASM4RGSV EQU   ASM4WKSV
ASM5WKSV EQU   ASMWKSA5
ASM5RGSV EQU   ASM5WKSV
ASXBPTR  EQU   ASCBASXB
CVTPTR   EQU   FLCCVT
PSARSVTE EQU   PSARSVT
PSACSTK  EQU   PSARSVTE
FRRSPTR  EQU   PSACSTK
FRREPTR  EQU   FRRSCURR
FLC      EQU   PSA
         AGO   .@UNREFD                START UNREFERENCED COMPONENTS
PSARSAV  EQU   PSARSVTE+60
PSARSTK  EQU   PSARSVTE+56
PSAESAV3 EQU   PSARSVTE+52
PSAESTK3 EQU   PSARSVTE+48
PSAESAV2 EQU   PSARSVTE+44
PSAESTK2 EQU   PSARSVTE+40
PSAESAV1 EQU   PSARSVTE+36
PSAESTK1 EQU   PSARSVTE+32
PSAPSAV  EQU   PSARSVTE+28
PSAPSTK  EQU   PSARSVTE+24
PSAMSAV  EQU   PSARSVTE+20
PSAMSTK  EQU   PSARSVTE+16
PSASSAV  EQU   PSARSVTE+12
PSASSTK  EQU   PSARSVTE+8
PSANSTK  EQU   PSARSVTE+4
ASM5FLGS EQU   ASM5WKSV+64
ASM5AIA  EQU   ASM5WKSV+60
ASM5GCTR EQU   ASM5WKSV+56
ASM5SR14 EQU   ASM5WKSV+52
@NM00006 EQU   ASM5RGSV+4
ASM5RG2  EQU   ASM5RGSV
@NM00005 EQU   ASM4RGSV+4
ASM4RG2  EQU   ASM4RGSV
ASM3SR13 EQU   ASM3WKSV+28
ASM3R14B EQU   ASM3WKSV+24
ASM3R14A EQU   ASM3WKSV+20
ASM3GRPA EQU   ASM3WKSV+16
ASM3TMPA EQU   ASM3WKSV+12
ASM3PIOP EQU   ASM3WKSV+8
ASM3GENQ EQU   ASM3WKSV+4
ASM3SWPQ EQU   ASM3WKSV
ASM2SR14 EQU   ASM2WRKA+16
@NM00004 EQU   ASM2WRKA+13
ASM2WFLG EQU   ASM2FLGS
ASM2RFLG EQU   ASM2FLGS
ASM2DUPQ EQU   ASM2WRKA+8
ASM2CAQ  EQU   ASM2WRKA+4
ASM2PAQ  EQU   ASM2WRKA
ASM2RGSV EQU   ASM2WKSV
ASM1NXTA EQU   ASM1WRKA+4
ASM1ASCB EQU   ASM1WRKA
ASM1RG15 EQU   ASM1RGSV+56
@NM00003 EQU   ASM1RGSV+4
ASM1RG1  EQU   ASM1RGSV
CVTRV628 EQU   CVTS01+728
CVTRV627 EQU   CVTS01+724
CVTRV626 EQU   CVTS01+720
CVTRV625 EQU   CVTS01+716
CVTRV624 EQU   CVTS01+712
CVTRV623 EQU   CVTS01+708
CVTRV622 EQU   CVTS01+704
CVTRV621 EQU   CVTS01+700
CVTIHASU EQU   CVTS01+696
CVTSUSP  EQU   CVTS01+692
CVTT6SVC EQU   CVTS01+688
CVTCDAL  EQU   CVTS01+684
CVTTCTL  EQU   CVTS01+680
CVTRSUME EQU   CVTS01+676
CVTJTERM EQU   CVTS01+672
CVTASMRM EQU   CVTS01+668
CVTTCASP EQU   CVTS01+664
CVT0PT03 EQU   CVTS01+660
CVT0PT0E EQU   CVTS01+656
CVTRV609 EQU   CVTS01+652
CVTCGK   EQU   CVTS01+648
CVTRAC   EQU   CVTS01+644
CVTRV606 EQU   CVTS01+640
CVTRV605 EQU   CVTS01+636
CVTRV604 EQU   CVTS01+632
CVTEFF02 EQU   CVTS01+628
CVTCBBR  EQU   CVTS01+624
CVTSSCR  EQU   CVTS01+620
CVTEVENT EQU   CVTS01+616
CVTCRCA  EQU   CVTS01+612
CVTTPIO  EQU   CVTS01+608
CVTADV   EQU   CVTS01+604
CVTGSDAB EQU   CVTGSDA
CVTQV3   EQU   CVTS01+596
CVTQV2   EQU   CVTS01+592
CVTQV1   EQU   CVTS01+588
CVTRPT   EQU   CVTS01+584
CVTSSRB  EQU   CVTS01+580
CVTCSDRL EQU   CVTS01+576
CVTEXP1  EQU   CVTS01+572
CVTRMPMT EQU   CVTS01+568
CVTRMPTT EQU   CVTS01+564
CVTVPSA  EQU   CVTS01+560
CVTVSTOP EQU   CVTS01+556
CVTGTFR8 EQU   CVTS01+552
CVTQUIT  EQU   CVTS01+548
CVTVACR  EQU   CVTS01+544
CVTWTCB  EQU   CVTS01+540
CVTSTPRS EQU   CVTS01+536
CVT0PT02 EQU   CVTS01+532
CVTDARCM EQU   CVTS01+528
CVTIRECM EQU   CVTS01+524
CVTJRECM EQU   CVTS01+520
CVTVEMS0 EQU   CVTS01+516
CVTSPFRR EQU   CVTS01+512
CVTRLSTG EQU   CVTS01+508
CVT0TC0A EQU   CVTS01+504
CVTGMBR  EQU   CVTS01+500
CVTLFRM  EQU   CVTS01+496
CVTRMBR  EQU   CVTS01+492
CVTVIOP  EQU   CVTS01+488
CVTRV307 EQU   CVTS01+486
CVTRV306 EQU   CVTS01+484
CVTRV305 EQU   CVTS01+482
CVTRV304 EQU   CVTS01+480
CVTRV303 EQU   CVTS01+478
CVTRV302 EQU   CVTS01+476
CVTTRCA  EQU   CVTS01+472
CVTRV297 EQU   CVTRV289
CVTRV296 EQU   CVTRV289
CVTRV295 EQU   CVTRV289
CVTRV294 EQU   CVTRV289
CVTRV293 EQU   CVTRV289
CVTRV292 EQU   CVTRV289
CVTRV291 EQU   CVTRV289
CVTRV290 EQU   CVTRV289
CVTRV288 EQU   CVTRV280
CVTRV287 EQU   CVTRV280
CVTRV286 EQU   CVTRV280
CVTRV285 EQU   CVTRV280
CVTRV284 EQU   CVTRV280
CVTRV283 EQU   CVTRV280
CVTRV282 EQU   CVTRV280
CVTRV281 EQU   CVTRV280
CVTRV279 EQU   CVTRV271
CVTRV278 EQU   CVTRV271
CVTRV277 EQU   CVTRV271
CVTRV276 EQU   CVTRV271
CVTRV275 EQU   CVTRV271
CVTRV274 EQU   CVTRV271
CVTRV273 EQU   CVTRV271
CVTRV272 EQU   CVTRV271
CVTRV270 EQU   CVTRV262
CVTRV269 EQU   CVTRV262
CVTRV268 EQU   CVTRV262
CVTRV267 EQU   CVTRV262
CVTRV266 EQU   CVTRV262
CVTRV265 EQU   CVTRV262
CVTRV264 EQU   CVTRV262
CVTRV263 EQU   CVTRV262
CVTVFP   EQU   CVTS01+464
CVTVSI   EQU   CVTS01+460
CVTVPSIB EQU   CVTS01+456
CVTMFACT EQU   CVTMFRTR
CVTMFCTL EQU   CVTS01+448
CVTPVBP  EQU   CVTS01+444
CVTPWI   EQU   CVTS01+440
CVTRV254 EQU   CVTS01+438
CVTRV253 EQU   CVTS01+436
CVTRV252 EQU   CVTS01+434
CVTRV251 EQU   CVTS01+433
CVTRV250 EQU   CVTS01+432
CVTRV249 EQU   CVTS01+431
CVTRV248 EQU   CVTS01+430
CVTRV247 EQU   CVTS01+429
CVTRV246 EQU   CVTS01+428
CVTRV245 EQU   CVTRV237
CVTRV244 EQU   CVTRV237
CVTRV243 EQU   CVTRV237
CVTRV242 EQU   CVTRV237
CVTRV241 EQU   CVTRV237
CVTRV240 EQU   CVTRV237
CVTRV239 EQU   CVTRV237
CVTRV238 EQU   CVTRV237
CVTRV236 EQU   CVTRV228
CVTRV235 EQU   CVTRV228
CVTRV234 EQU   CVTRV228
CVTRV233 EQU   CVTRV228
CVTRV232 EQU   CVTRV228
CVTRV231 EQU   CVTRV228
CVTRV230 EQU   CVTRV228
CVTRV229 EQU   CVTRV228
CVTRV227 EQU   CVTRV219
CVTRV226 EQU   CVTRV219
CVTRV225 EQU   CVTRV219
CVTRV224 EQU   CVTRV219
CVTRV223 EQU   CVTRV219
CVTRV222 EQU   CVTRV219
CVTRV221 EQU   CVTRV219
CVTRV220 EQU   CVTRV219
CVTRV218 EQU   CVTRV210
CVTRV217 EQU   CVTRV210
CVTRV216 EQU   CVTRV210
CVTRV215 EQU   CVTRV210
CVTRV214 EQU   CVTRV210
CVTRV213 EQU   CVTRV210
CVTRV212 EQU   CVTRV210
CVTRV211 EQU   CVTRV210
CVTLCCAT EQU   CVTS01+420
CVTPCCAT EQU   CVTS01+416
CVTIPCRP EQU   CVTS01+412
CVTIPCRI EQU   CVTS01+408
CVTIPCDS EQU   CVTS01+404
CVTAIDVT EQU   CVTS01+400
CVTSSAP  EQU   CVTS01+396
CVTEHCIR EQU   CVTS01+392
CVTEHDEF EQU   CVTS01+388
CVTDAIR  EQU   CVTS01+384
CVTPERFM EQU   CVTS01+380
CVT044R2 EQU   CVTS01+376
CVTFETCH EQU   CVTS01+372
CVTRSTWD EQU   CVTS01+368
CVTSPOST EQU   CVTS01+364
CVTIOBP  EQU   CVTS01+360
CVTRECRQ EQU   CVTS01+352
CVTWSAC  EQU   CVTS01+348
CVTRV149 EQU   CVTS01+344
CVTWSAL  EQU   CVTS01+340
CVTSPSA  EQU   CVTS01+336
CVTGLMN  EQU   CVTS01+332
CVT062R1 EQU   CVTS01+324
CVTRPOST EQU   CVTS01+320
CVTDQIQE EQU   CVTS01+316
CVTCSD   EQU   CVTS01+312
CVTLKRMA EQU   CVTS01+308
CVTRSPIE EQU   CVTS01+304
CVTRENQ  EQU   CVTS01+300
CVTLQCB  EQU   CVTS01+296
CVTFQCB  EQU   CVTS01+292
CVTQCS01 EQU   CVTS01+288
CVTAPFT  EQU   CVTS01+284
CVTPARRL EQU   CVTS01+280
CVTVWAIT EQU   CVTS01+276
CVTGSPL  EQU   CVTS01+272
CVTLSMQ  EQU   CVTS01+268
CVTGSMQ  EQU   CVTS01+264
CVTEXPRO EQU   CVTS01+260
CVTOPCTP EQU   CVTS01+256
CVTSIC   EQU   CVTS01+252
CVTTPIOS EQU   CVTS01+248
CVTRTMS  EQU   CVTS01+244
CVTSDBF  EQU   CVTS01+240
CVTSCBP  EQU   CVTS01+236
CVTSDMP  EQU   CVTS01+232
CVTSV60  EQU   CVTS01+228
CVTRTMCT EQU   CVTS01+224
CVTASCBL EQU   CVTS01+220
CVTASCBH EQU   CVTS01+216
CVTGDA   EQU   CVTS01+212
CVTASVT  EQU   CVTS01+208
CVTVVMDI EQU   CVTS01+204
CVTAQTOP EQU   CVTS01+200
CVTIOSCS EQU   CVTS01+196
CVTSDRM  EQU   CVTS01+192
CVTOPTE  EQU   CVTS01+188
CVTSTXU  EQU   CVTS01+184
CVTQUIS  EQU   CVTS01+180
CVTPARS  EQU   CVTS01+176
CVTS1EE  EQU   CVTS01+172
CVTFRAS  EQU   CVTS01+168
CVTQSAS  EQU   CVTS01+164
CVTCRAS  EQU   CVTS01+160
CVTCRMN  EQU   CVTS01+156
CVTDELCP EQU   CVTS01+152
CVTFRECL EQU   CVTS01+148
CVTGETCL EQU   CVTS01+144
CVTBLDCP EQU   CVTS01+140
CVTAUTHL EQU   CVTS01+136
CVTSCAN  EQU   CVTS01+132
CVTRV144 EQU   CVTS01+130
CVTMAXMP EQU   CVTS01+128
CVTSTCK  EQU   CVTS01+124
CVTRV139 EQU   CVTS01+123
CVTDSSAC EQU   CVTS01+122
CVTRV513 EQU   CVTS01+121
CVTIOSPL EQU   CVTS01+120
CVTPTGT  EQU   CVTS01+116
CVTCSPIE EQU   CVTS01+112
CVTSMFEX EQU   CVTS01+108
CVTOLT0A EQU   CVTS01+104
CVTPUTL  EQU   CVTS01+96
CVTASCRL EQU   CVTS01+92
CVTASCRF EQU   CVTS01+88
CVTRV326 EQU   CVTS01+84
CVTRV325 EQU   CVTS01+80
CVTRV324 EQU   CVTS01+76
CVT0VL01 EQU   CVTS01+72
CVTSHRVM EQU   CVTS01+68
CVTRV332 EQU   CVTS01+64
CVTTAS   EQU   CVTS01+60
CVTRSCN  EQU   CVTS01+56
CVTTRAC2 EQU   CVTS01+54
CVTTRACE EQU   CVTS01+52
CVTAPG   EQU   CVTS01+51
CVTSDTRC EQU   CVTCTLFG
CVTGTRCE EQU   CVTCTLFG
CVTNOMP  EQU   CVTCTLFG
CVTRSV79 EQU   CVTCTLFG
CVTDSTAT EQU   CVTCTLFG
CVTRSV78 EQU   CVTCTLFG
CVTRV333 EQU   CVTCTLFG
CVTRV323 EQU   CVTCTLFG
CVTSPVLK EQU   CVTS01+49
CVTRSV77 EQU   CVTS01+48
CVTRV331 EQU   CVTS01+44
CVTRV330 EQU   CVTS01+40
CVTRV329 EQU   CVTS01+36
CVTRV328 EQU   CVTS01+32
CVTRV322 EQU   CVTS01+28
CVTSLID  EQU   CVTSLIDA+1
CVTSYLK  EQU   CVTSLIDA
CVTRV321 EQU   CVTS01+20
CVTRV320 EQU   CVTS01+16
CVTLPDIR EQU   CVTLPDIA+1
CVTRSV69 EQU   CVTDIRST
CVTRSV68 EQU   CVTDIRST
CVTRSV67 EQU   CVTDIRST
CVTRSV66 EQU   CVTDIRST
CVTRSV65 EQU   CVTDIRST
CVTRSV64 EQU   CVTDIRST
CVTRSV63 EQU   CVTDIRST
CVTDICOM EQU   CVTDIRST
CVTLPDSR EQU   CVTS01+4
CVTGETL  EQU   CVTS01
AIADPXCT EQU   AIALGE
AIACEPTR EQU   AIALPMEP
AIASLOT  EQU   AIASSID+1
@NM00002 EQU   AIASSID
@NM00001 EQU   AIALSID
AIARCSN  EQU   AIANXAIA+2
AIACYL   EQU   AIANXAIA
AIARSV9  EQU   AIAFLG3
AIARSV8  EQU   AIAFLG3
AIARSV7  EQU   AIAFLG3
AIALPMEC EQU   AIAFLG3
AIARSV6  EQU   AIAFLG3
AIATRPSP EQU   AIAFLG3
AIAPRINO EQU   AIAFLG3
AIARSV5  EQU   AIAFLG3
AIABADID EQU   AIAFLG2
AIAERROR EQU   AIAFLG2
AIASECER EQU   AIAFLG2
AIAPRIER EQU   AIAFLG2
AIARSV4  EQU   AIAFLG2
AIAIORTY EQU   AIAFLG2
AIATERMR EQU   AIAFLG2
AIAFRAUX EQU   AIAFLG2
AIARSV1  EQU   AIAFLG1
AIASWPFX EQU   AIAFLG1
AIAPAGDS EQU   AIAFLG1
AIADUPLX EQU   AIAFLG1
AIAVIO   EQU   AIAFLG1
AIAPRIV  EQU   AIAFLG1
AIAWRITE EQU   AIAFLG1
AIAOP    EQU   AIA+8
AIABQPA  EQU   AIA+4
AIAFQPA  EQU   AIA
PIOISRB  EQU   SOUTPARM+20
QINDEX   EQU   SOUTWRKA
SRMPARMS EQU   SOUTPARM+8
NLSQAPCB EQU   SOUTPARM+5
@NM00045 EQU   SOUTFLGS
FWRDPTR  EQU   SOUTPARM
WSALEVNT EQU   WSAL+48
WSALSTAE EQU   WSAL+44
WSALSTAT EQU   WSAL+40
WSALWAIT EQU   WSAL+36
WSALPOST EQU   WSAL+32
WSALEXIT EQU   WSAL+28
WSALS2EE EQU   WSAL+24
WSALCIRB EQU   WSAL+20
WSALABTM EQU   WSAL+16
WSALSDMP EQU   WSAL+12
WSALRTM2 EQU   WSAL+8
WSALVALC EQU   WSAL+4
WSALCWSA EQU   WSAL
@NM00044 EQU   SRB+40
@NM00043 EQU   SRB+38
SRBPRIOR EQU   SRB+37
SRBPKF   EQU   SRB+36
SRBSAVE  EQU   SRB+32
SRBPARM  EQU   SRB+28
SRBRMTR  EQU   SRB+24
SRBEP    EQU   SRB+20
SRBPTCB  EQU   SRBFLC+4
SRBPASID EQU   SRBFLC+2
SRBCPAFF EQU   SRBFLC
SRBFLNK  EQU   SRB+4
SRBID    EQU   SRB
RCARES9  EQU   RCA+19
@NM00042 EQU   RCA+18
RCANAME7 EQU   RCANAMES+6
RCAREP1  EQU   RCANAME6
RCAPSIF  EQU   RCANAME6
RCAPSIX  EQU   RCANAME6
RCAVEQRP EQU   RCANAME6
RCARCFC  EQU   RCANAME6
RCACSGB  EQU   RCANAME6
RCAFXL   EQU   RCANAME6
RCAPS113 EQU   RCANAME6
RCAFREE  EQU   RCANAME5
RCARFR2  EQU   RCANAME5
RCACPBR  EQU   RCANAME5
RCAOPBR  EQU   RCANAME5
RCASORT  EQU   RCANAME5
RCASIRT  EQU   RCANAME5
RCARELV  EQU   RCANAME5
RCARELF  EQU   RCANAME5
RCAGFAD  EQU   RCANAME4
RCAVEQRI EQU   RCANAME4
RCAVEQRF EQU   RCANAME4
RCAVEQRC EQU   RCANAME4
RCATERM  EQU   RCANAME4
RCASQA   EQU   RCANAME4
RCASWIN  EQU   RCANAME4
RCASOUT  EQU   RCANAME4
RCARFR   EQU   RCANAME3
RCARELS  EQU   RCANAME3
RCARCFI  EQU   RCANAME3
RCARCF   EQU   RCANAME3
RCAPSII  EQU   RCANAME3
RCAPSIB  EQU   RCANAME3
RCAPS112 EQU   RCANAME3
RCAPIX   EQU   RCANAME3
RCAPIOP  EQU   RCANAME2
RCASWPC  EQU   RCANAME2
RCASWPP  EQU   RCANAME2
RCAPFTE  EQU   RCANAME2
RCAPCB   EQU   RCANAME2
RCAOUT   EQU   RCANAME2
RCAITAS  EQU   RCANAME2
RCAIOCP  EQU   RCANAME2
RCAINV   EQU   RCANAME1
RCAGFA   EQU   RCANAME1
RCAFXLD  EQU   RCANAME1
RCAVEQR  EQU   RCANAME1
RCADSEG  EQU   RCANAME1
RCADLAS  EQU   RCANAME1
RCACSEG  EQU   RCANAME1
RCAVAMSI EQU   RCANAME1
@NM00041 EQU   RCAFLAGS
RCAQS    EQU   RCAFLAGS
RCAPSIER EQU   RCAFLAGS
RCAABEND EQU   RCAFLAGS
RCARES7  EQU   RCA+8
PVTEND   EQU   PVT+1840
PVTSPARE EQU   PVT+1838
PVTCHUIC EQU   PVT+1836
PVTCOMFX EQU   PVT+1834
PVTSQAFX EQU   PVT+1832
PVTCNTFX EQU   PVT+1830
PVTDEFFX EQU   PVT+1828
PVTFIXOK EQU   PVT+1826
PVTPEROK EQU   PVT+1824
PVTMAXFX EQU   PVT+1822
PVTPERFX EQU   PVT+1820
PVTRSRB  EQU   PVT+1776
PVTRESV5 EQU   PVT+1773
PVTSRBS  EQU   PVT+1772
PVTSSRB  EQU   PVT+1768
PVTACA   EQU   PVTWSAX+1400
PVTSAVE  EQU   PVTWSAX+1328
PVTWSA18 EQU   PVTWSAX+1256
PVTWSA17 EQU   PVTWSAX+1184
PVTWSA16 EQU   PVTWSAX+1112
PVTWSA15 EQU   PVTWSAX+1040
PVTWSA14 EQU   PVTWSAX+968
PVTWSA13 EQU   PVTWSAX+896
PVTWSA12 EQU   PVTWSAX+824
PVTWSA11 EQU   PVTWSAX+752
PVTWSA10 EQU   PVTWSAX+672
PVTWSA9  EQU   PVTWSAX+592
PVTWSA8  EQU   PVTWSAX+504
PVTWSA7  EQU   PVTWSAX+432
PVTWSA6  EQU   PVTWSAX+360
PVTWSA5  EQU   PVTWSAX+288
PVTWSA4  EQU   PVTWSAX+216
PVTWSA3  EQU   PVTWSAX+144
PVTWSA2  EQU   PVTWSAX+72
PVTWSA1  EQU   PVTWSAX
PVTCIOQL EQU   PVTQS+36
PVTCIOQF EQU   PVTQS+32
PVTGFADL EQU   PVTQS+28
PVTGFADF EQU   PVTQS+24
PVTFPCBL EQU   PVTQS+20
PVTFPCBF EQU   PVTQS+16
PVTSQAQL EQU   PVTQS+14
PVTSQAQF EQU   PVTQS+12
PVTCFQL  EQU   PVTQS+10
PVTCFQF  EQU   PVTQS+8
PVTRSRVL EQU   PVTQS+6
PVTRSRVF EQU   PVTQS+4
PVTAFQL  EQU   PVTQS+2
PVTAFQF  EQU   PVTQS
PVTSPFR  EQU   PVT+302
PVTCFMCT EQU   PVT+300
PVTSPREC EQU   PVT+296
PVTCAREC EQU   PVT+292
PVTCAOUT EQU   PVT+288
PVTCAIN  EQU   PVT+284
PVTNSWPS EQU   PVT+280
PVTNPREC EQU   PVT+276
PVTSPOUT EQU   PVT+272
PVTSPIN  EQU   PVT+268
PVTVAMR  EQU   PVT+264
PVTVAMO  EQU   PVT+260
PVTVAMI  EQU   PVT+256
PVTNPOUT EQU   PVT+252
PVTNPIN  EQU   PVT+248
PVTPRSET EQU   PVT+244
PVTFRSLT EQU   PVT+240
PVTPAGIO EQU   PVT+236
PVTPSWPP EQU   PVT+228
PVTPPREF EQU   PVT+224
PVTPOPBR EQU   PVT+220
PVTPRELF EQU   PVT+216
PVTPRELV EQU   PVT+212
PVTPFREE EQU   PVT+208
PVTPRELS EQU   PVT+204
PVTPOUT  EQU   PVT+200
PVTPFXLD EQU   PVT+196
PVTPITAS EQU   PVT+192
PVTPSRBP EQU   PVT+188
PVTPDSEG EQU   PVT+184
PVTPCSGB EQU   PVT+180
PVTPCSEG EQU   PVT+176
PVTPSOUT EQU   PVT+164
PVTPSWIN EQU   PVT+160
PVTPRCFI EQU   PVT+152
PVTPRCF  EQU   PVT+148
PVTPVRC  EQU   PVT+144
PVTPVRIN EQU   PVT+140
PVTPVRLS EQU   PVT+136
PVTPVEQR EQU   PVT+132
PVTPPIOI EQU   PVT+128
PVTPVRPO EQU   PVT+124
PVTPRFR  EQU   PVT+120
PVTPFP2  EQU   PVT+116
PVTPFP   EQU   PVT+112
PVTREP2  EQU   PVT+100
PVTPIOCP EQU   PVT+96
PVTPIOP  EQU   PVT+92
PVTPGFAD EQU   PVT+88
PVTPGFA  EQU   PVT+84
PVTPSQA  EQU   PVT+80
PVTPSINT EQU   PVT+76
PVTPSIB  EQU   PVT+72
PVTSRBID EQU   PVT+68
PVTPCIWA EQU   PVT+64
PVTHQSA  EQU   PVT+62
PVTLQSA  EQU   PVT+60
PVTOROOT EQU   PVT+56
PVTREUS  EQU   PVT+48
PVTRESV4 EQU   PVT+46
PVTRSUS  EQU   PVT+44
PVTVROOT EQU   PVT+40
PVTPCBLO EQU   PVT+38
PVTPCBCT EQU   PVT+36
PVTDFRS  EQU   PVT+34
PVTRSQA  EQU   PVT+32
PVTPTLB  EQU   PVT+31
PVTPCBNO EQU   PVT+30
PVTSRBNO EQU   PVT+29
PVTSQDC  EQU   PVT+28
PVTLCSA  EQU   PVT+26
PVTLPRIV EQU   PVT+24
PVTLVR   EQU   PVT+22
PVTFVR   EQU   PVT+20
PVTLPFN  EQU   PVT+18
PVTFPFN  EQU   PVT+16
PVTSSPIN EQU   PVT+11
PVTPCBS  EQU   PVT+10
PVTPOOL  EQU   PVT+8
PVTAFCOK EQU   PVT+6
PVTAFCLO EQU   PVT+4
PVTAFC   EQU   PVT+2
PVTFLAG2 EQU   PVT+1
PVTDUMP  EQU   PVTFLAG1
PVTSIT   EQU   PVTFLAG1
PVTLSI   EQU   PVTFLAG1
PVTRESV1 EQU   PVTFLAG1
PVTPCBLT EQU   PVTFLAG1
PVTSRBIU EQU   PVTFLAG1
PVTBGMS  EQU   PVTFLAG1
PVTPMSG  EQU   PVTFLAG1
PCBRWRKB EQU   PCBR+60
PCBRWRKA EQU   PCBR+56
PCBRWRK9 EQU   PCBR+52
PCBRWRK8 EQU   PCBR+48
PCBRWRK7 EQU   PCBR+44
PCBRWRK6 EQU   PCBR+40
PCBRWRK5 EQU   PCBR+36
PCBRWRK4 EQU   PCBR+32
PCBRWRK3 EQU   PCBR+28
PCBRWRK2 EQU   PCBR+24
PCBRWRK1 EQU   PCBR+20
PCBRRSV1 EQU   PCBR+18
PCBRCNT  EQU   PCBR+16
PCBRASCB EQU   PCBR+12
PCBRECB  EQU   PCBR+8
PCBRGOTO EQU   PCBR+4
PCBRTCBA EQU   PCBRTCB+1
PCBRPOF  EQU   PCBRFLAG
PCBRFECB EQU   PCBRFLAG
PCBRLOAD EQU   PCBRFLAG
PCBRFAIL EQU   PCBRFLAG
PCBRFPCB EQU   PCBRFLAG
PCBRPB   EQU   PCBRFLAG
PCBRETRY EQU   PCBRFLAG
PCBRINT  EQU   PCBRFLAG
PFTUIC   EQU   PFTE+15
PFTQNDX  EQU   PFTE+14
@NM00016 EQU   PFTFLAG2
@NM00015 EQU   PFTFLAG2
PFTPREF  EQU   PFTFLAG2
PFTSTEAL EQU   PFTFLAG2
PFTIRRG  EQU   PFTFLAG2
PFTVR    EQU   PFTFLAG2
PFTOFFLN EQU   PFTFLAG2
PFTDFRLS EQU   PFTFLAG2
PFTOFINT EQU   PFTFLAG1
PFTVRALC EQU   PFTFLAG1
PFTBADPG EQU   PFTFLAG1
PFTLNGFX EQU   PFTFLAG1
PFTLSQA  EQU   PFTFLAG1
PFTVRINT EQU   PFTFLAG1
PFTONAVQ EQU   PFTFLAG1
PFTRSV1  EQU   PFTE+10
PFTFXCT  EQU   PFTE+8
PFTBQPTR EQU   PFTQPTRS+2
PFTFQPTR EQU   PFTQPTRS
PFTVBN   EQU   PFTPGID+2
PFTASID  EQU   PFTPGID
PCBEND   EQU   PCB+64
PCBSPCTE EQU   PCBRB
PCBVBN   EQU   PCB+26
PCBPGTA  EQU   PCBPGT+1
PCBSWPS2 EQU   PCBFL3
@NM00014 EQU   PCBFL3
PCBNOREC EQU   PCBFL3
PCBDFRLS EQU   PCBFL3
PCBSWPLS EQU   PCBFL3
PCBSWPS1 EQU   PCBFL3
PCBSWPIN EQU   PCBFL3
PCBSWPOT EQU   PCBFL3
PCBXPTA  EQU   PCBXPT+1
@NM00013 EQU   PCBFL2
@NM00012 EQU   PCBFL2
PCBVIO   EQU   PCBFL2
PCBSUPRS EQU   PCBFL2
PCBRESET EQU   PCBFL2
PCBIOERR EQU   PCBFL2
PCBGFAD  EQU   PCBFL2
PCBFREAL EQU   PCBFL2
PCBRLPA  EQU   PCBRLP+1
PCBFXC   EQU   PCBRLP
PCBIOCMP EQU   PCBFL1
PCBIOI   EQU   PCBFL1
PCBROOT  EQU   PCBFL1
PCBLFR   EQU   PCBFL1
PCBLLHLD EQU   PCBFL1
PCBSRBMD EQU   PCBFL1
PCBPEX   EQU   PCBFL1
@NM00011 EQU   PCBFL1
PCBBQPA  EQU   PCBBQP
PCBCQN   EQU   PCBFQP
@NM00010 EQU   FRRSFLGS+1
@NM00009 EQU   FRRSFLG1
FRRSNEST EQU   FRRSFLG1
FRRSRCUR EQU   FRRSFLG1
FRRSENTS EQU   FRRS+84
FRRSRTMW EQU   FRRS+16
CVTLEVL  EQU   CVTRELNO+2
CVTNUMB  EQU   CVTRELNO
CVTMDL   EQU   CVTFIX+250
@NM00008 EQU   CVTFIX+248
@NM00007 EQU   CVTFIX
CVTRV482 EQU   CVTXTNT2+128
CVTRV481 EQU   CVTXTNT2+124
CVTRV480 EQU   CVTXTNT2+120
CVTRV479 EQU   CVTXTNT2+118
CVTRV478 EQU   CVTXTNT2+117
CVTRV477 EQU   CVTXTNT2+116
CVTRV476 EQU   CVTXTNT2+115
CVTRV475 EQU   CVTXTNT2+114
CVTRV474 EQU   CVTRV466
CVTRV473 EQU   CVTRV466
CVTRV472 EQU   CVTRV466
CVTRV471 EQU   CVTRV466
CVTRV470 EQU   CVTRV466
CVTRV469 EQU   CVTRV466
CVTRV468 EQU   CVTRV466
CVTRV467 EQU   CVTRV466
CVTRV465 EQU   CVTRV457
CVTRV464 EQU   CVTRV457
CVTRV463 EQU   CVTRV457
CVTRV462 EQU   CVTRV457
CVTRV461 EQU   CVTRV457
CVTRV460 EQU   CVTRV457
CVTRV459 EQU   CVTRV457
CVTRV458 EQU   CVTRV457
CVTRV456 EQU   CVTXTNT2+108
CVTRV455 EQU   CVTXTNT2+104
CVTRV454 EQU   CVTXTNT2+100
CVTRV453 EQU   CVTXTNT2+96
CVTRV452 EQU   CVTXTNT2+94
CVTRV451 EQU   CVTXTNT2+92
CVTRV450 EQU   CVTXTNT2+90
CVTRV449 EQU   CVTXTNT2+88
CVTRV448 EQU   CVTXTNT2+87
CVTRV447 EQU   CVTXTNT2+86
CVTRV446 EQU   CVTRV438
CVTRV445 EQU   CVTRV438
CVTRV444 EQU   CVTRV438
CVTRV443 EQU   CVTRV438
CVTRV442 EQU   CVTRV438
CVTRV441 EQU   CVTRV438
CVTRV440 EQU   CVTRV438
CVTRV439 EQU   CVTRV438
CVTRV437 EQU   CVTRV429
CVTRV436 EQU   CVTRV429
CVTRV435 EQU   CVTRV429
CVTRV434 EQU   CVTRV429
CVTRV433 EQU   CVTRV429
CVTRV432 EQU   CVTRV429
CVTRV431 EQU   CVTRV429
CVTRV430 EQU   CVTRV429
CVTRV428 EQU   CVTXTNT2+80
CVTRV427 EQU   CVTXTNT2+76
CVTRV426 EQU   CVTXTNT2+72
CVTRV425 EQU   CVTXTNT2+68
CVTATACT EQU   CVTATCVT
CVTRV423 EQU   CVTXTNT2+62
CVTRV422 EQU   CVTXTNT2+60
CVTRV421 EQU   CVTXTNT2+58
CVTRV420 EQU   CVTXTNT2+56
CVTRV419 EQU   CVTXTNT2+55
CVTRV418 EQU   CVTXTNT2+54
CVTRV417 EQU   CVTRV409
CVTRV416 EQU   CVTRV409
CVTRV415 EQU   CVTRV409
CVTRV414 EQU   CVTRV409
CVTRV413 EQU   CVTRV409
CVTRV412 EQU   CVTRV409
CVTRV411 EQU   CVTRV409
CVTRV410 EQU   CVTRV409
CVTRV408 EQU   CVTRV400
CVTRV407 EQU   CVTRV400
CVTRV406 EQU   CVTRV400
CVTRV405 EQU   CVTRV400
CVTRV404 EQU   CVTRV400
CVTRV403 EQU   CVTRV400
CVTRV402 EQU   CVTRV400
CVTRV401 EQU   CVTRV400
CVTICB   EQU   CVTXTNT2+48
CVTSKTA  EQU   CVTXTNT2+44
CVTRSV99 EQU   CVTXTNT2+40
CVTRSV98 EQU   CVTXTNT2+36
CVTRSV97 EQU   CVTXTNT2+34
CVTRSV96 EQU   CVTXTNT2+32
CVTOLTEP EQU   CVTXTNT2+28
CVTQIDA  EQU   CVTQID+1
CVTRSV95 EQU   CVTQID
CVTRSV94 EQU   CVTXTNT2+20
CVTRSV93 EQU   CVTXTNT2+16
CVTRSV92 EQU   CVTXTNT2+12
CVTDEBVR EQU   CVTXTNT2+8
CVTRSV91 EQU   CVTXTNT2+6
CVTRSV9H EQU   CVTFLGBT
CVTRSV9G EQU   CVTFLGBT
CVTRSV9F EQU   CVTFLGBT
CVTRSV9E EQU   CVTFLGBT
CVTRSV9D EQU   CVTFLGBT
CVTRSV9C EQU   CVTFLGBT
CVTVME   EQU   CVTFLGBT
CVTNPE   EQU   CVTFLGBT
CVTNUCLS EQU   CVTXTNT2+4
CVTDSSVA EQU   CVTDSSV+1
CVTRSV89 EQU   CVTDSSV
CVTRSV88 EQU   CVTXTNT1+8
CVTRSV87 EQU   CVTXTNT1+4
CVTFACHN EQU   CVTXTNT1
CVTRV488 EQU   CVTMAP+412
CVTRV487 EQU   CVTMAP+408
CVTRV486 EQU   CVTMAP+404
CVTRV485 EQU   CVTMAP+400
CVTACTAP EQU   CVTMAP+396
CVTAUTH  EQU   CVTMAP+392
CVTATMCA EQU   CVTATMCT+1
CVTATMST EQU   CVTATMCT
CVTRSV61 EQU   CVTMAP+384
CVTVOLT1 EQU   CVTVOLM1+1
CVTVOLI1 EQU   CVTVOLF1
CVTSTOA  EQU   CVTMAP+376
CVTRSV58 EQU   CVTMAP+374
CVTRSV57 EQU   CVTMAP+372
CVTDDCE  EQU   CVTMAP+368
CVTPNWFR EQU   CVTMAP+364
CVTSMF   EQU   CVTMAP+360
CVTSULK  EQU   CVTMAP+358
CVTSLKO  EQU   CVTSYSK
CVTSLKP  EQU   CVTSYSK
CVTSLKQ  EQU   CVTSYSK
CVTSLKR  EQU   CVTSYSK
CVTRSV56 EQU   CVTSYSK
CVTRSV55 EQU   CVTSYSK
CVTRSV54 EQU   CVTSYSK
CVTRSV53 EQU   CVTSYSK
CVTRSV52 EQU   CVTA1F1
CVTRSV51 EQU   CVTA1F1
CVTRSV50 EQU   CVTA1F1
CVTRSV49 EQU   CVTA1F1
CVTRSV48 EQU   CVTA1F1
CVTRSV47 EQU   CVTA1F1
CVTSRSW  EQU   CVTA1F1
CVTPFSW  EQU   CVTA1F1
CVTPCVT  EQU   CVTMAP+352
CVTRSV46 EQU   CVTMAP+344
CVTRSV45 EQU   CVTMAP+340
CVTRSV44 EQU   CVTMAP+338
CVTRSV43 EQU   CVTMAP+336
CVTHJESA EQU   CVTHJES+1
CVTRSV42 EQU   CVTHJES
CVTEXT2A EQU   CVTEXT2+1
CVTRSV41 EQU   CVTEXT2
CVTAPFA  EQU   CVTAPF+1
CVTRSV40 EQU   CVTAPF
CVTRV518 EQU   CVTINTLA
CVTRV517 EQU   CVTERPV
CVTEORM  EQU   CVTMAP+312
CVTMCHPR EQU   CVTMAP+308
CVTTZ    EQU   CVTMAP+304
CVTJEPS  EQU   CVTMAP+300
CVTJESCT EQU   CVTMAP+296
CVTMODE  EQU   CVTMAP+292
CVTPTRV  EQU   CVTMAP+288
CVTREAL  EQU   CVTMAP+284
CVTRSV39 EQU   CVTMAP+280
CVTRSV38 EQU   CVTMAP+276
CVTDMSRA EQU   CVTDMSR+1
CVTRV634 EQU   CVTDMSRF
CVTRV633 EQU   CVTDMSRF
CVTRV632 EQU   CVTDMSRF
CVTRV631 EQU   CVTDMSRF
CVTRV630 EQU   CVTDMSRF
CVTRV629 EQU   CVTDMSRF
CVTUDUMP EQU   CVTDMSRF
CVTSDUMP EQU   CVTDMSRF
CVTQMSGA EQU   CVTQMSG+1
CVTRSV36 EQU   CVTQMSG
CVTAMFF  EQU   CVTMAP+264
CVTPURGA EQU   CVTPURG+1
CVTRSV35 EQU   CVTPURG
CVTCBSP  EQU   CVTMAP+256
CVTATERA EQU   CVTATER+1
CVTSYST  EQU   CVTATER
CVTVOLT2 EQU   CVTTAT
CVTVOLI2 EQU   CVTVOLF2
CVTAQAVB EQU   CVTAQAVT+1
CVTRSV34 EQU   CVTTCMFG
CVTRSV33 EQU   CVTTCMFG
CVTRSV32 EQU   CVTTCMFG
CVTRSV31 EQU   CVTTCMFG
CVTRSV30 EQU   CVTTCMFG
CVTRSV29 EQU   CVTTCMFG
CVTRSV28 EQU   CVTTCMFG
CVTTCRDY EQU   CVTTCMFG
CVTGTFA  EQU   CVTGTF+1
CVTRSV27 EQU   CVTGTFST
CVTRNIO  EQU   CVTGTFST
CVTUSR   EQU   CVTGTFST
CVTRV318 EQU   CVTFORM
CVTRV317 EQU   CVTTMODE
CVTRV316 EQU   CVTSTATE
CVTRV315 EQU   CVTGTFS
CVTGTFAV EQU   CVTGTFS
CVT0SCR1 EQU   CVTMAP+232
CVTRV515 EQU   CVTMAP+228
CVTRMS   EQU   CVTMAP+224
CVTPATCH EQU   CVTMAP+220
CVTTSCE  EQU   CVTMAP+216
CVTLNKSC EQU   CVTMAP+214
CVTQABST EQU   CVTMAP+212
CVTMDLDS EQU   CVTMAP+208
CVTUSER  EQU   CVTMAP+204
CVTABEND EQU   CVTMAP+200
CVTSMCA  EQU   CVTMAP+196
CVTRSV18 EQU   CVTMAP+192
CVTQLPAQ EQU   CVTMAP+188
CVTQCDSR EQU   CVTMAP+184
CVTRSV17 EQU   CVTOPTB
CVTRSV16 EQU   CVTOPTB
CVTFP    EQU   CVTOPTB
CVTAPTHR EQU   CVTOPTB
CVTNLOG  EQU   CVTOPTB
CVTTOD   EQU   CVTOPTB
CVTCTIMS EQU   CVTOPTB
CVTPROT  EQU   CVTOPTB
CVTXPFP  EQU   CVTOPTA
CVTASCII EQU   CVTOPTA
CVTRSV13 EQU   CVTOPTA
CVTRSV12 EQU   CVTOPTA
CVTNIP   EQU   CVTOPTA
CVTDDR   EQU   CVTOPTA
CVTAPR   EQU   CVTOPTA
CVTCCH   EQU   CVTOPTA
CVTSNCTR EQU   CVTMAP+180
CVTQMWR  EQU   CVTMAP+176
CVTQOCR  EQU   CVTMAP+172
CVT1EF00 EQU   CVTMAP+168
CVTMZ00  EQU   CVTMAP+164
CVTHEAD  EQU   CVTMAP+160
CVTRSV11 EQU   CVTMAP+156
CVT0PT01 EQU   CVTMAP+152
CVTMSER  EQU   CVTMAP+148
CVTRV516 EQU   CVTIERLC
CVTILCH  EQU   CVTMAP+140
CVT0DS   EQU   CVTMAP+136
CVTFBOSV EQU   CVTMAP+132
CVTNUCB  EQU   CVTMAP+128
CVTIXAVL EQU   CVTMAP+124
CVTIOQET EQU   CVTMAP+120
CVTDCBA  EQU   CVTMAP+117
CVTMVS2  EQU   CVTDCB
CVT6DAT  EQU   CVTDCB
CVT4MPS  EQU   CVTDCB
CVTRSV09 EQU   CVTDCB
CVT4MS1  EQU   CVTDCB
CVT2SPS  EQU   CVTDCB
CVT1SSS  EQU   CVTDCB
CVTRSV08 EQU   CVTDCB
CVTSTB   EQU   CVTMAP+112
CVTQTD00 EQU   CVTMAP+108
CVTQTE00 EQU   CVTMAP+104
CVTCUCB  EQU   CVTMAP+100
CVTSJQ   EQU   CVTMAP+96
CVTPBLDL EQU   CVTMAP+92
CVTTPC   EQU   CVTMAP+88
CVTSVDCB EQU   CVTMAP+84
CVTBRET  EQU   CVTMAP+82
CVTEXIT  EQU   CVTMAP+80
CVT0FN00 EQU   CVTMAP+76
CVTDARA  EQU   CVTDAR+1
CVTRSV07 EQU   CVTFLGS1
CVTRSV06 EQU   CVTFLGS1
CVTRSV05 EQU   CVTFLGS1
CVTRSV04 EQU   CVTFLGS1
CVTRSV03 EQU   CVTFLGS1
CVTRSV02 EQU   CVTFLGS1
CVTRSV01 EQU   CVTFLGS1
CVTDMPLK EQU   CVTFLGS1
CVTXITP  EQU   CVTMAP+68
CVTZDTAB EQU   CVTMAP+64
CVTMSLT  EQU   CVTMAP+60
CVTDATE  EQU   CVTMAP+56
CVTSYSAD EQU   CVTMAP+48
CVTXTLER EQU   CVTMAP+44
CVTILK2  EQU   CVTMAP+40
CVTILK1  EQU   CVTMAP+36
CVTPRLTV EQU   CVTMAP+32
CVTPCNVT EQU   CVTMAP+28
CVT0VL00 EQU   CVTMAP+24
CVTXAPG  EQU   CVTMAP+20
CVTBUF   EQU   CVTMAP+16
CVTJOB   EQU   CVTMAP+12
CVTLINK  EQU   CVTMAP+8
CVT0EF00 EQU   CVTMAP+4
CVTTCBP  EQU   CVTMAP
CVT      EQU   CVTMAP
ASXBEND  EQU   ASXB+232
ASXBRV25 EQU   ASXB+228
ASXBRV24 EQU   ASXB+224
ASXBPT0E EQU   ASXB+220
ASXBCRB4 EQU   ASXBCASW+3
ASXBCRB3 EQU   ASXBCASW+2
ASXBCRB2 EQU   ASXBCASW+1
ASXBCR06 EQU   ASXBCRB1
ASXBCR05 EQU   ASXBCRB1
ASXBCR04 EQU   ASXBCRB1
ASXBCR03 EQU   ASXBCRB1
ASXBCR02 EQU   ASXBCRB1
ASXBCR01 EQU   ASXBCRB1
ASXBTFD  EQU   ASXBCRB1
ASXBPIP  EQU   ASXBCRB1
ASXBCTDC EQU   ASXB+212
ASXBTDCB EQU   ASXB+208
ASXBRV19 EQU   ASXB+204
ASXBSENV EQU   ASXBSECR+1
ASXBRV34 EQU   ASCBSFLG
ASXBRV33 EQU   ASCBSFLG
ASXBRV32 EQU   ASCBSFLG
ASXBRV31 EQU   ASCBSFLG
ASXBRV30 EQU   ASCBSFLG
ASXBRV29 EQU   ASCBSFLG
ASXBRV28 EQU   ASCBSFLG
ASXBRV27 EQU   ASCBSFLG
ASXBUSER EQU   ASXB+192
ASXBLSRB EQU   ASXBAEQ+20
ASXBFSRB EQU   ASXBAEQ+16
ASXBLRQE EQU   ASXBAEQ+12
ASXBFRQE EQU   ASXBAEQ+8
ASXBLIQE EQU   ASXBAEQ+4
ASXBFIQE EQU   ASXBAEQ
ASXBETSK EQU   ASXB+164
ASXBSIRB EQU   ASXB+160
ASXBPSWD EQU   ASXB+152
ASXBPRG  EQU   ASXB+136
ASXBRV26 EQU   ASXB+132
ASXBOUSB EQU   ASXB+128
ASXBDDR  EQU   ASXB+124
ASXBRCTD EQU   ASXB+120
ASXBRSMD EQU   ASXB+116
ASXBFRWA EQU   ASXB+108
ASXBFLSA EQU   ASXB+36
ASXBIHSA EQU   ASXB+32
ASXBRV15 EQU   ASXB+28
ASXBRV14 EQU   ASXB+24
ASXBLWA  EQU   ASXB+20
ASXBMPST EQU   ASXB+16
ASXBRS00 EQU   ASXB+14
ASXBTCBS EQU   ASXB+12
ASXBLTCB EQU   ASXB+8
ASXBFTCB EQU   ASXB+4
ASXBASXB EQU   ASXB
ASXBEGIN EQU   ASXB
ASMCPRES EQU   ASMCPRSQ+4
ASMCPTAK EQU   ASMCPRSQ
ASMCPCNT EQU   ASMCPAVQ+4
ASMCPAVL EQU   ASMCPAVQ
ASMCPEXT EQU   ASMPOOLS+6
ASMCPSIZ EQU   ASMPOOLS+4
ASMCPID  EQU   ASMPOOLS
ASMRSV12 EQU   ASMVT+1000
ASMSAVE  EQU   ASMVT+928
ASMWKSA7 EQU   ASMVT+848
ASMWKSA6 EQU   ASMVT+768
ASMACEPC EQU   ASMVT+344
ASMSWKPC EQU   ASMVT+328
ASMBWKPC EQU   ASMVT+312
ASMIOEPC EQU   ASMVT+296
ASMRSV10 EQU   ASMVT+280
ASMPVACE EQU   ASMVT+276
ASMPIOFR EQU   ASMVT+272
ASMPVACQ EQU   ASMVT+268
ASMPMSGS EQU   ASMVT+264
ASMPMSG0 EQU   ASMVT+260
ASMPFRLG EQU   ASMVT+256
ASMPRLG  EQU   ASMVT+252
ASMPACT  EQU   ASMVT+248
ASMPSAV  EQU   ASMVT+244
ASMPCMP  EQU   ASMVT+240
ASMPCMPA EQU   ASMVT+236
ASMPCMPN EQU   ASMVT+232
ASMPCMPD EQU   ASMVT+228
ASMPEX   EQU   ASMVT+224
ASMVRMTR EQU   ASMVT+220
ASMPSRBC EQU   ASMVT+216
ASMPSRMT EQU   ASMVT+212
ASMPSWPD EQU   ASMVT+208
ASMPTM   EQU   ASMVT+204
ASMPFRSW EQU   ASMVT+200
ASMPFRSL EQU   ASMVT+196
ASMPQIOE EQU   ASMVT+192
ASMRSV8  EQU   ASMVT+184
ASMTASCB EQU   ASMVT+180
ASMRLGWQ EQU   ASMVT+176
ASMRLGRQ EQU   ASMVT+172
ASMTMECB EQU   ASMVT+168
ASMTCBPT EQU   ASMVT+164
ASMREQCT EQU   ASMVT+160
ASMGOSWK EQU   ASMGOSQS+4
ASMGOSWT EQU   ASMGOSQS
ASMLSAIH EQU   ASMLSAI+4
ASMLSAIL EQU   ASMLSAI
ASMCINV  EQU   ASMVT+140
ASMSTGXA EQU   ASMVT+136
ASMLGVT  EQU   ASMVT+132
ASMSLOTV EQU   ASMVT+128
ASMERRS  EQU   ASMVT+124
ASMNVSC  EQU   ASMVT+120
ASMVSC   EQU   ASMVT+116
ASMSLOTS EQU   ASMVT+112
ASMBKSLT EQU   ASMVT+108
ASMRSV7  EQU   ASMVT+92
ASMPSRB  EQU   ASMVT+88
ASMSRBCT EQU   ASMVT+84
ASMIOCNT EQU   ASMVT+80
ASMBURST EQU   ASMVT+76
ASMPCCWN EQU   ASMVT+72
ASMPCCWC EQU   ASMPCCWQ+4
ASMPCCWA EQU   ASMPCCWQ
ASMRSV6  EQU   ASMVT+48
ASMIORQC EQU   ASMVT+44
ASMIORQR EQU   ASMVT+40
ASMSTAGL EQU   ASMSTAGQ+4
ASMSTAGF EQU   ASMSTAGQ
ASMRSV5  EQU   ASMVT+28
ASMMSGBF EQU   ASMVT+24
ASMEREC  EQU   ASMVT+20
ASMTRPAG EQU   ASMVT+16
ASMGOS   EQU   ASMVT+12
ASMPART  EQU   ASMVT+8
ASMSART  EQU   ASMVT+4
ASMRSV4  EQU   ASMVT+2
ASMWARM  EQU   ASMFLAG2
ASMQUICK EQU   ASMFLAG2
ASMNOTPT EQU   ASMFLAG2
ASMNOTMR EQU   ASMFLAG2
ASMNOSAV EQU   ASMFLAG2
ASMCALLQ EQU   ASMFLAG2
ASMPLPAS EQU   ASMFLAG1
ASMCOMMF EQU   ASMFLAG1
ASMPLPAF EQU   ASMFLAG1
ASMNODPX EQU   ASMFLAG1
ASMRSV1  EQU   ASMFLAG1
ASMNOLCL EQU   ASMFLAG1
ASMNOCWQ EQU   ASMFLAG1
ASMDUPLX EQU   ASMFLAG1
ASCBEND  EQU   ASCB+208
ASCBSRBT EQU   ASCB+200
ASCBSWTL EQU   ASCB+196
ASCBRS14 EQU   ASCB+195
ASCBSMCT EQU   ASCB+194
ASCBRS12 EQU   ASCB+192
ASCBPCTT EQU   ASCB+188
ASCBVGTT EQU   ASCB+184
ASCBRV43 EQU   ASCBSRQ4
ASCBRV42 EQU   ASCBSRQ4
ASCBRV41 EQU   ASCBSRQ4
ASCBRV40 EQU   ASCBSRQ4
ASCBRV39 EQU   ASCBSRQ4
ASCBRV38 EQU   ASCBSRQ4
ASCBRV37 EQU   ASCBSRQ4
ASCBRV36 EQU   ASCBSRQ4
ASCBRV35 EQU   ASCBSRQ3
ASCBRV34 EQU   ASCBSRQ3
ASCBRV33 EQU   ASCBSRQ3
ASCBRV32 EQU   ASCBSRQ3
ASCBRV31 EQU   ASCBSRQ3
ASCBRV30 EQU   ASCBSRQ3
ASCBRV29 EQU   ASCBSRQ3
ASCBRV28 EQU   ASCBSRQ3
ASCBRV27 EQU   ASCBSRQ2
ASCBRV26 EQU   ASCBSRQ2
ASCBRV25 EQU   ASCBSRQ2
ASCBRV24 EQU   ASCBSRQ2
ASCBRV23 EQU   ASCBSRQ2
ASCBRV22 EQU   ASCBSRQ2
ASCBRV21 EQU   ASCBSRQ2
ASCBRV20 EQU   ASCBSRQ2
ASCBRV19 EQU   ASCBSRQ1
ASCBRV18 EQU   ASCBSRQ1
ASCBRV17 EQU   ASCBSRQ1
ASCBRV16 EQU   ASCBSRQ1
ASCBRV15 EQU   ASCBSRQ1
ASCBRV14 EQU   ASCBSRQ1
ASCBRV13 EQU   ASCBSRQ1
ASCBSTA  EQU   ASCBSRQ1
ASCBJBNS EQU   ASCB+176
ASCBJBNI EQU   ASCB+172
ASCBMCC  EQU   ASCB+168
ASCBRTWA EQU   ASCB+164
ASCBIQEA EQU   ASCB+160
ASCBXMPQ EQU   ASCB+156
ASCBRS01 EQU   ASCB+154
ASCBFMCT EQU   ASCB+152
ASCBOUXB EQU   ASCB+148
ASCBOUCB EQU   ASCB+144
ASCBMECB EQU   ASCB+140
ASCBQECB EQU   ASCB+136
ASCBLSQH EQU   ASCBLKGP+4
ASCBLOCK EQU   ASCBLKGP
ASCBTCBS EQU   ASCB+124
ASCBNVSC EQU   ASCB+122
ASCBVSC  EQU   ASCB+120
ASCBSRBS EQU   ASCB+118
ASCBSSRB EQU   ASCB+116
ASCBRV06 EQU   ASCBFLG2
ASCBRV05 EQU   ASCBFLG2
ASCBRV04 EQU   ASCBFLG2
ASCBSNQS EQU   ASCBFLG2
ASCBS2S  EQU   ASCBFLG2
ASCBCEXT EQU   ASCBFLG2
ASCBPXMT EQU   ASCBFLG2
ASCBXMPT EQU   ASCBFLG2
ASCBRF07 EQU   ASCBDSP1
ASCBRF06 EQU   ASCBDSP1
ASCBRF05 EQU   ASCBDSP1
ASCBRF04 EQU   ASCBDSP1
ASCBRF03 EQU   ASCBDSP1
ASCBRF02 EQU   ASCBDSP1
ASCBFAIL EQU   ASCBDSP1
ASCBNOQ  EQU   ASCBDSP1
ASCBSWCT EQU   ASCB+112
ASCBTMCH EQU   ASCB+104
ASCBNSWP EQU   ASCBFLG1
ASCBTYP1 EQU   ASCBFLG1
ASCBSTND EQU   ASCBFLG1
ASCBS3S  EQU   ASCBFLG1
ASCBCMSH EQU   ASCBFLG1
ASCBTOFF EQU   ASCBFLG1
ASCBRF01 EQU   ASCBRCTF
ASCBTMLW EQU   ASCBRCTF
ASCBOUT  EQU   ASCBRCTF
ASCBWAIT EQU   ASCBRCTF
ASCBRV08 EQU   ASCBRCTF
ASCBFQU  EQU   ASCBRCTF
ASCBFRS  EQU   ASCBRCTF
ASCBTMNO EQU   ASCBRCTF
ASCBAFFN EQU   ASCBFW1
ASCBDUMP EQU   ASCB+96
ASCBRV44 EQU   ASCB+92
ASCBUBET EQU   ASCB+88
ASCBECB  EQU   ASCB+84
ASCBJSTL EQU   ASCB+80
ASCBEWST EQU   ASCB+72
ASCBEJST EQU   ASCB+64
ASCBTSB  EQU   ASCB+60
ASCBCSCB EQU   ASCB+56
ASCBLDA  EQU   ASCB+48
ASCBSTOR EQU   ASCB+44
ASCBDP   EQU   ASCB+43
ASCBRV07 EQU   ASCB+42
ASCBIOSM EQU   ASCB+40
ASCBSEQN EQU   ASCB+38
ASCBCPUS EQU   ASCB+32
ASCBSPL  EQU   ASCB+28
ASCBIOSP EQU   ASCB+24
ASCBSYNC EQU   ASCBSUPC+4
ASCBSVRB EQU   ASCBSUPC
ASCBCMSF EQU   ASCB+12
ASCBBWDP EQU   ASCB+8
ASCBFWDP EQU   ASCB+4
ASCBEGIN EQU   ASCB
@NM00040 EQU   PSA+3668
PSASTAK  EQU   PSA+3072
@NM00039 EQU   PSA+1048
PSAUSEND EQU   PSA+1048
PSARV062 EQU   PSA+1044
PSACDAL  EQU   PSA+1040
PSAWTCOD EQU   PSA+1036
PSAATCVT EQU   PSA+1032
PSAPCPSW EQU   PSA+1024
PSAPIR2  EQU   PSA+1020
PSARV059 EQU   PSA+1018
PSASVC13 EQU   PSA+1016
PSASFACC EQU   PSA+1008
PSASTOP  EQU   PSA+992
PSASTART EQU   PSA+976
PSARSPSW EQU   PSA+968
PSASRPSW EQU   PSA+960
PSARV045 EQU   PSA+892
PSARV044 EQU   PSA+888
PSARV043 EQU   PSA+884
PSARV042 EQU   PSA+880
PSARV041 EQU   PSA+876
PSARV040 EQU   PSA+872
PSARV025 EQU   PSA+868
PSADSSED EQU   PSA+868
PSADSSPR EQU   PSA+864
PSADSSFW EQU   PSA+860
PSADSS14 EQU   PSA+856
PSADSSPP EQU   PSA+848
PSADSSRP EQU   PSA+840
PSADSS05 EQU   PSADSSF4
PSADSS10 EQU   PSADSSF4
PSADSSVE EQU   PSADSSF4
PSADSSDE EQU   PSADSSF4
PSADSSC0 EQU   PSADSSF4
PSADSSIE EQU   PSADSSF4
PSADSS12 EQU   PSADSSF4
PSADSSRC EQU   PSADSSF4
PSARV057 EQU   PSADSSF3
PSARV056 EQU   PSADSSF3
PSARV055 EQU   PSADSSF3
PSADSSMC EQU   PSADSSF3
PSADSSRW EQU   PSADSSF3
PSADSSNM EQU   PSADSSF3
PSADSSES EQU   PSADSSF3
PSADSSGP EQU   PSADSSF3
PSADSSF2 EQU   PSADSSFL+1
PSADSSPI EQU   PSADSSF1
PSADSSOI EQU   PSADSSF1
PSADSSSP EQU   PSADSSF1
PSADSSTP EQU   PSADSSF1
PSADSSDW EQU   PSADSSF1
PSADSSDD EQU   PSADSSF1
PSADSSDM EQU   PSADSSF1
PSADSSMV EQU   PSADSSF1
PSADSSTS EQU   PSA+816
PSADSSWK EQU   PSA+812
PSADSSR3 EQU   PSA+808
PSADSSR2 EQU   PSA+804
PSADSSRS EQU   PSA+800
PSASTOR  EQU   PSA+796
PSACPUSA EQU   PSA+794
PSAVSTAP EQU   PSA+792
PSAWKVAP EQU   PSA+788
PSAWKRAP EQU   PSA+784
PSAMCHIC EQU   PSA+783
PSARV061 EQU   PSA+782
PSASYMSK EQU   PSA+781
PSAMCHFL EQU   PSA+780
PSACR0   EQU   PSA+776
PSAPSWSV EQU   PSA+768
PSACLHS  EQU   PSAHLHI
PSALKR15 EQU   PSALKSA+60
PSALKR14 EQU   PSALKSA+56
PSALKR13 EQU   PSALKSA+52
PSALKR12 EQU   PSALKSA+48
PSALKR11 EQU   PSALKSA+44
PSALKR10 EQU   PSALKSA+40
PSALKR9  EQU   PSALKSA+36
PSALKR8  EQU   PSALKSA+32
PSALKR7  EQU   PSALKSA+28
PSALKR6  EQU   PSALKSA+24
PSALKR5  EQU   PSALKSA+20
PSALKR4  EQU   PSALKSA+16
PSALKR3  EQU   PSALKSA+12
PSALKR2  EQU   PSALKSA+8
PSALKR1  EQU   PSALKSA+4
PSALKR0  EQU   PSALKSA
PSARV023 EQU   PSACLHT+52
PSALOCAL EQU   PSACLHT+48
PSACMSL  EQU   PSACLHT+44
PSAOPTL  EQU   PSACLHT+40
PSATPACL EQU   PSACLHT+36
PSATPDNL EQU   PSACLHT+32
PSATPNCL EQU   PSACLHT+28
PSAIOSLL EQU   PSACLHT+24
PSAIOSUL EQU   PSACLHT+20
PSAIOSCL EQU   PSACLHT+16
PSAIOSSL EQU   PSACLHT+12
PSASALCL EQU   PSACLHT+8
PSAASML  EQU   PSACLHT+4
PSADISPL EQU   PSACLHT
PSASRSA  EQU   PSA+636
PSARV050 EQU   PSA+634
PSADSSGO EQU   PSA+633
PSARECUR EQU   PSA+632
PSAHLHIS EQU   PSA+628
PSAIPCSA EQU   PSA+624
@NM00038 EQU   PSA+621
PSAIPCDM EQU   PSA+620
PSAIPCD  EQU   PSA+616
@NM00037 EQU   PSA+613
PSAIPCRM EQU   PSA+612
PSAIPCR  EQU   PSA+608
PSAMCHEX EQU   PSA+600
PSAMPSW  EQU   PSA+592
PSAEXPS2 EQU   PSA+584
PSAEXPS1 EQU   PSA+576
PSAPIREG EQU   PSA+572
PSARSREG EQU   PSA+568
PSAGPREG EQU   PSA+556
PSARV022 EQU   PSASUP4
PSARV021 EQU   PSASUP4
PSARV020 EQU   PSASUP4
PSARV019 EQU   PSASUP4
PSARV018 EQU   PSASUP4
PSARV017 EQU   PSASUP4
PSARV016 EQU   PSASUP4
PSARV015 EQU   PSASUP4
PSARV014 EQU   PSASUP3
PSARV013 EQU   PSASUP3
PSARV012 EQU   PSASUP3
PSAESTA  EQU   PSASUP3
PSASPR   EQU   PSASUP3
PSAPSREG EQU   PSASUP3
PSAPI2   EQU   PSASUP3
PSAIOSUP EQU   PSASUP3
PSALCR   EQU   PSASUP2
PSARTM   EQU   PSASUP2
PSAACR   EQU   PSASUP2
PSAIPCE2 EQU   PSASUP2
PSAIPCES EQU   PSASUP2
PSAIPCEC EQU   PSASUP2
PSAGTF   EQU   PSASUP2
PSAIPCRI EQU   PSASUP2
PSATYPE6 EQU   PSASUP1
PSATCTL  EQU   PSASUP1
PSADISP  EQU   PSASUP1
PSALOCK  EQU   PSASUP1
PSAPI    EQU   PSASUP1
PSAEXT   EQU   PSASUP1
PSASVC   EQU   PSASUP1
PSAIO    EQU   PSASUP1
PSAANEW  EQU   PSA+544
PSATOLD  EQU   PSA+540
PSATNEW  EQU   PSA+536
PSALCCAR EQU   PSA+532
PSALCCAV EQU   PSA+528
PSAPCCAR EQU   PSA+524
PSAPCCAV EQU   PSA+520
PSACPULA EQU   PSA+518
PSACPUPA EQU   PSA+516
PSAPSA   EQU   PSA+512
FLCHDEND EQU   PSA+512
FLCCRSAV EQU   FLCMCLA+280
FLCGRSAV EQU   FLCMCLA+216
FLCFPSAV EQU   FLCMCLA+184
FLCFLA   EQU   FLCMCLA+88
FLCRGNCD EQU   FLCMCLA+84
FLCFSAA  EQU   FLCFSA+1
@NM00036 EQU   FLCFSA
@NM00035 EQU   FLCMCLA+72
FLCMCIC  EQU   FLCMCLA+64
@NM00034 EQU   FLCMCLA+20
FLCIOAA  EQU   FLCIOA+1
@NM00033 EQU   FLCIOA
@NM00032 EQU   FLCMCLA+15
@NM00031 EQU   FLCMCLA+14
@NM00030 EQU   FLCMCLA+12
FLCLCL   EQU   FLCMCLA+8
FLCIOELA EQU   FLCIOEL+1
@NM00029 EQU   FLCIOEL
FLCCHNID EQU   FLCMCLA
@NM00028 EQU   PSA+160
FLCMTRCD EQU   PSA+157
@NM00027 EQU   PSA+156
FLCPERA  EQU   FLCPER+1
@NM00026 EQU   FLCPER
@NM00025 EQU   PSA+151
FLCPERCD EQU   PSA+150
FLCMCNUM EQU   PSA+149
@NM00024 EQU   PSA+148
FLCTEAA  EQU   FLCTEA+1
@NM00023 EQU   FLCTEA
PSAPIPC  EQU   PSAPICOD
PSAPIMC  EQU   PSAPICOD
PSAPIPER EQU   PSAPICOD
PSARV049 EQU   FLCPICOD
FLCPILCB EQU   FLCPIILC
@NM00022 EQU   FLCPIILC
@NM00021 EQU   PSAEPPSW
FLCSVCN  EQU   PSAESPSW+2
FLCSILCB EQU   FLCSVILC
@NM00020 EQU   FLCSVILC
@NM00019 EQU   PSAESPSW
FLCEICOD EQU   PSAEEPSW+2
PSASPAD  EQU   PSAEEPSW
@NM00018 EQU   PSA+128
FLCINPSW EQU   PSA+120
FLCMNPSW EQU   PSA+112
FLCPNPSW EQU   PSA+104
FLCSNPSW EQU   PSA+96
FLCENPSW EQU   PSA+88
FLCTRACE EQU   PSA+84
FLCTIMER EQU   PSA+80
FLCCVT2  EQU   PSA+76
FLCCAW   EQU   PSA+72
FLCCSW   EQU   PSA+64
FLCIOPSW EQU   PSA+56
FLCMOPSW EQU   PSA+48
FLCPOPSW EQU   PSA+40
FLCSOPSW EQU   PSA+32
FLCEOPSW EQU   PSA+24
@NM00017 EQU   FLCICCW2+4
FLCICCW1 EQU   FLCROPSW
FLCIPPSW EQU   FLCRNPSW
.@UNREFD ANOP                          END UNREFERENCED COMPONENTS
@ENDDATA EQU   *
         END   IEAVPIOI,(C'PLS1636',0701,76086)
