         TITLE 'IEAVRSM - PAGE VECTOR TABLE CSECT'
* /* START OF SPECIFICATIONS ****
*
*01*  MODULE-NAME = IEAVRSM
*
*01*  DESCRIPTIVE-NAME = PAGE VECTOR TABLE (PVT) CSECT
*
*01*  COPYRIGHT = NONE
*
*01*  STATUS = NEW FOR VS2 RELEASE 2
*
*01*  FUNCTION = CONTAINS THE PVT, WHICH IS AN EXTENSION OF THE CVT FOR
*                THE USE OF REAL STORAGE MANAGEMENT.
*
*02*     OPERATION = THE IHAPVT MACRO IS EXPANDED WITH THE 'DSECT=NO'
*                    OPTION TO CREATE A PVT CSECT.
*
*01*   NOTES = FIELD CVTPVTP IN THE CVT POINTS TO THE HEAD OF THE PVT
*              IN THIS CSECT VIA A VCON FOR THE LABEL 'CSECPVT'.
*
*02*     DEPENDENCIES = DEPENDS ON THE IHAPVT MACRO. UPDATE OF THE
*                       PVT IS CONTROLLED BY THE SALLOC LOCK.
*
*03*        CHARACTER-CODE-DEPENDENCIES = NONE
*
*02*     RESTRICTIONS = THE PVT CAN BE UPDATED ONLY BY HOLDERS OF THE
*                       SALLOC LOCK.
*
*02*     REGISTER-CONVENTIONS = NOT APPLICABLE
*
*02*     PATCH-LABEL = PVTSPARE IS AN AREA RESERVED FOR FUTURE USE.
*
*01*   MODULE-TYPE = TABLE
*
*02*     PROCESSOR = ASSEMBLER-370R
*
*02*     MODULE-SIZE = 1584 BYTES
*
*02*     ATTRIBUTES = NUCLEUS, NOT EXECUTABLE
*
*01*  ENTRY-POINT = NOT APPLICABLE
*
*02*     PURPOSE = NOT APPLICABLE
*02*     LINKAGE = NOT APPLICABLE
*02*     INPUT = NOT APPLICABLE
*02*     OUTPUT = NOT APPLICABLE
*02*     REGISTERS-SAVED = NOT APPLICABLE
*
*01*  EXIT-NORMAL = NOT APPLICABLE
*
*02*     CONDITIONS = NOT APPLICABLE
*02*     OUTPUT = NOT APPLICABLE
*02*     RETURN-CODES = NOT APPLICABLE
*
*01*  EXIT-ERROR = NOT APPLICABLE
*
*02*     CONDITIONS = NOT APPLICABLE
*02*     OUTPUT = NOT APPLICABLE
*02*     RETURN-CODES = NOT APPLICABLE
*
*01*  EXTERNAL-REFERENCES = REFER TO THE VCONS SECTION OF THE PVT
*                    WHICH CONTAINS VCONS FOR MOST RSM ENTRY POINTS.
*                    ALSO IN THE PVT IS A POINTER TO THE PAGE FRAME
*                    TABLE (PVTPFTP) WHICH IS FILLED IN BY NIP.
*
*02*     CONTROL-BLOCKS = IHAPVT (C)
*
*01*  MACROS = IHAPVT
*
*02*    SERIALIZATION = SALLOC LOCK SERIALIZES UPDATE OF THE PVT.
*
*01*  CHANGE-ACTIVITY = Y02752, Y02753, 702751  (VS2 RELEASE 2)
*
*01*  MESSAGES = NONE
*01*  ABEND-CODES = NONE
**** END OF SPECIFICATIONS ***/
         EJECT
***********************************************************************
*  THIS CSECT DEFINES THE PAGING VECTOR TABLE FOR THE SYSTEM  AND     *
*  IT IS POINTED TO BY THE CVT FIELD CVTPVTP. THERE IS NO EXECUTABLE  *
*  CODE IN THE CSECT, BUT IT CONTAINS A VARIETY OF INFORMATION        *
*  NECESSARY FOR THE FUNCTIONING OF THE REAL STORAGE MANAGER. REFER   *
*  TO THE COMMENTS IN THE IHAPVT MACRO (BELOW) FOR FURTHER DETAILS.   *
***********************************************************************
         SPACE 5
IEAVRSM  CSECT
         ENTRY PVT             THIS ENTRY IS FOR CONVENIENT REFERENCE
         ENTRY CSECPVT
         MODID BR=NO           IDENTIFY THE CSECT
PVT      IHAPVT DSECT=NO       DEFINE STORAGE FOR THE PVT
CSECPVT  EQU   PVT             THIS LABEL IS USED TO INITIALIZE THE
*                              PVT POINTER IN THE CVT (CVTPVTP).
*                                                          @G33VPOD
         SPACE 2
**********************************************************************
*        PVT CONSTANTS THAT AFFECT THE PERFORMANCE AND EFFECTIVENESS *
*        OF RSM ARE INITIALIZED HERE. THEY CAN BE ALTERED TO ACHIEVE *
*        DIFFERENT OPERATIONAL CHARACTERISTICS, BUT BE WARNED THAT   *
*        THE EFFECTS CAN BE VERY SUBTLE AND THAT MODIFICATIONS       *
*        TO ASM INITIALIZATION AND/OR SRM ALGORITHMS MIGHT ALSO      *
*        ALSO BE REQUIRED.                                           *
**********************************************************************
         ORG    PVTFLAG1       SET FLAG1 TO 02
         DC     BL1'00000010'  TURN ON PVTSIT BIT
         ORG    PVTAFCLO       SET AFC LOW THRESHOLD VALUE
         DC     H'10'          VALUE IS 10
         ORG    PVTAFCOK       SET AFC O.K. THRESHOLD VALUE
         DC     H'14'          VALUE IS 14
         ORG    PVTPCBS        SET INITIAL NUMBER OF PCBS
         DC     AL1(100)       VALUE IS 100                    @Z30GNYD
         ORG    PVTSRBNO       SET NUMBER OF SRB'S FOR REPLENISH
*                              ATTEMPTS                        @Z30GNYD
         DC     AL1(10)        VALUE IS 10                     @Z30GNYD
         ORG    PVTSRBS        SET NUMBER FO SRB'S TO BE
*                              INITIALLY BUILT                 @Z30GNYD
         DC     AL1(20)        VALUE IS 20                     @Z30GNYD
         ORG    PVTPCBNO       SET NUMBER OF PCBS FOR
*                              REPLENISH ATTEMPTS
         DC     AL1(18)        VALUE IS 18
         ORG    PVTPCBLO       SET PCB POOL LOW THRESHOLD VALUE
         DC     H'3'           VALUE IS 3
         ORG    PVTREUS        SET PTR TO RESERVED SRB         @Z40WPYD
         DC     F'0'           INITIAL VALUE IS ZERO           @Z40WPYD
         ORG    PVTPERFX       SET THE PERCENTAGE OF AVAILABLE FRAMES
*                              WHICH MAY BE FIXED              @ZM01572
         DC     H'80'          PERCENTAGE IS 80                @ZM01572
         ORG    PVTPEROK       SET THE PERCENTAGE OF AVAILABLE FRAMES
*                              USED TO DETERMINE PVTFIXOK      @ZM01572
         DC     H'60'          PERCENTAGE IS 60                @ZM01572
         ORG    PVTMAXFX       SET FIXED FRAME THRESHOLD       @YA01572
         DC     XL2'7FFF'      VALUE IS HEX. 7FFF              @YA01572
         ORG    PVTDEFFX       SET THE NUMBER AT WHICH FIX REQUESTS ARE
*                              DEFFERED WHEN THE AFQ EQUALS IT @YA01572
         DC     H'4'           VALUE IS 2                      @YA01572
         ORG    PVTCNTFX       SET INITIAL SYSTEM FRAME COUNT  @YA01572
         DC     XL2'1000'      VALUE IS HEX. 1000              @YA01572
         ORG    ,              RESTORE ASSEMBLERS LOCATION POINTER
         END
