         TITLE 'IEAVTCR1 - ACR RECURSION HANDLER                       *
                        '
IEAVTCR1 CSECT ,                                                   0001
@MAINENT DS    0H                                                  0001
         USING *,@15                                               0001
         B     @PROLOG                                             0001
         DC    AL1(16)                                             0001
         DC    C'IEAVTCR1  74.085'                                 0001
         DROP  @15
@PROLOG  BALR  @08,0                                               0001
@PSTART  DS    0H                                                  0001
         USING @PSTART,@08                                         0001
*                                      AREA IN ACRSA                 */
*   DO;                             /* BEGIN SEGMENT 'CR1INIT'       */
*                                                                  0098
*     /***************************************************************/
*     /*                                                             */
*     /* SEGMENT 'CR1INIT' INITIALIZES THE RECOVERY ROUTINE WHEN     */
*     /* ENTERED VIA FRR ROUTING OR DIRECT RTM BRANCH                */
*     /*                                                             */
*     /***************************************************************/
*                                                                  0099
*     IF PSAACR=ON THEN             /* WERE WE ENTERED VIA DIRECT  0099
*                                      BRANCH FROM RTM(SUPER BIT ON) */
         TM    PSAACR,B'00000100'                                  0099
         BNO   @RF00099                                            0099
*       ENTTYPE=1;                  /* DIRECT BRANCH FROM RTM        */
         LA    ENTTYPE,1                                           0100
*     ELSE                          /* FRR ROUTING                   */
*       ENTTYPE=0;                  /* INDICATE FRR TYPE ENTRY       */
         B     @RC00099                                            0101
@RF00099 SLR   ENTTYPE,ENTTYPE                                     0101
*     PSAACR=ON;                    /* TURN ON SUPER BIT             */
@RC00099 OI    PSAACR,B'00000100'                                  0102
*     LCCAPTR=PSALCCAV;             /* PICK UP LCCA PTR FROM PSA     */
         L     LCCAPTR,PSALCCAV                                    0103
*     IF LCCACRIN=ON THEN           /* DOES LCCA SHOW ACR TO BE IN 0104
*                                      PRE-PROCESSOR PHASE           */
         TM    LCCACRIN(LCCAPTR),B'00001000'                       0104
         BNO   @RF00104                                            0104
*       RRPLPTR=LCCACPUS->WSACACR->ACRRRPLP;/* YES, PRE-PROCESSOR GET
*                                      RRPL PTR FROM CURNT CPU'S   0105
*                                      ACRSA                         */
         L     @15,LCCACPUS(,LCCAPTR)                              0105
         L     @15,WSACACR(,@15)                                   0105
         L     RRPLPTR,ACRRRPLP(,@15)                              0105
*     ELSE                          /* NOT PRE-PROCESSOR PHASE       */
*       RRPLPTR=LCCARCPU->LCCACPUS->WSACACR->ACRRRPLP;/* GET RRPL PTR
*                                      FROM RECOVERY CPU'S ACRSA     */
         B     @RC00104                                            0106
@RF00104 L     @15,LCCARCPU(,LCCAPTR)                              0106
         L     @15,LCCACPUS(,@15)                                  0106
         L     @15,WSACACR(,@15)                                   0106
         L     RRPLPTR,ACRRRPLP(,@15)                              0106
*   END;                            /* END SEGMENT CR1INIT           */
@RC00104 DS    0H                                                  0108
*   IF RRPLRTRY=ON THEN             /* WAS A RETRY IN PROGRESS WHEN
*                                      CODE TOOK THE HIT             */
         TM    RRPLRTRY(RRPLPTR),B'10000000'                       0108
         BNO   @RF00108                                            0108
*     DO;                           /* SEGMENT CR1STERM BEGIN        */
*                                                                  0109
*       /*************************************************************/
*       /*                                                           */
*       /* SEGMENT CR1STERM HANDLES THE INTERFACE TO THE SYSTEM      */
*       /* TERMINATION FACILITY WHEN RECOVERY FOR ACR FAILURES CANNOT*/
*       /* BE DONE. IF ENTRY WAS VIA PSAACR FLAG THEN REG0 CONTAINS  */
*       /* THE FUNCTION CODE FROM RTM1. IF ENTRY WAS VIA FRR ROUTNIG */
*       /* THEN REG1 POINTS TO THE RTCA.                             */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0110
*       RFY                                                        0110
*        (BMSGPTR) RSTD;                                           0110
*       BMSGPTR=ADDR(ACRACRSV);     /* USE AREA FOR BUILDING MSG     */
         L     @15,LCCACPUS(,LCCAPTR)                              0111
         L     BMSGPTR,WSACACR(,@15)                               0111
         LA    BMSGPTR,ACRACRSV(,BMSGPTR)                          0111
*       BUILD857=M857W;             /* MOVE IN SKELETON OF MSG       */
         MVC   BUILD857(43,BMSGPTR),M857W                          0112
*       B857TYPE='S';               /* SET TUPE OF ERROR TO        0113
*                                      'SOFTWARE'                    */
         MVI   B857TYPE(BMSGPTR),C'S'                              0113
*       IF ENTTYPE=1 THEN           /* ENTERED FOR SUPER BIT         */
         CH    ENTTYPE,@CH00066                                    0114
         BNE   @RF00114                                            0114
*         DO;                       /* YES, SUPER                    */
*           IF REG0=RT1WMCHR THEN   /* WAS THIS MACHINE CHECK        */
         CH    REG0,@CH00069                                       0116
         BNE   @RF00116                                            0116
*             B857TYPE='H';         /* YES, INDICATE HARDWARE FAILURE
*                                      IN MESSAGE                    */
         MVI   B857TYPE(BMSGPTR),C'H'                              0117
*         END;                      /* END OF SUPER CHECK            */
*       ELSE                        /* NOT SUPER BIT ENTRY           */
*         DO;                                                      0119
         B     @RC00114                                            0119
@RF00114 DS    0H                                                  0120
*           IF SDWAMCHK=ON THEN     /* WAS THIS MACHINE CHECK        */
         TM    SDWAMCHK(SDWAPTR),B'10000000'                       0120
         BNO   @RF00120                                            0120
*             B857TYPE='H';         /* YES, INDICATE HARDWARE FAILURE
*                                      IN MESSAGE                    */
         MVI   B857TYPE(BMSGPTR),C'H'                              0121
*         END;                                                     0122
@RF00120 DS    0H                                                  0123
*       IF LOGPHID>='07'X&LOGPHID<='0B'X THEN/* WAS FAILURE IN     0123
*                                      POST-PROCESSING PHASE         */
@RC00114 CLI   LOGPHID(RRPLPTR),X'07'                              0123
         BL    @RF00123                                            0123
         CLI   LOGPHID(RRPLPTR),X'0B'                              0123
         BH    @RF00123                                            0123
*         B857CODE=PPCODE;          /* SET MSG CODE FOR POST PROC.   */
         MVI   B857CODE(BMSGPTR),C'2'                              0124
*       ELSE                        /* NOT POST-PROCESSOR PHASE      */
*         B857CODE=NOTPCODE;        /* SET MSG CODE TO NOT POST    0125
*                                      PROCESSOR                     */
*                                                                  0125
         B     @RC00123                                            0125
@RF00123 MVI   B857CODE(BMSGPTR),C'1'                              0125
*       /*************************************************************/
*       /*                                                           */
*       /* GET PHYS ADDR OF RECOVERY AND DEAD CPUS                   */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0126
*       IF LCCACRIN=ON THEN         /* CHECK FOR PRE-PROCESSING PHASE*/
@RC00123 TM    LCCACRIN(LCCAPTR),B'00001000'                       0126
         BNO   @RF00126                                            0126
*         DO;                       /* YES,PRE-PROCESSOR PHASE       */
*           RPHYSAD=PSACPUPA;       /* RECOV. CPU IS THIS CPU        */
         L     @15,LCCACPUS(,LCCAPTR)                              0128
         L     @15,WSACACR(,@15)                                   0128
         LH    @12,PSACPUPA                                        0128
         ST    @12,RPHYSAD(,@15)                                   0128
*           DPHYSAD=PSASPAD;        /* DEAD CPU IS ONE THAT DID SIGP */
         LH    @12,PSASPAD                                         0129
         ST    @12,DPHYSAD(,@15)                                   0129
*         END;                                                     0130
*       ELSE                        /* NOT PRE-PROCESSOR PHASE       */
*         DO;                                                      0131
         B     @RC00126                                            0131
@RF00126 DS    0H                                                  0132
*           RPHYSAD=LCCARCPU->LCCACPUA-'40'X;/* CONVERT LOGICAL ADDR
*                                      OF RECOV. CPU TO PHYS ADDR    */
         L     @15,LCCACPUS(,LCCAPTR)                              0132
         L     @15,WSACACR(,@15)                                   0132
         LA    @12,64                                              0132
         L     @11,LCCARCPU(,LCCAPTR)                              0132
         LH    @11,LCCACPUA(,@11)                                  0132
         SLR   @11,@12                                             0132
         ST    @11,RPHYSAD(,@15)                                   0132
*           DPHYSAD=LCCADCPU->LCCACPUA-'40'X;/* CONVERT LOGICAL ADDR
*                                      OF DEAD CPU TO PHYSICAL ADDR  */
         L     @11,LCCADCPU(,LCCAPTR)                              0133
         LCR   @12,@12                                             0133
         AH    @12,LCCACPUA(,@11)                                  0133
         ST    @12,DPHYSAD(,@15)                                   0133
*         END;                                                     0134
*       RFY                                                        0135
*         SDWAPTR UNRSTD;           /* SDWA NOT REFERENCED FROM NOW
*                                      ON                            */
@RC00126 DS    0H                                                  0136
*       RFY                                                        0136
*         REG1 RSTD;                /* WORK REG                      */
*                                                                  0136
*       /*************************************************************/
*       /*                                                           */
*       /* CONVERT ADDRESS TO PRINTABLE DECIMAL                      */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0137
*       CVD(RPHYSAD,CVDDWD);        /* CONVERT TO DECIMAL            */
         L     @15,LCCACPUS(,LCCAPTR)                              0137
         L     @15,WSACACR(,@15)                                   0137
         L     @12,RPHYSAD(,@15)                                   0137
         CVD   @12,CVDDWD(,@15)                                    0137
*       UNPK(B857RAD,CVDDWD(7:8));  /* UNPACK LAST 2 BYTES           */
         UNPK  B857RAD(2,BMSGPTR),CVDDWD+6(2,@15)                  0138
*       B857RAD(2)=B857RAD(2)|'F0'X;/* MAKE LAST CHAR PRINTABLE      */
         OI    B857RAD+1(BMSGPTR),X'F0'                            0139
*       CVD(DPHYSAD,CVDDWD);        /* CONVERT DEAD CPU ADDR TO DEC. */
         L     @12,DPHYSAD(,@15)                                   0140
         CVD   @12,CVDDWD(,@15)                                    0140
*       UNPK(B857DAD,CVDDWD(7:8));  /* UNPACK LAST TWO BYTES         */
         UNPK  B857DAD(2,BMSGPTR),CVDDWD+6(2,@15)                  0141
*       B857DAD(2)=B857DAD(2)|'F0'X;/* MAKE LAST CHAR. PRINTABLE     */
         OI    B857DAD+1(BMSGPTR),X'F0'                            0142
*       GEN REFS(REG1,BUILD857)(LRA REG1,BUILD857(BMSGPTR));/* GET 0143
*                                      REAL ADDRESS OF MSG           */
         LRA REG1,BUILD857(BMSGPTR)
*       STMSGP=REG1;                /* PUT REAL MSG ADDR INTO SYSTERM
*                                      PARM LIST                     */
*                                                                  0144
         L     @15,LCCACPUS(,LCCAPTR)                              0144
         L     @15,WSACACR(,@15)                                   0144
         ST    REG1,STMSGP(,@15)                                   0144
*       /*************************************************************/
*       /*                                                           */
*       /* GET AND SET UP LRB FOR SYS TERM FACILITY                  */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0145
*       RFY                                                        0145
*        (LRBPTR) RSTD;                                            0145
*       LRBPTR=PCCAT00P(DPHYSAD+1)->PCCALRBV;/* GET ADDR OF LRB FOR
*                                      DEAD CPU              @YM04283*/
*                                                                  0146
         L     @15,DPHYSAD(,@15)                                   0146
         SLA   @15,2                                               0146
         L     @12,CVTPTR                                          0146
         L     @12,CVTPCCAT(,@12)                                  0146
         L     @15,PCCAT00P(@15,@12)                               0146
         L     LRBPTR,PCCALRBV(,@15)                               0146
*       /*************************************************************/
*       /*                                                           */
*       /* INSERT PROPER WAIT STATE CODE INTO LRB                    */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0147
*       IF B857TYPE='H' THEN        /* CHECK TYPE OF FAILURE         */
         CLI   B857TYPE(BMSGPTR),C'H'                              0147
         BNE   @RF00147                                            0147
*         LRBMWSC='00000052'X;      /* HARDWARE - SET HARDWARE WAIT
*                                      STATE CODE                    */
         MVC   LRBMWSC(4,LRBPTR),@CB02285                          0148
*       ELSE                        /* NOT HARDWARE                  */
*         LRBMWSC='00000051'X;      /* SET SOFTWARE WAIT STATE CODE  */
         B     @RC00147                                            0149
@RF00147 MVC   LRBMWSC(4,LRBPTR),@CB02286                          0149
*       LRBHTYPE='81'X;             /* INDICATE SYSTEM TERMINATION 0150
*                                      RECORD TYPE           @YM04283*/
*                                                                  0150
@RC00147 MVI   LRBHTYPE(LRBPTR),X'81'                              0150
*       /*************************************************************/
*       /*                                                           */
*       /* GET REAL ADDRESS OF LRB                                   */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0151
*       GEN REFS(REG1,LRBPTR)(LRA REG1,0(LRBPTR));                 0151
         LRA REG1,0(LRBPTR)
*       STLRBP=REG1;                /* PUT REAL LRB ADDR INTO SYSTEM
*                                      TERMINATION PARM              */
*                                                                  0152
         L     @15,LCCACPUS(,LCCAPTR)                              0152
         L     @15,WSACACR(,@15)                                   0152
         ST    REG1,STLRBP(,@15)                                   0152
*       /*************************************************************/
*       /*                                                           */
*       /* PUT REAL ADDRESS OF PARM IN REG1 AND GO TO SYSTEM         */
*       /* TERMINATION                                               */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0153
*       REG1=ADDR(STRPARM);         /* GET VIRTUAL ADDR              */
         LA    REG1,STRPARM(,@15)                                  0153
*       GEN REFS(REG1)(LRA REG1,0(REG1));                          0154
         LRA REG1,0(REG1)
*       LPSW(TRMPSW);               /* GO TO SYSTEM TERMINATION      */
         LPSW  TRMPSW                                              0155
*     END;                          /* END SEGMENT CR1STERM          */
*   RRPLRTRY=ON;                    /* NO, INDICATE RETRY MODE     0157
*                                      ENTERED                       */
*                                                                  0157
@RF00108 OI    RRPLRTRY(RRPLPTR),B'10000000'                       0157
*   /*****************************************************************/
*   /*                                                               */
*   /* FIND INDEX TO ACTION TABLE THAT CORRESPONDS TO THE PROPER     */
*   /* LOGICAL PHASE ID                                              */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0158
*   DO ACTINDEX=1 TO 20 WHILE(LOGPHID^=ACTPHID(ACTINDEX));         0158
         LA    ACTINDEX,1                                          0158
@DL00158 LR    @15,ACTINDEX                                        0158
         MH    @15,@CH00071                                        0158
         LA    @12,ACTPHID-3(@15)                                  0158
         CLC   LOGPHID(1,RRPLPTR),0(@12)                           0158
         BE    @DC00158                                            0158
*   END;                                                           0159
*                                                                  0159
         AH    ACTINDEX,@CH00066                                   0159
         CH    ACTINDEX,@CH01793                                   0159
         BNH   @DL00158                                            0159
@DC00158 DS    0H                                                  0160
*   /*****************************************************************/
*   /*                                                               */
*   /* PERFORM ACTION INDICATED IN ACTION TABLE(ACTION 0 IS A NO     */
*   /* OPERATION ACTION                                              */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0160
*   IF ACTACT(ACTINDEX)=1 THEN      /* ACTION 1 - RESET RTM INDICATOR*/
         LR    @15,ACTINDEX                                        0160
         MH    @15,@CH00071                                        0160
         SLR   @12,@12                                             0160
         IC    @12,ACTACT-3(@15)                                   0160
         CH    @12,@CH00066                                        0160
         BNE   @RF00160                                            0160
*     DO;                                                          0161
*       LCCARCPU->LCCACRTM=OFF;     /* RESET RTM FLAG IN RECOV CPU 0162
*                                      LCCA                          */
         L     @15,LCCARCPU(,LCCAPTR)                              0162
         NI    LCCACRTM(@15),B'01111111'                           0162
*       LCCADCPU->LCCACRTM=OFF;     /* RESET RTM FLAG IN DEAD CPU  0163
*                                      LCCA                          */
         L     @15,LCCADCPU(,LCCAPTR)                              0163
         NI    LCCACRTM(@15),B'01111111'                           0163
*     END;                                                         0164
*   DO;                             /* BEGIN SEGMENT CR1EXIT         */
*                                                                  0165
@RF00160 DS    0H                                                  0166
*     /***************************************************************/
*     /*                                                             */
*     /* SEGMENT CR1EXIT PERFORMS THE RETRY FROM THE RECOVERY        */
*     /* ROUTINE. THE METHOD OF RETRYING DEPENDS ON THE WAY IN WHICH */
*     /* THE RECOVERY ROUTINE WAS ENTERED. IF ENTRY WAS FROM FRR     */
*     /* ROUTING THEN SETRP IS USED. IF ENTRY WAS DIRECT BRANCH      */
*     /* BECAUSE SUPER BIT WAS ON, THEN REGS ARE RESTORED AND RETRY  */
*     /* POINT IS BRANCHED TO                                        */
*     /*                                                             */
*     /***************************************************************/
*                                                                  0166
*     IF ENTTYPE=0 THEN             /* ENTRY VIA FRR ROUTING         */
         LTR   ENTTYPE,ENTTYPE                                     0166
         BNZ   @RF00166                                            0166
*       DO;                         /* ISSUE SETRP FOR RETRY         */
*         SDWASRSV=RRPLREGS;        /* MOVE REGS SAVED BY MAINLINE 0168
*                                      ACR INTO THE SDWA FOR RETRY   */
         MVI   SDWASRSV+60(SDWAPTR),C' '                           0168
         MVC   SDWASRSV+61(3,SDWAPTR),SDWASRSV+60(SDWAPTR)         0168
         MVC   SDWASRSV(60,SDWAPTR),RRPLREGS(RRPLPTR)              0168
*         SDWARECP=MODULEID;        /* STORE MODULE,CSECT,FRR IDS IN
*                                      SDWA                  @YM08145*/
         MVC   SDWARECP(24,SDWAPTR),MODULEID                       0169
*         SDWAURAL='01'X;           /* SET LENGTH OF VAR. DATA     0170
*                                                            @YM08145*/
         MVI   SDWAURAL(SDWAPTR),X'01'                             0170
*         SDWAHEX=ON;               /* INDICATE TO EREP THAT DATA IS
*                                      HEX FORMAT            @YM08145*/
         OI    SDWAHEX(SDWAPTR),B'10000000'                        0171
*         SDWAVRA(1:1)=LOGPHID;     /* MOVE IN LOGPHID FOR RECORD  0172
*                                                            @YM08145*/
         MVC   SDWAVRA(1,SDWAPTR),LOGPHID(RRPLPTR)                 0172
*         DO;                       /* SETRP RC(4) RETADDR(EVAL(RETRY
*                                      PTS(ACTRETRY(ACTINDEX)))->ALAB
*                                      EL) RETREGS(YES)              */
*           RESPECIFY                                              0174
*            (GPR00P,                                              0174
*             GPR01P,                                              0174
*             GPR14P,                                              0174
*             GPR15P) RSTD;                                        0174
*           GPR01P->SDWARCDE=4;     /* STORE RC INTO SDWA            */
         MVI   SDWARCDE(GPR01P),X'04'                              0175
*           GPR01P->SDWARTYA=ADDR(EVAL(RETRYPTS(ACTRETRY(ACTINDEX)))->
*               ALABEL);            /* SAVE RETRY ADDRESS            */
         LR    @12,ACTINDEX                                        0176
         MH    @12,@CH00071                                        0176
         SLR   @02,@02                                             0176
         IC    @02,ACTRETRY-3(@12)                                 0176
         SLA   @02,2                                               0176
         L     @12,RETRYPTS-4(@02)                                 0176
         ST    @12,SDWARTYA(,GPR01P)                               0176
*           GPR01P->SDWAUPRG='1'B;  /* TURN ON RETREGS INDICATOR     */
         OI    SDWAUPRG(GPR01P),B'00001000'                        0177
*           RESPECIFY                                              0178
*            (GPR00P,                                              0178
*             GPR01P,                                              0178
*             GPR14P,                                              0178
*             GPR15P) UNRSTD;                                      0178
*         END;                                                     0179
*         PSAACR=OFF;               /* TURN OFF SUPER BIT            */
         NI    PSAACR,B'11111011'                                  0180
*         GOTO REG14;               /* RETURN TO RTM FRR ROUTING     */
         BR    REG14                                               0181
*       END;                                                       0182
*     ELSE                          /* ENTRY WAS VIA SUPER BIT     0183
*                                      ROUTING                       */
*       DO;                                                        0183
@RF00166 DS    0H                                                  0184
*         RFY                                                      0184
*           REG15 RSTD;                                            0184
*         REG15=RETRYPTS(ACTRETRY(ACTINDEX));/* SET REG 15 TO POINT
*                                      TO RETRY ADDRESS              */
         LR    @12,ACTINDEX                                        0185
         MH    @12,@CH00071                                        0185
         SLR   @02,@02                                             0185
         IC    @02,ACTRETRY-3(@12)                                 0185
         SLA   @02,2                                               0185
         L     REG15,RETRYPTS-4(@02)                               0185
*         GEN REFS(RRPLREGS)(LM 0,14,RRPLREGS(RRPLPTR));/* RELOAD  0186
*                                      REGS                          */
         LM 0,14,RRPLREGS(RRPLPTR)
*         GOTO REG15;               /* GO TO RETRY ADDRESS           */
         BR    REG15                                               0187
*         RFY                                                      0188
*           REG15 UNRSTD;                                          0188
*       END;                                                       0189
*   END;                            /* END OF SEGMENT CR1EXIT        */
*   DECLARE                         /* GENERAL PURPOSE REGISTERS     */
*     GPR00P PTR(31) REG(0),                                       0191
*     GPR01P PTR(31) REG(1),                                       0191
*     GPR14P PTR(31) REG(14),                                      0191
*     GPR15P PTR(31) REG(15);                                      0191
*   DECLARE                         /* COMMON VARIABLES              */
*     I256C CHAR(256) BASED,                                       0192
*     I031F FIXED(31) BASED,                                       0192
*     I031P PTR(31) BASED,                                         0192
*     I015F FIXED(15) BASED,                                       0192
*     I015P PTR(15) BASED,                                         0192
*     I008P PTR(8) BASED,                                          0192
*     I001C CHAR(1) BASED;                                         0192
*   END                                                            0193
*                                                                  0193
*/* THE FOLLOWING INCLUDE STATEMENTS WERE FOUND IN THIS PROGRAM.     */
*/*%INCLUDE SYSLIB  (CR1SPEC )                                       */
*/*%INCLUDE SYSLIB  (CR1DCL  )                                       */
*/*%INCLUDE SYSLIB  (IHAPSA  )                                       */
*/*%INCLUDE SYSLIB  (IHALCCA )                                       */
*/*%INCLUDE SYSLIB  (CVT     )                                       */
*/*%INCLUDE SYSLIB  (IHALRB  )                                       */
*/*%INCLUDE SYSLIB  (IHAWSAVT)                                       */
*/*%INCLUDE SYSLIB  (IHASDWA )                                       */
*/*%INCLUDE SYSLIB  (IHART1W )                                       */
*/*%INCLUDE SYSLIB  (IHAPCCAT)                                       */
*/*%INCLUDE SYSLIB  (IHAPCCA )                                       */
*/*%INCLUDE SYSLIB  (CR1INIT )                                       */
*/*%INCLUDE SYSLIB  (CR1STERM)                                       */
*/*%INCLUDE SYSLIB  (CR1EXIT )                                       */
*                                                                  0193
*       ;                                                          0193
@DATA    DS    0H
@CH00066 DC    H'1'
@CH00071 DC    H'3'
@CH00069 DC    H'5'
@CH01793 DC    H'20'
@DATD    DSECT
         DS    0F
IEAVTCR1 CSECT
         DS    0F
@DATD    DSECT
         DS    0D
@ENDDATD EQU   *
IEAVTCR1 CSECT
         NOPR  ((@ENDDATD-@DATD)*16)
         DS    0F
@SIZDATD DC    AL1(0)
         DC    AL3(@ENDDATD-@DATD)
@CV02065 DC    V(IGFPTERM)
@CV02066 DC    V(RSTRT0A)
@CV02067 DC    V(RSTRT0B)
@CV02068 DC    V(RSTRT04)
@CV02069 DC    V(RSTRT05)
@CV02070 DC    V(RSTRT06)
@CV02071 DC    V(RSTRT07)
@CV02072 DC    V(RSTRT08)
@CV02073 DC    V(RSTRT09)
@CV02074 DC    V(RSTRT00)
@CV02075 DC    V(RSTRTX0)
@CV02076 DC    V(RSTRTX1)
         DS    0D
@CB02285 DC    X'00000052'
@CB02286 DC    X'00000051'
TRMPSW   DS    CL8
         ORG   TRMPSW
TRMIMSK  DC    X'00'
TRMKYMWP DC    X'0C'
TRMCCPMK DC    X'00'
@NM00107 DC    X'00'
TRMPSWIC DC    VL4(IGFPTERM)
         ORG   TRMPSW+8
M857W    DS    CL43
         ORG   M857W
M857W01  DC    H'39'
M857W02  DC    B'1000000000000000'
M857W03  DC    CL35'IEA857W UNREC X ACR ERR-X-R=XX D=XX'
M857W04  DC    B'1000000000000000'
M857W05  DC    B'1000000000000000'
         ORG   M857W+43
MODULEID DC    CL24'IEAVTACRIEAVTACRIEAVTCR1'
ACTIONS  DC    X'000001'
         ORG   ACTIONS+0
ACTPHID  DS    CL1
ACTACT   DS    AL1
ACTRETRY DS    AL1
         ORG   ACTIONS+3
         DC    X'010001'
         ORG   ACTIONS+6
         DC    X'020101'
         ORG   ACTIONS+9
         DC    X'030001'
         ORG   ACTIONS+12
         DC    X'040001'
         ORG   ACTIONS+15
         DC    X'050003'
         ORG   ACTIONS+18
         DC    X'060004'
         ORG   ACTIONS+21
         DC    X'070005'
         ORG   ACTIONS+24
         DC    X'080006'
         ORG   ACTIONS+27
         DC    X'090007'
         ORG   ACTIONS+30
         DC    X'0A0008'
         ORG   ACTIONS+33
         DC    X'0B0009'
         ORG   ACTIONS+36
         DC    X'10000A'
         ORG   ACTIONS+39
         DC    X'11000B'
         ORG   ACTIONS+42
         DC    X'20000A'
         ORG   ACTIONS+45
         DC    X'21000B'
         ORG   ACTIONS+48
         DC    X'30000A'
         ORG   ACTIONS+51
         DC    X'31000B'
         ORG   ACTIONS+54
         DC    X'40000A'
         ORG   ACTIONS+57
         DC    X'41000B'
         ORG   ACTIONS+60
         DS    CL1
RETRYPTS DC    VL4(RSTRT00)
         DC    VL4(RSTRT04)
         DC    VL4(RSTRT05)
         DC    VL4(RSTRT06)
         DC    VL4(RSTRT07)
         DC    VL4(RSTRT08)
         DC    VL4(RSTRT09)
         DC    VL4(RSTRT0A)
         DC    VL4(RSTRT0B)
         DC    VL4(RSTRTX0)
         DC    VL4(RSTRTX1)
@00      EQU   00                      EQUATES FOR REGISTERS 0-15
@01      EQU   01
@02      EQU   02
@03      EQU   03
@04      EQU   04
@05      EQU   05
@06      EQU   06
@07      EQU   07
@08      EQU   08
@09      EQU   09
@10      EQU   10
@11      EQU   11
@12      EQU   12
@13      EQU   13
@14      EQU   14
@15      EQU   15
LCCAPTR  EQU   @06
LRBPTR   EQU   @03
SDWAPTR  EQU   @01
BMSGPTR  EQU   @04
REG0     EQU   @00
REG1     EQU   @01
ACTINDEX EQU   @09
ENTTYPE  EQU   @07
RRPLPTR  EQU   @05
REG14    EQU   @14
REG15    EQU   @15
GPR00P   EQU   @00
GPR01P   EQU   @01
GPR14P   EQU   @14
GPR15P   EQU   @15
PSA      EQU   0
FLCRNPSW EQU   PSA
FLCROPSW EQU   PSA+8
FLCICCW2 EQU   PSA+16
FLCCVT   EQU   FLCICCW2
FLCEOPSW EQU   PSA+24
FLCENPSW EQU   PSA+88
PSAEEPSW EQU   PSA+132
PSASPAD  EQU   PSAEEPSW
PSAESPSW EQU   PSA+136
FLCSVILC EQU   PSAESPSW+1
PSAEPPSW EQU   PSA+140
FLCPIILC EQU   PSAEPPSW+1
FLCPICOD EQU   PSAEPPSW+2
PSAPICOD EQU   FLCPICOD+1
FLCTEA   EQU   PSAEPPSW+4
FLCPER   EQU   PSA+152
FLCMTRCD EQU   PSA+157
FLCMCLA  EQU   PSA+168
FLCIOEL  EQU   FLCMCLA+4
FLCIOA   EQU   FLCMCLA+16
FLCFSA   EQU   FLCMCLA+80
PSAPSA   EQU   PSA+512
PSACPUPA EQU   PSA+516
PSAPCCAV EQU   PSA+520
PSALCCAV EQU   PSA+528
PSASUPER EQU   PSA+552
PSASUP1  EQU   PSASUPER
PSASUP2  EQU   PSASUPER+1
PSAACR   EQU   PSASUP2
PSASUP3  EQU   PSASUPER+2
PSASUP4  EQU   PSASUPER+3
PSACLHT  EQU   PSA+640
PSALKSA  EQU   PSA+696
PSAHLHI  EQU   PSA+760
PSADSSFL EQU   PSA+836
PSADSSF1 EQU   PSADSSFL
PSADSSF3 EQU   PSADSSFL+2
PSADSSF4 EQU   PSADSSFL+3
PSARSVT  EQU   PSA+896
PSAUSEND EQU   PSA+1032
LCCA     EQU   0
LCCACPUA EQU   LCCA+4
LCCAIHRC EQU   LCCA+520
LCCAIHR1 EQU   LCCAIHRC
LCCAIHR2 EQU   LCCAIHRC+1
LCCAIHR3 EQU   LCCAIHRC+2
LCCAIHR4 EQU   LCCAIHRC+3
LCCASPIN EQU   LCCA+524
LCCASPN1 EQU   LCCASPIN
LCCASPN2 EQU   LCCASPIN+1
LCCASPN3 EQU   LCCASPIN+2
LCCASPN4 EQU   LCCASPIN+3
LCCACPUS EQU   LCCA+536
LCCADSF1 EQU   LCCA+540
LCCADSF2 EQU   LCCA+541
LCCASPSA EQU   LCCA+544
LCCADCPU EQU   LCCA+676
LCCARCPU EQU   LCCA+680
LCCACRFL EQU   LCCA+692
LCCACRTM EQU   LCCACRFL
LCCACREX EQU   LCCA+693
LCCACRIN EQU   LCCACREX
LCCALKFG EQU   LCCA+694
LCCASRBF EQU   LCCA+720
CVTMAP   EQU   0
CVTBTERM EQU   CVTMAP+52
CVTDAR   EQU   CVTMAP+72
CVTFLGS1 EQU   CVTDAR
CVTDCB   EQU   CVTMAP+116
CVTIERLC EQU   CVTMAP+144
CVTOPTA  EQU   CVTMAP+182
CVTOPTB  EQU   CVTMAP+183
CVTGTF   EQU   CVTMAP+236
CVTGTFST EQU   CVTGTF
CVTGTFS  EQU   CVTGTFST
CVTSTATE EQU   CVTGTFST
CVTTMODE EQU   CVTGTFST
CVTFORM  EQU   CVTGTFST
CVTUSR   EQU   CVTGTFST
CVTAQAVT EQU   CVTMAP+240
CVTTCMFG EQU   CVTAQAVT
CVTVOLM2 EQU   CVTMAP+244
CVTTATA  EQU   CVTVOLM2
CVTTSKS  EQU   CVTTATA
CVTVOLF2 EQU   CVTTSKS
CVTTAT   EQU   CVTTATA+1
CVTATER  EQU   CVTMAP+248
CVTEXT1  EQU   CVTMAP+252
CVTPURG  EQU   CVTMAP+260
CVTQMSG  EQU   CVTMAP+268
CVTDMSR  EQU   CVTMAP+272
CVTERPV  EQU   CVTMAP+316
CVTINTLA EQU   CVTMAP+320
CVTAPF   EQU   CVTMAP+324
CVTEXT2  EQU   CVTMAP+328
CVTHJES  EQU   CVTMAP+332
CVTPGSIA EQU   CVTMAP+348
CVTA1F1  EQU   CVTMAP+356
CVTSYSK  EQU   CVTMAP+357
CVTVOLM1 EQU   CVTMAP+380
CVTVOLF1 EQU   CVTVOLM1
CVTATMCT EQU   CVTMAP+388
CVTXTNT1 EQU   0
CVTXTNT2 EQU   0
CVTDSSV  EQU   CVTXTNT2
CVTRSV90 EQU   CVTXTNT2+5
CVTQID   EQU   CVTXTNT2+24
CVTRV400 EQU   CVTXTNT2+52
CVTRV409 EQU   CVTXTNT2+53
CVTATCVT EQU   CVTXTNT2+64
CVTRV429 EQU   CVTXTNT2+84
CVTRV438 EQU   CVTXTNT2+85
CVTRV457 EQU   CVTXTNT2+112
CVTRV466 EQU   CVTXTNT2+113
CVTFIX   EQU   0
CVTRELNO EQU   CVTFIX+252
LRB      EQU   0
LRBHTYPE EQU   LRB
LRBHREL  EQU   LRB+1
LRBHSYS  EQU   LRBHREL
LRBHSW0  EQU   LRB+2
LRBHSW1  EQU   LRB+3
LRBHSW2  EQU   LRB+4
LRBMACT  EQU   LRBHSW2
LRBHSW3  EQU   LRB+5
LRBHCPID EQU   LRB+16
LRBBASE  EQU   LRB+24
LRBCVAR  EQU   0
LRBCMP   EQU   LRBCVAR+8
WSAG     EQU   0
WSAC     EQU   0
WSACACR  EQU   WSAC+16
SDWA     EQU   0
SDWAFIOB EQU   SDWA+4
SDWAABCC EQU   SDWAFIOB
SDWACMPF EQU   SDWAABCC
SDWACTL1 EQU   SDWA+8
SDWACMKA EQU   SDWACTL1
SDWAMWPA EQU   SDWACTL1+1
SDWAPMKA EQU   SDWACTL1+4
SDWACTL2 EQU   SDWA+16
SDWACMKP EQU   SDWACTL2
SDWAMWPP EQU   SDWACTL2+1
SDWAPMKP EQU   SDWACTL2+4
SDWAGRSV EQU   SDWA+24
SDWANAME EQU   SDWA+88
SDWAEC1  EQU   SDWA+104
SDWAEMK1 EQU   SDWAEC1
SDWAMWP1 EQU   SDWAEC1+1
SDWAINT1 EQU   SDWAEC1+2
SDWANXT1 EQU   SDWAEC1+4
SDWAAEC1 EQU   SDWA+112
SDWAILC1 EQU   SDWAAEC1+1
SDWAINC1 EQU   SDWAAEC1+2
SDWAICD1 EQU   SDWAINC1+1
SDWAEC2  EQU   SDWA+120
SDWAEMK2 EQU   SDWAEC2
SDWAMWP2 EQU   SDWAEC2+1
SDWAINT2 EQU   SDWAEC2+2
SDWANXT2 EQU   SDWAEC2+4
SDWAAEC2 EQU   SDWA+128
SDWAILC2 EQU   SDWAAEC2+1
SDWAINC2 EQU   SDWAAEC2+2
SDWAICD2 EQU   SDWAINC2+1
SDWASRSV EQU   SDWA+136
SDWAIDNT EQU   SDWA+200
SDWAMCH  EQU   SDWA+204
SDWASTCK EQU   SDWAMCH
SDWAMCHI EQU   SDWAMCH+8
SDWAMCHS EQU   SDWAMCHI
SDWAMCHD EQU   SDWAMCHI+1
SDWARSR1 EQU   SDWAMCH+12
SDWARSR2 EQU   SDWAMCH+13
SDWAFLGS EQU   SDWA+232
SDWAERRA EQU   SDWAFLGS
SDWAMCHK EQU   SDWAERRA
SDWAERRB EQU   SDWAFLGS+1
SDWAERRC EQU   SDWAFLGS+2
SDWAERRD EQU   SDWAFLGS+3
SDWAIOFS EQU   SDWA+238
SDWARTYA EQU   SDWA+240
SDWACPUA EQU   SDWA+248
SDWAPARQ EQU   SDWA+252
SDWARCDE EQU   SDWAPARQ
SDWAACF2 EQU   SDWAPARQ+1
SDWAUPRG EQU   SDWAACF2
SDWAACF3 EQU   SDWAPARQ+2
SDWAACF4 EQU   SDWAPARQ+3
SDWALKWA EQU   SDWA+256
SDWALKWS EQU   SDWALKWA
SDWARECP EQU   SDWA+292
SDWASNPA EQU   SDWA+320
SDWADUMP EQU   SDWASNPA
SDWADPFS EQU   SDWADUMP+1
SDWADDAT EQU   SDWASNPA+4
SDWASDAT EQU   SDWADDAT
SDWAPDAT EQU   SDWADDAT+2
SDWADPSA EQU   SDWA+328
SDWADPSL EQU   SDWADPSA
SDWARA   EQU   SDWA+400
SDWADPVA EQU   SDWARA+2
SDWAHEX  EQU   SDWADPVA
SDWAURAL EQU   SDWARA+3
SDWAVRA  EQU   SDWARA+4
RTMBRTAB EQU   0
RTMBTERM EQU   RTMBRTAB
PCCAVT   EQU   0
PCCAT00P EQU   PCCAVT
PCCA     EQU   0
PCCATMST EQU   PCCA+128
PCCATMFL EQU   PCCATMST
PCCATODE EQU   PCCATMST+1
PCCACCE  EQU   PCCATMST+2
PCCAINTE EQU   PCCATMST+3
PCCAEMSB EQU   PCCA+136
PCCAEMSI EQU   PCCAEMSB
PCCARISP EQU   PCCAEMSI
PCCAEMS2 EQU   PCCAEMSI+1
PCCAEMS3 EQU   PCCAEMSI+2
PCCARMSB EQU   PCCAEMSI+3
PCCALRBV EQU   PCCA+160
PCCAWERP EQU   PCCA+280
PCCACHPF EQU   PCCAWERP+4
PCCACHBL EQU   PCCAWERP+5
PCCACHVA EQU   PCCAWERP+6
PCCACHTS EQU   PCCAWERP+7
PCCACHS1 EQU   PCCA+288
PCCACHS2 EQU   PCCA+289
PCCACHRB EQU   PCCA+290
PCCACHF1 EQU   PCCA+308
PCCACHF2 EQU   PCCA+309
PCCACHF3 EQU   PCCA+310
PCCACHF4 EQU   PCCA+311
PCCAPTR  EQU   0
ALABEL   EQU   0
BUILD857 EQU   0
B857TYPE EQU   BUILD857+18
B857CODE EQU   BUILD857+28
B857RAD  EQU   BUILD857+32
B857DAD  EQU   BUILD857+37
RRPL     EQU   0
LOGPHID  EQU   RRPL
RRPLFLGS EQU   RRPL+1
RRPLRTRY EQU   RRPLFLGS
RRPLCNTS EQU   RRPL+2
RRPLREGS EQU   RRPL+4
ACRSA    EQU   0
ACRSVBSE EQU   ACRSA
ACRLMFSV EQU   ACRSVBSE
ACRLMGSV EQU   ACRSVBSE+32
ACRMCHEB EQU   ACRSVBSE+96
ACRRRPLP EQU   ACRMCHEB
ACRACRSV EQU   ACRSVBSE+104
ACRACRWA EQU   ACRSVBSE+248
ACRFLCSV EQU   ACRSVBSE+272
ACROPSW  EQU   ACRFLCSV+8
ACREPSWS EQU   ACRFLCSV+72
ACRCPIDS EQU   ACRSA+376
I001C    EQU   0
I008P    EQU   0
I015F    EQU   0
I015P    EQU   0
I031F    EQU   0
I031P    EQU   0
I256C    EQU   0
PSARSVTE EQU   PSARSVT
CVTPTR   EQU   FLCCVT
CVTS01   EQU   CVTPGSIA
CVTLPDIA EQU   CVTS01+12
CVTDIRST EQU   CVTLPDIA
CVTSLIDA EQU   CVTS01+24
CVTCTLFG EQU   CVTS01+50
CVTSPSA  EQU   CVTS01+336
CVTPCCAT EQU   CVTS01+416
CVTRV210 EQU   CVTS01+424
CVTRV219 EQU   CVTS01+425
CVTRV228 EQU   CVTS01+426
CVTRV237 EQU   CVTS01+427
CVTMFRTR EQU   CVTS01+452
CVTRV262 EQU   CVTS01+468
CVTRV271 EQU   CVTS01+469
CVTRV280 EQU   CVTS01+470
CVTRV289 EQU   CVTS01+471
CVTGSDA  EQU   CVTS01+600
LRBHRSW1 EQU   LRBHSW1
LRBHCSW1 EQU   LRBHSW1
LRBHMSW1 EQU   LRBHSW1
LRBMMCH  EQU   LRBBASE
LRBMWSC  EQU   LRBMMCH+4
LRBMCEIA EQU   LRBMMCH+8
LRBMTERM EQU   LRBMCEIA
LRBMHARD EQU   LRBMCEIA+1
LRBMINTM EQU   LRBMCEIA+2
LRBMSOFT EQU   LRBMCEIA+3
LRBMPDAR EQU   LRBMMCH+12
LRBMRSR1 EQU   LRBMMCH+13
LRBMRSR2 EQU   LRBMMCH+14
LRBMFLO  EQU   LRBMMCH+24
LRBMCIC  EQU   LRBMFLO
@NM00044 EQU   LRBMCIC
@NM00046 EQU   LRBMCIC+1
@NM00048 EQU   LRBMCIC+2
@NM00050 EQU   LRBMCIC+3
@NM00053 EQU   LRBMCIC+5
LRBRDDR  EQU   LRBBASE
LRBCCCH  EQU   LRBBASE
LRBCCUA  EQU   LRBCCCH+49
LRBDMDR  EQU   LRBBASE
LRBNMIH  EQU   LRBBASE
LRBTTER  EQU   LRBBASE
TEMPWORK EQU   ACRACRWA
CVDDWD   EQU   TEMPWORK
STRPARM  EQU   TEMPWORK+8
STMSGP   EQU   STRPARM
STLRBP   EQU   STRPARM+4
RPHYSAD  EQU   TEMPWORK+16
DPHYSAD  EQU   TEMPWORK+20
ACRCPUPA EQU   PSACPUPA
ACRLCCAV EQU   PSALCCAV
ACRPCCAV EQU   PSAPCCAV
ACRPSA   EQU   PSAPSA
ACRPSEND EQU   PSAUSEND
AECEND   EQU   FLCMTRCD+3
AECSTRT  EQU   PSAEEPSW
APSWEND  EQU   FLCENPSW
APSWSTRT EQU   FLCEOPSW
FLC      EQU   PSA
         AGO   .@UNREFD                START UNREFERENCED COMPONENTS
LRBTUSR  EQU   LRBTTER+8
LRBTWSC  EQU   LRBTTER+4
LRBTLNH  EQU   LRBTTER
LRBNINT  EQU   LRBNMIH+24
LRBNDEVT EQU   LRBNMIH+20
LRBNVOL  EQU   LRBNMIH+14
LRBNCUA1 EQU   LRBNMIH+11
LRBNCUA2 EQU   LRBNMIH+8
LRBNJOB  EQU   LRBNMIH
LRBDSENS EQU   LRBDMDR+8
LRBDVOL  EQU   LRBDMDR+2
LRBDCUA1 EQU   LRBDMDR
LRBCCLOG EQU   LRBCCCH+56
LRBCLOGL EQU   LRBCCCH+54
LRBCHCUA EQU   LRBCCCH+52
LRBCCUA2 EQU   LRBCCUA+1
@NM00057 EQU   LRBCCUA
LRBCCHID EQU   LRBCCCH+48
LRBCDEVT EQU   LRBCCCH+44
LRBCECSW EQU   LRBCCCH+40
LRBCFCSW EQU   LRBCCCH+32
LRBCFCCW EQU   LRBCCCH+24
LRBCAIO  EQU   LRBCCCH+8
LRBCJOB  EQU   LRBCCCH
LRBRDEV2 EQU   LRBRDDR+32
LRBRCUA2 EQU   LRBRDDR+29
LRBRPH2  EQU   LRBRDDR+28
LRBRDEV1 EQU   LRBRDDR+24
LRBRCUA1 EQU   LRBRDDR+21
LRBRPH1  EQU   LRBRDDR+20
LRBRVOL2 EQU   LRBRDDR+14
LRBRVOL1 EQU   LRBRDDR+8
LRBRJOB  EQU   LRBRDDR
LRBMCEL  EQU   LRBMMCH+304
@NM00056 EQU   LRBMFLO+20
LRBMFSA  EQU   LRBMFLO+16
@NM00055 EQU   LRBMFLO+8
LRBMCELL EQU   LRBMCIC+6
LRBMVCC  EQU   @NM00053
LRBMVPT  EQU   @NM00053
@NM00054 EQU   @NM00053
@NM00052 EQU   LRBMCIC+4
LRBMVST  EQU   @NM00050
LRBMVLG  EQU   @NM00050
LRBMVCR  EQU   @NM00050
LRBMVGR  EQU   @NM00050
LRBMVFP  EQU   @NM00050
@NM00051 EQU   @NM00050
LRBMVRC  EQU   @NM00050
LRBMVFA  EQU   @NM00050
LRBMVIA  EQU   @NM00048
LRBMVPM  EQU   @NM00048
LRBMVMS  EQU   @NM00048
LRBMVWP  EQU   @NM00048
@NM00049 EQU   @NM00048
LRBMFKE  EQU   @NM00048
LRBMFSC  EQU   @NM00048
LRBMFSE  EQU   @NM00048
LRBMIDY  EQU   @NM00046
LRBMIBU  EQU   @NM00046
@NM00047 EQU   @NM00046
LRBMFWN  EQU   @NM00046
LRBMFDG  EQU   @NM00044
@NM00045 EQU   @NM00044
LRBMFED  EQU   @NM00044
LRBMFCD  EQU   @NM00044
LRBMFTD  EQU   @NM00044
LRBMFSR  EQU   @NM00044
LRBMFPD  EQU   @NM00044
LRBMFSD  EQU   @NM00044
LRBMMOSW EQU   LRBMMCH+16
LRBMPWL  EQU   LRBMMCH+15
LRBMVEQR EQU   LRBMRSR2
LRBMPGFX EQU   LRBMRSR2
LRBMLSQA EQU   LRBMRSR2
LRBMFSQA EQU   LRBMRSR2
LRBMNUCL EQU   LRBMRSR2
LRBMSPER EQU   LRBMRSR2
LRBMINTC EQU   LRBMRSR2
LRBMOFLN EQU   LRBMRSR2
LRBMCHNG EQU   LRBMRSR1
LRBMSER  EQU   LRBMRSR1
@NM00043 EQU   LRBMRSR1
@NM00042 EQU   LRBMPDAR
LRBMRSRF EQU   LRBMPDAR
LRBMRSRC EQU   LRBMPDAR
LRBMINVP EQU   LRBMPDAR
@NM00041 EQU   LRBMPDAR
LRBMSBUF EQU   LRBMSOFT
LRBMSHIR EQU   LRBMSOFT
LRBMSECC EQU   LRBMSOFT
LRBMSEXD EQU   LRBMSOFT
@NM00040 EQU   LRBMSOFT
LRBMSSFT EQU   LRBMSOFT
LRBMIL80 EQU   LRBMINTM
LRBMICTM EQU   LRBMINTM
LRBMICKC EQU   LRBMINTM
LRBMITOD EQU   LRBMINTM
@NM00039 EQU   LRBMINTM
LRBMHIPD EQU   LRBMHARD
LRBMHSPF EQU   LRBMHARD
LRBMHSTO EQU   LRBMHARD
LRBMHINV EQU   LRBMHARD
@NM00038 EQU   LRBMHARD
LRBMHHRD EQU   LRBMHARD
LRBMTINV EQU   LRBMTERM
LRBMTDMG EQU   LRBMTERM
LRBMTWRN EQU   LRBMTERM
LRBMTCKS EQU   LRBMTERM
LRBMTSEC EQU   LRBMTERM
@NM00037 EQU   LRBMTERM
LRBMLNH  EQU   LRBMMCH
@NM00036 EQU   LRBHMSW1
LRBMSYST EQU   LRBHMSW1
@NM00035 EQU   LRBHMSW1
@NM00034 EQU   LRBHCSW1
LRBCERPP EQU   LRBHCSW1
LRBCDATA EQU   LRBHCSW1
LRBCICUA EQU   LRBHCSW1
LRBCNOSP EQU   LRBHCSW1
@NM00033 EQU   LRBHCSW1
LRBCINCO EQU   LRBHCSW1
LRBCMESG EQU   LRBHCSW1
@NM00032 EQU   LRBHRSW1
LRBRSYSI EQU   LRBHRSW1
LRBROPER EQU   LRBHRSW1
LRBRSEC  EQU   LRBHRSW1
LRBRPRIM EQU   LRBHRSW1
CVTTPIO  EQU   CVTS01+608
CVTADV   EQU   CVTS01+604
CVTGSDAB EQU   CVTGSDA
CVTQV3   EQU   CVTS01+596
CVTQV2   EQU   CVTS01+592
CVTQV1   EQU   CVTS01+588
CVTRPT   EQU   CVTS01+584
CVTSSRB  EQU   CVTS01+580
CVTCSDRL EQU   CVTS01+576
CVTEXP1  EQU   CVTS01+572
CVTRMPMT EQU   CVTS01+568
CVTRMPTT EQU   CVTS01+564
CVTVPSA  EQU   CVTS01+560
CVTVSTOP EQU   CVTS01+556
CVTGTFR8 EQU   CVTS01+552
CVTQUIT  EQU   CVTS01+548
CVTVACR  EQU   CVTS01+544
CVTWTCB  EQU   CVTS01+540
CVTSTPRS EQU   CVTS01+536
CVT0PT02 EQU   CVTS01+532
CVTDARCM EQU   CVTS01+528
CVTIRECM EQU   CVTS01+524
CVTJRECM EQU   CVTS01+520
CVTVEMS0 EQU   CVTS01+516
CVTSPFRR EQU   CVTS01+512
CVTRLSTG EQU   CVTS01+508
CVT0TC0A EQU   CVTS01+504
CVTGMBR  EQU   CVTS01+500
CVTLFRM  EQU   CVTS01+496
CVTRMBR  EQU   CVTS01+492
CVTVIOP  EQU   CVTS01+488
CVTRV307 EQU   CVTS01+486
CVTRV306 EQU   CVTS01+484
CVTRV305 EQU   CVTS01+482
CVTRV304 EQU   CVTS01+480
CVTRV303 EQU   CVTS01+478
CVTRV302 EQU   CVTS01+476
CVTRV301 EQU   CVTS01+475
CVTRV300 EQU   CVTS01+474
CVTRV299 EQU   CVTS01+473
CVTRV298 EQU   CVTS01+472
CVTRV297 EQU   CVTRV289
CVTRV296 EQU   CVTRV289
CVTRV295 EQU   CVTRV289
CVTRV294 EQU   CVTRV289
CVTRV293 EQU   CVTRV289
CVTRV292 EQU   CVTRV289
CVTRV291 EQU   CVTRV289
CVTRV290 EQU   CVTRV289
CVTRV288 EQU   CVTRV280
CVTRV287 EQU   CVTRV280
CVTRV286 EQU   CVTRV280
CVTRV285 EQU   CVTRV280
CVTRV284 EQU   CVTRV280
CVTRV283 EQU   CVTRV280
CVTRV282 EQU   CVTRV280
CVTRV281 EQU   CVTRV280
CVTRV279 EQU   CVTRV271
CVTRV278 EQU   CVTRV271
CVTRV277 EQU   CVTRV271
CVTRV276 EQU   CVTRV271
CVTRV275 EQU   CVTRV271
CVTRV274 EQU   CVTRV271
CVTRV273 EQU   CVTRV271
CVTRV272 EQU   CVTRV271
CVTRV270 EQU   CVTRV262
CVTRV269 EQU   CVTRV262
CVTRV268 EQU   CVTRV262
CVTRV267 EQU   CVTRV262
CVTRV266 EQU   CVTRV262
CVTRV265 EQU   CVTRV262
CVTRV264 EQU   CVTRV262
CVTRV263 EQU   CVTRV262
CVTVFP   EQU   CVTS01+464
CVTVSI   EQU   CVTS01+460
CVTVPSIB EQU   CVTS01+456
CVTMFACT EQU   CVTMFRTR
CVTMFCTL EQU   CVTS01+448
CVTPVBP  EQU   CVTS01+444
CVTPWI   EQU   CVTS01+440
CVTRV254 EQU   CVTS01+438
CVTRV253 EQU   CVTS01+436
CVTRV252 EQU   CVTS01+434
CVTRV251 EQU   CVTS01+433
CVTRV250 EQU   CVTS01+432
CVTRV249 EQU   CVTS01+431
CVTRV248 EQU   CVTS01+430
CVTRV247 EQU   CVTS01+429
CVTRV246 EQU   CVTS01+428
CVTRV245 EQU   CVTRV237
CVTRV244 EQU   CVTRV237
CVTRV243 EQU   CVTRV237
CVTRV242 EQU   CVTRV237
CVTRV241 EQU   CVTRV237
CVTRV240 EQU   CVTRV237
CVTRV239 EQU   CVTRV237
CVTRV238 EQU   CVTRV237
CVTRV236 EQU   CVTRV228
CVTRV235 EQU   CVTRV228
CVTRV234 EQU   CVTRV228
CVTRV233 EQU   CVTRV228
CVTRV232 EQU   CVTRV228
CVTRV231 EQU   CVTRV228
CVTRV230 EQU   CVTRV228
CVTRV229 EQU   CVTRV228
CVTRV227 EQU   CVTRV219
CVTRV226 EQU   CVTRV219
CVTRV225 EQU   CVTRV219
CVTRV224 EQU   CVTRV219
CVTRV223 EQU   CVTRV219
CVTRV222 EQU   CVTRV219
CVTRV221 EQU   CVTRV219
CVTRV220 EQU   CVTRV219
CVTRV218 EQU   CVTRV210
CVTRV217 EQU   CVTRV210
CVTRV216 EQU   CVTRV210
CVTRV215 EQU   CVTRV210
CVTRV214 EQU   CVTRV210
CVTRV213 EQU   CVTRV210
CVTRV212 EQU   CVTRV210
CVTRV211 EQU   CVTRV210
CVTLCCAT EQU   CVTS01+420
CVTIPCRP EQU   CVTS01+412
CVTIPCRI EQU   CVTS01+408
CVTIPCDS EQU   CVTS01+404
CVTAIDVT EQU   CVTS01+400
CVTSSAP  EQU   CVTS01+396
CVTEHCIR EQU   CVTS01+392
CVTEHDEF EQU   CVTS01+388
CVTDAIR  EQU   CVTS01+384
CVTPERFM EQU   CVTS01+380
CVT044R2 EQU   CVTS01+376
CVTFETCH EQU   CVTS01+372
CVTRSTWD EQU   CVTS01+368
CVTSPOST EQU   CVTS01+364
CVTIOBP  EQU   CVTS01+360
CVTASMVT EQU   CVTS01+356
CVTRECRQ EQU   CVTS01+352
CVTWSAC  EQU   CVTS01+348
CVTRV149 EQU   CVTS01+344
CVTWSAL  EQU   CVTS01+340
CVTGLMN  EQU   CVTS01+332
CVTVEAC0 EQU   CVTS01+328
CVT062R1 EQU   CVTS01+324
CVTRPOST EQU   CVTS01+320
CVTDQIQE EQU   CVTS01+316
CVTCSD   EQU   CVTS01+312
CVTLKRMA EQU   CVTS01+308
CVTRSPIE EQU   CVTS01+304
CVTRENQ  EQU   CVTS01+300
CVTLQCB  EQU   CVTS01+296
CVTFQCB  EQU   CVTS01+292
CVTQCS01 EQU   CVTS01+288
CVTAPFT  EQU   CVTS01+284
CVTPARRL EQU   CVTS01+280
CVTVWAIT EQU   CVTS01+276
CVTGSPL  EQU   CVTS01+272
CVTLSMQ  EQU   CVTS01+268
CVTGSMQ  EQU   CVTS01+264
CVTEXPRO EQU   CVTS01+260
CVTOPCTP EQU   CVTS01+256
CVTSIC   EQU   CVTS01+252
CVTTPIOS EQU   CVTS01+248
CVTRTMS  EQU   CVTS01+244
CVTSDBF  EQU   CVTS01+240
CVTSCBP  EQU   CVTS01+236
CVTSDMP  EQU   CVTS01+232
CVTSV60  EQU   CVTS01+228
CVTRTMCT EQU   CVTS01+224
CVTASCBL EQU   CVTS01+220
CVTASCBH EQU   CVTS01+216
CVTGDA   EQU   CVTS01+212
CVTASVT  EQU   CVTS01+208
CVTVVMDI EQU   CVTS01+204
CVTAQTOP EQU   CVTS01+200
CVTIOSCS EQU   CVTS01+196
CVTSDRM  EQU   CVTS01+192
CVTOPTE  EQU   CVTS01+188
CVTSTXU  EQU   CVTS01+184
CVTQUIS  EQU   CVTS01+180
CVTPARS  EQU   CVTS01+176
CVTS1EE  EQU   CVTS01+172
CVTFRAS  EQU   CVTS01+168
CVTQSAS  EQU   CVTS01+164
CVTCRAS  EQU   CVTS01+160
CVTCRMN  EQU   CVTS01+156
CVTDELCP EQU   CVTS01+152
CVTFRECL EQU   CVTS01+148
CVTGETCL EQU   CVTS01+144
CVTBLDCP EQU   CVTS01+140
CVTAUTHL EQU   CVTS01+136
CVTSCAN  EQU   CVTS01+132
CVTRV144 EQU   CVTS01+130
CVTMAXMP EQU   CVTS01+128
CVTSTCK  EQU   CVTS01+124
CVTRV139 EQU   CVTS01+123
CVTDSSAC EQU   CVTS01+122
CVTRV513 EQU   CVTS01+121
CVTIOSPL EQU   CVTS01+120
CVTPTGT  EQU   CVTS01+116
CVTCSPIE EQU   CVTS01+112
CVTSMFEX EQU   CVTS01+108
CVTOLT0A EQU   CVTS01+104
CVTSRBRT EQU   CVTS01+100
CVTPUTL  EQU   CVTS01+96
CVTRV519 EQU   CVTS01+92
CVTRV327 EQU   CVTS01+88
CVTRV326 EQU   CVTS01+84
CVTRV325 EQU   CVTS01+80
CVTRV324 EQU   CVTS01+76
CVT0VL01 EQU   CVTS01+72
CVTSHRVM EQU   CVTS01+68
CVTRV332 EQU   CVTS01+64
CVTTAS   EQU   CVTS01+60
CVTRSCN  EQU   CVTS01+56
CVTTRAC2 EQU   CVTS01+54
CVTTRACE EQU   CVTS01+52
CVTAPG   EQU   CVTS01+51
CVTSDTRC EQU   CVTCTLFG
CVTGTRCE EQU   CVTCTLFG
CVTNOMP  EQU   CVTCTLFG
CVTRSV79 EQU   CVTCTLFG
CVTDSTAT EQU   CVTCTLFG
CVTRSV78 EQU   CVTCTLFG
CVTRV333 EQU   CVTCTLFG
CVTRV323 EQU   CVTCTLFG
CVTSPVLK EQU   CVTS01+49
CVTRSV77 EQU   CVTS01+48
CVTRV331 EQU   CVTS01+44
CVTRV330 EQU   CVTS01+40
CVTRV329 EQU   CVTS01+36
CVTRV328 EQU   CVTS01+32
CVTRV322 EQU   CVTS01+28
CVTSLID  EQU   CVTSLIDA+1
CVTSYLK  EQU   CVTSLIDA
CVTRV321 EQU   CVTS01+20
CVTRV320 EQU   CVTS01+16
CVTLPDIR EQU   CVTLPDIA+1
CVTRSV69 EQU   CVTDIRST
CVTRSV68 EQU   CVTDIRST
CVTRSV67 EQU   CVTDIRST
CVTRSV66 EQU   CVTDIRST
CVTRSV65 EQU   CVTDIRST
CVTRSV64 EQU   CVTDIRST
CVTRSV63 EQU   CVTDIRST
CVTDICOM EQU   CVTDIRST
CVTPVTP  EQU   CVTS01+8
CVTLPDSR EQU   CVTS01+4
CVTGETL  EQU   CVTS01
PSARSAV  EQU   PSARSVTE+60
PSARSTK  EQU   PSARSVTE+56
PSAESAV3 EQU   PSARSVTE+52
PSAESTK3 EQU   PSARSVTE+48
PSAESAV2 EQU   PSARSVTE+44
PSAESTK2 EQU   PSARSVTE+40
PSAESAV1 EQU   PSARSVTE+36
PSAESTK1 EQU   PSARSVTE+32
PSAPSAV  EQU   PSARSVTE+28
PSAPSTK  EQU   PSARSVTE+24
PSAMSAV  EQU   PSARSVTE+20
PSAMSTK  EQU   PSARSVTE+16
PSASSAV  EQU   PSARSVTE+12
PSASSTK  EQU   PSARSVTE+8
PSANSTK  EQU   PSARSVTE+4
PSACSTK  EQU   PSARSVTE
AWSAEND  EQU   ACRSA+380
ACRCPUAD EQU   ACRCPIDS+2
ACRCAFM  EQU   ACRCPIDS
ACRMTRCD EQU   ACREPSWS+25
@NM00121 EQU   ACREPSWS+24
ACRPER   EQU   ACREPSWS+20
@NM00120 EQU   ACREPSWS+19
ACRPERCD EQU   ACREPSWS+18
ACRMCNUM EQU   ACREPSWS+17
@NM00119 EQU   ACREPSWS+16
ACRTEA   EQU   ACREPSWS+12
ACRPICOD EQU   ACREPSWS+10
ACRPIILC EQU   ACREPSWS+9
@NM00118 EQU   ACREPSWS+8
ACRSVCN  EQU   ACREPSWS+6
ACRSVILC EQU   ACREPSWS+5
@NM00117 EQU   ACREPSWS+4
ACREICOD EQU   ACREPSWS+2
ACRSPAD  EQU   ACREPSWS
ACRTRACE EQU   ACROPSW+60
ACRTIMER EQU   ACROPSW+56
ACRCVT2  EQU   ACROPSW+52
ACRCAW   EQU   ACROPSW+48
ACRCSW   EQU   ACROPSW+40
ACRIOPSW EQU   ACROPSW+32
ACRMOPSW EQU   ACROPSW+24
ACRPOPSW EQU   ACROPSW+16
ACRSOPSW EQU   ACROPSW+8
ACREOPSW EQU   ACROPSW
ACRRPSW  EQU   ACRFLCSV
@NM00116 EQU   ACRSVBSE+244
ACRLMRTN EQU   ACRSVBSE+240
ACRRRPL  EQU   ACRSVBSE+176
@NM00115 EQU   ACRACRSV+68
ACRSVLMR EQU   ACRACRSV+64
ACRSVR15 EQU   ACRACRSV+60
ACRSVR14 EQU   ACRACRSV+56
ACRSVR13 EQU   ACRACRSV+52
ACRSVR12 EQU   ACRACRSV+48
ACRSVR11 EQU   ACRACRSV+44
ACRSVR10 EQU   ACRACRSV+40
ACRSVR9  EQU   ACRACRSV+36
ACRSVR8  EQU   ACRACRSV+32
ACRSVR7  EQU   ACRACRSV+28
ACRSVR6  EQU   ACRACRSV+24
ACRSVR5  EQU   ACRACRSV+20
ACRSVR4  EQU   ACRACRSV+16
ACRSVR3  EQU   ACRACRSV+12
ACRSVR2  EQU   ACRACRSV+8
ACRSVR1  EQU   ACRACRSV+4
ACRSVR0  EQU   ACRACRSV
ACRCTRG1 EQU   ACRSVBSE+100
ACRGPR15 EQU   ACRLMGSV+60
ACRGPR14 EQU   ACRLMGSV+56
ACRGPR13 EQU   ACRLMGSV+52
ACRGPR12 EQU   ACRLMGSV+48
ACRGPR11 EQU   ACRLMGSV+44
ACRGPR10 EQU   ACRLMGSV+40
ACRGPR9  EQU   ACRLMGSV+36
ACRGPR8  EQU   ACRLMGSV+32
ACRGPR7  EQU   ACRLMGSV+28
ACRGPR6  EQU   ACRLMGSV+24
ACRGPR5  EQU   ACRLMGSV+20
ACRGPR4  EQU   ACRLMGSV+16
ACRGPR3  EQU   ACRLMGSV+12
ACRGPR2  EQU   ACRLMGSV+8
ACRGPR1  EQU   ACRLMGSV+4
ACRGPR0  EQU   ACRLMGSV
ACRFLPT6 EQU   ACRLMFSV+24
ACRFLPT4 EQU   ACRLMFSV+16
ACRFLPT2 EQU   ACRLMFSV+8
ACRFLPT0 EQU   ACRLMFSV
RRPLRRGS EQU   RRPLREGS
RRPLRF   EQU   RRPLCNTS+1
RRPLRE   EQU   RRPLCNTS+1
RRPLRD   EQU   RRPLCNTS+1
RRPLRC   EQU   RRPLCNTS+1
RRPLRB   EQU   RRPLCNTS+1
RRPLRA   EQU   RRPLCNTS+1
RRPLR9   EQU   RRPLCNTS+1
RRPLR8   EQU   RRPLCNTS+1
RRPLR7   EQU   RRPLCNTS
RRPLR6   EQU   RRPLCNTS
RRPLR5   EQU   RRPLCNTS
RRPLR4   EQU   RRPLCNTS
RRPLR3   EQU   RRPLCNTS
RRPLR2   EQU   RRPLCNTS
RRPLR1   EQU   RRPLCNTS
RRPLR0   EQU   RRPLCNTS
@NM00114 EQU   RRPLFLGS
RRPLCSD  EQU   RRPLFLGS
RRPLOL   EQU   RRPLFLGS
@NM00113 EQU   BUILD857+39
@NM00112 EQU   BUILD857+34
@NM00111 EQU   BUILD857+29
@NM00110 EQU   BUILD857+19
@NM00109 EQU   BUILD857+4
@NM00108 EQU   BUILD857
@NM00106 EQU   PCCA+512
PCCACAT  EQU   PCCA+384
PCCARV36 EQU   PCCA+380
PCCARV35 EQU   PCCA+378
PCCARV01 EQU   PCCA+377
PCCACPUM EQU   PCCA+376
PCCARV63 EQU   PCCA+372
PCCARV62 EQU   PCCA+368
PCCARV61 EQU   PCCA+364
PCCARV60 EQU   PCCA+360
PCCARV59 EQU   PCCA+356
PCCARV58 EQU   PCCA+352
PCCARV57 EQU   PCCA+348
PCCARV56 EQU   PCCA+344
PCCARV55 EQU   PCCA+340
PCCARV54 EQU   PCCA+336
PCCALOGA EQU   PCCA+332
PCCACHID EQU   PCCA+324
PCCACHSV EQU   PCCA+312
PCCARV79 EQU   PCCACHF4
PCCARV78 EQU   PCCACHF4
PCCARV77 EQU   PCCACHF4
PCCARV76 EQU   PCCACHF4
PCCARV75 EQU   PCCACHF4
PCCARV74 EQU   PCCACHF4
PCCARV73 EQU   PCCACHF4
PCCARV72 EQU   PCCACHF4
PCCARV71 EQU   PCCACHF3
PCCARV70 EQU   PCCACHF3
PCCARV69 EQU   PCCACHF3
PCCARV68 EQU   PCCACHF3
PCCARV67 EQU   PCCACHF3
PCCARV66 EQU   PCCACHF3
PCCARV65 EQU   PCCACHF3
PCCARV64 EQU   PCCACHF3
PCCACF28 EQU   PCCACHF2
PCCACF27 EQU   PCCACHF2
PCCACF26 EQU   PCCACHF2
PCCACF25 EQU   PCCACHF2
PCCACF24 EQU   PCCACHF2
PCCACF23 EQU   PCCACHF2
PCCACF22 EQU   PCCACHF2
PCCACF21 EQU   PCCACHF2
PCCACF18 EQU   PCCACHF1
PCCACF17 EQU   PCCACHF1
PCCACF16 EQU   PCCACHF1
PCCACF15 EQU   PCCACHF1
PCCACF14 EQU   PCCACHF1
PCCACF13 EQU   PCCACHF1
PCCACF12 EQU   PCCACHF1
PCCACF11 EQU   PCCACHF1
PCCARV05 EQU   PCCA+306
PCCACHPB EQU   PCCA+305
PCCALGP2 EQU   PCCA+304
PCCALGP1 EQU   PCCA+303
PCCALOGL EQU   PCCA+302
PCCARV80 EQU   PCCA+300
PCCACHW2 EQU   PCCA+296
PCCACHW1 EQU   PCCA+292
PCCAIOSI EQU   PCCA+291
PCCACNRB EQU   PCCACHRB
PCCACCVB EQU   PCCACHRB
PCCACSNB EQU   PCCACHRB
PCCARV52 EQU   PCCACHRB
PCCACHIB EQU   PCCACHRB
PCCACTIB EQU   PCCACHRB
PCCACINB EQU   PCCACHRB
PCCACSIB EQU   PCCACHRB
PCCARV51 EQU   PCCACHS2
PCCARV50 EQU   PCCACHS2
PCCARV49 EQU   PCCACHS2
PCCACURC EQU   PCCACHS2
PCCACNLG EQU   PCCACHS2
PCCACMOD EQU   PCCACHS2
PCCACALT EQU   PCCACHS2
PCCACIOR EQU   PCCACHS2
PCCARV47 EQU   PCCACHS1
PCCACUCB EQU   PCCACHS1
PCCACIBC EQU   PCCACHS1
PCCACAND EQU   PCCACHS1
PCCACNLS EQU   PCCACHS1
PCCACFRR EQU   PCCACHS1
PCCACNRE EQU   PCCACHS1
PCCACCMP EQU   PCCACHS1
PCCACSEQ EQU   PCCACHTS
PCCACDIN EQU   PCCACHTS
PCCARV44 EQU   PCCACHTS
PCCARV43 EQU   PCCACHTS
PCCACTEC EQU   PCCACHTS
PCCACDAV EQU   PCCACHVA
PCCACCHV EQU   PCCACHVA
PCCACCMD EQU   PCCACHVA
PCCACUNS EQU   PCCACHVA
PCCACSQV EQU   PCCACHVA
PCCARV42 EQU   PCCACHVA
PCCARV41 EQU   PCCACHVA
PCCACITF EQU   PCCACHVA
PCCARV40 EQU   PCCACHBL
PCCARV39 EQU   PCCACHBL
PCCARV38 EQU   PCCACHBL
PCCACCUE EQU   PCCACHBL
PCCACSTG EQU   PCCACHBL
PCCACSCU EQU   PCCACHBL
PCCACCHA EQU   PCCACHBL
PCCACCPU EQU   PCCACHBL
PCCACNOR EQU   PCCACHPF
PCCACCNT EQU   PCCACHPF
PCCACSNS EQU   PCCACHPF
PCCARV37 EQU   PCCACHPF
PCCACHIO EQU   PCCACHPF
PCCACTIO EQU   PCCACHPF
PCCACINT EQU   PCCACHPF
PCCACSIO EQU   PCCACHPF
PCCACHUB EQU   PCCAWERP
PCCACHEL EQU   PCCA+168
PCCALRBR EQU   PCCA+164
PCCAPWAR EQU   PCCA+156
PCCAPWAV EQU   PCCA+152
PCCAEMSA EQU   PCCAEMSB+12
PCCAEMSE EQU   PCCAEMSB+8
PCCAEMSP EQU   PCCAEMSB+4
PCCARMS  EQU   PCCARMSB
PCCARV34 EQU   PCCARMSB
PCCARV33 EQU   PCCARMSB
PCCARV32 EQU   PCCARMSB
PCCARV31 EQU   PCCARMSB
PCCARV30 EQU   PCCARMSB
PCCARV29 EQU   PCCARMSB
PCCARV28 EQU   PCCARMSB
PCCARV27 EQU   PCCAEMS3
PCCARV26 EQU   PCCAEMS3
PCCARV25 EQU   PCCAEMS3
PCCARV24 EQU   PCCAEMS3
PCCARV23 EQU   PCCAEMS3
PCCARV22 EQU   PCCAEMS3
PCCARV21 EQU   PCCAEMS3
PCCARV20 EQU   PCCAEMS3
PCCARV19 EQU   PCCAEMS2
PCCARV18 EQU   PCCAEMS2
PCCARV17 EQU   PCCAEMS2
PCCARV16 EQU   PCCAEMS2
PCCARV15 EQU   PCCAEMS2
PCCARV14 EQU   PCCAEMS2
PCCARV13 EQU   PCCAEMS2
PCCARV12 EQU   PCCAEMS2
PCCARV11 EQU   PCCARISP
PCCARV10 EQU   PCCARISP
PCCARV09 EQU   PCCARISP
PCCARV08 EQU   PCCARISP
PCCARV07 EQU   PCCARISP
PCCARV06 EQU   PCCARISP
PCCASERL EQU   PCCARISP
PCCAPARL EQU   PCCARISP
PCCARPB  EQU   PCCA+132
PCCACTIN EQU   PCCAINTE
PCCANFIN EQU   PCCAINTE
PCCANUIN EQU   PCCAINTE
PCCACTCC EQU   PCCACCE
PCCANFCC EQU   PCCACCE
PCCANUCC EQU   PCCACCE
PCCACTTD EQU   PCCATODE
PCCANFTD EQU   PCCATODE
PCCANUTD EQU   PCCATODE
PCCARV04 EQU   PCCATMFL
PCCARV03 EQU   PCCATMFL
PCCARV02 EQU   PCCATMFL
PCCAMINT EQU   PCCATMFL
PCCAMCC  EQU   PCCATMFL
PCCAVKIL EQU   PCCATMFL
PCCASYNC EQU   PCCATMFL
PCCAINIT EQU   PCCATMFL
PCCARV9E EQU   PCCA+124
PCCARV9D EQU   PCCA+120
PCCARV9C EQU   PCCA+116
PCCARV9B EQU   PCCA+112
PCCARV9A EQU   PCCA+108
PCCARV99 EQU   PCCA+104
PCCARV98 EQU   PCCA+100
PCCARV97 EQU   PCCA+96
PCCARV96 EQU   PCCA+92
PCCARV95 EQU   PCCA+88
PCCARV94 EQU   PCCA+84
PCCARV93 EQU   PCCA+80
PCCARV92 EQU   PCCA+76
PCCARV91 EQU   PCCA+72
PCCARV90 EQU   PCCA+68
PCCARV89 EQU   PCCA+64
PCCARV88 EQU   PCCA+60
PCCARV87 EQU   PCCA+56
PCCARV86 EQU   PCCA+52
PCCARV85 EQU   PCCA+48
PCCARV84 EQU   PCCA+44
PCCARV83 EQU   PCCA+40
PCCARV82 EQU   PCCA+36
PCCARV81 EQU   PCCA+32
PCCAPSAR EQU   PCCA+28
PCCAPSAV EQU   PCCA+24
PCCATQEP EQU   PCCA+20
PCCACAFM EQU   PCCA+18
PCCACPUA EQU   PCCA+16
PCCACPID EQU   PCCA+4
PCCAPCCA EQU   PCCA
RTMBSLIP EQU   RTMBRTAB+48
RTMBXABT EQU   RTMBRTAB+44
RTMBACR  EQU   RTMBRTAB+40
RTMBPROG EQU   RTMBRTAB+36
RTMBMEMT EQU   RTMBRTAB+32
RTMBCABT EQU   RTMBRTAB+28
RTMBPGIO EQU   RTMBRTAB+24
RTMBSVC  EQU   RTMBRTAB+20
RTMBMACH EQU   RTMBRTAB+16
RTMBREST EQU   RTMBRTAB+12
RTMBDAT  EQU   RTMBRTAB+8
RTMBPAD2 EQU   RTMBTERM+6
RTMBBRAN EQU   RTMBTERM+2
RTMBBALR EQU   RTMBTERM
@NM00105 EQU   SDWA+512
@NM00104 EQU   SDWADPVA
SDWAEBC  EQU   SDWADPVA
SDWAVRAL EQU   SDWARA
@NM00103 EQU   SDWA+396
SDWACOMP EQU   SDWA+392
SDWARCPL EQU   SDWA+364
@NM00102 EQU   SDWADPSA+32
SDWATO4  EQU   SDWADPSL+28
SDWAFRM4 EQU   SDWADPSL+24
SDWATO3  EQU   SDWADPSL+20
SDWAFRM3 EQU   SDWADPSL+16
SDWATO2  EQU   SDWADPSL+12
SDWAFRM2 EQU   SDWADPSL+8
SDWATO1  EQU   SDWADPSL+4
SDWAFRM1 EQU   SDWADPSL
@NM00101 EQU   SDWADDAT+3
@NM00100 EQU   SDWAPDAT
SDWAUSPL EQU   SDWAPDAT
SDWADPSW EQU   SDWAPDAT
SDWATJPA EQU   SDWAPDAT
SDWATLPA EQU   SDWAPDAT
SDWADREG EQU   SDWAPDAT
SDWADSAH EQU   SDWAPDAT
SDWADSAS EQU   SDWAPDAT
@NM00099 EQU   SDWADDAT+1
@NM00098 EQU   SDWASDAT
SDWAQQS  EQU   SDWASDAT
SDWACBS  EQU   SDWASDAT
SDWAGTF  EQU   SDWASDAT
SDWASWA  EQU   SDWASDAT
SDWALSQA EQU   SDWASDAT
SDWASQA  EQU   SDWASDAT
SDWANUC  EQU   SDWASDAT
@NM00097 EQU   SDWADUMP+2
@NM00096 EQU   SDWADPFS
SDWASLST EQU   SDWADPFS
@NM00095 EQU   SDWADPFS
SDWADLST EQU   SDWADPFS
SDWADPT  EQU   SDWADPFS
SDWADPID EQU   SDWADUMP
SDWADPLA EQU   SDWA+316
SDWAREXN EQU   SDWARECP+16
SDWACSCT EQU   SDWARECP+8
SDWAMODN EQU   SDWARECP
@NM00094 EQU   SDWALKWA+32
SDWATALW EQU   SDWALKWS+28
SDWATDLW EQU   SDWALKWS+24
SDWATNLW EQU   SDWALKWS+20
SDWAAPLW EQU   SDWALKWS+16
SDWAIPLW EQU   SDWALKWS+12
SDWAILLW EQU   SDWALKWS+8
SDWAIULW EQU   SDWALKWS+4
SDWAICLW EQU   SDWALKWS
SDWAFLLK EQU   SDWAACF4
SDWACMS  EQU   SDWAACF4
SDWAOPTM EQU   SDWAACF4
SDWATADB EQU   SDWAACF4
SDWATDNB EQU   SDWAACF4
SDWATNCB EQU   SDWAACF4
SDWAILCH EQU   SDWAACF4
SDWAIUCB EQU   SDWAACF4
SDWAICAT EQU   SDWAACF3
SDWAIPRG EQU   SDWAACF3
SDWASALL EQU   SDWAACF3
SDWAASMP EQU   SDWAACF3
SDWADISP EQU   SDWAACF3
@NM00093 EQU   SDWAACF3
@NM00092 EQU   SDWAACF2
SDWAFREE EQU   SDWAACF2
@NM00091 EQU   SDWAACF2
SDWASPIN EQU   SDWAACF2
@NM00090 EQU   SDWAACF2
SDWARCRD EQU   SDWAACF2
SDWALCPU EQU   SDWACPUA+2
@NM00089 EQU   SDWACPUA
SDWARECA EQU   SDWA+244
@NM00088 EQU   SDWA+239
@NM00087 EQU   SDWAIOFS
SDWANIOP EQU   SDWAIOFS
SDWANOIO EQU   SDWAIOFS
SDWAIOHT EQU   SDWAIOFS
SDWAIOQR EQU   SDWAIOFS
SDWAFMID EQU   SDWA+236
@NM00086 EQU   SDWAERRD
SDWAMCIV EQU   SDWAERRD
SDWARPIV EQU   SDWAERRD
SDWAMABD EQU   SDWAERRD
SDWACTS  EQU   SDWAERRD
SDWASTAE EQU   SDWAERRD
SDWANRBE EQU   SDWAERRD
SDWACLUP EQU   SDWAERRD
@NM00085 EQU   SDWAERRC
SDWAEAS  EQU   SDWAERRC
SDWAPERC EQU   SDWAERRC
SDWAIRB  EQU   SDWAERRC
SDWASTAI EQU   SDWAERRC
SDWASTAF EQU   SDWAERRC
SDWASRBM EQU   SDWAERRB
SDWALDIS EQU   SDWAERRB
SDWAENRB EQU   SDWAERRB
SDWATYP1 EQU   SDWAERRB
@NM00084 EQU   SDWAERRB
SDWAPGIO EQU   SDWAERRA
SDWATEXC EQU   SDWAERRA
SDWASVCE EQU   SDWAERRA
SDWAABTM EQU   SDWAERRA
SDWASVCD EQU   SDWAERRA
SDWARKEY EQU   SDWAERRA
SDWAPCHK EQU   SDWAERRA
SDWATIME EQU   SDWAMCH+20
SDWARFSA EQU   SDWAMCH+16
@NM00083 EQU   SDWAMCH+14
SDWAVEQR EQU   SDWARSR2
SDWAPGFX EQU   SDWARSR2
SDWAFLSQ EQU   SDWARSR2
SDWAFSQA EQU   SDWARSR2
SDWANUCL EQU   SDWARSR2
SDWASPER EQU   SDWARSR2
SDWAINTC EQU   SDWARSR2
SDWAOFLN EQU   SDWARSR2
SDWACHNG EQU   SDWARSR1
SDWAMSER EQU   SDWARSR1
@NM00082 EQU   SDWARSR1
SDWACPID EQU   SDWAMCH+10
SDWATERR EQU   SDWAMCHD
SDWAFPRX EQU   SDWAMCHD
SDWAINSF EQU   SDWAMCHD
SDWAACR  EQU   SDWAMCHD
SDWASCK  EQU   SDWAMCHD
SDWAPSWU EQU   SDWAMCHD
SDWAREGU EQU   SDWAMCHD
SDWASKYF EQU   SDWAMCHD
@NM00081 EQU   SDWAMCHS
SDWARSRF EQU   SDWAMCHS
SDWARSRC EQU   SDWAMCHS
SDWAINVP EQU   SDWAMCHS
SDWATSVL EQU   SDWAMCHS
SDWARCDF EQU   SDWAMCHS
SDWASRVL EQU   SDWAMCHS
SDWASCKE EQU   SDWASTCK+4
SDWASCKB EQU   SDWASTCK
SDWALNTH EQU   SDWAIDNT+1
SDWASPID EQU   SDWAIDNT
SDWASR15 EQU   SDWASRSV+60
SDWASR14 EQU   SDWASRSV+56
SDWASR13 EQU   SDWASRSV+52
SDWASR12 EQU   SDWASRSV+48
SDWASR11 EQU   SDWASRSV+44
SDWASR10 EQU   SDWASRSV+40
SDWASR09 EQU   SDWASRSV+36
SDWASR08 EQU   SDWASRSV+32
SDWASR07 EQU   SDWASRSV+28
SDWASR06 EQU   SDWASRSV+24
SDWASR05 EQU   SDWASRSV+20
SDWASR04 EQU   SDWASRSV+16
SDWASR03 EQU   SDWASRSV+12
SDWASR02 EQU   SDWASRSV+8
SDWASR01 EQU   SDWASRSV+4
SDWASR00 EQU   SDWASRSV
SDWATRN2 EQU   SDWAAEC2+4
SDWAIPC2 EQU   SDWAICD2
SDWAIMC2 EQU   SDWAICD2
SDWAIPR2 EQU   SDWAICD2
@NM00080 EQU   SDWAINC2
@NM00079 EQU   SDWAILC2
SDWAIL2  EQU   SDWAILC2
@NM00078 EQU   SDWAILC2
@NM00077 EQU   SDWAAEC2
SDWAADD2 EQU   SDWANXT2+1
@NM00076 EQU   SDWANXT2
@NM00075 EQU   SDWAEC2+3
SDWASGN2 EQU   SDWAINT2
SDWAEXP2 EQU   SDWAINT2
SDWADEC2 EQU   SDWAINT2
SDWAFPO2 EQU   SDWAINT2
SDWACC2  EQU   SDWAINT2
@NM00074 EQU   SDWAINT2
SDWAPGM2 EQU   SDWAMWP2
SDWAWAT2 EQU   SDWAMWP2
SDWAMCK2 EQU   SDWAMWP2
SDWAECT2 EQU   SDWAMWP2
SDWAKEY2 EQU   SDWAMWP2
SDWAEXT2 EQU   SDWAEMK2
SDWAIO2  EQU   SDWAEMK2
SDWATRM2 EQU   SDWAEMK2
@NM00073 EQU   SDWAEMK2
SDWAPER2 EQU   SDWAEMK2
@NM00072 EQU   SDWAEMK2
SDWATRAN EQU   SDWAAEC1+4
SDWAIPC1 EQU   SDWAICD1
SDWAIMC1 EQU   SDWAICD1
SDWAIPR1 EQU   SDWAICD1
@NM00071 EQU   SDWAINC1
@NM00070 EQU   SDWAILC1
SDWAIL1  EQU   SDWAILC1
@NM00069 EQU   SDWAILC1
@NM00068 EQU   SDWAAEC1
SDWAADD1 EQU   SDWANXT1+1
@NM00067 EQU   SDWANXT1
@NM00066 EQU   SDWAEC1+3
SDWASGN1 EQU   SDWAINT1
SDWAEXP1 EQU   SDWAINT1
SDWADEC1 EQU   SDWAINT1
SDWAFPO1 EQU   SDWAINT1
SDWACC1  EQU   SDWAINT1
@NM00065 EQU   SDWAINT1
SDWAPGM1 EQU   SDWAMWP1
SDWAWAT1 EQU   SDWAMWP1
SDWAMCK1 EQU   SDWAMWP1
SDWAECT1 EQU   SDWAMWP1
SDWAKEY1 EQU   SDWAMWP1
SDWAEXT1 EQU   SDWAEMK1
SDWAIO1  EQU   SDWAEMK1
SDWATRM1 EQU   SDWAEMK1
@NM00064 EQU   SDWAEMK1
SDWAPER1 EQU   SDWAEMK1
@NM00063 EQU   SDWAEMK1
SDWAIOBR EQU   SDWA+100
SDWAEPA  EQU   SDWA+96
@NM00062 EQU   SDWANAME+4
SDWARBAD EQU   SDWANAME
SDWAGR15 EQU   SDWAGRSV+60
SDWAGR14 EQU   SDWAGRSV+56
SDWAGR13 EQU   SDWAGRSV+52
SDWAGR12 EQU   SDWAGRSV+48
SDWAGR11 EQU   SDWAGRSV+44
SDWAGR10 EQU   SDWAGRSV+40
SDWAGR09 EQU   SDWAGRSV+36
SDWAGR08 EQU   SDWAGRSV+32
SDWAGR07 EQU   SDWAGRSV+28
SDWAGR06 EQU   SDWAGRSV+24
SDWAGR05 EQU   SDWAGRSV+20
SDWAGR04 EQU   SDWAGRSV+16
SDWAGR03 EQU   SDWAGRSV+12
SDWAGR02 EQU   SDWAGRSV+8
SDWAGR01 EQU   SDWAGRSV+4
SDWAGR00 EQU   SDWAGRSV
SDWANXTP EQU   SDWACTL2+5
SDWASGP  EQU   SDWAPMKP
SDWAEUP  EQU   SDWAPMKP
SDWADOP  EQU   SDWAPMKP
SDWAFPP  EQU   SDWAPMKP
SDWACCP  EQU   SDWAPMKP
SDWAILP  EQU   SDWAPMKP
SDWAINTP EQU   SDWACTL2+2
SDWASPVP EQU   SDWAMWPP
SDWAWATP EQU   SDWAMWPP
SDWAMCKP EQU   SDWAMWPP
@NM00061 EQU   SDWAMWPP
SDWAKEYP EQU   SDWAMWPP
SDWAEXTP EQU   SDWACMKP
SDWAIOP  EQU   SDWACMKP
SDWANXTA EQU   SDWACTL1+5
SDWASGA  EQU   SDWAPMKA
SDWAEUA  EQU   SDWAPMKA
SDWADOA  EQU   SDWAPMKA
SDWAFPA  EQU   SDWAPMKA
SDWACCA  EQU   SDWAPMKA
SDWAILA  EQU   SDWAPMKA
SDWAINTA EQU   SDWACTL1+2
SDWASPVA EQU   SDWAMWPA
SDWAWATA EQU   SDWAMWPA
SDWAMCKA EQU   SDWAMWPA
@NM00060 EQU   SDWAMWPA
SDWAKEYA EQU   SDWAMWPA
SDWAEXTA EQU   SDWACMKA
SDWAIOA  EQU   SDWACMKA
SDWACMPC EQU   SDWAABCC+1
@NM00059 EQU   SDWACMPF
SDWASTCC EQU   SDWACMPF
@NM00058 EQU   SDWACMPF
SDWASTEP EQU   SDWACMPF
SDWAREQ  EQU   SDWACMPF
SDWAPARM EQU   SDWA
WSACCCH  EQU   WSAC+52
WSACRRSA EQU   WSAC+48
WSACREST EQU   WSAC+44
WSACRSTI EQU   WSAC+40
WSACABTM EQU   WSAC+36
WSACMF1  EQU   WSAC+32
WSACEDS0 EQU   WSAC+28
WSACIOS  EQU   WSAC+24
WSACRTMK EQU   WSAC+20
WSACTIME EQU   WSAC+12
WSACOPTM EQU   WSAC+8
WSACGTF  EQU   WSAC+4
WSACCWSA EQU   WSAC
WSAGSCHE EQU   WSAG+40
WSAGREST EQU   WSAG+36
WSAGNQDQ EQU   WSAG+32
WSAGMEMT EQU   WSAG+28
WSAGOPTM EQU   WSAG+24
WSAGSTAT EQU   WSAG+20
WSAGEMS0 EQU   WSAG+16
WSAGSSRS EQU   WSAG+12
WSAGRSM  EQU   WSAG+8
WSAGGMFM EQU   WSAG+4
WSAGPGIO EQU   WSAG
LRBCMPCS EQU   LRBCMP+2
LRBCMPPA EQU   LRBCMP
LRBCMPNO EQU   LRBCVAR+6
LRBCMPF2 EQU   LRBCVAR+5
LRBCMPF1 EQU   LRBCVAR+4
LRBCRESD EQU   LRBCVAR+2
LRBCFT   EQU   LRBCVAR
LRBHMCEL EQU   LRBHCPID+6
LRBHMDL  EQU   LRBHCPID+4
LRBHCSER EQU   LRBHCPID+1
@NM00031 EQU   LRBHCPID
LRBHTIME EQU   LRB+12
LRBHDATE EQU   LRB+8
@NM00030 EQU   LRB+7
LRBHCNT  EQU   LRB+6
LRBMCLB  EQU   LRBHSW3
LRBNDEM  EQU   LRBMACT
LRBNCEM  EQU   LRBMACT
@NM00029 EQU   LRBHSW0
LRBHTMC  EQU   LRBHSW0
@NM00028 EQU   LRBHSW0
LRBHNS   EQU   LRBHSW0
LRBHMORE EQU   LRBHSW0
@NM00027 EQU   LRBHSYS
LRBHSYSB EQU   LRBHSYS
CVTLEVL  EQU   CVTRELNO+2
CVTNUMB  EQU   CVTRELNO
CVTMDL   EQU   CVTFIX+250
@NM00026 EQU   CVTFIX+248
@NM00025 EQU   CVTFIX
CVTRV482 EQU   CVTXTNT2+128
CVTRV481 EQU   CVTXTNT2+124
CVTRV480 EQU   CVTXTNT2+120
CVTRV479 EQU   CVTXTNT2+118
CVTRV478 EQU   CVTXTNT2+117
CVTRV477 EQU   CVTXTNT2+116
CVTRV476 EQU   CVTXTNT2+115
CVTRV475 EQU   CVTXTNT2+114
CVTRV474 EQU   CVTRV466
CVTRV473 EQU   CVTRV466
CVTRV472 EQU   CVTRV466
CVTRV471 EQU   CVTRV466
CVTRV470 EQU   CVTRV466
CVTRV469 EQU   CVTRV466
CVTRV468 EQU   CVTRV466
CVTRV467 EQU   CVTRV466
CVTRV465 EQU   CVTRV457
CVTRV464 EQU   CVTRV457
CVTRV463 EQU   CVTRV457
CVTRV462 EQU   CVTRV457
CVTRV461 EQU   CVTRV457
CVTRV460 EQU   CVTRV457
CVTRV459 EQU   CVTRV457
CVTRV458 EQU   CVTRV457
CVTRV456 EQU   CVTXTNT2+108
CVTRV455 EQU   CVTXTNT2+104
CVTRV454 EQU   CVTXTNT2+100
CVTRV453 EQU   CVTXTNT2+96
CVTRV452 EQU   CVTXTNT2+94
CVTRV451 EQU   CVTXTNT2+92
CVTRV450 EQU   CVTXTNT2+90
CVTRV449 EQU   CVTXTNT2+88
CVTRV448 EQU   CVTXTNT2+87
CVTRV447 EQU   CVTXTNT2+86
CVTRV446 EQU   CVTRV438
CVTRV445 EQU   CVTRV438
CVTRV444 EQU   CVTRV438
CVTRV443 EQU   CVTRV438
CVTRV442 EQU   CVTRV438
CVTRV441 EQU   CVTRV438
CVTRV440 EQU   CVTRV438
CVTRV439 EQU   CVTRV438
CVTRV437 EQU   CVTRV429
CVTRV436 EQU   CVTRV429
CVTRV435 EQU   CVTRV429
CVTRV434 EQU   CVTRV429
CVTRV433 EQU   CVTRV429
CVTRV432 EQU   CVTRV429
CVTRV431 EQU   CVTRV429
CVTRV430 EQU   CVTRV429
CVTRV428 EQU   CVTXTNT2+80
CVTRV427 EQU   CVTXTNT2+76
CVTRV426 EQU   CVTXTNT2+72
CVTRV425 EQU   CVTXTNT2+68
CVTATACT EQU   CVTATCVT
CVTRV423 EQU   CVTXTNT2+62
CVTRV422 EQU   CVTXTNT2+60
CVTRV421 EQU   CVTXTNT2+58
CVTRV420 EQU   CVTXTNT2+56
CVTRV419 EQU   CVTXTNT2+55
CVTRV418 EQU   CVTXTNT2+54
CVTRV417 EQU   CVTRV409
CVTRV416 EQU   CVTRV409
CVTRV415 EQU   CVTRV409
CVTRV414 EQU   CVTRV409
CVTRV413 EQU   CVTRV409
CVTRV412 EQU   CVTRV409
CVTRV411 EQU   CVTRV409
CVTRV410 EQU   CVTRV409
CVTRV408 EQU   CVTRV400
CVTRV407 EQU   CVTRV400
CVTRV406 EQU   CVTRV400
CVTRV405 EQU   CVTRV400
CVTRV404 EQU   CVTRV400
CVTRV403 EQU   CVTRV400
CVTRV402 EQU   CVTRV400
CVTRV401 EQU   CVTRV400
CVTRSVA1 EQU   CVTXTNT2+48
CVTRSVA0 EQU   CVTXTNT2+44
CVTRSV99 EQU   CVTXTNT2+40
CVTRSV98 EQU   CVTXTNT2+36
CVTRSV97 EQU   CVTXTNT2+34
CVTRSV96 EQU   CVTXTNT2+32
CVTOLTEP EQU   CVTXTNT2+28
CVTQIDA  EQU   CVTQID+1
CVTRSV95 EQU   CVTQID
CVTRSV94 EQU   CVTXTNT2+20
CVTRSV93 EQU   CVTXTNT2+16
CVTRSV92 EQU   CVTXTNT2+12
CVTDEBVR EQU   CVTXTNT2+8
CVTRSV91 EQU   CVTXTNT2+6
CVTRSV9H EQU   CVTRSV90
CVTRSV9G EQU   CVTRSV90
CVTRSV9F EQU   CVTRSV90
CVTRSV9E EQU   CVTRSV90
CVTRSV9D EQU   CVTRSV90
CVTRSV9C EQU   CVTRSV90
CVTRSV9B EQU   CVTRSV90
CVTRSV9A EQU   CVTRSV90
CVTNUCLS EQU   CVTXTNT2+4
CVTDSSVA EQU   CVTDSSV+1
CVTRSV89 EQU   CVTDSSV
CVTRSV88 EQU   CVTXTNT1+8
CVTRSV87 EQU   CVTXTNT1+4
CVTFACHN EQU   CVTXTNT1
CVTRV488 EQU   CVTMAP+412
CVTRV487 EQU   CVTMAP+408
CVTRV486 EQU   CVTMAP+404
CVTRV485 EQU   CVTMAP+400
CVTRV484 EQU   CVTMAP+396
CVTAUTH  EQU   CVTMAP+392
CVTATMCA EQU   CVTATMCT+1
CVTATMST EQU   CVTATMCT
CVTRSV61 EQU   CVTMAP+384
CVTVOLT1 EQU   CVTVOLM1+1
CVTVOLI1 EQU   CVTVOLF1
CVTSTOA  EQU   CVTMAP+376
CVTRSV58 EQU   CVTMAP+374
CVTRSV57 EQU   CVTMAP+372
CVTDDCE  EQU   CVTMAP+368
CVTPNWFR EQU   CVTMAP+364
CVTSMF   EQU   CVTMAP+360
CVTSULK  EQU   CVTMAP+358
CVTSLKO  EQU   CVTSYSK
CVTSLKP  EQU   CVTSYSK
CVTSLKQ  EQU   CVTSYSK
CVTSLKR  EQU   CVTSYSK
CVTRSV56 EQU   CVTSYSK
CVTRSV55 EQU   CVTSYSK
CVTRSV54 EQU   CVTSYSK
CVTRSV53 EQU   CVTSYSK
CVTRSV52 EQU   CVTA1F1
CVTRSV51 EQU   CVTA1F1
CVTRSV50 EQU   CVTA1F1
CVTRSV49 EQU   CVTA1F1
CVTRSV48 EQU   CVTA1F1
CVTRSV47 EQU   CVTA1F1
CVTSRSW  EQU   CVTA1F1
CVTPFSW  EQU   CVTA1F1
CVTPCVT  EQU   CVTMAP+352
CVTRSV46 EQU   CVTMAP+344
CVTRSV45 EQU   CVTMAP+340
CVTRSV44 EQU   CVTMAP+338
CVTRSV43 EQU   CVTMAP+336
CVTHJESA EQU   CVTHJES+1
CVTRSV42 EQU   CVTHJES
CVTEXT2A EQU   CVTEXT2+1
CVTRSV41 EQU   CVTEXT2
CVTAPFA  EQU   CVTAPF+1
CVTRSV40 EQU   CVTAPF
CVTRV518 EQU   CVTINTLA
CVTRV517 EQU   CVTERPV
CVTEORM  EQU   CVTMAP+312
CVTMCHPR EQU   CVTMAP+308
CVTTZ    EQU   CVTMAP+304
CVTJEPS  EQU   CVTMAP+300
CVTJESCT EQU   CVTMAP+296
CVTMODE  EQU   CVTMAP+292
CVTPTRV  EQU   CVTMAP+288
CVTREAL  EQU   CVTMAP+284
CVTRSV39 EQU   CVTMAP+280
CVTRSV38 EQU   CVTMAP+276
CVTDMSRA EQU   CVTDMSR+1
CVTRSV37 EQU   CVTDMSR
CVTQMSGA EQU   CVTQMSG+1
CVTRSV36 EQU   CVTQMSG
CVTAMFF  EQU   CVTMAP+264
CVTPURGA EQU   CVTPURG+1
CVTRSV35 EQU   CVTPURG
CVTCBSP  EQU   CVTMAP+256
CVTATERA EQU   CVTATER+1
CVTSYST  EQU   CVTATER
CVTVOLT2 EQU   CVTTAT
CVTVOLI2 EQU   CVTVOLF2
CVTAQAVB EQU   CVTAQAVT+1
CVTRSV34 EQU   CVTTCMFG
CVTRSV33 EQU   CVTTCMFG
CVTRSV32 EQU   CVTTCMFG
CVTRSV31 EQU   CVTTCMFG
CVTRSV30 EQU   CVTTCMFG
CVTRSV29 EQU   CVTTCMFG
CVTRSV28 EQU   CVTTCMFG
CVTTCRDY EQU   CVTTCMFG
CVTGTFA  EQU   CVTGTF+1
CVTRSV27 EQU   CVTGTFST
CVTRNIO  EQU   CVTGTFST
CVTRV319 EQU   CVTUSR
CVTRV318 EQU   CVTFORM
CVTRV317 EQU   CVTTMODE
CVTRV316 EQU   CVTSTATE
CVTRV315 EQU   CVTGTFS
CVTGTFAV EQU   CVTGTFS
CVT0SCR1 EQU   CVTMAP+232
CVTRV515 EQU   CVTMAP+228
CVTRMS   EQU   CVTMAP+224
CVTPATCH EQU   CVTMAP+220
CVTTSCE  EQU   CVTMAP+216
CVTLNKSC EQU   CVTMAP+214
CVTQABST EQU   CVTMAP+212
CVTMDLDS EQU   CVTMAP+208
CVTUSER  EQU   CVTMAP+204
CVTABEND EQU   CVTMAP+200
CVTSMCA  EQU   CVTMAP+196
CVTRSV18 EQU   CVTMAP+192
CVTQLPAQ EQU   CVTMAP+188
CVTQCDSR EQU   CVTMAP+184
CVTRSV17 EQU   CVTOPTB
CVTRSV16 EQU   CVTOPTB
CVTFP    EQU   CVTOPTB
CVTAPTHR EQU   CVTOPTB
CVTNLOG  EQU   CVTOPTB
CVTTOD   EQU   CVTOPTB
CVTCTIMS EQU   CVTOPTB
CVTPROT  EQU   CVTOPTB
CVTXPFP  EQU   CVTOPTA
CVTASCII EQU   CVTOPTA
CVTRSV13 EQU   CVTOPTA
CVTRSV12 EQU   CVTOPTA
CVTNIP   EQU   CVTOPTA
CVTDDR   EQU   CVTOPTA
CVTAPR   EQU   CVTOPTA
CVTCCH   EQU   CVTOPTA
CVTSNCTR EQU   CVTMAP+180
CVTQMWR  EQU   CVTMAP+176
CVTQOCR  EQU   CVTMAP+172
CVT1EF00 EQU   CVTMAP+168
CVTMZ00  EQU   CVTMAP+164
CVTHEAD  EQU   CVTMAP+160
CVTRSV11 EQU   CVTMAP+156
CVT0PT01 EQU   CVTMAP+152
CVTMSER  EQU   CVTMAP+148
CVTRV516 EQU   CVTIERLC
CVTILCH  EQU   CVTMAP+140
CVT0DS   EQU   CVTMAP+136
CVTFBOSV EQU   CVTMAP+132
CVTNUCB  EQU   CVTMAP+128
CVTIXAVL EQU   CVTMAP+124
CVTIOQET EQU   CVTMAP+120
CVTDCBA  EQU   CVTMAP+117
CVTMVS2  EQU   CVTDCB
CVT6DAT  EQU   CVTDCB
CVT4MPS  EQU   CVTDCB
CVTRSV09 EQU   CVTDCB
CVT4MS1  EQU   CVTDCB
CVT2SPS  EQU   CVTDCB
CVT1SSS  EQU   CVTDCB
CVTRSV08 EQU   CVTDCB
CVTSTB   EQU   CVTMAP+112
CVTQTD00 EQU   CVTMAP+108
CVTQTE00 EQU   CVTMAP+104
CVTCUCB  EQU   CVTMAP+100
CVTSJQ   EQU   CVTMAP+96
CVTPBLDL EQU   CVTMAP+92
CVTTPC   EQU   CVTMAP+88
CVTSVDCB EQU   CVTMAP+84
CVTBRET  EQU   CVTMAP+82
CVTEXIT  EQU   CVTMAP+80
CVT0FN00 EQU   CVTMAP+76
CVTDARA  EQU   CVTDAR+1
CVTRSV07 EQU   CVTFLGS1
CVTRSV06 EQU   CVTFLGS1
CVTRSV05 EQU   CVTFLGS1
CVTRSV04 EQU   CVTFLGS1
CVTRSV03 EQU   CVTFLGS1
CVTRSV02 EQU   CVTFLGS1
CVTRSV01 EQU   CVTFLGS1
CVTDMPLK EQU   CVTFLGS1
CVTXITP  EQU   CVTMAP+68
CVTZDTAB EQU   CVTMAP+64
CVTMSLT  EQU   CVTMAP+60
CVTDATE  EQU   CVTMAP+56
CVTSYSAD EQU   CVTMAP+48
CVTXTLER EQU   CVTMAP+44
CVTILK2  EQU   CVTMAP+40
CVTILK1  EQU   CVTMAP+36
CVTPRLTV EQU   CVTMAP+32
CVTPCNVT EQU   CVTMAP+28
CVT0VL00 EQU   CVTMAP+24
CVTXAPG  EQU   CVTMAP+20
CVTBUF   EQU   CVTMAP+16
CVTJOB   EQU   CVTMAP+12
CVTLINK  EQU   CVTMAP+8
CVT0EF00 EQU   CVTMAP+4
CVTTCBP  EQU   CVTMAP
CVT      EQU   CVTMAP
LCCAR125 EQU   LCCA+964
LCCAR124 EQU   LCCA+960
LCCAR123 EQU   LCCA+956
LCCAR122 EQU   LCCA+952
LCCAR121 EQU   LCCA+948
LCCAR120 EQU   LCCA+944
LCCAR119 EQU   LCCA+940
LCCAR118 EQU   LCCA+936
LCCAR117 EQU   LCCA+932
LCCAR116 EQU   LCCA+928
LCCAR115 EQU   LCCA+924
LCCAR114 EQU   LCCA+920
LCCAR113 EQU   LCCA+916
LCCAR112 EQU   LCCA+912
LCCAR111 EQU   LCCA+908
LCCAR110 EQU   LCCA+904
LCCAR109 EQU   LCCA+900
LCCAR108 EQU   LCCA+896
LCCADRT2 EQU   LCCA+888
LCCADRT1 EQU   LCCA+880
LCCAR103 EQU   LCCA+876
LCCAESS2 EQU   LCCA+872
LCCASPLJ EQU   LCCA+868
LCCASMQJ EQU   LCCA+864
LCCAIRT  EQU   LCCA+736
LCCARV90 EQU   LCCA+732
LCCARV89 EQU   LCCA+728
LCCAPGTA EQU   LCCASRBF+2
LCCASAFN EQU   LCCASRBF
LCCAECSA EQU   LCCA+716
LCCAICR0 EQU   LCCA+712
LCCALWTM EQU   LCCA+704
LCCARV78 EQU   LCCA+700
LCCAPINV EQU   LCCA+696
LCCARV88 EQU   LCCA+695
LCCARV87 EQU   LCCALKFG
LCCARV86 EQU   LCCALKFG
LCCARV85 EQU   LCCALKFG
LCCARV84 EQU   LCCALKFG
LCCALKRD EQU   LCCALKFG
LCCALKAQ EQU   LCCALKFG
LCCALKSA EQU   LCCALKFG
LCCALKDP EQU   LCCALKFG
LCCACRST EQU   LCCACREX
LCCACRDP EQU   LCCACREX
LCCACRLM EQU   LCCACREX
LCCACRRT EQU   LCCACREX
LCCACRLE EQU   LCCACREX
LCCACRRM EQU   LCCACREX
LCCACREF EQU   LCCACREX
LCCAVARY EQU   LCCACRFL
LCCARV73 EQU   LCCACRFL
LCCARV72 EQU   LCCACRFL
LCCARV71 EQU   LCCACRFL
LCCARV70 EQU   LCCACRFL
LCCARV69 EQU   LCCACRFL
LCCACLMS EQU   LCCACRFL
LCCALCR0 EQU   LCCA+688
LCCACRLC EQU   LCCA+684
LCCASRBJ EQU   LCCA+672
LCCADSSR EQU   LCCA+668
LCCADSSC EQU   LCCA+660
LCCADSS3 EQU   LCCA+648
LCCADSS2 EQU   LCCA+636
LCCADSS1 EQU   LCCA+624
LCCAWTIM EQU   LCCA+616
LCCAITOD EQU   LCCA+608
LCCADTOD EQU   LCCA+600
LCCASTOD EQU   LCCA+592
LCCARIR5 EQU   LCCASPSA+44
LCCARIR4 EQU   LCCASPSA+40
LCCARIR3 EQU   LCCASPSA+36
LCCARIR2 EQU   LCCASPSA+32
LCCARPR5 EQU   LCCASPSA+28
LCCARPR4 EQU   LCCASPSA+24
LCCARPR3 EQU   LCCASPSA+20
LCCARPR2 EQU   LCCASPSA+16
LCCADSR5 EQU   LCCASPSA+12
LCCADSR4 EQU   LCCASPSA+8
LCCADSR3 EQU   LCCASPSA+4
LCCADSR2 EQU   LCCASPSA
LCCARV68 EQU   LCCA+543
LCCAPSMK EQU   LCCA+542
LCCARV67 EQU   LCCADSF2
LCCARV66 EQU   LCCADSF2
LCCARV65 EQU   LCCADSF2
LCCARV64 EQU   LCCADSF2
LCCADSRW EQU   LCCADSF2
LCCADSPL EQU   LCCADSF2
LCCAGSRB EQU   LCCADSF2
LCCASRBM EQU   LCCADSF2
LCCARV61 EQU   LCCADSF1
LCCARV60 EQU   LCCADSF1
LCCARV59 EQU   LCCADSF1
LCCARV58 EQU   LCCADSF1
LCCATIMR EQU   LCCADSF1
LCCADSS  EQU   LCCADSF1
LCCAVCPU EQU   LCCADSF1
LCCAACR  EQU   LCCADSF1
LCCAASCP EQU   LCCA+532
LCCAESSA EQU   LCCA+528
LCCARV55 EQU   LCCASPN4
LCCARV54 EQU   LCCASPN4
LCCARV53 EQU   LCCASPN4
LCCARV52 EQU   LCCASPN4
LCCARV51 EQU   LCCASPN4
LCCARV50 EQU   LCCASPN4
LCCARV49 EQU   LCCASPN4
LCCARV48 EQU   LCCASPN4
LCCARV47 EQU   LCCASPN3
LCCARV46 EQU   LCCASPN3
LCCARV45 EQU   LCCASPN3
LCCARV44 EQU   LCCASPN3
LCCARV43 EQU   LCCASPN3
LCCARV42 EQU   LCCASPN3
LCCARV41 EQU   LCCASPN3
LCCARV40 EQU   LCCASPN3
LCCARV39 EQU   LCCASPN2
LCCARV38 EQU   LCCASPN2
LCCARV37 EQU   LCCASPN2
LCCARV36 EQU   LCCASPN2
LCCARV35 EQU   LCCASPN2
LCCARV34 EQU   LCCASPN2
LCCARV33 EQU   LCCASPN2
LCCARV32 EQU   LCCASPN2
LCCARV31 EQU   LCCASPN1
LCCARV30 EQU   LCCASPN1
LCCAMFIO EQU   LCCASPN1
LCCARSTR EQU   LCCASPN1
LCCATSPN EQU   LCCASPN1
LCCALOCK EQU   LCCASPN1
LCCASIGP EQU   LCCASPN1
LCCAPTLB EQU   LCCASPN1
LCCARV27 EQU   LCCAIHR4
LCCARV26 EQU   LCCAIHR4
LCCARV25 EQU   LCCAIHR4
LCCARV24 EQU   LCCAIHR4
LCCARV23 EQU   LCCAIHR4
LCCARV22 EQU   LCCAIHR4
LCCARV21 EQU   LCCAIHR4
LCCARV20 EQU   LCCAIHR4
LCCARV19 EQU   LCCAIHR3
LCCARV18 EQU   LCCAIHR3
LCCARV17 EQU   LCCAIHR3
LCCARV16 EQU   LCCAIHR3
LCCARV15 EQU   LCCAIHR3
LCCARV14 EQU   LCCAIHR3
LCCARV13 EQU   LCCAIHR3
LCCARV12 EQU   LCCAIHR3
LCCARV11 EQU   LCCAIHR2
LCCARV10 EQU   LCCAIHR2
LCCARV09 EQU   LCCAIHR2
LCCARV08 EQU   LCCAIHR2
LCCARV07 EQU   LCCAIHR2
LCCARV06 EQU   LCCAIHR2
LCCARV05 EQU   LCCAIHR2
LCCARV04 EQU   LCCAIHR2
LCCARV03 EQU   LCCAIHR1
LCCARV02 EQU   LCCAIHR1
LCCARV01 EQU   LCCAIHR1
LCCAPPIE EQU   LCCAIHR1
LCCAPSG1 EQU   LCCAIHR1
LCCAPDAT EQU   LCCAIHR1
LCCAXRC2 EQU   LCCAIHR1
LCCAXRC1 EQU   LCCAIHR1
LCCAIOPS EQU   LCCA+512
LCCAGPGR EQU   LCCA+448
LCCARSFP EQU   LCCA+416
LCCARSGR EQU   LCCA+352
LCCAXGR3 EQU   LCCA+288
LCCAXGR2 EQU   LCCA+224
LCCAXGR1 EQU   LCCA+160
LCCACR0  EQU   LCCA+156
LCCAMCR1 EQU   LCCA+152
LCCAPVAD EQU   LCCA+148
LCCAPINT EQU   LCCA+144
LCCAPPSW EQU   LCCA+136
LCCAPGR2 EQU   LCCA+72
LCCAPGR1 EQU   LCCA+8
LCCARV77 EQU   LCCA+6
LCCALCCA EQU   LCCA
@NM00024 EQU   PSA+3412
PSASTAK  EQU   PSA+3072
@NM00023 EQU   PSA+1032
PSAPCPSW EQU   PSA+1024
PSARV060 EQU   PSA+1020
PSARV059 EQU   PSA+1018
PSASVC13 EQU   PSA+1016
PSALSFCC EQU   PSA+1012
PSASFACC EQU   PSA+1008
PSASTOP  EQU   PSA+992
PSASTART EQU   PSA+976
PSARSPSW EQU   PSA+968
PSASRPSW EQU   PSA+960
PSARV045 EQU   PSA+892
PSARV044 EQU   PSA+888
PSARV043 EQU   PSA+884
PSARV042 EQU   PSA+880
PSARV041 EQU   PSA+876
PSARV040 EQU   PSA+872
PSARV025 EQU   PSA+868
PSADSSED EQU   PSA+868
PSADSSPR EQU   PSA+864
PSADSSFW EQU   PSA+860
PSADSS14 EQU   PSA+856
PSADSSPP EQU   PSA+848
PSADSSRP EQU   PSA+840
PSADSS05 EQU   PSADSSF4
PSADSS10 EQU   PSADSSF4
PSADSSVE EQU   PSADSSF4
PSADSSDE EQU   PSADSSF4
PSADSSC0 EQU   PSADSSF4
PSADSSIE EQU   PSADSSF4
PSADSS12 EQU   PSADSSF4
PSADSSRC EQU   PSADSSF4
PSARV057 EQU   PSADSSF3
PSARV056 EQU   PSADSSF3
PSARV055 EQU   PSADSSF3
PSADSSMC EQU   PSADSSF3
PSADSSRW EQU   PSADSSF3
PSADSSNM EQU   PSADSSF3
PSADSSES EQU   PSADSSF3
PSADSSGP EQU   PSADSSF3
PSADSSF2 EQU   PSADSSFL+1
PSADSSPI EQU   PSADSSF1
PSADSSOI EQU   PSADSSF1
PSADSSSP EQU   PSADSSF1
PSADSSTP EQU   PSADSSF1
PSADSSDW EQU   PSADSSF1
PSADSSDD EQU   PSADSSF1
PSADSSDM EQU   PSADSSF1
PSADSSMV EQU   PSADSSF1
PSADSSTS EQU   PSA+816
PSADSSWK EQU   PSA+812
PSADSSR3 EQU   PSA+808
PSADSSR2 EQU   PSA+804
PSADSSRS EQU   PSA+800
PSASTOR  EQU   PSA+796
PSACPUSA EQU   PSA+794
PSAVSTAP EQU   PSA+792
PSAWKVAP EQU   PSA+788
PSAWKRAP EQU   PSA+784
PSAMCHIC EQU   PSA+783
PSARV061 EQU   PSA+782
PSASYMSK EQU   PSA+781
PSAMCHFL EQU   PSA+780
PSACR0   EQU   PSA+776
PSAPSWSV EQU   PSA+768
PSALITA  EQU   PSA+764
PSACLHS  EQU   PSAHLHI
PSALKR15 EQU   PSALKSA+60
PSALKR14 EQU   PSALKSA+56
PSALKR13 EQU   PSALKSA+52
PSALKR12 EQU   PSALKSA+48
PSALKR11 EQU   PSALKSA+44
PSALKR10 EQU   PSALKSA+40
PSALKR9  EQU   PSALKSA+36
PSALKR8  EQU   PSALKSA+32
PSALKR7  EQU   PSALKSA+28
PSALKR6  EQU   PSALKSA+24
PSALKR5  EQU   PSALKSA+20
PSALKR4  EQU   PSALKSA+16
PSALKR3  EQU   PSALKSA+12
PSALKR2  EQU   PSALKSA+8
PSALKR1  EQU   PSALKSA+4
PSALKR0  EQU   PSALKSA
PSARV023 EQU   PSACLHT+52
PSALOCAL EQU   PSACLHT+48
PSACMSL  EQU   PSACLHT+44
PSAOPTL  EQU   PSACLHT+40
PSATPACL EQU   PSACLHT+36
PSATPDNL EQU   PSACLHT+32
PSATPNCL EQU   PSACLHT+28
PSAIOSLL EQU   PSACLHT+24
PSAIOSUL EQU   PSACLHT+20
PSAIOSCL EQU   PSACLHT+16
PSAIOSSL EQU   PSACLHT+12
PSASALCL EQU   PSACLHT+8
PSAASML  EQU   PSACLHT+4
PSADISPL EQU   PSACLHT
PSASRSA  EQU   PSA+636
PSARV050 EQU   PSA+634
PSADSSGO EQU   PSA+633
PSARECUR EQU   PSA+632
PSAHLHIS EQU   PSA+628
PSAIPCSA EQU   PSA+624
@NM00022 EQU   PSA+621
PSAIPCDM EQU   PSA+620
PSAIPCD  EQU   PSA+616
@NM00021 EQU   PSA+613
PSAIPCRM EQU   PSA+612
PSAIPCR  EQU   PSA+608
PSAMCHEX EQU   PSA+600
PSAMPSW  EQU   PSA+592
PSAEXPS2 EQU   PSA+584
PSAEXPS1 EQU   PSA+576
PSAPIREG EQU   PSA+572
PSARSREG EQU   PSA+568
PSAGPREG EQU   PSA+556
PSARV022 EQU   PSASUP4
PSARV021 EQU   PSASUP4
PSARV020 EQU   PSASUP4
PSARV019 EQU   PSASUP4
PSARV018 EQU   PSASUP4
PSARV017 EQU   PSASUP4
PSARV016 EQU   PSASUP4
PSARV015 EQU   PSASUP4
PSARV014 EQU   PSASUP3
PSARV013 EQU   PSASUP3
PSARV012 EQU   PSASUP3
PSARV011 EQU   PSASUP3
PSARV010 EQU   PSASUP3
PSARV009 EQU   PSASUP3
PSARV008 EQU   PSASUP3
PSAIOSUP EQU   PSASUP3
PSALCR   EQU   PSASUP2
PSARTM   EQU   PSASUP2
PSAIPCE2 EQU   PSASUP2
PSAIPCES EQU   PSASUP2
PSAIPCEC EQU   PSASUP2
PSAGTF   EQU   PSASUP2
PSAIPCRI EQU   PSASUP2
PSAIPCRP EQU   PSASUP1
PSAIPCDR EQU   PSASUP1
PSADISP  EQU   PSASUP1
PSALOCK  EQU   PSASUP1
PSAPI    EQU   PSASUP1
PSAEXT   EQU   PSASUP1
PSASVC   EQU   PSASUP1
PSAIO    EQU   PSASUP1
PSAAOLD  EQU   PSA+548
PSAANEW  EQU   PSA+544
PSATOLD  EQU   PSA+540
PSATNEW  EQU   PSA+536
PSALCCAR EQU   PSA+532
PSAPCCAR EQU   PSA+524
PSACPULA EQU   PSA+518
FLCHDEND EQU   PSA+512
FLCCRSAV EQU   FLCMCLA+280
FLCGRSAV EQU   FLCMCLA+216
FLCFPSAV EQU   FLCMCLA+184
FLCFLA   EQU   FLCMCLA+88
FLCRGNCD EQU   FLCMCLA+84
FLCFSAA  EQU   FLCFSA+1
@NM00020 EQU   FLCFSA
@NM00019 EQU   FLCMCLA+72
FLCMCIC  EQU   FLCMCLA+64
@NM00018 EQU   FLCMCLA+20
FLCIOAA  EQU   FLCIOA+1
@NM00017 EQU   FLCIOA
@NM00016 EQU   FLCMCLA+15
@NM00015 EQU   FLCMCLA+14
@NM00014 EQU   FLCMCLA+12
FLCLCL   EQU   FLCMCLA+8
FLCIOELA EQU   FLCIOEL+1
@NM00013 EQU   FLCIOEL
FLCCHNID EQU   FLCMCLA
@NM00012 EQU   PSA+160
@NM00011 EQU   PSA+156
FLCPERA  EQU   FLCPER+1
@NM00010 EQU   FLCPER
@NM00009 EQU   PSA+151
FLCPERCD EQU   PSA+150
FLCMCNUM EQU   PSA+149
@NM00008 EQU   PSA+148
FLCTEAA  EQU   FLCTEA+1
@NM00007 EQU   FLCTEA
PSAPIPC  EQU   PSAPICOD
PSAPIMC  EQU   PSAPICOD
PSAPIPER EQU   PSAPICOD
PSARV049 EQU   FLCPICOD
FLCPILCB EQU   FLCPIILC
@NM00006 EQU   FLCPIILC
@NM00005 EQU   PSAEPPSW
FLCSVCN  EQU   PSAESPSW+2
FLCSILCB EQU   FLCSVILC
@NM00004 EQU   FLCSVILC
@NM00003 EQU   PSAESPSW
FLCEICOD EQU   PSAEEPSW+2
@NM00002 EQU   PSA+128
FLCINPSW EQU   PSA+120
FLCMNPSW EQU   PSA+112
FLCPNPSW EQU   PSA+104
FLCSNPSW EQU   PSA+96
FLCTRACE EQU   PSA+84
FLCTIMER EQU   PSA+80
FLCCVT2  EQU   PSA+76
FLCCAW   EQU   PSA+72
FLCCSW   EQU   PSA+64
FLCIOPSW EQU   PSA+56
FLCMOPSW EQU   PSA+48
FLCPOPSW EQU   PSA+40
FLCSOPSW EQU   PSA+32
@NM00001 EQU   FLCICCW2+4
FLCICCW1 EQU   FLCROPSW
FLCIPPSW EQU   FLCRNPSW
.@UNREFD ANOP                          END UNREFERENCED COMPONENTS
@RF00116 EQU   @RC00114
@ENDDATA EQU   *
         END   IEAVTCR1
