         TITLE 'CONTROL CARD SCANNER -- IEBCCS0209'
*        TITLE UTILITY CONTROL CARD SCANNER ROUTINE
*
* THIS ROUTINE IS EXECUTED EVERY TIME THE CONTROL CARD ANALYZER    ULOH
* OF THE FOLLOWING UTILITIES REQUEST INFORMATION FROM THE CONTROL  ULOH
* DATA SET- IEBPTPCH,IEBCOPY,IEBGENER,AND IEBCOMPR                 ULOH
*   IT OPENS SYSIN,READS THE CONTROL CARDS AND PASSES THESE CARDS  ULOH
* AND LOCATION,LENGTH,AND IDENTIFICATION OF CONTROL CARD FIELDS TO ULOH
* THE CONTROL CARD ANALYZING ROUTINE.                              ULOH
*                                                                  ULOH
*     ENTRY POINTS:                                                ULOH
*                                                                  ULOH
*        IEBCCS02(CSECT NAME)                                      ULOH
*        ACTCCS  (MAIN ENTRY FROM ANALYZING ROUTINE)               ULOH
*        GENLABEL(THIS IS NOT A CONTROL FLOW ENTRY,BUT A SWITCH IN ULOH
*                 CCS02 THAT IS SET BY IEBGSCAN,INDICATING THAT THEULOH
*                 NEXT CARD FROM SYSIN NOT NEEDS TO BE SCANNED     ULOH
*                                                                  ULOH
*     INPUT:                                                       ULOH
*                                                                  ULOH
*        THE DATA FROM THE CONTROL DATA SET (SYSIN)                ULOH
*                                                                  ULOH
*     OUTPUT:                                                      ULOH
*                                                                  ULOH
*        CONTROL STATEMENT AND,IF THE SWITCH GENLABEL IS NOT       ULOH
*        ACTIVE,COMMAND,KEYWORD AND PARAMETER INDICATION TO        ULOH
*        THE ANALYZING ROUTINE                                     ULOH
*                                                                  ULOH
*     ATTRIBUTES:                                                  ULOH
*                                                                  ULOH
*        NON-REUSABLE                                              ULOH
*                                                                  ULOH
***********************************************************************
*
         EJECT
*
IEBCCS02 CSECT
* 033420-033440,13200                                             M3310
*0514050800-051800,052000,052400-054600,055000-055200,056000-056200BS0H
*128600-129000,132000-132600                                       BS0H
*0704012800-013000,014200-014800,015400-017200,018800,023600       SA0I
*027800,028600,032800-033600,038600,044000,045200,058600,061000,   SA0I
*063600,066600,067400,068600-072000,072600-072800,076000,078600,   SA0I
*080200,081200,081800-082000,083400,086600-086800,092400,          SA0I
*096000-097000,103200,107400-107600,110600-110800,133000           SA0I
*                                                                A27717
*                                                                A29174
*                                                                A28288
*                                                                A30916
*                                                                A32633
*A061300-061360                                                  A41815
*A060920-061020,106410-106500                                    A55761
*D060920-061040                                                  A55761
*A027900-027960                                                 SA63312
*C030600,033460,033500                                          SA63312
*D033480                                                        SA63312
*A110820,145020                                                 SA61471
*
*        THE ROUTINE SAVES REGISTERS 3 THROUGH 14 UPON ENTRY
*        IT TESTS SWITCHES TO CONTROL ENTRY TO THE SCAN RTN,
*        INITIALIZES A POINTER TO START SCAN ADDRESS
*
***********************************************************************
*
         ENTRY ACTCCS
         ENTRY RDCARD
         ENTRY GENLABEL                                            ULOH
         USING RDCARD,REG12        SET UP BASE
ACTCCS   DS    0H
RDCARD   SAVE  (14,12),T,IEBCCS02-JULY-66      SAVE REGISTERS 14-12
         LR    REG12,GO            INITIALIZE BASE
         LM    REG0,REG1,0(REG1)   LOAD WORK ADDRESS AND DDNAME ADDRESS
         LR    REG7,REG0           LOAD WORK ADDRESS
         MVC   KSIDD(8),0(REG1)    SAVE USER DDNAME
         STM   REG13,REG14,SAVE13  SAVE REGISTERS
         LA    REG1,KREGSAVE       GET POINTER TO SAVE AREA
         ST    REG1,8(REG13)       STORE POINTER TO SAVE AREA
*                                      IN SAVE AREA
         L     REG1,24(REG13)           RESTORE REG 1
         LA    REG13,KREGSAVE      ADDRESS OF REGISTER SAVE AREA
         MVI   144(REG7),X'00'     RESET CARD AND ERROR SWITCHES
         L     REG3,DSP13(0,REG7)  RESTORE POINTER
         TM    0(REG7),CMP2        IS END OF FILE BIT ON           SA0I
         BO    EOFRET              YES, GO TO EOF RETURN           SA0I
         TM    0(REG7),CMP0        IS ERROR BIT ON?                SA0I
         BZ    RSTERR1             NO-BRANCH AROUND THIS TEST      SA0I
         TM    0(REG7),CMP1        IS BYPASS BIT ON?               SA0I
         BO    RSTERR              YES-BRANCH AROUND BIT SETTING   SA0I
         NI    0(REG7),X'7F'       TURN OFF ERR BIT-BYPASS OFF AND SA0I
         B     KOMMD1              ERR ON MEANS ERROR IN NAME FLD  SA0I
*                                  BRANCH TO COMMAND CHECK RTN     SA0I
RSTERR   NI    0(REG7),X'7F'       TURN OFF ERROR BIT              SA0I
RSTERR1  TM    0(REG7),CMP3        TEST FIRST ENTRY SWITCH         SA0I
         BZ    KIRSCD              BRANCH IF OFF
         CLI   GENLABEL+3,X'F0'        IF LABEL GENERATION         UL0H
         BE    KGTCD                   BRANCH TO READ CARD         UL0H
         TM    0(REG7),CMP1        TEST BYPASS SWITCH
         BO    KBYPO               BRANCH IF ON
KPFOL1   TM    DSP5(REG7),CMP4         TEST READ CARD SWITCH       ULOH
         BO    KGTCD               BRANCH IF ON
KPFOL    TM    DSP5(REG7),CMP1     TEST CONTINUATION SWITCH        SA0I
         BO    KCONT               ON, BRANCH TO CONTINUE ROUTINE  SA0I
         TM    DSP5(REG7),CMP2     TEST PARAMETER FOLLOW SWITCH    SA0I
         BO    SCANR               ON, GO TO SCAN                  SA0I
         LA    REG3,ONE(0,REG7)    ADDRESS OF BEGIN COLUMN
***********************************************************************
*        THIS ROUTINE CHECKS FOR A NAME. IF NAME IS PRESENT,       SA0I
*        THE FIRST CHARACTER IS CHECKED TO ASSURE THAT IT IS       SA0I
*        ALPHABETIC. SUBSEQUENT CHARACTERS MUST BE ALPHAMERIC      SA0I
*        OR NATIONAL.  IF THESE CONDITIONS ARE NOT MET, OR IF THE  SA0I
*        LENGTH IS GREATER THAN NINE, AN ERROR CODE IS RETURNED    SA0I
*        TO THE CALLING ROUTINE, BUT THE REMAINDER OF THE CARD     SA0I
*        WILL BE SCANNED UPON RETURN.  IF NO ERRORS ARE FOUND      SA0I
*        THE NAME FIELD IS BYPASSED AND A POINTER SET TO THE       SA0I
*        FIRST BLANK COLUMN.                                       SA0I
*                                                                  SA0I
KNAME    CLI   0(REG3),BLANKCOL    IS COL. 1 BLANK                 SA0I
         BE    KOMMD               YES, GO TO COMMAND SCAN         SA0I
         CLI   0(REG3),X'C1'       IF FIRST CHAR IN NAME FIELD     SA0I
         BL    SETERR              IS NOT ALPHA, SET ERROR BIT.    SA0I
         CLI   0(REG3),X'E9'       IF IT IS ALPHA, CONTINUE THE    SA0I
         BNH   INIT                NAME FIELD SCAN                 SA0I
SETERR   OI    0(REG7),CMP0        SET ERROR BIT                   SA0I
INIT     SR    REG2,REG2           ZERO REGISTER TWO               SA0I
INCRMT   LA    REG3,ONE(REG3)      INCREMENT THE POINTER           SA0I
         LA    REG2,ONE(REG2)      INCREMENT THE LENGTH            SA0I
         CLI   0(REG3),BLANKCOL    IS CURRENT COL. BLANK           SA0I
         BE    LGTHCHK             YES, GO TO LENGTH CHECK         SA0I
         LA    REG5,DSP3(REG7)     LOAD ADDR. OF END COL.          SA0I
         CR    REG3,REG5           IS THIS THE END COL.            SA0I
         BE    KNOP                YES, GO TO NO COMMAND ROUTINE   SA0I
         CLI   0(REG3),X'5B'       NO, BEGIN SCAN FOR              SA0I
         BE    INCRMT              NATIONAL OR ALPAHMERIC          SA0I
         CLI   0(REG3),X'7B'       CHARACTERS. IF ONE OF THESE     SA0I
         BE    INCRMT              IS FOUND ,LOOP BACK TO          SA0I
         CLI   0(REG3),X'7C'       CONTINUE SCAN                   SA0I
         BE    INCRMT                                              SA0I
         CLI   0(REG3),X'C1'                                       SA0I
         BL    STER                ELSE, SET ERROR BIT             SA0I
         CLI   0(REG3),X'F9'                                       SA0I
         BNH   INCRMT                                              SA0I
STER     OI    0(REG7),CMP0        SET ERROR BIT                   SA0I
         B     INCRMT              SCAN REMAINDER OF NAME FIELD    SA0I
LGTHCHK  C     REG2,EIGHT          IS LENGTH GREATER THAN EIGHT    SA0I
         BH    ERR                 YES, GO TO SET ERROR BIT        SA0I
         TM    0(REG7),CMP0        NO, TEST ERROR BIT              SA0I
         BO    KPASS               IF ON, GO TO RETURN ROUTINE     SA0I
         B     KOMMD               IF NOT ON GO TO COMMAND RTN     SA0I
ERR      OI    0(REG7),CMP0        TURN ON ERROR BIT               SA0I
         B     KPASS               GO TO RETURN ROUTINE            SA0I
         EJECT
***********************************************************************
*        INITIALIZE SWITCHES AND INDICATORS TO RECOGNIZE COMMAND
*             WORD IN FIRST CARD OF A GROUP
*        RESET PARENTHESES COUNTER
*
KOMMD    LA    REG3,ONE(0,REG3)    SET POINTER TO NEXT COLUMN
KOMMD1   SR    REG2,REG2           SET REGISTER TO ZERO            SA0I
         STH   REG2,DSP9(0,REG7)   SET PARENTHESES COUNTER TO ZERO
         OI    DSP5(REG7),CMP5     SET COMMAND CONTROL SWITCH
         OI    0(REG7),CMP4        SET COMMAND BIT IN SWITCH AREA
         NI    DSP10(REG7),RESET0  RESET DELIMITER INDICATOR
*
***********************************************************************
*        ADJUST POINTER TO FIRST CHARACTER OF COMMAND
*             IF NO COMMAND FOUND BEFORE COL 71,SET BYPASS BIT
*
         LA    REG5,DSP3(0,REG7)   ADDRESS OF END COLUMN
KABC     CLI   0(REG3),BLANKCOL    TEST FOR BLANK COLUMN
         BNE   SCAN                COLUMN NOT BLANK-SCAN
         CR    REG3,REG5           TEST FOR END COLUMN
         BE    KNOP                END COLUMN-BRANCH
         LA    REG3,ONE(0,REG3)    ADJUST POINTER TO NEXT COLUMN
         B     KABC                CHECK NEXT COLUMN
***********************************************************************
*        RESET SWITCH AREA CONTROLS                                SA0I
*        RESET EXIT CONTROLS                                       SA0I
*        SAVE LAST DELIMITER AND CLEAR CURRENT DELIMITER INDICATOR SA0I
*
SCANR    NI    0(REG7),RESET1      RESET COMMAND BIT
SCAN     NI    0(REG7),RESET2      RESET ALL BITS BUT ERROR,FIRST
*                                      ENTRY AND COMMAND
         NI    DSP5(REG7),X'17'    RESET CONTINUATION,PARAMETER    SA0I
*                                      FOLLOW AND RD CD SWITCHES   SA0I
SCANPP   MVC   DSP11(ONE,REG7),DSP10(REG7)   SAVE LAST DELIMITER
KCPSS    NI    DSP10(REG7),RESET0            RESET DELIMITER INDICATOR
         NI    DSP8(REG7),RESET10            RESET EXIT CONTROL SWITCH
         EJECT
***********************************************************************
*        THIS ROUTINE SCANS THE COMMAND KEYWORD AND PARAMETER      SA0I
*        FIELDS OF THE CARD.  IF NO QUOTES ARE FOUND IN THE SCAN   SA0I
*        THE ROUTINE KOMPARA HANDLES THE SCAN FOR CORRECT          SA0I
*        CHARACTERS AND LENGTH.  LITERALS ARE HANDLED BY MEANS     SA0I
*        OF INSTRUCTION MODIFICATION PRIOR TO KOMPARA.             SA0I
*
KTRT     SR    REG1,REG1           ZERO REGISTER
         SR    REG2,REG2           ZERO REGISTER
         LA    REG5,DSP3(0,REG7)   ADDRESS OF END COLUMN
         LR    REG1,REG3           POINTER TO CURRENT COLUMN
KA       NOP   KE                  CHECK FOR DELIMITER,
         CLI   0(REG3),X'7D'            QUOTE
KB       BNE   KF                  NOT QUOTE
         TM    DSP5(REG7),CMP7     IS PARAMETER REQUIRED BIT ON    SA0I
         BO    QUOTE               YES, GO TO QUOTE SET            SA0I
         CLI   129(REG7),X'01'     IS PARENTHESES COUNTER =1       SA0I
         BE    QUOTE               YES, GO TO QUOTE SET            SA0I
         OI    0(REG7),CMP1        TURN ON BYPASS BIT              SA0I
         B     KPASS               GO TO RETURN ROUTINE            SA0I
QUOTE    OI    DSP10(REG7),CMP5    SET QUOTE DELIMITER ON          SA0I
*                                      FOR LITERAL                 SA0I
         CLI   0(REG3),X'7D'       IS CURRENT COLUMN A QUOTE       SA0I
KC       NOP   KD                  FIRST QUOTE FOUND BRANCH
         NI    KA+1,X'0F'          SET QUOTE FOUND BRANCH OFF
         NI    KB+1,X'0F'          SET TRUE DELIMITER BRANCH OFF
         OI    KC+1,X'80'          SET QUOTE FOUND BRANCH TO BE
         B     KOMPLIT             BRANCH TO LENGTH ADD            SA0I
KC1      NI    KA+1,X'0F'         SET QUOTE FOUND BRANCH OFF    SA63312
         NI    KB+1,X'0F'         SET TRUE DELIMITER BRANCH OFF SA63312
         OI    KC+1,X'80'         SET QUOTE FOUND BRANCH TO BE  SA63312
         B     KOMPLITT           BRANCH TO INCREMENT POINTER   SA63312
KD       OI    KA+1,X'F0'          SET QUOTE FOUND BRANCH UNC
         OI    KB+1,X'70'          SET BRANCH NE
         NI    KC+1,X'0F'          SET QUOTE FOUND BRANCH OFF
         B     KOMPLIT             BRANCH TO LENGTH ADD            SA0I
KE       CLI   0(REG3),X'5B'       TEST FOR DOLLAR SIGN
         BE    KC                 BRANCH FOR VALID CHAR.
         CLI   0(REG3),X'7B'       TEST FOR POUND SIGN
         BE    KC                 BRANCH FOR VALID CHAR.
         CLI   0(REG3),X'7C'       TEST FOR AT SIGN
         BE    KC                 BRANCH FOR VALID CHAR.
         CLI   0(REG3),X'7F'      TEST FOR DELIMITER
         BH    KC                  NOT DELIMITER -CHAR TOO HIGH
         CLI   0(REG3),X'7D'       TEST FOR QUOTE
         BE    KC1                YES,BRANCH TO SET BRANCH COND SA63312
         NI    KA+1,X'0F'          SET QUOTE FOUND BR OFF
         B     KFIND               BRANCH TO OTHER DELIMITER CHECK
KF       CLI   0(REG3),X'5B'       TEST FOR DOLLAR SIGN
         BE    KOMPARA            BRANCH FOR VALID CHAR.
         CLI   0(REG3),X'7B'       TEST FOR POUND SIGN
         BE    KOMPARA            BRANCH FOR VALID CHAR.
         CLI   0(REG3),X'7C'       TEST FOR AT SIGN
         BE    KOMPARA            BRANCH FOR VALID CHAR.
         CLI   0(REG3),X'7F'      TEST FOR DELIMITER
         BNH   KFIND               YES,BRANCH
KOMPARA  LTR   REG2,REG2           IS THIS FIRST CHAR SCANNED?     SA0I
         BP    LNGTHADD            NO-GO TO INCREMENT LENGTH RTN   SA0I
         CLI   129(REG7),X'01'     IS PARENTHESES COUNTER =1       SA0I
         BNE   TESTPARM            NO-GO TO TEST PARAMETER BIT RTN SA0I
ALPHANUM CLI   0(REG3),X'5B'       TEST FOR DOLLAR SIGN          A29174
         BE    LNGTHADD            ADD 1 TO LENGTH               A29174
         CLI   0(REG3),X'7B'       TEST FOR POUND SIGN           A29174
         BE    LNGTHADD            ADD 1 TO LENGTH               A29174
         CLI   0(REG3),X'7C'       TEST FOR AT SIGN              A29174
         BE    LNGTHADD            ADD 1 TO LENGTH               A29174
         CLI   0(REG3),X'C1'       IS THIS CHARACTER ALPHAMERIC  A29174
         BNL   LNGTHADD            YES-GO TO INCREMENT LENGTH RTN  SA0I
ERROR    OI    0(REG7),X'C0'       NO -SET ERROR AND BYPASS BITS   SA0I
LNGTHADD LA    REG2,ONE(0,REG2)    INCREMENT LENGTH BY ONE         SA0I
         C     REG2,EIGHT          IS LENGTH GREATER THAN EIGHT?   SA0I
         BNH   ENDCHK              NO-CHECK FOR END COLUMN         SA0I
         TM    0(REG7),CMP4        IS COMMAND BIT ON?              SA0I
         BZ    SETBYP              NO-GO TO SET BYPASS RTN         SA0I
         OI    0(REG7),X'C0'       SET ERROR AND BYPASS BITS       SA0I
         B     KPASS               GO TO RETURN RTN                SA0I
SETBYP   OI    0(REG7),CMP1        SET BYPASS BIT                  SA0I
         TM    DSP5(REG7),CMP6     IS KEYWORD REQUIRED BIT ON      SA0I
         BZ    PARMTEST            NO, TEST PARAMETER REQUIRED BIT SA0I
         OI    0(REG7),CMP5        YES, TURN ON KEYWORD BIT        SA0I
         B     KPASS               GO TO RETURN ROUTINE            SA0I
PARMTEST TM    DSP5(REG7),CMP7     IS PARAMETER REQUIRED BIT ON    SA0I
         BZ    PRNTEST             NO, TEST PARENTHESES COUNTER    SA0I
         OI    0(REG7),CMP6        YES, TURN ON PARAMETER BIT      SA0I
         B     KPASS               GO TO RETURN ROUTINE            SA0I
PRNTEST  CLI   129(REG7),X'01'     IS PARENTHESES COUNTER =1       SA0I
         BNE   KPASS               NO, GO TO RETURN ROUTINE        SA0I
         OI    0(REG7),X'82'       YES,TURN ON ERROR AND           SA0I
*                                      PARAMETER BITS              SA0I
         B     KPASS               GO TO RETURN RTN                SA0I
ENDCHK   CR    REG3,REG5           IS THIS END COLUMN?             SA0I
         BE    KPART               YES-SAVE PARTIAL PARAMETER      SA0I
         LA    REG3,ONE(0,REG3)    ADJUST POINTER TO NEXT COLUMN   SA0I
         B     KA                  CONTINUE CHECKING               SA0I
TESTPARM TM    DSP5(REG7),CMP7     IS PARAMETER REQUIRED BIT ON    SA0I
         BO    ALPHANUM            YES-GO TO ALPHAMERIC CHECK      SA0I
         CLI   0(REG3),X'5B'       TEST FOR DOLLAR SIGN          A29174
         BE    LNGTHADD            ADD 1 TO LENGTH               A29174
         CLI   0(REG3),X'7B'       TEST FOR POUND SIGN           A29174
         BE    LNGTHADD            ADD 1 TO LENGTH               A29174
         CLI   0(REG3),X'7C'       TEST FOR AT SIGN              A29174
         BE    LNGTHADD            ADD 1 TO LENGTH               A29174
         CLI   0(REG3),X'C1'       IS THIS CHAR ALPHABETIC?        SA0I
         BL    ERROR               NO-GO TO SET ERROR BIT RTN      SA0I
         CLI   0(REG3),X'E9'                                       SA0I
         BH    ERROR                                               SA0I
         B     LNGTHADD            YES-GO TO INCREMENT LENGTH RTN  SA0I
KOMPLIT  LA    REG2,ONE(0,REG2)    INCREMENT LENGTH BY ONE         SA0I
         C     REG2,FOUR3          IS LITERAL GT 43               M3310
         BNL   ZRPARN              YES,SET PARANT COUNT TO ZERO SA63312
KOMPLITT CR    REG3,REG5           IS THIS END COLUMN?          SA63312
         BE    KPART               YES-GO TO PARTIAL PARAMETER RTN
         LA    REG3,ONE(0,REG3)    NO-INCREMENT POINTER BY ONE     SA0I
         B     KA                  CONTINUE CHECKING               SA0I
*
***********************************************************************
*        KFIND CHECKS FOR DELIMITER OF PERIOD OR MINUS. IF EITHER IS
*        PRESENT,RETURNS TO SCAN ROUTINE. TESTS FOR END COLUMN. IF
*        DELIMITER IS IN END COLUMN,CC2 BIT IS SET; IF BEFORE END
*        COLUMN,CC1 BIT IS SET. THEN GOES TO TEST DELIMITER ROUTINE.
*
*
KFIND    CLI   0(REG3),PERIOD      TEST FOR PERIOD
         BE    KOMPARA             YES-BRANCH TO LENGTH INCREMENT
         CLI   0(REG3),MINUS       TEST FOR MINUS SIGN
         BE    KOMPARA             YES-BRANCH TO LENGTH INCREMENT
         CR    REG3,REG5           TEST FOR END COLUMN
         BNE   SETCC1              NOT END-SET CC1 BIT
         OI    DSP8(REG7),CMP2     END-SET CC2 BIT
         TM    DSP5(REG7),CMP3     TEST IF PARTIAL PARAMETER
*                                      SWITCH ON
         BO    KTERBY              TOO LONG IF ON-BYPASS
         B     TESTPAR             BRANCH TO PARAM TEST
*
***********************************************************************
*        THIS ROUTINE SETS BITS IN THE SWITCH AREA WHEN NO         SA0I
*        COMMAND IS FOUND OR WHEN NO KEYWORD OR PARAMETER          SA0I
*        FOLLOWS A COMMAND                                         SA0I
*
KNOP     OI    0(REG7),X'8C'       NO COMMAND ON CARD              SA0I
         SR    REG1,REG1           ZERO REGISTER
         SR    REG2,REG2           ZERO REGISTER
KNOPAR   OI    0(REG7),CMP1        NO KEYWORD OR PARAMETERS
*                                      FOLLOW, TURN ON BYPASS BIT
         LR    REG1,REG3           PUT COLUMN POINTER IN REG1      SA0I
         B     KPASS               BRANCH TO RETURN ROUTINE
*
         EJECT
***********************************************************************
*        TESTPAR CHECKS FOR --
*              PRESENCE OF PARTIAL PARAMETER
*              LENGTH EQUAL TO OR GREATER THAN ZERO,AND
*        SETS CORRECT LENGTH BIT
*
TESTPAR  TM    DSP5(REG7),CMP3     TEST IF PARTIAL PARAMETER SWITCH ON
         BO    KPPAR               BRANCH TO PARTIAL PARAMETER ROUTINE
         SR    REG4,REG4           ZERO REGISTER FOR ADD-TEST
         AR    REG4,REG2           GET PARAMETER LENGTH
         BZ    SETLZ               BRANCH TO SET LENGTH ZERO
         OI    DSP8(REG7),CMP6     SET LENGTH GREATER THAN ZERO BIT
*
***********************************************************************
*        DELIM CHECKS FOR VALID DELIMITER AND BRANCHES TO ROUTINE TO
*              SET CONTROL SWITCHES
*        IF INVALID DELIMITER IS FOUND,BRANCHES TO KINVAL
*        IT ALSO DETERMINES WHETHER OR NOT A PARTICULAR DELIMITER  SA0I
*        INDICATES THAT A COMMENT HAS BEEN FOUND. IF SO, THE       SA0I
*        BYPASS BIT IS TURNED ON.                                  SA0I
*
DELIM    CLI   0(REG3),EQUAL       TEST FOR EQUAL SIGN
         BE    KEY                 YES-BRANCH TO SWITCH SET-KEY.
         TM    DSP5(REG7),CMP7     IS PARAMETER REQUIRED BIT ON    SA0I
         BO    COMTEST             YES-GO TO COMMA TEST            SA0I
         CLI   129(REG7),X'01'     IS PARENTHESES COUNTER =1       SA0I
         BE    COMTEST             YES-GO TO COMMA TEST            SA0I
         TM    0(REG7),CMP4        IS COMMAND BIT ON               SA0I
         BO    TESTB               YES, GO TO TEST FOR BLANK       SA0I
         CLI   0(REG3),BLANKCOL    IS CURRENT COLUMN BLANK         SA0I
         BE    PARBLANK            YES, GO TO PARBLANK             SA0I
         CLI   0(REG3),COMMA       TEST FOR COMMA                  SA0I
         BNE   BYPSET              NOT COMMA, SET BYPASS BIT       SA0I
         TM    DSP11(REG7),CMP4    WAS LAST DELIMITER A BLANK      SA0I
         BZ    PARAMC              NO, BRANCH TO COMMA ROUTINE     SA0I
BYPSET   CLI   0(REG3),LPARN       CHECK FOR A LEFT PAREN        A28288
         BNE   BYPASS              NO-SET BYPASS BIT             A28288
         OI    0(REG7),X'02'       SET PARAMETER BIT
         B     SET                 BR TO SET ERR AND BYPASS BITS A28288
BYPASS   OI    0(REG7),CMP1        SET BYPASS BIT                A28288
         B     KPASS               GO TO RETURN RTN                SA0I
COMTEST  CLI   0(REG3),COMMA       TEST FOR COMMA                  SA0I
         BE    PARAMC              YES-BRANCH TO SET PARAMETER
*                                      AND COMMA BITS
         CLI   0(REG3),LPARN       TEST FOR LEFT PARENTHESIS
         BE    PARAMLP             YES-BRANCH TO SET PARAMETER
*                                      AND LEFT PARENTHESIS BITS
         CLI   0(REG3),RPARN       TEST FOR RIGHT PARENTHESIS
         BE    PARAMRP             YES-BRANCH TO SET PARAMETER
*                                      AND RIGHT PARENTHESIS BITS
TESTB    CLI   0(REG3),BLANKCOL    IS DELIMITER A BLANK            SA0I
         BE    PARBLANK            YES-BRANCH TO SET PARAMETER
*                                      AND BLANK BITS
         B     KINVALD             INVALID DELIMITER
         EJECT
*
***********************************************************************
*
*        KIRSCD,THE FIRST-ENTRY ROUTINE,CLEARS CONTROL SWITCHES TO
*        ZERO FOR FIRST READ AND GOES TO THE READ CARD ROUTINE.
*
KIRSCD   OI    0(REG7),CMP3        SET FIRST ENTRY BIT
         SR    REG3,REG3           *CLEAR READ ROUTINE*
         ST    REG3,DSP9(0,REG7)   *SWITCH AREAS ON   *
         STC   REG3,DSP5(0,REG7)   *FIRST ENTRY INTO  *
         STC   REG3,DSP8(0,REG7)   *ROUTINE           *
KGTCD4   NOP   KGTCD5              SKIP SWITCH
         MVC   KDCBSAVE(80),KSYSIN SAVE SYSIN DCB
         OI    KGTCD4+1,X'F0'      SET SKIP SWITCH TO UNC BRANCH
KGTCD5   MVC   KSYSIN(80),KDCBSAVE RESTORE SYSIN DCB
         SR    REG1,REG1           ZERO REGISTER FOR COMPARE
         C     REG1,KSIDD          TEST IF USER DDNAME GIVEN
         BE    KGTCD6              NO USER DDNAME
         LA    REG1,KSYSIN         LOAD SYSIN DCB ADDRESS
         MVC   DDNAME(8,REG1),KSIDD INSERT USER DDNAME IN SYSIN DCB
KGTCD6   OPEN  (KSYSIN,INPUT)      OPEN SYSIN
         LA    REG1,KSYSIN         LOAD SYSIN DCB ADDRESS
         TM    OFLGS(REG1),X'10'   TEST IF SYSIN DCB HAS BEEN OPENED
         BZ    DDERROR             NOT OPENED-BRANCH TO ERR PRINT SETUP
         TM    DFLAG,X'10'              TEST FOR INVALID BLKSIZE   BS0H
         BC    8,KGTCD                  GET CONTROL CARD           BS0H
         CLOSE (KSYSIN)           IF BLKSIZE INVALID CLOSE DCB     BS0H
         FREEPOOL  KSYSIN                                          BS0H
         L     REG13,SAVE13        AND RETURN WITH ADDRESS OF      BS0H
         L     REG14,VBLKRTN              ERROR ROUTINE            BS0H
         RETURN (2,12)                                             BS0H
KGTCD    GET   KSYSIN,1(7)              GET A RECORD IN WORK AREA  BS0H
         EJECT
         MVI   144(REG7),X'01'     SET NEW CARD SWITCH
         CLC   1(2,REG7),KEND      TEST FOR LAST CARD
         BE    KEOF                BRANCH TO END OF FILE ROUTINE
         CLI   GENLABEL+3,X'F0'        TEST GENLABEL SWITCH        UL0H
         BE    RETLABEL                 ON- RETURN TO IEBGSCAN     UL0H
         B     KGTCDR              BRANCH TO CONTINUATION TEST
*
***********************************************************************
*        KGTCDR TESTS COLUMN 72 FOR BLANK AND SETS BIT FOR BLANK OR
*        NON-BLANK. IT TESTS THE BYPASS BIT. IF THIS IS ON,GOES TO
*        KCONT TO DETERMINE IF THE CARD BEGINS IN THE PROPER       SA0I
*        COLUMN FOR A CONTINUATION CARD (THIS SITUATION WILL       SA0I
*        ARISE IF A COMMENT IS CONTINUED OR IF AN ERROR HAS        SA0I
*        BEEN FOUND ON A CARD THAT WAS TO BE CONTINUED.)           SA0I
*        IF THE BYPASS BIT IS NOT ON, THE ROUTINE BRANCHES TO      SA0I
*        KPFOL (THIS SITUATION ARISES IF A CARD IS CONTINUED       SA0I
*        WITHOUT THE USE OF A CONTINUATION CHARACTER OR IF         SA0I
*        THE PREVIOUS CARD WAS NOT CONTINUED.)                     SA0I
*
KGTCDR   NI    DSP8(REG7),RESET0   SET BLANK SWITCH
         CLI   DSP4(REG7),BLANKCOL TEST FOR COL 72 BLANK
         BE    SET72B              BRANCH TO SETBLANK
         OI    DSP8(REG7),CMP5     SET SWITCH FOR COL 72 NON-BLANK
RETURN   TM    0(REG7),CMP1        TEST BYPASS SWITCH
         BO    KCONT               GO TO CONTINUATION CARD RTN     SA0I
         B     KPFOL               NO - BYPASS
         EJECT
*
***********************************************************************
*        PARBLANK IS ENTERED IF DELIMITER WAS A BLANK. IT CHECKS FOR
*        COMMAND WORD. IF THE BLANK IS A DELIMITER FOR A COMMAND   SA0I
*        CONTROL GOES TO KPCMD.  IF THE LENGTH IS ZERO, THE BLANK  SA0I
*        DELIMITER BIT IS SET AND CONTROL GOES TO KFORZRO.         SA0I
*        IF THE LENGTH IS NOT ZERO AND A KEYWORD IS NOT EXPECTED   SA0I
*        THE PARAMETER AND BLANK DELIMITER BITS ARE SET.  IF A     SA0I
*        KEYWORD WAS EXPECTED, THE BYPASS BIT IS TURNED ON AND     SA0I
*        CONTROL GOES TO KPASS WHERE THE ERROR BIT WILL ALSO BE    SA0I
*        TURNED ON.                                                SA0I
*
PARBLANK TM    DSP5(REG7),CMP5     TEST COMMAND SWITCH
         BO    KPCMD               BRANCH IF COMMAND
         TM    DSP8(REG7),CMP7     IS LENGTH EQUAL TO ZERO         SA0I
         BO    SETB                GO TO SET BLANK                 SA0I
         TM    DSP5(REG7),CMP7    IS PARAM. REQ. BIT ON ?        A55761
         BO    SETP               YES, SET PARAMETER BIT ON      A55761
         B     SETBPASS           NO, SET BYPASS BIT ON          A55761
SETB     OI    DSP10(REG7),CMP4    SET BLANK DELIMITER             SA0I
         B     KFORZRO             GO TO ZERO, COUNT ROUTINE       SA0I
SETP     OI    0(REG7),CMP6        SET PARAMETER BIT               SA0I
         OI    DSP10(REG7),CMP4    SET BLANK DELIM BIT
         TM    DSP5(REG7),CMP3     IS PARTIAL PARAM. SWITCH ON   A41815
         BC    1,DECID             YES, DONT SET END-OF-PAR SW.  A41815
         OI    0(REG7),PRPARN      NO, SET END-OF-PAR. SW ON     A41815
*
***********************************************************************
*        DECID CHECKS THE EXIT CONTROL SWITCH AND DELIMITER INDICATOR
*        AND OTHER PERTINENT BITS  TO DECIDE WHETHER OR NOT THERE  SA0I
*        IS A VALID FIELD TO BE PASSED TO THE ANALYSIS ROUTINE.    SA0I
*        IF NOT, THE REMAINDER OF THE CARD IS TO BE BYPASSED.      SA0I
*        THE ERROR BIT WILL BE TURNED ON IF A BLANK DELIMITER      SA0I
*        IS FOUND IN AN INVALID SITUATION.                         SA0I
*
DECID    TM    DSP8(REG7),CMP2     IS DELIM IN END COLUMN
         BO    KWENT               BRANCH IF YES TO KWENT
         TM    DSP8(REG7),CMP7     IS LENGTH EQUAL TO ZERO
         BO    KFORZRO             YES,BRANCH
         OI    DSP5(REG7),CMP2     SET PARAM FOLLOW SWITCH
         TM    DSP10(REG7),CMP4    IS DELIM A BLANK
         BZ    KPASS               NO, GO TO RETURN ROUTINE        SA0I
         TM    DSP5(REG7),CMP7     IS PARAMETER REQUIRED BIT ON    SA0I
         BO    KETBYP              YES, GO TO BYPASS               SA0I
         CLI   129(REG7),X'01'     IS PARENTHESES COUNTER =1       SA0I
         BE    KETBYP              YES, GO TO BYPASS               SA0I
         TM    DSP11(REG7),CMP1    WAS LAST DELIMITER A COMMA      SA0I
         BZ    SETBPASS            NO - GO TO SET BYPASS BIT       SA0I
         OI    0(REG7),CMP0        YES - TURN ON ERROR BIT         SA0I
SETBPASS OI    0(REG7),CMP1        TURN ON BYPASS BIT              SA0I
         B     KPASS               DELIMITER NOT BLANK
*
*
KETBYP   OI    0(REG7),CMP1        SET BYPASS SWITCH ON
         BAL   REG9,PARAN          GO TO TEST PARAN CTR
         TM    DSP5(REG7),CMP3     IS PARTIAL PARAMETER SWITCH ON  4364
         BC    1,BKPASS            YES, DO NOT SET END-OF-         4364
*                                      PARAMETER SWITCH            4364
         OI    0(REG7),PRPARN      NO, SET END-OF-PARAMETER        4364
*                                      SWITCH ON                   4364
BKPASS   B     KPASS
*
*
***********************************************************************
*        KFORZRO HANDLES THE CASE WHERE A DELIMITER WITH NO        SA0I
*        PRECEEDING FIELD IS FOUND.(IN THIS CASE, THE LENGTH       SA0I
*        COUNTER WILL BE ZERO.)  IF THE DELIMITER WAS A BLANK,     SA0I
*        KETRDCD IS CALLED. OTHERWISE THE PROPER RETURN BITS       SA0I
*        WILL BE SET, DEPENDING ON THE DELIMITER.                  SA0I
*                                                                  SA0I
KFORZRO  SR    REG1,REG1           ZERO REGISTER
         SR    REG2,REG2           ZERO REGISTER
         TM    DSP10(REG7),CMP4    TEST DELIM FOR BLANK
         BO    KETRDCD             BRANCH ON BLANK
         OI    DSP5(REG7),CMP2     SET PARAMETER FOLLOW SWITCH
         TM    DSP10(REG7),CMP0    TEST DELIMITER FOR EQUAL SIGN
         BO    KEYSET              BRANCH IF EQUAL SIGN            SA0I
         TM    DSP10(REG7),CMP2    TEST DELIMITER FOR
*                                      LEFT PARENTHESIS
         BO    KPAFOL              BRANCH IF LEFT PARENTHESIS
         TM    DSP10(REG7),CMP3    TEST DELIMITER FOR
*                                      RIGHT PARENTHESIS
         BO    LDPNTR              BRANCH IF RIGHT PARENTHESIS     SA0I
         TM    DSP11(REG7),CMP3    WAS LAST DELIMITER A
*                                      RIGHT PARENTHESIS
         BO    KPAFOL              YES-BRANCH
LDPNTR   LR    REG1,REG3           SAVE POINTER TO CURRENT COLUMN  SA0I
         B     KPASS               BRANCH TO KPASS
*
*
***********************************************************************
*        KETRDCD GETS CONTROL FROM KFORZRO WHEN A BLANK DELIMITING SA0I
*        A FIELD OF LENGTH ZERO IS FOUND. IF THE LAST DELIMITER    SA0I
*        WAS A COMMA, THE NEXT CARD IS ASSUMED TO BE A CONTINUATIONSA0I
*        CARD. OTHERWISE, PROPER RETURN BITS ARE SET, DEPENDING    SA0I
*        ON THE LAST DELIMITER.                                    SA0I
*                                                                  SA0I
KETRDCD  TM    DSP11(REG7),CMP1    WAS LAST DELIMITER A COMMA      SA0I
         BO    SETRD               YES,SET RD CD AND CONTINUATION  SA0I
*                                      SWITCHES                    SA0I
         TM    DSP11(REG7),CMP0    WAS LAST DELIMITER AN EQUAL SIGNSA0I
         BO    SET                 YES,SET ERROR AND BYPASS BITS   SA0I
         TM    DSP11(REG7),CMP2    WAS LAST DELIMITER A            SA0I
*                                      LEFT PARENTHESIS            SA0I
         BO    SET                 YES,SET ERROR AND BYPASS BITS   SA0I
         OI    0(REG7),CMP1        IF NONE OF THESE,TURN ON BYPASS SA0I
         LR    REG1,REG3           LOAD POINTER TO CURRENT COL     SA0I
         B     KPASS               GO TO RETURN ROUTINE            SA0I
SETRD    OI    DSP5(REG7),X'48'    SET RD CD AND                   SA0I
*                                      CONTINUATION SWITCHES       SA0I
         CLI   129(REG7),X'01'     IS PARENTHESES COUNTER=1
         BE    SETPRM              GO TO SET PARAMETER BIT         SA0I
         OI    DSP5(REG7),CMP6     TURN ON KEYWORD REQUIRED BIT    SA0I
         B     KGTCD               READ A NEW CARD                 SA0I
SETPRM   OI    DSP5(REG7),CMP7     TURN ON PARAMETER REQUIRED BIT  SA0I
         B     KGTCD               READ A NEW CARD                 SA0I
SET      OI    0(REG7),X'C0'       SET ERROR AND BYPASS BITS       SA0I
         LR    REG1,REG3           MOVE COLUMN POINTER TO REG 3    SA0I
         B     KPASS               GO TO RETURN ROUTINE            SA0I
*
*
KEYSET   NI    0(REG7),X'FB'       TURN OFF KEYWORD BIT            SA0I
         OI    DSP5(REG7),CMP6     TURN ON KEYWORD REQUIRED BIT    SA0I
KTERBY   OI    0(REG7),X'C0'       SET ERROR AND BYPASS BITS       SA0I
         LR    REG1,REG3           SAVE POINTER TO CURRENT COLUMN  SA0I
         B     KPASS               BRANCH TO BYPASS
*
*
***********************************************************************
*        KWENT GETS CONTROL IF A DELIMITER WAS FOUND IN THE        SA0I
*        END COLUMN                                                SA0I
*                                                                  SA0I
KWENT    OI    DSP5(REG7),CONT     SET RD CARD AND CONTINUE
         TM    DSP8(REG7),CMP4     TEST FOR COL 72 BLANK
         BO    KETCTBL             YES-BRANCH TO BYPASS SET
         TM    DSP8(REG7),CMP7     DOES LENGTH EQUAL ZERO
         BO    KZERO               YES-BRANCH TO DELIM TEST
         TM    DSP10(REG7),CMP4    TEST FOR DELIM BLANK
         BO    KETBYP              BLANK-BRANCH TO BYPASS
         B     KPASS               BRANCH TO RETURN ROUTINE
*
*
***********************************************************************
*        KZERO GETS CONTROL FROM KWENT IF COLUMN 72 IS NON -BLANK  SA0I
*        AND IF THE DELIMITER OF A ZERO LENGTH FIELD IS IN COL 71. SA0I
*                                                                  SA0I
KZERO    SR    REG1,REG1           ZERO REGISTER
         TM    DSP10(REG7),CMP0    TEST FOR EQUAL SIGN DELIMITER
         BO    KTERBY              YES, BRANCH TO ERROR SET        SA0I
         TM    DSP10(REG7),RESETB  IS DELIMITER A COMMA OR
*                                      A RIGHT PARENTHESIS
         BZ    KGTCD               NEITHER-BRANCH TO CARD READ
         CLC   DSP10(1,REG7),DSP11(REG7)  TEST IF DELIM SAME AS LAST
         BE    KPASS                      YES-BRANCH TO BYPASS
         B     KGTCD               NO-BRANCH TO CARD READ
*
*
***********************************************************************
*        KETCTBL IS CALLED BY KWENT IF A DELIMITER IS IN THE END   SA0I
*        COLUMN AND IF COLUMN 72 IS BLANK.IF THE DELIMITER WAS A   SA0I
*        COMMA, KETCTBL DECIDES THAT THERE SHOULD HAVE BEEN A      SA0I
*        CONTINUATION CHARACTER IN COLUMN 72.                      SA0I
*                                                                  SA0I
KETCTBL  OI    0(REG7),CMP1        SET BYPASS SWITCH
         BAL   REG9,PARAN          CHECK PARENTHESES COUNTER
         TM    DSP8(REG7),CMP7     IS LENGTH EQUAL TO ZERO
         BO    KETLPRN             ON-BRANCH TO RIGHT PARENTHESIS
*                                      TEST
         TM    DSP8(REG7),CMP1     IS CC1 BIT ON                   SA0I
         BO    KTERBY              YES, BRANCH TO ERROR SET        SA0I
         B     KPASS               BRANCH TO RETURN ROUTINE
*
*
KETLPRN  TM    DSP10(REG7),CMP3    IS DELIMITER A RIGHT PAREN
         BO    KPASS               YES-BRANCH TO RETURN ROUTINE
         TM    DSP10(REG7),CMP4    IS DELIMITER A BLANK
         BO    KETBLK              YES-BRANCH TO BLANK ROUTINE
         B     KTERBY              OTHERWISE GO TO ERROR SET       SA0I
*
*
KETBLK   TM    DSP11(REG7),MSKG    WAS LAST DELIMITER A COMMA OR
*                                      A LEFT PARENTHESIS
         BZ    KPASS               NO-BRANCH TO BYPASS
         B     KTERBY              BRANCH TO ERROR SET             SA0I
*
*
*
*
SET72B   OI    DSP8(REG7),CMP4     SET COL 72 BLANK SWITCH
         B     RETURN              BRANCH TO PRELIMINARY TEST
*
*
***********************************************************************
*        KBYPO GETS CONTROL IF THE BYPASS BIT IS ON WHEN CCS02     SA0I
*        IS FIRST CALLED. IF THE ANALYSIS ROUTINE WAS EXPECTING    SA0I
*        A KEYWORD OR A PARAMETER, CONTROL IS GIVEN TO KPASS.      SA0I
*        OTHERWISE, KBYPO DETERMINES IF THERE ARE ANY CONTINUATION SA0I
*        CARDS WHICH SHOULD ALSO BE BYPASSED.                      SA0I
*
KBYPO    NI    0(REG7),X'FE'       TURN OFF "END OF PARAMETERS" BITSA0I
         TM    DSP5(REG7),X'03'    ARE KEYWORD REQUIRED OR         SA0I
*                                    PARAMETER REQUIRED BITS ON    SA0I
         BZ    TEST72              NO-CHECK COLUMN 72              SA0I
         NI    0(REG7),X'F7'       TURN OFF COMMAND BIT            SA0I
         LR    REG1,REG3           SAVE POINTER TO CURRENT COLUMN  SA0I
         B     KPASS               YES-GO TO RETURN ROUTINE        SA0I
TEST72   CLI   DSP4(REG7),BLANKCOL TEST FOR COLUMN 72 BLANK        SA0I
         BNE   KGTCD               NO-BRANCH TO READ NEXT CARD
         NI    0(REG7),CMP3        RESET SWITCH AREA
         NI    DSP5(REG7),RESET0   RESET ENTRY CONTROL SWITCH
         B     KGTCD               BRANCH TO READ NEXT CARD
*
*
SETCC1   OI    DSP8(REG7),CMP1     SET CONDITION CODE 1 SWITCH
         B     TESTPAR             BRANCH TO TEST PARAMETER
*
*
SETLZ    OI    DSP8(REG7),CMP7     SET LENGTH EQUAL TO ZERO BIT
         B     DELIM               BRANCH TO DELIMITER CHECK
*
*
***********************************************************************
*        KEY GETS CONTROL WHEN AN EQUAL SIGN DELIMITER IS FOUND    SA0I
*        IF A COMMAND HAS NOT PREVIOUSLY BEEN FOUND, THE ERROR     SA0I
*        BIT IS SET.                                               SA0I
*
KEY      CLI   SYNSW,X'01'         TEST IF SYNSW SET TO 1
         BE    SETSYN              YES, GO TO RESET SYNSW          SA0I
         OI    0(REG7),CMP5        NO, TURN ON KEYWORD BIT         SA0I
         B     KTERBY              GO TO ERROR SET                 SA0I
SETSYN   MVI   SYNSW,X'00'         SET SYNSW TO ZERO               SA0I
         OI    0(REG7),CMP5        SET KEYWORD BIT
         OI    DSP10(REG7),CMP0    SET DELIMITER BIT - EQUAL
         B     DECID               BRANCH TO EXIT CHECK
*
*
PARAMC   OI    0(REG7),CMP6        SET PARAMETER BIT
         OI    DSP10(REG7),CMP1    SET DELIMITER BIT-COMMA
         MVI   SYNSW,X'01'         SET SYNSW
         B     DECID               BRANCH TO EXIT CHECK
*
*
PARAMLP  OI    0(REG7),CMP6        SET PARAMETER BIT
         OI    DSP10(REG7),CMP2    SET DELIMITER BIT -
*                                      LEFT PARENTHESIS
         BAL   REG9,ADD            BAL TO COUNTER ADD
         B     DECID               BRANCH TO EXIT CHECK
*
*
PARAMRP  OI    0(REG7),PRPARN      SET PARAMETER BIT AND
*                                      END-OF-PARAMETER BIT
         OI    DSP10(REG7),CMP3    SET DELIMITER BIT -
         CLI   1(REG3),RPARN       ARE THERE 2 RIGHT PARENTHESES A32633
         BE    KPASERR             YES, ERROR BRANCH             A32633
*                                      RIGHT PARENTHESIS
         BAL   REG9,SUBT           BAL TO SUBTRACT UNATTACHED
*                                      PARENTHESIS
         B     DECID               BRANCH TO EXIT CHECK
*
*
PRFOL    OI    DSP5(REG7),CMP2     SET PARAMETER FOLLOW SWITCH
         B     KPASS               BRANCH TO RETURN ROUTINE
*
*
KINVAL   OI    0(REG7),X'C0'       TURN ON ERR AND BYPASS  BITS    SA0I
         LA    REG2,ONE(0,REG2)    ADJUST TO NEXT DELIMITER
         LA    REG3,ONE(0,REG3)    INCREMENT POINTER
         CLI   0(REG3),X'5B'       TEST FOR DOLLAR SIGN
         BE    NOTDELIM
         CLI   0(REG3),X'7B'       TEST FOR POUND SIGN
         BE    NOTDELIM
         CLI   0(REG3),X'7C'       TEST FOR AT SIGN
         BE    NOTDELIM            IF "AT" SIGN BRANCH TO NOTDELIM SA0I
         CLI   0(REG3),KSPLT       CHECK FOR DELIMITER
         BL    KINV                INVALID DELIMITER
NOTDELIM CR    REG3,REG5          TEST IF END COLUMN
         BL    KINVAL              NOT END-CONTINUE CHECKING
         TM    DSP8(REG7),CMP4     TEST IF COLUMN 72 BLANK
         BO    KTERBY              YES-BRANCH TO ERROR BYPASS
         LA    REG2,ONE(0,REG2)    INCREMENT POINTER
         B     KPTERR              BRANCH TO LENGTH CHECK
*
*
***********************************************************************
*        KCONT GETS CONTROL WHEN A CONTINUATION CARD HAS BEEN      SA0I
*        READ. IT FIRST CHECKS TO SEE THAT THE CARD BEGINS IN      SA0I
*        THE PROPER COLUMN.  IF THE CARD WAS TO BE BYPASSED,       SA0I
*        CONTROL IS GIVEN TO KPASS.  OTHERWISE CONTROL IS GIVEN    SA0I
*        TO SCANR, THE SCAN ROUTINE.                               SA0I
*
KCONT    CLC   1(3,REG7),BLANKS    ARE FIRST THREE COLUMNS ON      SA0I
*                                     CONTINUATION CARD BLANK      SA0I
         BNE   SETBITS             NO, GO TO SET ERR,BYPASS BITS   SA0I
         LA    REG3,DSP1(REG7)     SET PNTR TO CONTINUATION COL.(4)SA0I
         TM    0(REG7),CMP1        IS BYPASS BIT ON                SA0I
         BO    KPASS               YES, GO TO RETURN ROUTINE       SA0I
CHKBLNK  CLI   0(REG3),X'40'       IS CURRENT COL BLANK            SA0I
         BNE   RESET               NO,GO TO RESET DELIMITERS       SA0I
         LA    REG3,ONE(REG3)      ELSE, SET POINTER TO NEXT COL   SA0I
         TM    DSP10(REG7),CMP5    IS THIS A LITERAL               SA0I
         BZ    LOADAD              NO, CHECK FOR COL. 17           SA0I
         LA    REG5,DSP2(REG7)     LOAD ADDRESS OF COL. 16         SA0I
         CR    REG3,REG5           IS THIS COL. 16                 SA0I
         BE    RESET               YES, GO TO RESET DELIMITER      SA0I
         B     CHKBLNK             NO, GO TO CHECK FOR BLANK COL.  SA0I
LOADAD   LA    REG5,DSP17(REG7)    LOAD ADDRESS OF COL. 17         SA0I
         CR    REG3,REG5           IS POINTER SET TO COL 17        SA0I
         BNE   CHKBLNK             NO,GO TO CHK FOR BLNK COL.      SA0I
SETBITS  OI    0(REG7),X'C0'       YES,SET ERR AND BYPASS BITS     SA0I
         NI    DSP5(REG7),X'FC'    TURN OFF KEYWORD REQUIRED BIT   SA0I
*                                      AND PARAMETER REQUIRED BIT  SA0I
         B     KPASS               GO TO RETURN ROUTINE            SA0I
RESET    NI    DSP10(REG7),RESET0  RESET DELIMITER INDICATORS      SA0I
         B     SCANR               GO TO SCAN ROUTINE              SA0I
*
*
***********************************************************************
*        KPART GETS CONTROL WHEN A FIELD EXTENDS INTO COLUMN       SA0I
*        71.  IF A CONTINUATION CHARACTER HAS BEEN CODED IN        SA0I
*        COLUMN 72, THE FIELD IS TO BE CONTINUED ON THE NEXT       SA0I
*        CARD.  IN THIS CASE, THE PARTIAL PARAMETER SWITCH IS      SA0I
*        TURNED ON AND THE FIRST PART OF THE FIELD IS MOVED INTO   SA0I
*        A SPECIAL BUFFER AREA WHILE ITS LENGTH IS STORED.  THE    SA0I
*        CONTINUATION BIT IS ALSO SET AND A NEW CARD IS READ INTO  SA0I
*        THE REGULAR BUFFER.                                       SA0I
*
KPART    TM    DSP5(REG7),CMP3     TEST IF PARTIAL PARAM SWITCH ON
         BO    KTERBY              YES-BRANCH TO ERROR BYPASS
         OI    DSP8(REG7),CMP0     SET CCO BIT
KPTERR   OI    DSP5(REG7),CMP3     SET PARTIAL PARAMETER SWITCH ON
         TM    DSP8(REG7),CMP4     TEST FOR COL 72 BLANK
         BO    KLAST               ON-BRANCH TO PARAMETER SET
         MVI   DSP7(REG7),CMP1             MOVE BLANK TO WORK AREA
         MVC   DSP7+1(43,REG7),DSP7(REG7)  MOVE BLANK CHARACTERS
         STC   REG2,DSP6(0,REG7)   STORE PARTIAL PARAMETER LENGTH
         BCTR  REG2,REG0           ADJUST LENGTH FOR MOVE
         EX    REG2,MOVEP          MOVE PARTIAL PARAMETER
*                                     TO WORK AREA
         OI    DSP5(REG7),CMP1     SET CONTINUE BIT
         B     KCDFL               BRANCH TO COL 72 TEST
*
*
KLAST    OI    0(REG7),CMP6        SET PARAMETER BIT
         NI    DSP5(REG7),X'EF'    TURN PARTIAL PARAMETER          SA0I
*                                      SWITCH OFF                  SA0I
         B     KETBYP              BRANCH TO SET BYPASS BIT
*
*
***********************************************************************
*        KPPAR GETS CONTROL WHEN THE SECOND HALF OF A SPLIT FIELD  SA0I
*        IS FOUND. IT MOVES THIS SECOND PART INTO THE SAME SPECIAL SA0I
*        BUFFER AREA USED BY KPART TO STORE THE FIRST HALF OF THE  SA0I
*        FIELD.  THE TWO PARTS ARE JOINED TOGETHER AND THE FIELD   SA0I
*        IS PASSED TO THE ANALYSIS ROUTINE AS IF IT WERE A         SA0I
*        NORMAL FIELD.                                             SA0I
*
KPPAR    SR    REG4,REG4           ZERO REGISTER
         IC    REG4,DSP6(0,REG7)   TEST PARAMETER LENGTH
         LR    REG6,REG4           FIRST LENGTH IN INDEX
         AR    REG4,REG2           ADD PARTIAL LENGTH
         CH    REG4,FOUR4          COMPARE LENGTH TO MAXIMUM
         BH    KTERBY              HIGH-BRANCH TO ERROR BYPASS
         LA    REG4,DSP7(REG6,REG7)    INITIALIZE THE REGISTER     SA0I
*                                      SO THAT THE PARTIAL         SA0I
*                                      PARAMETER MAY BE MOVED      SA0I
         CLI   0(REG3),EQUAL       TEST FOR EQUAL SIGN             SA0I
         BE    SKIPDCR             YES - DO NOT DECREMENT LENGTH   SA0I
*                                      COUNTER, SO THAT EQUAL SIGN SA0I
*                                      WILL ALSO BE MOVED INTO     SA0I
*                                      PARTIAL PARAMETER BUFFER    SA0I
         SR    REG4,REG4           ZERO REGISTER
         AR    REG4,REG2           PARTIAL LENGTH
         BE    KOMPL               PART ZERO,ALL IN HOLD
         LA    REG4,DSP7(REG6,REG7)    INITIALIZE THE REGISTER     SA0I
*                                      SO THAT THE PARTIAL         SA0I
*                                      PARAMETER MAY BE MOVED      SA0I
         BCTR  REG2,REG0           DECREMENT FOR EXECUTE
         EX    REG2,MOVPP          MOVE PARAMETER
         LA    REG2,ONE(0,REG2)    INCREMENT LOCATION REGISTER
         B     KOMPL               BRANCH TO LENGTH COMPUTATION    SA0I
SKIPDCR  EX    REG2,MOVPP          MOVE KEYWORD INTO PARTIAL       SA0I
*                                      PARAMETER BUFFER            SA0I
KOMPL    SR    REG4,REG4           ZERO REGISTER
         IC    REG4,DSP6(0,REG7)   COMPUTE LENGTH AND
         AR    REG2,REG4           PLACE IN REGISTER2
         LA    REG1,DSP7(0,REG7)   ADDRESS OF HOLD AREA
         NI    DSP8(REG7),RESET10  RESET EXIT CONTROL SWITCH
*                                      TO ZERO
         OI    DSP8(REG7),MSKE     SET CC1 AND LENGTH GREATER THAN ZERO
         MVC   DSP11(ONE,REG7),DSP10(REG7)     MOVE PRESENT TO
*                                      LAST DELIMITER
         NI    DSP10(REG7),RESET0  SET PRESENT DELIMITER TO ZERO
         NI    DSP5(REG7),RESET6   RESET PARTIAL PARAMETER SWITCH
         B     DELIM               BRANCH TO DELIMITER CHECK
*
*
***********************************************************************
*        KPASS RETURNS CONTROL TO THE CALLING ANALYSIS ROUTINE.    SA0I
*        IT FIRST CHECKS VARIOUS COMBINATIONS OF BITS TO DETERMINE SA0I
*        IF AN ERROR CONDITION IS PRESENT. THE COMBINATION OF      SA0I
*        ERROR, BYPASS, COMMAND, KEYWORD, PARAMETER, KEYWORD       SA0I
*        REQUIRED, AND PARAMETER REQUIRED BITS TELLS THE CALLING   SA0I
*        ROUTINE EXACTLY WHAT TYPE OF INFORMATION IS BEING PASSED, SA0I
*        AND IF AN ERROR CONDITION EXISTS,JUST WHAT TYPE OF ERROR  SA0I
*        IT IS.                                                    SA0I
*
KPASS    LA    REG3,ONE(0,REG3)    SET POINTER TO NEXT COLUMN
         TM    0(REG7),X'C0'      BYPASS AND ERROR BITS ON ?     A55761
         BNO   KPASS2             NO, CONTINUE CHECKING          A55761
         TM    0(REG7),X'08'      COMMAND BIT ON ?               A55761
         BO    KPASS2             YES, LEAVE ERROR BIT ON        A55761
         TM    DSP5(REG7),CMP6    IS KEYW.  REQ. BIT ON ?        A55761
         BO    KPASS2             YES, LEAVE ERROR BIT ON        A55761
         TM    DSP5(REG7),CMP7    IS PARAM. REQ. BIT ON ?        A55761
         BO    KPASS2             YES, LEAVE ERROR BIT ON        A55761
         NI    0(REG7),X'7F'      SET OFF ERR. BIT , BEC. COMM.  A55761
KPASS2   EQU   *                  CONTINUE CHECKING              A55761
         TM    0(REG7),X'0C'       COMMAND AND KEYWORD BOTH ON
         BO    KPASERR             YES-BRANCH TO ERROR SET
         TM    0(REG7),X'0A'       COMMAND AND PARAMETER BOTH ON?
         BO    KPASERR             YES-BRANCH TO ERROR SET
         TM    0(REG7),CMP6        IS PARAMETER BIT ON             SA0I
         BZ    TESTKEY             NO-CHECK KEYWORD BIT            SA0I
         TM    DSP5(REG7),CMP6     IS KEYWORD REQUIRED BIT ON      SA0I
         BO    PAROFF              YES-BRANCH TO TURN OFF PARAMETERSA0I
*                                  BIT                             SA0I
TESTKEY  TM    0(REG7),CMP5        IS KEYWORD BIT ON               SA0I
         BZ    CHKBYP              NO-CHECK BYPASS BIT             SA0I
         TM    DSP5(REG7),CMP7     IS PARAMETER REQUIRED BIT ON    SA0I
         BO    KEYOFF              YES-BRANCH TO TURN OFF KEYWORD  SA0I
*                                  BIT                             SA0I
CHKBYP   TM    0(REG7),CMP1        IS BYPASS BIT ON                SA0I
         BZ    KPASS1              NO, SKIP ERROR SET              SA0I
         TM    0(REG7),CMP7        IS END-OF-PARAMETER BIT ON      SA0I
         BO    KPASS1              YES, RETURN TO ANALYSIS ROUTINE SA0I
         TM    DSP5(REG7),CMP6     IS KEYWORD REQUIRED BIT ON      SA0I
         BZ    PTEST               NO, TEST PARAMETER REQUIRED BIT SA0I
         B     KPASERR             GO TO ERROR SET                 SA0I
PTEST    TM    DSP5(REG7),CMP7     IS PARAMETER REQUIRED BIT ON    SA0I
         BZ    ETEST               NO, TEST ERROR BIT              SA0I
         B     KPASERR             GO TO ERROR SET                 SA0I
ETEST    TM    0(REG7),CMP0        IS ERROR BIT ON                 SA0I
         BO    KPASS1              IF SO, SKIP ERROR SET           SA0I
         CLI   144(REG7),X'01'     IS NEW CARD SWITCH ON           SA0I
         BE    KPASS1              YES,SKIP ERROR SET              SA0I
         TM    DSP8(REG7),CMP4     IS COL. 72 BLANK                SA0I
         BZ    KGTCD               NO,READ NEXT CARD AS            SA0I
*                                      CONTINUATION CARD           SA0I
         NI    0(REG7),X'BF'       TURN OFF BYPASS BIT ONLY        SA0I
         NI    DSP5(REG7),RESET0   RESET ENTRY CONTROL SWITCHES    SA0I
         B     KGTCD               NO, READ A NEW CARD             SA0I
PAROFF   NI    0(REG7),X'FD'       TURN OFF PARAMETER BIT          SA0I
         B     KPASERR             BRANCH TO ERROR SET             SA0I
KEYOFF   NI    0(REG7),X'FB'       TURN OFF KEYWORD BIT            SA0I
KPASERR  OI    0(REG7),X'C0'       SET ERROR AND BYPASS BITS       SA0I
KPASS1   NI    DSP5(REG7),X'EB'    RESET PARTIAL PARAM SWITCH
         NI    140(REG7),X'00'     RESET CARD SEQUENCE SWITCH
         ST    REG3,DSP13(0,REG7)  SAVE POINTER TO NEXT PARAMETER
         NI    KA+1,X'0F'          SET INLINE SWITCH-
         OI    KB+1,X'70'          SET INLINE SWITCH --TO ORIGINAL
         NI    KC+1,X'0F'          SET INLINE SWITCH-
         LR    REG0,REG2           LOAD PARAMETER LENGTH
RETLABEL LM    REG13,REG14,SAVE13       RESTORE REGISTERS
         RETURN  (2,12)
***********************************************************************
*        KPCMD RECEIVES CONTROL WHEN A BLANK DELIMITER IS FOUND    SA0I
*        AT THE END OF A COMMAND FIELD.  THE COLUMN POINTER IS     SA0I
*        INCREMENTED UNTIL THE FIRST NON-BLANK COLUMN IS FOUND     SA0I
*        OR UNTIL THE END COLUMN IS HIT.                           SA0I
*
KPCMD    MVI   SYNSW,X'01'         SET SWITCH
KPCMD2   LA    REG3,ONE(0,REG3)    INCREMENT POINTER
         CLI   0(REG3),BLANKCOL    TEST FOR BLANK COLUMN
         BNE   KPCMA               NOT BLANK-BRANCH TO KPCMA
         CR    REG5,REG3           TEST FOR END COLUMN
         BNE   KPCMD2              NOT END, INCREMENT COUNTER      SA0I
*                                          AND CONTINUE            SA0I
         OI    0(REG7),X'41'       TURN ON BYPASS AND END OF       SA0I
*                                          PARAMETERS BITS         SA0I
         OI    DSP15(REG7),X'0F'   SET RECORD WITHOUT PARAM SW  SA61471
         B     KPASS               GO TO RETURN ROUTINE            SA0I
*
*
KPCMA    CLI   0(REG3),COMMA       TEST FOR COMMA
         BE    KTERBY              YES-BRANCH TO ERROR BYPASS
         BCTR  REG3,REG0           DECREMENT LOCATION FOR TEST
         OI    DSP10(REG7),CMP4    TURN ON BLANK DELIMITER BIT     SA0I
         B     PRFOL               BRANCH TO PARAMETER FOLLOW SET
*
*
KSETP    OI    DSP5(REG7),CMP3     SET PARAMETER FOLLOW BIT
         LA    REG2,ONE(REG0,REG2) ADJUST LENGTH
         B     KPTERR              BRANCH TO PARAMETER SET
*
*
KINV     TM    DSP5(REG7),CMP5     TEST FOR COMMAND CONTROL SWITCH
         BO    KPCMD               YES-BRANCH TO SWITCH SET
         OI    0(REG7),CMP6        TURN ON PARAMETER BIT           SA0I
         B     PRFOL               BRANCH TO PARAMETER FOLLOW SET
*
*
KCDFL    TM    DSP8(REG7),CMP5     TEST COL 72 NON-BLANK
         BO    KGTCD               NON-BLANK,BRANCH TO READ NEW CARD
         OI    0(REG7),CMP0        SET ERROR
KBYPS    OI    0(REG7),CMP1        SET BYPASS
         B     KPASS               BRANCH TO BYPASS
*
*
SUBT     LH    REG4,DSP9(REG0,REG7)    DELIMITER WAS A
*                                      RIGHT PARENTHESIS
         BCTR  REG4,REG0            SUBTRACT ONE FROM COUNTER
         STH   REG4,DSP9(REG0,REG7) STORE UPDATED COUNTER
         NI    DSP5(REG7),X'FE'    TURN OFF PARAMETER REQ BIT    A30916
         LTR   REG4,REG4           TEST COUNTER FOR ZERO
         BNL   KACK                OK-BRANCH TO ESCAPE
         OI    0(REG7),CMP0        SET ERROR
KACK     BR    REG9                BRANCH BACK TO NEXT SEQUENTIAL
*                                     INSTRUCTION AFTER BAL
*
*
ADD      LH    REG4,DSP9(REG0,REG7)    DELIMITER WAS A
*                                      LEFT PARENTHESIS
         LA    REG4,ONE(REG0,REG4)  ADD ONE TO COUNTER
         STH   REG4,DSP9(REG0,REG7) STORE UPDATED COUNTER
         BR    REG9                BRANCH BACK TO NEXT SEQUENTIAL
*                                      INSTRUCTION AFTER BAL
*
*
EOFRET   NI    0(REG7),CMP2        TURN OFF ALL BITS EXCEPT EOF    SA0I
         B     RETLABEL            RETURN TO ANALYSIS ROUTINE      SA0I
*
*
KPAFOL   LA    REG3,ONE(REG0,REG3) ADJUST POINTER TO NEXT COLUMN
         B     SCANR               BRANCH TO READ NEXT CARD
*
*
KINVALD  OI    0(REG7),CMP0        SET ERROR
         TM    DSP8(REG7),CMP2     TEST IF DELIMITER IS IN END COL
         BO    KSETP               BRANCH TO PARAMETER FOLLOW SET
         B     KINVAL              BRANCH TO INVALID DELIMITER ROUTINE
*
*
ZRPARN   OI    0(REG7),CMP6        TURN ON PARAMETER BIT           SA0I
         SR    REG4,REG4           ZERO REGISTER FOUR              SA0I
         STH   REG4,DSP9(REG7)     RESET PARENTHESES COUNTER       SA0I
*                                      TO ZERO                     SA0I
         B     KPASS               GO TO RETURN ROUTINE            SA0I
KEOF     NI    0(REG7),X'00'       RESET SWITCH AREA
         OI    0(REG7),X'20'       SET EOF SWITCH
         BAL   REG9,PARAN          BRANCH TO PARENTHESES COUNTER
*                                      CHECK
KEOF2    CLOSE (KSYSIN)            CLOSE SYSIN
         FREEPOOL  KSYSIN                                          BS0H
         LR    REG1,REG9                                         A27717
         B     RETLABEL                                          A27717
*
*
PARAN    SR    REG4,REG4           ZERO WORK REGISTER
         AH    REG4,128(REG0,REG7) LOAD PARENTHESIS COUNT
         BZ    OKAY                COUNT ZERO-BRANCH TO ESCAPE
         OI    0(REG7),X'80'       NON-ZERO,SET ERROR
         OI    DSP10(REG7),CMP6    TURN ON PARENTHESES-            SA0I
*                                     NOT-CLOSED BIT               SA0I
         SR    REG4,REG4           ZERO REGISTER 4                 SA0I
         STH   REG4,DSP9(REG7)     RESET PARENTHESES COUNTER TO 0  SA0I
OKAY     BR    REG9                BRANCH TO NEXT SEQUENTIAL
*                                      INSTRUCTION AFTER BAL
*
*
DDERROR  LA    REG2,DDNAME(REG1)   ADDRESS OF DDNAME IN DCB
         L     REG1,VMSG           ADDRESS OF ERROR MESSAGE
         MVC   7(8,REG1),0(REG2)   MOVE DDNAME TO ERROR MESSAGE
         L     REG13,SAVE13        RESTORE REGISTER
         L     REG14,VADDR         WHERE TO GO IN ANALYZER ROUTINE
         RETURN  (2,12)
DCBEXITN LA    REG3,KSYSIN                                         BS0H
         LH    REG5,BLKSI(REG3)                                    BS0H
         OR    REG5,REG5                                           BS0H
         BC    8,DCBSIZ                 IF NONE SPECIFIED --       BS0H
         LA    REG6,80                                             BS0H
         SR    REG4,REG4                                           BS0H
         DR    REG4,REG6                                           BS0H
         LTR   REG4,REG4                TEST FOR MODULAR BLKSIZE   BS0H
         BC    2,BLKERR                 IF NOT MODULAR --          BS0H
         RETURN
         USING IHADCB,REG3                                         BS0H
DCBSIZ   MVI   DCBBLKSI+1,X'50'         INSERT BLKSIZE -- 80       BS0H
         RETURN
BLKERR   MVI   DFLAG,X'10'              SET BLKSIZE ERROR SWITCH   BS0H
         MVC   DCBBLKSI(2),DCBLRECL     MOVE LRECL TO BLKSIZE      BS0H
         DROP  REG3                                                BS0H
         RETURN
*
*
*
MOVEP    MVC   DSP7(ONE,REG7),0(REG1)   MOVE FOR EXECUTE
MOVPP    MVC   0(ONE,REG4),0(REG1)      MOVE FOR EXECUTE
*
         EJECT
***********************************************************************
*
*              CCS02 CONSTANTS AND DCB
*
GENLABEL DC    F'0'                NO-SCAN SWITCH,SET BY IEBGSCAN  UL0H
KEND     DC    C'/*'
EODA     DC    AL3(KEOF)
         EXTRN DDERROR1
VMSG     DC    A(DDERROR1)
         EXTRN DDRTN
VADDR    DC    A(DDRTN)
         EXTRN BLKRTN                                              BS0H
VBLKRTN  DC    A(BLKRTN)                                           BS0H
*
KSYSIN   DCB   DSORG=PS,MACRF=(GM),DDNAME=SYSIN,RECFM=FB,LRECL=80, BS0H*
               EXLST=OPT,EODAD=KEOF,SYNAD=KERR                     BS0H
OPT      DC    X'85'                                               BS0H
         DC    AL3(DCBEXITN)                                       BS0H
DFLAG    DC    X'00'                                               BS0H
*
*
KERR     SYNADAF ACSMETH=QSAM                                    A27717
         LR    REG9,REG1               SAVE POINTER TO SYNAD INFOA27717
         LA    REG1,79                 GET STORAGE TO SAVE       A27717
         GETMAIN  R,LV=(1)             SYNAD INFO                A27717
         MVC   0(79,REG1),49(REG9)     MOVE SYNAD INFO TO GOTTEN A27717
         LR    REG9,REG1               CORE AND SAVE POINTER     A27717
         SYNADRLS                                                A27717
         LR    REG1,REG9               RESTORE POINTER           A27717
         MVI   144(REG7),X'02'         SET INPUT ERROR SWITCH    A27717
         B     KEOF2                   BRANCH TO CLOSE           A27717
*
*
SYNSW    DC    X'00'
*
*              CONSTANTS
*
KREGSAVE DS    18F                 REGISTER SAVE AREA
KDCBSAVE DS    20F                 SYSIN DCB SAVE AREA
KSIDD    DS    2F                  USER DDNAME AREA
SAVE13   DS    2F                  REGISTERS 13-14 SAVE AREA
FOUR3    DC    F'43'                                              M3310
         DS    0F
EIGHT    DC    X'00000008'                                         SA0I
FOUR4    DC    H'44'
BLANKS   DC    CL3' '                                              SA0I
*
*              REGISTER EQUATES
*
REG0     EQU   0
REG1     EQU   1
REG2     EQU   2
REG3     EQU   3
REG4     EQU   4
REG5     EQU   5
REG6     EQU   6
REG7     EQU   7
REG8     EQU   8
REG9     EQU   9
REG10    EQU   10
REG11    EQU   11
REG12    EQU   12
REG13    EQU   13
REG14    EQU   14
GO       EQU   15
*
*              EQUATE BIT SWITCHES
*
CMP0     EQU   X'80'          SET  ERROR,CC0
CMP1     EQU   X'40'          SET  BYPASS,CONT,CC1
CMP2     EQU   X'20'          SET  EOF,PARAM FOLL,CC2
CMP3     EQU   X'10'          SET  FIRST ENTRY,PARTIAL PARAM
CMP4     EQU   X'08'          SET  COMMAND,RDCD,COL72 NON-BLANK
CMP5     EQU   X'04'           SET KEYWORD,CSWITCH,COL72 NON-BLANK
CMP6     EQU   X'02'          SET  PARAM,L70
CMP7     EQU   X'01'          SET  RPAREN,L=0
*
*              RESET EQUATES
*
CMP8     EQU   X'14'         RESET ENTRY CONTROL SWITCH
RESET0   EQU   X'00'         RESET TO ZERO
RESET1   EQU   X'F7'         RESET COMMAND,RDCD,COL 72 BLANK
RESET2   EQU   X'98'         RESET ALL BUT ERR,FST ENT,COMM
RESET6   EQU   X'EF'         RESET PART PARM SWITCH
RESET10  EQU   X'0C'         RESET EXIT CONTROL SWITCH
RESETB   EQU   X'50'               TEST COMMA OR RIGHT PAREN
*
CC0      EQU   8                   CONDITION CODE CMP0=8
CC1      EQU   4                   CONDITION CODE CMP1=4
CONT     EQU   X'48'               SETS ENTRY CONTROL SWITCH
ONE      EQU   1
KSPLT    EQU   X'7F'               DELIMITER TEST
*
*              WORK AREA DISPLACEMENTS
*
DSP1     EQU   4                                                   SA0I
DSP2     EQU   16                  COL 16 OF CARD
DSP3     EQU   71                  COL 71 OF CARD
DSP4     EQU   72                  COL 72 (CONTINUATION)
DSP5     EQU   81                  ENTRY CONTROL SWITCH
DSP6     EQU   82                  LENGTH OF PARTIAL PARAMETER
DSP7     EQU   83                  PARTIAL PARAMETER
DSP8     EQU   127                 EXIT CONTROL SWITCH
DSP9     EQU   128                 PARENTHESIS COUNTER
DSP10    EQU   130                 PRESENT DELIMITER INDICATOR
DSP11    EQU   131                 LAST DELIMITER INDICATOR
DSP13    EQU   136                 SAVE NEXT PARAMETER POINTER
DSP15    EQU   141                 RECORD WITHOUT PARAM SW      SA61471
DSP17    EQU   17                                                  SA0I
*
*              TEST CONSTANTS
*
EQUAL    EQU   C'='
COMMA    EQU   C','
BLANKCOL EQU   C' '
LPARN    EQU   C'('
RPARN    EQU   C')'
PERIOD   EQU   C'.'
MINUS    EQU   C'-'
PRPARN   EQU   X'03'
EQRPN    EQU   X'90'
MSKE     EQU   X'42'
MSKG     EQU   X'60'
*
         DCBD  DSORG=PS
DDNAME   EQU   DCBDDNAM-IHADCB
BLKSI    EQU   DCBBLKSI-IHADCB
OFLGS    EQU   DCBOFLGS-IHADCB
         END
