***********************************************************************
*                                                                     *
* NAME   *   *   *****   *****   *****   *       ***   *****   *****  *
*        ** **   *       *       *       *        *    *         *    *
*        * * *   ****     ***     ***    *        *     ***      *    *
*        *   *   *           *       *   *        *        *     *    *
*        *   *   *****   *****   *****   *****   ***   *****     *    *
*                                                                     *
***********************************************************************
*                                                                     *
* FUNCTION/OPERATION                                                  *
*                                                                     *
*     THIS IS THE STANDARD MESSAGE MODULE FOR THE DATA SET UTILITY    *
*   IEBCOMPR.  IT CONTAINS ALL THE MESSAGES GIVEN BY IEBCOMPR WHICH   *
*   ARE NOT SIMPLY INFORMATIONAL MESSAGES.  EACH MESSAGE HAS A SEVEN  *
*  CHARATER IDENTIFING LABEL AND UP TO SEVENTY-TWO CHARACTERS OF      *
*   MESSAGE TEXT.                                                     *
*                                                                     *
***********************************************************************
*                                                                     *
* ENTRY POINTS                                                        *
*                                                                     *
*   1. 'MESSLIST'   THIS IS THE CSECT NAME FOR THE MODULE, AND IS THE *
*                RELATIVE POINT FROM WHICH THE ADDRESS OF THE MESSAGES*
*                OF 40 BYTES LONG IS CALCULATED.                      *
*                                                                     *
*   2. 'DDERROR1'   THIS IS THE ADDRESS OF THE TEXT FOR THE MESSAGE   *
*                 THAT INDICATES SOME DDNAME CANNOT BE OPENED. THE    *
*                 DDNAME IS PLACED IN THE MESSAGE BY USING THIS ENTRY *
*                 POINT.                                              *
*                                                                     *
*   3. 'MSG31'      THIS IS THE RELATIVE POINT FROM WHICH THE ADDRESS *
*                OF THE MESSAGES OF 72 BYTES LONG IS CALCULATED.      *
***********************************************************************
         EJECT
***********************************************************************
*                                                                     *
* INPUT                                                               *
*      INPUT TO THE JPRINTRT MESSAGE WRITER-                      *SA0I
*     REGISTER 1 CONTAINS THE DESIRED MESSAGE NUMBER ON ENTRY TO  *SA0I
*      THE JPRINTRT MESSAGE WRITER ROUTINE.                       *SA0I
*                                                                     *
***********************************************************************
*                                                                     *
* OUTPUT                                                              *
*                                                                     *
*     NO OUTPUT                                                       *
*                                                                     *
***********************************************************************
*                                                                     *
* EXTERNAL ROUTINES                                                   *
*                                                                     *
*     NOT APPLICABLE                                                  *
*                                                                     *
***********************************************************************
*                                                                     *
* EXITS                                                               *
*                                                                     *
*     NOT APPLICABLE                                                  *
*                                                                     *
***********************************************************************
*                                                                     *
* TABLES/WORK AREA                                                    *
*                                                                     *
*     THE ENTIRE MODULE IS A TABLE.  EACH ENTRY IS FORTY BYTES LONG,  *
*   AND CONSISTS OF A SEVEN BYTE IDENTIFIER FOLLOWED BY UP TO THIRTY  *
*   TWO BYTES OF TEXT INFORMATION.                                    *
*                                                                     *
***********************************************************************
*                                                                     *
* ATTRIBUTES                                                          *
*                                                                     *
*     NOT APPLICABLE SINCE THE CSECT HAS NO EXECUTABLE INSTRUCTIONS.  *
*                                                                     *
***********************************************************************
*                                                                 *SA0I
*NOTE- DUPLICATE MESSAGES PREVIOUSLY OCCURING IN THIS MODULE      *SA0I
*        HAVE BEEN DELETED FOR RELEASE 18. THOSE MESSAGE SLOTS    *SA0I
*        WHICH ARE CURRENTLY AVAILABLE ARE MARKED AS UNUSED.      *SA0I
*        IF A MESSAGE IDENTIFIER CODE APPEARS AS OUTPUT WITHOUT   *SA0I
*        A FOLLOWING MESSAGE THEN THE MESSAGE NUMBER PASSED TO    *SA0I
*        THE JPRINTRT PRINT ROUTINE MUST BE CORRECTED TO THE NO.  *SA0I
*        INDICATED IN THE COMMENT OF THAT MESSAGE IDENTIFIER      *SA0I
*                                                                 *SA0I
*******************************************************************SA0I
MESSLIST CSECT
* 015800,021800,022600                                           A26556
*8047                                                              000H
*3265015800,016200,016600,020000,020200,021200,021400,022000-      SA0I
* 022600,025200,025400,026000,026200,426797                        SA0I
*C019800                                                         A41765
*C026740,026741                                                  A44318
*C016200                                                         A48817
         ENTRY DDERROR1
         ENTRY MSG31                                               UV0H
         DS    40X
         DC    CL8'IEB201I '
         DC    CL32'INVALID CONTROL STATEMENT       '
         DC    CL8'IEB202I '
         DC    CL32'INVALID DIRECTORY BLOCK SIZE    '            A26556
         DC    CL8'IEB203I '
         DC    CL32'ALIAS/TRUE NAME FAILURE         '            A48817
         DC    CL8'IEB204I '
         DC    CL32' '  UNUSED-REPLACED WITH MESSAGE 61            SA0I
         DC    CL8'IEB205I '
         DC    CL32'USER DATA FIELDS UNEQUAL        '
         DC    CL8'        '
         DC    CL32'ALIAS MISSING FROM SYSUT2       '
         DC    CL8'        '
         DC    CL32'TRUE NAME MISSING FROM SYSUT2   '
         DC    CL8'        '
         DC    CL32'ALIAS MISSING FROM SYSUT1       '
         DC    CL8'        '
         DC    CL32'TRUE NAME MISSING FROM SYSUT1   '
         DC    CL8'IEB210I '
         DC    CL32'   TRUE NAMES MISSING- BOTH SETS'
         DC    CL8'IEB211I '
         DC    CL32'   KEY LENGTHS ARE NOT EQUAL    '
         DC    CL8'IEB212I '
         DC    CL32'INVALID DCB PARAMETER           '            A41765
         DC    CL8'IEB213I '                                       SA0I
         DC    CL32'REPETITIOUS CARD INVALID        '              SA0I
         DC    CL8'IEB214I '
         DC    CL32'   FIXED RECORD LENGTHS UNEQUAL '
         DC    CL8'IEB215I '
         DC    CL32'RECORD FORMATS DIFFERENT        '
         DC    CL8'IEB216I '                                       SA0I
         DC    CL32'ILLEGAL CONTROL CARD SEQUENCE   '              SA0I
         DC    CL8'IEB217I '
         DC    CL32'INVALID LRECL FOR V/VS RECORD   '           A26556
         DC    CL8'IEB218I '                                       SA0I
         DC    CL32'PERMANENT INPUT ERROR-FIND MACRO'              SA0I
         DC    CL8'IEB219I '                                       SA0I
         DC    CL32'INVALID BLKSIZE FOR V/VS RECORD '           A26556
         DC    CL8'        '
         DC    CL32'   RECORD LENGTHS ARE UNEQUAL   '
         DC    CL8'IEB221I '
         DC    CL32'   RECORDS ARE NOT EQUAL        '
         DC    CL8'IEB222I '
         DC    CL32'   KEYS ARE NOT EQUAL           '
         DC    CL8'IEB223I '
         DC    CL32'EXTRA RECORD ON SYSUT2          '
         DC    CL8'IEB224I '
         DC    CL32'EXTRA RECORD ON SYSUT1          '
         DC    CL8'IEB225I '
         DC    CL32'JOB TERMINATED AFTER EXIT       '
         DC    CL8'IEB226I '                                       SA0I
         DC    CL32'WARNING-INVALID NAME            '              SA0I
         DC    CL8'IEB227I '
         DC    CL32'   TEN CONSECUTIVE ERRORS       '
         DC    CL8'IEB228I '                                       SA0I
         DC    CL32' '  UNUSED-REPLACED WITH MESSAGE 27            SA0I
         DC    CL8'IEB229I '
DDERROR1 DC   CL32'DDNAME          CANNOT BE OPENED'
         DC    CL8'IEB230I '                                       000H
         DC    CL32'SYSIN BLOCKSIZE ERROR           '              000H
MSG31    DC    CL8'IEB231I '                                       UL0H
         DC    CL32'EXTRA USER INPUT HEADER LABELS O'              UL0H
         DC    CL32'N SYSUT1                        '              UL0H
         DC    CL8'IEB232I '                                       UL0H
         DC    CL32'EXTRA USER INPUT HEADER LABELS O'              UL0H
         DC    CL32'N SYSUT2                        '              UL0H
         DC    CL8'IEB233I '                                       UL0H
         DC    CL32'EXTRA USER INPUT TRAILER LABELS '              UL0H
         DC    CL32'ON SYSUT1                       '              UL0H
         DC    CL8'IEB234I '                                       UL0H
         DC    CL32'EXTRA USER INPUT TRAILER LABELS '              UL0H
         DC    CL32'ON SYSUT2                       '              UL0H
         DC    CL8'IEB235I '                                       UL0H
         DC    CL32'SYSUT1 CONTAINS NO USER INPUT HE'              UL0H
         DC    CL32'ADER LABELS                     '              UL0H
         DC    CL8'IEB236I '                                       UL0H
         DC    CL32'SYSUT2 CONTAINS NO USER INPUT HE'              UL0H
         DC    CL32'ADER LABELS                     '              UL0H
         DC    CL8'IEB237I '                                       UL0H
         DC    CL32'BOTH INPUT DATA SETS CONTAIN NO '            A44318
         DC    CL32'USER HEADER LABELS              '            A44318
         DC    CL8'IEB238I '                                       UL0H
         DC    CL32'SYSUT1 CONTAINS NO USER INPUT TR'              UL0H
         DC    CL32'AILER LABELS                    '              UL0H
         DC    CL8'IEB239I '                                       UL0H
         DC    CL32'SYSUT2 CONTAINS NO USER INPUT TR'              UL0H
         DC    CL32'AILER LABELS                    '              UL0H
         DC    CL8'IEB240I '                                       UL0H
         DC    CL32'BOTH INPUT DATA SETS CONTAIN NO '              UL0H
         DC    CL32'USER TRAILER LABELS             '              UL0H
         DC    CL8'IEB241I '                                       UL0H
         DC    CL32'INPUT HEADER LABELS ARE NOT EQUA'              UL0H
         DC    CL32'L                               '              UL0H
         DC    CL8'IEB242I '                                       UL0H
         DC    CL32'INPUT TRAILER LABELS ARE NOT EQU'              UL0H
         DC    CL32'AL                              '              UL0H
         DC    CL8'IEB243I '                                       UL0H
         DC    CL32'I/O ERROR WHILE READING USER INP'              UL0H
         DC    CL32'UT HEADER LABEL ON SYSUT1       '              UL0H
         DC    CL8'IEB244I '                                       UL0H
         DC    CL32'I/O ERROR WHILE READING USER INP'              UL0H
         DC    CL32'UT HEADER LABEL ON SYSUT2       '              UL0H
         DC    CL8'IEB245I '                                       UL0H
         DC    CL32'I/O ERROR WHILE READING USER INP'              UL0H
         DC    CL32'UT TRAILER LABEL ON SYSUT1      '              UL0H
         DC    CL8'IEB246I '                                       UL0H
         DC    CL32'I/O ERROR WHILE READING USER INP'              UL0H
         DC    CL32'UT TRAILER LABEL ON SYSUT2      '              UL0H
         DS    72X                                                 ULVS
         DS    72X                                                 ULVS
         DC    CL8'IEB249I '                                       UL0H
         DC    CL32'NO RECORDS ARE COMPARED, DATA=ON'              UL0H
         DC    CL32'LY                              '              UL0H
         DC    CL8'IEB250I '                                       UL0H
         DC    CL32'USER LABEL IS NOT SUPPORTED BY P'              UL0H
         DC    CL32'ARTITIONED DATA SET             '              UL0H
         DC    CL8'IEB251I '                                       VS0H
         DC    CL32'INCOMPATIBLE MAXIMUM LOGICAL REC'              VS0H
         DC    CL32'ORD LENGTH.                     '              VS0H
         DC    CL8'IEB252I '                                       VS0H
         DC    CL32'KEYED DATA SETS. ONE CONTAINS VS'              VS0H
         DC    CL32' RECORDS, THE OTHER ONE DOES NOT'              VS0H
         DC    CL8'IEB253I '                                       VS0H
         DC    CL32'RECORDS ARE COMPARED AT PHYSICAL'              VS0H
         DC    CL32' BLOCK LEVEL                    '              VS0H
         DC    CL8'IEB254I '                                       VS0H
         DC    CL32'CORRESPONDING BLOCK LENGTH ARE N'              VS0H
         DC    CL32'OT EQUAL                        '              VS0H
         DC    CL8'IEB255I '                                       VS0H
         DC    CL32'CORRESPONDING RECORD LENGTH ARE '              VS0H
         DC    CL32'NOT EQUAL                       '              VS0H
         DC    CL8'IEB256I '                                       VS0H
         DC    CL32'IEBCOMPR DOES NOT COMPARE PARTIT'              VS0H
         DC    CL32'IONED DATA SETS WITH VS RECFM   '              VS0H
         DC    CL8'IEB257I '                                       UL0H
         DC    CL32'JOB TERMINATED AFTER EXIT FOR US'              UL0H
         DC    CL32'ER VOLUME SWITCH LABEL PROCESS  '              UL0H
         DC    CL8'IEB258I '                                       UL0H
         DC    CL32'USER LABELS NOT COMPARED, UNABLE'              UL0H
         DC    CL32' TO TAKE EXIT FOR ONE DATA SET  '              UL0H
         DC    CL8'IEB259I '                                       SA0I
         DC    CL32'   INVALID KEYWORD IN OR BEFORE '              SA0I
         DC    CL32'COLUMN                          '              SA0I
         DC    CL8'IEB260I '                                       SA0I
         DC    CL32'   MISSING COMMAND IN OR BEFORE '              SA0I
         DC    CL32'COLUMN                          '              SA0I
         DC    CL8'IEB261I '                                       SA0I
         DC    CL32' INVALID PARAMETER IN OR BEFORE '              SA0I
         DC    CL32'COLUMN                          '              SA0I
         DC    CL8'IEB262I '                                       SA0I
         DC    CL32'   MISSING KEYWORD IN OR BEFORE '              SA0I
         DC    CL32'COLUMN                          '              SA0I
         DC    CL8'IEB263I '                                       SA0I
         DC    CL32' MISSING PARAMETER IN OR BEFORE '              SA0I
         DC    CL32'COLUMN                          '              SA0I
         DC    CL8'IEB264I '                                       SA0I
         DC    CL32'FIRST CONTROL CARD IS NOT "COMPA'              SA0I
         DC    CL32'RE"                             '              SA0I
         DC    CL8'IEB265I '                                       SA0I
         DC    CL32'   INVALID COMMAND IN OR BEFORE '              SA0I
         DC    CL32'COLUMN                          '              SA0I
         DC    CL8'IEB266I '                                       SA0I
         DC    CL32'CONTINUATION CARD BEGINS IN WRON'              SA0I
         DC    CL32'G COLUMN                        '              SA0I
IOERR    DC    CL8'IEB267I '                                     A27718
         DC    CL32' THIS IS I/O ERROR MSG, MSG CONT'            A27718
         DC    CL32' EXTS PROVIDED BY SYNADAF       '            A27718
          END
