*                                                                     *
*  TITLE 'IEBDGMSG'   DATA GENERATOR MESSAGE MODULE                   *
*                                                                     *
* STATUS CHANGE LEVEL  0                                              *
*                                                                     *
* FUNCTION: TO PRINT MESSAGES,CONTROL CARD IMAGES,FLAG MESSAGES WHILE *
*           KEEPING A CORRECT COUNT OF PAGES . LINECT FROM PARM INFO  *
*           HONORED.CHANNEL 12 IS TESTED FIRST AND A NEW HEADING      *
*           PRINTED WHEN NECESSARY.OPERATOR MUST HAVE CORRECT CARRIAGE*
*           CONTROL TAPE INSTALLED.                                   *
*                                                                     *
* ENTRY POINT IEBDGMSG THE CSECT NAME OF THIS MODULE .                *
* CONTROL RECEIVED AS A RESULT OF A LINK FROM IEBDG                   *
*                                                                     *
* INPUT:                                                              *
*        1. COMMON AREA ( A DYNAMIC AREA GOT BY THE IEBDG MODULE)     *
*        2. REG 5-REGISTER CONTAINING COMMON AREA ADDRESS             *
*        3. MS - A TWO BYTE AREA IN COMMON WHICH CONTAINS:            *
*              A- THE NUMBER INDICATING WHICH MESSAGE TO PRINT        *
*              B- THE NUMBER 30 INDICATES CONTROL CARD IMAGE WANTED   *
*                  WHICH IS ACCESSED AT LABEL-INBUFA1                 *
*        4. LINECT -A FOUR BYTE AREA IN COMMON WHICH CONTAINS THE     *
*                   BINARY LINE COUNT OF 58 AS A DEFAULT OR THE LINE  *
*                   COUNT WHICH COMES FROM PARM INFORMATION           *
*        5. PAGENO -A FOUR BYTE AREA IN COMMON WHICH CONTAINS THE     *
*                   EBCDIC PAGE NUMBER 1 AS A DEFAULT OR THE PAGE     *
*                   NUMBER FROM INVOCATION IF PRESENT.                *
*        6. SYSP  THE NAME BY WHICH THE OUTPUT DCB IS ACCESSED        *
*        7. OFLGS BIT 4 THE INDICATION OF THE DCB BEING OPEN          *
*        8. IFLGS BIT 3 CHANNEL NINE INDICATOR                        *
*        9. IFLGS BIT 4 CHANNEL TWELVE INDICATOR                      *
*        10.  FLAGSW BIT 1 FLAG INDICATOR                             *
*        11.  FLAGSW BIT 2 HEADING INDICATOR                          *
*                                                                     *
* EXITS- NORMAL RETURN TO THE CALLER (IEBDG)                          *
*                                                                     *
* TABLES-WORKAREAS                                                    *
*                                                                     *
*        MSGPTR -A TABLE OF 30 FOUR BYTE ENTRIES CONTAINING MESSAGE   *
*                ADDRESSES                                            *
*                                                                     *
*        MESSAGES-ALL 121 BYTES LONG CONTAINING STANDARD MESSAGE      *
*                 IDENTIFIERS-  AS  IEB701I                           *
*                                                                     *
*        Q - THE WORKAREA USED WHEN CONVERTING,PACKING,ETC WHICH IS   *
*           ACCESSED IN COMMON AREA                                   *
*                                                                    *
* ATTRIBUTES--REFRESHIBLE,REENTRANT,REUSEABLE                         *
***********************************************************************
*    NEW MODULE, RELEASE 17.                                       DG0H
*CA1/A5                                          (ORG)@XA20990,@ZA33694
         LCLA  &T,&SPN                                            0003
.@001    ANOP                                                     0003
IEBDGMSG CSECT ,                                                  0003
         ST    @E,12(0,@D)                                        0003
         STM   @0,@8,20(@D)                                       0003
         STM   @A,@C,60(@D)                                       0003
         BALR  @B,0                                               0003
@PSTART  DS    0H                                                 0003
         USING @PSTART+00000,@B                                   0003
         L     @0,@SIZ001                                         0003
         GETMAIN  R,LV=(0)                                        0003
         LR    @C,@1                                              0003
         USING @DATD+00000,@C                                     0003
         LM    @0,@1,20(@D)                                       0003
         XC    @TEMPS(@L),@TEMPS                                  0003
         ST    @D,@SAV001+4                                       0003
         LA    @F,@SAV001                                         0003
         ST    @F,8(0,@D)                                         0003
         LR    @D,@F                                              0003
*  GEN ( EJECT);
          EJECT
         DS    0H
*  /*******************************************************************
*  /**                                                                *
*  /**                  ENTRY IS AT THIS POINT                        *
*  /**                                                                *
*  /*******************************************************************
*  GEN;                                                     /*@ZA33694*
         B     MODULEVL                                    /*@ZA33694*/
         DC    C'IEBDGMSG-OZ33694'                         /*@ZA33694*/
MODULEVL DS    0H                                          /*@ZA33694*/
         DS    0H
*  /*******************************************************************
*  /**                                                                *
*  /**    IF THE DATA GENERATOR OUTPUT DCB IS NOT OPEN,CONTROL RETURNS*
*  /** TO THE BASE MODULE.                                            *
*  /**                                                                *
*  /*******************************************************************
*               DCBPTR = ADDR(SYSP) /** PICK UP SYSP ADDR **/;
         LA    @F,20(0,@5)                                        0067
         ST    @F,300(0,@5)                                       0067
*         IF OFLGS(4) = '1'B THEN GO TO MSG01 /**BR IF DCB OPEN **/;
         L     @1,300(0,@5)
         TM    48(@1),B'00010000'                                 0068
         BC    01,MSG01                                           0069
*           RETURN        /* IF NOT RETURN*/;
         BC    15,@EL01                                           0070
*  /*******************************************************************
*  /**                                                                *
*  /**    THE COMMUNICATION POINTER MS WILL CONTAIN THE NUMBER OF THE *
*  /** MESSAGE TO BE PRINTED.THE HEADING MSG IS INDICATED FROM TWO    *
*  /** PLACES 1. THE BASE MODULE WHEN IT IS FIRST ENTERED AS MS = 1   *
*  /**        2. THIS MODULE AFTER A PAGE IS FILLED AS INDICATED BY   *
*  /**           LINE COUNT OR CHANNEL 12.                            *
*  /** WHEN MS = 30 WE PRINT A CARD IMAGE FROM THE INPUT.             *
*  /** ANY OTHER NUMBER,THE MESSAGE IS TAKEN FROM THIS MODULE.MESSAGES*
*  /** ARE CARRIED AS CONSTANTS OF 121 BYTES LONG.                    *
*  /**    *****                                                       *
*  /**    *****                                                       *
*  /**          MESSAGE 27 MAY NEVER BE CHANGED.THIS IS USED FOR ERROR*
*  /**          FLAGGING.                                             *
*  /**    *****                                                       *
*  /**    *****                                                       *
*  /**                                                                *
*  /*******************************************************************
*  MSG01:;
*  /*******************************************************************
*  /**                                                                *
*  /**    WHEN A HEADING MESSAGE IS INDICATED A BRANCH IS TAKEN TO    *
*  /** MSG03 TO PROCESS THE MESSAGE                                   *
*  /**                                                                *
*  /*******************************************************************
*         IF MS = 1 THEN GO TO MSG03 /*IF HDNG MSG BR TO SET PAGENO*/;
MSG01    LA    @F,1                                               0072
         CH    @F,406(0,@5)                                       0072
         BC    08,MSG03                                           0073
*         PARM = SYNAD;        /**SAVE DCBIOBL AND SYNAD IN PARM**/
         MVC   12(4,@5),SYNAD                                     0074
*         SYNAD = ADDR(ERRORS); /**PLACE MSG SYNAD ADDRESS IN DCB**/
         LA    @F,ERRORS                                          0075
         ST    @F,SYNAD                                           0075
*  /*******************************************************************
*  /**                                                                *
*  /**    THIS SECTION TESTS FOR AN INDICATION OF CHANNEL 12 BEING ON.*
*  /** A BRANCH IS TAKEN TO MSG03 FOR PRINTING OF A HEADER MSG IF ON. *
*  /**                                                                *
*  /*******************************************************************
*               IFLGS(3) = '0'B /*TURNS OFF CH 9 INDICATOR*/;
         L     @1,300(0,@5)
         NI    44(@1),B'11011111'                                 0076
*  GEN ( EJECT);
          EJECT
         DS    0H
*         IF IFLGS(4) = '1'B THEN DO /*IS CH 12 ON */;
         L     @1,300(0,@5)
         TM    44(@1),B'00010000'                                 0078
         BC    12,@9FF                                            0078
*               IFLGS(4) = '0'B /*IF SO TURN OFF CH 12*/;
         NI    44(@1),B'11101111'                                 0080
*               GO TO MSG03; /* BRANCH */
         BC    15,MSG03                                           0081
*         END;
*  /*******************************************************************
*  /**                                                                *
*  /**    IF PAGE IS FULL AS INDICATED BY LINECT AND LINECTR BEING    *
*  /** EQUAL A BRANCH IS TAKEN TO MSG03 TO PRINT A HEADER             *
*  /**                                                                *
*  /*******************************************************************
*         IF LINECT = LINECTR THEN GO TO MSG03 /* IS LINECTR AT MAX*/;
@9FF     L     @F,8(0,@5)                                         0083
         C     @F,4(0,@5)                                         0083
         BC    08,MSG03                                           0084
*  /*******************************************************************
*  /**                                                                *
*  /**    THIS SECTION BRANCHES TO MSG04 IF PRINTING OF A CONTROL     *
*  /** CARD IMAGE IS DESIRED.                                         *
*  /**                                                                *
*  /*******************************************************************
*  MSG02:;
*         IF MS = 30 THEN GO TO MSG04 /*BR TO PICK UP ADDR IF CNTRL*/;
MSG02    LA    @F,30                                              0086
         CH    @F,406(0,@5)                                       0086
         BC    08,MSG04                                           0087
*  /*******************************************************************
*  /**                                                                *
*  /**    THIS SECTION BRANCHES TO MSG05 IF ERROR FLAGGING IS DESIRED *
*  /** IF ERROR FLAGGING IS NOT INDICATED BY FIRST BIT IN FLAG SWITCH *
*  /** A MESSAGE IS INDICATED.THE MESSAGE ADDRESS IS THEN PICKED UP   *
*  /** AND A BRANCH TAKEN TO MSG06 TO 'PUT'THE MESSAGE ON THE SYSP DCB*
*  /**                                                                *
*  /*******************************************************************
*         IF FLAGSW(1) = '1'B THEN GO TO MSG05 /*IS FLAGSW ON*/;
         TM    566(@5),B'10000000'                                0088
         BC    01,MSG05                                           0089
*               R0 = MSGPTR(MS) /* PICK UP MSG ADDRESS*/;
         LH    @1,406(0,@5)                                       0090
         SLA   @1,2                                               0090
         L     @0,MSGPTR-4(@1)                                    0090
*  /*******************************************************************
*  /** THIS SECTION WILL CHECK FOR COMPLETION CODES IF MESSAGE NUMBER *
*  /** 29 IS INDICATED. THE WORD SUCCESSFUL WILL BE BLANKED OUT FOR   *
*  /** CODES OTHER THAN ZERO AND THE PROPER CODE PLACED WITHIN THE    *
*  /** MESSAGE.CONTROL IS THEN TRANSFERRED TO LABEL MSG06 TO INITIATE *
*  /** PRINTING OF THE MESSAGE                                        *
*  /*******************************************************************
*         IF MS = 29 THEN DO   /** IF MSG 29 THEN DO BELOW**/;
         LA    @F,29                                              0091
         CH    @F,406(0,@5)                                       0091
         BC    07,@9FE                                            0091
*         IF CONCODE = '0000'X THEN GO TO MSG06 /** BRANCH IF 0 CODE **
         L     @F,@X3                                             0093
         CH    @F,306(0,@5)                                       0093
         BC    08,MSG06                                           0094
*         R0 = ADDR(MESSAGE);
         LA    @0,668(0,@5)                                       0095
*         MESSAGE = M29;
         MVC   668(121,@5),M29                                    0096
*         MESSAGE(55:66) = ' ';
         MVI   722(@5),C' '                                       0097
         MVC   723(11,@5),722(@5)                                 0097
*         IF CONCODE = '000C'X THEN
         L     @F,@X5                                             0098
         CH    @F,306(0,@5)                                       0098
         BC    07,@9FD                                            0098
*         DO;
*         MESSAGE(97:102) = 'TWELVE';
         MVC   764(6,@5),@C6                                      0100
*         GO TO MSG06          /** BRANCH TO PRINT MESSAGE**/;
         BC    15,MSG06                                           0101
*         END;
*         IF CONCODE = '0004'X THEN DO /**DO BELOW IF FOUR**/;
@9FD     L     @F,@X7                                             0103
         CH    @F,306(0,@5)                                       0103
         BC    07,@9FC                                            0103
*         MESSAGE(97:100) = 'FOUR';
         MVC   764(4,@5),@C8                                      0105
*               GO TO MSG06    /** BRANCH TO PRINT MESSAGE **/;
         BC    15,MSG06                                           0106
*                                   END;
*         IF CONCODE = '0008'X THEN DO /** IF 8 DO BELOW**/;
@9FC     L     @F,@X9                                             0108
         CH    @F,306(0,@5)                                       0108
         BC    07,@9FB                                            0108
*         MESSAGE(97:101) = 'EIGHT';
         MVC   764(5,@5),@C10                                     0110
*               GO TO MSG06    /** BRANCH TO PRINT MESSAGE**/;
         BC    15,MSG06                                           0111
*                                    END;
*         IF CONCODE = '0010'X THEN DO /** IF 16 DO BELOW**/;
@9FB     L     @F,@X11                                            0113
         CH    @F,306(0,@5)                                       0113
         BC    07,@9FA                                            0113
*         MESSAGE(97:103) = 'SIXTEEN';
         MVC   764(7,@5),@C12                                     0115
*                                  END;
*                         END;
*               GO TO MSG06 /* BRANCH TO PICK UP DCB ADDRESS*/;
         BC    15,MSG06                                           0118
*  /*******************************************************************
*  /**    THIS SECTION IS ENTERED WHEN A HEADING IS DESIRED.THE       *
*  /** LINECTR IS RESTORED TO ZERO AND THE INTERNAL HEADING SWITCH,   *
*  /** SECOND BIT OF FLAG SWITCH,IS TURNED ON.THE HEADING MESSAGE IS  *
*  /** THEN MOVED INTO THE COMMUNICATION AREA(ADDRESSED BY REG5) FOR  *
*  /** PURPOSES OF REENTRANTCY.AFTER THE PAGENO IS MOVED INTO THE     *
*  /** MESSAGE,THE MSG ADDRESS IS PICKED UP AND A BRANCH TAKEN TO     *
*  /** MSG06 TO PUT THE MESSAGE.                                      *
*  /**                                                                *
*  /*******************************************************************
*  GEN ( EJECT);
          EJECT
         DS    0H
*  MSG03:;
*               LINECTR = 0     /* RESTORE COUNT TO ZERO */;
MSG03    SR    @F,@F                                              0121
         ST    @F,8(0,@5)                                         0121
*               FLAGSW(2) = '1'B /* SET HEADING SW */;
         OI    566(@5),B'01000000'                                0122
*               R1 = ADDR(M1) /*PICK UP HDNG ADDRESS*/;
         LA    @1,M1                                              0123
*               /** MOVE HEADING MESSAGE TO REENTRANT AREA**/
*         GEN ( MVC MESSAGE(121,R5),0(R1));
          MVC MESSAGE(121,R5),0(R1)
         DS    0H
*         R1 = ADDR(MESSAGE)   /** PICK UP HEADER LINE ADDRESS**/;
         LA    @1,668(0,@5)                                       0125
*            /* MOVE PAGE NO TO HEADING MESSAGE*/
*         GEN ( MVC 112(4,R1),PAGENO(R5));
          MVC 112(4,R1),PAGENO(R5)
         DS    0H
*         R0 = ADDR(MESSAGE)   /** PICK UP HEADER LINE ADDRESS**/;
         LA    @0,668(0,@5)                                       0127
*               GO TO MSG06       /* BRANCH TO PICK UP DCB ADDRESS */;
         BC    15,MSG06                                           0128
*  /*******************************************************************
*  /**                                                                *
*  /**    THIS SECTION PICKS UP THE ADDRESS OF THE CONTROL CARD IMAGE *
*  /** FROM THE REENTRANT COMMUNICATION AREA AND BRANCHES TO MSG06 TO *
*  /** PUT THE CARD IMAGE UPON SYSP.                                  *
*  /**                                                                *
*  /*******************************************************************
*  MSG04:;
*               R0 = ADDR(INBUFA1)  /*PICK UP CONTROL CARD ADDRESS*/;
MSG04    LA    @0,408(0,@5)                                       0130
*               GO TO MSG06        /* BR TO PICK UP DCB ADDRESS*/;
         BC    15,MSG06                                           0131
*  GEN ( EJECT);
          EJECT
         DS    0H
*  /*******************************************************************
*  /**                                                                *
*  /**    THIS SECTION PICKS UP THE FLAG MESSAGE ADDRESS AND MOVES    *
*  /** THE MESSAGE TO THE COMMUNICATION AREA.AT THIS TIME REG 9 IS    *
*  /** POINTING AT A SPOT WITHIN THE CARD IMAGE.REG 9 HAS BEEN USED AS*
*  /** A SCAN POINTER BY SOME OTHER MODULE.THIS OTHER MODULE HAS      *
*  /** DETECTED AN ERROR OF SOME KIND AND HAS INDICATED A DESIRE FOR  *
*  /** ERROR FLAGGING BY TURNING ON THE FIRST BIT OF THE FLAG SWITCH. *
*  /** THE POSITION OF THE ERROR FLAG IS DETERMINED BY RESOLVING THE  *
*  /** POSITION OF REG 9 IN RELATION TO THE START OF THE CONTROL CARD *
*  /** IMAGE.ONCE DETERMINED THE WORD -- ERROR -- IS PLACED IN THE    *
*  /** MESSAGE AND BRANCH POINT MSG06 IS ENTERED FOR OUTPUTING THE    *
*  /** MESSAGE.THE 'E' OF THE WORD ERROR WILL LINE UP EXACTLY UNDER   *
*  /** THE ERROR IN THE CONTROL CARD AS THE CONTROL CARD IMAGE WAS    *
*  /** JUST PLACED UPON THE OUTPUT DATA SET.                          *
*  /**                                                                *
*  /*******************************************************************
*  MSG05:;
*               R1 = MSGPTR(27)     /*PICK UP FLAG MSG ADDRESS*/;
MSG05    L     @1,MSGPTR+104                                      0134
*  GEN ( MVC MESSAGE(121,R5),0(R1));
          MVC MESSAGE(121,R5),0(R1)
         DS    0H
*         R1 = ADDR(MESSAGE)   /** PICK UP HEADER LINE ADDRESS**/;
         LA    @1,668(0,@5)                                       0136
*               R8 = R9 - ADDR(INBUFA) /* RESOLVE OFFSET IN INBUF*/;
         LA    @F,418(0,@5)                                       0137
         LCR   @F,@F                                              0137
         AR    @F,@9                                              0137
         LR    @8,@F                                              0137
*               R1 = R1 + R8 + 10 /* RESOLVE ADDRESS IN MESSAGE*/;
         LA    @F,10                                              0138
         AR    @F,@8                                              0138
         AR    @1,@F                                              0138
*         R1 -> COMMON(1:5) = 'ERROR' /* PLACE FLAG IN MESSAGE*/;
         MVC   0(5,@1),@C13                                       0139
*         R0 = ADDR(MESSAGE)   /** PICK UP HEADER LINE ADDRESS**/;
         LA    @0,668(0,@5)                                       0140
*  GEN ( EJECT);
          EJECT
         DS    0H
*  /*******************************************************************
*  /**                                                                *
*  /**    THIS SECTION WILL ISSUE THE DATA MANAGEMENT MACRO 'PUT'.    *
*  /** UPON ENTRY REG 0 CONTAINS THE ADDRESS OF THE WORKAREA. REG 1   *
*  /** WILL BE LOADED WITH THE ADDRESS OF THE SYSP DCB.               *
*  /**                                                                *
*  /*******************************************************************
*  MSG06:;
*               R1 = ADDR(SYSP)    /* PICK UP DCB ADDRESS*/;
MSG06    LA    @1,20(0,@5)                                        0143
*         GEN ( PUT (1),(0));
          PUT (1),(0)
         DS    0H
*  /*******************************************************************
*  /**                                                                *
*  /**    THE LINECTR IS NOW INCREMENTED BY ONE.IF A HEADING WAS JUST *
*  /** 'PUT' A BRANCH IS TAKEN TO MSG07 FOR FURTHER PROCESSING.IF AN  *
*  /** ERROR FLAG WAS JUST 'PUT' A BRANCH IS TAKEN TO MSG08 FOR       *
*  /** FURTHER PROCESSING,OTHERWISE CONTROL RETURN TO THE BASE MODULE *
*  /**                                                                *
*  /*******************************************************************
*               LINECTR = LINECTR+ 1 /* ADD 1 TO LINE COUNTER*/;
         LA    @F,1                                               0145
         A     @F,8(0,@5)                                         0145
         ST    @F,8(0,@5)                                         0145
*         IF FLAGSW(2) = '1'B THEN GO TO MSG07 /*BR IF HDNG SW ON*/;
         TM    566(@5),B'01000000'                                0146
         BC    01,MSG07                                           0147
*         IF FLAGSW(1) = '1'B THEN GO TO MSG08 /*IF FLAG ON BRANCH*/;
         TM    566(@5),B'10000000'                                0148
         BC    01,MSG08                                           0149
*         SYNAD = PARM;        /**RESTORE DCBIOBL FOR CLOSE**/
         MVC   SYNAD(4),12(@5)                                    0150
*               RETURN;
         BC    15,@EL01                                           0151
*  GEN ( EJECT);
          EJECT
         DS    0H
*  /*******************************************************************
*  /**                                                                *
*  /**    THIS SECTION IS ENTERED AFTER A HEADING HAS JUST BEEN 'PUT'.*
*  /** THE PAGENO IN THE COMMUNICATION AREA MUST BE INCREMENTED BY ONE*
*  /** THIS IS DONE BY PACKING THE NUMBER,CONVERTING TO BINARY,ADDING *
*  /** ONE,CONVERTING TO DECIMAL,CHANGING THE SIGN TO A PRINTIBLE     *
*  /** CHARACTER AND UNPACKING THE NUMBER BACK TO 'PAGENO'.IF A       *
*  /** HEADING ONLY WAS PRINTED,ONLY CALLED ONCE AS MS = 1,CONTROL    *
*  /** RETURNS TO THE BASE MODULE,OTHERWISE A BRANCH IS TAKEN TO MSG02*
*  /** TO PRINT A CARD IMAGE OR ERROR FLAG.                           *
*  /**                                                                *
*  /*******************************************************************
*  MSG07:;
*               FLAGSW(2) = '0'B    /* TURN OFF HDNG SW */;
MSG07    NI    566(@5),B'10111111'                                0154
*           /* THIS SECTION WILL INCREMENT PAGE NO BY ONE */
*         GEN ( PACK Q(8,R5),PAGENO(4,R5));
          PACK Q(8,R5),PAGENO(4,R5)
         DS    0H
*         GEN ( CVB 6,Q(0,R5));
          CVB 6,Q(0,R5)
         DS    0H
*         GEN ( LA 6,1(0,6));
          LA 6,1(0,6)
         DS    0H
*         GEN ( CVD 6,Q(0,R5));
          CVD 6,Q(0,R5)
         DS    0H
*               QSIGN = QSIGN | '0F'X /* CHANGE SIGN TO PRINTABLE CHAR*
         OI    223(@5),X'0F'                                      0159
*         GEN ( UNPK PAGENO(4,R5),Q(8,R5));
          UNPK PAGENO(4,R5),Q(8,R5)
         DS    0H
*         IF MS = 1 THEN DO /* IF HDNG MSG BRANCH TO RETURN */;
         LA    @F,1                                               0161
         CH    @F,406(0,@5)                                       0161
*         RETURN;
         BC    08,@EL01                                           0163
*         END;
*               GO TO MSG02 /* BRANCH TO CONTINUE*/;
         BC    15,MSG02                                           0165
*  GEN ( EJECT);
          EJECT
         DS    0H
*  /*******************************************************************
*  /**                                                                *
*  /**    THIS SECTION WILL TURN OFF THE ERROR FLAG INDICATOR,BIT ONE *
*  /** OF FLAG SWITCH,AND BRANCH TO MSG01 FOR FURTHER PROCESSING      *
*  /**                                                                *
*  /*******************************************************************
*  MSG08:;
*               FLAGSW(1) = '0'B   /* TURN OFF FLAG SW*/;
MSG08    NI    566(@5),B'01111111'                                0168
*               GO TO MSG01     /* BR TO TEST FOR CHANNEL 12 */;
         BC    15,MSG01                                           0169
*  ERRORS:;
*         FLUSHSW1 = ON; /**TURN ON FLUSH CAUSES BASE TO GO TO CLEANUP*
ERRORS   MVC   573(1,@5),ON                                       0171
*         SYNAD = PARM;        /**RESTORE DCBIOBL FOR CLOSE**/
         MVC   SYNAD(4),12(@5)                                    0172
*         RETURN;
*  END IEBDGMSG;
@EL01    L     @D,4(0,@D)                                         0174
         LR    @1,@C                                              0174
         L     @0,@SIZ001                                         0174
         FREEMAIN R,LV=(0),A=(1)                                  0174
         L     @E,12(0,@D)                                        0174
         LM    @0,@8,20(@D)                                       0174
         LM    @A,@C,60(@D)                                       0174
         BCR   15,@E                                              0174
@DATA1   EQU   *
@0       EQU   00                  EQUATES FOR REGISTERS 0-15
@1       EQU   01
@2       EQU   02
@3       EQU   03
@4       EQU   04
@5       EQU   05
@6       EQU   06
@7       EQU   07
@8       EQU   08
@9       EQU   09
@A       EQU   10
@B       EQU   11
@C       EQU   12
@D       EQU   13
@E       EQU   14
@F       EQU   15
         DS    0F
@SIZ001  DC    AL1(&SPN)
         DC    AL3(@DATEND-@DATD)
         DS    0F
@X3      DC    X'00000000'
@X5      DC    X'0000000C'
@X7      DC    X'00000004'
@C8      DC    C'FOUR'
@X9      DC    X'00000008'
@X11     DC    X'00000010'
@C6      DC    C'TWELVE'
@C10     DC    C'EIGHT'
@C12     DC    C'SIXTEEN'
@C13     DC    C'ERROR'
         DS    0D
@DATA    EQU   *
R14      EQU   00000014            FULLWORD INTEGER REGISTER
R15      EQU   00000015            FULLWORD INTEGER REGISTER
R0       EQU   00000000            FULLWORD INTEGER REGISTER
R1       EQU   00000001            FULLWORD POINTER REGISTER
R2       EQU   00000002            FULLWORD INTEGER REGISTER
R3       EQU   00000003            FULLWORD INTEGER REGISTER
R4       EQU   00000004            FULLWORD INTEGER REGISTER
R5       EQU   00000005            FULLWORD POINTER REGISTER
R6       EQU   00000006            FULLWORD POINTER REGISTER
R7       EQU   00000007            FULLWORD POINTER REGISTER
R8       EQU   00000008            FULLWORD POINTER REGISTER
R9       EQU   00000009            FULLWORD POINTER REGISTER
COMMON   EQU   00000000            308 BYTE(S) ON DWORD
PAGENO   EQU   COMMON+00000000     4 BYTE(S)
LINECT   EQU   COMMON+00000004     FULLWORD INTEGER
LINECTR  EQU   COMMON+00000008     FULLWORD INTEGER
PARM     EQU   COMMON+00000012     FULLWORD POINTER
REPEATNO EQU   COMMON+00000016     HALFWORD INTEGER
CREATENO EQU   COMMON+00000018     HALFWORD INTEGER
SYSP     EQU   COMMON+00000020     96 BYTE(S)
SYSI     EQU   COMMON+00000116     96 BYTE(S)
Q        EQU   COMMON+00000216     16 BYTE(S) ON DWORD
QFILL    EQU   COMMON+00000216     7 BYTE(S)
QSIGN    EQU   COMMON+00000223     8 BIT(S)
QFILL1   EQU   COMMON+00000224     7 BYTE(S)
QSIGN1   EQU   COMMON+00000231     8 BIT(S)
COUNTER  EQU   COMMON+00000232     FULLWORD POINTER
OPENLIST EQU   COMMON+00000236     8 BYTE(S)
OPTBYTE1 EQU   COMMON+00000236     4 BYTE(S)
OPTBYTE2 EQU   COMMON+00000240     4 BYTE(S)
EXLST    EQU   COMMON+00000244     24 BYTE(S) ON WORD
INHDR    EQU   COMMON+00000244     1 BYTE(S)
INHDR1   EQU   COMMON+00000245     3  BYTE  POINTER ON WORD+1
OUTHDR   EQU   COMMON+00000248     1 BYTE(S)
OUTHDR1  EQU   COMMON+00000249     3  BYTE  POINTER ON WORD+1
INTRL    EQU   COMMON+00000252     1 BYTE(S)
INTRL1   EQU   COMMON+00000253     3  BYTE  POINTER ON WORD+1
OUTTRL   EQU   COMMON+00000256     1 BYTE(S)
OUTTRL1  EQU   COMMON+00000257     3  BYTE  POINTER ON WORD+1
EXITDCB  EQU   COMMON+00000260     1 BYTE(S)
EXITDCB1 EQU   COMMON+00000261     3  BYTE  POINTER ON WORD+1
TOTAL    EQU   COMMON+00000264     1 BYTE(S)
TOTAL1   EQU   COMMON+00000265     3  BYTE  POINTER ON WORD+1
EXLST1   EQU   COMMON+00000268     4 BYTE(S) ON WORD
EDCB1    EQU   COMMON+00000268     1 BYTE(S)
EDCB2    EQU   COMMON+00000269     3  BYTE  POINTER ON WORD+1
EXLST2   EQU   COMMON+00000272     4 BYTE(S) ON WORD
EDCB3    EQU   COMMON+00000272     1 BYTE(S)
EDCB4    EQU   COMMON+00000273     3  BYTE  POINTER ON WORD+1
EXLST3   EQU   COMMON+00000276     4 BYTE(S) ON WORD
EDCB5    EQU   COMMON+00000276     1 BYTE(S)
EDCB6    EQU   COMMON+00000277     3  BYTE  POINTER ON WORD+1
DLRECL   EQU   COMMON+00000280     HALFWORD INTEGER
DBLKSI   EQU   COMMON+00000282     HALFWORD INTEGER
DRECFM   EQU   COMMON+00000284     8 BIT(S)
LEFTOVER EQU   COMMON+00000288     FULLWORD INTEGER
OFFSET   EQU   COMMON+00000292     FULLWORD POINTER
LPTR     EQU   COMMON+00000296     FULLWORD POINTER
DCBPTR   EQU   COMMON+00000300     FULLWORD POINTER
DUMMY    EQU   COMMON+00000304     FULLWORD POINTER
COMMON1  EQU   00000304            236 BYTE(S) ON WORD
SAVEMS   EQU   COMMON1+00000000    HALFWORD INTEGER
CONCODE  EQU   COMMON1+00000002    HALFWORD INTEGER
OUTREC   EQU   COMMON1+00000004    FULLWORD POINTER
CRTABPT  EQU   COMMON1+00000008    FULLWORD POINTER
CURCRTE  EQU   COMMON1+00000012    FULLWORD POINTER
CURCRGM  EQU   COMMON1+00000016    FULLWORD POINTER
CURPIC   EQU   COMMON1+00000020    FULLWORD POINTER
PICCTR   EQU   COMMON1+00000024    FULLWORD INTEGER
EXITTAB  EQU   COMMON1+00000028    FULLWORD POINTER
EXITGM   EQU   COMMON1+00000032    FULLWORD POINTER
CUREXIT  EQU   COMMON1+00000036    FULLWORD POINTER
DELIM    EQU   COMMON1+00000040    4 BYTE(S)
RECREM   EQU   COMMON1+00000044    FULLWORD INTEGER
CURFD    EQU   COMMON1+00000048    FULLWORD POINTER
CUROUT   EQU   COMMON1+00000052    FULLWORD POINTER
SAVE14   EQU   COMMON1+00000056    FULLWORD POINTER
GETMLIST EQU   COMMON1+00000060    16 BYTE(S) ON WORD
GLENGTH  EQU   COMMON1+00000060    FULLWORD INTEGER
ADRLIST  EQU   COMMON1+00000064    FULLWORD POINTER
IND      EQU   COMMON1+00000068    4 BYTE(S)
GCODE    EQU   COMMON1+00000068    1 BYTE(S)
SPOOL    EQU   COMMON1+00000069    1 BYTE(S)
CCODE    EQU   COMMON1+00000070    2 BYTE(S)
GCADDR   EQU   COMMON1+00000072    FULLWORD POINTER
FIRSTGMO EQU   COMMON1+00000076    FULLWORD POINTER
CURRGMO  EQU   COMMON1+00000080    FULLWORD POINTER
LASTGMO  EQU   COMMON1+00000084    FULLWORD POINTER
FIRSTGMI EQU   COMMON1+00000088    FULLWORD POINTER
CURRGMI  EQU   COMMON1+00000092    FULLWORD POINTER
LASTGMI  EQU   COMMON1+00000096    FULLWORD POINTER
CONDCODE EQU   COMMON1+00000100    HALFWORD INTEGER
MS       EQU   COMMON1+00000102    HALFWORD INTEGER
INBUFA1  EQU   COMMON1+00000104    121 BYTE(S)
INFILL   EQU   COMMON1+00000104    10 BYTE(S)
INBUFA   EQU   COMMON1+00000114    111 BYTE(S)
DDPTR    EQU   COMMON1+00000228    FULLWORD POINTER
DUMMY1   EQU   COMMON1+00000232    FULLWORD POINTER
COMMON2  EQU   00000536            76 BYTE(S) ON WORD
SWITCH   EQU   COMMON2+00000000    52 BYTE(S)
FDCSW    EQU   COMMON2+00000000    1 BYTE(S)
FDNAMESW EQU   COMMON2+00000001    1 BYTE(S)
FDPCSW   EQU   COMMON2+00000002    1 BYTE(S)
FDFMTSW  EQU   COMMON2+00000003    1 BYTE(S)
FDPLSW   EQU   COMMON2+00000004    1 BYTE(S)
RANGESW  EQU   COMMON2+00000005    1 BYTE(S)
FILLSW   EQU   COMMON2+00000006    1 BYTE(S)
REPSW    EQU   COMMON2+00000007    1 BYTE(S)
INDEXSW  EQU   COMMON2+00000008    1 BYTE(S)
INDNMSW  EQU   COMMON2+00000009    1 BYTE(S)
BQUOTESW EQU   COMMON2+00000010    1 BYTE(S)
PQUOTESW EQU   COMMON2+00000011    1 BYTE(S)
EQUOTESW EQU   COMMON2+00000012    1 BYTE(S)
FDSW     EQU   COMMON2+00000013    1 BYTE(S)
DSDSW    EQU   COMMON2+00000014    1 BYTE(S)
NOGOSW   EQU   COMMON2+00000015    1 BYTE(S)
CREATESW EQU   COMMON2+00000016    1 BYTE(S)
DSDCSW   EQU   COMMON2+00000017    1 BYTE(S)
CRCSW    EQU   COMMON2+00000018    1 BYTE(S)
EXITSW   EQU   COMMON2+00000019    1 BYTE(S)
EODSTOP  EQU   COMMON2+00000020    1 BYTE(S)
DSDNULSW EQU   COMMON2+00000021    1 BYTE(S)
DSDORGSW EQU   COMMON2+00000022    1 BYTE(S)
DSDDDSW  EQU   COMMON2+00000023    1 BYTE(S)
CRTBLK   EQU   COMMON2+00000024    1 BYTE(S)
NAMCSW   EQU   COMMON2+00000025    8 BIT(S)
PICCSW   EQU   COMMON2+00000026    8 BIT(S)
BUFPSW   EQU   COMMON2+00000027    1 BYTE(S)
ENDSW    EQU   COMMON2+00000028    1 BYTE(S)
COMCSW   EQU   COMMON2+00000029    1 BYTE(S)
FLAGSW   EQU   COMMON2+00000030    8 BIT(S)
PAGESW   EQU   COMMON2+00000031    1 BYTE(S)
EPSW     EQU   COMMON2+00000032    1  BYTE  POINTER
SYSISW   EQU   COMMON2+00000033    1 BYTE(S)
SYSPSW   EQU   COMMON2+00000034    1 BYTE(S)
OLDNEWSW EQU   COMMON2+00000035    1 BYTE(S)
FLUSHSW  EQU   COMMON2+00000036    1 BYTE(S)
FLUSHSW1 EQU   COMMON2+00000037    1 BYTE(S)
DSDOSW   EQU   COMMON2+00000038    1 BYTE(S)
DSDISW   EQU   COMMON2+00000039    1 BYTE(S)
QUANSW   EQU   COMMON2+00000040    1 BYTE(S)
PARENSW  EQU   COMMON2+00000041    1 BYTE(S)
REPEATSW EQU   COMMON2+00000042    1 BYTE(S)
FDPLGTH  EQU   COMMON2+00000052    HALFWORD INTEGER
SGCADDR  EQU   COMMON2+00000056    FULLWORD POINTER
FDPTR    EQU   COMMON2+00000060    FULLWORD POINTER
FDPTR1   EQU   COMMON2+00000064    FULLWORD POINTER
FDPTR2   EQU   COMMON2+00000068    FULLWORD POINTER
DUMMY2   EQU   COMMON2+00000072    FULLWORD POINTER
COMMON3  EQU   00000608            188 BYTE(S) ON WORD
FDCTR    EQU   COMMON3+00000000    HALFWORD POINTER
LREMAIN  EQU   COMMON3+00000004    FULLWORD POINTER
COMPCTR  EQU   COMMON3+00000008    FULLWORD POINTER
LMOVED   EQU   COMMON3+00000012    HALFWORD POINTER
U        EQU   COMMON3+00000016    FULLWORD POINTER
PICEND   EQU   COMMON3+00000020    HALFWORD POINTER
CURFDGM  EQU   COMMON3+00000024    FULLWORD POINTER
SWTCH    EQU   COMMON3+00000028    4 BYTE(S) ON WORD
SYSINSEL EQU   COMMON3+00000028    1 BYTE(S)
FIRSTSW  EQU   COMMON3+00000029    1 BYTE(S)
FRSTSW   EQU   COMMON3+00000030    1 BYTE(S)
STOPSW   EQU   COMMON3+00000031    1 BYTE(S)
COPYVAL  EQU   COMMON3+00000032    HALFWORD INTEGER
COPYFD   EQU   COMMON3+00000036    FULLWORD POINTER
COPYFDGM EQU   COMMON3+00000040    FULLWORD POINTER
NAMCTR   EQU   COMMON3+00000044    HALFWORD INTEGER
NAMCTR1  EQU   COMMON3+00000046    HALFWORD INTEGER
INRECSZ  EQU   COMMON3+00000048    HALFWORD POINTER
OUTRECSZ EQU   COMMON3+00000050    HALFWORD POINTER
INRECFM  EQU   COMMON3+00000052    1 BYTE(S)
RECOFFST EQU   COMMON3+00000053    1  BYTE  POINTER
OUTRECFM EQU   COMMON3+00000054    1 BYTE(S)
PICBASE  EQU   COMMON3+00000056    FULLWORD POINTER
MESSAGE  EQU   COMMON3+00000060    121 BYTE(S)
DUMMY3   EQU   COMMON3+00000184    FULLWORD POINTER
OPTIONS  EQU   00000000            256 BYTE(S)
PAGE     EQU   00000000            256 BYTE(S)
DDLST    EQU   00000000            256 BYTE(S)
DCBD     EQU   00000000            280 BYTE(S) ON DWORD
FILL     EQU   DCBD+00000000       26 BYTE(S)
DSORG1   EQU   DCBD+00000026       2 BYTE(S)
DSORG    EQU   DCBD+00000026       8 BIT(S)
FILLER   EQU   DCBD+00000028       8 BYTE(S)
IOBAD    EQU   DCBD+00000028       4 BYTE(S)
BFTEK    EQU   DCBD+00000032       8 BIT(S)
EODAD    EQU   DCBD+00000033       3 BYTE(S)
RECFM    EQU   DCBD+00000036       8 BIT(S)
EXLIST   EQU   DCBD+00000037       3  BYTE  POINTER ON WORD+1
DDNAME   EQU   DCBD+00000040       8 BYTE(S)
FILL1    EQU   DCBD+00000040       2 BYTE(S)
MACRF    EQU   DCBD+00000042       2 BYTE(S)
DEBAD    EQU   DCBD+00000044       4 BYTE(S)
IFLGS    EQU   DCBD+00000044       8 BIT(S)
GETAD    EQU   DCBD+00000048       4 BYTE(S)
OFLGS    EQU   DCBD+00000048       8 BIT(S)
FILL2    EQU   DCBD+00000052       10 BYTE(S)
BLKSI    EQU   DCBD+00000062       HALFWORD INTEGER
FILL3    EQU   DCBD+00000064       18 BYTE(S)
LRECL    EQU   DCBD+00000082       HALFWORD INTEGER
FILL4    EQU   DCBD+00000084       172 BYTE(S)
NEXTDCB  EQU   DCBD+00000256       FULLWORD POINTER
DDNAME1  EQU   DCBD+00000260       8 BYTE(S)
EODSW    EQU   DCBD+00000268       1 BYTE(S)
DCBSW1   EQU   DCBD+00000269       1 BYTE(S)
DCBSW2   EQU   DCBD+00000270       1 BYTE(S)
DCBSW3   EQU   DCBD+00000271       8 BIT(S)
INREC    EQU   DCBD+00000272       FULLWORD POINTER
GMLGTH   EQU   DCBD+00000276       HALFWORD INTEGER
FIELDSEL EQU   DCBD+00000278       1 BYTE(S)
SPARE    EQU   DCBD+00000279       1 BYTE(S)
ON       EQU   *                   1 BYTE(S)
         DC    X'FF'
OFF      EQU   *                   1 BYTE(S)
         DC    X'00'
INBUF    EQU   00000000            80 BYTE(S)
         ORG   @DATA+00000004
MSGPTR   EQU   *                   30*FULLWORD POINTER
         DC    AL4(M1)
         DC    AL4(M2)
         DC    AL4(M3)
         DC    AL4(M4)
         DC    AL4(M5)
         DC    AL4(M6)
         DC    AL4(M7)
         DC    AL4(M8)
         DC    AL4(M9)
         DC    AL4(M10)
         DC    AL4(M11)
         DC    AL4(M12)
         DC    AL4(M13)
         DC    AL4(M14)
         DC    AL4(M15)
         DC    AL4(M16)
         DC    AL4(M17)
         DC    AL4(M18)
         DC    AL4(M19)
         DC    AL4(M20)
         DC    AL4(M21)
         DC    AL4(M22)
         DC    AL4(M23)
         DC    AL4(M24)
         DC    AL4(M25)
         DC    AL4(M26)
         DC    AL4(M27)
         DC    AL4(M28)
         DC    AL4(M29)
         DC    AL4(INBUFA)
M1       EQU   *                   121 BYTE(S)
         DC    C'1                              DATA GENERA'
         DC    C'TOR OUTPUT FOR CONTROL CARDS AND MESSAGES '
         DC    C'                      PAGE          '
         DC    00001C' '
M2       EQU   *                   121 BYTE(S)
         DC    C' IEB702I OPERATION WAS NOT DSD,FD,CREATE,R'
         DC    C'EPEAT,OR END.CORRECT AND RERUN'
         DC    00049C' '
M3       EQU   *                   121 BYTE(S)
         DC    C' IEB703I INVALID KEYWORD VALUE.DELIMITER,D'
         DC    C'ESCRIPTOR OR TYPE IS IMPROPER, OR DUPLICAT'
         DC    C'ED'
         DC    00035C' '
M4       EQU   *                   121 BYTE(S)
         DC    C' IEB704I INPUT DDNAME ON CREATE OR FD CARD'
         DC    C' IS NOT SPECIFIED ON DSD CARD'
         DC    00050C' '
M5       EQU   *                   121 BYTE(S)
         DC    C' IEB705I INVALID KEYWORD,POSSIBLE IMBEDDED'
         DC    C' COMMA'
         DC    00073C' '
M6       EQU   *                   121 BYTE(S)
         DC    C' IEB706I NUMBER SPECIFIED IS LARGER THAN 3'
         DC    C'2,767 OR EXCEEDS MACHINE CAPACITY (2,147,4'
         DC    C'83,647).'
         DC    00029C' '
M7       EQU   *                   121 BYTE(S)
         DC    C' IEB707I FD NAME ON CREATE CARD IS NOT PRE'
         DC    C'VIOUSLY DEFINED BY AN FD CARD OR IS NOT AS'
         DC    C'SOCIATED WITH CORRECT DCB'
         DC    00012C' '
M8       EQU   *                   121 BYTE(S)
         DC    C' IEB708I PICTURE LENGTH TOO LARGE FOR CONV'
         DC    C'ERSION'
         DC    00073C' '
M9       EQU   *                   121 BYTE(S)
         DC    C' IEB709I USER EXIT ROUTINE RETURNED AN INV'
         DC    C'ALID RETURN CODE.'
         DC    00062C' '
M10      EQU   *                   121 BYTE(S)
         DC    C' IEB710I UNABLE TO GET ENOUGH SPACE TO PRO'
         DC    C'CESS REMAINING CONTROL CARDS'
         DC    00051C' '
M11      EQU   *                   121 BYTE(S)
         DC    C' IEB711I KEYWORD VALUE NOT FOLLOWED BY A B'
         DC    C'LANK OR COMMA.'
         DC    00065C' '
M12      EQU   *                   121 BYTE(S)
         DC    C' IEB712I CONTROL CARD NAME OR KEYWORD VALU'
         DC    C'E EXCEEDS EIGHT CHARACTERS.'
         DC    00052C' '
M13      EQU   *                   121 BYTE(S)
         DC    C' IEB713I FLAGGED KEYWORD IS NOT COMPATIBLE'
         DC    C' WITH A PRECEDING KEYWORD.'
         DC    00053C' '
M14      EQU   *                   121 BYTE(S)
         DC    C' IEB714I REPEAT CARD ERROR OR REQUIRED NUM'
         DC    C'BER OF CREATE CARDS NOT PRESENT'
         DC    00048C' '
M15      EQU   *                   121 BYTE(S)
         DC    C' IEB715I NAME AND/OR LENGTH OR QUANTITY SP'
         DC    C'ECIFICATION(S) OMITTED FROM FD AND/OR REPE'
         DC    C'AT CARD.'
         DC    00029C' '
M16      EQU   *                   121 BYTE(S)
         DC    C' IEB716I PICTURE STRING OR FD FIELD OVERFL'
         DC    C'OWS OUTPUT RECORD OR INPUT FIELD SELECTED '
         DC    C'OVERRUNS INPUT WORKAREA'
         DC    00014C' '
M17      EQU   *                   121 BYTE(S)
         DC    C' IEB717I INPUT RECORD SIZE EXCEEDS SPECIFI'
         DC    C'ED OUTPUT RECORD SIZE.'
         DC    00057C' '
M18      EQU   *                   121 BYTE(S)
         DC    C' IEB718I DSD CONTROL CARD MUST BE FIRST CA'
         DC    C'RD OF SET'
         DC    00070C' '
M19      EQU   *                   8 BYTE(S)
         DC    C' IEB719I'
M20      EQU   *                   121 BYTE(S)
         DC    C' IEB720I BLANK DOES NOT FOLLOW OPERATION O'
         DC    C'R CONTROL CARD NAME.'
         DC    00059C' '
M21      EQU   *                   121 BYTE(S)
         DC    C' IEB721I KEYWORD,KEYWORD VALUE OR DELIMITE'
         DC    C'R,IS MISSING OR EXTENDS INTO COLUMN 72'
         DC    00041C' '
M22      EQU   *                   8 BYTE(S)
         DC    C' IEB722I'
M23      EQU   *                   121 BYTE(S)
         DC    C' IEB723I PICTURE PARAMETER IS NOT FOLLOWED'
         DC    C' BY A BLANK OR COMMA'
         DC    00059C' '
M24      EQU   *                   121 BYTE(S)
         DC    C' IEB724I UNABLE TO OPEN DATA SET.LOOK FOR '
         DC    C'CONFLICTING VALUES OR MISSING DD CARD'
         DC    00042C' '
M25      EQU   *                   121 BYTE(S)
         DC    C' IEB725I  A DUPLICATE DSD CONTROL CARD HAS'
         DC    C' BEEN FOUND.CHECK FOR MISSING END CARD'
         DC    00041C' '
M26      EQU   *                   121 BYTE(S)
         DC    C' IEB726I EXEC STATEMENT PARM PARAMETER IS '
         DC    C'CODED INCORRECTLY'
         DC    00062C' '
M27      EQU   *                   121 BYTE(S)
         DC    C' IEB727I'
         DC    00113C' '
M28      EQU   *                   121 BYTE(S)
         DC    C' IEB728I INPUT STREAM FLUSHED FROM THIS PO'
         DC    C'INT LRECL,BLKSIZE,OR RECFM INCORRECT IN SY'
         DC    C'SIN, SYSPRINT, OUTPUT OR INPUT DCB'
         DC    00003C' '
M29      EQU   *                   121 BYTE(S)
         DC    C'1IEB700I                     DATA GENERATI'
         DC    C'ON HAS BEEN SUCCESSFULLY COMPLETED COMPLET'
         DC    C'ION CODE IS ZERO'
         DC    00021C' '
         ORG   @DATA
         DS    00003407C
@L       EQU   1
@DATD    DSECT
@SAV001  EQU   @DATD+00000000      72 BYTE(S) ON WORD
OPTPTR   EQU   @DATD+00000072      FULLWORD POINTER
PGPTR    EQU   @DATD+00000076      FULLWORD POINTER
SYNAD    EQU   @DATD+00000080      FULLWORD INTEGER
         DS    00000084C
@TEMPS   DS    0F
         DS    C
@DATEND  EQU   *
IEBDGMSG CSECT ,
@9FE     EQU   MSG06
@9FA     EQU   MSG06
@9F9     EQU   MSG02
         END   IEBDGMSG
