 TITLE  'IEBMLT01 - MODULE LISTS TABLE'
*  /* START OF SPECIFICATIONS ****
*
*01* MODULE NAME = IEBMLT01
*
*01* DESCRIPTIVE NAME = Module Lists Table (MLT) for the 1287 device
*
*    COPYRIGHT=  N/A
*
*    STATUS=  OS/VS2  EMI2220
*
*01* FUNCTION =
*      IEBMLT01 is a load module that contains the list of
*      nucleus device dependent module names and the list of
*      Link Pack Area (LPA) device dependent module names
*      required for the 1287  device.
*
*02*   OPERATION =
*      IEBMLT01 will be loaded into the IPL work space, during an
*      IPL, if the 1287 device was defined in the I/O configuration
*      specified for the IPL. This will cause the listed nucleus
*      modules to be loaded from SYS1.NUCLEUS into the nucleus
*      region and cause the listed LPA modules to be loaded from
*      SYS1.LINKLIB into the LPA.
*
*03*     RECOVERY OPERATION =  N/A
*
*01* NOTES =
*
*02*   DEPENDENCIES = None
*
*02*   RESTRICTIONS = None
*
*02*   REGISTER CONVENTIONS = N/A
*
*02*   PATCH LABEL = There is no patch label. However, the IOSDMLT
*                    macro builds unused entries at the end of the
*                    nucleus and LPA module lists. Additional modules
*                    can be zapped into these entries and the
*                    appropriate module list count can be incremented.
*
*01* MODULE TYPE = Table
*
*02*   PROCESSOR = N/A
*
*02*   MODULE SIZE = For exact size see assembler listing
*
*02*   ATTRIBUTES =
*
*03*     LOCATION = IPL work space
*
*03*     STATE = N/A
*
*03*     AMODE = N/A
*
*03*     RMODE = N/A
*
*03*     KEY = N/A
*
*03*     MODE = N/A
*
*03*     SERIALIZATION = None
*
*03*     TYPE = N/A
*
*01* MACROS EXECUTABLE = N/A
*
*01* CHANGE ACTIVITY =
* $L0=MICROCR,EMI2220,85220,PDG7:  MICR/OCR reship
*
***** END OF SPECIFICATIONS ******************************************/
* 1287 Optical Reader Nucleus and LPA device support modules
IEBMLT01 IOSDMLT                                                       X
               NUCL=(IECVDDTD,IECVXURS,IECVXURT,IECVOPTK),             X
               LPAL=(IECLMSGU,IGE0011C,IGG019VA,IGG019VB,IGG019VC,     X
               IGG019VD,IGG019VE,IGG019VF,IGG019VG,IGG019VH,IGG019VI,  X
               IGG019VJ,IGG019VK,IGG0197A,IGG0197B)
