         TITLE 'IEBTCR02 - MESSAGE MODULE - INTRODUCTORY COMMENTARY'
*                                                                     *
*TITLE 'IEBTCR02' - MESSAGE MODULE                                    *
*                                                                     *
*STATUS:  CHANGE LEVEL 000                                            *
*                                                                     *
*FUNCTION/OPERATION:  THIS MODULE CONTAINS LIST-FORM WTO MACRO-       *
*   INSTRUCTIONS FOR ALL IEBXXXX MESSAGES. IN ADDITION IT CONTAINS    *
*   THE SYSPRINT PAGE HEADING, THE UTILITY COMPLETION MESSAGE, AND    *
*   A DUMMY WTO FOR OUTPUTTING OF SYNAD MESSAGES.                     *
*                                                                     *
*ENTRY POINTS:                                                        *
*                                                                     *
*        IEBTCR02 - ADDRESS OF POINTER TABLE                          *
*                                                                     *
*   THE MODULE IS BROUGHT IN BY THE DRIVER (IEBTCRIN) BY A LOAD       *
*   MACRO-INSTRUCTION.                                                *
*                                                                     *
*        LOAD EP=IEBTCR02                                             *
*                                                                     *
*INPUT:  N/A                                                          *
*                                                                     *
*OUTPUT:  N/A                                                         *
*                                                                     *
*EXTERNAL ROUTINES:  N/A                                              *
*                                                                     *
*EXITS:  N/A                                                          *
*                                                                     *
*TABLES/WORK AREAS:                                                   *
*                                                                     *
*   1) MSGTAB - THIS TABLE CONTAINS FIXED-LENGTH POINTERS TO THE      *
*      VARIABLE-LENGTH MESSAGE TABLE.  EACH ENTRY CONSISTS OF A ONE-  *
*      BYTE MESSAGE LENGTH AND A 3-BYTE MESSAGE ADDRESS.              *
*                                                                     *
*   2) MESSAGE - THIS TABLE CONTAINS THE ACTUAL MESSAGES IN THE FORM  *
*      OF LIST-FORM WTO MACRO-INSTRUCTIONS AND DC'S.                  *
*                                                                     *
*ATTRIBUTES:  SERIALLY RE-USABLE. NOT RE-ENTRANT.                     *
*                                                                     *
*NOTES:  THIS MODULE IS USED IN CONJUNCTION WITH THE MESSAGE WRITER   *
*   (TCR220) OF THE DRIVER MODULE (IEBTCRIN). IF A MESSAGE IS TO BE   *
*   OUTPUT TO SYSPRINT, THE MESSAGE IS EXTRACTED FROM THE WTO AND     *
*   MOVED TO A GETMAINED DATA AREA.  IF IT IS TO BE OUTPUT TO THE     *
*   CONSOLE, AN EXECUTE-FORM MACRO-INSTRUCTION IS ISSUED BY THE       *
*   MESSAGE WRITER.                                                   *
*                                                                     *
*   THE OPERATION OF THIS MODULE DOES NOT DEPEND UPON A PARTICULAR    *
*   INTERNAL REPRESENTATION OF THE EXTERNAL CHARACTER SET.            *
*                                                                     *
*   IF THE MESSAGE TEXT IS MODIFIED TO SATISFY WORLD TRADE            *
*   REQUIREMENTS, IT MAY BE NECESSARY TO MODIFY THE INSERT LOCATIONS  *
*   SPECIFIED IN THE MESSAGE POINTER TABLE MSGPTRS CONTAINED IN THE   *
*   IEBTCRIN COMMON COMMUNICATION REGION CSECT TCRCOM.                *
         TITLE 'IEBTCR02 - MESSAGE MODULE - TABLES'
IEBTCR02 START
         SPACE 2
*        MESSAGE POINTER TABLE
         SPACE 1
*        THIS TABLE CONTAINS ONE FOUR-BYTE ENTRY FOR EACH ENTRY OF
*        THE MESSAGE TABLE.  EACH ENTRY CONSISTS OF A ONE-BYTE
*        MESSAGE LENGTH AND A THREE-BYTE MESSAGE ADDRESS.
         SPACE 2
MSGTAB   DS    0F                      FORCE FULL-WORD ALIGNMENT
         DC    AL1(B-A-8)              LENGTH MSG 01
         DC    AL3(A)                  ADDRESS MSG 01
         DC    AL1(C-B-8)              LENGTH MSG 02
         DC    AL3(B)                  ADDRESS MSG 02
         DC    AL1(D-C-8)              LENGTH MSG 03
         DC    AL3(C)                  ADDRESS MSG 03
         DC    AL1(E-D-8)              LENGTH MSG 04
         DC    AL3(D)                  ADDRESS MSG 04
         DC    AL1(F-E-8)              LENGTH MSG 05
         DC    AL3(E)                  ADDRESS MSG 05
         DC    AL1(G-F-8)              LENGTH MSG 06
         DC    AL3(F)                  ADDRESS MSG 06
         DC    AL1(H-G-8)              LENGTH MSG 07
         DC    AL3(G)                  ADDRESS MSG 07
         DC    AL1(I-H-8)              LENGTH MSG 08
         DC    AL3(H)                  ADDRESS MSG 08
         DC    AL1(J-I-8)              LENGTH MSG 09
         DC    AL3(I)                  ADDRESS MSG 09
         DC    AL1(K-J-8)              LENGTH MSG 10
         DC    AL3(J)                  ADDRESS MSG 10
         DC    AL1(L-K-8)              LENGTH MSG 11
         DC    AL3(K)                  ADDRESS MSG 11
         DC    AL1(M-L-8)              LENGTH MSG 12
         DC    AL3(L)                  ADDRESS MSG 12
         DC    AL1(N-M-8)              LENGTH MSG 13
         DC    AL3(M)                  ADDRESS MSG 13
         DC    AL1(O-N-8)              LENGTH MSG 14
         DC    AL3(N)                  ADDRESS MSG 14
         DC    AL1(P-O-8)              LENGTH MSG 15
         DC    AL3(O)                  ADDRESS MSG 15
         DC    AL1(Q-P-8)              LENGTH MSG 16
         DC    AL3(P)                  ADDRESS MSG 16
         DC    AL1(R-Q-8)              LENGTH MSG 17
         DC    AL3(Q)                  ADDRESS MSG 17
         DC    AL1(S-R-8)              LENGTH MSG 18
         DC    AL3(R)                  ADDRESS MSG 18
         DC    AL1(T-S-8)              LENGTH MSG 19
         DC    AL3(S)                  ADDRESS MSG 19
         DC    AL1(U-T-8)              LENGTH MSG 20
         DC    AL3(T)                  ADDRESS MSG 20
         DC    AL1(V-U)                LENGTH MSG U
         DC    AL3(U)                  ADDRESS MSG U
         DC    AL1(Z-V)                LENGTH MSG V
         DC    AL3(V)                  ADDRESS MSG V
         DC    AL4(Z)                  NULL ENTRY LENGTH
         EJECT
*        MESSAGE TABLE
         SPACE 1
*        THIS TABLE CONTAINS LIST-FORM WTO MACRO-INSTRUCTIONS
*        FOR ALL IEBXXXX MESSAGES, INCLUDING A DUMMY FOR OUTPUTTING
*        OF SYNAD MESSAGES.  IN ADDITION IT CONTAINS DC'S FOR THE
*        SYSPRINT HEADING MESSAGE AND COMPLETION MESSAGE.
         SPACE 2
MESSAGE  DS    0F                      FORCE FULL-WORD ALIGNMENT
         SPACE 1
A        WTO   'IEB901A M DDD,XXXXXX,JJJJJJJJ,SSSSSSSS',MF=L,          X
               ROUTCDE=3,DESC=2
         SPACE 1
B        WTO   'IEB902I INVALID NAME FIELD',MF=L,ROUTCDE=11,DESC=7
        SPACE 1
C        WTO   'IEB903I INVALID OPERATION',MF=L,ROUTCDE=11,DESC=7
        SPACE 1
D        WTO   'IEB904I INVALID KEYWORD',MF=L,ROUTCDE=11,DESC=7
        EJECT
E        WTO   'IEB905I INVALID PARAMETER VALUE',MF=L,ROUTCDE=11,      X
               DESC=7
         SPACE 1
F        WTO   'IEB906I DUPLICATE OPERATION FIELD',MF=L,ROUTCDE=11,    X
               DESC=7
         SPACE 1
G        WTO   'IEB907I INCONSISTENT REPLACE PARAMETER',MF=L,          X
               ROUTCDE=11,DESC=7
         SPACE 1
H        WTO   'IEB908I CONFLICTING OPTIONS SPECIFIED',MF=L,           X
               ROUTCDE=11,DESC=7
         SPACE 1
I        WTO   'IEB909I EXPECTED CONTINUATION NOT RECEIVED',MF=L,      X
               ROUTCDE=11,DESC=7
         EJECT
J        WTO   'IEB910I NO SYSUT1   DD CARD - JOB TERMINATED',         X
               ROUTCDE=11,DESC=7,MF=L
         SPACE 1
K        WTO   'IEB911I NO SYSIN    DD CARD - ALL DEFAULT OPTIONS ASSUMX
               ED',ROUTCDE=11,DESC=7,MF=L
         SPACE 1
L        WTO   'IEB912I NO SYSPRINT DD CARD - DUMMY ASSUMED',          X
               ROUTCDE=11,DESC=7,MF=L
         SPACE 1
M        WTO   'IEB913I NO XXXXXXXX DD CARD - DUMMY ASSUMED',          X
               ROUTCDE=11,DESC=7,MF=L
         SPACE 1
N        WTO   'IEB914I DCB SUBPARAMETERS MISSING IN XXXXXXXX DD CARD -X
                DEFAULTS ASSUMED',ROUTCDE=11,DESC=7,MF=L
         EJECT
O        WTO   'IEB915I DDNAME XXXXXXXX CANNOT BE OPENED',ROUTCDE=11,  X
               DESC=7,MF=L
         SPACE 1
P        WTO   'IEB916I INCONSISTENT XXXXXXXX DCB PARAMETERS',         X
               ROUTCDE=11,DESC=7,MF=L
         SPACE 1
Q        WTO   'IEB917I LOAD MODULE SPECIFIED FOR XXXXXXXX NOT FOUND', X
               ROUTCDE=11,DESC=7,MF=L
         SPACE 1
R        WTO   'IEB918I JOB TERMINATED AFTER XXXXXXXX EXIT',           X
               ROUTCDE=11,DESC=7,MF=L
         SPACE 1
S        WTO   'IEB919I INSUFFICIENT STORAGE AVAILABLE',ROUTCDE=11,    X
               DESC=7,MF=L
         EJECT
T        WTO   '                                                       X
                                ',ROUTCDE=11,DESC=7,MF=L
         SPACE 2
U        DC    C'IEBTCRIN DATA SET UTILITY'
V        DC    C'IEBTCRIN COMPLETED'
Z        DS    0C                      NULL ENTRY
         END
