*%       GOTO  CATPLS1;             /* BILINGUAL MACRO
         MACRO
         IECDCAT
         DSECT
CAT      DS    0F
         SPACE 1                   */
*%CATPLS1 : ;
*/* ******************************************************************/
*/*                                                                  */
*/*  THIS DSECT DESCRIBES AN ENTRY IN THE CHANNEL AVAILABILITY       */
*/*  TABLE. THE TABLE IS CPU RELATED AND RESIDES IN THE PCCA.        */
*/*  EACH PHYSICAL CHANNEL ATTACHED TO THE CPU CONTAINS AN ENTRY     */
*/*  IN THE CAT AND IS INDEXED BY THAT CHANNEL NUMBER. THE ENTRY     */
*/*  CONTAINS THE CHANNEL ID, CHANNEL STATUS, AND CHANNEL            */
*/*  STATISTICS.                                                     */
*/*  THE FOLLOWING FIELDS ARE MODIFIED BY  THE I/O SUPERVISOR.       */
*/*  THE MODIFICATIONS ARE SERIALIZED VIA DISABLED STATE AND         */
*/*  ALWAYS IN THE CPU OWNING THIS CAT.                              */
*/*         CATFLA                                                   */
*/*         CATSIOCT                                                 */
*/*                                                                  */
*/* ******************************************************************/
* %      GOTO CATPLS2;             /*
         SPACE 1
CATFLG   DS    XL1                 CAT ENTRY FLAG BYTE (NON-IOS)
CATRES1  EQU   X'80'               RESERVED
CATNOP   EQU   X'40'               CHANNEL NOT OPERATIVE
CATNGEN  EQU   X'20'               CHANNEL NOT SYSGENNED
CATNCPU  EQU   X'10'               CHANNEL NOT ON THIS CPU
CATNID   EQU   X'08'               CHANNEL ID (CATCHID) INVALID
CATFLG5  EQU   X'04'               RESERVED
CATFLG6  EQU   X'02'               RESERVED
CATDSABL EQU   X'01'               CHANNEL DISABLED            @ZA30350
CATFLA   DS    XL1                 IOS FLAG BYTE
CATBSY   EQU   X'80'               CHANNEL BUSY
CATIORST EQU   X'40'               CHAN NEED I/O RESTART       @G552PLM
CATCCRST EQU   X'20'               CHAN ERR ON I/O INTERRUPT   @G51BPLM
CATMCRST EQU   X'10'               CHAN ERR ON MACH CHK INTRPT @G51BPLM
CATSOL   EQU   X'08'               SIO CC=0 DONE               @ZA30350
CATFLARS EQU   X'07'               RESERVED                    @ZA30350
CATSIOCT DS    XL2                 CHANNEL SIO COUNT
CATCHID  DS    XL4                 CHANNEL ID
CATELP2  EQU    3                  ENTRY LENGTH IN POWERS OF 2
CATEL    EQU   *-CAT               CHANNEL TABLE ENTRY LENGTH
         MEND  ,                   */
*%CATPLS2 : ;
*   DCL 1 CAT  BASED(CATPTR),
*       2 CATENTRY CHAR(1),        /* ENTRY NAME              */
*         3 CATFLG CHAR(1),        /* CAT FLAG BYTE (NON-IOS) */
*          4 CATRES1 BIT(1),       /* RESERVED                */
*          4 CATNOP  BIT(1),       /* CHANNEL NOT OPERATIVE   */
*          4 CATNGEN BIT(1),       /* CHANNEL NOT SYSGENNED   */
*          4 CATNCPU BIT(1),       /* CHANNEL NOT ON THIS CPU */
*          4 CATNID  BIT(1),       /* CHANNEL ID INVALID      */
*          4 CATFLG5 BIT(1),       /* RESERVED                */
*          4 CATFLG6 BIT(1),       /* RESERVED                */
*          4 CATDSABL BIT(1),      /* CHANNEL DISABLED       @ZA30350*/
*       2 CATFLA   BIT(8),         /* IOS FLAG BYTE           */
*         3 CATBSY  BIT(1),        /* CHANNEL BUSY            */
*         3 CATIORST BIT(1),       /* CHAN NEEDS I/O RESTART @G552PLM*/
*         3 CATCCRST BIT(1),       /* CHAN ERR I/O INTRUPT   @G51BPLM*/
*         3 CATMCRST BIT(1),       /* CHAN ERR ON MACH CHK   @G51BPLM*/
*         3 CATSOL BIT(1),         /* SIO CC=0 DONE          @ZA30350*/
*         3 CATFLARS BIT(3),       /* RESERVED               @ZA30350*/
*       2 CATSIOCT  CHAR(2),       /* CHANNEL SIO COUNT       */
*       2 CATCHID   CHAR(4),       /* CHANNEL ID              */
*       2 CATEND  CHAR(0);         /* END OF CAT              */
*   DCL CATELP2 BIT(8) CONSTANT('03'X);  /*
*                                     ENTRY LENGTH IN
*                                     POWERS OF 2             */
*
*%DCL  CATEL  CHAR;                /* LENGTH OF CAT           */
*%CATEL='ADDR(CATEND)-ADDR(CATENTRY)';
