*        %GOTO HIDT1;              /*HIDT MAPPING
         MACRO
         IECDHIDT
*************** START OF SPECIFICATIONS *******************************
*                                                                     *
* MODULE NAME - IECVHIDT                                              *
*                                                                     *
* DESCRIPTIVE NAME - HOT IO DETECTION THRESHOLDS                      *
*                                                                     *
* COPYRIGHT - NONE                                                    *
*                                                                     *
* STATUS -                                                            *
*                                                                     *
* FUNCTION -                                                          *
*   THIS NON-EXECUTABLE MODULE CONTAINS THE THRESHOLDS USED BY        *
*   IECVHDET TO DETERMINE IF HOT I/O IS OCCURRING. THE CONTENTS       *
*   OF THIS MODULE ARE MAPPED BY IECDHIDT.                            *
*                                                                     *
*   OPERATION - NA                                                    *
*                                                                     *
* METHOD OF ACCESS                                                    *
*   TO CREATE CSECT USE BAL:                                          *
*     IECDHIDT                                                        *
*   TO GET MAPPING USE PLS:                                           *
*     INCLUDE IECDHIDT FROM SYSLIB                                    *
*                                                                     *
* NOTES -                                                             *
*                                                                     *
*   DEPENDENCIES -                                                    *
*     NONE OF THE THRESHOLDS MAY BE CHANGED TO A VALUE SMALLER THAN 2 *
*                                                                     *
*   RESTRICTIONS - NONE                                               *
*                                                                     *
*   REGISTER CONVENTIONS - NA                                         *
*                                                                     *
*   PATCH LABEL - NONE                                                *
*                                                                     *
* MODULE TYPE - NON-EXECUTABLE                                        *
*                                                                     *
*   PROCESSOR - ASSEMBLER                                             *
*                                                                     *
*   MODULE SIZE - 4 BYTES                                             *
*                                                                     *
*   ATTRIBUTES - NUCLEUS RESIDENT, NON-EXECUTABLE                     *
*                                                                     *
* ENTRY POINT - N/A                                                   *
*                                                                     *
* EXIT-NORMAL - N/A                                                   *
*                                                                     *
* EXIT-ERROR - N/A                                                    *
*                                                                     *
* EXTERNAL REFERENCES - NONE                                          *
*                                                                     *
* TABLES - N/A                                                        *
*                                                                     *
* MACROS - NONE                                                       *
*                                                                     *
* SERIALIZATION - NONE                                                *
*                                                                     *
* CHANGE ACTIVITY - NONE                                              *
*   A000000-999999                                          @ZA30350  *
*                                                                     *
* MESSAGES - NONE                                                     *
*                                                                     *
********************* END OF SPECIFICATIONS ***************************
IECVHIDT CSECT
         DC    XL2'64'             HOT CHANNEL THRESHOLD
         DC    XL2'64'             HOT DEVICE THRESHOLD
         DC    XL2'0C'             TIMEOUT THRESHOLD
         DC    XL2'04'             TIMEOUT INTERVAL IN SECONDS
         END
         MEND                      */
*%HIDT1:  ;
*
 /********************************************************************/
 /*                                                                  */
 /* CONTROL BLOCK NAME - HIDT                                        */
 /*                                                                  */
 /* DESCRIPTIVE NAME - HOT I/O DETECTION THRESHOLDS                  */
 /*                                                                  */
 /* FUNCTION -                                                       */
 /*   THE HIDT CONTAINS THE THRESHOLDS WHICH ARE USED BY MODULE      */
 /*   IECVHIDT TO DETERMINE IF HOT I/O IS OCCURRING.                 */
 /*                                                                  */
 /* CHANGE ACTIVITY -                                                */
 /*   A000000-999999                                         @ZA30350*/
 /*                                                                  */
 /********************************************************************/
 DCL
   1 HIDT BASED,                   /*HOT I/O DETECTION THRESHOLDS    */
     3 HIDTCHAN FIXED(15),         /*HOT CHANNEL THRESHOLD           */
     3 HIDTDEV FIXED(15),          /*HOT DEVICE THRESHOLD            */
     3 HIDTTIME FIXED(15),         /*TIMEOUT DETECTION THRESHOLD     */
     3 HIDTINTV FIXED(15);         /*TIMEOUT INTERVAL IN SECONDS     */
