* %      GOTO IPIBPLS;             /* GO TO PLS VERSION       */
         MACRO
         IECDIPIB   &DSECT=YES
         AIF   ('&DSECT' EQ 'NO').IPIB1
IPIB     DSECT
         AGO   .IPIB2
.IPIB1   ANOP
IPIB     DS    0D
.IPIB2   ANOP
         SPACE 1
****************************************************************
*                                                              *
*   THIS DSECT DESCRIBES THE IOS PURGE INTERFACE BLOCK WHICH   *
*   IS BUILT IN THE PURGE WORK AREA. IT IS USED TO HOLD ALL    *
*   THE INFORMATION THAT IS COMMUNICATED BETWEEN PURGE AND     *
*   THE CHANNEL SCHEDULER AND ITS DRIVERS.                     *
*                                                              *
****************************************************************
         SPACE 1
IPIBOPT  DS    XL1                 OPTIONS NEEDED BY DRIVERS
*                                  FOR CHANNEL SCHEDULER WHEN
*                                  PURGING THEIR QUEUES.
IPIBMEM  EQU   X'80'               ASID PURGE WAS SPECIFIED
IPIBTASK EQU   X'40'               TCB PURGE WAS SPECIFIED IF
*                                  ASID PURGE WAS NOT
*                                  SPECIFIED
IPIBRBP  EQU   X'20'               RB PURGE SPECIFIED
IPIBPOST EQU   X'10'               POST THE ECBS RELATED TO THE
*                                  I/O REQUESTS THAT ARE PURGED
IPIBREL  EQU   X'08'               PURGE ONLY REQUESTS THAT ARE
*                                  MARKED RELATED
IPIBHALT EQU   X'04'               HALT I/O REQUESTS - DO NOT
*                                  BUILD A CHAIN FOR RESTORE
IPIBOTCB EQU   X'02'               PURGE SO THAT I/O REQUESTS
*                                  MAY BE RESTORED TO THE
*                                  ORIGINATING TCB
         SPACE 1
IPIBDVID DS    XL1                 DRIVER ID FOR DSID PURGE  DCRR 21082
*                                  DEFAULT VALUE OF X'00'    DCRR 21082
*                                  IMPLIES EXCP              DCRR 21082
IPIBFLG1 DS    XL1                 FLAG BYTE                   @ZA12676
IPIBDQ   EQU   X'80'               INDICATES PURGEDQ ISSUED BY
*                                  IGC0001F                    @ZA12676
         DS    XL1                 RESERVED                    @ZA12676
IPIBCNT  DS    A                   COUNT OF I/O REQUESTS TO BE
*                                  COMPLETED. DECREMENTED BY
*                                  IOS DRIVERS WHEN I/O EVENT
*                                  COMPLETES
IPIBECB  DS    A                   ECB TO BE POSTED WHEN IPIBCNT
*                                  GOES TO ZERO. PURGE WAITS ON
*                                  THIS ECB WHEN THE COUNT IS
*                                  ESTABLISHED.
IPIBARG  DS    A                   PURGE ARGUMENT. IF ASID
*                                  PURGE, THE RIGHT TWO BYTES
*                                  CONTAIN THE ASID OF THE ASID
*                                  BEING PURGED AND THE LEFT
*                                  TWO BYTES CONTAIN THE SIGN
*                                  BIT OF THE ASID. IF TCB
*                                  PURGE, THEN THE TCB ADDRESS.
IPIBSRB  DS    A                   POINTER TO FIRST SRB ON CHAIN
*                                  OF SRBS THAT HAVE BEEN COL-
*                                  LECTED FOR RETURN TO THE
*                                  APPROPRIATE DRIVER OF THE
*                                  CHANNEL SCHEDULER.
IPIBIO   DS    A                   POINTER TO I/O REQUEST CHAIN
*                                  RETURNED TO PURGE FOR PLACE-
*                                  MENT ON THE PIRL.
IPIBDVRU DS    A                   POINTER TO ADDITIONAL INFOR-
*                                  MATION THE DRIVER MAINTAINS
*                                  INSURE TO THE PROPER RESTOR-
*                                  ATION OF ITS QUEUE OF I/O
*                                  REQUESTS (E.G.PROTECT KEYS
*                                  TCB ADDRESSES ETC)
IPIBPIRL DS    A                   POINTER TO PIRL FOR THIS
*                                  PURGE REQUEST.
IPIBPSQ  DS    A                   POINTER TO CHAIN OF I/O RE-
*                                  QUESTS INVOLVED WITH THIS
*                                  PURGE FOUND BY ROUTINES RUN-
*                                  NING ASYNCHRONOUSLY WITH THE
*                                  PURGE ROUTINE (E.G. THE IN-
*                                  TERRUPT HANDLER).
IPIBLNK  DS    A                   MAY BE A MAX OF 2 IPIBS/ASID@YM07220
*                                  IF SO, THIS POINTS TO 2ND  @YM07220
*                                  IPIB WHICH MUST BE A HALT OR = 0
IPIBASCB DS    A                   ASCB ADDRESS FOR MEMORY IN  @ZA30265
*                                  WHICH PURGE WAS ISSUED      @ZA30265
         MEND
*%IPIBPLS: ;
*
* /************************************************************/
* /*                                                          */
* /*   THIS STRUCTURE DESCRIBES THE IOS PURGE INTERFACE BLOCK */
* /*   WHICH IS BUILT IN THE PURGE WORK AREA . IT IS USED TO  */
* /*   HOLD ALL THE INFORMATION THAT IS COMMUNICATED BETWEEN  */
* /*   PURGE AND THE CHANNEL SCHEDULER AND ITS DRIVERS.       */
* /*                                                          */
* /************************************************************/
*
*DCL 1 IPIB  BDY(WORD)  BASED(IPIBPTR),
*    2 IPIBOPT     BIT(8),         /* OPTIONS NEEDED BY DRVRS
*                                     OF CHANNEL SCHEDULR WHEN
*                                     PURGING THEIR QUEUES    */
*     3 IPIBMEM    BIT(1),         /* ASID   PURGE WAS SPECFD */
*     3 IPIBTASK   BIT(1),         /* TCB PURGE WAS SPECIFIED
*                                     IF ASID   PURGE WAS NOT */
*     3 IPIBRBP    BIT(1),         /* RB PURGE SPECIFIED      */
*     3 IPIBPOST   BIT(1),         /* POST THE ECBS RELATED TO
*                                     THE I/O REQUESTS THAT
*                                     ARE PURGED              */
*     3 IPIBREL    BIT(1),         /* PURGE ONLY REQUESTS THAT
*                                     ARE MARKED RELATED      */
*     3 IPIBHALT   BIT(1),         /* HALT I/O REQUESTS - DO
*                                     NOT BUILD A CHAIN FOR
*                                     RESTORE                 */
*     3 IPIBOTCB   BIT(1),         /* PURGE SO I/O REQUESTS
*                                     MAY BE RESTORED TO THE
*                                     ORIGINATING TCB         */
*     3 *          BIT(1),         /* RESERVED                */
*
*    2 IPIBDVID    CHAR(1),        /* DRIVER ID FOR DSID PURGE
*                                     DEFAULT VALUE OF X'00'
*                                     IMPLIES EXCP  DCRR 21082*/
*    2 IPIBFLG1    BIT(8),         /* FLAG BYTE              @ZA12676*/
*     3 IPIBDQ     BIT(1),         /* IGC0001F ISSUED PURGEDQ@ZA12676*/
*     3 *          BIT(7),         /* RESERVED               @ZA12676*/
*    2 *           CHAR(1),        /* RESERVED               @ZA12676*/
*    2 IPIBCNT     CHAR(4),        /* COUNT OF I/O REQUESTS TO
*                                     BE COMPLETED. DECREMENTD
*                                     BY IOS DRIVERS WHEN
*                                     I/O EVENT COMPLETES     */
*    2 IPIBECB     PTR(31),        /* ECB TO BE POSTED WHEN
*                                     IPIBCNT GOES TO ZERO.
*                                     PURGE WAITS ON THIS ECB
*                                     WHEN COUNT IS ESTABLISHD*/
*    2 IPIBARG     PTR(31),        /* PURGE ARGUMENT. IF ASID
*                                     PURGE, THE RIGHT 2 BYTES
*                                     CONTAIN THE ASID OF THE
*                                     ASID BEING PURGED AND
*                                     THE LEFT TWO BYTES HAVE
*                                     THE SIGN BIT OF THE ASID
*                                     IF TCB PURGE, THEN THE
*                                     TCB ADDRESS             */
*    2 IPIBSRB     PTR(31),        /* PTR TO FIRST SRB ON CHN
*                                     OF SRBS THAT HAVE BEEN
*                                     COLLECTED FOR RETURN TO
*                                     THE APPROPRIATE DRIVER
*                                     OF THE CHANNL SCHEDULER */
*    2 IPIBIO      PTR(31),        /* PTR TO I/O REQUEST CHAIN
*                                     RETURNED TO PURGE FOR
*                                     PLACEMENT ON THE PIRL   */
*    2 IPIBDVRU    PTR(31),        /* PTR TO ADTNL INFO EACH
*                                     DRIVER MAINTNS TO INSURE
*                                     PROPER RESTORATN OF ITS
*                                     QUEUE OF REQUESTS (E.G.
*                                     PROTECT KEYS - TCB ADDR)
*                                     RETURNED TO PURGE FOR
*                                     PLACEMENT ON THE PIRL   */
*    2 IPIBPIRL    PTR(31),        /* PTR TO PIRL FOR THIS
*                                     PURGE REQUEST           */
*    2 IPIBPSQ     PTR(31),        /* PTR TO CHAIN OF I/O REQ.
*                                     INVOLVED WITH THIS PURGE
*                                     FOUND BY ROUTINES RUNNG
*                                     ASYNCHRONOUSLY WITH THE
*                                     PURGE ROUTINE (E.G. THE
*                                     INTERRUPT HANDLER).     */
*    2 IPIBLNK    PTR(31),         /* PTS TO 2ND IPIB IF 2,  @YM07220*/
*                                  /* EITHER PTS TO HALT IPIB@YM07220*/
*                                  /* OR =0, MAX OF 2 IPIBS  @YM07220*/
*    2 IPIBASCB   PTR(31),         /* ASCB ADDRESS FOR       @ZA30265*/
*                                  /* MEMORY IN WHICH PURGE  @ZA30265*/
*                                  /* WAS ISSUED             @ZA30265*/
*
*    2 IPIBEND     CHAR(0);        /* END OF IPIB             */
