* %      GOTO IRTPLS;              /* GO TO THE PLS VERSION   */
*
         MACRO
         IECDIRT
         ORG   LCCAIRT
IRT      DS    0D
         SPACE 1
****************************************************************
*                                                              *
*   THIS MACRO DSECT DESCRIBES THE IOS RECOVERY  TABLE.        *
*   THE TABLE IS RELATED TO A CPU AND IS LOCATED IN THE        *
*   LCCA.                                                      *
*                                                              *
****************************************************************
         SPACE 1
IRTENTRY EQU   *
IRTFLA   DS    XL1                 FLAG BYTE A
         SPACE 1
IRTULCK  EQU   X'80'               UCB LOCK HELD
IRTLLCK  EQU   X'40'               LCH LOCK HELD
IRTSLCK  EQU   X'20'               SYNCH LOCK HELD
IRTCLCK  EQU   X'10'               CAT LOCK HELD
IRTALCK  EQU   X'08'               SALLOC LOCK HLED
IRTIOQA  EQU   X'04'               AN IOQ IS ACTIVE
IRTSLISN EQU   X'02'               RECOVERY SENSE INDICATOR
IRTSSIGP EQU   X'01'               SHLDR TAP NEEDED FOR SENSE  @ZA16177
         SPACE 1
IRTFLB   DS    XL1                 FLAG BYTE B
IRTNRST  EQU   X'80'               SUPPRESS RESTART OF CURRENT
*                                  CHANNEL
IRTSKRST EQU   X'40'               FIRST PASS OF CHAN. RESTART
IRTPCISW EQU   X'20'               FIRST PASS OF PCI
IRTCHBSY EQU   X'10'               ALL CHANNELS BUSY
IRTSMGR  EQU   X'08'               STORAGE MANAGER ENTERED
IRT12GT  EQU   X'04'               STORAGE MNGR - SMALL BLK GET
IRTCCHWA EQU   X'02'               SET IF CCH GETS EWA         @ZA18094
*        EQU   X'01'               RESERVED                    @ZA18094
         SPACE 1
IRTENVR  DS    XL1                 ENVIRONMENT FLAGS
IRTCHENT EQU   X'80'               CHAN SCHED ENTRANCE
IRTSLIHA EQU   X'40'               I/O INT HNDLR ENTRANCE
IRTSHTP  EQU   X'20'               SHOULDER TAP ENTRANCE
IRTCRHIN EQU   X'10'               CRH INTERRUPT ON DEAD CPU   @ZA16177
IRTRSTI  EQU   X'08'               I/O RESTART IN PROGRESS
IRTHIO   EQU   X'04'               HIO IN PROCESS
IRTPINT  EQU   X'02'               I/O RESTART PSEUDO INTERRUPT
IRTCSINT EQU   X'01'               CHANNEL SCHEDULER ENTRANCE
*                                  * INITIALIZATION COMPLETE
         SPACE 1
         DS    XL1                 RESERVED
         SPACE 1
IRTSYMSK DS    XL1                 OLD SYSTEM MASK SET BY
*                                  CHANNEL SCHEDULER
IRTCCH   DS    XL1                 CHANNEL CHECK HANDLER
*                                  COMMUNICATION BYTE
IRTCMRST DS    XL1                 RESTART INDICATOR SET BY CHAN
*                                  SCHEDULER WHEN ENTERED. SET
*                                  IN THE OTHER CPU WHEN SHLDER
*                                  TAP IS TO BE DONE.
*                                    FF = IOS ACTIVE AND RESTART
*                                       CAN BE DONE VIA RESTART
*                                       ROUTINE
*                                    00 = IOS NOT ACTIVE. SHLDER
*                                       TAP TO BE USED TO RESTRT
IRTDETEC DS    XL1                 HOT I/O DETECTION FLAGS     @ZA30350
IRTDETR1 EQU   X'80'               RESERVED FOR HOT I/O DETEC  @ZA30350
IRTAVAIL EQU   X'40'               AVAILABILITY INTERRUPT      @ZA30350
IRTUNSOL EQU   X'20'               UNSOLICITED INTERRUPT       @ZA30350
IRTNOSYS EQU   X'10'               DEVICE NOT SYSGENED         @ZA30350
IRTHOTD  EQU   X'08'               HOT DEVICE DETECTION        @ZA30350
IRTINVDV EQU   X'04'               INVALID DEVICE ADDRESS AND  @ZA30350
*                                  CHANNEL ERROR               @ZA30350
IRTCUERR EQU   X'02'               CHANNEL ERROR-CONTROL UNIT  @ZA30350
*                                  PROBABLE CAUSE OF ERROR     @ZA30350
IRTCHERR EQU   X'01'               CHANNEL ERROR-CONTROL UNIT  @ZA30350
*                                  NOT PROBABLE CAUSE OF ERR   @ZA30350
IRTUCB   DS    A                   ADDRESS OF LOCKED UCB
IRTLCH   DS    A                   ADDRESS OF LOCKED LCH
IRTIOQ   DS    A                   ADDRESS OF ACTIVE IOQ
IRTCHNL  DS    A                   CURRENT CHANNEL USED BY TCH
IRTNIOQ  DS    A                   SAVED ADDRESS OF NEXT IOQ
IRTPSTSV DS    A                   IOQ SAVE AREA USED BY
*                                  CHANNEL SCHEDULER
IRTCHMSK DS    A                   RESTART CHANNEL MASK THIS CPU
IRTRSV01 DS    A                   RESERVED
IRTRTNSV DS    D                   USED BY CHAN SCHED AND SHLDR
*                                  TAP FOR REG 13 AND 14 SAVE
IRTTCHSV DS    A                   TCH ROUTINE LINK SAVE
IRTDDSV  DS    A                   DEVICE DEPENDENT SIO SUBROUTINE
IRTSIOSV DS    A                   POST SIO LINK SAVE
IRTSTASV DS    A                   STATUS ROUTINE LINK SAVE
IRTRSTSV DS    A                   RESTART ROUTINE LINK SAVE
IRTDIESV DS    A                   DIE ROUTINE LINK SAVE
IRTSENSV DS    A                   SENSE ROUTINE LINK SAVE
IRTPCISV DS    A                   PCI ROUTINE LINK SAVE
IRTPRGSV DS    A                   CHECK PURGE ROUTINE LINK SAVE
IRTCSME  DS    A                   SAVED CHANNEL SEARCH MODULE
*                                  TABLE ENTRY ADDRESS
IRTNSRB  DS    A                   ADDR OF SRB FOR NEW WORK
*                                  FROM DIE.
IRTFRRWA DS    A                   ADDR OF FRR WORKAREA
IRTATTSV DS    A                   ATTENTION ROUTINE LINK SAVE
IRTCCHSV DS    A                   CCH INTERFACE LINK SAVE
IRTINTSV DS    A                   SLIH ROUTINE LINK SAVE
IRTSTSSV DS    A                   TEST SCHEDULABILITY SAVE AREA
IRTLCHAD DS    A                   SAVED LCH ADDR FOR CHAN RSTRT
IRTSNSCT DS    A                   SENSE COUNTER               @ZA10792
IRTCHNSV DS    A                   SENSE CHAIN ROUTINE LINK SV @ZA16177
IRTRSV0B DS    A                   RESERVED                    @ZA10792
IRTEL    EQU   128                 ENTRY LENGTH
         MEND
*%IRTPLS: ;
*
*/*************************************************************/
*/*                                                           */
*/*  THIS STRUCTURE DESCRIBES THE IOS  RECOVERY  TABLE.  THE  */
*/*  TABLE IS RELATED TO A CPU AND IS LOCATED  IN  THE  LCCA. */
*/*  A RESPECIFY SHOULD BE DONE ON IRT TO  BASE  IT  ON  THE  */
*/*  ADDRESS OF LCCAIRT.                                      */
*/*                                                           */
*/*************************************************************/
*/*                                                           */
*/*    05/30/72     LEVEL=00                                  */
*/*                                                           */
*/*************************************************************/
*
*   DCL 1 IRT  BDY(WORD)  BASED(IRTPTR),
*
*       2 IRTENTRY  PTR(31),       /* LABEL IDENTIFICATION    */
*         3 IRTFLA  CHAR(1),       /* FLAG BYTE A             */
*           4 IRTULCK BIT(1),      /* UCB LOCK HELD           */
*           4 IRTLLCK BIT(1),      /* LCH LOCK HELD           */
*           4 IRTSLCK BIT(1),      /* SYNCH LOCK HELD         */
*           4 IRTCLCK BIT(1),      /* CAT LOCK HELD           */
*           4 IRTALCK BIT(1),      /* SALLOC LOCK HELD        */
*           4 IRTIOQA BIT(1),      /* AN IOQ  IS ACTIVE       */
*           4 IRTSLISN BIT(1),     /* RECOVERY SENSE IND      */
*           4 IRTSSIGP BIT(1),     /* SHLDR TAP NEEDED FOR SENSE
*                                                            @ZA16177*/
*         3 IRTFLB  CHAR(1),       /* RESERVED                */
*           4 IRTNRST BIT(1),      /* SUPPRESS RESTART FOR
*                                     CURRENT CHANNEL         */
*           4 IRTSKRST BIT(1),     /* FIRST PASS OF CHAN RSTRT*/
*           4 IRTPCISW BIT(1),     /* FIRST PASS OF PCI       */
*           4 IRTCHBSY BIT(1),     /* ALL CHANNELS BUSY       */
*           4 IRTSMGR  BIT(1),     /* STORAGE MANAGER ENTERED */
*           4 IRT12GT  BIT(1),     /* SMALL BLK GET           */
*           4 IRTCCHWA BIT(1),     /* SET IF CCH GETS EWA    @ZA18094*/
*           4 *        BIT(1),     /* RESERVED               @ZA18094*/
*
*         3 IRTENVR CHAR(1),       /* ENVIRONMENT INDICATORS  */
*           4 IRTCHENT BIT(1),     /* CHAN. SCHED. ENTRANCE   */
*           4 IRTSLIHA BIT(1),     /* I/O INT HNDLR ENTRANCE  */
*           4 IRTSHTP  BIT(1),     /* SHOULDER TAP ENTRANCE   */
*           4 IRTCRHIN BIT(1),     /* CRH INTERRUPT          @ZA16177*/
*           4 IRTRSTI  BIT(1),     /* I/O RESTART IN PROGRESS */
*           4 IRTHIO   BIT(1),     /* HIO IN PROCESS          */
*           4 IRTPINT  BIT(1),     /* I/O RESTART PSEUDO INT  */
*           4 IRTCSINT BIT(1),     /* CHAN SCHED INIT DONE    */
*
*         3 *         BIT(8),      /* RESERVED                */
*       2 IRTSYMSK  CHAR(1),       /* OLD SYSTEM MASK SET BY
*                                     CHANNEL SCHEDULER       */
*       2 IRTCCH    CHAR(1),       /* CCH COMMUNICATION BYTE  */
*       2 IRTCMRST  CHAR(1),       /* RESTRT IND. SET BY CHAN.
*                                     SCHED WHEN ENTERED. ALSO
*                                     SET IN THE OTHER CPU
*                                     WHEN SHOULDER TAP TO BE
*                                     DONE
*                                     FF = IOS ACTIVE AND CAN
*                                       RESTART VIA RSTSRT RTN
*                                     00 = IOS NOT ACTIVE.
*                                     SHOULDER TAP TO BE USED
*                                     TO RESTART              */
*       2 IRTDETEC  BIT(8),        /* HOT I/O DETECTION FLAG
*                                                           @ZA30350*/
*        3 IRTDETR1 BIT(1),        /* RESVD FOR HOT I/O     @ZA30350*/
*        3 IRTAVAIL BIT(1),        /* AVAILABILITY INTERPT  @ZA30350*/
*        3 IRTUNSOL BIT(1),        /* UNSOLICITED INTERRUPT @ZA30350*/
*        3 IRTNOSYS BIT(1),        /* DEVICE NOT SYSGENED   @ZA30350*/
*        3 IRTHOTD BIT(1),         /* HOT DEVICE DETECTION  @ZA30350*/
*        3 IRTINVDV BIT(1),        /* CHANNEL ERROR AND INVALID
*                                     DEVICE ADDRESS        @ZA30350*/
*        3 IRTCUERR BIT(1),        /* CHANNEL ERROR-CONTROL UNIT
*                                     PROBABLE CAUSE OF ERR @ZA30350*/
*        3 IRTCHERR BIT(1),        /* CHANNEL ERROR-CONTROL UNIT NOT
*                                     PROBABLE CAUSE OF ERR @ZA30350*/
*       2 IRTUCB    PTR(31),       /* ADDRESS OF LOCKED UCB   */
*       2 IRTLCH    PTR(31),       /* ADDRESS OF LOCKED LCH   */
*       2 IRTIOQ    PTR(31),       /* ADDRESS OF ACTIVE IOQ   */
*       2 IRTCHNL   PTR(31),       /* TCH CURRENT CHANNEL     */
*       2 IRTNIOQ   PTR(31),       /* SAVED ADDR OF NEXT IOQ  */
*       2 IRTPSTSV  PTR(31),       /* IOQE SAVE AREA USED BY
*                                     CHANNEL SCHEDULER       */
*       2 IRTCHMSK  CHAR(4),       /* RESTART CHANNEL MASK FOR
*                                     THIS CPU                */
*       2 IRTRSV01  PTR(31),       /* RESERVED                */
*       2 IRTRTNSV  CHAR(8),       /* USED BY CHAN SCHED AND
*                                     SHLDR TAP FOR RG 13 & 14*/
*       2 IRTTCHSV  PTR(31),       /* TCH ROUTINE LINK SAVE   */
*       2 IRTDDSV   PTR(31),       /* DEVICE DEPENDENT SIO
*                                     SUBROUTINE LINK SAVE    */
*       2 IRTSIOSV  PTR(31),       /* POST SIO LINK SAVE      */
*       2 IRTSTASV  PTR(31),       /* STATUS SUBRTN LINK SAVE */
*       2 IRTRSTSV  PTR(31),       /* RESTART RTN LINK SAVE   */
*       2 IRTDIESV  PTR(31),       /* DIE ROUTINE LINK SAVE   */
*       2 IRTSENSV  PTR(31),       /* SENSE ROUTINE LINK SAVE */
*       2 IRTPCISV  PTR(31),       /* PCI ROUTINE LINK SAVE   */
*       2 IRTPRGSV  PTR(31),       /* CHECK PURGE ROUTINE
*                                     LINK SAVE               */
*       2 IRTCSME   PTR(31),       /* SAVED CHANNEL SEARCH
*                                     MODULE TABLE ENTRY ADDR */
*       2 IRTNSRB   PTR(31),       /* ADDR OF SRB FOR NEW WORK
*                                     FROM DIE.               */
*       2 IRTFRRWA  PTR(31),       /* ADDR OF FRR WORKAREA    */
*       2 IRTATTSV  PTR(31),       /* ATTN. ROUTINE LINK SAVE */
*       2 IRTCCHSV  PTR(31),       /* CCH INTERFACE LINK SAVE */
*       2 IRTINTSV  PTR(31),       /* SLIH ROUTINE LINK SAVE  */
*       2 IRTSTSSV  PTR(31),       /* TEST SCHEDULABILITY SAVE*/
*       2 IRTLCHAD  PTR(31),       /* LCH ADDR FOR CHAN RSTRT */
*       2 IRTSNSCT  FIXED(31),     /* SENSE COUNTER          @ZA10792*/
*       2 IRTCHNSV  PTR(31),       /* SENSE CHAIN RTN LINK SV@ZA16177*/
*       2 IRTRSV0B  PTR(31),       /* RESERVED               @ZA10792*/
*       2 IRTEND    CHAR(0);       /* END OF IRT              */
*
*%DCL IRTEL CHAR;                  /* ENTRY LENGTH            */
*%IRTEL='ADDR(IRTEND)-ADDR(IRTENTRY)';
