* %      GOTO  LCHPLS;             /* GO TO THE PL/S VERSION   */
*
         MACRO
         IECDLCH
LCH      DSECT
         SPACE 1
*****************************************************************
*                                                               *
*   THIS MACRO DSECT DESCRIBES THE LOGICAL CHANNEL QUEUE TABLE. *
*                                                               *
*****************************************************************
         SPACE 1
LCHENTRY DS    0D                  DOUBLEWORD ALIGNMENT
LCHFST   DS    F                   FIRST IOQ ON LCH
LCHLST   DS    F                   LAST IOQ ON LCH
LCHLOCK  DS    F                   LOCKWORD ASSOCIATED WITH LCH YM3157P
LCHRSV01 DS    F                   RESERVED                     YM3157P
LCHTCH   DS    F                   TCH CHANNEL LIST
LCHCHCNT DS    FL1                 NUMBER OF CHANNELS ON LCH
LCHFLA   DS    XL1                 FLAG BYTE
         SPACE 1
LCHLKHLD EQU   X'80'               LCHLOCK HELD ON ENTRY
*        EQU   X'7F'               RESERVED
         SPACE 1
LCHRSV02 DS    H                   RESERVED                     YM3157P
LCHTOTAL DS    H                   TOTAL REQUESTS STARTED OR
*                                  QUEUED
LCHRSV03 DS    H                   RESERVED                     YM3157P
LCHLGBSY DS    H                   NUMBER REQUESTS QUEUED
*                                  BECAUSE LOGICALLY BUSY
LCHPYBSY DS    H                   NUMBER REQUESTS QUEUED
*                                  BECAUSE PHYSICALLY BUSY
LCHEL    EQU   *-LCHENTRY          ENTRY LENGTH
LCHELP2  EQU   5                   LENGTH OF LCH IN POWERS OF TWO
         MEND
*%LCHPLS: ;
*
* /*************************************************************/
* /*                                                           */
* /* THIS STRUCTURE DESCRIBES THE LOGICAL CHANNEL QUEUE TABLE. */
* /* CALLERS OF THIS MACRO SHOULD RESPECIFY THE LCH BASED  ON  */
* /* THE ADDRESS GOTTEN FROM THE CVT.                          */
* /*                                                           */
* /*************************************************************/
* /*                                                           */
* /*     09/05/73     LEVEL=00                                 */
* /*                                                           */
* /*************************************************************/
*
*   DCL  1 LCH  BDY(DWORD)  BASED(LCHPTR),
*        2  LCHENTRY  PTR(31),     /* LABEL IDENTIFICATION     */
*          3  LCHFST  PTR(31),     /* FIRST IOQ  ON LCH        */
*        2  LCHLST    PTR(31),     /* LAST IOQ  ON LCH         */
*        2  LCHLOCK   CHAR(4),     /* LOCKWORD FOR LCH YM3157P */
*        2  LCHRSV01  CHAR(4),     /* RESVERVED        YM3157P */
*        2  LCHTCH    PTR(31),     /* TCH CHANNEL LIST         */
*        2  LCHCHCNT  FIXED(8),    /* NUMBER OF CHANNELS IN
*                                     LIST                     */
*        2  LCHFLA    CHAR(1),     /* FLAG BYTE                */
*          3  LCHLKHLD  BIT(1),    /* LOCK HELD ON ENTRY       */
*          3  *         BIT(7),    /* RESERVED                 */
*
*        2  LCHRSV02    CHAR(2),   /* RESERVED         YM3157P */
*        2  LCHTOTAL  FIXED(15),   /* TOTAL REQUESTS STARTED
*                                     OR QUEUED                */
*        2  LCHRSV03  CHAR(2),     /* RESERVED         YM3157P */
*        2  LCHLGBSY  FIXED(15),   /* NUMBER OF RQSTS QUEUED
*                                     BECAUSE LOGICALLY BUSY   */
*        2  LCHPYBSY  FIXED(15),   /* NUMBER RQSTS QUEUED
*                                     BECAUSE PHYSICALLY BUSY  */
*        2  LCHEND    CHAR(0);     /* END OF LCH               */
*   DCL LCHELP2 BIT(8) CONSTANT('05'X);  /*
*                                     LCH ELEM LNGTH POWER OF 2*/
*
*%DCL  LCHEL  CHAR;                /* LENGTH OF TABLE          */
*%LCHEL='ADDR(LCHEND)-ADDR(LCHENTRY)';
