*        %GOTO RQEL1; /*
         MACRO
         IECDRQE
RQE      DSECT
         SPACE 1  */
*%RQEL1 : ;
*/********************************************************************/
*/*                                                                  */
*/* THIS DSECT DESCRIBES THE CONTROL BLOCK USED WITHIN THE EXCP PROC-*/
*/* ESSOR TO DEFINE A SINGLE REQUEST. IT CONTAINS ALL INFORMATION    */
*/* NECESSARY TO INITIATE AND TERMINATE I/O REQUESTS WITHIN THE EXCP */
*/* PROCESSOR.                                                       */
*/*                                                                  */
*/********************************************************************/
*%GOTO RQEL2; /*
         SPACE 1
RQEUCB   DS    A                   ADDRESS OF THE UNIT CONTROL BLOCK
RQEIOB   DS    A                   ADDRESS OF THE INPUT-OUTPUT BLOCK
RQEDEB   DS    A                   ADDRESS OF THE DATA EXTENT BLOCK
RQETCB   DS    A                   ADDRESS OF THE TASK CONTROL BLOCK
RQETCCW  DS    A                   ADDRESS OF TRANSLATION CONTROL
*                                  BLOCK - USED BY VIO
*                                  AS A WORK AREA
RQENRQE  DS    A                   ADDRESS OF THE NEXT RQE ON RELATED
*                                  REQUEST CHAIN - USED BY VIO
*                                  AS A WORK AREA
RQERRQ   DS    A                   ADDRESS OF RELATED REQUEST QUEUE -
*                                  USED BY VIO
*                                  AS A WORK AREA
RQESRB   DS    A                   ADDRESS OF ASSOCIATED SRB - USED BY
*                                  VIO AS A WORK AREA
RQEIPIB  DS    A                   ADDRESS OF PURGE IPIB
RQEPRT   DS    XL1                 PROTECT KEY FROM SVC OLD PSW@ZA06067
*                                  (BITS 0-3) AND FLAGS(4-7)   @ZA06067
RQEPKEY  EQU   X'F0'               PROTECT KEY - BITS 0-3      @ZA06067
RQEPRT4R EQU   X'08'               BIT4 - RESERVED             @ZA06067
RQEPRT5R EQU   X'04'               BIT5 - RESERVED             @ZA06067
RQEPRT6R EQU   X'02'               BIT6 - RESERVED             @ZA06067
RQESMFRQ EQU   X'01'               BIT7 - SMF RECORDING REQD   @ZA06067
         SPACE
RQETYPE  DS    XL1                 REQUEST TYPE FLAGS
         SPACE 1
*   BIT SETTINGS FOR RQETYPE
         SPACE 1
RQE114   EQU   X'80'               EXCPVR REQUEST
RQEVIRT  EQU   X'40'               VIRTUAL EXCP REQUEST
RQE1TO1  EQU   X'20'               VIRTUAL EQUAL REAL REQUEST
RQEVAM   EQU   X'10'               VIO RQE
RQEEOEE  EQU   X'08'               END-OF-EXTENT-ERROR,TO BE   @YM04681
*                                  PURGED
RQEDIE   EQU   X'04'               EXCP DIE GOING TO PCI APPEND@YM05537
RQERRTYP EQU   X'03'               RELATED REQUEST FLAGS
RQETYP3  EQU   X'03'               RELATED REQUEST TYPE 3
RQETYP2  EQU   X'02'               RELATED REQUEST TYPE 2
RQETYP1  EQU   X'01'               RELATED REQUEST TYPE 1
         SPACE 1
RQEFLAG  DS    XL1                 FLAG BYTE IN RQE
         SPACE 1
*   BIT SETTINGS FOR RQEFLAG2
RQERETRY EQU   X'80'               RETRY REQUESTED
RQENOPST EQU   X'40'               NO POST REQUESTED
RQENOFRE EQU   X'20'               DONT FREE RQE
RQEFIXST EQU   X'10'               FIX PROCESS HAS BEEN STARTED,
*                                  UNFIX REQUIRED
RQESTBL  EQU   X'08'               THIS REQUEST IS STARTABLE - THAT IS
*                                  ALL FIXING AND TRANSLATION IS DONE
RQESRBS  EQU   X'04'               SRB SCHEDULED FOR THIS RQE
RQEPURGE EQU   X'02'               RQE UNDERGOING PURGE
RQECHEAC EQU   X'01'               CHANNEL END APPENDAGE COMPLETE
*        BIT SETTINGS FOR RQEFLAG3                             @ZM32371
RQEFLAG3 DS    XL1                                             @ZM32371
RQEINIOS EQU   X'80'               REQUEST IN IOS              @ZM32371
RQECLEAR EQU   X'00'               RESET FLAG BYTES            @ZM32371
         SPACE 1
RQEBL    EQU   *-RQE               RQE BLOCK LENGTH
         MEND  , - */
*%RQEL2 : ;
* DECLARE 1 RQE BDY(WORD) BASED(RQEPTR), /* REQUEST QUEUE ELEMENT
*                                   FOR EXCP */
*    2 RQEUCB  PTR(31),            /* ADDRESS OF THE UNIT CONTROL
*                                     BLOCK.                         */
*    2 RQEIOB  PTR(31),            /* ADDRESS OF THE INPUT OUTPUT
*                                     BLOCK                          */
*    2 RQEDEB  PTR(31),            /* ADDRESS OF THE DATA EXTENT
*                                     BLOCK                          */
*    2 RQETCB  PTR(31),            /* ADDRESS OF THE TASK CONTROL
*                                     BLOCK                          */
*    2 RQETCCW PTR(31),            /* ADDRESS OF THE TRANSLATION IS
*                                     CONTROL BLOCK - THIS FIELD
*                                     USED BY VIO
*                                     AS A WORK AREA.                */
*    2 RQENRQE PTR(31),            /* ADDRESS OF NEXT RQE ON RELATED
*                                     REQUEST QUEUE - THIS FIELD IS
*                                     USED BY VIO AS
*                                     A WORK AREA.                   */
*    2 RQERRQ  PTR(31),            /* ADDRESS OF THE RELATED REQUEST
*                                     QUEUE - USED BY VIO
*                                     AS A WORK AREA                 */
*    2 RQESRB  PTR(31),            /* ADDRESS OF SRB - USED BY VIO
*                                     AS A WORK
*                                     AREA.                          */
*    2 RQEIPIB PTR(31),            /* ADDRESS OF IOS PURGE INTERFACE
*                                     BLOCK.                         */
*    2 RQEPRT  BIT(8),             /* PROTECTION KEY USED IN THE     */
*      3 RQEPKEY BIT(4),           /* PROTECTION KEY                 */
*      3 *     BIT(3),             /* RESERVED-MUST BE ZERO  @ZA06067*/
*      3 RQESMFRQ BIT(1),          /* SMF RECORDING REQUIRED @ZA06067*/
*    2 RQETYPE BIT(8),             /* RQE TYPE FLAGS                 */
*      3 RQE114  BIT(1),           /* EXCPVR REQUEST                 */
*      3 RQEVIRT BIT(1),           /* VIRTUAL EXCP REQUEST           */
*      3 RQE1TO1 BIT(1),           /* VIRTUAL = REAL EXCP REQUEST    */
*      3 RQEVAM  BIT(1),           /* VIO REQUEST                    */
*      3 RQEEOEE BIT(1),           /* END-OF-EXTENT-ERROR    @YM04681*/
*                                  /* TO BE PURGED                   */
*      3 RQEDIE  BIT(1),           /* EXCP DIE GOING TO PCI  @YM05537*/
*      3 RQETYP3 BIT(2),           /* TYPE 3 RELATED REQUEST         */
*        4 RQETYP2 BIT(1),         /* TYPE 2 RELATED REQUEST         */
*        4 RQETYP1 BIT(1),         /* TYPE 1 RELATED REQUEST         */
*    2 RQEFLAG BIT(8),             /* FLAGS INDICATING WORK TO DO
*                                     AND POSITION IN EXCP           */
*      3 RQERETRY BIT(1),          /* RETRY REQUEST FROM APPENDAGE   */
*      3 RQENOPST BIT(1),          /* NO POST REQUEST FROM APPEND    */
*      3 RQENOFRE BIT(1),          /* NO FREE REQUEST FROM APPEND    */
*      3 RQEFIXST BIT(1),          /* FIXING IS STARTED FOR REQUEST  */
*      3 RQESTBL  BIT(1),          /* REQUEST IS STARTABLE           */
*      3 RQESRBS  BIT(1),          /* REQUEST SENT TO IOS            */
*      3 RQEPURGE BIT(1),          /* PURGE IN CONTROL               */
*      3 RQECHEAC BIT(1),          /* CHANNEL END APPENDAGE COMPL    */
*    2 RQEFLAG3  BIT(8),           /* FLAG BYTE 3            @ZM32371*/
*      3 RQEINIOS BIT(1),          /* REQUEST IN IOS         @ZM32371*/
*      3 * BIT(7),                 /* UNUSED                 @ZM32371*/
*    2 RQEEND CHAR(0);             /* END OF RQE                     */
*%DCL RQEBL CHAR;
*%RQEBL='RQEEND-RQEUCB';           /* LENGTH OF RQE                  */
