         TITLE 'IECIOFT1-IOS CONTROL BLOCK FORMAT MODULE               *
                        '
IECIOFT1 CSECT ,                                                   0001
@MAINENT DS    0H                                                  0001
         USING *,@15                                               0001
         B     @PROLOG                                             0001
         DC    AL2(@EP00001-@MAINENT)
         DC    AL1(16)                                             0001
         DC    C'IECIOFT1  77.005'                                 0001
IECIOEXD DS    0H                                                  0001
         USING *,@15                                               0001
         B     @PROLOG                                             0001
         DC    AL2(@EP00119-IECIOEXD)
         ENTRY IECIOEXD
IECIOUCB DS    0H                                                  0001
         USING *,@15                                               0001
         B     @PROLOG                                             0001
         DC    AL2(@EP00154-IECIOUCB)
         ENTRY IECIOUCB
         DROP  @15
@PROLOG  STM   @14,@12,12(@13)                                     0001
         BALR  @12,0                                               0001
@PSTART  DS    0H                                                  0001
         USING @PSTART,@12                                         0001
         L     @00,@SIZDATD                                        0001
         GETMAIN  R,LV=(0)
         LR    @11,@01                                             0001
         USING @DATD,@11                                           0001
         ST    @13,@SA00001+4                                      0001
         LM    @15,@01,16(@13)                                     0001
         ST    @11,8(,@13)                                         0001
         LR    @13,@11                                             0001
         AH    @15,4(,@15)                                         0001
         BR    @15                                                 0001
@EP00001 DS    0H                                                  0002
*IECIOEXD:                                                         0119
*   ENTRY;                                                         0119
*                                                                  0119
@EP00119 DS    0H                                                  0120
*/********************************************************************/
*/* FUNCTION -                                                     0120
*      ROUTINE WHICH FORMATS THE IOS EXCP DEBUG AREA (XDBA,ALSO KNOWN
*      AS EXCPD). IT SETS UP THE POINTERS TO BE PASSED TO THE FORMAT
*      SERVICE ROUTINE SENT IN THE PARAMETER LIST. FOR A NON-ZERO  0120
*      RETURN CODE FROM THE FORMATTING SERVICE THE FOLLOWING MESSAGE
*      WILL BE PRINTED:                                            0120
*               *** FORMATTING SERVICE ROUTINE ERROR DURING EXCPD(XDBA)
*                   FORMATTING (POSSIBLE CAUSE: DATA NOT IN DUMP) ***
*      AT THIS POINT PROCESSING WOULD TERMINATE.                   0120
*                                                                  0120
*   INPUT -                                                        0120
*      REGISTER 1 POINTS TO THE PARAMETER WHICH CONTAINS THE ADDRESS
*      OF THE CONTROL BLOCK TO BE FORMATTED IN ADPLFMT2. ADPLFMT1, ALSO
*      DEFINED AS START,CONTAINS THE OFFSET TO BE PLACED ALONG SIDE THE
*      FIRST FIELD IN THE CONTROL BLOCK, AND ADPLCOM1 HAS THE ADDRESS
*      OF THE ESTAE PARAMETER LIST.                                0120
*                                                                  0120
*   CALLS -                                                        0120
*      CONVERT, FMTRTN, AND PRINT                                  0120
*                                                                  0120
*   CALLED BY -                                                    0120
*      IECIOFMT TO FORMAT THE XDBA(EXCPD)                          0120
*                                                                  0120
*   RETURNS TO -                                                   0120
*      CALLER WITH THE RETURN CODE SET BT THE FORMAT SERVICE ROUTINE
*                                                                    */
*/********************************************************************/
*                                                                  0120
*   ESTAPTR=ADPLCOM1;               /* SAVE PTR TO ESTAE PARM LIST   */
         L     ESTAPTR,ADPLCOM1(,ABDPLPTR)                         0120
*   EXCPDPTR=ADPLFMT2;              /* POINTER TO EXCPD PASSED IN  0121
*                                      PARMLIST                      */
         L     EXCPDPTR,ADPLFMT2(,ABDPLPTR)                        0121
*   SAVEPTR=EXCPDPTR-START;         /* VALUE FOR OFFSETS             */
         LR    SAVEPTR,EXCPDPTR                                    0122
         SL    SAVEPTR,START(,ABDPLPTR)                            0122
*   ADPLCOM1=ADDR(EXCPDMSG);        /* ERROR MSG                     */
         LA    @14,EXCPDMSG                                        0123
         ST    @14,ADPLCOM1(,ABDPLPTR)                             0123
*   STM(VADR,RCREG,LCALREGS);       /* SAVE REGS FOR EXPECTED RETRY  */
         STM   VADR,RCREG,LCALREGS(ESTAPTR)                        0124
*   ERRSW=OFF;                      /* ERROR INDICATOR               */
*                                                                  0125
         NI    ERRSW,B'01111111'                                   0125
*   /*****************************************************************/
*   /*                                                               */
*   /* PRINT THE HEADER FOR THE XDBA                                 */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0126
*   BUFFER(1:LENGTH(EXCPDHDR))=EXCPDHDR;/* TITLE LINE                */
         L     @14,ADPLBUF(,ABDPLPTR)                              0126
         MVC   BUFFER(54,@14),EXCPDHDR                             0126
*   PACKAREA=EXCPDPTR;              /* MOVE ADDR INTO CHAR AREA      */
         ST    EXCPDPTR,PACKAREA                                   0127
*   GARBAGE='04'X;                  /* GARBAGE BYTE FOR UNPACK       */
         MVI   GARBAGE,X'04'                                       0128
*   UNPK(ADDRESS,UNPACK);           /* UNPACK INTO BUFFER LINE       */
         UNPK  ADDRESS(9,@14),UNPACK(5)                            0129
*   TR(ADDRESS,TRANS);              /* MAKE PRINTABLE                */
         TR    ADDRESS(9,@14),TRANS                                0130
*   CALL PRINT;                     /* PRINT IT                      */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0131
         BALR  @14,@15                                             0131
*   BUFFER(1:LENGTH(EXCPUS))=EXCPUS;/* UNDERSCORE                    */
         L     @14,ADPLBUF(,ABDPLPTR)                              0132
         MVC   BUFFER(6,@14),EXCPUS                                0132
*   CALL PRINT;                     /* PRINT IT                      */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0133
         BALR  @14,@15                                             0133
*   CALL PRINT;                     /* BLANK                         */
*                                                                  0134
         L     @15,ADPLPRNT(,ABDPLPTR)                             0134
         BALR  @14,@15                                             0134
*   /*****************************************************************/
*   /*                                                               */
*   /* FORMAT THE FIRST SECTION OF THE XDBA                          */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0135
*   DO ARRAYCNT=1 TO DIM(XDBANAME) WHILE(ERRSW=OFF);/* PRINT ALL   0135
*                                      LINES FOR XDBA UNTIL RQE      */
         LA    ARRAYCNT,1                                          0135
@DL00135 TM    ERRSW,B'10000000'                                   0135
         BNZ   @DC00135                                            0135
*     LINEPTR=XDBANAME(ARRAYCNT);   /* POINTER TO FORMAT PATTERN     */
         LR    @14,ARRAYCNT                                        0136
         SLA   @14,2                                               0136
         L     LINEPTR,XDBANAME-4(@14)                             0136
*     CALL CONVERT;                 /* GENERATE OFFSET               */
         BAL   @14,CONVERT                                         0137
*     CALL FMTRTN;                  /* FORMAT AND PRINT              */
         BAL   @14,FMTRTN                                          0138
*   END;                            /* END FORMAT LOOP               */
         AH    ARRAYCNT,@CH00039                                   0139
         CH    ARRAYCNT,@CH00154                                   0139
         BNH   @DL00135                                            0139
@DC00135 DS    0H                                                  0140
*   LINEPTR=ADDR(XDBAF5);           /* NEXT FORMAT PATTERN WHICH GET
*                                      REPEATED A NUMBER OF TIMES    */
         LA    LINEPTR,XDBAF5                                      0140
*   DO ARRAYCNT=1 TO LISTMAX WHILE(ERRSW=OFF);/* REST OF CONTROL   0141
*                                      BLOCK                         */
         LA    ARRAYCNT,1                                          0141
@DL00141 TM    ERRSW,B'10000000'                                   0141
         BNZ   @DC00141                                            0141
*     CALL CONVERT;                 /* GENERATE OFFSET               */
         BAL   @14,CONVERT                                         0142
*     CALL FMTRTN;                  /* FORMAT AND PRINT              */
         BAL   @14,FMTRTN                                          0143
*   END;                            /* END REST OF XDBA FORMATTING   */
         AH    ARRAYCNT,@CH00039                                   0144
         CH    ARRAYCNT,@CH00967                                   0144
         BNH   @DL00141                                            0144
@DC00141 DS    0H                                                  0145
*   IF ERRSW=OFF THEN               /* FORMATTED ALL LINES SO FAR OK */
         TM    ERRSW,B'10000000'                                   0145
         BNZ   @RF00145                                            0145
*     DO;                                                          0146
*       LINEPTR=ADDR(XDBAF3);       /* LAST LINE OF OUTPUT           */
         LA    LINEPTR,XDBAF3                                      0147
*       CALL CONVERT;               /* GENERATE OFFSET               */
         BAL   @14,CONVERT                                         0148
*       CALL FMTRTN;                /* FORMAT AND PRINT              */
         BAL   @14,FMTRTN                                          0149
*     END;                          /* END FORMATTED ALL LINES OK    */
*   ELSE                                                           0151
*     ;                             /* ERROR FORMATTING BEB/FIX LISTS*/
@RF00145 DS    0H                                                  0152
*   LCALREGS=RTYREGS;               /* RESTORE CALLERS EXPECTED ERROR
*                                      REGS                          */
         MVC   LCALREGS(64,ESTAPTR),RTYREGS(ESTAPTR)               0152
*   RETURN CODE(RCCODE);                                           0153
         L     @13,4(,@13)                                         0153
         L     @00,@SIZDATD                                        0153
         LR    @01,@11                                             0153
         FREEMAIN R,LV=(0),A=(1)
         LR    @15,@07                                             0153
         L     @14,12(,@13)                                        0153
         LM    @00,@12,20(@13)                                     0153
         BR    @14                                                 0153
*IECIOUCB:                                                         0154
*   ENTRY;                                                         0154
*                                                                  0154
@EP00154 DS    0H                                                  0155
*/********************************************************************/
*/* FUNCTION -                                                     0155
*      ROUTINE WHICH FORMATS THE UNIT CONTROL BLOCK(UCB). IT SETS  0155
*      UP THE POINTERS TO BE PASSED TO THE FORMAT SERVICE ROUTINE  0155
*      SENT IN THE PARAMETER LIST. FOR A NON-ZERO RETURN CODE FROM THE
*      FORMATTING SERVICE THE FOLLOWING MESSAGE WILL BE PRINTED:   0155
*               *** FORMATTING SERVICE ROUTINE ERROR DURING UCB    0155
*                   FORMATTING (POSSIBLE CAUSE: DATA NOT IN DUMP) ***
*      IF THERE IS AN ERROR TRYING TO ACCESS THE UCBTYPE FIELD OR IF
*      THE FIELD IS INVALID THE FOLLOWING MESSAGE WILL BE PRINTED: 0155
*               *** UNKNOWN UCB TYPE FOR UCB AT LOCATION XXXXXXXX  0155
*      AT THIS POINT, FOR EITHER REASON, PROCESSING WOULD TERMINATE.
*                                                                  0155
*   INPUT -                                                        0155
*      REGISTER 1 POINTS TO THE PARAMETER WHICH CONTAINS THE ADDRESS
*      OF THE CONTROL BLOCK TO BE FORMATTED IN ADPLFMT2. ADPLFMT1, ALSO
*      DEFINED AS START,CONTAINS THE OFFSET TO BE PLACED ALONG SIDE THE
*      FIRST FIELD IN THE CONTROL BLOCK, AND ADPLCOM1 CONTAINS THE 0155
*      ADDRESS OF THE ESTAE PARAMETER LIST.                        0155
*                                                                  0155
*   CALLS -                                                        0155
*      ACCESRTN,CONVERT,FMTRTN, AND PRINT                          0155
*                                                                  0155
*   CALLED BY -                                                    0155
*      IECIOFMT TO FORMAT THE UNIT CONTROL BLOCK                   0155
*                                                                  0155
*   RETURNS TO -                                                   0155
*      CALLER WITH THE RETURN CODE SET BY THE ACCESS OR FORMAT SERVICE
*      ROUTINE.                                                    0155
*                                                                    */
*/********************************************************************/
*                                                                  0155
*   ESTAPTR=ADPLCOM1;               /* SAVE PTR TO ESTAE PARM LIST   */
         L     ESTAPTR,ADPLCOM1(,ABDPLPTR)                         0155
*   UCBPTR=ADPLFMT2;                /* PTR TO UCB PASSED IN PARMLIST */
         L     UCBPTR,ADPLFMT2(,ABDPLPTR)                          0156
*   SAVEPTR=UCBPTR-START;           /* USED FOR FIGURING OFFSET      */
         LR    SAVEPTR,UCBPTR                                      0157
         SL    SAVEPTR,START(,ABDPLPTR)                            0157
*   ADPLCOM1=ADDR(UCBMSG);          /* FORMAT ERROR MESSAGE          */
         LA    @14,UCBMSG                                          0158
         ST    @14,ADPLCOM1(,ABDPLPTR)                             0158
*   STM(VADR,RCREG,LCALREGS);       /* SAVE REGS FOR EXPECTED RETRY  */
         STM   VADR,RCREG,LCALREGS(ESTAPTR)                        0159
*   ERRSW=OFF;                      /* INITIALIZE ERROR INDICATOR    */
*                                                                  0160
         NI    ERRSW,B'01111111'                                   0160
*   /*****************************************************************/
*   /*                                                               */
*   /* INITIALIZE HEADER FOR THE UCB                                 */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0161
*   BUFFER(1:LENGTH(UCBHDR))=UCBHDR;/* HEADER LINE                   */
         L     @14,ADPLBUF(,ABDPLPTR)                              0161
         MVC   BUFFER(54,@14),UCBHDR                               0161
*   PACKAREA=UCBPTR;                /* MOVE ADDR INTO CHAR AREA      */
         ST    UCBPTR,PACKAREA                                     0162
*   GARBAGE='04'X;                  /* GARBAGE BYTE FOR UNPACK       */
         MVI   GARBAGE,X'04'                                       0163
*   UNPK(ADDRESS,UNPACK);           /* UNPACK INTO BUFFER LINE       */
         UNPK  ADDRESS(9,@14),UNPACK(5)                            0164
*   TR(ADDRESS,TRANS);              /* MAKE PRINTABLE                */
         TR    ADDRESS(9,@14),TRANS                                0165
*   VADR=ADDR(UCBTYP);              /* DEVICE TYPE                   */
         LA    VADR,UCBTYP(,UCBPTR)                                0166
*   CALL ACCESRTN;                  /* ACCESS IT                     */
         BAL   @14,ACCESRTN                                        0167
*   IF RCREG^=ZERO|DATAWORD=ZERO THEN/* ERROR FINDING UCBTYPE        */
         SLR   @14,@14                                             0168
         CR    RCREG,@14                                           0168
         BNE   @RT00168                                            0168
         C     @14,DATAWORD(,DATAPTR)                              0168
         BNE   @RF00168                                            0168
@RT00168 DS    0H                                                  0169
*     BUFFER(1:LENGTH(UNKNOWN))=UNKNOWN;                           0169
         L     @14,ADPLBUF(,ABDPLPTR)                              0169
         MVC   BUFFER(56,@14),UNKNOWN                              0169
*   ELSE                            /* FOUND UCB TYPE TO BE INSERTED
*                                      IN THE HEADER                 */
*     DO;                                                          0170
         B     @RC00168                                            0170
@RF00168 DS    0H                                                  0171
*       TYPBYTE=DATAWORD;           /* SAVE DEVICE TYPE FIELDS       */
         MVC   TYPBYTE(4),DATAWORD(DATAPTR)                        0171
*       ADPLFMT2=ADPLFMT2-PREFIX;   /* START UCB FORMATTING AT PREFIX*/
         L     @14,ADPLFMT2(,ABDPLPTR)                             0172
         SH    @14,@CH00072                                        0172
         ST    @14,ADPLFMT2(,ABDPLPTR)                             0172
*       IF TBYTE3=MAGTAPE THEN      /* MAGNETIC TAPE UCB             */
*                                                                  0173
         CLC   TBYTE3(1),MAGTAPE                                   0173
         BNE   @RF00173                                            0173
*         /***********************************************************/
*         /*                                                         */
*         /* MAGNETIC TAPE UCB                                       */
*         /*                                                         */
*         /***********************************************************/
*                                                                  0174
*         DO;                                                      0174
*           HDRTYPE(1:LENGTH(MAGHDR))=MAGHDR;/* FILL IN UCB TYPE     */
         L     @14,ADPLBUF(,ABDPLPTR)                              0175
         MVC   HDRTYPE(20,@14),MAGHDR                              0175
*           CALL PRINT;             /* PRINT HEADER                  */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0176
         BALR  @14,@15                                             0176
*           BUFFER(1:LENGTH(UCBUS))=UCBUS;/* UNDER SCORE             */
         L     @14,ADPLBUF(,ABDPLPTR)                              0177
         MVC   BUFFER(5,@14),UCBUS                                 0177
*           CALL PRINT;             /* PRINT IT                      */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0178
         BALR  @14,@15                                             0178
*           CALL PRINT;             /* BLANK LINE                    */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0179
         BALR  @14,@15                                             0179
*           DO ARRAYCNT=1 TO DIM(MAGDARAY) WHILE(ERRSW=OFF);/* FORMAT
*                                      PATTERN ARRAY                 */
         LA    ARRAYCNT,1                                          0180
@DL00180 TM    ERRSW,B'10000000'                                   0180
         BNZ   @DC00180                                            0180
*             LINEPTR=MAGDARAY(ARRAYCNT);/* FORMAT PATTERN ADDR      */
         LR    @14,ARRAYCNT                                        0181
         SLA   @14,2                                               0181
         L     LINEPTR,MAGDARAY-4(@14)                             0181
*             CALL CONVERT;         /* GENERATE OFFSET               */
         BAL   @14,CONVERT                                         0182
*             CALL FMTRTN;          /* FORMAT                        */
         BAL   @14,FMTRTN                                          0183
*           END;                    /* END FORMAT LOOP FILL IN HDR 0184
*                                      AND FORMAT                    */
         AH    ARRAYCNT,@CH00039                                   0184
         CH    ARRAYCNT,@CH00156                                   0184
         BNH   @DL00180                                            0184
@DC00180 DS    0H                                                  0185
*         END;                      /* END MAGNETIC TAPE TYPE        */
*       ELSE                        /* NOT A MAGNETIC TAPE UCB       */
*         IF TBYTE3=CTCTYPE THEN    /* CHANNEL TO CHANNEL UCB        */
*                                                                  0186
         B     @RC00173                                            0186
@RF00173 CLC   TBYTE3(1),CTCTYPE                                   0186
         BNE   @RF00186                                            0186
*           /*********************************************************/
*           /*                                                       */
*           /* CHANNEL TO CHANNEL UCB                                */
*           /*                                                       */
*           /*********************************************************/
*                                                                  0187
*           DO;                                                    0187
*             HDRTYPE(1:LENGTH(CTCHDR))=CTCHDR;/* FILL IN UCB TYPE   */
         L     @14,ADPLBUF(,ABDPLPTR)                              0188
         MVC   HDRTYPE(25,@14),CTCHDR                              0188
*             CALL PRINT;           /* PRINT HEADER                  */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0189
         BALR  @14,@15                                             0189
*             BUFFER(1:LENGTH(UCBUS))=UCBUS;/* UNDER SCORE           */
         L     @14,ADPLBUF(,ABDPLPTR)                              0190
         MVC   BUFFER(5,@14),UCBUS                                 0190
*             CALL PRINT;           /* PRINT IT                      */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0191
         BALR  @14,@15                                             0191
*             CALL PRINT;           /* BLANK LINE                    */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0192
         BALR  @14,@15                                             0192
*             DO ARRAYCNT=1 TO DIM(CTCARRAY) WHILE(ERRSW=OFF);/*   0193
*                                      FORMAT PATTERN ARRAY          */
         LA    ARRAYCNT,1                                          0193
@DL00193 TM    ERRSW,B'10000000'                                   0193
         BNZ   @DC00193                                            0193
*               LINEPTR=CTCARRAY(ARRAYCNT);/* FORMAT PATTERN ADDR    */
         LR    @14,ARRAYCNT                                        0194
         SLA   @14,2                                               0194
         L     LINEPTR,CTCARRAY-4(@14)                             0194
*               CALL CONVERT;       /* GENERATE OFFSET               */
         BAL   @14,CONVERT                                         0195
*               CALL FMTRTN;        /* FORMAT                        */
         BAL   @14,FMTRTN                                          0196
*             END;                  /* END FORMAT LOOP FILL IN HDR 0197
*                                      AND FORMAT                    */
         AH    ARRAYCNT,@CH00039                                   0197
         CH    ARRAYCNT,@CH00156                                   0197
         BNH   @DL00193                                            0197
@DC00193 DS    0H                                                  0198
*           END;                    /* END CHANNEL TO CHANNEL UCB    */
*         ELSE                      /* NOT A CHANNEL TO CHANNEL UCB  */
*           IF TBYTE3=COMTYPE THEN  /* COMMUNICATIONS TYPE UCB       */
         B     @RC00186                                            0199
@RF00186 CLC   TBYTE3(1),COMTYPE                                   0199
         BNE   @RF00199                                            0199
*             DO;                                                  0200
*               IF(TBYTE4&MASK3704)=MASK3704 THEN/* 3704,3705 TYPE   */
         SLR   @14,@14                                             0201
         IC    @14,MASK3704                                        0201
         SLR   @10,@10                                             0201
         IC    @10,TBYTE4                                          0201
         NR    @10,@14                                             0201
         CR    @10,@14                                             0201
         BNE   @RF00201                                            0201
*                 DO;                                              0202
*                                                                  0202
*                   /*************************************************/
*                   /*                                               */
*                   /* 3704,3705 UCB                                 */
*                   /*                                               */
*                   /*************************************************/
*                                                                  0203
*                   HDRTYPE(1:LENGTH(HDR3704))=HDR3704;/* FILL IN UCB
*                                      TYPE                          */
         L     @14,ADPLBUF(,ABDPLPTR)                              0203
         MVC   HDRTYPE(31,@14),HDR3704                             0203
*                   CALL PRINT;     /* PRINT HEADER                  */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0204
         BALR  @14,@15                                             0204
*                   BUFFER(1:LENGTH(UCBUS))=UCBUS;/* UNDER SCORE     */
         L     @14,ADPLBUF(,ABDPLPTR)                              0205
         MVC   BUFFER(5,@14),UCBUS                                 0205
*                   CALL PRINT;     /* PRINT IT                      */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0206
         BALR  @14,@15                                             0206
*                   CALL PRINT;     /* BLANK LINE                    */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0207
         BALR  @14,@15                                             0207
*                   DO ARRAYCNT=1 TO DIM(ARRY3704) WHILE(ERRSW=OFF);
         LA    ARRAYCNT,1                                          0208
@DL00208 TM    ERRSW,B'10000000'                                   0208
         BNZ   @DC00208                                            0208
*                                   /* FORMAT PATTERN ARRAY          */
*                     LINEPTR=ARRY3704(ARRAYCNT);/* FORMAT PATTERN 0209
*                                      ADDR                          */
         LR    @14,ARRAYCNT                                        0209
         SLA   @14,2                                               0209
         L     LINEPTR,ARRY3704-4(@14)                             0209
*                     CALL CONVERT; /* GENERATE OFFSET               */
         BAL   @14,CONVERT                                         0210
*                     CALL FMTRTN;  /* FORMAT                        */
         BAL   @14,FMTRTN                                          0211
*                   END;            /* END FORMAT LOOP FILL IN HDR 0212
*                                      AND FORMAT                    */
         AH    ARRAYCNT,@CH00039                                   0212
         CH    ARRAYCNT,@CH00156                                   0212
         BNH   @DL00208                                            0212
@DC00208 DS    0H                                                  0213
*                 END;              /* END 3704,3705 TYPE            */
*               ELSE                /* NOT 3704,3705 TYPE            */
*                 DO;                                              0214
*                                                                  0214
         B     @RC00201                                            0214
@RF00201 DS    0H                                                  0215
*                   /*************************************************/
*                   /*                                               */
*                   /* COMMUNICATIONS UCB                            */
*                   /*                                               */
*                   /*************************************************/
*                                                                  0215
*                   HDRTYPE(1:LENGTH(COMHDR))=COMHDR;/* FILL IN UCB
*                                      TYPE                          */
         L     @14,ADPLBUF(,ABDPLPTR)                              0215
         MVC   HDRTYPE(21,@14),COMHDR                              0215
*                   CALL PRINT;     /* PRINT HEADER                  */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0216
         BALR  @14,@15                                             0216
*                   BUFFER(1:LENGTH(UCBUS))=UCBUS;/* UNDER SCORE     */
         L     @14,ADPLBUF(,ABDPLPTR)                              0217
         MVC   BUFFER(5,@14),UCBUS                                 0217
*                   CALL PRINT;     /* PRINT IT                      */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0218
         BALR  @14,@15                                             0218
*                   CALL PRINT;     /* BLANK LINE                    */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0219
         BALR  @14,@15                                             0219
*                   DO ARRAYCNT=1 TO DIM(COMARRAY) WHILE(ERRSW=OFF);
         LA    ARRAYCNT,1                                          0220
@DL00220 TM    ERRSW,B'10000000'                                   0220
         BNZ   @DC00220                                            0220
*                                   /* FORMAT PATTERN ARRAY          */
*                     LINEPTR=COMARRAY(ARRAYCNT);/* FORMAT PATTERN 0221
*                                      ADDR                          */
         LR    @14,ARRAYCNT                                        0221
         SLA   @14,2                                               0221
         L     LINEPTR,COMARRAY-4(@14)                             0221
*                     CALL CONVERT; /* GENERATE OFFSET               */
         BAL   @14,CONVERT                                         0222
*                     CALL FMTRTN;  /* FORMAT                        */
         BAL   @14,FMTRTN                                          0223
*                   END;            /* END FORMAT LOOP FILL IN HDR 0224
*                                      AND FORMAT                    */
         AH    ARRAYCNT,@CH00039                                   0224
         CH    ARRAYCNT,@CH00154                                   0224
         BNH   @DL00220                                            0224
@DC00220 DS    0H                                                  0225
*                 END;              /* END NOT 3704,3705 UCB         */
*             END;                  /* END COMMUNICATIONS UCB        */
*           ELSE                    /* NOT COMMUNICATIONS UCB        */
*             IF TBYTE3=DATYPE THEN /* DIRECT ACCESS TYPE            */
         B     @RC00199                                            0227
@RF00199 CLC   TBYTE3(1),DATYPE                                    0227
         BNE   @RF00227                                            0227
*               DO;                                                0228
*                                                                  0228
*                 /***************************************************/
*                 /*                                                 */
*                 /* DIRECT ACCESS UCB                               */
*                 /*                                                 */
*                 /***************************************************/
*                                                                  0229
*                 HDRTYPE(1:LENGTH(DAHDR))=DAHDR;/* FILL IN UCB TYPE */
         L     @14,ADPLBUF(,ABDPLPTR)                              0229
         MVC   HDRTYPE(20,@14),DAHDR                               0229
*                 CALL PRINT;       /* PRINT HEADER                  */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0230
         BALR  @14,@15                                             0230
*                 BUFFER(1:LENGTH(UCBUS))=UCBUS;/* UNDER SCORE       */
         L     @14,ADPLBUF(,ABDPLPTR)                              0231
         MVC   BUFFER(5,@14),UCBUS                                 0231
*                 CALL PRINT;       /* PRINT IT                      */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0232
         BALR  @14,@15                                             0232
*                 CALL PRINT;       /* BLANK LINE                    */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0233
         BALR  @14,@15                                             0233
*                 DO ARRAYCNT=1 TO DIM(DARRAY) WHILE(ERRSW=OFF);/* 0234
*                                      FORMAT PATTERN ARRAY          */
         LA    ARRAYCNT,1                                          0234
@DL00234 TM    ERRSW,B'10000000'                                   0234
         BNZ   @DC00234                                            0234
*                   LINEPTR=DARRAY(ARRAYCNT);/* FORMAT PATTERN ADDR  */
         LR    @14,ARRAYCNT                                        0235
         SLA   @14,2                                               0235
         L     LINEPTR,DARRAY-4(@14)                               0235
*                   CALL CONVERT;   /* GENERATE OFFSET               */
         BAL   @14,CONVERT                                         0236
*                   CALL FMTRTN;    /* FORMAT                        */
         BAL   @14,FMTRTN                                          0237
*                 END;              /* END FORMAT LOOP FILL IN HDR 0238
*                                      AND FORMAT                    */
         AH    ARRAYCNT,@CH00039                                   0238
         CH    ARRAYCNT,@CH00156                                   0238
         BNH   @DL00234                                            0238
@DC00234 DS    0H                                                  0239
*               END;                /* END DIRECT ACCESS UCB         */
*             ELSE                  /* NOT DIRECT ACCESS TYPE        */
*               IF TBYTE3=GRAPHICS THEN/* GRAPHICS TYPE              */
         B     @RC00227                                            0240
@RF00227 CLC   TBYTE3(1),GRAPHICS                                  0240
         BNE   @RF00240                                            0240
*                 DO;                                              0241
*                                                                  0241
*                   /*************************************************/
*                   /*                                               */
*                   /* GRAPHICS UCB                                  */
*                   /*                                               */
*                   /*************************************************/
*                                                                  0242
*                   HDRTYPE(1:LENGTH(GRAPHDR))=GRAPHDR;/* FILL IN UCB
*                                      TYPE                          */
         L     @14,ADPLBUF(,ABDPLPTR)                              0242
         MVC   HDRTYPE(15,@14),GRAPHDR                             0242
*                   CALL PRINT;     /* PRINT HEADER                  */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0243
         BALR  @14,@15                                             0243
*                   BUFFER(1:LENGTH(UCBUS))=UCBUS;/* UNDER SCORE     */
         L     @14,ADPLBUF(,ABDPLPTR)                              0244
         MVC   BUFFER(5,@14),UCBUS                                 0244
*                   CALL PRINT;     /* PRINT IT                      */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0245
         BALR  @14,@15                                             0245
*                   CALL PRINT;     /* BLANK LINE                    */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0246
         BALR  @14,@15                                             0246
*                   DO ARRAYCNT=1 TO DIM(GRAPHARY) WHILE(ERRSW=OFF);
         LA    ARRAYCNT,1                                          0247
@DL00247 TM    ERRSW,B'10000000'                                   0247
         BNZ   @DC00247                                            0247
*                                   /* FORMAT PATTERN ARRAY          */
*                     LINEPTR=GRAPHARY(ARRAYCNT);/* FORMAT PATTERN 0248
*                                      ADDR                          */
         LR    @14,ARRAYCNT                                        0248
         SLA   @14,2                                               0248
         L     LINEPTR,GRAPHARY-4(@14)                             0248
*                     CALL CONVERT; /* GENERATE OFFSET               */
         BAL   @14,CONVERT                                         0249
*                     CALL FMTRTN;  /* FORMAT                        */
         BAL   @14,FMTRTN                                          0250
*                   END;            /* END FORMAT LOOP FILL IN HDR 0251
*                                      AND FORMAT                    */
         AH    ARRAYCNT,@CH00039                                   0251
         CH    ARRAYCNT,@CH00156                                   0251
         BNH   @DL00247                                            0251
@DC00247 DS    0H                                                  0252
*                 END;              /* END GRAPHICS UCB              */
*               ELSE                /* NOT GRAPHICS TYPE             */
*                 IF TBYTE3=UNITREC THEN/* UNIT RECORD TYPE          */
         B     @RC00240                                            0253
@RF00240 CLC   TBYTE3(1),UNITREC                                   0253
         BNE   @RF00253                                            0253
*                   DO;                                            0254
*                     IF TBYTE4=MASK3800 THEN/* 3800 DEVICE TYPE     */
         CLC   TBYTE4(1),MASK3800                                  0255
         BNE   @RF00255                                            0255
*                       DO;                                        0256
*                                                                  0256
*                         /*******************************************/
*                         /*                                         */
*                         /* 3800 DEVICE UCB                         */
*                         /*                                         */
*                         /*******************************************/
*                                                                  0257
*                         HDRTYPE(1:LENGTH(HDR3800))=HDR3800;/* FILL
*                                      IN UCB TYPE                   */
         L     @14,ADPLBUF(,ABDPLPTR)                              0257
         MVC   HDRTYPE(13,@14),HDR3800                             0257
*                         CALL PRINT;/* PRINT HEADER                 */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0258
         BALR  @14,@15                                             0258
*                         BUFFER(1:LENGTH(UCBUS))=UCBUS;/* UNDER   0259
*                                      SCORE                         */
         L     @14,ADPLBUF(,ABDPLPTR)                              0259
         MVC   BUFFER(5,@14),UCBUS                                 0259
*                         CALL PRINT;/* PRINT IT                     */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0260
         BALR  @14,@15                                             0260
*                         CALL PRINT;/* BLANK LINE                   */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0261
         BALR  @14,@15                                             0261
*                         DO ARRAYCNT=1 TO DIM(ARY3800) WHILE(ERRSW=OFF
*                               );  /* FORMAT PATTERN ARRAY          */
         LA    ARRAYCNT,1                                          0262
@DL00262 TM    ERRSW,B'10000000'                                   0262
         BNZ   @DC00262                                            0262
*                           LINEPTR=ARY3800(ARRAYCNT);/* FORMAT    0263
*                                      PATTERN ADDR                  */
         LR    @14,ARRAYCNT                                        0263
         SLA   @14,2                                               0263
         L     LINEPTR,ARY3800-4(@14)                              0263
*                           CALL CONVERT;/* GENERATE OFFSET          */
         BAL   @14,CONVERT                                         0264
*                           CALL FMTRTN;/* FORMAT                    */
         BAL   @14,FMTRTN                                          0265
*                         END;      /* END FORMAT LOOP FILL IN HDR 0266
*                                      AND FORMAT                    */
         AH    ARRAYCNT,@CH00039                                   0266
         CH    ARRAYCNT,@CH00156                                   0266
         BNH   @DL00262                                            0266
@DC00262 DS    0H                                                  0267
*                       END;        /* END 3800 DEVICE UCB           */
*                     ELSE          /* NOT 3800 DEVICE TYPE          */
*                       IF TBYTE4=MASK3851 THEN/* 3851 DEVICE TYPE   */
         B     @RC00255                                            0268
@RF00255 CLC   TBYTE4(1),MASK3851                                  0268
         BNE   @RF00268                                            0268
*                         DO;                                      0269
*                                                                  0269
*                           /*****************************************/
*                           /*                                       */
*                           /* 3851 DEVICE UCB                       */
*                           /*                                       */
*                           /*****************************************/
*                                                                  0270
*                           HDRTYPE(1:LENGTH(HDR3851))=HDR3851;/*  0270
*                                      FILL IN UCB TYPE              */
         L     @14,ADPLBUF(,ABDPLPTR)                              0270
         MVC   HDRTYPE(18,@14),HDR3851                             0270
*                           CALL PRINT;/* PRINT HEADER               */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0271
         BALR  @14,@15                                             0271
*                           BUFFER(1:LENGTH(UCBUS))=UCBUS;/* UNDER 0272
*                                      SCORE                         */
         L     @14,ADPLBUF(,ABDPLPTR)                              0272
         MVC   BUFFER(5,@14),UCBUS                                 0272
*                           CALL PRINT;/* PRINT IT                   */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0273
         BALR  @14,@15                                             0273
*                           CALL PRINT;/* BLANK LINE                 */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0274
         BALR  @14,@15                                             0274
*                           DO ARRAYCNT=1 TO DIM(ARY3851) WHILE(ERRSW=
*                                 OFF);/* FORMAT PATTERN ARRAY       */
         LA    ARRAYCNT,1                                          0275
@DL00275 TM    ERRSW,B'10000000'                                   0275
         BNZ   @DC00275                                            0275
*                             LINEPTR=ARY3851(ARRAYCNT);/* FORMAT  0276
*                                      PATTERN ADDR                  */
         LR    @14,ARRAYCNT                                        0276
         SLA   @14,2                                               0276
         L     LINEPTR,ARY3851-4(@14)                              0276
*                             CALL CONVERT;/* GENERATE OFFSET        */
         BAL   @14,CONVERT                                         0277
*                             CALL FMTRTN;/* FORMAT                  */
         BAL   @14,FMTRTN                                          0278
*                           END;    /* END FORMAT LOOP FILL IN HDR 0279
*                                      AND FORMAT                    */
         AH    ARRAYCNT,@CH00039                                   0279
         CH    ARRAYCNT,@CH00156                                   0279
         BNH   @DL00275                                            0279
@DC00275 DS    0H                                                  0280
*                         END;      /* END 3851 DEVICE UCB           */
*                       ELSE        /* NOT 3851 DEVICE TYPE          */
*                         IF(TBYTE2&UCHARSET)=UCHARSET THEN/*      0281
*                                      UNIVERSAL CHAR SET            */
         B     @RC00268                                            0281
@RF00268 SLR   @14,@14                                             0281
         IC    @14,UCHARSET                                        0281
         SLR   @10,@10                                             0281
         IC    @10,TBYTE2                                          0281
         NR    @10,@14                                             0281
         CR    @10,@14                                             0281
         BNE   @RF00281                                            0281
*                           DO;                                    0282
*                                                                  0282
*                             /***************************************/
*                             /*                                     */
*                             /* UNIT RECORD UCB WITH UNIVERSAL      */
*                             /* CHARACTER SET                       */
*                             /*                                     */
*                             /***************************************/
*                                                                  0283
*                             HDRTYPE(1:LENGTH(UCHARHDR))=UCHARHDR;/*
*                                      FILL IN UCB TYPE              */
         L     @14,ADPLBUF(,ABDPLPTR)                              0283
         MVC   HDRTYPE(31,@14),UCHARHDR                            0283
*                             CALL PRINT;/* PRINT HEADER             */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0284
         BALR  @14,@15                                             0284
*                             BUFFER(1:LENGTH(UCBUS))=UCBUS;/* UNDER
*                                      SCORE                         */
         L     @14,ADPLBUF(,ABDPLPTR)                              0285
         MVC   BUFFER(5,@14),UCBUS                                 0285
*                             CALL PRINT;/* PRINT IT                 */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0286
         BALR  @14,@15                                             0286
*                             CALL PRINT;/* BLANK LINE               */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0287
         BALR  @14,@15                                             0287
*                             DO ARRAYCNT=1 TO DIM(UCHARRAY) WHILE(
*                                   ERRSW=OFF);/* FORMAT PATTERN   0288
*                                      ARRAY                         */
         LA    ARRAYCNT,1                                          0288
@DL00288 TM    ERRSW,B'10000000'                                   0288
         BNZ   @DC00288                                            0288
*                               LINEPTR=UCHARRAY(ARRAYCNT);/* FORMAT
*                                      PATTERN ADDR                  */
         LR    @14,ARRAYCNT                                        0289
         SLA   @14,2                                               0289
         L     LINEPTR,UCHARRAY-4(@14)                             0289
*                               CALL CONVERT;/* GENERATE OFFSET      */
         BAL   @14,CONVERT                                         0290
*                               CALL FMTRTN;/* FORMAT                */
         BAL   @14,FMTRTN                                          0291
*                             END;  /* END FORMAT LOOP FORMAT        */
         AH    ARRAYCNT,@CH00039                                   0292
         CH    ARRAYCNT,@CH00156                                   0292
         BNH   @DL00288                                            0292
@DC00288 DS    0H                                                  0293
*                           END;    /* END UNIVERSAL CHAR SET        */
*                         ELSE      /* NOT UNIVERSAL CHAR SET        */
*                           DO;                                    0294
*                                                                  0294
         B     @RC00281                                            0294
@RF00281 DS    0H                                                  0295
*                             /***************************************/
*                             /*                                     */
*                             /* UNIT RECORD UCB                     */
*                             /*                                     */
*                             /***************************************/
*                                                                  0295
*                             HDRTYPE(1:LENGTH(UNITHDR))=UNITHDR;/*
*                                      FILL IN UCB TYPE              */
         L     @14,ADPLBUF(,ABDPLPTR)                              0295
         MVC   HDRTYPE(18,@14),UNITHDR                             0295
*                             CALL PRINT;/* PRINT HEADER             */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0296
         BALR  @14,@15                                             0296
*                             BUFFER(1:LENGTH(UCBUS))=UCBUS;/* UNDER
*                                      SCORE                         */
         L     @14,ADPLBUF(,ABDPLPTR)                              0297
         MVC   BUFFER(5,@14),UCBUS                                 0297
*                             CALL PRINT;/* PRINT IT                 */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0298
         BALR  @14,@15                                             0298
*                             CALL PRINT;/* BLANK LINE               */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0299
         BALR  @14,@15                                             0299
*                             DO ARRAYCNT=1 TO DIM(UNITARY) WHILE(ERRSW
*                                   =OFF);/* FORMAT PATTERN ARRAY    */
         LA    ARRAYCNT,1                                          0300
@DL00300 TM    ERRSW,B'10000000'                                   0300
         BNZ   @DC00300                                            0300
*                               LINEPTR=UNITARY(ARRAYCNT);/* FORMAT
*                                      PATTERN ADDR                  */
         LR    @14,ARRAYCNT                                        0301
         SLA   @14,2                                               0301
         L     LINEPTR,UNITARY-4(@14)                              0301
*                               CALL CONVERT;/* GENERATE OFFSET      */
         BAL   @14,CONVERT                                         0302
*                               CALL FMTRTN;/* FORMAT                */
         BAL   @14,FMTRTN                                          0303
*                             END;  /* END FORMAT LOOP FORMAT        */
         AH    ARRAYCNT,@CH00039                                   0304
         CH    ARRAYCNT,@CH00154                                   0304
         BNH   @DL00300                                            0304
@DC00300 DS    0H                                                  0305
*                           END;    /* END NOT UNIVERSAL CHAR SET    */
*                   END;            /* END UNIT RECORD UCB           */
*                 ELSE              /* NOT UNIT RECORD TYPE          */
*                   IF TBYTE3=CHARRDR THEN/* CHARACTER READER TYPE   */
         B     @RC00253                                            0307
@RF00253 CLC   TBYTE3(1),CHARRDR                                   0307
         BNE   @RF00307                                            0307
*                     DO;                                          0308
*                                                                  0308
*                       /*********************************************/
*                       /*                                           */
*                       /* CHARACTER READER UCB                      */
*                       /*                                           */
*                       /*********************************************/
*                                                                  0309
*                       HDRTYPE(1:LENGTH(CHARHDR))=CHARHDR;/* FILL IN
*                                      UCB TYPE                      */
         L     @14,ADPLBUF(,ABDPLPTR)                              0309
         MVC   HDRTYPE(18,@14),CHARHDR                             0309
*                       CALL PRINT; /* PRINT HEADER                  */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0310
         BALR  @14,@15                                             0310
*                       BUFFER(1:LENGTH(UCBUS))=UCBUS;/* UNDER SCORE */
         L     @14,ADPLBUF(,ABDPLPTR)                              0311
         MVC   BUFFER(5,@14),UCBUS                                 0311
*                       CALL PRINT; /* PRINT IT                      */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0312
         BALR  @14,@15                                             0312
*                       CALL PRINT; /* BLANK LINE                    */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0313
         BALR  @14,@15                                             0313
*                       DO ARRAYCNT=1 TO DIM(CHARARY) WHILE(ERRSW=OFF);
         LA    ARRAYCNT,1                                          0314
@DL00314 TM    ERRSW,B'10000000'                                   0314
         BNZ   @DC00314                                            0314
*                                   /* FORMAT PATTERN ARRAY          */
*                         LINEPTR=CHARARY(ARRAYCNT);/* FORMAT PATTERN
*                                      ADDR                          */
         LR    @14,ARRAYCNT                                        0315
         SLA   @14,2                                               0315
         L     LINEPTR,CHARARY-4(@14)                              0315
*                         CALL CONVERT;/* GENERATE OFFSET            */
         BAL   @14,CONVERT                                         0316
*                         CALL FMTRTN;/* FORMAT                      */
         BAL   @14,FMTRTN                                          0317
*                       END;        /* END FORMAT LOOP FORMAT        */
         AH    ARRAYCNT,@CH00039                                   0318
         CH    ARRAYCNT,@CH00154                                   0318
         BNH   @DL00314                                            0318
@DC00314 DS    0H                                                  0319
*                     END;          /* END CHARACTER READER UCB      */
*                   ELSE            /* INVALID UCB TYPE              */
*                     BUFFER(1:LENGTH(UNKNOWN))=UNKNOWN;           0320
         B     @RC00307                                            0320
@RF00307 L     @14,ADPLBUF(,ABDPLPTR)                              0320
         MVC   BUFFER(56,@14),UNKNOWN                              0320
*     END;                          /* END FOUND UCB TYPE FIELD      */
@RC00307 DS    0H                                                  0321
@RC00253 DS    0H                                                  0321
@RC00240 DS    0H                                                  0321
@RC00227 DS    0H                                                  0321
@RC00199 DS    0H                                                  0321
@RC00186 DS    0H                                                  0321
@RC00173 DS    0H                                                  0322
*   CALL PRINT;                     /* BLANK LINE OR ERROR MSG       */
@RC00168 L     @15,ADPLPRNT(,ABDPLPTR)                             0322
         BALR  @14,@15                                             0322
*   LCALREGS=RTYREGS;               /* RESTORE CALLERS EXPECTED ERROR
*                                      REGS                          */
         MVC   LCALREGS(64,ESTAPTR),RTYREGS(ESTAPTR)               0323
*   RETURN CODE(RCCODE);                                           0324
         L     @13,4(,@13)                                         0324
         L     @00,@SIZDATD                                        0324
         LR    @01,@11                                             0324
         FREEMAIN R,LV=(0),A=(1)
         LR    @15,@07                                             0324
         L     @14,12(,@13)                                        0324
         LM    @00,@12,20(@13)                                     0324
         BR    @14                                                 0324
*CONVERT:                                                          0325
*   PROC OPTIONS(SAVE(14));                                        0325
*                                                                  0325
CONVERT  ST    @14,12(,@13)                                        0325
*/********************************************************************/
*/* FUNCTION -                                                     0326
*      ROUTINE TO DYNAMICALLY GENERATE THE OFFSETS TO BE PUT ALONGSIDE
*      THE CONTROL BLOCK LINE.  IT FIGURES THE OFFSET FROM THE     0326
*      BEGINNING OF THE CONTROL BLOCK, CONVERTS IT TO PRINTABLE HEX,
*      PLACES IT INTO A BUFFER AREA AND PUTS THE ADDRESS OF THIS   0326
*      BUFFER AREA INTO THE PARAMETER LIST TO BE PICKED UP IN THE  0326
*      FORMAT PATTERNS BY THE FORMAT SERVICE ROUTINE.              0326
*                                                                  0326
*   NOTE  -                                                        0326
*      THIS CODE COMPARES THE ADDRESSES WITH THE HIGH ORDER BYTE   0326
*      OFF, SINCE ALL CODE IS NOT 31 BIT ADDRESSING AND SOME POINTERS
*      HAVE BITS SET IN THE HIGH ORDER BYTE OF THE ADDRESS.        0326
*                                                                  0326
*   INPUT -                                                        0326
*      SAVEPTR MUST HAVE THE ADDRESS OF THE BEGINNING OF THE CONTROL
*      BLOCK, REGISTER 1 POINTS TO THE PARMLIST WHICH CONTAINS THE 0326
*      CURRENT CONTROL BLOCK ADDRESS IN ADPLFMT2.                  0326
*                                                                  0326
*   CALLS -                                                        0326
*      MAKES NO OUTSIDE CALLS                                      0326
*                                                                  0326
*   CALLED BY -                                                    0326
*      IECIOEXD,IECIOUCB                                           0326
*                                                                  0326
*   RETURNS TO -                                                   0326
*      CALLER WITHOUT SETTING A RETURN CODE                        0326
*                                                                    */
*/********************************************************************/
*                                                                  0326
*   IF SAVEPTR>ADPLFMT2 THEN        /* THIS WILL OCCUR FOR A PREFIX
*                                      WITH A NEGATIVE OFFSET        */
         L     @14,ADPLFMT2(,ABDPLPTR)                             0326
         CR    SAVEPTR,@14                                         0326
         BNH   @RF00326                                            0326
*     DO;                                                          0327
*       NEGBIT=ON;                  /* INDICATE NEGATIVE OFFSET      */
         OI    NEGBIT,B'10000000'                                  0328
*       CONVRT=SAVEPTR-ADPLFMT2;    /* NEGATIVE OFFSET VALUE         */
         LCR   @14,@14                                             0329
         ALR   @14,SAVEPTR                                         0329
         LR    CONVRT,@14                                          0329
*     END;                          /* END NEGATIVE OFFSET           */
*   ELSE                            /* POSITIVE OR ZERO OFFSET       */
*     DO;                                                          0331
         B     @RC00326                                            0331
@RF00326 DS    0H                                                  0332
*       NEGBIT=OFF;                 /* INDICATE POS VALUE            */
         NI    NEGBIT,B'01111111'                                  0332
*       CONVRT=ADPLFMT2-SAVEPTR;    /* RELATIVE OFFSET IN CONTROL  0333
*                                      BLOCK                         */
         L     CONVRT,ADPLFMT2(,ABDPLPTR)                          0333
         SLR   CONVRT,SAVEPTR                                      0333
*     END;                          /* END POS VALUE                 */
*   DIGIT=BLANKS(1:5);              /* BLANK OUT DIGITS              */
@RC00326 MVC   DIGIT(5),BLANKS                                     0335
*   PACKAREA=CONVRT;                /* PLACE OFFSET INTO CHAR AREA 0336
*                                      FOR THE UNPACK                */
         ST    CONVRT,PACKAREA                                     0336
*   GARBAGE='04'X;                  /* GARBAGE BYTE SO OFFSET WILL 0337
*                                      UNPACK OK                     */
*                                                                  0337
         MVI   GARBAGE,X'04'                                       0337
*   /*****************************************************************/
*   /*                                                               */
*   /* FOR AN ODD NUMBER OF DIGITS THE OUTPUT SHOULD LOOK LIKE +C OR */
*   /* +13C. IF THE VALUE WAS UNPACKED DIRECTLY INTO DIGITS THE      */
*   /* OUTPUT WOULD HAVE UNWANTED LEADING ZEROS SUCH AS +0C. TO      */
*   /* ELIMINATE THIS(ONLY FOR AN ODD NUMBER OF DIGITS) UNPACK ODD   */
*   /* NUMBER OF DIGITS INTO CONVERTD WHERE THE LEADING ZERO WILL BE */
*   /* OVERWRITTEN BY THE '+' OR '-' SIGN                            */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0338
*   IF CONVRT<TWODGT THEN           /* ONLY 1 DIGIT TO OFFSET        */
         CH    CONVRT,@CH00377                                     0338
         BNL   @RF00338                                            0338
*     UNPK(CONVERTD(1:3),UNPACK(4:5));/* UNPACK ONLY 1 DIGIT AND   0339
*                                      DUMMY                         */
         UNPK  CONVERTD(3),UNPACK+3(2)                             0339
*   ELSE                                                           0340
*     IF CONVRT<THREDGT THEN        /* 2 DIGITS TO OFFSET            */
         B     @RC00338                                            0340
@RF00338 CH    CONVRT,@CH00994                                     0340
         BNL   @RF00340                                            0340
*       UNPK(DIGIT(1:3),UNPACK(4:5));/* UNPACK LAST 2 DIGITS & DUMMY */
         UNPK  DIGIT(3),UNPACK+3(2)                                0341
*     ELSE                                                         0342
*       IF CONVRT<FOURDGT THEN      /* 3 DIGITS TO OFFSET            */
         B     @RC00340                                            0342
@RF00340 CH    CONVRT,@CH00963                                     0342
         BNL   @RF00342                                            0342
*         UNPK(CONVERTD(1:5),UNPACK(3:5));/* UNPACK LAST 3 DIGITS &
*                                      DUMMY                         */
         UNPK  CONVERTD(5),UNPACK+2(3)                             0343
*       ELSE                        /* 4 DIGITS (MAX)                */
*         UNPK(DIGIT(1:5),UNPACK(3:5));/* LAST 4 DIGITS & DUMMY BYTE */
         B     @RC00342                                            0344
@RF00342 UNPK  DIGIT(5),UNPACK+2(3)                                0344
*   TR(DIGIT,TRANS);                /* MAKE PRINTABLE                */
@RC00342 DS    0H                                                  0345
@RC00340 DS    0H                                                  0345
@RC00338 TR    DIGIT(5),TRANS                                      0345
*   IF NEGBIT=ON THEN               /* WAS A NEGATIVE OFFSET         */
         TM    NEGBIT,B'10000000'                                  0346
         BNO   @RF00346                                            0346
*     PLUS=NEGCHAR;                 /* MINUS SIGN                    */
         MVI   PLUS,C'-'                                           0347
*   ELSE                            /* POSITIVE OFFSET               */
*     PLUS=PLUSCHAR;                /* MOVE IN PLUS SIGN             */
         B     @RC00346                                            0348
@RF00346 MVI   PLUS,C'+'                                           0348
*   ADPLFMT1=ADDR(CONVERTD);        /* SET UP FOR FORMAT             */
@RC00346 LA    @14,CONVERTD                                        0349
         ST    @14,ADPLFMT1(,ABDPLPTR)                             0349
*   END CONVERT;                                                   0350
@EL00002 DS    0H                                                  0350
@EF00002 DS    0H                                                  0350
@ER00002 L     @14,12(,@13)                                        0350
         BR    @14                                                 0350
*FMTRTN:                                                           0351
*   PROC OPTIONS(SAVE(14));                                        0351
*                                                                  0351
FMTRTN   ST    @14,@SA00003                                        0351
*/****************************************************************** */
*/* FUNCTION                                                       0352
*       ROUTINE TO SET UP CALLING OF THE FORMAT SERVICE ROUTINE PASSED
*     IN THE PARMLIST AND CHECKS RETURN CODE.  IF A RETURN CODE IS BAD
*     IT TAKES THE MESSAGE WHOSE ADDRESS IS IN ADPLCOM1. AND PUTS IT
*     IN THE BUFFER AND PRINTS IT. IT SETS THE ERRSW TO INDICATE BAD
*     RETURN CODE AND RETURNS. IF THE RETURN CODE WAS GOOD, IT PRINTS
*     THE FORMATTED LINE.                                          0352
*                                                                  0352
*   CALLS-                                                         0352
*       CALLS FORMAT AND PRINT                                     0352
*                                                                  0352
*   INPUT -                                                        0352
*     LINEPTR(REGISTER 0) HAS THE ADDRESS OF THE FORMAT PATTERN TO BE
*    PASSED TO THE FORMAT SERVICE ROUTINE. ADPLFMT2 CONTAINS THE CURREN
*    ADDRESS OF THE CONTROL BLOCK TO BE FORMATTED AND ,IN MOST CASES,
*    ADPLFMT1 CONTAINS THE ADDRESS OF THE FIELD 'CONVERTD' WHICH IS
*    THE EBCDIC REPRESENTATION OF THE OFFSET TO BE PLACED ALONG SIDE
*    THE OUTPUT LINE.                                              0352
*                                                                  0352
*   CALLED BY -                                                    0352
*     IECIOEXD,IECIOUCB                                            0352
*                                                                  0352
*   RETURNS CONTROL TO -                                           0352
*     CALLER WITH RETURN CODE RECIEVED FROM FORMAT                 0352
*     SERVICE ROUTINE                                              0352
*                                                                    */
*/****************************************************************** */
*                                                                  0352
*   IF ADPLSNPR=OFF THEN            /* SNAP WAS THE INVOKER          */
         TM    ADPLSNPR(ABDPLPTR),B'10000000'                      0352
         BNZ   @RF00352                                            0352
*     DO;                           /* PROTECTION IS NEEDED FROM THE
*                                      FORMAT SERVICE ROUTINE IN CASE
*                                      OF ABEND                      */
*       RTYADR=ADDR(FMTRTY);        /* WHERE TO RETRY                */
         LA    @14,FMTRTY                                          0354
         ST    @14,RTYADR(,ESTAPTR)                                0354
*       ERREXP=ON;                  /* INDICATE AN ERROR IS EXPECTED */
         OI    ERREXP(ESTAPTR),B'10000000'                         0355
*     END;                          /* END SNAP WAS INVOKER          */
*   ELSE                                                           0357
*     ;                             /* SNAP WAS NOT INVOKER          */
@RF00352 DS    0H                                                  0358
*   CALL FORMAT;                    /* FORMAT ROUTINE PASSED BY    0358
*                                      CALLER                        */
         L     @15,ADPLFRMT(,ABDPLPTR)                             0358
         BALR  @14,@15                                             0358
*   ERREXP=OFF;                     /* ERROR IS NO LONGER EXPECTED   */
         NI    ERREXP(ESTAPTR),B'01111111'                         0359
*   IF RCREG^=ZERO THEN                                            0360
         LTR   RCREG,RCREG                                         0360
         BZ    @RF00360                                            0360
*     DO;                           /* FORMAT ROUTINE ERROR          */
*FMTRTY:                            /* RETRY ADDRESS FROM ESTAE      */
*       ERRSW=ON;                   /* SET ERROR INDICATOR           */
FMTRTY   OI    ERRSW,B'10000000'                                   0362
*       CALL PRINT;                 /* SPACE A LINE                  */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0363
         BALR  @14,@15                                             0363
*       BUFFER=MSG;                 /* ERROR MSG PASSED BY CALLER  0364
*                                      WHOSE ADDR IS PLACED IN     0364
*                                      ADPLCOM1                      */
         L     @14,ADPLBUF(,ABDPLPTR)                              0364
         L     @10,ADPLCOM1(,ABDPLPTR)                             0364
         MVC   BUFFER(120,@14),MSG(@10)                            0364
*       RCREG=4;                    /* INDICATE THE FORMATTER DID NOT
*                                      FINISH SUCESSFULLY            */
         LA    RCREG,4                                             0365
*     END;                          /* END FORMAT ROUTINE ERROR      */
*   ELSE                                                           0367
*     ;                             /* FORMATTED LINE IS IN BUFFER   */
@RF00360 DS    0H                                                  0368
*   RCCODE=RCREG;                   /* SAVE RETURN CODE FROM FORMAT
*                                      SERVICE ROUTINE               */
         LR    RCCODE,RCREG                                        0368
*   CALL PRINT;                     /* PRINT THE ERROR MSG OR      0369
*                                      FORMATTED LINE                */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0369
         BALR  @14,@15                                             0369
*   RETURN CODE(RCCODE);                                           0370
         LR    @15,RCCODE                                          0370
@EL00003 DS    0H                                                  0370
@EF00003 DS    0H                                                  0370
@ER00003 L     @14,@SA00003                                        0370
         BR    @14                                                 0370
*   END FMTRTN;                                                    0371
*ACCESRTN:                                                         0372
*   PROC OPTIONS(SAVE(14));                                        0372
*                                                                  0372
ACCESRTN ST    @14,@SA00004                                        0372
*/********************************************************************/
*/* FUNCTION-                                                      0373
*       ROUTINE WHICH CALLS THE ACCESS SERVICE ROUTINE AND MOVES THE
*     VALUE RETURNED IN R0 INTO DATAPTR.                           0373
*                                                                  0373
*                                                                  0373
*   INPUT -                                                        0373
*         VADR(REGISTER 0) CONTAINS THE VIRTUAL ADDRESS OF THE FIELD
*         TO BE ACCESSED.                                          0373
*                                                                  0373
*    CALLS-                                                        0373
*         ACCESS SERVICE ROUTINE PASSED IN PARMLIST                0373
*                                                                  0373
*    CALLED BY -                                                   0373
*         IECIOEXD,IECIOUCB                                        0373
*                                                                  0373
*    RETURNS TO -                                                  0373
*         CALLER WITH THE RETURN CODE SET BY THE ACCESS            0373
*         SERVICE ROUTINE.                                         0373
*                                                                    */
*/********************************************************************/
*                                                                  0373
*   IF ADPLSNPR=OFF THEN            /* SNAP WAS INVOKER              */
         TM    ADPLSNPR(ABDPLPTR),B'10000000'                      0373
         BNZ   @RF00373                                            0373
*     DO;                                                          0374
*       RTYADR=ADDR(RETRY);         /* ESTAE RETRY ADDR FOR EXPECTED
*                                      ERROR                         */
         LA    @14,RETRY                                           0375
         ST    @14,RTYADR(,ESTAPTR)                                0375
*       DATAPTR=VADR;               /* TO GET THE PROPER BASING FOR
*                                      THE AREA                      */
         LR    DATAPTR,VADR                                        0376
*       RCREG=ZERO;                 /* SUCCESS UNLESS AN ABEND OCCURS*/
         SLR   RCREG,RCREG                                         0377
*       ERREXP=ON;                  /* INDICATE AN ERROR IS EXPECTED */
         OI    ERREXP(ESTAPTR),B'10000000'                         0378
*       VERIFY=DATADWRD;            /* MOVE A DOUBLE WORD INTO BUFFER*/
*                                                                  0379
         MVC   VERIFY(8),DATADWRD(DATAPTR)                         0379
*       /*************************************************************/
*       /*                                                           */
*       /* THIS MOVE WILL CAUSE AN ABEND IF THE DUMP DOES NOT CONTAIN*/
*       /* THE AREA REFERENCED OR IF THE AREA IS PROTECTED. IF AN    */
*       /* ABEND OCCURS, THE ESTAE WILL GET CONTROL AND RETRY AT THE */
*       /* POINT WHICH SETS A BAD RETURN CODE AND RETURNS TO THE     */
*       /* CALLER. THIS THEN SIMULATES THE PRINT DUMP ACCESS ROUTINE.*/
*       /* IF THE AREA ASKED FOR IS IN THE DUMP A DOUBLE WORD IS     */
*       /* MOVED INTO AN INTERNAL BUFFER TO PREVENT AN UNEXPECTED    */
*       /* ERROR WHEN REFERENCING THE AREA AGAIN                     */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0380
*       ERREXP=OFF;                 /* INDICATE AN ERROR IS NO LONGER
*                                      EXPECTED                      */
         NI    ERREXP(ESTAPTR),B'01111111'                         0380
*       DATAPTR=ADDR(VERIFY);       /* REBASE DATA OFF INTERNAL    0381
*                                      BUFFER                        */
         LA    DATAPTR,VERIFY                                      0381
*     END;                          /* END SNAP WAS INVOKER          */
*   ELSE                            /* CALLER HAS OWN ACCESS ROUTINE
*                                      LIKE PRINT DUMP               */
*     DO;                                                          0383
         B     @RC00373                                            0383
@RF00373 DS    0H                                                  0384
*       CALL ACCESS;                /* ACCESS SERVICE ROUTINE PASSED
*                                      BY CALLER                     */
         L     @15,ADPLMEMA(,ABDPLPTR)                             0384
         BALR  @14,@15                                             0384
*       IF RCREG=ZERO THEN                                         0385
         LTR   RCREG,RCREG                                         0385
         BNZ   @RF00385                                            0385
*         DATAPTR=VADR;             /* SAVE PTR RETURNED BY ACCESS 0386
*                                      SERVICE ROUTINE               */
         LR    DATAPTR,VADR                                        0386
*       ELSE                        /* BAD RETURN CODE               */
*RETRY:                             /* RETRY ADDR FOR ESTAE          */
*         RCREG=4;                  /* SET A BAD RETURN CODE         */
         B     @RC00385                                            0387
@RF00385 DS    0H                                                  0387
RETRY    LA    RCREG,4                                             0387
*     END;                          /* END INVOKER HAS OWN ACCESS  0388
*                                      ROUTINE                       */
@RC00385 DS    0H                                                  0389
*   RCCODE=RCREG;                   /* SAVE RETURN CODE FROM ACCESS
*                                      SERVICE RTN                   */
@RC00373 LR    RCCODE,RCREG                                        0389
*   RETURN CODE(RCCODE);                                           0390
         LR    @15,RCCODE                                          0390
@EL00004 DS    0H                                                  0390
@EF00004 DS    0H                                                  0390
@ER00004 L     @14,@SA00004                                        0390
         BR    @14                                                 0390
*   END ACCESRTN;                                                  0391
*   END IECIOFT1                                                   0392
*                                                                  0392
*/* THE FOLLOWING INCLUDE STATEMENTS WERE FOUND IN THIS PROGRAM.     */
*/*%INCLUDE SYSLIB  (IHAABDPL)                                       */
*/*%INCLUDE SYSLIB  (IEFUCBOB)                                       */
*                                                                  0392
*       ;                                                          0392
@DATA    DS    0H
@CH00039 DC    H'1'
@CH00154 DC    H'3'
@CH00156 DC    H'4'
@CH00072 DC    H'8'
@CH00377 DC    H'16'
@CH00967 DC    H'61'
@CH00994 DC    H'256'
@CH00963 DC    H'4096'
@DATD    DSECT
         DS    0F
@SA00001 DS    18F
@SA00003 DS    1F
@SA00004 DS    1F
IECIOFT1 CSECT
         DS    0F
@DATD    DSECT
         DS    0D
TYPBYTE  DS    FL4
         ORG   TYPBYTE
TBYTE1   DS    FL1
TBYTE2   DS    FL1
TBYTE3   DS    FL1
TBYTE4   DS    FL1
         ORG   TYPBYTE+4
CONVERTD DS    CL6
         ORG   CONVERTD
PLUS     DS    CL1
DIGIT    DS    CL5
         ORG   CONVERTD+6
ERRSW    DS    BL1
NEGBIT   DS    BL1
         DS    CL4
UNPACK   DS    CL5
         ORG   UNPACK
PACKAREA DS    CL4
GARBAGE  DS    CL1
         ORG   UNPACK+5
         DS    CL3
VERIFY   DS    CL8
         ORG   *+1-(*-@DATD)/(*-@DATD) INSURE DSECT DATA
@ENDDATD EQU   *
IECIOFT1 CSECT
         DS    0F
@SIZDATD DC    AL1(0)
         DC    AL3(@ENDDATD-@DATD)
         DS    0D
CHARRDR  DC    XL1'04'
COMTYPE  DC    XL1'40'
CTCTYPE  DC    XL1'41'
DATYPE   DC    XL1'20'
GRAPHICS DC    XL1'10'
MAGTAPE  DC    XL1'80'
MASK3704 DC    XL1'05'
MASK3800 DC    XL1'0E'
MASK3851 DC    XL1'42'
UCHARSET DC    XL1'80'
UNITREC  DC    XL1'08'
XDBAL1   DS    CL19
         ORG   XDBAL1
@NM00006 DC    CL4'COMP'
@NM00007 DC    CL4'FLAG'
@NM00008 DC    CL3'PSW'
@NM00009 DC    CL8'COMPCODE'
         ORG   XDBAL1+19
         DS    CL2
XDBAF1   DS    CL32
         ORG   XDBAF1
@NM00010 DS    CL4
         ORG   @NM00010
@NM00011 DC    X'01'
@NM00012 DC    X'40'
@NM00013 DC    AL1(0)
@NM00014 DC    AL1(0)
         ORG   XDBAF1+4
@NM00015 DS    CL8
         ORG   @NM00015
@NM00016 DC    X'07'
@NM00017 DC    X'31'
@NM00018 DC    AL1(8)
@NM00019 DC    AL1(13)
@NM00020 DC    AL4(XDBAL1)
         ORG   XDBAF1+12
@NM00021 DS    CL4
         ORG   @NM00021
@NM00022 DC    X'05'
@NM00023 DC    X'31'
@NM00024 DC    AL1(18)
@NM00025 DC    AL1(23)
         ORG   XDBAF1+16
@NM00026 DS    CL4
         ORG   @NM00026
@NM00027 DC    X'05'
@NM00028 DC    X'23'
@NM00029 DC    AL1(28)
@NM00030 DC    AL1(32)
         ORG   XDBAF1+20
@NM00031 DS    CL4
         ORG   @NM00031
@NM00032 DC    X'04'
@NM00033 DC    X'03'
@NM00034 DC    AL1(0)
@NM00035 DC    AL1(41)
         ORG   XDBAF1+24
@NM00036 DS    CL4
         ORG   @NM00036
@NM00037 DC    X'05'
@NM00038 DC    X'73'
@NM00039 DC    AL1(50)
@NM00040 DC    AL1(59)
         ORG   XDBAF1+28
@NM00041 DS    CL4
         ORG   @NM00041
@NM00042 DC    F'0'
         ORG   XDBAF1+32
XDBAL2   DS    CL11
         ORG   XDBAL2
@NM00043 DC    CL4'REGS'
@NM00044 DC    CL2'AT'
@NM00045 DC    CL5'ABEND'
         ORG   XDBAL2+11
         DS    CL1
XDBAF2   DS    CL44
         ORG   XDBAF2
@NM00046 DS    CL4
         ORG   @NM00046
@NM00047 DC    X'01'
@NM00048 DC    X'40'
@NM00049 DC    AL1(0)
@NM00050 DC    AL1(0)
         ORG   XDBAF2+4
@NM00051 DS    CL8
         ORG   @NM00051
@NM00052 DC    X'07'
@NM00053 DC    X'33'
@NM00054 DC    AL1(8)
@NM00055 DC    AL1(23)
@NM00056 DC    AL4(XDBAL2)
         ORG   XDBAF2+12
@NM00057 DS    CL4
         ORG   @NM00057
@NM00058 DC    X'05'
@NM00059 DC    X'13'
@NM00060 DC    AL1(13)
@NM00061 DC    AL1(32)
         ORG   XDBAF2+16
@NM00062 DS    CL4
         ORG   @NM00062
@NM00063 DC    X'05'
@NM00064 DC    X'43'
@NM00065 DC    AL1(16)
@NM00066 DC    AL1(41)
         ORG   XDBAF2+20
@NM00067 DS    CL4
         ORG   @NM00067
@NM00068 DC    X'04'
@NM00069 DC    X'03'
@NM00070 DC    AL1(0)
@NM00071 DC    AL1(50)
         ORG   XDBAF2+24
@NM00072 DS    CL4
         ORG   @NM00072
@NM00073 DC    X'04'
@NM00074 DC    X'03'
@NM00075 DC    AL1(0)
@NM00076 DC    AL1(59)
         ORG   XDBAF2+28
@NM00077 DS    CL4
         ORG   @NM00077
@NM00078 DC    X'04'
@NM00079 DC    X'03'
@NM00080 DC    AL1(0)
@NM00081 DC    AL1(68)
         ORG   XDBAF2+32
@NM00082 DS    CL4
         ORG   @NM00082
@NM00083 DC    X'04'
@NM00084 DC    X'03'
@NM00085 DC    AL1(0)
@NM00086 DC    AL1(77)
         ORG   XDBAF2+36
@NM00087 DS    CL4
         ORG   @NM00087
@NM00088 DC    X'04'
@NM00089 DC    X'03'
@NM00090 DC    AL1(0)
@NM00091 DC    AL1(86)
         ORG   XDBAF2+40
@NM00092 DS    CL4
         ORG   @NM00092
@NM00093 DC    F'0'
         ORG   XDBAF2+44
XDBAF3   DS    CL24
         ORG   XDBAF3
@NM00094 DS    CL4
         ORG   @NM00094
@NM00095 DC    X'01'
@NM00096 DC    X'40'
@NM00097 DC    AL1(0)
@NM00098 DC    AL1(0)
         ORG   XDBAF3+4
@NM00099 DS    CL4
         ORG   @NM00099
@NM00100 DC    X'04'
@NM00101 DC    X'03'
@NM00102 DC    AL1(0)
@NM00103 DC    AL1(23)
         ORG   XDBAF3+8
@NM00104 DS    CL4
         ORG   @NM00104
@NM00105 DC    X'04'
@NM00106 DC    X'03'
@NM00107 DC    AL1(0)
@NM00108 DC    AL1(32)
         ORG   XDBAF3+12
@NM00109 DS    CL4
         ORG   @NM00109
@NM00110 DC    X'04'
@NM00111 DC    X'03'
@NM00112 DC    AL1(0)
@NM00113 DC    AL1(41)
         ORG   XDBAF3+16
@NM00114 DS    CL4
         ORG   @NM00114
@NM00115 DC    X'04'
@NM00116 DC    X'03'
@NM00117 DC    AL1(0)
@NM00118 DC    AL1(50)
         ORG   XDBAF3+20
@NM00119 DS    CL4
         ORG   @NM00119
@NM00120 DC    F'0'
         ORG   XDBAF3+24
XDBAF4   DS    CL28
         ORG   XDBAF4
@NM00121 DS    CL4
         ORG   @NM00121
@NM00122 DC    X'01'
@NM00123 DC    X'40'
@NM00124 DC    AL1(0)
@NM00125 DC    AL1(0)
         ORG   XDBAF4+4
@NM00126 DS    CL4
         ORG   @NM00126
@NM00127 DC    X'04'
@NM00128 DC    X'03'
@NM00129 DC    AL1(0)
@NM00130 DC    AL1(23)
         ORG   XDBAF4+8
@NM00131 DS    CL4
         ORG   @NM00131
@NM00132 DC    X'04'
@NM00133 DC    X'03'
@NM00134 DC    AL1(0)
@NM00135 DC    AL1(32)
         ORG   XDBAF4+12
@NM00136 DS    CL4
         ORG   @NM00136
@NM00137 DC    X'04'
@NM00138 DC    X'03'
@NM00139 DC    AL1(0)
@NM00140 DC    AL1(41)
         ORG   XDBAF4+16
@NM00141 DS    CL4
         ORG   @NM00141
@NM00142 DC    X'04'
@NM00143 DC    X'03'
@NM00144 DC    AL1(0)
@NM00145 DC    AL1(50)
         ORG   XDBAF4+20
@NM00146 DS    CL4
         ORG   @NM00146
@NM00147 DC    X'04'
@NM00148 DC    X'03'
@NM00149 DC    AL1(0)
@NM00150 DC    AL1(59)
         ORG   XDBAF4+24
@NM00151 DS    CL4
         ORG   @NM00151
@NM00152 DC    F'0'
         ORG   XDBAF4+28
XDBAF5   DS    CL40
         ORG   XDBAF5
@NM00153 DS    CL4
         ORG   @NM00153
@NM00154 DC    X'01'
@NM00155 DC    X'40'
@NM00156 DC    AL1(0)
@NM00157 DC    AL1(0)
         ORG   XDBAF5+4
@NM00158 DS    CL4
         ORG   @NM00158
@NM00159 DC    X'04'
@NM00160 DC    X'03'
@NM00161 DC    AL1(0)
@NM00162 DC    AL1(23)
         ORG   XDBAF5+8
@NM00163 DS    CL4
         ORG   @NM00163
@NM00164 DC    X'04'
@NM00165 DC    X'03'
@NM00166 DC    AL1(0)
@NM00167 DC    AL1(32)
         ORG   XDBAF5+12
@NM00168 DS    CL4
         ORG   @NM00168
@NM00169 DC    X'04'
@NM00170 DC    X'03'
@NM00171 DC    AL1(0)
@NM00172 DC    AL1(41)
         ORG   XDBAF5+16
@NM00173 DS    CL4
         ORG   @NM00173
@NM00174 DC    X'04'
@NM00175 DC    X'03'
@NM00176 DC    AL1(0)
@NM00177 DC    AL1(50)
         ORG   XDBAF5+20
@NM00178 DS    CL4
         ORG   @NM00178
@NM00179 DC    X'04'
@NM00180 DC    X'03'
@NM00181 DC    AL1(0)
@NM00182 DC    AL1(59)
         ORG   XDBAF5+24
@NM00183 DS    CL4
         ORG   @NM00183
@NM00184 DC    X'04'
@NM00185 DC    X'03'
@NM00186 DC    AL1(0)
@NM00187 DC    AL1(68)
         ORG   XDBAF5+28
@NM00188 DS    CL4
         ORG   @NM00188
@NM00189 DC    X'04'
@NM00190 DC    X'03'
@NM00191 DC    AL1(0)
@NM00192 DC    AL1(77)
         ORG   XDBAF5+32
@NM00193 DS    CL4
         ORG   @NM00193
@NM00194 DC    X'04'
@NM00195 DC    X'03'
@NM00196 DC    AL1(0)
@NM00197 DC    AL1(86)
         ORG   XDBAF5+36
@NM00198 DS    CL4
         ORG   @NM00198
@NM00199 DC    F'0'
         ORG   XDBAF5+40
UCBL1    DS    CL7
         ORG   UCBL1
@NM00200 DC    CL4'LOCK'
@NM00201 DC    CL3'IOQ'
         ORG   UCBL1+7
         DS    CL1
UCBF1    DS    CL20
         ORG   UCBF1
@NM00202 DS    CL4
         ORG   @NM00202
@NM00203 DC    X'01'
@NM00204 DC    X'40'
@NM00205 DC    AL1(0)
@NM00206 DC    AL1(0)
         ORG   UCBF1+4
@NM00207 DS    CL8
         ORG   @NM00207
@NM00208 DC    X'07'
@NM00209 DC    X'33'
@NM00210 DC    AL1(8)
@NM00211 DC    AL1(17)
@NM00212 DC    AL4(UCBL1)
         ORG   UCBF1+12
@NM00213 DS    CL4
         ORG   @NM00213
@NM00214 DC    X'05'
@NM00215 DC    X'23'
@NM00216 DC    AL1(26)
@NM00217 DC    AL1(35)
         ORG   UCBF1+16
@NM00218 DS    CL4
         ORG   @NM00218
@NM00219 DC    F'0'
         ORG   UCBF1+20
UCBL2    DS    CL23
         ORG   UCBL2
@NM00220 DC    CL4'FLGS'
@NM00221 DC    CL2'ID'
@NM00222 DC    CL6'STATUS'
@NM00223 DC    CL4'CHAN'
@NM00224 DC    CL7'DEVFLAG'
         ORG   UCBL2+23
         DS    CL1
UCBF2    DS    CL32
         ORG   UCBF2
@NM00225 DS    CL4
         ORG   @NM00225
@NM00226 DC    X'01'
@NM00227 DC    X'40'
@NM00228 DC    AL1(0)
@NM00229 DC    AL1(0)
         ORG   UCBF2+4
@NM00230 DS    CL8
         ORG   @NM00230
@NM00231 DC    X'07'
@NM00232 DC    X'31'
@NM00233 DC    AL1(8)
@NM00234 DC    AL1(17)
@NM00235 DC    AL4(UCBL2)
         ORG   UCBF2+12
@NM00236 DS    CL4
         ORG   @NM00236
@NM00237 DC    X'05'
@NM00238 DC    X'10'
@NM00239 DC    AL1(26)
@NM00240 DC    AL1(35)
         ORG   UCBF2+16
@NM00241 DS    CL4
         ORG   @NM00241
@NM00242 DC    X'05'
@NM00243 DC    X'50'
@NM00244 DC    AL1(44)
@NM00245 DC    AL1(53)
         ORG   UCBF2+20
@NM00246 DS    CL4
         ORG   @NM00246
@NM00247 DC    X'05'
@NM00248 DC    X'33'
@NM00249 DC    AL1(62)
@NM00250 DC    AL1(71)
         ORG   UCBF2+24
@NM00251 DS    CL4
         ORG   @NM00251
@NM00252 DC    X'05'
@NM00253 DC    X'63'
@NM00254 DC    AL1(80)
@NM00255 DC    AL1(89)
         ORG   UCBF2+28
@NM00256 DS    CL4
         ORG   @NM00256
@NM00257 DC    F'0'
         ORG   UCBF2+32
UCBL3    DS    CL20
         ORG   UCBL3
@NM00258 DC    CL8'UNITNAME'
@NM00259 DC    CL7'DEVTYPE'
@NM00260 DC    CL5'EXTPT'
         ORG   UCBL3+20
UCBF3    DS    CL24
         ORG   UCBF3
@NM00261 DS    CL4
         ORG   @NM00261
@NM00262 DC    X'01'
@NM00263 DC    X'40'
@NM00264 DC    AL1(0)
@NM00265 DC    AL1(0)
         ORG   UCBF3+4
@NM00266 DS    CL8
         ORG   @NM00266
@NM00267 DC    X'07'
@NM00268 DC    X'73'
@NM00269 DC    AL1(8)
@NM00270 DC    AL1(17)
@NM00271 DC    AL4(UCBL3)
         ORG   UCBF3+12
@NM00272 DS    CL4
         ORG   @NM00272
@NM00273 DC    X'05'
@NM00274 DC    X'63'
@NM00275 DC    AL1(26)
@NM00276 DC    AL1(35)
         ORG   UCBF3+16
@NM00277 DS    CL4
         ORG   @NM00277
@NM00278 DC    X'05'
@NM00279 DC    X'43'
@NM00280 DC    AL1(44)
@NM00281 DC    AL1(53)
         ORG   UCBF3+20
@NM00282 DS    CL4
         ORG   @NM00282
@NM00283 DC    F'0'
         ORG   UCBF3+24
UCBP1    DS    CL12
         ORG   UCBP1
@NM00284 DS    CL4
         ORG   @NM00284
@NM00285 DC    X'01'
@NM00286 DC    X'40'
@NM00287 DC    AL1(0)
@NM00288 DC    AL1(0)
         ORG   UCBP1+4
@NM00289 DS    CL4
         ORG   @NM00289
@NM00290 DC    X'04'
@NM00291 DC    X'03'
@NM00292 DC    AL1(0)
@NM00293 DC    AL1(8)
         ORG   UCBP1+8
@NM00294 DS    CL4
         ORG   @NM00294
@NM00295 DC    F'0'
         ORG   UCBP1+12
UCBP2    DS    CL16
         ORG   UCBP2
@NM00296 DS    CL4
         ORG   @NM00296
@NM00297 DC    X'01'
@NM00298 DC    X'40'
@NM00299 DC    AL1(0)
@NM00300 DC    AL1(0)
         ORG   UCBP2+4
@NM00301 DS    CL4
         ORG   @NM00301
@NM00302 DC    X'04'
@NM00303 DC    X'03'
@NM00304 DC    AL1(0)
@NM00305 DC    AL1(8)
         ORG   UCBP2+8
@NM00306 DS    CL4
         ORG   @NM00306
@NM00307 DC    X'04'
@NM00308 DC    X'03'
@NM00309 DC    AL1(0)
@NM00310 DC    AL1(17)
         ORG   UCBP2+12
@NM00311 DS    CL4
         ORG   @NM00311
@NM00312 DC    F'0'
         ORG   UCBP2+16
UCBP4    DS    CL24
         ORG   UCBP4
@NM00313 DS    CL4
         ORG   @NM00313
@NM00314 DC    X'01'
@NM00315 DC    X'40'
@NM00316 DC    AL1(0)
@NM00317 DC    AL1(0)
         ORG   UCBP4+4
@NM00318 DS    CL4
         ORG   @NM00318
@NM00319 DC    X'04'
@NM00320 DC    X'03'
@NM00321 DC    AL1(0)
@NM00322 DC    AL1(8)
         ORG   UCBP4+8
@NM00323 DS    CL4
         ORG   @NM00323
@NM00324 DC    X'04'
@NM00325 DC    X'03'
@NM00326 DC    AL1(0)
@NM00327 DC    AL1(17)
         ORG   UCBP4+12
@NM00328 DS    CL4
         ORG   @NM00328
@NM00329 DC    X'04'
@NM00330 DC    X'03'
@NM00331 DC    AL1(0)
@NM00332 DC    AL1(26)
         ORG   UCBP4+16
@NM00333 DS    CL4
         ORG   @NM00333
@NM00334 DC    X'04'
@NM00335 DC    X'03'
@NM00336 DC    AL1(0)
@NM00337 DC    AL1(35)
         ORG   UCBP4+20
@NM00338 DS    CL4
         ORG   @NM00338
@NM00339 DC    F'0'
         ORG   UCBP4+24
UCBP6    DS    CL32
         ORG   UCBP6
@NM00340 DS    CL4
         ORG   @NM00340
@NM00341 DC    X'01'
@NM00342 DC    X'40'
@NM00343 DC    AL1(0)
@NM00344 DC    AL1(0)
         ORG   UCBP6+4
@NM00345 DS    CL4
         ORG   @NM00345
@NM00346 DC    X'04'
@NM00347 DC    X'03'
@NM00348 DC    AL1(0)
@NM00349 DC    AL1(8)
         ORG   UCBP6+8
@NM00350 DS    CL4
         ORG   @NM00350
@NM00351 DC    X'04'
@NM00352 DC    X'03'
@NM00353 DC    AL1(0)
@NM00354 DC    AL1(17)
         ORG   UCBP6+12
@NM00355 DS    CL4
         ORG   @NM00355
@NM00356 DC    X'04'
@NM00357 DC    X'03'
@NM00358 DC    AL1(0)
@NM00359 DC    AL1(26)
         ORG   UCBP6+16
@NM00360 DS    CL4
         ORG   @NM00360
@NM00361 DC    X'04'
@NM00362 DC    X'03'
@NM00363 DC    AL1(0)
@NM00364 DC    AL1(35)
         ORG   UCBP6+20
@NM00365 DS    CL4
         ORG   @NM00365
@NM00366 DC    X'04'
@NM00367 DC    X'03'
@NM00368 DC    AL1(0)
@NM00369 DC    AL1(44)
         ORG   UCBP6+24
@NM00370 DS    CL4
         ORG   @NM00370
@NM00371 DC    X'04'
@NM00372 DC    X'03'
@NM00373 DC    AL1(0)
@NM00374 DC    AL1(53)
         ORG   UCBP6+28
@NM00375 DS    CL4
         ORG   @NM00375
@NM00376 DC    F'0'
         ORG   UCBP6+32
BLANKS   DC    CL5' '
TRANS    DS    CL256
         ORG   TRANS
@NM00380 DS    CL64
BL       DC    CL1' '
@NM00381 DS    CL175
NUMS     DC    CL16'0123456789ABCDEF'
         ORG   TRANS+256
CHARHDR  DC    CL18'(CHARACTER READER)'
COMHDR   DC    CL21'(COMMUNICATION TYPE)'
CTCHDR   DC    CL25'(CHANNEL TO CHANNEL TYPE)'
DAHDR    DC    CL20'(DIRECT ACCESS TYPE)'
EXCPDHDR DC    CL54'-XDBA-    (EXCPD)    ---------------------AT LOCATIC
               ON '
EXCPDMSG DC    CL120'*** FORMATTING SERVICE ROUTINE ERROR DURING EXCPD C
               FORMATTING (POSSILE CAUSE: DATA NOT IN DUMP) ***'
EXCPUS   DC    CL6'------'
GRAPHDR  DC    CL15'(GRAPHICS TYPE)'
HDR3704  DC    CL31'(3704,3705 TELEPROCESSING TYPE)'
HDR3800  DC    CL13'(3800 DEVICE)'
HDR3851  DC    CL18'(3851 DEVICE TYPE)'
MAGHDR   DC    CL20'(MAGNETIC TAPE TYPE)'
UCBHDR   DC    CL54'-UCB-                                     AT LOCATIC
               ON '
UCBMSG   DC    CL120'*** FORMATTING SERVICE ROUTINE ERROR DURING UCB FOC
               RMATTING (POSSIBLE CAUSE: DATA NOT IN DUMP) ***'
UCHARHDR DC    CL31'(UNIT REC W/UNIVERSAL CHAR SET)'
UNITHDR  DC    CL18'(UNIT RECORD TYPE)'
UNKNOWN  DC    CL56'        *** UNKNOWN UCB TYPE FOR UCB AT LOCATION'
IO1PATCH DC    CL200'PATCH AREA FOR IECIOFT1 - IT IS 200 BYTES LONG'
         DS    CL3
CTCARRAY DC    AL4(UCBF1)
         DC    AL4(UCBF2)
         DC    AL4(UCBF3)
         DC    AL4(UCBP2)
ARY3800  DC    AL4(UCBF1)
         DC    AL4(UCBF2)
         DC    AL4(UCBF3)
         DC    AL4(UCBP1)
COMARRAY DC    AL4(UCBF1)
         DC    AL4(UCBF2)
         DC    AL4(UCBF3)
MAGDARAY DC    AL4(UCBF1)
         DC    AL4(UCBF2)
         DC    AL4(UCBF3)
         DC    AL4(UCBP6)
GRAPHARY DC    AL4(UCBF1)
         DC    AL4(UCBF2)
         DC    AL4(UCBF3)
         DC    AL4(UCBP4)
XDBANAME DC    AL4(XDBAF1)
         DC    AL4(XDBAF2)
         DC    AL4(XDBAF5)
@00      EQU   00                      EQUATES FOR REGISTERS 0-15
@01      EQU   01
@02      EQU   02
@03      EQU   03
@04      EQU   04
@05      EQU   05
@06      EQU   06
@07      EQU   07
@08      EQU   08
@09      EQU   09
@10      EQU   10
@11      EQU   11
@12      EQU   12
@13      EQU   13
@14      EQU   14
@15      EQU   15
SAVEPTR  EQU   @09
EXCPDPTR EQU   @05
RCCODE   EQU   @07
ESTAPTR  EQU   @06
DATAPTR  EQU   @08
CONVRT   EQU   @07
ARRAYCNT EQU   @05
UCBPTR   EQU   @05
ABDPLPTR EQU   @01
LINEPTR  EQU   @00
VADR     EQU   @00
RCREG    EQU   @15
ABDPL    EQU   0
ADPLFLAG EQU   ABDPL+7
ADPLSNPR EQU   ADPLFLAG
ADPLBUF  EQU   ABDPL+8
ADPLPRNT EQU   ABDPL+12
ADPLMEMA EQU   ABDPL+20
ADPLFRMT EQU   ABDPL+24
ADPLCOM1 EQU   ABDPL+28
ADPLFMT1 EQU   ABDPL+44
ADPLFMT2 EQU   ABDPL+48
UCB      EQU   0
UCBOB    EQU   0
UCBJBNR  EQU   UCBOB
UCBFL5   EQU   UCBOB+1
UCBAF    EQU   UCBFL5
UCBSTAT  EQU   UCBOB+3
UCBCHAN  EQU   UCBOB+4
UCBSFLS  EQU   UCBOB+6
UCBFLA   EQU   UCBSFLS
UCBFL1   EQU   UCBFLA
UCBBSY   EQU   UCBFL1
UCBNRY   EQU   UCBFL1
UCBPST   EQU   UCBFL1
UCBCUB   EQU   UCBFL1
UCBFLB   EQU   UCBSFLS+1
UCBCHM   EQU   UCBOB+8
UCBCHM1  EQU   UCBCHM
UCBPTH0  EQU   UCBCHM1
UCBPTH1  EQU   UCBCHM1
UCBWGT   EQU   UCBOB+12
UCBTYP   EQU   UCBOB+16
UCBTBYT1 EQU   UCBTYP
UCB1FEA5 EQU   UCBTBYT1
UCB1FEA6 EQU   UCBTBYT1
UCBTBYT2 EQU   UCBTYP+1
UCB2OPT2 EQU   UCBTBYT2
UCBDUDN1 EQU   UCB2OPT2
UCB2OPT3 EQU   UCBTBYT2
UCBDUDN2 EQU   UCB2OPT3
UCB2OPT4 EQU   UCBTBYT2
UCBRWTAU EQU   UCB2OPT4
UCB2OPT6 EQU   UCBTBYT2
UCB2OPT7 EQU   UCBTBYT2
UCBTBYT3 EQU   UCBTYP+2
UCBDVCLS EQU   UCBTBYT3
UCBTBYT4 EQU   UCBTYP+3
UCBEXTPT EQU   UCBOB+20
UCBFLC   EQU   UCBEXTPT
UCBDEV   EQU   UCBOB+24
UCBCMEXT EQU   0
UCBATI   EQU   UCBCMEXT+3
@NM00005 EQU   UCBATI
UCBFLP1  EQU   UCBCMEXT+5
UCBMT    EQU   0
UCBOCR   EQU   0
UCB3540X EQU   0
UCBDKBYT EQU   UCB3540X+6
UCB3800X EQU   0
UCBOPTNS EQU   UCB3800X
UCBACTIV EQU   UCB3800X+3
UCBMDRBF EQU   UCB3800X+36
UCBUCS   EQU   0
UCBUCSOP EQU   UCBUCS+4
UCBFCBOP EQU   UCBUCS+5
ACCESS   EQU   0
FORMAT   EQU   0
PRINT    EQU   0
BUFFER   EQU   0
HDRTYPE  EQU   BUFFER+10
ADDRESS  EQU   BUFFER+55
DATADWRD EQU   0
DATAWORD EQU   0
ESTAPARM EQU   0
ESTAERR  EQU   ESTAPARM
ERREXP   EQU   ESTAERR
RTYADR   EQU   ESTAPARM+4
RTYREGS  EQU   ESTAPARM+8
LCALREGS EQU   ESTAPARM+72
MSG      EQU   0
UCBBGN   EQU   0
UCBOBS01 EQU   UCBDEV
UCBSTAB  EQU   UCBOBS01+10
UCBBSVL  EQU   UCBSTAB
UCBPRSRS EQU   UCBSTAB
UCBDMCT  EQU   UCBOBS01+11
UCBFL4   EQU   UCBOBS01+13
UCBOBS02 EQU   UCBDEV
UCBTFL1  EQU   UCBOBS02+19
UCBXTN   EQU   UCBOBS02+20
UCBVOPT  EQU   UCBXTN
UCBOBS03 EQU   UCBDEV
UCBXTADR EQU   UCBOBS03
UCBOBS04 EQU   UCBDEV
UCBBTA   EQU   UCBOBS04+12
UCBOBS06 EQU   UCBDEV
UCBAOF   EQU   UCBOBS06
UCBAOF1  EQU   UCBAOF
UCBAOF2  EQU   UCBAOF+1
@NM00004 EQU   UCBOBS06+3
UCBIRB   EQU   UCBOBS06+4
UCBGRAF  EQU   UCBIRB
UCBLDNCA EQU   UCBOBS06+8
UCBRDYQ  EQU   UCBLDNCA
UCBIRLN  EQU   UCBRDYQ
UCBLDNCB EQU   UCBRDYQ+1
UCBCTLNK EQU   UCBOBS06+12
UCBOBS07 EQU   UCBDEV
UCBOBS08 EQU   UCBDEV
UCBCTCAD EQU   UCBOBS08
UCBCTCF1 EQU   UCBOBS08+4
UCBOBS09 EQU   UCBDEV
ARRY3704 EQU   CTCARRAY
ARY3851  EQU   CTCARRAY
CHARARY  EQU   COMARRAY
DARRAY   EQU   MAGDARAY
START    EQU   ADPLFMT1
UCHARRAY EQU   ARY3800
UNITARY  EQU   COMARRAY
UCBUS    EQU   EXCPUS
         AGO   .@UNREFD                START UNREFERENCED COMPONENTS
UCBRV066 EQU   UCBOBS09+4
UCBIOSBA EQU   UCBOBS09
UCBRV042 EQU   UCBOBS08+5
UCBRV082 EQU   UCBCTCF1
UCBRV081 EQU   UCBCTCF1
UCBRV080 EQU   UCBCTCF1
UCBRV079 EQU   UCBCTCF1
UCBRV078 EQU   UCBCTCF1
UCBRV077 EQU   UCBCTCF1
UCBRV076 EQU   UCBCTCF1
UCBCTC80 EQU   UCBCTCF1
UCBCTCAL EQU   UCBCTCAD
UCBICNCB EQU   UCBOBS07+4
UCBRV040 EQU   UCBOBS07
UCBCTLNA EQU   UCBCTLNK+1
UCBRLN   EQU   UCBCTLNK
UCBRDYQA EQU   UCBLDNCB
UCBINRLN EQU   UCBIRLN
UCBIRBA  EQU   UCBIRB+1
UCBRV039 EQU   UCBGRAF
UCBDWNR  EQU   UCBGRAF
UCBRPND  EQU   UCBGRAF
UCBUPM   EQU   UCBGRAF
UCBBTAM  EQU   UCBGRAF
UCBDRNO  EQU   UCBGRAF
UCBDRO   EQU   UCBGRAF
UCBOIP   EQU   UCBGRAF
UCBATRCD EQU   @NM00004
UCBSKPFG EQU   @NM00004
UCBRIPND EQU   @NM00004
UCBRTIAC EQU   @NM00004
UCBRSV79 EQU   @NM00004
UCBRSV78 EQU   @NM00004
UCBRSV77 EQU   @NM00004
UCBOLTEP EQU   @NM00004
UCBATNCT EQU   UCBOBS06+2
UCBRSV76 EQU   UCBAOF2
UCBRSV75 EQU   UCBAOF2
UCBRSV74 EQU   UCBAOF2
UCBRSV73 EQU   UCBAOF2
UCBRSV72 EQU   UCBAOF2
UCBRSV71 EQU   UCBAOF2
UCBRSV70 EQU   UCBAOF2
UCBRSV69 EQU   UCBAOF2
UCBRSV68 EQU   UCBAOF1
UCBRSV67 EQU   UCBAOF1
UCBRSV66 EQU   UCBAOF1
UCBRSV65 EQU   UCBAOF1
UCBRSV64 EQU   UCBAOF1
UCBOFNL  EQU   UCBAOF1
UCBOFSP  EQU   UCBAOF1
UCBOFMCR EQU   UCBAOF1
UCBBTB   EQU   UCBBTA+1
UCBDI    EQU   UCBBTA
UCBSNS   EQU   UCBOBS04+8
UCBTEB   EQU   UCBOBS04+4
UCBGCB   EQU   UCBOBS04+3
UCBOPEN  EQU   UCBOBS04+2
UCBSTART EQU   UCBOBS04
UCBXTNB  EQU   UCBXTN+1
UCBRSV22 EQU   UCBVOPT
UCBRSV21 EQU   UCBVOPT
UCBRSV20 EQU   UCBVOPT
UCBESVE  EQU   UCBVOPT
UCBERPC  EQU   UCBVOPT
UCBESVC  EQU   UCBVOPT
UCBEVA   EQU   UCBVOPT
UCBESV   EQU   UCBVOPT
UCBRV009 EQU   UCBTFL1
UCBRV008 EQU   UCBTFL1
UCBRV007 EQU   UCBTFL1
UCBRV006 EQU   UCBTFL1
UCBRV005 EQU   UCBTFL1
UCBRV038 EQU   UCBTFL1
UCBNSLTP EQU   UCBTFL1
UCBNLTP  EQU   UCBTFL1
UCBRES1B EQU   UCBOBS02+18
UCBFSER  EQU   UCBOBS02+12
@NM00003 EQU   UCBOBS02+4
UCBFSEQ  EQU   UCBOBS02+2
UCBFSCT  EQU   UCBOBS02
UCBNEXP  EQU   UCBOBS01+20
UCBBASE  EQU   UCBOBS01+16
UCBRES1A EQU   UCBOBS01+15
UCBUSER  EQU   UCBOBS01+14
UCBFL47  EQU   UCBFL4
UCBFL46  EQU   UCBFL4
UCBFL45  EQU   UCBFL4
UCBRV065 EQU   UCBFL4
UCBDSS   EQU   UCBFL4
UCBRESVP EQU   UCBFL4
UCBWDAV  EQU   UCBFL4
UCBDAVV  EQU   UCBFL4
UCBSQC   EQU   UCBOBS01+12
UCBDATP  EQU   UCBOBS01+12
UCBDMC   EQU   UCBDMCT
UCBMOUNT EQU   UCBDMCT
UCBBNUL  EQU   UCBSTAB
UCBSHAR  EQU   UCBSTAB
UCBBSTR  EQU   UCBSTAB
UCBBPUB  EQU   UCBSTAB
UCBBPRV  EQU   UCBSTAB
UCBBALB  EQU   UCBPRSRS
UCBPGFL  EQU   UCBSTAB
UCBDVSHR EQU   UCBBSVL
UCBVOLI  EQU   UCBOBS01+4
UCBVTOC  EQU   UCBOBS01
@NM00379 EQU   ESTAERR
UNEXP2   EQU   ESTAERR
LOCKHELD EQU   ESTAERR
@NM00378 EQU   BUFFER+64
@NM00377 EQU   BUFFER+6
OFFSET   EQU   BUFFER
UCBERADR EQU   UCBUCS+12
UCBFCBID EQU   UCBUCS+8
UCBERCNT EQU   UCBUCS+7
UCBRSV51 EQU   UCBUCS+6
UCBRSV50 EQU   UCBFCBOP
UCBRSV49 EQU   UCBFCBOP
UCBRSV48 EQU   UCBFCBOP
UCBRSV47 EQU   UCBFCBOP
UCBRSV46 EQU   UCBFCBOP
UCBRSV45 EQU   UCBFCBOP
UCBRSV44 EQU   UCBFCBOP
UCBFCBO1 EQU   UCBFCBOP
UCBUCSPE EQU   UCBUCSOP
UCBRSV43 EQU   UCBUCSOP
UCBRSV42 EQU   UCBUCSOP
UCBRSV41 EQU   UCBUCSOP
UCBRSV40 EQU   UCBUCSOP
UCBRSV39 EQU   UCBUCSOP
UCBUCSO2 EQU   UCBUCSOP
UCBUCSO1 EQU   UCBUCSOP
UCBUCSID EQU   UCBUCS
UCBMDRBA EQU   UCBMDRBF+1
UCBRV075 EQU   UCBMDRBF
UCBRV074 EQU   UCB3800X+32
UCBIMAGE EQU   UCB3800X+28
UCBFCBNM EQU   UCB3800X+24
UCBCHAR4 EQU   UCB3800X+20
UCBCHAR3 EQU   UCB3800X+16
UCBCHAR2 EQU   UCB3800X+12
UCBCHAR1 EQU   UCB3800X+8
UCBCGMID EQU   UCB3800X+4
UCBBRSTA EQU   UCBACTIV
UCBRV063 EQU   UCBACTIV
UCBRV062 EQU   UCBACTIV
UCBRV061 EQU   UCBACTIV
UCBRV060 EQU   UCBACTIV
UCBRV059 EQU   UCBACTIV
UCBRV058 EQU   UCBACTIV
UCBRV057 EQU   UCBACTIV
UCBRV050 EQU   UCB3800X+2
UCBCGMNO EQU   UCB3800X+1
UCBRV083 EQU   UCBOPTNS
UCBBRSTR EQU   UCBOPTNS
UCBRV056 EQU   UCBOPTNS
UCBRV055 EQU   UCBOPTNS
UCBRV054 EQU   UCBOPTNS
UCBRV053 EQU   UCBOPTNS
UCBRV052 EQU   UCBOPTNS
UCBRV051 EQU   UCBOPTNS
UCBRV073 EQU   UCB3540X+7
UCBRV072 EQU   UCBDKBYT
UCBRV071 EQU   UCBDKBYT
UCBRV070 EQU   UCBDKBYT
UCBRV069 EQU   UCBDKBYT
UCBRV068 EQU   UCBDKBYT
UCBRV067 EQU   UCBDKBYT
UCBVLVER EQU   UCBDKBYT
UCBDKAMX EQU   UCBDKBYT
UCBVLSER EQU   UCB3540X
UCBRDATA EQU   UCBOCR+4
UCBFRID  EQU   UCBOCR
UCBCLN   EQU   UCBMT+14
UCBERG   EQU   UCBMT+12
UCBMS    EQU   UCBMT+11
UCBNB    EQU   UCBMT+10
UCBPW    EQU   UCBMT+9
UCBPR    EQU   UCBMT+8
UCBSIO   EQU   UCBMT+6
UCBTW    EQU   UCBMT+5
UCBTR    EQU   UCBMT+4
UCBTWT   EQU   UCBMT+3
UCBTRT   EQU   UCBMT+2
UCBCTD   EQU   UCBMT
UCBWTOID EQU   UCBCMEXT+17
UCBRV043 EQU   UCBCMEXT+16
UCBASID  EQU   UCBCMEXT+14
UCBMFCNT EQU   UCBCMEXT+12
UCBPMSK  EQU   UCBCMEXT+10
UCBCCWOF EQU   UCBCMEXT+8
UCBRV041 EQU   UCBCMEXT+6
UCBRV036 EQU   UCBFLP1
UCBRV035 EQU   UCBFLP1
UCBERLOG EQU   UCBFLP1
UCBRV033 EQU   UCBFLP1
UCBRV032 EQU   UCBFLP1
UCBRV031 EQU   UCBFLP1
UCBSHRUP EQU   UCBFLP1
UCBNSRCH EQU   UCBFLP1
UCBSNSCT EQU   UCBCMEXT+4
UCBHPDV  EQU   @NM00005
UCBHALI  EQU   @NM00005
UCBRSV09 EQU   @NM00005
UCBRSV08 EQU   @NM00005
UCBRSV07 EQU   @NM00005
UCBRSV06 EQU   @NM00005
UCBRSV05 EQU   @NM00005
UCBRSV04 EQU   @NM00005
UCBDTI   EQU   UCBCMEXT+2
UCBSTI   EQU   UCBCMEXT+1
UCBETI   EQU   UCBCMEXT
UCBEXTP  EQU   UCBEXTPT+1
UCBDDRSW EQU   UCBFLC
UCBTICBT EQU   UCBFLC
UCBIVRR  EQU   UCBFLC
UCBIVRS  EQU   UCBFLC
UCBITF   EQU   UCBFLC
UCBUDE   EQU   UCBFLC
UCBWAA   EQU   UCBFLC
UCBATTP  EQU   UCBFLC
UCBUNTYP EQU   UCBTBYT4
UCBRSV11 EQU   UCBDVCLS
UCBRSV10 EQU   UCBDVCLS
UCB3CHAR EQU   UCBDVCLS
UCB3UREC EQU   UCBDVCLS
UCB3DISP EQU   UCBDVCLS
UCB3DACC EQU   UCBDVCLS
UCB3COMM EQU   UCBDVCLS
UCB3TAPE EQU   UCBDVCLS
UCBDVPWR EQU   UCB2OPT7
UCBVLPWR EQU   UCB2OPT6
UCB2OPT5 EQU   UCBTBYT2
UCBRVDEV EQU   UCBRWTAU
UCBRPS   EQU   UCBDUDN2
UCBRR    EQU   UCBDUDN1
UCB2OPT1 EQU   UCBTBYT2
UCB2OPT0 EQU   UCBTBYT2
UCB1FEA7 EQU   UCBTBYT1
UCBD6250 EQU   UCB1FEA6
UCBD1600 EQU   UCB1FEA5
UCB1FEA4 EQU   UCBTBYT1
UCB1FEA3 EQU   UCBTBYT1
UCB1FEA2 EQU   UCBTBYT1
UCB1FEA1 EQU   UCBTBYT1
UCB1FEA0 EQU   UCBTBYT1
UCBNAME  EQU   UCBOB+13
UCBRV029 EQU   UCBWGT
UCBVHRSN EQU   UCBWGT
UCBVORSN EQU   UCBWGT
UCBMTPXP EQU   UCBWGT
UCBREW   EQU   UCBWGT
UCBPUB   EQU   UCBWGT
UCBOUT   EQU   UCBWGT
UCBIN    EQU   UCBWGT
UCBCPU   EQU   UCBOB+11
UCBLCI   EQU   UCBOB+10
UCBCNT   EQU   UCBOB+9
UCBRV017 EQU   UCBCHM1
UCBRV016 EQU   UCBCHM1
UCBRV015 EQU   UCBCHM1
UCBRV014 EQU   UCBCHM1
UCBSPB   EQU   UCBPTH1
UCBPPB   EQU   UCBPTH1
UCBSPA   EQU   UCBPTH0
UCBPPA   EQU   UCBPTH0
UCBSIGP  EQU   UCBFLB
UCBVALPH EQU   UCBFLB
UCBCRHSN EQU   UCBFLB
UCBCRHRV EQU   UCBFLB
UCBRESVH EQU   UCBFLB
UCBSPST  EQU   UCBFLB
UCBASNS  EQU   UCBFLB
UCBIORST EQU   UCBFLB
UCBQISCE EQU   UCBFL1
UCBACTV  EQU   UCBFL1
UCBSAP   EQU   UCBFL1
UCBNOTRC EQU   UCBCUB
UCBPSNS  EQU   UCBFL1
UCBUSING EQU   UCBPST
UCBNOTRD EQU   UCBNRY
UCBBUSYD EQU   UCBBSY
UCBUA    EQU   UCBCHAN+1
UCBCHA   EQU   UCBCHAN
UCBDADI  EQU   UCBSTAT
UCBSYSR  EQU   UCBSTAT
UCBPRES  EQU   UCBSTAT
UCBALOC  EQU   UCBSTAT
UCBUNLD  EQU   UCBSTAT
UCBRESV  EQU   UCBSTAT
UCBCHGS  EQU   UCBSTAT
UCBONLI  EQU   UCBSTAT
UCBID    EQU   UCBOB+2
UCBALTPH EQU   UCBFL5
UCBALTCU EQU   UCBFL5
UCBNALOC EQU   UCBFL5
UCBENVRD EQU   UCBFL5
UCBVSDR  EQU   UCBFL5
UCBSASK  EQU   UCBFL5
UCBAMV   EQU   UCBAF
UCBDCC   EQU   UCBFL5
UCBMONT  EQU   UCBJBNR
UCBRV011 EQU   UCBJBNR
UCBMMSGP EQU   UCBJBNR
UCBOLDSM EQU   UCBJBNR
UCBRV003 EQU   UCBJBNR
UCBDUC   EQU   UCBJBNR
UCBJES3  EQU   UCBJBNR
UCBVRDEV EQU   UCBJBNR
UCBCMSEG EQU   UCBOB
UCBPFXND EQU   UCB+512
UCBIOQ   EQU   UCB+508
UCBLOCK  EQU   UCB+504
UCBPXST  EQU   UCB+504
@NM00002 EQU   UCB
ADPLABDA EQU   ABDPL+56
ADPLEXT  EQU   ABDPL+52
ADPLCOM4 EQU   ABDPL+40
ADPLCOM3 EQU   ABDPL+36
ADPLCOM2 EQU   ABDPL+32
ADPLCVT  EQU   ABDPL+16
@NM00001 EQU   ADPLFLAG
ADPLDMGT EQU   ADPLFLAG
ADPLSYTM EQU   ADPLFLAG
ADPLSBPL EQU   ABDPL+6
ADPLASID EQU   ABDPL+4
ADPLTCB  EQU   ABDPL
.@UNREFD ANOP                          END UNREFERENCED COMPONENTS
@RC00201 EQU   @RC00199
@RC00281 EQU   @RC00253
@RC00268 EQU   @RC00253
@RC00255 EQU   @RC00253
@ENDDATA EQU   *
         END   IECIOFT1,(C'PLS1912',0701,77005)
