         TITLE 'IEDAYAB - TIOC TSO ABEND'
IEDAYAB  CSECT
         SPACE 3
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
*A000000-999999                                                @YA14094
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
*                                                                     *
*                                                                     *
*    NAME - IEDAYAB, TIOC TSO ABEND                                   *
*                                                                     *
* STATUS - NONE                                                       *
*                                                                     *
* FUNCTION -                                                          *
*    ISSUES TSABEND SVC TO NOTIFY TSO TERMINAL USERS THAT TSO HAS AB- *
*    ENDED                                                            *
*                                                                     *
* ENTRY POINTS -                                                      *
*         IEDAYAB+2.    ENTERED FROM TCAM DISPATCHER AS A RESULT OF A *
*    TPOST BY TSC STAE ROUTINE OR THE MACHINE CHECK HANDLER           *
*                                                                     *
*    REGISTER  1 - ADDRESS OF TSABEND QCB                             *
*    REGISTER  7 - ADDRESS OF TSABEND QCB                             *
*    REGISTER 11 - ADDRESS OF TCAM DISPATCHER                         *
*    REGISTER 13 - ADDRESS OF AVTSAVE2                                *
*    REGISTER 15 - ENTRY POINT ADDRESS                                *
*    REGISTER 15 HAS ENTRY ADDRESS                                    *
*                                                                     *
* OUTPUT -                                                            *
*    NONE                                                             *
*                                                                     *
* EXTERNAL REFERENCES -                                               *
*         TSABEND, VIA SVC 94                                         *
*                                                                     *
* EXITS, NORMAL -                                                     *
*         DSPDISP, TCAM DISPATCHER'S ENTRY POINT VIA BRANCH           *
*                                                                     *
* EXITS, ERROR -                                                      *
*         NONE                                                        *
*                                                                     *
* TABLES/WORK AREAS -                                                 *
*    CONTROL BLOCKS ARE DESCRIBED IN THE DSECTS AT END OF LISTING     *
*                                                                     *
* ATTRIBUTES -                                                        *
*    ENABLED, PROBLEM PROGRAM MODE, REFRESHABLE, REUSABLE             *
*                                                                     *
* CHARACTER CODE DEPENDENCY -                                         *
*    NONE                                                             *
*                                                                     *
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
         EJECT
********
******** REGISTER EQUATES
********
R1       EQU   1                        AVT ADDR AT ENTRY
RDISP    EQU   11                       TCAM DISPATCHER POINTER  A44022
RAVT     EQU   13                       AVTSAVE2 ADDR            A44022
RETURN   EQU   14                       RETURN ADDRESS
RENTRY   EQU   15                       ENTRY ADDRESS
         SPACE 3
********
******** INITIALIZATION
********
         DC    AL1(DSPMCPL2),X'00'      STCB                     A44022
         USING *,RENTRY                 BASE                     A44022
         USING IEDQDISP,RDISP           TCAM DISPATCHER          A44022
         USING AVTSAVE2,RAVT            AVT                      A44022
IEDAYAB  IEDHJN ID
         SPACE 3
********
******** SET TSABEND INDICATOR IF NOT ALREADY SET
********
         TM    AVTBIT3,AVTTSAB          ALREADY SET              A44022
         BO    DSPDISP                  YES - EXIT TO TCAM DISP  A44022
         OI    AVTBIT3,AVTTSAB          INDICATE TSO ABENDED     A44022
         SPACE 3
********
******** CALL TSABEND SVC TO NOTIFY USERS OF TSO FAILURE
********
TELLALL  EQU   *
         TSABEND ,                      TELL TSO
         SPACE 3
         B     DSPDISP                  EXIT TO TCAM DISPATCHER  A44022
         EJECT
         TAVTD
         EJECT
         TDISPD
         END
