         TITLE 'IEDQFE - TCAM SERVICE AID SECONDARY AVT'
FEVECTOR CSECT
***********************************************************************
*                                                                     *
* MODULE NAME- IEDQFE                                                 *
*                                                                     *
* STATUS-      CHANGE LEVEL 1                                         *
*                                                                     *
* FUNCTION-    THIS MODULE IS THE SERVICE AID SECONDARY AVT.  IT      *
*              CONTAINS NO EXECUTABLE CODE                            *
*                                                                     *
* ENTRY POINTS-N/A, SINCE NO CODE IS EXECUTED.                        *
*                                                                     *
* INPUT-       NO DATA IS HANDLED BY THIS MODULE.                     *
*                                                                     *
* OUTPUT-      THIS MODULE ACTS AS A WORK AREA BETWEEN ASYCHRONOUS    *
*              ROUTINES (SEE EXTERNAL REFERENCES).                    *
*                                                                     *
* EXTERNAL REFERENCES-   WHEN COMWRITE(IEDQFW) IS FIRST ENTERED, MAIN *
*              STORAGE IS OBTAINED FOR A WORK AREA.  ADDRESSES OF     *
*              SELECTED FIELDS IN THE WORK AREA ARE PLACED IN THIS    *
*              MODULE.  THE FOLLOWING MODULES REFER TO THIS MODULE,   *
*              TO PERFORM PASSING OF PARAMETERS BETWEEN SEVERAL TASKS *
*              IN THE TCAM ENVIRONMENT.                               *
*              IGG019RO                                               *
*              IGG019Q0                                               *
*              IEDQAA                                                 *
*              IGG019RP  USE IEDQFE + 0 TO FIND POINTERS TO THEIR     *
*                        RESPECTIVE SERVICE AID DUMP MODULES.         *
*              IEDQFW    INITIALIZES THE FIELDS IN THE ADDRESS AND    *
*                        NAME LIST TO INDICATE TO ALL OTHER ROUTINES  *
*                        THAT THE SERVICE AIDS HAVE BEEN LOADED AND   *
*                        OBTAINS MAIN STORAGE TO RETAIN THE ENTRY     *
*                        POINT ADDRESSES FOR USE WHEN A THE SERVICE   *
*                        AID IS TO BE DELETED.                        *
*              IEDQC6    REFERENCES THE ADDRESS SLOTS AND NAME SLOTS  *
*                        TO DETERMINE THE LOADED OR NON-EXISTANCE     *
*                        STATUS OF A GIVEN SERVICE AID ROUTINE.       *
*                        A PARAMETER LIST IS ALSO PROVIDED FOR IEDQC6 *
*                        TO POST COMWRITE(IEDQFW) TO LOAD OR DELETE A *
*                        PARTICULAR SERVICE AID.                      *
         EJECT
*              IEDQFE10                                               *
*              IEDQFE20                                               *
*              IEDQFE30                                               *
*              IEDQFE40  THESE ROUTINES TURN ON A FLAG IN THE FIRST   *
*                        BYTE OF THE ADDRESS FIELD TO DENOTE THEIR    *
*                        PRESENCE TO THE SYSTEM.  THE FIELD MAY BE    *
*                        MODIFIED TO REFLECT DIFFERENT ENTRY POINT    *
*                        ADDRESSES DURING VARIOUS EXECUTION POINTS IN *
*                        EACH ROUTINE.  SEE THE MODULE PROSE FOR THE  *
*                        RESPECTIVE MODULES.  THESE ROUTINES FIND     *
*                        THEIR EXECUTION ADDRESS FIELD THROUGH THIS   *
*                        MODULE.                                      *
*                                                                     *
* EXITS,NORMAL-N/A, SINCE THIS MODULE IS NOT EXECUTED.                *
*                                                                     *
* EXITS,ERROR- N/A FOR SAME REASON AS ABOVE                           *
*                                                                     *
* TABLE/WORK AREAS-      THIS IS THE PARAMETER WORK AREA FOR THE TCAM *
*              SERVICE AID ROUTINES.IT IS USED, IN CONJUNCTION WITH   *
*              THE COMWRITE FLAGS IN THE AVT TO PROVIDE COMMUNICATIONS*
*              BETWEEN FE ROUTER(IEDQC6), COMWRITE(IEDQFW), THE TCAM  *
*              PROCESSING ROUTINES, AND THE SERVICEABILITY ROUTINES.  *
*                                                                     *
* ATTRIBUTES-  RESIDENT IN THE TCAM MCP REGION OR PARTITION.          *
*              SERIALLY REUSABLE.                                     *
*                                                                     *
* CHARACTER CODE DEPENDENCY-       NONE.                              *
*                                                                     *
* NOTES-       AN ADDRESS CONSTANT IN THE TCAM AVT CONTAINS THE       *
*              ADDRESS OF THE LABEL 'IEDQFE'  CONSTANTS ASSEMBLED     *
*              WITHIN THIS MODULE BEFORE THAT LABEL ARE USED ONLY BY  *
*              FE ROUTER(IEDQC6), AND COMWRITE(IEDQFW).               *
*                                                                     *
***********************************************************************
         EJECT
         ENTRY IEDQFE
IBMAIDS  EQU   9                   NUMBER OF SLOTS FOR IBM AIDS
USERAIDS EQU   5                   NUMBER OF SLOTS FOR USER AIDS
         SPACE 2
***********************************************************************
*                                                                     *
*        THIS MODULE IS DESCRIBED IN A COMMON DSECT WITHIN COMWRITE   *
*        AND FE ROUTER (IEDQFW0, IEDQFW1, IEDQFW2, AND IEDQC6).       *
*        THE DSECT IS DESCRIBED AS FOLLOWS-                           *
*                                                                     *
*FEAIDENT DS   CL16                MODULE IDENT                       *
*FEAPARM  DS   A                   POINTER TO FE ROUTER PARM LIST     *
*FEAEXEC  DS   0C                  DEBUG ROUTINE BEING 'EXECUTED'     *
*FEAINITI DS   0A                  POINTER TO IBM AID INIT LIST       *
*FEAWORK  DS   A                   ADDR OF COMWRITE WORK AREA         *
*FEAINITU DS   A                   POINTER TO USER AID INIT LIST      *
*FEANAMES DS   A                   POINTER TO SERVAID NAME LIST       *
*FEASIZE  DS   H                   SIZE(IN BYTES) OF COMWRITE AREA    *
*FEAACTIV DS   H                   NUMBER OF ACTIVE SERVICE AIDS      *
*FEAIBMNO DS   H                   NUMBER OF IBM SERVAID SLOTS        *
*FEAUSRNO DS   H                   NUMBER OF USER SERVAID SLOTS       *
*FEAEPAI  DS   A                   POINTER TO IBM SERVAID ENTRIES     *
*FEAEPAU  DS   A                   POINTER TO USER SERVAID ENTRIES    *
*                                                                     *
***********************************************************************
         SPACE
         DC    CL16'IEDQFE--03/03/71'  MODULE IDENTIFIER
         DC    A(0)                POINTER TO PARM LIST FOR IEDQC6
         DC    AL1(0)              DEBUG ROUTINE BEING 'EXECUTED'
         DC    AL3(0)              POINTER TO COMWRITE WORK AREA
         DC    A(0)                POINTER TO USER INITIALIZATION LIST
         DC    A(0)                POINTER TO LIST OF SERVAID NAMES
         DC    AL2(0)              SIZE OF COMWRITE WORK AREA IN BYTES
         DC    AL2(0)              NUMBER OF TOTAL SERVICE AIDS
         DC    AL2(IBMAIDS)        NUMBER OF SLOTS FOR IBM AIDS
         DC    AL2(USERAIDS)       NUMBER OF SLOTS FOR USER AIDS
IEDQFE   DC    A(0)                POINTER TO IBM SERVAID ENTRIES
         DC    A(0)                POINTER TO USER SERVAID ENTRIES
         END
