         TITLE 'IEDQWE2  TOTE CLEAN UP MODULE     '              S22024
IEDQWE2  CSECT                                                   S22024
*A000000-999999                                                @Y16X5U0
* CHANGE ACTIVITY AS FOLLOWS:                                    S22024
* A000000-999999                                                 S22024
*A301200,340600,321360-322020,420020-420220,424300,506240-506640 S05331
*A510700,569170-569190,569540-569560,625800-626100,863005-863025 S05331
*D299700,702900-708300                                           S05331
*A105600-105900,175700-176100,255650-256350                      Y06330
*C300300,301000,305500,420000,506200,862600                      S05331
*C521100                                                       @SA74550
*A125100,204600,285300,420040,506280,569040,569460,733500      @Y17XAUU
*A760500,844200                                                @Y17XAUU
*C569190,569560,672300-673200,675000,791100                    @Y17XAUU
*D762300-784800                                                @Y17XAUU
* A002694,175600,365400,387900,395820,420084,420100,447240,    @XM05672
* A458100,506352,506400,863025                                 @XM05672
* C395820,447240                                               @XM05672
* D120600-121500,122420-123020,175610-175640,366300,531700     @XM05672
* A420220,436500,472500,506640,545400,548100                   @G36XRUV
* C420300,437400,473400,506700,546300,549000                   @G36XRUV
*A108000,620100,651600,834300                                  @OY20578
* A164700,196200                                               @OY20828
* C166500                                                      @OY20828
*
***********************************************************************
*                                                               S22024*
*                                                               S22024*
* MODULE NAME:                                                  S22024*
*                                                               S22024*
*    IEDQWE2 (TCAM,TOTE)                                       @Y17XAUU
*                                                               S22024*
* DESCRIPTIVE NAME:                                             S22024*
*                                                               S22024*
*    TOTE CLEANUP MODULE                                        S22024*
*                                                               S22024*
* COPYRIGHT:                                                    S22024*
*                                                               S22024*
*    'NONE'                                                     S22024*
*                                                               S22024*
* STATUS:                                                       S22024*
*                                                               S22024*
*    VERSION 10.0                                              @Y17XAUU
*                                                                     *
* ENTRY POINT:                                                        *
*                                                                     *
*    IEDQWE2                                                   @Y17XAUU
*                                                              @Y17XAUU
* LINKAGE: XCTL'ED FROM IEDQWE                                 @Y17XAUU
*                                                              @Y17XAUU
* PURPOSE: SEE FUNCTION                                        @Y17XAUU
*                                                               S22024*
* FUNCTIONS:                                                          *
*                                                                     *
*    THE PURPOSE OF THIS MODULE IS TO:                          S22024*
*    1. GO TO IEDQWAJ FOR $CUTEST CLEANUP IF THE OLT HAS ISSUED S22024*
*        $CUTEST DURNING HIS RUN                                S22024*
*    2. IF THE CONTORL TERMINAL OR ALTERNATE PRINTER IS ON A    S22024*
*        270X WAIT UNTIL TCAM HAS SENT ALL MESSAGES SHIPPED BY  S22024*
*        TOTE                                                   S22024*
*    3. RESTORE ALL DEVICES USED BY TOTE ( CONTROL TERMINAL,    S22024*
*        ALTERNATE PRINTER, AND ALL TEST DEVICES) TO THEIR      S22024*
*        ORIGINAL STATUS IN THE EYES OF TCAM                    S22024*
*    4. DEQ ALL DEVICES USED BY TOTE                            S22024*
*    5. CLOSE THE PRIMARY AND SECONDARY DCB'S IF LEFT OPEN      S22024*
*    6. INSURE ALL DEVICES USED BY TOTE ARE RETURNED TO TCAM    S22024*
*    7. IF ANY OF THE DEVICES USED BY TOTE IS ON A CONCENTRATOR S22024*
*        XCTL   TO IEDQWEC FOR CONCENTRATOR CLEANUP OTHERWISE   S22024*
*        RETURN TO TOTE'S RESIDENT MODULE IEDQWA                S22024*
*                                                                     *
* INPUT:                                                              *
*                                                                     *
*    REGISTER 02,13,14,15 CONTAIN THE FOLLOWING VALUES:               *
*          02 - OLTCB POINTER                                         *
*          13 - SAVE AREA ADDRESS                                     *
*          14 - RETURN ADDRESS                                        *
*          15 - ENTRY POINT ADDRESS                                   *
*                                                                     *
* EXTERNAL ROUTINES:                                                  *
*                                                                     *
*       IEDQWK - TOTE MESSAGE MODULE                                  *
*       IEDQWAJ - $CUTEST MODULE                                S22024*
*                                                                     *
* EXIT POINTS:                                                        *
*                                                                     *
*    RETURN TO IEDQWA                                                 *
*    XCTL TO IEDQWEC - CONCENTRATOR MODULE                      S22024*
*                                                                     *
* TABLES/WORK AREAS:                                                  *
*                                                                     *
*       OLTCB, UCB                                                    *
*                                                                     *
* ATTRIBUTES:                                                         *
*                                                                     *
*       ENABLED, PROBLEM PROGRAM MODE, TRANSIENT.                     *
*                                                              @Y17XAUU
* MODULE TYPE: PROCEDURE                                       @Y17XAUU
*                                                              @Y17XAUU
* MODULE SIZE: 4K MAXIMUM                                      @Y17XAUU
*                                                              @Y17XAUU
* PROCESSOR: ASSEMBLER XF                                      @Y17XAUU
*                                                              @Y17XAUU
* MACROS - SAVE                                                @Y17XAUU
*          AQCTL                                               @Y17XAUU
*          IEDHJN                                              @Y17XAUU
*          XCTL                                                @Y17XAUU
*          WAIT                                                @Y17XAUU
*                                                              @Y17XAUU
* NOTES: SEE BELOW                                             @Y17XAUU
*                                                              @Y17XAUU
*  DEPENDENCIES: EBCDIC CHARACTER CODE                         @Y17XAUU
*                                                              @Y17XAUU
*  RESTRICTIONS: NONE                                          @Y17XAUU
*                                                              @Y17XAUU
*  REGISTER CONVENTIONS: SEE REGISTER ASSIGNMENT               @Y17XAUU
*                                                              @Y17XAUU
*  PATCH LABEL: PATCH                                          @Y17XAUU
***********************************************************************
         EJECT
*
*        REGISTER EQUATES
*
R0       EQU   0                       REG 0                     S99528
R1       EQU   1                       REG 1                     S99528
R2       EQU   2                       REG 2                     S99528
R3       EQU   3                       REG 3                     S99528
R4       EQU   4                       REG 4                     S99528
R5       EQU   5                       REG 5                     S99528
R6       EQU   6                       REG 6                     S99528
R7       EQU   7                       REG 7                     S99528
R8       EQU   8                       REG 8                     S99528
R9       EQU   9                       REG 9                     S99528
R10      EQU   10                      REG 10                    S99528
R11      EQU   11                      REG 11                    S99528
R12      EQU   12                      REG 12                    S99528
R13      EQU   13                      REG 13                    S99528
R14      EQU   14                      REG 14                    S99528
R15      EQU   15                      REG 15                    S99528
JFCBTSDM EQU   X'08'                   DISP                      S99528
JFCBLTYP EQU   X'02'                   TYPE                      S99528
ZERO     EQU   0                       ZERO                      S99528
ONE      EQU   1                       ONE                       S99528
TWO      EQU   2                       TWO                       S99528
THREE    EQU   3                       THREE                     S99528
FOUR     EQU   4                       FOUR                      S99528
FIVE     EQU   5                       FIVE                      S99528
SIX      EQU   6                       SIX                       S99528
SEVEN    EQU   7                       SEVEN                     S99528
EIGHT    EQU   8                       EIGHT                     S99528
NINE     EQU   9                       NINE                      S99528
TENN     EQU   10                      TEN                       S99528
ONEONE   EQU   11                      ELEVEN                    S99528
D0       EQU   0                       DISPLACEMENT              S22024
D1       EQU   1                       DISPLACEMENT              S22024
D2       EQU   2                       DISPLACEMENT              S22024
D3       EQU   3                       DISPLACEMENT              S22024
D4       EQU   4                       DISPLACEMENT              S22024
D5       EQU   5                       DISPLACEMENT              S22024
D6       EQU   6                       DISPLACEMENT              S22024
D7       EQU   7                       DISPLACEMENT              S22024
D8       EQU   8                       DISPLACEMENT              S22024
D9       EQU   9                       DISPLACEMENT              S22024
D10      EQU   10                      DISPLACEMENT              S22024
D13      EQU   13                      DISPLACEMENT              S22024
D16      EQU   16                      DISPLACEMENT              S22024
D32      EQU   32                      DISPLACEMENT              S22024
D34      EQU   34                      DISPLACEMENT 34           S99528
DEVTBEND EQU   X'00'                   TEST DEVICE TABLE END CODES99528
X40      EQU   X'40'                   BLANK                     S22024
X80      EQU   X'80'                   LINE ENTRY OR LGB TEST    S22024
X00      EQU   X'00'                   OK RETURN                 S22024
XF1      EQU   X'F1'                   TOTE RESOURCE             S22024
XDC      EQU   X'DC'                   PRIORITY                  S22024
X18      EQU   X'18'                   LENGTH OF ELEMENT         S22024
X08      EQU   X'08'                   ALREADY DONE RETURN       S22024
X0C      EQU   X'0C'                   FLAG START                S22024
XE0      EQU   X'E0'                   CLEAR EQU                 S22024
ZEROZ    EQU   X'00'                   CLEAR FIELD               S22024
X0F      EQU   X'0F'                   CLEAR FOR UCB TYPE        S22024
IPL3705  EQU   X'52'                   IPL VERB                  S22024
ACT3705  EQU   X'53'                   ACTIVATE VERB             S22024
DACT3705 EQU   X'54'                   DEACTIVATE VERB           S22024
RNUCBTST EQU   X'05'                   3705 UCB                  S22024
DEC58    EQU   58                      FIFTY EIGHT               S99528
SECTBEND EQU   X'40'                   SECTION TABLE END CODE    S99528
STRTCODE EQU   X'40'                   START CODE                S99528
STOPCODE EQU   X'41'                   START LINE                S99528
LINESTRT EQU   X'40'                   STOP LINE                 S99528
LINESTOP EQU   X'41'                   VERB CODE                 S99528
TERMSTRT EQU   X'45'                   VERB CODE START TERM      S99528
TERMSTOP EQU   X'47'                   TERMINAL CODE STOP        S99528
HOLDTERM EQU   X'88'                   HOLD TERMINAL VERB CODE   S99528
ACTIVETM EQU   X'46'                   ACTIVATE TERM VERB CODE   S99528
REALTERM EQU   X'87'                   RELEASE TERM VERB CODE    S99528
INACTERM EQU   X'48'                   INACTIVATE VERB CODE      S99528
SWPRI    EQU   X'50'                   SWITCH TO PRIMARY         Y06330
SWBCK    EQU   X'51'                   SWITCH TO BACKUP          Y06330
BLANK    EQU   X'40'                   INCLUSIVE DLIM            S99528
X44      EQU   X'44'                   DEB CK                    S22024
UCBNALBT EQU   X'04'                   UCB UNALLOCATE BIT        S22024
UCBNALOF EQU   X'FB'                   TURN OFF UNALLOCATE BIT   S22024
XFF      EQU   X'FF'                   CLEAN UP ELEMENT          S22024
X20      EQU   X'20'                   PRIORITY OF CLEANUP       S22024
ADRMSK   EQU   7                       ADDRESS MASK            @YM08136
*
HALFWORD EQU   3                       HALFWORD MASK           @OY20578
         EJECT
         SAVE  (14,12)                 SAVE REGS                 S99528
         USING TOTOLTCB,R2             OLTCB                     S22024
*
*        SATISFY LINKAGE CONVENTIONS
*
         LR    R4,R15                  ESTABLISH BASE REG        S99528
         USING IEDQWE2,R4              IEDQWE2
         ST    R13,TOTSAVE4+FOUR       SAVE CALLERS SAVE ADDR    S99528
         LR    R12,R13                 SAVE IT HERE TOO          S99528
         LA    R13,TOTSAVE4            MY SAVE AREA ADDRESS      S99528
         ST    R13,EIGHT(R12)          MY SAVE TO HIS            S99528
IEDQWE2  IEDHJN IEDQWEE,HJN            NAME AND HJN
*        HOUSEKEEP FOR TERMINATION
         SPACE 2
TCNT11E  EQU   *                                               @YM08158
         TM    TOTCUFLG,TOTCUDON       CU TEST BEEN ISSUED       S99528
         BZ    TCNT172                 BO BRANCH                 S99528
         OI    TOTCUFLG,TOTCUCUP       CLEAN UP NEEDED FLAG      S99528
         LA    R8,TOTSERV              ADDR OF  QWAJ WORK AREA @Y17XAUU
         LR    R10,R8             SET IT AGAIN                 @Y17XAUU
         LA    R9,L'TOTSERV            LENGTH OF WORKAREA      @Y17XAUU
         SLR   R11,R11                 SET COUNT REG           @Y17XAUU
         MVCL  R8,R10                 CLEAR WORK AREA          @Y17XAUU
         L     R5,TOTRESPL             GET RESPL ADDRESS       @Y17XAUU
         USING RESPL,R5                SET RESPL ADDRESSABILITY@Y17XAUU
         L     R15,RESPLAJ             $CUTEST ROUTINE ADDRESS @Y17XAUU
         BALR  R14,R15                 DO CUTEST CLEANUP       @Y17XAUU
TCNT172  EQU   *
         L     R8,TOTAVTPT             GET ADDRESS OF AVT        S22024
         USING IEDQAVTD,R8             SET UP BASE FOR AVT       S22024
         LA    R7,AVTOPCOB             GET POINTER TO OP CONTROL S22024
*                                        QCB                     S22024
         ST    R7,TOTOKEY              PUT ADDR IN PARM LIST     S22024
         MVI   TOTOKEY,X00             ZERO OUT KEY FIELD        S22024
         MVI   TOTOPRI,XDC             PRIORITY OF ELEMENT       S22024
         MVI   TOTOELNG,X18            LENGTH OF ELEMENT         S22024
         LA    R8,TOTPLIST             GET OP CONTROL P-LIST     S22024
         ST    R8,CBSLPL               ADDRESS AND STORE IN      S22024
         ST    R8,CBSLPL+D4            ELEMENT TWICE             S22024
         MVI   CBSLPL,X0C              START FLAG                S22024
         MVI   CBSLPL+D4,X80           END FLAG                  S22024
         MVI   TOTOLADR,C' '           BLANK OUT                 S22024
         MVC   TOTOLADR+D1(D7),TOTOLADR   NAME                   S22024
         L     R8,TOTCTTNT             GET DUMMY TNT ENTRY       S99528
         LTR   R8,R8                   IS THERE ONE              S99528
         BZ    APTEST                  NO BRANCH                 S99528
         LA    R7,TOTCTENT-4           GET IOBLOCKS DESECT       S99528
         BAL   R12,STCTAP              START LINE                S99528
         BAL   R7,TNTALINE             GET TNT ADDRESS           S99528
         USING IEDQQCB,R6              QCB ADDRESSIBILITY        S99528
CTWAIT   L     R8,EIGHT(R6)            THIRD WORD OF             S99528
         LA    R8,ZERO(R8)             QCB POINT                 S99528
         LA    R7,EIGHT(R6)            TO IT SELF                S99528
         CR    R7,R8                   IF SO                     S99528
         BE    APTEST                  BRANCH                    S99528
         NI    QCBDSFLG,X'FF'-QCBHELD  TURN OFF QCBHELD IF ON    S99528
         STIMER WAIT,DINTVL=SECS00     WAIT 11 SECS              S99528
         B     CTWAIT                  BRANCH                    S99528
APTEST   L     R8,TOTAPTNT             GET DUMMY TNT ADDTESS     S99528
         LTR   R8,R8                   IS THERE ONE              S99528
         BZ    TCNT1722                NO BRANCH                 S99528
         LA    R7,TOTAPENT-4           GET IOBLOCKS DESECT       S99528
         OI    APSTIME,APSTIMER        SET AP STIMER             S99528
         BAL   R12,STCTAP              START LINE                S99528
         BAL   R7,TNTALINE             GET TNT ADDRESS           S99528
APWAIT   L     R8,EIGHT(R6)            THIRD WORD OF             S99528
         LA    R8,ZERO(R8)             QCB POINT                 S99528
         LA    R7,EIGHT(R6)            TO IT SELF                S99528
         CR    R7,R8                   IF SO                     S99528
         BE    TCNT1722                BRANCH                    S99528
         NI    QCBDSFLG,X'FF'-QCBHELD  TURN OFF QCBHELD IF ON    S99528
         STIMER WAIT,DINTVL=SECS00     WAIT 11 SECS              S99528
         B     APWAIT                  BRANCH
         DROP  R6
         EJECT
*        START TEST DEVICES
*   RESTOR TEST DEVICES TO ORGINAL STATUS AND DEQ
*
**
***
*
TCNT1722 EQU   *                                                 S99528
         LA    R3,TOTTDTBL             GET TEST DEVICE TABLE ADDRS99528
ALLENTY  DS    0H                      BOUNDARY ALLIGNMENT     @OY20828
         LA    R12,TOTTDEND            GE T END OF TABLE ADDRT   S99528
         CR    R3,R12                  ALL ENTRIES PROCESSED?  @OY20828
         BE    TCNT179                 YES BRANCH                S99528
         L     R8,0(R3)                GET ADDRESS FROM TABLE    S99528
         LR    R1,R8                   RERPARE TO SAEE           S99528
         SRL   R1,24                   HIGH ORDER BYTE           S99528
         STC   R1,INITSTAT             BYTE                      S99528
         LA    R8,0(R8)                CLEAR HI BYTE             S99528
         LTR   R8,R8                   ANY ADDRESS               S99528
         BZ    TCNT179                 NO BRANCH                 S99528
         TM    INITSTAT,TOTTDLIN       UCBS IN TABLE             S99528
         BO    LINETEST                YES BRANCH                S99528
         SLR   R1,R1                   CLEAR REGISTER          @YM08136
         IC    R1,TOTTTBEL             GET MAXIMUM NAME LEN    @YM08136
         LA    R6,D0(R1,R8)            POINT TO TTE ADDRESS    @YM08136
         ICM   R6,ADRMSK,D0(R6)        GET TTE ADDRESS         @YM08136
         ST    R6,TTEADDR              SAVE TTE ADDRESS        @YM09003
         LA    R1,TRMPRFSZ             GET TTE PREFIX SIZE     @YM08136
         SLR   R6,R1                   POINT TO TTE PREFIX     @YM08136
         USING IEDNTRM,R6              SET TTE ADDRESSABILITY  @YM08136
         TM    TRMSTATE,TRMPREF        NCP RESOURCE            @YM08136
         BZ    TCNT1724                NO - CONTINUE           @YM08136
         CLI   TRMTYPE,TRMSDLC         Q-TD SNA LINE           @XM05672
         BNE   NOTSNALI                N-PROCESS NONSNA LINE   @XM05672
*        CONVERT LINE NAME TO TTCIN                            @XM05672
         USING IEDQAVTD,R8                                     @XM05672
         L     R8,TOTAVTPT             AVT ADDRESSABILITY      @XM05672
         SLR   R0,R0                   CLEAR REG 0             @XM05672
         IC    R0,TOTTTBEL             LENGTH OF NAME          @XM05672
         L     R1,0(R3)                ADDRESS OF TNT ENTRY    @XM05672
         LA    R1,0(R1)                CLEAR HI BYTE           @XM05672
         L     R15,AVTMSGS-1           CONVERT                 @XM05672
         L     R15,8(R15)               NAME TO                @XM05672
         BAL   R14,4(R15)               TTCIN                  @XM05672
         DROP  R8                      DROP AVT ADDRESSABILITY @XM05672
*        TURN OFF TRMSTOTE IN LINE ENTRY AND IN ALL INFERIOR   @XM05672
*        ENTRIES.                                              @XM05672
         LR    R1,R15                  COPY TTCIN              @XM05672
         USING RESPL,R8                RESPL BASE              @XM05672
         L     R8,TOTRESPL             RESPL ADDRESSABILITY    @XM05672
         L     R15,RESTLIB             ADDR OF HIER. SCAN RTN. @XM05672
         BALR  R14,R15                 TURN OFF BITS           @XM05672
         DROP  R8                      AVT ADDRESSABILITY      @XM05672
         B     SNARLSE                 GO RELEASE QUEUES       @XM05672
NOTSNALI DS    0H                                              @XM05672
         NI    TRMBYTE1,XFF-TRMSTOTE   RESET TOTE FLAG         @YM08136
         CLI   TRMTYPE,TRMLUNT         SNA LU ENTRY            @YM08136
         BNE   TCNT1724                N-BYPASS LU PROCESSING  @XM05672
         TM    INITSTAT,TOTTDTHD       Q-INITIALLY HELD        @XM05672
         BO    LUTDEND                 Y-BRANCH                @XM05672
SNARLSE  DS    0H                                              @XM05672
         MVI   TOTOVBCD,REALTERM       N-SET TO RELEASE LINE   @XM05672
         BAL   R12,STARTERM            GO RELEASE              @XM05672
         CLI   TOTORTCD,X00            Q-RELEASED              @XM05672
         BE    LUTDEND                 Y-BRANCH                @XM05672
         CLI   TOTORTCD,X08            Q-ALREADY RELEASED      @XM05672
         BE    LUTDEND                 Y-BRANCH                @XM05672
         BAL   R12,BSTOP               N-PRINT MESSAGE         @XM05672
LUTDEND  DS    0H                      END OF LU PROCESSING    @XM05672
         B     CONTE3                  GO CHECK FOR NEXT TD    @XM05672
         DROP  R6                                              @YM08136
TCNT1724 EQU   *                                               @YM08136
         TM    INITSTAT,TOTTSWPM       HAS TOTE SWITCHED DEVICE  Y06330
         BO    SWSTRET                 YES BRANCH                Y06330
SWRETURN EQU   *                                                 Y06330
         TM    INITSTAT,TOTTDTHD       TERM ORIG HELD            S99528
         BO    STOPTERM                YES BRANCH                S99528
CONTE1 EQU  *                                                    S99528
         MVI   TOTOVBCD,REALTERM       VERB TO REALSE TERMINAL   S22024
         BAL   R12,STARTERM            GO REALSSE TERMINAL       S99528
         CLI   TOTORTCD,X00            OK                        S22024
         BE    CONTE2                  GOOD RETURN               S99528
         CLI   TOTORTCD,X08            ALREADY DONE              S22024
         BE    CONTE2                  YES BR                    S99528
         BAL   R12,BSTOP               GO SEND MSG               S99528
CONTE2 EQU  *                                                    S99528
LINETEST EQU   *                                                 S99528
         SLR   R1,R1                   CLEAR REGISTER          @YM09003
         IC    R1,TOTTTBEL             GET MAXIMUM NAME LENGTH @YM09003
         LA    R6,D0(R1,R8)            POINT TO TTE ADDRESS    @YM09003
         ICM   R6,ADRMSK,D0(R6)        GET TTE ADDRESS         @YM09003
         ST    R6,TTEADDR              SAVE TTE ADDRESS        @YM09003
         XC    TOTORTCD,TOTORTCD       CLEAR RETURN CODE FIELD @YM09003
         TM    INITSTAT,TOTTDLIN       TEST DEVICE A LINE        S22024
         BO    UCBTAB                  YES BRANCH                S99528
         TM    INITSTAT,TOTTDTRM+TOTTDORN 3705 TERMINAL TEST   @OY20828
         BO    CONTE3                  YES PROCESS NEXT ENTRY  @OY20828
         TM    INITSTAT,TOTTDORN       TEST DEVICE ON RN         S22024
         BO    UCBTAB                  YES BRANCH                S22024
         BAL   R12,UCBFIND             LOCATE UCB                S99528
UCBTAB   BAL   R12,LISTART             START LINE                S99528
         CLI   TOTORTCD,X00            OK                        S22024
         BE    CONTE3                  GOOD RETURN               S99528
         CLI   TOTORTCD,X08            ALREADY DONE              S22024
         BE    CONTE3                  YES BR                    S99528
         BAL   R12,BSTOP               GO SEND MSG               S99528
CONTE3 EQU  *                                                    S99528
RESTLP   LA    R3,4(R3)                BUMP TABLE POINTER        S99528
         TM    INITSTAT,TOTTDORN       TEST DEV ON RN            S22024
         BZ    NOTRNIN                 NO BRANCH                 S22024
         L     R6,TTEADDR              GET TTE ADDRESS           S22024
         LA    R1,TRMPRFSZ             GET TTE PREFIX SIZE     @Y17XAUU
         SLR   R6,R1                   ADDRESS OF TTE PREFIX   @Y17XAUU
         USING IEDNTRM,R6              SET TTE ADDRESSABILITY  @Y17XAUU
         NI    TRMBYTE1,XFF-TRMSTOTE   RESET TOTE FLAG         @Y17XAUU
         DROP  R6                      TTE                       S22024
NOTRNIN  EQU   *                                                 S22024
         B     ALLENTY                 GO PROCESS NEXT ENTRY     S99528
*                                                                     *
*              ACTIVATE TERMINAL                                      *
*                                                                     *
ACTIVTRM EQU   *                                                 S99528
         MVI   TOTOVBCD,ACTIVETM       VERB TO ACTIVATE TERMINAL S22024
         BAL   R12,STARTERM            GO ACTIVATE TERMINAL      S99528
         CLI   TOTORTCD,X00            OK                        S22024
         BE    CONTE5                  GOOD RETURN               S99528
         CLI   TOTORTCD,X08            ALREADY DONE              S22024
         BE    CONTE5                  YES BR                    S99528
         BAL   R12,BSTOP               GO SEND MSG               S99528
*                                                                     *
*              HOLD TERMINAL                                          *
*                                                                     *
CONTE5 EQU  *                                                    S99528
         MVI   TOTOVBCD,HOLDTERM       VERB TO HOLD TERMINAL     S22024
         BAL   R12,STARTERM            GO HOLD TERM              S99528
         CLI   TOTORTCD,X00            OK                        S22024
         BE    CONTE6                  GOOD RETURN               S99528
         CLI   TOTORTCD,X08            ALREADY DONE              S22024
         BE    CONTE6                  YES BR                    S99528
         BAL   R12,BSTOP               GO SEND MSG               S99528
CONTE6 EQU  *                                                    S99528
         B     LINETEST                GO START LINE             S99528
STOPTERM EQU   *                                                 S99528
         MVI   TOTOVBCD,TERMSTOP       VERB TO STOP TERMINAL     S22024
         BAL   R12,STARTERM            GO STOP TERMINAL          S99528
         CLI   TOTORTCD,X00            OK                        S22024
         BE    CONTE7                  GOOD RETURN               S99528
         CLI   TOTORTCD,X08            ALREADY DONE              S22024
         BE    CONTE7                  YES BR                    S99528
         BAL   R12,BSTOP               GO SEND MSG               S99528
CONTE7 EQU  *                                                    S99528
         B     LINETEST                GO START LINE             S99528
*****                                                              ****
*****          TOTE CANNOT RETURN TEST DEVICES TO ORIGINAL STATUS  ****
*****                                                              ****
BSTOP    WTO   'IED154I TOTE CANNOT RETURN DEVICE          TO ORIGINAL C
               STATUS',ROUTCDE=10,DESC=7                         S99528
BSTOPNAM EQU   BSTOP+42                NAME IN MSG               S22024
         MVI   TOTORTCD,DEVTBEND       CLEAR RETURN CODE         S22024
         MVI   BSTOPNAM,BLANK          CLEAR                     S99528
         MVC   BSTOPNAM+ONE(SEVEN),BSTOPNAM  NAME IN MSG         S99528
         BR    R12                     RETURN                    S99528
SWSTRET  EQU   *                                                 Y06330
         LR    R9,R8                   SAVE TNT POINTER          Y06330
         SR    R10,R10                 CLEAR REG                 Y06330
         IC    R10,TOTTTBEL            NAME LENGTH               Y06330
         AR    R9,R10                  GET TTE ADDRESS           Y06330
         MVC   TTEADDR+D1(D3),D0(R9)   ALLINE ADDRESS            Y06330
         L     R6,TTEADDR              GET TTE ADDRESS           Y06330
         USING IEDQTRM,R6              TTE                       Y06330
         MVI   TOTOVBCD,SWBCK          SWITCH TO BACKUP          Y06330
         BAL   R12,STARTERM            GO SWITCH                 Y06330
         CLI   TOTORTCD,X00            OK                        Y06330
         BE    SWRETURN                YES BRANCH                Y06330
         BAL   R12,BSTOP               GO SEND MESSAGE           Y06330
         B     SWRETURN                CONTINUE                  Y06330
         DROP  R6                      TTE                       Y06330
         EJECT
***      DEQ TEST DEVICES   ********
***                          *******
TNTMOVE  MVC   RNAME(0),0(R6)          MOVE NAME TO DEQ          S99528
TNTMOVEE MVC   0(0,R8),0(R1)           MOVE NAME TO DEQ          S22024
TNTENTRY EQU   *                       TNT ONLY                  S99528
         LR    R8,R6                   R8 TO TNT ADDRESS
         BAL   R12,UCBFIND             GO FIND UCB
         USING UCB,R8
         MVC   RNAME(3),UCBNAME
         DROP  R8
         DEQ   ,MF=(E,DEQLIST)
         MVI   RNAME,X'40'
         MVC   RNAME+1(7),RNAME
         SR    R3,R3                   CLEAR REG                 S99528
         IC    R3,TOTTTBEL             GET NAME LENGTH           S99528
         BCTR  R3,0                    DECREMENT LENGTH OOR EX   S99528
         EX    R3,TNTMOVE              GO TO MOVE NAME           S99528
         B     DEQNAME                 GO DEQ                    S99528
RNTEMDQ  EQU   *                       THIS ROUTINE FINDS THE    S22024
*                                      LINE NAME DOR A TRRMINAL  S22024
         LR    R9,R6                   GET TNT ADDRESS           S22024
         BAL   R12,TERMRNDQ            DEQ LINE FOR TERMINAL     S22024
         B     NXTENT                  GO GET NEXT ENTRY         S22024
TERMRNDQ EQU   *                                                 S22024
         STM   R5,R7,DEQSAVE           SAVE REGS 5,6,7           S22024
         SR    R3,R3                   CLEAR REG                 S22024
         IC    R3,TOTTTBEL             GET NAME LENGTH           S22024
         AR    R9,R3                   TTE ADDRESS               S22024
         MVC   TTEADDR+D1(D3),D0(R9)   ALLINE ADDRESS            S22024
         L     R9,TTEADDR              TTE ADDRESS               S22024
         LA    R1,TRMPRFSZ             GET TTE PREFIX SIZE     @Y17XAUU
         SR    R9,R1                   GET NTRM                  S22024
         USING IEDNTRM,R9              TTE                       S22024
CHKTTE   EQU   *                                               @Y17XAUU
         LH    R1,TRMCOHRT             GET COHORT POINTER      @Y17XAUU
         L     R10,TOTAVTPT            GET AVT ADDRESS         @Y17XAUU
         USING IEDQAVTD,R10            SET AVT ADDRESSABILITY  @Y17XAUU
         L     R15,AVTRNMPT            TTCIN TO TTE CONVERSION @Y17XAUU
         STH   R1,OFFSET               SAVE COHORT POINTER     @Y17XAUU
         BALR  R14,R15                 GET NEXT TTE ENTRY      @Y17XAUU
         LA    R14,TRMPRFSZ            GET PREFIX SIZE         @Y17XAUU
         SLR   R1,R14                  POINT TO TTE PREFIX     @Y17XAUU
         LR    R9,R1                   SET TTE BASE            @Y17XAUU
         CLI   TRMTYPE,TRMNSDLC        PRE SNA LINE ENTRY      @Y17XAUU
         BE    LINETTE                 YES                     @Y17XAUU
         CLI   TRMTYPE,TRMSDLC         SNA LINE ENTRY          @Y17XAUU
         BNE   CHKTTE                  CHECK NEXT ENTRY        @Y17XAUU
         DROP  R9                                              @Y17XAUU
LINETTE  EQU   *                                               @Y17XAUU
         AR    R1,R14                  RESET TTE BASE          @Y17XAUU
         DROP  R10                                             @Y17XAUU
         TM    RNFLAG,APFLAG           IS THIS A SEARCH FOR AP   S05331
*                                        LINE TTE                S05331
         BNO   CHKCT                   NO, GO CHECK CT           S05331
         ST    R1,APLTTE               SAVE TTE ADDRESS          S05331
         B     D0(R6)                  BRANCH BACK TO CALLER     S05331
CHKCT    EQU   *                                                 S05331
         TM    RNFLAG,CTFLAG           IS THIS A SEARCH FOR CT   S05331
*                                        LINE TTE ADDRESS        S05331
         BNO   CONTINUE                NO, CONTINUE              S05331
         ST    R1,CTLTTE               STORE CT LINE TTE ADDR    S05331
         B     D0(R6)                  RETURN TO CALLER          S05331
CONTINUE EQU   *                                                 S05331
         L     R14,TOTAVTPT            GET AVT ADDRESS           S22024
         USING IEDQAVTD,R14            AVT                       S22024
         L     R1,AVTRNMPT             GET TERMNAME TABLE ADDR   S22024
         DROP  R14                     AVT                       S22024
         USING IEDQTNTD,R1             TNT                       S22024
         LA    R1,TNTFIRST             FIRST ENTRY ADDR          S22024
         DROP  R1                      TNT                       S22024
         LA    R7,D3                   LENGTH OF TTE ADDRESS     S22024
         SR    R3,R3                   CLEAR REG                 S22024
         IC    R3,TOTTTBEL             GET NAME LENGTH           S22024
         AR    R7,R3                   LENGTH OF TNT ENTRY       S22024
         LH    R11,OFFSET              GET TNT OFFSET            S22024
         LA    R14,D1                  SUBTRACT ONE              S22024
         SR    R11,R14                 TO GET RIGHT OFFSET       S22024
         MR    R10,R7                  OFFSET TO ACTUAL ENTRY    S22024
         AR    R1,R11                  TNT ADDR OF LINE          S22024
         BCTR  R3,0                    DECREMENT BY 1            S22024
         LA    R8,TNTNAME2              GET TNT POINTER        @OY20578
         EX    R3,TNTMOVEE             MOVE NAME                 S22024
         MVC   RNAME(D8),TNTNAME2       NAME TO DEQ            @OY20578
         DEQ   ,MF=(E,DEQLIST)         DEQ                       S22024
         MVI   RNAME,X40               CLEAR DEQ                 S22024
         MVC   RNAME+D1(D7),RNAME      PARM                      S22024
         LM    R5,R7,DEQSAVE           RESTORE REGS              S22024
         BR    R12                     GO DEQ NEXT ENTRY         S22024
TCNT179  EQU   *
         TM    TOTFLG01,TOTCONFG       CLEANUP FOR CONFIG        S99528
         BO    TCNT21                  YES BRANCH                S99528
         LA    R5,TOTTDTBL             DEVICE TABLE ADDRESS      S99528
         LA    R7,TOTTDEND             END OF TABLE ADDRESS      S99528
LOOPP    L     R6,0(R5)                GET UCB OR TNT            S99528
       LTR     R6,R6                   IS THERE ONE              S99528
         BZ    TCNT211                 NO BRANCH                 S99528
         LR    R1,R6                   SAVE                      S22024
         SRL   R1,24                   INITIAL                   S22024
         STC   R1,INITSTAT             STATUS                    S22024
         TM    0(R5),TOTTDORN          TEST DEVICE ON 3705       S22024
         BO    TNTENTRY                YES BRANCH                S22024
         TM    0(R5),TOTTDLIN          TEST FOR 0X LINES         S22024
         BZ    TNTENTRY                NO BRANCH                 S99528
         USING UCB,R6                  UCB BASE                  S99528
         MVC   RNAME(3),UCBNAME        MOVE NAME TO P-LIST       S99528
         DROP  R6                      DROP                      S99528
DEQNAME  DEQ   ,MF=(E,DEQLIST)         DEQ                       S99528
         MVI   RNAME,X'40'
         MVC   RNAME+1(7),RNAME
         TM    0(R5),TOTTDORN          TEST DEVICE ON 3705       S22024
         BZ    NXTENT                  NO BRANCH                 S22024
         TM    0(R5),TOTTDLIN          TEST DEVICE 3705 LINE    -S22024
         BZ    RNTEMDQ                 NO BRANCH                 S22024
NXTENT   EQU   *                                                 S22024
         LA    R5,4(R5)                GET NEXT ENTRS            S22024
         CR    R5,R7                   END OF TABLE              S99528
         BNE   LOOPP                   NO BRANCH                 S99528
TCNT211  TM    TOTPRDCB+X'30',X'10'    DCB OPEN                  S99528
         BZ    SECDCBT                 NO BRANCH                 S99528
         L     R1,TOTPRDEB             GET PRIMARY DEB         @XM05672
         LA    R1,0(R1)                CLEAR HI BYTE           @XM05672
         LTR   R1,R1                   Q-IS THERE ONE          @XM05672
         BZ    SECDCBT                 N-CHECK SECONDARY       @XM05672
         LA    R1,TOTPRDCB             TEST DCB                  S99528
         ST    R1,TOTWKSPC             STORE IN P LIST           S99528
         MVI   TOTWKSPC,X'B0'          OPTION CLOSE              S99528
         LA    R1,TOTWKSPC             ADDRESS OF P LIST         S99528
         CLOSE MF=(E,(1))              CLOSE TEST DCB            S99528
****   CLOSE GRABED DCBS IF ANY        ***********
*****                                  ***********
SECDCBT  TM    TOTSCDCB+X'30',X'10'    SECOND DCB OPEN           S99528
         BZ    TCNT21                  NO BRANCH                 S99528
         L     R1,TOTSCDEB             EET SECONDARY BED         S99528
         LTR   R1,R1                   IS THERE ONE              S99528
         BZ    TCNT21                  NO BRANCH                 S99528
         LA    R1,TOTSCDCB             SECENDARY DEC             S99528
         ST    R1,TOTWKSPC             STORE IN P LIST           S99528
         MVI   TOTWKSPC,X'B0'          OPTION CLOSE              S99528
         LA    R1,TOTWKSPC             ADDRESS OF P LIST         S99528
         CLOSE MF=(E,(1))              CLOSE SECONDARY DCB       S99528
TCNT21   EQU   *
         TM    TOTFLG09,TOTPRECT       WAS AP SELECTED           S99528
         BO    CTSYSCO                 NO BRANCH                 S99528
         TM    TOTFLG09,TOTAPTRM       IS AP TERMINAL            S99528
         BO    APORGST                 YES BRANCH                S99528
         B     CTSYSCO                 BRANCH                    S99528
APHOLD   EQU   *                                                 S22024
         TM    LUFLAGS,APLUNT     Q-IS AP AN LU                @XM05672
         BO    ON                 Y-BRANCH                     @XM05672
         MVI   TOTOVBCD,HOLDTERM       VERB TO HOLD TERMINAL     S22024
         B     HOLDREL                 GO HOLD                   S99528
INACTLST EQU   *                                                 S22024
         MVI   TOTOVBCD,INACTERM       VERB TO INACTIVATE        S22024
         B     INACACTI                GO INACTIVE               S99528
STOPAP   EQU   *                                                 S22024
         MVI   TOTOVBCD,LINESTOP       VERB TO STOP LINE         S22024
         B     STARSTOP                STOP                      S99528
APORGST  EQU   *                       AP ORGINAL STATUS         S99528
**   TEST FLAGS IN TOTAPDFL TO DETERMINE ORIGINAL STATUS OF      S99528
**   AP IF IT IS A TERMINAL-- RETURN TO ORGINAL STATUS           S99528
         L     R6,TOTARTNT             GET AP TNT ADDRESS      @YM08136
         SLR   R1,R1                   CLEAR REGISTER          @YM08136
         IC    R1,TOTTTBEL             GET MAXIMUM NAME LENGTH @YM08136
         AR    R6,R1                   POINT TO TTE PREFIX     @YM08136
         ICM   R6,ADRMSK,D0(R6)        GET TTE ADDRESS         @YM08136
         LA    R1,TRMPRFSZ             GET TTE PREFIX SIZE     @YM08136
         SLR   R6,R1                   POINT TO TTE PREFIX     @YM08136
         USING IEDNTRM,R6              SET TTE PREFIX ADDRESS  @YM08136
         TM    TRMSTATE,TRMPREF        NCP RESOURCE            @YM08136
         BZ    APCHKE                  NO - CONTINUE           @YM08136
         CLI   TRMTYPE,TRMLUNT         SNA LU ENTRY            @YM08136
         BNE   APCHKE                  N-BYPASS FLAG SETTING   @XM05672
         OI    LUFLAGS,APLUNT          AP IS LUNT FLAG         @XM05672
APCHKE   EQU   *                                               @YM08136
         DROP  R6                                              @YM08136
         SR    R7,R7                   CLEAR REG                 S99528
         IC    R7,TOTAPRLN             GET RLN                   S99528
         STC   R7,TOTORLN              PUT IN P-LIST             S22024
         MVC   TOTOLADR(D8),TOTAPNAM   NAME TO P-LIST            S22024
         MVC   BSTOPNAM(EIGHT),TOTAPNAM MANE TO MSG              S99528
         TM    TOTAPDFL,TOTAPHD        INIT HELD                 S99528
         BO    APHOLD                  YES BR                    S99528
         MVI   TOTOVBCD,REALTERM       VERB TO REALEASE TERMINAL
HOLDREL  BAL   R12,ORIGTERM            OP CONTROL                S99528
         CLI   TOTORTCD,X00            OK                        S22024
         BE    ON                      OK BR                     S99528
         CLI   TOTORTCD,X08            ALREADY DONE              S22024
         BE    ON                      OK BR                     S99528
         BAL   R12,BSTOP               MSG TO SYSCON             S99528
ON       EQU   *                       CONTINUE                  S99528
         MVI   BSTOPNAM,X40            CLEAR OUT                 S22024
         MVC   BSTOPNAM+D1(D7),BSTOPNAM  NAME IN MSG             S22024
INACACTI EQU   *                                                 S22024
         MVC   TOTOLADR(D8),TOTAPNAM   NAME TO P-LIST            S22024
         MVC   BSTOPNAM(EIGHT),TOTAPNAM  NAME TO MSG             S99528
ON1      EQU   *                       CONTINUE                  S99528
         TM    TOTAPFLG,TOTAPORN       AP ON 3705                S22024
         BNO   LINEAP                  NO, BRANCH                S05331
         MVC   TRMSAVE(D2),TOTARSID    GET RESOURCE ID OF AP     S05331
         OI    RNFLAG,APFLAG           SET AP ON 3705 FLAG       S05331
         L     R9,TOTARTNT             AP TNT ADDRESS          @Y17XAUU
         SLR   R3,R3                   CLEAR REG               @Y17XAUU
         IC    R3,TOTTTBEL             GET NAME LENGTH         @Y17XAUU
         AR    R9,R3                   POINT TO TTE ADDRESS    @Y17XAUU
         MVC   TTEADDR+D1(D3),D0(R9)   ALLIGN ADDRESS          @Y17XAUU
         L     R9,TTEADDR              GET TTE ADDRESS         @Y17XAUU
         LA    R3,TRMPRFSZ             GET TTE PREFIX SIZE     @Y17XAUU
         SLR   R9,R3                   ADDRESS OF TTE PREFIX   @Y17XAUU
         USING IEDNTRM,R9              TTE ADDRESSABILITY      @XM05672
         NI    TRMBYTE1,XFF-TRMSTOTE   TURN OFF TOTE BIT       @XM05672
         DROP  R9                                              @XM05672
         BAL   R6,CHKTTE               GET AP LINE TTE ADDRESS @Y17XAUU
         NI    RNFLAG,XFF-APFLAG       TURN OFF AP FLAG          S05331
         TM    LUFLAGS,APLUNT     Q-IS AP AN LU                @XM05672
         BO    ON2                Y-BRANCH AROUND STARTLINE    @XM05672
         MVC   TOTOLADR(EIGHT),TOTAPRNL  MOVE AP GROUP NAME INTO S05331
*                                          OP CONTROL PARM LIST  S05331
         MVC   BSTOPNAM(EIGHT),TOTAPRNL  MOVE GROUP NAME INTO MSGS05331
         MVC   TOTORLN(1),TOTAPRLN     MOVE RLN INTO PARM LIST   S05331
         B     CKLINEAP                GO CHECK INITIAL STATUS   S05331
LINEAP   EQU   *                                                 S05331
         SR    R6,R6                   CLEAR                   @G36XRUV
         ICM   R6,THREE,TOTAPUCB       UCB ADDRESS             @G36XRUV
         USING UCB,R6                  UCB                       S99528
         MVC   TOTOLADR(D3),UCBNAME    UCB TO P-LIST             S22024
         MVC   BSTOPNAM(THREE),UCBNAME UCB TO MSG                S99528
         DROP  R6                      UCB                       S99528
CKLINEAP EQU   *                                                 S05331
         TM    TOTAPDFL,TOTAPLST       AP LINE INIT STOPPED      S22024
         BO    STOPAP                  YES BR                    S99528
         MVI   TOTOVBCD,LINESTRT       VERB TO START LINE        S22024
STARSTOP BAL   R12,ORIGTERM            OP CONTROL                S99528
         CLI   TOTORTCD,X00            OK                        S22024
         BE    ON2                     OK BR                     S99528
         CLI   TOTORTCD,X08            ALREADY DONE              S22024
         BE    ON2                     OK BR                     S99528
         BAL   R12,BSTOP               MSG TO SYSCON             S99528
ON2      EQU   *                       CONTINUE                  S99528
         MVC    RNAME(EIGHT),TOTAPNAM  DEQ AP TERM               S99528
         DEQ   ,MF=(E,DEQLIST)         DEQ                       S99528
         MVI   RNAME,X'40'             BLANK OUT                 S99528
         MVC   RNAME+1(7),RNAME        R NAME                    S99528
         SR    R5,R5                   CLEAR                   @G36XRUV
         ICM   R5,THREE,TOTAPUCB       GET AP UCB ADDRESS      @G36XRUV
         USING UCB,R5                  UCB ADDRESSIBILITY        S99528
         MVC   RNAME(3),UCBNAME        UCB NAME TO DEQ           S99528
         DEQ   ,MF=(E,DEQLIST)         DEQ                       S99528
         MVI   RNAME,X'40'             BLANK OUT                 S99528
         MVC   RNAME+1(7),RNAME        R NAME                    S99528
         TM    TOTAPFLG,TOTAPORN       AP ON A 3705              S22024
         BO    RNAPDQ                  YES BRANCH                S22024
CTSYSCO  EQU   *                       CONTROL TERMINAL TO ORG STS99528
         TM    TOTFLG09,TOTCTCON       CONTROL TERMINAL = SYSCON S99528
         BO    UNALLOCK                YES BRANCH                S22024
         L     R3,TOTCRTNT             SEE IF A REAL ENTRY       S22024
         LTR   R3,R3                   EXIST IF NOT              S22024
         BZ    UNALLOCK                BRANCH                    S22024
         L     R6,TOTCRTNT             GET CT TNT ADDRESS      @YM08136
         SLR   R1,R1                   CLEAR REGISTER          @YM08136
         IC    R1,TOTTTBEL             GET MAXIMUM NAME LENGTH @YM08136
         AR    R6,R1                   POINT TO TTE ADDRESS    @YM08136
         ICM   R6,ADRMSK,D0(R6)        GET TTE ADDRESS         @YM08136
         LA    R1,TRMPRFSZ             GET TTE PREFIX SIZE     @YM08136
         SLR   R6,R1                   POINT TO TTE PREFIX     @YM08136
         USING IEDNTRM,R6              SET TTE ADDRESSABILITY  @YM08136
         TM    TRMSTATE,TRMPREF        NCP RESOURCE            @YM08136
         BZ    CTCKE                   NO - CONTINUE           @YM08136
         CLI   TRMTYPE,TRMLUNT         SNA LU ENTRY            @YM08136
         BNE   CTCKE                   N-BYPASS FLAG SETIING   @XM05672
         OI    LUFLAGS,CTLUNT          CONTROL TERM IS LU      @XM05672
         DROP  R6                                              @YM08136
CTCKE    EQU   *                                               @YM08136
*   RETURN CONTROL TO ORGINAL STATUS                             S99528
         LA    R1,TOTCTNAM             POINT TO TERM NAME        S99528
         SR    R3,R3                   CLEAR REG                 S99528
LOP      CLI   0(R1),X'61'             SLASH                     S99528
         BE    MOVE                    YES BR                    S99528
         LA    R3,1(R3)                BUMP CNTER                S99528
         LA    R1,1(R1)                BUMP CNTER                S99528
         B     LOP                     TRY AGAINM                S99528
RNAPDQ   EQU   *                                                 S22024
         L    R9,TOTARTNT              GET ALT PRT TNT ADDRESS   S22024
         BAL   R12,TERMRNDQ            GO DEQ LINE FOR AP        S22024
         B     CTSYSCO                 CHECK CONTROL TERM        S22024
CTHOLD   EQU   *                                                 S22024
         TM    LUFLAGS,CTLUNT          Q-IS CTL TERM LUNT      @XM05672
         BO    ON3                     Y-ALREADY HELD          @XM05672
         MVI   TOTOVBCD,HOLDTERM       HOLD TERMINAL             S22024
         B     RELHOLD                 GO HOLD                   S99528
LSTINACT EQU   *                                                 S22024
         MVI   TOTOVBCD,INACTERM       INACTIVATE TERM           S22024
         B     ACTIINAC                GO INACTIVE               S99528
STOPCT   EQU   *                                                 S22024
         MVI   TOTOVBCD,LINESTOP       STOP LINE                 S22024
         B     STOPSTAR                STOP                      S99528
RNCTDQ   EQU   *                                                 S22024
         L     R9,TOTCRTNT             GET CT TNT ADDRESS        S22024
         BAL   R12,TERMRNDQ            GO DEQ TERM - LINE        S22024
         B     APDQRT                  CONTINUE                  S22024
MOVE     EQU   *                                               @YM08136
         SLR   R3,R3                   CLEAR REGISTER          @YM08136
         IC    R3,TOTTTBEL             GET MAXIMUM NAME LENGTH @YM08136
         BCTR  R3,0                    DECREMENT FOR EX        @YM08136
         L     R1,TOTCRTNT             GET CT TNT ADDRESSAME   @YM08136
         EX    R3,CTNAME               GO MOCE NAME              S99528
         MVC   TOTCTNAM(EIGHT),RNAME   CT NAME SAVE              S99528
         MVC   TOTOLADR(EIGHT),TOTCTNAM  MOVE CT NAME INTO P-LISTS05331
         DEQ   ,MF=(E,DEQLIST)         DEQ                       S99528
         MVI   RNAME,X'40'             BLANK OUT                 S99528
         MVC   RNAME+1(7),RNAME        R NAME                    S99528
         SR    R5,R5                   CLEAR                   @G36XRUV
         ICM   R5,THREE,TOTCTUCB       GET CT UCB ADDRESS      @G36XRUV
         USING UCB,R5                  UCB ADDRESSIBILITY        S99528
         MVC   RNAME(3),UCBNAME        UCB NAME TO DEQ           S99528
         DEQ   ,MF=(E,DEQLIST)         DEQ                       S99528
         MVI   RNAME,X'40'             BLANK OUT                 S99528
         MVC   RNAME+1(7),RNAME        R NAME                    S99528
         DROP  R5                                                S99528
         TM    TOTCTFLG,TOTCTORN       CT ON A 3705              S22024
         BO    RNCTDQ                  YES BRANCH                S22024
APDQRT   EQU   *                                                 S22024
         SR    R7,R7                   CLEAR REG                 S22024
         IC    R7,TOTCTRLN             GET RLN                   S99528
         STC   R7,TOTORLN              RLN TO P-LIST             S22024
         MVC   BSTOPNAM(EIGHT),TOTCTNAM MANE TO MSG              S99528
         TM    TOTCTDFL,TOTAPHD        INIT HELD                 S99528
         BO    CTHOLD                  YES BR                    S99528
         MVI   TOTOVBCD,REALTERM       REALEASE TERMINAL         S22024
RELHOLD  BAL   R12,ORIGTERM            OP CONTROL                S99528
         CLI   TOTORTCD,X00            OK                        S22024
         BE    ON3                     OK BR                     S99528
         CLI   TOTORTCD,X08            ALREADY DONE              S22024
         BE    ON3                     OK BR                     S99528
         BAL   R12,BSTOP               MSG TO SYSCON             S99528
ON3      EQU   *                       CONTINUE                  S99528
         MVI   BSTOPNAM,X40            CLEAR OUT                 S22024
         MVC   BSTOPNAM+D1(D7),BSTOPNAM  NAME IN MSG             S22024
ACTIINAC EQU   *                                                 S22024
         MVC   TOTOLADR(D8),TOTCTNAM   NAME TO P-LIST            S22024
         MVC   BSTOPNAM(EIGHT),TOTCTNAM  NAME TO MSG             S99528
ON4      EQU   *                       CONTINUE                  S99528
         MVI   BSTOPNAM,X40            CLEAR OUT                 S22024
         MVC   BSTOPNAM+D1(D7),BSTOPNAM  NAME IN MSG             S22024
         TM    TOTCTFLG,TOTCTORN       CT ON 3705                S22024
         BNO   LINECT                  NO, BRANCH                S05331
         MVC   TRMSAVE(D2),TOTCRSID    GET RESOURCE ID OF CT     S05331
         OI    RNFLAG,CTFLAG           SET CT ON 3705 FLAG       S05331
         L     R9,TOTCRTNT             CT TNT ADDRESS          @Y17XAUU
         SLR   R3,R3                   CLEAR REG               @Y17XAUU
         IC    R3,TOTTTBEL             GET NAME LENGTH         @Y17XAUU
         AR    R9,R3                   POINT TO TTE ADDRESS    @Y17XAUU
         MVC   TTEADDR+D1(D3),D0(R9)   ALLIGN ADDRESS          @Y17XAUU
         L     R9,TTEADDR              GET TTE ADDRESS         @Y17XAUU
         LA    R3,TRMPRFSZ             GET TTE PREFIX SIZE     @Y17XAUU
         SLR   R9,R3                   POINT TO TTE PREFIX     @Y17XAUU
         USING IEDNTRM,R9              TTE ADDRESSABILITY      @XM05672
         NI    TRMBYTE1,XFF-TRMSTOTE   TURN OFF TOTE BIT       @XM05672
         DROP  R9                                              @XM05672
         BAL   R6,CHKTTE               GET CT LINE TTE ADDRESS @Y17XAUU
         NI    RNFLAG,XFF-CTFLAG       TURN OFF CT FLAG          S05331
         TM    LUFLAGS,CTLUNT           Q-IS CTL TERM LUNT     @XM05672
         BO    ON5                      Y-LINE ALREADY STARTED @XM05672
         MVC   TOTOLADR(EIGHT),TOTCTRNL  MOVE CT GROUP NAME INTO S05331
*                                          OP CONTROL PARM LIST  S05331
         MVC   BSTOPNAM(EIGHT),TOTCTRNL  MOVE GROUP NAME INTO MSGS05331
         MVC   TOTORLN(1),TOTCTRLN     MOVE RLN INTO PARM LIST   S05331
         B     CKLINECT                GO CHECK LINE STATUS      S05331
LINECT   EQU   *                                                 S05331
         SR    R6,R6                   CLEAR                   @G36XRUV
         ICM   R6,THREE,TOTCTUCB       UCB ADDRESS             @G36XRUV
         USING UCB,R6                  UCB                       S99528
         MVC   TOTOLADR(D3),UCBNAME    UCB TO P-LIST             S22024
         MVC   BSTOPNAM(THREE),UCBNAME UCB TO MSG                S99528
         DROP  R6                      UCB                       S99528
CKLINECT EQU   *                                                 S05331
         TM    TOTCTDFL,TOTCTLST       LINE INITALLY STOPPED     S22024
         BO    STOPCT                  YES BR                    S99528
         MVI   TOTOVBCD,LINESTRT       START LINE                S22024
STOPSTAR BAL   R12,ORIGTERM            OP CONTROL                S99528
         CLI   TOTORTCD,X00            OK                        S22024
         BE    ON5                     OK BR                     S99528
         CLI   TOTORTCD,X08            ALREADY DONE              S22024
         BE    ON5                     OK BR                     S99528
         BAL   R12,BSTOP               MSG TO SYSCON             S99528
ON5      EQU   *                       CONTINUE                  S99528
         B     UNALLOCK                BRANCH                    S22024
ORIGTERM EQU   *                                               @SA74550
         XC    TOTORTCD,TOTORTCD       CLEAR RETURN CODE FIELD @YM09003
         LA    R1,TOTOTECB              GET THE TOTE ECB ADDR  @SA74550
         ST    R1,TOTOECBA              PUT IN PARM LIST       @SA74550
         LA    R1,CBSLPL                GET PARM LIST ADDR     @SA74550
         XC    TOTOLINK(D3),TOTOLINK   CLEAR LINK FIELD          S22024
         XC    TOTOTECB,TOTOTECB       CLEAR ECB                 S99528
         AQCTL                         POST ELEMENT              S99528
         WAIT  ECB=TOTOTECB            WAIT FOR COMLLEATION      S99528
         MVI   TOTOLADR,C' '           CLEAR NAME                S22024
         MVC   TOTOLADR+D1(D7),TOTOLADR IN P-LIST                S22024
         BR    R12                     RETURN                    S99528
RETURN4  EQU   *
*
*        RETURN TO RESIDENT MODULE
*
         MVC   QNAME,QNAMEE            MAJOR TO LIST             S22024
         MVC   RNAME(8),RNAMEE         MINOR TO LIST             S22024
         DEQ   ,MF=(E,DEQLIST)         CONFIG LIBS               S22024
         SPACE 2
RETURN3  EQU   *                                                 S22024
         TM    TOTFLG02,TOTCONCU       CONC CLEANUP REQUIRED     S22024
         BZ    RETURN                  NO BRANCH                 S22024
         L     R14,12(R13)             GET RETURN ADDRESS        S22024
         XCTL  (2,12),EP=IEDQWEC       GO TO CONC CLEANUP MODULE S22024
RETURN   EQU   *                                                 S22024
         L     R13,4(R13)              RESTORE SAVE POINTER      S99528
         LM    R14,R12,12(R13)         RESTORE REGS              S99528
         SR    R15,R15            SET GOOD RETURN CODE
         BR    R14                     RETERN TO IEDQWA          S99528
*                                      THIS ROUTINE INSURES THAT S22024
*                                      ALL UCB UNALLOCATE BITS   S22024
*                                      ARE TURNED OFF            S22024
UNALLOCK EQU   *                                                 S22024
*        INSURE TOTE DOESNOT LEAVE THE CONTROL TERM OR ALT       S22024
*        PRINTER LISE RESORRCE ASSIGNED TO TOTE                  S22024
         TM    TOTCTFLG,TOTCTORN       CT ON RN                  S22024
         BO    CTSTOTE                 YES BRANCH                S22024
         L     R6,TOTCTRLN             GET LCB ADDRESS           S22024
         LTR   R6,R6                   IS THTER ONE              S22024
         BZ    APCHECK                 NO BRANCK                 S22024
         USING IEDQLCB,R6              LCB                       S22024
         CLI   LCBCPA,XF1              TOTE OWN RESOURCE         S22024
         BNE   APCHECK                 NO BRANCH                 S22024
         MVI   LCBCPA,X00              GIVE RESIURCE TO TCAM     S22024
APCHECK  EQU   *                                                 S22024
         TM    TOTAPFLG,TOTAPORN       AP ON RN                  S22024
         BO    APSTOTE                 YES BRANCH                S22024
         L     R6,TOTAPRLN             GET AP LCB ADDRESS        S22024
         LTR   R6,R6                   IS THTER ONE              S22024
         BZ    UNALLBIT                NO BRANCH                 S22024
         CLI   LCBCPA,XF1              TOE OWN RESOURCE          S22024
         BNE   UNALLBIT                NO BRANCH                 S22024
         MVI   LCBCPA,X00              GIVE RESOURCE TO TCAM     S22024
UNALLBIT EQU   *                                                 S22024
         DROP  R6                      LCB                       S22024
         TM    TOTTDTBL,TOTTDLIN       TEST DEV A LINE           S22024
         BZ    RETURN4                 NO BRANCH                 S22024
         TM    TOTTDTBL,TOTTDORN       TEST DEV ON RN            S22024
         BO    RETURN4                 YES BRANCH                S22024
         LA    R3,TOTTDTBL             TEST DEV TABLE ADDR       S22024
         LA    R5,TOTTDEND             END ADDRESS               S22024
UNALLALL EQU   *                                                 S22024
         CR    R3,R5                   ALL ENTRIES PROCESSED     S22024
         BE    RETURN4                 YES BRANCH                S22024
         L     R8,D0(R3)               GET UCB ADDRESS           S22024
         LA    R8,D0(R8)               CLEAR HIGH BYTE           S22024
         LTR   R8,R8                   ENTRY ZERO                S22024
         BZ    RETURN4                 YES BRANCH                S22024
         TM    D0(R8),UCBNALBT         UCB UNALLOCATE BIT ON     S22024
         BZ    BMPUNLL                 NO BRANCH                 S22024
         MVC   UCBWORK(D4),D0(R8)      MOVE UCB TO WORK AREA     S22024
         NI    UCBWORK+D1,UCBNALOF     TURN OFF UNALLOCATE BIT   S22024
         ST    R8,TOT102A              TARGET ADDRESS TO P LIST  S22024
         LA    R1,TOT102               POINT TO P LIST           S22024
         AQCTL                         MOVE DATA                 S22024
BMPUNLL  EQU   *                                                 S22024
         LA    R3,D4(R3)               DUMP TEST DEV PTR         S22024
         B     UNALLALL                CONTINUE THRU TABLE       S22024
         EJECT
         IEDQMSG LINK=YES,PREG0=R0
*                                                                     *
*        CONTROL TERMINAL AND ALTERNATE PRINTER ORIGINAL STATUS       *
*                                                                     *
STCTAP   EQU   *                       START CONTROL TERM AND AP S99528
         MVI   TOTOVBCD,LINESTRT       VERB TO START LINE        S22024
         L     R1,TOTAVTPT             GET AVT POINTER   DE      S99528
         USING IEDQAVTD,R1             AVT ADDRESSIBILITY        S99528
         LA    R1,AVTOPCOB             GET OP CONTROL QCB        S99528
         ST    R1,TOTOKEY              PUT IN P-LIST             S22024
         DROP  R1
         SR    R1,R1                   CLEAR                   @G36XRUV
         ICM   R1,THREE,TOTCTUCB       GET UCB ADDRESS         @G36XRUV
         TM    APSTIME,APSTIMER        STIM FOR AP               S99528
         BZ    STARTUCB                NO BRANCH                 S99528
         SR    R1,R1                   CLEAR                   @G36XRUV
         ICM   R1,THREE,TOTAPUCB       GET AP UCB              @G36XRUV
         USING UCB,R1                  UCB ADDRESSIBILITY        S99528
STARTUCB EQU   *                                                 S99528
         LTR   R1,R1              IS A VALID UCB ADDRESS PRESENT?S99528
         BZ    0(R12)             NO, RETURN                     S99528
         MVC   TOTOLADR(D3),UCBNAME    PUT UCB INTO P-LIST       S22024
         DROP  R1                                                S99528
         SR    R1,R1                   CLEAR REG                 S99528
         IC    R1,TOTCTRLN             GET RLN                   S99528
         TM    APSTIME,APSTIMER        STIMER FOR AP             S99528
         BZ    STARTRLN                NO BRANCH                 S99528
         IC    R1,TOTAPRLN             GET AP RLN                S99528
STARTRLN EQU   *                                                 S22024
         XC    TOTORTCD,TOTORTCD       CLEAR RETURN CODE FIELD @YM09003
         STC   R1,TOTORLN              RLN TO P-LIST             S22024
         LA    R1,TOTOTECB             GET ECB ADDRESS           S99528
         ST    R1,TOTOECBA             PUT IN P-LIST             S22024
         LA    R1,CBSLPL               SVC 102 P-LIST            S22024
         XC    TOTOLINK(D3),TOTOLINK   CLEAR LINK FIELD          S22024
         XC    TOTOTECB(4),TOTOTECB    CLEAR ECB                 S99528
         AQCTL                         GO TO OP CONTOOL          S99528
         WAIT  ECB=TOTOTECB            WAIT FOR START LINE       S99528
         MVI   TOTOLADR,C' '           BLANK OUT                 S22024
         MVC   TOTOLADR+D1(D7),TOTOLADR NAME IN P-LIST           S22024
         B     0(R12)                  RETURN                    S99528
CTSTOTE  EQU   *                                                 S22024
         L     R8,TOTCRTNT             GET TNT ADDRESS           S22024
         BAL   R7,TNTALINE             GO ALLINE ADDRESS         S22024
         L     R6,TTEADDR              GET TTE ADDRESS           S22024
         LA    R7,TRMPRFSZ             GET TTE PREFIX SIZE     @Y17XAUU
         SLR   R6,R7                   ADDRESS OF TTE PREFIX   @Y17XAUU
         USING IEDNTRM,R6              SET TTE ADDRESSABILITY  @Y17XAUU
         NI    TRMBYTE1,XFF-TRMSTOTE   RESET TOTE FLAG         @Y17XAUU
         L     R6,CTLTTE               GET CONTROL TERMINAL LINE S05331
*                                        TTE ADDRESS             S05331
         NI    TRMBYTE1,XFF-TRMSTOTE   RESET TOTE FLAG         @Y17XAUU
         B     APCHECK                 BRANCH                    S22024
APSTOTE  EQU   *                                                 S22024
         L     R8,TOTARTNT             GET TNT ADDRESS           S22024
         BAL   R7,TNTALINE             ALLINT TTE ADDRESS        S22024
         L     R6,TTEADDR              GET AP TTE ADDRESS        S22024
         LA    R7,TRMPRFSZ             GET TTE PREFIX SIZE     @Y17XAUU
         SLR   R6,R7                   POINT TO TTE PREFIX     @Y17XAUU
         NI    TRMBYTE1,XFF-TRMSTOTE   RESET TOTE FLAG         @Y17XAUU
         L     R6,APLTTE               GET ADDRESS OF AP LINE TTES05331
         NI    TRMBYTE1,XFF-TRMSTOTE   RESET TOTE FLAG         @Y17XAUU
         B     UNALLBIT                BRANCH                    S22024
         DROP  R6                      TTE                       S22024
         EJECT
*
*        START LINE ROUTINE
*
LISTART  EQU   *                                                 S22024
         MVI   TOTOVBCD,LINESTRT       VERB CODE TO START LINE   S22024
         TM    INITSTAT,TOTTDORN       TEST LIEN ON RN           S22024
         BO    LINERNST                YES BRANCH                S22024
         MVC   TOTOLADR(D3),D13(R8)    NAME TO REQ ELE           S22024
         MVC   BSTOPNAM(3),13(R8)      UCB NAME TO MSG           S99528
         L     R1,TOTAVTPT             GET AVT ADDRESS           S99528
         USING IEDQAVTD,R1             AVT ADDRESSIBILITY        S99528
         LA    R10,AVTOPCOB            GET OPERATOR CONTROL QCB  S99528
         ST    R10,TOTOKEY             PUT IN P-LIST             S22024
         L     R1,AVTTCB               GET TCAM TCB ADDRESS      S99528
         DROP  R1                      REALEASE R1               S99528
         L     R1,8(R1)                GET DEB CHAIN ADDRESS     S99528
STLINE01 EQU   *                                                 S99528
         LA    R1,0(R1)                CLEAR HIGH BYTE           S99528
         LTR   R1,R1                   ZERO                      S99528
         BZ    ERROR                   YES BRANCH                S99528
         SR    R10,R10                 CLEAR LOOP COUNTER AND    S99528
         IC    R10,16(R1)              INITIALIZE IT TO NUMBER EXS99528
         LA    R5,32(R1)               GET UCB CHAIN ADDRESS     S99528
         L     R11,4(R1)               GET NEXT BEB ADDRESS      S99528
         L     R9,24(R1)               GET DCB ADDRESS           S99528
         USING IHADCB,R9               DCB ADDRESSIBILITY        S99528
         TM    DCBDSORG+D1,X44         TCAM DEB                  S22024
         BZ    STLIN024                NO GET NEXT DEB           S99528
         LA    R7,1                    INITIALIZE RLN COUNTER
STLINE02 EQU   *                                                 S99528
         L     R6,0(R5)                GET UCB ADDDRESS          S99528
         LA    R6,0(R6)                FOR COMPARE               S99528
         LA    R8,0(R8)                CLEAR HIGH BYTE           S99528
         CR    R8,R6                   CORRECT UCB FOUND         S99528
         BE    STLINE03                YES BRANCH                S99528
         LA    R5,4(R5)                GET NEXT UCB ADDRESS      S99528
         LA    R7,1(R7)                BUMP RLN                  S99528
         BCT   R10,STLINE02            LOOP TILL END OF UCB CH   S99528
STLIN024 EQU   *                                                 S99528
         LR    R1,R11                  POINT R1 TO NEXT DEB      S99528
         B     STLINE01                GET NEXT UCB CHAIN        S99528
ERROR    EQU   *                                                 S99528
         OI    TOTFLG06,TOTCANCL+TOTOTERM CANCEL TRM             S99528
**********     TEST DEVICE DOES NOT BELONG TO TCAM      *********S99528
         IEDQMSG MSGID=045,PREG0=R0,PREG1=R1,FUNCT=CEC,          S99528C
               RET=TCNT179                                       S99528
STLINE03 EQU   *                                                 S99528
         SR    R10,R10                 CLEAR REG                 S99528
         IC    R10,DCBEXLST            GET LCB LENGTH            S99528
         LR    R11,R7                  GET RLN                   S99528
         MR    R10,R10                 RLN TIMES LCB LENGTH      S99528
         L     R10,DCBIOBAD            GET DUMMY IOB ADDRESS     S99528
         LA    R10,0(R10,R11)          GET IOB ADDRESS           S99528
         LA    R11,LCBFLAG1-IEDQLCB    GET OFFSET TO LCB START   S99528
         SR    R10,R11                 SUBTRACT FROM IOB ADDR    S99528
         USING IEDQLCB,R10             LCB ADDRESSABILITY        S99528
         MVI   LCBCPA,X'00'            CLEAR TOTE INDICATOR      S99528
         MVC   NCPTTCIN(D2),LCBTTCIN   SAVE NCP TTCIN OFFSET   @OY20578
*                                      FOR 3705 TEST           @OY20578
         USING UCBOB,R6                UCB                       S22024
         MVC   X3705(D1),UCBTBYT4      CONTROL UNIT TYPE         S22024
         NI    X3705,X0F               CLEAR UNWANTED BITS       S22024
         CLI   X3705,RNUCBTST          IS CONTROL UNIT 3705      S22024
         DROP  R6                      UCB                       S22024
         BNE   NO3705                  NO BRANCH                 S22024
         TM    INITSTAT,TOTTNIPL       IS IPL REQUIRED FOR 3705? S05331
         BO    CLEARNM                 NO, BYPASS IPL            S05331
         MVI   TOTOVBCD,IPL3705        IPL VERB                  S22024
         B     IPL37RN                 BRANCH                    S22024
NO3705   EQU   *                                                 S22024
         TM    INITSTAT,TOTTDLST       LINE ORIG STARTED         S22024
         BO    CLEARNM                 NO BRANCH                 S22024
         DROP  R9                                                S99528
         DROP  R10                                               S99528
IPL37RN  EQU   *                                                 S22024
         STC   R7,TOTORLN              RLN TO REQ ELE            S22024
RNLINRT  EQU   *                                                 S22024
         XC    TOTORTCD,TOTORTCD       CLEAR RETURN CODE FIELD @YM09003
         LA    R1,TOTOTECB             GET TOTE ECB              S99528
         ST    R1,TOTOECBA             PUT IN P-LIST             S22024
         LA    R1,CBSLPL               POINT R1 TO P-LIST        S99528
         XC    TOTOLINK(D3),TOTOLINK   CLEAR LINK FIELD          S22024
         XC    TOTOTECB(4),TOTOTECB    CLEAR TOTE ECB            S99528
         AQCTL                         POST ELEMENT TO OP CONTROLS99528
         WAIT  ECB=TOTOTECB            WAIT FOR COMPLETION       S99528
         CLI   X3705,RNUCBTST          3705 TEST                 S22024
         BNE   CLEARNM                 NO BRANCH                 S22024
         MVI   X3705,ZEROZ             CLEAR CONTROL TYPE        S22024
         MVI   TOTOVBCD,ACT3705        VERB TO ACTIVATE          S22024
*                                      3705                      S22024
         B     NO3705                  BRANCH                    S22024
CLEARNME EQU   *                                                 S22024
         MVI   TOTOLADR,C' '           BLANK OUT                 S22024
         MVC   TOTOLADR+D1(D7),TOTOLADR  NAME                    S22024
         BR    R12                     RETURN                    S22024
CLEARNM  EQU   *                                                 S22024
         MVI   TOTOLADR,C' '           BLANK OUT                 S22024
         MVC   TOTOLADR+D1(D7),TOTOLADR  NAME                    S22024
LINERNST EQU   *                       STOP LINE FOR RN TEST     S22024
*                                      DEVICES                   S22024
         TM    INITSTAT,TOTTDLIN+TOTTDORN TEST DEVICE 3705 LINE  S22024
         BO    SRTRNLIN                YES BRANCH                S22024
         SLR   R1,R1                   CLEAR PARM REG          @OY20578
         ICM   R1,HALFWORD,NCPTTCIN    GET NCP TTCIN           @OY20578
         L     R15,TOTAVTPT            GET AVT ADDRESS         @OY20578
         USING IEDQAVTD,R15            SET AVT ADDRESSSABILITY @OY20578
         L     R15,AVTRNMPT            ADDRESS OF TNT CODE     @OY20578
         DROP  R15                                             @OY20578
         BALR  R14,R15                 GET TTE ADDRESS         @OY20578
*        TTE ADDRESS IS RETURN IN REGISTER 1                   @OY20578
         LA    R15,TRMPRFSZ            TTE PREFIX SIZE         @OY20578
         SLR   R1,R15                  POINT TO TTE PREFIX     @OY20578
         USING IEDNTRM,R1              ADDR TO NEG PREFIX      @OY20578
         NI    TRMBYTE1,X'FF'-TRMSTOTE TURN OFF TOTE FLAG      @OY20578
         DROP  R1                                              @OY20578
         B     0(R12)                  RETURN                    S99528
*                                      TEST DEVICE IS A LINE     S22024
*                                      TEST ON A 3705            S22024
RNAMEPLT MVC   TOTOLADR(D0),D0(R8)     NAME TO P-LIST            S22024
RNAMEMSG MVC   BSTOPNAM(0),0(R8)       NAME TO MESSAGE           S22024
SRTRNLIN EQU   *                                                 S22024
         SR    R1,R1                   CLEAR REG                 S22024
         IC    R1,TOTTTBEL             GET NAME LENGTH           S22024
         BCTR  R1,D0                   DECREMENT FOR EX          S22024
         EX    R1,RNAMEMSG             LINE NAME TO MESSAGE      S22024
         L     R7,TOTAVTPT             GET AVT ADDRESS           S22024
         USING IEDQAVTD,R7             AVT                       S22024
         LA    R7,AVTOPCOB             GET ADDR OF OP CONTROL QCBS22024
         ST    R7,TOTOKEY              PUT IN P-LIST             S22024
         DROP  R7                      AVT                       S22024
         BAL   R7,TNTALINE             GET QCB ADDRESS           S22024
         SR    R7,R8                   CLEAR REG                 S22024
         USING IEDQQCB,R6              QCB                       S22024
         IC    R7,QCBRELLN             GET RLN FOR LINE          S22024
         STC   R7,TOTORLN              RLN TO P-LIST             S22024
         L     R7,QCBLGBAD-D1          GET LGB ADDRESS           S22024
         USING IEDNLGB,R7              LGB                       S22024
         MVC   TOTOLADR(D8),LGBNAME    GROUP NAME TO ELE         S22024
         DROP  R7                      LGB                       S22024
         L     R7,TTEADDR              GET TTE ADDRESS           S22024
         LA    R1,TRMPRFSZ             GET TTE PREFIX SIZE     @Y17XAUU
         SR    R7,R1                   POINT TO TTE PREFIX     @Y17XAUU
         USING IEDNTRM,R7              TTE                       S22024
         NI    TRMBYTE1,X'FF'-TRMSTOTE RESET TOTE FLAG         @Y17XAUU
         DROP  R7                      TTE                       S22024
         TM    INITSTAT,TOTTDLST       LINE ORIG ATARTED         S22024
         BO    CLEARNME                NO BRANCH                 S22024
         OI    INITSTAT,TOTTDLST       SET ORIG STOPPED          S22024
         B     RNLINRT                 GO START LINE             S22024
STARTERM EQU   *                                                 S99528
         XC    TOTORTCD,TOTORTCD       CLEAR RETURN CODE FIELD @YM
         BAL   R7,TNTALINE             GET QCB ADDRESS           S99528
         USING IEDQQCB,R6                                        S99528
         SR    R7,R7                   CLEAR REG                 S99528
         IC    R7,QCBRELLN             GET RLN                   S99528
         DROP  R6                                              @Y17XAUU
         STC   R7,TOTORLN              PUT IN P-LIST             S22024
         BCTR  R10,0                   DECREMENT FOR EX          S99528
         EX    R10,SYMMOVE             GO MAVE SYMBLLIC NAME     S99528
         EX    R10,MSGMOVE             MOVE NAME TO MSG          S99528
         XC    TOTOLINK(D3),TOTOLINK   CLEAR LINK FIELD          S22024
         XC    TOTOTECB,TOTOTECB       CLEAR ECB                 S99528
         LA    R1,TOTOTECB             GET ECB ADDRESS           S99528
         ST    R1,TOTOECBA             PUT IN P-LIST             S22024
         L     R1,TOTAVTPT             GET AVT ADDRESS           S99528
         USING IEDQAVTD,R1             AVT ADDRESSIBILITY        S99528
         LA    R1,AVTOPCOB             GET OP CONTROL QCB        S99528
         DROP  R1                                                S99528
         ST    R1,TOTOKEY              PUT IN P-LIST             S22024
         LA    R1,CBSLPL               GET P-LIST ADDR           S99528
         AQCTL                         POST ELEMENT TO OP CONRROLS99528
         WAIT  ECB=TOTOTECB            WAIT FOR COMPLEATION      S99528
         MVI   TOTOLADR,C' '           BLANK OUT                 S22024
         MVC   TOTOLADR+D1(D7),TOTOLADR
         MVC   TOTOLADR+D1(D7),TOTOLADR  NAME                    S22024
         B     0(R12)                  RETURN                    S99528
SYMMOVE  MVC   TOTOLADR(D0),D0(R8)     SYMBOLIC NAME TO P-LIST   S22024
MSGMOVE  MVC   BSTOPNAM(0),0(R8)       NAME TO MSG               S99528
         EJECT
***********************************************************************
***********************************************************************
*                                                                     *
*       FIND UCB ROUTINE FOR TNT ENTRIES                              *
*                                                                     *
***********************************************************************
***********************************************************************
UCBFIND  EQU   *                                                 S99528
         ST    R5,UCB5SAVE             SAVE REG
         ST    R3,UCB3SAVE             SAVE REG                  S99528
         SR    R5,R5                   CLEZA REG                 S99528
         IC    R5,TOTTTBEL             GET TERMINAL NAME LENGTH  S99528
         AR    R5,R8                   GET TTE ADDRESS           S99528
         MVC   TTEADDR+1(3),0(R5)      ALLINE ADDRESS            S99528
         L     R8,TTEADDR              GET TTE ADDR              S99528
         USING IEDQTRM,R8                                        S99528
         L     R8,TRMDESTQ-1           GET QCB ADDR              S99528
         DROP  R8                                                S99528
         USING IEDQQCB,R8                                        S99528
         TM    INITSTAT,TOTTDORN       TEST DEVICE ON RN         S22024
         BZ    TDNRN1                  NO BRANCH                 S22024
         LA    R3,D4                   FOURCE RLN TO ONE         S22024
         B     TDNRN2                  BRANCH                    S22024
TDNRN1   EQU   *                                                 S22024
         SR    R3,R3                   CLEAR REG                 S99528
         IC    R3,QCBRELLN             GET RLN                   S99528
         SLL   R3,2                    MULT BY 4                 S99528
TDNRN2   EQU   *                                                 S22024
         L     R8,QCBDCBAD-1           GET DCB ADDR              S99528
         DROP  R8                                                S99528
         USING IHADCB,R8                                         S99528
         TM    DCBDSORG,X80            DCB OR LGB                S22024
         BZ    GETDEB                  BRANCH IF DCB             S22024
         L     R1,TTEADDR              GET TTE ADDRESS         @Y17XAUU
         BAL   R14,NCPTTE              GET NCP TTE ADDRESS     @Y17XAUU
*                                                              @Y17XAUU
*        ON RETURN R1 CONTAINS ADDRESS OF NCP TTE PREFIX       @Y17XAUU
*                                                              @Y17XAUU
         USING IEDNTRM,R1              SET TTE ADDRESSABILITY  @Y17XAUU
         L     R1,TRMDESTQ-D1          GET QCB ADDRESS         @Y17XAUU
         DROP  R1                                              @Y17XAUU
         USING IEDQQCB,R1              SET QCB ADDRESSABILITY  @Y17XAUU
         L     R8,QCBDCBAD-D1          GET 3705 DCB ADDRESS    @Y17XAUU
         DROP  R1                                              @Y17XAUU
GETDEB   EQU   *                       GET DEB ADDRESS           S22024
         L     R8,DCBDEBAD             GET DEB ADDR              S99528
         DROP  R8                                                S99528
         USING DEBNMSUB,R8                                       S99528
         SR    R15,R15                 CLEAR REG                 S99528
         IC    R15,DEBNMEXT            GET # OF EXTENTS          S99528
         SLL   R15,2                   MULT BY 4                 S99528
         L     R8,DEBUCBAD-4(R3)       GET UCB ADDR              S99528
         L     R5,UCB5SAVE             RETURN REG
         L     R3,UCB3SAVE             RESTORE REG               S99528
         B     0(R12)                  BRANCH RETURN             S99528
*                                                                     *
*              ALLINE TNT ADDRESS                                     *
*                                                                     *
TNTALINE EQU   *                       FIND QCB                  S99528
         LR    R9,R8                   SAVE TNT POINTER          S99528
         SR    R10,R10                 CLEAR REG                 S99528
         IC    R10,TOTTTBEL            GET NAME LENGTH           S99528
         AR    R9,R10                  POINT TO TTE ADDRESS      S99528
         MVC   TTEADDR+1(3),0(R9)      ALLINE ADDRESS            S99528
         L     R6,TTEADDR              GET TTE ADDRESS           S99528
         USING IEDQTRM,R6                                        S99528
         L     R6,TRMDESTQ-1           GET QCB ADDRESS           S99528
         DROP  R6                                                S99528
         B     0(R7)                   RETURN                    S99528
         EJECT
************************************************************** @Y17XAUU
*        ROUTINE TO FIND NCP TTE ADDRESS. INPUT: REG 1 =     * @Y17XAUU
*        ENTRY TTE ADDRESS. OUTPUT: REG 1 = NCP TTE PREFIX   * @Y17XAUU
*        ADDRESS. RETURN TO CALLER VIA REG 14.               * @Y17XAUU
************************************************************** @Y17XAUU
NCPTTE   EQU   *                                               @Y17XAUU
         ST    R14,TRMSAVE2            SAVE RETURN ADDRESS     @Y17XAUU
         LA    R8,TRMPRFSZ             GET TTE PREFIX SIZE     @Y17XAUU
         SLR   R1,R8                   POINT TO TTE PREFIX     @Y17XAUU
         USING IEDNTRM,R1              SET TTE ADDRESSABILITY  @Y17XAUU
NCPLOOP  EQU   *                                               @Y17XAUU
         LH    R1,TRMCOHRT             GET COHORT POINTER      @Y17XAUU
         L     R15,TOTAVTPT            GET AVT ADDRESS         @Y17XAUU
         USING IEDQAVTD,R15            SET AVT ADDRESSABILITY  @Y17XAUU
         L     R15,AVTRNMPT            TTCIN TO TTE CONVERSION @Y17XAUU
*                                      ROUTINE ADDRESS         @Y17XAUU
         DROP  R15                                             @Y17XAUU
         BALR  R14,R15                 FIND TTE ADDRESS        @Y17XAUU
         SLR   R1,R8                   POINT TO TTE PREFIX     @Y17XAUU
         CLI   TRMTYPE,TRMLNCP         NCP ENTRY               @Y17XAUU
         BNE   NCPLOOP                 NO - CHECK NEXT ENTRY   @Y17XAUU
         L     R14,TRMSAVE2            RESTORE RETURN ADDRESS  @Y17XAUU
         BR    R14                     RETURN TO CALLER        @Y17XAUU
         DROP  R1                                              @Y17XAUU
         EJECT
         DS    0F                                                S99528
CDSLINE  DC    CL8'G0000000'           CDS NAME                  S99528
DEVADBUF DS    0F
         DC    4CL1'0'                 DEVICE ADDRESS BUFFER     S99528
DEQLIST  DEQ   (QNAME,RNAME,8,STEP),RET=HAVE,MF=L
QNAME    DC    CL8'SYSZTOTE'           MAJOR ELEMENT           @Y17XAUU
RNAME    DC    8CL1' '                 MINOR ELEMENT             S99528
*
*       PARAMETER LIST FOR SVC PURGE                                  *
CBPRGLST DS    0F                                                S99528
CBPRGDEB EQU   CBPRGLST                BEDADDRESS                S99528
CBPURFLG DC    A(0)                    FLAGS                     S99528
         DC    A(0)                    PURGE PARM                S99528
CBPRGIOB DS    0F                      UOB ADDRESS               S99528
CBPDEBNO DC    A(0)                    DEB ADDRESS               S99528
*                                                                S99528
*       PARAMETER LIST FOR SVC 102                                    *
CBSLPL   DS    0F                                                S99528
         DC    X'0C'                   START                     S99528
         DC    AL3(0)                  ADDR OF FIRST             S22024
         DC    X'80'                   FLAG END                  S99528
         DC    AL3(0)                  ADDR OF FIRST             S22024
ADDOFUCB DC    AL3(0)                  UCB ADDRESS               S99528
JFCBAA  DC     CL176'0'                JFCB                      S99528
         DS    0F                      EXIT LIST                 S99528
JFCBADDR DC    X'07'                   KEY FOR JFCB              S99528
         DC    AL3(JFCBAA)             ADDRESS OF THE JFCB       S99528
         DC    X'80'                   END OF LIST               S99528
         DC    AL3(0)                  ZEROS                     S99528
TTEADDR  DC    AL4(0)                  TTE ADDRESS               S99528
NCPTTCIN DC    H'0'                    NCP TTCIN               @OY20578
EXCPDCB  DCB   DDNAME=DD274E,DSORG=PS,EXLST=JFCBADDR,MACRF=(E),        C
               SIOA=AO,CENDA=AP,XENDA=AP   GRAPHIC APPENDAGES    S99528
EXCP     OPEN  (EXCPDCB,),MF=L                                   S99528
EXCPP    CLOSE EXCPDCB,MF=L                                      S99528
***
***      MESSAGES
***
UNIT     DC    CL8'        '           NNIT NAME                 S99528
UCB5SAVE DC    A(0)                    REG 5 SAVE                S99528
UCB3SAVE DC    A(0)                    REG 3 SEVE                S99528
         DS    0F                      ALLINE                    S22024
INVTIC   DC    X'08000002'             INVALID TIC             @YM08158
TRMSAVE2 DS    F                       REG SAVE AREA           @Y17XAUU
ONEE     DC    H'1'                    ONE                       S22024
OFFSET   DC    H'0'                    OFFSET OF TNT             S22024
TNTNAME2 DC    CL8'        '            TNTNAME SAVE AREA      @OY20578
DEQSAVE  DS    3F                      SAVE REGS K 6 7           S22024
NAMEMOVE MVC   UNIT(ZERO),ZERO(R1) MOVE NAME
CTNAME   MVC   RNAME,0(R1)             NAME TO DEQ               S99528
TERMIATE DC    CL26'            UNIT          '  START TERM MSG  S99528
NOCORE   DC    CL37'NOT ENOUGH CORE FOR SECTION          ' MSG   S99528
NOTLOAD  DC    CL32'OLT MODULE          NOT LOADABLE'    MSG     S99528
ASTRICK  EQU   X'5C'                   ASTERICK                  S99528
TEE      EQU   X'E3'                   T                         S99528
S        EQU   X'E2'                   S                         S99528
INITSTAT DC    X'00'                   INITAL STATUS BYTE        S99528
APSTIME  DC    X'00'                   AP STIMER FLAG            S99528
APSTIMER EQU   X'80'                   STIMER FOR AP             S99528
ALPHTABL DC    CL26'ABCDEFGHIJKLMNOPQRSTUVWXYZ'     TABLE        S99528
ENDALTAB DC    X'EA'                   PAST ALPHBET              S99528
         DS    0D                      DOUBLE WORD ALLINE        S99528
SECS00   DC    X'F0F0F0F0F1F1F1C1'     WAIT TIME                 S99528
X3705    DC    AL1(0)                  CONTROL UNIT TYPE SAVE    S22024
TRMSAVE  DC    H'0'                    RSID SAVE AREA            S05331
*                                                                S22024
*        PARZMETER LIST FOR SVC 102 DATA MOVE                    S22024
*                                                                S22024
         DS    0F                      ALLINE                    S22024
TOT102   DC    X'08'                   FLAG FOR DATA MOVE        S22024
         DC    AL3(UCBWORK)            DATA ADDRESS              S22024
TOT102A  DC    X'00'                   ZERO                      S22024
         DC    AL3(0)                  TARGET ADDRESS            S22024
         DC    X'80'                   LAST WORD FLAG            S22024
         DC    AL3(LENGADDR)           LENGTH ADDRESS            S22024
UCBWORK  DC    AL4(0)                  WORKAREA                  S22024
LENGADDR DC    H'04'                   LENGTH OF DATA            S22024
QNAMEE   DC    CL8'CDSLIB  '           MAJOR NAME                S22024
RNAMEE   DC    CL8'OLT2LIB '           MINOR NAME                S22024
RNFLAG   DC    X'00'                   FLAG BYTE FOR 3705        S05331
CTFLAG   EQU   X'80'                   CT ON 3705                S05331
APFLAG   EQU   X'40'                   AP ON 3705                S05331
CTLTTE   DS    F                       ADDR OF TTE FOR CT LINE   S05331
APLTTE   DS    F                       ADDR OF TTE FOR AP LINE   S05331
LUFLAGS  DC    X'00'                  LU FLAGS                 @XM05672
APLUNT   EQU   X'80'                  ALT. PRINTER IS LU       @XM05672
CTLUNT   EQU   X'40'                  CONTROL TERM IS LU       @XM05672
PATCH    DC    CL100' '                PATCH AREA                S22024
WEEND    EQU   *
         EJECT
         TLCBD
         EJECT
UCB      DSECT
         IEFUCBOB
         EJECT
         EJECT
RESPL    RESPL EQUATES=YES
         EJECT
         OLTCB                         OLTCB                     S22024
TCNTBLDL EQU   TOTWKSPC
TCNTBECT EQU   TCNTBLDL+1
TCNTBELN EQU   TCNTBLDL+3
TCNTMDNM EQU   TCNTBLDL+4
TCNTMDSZ EQU   TCNTBLDL+28
         EJECT
         TDEBD
         EJECT
PLNKPREF DSECT
PLNKNAME DS    CL8                     OLT NAME                  S99528
         ORG   PLNKPREF+10             TO POINTER                S99528
PLNKMPTR DS    CL2                     POINTER                   S99528
         SPACE 5
PLNKQPTR DSECT
PLNKQFWD DS    F                       FORWARD POINTER           S99528
PLNKQBKD DS    F                       BACK POINTER              S99528
         EJECT
DCBDSECT DCBD  DSORG=TX                                          S99528
          TQCBD                                                  S99528
         EJECT
CVT      DSECT                                                   S99528
         CVT                                                     S99528
TIOT     DSECT                                                   S99528
         IEFTIOT1                                                S99528
         EJECT
         TTRMD
         TPRFD                         BUFFER PREFIX             S22024
         EJECT
         TLGBD                         LGB                       S22024
         TTNTD                         TTE                       S22024
         TAVTD
         EJECT
         TREQD
         SPACE 4
         END
