         TITLE 'MESSAGE MODULE 2 - IEDQWL'
IEDQWL   CSECT
* CHANGE ACTIVTY AS FOLLOWS:                                     S22024
*C334000-352000                                                 SA41593
*A000250,002500-003200                                           S22024
*C370000-838000                                                  S22024
*C690000,698000                                                  S05331
*C664000                                                         Y06330
         SPACE 2
****************************************************************
*                                                              *
* TITLE = MESSAGE MODULE 2                                     * S22024
*                                                              * S22024
* MODULE NAME = IEDQWL                                         * S22024
*                                                              * S22024
* DESCRIPTIVE NAME = MESSAGE MODULE 2                          * S22024
*                                                              * S22024
* COPYRIGHT = NONE                                             * S22024
*                                                              * S22024
* STATUS --                                                    *
*    CHANGE LEVEL 5                                            * S05331
*                                                              *
* FUNCTIONS --                                                 *
*    THE PURPOSE OF THIS MODULE IS TO MOVE THE REQUESTED       *
*    OUTPUT MESSAGE TO THE OUTPUT BUFFER IN THE OLTCB. THE     *
*    KEY TO THE CORRECT MESSAGE TO MOVE IS THE ID IN THE       *
*    MESSAGE PARAMETER LIST. MESSAGES 0 THRU 49 ARE HANDLED.   *
*                                                              *
*    UPON EXIT, THE OUTPUT MESSAGE AND MESSAGE LENGTH ARE      *
*    PLACED IN THE OLTCB.                                      *
*                                                              *
* ENTRY POINTS --                                              *
*    IEDQWL - CALLED BY TOTE MESSAGE MODULE IEDQWK.            *
*                                                              *
* INPUT --                                                     *
*    REGISTERS 01, 02, 13, 14, 15 CONTAIN THE FOLLOWING VALUES *
*                                                              *
*    01 - MESSAGE PARAMETER ADDRESS                            *
*    02 - OLTCB BASE POINTER                                   *
*    13 - CALLER'S SAVE AREA ADDRESS                           *
*    14 - CALLER'S RETURN ADDRESS                              *
*    15 - IEDQWL ENTRY POINT ADDRESS                           *
*                                                              *
* OUTPUT --                                                    *
*    THE REQUESTED OUTPUT MESSAGE AND COUNT ARE PLACED IN      *
*    THE OLTCB                                                 *
*                                                              *
* EXTERNAL REFERENCES --                                       *
*    NONE                                                      *
*                                                              *
* EXITS,NORMAL --                                              *
*    RETURN TO IEDQWK                                          *
*                                                              *
* EXITS,ERROR                                                  *
*    NONE                                                      *
*                                                              *
* TABLES/WORK AREAS --                                         *
*    OLTCB, MESSAGE PARAMETER LIST                             *
*                                                              *
* ATTRIBUTES --                                                *
*    ENABLED, PROBLEM PROGRAM MODE, TRANSIENT                  *
*                                                              *
* NOTES --                                                     *
*    NONE                                                      *
*                                                              *
****************************************************************
         EJECT
*                                                              *
*        E Q U A T E S                                         *
*                                                              *
R0       EQU   0                  REG 0
R1       EQU   1                  REG 1
R2       EQU   2                  REG 2
R3       EQU   3                  REG 3
R4       EQU   4                  REG 4
R5       EQU   5                  REG 5
R6       EQU   6                  REG 6
R7       EQU   7                  REG 7
R8       EQU   8                  REG 8
R9       EQU   9                  REG 9
R10      EQU   10                 REG 10
R11      EQU   11                 REG 11
R12      EQU   12                 REG 12
R13      EQU   13                 REG 13
R14      EQU   14                 REG 14
R15      EQU   15                 REG 15
         SPACE 2
D0       EQU   0                  DISP OF 0
D1       EQU   1                  DISP OF 1
D2       EQU   2                  DISP OF 2
D3       EQU   3                  DISP OF 3
D4       EQU   4                  DISP OF 4
D5       EQU   5                  DISP OF 5
D6       EQU   6                  DISP OF 6
D7       EQU   7                  DISP OF 7
D8       EQU   8                  DISP OF 8
D9       EQU   9                  DISP OF 9
D10      EQU   10                 DISP OF 10
D11      EQU   11                 DISP OF 11
D12      EQU   12                 DISP OF 12
D13      EQU   13                 DISP OF 13
D14      EQU   14                 DISP OF 14
D15      EQU   15                 DISP OF 15
D16      EQU   16                 DISP OF 16
D17      EQU   17                 DISP OF 17
D18      EQU   18                 DISP OF 18
D19      EQU   19                 DISP OF 19
D20      EQU   20                 DISP OF 20
D24      EQU   24                 DISP OF 24
D28      EQU   28                 DISP OF 28
D32      EQU   32                 DISP OF 32
D36      EQU   36                 DISP OF 36
D40      EQU   40                 DISP OF 40
D50      EQU   50                 DISP OF 50
D60      EQU   60                 DISP OF 60
D70      EQU   70                 DISP OF 70
D80      EQU   80                 DISP OF 80
         SPACE 2
         EJECT
         USING IEDQWL,R15
IEDQWL   IEDHJN STARL,HJN
         SPACE
         DROP  R15
         SAVE  (14,12)            SAVE CALLER'S REG
         SPACE
         USING IEDQWL,R4
         USING TOTOLTCB,R2
         LR    R4,R15             SET BASE REG
         LA    R15,TOTSAVE2       GET MY SAVE AREA ADDR
         ST    R13,D4(R15)        SAVE CALLER'S SAVE AREA ADDR
         ST    R15,D8(R13)        SAVE MY SAVE AREA ADDR
         LR    R13,R15            POINT TO MY SAVE AREA
         LR    R10,R1             SET BASE FOR MSG PLIST
         USING PLIST,R10
         SPACE
*
*
         SR    R5,R5              CLEAR
         SR    R6,R6              REGISTERS
STMSG98  EQU   *
         LH    R5,MSGID           GET MESSAGE ID
         SLL   R5,D2              MULTIPLY BY 4 FOR TABLE DISP
         L     R7,MSGTABLE(R5)    GET MESSAGE PARAMETERS
         SLDL  R6,D8              MOVE BYTE COUNT
         SRL   R7,D8              RESTORE MESSAGE ADDRESS
STMSG99  EQU   *
         STC   R6,TOTOTCNT        PUT BYTE COUNT INTO OLTCB
         BCTR  R6,R0              DECREMENT COUNT FOR EX
         EX    R6,MSGMOVE         MOVE MESSAGE TO OLTCB
         SPACE
*
*        PROCESS MESSAGE AS REQUIRED
*
STMSGR1  EQU   *
         L     R13,D4(R13)        CALLER'S SAVE ADDR
         LM    R14,R1,D12(R13)    RESTORE REG 14-1              SA41593
         XCTL  (2,12),EP=IEDQWK1  RETURN TO IEDQWK              SA41593
         EJECT
*
*        CONSTANT AND TABLES
*
MSGMOVE  MVC   TOTOTBUF(D0),D0(R7) MOVE MESSAGE TO OLTCB
         SPACE
OUTMSG   DS    F                  WORK AREA
         SPACE 2
*                                                              *
*        THE FOLLOWING CODE IS USED AS A BRANCH TABLE          *
*        FOR OBTAINING THE CORRECT MESSAGE TO MOVE TO          *
*        THE OLTCB. EACH ENTRY IN THE TABLE IS 4 BYTES         *
*        LONG. BYTE 0 CONTAINS THE MESSAGE LENGTH. BYTES       *
*        1-3 CONTAIN THE ADDRESS OF THE MESSAGE. NO COMMENTS   *
*        ARE DEEMED NECESSARY FOR EACH ENTRY.                  *
*                                                              *
         SPACE
         SPACE
         EJECT
MSGTABLE DS    0F
         DC    AL1(MSG0E-MSG0)
         DC    AL3(MSG0)
         DC    AL1(MSG1E-MSG1)
         DC    AL3(MSG1)
         DC    AL1(MSG2E-MSG2)
         DC    AL3(MSG2)
         DC    AL1(MSG3E-MSG3)
         DC    AL3(MSG3)
         DC    AL1(MSG4E-MSG4)
         DC    AL3(MSG4)
         DC    AL1(MSG4E-MSG4)
         DC    AL3(MSG4)
         DC    AL1(MSG4E-MSG4)
         DC    AL3(MSG4)
         DC    AL1(MSG7E-MSG7)
         DC    AL3(MSG7)
         DC    AL1(MSG8E-MSG8)
         DC    AL3(MSG8)
         DC    AL1(MSG9E-MSG9)
         DC    AL3(MSG9)
         DC    AL1(MSGAE-MSGA)
         DC    AL3(MSGA)
         DC    AL1(MSGBE-MSGB)
         DC    AL3(MSGB)
         DC    AL1(MSGCE-MSGC)
         DC    AL3(MSGC)
         DC    AL1(MSGDE-MSGD)
         DC    AL3(MSGD)
         DC    AL1(MSGEE-MSGE)
         DC    AL3(MSGE)
         DC    AL1(MSGFE-MSGF)
         DC    AL3(MSGF)
         DC    AL1(MSG10E-MSG10)
         DC    AL3(MSG10)
         DC    AL1(MSG11E-MSG11)
         DC    AL3(MSG11)
         DC    AL1(MSG12E-MSG12)
         DC    AL3(MSG12)
         DC    AL1(MSG13E-MSG13)
         DC    AL3(MSG13)
         DC    AL1(MSG14E-MSG14)
         DC    AL3(MSG14)
         DC    AL1(MSG15E-MSG15)
         DC    AL3(MSG15)
         DC    AL1(MSG9E-MSG9)
         DC    AL3(MSG9)
         DC    AL1(MSG9E-MSG9)
         DC    AL3(MSG9)
         DC    AL1(MSG9E-MSG9)
         DC    AL3(MSG9)
         DC    AL1(MSG9E-MSG9)
         DC    AL3(MSG9)
         SPACE
         DC    48XL1'0'           SPARE
         DC    AL1(MSG38E-MSG38)
         DC    AL3(MSG38)
         SPACE
         DC    AL1(MSG39E-MSG39)
         DC    AL3(MSG39)
         DC    AL1(MSG40E-MSG40)
         DC    AL3(MSG40)
         DC    AL1(MSG41E-MSG41)
         DC    AL3(MSG41)
         DC    AL1(MSG42E-MSG42)
         DC    AL3(MSG42)
         DC    AL1(MSG43E-MSG43)
         DC    AL3(MSG43)
         DC    AL1(MSG44E-MSG44)
         DC    AL3(MSG44)
         SPACE
         SPACE
         DC    AL1(MSG45E-MSG45)
         DC    AL3(MSG45)
         DC    AL1(MSG46E-MSG46)
         DC    AL3(MSG46)
         DC    AL1(MSG47E-MSG47)
         DC    AL3(MSG47)
         DC    AL1(MSG48E-MSG48)
         DC    AL3(MSG48)
         DC    AL1(MSG49E-MSG49)
         DC    AL3(MSG49)
         SPACE
         EJECT
*                                                              *
*        THE FOLLOWING TABLE CONSISTS OF A PORTION OF          *
*        TOTE'S MESSAGES. EACH MESSAGE IS SELF-EXPLANATORY.    *
*                                                              *
MSG0     DS    0C
         DC    C'IED220I '
         DC    C'ERROR - MORE THAN 10 TEST DEVICES ENTERED'      S22024
MSG0E    DS    0C
MSG1     DS    0C
         DC    C'IED227I '
         DC    C'CHAN ADDR(S) SPECIFIED IN TRM ARE MIXED 2701,2,3 WITH *
               3705  '
MSG1E    DS    0C
MSG2     DS    0C
         DC    C'IED211I '
         DC    C'ON-LINE TESTING ACTIVE'
MSG2E    DS    0C
MSG3     DS    0C
         DC    C'IED342I '
         DC    C'OPEN FOR TEST DEVICE(S) FAILED - TRM REJECTED'
MSG3E    DS    0C
MSG4     DS    0C
         DC    C'IED343I '
         DC    C'ALTERNATE PRINTER LINE NOT OPENED'
MSG4E    DS    0C
MSG7     DS    0C
         DC    C'IED212I '
         DC    C'CLASS NOT TP OR SUPPORTED GRAPHIC - ABORT'
MSG7E    DS    0C
MSG8     DS    0C
         DC    C'IED218I '
         DC    C'NCM NOT ALLOWED ON 3705 TEST DEVICES, CM IS SET'
MSG8E    DS    0C
MSG9     DS    0C
         DC    C'IED304D '                                       S22024
         DC    C'IS THIS CONFIG AN EXTENSION(E) TO 3705, AN NCPCDS(C), *
               OR NEITHER(N)'                                    S22024
MSG9E    DS    0C
MSGA     DS    0C
         DC    C'IED217I '
         DC    C'3705 NOT ACTIVE'
MSGAE    DS    0C
MSGB     DS    0C
         DC    C'IED216I '
         DC    C'TRM CANCELLED - TOTE CANNOT USE TSO DEVICE'
MSGBE    DS    0C
MSGC     DS    0C
         DC    C'IED222I '
         DC    C'SWITCH DEVICE TO PRIMARY - REENTER TRM'
MSGCE    DS    0C
MSGD     DS    0C
         DC    C'IED257I '
         DC    C'TRM CANCELLED - MAX OLTT DATA TRANSFER MAY EXCEED 370/*
               3705 MAXIMUM'                                     S22024
MSGDE    DS    0C
MSGE     DS    0C
         DC    C'IED272I '                                       Y06330
         DC    C'TRM REJECTED - TEST IN BACK-UP MODE NOT YET SUPPORTED'
MSGEE    DS    0C
MSGF     DS    0C
         DC    C' '               NO MESSAGE
MSGFE    DS    0C
MSG10    DS    0C
         DC    C'IED219I '
         DC    C'ON-LINE TESTING ENDED'
MSG10E   DS    0C
MSG11    DS    0C
         DC    C' '                UNUSED MESSAGE
MSG11E   DS    0C
MSG12    DS    0C
         DC    C' '                UNUSED MESSAGE                S05331
MSG12E   DS    0C
MSG13    DS    0C
         DC    C' '                UNUSED MESSAGE                S05331
MSG13E   DS    0C
MSG14    DS    0C
         DC    C'IED223I '
         DC    C'ON-LINE TESTING CANCELLED'
MSG14E   DS    0C
MSG15    DS    0C
         DC    C' '                UNUSED MESSAGE
MSG15E   DS    0C
MSG38    DS    0C
         DC    C'IED225I '
         DC    C'INVALID TEST DEVICE ENTRY - TEST LINE NOT OPENED'
MSG38E   DS    0C
         SPACE
         SPACE
MSG39    DS    0C
         DC    C'IED226I '
         DC    C'TRM REJECTED - TCU NOT CONNECTED TO PROPER CPU'
MSG39E   DS    0C
MSG40    DS    0C
         DC    C' '                UNUSED MESSAGE
MSG40E   DS    0C
MSG41    DS    0C
         DC    C'IED228I '
         DC    C'TRM REJECTED - I/O ERROR LOADING CONFIGURATION DATA'
MSG41E   DS    0C
MSG42    DS    0C
         DC    C'IED229I '
         DC    C'TRM REJECTED - NO CONFIGURATION DATA'
MSG42E   DS    0C
MSG43    DS    0C
         DC    C'IED230I '
         DC    C'TRM REJECTED - CONFIGURATION DATA SET CANNOT BE OPENED*
               '
MSG43E   DS    0C
MSG44    DS    0C
         DC    C'IED231I '
         DC    C'REENTER TRM LATER - RESOURCE IN UNSHAREABLE STATE'
MSG44E   DS    0C
MSG45    DS    0C
         DC    C'IED297I '
         DC    C'TEST DEVICE DOES NOT BELONG TO TCAM'
MSG45E   DS    0C
MSG46    DS    0C
         DC    C'IED232I '
         DC    C'INVALID ALTERNATE PRINTER ENTRY'
MSG46E   DS    0C
MSG47    DS    0C
         DC    C'IED233D '
         DC    C'INVALID EP LEVEL - ENTER 0,1,2,OR 3'
MSG47E   DS    0C
         SPACE
MSG48    DS    0C
         DC    C'IED234D '
         DC    C'ENTER DIFFERENT TERMINAL, SYSOUT,SYSCON OR NAP'
MSG48E   DS    0C
MSG49    DS    0C
         DC    C' '                UNUSED MESSAGE
MSG49E   DS    0C
         SPACE
         SPACE 2
PLIST    DSECT
MSGID    DS    CL2                MESSAGE ID
MSGFLG   DS    CL1                MESSAGE FLAG
MSGCT    DS    CL1                MESSAGE IN COUNT
MSGCT1   DS    CL1                MESSAGE OUT COUNT
MSGADR   DS    CL3                MESSAGE ADDRESS
         EJECT
         OLTCB
         END
