QWL1     TITLE 'IEDQWL1 - MESSAGE SUB MODULE 2'
IEDQWL1  CSECT
*A000000-999999                                                @Y16X5U0
* CHANGE ACTIVITY AS FOLLOWS:                                    S22024
*C288000-291000                                                 SA41593
*A006500,013100-013800                                           S22024
*C297000-951000                                                  S22024
*A582000,885000,894000,912000                                  @Y17XAUU
         SPACE 4
****************************************************************
*                                                              *
* MODULE NAME = IEDQWL1 (TCAM,TOTE)                            @Y17XAUU
*                                                              * S22024
* DESCRIPTIVE NAME = MESSAGE MODULE 3                          * S22024
*                                                              * S22024
* COPYRIGHT = NONE                                             * S22024
*                                                              * S22024
* STATUS --                                                    *
*        VERSION 10.0                                          @Y17XAUU
*                                                              *
* FUNCTIONS --                                                 *
*    THE PURPOSE OF THIS MODULE IS TO MOVE THE REQUESTED       *
*    OUTPUT MESSAGE TO THE OUTPUT BUFFER IN THE OLTCB.         *
*    THE KEY TO THE CORRECT MESSAGE TO MOVE IS THE ID IN       *
*    THE MESSAGE PARAMETER LIST. THIS MODULE ONLY HAS ID'S     *
*    50 THROUGH 79.                                            *
*                                                              *
*    UPON EXIT, THE OUTPUT MESSAGE AND LENGTH ARE PLACED       *
*    IN THE OLTCB.                                             *
*                                                              @Y17XAUU
* PURPOSE -- SEE FUNCTION                                      @Y17XAUU
*                                                              @Y17XAUU
* MODULE SIZE -- 2K MAXIMUM                                    @Y17XAUU
*                                                              @Y17XAUU
* MODULE TYPE -- PROCEDURE                                     @Y17XAUU
*                                                              @Y17XAUU
* PROCESSOR -- ASSEMBLER XF                                    @Y17XAUU
*                                                              @Y17XAUU
* LINKAGE -- XCTL'ED FROM IEDQWK                               @Y17XAUU
*                                                              @Y17XAUU
* MACROS - IEDHJN,SAVE,XCTL                                    @Y17XAUU
*                                                              *
* ENTRY POINTS --                                              *
*    IEDQWL1                                                   @Y17XAUU
*                                                              *
* INPUT --                                                     *
*    REGISTERS 01, 02, 13, 14, 15 CONTAIN THE FOLLOWING VALUES *
*                                                              *
*    01 - MESSAGE PARAMETER LIST ADDRESS                       *
*    02 - OLTCB BASE POINTER                                   *
*    13 - CALLER'S SAVE AREA ADDRESS                           *
*    14 - CALLER'S RETURN ADDRESS                              *
*    15 - IEDQWL1 ENTRY POINT ADDRESS                          *
*                                                              *
* OUTPUT --                                                    *
*    THE REQUESTED OUTPUT MESSAGE AND COUNT ARE PLACED IN      *
*    THE OLTCB.                                                *
*                                                              *
* EXTERNAL REFERENCES --                                       *
*    NONE                                                      *
*                                                              *
* EXITS,NORMAL --                                              *
*    RETURN TO IEDQWK                                          *
*                                                              *
* EXITS,ERROR --                                               *
*    NONE                                                      *
*                                                              *
* TABLES/WORK AREAS --                                         *
*    OLTCB,MESSAGE PARAMETER LIST                              *
*                                                              *
* ATTRIBUTES --                                                *
*    ENABLED, PROBLEM PROGRAM MODE                             *
*                                                              *
* NOTE -- SEE BELOW                                            @Y17XAUU
*                                                              *
*  DEPENDENCIES - EBCDIC CODE CHARACTER SET.                   @Y17XAUU
*                                                              @Y17XAUU
*  RESTRICTIONS -- NONE                                        @Y17XAUU
*                                                              @Y17XAUU
*  REGISTER CONVENTIONS -- SEE REGISTER ASSIGNMENT             @Y17XAUU
*                                                              @Y17XAUU
*  PATCH LABEL -- PATCH                                        @Y17XAUU
*                                                              *
****************************************************************
         EJECT
*
*        EQUATES
*
R0       EQU   0                  REG 0
R1       EQU   1                  REG 1
R2       EQU   2                  REG 2
R3       EQU   3                  REG 3
R4       EQU   4                  REG 4
R5       EQU   5                  REG 5
R6       EQU   6                  REG 6
R7       EQU   7                  REG 7
R8       EQU   8                  REG 8
R9       EQU   9                  REG 9
R10      EQU   10                 REG 10
R11      EQU   11                 REG 11
R12      EQU   12                 REG 12
R13      EQU   13                 REG 13
R14      EQU   14                 REG 14
R15      EQU   15                 REG 15
D0       EQU   0                  DISP OF 0
D1       EQU   1                  DISP OF 1
D2       EQU   2                  DISP OF 2
D3       EQU   3                  DISP OF 3
D4       EQU   4                  DISP OF 4
D8       EQU   8                  DISP OF 8
D12      EQU   12                 DISP OF 12
D16      EQU   16                 DISP OF 16
D20      EQU   20                 DISP OF 20
         SPACE
KADJUST  EQU   50                 MSG ID ADJUSTOR
KSHFTRT  EQU   8                  SHIFT 8 BIT
         EJECT
         USING IEDQWL1,R15
IEDQWL1  IEDHJN STARL1,HJN
         DROP  R15
         SPACE
         SAVE  (14,12)            SAVE CALLER'S REGISTERS
         USING IEDQWL1,R4
         USING TOTOLTCB,R2
         USING PLIST,R10
         LR    R4,R15             SET BASE REG FOR THIS MODULE
         LR    R10,R1             SET BASE REG FOR MSG P-LIST
         SPACE 2
         LA    R15,TOTSAVE2       GET MY SAVE AREA ADDR
         ST    R13,D4(R15)        SAVE CALLER'S SAVE AREA ADDR
         ST    R15,D8(R13)        SAVE MY SAVE AREA ADDR
         LR    R13,R15            SET REG 13 TO MY SAVE AREA
         SPACE 2
         SR    R5,R5              CLEAR REG 5
         SR    R6,R6              CLEAR REG 6
         LH    R5,MSGID           GET MSG ID
         LA    R8,KADJUST         GET ADJUSTOR
         SR    R5,R8              ADJUST FOR ENTRY IN BRANCH TABLE
         SLL   R5,2               MULTIPLY BY FOUR
         SPACE
         L     R7,MSGTABLE(R5)    GET MSG PARAMETERS
         SLDL  R6,KSHFTRT         MOVE BYTE COUNT INTO REG 6
         SRL   R7,KSHFTRT         ISOLATE MESSAGE ADDRESS
         SPACE
         STC   R6,TOTOTCNT        PUT BYTE COUNT INTO OLTCB
         BCTR  R6,D0              DECREMENT COUNT FOR EXECUTE
         EX    R6,MSGMOVE         MOVE MESSAGE TO OLTCB
         SPACE 2
*
LIMSG0   EQU   *    RETURN TO IEDQWK
*
         L     R13,D4(R13)        RESTORE CALLER'S SAVE AREA ADDR
         LM    R14,R1,D12(R13)    RESTORE REG 14-1              SA41593
         XCTL  (2,12),EP=IEDQWK1  RETURN TO IEDQWK              SA41593
         EJECT
*
*        C O N S T A N T S
*
MSGMOVE  MVC   TOTOTBUF(D0),D0(R7)  MOVE MSG TO OUTPUT BUFFER
         SPACE 4
*
MSGTABLE DS    0F        MSG ENTRIES PARAMETER TABLE
*
         SPACE
*                                                              *
*        THE FOLLOWING CODE IS USED AS A BRANCH TABLE          *
*        FOR OBTAINING THE CORRECT MESSAGE TO MOVE TO          *
*        THE OLTCB. EACH ENTRY IN THE TABLE IS 4 BYTES         *
*        LONG. BYTE 0 CONTAINS THE MESSAGE LENGTH. BYTES       *
*        1-3 CONTAIN THE ADDRESS OF THE MESSAGE. NO COMMENTS   *
*        ARE DEEMED NECESSARY FOR EACH ENTRY.                  *
*                                                              *
         DC    AL1(MSG50E-MSG50)
         DC    AL3(MSG50)
         DC    AL1(MSG51E-MSG51)
         DC    AL3(MSG51)
         DC    AL1(MSG52E-MSG52)
         DC    AL3(MSG52)
         DC    AL1(MSG53E-MSG53)
         DC    AL3(MSG53)
         DC    AL1(MSG54E-MSG54)
         DC    AL3(MSG54)
         DC    AL1(MSG55E-MSG55)
         DC    AL3(MSG55)
         DC    AL1(MSG56E-MSG56)
         DC    AL3(MSG56)
         DC    AL1(MSG57E-MSG57)
         DC    AL3(MSG57)
         DC    AL1(MSG58E-MSG58)
         DC    AL3(MSG58)
         DC    AL1(MSG59E-MSG59)
         DC    AL3(MSG59)
         DC    AL1(MSG60E-MSG60)
         DC    AL3(MSG60)
         DC    AL1(MSG61E-MSG61)
         DC    AL3(MSG61)
         DC    AL1(MSG62E-MSG62)
         DC    AL3(MSG62)
         DC    AL1(MSG63E-MSG63)
         DC    AL3(MSG63)
         DC    AL1(MSG64E-MSG64)
         DC    AL3(MSG64)
         DC    AL1(MSG65E-MSG65)
         DC    AL3(MSG65)
         DC    AL1(MSG66E-MSG66)
         DC    AL3(MSG66)
         DC    AL1(MSG67E-MSG67)
         DC    AL3(MSG67)
         DC    AL1(MSG68E-MSG68)
         DC    AL3(MSG68)
         DC    AL1(MSG69E-MSG69)
         DC    AL3(MSG69)
         DC    AL1(MSG70E-MSG70)
         DC    AL3(MSG70)
         DC    AL1(MSG71E-MSG71)
         DC    AL3(MSG71)
         DC    AL1(MSG72E-MSG72)
         DC    AL3(MSG72)
         DC    AL1(MSG73E-MSG73)
         DC    AL3(MSG73)
         DC    AL1(MSG74E-MSG74)
         DC    AL3(MSG74)
         DC    AL1(MSG75E-MSG75)
         DC    AL3(MSG75)
         DC    AL1(MSG76E-MSG76)
         DC    AL3(MSG76)
         DC    AL1(MSG77E-MSG77)
         DC    AL3(MSG77)
         DC    AL1(MSG78E-MSG78)
         DC    AL3(MSG78)
         DC    AL1(MSG79E-MSG79)
         DC    AL3(MSG79)
         EJECT
*
*        THE FOLLOWING TABLE CONSISTS OF A PORTION OF
*        TOTE'S MESSAGES. EACH MESSAGE IS SELF-EXPLANATORY.
*
MSG50    DS    0C
         DC    C'IED236I '
         DC    C'DIAGMSG OPEN FAILED'
MSG50E   DS    0C
MSG51    DS    0C
         DC    C'IED237I '
         DC    C'OPERATOR WILL ONLY ALLOW CONCURRENT MODE - TRM REJECTE*
               D'
MSG51E   DS    0C
MSG52    DS    0C
         DC    C'IED238I '
         DC    C'DD CARD MISSING FOR LINE ENTRY IN TEST DEVICE FIELD'
MSG52E   DS    0C
MSG53    DS    0C
         DC    C'IED133I '                                     @Y17XAUU
         DC    C'C.T. REQUESTED BY OLT ASSIGNED TO ANOTHER OLT'
*                                                              @Y17XAUU
MSG53E   DS    0C
MSG54    DS    0C
         DC    C'IED128I '
         DC    C'ALTERNATE PRINTER REQUESTED BY OLT ALREADY IN USE'
MSG54E   DS    0C
MSG55    DS    0C
         DC    C'IED241D '
         DC    C'SYSOUT - SYSCON - SYMBOLIC TERMINAL NAME'
MSG55E   DS    0C
MSG56    DS    0C
         DC    C'IED241I '
         DC    C'ENTER ALTERNATE PRINTER LOCATION. VALID ENTRIES ARE'
MSG56E   DS    0C
MSG57    DS    0C
         DC    C'IED242D '
         DC    C'DO YOU WANT TO CONTINUE PROMPTING?  YES OR NO'
MSG57E   DS    0C
MSG58    DS    0C
         DC    C'IED243I '
         DC    C'MAKE ENTRY FROM APPROPRIATE PARENTHESES'
MSG58E   DS    0C
MSG59    DS    0C
         DC    C'IED243D '
         DC    C'YOU CAN REENTER(R), CANCEL(C) OR USE TRM AS IS(GO)'
MSG59E   DS    0C
MSG60    DS    0C
         DC    C'IED243I '
         DC    C'TRM BUFFER TOO SMALL FOR LAST ENTRY'
MSG60E   DS    0C
MSG61    DS    0C
         DC    C'IED245I '
         DC    C'ERROR IN TEST LOOP OR ERROR LOOP NUMBER'
MSG61E   DS    0C
MSG62    DS    0C
         DC    C'IED246I '
         DC    C'OPTION ENTRY INVALID'
MSG62E   DS    0C
MSG63    DS    0C
         DC    C'IED247D '
         DC    C'ENTER ONE OPTION OR NONE'
MSG63E   DS    0C
MSG64    DS    0C
         DC    C'IED247I '
         DC    C'EPN - WHERE N IS LEVEL OF PRINTED OUTPUT WANTED'
MSG64E   DS    0C
MSG65    DS    0C
         DC    C'IED247I '
         DC    C'CM,NCM,NEP,AP,NAP,TR,EXT=DATA/ - NNNN IS A 4 DIGIT DEC*
               IMAL NUMBER'
MSG65E   DS    0C
MSG66    DS    0C
         DC    C'IED247I '
         DC    C'VALID OPTIONS ARE TLNNNN,NTL,ELNNNN,NEL,CP,NCP,NMI,MI,*
               NP,TPP,TAP,BK,NBK'
MSG66E   DS    0C
MSG67    DS    0C
         DC    C'IED247I '
         DC    C'DEFAULT OPTIONS ARE CP,NTL,NEL,CM,NAP,NMI,EP,BK, AND T*
               PP'
MSG67E   DS    0C
MSG68    DS    0C
         DC    C'IED248I '
         DC    C'INVALID ENTRY FOR ADDITIONAL TESTS - VALID ENTRIES ARE*
                A-ZZZ'
MSG68E   DS    0C
MSG69    DS    0C
         DC    C'IED249I '
         DC    C'INVALID ROUTINE ENTRY'
MSG69E   DS    0C
MSG70    DS    0C
         DC    C'IED250I '
         DC    C'INVALID TEST NAME'
MSG70E   DS    0C
MSG71    DS    0C
         DC    C'IED251D '
         DC    C'ENTER ALPHA CHARACTERS SEPARATED BY COMMAS FOR OTHER S*
               ELECTIONS'
MSG71E   DS    0C
MSG72    DS    0C
         DC    C'IED252D '
         DC    C'DO YOU WANT OTHER SECTIONS RUN ON THIS DEVICE?  ANSWER*
                YES OR NO'
MSG72E   DS    0C
MSG73    DS    0C
         DC    C'IED253D '
         DC    C'ENTER ROUTINE NUMBER(S) - EXAMPLE 1,4-6,9'
MSG73E   DS    0C
MSG74    DS    0C
         DC    C'IED254D '
         DC    C'DO YOU WANT TO SELECT ROUTINES IN THIS TEST?  ANSWER Y*
               ES OR NO'
MSG74E   DS    0C
MSG75    DS    0C
         DC    C'IED255D '
         DC    C'ENTER TEST TO BE RUN - FORMAT NNNNB/ANNNNB - EXAMPLE 2*
               700A/T2700A'
MSG75E   DS    0C
MSG76    DS    0C
         DC    C'IED256D '
         DC    C'DO YOU WANT TO BE PROMPTED?  ANSWER YES OR NO'
MSG76E   DS    0C
MSG77    DS    0C
         DC    C'IED127I '                                     @Y17XAUU
         DC    C'OLT REQUEST REJECTED, CONTROL TERMINAL UNIDENTIFIED'
*                                                              @Y17XAUU
MSG77E   DS    0C
MSG78    DS    0C
         DC    C'IED216I '                                     @Y17XAUU
         DC    C'TRM CANCELLED - TOTE CANNOT USE TSO DEVICE'   @Y17XAUU
MSG78E   DS    0C
MSG79    DS    0C
         DC    C'IED259I '
         DC    C'INVALID RESPONSE'
MSG79E   DS    0C
         SPACE 2
PATCH    DC    10F'0'             PATCH AREA                   @Y17XAUU
         EJECT
*
         EJECT
         OLTCB
         EJECT
PLIST    DSECT
MSGID    DS    CL2                MESSAGE ID
MSGFLG   DS    CL1                MESSAGE FLAG
MSGCT    DS    CL1                MESSAGE IN COUNT
MSGCT1   DS    CL1                MESSAGE OUT COUNT
MSGADR   DS    CL3                MESSAGE OUT ADDRESS
         SPACE 2
         END
