QWL2     TITLE 'IEDQWL2 - MESSAGE SUB MODULE 3'
IEDQWL2  CSECT
*A000000-999999                                                @Y16X5U0
* CHANGE ACTIVITY AS FOLLOWS:                                    S22024
*C384000-388000                                                 SA41593
*C904000-908000                                                  S05331
*C720000-724000                                                @YA12402
*A824000,928000                                                @Y17XAUU
* A011401,848000,852000                                        @G36XRUV
* C852000                                                      @G36XRUV
*
         SPACE 4
****************************************************************
*                                                              *
* MODULUE NAME = IEDQWL2 (TCAM,TOTE)                           @Y17XAUU
*                                                              * S22024
* DESCRIPTIVE NAME = MESSAGE MODULE 4                          * S22024
*                                                              * S22024
* COPYRIGHT = NONE                                             * S22024
*                                                              * S22024
* STATUS --                                                    *
*    VERSION 10.0                                              @Y17XAUU
*                                                              *
* FUNCTIONS --                                                 *
*    THE PURPOSE OF THIS MODULE IS TO MOVE THE REQUESTED       *
*    OUTPUT MESSAGE TO THE OUTPUT BUFFER IN THE OLTCB.         *
*    THE KEY TO THE CORRECT MESSAGE TO MOVE IS THE ID IN       *
*    THE MESSAGE PARAMETER LIST. THIS MODULE ONLY HAS ID'S     *
*    80 THRU 99.                                               *
*                                                              *
*    UPON EXIT, THE OUTPUT MESSAGE AND LENGTH ARE PLACED       *
*    IN THE OLTCB.                                             *
*                                                              *
* ENTRY POINTS --                                              *
*    IEDQWL2 -                                                 @Y17XAUU
*                                                              @Y17XAUU
* PURPOSE -- SEE FUNCTION                                      @Y17XAUU
*                                                              @Y17XAUU
* MODULE TYPE -- PROCEDURE                                     @Y17XAUU
*                                                              @Y17XAUU
* MODULE SIZE -- 2K MAXIMUM                                    @Y17XAUU
*                                                              @Y17XAUU
* PROCESSOR -- ASSEMBLER XF                                    @Y17XAUU
*                                                              @Y17XAUU
* MACROS -- IEDHJN,SAVE,XCTL                                   @Y17XAUU
*                                                              @Y17XAUU
* LINKAGE -- XCTL'ED TO FROM IEDQWK                            @Y17XAUU
*                                                              *
* INPUT --                                                     *
*    REGISTERS 01, 02, 13, 14, 15 CONTAIN THE FOLLOWING VALUES *
*                                                              *
*    01 - MESSAGE PARAMETER LIST ADDRESS                       *
*    02 - OLTCB BASE POINTER                                   *
*    13 - CALLER'S SAVE AREA POINTER                           *
*    14 - CALLER'S RETURN ADDRESS                              *
*    15 - IEDQWL2 ENTRY POINT ADDRESS                          *
*                                                              *
* OUTPUT --                                                    *
*    THE REQUESTED OUTPUT MESSAGE AND COUNT ARE PLACED IN      *
*    THE OLTCB.                                                *
*                                                              *
* EXTERNAL REFERENCES --                                       *
*    NONE                                                      *
*                                                              *
* EXITS,NORMAL --                                              *
*    RETURN TO IEDQWK                                          *
*                                                              *
* EXITS,ERROR                                                  *
*    NONE                                                      *
*                                                              *
* TABLES/WORK AREAS --                                         *
*    OLTCB, MESSAGE PARAMETER LIST                             *
*                                                              *
* ATTRIBUTES --                                                *
*    ENABLED, PROBLEM PROGRAM MODE                             *
*                                                              *
* NOTES -- SEE BELOW                                           @Y17XAUU
*                                                              *
*  DEPENDENCIES -- EBCDIC CODE CHARACTER SET                   @Y17XAUU
*                                                              @Y17XAUU
*  RESTRICTIONS -- NONE                                        @Y17XAUU
*                                                              @Y17XAUU
*  REGISTER CONVENTIONS -- SEE REGISTERS ASSIGNMENT            @Y17XAUU
*                                                              @Y17XAUU
*  PATCH LABEL -- PATCH                                        @Y17XAUU
*                                                              *
****************************************************************
         EJECT
*
*        EQUATES
*
R0       EQU   0                  REG 0
R1       EQU   1                  REG 1
R2       EQU   2                  REG 2
R3       EQU   3                  REG 3
R4       EQU   4                  REG 4
R5       EQU   5                  REG 5
R6       EQU   6                  REG 6
R7       EQU   7                  REG 7
R8       EQU   8                  REG 8
R9       EQU   9                  REG 9
R10      EQU   10                 REG 10
R11      EQU   11                 REG 11
R12      EQU   12                 REG 12
R13      EQU   13                 REG 13
R14      EQU   14                 REG 14
R15      EQU   15                 REG 15
D0       EQU   0                  DISP OF 0
D1       EQU   1                  DISP OF 1
D2       EQU   2                  DISP OF 2
D3       EQU   3                  DISP OF 3
D4       EQU   4                  DISP OF 4
D8       EQU   8                  DISP OF 8
D12      EQU   12                 DISP OF 12
D16      EQU   16                 DISP OF 16
D20      EQU   20                 DISP OF 20
         SPACE
KADJUST  EQU   80                 MSG ID ADJUSTOR
KSHFTRT  EQU   8                  SHIFT 8 BIT
         EJECT
         USING IEDQWL2,R15
IEDQWL2  IEDHJN STARL2,HJN
         DROP  R15
         SPACE
         SAVE  (14,12)            SAVE CALLER'S REGISTERS
         USING IEDQWL2,R4
         USING TOTOLTCB,R2
         USING PLIST,R10
         LR    R4,R15             SET BASE REG FOR THIS MODULE
         LR    R10,R1             SET BASE REG FOR MSG P-LIST
         SPACE 2
         LA    R15,TOTSAVE2       GET MY SAVE AREA ADDR
         ST    R13,D4(R15)        SAVE CALLER'S SAVE AREA ADDR
         ST    R15,D8(R13)        SAVE MY SAVE AREA ADDR
         LR    R13,R15            SET REG 13 TO MY SAVE AREA
         SPACE 2
         SR    R5,R5              CLEAR REG 5
         SR    R6,R6              CLEAR REG 6
         LH    R5,MSGID           GET MSG ID
         LA    R8,KADJUST         GET ADJUSTOR
         SR    R5,R8              ADJUST FOR ENTRY IN BRANCH TABLE
         SLL   R5,2               MULTIPLY BY FOUR
         SPACE
         L     R7,MSGTABLE(R5)    GET MSG PARAMETERS
         SLDL  R6,KSHFTRT         MOVE BYTE COUNT INTO REG 6
         SRL   R7,KSHFTRT         ISOLATE MESSAGE ADDRESS
         SPACE
         STC   R6,TOTOTCNT        PUT BYTE COUNT INTO OLTCB
         BCTR  R6,D0              DECREMENT COUNT FOR EXECUTE
         EX    R6,MSGMOVE         MOVE MESSAGE TO OLTCB
         SPACE 2
*
LIMSG0   EQU   *    RETURN TO IEDQWK
*
         L     R13,D4(R13)        RESTORE CALLER'S SAVE AREA ADDR
         LM    R14,R1,D12(R13)    RESTORE REG 14-1              SA41593
         XCTL  (2,12),EP=IEDQWK1  RETURN TO IEDQWK              SA41593
         EJECT
*
*        C O N S T A N T S
*
MSGMOVE  MVC   TOTOTBUF(D0),D0(R7)  MOVE MSG TO OUTPUT BUFFER
         SPACE 4
*                                                              *
*        THE FOLLOWING CODE IS USED AS A BRANCH TABLE          *
*        FOR OBTAINING THE CORRECT MESSAGE TO MOVE TO THE      *
*        OLTCB. EACH ENTRY IN THE TABLE IS 4 BYTES LONG.       *
*        BYTE 0 CONTAINS THE MESSAGE LENGTH. BYTES 1-3         *
*        CONTAIN THE ADDRESS OF THE MESSAGE. NO COMMENTS       *
*        ARE DEEMED NECESSARY FOR EACH ENTRY.                  *
*                                                              *
MSGTABLE DS    0F
         DC    AL1(MSG80E-MSG80)
         DC    AL3(MSG80)
         DC    AL1(MSG81E-MSG81)
         DC    AL3(MSG81)
         DC    AL1(MSG82E-MSG82)
         DC    AL3(MSG82)
         DC    AL1(MSG83E-MSG83)
         DC    AL3(MSG83)
         DC    AL1(MSG84E-MSG84)
         DC    AL3(MSG84)
         DC    AL1(MSG85E-MSG85)
         DC    AL3(MSG85)
         DC    AL1(MSG86E-MSG86)
         DC    AL3(MSG86)
         DC    AL1(MSG87E-MSG87)
         DC    AL3(MSG87)
         DC    AL1(MSG88E-MSG88)
         DC    AL3(MSG88)
         DC    AL1(MSG89E-MSG89)
         DC    AL3(MSG89)
         DC    AL1(MSG90E-MSG90)
         DC    AL3(MSG90)
         DC    AL1(MSG91E-MSG91)
         DC    AL3(MSG91)
         DC    AL1(MSG92E-MSG92)
         DC    AL3(MSG92)
         DC    AL1(MSG93E-MSG93)
         DC    AL3(MSG93)
         DC    AL1(MSG94E-MSG94)
         DC    AL3(MSG94)
         DC    AL1(MSG95E-MSG95)
         DC    AL3(MSG95)
         DC    AL1(MSG96E-MSG96)
         DC    AL3(MSG96)
         DC    AL1(MSG97E-MSG97)
         DC    AL3(MSG97)
         DC    AL1(MSG98E-MSG98)
         DC    AL3(MSG98)
         DC    AL1(MSG99E-MSG99)
         DC    AL3(MSG99)
         EJECT
*                                                              *
*        THE FOLLOWING TABLE CONSIST OF A PORTION OF           *
*        TOTE'S MESSAGES. EACH MESSAGE IS SELF-EXPLANATORY.    *
*                                                              *
MSG80    DS    0C
         DC    C'IED215I '                                     @Y17XAUU
         DC    C'OLT REQUEST REJECTED, UNABLE TO ALLOCATE RESOURCES FOR*
               CT/AP'                                          @Y17XAUU
MSG80E   DS    0C
MSG81    DS    0C
         DC    C'IED261I '
         DC    C'INVALID TEST DEVICE ENTRY'
MSG81E   DS    0C
MSG82    DS    0C
         DC    C'IED262I '
         DC    C'ALREADY HAVE 10 TEST DEVICES - TEST DEVICE PROMPTING F*
               INISHED'
MSG82E   DS    0C
MSG83    DS    0C
         DC    C'IED263D '
         DC    C'INVALID RESPONSE, PLEASE ENTER YES OR NO'
MSG83E   DS    0C
MSG84    DS    0C
         DC    C'IED264D '
         DC    C'ARE THERE ANYMORE TEST DEVICES? ANSWER YES OR NO'
MSG84E   DS    0C
MSG85    DS    0C
         DC    C'IED265D '
         DC    C'ENTER SYMBOLIC NAME OF TERMINAL OR 0CUU OR CUU OF TCU X
               TO BE TESTED'                                   @YA12402
MSG85E   DS    0C
MSG86    DS    0C
         DC    C'IED217I '                                     @Y17XAUU
         DC    C'3705 NOT ACTIVE'                              @Y17XAUU
MSG86E   DS    0C
MSG87    DS    0C
         DC    C'IED267I '
         DC    C'ERROR IN OPTION FIELD'
MSG87E   DS    0C
MSG88    DS    0C
         DC    C'IED268I '
         DC    C'ERROR IN TEST FIELD'
MSG88E   DS    0C
MSG89    DS    0C
         DC    C'IED269I '
         DC    C'ERROR IN TEST DEVICE FIELD'
MSG89E   DS    0C
MSG90    DS    0C
         DC    C'IED270I '
         DC    C'TRM PROMPTER RUNNING'
MSG90E   DS    0C
MSG91    DS    0C
         DC    C'IED271I '
         DC    C'PROMPTING NOT ALLOWED ON 1060, RE-ENTER TRM'
MSG91E   DS    0C
MSG92    DS    0C
         DC    C'IED130I '                                     @Y17XAUU
         DC    C'OLT REQUEST REJECTED, CONTROL TERMINAL NOT OPENED'
*                                                              @Y17XAUU
MSG92E   DS    0C
MSG93    DS    0C
         DC    C'IED586I '                                     @XM05678
         DC    C'OLT REQUEST REJECTED, SNA LU NOT IN SSCP-LU SESSION ON*
               LY'                                             @XM05678
MSG93E   DS    0C
MSG94    DS    0C
         DC    C'IED607I '                                     @G36XRUV
         DC    C'3705/3270(LOCAL) NOT SUPPORTED AS T.D. BY TOTE - ENTERC
                DEALLOCATION TRM'                              @G36XRUV
MSG94E   DS    0C
MSG95    DS    0C
         DC    C' '                UNUSED MESSAGE
MSG95E   DS    0C
MSG96    DS    0C
         DC    C' '                UNUSED MESSAGE
MSG96E   DS    0C
MSG97    DS    0C
         DC    C'IED277I '
         DC    C'1060 CANNOT BE CONTROL TERMINAL FOR PROMPT OR CONFIG'
MSG97E   DS    0C
MSG98    DS    0C
         DC    C' '                UNUSED MESSAGE                S05331
MSG98E   DS    0C
MSG99    DS    0C
         DC    C'IED279D '
         DC    C'ENTER NEXT MESSAGE SEGMENT'
MSG99E   DS    0C
PATCH    DC    20F'0'             PATCH AREA                   @Y17XAUU
         EJECT
         OLTCB
         EJECT
PLIST    DSECT
MSGID    DS    CL2                MESSAGE ID
MSGFLG   DS    CL1                MESSAGE FLAG
MSGCT    DS    CL1                MESSAGE IN COUNT
MSGCT1   DS    CL1                MESSAGE OUT COUNT
MSGADR   DS    CL3                MESSAGE OUT ADDRESS
         SPACE 2
         END
