QWL3     TITLE 'IEDQWL3 - MESSAGE SUB MODULE 4'
IEDQWL3  CSECT
*A000000-999999                                                @Y16X5U0
* CHANGE ACTIVITY AS FOLLOWS:                                    S22024
*C288000-291000,657000,663000,687000,693000,699000,777000       SA41593
*C789000,795000-798000,816000,834000,864000,870000              SA41593
*A006500,013100-013800                                           S22024
*C174000,297000-941000                                           S22024
*D942000-966000                                                  S22024
*C619000                                                         S05331
*C693000                                                       @YA12402
*C789000                                                       @OY16442
*C643000,653000                                                @Y17XAUU
*A919000                                                       @Y17XAUU
         SPACE 4
****************************************************************
*                                                              *
* MODULE NAME = IEDQWL3 (TCAM,TOTE)                            @Y17XAUU
*                                                              * S22024
* DESCRIPTIVE NAME = MESSAGE MODULE 5                          * S22024
*                                                              * S22024
* COPYRIGHT = NONE                                             * S22024
*                                                              * S22024
* STATUS --                                                    *
*    VERSION 10.0                                              @Y17XAUU
*                                                              *
* FUNCTIONS --                                                 *
*    THE PURPOSE OF THIS MODULE IS TO MOVE THE REQUESTED       *
*    OUTPUT MESSAGE TO THE OUTPUT BUFFER IN THE OLTCB.         *
*    THE KEY TO THE CORRECT MESSAGE TO MOVE IS THE ID IN       *
*    THE MESSAGE PARAMETER LIST. THIS MODULE ONLY HAS ID'S     *
*    100 THRU 149.                                             *
*                                                              *
*    UPON EXIT, THE OUTPUT MESSAGE AND LENGTH ARE PLACED       *
*    IN THE OLTCB.                                             *
*                                                              *
* ENTRY POINTS --                                              *
*    IEDQWL3 - CALLED BY TOTE MESSAGE MODULE IEDQWK            *
*                                                              *
* PURPOSE -- SEE FUNCTION                                      @Y17XAUU
*                                                              @Y17XAUU
* PROCESSOR -- ASSEMBLER XF                                    @Y17XAUU
*                                                              @Y17XAUU
* MODULE TYPE -- PROCEDURE                                     @Y17XAUU
*                                                              @Y17XAUU
* MODULE SIZE -- 2K MAXIMUM                                    @Y17XAUU
*                                                              @Y17XAUU
* LINKAGE -- XCTL'ED TO FROM IEDQWK                            @Y17XAUU
*                                                              @Y17XAUU
* MACROS -- IEDHJN,SAVE,XCTL                                   @Y17XAUU
*                                                              @Y17XAUU
* INPUT --                                                     *
*    REGISTERS 01, 02, 13, 14, 15 CONTAIN THE FOLLOWING VALUES *
*                                                              *
*    01 - MESSAGE PARAMETER LIST ADDRESS                       *
*    02 - OLTCB BASE POINTER                                   *
*    13 - CALLER'S SAVE AREA ADDRESS                           *
*    14 - CALLER'S RETURN ADDRESS                              *
*    15 - IEDQWL3 ENTRY POINT ADDRESS                          *
*                                                              *
* OUTPUT --                                                    *
*    THE REQUESTED OUTPUT MESSAGE AND COUNT ARE PLACED IN      *
*    THE OLTCB                                                 *
*                                                              *
* EXTERNAL REFERENCES --                                       *
*    NONE                                                      *
*                                                              *
* EXITS,NORMAL                                                 *
*    RETURN TO IEDQWK                                          *
*                                                              *
* EXITS,ERRORS                                                 *
*    NONE                                                      *
*                                                              *
* TABLES/WORK AREAS --                                         *
*    OLTCB, MESSAGE PARAMETER LIST                             *
*                                                              *
* ATTRIBUTES --                                                *
*    ENABLED, PROBLEM PROGRAM MODE, TRANSIENT                  *
*                                                              *
* NOTES -- SEE BELOW                                           @Y17XAUU
*  DEPENDENCIES -- EBCDIC CHARACTER CODE SET                   @Y17XAUU
*                                                              @Y17XAUU
*  RESTRICTIONS -- NONE                                        @Y17XAUU
*                                                              @Y17XAUU
*  REGISTERS CONVENTION -- SEE REGISTERS ASSIGNMENT            @Y17XAUU
*                                                              @Y17XAUU
*  PATCH LEBEL -- PATCH                                        @Y17XAUU
*                                                              *
* **************************************************************
         EJECT
*
*        EQUATES
*
R0       EQU   0                  REG 0
R1       EQU   1                  REG 1
R2       EQU   2                  REG 2
R3       EQU   3                  REG 3
R4       EQU   4                  REG 4
R5       EQU   5                  REG 5
R6       EQU   6                  REG 6
R7       EQU   7                  REG 7
R8       EQU   8                  REG 8
R9       EQU   9                  REG 9
R10      EQU   10                 REG 10
R11      EQU   11                 REG 11
R12      EQU   12                 REG 12
R13      EQU   13                 REG 13
R14      EQU   14                 REG 14
R15      EQU   15                 REG 15
D0       EQU   0                  DISP OF 0
D1       EQU   1                  DISP OF 1
D2       EQU   2                  DISP OF 2
D3       EQU   3                  DISP OF 3
D4       EQU   4                  DISP OF 4
D8       EQU   8                  DISP OF 8
D12      EQU   12                 DISP OF 12
D16      EQU   16                 DISP OF 16
D20      EQU   20                 DISP OF 20
         SPACE
KADJUST  EQU   100                MSG ID ADJUSTER
KSHFTRT  EQU   8                  SHIFT 8 BIT
         EJECT
         USING IEDQWL3,R15
IEDQWL3  IEDHJN STARL3,HJN
         DROP  R15
         SPACE
         SAVE  (14,12)            SAVE CALLER'S REGISTERS
         USING IEDQWL3,R4
         USING TOTOLTCB,R2
         USING PLIST,R10
         LR    R4,R15             SET BASE REG FOR THIS MODULE
         LR    R10,R1             SET BASE REG FOR MSG P-LIST
         SPACE 2
         LA    R15,TOTSAVE2       GET MY SAVE AREA ADDR
         ST    R13,D4(R15)        SAVE CALLER'S SAVE AREA ADDR
         ST    R15,D8(R13)        SAVE MY SAVE AREA ADDR
         LR    R13,R15            SET REG 13 TO MY SAVE AREA
         SPACE 2
         SR    R5,R5              CLEAR REG 5
         SR    R6,R6              CLEAR REG 6
         LH    R5,MSGID           GET MSG ID
         LA    R8,KADJUST         GET ADJUSTOR
         SR    R5,R8              ADJUST FOR ENTRY IN BRANCH TABLE
         SLL   R5,2               MULTIPLY BY FOUR
         SPACE
         L     R7,MSGTABLE(R5)    GET MSG PARAMETERS
         SLDL  R6,KSHFTRT         MOVE BYTE COUNT INTO REG 6
         SRL   R7,KSHFTRT         ISOLATE MESSAGE ADDRESS
         SPACE
         STC   R6,TOTOTCNT        PUT BYTE COUNT INTO OLTCB
         BCTR  R6,D0              DECREMENT COUNT FOR EXECUTE
         EX    R6,MSGMOVE         MOVE MESSAGE TO OLTCB
         SPACE 2
*
LIMSG0   EQU   *    RETURN TO IEDQWK
*
         L     R13,D4(R13)        RESTORE CALLER'S SAVE AREA ADDR
         LM    R14,R1,D12(R13)    RESTORE REG 14-1              SA41593
         XCTL  (2,12),EP=IEDQWK1  RETURN TO IEDQWK              SA41593
         EJECT
*
*        C O N S T A N T S
*
MSGMOVE  MVC   TOTOTBUF(0),D0(R7) MOVE MSG TO OUTPUT BUFFER
OUTMSG   DS    F                  WORK AREA
         SPACE 4
         EJECT
MSGTABLE DS    0F
*                                                              *
*        THE FOLLOWING CODE IS USED AS A BRANCH TABLE          *
*        FOR OBTAINING THE CORRECT MESSAGE TO MOVE TO THE      *
*        OLTCB. EACH ENTRY IN THE TABLE IS 4 BYTES LONG.       *
*        BYTE 0 CONTAINS THE MESSAGE LENGTH. BYTES 1-3         *
*        CONTAIN THE ADDRESS OF THE MESSAGE. NO COMMENTS       *
*        ARE DEEMED NECESSARY FOR EACH ENTRY.                  *
*                                                              *
*
*        CONFIGURATOR MESSAGES ADDRESSES AND DISPLACEMENTS
*
         DC    AL1(MSG100E-MSG100)
         DC    AL3(MSG100)
         DC    AL1(MSG101E-MSG101)
         DC    AL3(MSG101)
         DC    AL1(MSG102E-MSG102)
         DC    AL3(MSG102)
         DC    AL1(MSG103E-MSG103)
         DC    AL3(MSG103)
         DC    AL1(MSG104E-MSG104)
         DC    AL3(MSG104)
         DC    AL1(MSG105E-MSG105)
         DC    AL3(MSG105)
         DC    AL1(MSG106E-MSG106)
         DC    AL3(MSG106)
         DC    AL1(MSG107E-MSG107)
         DC    AL3(MSG107)
         DC    AL1(MSG108E-MSG108)
         DC    AL3(MSG108)
         DC    AL1(MSG109E-MSG109)
         DC    AL3(MSG109)
         DC    AL1(MSG110E-MSG110)
         DC    AL3(MSG110)
         DC    AL1(MSG111E-MSG111)
         DC    AL3(MSG111)
         DC    AL1(MSG112E-MSG112)
         DC    AL3(MSG112)
         DC    AL1(MSG113E-MSG113)
         DC    AL3(MSG113)
         DC    AL1(MSG114E-MSG114)
         DC    AL3(MSG114)
         DC    AL1(MSG115E-MSG115)
         DC    AL3(MSG115)
         DC    AL1(MSG116E-MSG116)
         DC    AL3(MSG116)
         DC    AL1(MSG117E-MSG117)
         DC    AL3(MSG117)
         DC    AL1(MSG118E-MSG118)
         DC    AL3(MSG118)
         DC    AL1(MSG119E-MSG119)
         DC    AL3(MSG119)
         DC    AL1(MSG120E-MSG120)
         DC    AL3(MSG120)
         DC    AL1(MSG121E-MSG121)
         DC    AL3(MSG121)
         DC    AL1(MSG122E-MSG122)
         DC    AL3(MSG122)
         DC    AL1(MSG123E-MSG123)
         DC    AL3(MSG123)
         DC    AL1(MSG124E-MSG124)
         DC    AL3(MSG124)
         DC    AL1(MSG125E-MSG125)
         DC    AL3(MSG125)
         DC    AL1(MSG126E-MSG126)
         DC    AL3(MSG126)
         DC    AL1(MSG127E-MSG127)
         DC    AL3(MSG127)
         DC    AL1(MSG128E-MSG128)
         DC    AL3(MSG128)
         DC    AL1(MSG129E-MSG129)
         DC    AL3(MSG129)
         DC    AL1(MSG130E-MSG130)
         DC    AL3(MSG130)
         DC    AL1(MSG131E-MSG131)
         DC    AL3(MSG131)
         DC    AL1(MSG132E-MSG132)
         DC    AL3(MSG132)
         DC    AL1(MSG133E-MSG133)
         DC    AL3(MSG133)
         DC    AL1(MSG134E-MSG134)
         DC    AL3(MSG134)
         DC    AL1(MSG135E-MSG135)
         DC    AL3(MSG135)
         DC    AL1(MSG136E-MSG136)
         DC    AL3(MSG136)
         DC    AL1(MSG137E-MSG137)
         DC    AL3(MSG137)
         DC    AL1(MSG138E-MSG138)
         DC    AL3(MSG138)
         DC    AL1(MSG139E-MSG139)
         DC    AL3(MSG139)
         DC    AL1(MSG140E-MSG140)
         DC    AL3(MSG140)
         DC    AL1(MSG141E-MSG141)
         DC    AL3(MSG141)
         DC    AL1(MSG142E-MSG142)
         DC    AL3(MSG142)
         DC    AL1(MSG143E-MSG143)
         DC    AL3(MSG143)
         DC    AL1(MSG144E-MSG144)
         DC    AL3(MSG144)
         DC    AL1(MSG145E-MSG145)
         DC    AL3(MSG145)
         DC    AL1(MSG146E-MSG146)
         DC    AL3(MSG146)
         DC    AL1(MSG147E-MSG147)
         DC    AL3(MSG147)
         DC    AL1(MSG148E-MSG148)
         DC    AL3(MSG148)
         DC    AL1(MSG149E-MSG149)
         DC    AL3(MSG149)
         EJECT
*                                                              *
*        THE FOLLOWING TABLE CONSIST OF A PORTION OF           *
*        TOTE'S MESSAGES. EACH MESSAGE IS SELF EXPLANATORY.    *
*                                                              *
MSG100   DS    0C
         DC    C'IED280I '
         DC    C'CONFIGURATOR STARTED'
MSG100E  DS    0C
MSG101   DS    0C
         DC    C'IED281I '
         DC    C'CONFIGURATOR COMPLETED'
MSG101E  DS    0C
MSG102   DS    0C
         DC    C'IED282D '
         DC    C'ENTER FUNCTION: ADD,CHANGE,DELETE,EXHIBIT, OR NONE'
MSG102E  DS    0C
MSG103   DS    0C
         DC    C'IED283D '
         DC    C'ENTER A LINE ADDR. OR A SYMBOLIC TERMINAL NAME'
MSG103E  DS    0C
MSG104   DS    0C
         DC    C'IED305D '
         DC    C'IS DEVICE A LINE(L), START/STOP(S) OR BI-SYNC(B) DEVIC*
               E'
MSG104E  DS    0C
MSG105   DS    0C
         DC    C'IED308I '
         DC    C'CONCENTRATOR CANNOT BE CONFIGURED'
MSG105E  DS    0C
MSG106   DS    0C
         DC    C'IED286D '
         DC    C'ENTER TYPE OF TERMINAL'
MSG106E  DS    0C
MSG107   DS    0C
         DC    C'IED287D '
         DC    C'ENTER ADAPTER LINE CODE: (EBCDIC,TRANSCODE,ASCII)'
MSG107E  DS    0C
MSG108   DS    0C
         DC    C'IED309D '
         DC    C'ENTER NETWORK ADDRESS FOR DEVICE BEING CONFIGURED'
MSG108E  DS    0C
MSG109   DS    0C
         DC    C'IED311I '
         DC    C'CDS DATA SET IN UNSHAREABLE STATE - REENTER TRM LATER'
MSG109E  DS    0C
MSG110   DS    0C
         DC    C'IED316D '                                       S05331
         DC    C'IS THE DEVICE TO BE CONFIGURED A 3704?  REPLY YES OR N*
               O'                                                S05331
MSG110E  DS    0C
MSG111   DS    0C
         DC    C' '                UNUSED MESSAGE
MSG111E  DS    0C
MSG112   DS    0C
         DC    C'IED291I '
         DC    C'START/STOP TERMINALS SUPPORTED: 1030,1050,1060,2260,22*
               65,'
MSG112E  DS    0C
MSG113   DS    0C
         DC    C'IED291I '
         DC    C'                                2740,2741,2760,3700'
*                                                              @Y17XAUU
MSG113E  DS    0C
MSG114   DS    0C
         DC    C'IED292I '
         DC    C'BI-SYNC TERMNLS SUPPORTED: 2770,2780,1130,2020,3270,36*
               70,S360,3700'                                   @Y17XAUU
MSG114E  DS    0C
MSG115   DS    0C
         DC    C'IED293I '
         DC    C'OLD ENTRY DELETED FROM CDS'
MSG115E  DS    0C
MSG116   DS    0C
         DC    C'IED294I '
         DC    C'NEW ENTRY ADDED TO CDS'
MSG116E  DS    0C
MSG117   DS    0C
         DC    C'IED295I '
         DC    C'MODIFICATION/DELETION NOT PERMITTED FOR THIS DEVICE'
MSG117E  DS    0C
MSG118   DS    0C
         DC    C'IED296I '
         DC    C'LINE NOT OPENED'
MSG118E  DS    0C
MSG119   DS    0C
         DC    C'IED296D '
         DC    C'ENTER LINE ADDRESS (FORMAT 0CUU OR CUU)'      @YA12402
MSG119E  DS    0C
*        IED297I IS NOW IN IEDQWL
MSG120   DS    0C
         DC    C'IED298D '
         DC    C'ARE THERE OTHER ENTRIES TO ADD? (YES OR NO)'
MSG120E  DS    0C
MSG121   DS    0C
         DC    C'IED299D '
         DC    C'ARE THERE OTHER ENTRIES TO CHANGE? (YES OR NO)'
MSG121E  DS    0C
MSG122   DS    0C
         DC    C'IED300D '
         DC    C'ARE THERE OTHER ENTRIES TO DELETE? (YES OR NO)'
MSG122E  DS    0C
MSG123   DS    0C
         DC    C'IED301D '
         DC    C'ARE THERE OTHER ENTRIES TO EXHIBIT? (YES OR NO)'
MSG123E  DS    0C
MSG124   DS    0C
         DC    C'IED584D '                                     @YM07415
         DC    C'ENTER SYMBOLIC NAME OF NCP TO WHICH THIS RESOURCE IS A*
               TTACHED'                                        @YM07415
MSG124E  DS    0C
MSG125   DS    0C
         DC    C'IED303D '
         DC    C'DO YOU WISH TO CONTINUE? (YES OR NO)'
MSG125E  DS    0C
MSG126   DS    0C
         DC    C'IED585I '                                     @YM07415
         DC    C'INVALID NCP ENTRY'                            @YM07415
MSG126E  DS    0C
         DC    C' '                UNUSED MESSAGE
MSG127   DS    0C
         DC    C' '                UNUSED MESSAGE
MSG127E  DS    0C
MSG128   DS    0C
         DC    C'IED306I '
         DC    C'UNCORRECTABLE INPUT/OUTPUT ERROR'
MSG128E  DS    0C
MSG129   DS    0C
         DC    C'IED307I '
         DC    C'UNABLE TO OPEN CDS DATA SET'
MSG129E  DS    0C
MSG130   DS    0C
         DC    C' '                UNUSED MESSAGE
MSG130E  DS    0C
MSG131   DS    0C
         DC    C' '                UNUSED MESSAGE
MSG131E  DS    0C
MSG132   DS    0C
         DC    C'IED310I '
         DC    C'NAME NOT FOUND OR NAME INVALID FOR CONFIG'    @OY16442
MSG132E  DS    0C
MSG133   DS    0C
         DC    C' '                UNUSED MESSAGE
MSG133E  DS    0C
MSG134   DS    0C
         DC    C'IED312I '
         DC    C'PERMANENT I/O ERROR - CDS ENTRY MAY HAVE BEEN DELETED'
MSG134E  DS    0C
MSG135   DS    0C
         DC    C'IED313I '
         DC    C'UNCORRECTABLE ERROR ATTEMPTING TO ADD NEW ENTRY'
MSG135E  DS    0C
MSG136   DS    0C
         DC    C'IED314I '
         DC    C'OUT OF SPACE TO ADD NEW ENTRY'
MSG136E  DS    0C
MSG137   DS    0C
         DC    C'IED315I '
         DC    C'ENTRY TO DELETE NOT FOUND'
MSG137E  DS    0C
MSG138   DS    0C
         DC    C' '                UNUSED MESSAGE
MSG138E  DS    0C
MSG139   DS    0C
         DC    C' '                UNUSED MESSAGE
MSG139E  DS    0C
MSG140   DS    0C
         DC    C' '                UNUSED MESSAGE
MSG140E  DS    0C
MSG141   DS    0C
         DC    C'IED319I '
         DC    C'INVALID LINE ADDRESS'
MSG141E  DS    0C
MSG142   DS    0C
         DC    C'IED320I '
         DC    C'INVALID TERMINAL TYPE'
MSG142E  DS    0C
MSG143   DS    0C
         DC    C'IED321I '
         DC    C'UNSUPPORTED DEVICE TYPE'
MSG143E  DS    0C
MSG144   DS    0C
         DC    C'IED322I '
         DC    C'DEVICE NOT CONFIGURED'
MSG144E  DS    0C
MSG145   DS    0C
         DC    C'IED323I '
         DC    C'EXHIBIT OF THIS DEVICE CONFIGURATION NOT PERMITTED'
MSG145E  DS    0C
MSG146   DS    0C
         DC    C'IED324I '
         DC    C'ALREADY CONFIGURED; REQUEST CHANGE FUNCTION TO MODIFY'
MSG146E  DS    0C
MSG147   DS    0C
         DC    C'IED325I '
         DC    C'NO UNIT CONFIG MODULE FOR THIS DEVICE'
MSG147E  DS    0C
MSG148   DS    0C
         DC    C'IED326I '
         DC    C'I/O ERROR; UNABLE TO CONFIGURE THIS DEVICE TYPE'
MSG148E  DS    0C
MSG149   DS    0C
         DC    C'IED327I '
         DC    C'UNABLE TO LOAD UNIT CONFIG MODULE'
MSG149E  DS    0C
PATCH    DC    20F'0'             PATCH AREA                   @Y17XAUU
         EJECT
         OLTCB
         EJECT
PLIST    DSECT
MSGID    DS    CL2                MESSAGE ID
MSGFLG   DS    CL1                MESSAGE FLAG
MSGCT    DS    CL1                MESSAGE IN COUNT
MSGCT1   DS    CL1                MESSAGE OUT COUNT
MSGADR   DS    CL3                MESSAGE OUT ADDRESS
         SPACE 2
         END
