         TITLE 'TOTE EXIO SERVICE MODULE - IEDQWN'
IEDQWN   CSECT
*A000000-999999                                                @Y16X5U0
*CHANGE ACTIVITY AS FOLLOWS:
* THIS MODULE IS BEING RESEQUENCED AS OF TCAM 10.0             @Y17XAUU
* THE FOLLOWING APARS HAVE BEEN INCORPORATED INTO IT:          @Y17XAUU
* SA64784, OY12988                                             @Y17XAUU
* A004200,214200,217200,246600,294600,300000,316200,350400     @G36XRUV
* C214800,217800,247200,295200,300600,316800,351000            @G36XRUV
*
***********************************************************************
*                                                                     *
*                                                                     *
* MODULE NAME --                                                      *
*                                                                     *
*    IEDQWN   (ALIAS IEDQW35) (TCAM,TOTE)                      @Y17XAUU
*                                                                     *
* DESCRIPTIVE NAME --                                                 *
*                                                                     *
*    TOTE EXIO SERVICE MODULE                                         *
*                                                                     *
* COPYRIGHT --                                                        *
*                                                                     *
*    'NONE'                                                           *
*                                                                     *
* STATUS --                                                           *
*                                                                     *
*    VERSION 10.0                                              @Y17XAUU
*                                                                     *
* FUNCTIONS --                                                        *
*                                                                     *
*    THE PURPOSE OF THIS MODULE IS TO INITIATE I/O OPERATIONS.  ON    *
*    ENTRY IEDQWN CHECKS TO SEE IF A MACRO OF LEVEL 2 OR GREATER WAS  *
*    ISSUED.  IF NOT, A BAD RETURN CODE IS SET AND THE EXIT           *
*    ROUTINE IS ENTERED.                                              *
*                                                                     *
*    A CHECK IS THEN MADE TO SEE IF ANY UNSUPPORTED FUNCTION WAS      *
*    REQUESTED.  IF IT IS, A BAD RETURN CODE IS SET AND THE EXIT      *
*    ROUTINE IS ENTERED.                                              *
*                                                                     *
*    IEDQWN THEN DETERMINES IF THE REQUEST IS FOR THE PRIMARY         *
*    OR SECONDARY TEST DEVICE.  A BIT IS SET IN THE OLTCB INDICATING  *
*    WHICH TERMINAL IS BEING USED AND THE ADDRESS OF THE REQUIRED     *
*    I/O CONTROL BLOCKS (IOBLOCKS) IS OBTAINED.                       *
*                                                                     *
*    NEXT, AN EXAMINATION IS MADE TO SEE IF AN ATTENTION INTERRUPT    *
*    IS EXPECTED.  IF IT IS, THE CCW CHAIN IS SCANNED TO VERIFY IT    *
*    IS VALID AND THE IOB IS SET UP TO HANDLE THE ATTENTION           *
*    INTERRUPT.  IF THE LAST CCW IN THE CHAIN IS NOT A NO-OP,         *
*    A BAD RETURN CODE IS SET AND THE EXIT ROUTINE IS ENTERED.        *
*                                                                     *
*    THE LINE FOR THE REQUESTED TEST DEVICE IS STOPPED VIA OPERATOR   *
*    CONTROL.  IF THIS STOP LINE FAILS, A BAD RETURN CODE IS SET AND  *
*    THE EXIT ROUTINE IS ENTERED.                                     *
*                                                                     *
*    IEDQWN DETERMINES IF THE LINE BEING USED NEEDS TO BE ENABLED.    *
*    IF THE TEST DEVICE IS A LINE (CUU ADDRESS), THEN NO LINE         *
*    CONNECTION IS REQUIRED.  IF THE TEST DEVICE IS A TERMINAL,       *
*    THE LINE IS ENABLED IF NECESSARY.  IF THE ENABLE FAILS, A BAD    *
*    RETURN CODE IS SET AND THE EXIT ROUTINE IS ENTERED.              *
*                                                                     *
*    NEXT, THE IOB IS SET UP.  THE IOB IS CLEARED. THEN THE IOB       *
*    UNRELATED FLAG IS SET, THE CHANNEL PROGRAM ADDRESS IS INSERTED,  *
*    X'FF' IS SET IN THE RESTART ADDRESS AND THE CHANNEL PROGRAM      *
*    IS INSPECTED AND CHAINING FLAGS ARE SET AS DETERMINED BY CCW     *
*    FLAG BITS.                                                       *
*                                                                     *
*    THE DCB FLAGS ARE SET TO BYPASS ERP'S AND THE PERMANENT ERROR    *
*    FLAG IS CLEARED.  THE ADDRESS OF THE IOB IS PLACED IN THE DCB.   *
*    THE ADDRESS OF THE DCB AND ECB ARE PUT INTO THE IOB.  THE        *
*    EXCP IS ISSUED AND A GOOD RETURN CODE IS SET BEFORE EXIT.        *
*                                                                     *
*    IN THE EXIT ROUTINE, IF THE TRACE FUNCTION IS INDICATED IN THE   *
*    OLTCB, IEDQWN XCTL'S TO IEDQWM2 (TRACE MODULE).  IF NO TRACE     *
*    IS REQUESTED, CONTROL IS RETURNED TO IEDQWA VIA BR 14.           *
*    IF THE TEST DEVICE IS ON A 3705 (IE '$TDATBLK' BIT IS ON   S22024*
*    IN THE SCT), IEDQWN EXAMINES THE CCW CHAIN TO SEE WHAT     S22024*
*    COMMAND WAS REQUESTED.  IF IT IS A 'READ' CCW, A GOOD      S22024*
*    RETURN CODE IS SET AND THE EXIT ROUTINE IS ENTERED.  IF IT S22024*
*    IS A 'WRITE' CCW, BUFFER UNITS ARE REQUESTED FROM THE      S22024*
*    TCAM BUFFER UNIT POOL, THE DATA IS MOVED INTO THE UNITS,   S22024*
*    AND THE BUFFER IS POSTED DIRECTLY TO THE OUTPUT WRITER QCB S22024*
*    FOR THE RELATED 3705 LCB.  THE EXIT ROUTINE IS THEN        S22024*
*    ENTERED.                                                   S22024*
*                                                                     *
* ENTRY POINT --                                                      *
*                                                                     *
*    IEDQWN - CALLED BY OLT SERVICE MANAGER ROUTINE IN IEDQWA         *
*                                                              @Y17XAUU
* PROCESSOR -- ASSEMBLER XF                                    @Y17XAUU
*                                                              @Y17XAUU
* MODULE TYPE -- PROCEDURE                                     @Y17XAUU
*                                                              @Y17XAUU
* LINKAGE -- BALR REG14,REG15 FROM IEDQWA                      @Y17XAUU
*                                                              @Y17XAUU
* MODULE SIZE __ SEE ASSEMBLER LISTING                         @Y17XAUU
*                                                                     *
* INPUT --                                                            *
*                                                                     *
*    REGISTERS 01,02,13,14,15 CONTAIN THE FOLLOWING VALUES:           *
*                                                                     *
*         01 - PARAMETER LIST ADDRESS                                 *
*         02 - OLTCB ADDRESS                                          *
*         13 - SAVE AREA ADDRESS                                      *
*         14 - RETURN ADDRESS                                         *
*         15 - ENTRY POINT ADDRESS                                    *
*                                                                     *
* OUTPUT --                                                           *
*                                                                     *
*    REGISTER 15 CONTAINS ONE OF THE FOLLOWING RETURN CODE VALUES:    *
*                                                                     *
*         X'00' - EXCP ISSUED                                         *
*         X'04' - FACILITY NOT AVAILABLE                              *
*         X'08' - DEVICE NOT PRIMARY, GRABBED OR DATA PROTECTED       *
*               - DEVICE ALREADY IN OPERATION FROM PRECEDING EXIO     *
*               - TECB ADDRESS NOT GIVEN                              *
*               - ATTENTION WAS SPECIFIED AND CCW LIST DOES NOT       *
*                   END IN NO-OP. (OS ONLY)                           *
*               - CCW CHAIN DID NOT START WITH ONE OF THE       S22024*
*                 FOLLOWING COMMANDS:                           S22024*
*                      WRITE                                    S22024*
*                      WRITE BREAK                              S22024*
*                      READ                                     S22024*
*         X'0C' - DATA PROTECTION ERROR IN CCW LIST OPERATION         *
*         X'10' - PROCESSED ALL PARAMETERS EXCEPT SENSE               *
*         X'14' - LINE CONNECTION FAILED                              *
*                                                                     *
* EXTERNAL ROUTINES --                                                *
*                                                                     *
*    NONE                                                             *
*                                                                     *
* EXITS,NORMAL --                                                     *
*                                                                     *
*    IF TRACE FUNCTION SPECIFIED, 'XCTL' TO IEDQWM2                   *
*    OTHERWISE, RETURN TO IEDQWA VIA BR 14.                           *
*                                                                     *
* EXITS,ERROR --                                                      *
*                                                                     *
*    NONE                                                             *
*                                                                     *
* TABLES/WORK AREAS --                                                *
*                                                                     *
*    OLTCB,TECB,IOB,DCB,ECB,IOBLOCKS,AVT,UCB                          *
*                                                                     *
* ATTRIBUTES --                                                       *
*                                                                     *
*    ENABLED, PROBLEM PROGRAM MODE, RESIDENT RE-ENTRANT        @Y17XAUQ
*                                                              @Y17XAUU
* NOTES -- SEE BELOW                                           @Y17XAUU
*                                                              @Y17XAUU
*  RESTRICTIONS -- NONE                                        @Y17XAUU
*                                                              @Y17XAUU
*  DEPENDENCIES -- EBCDIC CHARACTER CODE                       @Y17XAUU
*                                                              @Y17XAUU
*  PATCH LABEL -- PATCH                                        @Y17XAUU
*                                                              @Y17XAUU
*  REGISTERS CONVENTION -- SEE REGISTERS ASSIGNMENT            @Y17XAUU
*                                                                     *
***********************************************************************
         SPACE 2
         EJECT
***********************************************************************
*                                                                     *
*        REGISTER EQUATES                                             *
*                                                                     *
***********************************************************************
         SPACE 2
R0       EQU   0                  WORK REGISTER
R1       EQU   1                  ADDRESS OF PARAMETER LIST
R2       EQU   2                  ADDRESS OF OLTCB
R3       EQU   3                  WORK REGISTER
R4       EQU   4                  BASE REGISTER
R5       EQU   5                  ADDRESS OF TTECB
R6       EQU   6                  WORK REGISTER
R7       EQU   7                  ADDRESS OF IOBLOCKS
R8       EQU   8                  WORK REGISTER
R9       EQU   9                  WORK REGISTER
R10      EQU   10                 WORK REGISTER
R11      EQU   11                 ADDRESS OF PARAMETER LIST PASSED
*                                   BY THE OLT
R12      EQU   12                 WORK REGISTER
R13      EQU   13                 SAVE AREA ADDRESS
R14      EQU   14                 RETURN ADDRESS
R15      EQU   15                 ENTRY POINT ADDRESS
         EJECT
**************************************************************** S22024
*        MODULE EQUATES                                        * S22024
**************************************************************** S22024
         SPACE 2
OLTCB    EQU   X'01'              BIT SETTING INDICATING THAT    S22024
*                                   CDS INFORMATION IS IN OLTCB  S22024
X01      EQU   X'01'              BIT SETTING INDICATING LINE    S22024
*                                   CONNECTION IS REQUIRED       S22024
X40      EQU   X'40'              BIT SETTING IN CDS INDICATING  S22024
*                                   ENTRY IS FOR A LINE          S22024
SENSENO  EQU   X'40'              BIT SETTING INDICATING THAT    S22024
*                                   SENSE=NO WAS SPECIFIED       S22024
*                                   IN THE MACRO                 S22024
ATTNIN   EQU   X'80'              ATTENTION IN OPTION FLAG       S22024
LINESTRT EQU   X'40'              VERB CODE FOR START LINE       S22024
LINESTOP EQU   X'41'              VERB CODE FOR STOP LINE        S22024
TERMSTRT EQU   X'45'              VERB CODE FOR START TERMINAL   S22024
TERMSTOP EQU   X'47'              VERB CODE FOR STOP TERMINAL    S22024
INACT    EQU   X'48'              VERB CODE FOR INACTIVATE     @YM08136
FLAG     EQU   X'42'              IOB FLAGS                      S22024
ENABLCMD EQU   X'27'              ENABLE COMMAND                 S22024
DIALCMD  EQU   X'29'              DIAL COMMAND                   S22024
SLI      EQU   X'20'              SLI BIT SETTING                S22024
TYPEIII  EQU   X'82'              TYPE III IBM                   S22024
TCU2702  EQU   X'02'              2702 TCU                       S22024
SWITCHED EQU   X'90'              UCB INDICATION OF DIAL LINE    S22024
AUTOCALL EQU   X'80'              AUTOCALL INDICATION IN UCB     S22024
CCSLI    EQU   X'60'              COMMAND CHAIN AND SLI          S22024
CLEAR    EQU   X'00'              USED TO CLEAR FIELDS           S22024
GOOD     EQU   X'00'              GOOD RETURN CODE               S22024
ALREADY  EQU   X'08'              RETURN CODE FROM OPERATOR      S22024
*                                   CONTROL IF LINE ALREADY      S22024
*                                   STOPPED                      S22024
TIC      EQU   X'08'              TIC COMMAND                    S22024
SDAII    EQU   X'90'              SDA II                         S22024
NOOP     EQU   X'03'              NO-OP COMMAND                  S22024
CMMDCH   EQU   X'40'              COMMAND CHAIN                  S22024
NORMAL   EQU   X'7F'              NORMAL ECB COMPLETION          S22024
BUFSIZE  EQU   X'80'              BUFFER SIZE SPECIFIED          S22024
DIAL     EQU   X'40'              DIAL TEST                      S22024
TSG      EQU   X'E0'              GROUP, SINGLE OR TERMINAL      S22024
UNREL    EQU   X'02'              IOB UNRELATED FLAG             S22024
CHAINDAT EQU   X'80'              DATA CHAINING FLAG
CHAINCMD EQU   X'40'              COMMAND CHAINING FLAG          S22024
CCWTIC   EQU   X'08'              TRANSFER IN CHANNEL CODE       S22024
BYPERPS  EQU   X'0C'              BYPASS ERROR RECOVERY          S22024
*                                   PROCEDURES FLAG              S22024
PERMERR  EQU   X'C0'              PERMANENT ERROR FLAGS          S22024
X02      EQU   X'02'              FLAG SETTING                   S22024
X0F      EQU   X'0F'              USED TO CLEAR BITS             S22024
XF0      EQU   X'F0'              USED TO MAKE DIAL DIGITS EBCDICS22024
XFF      EQU   X'FF'              USED IN CLEARING FLAGS         S22024
X3F      EQU   X'3F'              USED TO CLEAR FLAG             S22024
ZERO     EQU   0                  RETURN CODE AND DISPLACEMENT   S22024
ONE      EQU   1                  CONSTANT DISPLACEMENT          S22024
TWO      EQU   2                  CONSTANT DISPLACEMENT          S22024
THREE    EQU   3                  CONSTANT DISPLACEMENT          S22024
FOUR     EQU   X'04'              RETURN CODE AND DISPLACEMENT   S22024
SIX      EQU   6                  CONSTANT DISPLACEMENT          S22024
SEVEN    EQU   7                  DISPLACEMENT 7                 S22024
EIGHT    EQU   8                  RETURN CODE AND DISPLACEMENT   S22024
NINE     EQU   9                  CONSTANT DISPLACEMENT          S22024
TEN      EQU   10                 RETURN CODE USED WHEN SENSE    S22024
*                                   BYPASS IS NOT AVAILABLE      S22024
ELEVEN   EQU   11                 CONSTANT DISPLACEMENT          S22024
TWELVE   EQU   12                 CONSTANT DISPLACEMENT          S22024
FOURTEEN EQU   X'14'              RETURN CODE FOR LINE CONNECT-  S22024
*                                   ION FAILED                   S22024
D19      EQU   19                 CONSTANT DISPLACEMENT          S22024
TWENTY   EQU   20                 CONSTANT DISPLACEMENT          S22024
THIRTY2  EQU   32                 CONSTANT                       S22024
D100     EQU   X'64'              CONSTANT DISPLACEMENT          S22024
BRPRI    EQU   X'E4'              PRIORITY OF ERB POSTED TO BUFFES22024
*                                  REQUEST                       S22024
OUTPRI   EQU   X'E0'              PRIORITY USED TO POST TO       S22024
*                                  OUTPUT WRITER                 S22024
CODE     EQU   X'0C'              SVC 102 ACTION CODE            S22024
ENDLIST  EQU   X'80'              LAST WORD INDICATION IN SVC 102S22024
X08      EQU   X'08'              LENGTH OF DISTANCE BETWEEN     S22024
*                                  BUFFER START AND BTU          S22024
DC       EQU   X'80'              DATA CHAIN BIT SETTING IN CCW  S22024
READ     EQU   X'02'              READ COMMAND CODE IN CCW       S22024
WRITE    EQU   X'01'              WRITE COMMAND CODE IN CCW      S22024
WRITEBK  EQU   X'09'              WRITE BREAK COMMAND            S22024
RSRESET  EQU   X'93'              RESTART RESET CMDCODE IN CCW @Y17XAUQ
WRSTART0 EQU   X'31'              WRITE START 0 CMDCODE IN CCW @Y17XAUQ
RDSTART0 EQU   X'32'              READ START 0 CMDCODE IN CCW  @Y17XAUQ
HOLD     EQU   X'88'              OPCNTL HOLD VERB CODE        @Y17XAUQ
CCWLNGTH EQU   8                  LENGTH OF CCW                @Y17XAUQ
DEFSPON  EQU   X'80'              DEFINITE RESPONSE FLAG       @Y17XAUU
FORMAT   EQU   X'08'              FORMAT INDICATOR             @ZM47554
RN3705   EQU   X'05'              BIT SETTING INDICATING 3705 UCBS22024
OPCKEY   EQU   X'00'              OP CONTROL KEY FIELD           S22024
OPCPRI   EQU   X'DC'              OP CONTROL PRIORITY            S22024
OPCRTCD  EQU   X'00'              OP CONTROL RETURN CODE FIELD   S22024
OPCELNG  EQU   X'18'              OP CONTROL ELEMENT LENGTH      S22024
DISREG2  EQU   28
         EJECT
         USING IEDQWN,R15
IEDQWN   IEDHJN IEDQWNN,HJN       SET MODULE IDENTIFIER AND HJN  S99528
***********************************************************************
*                                                                     *
*        PERFORM INITIALIZATION                                       *
*                                                                     *
***********************************************************************
         SPACE 1
EXIO00   EQU   *
         DROP  R15
         USING EXIOLIST,R11       ESTABLISH ADDRESSIBILITY FOR   S99528
*                                   EXIO PARAMETER LIST          S99528
         USING TOTOLTCB,R2        ESTABLISH ADDRESSIBILITY FOR   S99528
*                                   OLTCB                        S99528
         USING IEDQWN,R4          SET UP BASE REGISTER           S99528
         USING TTECB,R5           SET UP ADDRESSIBILITY FOR      S99528
*                                   TEST EVENT CONTROL BLOCK     S99528
         USING IOBLOCKS,R7        SET UP ADDRESSIBLITY FOR       S99528
*                                   IOBLOCKS                     S99528
         STM   R14,R12,TWELVE(R13) SAVE CALLER'S REGISTERS       S99528
         LR    R4,R15              SET UP BASE.
         ST    R13,TOTSAVE1+FOUR  SAVE BACKWARD POINTER          S99528
         LA    R5,TOTSAVE1        SAVE ADDRESS OF SAVE AREA      S99528
         ST    R5,EIGHT(R13)      PUT ADDRESS OF SAVE AREA INTO  S99528
*                                  SAVE AREA                     S99528
         LR    R13,R5             GET ADDRESS OF SAVE AREA       S99528
         NI    TOTFLG07,XFF-TOTPRIEX-TOTSECEX CLEAR DEVICE FLAGS S99528
         LR    R11,R1             PUT PARAMETER LIST ADDRESS     S99528
*                                   INTO REGISTER 11             S99528
         SPACE 1
         CLI   XIOLEVEL,X02       CORRECT MACRO LEVEL?           S99528
         BNL   EX100              YES,CONTINUE                   S99528
         SPACE 1
         LA    R15,FOUR           NO, SET FUNCTION NOT AVAILABLE S99528
*                                  RETURN CODE.                  S99528
         B     EXIT               RETURN TO CALLER
         EJECT
***********************************************************************
*                                                                     *
*        DETERMINE IF DEVICE REQUESTED FOR EXIO IS THE PRIMARY        *
*        OR SECONDARY TEST DEVICE AND SET UP IOBLOCKS CONTROL         *
*        BLOCK BASE                                                   *
*                                                                     *
***********************************************************************
         SPACE 2
EX100    EQU   *
         LA    R6,LCBCPA          SAVE ADDR OF CHANNEL PGM     @ZM47553
         ST    R6,LCBSIOCC          AREA                       @ZM47553
         MVC   LCBCPA(CCWLNGTH),QCBCPA MOVE CCW INTO DSECT     @Y17XAUQ
         CLC   XIOCDSA(FOUR),ZEROADDR  IS CDS ADDRESS EQUAL TO 0?S99528
         BE    PRIMARY            YES,GO SET UP FOR PRIMARY      S99528
*                                  DEVICE                        S99528
         L     R6,XIOCDSA         GET ADDRESS OF CONFIGURATION   S99528
*                                   DATA FOR DEVICE              S99528
         TM    TOTTDTBL,TOTTDTRM  IS THE TEST DEVICE A TERMINAL? S99528
         BO    TERMTEST           YES, CONTINUE                  S22024
         TM    TOTTDTBL,TOTTDLIN+TOTTDORN  IS THE TEST DEVICE A  S22024
*                                            COMM LINE ON A 3705?S22024
         BNO   LINETEST           NO, THEN TEST IS FOR A LINE    S22024
TERMTEST EQU   *                                                 S22024
         SR    R8,R8              CLEAR REGISTER 8               S99528
         IC    R8,TOTTTBEL        GET LENGTH OF NAME FIELD IN    S99528
*                                  TERMNAME TABLE ENTRY          S99528
         BCT   R8,LABEL           DECREMENT LENGTH BY ONE        S99528
LABEL    EQU   *                                                 S99528
         L     R5,TOTTNTPR        GET TNT ADDRESS OF PRIMARY     S99528
*                                  DEVICE                        S99528
         EX    R8,COMPARE         GO COMPARE SYMBOLIC NAMES      S99528
         BE    PRIMARYA           IF THE SAME, SET UP PRIMARY    S99528
*                                 IOB                            S99528
         L     R5,TOTSRTNT        GET TNT ADDRESS OF SECONDARY   S99528
*                                  DEVICE                        S99528
         EX    R8,COMPARE         GO COMPARE SYMBOLIC NAMES      S99528
         BE    SECOND             IF EQUAL, GO SET UP SECONDARY  S99528
*                                  IOB                           S99528
ERROR    EQU   *                                                 S99528
         LA    R15,EIGHT          DEVICE NOT PRIMARY OR SECONDARYS99528
*                                 TECB ADDRESS NOT GIVEN         S99528
*                                 CCW CHAIN FOR ATTENTION IS NOT S99528
*                                  ENDED WITH A NO-OP            S99528
         B     EXIT               BRANCH TO EXIT                 S99528
LINETEST EQU   *                                                 S99528
         SR    R5,R5              CLEAR                        @G36XRUV
         ICM   R5,3,TOTPRUCB      GET PRIMARY UCB ADDRESS      @G36XRUV
         MVC   UCBAREA,FOUR(R5)   STORE UNIT ADDRESS             S99528
         NI    UCBAREA,X3F        CLEAR HIGH ORDER HALF BYTE     S99528
         CLC   UCBAREA,TWO(R6)    COMPARE UNIT NAMES             S99528
         BE    PRIMARYA           IF EQUAL, SET UP PRIMARY IOB   S99528
         SR    R5,R5              CLEAR                        @G36XRUV
         ICM   R5,3,TOTSCUCB      GET SECONDARY UCB ADDRESS    @G36XRUV
         MVC   UCBAREA,FOUR(R5)   STORE UNIT ADDRESS             S99528
         NI    UCBAREA,X3F        CLEAR HIGH ORDER HALF BYTE     S99528
         CLC   UCBAREA,TWO(R6)    COMPARE UNIT NAMES             S99528
         BE    SECOND             IF EQUAL, SET UP SECONDARY IOB S99528
         B     ERROR              IF NOT, ERROR CONDITION        S99528
PRIMARY  EQU   *                                                 S99528
         MVI   SWITCH,OLTCB       INDICATE THAT OLTCB CONTAINS   S99528
*                                   CDS INFORMATION              S99528
PRIMARYA EQU   *                                                 S99528
         OI    TOTFLG07,TOTPRIEX  SET PRIMARY DEVICE FLAG        S99528
         LA    R7,TOTPRIBK        SET UP FOR PRIMARY             S99528
         MVI   IOB,CLEAR          CLEAR OUT                      S99528
         MVC   IOB+ONE(DCB-IOB-ONE),IOB CLEAR IOB FIELD        @OY12988
         OI    IOBFLG4,IOBPRI     INDICATE PRIMARY IOB           S99528
         L     R6,OLTLCBA-ONE     GET ADDRESS OF 3705 LCB        S22024
         ST    R6,LCBADDR         SAVE LCB ADDRESS               S22024
         B     EX110              BRANCH AROUND SECONDARY SET UP S99528
SECOND   EQU   *                                                 S99528
         OI    TOTFLG07,TOTSECEX  SET SECONDARY DEVICE FLAG      S99528
         LA    R7,TOTSCIBK        SET UP FOR SECONDARY           S99528
         MVI   IOB,CLEAR          CLEAR OUT                      S99528
         MVC   IOB+ONE(DCB-IOB-ONE),IOB CLEAR IOB FIELD        @OY12988
         OI    IOBFLG4,IOBSEC     INDICATE SECONDARY IOB         S99528
         L     R6,OLTLCBA-ONE     GET ADDRESS OF3705 LCB         S22024
         ST    R6,LCBADDR         SAVE LCB ADDRESS               S22024
         EJECT
**************************************************************** S99528
*                                                              * S99528
*              STOP LINE ROUTINE                               * S99528
*                                                              * S99528
**************************************************************** S99528
         SPACE 1
EX110    EQU   *                                                 S99528
         TM    $TOTFLG1,$TDATBLK  IS THIS A 3705 EXIO REQUEST?   S22024
         BO    EX3705             YES, BRANCH TO 3705 CODE       S22024
         TM    TOTFLG09,TOTNOBRK+TOTLNCON  ARE NO BREAK AND LINE S22024
*                                            CONNECTION DONE     S22024
*                                            BITS ON?            S22024
         BO    LINECONN           YES, BYPASS STOP LINE          S22024
         MVI   TOTOVBCD,LINESTOP  MOVE IN STOP LINE VERB CODE    S22024
*                                                                S99528
         L     R6,TOTAVTPT        GET ADDRESS OF AVT             S99528
         USING IEDQAVTD,R6                                       S99528
         LA    R10,AVTOPCOB        GET POINTER TO OP CNTRL QCB   S99528
         ST    R10,TOTOKEY        PUT IN PARAMETER LIST          S22024
         MVI   TOTOKEY,OPCKEY     ZERO OUT KEY FIELD             S22024
         DROP  R6                                                S99528
         MVC   TOTORLN,OLTTCRLN   MOVE IN RELATIVE LINE NUMBER   S22024
         SR    R6,R6              CLEAR                        @G36XRUV
         ICM   R6,3,OLTUCBA       GET ADDRESS OF UCB           @G36XRUV
         USING UCB,R6                                            S99528
         MVC   TOTWKSPC(ONE),D19(R6)  GET CONTROL UNIT FIELD     S22024
*                                       FROM UCB                 S22024
         NI    TOTWKSPC,X0F       CLEAR HIGH ORDER NIBBLE        S22024
         CLI   TOTWKSPC,RN3705    IS THIS A 3705 UCB?            S22024
         BE    LINECONN           YES, BYPASS STOPLINE           S22024
         MVI   TOTOLADR,X40       MOVE BLANK INTO NAME FIELD     S22024
         MVC   TOTOLADR+ONE(SEVEN),TOTOLADR  BLANK OUT FIELD     S22024
         MVC   TOTOLADR(THREE),UCBNAME  GET UNIT NAME            S22024
         DROP  R6                                                S99528
         LA    R1,TOTOTECB         GET TOTE ECB                  S99528
         ST    R1,TOTOECBA        PUT IN PARAMETER LIST          S22024
         XC    TOTOLINK(THREE),TOTOLINK  CLEAR REQUEST ELEMENT   S22024
*                                          LINK FIELD            S22024
         MVI   TOTOPRI,OPCPRI     SET OP CONTROL PRIORITY TO DC  S22024
         MVI   TOTORTCD,OPCRTCD   CLEAR RETURN CODE FIELD        S22024
         MVI   TOTOELNG,OPCELNG   SET ELEMENT LENGTH TO X'18'    S22024
         LA    R1,TOTPLIST        GET ADDRESS OF OP CONTROL      S22024
*                                   PARAMETER LIST               S22024
         ST    R1,ELEM1           SAVE IT IN 1ST WORD OF POST    S22024
*                                   LIST                         S22024
         ST    R1,ELEM2           SAVE IT IN SECOND WORD OF      S22024
*                                   SVC 102 POST LIST            S22024
         MVI   ELEM1,CODE         SET SVC 102 START CODE         S22024
         MVI   ELEM2,ENDLIST      SET SVC 102 END CODE           S22024
         LA    R1,SLPL            POINT R1 TO PARAMETER LIST     S22024
         XC    TOTOTECB(FOUR),TOTOTECB CLEAR TOTE ECB            S99528
         AQCTL                     POST ELEMENT TO OPERATOR CNTL S99528
*                                                                S99528
         WAIT  ECB=TOTOTECB                                      S99528
*                                                                S99528
         CLI   TOTORTCD,GOOD      WAS STOP LINE SUCCESSFUL?      S22024
         BE    LINECONN           YES, BRANCH                    S99528
         CLI   TOTORTCD,ALREADY   WAS THE LINE ALREADY STOPPED?  S22024
         BE    LINECONN           YES, STOPLINE SUCCESSFUL       S99528
         LA    R15,FOURTEEN       SET RETURN CODE TO INDICATE    S99528
*                                  LINE CONNECTION FAILED        S99528
         B     EXIT               RETURN TO CALLER               S99528
         EJECT                                                   S99528
**************************************************************** S99528
*                                                              * S99528
*        DETERMINE IF THE LINE NEEDS TO BE ENABLED.  IF THE    * S99528
*        TEST DEVICE IS A LINE, THIS ROUTINE IS BYPASSED. IF   * S99528
*        THE TEST DEVICE IS A TERMINAL, THE LINE IS ENABLED IF * S99528
*        NECESSARY.                                            * S99528
*                                                              * S99528
**************************************************************** S99528
LINECONN EQU   *                                                 S99528
         CLI   SWITCH,OLTCB       IS CDS INFORMATION CONTAINED   S99528
*                                   IN THE OLTCB?                S99528
         BNE   GETCDS             NO, GO GET CDS ADDRESS         S99528
         LA    R9,$PDEVADR        GET STARTING ADDRESS OF CDS    S99528
*                                   INFORMATION IN OLTCB         S99528
         B     TESTCONN           GO,DETERMINE IF CONNECTION     S99528
*                                    IS REQUIRED                 S99528
GETCDS   EQU   *                                                 S99528
         L     R9,XIOCDSA         GET ADDRESS OF CDS             S99528
TESTCONN EQU   *                                                 S99528
         CLI   SIX(R9),X40        IS THE TEST DEVICE A LINE?     S99528
         BE    SETUP              YES, NO LINE CONNECTION      @OY12988
*                                   IS REQUIRED                  S99528
         TM    NINE(R9),X01       NO, IS LINE CONNECTION         S99528
*                                   REQUIRED?                    S99528
         BZ    SETUP              NO, BRANCH
         TM    TOTFLG09,TOTNOBRK+TOTLNCON  ARE NO BREAK AND LINE S22024
*                                            CONNECTION DONE     S22024
*                                            BITS ON?            S22024
         BO    SETUP              YES, BYPASS LINE CONNECTION    S22024
         XC    ECBOLT,ECBOLT           CLEAR ECB                 S99528
         LA    R3,IOB                  GET IOB ADDRESS           S99528
         ST    R3,DCBIOBAD             PUT IN DCB                S99528
         LA    R3,DCB                  GET DCB ADDRESS           S99528
         ST    R3,IOBDCBAD             PUT IN IOB                S99528
         LA    R3,ECBOLT               GET ECB ADDRESS           S99528
         ST    R3,IOBECBAD             PUT IN IOB                S99528
         LA    R3,LCBCPA               GET CCW ADDRESS           S99528
         ST    R3,IOBCCWAD             PUT IN IOB                S99528
         MVI   IOBFLG1,FLAG       SET IOB FLAGS TO DATA CHAINING S99528
*                                  AND UNRELATED ERROR           S99528
         SR    R8,R8              CLEAR                        @G36XRUV
         ICM   R8,3,OLTUCBA       SET UCB ADDRESS              @G36XRUV
         USING UCB,R8             SET UP ADDRESSIBILITY FOR UCB  S99528
         TM    UCBTBYT3,UCB3DISP       DISPLAY?                  S99528
         BO    SETUP              YES, NO LINE CONNECTION        S99528
*                                   REQUIRED                     S99528
         DROP  R8                 DROP UCB BASE                  S99528
*
PAS3     EQU   *
         OI    DCBIFLGS,BYPERPS   BYPASS ERPS                    S99528
         SR    R6,R6              CLEAR                        @G36XRUV
         ICM   R6,3,OLTUCBA            GET UCB ADDRESS         @G36XRUV
*
CPBUILD  EQU   *
*
         L     R15,LCBSIOCC       GET ADDRESS OF CHANNEL COMMAND S99528
*                                   AREA IN LCB                  S99528
         LA    R15,FOUR(R15)      PREPARE TO BUILD SECOND CCW    S99528
         EJECT
***********************************************************************
*                                                                     *
*        BUILD A DIAL COMMAND FOR DIAL LINES                          *
*                                                                     *
***********************************************************************
         USING UCB,R6                                            S99528
         TM    UCBTYP+ONE,SWITCHED     IS THIS A DIAL UCB?       S22024
         BZ    NODIAL                  NO, BRANCH                S22024
         TM    UCBTYP+THREE,TCU2702    IS UCB FOR 2701 OR 2703?  S22024
         BNO   NODIAL                  NO, GO GET SAD COMMAND    S22024
*                                        FOR 2702                S22024
*
*
*
DIALBLD  EQU   *
*
         TM    UCBTYP+THREE,SDAII    SDA II?                     S99528
         BO    SETBISCP                YES BR                    S99528
         BAL   R8,GETDIGTS             GO SEARCH TTE FOR DIAL DIGS99528
         SR    R6,R6              CLEAR                        @G36XRUV
         ICM   R6,3,OLTUCBA       GET UCB ADDRESS              @G36XRUV
         L     R8,DIALADDR             ADDRESS OF DIAL DIGEST    S99528
         MVC   ELEVEN(ONE,R15),ZERO(R8) PUT NUMBER IN CCW        S99528
         LA    R8,ONE(R8)         BUMP PAST NO OF DIGITS         S99528
         ST    R8,FOUR(R15)       STORE IN CCW                   S99528
         MVC   EIGHT(ONE,R15),SILI  SET SILI BIT                 S99528
         MVI   FOUR(R15),DIALCMD  PUT DIAL COMMAND INTO CCW      S99528
         B     STARTLIN           GO START LINE
         EJECT
***********************************************************************
*                                                                     *
*        IF 2702 SET UP CORRECT SAD COMMAND                           *
*                                                                     *
***********************************************************************
NODIAL   EQU   *                                                 S99528
         TM    UCBTYP+THREE,TCU2702  2702 TCU?                   S99528
         BO    NOT2702                 BRANCH IF NOT 2702        S99528
         IC    R3,UCBTYP+ONE           GET FEATURE BYTE FROM UCB S99528
         N     R3,ANDMASK         CLEAR UNWANTED BITS
         IC    R3,SADCODE(R3)     INSERT ACTUAL SAD COMMAND
         STC   R3,FOUR(R15)       STORE IN CPA                   S99528
         MVC   EIGHT(FOUR,R15),NOP BUILD REST OF COMMAND         S99528
         LA    R15,EIGHT(R15)     BUMP POINTER TO NEXT CCW       S99528
         TM    UCBTYP+ONE,SWITCHED  IS UCB FOR A DIAL LINE       S22024
         BZ    NOT2702            NO, BRANCH EVEN THOUGH A 2702  S22024
         OI    ZERO(R15),CCSLI    TURN ON CC AND SLI IN PREVIOUS S99528
*                                  CCW                           S99528
         B     DIALBLD            EXIT TO BUILD DIAL CCW
         EJECT
***********************************************************************
*                                                                     *
*        SET CORRECT COMMANDS FOR 2701 AND 2703                       *
*                                                                     *
***********************************************************************
NOT2702  EQU   *
*
         CLI   UCBTYP+THREE,TYPEIII  TEST FOR 2701 WITH IBM III  S22024
         BNE   ENABLE0            NO, CONTINUE LINE CONNECTION   S22024
         LA    R15,GOOD           LINE ALREADY CONDITION         S99528
         B     SETUP              BRANCH, NO LINE CONNECTION REQUIRED
ENABLE0  EQU   *
         TM    UCBTYP+THREE,SDAII SDA II                         S99528
         BO    SETBISCP                YES BRANCH                S99528
*
*        BUILD AN ENABLE COMMAND IF NOT A DIAL
*
ENABLEA  EQU   *
*
         MVC   FOUR(ONE,R15),ENABLE  SET COMMAND CODE FOR ENABLE S99528
         MVC   EIGHT(FOUR,R15),NOP  SET UP REST OF CCW           S99528
         OI    ZERO(R15),CCSLI    TURN ON CC AND SLI             S99528
         B     STARTLIN           EXIT TO ENABLE LINE            S99528
*
TSTRESTR EQU   *
*
* BUILD CHANNEL PGM FOR BI-SYNC DEVICE
         BAL   R8,GETDIGTS        GO SEARCH TTE FOR DIAL DIGITS  S99528
         SR    R6,R6              CLEAR                        @G36XRUV
         ICM   R6,3,OLTUCBA       GET UCB ADDRESS              @G36XRUV
         L     R8,DIALADDR        ADDRESS IF DIAL DIGITS         S99528
         MVC   ELEVEN(ONE,R15),ZERO(R8)  PUT NUMBER IN CCW       S99528
         LA    R8,ONE(R8)         BUMP PAST NO OF DIGITS         S99528
         OI    EIGHT(R15),SLI     TURN ON SLI IN THIS CCW        S99528
         OI    ZERO(R15),CCSLI    TURN ON CC AND SLI IN PRIOR CCWS99528
         ST    R8,FOUR(R15)       PUT ADDR IN CCW                S99528
         MVI   FOUR(R15),DIALCMD  PUT DIAL COMMAND IN CCW        S99528
         B     STARTLIN           EXIT TO ENABLE LINE            S99528
         EJECT
***********************************************************************
*                                                                     *
*        THIS ROUTINE BUILDS THE CHANNEL PROGRAM FOR A                *
*        BINARY SYNCHRONOUS DEVICE                                    *
*                                                                     *
***********************************************************************
SETBISCP EQU   *
         L     R3,OLTRLTNT        GET ADDRESS OF TERMNAME TABLE  S99528
*                                   ENTRY                        S99528
         SR    R10,R10            CLEAR REGISTER 10
         IC    R10,TOTTTBEL       GET NAME LENGTH                S99528
         AR    R10,R3             GET ADDRESS OF TERMINAL ENTRY  S99528
         MVC   TNTENTRY+ONE(THREE),ZERO(R10) MOVE ADDRESS TO     S99528
*                                              PROPER BOUNDARY   S99528
         L     R8,TNTENTRY        GET ADDR OF TERM TABLE ENTRY
         L     R8,ZERO(R8)        GET QCB ADDRESS                S99528
         SR    R9,R9              CLEAR REGISTER 9               S99528
         IC    R9,THIRTY2(R8)     GET RLN                        S99528
         SLL   R9,2               MULTIPLY BY 4                  S99528
         L     R8,THIRTY2(R8)     GET DCB ADDRESS                S99528
         LA    R3,X'38'(R9,R8)    GET ADDR OF SETMODE BYTE
         L     R8,OLTUCBA         GET UCB ADDRESS                S99528
*
SETMODEA EQU   *                                                 S99528
*
         ST    R3,FOUR(R15)       PUT ADDRESS OF MODE BYTE IN CCWS99528
         MVC   FOUR(ONE,R15),SETMODE PUT IN SET MODE COMMAND     S99528
         MVC   EIGHT(FOUR,R15),NOP  BUILD REST OF CCW            S99528
         OI    ZERO(R15),CMMDCH   TURN ON COMMAND CHAIN          S99528
         LA    R15,EIGHT(R15)     INCREMENT CPA POINTER          S99528
         MVC   FOUR(ONE,R15),ENABLE  SET COMMAND CODE FOR ENABLE S99528
         MVC   EIGHT(FOUR,R15),NOP  SET UP REST OF CCW           S99528
         OI    ZERO(R15),CCSLI    TURN ON CC AND SLI             S99528
         TM    UCBTYP+ONE,SWITCHED     SWITCHED DEVICE?         SA64784
         BNZ   TSTRESTR                YES, BRANCH              SA64784
         B     STARTLIN           EXIT TO ENABLE LINE
*
         EJECT
**************************************************************** S22024
*                                                              * S22024
*        ISSUE EXCP TO ESTABLISH LINE CONNECTION WITH THE      * S22024
*        TEST DEVICE                                           * S22024
*                                                              * S22024
**************************************************************** S22024
         SPACE 2
*
EXCP     EQU   *
*
         LA    R10,THREE                                         S99528
         TM    UCBTYP+ONE,SDAII   SET LOOP COUNT                 S99528
         BZ    NORMX                   SWITCHED?                 S99528
         TM    UCBTYP+ONE,AUTOCALL DOES UCB INDICATE AUTOCALL?   S22024
         BO    NORMX              YES, BRANCH                    S22024
         MVI   FOUR(R15),ENABLCMD CHANGE COMMAND FROM DIAL TO    S22024
*                                   ENABLE                       S22024
         MVC   DIALLINE(THREE),UCBNAME  MOVE LINE NAME INTO MSG  S22024
         L     R8,DIALADDR        GET ADDRESS OF DIAL DIGITS     S22024
         SR    R3,R3              CLEAR REGISTER 3               S22024
         IC    R3,ZERO(R8)        GET NUMBER OF DIAL DIGITS      S22024
         LTR   R3,R3              ARE THERE ANY DIAL DIGITS?    SA64784
         BZ    DIALMSG            NO, GO ISSUE MSG WITHOUT DIAL SA64784
*                                   DIGITS                      SA64784
EBCDIC   EQU   *                                                 S22024
         LA    R8,ONE(R8)         BUMP TO NEXT DIAL DIGIT        S22024
         OI    ZERO(R8),XF0       CONVERT DIGIT TO EBCDIC        S22024
         BCT   R3,EBCDIC          GO CONVERT NEXT DIGIT          S22024
         L     R8,DIALADDR        GET ADDR OF START OF DIAL DIGITS22024
         IC    R3,ZERO(R8)        GET NUMBER OF DIAL DIGITS      S22024
         BCT   R3,MOVEDIG         DECREMENT COUNT FOR EXECUTE    S22024
MOVEDIG  EQU   *                                                 S22024
         EX    R3,MOVEDIAL        MOVE DIAL DIGITS INTO MESSAGE  S22024
DIALMSG  WTO   'IED158A     DIAL                     '  MANUAL   S22024
*                                                       DIAL MSG S22024
DIALLINE EQU   DIALMSG+16         LINE FOR MANUAL DIAL           S22024
DIALNUM  EQU   DIALMSG+25         DIAL DIGITS FOR MANUAL DIAL    S22024
*
NORMX    EQU   *
         EXCP  IOB                     ENABLE                    S99528
         WAIT  ECB=ECBOLT              WAIT FOR COMPLEATION      S99528
*
         CLI   ECBOLT,NORMAL      NORMAL COMPLETION?             S99528
         BE    EXCPOK             YES
         XC    ECBOLT(FOUR),ECBOLT   CLEAR ECB                   S99528
         XC    IOBSNS(TWO),IOBSNS CLEAR SENSE BYTES IN IOB       S99528
         XC    IOBCSW(EIGHT),IOBCSW   CLEAR CHANNEL STATUS WORD  S99528
         BCT   R10,NORMX               RETRY OPERATION           S99528
         LA    R15,FOURTEEN       SET RETURN CODE INDICATING     S99528
*                                   LINE CONNECTION FAILED       S99528
         B     EXIT               GET OUT                        S99528
EXCPOK   EQU   *
*
         OI    TOTFLG09,TOTLNCON  SET LINE CONNECTION DONE BIT   S22024
         BR    R9                 RETURN
*
MOVEDIAL MVC   DIALNUM(ZERO),ONE(R8)   MOVE DIAL DIGITS INTO     S22024
*                                        MANUAL DIAL MESSAGE     S22024
         EJECT
***********************************************************************
*                                                                     *
*       THIS ROUTINE FINDS DIAL DIGITS FOR AUTO CALL LINES            *
*                                                                     *
***********************************************************************
GETDIGTS L     R1,OLTRLTNT             GET REAL TNT ENTRY        S99528
         SR    R10,R10            CLEAR REGISTER 10              S99528
         IC    R10,TOTTTBEL       GET NAME LENGTH                S99528
         AR    R10,R1             GET TTE ADDRESS                S99528
         MVC   ALINETTE+ONE(THREE),ZERO(R10)  MOVE ADDRESS TO    S99528
*                                             BOUNDARY           S99528
         L     R10,ALINETTE       GET TTE ADDRESS                S99528
         USING IEDQTRM,R10        ESTABLISH ADDRESSIBILITY FOR   S99528
*                                   TERMINAL TABLE ENTRY         S99528
         TM    TRMDEVFL,DIAL           DIAL DIGITS PRESENT?      S99528
         BNO   NODIALL                 NO DIGITS BRANCH          S99528
         TM    TRMSTATE,TSG            GROUP,SINGLE OR TERMINAL ?S99528
         BM    NODIALL                 NEITHER BRANCH            S99528
         L     R1,ALINETTE             GET TTE ADDRESS           S99528
         TM    TRMSTATE,TRMOPTFN       OPTION FIELD PRESENT?     S99528
         BO    ADDOPTS                 YES BRANCH                S99528
         AH    R1,NOOPT                POINT PAST OPTIONS        S99528
         B     DEVDEP                  BRANCH AROUND ADDOPTIONS  S99528
ADDOPTS  AH    R1,OPTIONS              POINT PAST OPTIONS        S99528
         SR    R6,R6                   CLEAR R6                  S99528
         IC    R6,TRMOPNO              GET # OF OPTION BYTES     S99528
         AR    R1,R6                                             S99528
DEVDEP   EQU   *                                                 S99528
         TM    TRMDEVFL,BUFSIZE        BUFFER SIZE DEV DEPENDENT S99528
         BNO   DIALDIGT                NO BRANCH                 S99528
         IC    R6,TRMOPT               GET LENGTH OF BUFSIZE FIELS99528
         AR    R1,R6                   BUMP AROUND BUFSIZE FIELD S99528
DIALDIGT EQU   *                                                 S99528
         ST    R1,DIALADDR             SAVE ADDRESS OF DIAL DIGITS99528
         B     ZERO(R8)           RETURN                         S99528
NODIALL  EQU   *                                                 S99528
         LA    R15,FOURTEEN       INSERT RETURN CODE TO INDICATE S99528
*                                   LINE CONNECTION FAILED       S99528
*                                  NO DIAL DIGITS OR INVALID     S99528
         B     EXIT               GET OUT                        S99528
         DROP  R10                DROP TERMINAL TABLE ENTRY BASE S99528
         EJECT
***********************************************************************
*                                                                     *
*        ISSUE EXCP FOR LINE ENABLING                                 *
*                                                                     *
***********************************************************************
STARTLIN EQU   *
*
         BAL   R9,EXCP            GO ENABLE LINE
         EJECT
***********************************************************************
*                                                                     *
*        EXECUTE THE CHANNEL PROGRAM PASSED BY THE OLT                *
*                                                                     *
***********************************************************************
         SPACE 2
SETUP    EQU   *                                                 S99528
         L     R5,XIOTECBA        GET TECB ADDRESS AND STORE IT  S99528
         LTR   R5,R5              IS THE TECB ADDRESS GIVEN?     S99528
         BZ    ERROR              NO, BRANCH TO ERROR EXIT       S99528
         ST    R5,TECBADDR         IN THE IOBLOCKS FIELD         S99528
*
         XC    ECBOLT(FOUR),ECBOLT  CLEAR ECB
*
*        CLEAR I/O BLOCK & SET IT UP FOR EXCP
*
         MVI   IOB,CLEAR          CLEAR OUT THE
         MVC   IOB+ONE(DCB-IOB),IOB IOB
         SPACE 2
**************************************************************** S99528
*                                                              * S99528
*        SET UP IOB IF ATTENTION INTERRUPT IS EXPECTED         * S99528
*                                                              * S99528
**************************************************************** S99528
         SPACE 1
         TM    XIOFLAG,ATTNIN     IS AN ATTENTION INTERRUPT      S99528
*                                   EXPECTED?                    S99528
         BZ    SETBIT             NO, BYPASS SET UP              S99528
         L     R5,XIOCCWA         GET ADDRESS OF CCW'S           S99528
         SR    R6,R6              CLEAR REG 6                    S99528
         IC    R6,XIOCCWC         INSERT CCW COUNT               S99528
LOOP00   EQU   *                                                 S99528
         CLI   ZERO(R5),NOOP      IS IT A NO-OP?                 S99528
         BE    LOOP01             YES, GO BRANCH                 S99528
         CLI   ZERO(R5),TIC       NO, IS IT A TIC?               S99528
         BNE   LOOP03             NO, GO BRANCH                  S99528
         LA    R5,ZERO(R5)        YES, A TIC - GET NEXT CCW      S99528
LOOP04   EQU   *                                                 S99528
         BCT   R6,LOOP00          DECREMENT CCW COUNT            S99528
         B     ERROR              WAS THAT THE LAST CCW?         S99528
*                                 IF YES, ERROR CONDITION        S99528
LOOP01   EQU   *                                                 S99528
         BCT   R6,LOOP02          DECREMENT CCW COUNT            S99528
LOOP02   EQU   *                                                 S99528
         DS    0H                 NO-OP WAS FOUND BUT,           S99528
         LTR   R6,R6              IS IT THE LAST CCW?            S99528
         BZ    LOOPEND            YES, ALL IS OK                 S99528
*                                                                S99528
LOOP03   EQU   *                                                 S99528
         LA    R5,EIGHT(R5)       BUMP TO NEXT CCW               S99528
         B     LOOP04             LOOP TO SEARCH AGAIN           S99528
*                                                                S99528
LOOPEND  EQU   *                                                 S99528
         OI    IOBFLG4,IOBATTN    SET BIT IN IOB INDICATING THAT S99528
*                                    AN ATTENTION IS EXPECTED    S99528
         SPACE 2
SETBIT   EQU   *                                                 S99528
*
         TM    TOTFLG07,TOTPRIEX  IS THE TEST DEVICE PRIMARY?    S99528
         BZ    SECOND1            NO, CHECK FOR SECONDARY        S99528
         OI    IOBFLG4,IOBPRI     YES, INDICATE PRIMARY IOB      S99528
         B     PRIIOB             BYPASS SECONDARY SETUP         S99528
SECOND1  EQU   *                                                 S99528
         OI    IOBFLG4,IOBSEC     INDICATE SECONDARY IOB         S99528
PRIIOB   EQU   *                                                 S99528
         OI    IOBFLG1,UNREL      SET UNRELATED FLAG
         OI    IOBRSTAD,XFF       PUT X'FFFFFF'
         MVC   IOBRSTAD+ONE(TWO),IOBRSTAD  IN RESTART ADDRESS
*
         SR    R10,R10            CLEAR R10
         IC    R10,XIOCCWC        GET NUMBER OF CCW'S            S99528
         SPACE 1
         L     R8,XIOCCWA         GET CHANNEL PROGRAM ADDRESS    S99528
         ST    R8,IOBCCWAD         AND STORE IT IN IOBLOCKS      S99528
*
XIO003   EQU   *                                                 S22024
         CLI   ZERO(R8),CCWTIC    IS IT TRANSFER IN CHANNEL?
         BNE   XIO004               NO
         L     R8,ZERO(R8)          YES, GET TIC ADDRESS
         B     XIO007             GO PREPARE TO ISSUE EXCP
*
XIO004   EQU   *
         TM    FOUR(R8),CHAINDAT  IS DATA CHAINING SET IN CCW?
         BZ    XIO005               NO
         OI    IOBFLG1,CHAINDAT     YES: SET IOB DATA CHAINING FLAG
*
XIO005   EQU   *
         TM    FOUR(R8),CHAINCMD  IS COMMAND CHAINING SET IN CCW?
         BZ    XIO006               NO
         OI    IOBFLG1,CHAINCMD     YES: SET IOB COMMAND CHAINING FLAG
*
XIO006   EQU   *
         LA    R8,EIGHT(R8)       GET NEXT CCW
*
XIO007   EQU   *
         BCT   R10,XIO003         LOOP UNTIL LAST CCW IS CHECKED
*
*        SET UP DCB FOR EXCP
*
         OI    DCBIFLGS,BYPERPS   SET DCB FLAGS TO BYPASS ERPS
         NI    DCBIFLGS,XFF-PERMERR  CLEAR PERMANENT ERROR FLAGS
*
         LA    R3,IOB             GET ADDRESS OF IOB             S99528
         ST    R3,DCBIOBAD        STORE ADDRESS IN DCB           S99528
         LA    R3,DCB             GET ADDRESS OF DCB             S99528
         ST    R3,IOBDCBAD        STORE ADDRESS IN IOB           S99528
         LA    R3,ECBOLT          GET ADDRESS OF ECB             S99528
         ST    R3,IOBECBAD        STORE ADDRESS IN IOB           S99528
*
XIO002A  EQU   *
*
         LA    R1,IOB             PUT IOB ADDRESS IN R1
*
         EXCP  (1)                ISSUE EXCP
*
         TM    XIOFLAG,SENSENO    WAS SENSE=NO SPECIFIED?        S99528
         BNO   GOODRET            NO, GO SET GOOD RETURN CODE    S99528
         LA    R15,TEN            SET RETURN CODE INDICATING     S99528
*                                   THAT EXIO WAS EXECUTED BUT   S99528
*                                   SENSE BYPASS NOT AVAILABLE   S99528
         B     EXIT               RETURN TO CALLER               S99528
         EJECT
**************************************************************** S22024
*                                                              * S22024
*        THIS ROUTINE HANDLES AN EXIO REQUEST FOR A TERMINAL   * S22024
*        OR LINE ON A 3705.                                    * S22024
*                                                              * S22024
**************************************************************** S22024
         SPACE 2
EX3705   EQU   *                                                 S22024
         L     R5,XIOCCWA         GET ADDRESS OF CCW CHAIN       S22024
         USING CCW,R5             ESTABLISH ADDRESSIBILITY       S22024
*                                  FOR CCW                       S22024
         ST    R5,OLTCCWA         SAVE ADDR OF FIRST CCW       @Y17XAUQ
         CLI   CCWCMD,READ        IS THIS A READ CCW?            S22024
         BNE   WRITECCW           NO, GO CHECK FOR WRITE CCW     S22024
         B     GOODRET            GO SET GOOD RETURN CODE & EXIT S22024
WRITECCW EQU   *                  ESTABLISH BRANCH POINT       @Y17XAUQ
         CLI   CCWCMD,RSRESET     IS IT A RESTART RESET        @Y17XAUQ
         BNE   ERROR              NO: A BAD CCW STRING         @Y17XAUQ
BUMPCCW  LA    R5,CCWLNGTH(R5)    YES: BUMP TO NEXT CCW        @Y17XAUQ
         CLI   CCWCMD,RDSTART0    IS IT A READ START0          @Y17XAUQ
         BE    BUMPCCW            YES, BUMP OVER               @Y17XAUQ
         CLI   CCWCMD,WRSTART0    IS IT A WRITE START0         @Y17XAUQ
         BE    BUMPCCW            YES, BUMP OVER               @Y17XAUQ
         ST    R5,OLTCCWA         SAVE ADDR OF THIS CCW        @Y17XAUQ
         CLI   CCWCMD,READ        IS IT A READ CCW             @Y17XAUQ
         BE    GOODRET            YES, SET GOOD RETURN & EXIT  @Y17XAUQ
         CLI   CCWCMD,WRITE       IS IT A WRITE CCW            @Y17XAUQ
         BE    EX3705A            YES - CONTINUE               @Y17XAUQ
         CLI   CCWCMD,WRITEBK     IS IT A WRITE BREAK          @YM07991
         BNE   ERROR              NO - ERROR                   @YM07991
         EJECT
**************************************************************** S22024
*                                                              * S22024
*        THE FOLLOWING CODE HANDLES THE REQUEST FOR A BUFFER   * S22024
*        FROM THE TCAM BUFFER UNIT POOL.  THE ERB IS BUILT AND * S22024
*        POSTED TO THE BUFFER REQUEST QCB VIA SVC 102.         * S22024
*                                                              * S22024
**************************************************************** S22024
         SPACE 2
EX3705A  EQU   *                                                 S22024
         BAL   R8,RSIDCHK         GO VERIFY RSID IN BTU          S22024
         LA    R12,TOTWKSPC       GET ADDRESS OF WORKSPACE       S22024
         USING DUMMYLCB,R12                                      S22024
         MVI   ERBSTAT,X02        STATUS OF ERB SET TO THAT OF   S22024
*                                  AN APPLICATION PROGRAM        S22024
         XC    ERBCHAIN(THREE),ERBCHAIN  ERBCHAIN IS ZEROED OUT  S22024
*                                        BEFORE REQUEST IS POSTEDS22024
         MVI   ERBCNT1,ONE         ONLY 1 BUFFER IS REQUESTED    S22024
         L     R3,TOTAVTPT        GET AVT ADDRESS                S22024
         USING IEDQAVTD,R3        ESTABLISH ADDRESSIBILITY       S22024
         SR    R8,R8              CLEAR REGISTER 8               S22024
         LA    R8,AVTHDRSZ        GET SIZE OF HEADER PREFIX    @Y17XAUQ
         STH   R8,PRFXSIZE        SAVE IT FOR CCW BUFFER TO    @YM08005
*                                 TCAM BUFFER MOVE             @Y17XAUQ
         LH    R8,AVTKEYLE        GET UNIT SIZE FROM AVT         S22024
         STH   R8,UNITSIZE        STORE UNIT SIZE                S22024
         L     R6,AVTDELAD        GET DUMMY ELEMENT ADDRESS      S22024
         ST    R6,ELCHNQCB-ONE    PLACE DUMMY ELEMENT IN FIRST   S22024
*                                  WORD OF QCB                   S22024
         LA    R6,AVTBFREB        GET ADDRESS OF BUFFER REQUEST  S22024
*                                  QCB                           S22024
         ST    R6,ERBQCB-ONE      ADDRESS OF BUFFER REQUEST QCB  S22024
*                                  IS PUT IN 1ST WORD OF ERB     S22024
         DROP  R3                 DROP AVT                       S22024
         L     R6,OLTCCWA         GET FIRST WRITE CCW          @YM08005
         L     R6,ZERO(R6)        GET @ OF DATA TO LOOK AT THE
*                                 TRANSMISSION HEADER(TH)      @YM08005
         USING OLLTFID1,R6                                     @YM08005
         SLR   R9,R9              CLEAR REG                    @YM08005
         ICM   R9,3,OLLTDCF       GET DATA COUNT FIELD FROM THE
*                                 THE TH                       @YM08005
         AH    R9,PRFXSIZE        BUMP COUNT BY PREFIX SIZE    @YM08005
         LA    R3,OLLTRHLG        GET LENGTH OF RH             @YM08005
         SR    R9,R3              DECREMENT NEEDED SIZE        @YM08005
         STH   R9,BUFDATLN        SAVE DATA COUNT FOR BUF PREFIX
*                                 BETWEEN CUA AND BTU TOTAL
*                                 SIZE                         @YM08005
         DROP  R6                                              @YM08005
         SR    R8,R8              CLEAR REGISTER 8               S22024
         LH    R10,UNITSIZE       GET SIZE OF UNIT               S22024
         DR    R8,R10             DETERMINE NUMBER OF UNITS      S22024
*                                  NEEDED                        S22024
         AH    R9,ONEMORE         ADD ONE TO REQUESTED UNITS     S22024
         STC   R9,ERBCNT2         PUT REQUIRED NUMBER OF UNITS   S22024
*                                  INTO ERB                      S22024
         STC   R9,UNITUSED        SAVE # OF UNITS IN THIS BUF  @Y17XAUQ
         MVI   QCB0SFLG,X02       QCB IDENTIFICATION BYTE        S22024
         LA    R9,DUMQCB          GET ADDRESS OF DUMMY QCB TO    S22024
*                                  WHICH BUFFER IS POSTED        S22024
         ST    R9,RCQCBLCB        STORE QCB ADDRESS IN LCB       S22024
         ST    R9,QCBPTR          LAST WORD OF QCB POINTS TO     S22024
*                                  FIRST WORD OF DUMMY QCB       S22024
         XC    STAT1LCB(TWO),STAT1LCB  CLEAR LCB STATUS BYTES    S22024
         MVI   ERBPRI,BRPRI       SET ERB PRIORITY TO X'E4'      S22024
         LA    R1,ERBLCB          GET ADDRESS OF ERB             S22024
         ST    R1,ELPT1-ONE       ADDRESS OF ERB PUT IN PARM LISTS22024
         ST    R1,ELPT2-ONE       ADDRESS OF ERB PUT IN PARM LISTS22024
         MVI   ACTCODE,CODE       SET ACTION CODE IN PARM LIST   S22024
         MVI   LASTWD,ENDLIST     INDICATE LAST WORD OF PARM LISTS22024
         LA    R1,PARMLIST        PLACE ADDRESS OF SVC 102'S PARMS22024
*                                  LIST INTO REG 1               S22024
         XC    ECBO(FOUR),ECBO    CLEAR ECB                      S22024
         AQCTL                    ISSUE SVC 102                  S22024
         WAIT  ECB=ECBO           WAIT FOR BUFFER TO BE RETURNED S22024
         SPACE 2
*        THE FOLLOWING CODE INITIALIZES THE SCB                * S22024
         SPACE 2
         LA    R6,SCB             GET SCB ADDRESS                S22024
         ST    R6,SCBALCB-ONE     PUT SCB ADDRESS INTO LCB       S22024
         XC    STATESCB(ONE),STATESCB  CLEAR SCB STATUS BYTE     S22024
         MVC   DESTQSCB(THREE),OLTQCBA  PUT QCB ADDRESS INTO SCB S22024
         EJECT
**************************************************************** S22024
*                                                              * S22024
*        THE FOLLOWING CODE MOVES THE DATA FROM THE CCW CHAIN  * S22024
*        INTO THE BUFFER UNITS                                 * S22024
*                                                              * S22024
**************************************************************** S22024
         SPACE 2
         L     R3,ERBCHAIN-ONE    GET STARTING ADDRESS OF BUFFER S22024
         LA    R6,TWELVE(R3)      GET ADDRESS OF FIRST BYTE      S22024
*                                   IN BUFFER                    S22024
         AH    R6,PRFXSIZE        LEAVE SPACE FOR PREFIX       @Y17XAUN
         LH    R8,UNITSIZE        GET SIZE OF BUFFER UNIT      @Y17XAUQ
         SH    R8,PRFXSIZE        DECREMENT SPACE USED FOR PFX @Y17XAUQ
         L     R7,CCWADDR-ONE     GET ADDRESS OF DATA TO BE MOVEDS22024
         LH    R9,CCWCOUNT        GET NUMBER OF BYTES TO BE MOVEDS22024
*                                  INTO BUFFER                   S22024
         SR    R3,R3              CLEAR REG                    @Y17XAUQ
         LA    R3,OLLTRHLG+OLLTTHLG GET LENGTH OF TH/RH        @YM08055
         SR    R9,R3              SUBTRACT IT FROM COUNT       @Y17XAUQ
         AR    R7,R3              BUMP DATA POINTER OVER RH    @Y17XAUQ
EX370510 EQU   *                                               @Y17XAUU
         L     R3,ERBCHAIN-ONE    RESTORE REG                  @Y17XAUQ
         CR    R8,R9              IS UNIT SIZE GREATER THAN DATA S22024
*                                  SIZE IN CCW?                  S22024
         BL    EX370560           NO,BRANCH                      S22024
EX370530 EQU   *                                                 S22024
         BCTR  R9,ZERO            DECREMENT COUNT BY ONE         S22024
         EX    R9,MOVE            GO MOVE DATA INTO BUFFER       S22024
         LA    R9,ONE(R9)         RESTORE COUNT                  S22024
         SR    R8,R9              GET NUMBER OF BYTES LEFT       S22024
*                                  IN UNIT                       S22024
         LTR   R8,R8              WAS UNIT SIZE=DATA SIZE?       S22024
         BZ    EX370540           YES, GO GET ADDRESS OF NEXT    S22024
*                                  UNIT                          S22024
         LA    R6,ZERO(R9,R6)     CALCULATE ADDRESS OF NEXT BYTE S22024
*                                  IN BUFFER TO HAVE DATA        S22024
*                                  INSERTED                      S22024
         B     EX370550           BRANCH AROUND UNIT SET UP      S22024
EX370540 EQU   *                                                 S22024
         L     R3,EIGHT(R3)       GET ADDRESS OF NEXT UNIT       S22024
         LA    R6,TWELVE(R3)      GET ADDRESS OF BYTE IN BUFFER  S22024
*                                  TO HAVE NEXT INSERTED BYTE    S22024
EX370550 EQU   *                                                 S22024
         TM    CCWFLAG,DC         IS CCW DATA CHAINED?           S22024
         BNO   EX370570           NO, END OF WRITE DATA          S22024
         LA    R5,EIGHT(R5)       GET ADDRESS OF NEXT CCW        S22024
         CLI   CCWCMD,TIC         IS IT A TIC CCW?               S22024
         BE    EX370555           YES , PROCESS NEXT CCW       @Y17XAUU
         L     R7,CCWADDR-ONE     GET ADDRESS OF NEXT CCW      @Y17XAUU
         LH    R9,CCWCOUNT        GET DATA BYTE COUNT          @Y17XAUU
         B     EX370510           GO MOVE DATA                 @Y17XAUU
EX370555 EQU   *                                               @Y17XAUU
         L     R5,CCWADDR-ONE     YES,GET ADDRESS OF NEXT CCW    S22024
         L     R7,CCWADDR-ONE     GET CCW ADDRESSS             @Y17XAUU
         LH    R9,CCWCOUNT        GET DATA BYTE COUNT          @Y17XAUU
         B     EX370510           GO MOVE DATA                   S22024
EX370560 EQU   *                                                 S22024
         BCTR  R8,ZERO            DECREMENT UNIT COUNT BY ONE    S22024
         EX    R8,MOVE            GO MOVE DATA INTO BUFFER       S22024
         LA    R8,ONE(R8)         RESTORE BYTE COUNT             S22024
         SR    R9,R8              GET NUMBER OF BYTES LEFT TO    S22024
*                                  BE MOVED                      S22024
         L     R3,EIGHT(R3)       GET ADDRESS OF NEXT UNIT       S22024
         LA    R6,TWELVE(R3)      GET ADDRESS OF BYTE IN BUFFER  S22024
*                                  TO MOVE NEXT INSERTED BYTE    S22024
         LA    R7,ZERO(R8,R7)     GET STARTING ADDRESS OF NEXT   S22024
*                                  BYTE TO BE MOVED              S22024
         LH    R8,UNITSIZE        GET UNIT SIZE                  S22024
         CR    R8,R9              CAN REMAINING CCW COUNT FIT    S22024
*                                  INTO ONE BUFFER UNIT          S22024
         BL    EX370560           NO, GO MOVE DATA INTO UNIT     S22024
         B     EX370530           YES,GO MOVE DATA INTO BUFFER   S22024
         EJECT
**************************************************************** S22024
*                                                              * S22024
*        THE FOLLOWING SECTION OF CODE POSTS THE BUFFER        * S22024
*        DIRECTLY TO THE SSCP MESSAGE HANDLER (OUTPUT SIDE) *  @Y17XAUQ
*        AFTER BUILDING THE PROPER PREFIX AND NEGATIVE      *  @Y17XAUQ
*        PREFIX TO THE BUFFER                               *  @Y17XAUQ
*                                                           *  @Y17XAUQ
*                                                              * S22024
**************************************************************** S22024
         SPACE 2
EX370570 EQU   *                                                 S22024
         L     R3,ERBCHAIN-ONE    GET ADDRESS OF FIRST BUFFER    S22024
*                                  UNIT                          S22024
         USING IEDQPRF,R3         ESTABLISH ADDRESSABILITY TO  @Y17XAUQ
*                                 BUFFER PREFIX                @Y17XAUQ
         L     R5,TOTAVTPT        GET POINTER TO AVT           @Y17XAUQ
         USING IEDQAVTD,R5        ESTABLISH ADDRESSABILITY     @Y17XAUQ
         L     R5,AVTSAVTP        GET ADDR OF SAVT             @Y17XAUQ
         DROP  R5                 FREE REG                     @Y17XAUQ
         USING IEDNSVTD,R5        ESTAB ADDRABILITY TO SAVT    @Y17XAUQ
         LA    R8,SAVTSCPQ        GET SSCP OUTBOUND QUEUE      @Y17XAUN
         ST    R8,PRFQCBA-ONE     STORE IN UCA FOR LATER POST  @Y17XAUQ
         SR    R8,R8              CLEAR REG                    @Y17XAUQ
         LA    R1,REQELMNT        GET ADDR OF REQ ELEMENT FIELD@Y17XAUQ
         STCM  R1,7,PRFLINK       PUT ELEMENT ADDR IN LINK FELD@Y17XAUQ
         MVI   PRFPRI,PRIDESTQ    SET DESTINATION QUEUE PRTY   @Y17XAUQ
         MVC   PRFNBUNT,UNITUSED  SET # OF UNITS IN THIS BUF   @Y17XAUQ
         STCM  R8,7,PRFLCB        CLEAR POINTER TO LCB         @Y17XAUQ
         LH    R8,SAVTSCPT        USE SSCP TTCIN AS ORIGIN     @Y17XAUQ
         STH   R8,PRFSRCE         SOURCE NOW INDICATES SSCP    @Y17XAUQ
         LH    R8,BUFDATLN        GET SAVED OLLT/OLTT DATASIZE @Y17XAUQ
         STH   R8,PRFSIZE         STORE IT IN PREFIX           @Y17XAUQ
         XC    PRFISIZE,PRFISIZE  ZERO OUT # OF RESERVES       @Y17XAUQ
         NI    PRFSTAT1,PRFNLSTF  MARK BUFFER LAST AND         @Y17XAUQ
         NI    PRFSTAT1,PRFNHDRF  MARK BUFFER HEADER           @Y17XAUQ
         MVC   PRFDEST,TGDAFHAR   MOVE TARGET DAF INTO DEST    @Y17XAUQ
         NC    PRFDEST,SAVTSUBM   MASK OFF ALL BUT SUBAREA     @Y17XAUQ
*                                 USING SUBAREA MASK IN SAVT   @Y17XAUQ
         LH    R1,PRFDEST         LOAD NA OF NCP PS INTO REG   @Y17XAUQ
         L     R15,SAVTNAX        GET @ OF NA TO TTCIN CONVERS @Y17XAUQ
         BALR  R14,R15            GO CONVERT NA TO TTCIN       @Y17XAUQ
         LTR   R15,R15            IS CONVERT GOOD              @Y17XAUQ
         BZ    RSIDCHK0           NO EXIT                      @Y17XAUQ
         STH   R15,PRFDEST        PUT NCP PS DEST IN PREFIX    @YM08054
         MVI   PRFTIC,X08         MOVE TIC INTO LINK FIELD     @Y17XAUQ
         DROP  R5                 FREE REGISTER                @Y17XAUQ
         EJECT                                                 @Y17XAUQ
************************************************************** @Y17XAUQ
*                                                            * @Y17XAUQ
*        NOW WE WILL FILL IN THE NEGATIVE PREFIX             * @Y17XAUQ
*                                                            * @Y17XAUQ
************************************************************** @Y17XAUQ
         LA    R1,PRF1LEN         GET LENGTH OF NEG PREFIX     @Y17XAUQ
         DROP  R3                 FREE REG                     @Y17XAUQ
         SR    R3,R1              BUMP BACK OVER NEG PREFIX    @Y17XAUQ
         USING IEDPF1,R3          ESTAB ADDRESSABILITY         @Y17XAUQ
         MVC   PRF1RH,RHHOLDAR    MOVE RH INTO NEG PREFIX      @Y17XAUQ
         XC    PRF1FLG1,PRF1FLG1  CLEAR OUT FLAG               @Y17XAUQ
         OI    PRF1FLG1,PRF1FIDI  SET FID1 INDICATION          @Y17XAUQ
         OI    PRF1FLG1,PRF1PTRI  TELL HIM SEQ# POINTER        @Y17XAUQ
*                                 FIELD IS PRESENT             @Y17XAUQ
         OI    PRF1RH+1,DEFSPON   SET DEFINITE RESPONSE        @Y17XAUU
         NI    PRF1RH+1,XFF-X'10'
         OI    PRF1RH,FORMAT      SET FORMAT INDICATOR         @ZM47554
         CLI   PRISECS#,PRISEQ#   WORKING WITH PRIMARY DEVICE  @Y17XAUQ
         BNE   SETSEQSC           NO GET SET FOR SECONDARY SEQ @Y17XAUQ
         LA    R8,TOTPRSN         GET PRI SEQ# SAVE AREA       @ZM47554
         B     SETSEQ             CONTINUE                     @Y17XAUQ
SETSEQSC LA    R8,TOTSCSN         GET SEC SEQ# SAVE AREA       @ZM47554
SETSEQ   DS    0H                 ESTAB BRANCH POINT           @Y17XAUQ
         ST    R8,PRF1SEQP        TELL HIM WHERE TO PUT SEQ#   @Y17XAUQ
POST     EQU   *                                                 S22024
         MVI   REQPRI,REQPRIE3    MOVE PRIORITY INTO ELEMENT   @Y17XAUQ
         LA    R0,TOTWAWRK        GET ADDR IF 'QWA WORK AREA   @Y17XAUQ
         L     R1,ERBCHAIN-ONE    PUT ADDR OF BUFFER IN REG    @Y17XAUQ
         ICM   R1,8,REQKEY        SET PROPER KEY               @Y17XAUQ
         LA    R10,DUMQCB-DUMMYLCB GET DISP OF THE QCB         @Y17XAUN
         AR    R10,R0             POINT TO QCB ADDR IN WORK    @Y17XAUN
*                                 AREA                         @Y17XAUN
         ST    R10,REQQCB         PUT QCB ADDRESS IN WORKAREA  @Y17XAUN
         L     R5,TOTRESPL        GET ADDR OF TOTES PARM LIST  @Y17XAUQ
         USING RESPL,R5           ESTABLISH ADDRESSABILITY     @Y17XAUQ
         L     R15,RESPLRVT       GET ADDR OF TOTE'S POST/WAIT @Y17XAUQ
         LR    R5,R4              COPY MODULE BASE REG         @XM05825
         L     R4,TOTAVTPT        GET TCAM AVT ADDRESS         @XM05825
         BALR  R14,R15            GO TO IEDQWA POST WAIT ROUTIN@Y17XAUQ
         LR    R4,R5              RESTORE BASE REG             @XM05825
         DROP  R5                 FREE REGISTER                @Y17XAUQ
*                                                              @Y17XAUQ
GOODRET  EQU   *                                                 S99528
         LA    R15,ZERO           SET GOOD RETURN CODE           S99528
         EJECT
***********************************************************************
*                                                                     *
*        EXIT ROUTINE                                                 *
*                                                                     *
***********************************************************************
         SPACE 2
EXIT     EQU   *                                                 S99528
         STC   R15,TOTRTCOD       PUT RETURN CODE INTO OLTCB     S99528
         TM    $OLTFLGS,$TRACE    WAS TRACE FUNCTION SPECIFIED?  S99528
         BO    TRACE              YES, GO TO IEDQWM2             S99528
         TM    $RETMASK,XFF       ANY RETURN CODES SET?
         BZ    NOTRACE            NORMAL EXIT                    S99528
         CLI   TOTRTCOD,ZERO      IS RETURN CODE ZERO?           S99528
         BNE   TRACE              NO, GO TO IEDQWM2              S99528
NOTRACE  EQU   *                                                 S99528
         L     R13,FOUR(R13)      GET CALLER'S SAVE ADDRESS      S99528
         L     R14,TWELVE(R13)    GET RETURN ADDRESS             S99528
         LM    R0,R12,TWENTY(R13) RESTORE CALLERS REGISTERS      S99528
         BR    R14                RETURN TO CALLER               S99528
TRACE    L     R13,FOUR(R13)      GET CALLER'S SAVE ADDRESS      S99528
         L     R14,TWELVE(R13)    GET HIS RETURN ADDRESS         S99528
         USING RESPL,R5          SETUP ADDRESSABILITY TO RESPL @Y17XAUQ
         L     R5,TOTRESPL        LOAD ADDR OF RESPL           @Y17XAUQ
         L     R15,RESPLM2        GET ADDR OF IEDQWM2          @Y17XAUQ
         LM    R2,R12,DISREG2(R13)
         BR    R15                GO TO IEDQWM2                @Y17XAUQ
         DROP  R5                                              @Y17XAUQ
         EJECT
**************************************************************** S22024
*                                                              * S22024
*        VERIFY THAT THE DAF OF THE TEST DEVICE IMBEDDED IN *  @Y17XAUQ
*        THE RU IS FOR EITHER THE PRIMARY OR SECONDARY TEST *  @Y17XAUQ
*        DEVICE.  ALSO INSURE THAT THE RU IS MARKED NETWORK *  @Y17XAUQ
*        SERVICES AND MAINTENANCE SERVICES.  IF EITHER IS   *  @Y17XAUQ
*        NOT TRUE ISSUE MESSAGE TO CONTROL TERMINAL AND SET *  @Y17XAUQ
*        RETURN CODE = 8.                                   *  @Y17XAUQ
*                                                              * S22024
**************************************************************** S22024
         SPACE 2
RSIDCHK  EQU   *                                                 S22024
         L     R6,OLTCCWA         GET VALIDIFIED CCW           @Y17XAUQ
         L     R6,ZERO(R6)        GET ADDRESS OF DATA          @Y17XAUQ
         USING OLLTFID1,R6        ESTAB ADDRABILITY            @Y17XAUQ
         CLI   OLLTPRFX,CD1NETS   IS THIS A VALID NET SERVICES @Y17XAUQ
         BNE   RSIDCHK0           NO TAKE ERROR EXIT           @Y17XAUQ
         CLI   OLLTPRFX+1,CD1MAINT IS IT MAINTENANCE SERVICES  @Y17XAUQ
         BNE   RSIDCHK0           NO TAKE ERROR EXIT           @Y17XAUQ
         CLI   OLLTREQ,CD1EX      IS IT EXECUTE TEST REQUEST   @Y17XAUQ
         BNE   RSIDCHK0           NO: PRINT ERROR AND EXIT     @Y17XAUQ
         CLC   OLLTTDEV,TOTPRSID  TARGET DAF = PRIMARY         @Y17XAUQ
         BE    RSIDCHKC           YES, CONTINUE                @Y17XAUQ
         CLC   OLLTTDEV,TOTSRSID  TARGET DAF = SECONDARY       @Y17XAUQ
         BE    RSIDCHKD           YES, CONTINUE                @Y17XAUQ
*                                 NEITHER PRI/SEC PRINT ERROR  @Y17XAUQ
         NI    TOTFLG05,XFF-TOTPRINT-TOTREPLY-TOTCECOM  TURN OFF S22024
*                                                         ACCESS S22024
*                                                         FLAGS  S22024
         OI    TOTFLG05,TOTCECOM  SET CECOM FLAG                 S22024
         MVI   TOTOTCNT,ERRORMSG  GET LENGTH OF ERROR MESSAGE    S22024
         MVC   TOTOTBUF(ERRORMSG),EXIOER  MOVE ERROR MSG INTO    S22024
*                                           OUTPUT BUFFER        S22024
         USING RESPL,R5          ESTAB ADDRESSABILITY TO RESPL @Y17XAUQ
RSIDCHK1 L     R5,TOTRESPL        LOAD ADDR OF RESPL           @Y17XAUQ
         L     R15,RESPLWO        GET ADDR OF IEDQWO           @Y17XAUQ
         BALR  R14,R15            GO TO IEDQWO                 @Y17XAUQ
         DROP  R5                 FREE ADDR'Y REG              @Y17XAUQ
*                                                              @Y17XAUQ
         LA    R15,EIGHT          SET RETURN CODE INDICATING     S22024
*                                   DEVICE NOT PRIMARY OR        S22024
*                                   SECONDARY                    S22024
         B     EXIT               GO TO EXIT ROUTINE           @Y17XAUN
         EJECT
*                                                              @Y17XAUQ
RSIDCHK0 DS    0H                 ESTABLISH BRANCH POINT       @Y17XAUQ
         NI    TOTFLG05,XFF-TOTPRINT-TOTREPLY-TOTCECOM         @Y17XAUQ
*                                 TURN OFF ACCESS FLAGS        @Y17XAUQ
         OI    TOTFLG05,TOTCECOM  SET CECOM FLAG               @Y17XAUQ
         MVI   TOTOTCNT,ERRMSG2   GET LENGTH OF ERROR MSG      @Y17XAUQ
         MVC   TOTOTBUF(ERRMSG2),EXIOER2 MOVE ERR MSG TO BUFFR @Y17XAUQ
         B     RSIDCHK1           GO PRINT MSG                 @Y17XAUQ
RSIDCHKC DS    0H                 ESTAB BRANCH POINT           @Y17XAUQ
         MVI   PRISECS#,PRISEQ#   INDICATE PRI SEQ# TO BE SAVE @Y17XAUQ
         B     RSIDCHK2           CONTINUE                     @Y17XAUQ
RSIDCHKD DS    0H                 ESTAB BRANCH POINT           @Y17XAUQ
         MVI   PRISECS#,SECSEQ#   INDICATE SEC SEQ# TO BE SAVE @Y17XAUQ
RSIDCHK2 DS    0H                 ESTABLISH BRANCH POINT       @Y17XAUQ
         MVC   RHHOLDAR,OLLTRHF1  MOVE OLLT/OLTT RH TO SAVAREA @Y17XAUQ
         MVC   TGDAFHAR,OLLTTDEV  PLACE TARGET IN HOLD AREA    @Y17XAUQ
         TM    $TOTFLG1,$CTEQTT   IS CT ON SAME LINE AS TSTDEV @Y17XAUQ
         BZ    RSIDCHK3           NO - CHECK AP                @YM08136
         CLC   TOTCRTNT+ONE(THREE),OLTRLTNT+ONE CONTROL        @YM08136
*                                 TERMINAL EQU TEST DEVICE     @YM08136
         BNE   RSIDCHK3           NO - CHECK AP                @YM08136
         MVC   OLTTCOFF(TWO),TOTCTOFF SET UP DUMMY TTCIN       @YM08136
         B     RSIDCHK4           CHECK FOR TEST START         @YM08136
RSIDCHK3 TM    TOTFLG01,TOTAPTST  IS AP ON SAME LINE AS TSTDEV @Y17XAUQ
         BZR   R8                 NO - CONTINUE                @YM08136
         CLC   TOTARTNT+ONE(THREE),OLTRLTNT+ONE ALTERNATE      @YM08136
*                                 PRINTER EQU TEST DEVICE      @YM08136
         BNER  R8                 NO - CONTINUE                @YM08136
         MVC   OLTTCOFF(TWO),TOTAPOFF SET UP DUMMY TTCIN       @YM08136
         B     RSIDCHK8           CHECK FOR START OF TEST      @YM08136
*                                                              @Y17XAUQ
RSIDCHK4 DS    0H                 ESTAB BRANCH POINT           @Y17XAUQ
         USING OLLTFID1,R6        ESTAB ADDRESSABILITY         @Y17XAUQ
         TM    OLLTCMOD,CD0TC     IS CONTACT ON IN MODIFIER    @Y17XAUN
         BO    RSIDCHK7           YES,SET INTEST SESSION:OLTCB @Y17XAUQ
RSIDCHK5 TM    OLLTCMOD,CD0TD     IS DISCONNECT ON IN MODIFIER @Y17XAUN
         BO    RSIDCHK6           YES, SET TEST SESS PENDG END @Y17XAUQ
         DROP  R6                 FREE REG                     @Y17XAUQ
         B     RSIDCHK3           CONTINUE                     @Y17XAUQ
*                                                              @Y17XAUQ
RSIDCHK7 DS    0H                 ESTAB BRANCH POINT           @Y17XAUQ
         OI    TOTFLG02,TOTTSST   TURN ON TEST SESSION STARTED @Y17XAUQ
         MVI   TOTOVBCD,HOLD      SET HOLD VERB CODE           @YM08136
         BAL   R14,OPCTL          HOLD CT QUEUE                @YM08136
         MVI   TOTOVBCD,INACT     SET INACT VERB CODE          @YM08136
         BAL   R14,OPCTL          INACTIVATE TEST DEVICE       @YM08136
         B     RSIDCHK5           CONTINUE                     @Y17XAUQ
*                                                              @Y17XAUQ
RSIDCHK6 DS    0H                 ESTABLISH BRANCH POINT       @Y17XAUQ
         OI    TOTFLG02,TOTTTSPE  SET TEST SESSION PENDING END @Y17XAUQ
         B     RSIDCHK3           CONTINUE                     @Y17XAUQ
*                                                              @Y17XAUQ
RSIDCHK8 DS    0H                 ESTABLISH BRANCH POINT       @Y17XAUQ
         L     R6,OLTCCWA         GET VALIDIFIED CCW           @Y17XAUQ
         L     R6,ZERO(R6)        GET ADDRESS OF DATA          @Y17XAUQ
         USING OLLTFID1,R6        ESTAB ADDRESSABILITY         @Y17XAUQ
         TM    OLLTCMD,CD0TC      IS CMD TEST WITH CONTACT     @Y17XAUQ
         BO    RSIDCHK9           YES, GO SET IN TEST SESS ON  @Y17XAUQ
RSIDCHKA TM    OLLTCMD,CD0TD      IS CMD TEST WITH DISCONTACT  @Y17XAUQ
         BO    RSIDCHKB           YES, SET TEST SESS PENDG END @Y17XAUQ
         DROP  R6                 FREE REG                     @Y17XAUQ
         B     ZERO(R8)           RETURN                       @Y17XAUQ
*                                                              @Y17XAUQ
RSIDCHK9 DS    0H                 ESTAB BRANCH POINT           @Y17XAUQ
         OI    TOTFLG02,TOTTSST   TURN ON TEST SESS STARTED    @Y17XAUQ
         MVI   TOTOVBCD,HOLD      SET HOLD VERB CODE           @YM08136
         BAL   R14,OPCTL          HOLD AP QUEUE                @YM08136
         MVI   TOTOVBCD,INACT     SET INACTIVATE VERB CODE     @YM08136
         BAL   R14,OPCTL          INACTIVATE TEST DEVICE       @YM08136
         B     RSIDCHKA           CONTINUE                     @Y17XAUQ
*                                                              @Y17XAUQ
RSIDCHKB DS    0H                 ESTAB BRANCH POINT           @Y17XAUQ
         OI    TOTFLG02,TOTTTSPE  SET TEST SESS PENDG END      @Y17XAUQ
         B     ZERO(R8)           RETURN                       @Y17XAUQ
*                                                              @Y17XAUQ
         EJECT
*                                                              @YM08136
*        ROUTINE TO INACTIVATE 3705 TERMINAL(DUMMY ENTRY)      @YM08136
*        RETURN TO CALLER VIA REGISTER 14                      @YM08136
*                                                              @YM08136
OPCTL    EQU   *                                               @YM08136
         L     R6,TOTAVTPT        GET ADDRESS OF AVT           @YM08136
         USING IEDQAVTD,R6                                     @YM08136
         LA    R10,AVTOPCOB        GET POINTER TO OP CNTRL QCB @YM08136
         ST    R10,TOTOKEY        PUT IN PARAMETER LIST        @YM08136
         MVI   TOTOKEY,OPCKEY     ZERO OUT KEY FIELD           @YM08136
         DROP  R6                                              @YM08136
         MVI   TOTOLADR,X40       BLANK OUT NAME               @YM08136
         MVC   TOTOLADR+ONE(SEVEN),TOTOLADR FIELD              @YM08136
         L     R6,OLTRLTNT        GET TD TNT ADDRESS           @YM08136
         SLR   R1,R1              CLEAR REG                    @YM08136
         IC    R1,TOTTTBEL        GET TD NAME LENGTH           @YM08136
         BCTR  R1,0               DECREMENT COUNT FOR EX       @YM08136
         EX    R1,MOVENAM         MOVE NAME TO PLIST           @YM08136
         MVC   TOTORLN,OLTTCRLN   MOVE IN RELATIVE LINE NUMBER @YM08136
         LA    R1,TOTOTECB         GET TOTE ECB                @YM08136
         ST    R1,TOTOECBA        PUT IN PARAMETER LIST        @YM08136
         OI    TOTOFLG,TOTOATC    SET C. TTCIN FLAG            @YM08136
         MVC   TOTOALTT(TWO),OLTTCOFF SET C. TTCIN IN ELEMENT  @YM08136
         XC    TOTOLINK(THREE),TOTOLINK  CLEAR REQUEST ELEMENT @YM08136
*                                          LINK FIELD          @YM08136
         MVI   TOTOPRI,OPCPRI     SET OP CONTROL PRIORITY TO DC@YM08136
         MVI   TOTORTCD,OPCRTCD   CLEAR RETURN CODE FIELD      @YM08136
         MVI   TOTOELNG,OPCELNG   SET ELEMENT LENGTH TO X'18'  @YM08136
         LA    R1,TOTPLIST        GET ADDRESS OF OP CONTROL    @YM08136
*                                   PARAMETER LIST             @YM08136
         ST    R1,ELEM1           SAVE IT IN 1ST WORD OF POST  @YM08136
*                                   LIST                       @YM08136
         ST    R1,ELEM2           SAVE IT IN SECOND WORD OF    @YM08136
*                                   SVC 102 POST LIST          @YM08136
         MVI   ELEM1,CODE         SET SVC 102 START CODE       @YM08136
         MVI   ELEM2,ENDLIST      SET SVC 102 END CODE         @YM08136
         LA    R1,SLPL            POINT R1 TO PARAMETER LIST   @YM08136
         XC    TOTOTECB(FOUR),TOTOTECB CLEAR TOTE ECB          @YM08136
         AQCTL                     POST ELEMENT TO OPERATOR CNTL@YM0813
*                                                              @YM08136
         WAIT  ECB=TOTOTECB                                    @YM08136
*                                                              @YM08136
         BR    R14                RETURN TO CALLER             @YM08136
         EJECT                                                 @Y17XAUQ
COMPARE  CLC   ZERO(ZERO,R5),TWELVE(R6)      COMPARE TERM NAME @Y17XAUQ
*                                        ENTRY WITH CDS FIELD    S99528
PATCH    DC    CL100' '           MAINTENANCE PATCH AREA         S99528
         EJECT                                                   S99528
         DS    0D                 ALIGN CCW ON DOUBLE WORD BOUNDARY
QCBCPA   EQU   *                  CHANNEL PGM AREA IN LCB      @Y17XAUQ
         CCW   X'2F',*,X'60',1    CHANNEL COMMAND WORD
         DC    2D'0'              SIXTEEN BYTES OF ZEROES
         SPACE 4
SADCODE  DC    X'13'              SAD 0
         DC    X'17'              SAD 1
         DC    X'1B'              SAD 2
         DC    X'1F'              SAD 3
NOP      DC    X'20000001'        NO-OP COMMAND FOR CCW
ANDMASK  DC    F'3'               USED TO CLEAR FLAG BYTE
OPTIONS  DC    H'20'              DISPLACEMENT IF OPTIONS        S99528
NOOPT    DC    H'17'              DISPLACEMENT IF NO OPTIONS     S99528
SILI     DC    X'20'              SLI BIT SETTING                S99528
ENABLE   DC    X'27'              ENABLE COMMAND                 S99528
SETMODE  DC    X'23'              SET MODE COMMAND               S99528
ONEMORE  DC    H'01'              CONSTANT 1                     S22024
EIGHTLN  DC    H'08'              CONSTANT 8                     S22024
MOVE     MVC   ZERO(ZERO,R6),ZERO(R7)   MOVE DATA FROM CCW TO    S22024
*                                        BUFFER                  S22024
MOVENAM  MVC   TOTOLADR(EIGHT),ZERO(R6) MOVE NAME TO PLIST     @YM08136
ZEROLAST DC    X'00000000'        ZERO TIC FIELD                 S22024
LASTUNIT DC    X'08000002'        TIC FIELD FOR LAST BUFFER UNIT S22024
ZEROADDR DC    A(0)               ZERO ADDRESS FOR A COMPARE   @Y17XAUQ
REQKEY   DC    X'E0'              REQUEST KEY FOR POST/WAIT    @Y17XAUQ
*                                 ROUTINE IN IEDQWA            @Y17XAUQ
MSGSTART EQU   *                  START OF ERROR MESSAGE         S22024
EXIOER   DC    C'IED258I OLT ATTEMPTED I/O TO RSID NOT UNDER TEST - I/O*
                NOT PERFORMED'    EXIO ERROR MESSAGE             S22024
MSGEND   EQU   *                  END OF ERROR MESSAGE           S22024
ERRORMSG EQU   MSGEND-MSGSTART    LENGTH OF ERROR MESSAGE        S22024
         EJECT
VALIDTST DC    X'010301'          1ST 3 BYTES OF A VALID       @Y17XAUQ
*                                 NET SVCS / MAINT SVCS        @Y17XAUQ
*                                 EXECUTE TEXT COMMAND         @Y17XAUQ
MSG2STRT EQU   *                                               @Y17XAUQ
EXIOER2  DC    C'IED574I OLT ATTEMPTED I/O WITH INVALID DATA'  @Y17XAUQ
MSG2END  EQU   *                                               @Y17XAUQ
ERRMSG2  EQU   MSG2END-MSG2STRT   LENGTH OF ERROR MSG          @Y17XAUQ
*                                                              @Y17XAUQ
         EJECT                                                 @Y17XAUQ
CCW      DSECT                    CHANNEL COMMAND WORD           S22024
CCWCMD   DS    C                  COMMAND CODE                   S22024
CCWADDR  DS    AL3                DATA ADDRESS                   S22024
CCWFLAG  DS    C                  CCW FLAGS                      S22024
         DS    C                  UNUSED                         S22024
CCWCOUNT DS    H                  BYTE COUNT                   @Y17XAUQ
         EJECT
         TCD0D                                                 @Y17XAUQ
         EJECT
         TCD1D                                                 @Y17XAUQ
         DSECT                                                 @Y17XAUQ
OLLTFID1 DS    0C                 ON LINE TEST FID1 DSECT      @Y17XAUQ
OLLTTHF1 DS    XL1                TRANS HEADER FLAG1           @Y17XAUQ
OLLTTHF2 DS    XL1                TRANS HEADER FLAG2           @Y17XAUQ
OLLTDAF  DS    XL2                DAF OF NCP PHYS SVCS         @Y17XAUQ
OLLTOAF  DS    XL2                OAF OF TCAM'S SSCP           @Y17XAUQ
OLLTSEQN DS    XL2                SEQ NUMBER                   @Y17XAUQ
OLLTDCF  DS    XL2                DATA COUNT FIELD             @Y17XAUQ
OLLTTHLG EQU   10                 OLLT TH LENGTH               @Y17XAUQ
*                                                              @Y17XAUQ
*                                                              @Y17XAUQ
*                                                              @Y17XAUQ
OLLTRHF1 DS    XL1                REQ HEADER FLAG1             @Y17XAUQ
OLLTRHF2 DS    XL1                REQ HEADER FLAG2             @Y17XAUQ
OLLTRHF3 DS    XL1                REQ HEADER FLAG3             @Y17XAUQ
OLLTRHLG EQU   3                  OLLT RH LENGTH               @Y17XAUQ
*                                                              @Y17XAUQ
*                                                              @Y17XAUQ
OLLTPRFX DS    XL2                PREFIX (NET SVCS+MAINT SVCS) @Y17XAUQ
OLLTREQ  DS    XL1                REQ TYPE EXEC TST/RCD STATS  @Y17XAUQ
OLLTTDEV DS    XL2                DAF OF TEST DEVICE           @Y17XAUQ
OLLTCMD  DS    XL1                COMMAND                      @Y17XAUQ
OLLTCMOD DS    XL1                COMMAND MODIFIER             @Y17XAUQ
OLLTSYSR DS    XL1                SYSTEM RESPONSE              @Y17XAUQ
OLLTERSP DS    XL2                EXTENDED RESPONSE            @Y17XAUQ
*                                                              @Y17XAUQ
         EJECT                                                 @Y17XAUQ
*                                                              @Y17XAUQ
         TPRFD                                                 @Y17XAUQ
RESPL    RESPL                                                 @Y17XAUQ
         EJECT                                                 @Y17XAUQ
         TPRIOR                                                @Y17XAUQ
         EJECT
DUMMYLCB DSECT                    DUMMY LCB                      S22024
RCQCBLCB DS    F                  ADDRESS OF THE QCB TO WHICH    S22024
*                                  REQUESTED BUFFERS ARE TO BE   S22024
*                                  POSTED                        S22024
PARMLIST DS    0F                 PARAMETER LIST FOR SVC 102     S22024
ACTCODE  DS    C                  ACTION CODE                    S22024
ELPT1    DS    AL3                ELEMENT POINTER                S22024
LASTWD   DS    C                  BYTE INDICATING LAST WORD IN   S22024
*                                  LIST                          S22024
ELPT2    DS    AL3                ELEMENT POINTER                S22024
         DS    2C                 UNUSED                         S22024
STAT1LCB DS    C                  FIRST STATUS BYTE- ALWAYS 0    S22024
STAT2LCB DS    C                  SECOND STATUS BYTE - ALWAYS 0  S22024
         DS    4C                 UNUSED                         S22024
ERBLCB   DS    0F                 START OF ERB                   S22024
ERBKEY   DS    C                  KEY FIELD - UNUSED             S22024
ERBQCB   DS    AL3                ADDRESS OF'BUFFER REQUEST' QCB S22024
ERBPRI   DS    C                  ERB PRIORITY                   S22024
ERBLINK  DS    AL3                ADDRESS OF NEXT ITEM IN THE    S22024
*                                  CHAIN IN WHICH THIS ERB       S22024
*                                  RESIDES- ALWAYS ZERO          S22024
ERBSTAT  DS    C                  STATUS BYTE                    S22024
ERBCHAIN DS    AL3                ADDRESS OF CHAIN TO BE ASSIGNEDS22024
*                                 BUFFERS-ON RETURN FROM BUFFER  S22024
*                                 REQUEST,CONTAINS ADDRESS OF    S22024
*                                 REQUESTED BUFFER               S22024
ERBCNT1  DS    C                  NUMBER OF BUFFERS REQUESTED -  S22024
*                                  ALWAYS 1                      S22024
ERBCNT2  DS    C                  NUMBER OF UNITS NEEDED IN THE  S22024
*                                  REQUESTED BUFFER              S22024
         DS    3C                 UNUSED                         S22024
SCBALCB  DS    AL3                ADDRESS OF SCB                 S22024
DUMQCB   DS    0F                 DUMMY QCB TO WHICH EMPTY BUFFERS22024
*                                  IS POSTED                     S22024
QCB0SFLG DS    C                  FLAG BYTE- ALWAYS X'02' WHICH  S22024
*                                  INDICATES A QCB               S22024
ELCHNQCB DS    AL3                ELEMENT CHAIN POINTER          S22024
ECBO     DS    F                  THE ECB ON WHICH IEDQWN WAITS  S22024
*                                  AFTER REQUESTING A BUFFER     S22024
QCBPTR   DS    AL4                POINTER BACK TO FIRST WORD OF  S22024
*                                  DUMMY QCB                     S22024
SCB      DS    0F                 STATION CONTROL BLOCK          S22024
STATESCB DS    C                  STATUS BYTE - ALWAYS ZERO      S22024
DESTQSCB DS    AL3                ADDRESS OF DESTINATION QCB     S22024
         DS    48C                REMAINDER OF SCB               S22024
         EJECT
UCB      DSECT                                                   S99528
         IEFUCBOB                                                S99528
         EJECT
         TAVTD                                                   S99528
         EJECT
         TTRMD                                                   S99528
         EJECT
         TQCBD                                                 @Y17XAUQ
         EJECT
         OLTCB
************************************************************** @Y17XAUQ
*                                                            * @Y17XAUQ
*        PARAMETER LIST FOR SVC 102                          * @Y17XAUQ
*                                                            * @Y17XAUQ
************************************************************** @Y17XAUQ
*                                                              @Y17XAUQ
SLPL     DS    0F                 ALIGN ON FULLWORD            @Y17XAUQ
ELEM1    DS    F                  POINTER TO FIRST ELEMENT     @Y17XAUQ
ELEM2    DS    F                  POINTER TO SECOND ELEMENT    @Y17XAUQ
*                                                              @Y17XAUQ
*                                                              @Y17XAUQ
LCBSIOCC DS    AL4                ADDR OF CHANNEL PGM AREA     @Y17XAUQ
         DS    0D                 ALIGN ON DOUBLE WORD         @Y17XAUQ
LCBCPA   EQU   *                  CHANNEL PGM AREA START       @Y17XAUQ
         DS    CL8                CHANNEL COMMAND WORD         @Y17XAUQ
         DS    CL8                EIGHT BYTES OF ZEROS         @Y17XAUQ
         DS    CL8                EIGHT BYTES OF ZEROS         @Y17XAUQ
*                                                              @Y17XAUQ
TRMSLPL  DS    0F                 PARAMETER LIST FOR HOLD      @Y17XAUQ
TRMSSLST DS    XL1                START OF LIST INDICATOR      @Y17XAUQ
TRMSREL1 DS    AL3                ADDR OF REQ ELEMENT          @Y17XAUQ
TRMSELST DS    XL1                END OF LIST INDICATOR        @Y17XAUQ
TRMSREL2 DS    AL3                ADDR OF REQ ELEMENT          @Y17XAUQ
         EJECT                                                 @Y17XAUQ
************************************************************** @Y17XAUQ
*                                                            * @Y17XAUQ
*        REQUEST ELEMENT LIST TO USE IEDQWA'S POST/WAIT      * @Y17XAUQ
*                                                            * @Y17XAUQ
************************************************************** @Y17XAUQ
REQELMNT DS    0F                 ADDR OF REQ ELEMENT          @Y17XAUQ
REQQCB   DS    F                  QCB ADDRESS                  @Y17XAUQ
REQPRI   DS    C                  PRIORITY OF REQ ELEMENT      @Y17XAUQ
REQPRIE3 EQU   X'E3'              PRIORITY FOR POST/WAIT@Y17XAUQ
REQLINK  DS    AL3                LINK FIELD                   @Y17XAUQ
         EJECT
TNTENTRY DS    A                  ADDR OF TERMINAL ENTRY       @Y17XAUQ
DIALADDR DS    F                  POINTER TO DIAL DIGITS       @Y17XAUQ
ALINETTE DS    A                  ALIGNED TTE ADDR             @Y17XAUQ
*                                                              @Y17XAUQ
LCBADDR  DS    F                  ADDR OF 3705 LCB             @Y17XAUQ
*                                                              @Y17XAUQ
PRFXSIZE DS    H                  SIZE OF PREFIX               @Y17XAUQ
UNITSIZE DS    H                  UNIT SIZE                    @Y17XAUQ
UCBAREA  DS    H                  UCB UNIT NAME                @Y17XAUQ
SWITCH   DS    XL1                SWITCH BYTE                  @Y17XAUQ
PRISECS# DS    XL1                INDICATES PRI/SEC            @Y17XAUQ
PRISEQ#  EQU   X'80'              TEST DEV                     @Y17XAUQ
SECSEQ#  EQU   X'40'              SEQ NO                       @Y17XAUQ
UNITUSED DS    XL1                # OF UNITS IN BUFFER         @Y17XAUQ
BUFDATLN DS    H                  SAVE AREA FOR OLLT/OLTT      @Y17XAUQ
*                                 DATA COUNT MINUS RH LENGTH   @Y17XAUQ
*                                 TO BE PUT IN BUFFER PREFIX   @Y17XAUQ
TGDAFHAR DS    XL2                TARGET DAF HOLD AREA         @Y17XAUQ
RHHOLDAR DS    XL3                RH HOLD AREA                 @Y17XAUQ
         EJECT
         IOBLOCKS
         EJECT
         TTECB
         EJECT
EXIOLIST DSECT
XIOTRMG  DS    XL1                CONTROL PROGRAM FLAGS          S99528
XIOLEVEL DS    XL1                MACRO LEVEL                    S99528
XIOIDNT  DS    XL2                MACRO IDENTIFICATION           S99528
XIOTECBA DS    A                  ADDRESS OF TECB                S99528
XIOCDSA  DS    A                  ADDRESS OF CDS                 S99528
XIOCCWA  DS    A                  ADDRESS OF CCW                 S99528
XIOCCWC  DS    XL1                NUMBER OF CCW'S                S99528
XIOFLAG  DS    XL1                FLAG BYTE                      S99528
         END
