         TITLE 'IEDXTREQ, CROSS-TASK-REQUEST HANDLER                   *
                        '
IEDXTREQ CSECT ,                                                   0001
@PROLOG  DS    0H                                                  0002
         USING *,RBASE
         DC    XL8'00'              QCB FOR THIS MODULE
         DC    XL1'06'              STCB KEY
         DC    AL3(*-1)             STCB ADDRESS
*
         LR    RBASE,RQCB           SET UP BASE REGISTER
*
IEDXTREQ IEDHJN  START,HJN
         EJECT
*                                                                  0088
*/********************************************************************/
*/*                                                                  */
*/*      M A I N   C O D E   S E G M E N T                           */
*/*                                                                  */
*/********************************************************************/
*                                                                  0088
*   RREQ=RPARM;                     /* REQUEST ELEMENT ADDRESS       */
         LR    RREQ,RPARM                                          0088
*   REQRCDS=0;                      /* INITIALIZE GOOD RETURN CODES  */
         SLR   @10,@10                                             0089
         STH   @10,REQRCDS(,RREQ)                                  0089
*/*                                                                  */
*                                                                  0090
*   IF REQTYPE=REQSGET THEN         /* GET-SIB REQUEST?              */
         CLI   REQTYPE(RREQ),X'03'                                 0090
         BNE   @RF00090                                            0090
*     CALL GETSIB;                  /* YES, REQUEST A SIB            */
         BAL   @14,GETSIB                                          0091
*   ELSE                                                           0092
*     IF REQTYPE=REQSFREE THEN      /* FREE-SIB REQUEST?             */
         B     @RC00090                                            0092
@RF00090 CLI   REQTYPE(RREQ),X'04'                                 0092
         BNE   @RF00092                                            0092
*       CALL FREESIB;               /* YES, FREE A SIB               */
         BAL   @14,FREESIB                                         0093
*     ELSE                                                         0094
*       REQRCD1=1;                  /* UNEXPECTED REQUEST TYPE --- 0094
*                                      SET BAD RETURN CODE           */
         B     @RC00092                                            0094
@RF00092 MVI   REQRCD1(RREQ),X'01'                                 0094
*/*                                                                  */
*                                                                  0095
*                                   /* SET UP REQUEST ELEMENT FOR  0095
*                                      TPOST BACK TO ORIGINATOR      */
*   REQQCBA=REQRQCBA;               /* RETURN QCB ADDRESS            */
@RC00092 DS    0H                                                  0095
@RC00090 MVC   REQQCBA(3,RREQ),REQRQCBA(RREQ)                      0095
*   REQPRI=REQRPRI;                 /* RETURN PRIORITY               */
         MVC   REQPRI(1,RREQ),REQRPRI(RREQ)                        0096
*   RPARM=RREQ;                     /* ELEMENT ADDRESS FOR TPOST     */
         LR    RPARM,RREQ                                          0097
*/*                                                                  */
*                                                                  0098
*   GO TO DSPPOST;                  /* TPOST REQUEST ELEMENT & EXIT  */
         LA    @10,DSPPOST(,RDISP)                                 0098
         BR    @10                                                 0098
         EJECT
*                                                                  0099
*/********************************************************************/
*/*                                                                  */
*/*      F R E E S I B   SUBROUTINE                                  */
*/*                                                                  */
*/********************************************************************/
*/*                                                                  */
*/*      THIS SUBROUTINE SETS UP PARAMETER REGISTERS AND CALLS       */
*/*      THE SUBROUTINE WITHIN THE SIB-POOL MANAGER TO FREE A SIB    */
*/*                                                                  */
*/********************************************************************/
*                                                                  0099
*FREESIB:                                                          0099
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);                               0099
*                                                                  0099
FREESIB  DS    0H                                                  0100
*/*                                                                  */
*                                                                  0100
*   RTRNADDR=RE;                    /* SAVE RETURN ADDRESS           */
         ST    RE,RTRNADDR(,IEDQAPTR)                              0100
*/*                                                                  */
*                                                                  0101
*   RZERO=REQSTNT;                  /* SIBINDEX VALUE OF SIB WHICH IS
*                                      TO BE FREED                   */
         LH    RZERO,REQSTNT(,RREQ)                                0101
         N     RZERO,@CF00701                                      0101
*   RPARM=REQSTTE;                  /* ADDR OF TERMINAL TABLE ENTRY
*                                      WHOSE SIB IS TO BE FREED      */
         L     RPARM,REQSTTE(,RREQ)                                0102
*   CALL IEDIAP08;                  /* PASS SIB TO SIB-POOL MANAGER
*                                      TO BE FREED                   */
         L     @10,AVTSAVTP(,IEDQAPTR)                             0103
         L     @15,SAVTSRTN(,@10)                                  0103
         BALR  @14,@15                                             0103
*/*                                                                  */
*                                                                  0104
*   RE=RTRNADDR;                    /* RESTORE RETURN ADDRESS        */
         L     RE,RTRNADDR(,IEDQAPTR)                              0104
*   END FREESIB;                    /* RETURN TO CALLER              */
@EL00002 DS    0H                                                  0105
@EF00002 DS    0H                                                  0105
@ER00002 BR    @14                                                 0105
         EJECT
*                                                                  0106
*/********************************************************************/
*/*                                                                  */
*/*      G E T S I B   SUBROUTINE                                    */
*/*                                                                  */
*/********************************************************************/
*/*                                                                  */
*/*      THIS SUBROUTINE SETS UP PARAMETER REGISTERS AND CALLS       */
*/*      A SIB-POOL-MANAGER SUBROUTINE TO REQUEST A SIB.  IF THE     */
*/*      REQUEST IS SUCCESSFUL, REGISTER 15 CONTAINS THE SIB         */
*/*      ADDRESS ON RETURN.  IF UNSUCCESSFUL, REGISTER 15 CONTAINS   */
*/*      ZERO ON RETURN.                                             */
*/*                                                                  */
*/********************************************************************/
*                                                                  0106
*GETSIB:                                                           0106
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);                               0106
*                                                                  0106
GETSIB   DS    0H                                                  0107
*/*                                                                  */
*                                                                  0107
*   RTRNADDR=RE;                    /* SAVE RETURN ADDRESS           */
         ST    RE,RTRNADDR(,IEDQAPTR)                              0107
*/*                                                                  */
*                                                                  0108
*   RZERO=REQSTNT;                  /* TNT OFFSET TO INSERT INTO THE
*                                      SIBINDEX FIELD OF THE SIB     */
         LH    RZERO,REQSTNT(,RREQ)                                0108
         N     RZERO,@CF00701                                      0108
*   RPARM=REQSTTE;                  /* ADDR OF TERMINAL TABLE ENTRY
*                                      WE ARE REQUESTING SIB FOR     */
         L     RPARM,REQSTTE(,RREQ)                                0109
*   CALL IEDIAP02;                  /* REQUEST A SIB FROM POOL MGR   */
         L     @10,AVTSAVTP(,IEDQAPTR)                             0110
         L     @15,SAVTSREQ(,@10)                                  0110
         BALR  @14,@15                                             0110
*/*                                                                  */
*                                                                  0111
*   IF RF=0 THEN                    /* SIB REQUEST UNSUCCESSFUL?     */
         LTR   RF,RF                                               0111
         BNZ   @RF00111                                            0111
*     REQRCD1=1;                    /* YES, SET BAD RETURN CODE      */
         MVI   REQRCD1(RREQ),X'01'                                 0112
*/*                                                                  */
*                                                                  0113
*   RE=RTRNADDR;                    /* RESTORE RETURN ADDRESS        */
@RF00111 L     RE,RTRNADDR(,IEDQAPTR)                              0113
*   END GETSIB;                     /* RETURN TO CALLER              */
@EL00003 DS    0H                                                  0114
@EF00003 DS    0H                                                  0114
@ER00003 BR    @14                                                 0114
         EJECT
*   END IEDXTREQ                                                   0115
*                                                                  0115
*/* THE FOLLOWING INCLUDE STATEMENTS WERE FOUND IN THIS PROGRAM.     */
*/*%INCLUDE SYSLIB  (TAVTD   )                                       */
*/*%INCLUDE SYSLIB  (TDISPD  )                                       */
*/*%INCLUDE SYSLIB  (TREQD   )                                       */
*                                                                  0115
*       ;                                                          0115
@DATA    DS    0H
         DS    0F
         DS    0F
@CF00701 DC    XL4'0000FFFF'
         DS    0D
@00      EQU   00                      EQUATES FOR REGISTERS 0-15
@01      EQU   01
@02      EQU   02
@03      EQU   03
@04      EQU   04
@05      EQU   05
@06      EQU   06
@07      EQU   07
@08      EQU   08
@09      EQU   09
@10      EQU   10
@11      EQU   11
@12      EQU   12
@13      EQU   13
@14      EQU   14
@15      EQU   15
IEDQAPTR EQU   @13
RDISP    EQU   @11
RREQ     EQU   @06
RZERO    EQU   @00
RPARM    EQU   @01
RQCB     EQU   @07
RBASE    EQU   @12
RAVT     EQU   @13
RE       EQU   @14
RF       EQU   @15
IEDQQPTR EQU   @07
IEDQAVTD EQU   0
AVTSAVEX EQU   IEDQAVTD+216
AVTDOUBL EQU   IEDQAVTD+272
@NM00003 EQU   IEDQAVTD+316
AVTCKFLG EQU   @NM00003
AVTBASE  EQU   IEDQAVTD+340
AVTPKF   EQU   AVTBASE
AVTHG02  EQU   IEDQAVTD+456
AVTDISP  EQU   IEDQAVTD+480
AVTHD    EQU   IEDQAVTD+484
AVTSCOPT EQU   AVTHD
AVTSAVTP EQU   IEDQAVTD+540
AVTSAVTF EQU   AVTSAVTP
AVTCKPEL EQU   IEDQAVTD+580
AVTCKRMV EQU   AVTCKPEL
AVTCKELF EQU   IEDQAVTD+608
AVTCKBYT EQU   IEDQAVTD+619
AVTHG01  EQU   IEDQAVTD+620
AVTCKLNK EQU   IEDQAVTD+624
AVTCRELE EQU   IEDQAVTD+636
AVTCCELE EQU   AVTCRELE
AVTCLRHI EQU   IEDQAVTD+644
AVTADBUF EQU   IEDQAVTD+648
AVTSYSER EQU   IEDQAVTD+656
AVTCKPQB EQU   IEDQAVTD+732
AVTCKPTB EQU   AVTCKPQB
AVTCKPEC EQU   AVTCKPQB+4
AVTCKPCC EQU   AVTCKPEC
AVTOPCQB EQU   IEDQAVTD+744
AVTOPCOB EQU   AVTOPCQB
AVTOPCEC EQU   AVTOPCQB+4
AVTOPCCC EQU   AVTOPCEC
AVTOLTQB EQU   IEDQAVTD+756
AVTCWFL1 EQU   IEDQAVTD+852
AVTCWFL2 EQU   IEDQAVTD+853
AVTSUBT  EQU   IEDQAVTD+876
AVTIOTR  EQU   IEDQAVTD+877
AVTBIT1  EQU   IEDQAVTD+978
AVTBIT2  EQU   IEDQAVTD+979
AVTBIT3  EQU   IEDQAVTD+980
AVTBIT4  EQU   IEDQAVTD+1064
@NM00083 EQU   IEDQAVTD+1160
IEDNSVTD EQU   0
SAVTDIAG EQU   IEDNSVTD
SAVTDIAF EQU   SAVTDIAG
SAVTSREQ EQU   IEDNSVTD+44
SAVTSRTN EQU   IEDNSVTD+48
SAVTLUSQ EQU   IEDNSVTD+88
SAVTTCPU EQU   IEDNSVTD+238
SAVTZELM EQU   IEDNSVTD+270
SAVTRDRV EQU   IEDNSVTD+284
SAVTCKQB EQU   IEDNSVTD+300
SAVTCKTB EQU   SAVTCKQB
SAVTCKEC EQU   SAVTCKQB+4
SAVTCKCC EQU   SAVTCKEC
IEDQDISP EQU   0
DSPPOST  EQU   24
IEDREQD  EQU   0
REQTYPE  EQU   IEDREQD
REQQCBA  EQU   IEDREQD+1
REQPRI   EQU   IEDREQD+4
REQRPRI  EQU   IEDREQD+8
REQRQCBA EQU   IEDREQD+9
REQROUTE EQU   IEDREQD+12
REQRCDS  EQU   IEDREQD+14
REQRCD1  EQU   REQRCDS
REQDATA  EQU   IEDREQD+16
IEDIAP02 EQU   0
IEDIAP08 EQU   0
DSPBYPAS EQU   20
DSPCHAIN EQU   12
DSPDISP  EQU   4
DSPLIFO  EQU   56
DSPLIFOR EQU   60
DSPLIST  EQU   8
DSPPOSTR EQU   28
DSPPRIO  EQU   48
DSPPRIOR EQU   52
DSPTRACE EQU   64
DSPTSTQ  EQU   32
DSPTSTQR EQU   36
DSPUNAV  EQU   40
DSPUNAVR EQU   44
DSPWAIT  EQU   16
REQLDATA EQU   REQDATA
REQSDATA EQU   REQDATA
REQSTTE  EQU   REQSDATA
REQSTNT  EQU   REQSDATA+4
RTRNADDR EQU   AVTDOUBL
         AGO   .@UNREFD                START UNREFERENCED COMPONENTS
REQLTNT  EQU   REQLDATA
REQRCD2  EQU   REQRCDS+1
REQSWTCH EQU   REQROUTE+1
REQFLAG  EQU   REQROUTE
REQLINK  EQU   IEDREQD+5
SAVTBITN EQU   IEDNSVTD+312
@NM00102 EQU   SAVTCKQB+8
@NM00101 EQU   SAVTCKEC+1
@NM00100 EQU   SAVTCKCC
SAVTCKPO EQU   SAVTCKCC
SAVTCKWA EQU   SAVTCKCC
SAVTCKCH EQU   SAVTCKTB+1
SAVTCKVT EQU   SAVTCKTB
@NM00099 EQU   IEDNSVTD+297
SAVTRDFG EQU   SAVTRDRV+12
@NM00098 EQU   SAVTRDRV+5
SAVTRDPY EQU   SAVTRDRV+4
SAVTRDQB EQU   SAVTRDRV+1
SAVTRDKY EQU   SAVTRDRV
SAVTNID  EQU   IEDNSVTD+280
SAVTDVAS EQU   IEDNSVTD+276
SAVTPLSZ EQU   IEDNSVTD+274
@NM00097 EQU   IEDNSVTD+273
SAVTSUBL EQU   IEDNSVTD+272
@NM00096 EQU   SAVTZELM+1
SAVTSUBM EQU   SAVTZELM
SAVTMHDX EQU   IEDNSVTD+268
SAVTNAT1 EQU   IEDNSVTD+266
SAVTSH20 EQU   IEDNSVTD+264
SAVTLCBS EQU   IEDNSVTD+260
SAVTRNMP EQU   IEDNSVTD+256
SAVTTNTX EQU   IEDNSVTD+252
SAVTNAX  EQU   IEDNSVTD+248
SAVTSUBV EQU   IEDNSVTD+247
SAVTSUBA EQU   IEDNSVTD+246
SAVTSIBC EQU   IEDNSVTD+244
SAVTBSM  EQU   IEDNSVTD+240
SAVTSCPT EQU   SAVTTCPU
SAVTRQTG EQU   IEDNSVTD+236
SAVTRQCH EQU   IEDNSVTD+232
SAVTMAND EQU   IEDNSVTD+228
SAVTSPLN EQU   IEDNSVTD+224
SAVTNADL EQU   IEDNSVTD+222
SAVTNATL EQU   IEDNSVTD+220
SAVTMHTB EQU   IEDNSVTD+216
SAVTSSMH EQU   IEDNSVTD+212
SAVTQRS  EQU   IEDNSVTD+208
SAVTRQIN EQU   IEDNSVTD+204
SAVTDFCO EQU   IEDNSVTD+200
SAVTSAO  EQU   IEDNSVTD+196
SAVTSARI EQU   IEDNSVTD+192
SAVTSAC  EQU   IEDNSVTD+188
SAVTSAI  EQU   IEDNSVTD+184
SAVTCSCI EQU   IEDNSVTD+180
SAVTSSRP EQU   IEDNSVTD+176
SAVTSSRQ EQU   IEDNSVTD+172
SAVTSCLU EQU   IEDNSVTD+168
SAVTXTRQ EQU   IEDNSVTD+164
SAVTMVBF EQU   IEDNSVTD+160
@NM00095 EQU   IEDNSVTD+148
SAVTIPCQ EQU   IEDNSVTD+144
@NM00094 EQU   IEDNSVTD+136
SAVTXFMI EQU   IEDNSVTD+132
@NM00093 EQU   IEDNSVTD+124
SAVTXFMO EQU   IEDNSVTD+120
@NM00092 EQU   IEDNSVTD+116
SAVTSSSR EQU   IEDNSVTD+112
SAVTSCPQ EQU   IEDNSVTD+108
SAVTSLCB EQU   IEDNSVTD+104
SAVTLUSR EQU   IEDNSVTD+100
@NM00091 EQU   SAVTLUSQ+8
SAVTLUSP EQU   SAVTLUSQ+4
SAVTLUSB EQU   SAVTLUSQ
@NM00090 EQU   IEDNSVTD+84
SAVTSAT  EQU   IEDNSVTD+80
SAVTNAT  EQU   IEDNSVTD+76
SAVTCLUP EQU   IEDNSVTD+72
SAVTPIUT EQU   IEDNSVTD+68
SAVTRNTA EQU   IEDNSVTD+64
SAVTDNIR EQU   IEDNSVTD+60
SAVTCNIR EQU   IEDNSVTD+56
SAVTFLDH EQU   IEDNSVTD+52
SAVTFAIL EQU   IEDNSVTD+42
SAVTSUSE EQU   IEDNSVTD+40
SAVTSIB  EQU   IEDNSVTD+36
SAVTPRTN EQU   IEDNSVTD+32
@NM00089 EQU   IEDNSVTD+28
SAVTWH20 EQU   IEDNSVTD+26
SAVTPWT  EQU   IEDNSVTD+24
SAVTPRTQ EQU   IEDNSVTD+20
SAVTPREQ EQU   IEDNSVTD+16
SAVTPH20 EQU   IEDNSVTD+14
SAVTPUSE EQU   IEDNSVTD+12
SAVTPLCB EQU   IEDNSVTD+8
SAVTPOOL EQU   IEDNSVTD+4
SAVTPRMT EQU   SAVTDIAF
SAVTVIRT EQU   SAVTDIAF
AVTCPBNO EQU   IEDQAVTD+1172
AVTHRESS EQU   IEDQAVTD+1171
@NM00088 EQU   IEDQAVTD+1170
@NM00087 EQU   IEDQAVTD+1169
@NM00086 EQU   IEDQAVTD+1168
@NM00085 EQU   IEDQAVTD+1165
@NM00084 EQU   IEDQAVTD+1164
AVTHRESE EQU   @NM00083
AVTRADDR EQU   IEDQAVTD+1156
AVTNADDR EQU   IEDQAVTD+1152
AVTHRESN EQU   IEDQAVTD+1148
AVTVOLRN EQU   IEDQAVTD+1144
AVTTOTNN EQU   IEDQAVTD+1140
AVTTRCYN EQU   IEDQAVTD+1136
AVTRCTRN EQU   IEDQAVTD+1132
AVTNOVON EQU   IEDQAVTD+1128
AVTADEBN EQU   IEDQAVTD+1124
AVTVOLRR EQU   IEDQAVTD+1120
AVTTOTNR EQU   IEDQAVTD+1116
AVTTRCYR EQU   IEDQAVTD+1112
AVTRCTRR EQU   IEDQAVTD+1108
AVTNOVOR EQU   IEDQAVTD+1104
AVTADEBR EQU   IEDQAVTD+1100
AVTLODPT EQU   IEDQAVTD+1096
AVTIOBN  EQU   IEDQAVTD+1092
AVTIOBR  EQU   IEDQAVTD+1088
AVTCPBPT EQU   IEDQAVTD+1084
AVTFCPB  EQU   IEDQAVTD+1080
@NM00082 EQU   IEDQAVTD+1076
AVTINCPQ EQU   IEDQAVTD+1072
@NM00081 EQU   IEDQAVTD+1068
@NM00080 EQU   IEDQAVTD+1065
@NM00079 EQU   AVTBIT4
@NM00078 EQU   AVTBIT4
@NM00077 EQU   AVTBIT4
@NM00076 EQU   AVTBIT4
@NM00075 EQU   AVTBIT4
@NM00074 EQU   AVTBIT4
@NM00073 EQU   AVTBIT4
AVTRUFTN EQU   AVTBIT4
@NM00072 EQU   IEDQAVTD+1060
AVTNOBFQ EQU   IEDQAVTD+1056
@NM00071 EQU   IEDQAVTD+1052
AVTDKENQ EQU   IEDQAVTD+1048
@NM00070 EQU   IEDQAVTD+1044
AVTDKAPQ EQU   IEDQAVTD+1040
AVTCOPY  EQU   IEDQAVTD+1036
AVTIA    EQU   IEDQAVTD+1032
AVTFL    EQU   IEDQAVTD+1028
@NM00069 EQU   IEDQAVTD+1024
AVTNCPBQ EQU   IEDQAVTD+1020
AVTTOTNC EQU   IEDQAVTD+1016
AVTCMAX  EQU   IEDQAVTD+1012
AVTCMIN  EQU   IEDQAVTD+1008
AVTHM02  EQU   IEDQAVTD+1004
AVTOPCIN EQU   IEDQAVTD+1002
AVTDCTLN EQU   IEDQAVTD+1000
AVTOPMSK EQU   IEDQAVTD+996
AVTDDFT  EQU   IEDQAVTD+992
AVTSTEAL EQU   IEDQAVTD+988
AVTOPTN  EQU   IEDQAVTD+984
AVTDSKCT EQU   IEDQAVTD+982
AVTCKRST EQU   IEDQAVTD+981
AVTSTAN  EQU   AVTBIT3
AVTSTACN EQU   AVTBIT3
AVTSTAIN EQU   AVTBIT3
AVTSTAYN EQU   AVTBIT3
AVTOLTBN EQU   AVTBIT3
AVTTSAB  EQU   AVTBIT3
AVTRFULN EQU   AVTBIT3
AVTRECVN EQU   AVTBIT3
@NM00068 EQU   AVTBIT2
@NM00067 EQU   AVTBIT2
AVTOPEIN EQU   AVTBIT2
AVTSTRTN EQU   AVTBIT2
AVTTOPOL EQU   AVTBIT2
AVTCOPYN EQU   AVTBIT2
AVTREUSN EQU   AVTBIT2
AVTEXTSC EQU   AVTBIT2
AVTDISKN EQU   AVTBIT1
AVTQUCKN EQU   AVTBIT1
AVTCLOSN EQU   AVTBIT1
AVTREADN EQU   AVTBIT1
AVTDLAYN EQU   AVTBIT1
AVTAQTAN EQU   AVTBIT1
AVTTSON  EQU   AVTBIT1
AVTAPLKN EQU   AVTBIT1
AVTDUMBR EQU   IEDQAVTD+976
AVTDLQX  EQU   IEDQAVTD+974
AVTINTLV EQU   IEDQAVTD+972
AVTSMCNT EQU   IEDQAVTD+970
AVTAVFCT EQU   IEDQAVTD+968
AVTOPCON EQU   IEDQAVTD+966
AVTOPCNT EQU   IEDQAVTD+964
AVTLNCNT EQU   IEDQAVTD+962
AVTKEYLE EQU   IEDQAVTD+960
AVTHA16  EQU   IEDQAVTD+958
AVTHA7   EQU   IEDQAVTD+956
AVTHA4   EQU   IEDQAVTD+954
AVTHA3   EQU   IEDQAVTD+952
AVTHA2   EQU   IEDQAVTD+950
AVTGETMS EQU   IEDQAVTD+949
@NM00066 EQU   IEDQAVTD+948
AVTGETMD EQU   IEDQAVTD+944
AVTGETMN EQU   IEDQAVTD+940
AVTCWTOT EQU   IEDQAVTD+936
AVTCWINT EQU   IEDQAVTD+884
AVTDTRAP EQU   IEDQAVTD+880
@NM00065 EQU   IEDQAVTD+878
@NM00064 EQU   AVTIOTR
AVTIOTRH EQU   AVTIOTR
AVTIOTRE EQU   AVTIOTR
@NM00063 EQU   AVTSUBT
AVTSUBPT EQU   AVTSUBT
AVTSUBON EQU   AVTSUBT
AVTAFE30 EQU   IEDQAVTD+872
AVTAFE20 EQU   IEDQAVTD+868
AVTAFE10 EQU   IEDQAVTD+864
AVTCWEC2 EQU   IEDQAVTD+860
AVTCWPM2 EQU   IEDQAVTD+856
AVTCWTS2 EQU   IEDQAVTD+855
AVTCWTS1 EQU   IEDQAVTD+854
AVTCWCLD EQU   AVTCWFL2
AVTCWRAP EQU   AVTCWFL2
@NM00062 EQU   AVTCWFL2
@NM00061 EQU   AVTCWFL2
@NM00060 EQU   AVTCWFL2
@NM00059 EQU   AVTCWFL2
@NM00058 EQU   AVTCWFL2
AVTCWACT EQU   AVTCWFL2
@NM00057 EQU   AVTCWFL1
@NM00056 EQU   AVTCWFL1
@NM00055 EQU   AVTCWFL1
@NM00054 EQU   AVTCWFL1
@NM00053 EQU   AVTCWFL1
@NM00052 EQU   AVTCWFL1
@NM00051 EQU   AVTCWFL1
AVTCOMWN EQU   AVTCWFL1
AVTCWEC1 EQU   IEDQAVTD+848
AVTCWPM1 EQU   IEDQAVTD+844
AVTCAREA EQU   IEDQAVTD+840
AVTFZERO EQU   IEDQAVTD+836
AVTCADDR EQU   IEDQAVTD+832
AVTCOREC EQU   IEDQAVTD+828
@NM00050 EQU   IEDQAVTD+820
AVTCPBCB EQU   IEDQAVTD+816
@NM00049 EQU   IEDQAVTD+808
AVTDSIOB EQU   IEDQAVTD+804
@NM00048 EQU   IEDQAVTD+796
AVTCPRMB EQU   IEDQAVTD+792
@NM00047 EQU   IEDQAVTD+784
AVTCLOSB EQU   IEDQAVTD+780
@NM00046 EQU   IEDQAVTD+772
AVTACTIB EQU   IEDQAVTD+768
@NM00045 EQU   IEDQAVTD+764
AVTOLTEB EQU   IEDQAVTD+760
AVTOLTCH EQU   AVTOLTQB+1
AVTOLTVT EQU   AVTOLTQB
@NM00044 EQU   AVTOPCQB+8
@NM00043 EQU   AVTOPCEC+1
@NM00042 EQU   AVTOPCCC
AVTOPCPO EQU   AVTOPCCC
AVTOPCWA EQU   AVTOPCCC
AVTOPCCH EQU   AVTOPCOB+1
AVTOPCVT EQU   AVTOPCOB
@NM00041 EQU   AVTCKPQB+9
AVTCKPTS EQU   AVTCKPQB+8
@NM00040 EQU   AVTCKPEC+1
@NM00039 EQU   AVTCKPCC
AVTCKPPO EQU   AVTCKPCC
AVTCKPWA EQU   AVTCKPCC
AVTCKPCH EQU   AVTCKPTB+1
AVTCKPVT EQU   AVTCKPTB
@NM00038 EQU   IEDQAVTD+724
AVTBFRTB EQU   IEDQAVTD+720
@NM00037 EQU   IEDQAVTD+712
AVTBFREB EQU   IEDQAVTD+708
AVTTIMQ  EQU   IEDQAVTD+704
@NM00036 EQU   IEDQAVTD+700
AVTIMQPS EQU   IEDQAVTD+696
AVTINOUT EQU   IEDQAVTD+694
AVTREFTM EQU   IEDQAVTD+692
@NM00035 EQU   IEDQAVTD+680
AVTDELYB EQU   IEDQAVTD+676
AVTOCQPT EQU   IEDQAVTD+672
AVTTSOPT EQU   IEDQAVTD+668
AVTSUPPT EQU   IEDQAVTD+664
AVTCBQCB EQU   IEDQAVTD+660
AVTMSGS  EQU   IEDQAVTD+657
@NM00034 EQU   AVTSYSER
@NM00033 EQU   AVTSYSER
@NM00032 EQU   AVTSYSER
@NM00031 EQU   AVTSYSER
@NM00030 EQU   AVTSYSER
@NM00029 EQU   AVTSYSER
AVTCMAXN EQU   AVTSYSER
AVTCMINN EQU   AVTSYSER
AVT2260L EQU   IEDQAVTD+652
AVTABEPL EQU   AVTADBUF
AVTHFF   EQU   AVTCLRHI+2
@NM00028 EQU   AVTCLRHI
AVTCCLNK EQU   AVTCRELE+5
AVTCCPRI EQU   AVTCRELE+4
AVTCCQCB EQU   AVTCCELE+1
AVTCCKEY EQU   AVTCCELE
AVTDELAD EQU   IEDQAVTD+632
AVTDELEM EQU   IEDQAVTD+628
AVTBSX   EQU   AVTCKLNK
AVTOPETR EQU   AVTHG01
@NM00027 EQU   AVTCKBYT
AVTCKONQ EQU   AVTCKBYT
@NM00026 EQU   AVTCKBYT
@NM00025 EQU   AVTCKBYT
@NM00024 EQU   AVTCKBYT
@NM00023 EQU   AVTCKBYT
@NM00022 EQU   AVTCKBYT
@NM00021 EQU   AVTCKBYT
AVTOPERT EQU   IEDQAVTD+618
AVTOPXCL EQU   IEDQAVTD+616
AVTOPERL EQU   IEDQAVTD+615
@NM00020 EQU   IEDQAVTD+614
AVTCKTIM EQU   IEDQAVTD+612
AVTCKELV EQU   IEDQAVTD+610
AVTCPRCD EQU   IEDQAVTD+609
AVTWARMN EQU   AVTCKELF
AVTCRTLN EQU   AVTCKELF
AVTCPIPN EQU   AVTCKELF
AVTCCLCN EQU   AVTCKELF
AVTCINCN EQU   AVTCKELF
@NM00019 EQU   AVTCKELF
AVTCMCPN EQU   AVTCKELF
AVTCRDYN EQU   AVTCKELF
AVTCKQAD EQU   IEDQAVTD+605
AVTSCBSZ EQU   IEDQAVTD+604
@NM00018 EQU   IEDQAVTD+600
AVTCKELE EQU   IEDQAVTD+596
@NM00017 EQU   AVTCKPEL+8
AVTCKRLK EQU   AVTCKPEL+5
AVTCKRPR EQU   AVTCKPEL+4
AVTCKRMQ EQU   AVTCKRMV+1
AVTCKRKY EQU   AVTCKRMV
AVTHK    EQU   IEDQAVTD+576
AVTHI    EQU   IEDQAVTD+572
AVTIOT   EQU   IEDQAVTD+568
AVTNX    EQU   IEDQAVTD+564
AVTTONE  EQU   IEDQAVTD+560
AVTA3TL  EQU   IEDQAVTD+556
AVTDMECB EQU   IEDQAVTD+552
AVTABEND EQU   IEDQAVTD+546
AVTPLCBN EQU   IEDQAVTD+544
@NM00016 EQU   AVTSAVTP+1
@NM00015 EQU   AVTSAVTF
AVTSNA   EQU   AVTSAVTF
AVTONSNA EQU   AVTSAVTF
AVTVTMCP EQU   AVTSAVTF
@NM00014 EQU   IEDQAVTD+536
AVTCMBSS EQU   IEDQAVTD+532
AVTRCV   EQU   IEDQAVTD+528
AVTSEND  EQU   IEDQAVTD+524
AVTCSCH  EQU   IEDQAVTD+520
AVTQ1    EQU   IEDQAVTD+516
AVTE7    EQU   IEDQAVTD+512
AVTHB    EQU   IEDQAVTD+508
AVTR1    EQU   IEDQAVTD+504
AVTBZ    EQU   IEDQAVTD+500
AVTEZ    EQU   IEDQAVTD+496
AVTEC    EQU   IEDQAVTD+492
AVTEW    EQU   IEDQAVTD+488
AVTNDIAL EQU   AVTSCOPT
AVTN2741 EQU   AVTSCOPT
AVTCONCO EQU   AVTSCOPT
AVTCONC  EQU   AVTSCOPT
AVTCMBUF EQU   AVTSCOPT
AVTAPDMP EQU   AVTSCOPT
@NM00013 EQU   AVTSCOPT
AVTHA    EQU   AVTDISP
AVTEA    EQU   IEDQAVTD+476
AVTAX    EQU   IEDQAVTD+472
AVTA3    EQU   IEDQAVTD+468
AVTGD    EQU   IEDQAVTD+464
AVTAL    EQU   IEDQAVTD+460
AVTOLTST EQU   AVTHG02
AVTE8    EQU   IEDQAVTD+452
AVTUI    EQU   IEDQAVTD+448
AVTCOMPT EQU   IEDQAVTD+444
AVTCRSRF EQU   IEDQAVTD+440
@NM00012 EQU   IEDQAVTD+436
AVTKA02  EQU   IEDQAVTD+432
AVTOPTPT EQU   IEDQAVTD+428
AVTPCBPT EQU   IEDQAVTD+424
AVTOSECB EQU   IEDQAVTD+420
AVTOPECA EQU   IEDQAVTD+416
AVTOLECA EQU   IEDQAVTD+412
AVTCKECA EQU   IEDQAVTD+408
AVTCWECA EQU   IEDQAVTD+404
AVTCWTCB EQU   IEDQAVTD+400
AVTOLTCB EQU   IEDQAVTD+396
AVTOCTCB EQU   IEDQAVTD+392
AVTCKTCB EQU   IEDQAVTD+388
AVTAS    EQU   IEDQAVTD+384
AVTNOLBF EQU   IEDQAVTD+382
AVTNCKPR EQU   IEDQAVTD+381
AVTCIB   EQU   IEDQAVTD+380
AVTSPLPT EQU   IEDQAVTD+376
AVTMVBFR EQU   IEDQAVTD+372
AVTSBTA  EQU   IEDQAVTD+368
AVTRARTN EQU   IEDQAVTD+364
AVTBSCAN EQU   IEDQAVTD+360
AVTRDYA  EQU   IEDQAVTD+356
AVTRNMPT EQU   IEDQAVTD+352
AVTDISTR EQU   IEDQAVTD+348
AVTPARM3 EQU   IEDQAVTD+344
@NM00011 EQU   AVTPKF
@NM00010 EQU   AVTPKF
@NM00009 EQU   AVTPKF
AVTFTCHF EQU   AVTPKF
@NM00008 EQU   AVTPKF
@NM00007 EQU   AVTPKF
@NM00006 EQU   AVTPKF
@NM00005 EQU   AVTPKF
AVTPARM  EQU   IEDQAVTD+336
AVTEXS2A EQU   IEDQAVTD+330
AVTEXA2S EQU   IEDQAVTD+324
AVTOCGET EQU   IEDQAVTD+320
AVTCKAVT EQU   @NM00003+1
@NM00004 EQU   AVTCKFLG
AVTCKHLT EQU   AVTCKFLG
AVTCKREQ EQU   AVTCKFLG
AVTCKENV EQU   AVTCKFLG
AVTCKNAC EQU   AVTCKFLG
AVTCKTAC EQU   AVTCKFLG
@NM00002 EQU   IEDQAVTD+312
AVTREADD EQU   IEDQAVTD+308
AVTREADY EQU   IEDQAVTD+304
AVTRACE  EQU   IEDQAVTD+300
AVTTCB   EQU   IEDQAVTD+296
AVTPASWD EQU   IEDQAVTD+288
AVTCTLCH EQU   IEDQAVTD+280
AVTDOUBX EQU   IEDQAVTD+264
AVTDPARM EQU   IEDQAVTD+260
AVTCSTCS EQU   IEDQAVTD+256
AVTDLQ   EQU   AVTSAVEX+32
@NM00001 EQU   AVTSAVEX
AVTSAVE4 EQU   IEDQAVTD+144
AVTSAVE3 EQU   IEDQAVTD+72
AVTSAVE2 EQU   IEDQAVTD
.@UNREFD ANOP                          END UNREFERENCED COMPONENTS
@ENDDATA EQU   *
         END   IEDXTREQ,(C'PLS2020',0701,76363)
