   TITLE  ' IGC0003D IGC0503D IGG2103D IEE0503D IEE2103D  MESSAGE MOD'
***********************************************************************
*                                                                     *
*  MODULE NAME =  IEE0503D                                       Y01939
*                                                                     *
*  DESCRIPTIVE NAME =  MESSAGE ASSEMBLY MODULE                   Y01939
*                                                                Y01939
*  COPYRIGHT =  NONE                                             Y01939
*                                                                Y01939
*  STATUS =  OS/VS2 - SERVICE DATA IMPROVEMENTS                @G17FPSS
*                                                                Y01939
*  FUNCTION =                                                    Y01939
*              ASSEMBLES AND EDITS MESSAGES FOR COMMAND          Y01939
*              EXECUTION AND ISSUES WTO OR TPUT MACRO.  SEE T2   Y01939
*              TABLE FOR MESSAGE TEXTS.                          Y01939
*                                                                     *
*     OPERATION =                                                Y01939
*               MESSAGES ARE SCHEDULED BY PROVIDING A CODE IN THEY01939
*               EXTENDED SAVE AREA (XSA), IN THE BYTE LABELED    Y01939
*               XAE. THIS CODE IS CHECKED TO BE WITHIN THE       Y01939
*               LIMITS OF THE CODE TABLE, T1.  THIS CODE ITSELF  Y01939
*               IS USED AS INDEX TO T1, WHICH CONTAINS AS        Y01939
*               ELEMENTS, POINTERS TO A MESSAGE TEXT TABLE, T2.  Y01939
*                                                                     *
*   THE MESSAGE IS ASSEMBLED THIS WAY -                               *
*   A. THE CORE FOR THE WTO PARAMETER LIST IS GOTTEN VIA CONDITIONAL
*      GETMAIN FOR 64 BYTES FROM SUBPOOL 230 OR, FAILING THAT, @Y02668P
*      VIA UNCONDITIONAL GETMAIN FROM SUBPOOL 245.               Y01939
*   B. THE PREFORMATTED TEXT (I. E. THE OUTPUT OF THE LIST FORM  Y01939
*      WTO MACRO)IS MOVED IN.                                    Y01939
*   C. THE VERB IS MOVED FROM XAV TO XAFMSG IN THE GOTTEN CORE,  Y01939
*      THUS FILLING IN THE VARIABLE SOURCE TEXT.                 Y01939
*   D. THE TERMINAL/CONSOLE ID IS MOVED FROM XAA/XAU TO REG 0.   Y02669
*   E. THE MSG. LN. IS PUT IN REG 0(IF TPUT).                    Y01939
*   F. THE WTO (TO CONSOLE) OR TPUT (TO TERMINAL) IS ISSUED.     Y01939
*   G. THE STORAGE GOTTEN FOR THE WTO PARAMETER LIST IS FREED    Y01939
*      FROM THE APPROPRIATE SUBPOOL.                             Y01939
*                                                                     *
*  NOTES =                                                       Y01939
*       THE MESSAGES WHICH RESIDE IN IEE2103D IN OS HAVE BEEN    Y01939
*   MOVED TO THIS MODULE FOR VS/2. THE MESSAGE CODES, PASSED TO  Y01939
*   THE MODULE IN THE XSA REMAIN UNCHANGED.                      Y01939
*                                                                     *
*     CHARACTER-CODE DEPENDENCIES =                              Y01939
*   THE OPERATION OF THIS MODULE DEPENDS UPON AN INTERNAL        Y01939
*   REPRESENTATION OF THE EXTERNAL CHARACTER SET WHICH IS EQUIVALENT  *
*   TO THE ONE USED AT ASSEMBLY TIME. THE CODING HAS BEEN ARRANGED SO *
*   THAT REDEFINITION OF 'CHARACTER' CONSTANTS, BY REASSEMBLY, WILL   *
*   RESULT IN A CORRECT MODULE FOR THE NEW DEFINITIONS.               *
*                                                                Y01939
*     DEPENDENCIES =  WTO, TPUT, GETMAIN, FREEMAIN               Y01939
*                                                                Y01939
*     RESTRICTIONS =  THIS MODULE EXPECTS REGISTER TWO TO POINT  Y01939
*                     TO THE EXTENDED SAVE AREA.  IT SAVES NO    Y01939
*                     REGISTERS, AND DESTROYS REGISTERS 0,1,3,4, Y01939
*                     AND 5.   IT DOES  NOT ALTER REGISTER 13,   Y01939
*                     AND RESTORES REGISTER 15.                  Y01939
*                                                                Y01939
*     REGISTER-CONVENTIONS =                                     Y01939
*                     REGISTER 0      UCMI                       Y01939
*                     REGISTER 1      T2 TABLE POINTER           Y01939
*                     REGISTER 2      XSA BASE                   Y01939
*                     REGISTER 4      MODULE BASE                Y01939
*                     REGISTER 5      ADDRESS OF GOTTEN BUFFER   Y01939
*                     REGISTER 15     TPUT RETURN CODE           Y01939
*                                                                Y01939
*     PATCH-LABEL =  PATCH                                       Y01939
*                                                                Y01939
*  MODULE-TYPE =  CSECT                                          Y01939
*                                                                Y01939
*     PROCESSOR =  ASSEMBLER                                     Y01939
*                                                                Y01939
*     MODULE-SIZE = N/A                                          Y01939
*                                                                Y01939
*     ATTRIBUTES =                                               Y01939
*                   PAGED LPA             REENTRANT              Y01939
*                   ZERO PSW PROTECT KEY  REUSABLE               Y01939
*                   SUPERVISOR MODE       REFRESHABLE            Y01939
*                                                                Y01939
*  ENTRY POINT =  IEE0503D                                       Y01939
*                                                                Y01939
*     PURPOSE =  TO ISSUE A MESSAGE, AS SPECIFIED BY THE VALUE   Y01939
*                IN THE XAE FIELD OF THE XSA.                    Y01939
*                                                                Y01939
*     LINKAGE =  REGISTER TWO CONTAINS THE ADDRESS OF AN XSA,    Y01939
*                INITIALIZED AS FOLLOWS:                         Y01939
*                FIELD         CONTENTS                          Y01939
*                XAE           MESSAGE INDEX                     Y01939
*                XAV           VARIABLE TEXT FOR MESSAGE         Y01939
*                XAU           UCM ENTRY INDICATOR FOR WTO       Y01939
*                XAA           ASID FOR TPUT                     Y02669
*                                                                Y01939
*     INPUT DATA =  AS DESCRIBED ABOVE.                          Y01939
*                                                                Y01939
*     REGISTERS SAVED =  REGISTER 15                             Y01939
*                                                                Y01939
*     REGISTER CONTENTS DURING PROCESSING =                      Y01939
*                   REGISTER 2        XSA ADDRESS                Y01939
*                   REGISTER 5        ADDRESS OF GOTTEN BUFFER   Y01939
*                   REGISTER 14       RETURN ADDRESS             Y01939
*                                                                Y01939
*     REGISTERS RESTORED =  REGISTER 15                          Y01939
*                                                                Y01939
*  ENTRY POINT =  IGC0503D                                       Y01939
*                           ALL CONDITIONS ARE IDENTICAL TO      Y01939
*                           THOSE FOR IEE0503D                   Y01939
*                                                                Y01939
*  ENTRY POINT =  IEE2103D                                       Y01939
*                           ALL CONDITIONS ARE IDENTICAL TO      Y01939
*                           THOSE FOR IEE0503D                   Y01939
*                                                                Y01939
*  ENTRY POINT =  IGG2103D                                       Y01939
*                           ALL CONDITIONS ARE IDENTICAL TO      Y01939
*                           THOSE FOR IEE0503D                   Y01939
*                                                                Y01939
*  EXIT-NORMAL =  FREECORE                                       Y01939
*     CONDITIONS =  AFTER ISSUING THE REQUESTED MESSAGE, THE     Y01939
*                   BUFFER IS FREED VIA FREEMAIN, HAVING         Y01939
*                   RECOVERED THE SUBPOOL AND LENGTH FROM THE    Y01939
*                   XSA, AND EXIT TAKEN VIA BRANCH TO THE        Y01939
*                   ADDRESS IN REGISTER 14.                      Y01939
*                                                                Y01939
*     OUTPUT DATA =                                              Y01939
*                                                                Y01939
*     RETURN CODES =  THE CONTENTS OF REGISTER 15 ON ENTRY ARE   Y01939
*                     RESTORED.                                  Y01939
*                                                                Y01939
*  EXIT-ERROR =  FREECORE                                        Y01939
*     CONDITIONS =  THE MESSAGE INDEX IN THE XAE CORRESPONDS TO  Y01939
*                   AN OBSOLETE MESSAGE.  THE BUFFER IS          Y01939
*                   FREED VIA FREEMAIN, HAVING RECOVERED THE     Y01939
*                   SUBPOOL AND LENGTH FROM THE XSA, AND EXIT    Y01939
*                   TAKEN VIA BRANCH TO THE ADDRESS IN REGISTER  Y01939
*                   14.                                          Y01939
*                                                                Y01939
*     RETURN CODES =  THE CONTENTS OF REGISTER 15 ON ENTRY ARE   Y01939
*                     RESTORED.                                  Y01939
*                                                                Y01939
*  EXIT-ERROR =  ERREXIT                                         Y01939
*     CONDITIONS =  THE MESSAGE INDEX IN THE XAE IS GREATER THAN Y01939
*                   THAT OF ANY MESSAGE.  EXIT TAKEN VIA BRANCH  Y01939
*                   TO THE ADDRESS IN REGISTER 14.               Y01939
*                                                                Y01939
*     RETURN CODES =  THE CONTENTS OF REGISTER 15 ON ENTRY ARE   Y01939
*                     UNCHANGED.                                 Y01939
*                                                                Y01939
*  EXTERNAL REFERENCES =                                         Y01939
*     REFERENCES =                                               Y01939
*                                                                Y01939
*     DATA AREAS =  64 BYTE BUFFER FOR MESSAGE                 @Y02668P
*                                                                Y01939
*     CONTROL BLOCKS =  EXTENDED SAVE AREA (XSA) OF THE CURRENT  Y01939
*                       SVRB.  USE:                              Y01939
*                       XAV   VARIABLE TEXT                      Y01939
*                       XAU   UCMI FOR WTO                       Y01939
*                       XAA   ASID FOR TPUT                      Y02669
*                       XAE   MESSAGE INDEX                      Y01939
*       TABLES =                                                 Y01939
*              MESSAGE ASSEMBLY TABLES, T1 AND T2.  T1           Y01939
*              INDEXED BY TWICE THE INCOMING MESSAGE CODE. T2,   Y01939
*              CONTAINING THE PREFORMATTED TEXT, IS REFERENCED   Y01939
*              BY T1.                                            Y01939
*                                                                Y01939
*     MACROS =  IEEXSA, WTO, TPUT, GETMAIN, FREEMAIN, MODID      Y01939
*                                                                Y01939
*     CHANGE LEVEL =  Y01939, @Y02668P, @Y30LPSV, @G17FPSS     @G17FPSS
*                                                                Y01939
*     MESSAGES =                                                 Y01939
*               ID        XAE CODE     ID         XAE CODE       Y01939
*               IEE019I    X'13'       IEE023I     X'17'         Y01939
*               IEE026I    X'1A'       IEE078I     X'18'       @Y30LPSV
*               IEE084I    X'19'       IEE138I     X'28'       @Y30LPSV
*               IEE298I    X'2B'       IEE299I     X'2D'         Y01939
*               IEE301I    X'01',X'02' IEE304I     X'04'       @G17FPSS
*               IEE305I    X'05'       IEE306I     X'06'         Y01939
*               IEE307I    X'07'       IEE308I     X'08'         Y01939
*               IEE309I    X'09'       IEE310I     X'0A'         Y01939
*               IEE311I    X'0B'       IEE312I     X'0C'         Y01939
*               IEE313I    X'0D'       IEE314I     X'0E'         Y01939
*               IEE315I    X'0F'       IEE324I     X'35'         Y02669
*               IEE328I    X'3A'       IEE335I     X'23'         Y02669
*               IEE338I    X'2A'       IEE339I     X'2C'         Y01939
*               IEE341I    X'24'       IEE342I     X'25'
*               IEE345I    X'29'       IEE376I     X'2E'         Y01939
*               IEE377I    X'2F'       IEE378I     X'30'         Y01939
*               IEE379I    X'31'       IEE380I     X'32'         Y01939
*               IEE381I    X'33'       IEE382I     X'34'         Y01939
*               IEE535I    X'3E'       IEE707I     X'3C'         Y02669
*               IEE708I    X'3D'       IEE711I     X'3F'         Y02669
*               IEE712I    X'03'       IEE777I     X'15'       @Y02668P
*               IEE838I    X'1B'       IEE841I     X'16',X'1C' @G17FPSS
*               IEE907I    X'37',X'38' IEE908I     X'39'         Y01939
*                                                                     *
*  SYSGEN =                                                      Y01939
*      THIS MODULE APPEARS IN SYS1.LPALIB IN LOAD MODULE         Y01939
*   IGC0003D, SEVERAL ALIASES OF WHICH (VIZ. IGC0503D, IEE0503D, Y02669
*   IGG2103D, AND IEE2103D) REFER TO THIS MODULE. THE MODULE IS  Y02669
*   INCLUDED AT SYSGEN FROM DLIB A0SB3 BY SYSGEN MACRO SGIEF441. Y02669
*                                                                Y01939
*  SYSTEM LIBRARIES =  NO SYSTEM LIBRARIES ARE READ OR CHANGED   Y01939
*                      BY THIS MODULE.                           Y01939
*                                                                     *
***********************************************************************
         EJECT
IEE0503D CSECT
         ENTRY IGC0503D                                          Y01939
         ENTRY IEE2103D                                          Y01939
         ENTRY IGG2103D                                          Y01939
*         REGISTER ASSIGNMENTS                                        *
R0       EQU   0                        FOR PASSING UCMI           IMCS
R1       EQU   1                             T2 POINTER
R2       EQU   2                             BASE FOR XSA
R3       EQU   3                             WORK REGISTER
MBASE    EQU   4                             BASE FOR PROGRAM
R5       EQU   5                        WORK REG                  M2070
R14      EQU   14                       RETURN REG                20774
R15      EQU   15                       TPUT RETURN CODE REG      20030
D0       EQU   0                        LENGTHS,OFFSETS,ETC.      20774
D1       EQU   1                        *                         20774
D2       EQU   2                        *                         20774
D3       EQU   3                        *                         20774
D4       EQU   4                                                  M3335
D5       EQU   5                        *                         20774
D7       EQU   7                        *                         20774
D8       EQU   8                        *                         20774
D9       EQU   9                        *                         20774
D10      EQU   10                       *                        Y01939
D18      EQU   18                       *                         20030
D22      EQU   22                       *                         20774
D24      EQU   24                       *                         20030
BLANK    EQU   C' '                     *                         20774
FLAG     EQU   X'80'                    FLAG - DENOTES TPUT RETRY 20030
          SPACE 2
*  THE FOLLOWING EQUATE MUST BE INCREASED BY ONE FOR EACH        Y01939
*  MESSAGE ADDED TO THIS MODULE                                  Y01939
CODHI    EQU   63                       HIGHEST VALID MSG CODE   Y02669
          EJECT
*****************************************************************Y01939
*                                                                Y01939
*        EXTERNAL ENTRY POINT NAMES                              Y01939
*                                                                Y01939
*****************************************************************Y01939
IGC0503D EQU   *                                                 Y01939
IEE2103D EQU   *                                                 Y01939
IGG2103D EQU   *                                                 Y01939
          SPACE
*A  ESTABLISH PROGRAM ADDRESSABILITY                                  *
         BALR  MBASE,0
         USING *,MBASE
         MODID BRANCH=YES                                        Y01886
         USING XSA,R2                   BASE REGISTER FOR XSA    Y01939
          SPACE
*B  CHECK FOR INCORRECT MESSAGE CODE                                  *
         CLI   XAE,CODHI                COMPARE WITH MAXIMUM     Y01939
ERREXIT  EQU     *                                               Y01939
         BCR   D2,R14                   TOO HIGH. RETURN.         20774
         ST    R15,XAS+D4               SAVE RETURN CODE REG     Y01939
          EJECT
*****************************************************************Y01939
*                                                                Y01939
* GET STORAGE FOR WTO PARAMETER LIST FROM SP230 OR SP245       @Y02668P
*                                                                Y01939
*****************************************************************Y01939
          SPACE 2
         MVC   XSA(D10),LISTFORM        MOVE CONDITIONAL GETMAIN Y01939
*                                       PARM LIST TO XSA         Y01939
         LA    R1,XAD                   GET STORAGE ADDRESS    @Y02668P
         ST    R1,XAD                   PROVIDE ADDRESS FOR      Y01939
*                                       GETMAIN                  Y01939
         LR    R1,R2                    PROVIDE ADDRESS OF       Y01939
*                                       PARMLIST TO GETMAIN      Y01939
         SPACE 2
         GETMAIN MF=(E,(1))             GET STORAGE IN SP230   @Y02668P
         MVC   XAS(D4),SP230            SAVE SUBPOOL AND LEN   @Y02668P
*                                       FOR FREEMAIN             Y01939
         LTR   R15,R15                  WAS CORE GOTTEN?         Y01939
         L     R1,XAD                   PREPARE FOR ADDRESSABILITY01939
*                                       TO GOTTEN CORE           Y01939
         BZ    GOTCORE                  YES, BRANCH AROUND SP245 Y01939
*                                       GETMAIN                  Y01939
         GETMAIN R,LV=64,SP=245         NO, GET FROM SP245     @Y02668P
         MVC   XAS(D4),SP245            SAVE SUBPOOL AND LENGTH  Y01939
*                                       FOR FREEMAIN             Y01939
GOTCORE  EQU   *                                                 Y01939
         LR    R5,R1                    SAVE ADDR OF GOTTEN CORE Y01939
          SPACE
* BUILD MESSAGE IN GOTTEN CORE                                   Y01939
         USING MSG,R5                   ADDRESSABILITY TO        Y01939
*                                       GOTTEN CORE              Y01939
         SR    R3,R3                    CLEAR WORKING REGISTER   Y01939
         EJECT
* OBTAIN MESSAGE CODE AND COMPUTE APPROPRIATE T1 ELEMENT ADDRESS
*     A T1 ENTRY IS THE OFFSET OF THE MESSAGE TEXT IN TABLE T2   Y01939
         SPACE
         IC    R3,XAE                   GET MESSAGE CODE         Y01939
         AR    R3,R3                    DOUBLE FOR INDEXING
         LA    R1,T1(R3)                PT TO APPROPRIATE T1 ELEMENT
         LH    R1,0(R1)                 LOAD TABLE ELEMENT
         LTR   R1,R1                  OBSOLETE MSG (DELETED FROM TABLE)
         BC    D4,FREECORE              YES, RETURN (NO MSG)     Y01939
          SPACE 2
* FILL IN MESSAGE ID, PREFORMATTED TEXT AND VARIABLE TEXT        Y01939
         LA    R3,T2(R1)                PT TO APPRPRIATE T2 ELEMENT
         LH    R1,D0(R3)                GET LENGTH OF WTO LIST   Y01939
         EX    R1,FAUPFT                MOVE MSG. TEXT IN
         MVC   XAFMSG(D8),XAV           MOVE VARIABLE SOURCE TEXTY01939
          SPACE 2
* DECIDE TO TPUT OR WTO                                          Y01939
         LH    R0,XAA                   LOAD ASID INTO REG 0     Y02669
         LTR   R0,R0                    MSG TO TERMINAL OR CONSOLE20030
         BZ    CONSOLE                  MSG TO CONSOLE           Y01939
           EJECT
*****************************************************************Y01939
*                                                                Y01939
*        SET UP FOR TPUT TO A TERMINAL                            20030
*                                                                Y01939
*****************************************************************Y01939
           SPACE 2
         LR    R3,R0                    MOVE ASID TO REG 3        20030
TPUTMSG  EQU   *                                                  20030
         LA    R1,XAIMSG                MSG ADDR (NO HEADER)     Y01939
*                                       RETURN TO SYSTEM         Y01939
         SR    R0,R0                    CLEAR FOR INSERT CHAR    Y01939
         IC    R0,XAHMSG+D1             GET TEXT LENGTH FOR TPUT Y01939
         SH    R0,FOUR                  WTO LENGTH MINUS FOUR    Y01939
         TPUT  (1),(0),TJID=(3)                                   20030
         CH    R15,ERRCODE              CHECK TPUT RETURN CODE    20030
         BC    D7,FREECORE              FREE MESSAGE AREA AND    Y01939
*                                       RETURN TO SYSTEM         Y01939
         TM    XAHMSG,FLAG              HAS A RETRY BEEN ATTEMPEDY01939
         BC    D1,FREECORE              YES. FREE MESSAGE AREA   Y01939
*                                       AND RETURN TO SYSTEM     Y01939
         OI    XAHMSG,FLAG              SET FLAG TO DENOTE RETRY Y01939
         B     TPUTMSG                  RETRY TPUT                20030
CONSOLE  EQU   *                                                  20030
         SPACE 3
* SET UP FOR WTO TO A CONSOLE                                     20030
         IC    R0,XAU                   GET CONS ID FOR WTO      Y01939
         WTO   MF=(E,(R5))              WRITE MSG.               Y01939
           EJECT
*****************************************************************Y01939
*                                                                Y01939
*        FREEMAIN THE CORE GOTTEN FOR WTO PARAMETER LIST         Y01939
*                                                                Y01939
*****************************************************************Y01939
          SPACE 2
FREECORE EQU   *                                                 Y01939
         L     R0,XAS                   GET SUBPOOL AND LENGTH   Y01939
         LR    R1,R5                    RESTORE CORE ADDR.       Y01939
         FREEMAIN R,LV=(0),A=(1)        FREE WTO CORE            Y01939
         L     R15,XAS+D4               RESTORE RETURN CODE REG  Y01939
         BR    14                       RETURN TO SYSTEM
         EJECT
ERRCODE  DC    X'0014'                  TPUT RETURN CODE - MSG    20030
*                                       DID NOT GO DUE TO AN      20030
*                                       OUTSTANDING TPUT          20030
FOUR     DC    H'4'                     USED IN SH INSTRUCTION   Y01939
*                                       FOR TPUT                 Y01939
         DS    0F                                                Y01939
SP230    DC    X'E6000040'              SP230 AND LENGTH FOR   @Y02668P
*                                       FREEMAIN                 Y01939
SP245    DC    X'F5000040'              SP245 AND LENGTH FOR   @Y02668P
*                                       FREEMAIN                 Y01939
         SPACE 2
         DS    0F                       FOR BOUNDARY ALIGNMENT   Y01939
LISTFORM GETMAIN EC,LV=64,A=0,SP=230,MF=L                      @Y02668P
         SPACE 2
FAUPFT   MVC   MSG(D1),D2(R3)           MOVE PREFORMATTED MESSAGEY01939
*                                       TO GOTTEN CORE.          Y01939
*        R3 POINTS TO THE LENGTH OF THE MESSAGE, IN THE T2       Y01939
*        TABLE. TWO BYTES BEYOND THIS, THE WTO PARAMETER LIST,   Y01939
*        WHICH IS TO BE MOVED, STARTS.                           Y01939
*
         EJECT
* THE FOLLOWING TABLE IS INDEXED BY TWICE THE MSG. CODE. EACH HALF-
* WORD POINTS TO A T2 ELEMENT CONTAINING THE APPROPRIATE MESSAGE.
         SPACE 2
T1       EQU   *
         SPACE 2
         DC    AL2(0)
         DC    Y(TM01-T2)               *                        Y01939
         DC    Y(TM02-T2)               *                      @G17FPSS
         DC    Y(TM03-T2)               *                        Y02669
         DC    Y(TM04-T2)               *                        Y01939
         DC    Y(TM05-T2)               *                        Y01939
         DC    Y(TM06-T2)               *                        Y01939
         DC    Y(TM07-T2)               *                        Y01939
         DC    Y(TM08-T2)               *                        Y01939
         DC    Y(TM09-T2)               *                        Y01939
         DC    Y(TM10-T2)               *                        Y01939
         DC    Y(TM11-T2)               *                        Y01939
         DC    Y(TM12-T2)               *                        Y01939
         DC    Y(TM13-T2)               *                        Y01939
         DC    Y(TM14-T2)               *                        Y01939
         DC    Y(TM15-T2)               *                        Y01939
         DC    X'FFFF'                  OBSOLETE MSG SLOT        Y02669
         DC    X'FFFF'                  OBSOLETE MSG SLOT        Y02669
         DC    X'FFFF'                  OBSOLETE MSG SLOT        Y02669
         DC    Y(TM19-T2)               *                        Y01939
         DC    X'FFFF'                  MESSAGE NOW IN IEE90110  YM1294
         DC    Y(TM21-T2)               *                      @Y02668P
         DC    Y(TM22-T2)               *                      @G17FPSS
         DC    Y(TM23-T2)               *                        Y01939
         DC    Y(TM24-T2)               *                      @Y30LPSV
         DC    Y(TM25-T2)               *                      @Y30LPSV
         DC    Y(TM26-T2)               *                        Y01939
         DC    Y(TM27-T2)               *                      @G17FPSS
         DC    Y(TM28-T2)               *                      @G17FPSS
         DC    X'FFFF'                  OBSOLETE MSG SLOT         M3335
         DC    X'FFFF'                  OBSOLETE MSG SLOT        Y02669
         DC    X'FFFF'                  OBSOLETE MSG SLOT        Y02669
         DC    X'FFFF'                  OBSOLETE MSG SLOT        Y02669
         DC    X'FFFF'                  OBSOLETE MSG SLOT        Y02669
         DC    X'FFFF'                  MESSAGE NOW IN IEE90110    R271
         DC    Y(TM35-T2)               *                        Y01939
         EJECT
***************************************************************  Y01939
*                                                             *  Y01939
*            OFFSETS FORMERLY IN IEE2103D                     *  Y01939
*                                                             *  Y01939
***************************************************************  Y01939
         SPACE 2
         DC    Y(TM36-T2)               *                        Y01939
         DC    Y(TM37-T2)               *                        Y01939
         DC    X'FFFF'                  OBSOLETE MSG SLOT        Y01939
         DC    X'FFFF'                  OBSOLETE MSG SLOT        Y01939
         DC    Y(TM40-T2)               *                        Y01939
         DC    Y(TM41-T2)               *                        Y01939
         DC    Y(TM42-T2)               *                        Y01939
         DC    Y(TM43-T2)               *                        Y01939
         DC    Y(TM44-T2)               *                        Y01939
         DC    Y(TM45-T2)               *                        Y01939
         DC    Y(TM46-T2)               *                        Y01939
         DC    Y(TM47-T2)               *                        Y01939
         DC    Y(TM48-T2)               *                        Y01939
         DC    Y(TM49-T2)               *                        Y01939
         DC    Y(TM50-T2)               *                        Y01939
         DC    Y(TM51-T2)               *                        Y01939
         DC    Y(TM52-T2)               *                        Y01939
         DC    Y(TM53-T2)               *                        Y01939
         DC    X'FFFF'                  OBSOLETE MSG SLOT        Y02669
         DC    Y(TM55-T2)               *                        Y01939
         DC    Y(TM56-T2)               *                        Y01939
         DC    Y(TM57-T2)               *                        Y01939
         DC    Y(TM58-T2)               *                        Y01939
         DC    X'FFFF'                  OBSOLETE MSG SLOT        Y02669
         DC    Y(TM60-T2)               *                        Y01939
         DC    Y(TM61-T2)               *                        Y02669
         DC    Y(TM62-T2)               *                        Y02669
         DC    Y(TM63-T2)               *                        Y02669
         EJECT
* THE FOLLOWING TABLE CONTAINS THE LIST FORM OF THE WTO MACRO    Y01939
* FOR THE MESSAGES ISSUED BY THIS MODULE, INCLUDING THE          Y01939
* PREFORMATTED MSG TEXT, THE MAXIMUM LENGTH OF WHICH IS 35. AN @Y02668P
* INCREASE IN THIS LIMIT WOULD REQUIRE CHANGING THE GETMAIN.     Y01939
         SPACE 2
T2       EQU   *
         SPACE 1
         CNOP  2,4                 PUT ADDRESS CONSTANT ON       Y01939
*                                  HALF WORD BOUNDARY            Y01939
TM01     DC    AL2(EM01-SM01-1)    LENGTH OF WTO LIST MINUS ONE  Y01939
SM01     WTO   'IEE301I          CANCEL COMMAND ACCEPTED',MF=L,  Y01939X
               DESC=(5),MCSFLAG=(REG0,RESP)                      Y01939
EM01     EQU   *                   END OF WTO LIST               Y01939
         SPACE 1
         CNOP  2,4                 *                             Y01939
TM02     DC    AL2(EM02-SM02-1) LENGTH OF WTO LIST MINUS ONE   @G17FPSS
SM02     WTO   'IEE301I          FORCE COMMAND ACCEPTED',MF=L, @G17FPSSX
               DESC=(5),MCSFLAG=(REG0,RESP)                    @G17FPSS
EM02     EQU   *                                               @G17FPSS
         SPACE 1
         CNOP  2,4                 *
TM03     DC    AL2(EM03-SM03-1)    *                             Y01939
SM03     WTO   'IEE712I          PROCESSING COMPLETE',MF=L,      Y02669X
               DESC=(5),MCSFLAG=(REG0,RESP)                      Y02669
EM03     EQU   *                   *                             Y01939
         SPACE 1
         CNOP  2,4                 *                             Y01939
TM04     DC    AL2(EM04-SM04-1)    *                             Y01939
SM04     WTO   'IEE304I          JOB RESET',MF=L,DESC=(5),       Y01939X
               MCSFLAG=(REG0,RESP),ROUTCDE=(2)                   Y01939
EM04     EQU   *                   *                             Y01939
         SPACE 1
         CNOP  2,4                 *                             Y01939
TM05     DC    AL2(EM05-SM05-1)    *                             Y01939
SM05     WTO   'IEE305I          COMMAND INVALID',MF=L,DESC=(5), Y01939X
               MCSFLAG=(REG0,RESP)                               Y01939
EM05     EQU   *                   *                             Y01939
         SPACE 1
         CNOP  2,4                 *                             Y01939
TM06     DC    AL2(EM06-SM06-1)    *                             Y01939
SM06     WTO   'IEE306I          INVALID NUMERICS',MF=L,         Y01939X
               DESC=(5),MCSFLAG=(REG0,RESP)                      Y01939
EM06     EQU   *                   *                             Y01939
         SPACE 1
         CNOP  2,4                 *                             Y01939
TM07     DC    AL2(EM07-SM07-1)    *                             Y01939
SM07     WTO   'IEE307I          DELIMITER ERROR',MF=L,          Y01939X
               DESC=(5),MCSFLAG=(REG0,RESP)                      Y01939
EM07     EQU   *                   *                             Y01939
         SPACE 1
         CNOP  2,4                 *                             Y01939
TM08     DC    AL2(EM08-SM08-1)    *                             Y01939
SM08     WTO   'IEE308I          TERM LENGTH ERROR',MF=L,        Y01939X
               DESC=(5),MCSFLAG=(REG0,RESP)                      Y01939
EM08     EQU   *                   *                             Y01939
         SPACE 1
         CNOP  2,4                 *                             Y01939
TM09     DC    AL2(EM09-SM09-1)    *                             Y01939
SM09     WTO   'IEE309I          UNIDENTIFIABLE KEYWORD',MF=L,   Y01939X
               DESC=(5),MCSFLAG=(REG0,RESP)                      Y01939
EM09     EQU   *                   *                             Y01939
         SPACE 1
         CNOP  2,4                 *                             Y01939
TM10     DC    AL2(EM10-SM10-1)    *                             Y01939
SM10     WTO   'IEE310I          KEYWORD MISSING',MF=L,          Y01939X
               DESC=(5),MCSFLAG=(REG0,RESP)                      Y01939
EM10     EQU   *                   *                             Y01939
         SPACE 1
         CNOP  2,4                 *                             Y01939
TM11     DC    AL2(EM11-SM11-1)    *                             Y01939
SM11     WTO   'IEE311I          PARAMETER MISSING',MF=L,        Y01939X
               DESC=(5),MCSFLAG=(REG0,RESP)                      Y01939
EM11     EQU   *                   *                             Y01939
         SPACE 1
         CNOP  2,4                 *                             Y01939
TM12     DC    AL2(EM12-SM12-1)    *                             Y01939
SM12     WTO   'IEE312I          PARAMETERS CONFLICT',MF=L,      Y01939X
               DESC=(5),MCSFLAG=(REG0,RESP)                      Y01939
EM12     EQU   *                   *                             Y01939
         SPACE 1
         CNOP  2,4                 *                             Y01939
TM13     DC    AL2(EM13-SM13-1)    *                             Y01939
SM13     WTO   'IEE313I          UNIT REF. INVALID',MF=L,        Y01939X
               DESC=(5),MCSFLAG=(REG0,RESP)                      Y01939
EM13     EQU   *                   *                             Y01939
         SPACE 1
         CNOP  2,4                 *                             Y01939
TM14     DC    AL2(EM14-SM14-1)    *                             Y01939
SM14     WTO   'IEE314I          UNIT NOT AVAILABLE',MF=L,       Y01939X
               DESC=(5),MCSFLAG=(REG0,RESP)                      Y01939
EM14     EQU   *                   *                             Y01939
         SPACE 1
         CNOP  2,4                 *                             Y01939
TM15     DC    AL2(EM15-SM15-1)    *                             Y01939
SM15     WTO   'IEE315I          UNIT NOT SUPPORTED',MF=L,       Y01939X
               DESC=(5),MCSFLAG=(REG0,RESP)                      Y01939
EM15     EQU   *                   *                             Y01939
         SPACE 1
         CNOP  2,4                 *                             Y01939
TM19     DC    AL2(EM19-SM19-1)    *                             Y01939
SM19     WTO   'IEE019I          QUOTE(S) MISSING',MF=L,         Y01939X
               DESC=(5),MCSFLAG=(REG0,RESP)                      Y01939
EM19     EQU   *                   *                             Y01939
         SPACE 1
         CNOP  2,4                 *                           @Y02668P
TM21     DC    AL2(EM21-SM21-1)    *                           @Y02668P
SM21     WTO   'IEE777I          INVALID FROM SUBSYSTEM CONSOLE',      X
               MF=L,DESC=(5),MCSFLAG=(REG0,RESP)               @Y02668P
EM21     EQU   *                   *                           @Y02668P
         SPACE
         CNOP  2,4
TM22     DC    AL2(EM22-SM22-1)    *                           @G17FPSS
SM22     WTO   'IEE841I          NON-FORCIBLE',MF=L,           @G17FPSSX
               DESC=(5),MCSFLAG=(REG0,RESP)                    @G17FPSS
EM22     EQU   *                                               @G17FPSS
         SPACE 1
         CNOP  2,4                 *                             Y01939
TM23     DC    AL2(EM23-SM23-1)    *                             Y01939
SM23     WTO   'IEE023I          CLASSNAME ERROR',MF=L,          Y01939X
               DESC=(5),MCSFLAG=(REG0,RESP)                      Y01939
EM23     EQU   *                   *                             Y01939
         SPACE 1                                               @Y30LPSV
         CNOP  2,4                 *                           @Y30LPSV
TM24     DC    AL2(EM24-SM24-1)    *                           @Y30LPSV
SM24     WTO   'IEE078I          3850 TYPE COMMAND INVALID',   @Y30LPSVX
               DESC=(5),MCSFLAG=(REG0,RESP),MF=L               @Y30LPSV
EM24     EQU   *                                               @Y30LPSV
         SPACE 1                                               @Y30LPSV
         CNOP  2,4                 *                           @Y30LPSV
TM25     DC    AL2(EM25-SM25-1)    *                           @Y30LPSV
SM25     WTO   'IEE084I          3850 PARAMETER MISSING',      @Y30LPSVX
               DESC=(5),MCSFLAG=(REG0,RESP),MF=L               @Y30LPSV
EM25     EQU   *                                               @Y30LPSV
         SPACE 1
         CNOP  2,4                 *                             Y01939
TM26     DC    AL2(EM26-SM26-1)    *                             Y01939
SM26     WTO   'IEE026I          NOT SUPPORTED',MF=L,            Y01939X
               DESC=(5),MCSFLAG=(REG0,RESP)                      Y01939
EM26     EQU   *                   *                             Y01939
         SPACE 1
         CNOP  2,4                 *                           @G17FPSS
TM27     DC    AL2(EM27-SM27-1)    *                           @G17FPSS
SM27     WTO   'IEE838I          CANCELABLE - ISSUE CANCEL BEFORE FORCEX
               ',DESC=(5),MCSFLAG=(REG0,RESP),MF=L             @G17FPSS
EM27     EQU   *                                               @G17FPSS
         SPACE
         CNOP  2,4                 *
TM28     DC    AL2(EM28-SM28-1)    *
SM28     WTO   'IEE841I          NON-CANCELABLE',MF=L,                 X
               DESC=(5),MCSFLAG=(REG0,RESP)                    @G17FPSS
EM28     EQU   *
         SPACE
         CNOP  2,4
TM35     DC    AL2(EM35-SM35-1)    *                             Y01939
SM35     WTO   'IEE335I          VOL PARAMETER MISSING',MF=L,    Y01939X
               DESC=(5),MCSFLAG=(REG0,RESP),ROUTCDE=(2)          Y01939
EM35     EQU   *                   *                             Y01939
         EJECT
***************************************************************  Y01939
*                                                             *  Y01939
*   START OF MESSAGES FORMERLY IN IEE2103D                    *  Y01939
*                                                             *  Y01939
***************************************************************  Y01939
         SPACE 2
         CNOP  2,4                 *                             Y01939
TM36     DC    AL2(EM36-SM36-1)    *                             Y01939
SM36     WTO   'IEE341I          NOT ACTIVE',MF=L,                     X
               DESC=(5),MCSFLAG=(REG0,RESP)
EM36     EQU   *                   *                             Y01939
         SPACE 1
         CNOP  2,4                 *                             Y01939
TM37     DC    AL2(EM37-SM37-1)    *                             Y01939
SM37     WTO   'IEE342I          REJECTED-TASK BUSY',MF=L,       Y01939X
               DESC=(5),MCSFLAG=(REG0,RESP)                      Y01939
EM37     EQU   *                   *                             Y01939
         SPACE 1
         CNOP  2,4                 *                             Y01939
TM40     DC    AL2(EM40-SM40-1)    *                             Y01939
SM40     WTO   'IEE138I          ALREADY IN SYSTEM',MF=L,        Y01939X
               DESC=(5),MCSFLAG=(REG0,RESP)                      Y01939
EM40     EQU   *                   *                             Y01939
         SPACE 1
         CNOP  2,4                 *                             Y01939
TM41     DC    AL2(EM41-SM41-1)    *                             Y01939
SM41     WTO   'IEE345I          AUTHORITY INVALID',MF=L,        Y01939X
               DESC=(5),MCSFLAG=(REG0,RESP)                      Y01939
EM41     EQU   *                   *                             Y01939
         SPACE 1
         CNOP  2,4                 *                             Y01939
TM42     DC    AL2(EM42-SM42-1)    *                             Y01939
SM42     WTO   'IEE338I          INACTIVE AS HARDCPY',MF=L,      Y01939X
               DESC=(5),MCSFLAG=(REG0,RESP)                      Y01939
EM42     EQU   *                   *                             Y01939
         SPACE 1
         CNOP  2,4                 *                             Y01939
TM43     DC    AL2(EM43-SM43-1)    *                             Y01939
SM43     WTO   'IEE298I          INVALID CHARACTER',MF=L,        Y01939X
               DESC=(5),MCSFLAG=(REG0,RESP)                      Y01939
EM43     EQU   *                   *                             Y01939
         SPACE 1
         CNOP  2,4                 *                             Y01939
TM44     DC    AL2(EM44-SM44-1)    *                             Y01939
SM44     WTO   'IEE339I          CHANGING STATUS',MF=L,          Y01939X
               DESC=(5),MCSFLAG=(REG0,RESP)                      Y01939
EM44     EQU   *                   *                             Y01939
         SPACE 1
         CNOP  2,4                 *                             Y01939
TM45     DC    AL2(EM45-SM45-1)    *                             Y01939
SM45     WTO   'IEE299I          REQ''D FOR HARDCPY',MF=L,       Y01939X
               DESC=(5),MCSFLAG=(REG0,RESP),ROUTCDE=(2)          Y01939
EM45     EQU   *                   *                             Y01939
         SPACE 1
         CNOP  2,4                 *                             Y01939
TM46     DC    AL2(EM46-SM46-1)    *                             Y01939
SM46     WTO   'IEE376I          LAST PATH TO DEVICE',MF=L,      Y01939X
               DESC=(5),MCSFLAG=(REG0,RESP)                      Y01939
EM46     EQU   *                   *                             Y01939
         SPACE 1
         CNOP  2,4                 *                             Y01939
TM47     DC    AL2(EM47-SM47-1)    *                             Y01939
SM47     WTO   'IEE377I          TP-CANNOT BE VARIED',MF=L,      Y01939X
               DESC=(5),MCSFLAG=(REG0,RESP)                      Y01939
EM47     EQU   *                   *                             Y01939
         SPACE 1
         CNOP  2,4                 *                             Y01939
TM48     DC    AL2(EM48-SM48-1)    *                             Y01939
SM48     WTO   'IEE378I          DOES NOT EXIST',MF=L,           Y01939X
               DESC=(5),MCSFLAG=(REG0,RESP)                      Y01939
EM48     EQU   *                   *                             Y01939
         SPACE 1
         CNOP  2,4                 *                             Y01939
TM49     DC    AL2(EM49-SM49-1)    *                             Y01939
SM49     WTO   'IEE379I          NOT AVAILABLE',MF=L,            Y01939X
               DESC=(5),MCSFLAG=(REG0,RESP)                      Y01939
EM49     EQU   *                   *                             Y01939
         SPACE 1
         CNOP  2,4                 *                             Y01939
TM50     DC    AL2(EM50-SM50-1)    *                             Y01939
SM50     WTO   'IEE380I          DEVICE TYPE INVALID',MF=L,      Y01939X
               DESC=(5),MCSFLAG=(REG0,RESP)                      Y01939
EM50     EQU   *                   *                             Y01939
         SPACE 1
         CNOP  2,4                 *                             Y01939
TM51     DC    AL2(EM51-SM51-1)    *                             Y01939
SM51     WTO   'IEE381I          DEVICE UNALLOCATED',MF=L,       Y01939X
               DESC=(5),MCSFLAG=(REG0,RESP)                      Y01939
EM51     EQU   *                   *                             Y01939
         SPACE 1
         CNOP  2,4                 *                             Y01939
TM52     DC    AL2(EM52-SM52-1)    *                             Y01939
SM52     WTO   'IEE382I          CURRENTLY ACTIVE',MF=L,         Y01939X
               DESC=(5),MCSFLAG=(REG0,RESP)                      Y01939
EM52     EQU   *                   *                             Y01939
         SPACE 1
         CNOP  2,4                 *                             Y01939
TM53     DC    AL2(EM53-SM53-1)    *                             Y01939
SM53     WTO   'IEE324I          NOT LOGGED ON',MF=L,            Y01939X
               DESC=(5),MCSFLAG=(REG0,RESP)                      Y01939
EM53     EQU   *                   *                             Y01939
         SPACE 1
         CNOP  2,4                 *                             Y01939
TM55     DC    AL2(EM55-SM55-1)    *                             Y01939
SM55     WTO   'IEE907I          ABEND-SEND CMD ABORTED',MF=L,   Y01939X
               DESC=(5),MCSFLAG=(REG0,RESP)                      Y01939
EM55     EQU   *                   *                             Y01939
         SPACE 1
         CNOP  2,4                 *                             Y01939
TM56     DC    AL2(EM56-SM56-1)    *                             Y01939
SM56     WTO   'IEE907I          ABEND-D CMD ABORTED',MF=L,      Y01939X
               DESC=(5),MCSFLAG=(REG0,RESP)                      Y01939
EM56     EQU   *                   *                             Y01939
         SPACE 1
         CNOP  2,4                 *                             Y01939
TM57     DC    AL2(EM57-SM57-1)    *                             Y01939
SM57     WTO   'IEE908I          CMD LENGTH EXCEEDS MAX',MF=L,   Y01939X
               DESC=(5),MCSFLAG=(REG0,RESP)                      Y01939
EM57     EQU   *                   *                             Y01939
         SPACE 1
         CNOP  2,4                 *                             Y01939
TM58     DC    AL2(EM58-SM58-1)    *                             Y01939
SM58     WTO   'IEE328I          COMMAND ABORTED',MF=L,          Y01939X
               DESC=(5),MCSFLAG=(REG0,RESP)                      Y01939
EM58     EQU   *                   *                             Y01939
         SPACE 1
         CNOP  2,4                 *                             Y01939
TM60     DC    AL2(EM60-SM60-1)    *                             Y01939
SM60     WTO   'IEE707I          NOT EXECUTED',MF=L,             Y01939X
               DESC=(5),MCSFLAG=(REG0,RESP)                      Y01939
EM60     EQU   *                   *                             Y01939
         SPACE 1
         CNOP  2,4                 *                             Y02669
TM61     DC    AL2(EM61-SM61-1)    *                             Y02669
SM61     WTO   'IEE708I          KEYWORD, VALUE INVALID',MF=L,   Y02669X
               DESC=(5),MCSFLAG=(REG0,RESP),ROUTCDE=(2)          Y02669
EM61     EQU   *                   *                             Y02669
         SPACE 1
         CNOP  2,4                 *                             Y02669
TM62     DC    AL2(EM62-SM62-1)    *                             Y02669
SM62     WTO   'IEE535I          INVALID PARAMETER',MF=L,        Y02669X
               DESC=(5),MCSFLAG=(REG0,RESP)                      Y02669
EM62     EQU   *                   *                             Y02669
         SPACE 1
         CNOP  2,4                 *                             Y02669
TM63     DC    AL2(EM63-SM63-1)    *                             Y02669
SM63     WTO   'IEE711I          UNABLE TO DUMP',MF=L,           Y02669X
               DESC=(5),MCSFLAG=(REG0,RESP)                      Y02669
EM63     EQU   *                   *                             Y02669
         SPACE 10
PATCH    DC    CL132'*********  IEE0503D  PATCH AREA  *******'   Y01939
         EJECT
FAUXSA   DSECT
         IEEXSA
**************************************************************** Y01939
*                                                              * Y01939
*        DSECT TO MAP THE GOTTEN CORE IN WHICH WTO PARAMETER   * Y01939
*        LIST IS BUILT                                         * Y01939
*                                                              * Y01939
**************************************************************** Y01939
         SPACE 2
MSG      DSECT                                                   Y01939
XAHMSG   DS    F                        *                        Y01939
XAIMSG   DS    2F                       *                        Y01939
XAFMSG   DS    2F                       *                        Y01939
XATMSG   DS    6F                       *                        Y01939
         END
