 TITLE 'IEE3603D - VARY ONLINE/CONSOLE PATH VERIFICATION ROUTINE'
IEE3603D CSECT                                                 @Z30LPTJ
         ENTRY IEE36ENT                                        @Z30LPTJ
* C 011665-011815,013404-013584,014120-014180,014362-014402,   @YM07231
* C 014524-014584,015679-015719,705858,705718-705738,          @YM07231
* C 820200-820340                                              @YM07231
* C 012922,015679,488000,820460-820487                         @ZM30436
* C 012922                                                     @ZM30445
* A 015699,133293,226958-226978,227038,705911-705912,705915,   @ZM30445
* A 707148-707178,707318                                       @ZM30445
* C 012922,015699,492000                                       @ZM30479
* LOOPENQ(C) - STIMER CODED INCORRECTLY                        @ZA09414
* LOOPENQ(C) - INTERLOCK PROBLEM WITH ALLOCATION               @ZA09166
         SPACE 1
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
*                                                             *
* MODULE NAME       = IEE3603D
*   CSECT NAME      = IEE3603D
*
* LOAD MODULE NAME  = IEE3603D
*
* DESCRIPTIVE NAME  = MP VARY COMMAND PRE-PROCESSOR AND FIRST
*                     VARY ONLIN/OFFLINE/CONSOLE ATTACHED RTN
*                     PATH AVAILABILITY CHECKER
*
* COPYRIGHT         = MISSING
*
* STATUS            = OS/VS/2 RELEASE 3 PTF UZ03709            @ZA09166
*
* FUNCTION          = THIS ROUTINE SETS UP THE ENVIRONMENT FOR
*                     THE VARY ONLINE/OFFLINE/AND CONSOLE PROCESSOR
*                     AND THEN IT WILL PREVENT DEVICES WHICH HAVE
*                     NO AVAILABLE PATHS FROM BECOMING ONLINE
*                     OR CONSOLES
*
* OPERATION         = AS THE FIRST THING, IT WILL HAVE A STAE
*                     ENVIRONMENT CREATED BY IEECB860.
*                     THEN, THIS ROUTINE WILL GETMAIN ENOUGH CORE
*                     FOR A DUMMY XSA,SAVE AREA AND WORK AREA,
*                     AND IT WILL INITIALIZE THE TABLES
*                     FOR THE REST OF THE ONLINE/OFFLINE/CONSOLE
*                     COMMAND PROCESSOR TO USE.
*                     AT THIS POINT, AN ENQ ON SYSIEFSD, Q4 IS @ZA09166
*                     ATTEMPTED. IF THE RESOURCE IS OBTAINED,  @ZA09166
*                     PROCESSING CONTINUES. IF THE RESOURCE    @ZA09166
*                     CAN'T BE OBTAINED, AN STIMER WAIT IS     @ZA09166
*                     ISSUED FOR 5 SECONDS AND THE ENQ IS      @ZA09166
*                     RE-ISSUED. IF THE RESOURCE STILL CAN'T   @ZA09166
*                     BE OBTAINED, A WTOR FOR IEE799I IS       @ZA09166
*                     ISSUED WITH THE OPTION OF RETRY,CANCEL OR@ZA09166
*                     WAIT. IF THE OPERATOR REPLIES RETRY,     @ZA09166
*                     THE WHOLE PROCESS IS REPEATED. IF THE    @ZA09166
*                     OPERATOR REPLIES CANCEL, MESSAGE IEE756I @ZA09166
*                     IS ISSUED AND PROCESSING IS TERMINATED.  @ZA09166
*                     IF THE OPERATOR REPLIES WAIT, AN         @ZA09166
*                     UNCONDITIONAL ENQ IS ISSUED.             @ZA09166
*                     THE FOLLOWING FIELDS WILL BE INITIALIZED
*                       XAL WILL POINT TO CHBUF=PTR TO PARAMS
*                            IN THE VARY COMMAND
*                       XAU WILL CONTAIN THE UCM ID OF THE ISSUING
*                            CONSOLE FROM THE INFOR IN THE CSCB
*                       XAV IS INIT TO THE COMMAND VERB = VARY
*                       XAR IS INIT TO THE LENGTH OF THE COMMAND
*                            THIS IS ALWAYS THE LENGTH OF THE CMD
*                            BUFFER IN THE CSCB = 124 BYTES
*                       XAS IS INIT TO THE R/I COMMAND AUTH.
*                            FROM THE CSCB (IF THE R/I ISSUED THE
*                            COMMAND, ELSE THIS FIELD IN THE CSCB
*                            IS ZEROES AND IT IS COPIED AS SUCH)
*                     IF A VARY RANGE COMMAND IS PRESENT, THEN @Z30LPTJ
*                     A BRANCH IS MADE TO IEECB904 TO EXPAND   @Z30LPTJ
*                     THE UNITS IN THE COMMAND INTO A VARY     @Z30LPTJ
*                     COMMAND WITH INDIVIDUAL DEVICES.         @Z30LPTJ
*                     THEN THE COMMAND SYNTAX IS CHECKED.
*                     A NORMAL EXIT IS TAKEN FOR INVALID SYNTAX.
*                     THEN, EACH UNIT IS CHECKED FOR GOOD PATHS.
*                     A MESSAGE IS WRITTEN FOR EACH UNIT HAVING NO
*                     GOOD PATHS OR EACH UNIT IN USE BY A      @YM07231
*                     SYSTEM COMPONENT AND THE UNIT IS DELETED @YM07231
*                     FROM THE BUFFER.  UNITS HAVING GOOD      @YM07231
*                     PATHS ARE LEFT IN THE COMMAND BUFFER.    @YM07231
*                     FINALLY, WHEN ALL UNITS HAVE BEEN CHECKED, A
*                     NORMAL EXIT IS TAKEN IF ANY UNITS ARE LEFT IN
*                     THE COMMAND BUFFER. OTHERWISE, AN ERROR EXIT
*                     IS TAKEN.
*
* NOTES
*   DEPENDENCIES    = NONE
*   CHARACTER/CODE DEPENDENCIES
*                   = THIS MODULE CAN BE ASSEMBLED WITH ANY NEW
*                     CHARACTER/CODE SET
*   RESTRICTIONS    = R2 CONTAINS THE PTR TO THE DUMMY XSA ON OUTPUT
*   REGISTER CONVENTIONS
*                   = REGISTERS ARE DEFINED AT LABEL: DEFREG
*   PATCH LABEL     = PATCH
*
* MODULE TYPE       = CSECT
*   PROCESSOR       = ASSEMBLER
*   MODULE SIZE     = VS/2 = 'B00'                             @ZM30479
*   ATTRIBUTES      = REENTRANT,REUSABLE,REFRESHABLE,
*                     PAGED LPA,ZERO PSW PROTECT KEY
*
* ENTRY POINTS      = IEE3603D FROM IEEVWAIT
*   PURPOSE         = TO PRESET THE ENVIRONMENT FOR THE VARY ONLINE/
*                     OFFLINE/CONSOLE CMDS, TO ROUT THE OFFLINE CMD
*                     DIRECTLY TO IEE3303D, TO TEST PATH-AVAILABILITY
*                     FOR UNITS GOING TO THE ONLINE AND CONSOLE STATES
*   LINKAGE         = ATTACH
*   INPUT           = REG1 HAS A PTR TO THE CSCB
*   REGISTERS SAVED = R14 = RETURN ADDRESS REG IS SAVED ON ENTRY
*                     R1  = CSCB PTR
*   REGISTER USAGE  = R2 PTR TO DUMMY XSA
*                     R3 PTR TO THE CSCB UNTIL IT IS STORED
*                     R12 ADDRESSABILITY REGISTER
*                     R13 PTR TO WORK AREA
*   REGISTER RESTORED
*                   = R14
*                                                              @Z30LPTJ
* ENTRY POINTS      = IEE36ENT FROM IEECB904                   @Z30LPTJ
*   PURPOSE         = TO EXECUTE NORMAL VARY PROCESSING AFTER  @Z30LPTJ
*                     EXPANSION OF THE VARY RANGE COMMAND INTO @Z30LPTJ
*                     INDIVIDUAL DEVICE UNITS HAS TAKEN PLACE. @Z30LPTJ
*   LINKAGE         = BRANCH                                   @Z30LPTJ
*   INPUT           = REGISTER 2 POINTING TO THE XSA           @Z30LPTJ
*   REGISTERS SAVED = NONE                                     @Z30LPTJ
*   REGISTER USAGE  = REGISTER 2 POINTING TO THE DUMMY XSA     @Z30LPTJ
*                     REGISTER 12 IS THE ADDRESSABILITY BASE   @Z30LPTJ
*                     REGISTER 13 POINTS TO THE WORK AREA      @Z30LPTJ
*   REGISTERS RESTORED                                         @Z30LPTJ
*                   = REGISTER 14                              @Z30LPTJ
*
* EXITS - NORMAL -1 = IEE3303D VIA BRANCH
*   CONDITIONS      = A NORMAL EXIT IS TAKEN IF THE COMMAND HAS A
*                     GROSS SYNTAX ERROR, WHICH WOULD MAKE THE TOTAL
*                     COMMAND, INVALID.  OR IF AFTER DELETION OF
*                     ALL UNAVAILABLE UNITS, AND UNITS IN USE  @YM07231
*                     BY A SYSTEM COMPONENT, AT LEAST ONE UNIT @YM07231
*                     IS LEFT IN THE COMMAND, OR BEFORE        @YM07231
*                     PROCESSING IF A 'VARY OFFLINE' IS FOUND. @YM07231
*   OUTPUT          = IF EXIT IS TAKEN TO IEE3303D, REGISTER 2
*                     POINTS TO THE DUMMY XSA
*                     R13 PTS TO THE SAVE AREA WORD 17 =CSCB PTR
*   RETURN CODES    = NONE
*
* EXITS - NORMAL -2 = IEEVDEV - MP PATH VERIFICATION SUBROUTINE
*   CONDITIONS      = A UNIT HAS BEEN FOUND THAT IS VALID AND THE
*                     PATH NOW HAS TO BE VERIFIED AS BEING OPEN OR NOT
*                     EVEN THOUGH 3603D WILL GO TO IEEVDEV AS MANY
*                     TIMES AS THERE ARE UNITS IN THE COMMAND WHICH
*                     ARE NOT ONLINE AT THE TIME OF THIS MODULE'S
*                     EXECUTION, ONLY ONE LOAD/DELETE AND ONE
*                     GETMAIN/FREEMAIN FOR VDEV'S PARAM CORE IS
*                     EXECUTED. ONE THE LOAD IS PERFORMED, THE ADDR
*                     OF IEEVDEV IS STORED IN THE XAP FOR FUTURE
*                     USE. ELSE THIS AREA IS 0 (PRESET AT XSA
*                     INIT TIME).
*                     ONCE THE CORE FOR IEEVDEV'S PARAM LIST AND
*                     SAVE AREA IS GOTTEN, ITS ADDRESS IS STORED
*                     IN THE XAD FOR FUTURE USE. ELSE THIS AREA
*                     IS 0 (PRESET AT XSA INIT TIME).
*                     THE FREEMAIN OF VDEV'S PARAM AND SAVE AREA
*                     CORE AND THE DELETE OF IEEVDEV ARE DONE EITHER
*                     ON EXIT TO IEE3303D OR UPON THE 'RETURN'
*                     EXIT, WHICHEVER IS TAKEN.
*   OUTPUT          = REG1 PTS TO A PTR WHICH PTS TO A TWO WORD PARAM
*                     LIST:
*                          WORD 1: PTR TO THE UCB TO HAVE PATH SEARCHED
*                          WORD 2,BYTE1 : FUNCTION CODE = VARY = X'00'
*                                  REST OF WORD 2 IS NOT APPLICABLE
*                     R13 PTS TO A 72 SAVE AREA                       P
*   RETURN CODES    = RETURN CODE 4 OR 12 MEANS THAT THERE IS NO
*                     AVAILABLE PATH TO THIS DEVICE AND THEREFORE
*                     IT CANNOT BE VARIED ONLINE OR THE CONSOLE
*                     STATE.
*                     RET CODE OF 16 MEANS THAT THE UNIT HAS BEEN
*                     FOUND TO BE IN USE BY A SYSTEM COMPONENT @YM07231
*                     RIGHT NOW, THEREFORE IT CANNOT BE VARIED @YM07231
*                     ONLINE, OR TESTED FOR PATHS , OR VARIED  @YM07231
*                     TO THE CONSOLE STATE.                    @YM07231
*                     A RET CODE OF 8 MEANS THE IEEVDEV COULD NOT
*                     GET ENOUGH CORE TO PROCESS AND THEREFORE
*                     NO PATH VERIFICATION WAS DONE.
*                     THE COMMAND AS ABORTED AT THIS TIME.
*                                                              @Z30LPTJ
* EXITS - NORMAL -3 = IEECB904 - VARY RANGE PROCESSOR ROUTINE  @Z30LPTJ
*   CONDITIONS      = WHENEVER IEE3603D DETECTS A VARY RANGE   @Z30LPTJ
*                     COMMAND IN THE COMMAND BUFFER AND IT HAS @Z30LPTJ
*                     SOME PRIMARY GOOD SYNTAX.  A RETURN FROM @Z30LPTJ
*                     IEECB904 WILL HAVE A NEW BUFFER (POINTED @Z30LPTJ
*                     TO BY THE XAL FIELD IN THE XSA) WHICH    @Z30LPTJ
*                     WILL CONTAIN THE EXPANDED FORM OF THE    @Z30LPTJ
*                     VARY RANGE COMMAND (UP TO 28 SINGLE      @Z30LPTJ
*                     DEVICE UNITS).                           @Z30LPTJ
*   OUTPUT          = REGISTER 2 POINTING TO THE XSA           @Z30LPTJ
*   RETURN CODES    = NONE                                     @Z30LPTJ
*
* EXITS - ERROR     = BR14 (RETURN TO THE SVC HANDLER)
*   CONDITIONS      = AN ERROR EXIT IS TAKEN IF NOTHING IS LEFT
*                     IN THE COMMAND BUFFER AFTER ALL UNITS
*                     ARE DELETED, OR WHEN THE STAE ENVIRONMENT@YM07231
*                     CANNOT BE CREATED SUCCESSFULLY.          @YM07231
*                     THE ABOVE-MENTIONED CONDITIONS HOLD TRUE @Z30LPTJ
*                     ONLY IF THE VARY RANGE BIT IS NOT ON.    @Z30LPTJ
*                     OR, THE FIRST TIME THAT IEEVDEV RETURNS A
*                     RETURN CODE OF 8 (INSUFF. CORE FOR PROCESSING)
*                     ALSO, AN ERROR EXIT IS MADE IF THE VARY  @Z30LPTJ
*                     RANGE COMMAND IS SYNTAXICALLY INCORRECT. @Z30LPTJ
*   OUTPUT          = FOR EACH UNIT IN THE VARY ONLINE OR      @Z30LPTJ
*                     VARY CONSOLE COMMAND THAT HAS:           @Z30LPTJ
*                      A) NO AVAILABLE PATHS -                 @Z30LPTJ
*                          NO PATHS MESSAGE (IEE025I)          @Z30LPTJ
*                      B) THE UNIT IN USE BY A SYSTEM          @Z30LPTJ
*                         COMPONENT -                          @Z30LPTJ
*                          SYSTEM COMPONENT MESSAGE (IEE329I)  @Z30LPTJ
*                      C) NO UCB -                             @Z30LPTJ
*                          UNIT REF INVALID MESSAGE (IEE313I)  @Z30LPTJ
*                      D) CHARACTERS AFTER THE 'OFFLINE' OR    @Z30LPTJ
*                         'ONLINE' KEYWORDS -                  @Z30LPTJ
*                          TERM LENGTH ERROR MESSAGE (IEE303I) @Z30LPTJ
*                     THE FOLLOWING ERROR MESSAGES ARE ISSUED  @Z30LPTJ
*                     WHEN A VARY RANGE COMMAND HAS SYNTAX     @Z30LPTJ
*                     ERRORS:                                  @Z30LPTJ
*                      A) RIGHT PARENTHESIS AND COMMA NOT      @Z30LPTJ
*                         PRESENT WHEN EXPECTED                @Z30LPTJ
*                          DELIMITER ERROR MESSAGE (IEE307I)   @Z30LPTJ
*                      B) MIXTURE OF SINGLE AND RANGE UNITS -  @Z30LPTJ
*                          TERM LENGTH ERROR MESSAGE (IEE308I) @Z30LPTJ
*                      C) 'CONSOLE' KEYWORD SPECIFIED -        @Z30LPTJ
*                          PARAMETER CONFLICT MESSAGE (IEE312I)@Z30LPTJ
*   RETURN CODES    = NONE
*
* EXTERNAL REFERENCES
*   ROUTINE         = IEE3303D
*                     IEEVDEV = (PATH CHECKER SUBROUTINE)
*                     IEECB860 = (STAE PROCESSOR)
*                     IEECB904 = (VARY RANGE PROCESSOR)        @Z30LPTJ
*   DATA AREAS      = SEE EXITS - OUTPUT DATA
*
* CONTROL BLOCKS    = DUMMY EXTENDED SAVE AREA (XSA)
*                     COMMAND SCHEDULING CONTROL BLOCK (CSCB)
*                       FIELDS TESTED  - CHBUF
*                                        CHUCMP
*                       FIELDS UPDATED - CHSTS -BIT= CHFC
*                     CVT
*                       FIELDS TESTED  - CVTILK2
*                                        CVTPTR
*                       FIELDS UPDATED - NONE
*                     UNIT CONTROL BLOCK (UCB)
*                       FIELDS TESTED  - UCBNAME
*                       FIELDS UPDATED - NONE
*
* TABLES            = 136 BYTE WORK AREA IN SUBPOOL 229 OF LSQA
*                     48 BYTES FOR USE AS A DUMMY XSA FOR
*                     THE VARY ONLINE/OFFLINE/CONSOLE PROCESSORS
*                     84 BYTES FOR THE SAVE AREA FOR VARY AND
*                     THE ONE WORD-CSCB-POINTER-STORE
*                     AND 4-WORD SAVE FOR REGS AT SETLOCK TIME
*
* MACROS            = GETMAIN,FREEMAIN,WTO,LOAD,DELETE,MGCR,ENQ,DEQ
*
* MAPPING MACROS    = IEEXSA
*                     CVT
*                     IEFUCBOB
*                     IEECHAIN
*   SERIALIZATION   = NO LOCKS ARE OBTAINED IN THIS ROUTINE
*                    FOR PROTECTION AGAINST ALLOC, ANOTHER VARY OR
*                     UNLOAD COMMAND THIS ROUTINE ISSUES THE ENQ ON
*                     Q4 WHICH WILL PROTECT ALL OR THE COMMAND PROCESOR
*
*                     THE ENQ IS ISSUED IN THIS MODULE
*                     THE DEQ ARE ISSUED IN THE FOLLOWING PLACES:
*                          IEEDEQUE IN THIS MODULE WHEN ERRORS ARE
*                              ENCOUNTERED
*                          SDEQUE IN IEE3303D
*                          UDEQUE IN IEE4203D
*                          KDEQUE IN IEE4403D
*                          ODEQUE IN IEE4603D
*                          CDEQUE IN IEE4903D
*                          VDEQUE IN IEE3103D
*                          CDEQUE IN IEE7303D
*                          CDEQUE IN IEE4803D
*                          CDEQUE IN IEECB904                  @Z30LPTJ
*
* CHANGE LEVEL      = Y02669, Y02651, Y02653, Z30LPTJ, ZM30436 @ZM30436
*                     ZM30445, ZM30479, ZA09166, ZA09414       @ZA09166
*
* CHANGE ACTIVITY   = N/A
*
* MESSAGES          = 'IEE025I UNIT XXX HAS NO LOGICAL  PATHS'
*                     'IEE025I UNIT XXX HAS NO PHYSICAL PATHS'
*                     'IEE329I XXX IN USE BY A SYSTEM          @YM07231
*                                               COMPONENT'     @YM07231
*                     'IEE313I XXX UNIT REF INVALID'           @Z30LPTJ
*                     'IEE084I XXX 3851 PARAMETER MISSING'     @Z30LPTJ
*                       WHERE XXX IS THE UNIT NAME             @Z30LPTJ
*                     'IEE328I VARY COMMAND ABORTED'
*                     'IEE307I VARY DELIMITER ERROR'           @Z30LPTJ
*                     'IEE308I VARY TERM LENGTH ERROR'         @Z30LPTJ
*                     'IEE312I VARY PARAMETERS CONFLICT'       @Z30LPTJ
*                     'IEE799A VARY CONSOLE DELAYED - REPLY    @ZA09166
*                      RETRY,CANCEL OR WAIT'                   @ZA09166
*
* ABEND CODES       = NONE
*
* PACKAGING         = IEE3603D WILL BE PART OF LOAD MODULE
*                       IEE3603D
*                     THIS LOAD MODULE ALIASES ARE
*                       NONE
*                     THIS LOAD MODULE ENTRY POINTS ARE
*                       IEE3603D
*                     THIS MODULE WILL RESIDE IN: LPALIB
*
* SYSGEN            = SUPPLIED BY SECTIONS
*                       LOAD MODULE NAME
*                       PACKAGING
*                       THIS CSECT WILL BE INCLUDED AT SYSGEN FROM
*                       DLIB -AOSB3- BY MACRO -SGIEF441-
*
* SYSTEM LIBRARIES  = NONE
*
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
         EJECT
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
*                                                             *
* EQUATES                                                     *
*                                                             *
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
         SPACE 1
DEFREG   EQU   *                                                 Y02669
R0       EQU   0
R1       EQU   1                   INPUT = CSCB POINTER          Y02669
R2       EQU   2                   DUMMY XSA POINTER             Y02669
R3       EQU   3                   MODULE'S CSCB POINTER         Y02669
R4       EQU   4                   EOB POINTER                   Y02669
R5       EQU   5
R6       EQU   6
R7       EQU   7
R8       EQU   8                   WORK AREA POINTER             Y02669
R9       EQU   9
R10      EQU   10
R11      EQU   11
R12      EQU   12                  ADDRESSABILITY                Y02669
R13      EQU   13                  SAVE AREA POINTER             Y02669
R14      EQU   14
R15      EQU   15
         SPACE 1
BE       EQU   8                   BCR CONDITION MASK
BNE      EQU   7                   BCR CONDITION MASK
         SPACE 1
K0       EQU   0
K1       EQU   1
K2       EQU   2
K3       EQU   3
K4       EQU   4
K5       EQU   5                                                 Y02669
K6       EQU   6
K7       EQU   7
K8       EQU   8
K9       EQU   9                                               @YM3411P
K12      EQU   12                                                Y02669
K13      EQU   13
K16      EQU   16                                                Y02669
K17      EQU   17
K24      EQU   24                                                Y02669
K28      EQU   28                                              @YM3369P
K130     EQU   130                                             @Z30LPTJ
K136     EQU   136                                             @Z30LPTJ
K140     EQU   140                                             @Z30LPTJ
         SPACE 1
XC1      EQU   X'C1'                                           @YM3411P
XC6      EQU   X'C6'                                           @YM3411P
XF0      EQU   X'F0'                                           @YM3411P
X4D      EQU   C'('
X40      EQU   C' '
X5D      EQU   C')'
X6B      EQU   C','
TWELV    EQU   12                                                Y02669
FOR      EQU   4                                                 Y02669
ZERO     EQU   0                                                 Y02669
EIT      EQU   8                                                 Y02669
SIXTEEN  EQU   16                                                Y02669
D132     EQU   132                                               Y02669
*              NOTE: IF THE SIZE OF THIS 'D132' IS CHANGED     @Z30LPTJ
*                    (REFLECTING CHANGE IN XSA MACRO SIZE),    @Z30LPTJ
*                    SUCH CHANGE MUST ALSO BE MADE TO THE SAME @Z30LPTJ
*                    LABEL IN THE FOLLOWING MODULES:           @Z30LPTJ
*                      IEE3103D  IEE4403D  IEE4903D            @Z30LPTJ
*                      IEE3303D  IEE4603D  IEE7303D            @Z30LPTJ
*                      IEE4203D  IEE4803D  IEECB904            @Z30LPTJ
D124     EQU   124                                               Y02669
D48      EQU   48                                                Y02669
D64      EQU   64                                                Y02669
D68      EQU   68                                                Y02669
D512     EQU   512                                               Y02669
TWENTY   EQU   20                                                     P
TREE08   EQU   308                                             @Z30LPTJ
*              NOTE: IF THE SIZE OF THIS 'TREE08' IS           @Z30LPTJ
*                    CHANGED, SUCH CHANGE MUST ALSO BE MADE    @Z30LPTJ
*                    AT THE 'SPSIZEC' LABEL IN IEECB904.       @Z30LPTJ
ECBPOST  EQU   X'40'
BLANK    EQU   C' '                                            @Z30LPTJ
LEFPAREN EQU   C'('                                            @Z30LPTJ
RTPAREN  EQU   C')'                                            @Z30LPTJ
COMMA    EQU   C','                                            @Z30LPTJ
HYPHEN   EQU   C'-'                                            @Z30LPTJ
OHDASH   EQU   C'O'                                            @Z30LPTJ
EYEDASH  EQU   C'I'                                            @Z30LPTJ
RI       EQU   X'80'                                           @ZM30445
         EJECT
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
*                                                             *
* ENTRY CODE AND INITIALIZATION                               *
*                                                             *
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
         USING CHAIN1,R3                                         Y02669
         USING IEE36XSA,R2         TO REF EXTENDED SAVE AREA
         USING IEE36WRK,R8        TO REFERENCE WORK AREA
         SPACE 1
         BALR  R12,R0              INITIALIZE BASE REGISTER
         USING *,R12        TO ESTAB BASE OF ADDRBILITY          Y02669
         SPACE 1
         MODID BR=YES
         SPACE 1
         LR    R3,R1              CSCB PTR                       Y02669
         LR    R4,R14             SAVE RET ADDRESS               Y02653
         LOAD  EP=IEECB860                                       Y02653
         LR    R6,R0              SAVE RTN'S ADDRESS             Y02653
*
         L     R0,IEE36GMP         INIT GETMAIN LV PARAM REG
       GETMAIN R,LV=(0)            GETMAIN WORK/SAVE AREA
         LR    R8,R1              INIT SAVE AREA REG             Y02653
         ST    R3,K12(R8)         SAVE CSCB POINTER              Y02653
         ST    R3,K0(R8)          SAVE CSCB PTR FOR STAE         Y02653
         ST    R4,K8(R8)          SAVE REUTRN ADDRESS            Y02653
         LA    R4,K16(R8)         GET ADDR OF STAE CMD PARAM     Y02653
         ST    R4,K4(R8)          AND STORE FOR STAE             Y02653
         MVC   K16(K5,R8),LVARY   INIT CMD PARAM TO HAVE SIZE    Y02653
*                                 OF CMD AND COMMAND VERB        Y02653
         LR    R15,R6             ADDRESS OF STAE RTN            Y02653
         LR    R13,R8             SAVE SA PTR                   YM02653
         STM   R0,R15,K24(R13) STR REGS SO CB860 DOESN'T CLOBBERYM02653
         BALR  R14,R15            GO TO SET UP STAE ENVIRONMNT   Y02653
*                                                                Y02653
         LM    R0,R14,K24(R13)    RESTORE REGS                  YM02653
         LR    R5,R15             SAVE RETURN CODE FROM STAE     Y02653
         DELETE EP=IEECB860                                      Y02653
         L     R3,K12(R8)         RE-OBTAIN CSCB PTR             Y02653
         L     R4,K8(R8)          RE-OBTAIN RETURN ADDRESS       Y02653
         LTR   R5,R5              STAE IS OK?                    Y02653
         BZ    STAEOK             YES                            Y02653
         LR    R1,R8              NO, GOTTEN CORE PTR INTO R1    Y02653
         L     R0,IEE36GMP        AND SIZE INTO R0 FOR FREE      Y02653
         FREEMAIN R,LV=(0),A=(1)                                 Y02653
         LR    R1,R3              CSCB PTR                       Y02653
         OI    CHSTS,CHFC         SET - FREE CSCB BIT            Y02653
         MGCR  (1),CHAIN                                         Y02653
         LR    R14,R4             RETURN ADDRESS TO R14          Y02653
         BR    R14                RETURN                         Y02653
*                                                                Y02653
STAEOK   EQU   *                                                 Y02653
         ST    R4,IEE36S14        SAVE RETURN REGISTER           Y02669
         LA    R0,D132            DUMMY XSA AND SAVE AREA CORE   Y02669
         GETMAIN R,LV=(0)                                        Y02669
         LR    R2,R1              DUMMY XSA POINTER              Y02669
         LA    R13,D48(R1)        SAVE AREA POINTER              Y02669
         XC    K0(D48,R2),K0(R2)  ZERO OUT DUMMY XSA             Y02669
         LR    R1,R3              CSCB PTR INTO REG1 FOR STORE   Y02669
         L     R14,IEE36S14         RESTORE REG14 FOR SAVE       Y02669
         STM   R0,R15,K0(R13)     SAVE REGS                      Y02669
         ST    R3,D64(R13)        CSCB PTR TO WORD17 OF SAVEAREA Y02669
         LA    R4,CHBUF           PTR TO CMD PARAM LIST          Y02669
         LA    R4,K0(R4)                                         Y02669
         ST    R4,XAL             STORE PTR TO PARAMS IN D XSA   Y02669
         MVC   XAU(K1),CHUCMP     UCMID INTO DUMMY XSA           Y02669
         MVC   XAV(K8),VARY       VARY VERB                      Y02669
         LA    R4,D124            SIZE OF PARAM LIST BUFFER      Y02669
         ST    R4,XAR             INTO DUMMY XSA                 Y02669
         MVC   XAS(K2),CHINC      MOVE R/I AUTH OR 0             Y02669
         DROP  R3                                                Y02669
*                                                                Y02669
         L     R3,XAL              GET PTR TO BEGIN OF OPERANDS
         LA    R3,K0(R3)           CLEAR HIGH ORDER BYTE OF ADR
         MVC   XAX(K8),IEE3303D     SET EXIT IDENTIFIER          Y02669
*                       XAP (1WORD) IS ZEROES NOW = NO LOAD FOR  Y02669
*                       IEEVDEV WAS PERFORMED AS YET             Y02669
*                       XAD (1 WORD) IS ALSO 0, NO GOTTEN        Y02669
*                       CORE FOR IEEVDEV PARAM AS YET            Y02669
         EJECT
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
*                                                             *
* DETERMINE LENGTH OF OPERANDS                                *
*                                                             *
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
         SPACE 1
         LR    R6,R3               GET POINTER TO BEG OF BUFFER
         AR    R4,R6              POINTER TO EOB INTO REG4       Y02669
IEE36030 EQU   *
         CLI   K0(R6),BLANK       IS THIS CHARACTER A BLANK?   @Z30LPTJ
         BE    IEE3603A           EXIT IF A BLANK IS FOUND     @Z30LPTJ
         CLC   K0(K6,R6),ONLINE   IS IT NOW 'ONLINE' KEYWORD?  @Z30LPTJ
         BE    CHKON              YES, CHECK FOR ITS VALIDITY  @Z30LPTJ
         CLC   K0(K7,R6),OFFLINE  IS IT NOW 'OFFLINE' KEYWORD? @Z30LPTJ
         BE    CHKOFF             YES, CHECK FOR ITS VALIDITY  @Z30LPTJ
         LA    R6,K1(R6)          INCREMENT TO NEXT CHARACTER  @Z30LPTJ
         CR    R6,R4              PAST END OF BUFFER?          @Z30LPTJ
         BNH   IEE36030           NO, LOOP UNTIL LAST END BLANK@Z30LPTJ
IEE3603A EQU   *                                               @Z30LPTJ
         LR    R4,R6              SAVE 'END OF COMMAND' POINTER@Z30LPTJ
         BCTR  R4,R0              DECREMENT IT BY ONE          @Z30LPTJ
         LR    R5,R4              POINTER TO  LAST NON-BLANK     Y02669
         SH    R5,FOUR            POINTER TO 'NLINE,'FLINE,OR    Y02669
*                                 'NSOLE                         Y02669
         LR    R6,R3              GET POINTER TO BEG OF BUFFER @Z30LPTJ
         B     STRTSCAN           START SCANNING THE COMMAND   @Z30LPTJ
         SPACE
CHKON    EQU   *                                               @Z30LPTJ
         LA    R6,K6(R6)          POINT PAST 'ONLINE' KEYWORD  @Z30LPTJ
         B     CHECKER            AVOID 'OFFLINE' INCREMENTER  @Z30LPTJ
CHKOFF   EQU   *                                               @Z30LPTJ
         LA    R6,K7(R6)          POINT PAST 'OFFLINE' KEYWORD @Z30LPTJ
CHECKER  EQU   *                                               @Z30LPTJ
         CLI   K0(R6),BLANK       IS THERE A REQUIRED BLANK?   @Z30LPTJ
         BE    IEE3603A           YES, A BLANK IS FOUND        @Z30LPTJ
         B     TERM               NO, TAKE ERROR EXIT          @Z30LPTJ
         EJECT
************************************************************** @Z30LPTJ
*                                                            * @Z30LPTJ
* DETERMINE IF THERE IS A VARY RANGE COMMAND                 * @Z30LPTJ
*                                                            * @Z30LPTJ
************************************************************** @Z30LPTJ
STRTSCAN EQU   *                                               @Z30LPTJ
         LR    R10,R6             OBTAIN AN INDEXING REGISTER  @Z30LPTJ
         CLI   K0(R10),LEFPAREN   IS THERE A LEFT PARENTHESIS? @Z30LPTJ
         BNE   SCANHERE           NO, AVOID INDEXING           @Z30LPTJ
         LA    R10,K1(R10)        INDEX TO NEXT CHARACTER      @Z30LPTJ
SCANHERE EQU   *                                               @Z30LPTJ
         CLI   K3(R10),HYPHEN     IS 3RD CHARACTER A HYPHEN?   @Z30LPTJ
         BNE   ONVARY             NO, DO NOT ENTER VARY RANGE  @Z30LPTJ
         CLI   K2(R10),EYEDASH    IS 2ND CHARACTER AN 'I'      @Z30LPTJ
         BE    ONVARY             YES, DO NOT ENTER VARY RANGE @Z30LPTJ
         CLI   K2(R10),OHDASH     IS 2ND CHARACTER AN 'O'      @Z30LPTJ
         BE    ONVARY             YES, DO NOT ENTER VARY RANGE @Z30LPTJ
         CLC   K0(K5,R5),FLINE    IS THIS VARY OFFLINE?        @Z30LPTJ
         BE    RANGLOOP           YES, AVOID ONLINE BIT SETTING@Z30LPTJ
         CLC   K0(K5,R5),NLINE    IS THIS VARY ONLINE?         @Z30LPTJ
         BNE   CONFLICT           NO, ISSUE ERROR MESSAGE      @Z30LPTJ
         OI    XAAVRANG,XAARNG4   TURN ONLINE BIT ON           @Z30LPTJ
RANGLOOP EQU   *                                               @Z30LPTJ
         CLI   K7(R10),COMMA      IS 7TH CHARACTER A COMMA?    @Z30LPTJ
         BNE   CHECK              NO, CHECK END DELIMTER       @Z30LPTJ
         CLC   K8(K6,R10),ONLINE  IS IT ONLINE KEYWORD NOW?    @Z30LPTJ
         BE    NEXTMOD            YES, GO TO IEECB904          @Z30LPTJ
         CLC   K8(K7,R10),OFFLINE IS IT OFFLINE KEYWORD NOW?   @Z30LPTJ
         BE    NEXTMOD            YES, GO TO IEECB904          @Z30LPTJ
         CLC   K8(K7,R10),CONSOLE IS IT CONSOLE KEYWORD?       @Z30LPTJ
         BE    CONFLICT           YES, ISSUE ERROR MESSAGE     @Z30LPTJ
         LA    R10,K8(R10)        INDEX TO NEXT SET OF RANGE   @Z30LPTJ
         CLI   K3(R10),HYPHEN     IS 3RD CHARACTER A HYPHEN?   @Z30LPTJ
         BE    RANGLOOP           YES, CHECK FURTHER           @Z30LPTJ
         B     TERM               NO, ISSUE ERROR MESSAGE      @Z30LPTJ
CHECK    EQU   *                                               @Z30LPTJ
         CLI   K7(R10),RTPAREN    IS IT A RIGHT PARENTHESIS?   @Z30LPTJ
         BNE   DELIMIT            NO, ISSUE ERROR MESSAGE      @Z30LPTJ
         CLI   K8(R10),COMMA      IS NEXT CHARACTER A COMMA?   @Z30LPTJ
         BNE   DELIMIT            NO, ISSUE ERROR MESSAGE      @Z30LPTJ
         CLC   K9(K6,R10),ONLINE  IS IT ONLINE KEYWORD NOW?    @Z30LPTJ
         BE    NEXTMOD            YES, GO TO IEECB904          @Z30LPTJ
         CLC   K9(K7,R10),OFFLINE IS IT OFFLINE KEYWORD NOW?   @Z30LPTJ
         BE    NEXTMOD            YES, GO TO IEECB904          @Z30LPTJ
         CLC   K9(K7,R10),CONSOLE IS IT CONSOLE KEYWORD?       @Z30LPTJ
         BNE   TERM               NO, ISSUE ERROR MESSAGE      @Z30LPTJ
         EJECT
************************************************************** @Z30LPTJ
*                                                            * @Z30LPTJ
* ERROR MESSAGES ARE ISSUED HERE DUE TO BAD VARY RANGE       * @Z30LPTJ
* COMMANDS                                                   * @Z30LPTJ
*                                                            * @Z30LPTJ
************************************************************** @Z30LPTJ
CONFLICT EQU   *                                               @Z30LPTJ
         MVC   XSA(CONFLNG),CONFMSG SET UP MESSAGE BUFFER      @Z30LPTJ
         B     MSGOUT             GO TO WTO ISSUER             @Z30LPTJ
TERM     EQU   *                                               @Z30LPTJ
         MVC   XSA(TERMLNG),TERMMSG SET UP MESSAGE BUFFER      @Z30LPTJ
         B     MSGOUT             GO TO WTO ISSUER             @Z30LPTJ
DELIMIT  EQU   *                                               @Z30LPTJ
         MVC   XSA(DELIMLNG),DELIMMSG SET UP MESSAGE BUFFER    @Z30LPTJ
MSGOUT   EQU   *                                               @Z30LPTJ
         SR    R0,R0              CLEAR FOR NEXT INSTRUCTION   @Z30LPTJ
         TM    XAU,RI             IS THIS FROM INPUT STREAM?   @ZM30445
         BO    XAUIN1             YES, DON'T INSERT CONSOLE ID @ZM30445
         IC    R0,XAU             INSERT CONSOLE ID            @Z30LPTJ
XAUIN1   EQU   *                                               @ZM30445
         LA    R1,XSA             GET POINTER TO MESSAGE BUFFER@Z30LPTJ
         WTO   MF=(E,(1))         ISSUE ERROR MESSAGE          @Z30LPTJ
         LM    R0,R15,K0(R13)     RESTORE REGISTERS            @Z30LPTJ
         LR    R4,R14             PREPARE FOR RETURN EXECUTION @Z30LPTJ
         B     NODELETE           PREPARE TO RETURN TO CALLER  @Z30LPTJ
         EJECT
************************************************************** @Z30LPTJ
*                                                            * @Z30LPTJ
* A GOOD VARY RANGE COMMAND HAS BEEN ISSUED                  * @Z30LPTJ
*                                                            * @Z30LPTJ
************************************************************** @Z30LPTJ
NEXTMOD  EQU   *                                               @Z30LPTJ
         LR    R10,R14            SAVE RETURN TO CALLER ADDRESS@Z30LPTJ
         L     R0,WORKAREA        OBTAIN CORE SPECIFICATION    @Z30LPTJ
         GETMAIN R,LV=(0)         GET THE DATA AREA CORE       @Z30LPTJ
         LR    R9,R1              SET DATA AREA ADDRESSABILITY @Z30LPTJ
NEXTMODA EQU   *                                               @Z30LPTJ
         XC    XAD(K4),XAD        CLEAR XAD ACROSS VARY AREA   @Z30LPTJ
         XC    XAP(K4),XAP        CLEAR XAP ACROSS VARY AREA   @Z30LPTJ
         L     R15,VCON904        GET IEECB904 ADDRESS         @Z30LPTJ
         BR    R15                GO TO VARY RANGE PROCESSOR   @Z30LPTJ
         EJECT
************************************************************** @Z30LPTJ
*                                                            * @Z30LPTJ
* SECONDARY ENTRY POINT AFTER A VARY RANGE COMMAND HAS BEEN  * @Z30LPTJ
* PROPAGATED INTO INDIVIDUAL UNITS                           * @Z30LPTJ
*                                                            * @Z30LPTJ
************************************************************** @Z30LPTJ
IEE36ENT EQU   *                                               @Z30LPTJ
         LR    R14,R10            GET RETURN TO CALLER ADDRESS @Z30LPTJ
         L     R5,D64(R13)        OBTAIN THE CSCB POINTER      @Z30LPTJ
         USING CHAIN1,R5          ESTABLISH CSCB ADDRESSABILITY@Z30LPTJ
         MVC   XAU(K1),CHUCMP     RE-SET UCM ID                @Z30LPTJ
         MVC   XAS(K2),CHINC      RE-SET R/I AUTHORITY         @Z30LPTJ
         DROP  R5                                              @Z30LPTJ
         MVC   XAV(K8),VARY       RE-SET VARY VERB INDICATOR   @Z30LPTJ
         MVC   XAX(K8),IEE3303D   RE-SET EXIT IDENTIFIER       @Z30LPTJ
         L     R3,XAL             GET POINTER TO NEW COMMAND   @Z30LPTJ
         LA    R3,K0(R3)          CLEAR HIGH ORDER BYTE        @Z30LPTJ
         L     R6,K136(R3)        OBTAIN SAVED XAD             @Z30LPTJ
         ST    R6,XAD             RESTORE XAD INTO THE XSA     @Z30LPTJ
         L     R6,K140(R3)        OBTAIN SAVED XAP             @Z30LPTJ
         ST    R6,XAP             RESTORE XAP INTO THE XSA     @Z30LPTJ
         LR    R6,R3              NEEDED FOR VARY PROCESSING   @Z30LPTJ
         LA    R4,D124            RE-ESTABLISH BUFFER SIZE     @Z30LPTJ
         ST    R4,XAR             PUT INTO XSA SLOT            @Z30LPTJ
         AR    R4,R6              OBTAIN END OF BUFFER POINTER @Z30LPTJ
BUFFLOOP EQU   *                                               @Z30LPTJ
         BCTR  R4,R0              DECREMENT END ADDRESS BY ONE @Z30LPTJ
         CLI   K0(R4),BLANK       IS THIS CHARACTER A BLANK?   @Z30LPTJ
         BE    BUFFLOOP           YES, LOOK FOR LAST END BLANK @Z30LPTJ
         LR    R5,R4              POINTER TO LAST NON-BLANK    @Z30LPTJ
         SH    R5,FOUR            POINTER TO 'NLINE' OR 'FLINE'@Z30LPTJ
         TM    XAAVRANG,XAARNG2   ENQ DONE ALREADY?            @Z30LPTJ
         BO    DIDENQ             YES, PROCESS THE COMMAND     @Z30LPTJ
ENQBIT   EQU   *                                               @Z30LPTJ
         OI    XAAVRANG,XAARNG2   TURN ENQ RESOURCE BIT ON     @Z30LPTJ
         EJECT
************************************************************** @Z30LPTJ
*                                                            * @Z30LPTJ
* COMMON VARY PROCESSING                                     * @Z30LPTJ
*                                                            * @Z30LPTJ
************************************************************** @Z30LPTJ
ONVARY   EQU   *                                               @Z30LPTJ
         CLC   K0(K5,R5),FLINE    IS IT AN OFFLINE COMMAND?      Y02669
         BE    OFFLENQ            YES, DO ENQ FOR THIS COMMAND @YM5443P
         CLC   K0(K5,R5),NLINE    IS IT AN ONLINE COMMAND?     @YM5443P
         BE    ONLENQ             YES, DO ENQ FOR THIS COMMAND @YM5443P
         LA    R11,K5             OBTAIN MAXIMUM CTR COMPRAND  @YM5443P
         LA    R10,K1             SET INCREMENTER TO ONE       @YM5443P
         LR    R9,R10             SET COUNTER TO ONE           @YM5443P
         ENQ   MF=(E,IEFSCONA)                                 @YM5443P
LOOPENQ  EQU   *                                               @YM5443P
         XC    ECBAREA(K4),ECBAREA CLEAR ECB AREA              @YM5443P
         MVC   ENQMVC(ENQLNTH),IEFSCONB                        @YM5443P
         LA    R1,ENQMVC                                       @YM5443P
         ENQ   MF=(E,(1)),ECB=ECBAREA                          @YM5443P
         LTR   R15,R15            IS RESOURCE OBTAINED?        @YM5443P
         BZ    DIDENQ             YES,EXIT                     @YM5443P
         STIMER WAIT,DINTVL=TIMELOC NO, WAIT 5 SECONDS?        @ZA09414
         TM    ECBAREA,ECBPOST    ECB POSTED?                  @YM5443P
         BO    DIDENQ             YES,EXIT                     @YM5443P
         DEQ   MF=(E,IEFSCONC)    NO, DEQUEUE                  @YM5443P
         BXLE  R9,R10,LOOPENQ     FIFTH ENQUEUE ATTEMPTED?     @YM5443P
REISSUE  EQU   *                  SET UP TO ISSUE WTOR         @ZA09166
         MVC   IEE799D(IEE799L),IEE799B MOVE LIST FORM TO DSECT@ZA09166
         SR    R0,R0              CLEAR WORK REGISTER          @ZA09166
         ST    R0,ECBAREA         CLEAR THE ECB                @ZA09166
         TM    XAU,RI             IS THE CMD FROM INPUT STREAM @ZA09166
         BO    NOCNSID            YES, NO CONSOLE ID NEEDED    @ZA09166
         IC    R0,XAU             GET THE CONSOLE ID           @ZA09166
NOCNSID  EQU   *                  ISSUE THE WTOR               @ZA09166
         WTOR   ,RPYAREA,6,ECBAREA,MF=(E,IEE799) ISSUE MSG     @ZA09166
         WAIT  ECB=ECBAREA        WAIT FOR A REPLY             @ZA09166
         OC    RPYAREA(L'RPYAREA),BLANKS CAPITALIZE REPLY      @ZA09166
         CLC   RPYAREA(L'CANCEL),CANCEL IS REPLY CANCEL        @ZA09166
         BNE   NOTCANCL           YES, EXIT THIS MODULE        @ZA09166
         SR    R0,R0               CLEAR R0 FOR CONS. ID       @ZA09166
         TM    XAU,RI              IS THIS FROM INPUT STREAM   @ZA09166
         BO   NOCNSID1             YES, DON'T INSERT CONSOLE ID@ZA09166
         IC    R0,XAU              CONSOLE ID FOR WTO          @ZA09166
NOCNSID1 EQU   *                                               @ZA09166
         WTO   MF=(E,IEE756I)      ISSUE VARY CNACELLED MSG    @ZA09166
         B     IEE36050            TERMINATE THE VARY COMMAND  @ZA09166
NOTCANCL EQU   *                                               @ZA09166
         CLC   RPYAREA(L'RETRY),RETRY IS REPLY RETRY           @ZA09166
         BNE   NOTRETRY           NO, CHECK FOR WAIT           @ZA09166
         LA    R11,K5             GET COUNTER FOR ENQ LOOP     @ZA09166
         LA    R10,K1             GET INCREMENT FOR ENQ LOOP   @ZA09166
         LR    R9,R10             START COUNT AT ONE           @ZA09166
         XC    ECBAREA(L'ECBAREA),ECBAREA CLEAR THE ECB        @ZA09166
         B     LOOPENQ            TRY THE ENQ LOOP AGAIN       @ZA09166
NOTRETRY EQU   *                  REPLY NOT RETRY, CHECK WAIT  @ZA09166
         CLC   RPYAREA(L'WAIT),WAIT WAS REPLY WAIT             @ZA09166
         BNE   REISSUE            NO, REISSUE WTOR             @ZA09166
         ENQ   MF=(E,IEFSCOND)    YES, OBTAIN RESOURCE         @YM5443P
         B     DIDENQ                                          @YM5443P
OFFLENQ  EQU   *                                               @YM5443P
         ENQ   MF=(E,IEFSOFFA)                                 @YM5443P
         ENQ   MF=(E,IEFSOFFB)                                 @YM5443P
         TM    XAAVRANG,XAARNG1   VARY RANGE BEING PROCESSED?  @Z30LPTJ
         BO    DIDENQ             YES, PROCESS THE COMMAND     @Z30LPTJ
         B     IEE360D0           EXIT TO IEE3303D             @YM5443P
ONLENQ   EQU   *                                               @YM5443P
         ENQ   MF=(E,IEFSDONA)                                 @YM5443P
         ENQ   MF=(E,IEFSDONB)                                 @YM5443P
DIDENQ   EQU   *                                               @YM5443P
         SR    R4,R6               CALCULATE LENGTH OF OPERANDS
         BCTR  R6,R0               DECREMENT BUFFER ADDRESS
         SPACE 1
         BAL   R14,IEE36140        LINK TO FIND NEXT TERM LGTH
         LA    R7,K0(R5,R6)        GET ADDR OF CHAR AFTER TERM
         BAL   R11,IEE36120        SEE IF SINGLE VALID TERM
         BNE   IEE36060            IF NOT, CHECK FOR MULT TERMS
         SPACE 1
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
*                                                             *
* VERIFY PATHS FOR SINGLE OPERAND (DEVICE) SPECIFIED          *
*                                                             *
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
         SPACE 1
         BAL   R10,IEE360E0        SEE IF UNIT HAS GOOD PATHS
         B     IEE360D0            IF SO, TAKE NORMAL EXIT
         EJECT
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
*                                                             *
* ERROR EXIT CODE (RETURN TO SYSTEM                           *
*                                                             *  Y02669
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
         SPACE 1
IEE36050 EQU   *                                                 Y02651
         TM    XAAVRANG,XAARNG1   VARY RANGE BEING PROCESSED?  @Z30LPTJ
         BNO   IEEDEQUE           NO, AVOID EXIT TO IEECB904   @Z30LPTJ
         OI    XAAVRANG,XAARNG3   TURN TERMINATION BIT ON      @Z30LPTJ
         LM    R0,R15,K0(R13)     RESTORE REGISTERS            @Z30LPTJ
         B     NEXTMODA           EXIT VIA IEECB904            @Z30LPTJ
         SPACE 2
IEE36904 EQU   *                                               @Z30LPTJ
         TM    XAAVRANG,XAARNG1   VARY RANGE BEING PROCESSED?  @Z30LPTJ
         BO    NEXTMODA           YES, PROCESS MORE UNITS      @Z30LPTJ
         SPACE 2
*****************************************************************Y02651
*                                                                Y02651
*  SINCE THIS IS A TERMINAL EXIT WE MUST DEQUE OFF BEFORE GETTINGY02651
*  OUT OF THIS COMMAND PROCESSOR                                 Y02651
*                                                                Y02541
IEEDEQUE EQU   *                                                 Y02651
         DEQ   MF=(E,IEFDEQUE)                                   Y02651
*                                                                Y02651
*****************************************************************Y02651
         SPACE 5
         LM    R0,R15,K0(R13)           RESTORE REGS             Y02669
         LR    R4,R14             SAVE RET ADDRESS               Y02669
         L     R15,XAP            GET IEEVDEV ADDRESS          @Z30LPTJ
         LTR   R15,R15            IS THERE AN ADDRESS?         @Z30LPTJ
         BZ    NODELETE           NOPE, NO DELETE REQUIRED     @Z30LPTJ
         XC    XAP(K4),XAP        MUST ISSUED DELETE FOR VDEV  @Z30LPTJ
         DELETE EP=IEEVDEV                                     @Z30LPTJ
         L     R1,XAD             ADDR OF VDEV PARAM CORE      @Z30LPTJ
         LTR   R1,R1              ANY PTR?, JUST IN CASE       @Z30LPTJ
         BZ    NODELETE           NOPE, NOTHING TO FREE        @Z30LPTJ
         LA    R0,TREE08         SIZE OF THAT CORE             @Z30LPTJ
         FREEMAIN R,LV=(0),A=(1)                               @Z30LPTJ
         XC    XAD(K4),XAD        ZERO OUT CORE PTR            @Z30LPTJ
NODELETE EQU   *                                               @Z30LPTJ
         L     R0,IEE36GMP        3603D WORK AREA SIZE         @Z30LPTJ
         LR    R1,R8              AND POINTER                  @Z30LPTJ
         FREEMAIN R,LV=(0),A=(1)                               @Z30LPTJ
         L     R1,D64(R13)        CSCB PTR                       Y02669
         USING CHAIN1,R1                                         Y02669
         OI    CHSTS,CHFC         SET - FREE CSCB BIT            Y02669
         MGCR  (1),CHAIN                                         Y02669
         LA    R0,D132            CORE GOTTEN FOR VARY = SIZE    Y02669
         LR    R1,R2              POINTER INTO REG1              Y02669
      FREEMAIN R,LV=(0),A=(1)      FREE UP WORK/SAVE AREA
         LR    R14,R4             RESTORE RETURN REG             Y02669
         BR    R14                 EXIT - NO VARY ONLINE DONE
         EJECT
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
*                                                             *
* LOOP TO CHECK SYNTAX OF EACH TERM                           *
*   EXIT - TO IEE360D0 FOR ANY INVALID TERM                   *
*        - TO IEE36080 (NSI) IF ALL TERMS ARE VALID           *
*                                                             *
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
         SPACE 1
IEE36060 LR    R6,R3               GET PTR TO BEG OF OPERANDS
         SPACE 1
IEE36070 BAL   R11,IEE36110        LINK TO VALIDATE NEXT TERM
         BNE   IEE360D0            TAKE NORMAL EXIT ON INV TERM
         ALR   R6,R5               UPDATE INDEX TO NEXT TERM
         CLC   K0(K2,R6),IEE36END  SEE IF DELIMETED BY C'),'
         BNE   IEE36070            LOOP UNTIL END OF LIST FOUND
         SPACE 1
         LR    R6,R3               GET PTR TO BEG OF OPERANDS
         SPACE 1
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
*                                                             *
* LOOP TO VERIFY PATHS FOR EACH OPERAND (DEVICE) SPECIFIED    *
*                                                             *
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
         SPACE 1
IEE36080 BAL   R14,IEE36140        LINK TO LOCATE NEXT TERM
         BAL   R10,IEE360E0        LINK TO CHECK UNIT'S PATHS
         SPACE 1
         B     IEE360B0            UPDATE INDEX FOR GOOD PATH
         SPACE 1
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
*                                                             *
* CODE TO DELETE UNIT HAVING NO PATHS FROM THE XSA            *
*                                                             *
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
         SPACE 1
         SLR   R4,R5               SUBTR LGTH TO DELETE FR TOTL
         LA    R7,K1(R6,R4)        GET ADDR OF NEW END OF BUFFR
         LA    R9,K0(R5,R6)        GET ADDR OF NEXT TERM
         EX    R4,IEE36090         OVERLAY DELETED TERM
         BCTR  R5,R0               DECREMENT LENGTH BY ONE
         BCTR  R5,R0               DECREMENT LENGTH BY ONE
         MVI   K0(R7),X40          MOVE BLANK INTO END OF BUFFR
         EX    R5,IEE360A0         BLANK OUT END OF BUFFER
         B     IEE360C0            GO TO SEE IF FINISHED
         SPACE 1
IEE36090 MVC   K0(K0,R6),K0(R9)    EX TO OVERLAY DELETED UNIT
IEE360A0 MVC   K1(K0,R7),K0(R7)    EX TO BLANK REMAINDER OF BUF
         EJECT
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
*                                                             *
* CODE TO UPDATE INDEX, LEAVING GOOD UNIT IN THE XSA          *
*                                                             *
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
         SPACE 1
IEE360B0 MVI   K0(R3),X4D          SET SWITCH FOR GOOD UNIT
         ALR   R6,R5               UPDATE OPERANDS INDEX
         SLR   R4,R5               DECREMENT REMAINING LENGTH
         SPACE 1
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
*                                                             *
* CODE TO LOOP UNTIL SCAN IS COMPLETE                         *
*   EXIT - TO IEE36080 IF SCAN IS NOT COMPLETE                *
*        - TO IEE360D0 (NSI) IF ANY UNIT IS LEFT IN THE XSA   *
*        - TO IEE36050 IF NO UNIT IS LEFT IN THE XSA          *
*                                                             *
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
         SPACE 1
IEE360C0 CLI   K0(R6),X5D          SEE IF SCAN IS COMPLETE
         BNE   IEE36080            LOOP UNTIL SCAN IS COMPLETED
         CLI   K0(R3),X4D          SEE IF ANY TERMS LEFT IN XSA
         BNE   IEE36904            IF NOT, IGNORE THE COMMAND  @Z30LPTJ
        SPACE 1
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
*                                                             *
* NORMAL EXIT CODE (EXIT TO VARY COMMAND PROCESSOR)           *  Y02669
*                                                             *
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
         SPACE 1
IEE360D0 EQU   *                                                 Y02669
         TM    XAAVRANG,XAARNG1   VARY RANGE BEING PROCESSED?  @Z30LPTJ
         BO    EXIT33             YES, DO NOT FREE AREAS       @Z30LPTJ
         LR    R1,R8              3603D'S WORK AREA POINTER      Y02669
         L     R0,IEE36GMP        AND ITS SIZE                   Y02669
      FREEMAIN R,LV=(0),A=(1)      FREE UP WORK/SAVE AREA
         L     R15,XAP                                           Y02669
         LTR   R15,R15            DID WE EVER LOAD IEEVDEV?      Y02669
         BZ    EXIT33             NOPE, NO DELETE REQUIRED       Y02669
         XC    XAP(K4),XAP        WE MUST DELETE VDEV FIRST      Y02669
         DELETE EP=IEEVDEV                                       Y02669
         L     R1,XAD             GET ADDR OF VDEV PARAM CORE    Y02669
         LTR   R1,R1              ANY PTR, JUST IN CASE          Y02669
         BZ    EXIT33             NOPE, NOTHING TO FREE          Y02669
         LA    R0,TREE08         GET SIZE INTO R0               YM01603
         FREEMAIN R,LV=(0),A=(1)                                 Y02669
         XC    XAD(K4),XAD        ZERO PARAM PTR                 Y02669
EXIT33   EQU   *                                                 Y02669
         L     R15,VCON33         ADDRESS OF IEE3303D          @Z30LPTJ
         LM    R0,R14,K0(R13)     RESTORE THE REGISTERS        @Z30LPTJ
         BR    R15                EXIT TO 3303D                  Y02669
         EJECT
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
*                                                             *
* ROUTINE TO SET INDEX AND LINK TO CHECK PATHS FOR AN OPERAND *
*   EXIT - TO K0(R10) IF TERM IS SATISFACTORY (GOOD PATHS)    *
*        - TO K4(R10) IF TERM SHOULD BE REJECTED (NO PATHS)   *
*                                                             *
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
         SPACE 1
IEE360E0 LR    R7,R6               GET PATH TEST OPERAND INDEX
         CLC   K1(K3,R7),IEE36CIN  SEE IF COMPOSITE CONSOLE    @ZM30436
         BE    IEE36100            IF SO, GO TEST BOTH UNITS
         CLC   K1(K2,R7),IEE36OUT  SEE IF OUTPUT-ONLY CONSOLE  @ZM30479
         BNE   IEE360F0            IF NOT, GO TEST NON-MCS UNIT
         LA    R7,K2(R7)           UPDATE INDEX FOR O-UNIT
IEE360F0 BAL   R11,IEE361A0        LINK TO TEST UNIT'S PATHS
         LTR   R15,R15            DOES THE UNIT HAVE A PATH?     Y02669
         BNZ   K4(R10)            NOPE, OMIT THIS UNIT           Y02669
         BR    R10                 ELSE TAKE A NORMAL EXIT
IEE36100 LA    R7,K3(R7)           UPDATE INDEX FOR I-UNIT
         BAL   R11,IEE361A0        LINK TO CHECK I-UNIT'S PATHS
         ST    R15,D68(R13)   STORE RET CODE FOR FUTURE USE      Y02669
         LA    R7,K6(R7)           UPDATE TEST INDEX FOR O-UNIT
         BAL   R11,IEE361A0        LINK TO CHECK O-UNIT'S PATHS
         BALR  R7,R0               SAVE CONDITION CODE BITS
         LTR   R15,R15            IS THE O-UNIT PATHABLE?        Y02669
         BNZ   K4(R10)            NOPE, OMIT THIS COMPOSITE      Y02669
         L     R15,D68(R13)    GET CODE FROM I-UNIT              Y02669
         LTR   R15,R15            IS THE I-UNIT PATHABLE?        Y02669
         BNZ   K4(R10)            NOPE, OMIT THIS COMPOSITE UNIT Y02669
         BR    R10           YES, ALL IS OK WITH THIS UN IT      Y02669
         EJECT
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
*                                                             *
* ROUTINE TO VALIDATE SYNTAX OF SPECIFIED TERM                *
*   EXIT - CC=0 ONLY IF SYNTAX OF TERM IS VALID               *
* THE FOLLOWING TERMS ARE CONSIDERED VALID                    *
*        DDD      - ANY I/O DEVICE DDD                        *
*       DDD/B     - BIN B OF DATA CELL DDD                    *
*       O-DDD     - OUTPUT-ONLY CONSOLE DDD                   *
*   (I-DDD,O-DDD) - COMPOSITE CONSOLE DDD/DDD                 *
*                                                             *
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
         SPACE 1
IEE36110 BAL   R14,IEE36140        LINK TO IDENTIFY NEXT TERM
IEE36120 CH    R5,IEE36H04         SEE IF LENGTH IS 4
         BCR   BE,R11              IF SO, EXIT (VALID TERM)
         CH    R5,IEE36H06         SEE IF LENGTH IS 6
         BNE   IEE36130            IF NOT, CHECK FOR COMPOS CON
         CLC   K1(K2,R6),IEE36OUT  SEE IF OUTPUT-ONLY CONSOLE
         BR    R11                 EXIT (VALID OR INVALID TERM)
IEE36130 CH    R5,IEE36H14         SEE IF LENGTH OF TERM IS 14
         BCR   BNE,R11             IF NOT, EXIT (INVALID TERM)
         CLC   K1(K3,R6),IEE36CIN  SEE IF BEGIN WITH C'(I-'
         BCR   BNE,R11             IF NOT, EXIT (INVALID TERM)
         CLC   K7(K3,R6),IEE36COU  SEE IF 6TH ON ARE C',O-'
         BCR   BNE,R11             IF NOT, EXIT (INVALID TERM)
         CLI   K13(R6),X5D         SEE IF LAST CHAR IS C')'
         BR    R11                 EXIT (VALID OR INVALID TERM)
         EJECT
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
*                                                             *
* ROUTINE TO LOCATE NEXT COMMA NOT WITHIN PARENTHESES         *
*   EXIT - TO IEE360D0 IF SCAN EXCEEDS LOGICAL END OF BUFFER  *
*        - TO IEE360D0 IF MORE THAN 2 LEVELS OF PARENTHESES   *
*        - TO K0(R14) IF COMMA NOT WITHIN PARENTHESES LOCATED *
*        - TO K0(R14) IF UNPAIRED PARENTHESES ENCOUNTERED     *
*                                                             *
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
         SPACE 1
IEE36140 STM   R9,R11,K8(R8)      SAVE WORK REGISTER CONTENTS    Y02669
         SR    R9,R9               ZERO PARENTHESES COUNTER
         LA    R10,K1              INITIALIZE BXLE INCREMENT
         LA    R11,K0(R4,R6)       INITIALIZE BXLE COMPARAND
         LR    R5,R6               INITIALIZE OPERANDS INDEX
IEE36150 CLI   K1(R5),X4D          SEE IF NEXT CHAR IS C'('
         BE    IEE36170            IF SO, ADD 1 TO PAREN COUNTR
         CLI   K1(R5),X5D          IF NOT, SEE IF IT IS C')'
         BE    IEE36180            IF SO, DECREM PAREN COUNTER
         CLI   K1(R5),X6B          SEE IF IT IS A COMMA
         BNE   IEE36160            IF NOT, KEEP SEARCHING
         LTR   R9,R9               SEE IF COMMA IS WITHIN ( )'S
         BZ    IEE36190            IF NOT, EXIT-END OF TERM FND
IEE36160 BXLE  R5,R10,IEE36150     LOOP TO CHECK NEXT CHARACTER
         B     IEE360D0            NORMAL EXIT IF END OF BUFFER
IEE36170 CR    R9,R10              SEE IF MORE THAN 2 LEVELS ()
         BH    IEE360D0            IF SO, TAKE A NORMAL EXIT
         BXLE  R9,R10,IEE36160     IF NOT, INC PAREN COUNT,LOOP
IEE36180 SR    R9,R10              DECREMENT PAREN COUNTER
         BNM   IEE36160            LOOP IF ()'S ARE PAIRED
IEE36190 SLR   R5,R6               CALCULATE LENGTH OF TERM
         ALR   R5,R10                  UPDATE LENGTH BY ONE
         LM    R9,R11,K8(R8)       RESTORE THE WORK REGISTERS    Y02669
         BR    R14                 RETURN WITH LGTH IN REG R5
         EJECT
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
*                                                             *
*  ROUTINE TO VALIDATE GOOD PATHS FOR DDD AT DISPL K1(R7)     *
*                                                             *
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
IEE361A0 EQU   *                                                 Y02669
         STM   R0,R6,K8(R8)                                      Y02669
         MVC   IOSAREA+K5(K3),K1(R7) MOVE UNIT INTO WORK AREA  @YM3411P
         LA    R3,K9               ESTABLISH ADDER OF 9        @YM3411P
         LA    R5,K3               ESTABLISH BYTE COUNTER      @YM3411P
TRILOOP  LA    R6,IOSAREA+K4(R5)   GET CURRENT BYTE ADDRESS    @YM3411P
         TM    K0(R6),XF0          IS IT NUMERIC?              @YM3411P
         BO    AROUND              YES, BRANCH                 @YM3411P
         CLI   K0(R6),XC1          NO, IS IT BELOW 'A'?        @YM3411P
         BL    UNITMSG             YES, ERROR EXIT             @YM3411P
         CLI   K0(R6),XC6          NO, IS IT ABOVE 'F'?        @YM3411P
         BH    UNITMSG             YES, ERROR EXIT             @YM3411P
         IC    R4,K0(R6)           NO, PREPARE FOR ADDITION    @YM3411P
         AR    R4,R3               CHANGE NUMBER TO ALPHA      @YM3411P
         STC   R4,IOSAREA+K4(R5)   STORE BACK INTO WORKAREA    @YM3411P
AROUND   BCT   R5,TRILOOP          THREE BYTES DONE?           @YM3411P
         PACK  IOSAREA(K4),IOSAREA+K5(K3) YES, TAKE OUT ZONES  @YM3411P
         L     R6,IOSAREA          PREPARE FOR IOSGEN MACRO    @YM3411P
         SRL   R6,K4               SHIFT OUT SIGN BIT          @YM3411P
         LR    R9,R13              SAVE SAVE AREA POINTER      @YM3411P
         LR    R1,R7               SAVE BUFFER POINTER         @YM3411P
         LA    R13,IOSAREA         POINTER TO IOSGEN SAVE AREA @YM3411P
         IOSGEN UCBLOOK            SCAN FOR SPECIFIED UCB      @YM3411P
         LR    R13,R9              RESTORE SAVE AREA POINTER   @YM3411P
         LR    R9,R7               PUT UCB ADDRESS INTO R9     @YM3411P
         LR    R7,R1               RESTORE BUFFER POINTER      @YM3411P
         LTR   R15,R15             RETURN CODE 0?              @YM3411P
         BNZ   UNITMSG             NO, ISSUE ERROR MESSAGE     @YM3411P
         USING OUCB,R9             YES, ESTABLISH UCB BASE     @YM3411P
         TM    UCBWGT,UCBMTPXP     SUB-UCB'S EXIST?            @YM3411P
         BNO   GOODUCB             NO, BRANCH                  @YM3411P
         L     R1,UCBBASE          YES, GET MASTER UCB ADDRESS @YM3411P
         LA    R1,D512(R1)         GET POINTER TO BASE UCB     @YM3411P
         CR    R9,R1               DOES UCB ADDRESSES MATCH?   @YM3411P
         BNE   UNITMSG             NO, ISSUE ERROR MESSAGE     @YM3411P
GOODUCB  EQU   *                   YES, PROCEED WITH EXECUTION @YM3411P
************************************************************** @Z30LPTJ
*                                                            * @Z30LPTJ
* IF VARY RANGE IS PRESENT, INCREMENT GOOD UNIT COUNTER FOR  * @Z30LPTJ
* THE DISPLAY UNIT COMMAND WHICH WILL BE ISSUED AT THE END   * @Z30LPTJ
* OF THE VARY RANGE PROCESS.  IF THE UCB INDICATES THAT THIS * @Z30LPTJ
* IS AN ALTERNATE PATH, OR IS A DEVICE WITHOUT AN UCB DEVICE * @Z30LPTJ
* NAME, THE COUNT IS NOT INCREMENTED.  INSTEAD A BIT IS      * @Z30LPTJ
* MARKED AND AIDS IN THE OUTPUT FROM IEECB904.               * @Z30LPTJ
*                                                            * @Z30LPTJ
************************************************************** @Z30LPTJ
         TM    XAAVRANG,XAARNG1    VARY RANGE BEING PROCESSED? @Z30LPTJ
         BNO   GOODUCB1            NO, PROCEED NORMALLY        @Z30LPTJ
         CLC   UCBNAME(K3),K1(R7)  DOES UCB NAMES MATCH?       @Z30LPTJ
         BNE   ALTMARK             NO, DO NOT INCLUDE IN COUNT @Z30LPTJ
         SR    R1,R1               PREPARE FOR NEXT INSTRUCTION@Z30LPTJ
         C     R1,UCBTYP           DEVICE TYPE INFO. PRESENT?  @Z30LPTJ
         BE    ALTMARK             NO, DO NOT INCLUDE IN COUNT @Z30LPTJ
         L     R1,XAL              GET VARY RANGE BUFFER @     @Z30LPTJ
         LH    R6,K130(R1)         GET VALID UNIT COUNTER      @Z30LPTJ
         LA    R6,K1(R6)           INCREMENT IT BY ONE         @Z30LPTJ
         STH   R6,K130(R1)         STORE THE COUNTER           @Z30LPTJ
         B     GOODUCB1            AVOID BIT SETTING           @Z30LPTJ
ALTMARK  EQU   *                                               @Z30LPTJ
         OI    XAAVRANG,XAARNG5    INDICATE A NON-COUNTED      @Z30LPTJ*
                                    DEVICE                     @Z30LPTJ
GOODUCB1 EQU   *                                               @Z30LPTJ
         CLI   UCBTBYT3,UCB3UREC   TEST FIRST BYTE FOR DSM     @Z30LPTJ
         BNE   GOODUCB2            DATA STAGING MANAGER NOT UP @Z30LPTJ
         CLI   UCBTBYT4,UCBDSM     TEST SECOND BYTE FOR DSM    @Z30LPTJ
         BE    SS1MSG              IT IS A DSM, PUT OUT MSG.   @Z30LPTJ
GOODUCB2 EQU   *                                               @Z30LPTJ
         TM    UCBSTAT,UCBONLI     IF DEV IS ONLINE, THEN THERE  Y02669
         BO    IEE36200            IS NOT REASON TO CHECK PATHS  Y02669
         TM    XAAVRANG,XAARNG1    VARY RANGE BEING PROCESSED? @Z30LPTJ
         BNO   CHKPATH             NO, PROCEED NORMALLY        @Z30LPTJ
         TM    XAAVRANG,XAARNG4    OFFLINE BEING PROCESSED?    @Z30LPTJ
         BNO   IEE36200            YES, AVOID CHECKING PATHS   @Z30LPTJ
CHKPATH  EQU   *                                               @Z30LPTJ
         L     R1,XAD             PTR TO CORE FOR VDEV           Y02669
         LTR   R1,R1              CORE GOTTEN BEFORE?            Y02669
         BNZ   GOTBEFOR           WE ALREADY HAVE IT             Y02669
         GETMAIN R,LV=308       CORE FOR IEEVDEV SUBROUTINE     YM01603
         ST    R1,XAD             STORE FOR FUTURE USE           Y02669
         TM    XAAVRANG,XAARNG1   VARY RANGE BEING PROCESSED?  @Z30LPTJ
         BNO   GOTBEFOR           NO, AVOID SAVING XAD         @Z30LPTJ
         L     R5,XAL             GET VARY RANGE BUFFER        @Z30LPTJ
         ST    R1,K136(R5)        SAVE XAD INTO BUFFER SLOT    @Z30LPTJ
GOTBEFOR EQU   *                                                 Y02669
         ST    R14,TWELV(R1)      STORE RETURN ADDRESS           Y02669
         ST    R13,SIXTEEN(R1)    SAVE 3603D'S SAVE AREA PTR    YM01603
         LA    R14,FOR(R1)        GET ADDR OF PARAM LST ITSELF   Y02669
         ST    R14,ZERO(R1)       STORE ADDR IN PARAMLIST PTR    Y02669
         XC    FOR(EIT,R1),FOR(R1)                               Y02669
*  BYTE ONE OF THE SECND WORD OF THE PARAMLIST HAS A X'00'       Y02669
*  THIS IS A FUNCTION CODE = VARY ONLINE AND CONSOLE             Y02669
*  PROCESSING                                                    Y02669
         ST    R9,FOR(R1)         UCB PTR INTO WORD 1            Y02669
         LA    R13,TWENTY(R1)   INIT R13 TO IEEVDEV'S SAVE AREA YM01603
         L     R15,XAP            XAP IS 0 IF NO LOAD FOR VDEV   Y02669
*                                 WAS EVER DONE BEFORE,OR IT WILLY02669
         LTR   R15,R15            HAVE THE ADDR IF LOAD DONE     Y02669
         BNZ   EXTVDEV                                           Y02669
*                                 FOUND ADDR OF VDEV, NO LOAD    Y02669
         LR    R6,R1              SAVE PTR TO PARAM IN REG6(TEMP)Y02669
         LOAD  EP=IEEVDEV                                        Y02669
         LR    R1,R6              RESTORE PARAM LIST PTR         Y02669
         LR    R15,R0             SUBROUTINE'S ADDRES INTO R15   Y02669
         ST    R15,XAP            STORE FOR FUTURE USE           Y02669
         TM    XAAVRANG,XAARNG1   VARY RANGE BEING PROCESSED?  @Z30LPTJ
         BNO   EXTVDEV            NO, AVOID SAVING XAP         @Z30LPTJ
         L     R5,XAL             GET VARY RANGE BUFFER        @Z30LPTJ
         ST    R15,K140(R5)       SAVE XAP INTO BUFFER SLOT    @Z30LPTJ
EXTVDEV  EQU   *                                                 Y02669
         BALR  R14,R15            GO TO SUBROUTINE TO CHECK      Y02669
*                                 PATH TO THIS DEVICE            Y02669
         LR    R6,R15             SAVE RETURN CODE FROM SUBRTN   Y02669
         L     R14,TWELV(R1)      RESTORE CALLERS ADDRESS        Y02669
         L     R13,SIXTEEN(R1) REINIT R13 TO PTR TO 3603D'S SAVEYM01603
         SR    R15,R15                                           Y02669
         LTR   R6,R6              IS PATH TO DEVICE AVAILABLE    Y02669
         BZ    IEE36200           YES, ALL IS OK FOR THIS DEV.   Y02669
         MVC   IEE36MSG(LENG),IEE36INT INITIALIZE MSG BUFFER   @YM3411P
         LA    R15,K4             CHECK FOR RETCODE OR 4         Y02669
         CR    R6,R15             IS IT RETCODE OF 4?            Y02669
         BE    NOPATHB            YES, NO LOGICAL PATH         @YM3369P
         LA    R15,K12            CHECK RETCODE OR 12            Y02669
         CR    R6,R15             IS IT 12? NO PATH AGAIN.       Y02669
         BE    NOPATHA            YES, NO PHYSICAL PATH        @YM3369P
         LA    R15,K8             CHECK RETCODE OR 8             Y02669
         CR    R6,R15             IS IT 8? INSUF CORE?           Y02669
         BE    INSUFCOR           YES, ABORT COMMAND             Y02669
         L     R1,XAD             DEVICE IS IN USE BY SYSTEM   @YM07231*
                                   COMPONENT                   @YM07231
*                                 GET CORE PTR TO MSG            Y02669
         LA    R1,TWENTY(R1)      INDEX TO MSG BUFFER            Y02669
         MVC   K0(COMPLN,R1),COMPMSG MOVE MESSAGE              @YM07231
         MVC   K12(K3,R1),K1(R7)  MOVE IN UNIT NAME              Y02669
         B     MESSG              GO ISSUE MSG                   Y02669
INSUFCOR EQU   *                  INSUFF CORE FOR PROCC          Y02669
         LA    R1,INSUFMSG        GET PTR TO MSG                 Y02669
         SR    R0,R0              CLEAR R0 FOR CONSOLE ID        Y02669
         TM    XAU,RI             IS THIS FROM INPUT STREAM?   @ZM30445
         BO    XAUIN2             YES, DON'T INSERT CONSOLE ID @ZM30445
         IC    R0,XAU                                            Y02669
XAUIN2   EQU   *                                               @ZM30445
         WTO   MF=(E,(1))         ISSUE MSG                      Y02669
         B     IEE36050           RETURN EXIT, ABORT COMMAND     Y02669
*                                                                Y02669
*                                                                Y02669
NOPATHA  EQU   *                                               @YM3369P
         MVC   IEE36FIL(K8),IEEPHYS    MOVE IN 'PHYSICAL'      @YM3369P
         B     NOPATH             AVOID NEXT INSTRUCTION       @YM3369P
NOPATHB  EQU   *                                               @YM3369P
         MVC   IEE36FIL(K8),IEELOGIC   MOVE IN 'LOGICAL '      @YM3369P
NOPATH   EQU   *                  NOPATHS MSG RTN                Y02669
         MVC   IEE36BUF(K3),K1(R7)     MOVE BAD UNIT INTO MSG    Y02669
*                                 BUFFER                         Y02669
ADDRMSG  EQU   *                                               @YM3411P
         LA    R1,IEE36MSG        GET ADDR OF MESSAGE FOR WTO    Y02669
MESSG    EQU   *                                                 Y02669
         SR    R0,R0              CLEAR R0 FOR CONS. ID          Y02669
         TM    XAU,RI             IS THIS FROM INPUT STREAM?   @ZM30445
         BO    XAUIN3             YES, DON'T INSERT CONSOLE ID @ZM30445
         IC    R0,XAU                                            Y02669
XAUIN3   EQU   *                                               @ZM30445
         WTO   MF=(E,(1))         WRITE NO PATHS MESSAGE         Y02669
NOUNIT   EQU   *                                               @Z30LPTJ
         LA    R15,K4             INDICATE NO PATH UNIT          Y02669
         SPACE 1
IEE36200 LM    R0,R6,K8(R8)       RESTORE REGISTER CONTENTS      Y02669
         BR    R11                 RETURN TO CALLER
UNITMSG  EQU   *                                               @YM3411P
         TM    XAAVRANG,XAARNG1   VARY RANGE BEING PROCESSED?  @Z30LPTJ
         BO    NOUNIT             YES, SKIP MESSAGE OUTPUT     @Z30LPTJ
         MVC   IEE36MSG(REFLNG),REFMSG  LOAD IEE313I MSG       @YM3411P
MOVEUNIT EQU   *                                               @Z30LPTJ
         MVC   IEE36DEV(K3),K1(R7)  MOVE BAD UNIT INTO MSG     @YM3411P
         B     ADDRMSG                                         @YM3411P
         SPACE
SS1MSG   EQU   *                                               @Z30LPTJ
         MVC   IEE36MSG(SS1LENG),SS1TEXT LOAD IEE084I MESSAGE  @Z30LPTJ
         B     MOVEUNIT            BRANCH TO LOAD UNIT VALUE   @Z30LPTJ
         EJECT
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *  Y02651
*                                                                Y02651
*  THE LIST FORM OF THE ENQ AND DEQ INSTRUCTION ISSUED IN THIS   Y02651
*  MODULE FOLLOW:                                                Y02651
*                                                                Y02651
IEFSCONA ENQ   (IEFSQCBS,IEFVQCBS,S,K7,SYSTEM),MF=L            @YM5443P
ENQBEGIN EQU *                                                 @ZA09166
IEFSCONB ENQ   (IEFSQCBS,IEFQ4QCB,E,K2,SYSTEM),MF=L,ECB=ZERO   @YM5443P
ENQEND   EQU   *                                               @YM5443P
ENQLNTH  EQU   ENQEND-ENQBEGIN                                 @ZA09166
IEFSCONC DEQ   (IEFSQCBS,IEFQ4QCB,K2,SYSTEM),RET=HAVE,MF=L     @YM5443P
IEFSCOND ENQ   (IEFSQCBS,IEFQ4QCB,E,K2,SYSTEM),MF=L            @YM5443P
IEFSOFFA ENQ   (IEFSQCBS,IEFVQCBS,E,K7,SYSTEM),MF=L            @YM5443P
IEFSOFFB ENQ   (IEFSQCBS,IEFQ4QCB,S,K2,SYSTEM),MF=L            @YM5443P
IEFSDONA ENQ   (IEFSQCBS,IEFVQCBS,E,K7,SYSTEM),MF=L            @YM5443P
IEFSDONB ENQ   (IEFSQCBS,IEFQ4QCB,S,K2,SYSTEM),MF=L            @YM5443P
IEFDEQUE DEQ   (IEFSQCBS,IEFQ4QCB,K2,SYSTEM,IEFSQCBS,IEFVQCBS,K7,      *
               SYSTEM),RET=HAVE,MF=L                           @YM5443P
IEFSQCBS DC    C'SYSIEFSD'                                       Y02651
IEFQ4QCB DC    C'Q4'                                             Y02651
IEFVQCBS DC    C'VARYDEV'                                      @YM5443P
*                                                                Y02651
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *  Y02651
         EJECT
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
*                                                             *
* CONSTANTS SECTION (READ-ONLY)                               *
*                                                             *
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
         SPACE 1
IEE36GMP DS    0F                  GETMAIN/FREEMAIN LV PARAM
         DC    X'E5'               SUBPOOL 229 INDICATOR
         DC    AL3(GETLEN)         LGTH OF GETMAIN'ED WORK AREA
WORKAREA DC    X'E5000020'         DATA AREA CORE SPECIFICATION@Z30LPTJ
*              NOTE: IF THE SIZE OF 'WORKAREA' IS CHANGED IN   @Z30LPTJ
*                    IEECB904, SUCH CHANGE MUST ALSO BE MADE   @Z30LPTJ
*                    TO 'WORKAREA' HERE.                       @Z30LPTJ
IEE36CIN DC    C'(I-'              MASK FOR COMPOSITE I-UNIT
IEE36END DC    C')'                MASK FOR END OF OPR SUBLIST
IEE36COU DC    C','                MASK FOR COMPOSITE O-UNIT
IEE36OUT DC    C'O-'               MASK FOR OUTPUT-ONLY CONSOLE
IEE3303D DC    C'IEE3303D'                                       Y02669
IEEPHYS  DC    C'PHYSICAL'         'PHYSICAL' INSERTION        @YM3369P
IEELOGIC DC    C'LOGICAL '         'LOGICAL ' INSERTION        @YM3369P
IEE36H04 DC    H'04'               TO COMPARE FOR TERM LENGTH 4
IEE36H06 DC    H'06'               TO COMPARE FOR TERM LENGTH 6
IEE36H14 DC    H'14'               TO COMPARE FOR TERM LGTH 14
IEE36INT WTO   'IEE025I UNIT DDD HAS NO LOGICAL  PATHS',MF=L,DESC=(5), *
               MCSFLAG=(REG0,RESP) NO PATHS MESSAGE FOR VARY   @YM3369P
LENG     EQU   *-IEE36INT
COMPMSG  WTO   'IEE329I     IN USE BY A SYSTEM COMPONENT',             *
               MF=L,DESC=(5),MCSFLAG=(REG0,RESP)               @YM07231
COMPLN   EQU   *-COMPMSG                                       @YM07231
INSUFMSG WTO   'IEE328I VARY     COMMAND ABORTED',MF=L,DESC=(5),       *
               MCSFLAG=(REG0,RESP)                             @ZM30436
REFMSG   WTO   'IEE313I DDD      UNIT REF INVALID',MF=L,DESC=(5),      *
               MCSFLAG=(REG0,RESP)                             @ZM30436
REFLNG   EQU   *-REFMSG                                        @YM3411P
TERMMSG  WTO   'IEE308I VARY     TERM LENGTH ERROR',MF=L,DESC=(5),     *
               MCSFLAG=(REG0,RESP)                             @Z30LPTJ
TERMLNG  EQU   *-TERMMSG                                       @Z30LPTJ
DELIMMSG WTO   'IEE307I VARY     DELIMITER ERROR',MF=L,DESC=(5),       *
               MCSFLAG=(REG0,RESP)                             @Z30LPTJ
DELIMLNG EQU   *-DELIMMSG                                      @Z30LPTJ
CONFMSG  WTO   'IEE312I VARY     PARAMETERS CONFLICT',MF=L,DESC=(5),   *
               MCSFLAG=(REG0,RESP)                             @Z30LPTJ
CONFLNG  EQU   *-CONFMSG                                       @Z30LPTJ
SS1TEXT  WTO   'IEE084I          3851 PARAMETER MISSING',MF=L,         *
               DESC=(5),MCSFLAG=(REG0,RESP)                    @Z30LPTJ
         DS    0F                                              @ZA09166
SS1LENG  EQU   *-SS1TEXT                                       @Z30LPTJ
IEE799B  EQU   *                  BEGINNING OF WTOR LIST       @ZA09166
IEE799LS WTOR  'IEE799A VARY CONSOLE DELAYED - REPLY RETRY,CANCEL,OR WA*
               IT',,6,DESC=(5),MCSFLAG=(REG0,RESP),MF=L        @ZA09166
IEE799L  EQU   *-IEE799B          LENGTH OF WTOR LIST          @ZA09166
IEE756I  WTO   'IEE756I VARY COMMAND CANCELLED BY OPERATOR',   @ZA09166*
               MF=L,DESC=(5),MCSFLAG=(REG0,RESP)               @ZA09166
         DS    0F                                                Y02669
VCON33   DC    V(IEE3303D)                                       Y02669
VCON904  DC    V(IEECB904)                                     @Z30LPTJ
LVARY    DC    X'04E5C1D9E8'                                     Y02653
VARY     DC    CL8'VARY    '                                     Y02653
         DS    0H                                                Y02669
FOUR     DC    H'4'                                              Y02669
FLINE    DC    C'FLINE'                                          Y02669
NLINE    DC    C'NLINE'
ONLINE   DC    C'ONLINE'                                       @Z30LPTJ
OFFLINE  DC    C'OFFLINE'                                      @Z30LPTJ
CONSOLE  DC    C'CONSOLE'                                      @Z30LPTJ
BLANKS   DC    CL6'      '        BLANKS TO CAPITALIZE REPLY   @ZA09166
CANCEL   DC    C'CANCEL'          REPLY OF CANCEL              @ZA09166
RETRY    DC    C'RETRY'           REPLY OF RETRY               @ZA09166
WAIT     DC    C'WAIT'            REPLY OF WAIT                @ZA09166
         DS    0D
TIMELOC  DC    C'00000500'
         SPACE 3
PATCH    DC    CL120'***IEE3603D***'                           @Z30LPTJ
         EJECT
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
*                                                             *
* DSECT TO REFERENCE GETMAIN'ED WORK/SAVE AREA                *
*                                                             *
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
         SPACE 1
IEE36WRK DSECT
         DS    18F                 REGISTER SAVE AREA
IEE36S14 DS    F                   WORD TO SAVE REGISTER 14
         DS    F                   WORD TO SAVE REGISTER 15
         DS    F                   WORD TO SAVE REGISTER 0
         DS    F                   WORD TO SAVE REGISTER 1
IEE36MSG DS    CL(LENG)            BUFFER TO BUILD NO PATHS MSG
IEE36DEV EQU   IEE36MSG+K12        LOC OF UNIT IN UNIT REF MSG @YM3411P
IEE36BUF EQU   IEE36MSG+K17        LOC OF UNIT IN NO PATHS MSG
IEE36FIL EQU   IEE36MSG+K28        LOCATION OF FILLER IN NO    @YM3369P
*                                       PATHS MESSAGE          @YM3369P
IOSAREA  DS    16F                 IOSGEN SAVE AREA            @YM3411P
ECBAREA  DS    F                   ECB POST AREA               @YM5443P
ENQMVC   EQU   *                   ENQ LIST AREA               @YM5443P
OFFSET   ENQ   (,,E,K2,SYSTEM),ECB=ZERO,MF=L ENQ LIST          @ZA09166
RPYAREA  DS    CL6                REPLY BUFFER                 @ZA09166
         DS    0F                                              @ZA09166
IEE799D  EQU   *                  AREA FOR WTOR LIST FOR       @ZA09166
IEE799   WTOR  'IEE799A VARY CONSOLE DELAYED - REPLY RETRY,CANCEL,OR WA*
               IT',,6,DESC=(5),MCSFLAG=(REG0,RESP),MF=L        @ZA09166
         DS    0D                  END OF GETMAIN'ED WORK AREA
GETLEN   EQU   *-IEE36WRK          LGTH OF GETMAIN'ED WORK AREA@Z30LPTJ
*              NOTE: IF THE SIZE OF THIS 'GETLEN' IS           @Z30LPTJ
*                    CHANGED, SUCH CHANGE MUST ALSO BE MADE    @Z30LPTJ
*                    AT THE 'SPSIZEA' LABEL IN IEECB904.       @Z30LPTJ
         EJECT
IEE36XSA DSECT
         IEEXSA
         EJECT
         CVT   DSECT=YES
         EJECT
         IECDIOCM
         EJECT
         IECDIOCX
         EJECT
CHAIN1   DSECT
         IEECHAIN
         SPACE 1
        EJECT
OUCB    DSECT
        IEFUCBOB
         END
