MSG TITLE 'IEECB911 MSG CSECT FOR IEECB910'
IEECB911 CSECT
         MODID BRANCH=NO
*/***************************************************************/
* /* START OF SPECIFICATIONS ****
*
*     MODULE NAME = IEECB911
*
*     DESCRIPTIVE NAME = DISPLAY DUMP MESSAGE CSECT
*
*****************************************************************
*     COPYRIGHT =  NONE
*
*     STATUS = NEW FOR OS/VS2 R3.7 SU33                 @G33CPHE
*
*     FUNCTION = MESSAGE CSECT FOR IEECB910
*
*       OPERATION = NONE
*
*     NOTES =
*
*       DEPENDENCIES = SYSTEM 370 COMPATABLE HARDWARE.
*                   MUST BE ASSEMBLED WITH THE CHARACTER CODE THAT THE
*                   WTO MESSAGES ARE TO APPEAR IN.
*
*       RESTRICTIONS = NONE
*
*       REGISTER CONVENTIONS = NONE
*
*       ADDITIONAL NOTES = WHERE BIT STRINGS ARE THE BASIS OF THE MSG
*                   TO BE GENERATED THE TEXT IN THIS CSECT IS IN A
*                   CONTINUOUS STRING CORRESPONDING TO THE BIT STRING.
*                   THERE IS ONE ELEMENT OF THE STRING FOR EACH BIT
*                   IN THE STRING. EACH ELEMENT CONSISTS OF A ONE BYTE
*                   LENGTH OF THE TEXT THAT FOLLOWS AND THEN THE TEXT
*                   THAT CORRESPONDS TO THE BIT. AT THE END OF THE LIST
*                   A LENGTH OF ZERO INDICATES THE END.
*                     THEN THE MSG IS BUILT BY TESTING EACH BIT AND
*                   MOVING IN THE TEXT IF IT IS ON. THEN SKIPPING TO
*                   THE NEXT TEXT AND REPEATTING THE PROCESS IF THE
*                   LENGTH IS NOT ZERO.
*
*       PACKAGING = LOAD MODULE IEECB910
*                   SYSGEN MACRO=SGIEA410 (LPA)
*
*     PATCH LABEL = PATCH AREA IN IEECB910
*
*     MODULE TYPE =
*       PROCESSOR = ASSEM
*       MODULE SIZE = 1K
*       ATTRIBUTES = REENTRANT, NOT EXECUTABLE
*
*     ENTRY POINT = NONE
*
*     EXIT-NORMAL = NONE
*
*     EXIT-ERROR = NONE
*
*     EXTERNAL REFERENCES = NONE
*
*     MACROS = WTO
*
*       SERIALIZATION = NONE
*
*     MESSAGES = IEE856I, IEE857I
*
*     ABEND CODES = NONE
*
*     CHANGE ACTIVITY = NONE 6/28/76                          @G33CPHE
*
**** END OF SPECIFICATIONS ***/
*/*A0-999999                                                 @G33CPHE*/
         EJECT
*
* THE CONTROL LINES FOR THE TWO DISPLAY DUMP MESSAGES
*
         ENTRY CNTL856
         DS    0F
         DS    3B
CNTL856  DC   AL1(E1-W1)
W1       WTO ('IEE856I 00.00.00 SYS1.DUMP STATUS',C),DESC=(5,8,9),MF=L,*
               MCSFLAG=(REG0,RESP),AREAID=Z
E1       EQU   *
         SPACE 2
         ENTRY CNTL857
         DS    0F
         DS    3B
CNTL857  DC   AL1(E2-W2)
W2       WTO ('IEE857I 00.00.00 DUMP OPTIONS',C),DESC=(5,8,9),MF=L,    *
               MCSFLAG=(REG0,RESP),AREAID=Z
E2       EQU   *
         EJECT
*
* LABEL & DATA LINE TEXT FOR MSG IEE856I (DISPLAY DUMP,STATUS)
*
         ENTRY LABEL856
LABEL856 DC    AL1(E350-T350)
T350     DC    C'SYS1.DUMP DATASETS AVAILABLE '
E350     DC    AL1(E351-T351)
T351     DC    C', AND FULL '
E351     EQU   *
         SPACE 2
         ENTRY DATA856
DATA856  DC    AL1(E352-T352)
T352     DC    C'AVAILABLE '
E352     DC    AL1(E353-T353)
T353     DC    C'FULL '
E353     DC    AL1(E354-T354)
T354     DC    C'TAPE DATASET UNIT='
E354     DC    AL1(E355-T355)
T355     DC    C'DASD DATASET SYS1.DUMP'
E355     DC    AL1(E357-T357)
T357     DC    C' *-*-*-*-- ERROR ATTEMPTING TO ALLOCATE THIS SYS1.DUMP*
                DATASET TO READ THE HEADER RECORD.--*-*-*-*'
E357     DC    AL1(E358-T358)
T358     DC    C' *-*-*-*-- ERROR. FIRST RECORD IN DATASET IS NOT A VALI
               LD DUMP HEADER RECORD.--*-*-*-*'
E358     DC    AL1(E359-T359)
T359     DC    C' *-*-*-*-- ERROR. AN ATTEMPT TO OPEN THIS DATASET RESUL
               LTED IN AN ERROR.--*-*-*-*'
E359     DC    AL1(E399-T399)
T399     DC    C' *-*-*-*-- ERROR. AN ATTEMPT TO READ THIS DATASET RESUL
               LTED IN AN ERROR.--*-*-*-*'
E399     DC    AL1(E356-T356)
T356     DC    C'  DUMP TITLE= '
E356     EQU   *
         EJECT
*
* DATA LINE TEXT FOR MSG IEE857I (DISPLAY DUMP,OPTIONS)
*
         ENTRY DUMPTYPE
DUMPTYPE DC    A(SYSATYPE)
         DC    A(SYSUTYPE)
         DC    A(SYSMTYPE)
         DC    A(SDMPTYPE)
         SPACE 2
SYSATYPE DC    AL1(L205-T205)
T205     DC    C'SYSABEND- '
L205     EQU   *
SYSUTYPE DC    AL1(L206-T206)
T206     DC    C'SYSUDUMP- '
L206     EQU   *
SYSMTYPE DC    AL1(L207-T207)
T207     DC    C'SYSMDUMP- '
L207     EQU   *
SDMPTYPE DC    AL1(L208-T208)
T208     DC    C'SDUMP- '
L208     EQU   *
*
*   OPTION MODES FOR IEE857I
*
         ENTRY OVERMODE
OVERMODE DC    AL1(L200-T200)
T200     DC    C'OVERRIDE WITH '
L200     EQU   *
         ENTRY ADDOPTS
ADDOPTS  DC    AL1(L201-T201)
T201     DC    C'ADD OPTIONS '
L201     EQU   *
         ENTRY ADDNOOPT
ADDNOOPT DC    AL1(L202-T202)
T202     DC    C'ADD NO OPTIONS'
L202     EQU   *
         ENTRY ADDPLIB
ADDPLIB  DC    AL1(L203-T203)
T203     DC    C'ADD PARMLIB OPTIONS '
L203     EQU   *
         ENTRY NODUMPS
NODUMPS  DC    AL1(L204-T204)
T204     DC    C'IGNORE DUMP REQUESTS'
L204     EQU   *
         EJECT
*
*   OPTIONS FOR SDATA BITS
*
         ENTRY NOSDATA
NOSDATA  DC    AL1(L60-T60)
T60      DC    C'NO SDATA OPTIONS'
L60      DC   AL1(0)             END OF LIST INDICATOR
         SPACE 2
         ENTRY SDATA
SDATA    DC    AL1(L1-T1)
T1       DC    C'SDATA=('
L1       DC    AL1(L2-T2)
T2       DC    C'NUC,'
L2       DC    AL1(L3-T3)
T3       DC    C'SQA,'
L3       DC    AL1(L4-T4)
T4       DC    C'LSQA,'
L4       DC    AL1(L5-T5)
T5       DC    C'SWA,'
L5       DC    AL1(L6-T6)
T6       DC    C'TRT,'
L6       DC    AL1(L7-T7)
T7       DC    C'CB,'
L7       DC    AL1(L8-T8)
T8       DC    C'ENQ,'
L8       DC    AL1(L9-T9)
T9       DC    C'DM,'
L9       DC    AL1(L10-T10)
T10      DC    C'IO,'
L10      DC    AL1(L11-T11)
T11      DC    C'ERR,'
L11      DC    AL1(0)              END OF LIST INDICATOR
         EJECT
*
*   OPTIONS FOR PDATA BITS
*
         ENTRY NOPDATA
NOPDATA  DC    AL1(L61-T61)
T61      DC    C', NO PDATA OPTIONS'
L61      DC    AL1(0)                   END OF LIST INDICATOR
         SPACE 2
         ENTRY PDATA
PDATA    DC    AL1(L51-T51)
T51      DC    C', PDATA=('
L51      DC    AL1(L52-T52)
T52      DC    C'SA,'
L52      DC    AL1(L53-T53)
T53      DC    C'SAH,'
L53      DC    AL1(L54-T54)
T54      DC    C'REGS,'
L54      DC    AL1(L55-T55)
T55      DC    C'LPA,'
L55      DC    AL1(L56-T56)
T56      DC    C'JPA,'
L56      DC    AL1(L57-T57)
T57      DC    C'PSW,'
L57      DC    AL1(L58-T58)
T58      DC    C'SPLS,'
L58      DC    AL1(0)              END OF LIST INDICATOR
         EJECT
*
*   OPTIONS FOR SYSMDUMP BITS
*
         ENTRY SMDATA
SMDATA   DC    AL1(L101-T101)
T101     DC    C'('
L101     DC    AL1(L102-T102)
T102     DC    C'NUC,'
L102     DC    AL1(L103-T103)
T103     DC    C'SQA,'
L103     DC    AL1(L104-T104)
T104     DC    C'LSQA,'
L104     DC    AL1(L105-T105)
T105     DC    C'SWA,'
L105     DC    AL1(L106-T106)
T106     DC    C'TRT,'
L106     DC    AL1(L107-T107)
T107     DC    C'RGN,'
L107     DC    AL1(L108-T108)
T108     DC    C'LPA,'
L108     DC    AL1(L109-T109)
T109     DC    C'CSA,'
L109     DC    AL1(0)              END OF LIST INDICATOR
         EJECT
*
*   OPTIONS FOR SDUMP BITS
*
         ENTRY SVCDATA
SVCDATA  DC    AL1(L151-T151)
T151     DC    C'('
L151     DC    AL1(L152-T152)
T152     DC    C'ALLPSA,'
L152     DC    AL1(L153-T153)
T153     DC    C'PSA,'
L153     DC    AL1(L154-T154)
T154     DC    C'NUC,'
L154     DC    AL1(L155-T155)
T155     DC    C'SQA,'
L155     DC    AL1(L156-T156)
T156     DC    C'LSQA,'
L156     DC    AL1(L157-T157)
T157     DC    C'RGN,'
L157     DC    AL1(L158-T158)
T158     DC    C'LPA,'
L158     DC    AL1(L159-T159)
T159     DC    C'TRT,'
L159     DC    AL1(L160-T160)
T160     DC    C'CSA,'
L160     DC    AL1(L161-T161)
T161     DC    C'SWA,'
L161     DC    AL1(L162-T162)
T162     DC    C'SUMDUMP,'
L162     DC    AL1(L163-T163)
T163     DC    C'NOSUMDUMP,'
L163     DC    AL1(L164-T164)
T164     DC    C'NOALLPSA,'
L164     DC    AL1(L165-T165)
T165     DC    C'NOSQA,'
L165     DC    AL1(L166-T166)
T166     DC    C'RESERVED,'
L166     DC    AL1(L167-T167)
T167     DC    C'RESERVED,'
L167     DC    AL1(L168-T168)
T168     DC    C'Q=YES,'
L168     DC    AL1(L169-T169)
T169     DC    C'Q=NO,'
L169     DC    AL1(0)              END OF LIST INDICATOR
         END
