IEECVETF CSECT
         TITLE 'IEECVETF LIGHT PEN-CURSOR'
*C 114500,119000,124000                                      ME  YM3894
*A 060600                                                    ME  YM3894
***********************************************************************
*                                                                     *
* STATUS       CHANGE LEVEL 0
*
* APARS FIXED --- ZA17699
*                                                                     *
* FUNCTION                                                            *
*    ANALYZE LIGHT PEN OR CURSOR INTERRUPTS AND DECIDE WHETHER IT IS A*
*    VALID DETECT.                                                    *
*                                                                     *
* ENTRY POINT  IEECVETF (CSECT NAME)
*                                                                     *
* INPUT        RELATIVE LINE AND CHARACTER (LINE1 = 0 , CHARACTER1 =0)*
*              POSITION OF LIGHT PEN OR CURSOR ON SCREEN AT TIME OF   *
*              INTERRUPT IN FIRST 2 BYTES OF DCMDSAV                  *
*                                                                     *
* OUTPUT       DCM ADDRESS OF LINE AND CHARACTER WHERE DETECT TOOK    *
*              PLACE, SCT ADDRESS OF LINE WHERE DETECT TOOK PLACE     *
*                                                                     *
* EXTERNAL REFERENCES NONE
*
* EXITS - NORMAL IEECVET8 DELETE 3
*                IEECVET9 DELETE 4
*                IEECVET4 COMMAND
*                IEECVETD MESSAGE MODULE 1
*                IEECVETE MESSAGE MODULE 2
*                IEECVETH OR P OR R OR U DEVICE-DEPENDENT IO     S21002
*                IEECVFTA  PFK RTN 1                             S21002
*       - ERROR  NONE
*
* TABLES/WORK AREAS                                                   *
*    UCM, WQE, CXSA, BASE UCM, RDCM, TDCM                             *
*
* ATTRIBUTES   REFRESHABLE, PRIVILEGED, TYPE 4 SVC
*
* NOTES        THE OPERATION OF THIS MODULE DOES NOT DEPEND UPON A
*              PARTICULAR INTERNAL REPRESENTATION OF THE EXTERNAL
*              CHARACTER SET.
*
***********************************************************************
         EJECT
***********************************************************************
**                                                                   **
*                   REG  EQUATES                                      *
**                                                                   **
***********************************************************************
REG1     EQU   1                   PARMREG
REG02    EQU   2                   REG 2                         S21002
REG3     EQU   3                   PTR TO DCM ENTRY AREA         S21002
REG4     EQU   4                   RDCM BASE REG                 S21002
POINT    EQU   6                   WORK
LINE     EQU   8                   WORK
WORK     EQU   9                   WORK
UCMBASE  EQU   10                  UCMLIST BASE
BASE     EQU   11                  PROG BASE
CXSABASE EQU   12                  XSA BASE
DCMBASE  EQU   13                  DMC BASE
RETURN   EQU   14                  RETURN REG
XCTLREG  EQU   15                  XCTL REG
X1PARM   EQU   1
X8UCME   EQU   8
XFBRANCH EQU   15
         EJECT
*****************************************************************
**                                                                   **
*                        EQUATES                                      *
**                                                                   **
*****************************************************************
ID1      EQU   C'E'                1ST CHARACTER OF CSECT ID
ID2      EQU   C'F'                2ND CHARACTER OF CSECT ID
N0       EQU   0                   NUMBER
N1       EQU   1                   NUMBER
N2       EQU   2                   NUMBER
N3       EQU   3                   NUMBER
N4       EQU   4                   NUMBER
N5       EQU   5                   NUMBER
N6       EQU   6                   NUMBER
N7       EQU   7                   NUMBER
N8       EQU   8                   NUMBER
NA       EQU   10                  CONSTANT                      S21002
N12      EQU   12                  FIELD INCREMENT               S21002
N14      EQU   14                  CONSTANT                      S21002
N15      EQU   15                  NUMBER
N16      EQU   16                  NUMBER
N24      EQU   24                  NUMBER
N27      EQU   27                  NUMBER
N32      EQU   32                  NUMBER
N38      EQU   38                  NUMBER
N54      EQU   54                  FIELD INCREMENR               S21002
N59      EQU   59                  NUMBER
N60      EQU   60                  NUMBER                      @ZA17699
N64      EQU   64                  NUMBER                    ME  YM3894
N65      EQU   65                  NUMBER
N67      EQU   67                  CHAR POSITION OF ERASE OPTION S21002
N126     EQU   126                 FIELD INCREMENT               S21002
P        EQU   C'P'                CHARACTER P
N        EQU   C'N'                CHARACTER N
R        EQU   C'R'                CHARACTER R
BLANK    EQU   C' '                BLANK
CF0      EQU   C'0'                CONSTANT
DCMFULL  EQU   54                  USED TO TURN MULTIPLE BITS ON
Z        EQU   C'Z'                INLINE MSG AREA MLWTO ID      S21002
***********************************************************************
         EJECT
***********************************************************************
**                                                                   **
*              INITIALIZE PROGRAM                                     *
**                                                                   **
***********************************************************************
         BALR  BASE,N0             DECLARE
         USING *,BASE                     BASE
         B     ICATCH              BRANCH AROUND EYECATCHER      S21003
         DC    C'   MODULE IGC5F07B, FICHE IEECVETF  ' EYECATCHERS21003
ZAPAREA  DC    12C'ZAP'   AND RESERVED FOR FIELD MODIFICATIONS   S21003
ICATCH   LR    CXSABASE,REG1       GET XSA ADDRESS               S21003
         USING CXSA,CXSABASE       DECLARE XSA
         L     UCMBASE,CSAUCM      GET UCM ENTRY POINTER
         USING UCMLIST,UCMBASE     DECLARE UCMLIST
         L     DCMBASE,UCMXB       GET DCM POINTER
         LR    REG4,DCMBASE        LOAD RDCM BASE REG            S21003
         USING DCMTSRT,REG4           ADDRESSABILITY
         L     DCMBASE,N0(DCMBASE) LOAD TDCM PT                  S21003
         USING DCMSTRT,DCMBASE    DECLARE DCM
         MVC   DCMTRACE(DCMTRLEN),DCMTRAC2 SHIFT OLD TRACE ENTRIES
         MVI   DCMTREN1,ID1        PUT CSECT ID INTO
         MVI   DCMTREN2,ID2        NEW TRACE ENTRY
         MVI   DCMUTILT,N0         CLEAR UTILITY BYTE
         EJECT
*    THIS RTN WILL CHK IF DETECT OCCURED IN OUT OF LINE DISPLAY  S21002
*                                                                S21002
         SR    WORK,WORK           CLEAR REG                     S21002
         IC    WORK,DCMDSAV        GET LINE NO. OF DETECT        S21002
* NEXT TEST MAKES SURE DETECT OCCURRED IN MSG AREA FOR DISP TST  S21002
         SR    LINE,LINE           CLEAR REG                     S21002
         LH    LINE,DCMRMSAL       LOAD NO. OF LINES ON SCREEN   S21002
         CR    WORK,LINE   COMP. DETECTED LINE NO. TO MAX. SIZE  S21002
         BH    CURSFIND            DETECT NOT IN MESSAGE AREA    S21002
         A     WORK,DCMADSEC       ADD  SSCT ADDR                S21002
         TM    N0(WORK),DCMSECCL   YES-IS IT A CONTROL LINE      S21002
         BO    OUTCTRL             YES- GO INSPECT IT            S21002
         TM    N0(WORK),DCMSECLL+DCMSECDL+DCMSECBL+DCMSECDD      S21002
         BNZ   ERROR               YES-                          S21002
         B     CURSFIND            NO--GO SEE WHERE DETECTED     S21002
GETSACB  EQU   *                                                 S21002
*    THIS RTN SEARCHES THE SACB TO FIND ONE THAT MATCHES THE TOP S21002
*    ROW LINE NUMBER OF THE SCREEN AREA NOW WORKING WITH         S21002
*                                                                S21002
         L     POINT,DCMADSDS      LOAD FIRST SACB PT            S21002
         USING DCMACB,POINT                                      S21002
*    NOTE: CHANGING LINE NUMBER MAY BE ONLY TEMPORARY            S21002
         SR    WORK,WORK           CLEAR REG                     S21002
         IC    WORK,DCMDSAV        LOAD LINE NUMBER              S21002
         LA    WORK,N1(WORK)       BUMP NO. BY 1                 S21002
         STC   WORK,DCMDSAV       TEMPORARY RESTORE              S21002
COMPLINE EQU   *                                                 S21002
         LTR   POINT,POINT         TEST FOR ZERO                 S21002
         BZ    ERROR                                             S21002
         CLC   DCMATOP(N1),DCMDSAV     TOP ROW LINE NO. OF AREA  S21002
*                                  DOES IT MATCH THE WORK AREA   S21002
         BNE   NEXTSACB           NO--GO PICK UP PT TO NEXT SACB S21002
         BCTR  WORK,N0              DECREMENT NUMBER BY 1        S21002
         STC   WORK,DCMDSAV        RESTORE NO. TO ORIGINAL VALUE S21002
         BR    RETURN              YES-RETURN TO CALLER          S21002
NEXTSACB EQU   *                                                 S21002
         L     POINT,N0(POINT)   SET PT TO NEXT SCREEN AREA CTRL S21002
         B     COMPLINE            BLOCK AND GO LOOP             S21002
         EJECT
*****************************************************************
*    THE DETECT OCCURED ON AN OUT-OF-LINE DISPLAY                S21002
*    THIS RTN CHKS FOR OUT-OF-LINE DISPLAY LINE CONTROL OPTIONS  S21002
*                                                                S21002
*****************************************************************
OUTCTRL  EQU   *                                                 S21002
         BAL   RETURN,GETSACB      GO FIND SACB                  S21002
         TM    DCMASACB,DCMAUSE    IS SACB IN USE                S21002
         BNO   ERROR               NO--                          S21002
         TM    DCMAFLG1,DCMADISP   IS A DISPLAY IN AREA          S21002
         BNO   ERROR               NO--                          S21002
         L     REG3,DCMAENTR       POINT TO ENTRY AREA           S21002
         CLI   DCMDSAV+N1,N67      DETECT ON *  OPTION           S21002
         BH    ERROR               ERROR- DETECTED ON AREA ID    S21002
         TM    DCMADFLG,DCMAHOLD+DCMADD Q. DYN DISP IN HOLD MODE S21002
         BO    DYNAMIC             YES-                          S21002
         TM    DCMADFLG,DCMADD     Q. IS IT A DYNAMIC DISPLAY    S21002
         BO    STOPMON2            YES-                          S21002
STATIC   EQU   *                   NO--CHK IF *F OR *E DETECTED  S21002
*                                                                S21002
*    SAMPLE STATIC DISPLAY OPTIONS POSITIONING:        *F    *E  S21002
         CLI   DCMDSAV+N1,N64      CHK IF *E                 ME  YM3894
         BNL   ERASEIT             YES-GO TO ERASE OPTION        S21002
         CLI   DCMDSAV+N1,N54      CHK IF *F                     S21002
         BNL   FOWARDIT            YES-GO MOVE IN PAGING COMMAND S21002
         B     ERROR               NO--ERROR--NEITHER OPTION     S21002
*                                                                S21002
*    IF DYNAMIC IN UPDATE MODE                          *F    *U S21002
*                                                                S21002
DYNAMIC  EQU   *                                                 S21002
         CLI   DCMDSAV+N1,N64      DETECT ON *U              ME  YM3894
         BNL   UPDATEIT              --MUST BE *U OPTION         S21002
         CLI   DCMDSAV+N1,N54      DETECT ON *F                  S21002
         BNL   FOWARDIT            NO--MUST BE *F OPTION         S21002
         B     ERROR               NO--NONE OF ABOVE--ERROR      S21002
*                                                                S21002
*    SAMPLE OF DYNAMIC DISPLAY OPTIONS POSITIONING:              S21002
*    IF DYNAMIC IN HOLD MODE                           *PM    *H S21002
*                                                                S21002
STOPMON2 EQU   *                                                 S21002
         CLI   DCMDSAV+N1,N64                                ME  YM3894
         BNL   HOLDIT              YES-*H OPTION                 S21002
         CLI   DCMDSAV+N1,N54      DETECT ON *PM                 S21002
         BL    ERROR               NEITHER OPTION                S21002
         LA    REG02,PTA         SET PT TO STOP TRACK COMMAND
         B     ENTCOMND                                          S21002
*                                                                S21002
UPDATEIT EQU   *                                                 S21002
         LA    REG02,KDU           SET PT TO UPDATE COMMAND      S21002
         B     ENTCOMND                                          S21002
*                                                                S21002
HOLDIT   EQU   *                                                 S21002
         LA    REG02,KDH           SET PT TO HOLD COMMAND        S21002
         B     ENTCOMND                                          S21002
*                                                                S21002
ERASEIT  EQU   *                                                 S21002
         LA    REG02,KED2          SET PT TO ERASE COMMAND       S21002
         B     ENTCOMND                                          S21002
*                                                                S21002
FOWARDIT EQU   *                                                 S21002
         LA    REG02,KDF2         SET PT TO FORWARD PAGE COMMAND S21002
*                                                                S21002
*    THIS RTN PUTS THE COMMAND POINTED TO BY POINT IN ENTRY AREA S21002
*    AND XCTLS TO THE COMMAND MODULE                             S21002
*                                                                S21002
ENTCOMND EQU   *                                                 S21002
         MVI   N0(REG3),BLANK      BLANK OUT 1ST 127 CHARACTERS  S21002
         MVC   N1(N126,REG3),N0(REG3)    OF ENTRY AREA           S21002
         MVC   N0(NA,REG3),N0(REG02) MOVE COMMAND IN ENTRY AREA  S21002
         MVC   N8(N1,REG3),DCMAID   MOVE AREA ID INTO COMMAND    S21002
         DROP  POINT                                             S21002
         B     COMMAND                                           S21002
         EJECT
*****************************************************************
*    NOT OUT OF LINE: CHECK WHERE CURSOR IS                      S21002
CURSFIND EQU   *
         SR    WORK,WORK           CLEAR REG
         IC    WORK,DCMDSAV        GET LINE NUMBER OF DETECT
         MH    WORK,DCMCORLN       GET DISPLACEMENT INTO DCM     S21003
         L     LINE,DCMASCRN       GET FIRST LINE POINTER
         AR    LINE,WORK           LINE POINTS TO DCM LINE OF DETECT
         L     WORK,DCMLSCRN       POINT TO LAST LINE         MH
         CR    LINE,WORK           DETECT IN MESSAGE AREA     MH
         BNH   MSGDET               YES, HANDLE               MH
         L     WORK,DCMAINS        POINT TO INSTRUCTION LINE
         CR    LINE,WORK           DETECT IN INSTRUCTION LINE
         BE    INSLDET             YES HANDLE
         BL    PFKEXIT             LOW, GO TO PFK1            MH
**                                                                   **
*              ERROR CHECK DETECT                                     *
**                                                                   **
ERROR    EQU   *                                              MH
         CLI   DCMIONDX,DEV2260    DEVICE A 2260              MH
         BNE   PENERROR            NO MUST BE LP - CURSOR ERR MH
         OI    DCMCMSG2,DCMMSGCR   INDICATE BAD CURSOR OP     MH
         OI    DCMIOCM1,DCMFULL    INDICATE WRITE FULL SCREEN
         L     XFBRANCH,DCMNMSG1   LOAD MESSAGE 1 ADDRESS
         L     X1PARM,DCMCXSVE     RESTORE CXSA ADDRESS
         BR    XFBRANCH            EXIT TO IEECVETD
ENTDCT   EQU   *
         CLI   DCMIONDX,DEV3277        IS THIS A 3277         MH S21003
         BE    ENT3277                  YES, SPECIAL CASE     MH S21003
         OI    DCMIOCM2,DCMIOCRD   PERFORM READ
         L     XFBRANCH,DCMIORTN   LOAD IO ROUTINE ADDRESS
         L     X1PARM,DCMCXSVE     RESTORE CXSA ADDRESS
         BR    XFBRANCH            EXIT TO IEECVET(H,P,R, OR U)
************ START OF DEVICE DEPENDANT CODE ****************  MH S21003
ENT3277  OI    DCMCOM1,DCMIOPRD        INDICATE READ          MH S21003
*                                         HAS BEEN PERFORMED  MH S21003
         L     XFBRANCH,DCMNPROC   LOAD PROC 1 ADDRESS
         L     X1PARM,DCMCXSVE     RESTORE CXSA ADDRESS
         BR    XFBRANCH            EXIT TO IEECVET1
************ END OF DEVICE DEPENDENT CODE ******************  MH S21003
         EJECT
**********************************************************************
**                                                                   **
*              INSTRUCTION LINE DETECT                                *
**                                                                   **
INSLDET  EQU   *
         TM    DCMIOUNQ,DCMINNOR   INS LINE NORMAL
         BO    NORMAL              YES   HANDLE
         TM    DCMIOUNQ,DCMINERR   ERROR MSG IN INS LINE
         BO    ERRORIN             YES HANDLE
         B     ERROR               NONE OF ABOVE ERROR
NORMAL   EQU   *
         CLI   DCMDSAV+N1,N38      DETECT OUTSIDE OF D C,K    MH  M2070
         BNL   ERROR               YES ERROR
         CLI   DCMDSAV+1,N7        DETECT BELOW ENTER
         BL    ERROR               YES ERROR
         CLI   DCMDSAV+N1,N27      DETECT IN D C,K            MH  M2070
         BH    GODCK               YES GO TO D C,K RTN
         CLI   DCMDSAV+N1,N16      DETECT IN CANCEL           MH  M2070
         BH    CANDETCT            YES HANDLE CANCEL
         B     ENTDCT              NONE OF ABOVE MUST BE ENTER
ERRORIN  EQU   *
         CLI   DCMDSAV+N1,N59      VALID DETECT
         BL    ERROR               NO ERROR
         CLI   DCMDSAV+N1,N65      DETECT IN CANCEL
         BH    CANDETCT            YES HANDLE
         B     ENTDCT              NO MUST BE ENTER
GODCK    EQU   *
         L     WORK,DCMAENTR       POINT TO ENTRY AREA
         MVI   N0(WORK),BLANK      BLANK OUT 1ST 127 CHARACTERS  S21002
         MVC   N1(N126,WORK),N0(WORK)    OF ENTRY AREA           S21002
         MVC   N0(N5,WORK),DCK     MOVE DCK INTO ENTRY AREA
         B     COMMAND             SET UP TO GO TO COMMAND RTN   S21002
         EJECT
CANDETCT EQU   *
*    THIS CANCEL IS THE RESULT OF OPERATOR PRESSING CANCEL KEY   S21002
*    IT IS NOT AN OPTION TYPE OF CANCEL                          S21002
         OI    DCMCOM1,DCMCANCL    DETECTED ON CANCEL
COMMAND  EQU   *                                                 S21002
         L     XFBRANCH,DCMNCMD1   LAOD COMMAND ROUTINE ADDRESS
         L     X1PARM,DCMCXSVE     RESTORE CXSA ADDRESS
         BR    XFBRANCH            EXIT TO IEECVET4
         SPACE 3
PENERROR EQU   *
         OI    DCMCMSG2,DCMCILLP   IND BAD L/P - CURSOR DET   MH  M2070
         L     XFBRANCH,DCMNMSG2   LOAD MESSAGE 2 ADDRESS
         L     X1PARM,DCMCXSVE     RESTORE CXSA ADDRESS
         BR    XFBRANCH            EXIT TO IEECVETE
PFKEXIT  OI    DCMIOCM3,DCMRDPFK  INDICATE PFK LINE HAS BEEN READS21003
         L     XFBRANCH,DCMNPFK1   LOAD PFK 1 ADDRESS
         L     X1PARM,DCMCXSVE     RESTORE CXSA ADDRESS
         BR    XFBRANCH            EXIT TO IEECVFTA
         EJECT
**********************************************************************
**                                                                   **
*              MESSAGE AREA DETECT                                    *
**                                                                   **
**********************************************************************
MSGDET   EQU   *                                                 S21002
         SR    POINT,POINT         CLEAR REG                     S21002
         IC    POINT,DCMDSAV        GET LINE NUMBER OF DETECT    S21002
         MH    POINT,DCMSCTCN       GET DISPLACEMENT INTO SCT    S21002
         A     POINT,DCMAMTAB       GET FIRST LINE POINTER       S21002
         TM    N1(POINT),DCMMSGCL  IS THIS CONTROL LINE OF MLWTO S21002
         BNO   NOMLWTO             NO--                          S21002
         CLI   DCMDSAV+N1,N67      DETECT ON *C OPTION           S21002
         BH    ERROR               ERROR- DETECTED ON AREA ID    S21002
*  THIS RTN WILL VERIFY LP DETECT ON *C OPTION OF IN-LINE MLWTO  S21002
         CLI   DCMDSAV+N1,N65      DETECT ON *C OPTION           S21002
         BL    NOMLWTO             NO--HANDLE AS ORDINARY DELETE S21002
*                                  YES-MOVE MLWTO CANCEL COMMAND S21002
LINEDETC EQU   *                                                 S21002
         SR    WORK,WORK           CLEAR REG                     S21002
         IC    WORK,DCMDSAV        LOAD LINE NO. OF DETECT       S21002
         MH    WORK,DCMCORLN       GET DISPLACEMENT INTO DCM     S21003
         A     WORK,DCMASCRN       ADD-PT TO FIRST LINE          S21002
         LA    WORK,N60(WORK)    WORK POINTS TO LINE DETECTED  @ZA17699
         LA    LINE,N60            SET UP LOOP CONTROL REG     @ZA17699
FINDIT   EQU   *                                                 S21002
         CLI   N0(WORK),BLANK      IS AREA ID FOUND IN CTRL LINE S21002
         BNE   MOVEID              YES-GO GET IT                 S21002
         BCTR  WORK,N0             DECR. POINTER                 S21002
         BCT   LINE,FINDIT         NO--DECREMENT PT AND LOOP     S21002
MOVEID   EQU   *                                                 S21002
         SH    WORK,TWO            MOVE PT TO START OF ID        S21002
         LR    LINE,WORK           SWITCH REGS                   S21002
         L     WORK,DCMAENTR       LOAD ENTRY ADDR               S21002
         MVI   N0(WORK),BLANK      BLANK OUT 1ST 127 CHARACTERS  S21002
         MVC   N1(N126,WORK),N0(WORK)    OF ENTRY AREA           S21002
         MVC   N0(N14,WORK),KCD    MOVE CANCEL INTO ENTRY AREA   S21002
         MVC   N6(N3,WORK),N0(LINE) MOVE INTO MSG AREA ID        S21002
         MVI   N12(WORK),Z    MOVE AREA ID INTO COMMAND          S21002
         B     COMMAND                                           S21002
*                                                                S21002
NOMLWTO  EQU   *                                                 S21002
         TM    N0(POINT),DCMMSGIN  IS THERE A MESSAGE IN THE LINE
         BNO   ERROR               NO ERROR
         TM    N1(POINT),DCMMSGAC     ACTION MESSAGE
         BNO   DELEXIT             NO GO TO DELETE
         OI    DCMUTILT,DCMUTILA   TURN ON WTOR BIT
         CLI   DCMDSAV+N1,N3       IS DETECT UNDER ASTERISK
         BE    DELEXIT             YES DELETE
         TM    N0(POINT),DCMMSGRD  IS IT MARKED FOR DELETION
         BO    DEL4EXIT            YES MUST BE VERIFICATION
         B     ERROR               NO ERROR
DELEXIT  EQU   *
         CLI   DCMRQDEL,BLANK      DELETE REQUEST PENDING
         BE    SKIP                NO DONT VERIFY
         SR    WORK,WORK           CLEAR REG
         IC    WORK,DCMDSAV        GET LINE POINTER
         LA    WORK,N1(WORK)       UP BY ONE
         TM    N0(POINT),DCMMSGCN  IS MESSAGE LINE CONTINUED
         BNO   NOTCONT             NO DONT UP POINTER
         LA    WORK,N1(WORK)       UP TO NEXT LINE
NOTCONT  EQU   *
         CVD   WORK,DCMPACK        UNPACK IT
         UNPK  DCMCVBIN+N2(N2),DCMCVBIN+N2(N2) UNPACK TO EBCDIC
         OI    DCMCVBIN+N3,CF0     CONVERT SIGN TO EBCDIC
         CLI   DCMCVBIN+N2,CF0     IS FIRST NUMBER ZERO
         BNE   NUMOK               NO DONY SHIFT IT
         MVC   DCMCVBIN+N2(N1),DCMCVBIN+N3 MOVE NUMBER ONE LEFT
         MVI   DCMCVBIN+N3,BLANK   BLANK LAST POSITION
NUMOK    EQU   *
         TM    DCMUTILT,DCMUTILA    WAS DETECT ON A WTOR
         BO    WTORCOMP            YES HANDLE
         MVC   DCMCVBIN(N2),ONECOMMA MOVE IN DELETE PREFIX
         CLC   DCMRQDEL+N2(N4),DCMCVBIN VERIFY DELETE REQUEST
         BE    DEL4EXIT            YES EXIT
         B     SKIP                NO REGULAR DELETE
WTORCOMP EQU   *
         CLC   DCMRQDEL+N2(N2),DCMCVBIN+N2 VERIF DELETE REQUEST
         BE    DEL4EXIT                 YES EXUT
SKIP     EQU   *
         ST    LINE,DCMDSAV+N4     SAVE LINE ADDRESS
         ST    POINT,DCMDSAV+N8    SAVE SCT ADDRESS
         OI    DCMCOM1,DCMCOMRD    PERFORM DELETE
         CLI   DCMCON,N            IS CON EQ N
         BNE   DONTURN             NO DONT TURN O BIT
         OI    DCMCOM1,DCMLPENT    INDICATE LIGHT PEN ENTER
DONTURN  EQU   *
         L     XFBRANCH,DCMNDEL3   LOAD DELETE 3 ADDRESS
         L     X1PARM,DCMCXSVE     RESTORE CXSA ADDRESS
         BR    XFBRANCH            EXIT TO IEECVET8
DEL4EXIT EQU   *
         L     XFBRANCH,DCMNDEL4   LOAD DELETE 4 ADDRESS
         L     X1PARM,DCMCXSVE     RESTORE CXSA ADDRESS
         BR    XFBRANCH            EXIT TO IEECVET9
         EJECT
***********************************************************************
TWO      DC    H'2'                CONSTANT                      S21003
ONECOMMA DC    C'1,'               CONSTANT                      S21003
DCK      DC    C'D C,K'            COMPARE FOR DCK DETECT
KCD      DC    C'K C,D,   ,L=  '   CANCEL COMMAND                S21002
PTA      DC    C'PT  A,L=  '       STOP TRACK COMMAND         MB Y02958
KDU      DC    C'K D,U,L=  '       UPDATE COMMAND                S21002
KDH      DC    C'K D,H,L=  '       HOLD COMMAND                  S21002
KED2     DC    C'K E,D,L=  '       ERASE COMMAND                 S21002
KDF2     DC    C'K D,F,L=  '       FORWARD PAGE COMMAND          S21002
         SPACE 2
DEV2260  EQU   X'0C'               I/O ROUTINE INDEX FOR 2260
DEV3277  EQU   X'10'               I/O ROUTINE INDEX FOR 3277
***********************************************************************
         EJECT
***********************************************************************
         IHACTM  CXSA
         EJECT
         IEERDCM
         EJECT
         IEETDCM
         EJECT
         IEECUCM  FORMAT=NEW
         END
