         TITLE 'IEEMB820 - SMF INITIALIZATION ROUTER                 '
IEEMB820 CSECT ,                                                01.0001
@MAINENT DS    0H                                               01.0001
         USING *,@15                                            01.0001
         B     @PROLOG                                          01.0001
         DC    AL1(16)                                          01.0001
         DC    C'IEEMB820  73.079'                              01.0001
         DROP  @15
@PROLOG  STM   @14,@12,12(@13)                                  01.0001
         BALR  @12,0                                            01.0001
@PSTART  DS    0H                                               01.0001
         USING @PSTART,@12                                      01.0001
         L     @00,@SIZDATD                                     01.0001
         GETMAIN R,LV=(0)
         LR    @11,@01                                          01.0001
         USING @DATD,@11                                        01.0001
         ST    @13,@SA00001+4                                   01.0001
         LM    @00,@01,20(@13)                                  01.0001
         ST    @11,8(,@13)                                      01.0001
         LR    @13,@11                                          01.0001
         MVC   @PC00001(4),0(@01)                               01.0001
*PARMP=R1;                             /* GET PARMLIST POINTER       */
         LR    PARMP,R1                                         01.0025
*RFY R1 UNRSTD;                        /* RELEASE REGISTER CONTROL   */
*STAE='0'B;                            /* ASSUME STAE SET UP OK      */
         NI    STAE,B'01111111'                                 01.0027
*/********************************************************************/
*/*                                                                  */
*/*SEGMENT NAME= INITPREP                                            */
*/*                                                                  */
*/*DESCRIPTIVE NAME= SMCA/STAE CREATION PROCESSING                   */
*/*                                                                  */
*/*FUNCTION=                                                         */
*/*  GENERALLY, THIS SEGMENT PERFORMS INITIALIZATION FUNCTIONS FOR   */
*/*  SMF INITIALIZATION.                                             */
*/*                                                                  */
*/*  INITPREP PEFFORMS THE FOLLOWING FUNCTIONS:                      */
*/*                                                                  */
*/*  .  SMCA INITIALIZATION                                          */
*/*     CORE FOR SMCA IS OBTAINED IN SQA - SUBPOOL 245, ALL          */
*/*     FIELDS IN SMCA ARE INITIALIZED TO ZERO AND                   */
*/*     THE CVT IS INITIALIZED TO POINT TO SMCA.                     */
*/*                                                                  */
*/*  .  STAE ENVIRONMENT INITIALIZATION                              */
*/*     A STAE PARAMETER AREA IS INITIALIZED, INDICATING             */
*/*     THAT STAE IS SET UP FOR INITIALIZATION. THE ESTAE MACRO      */
*/*     IS ISSUED TO CREATE A STAE ENVIRONMENT. IF A NON ZERO RETURN */
*/*     CODE IS RETURNED BY STAE, AN ERROR MESSAGE WILL BE ISSUED    */
*/*     AND SMF INITIALIZATION TERMINATED.                           */
*/*                                                                  */
*/*  OPERATION= NO SPECIAL ALGORITHMS ARE USED.                      */
*/*                                                                  */
*/*ENTRY= IN-LINE SEGMENT                                            */
*/*  PURPOSE= SEE FUNCTION                                           */
*/*  INPUT= CVT                                                      */
*/*                                                                  */
*/*EXITS=                                                            */
*/*  CONDITION= STAE SUCCESSFULLY CREATED                            */
*/*  OUTPUT=                                                         */
*/*    SMCA WITH ALL FIELDS ZEROED                                   */
*/*    CVT INITIALIZED TO POINT TO SMCA                              */
*/*    STAE ENVIRONMENT CREATED                                      */
*/*  RETURN CODES= NONE                                              */
*/*                                                                  */
*/*  CONDITION= STAE NOT SUCCESSFULLY CREATED                        */
*/*  OUPUT=                                                          */
*/*    SMCA WITH ALL FIELDS INITIALIZED TO ZERO                      */
*/*    CVT POINTING TO SMCA                                          */
*/*    STAE BIT SET ON INDICATING STAE FAILURE                       */
*/*  RETURN CODES= NONE                                              */
*/*                                                                  */
*/********************************************************************/
*RFY (R1) RSTD;                        /* RESERVE REGISTER           */
*R1 = LENGTH(SMCABASE);                /* GET LENGTH OF SMCA BLOCK   */
         LA    R1,180                                           02.0029
*GEN(GETMAIN R,SP=245,LV=(R1));        /* GET CORE FOR SMCA          */
         GETMAIN R,SP=245,LV=(R1)
*R1->SMCABASE=R1->SMCABASE&&R1->SMCABASE;/* SET ALL OF SMCA TO ZEROS */
         XC    SMCABASE(180,R1),SMCABASE(R1)                    02.0031
*R1->SMCAJWT=DEFLTJWT;                 /* SET DEFAULT JOB WAIT TIME  */
         MVC   SMCAJWT(4,R1),DEFLTJWT                           02.0032
*CVTSMCA=R1;                           /* POINT CVT TO SMCA          */
         L     @10,CVTPTR                                       02.0033
         ST    R1,CVTSMCA(,@10)                                 02.0033
*STAEFOR='1'B;                         /* INDICATE STAE IS FOR SMF
*                                         INITIALIZATION             */
         OI    STAEFOR,B'10000000'                              02.0034
*STAELST(1:STAELEN)=DYMSTAE(1:STAELEN);     /* INIT STAE LIST FORM   */
         LH    @10,STAELEN                                      02.0035
         BCTR  @10,0                                            02.0035
         EX    @10,@SM01099                                     02.0035
*RFY (R2,R3) RSTD;                     /* GET REGISTER CONTROL       */
*R2=ADDR(IEEMB825);                    /* ADDR OF STAE EXIT ROUTINE  */
         L     R2,@CV00061                                      02.0037
*R3=ADDR(STAEPARM);                    /* PARAM LIST FOR STAE EXIT   */
         LA    R3,STAEPARM                                      02.0038
*GEN(ESTAE (R2),,PARAM=(R3),PURGE=NONE,ASYNCH=YES,MF=(E,STAELST));
         ESTAE (R2),,PARAM=(R3),PURGE=NONE,ASYNCH=YES,MF=(E,STAELST)
*RFY (R2,R3) UNRSTD;                   /* RELEASE REGISTER CONTROL   */
*RFY STAERTCD RSTD;                    /* GET REGISTER CONTROL       */
*IF STAERTCD^=0 THEN                   /* STAE SET UP SUCCESSFULLY   */
         LTR   STAERTCD,STAERTCD                                02.0042
         BZ    @RF00042                                         02.0042
*  DO;                                 /* NO, ISSUE ERROR MESSAGE    */
*    STAE='1'B;                        /* INDICATE STAE FAILURE      */
         OI    STAE,B'10000000'                                 02.0044
*    R1=ADDR(I480I);                   /* GET ADDR OF ERROR MESSAGE  */
         L     R1,@CV00063                                      02.0045
*    GEN(WTO   MF=(E,(R1)));           /* ISSUE ERROR MESSAGE        */
         WTO   MF=(E,(R1))
*  END;                                                         02.0047
*RFY STAERTCD UNRSTD;                  /* RELEASE REGISTER CONTROL   */
@RF00042 DS    0H                                               02.0049
*SMCAFIRT='1'B;                        /* INDICATE INIT IN PROGRESS  */
         L     @10,CVTPTR                                       02.0049
         L     @05,CVTSMCA(,@10)                                02.0049
         OI    SMCAFIRT(@05),B'00010000'                        02.0049
*RFY (R1) UNRSTD;                      /* RELEASE REGISTER CONTROL   */
*IF STAE='0'B THEN                     /* IS STAE SET UP SUCCESSFUL  */
         TM    STAE,B'10000000'                                 01.0051
         BNZ   @RF00051                                         01.0051
*  DO;                                 /* YES, CONTINUE WITH INIT    */
*    IF MSSMFPRM=0 THEN                /* PARMLIB NAME SPEC AT IPL   */
         L     @10,CVTMSER(,@10)                                01.0053
         ICM   @05,15,MSSMFPRM(@10)                             01.0053
         BNZ   @RF00053                                         01.0053
*      PARMMEM='SMFPRM00';             /* NO, USE DEFALUT NAME       */
         MVC   PARMMEM(8),@CC01092                              01.0054
*    ELSE                              /* PARMLIB NAME SPEC AT IPL   */
*      DO;                                                      01.0055
         B     @RC00053                                         01.0055
@RF00053 DS    0H                                               01.0056
*        PARMMEM=SMFPRMXX;             /* GET MEMBER NAME FOR SMF    */
         L     @10,CVTPTR                                       01.0056
         L     @10,CVTMSER(,@10)                                01.0056
         L     @10,MSSMFPRM(,@10)                               01.0056
         MVC   PARMMEM(8),SMFPRMXX(@10)                         01.0056
*        RFY (R2,R3) RSTD;             /* GET RGISTER CONTROL        */
*        R3=MSSMFPRM;                  /* ADDRESS OF PARM AREA       */
         LR    R3,@10                                           01.0058
*        R2=SMFPRMLN;                  /* LENGTH OF AREA             */
         LH    R2,SMFPRMLN(,@10)                                01.0059
*        GEN(FREEMAIN R,SP=245,A=(R3),LV=(R2)); /* FREE AREA         */
         FREEMAIN R,SP=245,A=(R3),LV=(R2)
*        RFY (R2,R3) UNRSTD;           /* RELEASE REGISTER CONTROL   */
*      END;                                                     01.0062
*    CALL IEEMB821(PARMMEM,JWTMIN,ADDR(SMCABASE)); /* PROCESS PARMS  */
@RC00053 LA    @10,PARMMEM                                      01.0063
         ST    @10,@AL00001                                     01.0063
         LA    @10,JWTMIN                                       01.0063
         ST    @10,@AL00001+4                                   01.0063
         L     @10,CVTPTR                                       01.0063
         LA    @10,CVTSMCA(,@10)                                01.0063
         ST    @10,@AL00001+8                                   01.0063
         L     @15,@CV01093                                     01.0063
         LA    @01,@AL00001                                     01.0063
         BALR  @14,@15                                          01.0063
*    IF SMCAMAN='1'B THEN              /* RECORDING TO BE PERFORMED  */
         L     @10,CVTPTR                                       01.0064
         L     @05,CVTSMCA(,@10)                                01.0064
         TM    SMCAMAN(@05),B'01000000'                         01.0064
         BNO   @RF00064                                         01.0064
*      DO;                             /* YES,PREPARE FOR OPENS      */
*        CALL IEEMB822(ADDR(SMCABASE),WTRTCBPT,WTRECBPT);       01.0066
         LA    @10,CVTSMCA(,@10)                                01.0066
         ST    @10,@AL00001                                     01.0066
         ST    PARMP,@AL00001+4                                 01.0066
         LA    @10,WTRECBPT(,PARMP)                             01.0066
         ST    @10,@AL00001+8                                   01.0066
         L     @15,@CV01094                                     01.0066
         LA    @01,@AL00001                                     01.0066
         BALR  @14,@15                                          01.0066
*        IF SMCAMAN='1'B THEN          /* ANY ERRORS IN OPEN INIT    */
         L     @10,CVTPTR                                       01.0067
         L     @10,CVTSMCA(,@10)                                01.0067
         TM    SMCAMAN(@10),B'01000000'                         01.0067
         BNO   @RF00067                                         01.0067
*          DO;                         /* NO, WRITE SMF IPL RECORDS  */
*            SMCAFIRT='0'B;            /* INIT CAN RECORD NOW        */
         NI    SMCAFIRT(@10),B'11101111'                        01.0069
*            CALL IEEMB823(JWTMIN,CVTPTR);                      01.0070
         LA    @10,JWTMIN                                       01.0070
         ST    @10,@AL00001                                     01.0070
         LA    @10,CVTPTR                                       01.0070
         ST    @10,@AL00001+4                                   01.0070
         L     @15,@CV01095                                     01.0070
         LA    @01,@AL00001                                     01.0070
         BALR  @14,@15                                          01.0070
*          END;                                                 01.0071
*      END;                                                     01.0072
@RF00067 DS    0H                                               01.0073
*  END;                                                         01.0073
@RF00064 DS    0H                                               01.0074
*IF SMCAMAN='0'B THEN                  /* RECORDING TO BE PERFORMED  */
@RF00051 L     @10,CVTPTR                                       01.0074
         L     @10,CVTSMCA(,@10)                                01.0074
         TM    SMCAMAN(@10),B'01000000'                         01.0074
         BNZ   @RF00074                                         01.0074
*  DO;                                 /* NO, WRITE ^RECORDING MSG   */
*    RFY (R1) RSTD;                    /* GET REGISTER CONTROL       */
*    R1=ADDR(I351I);                   /* ADDR OF MESSAGE            */
         L     R1,@CV00062                                      01.0077
*    GEN(WTO   MF=(E,(R1)));           /* WRITE MESSAGE              */
         WTO   MF=(E,(R1))
*    RFY (R1) UNRSTD;                  /* RELEASE REGISTER CONTROL   */
*  END;                                                         01.0080
*SMCAFIRT='0'B;                        /* INIT COMPLETE PROCESSING   */
@RF00074 L     @10,CVTPTR                                       01.0081
         L     @10,CVTSMCA(,@10)                                01.0081
         NI    SMCAFIRT(@10),B'11101111'                        01.0081
*RETURN;                                                        01.0082
@EL00001 L     @13,4(,@13)                                      01.0082
@EF00001 L     @00,@SIZDATD                                     01.0082
         LR    @01,@11                                          01.0082
         FREEMAIN R,LV=(0),A=(1)
@ER00001 LM    @14,@12,12(@13)                                  01.0082
         BR    @14                                              01.0082
*END IEEMB820                                                   01.0083
*/* THE FOLLOWING INCLUDE STATEMENTS WERE FOUND IN THIS PROGRAM.      *
*/*%INCLUDE SYSLIB  (B820SPEC)                                        *
*/*%INCLUDE SYSLIB  (B820DATA)                                        *
*/*%INCLUDE SYSLIB  (CVT     )                                        *
*/*%INCLUDE SYSLIB  (IEEBASEA)                                        *
*/*%INCLUDE SYSLIB  (IEESMCA )                                        *
*/*%INCLUDE SYSLIB  (INITPREP)                                        *
*/*%INCLUDE SYSLIB  (INITPRES)                                        *
*;                                                              01.0083
         B     @EL00001                                         01.0083
@DATA    DS    0H
@SM01099 MVC   STAELST(0),DYMSTAE
@DATD    DSECT
         DS    0F
@SA00001 DS    18F
@PC00001 DS    1F
@AL00001 DS    3A
IEEMB820 CSECT
         DS    0F
@DATD    DSECT
         DS    0D
JWTMIN   DS    F
DMYPARM  DS    A
PARMMEM  DS    CL8
STAEPARM DS    CL124
         ORG   STAEPARM
STAESWCS DS    BL1
         ORG   STAESWCS
STAEFOR  DS    BL1
@NM00003 EQU   STAESWCS+0
         ORG   STAEPARM+1
@NM00004 DS    CL3
STAEWKAR DS    CL120
         ORG   STAEPARM+124
STAE     DS    BL1
IEEMB820 CSECT
         DS    0F
@SIZDATD DC    AL1(0)
         DC    AL3(@ENDDATD-@DATD)
@CV00061 DC    V(IEEMB825)
@CV00062 DC    V(IEE351I)
@CV00063 DC    V(IEE480I)
@CV01093 DC    V(IEEMB821)
@CV01094 DC    V(IEEMB822)
@CV01095 DC    V(IEEMB823)
         DS    0D
@CC01092 DC    C'SMFPRM00'
DEFLTJWT DC    X'7FFFFFFF'
@DATD    DSECT
STAELST  ESTAE ,CT,PURGE=NONE,ASYNCH=YES,RECORD=YES,MF=L
IEEMB820 CSECT
DYMSTAE  ESTAE ,CT,PURGE=NONE,ASYNCH=YES,RECORD=YES,MF=L
STAELEN  DC    AL2(*-DYMSTAE)          LENTH OF STAE LIST FORM
@DATD    DSECT
@ENDDATD EQU   *
IEEMB820 CSECT
@00      EQU   00                      EQUATES FOR REGISTERS 0-15
@01      EQU   01
@02      EQU   02
@03      EQU   03
@04      EQU   04
@05      EQU   05
@06      EQU   06
@07      EQU   07
@08      EQU   08
@09      EQU   09
@10      EQU   10
@11      EQU   11
@12      EQU   12
@13      EQU   13
@14      EQU   14
@15      EQU   15
PARMP    EQU   @04
R1       EQU   @01
R2       EQU   @02
R3       EQU   @03
STAERTCD EQU   @15
R0       EQU   @00
CVTPTR   EQU   16
PARMLIST EQU   0
WTRTCBPT EQU   PARMLIST
WTRECBPT EQU   PARMLIST+4
@NM00001 EQU   0
SMFPRMLN EQU   @NM00001
SMFPRMXX EQU   @NM00001+4
I351I    EQU   0
I480I    EQU   0
CVTMAP   EQU   0
CVTDAR   EQU   CVTMAP+72
CVTFLGS1 EQU   CVTDAR
CVTDCB   EQU   CVTMAP+116
CVTMSER  EQU   CVTMAP+148
CVTOPTA  EQU   CVTMAP+182
CVTOPTB  EQU   CVTMAP+183
CVTSMCA  EQU   CVTMAP+196
CVTTSCVT EQU   CVTMAP+228
CVTTSFLG EQU   CVTTSCVT
CVTGTF   EQU   CVTMAP+236
CVTGTFST EQU   CVTGTF
CVTGTFS  EQU   CVTGTFST
CVTSTATE EQU   CVTGTFST
CVTTMODE EQU   CVTGTFST
CVTFORM  EQU   CVTGTFST
CVTUSR   EQU   CVTGTFST
CVTAQAVT EQU   CVTMAP+240
CVTTCMFG EQU   CVTAQAVT
CVTTATA  EQU   CVTMAP+244
CVTATER  EQU   CVTMAP+248
CVTEXT1  EQU   CVTMAP+252
CVTPURG  EQU   CVTMAP+260
CVTQMSG  EQU   CVTMAP+268
CVTDMSR  EQU   CVTMAP+272
CVTAPF   EQU   CVTMAP+324
CVTEXT2  EQU   CVTMAP+328
CVTHJES  EQU   CVTMAP+332
CVTPGSIA EQU   CVTMAP+348
CVTA1F1  EQU   CVTMAP+356
CVTSYSK  EQU   CVTMAP+357
CVTATMCT EQU   CVTMAP+388
CVTXTNT1 EQU   0
CVTXTNT2 EQU   0
CVTDSSV  EQU   CVTXTNT2
CVTRSV90 EQU   CVTXTNT2+5
CVTQID   EQU   CVTXTNT2+24
CVTRV400 EQU   CVTXTNT2+52
CVTRV409 EQU   CVTXTNT2+53
CVTATCVT EQU   CVTXTNT2+64
CVTRV429 EQU   CVTXTNT2+84
CVTRV438 EQU   CVTXTNT2+85
CVTRV457 EQU   CVTXTNT2+112
CVTRV466 EQU   CVTXTNT2+113
CVTFIX   EQU   0
CVTRELNO EQU   CVTFIX+252
BASE     EQU   0
@NM00007 EQU   BASE+13
BALGSTAT EQU   BASE+24
BALOG    EQU   BALGSTAT+4
BASFL    EQU   BASE+36
BARSW    EQU   BASFL
MSLOGST  EQU   BASE+46
BASPBYTE EQU   BASE+47
BAMONITR EQU   BASE+56
MSSMFPRM EQU   BASE+96
@NM00031 EQU   BASE+104
MSLGCLOZ EQU   BASE+108
MSCLOSSW EQU   MSLGCLOZ
MSLGWLOG EQU   BASE+112
MSWLOGSW EQU   MSLGWLOG
MSLGWTR  EQU   BASE+116
MSWTRSW  EQU   MSLGWTR
MSLGSTRT EQU   BASE+120
MSSTRTSW EQU   MSLGSTRT
MS1BASEX EQU   BASE+136
BASES01  EQU   0
MSNTAL   EQU   BASES01
MSSSB    EQU   BASES01+1
MSBTN    EQU   MSSSB
MSPFG    EQU   BASES01+2
MSECBFL  EQU   BASES01+3
MSTUS    EQU   BASES01+4
MSSSA    EQU   MSTUS
MSINLSW  EQU   MSSSA
MSREOF   EQU   MSSSA
MSNWP    EQU   MSSSA
MSFHF    EQU   BASES01+5
SMCABASE EQU   0
SMCAOPT  EQU   SMCABASE
SMCAMISC EQU   SMCABASE+1
SMCAMAN  EQU   SMCAMISC
SMCAFIRT EQU   SMCAMISC
SMCAJWT  EQU   SMCABASE+8
SMCABUF  EQU   SMCABASE+12
SMCAPSTA EQU   SMCABASE+30
SMCAPLBL EQU   SMCABASE+34
SMCASTA  EQU   SMCABASE+46
SMCAALBL EQU   SMCABASE+50
SMCAENTY EQU   SMCABASE+80
SMCAENDI EQU   SMCAENTY
SMCAFOPT EQU   SMCABASE+82
SMCASWA  EQU   SMCABASE+104
SMCAASCB EQU   SMCABASE+120
DYMPARM  EQU   0
CVTS01   EQU   CVTPGSIA
CVTLPDIA EQU   CVTS01+12
CVTDIRST EQU   CVTLPDIA
CVTSLIDA EQU   CVTS01+24
CVTCTLFG EQU   CVTS01+50
CVTRV100 EQU   CVTS01+116
CVTRV109 EQU   CVTS01+117
CVTRV118 EQU   CVTS01+118
CVTRV127 EQU   CVTS01+119
CVTRV157 EQU   CVTS01+376
CVTRV166 EQU   CVTS01+377
CVTRV175 EQU   CVTS01+378
CVTRV184 EQU   CVTS01+379
CVTRV210 EQU   CVTS01+424
CVTRV219 EQU   CVTS01+425
CVTRV228 EQU   CVTS01+426
CVTRV237 EQU   CVTS01+427
CVTMFRTR EQU   CVTS01+452
CVTRV262 EQU   CVTS01+468
CVTRV271 EQU   CVTS01+469
CVTRV280 EQU   CVTS01+470
CVTRV289 EQU   CVTS01+471
         AGO   .@UNREFD                START UNREFERENCED COMPONENTS
CVTRV512 EQU   CVTS01+608
CVTRV511 EQU   CVTS01+604
CVTRV510 EQU   CVTS01+600
CVTRV509 EQU   CVTS01+596
CVTRV508 EQU   CVTS01+592
CVTRV507 EQU   CVTS01+588
CVTRV506 EQU   CVTS01+584
CVTRV505 EQU   CVTS01+580
CVTCSDRL EQU   CVTS01+576
CVTEXP1  EQU   CVTS01+572
CVTRMPMT EQU   CVTS01+568
CVTRMPTT EQU   CVTS01+564
CVTVPSA  EQU   CVTS01+560
CVTVSTOP EQU   CVTS01+556
CVTVALST EQU   CVTS01+552
CVTVTCH  EQU   CVTS01+548
CVTVWKUP EQU   CVTS01+544
CVTWTCB  EQU   CVTS01+540
CVTSTPRS EQU   CVTS01+536
CVT0PT02 EQU   CVTS01+532
CVTDARCM EQU   CVTS01+528
CVTIRECM EQU   CVTS01+524
CVTJRECM EQU   CVTS01+520
CVTVEMS0 EQU   CVTS01+516
CVTSPFRR EQU   CVTS01+512
CVTRLSTG EQU   CVTS01+508
CVT0TC0A EQU   CVTS01+504
CVTGMBR  EQU   CVTS01+500
CVTLFRM  EQU   CVTS01+496
CVTRMBR  EQU   CVTS01+492
CVTVIOP  EQU   CVTS01+488
CVTRV307 EQU   CVTS01+486
CVTRV306 EQU   CVTS01+484
CVTRV305 EQU   CVTS01+482
CVTRV304 EQU   CVTS01+480
CVTRV303 EQU   CVTS01+478
CVTRV302 EQU   CVTS01+476
CVTRV301 EQU   CVTS01+475
CVTRV300 EQU   CVTS01+474
CVTRV299 EQU   CVTS01+473
CVTRV298 EQU   CVTS01+472
CVTRV297 EQU   CVTRV289
CVTRV296 EQU   CVTRV289
CVTRV295 EQU   CVTRV289
CVTRV294 EQU   CVTRV289
CVTRV293 EQU   CVTRV289
CVTRV292 EQU   CVTRV289
CVTRV291 EQU   CVTRV289
CVTRV290 EQU   CVTRV289
CVTRV288 EQU   CVTRV280
CVTRV287 EQU   CVTRV280
CVTRV286 EQU   CVTRV280
CVTRV285 EQU   CVTRV280
CVTRV284 EQU   CVTRV280
CVTRV283 EQU   CVTRV280
CVTRV282 EQU   CVTRV280
CVTRV281 EQU   CVTRV280
CVTRV279 EQU   CVTRV271
CVTRV278 EQU   CVTRV271
CVTRV277 EQU   CVTRV271
CVTRV276 EQU   CVTRV271
CVTRV275 EQU   CVTRV271
CVTRV274 EQU   CVTRV271
CVTRV273 EQU   CVTRV271
CVTRV272 EQU   CVTRV271
CVTRV270 EQU   CVTRV262
CVTRV269 EQU   CVTRV262
CVTRV268 EQU   CVTRV262
CVTRV267 EQU   CVTRV262
CVTRV266 EQU   CVTRV262
CVTRV265 EQU   CVTRV262
CVTRV264 EQU   CVTRV262
CVTRV263 EQU   CVTRV262
CVTVFP   EQU   CVTS01+464
CVTVSI   EQU   CVTS01+460
CVTVPSIB EQU   CVTS01+456
CVTMFACT EQU   CVTMFRTR
CVTMFCTL EQU   CVTS01+448
CVTPVBP  EQU   CVTS01+444
CVTPWI   EQU   CVTS01+440
CVTRV254 EQU   CVTS01+438
CVTRV253 EQU   CVTS01+436
CVTRV252 EQU   CVTS01+434
CVTRV251 EQU   CVTS01+433
CVTRV250 EQU   CVTS01+432
CVTRV249 EQU   CVTS01+431
CVTRV248 EQU   CVTS01+430
CVTRV247 EQU   CVTS01+429
CVTRV246 EQU   CVTS01+428
CVTRV245 EQU   CVTRV237
CVTRV244 EQU   CVTRV237
CVTRV243 EQU   CVTRV237
CVTRV242 EQU   CVTRV237
CVTRV241 EQU   CVTRV237
CVTRV240 EQU   CVTRV237
CVTRV239 EQU   CVTRV237
CVTRV238 EQU   CVTRV237
CVTRV236 EQU   CVTRV228
CVTRV235 EQU   CVTRV228
CVTRV234 EQU   CVTRV228
CVTRV233 EQU   CVTRV228
CVTRV232 EQU   CVTRV228
CVTRV231 EQU   CVTRV228
CVTRV230 EQU   CVTRV228
CVTRV229 EQU   CVTRV228
CVTRV227 EQU   CVTRV219
CVTRV226 EQU   CVTRV219
CVTRV225 EQU   CVTRV219
CVTRV224 EQU   CVTRV219
CVTRV223 EQU   CVTRV219
CVTRV222 EQU   CVTRV219
CVTRV221 EQU   CVTRV219
CVTRV220 EQU   CVTRV219
CVTRV218 EQU   CVTRV210
CVTRV217 EQU   CVTRV210
CVTRV216 EQU   CVTRV210
CVTRV215 EQU   CVTRV210
CVTRV214 EQU   CVTRV210
CVTRV213 EQU   CVTRV210
CVTRV212 EQU   CVTRV210
CVTRV211 EQU   CVTRV210
CVTLCCAT EQU   CVTS01+420
CVTPCCAT EQU   CVTS01+416
CVTIPCRP EQU   CVTS01+412
CVTIPCRI EQU   CVTS01+408
CVTIPCDS EQU   CVTS01+404
CVTAIDVT EQU   CVTS01+400
CVTSSAP  EQU   CVTS01+396
CVTRV202 EQU   CVTS01+394
CVTRV201 EQU   CVTS01+392
CVTRV200 EQU   CVTS01+390
CVTRV199 EQU   CVTS01+388
CVTRV198 EQU   CVTS01+386
CVTRV197 EQU   CVTS01+384
CVTRV196 EQU   CVTS01+383
CVTRV195 EQU   CVTS01+382
CVTRV194 EQU   CVTS01+381
CVTRV193 EQU   CVTS01+380
CVTRV192 EQU   CVTRV184
CVTRV191 EQU   CVTRV184
CVTRV190 EQU   CVTRV184
CVTRV189 EQU   CVTRV184
CVTRV188 EQU   CVTRV184
CVTRV187 EQU   CVTRV184
CVTRV186 EQU   CVTRV184
CVTRV185 EQU   CVTRV184
CVTRV183 EQU   CVTRV175
CVTRV182 EQU   CVTRV175
CVTRV181 EQU   CVTRV175
CVTRV180 EQU   CVTRV175
CVTRV179 EQU   CVTRV175
CVTRV178 EQU   CVTRV175
CVTRV177 EQU   CVTRV175
CVTRV176 EQU   CVTRV175
CVTRV174 EQU   CVTRV166
CVTRV173 EQU   CVTRV166
CVTRV172 EQU   CVTRV166
CVTRV171 EQU   CVTRV166
CVTRV170 EQU   CVTRV166
CVTRV169 EQU   CVTRV166
CVTRV168 EQU   CVTRV166
CVTRV167 EQU   CVTRV166
CVTRV165 EQU   CVTRV157
CVTRV164 EQU   CVTRV157
CVTRV163 EQU   CVTRV157
CVTRV162 EQU   CVTRV157
CVTRV161 EQU   CVTRV157
CVTRV160 EQU   CVTRV157
CVTRV159 EQU   CVTRV157
CVTRV158 EQU   CVTRV157
CVTRV156 EQU   CVTS01+372
CVTRSTWD EQU   CVTS01+368
CVTSPOST EQU   CVTS01+364
CVTIOBP  EQU   CVTS01+360
CVTASMVT EQU   CVTS01+356
CVTRECRQ EQU   CVTS01+352
CVTWSAC  EQU   CVTS01+348
CVTWSAG  EQU   CVTS01+344
CVTWSAL  EQU   CVTS01+340
CVTSPSA  EQU   CVTS01+336
CVTGLMN  EQU   CVTS01+332
CVTVEAC0 EQU   CVTS01+328
CVT062R1 EQU   CVTS01+324
CVTRPOST EQU   CVTS01+320
CVTDQIQE EQU   CVTS01+316
CVTCSD   EQU   CVTS01+312
CVTLKRMA EQU   CVTS01+308
CVTRSPIE EQU   CVTS01+304
CVTRENQ  EQU   CVTS01+300
CVTLQCB  EQU   CVTS01+296
CVTFQCB  EQU   CVTS01+292
CVTQCS01 EQU   CVTS01+288
CVTAPFT  EQU   CVTS01+284
CVTPARRL EQU   CVTS01+280
CVTVWAIT EQU   CVTS01+276
CVTGSPL  EQU   CVTS01+272
CVTLSMQ  EQU   CVTS01+268
CVTGSMQ  EQU   CVTS01+264
CVTEXPRO EQU   CVTS01+260
CVTOPCTP EQU   CVTS01+256
CVTSIC   EQU   CVTS01+252
CVTTPIOS EQU   CVTS01+248
CVTRTMS  EQU   CVTS01+244
CVTSDBF  EQU   CVTS01+240
CVTSCBP  EQU   CVTS01+236
CVTSDMP  EQU   CVTS01+232
CVTSV60  EQU   CVTS01+228
CVTRTMCT EQU   CVTS01+224
CVTASCBL EQU   CVTS01+220
CVTASCBH EQU   CVTS01+216
CVTGDA   EQU   CVTS01+212
CVTASVT  EQU   CVTS01+208
CVTVVMDI EQU   CVTS01+204
CVTAQTOP EQU   CVTS01+200
CVTIOSCS EQU   CVTS01+196
CVTSDRM  EQU   CVTS01+192
CVTOPTE  EQU   CVTS01+188
CVTSTXU  EQU   CVTS01+184
CVTQUIS  EQU   CVTS01+180
CVTQREC  EQU   CVTS01+176
CVTS1EE  EQU   CVTS01+172
CVTFRAS  EQU   CVTS01+168
CVTQSAS  EQU   CVTS01+164
CVTCRAS  EQU   CVTS01+160
CVTCRMN  EQU   CVTS01+156
CVTDELCP EQU   CVTS01+152
CVTFRECL EQU   CVTS01+148
CVTGETCL EQU   CVTS01+144
CVTBLDCP EQU   CVTS01+140
CVTAUTHL EQU   CVTS01+136
CVTRV146 EQU   CVTS01+134
CVTRV145 EQU   CVTS01+132
CVTRV144 EQU   CVTS01+130
CVTMAXMP EQU   CVTS01+128
CVTRV142 EQU   CVTS01+126
CVTRV141 EQU   CVTS01+125
CVTRV140 EQU   CVTS01+124
CVTRV139 EQU   CVTS01+123
CVTDSSAC EQU   CVTS01+122
CVTRV513 EQU   CVTS01+121
CVTIOSPL EQU   CVTS01+120
CVTRV135 EQU   CVTRV127
CVTRV134 EQU   CVTRV127
CVTRV133 EQU   CVTRV127
CVTRV132 EQU   CVTRV127
CVTRV131 EQU   CVTRV127
CVTRV130 EQU   CVTRV127
CVTRV129 EQU   CVTRV127
CVTRV128 EQU   CVTRV127
CVTRV126 EQU   CVTRV118
CVTRV125 EQU   CVTRV118
CVTRV124 EQU   CVTRV118
CVTRV123 EQU   CVTRV118
CVTRV122 EQU   CVTRV118
CVTRV121 EQU   CVTRV118
CVTRV120 EQU   CVTRV118
CVTRV119 EQU   CVTRV118
CVTRV117 EQU   CVTRV109
CVTRV116 EQU   CVTRV109
CVTRV115 EQU   CVTRV109
CVTRV114 EQU   CVTRV109
CVTRV113 EQU   CVTRV109
CVTRV112 EQU   CVTRV109
CVTRV111 EQU   CVTRV109
CVTRV110 EQU   CVTRV109
CVTRV108 EQU   CVTRV100
CVTRV107 EQU   CVTRV100
CVTRV106 EQU   CVTRV100
CVTRV105 EQU   CVTRV100
CVTRV104 EQU   CVTRV100
CVTRV103 EQU   CVTRV100
CVTRV102 EQU   CVTRV100
CVTRV101 EQU   CVTRV100
CVTCSPIE EQU   CVTS01+112
CVTSMFEX EQU   CVTS01+108
CVTOLT0A EQU   CVTS01+104
CVTSRBRT EQU   CVTS01+100
CVTRSV82 EQU   CVTS01+98
CVTRSV81 EQU   CVTS01+96
CVTSYSWT EQU   CVTS01+92
CVTRV327 EQU   CVTS01+88
CVTRV326 EQU   CVTS01+84
CVTRV325 EQU   CVTS01+80
CVTRV324 EQU   CVTS01+76
CVT0VL01 EQU   CVTS01+72
CVTSHRVM EQU   CVTS01+68
CVTRV332 EQU   CVTS01+64
CVTTAS   EQU   CVTS01+60
CVTRSCN  EQU   CVTS01+56
CVTTRAC2 EQU   CVTS01+54
CVTTRACE EQU   CVTS01+52
CVTAPG   EQU   CVTS01+51
CVTSDTRC EQU   CVTCTLFG
CVTGTRCE EQU   CVTCTLFG
CVTRSV80 EQU   CVTCTLFG
CVTRSV79 EQU   CVTCTLFG
CVTDSTAT EQU   CVTCTLFG
CVTRSV78 EQU   CVTCTLFG
CVTRV333 EQU   CVTCTLFG
CVTRV323 EQU   CVTCTLFG
CVTSPVLK EQU   CVTS01+49
CVTRSV77 EQU   CVTS01+48
CVTRV331 EQU   CVTS01+44
CVTRV330 EQU   CVTS01+40
CVTRV329 EQU   CVTS01+36
CVTRV328 EQU   CVTS01+32
CVTRV322 EQU   CVTS01+28
CVTSLID  EQU   CVTSLIDA+1
CVTSYLK  EQU   CVTSLIDA
CVTRV321 EQU   CVTS01+20
CVTRV320 EQU   CVTS01+16
CVTLPDIR EQU   CVTLPDIA+1
CVTRSV69 EQU   CVTDIRST
CVTRSV68 EQU   CVTDIRST
CVTRSV67 EQU   CVTDIRST
CVTRSV66 EQU   CVTDIRST
CVTRSV65 EQU   CVTDIRST
CVTRSV64 EQU   CVTDIRST
CVTRSV63 EQU   CVTDIRST
CVTDICOM EQU   CVTDIRST
CVTPVTP  EQU   CVTS01+8
CVTLPDSR EQU   CVTS01+4
CVTRSVA2 EQU   CVTS01
SMCASTCB EQU   SMCABASE+176
SMCAWTCB EQU   SMCABASE+172
SMCAU83  EQU   SMCABASE+168
SMCAPGM  EQU   SMCABASE+164
SMCARGNM EQU   SMCABASE+160
SMCASPOT EQU   SMCABASE+156
SMCASPIN EQU   SMCABASE+152
SMCARGNS EQU   SMCABASE+148
SMCAPGRL EQU   SMCABASE+144
SMCAPGOT EQU   SMCABASE+140
SMCAPGIN EQU   SMCABASE+136
SMCATEXP EQU   SMCABASE+132
SMCARS22 EQU   SMCABASE+128
SMCARS21 EQU   SMCABASE+124
SMCATJID EQU   SMCAASCB+2
SMCAPOST EQU   SMCAASCB
SMCADSCT EQU   SMCABASE+116
SMCADSTM EQU   SMCABASE+108
SMCASWD  EQU   SMCABASE+107
SMCASWC  EQU   SMCABASE+106
SMCASWB  EQU   SMCABASE+105
SMCADSSW EQU   SMCASWA
SMCADSSP EQU   SMCASWA
SMCAZEOD EQU   SMCASWA
SMCANAVL EQU   SMCASWA
SMCANADA EQU   SMCASWA
SMCAOPFL EQU   SMCASWA
SMCADSTR EQU   SMCASWA
SMCASWAR EQU   SMCASWA
SMCAXNAM EQU   SMCABASE+96
@NM00048 EQU   SMCABASE+92
SMCAXCTL EQU   SMCABASE+88
SMCAWRTP EQU   SMCABASE+84
SMCAENAL EQU   SMCABASE+83
SMCAFGN  EQU   SMCAFOPT
SMCAFTDS EQU   SMCAFOPT
SMCAFESV EQU   SMCAFOPT
SMCAFVOL EQU   SMCAFOPT
SMCAFDSA EQU   SMCAFOPT
SMCAFEXT EQU   SMCAFOPT
SMCAFOP2 EQU   SMCAFOPT
SMCAFOP1 EQU   SMCAFOPT
SMCAENOP EQU   SMCAENTY+1
SMCADSNF EQU   SMCAENDI
SMCARS20 EQU   SMCAENDI
SMCARS19 EQU   SMCAENDI
SMCARS18 EQU   SMCAENDI
SMCARS17 EQU   SMCAENDI
SMCARS16 EQU   SMCAENDI
SMCARS15 EQU   SMCAENDI
SMCARS14 EQU   SMCAENDI
SMCAWAIT EQU   SMCABASE+72
SMCASGFT EQU   SMCABASE+68
SMCASGWR EQU   SMCABASE+64
SMCABECB EQU   SMCABASE+60
SMCAWECB EQU   SMCABASE+56
SMCAADCB EQU   SMCABASE+52
SMCAYORX EQU   SMCABASE+51
SMCAANL  EQU   SMCAALBL
SMCAASL  EQU   SMCAALBL
SMCAANSL EQU   SMCAALBL
SMCARS13 EQU   SMCAALBL
SMCARS12 EQU   SMCAALBL
SMCARS11 EQU   SMCAALBL
SMCARS10 EQU   SMCAALBL
SMCARS09 EQU   SMCAALBL
SMCAADAR EQU   SMCABASE+47
SMCAAVOL EQU   SMCASTA
SMCAAUNT EQU   SMCASTA
SMCARS08 EQU   SMCASTA
SMCAAMOD EQU   SMCASTA
SMCAAMTY EQU   SMCASTA
SMCAADA  EQU   SMCASTA
SMCAATAP EQU   SMCASTA
SMCAANAV EQU   SMCASTA
SMCAADEV EQU   SMCABASE+40
SMCAPDCB EQU   SMCABASE+36
SMCAXORY EQU   SMCABASE+35
SMCAPNL  EQU   SMCAPLBL
SMCAPSL  EQU   SMCAPLBL
SMCAPNSL EQU   SMCAPLBL
SMCARS07 EQU   SMCAPLBL
SMCARS06 EQU   SMCAPLBL
SMCARS05 EQU   SMCAPLBL
SMCARS04 EQU   SMCAPLBL
SMCARS03 EQU   SMCAPLBL
SMCAPDAR EQU   SMCABASE+31
SMCAPVOL EQU   SMCAPSTA
SMCAPUNT EQU   SMCAPSTA
SMCARS02 EQU   SMCAPSTA
SMCAMOD  EQU   SMCAPSTA
SMCAPMTY EQU   SMCAPSTA
SMCAPDA  EQU   SMCAPSTA
SMCAPTAP EQU   SMCAPSTA
SMCAPNAV EQU   SMCAPSTA
SMCAPDEV EQU   SMCABASE+24
SMCABUFP EQU   SMCABASE+20
SMCASID  EQU   SMCABASE+16
SMCABSIZ EQU   SMCABUF
SMCATIOT EQU   SMCABASE+4
SMCATOFF EQU   SMCABASE+2
SMCADUMP EQU   SMCAMISC
SMCABSW  EQU   SMCAMISC
SMCADBSY EQU   SMCAMISC
SMCAPSDP EQU   SMCAMISC
SMCAOPI  EQU   SMCAMISC
SMCAUSER EQU   SMCAMISC
SMCAFGND EQU   SMCAOPT
SMCATDS  EQU   SMCAOPT
SMCARS01 EQU   SMCAOPT
SMCAVOL  EQU   SMCAOPT
SMCADSA  EQU   SMCAOPT
SMCAEXT  EQU   SMCAOPT
SMCAOPT2 EQU   SMCAOPT
SMCAOPT1 EQU   SMCAOPT
MSSPARE  EQU   BASES01+52
MSABL    EQU   BASES01+48
MSUCBAL  EQU   BASES01+44
MSUCBPR  EQU   BASES01+40
MSBOBECB EQU   BASES01+36
MSSJQ    EQU   BASES01+32
MSECB    EQU   BASES01+28
MSPBP    EQU   BASES01+24
MSERM    EQU   BASES01+22
MSPASS   EQU   BASES01+14
MSVRB    EQU   BASES01+6
MSQHR    EQU   MSFHF
@NM00047 EQU   MSFHF
MSPSDT   EQU   MSFHF
MSREPLYB EQU   MSFHF
MSFAX    EQU   MSFHF
MSTTT    EQU   MSFHF
MSCSD    EQU   MSFHF
MSNMF    EQU   MSFHF
MSJNF    EQU   MSSSA
MSYOUT   EQU   MSNWP
MSNRP    EQU   MSSSA
MSSRDR   EQU   MSREOF
MSWRLOG  EQU   MSSSA
MSNUPSW  EQU   MSSSA
MSWRPEN  EQU   MSSSA
MSSSSIPL EQU   MSINLSW
MSSUM    EQU   MSECBFL
MSMCR    EQU   MSECBFL
MSYSOUT  EQU   MSECBFL
MSYSIN   EQU   MSECBFL
MSATTN   EQU   MSECBFL
MSWTL    EQU   MSECBFL
MSWTO    EQU   MSECBFL
MSEXT    EQU   MSECBFL
MSCCS    EQU   MSPFG
MSBSP    EQU   MSPFG
MSSYT    EQU   MSPFG
MSSYN    EQU   MSPFG
MSICR    EQU   MSPFG
MSCMC    EQU   MSPFG
MSPNB    EQU   MSPFG
MSDATE   EQU   MSPFG
@NM00046 EQU   MSBTN
MSTN     EQU   MSBTN
@NM00045 EQU   MSBTN
@NM00044 EQU   MSBTN
MSSO     EQU   MSBTN
MSROLFLG EQU   MSBTN
MSCANFLG EQU   MSBTN
MSCONFLG EQU   MSBTN
MSPNIP   EQU   MSNTAL
MSQNIP   EQU   MSNTAL
MSCURE34 EQU   MSNTAL
@NM00043 EQU   MSNTAL
@NM00042 EQU   MSNTAL
@NM00041 EQU   MSNTAL
@NM00040 EQU   MSNTAL
MSNIP    EQU   MSNTAL
@NM00039 EQU   MS1BASEX+40
@NM00038 EQU   MS1BASEX+20
@NM00037 EQU   MS1BASEX
@NM00036 EQU   BASE+128
MSLGJSCB EQU   BASE+124
@NM00035 EQU   MSSTRTSW
MSSTRTP  EQU   MSSTRTSW
MSSTRTW  EQU   MSSTRTSW
@NM00034 EQU   MSWTRSW
MSWTRP   EQU   MSWTRSW
MSWTRW   EQU   MSWTRSW
@NM00033 EQU   MSWLOGSW
MSWLOGP  EQU   MSWLOGSW
MSWLOGW  EQU   MSWLOGSW
@NM00032 EQU   MSCLOSSW
MSCLOSP  EQU   MSCLOSSW
MSCLOSW  EQU   MSCLOSSW
MSLOGLMT EQU   @NM00031+1
MSLOGCLS EQU   @NM00031
BAASCB   EQU   BASE+100
MSCOMMND EQU   BASE+92
BASP12   EQU   BASE+90
BASTCNT  EQU   BASE+88
BASESCT  EQU   BASE+86
BAJNCNT  EQU   BASE+84
BASUBECB EQU   BASE+80
BALOGCOM EQU   BASE+76
BADACNT  EQU   BASE+74
BATACNT  EQU   BASE+72
BAJBNR   EQU   BASE+64
BASP11   EQU   BASE+62
BALCCNT  EQU   BASE+61
BADUMPID EQU   BASE+60
BABCMAX  EQU   BASE+58
BAMONTR2 EQU   BASE+57
@NM00030 EQU   BAMONITR
BAMACTVE EQU   BAMONITR
@NM00029 EQU   BAMONITR
@NM00028 EQU   BAMONITR
@NM00027 EQU   BAMONITR
@NM00026 EQU   BAMONITR
BASPACE  EQU   BAMONITR
BADSN    EQU   BAMONITR
BADSO    EQU   BASE+52
BALOGECB EQU   BASE+48
@NM00025 EQU   BASPBYTE
@NM00024 EQU   BASPBYTE
@NM00023 EQU   BASPBYTE
@NM00022 EQU   BASPBYTE
@NM00021 EQU   BASPBYTE
@NM00020 EQU   BASPBYTE
@NM00019 EQU   BASPBYTE
BAMSSTAR EQU   BASPBYTE
@NM00018 EQU   MSLOGST
@NM00017 EQU   MSLOGST
MSLOGSTA EQU   MSLOGST
MSLOGIPL EQU   MSLOGST
MSLOGDAR EQU   MSLOGST
MSLOGCOM EQU   MSLOGST
MSLOGTHD EQU   MSLOGST
MSLOGENQ EQU   MSLOGST
BAMIPAR2 EQU   BASE+44
BAMINPAR EQU   BASE+42
BAPKES   EQU   BASE+40
BAICTR   EQU   BASE+38
@NM00016 EQU   BASE+37
BADSET   EQU   BARSW
BANOSET  EQU   BARSW
BAMIDNT  EQU   BARSW
BAHR     EQU   BARSW
BAVU     EQU   BARSW
BAINTSET EQU   BARSW
MSTODWTO EQU   BARSW
BAIN     EQU   BARSW
BACV     EQU   BASE+32
@NM00015 EQU   BALOG
@NM00014 EQU   BALOG
@NM00013 EQU   BALOG
@NM00012 EQU   BALOG
@NM00011 EQU   BALOG
@NM00010 EQU   BALOG
@NM00009 EQU   BALOG
BALOGINT EQU   BALOG
MSLOGSVC EQU   BALGSTAT
BAPRC    EQU   BASE+20
BAQ      EQU   BASE+16
BAIPLCC  EQU   @NM00007+2
@NM00008 EQU   @NM00007
BAIPL    EQU   BASE+12
BALAD    EQU   BASE+8
BATRM    EQU   BASE+4
BACHN    EQU   BASE
CVTLEVL  EQU   CVTRELNO+2
CVTNUMB  EQU   CVTRELNO
CVTMDL   EQU   CVTFIX+250
@NM00006 EQU   CVTFIX+248
@NM00005 EQU   CVTFIX
CVTRV482 EQU   CVTXTNT2+128
CVTRV481 EQU   CVTXTNT2+124
CVTRV480 EQU   CVTXTNT2+120
CVTRV479 EQU   CVTXTNT2+118
CVTRV478 EQU   CVTXTNT2+117
CVTRV477 EQU   CVTXTNT2+116
CVTRV476 EQU   CVTXTNT2+115
CVTRV475 EQU   CVTXTNT2+114
CVTRV474 EQU   CVTRV466
CVTRV473 EQU   CVTRV466
CVTRV472 EQU   CVTRV466
CVTRV471 EQU   CVTRV466
CVTRV470 EQU   CVTRV466
CVTRV469 EQU   CVTRV466
CVTRV468 EQU   CVTRV466
CVTRV467 EQU   CVTRV466
CVTRV465 EQU   CVTRV457
CVTRV464 EQU   CVTRV457
CVTRV463 EQU   CVTRV457
CVTRV462 EQU   CVTRV457
CVTRV461 EQU   CVTRV457
CVTRV460 EQU   CVTRV457
CVTRV459 EQU   CVTRV457
CVTRV458 EQU   CVTRV457
CVTRV456 EQU   CVTXTNT2+108
CVTRV455 EQU   CVTXTNT2+104
CVTRV454 EQU   CVTXTNT2+100
CVTRV453 EQU   CVTXTNT2+96
CVTRV452 EQU   CVTXTNT2+94
CVTRV451 EQU   CVTXTNT2+92
CVTRV450 EQU   CVTXTNT2+90
CVTRV449 EQU   CVTXTNT2+88
CVTRV448 EQU   CVTXTNT2+87
CVTRV447 EQU   CVTXTNT2+86
CVTRV446 EQU   CVTRV438
CVTRV445 EQU   CVTRV438
CVTRV444 EQU   CVTRV438
CVTRV443 EQU   CVTRV438
CVTRV442 EQU   CVTRV438
CVTRV441 EQU   CVTRV438
CVTRV440 EQU   CVTRV438
CVTRV439 EQU   CVTRV438
CVTRV437 EQU   CVTRV429
CVTRV436 EQU   CVTRV429
CVTRV435 EQU   CVTRV429
CVTRV434 EQU   CVTRV429
CVTRV433 EQU   CVTRV429
CVTRV432 EQU   CVTRV429
CVTRV431 EQU   CVTRV429
CVTRV430 EQU   CVTRV429
CVTRV428 EQU   CVTXTNT2+80
CVTRV427 EQU   CVTXTNT2+76
CVTRV426 EQU   CVTXTNT2+72
CVTRV425 EQU   CVTXTNT2+68
CVTATACT EQU   CVTATCVT
CVTRV423 EQU   CVTXTNT2+62
CVTRV422 EQU   CVTXTNT2+60
CVTRV421 EQU   CVTXTNT2+58
CVTRV420 EQU   CVTXTNT2+56
CVTRV419 EQU   CVTXTNT2+55
CVTRV418 EQU   CVTXTNT2+54
CVTRV417 EQU   CVTRV409
CVTRV416 EQU   CVTRV409
CVTRV415 EQU   CVTRV409
CVTRV414 EQU   CVTRV409
CVTRV413 EQU   CVTRV409
CVTRV412 EQU   CVTRV409
CVTRV411 EQU   CVTRV409
CVTRV410 EQU   CVTRV409
CVTRV408 EQU   CVTRV400
CVTRV407 EQU   CVTRV400
CVTRV406 EQU   CVTRV400
CVTRV405 EQU   CVTRV400
CVTRV404 EQU   CVTRV400
CVTRV403 EQU   CVTRV400
CVTRV402 EQU   CVTRV400
CVTRV401 EQU   CVTRV400
CVTRSVA1 EQU   CVTXTNT2+48
CVTRSVA0 EQU   CVTXTNT2+44
CVTRSV99 EQU   CVTXTNT2+40
CVTRSV98 EQU   CVTXTNT2+36
CVTRSV97 EQU   CVTXTNT2+34
CVTRSV96 EQU   CVTXTNT2+32
CVTOLTEP EQU   CVTXTNT2+28
CVTQIDA  EQU   CVTQID+1
CVTRSV95 EQU   CVTQID
CVTRSV94 EQU   CVTXTNT2+20
CVTRSV93 EQU   CVTXTNT2+16
CVTRSV92 EQU   CVTXTNT2+12
CVTDEBVR EQU   CVTXTNT2+8
CVTRSV91 EQU   CVTXTNT2+6
CVTRSV9H EQU   CVTRSV90
CVTRSV9G EQU   CVTRSV90
CVTRSV9F EQU   CVTRSV90
CVTRSV9E EQU   CVTRSV90
CVTRSV9D EQU   CVTRSV90
CVTRSV9C EQU   CVTRSV90
CVTRSV9B EQU   CVTRSV90
CVTRSV9A EQU   CVTRSV90
CVTNUCLS EQU   CVTXTNT2+4
CVTDSSVA EQU   CVTDSSV+1
CVTRSV89 EQU   CVTDSSV
CVTRSV88 EQU   CVTXTNT1+8
CVTRSV87 EQU   CVTXTNT1+4
CVTFACHN EQU   CVTXTNT1
CVTRV488 EQU   CVTMAP+412
CVTRV487 EQU   CVTMAP+408
CVTRV486 EQU   CVTMAP+404
CVTRV485 EQU   CVTMAP+400
CVTRV484 EQU   CVTMAP+396
CVTRV483 EQU   CVTMAP+392
CVTATMCA EQU   CVTATMCT+1
CVTATMST EQU   CVTATMCT
CVTRSV61 EQU   CVTMAP+384
CVTRSV60 EQU   CVTMAP+380
CVTSTOA  EQU   CVTMAP+376
CVTRSV58 EQU   CVTMAP+374
CVTRSV57 EQU   CVTMAP+372
CVTDDCE  EQU   CVTMAP+368
CVTPNWFR EQU   CVTMAP+364
CVTSMF   EQU   CVTMAP+360
CVTSULK  EQU   CVTMAP+358
CVTSLKO  EQU   CVTSYSK
CVTSLKP  EQU   CVTSYSK
CVTSLKQ  EQU   CVTSYSK
CVTSLKR  EQU   CVTSYSK
CVTRSV56 EQU   CVTSYSK
CVTRSV55 EQU   CVTSYSK
CVTRSV54 EQU   CVTSYSK
CVTRSV53 EQU   CVTSYSK
CVTRSV52 EQU   CVTA1F1
CVTRSV51 EQU   CVTA1F1
CVTRSV50 EQU   CVTA1F1
CVTRSV49 EQU   CVTA1F1
CVTRSV48 EQU   CVTA1F1
CVTRSV47 EQU   CVTA1F1
CVTSRSW  EQU   CVTA1F1
CVTPFSW  EQU   CVTA1F1
CVTPCVT  EQU   CVTMAP+352
CVTRSV46 EQU   CVTMAP+344
CVTRSV45 EQU   CVTMAP+340
CVTRSV44 EQU   CVTMAP+338
CVTRSV43 EQU   CVTMAP+336
CVTHJESA EQU   CVTHJES+1
CVTRSV42 EQU   CVTHJES
CVTEXT2A EQU   CVTEXT2+1
CVTRSV41 EQU   CVTEXT2
CVTAPFA  EQU   CVTAPF+1
CVTRSV40 EQU   CVTAPF
CVTINTLA EQU   CVTMAP+320
CVTERPV  EQU   CVTMAP+316
CVTEORM  EQU   CVTMAP+312
CVTMCHPR EQU   CVTMAP+308
CVTTZ    EQU   CVTMAP+304
CVTJEPS  EQU   CVTMAP+300
CVTJESCT EQU   CVTMAP+296
CVTMODE  EQU   CVTMAP+292
CVTPTRV  EQU   CVTMAP+288
CVTREAL  EQU   CVTMAP+284
CVTRSV39 EQU   CVTMAP+280
CVTRSV38 EQU   CVTMAP+276
CVTDMSRA EQU   CVTDMSR+1
CVTRSV37 EQU   CVTDMSR
CVTQMSGA EQU   CVTQMSG+1
CVTRSV36 EQU   CVTQMSG
CVTAMFF  EQU   CVTMAP+264
CVTPURGA EQU   CVTPURG+1
CVTRSV35 EQU   CVTPURG
CVTCBSP  EQU   CVTMAP+256
CVTATERA EQU   CVTATER+1
CVTSYST  EQU   CVTATER
CVTTAT   EQU   CVTTATA+1
CVTTSKS  EQU   CVTTATA
CVTAQAVB EQU   CVTAQAVT+1
CVTRSV34 EQU   CVTTCMFG
CVTRSV33 EQU   CVTTCMFG
CVTRSV32 EQU   CVTTCMFG
CVTRSV31 EQU   CVTTCMFG
CVTRSV30 EQU   CVTTCMFG
CVTRSV29 EQU   CVTTCMFG
CVTRSV28 EQU   CVTTCMFG
CVTTCRDY EQU   CVTTCMFG
CVTGTFA  EQU   CVTGTF+1
CVTRSV27 EQU   CVTGTFST
CVTRSV26 EQU   CVTGTFST
CVTRV319 EQU   CVTUSR
CVTRV318 EQU   CVTFORM
CVTRV317 EQU   CVTTMODE
CVTRV316 EQU   CVTSTATE
CVTRV315 EQU   CVTGTFS
CVTGTFAV EQU   CVTGTFS
CVT0SCR1 EQU   CVTMAP+232
CVTTSCVB EQU   CVTTSCVT+1
CVTRSV25 EQU   CVTTSFLG
CVTRSV24 EQU   CVTTSFLG
CVTRSV23 EQU   CVTTSFLG
CVTRSV22 EQU   CVTTSFLG
CVTRSV21 EQU   CVTTSFLG
CVTRSV20 EQU   CVTTSFLG
CVTRSV19 EQU   CVTTSFLG
CVTTSRDY EQU   CVTTSFLG
CVTRMS   EQU   CVTMAP+224
CVTPATCH EQU   CVTMAP+220
CVTTSCE  EQU   CVTMAP+216
CVTLNKSC EQU   CVTMAP+214
CVTQABST EQU   CVTMAP+212
CVTMDLDS EQU   CVTMAP+208
CVTUSER  EQU   CVTMAP+204
CVTABEND EQU   CVTMAP+200
CVTRSV18 EQU   CVTMAP+192
CVTQLPAQ EQU   CVTMAP+188
CVTQCDSR EQU   CVTMAP+184
CVTRSV17 EQU   CVTOPTB
CVTRSV16 EQU   CVTOPTB
CVTFP    EQU   CVTOPTB
CVTAPTHR EQU   CVTOPTB
CVTNLOG  EQU   CVTOPTB
CVTTOD   EQU   CVTOPTB
CVTCTIMS EQU   CVTOPTB
CVTPROT  EQU   CVTOPTB
CVTXPFP  EQU   CVTOPTA
CVTASCII EQU   CVTOPTA
CVTRSV13 EQU   CVTOPTA
CVTRSV12 EQU   CVTOPTA
CVTNIP   EQU   CVTOPTA
CVTDDR   EQU   CVTOPTA
CVTAPR   EQU   CVTOPTA
CVTCCH   EQU   CVTOPTA
CVTSNCTR EQU   CVTMAP+180
CVTQMWR  EQU   CVTMAP+176
CVTQOCR  EQU   CVTMAP+172
CVT1EF00 EQU   CVTMAP+168
CVTMZ00  EQU   CVTMAP+164
CVTHEAD  EQU   CVTMAP+160
CVTRSV11 EQU   CVTMAP+156
CVT0PT01 EQU   CVTMAP+152
CVTIERLC EQU   CVTMAP+144
CVTILCH  EQU   CVTMAP+140
CVT0DS   EQU   CVTMAP+136
CVTFBOSV EQU   CVTMAP+132
CVTNUCB  EQU   CVTMAP+128
CVTIXAVL EQU   CVTMAP+124
CVTIOQET EQU   CVTMAP+120
CVTDCBA  EQU   CVTMAP+117
CVTMVS2  EQU   CVTDCB
CVT6DAT  EQU   CVTDCB
CVT4MPS  EQU   CVTDCB
CVTRSV09 EQU   CVTDCB
CVT4MS1  EQU   CVTDCB
CVT2SPS  EQU   CVTDCB
CVT1SSS  EQU   CVTDCB
CVTRSV08 EQU   CVTDCB
CVTSTB   EQU   CVTMAP+112
CVTQTD00 EQU   CVTMAP+108
CVTQTE00 EQU   CVTMAP+104
CVTCUCB  EQU   CVTMAP+100
CVTSJQ   EQU   CVTMAP+96
CVTPBLDL EQU   CVTMAP+92
CVTTPC   EQU   CVTMAP+88
CVTSVDCB EQU   CVTMAP+84
CVTBRET  EQU   CVTMAP+82
CVTEXIT  EQU   CVTMAP+80
CVT0FN00 EQU   CVTMAP+76
CVTDARA  EQU   CVTDAR+1
CVTRSV07 EQU   CVTFLGS1
CVTRSV06 EQU   CVTFLGS1
CVTRSV05 EQU   CVTFLGS1
CVTRSV04 EQU   CVTFLGS1
CVTRSV03 EQU   CVTFLGS1
CVTRSV02 EQU   CVTFLGS1
CVTRSV01 EQU   CVTFLGS1
CVTDMPLK EQU   CVTFLGS1
CVTXITP  EQU   CVTMAP+68
CVTZDTAB EQU   CVTMAP+64
CVTMSLT  EQU   CVTMAP+60
CVTDATE  EQU   CVTMAP+56
CVTBTERM EQU   CVTMAP+52
CVTSYSAD EQU   CVTMAP+48
CVTXTLER EQU   CVTMAP+44
CVTILK2  EQU   CVTMAP+40
CVTILK1  EQU   CVTMAP+36
CVTPRLTV EQU   CVTMAP+32
CVTPCNVT EQU   CVTMAP+28
CVT0VL00 EQU   CVTMAP+24
CVTXAPG  EQU   CVTMAP+20
CVTBUF   EQU   CVTMAP+16
CVTJOB   EQU   CVTMAP+12
CVTLINK  EQU   CVTMAP+8
CVT0EF00 EQU   CVTMAP+4
CVTTCBP  EQU   CVTMAP
CVT      EQU   CVTMAP
@NM00002 EQU   @NM00001+2
.@UNREFD ANOP                          END UNREFERENCED COMPONENTS
@ENDDATA EQU   *
         END   IEEMB820
