         TITLE 'IEEMB823 - SMF INITIALIZATION RECORD PROCESSOR         *
                        '
IEEMB823 CSECT ,                                                01S0001
@MAINENT DS    0H                                               01S0001
         USING *,@15                                            01S0001
         B     @PROLOG                                          01S0001
         DC    AL1(16)                                          01S0001
         DC    C'IEEMB823  78.023'                              01S0001
         DROP  @15
@PROLOG  STM   @14,@12,12(@13)                                  01S0001
         BALR  @12,0                                            01S0001
@PSTART  DS    0H                                               01S0001
         USING @PSTART,@12                                      01S0001
         L     @00,@SIZDATD                                     01S0001
         GETMAIN  R,LV=(0)
         LR    @11,@01                                          01S0001
         USING @DATD,@11                                        01S0001
         ST    @13,@SA00001+4                                   01S0001
         LM    @00,@01,20(@13)                                  01S0001
         ST    @11,8(,@13)                                      01S0001
         LR    @13,@11                                          01S0001
         MVC   @PC00001(8),0(@01)                               01S0001
RECSBPL  EQU    0
*R1=LENGTH(RECORD);                    /* GET LENGTH OF LONGEST 01S0057
*                                         POSIBLE RECORD             */
         LH    R1,@CH01791                                      01S0057
*GEN(GETMAIN R,SP=RECSBPL,LV=(R1));    /* GET CORE FOR RECORD        */
         GETMAIN R,SP=RECSBPL,LV=(R1)
*RECPTR=R1;                            /* SAVE RECORD ADDRESS        */
         LR    RECPTR,R1                                        01S0059
*RFY (R1) UNRSTD;                      /* RELEASE REGISTER CONTROL   */
*RDWRES=0;                             /* ZERO RESERVED FIELD        */
         SLR   @10,@10                                          01S0061
         STH   @10,RDWRES(,RECPTR)                              01S0061
*COMHDR=COMHDR&&COMHDR;                /* ZERO COMMON RECORD SECTION */
         XC    COMHDR(14,RECPTR),COMHDR(RECPTR)                 01S0062
*/********************************************************************/
*/*                                                                  */
*/*SEGMENT NAME= BLDREC0                                             */
*/*                                                                  */
*/*DESCRIPTIVE NAME=  RECORD 0 PROCESSOR                             */
*/*                                                                  */
*/*FUNCTION=                                                         */
*/* THIS SEGMENT BUILDS AND ISSUES RECORD TYPE 0. THIS RECORD        */
*/*  CONTAINS INFORMATION PERTINENT TO THE SYSTEM ENVIRONMENT        */
*/*  AT IPL TIME. I.E., JOB WAIT TIME, SIZE OF SMF BUFFERS,          */
*/*  HIGHEST REAL AND HIGHEST VIRTUAL CORE SIZE IN ONE K MULTIPLES,  */
*/*  AND SMF OPTIONS USED FOR ACCOUNTING.                            */
*/*                                                                  */
*/*  OPERATION= NO SPECIAL ALGORITHMS                                */
*/*                                                                  */
*/*ENTRY POINT= IN-LINE SEGMENT                                      */
*/*  INPUT=                                                          */
*/*    JWTMIN  - VALUE OF JOB WAIT TIME IN MINUTES                   */
*/*              PASSED FROM IEEMB820.                               */
*/*    SMCABSIZ - SIZE OF ONE SMF BUFFER                             */
*/*    CVTMZ00  - HIGHEST VIRTUAL ADDRESS IN MACHINE                 */
*/*    CVTEORM  - HIGHEST REAL ADDRESS IN MACHINE                    */
*/*    SMCAOPT  - SMF ACCOUNTING OPTIONS                             */
*/*    RECORD   - BUFFER TO BUILD RECORD IN                          */
*/*                                                                  */
*/*EXIT=                                                             */
*/*  CONDITION= NORMAL, THE TYPE 0 RECORD BUILT AND ISSUED           */
*/*  OUTPUT= THE TYPE 0 RECORD ISSUED                                */
*/*  RETURN CODE= NONE                                               */
*/*                                                                  */
*/********************************************************************/
*SMF0LEN=LENGTH(SMFRCD00);             /* LENGTH OF RECORD           */
         MVC   SMF0LEN(2,RECPTR),@CH01792                       02S0063
*SMF0RTY=0;                            /* RECORD TYPE 0              */
         MVI   SMF0RTY(RECPTR),X'00'                            02S0064
*SMF0JWT=JWTMIN;                       /* JOB WAIT TIME IN MINUTES   */
         L     @10,@PC00001                                     02S0065
         MVC   SMF0JWT(4,RECPTR),JWTMIN(@10)                    02S0065
*SMF0BUF=2*SMCABSIZ;                   /* SIZE OF SMF BUFFERS        */
         L     @10,@PC00001+4                                   02S0066
         L     @10,CVTPTR(,@10)                                 02S0066
         L     @15,CVTSMCA(,@10)                                02S0066
         L     @14,SMCABSIZ(,@15)                               02S0066
         ALR   @14,@14                                          02S0066
         ST    @14,SMF0BUF(,RECPTR)                             02S0066
*SMF0VST=(CVTMZ00+1)/1024;             /* HIGHEST VITUAL @ IN 1K UNIT*/
         LA    @00,1                                            02S0067
         AL    @00,CVTMZ00(,@10)                                02S0067
         SRDA  @00,32                                           02S0067
         D     @00,@CF01774                                     02S0067
         ST    @01,SMF0VST(,RECPTR)                             02S0067
*SMF0OPT=SMCAOPT;                      /* SMCA OPTIONS FOR THIS IPL  */
         MVC   SMF0OPT(1,RECPTR),SMCAOPT(@15)                   02S0068
*SMF0RST=CVTRLSTG;                     /* ON-LINE STORAGE IN 1K UNITS
*                                                            @ZA28053*/
         MVC   SMF0RST(4,RECPTR),CVTRLSTG(@10)                  02S0069
*RFY R1 RSTD;                          /* GET REGISTER CONTROL       */
*R1=ADDR(SMFRCD00);                    /* GET ADDR OF SMF RECORD     */
         LR    R1,RECPTR                                        02S0071
*GEN(SMFWTM (R1));                     /* ISSUE RECORD 0             */
         SMFWTM (R1)
*RFY R1 UNRSTD;                        /* RELEASE REGISTER CONTROL   */
*/********************************************************************/
*/*                                                                  */
*/*SEGMENT NAME= BLDREC8                                             */
*/*                                                                  */
*/*DESCRIPTIVE NAME=  RECORD TYPE 8 PROCESSOR                        */
*/*                                                                  */
*/*FUNCTION=                                                         */
*/*  THIS SEGMENT BUILDS AND ISSUES REORD TYPE 8.                    */
*/*  THIS RECORD REFLECTS THE STATUS OF DEVICES THAT ARE             */
*/*  ONLINE AT IPL TIME.                                             */
*/*  EACH DEVICE ENTRY CONTAINS INFORMATION ON CLASS AND     @Y30LPPE*/
*/*  UNIT TYPE, CHANNEL AND UNIT ADDRESS, AND AN INDICATOR   @Y30LPPE*/
*/*  FOR VIRTUAL VOLUMES.                                    @Y30LPPE*/
*/*  IN ADDITION TO RECORD 8, IF VOLUME ACCOUNTING WAS REQUESTED,    */
*/*  RECORD TYPE 19 IS PRODUCED FOR ONLINE, READY DIRECT ACCESS      */
*/*  DEVICES. THIS IS PERFORMED BY INVOKING SVC 78 FOR               */
*/*  EACH ONLINE, READY DIRECT ACCESS DEVICE.                        */
*/*                                                                  */
*/*  OPERATION=                                                      */
*/*    THE UCB LOOKUP TABLE IS USED TO OBTAIN POINTERS TO ALL UCBS   */
*/*    IN THE SYSTEM. ZERO POINTERS ARE IGNORED (DUMMY UCB).         */
*/*    IF THE UCB CURRENTLY BEING USED INDICATES MULITPLE PATHS      */
*/*    EXIST TO THE DEVICE, THE UCB TABLE THUS FAR PROCESSED IS      */
*/*    RESCANNED. IF A UCB POINTER WHICH IS THE SAME AS THE CURRENT  */
*/*    UCB POINTER IS FOUND IN THE TABLE, THE UCB HAS ALREADY        */
*/*    BEEN PROCESSED, AND THEREFORE THE CURRENT ENTRY IS IGNORED.   */
*/*    IF THE UCBTYPE INDICATES A VIRTUAL DEVICE, THEN THE   @Y30LPPE*/
*/*    DEVICE ENTRY FLAGS WILL BE SET TO INDICATE A VIRTUAL  @Y30LPPE*/
*/*    DEVICE.                                               @Y30LPPE*/
*/*    A UCB POINTER OF 'FFFF'X DENOTES THE END OF THE TABLE.        */
*/*                                                                  */
*/*ENTRY POINT= IN-LINE SEGMENT                                      */
*/*  INPUT=                                                          */
*/*    UCBTBL   - UCB LOOKUP TABLE                                   */
*/*    UCBONLI  - DEVICE ON LINE INDICATOR                           */
*/*    UCB3DACC - DEVICE DIRECT ACCESS INDICATOR                     */
*/*    UCBNOTRD - DEVICE READY UNDICATOR                             */
*/*    UCBTYP   - DEVICE CLASS AND TYPE (BYTES 3 AND 4)              */
*/*    UCBRVDEV - VIRTUAL DEVICE INDICATOR                   @Y30LPPE*/
*/*    UCBCHAN  - CHANNEL AND UNIT ADDRESS                           */
*/*    SMCAVOL  - VOLUME ACCOUNTING INDICATOR                        */
*/*    RECORD   - BUFFER TO BUILD RECORD IN                          */
*/*                                                                  */
*/*EXIT=                                                             */
*/*  CONDITION= NORMAL, RECORD TYPE 8 AND/OR TYPE 19 ISSUED          */
*/*  OUTPUT= THE TYPE 8 AND/OR TYPE 19 RECORDS ISSUED                */
*/*  RETURN CODE= NONE                                               */
*/*                                                                  */
*/********************************************************************/
*SMF8RTY=8;                            /* RECORD TYPE 8              */
         MVI   SMF8RTY(RECPTR),X'08'                            02S0074
*DVCINDX=0;                            /* INIT DEVICE ENTRY INDEX    */
         SLR   DVCINDX,DVCINDX                                  02S0075
*UCBINDX=1;                            /* INIT INDEX FIRST UCB       */
         LA    UCBINDX,1                                        02S0076
*VARPTR=ADDR(SMF8LENN)+2;              /* ADDR OF FIRST DEVICE ENT   */
         LA    VARPTR,SMF8LENN(,RECPTR)                         02S0077
         AH    VARPTR,@CH00136                                  02S0077
*DO WHILE (UCBTBL(UCBINDX)^=TBLEND);   /* PROCESS UCBLOOKUP TBL      */
         B     @DE00078                                         02S0078
@DL00078 DS    0H                                               02S0079
*  UCBPTR=UCBTBL(UCBINDX);             /* GET UCB POINTER FROM TBL   */
         LR    @10,UCBINDX                                      02S0079
         ALR   @10,@10                                          02S0079
         L     @15,@PC00001+4                                   02S0079
         L     @01,CVTPTR(,@15)                                 02S0079
         L     @01,CVTILK2(,@01)                                02S0079
         BCTR  @01,0                                            02S0079
         BCTR  @01,0                                            02S0079
         LH    UCBPTR,UCBTBL(@10,@01)                           02S0079
*  UCBPTR=UCBPTR&'0000FFFF'X;          /* MAKE SURE UCB PTR POSITIVE */
         N     UCBPTR,@CF01776                                  02S0080
*  IF UCBPTR^=0 &                      /* IF NOT DUMMY UCB (ZERO PTR)*/
*     UCBONLI='1'B THEN                /* AND UCB IS ON LINE         */
         LTR   UCBPTR,UCBPTR                                    02S0081
         BZ    @RF00081                                         02S0081
         TM    UCBONLI(UCBPTR),B'10000000'                      02S0081
         BNO   @RF00081                                         02S0081
*    DO;                               /* THEN, BUILD RECORD ENTRY   */
*      DUPBIT='0'B;                    /* ASSUME UCB NOT DUP ENTRY   */
         NI    DUPBIT,B'01111111'                               02S0083
*      IF UCBALTPH='1'B &              /* IF MORE THAN ONE PATH 02S0084
*                                         AVAILABLE TO  THIS UCB AND */
*         UCBINDX^=1 THEN              /* THIS IS NOT FIRST UCB      */
         TM    UCBALTPH(UCBPTR),B'00000001'                     02S0084
         BNO   @RF00084                                         02S0084
         LA    @10,1                                            02S0084
         CR    UCBINDX,@10                                      02S0084
         BE    @RF00084                                         02S0084
*        DO;                           /* SEE IF ALREADY PROCEESED   */
*          DO UCBINDX1=1 TO UCBINDX-1 WHILE(DUPBIT='0'B);    /* CHECK
*                                         IF UCB ALREADY PROCESSED   */
         LR    UCBINDX1,@10                                     02S0086
         B     @DE00086                                         02S0086
@DL00086 TM    DUPBIT,B'10000000'                               02S0086
         BNZ   @DC00086                                         02S0086
*            IF UCBTBL(UCBINDX)=UCBTBL(UCBINDX1) THEN /* IF YES,     */
         LR    @10,UCBINDX                                      02S0087
         ALR   @10,@10                                          02S0087
         L     @09,@PC00001+4                                   02S0087
         L     @09,CVTPTR(,@09)                                 02S0087
         L     @09,CVTILK2(,@09)                                02S0087
         LR    @02,UCBINDX1                                     02S0087
         ALR   @02,@02                                          02S0087
         BCTR  @10,0                                            02S0087
         BCTR  @10,0                                            02S0087
         LH    @10,UCBTBL(@10,@09)                              02S0087
         BCTR  @09,0                                            02S0087
         BCTR  @09,0                                            02S0087
         CH    @10,UCBTBL(@02,@09)                              02S0087
         BNE   @RF00087                                         02S0087
*              DUPBIT='1'B;            /* THEN INDICATE DUP UCB ENTRY*/
         OI    DUPBIT,B'10000000'                               02S0088
*          END;                                                 02S0089
@RF00087 AH    UCBINDX1,@CH00062                                02S0089
@DE00086 LR    @10,UCBINDX                                      02S0089
         BCTR  @10,0                                            02S0089
         CR    UCBINDX1,@10                                     02S0089
         BNH   @DL00086                                         02S0089
@DC00086 DS    0H                                               02S0090
*        END;                                                   02S0090
*      IF DUPBIT='0'B THEN             /* IF NOT DUP UCB ENTRY, THEN */
@RF00084 TM    DUPBIT,B'10000000'                               02S0091
         BNZ   @RF00091                                         02S0091
*        DO;                           /* PROCESS UCB FOR RECORD 8   */
*          IF SMCAVOL='1'B  &          /* IF VOLUMN RECORDING NEEDED */
*             UCB3DACC='1'B  &         /* AND DIRECT ACCESS DEVICE   */
*             UCBNOTRD='0'B THEN       /* AND DEVICE READY           */
         L     @10,@PC00001+4                                   02S0093
         L     @10,CVTPTR(,@10)                                 02S0093
         L     @10,CVTSMCA(,@10)                                02S0093
         TM    SMCAVOL(@10),B'00001000'                         02S0093
         BNO   @RF00093                                         02S0093
         TM    UCB3DACC(UCBPTR),B'00100000'                     02S0093
         BNO   @RF00093                                         02S0093
         TM    UCBNOTRD(UCBPTR),B'01000000'                     02S0093
         BNZ   @RF00093                                         02S0093
*            DO;                       /* ISSUE LSPACE FOR REC 19    */
*              RFY (R0,R1) RSTD;       /* GET REGISTER CONTROL       */
*              R0=UCBPTR;              /* ADDRESS OF UCB TO PROCESS  */
         LR    R0,UCBPTR                                        02S0096
*              R1='80000000'X;         /* CONTROL INFO TO LSPACE     */
         L     R1,@CF01779                                      02S0097
*              SVC( 78);               /* ISSUE LSPACE TO BUILD 02S0098
*                                         RECORD TYPE 19             */
         SVC   78                                               02S0098
*              RFY (R0,R1) UNRSTD;     /* RELEASE REGISTER CONTROL   */
*            END;                                               02S0100
*          DVCINDX=DVCINDX+1;          /* INCREMENT DEVICE ENTRY INDX*/
@RF00093 AH    DVCINDX,@CH00062                                 02S0101
*          RFY SMF8IODV BASED(VARPTR); /* BASE FOR DEVICE ENTRIES    */
*          SMF8DUT=UCBTYP(3:4);        /* SET CLASS AND UNIT    02S0103
*                                         TYPE IN ENRTY              */
         MVC   SMF8DUT(2,VARPTR),UCBTYP+2(UCBPTR)               02S0103
*          SMF8CHA=UCBCHAN;            /* SET CHANNEL AND UNIT  02S0104
*                                         ADDRESS IN ENTRY           */
         MVC   SMF8CHA(2,VARPTR),UCBCHAN(UCBPTR)                02S0104
*          SMF8CHA(1)=SMF8CHA(1)&'0F'X;     /* CLEAR UNWANTED BITS
*                                         IN CHANNEL ADDRESS @YM04913*/
         NI    SMF8CHA(VARPTR),X'0F'                            02S0105
*          IF UCBRVDEV='1'B &          /*IF UCB IS VIRTUAL   @Y30LPPE*/
*             UCBTYP(3:4)=THRTY330 THEN/*3330                @Y30LPPE*/
         TM    UCBRVDEV(UCBPTR),B'00001000'                     02S0106
         BNO   @RF00106                                         02S0106
         CLC   UCBTYP+2(2,UCBPTR),@CB00043                      02S0106
         BNE   @RF00106                                         02S0106
*            DO;                       /*THEN                @Y30LPPE*/
*              SMF8VDV='1'B;           /*TURN ON VIRTUAL     @Y30LPPE*/
         OI    SMF8VDV(VARPTR),B'10000000'                      02S0108
*            END;                      /*BIT IN DVENTRY FLAGS@Y30LPPE*/
*          VARPTR=VARPTR+LENGTH(SMF8IODV);/*BUMP TO NEXT DEVICE ENTRY*/
@RF00106 AH    VARPTR,@CH00077                                  02S0110
*        END;                                                   02S0111
*    END;                                                       02S0112
@RF00091 DS    0H                                               02S0113
*  UCBINDX=UCBINDX+1;                  /* TO NEXT UCB TBL ENTRY      */
@RF00081 AH    UCBINDX,@CH00062                                 02S0113
*END;                                                           02S0114
@DE00078 LR    @10,UCBINDX                                      02S0114
         ALR   @10,@10                                          02S0114
         L     @15,@PC00001+4                                   02S0114
         L     @01,CVTPTR(,@15)                                 02S0114
         L     @01,CVTILK2(,@01)                                02S0114
         BCTR  @01,0                                            02S0114
         BCTR  @01,0                                            02S0114
         LH    @10,UCBTBL(@10,@01)                              02S0114
         CH    @10,@CH00040                                     02S0114
         BNE   @DL00078                                         02S0114
*SMF8LEN=DVCINDX*LENGTH(SMF8IODV)+LENGTH(SMFRCD08);/* TOTAL LENGTH   */
         LR    @10,DVCINDX                                      02S0115
         SLA   @10,2                                            02S0115
         LA    @06,20                                           02S0115
         ALR   @06,@10                                          02S0115
         STH   @06,SMF8LEN(,RECPTR)                             02S0115
*SMF8LENN=DVCINDX*LENGTH(SMF8IODV)+2;  /* LENGTH OF DEVICE ENTRY
*                                         SECTION                    */
         AH    @10,@CH00136                                     02S0116
         STH   @10,SMF8LENN(,RECPTR)                            02S0116
*RFY R1 RSTD;                          /* GET REGISTER CONTROL       */
*R1=ADDR(SMFRCD08);                    /* ADDR OF RECORD 8           */
         LR    R1,RECPTR                                        02S0118
*GEN(SMFWTM (R1));                     /* WRITE RECORD TYPE 8        */
         SMFWTM (R1)
*RFY R1 UNRSTD;                        /* RELEASE REGISTER CONTROL   */
*/********************************************************************/
*/*                                                           @Y02651*/
*/*SEGMENT NAME= BLDREC22                                     @Y02651*/
*/*                                                           @Y02651*/
*/*DESCRIPTIVE NAME=  RECORD TYPE 22 PROCESSOR                @Y02651*/
*/*                                                           @Y02651*/
*/*FUNCTION=                                                  @Y02651*/
*/*  THIS SEGMENT BUILDS AND ISSUES REORD TYPE 22.            @Y02651*/
*/*  THIS RECORD REFLECTS THE STATUS OF STORAGE, CPU'S        @Y02651*/
*/*  AND CHANNELS PER CPU AT IPL TIME.                        @Y02651*/
*/*                                                           @Y02651*/
*/*  OPERATION=                                               @Y02651*/
*/*    THE PHYSICAL CONFIGURATION COMMUNICATION VECTOR        @Y02651*/
*/*    TABLE (PCCVT) IS USED TO OBTAIN INFORMATION ABOUT      @Y02651*/
*/*    ONLINE CPUS. THE PCCVT POINTS TO A PCCA FOR EACH       @Y02651*/
*/*    POSSIBLE CPU. IF THE CPU WAS NOT ONLINE AT IPL TIME,   @Y02651*/
*/*    THE PCCVT POINTER TO THAT CPU WILL BE ZERO.            @Y02651*/
*/*    THE CPU ADDRESS (0,1,2, ETC.) IS USED AS AN INDEX INTO @Y02651*/
*/*    THIS PCCVT.                                            @Y02651*/
*/*    FOR EACH NON ZERO TABLE ENTRY A CPU ENTRY              @Y02651*/
*/*    WILL BE CONSTRUCTED.                                   @Y02651*/
*/*    THE PHYSICAL CONFIGURATION COMMUNICATION AREA (PCCA)   @Y02651*/
*/*    IS THEN EXAMINED FOR CHANNEL INFORMATION.              @Y02651*/
*/*    THE PCCA CONTAINS A CHANNEL AVAILABILITY TABLE (CAT)   @Y02651*/
*/*    WHICH CONTAINS INFORMATION ABOUT THE CHANNELS ON THAT  @Y02651*/
*/*    CPU:                                                   @Y02651*/
*/*    . ONLINE INDICATOR                                     @Y02651*/
*/*    . CHANNEL TYPE                                         @Y02651*/
*/*    . CHANNEL MODULE NUMBER                                @Y02651*/
*/*    . CHANNEL ADDRESS (RELATIVE OFFSET INTO CAT)           @Y02651*/
*/*    FOR EACH CHANNEL MARKED AS ONLINE A CHANNEL ENTRY IN   @Y02651*/
*/*    RECORD 22 IS CONSTRUCTED.                              @Y02651*/
*/*                                                           @Y02651*/
*/*ENTRY POINT= IN-LINE SEGMENT                               @Y02651*/
*/*  INPUT=                                                   @Y02651*/
*/*    RECORD   - BUFFER TO BUILD RECORD IN                   @Y02651*/
*/*    PCCAVT   - PAGE PCCA VECTOR TABLE                      @Y02651*/
*/*    PCCA     - PHYSICAL CCA AREA FOR EACH CPU              @Y02651*/
*/*    CAT      - CHANNEL AVAILABILITY TABLE (IN PCCA)        @Y02651*/
*/*                                                           @Y02651*/
*/*EXIT=                                                      @Y02651*/
*/*  CONDITION= NORMAL, RECORD TYPE 22 IS BUILT AND ISSUED    @Y02651*/
*/*  OUTPUT= THE TYPE 22 RECORD ISSUED                        @Y02651*/
*/*  RETURN CODE= NONE                                        @Y02651*/
*/*                                                           @Y02651*/
*/********************************************************************/
*SMF22LEN=LENGTH(SMFRCD22);            /* BASIC LEN RECORD 22 @Y02651*/
         LA    @10,22                                           02S0121
         STH   @10,SMF22LEN(,RECPTR)                            02S0121
*SMF22RTY=22;                          /* SET RECORD TYPE - 22@Y02651*/
         MVI   SMF22RTY(RECPTR),X'16'                           02S0122
*SMF22IND=1;                           /* INDICATE IPL TIME   @Y02651*/
         LA    @15,1                                            02S0123
         STH   @15,SMF22IND(,RECPTR)                            02S0123
*SMF22ECT=0;                           /* INDICATE NO ENTRIES   02S0124
*                                         IN RECORD YET       @Y02651*/
         SLR   @14,@14                                          02S0124
         STH   @14,SMF22ECT(,RECPTR)                            02S0124
*ELEMTPTR=ADDR(SMFRCD22)+LENGTH(SMFRCD22); /* FIRST ELEMENT   @Y02651*/
         ALR   @10,RECPTR                                       02S0125
         LR    ELEMTPTR,@10                                     02S0125
*DO CPUIDX=1 TO DIM(PCCAT00P);         /* CONSTRUCT CPU AND     02S0126
*                                         CHANNEL ELEMENTS    @Y02651*/
         LR    CPUIDX,@15                                       02S0126
@DL00126 DS    0H                                               02S0127
*  IF PCCAT00P(CPUIDX)^=0 THEN         /* CPU ONLINE, THEN    @Y02651*/
         LR    @10,CPUIDX                                       02S0127
         SLA   @10,2                                            02S0127
         L     @07,@PC00001+4                                   02S0127
         L     @07,CVTPTR(,@07)                                 02S0127
         L     @07,CVTPCCAT(,@07)                               02S0127
         AL    @07,@CF01800                                     02S0127
         L     @10,PCCAT00P(@10,@07)                            02S0127
         LTR   @10,@10                                          02S0127
         BZ    @RF00127                                         02S0127
*    DO;                               /* CONSTRUCT CPU ELEMNT@Y02651*/
*      RFY SMF22CPU BASED(ELEMTPTR);   /* ADDR OF CPU ENTRY   @Y02651*/
*      SMF22CPU=SMF22CPU&&SMF22CPU;    /* INITIALIZE ELEMNT 0S@Y02651*/
         XC    SMF22CPU(6,ELEMTPTR),SMF22CPU(ELEMTPTR)          02S0130
*      SMF22PID=1;                     /* INDICATE CPU ELEMENT@Y02651*/
         MVI   SMF22PID(ELEMTPTR),X'01'                         02S0131
*      PACKFLD1=PCCACPID(10:12);       /* GET CPU MODULE #    @Y02651*/
         MVI   PACKFLD1+3,C' '                                  02S0132
         MVC   PACKFLD1(3),PCCACPID+9(@10)                      02S0132
*      PACK(PACKFLD2,PACKFLD1);        /* CONVERT CPU MODULE NUMBER
*                                         FROM EBCDIC TO PACKE@Y02651*/
         PACK  PACKFLD2(3),PACKFLD1(4)                          02S0133
*      SMF22CPN=PACKFLD2(1:2);         /* AND MOVE TO RECORD  @Y02651*/
         MVC   SMF22CPN(2,ELEMTPTR),PACKFLD2                    02S0134
*      R22TEMP=CPUIDX-1;               /* CALCULATE CPU ADDRES@Y02651*/
         LR    R22TEMP,CPUIDX                                   02S0135
         BCTR  R22TEMP,0                                        02S0135
*      SMF22CPA=R22TEMP;               /* CPU ADDRESS TO REC  @Y02651*/
         STC   R22TEMP,SMF22CPA(,ELEMTPTR)                      02S0136
*      SMF22ECT=SMF22ECT+1;            /* UPDATE ELEMENT COUNT@Y02651*/
         LA    @07,1                                            02S0137
         LH    @02,SMF22ECT(,RECPTR)                            02S0137
         ALR   @02,@07                                          02S0137
         STH   @02,SMF22ECT(,RECPTR)                            02S0137
*      SMF22LEN=SMF22LEN+LENGTH(SMF22CPU); /* INCR RECORD LEN @Y02651*/
         LA    @02,6                                            02S0138
         LH    @15,SMF22LEN(,RECPTR)                            02S0138
         ALR   @15,@02                                          02S0138
         STH   @15,SMF22LEN(,RECPTR)                            02S0138
*      ELEMTPTR=ELEMTPTR+LENGTH(SMF22CPU); /* BUMP TO ADDRESS OF NEXT
*                                         ELEMNT ENTRY IN REC @Y02651*/
         ALR   ELEMTPTR,@02                                     02S0139
*      CATPTR=ADDR(PCCACAT(1));        /* ADDR FIRST CAT ENTRY@Y02651*/
         LA    CATPTR,PCCACAT(,@10)                             02S0140
*      DO CHLIDX=1 TO LENGTH(PCCACAT)/LENGTH(CAT);   /*       @Y02651*/
         LR    CHLIDX,@07                                       02S0141
@DL00141 DS    0H                                               02S0142
*        IF CATNOP='0'B &              /* IF CHANNEL OPERATIVE@Y02651*/
*           CATNGEN='0'B &             /* AND CHANNEL SYSGENED@Y02651*/
*           CATNCPU='0'B THEN          /* AND CHANNEL ON CPU, @Y02651*/
         TM    CATNOP(CATPTR),B'01110000'                       02S0142
         BNZ   @RF00142                                         02S0142
*          DO;                         /* BUILD CHANNEL ENTRY @Y02651*/
*            RFY SMF22CHL BASED(ELEMTPTR);/* ADDR CHAN ENTRY  @Y02651*/
*            SMF22CHL=SMF22CHL&&SMF22CHL;/*INIT ELEMENT TO 0'S@Y02651*/
         XC    SMF22CHL(6,ELEMTPTR),SMF22CHL(ELEMTPTR)          02S0145
*            SMF22CID=2;               /* CHANNEL ENTRY       @Y02651*/
         MVI   SMF22CID(ELEMTPTR),X'02'                         02S0146
*            IF CATNID='0'B THEN       /* IF CHANNEL ID OK    @Y02651*/
         TM    CATNID(CATPTR),B'00001000'                       02S0147
         BNZ   @RF00147                                         02S0147
*              SMF22CHN=CATCHID(1:2);  /* SET CHANNEL TYPE &    02S0148
*                                         AND MODEL NUMBER    @Y02651*/
         MVC   SMF22CHN(2,ELEMTPTR),CATCHID(CATPTR)             02S0148
*            R22TEMP=CHLIDX-1;         /* CALCULATE CHAN ADDR @Y02651*/
@RF00147 LR    R22TEMP,CHLIDX                                   02S0149
         BCTR  R22TEMP,0                                        02S0149
*            SMF22CHA=R22TEMP;         /* AND MOVE TO RECORD  @Y02651*/
         STC   R22TEMP,SMF22CHA(,ELEMTPTR)                      02S0150
*            R22TEMP=CPUIDX-1;         /* CALCULATE CPU ADDR  @Y02651*/
         LR    R22TEMP,CPUIDX                                   02S0151
         BCTR  R22TEMP,0                                        02S0151
*            SMF22CPD=R22TEMP;         /* AND MOVE TO RECORD  @Y02651*/
         STC   R22TEMP,SMF22CPD(,ELEMTPTR)                      02S0152
*            SMF22ECT=SMF22ECT+1;      /* UPDATE ELEMENT COUNT@Y02651*/
         LA    @10,1                                            02S0153
         AH    @10,SMF22ECT(,RECPTR)                            02S0153
         STH   @10,SMF22ECT(,RECPTR)                            02S0153
*            SMF22LEN=SMF22LEN+LENGTH(SMF22CHL); /* UPDATE RCD LENGTH*/
         LA    @10,6                                            02S0154
         LH    @09,SMF22LEN(,RECPTR)                            02S0154
         ALR   @09,@10                                          02S0154
         STH   @09,SMF22LEN(,RECPTR)                            02S0154
*            ELEMTPTR=ELEMTPTR+LENGTH(SMF22CHL); /* BUMP TO ADDR OF
*                                         NEXT ENTRY IN RCD   @Y02651*/
         ALR   ELEMTPTR,@10                                     02S0155
*          END;                        /*                     @Y02651*/
*        CATPTR=CATPTR+LENGTH(CAT);    /* ADDR NEXT CAT ENTRY @Y02651*/
@RF00142 AH    CATPTR,@CH00060                                  02S0157
*      END;                            /*                     @Y02651*/
         AH    CHLIDX,@CH00062                                  02S0158
         CH    CHLIDX,@CH00042                                  02S0158
         BNH   @DL00141                                         02S0158
*    END;                              /*                     @Y02651*/
*END;                                  /*                     @Y02651*/
@RF00127 AH    CPUIDX,@CH00062                                  02S0160
         CH    CPUIDX,@CH00042                                  02S0160
         BNH   @DL00126                                         02S0160
*/********************************************************************/
*/*                                                           @Y02651*/
*/*SEGMENT NAME= BLDRSTOR                                     @Y02651*/
*/*                                                           @Y02651*/
*/*DESCRIPTIVE NAME= BUILD STORAGE ELEMENTS FOR RECORD 22     @Y02651*/
*/*                                                           @Y02651*/
*/*FUNCTION=                                                  @Y02651*/
*/*  THIS SEGMENT BUILDS THE STORAGE ELEMENT PORTION          @Y02651*/
*/*  OF RECORD TYPE 22. THE STORAGE ELEMENT CONTAINS          @Y02651*/
*/*  INFORMATION PERTAINNING TO THE BEGINNING AND ENDING      @Y02651*/
*/*  PAGES OF AN ONLINE SECTION OF REAL CORE.                 @Y02651*/
*/*                                                           @Y02651*/
*/*  OPERATION=                                               @Y02651*/
*/*    STORAGE ELEMENTS FOR EACH CONTIGUOUS BLOCK OF ONLINE   @Y02651*/
*/*    STORAGE ARE CONSTRUCTED FROM INFORMATION RETURNED      @Y02651*/
*/*    BY REAL STORAGE MANAGEMENT (RSM) RECONFIGURATION       @Y02651*/
*/*    ROUTINE. A PARAMETER LIST CONTAINING ONE BYTE FOR EACH @Y02651*/
*/*    PAGE OF REAL STORAGE IS OBTAINED FOR RSM, USING THE CVT@Y02651*/
*/*    HIGHEST REAL CORE ADDRESS FIELD TO DETERMINE THE NUMBER@Y02651*/
*/*    REAL PAGES. RSM IS CALLED TO FILL IN THE PARAMETER LIST@Y02651*/
*/*    WITH INFORMATION ABOUT ALL REAL PAGES. UPON RETURN, THE@Y02651*/
*/*    PARAMETER LIST IS SCANNED TO FIND THE FIRST ONLINE PAGE@Y02651*/
*/*    AND THE NEXT OFFLINE PAGE. THIS DETERMINES THE RANGE OF@Y02651*/
*/*    A CONTIGUOUS BLOCK OF ONLINE STORAGE. THE RELATIVE     @Y02651*/
*/*    INDEX OF THE BYTE INDICATING ONLINE/OFFLINE IS USED    @Y02651*/
*/*    TO CALCULATE FIRST PAGE NUMBER AND NUMBER OF PAGES FOR @Y02651*/
*/*    THIS STORAGE ENTRY.                                    @Y02651*/
*/*    THE ABOVE SCAN IS REPEATED UNTIL ALL BYTES OR PAGES    @Y02651*/
*/*    HAVE BEEN PROCESSED.                                   @Y02651*/
*/*                                                           @Y02651*/
*/*ENTRY POINT= IN-LINE SEGMENT                               @Y02651*/
*/*  INPUT=                                                   @Y02651*/
*/*    ELEMTPR  - PONITER TO THE NEXT ELEMENT ENTRY IN REC 22 @Y02651*/
*/*    CVTEORM  - HIGHEST POSSIBLE REAL STORAGE ADDRESS       @Y02651*/
*/*    RSMSLST  - LIST OF BYTES SET UP BY RSM, DESCRIBING THE @Y02651*/
*/*               ONLINE/OFFLINE STATUS OF ALL REAL FRAMES    @Y02651*/
*/*                                                           @Y02651*/
*/*EXIT=                                                      @Y02651*/
*/*  CONDITION= NORMAL, STORAGE ELEMENTS HAVE BEEN CONSTRUCTED@Y02651*/
*/*  OUTPUT= THE STORAGE ELEMENTS HAVE BEEN ADDED TO RECORD 22@Y02651*/
*/*  RETURN CODE= NONE                                        @Y02651*/
*/*                                                           @Y02651*/
*/*  CONDITION= ERROR, NON-ZERO RETURN CODE FROM RSM (IEAVRFC)@Y02651*/
*/*  OUTPUT= NONE                                             @Y02651*/
*/*  RETURN CODE= NONE                                        @Y02651*/
*/*                                                           @Y02651*/
*/********************************************************************/
*RFY R1 RSTD;                          /* GET REGISTER CONTROL@Y02651*/
*R1=LENGTH(RSMLIST)+PVTLPFN/16+1;      /* LEN OF RSM PARM LIST@Y02651*/
         L     @10,@PC00001+4                                   03S0162
         L     @10,CVTPTR(,@10)                                 03S0162
         L     @10,CVTPVTP(,@10)                                03S0162
         SLR   R1,R1                                            03S0162
         ICM   R1,3,PVTLPFN(@10)                                03S0162
         SRL   R1,4                                             03S0162
         AH    R1,@CH01795                                      03S0162
*GEN(GETMAIN  R,SP=253,LV=(R1));       /* GET RSM PARM CORE   @Y02651*/
         GETMAIN  R,SP=253,LV=(R1)
*RSMPTR=R1;                            /* SAVE ADDR RSM LIST  @Y02651*/
         LR    RSMPTR,R1                                        03S0164
*RFY R1 UNRSTD;                        /* RELEASE REG CONTROL @Y02651*/
*RSMLIST=RSMLIST&&RSMLIST;             /* INIT RSM LIST TO 0'S@Y02651*/
         XC    RSMLIST(16,RSMPTR),RSMLIST(RSMPTR)               03S0166
*RSMNUBL=PVTLPFN/16+1;                 /* PROCESS ALL PAGES   @Y02651*/
         LA    @10,1                                            03S0167
         L     @02,@PC00001+4                                   03S0167
         L     @02,CVTPTR(,@02)                                 03S0167
         L     @02,CVTPVTP(,@02)                                03S0167
         SLR   @15,@15                                          03S0167
         ICM   @15,3,PVTLPFN(@02)                               03S0167
         SRL   @15,4                                            03S0167
         ALR   @15,@10                                          03S0167
         STH   @15,RSMNUBL(,RSMPTR)                             03S0167
*RSMOPLN='1'B;                         /* FRAME STATUS          03S0168
*                                         REQUESTED           @Y02651*/
         OI    RSMOPLN(RSMPTR),B'00001000'                      03S0168
*RSMSPTR=(ADDR(RSMSLST(1)));           /* ADDRESS OUTPUT LIST @Y02651*/
         LA    @02,RSMSLST(,RSMPTR)                             03S0169
         ST    @02,RSMSPTR(,RSMPTR)                             03S0169
*DO PAGEIDX=1 TO RSMNUBL;              /* INITIALIZE RSM LIST @Y02651*/
         LR    PAGEIDX,@10                                      03S0170
         B     @DE00170                                         03S0170
@DL00170 DS    0H                                               03S0171
*  RSMSLST(PAGEIDX)=RSMSLST(PAGEIDX)&&RSMSLST(PAGEIDX); /*    @Y02651*/
         LR    @10,RSMPTR                                       03S0171
         ALR   @10,PAGEIDX                                      03S0171
         XC    RSMSLST-1(1,@10),RSMSLST-1(@10)                  03S0171
*END;                                  /*                     @Y02651*/
         AH    PAGEIDX,@CH00062                                 03S0172
@DE00170 CH    PAGEIDX,RSMNUBL(,RSMPTR)                         03S0172
         BNH   @DL00170                                         03S0172
*RFY R1 RSTD;                          /* GET REGISTER CONTROL@Y02651*/
*R1=ADDR(RSMLIST);                     /* PARM LIST FOR RSM   @Y02651*/
         LR    R1,RSMPTR                                        03S0174
*CALL IEAVRCF;                         /* CALL RSM ROUTINE    @Y02651*/
         L     @10,@PC00001+4                                   03S0175
         L     @10,CVTPTR(,@10)                                 03S0175
         L     @10,CVTPVTP(,@10)                                03S0175
         L     @15,PVTPRCF(,@10)                                03S0175
         BALR  @14,@15                                          03S0175
*RFY R1 UNRSTD;                        /* RELEASE REG CONTROL @Y02651*/
*RFY R15 RSTD;                         /* GET REGISTER CONTROL@Y02651*/
*IF R15=0 THEN                         /* NO ERRORS FROM RSM, @Y02651*/
         LTR   R15,R15                                          03S0178
         BNZ   @RF00178                                         03S0178
*  DO;                                 /* CONSRTUCT STORAGE     03S0179
*                                         ELEMENTS            @Y02651*/
*    PAGEIDX=1;                        /* INIT PAGE INDEX     @Y02651*/
         LA    PAGEIDX,1                                        03S0180
*    DO WHILE(PAGEIDX<=RSMNUBL);       /* PROCESS ALL PAGES   @Y02651*/
         B     @DE00181                                         03S0181
@DL00181 DS    0H                                               03S0182
*      NUMPGS=0;                       /* INITIALIZE NUMBER OF  03S0182
*                                         OFFLINE PAGES       @Y02651*/
         SLR   NUMPGS,NUMPGS                                    03S0182
*      DO STRTPG = PAGEIDX TO RSMNUBL WHILE(RSMONLI(STRTPG)='1'B);   /*
*                                                             @Y02651*/
         LR    STRTPG,PAGEIDX                                   03S0183
         B     @DE00183                                         03S0183
@DL00183 LR    @14,RSMPTR                                       03S0183
         ALR   @14,STRTPG                                       03S0183
         TM    RSMONLI-1(@14),B'10000000'                       03S0183
         BNO   @DC00183                                         03S0183
*        NUMPGS=NUMPGS+1;              /* ANOTHER PAGE OFFLINE@Y02651*/
         AH    NUMPGS,@CH00062                                  03S0184
*      END;                            /*                     @Y02651*/
         AH    STRTPG,@CH00062                                  03S0185
@DE00183 CH    STRTPG,RSMNUBL(,RSMPTR)                          03S0185
         BNH   @DL00183                                         03S0185
@DC00183 DS    0H                                               03S0186
*      PAGEIDX=PAGEIDX+NUMPGS;         /* NEXT PAGE TO LOOK AT@Y02651*/
         ALR   PAGEIDX,NUMPGS                                   03S0186
*      IF PAGEIDX<=RSMNUBL THEN        /* CONSTRUCT ELEMENT   @Y02651*/
         CH    PAGEIDX,RSMNUBL(,RSMPTR)                         03S0187
         BH    @RF00187                                         03S0187
*        DO;                           /* IF ONLINE PAGE FOUND@Y02651*/
*          NUMPGS=0;                   /* INIT NUMBER OF ONLINE PAGES*/
         SLR   NUMPGS,NUMPGS                                    03S0189
*          DO ENDPG=PAGEIDX TO RSMNUBL WHILE(RSMONLI(ENDPG)^='1'B);
         LR    ENDPG,PAGEIDX                                    03S0190
         B     @DE00190                                         03S0190
@DL00190 LR    @14,RSMPTR                                       03S0190
         ALR   @14,ENDPG                                        03S0190
         TM    RSMONLI-1(@14),B'10000000'                       03S0190
         BO    @DC00190                                         03S0190
*            NUMPGS=NUMPGS+1;          /* ANOTHER PAGE ONLINE @Y02651*/
         AH    NUMPGS,@CH00062                                  03S0191
*          END;                        /*                     @Y02651*/
         AH    ENDPG,@CH00062                                   03S0192
@DE00190 CH    ENDPG,RSMNUBL(,RSMPTR)                           03S0192
         BNH   @DL00190                                         03S0192
@DC00190 DS    0H                                               03S0193
*          RFY SMF22STR BASED(ELEMTPTR); /* ADDR STORAGE ENTRY@Y02651*/
*          SMF22STR=SMF22STR&&SMF22STR; /* STORAGE ELEMENT 0'S@Y02651*/
         XC    SMF22STR(6,ELEMTPTR),SMF22STR(ELEMTPTR)          03S0194
*          SMF22TID=3;                 /* INDICATE STOR ELEMNT@Y02651*/
         MVI   SMF22TID(ELEMTPTR),X'03'                         03S0195
*          SMF22PGL=PAGEIDX-1;         /* PAGE NUMBER OF STARTING
*                                         PAGE (0 ORIGIN)     @Y02651*/
         LR    @14,PAGEIDX                                      03S0196
         BCTR  @14,0                                            03S0196
         STH   @14,SMF22PGL(,ELEMTPTR)                          03S0196
*          SMF22NPG=NUMPGS;            /* NUMBER PAGES ONLINE @Y02651*/
         STH   NUMPGS,SMF22NPG(,ELEMTPTR)                       03S0197
*          SMF22ECT=SMF22ECT+1;        /* UPDATE ELEMENT COUNT@Y02651*/
         LA    @14,1                                            03S0198
         AH    @14,SMF22ECT(,RECPTR)                            03S0198
         STH   @14,SMF22ECT(,RECPTR)                            03S0198
*          SMF22LEN=SMF22LEN+LENGTH(SMF22STR); /* INCREMENT RECORD
*                                         LENGTH              @Y02651*/
         LA    @14,6                                            03S0199
         LH    @10,SMF22LEN(,RECPTR)                            03S0199
         ALR   @10,@14                                          03S0199
         STH   @10,SMF22LEN(,RECPTR)                            03S0199
*          ELEMTPTR=ELEMTPTR+LENGTH(SMF22STR); /* BUMP TO ADDRESS OF
*                                         NEXT ELEMENT ENTRY  @Y02651*/
         ALR   ELEMTPTR,@14                                     03S0200
*          PAGEIDX=PAGEIDX+NUMPGS;     /* NEXT PAGE TO LOOK AT@Y02651*/
         ALR   PAGEIDX,NUMPGS                                   03S0201
*        END;                          /*                     @Y02651*/
*    END;                              /*                     @Y02651*/
@RF00187 DS    0H                                               03S0203
@DE00181 CH    PAGEIDX,RSMNUBL(,RSMPTR)                         03S0203
         BNH   @DL00181                                         03S0203
*  END;                                /*                     @Y02651*/
*RFY R15 UNRSTD;                       /* RELEASE REG CONTROL @Y02651*/
@RF00178 DS    0H                                               03S0206
*RFY (R1,R2) RSTD;                     /* GET REGISTER CONTROL@Y02651*/
*R2=RSMPTR;                            /* RSM PARAMETER AREA  @Y02651*/
         LR    R2,RSMPTR                                        03S0207
*R1=LENGTH(RSMLIST)+PVTLPFN/16+1;      /* LENGTH OF AREA      @Y02651*/
         L     @10,@PC00001+4                                   03S0208
         L     @10,CVTPTR(,@10)                                 03S0208
         L     @10,CVTPVTP(,@10)                                03S0208
         SLR   R1,R1                                            03S0208
         ICM   R1,3,PVTLPFN(@10)                                03S0208
         SRL   R1,4                                             03S0208
         AH    R1,@CH01795                                      03S0208
*GEN(FREEMAIN R,SP=253,LV=(R1),A=(R2));   /* FREE RSM AREA    @Y02651*/
         FREEMAIN R,SP=253,LV=(R1),A=(R2)
*RFY (R1,R2) UNRSTD;                   /* RELEASE REG CONTROL @Y02651*/
*RFY R1 RSTD;                          /* GET REGISTER CONTROL@Y02651*/
*R1=ADDR(SMFRCD22);                    /* GET ADDR OF SMF REC @Y02651*/
         LR    R1,RECPTR                                        02S0212
*GEN(SMFWTM (R1));                     /* ISSUE RECORD 22     @Y02651*/
         SMFWTM (R1)
*RFY R1 UNRSTD;                        /* RELEASE REG CONTROL @Y02651*/
*RFY (R1,R2) RSTD;                     /* GET REGISTER CONTROL       */
*R2=LENGTH(RECORD);                    /* LENGTH OF SMF RECORD       */
         LH    R2,@CH01791                                      01S0216
*R1=RECPTR;                            /* ADDRRESS OF SMF RECORD     */
         LR    R1,RECPTR                                        01S0217
*GEN(FREEMAIN R,SP=RECSBPL,LV=(R2),A=(R1)); /* FREE RECORD CORE      */
         FREEMAIN R,SP=RECSBPL,LV=(R2),A=(R1)
*RFY (R1,R2) UNRSTD;                   /* RELEASE REGISTER CONTROL   */
*END IEEMB823                                                   01S0220
*/* THE FOLLOWING INCLUDE STATEMENTS WERE FOUND IN THIS PROGRAM.      *
*/*%INCLUDE SYSLIB  (B823SPEC)                                        *
*/*%INCLUDE SYSLIB  (B823DATA)                                        *
*/*%INCLUDE SYSLIB  (CVT     )                                        *
*/*%INCLUDE SYSLIB  (IECDCAT )                                        *
*/*%INCLUDE SYSLIB  (IEESMCA )                                        *
*/*%INCLUDE SYSLIB  (IEFUCBOB)                                        *
*/*%INCLUDE SYSLIB  (IHAPVT  )                                        *
*/*%INCLUDE SYSLIB  (IHAPCCA )                                        *
*/*%INCLUDE SYSLIB  (IHAPCCAT)                                        *
*/*%INCLUDE SYSLIB  (IFASMFR )                                        *
*/*%INCLUDE SYSLIB  (IFASMFR1)                                        *
*/*%INCLUDE SYSLIB  (IFASMFR2)                                        *
*/*%INCLUDE SYSLIB  (IFASMFR3)                                        *
*/*%INCLUDE SYSLIB  (IFASMFR4)                                        *
*/*%INCLUDE SYSLIB  (IFASMFR5)                                        *
*/*%INCLUDE SYSLIB  (IFASMFR6)                                        *
*/*%INCLUDE SYSLIB  (IFASMFR7)                                        *
*/*%INCLUDE SYSLIB  (IFASMFR8)                                        *
*/*%INCLUDE SYSLIB  (IFASMFR9)                                        *
*/*%INCLUDE SYSLIB  (IFASMFRA)                                        *
*/*%INCLUDE SYSLIB  (IFASMFRB)                                        *
*/*%INCLUDE SYSLIB  (IFASMFRC)                                        *
*/*%INCLUDE SYSLIB  (IFASMFRD)                                        *
*/*%INCLUDE SYSLIB  (BLDREC0 )                                        *
*/*%INCLUDE SYSLIB  (BLDR0SPC)                                        *
*/*%INCLUDE SYSLIB  (BLDREC8 )                                        *
*/*%INCLUDE SYSLIB  (BLDR8SPC)                                        *
*/*%INCLUDE SYSLIB  (BLDREC22)                                        *
*/*%INCLUDE SYSLIB  (BLDR22SP)                                        *
*/*%INCLUDE SYSLIB  (BLDSTOR )                                        *
*/*%INCLUDE SYSLIB  (STRGSPC )                                        *
*;                                                              01S0220
@EL00001 L     @13,4(,@13)                                      01S0220
@EF00001 L     @00,@SIZDATD                                     01S0220
         LR    @01,@11                                          01S0220
         FREEMAIN R,LV=(0),A=(1)
@ER00001 LM    @14,@12,12(@13)                                  01S0220
         BR    @14                                              01S0220
@DATA    DS    0H
@CH00062 DC    H'1'
@CH00136 DC    H'2'
@CH00077 DC    H'4'
@CH00060 DC    H'8'
@CH00042 DC    H'16'
@CH01795 DC    H'17'
@CH01792 DC    H'35'
@CH01791 DC    H'8192'
@CH00040 DC    H'-1'
@DATD    DSECT
         DS    0F
@SA00001 DS    18F
@PC00001 DS    2F
IEEMB823 CSECT
         DS    0F
@CF01774 DC    F'1024'
@CF01800 DC    F'-4'
@CF01776 DC    XL4'0000FFFF'
@CF01779 DC    XL4'80000000'
@DATD    DSECT
         DS    0D
PVTPTR   DS    A
PCCAPTR  DS    A
BITSWTCH DS    BL1
         ORG   BITSWTCH
DUPBIT   DS    BL1
         ORG   BITSWTCH+1
PACKFLD1 DS    CL4
PACKFLD2 DS    CL3
IEEMB823 CSECT
         DS    0F
@SIZDATD DC    AL1(0)
         DC    AL3(@ENDDATD-@DATD)
         DS    0D
@CB00043 DC    X'2009'
IEEMB823 CSECT
         DS   0H
PATCH DC ((@DATA-@PSTART)/20)X'00'
@DATD    DSECT
         ORG   *+1-(*-@DATD)/(*-@DATD) INSURE DSECT DATA
@ENDDATD EQU   *
IEEMB823 CSECT
@00      EQU   00                      EQUATES FOR REGISTERS 0-15
@01      EQU   01
@02      EQU   02
@03      EQU   03
@04      EQU   04
@05      EQU   05
@06      EQU   06
@07      EQU   07
@08      EQU   08
@09      EQU   09
@10      EQU   10
@11      EQU   11
@12      EQU   12
@13      EQU   13
@14      EQU   14
@15      EQU   15
UCBINDX1 EQU   @08
UCBINDX  EQU   @05
STRTPG   EQU   @08
R22TEMP  EQU   @07
PAGEIDX  EQU   @06
NUMPGS   EQU   @07
ENDPG    EQU   @08
DVCINDX  EQU   @07
CPUIDX   EQU   @06
CHLIDX   EQU   @08
VARPTR   EQU   @06
UCBPTR   EQU   @03
RSMPTR   EQU   @03
RECPTR   EQU   @04
ELEMTPTR EQU   @05
CATPTR   EQU   @03
R0       EQU   @00
R1       EQU   @01
R2       EQU   @02
R15      EQU   @15
UCBTBL   EQU   0
IEAVRCF  EQU   0
RECORD   EQU   0
RDW      EQU   RECORD
RDWRES   EQU   RDW+2
SMFRCD   EQU   RECORD+4
COMHDR   EQU   SMFRCD
RSMLIST  EQU   0
RSMNUBL  EQU   RSMLIST+2
RSMOPTN  EQU   RSMLIST+4
RSMOPLN  EQU   RSMOPTN
RSMSPTR  EQU   RSMLIST+8
RSMEND   EQU   RSMLIST+16
CVTMAP   EQU   0
CVTILK2  EQU   CVTMAP+40
CVTDAR   EQU   CVTMAP+72
CVTFLGS1 EQU   CVTDAR
CVTDCB   EQU   CVTMAP+116
CVTIOQET EQU   CVTMAP+120
CVTIERLC EQU   CVTMAP+144
CVTHEAD  EQU   CVTMAP+160
CVTSV76C EQU   CVTHEAD
CVTMZ00  EQU   CVTMAP+164
CVTOPTA  EQU   CVTMAP+182
CVTOPTB  EQU   CVTMAP+183
CVTSMCA  EQU   CVTMAP+196
CVTGTF   EQU   CVTMAP+236
CVTGTFST EQU   CVTGTF
CVTGTFS  EQU   CVTGTFST
CVTSTATE EQU   CVTGTFST
CVTTMODE EQU   CVTGTFST
CVTFORM  EQU   CVTGTFST
CVTAQAVT EQU   CVTMAP+240
CVTTCMFG EQU   CVTAQAVT
CVTVOLM2 EQU   CVTMAP+244
CVTTATA  EQU   CVTVOLM2
CVTTSKS  EQU   CVTTATA
CVTVOLF2 EQU   CVTTSKS
CVTTAT   EQU   CVTTATA+1
CVTATER  EQU   CVTMAP+248
CVTEXT1  EQU   CVTMAP+252
CVTPURG  EQU   CVTMAP+260
CVTQMSG  EQU   CVTMAP+268
CVTDMSR  EQU   CVTMAP+272
CVTRSV37 EQU   CVTDMSR
CVTDMSRF EQU   CVTRSV37
CVTERPV  EQU   CVTMAP+316
CVTINTLA EQU   CVTMAP+320
CVTAPF   EQU   CVTMAP+324
CVTEXT2  EQU   CVTMAP+328
CVTHJES  EQU   CVTMAP+332
CVTPGSIA EQU   CVTMAP+348
CVTA1F1  EQU   CVTMAP+356
CVTSYSK  EQU   CVTMAP+357
CVTVOLM1 EQU   CVTMAP+380
CVTVOLF1 EQU   CVTVOLM1
CVTATMCT EQU   CVTMAP+388
CVTXTNT1 EQU   0
CVTXTNT2 EQU   0
CVTDSSV  EQU   CVTXTNT2
CVTFLGBT EQU   CVTXTNT2+5
CVTQID   EQU   CVTXTNT2+24
CVTRV400 EQU   CVTXTNT2+52
CVTRV409 EQU   CVTXTNT2+53
CVTATCVT EQU   CVTXTNT2+64
CVTRV429 EQU   CVTXTNT2+84
CVTRV438 EQU   CVTXTNT2+85
CVTRV457 EQU   CVTXTNT2+112
CVTRV466 EQU   CVTXTNT2+113
CVTFIX   EQU   0
CVTRELNO EQU   CVTFIX+252
CAT      EQU   0
CATENTRY EQU   CAT
CATFLG   EQU   CATENTRY
CATNOP   EQU   CATFLG
CATNGEN  EQU   CATFLG
CATNCPU  EQU   CATFLG
CATNID   EQU   CATFLG
CATFLA   EQU   CAT+1
CATCHID  EQU   CAT+4
SMCABASE EQU   0
SMCAOPT  EQU   SMCABASE
SMCAVOL  EQU   SMCAOPT
SMCAMISC EQU   SMCABASE+1
SMCABUF  EQU   SMCABASE+12
SMCABSIZ EQU   SMCABUF
SMCAPSTA EQU   SMCABASE+30
SMCAPLBL EQU   SMCABASE+34
SMCASTA  EQU   SMCABASE+46
SMCAALBL EQU   SMCABASE+50
SMCAENTY EQU   SMCABASE+80
SMCAENDI EQU   SMCAENTY
SMCAFOPT EQU   SMCABASE+82
SMCASWA  EQU   SMCABASE+104
SMCAASCB EQU   SMCABASE+120
SMCAPGIN EQU   SMCABASE+136
SMCAPGOT EQU   SMCABASE+140
UCB      EQU   0
UCBOB    EQU   0
UCBJBNR  EQU   UCBOB
UCBFL5   EQU   UCBOB+1
UCBAF    EQU   UCBFL5
UCBALTPH EQU   UCBFL5
UCBSTAT  EQU   UCBOB+3
UCBONLI  EQU   UCBSTAT
UCBCHAN  EQU   UCBOB+4
UCBSFLS  EQU   UCBOB+6
UCBFLA   EQU   UCBSFLS
UCBFL1   EQU   UCBFLA
UCBBSY   EQU   UCBFL1
UCBNRY   EQU   UCBFL1
UCBNOTRD EQU   UCBNRY
UCBPST   EQU   UCBFL1
UCBCUB   EQU   UCBFL1
UCBFLB   EQU   UCBSFLS+1
UCBCHM   EQU   UCBOB+8
UCBCHM1  EQU   UCBCHM
UCBPTH0  EQU   UCBCHM1
UCBPTH1  EQU   UCBCHM1
UCBWGT   EQU   UCBOB+12
UCBTYP   EQU   UCBOB+16
UCBTBYT1 EQU   UCBTYP
UCB1FEA5 EQU   UCBTBYT1
UCB1FEA6 EQU   UCBTBYT1
UCBTBYT2 EQU   UCBTYP+1
UCB2OPT2 EQU   UCBTBYT2
UCBDUDN1 EQU   UCB2OPT2
UCB2OPT3 EQU   UCBTBYT2
UCBDUDN2 EQU   UCB2OPT3
UCB2OPT4 EQU   UCBTBYT2
UCBRWTAU EQU   UCB2OPT4
UCBRVDEV EQU   UCBRWTAU
UCB2OPT6 EQU   UCBTBYT2
UCB2OPT7 EQU   UCBTBYT2
UCBTBYT3 EQU   UCBTYP+2
UCBDVCLS EQU   UCBTBYT3
UCB3DACC EQU   UCBDVCLS
UCBTBYT4 EQU   UCBTYP+3
UCBEXTPT EQU   UCBOB+20
UCBFLC   EQU   UCBEXTPT
UCBDEV   EQU   UCBOB+24
UCBCMEXT EQU   0
UCBATI   EQU   UCBCMEXT+3
@NM00009 EQU   UCBATI
UCBFLP1  EQU   UCBCMEXT+5
UCBMT    EQU   0
UCBOCR   EQU   0
UCB3540X EQU   0
UCBDKBYT EQU   UCB3540X+6
UCB3800X EQU   0
UCBOPTNS EQU   UCB3800X
UCBACTIV EQU   UCB3800X+3
UCBMDRBF EQU   UCB3800X+36
UCBUCS   EQU   0
UCBUCSOP EQU   UCBUCS+4
UCBFCBOP EQU   UCBUCS+5
PVT      EQU   0
PVTFLAG1 EQU   PVT
PVTFLAG2 EQU   PVT+1
PVTLPFN  EQU   PVT+18
PVTPRCF  EQU   PVT+148
PVTQS    EQU   PVT+304
PVTWSAX  EQU   PVT+344
PCCA     EQU   0
PCCACPID EQU   PCCA+4
PCCATMST EQU   PCCA+128
PCCATMFL EQU   PCCATMST
PCCATODE EQU   PCCATMST+1
PCCACCE  EQU   PCCATMST+2
PCCAINTE EQU   PCCATMST+3
PCCAEMSB EQU   PCCA+136
PCCAEMSI EQU   PCCAEMSB
PCCARISP EQU   PCCAEMSI
PCCAEMS2 EQU   PCCAEMSI+1
PCCAEMS3 EQU   PCCAEMSI+2
PCCARMSB EQU   PCCAEMSI+3
PCCAWERP EQU   PCCA+280
PCCACHPF EQU   PCCAWERP+4
PCCACHBL EQU   PCCAWERP+5
PCCACHVA EQU   PCCAWERP+6
PCCACHTS EQU   PCCAWERP+7
PCCACHS1 EQU   PCCA+288
PCCACHS2 EQU   PCCA+289
PCCACHRB EQU   PCCA+290
PCCACHF1 EQU   PCCA+308
PCCACHF2 EQU   PCCA+309
PCCACHF3 EQU   PCCA+310
PCCACHF4 EQU   PCCA+311
PCCACAT  EQU   PCCA+384
PCCAVT   EQU   0
PCCAT00P EQU   PCCAVT
SMFRCD00 EQU   0
SMF0LEN  EQU   SMFRCD00
SMF0RTY  EQU   SMFRCD00+5
SMF0JWT  EQU   SMFRCD00+18
SMF0BUF  EQU   SMFRCD00+22
SMF0VST  EQU   SMFRCD00+26
SMF0OPT  EQU   SMFRCD00+30
SMF0RST  EQU   SMFRCD00+31
SMFRCD08 EQU   0
SMF8LEN  EQU   SMFRCD08
SMF8RTY  EQU   SMFRCD08+5
SMF8LENN EQU   SMFRCD08+18
SMF8IODV EQU   0
SMF8DUT  EQU   SMF8IODV
SMF8CHA  EQU   SMF8IODV+2
SMF8VDV  EQU   SMF8CHA
SMFRCD22 EQU   0
SMF22LEN EQU   SMFRCD22
SMF22RTY EQU   SMFRCD22+5
SMF22IND EQU   SMFRCD22+18
SMF22ECT EQU   SMFRCD22+20
SMF22CPU EQU   0
SMF22PID EQU   SMF22CPU+1
SMF22CPN EQU   SMF22CPU+2
SMF22CPA EQU   SMF22CPU+5
SMF22CHL EQU   0
SMF22CID EQU   SMF22CHL+1
SMF22CHN EQU   SMF22CHL+2
SMF22CHA EQU   SMF22CHL+4
SMF22CPD EQU   SMF22CHL+5
SMF22STR EQU   0
SMF22TID EQU   SMF22STR+1
SMF22PGL EQU   SMF22STR+2
SMF22NPG EQU   SMF22STR+4
SMF22IPL EQU   0
SMF22VON EQU   0
SMF22VOF EQU   0
UCBBGN   EQU   0
JWTMIN   EQU   0
CVTPTR   EQU   0
RSMSLST  EQU   RSMEND
RSMONLI  EQU   RSMSLST
CVTS01   EQU   CVTPGSIA
CVTPVTP  EQU   CVTS01+8
CVTLPDIA EQU   CVTS01+12
CVTDIRST EQU   CVTLPDIA
CVTSLIDA EQU   CVTS01+24
CVTCTLFG EQU   CVTS01+50
CVTPCCAT EQU   CVTS01+416
CVTRV210 EQU   CVTS01+424
CVTRV219 EQU   CVTS01+425
CVTRV228 EQU   CVTS01+426
CVTRV237 EQU   CVTS01+427
CVTMFRTR EQU   CVTS01+452
CVTRV262 EQU   CVTS01+468
CVTRV271 EQU   CVTS01+469
CVTRV280 EQU   CVTS01+470
CVTRV289 EQU   CVTS01+471
CVTRLSTG EQU   CVTS01+508
CVTGSDA  EQU   CVTS01+600
UCBOBS01 EQU   UCBDEV
UCBSTAB  EQU   UCBOBS01+10
UCBBSVL  EQU   UCBSTAB
UCBPRSRS EQU   UCBSTAB
UCBDMCT  EQU   UCBOBS01+11
UCBFL4   EQU   UCBOBS01+13
UCBOBS02 EQU   UCBDEV
UCBTFL1  EQU   UCBOBS02+19
UCBXTN   EQU   UCBOBS02+20
UCBVOPT  EQU   UCBXTN
UCBOBS03 EQU   UCBDEV
UCBXTADR EQU   UCBOBS03
UCBOBS04 EQU   UCBDEV
UCBBTA   EQU   UCBOBS04+12
UCBOBS06 EQU   UCBDEV
UCBAOF   EQU   UCBOBS06
UCBAOF1  EQU   UCBAOF
UCBAOF2  EQU   UCBAOF+1
@NM00008 EQU   UCBOBS06+3
UCBIRB   EQU   UCBOBS06+4
UCBGRAF  EQU   UCBIRB
UCBLDNCA EQU   UCBOBS06+8
UCBRDYQ  EQU   UCBLDNCA
UCBIRLN  EQU   UCBRDYQ
UCBLDNCB EQU   UCBRDYQ+1
UCBCTLNK EQU   UCBOBS06+12
UCBOBS07 EQU   UCBDEV
UCBOBS08 EQU   UCBDEV
UCBCTCAD EQU   UCBOBS08
UCBCTCF1 EQU   UCBOBS08+4
UCBOBS09 EQU   UCBDEV
         AGO   .@UNREFD                START UNREFERENCED COMPONENTS
UCBRV066 EQU   UCBOBS09+4
UCBIOSBA EQU   UCBOBS09
UCBRV042 EQU   UCBOBS08+5
UCBRV082 EQU   UCBCTCF1
UCBRV081 EQU   UCBCTCF1
UCBRV080 EQU   UCBCTCF1
UCBRV079 EQU   UCBCTCF1
UCBRV078 EQU   UCBCTCF1
UCBRV077 EQU   UCBCTCF1
UCBRV076 EQU   UCBCTCF1
UCBCTC80 EQU   UCBCTCF1
UCBCTCAL EQU   UCBCTCAD
UCBICNCB EQU   UCBOBS07+4
UCBRV040 EQU   UCBOBS07
UCBCTLNA EQU   UCBCTLNK+1
UCBRLN   EQU   UCBCTLNK
UCBRDYQA EQU   UCBLDNCB
UCBINRLN EQU   UCBIRLN
UCBIRBA  EQU   UCBIRB+1
UCBRV039 EQU   UCBGRAF
UCBDWNR  EQU   UCBGRAF
UCBRPND  EQU   UCBGRAF
UCBUPM   EQU   UCBGRAF
UCBBTAM  EQU   UCBGRAF
UCBDRNO  EQU   UCBGRAF
UCBDRO   EQU   UCBGRAF
UCBOIP   EQU   UCBGRAF
UCBATRCD EQU   @NM00008
UCBSKPFG EQU   @NM00008
UCBRIPND EQU   @NM00008
UCBRTIAC EQU   @NM00008
UCBRSV79 EQU   @NM00008
UCBRSV78 EQU   @NM00008
UCBRSV77 EQU   @NM00008
UCBOLTEP EQU   @NM00008
UCBATNCT EQU   UCBOBS06+2
UCBRSV76 EQU   UCBAOF2
UCBRSV75 EQU   UCBAOF2
UCBRSV74 EQU   UCBAOF2
UCBRSV73 EQU   UCBAOF2
UCBRSV72 EQU   UCBAOF2
UCBRSV71 EQU   UCBAOF2
UCBRSV70 EQU   UCBAOF2
UCBRSV69 EQU   UCBAOF2
UCBRSV68 EQU   UCBAOF1
UCBRSV67 EQU   UCBAOF1
UCBRSV66 EQU   UCBAOF1
UCBRSV65 EQU   UCBAOF1
UCBRSV64 EQU   UCBAOF1
UCBOFNL  EQU   UCBAOF1
UCBOFSP  EQU   UCBAOF1
UCBOFMCR EQU   UCBAOF1
UCBBTB   EQU   UCBBTA+1
UCBDI    EQU   UCBBTA
UCBSNS   EQU   UCBOBS04+8
UCBTEB   EQU   UCBOBS04+4
UCBGCB   EQU   UCBOBS04+3
UCBOPEN  EQU   UCBOBS04+2
UCBSTART EQU   UCBOBS04
UCBXTNB  EQU   UCBXTN+1
UCBRSV22 EQU   UCBVOPT
UCBRSV21 EQU   UCBVOPT
UCBRSV20 EQU   UCBVOPT
UCBESVE  EQU   UCBVOPT
UCBERPC  EQU   UCBVOPT
UCBESVC  EQU   UCBVOPT
UCBEVA   EQU   UCBVOPT
UCBESV   EQU   UCBVOPT
UCBRV009 EQU   UCBTFL1
UCBRV008 EQU   UCBTFL1
UCBRV007 EQU   UCBTFL1
UCBRV006 EQU   UCBTFL1
UCBRV005 EQU   UCBTFL1
UCBDQDSP EQU   UCBTFL1
UCBNSLTP EQU   UCBTFL1
UCBNLTP  EQU   UCBTFL1
UCBRES1B EQU   UCBOBS02+18
UCBFSER  EQU   UCBOBS02+12
@NM00007 EQU   UCBOBS02+4
UCBFSEQ  EQU   UCBOBS02+2
UCBFSCT  EQU   UCBOBS02
UCBNEXP  EQU   UCBOBS01+20
UCBBASE  EQU   UCBOBS01+16
UCBRES1A EQU   UCBOBS01+15
UCBUSER  EQU   UCBOBS01+14
UCBFL47  EQU   UCBFL4
UCBFL46  EQU   UCBFL4
UCBFL45  EQU   UCBFL4
UCBRV065 EQU   UCBFL4
UCBDSS   EQU   UCBFL4
UCBRESVP EQU   UCBFL4
UCBWDAV  EQU   UCBFL4
UCBDAVV  EQU   UCBFL4
UCBSQC   EQU   UCBOBS01+12
UCBDATP  EQU   UCBOBS01+12
UCBDMC   EQU   UCBDMCT
UCBMOUNT EQU   UCBDMCT
UCBBNUL  EQU   UCBSTAB
UCBSHAR  EQU   UCBSTAB
UCBBSTR  EQU   UCBSTAB
UCBBPUB  EQU   UCBSTAB
UCBBPRV  EQU   UCBSTAB
UCBBALB  EQU   UCBPRSRS
UCBPGFL  EQU   UCBSTAB
UCBDVSHR EQU   UCBBSVL
UCBVOLI  EQU   UCBOBS01+4
UCBVTOC  EQU   UCBOBS01
CVTRV628 EQU   CVTS01+728
CVTRV627 EQU   CVTS01+724
CVTRV626 EQU   CVTS01+720
CVTRV625 EQU   CVTS01+716
CVTRV624 EQU   CVTS01+712
CVTRV623 EQU   CVTS01+708
CVTRV622 EQU   CVTS01+704
CVTRV621 EQU   CVTS01+700
CVTIHASU EQU   CVTS01+696
CVTSUSP  EQU   CVTS01+692
CVTT6SVC EQU   CVTS01+688
CVTCDAL  EQU   CVTS01+684
CVTTCTL  EQU   CVTS01+680
CVTRSUME EQU   CVTS01+676
CVTJTERM EQU   CVTS01+672
CVTASMRM EQU   CVTS01+668
CVTTCASP EQU   CVTS01+664
CVT0PT03 EQU   CVTS01+660
CVT0PT0E EQU   CVTS01+656
CVTRV609 EQU   CVTS01+652
CVTCGK   EQU   CVTS01+648
CVTRAC   EQU   CVTS01+644
CVTHSM   EQU   CVTS01+640
CVTRV605 EQU   CVTS01+636
CVTRV604 EQU   CVTS01+632
CVTEFF02 EQU   CVTS01+628
CVTCBBR  EQU   CVTS01+624
CVTSSCR  EQU   CVTS01+620
CVTEVENT EQU   CVTS01+616
CVTCRCA  EQU   CVTS01+612
CVTTPIO  EQU   CVTS01+608
CVTADV   EQU   CVTS01+604
CVTGSDAB EQU   CVTGSDA
CVTQV3   EQU   CVTS01+596
CVTQV2   EQU   CVTS01+592
CVTQV1   EQU   CVTS01+588
CVTRPT   EQU   CVTS01+584
CVTSSRB  EQU   CVTS01+580
CVTCSDRL EQU   CVTS01+576
CVTEXP1  EQU   CVTS01+572
CVTRMPMT EQU   CVTS01+568
CVTRMPTT EQU   CVTS01+564
CVTVPSA  EQU   CVTS01+560
CVTVSTOP EQU   CVTS01+556
CVTGTFR8 EQU   CVTS01+552
CVTQUIT  EQU   CVTS01+548
CVTVACR  EQU   CVTS01+544
CVTWTCB  EQU   CVTS01+540
CVTSTPRS EQU   CVTS01+536
CVT0PT02 EQU   CVTS01+532
CVTDARCM EQU   CVTS01+528
CVTIRECM EQU   CVTS01+524
CVTJRECM EQU   CVTS01+520
CVTVEMS0 EQU   CVTS01+516
CVTSPFRR EQU   CVTS01+512
CVT0TC0A EQU   CVTS01+504
CVTGMBR  EQU   CVTS01+500
CVTLFRM  EQU   CVTS01+496
CVTRMBR  EQU   CVTS01+492
CVTVIOP  EQU   CVTS01+488
CVTRV307 EQU   CVTS01+486
CVTRV306 EQU   CVTS01+484
CVTRV305 EQU   CVTS01+482
CVTRV304 EQU   CVTS01+480
CVTRV303 EQU   CVTS01+478
CVTRV302 EQU   CVTS01+476
CVTTRCA  EQU   CVTS01+472
CVTRV297 EQU   CVTRV289
CVTRV296 EQU   CVTRV289
CVTRV295 EQU   CVTRV289
CVTRV294 EQU   CVTRV289
CVTRV293 EQU   CVTRV289
CVTRV292 EQU   CVTRV289
CVTRV291 EQU   CVTRV289
CVTRV290 EQU   CVTRV289
CVTRV288 EQU   CVTRV280
CVTRV287 EQU   CVTRV280
CVTRV286 EQU   CVTRV280
CVTRV285 EQU   CVTRV280
CVTRV284 EQU   CVTRV280
CVTRV283 EQU   CVTRV280
CVTRV282 EQU   CVTRV280
CVTRV281 EQU   CVTRV280
CVTRV279 EQU   CVTRV271
CVTRV278 EQU   CVTRV271
CVTRV277 EQU   CVTRV271
CVTRV276 EQU   CVTRV271
CVTRV275 EQU   CVTRV271
CVTRV274 EQU   CVTRV271
CVTRV273 EQU   CVTRV271
CVTRV272 EQU   CVTRV271
CVTRV270 EQU   CVTRV262
CVTRV269 EQU   CVTRV262
CVTRV268 EQU   CVTRV262
CVTRV267 EQU   CVTRV262
CVTRV266 EQU   CVTRV262
CVTRV265 EQU   CVTRV262
CVTRV264 EQU   CVTRV262
CVTRV263 EQU   CVTRV262
CVTVFP   EQU   CVTS01+464
CVTVSI   EQU   CVTS01+460
CVTVPSIB EQU   CVTS01+456
CVTMFACT EQU   CVTMFRTR
CVTMFCTL EQU   CVTS01+448
CVTPVBP  EQU   CVTS01+444
CVTPWI   EQU   CVTS01+440
CVTRV254 EQU   CVTS01+438
CVTRV253 EQU   CVTS01+436
CVTRV252 EQU   CVTS01+434
CVTRV251 EQU   CVTS01+433
CVTRV250 EQU   CVTS01+432
CVTRV249 EQU   CVTS01+431
CVTRV248 EQU   CVTS01+430
CVTRV247 EQU   CVTS01+429
CVTRV246 EQU   CVTS01+428
CVTRV245 EQU   CVTRV237
CVTRV244 EQU   CVTRV237
CVTRV243 EQU   CVTRV237
CVTRV242 EQU   CVTRV237
CVTRV241 EQU   CVTRV237
CVTRV240 EQU   CVTRV237
CVTRV239 EQU   CVTRV237
CVTRV238 EQU   CVTRV237
CVTRV236 EQU   CVTRV228
CVTRV235 EQU   CVTRV228
CVTRV234 EQU   CVTRV228
CVTRV233 EQU   CVTRV228
CVTRV232 EQU   CVTRV228
CVTRV231 EQU   CVTRV228
CVTRV230 EQU   CVTRV228
CVTRV229 EQU   CVTRV228
CVTRV227 EQU   CVTRV219
CVTRV226 EQU   CVTRV219
CVTRV225 EQU   CVTRV219
CVTRV224 EQU   CVTRV219
CVTRV223 EQU   CVTRV219
CVTRV222 EQU   CVTRV219
CVTRV221 EQU   CVTRV219
CVTRV220 EQU   CVTRV219
CVTRV218 EQU   CVTRV210
CVTRV217 EQU   CVTRV210
CVTRV216 EQU   CVTRV210
CVTRV215 EQU   CVTRV210
CVTRV214 EQU   CVTRV210
CVTRV213 EQU   CVTRV210
CVTRV212 EQU   CVTRV210
CVTRV211 EQU   CVTRV210
CVTLCCAT EQU   CVTS01+420
CVTIPCRP EQU   CVTS01+412
CVTIPCRI EQU   CVTS01+408
CVTIPCDS EQU   CVTS01+404
CVTAIDVT EQU   CVTS01+400
CVTSSAP  EQU   CVTS01+396
CVTEHCIR EQU   CVTS01+392
CVTEHDEF EQU   CVTS01+388
CVTDAIR  EQU   CVTS01+384
CVTPERFM EQU   CVTS01+380
CVT044R2 EQU   CVTS01+376
CVTFETCH EQU   CVTS01+372
CVTRSTWD EQU   CVTS01+368
CVTSPOST EQU   CVTS01+364
CVTIOBP  EQU   CVTS01+360
CVTASMVT EQU   CVTS01+356
CVTRECRQ EQU   CVTS01+352
CVTWSAC  EQU   CVTS01+348
CVTRV149 EQU   CVTS01+344
CVTWSAL  EQU   CVTS01+340
CVTSPSA  EQU   CVTS01+336
CVTGLMN  EQU   CVTS01+332
CVTVEAC0 EQU   CVTS01+328
CVT062R1 EQU   CVTS01+324
CVTRPOST EQU   CVTS01+320
CVTDQIQE EQU   CVTS01+316
CVTCSD   EQU   CVTS01+312
CVTLKRMA EQU   CVTS01+308
CVTRSPIE EQU   CVTS01+304
CVTRENQ  EQU   CVTS01+300
CVTLQCB  EQU   CVTS01+296
CVTFQCB  EQU   CVTS01+292
CVTQCS01 EQU   CVTS01+288
CVTAPFT  EQU   CVTS01+284
CVTPARRL EQU   CVTS01+280
CVTVWAIT EQU   CVTS01+276
CVTGSPL  EQU   CVTS01+272
CVTLSMQ  EQU   CVTS01+268
CVTGSMQ  EQU   CVTS01+264
CVTEXPRO EQU   CVTS01+260
CVTOPCTP EQU   CVTS01+256
CVTSIC   EQU   CVTS01+252
CVTTPIOS EQU   CVTS01+248
CVTRTMS  EQU   CVTS01+244
CVTSDBF  EQU   CVTS01+240
CVTSCBP  EQU   CVTS01+236
CVTSDMP  EQU   CVTS01+232
CVTSV60  EQU   CVTS01+228
CVTRTMCT EQU   CVTS01+224
CVTASCBL EQU   CVTS01+220
CVTASCBH EQU   CVTS01+216
CVTGDA   EQU   CVTS01+212
CVTASVT  EQU   CVTS01+208
CVTVVMDI EQU   CVTS01+204
CVTAQTOP EQU   CVTS01+200
CVTIOSCS EQU   CVTS01+196
CVTSDRM  EQU   CVTS01+192
CVTOPTE  EQU   CVTS01+188
CVTSTXU  EQU   CVTS01+184
CVTQUIS  EQU   CVTS01+180
CVTPARS  EQU   CVTS01+176
CVTS1EE  EQU   CVTS01+172
CVTFRAS  EQU   CVTS01+168
CVTQSAS  EQU   CVTS01+164
CVTCRAS  EQU   CVTS01+160
CVTCRMN  EQU   CVTS01+156
CVTDELCP EQU   CVTS01+152
CVTFRECL EQU   CVTS01+148
CVTGETCL EQU   CVTS01+144
CVTBLDCP EQU   CVTS01+140
CVTAUTHL EQU   CVTS01+136
CVTSCAN  EQU   CVTS01+132
CVTRV144 EQU   CVTS01+130
CVTMAXMP EQU   CVTS01+128
CVTSTCK  EQU   CVTS01+124
CVTRV139 EQU   CVTS01+123
CVTDSSAC EQU   CVTS01+122
CVTRV513 EQU   CVTS01+121
CVTIOSPL EQU   CVTS01+120
CVTPTGT  EQU   CVTS01+116
CVTCSPIE EQU   CVTS01+112
CVTSMFEX EQU   CVTS01+108
CVTOLT0A EQU   CVTS01+104
CVTSRBRT EQU   CVTS01+100
CVTPUTL  EQU   CVTS01+96
CVTASCRL EQU   CVTS01+92
CVTASCRF EQU   CVTS01+88
CVTRV326 EQU   CVTS01+84
CVTRV325 EQU   CVTS01+80
CVTRV324 EQU   CVTS01+76
CVT0VL01 EQU   CVTS01+72
CVTSHRVM EQU   CVTS01+68
CVTRV332 EQU   CVTS01+64
CVTTAS   EQU   CVTS01+60
CVTRSCN  EQU   CVTS01+56
CVTTRAC2 EQU   CVTS01+54
CVTTRACE EQU   CVTS01+52
CVTAPG   EQU   CVTS01+51
CVTSDTRC EQU   CVTCTLFG
CVTGTRCE EQU   CVTCTLFG
CVTNOMP  EQU   CVTCTLFG
CVTRSV79 EQU   CVTCTLFG
CVTDSTAT EQU   CVTCTLFG
CVTRSV78 EQU   CVTCTLFG
CVTRV333 EQU   CVTCTLFG
CVTRV323 EQU   CVTCTLFG
CVTSPVLK EQU   CVTS01+49
CVTRSV77 EQU   CVTS01+48
CVTRV331 EQU   CVTS01+44
CVTRV330 EQU   CVTS01+40
CVTRV329 EQU   CVTS01+36
CVTRV328 EQU   CVTS01+32
CVTRV322 EQU   CVTS01+28
CVTSLID  EQU   CVTSLIDA+1
CVTSYLK  EQU   CVTSLIDA
CVTRV321 EQU   CVTS01+20
CVTRV320 EQU   CVTS01+16
CVTLPDIR EQU   CVTLPDIA+1
CVTRSV69 EQU   CVTDIRST
CVTRSV68 EQU   CVTDIRST
CVTRSV67 EQU   CVTDIRST
CVTRSV66 EQU   CVTDIRST
CVTRSV65 EQU   CVTDIRST
CVTRSV64 EQU   CVTDIRST
CVTRSV63 EQU   CVTDIRST
CVTDICOM EQU   CVTDIRST
CVTLPDSR EQU   CVTS01+4
CVTGETL  EQU   CVTS01
RSMSRSV  EQU   RSMSLST
SMF22FSI EQU   SMF22VOF+3
SMF22RVB EQU   SMF22VOF+2
SMF22FID EQU   SMF22VOF+1
SMF22RV6 EQU   SMF22VOF
SMF22NSI EQU   SMF22VON+3
SMF22RVA EQU   SMF22VON+2
SMF22NID EQU   SMF22VON+1
SMF22RV5 EQU   SMF22VON
SMF22ION EQU   SMF22IPL+2
SMF22IID EQU   SMF22IPL+1
SMF22RV4 EQU   SMF22IPL
SMF22RV3 EQU   SMF22STR
SMF22RV2 EQU   SMF22CHL
SMF22RV1 EQU   SMF22CPU+4
SMF22RV0 EQU   SMF22CPU
SMF22SID EQU   SMFRCD22+14
SMF22DTE EQU   SMFRCD22+10
SMF22TME EQU   SMFRCD22+6
SMF22FLG EQU   SMFRCD22+4
SMF22SEG EQU   SMFRCD22+2
SMF8SID  EQU   SMFRCD08+14
SMF8DTE  EQU   SMFRCD08+10
SMF8TME  EQU   SMFRCD08+6
SMF8FLG  EQU   SMFRCD08+4
SMF8SEG  EQU   SMFRCD08+2
SMF0SID  EQU   SMFRCD00+14
SMF0DTE  EQU   SMFRCD00+10
SMF0TME  EQU   SMFRCD00+6
SMF0FLG  EQU   SMFRCD00+4
SMF0SEG  EQU   SMFRCD00+2
@NM00011 EQU   PCCA+512
PCCARV36 EQU   PCCA+380
PCCARV35 EQU   PCCA+378
PCCARV01 EQU   PCCA+377
PCCACPUM EQU   PCCA+376
PCCARV63 EQU   PCCA+372
PCCARV62 EQU   PCCA+368
PCCARV61 EQU   PCCA+364
PCCARV60 EQU   PCCA+360
PCCARV59 EQU   PCCA+356
PCCARV58 EQU   PCCA+352
PCCARV57 EQU   PCCA+348
PCCARV56 EQU   PCCA+344
PCCARV55 EQU   PCCA+340
PCCARV54 EQU   PCCA+336
PCCALOGA EQU   PCCA+332
PCCACHID EQU   PCCA+324
PCCACHSV EQU   PCCA+312
PCCARV79 EQU   PCCACHF4
PCCARV78 EQU   PCCACHF4
PCCARV77 EQU   PCCACHF4
PCCARV76 EQU   PCCACHF4
PCCARV75 EQU   PCCACHF4
PCCARV74 EQU   PCCACHF4
PCCARV73 EQU   PCCACHF4
PCCARV72 EQU   PCCACHF4
PCCARV71 EQU   PCCACHF3
PCCARV70 EQU   PCCACHF3
PCCARV69 EQU   PCCACHF3
PCCARV68 EQU   PCCACHF3
PCCARV67 EQU   PCCACHF3
PCCARV66 EQU   PCCACHF3
PCCARV65 EQU   PCCACHF3
PCCARV64 EQU   PCCACHF3
PCCACF28 EQU   PCCACHF2
PCCACF27 EQU   PCCACHF2
PCCACF26 EQU   PCCACHF2
PCCACF25 EQU   PCCACHF2
PCCACF24 EQU   PCCACHF2
PCCACF23 EQU   PCCACHF2
PCCACF22 EQU   PCCACHF2
PCCACF21 EQU   PCCACHF2
PCCACF18 EQU   PCCACHF1
PCCACF17 EQU   PCCACHF1
PCCACF16 EQU   PCCACHF1
PCCACF15 EQU   PCCACHF1
PCCACF14 EQU   PCCACHF1
PCCACF13 EQU   PCCACHF1
PCCACF12 EQU   PCCACHF1
PCCACF11 EQU   PCCACHF1
PCCARV05 EQU   PCCA+306
PCCACHPB EQU   PCCA+305
PCCALGP2 EQU   PCCA+304
PCCALGP1 EQU   PCCA+303
PCCALOGL EQU   PCCA+302
PCCARV80 EQU   PCCA+300
PCCACHW2 EQU   PCCA+296
PCCACHW1 EQU   PCCA+292
PCCAIOSI EQU   PCCA+291
PCCACNRB EQU   PCCACHRB
PCCACCVB EQU   PCCACHRB
PCCACSNB EQU   PCCACHRB
PCCARV52 EQU   PCCACHRB
PCCACHIB EQU   PCCACHRB
PCCACTIB EQU   PCCACHRB
PCCACINB EQU   PCCACHRB
PCCACSIB EQU   PCCACHRB
PCCARV51 EQU   PCCACHS2
PCCARV50 EQU   PCCACHS2
PCCACCRA EQU   PCCACHS2
PCCACURC EQU   PCCACHS2
PCCACNLG EQU   PCCACHS2
PCCACMOD EQU   PCCACHS2
PCCACALT EQU   PCCACHS2
PCCACIOR EQU   PCCACHS2
PCCARV47 EQU   PCCACHS1
PCCACUCB EQU   PCCACHS1
PCCACIBC EQU   PCCACHS1
PCCACAND EQU   PCCACHS1
PCCACNLS EQU   PCCACHS1
PCCACFRR EQU   PCCACHS1
PCCACNRE EQU   PCCACHS1
PCCACCMP EQU   PCCACHS1
PCCACSEQ EQU   PCCACHTS
PCCACDIN EQU   PCCACHTS
PCCARV44 EQU   PCCACHTS
PCCARV43 EQU   PCCACHTS
PCCACTEC EQU   PCCACHTS
PCCACDAV EQU   PCCACHVA
PCCACCHV EQU   PCCACHVA
PCCACCMD EQU   PCCACHVA
PCCACUNS EQU   PCCACHVA
PCCACSQV EQU   PCCACHVA
PCCARV42 EQU   PCCACHVA
PCCARV41 EQU   PCCACHVA
PCCACITF EQU   PCCACHVA
PCCARV40 EQU   PCCACHBL
PCCARV39 EQU   PCCACHBL
PCCARV38 EQU   PCCACHBL
PCCACCUE EQU   PCCACHBL
PCCACSTG EQU   PCCACHBL
PCCACSCU EQU   PCCACHBL
PCCACCHA EQU   PCCACHBL
PCCACCPU EQU   PCCACHBL
PCCACNOR EQU   PCCACHPF
PCCACCNT EQU   PCCACHPF
PCCACSNS EQU   PCCACHPF
PCCARV37 EQU   PCCACHPF
PCCACHIO EQU   PCCACHPF
PCCACTIO EQU   PCCACHPF
PCCACINT EQU   PCCACHPF
PCCACSIO EQU   PCCACHPF
PCCACHUB EQU   PCCAWERP
PCCACHEL EQU   PCCA+168
PCCALRBR EQU   PCCA+164
PCCALRBV EQU   PCCA+160
PCCAPWAR EQU   PCCA+156
PCCAPWAV EQU   PCCA+152
PCCAEMSA EQU   PCCAEMSB+12
PCCAEMSE EQU   PCCAEMSB+8
PCCAEMSP EQU   PCCAEMSB+4
PCCARMS  EQU   PCCARMSB
PCCARV34 EQU   PCCARMSB
PCCARV33 EQU   PCCARMSB
PCCARV32 EQU   PCCARMSB
PCCARV31 EQU   PCCARMSB
PCCARV30 EQU   PCCARMSB
PCCARV29 EQU   PCCARMSB
PCCARV28 EQU   PCCARMSB
PCCARV27 EQU   PCCAEMS3
PCCARV26 EQU   PCCAEMS3
PCCARV25 EQU   PCCAEMS3
PCCARV24 EQU   PCCAEMS3
PCCARV23 EQU   PCCAEMS3
PCCARV22 EQU   PCCAEMS3
PCCARV21 EQU   PCCAEMS3
PCCARV20 EQU   PCCAEMS3
PCCARV19 EQU   PCCAEMS2
PCCARV18 EQU   PCCAEMS2
PCCARV17 EQU   PCCAEMS2
PCCARV16 EQU   PCCAEMS2
PCCARV15 EQU   PCCAEMS2
PCCARV14 EQU   PCCAEMS2
PCCARV13 EQU   PCCAEMS2
PCCARV12 EQU   PCCAEMS2
PCCARV11 EQU   PCCARISP
PCCARV10 EQU   PCCARISP
PCCARV09 EQU   PCCARISP
PCCARV08 EQU   PCCARISP
PCCARV07 EQU   PCCARISP
PCCARV06 EQU   PCCARISP
PCCASERL EQU   PCCARISP
PCCAPARL EQU   PCCARISP
PCCARPB  EQU   PCCA+132
PCCACTIN EQU   PCCAINTE
PCCANFIN EQU   PCCAINTE
PCCANUIN EQU   PCCAINTE
PCCACTCC EQU   PCCACCE
PCCANFCC EQU   PCCACCE
PCCANUCC EQU   PCCACCE
PCCACTTD EQU   PCCATODE
PCCANFTD EQU   PCCATODE
PCCANUTD EQU   PCCATODE
PCCARV04 EQU   PCCATMFL
PCCARV03 EQU   PCCATMFL
PCCARV02 EQU   PCCATMFL
PCCAMINT EQU   PCCATMFL
PCCAMCC  EQU   PCCATMFL
PCCAVKIL EQU   PCCATMFL
PCCASYNC EQU   PCCATMFL
PCCAINIT EQU   PCCATMFL
PCCARV9E EQU   PCCA+124
PCCARV9D EQU   PCCA+120
PCCARV9C EQU   PCCA+116
PCCARV9B EQU   PCCA+112
PCCARV9A EQU   PCCA+108
PCCARV99 EQU   PCCA+104
PCCARV98 EQU   PCCA+100
PCCARV97 EQU   PCCA+96
PCCARV96 EQU   PCCA+92
PCCARV95 EQU   PCCA+88
PCCARV94 EQU   PCCA+84
PCCARV93 EQU   PCCA+80
PCCARV92 EQU   PCCA+76
PCCARV91 EQU   PCCA+72
PCCARV90 EQU   PCCA+68
PCCARV89 EQU   PCCA+64
PCCARV88 EQU   PCCA+60
PCCARV87 EQU   PCCA+56
PCCARV86 EQU   PCCA+52
PCCARV85 EQU   PCCA+48
PCCARV84 EQU   PCCA+44
PCCARV83 EQU   PCCA+40
PCCARV82 EQU   PCCA+36
PCCARV81 EQU   PCCA+32
PCCAPSAR EQU   PCCA+28
PCCAPSAV EQU   PCCA+24
PCCATQEP EQU   PCCA+20
PCCACAFM EQU   PCCA+18
PCCACPUA EQU   PCCA+16
PCCAPCCA EQU   PCCA
PVTEND   EQU   PVT+1848
PVTTASID EQU   PVT+1846
PVTXXXXX EQU   PVT+1844
PVTMVCLC EQU   PVT+1840
PVTSPARE EQU   PVT+1838
PVTCHUIC EQU   PVT+1836
PVTCOMFX EQU   PVT+1834
PVTSQAFX EQU   PVT+1832
PVTCNTFX EQU   PVT+1830
PVTDEFFX EQU   PVT+1828
PVTFIXOK EQU   PVT+1826
PVTPEROK EQU   PVT+1824
PVTMAXFX EQU   PVT+1822
PVTPERFX EQU   PVT+1820
PVTRSRB  EQU   PVT+1776
PVTRESV5 EQU   PVT+1773
PVTSRBS  EQU   PVT+1772
PVTSSRB  EQU   PVT+1768
PVTACA   EQU   PVTWSAX+1400
PVTSAVE  EQU   PVTWSAX+1328
PVTWSA18 EQU   PVTWSAX+1256
PVTWSA17 EQU   PVTWSAX+1184
PVTWSA16 EQU   PVTWSAX+1112
PVTWSA15 EQU   PVTWSAX+1040
PVTWSA14 EQU   PVTWSAX+968
PVTWSA13 EQU   PVTWSAX+896
PVTWSA12 EQU   PVTWSAX+824
PVTWSA11 EQU   PVTWSAX+752
PVTWSA10 EQU   PVTWSAX+672
PVTWSA9  EQU   PVTWSAX+592
PVTWSA8  EQU   PVTWSAX+504
PVTWSA7  EQU   PVTWSAX+432
PVTWSA6  EQU   PVTWSAX+360
PVTWSA5  EQU   PVTWSAX+288
PVTWSA4  EQU   PVTWSAX+216
PVTWSA3  EQU   PVTWSAX+144
PVTWSA2  EQU   PVTWSAX+72
PVTWSA1  EQU   PVTWSAX
PVTCIOQL EQU   PVTQS+36
PVTCIOQF EQU   PVTQS+32
PVTGFADL EQU   PVTQS+28
PVTGFADF EQU   PVTQS+24
PVTFPCBL EQU   PVTQS+20
PVTFPCBF EQU   PVTQS+16
PVTSQAQL EQU   PVTQS+14
PVTSQAQF EQU   PVTQS+12
PVTCFQL  EQU   PVTQS+10
PVTCFQF  EQU   PVTQS+8
PVTRSRVL EQU   PVTQS+6
PVTRSRVF EQU   PVTQS+4
PVTAFQL  EQU   PVTQS+2
PVTAFQF  EQU   PVTQS
PVTSPFR  EQU   PVT+302
PVTCFMCT EQU   PVT+300
PVTSPREC EQU   PVT+296
PVTCAREC EQU   PVT+292
PVTCAOUT EQU   PVT+288
PVTCAIN  EQU   PVT+284
PVTNSWPS EQU   PVT+280
PVTNPREC EQU   PVT+276
PVTSPOUT EQU   PVT+272
PVTSPIN  EQU   PVT+268
PVTVAMR  EQU   PVT+264
PVTVAMO  EQU   PVT+260
PVTVAMI  EQU   PVT+256
PVTNPOUT EQU   PVT+252
PVTNPIN  EQU   PVT+248
PVTPRSET EQU   PVT+244
PVTFRSLT EQU   PVT+240
PVTPAGIO EQU   PVT+236
PVTSWPIO EQU   PVT+232
PVTPSWPP EQU   PVT+228
PVTPPREF EQU   PVT+224
PVTPOPBR EQU   PVT+220
PVTPRELF EQU   PVT+216
PVTPRELV EQU   PVT+212
PVTPFREE EQU   PVT+208
PVTPRELS EQU   PVT+204
PVTPOUT  EQU   PVT+200
PVTPFXLD EQU   PVT+196
PVTPITAS EQU   PVT+192
PVTPSRBP EQU   PVT+188
PVTPDSEG EQU   PVT+184
PVTPCSGB EQU   PVT+180
PVTPCSEG EQU   PVT+176
PVTPINV  EQU   PVT+172
PVTPSWPC EQU   PVT+168
PVTPSOUT EQU   PVT+164
PVTPSWIN EQU   PVT+160
PVTPRCV  EQU   PVT+156
PVTPRCFI EQU   PVT+152
PVTPVRC  EQU   PVT+144
PVTPVRIN EQU   PVT+140
PVTPVRLS EQU   PVT+136
PVTPVEQR EQU   PVT+132
PVTPPIOI EQU   PVT+128
PVTPVRPO EQU   PVT+124
PVTPRFR  EQU   PVT+120
PVTPFP2  EQU   PVT+116
PVTPFP   EQU   PVT+112
PVTPFTE  EQU   PVT+108
PVTPCB   EQU   PVT+104
PVTREP2  EQU   PVT+100
PVTPIOCP EQU   PVT+96
PVTPIOP  EQU   PVT+92
PVTPGFAD EQU   PVT+88
PVTPGFA  EQU   PVT+84
PVTPSQA  EQU   PVT+80
PVTPSINT EQU   PVT+76
PVTPSIB  EQU   PVT+72
PVTSRBID EQU   PVT+68
PVTPCIWA EQU   PVT+64
PVTHQSA  EQU   PVT+62
PVTLQSA  EQU   PVT+60
PVTOROOT EQU   PVT+56
PVTPRCA  EQU   PVT+52
PVTREUS  EQU   PVT+48
PVTSQNPC EQU   PVT+47
PVTSQVRC EQU   PVT+46
PVTRSUS  EQU   PVT+44
PVTVROOT EQU   PVT+40
PVTPCBLO EQU   PVT+38
PVTPCBCT EQU   PVT+36
PVTDFRS  EQU   PVT+34
PVTRSQA  EQU   PVT+32
PVTPTLB  EQU   PVT+31
PVTPCBNO EQU   PVT+30
PVTSRBNO EQU   PVT+29
PVTSQDC  EQU   PVT+28
PVTLCSA  EQU   PVT+26
PVTLPRIV EQU   PVT+24
PVTLVR   EQU   PVT+22
PVTFVR   EQU   PVT+20
PVTFPFN  EQU   PVT+16
PVTPFTP  EQU   PVT+12
PVTSSPIN EQU   PVT+11
PVTPCBS  EQU   PVT+10
PVTPOOL  EQU   PVT+8
PVTAFCOK EQU   PVT+6
PVTAFCLO EQU   PVT+4
PVTAFC   EQU   PVT+2
@NM00010 EQU   PVTFLAG2
PVTRSMGM EQU   PVTFLAG2
PVTDUMP  EQU   PVTFLAG1
PVTSIT   EQU   PVTFLAG1
PVTLSI   EQU   PVTFLAG1
PVTAPREF EQU   PVTFLAG1
PVTPCBLT EQU   PVTFLAG1
PVTSRBIU EQU   PVTFLAG1
PVTBGMS  EQU   PVTFLAG1
PVTPMSG  EQU   PVTFLAG1
UCBERADR EQU   UCBUCS+12
UCBFCBID EQU   UCBUCS+8
UCBERCNT EQU   UCBUCS+7
UCBRSV51 EQU   UCBUCS+6
UCBFCBPE EQU   UCBFCBOP
UCBRSV49 EQU   UCBFCBOP
UCBRSV48 EQU   UCBFCBOP
UCBRSV47 EQU   UCBFCBOP
UCBRSV46 EQU   UCBFCBOP
UCBRSV45 EQU   UCBFCBOP
UCBRSV44 EQU   UCBFCBOP
UCBFCBO1 EQU   UCBFCBOP
UCBUCSPE EQU   UCBUCSOP
UCBRSV43 EQU   UCBUCSOP
UCBRSV42 EQU   UCBUCSOP
UCBRSV41 EQU   UCBUCSOP
UCBRSV40 EQU   UCBUCSOP
UCBRSV39 EQU   UCBUCSOP
UCBUCSO2 EQU   UCBUCSOP
UCBUCSO1 EQU   UCBUCSOP
UCBUCSID EQU   UCBUCS
UCBMDRBA EQU   UCBMDRBF+1
UCBRV075 EQU   UCBMDRBF
UCBRV074 EQU   UCB3800X+32
UCBIMAGE EQU   UCB3800X+28
UCBFCBNM EQU   UCB3800X+24
UCBCHAR4 EQU   UCB3800X+20
UCBCHAR3 EQU   UCB3800X+16
UCBCHAR2 EQU   UCB3800X+12
UCBCHAR1 EQU   UCB3800X+8
UCBCGMID EQU   UCB3800X+4
UCBBRSTA EQU   UCBACTIV
UCBRV063 EQU   UCBACTIV
UCBRV062 EQU   UCBACTIV
UCBRV061 EQU   UCBACTIV
UCBRV060 EQU   UCBACTIV
UCBRV059 EQU   UCBACTIV
UCBRV058 EQU   UCBACTIV
UCBRV057 EQU   UCBACTIV
UCBRV050 EQU   UCB3800X+2
UCBCGMNO EQU   UCB3800X+1
UCBRV083 EQU   UCBOPTNS
UCBBRSTR EQU   UCBOPTNS
UCBRV056 EQU   UCBOPTNS
UCBRV055 EQU   UCBOPTNS
UCBRV054 EQU   UCBOPTNS
UCBRV053 EQU   UCBOPTNS
UCBRV052 EQU   UCBOPTNS
UCBRV051 EQU   UCBOPTNS
UCBRV073 EQU   UCB3540X+7
UCBRV072 EQU   UCBDKBYT
UCBRV071 EQU   UCBDKBYT
UCBRV070 EQU   UCBDKBYT
UCBRV069 EQU   UCBDKBYT
UCBRV068 EQU   UCBDKBYT
UCBRV067 EQU   UCBDKBYT
UCBVLVER EQU   UCBDKBYT
UCBDKAMX EQU   UCBDKBYT
UCBVLSER EQU   UCB3540X
UCBRDATA EQU   UCBOCR+4
UCBFRID  EQU   UCBOCR
UCBCLN   EQU   UCBMT+14
UCBERG   EQU   UCBMT+12
UCBMS    EQU   UCBMT+11
UCBNB    EQU   UCBMT+10
UCBPW    EQU   UCBMT+9
UCBPR    EQU   UCBMT+8
UCBSIO   EQU   UCBMT+6
UCBTW    EQU   UCBMT+5
UCBTR    EQU   UCBMT+4
UCBTWT   EQU   UCBMT+3
UCBTRT   EQU   UCBMT+2
UCBCTD   EQU   UCBMT
UCBWTOID EQU   UCBCMEXT+17
UCBRV043 EQU   UCBCMEXT+16
UCBASID  EQU   UCBCMEXT+14
UCBMFCNT EQU   UCBCMEXT+12
UCBPMSK  EQU   UCBCMEXT+10
UCBCCWOF EQU   UCBCMEXT+8
UCBRV041 EQU   UCBCMEXT+6
UCBRV036 EQU   UCBFLP1
UCBRV035 EQU   UCBFLP1
UCBERLOG EQU   UCBFLP1
UCBRV033 EQU   UCBFLP1
UCBINHIO EQU   UCBFLP1
UCBNSWAP EQU   UCBFLP1
UCBSHRUP EQU   UCBFLP1
UCBNSRCH EQU   UCBFLP1
UCBSNSCT EQU   UCBCMEXT+4
UCBHPDV  EQU   @NM00009
UCBHALI  EQU   @NM00009
UCBRSV09 EQU   @NM00009
UCBRSV08 EQU   @NM00009
UCBRSV07 EQU   @NM00009
UCBRSV06 EQU   @NM00009
UCBRSV05 EQU   @NM00009
UCBRSV04 EQU   @NM00009
UCBDTI   EQU   UCBCMEXT+2
UCBSTI   EQU   UCBCMEXT+1
UCBETI   EQU   UCBCMEXT
UCBEXTP  EQU   UCBEXTPT+1
UCBDDRSW EQU   UCBFLC
UCBTICBT EQU   UCBFLC
UCBIVRR  EQU   UCBFLC
UCBIVRS  EQU   UCBFLC
UCBITF   EQU   UCBFLC
UCBUDE   EQU   UCBFLC
UCBWAA   EQU   UCBFLC
UCBATTP  EQU   UCBFLC
UCBUNTYP EQU   UCBTBYT4
UCBRSV11 EQU   UCBDVCLS
UCBRSV10 EQU   UCBDVCLS
UCB3CHAR EQU   UCBDVCLS
UCB3UREC EQU   UCBDVCLS
UCB3DISP EQU   UCBDVCLS
UCB3COMM EQU   UCBDVCLS
UCB3TAPE EQU   UCBDVCLS
UCBDVPWR EQU   UCB2OPT7
UCBVLPWR EQU   UCB2OPT6
UCB2OPT5 EQU   UCBTBYT2
UCBRPS   EQU   UCBDUDN2
UCBRR    EQU   UCBDUDN1
UCB2OPT1 EQU   UCBTBYT2
UCB2OPT0 EQU   UCBTBYT2
UCB1FEA7 EQU   UCBTBYT1
UCBD6250 EQU   UCB1FEA6
UCBD1600 EQU   UCB1FEA5
UCB1FEA4 EQU   UCBTBYT1
UCB1FEA3 EQU   UCBTBYT1
UCB1FEA2 EQU   UCBTBYT1
UCB1FEA1 EQU   UCBTBYT1
UCB1FEA0 EQU   UCBTBYT1
UCBNAME  EQU   UCBOB+13
UCBRV029 EQU   UCBWGT
UCBVHRSN EQU   UCBWGT
UCBVORSN EQU   UCBWGT
UCBMTPXP EQU   UCBWGT
UCBREW   EQU   UCBWGT
UCBPUB   EQU   UCBWGT
UCBOUT   EQU   UCBWGT
UCBIN    EQU   UCBWGT
UCBCPU   EQU   UCBOB+11
UCBLCI   EQU   UCBOB+10
UCBCNT   EQU   UCBOB+9
UCBRV017 EQU   UCBCHM1
UCBRV016 EQU   UCBCHM1
UCBRV015 EQU   UCBCHM1
UCBRV014 EQU   UCBCHM1
UCBSPB   EQU   UCBPTH1
UCBPPB   EQU   UCBPTH1
UCBSPA   EQU   UCBPTH0
UCBPPA   EQU   UCBPTH0
UCBSIGP  EQU   UCBFLB
UCBVALPH EQU   UCBFLB
UCBCRHSN EQU   UCBFLB
UCBCRHRV EQU   UCBFLB
UCBRESVH EQU   UCBFLB
UCBSPST  EQU   UCBFLB
UCBASNS  EQU   UCBFLB
UCBIORST EQU   UCBFLB
UCBQISCE EQU   UCBFL1
UCBACTV  EQU   UCBFL1
UCBSAP   EQU   UCBFL1
UCBNOTRC EQU   UCBCUB
UCBPSNS  EQU   UCBFL1
UCBUSING EQU   UCBPST
UCBBUSYD EQU   UCBBSY
UCBUA    EQU   UCBCHAN+1
UCBCHA   EQU   UCBCHAN
UCBDADI  EQU   UCBSTAT
UCBSYSR  EQU   UCBSTAT
UCBPRES  EQU   UCBSTAT
UCBALOC  EQU   UCBSTAT
UCBUNLD  EQU   UCBSTAT
UCBRESV  EQU   UCBSTAT
UCBCHGS  EQU   UCBSTAT
UCBID    EQU   UCBOB+2
UCBALTCU EQU   UCBFL5
UCBNALOC EQU   UCBFL5
UCBENVRD EQU   UCBFL5
UCBVSDR  EQU   UCBFL5
UCBSASK  EQU   UCBFL5
UCBAMV   EQU   UCBAF
UCBDCC   EQU   UCBFL5
UCBMONT  EQU   UCBJBNR
UCBRV011 EQU   UCBJBNR
UCBMMSGP EQU   UCBJBNR
UCBOLDSM EQU   UCBJBNR
UCBRV003 EQU   UCBJBNR
UCBDUC   EQU   UCBJBNR
UCBJES3  EQU   UCBJBNR
UCBVRDEV EQU   UCBJBNR
UCBCMSEG EQU   UCBOB
UCBPFXND EQU   UCB+512
UCBIOQ   EQU   UCB+508
UCBLOCK  EQU   UCB+504
UCBPXST  EQU   UCB+504
@NM00006 EQU   UCB
SMCASTCB EQU   SMCABASE+176
SMCAWTCB EQU   SMCABASE+172
SMCAU83  EQU   SMCABASE+168
SMCAPGM  EQU   SMCABASE+164
SMCARGNM EQU   SMCABASE+160
SMCASPOT EQU   SMCABASE+156
SMCASPIN EQU   SMCABASE+152
SMCARGNS EQU   SMCABASE+148
SMCAPGRL EQU   SMCABASE+144
SMCADOMY EQU   SMCAPGOT
SMCADOMX EQU   SMCAPGIN
SMCATEXP EQU   SMCABASE+132
SMCASAVE EQU   SMCABASE+128
SMCARS21 EQU   SMCABASE+124
SMCATJID EQU   SMCAASCB+2
SMCAPOST EQU   SMCAASCB
SMCADSCT EQU   SMCABASE+116
SMCADSTM EQU   SMCABASE+108
SMCASWD  EQU   SMCABASE+107
SMCASWC  EQU   SMCABASE+106
SMCASWB  EQU   SMCABASE+105
SMCADSSW EQU   SMCASWA
SMCADSSP EQU   SMCASWA
SMCAZEOD EQU   SMCASWA
SMCANAVL EQU   SMCASWA
SMCANADA EQU   SMCASWA
SMCAOPFL EQU   SMCASWA
SMCADSTR EQU   SMCASWA
SMCASWAR EQU   SMCASWA
SMCAXNAM EQU   SMCABASE+96
@NM00005 EQU   SMCABASE+92
SMCAXCTL EQU   SMCABASE+88
SMCAWRTP EQU   SMCABASE+84
SMCAENAL EQU   SMCABASE+83
SMCAFGN  EQU   SMCAFOPT
SMCAFTDS EQU   SMCAFOPT
SMCAFR01 EQU   SMCAFOPT
SMCAFVOL EQU   SMCAFOPT
SMCAFDSA EQU   SMCAFOPT
SMCAFEXT EQU   SMCAFOPT
SMCAFOP2 EQU   SMCAFOPT
SMCAFOP1 EQU   SMCAFOPT
SMCAENOP EQU   SMCAENTY+1
SMCADSNF EQU   SMCAENDI
SMCARS20 EQU   SMCAENDI
SMCARS19 EQU   SMCAENDI
SMCARS18 EQU   SMCAENDI
SMCARS17 EQU   SMCAENDI
SMCARS16 EQU   SMCAENDI
SMCARS15 EQU   SMCAENDI
SMCARS14 EQU   SMCAENDI
SMCAWAIT EQU   SMCABASE+72
SMCASGFT EQU   SMCABASE+68
SMCASGWR EQU   SMCABASE+64
SMCABECB EQU   SMCABASE+60
SMCAWECB EQU   SMCABASE+56
SMCAADCB EQU   SMCABASE+52
SMCAYORX EQU   SMCABASE+51
SMCAANL  EQU   SMCAALBL
SMCAASL  EQU   SMCAALBL
SMCAANSL EQU   SMCAALBL
SMCARS13 EQU   SMCAALBL
SMCARS12 EQU   SMCAALBL
SMCARS11 EQU   SMCAALBL
SMCARS10 EQU   SMCAALBL
SMCARS09 EQU   SMCAALBL
SMCAADAR EQU   SMCABASE+47
SMCAAVOL EQU   SMCASTA
SMCAAUNT EQU   SMCASTA
SMCARS08 EQU   SMCASTA
SMCAAMOD EQU   SMCASTA
SMCAAMTY EQU   SMCASTA
SMCAADA  EQU   SMCASTA
SMCAATAP EQU   SMCASTA
SMCAANAV EQU   SMCASTA
SMCAADEV EQU   SMCABASE+40
SMCAPDCB EQU   SMCABASE+36
SMCAXORY EQU   SMCABASE+35
SMCAPNL  EQU   SMCAPLBL
SMCAPSL  EQU   SMCAPLBL
SMCAPNSL EQU   SMCAPLBL
SMCARS07 EQU   SMCAPLBL
SMCARS06 EQU   SMCAPLBL
SMCARS05 EQU   SMCAPLBL
SMCARS04 EQU   SMCAPLBL
SMCARS03 EQU   SMCAPLBL
SMCAPDAR EQU   SMCABASE+31
SMCAPVOL EQU   SMCAPSTA
SMCAPUNT EQU   SMCAPSTA
SMCARS02 EQU   SMCAPSTA
SMCAMOD  EQU   SMCAPSTA
SMCAPMTY EQU   SMCAPSTA
SMCAPDA  EQU   SMCAPSTA
SMCAPTAP EQU   SMCAPSTA
SMCAPNAV EQU   SMCAPSTA
SMCAPDEV EQU   SMCABASE+24
SMCABUFP EQU   SMCABASE+20
SMCASID  EQU   SMCABASE+16
SMCAJWT  EQU   SMCABASE+8
SMCATIOT EQU   SMCABASE+4
SMCATOFF EQU   SMCABASE+2
SMCADUMP EQU   SMCAMISC
SMCABSW  EQU   SMCAMISC
SMCADBSY EQU   SMCAMISC
SMCAPSDP EQU   SMCAMISC
SMCAFIRT EQU   SMCAMISC
SMCAOPI  EQU   SMCAMISC
SMCAMAN  EQU   SMCAMISC
SMCAUSER EQU   SMCAMISC
SMCAFGND EQU   SMCAOPT
SMCATDS  EQU   SMCAOPT
SMCARS01 EQU   SMCAOPT
SMCADSA  EQU   SMCAOPT
SMCAEXT  EQU   SMCAOPT
SMCAOPT2 EQU   SMCAOPT
SMCAOPT1 EQU   SMCAOPT
CATEND   EQU   CAT+8
CATSIOCT EQU   CAT+2
CASFLARS EQU   CATFLA
CATBSY   EQU   CATFLA
CATFLG7  EQU   CATFLG
CATFLG6  EQU   CATFLG
CATFLG5  EQU   CATFLG
CATRES1  EQU   CATFLG
CVTLEVL  EQU   CVTRELNO+2
CVTNUMB  EQU   CVTRELNO
CVTMDL   EQU   CVTFIX+250
@NM00004 EQU   CVTFIX+248
@NM00003 EQU   CVTFIX
CVTRV482 EQU   CVTXTNT2+128
CVTRV481 EQU   CVTXTNT2+124
CVTRV480 EQU   CVTXTNT2+120
CVTRV479 EQU   CVTXTNT2+118
CVTRV478 EQU   CVTXTNT2+117
CVTRV477 EQU   CVTXTNT2+116
CVTRV476 EQU   CVTXTNT2+115
CVTRV475 EQU   CVTXTNT2+114
CVTRV474 EQU   CVTRV466
CVTRV473 EQU   CVTRV466
CVTRV472 EQU   CVTRV466
CVTRV471 EQU   CVTRV466
CVTRV470 EQU   CVTRV466
CVTRV469 EQU   CVTRV466
CVTRV468 EQU   CVTRV466
CVTRV467 EQU   CVTRV466
CVTRV465 EQU   CVTRV457
CVTRV464 EQU   CVTRV457
CVTRV463 EQU   CVTRV457
CVTRV462 EQU   CVTRV457
CVTRV461 EQU   CVTRV457
CVTRV460 EQU   CVTRV457
CVTRV459 EQU   CVTRV457
CVTRV458 EQU   CVTRV457
CVTRV456 EQU   CVTXTNT2+108
CVTRV455 EQU   CVTXTNT2+104
CVTRV454 EQU   CVTXTNT2+100
CVTRV453 EQU   CVTXTNT2+96
CVTRV452 EQU   CVTXTNT2+94
CVTRV451 EQU   CVTXTNT2+92
CVTRV450 EQU   CVTXTNT2+90
CVTRV449 EQU   CVTXTNT2+88
CVTRV448 EQU   CVTXTNT2+87
CVTRV447 EQU   CVTXTNT2+86
CVTRV446 EQU   CVTRV438
CVTRV445 EQU   CVTRV438
CVTRV444 EQU   CVTRV438
CVTRV443 EQU   CVTRV438
CVTRV442 EQU   CVTRV438
CVTRV441 EQU   CVTRV438
CVTRV440 EQU   CVTRV438
CVTRV439 EQU   CVTRV438
CVTRV437 EQU   CVTRV429
CVTRV436 EQU   CVTRV429
CVTRV435 EQU   CVTRV429
CVTRV434 EQU   CVTRV429
CVTRV433 EQU   CVTRV429
CVTRV432 EQU   CVTRV429
CVTRV431 EQU   CVTRV429
CVTRV430 EQU   CVTRV429
CVTRV428 EQU   CVTXTNT2+80
CVTRV427 EQU   CVTXTNT2+76
CVTRV426 EQU   CVTXTNT2+72
CVTRV425 EQU   CVTXTNT2+68
CVTATACT EQU   CVTATCVT
CVTRV423 EQU   CVTXTNT2+62
CVTRV422 EQU   CVTXTNT2+60
CVTRV421 EQU   CVTXTNT2+58
CVTRV420 EQU   CVTXTNT2+56
CVTRV419 EQU   CVTXTNT2+55
CVTRV418 EQU   CVTXTNT2+54
CVTRV417 EQU   CVTRV409
CVTRV416 EQU   CVTRV409
CVTRV415 EQU   CVTRV409
CVTRV414 EQU   CVTRV409
CVTRV413 EQU   CVTRV409
CVTRV412 EQU   CVTRV409
CVTRV411 EQU   CVTRV409
CVTRV410 EQU   CVTRV409
CVTRV408 EQU   CVTRV400
CVTRV407 EQU   CVTRV400
CVTRV406 EQU   CVTRV400
CVTRV405 EQU   CVTRV400
CVTRV404 EQU   CVTRV400
CVTRV403 EQU   CVTRV400
CVTRV402 EQU   CVTRV400
CVTRV401 EQU   CVTRV400
CVTICB   EQU   CVTXTNT2+48
CVTSKTA  EQU   CVTXTNT2+44
CVTCCVT  EQU   CVTXTNT2+40
CVTRSV98 EQU   CVTXTNT2+36
CVTRSV97 EQU   CVTXTNT2+34
CVTRSV96 EQU   CVTXTNT2+32
CVTOLTEP EQU   CVTXTNT2+28
CVTQIDA  EQU   CVTQID+1
CVTRSV95 EQU   CVTQID
CVTRSV94 EQU   CVTXTNT2+20
CVTRSV93 EQU   CVTXTNT2+16
CVTRSV92 EQU   CVTXTNT2+12
CVTDEBVR EQU   CVTXTNT2+8
CVTRSV91 EQU   CVTXTNT2+6
CVTRSV9H EQU   CVTFLGBT
CVTRSV9G EQU   CVTFLGBT
CVTRSV9F EQU   CVTFLGBT
CVTRSV9E EQU   CVTFLGBT
CVTRSV9D EQU   CVTFLGBT
CVTRSV9C EQU   CVTFLGBT
CVTVME   EQU   CVTFLGBT
CVTNPE   EQU   CVTFLGBT
CVTNUCLS EQU   CVTXTNT2+4
CVTDSSVA EQU   CVTDSSV+1
CVTRSV89 EQU   CVTDSSV
CVTRSV88 EQU   CVTXTNT1+8
CVTRSV87 EQU   CVTXTNT1+4
CVTFACHN EQU   CVTXTNT1
CVTRV488 EQU   CVTMAP+412
CVTRV487 EQU   CVTMAP+408
CVTRV486 EQU   CVTMAP+404
CVTRV485 EQU   CVTMAP+400
CVTACTAP EQU   CVTMAP+396
CVTAUTH  EQU   CVTMAP+392
CVTATMCA EQU   CVTATMCT+1
CVTATMST EQU   CVTATMCT
CVTRSV61 EQU   CVTMAP+384
CVTVOLT1 EQU   CVTVOLM1+1
CVTVOLI1 EQU   CVTVOLF1
CVTSTOA  EQU   CVTMAP+376
CVTRSV58 EQU   CVTMAP+374
CVTRSV57 EQU   CVTMAP+372
CVTDDCE  EQU   CVTMAP+368
CVTPNWFR EQU   CVTMAP+364
CVTSMF   EQU   CVTMAP+360
CVTSULK  EQU   CVTMAP+358
CVTSLKO  EQU   CVTSYSK
CVTSLKP  EQU   CVTSYSK
CVTSLKQ  EQU   CVTSYSK
CVTSLKR  EQU   CVTSYSK
CVTRSV56 EQU   CVTSYSK
CVTRSV55 EQU   CVTSYSK
CVTRSV54 EQU   CVTSYSK
CVTRSV53 EQU   CVTSYSK
CVTRSV52 EQU   CVTA1F1
CVTRSV51 EQU   CVTA1F1
CVTRSV50 EQU   CVTA1F1
CVTRSV49 EQU   CVTA1F1
CVTRSV48 EQU   CVTA1F1
CVTRSV47 EQU   CVTA1F1
CVTSRSW  EQU   CVTA1F1
CVTPFSW  EQU   CVTA1F1
CVTPCVT  EQU   CVTMAP+352
CVTRSV46 EQU   CVTMAP+344
CVTRSV45 EQU   CVTMAP+340
CVTRSV44 EQU   CVTMAP+338
CVTRSV43 EQU   CVTMAP+336
CVTHJESA EQU   CVTHJES+1
CVTRSV42 EQU   CVTHJES
CVTEXT2A EQU   CVTEXT2+1
CVTRSV41 EQU   CVTEXT2
CVTAPFA  EQU   CVTAPF+1
CVTRSV40 EQU   CVTAPF
CVTRV518 EQU   CVTINTLA
CVTRV517 EQU   CVTERPV
CVTEORM  EQU   CVTMAP+312
CVTMCHPR EQU   CVTMAP+308
CVTTZ    EQU   CVTMAP+304
CVTJEPS  EQU   CVTMAP+300
CVTJESCT EQU   CVTMAP+296
CVTMODE  EQU   CVTMAP+292
CVTPTRV  EQU   CVTMAP+288
CVTREAL  EQU   CVTMAP+284
CVTRSV39 EQU   CVTMAP+280
CVTRSV38 EQU   CVTMAP+276
CVTDMSRA EQU   CVTDMSR+1
CVTRV634 EQU   CVTDMSRF
CVTRV633 EQU   CVTDMSRF
CVTRV632 EQU   CVTDMSRF
CVTRV631 EQU   CVTDMSRF
CVTRV630 EQU   CVTDMSRF
CVTRV629 EQU   CVTDMSRF
CVTUDUMP EQU   CVTDMSRF
CVTSDUMP EQU   CVTDMSRF
CVTQMSGA EQU   CVTQMSG+1
CVTRSV36 EQU   CVTQMSG
CVTAMFF  EQU   CVTMAP+264
CVTPURGA EQU   CVTPURG+1
CVTRSV35 EQU   CVTPURG
CVTCBSP  EQU   CVTMAP+256
CVTATERA EQU   CVTATER+1
CVTSYST  EQU   CVTATER
CVTVOLT2 EQU   CVTTAT
CVTVOLI2 EQU   CVTVOLF2
CVTAQAVB EQU   CVTAQAVT+1
CVTRSV34 EQU   CVTTCMFG
CVTRSV33 EQU   CVTTCMFG
CVTRSV32 EQU   CVTTCMFG
CVTRSV31 EQU   CVTTCMFG
CVTRSV30 EQU   CVTTCMFG
CVTRSV29 EQU   CVTTCMFG
CVTLDEV  EQU   CVTTCMFG
CVTTCRDY EQU   CVTTCMFG
CVTGTFA  EQU   CVTGTF+1
CVTRSV27 EQU   CVTGTFST
CVTRNIO  EQU   CVTGTFST
CVTUSR   EQU   CVTGTFST
CVTRV318 EQU   CVTFORM
CVTRV317 EQU   CVTTMODE
CVTRV316 EQU   CVTSTATE
CVTRV315 EQU   CVTGTFS
CVTGTFAV EQU   CVTGTFS
CVT0SCR1 EQU   CVTMAP+232
CVTRV515 EQU   CVTMAP+228
CVTRMS   EQU   CVTMAP+224
CVTPATCH EQU   CVTMAP+220
CVTTSCE  EQU   CVTMAP+216
CVTLNKSC EQU   CVTMAP+214
CVTQABST EQU   CVTMAP+212
CVTMDLDS EQU   CVTMAP+208
CVTUSER  EQU   CVTMAP+204
CVTABEND EQU   CVTMAP+200
CVTRSV18 EQU   CVTMAP+192
CVTQLPAQ EQU   CVTMAP+188
CVTQCDSR EQU   CVTMAP+184
CVTRSV17 EQU   CVTOPTB
CVTRSV16 EQU   CVTOPTB
CVTFP    EQU   CVTOPTB
CVTAPTHR EQU   CVTOPTB
CVTNLOG  EQU   CVTOPTB
CVTTOD   EQU   CVTOPTB
CVTCTIMS EQU   CVTOPTB
CVTPROT  EQU   CVTOPTB
CVTXPFP  EQU   CVTOPTA
CVTASCII EQU   CVTOPTA
CVTRSV13 EQU   CVTOPTA
CVTRSV12 EQU   CVTOPTA
CVTNIP   EQU   CVTOPTA
CVTDDR   EQU   CVTOPTA
CVTAPR   EQU   CVTOPTA
CVTCCH   EQU   CVTOPTA
CVTSNCTR EQU   CVTMAP+180
CVTQMWR  EQU   CVTMAP+176
CVTQOCR  EQU   CVTMAP+172
CVT1EF00 EQU   CVTMAP+168
CVTSV76Q EQU   CVTSV76C
CVTRSV11 EQU   CVTMAP+156
CVT0PT01 EQU   CVTMAP+152
CVTMSER  EQU   CVTMAP+148
CVTRV516 EQU   CVTIERLC
CVTILCH  EQU   CVTMAP+140
CVT0DS   EQU   CVTMAP+136
CVTFBOSV EQU   CVTMAP+132
CVTNUCB  EQU   CVTMAP+128
CVTIXAVL EQU   CVTMAP+124
CVTSV76M EQU   CVTIOQET
CVTDCBA  EQU   CVTMAP+117
CVTMVS2  EQU   CVTDCB
CVT6DAT  EQU   CVTDCB
CVT4MPS  EQU   CVTDCB
CVTRSV09 EQU   CVTDCB
CVT4MS1  EQU   CVTDCB
CVT2SPS  EQU   CVTDCB
CVT1SSS  EQU   CVTDCB
CVTRSV08 EQU   CVTDCB
CVTSTB   EQU   CVTMAP+112
CVTQTD00 EQU   CVTMAP+108
CVTQTE00 EQU   CVTMAP+104
CVTCUCB  EQU   CVTMAP+100
CVTSJQ   EQU   CVTMAP+96
CVTPBLDL EQU   CVTMAP+92
CVTTPC   EQU   CVTMAP+88
CVTSVDCB EQU   CVTMAP+84
CVTBRET  EQU   CVTMAP+82
CVTEXIT  EQU   CVTMAP+80
CVT0FN00 EQU   CVTMAP+76
CVTDARA  EQU   CVTDAR+1
CVTRSV07 EQU   CVTFLGS1
CVTRSV06 EQU   CVTFLGS1
CVTRSV05 EQU   CVTFLGS1
CVTRSV04 EQU   CVTFLGS1
CVTRSV03 EQU   CVTFLGS1
CVTRSV02 EQU   CVTFLGS1
CVTRSV01 EQU   CVTFLGS1
CVTDMPLK EQU   CVTFLGS1
CVTXITP  EQU   CVTMAP+68
CVTZDTAB EQU   CVTMAP+64
CVTMSLT  EQU   CVTMAP+60
CVTDATE  EQU   CVTMAP+56
CVTBTERM EQU   CVTMAP+52
CVTSYSAD EQU   CVTMAP+48
CVTXTLER EQU   CVTMAP+44
CVTILK1  EQU   CVTMAP+36
CVTPRLTV EQU   CVTMAP+32
CVTPCNVT EQU   CVTMAP+28
CVT0VL00 EQU   CVTMAP+24
CVTXAPG  EQU   CVTMAP+20
CVTBUF   EQU   CVTMAP+16
CVTJOB   EQU   CVTMAP+12
CVTLINK  EQU   CVTMAP+8
CVT0EF00 EQU   CVTMAP+4
CVTTCBP  EQU   CVTMAP
CVT      EQU   CVTMAP
RSMECBP  EQU   RSMLIST+12
RSMSTA2  EQU   RSMLIST+7
RSMSTA1  EQU   RSMLIST+6
RSMRES1  EQU   RSMLIST+5
@NM00002 EQU   RSMOPTN
@NM00001 EQU   RSMOPTN
RSMSRBL  EQU   RSMLIST
RDWLEN   EQU   RDW
.@UNREFD ANOP                          END UNREFERENCED COMPONENTS
@ENDDATA EQU   *
         END   IEEMB823,(C'PLS2007',0701,78023)
