         MACRO
         IEEUCDX
*        7/21/71
*        11/4/74,OS/VS2 RELEASE 3                              @ZM30471
* D 008500                                                     @ZM30471
*              DATA MANAGEMENT AND I/O SUPERVISOR CONTROL
*              BLOCKS FOR VMS OPERATOR CONSOLE SUPPORT
*              FOR THE 1052 USING EXCP.
*
*              1052 DCB (EXCP) DEFINITION.
****************************************************************
         DS    0D            DOUBLE WORD ALIGNMENT
DMDCB    DCB DDNAME=IEECVTSK,MACRF=(E),DSORG=PS
****************************************************************
         ORG
         SPACE
*
*                            STATUS.
         DC    D'0'               WORK AREA.
         SPACE
*                            1052 IOB DEFINITION.
         DS    0D
         DC    BL1'01000010'      COMMAND CHAINING,UNRELATED(42).
         DC    X'00'              2ND FLAG BYTE
         DC    H'0'               TWO SENSE BYTES.
         DC    F'0'          (DYNAMIC) ECB CODE AND PTR.
         DC    D'0'               CHANNEL STATUS WORD.
         DC    F'0'          (DYNAMIC) CHANNEL PROGRAM ADDRESS
         DC    F'0'          (DYNAMIC) DCB PTR.
         DC    F'0'               RESTART POINTER.
         DC    H'0'               BLOCK COUNT (UNUSED)
         DC    H'0'               ERROR COUNT (UNUSED)
         SPACE
         DS    0D            1052 CCW DEFINITIONS.
*                            READ
         DC    X'0A'         READ CODE.
         DC    FL3'0'        DATA PTR.
         DC    BL1'01100000' CC,SLI.
         DC    X'00'
         DC    FL2'1'        COUNT FIELD.
*                            TRANSFER TO NOP.
         DC    X'08'         TRANSFER IN CHANNEL.
         DC    FL3'0'        (DYNAMIC) TO NOP.
         DC    F'0'          IGNORED.
*                            WRITE
         DC    X'09'         WRITE CODE.
         DC    FL3'0'        DATA PTR.
         DC    BL1'01100000' CC,SLI.
         DC    X'00'
         DC    FL2'1'             COUNT FIELD.
*                            NOP.
*                                 ACTIVE COMMANDS CHAINED TO NOP FORCES
*                                 DEVICE END AND CHANNEL END TO OCCUR
*                                 TOGETHER,AVOIDING FUTURE INTERCEPTS,
*                                 ALLOWING CURRENT ERROR CHECK.
         DC    X'03'              NOP CODE
         DC    FL3'0'             NO DATA
         DC    BL1'00100000'      SLI
         DC    X'00'
         DC    FL2'1'             NON-ZERO COUNT
*                            ALARM.
         DC    X'0B'              GONG CODE
         DC    FL3'0'             NO DATA
         DC    BL1'00100000'      SLI.
         DC    X'00'
         DC    FL2'1'             NON ZERO COUNT
DMLAST   EQU   *                  END.
DMCORE   EQU   *-DMDCB            CORE REQUIREMENT.
         IHADCB DSORG=XE
         ORG
         SPACE
*
*                            STATUS.
DMX      DC    D'0'               WORK AREA.
DMXR     EQU   0                  READ LAST.
DMXW     EQU   4                  WRITE LAST.
DMXE     EQU   8                  GOING LAST.
DMX4     EQU   DMX+4              TERMINAL FLAG BYTE
DMX4C    EQU   X'80'              CLOSE
DMXERR   EQU   DMX+6
         SPACE
*                            1052 IOB DEFINITION
DMIOB    DS    0D
DMIF1    DC    BL1'01000010'      COMMAND CHAINING,UNRELATED(42).
DMIF2    DC    X'00'              2ND FLAG BYTE
DMISNS   DC    H'0'               TWO SENSE BYTES.
DMIECBP  DC    F'0'          (DYNAMIC) ECB CODE AND PTR.
DMIECBK  EQU   X'7F'                         7F  ERROR FREE
DMIECBX  EQU   X'41'                         41  PERMANENT ERROR
DMIECBR  EQU   X'44'                         44  INTERCEPT RETRY
DMIUX    EQU   1                  CANCEL, UNIT EXCEPTION.
DMICSW   DC    D'0'               CHANNEL STATUS WORD.
DMISTUS  EQU   DMICSW+4           STATUS BYTE.
DMICPA   DC    A(DMCCW)      (DYNAMIC) CHANNEL PROGRAM ADDRESS.
DMIDCB   DC    F'0'          (DYNAMIC) DCB PTR.
DMIRST   DC    F'0'               RESTART POINTER.
DMIBLK   DC    H'0'               BLOCK COUNT (UNUSED)
DMIERR   DC    H'0'               ERROR COUNT (UNUSED)
         SPACE
DMCCW    DS    0D            1052 CCW DEFINITIONS.
*                            READ
DMCREAD  DC    X'0A'         READ CODE.
DMCRDATA DC    FL3'0'        DATA PTR.
DMCRFLAG DC    BL1'01100000' CC,SLI.
         DC    X'00'
DMCRNBR  DC    FL2'1'        COUNT FIELD.
*                            TRANSFER TO NOP.
DMCTRA   DC    X'08'         TRANSFER IN CHANNEL.
         DC    AL3(DMCNOP)   TO NOP.
         DC    F'0'          IGNORED.
*                            WRITE
DMCWRITE DC    X'09'         WRITE CODE.
DMCWDATA DC    FL3'0'        DATA PTR.
DMCWFLAG DC    BL1'01100000' CC,SLI.
         DC    X'00'
DMCWNBR  DC    FL2'1'             COUNT FIELD.
*                            NOP.
*                                 ACTIVE COMMANDS CHAINED TO NOP FORCES
*                                 DEVICE END AND CHANNEL END TO OCCUR
*                                 TOGETHER,AVOIDING FUTURE INTERCEPTS,
*                                 ALLOWING CURRENT ERROR CHECK.
DMCNOP   DC    X'03'              NOP CODE
         DC    FL3'0'             NO DATA
         DC    BL1'00100000'      SLI
         DC    X'00'
         DC    FL2'1'             NON-ZERO COUNT
*                            ALARM.
DMCGONG  DC    X'0B'              GONG CODE
         DC    FL3'0'             NO DATA
         DC    BL1'00100000'      SLI.
         DC    X'00'
         DC    FL2'1'             NON ZERO COUNT
         MEND
