         TITLE 'IEEVDUS1 - DISPLAY USERS RTN'
*         GEN (TITLE 'IEEVDUS1 - DISPLAY USER ROUTINE');
         TITLE 'IEEVDUS1 - DISPLAY USER ROUTINE'
* /* * * * * * * * * * * * * * * * * * * * * * * * * * * ** * * * * * *
* /* STATUS:                                                          *
* /*   CHANGE LEVEL 000                                               *
* /*                                                            M4801 *
* /*                                                            M4619 *
* /*                                                            M3822 *
* /* C 390200-390220                                            M0383 *
* /* C 026898,701500,725000                                     M2089 *
* /* A 293000,817000,027112                                     M2089 *
* /* TITLE:                                                           *
* /*   DISPLAY USER ROUTINE FOR TSO                                   *
* /* FUNCTION:                                                        *
* /*   DISPLAYS THE ACTIVE USERS IN A TIME SHARING ENVIRONMENT. THE   *
* /*   USERID AND REGION NUMBER THAT THE USER IS RUNNING IN IS DIS-   *
* /*   PLAYED. THE TOTAL NUMBER OF TIME SHARING USERS IS ALSO DIS-    *
* /*   PLAYED.                                                        *
* /* OPERATION:                                                       *
* /*   UPON ENTRY, IT IS DETERMINED IF TIME SHARING IS ACTIVE. IF IT  *
* /*   IS NOT, AN ERROR MESSAGE IS WRITTEN TO THE CONSOLE AND CONTROL *
* /*   RETURNS TO INVOKER.  IF TIME SHARING IS ACTIVE THE SYSTEM IS   *
* /*   ACTIVE THE SYSTEM IS DISABLED. THE TOTAL NUMBER OF TIME        *
* /*   SHARING USERS IS SAVED IN THE WORKAREA FROM TSCVT. THE TJB     *
* /*   CHAIN IS SEARCHED FOR ACTIVE USERS. IF A TJB IS MARKED IN USE, *
* /*   THE USERID IS SAVED IN A WORKAREA AND THE REGION NUMBER IS     *
* /*   SAVED FROM THE ASSOCIATED RCB. WHEN THE TJB SEARCH IS COMPLETE,*
* /*   THE SYSTEM IS ENABLED, THE MESSAGES FORMATTED, AND SENT TO THE *
* /*   ISSUING CONSOLE OR TERMINAL.                                   *
* /*   IF USER=NMBR WAS ISSUED, THE TOTAL NUMBER OF ACTIVE USERS IS   *
* /*   GOTTEN FROM THE TSCVT, THE MESSAGE FORMATTED, SENT TO THE      *
* /*   ISSUING CONSOLE OR TERMINAL AND CONTROL RETURNS TO INVOKER.    *
* /* ENTRY POINT:                                                     *
* /*   IEEVDUS1 FROM IEEVWAIT                                         *
* /* INPUT:                                                           *
* /*   REGISTER 1 CONTAINS THE ADDRESS OF THE CSCB FOR DISPLAY USER   *
* /* OUTPUT:                                                          *
* /*   MESSAGES TO THE ISSUING CONSOLE/TERMINAL                       *
* /*   IEE325I DISPLAY REJECTED-TSO NOT ACTIVE                        *
* /*   IEE327I USERS=NN 'USERID'(RN) ...                              *
* /* EXTERNAL REFERENCES:                                             *
* /*   N/A                                                            *
* /* MACROS CALLED:                                                   *
* /*   GETMAIN,TPUT,WTO,IKJTSCVT,CVT,IKJRCB,IKJTCB,IEECHAIN           *
* /* EXITS, NORMAL:                                                   *
* /*   CONTROL RETURNS TO INVOKER                                     *
* /* EXITS, ERROR:                                                    *
* /*   CONTROL RETURNS TO INVOKER                                     *
* /* TABLES/WORKAREAS:                                                *
* /*   THE USERID AND REGION NUMBER FOR 208 USERS ARE SAVED IN A      *
* /*   WORKAREA WITH THE FOLLOWING FORMAT                             *
* /*         /USERID       /REGION NUMBER/                            *
* /*          0             8           9                             *
* /* ATTRIBUTES:                                                      *
* /*   REENTRANT, REFRESHABLE,READONLY, DISABLED DURING SEARCH OF     *
* /*   TJB CHAIN                                                      *
* /* SUPPORT CODE:                                                    *
* /*   20034                                                          *
* /* NOTES:                                                           *
* /*   EBCDIC CHARACTER CODE DEPENDENCY                               *
* /* * * * * * * * * * * * * * * * * *  * * * * * * * * * * * * * * * *
*         GEN(EJECT);
         EJECT
* IEEVDUS1: PROC (CALLPARM) OPTIONS
* (REENTRANT,NOSAVEAREA,DONTSAVE,DATAREG(0));
         LCLA  &T,&SPN                                            0003
.@001    ANOP                                                     0003
IEEVDUS1 CSECT ,                                                  0003
         BALR  @B,0                                               0003
@PSTART  DS    0H                                                 0003
         USING @PSTART+00000,@B                                   0003
*                                   /*                          M3822 *
*         DCL FREECSCB STATIC LOCAL ENTRY INTERNAL;         /* Y01012 *
*         DCL  CALLPARM PTR (31);
*
* /*      REGISTER USAGE                                              *
*
*         RESTRICT (3,4,5,6,7);
*         DCL R0 REG (0);
*         DCL R1 REG (1) PTR (31);                          /* Y01043 *
*         DCL R2 REG (2);           /* USED TO TEMP STORE RET R M3822 *
*         DCL R3 REG (3) PTR (31);
*         DCL R4 REG (4) FIXED (31);
*         DCL R6 REG (6) PTR (31);
*         DCL R7 REG (7) PTR (31);                          /* Y01043 *
*         DCL R11 REG (11) PTR (31);/* BASE REGISTER OF THIS ROUTINE  *
*         DCL R12 REG (12) PTR (31);/* REG FOR BASE OF WORKAREA M3822 *
*         DCL R15 REG (15) FIXED (31);                      /* Y01043 *
*                                   /*                          M2089 *
*         DCL R14 REG (14) FIXED (31);                      /* Y01043 *
*                                   /* SAVE RETURN ADDR IN REGISTER   *
*         DCL WORK1 REG(4) PTR (31);                        /* Y01043 *
*         DCL WORK2 REG(5) PTR (31);    /* TJB BASE            Y01043 *
*         DCL WORK3 REG(7) PTR (31);                        /* Y01043 *
*         GEN(EJECT);
         EJECT
         DS    0H
*
* /*       CVT MACRO                                                  *
*
*         DCL CVTPTR BASED (16) PTR (31);     /* PTR TO CVT           *
**
** /*     COMMUNICATION VECTOR TABLE                                  *
** /* RELEASE 1 AOS (AOS/1 REL 1), 02/07/72, LEVEL=13                 *
** /* RELEASE 2 AOS (AOS/1 REL 2, AOS/2 REL 1), 02/11/72, LEVEL=21    *
**
** /*                   CVT PROPER                                    *
**
** DECLARE
**   1 CVTMAP   BASED(CVTPTR),
**
**    2 CVTTCBP  PTR(31),             /* PTR TO ADDRESSES FOR NEXT
**                                       AND CURRENT TCB              *
**    2 CVT0EF00 PTR(31),             /* ADDR OF ROUTINE TO SCHEDULE
**                                       ASYNCHRONOUS EXITS           *
**    2 CVTLINK  PTR(31),             /* ADDR OF DCB FOR SYS1.LINKLIB *
**    2 CVTJOB   PTR(31),             /* ADDR OF WORK QUEUE CONTROL
**                                       BLOCKS                       *
**    2 CVTBUF   PTR(31),             /* ADDR OF BUFFER FOR RESIDENT
**                                       CONSOLE INTERRUPTION ROUTINE *
**    2 CVTXAPG  PTR(31),             /* ADDR OF IOS APPENDAGE TABLE  *
**    2 CVT0VL00 PTR(31),             /* ENTRY POINT ADDR OF ADDR
**                                       VALIDITY CHECKING ROUTINE    *
**    2 CVTPCNVT PTR(31),             /* ENTRY POINT ADDR OF ROUTINE
**                                       FOR CONVERTING RELATIVE
**                                       TRACK ADDR TO ABSOLUTE       *
**    2 CVTPRLTV PTR(31),             /* ENTRY POINT ADDR OF ROUTINE
**                                       FOR CONVERTING ABSOLUTE
**                                       TRACK ADDR TO RELATIVE       *
**    2 CVTILK1  PTR(31),             /* ADDR OF CHANNEL AND CONTROL
**                                       UNIT SECTION IN UCB LOOKUP
**                                       TABLE                        *
**    2 CVTILK2  PTR(31),             /* ADDR OF UCB ADDR LIST
**                                       SECTION IN UCB LOOKUP TABLE  *
**    2 CVTXTLER PTR(31),             /* ENTRY POINT ADDR TO XCTL
**                                       ROUTINE FOR SYSTEM ERROR
**                                       ROUTINES                     *
**    2 CVTSYSAD PTR(31),             /* ADDR OF SYSTEM RESIDENCE
**                                       VOLUME ENTRY IN UCB TABLE    *
**    2 CVTBTERM PTR(31),             /* ENTRY POINT ADDR OF ABTERM
**                                       ROUTINE                      *
**    2 CVTDATE  CHAR(4),             /* LOCAL DATE IN PACKED DECIMAL *
**    2 CVTMSLT  PTR(31),             /* ADDR OF MASTER COMMON AREA
**                                       PLEASE USE CVTMSER INSTEAD
**                                       TO ADDRESS MASTER SCHEDULER
**                                       RESIDENT DATA AREA           *
**    2 CVTZDTAB PTR(31),             /* ADDR OF I/O DEVICE
**                                       CHARACTERISTIC TABLE         *
**    2 CVTXITP  PTR(31),             /* ADDR OF ERROR INTERPRETER
**                                       ROUTINE                      *
**    2 CVTDAR   PTR(31),             /* SAME AS CVTDARA BELOW  ICB370*
**     3 CVTFLGS1 BIT(8),             /* FLAG BYTE              ICB370*
**      4 CVTDMPLK BIT(1),            /* SVC DUMP IS IN PROGRESS
**                                                              ICB370*
**      4 *        BIT(7),            /* RESERVED               ICB370*
**     3 CVTDARA  PTR(24),            /* ADDRESS OF SYS1.DUMP I/O
**                                       CONTROL BLOCKS FOR DAMAGE
**                                       ASSESSMENT ROUTINES  (AOS/1)
**                                       ADDRESS OF DCB FOR SYS1.DUMP
**                                       DATA SET  (AOS/2)      ICB370*
**    2 CVT0FN00 PTR(31),             /* ENTRY POINT ADDR TO FINCH    *
**    2 CVTEXIT  CHAR(2),             /* AN SVC 3 INSTRUCTION         *
**    2 CVTBRET  CHAR(2),             /* A BCR 15,14 INSTRUCTION      *
**    2 CVTSVDCB PTR(31),             /* ADDR OF DCB FOR SYS1.SVCLIB  *
**    2 CVTTPC   PTR(31),             /* ADDR OF TIMER SUPERVISOR
**                                       WORK AREA                    *
**    2 CVTPBLDL PTR(31),             /* BRANCH AND LINK ENTRY POINT
**                                       TO BLDL ROUTINE              *
**    2 CVTSJQ   PTR(31),             /* ADDR OF SELECTED JOB QUEUE   *
**    2 CVTCUCB  PTR(31),             /* ADDR OF TABLE WITH CONSOLE
**                                       UCB ADDR                     *
**    2 CVTQTE00 PTR(31),             /* ADDR OF TIMER ENQUEUE
**                                       ROUTINE                      *
**    2 CVTQTD00 PTR(31),             /* ADDR OF TIMER DEQUEUE
**                                       ROUTINE                      *
**    2 CVTSTB   PTR(31),             /* ADDR OF I/O DEVICE STATISTIC
**                                       TABLE                        *
**    2 CVTDCB   CHAR(1),             /* OPERATING SYSTEM
**                                       CONFIGURATION                *
**      4 *        BIT(1),            /* RESERVED                     *
**      4 CVT1SSS  BIT(1),            /* - PCP                        *
**      4 CVT2SPS  BIT(1),            /* - MFT, AOS/1                 *
**      4 CVT4MS1  BIT(1),            /* - MVT, AOS/2                 *
**      4 *        BIT(1),            /* RESERVED                     *
**      4 CVT4MPS  BIT(1),            /* - MULTIPROCESSING            *
**      4 CVT6DAT  BIT(1),            /* DYNAMIC ADDRESS TRANSLATION
**                                       BY CPU (AOS/1, AOS/2)        *
**      4 *        BIT(1),            /* RESERVED                     *
**    2 CVTDCBA   PTR(24),            /* ADDR OF DCB FOR SYS1.LOGREC  *
**    2 CVTIOQET PTR(31),             /* ADDR OF REQUEST ELEMENT
**                                       TABLE                        *
**    2 CVTIXAVL PTR(31),             /* ADDR OF I/O SUPERVISOR'S
**                                       FREELIST POINTER             *
**    2 CVTNUCB  PTR(31),             /* LOWEST ADDRESS NOT IN
**                                       NUCLEUS.  ON PAGE BDY        *
**    2 CVTFBOSV PTR(31),             /* ADDR OF PROGRAM FETCH
**                                       ROUTINE                      *
**    2 CVT0DS   PTR(31),             /* ADDR OF ENTRY POINT OF
**                                       DISPATCHER                   *
**    2 CVTILCH  PTR(31),             /* ADDR OF LOGICAL CHANNEL WORD
**                                       TABLE                        *
**    2 CVTIERLC PTR(31),             /* ADDR OF ASYNCHRONOUS EXIT
**                                       QUEUE                        *
**    2 CVTMSER  PTR(31),             /* ADDR OF MASTER SCHEDULER
**                                       RESIDENT DATA AREA           *
**    2 CVT0PT01 PTR(31),             /* ADDR OF BRANCH ENTRY POINT
**                                       OF POST ROUTINE              *
**    2 *        PTR(31),             /* ** CVTTRMTB FIELD UNUSED
**                                       IN AOS **                    *
**    2 CVTHEAD  PTR(31),             /* ADDR OF HIGHEST PRIORITY TCB
**                                       IN READY QUEUE               *
**    2 CVTMZ00  PTR(31),             /* HIGHEST ADDRESS IN VIRTUAL
**                                       STORAGE                      *
**    2 CVT1EF00 PTR(31),             /* ADDR OF ROUTINE WHICH
**                                       CREATES IRBS FOR EXITS       *
**    2 CVTQOCR  PTR(31),             /* ADDR OF A GFX PARM LIST
**                                       WORD, OR ZERO                *
**    2 CVTQMWR  PTR(31),             /* ADDR OF QMGR COMMUNICATION
**                                       DATA AREA                    *
**    2 CVTSNCTR FIXED(15),           /* SERIAL DATA SET SEQUENCE
**                                       NUMBER COUNTER               *
**    2 CVTOPTA  CHAR(1),             /* FLAGS                        *
**     3 CVTCCH   BIT(1),             /* CCH OPTION PRESENT   PTM 4686*
**     3 CVTAPR   BIT(1),             /* AUTOMATIC PATH RETRY --
**                                       I/O RECOVERY MGT             *
**     3 CVTDDR   BIT(1),             /* DYNAMIC DEVICE
**                                       RECONFIGURATION --
**                                       I/O RECOVERY MGT     PTM 4686*
**     3 CVTNIP   BIT(1),             /* - NIP PROCESSING             *
**     3 *        BIT(2),             /* RESERVED                     *
**     3 CVTASCII BIT(1),             /* USAS(CI)I OPTION PRESENT     *
**     3 CVTXPFP  BIT(1),             /* CPU HAS EXTENDED PRECISION
**                                       FLOATING POINT               *
**    2 CVTOPTB  CHAR(1),             /* RESERVED                     *
**     3 CVTPROT  BIT(1),             /* STORE PROTECTION SYSGENED    *
**     3 *        BIT(1),             /* RESERVED                     *
**     3 CVTTOD   BIT(1),             /* CPU HAS TIME OF DAY CLOCK    *
**     3 CVTNLOG  BIT(1),             /* SYS1.LOGREC UNAVAILABLE FOR
**                                       ERROR RECORDING        ICB382*
**     3 *        BIT(1),             /* RESERVED                     *
**     3 CVTFP    BIT(1),             /* FETCH PROTECT IS ACTIVE
**                                       (AOS/1)                ICB427*
**     3 *        BIT(2),             /* RESERVED                     *
**    2 CVTQCDSR PTR(31),             /* CDE SEARCH ROUTINE ADDRESS   *
**    2 CVTQLPAQ PTR(31),             /* ADDRESS OF POINTER TO MOST
**                                       RECENT ENTRY ON LPA CDE QUEUE*
**    2 *        PTR(31),             /* ** CVTMPCVT FIELD UNUSED IN
**                                       AOS **                       *
**    2 CVTSMCA  PTR(31),             /* ADDR OF SMCA                 *
**    2 CVTABEND PTR(31),             /* AOS/2 - ADDR OF SECONDARY CVT
**                                       --  AOS/1 -  RESERVED        *
**    2 CVTUSER  PTR(31),             /* FIELD AVAILABLE TO USER      *
**    2 CVTMDLDS PTR(31),             /* RESERVED FOR MODEL-DEPENDENT
**                                       SUPPORT                      *
**    2 CVTQABST CHAR (2),            /* AOS/2 - AN SVC 13 INSTRUCTION
**                                       --  AOS/1 - RESERVED         *
**    2 CVTLNKSC CHAR(2),             /* AN SVC 6 (LINK) INSTRUCTION
**                                                              ICB369*
**    2 CVTTSCE  PTR(31),             /* ADDR OF FIRST TSCE           *
**    2 CVTPATCH PTR(31),             /* ADDR OF FE PATCH AREA        *
**    2 CVTRMS   PTR(31),             /* ADDRESS OF RMS VECTOR TABLE  *
**    2 CVTTSCVT PTR(31),             /* ADDR OF TIME SHARING CVT     *
**     3 CVTTSFLG CHAR(1),            /* TIME SHARING OPTION FLAGS    *
**      4 CVTTSRDY BIT(1),            /* TSO READY AND INIT           *
**      4 *        BIT(7),            /* RESERVED                     *
**     3 CVTTSCVB PTR(24),            /* ADDR OF TIME SHARING CVT     *
**    2 CVT0SCR1 PTR(31),             /* ADDRESS OF RPS SECTOR
**                                       CONVERTER                    *
**    2 CVTGTF   PTR(31),             /* GTF CONTROL WORD       ICB312*
**     3 CVTGTFST BIT(8),             /* GTF FLAG BYTE          ICB312*
**      4 CVTGTFS  BIT(2),            /* GTF STATUS             ICB312*
**      4 CVTSTATE BIT(1),            /* GTF IN CONTROL PROCESSING
**                                       A HOOK                 ICB312*
**      4 CVTTMODE BIT(1),            /* IF 0 - MODE=INT
**                                       IF 1 - MODE=EXT        ICB312*
**      4 CVTFORM  BIT(1),            /* FORMAT TRACE TABLE AT
**                                       ABEND                  ICB312*
**      4 CVTUSR   BIT(1),            /* TRACE=USR SPECIFIED    ICB312*
**      4 *        BIT(2),            /* RESERVED               ICB312*
**     3 CVTGTFA  PTR(24),            /* ADDR OF MONITOR CALL
**                                       VECTOR TABLE           ICB312*
**    2 CVTAQAVT PTR(31),             /* POINTER TO WORD CONTAINING
**                                       ADDR OF TCAM VECTOR TABLE    *
**     3 CVTTCMFG CHAR(1),            /* TCAM FLAGS                   *
**      4 CVTTCRDY BIT(1),            /* TCAM RUNNING                 *
**      4 *        BIT(7),            /* RESERVED                     *
**     3 CVTAQAVB PTR(24),            /* POINTER TO WORD CONTAINING
**                                       ADDR OF TCAM VECTOR TABLE    *
**    2 CVTTATA  PTR(31),             /* ADDR OF P0 TCB POINTER       *
**     3 CVTTSKS  PTR(8),             /* MAXIMAL NUMBER OF TCB ADDR
**                                       TAB ENTRIES                  *
**     3 CVTTAT   PTR(24),            /* ADDR OF P0 TCB POINTER       *
**    2 CVTATER  PTR(31),             /* POINTER TO SYSTEM ERROR
**                                       TCB  (AOS/1)           ICB346*
**     3 CVTSYST  PTR(8),             /* NUMBER OF SYSGEN'D TCB'S     *
**     3 CVTATERA PTR(24),            /* POINTER TO SYSTEM ERROR
**                                       TCB  (AOS/1)           ICB346*
**    2 CVTEXT1  PTR(31),             /* ADDRESS OF OS-AOS COMMON
**                                       EXTENSION              ICB421*
**    2 CVTCBSP  PTR(31),             /* ADDRESS OF ACCESS METHOD
**                                       CONTROL BLOCK STRUCTURE.  IF
**                                       ZERO, IT INDICATES THAT THE
**                                       ACCESS METHOD MASTER CATALOG
**                                       IS NOT OPEN'ED AND AVAILABLE
**                                                              ICB436*
**    2 CVTPURG  PTR(31),             /* POINTER TO SUBSYSTEM PURGE
**                                       ROUTINE                ICB330*
**     3 *        CHAR(1),            /* RESERVED               ICB330*
**     3 CVTPURGA PTR(24),            /* ADDRESS OF SUBSYSTEM PURGE
**                                       ROUTINE                ICB330*
**    2 CVTAMFF  CHAR(4),             /* RESERVED FOR ACCESS METHOD
**                                       FLAGS                  ICB436*
**    2 CVTQMSG  PTR(31),             /* POINTER TO INFORMATION TO BE
**                                       PRINTED BY ABEND       ICB307*
**     3 *        CHAR(1),            /* RESERVED               ICB307*
**     3 CVTQMSGA PTR(24),            /* ADDRESS OF INFORMATION TO BE
**                                       PRINTED BY ABEND       ICB307*
**    2 CVTDMSR  PTR(31),             /* SAME AS CVTDMSRA BELOW ICB346*
**     3 *        CHAR(1),            /* RESERVED               ICB346*
**     3 CVTDMSRA PTR(24),            /* ADDRESS OF OPEN/CLOSE/EOV
**                                       SUPERVISORY ROUTINE    ICB346*
**    2 *        CHAR(8),             /* RESERVED               ICB346*
**
** /*           AOS/1 - AOS/2 COMMON SECTION                          *
**
**    2 CVTREAL  PTR(31),             /* ADDRESS OF THE VIRTUAL
**                                       STORAGE BYTE FOLLOWING THE
**                                       HIGHEST VIRTUAL=REAL STORAGE
**                                       ADDRESS                ICB368*
**    2 CVTPTRV  PTR(31),             /* ADDRESS OF PAGING SUPERVISOR
**                                       GENERAL ROUTINE TO TRANSLATE
**                                       REAL ADDRESSES TO VIRTUAL    *
**    2 CVTMODE  PTR(31),             /* ADDRESS OF ROUTINE TO CHANGE
**                                       SYSTEM MASK                  *
**    2 CVTJESCT PTR(31),             /* ADDRESS OF JES CONTROL TABLE *
**    2 CVTJEPS  PTR(31),             /* ADDRESS OF JEPS MONITOR TCB  *
**    2 CVTTZ    FIXED(31),           /* DIFFERENCE BETWEEN LOCAL TIME
**                                       AND GREENWICH MEAN TIME
**                                       (BIT 31 = 1.048576 SEC)      *
**    2 CVTMCHPR PTR(31),             /* ADDRESS OF MACHINE CHECK
**                                       PARAMETER LIST               *
**    2 CVTEORM  PTR(31),             /* HIGHEST REAL ADDRESS IN MAIN
**                                       STORAGE                      *
**    2 CVTERPV  PTR(31),             /* POINTER TO SUBROUTINE IN IOS
**                                       TO CONVERT CCW DATA ADDRESSES
**                                       TO VIRTUAL ADDRESSES   ICB367*
**    2 CVTINTLA PTR(31),             /* ADDRESS OF AREA CONTAINING
**                                       INTERVAL LENGTH AT WHICH I/O
**                                       LOAD BALANCING EXCP COUNTS
**                                       AND RATES ARE COMPUTED ICB341*
**    2 CVTAPF   PTR(31),             /* SAME AS CVTAPFA BELOW  ICB360*
**     3 *        CHAR(1),            /* RESERVED               ICB360*
**     3 CVTAPFA  PTR(24),            /* ADDRESS OF BRANCH ENTRY POINT
**                                       IN APF ROUTINE (AOS/2) ICB360*
**    2 CVTEXT2    PTR(31),           /* ADDRESS OF AOS/1 - AOS/2
**                                       COMMON EXTENSION       ICB330*
**     3 *          CHAR(1),          /* RESERVED               ICB330*
**     3 CVTEXT2A   PTR(24),          /* SAME AS CVTEXT2 ABOVE  ICB330*
**    2 CVTHJES  PTR(31),             /* SAME AS CVTHJESA BELOW ICB454*
**     3 *        CHAR(1),            /* RESERVED               ICB454*
**     3 CVTHJESA PTR(24),            /* ADDRESS OF OPTIONAL JOB ENTRY
**                                       SYSTEM COMMUNICATION VECTOR
**                                       TABLE                  ICB454*
**    2 *        CHAR(12),            /* RESERVED                     *
**
** /*           AOS/1 OVERLAY                                         *
**
**    2 CVTPGSIA PTR(31),             /* ADDRESS OF PAGING SUPERVISOR
**                                       INFORMATION AREA             *
**    2 CVTPCVT  PTR(31),             /* ADDRESS OF PAGED CVT
**                                       EXTENSION                    *
**    2 CVTA1F1  CHAR(1),             /* PAGE FAULT FLAGS             *
**     3 CVTPFSW  BIT(1),             /* ONLY PAGING TASK MAY BE
**                                       DISPATCHABLE                 *
**     3 CVTSRSW  BIT(1),             /* NO TASK EXCEPT PAGING TASK
**                                       MAY EXECUTE DISABLED CODE    *
**     3 *        BIT(6),             /* RESERVED                     *
**    2 CVTSYSK  CHAR(1),             /* SYSTEM LOCK.  IF NOT ZERO,
**                                       ONLY PAGING TASK MAY BE
**                                       DISPATCHED                   *
**     3 *        BIT(4),             /* RESERVED                     *
**     3 CVTSLKR  BIT(1),             /* MACHINE CHECK HANDLING IS IN
**                                       PROGRESS               ICB320*
**     3 CVTSLKQ  BIT(1),             /* SQA EXHAUSTED                *
**     3 CVTSLKP  BIT(1),             /* LAST PCB USED                *
**     3 CVTSLKO  BIT(1),             /* A DISABLED ROUTINE HAS
**                                       PRODUCED A PAGE FAULT        *
**    2 CVTSULK  FIXED(15),           /* SUPERVISOR LOCK.  NUMBER OF
**                                       TASKS ATTEMPTING TO EXECUTE
**                                       DISABLED CODE.  IF NOT ZERO,
**                                       ONLY ENABLED TASKS MAY RUN   *
**    2 CVTSMF   PTR(31),             /* ADDRESS OF SMF TCB     ICB395*
**    2 CVTPNWFR PTR(31);             /* ADDRESS OF ROUTINE WHICH
**                                       FREES THE 'EMERGENCY' WORK
**                                       AREA (ICB413)        PTM 2452*
**
** /*           AOS/2 OVERLAY                                         *
**
** DECLARE
**   1 CVTS01   BASED(ADDR(CVTPGSIA)),/* AOS/2 OVERLAY                *
**    2 *        PTR(31),             /* RESERVED               ICB339*
**    2 CVTLPDSR PTR(31),             /* ADDRESS OF LPA DIRECTORY
**                                       SEARCH ROUTINE               *
**    2 CVTPVTP  PTR(31),             /* ADDRESS OF PAGE VECTOR TABLE *
**    2 CVTLPDIA PTR(31),             /* ADDRESS OF LPA DIRECTORY.
**                                       ON PAGE BOUNDARY             *
**     3 CVTDIRST CHAR(1),            /* FLAG BYTE                    *
**      4 CVTDICOM BIT(1),            /* LPA DIRECTORY HAS BEEN
**                                       INITIALIZED BY NIP           *
**      4 *        BIT(7),            /* RESERVED                     *
**     3 CVTLPDIR PTR(24),            /* ADDRESS OF LPA DIRECTORY.
**                                       ON PAGE BOUNDARY             *
**    2 CVTPAGE1 PTR(31),             /* ADDRESS OF DCB FOR PRIMARY
**                                       PAGING DATA SET              *
**    2 CVTPGSUP PTR(31),             /* ADDRESS OF TCB FOR PAGING
**                                       SUPERVISOR                   *
**    2 CVTSLIDA CHAR(4) BDY(WORD),   /* IDENTITY OF TCB CAUSING
**                                       SUPERVISOR LOCK BYTE (CVTSYLK)
**                                       TO BE SET OR IDENTITY OF TCB
**                                       THAT SECOND EXIT PROCESSING
**                                       IS FOR WHEN CVTSEIC=1        *
**     3 CVTSYLK  CHAR(1),            /* SUPERVISOR LOCK.  ONLY
**                                       ENABLED TASKS MAY BE
**                                       DISPATCHED                   *
**     3 CVTSLID  CHAR(3),            /* SAME AS CVTSLIDA ABOVE       *
**    2 CVTSER   PTR(31),             /* SAME AS CVTSERA BELOW        *
**     3 CVTSEFLG CHAR(1),            /* SECOND EXIT FLAGS            *
**      4 CVTSEIC  BIT(1),            /* INDICATES THAT PAGING
**                                       SUPERVISOR HAS BRANCHED TO A
**                                       SECOND EXIT ROUTINE          *
**      4 *        BIT(7),            /* RESERVED                     *
**     3 CVTSERA  PTR(24),            /* SECOND EXIT ROUTINE ADDRESS
**                                       THAT WILL BE BRANCHED TO BY
**                                       ABTERM PROLOGUE SHOULD THE
**                                       SECOND EXIT ROUTINE PROGRAM
**                                       CHECK                        *
**    2 CVTSEG   CHAR(16) BDY(WORD),  /* SEGMENT TABLE INFORMATION    *
**     3 CVTSEGA  PTR(31),            /* VIRTUAL ADDRESS OF USER
**                                       SEGMENT TABLE                *
**     3 CVTSEGB  PTR(31),            /* VIRTUAL ADDRESS OF SYSTEM
**                                       SEGMENT TABLE                *
**     3 CVTSEGC  PTR(31),            /* REAL ADDRESS OF USER SEGMENT
**                                       TABLE                        *
**      4 CVTSEGLC PTR(8),            /* LENGTH IN 64-BYTE UNITS OF
**                                       USER SEGMENT TABLE           *
**      4 CVTSEGCA PTR(24),           /* REAL ADDRESS OF USER SEGMENT
**                                       TABLE                        *
**     3 CVTSEGD  PTR(31),            /* REAL ADDRESS OF SYSTEM
**                                       SEGMENT TABLE                *
**      4 CVTSEGLD PTR(8),            /* LENGTH IN 64-BYTE UNITS OF
**                                       SYSTEM SEGMENT TABLE         *
**      4 CVTSEGDA PTR(24),           /* REAL ADDRESS OF SYSTEM
**                                       SEGMENT TABLE                *
**    2 *        CHAR(1),             /* RESERVED                     *
**    2 CVTSPVLK PTR(8),              /* NUMBER OF TASKS WHICH HAVE
**                                       TERMINATED WHILE OWNING
**                                       SUPERVISOR LOCK WITHOUT
**                                       OPERATOR HAVING YET BEEN
**                                       NOTIFIED                     *
**    2 CVTCTLFG CHAR(1),             /* SYSTEM CONTROL FLAGS         *
**     3 CVTPSIC  BIT(1),             /* PAGING SUPERVISOR IN CONTROL *
**     3 CVTAPGB  BIT(1),             /* APG IS ACTIVE          ICB339*
**     3 *        BIT(1),             /* RESERVED               ICB382*
**     3 CVTDSTAT BIT(1),             /* DEVSTAT OPTION IN EFFECT.
**                                       DEVICE ADDRESS FOR 2319-3330-
**                                       2314 CAN VARY ACROSS SYSTEMS *
**     3 *        BIT(2),             /* RESERVED                     *
**     3 CVTGTRCE BIT(1),             /* GTF HAS SUPPRESSED SUPERVISOR
**                                       TRACE                  ICB446*
**     3 CVTSDTRC BIT(1),             /* SVC DUMP HAS SUPPRESSED
**                                       SUPERVISOR TRACE       ICB446*
**    2 CVTAPG   CHAR(1),             /* DISPATCHING PRIORITY OF
**                                       APG                    ICB339*
**    2 CVTTRACE CHAR(2),             /* BRANCH ON REGISTER
**                                       INSTRUCTION.  SET BY NIP.
**                                       REGISTER TEN FOR TRACE.
**                                       REGISTER ELEVEN FOR NO TRACE.*
**    2 CVTTRAC2 CHAR(2),             /* BRANCH ON REGISTER 11
**                                       INSTRUCTION.  THIS ALLOWS FOR
**                                       SUPPRESSING TRACE DYNAMICALLY
**                                       BY SETTING CONDITION CODE
**                                       MASK TO ZERO IN FIRST
**                                       INSTRUCTION  (CVTTRACE)      *
**    2 CVTRSCN  PTR(31),             /* ADDRESS OF ROUTINE TO SCAN
**                                       TCB TREE                     *
**    2 CVTTAS   PTR(31),             /* ADDRESS OF ROUTINE TO
**                                       TRANSFER ADDRESS SPACE       *
**    2 CVTPVALD PTR(31),             /* ADDRESS OF ROUTINE TO CHECK
**                                       ADDRESSES AS BEING IN A
**                                       REGION                       *
**    2 CVTSHRVM PTR(31),             /* LOWEST ADDRESS OF SHARED
**                                       VIRTUAL STORAGE AREA.  THIS
**                                       ADDRESS WILL BE EITHER THE
**                                       BEGINNING OF LPA DIRECTORY OR
**                                       THE BEGINNING OF LPA UPDATE
**                                       AREA IF 'MLPA' OPTION WAS
**                                       USED AT SUPERVISOR
**                                       INITIALIZATION.              *
**    2 CVT0VL01 PTR(31),             /* ENTRY POINT ADDRESS OF
**                                       VALIDITY CHECK ROUTINE
**                                       (IEA0VL01) USED TO COMPARE
**                                       PROTECT KEY OF AN ADDRESS
**                                       WITH TCB PROTECT KEY.        *
**    2 CVTPFIXQ PTR(31),             /* BRANCH ENTRY TO IEAPFIXQ, THE
**                                       FIX-QUIESCE ROUTINE USED BY
**                                       TSO BEFORE SWAP TO FREE ALL
**                                       SVC FIXES              ICB412*
**    2 CVTPFIXR PTR(31),             /* BRANCH ENTRY TO IEAPFIXR, THE
**                                       FIX-RESTORE ROUTINE USED BY
**                                       TSO AFTER SWAP (INVERSE OF
**                                       FIX-QUIESCE)           ICB412*
**    2 CVTPFIXP PTR(31),             /* BRANCH ENTRY TO IEAPFIXP, THE
**                                       FIX-PURGE ROUTINE USED BY
**                                       STAE, ABEND, ETC., TO GET RID
**                                       OF OUTSTANDING FIX REQUESTS
**                                                              ICB412*
**    2 CVTPTCD  PTR(31);             /* BRANCH ENTRY TO IEAPTCD, THE
**                                       PAGE-TABLE-CREATE-DESTROY
**                                       ROUTINE USED BY TSO LOGOFF IN
**                                       DOING A PSEUDO-FREEPART
**                                                              ICB412*
**
** /*                                                                 *
** /*           OS - AOS COMMON EXTENSION                             *
** /*                                                                 *
**
** DECLARE
**   1 CVTXTNT1 BASED(CVTEXT1),       /* START OF OS-AOS COMMON
**                                       EXTENSION              ICB421*
**    2 CVTFACHN PTR(31);             /* ADDRESS OF CHAIN OF DCB FIELD
**                                       AREAS (ISAM)           ICB421*
**
** /*                                                                 *
** /*           AOS/1 - AOS/2 COMMON EXTENSION                        *
** /*                                                                 *
**
** DECLARE
**   1 CVTXTNT2 BASED(CVTEXT2),       /* START OF AOS/1-AOS/2 EXT     *
**    2 CVTDSSV  PTR(31),             /* ADDRESS OF THE DSS VECTOR
**                                       TABLE                  ICB313*
**     3 *        CHAR(1),            /* RESERVED               ICB313*
**     3 CVTDSSVA PTR(24),            /* ADDRESS OF THE DSS VECTOR
**                                       TABLE                  ICB313*
**    2 CVTNUCLS CHAR(1),             /* USED TO IDENTIFY THE NUCLEUS
**                                       MEMBER NAME            ICB322*
**    2 *        CHAR(3),             /* RESERVED               ICB322*
**    2 CVTDEBVR PTR(31),             /* ADDRESS OF BRANCH ENTRY POINT
**                                       OF DEBCHK VERIFY ROUTINE
**                                       (AOS/2)                ICB380*
**    2 *        (3) FIXED(31),       /* RESERVED               ICB381*
**    2 CVTQID   PTR(31),             /* SAVE AS CVTQIDA BELOW  ICB381*
**     3 *        CHAR(1),            /* RESERVED               ICB381*
**     3 CVTQIDA  PTR(24),            /* ADDRESS OF QID TABLE
**                                       PREFIX                 ICB381*
**    2 CVTOLTEP PTR(31);             /* POINTER TO CONTROL BLOCK
**                                       CREATED BY SVC 59 TO POINT TO
**                                       PSEUDO-DEB'S           ICB423*
**
** /*                      CVT PREFIX                                 *
**
**    DCL 1 CVTFIX BASED (ADDR (CVTMAP) - 256), /* CVT PREFIX         *
**    2 *        CHAR(248),           /* RESERVED                     *
**    2 *        CHAR(2),             /* RESERVED                     *
**    2 CVTMDL   CHAR(2),             /* CPU MODEL NUMBER IN SIGNLESS
**                                       PACKED DECIMAL, I.E., A
**                                       MODEL 50 WOULD BE REPRESENTED
**                                       AS 0050 HEX                  *
**    2 CVTRELNO CHAR(4),             /* OS RELEASE NUMBER (EBCDIC)   *
**     3 CVTNUMB  CHAR(2),            /* RELEASE NUMBER               *
**     3 CVTLEVL  CHAR(2);            /* RELEASE LEVEL                *
**
** /*                   END OF CVT MACRO                              *
**
*         GEN(EJECT);
         EJECT
         DS    0H
*
* /*       TSCVT MACRO                                                *
*
** DECLARE
**   1 TSCVT    BASED(CVTTSCVT),
**    2 TSCVTTJB PTR(31),             /* POINTER TO TJB TABLE         *
**    2 TSCVTRCB PTR(31),             /* POINTER TO RCB TABLE         *
**    2 TSCVTRPT PTR(31),             /* PTR TO REFERENCE POINTER
**                                       TABLE                        *
**    2 TSCVTFLG  CHAR(2),            /*  FLAGS TO INDICATE FUNCT
**                                       REQUESTED OF TSC             *
**     3 * BIT(1),                    /* SPARE                        *
**     3 TSCSWPBG BIT(1),             /* SWAP SHOULD BE STARTED       *
**     3 TSCLOGON BIT(1),             /* A LOGON IS TO BE PROCESSED   *
**     3 TSCDISC  BIT(1),             /* A DISCONNECT IS TO BE
**                                       PROCESSED BITS               *
**     3 TSCVTTHR BIT(1),             /* SYSTEM IS THRASHING          *
**    2 TSCVTFL1  CHAR(2),            /*  FLAGS TO INDICATE FUNCT
**                                       REQUESTED OF TSC             *
**     3 TSCSSTOP BIT(1),             /* SYSTEM STOP REQUESTED AND
**                                       TSC IS STOPPING              *
**     3 TSCRSTOP BIT(1),             /* REGION STOP REQUESTED        *
**     3 TSCASTOP BIT(1),             /* ABEND-STOP TS FLG. SET BY
**                                       TSO/RMS IF TCAM MCH'SSET BY
**                                       TCAM STAE EXIT IF TCAM
**                                       ABENDS  BITS                 *
**     3 TSCTSTOP BIT(1),             /* RMS/MCH INTERFACE HAS STOPPED
**                                    /* TSC                          *
**     3 *        BIT(1),             /* RESERVED                     *
**     3 *        BIT(1),             /* RESERVED                     *
**     3 *        BIT(1),             /* RESERVED                     *
**     3 *        BIT(1),             /* RESERVED                     *
**    2 TSCVTI04 PTR(31),             /* ADDRESS OF IKJVAI04 IN TS
**                                       DISPATCHER                   *
**    2 TSCVTCUS FIXED(15),           /* CURR NO. OF USERS LOGGED ON
**                                       TSO                          *
**    2 TSCVTLUS FIXED(15),           /* CURRENT LIMIT NO. OF USERS
**                                       LOGGED ON TO TSO SET BY TSC  *
**    2 TSCVTNTJ FIXED(15),           /* NO.TJB-TSB'S ALLOC BY TSO
**                                       INITIALLY                    *
**    2 TSCVTSZU FIXED(15),           /* SIZE OF TJB                  *
**    2 TSCVTCTR FIXED(15),           /* NO. OF RCB'S ALLOC BY TSO
**                                       INITIALLY                    *
**    2 TSCVTMUS FIXED(15),           /* MAX NUMBER OF USERS LOGGED
**                                       ON TO TSO SET BY START AND
**                                       MODIFY COMMANDS (TSC)        *
**    2 TSCVTSAV PTR(31),             /* PTR TO SAV AREA FOR
**                                       TSC,TSIP&TS DISP             *
**    2 TSCVTECB PTR(31),             /* PTR TO TSECBTAB CTL BLK OF
**                                       ECB'S                        *
**    2 TSCVTSIA PTR(31),             /* PTR TO TSIA                  *
**    2 TSCVTICB PTR(31),             /* PTR TO TSICB                 *
**    2 TSCVTI01 PTR(31),             /* ADDRESS OF ENTRY POINT
**                                       IKJEAI01 TSIP BR ENTRY       *
**    2 TSCVTTQE PTR(31),             /* PTR TO TQE FOR TSO'S TIME
**                                       SLICING                      *
**    2 TSCVTI02 PTR(31),             /* ADDRESS OF ENTRY POINT
**                                       IKJEAI02 IN TS DISPATCH      *
**    2 TSCVTI03 PTR(31),             /* ADDRESS OF ENTRY POINT
**                                       IKJEAI03 IN TS DISPATCH      *
**    2 TSCVTD02 PTR(31),             /* ADDRESS OF ENTRY POINT
**                                       IKJEAD02 IN TS DRIVER        *
**    2 TSCVTLCQ PTR(31),             /* ADDR OF TOP ELEM ON LOGON
**                                       COMM. QUE                    *
**    2 TSCVTTRB PTR(31),             /* ADDR OF TRACE CTL BLK CHAIN  *
**    2 TSCVTLPA PTR(31),             /* ADDR OF 1ST CDE IN TS LINK
**                                       PACK AREA                    *
**    2 TSCVTSLF FIXED(31),           /* SYSTEM INIATED LOGOFF        *
**    2 TSCVTTSC PTR(31),             /* ADDR OF THE                  *
**    2 TSCVTSPL PTR(31),             /* ADDRESS OF START PARAMETER
**                                       LIST                         *
**    2 TSCVTRSZ FIXED(15),           /* MIN REGION SIZE FOR LOGON    *
**    2 *        CHAR(2),             /* RESERVED                     *
**    2 TSCVTSVT CHAR(4),             /* SVCTBL ENTRY FOR TSIP PRIOR
**                                       TO START TS                  *
**    2 TSCVTSVQ CHAR(4),             /* SVCTBL ENTRY FOR QTIP PRIOR
**                                       TO START TS                  *
**    2 TSCVTABN PTR(31),             /* ADDR OF OUT-OF-CORE ABEND
**                                       RTN(IKJEAT07)                *
**    2 TSCVTD03 PTR(31),             /* ADDR OF EP IKJEAD03 IN TS
**                                       DRIVER                       *
**    2 TSCVTFLM PTR(31),             /* ADDR OF EP - IKJEFLM         *
**    2 TSCVTQTP PTR(31),             /* ADDR OF EP OF QTIP SVC -
**                                       IKJGGQT1                     *
**    2 TSCVTT08 PTR(31),             /* ADDR OF EP - IKJEAT08        *
**    2 TSCVTDMP PTR(31),             /* ADDR OF TSO DUMP CONTROL
**                                        BLOCK - IKJTSDMP            *
**    2 TSCVTT06 PTR(31),             /* ADDR OF TCB FOR IKJEAT06     *
**    2 TSCVTLS3 PTR(31),             /* ADDR OF LOGON OUT OF CORE    *
**    2 TSCVTSMI PTR(31),             /* ADDRESS OF SMITDSN CONTROL
**                                       BLOCK                        *
**    2 TSCVTMSG PTR(31),             /* BRANCH ENTRY POINT FOR IKJVAMS
**                                                                    *
**    2 TSCVTSCN PTR(31),             /* BRANCH ENTRY POINT FOR IKJVASC
**                                                                    *
**    2 TSCVTR01 PTR(31);             /* ADDRESS OF IKJVAR01.         *
**
*         GEN(EJECT);
         EJECT
         DS    0H
*
* /*       TJB MACRO                                                  *
*
** DECLARE
**   1 TJB      BASED(WORK2),
**    2 TJBTSB   PTR(31),             /* ADDR OF TSB FOR THIS
**                                       JOB,0-STARTED BY OPERATOR    *
**    2 TJBATTN  CHAR(1),             /* NUMBER OF UNPROCESSED ATTNS
**                                       FOR THIS JOB                 *
**    2 TJBSTAX  CHAR(1),             /* NUMBER OF STAX EXITS YET
**                                       UNSCHEDULED                  *
**    2 TJBSTAT  CHAR(1),             /* STATUS FLAGS                 *
**     3 TJBNJB   BIT(1),             /* NO JOB,THIS TJB IS CURRENTLY
**                                       UNUSED                       *
**     3 TJBINCOR BIT(1),             /* USER IN CORE                 *
**     3 TJBLOGON BIT(1),             /* LOGON START,SET BY TIOC AT
**                                       DIAL-UP,TSC RESET            *
**     3 TJBIWAIT BIT(1),             /* INPUT WAIT,TERMINAL JOB IS
**                                       IN INPUT WAIT                *
**     3 TJBOWAIT BIT(1),             /* OUTPUT WAIT,TERMINAL JOB IS
**                                       IN OUTPUT WAIT               *
**     3 TJBSILF  BIT(1),             /* SYSTEM INITIATED LOGOFF      *
**     3 TJBDISC  BIT(1),             /* DISCONNECT SET TO REQUEST
**                                       TIOC TO DISCON LINE          *
**     3 TJBSILF2 BIT(1),             /* SYSTEM INITIATED LOGOFF      *
**    2 TJBSTAT2 CHAR(1),             /* STATUS FLAGS                 *
**     3 TJBHUNG  BIT(1),             /* HUNG UP                      *
**     3 TJBHOLD  BIT(1),             /* USER IS IN OWAIT DUE TO HOLD
**                                       OPTIONS                      *
**     3 TJBOCAB  BIT(1),             /* TSO FAILURE RESULTING IN
**                                       OUT-OF-CORE ABEND            *
**     3 TJBRNAV  BIT(1),             /* USER CANNOT BE LOGGED ON
**                                       BECAUSE MACHINE CHECK IN
**                                       REGION OR NO REGION LARGE
**                                       ENOUGH BITS                  *
**     3 TJBSURSV BIT(1),             /* ON NEXT SWAP IN,DO NOT MARK
**                                       SWAP UNIT AVAILABLE FOR USE  *
**     3 TJBQUIS  BIT(1),             /* QUIESCE STARTED FOR USER     *
**     3 TJBUSERR BIT(1),             /* USER READY TO RUN            *
**     3 TJBDEAD  BIT(1),             /* INDIACTE ABEND RECURSION
**                                       TO IKJEAT07                  *
**    2 TJBEXTNT PTR(31),             /* POINTER TO TJB IN SWAPPED
**                                       OUT JOB IMAGE                *
**    2 TJBRCB   PTR(31),             /* POINTER TO RCB FOR THIS
**                                       REGION                       *
**    2 *        PTR(31),             /* RESERVED                     *
**    2 TJBSPCT PTR(31),              /* PTR TO USER SPCT             *
**    2 *    FIXED(15),               /* RESERVED                     *
**    2 TJBRSTOR CHAR(1),             /* RESTORE FLAGS, TESTED BY RCT
**                                       RESTORE                      *
**     3 TJBOWP   BIT(1),             /* POST OUTPUT WAIT,SET BY
**                                       TIOC,ENDS AN OWAIT           *
**     3 TJBIWP   BIT(1),             /* POST INPUT WAIT,SET BY
**                                       TIOC,ENDS AN IWAIT EQU       *
**     3 *        BIT(1),             /* RESERVED                     *
**     3 TJBLOGP  BIT(1),             /* POST LOGON,POST ECB WAITED
**                                       ON BY LOGON IMAGE            *
**     3 TJBLWAIT BIT(1),             /* USER IN LONG WAIT,SWAP OUT
**                                       IF NOT MADE READY BY RESTORE
**                                       PROCESSING EQU               *
**     3 TJBDDRD  BIT(1),             /* WHEN ON RESTORE WILL RESET DDR
**                                       NON DISPATCHABILITY BIT      *
**     3 TJBFAT   BIT(1),             /* AN ATTN EXIT IS REQ FOR THIS
**                                       USER                         *
**     3 TJBDDRND BIT(1) ,            /* INDICATES TO RESTORE TO SET
**                                       TCB NON DISPATCHABILE WHEN
**                                       JOB SWAPPED IN               *
**    2 *        CHAR(1),             /* RESERVED                     *
**    2 TJBUSER  CHAR(8),             /* USERID OF THIS JOB
**                                       OWNER,PADDED RT WITH BLANKS  *
**    2 TJBIPPB  FIXED(31),           /* IPPB CHAIN OF ECB'S TO BE
**                                       POSTED BY RESTORE            *
**    2 TJBNEWID PTR(8),              /* RGN ID INTO WHICH THIS USER
**                                       SHOULD BE LOGGED ON. 0 IF
**                                       SELECTED BY DRIVER           *
**    2 TJBFLUSL CHAR(1),             /* STAX LEV OF LAST STAX ISSUED
**                                       WITH NOPURGE OPTION          *
**    2 TJBTJID  FIXED(15),           /* TERMINAL JOB ID              *
**    2 TJBMONI  CHAR(1),             /* MONITOR CMD INDICATING INFO
**                                       REQUESTED                    *
**     3 TJBMDSN  BIT(1),             /* DSNAMES                      *
**     3 TJBMJBN  BIT(1),             /* JOBNAMES                     *
**     3 TJBMSES  BIT(1),             /* SESSION                      *
**     3 TJBMSPA  BIT(1),             /* SPACE                        *
**     3 TJBMSTA  BIT(1),             /* STATUS                       *
**     3 TJBGETBF BIT(1),             /* THIS BIT INDICATES TPUT SHOULD
**                                       ATTEMPT TO GET ADDITIONAL
**                                       BUFFERS FOR USER BEFORE GOING
**                                       INTO A WAIT STATE            *
**     3 *        BIT(1),             /* RESERVED                     *
**     3 *        BIT(1),             /* RESERVED                     *
**    2 TJBSTAT3 CHAR(1),             /* STATUS FLAGS                 *
**     3 TJBDISC2 BIT(1),             /* TJB GOING TO DISCONNECT      *
**     3 TJBSOEM BIT(1),              /* SWAP OUT ERR MSG RECURS FLG  *
**     3 TJBLOGTM BIT(1),             /* INDICATES TO LOGON THAT
**                                       TERMINATION IS REQUESTED     *
**    2 TJBLINE  CHAR(2);             /* CONTAINS THE BINARY REP OF THE
**                                       UNIT ADR OF LINE BEING USED  *
*         GEN(EJECT);
         EJECT
         DS    0H
*
* /*      RCB MACRO                                                   *
*
** DECLARE
**   1 RCB      BASED(TJBRCB),
**    2 RCBRCT   PTR(31),             /* ADDR OF RCT'S TCB            *
**    2 RCBECB   FIXED(31),           /* RCT'S ECB                    *
**    2 RCBDIECB FIXED(31),           /* POSTED AT RCT TERMINATION    *
**    2 RCBTJID  FIXED(15),           /* TERM JOB ID OF CURRENT TS
**                                       JOB EXEC IN REGION           *
**    2 RCBRSIZE FIXED(15),           /* SIZE OF THIS TS REGION       *
**    2 RCBCOMM  FIXED(15),           /* AMT AUX. STORAGE COMMITTED
**                                       AT LOGON FOR THIS REGION     *
**    2 RCBNMBR  CHAR(1),             /* REGION NUMBER ASSIGNED TO
**                                       THIS REGION                  *
**    2 RCBFLG   CHAR(1),             /* FIRST BYTE OF RCB FLAGS      *
**     3 RCBFQU   BIT(1),             /* QUIESCE FLAG-CURR USER
**                                       SHOULD BE QUIESCED           *
**     3 RCBFSO   BIT(1),             /* SWAP OUT                     *
**     3 RCBFSI   BIT(1),             /* SWAP IN USERS TJID IS IN THE
**                                       RCB                          *
**     3 RCBFRS   BIT(1),             /* RESTORE FLAG-USER WHOSE TJID
**                                       IS IN THE RCB                *
**     3 RCBOCAB  BIT(1),             /* OUT-OF-CORE ABEND(IKJVAT07)
**                                       USER WHOSE TJID IS IN RCB    *
**     3 RCBABRT  BIT(1),             /* INDICATES STOP REGION FOR
**                                       ACTIVE RCT BEFORE LOGON IMAGE
**                                       CREATED                      *
**     3 RCBFAT   BIT(1),             /* ATTENTION EXIT- A ATTN EXIT
**                                       IS REQ FOR A USER            *
**     3 RCBFND   BIT(1),             /* END RCT - RCT SHOULD RETURN
**                                       TO TSC-NORMALLY              *
**    2 RCBFLG2  CHAR(1),             /* SECOND BYTE OF RCB FLAGS     *
**     3 RCBRDY   BIT(1),             /* INDICATES ACTIVE RCT READY
**                                       FOR LOGONS                   *
**     3 RCBSTOP  BIT(1),             /* REGION STOP REQUESTED        *
**     3 RCBACTV  BIT(1),             /* INDICATES ACTIVE RCT. SET TO
**                                       1 BY RCT INIT RESET TO 0 BY
**                                       RCT TERM                     *
**     3 RCBSTR1  BIT(1),             /* INDICATES REGION START
**                                       REQUESTED  ATTACH AN RCT     *
**     3 RCBSTR2  BIT(1),             /* INDICATES REGION START
**                                       REQUESTED  CREATE SWAP LOGON
**                                       IMAGE                        *
**     3 RCBDEAD  BIT(1),             /* REGION TERMINATED ABNORMALLY *
**     3 RCBLOGPR BIT(1),             /* INDICATE LOGON IMAGE
**                                       SWAPPED OUT                  *
**     3 RCBMODFY BIT(1),             /* INDICATES T06 MODIFY IN
**                                       PROGRESS FOR THIS REGION -
**                                       TSCECB4 SHOULD BE POSTED
**                                       UPON RCT TERMINATION         *
**    2 * CHAR(1),                    /* SPARE                        *
**    2 RCBCUSE  FIXED(15),           /* NO OF USERS CURR LOGGED ON
**                                       IN THIS REGION TSC WILL
**                                       INCREMENT COUNT BEFORE
**                                       DISCONNECTTSC WILL DECREMENT
**                                       COUNT IN LOGON               *
**    2 RCBEXTNT PTR(31),             /* PTR TO TJBX CREATED SURING
**                                       LOGON INIT FOR REG           *
**    2 RCBSPCT  PTR(31),             /* PTR TO LOGON SPCT            *
**    2 RCBTMECB PTR(31),             /* ECB USED BY R01 FOR SWAP-IN
**                                       OF THE LOGON IMAGE AT
**                                       REGION TERMINATION           *
**    2 RCBPRG   CHAR(12),            /* SVC PURGE I/O PARM LIST      *
**    2 RCBQPL   PTR(31),             /* ADDR OF QUIESCE I/O          *
**    2 RCBSTECB FIXED(31),           /* POSTED UPON RCT SUBTASK
**                                       TERMINATION                  *
**    2 RCBRCOVR CHAR(1),             /* INDICATE CURRENT STATE OF
**                                       RCT FOR RECOVERY PURPOSES IN
**                                       EVENT SUBSYSTEM FAILURE      *
**    2 RCBRSFLG CHAR(1),             /* INDICATORS FOR OUT OF CORE
**                                       ABEND                        *
**     3 RCBRSTRT BIT(1),             /* INDICATE RESTORE STARTED     *
**     3 RCBTCBDN BIT(1),             /* INDICATE TCBS REQUEUED       *
**     3 RCBQELCM BIT(1),             /* INDICATE QEL RESTORE
**                                       PROCESSING COMPLETE          *
**     3 RCBTQECM BIT(1),             /* INDICATE TQE RESTORE
**                                       PROCESSING COMPLETE          *
**     3 RCBRQIQC BIT(1),            /* INDICATE RQE AND IQE RESTORE
**                                       PROCESSING COMP              *
**     3 RCBIORSC BIT(1),             /* INDICATE I/O RESTORE
**                                       PROCESSING COMPLETE          *
**     3 RCBWTORC BIT(1),             /* INDICATE WTOR RESTORE
**                                       PROCESSING COMPLETE          *
**     3 RCBSQECM BIT(1),             /* INDICATE SQE RESTORE DONE    *
**    2 RCBQUFLG CHAR(1),             /* INDICATIONS FOR OUT OF CORE
**                                       ABEND                        *
**     3 RCBQUSTR BIT(1),             /* QUIESCE STARTED              *
**     3 RCBIOSTR BIT(1),             /* INDICATE 1ST ENTRY I/O PURGE
**                                       COMPLETE                     *
**     3 RCBSQEDN BIT(1),             /* SQE QUIESCE COMPLETE         *
**     3 RCBWTORD BIT(1),             /* WTOR QUIESCE DONE            *
**     3 RCBQELDN BIT(1),             /* QEL QUIESCE DONE             *
**     3 RCBIODON BIT(1),             /* INDICATE 2ND ENTRY I/O PURGE
**                                       COMPLETE                     *
**     3 RCBTQEDN BIT(1),             /* TQE QUIESCE                  *
**     3 RCBRQIQD BIT(1),             /* INDICATE IQE AND RQE
**                                       COMPLETE                     *
**    2 RCBSWTCH CHAR(1),             /* SET & RESET BY IKJVAT07 TO
**                                       INDICATE METHOD OF SEARCH BY
**                                       IKJEAT07                     *
**     3 RCBSTSP  BIT(1),             /* FLAG=STATUS STOP RECURSION   *
**     3 RCBSWTON BIT(1),             /* WHEN SET WITH BIT 0 SEARCH
**                                       BY TJID & TCB ADDR           *
**     3 RCBEXTRN BIT(1),             /* INDICATE USAGE OF EXTERNAL
**                                       BY IKJEAR02 AND IKJEAR03     *
**     3 RCBRMSAL BIT(1),             /* SOLID MACHINE CHECK IN USER
**                                       REGION                       *
**     3 RCBRMS1U BIT(1),             /* INTERMITTENT MACHINE CHECK
**                                       IN USER REGION               *
**     3 RCBZQRF  BIT(1),             /* IF ON ZERO THE RCBRSFLG AND
**                                       RCBQUFLG BEF TSEVENT LOGOFF  *
**     3 *        BIT(1),             /* RESERVED                     *
**     3 *        BIT(1),             /* RESERVED                     *
**    2 RCBCONID CHAR(1),             /* CONSOLE ID FOR START COMMAND
**                                       OR MODIFY COMMAND            *
**    2 RCBSTAEN CHAR(1),             /* INDEX VALUE TO SCHEDULE STAE
**                                       RETRY ROUTINES FOR RCT       *
**    2 * CHAR(2),                    /* SPARE                        *
**    2 RCBFXECB PTR(31),             /* ECB POSTED ON FIX COMPLETION *
**    2 RCBUSPCT PTR(31),             /* ADDRESS OF USER SPCT         *
**    2 RCBPQE PTR(31);               /* ADDRESS OF COPY OF PQE IN SQA*
**
*         GEN(EJECT);
         EJECT
         DS    0H
*
* /*       CSCB MACRO                                                 *
*
**
** /* --------------------------------------------------------------- *
**
** /*           IEECHAIN MAPPING OF CSCB                              *
** /*           COMMAND SCHEDULING CONTROL BLOCK                      *
** /*           REVISED 9-1-70                                        *
**
** /* AOS/1 RELEASE 1, 10/14/71, LEVEL=1                              *
** /* AOS/2 RELEASE 1, 10/20/71, LEVEL=2                              *
**
** /*           RUN TIME JOB DESCRIPTOR RESIDENT IN GLOBAL SQS AND    *
** /*           COMMUNICATION AREA PASSED VIA CSCB QUEUE              *
** /*           FROM COMMAND SCHEDULING ROUTINES                      *
** /*           TO COMMAND EXECUTION ROUTINES                         *
**
** /*     CREATED BY COMMAND SCHEDULER FOR LIFE OF TASK               *
** /*     FOR RDR, WTR, INIT OR MOUNT TASKS                           *
**
** /*     CREATED BY QUEUE MANAGEMENT DEQUEUE FOR LIFE OF JOB         *
** /*     BETWEEN DEQUEUEING AND TERMINATION                          *
**
** /*     CREATED BY SYSOUT WRITER FOR DSB STRING IN QUEUE ENTRY      *
** /*     TO ALLOW CANCELLATION OF WRITER SUBTASKS                    *
**
** /*     UPDATED BY COMMAND SCHEDULER IN EVENT OF                    *
** /*     CANCEL JOBNAME AFTER SELECTION, CANCEL WRITER DEVICE,       *
** /*     MODIFY, OR NON-PERIODIC STOP                                *
**
** DECLARE
**   1 CHAIN    BASED(R6),
**
**    2 CHPTR       PTR(31),          /* CHAIN PTR TO NEXT CSCB       *
**    2 CHFLG       CHAR(4),          /* FOUR BYTES                   *
**     3 CHVCD       CHAR(1),         /* COMMAND VERB CODE            *
**     3 CHSZE       PTR(8),          /* SIZE OF THIS CSCB IN DOUBLE
**                                       WORDS                        *
**     3 CHSTS       CHAR(1),         /* STATUS FLAGS                 *
**      4 CHAP     BIT(1),            /* ASSIGNMENT PENDING           *
**      4 CHSYS    BIT(1),            /* SYSTEM TASK CSCB             *
**      4 CHSOUT   BIT(1),            /* CANCEL ALL SYSOUT            *
**      4 CHQSPC   BIT(1),            /* INSUFFICIENT Q SPACE FOR 422
**                                       ABEND                        *
**      4 CHAD     BIT(1),            /* ADD THIS CSCB TO CHAIN       *
**      4 CHDL     BIT(1),            /* DELETE THIS CSCB FROM CHAIN  *
**      4 CHFC     BIT(1),            /* FREE THIS CSCB'S CORE        *
**      4 CHABTERM BIT(1),            /* EXECUTE BRANCH ENTRY TO
**                                       ABTERM                       *
**     3 CHACT       CHAR(1),         /* FLAGS INDICATING ACTIVITY
**                                       INVOLVED                     *
**      4 CHSWAP   BIT(1),            /* SWAPPABLE JOB                *
**      4 CHTERM   BIT(1),            /* TERMINAL JOB                 *
**      4 CHDISC   BIT(1),            /* CANCEL IMPLIES DISCONNECT    *
**      4 CHDSI    BIT(1),            /* ON MEANS NO DATA SET
**                                       INTEGRITY                    *
**      4 CHCL     BIT(1),            /* CANCELABLE JOB STEP          *
**      4 CHCLD    BIT(1),            /* CANCEL COMMUNICATION SWITCH  *
**      4 CHAIFX   BIT(1),            /* CANCELABLE--MFTII ONLY       *
**      4 CHIFY    BIT(1),            /* SYSTEM ASSIGNED
**                                       PROCEDURE--MFTII             *
**    2 CHKEY       CHAR(8),          /* 1. ID OF A STARTED TASK
**                                       (THIS ID IS THE TASK'S
**                                       STEPNAME)  2. JOBNAME OF AN
**                                       EXECUTED JOB.                *
**    2 CHCLS       CHAR(8),          /* 1.PROCNAME OF A STARTED TASK
**                                       (THE PROCNAME IS THE TASK'S
**                                       JOBNAME.)  2. JOBNAME OF AN
**                                       EXECUTED JOB (SAME AS CHKEY) *
**    2 CHUNIT      CHAR(3),          /* UNITNAME (SET FOR STARTED
**                                       TASKS ONLY)                  *
**    2 CHCIBCTR    PTR(8),           /* MAXIMAL NUMBER OF QUEUED
**                                       CIB'S                        *
**    2 CHPKE       CHAR(1),          /* PROTECT KEY (AOS/1)    ICB345*
**     3 CHJBNR      CHAR(1),         /* FLAG BYTE (AOS/2)      ICB345*
**      4 CHJBNRF  BIT(6),            /* INITIATOR IDENTIFIER
**                                       (AOS/2)                ICB345*
**      4 *        BIT(2),            /* RESERVED (AOS/2)       ICB345*
**    2 CHUCMP      CHAR(1),          /* UCMI (UNIT CONTROL MODULE
**                                       INDICATOR)  THIS IS THE ID
**                                       OF THE CONSOLE WHICH  ISSUED
**                                       THE COMMAND.                 *
**    2 CHTJID      FIXED(15),        /* TERMINAL ID                  *
**
**    2 CHASM,
** /*                     BEGINNING OF OVERLAY SEGMENT                *
**
** /*           BEGINNING OF CONTROL FORMAT MAPPING AFTER             *
** /*           INTERPRETATION OF COMMAND OPERANDS                    *
**
**     3 CHECBP      PTR(31),         /* PTR TO STOP/MODIFY ECB       *
**     3 CHCIBP      PTR(31),         /* PTR TO CIB --                *
**      4 CHEND    BIT(1),            /* HIGH ORDER BIT OF LAST
**                                       PARAMETER POINTER IS ON      *
**      4 *        BIT(7),            /* RESERVED                     *
**
** /*           THE ABOVE ECB AND CIB POINTERS FORM                   *
** /*           THE COMMUNICATIONS PARAMETER LIST MAPPED BY IEZCOM    *
**
**     3 CHRPRTY     CHAR(1),         /* RESET PRIORITY OF A JOB
**                                       WHOSE PRIORITY  HAS BEEN
**                                       RESET DURING EXECUTION       *
**     3 *           PTR(24),         /* RESERVED                     *
**     3 *           FIXED(31),       /* RESERVED                     *
**     3 CHECB       FIXED(31),       /* STOP/MODIFY ECB              *
**     3 CHCECB      FIXED(31),       /* CANCEL ECB                   *
**     3 *        (2) FIXED(31),      /* RESERVED                     *
**
**     3 CHSHORT,
** /*                     AFTER MVT JOB SELECT TIME, END OF CSCB.     *
** /*                     MFTII CSCB IS UNCHANGED.                    *
**
**      4 CHSWT       CHAR(1),        /* COMMUNICATIONS SWITCHES      *
**       5 CHRESC   BIT(1),           /* RESERVED                     *
**       5 CHJCT    BIT(1),           /* READER RETURN WITH IN-CORE
**                                       JCT                          *
**       5 CHPSD    BIT(1),           /* WRITER PAUSE DATASET         *
**       5 CHPSF    BIT(1),           /* WRITER PAUSE FORMS           *
**       5 CHAC     BIT(1),           /* ID SPECIFIED ON S COMMAND    *
**       5 CHRESB   BIT(1),           /* RESERVED                     *
**       5 *        BIT(2),           /* RESERVED  (ICB337)      40890*
**      4 CHTCB       PTR(24),        /* TCB PTR (MFTII ONLY)         *
**      4 CHSPB       PTR(31),        /* TCB PTR FOR ABTERM--MFTII    *
**      4 CHSPC       PTR(31),        /* PTR TO SMALL PARTITION
**                                       LIST--MFTII  TRANSIENT RDR
**                                       TTR--MFTII  COMPLETION CODE
**                                       FOR ABTERM--MFTII            *
**      4 CHJCL       PTR(31),        /* JCLS PTR --  IN-CORE JCT PTR
**                                       -- DA JCT TTR                *
**
**      4 CHQPA    (9) FIXED(31),     /* INPUT Q MANAGER PARAMETER
**                                       AREA                         *
**      4 CHSQA    (9) FIXED(31),     /* SYSOUT Q MANAGER PARAMETER
**                                       AREA  NOTE--THESE 2 QMPAS
**                                       EXIST IN MVT CSCBS ONLY
**                                       BEFORE INITIATOR  JOB SELECT
**                                       TIME.                        *
**
**      4 CHUSC       FIXED(31),      /* TIOT LENGTH--MFTII           *
**      4 CHJSCB      PTR(31),        /* JSCB PTR--MFTII ONLY         *
**      4 *        (4) FIXED(31);     /* RESERVED                     *
**
** /*           END OF CONTROL FORMAT MAPPING AFTER                   *
** /*           INTERPRETATION OF COMMAND OPERANDS                    *
**
** DECLARE 1 CHAINS01
**       BASED(ADDR(CHASM)),          /* OVERLAY                      *
**
** /*           BEGINNING OF INPUT FORMAT MAPPING BEFORE              *
** /*           INTERPRETATION OF COMMAND OPERANDS                    *
**
**    2 CHBUF       CHAR(124),        /* COMMAND IMAGE (OPERAND
**                                       FIELD)                       *
**    2 CHTYPE      CHAR(1),          /* FLAGS                        *
**     3 CHDSTAT  BIT(1),             /* STATUS DISPLAY (SVC 104) CMD *
**     3 *        BIT(5),             /* RESERVED                     *
**     3 CHHIAR   BIT(1),             /* ON MEANS H1 SPECIFIED ON
**                                       COMMAND (ICB337)      40890  *
**     3 CHDEF    BIT(1),             /* ON MEANS DEFAULT TO
**                                       H0  (ICB337)          40890  *
**    2 CHLSQA      PTR(8),           /* NUMBER OF SEGMENTS OF LSQA
**                                       NEEDED BY THE START
**                                       COMMAND                ICB397*
**    2 CHCNID      CHAR(1),          /* DISPLAY-RECEIVING CONSOLE ID *
**    2 CHARID      CHAR(1),          /* DISPLAY SCREEN-AREA ID       *
**    2 CHPEND      PTR(31),          /* CHAIN PTR FOR PENDING S
**                                       CMS--MFTII ONLY              *
**    2 CHINC       FIXED(15),        /* UNIQUE CTR FOR INTERPRETER   *
**    2 CHCSYSO     CHAR(1),          /* EXPRESS CANCEL SYSOUT        *
**     3 CHALL    BIT(1),             /* ALL SPECIFIED                *
**     3 CHINN    BIT(1),             /* IN SPECIFIED                 *
**     3 CHOUT    BIT(1),             /* OUT SPECIFIED                *
**     3 CHHOLD   BIT(1),             /* HOLD Q SPECIFIED             *
**     3 CHQUE    BIT(1),             /* SPECIFIC QUEUE               *
**     3 CHDUMP   BIT(1),             /* DUMP SPECIFIED               *
**     3 CHJB     BIT(1),             /* END SCAN SWITCH              *
**     3 CHRESD   BIT(1),             /* RESERVED                     *
**    2 CHSPA       CHAR(1),          /* MFTII STC SWITCHES           *
**    2 *           CHAR(8),          /* RESERVED                     *
**
** /*           END OF INPUT FORMAT MAPPING BEFORE                    *
** /*           INTERPRETATION OF COMMAND OPERANDS                    *
**
**    2 CHLAST      CHAR(0);
** /*                     END OF CSCB                                 *
**
** /* --------------------------------------------------------------- *
**
*         GEN(EJECT);
         EJECT
         DS    0H
*
* /*       CONSTANTS                                                  *
*
*         DCL BLANK CHAR (1) INIT (' ');
*         DCL ZEROS CHAR (4) BDY (WORD) INIT ('00000000'X); /* Y01043 *
*         DCL PARMAR FIXED(32) BDY(WORD) INIT('00000010'X); /* Y01043 *
* /* * * * * * * * * * * * * *  * * * * * * * * * * * * * * * * * * * *
* /*                                                                  *
* /*        LENGTH AND NAME OF COMMAND                                *
* /*                                                                  *
* /* * * * * * * * * * * * * *  * * * * * * * * * * * * * * * * * * * *
*         DCL 1  COMMNAME STATIC,                           /* Y01043 *
*                2   *   PTR(8) INIT ('0C'X),               /* Y01043 *
*                2   *   CHAR(12) INIT('DISPLAY USER');     /* Y01043 *
* /* * * * * * * * * * * * * *  * * * * * * * * * * * * * * * * * * * *
* /*                                                                  *
* /*       WORK AREAS                                                 *
* /*                                                                  *
* /* * * * * * * * * * * * * ** * * * ** * * * * * * ** * ** * ** * * *
*
* /*      WORKAREAS USED IN PROCESSING                          M3822 *
*
*         DCL SAVE14 FIXED (31) AUTOMATIC;
*                                   /* SAVE AREA FOR REG 14    M3822 */
*
* /* * * * * * * * * * * * * *  * * * * * * * * * * * * * * * * * * * *
* /*                                                                  *
* /*      MAPPING USED TO CREATE STAE INTERFACE ROUTINE PARM LIST     *
* /*                                                                  *
* /* * * * * * * * * * * * * *  * * * * * * * * * * * * * * * * * * * *
*
*         DCL 1 PARMLIST BASED(R1),                         /* Y01043 *
*               2 CSCBADR PTR(31),                          /* Y01043 *
*               2 COMMAND PTR(31),                          /* Y01043 *
*               2 BASEADR PTR(31),                          /* Y01043 *
*               2 R14SAV  PTR(31);                          /* Y01043 *
*
* /*       AREA USED TO FORMAT DISPLAY MESSAGES                       *
*
*         DCL 1 WTOMSG BDY (WORD),
*               2 LNGMSG FIXED (15),
*               2 MCSBITS FIXED (15),
*               2 MSGTEXT CHAR (72);
*
* /*      COUNTERS USED IN PROCESSING                                 *
*
*         DCL CORECNT FIXED(31) AUTOMATIC; /* CORE LEFT IN WORKAREA   *
*         DCL NOUSER FIXED (15) AUTOMATIC; /* TOTAL NUMBER OF USERS   *
*         DCL CNTTJB FIXED (15) AUTOMATIC; /* TOTAL NUMBER OF TJB'S   *
*
* /*      FLAGS                                                       *
*
*         DCL 1 FLAGS AUTOMATIC,
*               2 TPUTFLAG BIT (1);        /* USED FOR TPUT RC=14     *
*
* /*      FORMAT OF EACH ENTRY IN WORKAREA FOR USERID AND REGION NO   *
*
*         DCL 1 IDAREA BASED (R3),
*                 3 USRID CHAR(8),
*                 3 RGNUM CHAR (1);
*
* /*      AREA USED FOR CONVERT TO DECIMAL ROUTINE                    *
*
*         DCL UNPKAREA CHAR (8) AUTOMATIC BDY (DWORD);
*         DCL CVDAREA CHAR (8) AUTOMATIC BDY (DWORD);        /* M3822 *
*
* /*      WTO GENERATED LIST FORMS                                    *
*
*         DCL WTOLST1 GENERATED CHAR (72);
*         DCL WTOLST2 GENERATED CHAR (72);
*         DCL WTOLST3 GENERATED CHAR (72);
*         DCL ENDLST1 GENERATED;                             /* M3822 *
*         DCL ENDLST2 GENERATED;                             /* M3822 *
*         DCL ENDLST3 GENERATED;                             /* M3822 *
*
* /*      ADDITIONAL CONSTANTS                                        *
*
*         DCL LTPAREN CHAR (1) INIT (')');
*         DCL RTPAREN CHAR (1) INIT ('(');
*         DCL OPERAND CHAR (9) INIT ('USER=NMBR');
*         DCL DESCODE FIXED (31) INIT ('04000000'X);
*                                   /* DESCRIPTOR AND ROUTING CODES
*                                      FOR WTO MACRO          M3822 */
*         DCL DUSERLMT FIXED (15) INIT ('750'X);
*                                   /* LIMIT OF SIZE OF WORKAREA FOR
*                                      VDUS1 DUE TO CORE LIMITS -
*                                      ALLOWS FOR DISPLAY OF MAXIMUM
*                                           OF 195 USERS        M3822 *
*         GEN(EJECT);
         EJECT
         DS    0H
*         GO TO START;
         BC    15,START                                           0064
*         GEN (DC C'IEEVDUS1 2/14/71');
         DC C'IEEVDUS1 2/14/71'
         DS    0H
* START:
*         R6 = R1;                  /* SAVE PARAMETER REG IN    M3822 *
START    LR    @6,@1                                              0066
*         R7 = R14;                 /* SAVE RETURN ADDRESS     Y01043 *
         LR    @7,@E                                              0067
*         GEN(LOAD  EP=IEECB860);   /* LOAD THE SATE MODULE    Y01043 *
         LOAD  EP=IEECB860
         DS    0H
*         R3 = R0;                  /* SAVE ADDR OF (IEECB860) Y01043 *
         LR    @3,@0                                              0069
*         R0 = PARMAR;              /* LGTH/SP OF PARM LIST    Y01043 *
         L     @0,PARMAR                                          0070
*         GEN(GETMAIN R,LV=(0));    /* GET THE PARM LIST       Y01043 *
         GETMAIN R,LV=(0)
         DS    0H
*         COMMAND = ADDR(COMMNAME); /* LENGTH/ADDR OF COMMAND  Y01043 *
         LA    @F,COMMNAME                                        0072
         ST    @F,4(0,@1)                                         0072
*         R14SAV = R7;              /* PUT ADDR IN PARM AREA   Y01043 *
         ST    @7,12(0,@1)                                        0073
*         BASEADR = R11;            /* SAVE THE BASE ADDRESS   Y01043 *
         ST    @B,8(0,@1)                                         0074
*         CSCBADR = R6;             /* PASS THE CSCB ADDRESS   Y01043 *
         ST    @6,0(0,@1)                                         0075
*         R15 = R3;                 /* SET UP FOR BALR         Y01043 *
         LR    @F,@3                                              0076
*         GEN(BALR  14,15);         /* INVOKE THE STAE MODULE  Y01043 *
         BALR  14,15
         DS    0H
*         R7 = R15;                 /* SAVE RETURN CODE        Y01043 *
         LR    @7,@F                                              0078
*         RESTRICT (R2);            /* SET REG ASIDE FOR FREE  Y01043 *
*         R2 = R14SAV;              /* RESTORE RETURN ADDRESS  Y01043 *
         L     @2,12(0,@1)                                        0080
*         R11 = BASEADR;            /* RESTORE BASE ADDRESS    Y01043 *
         L     @B,8(0,@1)                                         0081
*         R6 = CSCBADR;             /* RESTORE CSCB ADDRESS    Y01043 *
         L     @6,0(0,@1)                                         0082
*         R0 = PARMAR;              /* LENGTH/SP OF THE LIST   Y01043 *
         L     @0,PARMAR                                          0083
*         GEN(FREEMAIN R,LV=(0),A=(1)); /* FREE THE PARM AREA  Y01043 *
         FREEMAIN R,LV=(0),A=(1)
         DS    0H
*         IF R7 ^= 0                /* WAS STAE CREATED        Y01043 *
*            THEN                   /* YES CONTINUE PROCESS    Y01043 *
         LTR   @7,@7                                              0085
         BC    08,@9FF                                            0085
*              DO;                  /* NO CLEAN-UP AND GET     Y01043 *
*               GEN(DELETE EP=IEECB860);                    /* Y01043 *
         DELETE EP=IEECB860
         DS    0H
*               CALL FREECSCB;      /* FREE CORE FOR CSCB      Y01043 *
         BAL   @E,FREECSCB                                        0088
*               R14 = R2;           /* SET UP TO RETURN        Y01043 *
         LR    @E,@2                                              0089
*               GEN(BR    14);      /* RETURN                  Y01043 *
         BR    14
         DS    0H
*              END;                                         /* Y01043 *
*         R0 = DUSERLMT;            /* CALCULATE AMT CORE NEEDED BY
*                                      VDUS1 FOR WORK SPACE -   M3822 *
@9FF     LH    @0,DUSERLMT                                        0092
*         R4 = R0;                  /* SAVE SIZE                M3822 *
         LR    @4,@0                                              0093
*         GEN (GETMAIN R,LV=(0));
         GETMAIN R,LV=(0)
         DS    0H
*                                   /* GETMAIN WORKAREA         M3822 *
*         RESTRICT (12);            /*                          M3822 *
*         R12 = R1;                 /* SAVE ADDR OF WORKAREA    M3822 *
         LR    @C,@1                                              0096
*         GEN (USING @DATD,R12);
         USING @DATD,R12
         DS    0H
*                                   /*                          M2089 *
*         R3 = R12;              /* SET UP BASE REG FOR W/A     M3822 *
         LR    @3,@C                                              0098
*
* /* TEST FOR TIME SHARING ACTIVE, IF TS NOT ACTIVE, ISSUE ERROR MSG  *
*
*         SAVE14 = R2;              /* SAVE RETURN REG          M3822 *
         ST    @2,SAVE14                                          0099
*         IF CVTTSCVT = ZEROS|CVTTSCVT = ADDR(CVTTSCVT)
*                                   /* IF PTR TO TSCVT IN CVT = 0 OR
*                                      IF IT POINTS TO ITSELF   M3822 *
*            THEN GO TO NOTSO;   /* THEN TSO NOT ACTIVE               *
         L     @F,ZEROS                                           0100
         L     @8,CVTPTR                                          0100
         CL    @F,228(0,@8)                                       0100
         BC    08,@9FE                                            0100
         LA    @F,228(0,@8)                                       0100
         C     @F,228(0,@8)                                       0100
         BC    08,NOTSO                                           0101
*
* /* INITIALIZE WORK AREA AND MESSAGE FORMAT AREA                     *
*
*         WORK3 = 255;             /* INITIALIZE REG FOR MAXIMUM ON
*                                     EXECUTE STATEMENT         M3822 *
@9FD     LA    @7,255                                             0102
* ZEROAGAN:
*         GEN (EX WORK3,ZEROWORK); /* ZERO OUT W/A 255 EACH     M3822 *
ZEROAGAN EX WORK3,ZEROWORK
         DS    0H
*         R4 = R4 - WORK3;         /* DECREMENT SIZE TO AMT LEFT TO
*                                     BE ZEROED OUT             M3822 *
         SR    @4,@7                                              0104
*         R3 = R3 + WORK3;         /* INCREMENT POINTER TO NEXT AREA
*                                     IN W/A TO BE CLEARED      M4619 *
         AR    @3,@7                                              0105
*         IF R4 > WORK3            /* IF MORE THAN 255 LEFT     M3822 *
*            THEN GO TO ZEROAGAN;  /* CONTINUE IN LOOP          M3822 *
         CR    @4,@7                                              0106
         BC    02,ZEROAGAN                                        0107
*         WORK3 = R4;              /* INITIALIZE LENGTH REG     M3822 *
         LR    @7,@4                                              0108
*         GEN ( EX WORK3,ZEROWORK);   /* USE REMAINDER IN R4 TO FINISH
*                                     ZEROING OUT WORKAREA      M3822 *
          EX WORK3,ZEROWORK
         DS    0H
*         WTOMSG(1) = BLANK(1);  /* BLANK OUT MSG AREA                *
         MVC   WTOMSG(1),BLANK                                    0110
*         WTOMSG(2:76) = WTOMSG(1:75);
         MVC   WTOMSG+1(75),WTOMSG                                0111
*         SAVE14 = R2;              /* SAVE RETURN REGISTER     M3822 *
         ST    @2,SAVE14                                          0112
*         R3 = R12;              /* SET UP BASE REG FOR W/A     M3822 *
         LR    @3,@C                                              0113
*         GEN (A R3,@SIZ001);
         A R3,@SIZ001
         DS    0H
*         RELEASE (2);
*
* /* IF USER=NMBR REQUESTED (NUMBER ONLY OF ACTIVE USERS) GO TO
*    ISSUE MESSAGE TO REQUESTOR                                      */
*
*         IF CHBUF(1:9) = OPERAND  /* THE OPERAND OF THE DISPLAY CMD IS
*                                        SAVED IN THE CSCB, COMPARE FOR
*                                        KEYWORDS.                   */
*            THEN GO TO FORMMSG;  /* GO TO GET NO. OF USERS AND ISSUE
         CLC   32(9,@6),OPERAND                                   0116
*                                        MESSAGE                     */
         BC    08,FORMMSG                                         0117
*
* /* DETERMINE IF THERE ARE ANY ACTIVE TSO USERS                      *
*
*         IF TSCVTCUS = 0            /* IF THERE ARE NO ACTIVE USERS  *
*            THEN GO TO FORMMSG;     /* THEN GO TO FORMAT USER=NMBR
         SR    @F,@F                                              0118
         L     @2,CVTPTR                                          0118
         L     @2,228(0,@2)        CVTMAP                         0118
         CH    @F,20(0,@2)                                        0118
*                                       MESSAGE ONLY                  *
         BC    08,FORMMSG                                         0119
*
* /* DISABLE SYSTEM TO GATHER INFORMATION                            */
*
*         GEN;
         MODESET ENABLE=NO                                       Y01043
         DS    0H
*         WORK3 = 23;              /* INITIALIZE REG TO MINIMUM LNG
*                                     OF MSG-IN CASE SEARCH FINDS NO
*                                     ACTIVE TJB'S THE WTO RTN EXPECTS
*                                     LNG IN REGISTER           M3822 *
         LA    @7,23                                              0121
*         WORK2 = TSCVTTJB;       /* WORK3 = PTR TO TJB ARRAY       */
         L     @5,0(0,@2)                                         0122
*         WORK2 = WORK2+48;       /* INCREMENT TJB BASE PTR PASSED
*                                        FIRST DUMMY TJB             */
         AH    @5,@D1                                             0123
*         NOUSER = TSCVTCUS;      /* SAVE COUNT OF TOTAL NUMBER OF
*                                    ACTIVE USERS IN WORK FIELD      */
         MVC   NOUSER(2),20(@2)                                   0124
*
* /* SEARCH TJB ARRAY FOR ACTIVE USERS                               */
*
* TJBLOOP:
*         IF CNTTJB = TSCVTNTJ    /* COMPARE COUNTER OF TJB'S SEARCHED
*                                     AGAINST MAXIMUM NUMBER TJB'S
*                                     IN TJB ARRAY                   */
*            THEN GO TO FORMAT;   /* IF MAXIMUM REACHED, TJB SEARCH
TJBLOOP  L     @2,CVTPTR                                          0125
         L     @2,228(0,@2)        CVTMAP                         0125
         LH    @F,24(0,@2)                                        0125
         CH    @F,CNTTJB                                          0125
*                                     ENDED, GO FORMAT MESSAGES      */
         BC    08,FORMAT                                          0126
*         CNTTJB = CNTTJB + 1;    /* INCREMENT COUNTER OF NO. OF TJB'S
*                                     SEARCHED                       */
         LA    @F,1                                               0127
         AH    @F,CNTTJB                                          0127
         STH   @F,CNTTJB                                          0127
*
* /* IF WORKAREA IS FULL, STOP SEARCH AND GO TO FORMAT MESSAGES      */
*
*         IF CORECNT => DUSERLMT  /* COMPARE AMT OF WORKAREA USED
*                                    AGAINST MAXIMUM SIZE OF WORKAREA *
*            THEN GO TO FORMAT;   /* IF MAXIMUM REACHED, STOP SEARCH
         LH    @F,DUSERLMT                                        0128
         C     @F,CORECNT                                         0128
*                                    AND GO TO FORMAT MESSAGES        *
         BC    12,FORMAT                                          0129
*
* /* IF TJB IS ACTIVE THEN SAVE INFORMATION IN WORKAREA, ELSE
*    CONTINUING LOOPING THROUGH TJB ARRAY                            */
*
*         IF TJBNJB = '1'B | TJBUSER(1) = ZEROS              /* M0383 *
*                                   /* IF TJB IS NOT IN USE(NEGATIVE
*                                      LOGIC) OR USERID FIELD IS ZERO *
*            THEN DO;             /* THEN INCREMENT POINTER TO NEXT
         TM    6(@5),B'10000000'                                  0130
         BC    01,@9FC                                            0130
         CLC   28(1,@5),ZEROS                                     0130
         BC    07,@9FB                                            0130
*                                    NEXT TJB AND CONTINUE LOOPING    *
*                 WORK2 = WORK2 + 48;
@9FC     AH    @5,@D1                                             0132
*                 GO TO TJBLOOP;
         BC    15,TJBLOOP                                         0133
*            END;
*
* /* SAVE USERID AND REGION NUMBER OF USER IN WORKAREA               */
*
* CONTLOOP:
*         USRID = TJBUSER;         /* SAVE USERID IN WORKAREA         *
@9FB     EQU   *                                                  0135
CONTLOOP MVC   0(8,@3),28(@5)                                     0135
*         RGNUM = RCBNMBR;        /* SAVE REGION NUMBER OF USER IN WA *
         L     @2,12(0,@5)
         MVC   8(1,@3),18(@2)                                     0136
*         CORECNT = CORECNT + 9;  /* INCREMENT AMT OF WORKAREA USED BY
*                                    ENTRY                            *
         LA    @F,9                                               0137
         A     @F,CORECNT                                         0137
         ST    @F,CORECNT                                         0137
*         R3 = R3 + 9;            /* INCREMENT POINTER TO NEXT ENTRY IN
*                                    WORKAREA                         *
         AH    @3,@D2                                             0138
*         WORK2 = WORK2 + 48;     /* INCREMENT POINTER TO NEXT TJB    *
         AH    @5,@D1                                             0139
*         GO TO TJBLOOP;          /* LOOP BACK TO TEST NEXT TJB       *
         BC    15,TJBLOOP                                         0140
*
* /* END OF SEARCH, ENABLE SYSTEM                                    */
*
* FORMAT:
*         GEN;
FORMAT   EQU   *                                                  0141
         MODESET ENABLE=YES                                      Y01043
         DS    0H
*         R3 = R12;               /* POINT TO BEGINNING OF WORKAREA   *
         LR    @3,@C                                              0142
*         GEN (A R3,@SIZ001);
         A R3,@SIZ001
         DS    0H
*
* /* FORMAT MESSAGES                                                 */
*
* FORMMSG1:
*         R4 = ADDR(ENDLST1) - ADDR(WTOLST1) + 1;
FORMMSG1 LA    @F,1                                               0144
         LA    @0,WTOLST1                                         0144
         SR    @F,@0                                              0144
         LA    @0,ENDLST1                                         0144
         AR    @F,@0                                              0144
         LR    @4,@F                                              0144
*                                  /* CALCULATE LNG OF WTO EXP. M3822 *
*         WTOMSG(1:R4) = WTOLST1(1:R4);
         LA    @E,WTOLST1                                         0145
         LR    @2,@4                                              0145
         BCTR  @2,0                                               0145
         LA    @A,WTOMSG                                          0145
         EX    @2,@MVC                                            0145
*                                 /* MOVE WTO LIST FORM TO WORKAREA  */
*         WORK2 = 23;             /* INCREMENT OFFSET INTO MESSAGE TO
*                                    TOTAL NUMBER OF USERS            *
         LA    @5,23                                              0146
*         R1 =   NOUSER;          /* GET TOTAL NUMBER OF ACTIVE USERS *
         LH    @1,NOUSER                                          0147
*
* /* CONVERT NUMBER OF ACTIVE USERS TO DECIMAL                       */
*
*         GEN;
         CVD   1,CVDAREA
         UNPK  UNPKAREA(5),CVDAREA+6(3)                          M3822
         DS    0H
*         WTOMSG(19:21) = UNPKAREA(1:3);
         MVC   WTOMSG+18(3),UNPKAREA                              0149
*                                 /* MOVE CONVERTED NUMBER TO MSGAREA *
*
* /* MOVE USERIDS TO MESSAGE AREA IN WORKAREA                        */
*
* MSG1LOOP:
*         IF USRID(1) = ZEROS     /* IF THERE ARE NO MORE USERIDS TO
*                                    BE FORMATTED INTO MESSAGES       *
*            THEN GO TO WRITEMSG; /* THEN GO TO PUT MSG TO TERM/CONS  *
MSG1LOOP CLC   0(1,@3),ZEROS                                      0150
         BC    08,WRITEMSG                                        0151
*         WORK3 = WORK2 + 8;      /* INCREMENT TO END OF USERID       *
         LA    @7,8                                               0152
         AR    @7,@5                                              0152
*         WTOMSG(WORK2:WORK3) = USRID(1:8);
         LR    @E,@3                                              0153
         LR    @2,@7                                              0153
         LR    @8,@5                                              0153
         SR    @2,@8                                              0153
         LA    @A,WTOMSG-1(@8)                                    0153
         EX    @2,@MVC                                            0153
*                                 /* MOVE USERID TO MESSAGE AREA      *
*         WTOMSG(WORK3) = RTPAREN;
         LR    @2,@7                                              0154
         LA    @A,WTOMSG-1(@2)                                    0154
         MVC   0(1,@A),RTPAREN                                    0154
*                                 /* MOVE INTO MESSAGE TEXT ENCLOSING
*                                    PARENS FOR REGION NUMBER         *
*         WORK2=WORK3+1;          /* POINT TO NEXT SPACE IN MSGAREA   *
         LA    @5,1                                               0155
         AR    @5,@7                                              0155
*         R1 = RGNUM;             /* GET REGION NUMBER OF USER        *
         SR    @1,@1                                              0156
         IC    @1,8(0,@3)                                         0156
*
* /* CONVERT REGION NUMBER TO DECIMAL                                */
*
*         GEN;
         CVD   1,CVDAREA
         UNPK  CVDAREA+1(3),CVDAREA+6(2)                         TM1877
         OI    CVDAREA+3,X'F0'
         DS    0H
*         WORK3 = WORK2 + 1;      /* POINT TO END OF REGION NUMBER    *
         LA    @7,1                                               0158
         AR    @7,@5                                              0158
*         WTOMSG(WORK2:WORK3) =CVDAREA(3:4);
         LA    @E,CVDAREA+2                                       0159
         LR    @2,@7                                              0159
         LR    @8,@5                                              0159
         SR    @2,@8                                              0159
         LA    @A,WTOMSG-1(@8)                                    0159
         EX    @2,@MVC                                            0159
*                                 /* MOVE REGION NUMBER TO MSGAREA    *
*         WORK2 = WORK3+1;        /* POINT TO NEXT SPACE IN MSG TEXT  *
         LA    @5,1                                               0160
         AR    @5,@7                                              0160
*         WTOMSG(WORK2) = LTPAREN;
         LR    @2,@5                                              0161
         LA    @A,WTOMSG-1(@2)                                    0161
         MVC   0(1,@A),LTPAREN                                    0161
*                                 /* MOVE ENCLOSING PARENS AROUND
*                                    REGION NUMBER                    *
*         WORK2 = WORK2+1;        /* POINT TO NEXT SPACE IN MSG TEXT  *
         AH    @5,@D3                                             0162
*         WORK3 = WORK2;          /* NEEDED FOR LNG OF MSG IN WTO RTN *
         LR    @7,@5                                              0163
*         WTOMSG(WORK2) =BLANK;   /* INSERT A SPACE BETWEEN ENTRIES   *
         LR    @2,@5                                              0164
         LA    @A,WTOMSG-1(@2)                                    0164
         MVC   0(1,@A),BLANK                                      0164
*         WORK2 = WORK2 + 1;      /* POINT TO NEXT SPACE IN MSG TEXT  *
         AH    @5,@D3                                             0165
*         R3 = R3 + 9;            /* INCREMENT TO NEXT ENTRY IN WA    *
         AH    @3,@D2                                             0166
*
* /* IF MESSAGE BUFFER FULL, WRITE MESSAGE TO REQUESTOR              */
*
*         IF WORK2=>58            /* IF OFFSET INTO MESSAGE TEXT IS AT
*                                    MAXIMUM LENGTH                   *
*            THEN GO TO WRITEMSG;   /* THEN GO TO ISSUE MSG     M3822 *
         CH    @5,@D4                                             0167
         BC    10,WRITEMSG                                        0168
*         GO TO MSG1LOOP;
         BC    15,MSG1LOOP                                        0169
*
* /* FORMAT MESSAGE FOR USER=NMBR REQUEST B                          */
*
* FORMMSG:
*         R4 = ADDR(ENDLST3) - ADDR(WTOLST3) + 1;
FORMMSG  LA    @F,1                                               0170
         LA    @0,WTOLST3                                         0170
         SR    @F,@0                                              0170
         LA    @0,ENDLST3                                         0170
         AR    @F,@0                                              0170
         LR    @4,@F                                              0170
*                                   /* CALCULATE LNG OF MESSAGE M3822 *
*         WTOMSG(1:R4) = WTOLST3(1:R4);
         LA    @E,WTOLST3                                         0171
         LR    @2,@4                                              0171
         BCTR  @2,0                                               0171
         LA    @A,WTOMSG                                          0171
         EX    @2,@MVC                                            0171
*                                 /* MOVE WTO LIST FORM TO MSGAREA    *
*         R1 = TSCVTCUS;          /* GET TOTAL NUMBER OF ACTIVE USERS *
         L     @2,CVTPTR                                          0172
         L     @2,228(0,@2)        CVTMAP                         0172
         LH    @1,20(0,@2)                                        0172
*         GEN;
         CVD   1,CVDAREA
         UNPK  UNPKAREA(5),CVDAREA+6(3)                           M3822
         DS    0H
*         WTOMSG(19:21) = UNPKAREA(1:3);
         MVC   WTOMSG+18(3),UNPKAREA                              0174
*                                 /* MOVE CONVERTED NUMBER TO MSGAREA *
*         WORK3 = LNGMSG;         /* GET LENGTH OF MESSAGE LIST FORM  *
         LH    @7,WTOMSG                                          0175
*
* /* TEST IF ISSUER IS CONSOLE OR TERMINAL                           */
*
* WRITEMSG:
*         IF CHTJID = ZEROS       /* IF TERMINAL ID FIELD IN CSCB IS 0*
*            THEN GO TO CONSOLE;  /* THEN CONSOLE ISSUED COMMAND, GO
WRITEMSG L     @F,ZEROS                                           0176
         LH    @0,30(0,@6)                                        0176
         CLR   @F,@0                                              0176
*                                    WTO MESSAGE TO CONSOLE           *
         BC    08,CONSOLE                                         0177
*
* /* TERMINAL REQUEST, TPUT MESSAGE TO TERMINAL                      */
*
* WRTEMSG2:
*                                   /*                          M2089 *
*         R1 = ADDR(WTOMSG)+4;      /* POINT TO MESSAGE TEXT          *
WRTEMSG2 LA    @1,WTOMSG+4                                        0178
*                                   /* (INCREMENT PAST MCS FLAGS)     *
*         R0 = WORK3-4;             /* DECREMENT WTO LENGTH BY 4      *
         LR    @F,@7                                              0179
         SH    @F,@D5                                             0179
         LR    @0,@F                                              0179
*                                   /* TO ACCOUNT FOR MCS FLAGS IN
*                                      WTO LIST EXPANSION            */
*         R15 = CHTJID;             /* GET TERMINAL ID FOR TPUT MACRO
*                                                              Y01012 *
         LH    @F,30(0,@6)                                        0180
*         GEN;
         TPUT (1),(0),TJID=(15)    PUT MESSAGE TO TERMINAL        M2089
         DS    0H
*         GO TO TESTMORE;           /* GO TO DETERMINE IF THERE ARE
*                                      MORE MSGS TO PUT TO TERM M3822 *
         BC    15,TESTMORE                                        0182
*
* /* WTO MESSAGE TO ISSUING CONSOLE                                  */
*
* CONSOLE:
*         LNGMSG = WORK3;         /* SET LENGTH OF DYNAMIC MESSAGE IN
*                                    WTO PARAMETER LIST               *
CONSOLE  STH   @7,WTOMSG                                          0183
*         R4 = WORK3 + 6;         /* INCLUDE ROUTING AND DESCRIPTOR
*                                      CODES                    M3822 *
         LA    @4,6                                               0184
         AR    @4,@7                                              0184
*         WTOMSG(WORK3:R4) = DESCODE; /* MOVE INTO WTO PARMS    M3822 *
         LA    @E,DESCODE                                         0185
         LR    @2,@4                                              0185
         LR    @8,@7                                              0185
         SR    @2,@8                                              0185
         LA    @A,WTOMSG-1(@8)                                    0185
         EX    @2,@MVC                                            0185
*         R0 = CHUCMP;            /* GET CONSOLE ID FROM CSCB         *
         SR    @0,@0                                              0186
         IC    @0,29(0,@6)                                        0186
*         R1 = ADDR(WTOMSG);      /* POINT TO PARAMETER LIST          *
         LA    @1,WTOMSG                                          0187
*         GEN;
         WTO   MF=(E,(1))           PUT MESSAGE TO CONSOLE
         DS    0H
*
* /* IF THERE ARE ANY MORE USERS TO BE LISTED, RETURN TO REFORMAT
*    ANOTHER MESSAGE                                                 */
*
* TESTMORE:
*         IF USRID(1)^=ZEROS      /* IF THERE ARE MORE USERID'S IN WA *
*            THEN GO TO FORMMSG1; /* THEN GO TO FORMAT MESSAGE        *
TESTMORE CLC   0(1,@3),ZEROS                                      0189
         BC    07,FORMMSG1                                        0190
*            ELSE GO TO RET1;     /* ELSE RETURN TO INVOKER           *
         BC    15,RET1                                            0191
*
* /* FORMAT MESSAGE IEE325I TS NOT ACTIVE AND SEND TO CONSOLE        */
*
* NOTSO:
*         R4 = ADDR(ENDLST2) - ADDR(WTOLST2) + 1;
NOTSO    LA    @F,1                                               0192
         LA    @0,WTOLST2                                         0192
         SR    @F,@0                                              0192
         LA    @0,ENDLST2                                         0192
         AR    @F,@0                                              0192
         LR    @4,@F                                              0192
*                                   /* CALCULATE LNG OF MESSAGE M3822 *
*         WTOMSG(1:R4) = WTOLST2(1:R4);
         LA    @E,WTOLST2                                         0193
         LR    @2,@4                                              0193
         BCTR  @2,0                                               0193
         LA    @A,WTOMSG                                          0193
         EX    @2,@MVC                                            0193
*                                 /* MOVE WTO LIST FORM TO MSGAREA    *
*         R0 = CHUCMP;            /* GET CONSOLE ID FROM CSCB         *
         SR    @0,@0                                              0194
         IC    @0,29(0,@6)                                        0194
*         R1 = ADDR(WTOMSG);      /* POINT TO WTO PARAMETER LIST      *
         LA    @1,WTOMSG                                          0195
*         GEN;
         WTO   MF=(E,(1))           PUT ERROR MESSAGE TO CONSOLE
         DS    0H
* RET1:
* RET:
*                                 /*                            M2089 *
*         R1 = R12;               /* GET WORK AREA ADDR         M3822 *
RET1     EQU   *                                                  0197
RET      LR    @1,@C                                              0197
*         R0 = DUSERLMT;          /* GET SIZE OF W/A            M3822 *
         LH    @0,DUSERLMT                                        0198
*         R3 = SAVE14;            /* GET RETURN REG            Y01012 *
         L     @3,SAVE14                                          0199
*         GEN (FREEMAIN R,LV=(0),A=(1));
         FREEMAIN R,LV=(0),A=(1)
         DS    0H
*                                 /* FREEMAIN WORKAREA          M3822 *
*         CALL FREECSCB;          /* FREE CORE FOR CSCB        Y01012 *
         BAL   @E,FREECSCB                                        0201
*         R15 = 0;                /* SET RETURN CODE = NORMAL   M4801 *
         SR    @F,@F                                              0202
*         R14 = R3;               /* RESTORE RETURN ADDRESS    Y01012 *
         LR    @E,@3                                              0203
*         RETURN;                 /* RETURN TO INVOKER                *
         BC    15,@EL01                                           0204
*         GEN;
WTOLST1  WTO   'IEE327I USERS=                                         *
                 ',MF=L,DESC=(6),MCSFLAG=(REG0,RESP)
ENDLST1  EQU   *                                                  M3822
WTOLST2  WTO   'IEE325I DISPLAY  REJECTED-TSO NOT ACTIVE',MF=L,        *
               DESC=(6),MCSFLAG=(REG0,RESP)
ENDLST2  EQU   *                                                  M3822
WTOLST3  WTO   'IEE327I USERS=    ',MF=L,DESC=(6),MCSFLAG=(REG0,RESP)
ENDLST3  EQU   *                                                  M3822
ZEROWORK XC    0(WORK3,R3),0(R3)        ZERO OUT WORK AREA        M3822
         DS    0H
* FREECSCB: PROC OPTIONS(NOSAVEAREA,DONTSAVE);
@EL01    BCR   15,@E                                              0206
*           RESTRICT (R2,R3,R6);  /* SAVE MOTHER RTN ADDRESS   Y01012 *
*           RESTRICT (R4);        /* SET REG ASIDE FOR RETURN  Y01012 *
*           R4 = R14;             /* SAVE RETURN ADDRESS       Y01012 *
FREECSCB LR    @4,@E                                              0209
*           CHAD = '0'B;          /* TURN OFF ADD BIT          Y01012 *
         NI    6(@6),B'11110010'                                  0210
*           CHABTERM = '0'B;      /* TURN OFF ABTERM FLAG      Y01012 *
*           CHDL = '0'B;          /* TURN OFF DELETE FLAG      Y01012 *
*           CHFC = '1'B;          /* INDICATE FREE             Y01012 *
         OI    6(@6),B'00000010'                                  0213
*           R1 = R6;              /* SET PTR TO CSCB           Y01012 *
         LR    @1,@6                                              0214
*           GEN(MGCR  (1),CHAIN); /* FREE CORE FOR CSCB        Y01012 *
         MGCR  (1),CHAIN
         DS    0H
*           R14 = R4;             /* RESTORE RETURN ADDRESS    Y01012 *
         LR    @E,@4                                              0216
*           RELEASE (R2,R3,R4,R6);/* RETURN REGISTERS          Y01012 *
* END FREECSCB;
@EL02    BCR   15,@E                                              0218
*         END IEEVDUS1
* /* THE FOLLOWING INCLUDE STATEMENTS WERE FOUND IN THIS PROGRAM.
* /*%INCLUDE SYSLIB  (CVT     )
* /*%INCLUDE SYSLIB  (IKJTSCVT)
* /*%INCLUDE SYSLIB  (IKJTJB  )
* /*%INCLUDE SYSLIB  (IKJRCB  )
* /*%INCLUDE SYSLIB  (IEECHAIN)
* ;
@DATA1   EQU   *
@0       EQU   00                  EQUATES FOR REGISTERS 0-15
@1       EQU   01
@2       EQU   02
@3       EQU   03
@4       EQU   04
@5       EQU   05
@6       EQU   06
@7       EQU   07
@8       EQU   08
@9       EQU   09
@A       EQU   10
@B       EQU   11
@C       EQU   12
@D       EQU   13
@E       EQU   14
@F       EQU   15
@D1      DC    H'48'
@D2      DC    H'9'
@D3      DC    H'1'
@D4      DC    H'58'
@D5      DC    H'4'
@MVC     MVC   0(1,@A),0(@E)
         DS    0F
@SIZ001  DC    AL1(&SPN)
         DC    AL3(@DATEND-@DATD)
         DS    0F
         DS    0D
@DATA    EQU   *
CALLPARM EQU   00000000            FULLWORD POINTER
R0       EQU   00000000            FULLWORD INTEGER REGISTER
R1       EQU   00000001            FULLWORD POINTER REGISTER
R2       EQU   00000002            FULLWORD INTEGER REGISTER
R3       EQU   00000003            FULLWORD POINTER REGISTER
R4       EQU   00000004            FULLWORD INTEGER REGISTER
R6       EQU   00000006            FULLWORD POINTER REGISTER
R7       EQU   00000007            FULLWORD POINTER REGISTER
R11      EQU   00000011            FULLWORD POINTER REGISTER
R12      EQU   00000012            FULLWORD POINTER REGISTER
R15      EQU   00000015            FULLWORD INTEGER REGISTER
R14      EQU   00000014            FULLWORD INTEGER REGISTER
WORK1    EQU   00000004            FULLWORD POINTER REGISTER
WORK2    EQU   00000005            FULLWORD POINTER REGISTER
WORK3    EQU   00000007            FULLWORD POINTER REGISTER
CVTPTR   EQU   00000016            FULLWORD POINTER
CVTMAP   EQU   00000000            368 BYTE(S) ON WORD
CVTTCBP  EQU   CVTMAP+00000000     FULLWORD POINTER
CVT0EF00 EQU   CVTMAP+00000004     FULLWORD POINTER
CVTLINK  EQU   CVTMAP+00000008     FULLWORD POINTER
CVTJOB   EQU   CVTMAP+00000012     FULLWORD POINTER
CVTBUF   EQU   CVTMAP+00000016     FULLWORD POINTER
CVTXAPG  EQU   CVTMAP+00000020     FULLWORD POINTER
CVT0VL00 EQU   CVTMAP+00000024     FULLWORD POINTER
CVTPCNVT EQU   CVTMAP+00000028     FULLWORD POINTER
CVTPRLTV EQU   CVTMAP+00000032     FULLWORD POINTER
CVTILK1  EQU   CVTMAP+00000036     FULLWORD POINTER
CVTILK2  EQU   CVTMAP+00000040     FULLWORD POINTER
CVTXTLER EQU   CVTMAP+00000044     FULLWORD POINTER
CVTSYSAD EQU   CVTMAP+00000048     FULLWORD POINTER
CVTBTERM EQU   CVTMAP+00000052     FULLWORD POINTER
CVTDATE  EQU   CVTMAP+00000056     4 BYTE(S)
CVTMSLT  EQU   CVTMAP+00000060     FULLWORD POINTER
CVTZDTAB EQU   CVTMAP+00000064     FULLWORD POINTER
CVTXITP  EQU   CVTMAP+00000068     FULLWORD POINTER
CVTDAR   EQU   CVTMAP+00000072     FULLWORD POINTER
CVTFLGS1 EQU   CVTMAP+00000072     8 BIT(S)
CVTDMPLK EQU   CVTMAP+00000072     1 BIT(S)
A00000   EQU   CVTMAP+00000072     7 BIT(S)
CVTDARA  EQU   CVTMAP+00000073     3  BYTE  POINTER ON WORD+1
CVT0FN00 EQU   CVTMAP+00000076     FULLWORD POINTER
CVTEXIT  EQU   CVTMAP+00000080     2 BYTE(S)
CVTBRET  EQU   CVTMAP+00000082     2 BYTE(S)
CVTSVDCB EQU   CVTMAP+00000084     FULLWORD POINTER
CVTTPC   EQU   CVTMAP+00000088     FULLWORD POINTER
CVTPBLDL EQU   CVTMAP+00000092     FULLWORD POINTER
CVTSJQ   EQU   CVTMAP+00000096     FULLWORD POINTER
CVTCUCB  EQU   CVTMAP+00000100     FULLWORD POINTER
CVTQTE00 EQU   CVTMAP+00000104     FULLWORD POINTER
CVTQTD00 EQU   CVTMAP+00000108     FULLWORD POINTER
CVTSTB   EQU   CVTMAP+00000112     FULLWORD POINTER
CVTDCB   EQU   CVTMAP+00000116     1 BYTE(S)
A00001   EQU   CVTMAP+00000116     1 BIT(S)
CVT1SSS  EQU   CVTMAP+00000116     1 BIT(S)
CVT2SPS  EQU   CVTMAP+00000116     1 BIT(S)
CVT4MS1  EQU   CVTMAP+00000116     1 BIT(S)
A00002   EQU   CVTMAP+00000116     1 BIT(S)
CVT4MPS  EQU   CVTMAP+00000116     1 BIT(S)
CVT6DAT  EQU   CVTMAP+00000116     1 BIT(S)
A00003   EQU   CVTMAP+00000116     1 BIT(S)
CVTDCBA  EQU   CVTMAP+00000117     3  BYTE  POINTER ON WORD+1
CVTIOQET EQU   CVTMAP+00000120     FULLWORD POINTER
CVTIXAVL EQU   CVTMAP+00000124     FULLWORD POINTER
CVTNUCB  EQU   CVTMAP+00000128     FULLWORD POINTER
CVTFBOSV EQU   CVTMAP+00000132     FULLWORD POINTER
CVT0DS   EQU   CVTMAP+00000136     FULLWORD POINTER
CVTILCH  EQU   CVTMAP+00000140     FULLWORD POINTER
CVTIERLC EQU   CVTMAP+00000144     FULLWORD POINTER
CVTMSER  EQU   CVTMAP+00000148     FULLWORD POINTER
CVT0PT01 EQU   CVTMAP+00000152     FULLWORD POINTER
A00004   EQU   CVTMAP+00000156     FULLWORD POINTER
CVTHEAD  EQU   CVTMAP+00000160     FULLWORD POINTER
CVTMZ00  EQU   CVTMAP+00000164     FULLWORD POINTER
CVT1EF00 EQU   CVTMAP+00000168     FULLWORD POINTER
CVTQOCR  EQU   CVTMAP+00000172     FULLWORD POINTER
CVTQMWR  EQU   CVTMAP+00000176     FULLWORD POINTER
CVTSNCTR EQU   CVTMAP+00000180     HALFWORD INTEGER
CVTOPTA  EQU   CVTMAP+00000182     1 BYTE(S)
CVTCCH   EQU   CVTMAP+00000182     1 BIT(S)
CVTAPR   EQU   CVTMAP+00000182     1 BIT(S)
CVTDDR   EQU   CVTMAP+00000182     1 BIT(S)
CVTNIP   EQU   CVTMAP+00000182     1 BIT(S)
A00005   EQU   CVTMAP+00000182     2 BIT(S)
CVTASCII EQU   CVTMAP+00000182     1 BIT(S)
CVTXPFP  EQU   CVTMAP+00000182     1 BIT(S)
CVTOPTB  EQU   CVTMAP+00000183     1 BYTE(S)
CVTPROT  EQU   CVTMAP+00000183     1 BIT(S)
A00006   EQU   CVTMAP+00000183     1 BIT(S)
CVTTOD   EQU   CVTMAP+00000183     1 BIT(S)
CVTNLOG  EQU   CVTMAP+00000183     1 BIT(S)
A00007   EQU   CVTMAP+00000183     1 BIT(S)
CVTFP    EQU   CVTMAP+00000183     1 BIT(S)
A00008   EQU   CVTMAP+00000183     2 BIT(S)
CVTQCDSR EQU   CVTMAP+00000184     FULLWORD POINTER
CVTQLPAQ EQU   CVTMAP+00000188     FULLWORD POINTER
A00009   EQU   CVTMAP+00000192     FULLWORD POINTER
CVTSMCA  EQU   CVTMAP+00000196     FULLWORD POINTER
CVTABEND EQU   CVTMAP+00000200     FULLWORD POINTER
CVTUSER  EQU   CVTMAP+00000204     FULLWORD POINTER
CVTMDLDS EQU   CVTMAP+00000208     FULLWORD POINTER
CVTQABST EQU   CVTMAP+00000212     2 BYTE(S)
CVTLNKSC EQU   CVTMAP+00000214     2 BYTE(S)
CVTTSCE  EQU   CVTMAP+00000216     FULLWORD POINTER
CVTPATCH EQU   CVTMAP+00000220     FULLWORD POINTER
CVTRMS   EQU   CVTMAP+00000224     FULLWORD POINTER
CVTTSCVT EQU   CVTMAP+00000228     FULLWORD POINTER
CVTTSFLG EQU   CVTMAP+00000228     1 BYTE(S)
CVTTSRDY EQU   CVTMAP+00000228     1 BIT(S)
A00010   EQU   CVTMAP+00000228     7 BIT(S)
CVTTSCVB EQU   CVTMAP+00000229     3  BYTE  POINTER ON WORD+1
CVT0SCR1 EQU   CVTMAP+00000232     FULLWORD POINTER
CVTGTF   EQU   CVTMAP+00000236     FULLWORD POINTER
CVTGTFST EQU   CVTMAP+00000236     8 BIT(S)
CVTGTFS  EQU   CVTMAP+00000236     2 BIT(S)
CVTSTATE EQU   CVTMAP+00000236     1 BIT(S)
CVTTMODE EQU   CVTMAP+00000236     1 BIT(S)
CVTFORM  EQU   CVTMAP+00000236     1 BIT(S)
CVTUSR   EQU   CVTMAP+00000236     1 BIT(S)
A00011   EQU   CVTMAP+00000236     2 BIT(S)
CVTGTFA  EQU   CVTMAP+00000237     3  BYTE  POINTER ON WORD+1
CVTAQAVT EQU   CVTMAP+00000240     FULLWORD POINTER
CVTTCMFG EQU   CVTMAP+00000240     1 BYTE(S)
CVTTCRDY EQU   CVTMAP+00000240     1 BIT(S)
A00012   EQU   CVTMAP+00000240     7 BIT(S)
CVTAQAVB EQU   CVTMAP+00000241     3  BYTE  POINTER ON WORD+1
CVTTATA  EQU   CVTMAP+00000244     FULLWORD POINTER
CVTTSKS  EQU   CVTMAP+00000244     1  BYTE  POINTER
CVTTAT   EQU   CVTMAP+00000245     3  BYTE  POINTER ON WORD+1
CVTATER  EQU   CVTMAP+00000248     FULLWORD POINTER
CVTSYST  EQU   CVTMAP+00000248     1  BYTE  POINTER
CVTATERA EQU   CVTMAP+00000249     3  BYTE  POINTER ON WORD+1
CVTEXT1  EQU   CVTMAP+00000252     FULLWORD POINTER
CVTCBSP  EQU   CVTMAP+00000256     FULLWORD POINTER
CVTPURG  EQU   CVTMAP+00000260     FULLWORD POINTER
A00013   EQU   CVTMAP+00000260     1 BYTE(S)
CVTPURGA EQU   CVTMAP+00000261     3  BYTE  POINTER ON WORD+1
CVTAMFF  EQU   CVTMAP+00000264     4 BYTE(S)
CVTQMSG  EQU   CVTMAP+00000268     FULLWORD POINTER
A00014   EQU   CVTMAP+00000268     1 BYTE(S)
CVTQMSGA EQU   CVTMAP+00000269     3  BYTE  POINTER ON WORD+1
CVTDMSR  EQU   CVTMAP+00000272     FULLWORD POINTER
A00015   EQU   CVTMAP+00000272     1 BYTE(S)
CVTDMSRA EQU   CVTMAP+00000273     3  BYTE  POINTER ON WORD+1
A00016   EQU   CVTMAP+00000276     8 BYTE(S)
CVTREAL  EQU   CVTMAP+00000284     FULLWORD POINTER
CVTPTRV  EQU   CVTMAP+00000288     FULLWORD POINTER
CVTMODE  EQU   CVTMAP+00000292     FULLWORD POINTER
CVTJESCT EQU   CVTMAP+00000296     FULLWORD POINTER
CVTJEPS  EQU   CVTMAP+00000300     FULLWORD POINTER
CVTTZ    EQU   CVTMAP+00000304     FULLWORD INTEGER
CVTMCHPR EQU   CVTMAP+00000308     FULLWORD POINTER
CVTEORM  EQU   CVTMAP+00000312     FULLWORD POINTER
CVTERPV  EQU   CVTMAP+00000316     FULLWORD POINTER
CVTINTLA EQU   CVTMAP+00000320     FULLWORD POINTER
CVTAPF   EQU   CVTMAP+00000324     FULLWORD POINTER
A00017   EQU   CVTMAP+00000324     1 BYTE(S)
CVTAPFA  EQU   CVTMAP+00000325     3  BYTE  POINTER ON WORD+1
CVTEXT2  EQU   CVTMAP+00000328     FULLWORD POINTER
A00018   EQU   CVTMAP+00000328     1 BYTE(S)
CVTEXT2A EQU   CVTMAP+00000329     3  BYTE  POINTER ON WORD+1
CVTHJES  EQU   CVTMAP+00000332     FULLWORD POINTER
A00019   EQU   CVTMAP+00000332     1 BYTE(S)
CVTHJESA EQU   CVTMAP+00000333     3  BYTE  POINTER ON WORD+1
A00020   EQU   CVTMAP+00000336     12 BYTE(S)
CVTPGSIA EQU   CVTMAP+00000348     FULLWORD POINTER
CVTPCVT  EQU   CVTMAP+00000352     FULLWORD POINTER
CVTA1F1  EQU   CVTMAP+00000356     1 BYTE(S)
CVTPFSW  EQU   CVTMAP+00000356     1 BIT(S)
CVTSRSW  EQU   CVTMAP+00000356     1 BIT(S)
A00021   EQU   CVTMAP+00000356     6 BIT(S)
CVTSYSK  EQU   CVTMAP+00000357     1 BYTE(S)
A00022   EQU   CVTMAP+00000357     4 BIT(S)
CVTSLKR  EQU   CVTMAP+00000357     1 BIT(S)
CVTSLKQ  EQU   CVTMAP+00000357     1 BIT(S)
CVTSLKP  EQU   CVTMAP+00000357     1 BIT(S)
CVTSLKO  EQU   CVTMAP+00000357     1 BIT(S)
CVTSULK  EQU   CVTMAP+00000358     HALFWORD INTEGER
CVTSMF   EQU   CVTMAP+00000360     FULLWORD POINTER
CVTPNWFR EQU   CVTMAP+00000364     FULLWORD POINTER
CVTS01   EQU   00000348            92 BYTE(S) ON WORD
A00023   EQU   CVTS01+00000000     FULLWORD POINTER
CVTLPDSR EQU   CVTS01+00000004     FULLWORD POINTER
CVTPVTP  EQU   CVTS01+00000008     FULLWORD POINTER
CVTLPDIA EQU   CVTS01+00000012     FULLWORD POINTER
CVTDIRST EQU   CVTS01+00000012     1 BYTE(S)
CVTDICOM EQU   CVTS01+00000012     1 BIT(S)
A00024   EQU   CVTS01+00000012     7 BIT(S)
CVTLPDIR EQU   CVTS01+00000013     3  BYTE  POINTER ON WORD+1
CVTPAGE1 EQU   CVTS01+00000016     FULLWORD POINTER
CVTPGSUP EQU   CVTS01+00000020     FULLWORD POINTER
CVTSLIDA EQU   CVTS01+00000024     4 BYTE(S) ON WORD
CVTSYLK  EQU   CVTS01+00000024     1 BYTE(S)
CVTSLID  EQU   CVTS01+00000025     3 BYTE(S)
CVTSER   EQU   CVTS01+00000028     FULLWORD POINTER
CVTSEFLG EQU   CVTS01+00000028     1 BYTE(S)
CVTSEIC  EQU   CVTS01+00000028     1 BIT(S)
A00025   EQU   CVTS01+00000028     7 BIT(S)
CVTSERA  EQU   CVTS01+00000029     3  BYTE  POINTER ON WORD+1
CVTSEG   EQU   CVTS01+00000032     16 BYTE(S) ON WORD
CVTSEGA  EQU   CVTS01+00000032     FULLWORD POINTER
CVTSEGB  EQU   CVTS01+00000036     FULLWORD POINTER
CVTSEGC  EQU   CVTS01+00000040     FULLWORD POINTER
CVTSEGLC EQU   CVTS01+00000040     1  BYTE  POINTER
CVTSEGCA EQU   CVTS01+00000041     3  BYTE  POINTER ON WORD+1
CVTSEGD  EQU   CVTS01+00000044     FULLWORD POINTER
CVTSEGLD EQU   CVTS01+00000044     1  BYTE  POINTER
CVTSEGDA EQU   CVTS01+00000045     3  BYTE  POINTER ON WORD+1
A00026   EQU   CVTS01+00000048     1 BYTE(S)
CVTSPVLK EQU   CVTS01+00000049     1  BYTE  POINTER
CVTCTLFG EQU   CVTS01+00000050     1 BYTE(S)
CVTPSIC  EQU   CVTS01+00000050     1 BIT(S)
CVTAPGB  EQU   CVTS01+00000050     1 BIT(S)
A00027   EQU   CVTS01+00000050     1 BIT(S)
CVTDSTAT EQU   CVTS01+00000050     1 BIT(S)
A00028   EQU   CVTS01+00000050     2 BIT(S)
CVTGTRCE EQU   CVTS01+00000050     1 BIT(S)
CVTSDTRC EQU   CVTS01+00000050     1 BIT(S)
CVTAPG   EQU   CVTS01+00000051     1 BYTE(S)
CVTTRACE EQU   CVTS01+00000052     2 BYTE(S)
CVTTRAC2 EQU   CVTS01+00000054     2 BYTE(S)
CVTRSCN  EQU   CVTS01+00000056     FULLWORD POINTER
CVTTAS   EQU   CVTS01+00000060     FULLWORD POINTER
CVTPVALD EQU   CVTS01+00000064     FULLWORD POINTER
CVTSHRVM EQU   CVTS01+00000068     FULLWORD POINTER
CVT0VL01 EQU   CVTS01+00000072     FULLWORD POINTER
CVTPFIXQ EQU   CVTS01+00000076     FULLWORD POINTER
CVTPFIXR EQU   CVTS01+00000080     FULLWORD POINTER
CVTPFIXP EQU   CVTS01+00000084     FULLWORD POINTER
CVTPTCD  EQU   CVTS01+00000088     FULLWORD POINTER
CVTXTNT1 EQU   00000000            4 BYTE(S) ON WORD
CVTFACHN EQU   CVTXTNT1+00000000   FULLWORD POINTER
CVTXTNT2 EQU   00000000            32 BYTE(S) ON WORD
CVTDSSV  EQU   CVTXTNT2+00000000   FULLWORD POINTER
A00029   EQU   CVTXTNT2+00000000   1 BYTE(S)
CVTDSSVA EQU   CVTXTNT2+00000001   3  BYTE  POINTER ON WORD+1
CVTNUCLS EQU   CVTXTNT2+00000004   1 BYTE(S)
A00030   EQU   CVTXTNT2+00000005   3 BYTE(S)
CVTDEBVR EQU   CVTXTNT2+00000008   FULLWORD POINTER
A00031   EQU   CVTXTNT2+00000012   3*FULLWORD INTEGER
CVTQID   EQU   CVTXTNT2+00000024   FULLWORD POINTER
A00032   EQU   CVTXTNT2+00000024   1 BYTE(S)
CVTQIDA  EQU   CVTXTNT2+00000025   3  BYTE  POINTER ON WORD+1
CVTOLTEP EQU   CVTXTNT2+00000028   FULLWORD POINTER
CVTFIX   EQU   00000256            256 BYTE(S) ON WORD
A00033   EQU   CVTFIX+00000000     248 BYTE(S)
A00034   EQU   CVTFIX+00000248     2 BYTE(S)
CVTMDL   EQU   CVTFIX+00000250     2 BYTE(S)
CVTRELNO EQU   CVTFIX+00000252     4 BYTE(S)
CVTNUMB  EQU   CVTFIX+00000252     2 BYTE(S)
CVTLEVL  EQU   CVTFIX+00000254     2 BYTE(S)
TSCVT    EQU   00000000            152 BYTE(S) ON WORD
TSCVTTJB EQU   TSCVT+00000000      FULLWORD POINTER
TSCVTRCB EQU   TSCVT+00000004      FULLWORD POINTER
TSCVTRPT EQU   TSCVT+00000008      FULLWORD POINTER
TSCVTFLG EQU   TSCVT+00000012      2 BYTE(S)
A00035   EQU   TSCVT+00000012      1 BIT(S)
TSCSWPBG EQU   TSCVT+00000012      1 BIT(S)
TSCLOGON EQU   TSCVT+00000012      1 BIT(S)
TSCDISC  EQU   TSCVT+00000012      1 BIT(S)
TSCVTTHR EQU   TSCVT+00000012      1 BIT(S)
TSCVTFL1 EQU   TSCVT+00000014      2 BYTE(S)
TSCSSTOP EQU   TSCVT+00000014      1 BIT(S)
TSCRSTOP EQU   TSCVT+00000014      1 BIT(S)
TSCASTOP EQU   TSCVT+00000014      1 BIT(S)
TSCTSTOP EQU   TSCVT+00000014      1 BIT(S)
A00036   EQU   TSCVT+00000014      1 BIT(S)
A00037   EQU   TSCVT+00000014      1 BIT(S)
A00038   EQU   TSCVT+00000014      1 BIT(S)
A00039   EQU   TSCVT+00000014      1 BIT(S)
TSCVTI04 EQU   TSCVT+00000016      FULLWORD POINTER
TSCVTCUS EQU   TSCVT+00000020      HALFWORD INTEGER
TSCVTLUS EQU   TSCVT+00000022      HALFWORD INTEGER
TSCVTNTJ EQU   TSCVT+00000024      HALFWORD INTEGER
TSCVTSZU EQU   TSCVT+00000026      HALFWORD INTEGER
TSCVTCTR EQU   TSCVT+00000028      HALFWORD INTEGER
TSCVTMUS EQU   TSCVT+00000030      HALFWORD INTEGER
TSCVTSAV EQU   TSCVT+00000032      FULLWORD POINTER
TSCVTECB EQU   TSCVT+00000036      FULLWORD POINTER
TSCVTSIA EQU   TSCVT+00000040      FULLWORD POINTER
TSCVTICB EQU   TSCVT+00000044      FULLWORD POINTER
TSCVTI01 EQU   TSCVT+00000048      FULLWORD POINTER
TSCVTTQE EQU   TSCVT+00000052      FULLWORD POINTER
TSCVTI02 EQU   TSCVT+00000056      FULLWORD POINTER
TSCVTI03 EQU   TSCVT+00000060      FULLWORD POINTER
TSCVTD02 EQU   TSCVT+00000064      FULLWORD POINTER
TSCVTLCQ EQU   TSCVT+00000068      FULLWORD POINTER
TSCVTTRB EQU   TSCVT+00000072      FULLWORD POINTER
TSCVTLPA EQU   TSCVT+00000076      FULLWORD POINTER
TSCVTSLF EQU   TSCVT+00000080      FULLWORD INTEGER
TSCVTTSC EQU   TSCVT+00000084      FULLWORD POINTER
TSCVTSPL EQU   TSCVT+00000088      FULLWORD POINTER
TSCVTRSZ EQU   TSCVT+00000092      HALFWORD INTEGER
A00040   EQU   TSCVT+00000094      2 BYTE(S)
TSCVTSVT EQU   TSCVT+00000096      4 BYTE(S)
TSCVTSVQ EQU   TSCVT+00000100      4 BYTE(S)
TSCVTABN EQU   TSCVT+00000104      FULLWORD POINTER
TSCVTD03 EQU   TSCVT+00000108      FULLWORD POINTER
TSCVTFLM EQU   TSCVT+00000112      FULLWORD POINTER
TSCVTQTP EQU   TSCVT+00000116      FULLWORD POINTER
TSCVTT08 EQU   TSCVT+00000120      FULLWORD POINTER
TSCVTDMP EQU   TSCVT+00000124      FULLWORD POINTER
TSCVTT06 EQU   TSCVT+00000128      FULLWORD POINTER
TSCVTLS3 EQU   TSCVT+00000132      FULLWORD POINTER
TSCVTSMI EQU   TSCVT+00000136      FULLWORD POINTER
TSCVTMSG EQU   TSCVT+00000140      FULLWORD POINTER
TSCVTSCN EQU   TSCVT+00000144      FULLWORD POINTER
TSCVTR01 EQU   TSCVT+00000148      FULLWORD POINTER
TJB      EQU   00000000            48 BYTE(S) ON WORD
TJBTSB   EQU   TJB+00000000        FULLWORD POINTER
TJBATTN  EQU   TJB+00000004        1 BYTE(S)
TJBSTAX  EQU   TJB+00000005        1 BYTE(S)
TJBSTAT  EQU   TJB+00000006        1 BYTE(S)
TJBNJB   EQU   TJB+00000006        1 BIT(S)
TJBINCOR EQU   TJB+00000006        1 BIT(S)
TJBLOGON EQU   TJB+00000006        1 BIT(S)
TJBIWAIT EQU   TJB+00000006        1 BIT(S)
TJBOWAIT EQU   TJB+00000006        1 BIT(S)
TJBSILF  EQU   TJB+00000006        1 BIT(S)
TJBDISC  EQU   TJB+00000006        1 BIT(S)
TJBSILF2 EQU   TJB+00000006        1 BIT(S)
TJBSTAT2 EQU   TJB+00000007        1 BYTE(S)
TJBHUNG  EQU   TJB+00000007        1 BIT(S)
TJBHOLD  EQU   TJB+00000007        1 BIT(S)
TJBOCAB  EQU   TJB+00000007        1 BIT(S)
TJBRNAV  EQU   TJB+00000007        1 BIT(S)
TJBSURSV EQU   TJB+00000007        1 BIT(S)
TJBQUIS  EQU   TJB+00000007        1 BIT(S)
TJBUSERR EQU   TJB+00000007        1 BIT(S)
TJBDEAD  EQU   TJB+00000007        1 BIT(S)
TJBEXTNT EQU   TJB+00000008        FULLWORD POINTER
TJBRCB   EQU   TJB+00000012        FULLWORD POINTER
A00041   EQU   TJB+00000016        FULLWORD POINTER
TJBSPCT  EQU   TJB+00000020        FULLWORD POINTER
A00042   EQU   TJB+00000024        HALFWORD INTEGER
TJBRSTOR EQU   TJB+00000026        1 BYTE(S)
TJBOWP   EQU   TJB+00000026        1 BIT(S)
TJBIWP   EQU   TJB+00000026        1 BIT(S)
A00043   EQU   TJB+00000026        1 BIT(S)
TJBLOGP  EQU   TJB+00000026        1 BIT(S)
TJBLWAIT EQU   TJB+00000026        1 BIT(S)
TJBDDRD  EQU   TJB+00000026        1 BIT(S)
TJBFAT   EQU   TJB+00000026        1 BIT(S)
TJBDDRND EQU   TJB+00000026        1 BIT(S)
A00044   EQU   TJB+00000027        1 BYTE(S)
TJBUSER  EQU   TJB+00000028        8 BYTE(S)
TJBIPPB  EQU   TJB+00000036        FULLWORD INTEGER
TJBNEWID EQU   TJB+00000040        1  BYTE  POINTER
TJBFLUSL EQU   TJB+00000041        1 BYTE(S)
TJBTJID  EQU   TJB+00000042        HALFWORD INTEGER
TJBMONI  EQU   TJB+00000044        1 BYTE(S)
TJBMDSN  EQU   TJB+00000044        1 BIT(S)
TJBMJBN  EQU   TJB+00000044        1 BIT(S)
TJBMSES  EQU   TJB+00000044        1 BIT(S)
TJBMSPA  EQU   TJB+00000044        1 BIT(S)
TJBMSTA  EQU   TJB+00000044        1 BIT(S)
TJBGETBF EQU   TJB+00000044        1 BIT(S)
A00045   EQU   TJB+00000044        1 BIT(S)
A00046   EQU   TJB+00000044        1 BIT(S)
TJBSTAT3 EQU   TJB+00000045        1 BYTE(S)
TJBDISC2 EQU   TJB+00000045        1 BIT(S)
TJBSOEM  EQU   TJB+00000045        1 BIT(S)
TJBLOGTM EQU   TJB+00000045        1 BIT(S)
TJBLINE  EQU   TJB+00000046        2 BYTE(S)
RCB      EQU   00000000            76 BYTE(S) ON WORD
RCBRCT   EQU   RCB+00000000        FULLWORD POINTER
RCBECB   EQU   RCB+00000004        FULLWORD INTEGER
RCBDIECB EQU   RCB+00000008        FULLWORD INTEGER
RCBTJID  EQU   RCB+00000012        HALFWORD INTEGER
RCBRSIZE EQU   RCB+00000014        HALFWORD INTEGER
RCBCOMM  EQU   RCB+00000016        HALFWORD INTEGER
RCBNMBR  EQU   RCB+00000018        1 BYTE(S)
RCBFLG   EQU   RCB+00000019        1 BYTE(S)
RCBFQU   EQU   RCB+00000019        1 BIT(S)
RCBFSO   EQU   RCB+00000019        1 BIT(S)
RCBFSI   EQU   RCB+00000019        1 BIT(S)
RCBFRS   EQU   RCB+00000019        1 BIT(S)
RCBOCAB  EQU   RCB+00000019        1 BIT(S)
RCBABRT  EQU   RCB+00000019        1 BIT(S)
RCBFAT   EQU   RCB+00000019        1 BIT(S)
RCBFND   EQU   RCB+00000019        1 BIT(S)
RCBFLG2  EQU   RCB+00000020        1 BYTE(S)
RCBRDY   EQU   RCB+00000020        1 BIT(S)
RCBSTOP  EQU   RCB+00000020        1 BIT(S)
RCBACTV  EQU   RCB+00000020        1 BIT(S)
RCBSTR1  EQU   RCB+00000020        1 BIT(S)
RCBSTR2  EQU   RCB+00000020        1 BIT(S)
RCBDEAD  EQU   RCB+00000020        1 BIT(S)
RCBLOGPR EQU   RCB+00000020        1 BIT(S)
RCBMODFY EQU   RCB+00000020        1 BIT(S)
A00047   EQU   RCB+00000021        1 BYTE(S)
RCBCUSE  EQU   RCB+00000022        HALFWORD INTEGER
RCBEXTNT EQU   RCB+00000024        FULLWORD POINTER
RCBSPCT  EQU   RCB+00000028        FULLWORD POINTER
RCBTMECB EQU   RCB+00000032        FULLWORD POINTER
RCBPRG   EQU   RCB+00000036        12 BYTE(S)
RCBQPL   EQU   RCB+00000048        FULLWORD POINTER
RCBSTECB EQU   RCB+00000052        FULLWORD INTEGER
RCBRCOVR EQU   RCB+00000056        1 BYTE(S)
RCBRSFLG EQU   RCB+00000057        1 BYTE(S)
RCBRSTRT EQU   RCB+00000057        1 BIT(S)
RCBTCBDN EQU   RCB+00000057        1 BIT(S)
RCBQELCM EQU   RCB+00000057        1 BIT(S)
RCBTQECM EQU   RCB+00000057        1 BIT(S)
RCBRQIQC EQU   RCB+00000057        1 BIT(S)
RCBIORSC EQU   RCB+00000057        1 BIT(S)
RCBWTORC EQU   RCB+00000057        1 BIT(S)
RCBSQECM EQU   RCB+00000057        1 BIT(S)
RCBQUFLG EQU   RCB+00000058        1 BYTE(S)
RCBQUSTR EQU   RCB+00000058        1 BIT(S)
RCBIOSTR EQU   RCB+00000058        1 BIT(S)
RCBSQEDN EQU   RCB+00000058        1 BIT(S)
RCBWTORD EQU   RCB+00000058        1 BIT(S)
RCBQELDN EQU   RCB+00000058        1 BIT(S)
RCBIODON EQU   RCB+00000058        1 BIT(S)
RCBTQEDN EQU   RCB+00000058        1 BIT(S)
RCBRQIQD EQU   RCB+00000058        1 BIT(S)
RCBSWTCH EQU   RCB+00000059        1 BYTE(S)
RCBSTSP  EQU   RCB+00000059        1 BIT(S)
RCBSWTON EQU   RCB+00000059        1 BIT(S)
RCBEXTRN EQU   RCB+00000059        1 BIT(S)
RCBRMSAL EQU   RCB+00000059        1 BIT(S)
RCBRMS1U EQU   RCB+00000059        1 BIT(S)
RCBZQRF  EQU   RCB+00000059        1 BIT(S)
A00048   EQU   RCB+00000059        1 BIT(S)
A00049   EQU   RCB+00000059        1 BIT(S)
RCBCONID EQU   RCB+00000060        1 BYTE(S)
RCBSTAEN EQU   RCB+00000061        1 BYTE(S)
A00050   EQU   RCB+00000062        2 BYTE(S)
RCBFXECB EQU   RCB+00000064        FULLWORD POINTER
RCBUSPCT EQU   RCB+00000068        FULLWORD POINTER
RCBPQE   EQU   RCB+00000072        FULLWORD POINTER
CHAIN    EQU   00000000            176 BYTE(S) ON WORD
CHPTR    EQU   CHAIN+00000000      FULLWORD POINTER
CHFLG    EQU   CHAIN+00000004      4 BYTE(S)
CHVCD    EQU   CHAIN+00000004      1 BYTE(S)
CHSZE    EQU   CHAIN+00000005      1  BYTE  POINTER
CHSTS    EQU   CHAIN+00000006      1 BYTE(S)
CHAP     EQU   CHAIN+00000006      1 BIT(S)
CHSYS    EQU   CHAIN+00000006      1 BIT(S)
CHSOUT   EQU   CHAIN+00000006      1 BIT(S)
CHQSPC   EQU   CHAIN+00000006      1 BIT(S)
CHAD     EQU   CHAIN+00000006      1 BIT(S)
CHDL     EQU   CHAIN+00000006      1 BIT(S)
CHFC     EQU   CHAIN+00000006      1 BIT(S)
CHABTERM EQU   CHAIN+00000006      1 BIT(S)
CHACT    EQU   CHAIN+00000007      1 BYTE(S)
CHSWAP   EQU   CHAIN+00000007      1 BIT(S)
CHTERM   EQU   CHAIN+00000007      1 BIT(S)
CHDISC   EQU   CHAIN+00000007      1 BIT(S)
CHDSI    EQU   CHAIN+00000007      1 BIT(S)
CHCL     EQU   CHAIN+00000007      1 BIT(S)
CHCLD    EQU   CHAIN+00000007      1 BIT(S)
CHAIFX   EQU   CHAIN+00000007      1 BIT(S)
CHIFY    EQU   CHAIN+00000007      1 BIT(S)
CHKEY    EQU   CHAIN+00000008      8 BYTE(S)
CHCLS    EQU   CHAIN+00000016      8 BYTE(S)
CHUNIT   EQU   CHAIN+00000024      3 BYTE(S)
CHCIBCTR EQU   CHAIN+00000027      1  BYTE  POINTER
CHPKE    EQU   CHAIN+00000028      1 BYTE(S)
CHJBNR   EQU   CHAIN+00000028      1 BYTE(S)
CHJBNRF  EQU   CHAIN+00000028      6 BIT(S)
A00051   EQU   CHAIN+00000028      2 BIT(S)
CHUCMP   EQU   CHAIN+00000029      1 BYTE(S)
CHTJID   EQU   CHAIN+00000030      HALFWORD INTEGER
CHASM    EQU   CHAIN+00000032      144 BYTE(S) ON WORD
CHECBP   EQU   CHAIN+00000032      FULLWORD POINTER
CHCIBP   EQU   CHAIN+00000036      FULLWORD POINTER
CHEND    EQU   CHAIN+00000036      1 BIT(S)
A00052   EQU   CHAIN+00000036      7 BIT(S)
CHRPRTY  EQU   CHAIN+00000040      1 BYTE(S)
A00053   EQU   CHAIN+00000041      3  BYTE  POINTER ON WORD+1
A00054   EQU   CHAIN+00000044      FULLWORD INTEGER
CHECB    EQU   CHAIN+00000048      FULLWORD INTEGER
CHCECB   EQU   CHAIN+00000052      FULLWORD INTEGER
A00055   EQU   CHAIN+00000056      2*FULLWORD INTEGER
CHSHORT  EQU   CHAIN+00000064      112 BYTE(S) ON WORD
CHSWT    EQU   CHAIN+00000064      1 BYTE(S)
CHRESC   EQU   CHAIN+00000064      1 BIT(S)
CHJCT    EQU   CHAIN+00000064      1 BIT(S)
CHPSD    EQU   CHAIN+00000064      1 BIT(S)
CHPSF    EQU   CHAIN+00000064      1 BIT(S)
CHAC     EQU   CHAIN+00000064      1 BIT(S)
CHRESB   EQU   CHAIN+00000064      1 BIT(S)
A00056   EQU   CHAIN+00000064      2 BIT(S)
CHTCB    EQU   CHAIN+00000065      3  BYTE  POINTER ON WORD+1
CHSPB    EQU   CHAIN+00000068      FULLWORD POINTER
CHSPC    EQU   CHAIN+00000072      FULLWORD POINTER
CHJCL    EQU   CHAIN+00000076      FULLWORD POINTER
CHQPA    EQU   CHAIN+00000080      9*FULLWORD INTEGER
CHSQA    EQU   CHAIN+00000116      9*FULLWORD INTEGER
CHUSC    EQU   CHAIN+00000152      FULLWORD INTEGER
CHJSCB   EQU   CHAIN+00000156      FULLWORD POINTER
A00057   EQU   CHAIN+00000160      4*FULLWORD INTEGER
CHAINS01 EQU   00000032            144 BYTE(S) ON WORD
CHBUF    EQU   CHAINS01+00000000   124 BYTE(S)
CHTYPE   EQU   CHAINS01+00000124   1 BYTE(S)
CHDSTAT  EQU   CHAINS01+00000124   1 BIT(S)
A00058   EQU   CHAINS01+00000124   5 BIT(S)
CHHIAR   EQU   CHAINS01+00000124   1 BIT(S)
CHDEF    EQU   CHAINS01+00000124   1 BIT(S)
CHLSQA   EQU   CHAINS01+00000125   1  BYTE  POINTER
CHCNID   EQU   CHAINS01+00000126   1 BYTE(S)
CHARID   EQU   CHAINS01+00000127   1 BYTE(S)
CHPEND   EQU   CHAINS01+00000128   FULLWORD POINTER
CHINC    EQU   CHAINS01+00000132   HALFWORD INTEGER
CHCSYSO  EQU   CHAINS01+00000134   1 BYTE(S)
CHALL    EQU   CHAINS01+00000134   1 BIT(S)
CHINN    EQU   CHAINS01+00000134   1 BIT(S)
CHOUT    EQU   CHAINS01+00000134   1 BIT(S)
CHHOLD   EQU   CHAINS01+00000134   1 BIT(S)
CHQUE    EQU   CHAINS01+00000134   1 BIT(S)
CHDUMP   EQU   CHAINS01+00000134   1 BIT(S)
CHJB     EQU   CHAINS01+00000134   1 BIT(S)
CHRESD   EQU   CHAINS01+00000134   1 BIT(S)
CHSPA    EQU   CHAINS01+00000135   1 BYTE(S)
A00059   EQU   CHAINS01+00000136   8 BYTE(S)
CHLAST   EQU   CHAINS01+00000144   BYTE(S)
BLANK    EQU   *                   1 BYTE(S)
         DC    C' '
         ORG   @DATA+00000004
ZEROS    EQU   *                   4 BYTE(S) ON WORD
         DC    X'00000000'
PARMAR   EQU   *                   FULLWORD INTEGER
         DC    XL4'00000010'
COMMNAME EQU   @DATA+00000012      13 BYTE(S) ON WORD
A00060   EQU   *                   1  BYTE  POINTER
         DC    XL1'0C'
A00061   EQU   *                   12 BYTE(S)
         DC    C'DISPLAY USER'
PARMLIST EQU   00000000            16 BYTE(S) ON WORD
CSCBADR  EQU   PARMLIST+00000000   FULLWORD POINTER
COMMAND  EQU   PARMLIST+00000004   FULLWORD POINTER
BASEADR  EQU   PARMLIST+00000008   FULLWORD POINTER
R14SAV   EQU   PARMLIST+00000012   FULLWORD POINTER
IDAREA   EQU   00000000            9 BYTE(S) ON WORD
USRID    EQU   IDAREA+00000000     8 BYTE(S)
RGNUM    EQU   IDAREA+00000008     1 BYTE(S)
LTPAREN  EQU   *                   1 BYTE(S)
         DC    C')'
RTPAREN  EQU   *                   1 BYTE(S)
         DC    C'('
OPERAND  EQU   *                   9 BYTE(S)
         DC    C'USER=NMBR'
DESCODE  EQU   *                   FULLWORD INTEGER
         DC    XL4'04000000'
DUSERLMT EQU   *                   HALFWORD INTEGER
         DC    XL2'750'
         ORG   @DATA
         DS    00000042C
@L       EQU   1
@DATD    DSECT
SAVE14   EQU   @DATD+00000000      FULLWORD INTEGER
WTOMSG   EQU   @DATD+00000004      76 BYTE(S) ON WORD
LNGMSG   EQU   WTOMSG+00000000     HALFWORD INTEGER
MCSBITS  EQU   WTOMSG+00000002     HALFWORD INTEGER
MSGTEXT  EQU   WTOMSG+00000004     72 BYTE(S)
CORECNT  EQU   @DATD+00000080      FULLWORD INTEGER
NOUSER   EQU   @DATD+00000084      HALFWORD INTEGER
CNTTJB   EQU   @DATD+00000086      HALFWORD INTEGER
FLAGS    EQU   @DATD+00000088      1 BYTE(S) ON WORD
TPUTFLAG EQU   FLAGS+00000000      1 BIT(S)
UNPKAREA EQU   @DATD+00000096      8 BYTE(S) ON DWORD
CVDAREA  EQU   @DATD+00000104      8 BYTE(S) ON DWORD
         DS    00000112C
@TEMPS   DS    0F
         DS    C
@DATEND  EQU   *
IEEVDUS1 CSECT ,
@9FE     EQU   NOTSO
         END   IEEVDUS1
