         TITLE 'IEFAB424 - BUILD ELIGIBLE DEVICE LIST                  *
                        '
IEFAB424 CSECT ,                                                01S0001
@MAINENT DS    0H                                               01S0001
         USING *,@15                                            01S0001
         B     @PROLOG                                          01S0001
         DC    AL1(16)                                          01S0001
         DC    C'IEFAB424  76.334'                              01S0001
         DROP  @15
@PROLOG  STM   @14,@12,12(@13)                                  01S0001
         BALR  @12,0                                            01S0001
@PSTART  DS    0H                                               01S0001
         USING @PSTART,@12                                      01S0001
         L     @00,@SIZDATD                                     01S0001
         GSPACE   R,LV=(0)
         LR    @11,@01                                          01S0001
         USING @DATD,@11                                        01S0001
         ST    @13,@SA00001+4                                   01S0001
         LM    @00,@01,20(@13)                                  01S0001
         ST    @11,8(,@13)                                      01S0001
         LR    @13,@11                                          01S0001
         MVC   @PC00001(4),0(@01)                               01S0001
*RETNCODE = ZERO;                      /* INITIALIZE ERROR WORD      */
         SLR   @10,@10                                          01S0064
         STH   @10,RETNCODE                                     01S0064
*ATCAPTR = CVTQMWR;                    /*PTR TO AREA WITH IEFAB438 AD*/
         L     @08,CVTPTR                                       01S0065
         MVC   ATCAPTR(4),CVTQMWR(@08)                          01S0065
*SIOTPTR = SIOT1P;                                              01S0066
         L     @15,@PC00001                                     01S0066
         L     @01,ALCWAPTR(,@15)                               01S0066
         L     SIOTPTR,SIOT1P(,@01)                             01S0066
*IF SU24BIT = ON THEN                  /* IF SU 24 INSTALLED @G24LPSJ*/
         L     @01,CVTIHASU(,@08)                               01S0067
         TM    SU24BIT(@01),B'10000000'                         01S0067
         BNO   @RF00067                                         01S0067
*  IF CVTICB ^= ZERO&                  /* THEN IF ICB EXISTS @G24LPSJ*/
*     ICBI = ON&                       /* AND MSS IS INIT.   @G24LPSJ*/
*     ICBB = OFF THEN                  /* AND MSS NOT BROKEN @G24LPSJ*/
         L     @08,CVTEXT2(,@08)                                01S0068
         L     @08,CVTICB(,@08)                                 01S0068
         CR    @08,@10                                          01S0068
         BE    @RF00068                                         01S0068
         TM    ICBI(@08),B'10000000'                            01S0068
         BNO   @RF00068                                         01S0068
         TM    ICBB(@08),B'00010000'                            01S0068
         BNZ   @RF00068                                         01S0068
*    MSSELIG = ON;                     /* SET MSS REQUESTS ELIGIBLE
*                                                            @G24LPSJ*/
         OI    MSSELIG,B'10000000'                              01S0069
*  ELSE                                /* ELSE               @G24LPSJ*/
*    MSSELIG = OFF;                    /* SET MSS REQUEST INELIGIBLE
*                                                            @G24LPSJ*/
         B     @RC00068                                         01S0070
@RF00068 NI    MSSELIG,B'01111111'                              01S0070
*ELSE                                  /* IF NO SU 24 INSTALLED 01S0071
*                                                            @G24LPSJ*/
*  MSSELIG = ON;                       /* SET MSS REQUESTS ELIGIBLE
*                                                            @G24LPSJ*/
         B     @RC00067                                         01S0071
@RF00067 OI    MSSELIG,B'10000000'                              01S0071
*DO SIOTCTR = ONE TO NUMREQS WHILE(RETNCODE=ZERO); /* PROC ALL SIOTS */
@RC00067 LA    @10,1                                            01S0072
         B     @DE00072                                         01S0072
@DL00072 ICM   @10,3,RETNCODE                                   01S0072
         BNZ   @DC00072                                         01S0072
*  RFY EDTHDR BASED(EDTABPTR);         /* SET BASE FOR EDT           */
*  NOBUMP=OFF;                         /* CONTINUE TO BUMP SIOTPTR   */
         NI    NOBUMP,B'01111111'                               01S0074
*  IF SIOTALCD = OFF  THEN             /* SIOT IS NOT ALLOC'D        */
         TM    SIOTALCD(SIOTPTR),B'00000010'                    01S0075
         BNZ   @RF00075                                         01S0075
*    DO;                               /* PROCESS THIS SIOT          */
*      CALL IEFAB438;                  /* GET DDR COUNT              */
         L     @10,ATCAPTR                                      01S0077
         L     @15,ATCA438P(,@10)                               01S0077
         BALR  @14,@15                                          01S0077
*      DDRCNT = REG15;                 /* SAVE DDR COUNT             */
         ST    REG15,DDRCNT                                     01S0078
*      IF SIOTDMND = OFF THEN          /* NOT SPECIFIC UNIT REQUEST  */
         TM    SIOTDMND(SIOTPTR),B'10000000'                    01S0079
         BNZ   @RF00079                                         01S0079
*        DO;                           /* BUILD NON-SPECIFIC EDL     */
*/********************************************************************/
*/*                                                                  */
*/* SEGMENT NAME - BLDNSEDL                                          */
*/*                                                                  */
*/* DESCRIPTIVE NAME - BUILD EDL FOR NON-SPECIFIC UNIT REQUEST       */
*/*                                                                  */
*/* FUNCTION -                                                       */
*/*   THE FUNCTION OF THIS SEGMENT IS TO BUILD THE ELIGIBLE DEVICE   */
*/*   LIST (EDL) FOR A NON-SPECIFIC UNIT REQUEST. THE EDL LISTS ALL  */
*/*   UNITS WHICH A GIVEN REQUEST IS ELIGIBLE TO BE ALLOCATED TO.    */
*/*   THE EDL IS CONSTRUCTED FROM THE ELIGIBLE DEVICE TABLE(EDT).    */
*/*   SEE IEFZB421(EDT MAPPING MACRO) AND IEFZB422(EDL MAPPING MACRO)*/
*/*   FOR AN EXPLANATION OF THE STRUCTURE OF THE EDT AND EDL.        */
*/*                                                                  */
*/* OPERATION -                                                      */
*/*   1. LOCATE THE EDT LOOKUP VALUE ENTRY FOR THIS REQUEST -        */
*/*      THE SIOT CONTAINS A LOOK-UP-VALUE WHICH IS USED AS A SEARCH */
*/*      ARGUMENT INTO THE EDT LOOK-UP-VALUE ENTRIES. THE LOOK-UP-   */
*/*      VALUE IN EACH EDT LOOK-UP-VALUE ENTRY IS COMPARED WITH THE  */
*/*      LOOK-UP-VALUE IN THE SIOT UNTIL A MATCH IS FOUND.           */
*/*                                                                  */
*/*   2. DETERMINE THE SIZE OF THE EDL -                             */
*/*      SIZE OF THE EDL = LENGTH(EDLHDR) +                          */
*/*                        LUVGENNO*LENGTH(EDLENTRY) +               */
*/*                        TOTGRP*LENGTH(EDLGNTRY) +                 */
*/*                        TOTNUM*LENGTH(EDLUCBL)                    */
*/*      WHERE :                                                     */
*/*        LUVGENNO = TOTAL NUMBER OF GENERICS FOR THIS LOOK-UP-VALUE*/
*/*        LENGTH(EDLHDR) = LENGTH OF THE EDL HEADER                 */
*/*        LENGTH(EDLENTRY) = LENGTH OF EACH GENERIC ENTRY IN THE EDL*/
*/*        TOTGRP = TOTAL NUMBER OF GROUPS FOR THIS LOOK-UP-VALUE    */
*/*        LENGTH(EDLGNTRY) = LENGTH OF EACH GROUP ENTRY IN THE EDL  */
*/*        TOTUN = TOTAL NUMBER OF UNITS FOR THIS LOOK-UP-VALUE      */
*/*        LENGTH(EDLUCBL) = LENGTH OF EACH ENTRY IN THE EDL UCB LIST*/
*/*                                                                  */
*/*   3. GET SPACE FOR THE EDL -                                     */
*/*      THE SIZE CALCULATED ABOVE IS USED TO GET SPACE FOR THE      */
*/*      EDL. THE ADDRESS OF THE GOTTEN SPACE IS PUT IN THE SIOT.    */
*/*      THE SIZE IS ALSO PUT IN THE SIOT. IF SPACE IS NOT AVAILABLE */
*/*      FOR THE EDL AN ERROR RETURN CODE IS SET AND A STEP RELATED  */
*/*      REASON CODE INDICATING GETMAIN ERROR IS SET.                */
*/*                                                                  */
*/*   4. FILL IN THE EDL -                                           */
*/*      INFORMATION OBTAINED FROM THE EDT IS USED TO FILL IN THE    */
*/*      EDL.                                                        */
*/*                                                                  */
*/* ENTRY - IN-LINE SEGMENT                                          */
*/*   PURPOSE - SEE FUNCTION                                         */
*/*                                                                  */
*/*   INPUT -                                                        */
*/*     SIOT -                                                       */
*/*       SCTUTYPE(1:4) - LOOK-UP-VALUE(CONVERTED FROM UNIT PARAMETER*/
*/*                                                                  */
*/*     EDT - ELIGIBLE DEVICE TABLE (MAPPED BY IEFZB421)             */
*/*                                                                  */
*/* EXITS -                                                          */
*/* 1 CONDITION - EDL SUCCESSFULLY CONSTRUCTED                       */
*/*                                                                  */
*/*   OUTPUT -                                                       */
*/*     SIOT -                                                       */
*/*       SIOTEDLP - POINTER TO THE EDL                              */
*/*       SIOTEDLS - SIZE OF THE EDL                                 */
*/*                                                                  */
*/*     EDL - ELIGIBLE DEVICE LIST (MAPPED BY IEFZB422)              */
*/*                                                                  */
*/*   RETURN CODE - 0                                                */
*/*                                                                  */
*/* 2 CONDITION - EDL NOT CONSTRUCTED                                */
*/*                                                                  */
*/*   OUTPUT -                                                       */
*/*     STEPRSNC - STEP RELATED REASON CODE                          */
*/*       2 = GETMAIN FAILURE                                        */
*/*       8 = INVALID UNIT TYPE                                      */
*/*                                                                  */
*/*     SIOTRSNC =- DD RELATED REASON CODE -                         */
*/*       10 = INSUFFICIENT UNITS TO SATISFY REQUEST.                */
*/*       72 = MSS NOT UP FOR SINGLE GENERIC REQ             @G24LPSJ*/
*/*                                                                  */
*/*   RETURN CODE - 4                                                */
*/*                                                                  */
*/********************************************************************/
*LUVPTR = EDTLUVSP + LENGTH(LUVHDR);   /* ADDR OF FIRST EDT LUVENTRY */
         L     @08,@PC00001                                     02S0081
         L     @08,ALCWAPTR(,@08)                               02S0081
         L     @08,EDTABPTR(,@08)                               02S0081
         LA    LUVPTR,8                                         02S0081
         AL    LUVPTR,EDTLUVSP(,@08)                            02S0081
*LUVFNDSW = OFF;                       /* LUV NOT YET FOUND IN EDT   */
         NI    LUVFNDSW,B'01111111'                             02S0082
*DO LUVCTR = ONE TO LUVENTNO           /* SEARCH ALL LUV ENTRIES     */
*    WHILE (LUVFNDSW = OFF);           /* UNTIL A MATCH IS FOUND     */
         LA    LUVCTR,1                                         02S0083
         B     @DE00083                                         02S0083
@DL00083 TM    LUVFNDSW,B'10000000'                             02S0083
         BNZ   @DC00083                                         02S0083
*  IF SCTUTYPE(1:4) = LUVALUE THEN     /* LUV FOUND                  */
         CLC   SCTUTYPE(4,SIOTPTR),LUVALUE(LUVPTR)              02S0084
         BNE   @RF00084                                         02S0084
*    LUVFNDSW = ON;                    /* TURN FOUND SW ON           */
         OI    LUVFNDSW,B'10000000'                             02S0085
*  ELSE                                /* NOT RIGHT LUV SECTION      */
*    LUVPTR = LUVPTR + LENGTH(LUVENTRY); /* NEXT LUV ENTRY           */
         B     @RC00084                                         02S0086
@RF00084 AH    LUVPTR,@CH00092                                  02S0086
*END;                                  /* END SEARCH ALL LUV ENTRIES */
@RC00084 AH    LUVCTR,@CH00051                                  02S0087
@DE00083 L     @08,@PC00001                                     02S0087
         L     @08,ALCWAPTR(,@08)                               02S0087
         L     @08,EDTABPTR(,@08)                               02S0087
         L     @08,EDTLUVSP(,@08)                               02S0087
         C     LUVCTR,LUVENTNO(,@08)                            02S0087
         BNH   @DL00083                                         02S0087
@DC00083 DS    0H                                               02S0088
*IF LUVFNDSW = ON THEN                 /* LUV WAS FOUND IN THE EDT   */
         TM    LUVFNDSW,B'10000000'                             02S0088
         BNO   @RF00088                                         02S0088
*  DO;                                 /* BUILD THE EDL FOR THIS SIOT*/
*    TOTGRP = ZERO;                    /* INIT TOTAL NUMBR OF GROUPS */
         SLR   @08,@08                                          02S0090
         ST    @08,TOTGRP                                       02S0090
*    TOTUN = ZERO;                     /* INIT TOTAL NUMBER OF UNITS */
         SLR   TOTUN,TOTUN                                      02S0091
*    GENPTR = LUVGENP;                 /* ADDR OF FIRST GENERIC ENTRY
*                                         FOR THIS LOOK-UP-VALUE     */
         L     GENPTR,LUVGENP(,LUVPTR)                          02S0092
*    DO GENCTR = ONE TO LUVGENNO;      /* COUNT ALL GROUP ENTRIES    */
         LA    @08,1                                            02S0093
         B     @DE00093                                         02S0093
@DL00093 DS    0H                                               02S0094
*      GRPTABP = GENGRPTR;             /* FIRST GROUP ENTRY FOR THIS
*                                         GENERIC                    */
         L     GRPTABP,GENGRPTR(,GENPTR)                        02S0094
*      DO GRPCTR = ONE TO GENGRPNO;    /* COUNT ALL GROUP ENTRIES    */
         LA    @08,1                                            02S0095
         B     @DE00095                                         02S0095
@DL00095 DS    0H                                               02S0096
*        TOTUN = TOTUN + GRPUCBNO;     /* ADD NUMBER OF UNITS FOR
*                                         THIS GROUP TO TOTAL UNITS  */
         L     @07,GRPTR(,GRPTABP)                              02S0096
         AL    TOTUN,GRPUCBNO(,@07)                             02S0096
*        GRPTABP = GRPTABP + LENGTH(GRPTRTAB); /* NEXT GROUP PTR TABLE
*                                         ENTRY                      */
         AH    GRPTABP,@CH00062                                 02S0097
*      END;                            /* END OF GROUP LOOP          */
         AH    @08,@CH00051                                     02S0098
@DE00095 ST    @08,GRPCTR                                       02S0098
         C     @08,GENGRPNO(,GENPTR)                            02S0098
         BNH   @DL00095                                         02S0098
*      TOTGRP = TOTGRP + GENGRPNO;     /* ADD NUMBER OF GROUPS FOR
*                                         THIS GENERIC TO TOTL GROUPS*/
         L     @08,TOTGRP                                       02S0099
         AL    @08,GENGRPNO(,GENPTR)                            02S0099
         ST    @08,TOTGRP                                       02S0099
*      GENPTR = GENPTR + LENGTH(GENENTRY); /* NEXT EDT GENERIC ENTRY */
         AH    GENPTR,@CH01488                                  02S0100
*    END;                              /* END OF GENERIC LOOP        */
         LA    @08,1                                            02S0101
         AL    @08,GENCTR                                       02S0101
@DE00093 ST    @08,GENCTR                                       02S0101
         C     @08,LUVGENNO(,LUVPTR)                            02S0101
         BNH   @DL00093                                         02S0101
*    SIOTEDLS = LUVGENNO*LENGTH(EDLENTRY) + TOTGRP*LENGTH(EDLGNTRY) +
*      TOTUN*LENGTH(EDLUCBL) + LENGTH(EDLHDR); /* SIZE OF EDL        */
         LA    @08,20                                           02S0102
         L     @07,LUVGENNO(,LUVPTR)                            02S0102
         MH    @07,@CH00269                                     02S0102
         L     @01,TOTGRP                                       02S0102
         MR    @00,@08                                          02S0102
         ALR   @07,@01                                          02S0102
         LR    @15,TOTUN                                        02S0102
         SLA   @15,2                                            02S0102
         ALR   @07,@15                                          02S0102
         ALR   @07,@08                                          02S0102
         ST    @07,SIOTEDLS(,SIOTPTR)                           02S0102
*     /* ?GETSTORG (SPID,SIOTEDLS,SIOTEDLP);*/                  02S0103
*       /* DEFINITIONS OF GETMAIN PARMS */                      02S0103
*       DCL                                                     02S0103
*         GTSTR0   FIXED(31) REG(0),/*GTMN PARM REG*/           02S0103
*         GTSTR1   FIXED(31) REG(1),/*GTMN PARM REG*/           02S0103
*         GTSTR2   PTR(31)   REG(2),/*GTMN PARM REG*/           02S0103
*         GTSTR15  FIXED(31) REG(15),/*GTMN RET COD*/           02S0103
*         GTSTRTCD FIXED(31); /* GETMAIN RTN CODE  */           02S0103
*       DCL                                                     02S0104
*         GTSTR3   FIXED(31) REG(3),/* CLEARING REG*/           02S0104
*         GTSTR4   FIXED(31) REG(4),/* CLEARING REG*/           02S0104
*         GTSTR5   FIXED(31) REG(5),/* CLEARING REG*/           02S0104
*         GTSTR6   FIXED(31) REG(6),/* CLEARING REG*/           02S0104
*         GTSTR7   FIXED(31) REG(7),/* CLEARING REG*/           02S0104
*         GTSTR8   FIXED(31) REG(8),/* CLEARING REG*/           02S0104
*         GTSTZERO FIXED(31) INIT(0),                           02S0104
*         GTST253  FIXED(31) CONSTANT(253);                     02S0104
*       RFY (GTSTR0,GTSTR1,GTSTR2) RSTD; /*SAVE RGS*/           02S0105
*       GTSTR0 = SIOTEDLS; /* SET AMOUNT*/                      02S0106
         LR    GTSTR0,@07                                       02S0106
*       GTSTR2 = SPID; /* SET SUBPOOL*/                         02S0107
         LA    GTSTR2,230                                       02S0107
*       GENERATE CODE;                                          02S0108
         GETMAIN RC,LV=(0),SP=(2)  DO GETMAIN
*       GTSTRTCD = GTSTR15; /* SAVE GETMAIN RET COD*/           02S0109
         ST    GTSTR15,GTSTRTCD                                 02S0109
*       SIOTEDLP = GTSTR1; /* ADDR OF GOTN STORG*/              02S0110
         ST    GTSTR1,SIOTEDLP(,SIOTPTR)                        02S0110
*       RFY (GTSTR0,GTSTR1,GTSTR2) UNRSTD; /*RLSE */            02S0111
*       IF GTSTRTCD = 0 THEN /*GETMAIN SUCCESSFUL? */           02S0112
         L     @08,GTSTRTCD                                     02S0112
         LTR   @08,@08                                          02S0112
         BNZ   @RF00112                                         02S0112
*         DO;               /* YES, CLEAR STORAGE.*/            02S0113
*           RFY (GTSTR2,GTSTR4,GTSTR5,GTSTR6,                   02S0114
*                              GTSTR7,GTSTR8) RSTD;             02S0114
*           GTSTR4 = SIOTEDLP; /*STORG PTR*/                    02S0115
         L     @03,SIOTEDLP(,SIOTPTR)                           02S0115
         LR    GTSTR4,@03                                       02S0115
*           GTSTR5 = SIOTEDLS; /*STORG AMNT*/                   02S0116
         L     GTSTR5,SIOTEDLS(,SIOTPTR)                        02S0116
*           GTSTR7 = '00000000'X; /*PAD CHAR & LNTH*/           02S0117
         SLR   GTSTR7,GTSTR7                                    02S0117
*           IF SPID = GTST253 THEN                              02S0118
         B     @RF00118                                         02S0118
*          GEN                                                  02S0119
*       (MODESET KEYADDR=GTSTZERO,SAVEKEY=(2),WORKREG=8);       02S0119
         MODESET KEYADDR=GTSTZERO,SAVEKEY=(2),WORKREG=8
*           GEN REFS(GTSTR4,GTSTR6);                            02S0120
@RF00118 DS    0H                                               02S0120
              MVCL  GTSTR4,GTSTR6 CLEAR GOTTEN STORG
*           IF SPID = GTST253 THEN                              02S0121
         B     @RF00121                                         02S0121
*             GEN (MODESET KEYADDR=(2));                        02S0122
         MODESET KEYADDR=(2)
*           RFY (GTSTR2,GTSTR4,GTSTR5,GTSTR6,                   02S0123
*                              GTSTR7,GTSTR8) UNRSTD;           02S0123
@RF00121 DS    0H                                               02S0124
*         END;       /* STORAGE CLEARING COMPLETED */           02S0124
*       ELSE                                                    02S0125
*       SIOTEDLP= 0;   /* CLEAR RETURN ADDR. */                 02S0125
         B     @RC00112                                         02S0125
@RF00112 SLR   @08,@08                                          02S0125
         ST    @08,SIOTEDLP(,SIOTPTR)                           02S0125
*       GTSTR15 = GTSTRTCD;    /* GTMN RETURN CODE */           02S0126
@RC00112 L     GTSTR15,GTSTRTCD                                 02S0126
*                                      /* RESTORE LIST PRINT STATUS  */
*/* GET CORE FOR EDL          */                                02S0127
*    IF REG15 = ZERO THEN              /* GETMAIN SUCCESSFUL         */
         LTR   REG15,REG15                                      02S0127
         BNZ   @RF00127                                         02S0127
*      DO;                             /* BUILD THE EDL              */
*        EDLLUV = LUVALUE;             /* LOOK-UP-VALUE FROM EDT     */
         L     @08,SIOTEDLP(,SIOTPTR)                           02S0129
         MVC   EDLLUV(4,@08),LUVALUE(LUVPTR)                    02S0129
*        EDLGENNO = LUVGENNO;          /* NO OF GENERICS FROM EDT    */
         MVC   EDLGENNO(4,@08),LUVGENNO(LUVPTR)                 02S0130
*        EDLFGENP = SIOTEDLP + LENGTH(EDLHDR); /* EDL PTR TO FIRST
*                                         GENERIC ENTRY              */
         LA    @02,20                                           02S0131
         ALR   @02,@08                                          02S0131
         ST    @02,EDLFGENP(,@08)                               02S0131
*        EDLGMTP = LUVGMTP;            /* EDL PTR TO GROUP MASK      */
         MVC   EDLGMTP(4,@08),LUVGMTP(LUVPTR)                   02S0132
*        ONEGENER = OFF;               /* TURN OFF SWITCH    @G24LPSJ*/
         NI    ONEGENER,B'01111111'                             02S0133
*/********************************************************************/
*/*                                                                  */
*/* SEGMENT NAME - FILLEDL                                           */
*/*                                                                  */
*/* DESCRIPTIVE NAME - FILL IN EDL FOR A NON-SPECIFIC UNIT REQUEST   */
*/*                                                                  */
*/* FUNCTION -                                                       */
*/*   THE FUNCTION OF THIS SEGMENT IS TO FILL IN THE EDL FIELDS IN   */
*/*   THE EDL FOR A NON-SPECIFIC UNIT REQUEST.  THIS SEGMENT ALSO    */
*/*   DETERMINES IF THERE ARE ENOUGH UNITS IN THE SYSTEM TO SATISFY  */
*/*   THE REQUEST.                                                   */
*/*                                                                  */
*/* OPERATION -                                                      */
*/*   1. FILL IN THE EDL GENERIC ENTRIES.                            */
*/*      THE NUMBER OF GENERIC ENTRIES IS OBTAINED FROM THE EDT      */
*/*      LOOK UP VALUE ENTRY.  THE FOLLOWING FIELDS ARE FILLED IN:   */
*/*        DEVICE TYPE - FROM DEVICE TYPE IN EDT GENERIC ENTRY       */
*/*        NUMBER OF GROUPS - FROM NUMBER OF GROUPS IN EDT GENERIC   */
*/*          ENTRY                                                   */
*/*        POINTER TO NEXT GENERIC ENTRY - POINTER TO NEXT GENERIC   */
*/*          OR ZERO FOR LAST ENTRY                                  */
*/*        POINTER TO FIRST GROUP ENTRY                              */
*/*      IF THE ALLOCATION ACROSS GENERICS BIT IS ON IN THE EDT IT   */
*/*      IS SET ON IN THE EDL.                                       */
*/*                                                                  */
*/*      IF A REQUEST IS FOR AN ESOTERIC WHICH CONTAINS              */
*/*      ONLY 3400 TAPE DEVICES, SET THE '3400 ONLY' BIT IN          */
*/*      THE SIOT.                                                   */
*/*                                                                  */
*/*   2. FILL IN THE EDL GROUP ENTRIES FOR EACH GENERIC.             */
*/*      FOR EACH GENERIC, IF IT IS MSS AND MSS IS           @G24LPSJ*/
*/*      INELIGIBLE, THEN MARK THE EDL GROUP ENTRY           @G24LPSJ*/
*/*      INELIGIBLE (EDLJINEL).                              @G24LPSJ*/
*/*      THE NUMBER OF GROUP ENTRIES IS OBTAINED FROM THE EDT GENERIC*/
*/*      ENTRY.  THE FOLLOWING FIELDS ARE FILLED IN:                 */
*/*        POINTER TO NEXT GROUP ENTRY - POINTER TO NEXT GROUP ENTRY */
*/*          OR ZERO FOR LAST ENTRY.                                 */
*/*        NUMBER OF UCBS FOR GROUP - FROM EDT GROUP ENTRY           */
*/*        POINTER TO UCB LIST                                       */
*/*        GROUP ID - FROM EDT GROUP ENTRY                           */
*/*                                                                  */
*/*   3. FILL IN THE EDL UCB LIST FOR EACH GROUP.                    */
*/*      THE NUMBER OF UCBS IN THE LIST IS OBTAINED FROM THE EDT     */
*/*      GROUP ENTRY. THE EDT UCB LIST ENTRY HAS AN INDEX INTO THE   */
*/*      IOS UCB LOOK UP TABLE. THIS INDEX IS USED TO LOCATE THE     */
*/*      UCB ADDRESS. THE INDEX IN THE EDT HAS A 0 ORIGIN.           */
*/*                                                                  */
*/*   4. DETERMINE IF THERE ARE ENOUGH UNITS TO SATISFY THE REQUEST. */
*/*      IF THERE ARE ENOUGH UNITS, VERIFY THAT THE GENERIC  @G24LPSJ*/
*/*      IS NOT MSS OR THAT MSS REQUESTS ARE ELIGIBLE.       @G24LPSJ*/
*/*      THERE ARE TWO CASES FOR THIS:                               */
*/*      A. NO ALLOCATION ACROSS GENERICS -                          */
*/*         IF THE SUM OF THE NUMBER OF ALL UCBS TAKEN OVER ALL      */
*/*         GROUPS FOR A GENERIC IS LESS THAN THE TOTAL UNITS        */
*/*         REQUIRED FROM THE SIOT, THE INELIGIBLE DEVICE TYPE BIT   */
*/*         IS SET IN THAT GENERIC ENTRY EDL. IF THERE ARE ENOUGH    */
*/*         UNITS AN INDICATOR IS SET MEANING THAT AT LEAST ONE      */
*/*         GENERIC HAD ENOUGH UNITS.                                */
*/*      B. ALLOCATION ACROSS GENERICS IS POSSIBLE -                 */
*/*         IF THE SUM OF ALL UCBS FOR ALL GENERICS IS GREATER THAN  */
*/*         THE TOTAL NUMBER OF UNITS REQUIRED FROM THE SIOT, AN     */
*/*         INDICATOR IS SET MEANING THAT THERE ARE ENOUGH  UNITS    */
*/*         FOR THIS REQUEST.                                        */
*/*                                                                  */
*/* NOTE: ALTHOUGH THE EDL ENTRIES ARE CHAINED THEY ARE BUILT        */
*/*       IN CONTIGUOUS CORE.                                        */
*/*                                                                  */
*/* ENTRY - IN-LINE SEGMENT                                          */
*/*   PURPOSE - SEE FUNCTION                                         */
*/*                                                                  */
*/*   INPUT -                                                        */
*/*     EDT                                                          */
*/*                                                                  */
*/*     SIOT -                                                       */
*/*       SIOTEDLP - PTR TO CORE FOR EDL                             */
*/*       SIOTOTUN - TOTAL NUMBER OF UNITS REQUIRED                  */
*/*                                                                  */
*/* EXIT -                                                           */
*/*   CONDITION - EDL BUILT                                          */
*/*                                                                  */
*/*   OUTPUT -                                                       */
*/*     EDL FILLED IN                                                */
*/*                                                                  */
*/*     ELIGSW - IF ON INDICATES THERE ARE ENOUGH UNITS TO SATISFY   */
*/*              THIS REQUEST.                                       */
*/*     S3400DSP - SET ON IF 3400 TAPE                               */
*/*                                                          @G24LPSJ*/
*/*     ONEGENER - SET ON IF ONE GENERIC                     @G24LPSJ*/
*/*     MSSDEVTP - SET ON IF ONE GENERIC AND MSS DEVICE      @G24LPSJ*/
*/*                                                                  */
*/*   RETURN CODE - NONE                                             */
*/*                                                                  */
*/********************************************************************/
*EDLPTR = EDLFGENP;                    /* ADDR OF FIRST EDL GENERIC
*                                         ENTRY                      */
         LR    EDLPTR,@02                                       03S0134
*IF LUVMGENS = ON THEN                 /* ALLOC ACROSS GENERICS OK   */
         TM    LUVMGENS(LUVPTR),B'00100000'                     03S0135
         BNO   @RF00135                                         03S0135
*  EDLMGENS = ON;                      /* SET IN EDL                 */
         OI    EDLMGENS(@08),B'01000000'                        03S0136
*EDLGNTP = EDLPTR + LUVGENNO*LENGTH(EDLENTRY); /* FIRST EDL GROUP
*                                         ENTRY                      */
@RF00135 L     @08,LUVGENNO(,LUVPTR)                            03S0137
         LR    EDLGNTP,@08                                      03S0137
         MH    EDLGNTP,@CH00269                                 03S0137
         ALR   EDLGNTP,EDLPTR                                   03S0137
*EDLUCBLP = EDLGNTP + TOTGRP*LENGTH(EDLGNTRY); /* FIRST ENTRY IN THE
*                                         EDL UCB LIST               */
         L     EDLUCBLP,TOTGRP                                  03S0138
         MH    EDLUCBLP,@CH01683                                03S0138
         ALR   EDLUCBLP,EDLGNTP                                 03S0138
*GENPTR = LUVGENP;                     /* FIRST EDT GENERIC ENTRY    */
         L     GENPTR,LUVGENP(,LUVPTR)                          03S0139
*ELIGSW = OFF;                         /* INIT ELIGIBLE GENERIC BIT  */
         NI    ELIGSW,B'01111111'                               03S0140
*IF LUVGENNO = ONE THEN                /* IF ONE GENERIC     @G24LPSJ*/
         CH    @08,@CH00051                                     03S0141
         BNE   @RF00141                                         03S0141
*  ONEGENER = ON;                      /* THEN SET FLAG ON   @G24LPSJ*/
         OI    ONEGENER,B'10000000'                             03S0142
*TOTUN = ZERO;                         /* INIT TOTAL UNITS           */
@RF00141 SLR   TOTUN,TOTUN                                      03S0143
*S3400DSP = ON;                        /* INIT 3400 TAPE BIT         */
         OI    S3400DSP(SIOTPTR),B'01000000'                    03S0144
*DO GENCTR = ONE TO LUVGENNO;          /* DO FOR ALL EDT GENERIC ENTS*/
         LA    @08,1                                            03S0145
         B     @DE00145                                         03S0145
@DL00145 DS    0H                                               03S0146
*   MSSDEVTP = OFF;                    /* SET MSS DEVICE FLAG OFF
*                                                            @G24LPSJ*/
         NI    MSSDEVTP,B'01111111'                             03S0146
*  IF LUVMGENS = OFF & SIO3COMM = OFF THEN/* NO ALLOC ACROSS GENERICS*/
         TM    LUVMGENS(LUVPTR),B'00100000'                     03S0147
         BNZ   @RF00147                                         03S0147
         TM    SIO3COMM(SIOTPTR),B'01000000'                    03S0147
         BNZ   @RF00147                                         03S0147
*    TOTUN = ZERO;                     /* RESET TOTAL UNITS          */
         SLR   TOTUN,TOTUN                                      03S0148
*  IF GENCTR = LUVGENNO THEN           /* LAST GENERIC ENTRY         */
@RF00147 CLC   GENCTR(4),LUVGENNO(LUVPTR)                       03S0149
         BNE   @RF00149                                         03S0149
*    EDLNXTNT = ZERO;                  /* NO NEXT ENTRY              */
         SLR   @08,@08                                          03S0150
         ST    @08,EDLNXTNT(,EDLPTR)                            03S0150
*  ELSE                                /* NOT LAST GENERIC ENTRY     */
*    EDLNXTNT = EDLPTR + LENGTH(EDLENTRY); /* POINT TO NEXT EDL 03S0151
*                                         GENERIC ENTRY              */
         B     @RC00149                                         03S0151
@RF00149 LA    @08,24                                           03S0151
         ALR   @08,EDLPTR                                       03S0151
         ST    @08,EDLNXTNT(,EDLPTR)                            03S0151
*  EDLDEVT = GENDEVT;                  /* SET DEVICE TYPE FROM EDT   */
@RC00149 MVC   EDLDEVT(4,EDLPTR),GENDEVT(GENPTR)                03S0152
*   RFY DEVTYPE BASED(ADDR(EDLDEVT));  /* SET ADDRESSABILITY @G24LPSJ*/
*  IF DEVRVDEV = ON&                  /* IF VIRTUAL DEVICE   @G24LPSJ*/
*     DEVDACC  = ON&                  /* AND DA              @G24LPSJ*/
*     DEVUNTYP = U3330 THEN           /* AND 3330 UNIT THEN  @G24LPSJ*/
         LA    @08,4                                            03S0154
         ALR   @08,EDLPTR                                       03S0154
         TM    DEVRVDEV(@08),B'00001000'                        03S0154
         BNO   @RF00154                                         03S0154
         TM    DEVDACC(@08),B'00100000'                         03S0154
         BNO   @RF00154                                         03S0154
         CLI   DEVUNTYP(@08),X'09'                              03S0154
         BNE   @RF00154                                         03S0154
*    MSSDEVTP  = ON;                  /* SET MSS DEVICE FLAG ON 03S0155
*                                                            @G24LPSJ*/
         OI    MSSDEVTP,B'10000000'                             03S0155
*  IF EDLDEVT(3:4) ^= TAPE3400 THEN    /*GENERIC IS NOT 3400         */
@RF00154 CLC   EDLDEVT+2(2,EDLPTR),@CB00117                     03S0156
         BE    @RF00156                                         03S0156
*    S3400DSP = OFF;                                            03S0157
         NI    S3400DSP(SIOTPTR),B'10111111'                    03S0157
*  EDLGRPNO = GENGRPNO;                /* NUMBR OF GROUPS FOR GENERIC*/
@RF00156 MVC   EDLGRPNO(4,EDLPTR),GENGRPNO(GENPTR)              03S0158
*  EDLGRPTR = EDLGNTP;                 /* ADDR OF EDL GROUP ENTRY    */
         ST    EDLGNTP,EDLGRPTR(,EDLPTR)                        03S0159
*  GRPTABP = GENGRPTR;                 /* EDT PTR TO FIRST GROUP ENT */
         L     GRPTABP,GENGRPTR(,GENPTR)                        03S0160
*  DO GRPCTR = ONE TO GENGRPNO;        /* DO FOR ALL GROUPS FOR THIS
*                                         GENERIC                    */
         LA    @08,1                                            03S0161
         B     @DE00161                                         03S0161
@DL00161 DS    0H                                               03S0162
*    IF GRPCTR = GENGRPNO THEN         /* LAST GROUP FOR THIS GENERIC*/
         C     @08,GENGRPNO(,GENPTR)                            03S0162
         BNE   @RF00162                                         03S0162
*      EDLNXGRP = ZERO;                /* NO NEXT GROUP              */
         SLR   @08,@08                                          03S0163
         ST    @08,EDLNXGRP(,EDLGNTP)                           03S0163
*    ELSE                              /* NOT LAST GROUP             */
*      EDLNXGRP = EDLGNTP + LENGTH(EDLGNTRY); /* EDL PTR TO NEXT
*                                         GROUP ENTRY                */
         B     @RC00162                                         03S0164
@RF00162 LA    @08,20                                           03S0164
         ALR   @08,EDLGNTP                                      03S0164
         ST    @08,EDLNXGRP(,EDLGNTP)                           03S0164
*    EDLUCBNO = GRPUCBNO;              /* NUMBR OF UCBS FROM EDT     */
@RC00162 L     @08,GRPTR(,GRPTABP)                              03S0165
         MVC   EDLUCBNO(4,EDLGNTP),GRPUCBNO(@08)                03S0165
*    EDLLISTP = EDLUCBLP;              /* PTR TO UCB LIST            */
         ST    EDLUCBLP,EDLLISTP(,EDLGNTP)                      03S0166
*    EDLGRID = GRPID;                  /* GROUP ID FROM EDT          */
         MVC   EDLGRID(4,EDLGNTP),GRPID(@08)                    03S0167
*    IF MSSDEVTP = ON&                 /* IF MSS DEVICE AND  @G24LPSJ*/
*       MSSELIG = OFF THEN             /* MSS IS INELIGIBLE  @G24LPSJ*/
         TM    MSSDEVTP,B'10000000'                             03S0168
         BNO   @RF00168                                         03S0168
         TM    MSSELIG,B'10000000'                              03S0168
         BNZ   @RF00168                                         03S0168
*      EDLJINEL = ON;                  /* THEN MARK GROUP INELIGIBLE
*                                                            @G24LPSJ*/
         OI    EDLJINEL(EDLGNTP),B'10000000'                    03S0169
*    DO UCBCTR = ONE TO GRPUCBNO;      /* DO FOR ALL UCBS FOR THIS
*                                         GROUP                      */
@RF00168 LA    UCBCTR,1                                         03S0170
         B     @DE00170                                         03S0170
@DL00170 DS    0H                                               03S0171
*      EDLUCBAD(UCBCTR) = IOSLUT(EUCBTPOS(UCBCTR)+1); /* UCB ADDR FROM
*                                         IOSLUT INDEXED BY EDT LUT
*                                         INDEX                      */
         LR    @15,UCBCTR                                       03S0171
         SLA   @15,2                                            03S0171
         LR    @14,UCBCTR                                       03S0171
         ALR   @14,@14                                          03S0171
         L     @01,GRPTR(,GRPTABP)                              03S0171
         L     @01,GRPUCBP(,@01)                                03S0171
         BCTR  @01,0                                            03S0171
         BCTR  @01,0                                            03S0171
         LH    @14,EUCBTPOS(@14,@01)                            03S0171
         ALR   @14,@14                                          03S0171
         L     @01,@PC00001                                     03S0171
         L     @01,ALCWAPTR(,@01)                               03S0171
         L     @01,IOSLUTP(,@01)                                03S0171
         ALR   @15,EDLUCBLP                                     03S0171
         AL    @15,@CF01692                                     03S0171
         ALR   @01,@14                                          03S0171
         MVC   EDLUCBAD(2,@15),IOSLUT(@01)                      03S0171
*    END;                                                       03S0172
         AH    UCBCTR,@CH00051                                  03S0172
@DE00170 L     @01,GRPTR(,GRPTABP)                              03S0172
         C     UCBCTR,GRPUCBNO(,@01)                            03S0172
         BNH   @DL00170                                         03S0172
*    TOTUN = TOTUN + GRPUCBNO;         /* ADD UNITS FOR THIS GROUP TO
*                                         TOTAL UNITS                */
         L     @08,GRPTR(,GRPTABP)                              03S0173
         L     @08,GRPUCBNO(,@08)                               03S0173
         ALR   TOTUN,@08                                        03S0173
*    EDLUCBLP = EDLUCBLP + GRPUCBNO*LENGTH(EDLUCBL); /* EDL PTR TO
*                                         NEXT UCB LIST              */
         SLA   @08,2                                            03S0174
         ALR   EDLUCBLP,@08                                     03S0174
*    GRPTABP = GRPTABP + LENGTH(GRPTRTAB); /* NEXT EDT GROUP ENTRY   */
         AH    GRPTABP,@CH00062                                 03S0175
*    EDLGNTP = EDLGNTP + LENGTH(EDLGNTRY); /* NEXT EDL GROUP ENTRY   */
         AH    EDLGNTP,@CH01683                                 03S0176
*  END;                                /* END OF GROUP LOOP          */
         LA    @08,1                                            03S0177
         AL    @08,GRPCTR                                       03S0177
@DE00161 ST    @08,GRPCTR                                       03S0177
         C     @08,GENGRPNO(,GENPTR)                            03S0177
         BNH   @DL00161                                         03S0177
*  IF SIOTOTUN > TOTUN                 /* NOT ENOUGH UNITS IN GENERIC*/
*      | (SIOTFUDA = ON                                         03S0178
*      & EDLDEVT(3) = DATYPE) THEN     /* NOT ENOUGH UNITS IN GEN    */
         SLR   @08,@08                                          03S0178
         IC    @08,SIOTOTUN(,SIOTPTR)                           03S0178
         CR    TOTUN,@08                                        03S0178
         BL    @RT00178                                         03S0178
         TM    SIOTFUDA(SIOTPTR),B'00100000'                    03S0178
         BNO   @RF00178                                         03S0178
         CLI   EDLDEVT+2(EDLPTR),X'20'                          03S0178
         BNE   @RF00178                                         03S0178
@RT00178 DS    0H                                               03S0179
*    IF LUVMGENS = OFF & SIO3COMM = OFF THEN /* CANT ALLOCATE ACROSS
*                                        GENERICS                    */
         TM    LUVMGENS(LUVPTR),B'00100000'                     03S0179
         BNZ   @RF00179                                         03S0179
         TM    SIO3COMM(SIOTPTR),B'01000000'                    03S0179
         BNZ   @RF00179                                         03S0179
*      EINDEVTP = ON;                  /* INELIGIBLE GENERIC         */
         OI    EINDEVTP(EDLPTR),B'10000000'                     03S0180
*    ELSE;                             /* GENERIC STILL ELIGIBLE     */
@RF00179 DS    0H                                               03S0182
*  ELSE                                /* ENOUGH UNITS IN GENERIC    */
*  IF MSSDEVTP = OFF|                  /* IF NOT MSS DEVICE  @G24LPSJ*/
*     MSSELIG = ON THEN                /* OR MSS IS ELIGIBLE @G24LPSJ*/
         B     @RC00178                                         03S0182
@RF00178 TM    MSSDEVTP,B'10000000'                             03S0182
         BZ    @RT00182                                         03S0182
         TM    MSSELIG,B'10000000'                              03S0182
         BNO   @RF00182                                         03S0182
@RT00182 DS    0H                                               03S0183
*    ELIGSW = ON;                      /* THEN SET ELIGIBLE GROUP
*                                                  FOUND     @G24LPSJ*/
         OI    ELIGSW,B'10000000'                               03S0183
*  EDLPTR = EDLPTR + LENGTH(EDLENTRY); /* NEXT EDL GENERIC ENTRY     */
@RF00182 DS    0H                                               03S0184
@RC00178 AH    EDLPTR,@CH00269                                  03S0184
*  GENPTR = GENPTR + LENGTH(GENENTRY); /* NEXT EDT GENERIC ENTRY     */
         AH    GENPTR,@CH01488                                  03S0185
*END;                                  /* END OF GENERIC LOOP        */
         LA    @08,1                                            03S0186
         AL    @08,GENCTR                                       03S0186
@DE00145 ST    @08,GENCTR                                       03S0186
         C     @08,LUVGENNO(,LUVPTR)                            03S0186
         BNH   @DL00145                                         03S0186
*        IF ELIGSW = OFF THEN          /* NO ELIGIBLE GENERICS       */
         TM    ELIGSW,B'10000000'                               02S0187
         BNZ   @RF00187                                         02S0187
*          DO;                         /* INDICATE REQUEST FAILED    */
*            RETNCODE = FAIL;          /* INDICATE BLDNSEDL FAILED   */
         MVC   RETNCODE(2),@CH00062                             02S0189
*            IF ONEGENER = ON&         /* IF ONE GENERIC AND @G24LPSJ*/
*               MSSELIG = OFF&         /* MSS INELIGIBLE AND @G24LPSJ*/
*               MSSDEVTP = ON THEN     /* MSS DEVICE TYPE    @G24LPSJ*/
         TM    ONEGENER,B'10000000'                             02S0190
         BNO   @RF00190                                         02S0190
         TM    MSSELIG,B'10000000'                              02S0190
         BNZ   @RF00190                                         02S0190
         TM    MSSDEVTP,B'10000000'                             02S0190
         BNO   @RF00190                                         02S0190
*              SIOTRSNC = MSSNOTUP;    /* SET MSS NOT UP REASON CODE
*                                                            @G24LPSJ*/
         MVC   SIOTRSNC(2,SIOTPTR),@CH00097                     02S0191
*            ELSE                      /* ELSE               @G24LPSJ*/
*              SIOTRSNC = TOOMANYU;    /* SET TOO MANY UNITS @G24LPSJ*/
         B     @RC00190                                         02S0192
@RF00190 MVC   SIOTRSNC(2,SIOTPTR),@CH00111                     02S0192
*          END;                                                 02S0193
*      END;                                                     02S0194
*    ELSE                              /* CORE NOT AVAILABLE FOR EDL */
*      DO;                             /* INDICATE NO EDL            */
         B     @RC00127                                         02S0195
@RF00127 DS    0H                                               02S0196
*        RETNCODE = FAIL;              /* INDICATE BLDNSEDL FAILED   */
         MVC   RETNCODE(2),@CH00062                             02S0196
*        STEPRSNC = GETMAIN;           /* INDICATE GETMAIN ERROR     */
         L     @10,@PC00001                                     02S0197
         L     @10,ALCWAPTR(,@10)                               02S0197
         L     @10,FAILRSCP(,@10)                               02S0197
         MVC   STEPRSNC(2,@10),@CH00072                         02S0197
*      END;                                                     02S0198
*  END;                                /* END BUILD THE EDL          */
*ELSE                                  /* LUV NOT FOUND IN THE EDT   */
*  DO;                                 /* FAIL THE REQUEST           */
         B     @RC00088                                         02S0200
@RF00088 DS    0H                                               02S0201
*    RETNCODE = FAIL;                  /* INDICATE BLDNSEDL FAILED   */
         MVC   RETNCODE(2),@CH00062                             02S0201
*    SIOTRSNC = INVUTYPE;              /* REASON IS INVAL UNIT PARM  */
         MVC   SIOTRSNC(2,SIOTPTR),@CH00064                     02S0202
*  END;                                /* END FAIL THE REQUEST       */
*        END;                                                   01S0204
*      ELSE                            /* SPECIFIC UNIT REQUEST      */
*        IF SIOTOTUN > ONE THEN        /* MORE THAN 1 DEV NEEDED
*                                                            @YM03592*/
         B     @RC00079                                         01S0205
@RF00079 CLI   SIOTOTUN(SIOTPTR),1                              01S0205
         BNH   @RF00205                                         01S0205
*          DO;                                                  01S0206
*            RETNCODE = FAIL;          /* INDICATE ERROR     @YM03592*/
         MVC   RETNCODE(2),@CH00062                             01S0207
*            SIOTRSNC = NOTEDEVS;      /* SET REASON CODE    @YM03592*/
         MVC   SIOTRSNC(2,SIOTPTR),@CH00080                     01S0208
*          END;                                                 01S0209
*        ELSE                          /* ONE DEVICE         @YM03592*/
*          DO;                         /* BUILD SPECIFIC EDL         */
         B     @RC00205                                         01S0210
@RF00205 DS    0H                                               01S0211
*/********************************************************************/
*/*                                                                  */
*/* SEGMENT NAME - BLDSPEDL                                          */
*/*                                                                  */
*/* DESCRIPTIVE NAME - BUILD EDL FOR SPECIFIC UNIT ADDRESS           */
*/*                                                                  */
*/* FUNCTION -                                                       */
*/*   THE PURPOSE OF THIS SEGMENT IS TO BUILD AN ELIGIBLE DEVICE     */
*/*   LIST(EDL) FOR A SPECIFIC UNIT REQUEST. AN EDL WITH ONE GENERIC */
*/*   ENTRY, ONE GROUP ENTRY AND ONE ENTRY IN THE UCB LIST IS BUILT. */
*/*   THE GROUP ID FOR A SPECIFIC UNIT ADDRESS IS DEFINED TO BE THE  */
*/*   GROUP ID OF THE GENERIC WHICH CONTAINS THIS DEVICE.            */
*/*                                                                  */
*/* OPERATION -                                                      */
*/*   IN GENERAL THE OPERATION IS DEFINED IN THE CODE, HOWEVER       */
*/*   THE FOLLOWING METHOD IS USED TO FIND THE GROUP ID:             */
*/*                                                                  */
*/*   1. SCTUTYPE(7:8) CONTAINS THE UCB ADDRESS FOR A SPECIFIC UNIT  */
*/*      REQUEST. PART OF THE UCBTYPE FIELD WILL BE USED AS A SEARCH */
*/*      ARGUMENT INTO THE EDT LUV SECTION. THE PART OF THE UCBTYP   */
*/*      FIELD THAT IS USED DEPENDS ON THE DEVICE CLASS(THIRD BYTE)  */
*/*      AS FOLLOWS:                                                 */
*/*        DIRECT ACCESS - BYTES 3 AND 4 PLUS THE VIRTUAL    @Y30LPPD*/
*/*          BIT IN BYTE 2 OF UCBTYPE ARE COMPARED AGAINST   @Y30LPPD*/
*/*          THE THIRD AND FOURTH BYTES AND THE VIRTUAL BIT  @Y30LPPD*/
*/*          IN BYTE 2 OF EDTLUV.                            @Y30LPPD*/
*/*                                                                  */
*/*        UNIT RECORD - SAME AS DIRECT ACCESS.                      */
*/*                                                                  */
*/*        MAGNETIC TAPE - BYTES 1,2 (LESS THE ALTERNATE     @YM05477*/
*/*          POWER USAGE BITS), 3 AND 4 OF UCBTYP ARE        @YM05477*/
*/*          COMPARED AGAINST BYTES 1,2,3 AND 4 OF EDTLUV.   @YM05477*/
*/*                                                                  */
*/*        GRAPHIC DEVICE CLASS - BYTES 1,3 AND 4 OF UCBTYP ARE      */
*/*          COMPARED AGAINST BYTES 1,3 AND 4 OF EDTLUV.             */
*/*                                                                  */
*/*        COMMUNICATIONS DEVICE CLASS - NO GROUP IS NECESSARY       */
*/*          FOR COMMUNICATIONS DEVICES. THE GROUP ID IS SET TO 0.   */
*/*                                                                  */
*/* ENTRY - IN-LINE SEGMENT                                          */
*/*   PURPOSE - SEE FUNCTION                                         */
*/*                                                                  */
*/*   INPUT -                                                        */
*/*     SIOT                                                         */
*/*     EDT                                                          */
*/*                                                                  */
*/* EXITS -                                                          */
*/* 1 CONDITION - EDL SUCCESSFULLY BUILT                             */
*/*                                                                  */
*/*   OUTPUT -                                                       */
*/*     SIOT -                                                       */
*/*       SIOTEDLP - POINTER TO EDL                                  */
*/*       SIOTEDLS - SIZE OF EDL = 48 BYTES                          */
*/*       S3400DSP - SET ON IF 3400 TAPE                     @YM07622*/
*/*                                                                  */
*/*     EDL -                                                        */
*/*       EDLLUV   - LUV FROM EDT                                    */
*/*       EDLGMTP  - PTR. TO GROUP MASK TABLE                        */
*/*       EDLFGENP - PTR. TO FIRST GENERIC ENTRY                     */
*/*       EDLGENNO - 1                                               */
*/*       EDLNXTNT - 0                                               */
*/*       EDLDEVT  - UCBTYPE FROM UCB                                */
*/*       EDLGRPNO - 1                                               */
*/*       EDLGRPTR - PTR. TO GROUP ENTRY                             */
*/*       EINDEVTP - 0                                               */
*/*       EDLNXGRP - 0                                               */
*/*       EDLUCBNO - 1                                               */
*/*       EDLLISP - PTR. TO UCB ADDRESS                              */
*/*       EDLGRIP - GROUP ID OF GENERIC                              */
*/*       EDLUCBAD - UCB ADDRESS FROM SIOT                           */
*/*                                                                  */
*/*   RETURN CODE - 0                                                */
*/*                                                                  */
*/* 2 CONDITION - EDL NOT BUILT                                      */
*/*                                                                  */
*/*   OUTPUT -                                                       */
*/*     STEPRSNC - STEP RELATED REASON CODE                  @G24LPSJ*/
*/*       2 = GETMAIN FAILURE                                @G24LPSJ*/
*/*                                                          @G24LPSJ*/
*/*     SIOTRSNC - DD RELATE REASON CODE                     @G24LPSJ*/
*/*       72 = MSS NOT UP FOR SINGLE GENERIC REQ             @G24LPSJ*/
*/*                                                                  */
*/*   RETURN CODE - 4                                                */
*/********************************************************************/
*SIOTEDLS = LENGTH(EDLHDR)+LENGTH(EDLENTRY)+LENGTH(EDLGNTRY)    02S0211
*                +LENGTH(EDLUCBL);     /* SIZE FOR SPEC. UNIT EDL    */
         LA    @10,68                                           02S0211
         ST    @10,SIOTEDLS(,SIOTPTR)                           02S0211
* /* ?GETSTORG (SPID,SIOTEDLS,SIOTEDLP);*/                      02S0212
*   RFY (GTSTR0,GTSTR1,GTSTR2) RSTD; /*SAVE RGS*/               02S0212
*   GTSTR0 = SIOTEDLS; /* SET AMOUNT*/                          02S0213
         LR    GTSTR0,@10                                       02S0213
*   GTSTR2 = SPID; /* SET SUBPOOL*/                             02S0214
         LA    GTSTR2,230                                       02S0214
*   GENERATE CODE;                                              02S0215
     GETMAIN RC,LV=(0),SP=(2)  DO GETMAIN
*   GTSTRTCD = GTSTR15; /* SAVE GETMAIN RET COD*/               02S0216
         ST    GTSTR15,GTSTRTCD                                 02S0216
*   SIOTEDLP = GTSTR1; /* ADDR OF GOTN STORG*/                  02S0217
         ST    GTSTR1,SIOTEDLP(,SIOTPTR)                        02S0217
*   RFY (GTSTR0,GTSTR1,GTSTR2) UNRSTD; /*RLSE */                02S0218
*   IF GTSTRTCD = 0 THEN /*GETMAIN SUCCESSFUL? */               02S0219
         L     @10,GTSTRTCD                                     02S0219
         LTR   @10,@10                                          02S0219
         BNZ   @RF00219                                         02S0219
*     DO;               /* YES, CLEAR STORAGE.*/                02S0220
*       RFY (GTSTR2,GTSTR4,GTSTR5,GTSTR6,                       02S0221
*                          GTSTR7,GTSTR8) RSTD;                 02S0221
*       GTSTR4 = SIOTEDLP; /*STORG PTR*/                        02S0222
         L     @10,SIOTEDLP(,SIOTPTR)                           02S0222
         LR    GTSTR4,@10                                       02S0222
*       GTSTR5 = SIOTEDLS; /*STORG AMNT*/                       02S0223
         L     GTSTR5,SIOTEDLS(,SIOTPTR)                        02S0223
*       GTSTR7 = '00000000'X; /*PAD CHAR & LNTH*/               02S0224
         SLR   GTSTR7,GTSTR7                                    02S0224
*       IF SPID = GTST253 THEN                                  02S0225
         B     @RF00225                                         02S0225
*      GEN                                                      02S0226
*   (MODESET KEYADDR=GTSTZERO,SAVEKEY=(2),WORKREG=8);           02S0226
         MODESET KEYADDR=GTSTZERO,SAVEKEY=(2),WORKREG=8
*       GEN REFS(GTSTR4,GTSTR6);                                02S0227
@RF00225 DS    0H                                               02S0227
          MVCL  GTSTR4,GTSTR6 CLEAR GOTTEN STORG
*       IF SPID = GTST253 THEN                                  02S0228
         B     @RF00228                                         02S0228
*         GEN (MODESET KEYADDR=(2));                            02S0229
         MODESET KEYADDR=(2)
*       RFY (GTSTR2,GTSTR4,GTSTR5,GTSTR6,                       02S0230
*                          GTSTR7,GTSTR8) UNRSTD;               02S0230
@RF00228 DS    0H                                               02S0231
*     END;       /* STORAGE CLEARING COMPLETED */               02S0231
*   ELSE                                                        02S0232
*   SIOTEDLP= 0;   /* CLEAR RETURN ADDR. */                     02S0232
         B     @RC00219                                         02S0232
@RF00219 SLR   @10,@10                                          02S0232
         ST    @10,SIOTEDLP(,SIOTPTR)                           02S0232
*   GTSTR15 = GTSTRTCD;    /* GTMN RETURN CODE */               02S0233
@RC00219 L     GTSTR15,GTSTRTCD                                 02S0233
*                                      /* RESTORE LIST PRINT STATUS  */
*   /* GET CORE FOR EDL           */                            02S0234
*IF REG15 = SUCCESS THEN               /* CORE WAS GOTTEN            */
         LTR   REG15,REG15                                      02S0234
         BNZ   @RF00234                                         02S0234
*  DO;                                 /* BUILD EDL                  */
*    EDLFGENP = SIOTEDLP+LENGTH(EDLHDR);/* EDL PTR TO FIRST     02S0236
*                                         GENERIC                    */
         L     @10,SIOTEDLP(,SIOTPTR)                           02S0236
         LA    @08,20                                           02S0236
         LR    @06,@10                                          02S0236
         ALR   @06,@08                                          02S0236
         ST    @06,EDLFGENP(,@10)                               02S0236
*    EDLPTR = EDLFGENP;                /* BASE FOR EDL GENERIC ENTRY */
         LR    EDLPTR,@06                                       02S0237
*    EDLGENNO = ONE;                   /* ONLY ONE GENERIC FOR SPEC.
*                                         UNIT                       */
         LA    @06,1                                            02S0238
         ST    @06,EDLGENNO(,@10)                               02S0238
*    EDLGNTP = ADDR(EDLENTRY)+LENGTH(EDLENTRY); /* SET BASE FOR EDL
*                                         GROUP ENTRY                */
         LA    EDLGNTP,24                                       02S0239
         ALR   EDLGNTP,EDLPTR                                   02S0239
*    EDLUCBLP = EDLGNTP+LENGTH(EDLGNTRY); /* SET BASE FOR EDL   02S0240
*                                         UCB LIST                   */
         ALR   @08,EDLGNTP                                      02S0240
         LR    EDLUCBLP,@08                                     02S0240
*    UCBPTR = SCTUTYPE(7:8);           /* SET BASE FOR UCB           */
         SLR   UCBPTR,UCBPTR                                    02S0241
         ICM   UCBPTR,3,SCTUTYPE+6(SIOTPTR)                     02S0241
*    EDLGRPNO = ONE;                   /* ONE GROUP SECTION          */
         ST    @06,EDLGRPNO(,EDLPTR)                            02S0242
*    EDLGRPTR = ADDR(EDLGNTRY);        /* PTR TO FIRST GROUP ENTRY   */
         ST    EDLGNTP,EDLGRPTR(,EDLPTR)                        02S0243
*    EDLUCBNO = ONE;                   /* ONE UCB FOR THIS GROUP     */
         ST    @06,EDLUCBNO(,EDLGNTP)                           02S0244
*    EDLLISTP = ADDR(EDLUCBL(ONE));    /* SET BASE FOR UCB LIST      */
         ST    EDLUCBLP,EDLLISTP(,EDLGNTP)                      02S0245
*    EDLUCBAD(ONE) = UCBPTR;           /* UCB ADDRESS IN UCB LIST    */
         STH   UCBPTR,EDLUCBAD(,EDLUCBLP)                       02S0246
*    IF UCB3COMM ^= ON THEN            /* NOT COMMUNICATION DEVICE   */
         TM    UCB3COMM(UCBPTR),B'01000000'                     02S0247
         BO    @RF00247                                         02S0247
*      DO;                             /* SEARCH EDT LUVS FOR GENERIC*/
*        LUVPTR = ADDR(LUVHDR)+LENGTH(LUVHDR); /* FIRST LUV ENTRY    */
         L     @08,@PC00001                                     02S0249
         L     @08,ALCWAPTR(,@08)                               02S0249
         L     @08,EDTABPTR(,@08)                               02S0249
         LA    LUVPTR,8                                         02S0249
         AL    LUVPTR,EDTLUVSP(,@08)                            02S0249
*        FOUNDSW = OFF;                /* INIT LUV FOUND SWITCH      */
         NI    FOUNDSW,B'01111111'                              02S0250
*        DO LUVCTR = ONE TO LUVENTNO WHILE(FOUNDSW = OFF); /* SEARCH
*                                         ALL LUV ENTRYS UNTIL FOUND */
         LA    @08,1                                            02S0251
         LR    LUVCTR,@08                                       02S0251
         B     @DE00251                                         02S0251
@DL00251 TM    FOUNDSW,B'10000000'                              02S0251
         BNZ   @DC00251                                         02S0251
*          IF LUVALUE(3:4) = UCBTYP(3:4) THEN /* DEVICE CLASS AND
*                                         TYPE MATCH                 */
         CLC   LUVALUE+2(2,LUVPTR),UCBTYP+2(UCBPTR)             02S0252
         BNE   @RF00252                                         02S0252
*            IF UCB3DACC=ON &          /* D. A. DEVICE       @Y30LPPD*/
*               ((LUVALUE(2)&VIRTMASK)=/* COMPARE FOR VIRTUAL@Y30LPPD*/
*               (UCBTYP(2)&VIRTMASK)) THEN/* DEVICE          @Y30LPPD*/
         TM    UCB3DACC(UCBPTR),B'00100000'                     02S0253
         BNO   @RF00253                                         02S0253
         MVC   @TS00001(1),LUVALUE+1(LUVPTR)                    02S0253
         NI    @TS00001,X'08'                                   02S0253
         MVC   @TS00001+1(1),UCBTYP+1(UCBPTR)                   02S0253
         NI    @TS00001+1,X'08'                                 02S0253
         CLC   @TS00001(1),@TS00001+1                           02S0253
         BNE   @RF00253                                         02S0253
*               DO;                    /*                    @G24LPSJ*/
*                 FOUNDSW = ON;        /* GENERIC ENTRY FOUND@G24LPSJ*/
         OI    FOUNDSW,B'10000000'                              02S0255
*                 IF UCBRVDEV = ON&    /* IF VIRTUAL DEVICE  @G24LPSJ*/
*                    UCBUNTYP = U3330& /* AND 3330           @G24LPSJ*/
*                    MSSELIG = OFF THEN/* AND MSS INELIGIBLE @G24LPSJ*/
         TM    UCBRVDEV(UCBPTR),B'00001000'                     02S0256
         BNO   @RF00256                                         02S0256
         CLI   UCBUNTYP(UCBPTR),X'09'                           02S0256
         BNE   @RF00256                                         02S0256
         TM    MSSELIG,B'10000000'                              02S0256
         BNZ   @RF00256                                         02S0256
*                   DO;                /* THEN               @G24LPSJ*/
*                     RETNCODE = FAIL; /* EDL BUILD FAILURE  @G24LPSJ*/
         MVC   RETNCODE(2),@CH00062                             02S0258
*                     SIOTRSNC = MSSNOTUP;/*SET MSS NOT INITIALIZED
*                                               REASON CODE  @G24LPSJ*/
         MVC   SIOTRSNC(2,SIOTPTR),@CH00097                     02S0259
*                   END;                /*                   @G24LPSJ*/
*               END;                   /*                    @G24LPSJ*/
*            ELSE                      /* NOT DIRECT ACCESS          */
*              IF UCB3UREC = ON THEN   /* UNIT RECORD DEVICE         */
         B     @RC00253                                         02S0262
@RF00253 TM    UCB3UREC(UCBPTR),B'00001000'                     02S0262
         BNO   @RF00262                                         02S0262
*                FOUNDSW = ON;         /* GENERIC ENTRY FOUND        */
         OI    FOUNDSW,B'10000000'                              02S0263
*              ELSE                    /* NOT UNIT RECORD DEVICE     */
*                IF UCB3TAPE = ON THEN /* TAPE DEVICE                */
         B     @RC00262                                         02S0264
@RF00262 TM    UCB3TAPE(UCBPTR),B'10000000'                     02S0264
         BNO   @RF00264                                         02S0264
*                  IF LUVALUE(1:2) = (UCBTYP(1:2) & POWEROFF) THEN
         MVC   @TS00001(2),UCBTYP(UCBPTR)                       02S0265
         NC    @TS00001(2),@CB00087                             02S0265
         CLC   LUVALUE(2,LUVPTR),@TS00001                       02S0265
         BNE   @RF00265                                         02S0265
*                                      /* GENERIC FOUND      @YM05477*/
*                    DO;               /*                    @YM07622*/
*                      IF UCBTYP(3:4)=TAPE3400 THEN             02S0267
         CLC   UCBTYP+2(2,UCBPTR),@CB00117                      02S0267
         BNE   @RF00267                                         02S0267
*                        S3400DSP=ON;  /* INDIC 3400 TAPE    @YM07622*/
         OI    S3400DSP(SIOTPTR),B'01000000'                    02S0268
*                        FOUNDSW = ON; /* GENERIC ENTRY FOUND        */
@RF00267 OI    FOUNDSW,B'10000000'                              02S0269
*                      END;            /*                    @YM07622*/
*                  ELSE;               /* GENERIC NOT FOUND          */
@RF00265 DS    0H                                               02S0272
*                ELSE                  /* NOT TAPE DEVICE            */
*                  IF UCB3DISP = ON THEN /* GRAPHICS DEVICE          */
         B     @RC00264                                         02S0272
@RF00264 TM    UCB3DISP(UCBPTR),B'00010000'                     02S0272
         BNO   @RF00272                                         02S0272
*                    IF LUVALUE(1) = UCBTYP(1) THEN /* GENERIC FOUND */
         CLC   LUVALUE(1,LUVPTR),UCBTYP(UCBPTR)                 02S0273
         BNE   @RF00273                                         02S0273
*                      FOUNDSW = ON;   /* GENERIC ENTRY FOUND        */
         OI    FOUNDSW,B'10000000'                              02S0274
*                    ELSE;             /* GENERIC NOT FOUND          */
@RF00273 DS    0H                                               02S0276
*                  ELSE;               /* UNKNOWN DEVICE CLASS       */
@RF00272 DS    0H                                               02S0277
*          IF FOUNDSW = ON THEN        /* CORRECT LUV ENTRY FOUND    */
@RC00264 DS    0H                                               02S0277
@RC00262 DS    0H                                               02S0277
@RC00253 DS    0H                                               02S0277
@RF00252 TM    FOUNDSW,B'10000000'                              02S0277
         BNO   @RF00277                                         02S0277
*            DO;                       /* FIND CORRECT GROUP         */
*              GRPTABP = LUVGENP -> GENGRPTR; /* FIRST GROUP PTR
*                                         TABLE ENTRY FOR GENERIC    */
         L     @08,LUVGENP(,LUVPTR)                             02S0279
         L     GRPTABP,GENGRPTR(,@08)                           02S0279
*              UCBFOUND = OFF;         /* INIT UCB FOUND SWITCH      */
         NI    UCBFOUND,B'10111111'                             02S0280
*              DO GRPCTR = ONE TO LUVGENP -> GENGRPNO           02S0281
*                WHILE(UCBFOUND = OFF); /* LOOK AT ALL GROUPS        */
         LA    @08,1                                            02S0281
         B     @DE00281                                         02S0281
@DL00281 TM    UCBFOUND,B'01000000'                             02S0281
         BNZ   @DC00281                                         02S0281
*                DO UCBCTR = ONE TO GRPUCBNO WHILE(UCBFOUND = OFF);
         LA    UCBCTR,1                                         02S0282
         B     @DE00282                                         02S0282
@DL00282 TM    UCBFOUND,B'01000000'                             02S0282
         BNZ   @DC00282                                         02S0282
*                                      /* LOOK AT ALL UCBS UNTIL A
*                                         MATCH IS FOUND             */
*                  IF IOSLUT(EUCBTPOS(UCBCTR)+ONE) = UCBPTR THEN
         LR    @07,UCBCTR                                       02S0283
         ALR   @07,@07                                          02S0283
         L     @15,GRPTR(,GRPTABP)                              02S0283
         L     @01,GRPUCBP(,@15)                                02S0283
         BCTR  @01,0                                            02S0283
         BCTR  @01,0                                            02S0283
         LH    @07,EUCBTPOS(@07,@01)                            02S0283
         ALR   @07,@07                                          02S0283
         L     @14,@PC00001                                     02S0283
         L     @01,ALCWAPTR(,@14)                               02S0283
         L     @01,IOSLUTP(,@01)                                02S0283
         ALR   @01,@07                                          02S0283
         SLR   @07,@07                                          02S0283
         ICM   @07,3,IOSLUT(@01)                                02S0283
         CR    UCBPTR,@07                                       02S0283
         BNE   @RF00283                                         02S0283
*                                      /* FOUND THE UCB IN THIS GROUP*/
*                    DO;               /* FILL IN EDL GROUP ID       */
*                      UCBFOUND = ON;  /* UCB HAS BEEN FOUND         */
         OI    UCBFOUND,B'01000000'                             02S0285
*                      EDLGRID = GRPID; /* SET EDL GROUP ID          */
         MVC   EDLGRID(4,EDLGNTP),GRPID(@15)                    02S0286
*                      EDLLUV=LUVALUE;  /*SET EDL LUV FROM EOT       */
         L     @07,SIOTEDLP(,SIOTPTR)                           02S0287
         MVC   EDLLUV(4,@07),LUVALUE(LUVPTR)                    02S0287
*                      EDLDEVT=LUVGENP->GENDEVT; /*SET GEN LUV       */
         L     @01,LUVGENP(,LUVPTR)                             02S0288
         MVC   EDLDEVT(4,EDLPTR),GENDEVT(@01)                   02S0288
*                      EDLGMTP=LUVGMTP; /*SET GROUP MASK TABLE PTR   */
         MVC   EDLGMTP(4,@07),LUVGMTP(LUVPTR)                   02S0289
*                    END;                                       02S0290
*                END;                                           02S0291
@RF00283 AH    UCBCTR,@CH00051                                  02S0291
@DE00282 L     @07,GRPTR(,GRPTABP)                              02S0291
         C     UCBCTR,GRPUCBNO(,@07)                            02S0291
         BNH   @DL00282                                         02S0291
@DC00282 DS    0H                                               02S0292
*                GRPTABP = GRPTABP + LENGTH(GRPTRTAB); /* NEXT EDT
*                                         GROUP ENTRY                */
         AH    GRPTABP,@CH00062                                 02S0292
*              END;                                             02S0293
         LA    @08,1                                            02S0293
         AL    @08,GRPCTR                                       02S0293
@DE00281 ST    @08,GRPCTR                                       02S0293
         L     @07,LUVGENP(,LUVPTR)                             02S0293
         C     @08,GENGRPNO(,@07)                               02S0293
         BNH   @DL00281                                         02S0293
@DC00281 DS    0H                                               02S0294
*            END;                                               02S0294
*          ELSE                        /* CORRECT LUV NOT FOUND      */
*            LUVPTR = LUVPTR + LENGTH(LUVENTRY); /* NEXT LUV ENTRY   */
         B     @RC00277                                         02S0295
@RF00277 AH    LUVPTR,@CH00092                                  02S0295
*        END;                                                   02S0296
@RC00277 AH    LUVCTR,@CH00051                                  02S0296
@DE00251 L     @08,@PC00001                                     02S0296
         L     @08,ALCWAPTR(,@08)                               02S0296
         L     @08,EDTABPTR(,@08)                               02S0296
         L     @08,EDTLUVSP(,@08)                               02S0296
         C     LUVCTR,LUVENTNO(,@08)                            02S0296
         BNH   @DL00251                                         02S0296
@DC00251 DS    0H                                               02S0297
*      END;                                                     02S0297
*  END;                                                         02S0298
*ELSE                                  /* GETMAIN NOT SUCCESSFUL     */
*  DO;                                 /* INDICATE GETMAIN FAILURE   */
         B     @RC00234                                         02S0299
@RF00234 DS    0H                                               02S0300
*    RETNCODE = FAIL;                  /* BLDSPEDL FAILED            */
         MVC   RETNCODE(2),@CH00062                             02S0300
*    STEPRSNC = GETMAIN;               /* GETMAIN ERROR              */
         L     @10,@PC00001                                     02S0301
         L     @10,ALCWAPTR(,@10)                               02S0301
         L     @10,FAILRSCP(,@10)                               02S0301
         MVC   STEPRSNC(2,@10),@CH00072                         02S0301
*  END;                                                         02S0302
*          END;                                                 01S0303
@RC00234 DS    0H                                               01S0304
*      CALL IEFAB438;                  /* GET DDR COUNT              */
@RC00205 DS    0H                                               01S0304
@RC00079 L     @10,ATCAPTR                                      01S0304
         L     @15,ATCA438P(,@10)                               01S0304
         BALR  @14,@15                                          01S0304
*      DDRCNT2 = REG15;                /* SAVE DDR COUNT             */
         LR    DDRCNT2,REG15                                    01S0305
*      IF DDRCNT2 ^= DDRCNT THEN       /* COUNTS NOT EQUAL           */
         C     DDRCNT2,DDRCNT                                   01S0306
         BE    @RF00306                                         01S0306
*        DO;                           /* SET UP TO REBUILD EDL      */
*          RFY (REG0,REG1) RSTD;                                01S0308
*          REG0 = SIOTEDLS;            /* GET EDL LENGTH FOR FREEMAIN*/
         L     REG0,SIOTEDLS(,SIOTPTR)                          01S0309
*          REG0 = REG0 | SUBPL230;     /* FREE FROM SUBPOOL 230.     */
         O     REG0,@CF00093                                    01S0310
*          REG1 = SIOTEDLP;            /* PTR TO EDL                 */
         L     REG1,SIOTEDLP(,SIOTPTR)                          01S0311
*          SIOTEDLP = ZERO;            /* ZERO SIOT PTR TO EDL       */
         SLR   @10,@10                                          01S0312
         ST    @10,SIOTEDLP(,SIOTPTR)                           01S0312
*          SIOTEDLS = ZERO;            /* ZERO EDL LENGTH            */
         ST    @10,SIOTEDLS(,SIOTPTR)                           01S0313
*          GEN(  FREEMAIN R,LV=(0),A=(1) );                     01S0314
           FREEMAIN R,LV=(0),A=(1)
*          RFY (REG0,REG1) UNRSTD;                              01S0315
*          SIOTCTR = SIOTCTR - ONE;    /* RESET LOOP CTR             */
         L     @10,SIOTCTR                                      01S0316
         BCTR  @10,0                                            01S0316
         ST    @10,SIOTCTR                                      01S0316
*          NOBUMP = ON;                /* DONT BUMP SIOT PTR         */
         OI    NOBUMP,B'10000000'                               01S0317
*        END;                                                   01S0318
*    END;                                                       01S0319
@RF00306 DS    0H                                               01S0320
*  IF NOBUMP = OFF THEN                /* DDR COUNTS WERE EQUAL      */
@RF00075 TM    NOBUMP,B'10000000'                               01S0320
         BNZ   @RF00320                                         01S0320
*    SIOTPTR = SIOTNPTR;               /* GET NEXT SIOT              */
         L     SIOTPTR,SIOTNPTR(,SIOTPTR)                       01S0321
*END;                                                           01S0322
@RF00320 LA    @10,1                                            01S0322
         AL    @10,SIOTCTR                                      01S0322
@DE00072 ST    @10,SIOTCTR                                      01S0322
         L     @08,@PC00001                                     01S0322
         L     @08,ALCWAPTR(,@08)                               01S0322
         C     @10,NUMREQS(,@08)                                01S0322
         BNH   @DL00072                                         01S0322
@DC00072 DS    0H                                               01S0323
*RETURN CODE(RETNCODE);                                         01S0323
         LH    @10,RETNCODE                                     01S0323
         L     @13,4(,@13)                                      01S0323
         L     @00,@SIZDATD                                     01S0323
         LR    @01,@11                                          01S0323
         FSPACE   R,LV=(0),A=(1)
         LR    @15,@10                                          01S0323
         L     @14,12(,@13)                                     01S0323
         LM    @00,@12,20(@13)                                  01S0323
         BR    @14                                              01S0323
*END IEFAB424                                                   01S0324
*/* THE FOLLOWING INCLUDE STATEMENTS WERE FOUND IN THIS PROGRAM.      *
*/*%INCLUDE SYSLIB  (A424SPEC)                                        *
*/*%INCLUDE SYSLIB  (A424DATA)                                        *
*/*%INCLUDE SYSLIB  (BLDNDATA)                                        *
*/*%INCLUDE SYSLIB  (FILLDATA)                                        *
*/*%INCLUDE SYSLIB  (BLDSDATA)                                        *
*/*%INCLUDE SYSLIB  (IEFUCBOB)                                        *
*/*%INCLUDE SYSLIB  (CVT     )                                        *
*/*%INCLUDE SYSLIB  (IEZSSC  )                                        *
*/*%INCLUDE SYSLIB  (IHASUBIT)                                        *
*/*%INCLUDE SYSLIB  (IEFASIOT)                                        *
*/*%INCLUDE SYSLIB  (IEFZB421)                                        *
*/*%INCLUDE SYSLIB  (IEFZB422)                                        *
*/*%INCLUDE SYSLIB  (IEFZB425)                                        *
*/*%INCLUDE SYSLIB  (IEFZB432)                                        *
*/*%INCLUDE SYSLIB  (BLDNSEDL)                                        *
*/*%INCLUDE SYSLIB  (BLDNSPEC)                                        *
*/*%INCLUDE SYSLIB  (FILLEDL )                                        *
*/*%INCLUDE SYSLIB  (FILLSPEC)                                        *
*/*%INCLUDE SYSLIB  (BLDSPEDL)                                        *
*/*%INCLUDE SYSLIB  (BLDSSPEC)                                        *
*;                                                              01S0324
@DATA    DS    0H
@CH00051 DC    H'1'
@CH00072 DC    H'2'
@CH00062 DC    H'4'
@CH00064 DC    H'8'
@CH00111 DC    H'10'
@CH01488 DC    H'12'
@CH01683 DC    H'20'
@CH00269 DC    H'24'
@CH00092 DC    H'32'
@CH00097 DC    H'72'
@CH00080 DC    H'74'
@DATD    DSECT
         DS    0F
@SA00001 DS    18F
@PC00001 DS    1F
IEFAB424 CSECT
         DS    0F
@CF01692 DC    F'-4'
@CF00093 DC    XL4'E6000000'
@DATD    DSECT
         DS    0D
ATCAPTR  DS    A
DDRCNT   DS    F
SIOTCTR  DS    F
GENCTR   DS    F
GRPCTR   DS    F
TOTGRP   DS    F
EDTPTR   DS    A
GRPPTR   DS    A
GTSTRTCD DS    F
RETNCODE DS    H
@TS00001 DS    CL2
NOBUMP   DS    BL1
MSSELIG  DS    BL1
MSSDEVTP DS    BL1
ONEGENER DS    BL1
ELIGSW   DS    BL1
LUVFNDSW DS    BL1
INDICS   DS    BL1
         ORG   INDICS
FOUNDSW  DS    BL1
UCBFOUND EQU   INDICS+0
@NM00008 EQU   INDICS+0
         ORG   INDICS+1
IEFAB424 CSECT
         DS    0F
@SIZDATD DC    AL1(230)
         DC    AL3(@ENDDATD-@DATD)
         DS    0D
GTSTZERO DC    F'0'
@CB00087 DC    X'FFFC'
@CB00117 DC    X'8003'
IEFAB424 CSECT
         DS   0H
A424PTCH DC ((@DATA-@PSTART)/20)X'00'
@DATD    DSECT
         ORG   *+1-(*-@DATD)/(*-@DATD) INSURE DSECT DATA
@ENDDATD EQU   *
IEFAB424 CSECT
@00      EQU   00                      EQUATES FOR REGISTERS 0-15
@01      EQU   01
@02      EQU   02
@03      EQU   03
@04      EQU   04
@05      EQU   05
@06      EQU   06
@07      EQU   07
@08      EQU   08
@09      EQU   09
@10      EQU   10
@11      EQU   11
@12      EQU   12
@13      EQU   13
@14      EQU   14
@15      EQU   15
UCBPTR   EQU   @02
TOTUN    EQU   @06
GRPTABP  EQU   @04
GENPTR   EQU   @02
UCBCTR   EQU   @08
LUVCTR   EQU   @06
DDRCNT2  EQU   @02
SIOTPTR  EQU   @09
LUVPTR   EQU   @10
EDLUCBLP EQU   @07
EDLPTR   EQU   @03
EDLGNTP  EQU   @05
REG0     EQU   @00
REG1     EQU   @01
REG15    EQU   @15
GTSTR0   EQU   @00
GTSTR1   EQU   @01
GTSTR2   EQU   @02
GTSTR15  EQU   @15
GTSTR4   EQU   @04
GTSTR5   EQU   @05
GTSTR6   EQU   @06
GTSTR7   EQU   @07
GTSTR8   EQU   @08
GTSTR3   EQU   @03
CVTPTR   EQU   16
STEPRSNC EQU   0
DEVTYPE  EQU   0
@NM00002 EQU   DEVTYPE+1
DEVRVDEV EQU   @NM00002
@NM00005 EQU   DEVTYPE+2
DEVDACC  EQU   @NM00005
DEVUNTYP EQU   DEVTYPE+3
IOSLUT   EQU   0
UCB      EQU   0
UCBOB    EQU   0
UCBJBNR  EQU   UCBOB
UCBFL5   EQU   UCBOB+1
UCBAF    EQU   UCBFL5
UCBSTAT  EQU   UCBOB+3
UCBCHAN  EQU   UCBOB+4
UCBSFLS  EQU   UCBOB+6
UCBFLA   EQU   UCBSFLS
UCBFL1   EQU   UCBFLA
UCBBSY   EQU   UCBFL1
UCBNRY   EQU   UCBFL1
UCBPST   EQU   UCBFL1
UCBCUB   EQU   UCBFL1
UCBFLB   EQU   UCBSFLS+1
UCBCHM   EQU   UCBOB+8
UCBCHM1  EQU   UCBCHM
UCBPTH0  EQU   UCBCHM1
UCBPTH1  EQU   UCBCHM1
UCBWGT   EQU   UCBOB+12
UCBTYP   EQU   UCBOB+16
UCBTBYT1 EQU   UCBTYP
UCB1FEA5 EQU   UCBTBYT1
UCB1FEA6 EQU   UCBTBYT1
UCBTBYT2 EQU   UCBTYP+1
UCB2OPT2 EQU   UCBTBYT2
UCBDUDN1 EQU   UCB2OPT2
UCB2OPT3 EQU   UCBTBYT2
UCBDUDN2 EQU   UCB2OPT3
UCB2OPT4 EQU   UCBTBYT2
UCBRWTAU EQU   UCB2OPT4
UCBRVDEV EQU   UCBRWTAU
UCB2OPT6 EQU   UCBTBYT2
UCB2OPT7 EQU   UCBTBYT2
UCBTBYT3 EQU   UCBTYP+2
UCBDVCLS EQU   UCBTBYT3
UCB3TAPE EQU   UCBDVCLS
UCB3COMM EQU   UCBDVCLS
UCB3DACC EQU   UCBDVCLS
UCB3DISP EQU   UCBDVCLS
UCB3UREC EQU   UCBDVCLS
UCBTBYT4 EQU   UCBTYP+3
UCBUNTYP EQU   UCBTBYT4
UCBEXTPT EQU   UCBOB+20
UCBFLC   EQU   UCBEXTPT
UCBDEV   EQU   UCBOB+24
UCBCMEXT EQU   0
UCBATI   EQU   UCBCMEXT+3
@NM00012 EQU   UCBATI
UCBFLP1  EQU   UCBCMEXT+5
UCBMT    EQU   0
UCBOCR   EQU   0
UCB3540X EQU   0
UCBDKBYT EQU   UCB3540X+6
UCB3800X EQU   0
UCBOPTNS EQU   UCB3800X
UCBACTIV EQU   UCB3800X+3
UCBMDRBF EQU   UCB3800X+36
UCBUCS   EQU   0
UCBUCSOP EQU   UCBUCS+4
UCBFCBOP EQU   UCBUCS+5
CVTMAP   EQU   0
CVTDAR   EQU   CVTMAP+72
CVTFLGS1 EQU   CVTDAR
CVTDCB   EQU   CVTMAP+116
CVTIERLC EQU   CVTMAP+144
CVTQMWR  EQU   CVTMAP+176
CVTOPTA  EQU   CVTMAP+182
CVTOPTB  EQU   CVTMAP+183
CVTGTF   EQU   CVTMAP+236
CVTGTFST EQU   CVTGTF
CVTGTFS  EQU   CVTGTFST
CVTSTATE EQU   CVTGTFST
CVTTMODE EQU   CVTGTFST
CVTFORM  EQU   CVTGTFST
CVTAQAVT EQU   CVTMAP+240
CVTTCMFG EQU   CVTAQAVT
CVTVOLM2 EQU   CVTMAP+244
CVTTATA  EQU   CVTVOLM2
CVTTSKS  EQU   CVTTATA
CVTVOLF2 EQU   CVTTSKS
CVTTAT   EQU   CVTTATA+1
CVTATER  EQU   CVTMAP+248
CVTEXT1  EQU   CVTMAP+252
CVTPURG  EQU   CVTMAP+260
CVTQMSG  EQU   CVTMAP+268
CVTDMSR  EQU   CVTMAP+272
CVTRSV37 EQU   CVTDMSR
CVTDMSRF EQU   CVTRSV37
CVTERPV  EQU   CVTMAP+316
CVTINTLA EQU   CVTMAP+320
CVTAPF   EQU   CVTMAP+324
CVTEXT2  EQU   CVTMAP+328
CVTHJES  EQU   CVTMAP+332
CVTPGSIA EQU   CVTMAP+348
CVTA1F1  EQU   CVTMAP+356
CVTSYSK  EQU   CVTMAP+357
CVTVOLM1 EQU   CVTMAP+380
CVTVOLF1 EQU   CVTVOLM1
CVTATMCT EQU   CVTMAP+388
CVTXTNT1 EQU   0
CVTXTNT2 EQU   0
CVTDSSV  EQU   CVTXTNT2
CVTFLGBT EQU   CVTXTNT2+5
CVTQID   EQU   CVTXTNT2+24
CVTICB   EQU   CVTXTNT2+48
CVTRV400 EQU   CVTXTNT2+52
CVTRV409 EQU   CVTXTNT2+53
CVTATCVT EQU   CVTXTNT2+64
CVTRV429 EQU   CVTXTNT2+84
CVTRV438 EQU   CVTXTNT2+85
CVTRV457 EQU   CVTXTNT2+112
CVTRV466 EQU   CVTXTNT2+113
CVTFIX   EQU   0
CVTRELNO EQU   CVTFIX+252
ICB2SSCB EQU   0
ICBOPT   EQU   ICB2SSCB+48
ICBFLG   EQU   ICB2SSCB+52
ICBFG1   EQU   ICBFLG
ICBI     EQU   ICBFG1
ICBB     EQU   ICBFG1
ICBTRACE EQU   ICB2SSCB+112
SUBITS   EQU   0
SUBYTE1  EQU   SUBITS
SUBYTE2  EQU   SUBITS+1
SUBYTE3  EQU   SUBITS+2
SUBYTE4  EQU   SUBITS+3
SU24BIT  EQU   SUBYTE4
SUBYTE5  EQU   SUBITS+4
SUBYTE6  EQU   SUBITS+5
SUBYTE7  EQU   SUBITS+6
SUBYTE8  EQU   SUBITS+7
SUBYTE9  EQU   SUBITS+8
SUBYTE10 EQU   SUBITS+9
SUBYTE11 EQU   SUBITS+10
SUBYTE12 EQU   SUBITS+11
SUBYTE13 EQU   SUBITS+12
INDMSIOT EQU   0
SCTUSADD EQU   INDMSIOT+20
SIOTOTUN EQU   INDMSIOT+39
SIOTBYT1 EQU   INDMSIOT+43
SIOTALCD EQU   SIOTBYT1
SIOTBYT3 EQU   INDMSIOT+46
SIOTTSTC EQU   INDMSIOT+47
SIOTBYT0 EQU   INDMSIOT+52
SIOTFUDA EQU   SIOTBYT0
SCTSDISP EQU   INDMSIOT+55
S3400DSP EQU   SCTSDISP
SCTSBYT1 EQU   INDMSIOT+56
SCTSBYT2 EQU   INDMSIOT+57
SCTSBYT3 EQU   INDMSIOT+58
SCTSBYT4 EQU   INDMSIOT+59
SCTUTYPE EQU   INDMSIOT+60
SIOTDEVT EQU   SCTUTYPE
SIOUBYT3 EQU   SIOTDEVT+2
SIO3COMM EQU   SIOUBYT3
SIOTBYT4 EQU   INDMSIOT+81
SIOTALTD EQU   INDMSIOT+92
SIOTBYT2 EQU   INDMSIOT+103
SIOTDMND EQU   SIOTBYT2
SIOTRSNC EQU   INDMSIOT+130
SIOTEDLS EQU   INDMSIOT+132
SIOTEDLP EQU   INDMSIOT+136
SIOTNPTR EQU   INDMSIOT+152
EDTHDR   EQU   0
EDTLUVSP EQU   EDTHDR
EDTGENSP EQU   EDTHDR+4
EDTGRPSP EQU   EDTHDR+8
EDTUCBSP EQU   EDTHDR+12
EDTMSKTP EQU   EDTHDR+16
LUVSECT  EQU   0
LUVHDR   EQU   LUVSECT
LUVENTNO EQU   LUVHDR
LUVENTRY EQU   0
LUVALUE  EQU   LUVENTRY+8
LUVGMTP  EQU   LUVENTRY+12
LUVGENNO EQU   LUVENTRY+16
LUVGENP  EQU   LUVENTRY+20
LUVFLAGS EQU   LUVENTRY+24
LUVMGENS EQU   LUVFLAGS
GENSECT  EQU   0
GENHDR   EQU   GENSECT
GENENTRY EQU   0
GENDEVT  EQU   GENENTRY
GENGRPNO EQU   GENENTRY+4
GENGRPTR EQU   GENENTRY+8
GRPTRTAB EQU   0
GRPTR    EQU   GRPTRTAB
GRPSECT  EQU   0
GRPHDR   EQU   GRPSECT
GRPENTRY EQU   0
GRPID    EQU   GRPENTRY
GRPUCBNO EQU   GRPENTRY+4
GRPUCBP  EQU   GRPENTRY+8
EUCBSECT EQU   0
EUCBHDR  EQU   EUCBSECT
EUCBENTY EQU   0
EUCBTPOS EQU   EUCBENTY
GRMSKTAB EQU   0
GMTHDR   EQU   GRMSKTAB
GMTENTRY EQU   0
IEFEDL   EQU   0
EDLHDR   EQU   IEFEDL
EDLLUV   EQU   EDLHDR
EDLGENNO EQU   EDLHDR+4
EDLFGENP EQU   EDLHDR+8
EDLGMTP  EQU   EDLHDR+12
EDLUVFLG EQU   EDLHDR+16
EDLMGENS EQU   EDLUVFLG
EDLENTRY EQU   0
EDLNXTNT EQU   EDLENTRY
EDLDEVT  EQU   EDLENTRY+4
EDLGRPNO EQU   EDLENTRY+8
EDLGRPTR EQU   EDLENTRY+12
EDLDTFLG EQU   EDLENTRY+20
EINDEVTP EQU   EDLDTFLG
EDLGNTRY EQU   0
EDLNXGRP EQU   EDLGNTRY
EDLUCBNO EQU   EDLGNTRY+4
EDLLISTP EQU   EDLGNTRY+8
EDLGRID  EQU   EDLGNTRY+12
EDLGRFLG EQU   EDLGNTRY+16
EDLJINEL EQU   EDLGRFLG
EDLUCBL  EQU   0
EDLUCBAD EQU   EDLUCBL
EDLINDIC EQU   EDLUCBL+2
ALCWA    EQU   0
SIOT1P   EQU   ALCWA+8
IOSLUTP  EQU   ALCWA+16
FAILRSCP EQU   ALCWA+20
EDTABPTR EQU   ALCWA+24
CNTABLE  EQU   ALCWA+28
NUMREQS  EQU   CNTABLE+40
INDICATE EQU   ALCWA+112
@NM00031 EQU   ALCWA+113
TIOTHDRP EQU   ALCWA+120
NAMES    EQU   0
ATCA     EQU   0
ATCA438P EQU   ATCA
IEFAB438 EQU   0
UCBBGN   EQU   0
ALCWAPTR EQU   0
UCBOBS01 EQU   UCBDEV
UCBSTAB  EQU   UCBOBS01+10
UCBBSVL  EQU   UCBSTAB
UCBPRSRS EQU   UCBSTAB
UCBDMCT  EQU   UCBOBS01+11
UCBFL4   EQU   UCBOBS01+13
UCBOBS02 EQU   UCBDEV
UCBTFL1  EQU   UCBOBS02+19
UCBXTN   EQU   UCBOBS02+20
UCBVOPT  EQU   UCBXTN
UCBOBS03 EQU   UCBDEV
UCBXTADR EQU   UCBOBS03
UCBOBS04 EQU   UCBDEV
UCBBTA   EQU   UCBOBS04+12
UCBOBS06 EQU   UCBDEV
UCBAOF   EQU   UCBOBS06
UCBAOF1  EQU   UCBAOF
UCBAOF2  EQU   UCBAOF+1
@NM00011 EQU   UCBOBS06+3
UCBIRB   EQU   UCBOBS06+4
UCBGRAF  EQU   UCBIRB
UCBLDNCA EQU   UCBOBS06+8
UCBRDYQ  EQU   UCBLDNCA
UCBIRLN  EQU   UCBRDYQ
UCBLDNCB EQU   UCBRDYQ+1
UCBCTLNK EQU   UCBOBS06+12
UCBOBS07 EQU   UCBDEV
UCBOBS08 EQU   UCBDEV
UCBCTCAD EQU   UCBOBS08
UCBCTCF1 EQU   UCBOBS08+4
UCBOBS09 EQU   UCBDEV
CVTS01   EQU   CVTPGSIA
CVTLPDIA EQU   CVTS01+12
CVTDIRST EQU   CVTLPDIA
CVTSLIDA EQU   CVTS01+24
CVTCTLFG EQU   CVTS01+50
CVTRV210 EQU   CVTS01+424
CVTRV219 EQU   CVTS01+425
CVTRV228 EQU   CVTS01+426
CVTRV237 EQU   CVTS01+427
CVTMFRTR EQU   CVTS01+452
CVTRV262 EQU   CVTS01+468
CVTRV271 EQU   CVTS01+469
CVTRV280 EQU   CVTS01+470
CVTRV289 EQU   CVTS01+471
CVTGSDA  EQU   CVTS01+600
CVTIHASU EQU   CVTS01+696
         AGO   .@UNREFD                START UNREFERENCED COMPONENTS
CVTRV628 EQU   CVTS01+728
CVTRV627 EQU   CVTS01+724
CVTRV626 EQU   CVTS01+720
CVTRV625 EQU   CVTS01+716
CVTRV624 EQU   CVTS01+712
CVTRV623 EQU   CVTS01+708
CVTRV622 EQU   CVTS01+704
CVTRV621 EQU   CVTS01+700
CVTSUSP  EQU   CVTS01+692
CVTT6SVC EQU   CVTS01+688
CVTCDAL  EQU   CVTS01+684
CVTTCTL  EQU   CVTS01+680
CVTRSUME EQU   CVTS01+676
CVTJTERM EQU   CVTS01+672
CVTASMRM EQU   CVTS01+668
CVTTCASP EQU   CVTS01+664
CVT0PT03 EQU   CVTS01+660
CVT0PT0E EQU   CVTS01+656
CVTRV609 EQU   CVTS01+652
CVTCGK   EQU   CVTS01+648
CVTRAC   EQU   CVTS01+644
CVTRV606 EQU   CVTS01+640
CVTRV605 EQU   CVTS01+636
CVTRV604 EQU   CVTS01+632
CVTEFF02 EQU   CVTS01+628
CVTCBBR  EQU   CVTS01+624
CVTSSCR  EQU   CVTS01+620
CVTEVENT EQU   CVTS01+616
CVTCRCA  EQU   CVTS01+612
CVTTPIO  EQU   CVTS01+608
CVTADV   EQU   CVTS01+604
CVTGSDAB EQU   CVTGSDA
CVTQV3   EQU   CVTS01+596
CVTQV2   EQU   CVTS01+592
CVTQV1   EQU   CVTS01+588
CVTRPT   EQU   CVTS01+584
CVTSSRB  EQU   CVTS01+580
CVTCSDRL EQU   CVTS01+576
CVTEXP1  EQU   CVTS01+572
CVTRMPMT EQU   CVTS01+568
CVTRMPTT EQU   CVTS01+564
CVTVPSA  EQU   CVTS01+560
CVTVSTOP EQU   CVTS01+556
CVTGTFR8 EQU   CVTS01+552
CVTQUIT  EQU   CVTS01+548
CVTVACR  EQU   CVTS01+544
CVTWTCB  EQU   CVTS01+540
CVTSTPRS EQU   CVTS01+536
CVT0PT02 EQU   CVTS01+532
CVTDARCM EQU   CVTS01+528
CVTIRECM EQU   CVTS01+524
CVTJRECM EQU   CVTS01+520
CVTVEMS0 EQU   CVTS01+516
CVTSPFRR EQU   CVTS01+512
CVTRLSTG EQU   CVTS01+508
CVT0TC0A EQU   CVTS01+504
CVTGMBR  EQU   CVTS01+500
CVTLFRM  EQU   CVTS01+496
CVTRMBR  EQU   CVTS01+492
CVTVIOP  EQU   CVTS01+488
CVTRV307 EQU   CVTS01+486
CVTRV306 EQU   CVTS01+484
CVTRV305 EQU   CVTS01+482
CVTRV304 EQU   CVTS01+480
CVTRV303 EQU   CVTS01+478
CVTRV302 EQU   CVTS01+476
CVTTRCA  EQU   CVTS01+472
CVTRV297 EQU   CVTRV289
CVTRV296 EQU   CVTRV289
CVTRV295 EQU   CVTRV289
CVTRV294 EQU   CVTRV289
CVTRV293 EQU   CVTRV289
CVTRV292 EQU   CVTRV289
CVTRV291 EQU   CVTRV289
CVTRV290 EQU   CVTRV289
CVTRV288 EQU   CVTRV280
CVTRV287 EQU   CVTRV280
CVTRV286 EQU   CVTRV280
CVTRV285 EQU   CVTRV280
CVTRV284 EQU   CVTRV280
CVTRV283 EQU   CVTRV280
CVTRV282 EQU   CVTRV280
CVTRV281 EQU   CVTRV280
CVTRV279 EQU   CVTRV271
CVTRV278 EQU   CVTRV271
CVTRV277 EQU   CVTRV271
CVTRV276 EQU   CVTRV271
CVTRV275 EQU   CVTRV271
CVTRV274 EQU   CVTRV271
CVTRV273 EQU   CVTRV271
CVTRV272 EQU   CVTRV271
CVTRV270 EQU   CVTRV262
CVTRV269 EQU   CVTRV262
CVTRV268 EQU   CVTRV262
CVTRV267 EQU   CVTRV262
CVTRV266 EQU   CVTRV262
CVTRV265 EQU   CVTRV262
CVTRV264 EQU   CVTRV262
CVTRV263 EQU   CVTRV262
CVTVFP   EQU   CVTS01+464
CVTVSI   EQU   CVTS01+460
CVTVPSIB EQU   CVTS01+456
CVTMFACT EQU   CVTMFRTR
CVTMFCTL EQU   CVTS01+448
CVTPVBP  EQU   CVTS01+444
CVTPWI   EQU   CVTS01+440
CVTRV254 EQU   CVTS01+438
CVTRV253 EQU   CVTS01+436
CVTRV252 EQU   CVTS01+434
CVTRV251 EQU   CVTS01+433
CVTRV250 EQU   CVTS01+432
CVTRV249 EQU   CVTS01+431
CVTRV248 EQU   CVTS01+430
CVTRV247 EQU   CVTS01+429
CVTRV246 EQU   CVTS01+428
CVTRV245 EQU   CVTRV237
CVTRV244 EQU   CVTRV237
CVTRV243 EQU   CVTRV237
CVTRV242 EQU   CVTRV237
CVTRV241 EQU   CVTRV237
CVTRV240 EQU   CVTRV237
CVTRV239 EQU   CVTRV237
CVTRV238 EQU   CVTRV237
CVTRV236 EQU   CVTRV228
CVTRV235 EQU   CVTRV228
CVTRV234 EQU   CVTRV228
CVTRV233 EQU   CVTRV228
CVTRV232 EQU   CVTRV228
CVTRV231 EQU   CVTRV228
CVTRV230 EQU   CVTRV228
CVTRV229 EQU   CVTRV228
CVTRV227 EQU   CVTRV219
CVTRV226 EQU   CVTRV219
CVTRV225 EQU   CVTRV219
CVTRV224 EQU   CVTRV219
CVTRV223 EQU   CVTRV219
CVTRV222 EQU   CVTRV219
CVTRV221 EQU   CVTRV219
CVTRV220 EQU   CVTRV219
CVTRV218 EQU   CVTRV210
CVTRV217 EQU   CVTRV210
CVTRV216 EQU   CVTRV210
CVTRV215 EQU   CVTRV210
CVTRV214 EQU   CVTRV210
CVTRV213 EQU   CVTRV210
CVTRV212 EQU   CVTRV210
CVTRV211 EQU   CVTRV210
CVTLCCAT EQU   CVTS01+420
CVTPCCAT EQU   CVTS01+416
CVTIPCRP EQU   CVTS01+412
CVTIPCRI EQU   CVTS01+408
CVTIPCDS EQU   CVTS01+404
CVTAIDVT EQU   CVTS01+400
CVTSSAP  EQU   CVTS01+396
CVTEHCIR EQU   CVTS01+392
CVTEHDEF EQU   CVTS01+388
CVTDAIR  EQU   CVTS01+384
CVTPERFM EQU   CVTS01+380
CVT044R2 EQU   CVTS01+376
CVTFETCH EQU   CVTS01+372
CVTRSTWD EQU   CVTS01+368
CVTSPOST EQU   CVTS01+364
CVTIOBP  EQU   CVTS01+360
CVTASMVT EQU   CVTS01+356
CVTRECRQ EQU   CVTS01+352
CVTWSAC  EQU   CVTS01+348
CVTRV149 EQU   CVTS01+344
CVTWSAL  EQU   CVTS01+340
CVTSPSA  EQU   CVTS01+336
CVTGLMN  EQU   CVTS01+332
CVTVEAC0 EQU   CVTS01+328
CVT062R1 EQU   CVTS01+324
CVTRPOST EQU   CVTS01+320
CVTDQIQE EQU   CVTS01+316
CVTCSD   EQU   CVTS01+312
CVTLKRMA EQU   CVTS01+308
CVTRSPIE EQU   CVTS01+304
CVTRENQ  EQU   CVTS01+300
CVTLQCB  EQU   CVTS01+296
CVTFQCB  EQU   CVTS01+292
CVTQCS01 EQU   CVTS01+288
CVTAPFT  EQU   CVTS01+284
CVTPARRL EQU   CVTS01+280
CVTVWAIT EQU   CVTS01+276
CVTGSPL  EQU   CVTS01+272
CVTLSMQ  EQU   CVTS01+268
CVTGSMQ  EQU   CVTS01+264
CVTEXPRO EQU   CVTS01+260
CVTOPCTP EQU   CVTS01+256
CVTSIC   EQU   CVTS01+252
CVTTPIOS EQU   CVTS01+248
CVTRTMS  EQU   CVTS01+244
CVTSDBF  EQU   CVTS01+240
CVTSCBP  EQU   CVTS01+236
CVTSDMP  EQU   CVTS01+232
CVTSV60  EQU   CVTS01+228
CVTRTMCT EQU   CVTS01+224
CVTASCBL EQU   CVTS01+220
CVTASCBH EQU   CVTS01+216
CVTGDA   EQU   CVTS01+212
CVTASVT  EQU   CVTS01+208
CVTVVMDI EQU   CVTS01+204
CVTAQTOP EQU   CVTS01+200
CVTIOSCS EQU   CVTS01+196
CVTSDRM  EQU   CVTS01+192
CVTOPTE  EQU   CVTS01+188
CVTSTXU  EQU   CVTS01+184
CVTQUIS  EQU   CVTS01+180
CVTPARS  EQU   CVTS01+176
CVTS1EE  EQU   CVTS01+172
CVTFRAS  EQU   CVTS01+168
CVTQSAS  EQU   CVTS01+164
CVTCRAS  EQU   CVTS01+160
CVTCRMN  EQU   CVTS01+156
CVTDELCP EQU   CVTS01+152
CVTFRECL EQU   CVTS01+148
CVTGETCL EQU   CVTS01+144
CVTBLDCP EQU   CVTS01+140
CVTAUTHL EQU   CVTS01+136
CVTSCAN  EQU   CVTS01+132
CVTRV144 EQU   CVTS01+130
CVTMAXMP EQU   CVTS01+128
CVTSTCK  EQU   CVTS01+124
CVTRV139 EQU   CVTS01+123
CVTDSSAC EQU   CVTS01+122
CVTRV513 EQU   CVTS01+121
CVTIOSPL EQU   CVTS01+120
CVTPTGT  EQU   CVTS01+116
CVTCSPIE EQU   CVTS01+112
CVTSMFEX EQU   CVTS01+108
CVTOLT0A EQU   CVTS01+104
CVTSRBRT EQU   CVTS01+100
CVTPUTL  EQU   CVTS01+96
CVTASCRL EQU   CVTS01+92
CVTASCRF EQU   CVTS01+88
CVTRV326 EQU   CVTS01+84
CVTRV325 EQU   CVTS01+80
CVTRV324 EQU   CVTS01+76
CVT0VL01 EQU   CVTS01+72
CVTSHRVM EQU   CVTS01+68
CVTRV332 EQU   CVTS01+64
CVTTAS   EQU   CVTS01+60
CVTRSCN  EQU   CVTS01+56
CVTTRAC2 EQU   CVTS01+54
CVTTRACE EQU   CVTS01+52
CVTAPG   EQU   CVTS01+51
CVTSDTRC EQU   CVTCTLFG
CVTGTRCE EQU   CVTCTLFG
CVTNOMP  EQU   CVTCTLFG
CVTRSV79 EQU   CVTCTLFG
CVTDSTAT EQU   CVTCTLFG
CVTRSV78 EQU   CVTCTLFG
CVTRV333 EQU   CVTCTLFG
CVTRV323 EQU   CVTCTLFG
CVTSPVLK EQU   CVTS01+49
CVTRSV77 EQU   CVTS01+48
CVTRV331 EQU   CVTS01+44
CVTRV330 EQU   CVTS01+40
CVTRV329 EQU   CVTS01+36
CVTRV328 EQU   CVTS01+32
CVTRV322 EQU   CVTS01+28
CVTSLID  EQU   CVTSLIDA+1
CVTSYLK  EQU   CVTSLIDA
CVTRV321 EQU   CVTS01+20
CVTRV320 EQU   CVTS01+16
CVTLPDIR EQU   CVTLPDIA+1
CVTRSV69 EQU   CVTDIRST
CVTRSV68 EQU   CVTDIRST
CVTRSV67 EQU   CVTDIRST
CVTRSV66 EQU   CVTDIRST
CVTRSV65 EQU   CVTDIRST
CVTRSV64 EQU   CVTDIRST
CVTRSV63 EQU   CVTDIRST
CVTDICOM EQU   CVTDIRST
CVTPVTP  EQU   CVTS01+8
CVTLPDSR EQU   CVTS01+4
CVTGETL  EQU   CVTS01
UCBRV066 EQU   UCBOBS09+4
UCBIOSBA EQU   UCBOBS09
UCBRV042 EQU   UCBOBS08+5
UCBRV082 EQU   UCBCTCF1
UCBRV081 EQU   UCBCTCF1
UCBRV080 EQU   UCBCTCF1
UCBRV079 EQU   UCBCTCF1
UCBRV078 EQU   UCBCTCF1
UCBRV077 EQU   UCBCTCF1
UCBRV076 EQU   UCBCTCF1
UCBCTC80 EQU   UCBCTCF1
UCBCTCAL EQU   UCBCTCAD
UCBICNCB EQU   UCBOBS07+4
UCBRV040 EQU   UCBOBS07
UCBCTLNA EQU   UCBCTLNK+1
UCBRLN   EQU   UCBCTLNK
UCBRDYQA EQU   UCBLDNCB
UCBINRLN EQU   UCBIRLN
UCBIRBA  EQU   UCBIRB+1
UCBRV039 EQU   UCBGRAF
UCBDWNR  EQU   UCBGRAF
UCBRPND  EQU   UCBGRAF
UCBUPM   EQU   UCBGRAF
UCBBTAM  EQU   UCBGRAF
UCBDRNO  EQU   UCBGRAF
UCBDRO   EQU   UCBGRAF
UCBOIP   EQU   UCBGRAF
UCBATRCD EQU   @NM00011
UCBSKPFG EQU   @NM00011
UCBRIPND EQU   @NM00011
UCBRTIAC EQU   @NM00011
UCBRSV79 EQU   @NM00011
UCBRSV78 EQU   @NM00011
UCBRSV77 EQU   @NM00011
UCBOLTEP EQU   @NM00011
UCBATNCT EQU   UCBOBS06+2
UCBRSV76 EQU   UCBAOF2
UCBRSV75 EQU   UCBAOF2
UCBRSV74 EQU   UCBAOF2
UCBRSV73 EQU   UCBAOF2
UCBRSV72 EQU   UCBAOF2
UCBRSV71 EQU   UCBAOF2
UCBRSV70 EQU   UCBAOF2
UCBRSV69 EQU   UCBAOF2
UCBRSV68 EQU   UCBAOF1
UCBRSV67 EQU   UCBAOF1
UCBRSV66 EQU   UCBAOF1
UCBRSV65 EQU   UCBAOF1
UCBRSV64 EQU   UCBAOF1
UCBOFNL  EQU   UCBAOF1
UCBOFSP  EQU   UCBAOF1
UCBOFMCR EQU   UCBAOF1
UCBBTB   EQU   UCBBTA+1
UCBDI    EQU   UCBBTA
UCBSNS   EQU   UCBOBS04+8
UCBTEB   EQU   UCBOBS04+4
UCBGCB   EQU   UCBOBS04+3
UCBOPEN  EQU   UCBOBS04+2
UCBSTART EQU   UCBOBS04
UCBXTNB  EQU   UCBXTN+1
UCBRSV22 EQU   UCBVOPT
UCBRSV21 EQU   UCBVOPT
UCBRSV20 EQU   UCBVOPT
UCBESVE  EQU   UCBVOPT
UCBERPC  EQU   UCBVOPT
UCBESVC  EQU   UCBVOPT
UCBEVA   EQU   UCBVOPT
UCBESV   EQU   UCBVOPT
UCBRV009 EQU   UCBTFL1
UCBRV008 EQU   UCBTFL1
UCBRV007 EQU   UCBTFL1
UCBRV006 EQU   UCBTFL1
UCBRV005 EQU   UCBTFL1
UCBRV038 EQU   UCBTFL1
UCBNSLTP EQU   UCBTFL1
UCBNLTP  EQU   UCBTFL1
UCBRES1B EQU   UCBOBS02+18
UCBFSER  EQU   UCBOBS02+12
@NM00010 EQU   UCBOBS02+4
UCBFSEQ  EQU   UCBOBS02+2
UCBFSCT  EQU   UCBOBS02
UCBNEXP  EQU   UCBOBS01+20
UCBBASE  EQU   UCBOBS01+16
UCBRES1A EQU   UCBOBS01+15
UCBUSER  EQU   UCBOBS01+14
UCBFL47  EQU   UCBFL4
UCBMAT   EQU   UCBFL4
UCBHOLD  EQU   UCBFL4
UCBATTN  EQU   UCBFL4
UCBDSS   EQU   UCBFL4
UCBRESVP EQU   UCBFL4
UCBWDAV  EQU   UCBFL4
UCBDAVV  EQU   UCBFL4
UCBSQC   EQU   UCBOBS01+12
UCBDATP  EQU   UCBOBS01+12
UCBDMC   EQU   UCBDMCT
UCBMOUNT EQU   UCBDMCT
UCBBNUL  EQU   UCBSTAB
UCBSHAR  EQU   UCBSTAB
UCBBSTR  EQU   UCBSTAB
UCBBPUB  EQU   UCBSTAB
UCBBPRV  EQU   UCBSTAB
UCBBALB  EQU   UCBPRSRS
UCBPGFL  EQU   UCBSTAB
UCBDVSHR EQU   UCBBSVL
UCBVOLI  EQU   UCBOBS01+4
UCBVTOC  EQU   UCBOBS01
ATCAMVCP EQU   ATCA+12
@NM00034 EQU   ATCA+8
@NM00033 EQU   ATCA+4
ALCPROCN EQU   NAMES+16
ALCSTEPN EQU   NAMES+8
ALCJOBN  EQU   NAMES
LOJSSNMP EQU   ALCWA+164
SSERBLKP EQU   ALCWA+160
GROUPSZ  EQU   ALCWA+156
GRIDPTR  EQU   ALCWA+152
ALCNUCBS EQU   ALCWA+148
EXITPRMP EQU   ALCWA+144
CANCELP  EQU   ALCWA+140
WORK3MP  EQU   ALCWA+136
WMASK2P  EQU   ALCWA+132
WMASKPTR EQU   ALCWA+128
LGENLOCK EQU   ALCWA+124
TCBP     EQU   ALCWA+116
ALCWASID EQU   ALCWA+114
@NM00032 EQU   @NM00031
NODEVERR EQU   @NM00031
NEEDRCVY EQU   @NM00031
ALCWAREC EQU   @NM00031
WAITIGEN EQU   @NM00031
UNITRECS EQU   @NM00031
ALCWADUL EQU   INDICATE
ALCWISAM EQU   INDICATE
DSSUNIT  EQU   INDICATE
DSSTAPE  EQU   INDICATE
PRIVASUM EQU   INDICATE
INDREQU  EQU   INDICATE
INDRETRY EQU   INDICATE
INDWAIT  EQU   INDICATE
QMGRRBP  EQU   ALCWA+108
RIMTABCT EQU   ALCWA+104
RIMTABLN EQU   ALCWA+100
RIMTABP  EQU   ALCWA+96
ALGTABSZ EQU   ALCWA+92
ALGTABP  EQU   ALCWA+88
VOLUNSZE EQU   ALCWA+84
VOLUNPTR EQU   ALCWA+80
@NM00030 EQU   ALCWA+78
LTUNITID EQU   ALCWA+76
TOTVOLUN EQU   CNTABLE+44
TOTREQS  EQU   CNTABLE+36
OTHEREQS EQU   CNTABLE+32
SUBSREQS EQU   CNTABLE+28
STRGREQS EQU   CNTABLE+24
PUBLREQS EQU   CNTABLE+20
PVTNREQS EQU   CNTABLE+16
SPECREQS EQU   CNTABLE+12
TPREQS   EQU   CNTABLE+8
VAMREQS  EQU   CNTABLE+4
DMYREQS  EQU   CNTABLE
JSCBPTR  EQU   ALCWA+12
FMAPPTR  EQU   ALCWA+4
WASIZE   EQU   ALCWA
EDLNOJES EQU   EDLINDIC
EDLVOLAF EQU   EDLINDIC
EDLENQ   EQU   EDLINDIC
EDLDADSM EQU   EDLINDIC
EDLALCD  EQU   EDLINDIC
@NM00029 EQU   EDLENTRY+18
EDLNSCNT EQU   EDLENTRY+16
EDLVAM   EQU   EDLUVFLG
GRPMASK  EQU   GMTENTRY
GMTENTLN EQU   GMTHDR+4
GMTENTNO EQU   GMTHDR
EUCBENLN EQU   EUCBHDR+4
EUCBENNO EQU   EUCBHDR
GRPENTLN EQU   GRPHDR+4
GRPENTNO EQU   GRPHDR
GENENTLN EQU   GENHDR+4
GENENTNO EQU   GENHDR
LUVAGMTP EQU   LUVENTRY+28
@NM00028 EQU   LUVFLAGS
LUVAGMSK EQU   LUVFLAGS
LUVVAM   EQU   LUVFLAGS
UNITNAME EQU   LUVENTRY
LUVENTLN EQU   LUVHDR+4
SIODDSNL EQU   INDMSIOT+173
SIOVDSNL EQU   INDMSIOT+172
SIOVDSNT EQU   INDMSIOT+170
SVOLUNNO EQU   INDMSIOT+168
SIOTVMVP EQU   INDMSIOT+164
SIOTJFX  EQU   INDMSIOT+160
SJFCBPTR EQU   INDMSIOT+156
SIOTETIO EQU   INDMSIOT+148
SIOTATE  EQU   INDMSIOT+144
SVOLUNAD EQU   INDMSIOT+140
SCTANAME EQU   INDMSIOT+122
SIOTSSIC EQU   INDMSIOT+120
@NM00027 EQU   INDMSIOT+108
SIOTSSNM EQU   INDMSIOT+104
SIODDQCR EQU   SIOTBYT2
SIOVDQCR EQU   SIOTBYT2
SIOTCVOL EQU   SIOTBYT2
SIOTCNEW EQU   SIOTBYT2
SIOTCALC EQU   SIOTBYT2
SIOTGALL EQU   SIOTBYT2
SIOTDSPD EQU   SIOTBYT2
SIOTOPUC EQU   INDMSIOT+99
SIOTOUTR EQU   INDMSIOT+97
SIOTOUTC EQU   INDMSIOT+96
SIOTSSWA EQU   INDMSIOT+93
SIOTAUNC EQU   SIOTALTD
SIOTACAT EQU   SIOTALTD
SIOTADEL EQU   SIOTALTD
SIOTAKEP EQU   SIOTALTD
SIOTNPRV EQU   SIOTALTD
SIOJCATS EQU   SIOTALTD
@NM00026 EQU   SIOTALTD
@NM00025 EQU   SIOTALTD
@NM00024 EQU   INDMSIOT+91
SIOTNDSB EQU   INDMSIOT+88
@NM00023 EQU   INDMSIOT+84
SIOTDPCD EQU   INDMSIOT+82
@NM00022 EQU   SIOTBYT4
SIOTRACT EQU   SIOTBYT4
SIOTRACD EQU   SIOTBYT4
SIOTPROT EQU   SIOTBYT4
SCTOUTPN EQU   INDMSIOT+80
SCTOUTNO EQU   INDMSIOT+76
SCTOUTNM EQU   INDMSIOT+68
SIOUCBAD EQU   SCTUTYPE+5
SIOUCNVT EQU   SCTUTYPE+4
SIOUBYT4 EQU   SIOTDEVT+3
@NM00021 EQU   SIOUBYT3
SIO3UREC EQU   SIOUBYT3
SIO3DISP EQU   SIOUBYT3
SIO3DACC EQU   SIOUBYT3
SIO3TAPE EQU   SIOUBYT3
SIOUBYT2 EQU   SIOTDEVT+1
SIOUBYT1 EQU   SIOTDEVT
SIOTOMN  EQU   SCTSBYT4
SIOTIPDI EQU   SCTSBYT4
SIOTVAFF EQU   SCTSBYT4
SIOTSTEP EQU   SCTSBYT4
SIOTASCI EQU   SCTSBYT4
@NM00020 EQU   SCTSBYT4
SIOTGDGA EQU   SCTSBYT4
SCTSGDGS EQU   SCTSBYT4
SCTSOLD  EQU   SCTSBYT3
SCTSMOD  EQU   SCTSBYT3
SCTSNEW  EQU   SCTSBYT3
SCTSYSOU EQU   SCTSBYT3
SCTVREF  EQU   SCTSBYT3
SCTALCHK EQU   SCTSBYT3
SCTSYSNE EQU   SCTSBYT3
SCTDSNRF EQU   SCTSBYT3
SCTRECVD EQU   SCTSBYT2
SCTDEFER EQU   SCTSBYT2
SCTLABEL EQU   SCTSBYT2
SCTUNLBD EQU   SCTSBYT2
SCTJOBLB EQU   SCTSBYT2
SCTVOLAF EQU   SCTSBYT2
SIOTCATL EQU   SCTSBYT2
SIOCLUNL EQU   SCTSBYT2
SIOTJSCT EQU   SCTSBYT1
SCTUNAFF EQU   SCTSBYT1
SCTPARLM EQU   SCTSBYT1
SIOTQDSN EQU   SCTSBYT1
SIOTGDSN EQU   SCTSBYT1
SIOTCCAT EQU   SCTSBYT1
SCTSYSIN EQU   SCTSBYT1
SCTDUMMY EQU   SCTSBYT1
SIOTUNCT EQU   SCTSDISP
SIOTCTLG EQU   SCTSDISP
SIOTDLET EQU   SCTSDISP
SIOTKEEP EQU   SCTSDISP
SIOTPASS EQU   SCTSDISP
SIOTPRIV EQU   SCTSDISP
SIOTRETN EQU   SCTSDISP
SIOTVLCT EQU   INDMSIOT+54
SCTNMBUT EQU   INDMSIOT+53
SIOTRTRY EQU   SIOTBYT0
SIOTPUPV EQU   SIOTBYT0
SIOTNOPV EQU   SIOTBYT0
SIOTGIGN EQU   SIOTBYT0
SPVTAMSG EQU   SIOTBYT0
SIOTDYAL EQU   SIOTBYT0
SIOTSSDS EQU   SIOTBYT0
SIOTGIID EQU   INDMSIOT+50
SCTVOLCT EQU   INDMSIOT+49
SCTSPOOL EQU   INDMSIOT+48
SIOTQNAM EQU   SIOTTSTC
SIOTDSNM EQU   SIOTTSTC
SIOTTRKM EQU   SIOTTSTC
SIOTSSMG EQU   SIOTTSTC
SIOTSSGP EQU   SIOTTSTC
@NM00019 EQU   SIOTTSTC
SIOTTERM EQU   SIOTTSTC
SIOTINFC EQU   SIOTTSTC
@NM00018 EQU   SIOTBYT3
SIOTJES3 EQU   SIOTBYT3
SIOCDEVT EQU   SIOTBYT3
SIOALIAS EQU   SIOTBYT3
SCTDDINO EQU   INDMSIOT+44
SIOTDDNT EQU   SIOTBYT1
SIODADSM EQU   SIOTBYT1
SIOTDADR EQU   SIOTBYT1
SIODUNAL EQU   SIOTBYT1
SIOVAMDS EQU   SIOTBYT1
SIOTHOLD EQU   SIOTBYT1
SIOTOCKP EQU   SIOTBYT1
SIOPSCNT EQU   INDMSIOT+42
SIOTREFN EQU   INDMSIOT+40
SIOTVRSB EQU   INDMSIOT+36
@NM00017 EQU   INDMSIOT+35
SCTPJFCB EQU   INDMSIOT+32
@NM00016 EQU   INDMSIOT+31
SCTPSIOT EQU   INDMSIOT+28
SIOTAFID EQU   INDMSIOT+26
SIOTVLSP EQU   INDMSIOT+24
SIODSNTE EQU   INDMSIOT+22
SIOTUNAF EQU   SCTUSADD
SIOTDEST EQU   INDMSIOT+12
SCTDDNAM EQU   INDMSIOT+4
SIOTTYPE EQU   INDMSIOT+3
SIOTDSKA EQU   INDMSIOT
SURV104  EQU   SUBITS+13
SURV103  EQU   SUBYTE13
SURV102  EQU   SUBYTE13
SURV101  EQU   SUBYTE13
SU100BT  EQU   SUBYTE13
SU99BIT  EQU   SUBYTE13
SU98BIT  EQU   SUBYTE13
SU97BIT  EQU   SUBYTE13
SU96BIT  EQU   SUBYTE13
SU95BIT  EQU   SUBYTE12
SU94BIT  EQU   SUBYTE12
SU93BIT  EQU   SUBYTE12
SU92BIT  EQU   SUBYTE12
SU91BIT  EQU   SUBYTE12
SU90BIT  EQU   SUBYTE12
SU89BIT  EQU   SUBYTE12
SU88BIT  EQU   SUBYTE12
SU87BIT  EQU   SUBYTE11
SU86BIT  EQU   SUBYTE11
SU85BIT  EQU   SUBYTE11
SU84BIT  EQU   SUBYTE11
SU83BIT  EQU   SUBYTE11
SU82BIT  EQU   SUBYTE11
SU81BIT  EQU   SUBYTE11
SU80BIT  EQU   SUBYTE11
SU79BIT  EQU   SUBYTE10
SU78BIT  EQU   SUBYTE10
SU77BIT  EQU   SUBYTE10
SU76BIT  EQU   SUBYTE10
SU75BIT  EQU   SUBYTE10
SU74BIT  EQU   SUBYTE10
SU73BIT  EQU   SUBYTE10
SU72BIT  EQU   SUBYTE10
SU71BIT  EQU   SUBYTE9
SU70BIT  EQU   SUBYTE9
SU69BIT  EQU   SUBYTE9
SU68BIT  EQU   SUBYTE9
SU67BIT  EQU   SUBYTE9
SU66BIT  EQU   SUBYTE9
SU65BIT  EQU   SUBYTE9
SU64BIT  EQU   SUBYTE9
SU63BIT  EQU   SUBYTE8
SU62BIT  EQU   SUBYTE8
SU61BIT  EQU   SUBYTE8
SU60BIT  EQU   SUBYTE8
SU59BIT  EQU   SUBYTE8
SU58BIT  EQU   SUBYTE8
SU57BIT  EQU   SUBYTE8
SU56BIT  EQU   SUBYTE8
SU55BIT  EQU   SUBYTE7
SU54BIT  EQU   SUBYTE7
SU53BIT  EQU   SUBYTE7
SU52BIT  EQU   SUBYTE7
SU51BIT  EQU   SUBYTE7
SU50BIT  EQU   SUBYTE7
SU49BIT  EQU   SUBYTE7
SU48BIT  EQU   SUBYTE7
SU47BIT  EQU   SUBYTE6
SU46BIT  EQU   SUBYTE6
SU45BIT  EQU   SUBYTE6
SU44BIT  EQU   SUBYTE6
SU43BIT  EQU   SUBYTE6
SU42BIT  EQU   SUBYTE6
SU41BIT  EQU   SUBYTE6
SU40BIT  EQU   SUBYTE6
SU39BIT  EQU   SUBYTE5
SU38BIT  EQU   SUBYTE5
SU37BIT  EQU   SUBYTE5
SU36BIT  EQU   SUBYTE5
SU35BIT  EQU   SUBYTE5
SU34BIT  EQU   SUBYTE5
SU33BIT  EQU   SUBYTE5
SU32BIT  EQU   SUBYTE5
SU31BIT  EQU   SUBYTE4
SU30BIT  EQU   SUBYTE4
SU29BIT  EQU   SUBYTE4
SU28BIT  EQU   SUBYTE4
SU27BIT  EQU   SUBYTE4
SU26BIT  EQU   SUBYTE4
SU25BIT  EQU   SUBYTE4
SU23BIT  EQU   SUBYTE3
SU22BIT  EQU   SUBYTE3
SU21BIT  EQU   SUBYTE3
SU20BIT  EQU   SUBYTE3
SU19BIT  EQU   SUBYTE3
SU18BIT  EQU   SUBYTE3
SU17BIT  EQU   SUBYTE3
SU16BIT  EQU   SUBYTE3
SU15BIT  EQU   SUBYTE2
SU14BIT  EQU   SUBYTE2
SU13BIT  EQU   SUBYTE2
SU12BIT  EQU   SUBYTE2
SU11BIT  EQU   SUBYTE2
SU10BIT  EQU   SUBYTE2
SU9BIT   EQU   SUBYTE2
SU8BIT   EQU   SUBYTE2
SU7BIT   EQU   SUBYTE1
SU6BIT   EQU   SUBYTE1
SU5BIT   EQU   SUBYTE1
SU4BIT   EQU   SUBYTE1
SU3BIT   EQU   SUBYTE1
SU2BIT   EQU   SUBYTE1
SU1BIT   EQU   SUBYTE1
SU0BIT   EQU   SUBYTE1
ICBCPUID EQU   ICB2SSCB+496
ICBLORD  EQU   ICBTRACE+256
ICBOTRC  EQU   ICBTRACE
ICBFAB   EQU   ICB2SSCB+108
ICBMSSC  EQU   ICB2SSCB+104
ICBRSVP  EQU   ICB2SSCB+100
ICBAEAP  EQU   ICB2SSCB+96
ICBSIOBP EQU   ICB2SSCB+92
ICBIATNA EQU   ICB2SSCB+88
ICBIPRGA EQU   ICB2SSCB+84
ICBSRBP  EQU   ICB2SSCB+80
ICBVVICB EQU   ICB2SSCB+76
ICBVVIC  EQU   ICB2SSCB+72
ICBSIOP  EQU   ICB2SSCB+68
ICBMEP   EQU   ICB2SSCB+64
ICBIORCI EQU   ICB2SSCB+60
ICB2ACTP EQU   ICB2SSCB+56
ICBSAMP  EQU   ICBFLG+2
ICBFG2   EQU   ICBFLG+1
@NM00015 EQU   ICBFG1
ICBMSCA  EQU   ICBFG1
ICBMSCMP EQU   ICBFG1
ICBS     EQU   ICBFG1
ICBV     EQU   ICBFG1
ICBR     EQU   ICBFG1
ICBNVT   EQU   ICBOPT
ICBVN02P EQU   ICB2SSCB+44
ICBTCB   EQU   ICB2SSCB+40
ICBQHEAD EQU   ICB2SSCB+36
ICBAUCB  EQU   ICB2SSCB+32
ICBPUCB  EQU   ICB2SSCB+28
ICBCOMQ  EQU   ICB2SSCB+24
ICBIOR   EQU   ICB2SSCB+20
ICBCOM   EQU   ICB2SSCB+16
ICBACTV  EQU   ICB2SSCB+12
ICBECB   EQU   ICB2SSCB+8
ICBSSNAM EQU   ICB2SSCB
CVTLEVL  EQU   CVTRELNO+2
CVTNUMB  EQU   CVTRELNO
CVTMDL   EQU   CVTFIX+250
@NM00014 EQU   CVTFIX+248
@NM00013 EQU   CVTFIX
CVTRV482 EQU   CVTXTNT2+128
CVTRV481 EQU   CVTXTNT2+124
CVTRV480 EQU   CVTXTNT2+120
CVTRV479 EQU   CVTXTNT2+118
CVTRV478 EQU   CVTXTNT2+117
CVTRV477 EQU   CVTXTNT2+116
CVTRV476 EQU   CVTXTNT2+115
CVTRV475 EQU   CVTXTNT2+114
CVTRV474 EQU   CVTRV466
CVTRV473 EQU   CVTRV466
CVTRV472 EQU   CVTRV466
CVTRV471 EQU   CVTRV466
CVTRV470 EQU   CVTRV466
CVTRV469 EQU   CVTRV466
CVTRV468 EQU   CVTRV466
CVTRV467 EQU   CVTRV466
CVTRV465 EQU   CVTRV457
CVTRV464 EQU   CVTRV457
CVTRV463 EQU   CVTRV457
CVTRV462 EQU   CVTRV457
CVTRV461 EQU   CVTRV457
CVTRV460 EQU   CVTRV457
CVTRV459 EQU   CVTRV457
CVTRV458 EQU   CVTRV457
CVTRV456 EQU   CVTXTNT2+108
CVTRV455 EQU   CVTXTNT2+104
CVTRV454 EQU   CVTXTNT2+100
CVTRV453 EQU   CVTXTNT2+96
CVTRV452 EQU   CVTXTNT2+94
CVTRV451 EQU   CVTXTNT2+92
CVTRV450 EQU   CVTXTNT2+90
CVTRV449 EQU   CVTXTNT2+88
CVTRV448 EQU   CVTXTNT2+87
CVTRV447 EQU   CVTXTNT2+86
CVTRV446 EQU   CVTRV438
CVTRV445 EQU   CVTRV438
CVTRV444 EQU   CVTRV438
CVTRV443 EQU   CVTRV438
CVTRV442 EQU   CVTRV438
CVTRV441 EQU   CVTRV438
CVTRV440 EQU   CVTRV438
CVTRV439 EQU   CVTRV438
CVTRV437 EQU   CVTRV429
CVTRV436 EQU   CVTRV429
CVTRV435 EQU   CVTRV429
CVTRV434 EQU   CVTRV429
CVTRV433 EQU   CVTRV429
CVTRV432 EQU   CVTRV429
CVTRV431 EQU   CVTRV429
CVTRV430 EQU   CVTRV429
CVTRV428 EQU   CVTXTNT2+80
CVTRV427 EQU   CVTXTNT2+76
CVTRV426 EQU   CVTXTNT2+72
CVTRV425 EQU   CVTXTNT2+68
CVTATACT EQU   CVTATCVT
CVTRV423 EQU   CVTXTNT2+62
CVTRV422 EQU   CVTXTNT2+60
CVTRV421 EQU   CVTXTNT2+58
CVTRV420 EQU   CVTXTNT2+56
CVTRV419 EQU   CVTXTNT2+55
CVTRV418 EQU   CVTXTNT2+54
CVTRV417 EQU   CVTRV409
CVTRV416 EQU   CVTRV409
CVTRV415 EQU   CVTRV409
CVTRV414 EQU   CVTRV409
CVTRV413 EQU   CVTRV409
CVTRV412 EQU   CVTRV409
CVTRV411 EQU   CVTRV409
CVTRV410 EQU   CVTRV409
CVTRV408 EQU   CVTRV400
CVTRV407 EQU   CVTRV400
CVTRV406 EQU   CVTRV400
CVTRV405 EQU   CVTRV400
CVTRV404 EQU   CVTRV400
CVTRV403 EQU   CVTRV400
CVTRV402 EQU   CVTRV400
CVTRV401 EQU   CVTRV400
CVTSKTA  EQU   CVTXTNT2+44
CVTRSV99 EQU   CVTXTNT2+40
CVTRSV98 EQU   CVTXTNT2+36
CVTRSV97 EQU   CVTXTNT2+34
CVTRSV96 EQU   CVTXTNT2+32
CVTOLTEP EQU   CVTXTNT2+28
CVTQIDA  EQU   CVTQID+1
CVTRSV95 EQU   CVTQID
CVTRSV94 EQU   CVTXTNT2+20
CVTRSV93 EQU   CVTXTNT2+16
CVTRSV92 EQU   CVTXTNT2+12
CVTDEBVR EQU   CVTXTNT2+8
CVTRSV91 EQU   CVTXTNT2+6
CVTRSV9H EQU   CVTFLGBT
CVTRSV9G EQU   CVTFLGBT
CVTRSV9F EQU   CVTFLGBT
CVTRSV9E EQU   CVTFLGBT
CVTRSV9D EQU   CVTFLGBT
CVTRSV9C EQU   CVTFLGBT
CVTVME   EQU   CVTFLGBT
CVTNPE   EQU   CVTFLGBT
CVTNUCLS EQU   CVTXTNT2+4
CVTDSSVA EQU   CVTDSSV+1
CVTRSV89 EQU   CVTDSSV
CVTRSV88 EQU   CVTXTNT1+8
CVTRSV87 EQU   CVTXTNT1+4
CVTFACHN EQU   CVTXTNT1
CVTRV488 EQU   CVTMAP+412
CVTRV487 EQU   CVTMAP+408
CVTRV486 EQU   CVTMAP+404
CVTRV485 EQU   CVTMAP+400
CVTACTAP EQU   CVTMAP+396
CVTAUTH  EQU   CVTMAP+392
CVTATMCA EQU   CVTATMCT+1
CVTATMST EQU   CVTATMCT
CVTRSV61 EQU   CVTMAP+384
CVTVOLT1 EQU   CVTVOLM1+1
CVTVOLI1 EQU   CVTVOLF1
CVTSTOA  EQU   CVTMAP+376
CVTRSV58 EQU   CVTMAP+374
CVTRSV57 EQU   CVTMAP+372
CVTDDCE  EQU   CVTMAP+368
CVTPNWFR EQU   CVTMAP+364
CVTSMF   EQU   CVTMAP+360
CVTSULK  EQU   CVTMAP+358
CVTSLKO  EQU   CVTSYSK
CVTSLKP  EQU   CVTSYSK
CVTSLKQ  EQU   CVTSYSK
CVTSLKR  EQU   CVTSYSK
CVTRSV56 EQU   CVTSYSK
CVTRSV55 EQU   CVTSYSK
CVTRSV54 EQU   CVTSYSK
CVTRSV53 EQU   CVTSYSK
CVTRSV52 EQU   CVTA1F1
CVTRSV51 EQU   CVTA1F1
CVTRSV50 EQU   CVTA1F1
CVTRSV49 EQU   CVTA1F1
CVTRSV48 EQU   CVTA1F1
CVTRSV47 EQU   CVTA1F1
CVTSRSW  EQU   CVTA1F1
CVTPFSW  EQU   CVTA1F1
CVTPCVT  EQU   CVTMAP+352
CVTRSV46 EQU   CVTMAP+344
CVTRSV45 EQU   CVTMAP+340
CVTRSV44 EQU   CVTMAP+338
CVTRSV43 EQU   CVTMAP+336
CVTHJESA EQU   CVTHJES+1
CVTRSV42 EQU   CVTHJES
CVTEXT2A EQU   CVTEXT2+1
CVTRSV41 EQU   CVTEXT2
CVTAPFA  EQU   CVTAPF+1
CVTRSV40 EQU   CVTAPF
CVTRV518 EQU   CVTINTLA
CVTRV517 EQU   CVTERPV
CVTEORM  EQU   CVTMAP+312
CVTMCHPR EQU   CVTMAP+308
CVTTZ    EQU   CVTMAP+304
CVTJEPS  EQU   CVTMAP+300
CVTJESCT EQU   CVTMAP+296
CVTMODE  EQU   CVTMAP+292
CVTPTRV  EQU   CVTMAP+288
CVTREAL  EQU   CVTMAP+284
CVTRSV39 EQU   CVTMAP+280
CVTRSV38 EQU   CVTMAP+276
CVTDMSRA EQU   CVTDMSR+1
CVTRV634 EQU   CVTDMSRF
CVTRV633 EQU   CVTDMSRF
CVTRV632 EQU   CVTDMSRF
CVTRV631 EQU   CVTDMSRF
CVTRV630 EQU   CVTDMSRF
CVTRV629 EQU   CVTDMSRF
CVTUDUMP EQU   CVTDMSRF
CVTSDUMP EQU   CVTDMSRF
CVTQMSGA EQU   CVTQMSG+1
CVTRSV36 EQU   CVTQMSG
CVTAMFF  EQU   CVTMAP+264
CVTPURGA EQU   CVTPURG+1
CVTRSV35 EQU   CVTPURG
CVTCBSP  EQU   CVTMAP+256
CVTATERA EQU   CVTATER+1
CVTSYST  EQU   CVTATER
CVTVOLT2 EQU   CVTTAT
CVTVOLI2 EQU   CVTVOLF2
CVTAQAVB EQU   CVTAQAVT+1
CVTRSV34 EQU   CVTTCMFG
CVTRSV33 EQU   CVTTCMFG
CVTRSV32 EQU   CVTTCMFG
CVTRSV31 EQU   CVTTCMFG
CVTRSV30 EQU   CVTTCMFG
CVTRSV29 EQU   CVTTCMFG
CVTLDEV  EQU   CVTTCMFG
CVTTCRDY EQU   CVTTCMFG
CVTGTFA  EQU   CVTGTF+1
CVTRSV27 EQU   CVTGTFST
CVTRNIO  EQU   CVTGTFST
CVTUSR   EQU   CVTGTFST
CVTRV318 EQU   CVTFORM
CVTRV317 EQU   CVTTMODE
CVTRV316 EQU   CVTSTATE
CVTRV315 EQU   CVTGTFS
CVTGTFAV EQU   CVTGTFS
CVT0SCR1 EQU   CVTMAP+232
CVTRV515 EQU   CVTMAP+228
CVTRMS   EQU   CVTMAP+224
CVTPATCH EQU   CVTMAP+220
CVTTSCE  EQU   CVTMAP+216
CVTLNKSC EQU   CVTMAP+214
CVTQABST EQU   CVTMAP+212
CVTMDLDS EQU   CVTMAP+208
CVTUSER  EQU   CVTMAP+204
CVTABEND EQU   CVTMAP+200
CVTSMCA  EQU   CVTMAP+196
CVTRSV18 EQU   CVTMAP+192
CVTQLPAQ EQU   CVTMAP+188
CVTQCDSR EQU   CVTMAP+184
CVTRSV17 EQU   CVTOPTB
CVTRSV16 EQU   CVTOPTB
CVTFP    EQU   CVTOPTB
CVTAPTHR EQU   CVTOPTB
CVTNLOG  EQU   CVTOPTB
CVTTOD   EQU   CVTOPTB
CVTCTIMS EQU   CVTOPTB
CVTPROT  EQU   CVTOPTB
CVTXPFP  EQU   CVTOPTA
CVTASCII EQU   CVTOPTA
CVTRSV13 EQU   CVTOPTA
CVTRSV12 EQU   CVTOPTA
CVTNIP   EQU   CVTOPTA
CVTDDR   EQU   CVTOPTA
CVTAPR   EQU   CVTOPTA
CVTCCH   EQU   CVTOPTA
CVTSNCTR EQU   CVTMAP+180
CVTQOCR  EQU   CVTMAP+172
CVT1EF00 EQU   CVTMAP+168
CVTMZ00  EQU   CVTMAP+164
CVTHEAD  EQU   CVTMAP+160
CVTRSV11 EQU   CVTMAP+156
CVT0PT01 EQU   CVTMAP+152
CVTMSER  EQU   CVTMAP+148
CVTRV516 EQU   CVTIERLC
CVTILCH  EQU   CVTMAP+140
CVT0DS   EQU   CVTMAP+136
CVTFBOSV EQU   CVTMAP+132
CVTNUCB  EQU   CVTMAP+128
CVTIXAVL EQU   CVTMAP+124
CVTIOQET EQU   CVTMAP+120
CVTDCBA  EQU   CVTMAP+117
CVTMVS2  EQU   CVTDCB
CVT6DAT  EQU   CVTDCB
CVT4MPS  EQU   CVTDCB
CVTRSV09 EQU   CVTDCB
CVT4MS1  EQU   CVTDCB
CVT2SPS  EQU   CVTDCB
CVT1SSS  EQU   CVTDCB
CVTRSV08 EQU   CVTDCB
CVTSTB   EQU   CVTMAP+112
CVTQTD00 EQU   CVTMAP+108
CVTQTE00 EQU   CVTMAP+104
CVTCUCB  EQU   CVTMAP+100
CVTSJQ   EQU   CVTMAP+96
CVTPBLDL EQU   CVTMAP+92
CVTTPC   EQU   CVTMAP+88
CVTSVDCB EQU   CVTMAP+84
CVTBRET  EQU   CVTMAP+82
CVTEXIT  EQU   CVTMAP+80
CVT0FN00 EQU   CVTMAP+76
CVTDARA  EQU   CVTDAR+1
CVTRSV07 EQU   CVTFLGS1
CVTRSV06 EQU   CVTFLGS1
CVTRSV05 EQU   CVTFLGS1
CVTRSV04 EQU   CVTFLGS1
CVTRSV03 EQU   CVTFLGS1
CVTRSV02 EQU   CVTFLGS1
CVTRSV01 EQU   CVTFLGS1
CVTDMPLK EQU   CVTFLGS1
CVTXITP  EQU   CVTMAP+68
CVTZDTAB EQU   CVTMAP+64
CVTMSLT  EQU   CVTMAP+60
CVTDATE  EQU   CVTMAP+56
CVTBTERM EQU   CVTMAP+52
CVTSYSAD EQU   CVTMAP+48
CVTXTLER EQU   CVTMAP+44
CVTILK2  EQU   CVTMAP+40
CVTILK1  EQU   CVTMAP+36
CVTPRLTV EQU   CVTMAP+32
CVTPCNVT EQU   CVTMAP+28
CVT0VL00 EQU   CVTMAP+24
CVTXAPG  EQU   CVTMAP+20
CVTBUF   EQU   CVTMAP+16
CVTJOB   EQU   CVTMAP+12
CVTLINK  EQU   CVTMAP+8
CVT0EF00 EQU   CVTMAP+4
CVTTCBP  EQU   CVTMAP
CVT      EQU   CVTMAP
UCBERADR EQU   UCBUCS+12
UCBFCBID EQU   UCBUCS+8
UCBERCNT EQU   UCBUCS+7
UCBRSV51 EQU   UCBUCS+6
UCBRSV50 EQU   UCBFCBOP
UCBRSV49 EQU   UCBFCBOP
UCBRSV48 EQU   UCBFCBOP
UCBRSV47 EQU   UCBFCBOP
UCBRSV46 EQU   UCBFCBOP
UCBRSV45 EQU   UCBFCBOP
UCBRSV44 EQU   UCBFCBOP
UCBFCBO1 EQU   UCBFCBOP
UCBUCSPE EQU   UCBUCSOP
UCBRSV43 EQU   UCBUCSOP
UCBRSV42 EQU   UCBUCSOP
UCBRSV41 EQU   UCBUCSOP
UCBRSV40 EQU   UCBUCSOP
UCBRSV39 EQU   UCBUCSOP
UCBUCSO2 EQU   UCBUCSOP
UCBUCSO1 EQU   UCBUCSOP
UCBUCSID EQU   UCBUCS
UCBMDRBA EQU   UCBMDRBF+1
UCBRV075 EQU   UCBMDRBF
UCBRV074 EQU   UCB3800X+32
UCBIMAGE EQU   UCB3800X+28
UCBFCBNM EQU   UCB3800X+24
UCBCHAR4 EQU   UCB3800X+20
UCBCHAR3 EQU   UCB3800X+16
UCBCHAR2 EQU   UCB3800X+12
UCBCHAR1 EQU   UCB3800X+8
UCBCGMID EQU   UCB3800X+4
UCBBRSTA EQU   UCBACTIV
UCBRV063 EQU   UCBACTIV
UCBRV062 EQU   UCBACTIV
UCBRV061 EQU   UCBACTIV
UCBRV060 EQU   UCBACTIV
UCBRV059 EQU   UCBACTIV
UCBRV058 EQU   UCBACTIV
UCBRV057 EQU   UCBACTIV
UCBRV050 EQU   UCB3800X+2
UCBCGMNO EQU   UCB3800X+1
UCBRV083 EQU   UCBOPTNS
UCBBRSTR EQU   UCBOPTNS
UCBRV056 EQU   UCBOPTNS
UCBRV055 EQU   UCBOPTNS
UCBRV054 EQU   UCBOPTNS
UCBRV053 EQU   UCBOPTNS
UCBRV052 EQU   UCBOPTNS
UCBRV051 EQU   UCBOPTNS
UCBRV073 EQU   UCB3540X+7
UCBRV072 EQU   UCBDKBYT
UCBRV071 EQU   UCBDKBYT
UCBRV070 EQU   UCBDKBYT
UCBRV069 EQU   UCBDKBYT
UCBRV068 EQU   UCBDKBYT
UCBRV067 EQU   UCBDKBYT
UCBVLVER EQU   UCBDKBYT
UCBDKAMX EQU   UCBDKBYT
UCBVLSER EQU   UCB3540X
UCBRDATA EQU   UCBOCR+4
UCBFRID  EQU   UCBOCR
UCBCLN   EQU   UCBMT+14
UCBERG   EQU   UCBMT+12
UCBMS    EQU   UCBMT+11
UCBNB    EQU   UCBMT+10
UCBPW    EQU   UCBMT+9
UCBPR    EQU   UCBMT+8
UCBSIO   EQU   UCBMT+6
UCBTW    EQU   UCBMT+5
UCBTR    EQU   UCBMT+4
UCBTWT   EQU   UCBMT+3
UCBTRT   EQU   UCBMT+2
UCBCTD   EQU   UCBMT
UCBWTOID EQU   UCBCMEXT+17
UCBMIHTI EQU   UCBCMEXT+16
UCBASID  EQU   UCBCMEXT+14
UCBMFCNT EQU   UCBCMEXT+12
UCBPMSK  EQU   UCBCMEXT+10
UCBCCWOF EQU   UCBCMEXT+8
UCBRV041 EQU   UCBCMEXT+6
UCBRV036 EQU   UCBFLP1
UCBRV035 EQU   UCBFLP1
UCBERLOG EQU   UCBFLP1
UCBRV033 EQU   UCBFLP1
UCBRV032 EQU   UCBFLP1
UCBRV031 EQU   UCBFLP1
UCBSHRUP EQU   UCBFLP1
UCBNSRCH EQU   UCBFLP1
UCBSNSCT EQU   UCBCMEXT+4
UCBHPDV  EQU   @NM00012
UCBHALI  EQU   @NM00012
UCBRSV09 EQU   @NM00012
UCBRSV08 EQU   @NM00012
UCBRSV07 EQU   @NM00012
UCBRSV06 EQU   @NM00012
UCBRSV05 EQU   @NM00012
UCBRSV04 EQU   @NM00012
UCBDTI   EQU   UCBCMEXT+2
UCBSTI   EQU   UCBCMEXT+1
UCBETI   EQU   UCBCMEXT
UCBEXTP  EQU   UCBEXTPT+1
UCBDDRSW EQU   UCBFLC
UCBTICBT EQU   UCBFLC
UCBIVRR  EQU   UCBFLC
UCBIVRS  EQU   UCBFLC
UCBITF   EQU   UCBFLC
UCBUDE   EQU   UCBFLC
UCBWAA   EQU   UCBFLC
UCBATTP  EQU   UCBFLC
UCBRSV11 EQU   UCBDVCLS
UCBRSV10 EQU   UCBDVCLS
UCB3CHAR EQU   UCBDVCLS
UCBDVPWR EQU   UCB2OPT7
UCBVLPWR EQU   UCB2OPT6
UCB2OPT5 EQU   UCBTBYT2
UCBRPS   EQU   UCBDUDN2
UCBRR    EQU   UCBDUDN1
UCB2OPT1 EQU   UCBTBYT2
UCB2OPT0 EQU   UCBTBYT2
UCB1FEA7 EQU   UCBTBYT1
UCBD6250 EQU   UCB1FEA6
UCBD1600 EQU   UCB1FEA5
UCB1FEA4 EQU   UCBTBYT1
UCB1FEA3 EQU   UCBTBYT1
UCB1FEA2 EQU   UCBTBYT1
UCB1FEA1 EQU   UCBTBYT1
UCB1FEA0 EQU   UCBTBYT1
UCBNAME  EQU   UCBOB+13
UCBRV029 EQU   UCBWGT
UCBVHRSN EQU   UCBWGT
UCBVORSN EQU   UCBWGT
UCBMTPXP EQU   UCBWGT
UCBREW   EQU   UCBWGT
UCBPUB   EQU   UCBWGT
UCBOUT   EQU   UCBWGT
UCBIN    EQU   UCBWGT
UCBCPU   EQU   UCBOB+11
UCBLCI   EQU   UCBOB+10
UCBCNT   EQU   UCBOB+9
UCBRV017 EQU   UCBCHM1
UCBRV016 EQU   UCBCHM1
UCBRV015 EQU   UCBCHM1
UCBRV014 EQU   UCBCHM1
UCBSPB   EQU   UCBPTH1
UCBPPB   EQU   UCBPTH1
UCBSPA   EQU   UCBPTH0
UCBPPA   EQU   UCBPTH0
UCBSIGP  EQU   UCBFLB
UCBVALPH EQU   UCBFLB
UCBCRHSN EQU   UCBFLB
UCBCRHRV EQU   UCBFLB
UCBRESVH EQU   UCBFLB
UCBSPST  EQU   UCBFLB
UCBASNS  EQU   UCBFLB
UCBIORST EQU   UCBFLB
UCBQISCE EQU   UCBFL1
UCBACTV  EQU   UCBFL1
UCBSAP   EQU   UCBFL1
UCBNOTRC EQU   UCBCUB
UCBPSNS  EQU   UCBFL1
UCBUSING EQU   UCBPST
UCBNOTRD EQU   UCBNRY
UCBBUSYD EQU   UCBBSY
UCBUA    EQU   UCBCHAN+1
UCBCHA   EQU   UCBCHAN
UCBDADI  EQU   UCBSTAT
UCBSYSR  EQU   UCBSTAT
UCBPRES  EQU   UCBSTAT
UCBALOC  EQU   UCBSTAT
UCBUNLD  EQU   UCBSTAT
UCBRESV  EQU   UCBSTAT
UCBCHGS  EQU   UCBSTAT
UCBONLI  EQU   UCBSTAT
UCBID    EQU   UCBOB+2
UCBALTPH EQU   UCBFL5
UCBALTCU EQU   UCBFL5
UCBNALOC EQU   UCBFL5
UCBENVRD EQU   UCBFL5
UCBVSDR  EQU   UCBFL5
UCBSASK  EQU   UCBFL5
UCBAMV   EQU   UCBAF
UCBDCC   EQU   UCBFL5
UCBMONT  EQU   UCBJBNR
UCBRV011 EQU   UCBJBNR
UCBMMSGP EQU   UCBJBNR
UCBOLDSM EQU   UCBJBNR
UCBRV003 EQU   UCBJBNR
UCBDUC   EQU   UCBJBNR
UCBJES3  EQU   UCBJBNR
UCBVRDEV EQU   UCBJBNR
UCBCMSEG EQU   UCBOB
UCBPFXND EQU   UCB+512
UCBIOQ   EQU   UCB+508
UCBLOCK  EQU   UCB+504
UCBPXST  EQU   UCB+504
@NM00009 EQU   UCB
@NM00007 EQU   @NM00005
@NM00006 EQU   @NM00005
@NM00004 EQU   @NM00002
@NM00003 EQU   @NM00002
@NM00001 EQU   DEVTYPE
.@UNREFD ANOP                          END UNREFERENCED COMPONENTS
@RC00068 EQU   @RC00067
@RC00088 EQU   @RC00079
@RF00256 EQU   @RC00253
@RF00247 EQU   @RC00234
@RC00127 EQU   @RC00088
@RF00187 EQU   @RC00127
@RC00190 EQU   @RC00127
@ENDDATA EQU   *
         END   IEFAB424,(C'PLS2116',0701,76334)
