         TITLE 'IEFAB430 - FIXED DEVICE CONTROL                        *
                        '
IEFAB430 CSECT ,                                                01S0001
@MAINENT DS    0H                                               01S0001
         USING *,@15                                            01S0001
         B     @PROLOG                                          01S0001
         DC    AL1(24)                                          01S0001
         DC    C'IEFAB430 78089  UZ17788 '                      01S0001
         DROP  @15
@PROLOG  STM   @14,@12,12(@13)                                  01S0001
         BALR  @12,0                                            01S0001
@PSTART  DS    0H                                               01S0001
         USING @PSTART,@12                                      01S0001
         L     @00,@SIZDATD                                     01S0001
         GSPACE   R,LV=(0)
         LR    @11,@01                                          01S0001
         USING @DATD,@11                                        01S0001
         ST    @13,@SA00001+4                                   01S0001
         LM    @00,@01,20(@13)                                  01S0001
         ST    @11,8(,@13)                                      01S0001
         LR    @13,@11                                          01S0001
         MVC   @PC00001(4),0(@01)                               01S0001
*ALCWAPTR = PARMPTR;                   /*SET POINTER TO ALCWA        */
         L     @10,@PC00001                                     01S0054
         L     @10,PARMPTR(,@10)                                01S0054
         ST    @10,ALCWAPTR                                     01S0054
*PSPRMPTR = ADDR(PSCPARM);             /*SET PTR TO CALLED RTN PARAM */
         LA    @07,PSCPARM                                      01S0055
         ST    @07,PSPRMPTR                                     01S0055
*PSSWTCHS = PSSWTCHS && PSSWTCHS;      /*SET SWITCHES OFF            */
         XC    PSSWTCHS(1),PSSWTCHS                             01S0056
*ERRCODE2 = ZERO;                      /*INIT RETURN CODE TO ZERO    */
         SLR   ERRCODE2,ERRCODE2                                01S0057
*PERMRES = ON;                         /*INDICATES PROCESSING IS TO
*                                        BE DONE FOR PERMRES OR RESVD
*                                        VOLUMES                     */
         OI    PERMRES,B'00010000'                              01S0058
*IF SPECREQS ^= ZERO & ERRCODE2 = ZERO THEN /* PROCESS SPECIFIC 01S0059
*                                        REQUESTS IF ANY             */
         SLR   @07,@07                                          01S0059
         C     @07,SPECREQS(,@10)                               01S0059
         BE    @RF00059                                         01S0059
         CR    ERRCODE2,@07                                     01S0059
         BNE   @RF00059                                         01S0059
*  DO;                                                          01S0060
*    CALL IEFAB433(ALCWAPTR,PSPRMPTR); /*CALL IEFAB433               */
         LA    @10,ALCWAPTR                                     01S0061
         ST    @10,@AL00001                                     01S0061
         LA    @10,PSPRMPTR                                     01S0061
         ST    @10,@AL00001+4                                   01S0061
         L     @15,@CV00076                                     01S0061
         LA    @01,@AL00001                                     01S0061
         BALR  @14,@15                                          01S0061
*    ERRCODE2 = REG15;                 /*SAVE RETURN CODE            */
         LR    ERRCODE2,REG15                                   01S0062
*  END;                                                         01S0063
*ELSE;                                 /*DONT PROCESS SPECIFICS      */
@RF00059 DS    0H                                               01S0065
*IF ERRCODE2 = ZERO THEN               /*ANY ERRORS?                 */
         LTR   ERRCODE2,ERRCODE2                                01S0065
         BNZ   @RF00065                                         01S0065
*  DO;                                 /*NO, UPDATE COUNT TABLE      */
*/********************************************************************/
*/*                                                                  */
*/* SEGMENT NAME - UPDTCNT                                           */
*/*                                                                  */
*/* DESCRIPTIVE NAME - UPDATE COUNT TABLE                            */
*/*                                                                  */
*/* FUNCTION -                                                       */
*/*   THIS ROUTINE DOES THE FOLLOWING FOR EACH UNALLOCATED VOLUNIT   */
*/*   ENTRY:                                                         */
*/*     1. UPDATES THE TOTAL COUNT FIELD(TOTVOLUN)                   */
*/*     2. DETERMINES THE TYPE OF THIS VOLUNIT ENTRY AND UPDATES A   */
*/*        COUNT FIELD AS FOLLOWS:                                   */
*/*          - TYPE -                     - FIELD UPDATED -          */
*/*          PRIVATE OR SPECIFIC     SPECREQS (COUNT OF NO. SPECIFIC)*/
*/*          PUBLIC                  PUBLREQS (COUNT OF NO. PUBLIC)  */
*/*          STORAGE                 STRGREQS(COUNT OF NO. STORAGE)  */
*/*          PRIVATE/NON-SPECIFIC    PVTNREQS(COUNT OF PRIV/NON-SPEC)*/
*/*                                                                  */
*/*   THIS ROUTINE ALSO DETERMINES THE NUMBER OF PUBLIC/STORAGE UNITS*/
*/*   REMAINING TO BE ALLOCATED PER REQUEST.                         */
*/*                                                                  */
*/* ENTRY -  INLINE SEGMENT OF IEFAB430                              */
*/*   PURPOSE - SEE FUNCTION.                                        */
*/*                                                                  */
*/*   INPUT  -                                                       */
*/*     SIOT1P - POINTER TO FIRST SIOT, IN IEFZB425                  */
*/*     CNTABLE - TABLE OF COUNTS BY REQUEST TYPE, IN IEFZB425       */
*/* EXITS -                                                          */
*/*   CONDITION - COUNT TABLE UPDATED                                */
*/*                                                                  */
*/*   OUTPUT  -                                                      */
*/*     CNTABLE - UPDATED TO REFLECT THE FACT THAT SPECIFIC REQUESTS */
*/*               HAVE BEEN ALLOCATED.                               */
*/*                                                                  */
*/*     SIOPSCNT - IN IEFASIOT, UPDATED COUNT OF THE NUMBER OF PUBLIC*/
*/*                AND STORAGE UNITS TO BE ALLOCATED.                */
*/*                                                                  */
*/*   RETURN CODE - NONE                                             */
*/*                                                                  */
*/********************************************************************/
*COUNTERS = COUNTERS && COUNTERS;      /*CLEAR COUNT ACCUMULATORS    */
         XC    COUNTERS(20),COUNTERS                            02S0067
*SIOTPTR = SIOT1P;                     /*GET POINTER TO FIRST SIOT   */
         L     @10,ALCWAPTR                                     02S0068
         L     SIOTPTR,SIOT1P(,@10)                             02S0068
*DO I = 1 TO NUMREQS;                  /*LOOP THRU ALL REQUESTS      */
         LA    I,1                                              02S0069
         B     @DE00069                                         02S0069
@DL00069 DS    0H                                               02S0070
*  VUPTR = SVOLUNAD;                   /*PT TO FIRST ENTRY OF REQ    */
         L     VUPTR,SVOLUNAD(,SIOTPTR)                         02S0070
*  IF SIOTALCD = OFF THEN              /*IF SIOT IS NOT ALLOC'D 02S0071
*                                        PROCESS ITS VOLUNIT ENTRYS  */
         TM    SIOTALCD(SIOTPTR),B'00000010'                    02S0071
         BNZ   @RF00071                                         02S0071
*    DO VUCTR = ONE TO SVOLUNNO;       /*LOOP THRU ALL VOLUNIT ENTRYS*/
         LA    VUCTR,1                                          02S0072
         B     @DE00072                                         02S0072
@DL00072 DS    0H                                               02S0073
*      IF VOLALOC = OFF & VDEVREQD = ON THEN/*IF ANY NOT ALLOC'D
*                                        AND A UNIT IS REQUIRED      */
         TM    VDEVREQD(VUPTR),B'00100000'                      02S0073
         BNO   @RF00073                                         02S0073
         TM    VOLALOC(VUPTR),B'10000000'                       02S0073
         BNZ   @RF00073                                         02S0073
*        DO;                                                    02S0074
*          TOTLCNT = TOTLCNT+ONE;      /*INCREMENT TOTAL COUNT OF
*                                        UNITS LEFT TO BE ALLOC'D FOR
*                                        THIS STEP                   */
         LA    @10,1                                            02S0075
         L     @07,TOTLCNT                                      02S0075
         ALR   @07,@10                                          02S0075
         ST    @07,TOTLCNT                                      02S0075
*          IF VOLSPEC = ON THEN        /*IS THIS A SPECIFIC REQ      */
         TM    VOLSPEC(VUPTR),B'00100000'                       02S0076
         BNO   @RF00076                                         02S0076
*            DO;                                                02S0077
*              SPECCNT  = SPECCNT+ONE; /*UPDATE NUMBER OF UNITS 02S0078
*                                          STILL TO BE ALLOCATED TO
*                                          SPECIFICS FOR THIS STEP   */
         AL    @10,SPECCNT                                      02S0078
         ST    @10,SPECCNT                                      02S0078
*            END;                                               02S0079
*          ELSE                        /*NOT SPECIFIC                */
*            DO;                                                02S0080
         B     @RC00076                                         02S0080
@RF00076 DS    0H                                               02S0081
*              IF VOLPUB = ON THEN     /*IS THIS A PUBLIC VOL REQEST */
         TM    VOLPUB(VUPTR),B'10000000'                        02S0081
         BNO   @RF00081                                         02S0081
*                DO;                                            02S0082
*                  PUBLCNT  = PUBLCNT+ONE; /*UPDATE NO. PUBLICS      */
         LA    @10,1                                            02S0083
         L     @07,PUBLCNT                                      02S0083
         ALR   @07,@10                                          02S0083
         ST    @07,PUBLCNT                                      02S0083
*                  IF VOLNSHR = OFF THEN /*IF VOLUME IS SHAREABLE
*                                        INCREMENT COUNT OF     02S0084
*                                        PUBLIC AND STORAGE     02S0084
*                                        DEVICES NEEDED              */
         TM    VOLNSHR(VUPTR),B'00001000'                       02S0084
         BNZ   @RF00084                                         02S0084
*                    SIOPSCNT = SIOPSCNT + ONE;                 02S0085
         SLR   @07,@07                                          02S0085
         IC    @07,SIOPSCNT(,SIOTPTR)                           02S0085
         ALR   @10,@07                                          02S0085
         STC   @10,SIOPSCNT(,SIOTPTR)                           02S0085
*                END;                                           02S0086
*              ELSE                    /*NOT PUBLIC                  */
*                DO;                                            02S0087
         B     @RC00081                                         02S0087
@RF00081 DS    0H                                               02S0088
*                  IF VOLSTG = ON THEN /*IS THIS STORAGE             */
         TM    VOLSTG(VUPTR),B'00010000'                        02S0088
         BNO   @RF00088                                         02S0088
*                    DO;                                        02S0089
*                      STRGCNT = STRGCNT+ONE; /*UPDATE NO. STORAGE
*                                        DEVICES REQUIRED            */
         LA    @10,1                                            02S0090
         L     @07,STRGCNT                                      02S0090
         ALR   @07,@10                                          02S0090
         ST    @07,STRGCNT                                      02S0090
*                      IF VOLNSHR = OFF THEN /*IF VOL SHAREABLE      */
         TM    VOLNSHR(VUPTR),B'00001000'                       02S0091
         BNZ   @RF00091                                         02S0091
*                        SIOPSCNT = SIOPSCNT + ONE; /*INCREMENT 02S0092
*                                        COUNT OF PUBLIC AND STORAGE
*                                        DEVICES NEEDED              */
         SLR   @07,@07                                          02S0092
         IC    @07,SIOPSCNT(,SIOTPTR)                           02S0092
         ALR   @10,@07                                          02S0092
         STC   @10,SIOPSCNT(,SIOTPTR)                           02S0092
*                    END;                                       02S0093
*                  ELSE                /*NOT STORAGE                 */
*                    DO;                                        02S0094
         B     @RC00088                                         02S0094
@RF00088 DS    0H                                               02S0095
*                      IF VOLPRV= ON & VOLSPEC = OFF THEN /*IF VOL
*                                        IS PRIVATE NON-SPECIFIC     */
         TM    VOLPRV(VUPTR),B'01000000'                        02S0095
         BNO   @RF00095                                         02S0095
         TM    VOLSPEC(VUPTR),B'00100000'                       02S0095
         BNZ   @RF00095                                         02S0095
*                        PNSPCNT = PNSPCNT +ONE; /*INCREMENT COUNT
*                                        OF UNIT STILL TO BE ALLOC-
*                                        ATED FOR THIS STEP          */
         LA    @10,1                                            02S0096
         AL    @10,PNSPCNT                                      02S0096
         ST    @10,PNSPCNT                                      02S0096
*                      ELSE;           /*NOT PRIVATE                 */
@RF00095 DS    0H                                               02S0098
*                    END;                                       02S0098
*                END;                                           02S0099
*            END;                                               02S0100
*        END;                                                   02S0101
*      ELSE;                           /*THIS ENTRY WAS ALLOC'D      */
@RF00073 DS    0H                                               02S0103
*      VUPTR = VUPTR + VULENGTH;       /*UPDATE TO NEXT ENTRY        */
@RC00073 AL    VUPTR,VULENGTH                                   02S0103
*    END;                                                       02S0104
         AH    VUCTR,@CH00052                                   02S0104
@DE00072 CH    VUCTR,SVOLUNNO(,SIOTPTR)                         02S0104
         BNH   @DL00072                                         02S0104
*  ELSE;                               /*REQ WAS COMPLETELY ALLOC'D  */
@RF00071 DS    0H                                               02S0106
*  SIOTPTR = SIOTNPTR;                 /*PT TO NEXT SIOT             */
         L     SIOTPTR,SIOTNPTR(,SIOTPTR)                       02S0106
*END;                                                           02S0107
         AH    I,@CH00052                                       02S0107
@DE00069 L     @10,ALCWAPTR                                     02S0107
         C     I,NUMREQS(,@10)                                  02S0107
         BNH   @DL00069                                         02S0107
*SPECREQS = SPECCNT;                   /*UPDATE COUNT TABLE OF  02S0108
*                                        DEVICES STILL NEEDED        */
         L     @10,ALCWAPTR                                     02S0108
         MVC   SPECREQS(4,@10),SPECCNT                          02S0108
*PUBLREQS = PUBLCNT;                   /* NO. OF PUBLIC              */
         MVC   PUBLREQS(4,@10),PUBLCNT                          02S0109
*STRGREQS = STRGCNT;                   /* NO. OF STORAGE             */
         MVC   STRGREQS(4,@10),STRGCNT                          02S0110
*PVTNREQS = PNSPCNT;                   /* NO. OF PRIVATE/NON-   02S0111
*                                         SPECIFIC                   */
         MVC   PVTNREQS(4,@10),PNSPCNT                          02S0111
*TOTVOLUN = TOTLCNT;                   /*TOTAL UNALLOCATED VU   02S0112
*                                         ENTRIES                    */
         MVC   TOTVOLUN(4,@10),TOTLCNT                          02S0112
*  END;                                                         01S0113
*ELSE;                                 /*NULL                        */
@RF00065 DS    0H                                               01S0115
*IF (PUBLREQS ^= ZERO | STRGREQS ^= ZERO) /*ANY PUBLIC OR STORAGE    */
*     & ERRCODE2 = ZERO THEN           /*REQUESTS AND NO ERRORS YET? */
         SLR   @10,@10                                          01S0115
         L     @07,ALCWAPTR                                     01S0115
         C     @10,PUBLREQS(,@07)                               01S0115
         BNE   @GL00002                                         01S0115
         C     @10,STRGREQS(,@07)                               01S0115
         BE    @RF00115                                         01S0115
@GL00002 LTR   ERRCODE2,ERRCODE2                                01S0115
         BNZ   @RF00115                                         01S0115
*  DO;                                                          01S0116
*/********************************************************************/
*/*                                                                  */
*/* SEGMENT NAME - BLDPRLST                                          */
*/*                                                                  */
*/* DESCRIPTIVE NAME - BUILD PERMRES/RESERVED LIST                   */
*/*                                                                  */
*/* FUNCTION - THE FUNCTION OF THIS ROUTINE IS TO BUILD A LIST OF    */
*/*   HALFWORD POINTERS TO UCBS. THESE UCBS WILL BE THOSE WHICH      */
*/*   REPRESENT DIRECT ACCESS DEVICES WHICH ARE ONLINE, READY, NOT   */
*/*   PENDING OFFLINE NOR PENDING UNLOAD,  NOT                       */
*/*   IN USE BY OLTEP, AND PERMANENTLY RESIDENT OR RESERVED          */
*/*   WITH A VOLUME SERIAL NUMBER IN THE UCB.                @ZA18146*/
*/*   THIS LIST IS THEN USED BY THE ALLOCATION ROUTINES FOR THEIR    */
*/*   DEVICE SELECTION. IF CORE IS NOT AVAILABLE FOR THE LIST A      */
*/*   GETMAIN ERROR INDICATOR WILL BE RETURNED IN REG 15.            */
*/*                                                                  */
*/* ENTRY -  INLINE SEGMENT OF IEFAB430                              */
*/*   PURPOSE - SEE FUNCTION                                         */
*/*                                                                  */
*/*   INPUT  -                                                       */
*/*     ALCWAPTR - POINTER TO ALLOCATION WORK AREA.                  */
*/*     EDTNUCBS - NUMBER OF ENTRIES IN IOS LOOK-UP TABLE.   @Z40FPPD*/
*/*                USED TO DETERMINE MAXIMUM SIZE OF LIST.   @Z40FPPD*/
*/*                                                                  */
*/* EXITS -                                                          */
*/*   CONDITION - PERMRES/RESERVED LIST BUILT                        */
*/*                                                                  */
*/*     OUTPUT-                                                      */
*/*        PRLST - A LIST OF HALFWORD POINTERS TO UCBS WHICH ARE     */
*/*              DIRECT ACCESS,ONLINE,READY,PERMANENTLY RESIDENT OR  */
*/*              RESERVED.                                           */
*/*                                                                  */
*/*        PRLSTLEN - A FULL WORD FIELD IN PSCPARM CONTAINING THE    */
*/*                   LENGTH OF THE PERMRES/RESERVED LIST.           */
*/*                                                                  */
*/*                                                                  */
*/*        PRLSTPTR - A FULL WORD POINTER TO THE PRLIST.             */
*/*                                                                  */
*/*     RETURN CODE -                                                */
*/*        ERRCODE2 - 0, INDICATING PRLIST WAS SUCCESSFULLY BUILT.   */
*/*                                                                  */
*/*                                                                  */
*/*   CONDITION - NO CORE AVAILABLE TO BUILD PRLIST.                 */
*/*                                                                  */
*/*     OUTPUT-                                                      */
*/*        FAILCODE - 2, INDICATING GETMAIN FAILURE                  */
*/*                                                                  */
*/*     RETURN CODE -                                                */
*/*        ERRCODE2 - 4,INDICATING GETMAIN FAILURE TRYING TO GET     */
*/*                     CORE TO BUILD PRLIST                         */
*/*                                                                  */
*/*                                                                  */
*/*                                                                  */
*/********************************************************************/
*RFY IOSLUT BASED(IOSLUTP);                                     02S0117
*SLOTNO = ONE;                         /*INIT PRLST SLOT POINTER     */
         LA    SLOTNO,1                                         02S0118
*PRLSTLEN =  (ALCNUCBS * TWO) + TWO;   /*CALC MAX LENGTH OF LIST PLUS
*                                        LIST END INDICATOR  @Z40FPPJ*/
         L     @08,ALCWAPTR                                     02S0119
         L     @08,ALCNUCBS(,@08)                               02S0119
         ALR   @08,@08                                          02S0119
         AH    @08,@CH00091                                     02S0119
         ST    @08,PRLSTLEN                                     02S0119
* /* ?GETSTORG (SPID,PRLSTLEN,PRLSTPTR);*/                      02S0120
*   /* DEFINITIONS OF GETMAIN PARMS */                          02S0120
*   DCL                                                         02S0120
*     GTSTR0   FIXED(31) REG(0),/*GTMN PARM REG*/               02S0120
*     GTSTR1   FIXED(31) REG(1),/*GTMN PARM REG*/               02S0120
*     GTSTR2   PTR(31)   REG(2),/*GTMN PARM REG*/               02S0120
*     GTSTR15  FIXED(31) REG(15),/*GTMN RET COD*/               02S0120
*     GTSTRTCD FIXED(31); /* GETMAIN RTN CODE  */               02S0120
*   DCL                                                         02S0121
*     GTSTR3   FIXED(31) REG(3),/* CLEARING REG*/               02S0121
*     GTSTR4   FIXED(31) REG(4),/* CLEARING REG*/               02S0121
*     GTSTR5   FIXED(31) REG(5),/* CLEARING REG*/               02S0121
*     GTSTR6   FIXED(31) REG(6),/* CLEARING REG*/               02S0121
*     GTSTR7   FIXED(31) REG(7),/* CLEARING REG*/               02S0121
*     GTSTR8   FIXED(31) REG(8),/* CLEARING REG*/               02S0121
*     GTSTZERO FIXED(31) INIT(0),                               02S0121
*     GTST253  FIXED(31) CONSTANT(253);                         02S0121
*   RFY (GTSTR0,GTSTR1,GTSTR2) RSTD; /*SAVE RGS*/               02S0122
*   GTSTR0 = PRLSTLEN; /* SET AMOUNT*/                          02S0123
         LR    GTSTR0,@08                                       02S0123
*   GTSTR2 = SPID; /* SET SUBPOOL*/                             02S0124
         LA    GTSTR2,230                                       02S0124
*   GENERATE CODE;                                              02S0125
     GETMAIN RC,LV=(0),SP=(2)  DO GETMAIN
*   GTSTRTCD = GTSTR15; /* SAVE GETMAIN RET COD*/               02S0126
         LR    GTSTRTCD,GTSTR15                                 02S0126
*   PRLSTPTR = GTSTR1; /* ADDR OF GOTN STORG*/                  02S0127
         ST    GTSTR1,PRLSTPTR                                  02S0127
*   RFY (GTSTR0,GTSTR1,GTSTR2) UNRSTD; /*RLSE */                02S0128
*   IF GTSTRTCD = 0 THEN /*GETMAIN SUCCESSFUL? */               02S0129
         LTR   GTSTRTCD,GTSTRTCD                                02S0129
         BNZ   @RF00129                                         02S0129
*     DO;               /* YES, CLEAR STORAGE.*/                02S0130
*       RFY (GTSTR2,GTSTR4,GTSTR5,GTSTR6,                       02S0131
*                          GTSTR7,GTSTR8) RSTD;                 02S0131
*       GTSTR4 = PRLSTPTR; /*STORG PTR*/                        02S0132
         L     @03,PRLSTPTR                                     02S0132
         LR    GTSTR4,@03                                       02S0132
*       GTSTR5 = PRLSTLEN; /*STORG AMNT*/                       02S0133
         L     GTSTR5,PRLSTLEN                                  02S0133
*       GTSTR7 = '00000000'X; /*PAD CHAR & LNTH*/               02S0134
         SLR   GTSTR7,GTSTR7                                    02S0134
*       IF SPID = GTST253 THEN                                  02S0135
         B     @RF00135                                         02S0135
*      GEN                                                      02S0136
*   (MODESET KEYADDR=GTSTZERO,SAVEKEY=(2),WORKREG=8);           02S0136
         MODESET KEYADDR=GTSTZERO,SAVEKEY=(2),WORKREG=8
*       GEN REFS(GTSTR4,GTSTR6);                                02S0137
@RF00135 DS    0H                                               02S0137
          MVCL  GTSTR4,GTSTR6 CLEAR GOTTEN STORG
*       IF SPID = GTST253 THEN                                  02S0138
         B     @RF00138                                         02S0138
*         GEN (MODESET KEYADDR=(2));                            02S0139
         MODESET KEYADDR=(2)
*       RFY (GTSTR2,GTSTR4,GTSTR5,GTSTR6,                       02S0140
*                          GTSTR7,GTSTR8) UNRSTD;               02S0140
@RF00138 DS    0H                                               02S0141
*     END;       /* STORAGE CLEARING COMPLETED */               02S0141
*   ELSE                                                        02S0142
*   PRLSTPTR= 0;   /* CLEAR RETURN ADDR. */                     02S0142
         B     @RC00129                                         02S0142
@RF00129 SLR   @08,@08                                          02S0142
         ST    @08,PRLSTPTR                                     02S0142
*   GTSTR15 = GTSTRTCD;    /* GTMN RETURN CODE */               02S0143
@RC00129 LR    GTSTR15,GTSTRTCD                                 02S0143
*                                      /* RESTORE LIST PRINT STATUS  */
*   /*GET CORE FOR PRLIST         */                            02S0144
*ERRCODE2 = REG15;                     /*SAVE RETURN CODE            */
         LR    ERRCODE2,REG15                                   02S0144
*IF ERRCODE2 = ZERO THEN               /*IF CORE GOTTEN CONTINUE     */
         LTR   ERRCODE2,ERRCODE2                                02S0145
         BNZ   @RF00145                                         02S0145
*  DO;                                                          02S0146
*    DO LUTENTNO = 1 BY 1 WHILE(IOSLUT(LUTENTNO)^=IOSLTEND);    02S0147
         LA    LUTENTNO,1                                       02S0147
         B     @DE00147                                         02S0147
@DL00147 DS    0H                                               02S0148
*      IF IOSLUT(LUTENTNO)^=NOUCBADR THEN /*NO MATCH IN LOOK UP TBL  */
         LR    @10,LUTENTNO                                     02S0148
         ALR   @10,@10                                          02S0148
         L     @08,ALCWAPTR                                     02S0148
         L     @08,IOSLUTP(,@08)                                02S0148
         ALR   @08,@10                                          02S0148
         BCTR  @08,0                                            02S0148
         BCTR  @08,0                                            02S0148
         SLR   @10,@10                                          02S0148
         ICM   @10,3,IOSLUT(@08)                                02S0148
         LTR   @10,@10                                          02S0148
         BZ    @RF00148                                         02S0148
*        DO;                                                    02S0149
*          UCBPTR = IOSLUT(LUTENTNO);                           02S0150
         LR    UCBPTR,@10                                       02S0150
*          IF UCB3DACC = ON            /*IS DEVICE DIRECT ACCESS     */
*            & UCBCHGS = OFF           /*NOT PENDING OFFLINE         */
*            & UCBUNLD = OFF           /*NOT PENDING UNLOAD          */
*            &UCBNOTRD = OFF           /*IS DEVICE READY             */
*            &UCBONLI  = ON            /*IS DEVICE ONLINE            */
*            &UCBNALOC=OFF             /*DEVICE IN USE BY OLTEP      */
*            &(UCBRESV=ON              /*RESERVED OR         @ZA18146*/
*            |(UCBPRES = ON            /*PERMANENTLY RESIDENT@ZA18146*/
*            & UCBVOLI ^= NOVOLSER)) THEN /*WITH A VOLSER    @ZA18146*/
         TM    UCB3DACC(UCBPTR),B'00100000'                     02S0151
         BNO   @RF00151                                         02S0151
         TM    UCBCHGS(UCBPTR),B'01010000'                      02S0151
         BNZ   @RF00151                                         02S0151
         TM    UCBNOTRD(UCBPTR),B'01000000'                     02S0151
         BNZ   @RF00151                                         02S0151
         TM    UCBONLI(UCBPTR),B'10000000'                      02S0151
         BNO   @RF00151                                         02S0151
         TM    UCBNALOC(UCBPTR),B'00000100'                     02S0151
         BNZ   @RF00151                                         02S0151
         TM    UCBRESV(UCBPTR),B'00100000'                      02S0151
         BO    @RT00151                                         02S0151
         TM    UCBPRES(UCBPTR),B'00000100'                      02S0151
         BNO   @RF00151                                         02S0151
         CLC   UCBVOLI(6,UCBPTR),NOVOLSER                       02S0151
         BE    @RF00151                                         02S0151
@RT00151 DS    0H                                               02S0152
*            DO;                                                02S0152
*              PRLST(SLOTNO) = UCBPTR; /*IF SO MOVE ADDRESS TO PRLIST*/
         LR    @10,SLOTNO                                       02S0153
         ALR   @10,@10                                          02S0153
         L     @08,PRLSTPTR                                     02S0153
         BCTR  @08,0                                            02S0153
         BCTR  @08,0                                            02S0153
         STH   UCBPTR,PRLST(@10,@08)                            02S0153
*              SLOTNO = SLOTNO + ONE;  /*POINT TO NEXT PRLST SLOT    */
         AH    SLOTNO,@CH00052                                  02S0154
*            END;                                               02S0155
*          ELSE;                       /*DEV NOT DIRCT ACCESS        */
@RF00151 DS    0H                                               02S0157
*        END;                                                   02S0157
*      ELSE;                           /*MATCH FOUND                 */
@RF00148 DS    0H                                               02S0159
*    END;                                                       02S0159
         AH    LUTENTNO,@CH00052                                02S0159
@DE00147 LR    @10,LUTENTNO                                     02S0159
         ALR   @10,@10                                          02S0159
         L     @08,ALCWAPTR                                     02S0159
         L     @08,IOSLUTP(,@08)                                02S0159
         ALR   @08,@10                                          02S0159
         BCTR  @08,0                                            02S0159
         BCTR  @08,0                                            02S0159
         CLC   IOSLUT(2,@08),IOSLTEND                           02S0159
         BNE   @DL00147                                         02S0159
*    PRLST(SLOTNO) = ZERO;             /*INDICATE END OF PRLIST      */
         LR    @10,SLOTNO                                       02S0160
         ALR   @10,@10                                          02S0160
         L     @08,PRLSTPTR                                     02S0160
         ALR   @08,@10                                          02S0160
         BCTR  @08,0                                            02S0160
         BCTR  @08,0                                            02S0160
         SLR   @10,@10                                          02S0160
         STH   @10,PRLST(,@08)                                  02S0160
*  END;                                                         02S0161
*ELSE                                  /*NO CORE FOR PRLST           */
*  FAILRSCP -> FAILCODE = NOPRLST;     /*SET NO CORE FOR PRLST       */
         B     @RC00145                                         02S0162
@RF00145 L     @10,ALCWAPTR                                     02S0162
         L     @10,FAILRSCP(,@10)                               02S0162
         MVC   FAILCODE(2,@10),@CH00091                         02S0162
*    IF STRGREQS ^= ZERO & ERRCODE2 = ZERO THEN /*PROCESS STORAGE    */
@RC00145 SLR   @10,@10                                          01S0163
         L     @07,ALCWAPTR                                     01S0163
         C     @10,STRGREQS(,@07)                               01S0163
         BE    @RF00163                                         01S0163
         CR    ERRCODE2,@10                                     01S0163
         BNE   @RF00163                                         01S0163
*      DO;                             /*REQUESTS IF ANY             */
*        STORAGE = ON;                 /*SET TO PROCESS STORAGE      */
         OI    STORAGE,B'01000000'                              01S0165
*        CALL IEFAB436(ALCWAPTR,PRLSTPTR,PSPRMPTR); /*ALLOC STORAGE  */
         LA    @10,ALCWAPTR                                     01S0166
         ST    @10,@AL00001                                     01S0166
         LA    @10,PRLSTPTR                                     01S0166
         ST    @10,@AL00001+4                                   01S0166
         LA    @10,PSPRMPTR                                     01S0166
         ST    @10,@AL00001+8                                   01S0166
         L     @15,@CV00077                                     01S0166
         LA    @01,@AL00001                                     01S0166
         BALR  @14,@15                                          01S0166
*        ERRCODE2 = REG15;             /*SAVE RET CODE               */
         LR    ERRCODE2,REG15                                   01S0167
*        STORAGE = OFF;                /*SET STORAGE  OFF            */
         NI    STORAGE,B'10111111'                              01S0168
*      END;                            /*DONE                        */
*    ELSE;                             /*NO STORAGE REQUESTS         */
@RF00163 DS    0H                                               01S0171
*    IF PUBLREQS ^= ZERO & ERRCODE2 = ZERO THEN /*PROCESS PUBLICS    */
         SLR   @10,@10                                          01S0171
         L     @07,ALCWAPTR                                     01S0171
         C     @10,PUBLREQS(,@07)                               01S0171
         BE    @RF00171                                         01S0171
         CR    ERRCODE2,@10                                     01S0171
         BNE   @RF00171                                         01S0171
*      DO;                                                      01S0172
*        PUBLIC = ON;                  /*SET TO PROCESS PUBLICS      */
         OI    PUBLIC,B'10000000'                               01S0173
*        CALL IEFAB436(ALCWAPTR,PRLSTPTR,PSPRMPTR); /*ALLOC PUBLICS  */
         LA    @10,ALCWAPTR                                     01S0174
         ST    @10,@AL00001                                     01S0174
         LA    @10,PRLSTPTR                                     01S0174
         ST    @10,@AL00001+4                                   01S0174
         LA    @10,PSPRMPTR                                     01S0174
         ST    @10,@AL00001+8                                   01S0174
         L     @15,@CV00077                                     01S0174
         LA    @01,@AL00001                                     01S0174
         BALR  @14,@15                                          01S0174
*        ERRCODE2 = REG15;             /*SAVE RET CODE               */
         LR    ERRCODE2,REG15                                   01S0175
*        PUBLIC = OFF;                 /*SET PUBLICS OFF             */
         NI    PUBLIC,B'01111111'                               01S0176
*      END;                            /*DONE                        */
*    ELSE;                             /*NO PUBLIC REQUESTS          */
@RF00171 DS    0H                                               01S0179
*    IF PUBLREQS^=ZERO & ERRCODE2 =ZERO THEN /*ANY PUBLIC REQUESTS
*                                        NOT YET ALLOCATED           */
         SLR   @10,@10                                          01S0179
         L     @07,ALCWAPTR                                     01S0179
         C     @10,PUBLREQS(,@07)                               01S0179
         BE    @RF00179                                         01S0179
         CR    ERRCODE2,@10                                     01S0179
         BNE   @RF00179                                         01S0179
*      DO;                                                      01S0180
*        PUBSTOR = ON;                 /*SET TO PROCESS PUBLIC REQ'S
*                                        TO PUBLIC & STORAGE VOLUMES */
         OI    PUBSTOR,B'00100000'                              01S0181
*        CALL IEFAB436(ALCWAPTR,PRLSTPTR,PSPRMPTR); /*ALLOCATE PUBLC
*                                       REQUEST TO PUBLIC & STORAGE
*                                       VOLUMES                      */
         LA    @10,ALCWAPTR                                     01S0182
         ST    @10,@AL00001                                     01S0182
         LA    @10,PRLSTPTR                                     01S0182
         ST    @10,@AL00001+4                                   01S0182
         LA    @10,PSPRMPTR                                     01S0182
         ST    @10,@AL00001+8                                   01S0182
         L     @15,@CV00077                                     01S0182
         LA    @01,@AL00001                                     01S0182
         BALR  @14,@15                                          01S0182
*        ERRCODE2 = REG15;             /*SAVE RET  CODE              */
         LR    ERRCODE2,REG15                                   01S0183
*        PUBSTOR = OFF;                                         01S0184
         NI    PUBSTOR,B'11011111'                              01S0184
*      END;                                                     01S0185
*    ELSE;                             /*NO PUBLIC REQS              */
@RF00179 DS    0H                                               01S0187
*    IF PRLSTPTR ^= ZERO THEN          /*ANY PRLST TO FREE ?         */
         L     @10,PRLSTPTR                                     01S0187
         LTR   @10,@10                                          01S0187
         BZ    @RF00187                                         01S0187
*      DO;                             /*YES                         */
*        RFY(REG0,REG1) RSTD;                                   01S0189
*        REG0 = PRLSTLEN;              /*LENGTH OF PERM/RES LIST     */
         L     REG0,PRLSTLEN                                    01S0190
*        REG0 = REG0 | SUBPL230;       /*FREE FROM SUBPOOL 230       */
         O     REG0,@CF00088                                    01S0191
*        REG1 = PRLSTPTR;              /*ADDRESS OF PERM/RES LIST    */
         LR    REG1,@10                                         01S0192
*        GEN (FREEMAIN R,LV=(0),A=(1)); /*FREE PERMRES RESVE LST CORE*/
         FREEMAIN R,LV=(0),A=(1)
*        RFY (REG0,REG1) UNRSTD;                                01S0194
*      END;                                                     01S0195
*  END;                                                         01S0196
*ELSE;                                 /*NO PUB OR STRG REQS         */
@RF00115 DS    0H                                               01S0198
*IF ERRCODE2 = ZERO THEN               /*ANY ERRORS ?                */
@RC00115 LTR   ERRCODE2,ERRCODE2                                01S0198
         BNZ   @RF00198                                         01S0198
*  DO;                                 /*NO,CHECK DEMAND REQS        */
*/********************************************************************/
*/*                                                                  */
*/* SEGMENT NAME - CHEKDMND                                          */
*/*                                                                  */
*/* DESCRIPTIVE NAME - ERROR CHECKER FOR DUPLICATE DEMAND REQUESTS   */
*/*                                                                  */
*/* FUNCTION -                                                       */
*/*     THIS ROUTINE DETERMINES IF THERE IS MORE THAN ONE DEMAND     */
*/*     REQUEST FOR THE SAME UNIT (E.G. TWO DD'S WITH UNIT=190).     */
*/*     IF THERE ARE TWO REQUESTS FOR THE SAME UNIT THE ALLOCATION   */
*/*     IS FAILED UNLESS:                                            */
*/*       (1) THE TWO REQUESTS ARE GOING TO USE THE SAME VOLUME.     */
*/*                                                                  */
*/*        OR                                                        */
*/*                                                                  */
*/*       (2) THE UNIT REQUESTED IS DIRECT ACCESS , AND              */
*/*           BOTH REQUESTS ARE NOT FOR SPECIFIC VOLUMES, AND        */
*/*           NEITHER REQUEST IS PRIVATE OR NONSHAREABLE.            */
*/*                                                          @YA00062*/
*/*       OR                                                 @YA00062*/
*/*                                                          @YA00062*/
*/*       (3) ONE OF THE TWO REQUESTS IS A DD DUMMY.         @YA00062*/
*/*                                                                  */
*/*   OPERATION - THE SIOT CHAIN IS SCANNED TO LOCATE EACH           */
*/*               NON-ALLOCATED DEMAND REQUEST. WHEN A DEMAND        */
*/*               REQ IS FOUND, THE SIOT CHAIN IS RESCANNED TO FIND  */
*/*               OTHER NON-ALLOCATED DEMAND REQS FOR                */
*/*               THE SAME UNIT -- THEN THE ABOVE TESTS ARE MADE.    */
*/* ENTRY - (INLINE SUBROUTINE)                                      */
*/*                                                                  */
*/*   PURPOSE - (SEE FUNCTION)                                       */
*/*                                                                  */
*/*   INPUT -                                                        */
*/*       ALCWAPTR - PTR TO THE ALLOCATION WORK AREA                 */
*/*         SIOT1P - PTR TO THE FIRST SIOT IN THE CHAIN              */
*/*                                                                  */
*/* EXIT - NORMAL - (INLINE SUBROUTINE)                              */
*/*                                                                  */
*/*   CONDITIONS - NO ERRORS DETECTED                                */
*/*                                                                  */
*/*   OUTPUT - (NONE)                                                */
*/*                                                                  */
*/*   RETURN CODES - (SAME AS ON ENTRY)                              */
*/*                                                                  */
*/* EXIT - ERROR - (INLINE SUBROUTINE)                               */
*/*                                                                  */
*/*   CONDITIONS - ERROR DUE TO 2 DEMAND REQS FOR THE SAME UNIT      */
*/*                                                                  */
*/*   OUTPUT - SIOT REASON CODE (SIOTRSNC) SET TO 65                 */
*/*                                                                  */
*/*   RETURN CODES - ERRCODE2 SET TO 4                               */
*/*                                                                  */
*/********************************************************************/
*SIOTPTR = SIOT1P;                     /*POINT TO THE FIRST SIOT     */
         L     @10,ALCWAPTR                                     02S0200
         L     SIOTPTR,SIOT1P(,@10)                             02S0200
*DO WHILE (SIOTPTR^=ZERO & ERRCODE2=ZERO); /*SCAN ALL SIOTS          */
         B     @DE00201                                         02S0201
@DL00201 DS    0H                                               02S0202
*  IF SIOTDMND = ON                    /*DEMAND REQUEST AND          */
*     & SCTDUMMY = OFF THEN            /*NOT DUMMY ?         @YA00062*/
         TM    SIOTDMND(SIOTPTR),B'10000000'                    02S0202
         BNO   @RF00202                                         02S0202
         TM    SCTDUMMY(SIOTPTR),B'10000000'                    02S0202
         BNZ   @RF00202                                         02S0202
*    DO;                               /*YES,LOOK FOR OTHERS         */
*      VUPTR = SVOLUNAD;               /*POINT TO SIOT'S FIRST VU    */
         L     VUPTR,SVOLUNAD(,SIOTPTR)                         02S0204
*      SPTR = SIOT1P;                  /*POINT TO THE FIRST SIOT     */
         L     @10,ALCWAPTR                                     02S0205
         L     SPTR,SIOT1P(,@10)                                02S0205
*      DO WHILE (SPTR^=ZERO & ERRCODE2=ZERO); /*RESCAN ALL SIOTS     */
         B     @DE00206                                         02S0206
@DL00206 DS    0H                                               02S0207
*        IF SPTR->SIOTDMND = ON        /*DEMAND REQUEST              */
*            & SPTR->SCTDUMMY = OFF    /*NOT DUMMY           @YA00062*/
*            & SPTR->SIOUCBAD = SIOUCBAD /*..FOR THE SAME UNIT WITH  */
*            & SPTR->SVOLUNAD->VOLUNTID^=VOLUNTID  /*..NO AFF        */
*            & SIOTALCD=OFF THEN       /*NOT ALLOCATED       @ZA00869*/
         TM    SIOTDMND(SPTR),B'10000000'                       02S0207
         BNO   @RF00207                                         02S0207
         TM    SCTDUMMY(SPTR),B'10000000'                       02S0207
         BNZ   @RF00207                                         02S0207
         CLC   SIOUCBAD(3,SPTR),SIOUCBAD(SIOTPTR)               02S0207
         BNE   @RF00207                                         02S0207
         L     @10,SVOLUNAD(,SPTR)                              02S0207
         CLC   VOLUNTID(2,@10),VOLUNTID(VUPTR)                  02S0207
         BE    @RF00207                                         02S0207
         TM    SIOTALCD(SIOTPTR),B'00000010'                    02S0207
         BNZ   @RF00207                                         02S0207
*          DO;                         /*YES,TEST IF ERROR           */
*            IF SIOUCBAD->UCB3DACC=ON THEN /*DA UNIT REQUESTED ?     */
         ICM   @07,7,SIOUCBAD(SIOTPTR)                          02S0209
         TM    UCB3DACC(@07),B'00100000'                        02S0209
         BNO   @RF00209                                         02S0209
*              DO;                     /*YES,ONLY ERROR IF BOTH SPEC
*                                        VOL REQS OR IF ONE REQ IS
*                                        PRIVATE OR NONSHAREABLE     */
*                IF (SPTR->SVOLUNAD->VOLSPEC=ON & VOLSPEC=ON)   02S0211
*                    | (SPTR->SVOLUNAD->VOLPRV=ON | VOLPRV=ON)  02S0211
*                    | (SPTR->SVOLUNAD->VOLNSHR=ON              02S0211
*                    | VOLNSHR=ON) THEN /*CHECK FOR ERROR COND       */
         TM    VOLSPEC(@10),B'00100000'                         02S0211
         BNO   @GL00020                                         02S0211
         TM    VOLSPEC(VUPTR),B'00100000'                       02S0211
         BO    @RT00211                                         02S0211
@GL00020 L     @10,SVOLUNAD(,SPTR)                              02S0211
         TM    VOLPRV(@10),B'01000000'                          02S0211
         BO    @RT00211                                         02S0211
         TM    VOLPRV(VUPTR),B'01000000'                        02S0211
         BO    @RT00211                                         02S0211
         TM    VOLNSHR(@10),B'00001000'                         02S0211
         BO    @RT00211                                         02S0211
         TM    VOLNSHR(VUPTR),B'00001000'                       02S0211
         BNO   @RF00211                                         02S0211
@RT00211 DS    0H                                               02S0212
*                  DO;                                          02S0212
*                    ERRCODE2 = FAILURE; /*SET ERROR RETURN CODE     */
         LA    ERRCODE2,4                                       02S0213
*                    SIOTRSNC=SAMUNITS;/*SET SIOT REASON CODE        */
         MVC   SIOTRSNC(2,SIOTPTR),@CH00073                     02S0214
*                  END;                                         02S0215
*                ELSE;                 /*NO ERROR                    */
@RF00211 DS    0H                                               02S0217
*              END;                                             02S0217
*            ELSE                      /*NOT A DIRECT ACCESS UNIT    */
*              DO;                                              02S0218
         B     @RC00209                                         02S0218
@RF00209 DS    0H                                               02S0219
*                ERRCODE2 = FAILURE;   /*SET ERROR RETURN CODE       */
         LA    ERRCODE2,4                                       02S0219
*                SIOTRSNC = SAMUNITS;  /*SET SIOT ERROR REASON CODE  */
         MVC   SIOTRSNC(2,SIOTPTR),@CH00073                     02S0220
*              END;                                             02S0221
*          END;                                                 02S0222
*        ELSE;                         /*SAME UNIT NOT DEMANDED      */
@RF00207 DS    0H                                               02S0224
*        SPTR = SPTR->SIOTNPTR;        /*POINT TO THE NEXT SIOT      */
@RC00207 L     SPTR,SIOTNPTR(,SPTR)                             02S0224
*      END;                                                     02S0225
@DE00206 SLR   @10,@10                                          02S0225
         CR    SPTR,@10                                         02S0225
         BE    @DC00206                                         02S0225
         CR    ERRCODE2,@10                                     02S0225
         BE    @DL00206                                         02S0225
@DC00206 DS    0H                                               02S0226
*    END;                                                       02S0226
*  ELSE;                               /*NOT A DEMAND REQUEST        */
@RF00202 DS    0H                                               02S0228
*  SIOTPTR = SIOTNPTR;                 /*POINT TO THE NEXT SIOT      */
         L     SIOTPTR,SIOTNPTR(,SIOTPTR)                       02S0228
*END;                                                           02S0229
@DE00201 SLR   @10,@10                                          02S0229
         CR    SIOTPTR,@10                                      02S0229
         BE    @DC00201                                         02S0229
         CR    ERRCODE2,@10                                     02S0229
         BE    @DL00201                                         02S0229
@DC00201 DS    0H                                               02S0230
*  END;                                                         01S0230
*ELSE;                                 /*ERROR                       */
@RF00198 DS    0H                                               01S0232
*  PERMRES = OFF;                      /*SIGNIFY END OF PERMRES/RESVD
*                                        PROCESSING                  */
         NI    PERMRES,B'11101111'                              01S0232
*RETURN CODE(ERRCODE2);                /*RETURN TO CALLER            */
         L     @13,4(,@13)                                      01S0233
         L     @00,@SIZDATD                                     01S0233
         LR    @01,@11                                          01S0233
         FSPACE   R,LV=(0),A=(1)
         LR    @15,@06                                          01S0233
         L     @14,12(,@13)                                     01S0233
         LM    @00,@12,20(@13)                                  01S0233
         BR    @14                                              01S0233
*END IEFAB430                          /*END OF FIXED DEVICE CONTROL */
*/* THE FOLLOWING INCLUDE STATEMENTS WERE FOUND IN THIS PROGRAM.      *
*/*%INCLUDE SYSLIB  (A430SPEC)                                        *
*/*%INCLUDE SYSLIB  (A430DATA)                                        *
*/*%INCLUDE SYSLIB  (BLPRDATA)                                        *
*/*%INCLUDE SYSLIB  (UPCTDATA)                                        *
*/*%INCLUDE SYSLIB  (IEFASIOT)                                        *
*/*%INCLUDE SYSLIB  (IEFZB423)                                        *
*/*%INCLUDE SYSLIB  (IEFZB421)                                        *
*/*%INCLUDE SYSLIB  (IEFZB425)                                        *
*/*%INCLUDE SYSLIB  (IEFUCBOB)                                        *
*/*%INCLUDE SYSLIB  (UPDTCNT )                                        *
*/*%INCLUDE SYSLIB  (UPCTSPEC)                                        *
*/*%INCLUDE SYSLIB  (BLDPRLST)                                        *
*/*%INCLUDE SYSLIB  (BLDPRSPC)                                        *
*/*%INCLUDE SYSLIB  (CHEKDMND)                                        *
*/*%INCLUDE SYSLIB  (CHEKSPEC)                                        *
*;                                                              01S0234
@DATA    DS    0H
@CH00052 DC    H'1'
@CH00091 DC    H'2'
@CH00073 DC    H'65'
@DATD    DSECT
         DS    0F
@SA00001 DS    18F
@PC00001 DS    1F
@AL00001 DS    3A
IEFAB430 CSECT
         DS    0F
@CF00088 DC    XL4'E6000000'
@DATD    DSECT
         DS    0D
ALCWAPTR DS    A
PRLSTPTR DS    A
PSPRMPTR DS    A
EDTPTR   DS    A
LUVPTR   DS    A
GENPTR   DS    A
GRPTABP  DS    A
GRPPTR   DS    A
PSCPARM  DS    CL8
         ORG   PSCPARM
@NM00001 DS    CL4
         ORG   @NM00001
PSSWTCHS DS    BL1
         ORG   PSSWTCHS
PUBLIC   DS    BL1
STORAGE  EQU   PSSWTCHS+0
PUBSTOR  EQU   PSSWTCHS+0
PERMRES  EQU   PSSWTCHS+0
MOUNTED  EQU   PSSWTCHS+0
@NM00002 EQU   PSSWTCHS+0
@NM00003 EQU   PSSWTCHS+0
@NM00004 EQU   PSSWTCHS+0
         ORG   @NM00001+1
@NM00005 DS    AL3
         ORG   PSCPARM+4
PRLSTLEN DS    FL4
         ORG   PSCPARM+8
COUNTERS DS    CL20
         ORG   COUNTERS
SPECCNT  DS    FL4
PUBLCNT  DS    FL4
STRGCNT  DS    FL4
PNSPCNT  DS    FL4
TOTLCNT  DS    FL4
         ORG   COUNTERS+20
IEFAB430 CSECT
         DS    0F
@SIZDATD DC    AL1(230)
         DC    AL3(@ENDDATD-@DATD)
@CV00076 DC    V(IEFAB433)
@CV00077 DC    V(IEFAB436)
         DS    0D
VULENGTH DC    AL4(28)
GTSTZERO DC    F'0'
IOSLTEND DC    XL2'FFFF'
NOVOLSER DC    X'000000000000'
IEFAB430 CSECT
         DS   0H
PATCHLOC DC ((@DATA-@PSTART)/20)X'00'
@DATD    DSECT
         ORG   *+1-(*-@DATD)/(*-@DATD) INSURE DSECT DATA
@ENDDATD EQU   *
IEFAB430 CSECT
@00      EQU   00                      EQUATES FOR REGISTERS 0-15
@01      EQU   01
@02      EQU   02
@03      EQU   03
@04      EQU   04
@05      EQU   05
@06      EQU   06
@07      EQU   07
@08      EQU   08
@09      EQU   09
@10      EQU   10
@11      EQU   11
@12      EQU   12
@13      EQU   13
@14      EQU   14
@15      EQU   15
GTSTRTCD EQU   @10
VUCTR    EQU   @05
VUPTR    EQU   @03
SIOTPTR  EQU   @02
LUTENTNO EQU   @03
SLOTNO   EQU   @09
UCBPTR   EQU   @02
ERRCODE2 EQU   @06
I        EQU   @04
SPTR     EQU   @04
REG0     EQU   @00
REG1     EQU   @01
REG15    EQU   @15
GTSTR0   EQU   @00
GTSTR1   EQU   @01
GTSTR2   EQU   @02
GTSTR15  EQU   @15
GTSTR4   EQU   @04
GTSTR5   EQU   @05
GTSTR6   EQU   @06
GTSTR7   EQU   @07
GTSTR8   EQU   @08
GTSTR3   EQU   @03
IOSLUT   EQU   0
PRLST    EQU   0
FAILCODE EQU   0
INDMSIOT EQU   0
SCTUSADD EQU   INDMSIOT+20
SIOPSCNT EQU   INDMSIOT+42
SIOTBYT1 EQU   INDMSIOT+43
SIOTALCD EQU   SIOTBYT1
SIOTBYT3 EQU   INDMSIOT+46
SIOTTSTC EQU   INDMSIOT+47
SIOTBYT0 EQU   INDMSIOT+52
SCTSDISP EQU   INDMSIOT+55
SCTSBYT1 EQU   INDMSIOT+56
SCTDUMMY EQU   SCTSBYT1
SCTSBYT2 EQU   INDMSIOT+57
SCTSBYT3 EQU   INDMSIOT+58
SCTSBYT4 EQU   INDMSIOT+59
SCTUTYPE EQU   INDMSIOT+60
SIOTDEVT EQU   SCTUTYPE
SIOUBYT3 EQU   SIOTDEVT+2
SIOUCBAD EQU   SCTUTYPE+5
SIOTBYT4 EQU   INDMSIOT+81
SIOTALTD EQU   INDMSIOT+92
SIOTBYT2 EQU   INDMSIOT+103
SIOTDMND EQU   SIOTBYT2
SIOTRSNC EQU   INDMSIOT+130
SVOLUNAD EQU   INDMSIOT+140
SIOTNPTR EQU   INDMSIOT+152
SVOLUNNO EQU   INDMSIOT+168
VOLUNTAB EQU   0
VOLSTAT  EQU   VOLUNTAB+6
VOLSTATA EQU   VOLSTAT
VOLPUB   EQU   VOLSTATA
VOLPRV   EQU   VOLSTATA
VOLSPEC  EQU   VOLSTATA
VOLSTG   EQU   VOLSTATA
VOLNSHR  EQU   VOLSTATA
VOLSTATB EQU   VOLSTAT+1
VOLALOC  EQU   VOLSTATB
VDEVREQD EQU   VOLSTATB
VOLSTATC EQU   VOLSTAT+2
VOLSTATD EQU   VOLSTAT+3
VOLUNTID EQU   VOLUNTAB+10
VUUCBP   EQU   VOLUNTAB+20
VUGRID   EQU   VOLUNTAB+24
VUPOOL   EQU   0
VUGRLST  EQU   0
VUGRLENT EQU   VUGRLST
VUGRLFLG EQU   VUGRLENT+4
EDTHDR   EQU   0
EDTLUVSP EQU   EDTHDR
EDTGENSP EQU   EDTHDR+4
EDTGRPSP EQU   EDTHDR+8
EDTUCBSP EQU   EDTHDR+12
EDTMSKTP EQU   EDTHDR+16
LUVSECT  EQU   0
LUVHDR   EQU   LUVSECT
LUVENTRY EQU   0
LUVGMTP  EQU   LUVENTRY+12
LUVFLAGS EQU   LUVENTRY+24
GENSECT  EQU   0
GENHDR   EQU   GENSECT
GENENTRY EQU   0
GRPTRTAB EQU   0
GRPSECT  EQU   0
GRPHDR   EQU   GRPSECT
GRPENTRY EQU   0
GRPUCBP  EQU   GRPENTRY+8
EUCBSECT EQU   0
EUCBHDR  EQU   EUCBSECT
EUCBENTY EQU   0
GRMSKTAB EQU   0
GMTHDR   EQU   GRMSKTAB
GMTENTRY EQU   0
ALCWA    EQU   0
SIOT1P   EQU   ALCWA+8
IOSLUTP  EQU   ALCWA+16
FAILRSCP EQU   ALCWA+20
EDTABPTR EQU   ALCWA+24
CNTABLE  EQU   ALCWA+28
SPECREQS EQU   CNTABLE+12
PVTNREQS EQU   CNTABLE+16
PUBLREQS EQU   CNTABLE+20
STRGREQS EQU   CNTABLE+24
NUMREQS  EQU   CNTABLE+40
TOTVOLUN EQU   CNTABLE+44
INDICATE EQU   ALCWA+112
@NM00025 EQU   ALCWA+113
TIOTHDRP EQU   ALCWA+120
ALCNUCBS EQU   ALCWA+148
NAMES    EQU   0
UCB      EQU   0
UCBOB    EQU   0
UCBJBNR  EQU   UCBOB
UCBFL5   EQU   UCBOB+1
UCBAF    EQU   UCBFL5
UCBNALOC EQU   UCBFL5
UCBSTAT  EQU   UCBOB+3
UCBONLI  EQU   UCBSTAT
UCBCHGS  EQU   UCBSTAT
UCBRESV  EQU   UCBSTAT
UCBUNLD  EQU   UCBSTAT
UCBPRES  EQU   UCBSTAT
UCBCHAN  EQU   UCBOB+4
UCBSFLS  EQU   UCBOB+6
UCBFLA   EQU   UCBSFLS
UCBFL1   EQU   UCBFLA
UCBBSY   EQU   UCBFL1
UCBNRY   EQU   UCBFL1
UCBNOTRD EQU   UCBNRY
UCBPST   EQU   UCBFL1
UCBCUB   EQU   UCBFL1
UCBFLB   EQU   UCBSFLS+1
UCBCHM   EQU   UCBOB+8
UCBCHM1  EQU   UCBCHM
UCBPTH0  EQU   UCBCHM1
UCBPTH1  EQU   UCBCHM1
UCBWGT   EQU   UCBOB+12
UCBTYP   EQU   UCBOB+16
UCBTBYT1 EQU   UCBTYP
UCB1FEA5 EQU   UCBTBYT1
UCB1FEA6 EQU   UCBTBYT1
UCBTBYT2 EQU   UCBTYP+1
UCB2OPT2 EQU   UCBTBYT2
UCBDUDN1 EQU   UCB2OPT2
UCB2OPT3 EQU   UCBTBYT2
UCBDUDN2 EQU   UCB2OPT3
UCB2OPT4 EQU   UCBTBYT2
UCBRWTAU EQU   UCB2OPT4
UCB2OPT6 EQU   UCBTBYT2
UCB2OPT7 EQU   UCBTBYT2
UCBTBYT3 EQU   UCBTYP+2
UCBDVCLS EQU   UCBTBYT3
UCB3DACC EQU   UCBDVCLS
UCBTBYT4 EQU   UCBTYP+3
UCBEXTPT EQU   UCBOB+20
UCBFLC   EQU   UCBEXTPT
UCBDEV   EQU   UCBOB+24
UCBCMEXT EQU   0
UCBATI   EQU   UCBCMEXT+3
@NM00030 EQU   UCBATI
UCBFLP1  EQU   UCBCMEXT+5
UCBMT    EQU   0
UCBOCR   EQU   0
UCB3540X EQU   0
UCBDKBYT EQU   UCB3540X+6
UCB3800X EQU   0
UCBOPTNS EQU   UCB3800X
UCBACTIV EQU   UCB3800X+3
UCBMDRBF EQU   UCB3800X+36
UCBUCS   EQU   0
UCBUCSOP EQU   UCBUCS+4
UCBFCBOP EQU   UCBUCS+5
UCBBGN   EQU   0
PARMPTR  EQU   0
UCBOBS01 EQU   UCBDEV
UCBVOLI  EQU   UCBOBS01+4
UCBSTAB  EQU   UCBOBS01+10
UCBBSVL  EQU   UCBSTAB
UCBPRSRS EQU   UCBSTAB
UCBDMCT  EQU   UCBOBS01+11
UCBFL4   EQU   UCBOBS01+13
UCBOBS02 EQU   UCBDEV
UCBTFL1  EQU   UCBOBS02+19
UCBXTN   EQU   UCBOBS02+20
UCBVOPT  EQU   UCBXTN
UCBOBS03 EQU   UCBDEV
UCBXTADR EQU   UCBOBS03
UCBOBS04 EQU   UCBDEV
UCBBTA   EQU   UCBOBS04+12
UCBOBS06 EQU   UCBDEV
UCBAOF   EQU   UCBOBS06
UCBAOF1  EQU   UCBAOF
UCBAOF2  EQU   UCBAOF+1
@NM00029 EQU   UCBOBS06+3
UCBIRB   EQU   UCBOBS06+4
UCBGRAF  EQU   UCBIRB
UCBLDNCA EQU   UCBOBS06+8
UCBRDYQ  EQU   UCBLDNCA
UCBIRLN  EQU   UCBRDYQ
UCBLDNCB EQU   UCBRDYQ+1
UCBCTLNK EQU   UCBOBS06+12
UCBOBS07 EQU   UCBDEV
UCBOBS08 EQU   UCBDEV
UCBCTCAD EQU   UCBOBS08
UCBCTCF1 EQU   UCBOBS08+4
UCBOBS09 EQU   UCBDEV
         AGO   .@UNREFD                START UNREFERENCED COMPONENTS
UCBRV066 EQU   UCBOBS09+4
UCBIOSBA EQU   UCBOBS09
UCBRV042 EQU   UCBOBS08+5
UCBRV082 EQU   UCBCTCF1
UCBRV081 EQU   UCBCTCF1
UCBRV080 EQU   UCBCTCF1
UCBRV079 EQU   UCBCTCF1
UCBRV078 EQU   UCBCTCF1
UCBRV077 EQU   UCBCTCF1
UCBRV076 EQU   UCBCTCF1
UCBCTC80 EQU   UCBCTCF1
UCBCTCAL EQU   UCBCTCAD
UCBICNCB EQU   UCBOBS07+4
UCBRV040 EQU   UCBOBS07
UCBCTLNA EQU   UCBCTLNK+1
UCBRLN   EQU   UCBCTLNK
UCBRDYQA EQU   UCBLDNCB
UCBINRLN EQU   UCBIRLN
UCBIRBA  EQU   UCBIRB+1
UCBRV039 EQU   UCBGRAF
UCBDWNR  EQU   UCBGRAF
UCBRPND  EQU   UCBGRAF
UCBUPM   EQU   UCBGRAF
UCBBTAM  EQU   UCBGRAF
UCBDRNO  EQU   UCBGRAF
UCBDRO   EQU   UCBGRAF
UCBOIP   EQU   UCBGRAF
UCBATRCD EQU   @NM00029
UCBSKPFG EQU   @NM00029
UCBRIPND EQU   @NM00029
UCBRTIAC EQU   @NM00029
UCBRSV79 EQU   @NM00029
UCBRSV78 EQU   @NM00029
UCBRSV77 EQU   @NM00029
UCBOLTEP EQU   @NM00029
UCBATNCT EQU   UCBOBS06+2
UCBRSV76 EQU   UCBAOF2
UCBRSV75 EQU   UCBAOF2
UCBRSV74 EQU   UCBAOF2
UCBRSV73 EQU   UCBAOF2
UCBRSV72 EQU   UCBAOF2
UCBRSV71 EQU   UCBAOF2
UCBRSV70 EQU   UCBAOF2
UCBRSV69 EQU   UCBAOF2
UCBRSV68 EQU   UCBAOF1
UCBRSV67 EQU   UCBAOF1
UCBRSV66 EQU   UCBAOF1
UCBRSV65 EQU   UCBAOF1
UCBRSV64 EQU   UCBAOF1
UCBOFNL  EQU   UCBAOF1
UCBOFSP  EQU   UCBAOF1
UCBOFMCR EQU   UCBAOF1
UCBBTB   EQU   UCBBTA+1
UCBDI    EQU   UCBBTA
UCBSNS   EQU   UCBOBS04+8
UCBTEB   EQU   UCBOBS04+4
UCBGCB   EQU   UCBOBS04+3
UCBOPEN  EQU   UCBOBS04+2
UCBSTART EQU   UCBOBS04
UCBXTNB  EQU   UCBXTN+1
UCBRSV22 EQU   UCBVOPT
UCBRSV21 EQU   UCBVOPT
UCBRSV20 EQU   UCBVOPT
UCBESVE  EQU   UCBVOPT
UCBERPC  EQU   UCBVOPT
UCBESVC  EQU   UCBVOPT
UCBEVA   EQU   UCBVOPT
UCBESV   EQU   UCBVOPT
UCBRV009 EQU   UCBTFL1
UCBRV008 EQU   UCBTFL1
UCBRV007 EQU   UCBTFL1
UCBRV006 EQU   UCBTFL1
UCBRV005 EQU   UCBTFL1
UCBDQDSP EQU   UCBTFL1
UCBNSLTP EQU   UCBTFL1
UCBNLTP  EQU   UCBTFL1
UCBRES1B EQU   UCBOBS02+18
UCBFSER  EQU   UCBOBS02+12
@NM00028 EQU   UCBOBS02+4
UCBFSEQ  EQU   UCBOBS02+2
UCBFSCT  EQU   UCBOBS02
UCBNEXP  EQU   UCBOBS01+20
UCBBASE  EQU   UCBOBS01+16
UCBRES1A EQU   UCBOBS01+15
UCBUSER  EQU   UCBOBS01+14
UCBFL47  EQU   UCBFL4
UCBFL46  EQU   UCBFL4
UCBFL45  EQU   UCBFL4
UCBRV065 EQU   UCBFL4
UCBDSS   EQU   UCBFL4
UCBRESVP EQU   UCBFL4
UCBWDAV  EQU   UCBFL4
UCBDAVV  EQU   UCBFL4
UCBSQC   EQU   UCBOBS01+12
UCBDATP  EQU   UCBOBS01+12
UCBDMC   EQU   UCBDMCT
UCBMOUNT EQU   UCBDMCT
UCBBNUL  EQU   UCBSTAB
UCBSHAR  EQU   UCBSTAB
UCBBSTR  EQU   UCBSTAB
UCBBPUB  EQU   UCBSTAB
UCBBPRV  EQU   UCBSTAB
UCBBALB  EQU   UCBPRSRS
UCBPGFL  EQU   UCBSTAB
UCBDVSHR EQU   UCBBSVL
UCBVTOC  EQU   UCBOBS01
UCBERADR EQU   UCBUCS+12
UCBFCBID EQU   UCBUCS+8
UCBERCNT EQU   UCBUCS+7
UCBRSV51 EQU   UCBUCS+6
UCBFCBPE EQU   UCBFCBOP
UCBRSV49 EQU   UCBFCBOP
UCBRSV48 EQU   UCBFCBOP
UCBRSV47 EQU   UCBFCBOP
UCBRSV46 EQU   UCBFCBOP
UCBRSV45 EQU   UCBFCBOP
UCBRSV44 EQU   UCBFCBOP
UCBFCBO1 EQU   UCBFCBOP
UCBUCSPE EQU   UCBUCSOP
UCBRSV43 EQU   UCBUCSOP
UCBRSV42 EQU   UCBUCSOP
UCBRSV41 EQU   UCBUCSOP
UCBRSV40 EQU   UCBUCSOP
UCBRSV39 EQU   UCBUCSOP
UCBUCSO2 EQU   UCBUCSOP
UCBUCSO1 EQU   UCBUCSOP
UCBUCSID EQU   UCBUCS
UCBMDRBA EQU   UCBMDRBF+1
UCBRV075 EQU   UCBMDRBF
UCBRV074 EQU   UCB3800X+32
UCBIMAGE EQU   UCB3800X+28
UCBFCBNM EQU   UCB3800X+24
UCBCHAR4 EQU   UCB3800X+20
UCBCHAR3 EQU   UCB3800X+16
UCBCHAR2 EQU   UCB3800X+12
UCBCHAR1 EQU   UCB3800X+8
UCBCGMID EQU   UCB3800X+4
UCBBRSTA EQU   UCBACTIV
UCBRV063 EQU   UCBACTIV
UCBRV062 EQU   UCBACTIV
UCBRV061 EQU   UCBACTIV
UCBRV060 EQU   UCBACTIV
UCBRV059 EQU   UCBACTIV
UCBRV058 EQU   UCBACTIV
UCBRV057 EQU   UCBACTIV
UCBRV050 EQU   UCB3800X+2
UCBCGMNO EQU   UCB3800X+1
UCBRV083 EQU   UCBOPTNS
UCBBRSTR EQU   UCBOPTNS
UCBRV056 EQU   UCBOPTNS
UCBRV055 EQU   UCBOPTNS
UCBRV054 EQU   UCBOPTNS
UCBRV053 EQU   UCBOPTNS
UCBRV052 EQU   UCBOPTNS
UCBRV051 EQU   UCBOPTNS
UCBRV073 EQU   UCB3540X+7
UCBRV072 EQU   UCBDKBYT
UCBRV071 EQU   UCBDKBYT
UCBRV070 EQU   UCBDKBYT
UCBRV069 EQU   UCBDKBYT
UCBRV068 EQU   UCBDKBYT
UCBRV067 EQU   UCBDKBYT
UCBVLVER EQU   UCBDKBYT
UCBDKAMX EQU   UCBDKBYT
UCBVLSER EQU   UCB3540X
UCBRDATA EQU   UCBOCR+4
UCBFRID  EQU   UCBOCR
UCBCLN   EQU   UCBMT+14
UCBERG   EQU   UCBMT+12
UCBMS    EQU   UCBMT+11
UCBNB    EQU   UCBMT+10
UCBPW    EQU   UCBMT+9
UCBPR    EQU   UCBMT+8
UCBSIO   EQU   UCBMT+6
UCBTW    EQU   UCBMT+5
UCBTR    EQU   UCBMT+4
UCBTWT   EQU   UCBMT+3
UCBTRT   EQU   UCBMT+2
UCBCTD   EQU   UCBMT
UCBWTOID EQU   UCBCMEXT+17
UCBRV043 EQU   UCBCMEXT+16
UCBASID  EQU   UCBCMEXT+14
UCBMFCNT EQU   UCBCMEXT+12
UCBPMSK  EQU   UCBCMEXT+10
UCBCCWOF EQU   UCBCMEXT+8
UCBRV041 EQU   UCBCMEXT+6
UCBRV036 EQU   UCBFLP1
UCBRV035 EQU   UCBFLP1
UCBERLOG EQU   UCBFLP1
UCBRV033 EQU   UCBFLP1
UCBINHIO EQU   UCBFLP1
UCBNSWAP EQU   UCBFLP1
UCBSHRUP EQU   UCBFLP1
UCBNSRCH EQU   UCBFLP1
UCBSNSCT EQU   UCBCMEXT+4
UCBHPDV  EQU   @NM00030
UCBHALI  EQU   @NM00030
UCBRSV09 EQU   @NM00030
UCBRSV08 EQU   @NM00030
UCBRSV07 EQU   @NM00030
UCBRSV06 EQU   @NM00030
UCBRSV05 EQU   @NM00030
UCBRSV04 EQU   @NM00030
UCBDTI   EQU   UCBCMEXT+2
UCBSTI   EQU   UCBCMEXT+1
UCBETI   EQU   UCBCMEXT
UCBEXTP  EQU   UCBEXTPT+1
UCBDDRSW EQU   UCBFLC
UCBTICBT EQU   UCBFLC
UCBIVRR  EQU   UCBFLC
UCBIVRS  EQU   UCBFLC
UCBITF   EQU   UCBFLC
UCBUDE   EQU   UCBFLC
UCBWAA   EQU   UCBFLC
UCBATTP  EQU   UCBFLC
UCBUNTYP EQU   UCBTBYT4
UCBRSV11 EQU   UCBDVCLS
UCBRSV10 EQU   UCBDVCLS
UCB3CHAR EQU   UCBDVCLS
UCB3UREC EQU   UCBDVCLS
UCB3DISP EQU   UCBDVCLS
UCB3COMM EQU   UCBDVCLS
UCB3TAPE EQU   UCBDVCLS
UCBDVPWR EQU   UCB2OPT7
UCBVLPWR EQU   UCB2OPT6
UCB2OPT5 EQU   UCBTBYT2
UCBRVDEV EQU   UCBRWTAU
UCBRPS   EQU   UCBDUDN2
UCBRR    EQU   UCBDUDN1
UCB2OPT1 EQU   UCBTBYT2
UCB2OPT0 EQU   UCBTBYT2
UCB1FEA7 EQU   UCBTBYT1
UCBD6250 EQU   UCB1FEA6
UCBD1600 EQU   UCB1FEA5
UCB1FEA4 EQU   UCBTBYT1
UCB1FEA3 EQU   UCBTBYT1
UCB1FEA2 EQU   UCBTBYT1
UCB1FEA1 EQU   UCBTBYT1
UCB1FEA0 EQU   UCBTBYT1
UCBNAME  EQU   UCBOB+13
UCBRV029 EQU   UCBWGT
UCBVHRSN EQU   UCBWGT
UCBVORSN EQU   UCBWGT
UCBMTPXP EQU   UCBWGT
UCBREW   EQU   UCBWGT
UCBPUB   EQU   UCBWGT
UCBOUT   EQU   UCBWGT
UCBIN    EQU   UCBWGT
UCBCPU   EQU   UCBOB+11
UCBLCI   EQU   UCBOB+10
UCBCNT   EQU   UCBOB+9
UCBRV017 EQU   UCBCHM1
UCBRV016 EQU   UCBCHM1
UCBRV015 EQU   UCBCHM1
UCBRV014 EQU   UCBCHM1
UCBSPB   EQU   UCBPTH1
UCBPPB   EQU   UCBPTH1
UCBSPA   EQU   UCBPTH0
UCBPPA   EQU   UCBPTH0
UCBSIGP  EQU   UCBFLB
UCBVALPH EQU   UCBFLB
UCBCRHSN EQU   UCBFLB
UCBCRHRV EQU   UCBFLB
UCBRESVH EQU   UCBFLB
UCBSPST  EQU   UCBFLB
UCBASNS  EQU   UCBFLB
UCBIORST EQU   UCBFLB
UCBQISCE EQU   UCBFL1
UCBACTV  EQU   UCBFL1
UCBSAP   EQU   UCBFL1
UCBNOTRC EQU   UCBCUB
UCBPSNS  EQU   UCBFL1
UCBUSING EQU   UCBPST
UCBBUSYD EQU   UCBBSY
UCBUA    EQU   UCBCHAN+1
UCBCHA   EQU   UCBCHAN
UCBDADI  EQU   UCBSTAT
UCBSYSR  EQU   UCBSTAT
UCBALOC  EQU   UCBSTAT
UCBID    EQU   UCBOB+2
UCBALTPH EQU   UCBFL5
UCBALTCU EQU   UCBFL5
UCBENVRD EQU   UCBFL5
UCBVSDR  EQU   UCBFL5
UCBSASK  EQU   UCBFL5
UCBAMV   EQU   UCBAF
UCBDCC   EQU   UCBFL5
UCBMONT  EQU   UCBJBNR
UCBRV011 EQU   UCBJBNR
UCBMMSGP EQU   UCBJBNR
UCBOLDSM EQU   UCBJBNR
UCBRV003 EQU   UCBJBNR
UCBDUC   EQU   UCBJBNR
UCBJES3  EQU   UCBJBNR
UCBVRDEV EQU   UCBJBNR
UCBCMSEG EQU   UCBOB
UCBPFXND EQU   UCB+512
UCBIOQ   EQU   UCB+508
UCBLOCK  EQU   UCB+504
UCBPXST  EQU   UCB+504
@NM00027 EQU   UCB
ALCPROCN EQU   NAMES+16
ALCSTEPN EQU   NAMES+8
ALCJOBN  EQU   NAMES
LOJSSNMP EQU   ALCWA+164
SSERBLKP EQU   ALCWA+160
GROUPSZ  EQU   ALCWA+156
GRIDPTR  EQU   ALCWA+152
EXITPRMP EQU   ALCWA+144
CANCELP  EQU   ALCWA+140
WORK3MP  EQU   ALCWA+136
WMASK2P  EQU   ALCWA+132
WMASKPTR EQU   ALCWA+128
LGENLOCK EQU   ALCWA+124
TCBP     EQU   ALCWA+116
ALCWASID EQU   ALCWA+114
@NM00026 EQU   @NM00025
NODEVERR EQU   @NM00025
NEEDRCVY EQU   @NM00025
ALCWAREC EQU   @NM00025
WAITIGEN EQU   @NM00025
UNITRECS EQU   @NM00025
ALCWADUL EQU   INDICATE
ALCWISAM EQU   INDICATE
DSSUNIT  EQU   INDICATE
DSSTAPE  EQU   INDICATE
PRIVASUM EQU   INDICATE
INDREQU  EQU   INDICATE
INDRETRY EQU   INDICATE
INDWAIT  EQU   INDICATE
QMGRRBP  EQU   ALCWA+108
RIMTABCT EQU   ALCWA+104
RIMTABLN EQU   ALCWA+100
RIMTABP  EQU   ALCWA+96
ALGTABSZ EQU   ALCWA+92
ALGTABP  EQU   ALCWA+88
VOLUNSZE EQU   ALCWA+84
VOLUNPTR EQU   ALCWA+80
@NM00024 EQU   ALCWA+78
LTUNITID EQU   ALCWA+76
TOTREQS  EQU   CNTABLE+36
OTHEREQS EQU   CNTABLE+32
SUBSREQS EQU   CNTABLE+28
TPREQS   EQU   CNTABLE+8
VAMREQS  EQU   CNTABLE+4
DMYREQS  EQU   CNTABLE
JSCBPTR  EQU   ALCWA+12
FMAPPTR  EQU   ALCWA+4
WASIZE   EQU   ALCWA
GRPMASK  EQU   GMTENTRY
GMTENTLN EQU   GMTHDR+4
GMTENTNO EQU   GMTHDR
EUCBTPOS EQU   EUCBENTY
EUCBENLN EQU   EUCBHDR+4
EUCBENNO EQU   EUCBHDR
GRPUCBNO EQU   GRPENTRY+4
GRPID    EQU   GRPENTRY
GRPENTLN EQU   GRPHDR+4
GRPENTNO EQU   GRPHDR
GRPTR    EQU   GRPTRTAB
GENGRPTR EQU   GENENTRY+8
GENGRPNO EQU   GENENTRY+4
GENDEVT  EQU   GENENTRY
GENENTLN EQU   GENHDR+4
GENENTNO EQU   GENHDR
LUVAGMTP EQU   LUVENTRY+28
@NM00023 EQU   LUVFLAGS
LUVMGENS EQU   LUVFLAGS
LUVAGMSK EQU   LUVFLAGS
LUVVAM   EQU   LUVFLAGS
LUVGENP  EQU   LUVENTRY+20
LUVGENNO EQU   LUVENTRY+16
LUVALUE  EQU   LUVENTRY+8
UNITNAME EQU   LUVENTRY
LUVENTLN EQU   LUVHDR+4
LUVENTNO EQU   LUVHDR
@NM00022 EQU   VUGRLENT+5
@NM00021 EQU   VUGRLFLG
VUGRALCD EQU   VUGRLFLG
VUGRLIDS EQU   VUGRLENT
VUCBS    EQU   VUPOOL+4
VUPOOL#  EQU   VUPOOL
VOLSIOTP EQU   VOLUNTAB+16
VOLALGTP EQU   VOLUNTAB+12
VURCVYPR EQU   VOLSTATD
VUVLUNIQ EQU   VOLSTATD
VUDMUNIQ EQU   VOLSTATD
VUUNALSW EQU   VOLSTATD
VUDMNDAL EQU   VOLSTATD
VUDMNDOF EQU   VOLSTATD
VUREALOC EQU   VOLSTATD
VUMUGDON EQU   VOLSTATD
@NM00020 EQU   VOLSTATC
@NM00019 EQU   VOLSTATC
VURECVRY EQU   VOLSTATC
VOLURREQ EQU   VOLSTATC
VOLGRREQ EQU   VOLSTATC
VOLDAREQ EQU   VOLSTATC
VOLCOREQ EQU   VOLSTATC
VOLTAREQ EQU   VOLSTATC
VUAFFWRK EQU   VOLSTATB
VUVINELG EQU   VOLSTATB
VUDADSME EQU   VOLSTATB
VUDNALOC EQU   VOLSTATB
VUPROCED EQU   VOLSTATB
VOLMNTD  EQU   VOLSTATB
VOLDEFER EQU   VOLSTATA
VUDADSM  EQU   VOLSTATA
VOLRESVE EQU   VOLSTATA
VOLID    EQU   VOLUNTAB
SIODDSNL EQU   INDMSIOT+173
SIOVDSNL EQU   INDMSIOT+172
SIOVDSNT EQU   INDMSIOT+170
SIOTVMVP EQU   INDMSIOT+164
SIOTJFX  EQU   INDMSIOT+160
SJFCBPTR EQU   INDMSIOT+156
SIOTETIO EQU   INDMSIOT+148
SIOTATE  EQU   INDMSIOT+144
SIOTEDLP EQU   INDMSIOT+136
SIOTEDLS EQU   INDMSIOT+132
SCTANAME EQU   INDMSIOT+122
SIOTSSIC EQU   INDMSIOT+120
@NM00018 EQU   INDMSIOT+108
SIOTSSNM EQU   INDMSIOT+104
@NM00017 EQU   SIOTBYT2
SIOTCVOL EQU   SIOTBYT2
SIOTCNEW EQU   SIOTBYT2
SIOTCALC EQU   SIOTBYT2
SIOTGALL EQU   SIOTBYT2
SIOTDSPD EQU   SIOTBYT2
SIOTOPUC EQU   INDMSIOT+99
SIOTOUTR EQU   INDMSIOT+97
SIOTOUTC EQU   INDMSIOT+96
SIOTSSWA EQU   INDMSIOT+93
SIOTAUNC EQU   SIOTALTD
SIOTACAT EQU   SIOTALTD
SIOTADEL EQU   SIOTALTD
SIOTAKEP EQU   SIOTALTD
SIOTNPRV EQU   SIOTALTD
SIOJCATS EQU   SIOTALTD
@NM00016 EQU   SIOTALTD
@NM00015 EQU   SIOTALTD
@NM00014 EQU   INDMSIOT+91
SIOTNDSB EQU   INDMSIOT+88
@NM00013 EQU   INDMSIOT+84
SIOTDPCD EQU   INDMSIOT+82
@NM00012 EQU   SIOTBYT4
SIOTRACT EQU   SIOTBYT4
SIOTRACD EQU   SIOTBYT4
SIOTPROT EQU   SIOTBYT4
SCTOUTPN EQU   INDMSIOT+80
SCTOUTNO EQU   INDMSIOT+76
SCTOUTNM EQU   INDMSIOT+68
SIOUCNVT EQU   SCTUTYPE+4
SIOUBYT4 EQU   SIOTDEVT+3
@NM00011 EQU   SIOUBYT3
SIO3UREC EQU   SIOUBYT3
SIO3DISP EQU   SIOUBYT3
SIO3DACC EQU   SIOUBYT3
SIO3COMM EQU   SIOUBYT3
SIO3TAPE EQU   SIOUBYT3
SIOUBYT2 EQU   SIOTDEVT+1
SIOUBYT1 EQU   SIOTDEVT
SIOTOMN  EQU   SCTSBYT4
SIOTIPDI EQU   SCTSBYT4
SIOTVAFF EQU   SCTSBYT4
SIOTSTEP EQU   SCTSBYT4
SIOTASCI EQU   SCTSBYT4
@NM00010 EQU   SCTSBYT4
SIOTGDGA EQU   SCTSBYT4
SCTSGDGS EQU   SCTSBYT4
SCTSOLD  EQU   SCTSBYT3
SCTSMOD  EQU   SCTSBYT3
SCTSNEW  EQU   SCTSBYT3
SCTSYSOU EQU   SCTSBYT3
SCTVREF  EQU   SCTSBYT3
SCTALCHK EQU   SCTSBYT3
SCTSYSNE EQU   SCTSBYT3
SCTDSNRF EQU   SCTSBYT3
SCTRECVD EQU   SCTSBYT2
SCTDEFER EQU   SCTSBYT2
SCTLABEL EQU   SCTSBYT2
SCTUNLBD EQU   SCTSBYT2
SCTJOBLB EQU   SCTSBYT2
SCTVOLAF EQU   SCTSBYT2
SIOTCATL EQU   SCTSBYT2
SIOCLUNL EQU   SCTSBYT2
SIOTJSCT EQU   SCTSBYT1
SCTUNAFF EQU   SCTSBYT1
SCTPARLM EQU   SCTSBYT1
SIOTQDSN EQU   SCTSBYT1
SIOTGDSN EQU   SCTSBYT1
SIOTCCAT EQU   SCTSBYT1
SCTSYSIN EQU   SCTSBYT1
SIOTUNCT EQU   SCTSDISP
SIOTCTLG EQU   SCTSDISP
SIOTDLET EQU   SCTSDISP
SIOTKEEP EQU   SCTSDISP
SIOTPASS EQU   SCTSDISP
SIOTPRIV EQU   SCTSDISP
S3400DSP EQU   SCTSDISP
SIOTRETN EQU   SCTSDISP
SIOTVLCT EQU   INDMSIOT+54
SCTNMBUT EQU   INDMSIOT+53
SIOTRTRY EQU   SIOTBYT0
SIOTPUPV EQU   SIOTBYT0
SIOTNOPV EQU   SIOTBYT0
SIOTGIGN EQU   SIOTBYT0
SPVTAMSG EQU   SIOTBYT0
SIOTFUDA EQU   SIOTBYT0
SIOTDYAL EQU   SIOTBYT0
SIOTSSDS EQU   SIOTBYT0
SIOTGIID EQU   INDMSIOT+50
SCTVOLCT EQU   INDMSIOT+49
SCTSPOOL EQU   INDMSIOT+48
SIOTQNAM EQU   SIOTTSTC
SIOTDSNM EQU   SIOTTSTC
SIOTTRKM EQU   SIOTTSTC
SIOTSSMG EQU   SIOTTSTC
SIOTSSGP EQU   SIOTTSTC
@NM00009 EQU   SIOTTSTC
SIOTTERM EQU   SIOTTSTC
SIOTINFC EQU   SIOTTSTC
@NM00008 EQU   SIOTBYT3
SIOTDSID EQU   SIOTBYT3
S3400OFF EQU   SIOTBYT3
SIOTJES3 EQU   SIOTBYT3
SIOCDEVT EQU   SIOTBYT3
SIOALIAS EQU   SIOTBYT3
SCTDDINO EQU   INDMSIOT+44
SIOTDDNT EQU   SIOTBYT1
SIODADSM EQU   SIOTBYT1
SIOTDADR EQU   SIOTBYT1
SIODUNAL EQU   SIOTBYT1
SIOVAMDS EQU   SIOTBYT1
SIOTHOLD EQU   SIOTBYT1
SIOTOCKP EQU   SIOTBYT1
SIOTREFN EQU   INDMSIOT+40
SIOTOTUN EQU   INDMSIOT+39
SIOTVRSB EQU   INDMSIOT+36
@NM00007 EQU   INDMSIOT+35
SCTPJFCB EQU   INDMSIOT+32
@NM00006 EQU   INDMSIOT+31
SCTPSIOT EQU   INDMSIOT+28
SIOTAFID EQU   INDMSIOT+26
SIOTVLSP EQU   INDMSIOT+24
SIODSNTE EQU   INDMSIOT+22
SIOTUNAF EQU   SCTUSADD
SIOTDEST EQU   INDMSIOT+12
SCTDDNAM EQU   INDMSIOT+4
SIOTTYPE EQU   INDMSIOT+3
SIOTDSKA EQU   INDMSIOT
.@UNREFD ANOP                          END UNREFERENCED COMPONENTS
@RC00076 EQU   @RC00073
@RC00081 EQU   @RC00073
@RC00088 EQU   @RC00073
@RF00187 EQU   @RC00115
@RC00209 EQU   @RC00207
@RF00084 EQU   @RC00081
@RF00091 EQU   @RC00088
@ENDDATA EQU   *
         END   IEFAB430,(C'PLS2201',0701,78089)
