         TITLE 'IEFAB436 - NON-SPECIFIC VOLUME ALLOCATION CONTROL      *
                        '
IEFAB436 CSECT ,                                                01S0001
@MAINENT DS    0H                                               01S0001
         USING *,@15                                            01S0001
         B     @PROLOG                                          01S0001
         DC    AL1(24)                                          01S0001
         DC    C'IEFAB436 76265  UZ05402 '                      01S0001
         DROP  @15
@PROLOG  STM   @14,@12,12(@13)                                  01S0001
         BALR  @12,0                                            01S0001
@PSTART  DS    0H                                               01S0001
         USING @PSTART,@12                                      01S0001
         L     @00,@SIZDATD                                     01S0001
         GSPACE   R,LV=(0)
         LR    @11,@01                                          01S0001
         USING @DATD,@11                                        01S0001
         ST    @13,@SA00001+4                                   01S0001
         LM    @00,@01,20(@13)                                  01S0001
         ST    @11,8(,@13)                                      01S0001
         LR    @13,@11                                          01S0001
         MVC   @PC00001(12),0(@01)                              01S0001
JSCBDISP EQU 188
JSCBAOS1 EQU  72
JSCBAOS2 EQU 192
*SIOTPTR=SIOT1P;                      /*INITIALIZE SIOT PTR          */
         L     @08,@PC00001                                     01S0064
         L     @08,ALCWAPTR(,@08)                               01S0064
         MVC   SIOTPTR(4),SIOT1P(@08)                           01S0064
*DOINGDA = NO;                        /*INITIALIZE DA SWITCHES       */
         NI    DOINGDA,B'01111111'                              01S0065
*F0MAP = F0MAP && F0MAP;               /*CLEAR MAP FOR F0            */
         XC    F0MAP(1),F0MAP                                   01S0066
*/********************************************************************/
*/*                                                                  */
*/* SEGMENT NAME - PSCTLINT                                          */
*/*                                                                  */
*/* DESCRIPTIVE NAME - PUBLIC/STORAGE ALLOCATION INITIALIZATION      */
*/*                                                                  */
*/* FUNCTION -                                                       */
*/*   THIS ROUTINE PERFORMS THE FOLLOWING FUNCTIONS:                 */
*/*     .GETS CORE FOR THE PUBLIC/STORAGE UCB LIST AND THE           */
*/*      OPTIMIZER LIST. THE AMOUNT OF CORE GOTTEN FOR THE UCB LIST  */
*/*      IS EQUAL TO TWO TIMES THE SIZE OF THE UCB LIST              */
*/*      PASSED BY THE CALLER PLUS THE LENGTH OF THE PSLIST HEADER,  */
*/*      SINCE THIS WOULD BE THE MAXIMUM TABLE SIZE AND              */
*/*      SO THAT THE CORE CAN BE REUSED FOR EACH REQUEST. IF THE     */
*/*      CORE IS NOT AVAILABLE,RETURN CODE WILL BE 4 AND ERROR       */
*/*      REASON CODE 2 IS SET.                                       */
*/*     .DETERMINES TYPE OF PROCESSING,PUBLIC OR STORAGE, TO BE DONE.*/
*/*      A THIRD TYPE OF PROCESSING WHEREBY A PUBLIC REQUEST IS      */
*/*      ASSIGNED TO A STORAGE VOLUME MAY ALSO BE INDICATED. BASED ON*/
*/*      THIS INFORMATION,UCB AND VOLUNIT MASKS ARE INITIALIZED.     */
*/*      MASKS WILL BE USED TO DETERMINE IF A UCB IS ELIGIBLE FOR    */
*/*      ALLOCATION AND IF A VOLUNIT ENTRY SHOULD BE PROCESSED.      */
*/*      ALSO A POINTER TO THE PUBLIC OR STORAGE ENTRY               */
*/*      IN THE COUNT TABLE IS SET. THE FIELD LOCATED BY THIS        */
*/*      POINTER WILL BE DECREMENTED AS UNITS ARE ALLOCATED.         */
*/*     .INITIALIZE THE FOLLOWING VARIABLES.                         */
*/*        RETURN CODE FIELD                                         */
*/*        FLAGS FOR THE ALLOCATE REQUEST TO UNIT ROUTINE ZEROED     */
*/*        PTR TO THE PUBLIC/STORAGE UCB LIST                        */
*/*                                                                  */
*/* ENTRY -                                                          */
*/*   PSCTLINT - INCLUDED IN MODULE IEFAB436                         */
*/*                                                                  */
*/*   PURPOSE - INITIALIZATION                                       */
*/*                                                                  */
*/*   INPUT -                                                        */
*/*     POINTER TO FUNCTION MAP                                      */
*/*     LENGTH OF INPUT UCB LIST (PSUCBLST)                          */
*/*                                                                  */
*/* EXITS -                                                          */
*/*                                                                  */
*/*   CONDITION - NORMAL COMPLETION                                  */
*/*                                                                  */
*/*   OUTPUT -                                                       */
*/*     CORE FOR THE PUBLIC/STORAGE LIST AND THE OPTIMIZER PARM LIST */
*/*     AND INITIALIZED VARIABLES                                    */
*/*                                                                  */
*/*   RETURN CODE - 0                                                */
*/*                                                                  */
*/*   CONDITION - GETMAIN ERROR                                      */
*/*                                                                  */
*/*   OUTPUT -                                                       */
*/*     REASON CODE 2                                                */
*/*                                                                  */
*/*   RETURN CODE - 4                                                */
*/*                                                                  */
*/********************************************************************/
*RETCODE=NOERROR;                      /*INIT RETURN CODE            */
         SLR   @08,@08                                          02S0067
         ST    @08,RETCODE                                      02S0067
*ERETCODE = NOERROR;                                            02S0068
         SLR   ERETCODE,ERETCODE                                02S0068
*PSOPTCOR=OFF;                         /*INITIALIZE CORE GOTTEN SW
*                                                            @YM08667*/
         NI    PSOPTCOR,B'01111111'                             02S0069
*SUBPL=TWO53;                          /*SUBPOOL NO. FOR PARM LIST   */
         LA    @08,253                                          02S0070
         ST    @08,SUBPL                                        02S0070
*PSOPTLEN=LENGTH(OPTPARMS)+(TWO*PSUCBLEN+PSHDRLEN);  /*CORE FOR OPT
*                                        PARMS+MAXSIZE PSLIST@YM08667*/
         L     @15,@PC00001+8                                   02S0071
         L     @01,PSPARMP(,@15)                                02S0071
         L     @15,PSUCBLEN(,@01)                               02S0071
         ALR   @15,@15                                          02S0071
         AL    @15,PSHDRLEN                                     02S0071
         AH    @15,@CH01088                                     02S0071
         ST    @15,PSOPTLEN                                     02S0071
* /* ?GETSTORG (SUBPL,PSOPTLEN,LISTP);*/                        02S0072
*   /* DEFINITIONS OF GETMAIN PARMS */                          02S0072
*   DCL                                                         02S0072
*     GTSTR0   FIXED(31) REG(0),/*GTMN PARM REG*/               02S0072
*     GTSTR1   FIXED(31) REG(1),/*GTMN PARM REG*/               02S0072
*     GTSTR2   PTR(31)   REG(2),/*GTMN PARM REG*/               02S0072
*     GTSTR15  FIXED(31) REG(15),/*GTMN RET COD*/               02S0072
*     GTSTRTCD FIXED(31); /* GETMAIN RTN CODE  */               02S0072
*   DCL                                                         02S0073
*     GTSTR3   FIXED(31) REG(3),/* CLEARING REG*/               02S0073
*     GTSTR4   FIXED(31) REG(4),/* CLEARING REG*/               02S0073
*     GTSTR5   FIXED(31) REG(5),/* CLEARING REG*/               02S0073
*     GTSTR6   FIXED(31) REG(6),/* CLEARING REG*/               02S0073
*     GTSTR7   FIXED(31) REG(7),/* CLEARING REG*/               02S0073
*     GTSTR8   FIXED(31) REG(8),/* CLEARING REG*/               02S0073
*     GTSTZERO FIXED(31) INIT(0),                               02S0073
*     GTST253  FIXED(31) CONSTANT(253);                         02S0073
*   RFY (GTSTR0,GTSTR1,GTSTR2) RSTD; /*SAVE RGS*/               02S0074
*   GTSTR0 = PSOPTLEN; /* SET AMOUNT*/                          02S0075
         LR    GTSTR0,@15                                       02S0075
*   GTSTR2 = SUBPL; /* SET SUBPOOL*/                            02S0076
         LR    GTSTR2,@08                                       02S0076
*   GENERATE CODE;                                              02S0077
     GETMAIN RC,LV=(0),SP=(2)  DO GETMAIN
*   GTSTRTCD = GTSTR15; /* SAVE GETMAIN RET COD*/               02S0078
         ST    GTSTR15,GTSTRTCD                                 02S0078
*   LISTP = GTSTR1; /* ADDR OF GOTN STORG*/                     02S0079
         ST    GTSTR1,LISTP                                     02S0079
*   RFY (GTSTR0,GTSTR1,GTSTR2) UNRSTD; /*RLSE */                02S0080
*   IF GTSTRTCD = 0 THEN /*GETMAIN SUCCESSFUL? */               02S0081
         L     @08,GTSTRTCD                                     02S0081
         LTR   @08,@08                                          02S0081
         BNZ   @RF00081                                         02S0081
*     DO;               /* YES, CLEAR STORAGE.*/                02S0082
*       RFY (GTSTR2,GTSTR4,GTSTR5,GTSTR6,                       02S0083
*                          GTSTR7,GTSTR8) RSTD;                 02S0083
*       GTSTR4 = LISTP; /*STORG PTR*/                           02S0084
         L     @03,LISTP                                        02S0084
         LR    GTSTR4,@03                                       02S0084
*       GTSTR5 = PSOPTLEN; /*STORG AMNT*/                       02S0085
         L     GTSTR5,PSOPTLEN                                  02S0085
*       GTSTR7 = '00000000'X; /*PAD CHAR & LNTH*/               02S0086
         SLR   GTSTR7,GTSTR7                                    02S0086
*       IF SUBPL = GTST253 THEN                                 02S0087
         CLC   SUBPL(4),@CF00958                                02S0087
         BNE   @RF00087                                         02S0087
*      GEN                                                      02S0088
*   (MODESET KEYADDR=GTSTZERO,SAVEKEY=(2),WORKREG=8);           02S0088
         MODESET KEYADDR=GTSTZERO,SAVEKEY=(2),WORKREG=8
*       GEN REFS(GTSTR4,GTSTR6);                                02S0089
@RF00087 DS    0H                                               02S0089
          MVCL  GTSTR4,GTSTR6 CLEAR GOTTEN STORG
*       IF SUBPL = GTST253 THEN                                 02S0090
         CLC   SUBPL(4),@CF00958                                02S0090
         BNE   @RF00090                                         02S0090
*         GEN (MODESET KEYADDR=(2));                            02S0091
         MODESET KEYADDR=(2)
*       RFY (GTSTR2,GTSTR4,GTSTR5,GTSTR6,                       02S0092
*                          GTSTR7,GTSTR8) UNRSTD;               02S0092
@RF00090 DS    0H                                               02S0093
*     END;       /* STORAGE CLEARING COMPLETED */               02S0093
*   ELSE                                                        02S0094
*   LISTP= 0;   /* CLEAR RETURN ADDR. */                        02S0094
         B     @RC00081                                         02S0094
@RF00081 SLR   @08,@08                                          02S0094
         ST    @08,LISTP                                        02S0094
*   GTSTR15 = GTSTRTCD;    /* GTMN RETURN CODE */               02S0095
@RC00081 L     GTSTR15,GTSTRTCD                                 02S0095
*                                      /* RESTORE LIST PRINT STATUS  */
*     /*GET CORE IN SP253   @YM08667*/                          02S0096
*IF REG15 ^= NOERROR THEN              /*GETMAIN ERROR               */
         LTR   REG15,REG15                                      02S0096
         BZ    @RF00096                                         02S0096
*  DO;                                                          02S0097
*    RETCODE = GETMERR;                                         02S0098
         MVC   RETCODE(4),@CF00160                              02S0098
*    FAILRSC = RSNGET;                                          02S0099
         L     @08,@PC00001                                     02S0099
         L     @08,ALCWAPTR(,@08)                               02S0099
         L     @08,FAILRSCP(,@08)                               02S0099
         MVC   FAILRSC(2,@08),@CH00065                          02S0099
*  END;                                                         02S0100
*ELSE                                                           02S0101
*  DO;                                                          02S0101
         B     @RC00096                                         02S0101
@RF00096 DS    0H                                               02S0102
*    PSOPTCOR = ON;                    /*CORE GOTTEN         @YM08667*/
         OI    PSOPTCOR,B'10000000'                             02S0102
*    OPTPARMP=LISTP+(TWO*PSUCBLEN+PSHDRLEN); /*POINT TO OPTPARMS CORE
*                                                            @YM08667*/
         L     @15,@PC00001+8                                   02S0103
         L     @01,PSPARMP(,@15)                                02S0103
         L     OPTPARMP,PSUCBLEN(,@01)                          02S0103
         ALR   OPTPARMP,OPTPARMP                                02S0103
         AL    OPTPARMP,PSHDRLEN                                02S0103
         AL    OPTPARMP,LISTP                                   02S0103
*    MASKS=CLRMASK;                    /*ZERO MASKS                  */
         MVC   MASKS(2),CLRMASK                                 02S0104
*    UCBPTR = PSUCBLST(1);             /*FIRST UCB IN LIST           */
         L     @08,@PC00001+4                                   02S0105
         L     @08,PSUCBPTR(,@08)                               02S0105
         SLR   @15,@15                                          02S0105
         ICM   @15,3,PSUCBLST(@08)                              02S0105
         ST    @15,UCBPTR                                       02S0105
*    IF UCB3DACC = ON THEN             /*SET DA GENERIC              */
         TM    UCB3DACC(@15),B'00100000'                        02S0106
         BNO   @RF00106                                         02S0106
*      DOINGDA = YES;                                           02S0107
         OI    DOINGDA,B'10000000'                              02S0107
*    IF PSPUB=ON THEN                  /*PUBLIC PROCESSING REQUESTED?*/
@RF00106 L     @08,@PC00001+8                                   02S0108
         L     @08,PSPARMP(,@08)                                02S0108
         TM    PSPUB(@08),B'10000000'                           02S0108
         BNO   @RF00108                                         02S0108
*      DO;                             /*YES,INIT FOR PUBLIC PROCESS */
*        PUBUCB=ON;                    /*INDICATE PUBLIC UCB         */
         OI    PUBUCB,B'00001000'                               02S0110
*        PUBVOL=ON;                    /*INDICATE PUBLIC VOLUME      */
         OI    PUBVOL,B'10000000'                               02S0111
*        COUNTABP=ADDR(PUBLREQS);      /*SET POINTER INTO COUNT TABLE*/
         L     @08,@PC00001                                     02S0112
         L     @08,ALCWAPTR(,@08)                               02S0112
         LA    @08,PUBLREQS(,@08)                               02S0112
         ST    @08,COUNTABP                                     02S0112
*      END;                                                     02S0113
*    ELSE                                                       02S0114
*      IF PSSTRG=ON THEN               /*NO, CHECK FOR STORAGE       */
         B     @RC00108                                         02S0114
@RF00108 L     @08,@PC00001+8                                   02S0114
         L     @08,PSPARMP(,@08)                                02S0114
         TM    PSSTRG(@08),B'01000000'                          02S0114
         BNO   @RF00114                                         02S0114
*        DO;                                                    02S0115
*          STGUCB=ON;                  /*INDICATE STORAGE UCB        */
         OI    STGUCB,B'00000100'                               02S0116
*          STGVOL=ON;                  /*INDICATE STORAGE VOLUME     */
         OI    STGVOL,B'00010000'                               02S0117
*          COUNTABP=ADDR(STRGREQS);    /*SET POINTER INTO COUNT TABLE*/
         L     @08,@PC00001                                     02S0118
         L     @08,ALCWAPTR(,@08)                               02S0118
         LA    @08,STRGREQS(,@08)                               02S0118
         ST    @08,COUNTABP                                     02S0118
*        END;                                                   02S0119
*      ELSE                            /*NOT PUBLIC OR STORAGE       */
*        IF PUBSTOR=ON THEN            /*ASSIGN PUB REQS TO PUB &
*                                        STORAGE VOLUMES ?           */
         B     @RC00114                                         02S0120
@RF00114 L     @08,@PC00001+8                                   02S0120
         L     @08,PSPARMP(,@08)                                02S0120
         TM    PUBSTOR(@08),B'00100000'                         02S0120
         BNO   @RF00120                                         02S0120
*          DO;                         /*YES:                        */
*            STGUCB=ON;                /*INDICATE STORAGE UCB        */
*            PUBUCB = ON;              /*INDICATE PUBLIC UCB,TOO     */
         OI    STGUCB,B'00001100'                               02S0123
*            PUBVOL=ON;                /*INDICATE PUBLIC VOLUME      */
         OI    PUBVOL,B'10000000'                               02S0124
*            COUNTABP=ADDR(PUBLREQS);  /*SET POINTER INTO COUNT TABLE*/
         L     @08,@PC00001                                     02S0125
         L     @08,ALCWAPTR(,@08)                               02S0125
         LA    @08,PUBLREQS(,@08)                               02S0125
         ST    @08,COUNTABP                                     02S0125
*          END;                                                 02S0126
*        ELSE;                                                  02S0127
@RF00120 DS    0H                                               02S0128
*    ARUINDIC=ZERO;                    /*CLEAR FLAGS IN ARU PARMLIST */
@RC00114 DS    0H                                               02S0128
@RC00108 SLR   @08,@08                                          02S0128
         ST    @08,ARUINDIC                                     02S0128
*  END;                                                         02S0129
*SWITCHES = CLEAR;                    /* INITIALIZE SWITCHES         */
@RC00096 MVI   SWITCHES+1,X'00'                                 01S0130
         MVI   SWITCHES,X'00'                                   01S0130
*DO NUMSIOTS=NUMREQS TO 1 BY -1       /*PROCESS ALL SIOTS(REQUESTS)  */
*  WHILE(RETCODE=NOERROR & PSCNTENT>ZERO); /*STOP ON ERROR OR WHEN NO
*                                       MORE REQUESTS IN COUNT TABLE */
         L     @08,@PC00001                                     01S0131
         L     @08,ALCWAPTR(,@08)                               01S0131
         L     @08,NUMREQS(,@08)                                01S0131
         ST    @08,NUMSIOTS                                     01S0131
         B     @DE00131                                         01S0131
@DL00131 SLR   @08,@08                                          01S0131
         C     @08,RETCODE                                      01S0131
         BNE   @DC00131                                         01S0131
         L     @01,COUNTABP                                     01S0131
         C     @08,PSCNTENT(,@01)                               01S0131
         BNL   @DC00131                                         01S0131
*  IF SIOTALCD=OFF &                  /*THIS SIOT ALREADY PROCESSED? */
*    SIOTGIGN=OFF THEN                                          01S0132
         L     @08,SIOTPTR                                      01S0132
         TM    SIOTALCD(@08),B'00000010'                        01S0132
         BNZ   @RF00132                                         01S0132
         TM    SIOTGIGN(@08),B'00001000'                        01S0132
         BNZ   @RF00132                                         01S0132
*    DO;                              /*NO,PROCESS VOLUNIT ENTRIES   */
*      VUPTR=SVOLUNAD;                /*POINT TO FIRST VOLUNIT ENTRY */
         MVC   VUPTR(4),SVOLUNAD(@08)                           01S0134
*      SWITCHES=CLEAR;                /*INITIALIZE SWITCHES          */
         MVI   SWITCHES+1,X'00'                                 01S0135
         MVI   SWITCHES,X'00'                                   01S0135
*      FIRSTALC=OFF;                                            01S0136
         NI    FIRSTALC,B'01111111'                             01S0136
*      EDLFINIS=OFF;                                            01S0137
         NI    EDLFINIS,B'01111111'                             01S0137
*      RELDEVNO = ZERO;               /*INIT RELATIVE DEVICE COUNT   */
         SLR   RELDEVNO,RELDEVNO                                01S0138
*      DO NUMVOLUN=1 TO SVOLUNNO      /*PROCESS SIOTS VOLUNIT ENTRIES*/
*        WHILE(RETCODE=NOERROR & VOLUNOPR=OFF); /*STOP ON ERROR, OR
*                                        WHEN ENTRY CAN'T BE ALLOC'D */
         LA    NUMVOLUN,1                                       01S0139
         B     @DE00139                                         01S0139
@DL00139 SLR   @07,@07                                          01S0139
         C     @07,RETCODE                                      01S0139
         BNE   @DC00139                                         01S0139
         TM    VOLUNOPR,B'00000010'                             01S0139
         BNZ   @DC00139                                         01S0139
*      IF RELDEVNO ^= ZERO |                                    01S0140
*         (RELDEVNO = ZERO &                                    01S0140
*         PARTALOC = OFF) THEN        /*DO NOT SKIP                  */
         CR    RELDEVNO,@07                                     01S0140
         BNE   @RT00140                                         01S0140
         CR    RELDEVNO,@07                                     01S0140
         BNE   @RF00140                                         01S0140
         L     @07,@PC00001+8                                   01S0140
         L     @07,PSPARMP(,@07)                                01S0140
         TM    PARTALOC(@07),B'00000001'                        01S0140
         BNZ   @RF00140                                         01S0140
@RT00140 DS    0H                                               01S0141
*        DO;                                                    01S0141
*          IF VDEVREQD=ON THEN        /*DEVICE REQUIRED BY THIS ENTRY*/
         L     @07,VUPTR                                        01S0142
         TM    VDEVREQD(@07),B'00100000'                        01S0142
         BNO   @RF00142                                         01S0142
*              DO;                    /*YES:                         */
*                RELDEVNO=RELDEVNO+1; /*UPDATE DEVICE COUNT          */
         AH    RELDEVNO,@CH00056                                01S0144
*                IF VOLALOC=OFF THEN  /*ENTRY ALREADY PROCESSED?     */
         TM    VOLALOC(@07),B'10000000'                         01S0145
         BNZ   @RF00145                                         01S0145
*                  IF VOLUMASK =                                01S0146
*                    (VOLSTATA & VOLUMASK)    /*NO, ENT RIGHT TYPE?  */
*                    & VUDNALOC=OFF THEN /*AND OKAY TO ALLOCATE?     */
         MVC   @TS00001(1),VOLSTATA(@07)                        01S0146
         NC    @TS00001(1),VOLUMASK                             01S0146
         CLC   VOLUMASK(1),@TS00001                             01S0146
         BNE   @RF00146                                         01S0146
         TM    VUDNALOC(@07),B'00001000'                        01S0146
         BNZ   @RF00146                                         01S0146
*                    IF DOINGDA = NO |                          01S0147
*                        (DOINGDA = YES & VOLNSHR = OFF) THEN /*OK   */
         TM    DOINGDA,B'10000000'                              01S0147
         BZ    @RT00147                                         01S0147
         TM    DOINGDA,B'10000000'                              01S0147
         BNO   @RF00147                                         01S0147
         TM    VOLNSHR(@07),B'00001000'                         01S0147
         BNZ   @RF00147                                         01S0147
@RT00147 DS    0H                                               01S0148
*                      DO;                                      01S0148
*/********************************************************************/
*/*                                                                  */
*/* SEGMENT NAME - PSVOLUN                                           */
*/*                                                                  */
*/* DESCRIPTIVE NAME - PROCESS NON-SPECIFIC VOLUNIT ENTRIES          */
*/*                                                                  */
*/* FUNCTION                                                         */
*/*   THIS ROUTINE CONTROLS THE PROCESSING OF A NON-SPECIFIC         */
*/*   VOLUNIT ENTRY IN THE FOLLOWING WAYS:                           */
*/*     .IT INCLUDES SUBROUTINE PSLSTMNT TO BUILD OR UPDATE THE      */
*/*      PUBLIC/STORAGE UCB LIST(PSLIST)                             */
*/*     .IF THE PSLIST HAS ENTRIES, THIS ROUTINE CALLS SUBROUTINE    */
*/*      IEFAB44O TO BUILD A LIST OF ALLOCATED UCBS FOR USE BY       */
*/*      IEFAB434.  (THIS LIST WILL NOT BE BUILT IF A                */
*/*      DADSM ERROR OR VOLUME ENQ ERROR OCCURED,                    */
*/*      BECAUSE THE OLD LIST IS STILL VALID, AND WAS,               */
*/*      THEREFORE, NOT FREED BY PSALLOC.) PROVIDING THE LIST IS     */
*/*      BUILT SUCCESSFULLY (OR IF IT ALREADY EXISTS) SUBROUTINE     */
*/*      PSALLOC INTERFACES WITH IEFAB434 IN ORDER TO ALLOCATE THE   */
*/*      REQUEST.                                                    */
*/*     .IF THE PSLIST HAS BECOME NULL BECAUSE THERE WERE NOT ENOUGH */
*/*      ELIGIBLE STORAGE DEVICES TO SATISFY THE REQUEST, A          */
*/*      SUBROUTINE IS CALLED TO CHANGE THE STORAGE REQUEST TO A     */
*/*      PRIVATE REQUEST.                                            */
*/*     .IF THE PSLIST DOES NOT HAVE ANY ENTRIES AS THE RESULT OF A  */
*/*      'SPACE REQUESTED NOT AVAILABLE' DADSM ERROR (DADSM RETURN   */
*/*      CODE HEX 14) AND IF A STORAGE VOLUME WAS BEING PROCESSED, A */
*/*      REASON CODE OF 12 IS SET SO THAT THE 'INSUFFICIENT SPACE ON */
*/*      STORAGE VOLUMES' MESSAGE WILL BE ISSUED. IF A PUBLIC VOLUME */
*/*      WAS BEING PROCESSED OR IF THE PSLIST HAS BECOME NULL        */
*/*      AS THE RESULT OF ANY OTHER DADSM ERROR, THE REASON CODE SET */
*/*      BY IEFAB434 IS NOT ALTERED.                                 */
*/*                                                                  */
*/*     .IF THE DADSM ERROR IS RECOVERABLE,A CHECK IS MADE TO@ZA04836*/
*/*      DETERMINE IF THERE ARE ANY AFFINITIES. IF THERE ARE,@ZA04836*/
*/*      ALL VOLUNIT ENTRIES ASSOCIATED WITH THESE REQUESTS  @ZA04836*/
*/*      ARE MARKED WITH VUDADSME AND VUDNALOC.              @ZA04836*/
*/*                                                                  */
*/* ENTRY -                                                          */
*/*   PSVOLUN- INCLUDED MODULE IN IEFAB436                           */
*/*                                                                  */
*/*   PURPOSE - TO PROCESS NON-SPECIFIC DA VOLUNIT ENTRIES           */
*/*                                                                  */
*/*   INPUT -                                                        */
*/*     POINTER TO CORE FOR PSLIST OR TO PSLIST IF IT ALREADY EXISTS */
*/*     THE VOLUNIT ENTRY BEING PROCESSED                            */
*/*     THE SIOT BEING PROCESSED (THE SIOT CONTAINS PTRS TO THE EDL  */
*/*       AND TO THE NUMBER OF UNITS REMAINING TO BE ALLOCATED)      */
*/*     FLAGS INDICATING IF A PUBLIC OR STORAGE VOLUME IS BEING      */
*/*       PROCESSED                                                  */
*/*                                                                  */
*/* EXITS -                                                          */
*/*                                                                  */
*/*   CONDITION - NORMAL COMPLETION                                  */
*/*                                                                  */
*/*     OUTPUT -                                                     */
*/*       LIST OF ALLOCATED UCBS (ALCUCBLT)                          */
*/*       BUILT OR UPDATED PUBLIC/STORAGE LIST(PSLIST)               */
*/*                                                                  */
*/*     RETURN CODE - 0                                              */
*/*                                                                  */
*/*   CONDITION - ALLOCATED UCB LIST COULD NOT BE BUILT              */
*/*                                                                  */
*/*     OUTPUT -                                                     */
*/*       INDICATORS FOR VOLUNIT ENTRY NOT PROCESSED AND SIOT NOT    */
*/*       COMPLETELY ALLOCATED                                       */
*/*                                                                  */
*/*     RETURN CODE - 4                                              */
*/*                                                                  */
*/*   CONDITION - DADSM ERROR(RETURN CODE X'14') ON STORAGE VOLUME   */
*/*                                                                  */
*/*     OUTPUT -                                                     */
*/*       INDICATORS FOR VOLUNIT ENTRY NOT PROCESSED AND SIOT NOT    */
*/*         COMPLETELY ALLOCATED                                     */
*/*       REASON CODE 12 SET IN SIOT                                 */
*/*                                                                  */
*/*     RETURN CODE - 4                                              */
*/*                                                                  */
*/*   CONDITION - DADSM ERROR(OTHER THAN RETURN CODE X'14') ON       */
*/*               ON STORAGE VOLUME                                  */
*/*                                                                  */
*/*     OUTPUT -                                                     */
*/*       INDICATORS FOR VOLUNIT ENTRY NOT PROCESSED AND SIOT NOT    */
*/*       COMPLETELY ALLOCATED.                                      */
*/*                                                                  */
*/*     RETURN CODE - 4                                              */
*/*                                                          @ZA04836*/
*/*   CONDITION - RECOVERABLE DADSM ERROR ON PUBLIC VOLUME   @ZA04836*/
*/*                                                          @ZA04836*/
*/*     OUTPUT -                                             @ZA04836*/
*/*       DADSM ERROR INDICATORS SETIN ALL VOLUNIT ENTRIES   @ZA04836*/
*/*       WHICH REQUEST AFFINITY                             @ZA04836*/
*/*                                                          @ZA04836*/
*/*       DONT PROCESS UNITL RECOVERY INDICATORS SET IN      @ZA04836*/
*/*       ALL VOLUNIT ENTRIES WHICH REQUEST AFFINITY         @ZA04836*/
*/*                                                                  */
*/*                                                                  */
*/********************************************************************/
*DO WHILE(VOLALOC=OFF & RETCODE=NOERROR & VOLUNOPR=OFF); /*STOP ON
*                                        ERROR,WHEN ALLOCATED OR WHEN
*                                        CAN'T BE ALLOCATED          */
         B     @DE00149                                         02S0149
@DL00149 DS    0H                                               02S0150
*/********************************************************************/
*/*                                                                  */
*/* SEGMENT NAME - PSLSTMNT                                          */
*/*                                                                  */
*/* DESCRIPTIVE NAME - MAINTAIN PSLIST                               */
*/*                                                                  */
*/* FUNCTION -                                                       */
*/*   THIS ROUTINE IS RESPONSIBLE FOR THE CREATION AND UPDATING OF   */
*/*   THE PUBLIC/STORAGE UCB LIST(PSLIST) AS FOLLOWS:                */
*/*     . IF THE PSLIST IS TO BE CREATED, A BUILD SUBROUTINE,        */
*/*       PSLSTBLD, IS INVOKED FOR EACH DEVICE TYPE IN THE EDL. A    */
*/*       FLAG IS SET TO INDICATE THAT THE LIST EXISTS.              */
*/*     . THE PSLIST CAN BE UPDATED IN ONE OF THREE WAYS. (1) FOR    */
*/*       MULTI-UNIT ALLOCATION, AFTER THE FIRST UNIT HAS BEEN       */
*/*       ALLOCATED, THE LIST IS UPDATED SO THAT REMAINING UNITS     */
*/*       WILL BE ALLOCATED FROM THE SAME DEVICE TYPE AS THE FIRST   */
*/*       UNIT. THE UPDATING IS DONE BY THE PSLSTBLD SUBROUTINE.     */
*/*       THE POINTER TO THE EDL ENTRY FOR THE ELIGIBLE DEVICE TYPE  */
*/*       HAS BEEN SET IN PRIOR PROCESSING IN THE PSFNDEDL ROUTINE   */
*/*       SO IT IS NOT RESET BY THIS ROUTINE BEFORE PSLSTBLD IS      */
*/*       CALLED. ON RETURN FROM PSLSTBLD, THE EDL IS UPDATED SO     */
*/*       THAT ALL EDL ENTRIES EXCEPT THE ONE FOR THE GENERIC JUST   */
*/*       ALLOCATED ARE MARKED INELIGIBLE. (2) THE PSLIST CAN ALSO BE*/
*/*       UPDATED BY ELIMINATING AN ENTRY THAT WAS JUST PROCESSED.   */
*/*       THIS IS DONE FOR A MULTI-UNIT REQUEST WHEN THE PSLIST      */
*/*       ALREADY CONTAINS ENTRIES FOR JUST ONE GENERIC. (3) IF      */
*/*       A DADSM ERROR OCCURS, THE ENTRY FOR WHICH THE ERROR        */
*/*       OCCURRED IS EXCHANGED WITH THE LAST ENTRY IN THE LIST.     */
*/*       SINCE THE INDEX INTO THE PSLIST HAS BEEN DECREMENTED, THIS */
*/*       ENTRY WILL NOT BE CONSIDERED FOR FUTURE ALLOCATION UNTIL   */
*/*       SPACE HAS BEEN ASSIGNED TO ANOTHER UNIT VIA DADSM. WHEN    */
*/*       SPACE HAS BEEN GOTTEN, THE ORIGINAL INDEX IS RESTORED SO   */
*/*       THAT ALL ENTRIES CAN NOW BE CONSIDERED IF THIS IS A MULTI- */
*/*       UNIT REQUEST. (THIS IS POSSIBLE BECAUSE SPACE IS ONLY      */
*/*       ASSIGNED ONCE FOR MULTI-UNIT REQUESTS.                     */
*/*                                                                  */
*/* ENTRY - PSLSTMNT(INCLUDED SEGMENT IN PSVOLUN)                    */
*/*                                                                  */
*/*   PURPOSE - TO BUILD AND MAINTAIN THE PUBLIC/STORAGE LIST(PSLIST)*/
*/*                                                                  */
*/*   INPUT -                                                        */
*/*     POINTER TO CORE FOR PSLIST OR TO PSLIST IF IT ALREADY EXISTS */
*/*     PSLEXIST SWITCH - ON IF PSLIST ALREADY EXISTS                */
*/*     PTR TO THE EDL GENERIC ENTRY JUST ALLOCATED                  */
*/*                                                                  */
*/* EXITS -                                                          */
*/*                                                                  */
*/*   CONDITION - NORMAL COMPLETION                                  */
*/*                                                                  */
*/*     OUTPUT -                                                     */
*/*       BUILT OR UPDATED PUBLIC/STORAGE UCB LIST(PSLIST)           */
*/*       UPDATED EDL ENTRIES IF PROCESSING FOR ONE GENERIC ONLY     */
*/*                                                                  */
*/*     RETURN CODE - N/A                                            */
*/*                                                                  */
*/********************************************************************/
* DO; /*MODESET  KEYADDR(ZERO)*/                                03S0150
*   SPKA (ZERO); /*SET PSW KEY*/                                03S0151
         SLR   @07,@07                                          03S0151
         SPKA  0(@07)                                           03S0151
* END; /*MODESET  KEYADDR(ZERO)*/                               03S0152
*PSLISTP = LISTP;                      /*PTR TO CAND LIST FOR OPT    */
         MVC   PSLISTP(4,OPTPARMP),LISTP                        03S0153
*IF PSLEXIST=OFF THEN                  /*PUBLIC/STORAGE LIST BUILT?  */
         TM    PSLEXIST,B'00100000'                             03S0154
         BNZ   @RF00154                                         03S0154
*  DO;                                 /*NO,BUILD LIST               */
*    EDLPTR=EDLFGENP;                  /*POINT TO FIRST EDL ENTRY    */
         L     @07,SIOTPTR                                      03S0156
         L     @07,SIOTEDLP(,@07)                               03S0156
         L     EDLPTR,EDLFGENP(,@07)                            03S0156
*    PSLINDEX=1;                       /*INIT INDEX INTO PSLIST      */
         LA    PSLINDEX,1                                       03S0157
*    DO WHILE(EDLPTR^=TABEND);         /*PROCESS ALL EDL DEVICE TYPES*/
         B     @DE00158                                         03S0158
@DL00158 DS    0H                                               03S0159
*      SAVENDEX = PSLINDEX;            /*SAVE CURRENT INDEX          */
         LR    SAVENDEX,PSLINDEX                                03S0159
*      CALL PSLSTBLD;                  /*BUILD LIST FOR DEVICE TYPE  */
         BAL   @14,PSLSTBLD                                     03S0160
*      IF (PSLINDEX-SAVENDEX)<SIOPSCNT & /*ENOUGH UNITS IN LST  03S0161
*                                        FOR REQUEST?                */
*         PARTALOC=OFF &                                        03S0161
*         EDLMGENS=OFF THEN                                     03S0161
         LR    @07,PSLINDEX                                     03S0161
         SLR   @07,SAVENDEX                                     03S0161
         L     @15,SIOTPTR                                      03S0161
         SLR   @14,@14                                          03S0161
         IC    @14,SIOPSCNT(,@15)                               03S0161
         CR    @07,@14                                          03S0161
         BNL   @RF00161                                         03S0161
         L     @14,@PC00001+8                                   03S0161
         L     @01,PSPARMP(,@14)                                03S0161
         TM    PARTALOC(@01),B'00000001'                        03S0161
         BNZ   @RF00161                                         03S0161
         L     @01,SIOTEDLP(,@15)                               03S0161
         TM    EDLMGENS(@01),B'01000000'                        03S0161
         BNZ   @RF00161                                         03S0161
*           DO;                                                 03S0162
*             IF LGENLOCK=EDLDEVT THEN   /*ALLOCATING BY GENERIC     */
         L     @15,@PC00001                                     03S0163
         L     @01,ALCWAPTR(,@15)                               03S0163
         CLC   LGENLOCK(4,@01),EDLDEVT(EDLPTR)                  03S0163
         BNE   @RF00163                                         03S0163
*               EDLNSCNT=PSLINDEX-SAVENDEX;  /*SAVE # OF UNITS IN GEN*/
         STH   @07,EDLNSCNT(,EDLPTR)                            03S0164
*             PSLINDEX = SAVENDEX;     /*NO,DEL THIS DEVTYPE FROM LST*/
@RF00163 LR    PSLINDEX,SAVENDEX                                03S0165
*             PSLISTNO = PSLINDEX-1;   /*RESTORE NO. PSLIST ENTRIES  */
         L     @07,PSLISTP(,OPTPARMP)                           03S0166
         LR    @03,PSLINDEX                                     03S0166
         BCTR  @03,0                                            03S0166
         ST    @03,PSLISTNO(,@07)                               03S0166
*           END;                                                03S0167
*      EDLPTR=EDLNXTNT;                /*POINT TO NEXT DEVICE TYPE   */
@RF00161 L     EDLPTR,EDLNXTNT(,EDLPTR)                         03S0168
*    END;                                                       03S0169
@DE00158 LTR   EDLPTR,EDLPTR                                    03S0169
         BNZ   @DL00158                                         03S0169
*    PSLEXIST=ON;                      /*INDICATE LIST EXISTS        */
         OI    PSLEXIST,B'00100000'                             03S0170
*  END;                                                         03S0171
*ELSE                                  /*LIST WAS BUILT - UPDATE IT  */
*  IF PSLUPDAT=OFF & DADSMESW=OFF &    /*ELIMINATE OTHER DEV TYPES?  */
*    ENQERROR=OFF & EDLMGENS = OFF THEN                         03S0172
         B     @RC00154                                         03S0172
@RF00154 TM    PSLUPDAT,B'01011000'                             03S0172
         BNZ   @RF00172                                         03S0172
         L     @07,SIOTPTR                                      03S0172
         L     @07,SIOTEDLP(,@07)                               03S0172
         TM    EDLMGENS(@07),B'01000000'                        03S0172
         BNZ   @RF00172                                         03S0172
*      DO;                             /*YES,REBUILD LIST            */
*        EDLFINIS = OFF;               /*INDICATE EDL UPDATED        */
         NI    EDLFINIS,B'01111111'                             03S0174
*        PSLINDEX=1;                   /*INIT INDEX INTO PSLIST      */
         LA    PSLINDEX,1                                       03S0175
*        CALL PSLSTBLD;                /*REBUILD LIST FOR ONE GENERIC*/
         BAL   @14,PSLSTBLD                                     03S0176
*        PSLUPDAT=ON;                  /*INDICATE ONE GENERIC IN LIST*/
         OI    PSLUPDAT,B'00010000'                             03S0177
*        EDLPSAVE=EDLPTR;              /*SAVE PTR TO EDL ENTRY       */
         LR    EDLPSAVE,EDLPTR                                  03S0178
*        EDLPTR=EDLFGENP;              /*POINT TO FIRST EDL          */
         L     @07,SIOTPTR                                      03S0179
         L     @07,SIOTEDLP(,@07)                               03S0179
         L     EDLPTR,EDLFGENP(,@07)                            03S0179
*        DO WHILE(EDLPTR^=ZERO);       /*MARK EDL ENTRIES FOR ALL
*                                        GENERICS BUT ONE INELIGIBLE */
         B     @DE00180                                         03S0180
@DL00180 DS    0H                                               03S0181
*          IF EDLPTR^=EDLPSAVE THEN    /*EDL FOR ELIGIBLE GENERIC?   */
         CR    EDLPTR,EDLPSAVE                                  03S0181
         BE    @RF00181                                         03S0181
*            EINDEVTP=ON;              /*NO,MARK EDL INELIGIBLE      */
         OI    EINDEVTP(EDLPTR),B'10000000'                     03S0182
*          EDLPTR=EDLNXTNT;            /*POINT TO NEXT EDL ENTRY     */
@RF00181 L     EDLPTR,EDLNXTNT(,EDLPTR)                         03S0183
*        END;                                                   03S0184
@DE00180 LTR   EDLPTR,EDLPTR                                    03S0184
         BNZ   @DL00180                                         03S0184
*      EDLPTR=EDLPSAVE;                /*RESTORE EDL PTR             */
         LR    EDLPTR,EDLPSAVE                                  03S0185
*    END;                                                       03S0186
*  ELSE                                /*NO,REMOVE ENTRY LAST PROCESS*/
*    DO;                                                        03S0187
         B     @RC00172                                         03S0187
@RF00172 DS    0H                                               03S0188
*      PSLISTNO=PSLISTNO-1;            /*DECREMENT INDEX BY ONE      */
         L     @07,PSLISTP(,OPTPARMP)                           03S0188
         L     @15,PSLISTNO(,@07)                               03S0188
         BCTR  @15,0                                            03S0188
         ST    @15,PSLISTNO(,@07)                               03S0188
*      IF PSLISTNO^=ZERO THEN          /*LAST PSLIST ENTRY?          */
         LTR   @15,@15                                          03S0189
         BZ    @RF00189                                         03S0189
*        DO;                                                    03S0190
*          PSLINDEX=((OPTDEVP-PSLISTP)/PSENTLN); /*SET INDEX TO ENT
*                                                  JUST PROCESSED    */
         LR    @00,@07                                          03S0191
         LCR   @00,@00                                          03S0191
         AL    @00,OPTDEVP(,OPTPARMP)                           03S0191
         SRDA  @00,32                                           03S0191
         LH    PSLINDEX,PSENTLN                                 03S0191
         DR    @00,PSLINDEX                                     03S0191
         LR    PSLINDEX,@01                                     03S0191
*          IF DADSMESW=OFF THEN        /*DADSM ERROR?                */
         TM    DADSMESW,B'00001000'                             03S0192
         BNZ   @RF00192                                         03S0192
*            DO PSLINDEX TO PSLISTNO;  /*NO,REMOVE LAST ENT PROCESSED*/
         B     @DE00193                                         03S0193
@DL00193 DS    0H                                               03S0194
*              PSLSTENT(PSLINDEX)=PSLSTENT(PSLINDEX+1); /*MOVE ENTRY */
         LR    @07,PSLINDEX                                     03S0194
         SLA   @07,2                                            03S0194
         L     @03,PSLISTP(,OPTPARMP)                           03S0194
         L     @15,PSLSTENT(@07,@03)                            03S0194
         ST    @15,PSLSTENT-4(@07,@03)                          03S0194
*            END;                                               03S0195
         AH    PSLINDEX,@CH00056                                03S0195
@DE00193 L     @07,PSLISTP(,OPTPARMP)                           03S0195
         C     PSLINDEX,PSLISTNO(,@07)                          03S0195
         BNH   @DL00193                                         03S0195
*          ELSE                        /*YES, DADSM ERROR            */
*            DO;                       /*EXCHANGE BAD ENT WITH LAST
*                                        ENTRY BY USING EXCLUSIVE ORS*/
         B     @RC00192                                         03S0196
@RF00192 DS    0H                                               03S0197
*              PSLSTENT(PSLINDEX)=                              03S0197
*                PSLSTENT(PSLINDEX) && PSLSTENT(PSLISTNO+1);    03S0197
         LR    @07,PSLINDEX                                     03S0197
         SLA   @07,2                                            03S0197
         L     @03,PSLISTP(,OPTPARMP)                           03S0197
         L     @15,PSLISTNO(,@03)                               03S0197
         SLA   @15,2                                            03S0197
         L     @14,PSLSTENT-4(@07,@03)                          03S0197
         X     @14,PSLSTENT(@15,@03)                            03S0197
         ST    @14,PSLSTENT-4(@07,@03)                          03S0197
*              PSLSTENT(PSLISTNO+1)=                            03S0198
*                PSLSTENT(PSLISTNO+1) && PSLSTENT(PSLINDEX);    03S0198
         X     @14,PSLSTENT(@15,@03)                            03S0198
         ST    @14,PSLSTENT(@15,@03)                            03S0198
*              PSLSTENT(PSLINDEX)=                              03S0199
*                PSLSTENT(PSLINDEX) && PSLSTENT(PSLISTNO+1);    03S0199
         X     @14,PSLSTENT-4(@07,@03)                          03S0199
         ST    @14,PSLSTENT-4(@07,@03)                          03S0199
*            END;                                               03S0200
*        END;                                                   03S0201
@RC00192 DS    0H                                               03S0202
*    END;                                                       03S0202
@RF00189 DS    0H                                               03S0203
* DO; /*MODESET  EXTKEY(SCHED)*/                                03S0203
@RC00172 DS    0H                                               03S0203
@RC00154 DS    0H                                               03S0204
*   SPKA (16); /*SET PSW KEY*/                                  03S0204
         LA    @07,16                                           03S0204
         SPKA  0(@07)                                           03S0204
* END; /*MODESET  EXTKEY(SCHED)*/                               03S0205
*  IF PSLISTNO^=ZERO THEN              /*ANY ENTRIES IN PUB/STG LIST?*/
         L     @07,PSLISTP(,OPTPARMP)                           02S0206
         ICM   @15,15,PSLISTNO(@07)                             02S0206
         BZ    @RF00206                                         02S0206
*    DO;                                                        02S0207
*      IF REUSESW=OFF THEN             /*YES,REUSE PREVIOUS ALUCBLT? */
         TM    REUSESW,B'00000001'                              02S0208
         BNZ   @RF00208                                         02S0208
*        DO;                           /*NO:                         */
*          CALL IEFAB440(ALCWAPTR,ALCUCBP,ALCULEN); /*BUILD ALLOCATED
*                                                     UCB LIST       */
         L     @07,@PC00001                                     02S0210
         ST    @07,@AL00001                                     02S0210
         LA    @07,ALCUCBP(,OPTPARMP)                           02S0210
         ST    @07,@AL00001+4                                   02S0210
         LA    @07,ALCULEN                                      02S0210
         ST    @07,@AL00001+8                                   02S0210
         L     @15,@CV00964                                     02S0210
         LA    @01,@AL00001                                     02S0210
         BALR  @14,@15                                          02S0210
*          RETCODE=REG15;              /*SAVE RETURN CODE            */
         ST    REG15,RETCODE                                    02S0211
*        END;                                                   02S0212
*      ELSE                            /*ALCUCBLT ALREADY EXISTS     */
*        REUSESW=OFF;                  /*RESET REUSE SLCUCBLT SWITCH */
         B     @RC00208                                         02S0213
@RF00208 NI    REUSESW,B'11111110'                              02S0213
*      IF RETCODE = ZERO THEN          /*LIST BUILT SUCCESSFULLY OR
*                                        ALREADY EXISTS?             */
@RC00208 SLR   @07,@07                                          02S0214
         C     @07,RETCODE                                      02S0214
         BNE   @RF00214                                         02S0214
*        DO;                           /*YES:                        */
*/********************************************************************/
*/*                                                                  */
*/* SEGMENT NAME - PSALLOC                                           */
*/*                                                                  */
*/* DESCRIPTIVE NAME - ALLOCATE NON-SPECIFIC REQUEST                 */
*/*                                                                  */
*/* FUNCTION -                                                       */
*/*   THIS ROUTINE INTERFACES WITH THE SYS RESOURCES MGR (OPTIMIZER) */
*/*   AND WITH THE ALLOCATE REQUEST TO UNIT ROUTINE (IEFAB434) IN    */
*/*   ORDER TO ALLOCATE NON-SPECIFIC VOLUNIT ENTRIES. IT HAS THE     */
*/*   FOLLOWING FUNCTIONS:                                           */
*/*     .SELECTION OF AN OPTIMUM DEVICE OUT OF THE PSLIST BY         */
*/*      INVOKING THE SYSTEM RESOURCES MANAGER. A 2-WORD RETURN      */
*/*      AREA IS FILLED IN BY THE OPTIMIZER.                         */
*/*      IF A DEVICE IS SELECTED, THE FIRST WORD CONTAINS A POINTER  */
*/*      TO THE UCB ADDRESS IN PSLIST OF THE SELECTED DEVICE. THE    */
*/*      SECOND WORD EQUALS ZERO. OTHERWISE, THE FIRST WORD EQUALS   */
*/*      ZERO AND THE SECOND WORD CONTAINS AN ERROR REASON CODE.     */
*/*     .IF A NON-SPECIFIC REQUEST IS ALLOCATED TO A NON PERMRES/    */
*/*      RESVD DEVICE A CONDITIONAL ENQ ON THE VOLUME SERIAL NUMBER  */
*/*      IS DONE (BY INVOKING IEFAB4F0). IF THE ENQ IS NOT           */
*/*      SUCCESSFUL, ANOTHER CANDIDATE WILL BE CHOSEN.               */
*/*     .INVOKING IEFAB434 TO ALLOCATE THE UNIT. PARAMETERS PASSED   */
*/*      INCLUDE THE RELATIVE POSITION IN THE ETIOT FOR THIS UNIT,   */
*/*      THE UNIT'S GROUP ID, AN INDICATION OF WHETHER TO UPDATE OR  */
*/*      CREATE THE ETIOT, AND, IF THE ETIOT IS TO BE CREATED, THE   */
*/*      NUMBER OF DEVICE ENTRIES NEEDED.                            */
*/*     .IF THE ALLOCATION IS SUCCESSFUL, MARKING THE VOLUNIT AND    */
*/*      EDL UCB ENTRIES ALLOCATED. ALSO, APPROPRIATE FIELDS IN THE  */
*/*      COUNT TABLE ARE DECREMENTED. THIS PROCESSING IS ALSO DONE   */
*/*      IF RETURN CODES 32 OR 36 ARE RECEIVED FROM IEFAB434 BECAUSE */
*/*      THESE RETURN CODES DO NOT INDICATE AN ERROR IN THE REQUEST  */
*/*      BEING PROCESSED. THEY INDICATE AN ERROR IN A DD REQUESTING  */
*/*      AFFINITY TO THE REQUEST BEING PROCESSED. IF THE RETURN CODE */
*/*      IS 36, THE RETCODE FIELD IS SET TO 36 SO THAT PROCESSING    */
*/*      WILL NOT CONTINUE. IF THE RETURN CODE IS 32, THE RETCODE    */
*/*      FIELD IS LEFT AT ZERO, AND A REASON CODE IS SET TO INDICATE */
*/*      A DADSM ERROR DURING AFFINITY PROCESSING.                   */
*/*     .IF THE ALLOCATION FAILS BECAUSE OF A DADSM ERROR            */
*/*      OR VOLUME ENQ ERROR, SETTING A FLAG                         */
*/*      TO INDICATE THAT THE PSLIST MUST BE UPDATED TO              */
*/*      ELIMINATE AN ENTRY. FOR OTHER ERRORS, A REASON CODE IS SET  */
*/*      AND AN ERROR RETURN CODE IS RETURNED TO THE CALLER.         */
*/*     .FREEING THE CORE CONTAINING THE LIST OF ALLOCATED UCBS      */
*/*      (ALCUCBLT) BUILT BY IEFAB440 FOR USE BY THE SYSTEM RESOURCES*/
*/*      MANAGER. (THE CORE IS NOT FREED IF A DADSM ERROR            */
*/*      OCCURRED IN ORDER THAT THE LIST MAY BE REUSED.)             */
*/*                                                                  */
*/* ENTRY - PSALLOC (INCLUDED SEGMENT IN PSVOLUN)                    */
*/*                                                                  */
*/*   PURPOSE -                                                      */
*/*     TO INTERFACE WITH THE SYSTEM RESOURCES MANAGER AND           */
*/*     IEFAB434.                                                    */
*/*                                                                  */
*/*   INPUT -                                                        */
*/*     PSLIST                                                       */
*/*     LIST OF ALLOCATED UCBS(ALCUCBLT)                             */
*/*                                                                  */
*/* EXITS -                                                          */
*/*                                                                  */
*/*   CONDITION - SUCCESSFUL ALLOCATION                              */
*/*                                                                  */
*/*   OUTPUT -                                                       */
*/*     ALLOCATED UNIT FOR VOLUNIT ENTRY                             */
*/*     POINTER TO EDL ENTRY FOR ALLOCATED UNIT                      */
*/*     FREED CORE FOR ALCUCBLT UNLESS A DADSM ERROR OCCURRED        */
*/*     EDL UCB ENTRY MARKED ALLOCATED                               */
*/*     VOLUNIT ENTRY MARKED ALLOCATED                               */
*/*     VOLUME SERIAL ENQ'D                                          */
*/*                                                                  */
*/*   RETURN CODE - 0                                                */
*/*                                                                  */
*/*   CONDITION - DADSM ERROR                                        */
*/*                                                                  */
*/*   OUTPUT -                                                       */
*/*     SWITCH SET TO INDICATE THAT PSLIST MUST BE UPDATED           */
*/*                                                                  */
*/*   RETURN CODE -                                                  */
*/*     A RETURN CODE OF 12 IS RECEIVED FROM IEFAB434, A RETURN      */
*/*     CODE OF 0 IS RETURNED TO THE CALLER                          */
*/*                                                                  */
*/*   CONDITION - GETMAIN ERROR                                      */
*/*                                                                  */
*/*   OUTPUT - REASON CODE 2                                         */
*/*                                                                  */
*/*   RETURN CODE - 4                                                */
*/*                                                                  */
*/*   CONDITION - SYSTEM RESOURCES MANAGER ERROR                     */
*/*                                                                  */
*/*   OUTPUT - REASON CODE 9                                         */
*/*                                                                  */
*/*   RETURN CODE - 8                                                */
*/*                                                                  */
*/*   CONDITION - RECOVERABLE DADSM ERROR DURING AFFINITY            */
*/*     PROCESSING (RETURN CODE 32 FROM IEFAB434)                    */
*/*                                                                  */
*/*   OUTPUT -                                                       */
*/*     ALLOCATED UNIT FOR VOLUNIT ENTRY                             */
*/*     EDL UCB ENTRY MARKED ALLOCATED                               */
*/*     VOLUNIT ENTRY MARKED ALLOCATED                               */
*/*     SIOT MARKED ALLOCATED IF LAST VOLUNIT ENTRY FOR DD ALLOCATED */
*/*     TOTREQS FIELD IN COUNT TABLE DECREMENTED IF SIOT ALLOCATED   */
*/*     FREED CORE FOR ALCUCBLT                                      */
*/*     REASON CODE 8                                                */
*/*                                                                  */
*/*   RETURN CODE - 0                                                */
*/*                                                                  */
*/*   CONDITION - ERROR OTHER THAN RECOVERABLE DADSM DURING          */
*/*     AFFINITY PROCESSING (RETURN CODE 36 FROM IEFAB434)           */
*/*                                                                  */
*/*   OUTPUT -                                                       */
*/*     ALLOCATED UNIT FOR VOLUNIT ENTRY                             */
*/*     EDL UCB ENTRY MARKED ALLOCATED                               */
*/*     VOLUNIT ENTRY MARKED ALLOCATED                               */
*/*     SIOT MARKED ALLOCATED IF LAST VOLUNIT ENTRY FOR DD ALLOCATED */
*/*     TOTREQS FIELD IN COUNT TABLE DECREMENTED IF SIOT ALLOCATED   */
*/*     FREED CORE FOR ALCUCBLT                                      */
*/*                                                                  */
*/*   RETURN CODE - 36                                               */
*/*                                                                  */
*/*   CONDITION - TAPE VALIDITY CHECK ERROR (RETURN CODE     @ZA04112*/
*/*               40 FROM IEFAB434)                          @ZA04112*/
*/*                                                          @ZA04112*/
*/*   OUTPUT -                                               @ZA04112*/
*/*     ALLOCATED UNIT FOR VOLUNIT ENTRY                     @ZA04112*/
*/*     EDL UCB ENTRY MARKED ALLOCATED                       @ZA04112*/
*/*     VOLUNIT ENTRY MARKED ALLOCATED                       @ZA04112*/
*/*     SIOT MARKED ALLOCATED IF LAST VOLUNIT ENTRY FOR      @ZA04112*/
*/*       DD ALLOCATED                                       @ZA04112*/
*/*     TOTREQS FIELD IN COUNT TABLE DECREMENTED IF SIOT     @ZA04112*/
*/*       ALLOCATED                                          @ZA04112*/
*/*     FREED CORE FOR ALCUCBLT                              @ZA04112*/
*/*     VOLUNIT ENTRIES IN AFFINITY CHAIN MARKED FOR         @ZA04112*/
*/*       RECOVERY                                           @ZA04112*/
*/*                                                                  */
*/*   RETURN CODE - 40                                       @ZA04112*/
*/*                                                                  */
*/********************************************************************/
*VOLUMENQ=OFF;                                                  03S0216
*VOLUMEDQ=OFF;                                                  03S0217
         NI    VOLUMENQ,B'00111111'                             03S0217
*ENQERROR=OFF;                                                  03S0218
*DADSMESW=OFF;                         /*INIT DADSM ERROR SWITCH     */
         NI    ENQERROR,B'10110111'                             03S0219
* DO; /*MODESET  KEYADDR(ZERO)*/                                03S0220
*   SPKA (ZERO); /*SET PSW KEY*/                                03S0221
         SPKA  0(@07)                                           03S0221
* END; /*MODESET  KEYADDR(ZERO)*/                               03S0222
*IF PSLISTNO ^= ONE THEN               /*MORE THAN 1 CANDIDATE       */
         L     @07,PSLISTP(,OPTPARMP)                           03S0223
         CLC   PSLISTNO(4,@07),@CF00056                         03S0223
         BE    @RF00223                                         03S0223
*  DO;                                                          03S0224
*    RETPARMP = ADDR(RETAREA);                                  03S0225
         LA    @07,RETAREA(,OPTPARMP)                           03S0225
         ST    @07,RETPARMP(,OPTPARMP)                          03S0225
*    RFY (REG1) RSTD;                                           03S0226
*    REG1 = OPTPARMP;                                           03S0227
         LR    REG1,OPTPARMP                                    03S0227
*    GEN(SYSEVENT DEVALLOC);           /*CALL OPTIMIZER              */
         SYSEVENT DEVALLOC
*    RFY (REG1) UNRSTD;                                         03S0229
*  END;                                                         03S0230
*ELSE                                  /*ONLY 1 CANDIDATE            */
*  OPTDEVP = PSLISTP + PSHDRLEN;       /*POINT TO ONLY CANDIDATE     */
         B     @RC00223                                         03S0231
@RF00223 L     @07,PSLISTP(,OPTPARMP)                           03S0231
         AL    @07,PSHDRLEN                                     03S0231
         ST    @07,OPTDEVP(,OPTPARMP)                           03S0231
* DO; /*MODESET  EXTKEY(SCHED)*/                                03S0232
@RC00223 DS    0H                                               03S0233
*   SPKA (16); /*SET PSW KEY*/                                  03S0233
         LA    @07,16                                           03S0233
         SPKA  0(@07)                                           03S0233
* END; /*MODESET  EXTKEY(SCHED)*/                               03S0234
*IF OPTDEVP^=ZERO THEN                 /*DEVICE SELECTED?            */
         L     @07,OPTDEVP(,OPTPARMP)                           03S0235
         LTR   @07,@07                                          03S0235
         BZ    @RF00235                                         03S0235
*  DO;                                 /*YES,SET UP TO ALLOCATE      */
*    PSLINDEX=((OPTDEVP-PSLISTP)/PSENTLN); /*SET INDEX TO OPTIMUM ENT*/
         L     @15,PSLISTP(,OPTPARMP)                           03S0237
         LR    @00,@07                                          03S0237
         SLR   @00,@15                                          03S0237
         SRDA  @00,32                                           03S0237
         LH    PSLINDEX,PSENTLN                                 03S0237
         DR    @00,PSLINDEX                                     03S0237
         LR    PSLINDEX,@01                                     03S0237
*    UCBPTR=PSLSTENT(PSLINDEX);        /*SET UCB PTR TO OPTIMUM DEV  */
         LR    @07,PSLINDEX                                     03S0238
         SLA   @07,2                                            03S0238
         L     @07,PSLSTENT-4(@07,@15)                          03S0238
         ST    @07,UCBPTR                                       03S0238
*/********************************************************************/
*/*                                                                  */
*/* SEGMENT NAME - PSFNDEDL                                          */
*/*                                                                  */
*/* DESCRIPTIVE NAME - FIND EDL ENTRY                                */
*/*                                                                  */
*/* FUNCTION -                                                       */
*/*   THIS ROUTINE FINDS THE EDL ENTRY WHICH CONTAINS A PTR TO THE   */
*/*   OPTIMUM DEVICE UCB. WHEN THE EDL ENTRY IS FOUND,THE GROUP ID OF*/
*/*   THE OPTIMUM DEVICE IS SAVED SO THAT PSALLOC MAY PASS THE ID    */
*/*   TO THE ALLOCATE REQUEST ROUTINE. THE POINTER TO THE EDL UCB    */
*/*   LIST AND THE INDEX INTO THE LIST ARE USED LATER BY PSALLOC     */
*/*   TO SET BITS IN THE EDL. THE POINTER TO THE EDL IS USED BY      */
*/*   PSLSTBLD WHEN THE PSLIST IS UPDATED TO CONTAIN ENTRIES FOR     */
*/*   ONLY ONE GENERIC DEVICE TYPE                                   */
*/*                                                                  */
*/* ENTRY - PSFNDEDL (INCLUDED SEGMENT IN PSALLOC)                   */
*/*                                                                  */
*/*   PURPOSE - TO FIND THE EDL ENTRY WHICH CONTAINS A PTR TO THE UCB*/
*/*     SELECTED FOR ALLOCATION BY THE SYSTEM RESOURCES MANAGER      */
*/*                                                                  */
*/*   INPUT -                                                        */
*/*     PTR TO UCB SELECTED FOR ALLOCATION                           */
*/*     PTR TO EDL                                                   */
*/*                                                                  */
*/* EXIT -                                                           */
*/*                                                                  */
*/*   CONDITION - EDL ENTRY FOR SELECTED DEVICE FOUND                */
*/*                                                                  */
*/*   OUTPUT -                                                       */
*/*     GROUP ID OF SELECTED DEVICE                                  */
*/*     PTR TO UCB LIST  IN EDL  CONTAINING UCB ADDR OF SELECTED DEV */
*/*     INDEX INTO UCB LIST FOR SELECTED DEVICE ADDR                 */
*/*     PTR TO GENERIC EDL ENTRY FOR SELECTED DEVICE                 */
*/*                                                                  */
*/*   RETURN CODE - 0                                                */
*/*                                                                  */
*/********************************************************************/
*EDLPTR=EDLFGENP;                      /*PT TO 1ST EDL GENERIC ENTRY */
         L     @07,SIOTPTR                                      04S0239
         L     @07,SIOTEDLP(,@07)                               04S0239
         L     EDLPTR,EDLFGENP(,@07)                            04S0239
*UCBMATCH=OFF;                         /*INIT LOOP CONTROL SWITCH    */
         NI    UCBMATCH,B'01111111'                             04S0240
*DO WHILE(UCBMATCH=OFF & EDLPTR^=ZERO);                         04S0241
         B     @DE00241                                         04S0241
@DL00241 DS    0H                                               04S0242
*  EDLGNTP=EDLGRPTR;                   /*POINT TO EDL GROUP ENTRY    */
         L     EDLGNTP,EDLGRPTR(,EDLPTR)                        04S0242
*  DO EDLINDX1=1 TO EDLGRPNO WHILE(UCBMATCH=OFF); /*SEARCH GROUP ENTS*/
         LA    EDLINDX1,1                                       04S0243
         B     @DE00243                                         04S0243
@DL00243 TM    UCBMATCH,B'10000000'                             04S0243
         BNZ   @DC00243                                         04S0243
*    EDLUCBLP=EDLLISTP;                /*POINT TO UCB LIST FOR GROUP */
         MVC   EDLUCBLP(4),EDLLISTP(EDLGNTP)                    04S0244
*    DO EDLINDEX=1 TO EDLUCBNO WHILE(UCBMATCH=OFF); /*SEARCH UCB LIST*/
         LA    @02,1                                            04S0245
         B     @DE00245                                         04S0245
@DL00245 TM    UCBMATCH,B'10000000'                             04S0245
         BNZ   @DC00245                                         04S0245
*      IF UCBPTR=EDLUCBAD(EDLINDEX) THEN /*MATCH?                    */
         SLA   @02,2                                            04S0246
         L     @01,EDLUCBLP                                     04S0246
         ALR   @01,@02                                          04S0246
         AL    @01,@CF01109                                     04S0246
         SLR   @02,@02                                          04S0246
         ICM   @02,3,EDLUCBAD(@01)                              04S0246
         C     @02,UCBPTR                                       04S0246
         BNE   @RF00246                                         04S0246
*        DO;                                                    04S0247
*          ARUGRPID=EDLGRID;           /*SAVE GROUP ID OF UCB        */
         MVC   ARUGRPID(4),EDLGRID(EDLGNTP)                     04S0248
*          UCBMATCH=ON;                /*INDICATE MATCH FOUND        */
         OI    UCBMATCH,B'10000000'                             04S0249
*        END;                                                   04S0250
*    END;                                                       04S0251
@RF00246 LA    @02,1                                            04S0251
         AL    @02,EDLINDEX                                     04S0251
@DE00245 ST    @02,EDLINDEX                                     04S0251
         C     @02,EDLUCBNO(,EDLGNTP)                           04S0251
         BNH   @DL00245                                         04S0251
@DC00245 DS    0H                                               04S0252
*    IF UCBMATCH=OFF THEN              /*MATCH FOUND?                */
         TM    UCBMATCH,B'10000000'                             04S0252
         BNZ   @RF00252                                         04S0252
*      EDLGNTP=EDLNXGRP;               /*NO,POINT TO NEXT GROUP      */
         L     EDLGNTP,EDLNXGRP(,EDLGNTP)                       04S0253
*  END;                                                         04S0254
@RF00252 AL    EDLINDX1,@CF00056                                04S0254
@DE00243 C     EDLINDX1,EDLGRPNO(,EDLPTR)                       04S0254
         BNH   @DL00243                                         04S0254
@DC00243 DS    0H                                               04S0255
*  IF UCBMATCH=OFF THEN                /*MATCH FOUND?                */
         TM    UCBMATCH,B'10000000'                             04S0255
         BNZ   @RF00255                                         04S0255
*    EDLPTR=EDLNXTNT;                  /*NO,POINT TO NEXT EDL        */
         L     EDLPTR,EDLNXTNT(,EDLPTR)                         04S0256
*END;                                                           04S0257
@RF00255 DS    0H                                               04S0257
@DE00241 TM    UCBMATCH,B'10000000'                             04S0257
         BNZ   @DC00241                                         04S0257
         LTR   EDLPTR,EDLPTR                                    04S0257
         BNZ   @DL00241                                         04S0257
@DC00241 DS    0H                                               04S0258
*EDLINDEX = EDLINDEX-1;                /*RESET CORRECT EDL INDEX     */
         L     @07,EDLINDEX                                     04S0258
         BCTR  @07,0                                            04S0258
         ST    @07,EDLINDEX                                     04S0258
*    IF RETCODE=NOERROR THEN           /*UCB ADDR FOUND IN EDL?      */
         SLR   @07,@07                                          03S0259
         C     @07,RETCODE                                      03S0259
         BNE   @RF00259                                         03S0259
*      DO;                             /*YES:                        */
*        ARURLPOS=RELDEVNO;            /*SET RELATIVE ETIOT POSITION */
         STH   RELDEVNO,ARURLPOS                                03S0261
*        UCBPARMP=ADDR(UCBPARMS);      /*POINT TO UCB PARM FIELD     */
         LA    @15,UCBPARMS                                     03S0262
         ST    @15,UCBPARMP                                     03S0262
*        IF SIOTETIO^=ZERO THEN        /*ETIOT EXIST?                */
         L     @01,SIOTPTR                                      03S0263
         C     @07,SIOTETIO(,@01)                               03S0263
         BE    @RF00263                                         03S0263
*          ARUETUPD=ON;                /*YES,INDICATE TO UPDATE IT   */
         OI    ARUETUPD,B'10000000'                             03S0264
*        ELSE                          /*ETIOT DOES NOT EXIST        */
*          DO;                                                  03S0265
         B     @RC00263                                         03S0265
@RF00263 DS    0H                                               03S0266
*            ARUETUPD=OFF;             /*INDICATE TO BUILD ETIOT     */
         NI    ARUETUPD,B'01111111'                             03S0266
*            ARUNDEVS=SIOTOTUN;        /*SET NUMBER ETIOT DEV ENTRIES*/
         L     @07,SIOTPTR                                      03S0267
         SLR   @15,@15                                          03S0267
         IC    @15,SIOTOTUN(,@07)                               03S0267
         STH   @15,ARUNDEVS                                     03S0267
*          END;                                                 03S0268
*        IF UCB3TAPE = ON THEN         /*MUST ENQ EXCL               */
@RC00263 L     @07,UCBPTR                                       03S0269
         TM    UCB3TAPE(@07),B'10000000'                        03S0269
         BNO   @RF00269                                         03S0269
*          DO;                                                  03S0270
*            VOLUMENQ = ON;                                     03S0271
*            VOLEXCLU = ON;                                     03S0272
         OI    VOLUMENQ,B'10100000'                             03S0272
*          END;                                                 03S0273
*        ELSE;                                                  03S0274
@RF00269 DS    0H                                               03S0275
*        IF UCB3DACC=ON &                                       03S0275
*           UCBPRES=OFF &                                       03S0275
*           UCBRESV=OFF THEN           /*REMOVEABLE DA               */
         L     @07,UCBPTR                                       03S0275
         TM    UCB3DACC(@07),B'00100000'                        03S0275
         BNO   @RF00275                                         03S0275
         TM    UCBPRES(@07),B'00100100'                         03S0275
         BNZ   @RF00275                                         03S0275
*          DO;                                                  03S0276
*            VOLUMENQ=ON;              /*INDICATE ENQ                */
*            VOLEXCLU = OFF;                                    03S0278
         OI    VOLUMENQ,B'10000000'                             03S0278
         NI    VOLEXCLU,B'11011111'                             03S0278
*          END;                                                 03S0279
*        IF VOLUMENQ = ON THEN                                  03S0280
@RF00275 TM    VOLUMENQ,B'10000000'                             03S0280
         BNO   @RF00280                                         03S0280
*          DO;                                                  03S0281
*            VOLSERP=ADDR(UCBVOLI);    /*VOLSER POINTER              */
         L     @07,UCBPTR                                       03S0282
         LA    @07,UCBVOLI(,@07)                                03S0282
         ST    @07,VOLSERP                                      03S0282
*            TCBADD=JSCBPTR->JSCBTCBP; /*TCB POINTER                 */
         L     @07,@PC00001                                     03S0283
         L     @07,ALCWAPTR(,@07)                               03S0283
         L     @03,JSCBPTR(,@07)                                03S0283
         MVC   TCBADD(4),JSCBTCBP(@03)                          03S0283
*            CALL IEFAB4F0(F0MAP,VOLSERP,TCBADD,VOLUNPTR,VOLUNSZE);
         LA    @03,F0MAP                                        03S0284
         ST    @03,@AL00001                                     03S0284
         LA    @03,VOLSERP                                      03S0284
         ST    @03,@AL00001+4                                   03S0284
         LA    @03,TCBADD                                       03S0284
         ST    @03,@AL00001+8                                   03S0284
         LA    @03,VOLUNPTR(,@07)                               03S0284
         ST    @03,@AL00001+12                                  03S0284
         LA    @07,VOLUNSZE(,@07)                               03S0284
         ST    @07,@AL00001+16                                  03S0284
         L     @15,@CV00963                                     03S0284
         LA    @01,@AL00001                                     03S0284
         BALR  @14,@15                                          03S0284
*            ERETCODE = REG15;                                  03S0285
         LR    ERETCODE,REG15                                   03S0285
*            IF ERETCODE^=ZERO THEN    /*VOL ENQ FAILED              */
         LTR   ERETCODE,ERETCODE                                03S0286
         BZ    @RF00286                                         03S0286
*              IF ERETCODE = JOBOWNS THEN /*ALREADY ENQ'D            */
         CH    ERETCODE,@CH00058                                03S0287
         BNE   @RF00287                                         03S0287
*                VOLUMENQ = OFF;       /*CANCEL DEQ ACTION           */
         NI    VOLUMENQ,B'01111111'                             03S0288
*              ELSE                                             03S0289
*                DO;                                            03S0289
         B     @RC00287                                         03S0289
@RF00287 DS    0H                                               03S0290
*                  ENQERROR=ON;        /*VOL ENQ ERROR               */
         OI    ENQERROR,B'01000000'                             03S0290
*                  EDLENQ(EDLINDEX)=ON;/*ENQ ERROR IN EDL            */
         L     @07,EDLINDEX                                     03S0291
         SLA   @07,2                                            03S0291
         L     @01,EDLUCBLP                                     03S0291
         ALR   @01,@07                                          03S0291
         BCTR  @01,0                                            03S0291
         BCTR  @01,0                                            03S0291
         OI    EDLENQ-2(@01),B'00100000'                        03S0291
*                END;                                           03S0292
*            ELSE;                     /*ENQ OK                      */
@RF00286 DS    0H                                               03S0294
*            END;                                               03S0294
*          ELSE;                       /*NON DA P/R RESVD            */
@RF00280 DS    0H                                               03S0296
*            IF ENQERROR = OFF THEN    /*CONTINUE PROCESS            */
@RC00280 TM    ENQERROR,B'01000000'                             03S0296
         BNZ   @RF00296                                         03S0296
*              DO;                                              03S0297
*                IF UCB3DACC=ON THEN   /*DA                          */
         L     @07,UCBPTR                                       03S0298
         TM    UCB3DACC(@07),B'00100000'                        03S0298
         BNO   @RF00298                                         03S0298
*                  ARUUSECT=ON;        /*UPDATE USE COUNT            */
         OI    ARUUSECT,B'01000000'                             03S0299
*                ELSE;                 /*TAPE                        */
@RF00298 DS    0H                                               03S0301
*                ARUVLCHK = OFF;       /*NO VALIDITY CHECK           */
         NI    ARUVLCHK,B'11101111'                             03S0301
*                IF MOUNTED=ON THEN                             03S0302
         L     @07,@PC00001+8                                   03S0302
         L     @07,PSPARMP(,@07)                                03S0302
         TM    MOUNTED(@07),B'00001000'                         03S0302
         BNO   @RF00302                                         03S0302
*                  ARUUPDAL=ON;        /*UPDATE ALG TABLES           */
         OI    ARUUPDAL,B'00000100'                             03S0303
*                IF UCBPRES=OFF &                               03S0304
*                   UCBRESV=OFF THEN   /*REMOVEABLE VOL              */
@RF00302 L     @07,UCBPTR                                       03S0304
         TM    UCBPRES(@07),B'00100100'                         03S0304
         BNZ   @RF00304                                         03S0304
*                  ARUUSEST=ON;        /*UPDATE USE ATTRIBUTE        */
         OI    ARUUSEST,B'00001000'                             03S0305
*                ARUAFF=ON;            /*PROCESS AFFINITY            */
@RF00304 OI    ARUAFF,B'00100000'                               03S0306
*                VOLUMEID = UCBVOLI;   /*VOLSER TO IEFAB435 PARM LIST*/
         L     @07,UCBPTR                                       03S0307
         MVC   VOLUMEID(6),UCBVOLI(@07)                         03S0307
*                IF UCB3TAPE=ON & UCBRESV=ON THEN /*RESV'D TAPE      */
         TM    UCB3TAPE(@07),B'10000000'                        03S0308
         BNO   @RF00308                                         03S0308
         TM    UCBRESV(@07),B'00100000'                         03S0308
         BNO   @RF00308                                         03S0308
*                  DO;                                          03S0309
*                    CALL IEFAB442(FUNC442,ALCWAPTR,VOLID,VOLUNTID);
         LA    @07,@CB00943                                     03S0310
         ST    @07,@AL00001                                     03S0310
         L     @07,@PC00001                                     03S0310
         ST    @07,@AL00001+4                                   03S0310
         L     @07,VUPTR                                        03S0310
         ST    @07,@AL00001+8                                   03S0310
         LA    @07,VOLUNTID(,@07)                               03S0310
         ST    @07,@AL00001+12                                  03S0310
         L     @15,@CV00965                                     03S0310
         LA    @01,@AL00001                                     03S0310
         BALR  @14,@15                                          03S0310
*                    RETCODE = REG15;  /*SAVE THE RETURN CODE        */
         ST    REG15,RETCODE                                    03S0311
*                  END;                                         03S0312
*              ELSE;                   /*NOT A RESERVED TAPE         */
@RF00308 DS    0H                                               03S0314
*            IF RETCODE = NOERROR THEN /*ANY ERRORS                  */
         ICM   @07,15,RETCODE                                   03S0314
         BNZ   @RF00314                                         03S0314
*              DO;                                              03S0315
*                CALL IEFAB434 (SIOTPTR,VUPTR,UCBPTR,ARUINDIC,ARUWORD,
*                 ALCWAPTR,ARUGRPID,UCBPARMP);/*TRY TO ALLOC UNIT    */
         LA    @07,SIOTPTR                                      03S0316
         ST    @07,@AL00001                                     03S0316
         LA    @07,VUPTR                                        03S0316
         ST    @07,@AL00001+4                                   03S0316
         LA    @07,UCBPTR                                       03S0316
         ST    @07,@AL00001+8                                   03S0316
         LA    @07,ARUINDIC                                     03S0316
         ST    @07,@AL00001+12                                  03S0316
         LA    @07,ARUWORD                                      03S0316
         ST    @07,@AL00001+16                                  03S0316
         L     @07,@PC00001                                     03S0316
         ST    @07,@AL00001+20                                  03S0316
         LA    @07,ARUGRPID                                     03S0316
         ST    @07,@AL00001+24                                  03S0316
         LA    @07,UCBPARMP                                     03S0316
         ST    @07,@AL00001+28                                  03S0316
         L     @15,@CV00967                                     03S0316
         LA    @01,@AL00001                                     03S0316
         BALR  @14,@15                                          03S0316
*                RFY REG15 RSTD;                                03S0317
*                IF REG15=NOERROR      /*ALLOCATION SUCCESSFUL?      */
*                  | REG15=RET32                                03S0318
*                    | REG15=RET36 | REG15=RET40 THEN /*     @ZA04112*/
         LTR   REG15,REG15                                      03S0318
         BZ    @RT00318                                         03S0318
         CH    REG15,@CH00955                                   03S0318
         BE    @RT00318                                         03S0318
         CH    REG15,@CH00994                                   03S0318
         BE    @RT00318                                         03S0318
         CH    REG15,@CH00996                                   03S0318
         BNE   @RF00318                                         03S0318
@RT00318 DS    0H                                               03S0319
*                      DO;                                      03S0319
*                        IF FIRSTALC=OFF THEN /*FIRST UNIT ALLOC'D   */
         TM    FIRSTALC,B'10000000'                             03S0320
         BNZ   @RF00320                                         03S0320
*                          EDLFINIS=ON; /*YES, EDL UPDATE NEEDED     */
         OI    EDLFINIS,B'10000000'                             03S0321
*                        ELSE;                                  03S0322
@RF00320 DS    0H                                               03S0323
*                          FIRSTALC = ON; /*ONE UNIT ALLOC'D         */
         OI    FIRSTALC,B'10000000'                             03S0323
*                        VOLALOC=ON;   /*YES,MARK VOLUNIT ENT ALLOC'D*/
         L     @14,VUPTR                                        03S0324
         OI    VOLALOC(@14),B'10000000'                         03S0324
*                        IF REG15=RET32 THEN/*AFFINITY DADSM ERROR ? */
         CH    REG15,@CH00955                                   03S0325
         BNE   @RF00325                                         03S0325
*                          DO;                                  03S0326
*                            EDLVOLAF(EDLINDEX)=ON;/*YES,IND. IN EDL */
         L     @14,EDLINDEX                                     03S0327
         SLA   @14,2                                            03S0327
         L     @07,EDLUCBLP                                     03S0327
         ALR   @07,@14                                          03S0327
         BCTR  @07,0                                            03S0327
         BCTR  @07,0                                            03S0327
         OI    EDLVOLAF-2(@07),B'00010000'                      03S0327
*                            SIOTNOPR = ON;/*SIOT NOT ALL PROCESSED  */
         OI    SIOTNOPR,B'00000100'                             03S0328
*                          END;                                 03S0329
*                        ELSE;         /*NOT AFFINITY DADSM ERROR    */
@RF00325 DS    0H                                               03S0331
*                        EDLALCD(EDLINDEX)=ON; /*EDL UCB ENT IS ALLOC*/
         L     @14,EDLINDEX                                     03S0331
         SLA   @14,2                                            03S0331
         L     @07,EDLUCBLP                                     03S0331
         ALR   @07,@14                                          03S0331
         BCTR  @07,0                                            03S0331
         BCTR  @07,0                                            03S0331
         OI    EDLALCD-2(@07),B'10000000'                       03S0331
*                        PSCNTENT=PSCNTENT-1;  /*DECREMENT CNTTAB ENT*/
         L     @14,COUNTABP                                     03S0332
         L     @07,PSCNTENT(,@14)                               03S0332
         BCTR  @07,0                                            03S0332
         ST    @07,PSCNTENT(,@14)                               03S0332
*                        TOTVOLUN=TOTVOLUN-1;  /*DECREMENT TOTAL     */
         L     @14,@PC00001                                     03S0333
         L     @14,ALCWAPTR(,@14)                               03S0333
         L     @07,TOTVOLUN(,@14)                               03S0333
         BCTR  @07,0                                            03S0333
         ST    @07,TOTVOLUN(,@14)                               03S0333
*                                              /*COUNTAB ENTRY       */
*                        IF REG15=RET36 THEN   /*RETURN CODE 36?     */
         LA    @14,36                                           03S0334
         CR    REG15,@14                                        03S0334
         BNE   @RF00334                                         03S0334
*                          DO;                                  03S0335
*                            RETCODE=RET36;    /*YES,SET RETURN CODE */
         ST    @14,RETCODE                                      03S0336
*                            IF NUMVOLUN^=SVOLUNNO THEN /*LAST VU    */
         L     @14,SIOTPTR                                      03S0337
         CH    NUMVOLUN,SVOLUNNO(,@14)                          03S0337
         BE    @RF00337                                         03S0337
*                                                       /*FOR SIOT?  */
*                              SIOTNOPR=ON;  /*SIOT NOT ALL PROCESSED*/
         OI    SIOTNOPR,B'00000100'                             03S0338
*                          END;                                 03S0339
*                        ELSE;                                  03S0340
@RF00334 DS    0H                                               03S0341
*                      END;                                     03S0341
*                ELSE                  /*ALLOCATION NOT SUCCESSFUL   */
*                  DO;                                          03S0342
         B     @RC00318                                         03S0342
@RF00318 DS    0H                                               03S0343
*                    IF REG15=DADSMERR THEN /*RECOVERABLE DADSM ERR  */
         CH    REG15,@CH00986                                   03S0343
         BNE   @RF00343                                         03S0343
*                      DO;                                      03S0344
*                        EDLDADSM(EDLINDEX)=ON;  /*YES,INDICATE IT   */
         L     @14,EDLINDEX                                     03S0345
         SLA   @14,2                                            03S0345
         L     @07,EDLUCBLP                                     03S0345
         ALR   @07,@14                                          03S0345
         BCTR  @07,0                                            03S0345
         BCTR  @07,0                                            03S0345
         OI    EDLDADSM-2(@07),B'01000000'                      03S0345
*                                                /*EDL ENTRY         */
*                        DADSMESW=ON;            /*INDICATE ERROR TO */
         OI    DADSMESW,B'00001000'                             03S0346
*                                                /*LIST BUILD        */
*                      END;                                     03S0347
*                    ELSE              /*NON-RECOVERABLE DADSM ERROR */
*                      DO;                                      03S0348
         B     @RC00343                                         03S0348
@RF00343 DS    0H                                               03S0349
*                        SIOTNOPR = ON; /*SIOT NOT FULLY ALOC'D      */
         OI    SIOTNOPR,B'00000100'                             03S0349
*                        RETCODE=REG15; /*SET ERROR CODE             */
         ST    REG15,RETCODE                                    03S0350
*                      END;                                     03S0351
*                    RFY REG15 UNRSTD;                          03S0352
@RC00343 DS    0H                                               03S0353
*                    IF VOLUMENQ=ON THEN    /*MUST DO DEQ           */
         TM    VOLUMENQ,B'10000000'                             03S0353
         BNO   @RF00353                                         03S0353
*                      DO;                                      03S0354
*                        VOLUMENQ=OFF;                          03S0355
*                        VOLUMEDQ=ON;                           03S0356
         OI    VOLUMEDQ,B'01000000'                             03S0356
         NI    VOLUMENQ,B'01111111'                             03S0356
*                        CALL IEFAB4F0(F0MAP,VOLSERP,TCBADD,VOLUNPTR,
*                                      VOLUNSZE);               03S0357
         LA    @07,F0MAP                                        03S0357
         ST    @07,@AL00001                                     03S0357
         LA    @07,VOLSERP                                      03S0357
         ST    @07,@AL00001+4                                   03S0357
         LA    @07,TCBADD                                       03S0357
         ST    @07,@AL00001+8                                   03S0357
         L     @07,@PC00001                                     03S0357
         L     @07,ALCWAPTR(,@07)                               03S0357
         LA    @15,VOLUNPTR(,@07)                               03S0357
         ST    @15,@AL00001+12                                  03S0357
         LA    @07,VOLUNSZE(,@07)                               03S0357
         ST    @07,@AL00001+16                                  03S0357
         L     @15,@CV00963                                     03S0357
         LA    @01,@AL00001                                     03S0357
         BALR  @14,@15                                          03S0357
*                      END;                                     03S0358
*                  END;                                         03S0359
*                END;                                           03S0360
*              ELSE;                   /*ERROR REMOVING UNIT AFFS    */
@RF00314 DS    0H                                               03S0362
*          END;                                                 03S0362
*      END;                                                     03S0363
*  END;                                                         03S0364
*ELSE                                  /*OPTIMUM DEVICE NOT SELECTED */
*  DO;                                                          03S0365
         B     @RC00235                                         03S0365
@RF00235 DS    0H                                               03S0366
*    RETCODE=ERROR;                    /*SET RETURN CODE             */
         MVC   RETCODE(4),@CF00160                              03S0366
*    FAILRSC=OPDEVERR;                 /*SET REASON CODE             */
         L     @07,@PC00001                                     03S0367
         L     @07,ALCWAPTR(,@07)                               03S0367
         L     @07,FAILRSCP(,@07)                               03S0367
         MVC   FAILRSC(2,@07),@CH00991                          03S0367
*  END;                                                         03S0368
*IF DADSMESW=OFF &                     /*DADSM ERROR?                */
*  ENQERROR=OFF THEN                                            03S0369
@RC00235 TM    DADSMESW,B'01001000'                             03S0369
         BNZ   @RF00369                                         03S0369
*  DO;                                 /*NO,FREE ALLOC'D UCB LST CORE*/
*    RFY (REG0,REG1)RSTD;                                       03S0371
*    REG0=ALCULEN;                     /*LENGTH OF ALCUCBLT          */
         L     REG0,ALCULEN                                     03S0372
*    REG0 = REG0 | TOO53;              /*SET SP253                   */
         O     REG0,@CF00956                                    03S0373
*    REG1=ALCUCBP;                     /*POINTER TO ALCUCBLT         */
         L     REG1,ALCUCBP(,OPTPARMP)                          03S0374
*    GEN( FREEMAIN R,LV=(0),A=(1) );   /*FREE ALLOCATED UCB LIST CORE*/
          FREEMAIN R,LV=(0),A=(1)
*    RFY (REG0,REG1) UNRSTD;                                    03S0376
*  END;                                                         03S0377
*ELSE                                  /*DADSM ERROR OCCURRED        */
*  REUSESW=ON;                         /*INDICATE TO REUSE ALCUCBLT  */
         B     @RC00369                                         03S0378
@RF00369 OI    REUSESW,B'00000001'                              03S0378
*        END;                                                   02S0379
*      ELSE                            /*NO:                         */
*        DO;                                                    02S0380
         B     @RC00214                                         02S0380
@RF00214 DS    0H                                               02S0381
*          VOLUNOPR=ON;                /*INDICATE VOLUNIT NOT PROCESS*/
*          SIOTNOPR=ON;                /*SIOT NOT COMPLETELY PROCESS */
         OI    VOLUNOPR,B'00000110'                             02S0382
*        END;                                                   02S0383
*    END;                                                       02S0384
*  ELSE                                /*NO,PSLIST IS EMPTY          */
*    DO;                                                        02S0385
         B     @RC00206                                         02S0385
@RF00206 DS    0H                                               02S0386
*      VOLUNOPR=ON;                    /*INDICATE VOLUNIT NOT PROCESS*/
*      SIOTNOPR=ON;                    /*INDICATE SIOT NOT COMPLETELY
*                                        PROCESSED                   */
         OI    VOLUNOPR,B'00000110'                             02S0387
*      IF DADSMESW=OFF &               /*DADSM ERROR?                */
*         PUBVOL = OFF THEN            /*STORAGE VOLUME ?            */
         TM    DADSMESW,B'00001000'                             02S0388
         BNZ   @RF00388                                         02S0388
         TM    PUBVOL,B'10000000'                               02S0388
         BNZ   @RF00388                                         02S0388
*        DO;                                                    02S0389
*/********************************************************************/
*/*                                                                  */
*/* SEGMENT NAME - PVTUPDTE                                          */
*/*                                                                  */
*/* DESCRIPTIVE NAME - UPDATE REQUEST TO PRIVATE                     */
*/*                                                                  */
*/* FUNCTION -                                                       */
*/*   THIS ROUTINE WILL CHANGE A REQUEST FOR STORAGE VOLUMES TO A    */
*/*   REQUEST FOR PRIVATE VOLUMES WHEN THERE ARE NOT ENOUGH STORAGE  */
*/*   VOLUMES AVAILABLE TO SATISFY THE REQUEST. ALL STORAGE VOLUNIT  */
*/*   ENTRIES REMAINING TO BE ALLOCATED ARE CHANGED TO PRIVATE AND   */
*/*   INDICATORS SET IN THE SIOT AND IN ALCWA TO INDICATE THAT A     */
*/*   MESSAGE MUST BE ISSUED TELLING THE CHANGE. ANY OTHER           */
*/*   ALLOCATED VOLUNIT ENTRIES WHICH REQUIRE THE SAME VOLUME        */
*/*   AND UNIT ARE ALSO CHANGED TO PRIVATE. THE COUNT TABLE          */
*/*   (IN ALCWA) IS ALSO UPDATED TO REFLECT THE CHANGE.              */
*/*                                                                  */
*/* ENTRY -                                                          */
*/*   PVTUPDTE - IN-LINE SEGMENT                                     */
*/*                                                                  */
*/*   PURPOSE - SEE FUNCTION                                         */
*/*                                                                  */
*/*   INPUT -                                                        */
*/*     SIOT CURRENTLY BEING PROCESSED                               */
*/*     VOLUNIT ENTRY CURRENTLY BEING PROCESSED                      */
*/*     ALCWA                                                        */
*/*       COUNT TABLE                                                */
*/* EXITS -                                                          */
*/*   CONDITION - FUNCTION COMPLETED                                 */
*/*                                                                  */
*/*     OUTPUT -                                                     */
*/*       UPDATED VOLUNIT ENTRIES -                                  */
*/*         STORAGE INDICATOR OFF                                    */
*/*         PRIVATE INDICATOR ON                                     */
*/*       UPDATED SIOT(S) -                                          */
*/*         INDICATOR TO ISSUE MSG FOR DD                            */
*/*       UPDATED ALCWA -                                            */
*/*         INDICATOR THAT AT LEAST ONE SIOT NEEDS 'PRIVATE ASSUMED' */
*/*         MESSAGE.                                                 */
*/*         UPDATED COUNT TABLE -                                    */
*/*           STORAGE COUNT DECREASED                                */
*/*           NON-SPECIFIC PRIVATE COUNT INCREASED                   */
*/*                                                                  */
*/*     RETURN CODES - NONE                                          */
*/********************************************************************/
*VUSAVE = VUPTR;                       /*SAVE PTR TO CURRENT ENTRY   */
         L     VUSAVE,VUPTR                                     03S0390
*VUPTR = SVOLUNAD;                     /*POINT TO FIRST ENTRY OF
*                                        REQUEST                     */
         L     @07,SIOTPTR                                      03S0391
         MVC   VUPTR(4),SVOLUNAD(@07)                           03S0391
*DO VUCTR = ONE TO SVOLUNNO;           /*PROCESS ALL ENTRIES         */
         LA    VUCTR,1                                          03S0392
         B     @DE00392                                         03S0392
@DL00392 DS    0H                                               03S0393
*  IF VOLALOC = OFF                    /*CHANGE ENTRY IF NOT ALOC'D..*/
*      & VDEVREQD = ON                 /*.. REQUIRES A DEV ENTRY ... */
*      & VOLSTG = ON THEN              /*.. AND NEEDS STORAGE VOLUME */
         L     @07,VUPTR                                        03S0393
         TM    VDEVREQD(@07),B'00100000'                        03S0393
         BNO   @RF00393                                         03S0393
         TM    VOLALOC(@07),B'10000000'                         03S0393
         BNZ   @RF00393                                         03S0393
         TM    VOLSTG(@07),B'00010000'                          03S0393
         BNO   @RF00393                                         03S0393
*    DO;                               /*ADJUST ENTRY,SIOT, & ALCWA  */
*      VOLSTG = OFF;                   /*TURN OFF STRG INDICATOR     */
*      VOLPRV = ON;                    /*MAKE ENTRY REQ PRIVATE VOL  */
         OI    VOLPRV(@07),B'01000000'                          03S0396
         NI    VOLSTG(@07),B'11101111'                          03S0396
*      SPVTAMSG = ON;                  /*INDIC MSG FOR STEP IN SIOT  */
         L     @07,SIOTPTR                                      03S0397
         OI    SPVTAMSG(@07),B'00010000'                        03S0397
*      PRIVASUM = ON;                  /*INDIC MSG FOR STEP IN ALCWA */
         L     @07,@PC00001                                     03S0398
         L     @07,ALCWAPTR(,@07)                               03S0398
         OI    PRIVASUM(@07),B'00010000'                        03S0398
*      STRGREQS = STRGREQS - ONE;      /*DECREASE STORAGE COUNT      */
         L     @03,STRGREQS(,@07)                               03S0399
         BCTR  @03,0                                            03S0399
         ST    @03,STRGREQS(,@07)                               03S0399
*      PVTNREQS = PVTNREQS + ONE;      /*INCREASE NON-SPEC PRIVATE
*                                        COUNT                       */
         LA    @03,1                                            03S0400
         L     @15,PVTNREQS(,@07)                               03S0400
         ALR   @15,@03                                          03S0400
         ST    @15,PVTNREQS(,@07)                               03S0400
*      TVUPTR = VOLUNPTR;              /*PT. TO BEGINNING OF VU TABLE*/
         L     TVUPTR,VOLUNPTR(,@07)                            03S0401
*      DO VUCTR1 = ONE TO VOLUNSZE/VOLENTLN; /*SCAN ALL ENTRIES      */
         LA    @07,1                                            03S0402
         LR    VUCTR1,@07                                       03S0402
         B     @DE00402                                         03S0402
@DL00402 DS    0H                                               03S0403
*        IF TVUPTR ^= VUPTR            /*DON'T PROCESS CURRENT ENTRY */
*            & TVUPTR -> VOLID = VOLID THEN /*SAME VOLID'S?          */
         L     @07,VUPTR                                        03S0403
         CR    TVUPTR,@07                                       03S0403
         BE    @RF00403                                         03S0403
         CLC   VOLID(6,TVUPTR),VOLID(@07)                       03S0403
         BNE   @RF00403                                         03S0403
*          IF TVUPTR -> VOLALOC = OFF  /*YES,ENTRY ALREADY ALLOCATED?*/
*              & TVUPTR -> VDEVREQD = ON THEN /*YES, AND REQS DEVICE?*/
         TM    VDEVREQD(TVUPTR),B'00100000'                     03S0404
         BNO   @RF00404                                         03S0404
         TM    VOLALOC(TVUPTR),B'10000000'                      03S0404
         BNZ   @RF00404                                         03S0404
*            DO;                       /*YES, CHANGE ENTRY TO PRIVATE*/
*              IF TVUPTR -> VOLSTG = ON THEN /*ENTRY STORAGE?        */
         TM    VOLSTG(TVUPTR),B'00010000'                       03S0406
         BNO   @RF00406                                         03S0406
*                DO;                   /*YES                         */
*                  STRGREQS = STRGREQS - ONE; /*DECREMENT COUNT      */
         L     @07,@PC00001                                     03S0408
         L     @07,ALCWAPTR(,@07)                               03S0408
         L     @15,STRGREQS(,@07)                               03S0408
         BCTR  @15,0                                            03S0408
         ST    @15,STRGREQS(,@07)                               03S0408
*                  TVUPTR -> VOLSTG = OFF; /*TURN OFF STORAGE INDIC  */
         NI    VOLSTG(TVUPTR),B'11101111'                       03S0409
*                END;                                           03S0410
*              ELSE                                             03S0411
*                DO;                   /*ADJUST PUBLIC ENTRY & COUNT */
         B     @RC00406                                         03S0411
@RF00406 DS    0H                                               03S0412
*                  PUBLREQS = PUBLREQS - ONE; /*DECREMENT COUNT      */
         L     @07,@PC00001                                     03S0412
         L     @07,ALCWAPTR(,@07)                               03S0412
         L     @15,PUBLREQS(,@07)                               03S0412
         BCTR  @15,0                                            03S0412
         ST    @15,PUBLREQS(,@07)                               03S0412
*                  TVUPTR -> VOLPUB = OFF; /*TURN OFF PUBLIC INDIC   */
         NI    VOLPUB(TVUPTR),B'01111111'                       03S0413
*                END;                                           03S0414
*              TVUPTR -> VOLPRV = ON;  /*MAKE ENTRY PRIVATE          */
@RC00406 OI    VOLPRV(TVUPTR),B'01000000'                       03S0415
*              PVTNREQS = PVTNREQS + ONE; /*INCREMENT PRIVATE COUNT  */
         L     @07,@PC00001                                     03S0416
         L     @07,ALCWAPTR(,@07)                               03S0416
         LA    @15,1                                            03S0416
         AL    @15,PVTNREQS(,@07)                               03S0416
         ST    @15,PVTNREQS(,@07)                               03S0416
*              TVUPTR -> VOLSIOTP -> SPVTAMSG = ON; /*SET INDIC TO
*                                        ISSUE MSG                   */
         L     @07,VOLSIOTP(,TVUPTR)                            03S0417
         OI    SPVTAMSG(@07),B'00010000'                        03S0417
*            END;                                               03S0418
*          ELSE;                                                03S0419
@RF00404 DS    0H                                               03S0420
*        ELSE;                                                  03S0420
@RF00403 DS    0H                                               03S0421
*        TVUPTR = TVUPTR + VOLENTLN;   /*POINT TO NEXT ENTRY         */
         AH    TVUPTR,VOLENTLN                                  03S0421
*      END;                                                     03S0422
         AL    VUCTR1,@CF00056                                  03S0422
@DE00402 L     @07,@PC00001                                     03S0422
         L     @07,ALCWAPTR(,@07)                               03S0422
         L     @00,VOLUNSZE(,@07)                               03S0422
         SRDA  @00,32                                           03S0422
         LH    @07,VOLENTLN                                     03S0422
         DR    @00,@07                                          03S0422
         CR    VUCTR1,@01                                       03S0422
         BNH   @DL00402                                         03S0422
*    END;                                                       03S0423
*  ELSE;                                                        03S0424
@RF00393 DS    0H                                               03S0425
*  VUPTR = VUPTR +VOLENTLN;            /*POINT TO NEXT ENTRY         */
         LH    @07,VOLENTLN                                     03S0425
         AL    @07,VUPTR                                        03S0425
         ST    @07,VUPTR                                        03S0425
*END;                                                           03S0426
         AL    VUCTR,@CF00056                                   03S0426
@DE00392 L     @07,SIOTPTR                                      03S0426
         CH    VUCTR,SVOLUNNO(,@07)                             03S0426
         BNH   @DL00392                                         03S0426
* VUPTR = VUSAVE;                      /*RESET PTR TO CURRENT ENTRY  */
         ST    VUSAVE,VUPTR                                     03S0427
*        END;                                                   02S0428
*      ELSE                            /*YES, DADSM ERROR            */
*        IF STGVOL=ON THEN             /*A STORAGE VOLUME?           */
         B     @RC00388                                         02S0429
@RF00388 TM    STGVOL,B'00010000'                               02S0429
         BNO   @RF00429                                         02S0429
*          DO;                                                  02S0430
*            RETCODE=NOSTRG;           /*YES,SET ERROR RETURN CODE   */
         MVC   RETCODE(4),@CF00160                              02S0431
*            IF SIOTRSNC=SPACERR THEN  /*SPACE COULDN'T BE GOTTEN?   */
         L     @07,SIOTPTR                                      02S0432
         CLC   SIOTRSNC(2,@07),@CH01051                         02S0432
         BNE   @RF00432                                         02S0432
*              SIOTRSNC=STRGERR;       /*YES,SET NO SPACE ON STORAGE
*                                        VOLUME REASON CODE          */
         MVC   SIOTRSNC(2,@07),@CH00986                         02S0433
*          END;                                                 02S0434
@RF00432 DS    0H                                               02S0435
*        IF DADSMESW = ON &            /*DADSM ERROR ON      @ZA04836*/
*           PUBVOL = ON THEN           /*PUBLIC REQUEST      @ZA04836*/
@RF00429 DS    0H                                               02S0435
@RC00388 TM    DADSMESW,B'00001000'                             02S0435
         BNO   @RF00435                                         02S0435
         TM    PUBVOL,B'10000000'                               02S0435
         BNO   @RF00435                                         02S0435
*          DO;                                                  02S0436
*/********************************************************************/
*/*                                                          @ZA04836*/
*/* SEGMENT NAME - AFFCHCK                                   @ZA04836*/
*/*                                                          @ZA04836*/
*/* DESCRIPTIVE NAME - PROCESS AFFINITY REQUEST              @ZA04836*/
*/*                                                          @ZA04836*/
*/* FUNCTION -                                               @ZA04836*/
*/*   THIS ROUTINE MARKS ALL VOLUNIT ENTRIES WHICH REQUEST   @ZA04836*/
*/*   AFFINITY TO THIS SIOT WITH VUDADSME                    @ZA04836*/
*/*   AND VUDNALOC SO THAT THEY WILL NOT BE ALLOCATED UNTIL  @ZA04836*/
*/*   THE PRIMARY SIOT HAS BEEN ALLOCATED.                   @ZA04836*/
*/*                                                          @ZA04836*/
*/* ENTRY -                                                  @ZA04836*/
*/*   AFFCHCK - INCLUDED SEGMENT IN PSVOLUN                  @ZA04836*/
*/*                                                          @ZA04836*/
*/*   PURPOSE - TO MARK REQUEST FOR NON-SPECIFIC DA VOLUME   @ZA04836*/
*/*             AFFINITY                                     @ZA04836*/
*/*                                                          @ZA04836*/
*/*   INPUT -                                                @ZA04836*/
*/*     PTR TO SIOT FOR THE REQUEST BEING PROCESSED          @ZA04836*/
*/*                                                          @ZA04836*/
*/* EXITS -                                                  @ZA04836*/
*/*   CONDITION - NORMAL COMPLETION                          @ZA04836*/
*/*                                                          @ZA04836*/
*/*   OUTPUT - ANY SIOT WHICH HAS AFFINITY TO THE INPUT SIOT @ZA04836*/
*/*            WILL HAVE ALL ITS VU ENTRIESMARKED WITH       @ZA04836*/
*/*            VUDADSME AND VUDNALOC.                        @ZA04836*/
*/*                                                          @ZA04836*/
*/********************************************************************/
*CHCKSIOT = OFF;                       /*INITIALIZE SWITCH   @ZA04836*/
         NI    CHCKSIOT,B'01111111'                             03S0437
*NUMVUENT = VOLUNSZE/VOLENTLN;         /*GET TOTAL OF VU ENTRIES
*                                                            @ZA04836*/
         L     @07,@PC00001                                     03S0438
         L     @07,ALCWAPTR(,@07)                               03S0438
         L     @00,VOLUNSZE(,@07)                               03S0438
         SRDA  @00,32                                           03S0438
         LH    NUMVUENT,VOLENTLN                                03S0438
         DR    @00,NUMVUENT                                     03S0438
         LR    NUMVUENT,@01                                     03S0438
*AVUPTR = SVOLUNAD;                    /*GET PTR TO CURRENT SIOTS 1ST
*                                        VU ENTRY            @ZA04836*/
         L     @07,SIOTPTR                                      03S0439
         L     AVUPTR,SVOLUNAD(,@07)                            03S0439
*DO AFFCTR = ONE TO SVOLUNNO;          /*CHECK EVERY VU ENTRY IN
*                                        TABLE FOR A MATCH   @ZA04836*/
         LA    AFFCTR,1                                         03S0440
         B     @DE00440                                         03S0440
@DL00440 DS    0H                                               03S0441
*  CALL VUSCAN;                        /*SCAN FOR AFFINITIES @ZA04836*/
         BAL   @14,VUSCAN                                       03S0441
*  AVUPTR = AVUPTR + VOLENTLN;         /*POINT TO NEXT VU ENTRY 03S0442
*                                        FOR CURRENT SIOT    @ZA04836*/
         AH    AVUPTR,VOLENTLN                                  03S0442
*END;                                                           03S0443
         AL    AFFCTR,@CF00056                                  03S0443
@DE00440 L     @07,SIOTPTR                                      03S0443
         CH    AFFCTR,SVOLUNNO(,@07)                            03S0443
         BNH   @DL00440                                         03S0443
*IF CHCKSIOT = ON THEN                 /*IF WE FOUND AFFIN   @ZA04836*/
         TM    CHCKSIOT,B'10000000'                             03S0444
         BNO   @RF00444                                         03S0444
*  DO;                                                          03S0445
*    CHCKSIOT = OFF;                                            03S0446
         NI    CHCKSIOT,B'01111111'                             03S0446
*    ASIOTPTR = SIOT1P;                /*PT TO 1ST SIOT ON CHAIN
*                                                            @ZA04836*/
         L     @07,@PC00001                                     03S0447
         L     @07,ALCWAPTR(,@07)                               03S0447
         L     ASIOTPTR,SIOT1P(,@07)                            03S0447
*    DO WHILE ASIOTPTR^=ZERO;          /*LOOK AT ALL SIOTS TO FIND
*                                        AFFINITY REQUESTS   @ZA04836*/
         B     @DE00448                                         03S0448
@DL00448 DS    0H                                               03S0449
*      IF ASIOTPTR->SIOTAFF=ON THEN    /*THIS SIOT REQUESTED    03S0449
*                                        AFFINITY            @ZA04836*/
         TM    SIOTAFF(ASIOTPTR),B'00100000'                    03S0449
         BNO   @RF00449                                         03S0449
*        DO;                                                    03S0450
*          AVUPTR=ASIOTPTR->SVOLUNAD;  /*GET PTR TO AFFINITY 1ST
*                                        VU ENTRY            @ZA04836*/
         L     AVUPTR,SVOLUNAD(,ASIOTPTR)                       03S0451
*          ASIOTPTR->SIOTAFF=OFF;      /*RESET SWITCH        @ZA04836*/
         NI    SIOTAFF(ASIOTPTR),B'11011111'                    03S0452
*          DO AVUCTR=ONE TO ASIOTPTR->SVOLUNNO; /*SIOT VU ENTRIES
*                                                            @ZA04836*/
         LA    AVUCTR,1                                         03S0453
         B     @DE00453                                         03S0453
@DL00453 DS    0H                                               03S0454
*            IF AVUPTR->VUDADSME=OFF &                          03S0454
*               AVUPTR->VUDNALOC=OFF THEN /*HAS THIS VU ENTRY ALREADY
*                                           BEEN PROCESSED?  @ZA04836*/
         TM    VUDADSME(AVUPTR),B'00001100'                     03S0454
         BNZ   @RF00454                                         03S0454
*                CALL VUSCAN;          /*PROCESS ALL AFFIN   @ZA04836*/
         BAL   @14,VUSCAN                                       03S0455
*            ELSE;                     /*VU ENTRY PROCESSED  @ZA04836*/
@RF00454 DS    0H                                               03S0457
*            AVUPTR=AVUPTR+VOLENTLN;   /*PT TO NEXT VU ENTRY @ZA04836*/
         AH    AVUPTR,VOLENTLN                                  03S0457
*          END;                                                 03S0458
         AL    AVUCTR,@CF00056                                  03S0458
@DE00453 CH    AVUCTR,SVOLUNNO(,ASIOTPTR)                       03S0458
         BNH   @DL00453                                         03S0458
*        END;                                             /* @ZA04836*/
*      ELSE;                                              /* @ZA04836*/
@RF00449 DS    0H                                               03S0461
*      ASIOTPTR = ASIOTPTR->SIOTNPTR;  /*                    @ZA04836*/
         L     ASIOTPTR,SIOTNPTR(,ASIOTPTR)                     03S0461
*    END;                                                       03S0462
@DE00448 LTR   ASIOTPTR,ASIOTPTR                                03S0462
         BNZ   @DL00448                                         03S0462
*  END;                                                         03S0463
*          END;                                                 02S0464
@RF00444 DS    0H                                               02S0465
*    END;                                                       02S0465
@RF00435 DS    0H                                               02S0466
*END;                                                           02S0466
@RC00206 DS    0H                                               02S0466
@DE00149 L     @07,VUPTR                                        02S0466
         TM    VOLALOC(@07),B'10000000'                         02S0466
         BNZ   @DC00149                                         02S0466
         ICM   @07,15,RETCODE                                   02S0466
         BNZ   @DC00149                                         02S0466
         TM    VOLUNOPR,B'00000010'                             02S0466
         BZ    @DL00149                                         02S0466
@DC00149 DS    0H                                               02S0467
*                      END;                                     01S0467
*                    ELSE             /*REQUEST NOT SHAREABLE        */
*                      DO;                                      01S0468
         B     @RC00147                                         01S0468
@RF00147 DS    0H                                               01S0469
*                        SIOTNOPR = ON; /*REQ NOT TOTALLY ALOC'D     */
         OI    SIOTNOPR,B'00000100'                             01S0469
*                      END;                                     01S0470
*                  ELSE               /*VOLUNIT ENTRY NOT PROCESSED  */
*                    SIOTNOPR=ON;     /*SIOT NOT TOTALLY ALLOC'D BIT */
         B     @RC00146                                         01S0471
@RF00146 OI    SIOTNOPR,B'00000100'                             01S0471
*                ELSE                 /*ENTRY ALLOCATED              */
*                  DO;                                          01S0472
         B     @RC00145                                         01S0472
@RF00145 DS    0H                                               01S0473
*                    IF VUDNALOC = ON THEN /*VU NOT TO BE PROCESSED  */
         L     @07,VUPTR                                        01S0473
         TM    VUDNALOC(@07),B'00001000'                        01S0473
         BNO   @RF00473                                         01S0473
*                      SIOTNOPR = ON; /*YES, DON'T MARK SIOT ALLOC'D */
         OI    SIOTNOPR,B'00000100'                             01S0474
*                    ELSE;            /*VU PROCESSED OK              */
@RF00473 DS    0H                                               01S0476
*                  END;                                         01S0476
*              END;                                             01S0477
*        END;                                                   01S0478
*      ELSE                           /*SKIP FIRST ENTRY             */
*        DO;                                                    01S0479
         B     @RC00140                                         01S0479
@RF00140 DS    0H                                               01S0480
*          RELDEVNO = RELDEVNO+ONE;                             01S0480
         AL    RELDEVNO,@CF00056                                01S0480
*          SIOTNOPR = ON;             /*SIOT NOT ALL PROCESSED       */
         OI    SIOTNOPR,B'00000100'                             01S0481
*        END;                                                   01S0482
*        VUPTR=VUPTR + VOLENTLN;      /*POINT TO NEXT VOLUNIT ENTRY  */
@RC00140 LH    @07,VOLENTLN                                     01S0483
         AL    @07,VUPTR                                        01S0483
         ST    @07,VUPTR                                        01S0483
*      END;                                                     01S0484
         AL    NUMVOLUN,@CF00056                                01S0484
@DE00139 L     @07,SIOTPTR                                      01S0484
         CH    NUMVOLUN,SVOLUNNO(,@07)                          01S0484
         BNH   @DL00139                                         01S0484
@DC00139 DS    0H                                               01S0485
*      IF SIOTNOPR=OFF & SIOTALCD=OFF THEN /*REQ COMPLETELY ALLOC'D  */
         TM    SIOTNOPR,B'00000100'                             01S0485
         BNZ   @RF00485                                         01S0485
         L     @08,SIOTPTR                                      01S0485
         TM    SIOTALCD(@08),B'00000010'                        01S0485
         BNZ   @RF00485                                         01S0485
*        DO;                                                    01S0486
*          SIOTALCD=ON;               /*YES,MARK SIOT PROCESSED      */
         OI    SIOTALCD(@08),B'00000010'                        01S0487
*          TOTREQS=TOTREQS-1;         /*REDUCE TOTAL REQUEST COUNT   */
         L     @08,@PC00001                                     01S0488
         L     @08,ALCWAPTR(,@08)                               01S0488
         L     @15,TOTREQS(,@08)                                01S0488
         BCTR  @15,0                                            01S0488
         ST    @15,TOTREQS(,@08)                                01S0488
*        END;                                                   01S0489
*      ELSE                           /*SIOT NOT FULLY ALLOC'D       */
*        DO;                                                    01S0490
         B     @RC00485                                         01S0490
@RF00485 DS    0H                                               01S0491
*          IF EDLFINIS = ON & EDLMGENS = OFF THEN /*MUST EDL BE 01S0491
*                                       UPDATED ?                    */
         TM    EDLFINIS,B'10000000'                             01S0491
         BNO   @RF00491                                         01S0491
         L     @08,SIOTPTR                                      01S0491
         L     @08,SIOTEDLP(,@08)                               01S0491
         TM    EDLMGENS(@08),B'01000000'                        01S0491
         BNZ   @RF00491                                         01S0491
*            DO;                      /*YES, UPDATE THE EDL          */
*              EDLPSAVE = EDLPTR;                               01S0493
         LR    EDLPSAVE,EDLPTR                                  01S0493
*              EDLPTR = EDLFGENP;                               01S0494
         L     EDLPTR,EDLFGENP(,@08)                            01S0494
*              DO WHILE(EDLPTR^=ZERO);                          01S0495
         B     @DE00495                                         01S0495
@DL00495 DS    0H                                               01S0496
*                IF EDLPTR^=EDLPSAVE THEN /*GEN ALLOC'D              */
         CR    EDLPTR,EDLPSAVE                                  01S0496
         BE    @RF00496                                         01S0496
*                  EINDEVTP=ON;       /*NO, MARK INELIGIBLE          */
         OI    EINDEVTP(EDLPTR),B'10000000'                     01S0497
*                  EDLPTR=EDLNXTNT;                             01S0498
@RF00496 L     EDLPTR,EDLNXTNT(,EDLPTR)                         01S0498
*                END;                                           01S0499
@DE00495 LTR   EDLPTR,EDLPTR                                    01S0499
         BNZ   @DL00495                                         01S0499
*              END;                                             01S0500
*            ELSE;                    /*DON'T UPDATE EDL             */
@RF00491 DS    0H                                               01S0502
*          END;                                                 01S0502
*    END;                                                       01S0503
*  ELSE;                              /*SIOT WAS ALREADY PROCESSED   */
@RF00132 DS    0H                                               01S0505
*  SIOTPTR=SIOTNPTR;                  /*POINT TO NEXT SIOT(REQUEST)  */
@RC00132 L     @08,SIOTPTR                                      01S0505
         L     @08,SIOTNPTR(,@08)                               01S0505
         ST    @08,SIOTPTR                                      01S0505
*END;                                                           01S0506
         SLR   @08,@08                                          01S0506
         BCTR  @08,0                                            01S0506
         AL    @08,NUMSIOTS                                     01S0506
         ST    @08,NUMSIOTS                                     01S0506
@DE00131 LTR   @08,@08                                          01S0506
         BP    @DL00131                                         01S0506
@DC00131 DS    0H                                               01S0507
*RFY (REG0,REG1) RSTD;                                          01S0507
*IF REUSESW=ON THEN                    /*ALCUCBLT CORE FREED?@ZA02380*/
         TM    REUSESW,B'00000001'                              01S0508
         BNO   @RF00508                                         01S0508
*  DO;                                 /*NO,FREE CORE        @ZA02380*/
*    REG0=ALCULEN;                     /*LENGTH OF ALCUCBLT  @ZA02380*/
         L     REG0,ALCULEN                                     01S0510
*    REG0 = REG0 | TOO53;              /*SET SP253           @ZA02380*/
         O     REG0,@CF00956                                    01S0511
*    REG1=ALCUCBP;                     /*PTR TO ALCUCBLT     @ZA02380*/
         L     REG1,ALCUCBP(,OPTPARMP)                          01S0512
*    GEN (  FREEMAIN  R,LV=(0),A=(1) ); /*FREE ALCUCBLT CORE @ZA02380*/
           FREEMAIN  R,LV=(0),A=(1)
*  END;                                /*                    @ZA02380*/
*IF PSOPTCOR=ON THEN                  /*ERROR GETTING CORE?  @YM08667*/
@RF00508 TM    PSOPTCOR,B'10000000'                             01S0515
         BNO   @RF00515                                         01S0515
*  DO;                                /*NO,FREE CORE         @YM08667*/
*    REG0=PSOPTLEN;                   /*SET LENGTH TO FREED  @YM08667*/
         L     REG0,PSOPTLEN                                    01S0517
*    REG0 = REG0 | TOO53;              /*SET SP253                   */
         O     REG0,@CF00956                                    01S0518
*    REG1=LISTP;                       /*SET ADDRESS OF AREA TO FREE */
         L     REG1,LISTP                                       01S0519
*    GEN( FREEMAIN   R,LV=(0),A=(1) ); /*FREE CORE           @YM08667*/
          FREEMAIN   R,LV=(0),A=(1)
*  END;                                                         01S0521
*RFY (REG0,REG1) UNRSTD;                                        01S0522
@RF00515 DS    0H                                               01S0523
*RETURN CODE(RETCODE);                /*RETURN ERROR CODE TO CALLER  */
         L     @10,RETCODE                                      01S0523
         L     @13,4(,@13)                                      01S0523
         L     @00,@SIZDATD                                     01S0523
         LR    @01,@11                                          01S0523
         FSPACE   R,LV=(0),A=(1)
         LR    @15,@10                                          01S0523
         L     @14,12(,@13)                                     01S0523
         LM    @00,@12,20(@13)                                  01S0523
         BR    @14                                              01S0523
*/********************************************************************/
*/*                                                                  */
*/* SEGMENT NAME - PSLSTBLD                                          */
*/*                                                                  */
*/* DESCRIPTIVE NAME - BUILD PUBLIC/STORAGE UCB LIST, PSLIST         */
*/*                                                                  */
*/* FUNCTION                                                         */
*/*   THIS SUBROUTINE BUILDS THE PUBLIC/STORAGE UCB LIST(PSLIST) FOR */
*/*   AN EDL DEVICE TYPE ENTRY. THE LIST OF PERMANENTLY RESIDENT     */
*/*   OR RESERVED DEVICES, OR DEVICES WITH VOLUMES MOUNTED, WHICH ARE*/
*/*   ONLINE AND READY AND NOT IN USE BY OLTEP(PSUCBLST) IS SEARCHED */
*/*   FOR A UCB ADDRESS WHICH IS ALSO FOUND IN THE EDL. IF A MATCH   */
*/*   IS FOUND AND THE UCB HAS THE CORRECT USE ATTRIBUTE(PUBLIC OR   */
*/*   STORAGE DEPENDING ON THE TYPE OF PROCESSING BEING DONE), AN    */
*/*   ENTRY IS MADE INTO THE PSLIST AND THE INDEX INTO THE PSLIST    */
*/*   (PSLINDEX) IS INCREMENTED.                                     */
*/*                                                                  */
*/* ENTRY -                                                          */
*/*   PSLSTBLD - INTERNAL PROCEDURE NAME                             */
*/*                                                                  */
*/*   PURPOSE - TO BUILD THE PUBLIC/STORAGE LIST (PSLIST)            */
*/*                                                                  */
*/*   INPUT -                                                        */
*/*     POINTER TO THE EDL GENERIC ENTRY TO BE PROCESSED             */
*/*     POINTER TO PSUCBLST                                          */
*/*     INDEX INTO THE PUBLIC OR STORAGE UCB LIST                    */
*/*     MASK TO DETERMINE IF UCB HAS CORRECT ATTRIBUTE               */
*/*                                                                  */
*/* EXIT                                                             */
*/*                                                                  */
*/*   CONDITION -                                                    */
*/*     PSLIST CREATED                                               */
*/*                                                                  */
*/*   OUTPUT -                                                       */
*/*     PUBLIC/STORAGE UCB LIST                                      */
*/*     INDEX INTO PUBLIC/STORAGE LIST FOR THE NEXT ENTRY TO BE ADDED*/
*/*                                                                  */
*/*   RETURN CODE - NONE                                             */
*/*                                                                  */
*/********************************************************************/
*PSLSTBLD: PROC;                                                02S0524
PSLSTBLD STM   @14,@01,12(@13)                                  02S0524
         STM   @03,@12,32(@13)                                  02S0524
*EDLGNTP=EDLGRPTR;                     /*INIT PTR TO EDL GROUP ENTRY */
         L     EDLGNTP,EDLGRPTR(,EDLPTR)                        02S0525
*LPSUCBPT = PSUCBPTR;                  /*COPY UCB LIST PTR   @YM08667*/
         L     @08,@PC00001+4                                   02S0526
         L     LPSUCBPT,PSUCBPTR(,@08)                          02S0526
*RFY PSUCBLST BASED(LPSUCBPT);         /*RESET LIST BASE PTR @YM08667*/
*IF EINDEVTP=OFF THEN                  /*ELIGIBLE DEVICE TYPE?       */
         TM    EINDEVTP(EDLPTR),B'10000000'                     02S0528
         BNZ   @RF00528                                         02S0528
*  DO EDLINDX1 = 1 TO EDLGRPNO;        /*YES,PROCESS GROUPS IN EDL   */
         LA    EDLINDX1,1                                       02S0529
         B     @DE00529                                         02S0529
@DL00529 DS    0H                                               02S0530
*    IF EDLJINEL = OFF THEN            /*GROUP IS ELIG.      @Y30QPPA*/
         TM    EDLJINEL(EDLGNTP),B'10000000'                    02S0530
         BNZ   @RF00530                                         02S0530
*      DO;                             /*                    @Y30QPPA*/
*        EDLUCBLP=EDLLISTP;            /*POINT TO UCB LIST           */
         MVC   EDLUCBLP(4),EDLLISTP(EDLGNTP)                    02S0532
*        DO EDLINDEX=1 TO EDLUCBNO;    /*PROCESS UCBS WITHIN GROUP   */
         LA    @08,1                                            02S0533
         B     @DE00533                                         02S0533
@DL00533 DS    0H                                               02S0534
*          IF EDLALCD(EDLINDEX)=OFF |  /*THIS DEVICE ELIGIBLE?       */
*            (EDLALCD(EDLINDEX) = ON                            02S0534
*            & EDLVOLAF(EDLINDEX) = ON                          02S0534
*            & PARTALOC = ON) THEN                              02S0534
         L     @06,EDLUCBLP                                     02S0534
         SLA   @08,2                                            02S0534
         ST    @08,@TF00001                                     02S0534
         ALR   @08,@06                                          02S0534
         BCTR  @08,0                                            02S0534
         BCTR  @08,0                                            02S0534
         TM    EDLALCD-2(@08),B'10000000'                       02S0534
         BZ    @RT00534                                         02S0534
         AL    @06,@TF00001                                     02S0534
         BCTR  @06,0                                            02S0534
         BCTR  @06,0                                            02S0534
         TM    EDLALCD-2(@06),B'10010000'                       02S0534
         BNO   @RF00534                                         02S0534
         L     @08,@PC00001+8                                   02S0534
         L     @08,PSPARMP(,@08)                                02S0534
         TM    PARTALOC(@08),B'00000001'                        02S0534
         BNO   @RF00534                                         02S0534
@RT00534 DS    0H                                               02S0535
*            DO;                                                02S0535
*              UCBMATCH=OFF;           /*YES,INIT MATCH FOUND SWITCH */
         NI    UCBMATCH,B'01111111'                             02S0536
*              DO UCBINDEX=1 BY 1      /*SEARCH INPUT UCB LIST       */
*                WHILE(PSUCBLST(UCBINDEX)^=TABEND & UCBMATCH=OFF);/*
*                                     STOP AT END OF LIST OR IF MATCH*/
         LA    UCBINDEX,1                                       02S0537
         B     @DE00537                                         02S0537
@DL00537 DS    0H                                               02S0538
*                IF (EDLUCBAD(EDLINDEX)=PSUCBLST(UCBINDEX)) &   02S0538
*                    (EDLNOJES(EDLINDEX) = OFF) THEN /*IF JES3 BIT
*                                        OFF, OR IF MATCH, THIS UCB MAY
*                                       BE USED              @ZA12457*/
         L     @08,EDLUCBLP                                     02S0538
         L     @06,EDLINDEX                                     02S0538
         SLA   @06,2                                            02S0538
         LR    @15,UCBINDEX                                     02S0538
         ALR   @15,@15                                          02S0538
         ST    @06,@TF00001                                     02S0538
         ALR   @06,@08                                          02S0538
         AL    @06,@CF01109                                     02S0538
         ST    @15,@TF00002                                     02S0538
         ALR   @15,LPSUCBPT                                     02S0538
         BCTR  @15,0                                            02S0538
         BCTR  @15,0                                            02S0538
         CLC   EDLUCBAD(2,@06),PSUCBLST(@15)                    02S0538
         BNE   @RF00538                                         02S0538
         AL    @08,@TF00001                                     02S0538
         BCTR  @08,0                                            02S0538
         BCTR  @08,0                                            02S0538
         TM    EDLNOJES-2(@08),B'00001000'                      02S0538
         BNZ   @RF00538                                         02S0538
*                  DO;                                          02S0539
*                    UCBMATCH=ON;      /*YES,INDICATE MATCH FOUND    */
         OI    UCBMATCH,B'10000000'                             02S0540
*                    UCBPTR=PSUCBLST(UCBINDEX);/*SET UCBPTR          */
         LR    @08,LPSUCBPT                                     02S0541
         AL    @08,@TF00002                                     02S0541
         BCTR  @08,0                                            02S0541
         BCTR  @08,0                                            02S0541
         SLR   @06,@06                                          02S0541
         ICM   @06,3,PSUCBLST(@08)                              02S0541
         ST    @06,UCBPTR                                       02S0541
*                    IF (UCBSTAB & UCBMASK) ^= ZERO THEN /*UCB HAVE OK
*                                         USE ATTRIUBTE?             */
         SLR   @08,@08                                          02S0542
         IC    @08,UCBSTAB(,@06)                                02S0542
         SLR   @15,@15                                          02S0542
         IC    @15,UCBMASK                                      02S0542
         NR    @08,@15                                          02S0542
         LTR   @08,@08                                          02S0542
         BZ    @RF00542                                         02S0542
*                      DO;             /*YES                         */
*                        PSLSTENT(PSLINDEX)=PSUCBLST(UCBINDEX); /*PUT
*                                        UCB ADDR IN PSLIST          */
         LR    @08,PSLINDEX                                     02S0544
         SLA   @08,2                                            02S0544
         L     @01,PSLISTP(,OPTPARMP)                           02S0544
         ST    @06,PSLSTENT-4(@08,@01)                          02S0544
*                        PSLINDEX=PSLINDEX+1;/*UPDATE ENTRY INDEX    */
         AL    PSLINDEX,@CF00056                                02S0545
*                      END;                                     02S0546
*                    ELSE;             /*UCB HAS WRONG ATTRIBUTE     */
@RF00542 DS    0H                                               02S0548
*                  END;                                         02S0548
*                ELSE;                 /*UCB'S DON'T MATCH           */
@RF00538 DS    0H                                               02S0550
*              END;                                             02S0550
         AL    UCBINDEX,@CF00056                                02S0550
@DE00537 LR    @08,UCBINDEX                                     02S0550
         ALR   @08,@08                                          02S0550
         ALR   @08,LPSUCBPT                                     02S0550
         BCTR  @08,0                                            02S0550
         BCTR  @08,0                                            02S0550
         SLR   @06,@06                                          02S0550
         ICM   @06,3,PSUCBLST(@08)                              02S0550
         LTR   @06,@06                                          02S0550
         BZ    @DC00537                                         02S0550
         TM    UCBMATCH,B'10000000'                             02S0550
         BZ    @DL00537                                         02S0550
@DC00537 DS    0H                                               02S0551
*            END;                                               02S0551
*          ELSE;                       /*EDL ENTRY NOT ELIGIBLE      */
@RF00534 DS    0H                                               02S0553
*        END;                                                   02S0553
         LA    @08,1                                            02S0553
         AL    @08,EDLINDEX                                     02S0553
@DE00533 ST    @08,EDLINDEX                                     02S0553
         C     @08,EDLUCBNO(,EDLGNTP)                           02S0553
         BNH   @DL00533                                         02S0553
*      END;                            /*                    @Y30QPPA*/
*    EDLGNTP=EDLNXGRP;                 /*POINT TO NEXT GROUP ENTRY   */
@RF00530 L     EDLGNTP,EDLNXGRP(,EDLGNTP)                       02S0555
*  END;                                                         02S0556
         AL    EDLINDX1,@CF00056                                02S0556
@DE00529 C     EDLINDX1,EDLGRPNO(,EDLPTR)                       02S0556
         BNH   @DL00529                                         02S0556
*PSLISTNO=PSLINDEX-1;                  /*NO. OF ENTRIES IN PLSIST    */
@RF00528 L     @08,PSLISTP(,OPTPARMP)                           02S0557
         LR    @03,PSLINDEX                                     02S0557
         BCTR  @03,0                                            02S0557
         ST    @03,PSLISTNO(,@08)                               02S0557
*END PSLSTBLD;                                                  02S0558
@EL00002 DS    0H                                               02S0558
@EF00002 DS    0H                                               02S0558
@ER00002 LM    @14,@01,12(@13)                                  02S0558
         LM    @03,@12,32(@13)                                  02S0558
         BR    @14                                              02S0558
*/********************************************************************/
*/* SEGMENT NAME - VUSCAN                                    @ZA04836*/
*/*                                                          @ZA04836*/
*/* DESCRIPTIVE NAME - VOLUNIT TABLE SCAN ROUTINE            @ZA04836*/
*/*                                                          @ZA04836*/
*/* FUNCTION -                                               @ZA04836*/
*/*   THIS ROUTINE SCANS THE VOLUNIT TABLE.  IF IT FINDS A VU@ZA04836*/
*/*   ENTRY WITH THE SAME VOLUNIT ID AS THE INPUT VU ENTRY,  @ZA04836*/
*/*   IT SETS THE FOLLOWING INDICATORS IN THE VU ENTRY       @ZA04836*/
*/*   VUDADSME AND VUDNALOC.                                 @ZA04836*/
*/*                                                          @ZA04836*/
*/* ENTRY -                                                  @ZA04836*/
*/*   VUSCAN - INTERNAL PROCEDURE NAME                       @ZA04836*/
*/*                                                          @ZA04836*/
*/*   PURPOSE - MARKS ERROR INDICATORS IN VOLUNIT ENTRIES    @ZA04836*/
*/*                                                          @ZA04836*/
*/*   INPUT -                                                @ZA04836*/
*/*     NUMVUENT - TOTAL NUMBER OF VOLUNIT ENTRIES           @ZA04836*/
*/*     AVUPTR - POINTER TO THE VU ENTRY BEING PROCESSED     @ZA04836*/
*/*      - VU ENTRY CONTAINS A POINTER SIOT                  @ZA04836*/
*/*                                                          @ZA04836*/
*/* EXIT -                                                   @ZA04836*/
*/*   CONDITION - FUNCTION COMPLETED                         @ZA04836*/
*/*                                                          @ZA04836*/
*/*   OUTPUT -                                               @ZA04836*/
*/*     UPDATED VOLUNIT ENTRIES -                            @ZA04836*/
*/*       DADSM ERROR INDICATOR ON                           @ZA04836*/
*/*       DO NOT ALLOCATE ENTRY INDICATOR ON                 @ZA04836*/
*/*       CHECK REQUEST FOR AFFINITIES INDICATOR ON          @ZA04836*/
*/*                                                          @ZA04836*/
*/*     UPDATED SIOT -                                       @ZA04836*/
*/*       REQUEST HAS AFFINITIES INDICATOR ON                @ZA04836*/
*/*                                                          @ZA04836*/
*/*   RETURN CODES - NONE                                    @ZA04836*/
*/*                                                          @ZA04836*/
*/********************************************************************/
*VUSCAN: PROC;                                                  02S0559
VUSCAN   STM   @14,@12,12(@13)                                  02S0559
*AFFVUPTR = VOLUNPTR;                                           02S0560
         L     @10,@PC00001                                     02S0560
         L     @10,ALCWAPTR(,@10)                               02S0560
         L     AFFVUPTR,VOLUNPTR(,@10)                          02S0560
*DO SCANCTR = ONE TO NUMVUENT;                                  02S0561
         LA    SCANCTR,1                                        02S0561
         B     @DE00561                                         02S0561
@DL00561 DS    0H                                               02S0562
*  IF AVUPTR -> VOLUNTID = AFFVUPTR -> VOLUNTID THEN /*VOLUNIT IDS SAME
*                                                            @ZA04836*/
         CLC   VOLUNTID(2,AVUPTR),VOLUNTID(AFFVUPTR)            02S0562
         BNE   @RF00562                                         02S0562
*    DO;                                                        02S0563
*      AFFVUPTR->VUDADSME=ON;          /*SET DADSM ERROR SW  @ZA04836*/
*      AFFVUPTR->VUDNALOC=ON;          /*SET DONT PROCESS VU ENTRY SW
*                                                            @ZA04836*/
         OI    VUDADSME(AFFVUPTR),B'00001100'                   02S0565
*     IF AVUPTR ^= AFFVUPTR THEN                                02S0566
         CR    AVUPTR,AFFVUPTR                                  02S0566
         BE    @RF00566                                         02S0566
*       DO;                                                     02S0567
*         CHCKSIOT=ON;                 /*SET CHECK FOR AFF SW@ZA04836*/
         OI    CHCKSIOT,B'10000000'                             02S0568
*         AFFVUPTR->VOLSIOTP->SIOTAFF=ON; /*SET SIOT HAS AFFINITY
*                                                            @ZA04836*/
         L     @10,VOLSIOTP(,AFFVUPTR)                          02S0569
         OI    SIOTAFF(@10),B'00100000'                         02S0569
*       END;                                                    02S0570
*     ELSE;                                                     02S0571
@RF00566 DS    0H                                               02S0572
*    END;                                                       02S0572
*  ELSE;                               /*VOLUNIT IDS DONT MATCH 02S0573
*                                                            @ZA04836*/
@RF00562 DS    0H                                               02S0574
*  AFFVUPTR=AFFVUPTR+VOLENTLN;                                  02S0574
         AH    AFFVUPTR,VOLENTLN                                02S0574
*END;                                                           02S0575
         AL    SCANCTR,@CF00056                                 02S0575
@DE00561 CR    SCANCTR,NUMVUENT                                 02S0575
         BNH   @DL00561                                         02S0575
*END VUSCAN;                                                    02S0576
@EL00003 DS    0H                                               02S0576
@EF00003 DS    0H                                               02S0576
@ER00003 LM    @14,@12,12(@13)                                  02S0576
         BR    @14                                              02S0576
*                                                               01S0577
*                                                               01S0577
* DECLARE /* COMMON VARIABLES */                                01S0577
*   I256C CHAR(256) BASED,                                      01S0577
*   I031F FIXED(31) BASED,                                      01S0577
*   I031P PTR(31)   BASED,                                      01S0577
*   I015F FIXED(15) BASED,                                      01S0577
*   I015P PTR(15)   BASED,                                      01S0577
*   I008P PTR(8)    BASED,                                      01S0577
*   I001C CHAR(1)   BASED;                                      01S0577
*END IEFAB436                                                   01S0578
*/* THE FOLLOWING INCLUDE STATEMENTS WERE FOUND IN THIS PROGRAM.      *
*/*%INCLUDE SYSLIB  (A436SPEC)                                        *
*/*%INCLUDE SYSLIB  (A436DATA)                                        *
*/*%INCLUDE SYSLIB  (IEFASIOT)                                        *
*/*%INCLUDE SYSLIB  (IEFUCBOB)                                        *
*/*%INCLUDE SYSLIB  (IEFZB423)                                        *
*/*%INCLUDE SYSLIB  (IEFZB425)                                        *
*/*%INCLUDE SYSLIB  (IEZJSCB )                                        *
*/*%INCLUDE SYSLIB  (PSALCDAT)                                        *
*/*%INCLUDE SYSLIB  (PSINTDAT)                                        *
*/*%INCLUDE SYSLIB  (PSLSTDAT)                                        *
*/*%INCLUDE SYSLIB  (PSVOLDAT)                                        *
*/*%INCLUDE SYSLIB  (IEFZB422)                                        *
*/*%INCLUDE SYSLIB  (PSCTLINT)                                        *
*/*%INCLUDE SYSLIB  (PSINTSPC)                                        *
*/*%INCLUDE SYSLIB  (PSVOLUN )                                        *
*/*%INCLUDE SYSLIB  (PSVOLSPC)                                        *
*/*%INCLUDE SYSLIB  (PSLSTMNT)                                        *
*/*%INCLUDE SYSLIB  (PSMNTSPC)                                        *
*/*%INCLUDE SYSLIB  (PSALLOC )                                        *
*/*%INCLUDE SYSLIB  (PSALCSPC)                                        *
*/*%INCLUDE SYSLIB  (PSFNDEDL)                                        *
*/*%INCLUDE SYSLIB  (PSEDLSPC)                                        *
*/*%INCLUDE SYSLIB  (PVTUPDTE)                                        *
*/*%INCLUDE SYSLIB  (PVTUPSPC)                                        *
*/*%INCLUDE SYSLIB  (AFFCHCK )                                        *
*/*%INCLUDE SYSLIB  (AFFCKSPC)                                        *
*/*%INCLUDE SYSLIB  (PSLSTBLD)                                        *
*/*%INCLUDE SYSLIB  (PSBLDSPC)                                        *
*/*%INCLUDE SYSLIB  (VUSCAN  )                                        *
*/*%INCLUDE SYSLIB  (VUSCNSPC)                                        *
*;                                                              01S0578
@DATA    DS    0H
@CH00065 DC    H'2'
@CH00058 DC    H'8'
@CH00991 DC    H'9'
@CH00986 DC    H'12'
@CH01088 DC    H'20'
@CH01051 DC    H'26'
@CH00955 DC    H'32'
@CH00994 DC    H'36'
@CH00996 DC    H'40'
@DATD    DSECT
         DS    0F
@SA00001 DS    18F
@PC00001 DS    3F
@AL00001 DS    8A
@TF00001 DS    F
@TF00002 DS    F
IEFAB436 CSECT
         DS    0F
@CF00056 DC    F'1'
@CH00056 EQU   @CF00056+2
@CF00160 DC    F'4'
@CF00958 DC    F'253'
@CF01109 DC    F'-4'
@CF00956 DC    XL4'FD000000'
@DATD    DSECT
         DS    0D
COUNTABP DS    A
LISTP    DS    A
SIOTPTR  DS    A
UCBPTR   DS    A
VUPTR    DS    A
TCBJSCB  DS    A
ALCULEN  DS    F
ARUINDIC DS    FL4
         ORG   ARUINDIC
ARUETUPD DS    BL1
ARUUSECT EQU   ARUINDIC+0
ARUAFF   EQU   ARUINDIC+0
ARUVLCHK EQU   ARUINDIC+0
ARUUSEST EQU   ARUINDIC+0
ARUUPDAL EQU   ARUINDIC+0
ARUVOLSW EQU   ARUINDIC+0
         ORG   ARUINDIC+4
NUMSIOTS DS    F
RETCODE  DS    F
SUBPL    DS    F
TCBADD   DS    A
UCBPARMP DS    A
VOLSERP  DS    A
ARUGRPID DS    F
ARUWORD  DS    FL4
         ORG   ARUWORD
ARURLPOS DS    FL2
ARUNDEVS DS    FL2
         ORG   ARUWORD+4
PSOPTLEN DS    F
EDLINDEX DS    F
EDLUCBLP DS    A
GTSTRTCD DS    F
@TS00001 DS    CL1
DOINGDA  DS    BL1
EDLFINIS DS    BL1
FIRSTALC DS    BL1
MASKS    DS    CL2
         ORG   MASKS
UCBMASK  DS    BL1
         ORG   UCBMASK
@NM00028 DS    BL1
PUBUCB   EQU   UCBMASK+0
STGUCB   EQU   UCBMASK+0
@NM00029 EQU   UCBMASK+0
         ORG   MASKS+1
VOLUMASK DS    BL1
         ORG   VOLUMASK
PUBVOL   DS    BL1
@NM00030 EQU   VOLUMASK+0
STGVOL   EQU   VOLUMASK+0
@NM00031 EQU   VOLUMASK+0
         ORG   MASKS+2
PSOPTCOR DS    BL1
SWITCHES DS    BL2
         ORG   SWITCHES
CHCKSIOT DS    BL1
ENQERROR EQU   SWITCHES+0
PSLEXIST EQU   SWITCHES+0
PSLUPDAT EQU   SWITCHES+0
DADSMESW EQU   SWITCHES+0
SIOTNOPR EQU   SWITCHES+0
VOLUNOPR EQU   SWITCHES+0
REUSESW  EQU   SWITCHES+0
UCBMATCH DS    BL1
         ORG   SWITCHES+2
F0MAP    DS    BL1
         ORG   F0MAP
VOLUMENQ DS    BL1
VOLUMEDQ EQU   F0MAP+0
VOLEXCLU EQU   F0MAP+0
@NM00034 EQU   F0MAP+0
         ORG   F0MAP+1
UCBPARMS DS    CL9
         ORG   UCBPARMS
@NM00035 DS    CL2
VOLUMEID DS    CL6
@NM00036 DS    CL1
         ORG   UCBPARMS+9
IEFAB436 CSECT
         DS    0F
@SIZDATD DC    AL1(230)
         DC    AL3(@ENDDATD-@DATD)
@CV00963 DC    V(IEFAB4F0)
@CV00964 DC    V(IEFAB440)
@CV00965 DC    V(IEFAB442)
@CV00967 DC    V(IEFAB434)
         DS    0D
PSHDRLEN DC    AL4(4)
GTSTZERO DC    F'0'
VOLENTLN DC    AL2(28)
PSENTLN  DC    AL2(4)
@CB00943 DC    B'10000000'
CLRMASK  DC    XL2'0'
IEFAB436 CSECT
         DS   0H
PATCHLOC DC ((@DATA-@PSTART)/20)X'00'
@DATD    DSECT
         ORG   *+1-(*-@DATD)/(*-@DATD) INSURE DSECT DATA
@ENDDATD EQU   *
IEFAB436 CSECT
@00      EQU   00                      EQUATES FOR REGISTERS 0-15
@01      EQU   01
@02      EQU   02
@03      EQU   03
@04      EQU   04
@05      EQU   05
@06      EQU   06
@07      EQU   07
@08      EQU   08
@09      EQU   09
@10      EQU   10
@11      EQU   11
@12      EQU   12
@13      EQU   13
@14      EQU   14
@15      EQU   15
VUCTR1   EQU   @03
VUCTR    EQU   @04
SAVENDEX EQU   @03
PSLINDEX EQU   @02
VUSAVE   EQU   @05
TVUPTR   EQU   @02
EDLPTR   EQU   @10
EDLPSAVE EQU   @02
EDLGNTP  EQU   @03
UCBINDEX EQU   @05
EDLINDX1 EQU   @07
RELDEVNO EQU   @06
SCANCTR  EQU   @04
NUMVUENT EQU   @05
NUMVOLUN EQU   @08
AVUCTR   EQU   @04
AFFCTR   EQU   @02
ERETCODE EQU   @02
OPTPARMP EQU   @09
LPSUCBPT EQU   @04
AVUPTR   EQU   @03
ASIOTPTR EQU   @02
AFFVUPTR EQU   @02
REG0     EQU   @00
REG1     EQU   @01
REG15    EQU   @15
GTSTR0   EQU   @00
GTSTR1   EQU   @01
GTSTR2   EQU   @02
GTSTR15  EQU   @15
GTSTR4   EQU   @04
GTSTR5   EQU   @05
GTSTR6   EQU   @06
GTSTR7   EQU   @07
GTSTR8   EQU   @08
GTSTR3   EQU   @03
INDMSIOT EQU   0
SCTUSADD EQU   INDMSIOT+20
SIOTOTUN EQU   INDMSIOT+39
SIOPSCNT EQU   INDMSIOT+42
SIOTBYT1 EQU   INDMSIOT+43
SIOTALCD EQU   SIOTBYT1
SIOTBYT3 EQU   INDMSIOT+46
SIOTTSTC EQU   INDMSIOT+47
SIOTBYT0 EQU   INDMSIOT+52
SPVTAMSG EQU   SIOTBYT0
SIOTGIGN EQU   SIOTBYT0
SCTSDISP EQU   INDMSIOT+55
SCTSBYT1 EQU   INDMSIOT+56
SCTSBYT2 EQU   INDMSIOT+57
SCTSBYT3 EQU   INDMSIOT+58
SCTSBYT4 EQU   INDMSIOT+59
SIOTAFF  EQU   SCTSBYT4
SCTUTYPE EQU   INDMSIOT+60
SIOTDEVT EQU   SCTUTYPE
SIOUBYT3 EQU   SIOTDEVT+2
SIOTALTD EQU   INDMSIOT+92
SIOTBYT2 EQU   INDMSIOT+103
SIOTRSNC EQU   INDMSIOT+130
SIOTEDLP EQU   INDMSIOT+136
SVOLUNAD EQU   INDMSIOT+140
SIOTETIO EQU   INDMSIOT+148
SIOTNPTR EQU   INDMSIOT+152
SVOLUNNO EQU   INDMSIOT+168
UCB      EQU   0
UCBOB    EQU   0
UCBJBNR  EQU   UCBOB
UCBFL5   EQU   UCBOB+1
UCBAF    EQU   UCBFL5
UCBSTAT  EQU   UCBOB+3
UCBRESV  EQU   UCBSTAT
UCBPRES  EQU   UCBSTAT
UCBCHAN  EQU   UCBOB+4
UCBSFLS  EQU   UCBOB+6
UCBFLA   EQU   UCBSFLS
UCBFL1   EQU   UCBFLA
UCBBSY   EQU   UCBFL1
UCBNRY   EQU   UCBFL1
UCBPST   EQU   UCBFL1
UCBCUB   EQU   UCBFL1
UCBFLB   EQU   UCBSFLS+1
UCBCHM   EQU   UCBOB+8
UCBCHM1  EQU   UCBCHM
UCBPTH0  EQU   UCBCHM1
UCBPTH1  EQU   UCBCHM1
UCBWGT   EQU   UCBOB+12
UCBTYP   EQU   UCBOB+16
UCBTBYT1 EQU   UCBTYP
UCB1FEA5 EQU   UCBTBYT1
UCB1FEA6 EQU   UCBTBYT1
UCBTBYT2 EQU   UCBTYP+1
UCB2OPT2 EQU   UCBTBYT2
UCBDUDN1 EQU   UCB2OPT2
UCB2OPT3 EQU   UCBTBYT2
UCBDUDN2 EQU   UCB2OPT3
UCB2OPT4 EQU   UCBTBYT2
UCBRWTAU EQU   UCB2OPT4
UCB2OPT6 EQU   UCBTBYT2
UCB2OPT7 EQU   UCBTBYT2
UCBTBYT3 EQU   UCBTYP+2
UCBDVCLS EQU   UCBTBYT3
UCB3TAPE EQU   UCBDVCLS
UCB3DACC EQU   UCBDVCLS
UCBTBYT4 EQU   UCBTYP+3
UCBEXTPT EQU   UCBOB+20
UCBFLC   EQU   UCBEXTPT
UCBDEV   EQU   UCBOB+24
UCBCMEXT EQU   0
UCBATI   EQU   UCBCMEXT+3
@NM00018 EQU   UCBATI
UCBFLP1  EQU   UCBCMEXT+5
UCBMT    EQU   0
UCBOCR   EQU   0
UCB3540X EQU   0
UCBDKBYT EQU   UCB3540X+6
UCB3800X EQU   0
UCBOPTNS EQU   UCB3800X
UCBACTIV EQU   UCB3800X+3
UCBMDRBF EQU   UCB3800X+36
UCBUCS   EQU   0
UCBUCSOP EQU   UCBUCS+4
UCBFCBOP EQU   UCBUCS+5
VOLUNTAB EQU   0
VOLID    EQU   VOLUNTAB
VOLSTAT  EQU   VOLUNTAB+6
VOLSTATA EQU   VOLSTAT
VOLPUB   EQU   VOLSTATA
VOLPRV   EQU   VOLSTATA
VOLSTG   EQU   VOLSTATA
VOLNSHR  EQU   VOLSTATA
VOLSTATB EQU   VOLSTAT+1
VOLALOC  EQU   VOLSTATB
VDEVREQD EQU   VOLSTATB
VUDNALOC EQU   VOLSTATB
VUDADSME EQU   VOLSTATB
VOLSTATC EQU   VOLSTAT+2
VOLSTATD EQU   VOLSTAT+3
VOLUNTID EQU   VOLUNTAB+10
VOLSIOTP EQU   VOLUNTAB+16
ALCWA    EQU   0
SIOT1P   EQU   ALCWA+8
JSCBPTR  EQU   ALCWA+12
FAILRSCP EQU   ALCWA+20
CNTABLE  EQU   ALCWA+28
PVTNREQS EQU   CNTABLE+16
PUBLREQS EQU   CNTABLE+20
STRGREQS EQU   CNTABLE+24
TOTREQS  EQU   CNTABLE+36
NUMREQS  EQU   CNTABLE+40
TOTVOLUN EQU   CNTABLE+44
VOLUNPTR EQU   ALCWA+80
VOLUNSZE EQU   ALCWA+84
INDICATE EQU   ALCWA+112
PRIVASUM EQU   INDICATE
@NM00022 EQU   ALCWA+113
TIOTHDRP EQU   ALCWA+120
LGENLOCK EQU   ALCWA+124
NAMES    EQU   0
IEZJSCB  EQU   0
JSCBSEC1 EQU   IEZJSCB+188
JSCHPCE  EQU   JSCBSEC1+4
JSCBTCBP EQU   JSCBSEC1+20
JSCBDCB  EQU   JSCBSEC1+36
JSCBOPTS EQU   JSCBSEC1+48
JSCBSWT1 EQU   JSCBSEC1+55
JSCBWTP  EQU   JSCBSEC1+64
JSCBWTFG EQU   JSCBWTP
JSCBEND1 EQU   IEZJSCB+260
ALCUCBLT EQU   0
FAILRSC  EQU   0
OPTPARMS EQU   0
PSLISTP  EQU   OPTPARMS
ALCUCBP  EQU   OPTPARMS+4
RETPARMP EQU   OPTPARMS+8
RETAREA  EQU   OPTPARMS+12
OPTDEVP  EQU   RETAREA
PSCNTENT EQU   0
PSLIST   EQU   0
PSLISTNO EQU   PSLIST
PSLSTENT EQU   PSLIST+4
PSPARM   EQU   0
PSSW     EQU   PSPARM
PSPUB    EQU   PSSW
PSSTRG   EQU   PSSW
PUBSTOR  EQU   PSSW
MOUNTED  EQU   PSSW
PARTALOC EQU   PSSW
PSUCBLEN EQU   PSPARM+4
PSUCBLST EQU   0
IEFEDL   EQU   0
EDLHDR   EQU   IEFEDL
EDLFGENP EQU   EDLHDR+8
EDLUVFLG EQU   EDLHDR+16
EDLMGENS EQU   EDLUVFLG
EDLENTRY EQU   0
EDLNXTNT EQU   EDLENTRY
EDLDEVT  EQU   EDLENTRY+4
EDLGRPNO EQU   EDLENTRY+8
EDLGRPTR EQU   EDLENTRY+12
EDLNSCNT EQU   EDLENTRY+16
EDLDTFLG EQU   EDLENTRY+20
EINDEVTP EQU   EDLDTFLG
EDLGNTRY EQU   0
EDLNXGRP EQU   EDLGNTRY
EDLUCBNO EQU   EDLGNTRY+4
EDLLISTP EQU   EDLGNTRY+8
EDLGRID  EQU   EDLGNTRY+12
EDLGRFLG EQU   EDLGNTRY+16
EDLJINEL EQU   EDLGRFLG
EDLUCBL  EQU   0
EDLUCBAD EQU   EDLUCBL
EDLINDIC EQU   EDLUCBL+2
EDLALCD  EQU   EDLINDIC
EDLDADSM EQU   EDLINDIC
EDLENQ   EQU   EDLINDIC
EDLVOLAF EQU   EDLINDIC
EDLNOJES EQU   EDLINDIC
I001C    EQU   0
I008P    EQU   0
I015F    EQU   0
I015P    EQU   0
I031F    EQU   0
I031P    EQU   0
I256C    EQU   0
UCBBGN   EQU   0
ALCWAPTR EQU   0
PSUCBPTR EQU   0
PSPARMP  EQU   0
UCBOBS01 EQU   UCBDEV
UCBVOLI  EQU   UCBOBS01+4
UCBSTAB  EQU   UCBOBS01+10
UCBBSVL  EQU   UCBSTAB
UCBPRSRS EQU   UCBSTAB
UCBDMCT  EQU   UCBOBS01+11
UCBFL4   EQU   UCBOBS01+13
UCBOBS02 EQU   UCBDEV
UCBTFL1  EQU   UCBOBS02+19
UCBXTN   EQU   UCBOBS02+20
UCBVOPT  EQU   UCBXTN
UCBOBS03 EQU   UCBDEV
UCBXTADR EQU   UCBOBS03
UCBOBS04 EQU   UCBDEV
UCBBTA   EQU   UCBOBS04+12
UCBOBS06 EQU   UCBDEV
UCBAOF   EQU   UCBOBS06
UCBAOF1  EQU   UCBAOF
UCBAOF2  EQU   UCBAOF+1
@NM00017 EQU   UCBOBS06+3
UCBIRB   EQU   UCBOBS06+4
UCBGRAF  EQU   UCBIRB
UCBLDNCA EQU   UCBOBS06+8
UCBRDYQ  EQU   UCBLDNCA
UCBIRLN  EQU   UCBRDYQ
UCBLDNCB EQU   UCBRDYQ+1
UCBCTLNK EQU   UCBOBS06+12
UCBOBS07 EQU   UCBDEV
UCBOBS08 EQU   UCBDEV
UCBCTCAD EQU   UCBOBS08
UCBCTCF1 EQU   UCBOBS08+4
UCBOBS09 EQU   UCBDEV
JSCBSEC2 EQU   JSCBEND1
JSCBSEC3 EQU   JSCBEND1
JSCBJCT  EQU   JSCBSEC3
JSCBJCTA EQU   JSCBJCT+1
JSCBASID EQU   JSCBSEC3+8
JSCBFBYT EQU   JSCBSEC3+10
JSCBJNL  EQU   JSCBSEC3+28
JSCBJJSB EQU   JSCBJNL
JSCBSUB  EQU   JSCBSEC3+40
JSCSCT   EQU   JSCBSEC3+68
JSCRSV45 EQU   JSCBSEC3+112
JSCRSV46 EQU   JSCRSV45
JSCRSV47 EQU   JSCRSV45+2
         AGO   .@UNREFD                START UNREFERENCED COMPONENTS
JSCBEND3 EQU   JSCBSEC3+120
JSCRSV52 EQU   JSCBSEC3+116
JSCRSV51 EQU   JSCRSV47+1
JSCRSV50 EQU   JSCRSV47
JSCRSV49 EQU   JSCRSV46+1
JSCRSV48 EQU   JSCRSV46
JSCRSV44 EQU   JSCBSEC3+108
JSCRSV43 EQU   JSCBSEC3+104
JSCRSV42 EQU   JSCBSEC3+100
JSCBASWA EQU   JSCBSEC3+96
JSCBUFPT EQU   JSCBSEC3+92
JSCBACT  EQU   JSCBSEC3+88
JSCBSWSP EQU   JSCBSEC3+87
JSCRSV33 EQU   JSCBSEC3+86
JSCDDNUM EQU   JSCBSEC3+84
JSCRSV53 EQU   JSCBSEC3+82
JSCDDNNO EQU   JSCBSEC3+80
JSCBVATA EQU   JSCBSEC3+76
JSCTMCOR EQU   JSCBSEC3+72
JSCSCTP  EQU   JSCSCT+1
JSCRSV55 EQU   JSCSCT
JSCRSV54 EQU   JSCBSEC3+64
JSCDSABQ EQU   JSCBSEC3+60
JSCBSSIB EQU   JSCBSEC3+56
JSCBFRBA EQU   JSCBSEC3+48
JSCRSV28 EQU   JSCBSEC3+46
JSCBSONO EQU   JSCBSEC3+44
JSCBSUBA EQU   JSCBSUB+1
JSCRSV31 EQU   JSCBSUB
JSCBSMLR EQU   JSCBSEC3+36
JSCBJNLR EQU   JSCBSEC3+32
JSCBJNLA EQU   JSCBJNL+1
JSCBJSBT EQU   JSCBJJSB
JSCBJSBX EQU   JSCBJJSB
JSCBJSBA EQU   JSCBJJSB
JSCBJSBI EQU   JSCBJJSB
@NM00027 EQU   JSCBJJSB
JSCBJNLE EQU   JSCBJJSB
JSCBJNLF EQU   JSCBJJSB
JSCBJNLN EQU   JSCBJJSB
@NM00026 EQU   JSCBSEC3+24
JSCBJRBA EQU   JSCBSEC3+16
JSCBIECB EQU   JSCBSEC3+12
JSCBRV08 EQU   JSCBSEC3+11
JSCBRV07 EQU   JSCBFBYT
JSCBRV06 EQU   JSCBFBYT
JSCBRV05 EQU   JSCBFBYT
JSCBRV04 EQU   JSCBFBYT
JSCBRV03 EQU   JSCBFBYT
JSCBRV02 EQU   JSCBFBYT
JSCBADSP EQU   JSCBFBYT
JSCBRV01 EQU   JSCBFBYT
JSCBTJID EQU   JSCBASID
JSCBPSCB EQU   JSCBSEC3+4
JSCJCTP  EQU   JSCBJCTA
JSCRSV24 EQU   JSCBJCT
JSCBEND2 EQU   JSCBSEC2
UCBRV066 EQU   UCBOBS09+4
UCBIOSBA EQU   UCBOBS09
UCBRV042 EQU   UCBOBS08+5
UCBRV082 EQU   UCBCTCF1
UCBRV081 EQU   UCBCTCF1
UCBRV080 EQU   UCBCTCF1
UCBRV079 EQU   UCBCTCF1
UCBRV078 EQU   UCBCTCF1
UCBRV077 EQU   UCBCTCF1
UCBRV076 EQU   UCBCTCF1
UCBCTC80 EQU   UCBCTCF1
UCBCTCAL EQU   UCBCTCAD
UCBICNCB EQU   UCBOBS07+4
UCBRV040 EQU   UCBOBS07
UCBCTLNA EQU   UCBCTLNK+1
UCBRLN   EQU   UCBCTLNK
UCBRDYQA EQU   UCBLDNCB
UCBINRLN EQU   UCBIRLN
UCBIRBA  EQU   UCBIRB+1
UCBRV039 EQU   UCBGRAF
UCBDWNR  EQU   UCBGRAF
UCBRPND  EQU   UCBGRAF
UCBUPM   EQU   UCBGRAF
UCBBTAM  EQU   UCBGRAF
UCBDRNO  EQU   UCBGRAF
UCBDRO   EQU   UCBGRAF
UCBOIP   EQU   UCBGRAF
UCBATRCD EQU   @NM00017
UCBSKPFG EQU   @NM00017
UCBRIPND EQU   @NM00017
UCBRTIAC EQU   @NM00017
UCBRSV79 EQU   @NM00017
UCBRSV78 EQU   @NM00017
UCBRSV77 EQU   @NM00017
UCBOLTEP EQU   @NM00017
UCBATNCT EQU   UCBOBS06+2
UCBRSV76 EQU   UCBAOF2
UCBRSV75 EQU   UCBAOF2
UCBRSV74 EQU   UCBAOF2
UCBRSV73 EQU   UCBAOF2
UCBRSV72 EQU   UCBAOF2
UCBRSV71 EQU   UCBAOF2
UCBRSV70 EQU   UCBAOF2
UCBRSV69 EQU   UCBAOF2
UCBRSV68 EQU   UCBAOF1
UCBRSV67 EQU   UCBAOF1
UCBRSV66 EQU   UCBAOF1
UCBRSV65 EQU   UCBAOF1
UCBRSV64 EQU   UCBAOF1
UCBOFNL  EQU   UCBAOF1
UCBOFSP  EQU   UCBAOF1
UCBOFMCR EQU   UCBAOF1
UCBBTB   EQU   UCBBTA+1
UCBDI    EQU   UCBBTA
UCBSNS   EQU   UCBOBS04+8
UCBTEB   EQU   UCBOBS04+4
UCBGCB   EQU   UCBOBS04+3
UCBOPEN  EQU   UCBOBS04+2
UCBSTART EQU   UCBOBS04
UCBXTNB  EQU   UCBXTN+1
UCBRSV22 EQU   UCBVOPT
UCBRSV21 EQU   UCBVOPT
UCBRSV20 EQU   UCBVOPT
UCBESVE  EQU   UCBVOPT
UCBERPC  EQU   UCBVOPT
UCBESVC  EQU   UCBVOPT
UCBEVA   EQU   UCBVOPT
UCBESV   EQU   UCBVOPT
UCBRV009 EQU   UCBTFL1
UCBRV008 EQU   UCBTFL1
UCBRV007 EQU   UCBTFL1
UCBRV006 EQU   UCBTFL1
UCBRV005 EQU   UCBTFL1
UCBRV038 EQU   UCBTFL1
UCBNSLTP EQU   UCBTFL1
UCBNLTP  EQU   UCBTFL1
UCBRES1B EQU   UCBOBS02+18
UCBFSER  EQU   UCBOBS02+12
@NM00016 EQU   UCBOBS02+4
UCBFSEQ  EQU   UCBOBS02+2
UCBFSCT  EQU   UCBOBS02
UCBNEXP  EQU   UCBOBS01+20
UCBBASE  EQU   UCBOBS01+16
UCBRES1A EQU   UCBOBS01+15
UCBUSER  EQU   UCBOBS01+14
UCBFL47  EQU   UCBFL4
UCBFL46  EQU   UCBFL4
UCBFL45  EQU   UCBFL4
UCBRV065 EQU   UCBFL4
UCBDSS   EQU   UCBFL4
UCBRESVP EQU   UCBFL4
UCBWDAV  EQU   UCBFL4
UCBDAVV  EQU   UCBFL4
UCBSQC   EQU   UCBOBS01+12
UCBDATP  EQU   UCBOBS01+12
UCBDMC   EQU   UCBDMCT
UCBMOUNT EQU   UCBDMCT
UCBBNUL  EQU   UCBSTAB
UCBSHAR  EQU   UCBSTAB
UCBBSTR  EQU   UCBSTAB
UCBBPUB  EQU   UCBSTAB
UCBBPRV  EQU   UCBSTAB
UCBBALB  EQU   UCBPRSRS
UCBPGFL  EQU   UCBSTAB
UCBDVSHR EQU   UCBBSVL
UCBVTOC  EQU   UCBOBS01
@NM00037 EQU   EDLENTRY+18
EDLVAM   EQU   EDLUVFLG
EDLGMTP  EQU   EDLHDR+12
EDLGENNO EQU   EDLHDR+4
EDLLUV   EQU   EDLHDR
@NM00033 EQU   PSPARM+1
VOLSWOK  EQU   PSSW
@NM00032 EQU   PSSW
PERMRES  EQU   PSSW
RSNCODE  EQU   RETAREA+4
ALCUENT  EQU   ALCUCBLT+4
ALCUNO   EQU   ALCUCBLT
JSCBCSCB EQU   JSCBSEC1+68
JSCBPMG  EQU   JSCBWTP+2
JSCBWTSP EQU   JSCBWTP+1
JSCRSV23 EQU   JSCBWTFG
JSCRSV22 EQU   JSCBWTFG
JSCRSV21 EQU   JSCBWTFG
JSCRSV20 EQU   JSCBWTFG
JSCRSV19 EQU   JSCBWTFG
JSCRSV18 EQU   JSCBWTFG
JSCBRET  EQU   JSCBWTFG
JSCBIOFG EQU   JSCBWTFG
@NM00025 EQU   JSCBSEC1+60
JSCBQMPI EQU   JSCBSEC1+56
JSCBPMSG EQU   JSCBSWT1
JSCRSV16 EQU   JSCBSWT1
JSCRSV15 EQU   JSCBSWT1
JSCRSV14 EQU   JSCBSWT1
JSCRSV13 EQU   JSCBSWT1
JSCRSV12 EQU   JSCBSWT1
JSCRSV11 EQU   JSCBSWT1
JSCBPASS EQU   JSCBSWT1
JSCBTTTR EQU   JSCBSEC1+52
JSCRSV10 EQU   JSCBSEC1+49
JSCBAUTH EQU   JSCBOPTS
JSCSIOTS EQU   JSCBOPTS
JSCRSV08 EQU   JSCBOPTS
JSCRSV07 EQU   JSCBOPTS
JSCRSV06 EQU   JSCBOPTS
JSCBLONG EQU   JSCBOPTS
JSCRSV05 EQU   JSCBOPTS
JSCRSV04 EQU   JSCBOPTS
JSCBSECB EQU   JSCBSEC1+44
JSCRSV03 EQU   JSCBSEC1+41
JSCBSTEP EQU   JSCBSEC1+40
JSCBDCBA EQU   JSCBDCB+1
JSCRSV02 EQU   JSCBDCB
JSCBID   EQU   JSCBSEC1+32
JSCBDBTB EQU   JSCBSEC1+28
JSCBIJSC EQU   JSCBSEC1+24
JSCBPCC  EQU   JSCBSEC1+16
JSCBTCP  EQU   JSCBSEC1+12
JSCBSHR  EQU   JSCBSEC1+8
JSCHPCEA EQU   JSCHPCE+1
JSCRSV32 EQU   JSCHPCE
JSCRSV01 EQU   JSCBSEC1
@NM00024 EQU   IEZJSCB
ALCPROCN EQU   NAMES+16
ALCSTEPN EQU   NAMES+8
ALCJOBN  EQU   NAMES
EXITPRMP EQU   ALCWA+144
CANCELP  EQU   ALCWA+140
WORK3MP  EQU   ALCWA+136
WMASK2P  EQU   ALCWA+132
WMASKPTR EQU   ALCWA+128
TCBP     EQU   ALCWA+116
ALCWASID EQU   ALCWA+114
@NM00023 EQU   @NM00022
NODEVERR EQU   @NM00022
NEEDRCVY EQU   @NM00022
ALCWAREC EQU   @NM00022
WAITIGEN EQU   @NM00022
UNITRECS EQU   @NM00022
ALCWADUL EQU   INDICATE
ALCWISAM EQU   INDICATE
DSSUNIT  EQU   INDICATE
DSSTAPE  EQU   INDICATE
INDREQU  EQU   INDICATE
INDRETRY EQU   INDICATE
INDWAIT  EQU   INDICATE
QMGRRBP  EQU   ALCWA+108
RIMTABCT EQU   ALCWA+104
RIMTABLN EQU   ALCWA+100
RIMTABP  EQU   ALCWA+96
ALGTABSZ EQU   ALCWA+92
ALGTABP  EQU   ALCWA+88
@NM00021 EQU   ALCWA+78
LTUNITID EQU   ALCWA+76
OTHEREQS EQU   CNTABLE+32
SUBSREQS EQU   CNTABLE+28
SPECREQS EQU   CNTABLE+12
TPREQS   EQU   CNTABLE+8
VAMREQS  EQU   CNTABLE+4
DMYREQS  EQU   CNTABLE
EDTABPTR EQU   ALCWA+24
IOSLUTP  EQU   ALCWA+16
FMAPPTR  EQU   ALCWA+4
WASIZE   EQU   ALCWA
VUGRID   EQU   VOLUNTAB+24
VUUCBP   EQU   VOLUNTAB+20
VOLALGTP EQU   VOLUNTAB+12
VURCVYPR EQU   VOLSTATD
VUVLUNIQ EQU   VOLSTATD
VUDMUNIQ EQU   VOLSTATD
VUUNALSW EQU   VOLSTATD
VUDMNDAL EQU   VOLSTATD
VUDMNDOF EQU   VOLSTATD
VUREALOC EQU   VOLSTATD
VUMUGDON EQU   VOLSTATD
@NM00020 EQU   VOLSTATC
@NM00019 EQU   VOLSTATC
VURECVRY EQU   VOLSTATC
VOLURREQ EQU   VOLSTATC
VOLGRREQ EQU   VOLSTATC
VOLDAREQ EQU   VOLSTATC
VOLCOREQ EQU   VOLSTATC
VOLTAREQ EQU   VOLSTATC
VUAFFWRK EQU   VOLSTATB
VUVINELG EQU   VOLSTATB
VUPROCED EQU   VOLSTATB
VOLMNTD  EQU   VOLSTATB
VOLDEFER EQU   VOLSTATA
VUDADSM  EQU   VOLSTATA
VOLRESVE EQU   VOLSTATA
VOLSPEC  EQU   VOLSTATA
UCBERADR EQU   UCBUCS+12
UCBFCBID EQU   UCBUCS+8
UCBERCNT EQU   UCBUCS+7
UCBRSV51 EQU   UCBUCS+6
UCBRSV50 EQU   UCBFCBOP
UCBRSV49 EQU   UCBFCBOP
UCBRSV48 EQU   UCBFCBOP
UCBRSV47 EQU   UCBFCBOP
UCBRSV46 EQU   UCBFCBOP
UCBRSV45 EQU   UCBFCBOP
UCBRSV44 EQU   UCBFCBOP
UCBFCBO1 EQU   UCBFCBOP
UCBUCSPE EQU   UCBUCSOP
UCBRSV43 EQU   UCBUCSOP
UCBRSV42 EQU   UCBUCSOP
UCBRSV41 EQU   UCBUCSOP
UCBRSV40 EQU   UCBUCSOP
UCBRSV39 EQU   UCBUCSOP
UCBUCSO2 EQU   UCBUCSOP
UCBUCSO1 EQU   UCBUCSOP
UCBUCSID EQU   UCBUCS
UCBMDRBA EQU   UCBMDRBF+1
UCBRV075 EQU   UCBMDRBF
UCBRV074 EQU   UCB3800X+32
UCBIMAGE EQU   UCB3800X+28
UCBFCBNM EQU   UCB3800X+24
UCBCHAR4 EQU   UCB3800X+20
UCBCHAR3 EQU   UCB3800X+16
UCBCHAR2 EQU   UCB3800X+12
UCBCHAR1 EQU   UCB3800X+8
UCBCGMID EQU   UCB3800X+4
UCBBRSTA EQU   UCBACTIV
UCBRV063 EQU   UCBACTIV
UCBRV062 EQU   UCBACTIV
UCBRV061 EQU   UCBACTIV
UCBRV060 EQU   UCBACTIV
UCBRV059 EQU   UCBACTIV
UCBRV058 EQU   UCBACTIV
UCBRV057 EQU   UCBACTIV
UCBRV050 EQU   UCB3800X+2
UCBCGMNO EQU   UCB3800X+1
UCBRV083 EQU   UCBOPTNS
UCBBRSTR EQU   UCBOPTNS
UCBRV056 EQU   UCBOPTNS
UCBRV055 EQU   UCBOPTNS
UCBRV054 EQU   UCBOPTNS
UCBRV053 EQU   UCBOPTNS
UCBRV052 EQU   UCBOPTNS
UCBRV051 EQU   UCBOPTNS
UCBRV073 EQU   UCB3540X+7
UCBRV072 EQU   UCBDKBYT
UCBRV071 EQU   UCBDKBYT
UCBRV070 EQU   UCBDKBYT
UCBRV069 EQU   UCBDKBYT
UCBRV068 EQU   UCBDKBYT
UCBRV067 EQU   UCBDKBYT
UCBVLVER EQU   UCBDKBYT
UCBDKAMX EQU   UCBDKBYT
UCBVLSER EQU   UCB3540X
UCBRDATA EQU   UCBOCR+4
UCBFRID  EQU   UCBOCR
UCBCLN   EQU   UCBMT+14
UCBERG   EQU   UCBMT+12
UCBMS    EQU   UCBMT+11
UCBNB    EQU   UCBMT+10
UCBPW    EQU   UCBMT+9
UCBPR    EQU   UCBMT+8
UCBSIO   EQU   UCBMT+6
UCBTW    EQU   UCBMT+5
UCBTR    EQU   UCBMT+4
UCBTWT   EQU   UCBMT+3
UCBTRT   EQU   UCBMT+2
UCBCTD   EQU   UCBMT
UCBWTOID EQU   UCBCMEXT+17
UCBRV043 EQU   UCBCMEXT+16
UCBASID  EQU   UCBCMEXT+14
UCBMFCNT EQU   UCBCMEXT+12
UCBPMSK  EQU   UCBCMEXT+10
UCBCCWOF EQU   UCBCMEXT+8
UCBRV041 EQU   UCBCMEXT+6
UCBRV036 EQU   UCBFLP1
UCBRV035 EQU   UCBFLP1
UCBERLOG EQU   UCBFLP1
UCBRV033 EQU   UCBFLP1
UCBRV032 EQU   UCBFLP1
UCBRV031 EQU   UCBFLP1
UCBSHRUP EQU   UCBFLP1
UCBNSRCH EQU   UCBFLP1
UCBSNSCT EQU   UCBCMEXT+4
UCBHPDV  EQU   @NM00018
UCBHALI  EQU   @NM00018
UCBRSV09 EQU   @NM00018
UCBRSV08 EQU   @NM00018
UCBRSV07 EQU   @NM00018
UCBRSV06 EQU   @NM00018
UCBRSV05 EQU   @NM00018
UCBRSV04 EQU   @NM00018
UCBDTI   EQU   UCBCMEXT+2
UCBSTI   EQU   UCBCMEXT+1
UCBETI   EQU   UCBCMEXT
UCBEXTP  EQU   UCBEXTPT+1
UCBDDRSW EQU   UCBFLC
UCBTICBT EQU   UCBFLC
UCBIVRR  EQU   UCBFLC
UCBIVRS  EQU   UCBFLC
UCBITF   EQU   UCBFLC
UCBUDE   EQU   UCBFLC
UCBWAA   EQU   UCBFLC
UCBATTP  EQU   UCBFLC
UCBUNTYP EQU   UCBTBYT4
UCBRSV11 EQU   UCBDVCLS
UCBRSV10 EQU   UCBDVCLS
UCB3CHAR EQU   UCBDVCLS
UCB3UREC EQU   UCBDVCLS
UCB3DISP EQU   UCBDVCLS
UCB3COMM EQU   UCBDVCLS
UCBDVPWR EQU   UCB2OPT7
UCBVLPWR EQU   UCB2OPT6
UCB2OPT5 EQU   UCBTBYT2
UCBRVDEV EQU   UCBRWTAU
UCBRPS   EQU   UCBDUDN2
UCBRR    EQU   UCBDUDN1
UCB2OPT1 EQU   UCBTBYT2
UCB2OPT0 EQU   UCBTBYT2
UCB1FEA7 EQU   UCBTBYT1
UCBD6250 EQU   UCB1FEA6
UCBD1600 EQU   UCB1FEA5
UCB1FEA4 EQU   UCBTBYT1
UCB1FEA3 EQU   UCBTBYT1
UCB1FEA2 EQU   UCBTBYT1
UCB1FEA1 EQU   UCBTBYT1
UCB1FEA0 EQU   UCBTBYT1
UCBNAME  EQU   UCBOB+13
UCBRV029 EQU   UCBWGT
UCBVHRSN EQU   UCBWGT
UCBVORSN EQU   UCBWGT
UCBMTPXP EQU   UCBWGT
UCBREW   EQU   UCBWGT
UCBPUB   EQU   UCBWGT
UCBOUT   EQU   UCBWGT
UCBIN    EQU   UCBWGT
UCBCPU   EQU   UCBOB+11
UCBLCI   EQU   UCBOB+10
UCBCNT   EQU   UCBOB+9
UCBRV017 EQU   UCBCHM1
UCBRV016 EQU   UCBCHM1
UCBRV015 EQU   UCBCHM1
UCBRV014 EQU   UCBCHM1
UCBSPB   EQU   UCBPTH1
UCBPPB   EQU   UCBPTH1
UCBSPA   EQU   UCBPTH0
UCBPPA   EQU   UCBPTH0
UCBSIGP  EQU   UCBFLB
UCBVALPH EQU   UCBFLB
UCBCRHSN EQU   UCBFLB
UCBCRHRV EQU   UCBFLB
UCBRESVH EQU   UCBFLB
UCBSPST  EQU   UCBFLB
UCBASNS  EQU   UCBFLB
UCBIORST EQU   UCBFLB
UCBQISCE EQU   UCBFL1
UCBACTV  EQU   UCBFL1
UCBSAP   EQU   UCBFL1
UCBNOTRC EQU   UCBCUB
UCBPSNS  EQU   UCBFL1
UCBUSING EQU   UCBPST
UCBNOTRD EQU   UCBNRY
UCBBUSYD EQU   UCBBSY
UCBUA    EQU   UCBCHAN+1
UCBCHA   EQU   UCBCHAN
UCBDADI  EQU   UCBSTAT
UCBSYSR  EQU   UCBSTAT
UCBALOC  EQU   UCBSTAT
UCBUNLD  EQU   UCBSTAT
UCBCHGS  EQU   UCBSTAT
UCBONLI  EQU   UCBSTAT
UCBID    EQU   UCBOB+2
UCBALTPH EQU   UCBFL5
UCBALTCU EQU   UCBFL5
UCBNALOC EQU   UCBFL5
UCBENVRD EQU   UCBFL5
UCBVSDR  EQU   UCBFL5
UCBSASK  EQU   UCBFL5
UCBAMV   EQU   UCBAF
UCBDCC   EQU   UCBFL5
UCBMONT  EQU   UCBJBNR
UCBRV011 EQU   UCBJBNR
UCBRSV02 EQU   UCBJBNR
UCBOLDSM EQU   UCBJBNR
UCBRV003 EQU   UCBJBNR
UCBDUC   EQU   UCBJBNR
UCBJES3  EQU   UCBJBNR
UCBVRDEV EQU   UCBJBNR
UCBCMSEG EQU   UCBOB
UCBPFXND EQU   UCB+512
UCBIOQ   EQU   UCB+508
UCBLOCK  EQU   UCB+504
UCBPXST  EQU   UCB+504
@NM00015 EQU   UCB
SIODDSNL EQU   INDMSIOT+173
SIOVDSNL EQU   INDMSIOT+172
SIOVDSNT EQU   INDMSIOT+170
SIOTVMVP EQU   INDMSIOT+164
SIOTJFX  EQU   INDMSIOT+160
SJFCBPTR EQU   INDMSIOT+156
SIOTATE  EQU   INDMSIOT+144
SIOTEDLS EQU   INDMSIOT+132
SCTANAME EQU   INDMSIOT+122
@NM00014 EQU   INDMSIOT+108
SIOTSSNM EQU   INDMSIOT+104
SIODDQCR EQU   SIOTBYT2
SIOVDQCR EQU   SIOTBYT2
SIOTCVOL EQU   SIOTBYT2
SIOTCNEW EQU   SIOTBYT2
SIOTCALC EQU   SIOTBYT2
SIOTGALL EQU   SIOTBYT2
SIOTDSPD EQU   SIOTBYT2
SIOTDMND EQU   SIOTBYT2
SIOTOPUC EQU   INDMSIOT+99
SIOTOUTR EQU   INDMSIOT+97
SIOTOUTC EQU   INDMSIOT+96
@NM00013 EQU   INDMSIOT+93
SIOTAUNC EQU   SIOTALTD
SIOTACAT EQU   SIOTALTD
SIOTADEL EQU   SIOTALTD
SIOTAKEP EQU   SIOTALTD
SIOTNPRV EQU   SIOTALTD
SIOJCATS EQU   SIOTALTD
@NM00012 EQU   SIOTALTD
@NM00011 EQU   SIOTALTD
@NM00010 EQU   INDMSIOT+91
SIOTNDSB EQU   INDMSIOT+88
@NM00009 EQU   INDMSIOT+84
SIOTDPCD EQU   INDMSIOT+82
@NM00008 EQU   INDMSIOT+81
SCTOUTPN EQU   INDMSIOT+80
SCTOUTNO EQU   INDMSIOT+76
SCTOUTNM EQU   INDMSIOT+68
SIOUCBAD EQU   SCTUTYPE+5
SIOUCNVT EQU   SCTUTYPE+4
SIOUBYT4 EQU   SIOTDEVT+3
@NM00007 EQU   SIOUBYT3
SIO3UREC EQU   SIOUBYT3
SIO3DISP EQU   SIOUBYT3
SIO3DACC EQU   SIOUBYT3
SIO3COMM EQU   SIOUBYT3
SIO3TAPE EQU   SIOUBYT3
SIOUBYT2 EQU   SIOTDEVT+1
SIOUBYT1 EQU   SIOTDEVT
SIOTOMN  EQU   SCTSBYT4
SIOTIPDI EQU   SCTSBYT4
SIOTVAFF EQU   SCTSBYT4
SIOTSTEP EQU   SCTSBYT4
SIOTASCI EQU   SCTSBYT4
SIOTGDGA EQU   SCTSBYT4
SCTSGDGS EQU   SCTSBYT4
SCTSOLD  EQU   SCTSBYT3
SCTSMOD  EQU   SCTSBYT3
SCTSNEW  EQU   SCTSBYT3
SCTSYSOU EQU   SCTSBYT3
SCTVREF  EQU   SCTSBYT3
SCTALCHK EQU   SCTSBYT3
SCTSYSNE EQU   SCTSBYT3
SCTDSNRF EQU   SCTSBYT3
SCTRECVD EQU   SCTSBYT2
SCTDEFER EQU   SCTSBYT2
SCTLABEL EQU   SCTSBYT2
SCTUNLBD EQU   SCTSBYT2
SCTJOBLB EQU   SCTSBYT2
SCTVOLAF EQU   SCTSBYT2
SIOTCATL EQU   SCTSBYT2
SIOCLUNL EQU   SCTSBYT2
SIOTJSCT EQU   SCTSBYT1
SCTUNAFF EQU   SCTSBYT1
SCTPARLM EQU   SCTSBYT1
SIOTQDSN EQU   SCTSBYT1
SIOTGDSN EQU   SCTSBYT1
SIOTCCAT EQU   SCTSBYT1
SCTSYSIN EQU   SCTSBYT1
SCTDUMMY EQU   SCTSBYT1
SIOTUNCT EQU   SCTSDISP
SIOTCTLG EQU   SCTSDISP
SIOTDLET EQU   SCTSDISP
SIOTKEEP EQU   SCTSDISP
SIOTPASS EQU   SCTSDISP
SIOTPRIV EQU   SCTSDISP
S3400DSP EQU   SCTSDISP
SIOTRETN EQU   SCTSDISP
SIOTVLCT EQU   INDMSIOT+54
SCTNMBUT EQU   INDMSIOT+53
SIOTRTRY EQU   SIOTBYT0
SIOTPUPV EQU   SIOTBYT0
SIOTNOPV EQU   SIOTBYT0
SIOTFUDA EQU   SIOTBYT0
SIOTDYAL EQU   SIOTBYT0
SIOTSSDS EQU   SIOTBYT0
SIOTGIID EQU   INDMSIOT+50
SCTVOLCT EQU   INDMSIOT+49
SCTSPOOL EQU   INDMSIOT+48
SIOTQNAM EQU   SIOTTSTC
SIOTDSNM EQU   SIOTTSTC
SIOTTRKM EQU   SIOTTSTC
@NM00006 EQU   SIOTTSTC
SIOTTERM EQU   SIOTTSTC
@NM00005 EQU   SIOTTSTC
@NM00004 EQU   SIOTBYT3
SIOTJES3 EQU   SIOTBYT3
SIOCDEVT EQU   SIOTBYT3
SIOALIAS EQU   SIOTBYT3
SCTDDINO EQU   INDMSIOT+44
SIOTDDNT EQU   SIOTBYT1
SIODADSM EQU   SIOTBYT1
SIOTDADR EQU   SIOTBYT1
SIODUNAL EQU   SIOTBYT1
SIOVAMDS EQU   SIOTBYT1
SIOTHOLD EQU   SIOTBYT1
SIOTOCKP EQU   SIOTBYT1
SIOTREFN EQU   INDMSIOT+40
SIOTVRSB EQU   INDMSIOT+36
@NM00003 EQU   INDMSIOT+35
SCTPJFCB EQU   INDMSIOT+32
@NM00002 EQU   INDMSIOT+31
SCTPSIOT EQU   INDMSIOT+28
SIOTAFID EQU   INDMSIOT+26
@NM00001 EQU   INDMSIOT+24
SIODSNTE EQU   INDMSIOT+22
SIOTUNAF EQU   SCTUSADD
SIOTDEST EQU   INDMSIOT+12
SCTDDNAM EQU   INDMSIOT+4
SIOTTYPE EQU   INDMSIOT+3
SIOTDSKA EQU   INDMSIOT
.@UNREFD ANOP                          END UNREFERENCED COMPONENTS
@RC00286 EQU   @RC00280
@RF00259 EQU   @RC00235
@RF00296 EQU   @RC00235
@RC00314 EQU   @RC00235
@RC00214 EQU   @RC00206
@RF00142 EQU   @RC00140
@RC00145 EQU   @RC00140
@RC00485 EQU   @RC00132
@RC00287 EQU   @RC00286
@RC00318 EQU   @RC00314
@RF00353 EQU   @RC00314
@RC00369 EQU   @RC00214
@RC00146 EQU   @RC00145
@RC00334 EQU   @RC00318
@RC00147 EQU   @RC00146
@RF00337 EQU   @RC00334
@ENDDATA EQU   *
         END   IEFAB436,(C'PLS0957',0701,76265)
