         TITLE 'IEFAB451 - HSKP CONTROL ROUTINE                        *
                        '
IEFAB451 CSECT ,                                                01S0001
@MAINENT DS    0H                                               01S0001
         USING *,@15                                            01S0001
         B     @PROLOG                                          01S0001
         DC    AL1(16)                                          01S0001
         DC    C'IEFAB451  76.334'                              01S0001
         DROP  @15
@PROLOG  STM   @14,@12,12(@13)                                  01S0001
         BALR  @12,0                                            01S0001
@PSTART  DS    0H                                               01S0001
         USING @PSTART,@12                                      01S0001
         L     @00,@SIZDATD                                     01S0001
         GSPACE   R,LV=(0)
         LR    @11,@01                                          01S0001
         USING @DATD,@11                                        01S0001
         ST    @13,@SA00001+4                                   01S0001
         LM    @00,@01,20(@13)                                  01S0001
         ST    @11,8(,@13)                                      01S0001
         LR    @13,@11                                          01S0001
         MVC   @PC00001(44),0(@01)                              01S0001
JSCBDISP EQU 188
JSCBAOS1 EQU  72
JSCBAOS2 EQU 192
*   RTNCODE=SUCCESS;                /* SET NORMAL RETURN CODE        */
         SLR   @10,@10                                          01S0061
         ST    @10,RTNCODE                                      01S0061
*   IF FSIOTPTR^=0 THEN             /* CHECK FOR ANY REQUESTS TO     */
         L     @15,@PC00001+4                                   01S0062
         C     @10,FSIOTPTR(,@15)                               01S0062
         BE    @RF00062                                         01S0062
*     DO;                           /* PROCESS                       */
*                                                               02S0064
*/********************************************************************/
*/*                                                                  */
*/* SEGMENT NAME - HSKESTAE                                          */
*/*                                                                  */
*/* DESCRIPTIVE NAME - HSKP ESTAE SETUP                              */
*/*                                                                  */
*/* FUNCTION - OBTAIN AND INITIALIZE THE ESTAE EXIT PARMLIST.        */
*/*            CREATE AN ESTAE ENVIRONMENT.                  @Z40FPPG*/
*/*                                                                  */
*/*    OPERATION - 1. ISSUE GETMAIN FOR PARMLIST                     */
*/*                2. INITIALIZE FIELDS WITHIN PARMLIST              */
*/*                3. CREATE ESTAE ENVIRONMENT               @Z40FPPG*/
*/*                4. CHECK SUCCESS OF ESTAE SET UP.         @Z40FPPG*/
*/*                5. FAIL IF ESTAE UNSUCCESSFUL AND FREE PARMLIST   */
*/*                                                                  */
*/* ENTRY - INLINE SEGMENT                                           */
*/*                                                                  */
*/*    INPUT - SEGMENT USES INPUT TO HSKP TO INITIALIZE PARMLIST     */
*/*                                                                  */
*/* EXIT - N/A                                                       */
*/*                                                                  */
*/*    CONDITION - IF SUCCESSFUL ESTAE ENVIRONMENT, RTNCODE = 0      */
*/*                                                          @Z40FPPG*/
*/*                IF UNSUCCESSFUL, RTNCODE=8, REASONCD=16           */
*/*                                                                  */
*/*    OUTPUT DATA - INITIALIZED ESTAE PARMLIST AND ESTAE            */
*/*                  ENVIRONMENT SET UP.                     @Z40FPPG*/
*/*                                                                  */
*/********************************************************************/
*                                                               02S0064
*                                                               02S0064
*/********************************************************************/
*                                                               02S0064
*       RFY                                                     02S0064
*        (REG0,                                                 02S0064
*         REG1,                                                 02S0064
*         REG15) RSTD;                                          02S0064
*       SBPOOL=SUBPOOOL;            /* SET SUBPOOL NUMBER            */
         MVI   SBPOOL,X'E6'                                     02S0065
*       LENTH=LENGTH(EPARMLST);     /* LENGTH OF ESTAE PARMLIST      */
         MVC   LENTH(3),@CF01849+1                              02S0066
*       REG0=SPLEN;                 /* SET SUBPOOL+LENGTH IN REG 0   */
         L     REG0,SPLEN                                       02S0067
*       GEN(GETMAIN R,LV=(0));      /* ESTAE PARMLIST GETMAIN        */
         GETMAIN R,LV=(0)
*       EPRMLSTP=REG1;              /* PARMLIST POINTER              */
         LR    EPRMLSTP,REG1                                    02S0069
*       RFY                                                     02S0070
*        (REG0,                                                 02S0070
*         REG1) UNRSTD;                                         02S0070
*       EECNTRLS=0;                 /* CLEAR CONTROLS                */
         SLR   @14,@14                                          02S0071
         ST    @14,EECNTRLS(,EPRMLSTP)                          02S0071
*       IF IDENQTIO=ON THEN         /* ENQ ON TIOT ONLY IF           */
         L     @14,@PC00001                                     02S0072
         TM    IDENQTIO(@14),B'01000000'                        02S0072
         BNO   @RF00072                                         02S0072
*         EEDNENQT=ON;              /* CALLER DIDN'T                 */
         OI    EEDNENQT(EPRMLSTP),B'00000001'                   02S0073
*       IF ICAJSCB=ON THEN          /* REINSTATE JSCB PTR(S) IF      */
@RF00072 L     @14,@PC00001                                     02S0074
         TM    ICAJSCB(@14),B'00100000'                         02S0074
         BNO   @RF00074                                         02S0074
*         EERAJSCP=ON;              /* SWITCHING WAS ALLOWED         */
         OI    EERAJSCP(EPRMLSTP),B'00000100'                   02S0075
*       IF IUNCATSW=ON THEN         /* CATALOG UNALLOCATION          */
@RF00074 L     @14,@PC00001                                     02S0076
         TM    IUNCATSW(@14),B'00001000'                        02S0076
         BNO   @RF00076                                         02S0076
*         DO;                       /* ALLOWED                       */
*           EEUALCAT=ON;            /* UNALLOCATE ALL PVT.CATALOGS   */
*           EECLACAT=ON;            /* CLOSE ALL PVT.CATALOGS        */
*           EEFAPCCB=ON;            /* FREE ALL PVT.CATALOG PCCBS    */
         OI    EEUALCAT(EPRMLSTP),B'11100000'                   02S0080
*         END;                                                  02S0081
*       ELSE                        /* DO NOT ALLOW CATALOG          */
*         EEDYNAM=ON;               /* UNALLOCATION - DYN.ALLOC.     */
         B     @RC00076                                         02S0082
@RF00076 OI    EEDYNAM(EPRMLSTP),B'00000010'                    02S0082
*       ECJSCBP=JSCBPTR;            /* CURRENT JSCB PTR              */
@RC00076 L     @14,@PC00001+28                                  02S0083
         L     @14,JSCBPTR(,@14)                                02S0083
         ST    @14,ECJSCBP(,EPRMLSTP)                           02S0083
*       EAJSCBP=JSCBPTR->JSCBACT;   /* ACTIVE JSCB PTR               */
         L     @14,JSCBACT(,@14)                                02S0084
         ST    @14,EAJSCBP(,EPRMLSTP)                           02S0084
*                                                               03S0085
*/********************************************************************/
*/*                                                          @Z40FPPG*/
*/* SEGMENT NAME - ESTAECOD                                  @Z40FPPG*/
*/*                                                          @Z40FPPG*/
*/* DESCRIPTIVE NAME - ESTAE CODE                            @Z40FPPG*/
*/*                                                          @Z40FPPG*/
*/* FUNCTION - SET UP THE APPROPRIATE ESTAE ENVIRONMENT      @Z40FPPG*/
*/*                                                          @Z40FPPG*/
*/* OPERATION -                                              @Z40FPPG*/
*/*          . AN ALLOCATION STAE WORK AREA (ASWA) IS FILLED @Z40FPPG*/
*/*            IN. THIS ALLOWS THE ALLOCATION COMMON ESTAE   @Z40FPPG*/
*/*            EXIT (IEFAB4ED) TO ROUTE CONTROL TO THE OTHER @Z40FPPG*/
*/*            APPROPRIATE EXIT ROUTINES FOR SPECIFIC        @Z40FPPG*/
*/*            RECOVERY PROCESSING.                          @Z40FPPG*/
*/*          . IF NO ALLOCATION ESTAE IS IN EFFECT, OR IF ONE@Z40FPPG*/
*/*            IS BUT IT IS NOT THE CURRENT ESTAE A NEW ESTAE@Z40FPPG*/
*/*            MUST BE ISSUED, THE ASWA BUILT BECOMES THE    @Z40FPPG*/
*/*            FIRST ONE IN A NEW CHAIN, IS THE EXIT PARM    @Z40FPPG*/
*/*            RECEIVED BY THE COMMON ESTAE EXIT, AND MUST   @Z40FPPG*/
*/*            PROVIDE THE AUTOMATIC CORE FOR THE DATA THAT  @Z40FPPG*/
*/*            ROUTINE USES. THE PTR TO THE LAST ASWA OF AN  @Z40FPPG*/
*/*            EARLIER ALLOCATION ESTAE, IF ANY, IS SAVED IN @Z40FPPG*/
*/*            THIS ASWA. NOTE THAT THE STAE CONTROL BLOCK   @Z40FPPG*/
*/*            ADDRESS IN THE ASWA IS NOT UPDATED UNTIL AFTER@Z40FPPG*/
*/*            THE ESTAE IS ISSUED SO THAT IT REFLECTS THE   @Z40FPPG*/
*/*            CURRENT ONE.                                  @Z40FPPG*/
*/*          . IF THE CURRENT ESTAE IN EFFECT IS ALLOCATION'S@Z40FPPG*/
*/*            IT CAN BE USED TO PROVIDE THIS ROUTINES NECES-@Z40FPPG*/
*/*            SARY RECOVERY ENVIRONMENT. THE SCB ADDRESS    @Z40FPPG*/
*/*            BE COPIED FROM THE MOST RECENT ASWA, TO WHICH @Z40FPPG*/
*/*            THE CHAIN PTR OF THIS NEW ASWA WILL POINT BACK@Z40FPPG*/
*/*          . THE ADDRESS OF THE NEW ASWA IS PLACED IN      @Z40FPPG*/
*/*            THE JSCB AS THE LAST ONE IN THE CHAIN FOR THE @Z40FPPG*/
*/*            CURRENT ALLOCATION ESTAE                      @Z40FPPG*/
*/*          . (NOTE THAT AS OF REL4, THERE SHOULD ALWAYS    @Z40FPPG*/
*/*             BE A USEABLE EXISTING ALLOCATION ESTAE IN    @Z40FPPG*/
*/*             EFFECT WHEN THIS MODULE GETS CONTROL.)       @Z40FPPG*/
*/*                                                          @Z40FPPG*/
*/* ENTRY - INLINE SUBROUTINE ENTERED AT THE TOP             @Z40FPPG*/
*/*                                                          @Z40FPPG*/
*/*   PURPOSE - SEE FUNCTION                                 @Z40FPPG*/
*/*                                                          @Z40FPPG*/
*/*   INPUT -                                                @Z40FPPG*/
*/*        .JSCBASWA - PTR LAST LAST ASWA ON CHAIN, IF ANY   @Z40FPPG*/
*/*        .TCBSTABB - PTR TO CURRENT STAE CONTROL BLOCK     @Z40FPPG*/
*/*                                                          @Z40FPPG*/
*/* EXIT - INLINE SUBROUTINE THAT EXISTS AT THE BOTTOM       @Z40FPPG*/
*/*                                                          @Z40FPPG*/
*/*   CONDITION - ESTAE SETUP COMPLETED                      @Z40FPPG*/
*/*                                                          @Z40FPPG*/
*/*   OUTPUT -                                               @Z40FPPG*/
*/*           .ASWA - FILLED IN AND PLACED ON THE CHAIN      @Z40FPPG*/
*/*           .JSCBASWA - POINTS TO ASWA AS LAST ON CHAIN    @Z40FPPG*/
*/*           .EPRMLSTP - PTR TO HSKPING ESTAE PARMS         @Z40FPPG*/
*/*           .ISSUESTA - ON IF ESTAE ISSUED                 @Z40FPPG*/
*/*                                                          @Z40FPPG*/
*/*   RETURN CODES - REG15 HAS ESTAE RETURN CODE             @Z40FPPG*/
*/*                  IF ONE WAS ISSUED. (ZERO OTHERWISE)     @Z40FPPG*/
*/*                                                          @Z40FPPG*/
*/********************************************************************/
*                                                               03S0085
*       REG15=ZERO;                 /* INIT RETURN CODE      @Z40FPPG*/
         SLR   REG15,REG15                                      03S0085
*       ASWAPTR=ADDR(ASWACORE);     /* ADDRESS ASWA CORE     @Z40FPPG*/
         LA    ASWAPTR,ASWACORE                                 03S0086
*       ASWA=ASWA&&ASWA;            /* ZERO OUT ASWA         @Z40FPPG*/
         XC    ASWA(40,ASWAPTR),ASWA(ASWAPTR)                   03S0087
*       ASWAID=CHARASWA;            /* FILL IN BLOCK ID      @Z40FPPG*/
         MVC   ASWAID(4,ASWAPTR),@CC00114                       03S0088
*       ASWACSCT=EXITCSCT;          /* CSECT NAME OF EXIT    @Z40FPPG*/
         MVC   ASWACSCT(8,ASWAPTR),@CC00116                     03S0089
*       ASWARTNP=ADDR(IEFAB4EA);    /* ADDRESS OF EXIT RTN   @Z40FPPG*/
         L     @08,@CV00138                                     03S0090
         STCM  @08,15,ASWARTNP(ASWAPTR)                         03S0090
*       ASWAPRMS=EPRMLSTP;          /* PARMS FOR THIS EXIT   @Z40FPPG*/
         STCM  EPRMLSTP,15,ASWAPRMS(ASWAPTR)                    03S0091
*       JSCBWRKP=JSCBACT;           /* GET ACTIVE JSCB       @Z40FPPG*/
         ST    @14,JSCBWRKP                                     03S0092
*       RFY                                                     03S0093
*         IEZJSCB BASED(JSCBWRKP);  /*                       @Z40FPPG*/
*       ISSUESTA=OFF;               /* INIT. ESTAE SW        @Z40FPPG*/
         NI    ISSUESTA,B'01111111'                             03S0094
*       IF JSCBASWA=ZERO|           /* NO ALLOC ESTAE IN EFFECT OR
*                                                            @Z40FPPG*/
*           JSCBASWA->ASWASCBP^=TCBSTABB THEN/* ITS NOT THE CURRENT
*                                      ONE                   @Z40FPPG*/
         L     @14,JSCBASWA(,@14)                               03S0095
         LTR   @14,@14                                          03S0095
         BZ    @RT00095                                         03S0095
         L     @08,LOC16PTR                                     03S0095
         L     @08,TCBLISTP(,@08)                               03S0095
         L     @08,TCBPTR(,@08)                                 03S0095
         ICM   @07,15,ASWASCBP(@14)                             03S0095
         L     @14,TCBSTABB-1(,@08)                             03S0095
         LA    @14,0(,@14)                                      03S0095
         CR    @07,@14                                          03S0095
         BE    @RF00095                                         03S0095
@RT00095 DS    0H                                               03S0096
*         DO;                       /* PROCESS NEW ESTAE     @Z40FPPG*/
*           ISSUESTA=ON;            /* SAY ESTAE ISSUED      @Z40FPPG*/
         OI    ISSUESTA,B'10000000'                             03S0097
*           ASWAAUTO=ADDR(AB4EDCOR);/* 1ST ASWA GIVES W/A    @Z40FPPG*/
         LA    @14,AB4EDCOR                                     03S0098
         STCM  @14,15,ASWAAUTO(ASWAPTR)                         03S0098
*           ASWAOLDP=JSCBASWA;      /* OLD LAST IF ANY       @Z40FPPG*/
         L     @14,JSCBWRKP                                     03S0099
         MVC   ASWAOLDP(4,ASWAPTR),JSCBASWA(@14)                03S0099
*           RFY                                                 03S0100
*            (REG2,                                             03S0100
*             REG3) RSTD;           /* RESTRICT WORK REGS    @Z40FPPG*/
*           REG2=ADDR(IEFAB4ED);    /* COMMON ESTAE EXIT     @Z40FPPG*/
         L     REG2,@CV00139                                    03S0101
*           REG3=ASWAPTR;           /* ASWA IS EXIT PARMS    @Z40FPPG*/
         LR    REG3,ASWAPTR                                     03S0102
*           ESTAECOR(1:ESTAELEN)=ESTAELST(1:ESTAELEN);/* MOVE TO AUTO
*                                      CORE                  @Z40FPPG*/
         L     @14,ESTAELEN                                     03S0103
         BCTR  @14,0                                            03S0103
         EX    @14,@SM01862                                     03S0103
*           GEN REFS(ESTAECOR) SETS(REG15,TCBSTABB);            03S0104
      ESTAE (2),PARAM=(3),RECORD=YES,TERM=YES,MF=(E,ESTAECOR)
*           RFY                                                 03S0105
*            (REG2,                                             03S0105
*             REG3) UNRSTD;                                     03S0105
*           IF REG15=ZERO THEN      /* IF ESTAE SUCCESSFUL   @Z40FPPG*/
         LTR   REG15,REG15                                      03S0106
         BNZ   @RF00106                                         03S0106
*             ASWASCBP=TCBSTABB;    /* CURRENT SCB @         @Z40FPPG*/
         L     @14,LOC16PTR                                     03S0107
         L     @14,TCBLISTP(,@14)                               03S0107
         L     @14,TCBPTR(,@14)                                 03S0107
         L     @14,TCBSTABB-1(,@14)                             03S0107
         LA    @14,0(,@14)                                      03S0107
         STCM  @14,15,ASWASCBP(ASWAPTR)                         03S0107
*         END;                      /* END IF ESTAE ISSUED   @Z40FPPG*/
*       ELSE                        /* CURRENT IS ALLOC'S    @Z40FPPG*/
*         DO;                       /* USE EXISTING ESTAE    @Z40FPPG*/
         B     @RC00095                                         03S0109
@RF00095 DS    0H                                               03S0110
*           ASWASCBP=JSCBASWA->ASWASCBP;/* SCB @ FROM LAST      03S0110
*                                      ASWA@Z40FPPG                  */
         L     @14,JSCBWRKP                                     03S0110
         L     @14,JSCBASWA(,@14)                               03S0110
         MVC   ASWASCBP(4,ASWAPTR),ASWASCBP(@14)                03S0110
*           ASWACHNP=JSCBASWA;      /* POINT BACK TO LAST    @Z40FPPG*/
         STCM  @14,15,ASWACHNP(ASWAPTR)                         03S0111
*         END;                      /* CURRENT ESTAE USED    @Z40FPPG*/
*       IF REG15=ZERO THEN          /* IF NO ERROR           @Z40FPPG*/
@RC00095 SLR   @14,@14                                          03S0113
         CR    REG15,@14                                        03S0113
         BNE   @RF00113                                         03S0113
*         DO;                       /* PUT ASWA ONTO CHAIN   @Z40FPPG*/
*           DO;                     /* MODESET KEYADDR(ZERO)         */
*             SPKA(ZERO);           /* SET PSW KEY                   */
         SPKA  0(@14)                                           03S0116
*           END;                    /* MODESET KEYADDR(ZERO) KEY TO
*                                      UPDATE JSCB           @Z40FPPG*/
*           JSCBASWA=ASWAPTR;       /* NEW LAST ASWA PTR     @Z40FPPG*/
         L     @14,JSCBWRKP                                     03S0118
         ST    ASWAPTR,JSCBASWA(,@14)                           03S0118
*           DO;                     /* MODESET EXTKEY(SCHED)         */
*             SPKA(16);             /* SET PSW KEY                   */
         LA    @14,16                                           03S0120
         SPKA  0(@14)                                           03S0120
*           END;                    /* MODESET EXTKEY(SCHED) BACK TO
*                                      SCHED KEY             @Z40FPPG*/
*         END;                      /* END IF NO ERROR       @Z40FPPG*/
*       RFY                                                     03S0123
*         IEZJSCB BASED(JSCBPTR);   /*                       @Z40FPPG*/
@RF00113 DS    0H                                               03S0124
*       IF REG15^=0 THEN            /* ESTAE ENVIRONMENT NOT SET     */
         LTR   REG15,REG15                                      02S0124
         BZ    @RF00124                                         02S0124
*         DO;                       /* - FAILING SITUATION           */
*           RFY                                                 02S0126
*            (REG0,                                             02S0126
*             REG1) RSTD;                                       02S0126
*           SBPOOL=SUBPOOOL;        /* SET SUBPOOL NUMBER            */
         MVI   SBPOOL,X'E6'                                     02S0127
*           LENTH=LENGTH(EPARMLST); /* LENGTH OF ESTAE PARMLIST      */
         MVC   LENTH(3),@CF01849+1                              02S0128
*           REG0=SPLEN;             /* SUBPOOL+LENGTH TO REG 0       */
         L     REG0,SPLEN                                       02S0129
*           REG1=EPRMLSTP;          /* PTR TO PARMLIST               */
         LR    REG1,EPRMLSTP                                    02S0130
*           GEN(FREEMAIN R,LV=(0),A=(1));                       02S0131
         FREEMAIN R,LV=(0),A=(1)
*           RFY                                                 02S0132
*            (REG0,                                             02S0132
*             REG1) UNRSTD;                                     02S0132
*           RTNCODE=STEPERR;        /* 8 - ESTABLISH ESTAE           */
         MVC   RTNCODE(4),@CF00074                              02S0133
*           REASONCD=ESTAEERR;      /* 16 - ENVIRONMENT FAILED       */
         L     @14,@PC00001+36                                  02S0134
         MVC   REASONCD(2,@14),@CH00055                         02S0134
*         END;                                                  02S0135
*       RFY                                                     02S0136
*        (REG15) UNRSTD;            /*                       @Z40FPPG*/
@RF00124 DS    0H                                               02S0137
*       IF RTNCODE=SUCCESS THEN     /* SUCCESSFUL ESTAE              */
         L     @08,RTNCODE                                      01S0137
         LTR   @08,@08                                          01S0137
         BNZ   @RF00137                                         01S0137
*         DO;                                                   01S0138
*                                                               02S0139
*/********************************************************************/
*/*                                                                  */
*/* SEGMENT NAME - HSKPINIT                                          */
*/*                                                                  */
*/* DESCRIPTIVE NAME - HSKP INITIALIZATION ROUTINE                   */
*/*                                                                  */
*/* FUNCTION - OBTAIN AND INITIALIZE THE HOUSEKEEPING WORKAREA       */
*/*                                                                  */
*/*     OPERATION - INITIALLY A GETMAIN IS ISSUED TO OBTAIN SPACE TO */
*/*            CONSTRUCT THE HOUSEKEEPING WORKAREA(HSKPWA). THE      */
*/*            WORKAREA IS THEN INITALIZED WITH INFORMATION PASSED   */
*/*            TO JFCB HOUSEKEEPING. FIELDS ARE INITIALIZED EITHER   */
*/*            TO ZERO OR WITH THE INFORMATION LISTED AS INPUT DATA  */
*/*            BELOW. THE INPUT FUNCTION MAP BECOMES GLOBAL CONTROLS */
*/*            WITHIN THE CONTROL AREA OF HSKPWA. A PARAMETER LIST   */
*/*            FOR SUBSEQUENT HOUSEKEEPING PROCESSING IS CONSTRUCTED */
*/*            AS FOLLOWS:                                           */
*/*                      WORD1 - PTR TO CONTROL INFO.                */
*/*                      WORD2 - PTR TO DATA AREA.                   */
*/*                      WORD3 - PTR TO INTERNAL RETURN INFO AREA.   */
*/*                      WORD4 - PTR TO ADDRESS OF FIRST SIOT TO BE  */
*/*                                PROCESSED.                        */
*/*            ERROR SITUATIONS(E.G. GETMAIN) ARE REPRESENTED BY A   */
*/*            STEP RELATED REASON CODE PLACED IN A HALF-WORD RETURN */
*/*            AREA PASSED BY THE CALLER OF HOUSEKEEPING.            */
*/*                                                                  */
*/*                                                                  */
*/*                                                                  */
*/* ENTRY - N/A (INLINE SEGMENT)                                     */
*/*   PURPOSE - INCLUDED ONCE PER JOB STEP/SESSION WITHIN HSKP       */
*/*             CONTROL                                              */
*/*                                                                  */
*/*   INPUT DATA - A PARAMETER LIST CONTAINING THE FOLLOWING:        */
*/*                                                                  */
*/*                 WORD1 -  CALLER'S FUNCTION MAP                   */
*/*                 WORD2 -  PTR OF FIRST SIOT TO BE PROCESSED       */
*/*                 WORD3 -  THE JOB STEP NUMBER OR ZERO             */
*/*                 WORD4 -  PTR OF JCT                              */
*/*                 WORD5 -  PTR OF SCT                              */
*/*                 WORD6 -  PTR TO LAST EPA IN CHAIN                */
*/*                 WORD7 -  PTR TO SPECIAL EPA CHAIN                */
*/*                 WORD8 -  PTR OF JSCB                             */
*/*                 WORD9 -  PTR OF IOS LOOKUP TABLE                 */
*/*                 WORD10- 2 BYTE FIELD FOR RETURNING STEP RELATED  */
*/*                            REASON CODE TO CALLER                 */
*/*                                                                  */
*/* EXITS - N/A                                                      */
*/*   CONDITION -IF GETMAIN FAILURE, APPROPRIATE REASON CODE PLACED  */
*/*             IN CALLER'S RETURN INFORMATION AREA.                 */
*/*   OUTPUT DATA - INITIALIZED WORK AREA (HSKPWA)                   */
*/*                                                                  */
*/*   RETURN CODE - R15 - 0 SUCCESSFUL                               */
*/*                       8 STEP RELATED ERROR                       */
*/********************************************************************/
*                                                               02S0139
*           GETLNTH=LENGTH(HWCNTRL)+/* CALCULATE WORKAREA LENGTH     */
*               LENGTH(HWDATA)+LENGTH(HWRETURN)+LENGTH(HWUCLST);
*                                                               02S0139
         LA    @08,1085                                         02S0139
         ST    @08,GETLNTH                                      02S0139
*           /*********************************************************/
*           /*                                                       */
*           /* ?GETSTORG (SUBPOOOL,GETLNTH,ADDRESS);                 */
*           /*                                                       */
*           /*********************************************************/
*                                                               02S0140
*                                                               02S0140
*           /*********************************************************/
*           /*                                                       */
*           /* DEFINITIONS OF GETMAIN PARMS                          */
*           /*                                                       */
*           /*********************************************************/
*                                                               02S0140
*           DCL                                                 02S0140
*             GTSTR0 FIXED(31) REG(0),/* GTMN PARM REG               */
*             GTSTR1 FIXED(31) REG(1),/* GTMN PARM REG               */
*             GTSTR2 PTR(31) REG(2),/* GTMN PARM REG                 */
*             GTSTR15 FIXED(31) REG(15),/* GTMN RET COD              */
*             GTSTRTCD FIXED(31);   /* GETMAIN RTN CODE              */
*           DCL                                                 02S0141
*             GTSTR3 FIXED(31) REG(3),/* CLEARING REG                */
*             GTSTR4 FIXED(31) REG(4),/* CLEARING REG                */
*             GTSTR5 FIXED(31) REG(5),/* CLEARING REG                */
*             GTSTR6 FIXED(31) REG(6),/* CLEARING REG                */
*             GTSTR7 FIXED(31) REG(7),/* CLEARING REG                */
*             GTSTR8 FIXED(31) REG(8),/* CLEARING REG                */
*             GTSTZERO FIXED(31) INIT(0),                       02S0141
*             GTST253 FIXED(31) CONSTANT(253);                  02S0141
*           RFY                                                 02S0142
*            (GTSTR0,                                           02S0142
*             GTSTR1,                                           02S0142
*             GTSTR2) RSTD;         /* SAVE RGS                      */
*           GTSTR0=GETLNTH;         /* SET AMOUNT                    */
         LR    GTSTR0,@08                                       02S0143
*           GTSTR2=SUBPOOOL;        /* SET SUBPOOL                   */
         LA    GTSTR2,230                                       02S0144
*           GENERATE CODE;                                      02S0145
       GETMAIN RC,LV=(0),SP=(2)  DO GETMAIN
*           GTSTRTCD=GTSTR15;       /* SAVE GETMAIN RET COD          */
         ST    GTSTR15,GTSTRTCD                                 02S0146
*           ADDRESS=GTSTR1;         /* ADDR OF GOTN STORG            */
         ST    GTSTR1,ADDRESS                                   02S0147
*           RFY                                                 02S0148
*            (GTSTR0,                                           02S0148
*             GTSTR1,                                           02S0148
*             GTSTR2) UNRSTD;       /* RLSE                          */
*           IF GTSTRTCD=0 THEN      /* GETMAIN SUCCESSFUL?           */
         L     @08,GTSTRTCD                                     02S0149
         LTR   @08,@08                                          02S0149
         BNZ   @RF00149                                         02S0149
*             DO;                   /* YES, CLEAR STORAGE.           */
*               RFY                                             02S0151
*                (GTSTR2,                                       02S0151
*                 GTSTR4,                                       02S0151
*                 GTSTR5,                                       02S0151
*                 GTSTR6,                                       02S0151
*                 GTSTR7,                                       02S0151
*                 GTSTR8) RSTD;                                 02S0151
*               GTSTR4=ADDRESS;     /* STORG PTR                     */
         L     @03,ADDRESS                                      02S0152
         LR    GTSTR4,@03                                       02S0152
*               GTSTR5=GETLNTH;     /* STORG AMNT                    */
         L     GTSTR5,GETLNTH                                   02S0153
*               GTSTR7='00000000'X; /* PAD CHAR & LNTH               */
         SLR   GTSTR7,GTSTR7                                    02S0154
*               IF SUBPOOOL=GTST253 THEN                        02S0155
         B     @RF00155                                         02S0155
*                 GEN(MODESET KEYADDR=GTSTZERO,SAVEKEY=(2),WORKREG=8);
         MODESET KEYADDR=GTSTZERO,SAVEKEY=(2),WORKREG=8
*               GEN REFS(GTSTR4,GTSTR6);                        02S0157
@RF00155 DS    0H                                               02S0157
            MVCL  GTSTR4,GTSTR6 CLEAR GOTTEN STORG
*               IF SUBPOOOL=GTST253 THEN                        02S0158
         B     @RF00158                                         02S0158
*                 GEN(MODESET KEYADDR=(2));                     02S0159
         MODESET KEYADDR=(2)
*               RFY                                             02S0160
*                (GTSTR2,                                       02S0160
*                 GTSTR4,                                       02S0160
*                 GTSTR5,                                       02S0160
*                 GTSTR6,                                       02S0160
*                 GTSTR7,                                       02S0160
*                 GTSTR8) UNRSTD;                               02S0160
@RF00158 DS    0H                                               02S0161
*             END;                  /* STORAGE CLEARING COMPLETED    */
*           ELSE                                                02S0162
*             ADDRESS=0;            /* CLEAR RETURN ADDR.            */
         B     @RC00149                                         02S0162
@RF00149 SLR   @08,@08                                          02S0162
         ST    @08,ADDRESS                                      02S0162
*           GTSTR15=GTSTRTCD;       /* GTMN RETURN CODE              */
@RC00149 L     GTSTR15,GTSTRTCD                                 02S0163
*                                   /* RESTORE LIST PRINT STATUS     */
*                                                               02S0164
*           /*********************************************************/
*           /*                                                       */
*           /* HAVE GETMAIN ISSUED                                   */
*           /*                                                       */
*           /*********************************************************/
*                                                               02S0164
*           IF REG15=SUCCESS THEN   /* GETMAIN FOR WORKAREA GOOD     */
         LTR   REG15,REG15                                      02S0164
         BNZ   @RF00164                                         02S0164
*             DO;                                               02S0165
*                                                               02S0165
*               /*****************************************************/
*               /*                                                   */
*               /* FOLLOWING CODE INITIALIZES CONTROL, DATA, AND     */
*               /* RETURN INFO AREA POINTERS. THESE AREAS MAKE UP    */
*               /* HSKP WORKAREA.                                    */
*               /*                                                   */
*               /*****************************************************/
*                                                               02S0166
*               HWCNTRLP=ADDRESS;   /* POINTER TO CONTROL AREA       */
         L     @08,ADDRESS                                      02S0166
         ST    @08,HWCNTRLP                                     02S0166
*               HWDATAP=HWCNTRLP+LENGTH(HWCNTRL);/* PTR TO DATA AREA */
         LA    @15,16                                           02S0167
         ALR   @15,@08                                          02S0167
         ST    @15,HWDATAP                                      02S0167
*               HWUCLPTR=HWDATAP+LENGTH(HWDATA);/* PTR TO UNIT NAME
*                                      CONVERSION LIST               */
         LA    @14,1054                                         02S0168
         ALR   @14,@15                                          02S0168
         ST    @14,HWUCLPTR(,@15)                               02S0168
*               HWRTNP=HWUCLPTR+LENGTH(HWUCLST);/* PTR TO RETURN AREA*/
*                                                               02S0169
         AL    @14,@CF00492                                     02S0169
         ST    @14,HWRTNP                                       02S0169
*               /*****************************************************/
*               /*                                                   */
*               /* FOLLOWING CODE INITIALIZE FIELDS WITHIN THE       */
*               /* CONTROL AND DATA AREA OF THE HSKP WORKAREA WITH   */
*               /* DATA PASSED AS INPUT TO THE HSKP PROCESS OR       */
*               /* OBTAINED AS RESULT OF ABOVE GETMAIN.              */
*               /*                                                   */
*               /*****************************************************/
*                                                               02S0170
*               HWGETADD=ADDRESS;   /* SAVE ADDRESS OF GETMAIN       */
         ST    @08,HWGETADD(,@15)                               02S0170
*               HWGETSPN=SUBPOOOL;  /* SUBPOOL FOR HSKPWA GETMAIN    */
         MVC   HWGETSPN(4,@15),@CF00043                         02S0171
*               HWGETLN=GETLNTH;    /* LENGTH OF HSKPWA GETMAIN      */
         L     @14,GETLNTH                                      02S0172
         ST    @14,HWGETLN(,@15)                                02S0172
*               HWCNTRL=IFUNCTN;    /* MOVE INPUT FUNCTION MAP TO
*                                      HSKPWA GLOBAL CONTROL AREA    */
         XC    HWCNTRL+2(14,@08),HWCNTRL+2(@08)                 02S0173
         L     @14,@PC00001                                     02S0173
         MVC   HWCNTRL(2,@08),IFUNCTN(@14)                      02S0173
*               HWFSIOTP=FSIOTPTR;  /* POINTER TO FIRST SIOT         */
         L     @08,@PC00001+4                                   02S0174
         L     @08,FSIOTPTR(,@08)                               02S0174
         ST    @08,HWFSIOTP(,@15)                               02S0174
*               HWSTEPNO=STEPNUMB;  /* NUMBER OF STEP BEING PROCESSED*/
         L     @08,@PC00001+8                                   02S0175
         IC    @14,STEPNUMB(,@08)                               02S0175
         STC   @14,HWSTEPNO(,@15)                               02S0175
*               HWJCTP=JCTPTR;      /* CORE POINTER TO THE JCT       */
         L     @08,@PC00001+12                                  02S0176
         L     @08,JCTPTR(,@08)                                 02S0176
         ST    @08,HWJCTP(,@15)                                 02S0176
*               HWSCTP=SCTPTR;      /* CORE POINTER TO THE SCT       */
         L     @08,@PC00001+16                                  02S0177
         L     @08,SCTPTR(,@08)                                 02S0177
         ST    @08,HWSCTP(,@15)                                 02S0177
*               HWLEPAP=LEPAPTR;    /* PTR TO LAST EPA ON EPA CHAIN  */
         L     @08,@PC00001+20                                  02S0178
         L     @08,LEPAPTR(,@08)                                02S0178
         ST    @08,HWLEPAP(,@15)                                02S0178
*               HWGEPACP=GEPACPTR;  /* PTR TO SPECIAL EPA CHAIN FOR
*                                      GENERATED TABLES              */
         L     @08,@PC00001+24                                  02S0179
         L     @08,GEPACPTR(,@08)                               02S0179
         ST    @08,HWGEPACP(,@15)                               02S0179
*               HWJSCBP=JSCBPTR;    /* JSCB POINTER                  */
         L     @08,@PC00001+28                                  02S0180
         L     @08,JSCBPTR(,@08)                                02S0180
         ST    @08,HWJSCBP(,@15)                                02S0180
*               HWIOSLTP=IOSLUTP;   /* IOS (UCB) LOOK-UP-TABLE PTR   */
         L     @08,@PC00001+32                                  02S0181
         L     @08,IOSLUTP(,@08)                                02S0181
         ST    @08,HWIOSLTP(,@15)                               02S0181
*               HWCRIP=ADDR(HWCRI); /* CATALOG RETURN INFO PTR       */
         LA    @08,HWCRI(,@15)                                  02S0182
         ST    @08,HWCRIP(,@15)                                 02S0182
*             END;                                              02S0183
*           ELSE                    /* GETMAIN FAILURE               */
*             DO;                                               02S0184
         B     @RC00164                                         02S0184
@RF00164 DS    0H                                               02S0185
*               RTNCODE=FAILURE;    /* CALLER'S RETURN CODE INFO     */
         MVC   RTNCODE(4),@CF00113                              02S0185
*               REASONCD=GETERROR;  /* 2 - CALLER'S REASON CODE      */
         L     @08,@PC00001+36                                  02S0186
         MVC   REASONCD(2,@08),@CH00125                         02S0186
*             END;                                              02S0187
*           IF RTNCODE=SUCCESS THEN /* SUCCESSFUL HSKP INITIALIZATION*/
@RC00164 L     @08,RTNCODE                                      01S0188
         LTR   @08,@08                                          01S0188
         BNZ   @RF00188                                         01S0188
*             DO;                                               01S0189
*               CALL IEFAB452(HWCNTRLP,/* DD PROCESSING CONTROL -    */
*                   HWDATAP,HWRTNP,HWFSIOTP);/* PROCESS ALL REQUESTS
*                                      OF THIS STEP                  */
         LA    @08,HWCNTRLP                                     01S0190
         ST    @08,@AL00001                                     01S0190
         LA    @08,HWDATAP                                      01S0190
         ST    @08,@AL00001+4                                   01S0190
         LA    @08,HWRTNP                                       01S0190
         ST    @08,@AL00001+8                                   01S0190
         L     @08,HWDATAP                                      01S0190
         LA    @08,HWFSIOTP(,@08)                               01S0190
         ST    @08,@AL00001+12                                  01S0190
         L     @15,@CV00137                                     01S0190
         LA    @01,@AL00001                                     01S0190
         BALR  @14,@15                                          01S0190
*               IF HWRTCD=DDERR THEN/* DD RELATED ERROR - 4          */
         LA    @08,4                                            01S0191
         L     @15,HWRTNP                                       01S0191
         CH    @08,HWRTCD(,@15)                                 01S0191
         BNE   @RF00191                                         01S0191
*                 DO;               /* PUT REASON CODE IN SIOT OF    */
*                   HWCSIOTP->SIOTRSNC=HWRSNCD;/* FAILING REQUEST    */
         L     @01,HWDATAP                                      01S0193
         L     @01,HWCSIOTP(,@01)                               01S0193
         LH    @00,HWRSNCD(,@15)                                01S0193
         STH   @00,SIOTRSNC(,@01)                               01S0193
*                   RTNCODE=FAILURE;/* FAILING RETURN CODE - 4       */
         ST    @08,RTNCODE                                      01S0194
*                 END;                                          01S0195
*               ELSE                /* NOT DD RELATED ERROR -4       */
*                 IF HWRTCD=STEPERR THEN/* STEP RELATED ERROR - 8    */
         B     @RC00191                                         01S0196
@RF00191 L     @08,HWRTNP                                       01S0196
         CLC   HWRTCD(2,@08),@CH00074                           01S0196
         BNE   @RF00196                                         01S0196
*                   DO;             /* PUT REASON CODE IN AREA       */
*                     REASONCD=HWRSNCD;/* PROVIDED BY CALLER OF HSKP */
         L     @15,@PC00001+36                                  01S0198
         LH    @08,HWRSNCD(,@08)                                01S0198
         STH   @08,REASONCD(,@15)                               01S0198
*                     RTNCODE=FAILURE;/* FAILING RETURN CODE - 4     */
         MVC   RTNCODE(4),@CF00113                              01S0199
*                   END;                                        01S0200
*               IF HWLEPAP^=LEPAPTR THEN/* IF EPA(S) WERE CREATED    */
@RF00196 DS    0H                                               01S0201
@RC00191 L     @08,HWDATAP                                      01S0201
         L     @08,HWLEPAP(,@08)                                01S0201
         L     @15,@PC00001+20                                  01S0201
         C     @08,LEPAPTR(,@15)                                01S0201
         BE    @RF00201                                         01S0201
*                 LEPAPTR=HWLEPAP;  /* UPDATE CALLER'S LAST EPA PTR  */
         ST    @08,LEPAPTR(,@15)                                01S0202
*               IF HWGEPACP^=GEPACPTR THEN/* IF EPA(S) WERE CREATED  */
@RF00201 L     @08,HWDATAP                                      01S0203
         L     @08,HWGEPACP(,@08)                               01S0203
         L     @15,@PC00001+24                                  01S0203
         C     @08,GEPACPTR(,@15)                               01S0203
         BE    @RF00203                                         01S0203
*                 GEPACPTR=HWGEPACP;/* UPDATE DYNALLOCS EPA PTR      */
         ST    @08,GEPACPTR(,@15)                               01S0204
*                                                               02S0205
*/********************************************************************/
*/*                                                                  */
*/* SEGMENT NAME - HSKPCLUP                                          */
*/*                                                                  */
*/* DESCRIPTIVE NAME - HSKP CLEANUP ROUTINE                          */
*/*                                                                  */
*/* FUNCTION - HOUSEKEEPING CLEANUP IS PERFORMED ONCE PER JOB STEP/  */
*/*            SESSION AT THE END OF THE HOUSEKEEPING PROCESS. IT    */
*/*            INVOLVES UNALLOCATION OF USER CATALOGS AND ISSUANCE   */
*/*            OF A FREEMAIN FOR THE HOUSEKEEPING WORKAREA(HSKPWA).  */
*/*                                                                  */
*/*     OPERATION -  INITIALLY, IT IS DETERMINED IF ANY  PRIVATE     */
*/*            CATALOGS HAVE BEEN ALLOCATED TO THE STEP/SESSION. IF  */
*/*            HOUSEKEEPING WAS USED AS A SUBROUTINE OF DYNAMIC      */
*/*            ALLOCATION AND IF PRIVATE CATALOGS WERE ALLOCATED BY  */
*/*            HOUSEKEEPING DURING THAT SESSION, THOSE CATALOGS WILL */
*/*            NOT BE UNALLOCATED DURING THE HSKP CLEANUP PROCESS.   */
*/*            IF HOUSEKEEPING WAS CALLED FROM STEP ALLOCATION AND   */
*/*            IF CATALOGS ARE ALLOCATED DURING HOUSEKEEPING PROCESS */
*/*            THEN THE  CATALOG UNALLOCATION  ROUTINE(IEFAB4F4) IS  */
*/*            CALLED BY HSKP CLEANUP TO PERFORM THE UNALLOCATION    */
*/*            AND TEMPORARY CLOSE OF ALL PRIVATE VSAM       @YM04224*/
*/*            (USER) CATALOGS ALLOCATED TO THAT STEP. THIS  @YM04224*/
*/*            'TEMPORARY' CLOSE ALLOWS 'OPEN'S' CONTROL     @YM04224*/
*/*            BLOCKS TO REMAIN INTACT, THUS SPEEDING UP     @YM04224*/
*/*            THE SUBSEQUENT OPEN DONE FOR THE PRIVATE      @YM04224*/
*/*            CATALOGS ON BEHALF OF THE PROBLEM PROGRAM.    @YM04224*/
*/*                                                                  */
*/*            THEN AN FSPACE IS ISSUED TO FREE UP THE CORE  @Z40FPPD*/
*/*            PREVIOUSLY OBTAINED FOR AN EPA (USED FOR READ         */
*/*            OPERATIONS DURING HSKP) IF ONE EXISTS, AND A          */
*/*            FREEMAIN IS ISSUED FOR THE HOUSEKEEPING WORKAREA.     */
*/*            ERROR SITUATIONS ARE REPRESENTED BY RELATED           */
*/*            REASON CODES PLACED IN A HALF-WORD RETURN AREA        */
*/*            PASSED BY THE CALLER OF HOUSEKEEPING.                 */
*/*                                                                  */
*/*                                                                  */
*/* ENTRY - N/A (INLINE SEGMENT)                                     */
*/*   PURPOSE - INCLUDED ONCE PER JOB STEP/SESSION WITHIN HSKP       */
*/*             CONTROL                                              */
*/*                                                                  */
*/*   INPUT DATA - IN ADDITION TO THE HSKPWA BEING AVAILABLE TO      */
*/*            THIS SEGMENT, THE JSCB IS SPECIFICALLY USED TO        */
*/*            DETERMINE IF ANY PRIVATE CATALOGS HAVE BEEN ALLOCATED */
*/*            DURING THE HOUSEKEEPING PROCESS AND TO OBTAIN THE     */
*/*            PTR TO THE PCCB CHAIN(IF PRESENT)FROM THE ACTIVE JSCB */
*/*                                                                  */
*/* EXITS -N/A                                                       */
*/*   CONDITION - NO ERROR CONDITIONS ENCOUNTERED IN THIS SEGMENT    */
*/*                                                                  */
*/*   OUTPUT DATA - NONE                                             */
*/*                                                                  */
*/********************************************************************/
*                                                               02S0205
*               IF JSCBACT->JSCBPCC^=0&HWUNLCCT=ON THEN/* IF COND MET
*                                      PROCESS                       */
@RF00203 SLR   @08,@08                                          02S0205
         L     @15,@PC00001+28                                  02S0205
         L     @01,JSCBPTR(,@15)                                02S0205
         L     @01,JSCBACT(,@01)                                02S0205
         C     @08,JSCBPCC(,@01)                                02S0205
         BE    @RF00205                                         02S0205
         L     @15,HWCNTRLP                                     02S0205
         TM    HWUNLCCT(@15),B'00001000'                        02S0205
         BNO   @RF00205                                         02S0205
*                 DO;               /* INITIALIZE UNALLOCATE CTLG    */
*                   UCCNTRLS=0;     /* CLEAR CONTROLS        @YM05752*/
         STH   @08,UCCNTRLS                                     02S0207
*                   IF HWDENQT=ON THEN/* DO NOT ENQ ON TIOT IF       */
         TM    HWDENQT(@15),B'01000000'                         02S0208
         BNO   @RF00208                                         02S0208
*                     UCNTIONQ=ON;  /* CALLER REQUESTS SAME.         */
         OI    UCNTIONQ,B'01000000'                             02S0209
*                   UCALLCAT=ON;    /* CONTROLS TO UNALLOCATE AND    */
@RF00208 DS    0H                                               02S0211
*                   UCALLACB=ON;    /* CLOSE ALL PRIVATE CATALOGS    */
         OI    UCALLCAT,B'00010100'                             02S0211
*                   IF HWRTCD=0 THEN/* TEMPORARILY CLOSE     @YM04224*/
         L     @08,HWRTNP                                       02S0212
         LH    @08,HWRTCD(,@08)                                 02S0212
         LTR   @08,@08                                          02S0212
         BNZ   @RF00212                                         02S0212
*                     UCTEMP=ON;    /* IF NO ERRORS          @YM04224*/
         OI    UCTEMP,B'10000000'                               02S0213
*                   IF HWCAJSCB=ON THEN/* CHANGE ACTIVE JSCB IF      */
@RF00212 L     @08,HWCNTRLP                                     02S0214
         TM    HWCAJSCB(@08),B'00100000'                        02S0214
         BNO   @RF00214                                         02S0214
*                     UCCAJSCB=ON;  /* ALLOWED BY CALLER             */
         OI    UCCAJSCB,B'10000000'                             02S0215
*                   CALL IEFAB4F4   /* CALL IEFAB4F4                 */
*                       (UCCNTRLS,ADDR(RETINFO),0,0,0,JSCBPTR); 02S0216
@RF00214 LA    @08,UCCNTRLS                                     02S0216
         ST    @08,@AL00001                                     02S0216
         LA    @08,RETINFO                                      02S0216
         ST    @08,@TF00001                                     02S0216
         LA    @08,@TF00001                                     02S0216
         ST    @08,@AL00001+4                                   02S0216
         LA    @08,@CF00122                                     02S0216
         ST    @08,@AL00001+8                                   02S0216
         LA    @08,@CF00122                                     02S0216
         ST    @08,@AL00001+12                                  02S0216
         LA    @08,@CF00122                                     02S0216
         ST    @08,@AL00001+16                                  02S0216
         L     @08,@PC00001+28                                  02S0216
         ST    @08,@AL00001+20                                  02S0216
         L     @15,@CV00140                                     02S0216
         LA    @01,@AL00001                                     02S0216
         BALR  @14,@15                                          02S0216
*                   IF RETCODE^=0&  /* RETURN CODE NOT = O           */
*                       REASONCD=0 THEN/* REASON CODE = 0            */
         SLR   @08,@08                                          02S0217
         CH    @08,RETCODE                                      02S0217
         BE    @RF00217                                         02S0217
         L     @15,@PC00001+36                                  02S0217
         CH    @08,REASONCD(,@15)                               02S0217
         BNE   @RF00217                                         02S0217
*                     DO;                                       02S0218
*                       REASONCD=REASCODE;/* SAVE FAILING REASON CODE*/
         LH    @08,REASCODE                                     02S0219
         STH   @08,REASONCD(,@15)                               02S0219
*                       RTNCODE=FAILURE;/* SET FAILING RETURN CODE   */
         MVC   RTNCODE(4),@CF00113                              02S0220
*                     END;                                      02S0221
*                 END;                                          02S0222
@RF00217 DS    0H                                               02S0223
*               IF HWSELDON=ON THEN /* IF MSS SELECTS DONE THEN 02S0223
*                                                            @G24LPSJ*/
@RF00205 L     @08,HWCNTRLP                                     02S0223
         TM    HWSELDON(@08),B'00000010'                        02S0223
         BNO   @RF00223                                         02S0223
*                 IF RTNCODE=SUCCESS THEN/* IF HSKP SUCCESSFUL, THEN
*                                                            @G24LPSJ*/
         L     @08,RTNCODE                                      02S0224
         LTR   @08,@08                                          02S0224
         BNZ   @RF00224                                         02S0224
*                   JHMSSTRM=ON;    /* INDICATE MSS TERMINATION 02S0225
*                                      REQUIRED              @G24LPSJ*/
         L     @08,@PC00001+40                                  02S0225
         OI    JHMSSTRM(@08),B'10000000'                        02S0225
*                 ELSE                                          02S0226
*                   DO;             /*                       @G24LPSJ*/
         B     @RC00224                                         02S0226
@RF00224 DS    0H                                               02S0227
*                                                               03S0227
*/***********************************************************@G24LPSJ*/
*/*                                                          @G24LPSJ*/
*/* SEGMENT NAME - TERMCALL                                  @G24LPSJ*/
*/*                                                          @G24LPSJ*/
*/* DESCRIPTIVE NAME - MSSC TERMINATE PROCESSING             @G24LPSJ*/
*/*                                                          @G24LPSJ*/
*/* FUNCTION -                                               @G24LPSJ*/
*/*                                                          @G24LPSJ*/
*/*   THIS SEGMENT WILL ISSUE THE MSS TERMINATE REQUEST IF   @G24LPSJ*/
*/*   THERE HAS BEEN A HOUSEKEEPING FAILURE.                 @G24LPSJ*/
*/*                                                          @G24LPSJ*/
*/* OPERATION -                                              @G24LPSJ*/
*/*                                                          @G24LPSJ*/
*/*   THE MSS TERMINATE PROCESSING IS DONE. THE TERMINATE    @G24LPSJ*/
*/*   REQUEST BLOCK IS CLEARED AND INITIALIZED. REG 1 IS     @G24LPSJ*/
*/*   POINTED TO THE REQUEST BLOCK AND SVC 126 ISSUED.       @G24LPSJ*/
*/*                                                          @G24LPSJ*/
*/* ENTRY - IN-LINE SEGMENT                                  @G24LPSJ*/
*/*                                                          @G24LPSJ*/
*/*   PURPOSE - SEE FUNCTION                                 @G24LPSJ*/
*/*   INPUT - ASCB                                           @G24LPSJ*/
*/*                                                          @G24LPSJ*/
*/*                                                          @G24LPSJ*/
*/* EXIT -                                                   @G24LPSJ*/
*/*                                                          @G24LPSJ*/
*/*   CONDITION - MSSC TERMINATE ISSUED                      @G24LPSJ*/
*/*     OUTPUT -                                             @G24LPSJ*/
*/*       NONE                                               @G24LPSJ*/
*/*     RETURN CODES -                                       @G24LPSJ*/
*/*       NONE                                               @G24LPSJ*/
*/*                                                          @G24LPSJ*/
*/***********************************************************@G24LPSJ*/
*                                                               03S0227
*                     RFY                                       03S0227
*                       TRMRB BASED(ADDR(TERMAREA));/* SET ADDR FOR
*                                      TERMINATE REQUEST BLOCK  03S0227
*                                                            @G24LPSJ*/
*                     TRMRB=TRMRB&&TRMRB;/* CLEAR BLOCK      @G24LPSJ*/
         LA    @08,TERMAREA                                     03S0228
         XC    TRMRB(16,@08),TRMRB(@08)                         03S0228
*                     TRMRBLEN=LENGTH(TRMRB);/* SET TERM LENGTH 03S0229
*                                                            @G24LPSJ*/
         MVC   TRMRBLEN(4,@08),@CF00055                         03S0229
*                     TRMRBOPC=TRMOPCD;/* SET TERM OP CODE   @G24LPSJ*/
         MVI   TRMRBOPC(@08),X'8A'                              03S0230
*                     ASCBPTR=PSAAOLD;/* SET ASCB ADDRESS    @G24LPSJ*/
         L     ASCBPTR,PSAAOLD                                  03S0231
*                     TRMJOBID=ASCBASID;/* SET ASID OF STEP  @G24LPSJ*/
         LH    @03,ASCBASID(,ASCBPTR)                           03S0232
         N     @03,@CF01865                                     03S0232
         ST    @03,TRMJOBID(,@08)                               03S0232
*                     REG1=ADDR(TRMRB);/* LOAD ADDR TRMTRB   @G24LPSJ*/
         LR    REG1,@08                                         03S0233
*                     RFY                                       03S0234
*                       REG1 RSTD;  /* RESTRICT REG 1        @G24LPSJ*/
*                     SVC(126);     /* CALL MSSC             @G24LPSJ*/
         SVC   126                                              03S0235
*                     RFY                                       03S0236
*                       REG1 UNRSTD;/* RELEASE REG 1         @G24LPSJ*/
*                   END;            /*                       @G24LPSJ*/
*/*** COMMUNICATE TO DYN.ALLOCATION THAT JCT WAS/WAS NOT ADDED TO  ***/
*/*** EPA CHAIN DURING GDG PROCESSING                              ***/
*                                                               02S0238
*               IF HWEPAJCT=OFF&    /* JCT ADDED TO EPA CHAIN        */
*                   IAEPAJCT=ON THEN/* AND DYN.ALLOCATION CALLING    */
@RC00224 DS    0H                                               02S0238
@RF00223 L     @08,HWCNTRLP                                     02S0238
         TM    HWEPAJCT(@08),B'00010000'                        02S0238
         BNZ   @RF00238                                         02S0238
         L     @08,@PC00001                                     02S0238
         TM    IAEPAJCT(@08),B'00010000'                        02S0238
         BNO   @RF00238                                         02S0238
*                 IAEPAJCT=OFF;                                 02S0239
*                                                               02S0239
         NI    IAEPAJCT(@08),B'11101111'                        02S0239
*/*** THE FOLLOWING SETS UP AND FREES AN EPA, IF ONE EXISTS @Z40FPPD**/
*/*** (HWLEPARP NOT 0), THAT WAS USED FOR READING SWA.  THE @Z40FPPD**/
*/*** EPA WAS GOTTEN VIA GSPACE IN IEFAB4F7. A CATALOG      @Z40FPPD**/
*/*** VOLUME LIST IS FREED IF ONE EXISTS OUTSIDE HSKPWA AND THEN    **/
*/*** THE HOUSEKEEPING WORKAREA IS FREED.                           **/
*                                                               02S0240
*               RFY                                             02S0240
*                (REG0,                                         02S0240
*                 REG1) RSTD;                                   02S0240
@RF00238 DS    0H                                               02S0241
*               IF HWLEPARP^=0 THEN /* AN EPA EXISTS                 */
         L     @08,HWDATAP                                      02S0241
         L     @08,HWLEPARP(,@08)                               02S0241
         LTR   @08,@08                                          02S0241
         BZ    @RF00241                                         02S0241
*                 DO;                                           02S0242
*                   SBPOOL=SUBPOOOL;/* SET SUBPOOL NUMBER            */
         MVI   SBPOOL,X'E6'                                     02S0243
*                   LENTH=LENGTH(SWAEPA);/* LENGTH OF AN EPA         */
         MVC   LENTH(3),@CF00055+1                              02S0244
*                   REG0=SPLEN;     /* SUBPOOL+LENGTH TO REG 0       */
         L     REG0,SPLEN                                       02S0245
*                   REG1=HWLEPARP;  /* POINTER TO EPA                */
         LR    REG1,@08                                         02S0246
*                   GEN(FREEMAIN R,LV=(0),A=(1));/* FREE EPA @Z40FPPD*/
         FREEMAIN R,LV=(0),A=(1)
*                 END;                                          02S0248
*               IF HWNEWVL=ON THEN  /* AN ADDITIONAL VOL LIST        */
@RF00241 L     @08,HWCNTRLP                                     02S0249
         TM    HWNEWVL(@08),B'00001000'                         02S0249
         BNO   @RF00249                                         02S0249
*                 DO;                                           02S0250
*                   SBPOOL=SUBPOOOL;/* SET SUBPOOL NUMBER            */
         MVI   SBPOOL,X'E6'                                     02S0251
*                   LENTH=CTGWALV;  /* LENGTH OF VOL LIST            */
         L     @08,HWDATAP                                      02S0252
         L     @08,HWCRIP(,@08)                                 02S0252
         L     @08,CTGWKA(,@08)                                 02S0252
         LH    @15,CTGWALV(,@08)                                02S0252
         STCM  @15,7,LENTH                                      02S0252
*                   REG0=SPLEN;     /* SUBPOOL+LENGTH TO REG 0       */
         L     REG0,SPLEN                                       02S0253
*                   REG1=CTGWAVL;   /* POINTER TO VOL LIST           */
         L     REG1,CTGWAVL(,@08)                               02S0254
*                   GEN(FREEMAIN R,LV=(0),A=(1));               02S0255
         FREEMAIN R,LV=(0),A=(1)
*                 END;                                          02S0256
*               SBPOOL=SUBPOOOL;    /* SET SUBPOOL NUMBER            */
@RF00249 MVI   SBPOOL,X'E6'                                     02S0257
*               LENTH=HWGETLN;      /* LENGTH OF HSKP WORKAREA       */
         L     @08,HWDATAP                                      02S0258
         MVC   LENTH(3),HWGETLN+1(@08)                          02S0258
*               REG0=SPLEN;         /* SUBPOOL+LENGTH TO REG 0       */
         L     REG0,SPLEN                                       02S0259
*               REG1=HWGETADD;      /* ADDRESS OF WORKAREA           */
         L     REG1,HWGETADD(,@08)                              02S0260
*               GEN(FREEMAIN R,LV=(0),A=(1));                   02S0261
         FREEMAIN R,LV=(0),A=(1)
*               RFY                                             01S0262
*                 IEZJSCB BASED(JSCBWRKP);/* REFER TO ACTIVE @Z40FPPG*/
*               DO;                 /* MODESET KEYADDR(ZERO)         */
*                 SPKA(ZERO);       /* SET PSW KEY                   */
         SLR   @08,@08                                          01S0264
         SPKA  0(@08)                                           01S0264
*               END;                /* MODESET KEYADDR(ZERO) KEY TO
*                                      UPDATE JSCB           @Z40FPPG*/
*               IF ISSUESTA=ON THEN /* WAS ESTAE ISSUED      @Z40FPPG*/
         TM    ISSUESTA,B'10000000'                             01S0266
         BNO   @RF00266                                         01S0266
*                 JSCBASWA=ASWAOLDP;/* ZERO OR OLD LAST      @Z40FPPG*/
         L     @08,JSCBWRKP                                     01S0267
         MVC   JSCBASWA(4,@08),ASWAOLDP(ASWAPTR)                01S0267
*               ELSE                /* NO ESTAE ISSUED       @Z40FPPG*/
*                 JSCBASWA=ASWACHNP;/* PRECEEDING IS LAST    @Z40FPPG*/
         B     @RC00266                                         01S0268
@RF00266 L     @08,JSCBWRKP                                     01S0268
         MVC   JSCBASWA(4,@08),ASWACHNP(ASWAPTR)                01S0268
*               DO;                 /* MODESET EXTKEY(SCHED)         */
@RC00266 DS    0H                                               01S0270
*                 SPKA(16);         /* SET PSW KEY                   */
         LA    @15,16                                           01S0270
         SPKA  0(@15)                                           01S0270
*               END;                /* MODESET EXTKEY(SCHED) BACK TO
*                                      SCHED KEY             @Z40FPPG*/
*               RFY                                             01S0272
*                 IEZJSCB BASED(JSCBPTR);/* RESET BASE       @Z40FPPG*/
*               IF ISSUESTA=ON THEN /* WAS ESTAE ISSUED      @Z40FPPG*/
         TM    ISSUESTA,B'10000000'                             01S0273
         BNO   @RF00273                                         01S0273
*                 DO;               /* YES, CANCEL IT        @Z40FPPG*/
*                   GEN REFS(ESTAECOR);                         01S0275
                  ESTAE 0,MF=(E,ESTAECOR)
*                 END;              /*                       @Z40FPPG*/
*               RFY                                             01S0277
*                (REG0,                                         01S0277
*                 REG1) RSTD;       /* ESTAE PARMLIST IS TO BE FREED */
@RF00273 DS    0H                                               01S0278
*               SBPOOL=SUBPOOOL;    /* SET SUBPOOL NUMBER            */
         MVI   SBPOOL,X'E6'                                     01S0278
*               LENTH=LENGTH(EPARMLST);/* LENGTH OF ESTAE PARMLIST   */
         MVC   LENTH(3),@CF01849+1                              01S0279
*               REG0=SPLEN;         /* SET SUBPOOL+LENGTH IN REG 0   */
         L     REG0,SPLEN                                       01S0280
*               REG1=EPRMLSTP;      /* PTR TO PARMLIST TO FREE       */
         LR    REG1,EPRMLSTP                                    01S0281
*               GEN(FREEMAIN R,LV=(0),A=(1));                   01S0282
         FREEMAIN R,LV=(0),A=(1)
*               RFY                                             01S0283
*                (REG0,                                         01S0283
*                 REG1) UNRSTD;                                 01S0283
*             END;                                              01S0284
*         END;                                                  01S0285
@RF00188 DS    0H                                               01S0286
*     END;                                                      01S0286
@RF00137 DS    0H                                               01S0287
*   RETURN CODE(RTNCODE);           /* RETURN TO CALLER PASSING 01S0287
*                                      APPROPRIATE RETURN CODE       */
@RF00062 L     @10,RTNCODE                                      01S0287
         L     @13,4(,@13)                                      01S0287
         L     @00,@SIZDATD                                     01S0287
         LR    @01,@11                                          01S0287
         FSPACE   R,LV=(0),A=(1)
         LR    @15,@10                                          01S0287
         L     @14,12(,@13)                                     01S0287
         LM    @00,@12,20(@13)                                  01S0287
         BR    @14                                              01S0287
*   END IEFAB451                    /* END HSKP CONTROL ROUTINE      */
*                                                               01S0288
*/* THE FOLLOWING INCLUDE STATEMENTS WERE FOUND IN THIS PROGRAM.     */
*/*%INCLUDE SYSUT5  (HCNTLSPC)                                       */
*/*%INCLUDE SYSUT5  (B451DATA)                                       */
*/*%INCLUDE SYSLIB  (IEFZB437)                                       */
*/*%INCLUDE SYSLIB  (IEFZB444)                                       */
*/*%INCLUDE SYSLIB  (IEFZB443)                                       */
*/*%INCLUDE SYSLIB  (IEZJSCB )                                       */
*/*%INCLUDE SYSLIB  (IEZCTGPL)                                       */
*/*%INCLUDE SYSLIB  (IEZCTGWA)                                       */
*/*%INCLUDE SYSLIB  (IEFZB505)                                       */
*/*%INCLUDE SYSLIB  (IEFASCTB)                                       */
*/*%INCLUDE SYSLIB  (IEFASIOT)                                       */
*/*%INCLUDE SYSLIB  (IEFAJCTB)                                       */
*/*%INCLUDE SYSLIB  (IKJTCB  )                                       */
*/*%INCLUDE SYSLIB  (IEFZB453)                                       */
*/*%INCLUDE SYSLIB  (IHAPSA  )                                       */
*/*%INCLUDE SYSLIB  (IHAASCB )                                       */
*/*%INCLUDE SYSUT5  (HESTAESP)                                       */
*/*%INCLUDE SYSUT5  (HSKESTAE)                                       */
*/*%INCLUDE SYSUT5  (ESTAECOD)                                       */
*/*%INCLUDE SYSLIB  (ESTAESPC)                                       */
*/*%INCLUDE SYSUT5  (HINITSPC)                                       */
*/*%INCLUDE SYSUT5  (HSKPINIT)                                       */
*/*%INCLUDE SYSUT5  (HCLUPSPC)                                       */
*/*%INCLUDE SYSUT5  (HSKPCLUP)                                       */
*/*%INCLUDE SYSUT5  (TERMCALL)                                       */
*/*%INCLUDE SYSLIB  (TERMSPEC)                                       */
*                                                               01S0288
*       ;                                                       01S0288
@DATA    DS    0H
@CH00125 DC    H'2'
@SM01862 MVC   ESTAECOR(0),ESTAELST
@DATD    DSECT
         DS    0F
@SA00001 DS    18F
@PC00001 DS    11F
@AL00001 DS    6A
@TF00001 DS    F
IEFAB451 CSECT
         DS    0F
@CF00122 DC    F'0'
@CF00113 DC    F'4'
@CF00074 DC    F'8'
@CH00074 EQU   @CF00074+2
@CF00492 DC    F'11'
@CF00055 DC    F'16'
@CH00055 EQU   @CF00055+2
@CF00043 DC    F'230'
@CF01849 DC    F'436'
@CF01865 DC    XL4'0000FFFF'
@DATD    DSECT
         DS    0D
JSCBWRKP DS    A
SIOTPTR  DS    A
RTNCODE  DS    F
ADDRESS  DS    F
GETLNTH  DS    F
HWCNTRLP DS    A
HWDATAP  DS    A
HWRTNP   DS    A
GTSTRTCD DS    F
UCCNTRLS DS    FL2
         ORG   UCCNTRLS
UCCAJSCB DS    BL1
UCNTIONQ EQU   UCCNTRLS+0
UCONECAT EQU   UCCNTRLS+0
UCALLCAT EQU   UCCNTRLS+0
UCONEACB EQU   UCCNTRLS+0
UCALLACB EQU   UCCNTRLS+0
UCONPCCB EQU   UCCNTRLS+0
UCALPCCB EQU   UCCNTRLS+0
UCTEMP   DS    BL1
UCSWTIOT EQU   UCCNTRLS+1
@NM00021 EQU   UCCNTRLS+1
         ORG   UCCNTRLS+2
AB4EDCOR DS    CL500
ASWACORE DS    CL40
SWITCHES DS    BL1
         ORG   SWITCHES
ISSUESTA DS    BL1
@NM00003 EQU   SWITCHES+0
         ORG   SWITCHES+1
         DS    CL1
RETINFO  DS    CL4
         ORG   RETINFO
RETCODE  DS    FL2
REASCODE DS    FL2
         ORG   RETINFO+4
SPLEN    DS    CL4
         ORG   SPLEN
SBPOOL   DS    FL1
LENTH    DS    FL3
         ORG   SPLEN+4
TERMAREA DS    CL16
IEFAB451 CSECT
         DS    0F
@SIZDATD DC    AL1(230)
         DC    AL3(@ENDDATD-@DATD)
@CV00137 DC    V(IEFAB452)
@CV00138 DC    V(IEFAB4EA)
@CV00139 DC    V(IEFAB4ED)
@CV00140 DC    V(IEFAB4F4)
         DS    0D
GTSTZERO DC    F'0'
@CC00116 DC    C'IEFAB4EA'
@CC00114 DC    C'ASWA'
IEFAB451 CSECT
ESTAELST ESTAE RECORD=YES,TERM=YES,MF=L
ESTAELEN DC A(*-ESTAELST)
@DATD    DSECT
ESTAECOR ESTAE RECORD=YES,TERM=YES,MF=L
IEFAB451 CSECT
         DS   0H
PATCHLOC DC ((@DATA-@PSTART)/20)X'00'
@DATD    DSECT
         ORG   *+1-(*-@DATD)/(*-@DATD) INSURE DSECT DATA
@ENDDATD EQU   *
IEFAB451 CSECT
@00      EQU   00                      EQUATES FOR REGISTERS 0-15
@01      EQU   01
@02      EQU   02
@03      EQU   03
@04      EQU   04
@05      EQU   05
@06      EQU   06
@07      EQU   07
@08      EQU   08
@09      EQU   09
@10      EQU   10
@11      EQU   11
@12      EQU   12
@13      EQU   13
@14      EQU   14
@15      EQU   15
ASWAPTR  EQU   @09
ASCBPTR  EQU   @02
EPRMLSTP EQU   @10
REG0     EQU   @00
REG1     EQU   @01
REG2     EQU   @02
REG3     EQU   @03
REG15    EQU   @15
GTSTR0   EQU   @00
GTSTR1   EQU   @01
GTSTR2   EQU   @02
GTSTR15  EQU   @15
GTSTR4   EQU   @04
GTSTR5   EQU   @05
GTSTR6   EQU   @06
GTSTR7   EQU   @07
GTSTR8   EQU   @08
GTSTR3   EQU   @03
LOC16PTR EQU   16
PSA      EQU   0
FLCRNPSW EQU   PSA
FLCROPSW EQU   PSA+8
FLCICCW2 EQU   PSA+16
PSAEEPSW EQU   PSA+132
PSAESPSW EQU   PSA+136
FLCSVILC EQU   PSAESPSW+1
PSAEPPSW EQU   PSA+140
FLCPIILC EQU   PSAEPPSW+1
FLCPICOD EQU   PSAEPPSW+2
PSAPICOD EQU   FLCPICOD+1
FLCTEA   EQU   PSAEPPSW+4
FLCPER   EQU   PSA+152
FLCMCLA  EQU   PSA+168
FLCIOEL  EQU   FLCMCLA+4
FLCIOA   EQU   FLCMCLA+16
FLCFSA   EQU   FLCMCLA+80
PSAAOLD  EQU   PSA+548
PSASUPER EQU   PSA+552
PSASUP1  EQU   PSASUPER
PSASUP2  EQU   PSASUPER+1
PSASUP3  EQU   PSASUPER+2
PSASUP4  EQU   PSASUPER+3
PSACLHT  EQU   PSA+640
PSALKSA  EQU   PSA+696
PSAHLHI  EQU   PSA+760
PSADSSFL EQU   PSA+836
PSADSSF1 EQU   PSADSSFL
PSADSSF3 EQU   PSADSSFL+2
PSADSSF4 EQU   PSADSSFL+3
PSARSVT  EQU   PSA+896
TCBLISTP EQU   0
TWOTCBPS EQU   0
TCBPTR   EQU   TWOTCBPS+4
AB4EDPMS EQU   0
ASWA     EQU   0
ASWAID   EQU   ASWA
ASWACSCT EQU   ASWA+4
ASWARTNP EQU   ASWA+12
ASWAPRMS EQU   ASWA+16
ASWASCBP EQU   ASWA+20
ASWAOLDP EQU   ASWA+24
ASWAFLGS EQU   ASWA+28
ASWADSWS EQU   ASWAFLGS
ASWAAUTO EQU   ASWA+32
ASWACHNP EQU   ASWA+36
HWCNTRL  EQU   0
HWUNLCCT EQU   HWCNTRL
HWDENQT  EQU   HWCNTRL+1
HWCAJSCB EQU   HWCNTRL+1
HWEPAJCT EQU   HWCNTRL+1
HWNEWVL  EQU   HWCNTRL+3
HWMSSCTL EQU   HWCNTRL+3
HWSELDON EQU   HWMSSCTL
HWTBLCTL EQU   HWCNTRL+6
HWJLCTLS EQU   HWCNTRL+7
HWDATA   EQU   0
HWJCTP   EQU   HWDATA
HWSCTP   EQU   HWDATA+4
HWFSIOTP EQU   HWDATA+8
HWLEPAP  EQU   HWDATA+12
HWGEPACP EQU   HWDATA+16
HWJSCBP  EQU   HWDATA+20
HWIOSLTP EQU   HWDATA+32
HWCRIP   EQU   HWDATA+36
HWCSIOTP EQU   HWDATA+44
HWGETADD EQU   HWDATA+52
HWUCLPTR EQU   HWDATA+56
HWLEPARP EQU   HWDATA+60
HWVLSELP EQU   HWDATA+80
HWGETSPN EQU   HWDATA+164
HWGETLN  EQU   HWDATA+168
HWSTPNBR EQU   HWDATA+172
HWSTEPNO EQU   HWSTPNBR+1
HWCRI    EQU   HWDATA+220
HWUCLST  EQU   0
HWDEV    EQU   0
HWOBYTE  EQU   HWDEV+1
HWCTBYT  EQU   HWDEV+2
HWRETURN EQU   0
HWRTCD   EQU   HWRETURN
HWRSNCD  EQU   HWRETURN+2
HWVLSELB EQU   0
HWSELHDR EQU   HWVLSELB
EPARMLST EQU   0
EECNTRLS EQU   EPARMLST+400
EEUALCAT EQU   EECNTRLS
EECLACAT EQU   EECNTRLS
EEFAPCCB EQU   EECNTRLS
EERAJSCP EQU   EECNTRLS
EEDYNAM  EQU   EECNTRLS
EEDNENQT EQU   EECNTRLS
ECJSCBP  EQU   EPARMLST+404
EAJSCBP  EQU   EPARMLST+408
ERETURNS EQU   EPARMLST+424
IEZJSCB  EQU   0
JSCBSEC1 EQU   IEZJSCB+188
JSCHPCE  EQU   JSCBSEC1+4
JSCBPCC  EQU   JSCBSEC1+16
JSCBDCB  EQU   JSCBSEC1+36
JSCBOPTS EQU   JSCBSEC1+48
JSCBSWT1 EQU   JSCBSEC1+55
JSCBWTP  EQU   JSCBSEC1+64
JSCBWTFG EQU   JSCBWTP
JSCBEND1 EQU   IEZJSCB+260
CTGPL    EQU   0
CTGOPTN1 EQU   CTGPL
CTGOPTN2 EQU   CTGPL+1
CTGEXT   EQU   CTGOPTN2
CTGERASE EQU   CTGOPTN2
CTGSMF   EQU   CTGERASE
CTGREL   EQU   CTGSMF
CTGPURG  EQU   CTGOPTN2
CTGVMNT  EQU   CTGPURG
CTGRCATN EQU   CTGVMNT
CTGOPTN3 EQU   CTGPL+2
CTGOPTN4 EQU   CTGPL+3
CTGENT   EQU   CTGPL+4
CTGCAT   EQU   CTGPL+8
CTGWKA   EQU   CTGPL+12
CTGDSORG EQU   CTGPL+16
CTGDDNM  EQU   CTGPL+20
CTGNEWNM EQU   CTGDDNM
CTGFBFLG EQU   CTGNEWNM+2
CTGJSCB  EQU   CTGPL+24
CTGWA    EQU   0
CTGWAVL  EQU   CTGWA
CTGWALV  EQU   CTGWA+4
SWAEPA   EQU   0
SWVAFW   EQU   SWAEPA+4
INSMSCT  EQU   0
SCTSSTAT EQU   INSMSCT+4
SCTSTYPE EQU   INSMSCT+67
SCTSDPTY EQU   INSMSCT+94
SCTSTAT2 EQU   INSMSCT+104
SCTBCT   EQU   SCTSTAT2
SCTCDENT EQU   INSMSCT+118
SCTSTEND EQU   INSMSCT+172
@NM00053 EQU   0
SCTABCND EQU   @NM00053
INDMSIOT EQU   0
SCTUSADD EQU   INDMSIOT+20
SIOTBYT1 EQU   INDMSIOT+43
SIOTBYT3 EQU   INDMSIOT+46
SIOTTSTC EQU   INDMSIOT+47
SIOTBYT0 EQU   INDMSIOT+52
SCTSDISP EQU   INDMSIOT+55
SCTSBYT1 EQU   INDMSIOT+56
SCTSBYT2 EQU   INDMSIOT+57
SCTSBYT3 EQU   INDMSIOT+58
SCTSBYT4 EQU   INDMSIOT+59
SCTUTYPE EQU   INDMSIOT+60
SIOTDEVT EQU   SCTUTYPE
SIOUBYT3 EQU   SIOTDEVT+2
SIOTBYT4 EQU   INDMSIOT+81
SIOTALTD EQU   INDMSIOT+92
SIOTBYT2 EQU   INDMSIOT+103
SIOTRSNC EQU   INDMSIOT+130
INJMJCT  EQU   0
JCTJSTAT EQU   INJMJCT+5
INDMCTLG EQU   JCTJSTAT
JCTJBYTE EQU   INJMJCT+7
JCTJMGLV EQU   JCTJBYTE
JCTCCODE EQU   INJMJCT+54
JCTRSW1  EQU   INJMJCT+86
JCTRSW2  EQU   INJMJCT+87
JCTJSB   EQU   INJMJCT+111
JCTSTAT2 EQU   INJMJCT+116
IEFAACTB EQU   0
TCBFIX   EQU   0
TCBFRS   EQU   TCBFIX
TCB      EQU   0
TCBPIE   EQU   TCB+4
TCBPMASK EQU   TCBPIE
TCBCMP   EQU   TCB+16
TCBCMPF  EQU   TCBCMP
TCBCPP   EQU   TCBCMPF
TCBSTCC  EQU   TCBCMPF
TCBCDBL  EQU   TCBCMPF
TCBCWTO  EQU   TCBCMPF
TCBCIND  EQU   TCBCMPF
TCBCMSG  EQU   TCBCMPF
TCBTRN   EQU   TCB+20
TCBABF   EQU   TCBTRN
TCBMSS   EQU   TCB+24
TCBPKF   EQU   TCB+28
TCBFLGS  EQU   TCB+29
TCBFLGS1 EQU   TCBFLGS
TCBFLGS2 EQU   TCBFLGS+1
TCBFLGS3 EQU   TCBFLGS+2
TCBFLGS4 EQU   TCBFLGS+3
TCBFLGS5 EQU   TCBFLGS+4
TCBABWF  EQU   TCBFLGS5
TCBJPQ   EQU   TCB+44
TCBPURGE EQU   TCBJPQ
TCBGRS   EQU   TCB+48
TCBFSA   EQU   TCB+112
TCBTME   EQU   TCB+120
TCBJSTCB EQU   TCB+124
TCBTSFLG EQU   TCB+148
TCBTSTSK EQU   TCBTSFLG
TCBSTAB  EQU   TCB+160
TCBNSTAE EQU   TCBSTAB
TCBSTABB EQU   TCBSTAB+1
TCBTCT   EQU   TCB+164
TCBTCTGF EQU   TCBTCT
TCBSCNDY EQU   TCB+172
TCBNDSP  EQU   TCBSCNDY
TCBNDSP1 EQU   TCBNDSP+1
TCBNDSP2 EQU   TCBNDSP+2
TCBNDSP3 EQU   TCBNDSP+3
TCBJSCB  EQU   TCB+180
TCBRECDE EQU   TCBJSCB
TCBEXT1  EQU   TCB+196
TCBBITS  EQU   TCB+200
TCBNDSP4 EQU   TCBBITS
TCBNDSP5 EQU   TCBBITS+1
TCBFLGS6 EQU   TCBBITS+2
TCBFLGS7 EQU   TCBBITS+3
TCBDAR   EQU   TCB+204
TCBDARC  EQU   TCBDAR
TCBEXT2  EQU   TCB+208
TCBXSCT  EQU   TCB+240
TCBXSCT1 EQU   TCBXSCT
TCBFOE   EQU   TCB+244
TCBESTAE EQU   TCB+264
TCBESTRM EQU   TCBESTAE+1
TCBFBYT1 EQU   TCB+276
TCBFBYT2 EQU   TCB+277
TCBRV124 EQU   TCB+278
TCBRV133 EQU   TCB+279
TCBXTNT2 EQU   0
TCBGTF   EQU   TCBXTNT2
TCBTFLG  EQU   TCBGTF
TCBRV146 EQU   TCBXTNT2+28
TCBRV155 EQU   TCBXTNT2+29
TCBRV164 EQU   TCBXTNT2+30
TCBRV173 EQU   TCBXTNT2+31
ASCB     EQU   0
ASCBSUPC EQU   ASCB+16
ASCBASID EQU   ASCB+36
ASCBFW1  EQU   ASCB+100
ASCBRCTF EQU   ASCBFW1+2
ASCBFLG1 EQU   ASCBFW1+3
ASCBDSP1 EQU   ASCB+114
ASCBFLG2 EQU   ASCB+115
ASCBLKGP EQU   ASCB+128
ASCBSRQ  EQU   ASCB+180
ASCBSRQ1 EQU   ASCBSRQ
ASCBSRQ2 EQU   ASCBSRQ+1
ASCBSRQ3 EQU   ASCBSRQ+2
ASCBSRQ4 EQU   ASCBSRQ+3
TRMRB    EQU   0
TRMRBLEN EQU   TRMRB
TRMRBOPC EQU   TRMRB+4
TRMFLAGS EQU   TRMRB+5
TRMJOBID EQU   TRMRB+8
INDMDSNT EQU   0
IFUNCTN  EQU   0
IUNCATSW EQU   IFUNCTN
IDENQTIO EQU   IFUNCTN+1
ICAJSCB  EQU   IFUNCTN+1
IAEPAJCT EQU   IFUNCTN+1
FSIOTPTR EQU   0
STEPNUMB EQU   0
JCTPTR   EQU   0
SCTPTR   EQU   0
LEPAPTR  EQU   0
GEPACPTR EQU   0
JSCBPTR  EQU   0
IOSLUTP  EQU   0
REASONCD EQU   0
JHRETMAP EQU   0
JHMSSTRM EQU   JHRETMAP
JSCBSEC2 EQU   JSCBEND1
JSCBSEC3 EQU   JSCBEND1
JSCBJCT  EQU   JSCBSEC3
JSCBJCTA EQU   JSCBJCT+1
JSCBASID EQU   JSCBSEC3+8
JSCBFBYT EQU   JSCBSEC3+10
JSCBJNL  EQU   JSCBSEC3+28
JSCBJJSB EQU   JSCBJNL
JSCBSUB  EQU   JSCBSEC3+40
JSCSCT   EQU   JSCBSEC3+68
JSCBACT  EQU   JSCBSEC3+88
JSCBASWA EQU   JSCBSEC3+96
JSCRSV45 EQU   JSCBSEC3+112
JSCRSV46 EQU   JSCRSV45
JSCRSV47 EQU   JSCRSV45+2
@NM00031 EQU   CTGDDNM
CTGPROB  EQU   @NM00031
CTGREASN EQU   CTGPROB+2
PSARSVTE EQU   PSARSVT
FLC      EQU   PSA
         AGO   .@UNREFD                START UNREFERENCED COMPONENTS
PSARSAV  EQU   PSARSVTE+60
PSARSTK  EQU   PSARSVTE+56
PSAESAV3 EQU   PSARSVTE+52
PSAESTK3 EQU   PSARSVTE+48
PSAESAV2 EQU   PSARSVTE+44
PSAESTK2 EQU   PSARSVTE+40
PSAESAV1 EQU   PSARSVTE+36
PSAESTK1 EQU   PSARSVTE+32
PSAPSAV  EQU   PSARSVTE+28
PSAPSTK  EQU   PSARSVTE+24
PSAMSAV  EQU   PSARSVTE+20
PSAMSTK  EQU   PSARSVTE+16
PSASSAV  EQU   PSARSVTE+12
PSASSTK  EQU   PSARSVTE+8
PSANSTK  EQU   PSARSVTE+4
PSACSTK  EQU   PSARSVTE
CTGREAS2 EQU   CTGREASN+1
CTGREAS1 EQU   CTGREASN
CTGMODID EQU   CTGPROB
JSCBEND3 EQU   JSCBSEC3+120
JSCRSV52 EQU   JSCBSEC3+116
JSCRSV51 EQU   JSCRSV47+1
JSCRSV50 EQU   JSCRSV47
JSCRSV49 EQU   JSCRSV46+1
JSCRSV48 EQU   JSCRSV46
JSCRSV44 EQU   JSCBSEC3+108
JSCRSV43 EQU   JSCBSEC3+104
JSCRSV42 EQU   JSCBSEC3+100
JSCBUFPT EQU   JSCBSEC3+92
JSCBSWSP EQU   JSCBSEC3+87
JSCRSV33 EQU   JSCBSEC3+86
JSCDDNUM EQU   JSCBSEC3+84
JSCRSV53 EQU   JSCBSEC3+82
JSCDDNNO EQU   JSCBSEC3+80
JSCBVATA EQU   JSCBSEC3+76
JSCTMCOR EQU   JSCBSEC3+72
JSCSCTP  EQU   JSCSCT+1
JSCRSV55 EQU   JSCSCT
JSCRSV54 EQU   JSCBSEC3+64
JSCDSABQ EQU   JSCBSEC3+60
JSCBSSIB EQU   JSCBSEC3+56
JSCBFRBA EQU   JSCBSEC3+48
JSCRSV28 EQU   JSCBSEC3+46
JSCBSONO EQU   JSCBSEC3+44
JSCBSUBA EQU   JSCBSUB+1
JSCRSV31 EQU   JSCBSUB
JSCBSMLR EQU   JSCBSEC3+36
JSCBJNLR EQU   JSCBSEC3+32
JSCBJNLA EQU   JSCBJNL+1
JSCBJSBT EQU   JSCBJJSB
JSCBJSBX EQU   JSCBJJSB
JSCBJSBA EQU   JSCBJJSB
JSCBJSBI EQU   JSCBJJSB
@NM00025 EQU   JSCBJJSB
JSCBJNLE EQU   JSCBJJSB
JSCBJNLF EQU   JSCBJJSB
JSCBJNLN EQU   JSCBJJSB
@NM00024 EQU   JSCBSEC3+24
JSCBJRBA EQU   JSCBSEC3+16
JSCBIECB EQU   JSCBSEC3+12
JSCBRV08 EQU   JSCBSEC3+11
JSCBRV07 EQU   JSCBFBYT
JSCBRV06 EQU   JSCBFBYT
JSCBRV05 EQU   JSCBFBYT
JSCBRV04 EQU   JSCBFBYT
JSCBRV03 EQU   JSCBFBYT
JSCBRV02 EQU   JSCBFBYT
JSCBADSP EQU   JSCBFBYT
JSCBRV01 EQU   JSCBFBYT
JSCBTJID EQU   JSCBASID
JSCBPSCB EQU   JSCBSEC3+4
JSCJCTP  EQU   JSCBJCTA
JSCRSV24 EQU   JSCBJCT
JSCBEND2 EQU   JSCBSEC2
@NM00002 EQU   JHRETMAP
@NM00001 EQU   IFUNCTN+1
IDNOVRID EQU   IFUNCTN+1
IDSAUTH  EQU   IFUNCTN+1
INODSI   EQU   IFUNCTN+1
ICOFFDEV EQU   IFUNCTN+1
INOSCAT  EQU   IFUNCTN
IWAITVSW EQU   IFUNCTN
IDCCDDSW EQU   IFUNCTN
IWAITUSW EQU   IFUNCTN
ICATMTSW EQU   IFUNCTN
INOSCTUP EQU   IFUNCTN
IPRPDISW EQU   IFUNCTN
TRMSTHDR EQU   TRMRB+12
@NM00115 EQU   TRMRB+6
@NM00114 EQU   TRMFLAGS
TRMSCHAB EQU   TRMFLAGS
TRMALLOK EQU   TRMFLAGS
ASCBEND  EQU   ASCB+208
ASCBSRBT EQU   ASCB+200
ASCBSWTL EQU   ASCB+196
ASCBRS14 EQU   ASCB+195
ASCBSMCT EQU   ASCB+194
ASCBRS12 EQU   ASCB+192
ASCBPCTT EQU   ASCB+188
ASCBVGTT EQU   ASCB+184
ASCBRV43 EQU   ASCBSRQ4
ASCBRV42 EQU   ASCBSRQ4
ASCBRV41 EQU   ASCBSRQ4
ASCBRV40 EQU   ASCBSRQ4
ASCBRV39 EQU   ASCBSRQ4
ASCBRV38 EQU   ASCBSRQ4
ASCBRV37 EQU   ASCBSRQ4
ASCBRV36 EQU   ASCBSRQ4
ASCBRV35 EQU   ASCBSRQ3
ASCBRV34 EQU   ASCBSRQ3
ASCBRV33 EQU   ASCBSRQ3
ASCBRV32 EQU   ASCBSRQ3
ASCBRV31 EQU   ASCBSRQ3
ASCBRV30 EQU   ASCBSRQ3
ASCBRV29 EQU   ASCBSRQ3
ASCBRV28 EQU   ASCBSRQ3
ASCBRV27 EQU   ASCBSRQ2
ASCBRV26 EQU   ASCBSRQ2
ASCBRV25 EQU   ASCBSRQ2
ASCBRV24 EQU   ASCBSRQ2
ASCBRV23 EQU   ASCBSRQ2
ASCBRV22 EQU   ASCBSRQ2
ASCBRV21 EQU   ASCBSRQ2
ASCBRV20 EQU   ASCBSRQ2
ASCBRV19 EQU   ASCBSRQ1
ASCBRV18 EQU   ASCBSRQ1
ASCBRV17 EQU   ASCBSRQ1
ASCBRV16 EQU   ASCBSRQ1
ASCBRV15 EQU   ASCBSRQ1
ASCBRV14 EQU   ASCBSRQ1
ASCBRV13 EQU   ASCBSRQ1
ASCBSTA  EQU   ASCBSRQ1
ASCBJBNS EQU   ASCB+176
ASCBJBNI EQU   ASCB+172
ASCBMCC  EQU   ASCB+168
ASCBRTWA EQU   ASCB+164
ASCBIQEA EQU   ASCB+160
ASCBXMPQ EQU   ASCB+156
ASCBRS01 EQU   ASCB+154
ASCBFMCT EQU   ASCB+152
ASCBOUXB EQU   ASCB+148
ASCBOUCB EQU   ASCB+144
ASCBMECB EQU   ASCB+140
ASCBQECB EQU   ASCB+136
ASCBLSQH EQU   ASCBLKGP+4
ASCBLOCK EQU   ASCBLKGP
ASCBTCBS EQU   ASCB+124
ASCBNVSC EQU   ASCB+122
ASCBVSC  EQU   ASCB+120
ASCBSRBS EQU   ASCB+118
ASCBSSRB EQU   ASCB+116
ASCBRV06 EQU   ASCBFLG2
ASCBRV05 EQU   ASCBFLG2
ASCBRV04 EQU   ASCBFLG2
ASCBSNQS EQU   ASCBFLG2
ASCBS2S  EQU   ASCBFLG2
ASCBCEXT EQU   ASCBFLG2
ASCBPXMT EQU   ASCBFLG2
ASCBXMPT EQU   ASCBFLG2
ASCBRF07 EQU   ASCBDSP1
ASCBRF06 EQU   ASCBDSP1
ASCBRF05 EQU   ASCBDSP1
ASCBRF04 EQU   ASCBDSP1
ASCBRF03 EQU   ASCBDSP1
ASCBRF02 EQU   ASCBDSP1
ASCBFAIL EQU   ASCBDSP1
ASCBNOQ  EQU   ASCBDSP1
ASCBSWCT EQU   ASCB+112
ASCBASXB EQU   ASCB+108
ASCBTMCH EQU   ASCB+104
ASCBNSWP EQU   ASCBFLG1
ASCBTYP1 EQU   ASCBFLG1
ASCBSTND EQU   ASCBFLG1
ASCBABNT EQU   ASCBFLG1
ASCBTERM EQU   ASCBFLG1
ASCBS3S  EQU   ASCBFLG1
ASCBCMSH EQU   ASCBFLG1
ASCBTOFF EQU   ASCBFLG1
ASCBRF01 EQU   ASCBRCTF
ASCBTMLW EQU   ASCBRCTF
ASCBOUT  EQU   ASCBRCTF
ASCBWAIT EQU   ASCBRCTF
ASCBRV08 EQU   ASCBRCTF
ASCBFQU  EQU   ASCBRCTF
ASCBFRS  EQU   ASCBRCTF
ASCBTMNO EQU   ASCBRCTF
ASCBAFFN EQU   ASCBFW1
ASCBDUMP EQU   ASCB+96
ASCBRV44 EQU   ASCB+92
ASCBUBET EQU   ASCB+88
ASCBECB  EQU   ASCB+84
ASCBJSTL EQU   ASCB+80
ASCBEWST EQU   ASCB+72
ASCBEJST EQU   ASCB+64
ASCBTSB  EQU   ASCB+60
ASCBCSCB EQU   ASCB+56
ASCBRSM  EQU   ASCB+52
ASCBLDA  EQU   ASCB+48
ASCBSTOR EQU   ASCB+44
ASCBDP   EQU   ASCB+43
ASCBRV07 EQU   ASCB+42
ASCBIOSM EQU   ASCB+40
ASCBSEQN EQU   ASCB+38
ASCBCPUS EQU   ASCB+32
ASCBSPL  EQU   ASCB+28
ASCBIOSP EQU   ASCB+24
ASCBSYNC EQU   ASCBSUPC+4
ASCBSVRB EQU   ASCBSUPC
ASCBCMSF EQU   ASCB+12
ASCBBWDP EQU   ASCB+8
ASCBFWDP EQU   ASCB+4
ASCBASCB EQU   ASCB
ASCBEGIN EQU   ASCB
@NM00089 EQU   TCBXTNT2+32
TCBRV181 EQU   TCBRV173
TCBRV180 EQU   TCBRV173
TCBRV179 EQU   TCBRV173
TCBRV178 EQU   TCBRV173
TCBRV177 EQU   TCBRV173
TCBRV176 EQU   TCBRV173
TCBRV175 EQU   TCBRV173
TCBRV174 EQU   TCBRV173
TCBRV172 EQU   TCBRV164
TCBRV171 EQU   TCBRV164
TCBRV170 EQU   TCBRV164
TCBRV169 EQU   TCBRV164
TCBRV168 EQU   TCBRV164
TCBRV167 EQU   TCBRV164
TCBRV166 EQU   TCBRV164
TCBRV165 EQU   TCBRV164
TCBRV163 EQU   TCBRV155
TCBRV162 EQU   TCBRV155
TCBRV161 EQU   TCBRV155
TCBRV160 EQU   TCBRV155
TCBRV159 EQU   TCBRV155
TCBRV158 EQU   TCBRV155
TCBRV157 EQU   TCBRV155
TCBRV156 EQU   TCBRV155
TCBRV154 EQU   TCBRV146
TCBRV153 EQU   TCBRV146
TCBRV152 EQU   TCBRV146
TCBRV151 EQU   TCBRV146
TCBRV150 EQU   TCBRV146
TCBRV149 EQU   TCBRV146
TCBRV148 EQU   TCBRV146
TCBRV147 EQU   TCBRV146
TCBRV145 EQU   TCBXTNT2+26
TCBRV144 EQU   TCBXTNT2+24
TCBRV143 EQU   TCBXTNT2+20
TCBRV142 EQU   TCBXTNT2+16
TCBRSV49 EQU   TCBXTNT2+12
TCBEVENT EQU   TCBXTNT2+8
TCBRCMP  EQU   TCBXTNT2+5
TCBRSVAB EQU   TCBXTNT2+4
TCBGTFA  EQU   TCBGTF+1
TCBRSV47 EQU   TCBTFLG
TCBRSV46 EQU   TCBTFLG
TCBRSV45 EQU   TCBTFLG
TCBRSV44 EQU   TCBTFLG
TCBRSV43 EQU   TCBTFLG
TCBDSPIT EQU   TCBTFLG
TCBERRTN EQU   TCBTFLG
TCBASYNC EQU   TCBTFLG
@NM00088 EQU   TCB+296
TCBSVCA2 EQU   TCB+292
TCBSWASA EQU   TCB+288
TCBDBTB  EQU   TCB+284
TCBRPT   EQU   TCB+280
TCBRV141 EQU   TCBRV133
TCBRV140 EQU   TCBRV133
TCBRV139 EQU   TCBRV133
TCBRV138 EQU   TCBRV133
TCBRV137 EQU   TCBRV133
TCBRV136 EQU   TCBRV133
TCBRV135 EQU   TCBRV133
TCBRV134 EQU   TCBRV133
TCBRV132 EQU   TCBRV124
TCBRV131 EQU   TCBRV124
TCBRV130 EQU   TCBRV124
TCBRV129 EQU   TCBRV124
TCBRV128 EQU   TCBRV124
TCBRV127 EQU   TCBRV124
TCBRV126 EQU   TCBRV124
TCBRV125 EQU   TCBRV124
TCBRV123 EQU   TCBFBYT2
TCBRV122 EQU   TCBFBYT2
TCBECBNV EQU   TCBFBYT2
TCBSSSYN EQU   TCBFBYT2
TCBFPRAP EQU   TCBFBYT2
TCBFDW   EQU   TCBFBYT2
TCBFMW   EQU   TCBFBYT2
TCBCNCB  EQU   TCBFBYT2
TCBLLH   EQU   TCBFBYT1
TCBRV113 EQU   TCBFBYT1
TCBEOT   EQU   TCBFBYT1
TCBRTM2  EQU   TCBFBYT1
TCBPGNLY EQU   TCBFBYT1
TCBNDIOS EQU   TCBFBYT1
TCBRV327 EQU   TCBFBYT1
TCBEOTFM EQU   TCBFBYT1
TCBAFFN  EQU   TCB+274
TCBRV326 EQU   TCB+272
TCBUKYSP EQU   TCB+268
TCBMODE  EQU   TCBESTAE+3
TCBERTYP EQU   TCBESTAE+2
TCBRV314 EQU   TCBESTRM
TCBRV313 EQU   TCBESTRM
TCBRV312 EQU   TCBESTRM
TCBRV311 EQU   TCBESTRM
TCBRV310 EQU   TCBESTRM
TCBRV309 EQU   TCBESTRM
TCBRV308 EQU   TCBESTRM
TCBETERM EQU   TCBESTRM
TCBSCBKY EQU   TCBESTAE
TCBRTM12 EQU   TCB+260
TCBTCBID EQU   TCB+256
TCBSTAWA EQU   TCB+252
TCBSWA   EQU   TCB+248
TCBFOEA  EQU   TCBFOE+1
TCBRSV42 EQU   TCBFOE
TCBCCPVI EQU   TCBXSCT+2
TCBRV325 EQU   TCBXSCT+1
TCBRV324 EQU   TCBXSCT1
TCBRV323 EQU   TCBXSCT1
TCBRV322 EQU   TCBXSCT1
TCBRV321 EQU   TCBXSCT1
TCBRV320 EQU   TCBXSCT1
TCBRV319 EQU   TCBXSCT1
TCBS3A   EQU   TCBXSCT1
TCBACTIV EQU   TCBXSCT1
TCBRSV41 EQU   TCB+239
TCBTID   EQU   TCB+238
TCBRSVAA EQU   TCB+237
TCBABCUR EQU   TCB+236
TCBTMSAV EQU   TCB+232
TCBIOTIM EQU   TCB+228
TCBRTWA  EQU   TCB+224
TCBBACK  EQU   TCB+220
TCBTIRB  EQU   TCB+216
TCBAECB  EQU   TCB+212
TCBEXT2A EQU   TCBEXT2+1
TCBRSV39 EQU   TCBEXT2
TCBSTMCT EQU   TCB+207
TCBSYSCT EQU   TCB+206
TCBRSV37 EQU   TCB+205
TCBEXSVC EQU   TCBDAR
TCBDARMS EQU   TCBDAR
TCBDARWT EQU   TCBDAR
TCBDARO  EQU   TCBDAR
TCBDARMC EQU   TCBDARC
TCBDARD  EQU   TCBDAR
TCBDARS  EQU   TCBDAR
TCBDARP  EQU   TCBDAR
TCBGTOFM EQU   TCBFLGS7
TCBADMP  EQU   TCBFLGS7
TCBRSTSK EQU   TCBFLGS7
TCBSVCS  EQU   TCBFLGS7
TCBSTACK EQU   TCBFLGS7
TCBRSV34 EQU   TCBFLGS7
TCBRSV33 EQU   TCBFLGS7
TCBGPECB EQU   TCBFLGS7
TCBNTJS  EQU   TCBFLGS6
TCBAPG   EQU   TCBFLGS6
TCBMIGR  EQU   TCBFLGS6
TCBRV303 EQU   TCBFLGS6
TCBSPVLK EQU   TCBFLGS6
TCBCPU   EQU   TCBFLGS6
TCBPIE17 EQU   TCBFLGS6
TCBRV    EQU   TCBFLGS6
TCBRSV79 EQU   TCBNDSP5
TCBRSV78 EQU   TCBNDSP5
TCBRSV77 EQU   TCBNDSP5
TCBRSV76 EQU   TCBNDSP5
TCBRSV75 EQU   TCBNDSP5
TCBRSV74 EQU   TCBNDSP5
TCBRSV95 EQU   TCBNDSP5
TCBRSV94 EQU   TCBNDSP5
TCBRSV93 EQU   TCBNDSP4
TCBRSV92 EQU   TCBNDSP4
TCBRSV91 EQU   TCBNDSP4
TCBRSV90 EQU   TCBNDSP4
TCBRSV89 EQU   TCBNDSP4
TCBRSV88 EQU   TCBNDSP4
TCBRSV87 EQU   TCBNDSP4
TCBRSV86 EQU   TCBNDSP4
TCBEXT1A EQU   TCBEXT1+1
TCBRSV32 EQU   TCBEXT1
TCBEXCPD EQU   TCB+192
TCBIOBRC EQU   TCB+188
TCBDDWTC EQU   TCB+186
TCBDDEXC EQU   TCB+184
TCBJSCBB EQU   TCBJSCB+1
@NM00087 EQU   TCBRECDE
TCBREC   EQU   TCBRECDE
TCBMDIDS EQU   TCB+176
TCBNDINT EQU   TCBNDSP3
TCBRSV27 EQU   TCBNDSP3
TCBRSV26 EQU   TCBNDSP3
TCBRSV25 EQU   TCBNDSP3
TCBRSV24 EQU   TCBNDSP3
TCBSRBND EQU   TCBNDSP3
TCBRV302 EQU   TCBNDSP3
TCBLJSND EQU   TCBNDSP3
TCBABE   EQU   TCBNDSP2
TCBDSS   EQU   TCBNDSP2
TCBOWAIT EQU   TCBNDSP2
TCBIWAIT EQU   TCBNDSP2
TCBNDTS  EQU   TCBNDSP2
TCBNDSVC EQU   TCBNDSP2
TCBSTPP  EQU   TCBNDSP2
TCBABD   EQU   TCBNDSP2
TCBRSV22 EQU   TCBNDSP1
TCBPIEND EQU   TCBNDSP1
TCBTPSP  EQU   TCBNDSP1
TCBDDRND EQU   TCBNDSP1
TCBRSPND EQU   TCBNDSP1
TCBRSTND EQU   TCBNDSP1
TCBDARPN EQU   TCBNDSP1
TCBDARTN EQU   TCBNDSP1
TCBNDSP0 EQU   TCBNDSP
TCBUSER  EQU   TCB+168
TCBTCTB  EQU   TCBTCT+1
TCBRSV9C EQU   TCBTCTGF
TCBRSV9B EQU   TCBTCTGF
TCBRSV9A EQU   TCBTCTGF
TCBRSV99 EQU   TCBTCTGF
TCBRSV98 EQU   TCBTCTGF
TCBRSV97 EQU   TCBTCTGF
TCBRSV20 EQU   TCBTCTGF
TCBSMFGF EQU   TCBTCTGF
TCBSTCUR EQU   TCBNSTAE
TCBRV301 EQU   TCBNSTAE
TCBSYNCH EQU   TCBNSTAE
TCBHALT  EQU   TCBNSTAE
TCBPPSUP EQU   TCBNSTAE
TCB33E   EQU   TCBNSTAE
TCBQUIES EQU   TCBNSTAE
TCBSTABE EQU   TCBNSTAE
TCBAQE   EQU   TCB+156
TCBPQE   EQU   TCB+152
TCBTSDP  EQU   TCB+151
TCBTSLP  EQU   TCB+150
TCBSTPCT EQU   TCB+149
TCBCPUBN EQU   TCBTSFLG
TCBDYDSP EQU   TCBTSFLG
TCBRSV18 EQU   TCBTSFLG
TCBRSV17 EQU   TCBTSFLG
TCBTIOTG EQU   TCBTSFLG
TCBATT   EQU   TCBTSFLG
TCBSTPPR EQU   TCBTSFLG
TCBRV300 EQU   TCBTSTSK
TCBECB   EQU   TCB+144
TCBIQE   EQU   TCB+140
TCBLTC   EQU   TCB+136
TCBOTC   EQU   TCB+132
TCBNTC   EQU   TCB+128
TCBJSTCA EQU   TCBJSTCB+1
TCBRSV16 EQU   TCBJSTCB
TCBTQET  EQU   TCBTME
TCBTCB   EQU   TCB+116
TCBFSAB  EQU   TCBFSA+1
TCBQEL   EQU   TCBFSA
TCBGRS15 EQU   TCBGRS+60
TCBGRS14 EQU   TCBGRS+56
TCBGRS13 EQU   TCBGRS+52
TCBGRS12 EQU   TCBGRS+48
TCBGRS11 EQU   TCBGRS+44
TCBGRS10 EQU   TCBGRS+40
TCBGRS9  EQU   TCBGRS+36
TCBGRS8  EQU   TCBGRS+32
TCBGRS7  EQU   TCBGRS+28
TCBGRS6  EQU   TCBGRS+24
TCBGRS5  EQU   TCBGRS+20
TCBGRS4  EQU   TCBGRS+16
TCBGRS3  EQU   TCBGRS+12
TCBGRS2  EQU   TCBGRS+8
TCBGRS1  EQU   TCBGRS+4
TCBGRS0  EQU   TCBGRS
TCBJPQB  EQU   TCBJPQ+1
TCBRSV15 EQU   TCBPURGE
TCBRSV14 EQU   TCBPURGE
TCBRSV13 EQU   TCBPURGE
TCBRSV12 EQU   TCBPURGE
TCBRSV11 EQU   TCBPURGE
TCBRSV10 EQU   TCBPURGE
TCBRSV09 EQU   TCBPURGE
TCBJPQF  EQU   TCBPURGE
TCBJLB   EQU   TCB+40
TCBLLS   EQU   TCB+36
TCBDSP   EQU   TCB+35
TCBLMP   EQU   TCB+34
TCBPNDSP EQU   TCBFLGS5
TCBFCD1  EQU   TCBFLGS5
TCBSTP   EQU   TCBFLGS5
TCBSYS   EQU   TCBFLGS5
TCBANDSP EQU   TCBFLGS5
TCBPAGE  EQU   TCBFLGS5
TCBUXNDF EQU   TCBABWF
TCBFC    EQU   TCBFLGS5
TCBONDSP EQU   TCBFLGS4
TCBMPCND EQU   TCBFLGS4
TCBMPCVQ EQU   TCBFLGS4
TCBUXNDV EQU   TCBFLGS4
TCBHNDSP EQU   TCBFLGS4
TCBRQENA EQU   TCBFLGS4
TCBSER   EQU   TCBFLGS4
TCBNDUMP EQU   TCBFLGS4
TCBDWSTA EQU   TCBFLGS3
TCBRSV08 EQU   TCBFLGS3
TCBRSV07 EQU   TCBFLGS3
TCBRSV06 EQU   TCBFLGS3
TCBABGM  EQU   TCBFLGS3
TCBABTRM EQU   TCBFLGS3
TCBADINP EQU   TCBFLGS3
TCBFSM   EQU   TCBFLGS3
TCBFTS   EQU   TCBFLGS2
TCBFETXR EQU   TCBFLGS2
TCBFDSOP EQU   TCBFLGS2
TCBFJMC  EQU   TCBFLGS2
TCBFSMC  EQU   TCBFLGS2
TCBFABOP EQU   TCBFLGS2
TCBFSTI  EQU   TCBFLGS2
TCBFOINP EQU   TCBFLGS2
TCBFX    EQU   TCBFLGS1
TCBFS    EQU   TCBFLGS1
TCBFT    EQU   TCBFLGS1
TCBPDUMP EQU   TCBFLGS1
TCBNONPR EQU   TCBFLGS1
TCBFERA  EQU   TCBFLGS1
TCBFE    EQU   TCBFLGS1
TCBFA    EQU   TCBFLGS1
TCBZERO  EQU   TCBPKF
TCBFLAG  EQU   TCBPKF
TCBMSSB  EQU   TCBMSS+1
TCBRSV03 EQU   TCBMSS
TCBTRNB  EQU   TCBTRN+1
TCBRSV02 EQU   TCBABF
TCBOLTEP EQU   TCBABF
TCBTCP   EQU   TCBABF
TCBTCPP  EQU   TCBABF
TCBRSV01 EQU   TCBABF
TCBGRPH  EQU   TCBABF
TCBNOCHK EQU   TCBABF
TCBMOD91 EQU   TCBABF
TCBCMPC  EQU   TCBCMP+1
TCBRV318 EQU   TCBCMSG
TCBRV317 EQU   TCBCIND
TCBRV316 EQU   TCBCWTO
TCBCASID EQU   TCBCDBL
TCBNOCC  EQU   TCBSTCC
TCBDMPO  EQU   TCBCPP
TCBCSTEP EQU   TCBCMPF
TCBCREQ  EQU   TCBCMPF
TCBTIO   EQU   TCB+12
TCBDEB   EQU   TCB+8
TCBPIEA  EQU   TCBPIE+1
TCBPM    EQU   TCBPMASK
@NM00086 EQU   TCBPMASK
TCBRBP   EQU   TCB
TCBFRS6  EQU   TCBFRS+24
TCBFRS4  EQU   TCBFRS+16
TCBFRS2  EQU   TCBFRS+8
TCBFRS0  EQU   TCBFRS
ACTACCNT EQU   IEFAACTB+32
ACTJNFLD EQU   IEFAACTB+31
ACTJTIME EQU   IEFAACTB+28
ACTPRGNM EQU   IEFAACTB+8
@NM00085 EQU   IEFAACTB+7
ACTNEXT  EQU   IEFAACTB+4
ACTIDENT EQU   IEFAACTB+3
ACTDSKAD EQU   IEFAACTB
@NM00084 EQU   INJMJCT+175
JCTVULDP EQU   INJMJCT+172
JCTACODE EQU   INJMJCT+168
JCTPRFMF EQU   INJMJCT+167
JCTUSER  EQU   INJMJCT+160
JCTSSD   EQU   INJMJCT+157
@NM00083 EQU   INJMJCT+156
JCTSRBT  EQU   INJMJCT+152
JCTJMRJD EQU   INJMJCT+149
JCTJMRJT EQU   INJMJCT+146
JCTJMRSS EQU   INJMJCT+143
JCTJMRTL EQU   INJMJCT+140
JCTJMRCL EQU   INJMJCT+139
JCTJMROP EQU   INJMJCT+138
JCTJMRD  EQU   INJMJCT+137
JCTJMR   EQU   INJMJCT+134
JCTCKIDT EQU   INJMJCT+118
JCTCKIDL EQU   INJMJCT+117
@NM00082 EQU   JCTSTAT2
JCTBLP   EQU   JCTSTAT2
JCTPERFM EQU   JCTSTAT2
JCTSWSM  EQU   JCTSTAT2
JCTENDIT EQU   JCTSTAT2
JCTADSPC EQU   JCTSTAT2
JCTSPSYS EQU   JCTSTAT2
@NM00081 EQU   INJMJCT+115
JCTSSTR  EQU   INJMJCT+112
JCTJSBTM EQU   JCTJSB
JCTJSBEX EQU   JCTJSB
JCTJSBAL EQU   JCTJSB
JCTJSBIN EQU   JCTJSB
@NM00080 EQU   JCTJSB
JCTVOLSQ EQU   INJMJCT+110
JCTNRCKP EQU   INJMJCT+108
JCTNTRK  EQU   INJMJCT+107
JCTCKTTR EQU   INJMJCT+104
JCTDEVT  EQU   INJMJCT+100
@NM00079 EQU   INJMJCT+99
JCTSTIOT EQU   INJMJCT+96
JCTSNUMB EQU   INJMJCT+95
JCTQIDNT EQU   INJMJCT+94
JCTEQREG EQU   INJMJCT+92
@NM00078 EQU   INJMJCT+91
JCTDETDA EQU   INJMJCT+88
JCTDSDRA EQU   JCTRSW2
JCTDSOJB EQU   JCTRSW2
JCTDSOCR EQU   JCTRSW2
JCTRESTT EQU   JCTRSW2
JCTNOCKP EQU   JCTRSW2
JCTNORST EQU   JCTRSW2
JCTNARST EQU   JCTRSW2
JCTSYSCK EQU   JCTRSW2
@NM00077 EQU   JCTRSW1
JCTSTEPR EQU   JCTRSW1
JCTCKPTR EQU   JCTRSW1
JCTCKFT  EQU   JCTRSW1
JCTCONTR EQU   JCTRSW1
JCTSTERM EQU   JCTRSW1
JCTWARMS EQU   JCTRSW1
@NM00076 EQU   JCTCCODE+3
JCTJDPOP EQU   JCTCCODE+2
JCTJDPCD EQU   JCTCCODE
@NM00075 EQU   INJMJCT+53
JCTSCT   EQU   INJMJCT+52
JCTSMRBA EQU   INJMJCT+44
@NM00074 EQU   INJMJCT+43
JCTACTAD EQU   INJMJCT+40
@NM00073 EQU   INJMJCT+39
JCTJCTX  EQU   INJMJCT+36
@NM00072 EQU   INJMJCT+35
JCTSDKAD EQU   INJMJCT+32
JCTJCSMF EQU   INJMJCT+31
JCTGDGNT EQU   INJMJCT+28
@NM00071 EQU   INJMJCT+27
JCTPDIP  EQU   INJMJCT+24
JCTJTPTN EQU   INJMJCT+16
JCTJNAME EQU   INJMJCT+8
JCTJPRTY EQU   JCTJBYTE
INCMMGL1 EQU   JCTJMGLV
INCMMGL2 EQU   JCTJMGLV
@NM00070 EQU   JCTJMGLV
INCMALL  EQU   JCTJMGLV
JCTJMGPO EQU   INJMJCT+6
INCMNSET EQU   JCTJSTAT
INCMCAT  EQU   INDMCTLG
INCMSTS  EQU   JCTJSTAT
JCTABEND EQU   JCTJSTAT
@NM00069 EQU   JCTJSTAT
JCTJSTPC EQU   JCTJSTAT
@NM00068 EQU   JCTJSTAT
JCTJBLBS EQU   JCTJSTAT
JCTJSRNO EQU   INJMJCT+4
JCTIDENT EQU   INJMJCT+3
JCTDSKAD EQU   INJMJCT
SIODDSNL EQU   INDMSIOT+173
SIOVDSNL EQU   INDMSIOT+172
SIOVDSNT EQU   INDMSIOT+170
SVOLUNNO EQU   INDMSIOT+168
SIOTVMVP EQU   INDMSIOT+164
SIOTJFX  EQU   INDMSIOT+160
SJFCBPTR EQU   INDMSIOT+156
SIOTNPTR EQU   INDMSIOT+152
SIOTETIO EQU   INDMSIOT+148
SIOTATE  EQU   INDMSIOT+144
SVOLUNAD EQU   INDMSIOT+140
SIOTEDLP EQU   INDMSIOT+136
SIOTEDLS EQU   INDMSIOT+132
SCTANAME EQU   INDMSIOT+122
SIOTSSIC EQU   INDMSIOT+120
@NM00067 EQU   INDMSIOT+108
SIOTSSNM EQU   INDMSIOT+104
SIODDQCR EQU   SIOTBYT2
SIOVDQCR EQU   SIOTBYT2
SIOTCVOL EQU   SIOTBYT2
SIOTCNEW EQU   SIOTBYT2
SIOTCALC EQU   SIOTBYT2
SIOTGALL EQU   SIOTBYT2
SIOTDSPD EQU   SIOTBYT2
SIOTDMND EQU   SIOTBYT2
SIOTOPUC EQU   INDMSIOT+99
SIOTOUTR EQU   INDMSIOT+97
SIOTOUTC EQU   INDMSIOT+96
SIOTSSWA EQU   INDMSIOT+93
SIOTAUNC EQU   SIOTALTD
SIOTACAT EQU   SIOTALTD
SIOTADEL EQU   SIOTALTD
SIOTAKEP EQU   SIOTALTD
SIOTNPRV EQU   SIOTALTD
SIOJCATS EQU   SIOTALTD
@NM00066 EQU   SIOTALTD
@NM00065 EQU   SIOTALTD
@NM00064 EQU   INDMSIOT+91
SIOTNDSB EQU   INDMSIOT+88
@NM00063 EQU   INDMSIOT+84
SIOTDPCD EQU   INDMSIOT+82
@NM00062 EQU   SIOTBYT4
SIOTRACT EQU   SIOTBYT4
SIOTRACD EQU   SIOTBYT4
SIOTPROT EQU   SIOTBYT4
SCTOUTPN EQU   INDMSIOT+80
SCTOUTNO EQU   INDMSIOT+76
SCTOUTNM EQU   INDMSIOT+68
SIOUCBAD EQU   SCTUTYPE+5
SIOUCNVT EQU   SCTUTYPE+4
SIOUBYT4 EQU   SIOTDEVT+3
@NM00061 EQU   SIOUBYT3
SIO3UREC EQU   SIOUBYT3
SIO3DISP EQU   SIOUBYT3
SIO3DACC EQU   SIOUBYT3
SIO3COMM EQU   SIOUBYT3
SIO3TAPE EQU   SIOUBYT3
SIOUBYT2 EQU   SIOTDEVT+1
SIOUBYT1 EQU   SIOTDEVT
SIOTOMN  EQU   SCTSBYT4
SIOTIPDI EQU   SCTSBYT4
SIOTVAFF EQU   SCTSBYT4
SIOTSTEP EQU   SCTSBYT4
SIOTASCI EQU   SCTSBYT4
@NM00060 EQU   SCTSBYT4
SIOTGDGA EQU   SCTSBYT4
SCTSGDGS EQU   SCTSBYT4
SCTSOLD  EQU   SCTSBYT3
SCTSMOD  EQU   SCTSBYT3
SCTSNEW  EQU   SCTSBYT3
SCTSYSOU EQU   SCTSBYT3
SCTVREF  EQU   SCTSBYT3
SCTALCHK EQU   SCTSBYT3
SCTSYSNE EQU   SCTSBYT3
SCTDSNRF EQU   SCTSBYT3
SCTRECVD EQU   SCTSBYT2
SCTDEFER EQU   SCTSBYT2
SCTLABEL EQU   SCTSBYT2
SCTUNLBD EQU   SCTSBYT2
SCTJOBLB EQU   SCTSBYT2
SCTVOLAF EQU   SCTSBYT2
SIOTCATL EQU   SCTSBYT2
SIOCLUNL EQU   SCTSBYT2
SIOTJSCT EQU   SCTSBYT1
SCTUNAFF EQU   SCTSBYT1
SCTPARLM EQU   SCTSBYT1
SIOTQDSN EQU   SCTSBYT1
SIOTGDSN EQU   SCTSBYT1
SIOTCCAT EQU   SCTSBYT1
SCTSYSIN EQU   SCTSBYT1
SCTDUMMY EQU   SCTSBYT1
SIOTUNCT EQU   SCTSDISP
SIOTCTLG EQU   SCTSDISP
SIOTDLET EQU   SCTSDISP
SIOTKEEP EQU   SCTSDISP
SIOTPASS EQU   SCTSDISP
SIOTPRIV EQU   SCTSDISP
S3400DSP EQU   SCTSDISP
SIOTRETN EQU   SCTSDISP
SIOTVLCT EQU   INDMSIOT+54
SCTNMBUT EQU   INDMSIOT+53
SIOTRTRY EQU   SIOTBYT0
SIOTPUPV EQU   SIOTBYT0
SIOTNOPV EQU   SIOTBYT0
SIOTGIGN EQU   SIOTBYT0
SPVTAMSG EQU   SIOTBYT0
SIOTFUDA EQU   SIOTBYT0
SIOTDYAL EQU   SIOTBYT0
SIOTSSDS EQU   SIOTBYT0
SIOTGIID EQU   INDMSIOT+50
SCTVOLCT EQU   INDMSIOT+49
SCTSPOOL EQU   INDMSIOT+48
SIOTQNAM EQU   SIOTTSTC
SIOTDSNM EQU   SIOTTSTC
SIOTTRKM EQU   SIOTTSTC
SIOTSSMG EQU   SIOTTSTC
SIOTSSGP EQU   SIOTTSTC
@NM00059 EQU   SIOTTSTC
SIOTTERM EQU   SIOTTSTC
SIOTINFC EQU   SIOTTSTC
@NM00058 EQU   SIOTBYT3
SIOTJES3 EQU   SIOTBYT3
SIOCDEVT EQU   SIOTBYT3
SIOALIAS EQU   SIOTBYT3
SCTDDINO EQU   INDMSIOT+44
SIOTDDNT EQU   SIOTBYT1
SIOTALCD EQU   SIOTBYT1
SIODADSM EQU   SIOTBYT1
SIOTDADR EQU   SIOTBYT1
SIODUNAL EQU   SIOTBYT1
SIOVAMDS EQU   SIOTBYT1
SIOTHOLD EQU   SIOTBYT1
SIOTOCKP EQU   SIOTBYT1
SIOPSCNT EQU   INDMSIOT+42
SIOTREFN EQU   INDMSIOT+40
SIOTOTUN EQU   INDMSIOT+39
SIOTVRSB EQU   INDMSIOT+36
@NM00057 EQU   INDMSIOT+35
SCTPJFCB EQU   INDMSIOT+32
@NM00056 EQU   INDMSIOT+31
SCTPSIOT EQU   INDMSIOT+28
SIOTAFID EQU   INDMSIOT+26
SIOTVLSP EQU   INDMSIOT+24
SIODSNTE EQU   INDMSIOT+22
SIOTUNAF EQU   SCTUSADD
SIOTDEST EQU   INDMSIOT+12
SCTDDNAM EQU   INDMSIOT+4
SIOTTYPE EQU   INDMSIOT+3
SIOTDSKA EQU   INDMSIOT
@NM00055 EQU   @NM00053+1
SCTONLY  EQU   SCTABCND
SCTEVEN  EQU   SCTABCND
SCTABEND EQU   SCTABCND
SCTONLYC EQU   SCTABCND
SCTABCAN EQU   SCTABCND
@NM00054 EQU   SCTABCND
@NM00052 EQU   INSMSCT+173
@NM00051 EQU   SCTSTEND
SCTSYSCK EQU   SCTSTEND
SCTSTPND EQU   SCTSTEND
SCTSTSRT EQU   SCTSTEND
@NM00050 EQU   INSMSCT+168
SCTCATCT EQU   INSMSCT+166
SCTSDPSA EQU   SCTCDENT+3
SCTSDPOP EQU   SCTCDENT+2
SCTSDPCD EQU   SCTCDENT
@NM00049 EQU   INSMSCT+117
SCTPRFMF EQU   INSMSCT+116
SCTPGMNM EQU   INSMSCT+108
SCTTIOT  EQU   INSMSCT+105
@NM00048 EQU   SCTBCT
SCTJBEND EQU   SCTBCT
SCTSPSYS EQU   SCTBCT
SCTSTPLB EQU   SCTBCT
@NM00047 EQU   SCTBCT
SCTMCVOL EQU   SCTBCT
@NM00046 EQU   SCTBCT
SCTGOTTR EQU   INSMSCT+100
SCTSMF   EQU   INSMSCT+96
@NM00045 EQU   SCTSDPTY+1
SCTSDP   EQU   SCTSDPTY
SCTFSTEP EQU   SCTSDPTY
@NM00044 EQU   SCTSDPTY
@NM00043 EQU   SCTSDPTY
SCTNIUSL EQU   INSMSCT+92
@NM00042 EQU   INSMSCT+90
SCTMSSZE EQU   INSMSCT+88
SCTPCAT  EQU   INSMSCT+84
SCTLDSTB EQU   INSMSCT+80
SCTSRBT  EQU   INSMSCT+76
SCTMSADR EQU   INSMSCT+72
@NM00041 EQU   INSMSCT+71
SCTXBTTR EQU   INSMSCT+68
SCTJSCAT EQU   SCTSTYPE
SCTINITB EQU   SCTSTYPE
SCTSJFHK EQU   SCTSTYPE
SCTOUTMC EQU   SCTSTYPE
SCTINPUT EQU   SCTSTYPE
SCTGOSTP EQU   SCTSTYPE
@NM00040 EQU   INSMSCT+66
SCTNSMSG EQU   INSMSCT+65
SCTSNUMB EQU   INSMSCT+64
@NM00039 EQU   INSMSCT+62
SCTRPACT EQU   INSMSCT+60
SCTSNAME EQU   INSMSCT+52
SCTSCLPC EQU   INSMSCT+44
@NM00038 EQU   INSMSCT+43
SCTADSTB EQU   INSMSCT+40
@NM00037 EQU   INSMSCT+36
@NM00036 EQU   INSMSCT+35
SCTAFACT EQU   INSMSCT+32
SCTDDNT  EQU   INSMSCT+28
@NM00035 EQU   INSMSCT+27
SCTLSIOT EQU   INSMSCT+24
@NM00034 EQU   INSMSCT+23
SCTANSCT EQU   INSMSCT+20
@NM00033 EQU   INSMSCT+19
SCTAALOC EQU   INSMSCT+16
@NM00032 EQU   INSMSCT+15
SCTFSIOT EQU   INSMSCT+12
SCTLALOC EQU   INSMSCT+10
SCTSEXEC EQU   INSMSCT+8
SCTSTIME EQU   INSMSCT+5
INCMSSTS EQU   SCTSSTAT
SCTGRPH  EQU   SCTSSTAT
SCTKEY0  EQU   SCTSSTAT
SCTDORST EQU   SCTSSTAT
SCTNOCKP EQU   SCTSSTAT
SCTNORST EQU   SCTSSTAT
EACAUSER EQU   SCTSSTAT
EAADDRBT EQU   SCTSSTAT
SCTTBLID EQU   INSMSCT+3
SCTDISKA EQU   INSMSCT
SWCHNPTR EQU   SWAEPA+12
SWLNGTH  EQU   SWAEPA+8
SWBLKID  EQU   SWVAFW+3
SWVA     EQU   SWVAFW
SWBLKPTR EQU   SWAEPA
CTGWAGB  EQU   CTGWA+12
CTGWAGCT EQU   CTGWA+10
CTGWAUCT EQU   CTGWA+8
CTGWAVCT EQU   CTGWA+6
CTGFIELD EQU   CTGPL+28
CTGPSWD  EQU   CTGJSCB
@NM00030 EQU   CTGFBFLG
CTGNGDSN EQU   CTGFBFLG
CTGGDGB  EQU   CTGFBFLG
CTGKEEP  EQU   CTGFBFLG
CTGPAR   EQU   CTGFBFLG
CTGFDBK  EQU   CTGNEWNM
CTGNOFLD EQU   CTGPL+19
CTGTYPE  EQU   CTGPL+18
@NM00029 EQU   CTGDSORG
CTGOPTNS EQU   CTGDSORG
CTGCVOL  EQU   CTGCAT
CTGFVT   EQU   CTGENT
@NM00028 EQU   CTGOPTN4
CTGBYPMT EQU   CTGOPTN4
@NM00027 EQU   CTGOPTN4
CTGNPROF EQU   CTGOPTN4
CTGDOCAT EQU   CTGOPTN4
CTGLBASE EQU   CTGOPTN4
CTGAM0   EQU   CTGOPTN3
CTGNUM   EQU   CTGOPTN3
CTGSRH   EQU   CTGOPTN3
CTGGDGL  EQU   CTGOPTN3
CTGSUPLT EQU   CTGOPTN3
CTGFUNC  EQU   CTGOPTN3
@NM00026 EQU   CTGOPTN2
CTGSCR   EQU   CTGOPTN2
CTGOVRID EQU   CTGOPTN2
CTGDISC  EQU   CTGOPTN2
CTGGTNXT EQU   CTGOPTN2
CTGSWAP  EQU   CTGRCATN
CTGGTALL EQU   CTGREL
CTGNSVS  EQU   CTGEXT
CTGGENLD EQU   CTGOPTN1
CTGCNAME EQU   CTGOPTN1
CTGNAME  EQU   CTGOPTN1
CTGREAD  EQU   CTGOPTN1
CTGUPD   EQU   CTGOPTN1
CTGCI    EQU   CTGOPTN1
CTGMAST  EQU   CTGOPTN1
CTGBYPSS EQU   CTGOPTN1
JSCBCSCB EQU   JSCBSEC1+68
JSCBPMG  EQU   JSCBWTP+2
JSCBWTSP EQU   JSCBWTP+1
JSCRSV23 EQU   JSCBWTFG
JSCRSV22 EQU   JSCBWTFG
JSCRSV21 EQU   JSCBWTFG
JSCRSV20 EQU   JSCBWTFG
JSCRSV19 EQU   JSCBWTFG
JSCRSV18 EQU   JSCBWTFG
JSCBRET  EQU   JSCBWTFG
JSCBIOFG EQU   JSCBWTFG
@NM00023 EQU   JSCBSEC1+60
JSCBQMPI EQU   JSCBSEC1+56
JSCBPMSG EQU   JSCBSWT1
JSCRSV16 EQU   JSCBSWT1
JSCRSV15 EQU   JSCBSWT1
JSCRSV14 EQU   JSCBSWT1
JSCRSV13 EQU   JSCBSWT1
JSCRSV12 EQU   JSCBSWT1
JSCRSV11 EQU   JSCBSWT1
JSCBPASS EQU   JSCBSWT1
JSCBTTTR EQU   JSCBSEC1+52
JSCRSV10 EQU   JSCBSEC1+49
JSCBAUTH EQU   JSCBOPTS
JSCSIOTS EQU   JSCBOPTS
JSCRSV08 EQU   JSCBOPTS
JSCRSV07 EQU   JSCBOPTS
JSCRSV06 EQU   JSCBOPTS
JSCBLONG EQU   JSCBOPTS
JSCRSV05 EQU   JSCBOPTS
JSCRSV04 EQU   JSCBOPTS
JSCBSECB EQU   JSCBSEC1+44
JSCRSV03 EQU   JSCBSEC1+41
JSCBSTEP EQU   JSCBSEC1+40
JSCBDCBA EQU   JSCBDCB+1
JSCRSV02 EQU   JSCBDCB
JSCBID   EQU   JSCBSEC1+32
JSCBDBTB EQU   JSCBSEC1+28
JSCBIJSC EQU   JSCBSEC1+24
JSCBTCBP EQU   JSCBSEC1+20
JSCBTCP  EQU   JSCBSEC1+12
JSCBSHR  EQU   JSCBSEC1+8
JSCHPCEA EQU   JSCHPCE+1
JSCRSV32 EQU   JSCHPCE
JSCRSV01 EQU   JSCBSEC1
@NM00022 EQU   IEZJSCB
ETCBP    EQU   EPARMLST+432
EEINTIOT EQU   EPARMLST+428
ERESCD   EQU   ERETURNS+2
ERETCD   EQU   ERETURNS
EDDNAME  EQU   EPARMLST+416
EACBPTR  EQU   EPARMLST+412
@NM00020 EQU   EECNTRLS+1
@NM00019 EQU   EECNTRLS+1
EENOUNCT EQU   EECNTRLS+1
EESWTIOT EQU   EECNTRLS+1
EECCUCAT EQU   EECNTRLS
EEUCUCAT EQU   EECNTRLS
@NM00018 EQU   EPARMLST
HWVLSERS EQU   HWVLSELB+4
HWVLSLCT EQU   HWSELHDR+2
HWVLSBLN EQU   HWSELHDR
HWTYPE   EQU   HWCTBYT+1
@NM00017 EQU   HWCTBYT
HWDA     EQU   HWCTBYT
@NM00016 EQU   HWCTBYT
HWTAPE   EQU   HWCTBYT
@NM00015 EQU   HWOBYTE
HWRVDEV  EQU   HWOBYTE
@NM00014 EQU   HWOBYTE
HW7TRK   EQU   HWOBYTE
HWMBYTE  EQU   HWDEV
HWUCBP   EQU   HWUCLST+8
HWDEVTYP EQU   HWUCLST+4
HWEDTLUV EQU   HWUCLST
HWRSVCHR EQU   HWDATA+986
HWCONCAT EQU   HWDATA+984
HWCATSER EQU   HWDATA+978
@NM00013 EQU   HWDATA+958
HWDSNAME EQU   HWDATA+176
HWDSNLN  EQU   HWDATA+174
@NM00012 EQU   HWSTPNBR
HWRSVPTR EQU   HWDATA+84
HWDSENQP EQU   HWDATA+76
HWRPDIEP EQU   HWDATA+72
HWLPDIBP EQU   HWDATA+68
HWGDGBSP EQU   HWDATA+64
HWCJFCBP EQU   HWDATA+48
HWRSIOTP EQU   HWDATA+40
HWGDGNTP EQU   HWDATA+28
HWPDIP   EQU   HWDATA+24
@NM00011 EQU   HWCNTRL+14
HWDDCTR  EQU   HWCNTRL+12
HWDDSTEP EQU   HWCNTRL+10
@NM00010 EQU   HWCNTRL+9
@NM00009 EQU   HWJLCTLS+1
HWNOVOLU EQU   HWJLCTLS+1
HWDOMOD  EQU   HWJLCTLS+1
HWVSAME  EQU   HWJLCTLS
HWLOCCAT EQU   HWJLCTLS
HWGDGSLC EQU   HWJLCTLS
HWLBASEL EQU   HWJLCTLS
@NM00008 EQU   HWJLCTLS
HWSYSLOC EQU   HWJLCTLS
HWPDIEDL EQU   HWJLCTLS
HWPDISCN EQU   HWJLCTLS
@NM00007 EQU   HWTBLCTL
HWCOPYAF EQU   HWTBLCTL
HWTBCOPY EQU   HWTBLCTL
@NM00006 EQU   HWCNTRL+4
@NM00005 EQU   HWMSSCTL+1
HWAVSRCH EQU   HWMSSCTL+1
HWVLSELF EQU   HWMSSCTL+1
HWAVUNIT EQU   HWMSSCTL
HWCATINT EQU   HWCNTRL+3
HWDDDONE EQU   HWCNTRL+3
HWOVRDN  EQU   HWCNTRL+3
HWVAME   EQU   HWCNTRL+3
HWEDT    EQU   HWCNTRL+3
HWUCB    EQU   HWCNTRL+2
HWOVCAND EQU   HWCNTRL+2
HWDSNCAT EQU   HWCNTRL+2
HWRESIOT EQU   HWCNTRL+2
HWGDGALL EQU   HWCNTRL+2
HWDSNRQD EQU   HWCNTRL+2
HWVUREC  EQU   HWCNTRL+2
HWDSNREC EQU   HWCNTRL+2
@NM00004 EQU   HWCNTRL+1
HWNOVRID EQU   HWCNTRL+1
HWDSAUTH EQU   HWCNTRL+1
HWNODSI  EQU   HWCNTRL+1
HWOFFDEV EQU   HWCNTRL+1
HWNOSCAT EQU   HWCNTRL
HWWVOLS  EQU   HWCNTRL
HWDNCCDD EQU   HWCNTRL
HWWAITOK EQU   HWCNTRL
HWMNTCAT EQU   HWCNTRL
HWNOULSP EQU   HWCNTRL
HWDOPDI  EQU   HWCNTRL
ASWRSV02 EQU   ASWAFLGS+1
ASWRSV01 EQU   ASWADSWS
ASWADYUE EQU   ASWADSWS
ASWAVMVF EQU   ASWADSWS
ASWACOMF EQU   ASWADSWS
ASWADYNF EQU   ASWADSWS
NEXTTCBP EQU   TWOTCBPS
@NM00113 EQU   PSA+3668
PSASTAK  EQU   PSA+3072
@NM00112 EQU   PSA+1048
PSAUSEND EQU   PSA+1048
PSARV062 EQU   PSA+1044
PSACDAL  EQU   PSA+1040
PSAWTCOD EQU   PSA+1036
PSAATCVT EQU   PSA+1032
PSAPCPSW EQU   PSA+1024
PSAPIR2  EQU   PSA+1020
PSARV059 EQU   PSA+1018
PSASVC13 EQU   PSA+1016
PSALSFCC EQU   PSA+1012
PSASFACC EQU   PSA+1008
PSASTOP  EQU   PSA+992
PSASTART EQU   PSA+976
PSARSPSW EQU   PSA+968
PSASRPSW EQU   PSA+960
PSARV045 EQU   PSA+892
PSARV044 EQU   PSA+888
PSARV043 EQU   PSA+884
PSARV042 EQU   PSA+880
PSARV041 EQU   PSA+876
PSARV040 EQU   PSA+872
PSARV025 EQU   PSA+868
PSADSSED EQU   PSA+868
PSADSSPR EQU   PSA+864
PSADSSFW EQU   PSA+860
PSADSS14 EQU   PSA+856
PSADSSPP EQU   PSA+848
PSADSSRP EQU   PSA+840
PSADSS05 EQU   PSADSSF4
PSADSS10 EQU   PSADSSF4
PSADSSVE EQU   PSADSSF4
PSADSSDE EQU   PSADSSF4
PSADSSC0 EQU   PSADSSF4
PSADSSIE EQU   PSADSSF4
PSADSS12 EQU   PSADSSF4
PSADSSRC EQU   PSADSSF4
PSARV057 EQU   PSADSSF3
PSARV056 EQU   PSADSSF3
PSARV055 EQU   PSADSSF3
PSADSSMC EQU   PSADSSF3
PSADSSRW EQU   PSADSSF3
PSADSSNM EQU   PSADSSF3
PSADSSES EQU   PSADSSF3
PSADSSGP EQU   PSADSSF3
PSADSSF2 EQU   PSADSSFL+1
PSADSSPI EQU   PSADSSF1
PSADSSOI EQU   PSADSSF1
PSADSSSP EQU   PSADSSF1
PSADSSTP EQU   PSADSSF1
PSADSSDW EQU   PSADSSF1
PSADSSDD EQU   PSADSSF1
PSADSSDM EQU   PSADSSF1
PSADSSMV EQU   PSADSSF1
PSADSSTS EQU   PSA+816
PSADSSWK EQU   PSA+812
PSADSSR3 EQU   PSA+808
PSADSSR2 EQU   PSA+804
PSADSSRS EQU   PSA+800
PSASTOR  EQU   PSA+796
PSACPUSA EQU   PSA+794
PSAVSTAP EQU   PSA+792
PSAWKVAP EQU   PSA+788
PSAWKRAP EQU   PSA+784
PSAMCHIC EQU   PSA+783
PSARV061 EQU   PSA+782
PSASYMSK EQU   PSA+781
PSAMCHFL EQU   PSA+780
PSACR0   EQU   PSA+776
PSAPSWSV EQU   PSA+768
PSALITA  EQU   PSA+764
PSACLHS  EQU   PSAHLHI
PSALKR15 EQU   PSALKSA+60
PSALKR14 EQU   PSALKSA+56
PSALKR13 EQU   PSALKSA+52
PSALKR12 EQU   PSALKSA+48
PSALKR11 EQU   PSALKSA+44
PSALKR10 EQU   PSALKSA+40
PSALKR9  EQU   PSALKSA+36
PSALKR8  EQU   PSALKSA+32
PSALKR7  EQU   PSALKSA+28
PSALKR6  EQU   PSALKSA+24
PSALKR5  EQU   PSALKSA+20
PSALKR4  EQU   PSALKSA+16
PSALKR3  EQU   PSALKSA+12
PSALKR2  EQU   PSALKSA+8
PSALKR1  EQU   PSALKSA+4
PSALKR0  EQU   PSALKSA
PSARV023 EQU   PSACLHT+52
PSALOCAL EQU   PSACLHT+48
PSACMSL  EQU   PSACLHT+44
PSAOPTL  EQU   PSACLHT+40
PSATPACL EQU   PSACLHT+36
PSATPDNL EQU   PSACLHT+32
PSATPNCL EQU   PSACLHT+28
PSAIOSLL EQU   PSACLHT+24
PSAIOSUL EQU   PSACLHT+20
PSAIOSCL EQU   PSACLHT+16
PSAIOSSL EQU   PSACLHT+12
PSASALCL EQU   PSACLHT+8
PSAASML  EQU   PSACLHT+4
PSADISPL EQU   PSACLHT
PSASRSA  EQU   PSA+636
PSARV050 EQU   PSA+634
PSADSSGO EQU   PSA+633
PSARECUR EQU   PSA+632
PSAHLHIS EQU   PSA+628
PSAIPCSA EQU   PSA+624
@NM00111 EQU   PSA+621
PSAIPCDM EQU   PSA+620
PSAIPCD  EQU   PSA+616
@NM00110 EQU   PSA+613
PSAIPCRM EQU   PSA+612
PSAIPCR  EQU   PSA+608
PSAMCHEX EQU   PSA+600
PSAMPSW  EQU   PSA+592
PSAEXPS2 EQU   PSA+584
PSAEXPS1 EQU   PSA+576
PSAPIREG EQU   PSA+572
PSARSREG EQU   PSA+568
PSAGPREG EQU   PSA+556
PSARV022 EQU   PSASUP4
PSARV021 EQU   PSASUP4
PSARV020 EQU   PSASUP4
PSARV019 EQU   PSASUP4
PSARV018 EQU   PSASUP4
PSARV017 EQU   PSASUP4
PSARV016 EQU   PSASUP4
PSARV015 EQU   PSASUP4
PSARV014 EQU   PSASUP3
PSARV013 EQU   PSASUP3
PSARV012 EQU   PSASUP3
PSAESTA  EQU   PSASUP3
PSASPR   EQU   PSASUP3
PSAPSREG EQU   PSASUP3
PSAPI2   EQU   PSASUP3
PSAIOSUP EQU   PSASUP3
PSALCR   EQU   PSASUP2
PSARTM   EQU   PSASUP2
PSAACR   EQU   PSASUP2
PSAIPCE2 EQU   PSASUP2
PSAIPCES EQU   PSASUP2
PSAIPCEC EQU   PSASUP2
PSAGTF   EQU   PSASUP2
PSAIPCRI EQU   PSASUP2
PSATYPE6 EQU   PSASUP1
PSATCTL  EQU   PSASUP1
PSADISP  EQU   PSASUP1
PSALOCK  EQU   PSASUP1
PSAPI    EQU   PSASUP1
PSAEXT   EQU   PSASUP1
PSASVC   EQU   PSASUP1
PSAIO    EQU   PSASUP1
PSAANEW  EQU   PSA+544
PSATOLD  EQU   PSA+540
PSATNEW  EQU   PSA+536
PSALCCAR EQU   PSA+532
PSALCCAV EQU   PSA+528
PSAPCCAR EQU   PSA+524
PSAPCCAV EQU   PSA+520
PSACPULA EQU   PSA+518
PSACPUPA EQU   PSA+516
PSAPSA   EQU   PSA+512
FLCHDEND EQU   PSA+512
FLCCRSAV EQU   FLCMCLA+280
FLCGRSAV EQU   FLCMCLA+216
FLCFPSAV EQU   FLCMCLA+184
FLCFLA   EQU   FLCMCLA+88
FLCRGNCD EQU   FLCMCLA+84
FLCFSAA  EQU   FLCFSA+1
@NM00109 EQU   FLCFSA
@NM00108 EQU   FLCMCLA+72
FLCMCIC  EQU   FLCMCLA+64
@NM00107 EQU   FLCMCLA+20
FLCIOAA  EQU   FLCIOA+1
@NM00106 EQU   FLCIOA
@NM00105 EQU   FLCMCLA+15
@NM00104 EQU   FLCMCLA+14
@NM00103 EQU   FLCMCLA+12
FLCLCL   EQU   FLCMCLA+8
FLCIOELA EQU   FLCIOEL+1
@NM00102 EQU   FLCIOEL
FLCCHNID EQU   FLCMCLA
@NM00101 EQU   PSA+160
FLCMTRCD EQU   PSA+157
@NM00100 EQU   PSA+156
FLCPERA  EQU   FLCPER+1
@NM00099 EQU   FLCPER
@NM00098 EQU   PSA+151
FLCPERCD EQU   PSA+150
FLCMCNUM EQU   PSA+149
@NM00097 EQU   PSA+148
FLCTEAA  EQU   FLCTEA+1
@NM00096 EQU   FLCTEA
PSAPIPC  EQU   PSAPICOD
PSAPIMC  EQU   PSAPICOD
PSAPIPER EQU   PSAPICOD
PSARV049 EQU   FLCPICOD
FLCPILCB EQU   FLCPIILC
@NM00095 EQU   FLCPIILC
@NM00094 EQU   PSAEPPSW
FLCSVCN  EQU   PSAESPSW+2
FLCSILCB EQU   FLCSVILC
@NM00093 EQU   FLCSVILC
@NM00092 EQU   PSAESPSW
FLCEICOD EQU   PSAEEPSW+2
PSASPAD  EQU   PSAEEPSW
@NM00091 EQU   PSA+128
FLCINPSW EQU   PSA+120
FLCMNPSW EQU   PSA+112
FLCPNPSW EQU   PSA+104
FLCSNPSW EQU   PSA+96
FLCENPSW EQU   PSA+88
FLCTRACE EQU   PSA+84
FLCTIMER EQU   PSA+80
FLCCVT2  EQU   PSA+76
FLCCAW   EQU   PSA+72
FLCCSW   EQU   PSA+64
FLCIOPSW EQU   PSA+56
FLCMOPSW EQU   PSA+48
FLCPOPSW EQU   PSA+40
FLCSOPSW EQU   PSA+32
FLCEOPSW EQU   PSA+24
@NM00090 EQU   FLCICCW2+4
FLCCVT   EQU   FLCICCW2
FLCICCW1 EQU   FLCROPSW
FLCIPPSW EQU   FLCRNPSW
.@UNREFD ANOP                          END UNREFERENCED COMPONENTS
@RF00106 EQU   @RC00095
@ENDDATA EQU   *
         END   IEFAB451,(C'PLS2207',0701,76334)
