         TITLE 'IEFAB452 - DD PROCESSING CONTROL ROUTINE               *
                        '
IEFAB452 CSECT ,                                                01S0001
@MAINENT DS    0H                                               01S0001
         USING *,@15                                            01S0001
         B     @PROLOG                                          01S0001
         DC    AL1(16)                                          01S0001
         DC    C'IEFAB452  73.325'                              01S0001
         DROP  @15
@PROLOG  STM   @14,@12,12(@13)                                  01S0001
         BALR  @12,0                                            01S0001
@PSTART  DS    0H                                               01S0001
         USING @PSTART,@12                                      01S0001
         L     @00,@SIZDATD                                     01S0001
         MODESET EXTKEY=SCHED,SAVEKEY=(2)
         GSPACE  R,LV=(0)
         LR    @11,@01                                          01S0001
         USING @DATD,@11                                        01S0001
         ST    @13,@SA00001+4                                   01S0001
         STC   @02,@OLDKEY                                      01S0001
         MODESET KEYADDR=(2)
         LM    @00,@02,20(@13)                                  01S0001
         ST    @11,8(,@13)                                      01S0001
         LR    @13,@11                                          01S0001
         MODESET EXTKEY=ZERO
         MVC   @PC00001(16),0(@01)                              01S0001
         MODESET EXTKEY=SCHED
JSCBDISP EQU 188
JSCBAOS1 EQU  72
JSCBAOS2 EQU 192
*                                                                    */
*   DATAPREG=HWDATAP;               /* MAP HSKP DATA AND RETURN      */
         L     @10,@PC00001+4                                   01S0037
         L     DATAPREG,HWDATAP(,@10)                           01S0037
*   RTNPREG=HWRTNP;                 /* AREAS FOR PROCESSING SPEED    */
         L     @10,@PC00001+8                                   01S0038
         L     RTNPREG,HWRTNP(,@10)                             01S0038
*   RFY                                                         01S0039
*     HWDATA BASED(DATAPREG);                                   01S0039
*   RFY                                                         01S0040
*     HWRETURN BASED(RTNPREG);                                  01S0040
*   IF HWNOSCAT=OFF&                /* STEPCAT PROCESSING ALLOWED    */
*       SCTPCAT^=0 THEN             /* STEP-CATALOGS ARE INDICATED   */
         L     @10,@PC00001                                     01S0041
         L     @10,HWCNTRLP(,@10)                               01S0041
         TM    HWNOSCAT(@10),B'00000001'                        01S0041
         BNZ   @RF00041                                         01S0041
         SLR   @10,@10                                          01S0041
         L     @02,HWSCTP(,DATAPREG)                            01S0041
         CL    @10,SCTPCAT(,@02)                                01S0041
         BE    @RF00041                                         01S0041
*     DO;                                                       01S0042
*                                                               02S0043
*/********************************************************************/
*/* SEGMENT NAME - CATSPEC                                           */
*/*                                                                  */
*/* DESCRIPTIVE NAME - STEPCAT PROCESSING                            */
*/*                                                                  */
*/* FUNCTION    - CHECK THE INFORMATION OF THE STEPCAT DD(S) AND     */
*/*               INITIATE HOUSEKEEPING PROCESSING OF THEM.          */
*/*                                                                  */
*/*   OPERATION-1.THIS COULD BE A CHECKPOINT RESTART, SO ALL         */
*/*               JOB/STEPCATS MUST BE PROPER (NOT A DUPLICATE       */
*/*               REQUEST FOR A PREVIOUS CATALOG). IF NOT PROPER     */
*/*               THE REQUEST IS NOT SYNTAX CHECKED.                 */
*/*             2.THE SIOT WILL BE CHECKED, INSURING THAT NO VOLUME  */
*/*               OR UNIT INFORMATION WAS SPECIFIED, NO 'DEFER'      */
*/*               MOUNTING WAS REQUESTED, AND THE DISPOSITION IS     */
*/*               OLD AND 'KEEP' IS SPECIFIED OR IMPLIED.            */
*/*             3.IEFAB454 ( DD FUNCTION CONTROL ) IS THEN CALLED    */
*/*               TO PROCESS THE DD.                                 */
*/*             4.THE PCCB ROUTINE (IEFAB4EF) WILL THEN BE CALLED TO */
*/*               CREATE A PCCB FOR THE CATALOG IF THERE IS NO ERROR */
*/*               INDICATED BY HOUSEKEEPING, AND THE DATA SET EXISTS */
*/*               ON ONLY ONE DEVICE AND VOLUME AND IS NOT A GDG.    */
*/*               IF THE PCCB ALREADY EXISTED, THE 'STEPCAT' AND     */
*/*               'CATALOGUED DATA SET' BITS ARE TURNED OFF IN THE   */
*/*               SIOT, BECAUSE ONLY ONE STEPCAT DD CAN REPRESENT    */
*/*               ONE CATALOG DATA SET. THE DD WILL BE PROCESSED     */
*/*               WITH AND AS A NORMAL DD IN THE JOBSTREAM.          */
*/*                                                                  */
*/*             5.RETURN AND REASON CODES ARE SET INTO THE HOUSE-    */
*/*               KEEPING WORKAREA IF ANY OF THE ABOVE ERRORS EXIST. */
*/*                                                                  */
*/* ENTRY - IF ANY STEPCATS EXIST                                    */
*/*                                                                  */
*/* INPUT DATA - THE NUMBER OF STEPCATS IN THE STEP AND A POINTER TO */
*/*              THE FIRST STEPCAT'S SIOT.                           */
*/*                                                                  */
*/* EXIT - INLINE IN ALL CASES                                       */
*/*                                                                  */
*/*   OUTPUT DATA - PROCESSED STEPCAT SIOT,JFCBS.                    */
*/*               ERROR REASON CODES                                 */
*/*               JCL STATEMENT ERROR - 75                           */
*/*               CATALOG RETURN INFORMATION ERROR - 76              */
*/*                                                                  */
*/*   RETURN CODES - NO ERROR - 0                                    */
*/*                - ERROR    - 4                                    */
*/*                                                                  */
*/********************************************************************/
*                                                               02S0043
*       SWACTLS=0;                  /* CALL SWA INTERFACE TO READ    */
         STH   @10,SWACTLS                                      02S0043
*       SWREAD=ON;                  /* LOCATE THE FIRST STEPCAT SIOT,*/
         OI    SWREAD,B'00100000'                               02S0044
*       IF HWLEPARP=0 THEN          /* CREATING A NEW EPA IF NEEDED, */
         C     @10,HWLEPARP(,DATAPREG)                          02S0045
         BNE   @RF00045                                         02S0045
*         SWNEW=ON;                                             02S0046
         OI    SWNEW,B'00001000'                                02S0046
*       ELSE                        /* ELSE, USING THE OLD HSKP EPA  */
*         SWMOD=ON;                                             02S0047
         B     @RC00045                                         02S0047
@RF00045 OI    SWMOD,B'00000010'                                02S0047
*       CALL IEFAB4F7(SWACTLS,HWLEPARP,0,ADDR(SCTPCAT),ADDR(SCAT1),0,1)
*           ;                       /* SWA INTERFACE                 */
@RC00045 LA    @10,SWACTLS                                      02S0048
         ST    @10,@AL00001                                     02S0048
         LA    @10,HWLEPARP(,DATAPREG)                          02S0048
         ST    @10,@AL00001+4                                   02S0048
         LA    @10,@CF00528                                     02S0048
         ST    @10,@AL00001+8                                   02S0048
         L     @10,HWSCTP(,DATAPREG)                            02S0048
         LA    @10,SCTPCAT(,@10)                                02S0048
         ST    @10,@TF00001                                     02S0048
         LA    @10,@TF00001                                     02S0048
         ST    @10,@AL00001+12                                  02S0048
         LA    @10,SCAT1                                        02S0048
         ST    @10,@TF00002                                     02S0048
         LA    @10,@TF00002                                     02S0048
         ST    @10,@AL00001+16                                  02S0048
         LA    @10,@CF00528                                     02S0048
         ST    @10,@AL00001+20                                  02S0048
         LA    @10,@CF00043                                     02S0048
         ST    @10,@AL00001+24                                  02S0048
         L     @15,@CV00085                                     02S0048
         LA    @01,@AL00001                                     02S0048
         BALR  @14,@15                                          02S0048
*       SIOTPTR=SCAT1;              /* FIRST STEPCAT TO PROCESS      */
         L     SIOTPTR,SCAT1                                    02S0049
*       DO STEPCATS=1 TO SCTCATCT WHILE/* NUMBER OF STEPCATS IN SCT  */
*             (HWRTCD=0);           /* AND NO ERRORS DETECTED        */
         LA    STEPCATS,1                                       02S0050
         B     @DE00050                                         02S0050
@DL00050 SLR   @10,@10                                          02S0050
         CH    @10,HWRTCD(,RTNPREG)                             02S0050
         BNE   @DC00050                                         02S0050
*         HWCSIOTP=SIOTPTR;         /* SIOTPTR TO HSKP WORKAREA      */
         ST    SIOTPTR,HWCSIOTP(,DATAPREG)                      02S0051
*         DISPTEMP=SCTSDISP&NODISP; /* FOR CHECKING SCHEDULER AND    */
         LA    DISPTEMP,31                                      02S0052
         SLR   @15,@15                                          02S0052
         IC    @15,SCTSDISP(,SIOTPTR)                           02S0052
         NR    DISPTEMP,@15                                     02S0052
*         ALTDTEMP=SIOTALTD&NOALTDSP;/* ALTERNATE DISPOSITIONS       */
         LA    ALTDTEMP,15                                      02S0053
         SLR   @15,@15                                          02S0053
         IC    @15,SIOTALTD(,SIOTPTR)                           02S0053
         NR    ALTDTEMP,@15                                     02S0053
*         IF SIOTJSCT=ON THEN       /* MAKE CHECKS ONLY IF THIS IS A
*                                      PROPER JOB/STEPCAT. IT MAY BE
*                                      A RESTART WITH BIT TURNED OFF.*/
         TM    SIOTJSCT(SIOTPTR),B'00000001'                    02S0054
         BNO   @RF00054                                         02S0054
*           IF SCTUTYPE=BLANK&SCTUNAFF=OFF&/* NO UNIT INFORMATION AND*/
*               SCTVOLCT=0&         /* NO VOLUME INFO, NOT A SUB-    */
*               SIOTSSDS=OFF&SCTDEFER=OFF&/* SYSTEM DS,OR DEFER 02S0055
*                                      MOUNT,                        */
*               SCTVOLAF=OFF&SCTSOLD=ON&/* NO VOL=REF= , AND    02S0055
*                                      DISP=OLD,                     */
*               (SIOTKEEP=ON|DISPTEMP=0)&/* DISPOSITIONS ARE KEEP,   */
*               (SIOTAKEP=ON|ALTDTEMP=0)&/* (OR WILL DEFAULT TO 02S0055
*                                      KEEP),                        */
*               SCTDUMMY=OFF&       /* VSAM 'DUMMY' ILLEGAL,         */
*               SCTSGDGS=OFF THEN   /* AND NOT A GDG SINGLE, THEN IT */
         CLC   SCTUTYPE(8,SIOTPTR),@CC00050                     02S0055
         BNE   @RF00055                                         02S0055
         TM    SCTUNAFF(SIOTPTR),B'00000010'                    02S0055
         BNZ   @RF00055                                         02S0055
         CLI   SCTVOLCT(SIOTPTR),0                              02S0055
         BNE   @RF00055                                         02S0055
         TM    SIOTSSDS(SIOTPTR),B'10000000'                    02S0055
         BNZ   @RF00055                                         02S0055
         TM    SCTDEFER(SIOTPTR),B'00100010'                    02S0055
         BNZ   @RF00055                                         02S0055
         TM    SCTSOLD(SIOTPTR),B'00000001'                     02S0055
         BNO   @RF00055                                         02S0055
         TM    SIOTKEEP(SIOTPTR),B'00001000'                    02S0055
         BO    @GL00004                                         02S0055
         CR    DISPTEMP,@10                                     02S0055
         BNE   @RF00055                                         02S0055
@GL00004 TM    SIOTAKEP(SIOTPTR),B'00001000'                    02S0055
         BO    @GL00003                                         02S0055
         CH    ALTDTEMP,@CH00528                                02S0055
         BNE   @RF00055                                         02S0055
@GL00003 TM    SCTDUMMY(SIOTPTR),B'10000000'                    02S0055
         BNZ   @RF00055                                         02S0055
         TM    SCTSGDGS(SIOTPTR),B'10000000'                    02S0055
         BNZ   @RF00055                                         02S0055
*             DO;                   /* MAY BE PROCESSED AS A STEPCAT.*/
*               DDNUMSAV=JSCDDNUM;  /* NO SIOTS (DDS) MAY BE CREATED */
         L     @10,HWJSCBP(,DATAPREG)                           02S0057
         LH    DDNUMSAV,JSCDDNUM(,@10)                          02S0057
*               CALL IEFAB453(HWCNTRLP,HWDATAP,HWRTNP,HWCSIOTP);
         L     @10,@PC00001                                     02S0058
         ST    @10,@AL00001                                     02S0058
         L     @10,@PC00001+4                                   02S0058
         ST    @10,@AL00001+4                                   02S0058
         L     @10,@PC00001+8                                   02S0058
         ST    @10,@AL00001+8                                   02S0058
         LA    @10,HWCSIOTP(,DATAPREG)                          02S0058
         ST    @10,@AL00001+12                                  02S0058
         L     @15,@CV00077                                     02S0058
         LA    @01,@AL00001                                     02S0058
         BALR  @14,@15                                          02S0058
*               IF HWRTCD=0 THEN    /* NO ERROR IN DD PREPARATION    */
         ICM   @10,3,HWRTCD(RTNPREG)                            02S0059
         BNZ   @RF00059                                         02S0059
*                 CALL IEFAB454(HWCNTRLP,HWDATAP,HWRTNP,HWCSIOTP,
*                     HWCJFCBP);    /* DD FUNCTION CONTROL           */
         L     @10,@PC00001                                     02S0060
         ST    @10,@AL00001                                     02S0060
         L     @10,@PC00001+4                                   02S0060
         ST    @10,@AL00001+4                                   02S0060
         L     @10,@PC00001+8                                   02S0060
         ST    @10,@AL00001+8                                   02S0060
         LA    @10,HWCSIOTP(,DATAPREG)                          02S0060
         ST    @10,@AL00001+12                                  02S0060
         LA    @10,HWCJFCBP(,DATAPREG)                          02S0060
         ST    @10,@AL00001+16                                  02S0060
         L     @15,@CV00083                                     02S0060
         LA    @01,@AL00001                                     02S0060
         BALR  @14,@15                                          02S0060
*               IF HWRTCD=0&DDNUMSAV=JSCDDNUM&/* DS FOUND,NOT MULTI- */
*                   SIOTGALL=OFF&JFCBNVOL=ONE THEN/* DEVICE OR GDG   */
@RF00059 SLR   @10,@10                                          02S0061
         CH    @10,HWRTCD(,RTNPREG)                             02S0061
         BNE   @RF00061                                         02S0061
         L     @06,HWJSCBP(,DATAPREG)                           02S0061
         CH    DDNUMSAV,JSCDDNUM(,@06)                          02S0061
         BNE   @RF00061                                         02S0061
         TM    SIOTGALL(SIOTPTR),B'00100000'                    02S0061
         BNZ   @RF00061                                         02S0061
         L     @06,HWCJFCBP(,DATAPREG)                          02S0061
         CLI   JFCBNVOL(@06),1                                  02S0061
         BNE   @RF00061                                         02S0061
*                 DO;               /* HAVE A PCCB CREATED, (IF NONE */
*                   PCCNTRLS=0;     /* EXIST FOR THIS CATALOG).      */
         STH   @10,PCCNTRLS                                     02S0063
*                   PCCSTPCT=ON;    /* STEP CATALOG                  */
*                   PCCMAKE=ON;     /* CREATE AND CHAIN A PCCB       */
         OI    PCCSTPCT,B'10100000'                             02S0065
*                   IF CTGCVCC=JFCBDSNM THEN/* STEPCAT NAME NOT AN
*                                      ALIAS                         */
         L     @02,HWCRIP(,DATAPREG)                            02S0066
         L     @02,CTGCVOL(,@02)                                02S0066
         CLC   CTGCVCC(44,@02),JFCBDSNM(@06)                    02S0066
         BNE   @RF00066                                         02S0066
*                     CTGCONP=0;    /* INDICATE 'NO ALIAS'           */
         ST    @10,CTGCONP                                      02S0067
*                   ELSE                                        02S0068
*                     CTGCONP=ADDR(CTGCVCC);/* ADDRESS OF ALIAS NAME */
         B     @RC00066                                         02S0068
@RF00066 L     @10,HWCRIP(,DATAPREG)                            02S0068
         L     @10,CTGCVOL(,@10)                                02S0068
         LA    @10,CTGCVCC(,@10)                                02S0068
         ST    @10,CTGCONP                                      02S0068
*                   CALL IEFAB4EF(PCCNTRLS,HWRTNP,JSCBACT,ADDR(JFCBDSNM
*                       ),CTGCONP,0,0,0,0);/* PCCB MAKE              */
@RC00066 LA    @10,PCCNTRLS                                     02S0069
         ST    @10,@AL00001                                     02S0069
         L     @10,@PC00001+8                                   02S0069
         ST    @10,@AL00001+4                                   02S0069
         L     @10,HWJSCBP(,DATAPREG)                           02S0069
         LA    @10,JSCBACT(,@10)                                02S0069
         ST    @10,@AL00001+8                                   02S0069
         LA    @10,HWCJFCBP(,DATAPREG)                          02S0069
         ST    @10,@AL00001+12                                  02S0069
         LA    @10,CTGCONP                                      02S0069
         ST    @10,@AL00001+16                                  02S0069
         LA    @10,@CF00528                                     02S0069
         ST    @10,@AL00001+20                                  02S0069
         LA    @10,@CF00528                                     02S0069
         ST    @10,@AL00001+24                                  02S0069
         LA    @10,@CF00528                                     02S0069
         ST    @10,@AL00001+28                                  02S0069
         LA    @10,@CF00528                                     02S0069
         ST    @10,@AL00001+32                                  02S0069
         L     @15,@CV00084                                     02S0069
         LA    @01,@AL00001                                     02S0069
         BALR  @14,@15                                          02S0069
*                   IF HWRTCD=DUPCTLG THEN/* PCCB FOUND FOR THE 02S0070
*                                                             STEPCAT*/
         CLC   HWRTCD(2,RTNPREG),@CH00054                       02S0070
         BNE   @RF00070                                         02S0070
*                     DO;           /* INDICATED BY THIS DD          */
*                       HWRETURN=0; /* RESET 'INVALID' RETURN CODE   */
         SLR   @10,@10                                          02S0072
         ST    @10,HWRETURN(,RTNPREG)                           02S0072
*                       SIOTJSCT=OFF;/* ONLY ONE STEPCAT DD ALLOWED  */
         NI    SIOTJSCT(SIOTPTR),B'11111110'                    02S0073
*                       SIOTCATL=OFF;/* TO REPRESENT ONE CATALOG     */
         NI    SIOTCATL(SIOTPTR),B'10111111'                    02S0074
*                     END;                                      02S0075
*                 END;                                          02S0076
*               ELSE                /* ERROR FROM IEFAB454 OR ERROR  */
*                 IF HWRTCD=0 THEN  /* IN THE CATALOG INFORMATION    */
         B     @RC00061                                         02S0077
@RF00061 ICM   @10,3,HWRTCD(RTNPREG)                            02S0077
         BNZ   @RF00077                                         02S0077
*                   DO;             /* DATA SET NOT A PROPER STEPCAT */
*                     HWRTCD=DDERR; /* RETURN CODE - 4               */
         MVC   HWRTCD(2,RTNPREG),@CH00054                       02S0079
*                     HWRSNCD=SCATERR;/* REASON CODE - 76            */
         MVC   HWRSNCD(2,RTNPREG),@CH00059                      02S0080
*                   END;                                        02S0081
*             END;                                              02S0082
*           ELSE                    /* SYNTAX ERROR ON DD STATEMENT  */
*             DO;                                               02S0083
         B     @RC00055                                         02S0083
@RF00055 DS    0H                                               02S0084
*               HWRTCD=DDERR;       /* RETURN CODE - 4               */
         MVC   HWRTCD(2,RTNPREG),@CH00054                       02S0084
*               HWRSNCD=SCATJCL;    /* REASON CODE - 75              */
         MVC   HWRSNCD(2,RTNPREG),@CH00057                      02S0085
*             END;                                              02S0086
*         SIOTPTR=SIOTNPTR;         /* GET NEXT STEPCAT, IF ANY      */
@RC00055 DS    0H                                               02S0087
@RF00054 L     SIOTPTR,SIOTNPTR(,SIOTPTR)                       02S0087
*       END;                        /* STEPCAT PROCESSING LOOP  02S0088
*                                                                    */
         AH    STEPCATS,@CH00043                                02S0088
@DE00050 L     @10,HWSCTP(,DATAPREG)                            02S0088
         SLR   @06,@06                                          02S0088
         ICM   @06,3,SCTCATCT(@10)                              02S0088
         CR    STEPCATS,@06                                     02S0088
         BNH   @DL00050                                         02S0088
@DC00050 DS    0H                                               02S0089
*     END;                          /* END STEPCAT PROCESSING GROUP  */
*   SIOTPTR=FRSTSIOT;               /* MAP FIRST SIOT                */
@RF00041 L     @10,@PC00001+12                                  01S0090
         L     @10,FRSTSIOT(,@10)                               01S0090
         LR    SIOTPTR,@10                                      01S0090
*   SCNSIOTP=FRSTSIOT;              /* GET 1ST SIOT IN CHAIN.        */
         LR    SCNSIOTP,@10                                     01S0091
*   DO WHILE(SCNSIOTP^=0&SCTSTPLB=OFF);/* SCAN DDS IN THIS STEP FOR  */
         B     @DE00092                                         01S0092
@DL00092 DS    0H                                               01S0093
*     IF SCNSIOTP->SCTDDNAM=STEPLIB THEN/* FOR A DDNAME OF STEPLIB,  */
         CLC   SCTDDNAM(8,SCNSIOTP),@CC00061                    01S0093
         BNE   @RF00093                                         01S0093
*       SCTSTPLB=ON;                /* INDICATE IN SCT IF A          */
         L     @10,HWSCTP(,DATAPREG)                            01S0094
         OI    SCTSTPLB(@10),B'00001000'                        01S0094
*     ELSE                          /* STEPLIB IS FOUND.             */
*       SCNSIOTP=SCNSIOTP->SIOTNPTR;/* GET PTR TO NEXT DD.           */
         B     @RC00093                                         01S0095
@RF00093 L     SCNSIOTP,SIOTNPTR(,SCNSIOTP)                     01S0095
*   END;                            /* STEPLIB SCAN END.             */
@RC00093 DS    0H                                               01S0096
@DE00092 LTR   SCNSIOTP,SCNSIOTP                                01S0096
         BZ    @DC00092                                         01S0096
         L     @10,HWSCTP(,DATAPREG)                            01S0096
         TM    SCTSTPLB(@10),B'00001000'                        01S0096
         BZ    @DL00092                                         01S0096
@DC00092 DS    0H                                               01S0097
*   DO WHILE(HWRTCD=0&              /* NO ERRORS OCCURED             */
*         SIOTPTR^=0);              /* THERE IS ANOTHER SIOT         */
         B     @DE00097                                         01S0097
@DL00097 DS    0H                                               01S0098
*     IF SIOTJSCT^=ON THEN          /* DO NOT REPROCESS STEPCATS     */
         TM    SIOTJSCT(SIOTPTR),B'00000001'                    01S0098
         BO    @RF00098                                         01S0098
*       DO;                         /* PROCESS NORMAL DD(S)          */
*         HWCSIOTP=SIOTPTR;         /* UPDATE WORKAREA POINTER       */
         ST    SIOTPTR,HWCSIOTP(,DATAPREG)                      01S0100
*         CALL IEFAB453(HWCNTRLP,HWDATAP,HWRTNP,HWCSIOTP);      01S0101
         L     @10,@PC00001                                     01S0101
         ST    @10,@AL00001                                     01S0101
         L     @10,@PC00001+4                                   01S0101
         ST    @10,@AL00001+4                                   01S0101
         L     @10,@PC00001+8                                   01S0101
         ST    @10,@AL00001+8                                   01S0101
         LA    @10,HWCSIOTP(,DATAPREG)                          01S0101
         ST    @10,@AL00001+12                                  01S0101
         L     @15,@CV00077                                     01S0101
         LA    @01,@AL00001                                     01S0101
         BALR  @14,@15                                          01S0101
*         IF HWDDDONE^=COMPLETE&    /* PROCESSING NOT COMPLETE       */
*             HWRTCD=0 THEN         /* NO ERROR IN DD PREPARATION    */
         L     @10,@PC00001                                     01S0102
         L     @02,HWCNTRLP(,@10)                               01S0102
         TM    HWDDDONE(@02),B'00010000'                        01S0102
         BO    @RF00102                                         01S0102
         ICM   @02,3,HWRTCD(RTNPREG)                            01S0102
         BNZ   @RF00102                                         01S0102
*           CALL IEFAB454(HWCNTRLP,HWDATAP,HWRTNP,HWCSIOTP,HWCJFCBP);
         ST    @10,@AL00001                                     01S0103
         L     @10,@PC00001+4                                   01S0103
         ST    @10,@AL00001+4                                   01S0103
         L     @10,@PC00001+8                                   01S0103
         ST    @10,@AL00001+8                                   01S0103
         LA    @10,HWCSIOTP(,DATAPREG)                          01S0103
         ST    @10,@AL00001+12                                  01S0103
         LA    @10,HWCJFCBP(,DATAPREG)                          01S0103
         ST    @10,@AL00001+16                                  01S0103
         L     @15,@CV00083                                     01S0103
         LA    @01,@AL00001                                     01S0103
         BALR  @14,@15                                          01S0103
*                                   /* DD FUNCTION CONTROL           */
*       END;                                                    01S0104
@RF00102 DS    0H                                               01S0105
*     SIOTPTR=SIOTNPTR;             /* GET NEXT SIOT POINTER         */
@RF00098 L     SIOTPTR,SIOTNPTR(,SIOTPTR)                       01S0105
*   END;                                                        01S0106
@DE00097 SLR   @10,@10                                          01S0106
         CH    @10,HWRTCD(,RTNPREG)                             01S0106
         BNE   @DC00097                                         01S0106
         CR    SIOTPTR,@10                                      01S0106
         BNE   @DL00097                                         01S0106
@DC00097 DS    0H                                               01S0107
*   END IEFAB452                                                01S0107
*                                                               01S0107
*/* THE FOLLOWING INCLUDE STATEMENTS WERE FOUND IN THIS PROGRAM.     */
*/*%INCLUDE SYSUT5  (DDPROCPR)                                       */
*/*%INCLUDE SYSUT5  (DDPROCDC)                                       */
*/*%INCLUDE SYSLIB  (IEFZB436)                                       */
*/*%INCLUDE SYSLIB  (IEFZB437)                                       */
*/*%INCLUDE SYSLIB  (IEFZB450)                                       */
*/*%INCLUDE SYSLIB  (IEFASIOT)                                       */
*/*%INCLUDE SYSLIB  (IEFASCTB)                                       */
*/*%INCLUDE SYSLIB  (IEZJSCB )                                       */
*/*%INCLUDE SYSLIB  (IEFJFCBN)                                       */
*/*%INCLUDE SYSLIB  (IEZCTGPL)                                       */
*/*%INCLUDE SYSLIB  (IEZCTGWA)                                       */
*/*%INCLUDE SYSLIB  (IEZCTGVL)                                       */
*/*%INCLUDE SYSLIB  (IEZCTGCV)                                       */
*/*%INCLUDE SYSUT5  (CATSPEC )                                       */
*/*%INCLUDE SYSUT5  (CATPROC )                                       */
*                                                               01S0107
*       ;                                                       01S0107
@EL00001 IC    @02,@OLDKEY                                      01S0107
         L     @13,4(,@13)                                      01S0107
@EF00001 L     @00,@SIZDATD                                     01S0107
         LR    @01,@11                                          01S0107
         FSPACE   R,LV=(0),A=(1)
         MODESET KEYADDR=(2)
@ER00001 LM    @14,@12,12(@13)                                  01S0107
         BR    @14                                              01S0107
@DATA    DS    0H
@CH00054 DC    H'4'
@CH00057 DC    H'75'
@CH00059 DC    H'76'
@DATD    DSECT
         DS    0F
@SA00001 DS    18F
@PC00001 DS    4F
@AL00001 DS    9A
@TF00001 DS    F
@TF00002 DS    F
IEFAB452 CSECT
         DS    0F
@CF00528 DC    F'0'
@CH00528 EQU   @CF00528+2
@CF00043 DC    F'1'
@CH00043 EQU   @CF00043+2
@DATD    DSECT
         DS    0D
CTGCONP  DS    A
SCAT1    DS    A
SWACTLS  DS    FL2
         ORG   SWACTLS
SWASN    DS    BL1
SWDEL    EQU   SWACTLS+0
SWREAD   EQU   SWACTLS+0
SWWRT    EQU   SWACTLS+0
SWNEW    EQU   SWACTLS+0
SWFREE   EQU   SWACTLS+0
SWMOD    EQU   SWACTLS+0
SWOLD    EQU   SWACTLS+0
SWCHN    DS    BL1
@NM00001 EQU   SWACTLS+1
         ORG   SWACTLS+2
PCCNTRLS DS    FL2
         ORG   PCCNTRLS
PCCMAKE  DS    BL1
PCCFREE  EQU   PCCNTRLS+0
PCCSTPCT EQU   PCCNTRLS+0
PCCFREAL EQU   PCCNTRLS+0
PCCVOL   EQU   PCCNTRLS+0
@NM00012 EQU   PCCNTRLS+0
         ORG   PCCNTRLS+2
@OLDKEY  DS    AL1
IEFAB452 CSECT
         DS    0F
@SIZDATD DC    AL1(230)
         DC    AL3(@ENDDATD-@DATD)
@CV00077 DC    V(IEFAB453)
@CV00083 DC    V(IEFAB454)
@CV00084 DC    V(IEFAB4EF)
@CV00085 DC    V(IEFAB4F7)
         DS    0D
@CC00050 DC    C'        '
@CC00061 DC    C'STEPLIB '
IEFAB452 CSECT
         DS   0H
PATCHLOC DC ((@DATA-@PSTART)/20)X'00'
@DATD    DSECT
         ORG   *+1-(*-@DATD)/(*-@DATD) INSURE DSECT DATA
@ENDDATD EQU   *
IEFAB452 CSECT
@00      EQU   00                      EQUATES FOR REGISTERS 0-15
@01      EQU   01
@02      EQU   02
@03      EQU   03
@04      EQU   04
@05      EQU   05
@06      EQU   06
@07      EQU   07
@08      EQU   08
@09      EQU   09
@10      EQU   10
@11      EQU   11
@12      EQU   12
@13      EQU   13
@14      EQU   14
@15      EQU   15
STEPCATS EQU   @07
DDNUMSAV EQU   @02
SCNSIOTP EQU   @02
ALTDTEMP EQU   @06
DISPTEMP EQU   @02
DATAPREG EQU   @03
RTNPREG  EQU   @04
SIOTPTR  EQU   @05
HWRETURN EQU   0
HWRTCD   EQU   HWRETURN
HWRSNCD  EQU   HWRETURN+2
HWCNTRL  EQU   0
HWNOSCAT EQU   HWCNTRL
HWDSNRQD EQU   HWCNTRL+2
HWDDDONE EQU   HWCNTRL+3
HWTBLCTL EQU   HWCNTRL+6
HWJLCTLS EQU   HWCNTRL+7
HWDATA   EQU   0
HWSCTP   EQU   HWDATA+4
HWJSCBP  EQU   HWDATA+20
HWCRIP   EQU   HWDATA+36
HWCSIOTP EQU   HWDATA+44
HWCJFCBP EQU   HWDATA+48
HWUCLPTR EQU   HWDATA+56
HWLEPARP EQU   HWDATA+60
HWSTPNBR EQU   HWDATA+172
HWUCLST  EQU   0
HWDEV    EQU   0
HWOBYTE  EQU   HWDEV+1
HWCTBYT  EQU   HWDEV+2
INDMSIOT EQU   0
SCTDDNAM EQU   INDMSIOT+4
SCTUSADD EQU   INDMSIOT+20
SIOTBYT1 EQU   INDMSIOT+43
SIOTBYT3 EQU   INDMSIOT+46
SIOTTSTC EQU   INDMSIOT+47
SCTVOLCT EQU   INDMSIOT+49
SIOTBYT0 EQU   INDMSIOT+52
SIOTSSDS EQU   SIOTBYT0
SCTSDISP EQU   INDMSIOT+55
SIOTKEEP EQU   SCTSDISP
SCTSBYT1 EQU   INDMSIOT+56
SCTDUMMY EQU   SCTSBYT1
SCTUNAFF EQU   SCTSBYT1
SIOTJSCT EQU   SCTSBYT1
SCTSBYT2 EQU   INDMSIOT+57
SIOTCATL EQU   SCTSBYT2
SCTVOLAF EQU   SCTSBYT2
SCTDEFER EQU   SCTSBYT2
SCTSBYT3 EQU   INDMSIOT+58
SCTSOLD  EQU   SCTSBYT3
SCTSBYT4 EQU   INDMSIOT+59
SCTSGDGS EQU   SCTSBYT4
SCTUTYPE EQU   INDMSIOT+60
SIOTDEVT EQU   SCTUTYPE
SIOUBYT3 EQU   SIOTDEVT+2
SIOTALTD EQU   INDMSIOT+92
SIOTAKEP EQU   SIOTALTD
SIOTBYT2 EQU   INDMSIOT+103
SIOTGALL EQU   SIOTBYT2
SIOTNPTR EQU   INDMSIOT+152
INSMSCT  EQU   0
SCTSSTAT EQU   INSMSCT+4
SCTSTYPE EQU   INSMSCT+67
SCTPCAT  EQU   INSMSCT+84
SCTSDPTY EQU   INSMSCT+94
SCTSTAT2 EQU   INSMSCT+104
SCTBCT   EQU   SCTSTAT2
SCTSTPLB EQU   SCTBCT
SCTCDENT EQU   INSMSCT+118
SCTCATCT EQU   INSMSCT+166
SCTSTEND EQU   INSMSCT+172
@NM00051 EQU   0
SCTABCND EQU   @NM00051
IEZJSCB  EQU   0
JSCBSEC1 EQU   IEZJSCB+188
JSCHPCE  EQU   JSCBSEC1+4
JSCBDCB  EQU   JSCBSEC1+36
JSCBOPTS EQU   JSCBSEC1+48
JSCBSWT1 EQU   JSCBSEC1+55
JSCBWTP  EQU   JSCBSEC1+64
JSCBWTFG EQU   JSCBWTP
JSCBEND1 EQU   IEZJSCB+260
INFMJFCB EQU   0
JFCBDSNM EQU   INFMJFCB
JFCBELNM EQU   INFMJFCB+44
JFCBTSDM EQU   INFMJFCB+52
JFCFCBID EQU   INFMJFCB+56
JFCBFRID EQU   JFCFCBID
JFCBLTYP EQU   INFMJFCB+66
JFCBOTTR EQU   INFMJFCB+67
JFCBUFOF EQU   JFCBOTTR
JFCBFLSQ EQU   JFCBOTTR+1
JFCFUNC  EQU   JFCBFLSQ
JFCBMASK EQU   INFMJFCB+72
JFCBFLG1 EQU   JFCBMASK+5
JFCOPEN  EQU   JFCBFLG1
JFCBFLG2 EQU   JFCBMASK+6
JFCDEFER EQU   JFCBFLG2
JFCBIND1 EQU   INFMJFCB+86
JFCBIND2 EQU   INFMJFCB+87
JFCAMPTR EQU   INFMJFCB+88
JFCBUFRQ EQU   JFCAMPTR
JFCBUFNO EQU   JFCBUFRQ
JFCBGNCP EQU   JFCAMPTR+1
JFCBHIAR EQU   JFCBGNCP
JFCBFALN EQU   JFCBHIAR
JFCBFTEK EQU   JFCBFALN
JFCBBFTA EQU   JFCBFTEK
JFCEROPT EQU   INFMJFCB+92
JFCTRTCH EQU   INFMJFCB+93
CTGPL    EQU   0
CTGOPTN1 EQU   CTGPL
CTGOPTN2 EQU   CTGPL+1
CTGERASE EQU   CTGOPTN2
CTGSMF   EQU   CTGERASE
CTGREL   EQU   CTGSMF
CTGPURG  EQU   CTGOPTN2
CTGVMNT  EQU   CTGPURG
CTGOPTN3 EQU   CTGPL+2
CTGOPTN4 EQU   CTGPL+3
CTGENT   EQU   CTGPL+4
CTGCAT   EQU   CTGPL+8
CTGCVOL  EQU   CTGCAT
CTGWKA   EQU   CTGPL+12
CTGDSORG EQU   CTGPL+16
CTGDDNM  EQU   CTGPL+20
CTGNEWNM EQU   CTGDDNM
CTGFBFLG EQU   CTGNEWNM+2
CTGJSCB  EQU   CTGPL+24
CTGWA    EQU   0
CTGWAVL  EQU   CTGWA
CTGVL    EQU   0
CTGVLX   EQU   0
CTGCV    EQU   0
CTGCVDSN EQU   CTGCV+6
CTGCVCC  EQU   CTGCV+50
INDMDSNT EQU   0
HWCNTRLP EQU   0
HWDATAP  EQU   0
HWRTNP   EQU   0
FRSTSIOT EQU   0
JSCBSEC2 EQU   JSCBEND1
JSCBSEC3 EQU   JSCBEND1
JSCBJCT  EQU   JSCBSEC3
JSCBJCTA EQU   JSCBJCT+1
JSCBASID EQU   JSCBSEC3+8
JSCBJNL  EQU   JSCBSEC3+28
JSCBJJSB EQU   JSCBJNL
JSCBSUB  EQU   JSCBSEC3+40
JSCSCT   EQU   JSCBSEC3+68
JSCDDNUM EQU   JSCBSEC3+84
JSCBACT  EQU   JSCBSEC3+88
JSCRSV35 EQU   JSCBSEC3+96
JSCRSV36 EQU   JSCRSV35
JSCRSV37 EQU   JSCRSV35+2
JSCRSV45 EQU   JSCBSEC3+112
JSCRSV46 EQU   JSCRSV45
JSCRSV47 EQU   JSCRSV45+2
JFCKEYLE EQU   JFCTRTCH
JFCCODE  EQU   JFCKEYLE
JFCSTACK EQU   JFCTRTCH
JFCMODE  EQU   JFCSTACK
JFCSPPRT EQU   JFCTRTCH
JFCBABFS EQU   JFCSPPRT+2
JFCLIMCT EQU   JFCBABFS
JFCDSORG EQU   JFCSPPRT+5
JFCDSRG1 EQU   JFCDSORG
JFCDSRG2 EQU   JFCDSORG+1
JFCRECFM EQU   JFCSPPRT+7
JFCRCFM  EQU   JFCRECFM
JFCOPTCD EQU   JFCSPPRT+8
JFCWVCSP EQU   JFCOPTCD
JFCWVCIS EQU   JFCWVCSP
JFCWVCBD EQU   JFCWVCIS
JFCALLOW EQU   JFCOPTCD
JFCRSV17 EQU   JFCALLOW
JFCOVER  EQU   JFCRSV17
JFCPCIBT EQU   JFCOPTCD
JFCMAST  EQU   JFCPCIBT
JFCEXT   EQU   JFCMAST
JFCBCKPT EQU   JFCOPTCD
JFCIND   EQU   JFCBCKPT
JFCRSV18 EQU   JFCOPTCD
JFCCYL   EQU   JFCRSV18
JFCACT   EQU   JFCCYL
JFCREDUC EQU   JFCOPTCD
JFCRSV19 EQU   JFCREDUC
JFCRSV20 EQU   JFCRSV19
JFCRSV21 EQU   JFCOPTCD
JFCDEL   EQU   JFCRSV21
JFCRSV23 EQU   JFCOPTCD
JFCREORG EQU   JFCRSV23
JFCBLKSI EQU   JFCSPPRT+9
JFCBUFSI EQU   JFCBLKSI
JFCAMSYN EQU   JFCSPPRT+11
JFCNCP   EQU   JFCAMSYN+2
JFCNTM   EQU   JFCAMSYN+3
JFCBFSEQ EQU   JFCNTM
JFCPCI   EQU   JFCBFSEQ
JFCRESRV EQU   JFCAMSYN+4
JFCUCSEG EQU   JFCRESRV
JFCUCSOP EQU   JFCUCSEG+4
JFCOUTLI EQU   JFCUCSEG+5
JFCTHRSH EQU   JFCOUTLI
JFCCPRI  EQU   JFCTHRSH
JFCBNVOL EQU   JFCUCSEG+9
JFCBVOLS EQU   JFCUCSEG+10
JFCBPQTY EQU   JFCUCSEG+44
JFCBCTRI EQU   JFCUCSEG+47
JFCBSQTY EQU   JFCUCSEG+48
JFCBIND3 EQU   JFCBSQTY+2
JFCFLGS1 EQU   JFCUCSEG+51
         AGO   .@UNREFD                START UNREFERENCED COMPONENTS
JFCBEND  EQU   JFCUCSEG+68
JFCBSPTN EQU   JFCUCSEG+67
JFCBVLCT EQU   JFCUCSEG+66
JFCBDRLH EQU   JFCUCSEG+63
JFCBSBNM EQU   JFCUCSEG+60
JFCBABST EQU   JFCUCSEG+58
JFCBSPNM EQU   JFCUCSEG+55
JFCBDQTY EQU   JFCUCSEG+52
JFCBUAFF EQU   JFCFLGS1
JFCRSV45 EQU   JFCFLGS1
JFCVRDS  EQU   JFCFLGS1
JFCRSV43 EQU   JFCFLGS1
JFCRSV42 EQU   JFCFLGS1
JFCRSV41 EQU   JFCFLGS1
JFCTOPEN EQU   JFCFLGS1
JFCRSV39 EQU   JFCFLGS1
JFCRSV52 EQU   JFCBIND3
JFCRSV51 EQU   JFCBIND3
JFCRSV50 EQU   JFCBIND3
JFCRSV49 EQU   JFCBIND3
JFCRSV48 EQU   JFCBIND3
JFCRSV47 EQU   JFCBIND3
JFCRSV46 EQU   JFCBIND3
JFCBDLET EQU   JFCBIND3
JFCRQID  EQU   JFCBSQTY
JFCROUND EQU   JFCBCTRI
JFCALX   EQU   JFCBCTRI
JFCMIXG  EQU   JFCBCTRI
JFCONTIG EQU   JFCBCTRI
JFCRSV29 EQU   JFCBCTRI
JFCRSV28 EQU   JFCBCTRI
JFCBSPAC EQU   JFCBCTRI
JFCRUNIT EQU   JFCBPQTY
JFCBEXAD EQU   JFCUCSEG+41
JFCBEXTL EQU   JFCUCSEG+40
JFCAVOLS EQU   JFCBVOLS
JFCBNTCS EQU   JFCUCSEG+8
JFCSOWA  EQU   JFCOUTLI+1
JFCSEND  EQU   JFCCPRI
JFCEQUAL EQU   JFCCPRI
JFCRECV  EQU   JFCCPRI
JFCRSV34 EQU   JFCCPRI
JFCRSV33 EQU   JFCCPRI
JFCRSV55 EQU   JFCCPRI
JFCRSV54 EQU   JFCCPRI
JFCRSV53 EQU   JFCCPRI
JFCRSV27 EQU   JFCUCSOP
JFCRSV26 EQU   JFCUCSOP
JFCFCBVR EQU   JFCUCSOP
JFCFCBAL EQU   JFCUCSOP
JFCVER   EQU   JFCUCSOP
JFCRSV25 EQU   JFCUCSOP
JFCFOLD  EQU   JFCUCSOP
JFCRSV24 EQU   JFCUCSOP
JFCUCSID EQU   JFCUCSEG
JFCINTVL EQU   JFCSPPRT+19
JFCDBUFN EQU   JFCRESRV+3
JFCCYLOF EQU   JFCRESRV+2
JFCRKP   EQU   JFCRESRV
JFCPCIR2 EQU   JFCPCI
JFCPCIR1 EQU   JFCPCI
JFCPCIN2 EQU   JFCPCI
JFCPCIN1 EQU   JFCPCI
JFCPCIA2 EQU   JFCPCI
JFCPCIA1 EQU   JFCPCI
JFCPCIX2 EQU   JFCPCI
JFCPCIX1 EQU   JFCPCI
JFCBUFMX EQU   JFCNCP
JFCLRECL EQU   JFCAMSYN
JFCBAXBF EQU   JFCBUFSI
JFCREL   EQU   JFCREORG
JFCRSV22 EQU   JFCDEL
JFCSRCHD EQU   JFCRSV20
JFCOPTQ  EQU   JFCACT
JFCFEED  EQU   JFCIND
JFCCBWU  EQU   JFCEXT
JFCWUMSG EQU   JFCOVER
JFCSDNAM EQU   JFCWVCBD
@NM00060 EQU   JFCRECFM
JFCCHAR  EQU   JFCRECFM
JFCRFS   EQU   JFCRECFM
JFCRFB   EQU   JFCRECFM
JFCRFO   EQU   JFCRCFM
JFCFMREC EQU   JFCRCFM
JFCRSV16 EQU   JFCDSRG2
JFCRSV15 EQU   JFCDSRG2
JFCORGTR EQU   JFCDSRG2
JFCORGAM EQU   JFCDSRG2
JFCRSV13 EQU   JFCDSRG2
JFCORGTQ EQU   JFCDSRG2
JFCORGTX EQU   JFCDSRG2
JFCORGGS EQU   JFCDSRG2
JFCORGU  EQU   JFCDSRG1
JFCORGPO EQU   JFCDSRG1
JFCORGMQ EQU   JFCDSRG1
JFCORGCQ EQU   JFCDSRG1
JFCORGCX EQU   JFCDSRG1
JFCORGDA EQU   JFCDSRG1
JFCORGPS EQU   JFCDSRG1
JFCORGIS EQU   JFCDSRG1
JFCTRKBL EQU   JFCLIMCT+1
@NM00059 EQU   JFCLIMCT
JFCDEN   EQU   JFCSPPRT+1
JFCPRTSP EQU   JFCSPPRT
JFCONE   EQU   JFCMODE
JFCTWO   EQU   JFCMODE
JFCRSV07 EQU   JFCMODE
JFCRSV06 EQU   JFCMODE
JFCMODER EQU   JFCMODE
JFCMODEO EQU   JFCMODE
JFCEBCD  EQU   JFCMODE
JFCBIN   EQU   JFCMODE
JFCRSV32 EQU   JFCCODE
JFCTTY   EQU   JFCCODE
JFCASCII EQU   JFCCODE
JFCNCR   EQU   JFCCODE
JFCBUR   EQU   JFCCODE
JFCFRI   EQU   JFCCODE
JFCBCD   EQU   JFCCODE
JFCNOCON EQU   JFCCODE
JSCBEND3 EQU   JSCBSEC3+120
JSCRSV52 EQU   JSCBSEC3+116
JSCRSV51 EQU   JSCRSV47+1
JSCRSV50 EQU   JSCRSV47
JSCRSV49 EQU   JSCRSV46+1
JSCRSV48 EQU   JSCRSV46
JSCRSV44 EQU   JSCBSEC3+108
JSCRSV43 EQU   JSCBSEC3+104
JSCRSV42 EQU   JSCBSEC3+100
JSCRSV41 EQU   JSCRSV37+1
JSCRSV40 EQU   JSCRSV37
JSCRSV39 EQU   JSCRSV36+1
JSCRSV38 EQU   JSCRSV36
JSCBUFPT EQU   JSCBSEC3+92
JSCBSWSP EQU   JSCBSEC3+87
JSCRSV33 EQU   JSCBSEC3+86
JSCRSV53 EQU   JSCBSEC3+82
JSCDDNNO EQU   JSCBSEC3+80
JSCBVATA EQU   JSCBSEC3+76
JSCTMCOR EQU   JSCBSEC3+72
JSCSCTP  EQU   JSCSCT+1
JSCRSV55 EQU   JSCSCT
JSCRSV54 EQU   JSCBSEC3+64
JSCDSABQ EQU   JSCBSEC3+60
JSCBSSIB EQU   JSCBSEC3+56
JSCRSV30 EQU   JSCBSEC3+52
JSCRSV29 EQU   JSCBSEC3+48
JSCRSV28 EQU   JSCBSEC3+46
JSCBSONO EQU   JSCBSEC3+44
JSCBSUBA EQU   JSCBSUB+1
JSCRSV31 EQU   JSCBSUB
JSCBSMLR EQU   JSCBSEC3+36
JSCBJNLR EQU   JSCBSEC3+32
JSCBJNLA EQU   JSCBJNL+1
JSCBJSBT EQU   JSCBJJSB
JSCBJSBX EQU   JSCBJJSB
JSCBJSBA EQU   JSCBJJSB
JSCBJSBI EQU   JSCBJJSB
@NM00057 EQU   JSCBJJSB
JSCBJNLE EQU   JSCBJJSB
JSCBJNLF EQU   JSCBJJSB
JSCBJNLN EQU   JSCBJJSB
@NM00056 EQU   JSCBSEC3+24
JSCRSV27 EQU   JSCBSEC3+20
JSCRSV26 EQU   JSCBSEC3+16
JSCBIECB EQU   JSCBSEC3+12
JSCRSV25 EQU   JSCBSEC3+10
JSCBTJID EQU   JSCBASID
JSCBPSCB EQU   JSCBSEC3+4
JSCJCTP  EQU   JSCBJCTA
JSCRSV24 EQU   JSCBJCT
JSCBEND2 EQU   JSCBSEC2
CTGCVDEV EQU   CTGCVDSN
CTGCVVOL EQU   CTGCV
CTGVLTTR EQU   CTGVLX+12
@NM00065 EQU   CTGVLX
CTGVLSEQ EQU   CTGVL+10
CTGVLDEV EQU   CTGVL+6
CTGVLVOL EQU   CTGVL
CTGWAGB  EQU   CTGWA+12
CTGWAGCT EQU   CTGWA+10
CTGWAUCT EQU   CTGWA+8
CTGWAVCT EQU   CTGWA+6
CTGWALV  EQU   CTGWA+4
CTGFIELD EQU   CTGPL+28
CTGPSWD  EQU   CTGJSCB
@NM00064 EQU   CTGFBFLG
CTGNGDSN EQU   CTGFBFLG
CTGGDGB  EQU   CTGFBFLG
CTGKEEP  EQU   CTGFBFLG
CTGPAR   EQU   CTGFBFLG
CTGFDBK  EQU   CTGNEWNM
CTGNOFLD EQU   CTGPL+19
CTGTYPE  EQU   CTGPL+18
@NM00063 EQU   CTGDSORG
CTGOPTNS EQU   CTGDSORG
CTGFVT   EQU   CTGENT
@NM00062 EQU   CTGOPTN4
CTGDOCAT EQU   CTGOPTN4
CTGLBASE EQU   CTGOPTN4
CTGAM0   EQU   CTGOPTN3
CTGNUM   EQU   CTGOPTN3
CTGSRH   EQU   CTGOPTN3
CTGGDGL  EQU   CTGOPTN3
CTGSUPLT EQU   CTGOPTN3
CTGFUNC  EQU   CTGOPTN3
@NM00061 EQU   CTGOPTN2
CTGSCR   EQU   CTGOPTN2
CTGOVRID EQU   CTGOPTN2
CTGDISC  EQU   CTGOPTN2
CTGGTNXT EQU   CTGOPTN2
CTGRCATN EQU   CTGVMNT
CTGGTALL EQU   CTGREL
CTGEXT   EQU   CTGOPTN2
CTGGENLD EQU   CTGOPTN1
CTGCNAME EQU   CTGOPTN1
CTGNAME  EQU   CTGOPTN1
CTGREAD  EQU   CTGOPTN1
CTGUPD   EQU   CTGOPTN1
CTGCI    EQU   CTGOPTN1
CTGMAST  EQU   CTGOPTN1
CTGBYPSS EQU   CTGOPTN1
JFCRSV05 EQU   JFCEROPT
JFCRSV04 EQU   JFCEROPT
JFCRSV03 EQU   JFCEROPT
JFCRSV02 EQU   JFCEROPT
JFCTOPT  EQU   JFCEROPT
JFCABN   EQU   JFCEROPT
JFCSKP   EQU   JFCEROPT
JFCACC   EQU   JFCEROPT
JFCBUFL  EQU   JFCAMPTR+2
JFCFWORD EQU   JFCBFTEK
JFCDWORD EQU   JFCBFTEK
JFCHIER1 EQU   JFCBFTEK
JFCDYN   EQU   JFCBFTEK
JFCEXC   EQU   JFCBFTEK
JFCBBFTR EQU   JFCBBFTA
JFCSIM   EQU   JFCBBFTA
JFCHIER  EQU   JFCBFTEK
JFCBFOUT EQU   JFCBUFNO
JFCBUFIN EQU   JFCBUFNO
JFCTEMP  EQU   JFCBIND2
JFCREQ   EQU   JFCBIND2
JFCENT   EQU   JFCBIND2
JFCSHARE EQU   JFCBIND2
JFCSECUR EQU   JFCBIND2
JFCDISP  EQU   JFCBIND2
JFCPDS   EQU   JFCBIND1
JFCGDG   EQU   JFCBIND1
JFCADDED EQU   JFCBIND1
JFCLOC   EQU   JFCBIND1
JFCRLSE  EQU   JFCBIND1
JFCBXPDT EQU   INFMJFCB+83
JFCBCRDT EQU   INFMJFCB+80
JFCBOPS2 EQU   JFCBMASK+7
JFCRCTLG EQU   JFCBFLG2
JFCBBUFF EQU   JFCBFLG2
JFCTRACE EQU   JFCBFLG2
JFCSDRPS EQU   JFCBFLG2
JFCMODNW EQU   JFCBFLG2
JFCNRPS  EQU   JFCDEFER
JFCOUTOP EQU   JFCBFLG2
JFCINOP  EQU   JFCBFLG2
JFCBPWBP EQU   JFCOPEN
@NM00058 EQU   JFCOPEN
JFCDUAL  EQU   JFCBFLG1
JFCSLDES EQU   JFCBFLG1
JFCSLCRE EQU   JFCBFLG1
JFCSTAND EQU   JFCBFLG1
JFCBOPS1 EQU   JFCBMASK
JFCBVLSQ EQU   INFMJFCB+70
JFCRSV31 EQU   JFCFUNC
JFCFNCBT EQU   JFCFUNC
JFCFNCBX EQU   JFCFUNC
JFCFNCBD EQU   JFCFUNC
JFCFNCBW EQU   JFCFUNC
JFCFNCBP EQU   JFCFUNC
JFCFNCBR EQU   JFCFUNC
JFCFNCBI EQU   JFCFUNC
JFCBFOFL EQU   JFCBUFOF
JFCNL    EQU   JFCBLTYP
JFCSL    EQU   JFCBLTYP
JFCNSL   EQU   JFCBLTYP
JFCSUL   EQU   JFCBLTYP
JFCBLP   EQU   JFCBLTYP
JFCBLTM  EQU   JFCBLTYP
JFCBAL   EQU   JFCBLTYP
JFCRSV38 EQU   JFCBLTYP
JFCRSV01 EQU   INFMJFCB+64
JFCNLREC EQU   INFMJFCB+62
JFCBADBF EQU   INFMJFCB+60
JFCAMSTR EQU   JFCBFRID+2
JFCAMCRO EQU   JFCBFRID
JFCBDSCB EQU   INFMJFCB+53
JFCPAT   EQU   JFCBTSDM
JFCNDCB  EQU   JFCBTSDM
JFCNDSCB EQU   JFCBTSDM
JFCNWRIT EQU   JFCBTSDM
JFCTTR   EQU   JFCBTSDM
JFCSDS   EQU   JFCBTSDM
JFCVSL   EQU   JFCBTSDM
JFCCAT   EQU   JFCBTSDM
JFCIPLTX EQU   JFCBELNM
JFCBQNAM EQU   JFCBDSNM
JSCBCSCB EQU   JSCBSEC1+68
JSCBPMG  EQU   JSCBWTP+2
JSCBWTSP EQU   JSCBWTP+1
JSCRSV23 EQU   JSCBWTFG
JSCRSV22 EQU   JSCBWTFG
JSCRSV21 EQU   JSCBWTFG
JSCRSV20 EQU   JSCBWTFG
JSCRSV19 EQU   JSCBWTFG
JSCRSV18 EQU   JSCBWTFG
JSCBRET  EQU   JSCBWTFG
JSCBIOFG EQU   JSCBWTFG
@NM00055 EQU   JSCBSEC1+60
JSCBQMPI EQU   JSCBSEC1+56
JSCBPMSG EQU   JSCBSWT1
JSCRSV16 EQU   JSCBSWT1
JSCRSV15 EQU   JSCBSWT1
JSCRSV14 EQU   JSCBSWT1
JSCRSV13 EQU   JSCBSWT1
JSCRSV12 EQU   JSCBSWT1
JSCRSV11 EQU   JSCBSWT1
JSCBPASS EQU   JSCBSWT1
JSCBTTTR EQU   JSCBSEC1+52
JSCRSV10 EQU   JSCBSEC1+49
JSCBAUTH EQU   JSCBOPTS
JSCSIOTS EQU   JSCBOPTS
JSCRSV08 EQU   JSCBOPTS
JSCRSV07 EQU   JSCBOPTS
JSCRSV06 EQU   JSCBOPTS
JSCBLONG EQU   JSCBOPTS
JSCRSV05 EQU   JSCBOPTS
JSCRSV04 EQU   JSCBOPTS
JSCBSECB EQU   JSCBSEC1+44
JSCRSV03 EQU   JSCBSEC1+41
JSCBSTEP EQU   JSCBSEC1+40
JSCBDCBA EQU   JSCBDCB+1
JSCRSV02 EQU   JSCBDCB
JSCBID   EQU   JSCBSEC1+32
JSCBDBTB EQU   JSCBSEC1+28
JSCBIJSC EQU   JSCBSEC1+24
JSCBTCBP EQU   JSCBSEC1+20
JSCBPCC  EQU   JSCBSEC1+16
JSCBTCP  EQU   JSCBSEC1+12
JSCBSHR  EQU   JSCBSEC1+8
JSCHPCEA EQU   JSCHPCE+1
JSCRSV32 EQU   JSCHPCE
JSCRSV01 EQU   JSCBSEC1
@NM00054 EQU   IEZJSCB
@NM00053 EQU   @NM00051+1
SCTONLY  EQU   SCTABCND
SCTEVEN  EQU   SCTABCND
SCTABEND EQU   SCTABCND
SCTONLYC EQU   SCTABCND
SCTABCAN EQU   SCTABCND
@NM00052 EQU   SCTABCND
@NM00050 EQU   INSMSCT+173
@NM00049 EQU   SCTSTEND
SCTSYSCK EQU   SCTSTEND
SCTSTPND EQU   SCTSTEND
SCTSTSRT EQU   SCTSTEND
@NM00048 EQU   INSMSCT+168
SCTSDPSA EQU   SCTCDENT+3
SCTSDPOP EQU   SCTCDENT+2
SCTSDPCD EQU   SCTCDENT
@NM00047 EQU   INSMSCT+117
SCTPRFMF EQU   INSMSCT+116
SCTPGMNM EQU   INSMSCT+108
SCTTIOT  EQU   INSMSCT+105
@NM00046 EQU   SCTBCT
SCTJBEND EQU   SCTBCT
SCTSPSYS EQU   SCTBCT
@NM00045 EQU   SCTBCT
SCTMCVOL EQU   SCTBCT
@NM00044 EQU   SCTBCT
SCTGOTTR EQU   INSMSCT+100
SCTSMF   EQU   INSMSCT+96
@NM00043 EQU   SCTSDPTY+1
SCTSDP   EQU   SCTSDPTY
SCTFSTEP EQU   SCTSDPTY
@NM00042 EQU   SCTSDPTY
@NM00041 EQU   SCTSDPTY
SCTNIUSL EQU   INSMSCT+92
@NM00040 EQU   INSMSCT+90
SCTMSSZE EQU   INSMSCT+88
SCTLDSTB EQU   INSMSCT+80
SCTSRBT  EQU   INSMSCT+76
SCTMSADR EQU   INSMSCT+72
@NM00039 EQU   INSMSCT+71
SCTXBTTR EQU   INSMSCT+68
SCTJSCAT EQU   SCTSTYPE
SCTINITB EQU   SCTSTYPE
SCTSJFHK EQU   SCTSTYPE
SCTOUTMC EQU   SCTSTYPE
SCTINPUT EQU   SCTSTYPE
SCTGOSTP EQU   SCTSTYPE
@NM00038 EQU   INSMSCT+66
SCTNSMSG EQU   INSMSCT+65
SCTSNUMB EQU   INSMSCT+64
@NM00037 EQU   INSMSCT+62
SCTRPACT EQU   INSMSCT+60
SCTSNAME EQU   INSMSCT+52
SCTSCLPC EQU   INSMSCT+44
@NM00036 EQU   INSMSCT+43
SCTADSTB EQU   INSMSCT+40
@NM00035 EQU   INSMSCT+36
@NM00034 EQU   INSMSCT+35
SCTAFACT EQU   INSMSCT+32
SCTDDNT  EQU   INSMSCT+28
@NM00033 EQU   INSMSCT+27
SCTLSIOT EQU   INSMSCT+24
@NM00032 EQU   INSMSCT+23
SCTANSCT EQU   INSMSCT+20
@NM00031 EQU   INSMSCT+19
SCTAALOC EQU   INSMSCT+16
@NM00030 EQU   INSMSCT+15
SCTFSIOT EQU   INSMSCT+12
SCTLALOC EQU   INSMSCT+10
SCTSEXEC EQU   INSMSCT+8
SCTSTIME EQU   INSMSCT+5
INCMSSTS EQU   SCTSSTAT
SCTGRPH  EQU   SCTSSTAT
SCTKEY0  EQU   SCTSSTAT
SCTDORST EQU   SCTSSTAT
SCTNOCKP EQU   SCTSSTAT
SCTNORST EQU   SCTSSTAT
EACAUSER EQU   SCTSSTAT
EAADDRBT EQU   SCTSSTAT
SCTTBLID EQU   INSMSCT+3
SCTDISKA EQU   INSMSCT
SIODDSNL EQU   INDMSIOT+173
SIOVDSNL EQU   INDMSIOT+172
SIOVDSNT EQU   INDMSIOT+170
SVOLUNNO EQU   INDMSIOT+168
SIOTVMVP EQU   INDMSIOT+164
SIOTJFX  EQU   INDMSIOT+160
SJFCBPTR EQU   INDMSIOT+156
SIOTETIO EQU   INDMSIOT+148
SIOTATE  EQU   INDMSIOT+144
SVOLUNAD EQU   INDMSIOT+140
SIOTEDLP EQU   INDMSIOT+136
SIOTEDLS EQU   INDMSIOT+132
SIOTRSNC EQU   INDMSIOT+130
SCTANAME EQU   INDMSIOT+122
@NM00029 EQU   INDMSIOT+108
SIOTSSNM EQU   INDMSIOT+104
SIODDQCR EQU   SIOTBYT2
SIOVDQCR EQU   SIOTBYT2
SIOTCVOL EQU   SIOTBYT2
SIOTCNEW EQU   SIOTBYT2
SIOTCALC EQU   SIOTBYT2
SIOTDSPD EQU   SIOTBYT2
SIOTDMND EQU   SIOTBYT2
SIOTOPUC EQU   INDMSIOT+99
SIOTOUTR EQU   INDMSIOT+97
SIOTOUTC EQU   INDMSIOT+96
@NM00028 EQU   INDMSIOT+93
SIOTAUNC EQU   SIOTALTD
SIOTACAT EQU   SIOTALTD
SIOTADEL EQU   SIOTALTD
SIOTNPRV EQU   SIOTALTD
SIOJCATS EQU   SIOTALTD
@NM00027 EQU   SIOTALTD
@NM00026 EQU   SIOTALTD
@NM00025 EQU   INDMSIOT+91
SIOTNDSB EQU   INDMSIOT+88
@NM00024 EQU   INDMSIOT+84
SIOTDPCD EQU   INDMSIOT+82
@NM00023 EQU   INDMSIOT+81
SCTOUTPN EQU   INDMSIOT+80
SCTOUTNO EQU   INDMSIOT+76
SCTOUTNM EQU   INDMSIOT+68
SIOUCBAD EQU   SCTUTYPE+5
SIOUCNVT EQU   SCTUTYPE+4
SIOUBYT4 EQU   SIOTDEVT+3
@NM00022 EQU   SIOUBYT3
SIO3UREC EQU   SIOUBYT3
SIO3DISP EQU   SIOUBYT3
SIO3DACC EQU   SIOUBYT3
SIO3COMM EQU   SIOUBYT3
SIO3TAPE EQU   SIOUBYT3
SIOUBYT2 EQU   SIOTDEVT+1
SIOUBYT1 EQU   SIOTDEVT
SIOTOMN  EQU   SCTSBYT4
SIOTIPDI EQU   SCTSBYT4
SIOTVAFF EQU   SCTSBYT4
SIOTSTEP EQU   SCTSBYT4
SIOTASCI EQU   SCTSBYT4
@NM00021 EQU   SCTSBYT4
SIOTGDGA EQU   SCTSBYT4
SCTSMOD  EQU   SCTSBYT3
SCTSNEW  EQU   SCTSBYT3
SCTSYSOU EQU   SCTSBYT3
SCTVREF  EQU   SCTSBYT3
@NM00020 EQU   SCTSBYT3
SCTSYSNE EQU   SCTSBYT3
SCTDSNRF EQU   SCTSBYT3
SCTRECVD EQU   SCTSBYT2
SCTLABEL EQU   SCTSBYT2
SCTUNLBD EQU   SCTSBYT2
SCTJOBLB EQU   SCTSBYT2
SIOCLUNL EQU   SCTSBYT2
SCTPARLM EQU   SCTSBYT1
SIOTQDSN EQU   SCTSBYT1
SIOTGDSN EQU   SCTSBYT1
SIOTCCAT EQU   SCTSBYT1
SCTSYSIN EQU   SCTSBYT1
SIOTUNCT EQU   SCTSDISP
SIOTCTLG EQU   SCTSDISP
SIOTDLET EQU   SCTSDISP
SIOTPASS EQU   SCTSDISP
SIOTPRIV EQU   SCTSDISP
S3400DSP EQU   SCTSDISP
@NM00019 EQU   SCTSDISP
SIOTVLCT EQU   INDMSIOT+54
SCTNMBUT EQU   INDMSIOT+53
SIOTRTRY EQU   SIOTBYT0
SIOTPUPV EQU   SIOTBYT0
SIOTNOPV EQU   SIOTBYT0
SIOTGIGN EQU   SIOTBYT0
SPVTAMSG EQU   SIOTBYT0
SIOTFUDA EQU   SIOTBYT0
SIOTDYAL EQU   SIOTBYT0
SIOTGIID EQU   INDMSIOT+50
SCTSPOOL EQU   INDMSIOT+48
SIOTQNAM EQU   SIOTTSTC
@NM00018 EQU   SIOTTSTC
SIOTTERM EQU   SIOTTSTC
@NM00017 EQU   SIOTTSTC
@NM00016 EQU   SIOTBYT3
SIOTJES3 EQU   SIOTBYT3
SIOCDEVT EQU   SIOTBYT3
SIOALIAS EQU   SIOTBYT3
SCTDDINO EQU   INDMSIOT+44
SIOTDDNT EQU   SIOTBYT1
SIOTALCD EQU   SIOTBYT1
SIODADSM EQU   SIOTBYT1
SIOTDADR EQU   SIOTBYT1
SIODUNAL EQU   SIOTBYT1
SIOVAMDS EQU   SIOTBYT1
SIOTHOLD EQU   SIOTBYT1
SIOTOCKP EQU   SIOTBYT1
SIOPSCNT EQU   INDMSIOT+42
SIOTREFN EQU   INDMSIOT+40
SIOTOTUN EQU   INDMSIOT+39
SIOTVRSB EQU   INDMSIOT+36
@NM00015 EQU   INDMSIOT+35
SCTPJFCB EQU   INDMSIOT+32
@NM00014 EQU   INDMSIOT+31
SCTPSIOT EQU   INDMSIOT+28
SIOTAFID EQU   INDMSIOT+26
@NM00013 EQU   INDMSIOT+24
SIODSNTE EQU   INDMSIOT+22
SIOTUNAF EQU   SCTUSADD
SIOTDEST EQU   INDMSIOT+12
SIOTTYPE EQU   INDMSIOT+3
SIOTDSKA EQU   INDMSIOT
HWTYPE   EQU   HWCTBYT+1
@NM00011 EQU   HWCTBYT
HWDA     EQU   HWCTBYT
@NM00010 EQU   HWCTBYT
HWTAPE   EQU   HWCTBYT
HW7TRK   EQU   HWOBYTE
HWMBYTE  EQU   HWDEV
HWUCBP   EQU   HWUCLST+8
HWDEVTYP EQU   HWUCLST+4
HWEDTLUV EQU   HWUCLST
HWRSVCHR EQU   HWDATA+954
HWCRI    EQU   HWDATA+220
HWDSNAME EQU   HWDATA+176
HWDSNLN  EQU   HWDATA+174
HWSTEPNO EQU   HWSTPNBR+1
@NM00009 EQU   HWSTPNBR
HWGETLN  EQU   HWDATA+168
HWGETSPN EQU   HWDATA+164
HWRSVPTR EQU   HWDATA+80
HWDSENQP EQU   HWDATA+76
HWRPDIEP EQU   HWDATA+72
HWLPDIBP EQU   HWDATA+68
HWGDGBSP EQU   HWDATA+64
HWGETADD EQU   HWDATA+52
HWRSIOTP EQU   HWDATA+40
HWIOSLTP EQU   HWDATA+32
HWGDGNTP EQU   HWDATA+28
HWPDIP   EQU   HWDATA+24
HWGEPACP EQU   HWDATA+16
HWLEPAP  EQU   HWDATA+12
HWFSIOTP EQU   HWDATA+8
HWJCTP   EQU   HWDATA
@NM00008 EQU   HWCNTRL+14
HWDDCTR  EQU   HWCNTRL+12
HWDDSTEP EQU   HWCNTRL+10
@NM00007 EQU   HWCNTRL+9
@NM00006 EQU   HWJLCTLS+1
HWDOMOD  EQU   HWJLCTLS+1
HWVSAME  EQU   HWJLCTLS
HWLOCCAT EQU   HWJLCTLS
HWGDGSLC EQU   HWJLCTLS
HWLBASEL EQU   HWJLCTLS
@NM00005 EQU   HWJLCTLS
HWSYSLOC EQU   HWJLCTLS
HWPDIEDL EQU   HWJLCTLS
HWPDISCN EQU   HWJLCTLS
@NM00004 EQU   HWTBLCTL
HWCOPYAF EQU   HWTBLCTL
HWTBCOPY EQU   HWTBLCTL
@NM00003 EQU   HWCNTRL+3
HWCATINT EQU   HWCNTRL+3
HWNEWVL  EQU   HWCNTRL+3
HWOVRDN  EQU   HWCNTRL+3
HWVAME   EQU   HWCNTRL+3
HWEDT    EQU   HWCNTRL+3
HWUCB    EQU   HWCNTRL+2
HWOVCAND EQU   HWCNTRL+2
HWDSNCAT EQU   HWCNTRL+2
HWRESIOT EQU   HWCNTRL+2
HWGDGALL EQU   HWCNTRL+2
HWVUREC  EQU   HWCNTRL+2
HWDSNREC EQU   HWCNTRL+2
@NM00002 EQU   HWCNTRL+1
HWDSAUTH EQU   HWCNTRL+1
HWNODSI  EQU   HWCNTRL+1
HWEPAJCT EQU   HWCNTRL+1
HWCAJSCB EQU   HWCNTRL+1
HWDENQT  EQU   HWCNTRL+1
HWOFFDEV EQU   HWCNTRL+1
HWWVOLS  EQU   HWCNTRL
HWDNCCDD EQU   HWCNTRL
HWUNLCCT EQU   HWCNTRL
HWWAITOK EQU   HWCNTRL
HWMNTCAT EQU   HWCNTRL
HWNOULSP EQU   HWCNTRL
HWDOPDI  EQU   HWCNTRL
.@UNREFD ANOP                          END UNREFERENCED COMPONENTS
@RF00077 EQU   @RC00055
@RC00061 EQU   @RC00055
@RF00070 EQU   @RC00061
@ENDDATA EQU   *
         END   IEFAB452
