         TITLE 'IEFAB480 - COVER/REDUCE                                *
                        '
IEFAB480 CSECT ,                                                01S0001
@MAINENT DS    0H                                               01S0001
         USING *,@15                                            01S0001
         B     @PROLOG                                          01S0001
         DC    AL1(16)                                          01S0001
         DC    C'IEFAB480  74.212'                              01S0001
         DROP  @15
@PROLOG  STM   @14,@12,12(@13)                                  01S0001
         BALR  @12,0                                            01S0001
@PSTART  DS    0H                                               01S0001
         USING @PSTART,@12                                      01S0001
         L     @00,@SIZDATD                                     01S0001
         MODESET EXTKEY=SCHED,SAVEKEY=(2)
         GSPACE   R,LV=(0)
         LR    @11,@01                                          01S0001
         USING @DATD,@11                                        01S0001
         ST    @13,@SA00001+4                                   01S0001
         STC   @02,@OLDKEY                                      01S0001
         MODESET KEYADDR=(2)
         LM    @00,@02,20(@13)                                  01S0001
         ST    @11,8(,@13)                                      01S0001
         LR    @13,@11                                          01S0001
         MODESET EXTKEY=ZERO
         MVC   @PC00001(4),0(@01)                               01S0001
         MODESET EXTKEY=SCHED
*   PARMPTR=PARMPTR2;               /* COPY PARM TO LOCAL VARIABLE TO
*                                      IMPROVE PERFORMANCE           */
*                                                               01S0049
         L     @08,@PC00001                                     01S0049
         L     PARMPTR,PARMPTR2(,@08)                           01S0049
*   /*****************************************************************/
*   /*                                                               */
*   /* CHECK VALIDITY OF FLAGS                                       */
*   /*                                                               */
*   /*****************************************************************/
*                                                               01S0050
*   RCODE=NOERROR;                  /* INITIALIZE RCODE TO SUCCESSFUL*/
         SLR   @04,@04                                          01S0050
         LR    RCODE,@04                                        01S0050
*                                                               02S0051
*/********************************************************************/
*/*                                                                  */
*/* SEGMENT NAME - CHKPARM                                           */
*/*                                                                  */
*/* DESCRIPTIVE NAME - VALIDATE PARAMETER                            */
*/*                                                                  */
*/* FUNCTION - TO CHECK PARAMETER FLAGS FOR CONSISTENCY              */
*/*                                                                  */
*/* OPERATION - A COUNT IS KEPT OF THE NUMBER OF FLAGS ON.  AT THE   */
*/*            END, THE COUNT IS CHECKED.  IF THE VALUE IS 0, THE    */
*/*            THE RETURN CODE VARIABLE IS SET TO INDICATE THE ERROR.*/
*/*                                                                  */
*/* ENTRY - INLINE SUBROUTINE - ENTERED AT TOP.                      */
*/*                                                                  */
*/*   PURPOSE - SEE FUNCTION                                         */
*/*                                                                  */
*/*   INPUT  - CVRPARM   CVRAVFLG                                    */
*/*                      CVRALFLG                                    */
*/*                      CVROFFLG                                    */
*/*                                                                  */
*/* EXIT - NORMAL - (INLINE SUBROUTINE EXITS AT BOTTOM)              */
*/*                                                                  */
*/*   CONDITION - PARAMETER FLAGS CHECKED                            */
*/*                                                                  */
*/*   OUTPUT - NONE                                                  */
*/*                                                                  */
*/*   CONDITION - FLAG COUNT IS ZERO                                 */
*/*                                                                  */
*/*   RETURN CODE - RCODE = 12                                       */
*/*                                                                  */
*/********************************************************************/
*                                                               02S0051
*   DO;                             /* START OF CHKPARM              */
*     FLAGCNT=CNTINIT;              /* INITIALIZE COUNTER            */
         LR    FLAGCNT,@04                                      02S0052
*     IF CVRAVFLG=ON                /* AVAILABLE FLAG ON?            */
*       THEN                                                    02S0053
         TM    CVRAVFLG(PARMPTR),B'10000000'                    02S0053
         BNO   @RF00053                                         02S0053
*       FLAGCNT=FLAGCNT+CNTINCR;    /* INCREMENT COUNT OF FLAGS      */
         AH    FLAGCNT,@CH00051                                 02S0054
*     IF CVRALFLG=ON                /* CHECK ALLOCATED FLAG          */
*       THEN                        /* ALLOCATED FLAG ON             */
@RF00053 TM    CVRALFLG(PARMPTR),B'01000000'                    02S0055
         BNO   @RF00055                                         02S0055
*       FLAGCNT=FLAGCNT+CNTINCR;    /* INCREMENT COUNT OF FLAGS      */
         AH    FLAGCNT,@CH00051                                 02S0056
*     IF CVROFFLG=ON                /* CHECK OFF-LINE FLAG           */
*       THEN                        /* OFF-LINE FLAG ON              */
@RF00055 TM    CVROFFLG(PARMPTR),B'00100000'                    02S0057
         BNO   @RF00057                                         02S0057
*       FLAGCNT=FLAGCNT+CNTINCR;    /* INCREMENT COUNT OF FLAGS      */
         AH    FLAGCNT,@CH00051                                 02S0058
*     IF FLAGCNT=CNTINIT            /* ANY FLAGS ON?                 */
*       THEN                        /* NO - ERROR                    */
@RF00057 LTR   FLAGCNT,FLAGCNT                                  02S0059
         BNZ   @RF00059                                         02S0059
*       RCODE=BADPARM;              /* SET UP RETURN CODE            */
         LA    RCODE,12                                         02S0060
*     ELSE                                                      02S0061
*       ;                           /* YES - PARAMETERS OK           */
@RF00059 DS    0H                                               02S0062
*   END;                            /* END OF CHKPARM                */
*   IF RCODE=NOERROR                /* PARAMETERS OK?                */
*     THEN                          /* PROCESS REQ                   */
*                                                               01S0063
         SLR   @08,@08                                          01S0063
         CR    RCODE,@08                                        01S0063
         BNE   @RF00063                                         01S0063
*     /***************************************************************/
*     /*                                                             */
*     /* INITIALIZE VOLATILE FIELDS IN INPUT STRUCTURES              */
*     /*                                                             */
*     /***************************************************************/
*                                                               01S0064
*                                                               02S0064
*/********************************************************************/
*/*                                                                  */
*/* SEGMENT NAME - CVRINIT                                           */
*/*                                                                  */
*/* DESCRIPTIVE NAME - INITIALIZATION ROUTINE                        */
*/*                                                                  */
*/* FUNCTION - TO INITIALIZE VARIABLES AND FILL IN VOLATILE AREAS    */
*/*            OF TABLES.  ALSO CONSTRUCTS CVRWORK, A WORKAREA FOR   */
*/*            GROUPS.                                               */
*/*                                                                  */
*/* OPERATION -                                                      */
*/*      FIRST REQUEST SCAN COUNTS TOTAL NUMBER OF LOCKED GROUPS TO  */
*/*            DETERMINE MAXIMUM SIZE OF WORK AREA AND SETS WORK     */
*/*            AREA POINTER (GRPWPTR) TO 0 FOR LATER USE IN UNIQUELY */
*/*            ASSIGNING WORK AREA ENTRIES TO GROUP COUNT ENTRIES.   */
*/*            ALSO INITIALIZES CVRNEED, EITHER TO 0 IF NOT FIRST    */
*/*            CALL OR TO NUMBER STILL REQUIRED IF FIRST CALL.  A    */
*/*            COUNT IS KEPT OF NUMBER OF ALLOCATED UNITS FOR EACH   */
*/*            REQUEST.  IF THIS NUMBER AND CVRNEED ARE BOTH 0, THE  */
*/*            REQUEST IS MARKED 'FULL' FOR USE IN PTS PROCESSING.   */
*/*      WORKAREA GETMAIN IS FOR NUMBER OF GROUPS COUNTED PLUS 1.    */
*/*            THE EXTRA IS TO CONTAIN A 'LAST ENTRY' FLAG USED TO   */
*/*            END ALL SCANS OF THE TABLE.  IT IS UNLIKELY THAT ALL  */
*/*            OF THESE ENTRIES WILL BE REQUIRED, BUT IT SAVES A     */
*/*            DATA SCAN.                                            */
*/*      SECOND REQUEST SCAN ASSIGNS WORK AREA ENTRIES TO GRPCOUNT   */
*/*            ENTRIES AND CALCULATES THE NUMBER OF UNITS AVAILABLE  */
*/*            FOR ALLOCATION.                                       */
*/*      GROUP SCAN CHECKS EACH GROUP TO BE SURE THAT MORE UNITS     */
*/*            HAVE NOT BEEN ALLOCATED (BY CALLER) THAN WERE         */
*/*            ORIGINALLY AVAILABLE.  IF SOME 'EXCESS' COUNT IS      */
*/*            NEGATIVE, ALLOCATIONS ARE REDUCED TO CORRECT THE      */
*/*            CONDITION AND THE NUMBER OF UNITS NEEDED IS           */
*/*            INCREASED.                                            */
*/*                                                                  */
*/* ENTRY - (INLINE SUBROUTINE - ENTERED AT TOP)                     */
*/*                                                                  */
*/*   PURPOSE - SEE FUNCTION                                         */
*/*                                                                  */
*/*   INPUT  - CVRPARM   CVRRQPTR  POINTER TO FIRST REQUEST          */
*/*                      CVRNREQ   NUMBER OF REQUESTS                */
*/*                      CVRFLG1   INDICATES WHICH COUNTS ARE TO     */
*/*                                BE USED                           */
*/*                      CVRGRPLK  ID OF HIGHEST LOCKED GROUP        */
*/*            CVRRQLST  CVRREQ1   NUMBER OF UNITS REQUIRED FOR REQ. */
*/*                      CVRALLCT  NUMBER OF UNITS ALREADY ALLOCATED */
*/*                      CVRSKFLG  1 - IGNORE THIS REQUEST           */
*/*                      CVRNGRP   NUMBER OF GROUPS FOR THIS REQUEST */
*/*                      CVRGRPPT  POINTER TO FIRST GROUP ENTRY      */
*/*            CVRGPLST  CVRGCPTR  POINTER TO COUNT ENTRY            */
*/*                      CVRGRPID  ID OF GROUP                       */
*/*                      CVRGRPAL  UNITS PRE-ALLOCATED               */
*/*            GRPCOUNT  GRPAVAIL  NUMBER OF AVAILABLE UNITS         */
*/*                      GRPALLCT  NUMBER OF ALLOCATED UNITS         */
*/*                      GRPOFFLN  NUMBER OF OFF-LINE UNITS          */
*/*                                                                  */
*/* EXIT - (INLINE SUBROUTINE - EXITS AT BOTTOM)                     */
*/*                                                                  */
*/*   CONDITION - NORMAL - FUNCTION COMPLETE                         */
*/*                                                                  */
*/*   OUTPUT - CVRRQLST  CVRNEED   NUMBER STILL TO BE ALLOCATED      */
*/*            CVRGPLST  CVRGALL   NUMBER ALLOCATED SO FAR           */
*/*            GRPCOUNT  GRPEXCS   NUMBER OF UNITS STILL AVAILABLE   */
*/*                      GRPWPTR   POINTER TO CVRWORK ENTRY FOR THIS */
*/*                                GROUP                             */
*/*            COUNT               NUMBER OF UNIQUE LOCKED GROUPS    */
*/*            CVRWORK             WORK AREA FOR COUNTS              */
*/*            SIZE                SIZE OF GETMAINED AREA            */
*/*            ACVRWORK            ADDRESS OF GETMAINED AREA         */
*/*                                                                  */
*/* IN-LINE SUBROUTINES                                              */
*/*            CNTGRPS             COUNTS GROUPS AND PUTS INITIAL    */
*/*                                VALUES INTO FIELDS                */
*/*            GETWORK             GETMAIN FOR WORK AREA             */
*/*            SUMUNITS            TOTAL ALLOCATABLE UNITS ACCORDING */
*/*                                TO FLAGS IN CVRPARM               */
*/*            REDOSOL             REDUCE SOLUTION IF GROUP IS OVER- */
*/*                                ALLOCATED                         */
*/*                                                                  */
*/********************************************************************/
*                                                               02S0064
*     DO;                           /* START OF CVRINIT              */
*                                                               02S0064
*       /*************************************************************/
*       /*                                                           */
*       /* COUNT GROUPS USED IN THIS SET OF REQUESTS TO DETERMINE    */
*       /* SIZE OF WORK AREA. IN ADDITION, CALCULATE NUMBER STILL    */
*       /* NEEDED FOR EACH REQUEST AND MARK ANY REQUEST WHICH IS     */
*       /* FULLY BOUND.                                              */
*       /*                                                           */
*       /*************************************************************/
*                                                               02S0065
*                                                               03S0065
*/********************************************************************/
*/*                                                                  */
*/*  SEGMENT NAME - CNTGRPS                                          */
*/*                                                                  */
*/* DESCRIPTIVE NAME - COUNT LOCKED GROUPS                           */
*/*                                                                  */
*/* FUNCTION - TO COUNT THE GROUPS USED FOR THE GETMAIN AND TO FILL  */
*/*            IN THE INITIAL VALUES IN WORK FIELDS IN INPUT TABLES. */
*/*                                                                  */
*/* OPERATION -                                                      */
*/*      REQUEST SCAN - CALCULATE CVRNEED IF FIRST CALL, OR SET IT   */
*/*            TO 0.  THE NUMBER ALLOCATED IS COUNTED IN THE GROUP   */
*/*            SCAN.  IF NUMBER ALLOCATED(MOVEABLE) AND NUMBER       */
*/*            NEEDED ARE BOTH 0, MARK THE REQUEST 'FULL.'           */
*/*      GROUP SCAN - COUNT THE NUMBER OF LOCKED GROUPS.  IF FIRST   */
*/*            CALL, COPY THE ALREADY ALLOCATED FIELD AND SUBTRACT   */
*/*            BOUND COUNT FROM CVRNEED.  IF ANY ARE ALLOCATED       */
*/*            (CVRGALL>0), ADD THE NUMBER ALLOCATED TO ALCOUNT,     */
*/*            TO BE USED TO LOCATE FULL REQUESTS.                   */
*/*                                                                  */
*/* ENTRY - (INLINE SUBROUTINE - ENTERED AT TOP)                     */
*/*                                                                  */
*/*   PURPOSE - SEE FUNCTION                                         */
*/*                                                                  */
*/*   INPUT  - CVRPARM   CVRFCALL  1 - FIRST CALL WITH THIS DATA     */
*/*            CVRRQLST  CVRREQ1   NUMBER NEEDED                     */
*/*                      CVRALLCT  NUMBER ALREADY ALLOCATED BY CALLER*/
*/*            CVRGPLST  CVRGRPAL  NUMBER ALLOCATED FROM GROUP BY    */
*/*                                CALLER - FIRST CALL ONLY          */
*/*                      CVRGALL   NUMBER ALLOCATED FROM GROUP BY    */
*/*                                PREVIOUS INVOCATION OF IEFAB480   */
*/*                      CVRBOUND  NUMBER BOUND TO GROUP BY CALLER   */
*/*                                                                  */
*/* EXIT - NORMAL - (INLINE SUBROUTINE - EXITS AT BOTTOM)            */
*/*                                                                  */
*/*   CONDITION - FUNCTION COMPLETE                                  */
*/*                                                                  */
*/*   OUTPUT - CVRRQLST  CVRNEED   NUMBER STILL NEEDED (NOT ALREADY  */
*/*                                ALLOCATED OR BOUND)               */
*/*                      CVRFULL   0 - REQUEST NOT FULLY BOUND       */
*/*                                1 - REQUEST FULLY BOUND           */
*/*            CVRGPLST  CVRGALL   FIRST CALL ONLY - NUMBER          */
*/*                                ALLOCATED BY CALLER               */
*/*            GRPCOUNT  GRPWPTR   0                                 */
*/*            COUNT               MAXIMUM NUMBER OF LOCKED GROUPS   */
*/*                                                                  */
*/********************************************************************/
*                                                               03S0065
*       DO;                         /* START OF CNTGRPS              */
*         COUNT=CNTINIT;            /* INITIALIZE COUNT OF LOCKED
*                                      GROUPS                        */
*                                                               03S0066
         LR    COUNT,@08                                        03S0066
*         /***********************************************************/
*         /*                                                         */
*         /* SCAN OF REQUESTS WHICH ARE NOT MARKED 'SKIP'. CALCULATE */
*         /* NUMBER OF UNITS NEEDED, MARK ANY REQUESTS WHICH ARE     */
*         /* FULLY BOUND AND COUNT ALL GROUPS WHICH THESE REQUESTS   */
*         /* CAN USE.                                                */
*         /*                                                         */
*         /***********************************************************/
*                                                               03S0067
*         REQPTR=CVRRQPTR;          /* LOCATE FIRST REQUEST          */
         L     REQPTR,CVRRQPTR(,PARMPTR)                        03S0067
*         DO INDEX1=1 TO CVRNREQ;   /* LOOP OVER ALL REQUESTS        */
         LA    INDEX1,1                                         03S0068
         B     @DE00068                                         03S0068
@DL00068 DS    0H                                               03S0069
*           IF CVRSKFLG=OFF         /* REQ TO BE PROCESSED OR   03S0069
*                                      IGNORED?                      */
*             THEN                  /* REQUEST IS TO BE PROCESSED    */
         TM    CVRSKFLG(REQPTR),B'10000000'                     03S0069
         BNZ   @RF00069                                         03S0069
*             DO;                                               03S0070
*               IF CVRFCALL=ON      /* FIRST CALL WITH THIS DATA?    */
*                 THEN              /* FIRST CALL WITH THIS DATA     */
         TM    CVRFCALL(PARMPTR),B'00010000'                    03S0071
         BNO   @RF00071                                         03S0071
*                 CVRNEED=CVRREQ1-CVRALLCT;/* NUMBER STILL NEEDED IS
*                                      NUMBER REQUIRED LESS NUMBER
*                                      ALLOCATED (NUMBER BOUND WILL
*                                      BE SUBTRACTED LATER)          */
         LH    @10,CVRREQ1(,REQPTR)                             03S0072
         SH    @10,CVRALLCT(,REQPTR)                            03S0072
         STH   @10,CVRNEED(,REQPTR)                             03S0072
*               ELSE                /* NOT FIRST CALL - PREVIOUS
*                                      ALLOCATION WAS COMPLETE       */
*                 CVRNEED=0;        /* INIT TO 0 (CAN BE INCREASED IF
*                                      CALLER CHANGED SOLUTION)      */
         B     @RC00071                                         03S0073
@RF00071 SLR   @10,@10                                          03S0073
         STH   @10,CVRNEED(,REQPTR)                             03S0073
*               ALCOUNT=CNTINIT;    /* INITIALIZE COUNT OF MOVEABLE
*                                      UNITS                         */
*                                                               03S0074
@RC00071 SLR   ALCOUNT,ALCOUNT                                  03S0074
*               /*****************************************************/
*               /*                                                   */
*               /* EXAMINE GROUPS FOR THIS REQUEST, SETTING CVRGALL  */
*               /* IF FIRST CALL, KEEPING A COUNT OF NUMBER ALREADY  */
*               /* ALLOCATED TO USE IN DETERMINING WHETHER REQUEST IS*/
*               /* FULLY BOUND AND, IF FIRST CALL, SUBTRACT BOUND    */
*               /* FROM NEEDED UNITS.                                */
*               /*                                                   */
*               /*****************************************************/
*                                                               03S0075
*               GRPPTR=CVRGRPPT;    /* LOCATE FIRST GROUP FOR REQ    */
         L     GRPPTR,CVRGRPPT(,REQPTR)                         03S0075
*               DO INDEX2=1 TO CVRNGRP WHILE(CVRGRPID<=CVRGRPLK);
         LA    INDEX2,1                                         03S0076
         B     @DE00076                                         03S0076
@DL00076 LH    @06,CVRGRPID(,GRPPTR)                            03S0076
         CH    @06,CVRGRPLK(,PARMPTR)                           03S0076
         BH    @DC00076                                         03S0076
*                 IF CVRGSKP=OFF THEN                           03S0077
         TM    CVRGSKP(GRPPTR),B'10000000'                      03S0077
         BNZ   @RF00077                                         03S0077
*                   DO;                                         03S0078
*                     COUNT=COUNT+CNTINCR;/* INCREMENT COUNT OF 03S0079
*                                      LOCKED GROUPS                 */
         AH    COUNT,@CH00051                                   03S0079
*                     CNTPTR=CVRGCPTR;/* LOCATE COUNTS FOR GROUP     */
         L     CNTPTR,CVRGCPTR(,GRPPTR)                         03S0080
*                     IF CVRFCALL=ON/* FIRST CALL WITH THIS DATA?    */
*                       THEN        /* FIRST CALL WITH THIS DATA     */
         TM    CVRFCALL(PARMPTR),B'00010000'                    03S0081
         BNO   @RF00081                                         03S0081
*                       DO;                                     03S0082
*                         CVRGALL=CVRGRPAL;/* COPY COUNT OF ALLOCATED
*                                      UNITS TO WORK AREA            */
         MVC   CVRGALL(2,GRPPTR),CVRGRPAL(GRPPTR)               03S0083
*                         CVRNEED=CVRNEED-CVRBOUND;/* REMOVE NUMBER
*                                      BOUND FROM CONSIDERATION      */
         LH    @15,CVRNEED(,REQPTR)                             03S0084
         SH    @15,CVRBOUND(,GRPPTR)                            03S0084
         STH   @15,CVRNEED(,REQPTR)                             03S0084
*                       END;        /* END PROCESSING FIRST CALL     */
*/*THE FOLLOWING CODE TRANSLATES THE INPUT DATA INTO A FORM EXPECTED */
*/*BY THE 'REDUCE' FUNCTION. THIS CODE IS DEPENDENT ON CVRREQ1 NOT   */
*/*GREATER THAN ONE                                                  */
*                                                               03S0086
*                     ELSE          /* NOT FIRST CALL WITH      03S0086
*                                      DATA-REDUCE                   */
*                       DO;                                     03S0086
         B     @RC00081                                         03S0086
@RF00081 DS    0H                                               03S0087
*                         IF CVRALLCT>0&CVRGALL>0 THEN/* ALLOC'D BY
*                                      CALLER ?                      */
         SLR   @15,@15                                          03S0087
         CH    @15,CVRALLCT(,REQPTR)                            03S0087
         BNL   @RF00087                                         03S0087
         CH    @15,CVRGALL(,GRPPTR)                             03S0087
         BNL   @RF00087                                         03S0087
*                           CVRGALL=0;/* YES,ZERO ALG'S CHOICE       */
         STH   @15,CVRGALL(,GRPPTR)                             03S0088
*                         ELSE                                  03S0089
*                           ;       /* NOT ALLOCATED BY CALLER       */
@RF00087 DS    0H                                               03S0090
*                         IF CVRALLCT>0&CVRREQ1>0/* GROUP CALLR 03S0090
*                                      PICKED                        */
*                             &CVRGRPAL=1 THEN                  03S0090
         SLR   @15,@15                                          03S0090
         CH    @15,CVRALLCT(,REQPTR)                            03S0090
         BNL   @RF00090                                         03S0090
         CH    @15,CVRREQ1(,REQPTR)                             03S0090
         BNL   @RF00090                                         03S0090
         CLC   CVRGRPAL(2,GRPPTR),@CH00051                      03S0090
         BNE   @RF00090                                         03S0090
*                           DO;     /* YES,DECREMENT NO. OF REQSAC
*                                      AND FORM COUNT TABLE          */
*                             CVRREQ1=0;                        03S0092
         STH   @15,CVRREQ1(,REQPTR)                             03S0092
*                             IF GRPAVAIL>0 THEN                03S0093
         LH    @14,GRPAVAIL(,CNTPTR)                            03S0093
         CR    @14,@15                                          03S0093
         BNH   @RF00093                                         03S0093
*                               GRPAVAIL=GRPAVAIL-1;            03S0094
         BCTR  @14,0                                            03S0094
         STH   @14,GRPAVAIL(,CNTPTR)                            03S0094
*                             ELSE                              03S0095
*                               DO;                             03S0095
         B     @RC00093                                         03S0095
@RF00093 DS    0H                                               03S0096
*                                 IF GRPALLCT>0&CVRALFLG=ON THEN
         LH    @15,GRPALLCT(,CNTPTR)                            03S0096
         LTR   @15,@15                                          03S0096
         BNP   @RF00096                                         03S0096
         TM    CVRALFLG(PARMPTR),B'01000000'                    03S0096
         BNO   @RF00096                                         03S0096
*                                   GRPALLCT=GRPALLCT-1;        03S0097
         BCTR  @15,0                                            03S0097
         STH   @15,GRPALLCT(,CNTPTR)                            03S0097
*                                 ELSE                          03S0098
*                                   GRPOFFLN=GRPOFFLN-1;        03S0098
         B     @RC00096                                         03S0098
@RF00096 LH    @15,GRPOFFLN(,CNTPTR)                            03S0098
         BCTR  @15,0                                            03S0098
         STH   @15,GRPOFFLN(,CNTPTR)                            03S0098
*                               END;                            03S0099
*                           END;                                03S0100
*                         ELSE                                  03S0101
*                           ;       /* NOT THE GROUP CALLER PICKED   */
@RF00090 DS    0H                                               03S0102
*                       END;                                    03S0102
@RC00090 DS    0H                                               03S0103
*                     IF CVRGALL>0  /* ANY UNITS ALLOCATED?          */
*                       THEN        /* UNITS ALLOCATED FROM THIS GRP */
@RC00081 LH    @15,CVRGALL(,GRPPTR)                             03S0103
         LTR   @15,@15                                          03S0103
         BNP   @RF00103                                         03S0103
*                       ALCOUNT=ALCOUNT+CVRGALL;/* ADD THEM TO COUNT
*                                      OF ALLOCATED UNITS            */
         ALR   ALCOUNT,@15                                      03S0104
*                     GRPWPTR=INITVAL;/* SET TO STANDARD NULL VALUE  */
@RF00103 SLR   @15,@15                                          03S0105
         ST    @15,GRPWPTR(,CNTPTR)                             03S0105
*                   END;                                        03S0106
*                 ELSE                                          03S0107
*                   ;                                           03S0107
@RF00077 DS    0H                                               03S0108
*                 GRPPTR=GRPPTR+LENGTH(CVRGPLST);/* LOCATE NEXT GROUP*/
         AH    GRPPTR,@CH00067                                  03S0108
*               END;                /* END OF GROUP SCAN             */
         AH    INDEX2,@CH00051                                  03S0109
@DE00076 CH    INDEX2,CVRNGRP(,REQPTR)                          03S0109
         BNH   @DL00076                                         03S0109
@DC00076 DS    0H                                               03S0110
*               IF ALCOUNT=CNTINIT  /* ANY UNITS ALLOCATED TO THIS RQ*/
*                   &CVRNEED=0      /* OR NEEDED BY IT?              */
*                 THEN              /* NO UNITS ALLOCATED OR NEEDED  */
         SLR   @10,@10                                          03S0110
         CR    ALCOUNT,@10                                      03S0110
         BNE   @RF00110                                         03S0110
         CH    @10,CVRNEED(,REQPTR)                             03S0110
         BNE   @RF00110                                         03S0110
*                 CVRFULL=ON;       /* REQUEST FULL FROM BOUND UNITS */
         OI    CVRFULL(REQPTR),B'00010000'                      03S0111
*               ELSE                /* NOT ALL UNITS BOUND           */
*                 CVRFULL=OFF;      /* MARK REQ NOT FULL             */
         B     @RC00110                                         03S0112
@RF00110 NI    CVRFULL(REQPTR),B'11101111'                      03S0112
*             END;                  /* END PROCESSING OF ACTIVE REQ  */
@RC00110 DS    0H                                               03S0114
*           REQPTR=REQPTR+LENGTH(CVRRQLST);/* LOCATE NEXT REQUEST    */
@RF00069 AH    REQPTR,@CH00250                                  03S0114
*         END;                      /* END OF REQUEST SCAN           */
         AH    INDEX1,@CH00051                                  03S0115
@DE00068 CH    INDEX1,CVRNREQ(,PARMPTR)                         03S0115
         BNH   @DL00068                                         03S0115
*       END;                        /* END OF CNTGRPS                */
*                                                               03S0117
*/********************************************************************/
*/*                                                                  */
*/* SEGMENT NAME - GETWORK                                           */
*/*                                                                  */
*/* DESCRIPTIVE NAME - OBTAIN STORAGE                                */
*/*                                                                  */
*/* FUNCTION - TO OBTAIN STORAGE FOR WORK AREA AND SET UP POINTER TO */
*/*            IT                                                    */
*/*                                                                  */
*/* ENTRY - (INLINE SUBROUTINE - ENTERED AT TOP)                     */
*/*                                                                  */
*/*   PURPOSE - SEE FUNCTION                                         */
*/*                                                                  */
*/*   INPUT  - COUNT               NUMBER OF ENTRIES NEEDED IN TABLE */
*/*                                                                  */
*/* EXIT - NORMAL - (INLINE SUBROUTINE - EXITS AT BOTTOM)            */
*/*                                                                  */
*/*   CONDITION - GETMAIN SUCCESSFUL                                 */
*/*                                                                  */
*/*   OUTPUT - SIZE                SIZE OF AREA                      */
*/*            ACVRWORK            ADDRESS OF AREA                   */
*/*                                                                  */
*/*   RETURN CODE - RCODE = 0                                        */
*/*                                                                  */
*/* EXIT - ERROR - (INLINE SUBROUTINE - EXITS AT BOTTOM)             */
*/*                                                                  */
*/*   CONDITION - GETMAIN FAIL                                       */
*/*                                                                  */
*/*   RETURN CODE - RCODE = 16                                       */
*/*                                                                  */
*/********************************************************************/
*                                                               03S0117
*       DO;                         /* START OF GETWORK              */
*         RESPECIFY                                             03S0118
*          (R2,                                                 03S0118
*           R3,                                                 03S0118
*           R15) RESTRICTED;        /* RESTRICT REGS NEEDED          */
*         R2=(COUNT+1)*LENGTH(CVRWORKD);/* FIND MAX SIZE OF WORKAREA */
         LA    R2,1                                             03S0119
         ALR   R2,COUNT                                         03S0119
         SLA   R2,4                                             03S0119
*         SIZE=R2;                  /* SAVE SIZE FOR FREEMAIN        */
         LR    SIZE,R2                                          03S0120
*         R3=ADDR(ACVRWORK);        /* PUT ADDRESS OF ANSWER AREA
*                                      INTO REG FOR GETMAIN          */
         LA    R3,ACVRWORK                                      03S0121
*         GEN REFS(R3,R2) SETS(ACVRWORK,R15)                    03S0122
*             (GETMAIN  EC,LV=(R2),A=(R3),SP=230,MF=(E,GETMAIN));
         GETMAIN  EC,LV=(R2),A=(R3),SP=230,MF=(E,GETMAIN)
*         IF R15^=0                 /* CHECK RESULT OF GETMAIN       */
*           THEN                    /* GETMAIN FAILED                */
         LTR   R15,R15                                          03S0123
         BZ    @RF00123                                         03S0123
*           RCODE=GETFAIL;          /* INDICATE GETMAIN FAILURE      */
         LA    RCODE,16                                         03S0124
*         ELSE                                                  03S0125
*           ;                       /* GETMAIN SUCCESSFUL            */
@RF00123 DS    0H                                               03S0126
*         RESPECIFY                                             03S0126
*          (R2,                                                 03S0126
*           R3,                                                 03S0126
*           R15);                   /* RELEASE REGISTERS             */
*       END;                        /* END OF GETWORK                */
*       IF RCODE=NOERROR            /* WAS GETMAIN SUCCESSFUL?       */
*         THEN                      /* YES -                         */
         LTR   RCODE,RCODE                                      02S0128
         BNZ   @RF00128                                         02S0128
*         DO;                                                   02S0129
*           WORKPTR=ACVRWORK;       /* SET UP ADDRESSABILITY FOR
*                                      WORKAREA                      */
         L     WORKPTR,ACVRWORK                                 02S0130
*           RESPECIFY                                           02S0131
*            (CVRWORKD) BASED(WORKPTR);                         02S0131
*                                                               02S0131
*           /*********************************************************/
*           /*                                                       */
*           /* SCAN REQUESTS TO FILL IN GRPCOUNT AND CVRWORK ENTRIES */
*           /* FOR EACH UNIQUE GROUP.                                */
*           /*                                                       */
*           /*********************************************************/
*                                                               02S0132
*           REQPTR=CVRRQPTR;        /* LOCATE FIRST REQUEST          */
         L     REQPTR,CVRRQPTR(,PARMPTR)                        02S0132
*           DO INDEX3=1 TO CVRNREQ; /* SET UP LOOP CTL OVER REQUESTS */
         LA    INDEX3,1                                         02S0133
         B     @DE00133                                         02S0133
@DL00133 DS    0H                                               02S0134
*             IF CVRSKFLG=OFF       /* IS REQUEST TO BE IGNORED?     */
*               THEN                /* NO - TO BE PROCESSED          */
         TM    CVRSKFLG(REQPTR),B'10000000'                     02S0134
         BNZ   @RF00134                                         02S0134
*               DO;                                             02S0135
*                                                               02S0135
*                 /***************************************************/
*                 /*                                                 */
*                 /* EXAMINE LOCKED GROUPS. IF NOT PREVIOUSLY FILLED */
*                 /* IN (GRPWPTR=0), COMPLETE GRPCOUNT AND CVRWORK   */
*                 /* ENTRIES.                                        */
*                 /*                                                 */
*                 /***************************************************/
*                                                               02S0136
*                 GRPPTR=CVRGRPPT;  /* FIND FIRST GROUP FOR REQ      */
         L     GRPPTR,CVRGRPPT(,REQPTR)                         02S0136
*                 DO INDEX4=1 TO CVRNGRP WHILE(CVRGRPID<=CVRGRPLK);
         LA    INDEX4,1                                         02S0137
         B     @DE00137                                         02S0137
@DL00137 LH    @06,CVRGRPID(,GRPPTR)                            02S0137
         CH    @06,CVRGRPLK(,PARMPTR)                           02S0137
         BH    @DC00137                                         02S0137
*                   IF CVRGSKP=OFF THEN                         02S0138
         TM    CVRGSKP(GRPPTR),B'10000000'                      02S0138
         BNZ   @RF00138                                         02S0138
*                     DO;                                       02S0139
*                       CNTPTR=CVRGCPTR;/* FIND COUNTS FOR THIS GROUP*/
         L     CNTPTR,CVRGCPTR(,GRPPTR)                         02S0140
*                       IF GRPWPTR=INITVAL/* HAS THIS ENTRY BEEN
*                                      CREATED?                      */
*                         THEN      /* NOT USED YET - INCLUDE IN
*                                      TABLE                         */
         ICM   @15,15,GRPWPTR(CNTPTR)                           02S0141
         BNZ   @RF00141                                         02S0141
*                         DO;                                   02S0142
*                                                               03S0143
*/********************************************************************/
*/*                                                                  */
*/* SEGMENT NAME - SUMUNITS                                          */
*/*                                                                  */
*/* DESCRIPTIVE NAME - TOTAL ALLOCATABLE UNITS                       */
*/*                                                                  */
*/* FUNCTION - TO PUT NUMBER OF UNUSED UNITS OF DESIRED TYPE IN      */
*/*            GRPEXCS                                               */
*/*                                                                  */
*/* ENTRY - (INLINE SUBROUTINE - ENTERED AT TOP)                     */
*/*                                                                  */
*/*   PURPOSE - SEE FUNCTION                                         */
*/*                                                                  */
*/*   INPUT  - CVRPARM   CVRFLG1   INDICATES WHICH COUNT(S) SHOULD   */
*/*                                BE USED                           */
*/*            GRPCOUNT  GRPAVAIL                                    */
*/*                      GRPALLCT                                    */
*/*                      GRPOFFLN                                    */
*/*                                                                  */
*/* EXIT - NORMAL - (INLINE SUBROUTINE - EXITS AT BOTTOM)            */
*/*                                                                  */
*/*   CONDITION - FUNCTION COMPLETE                                  */
*/*                                                                  */
*/*   OUTPUT - GRPCOUNT  GRPEXCS                                     */
*/*                                                                  */
*/********************************************************************/
*                                                               03S0143
*                           DO;     /* START OF SUMUNITS             */
*                             IF CVRAVFLG=ON/* IS AVAILABLE FLAG ON? */
*                               THEN/* AVAILABLE FLAG IS ON          */
         TM    CVRAVFLG(PARMPTR),B'10000000'                    03S0144
         BNO   @RF00144                                         03S0144
*                               GRPEXCS=GRPAVAIL;/* MOVE AVAILABLE
*                                      COUNT TO WORK FIELD           */
         MVC   GRPEXCS(2,CNTPTR),GRPAVAIL(CNTPTR)               03S0145
*                             ELSE  /* AVAILABLE FLAG IS NOT ON      */
*                               GRPEXCS=0;/* INIT FIELD TO 0         */
         B     @RC00144                                         03S0146
@RF00144 SLR   @15,@15                                          03S0146
         STH   @15,GRPEXCS(,CNTPTR)                             03S0146
*                             IF CVRALFLG=ON/* IS ALLOCATED FLAG ON? */
*                               THEN/* ALLOCATED COUNT TO BE USED    */
@RC00144 TM    CVRALFLG(PARMPTR),B'01000000'                    03S0147
         BNO   @RF00147                                         03S0147
*                               GRPEXCS=GRPEXCS+GRPALLCT;/* ADD IN
*                                      ALLOCATED COUNT               */
         LH    @15,GRPEXCS(,CNTPTR)                             03S0148
         AH    @15,GRPALLCT(,CNTPTR)                            03S0148
         STH   @15,GRPEXCS(,CNTPTR)                             03S0148
*                             ELSE                              03S0149
*                               ;   /* COUNT NOT TO BE USED          */
@RF00147 DS    0H                                               03S0150
*                             IF CVROFFLG=ON/* OFF-LINE UNITS TO BE
*                                      INCLUDED?                     */
*                               THEN/* USE OFF-LINE UNITS            */
         TM    CVROFFLG(PARMPTR),B'00100000'                    03S0150
         BNO   @RF00150                                         03S0150
*                               GRPEXCS=GRPEXCS+GRPOFFLN;/* ADD IN
*                                      OFF-LINE UNITS                */
         LH    @15,GRPEXCS(,CNTPTR)                             03S0151
         AH    @15,GRPOFFLN(,CNTPTR)                            03S0151
         STH   @15,GRPEXCS(,CNTPTR)                             03S0151
*                             ELSE                              03S0152
*                               ;   /* OFF-LINE UNITS NOT USED       */
@RF00150 DS    0H                                               03S0153
*                           END;    /* END OF SUMUNITS               */
*                           GRPWPTR=WORKPTR;/* SET UP CROSS POINTERS */
         ST    WORKPTR,GRPWPTR(,CNTPTR)                         02S0154
*                           WCNTPTR=CNTPTR;                     02S0155
         ST    CNTPTR,WCNTPTR(,WORKPTR)                         02S0155
*                           LASTFLAG=OFF;/* INDICATE NOT LAST ENTRY  */
         NI    LASTFLAG(WORKPTR),B'01111111'                    02S0156
*                           WORKPTR=WORKPTR+LENGTH(CVRWORKD);/* SET
*                                      POINTER TO NEXT ENTRY IN WORK
*                                      TABLE                         */
         AH    WORKPTR,@CH00067                                 02S0157
*                         END;                                  02S0158
*                       GRPEXCS=GRPEXCS-CVRBOUND;/* SUBTRACT BOUND
*                                      UNIT COUNT                    */
@RF00141 LH    @15,GRPEXCS(,CNTPTR)                             02S0159
         SH    @15,CVRBOUND(,GRPPTR)                            02S0159
         STH   @15,GRPEXCS(,CNTPTR)                             02S0159
*                       IF CVRGALL>0/* ANY ALLOCATED UNITS?          */
*                         THEN      /* YES                           */
         LH    @14,CVRGALL(,GRPPTR)                             02S0160
         LTR   @14,@14                                          02S0160
         BNP   @RF00160                                         02S0160
*                         GRPEXCS=GRPEXCS-CVRGALL;/* SUBTRACT FROM
*                                      ALLOCATABLE UNIT COUNT        */
         SLR   @15,@14                                          02S0161
         STH   @15,GRPEXCS(,CNTPTR)                             02S0161
*                       IF GRPEXCS<0/* TOO MANY FROM THIS GROUP?     */
*                         THEN      /* TOO MANY FROM THIS GROUP      */
@RF00160 ICM   @15,3,GRPEXCS(CNTPTR)                            02S0162
         BNM   @RF00162                                         02S0162
*                         WPTS=CVRPTS;/* SAVE PTS NUMBER             */
         MVC   WPTS(2,WORKPTR),CVRPTS(REQPTR)                   02S0163
*                     END;                                      02S0164
*                   ELSE                                        02S0165
*                     ;                                         02S0165
@RF00138 DS    0H                                               02S0166
*                   GRPPTR=GRPPTR+LENGTH(CVRGPLST);/* FIND NEXT GROUP*/
@RC00138 AH    GRPPTR,@CH00067                                  02S0166
*                 END;              /* END OF GROUP SCAN             */
         AH    INDEX4,@CH00051                                  02S0167
@DE00137 CH    INDEX4,CVRNGRP(,REQPTR)                          02S0167
         BNH   @DL00137                                         02S0167
@DC00137 DS    0H                                               02S0168
*               END;                /* END OF PROCESSING OF ACTIVE RQ*/
*             REQPTR=REQPTR+LENGTH(CVRRQLST);/* LOCATE NEXT REQUEST  */
@RF00134 AH    REQPTR,@CH00250                                  02S0169
*           END;                    /* END OF REQUEST SCAN           */
         AH    INDEX3,@CH00051                                  02S0170
@DE00133 CH    INDEX3,CVRNREQ(,PARMPTR)                         02S0170
         BNH   @DL00133                                         02S0170
*           LASTFLAG=ON;            /* MARK LAST ENTRY               */
         OI    LASTFLAG(WORKPTR),B'10000000'                    02S0171
*                                                               03S0172
*/********************************************************************/
*/*                                                                  */
*/* SEGMENT NAME - REDOSOL                                           */
*/*                                                                  */
*/* DESCRIPTIVE NAME - REDUCE SOLUTION IF GROUP IS OVER ALLOCATED    */
*/*                                                                  */
*/* FUNCTION - TO REDUCE TRIAL SOLUTION (CVRGALL) ON CALLS OTHER     */
*/*            THAN THE FIRST WHERE SELECTION HAS BEEN MADE FROM     */
*/*            SOME GROUP NOT IN TRIAL SOLUTION.                     */
*/*                                                                  */
*/* OPERATION -                                                      */
*/*      WORK AREA SCAN - EACH GROUP IS EXAMINED TO SEE WHETHER IT   */
*/*            IS OVER-ALLOCATED.  IF IT IS, THE ALLOCATION IS       */
*/*            REDUCED.                                              */
*/*        REQUEST SCAN - EACH REQUEST WHICH MIGHT HAVE ALLOCATIONS  */
*/*            IN THE GROUP IS CHECKED(CVRPTS=WPTS).  IF THE         */
*/*            REQUEST HAS UNITS ALLOCATED FROM THE GROUP, THE       */
*/*            ALLOCATION IS REDUCED, CVRNEED IS INCREASED, AND      */
*/*            THE NUMBER OF OVER-ALLOCATED UNITS IS REDUCED.        */
*/*                                                                  */
*/* ENTRY - (INLINE SUBROUTINE - ENTERED AT TOP)                     */
*/*                                                                  */
*/*   PURPOSE - SEE FUNCTION                                         */
*/*                                                                  */
*/*   INPUT  - CVRRQLST  CVRFULL   FLAG TO INDICATE REQUEST TO BE    */
*/*                                SKIPPED BECAUSE FULLY BOUND       */
*/*                      CVRPTS    PTS NUMBER OF REQUEST             */
*/*            GRPCOUNT  GRPEXCS   NUMBER AVAIL FOR ALLOCATION       */
*/*                                NEGATIVE IF OVER-ALLOCATED        */
*/*            CVRWORKD  WPTS      PTS NUMBER OF GROUP               */
*/*                                                                  */
*/* EXIT - NORMAL - (INLINE SUBROUTINE - EXITS AT BOTTOM)            */
*/*                                                                  */
*/*   CONDITION - FUNCTION COMPLETE                                  */
*/*                                                                  */
*/*   OUTPUT - CVRRQLST  CVRNEED   INCREASED TO SHOW UNITS DISPLACED */
*/*            GRPCOUNT  GRPEXCS   IF PREVIOUS NEGATIVE, NOW 0       */
*/*            CVRGPLST  CVRGALL   REDUCED IF OVER-ALLOCATED         */
*/*                                                                  */
*/********************************************************************/
*                                                               03S0172
*           DO;                     /* START OF REDOSOL              */
*                                                               03S0172
*             /*******************************************************/
*             /*                                                     */
*             /* EXAMINE EACH ENTRY OF GRPCOUNT LOOKING FOR          */
*             /* GRPEXCS<0. ANY WHICH ARE FOUND CAUSE A SCAN TO      */
*             /* REDUCE ALLOCATIONS TO THIS GROUP IN ORDER TO BRING  */
*             /* GRPEXCS TO 0.                                       */
*             /*                                                     */
*             /*******************************************************/
*                                                               03S0173
*             WORKPTR=ACVRWORK;     /* LOCATE FIRST ENTRY OF CVRWORK */
         L     WORKPTR,ACVRWORK                                 03S0173
*             RESPECIFY                                         03S0174
*              (GRPCOUNT) BASED(WCNTPTR);/* LOCATE COUNT ENTRIES FROM
*                                      CORRESPONDING WORKAREA ENTRY  */
*             DO WHILE(LASTFLAG=OFF);/* CHECK EACH ENTRY OF CVRWORK  */
         B     @DE00175                                         03S0175
@DL00175 DS    0H                                               03S0176
*               IF GRPEXCS<0        /* GROUP OVER-ALLOCATED?         */
*                 THEN              /* GROUP OVER-ALLOCATED          */
         L     @08,WCNTPTR(,WORKPTR)                            03S0176
         ICM   @15,3,GRPEXCS(@08)                               03S0176
         BNM   @RF00176                                         03S0176
*                 DO;               /* REDUCE ALLOCATION             */
*                                                               03S0177
*                   /*************************************************/
*                   /*                                               */
*                   /* LOCATE REQUESTS WHICH USE THIS GROUP AND      */
*                   /* REDUCE THEIR ALLOCATION TO IT UNTIL GRPEXCS IS*/
*                   /* 0.                                            */
*                   /*                                               */
*                   /*************************************************/
*                                                               03S0178
*                   REQPTR=CVRRQPTR;/* LOCATE FIRST REQUEST          */
         L     REQPTR,CVRRQPTR(,PARMPTR)                        03S0178
*                   DO INDEX5=1 TO CVRNREQ WHILE(GRPEXCS<0);/* SET UP
*                                      LOOP CONTROL OVER REQUESTS TO
*                                      END WHEN NO LONGER       03S0179
*                                      OVER-ALLOCATED                */
         LA    INDEX5,1                                         03S0179
         B     @DE00179                                         03S0179
@DL00179 L     @08,WCNTPTR(,WORKPTR)                            03S0179
         ICM   @07,3,GRPEXCS(@08)                               03S0179
         BNM   @DC00179                                         03S0179
*                     IF CVRSKFLG=OFF&CVRFULL=OFF THEN/* ACTIVE 03S0180
*                                      REQUEST                       */
         TM    CVRSKFLG(REQPTR),B'10010000'                     03S0180
         BNZ   @RF00180                                         03S0180
*                       DO;         /* CHECK REQ FOR UNITS IN GROUP  */
*                                                               03S0181
*                         /*******************************************/
*                         /*                                         */
*                         /* SCAN GROUPS FOR REQUEST UNTIL GROUP IN  */
*                         /* QUESTION IS REACHED OR PASSED. IF UNITS */
*                         /* HAVE BEEN ALLOCATED TO GROUP, REDUCE    */
*                         /* ALLOCATION.                             */
*                         /*                                         */
*                         /*******************************************/
*                                                               03S0182
*                         GRPPTR=CVRGRPPT;/* LOCATE FIRST GROUP      */
         L     GRPPTR,CVRGRPPT(,REQPTR)                         03S0182
*                         GFOUNDSW=OFF;/* SET SWITCH TO ENTER LOOP   */
         NI    GFOUNDSW,B'11111011'                             03S0183
*                         DO INDEX6=1 TO CVRNGRP WHILE(GFOUNDSW=OFF);
         LA    INDEX6,1                                         03S0184
         B     @DE00184                                         03S0184
@DL00184 TM    GFOUNDSW,B'00000100'                             03S0184
         BNZ   @DC00184                                         03S0184
*                                   /* LOOP OVER LOCKED GROUPS UNTIL
*                                      MATCH FOUND                   */
*                           IF CVRGSKP=OFF THEN                 03S0185
         TM    CVRGSKP(GRPPTR),B'10000000'                      03S0185
         BNZ   @RF00185                                         03S0185
*                             DO;                               03S0186
*                               IF GRPIDENT<=CVRGRPID/* GROUP REACHED
*                                      OR PASSED?                    */
*                                 THEN/* YES                         */
         L     @08,WCNTPTR(,WORKPTR)                            03S0187
         LH    @15,GRPIDENT(,@08)                               03S0187
         LH    @14,CVRGRPID(,GRPPTR)                            03S0187
         CR    @15,@14                                          03S0187
         BH    @RF00187                                         03S0187
*                                 DO;                           03S0188
*                                   GFOUNDSW=ON;/* TERMINATE SCAN OF
*                                      GROUPS                        */
         OI    GFOUNDSW,B'00000100'                             03S0189
*                                   IF CVRGRPID=GRPIDENT/* GROUP
*                                      DESIRED?                      */
*                                       &CVRGALL>0/* ANY ALLOCATED?  */
*                                     THEN/* SOME ALLOCATED TO  03S0190
*                                      DESIRED GRP                   */
         CR    @14,@15                                          03S0190
         BNE   @RF00190                                         03S0190
         LH    @15,CVRGALL(,GRPPTR)                             03S0190
         LTR   @15,@15                                          03S0190
         BNP   @RF00190                                         03S0190
*                                    DO;                        03S0191
*                                     CVRGALL=CVRGALL-1;/* REDUCE
*                                      ALLOCATION                    */
         BCTR  @15,0                                            03S0192
         STH   @15,CVRGALL(,GRPPTR)                             03S0192
*                                     GRPEXCS=GRPEXCS+1;/* SHOW GROUP
*                                      NO LONGER PROBLEM             */
         LA    @15,1                                            03S0193
         LH    @14,GRPEXCS(,@08)                                03S0193
         ALR   @14,@15                                          03S0193
         STH   @14,GRPEXCS(,@08)                                03S0193
*                                     CVRNEED=CVRNEED+1;/* REQUEST
*                                      NOW NEEDS UNIT                */
         AH    @15,CVRNEED(,REQPTR)                             03S0194
         STH   @15,CVRNEED(,REQPTR)                             03S0194
*                                    END;/* END OF REDUCING REQUEST  */
*                                   ELSE                        03S0196
*                                    ;/* REQUEST DOESN'T USE DESIRED
*                                      GROUP OR NONE WERE ALLOCATED  */
@RF00190 DS    0H                                               03S0197
*                                 END;                          03S0197
*                               ELSE                            03S0198
*                                 ; /* GROUP NOT REACHED YET         */
@RF00187 DS    0H                                               03S0199
*                             END;                              03S0199
*                           ELSE                                03S0200
*                             ;                                 03S0200
@RF00185 DS    0H                                               03S0201
*                           GRPPTR=GRPPTR+LENGTH(CVRGPLST);/* LOCATE
*                                      NEXT GROUP                    */
         AH    GRPPTR,@CH00067                                  03S0201
*                         END;      /* END OF GROUP SCAN             */
         AH    INDEX6,@CH00051                                  03S0202
@DE00184 CH    INDEX6,CVRNGRP(,REQPTR)                          03S0202
         BNH   @DL00184                                         03S0202
@DC00184 DS    0H                                               03S0203
*                       END;        /* END OF CHECKING REQUEST       */
*                     ELSE                                      03S0204
*                       ;           /* NOT ACTIVE REQUEST            */
@RF00180 DS    0H                                               03S0205
*                     REQPTR=REQPTR+LENGTH(CVRRQLST);/* LOCATE NEXT
*                                      REQUEST                       */
         AH    REQPTR,@CH00250                                  03S0205
*                   END;            /* END OF REQUEST SCAN           */
         AH    INDEX5,@CH00051                                  03S0206
@DE00179 CH    INDEX5,CVRNREQ(,PARMPTR)                         03S0206
         BNH   @DL00179                                         03S0206
@DC00179 DS    0H                                               03S0207
*                 END;              /* END OF PROCESSING OF GROUP
*                                      WHICH IS OVER-ALLOCATED       */
*               ELSE                                            03S0208
*                 ;                 /* GROUP NOT OVER-ALLOCATED      */
@RF00176 DS    0H                                               03S0209
*               WORKPTR=WORKPTR+LENGTH(CVRWORKD);/* LOCATE NEXT ENTRY
*                                      OF CVRWORK                    */
         AH    WORKPTR,@CH00067                                 03S0209
*             END;                  /* END OF CVRWORK SCAN           */
@DE00175 TM    LASTFLAG(WORKPTR),B'10000000'                    03S0210
         BZ    @DL00175                                         03S0210
*             RESPECIFY                                         03S0211
*              (GRPCOUNT) BASED(CNTPTR);                        03S0211
*           END;                    /* END OF REDOSOL                */
*         END;                                                  02S0213
*       ELSE                                                    02S0214
*         ;                         /* GETMAIN FAILED                */
@RF00128 DS    0H                                               02S0215
*     END;                          /* END OF CVRINIT                */
*   ELSE                                                        01S0216
*     ;                             /* PARAMETERS INCORRECT          */
@RF00063 DS    0H                                               01S0217
*   IF RCODE=NOERROR                /* INITIALIZE WITHOUT ERROR?     */
*     THEN                          /* YES - CONTINUE PROCESSING     */
         LTR   RCODE,RCODE                                      01S0217
         BNZ   @RF00217                                         01S0217
*     DO;                                                       01S0218
*                                                               01S0218
*       /*************************************************************/
*       /*                                                           */
*       /* FIND SOLUTION IF POSSIBLE.                                */
*       /*                                                           */
*       /*************************************************************/
*                                                               01S0219
*       CALL FINDTRL;               /* FIND TRIAL SOLUTION BY   01S0219
*                                      INSPECTION                    */
         BAL   @14,FINDTRL                                      01S0219
*       RESPECIFY                                               01S0220
*        (R15) RESTRICTED;                                      01S0220
*       RCODE=R15;                  /* SAVE RETURN CODE              */
         LR    RCODE,R15                                        01S0221
*       IF RCODE^=NOERROR           /* WERE ALL REQUESTS SATISFIED?  */
*         THEN                      /* SOME REQUESTS NOT SATISFIED   */
         LTR   RCODE,RCODE                                      01S0222
         BZ    @RF00222                                         01S0222
*         DO;                                                   01S0223
*           CALL HUNG;              /* EXTEND SOLUTION               */
         BAL   @14,HUNG                                         01S0224
*           RCODE=R15;              /* SAVE RETURN CODE              */
         LR    RCODE,R15                                        01S0225
*         END;                                                  01S0226
*       ELSE                                                    01S0227
*         ;                         /* SOLUTION COMPLETE             */
@RF00222 DS    0H                                               01S0228
*       RESPECIFY                                               01S0228
*        (R15);                     /* RELEASE REGISTER              */
*                                                               01S0229
*       /*************************************************************/
*       /*                                                           */
*       /* REMOVE INADMISSIBLE COMBINATIONS IF ALL REQUESTS ARE      */
*       /* SATISFIED                                                 */
*       /*                                                           */
*       /*************************************************************/
*                                                               01S0229
*       IF RCODE=NOERROR            /* IS ALLOCATION SUCCESSFUL?     */
*         THEN                      /* ALLOCATION SUCCESSFUL         */
         LTR   RCODE,RCODE                                      01S0229
         BNZ   @RF00229                                         01S0229
*                                                               02S0230
*/********************************************************************/
*/*                                                                  */
*/* SEGMENT NAME - PTSREDUC                                          */
*/*                                                                  */
*/* DESCRIPTIVE NAME - REMOVE INELIGIBEL REQUEST/GROUP COMBINATIONS  */
*/*                                                                  */
*/* FUNCTION - TO DETERMINE FOR EACH REQUEST ALL THE GROUPS FROM     */
*/*            WHICH AT LEAST ONE UNIT CAN BE ALLOCATED WITHOUT      */
*/*            JEOPARDIZING THE FULL SOLUTION.                       */
*/*                                                                  */
*/* OPERATION -                                                      */
*/*      SCAN 1 - SCAN OF REQUESTS LOOKING FOR THOSE WHICH CAN USE   */
*/*            GROUPS WHICH HAVE EXCESS UNITS.  IF ANY ARE FOUND,    */
*/*            THIS PTS IS COMPLETED AND THE PTS NUMBER IS           */
*/*            INCREMENTED.                                          */
*/*      SCAN 2 - LOCATE FIRST ACTIVE REQUEST NOT YET IN PTS.        */
*/*            COMPLETE PTS.                                         */
*/*      REDUCE - WHEN ALL ACTIVE REQUESTS ARE INCLUDED IN SOME PTS, */
*/*            REMOVE GROUPS FROM REQUESTS WHERE GROUP AND REQUEST   */
*/*            ARE NOT IN SAME PTS.                                  */
*/*                                                                  */
*/* ENTRY - (INLINE SUBROUTINE - ENTERED AT TOP)                     */
*/*                                                                  */
*/*   PURPOSE - SEE FUNCTION                                         */
*/*                                                                  */
*/*   INPUT  - GRPCOUNT  GRPEXCS                                     */
*/*            CVRGPLST  CVRGALL                                     */
*/*                                                                  */
*/* EXIT - NORMAL - (INLINE SUBROUTINE - EXITS AT BOTTOM)            */
*/*                                                                  */
*/*   CONDITION - FUNCTION COMPLETE                                  */
*/*                                                                  */
*/*   OUTPUT - CVRRQLST  CVRPTS                                      */
*/*            CVRGPLST  CVRGALL                                     */
*/*                                                                  */
*/* IN-LINE SUBROUTINES                                              */
*/*            FINDEXCS            LOCATE GROUPS WITH UNASSIGNED     */
*/*                                UNITS                             */
*/*            FINDSTRT            LOCATE A REQUEST NOT YET IN PTS   */
*/*            ROWREACH            FIND REQUEST REACH OF SPECIFIED   */
*/*                                REQUEST                           */
*/*            REDUCE              FLAG GROUPS FROM WHICH ALLOCATION */
*/*                                MUST NOT BE MADE                  */
*/*            COLREACH            FIND GROUPS REACH OF SPECIFIED    */
*/*                                GROUPS OVER MARKED REQUESTS       */
*/*            FINDROWS            LOCATE REQUESTS HAVING SOLUTION   */
*/*                                ELEMENT IN SPECIFIED GROUPS.      */
*/*                                                                  */
*/********************************************************************/
*                                                               02S0230
*         DO;                       /* START OF PTSREDUC             */
*           PTSN=PTSINIT;           /* ID OF FIRST PTS               */
         LA    PTSN,1                                           02S0231
*           RESPECIFY                                           02S0232
*            (CVRWORKD) BASED(GRPWPTR);                         02S0232
*                                                               02S0232
*           /*********************************************************/
*           /*                                                       */
*           /* LOCATE GROUPS WITH EXCESS UNITS AND REQUESTS WHICH USE*/
*           /* THEM                                                  */
*           /*                                                       */
*           /*********************************************************/
*                                                               02S0233
*                                                               03S0233
*/********************************************************************/
*/*                                                                  */
*/* SEGMENT NAME - FINDEXCS                                          */
*/*                                                                  */
*/* DESCRIPTIVE NAME - LOCATE GROUPS WITH UNASSIGNED UNITS           */
*/*                                                                  */
*/* FUNCTION - TO FIND GROUPS WITH UNUSED UNITS AND SET UP FLAGS     */
*/*                                                                  */
*/* OPERATION -                                                      */
*/*  INITIALLY - SET WPTS TO 0 FOR ALL GROUP                         */
*/*      SCAN EACH ACTIVE REQUEST LOOKING FOR GROUP WITH EXCESS      */
*/*            UNITS.  MARK THE GROUP WITH THE PTS NUMBER.  IF       */
*/*            REQUEST HAS A GROUP WITH EXCESS UNITS, RESCAN         */
*/*            REQUEST AND FLAG ALL SOLUTION GROUPS FOR GROUP REACH. */
*/*            SET FLAG INDICATING EXCESS HAS BEEN FOUND.            */
*/*                                                                  */
*/* ENTRY - (INLINE SUBROUTINE - ENTERED AT TOP)                     */
*/*                                                                  */
*/*   PURPOSE - SEE FUNCTION                                         */
*/*                                                                  */
*/*   INPUT  - GRPCOUNT  GRPEXCS                                     */
*/*                                                                  */
*/* EXIT - NORMAL - (INLINE SUBROUTINE - EXIT AT BOTTOM)             */
*/*                                                                  */
*/*   CONDITION - FUNCTION COMPLETE                                  */
*/*                                                                  */
*/*   OUTPUT - CVRRQLST  CVRPTS    INIT TO 0                         */
*/*                      CVRREACH  INIT ON FOR GROUP REACH OVER      */
*/*                                EXCESS                            */
*/*            CVRWORKD  WPTS      PTS NUMBER - GROUP WITH EXCESS    */
*/*                                -1 - SOLUTION GROUP FOR REQUEST   */
*/*                                     WITH EXCESS UNITS            */
*/*                                0 - NONE OF ABOVE                 */
*/*            EXCESSSW            0 - NO REQUEST CAN USE GROUP WITH */
*/*                                     EXCESS                       */
*/*                                1 - SOME REQUEST CAN USE GROUP    */
*/*                                                                  */
*/********************************************************************/
*                                                               03S0233
*           DO;                     /* START OF FINDEXCS             */
*                                                               03S0233
*             /*******************************************************/
*             /*                                                     */
*             /* INITIALIZE WPTS TO 0 IN ALL WORK AREA ENTRIES       */
*             /*                                                     */
*             /*******************************************************/
*                                                               03S0234
*             RESPECIFY                                         03S0234
*              (CVRWORKD) BASED(WORKPTR);                       03S0234
*             WORKPTR=ACVRWORK;     /* LOCATE FIRST ENTRY            */
         L     WORKPTR,ACVRWORK                                 03S0235
*             DO WHILE(LASTFLAG=OFF);/* SCAN ALL ENTRIES             */
         B     @DE00236                                         03S0236
@DL00236 DS    0H                                               03S0237
*               WPTS=NOPTS;         /* INIT TO 0                     */
         SLR   @15,@15                                          03S0237
         STH   @15,WPTS(,WORKPTR)                               03S0237
*               WORKPTR=WORKPTR+LENGTH(CVRWORKD);/* LOCATE NEXT ENTRY*/
         AH    WORKPTR,@CH00067                                 03S0238
*             END;                  /* END CVRWORK SCAN              */
@DE00236 TM    LASTFLAG(WORKPTR),B'10000000'                    03S0239
         BZ    @DL00236                                         03S0239
*             RESPECIFY                                         03S0240
*              (CVRWORKD) BASED(GRPWPTR);                       03S0240
*             EXCESSSW=OFF;         /* INITIALIZE SWITCH             */
*                                                               03S0241
         NI    EXCESSSW,B'11011111'                             03S0241
*             /*******************************************************/
*             /*                                                     */
*             /* SCAN ALL REQUESTS TO SET UP FLAGS AND SEARCH FOR    */
*             /* EXCESS UNITS                                        */
*             /*                                                     */
*             /*******************************************************/
*                                                               03S0242
*             REQPTR=CVRRQPTR;      /* LOCATE FIRST REQUEST          */
         L     REQPTR,CVRRQPTR(,PARMPTR)                        03S0242
*             DO INDEX7=1 TO CVRNREQ;/* LOOP OVER ALL REQUESTS       */
         LA    INDEX7,1                                         03S0243
         B     @DE00243                                         03S0243
@DL00243 DS    0H                                               03S0244
*               IF CVRSKFLG=OFF     /* IS REQUEST TO BE PROCESSED?   */
*                 THEN              /* REQUEST TO BE PROCESSED       */
         TM    CVRSKFLG(REQPTR),B'10000000'                     03S0244
         BNZ   @RF00244                                         03S0244
*                 DO;               /* START OF PROCESSING ONE REQ.  */
*                   CVRPTS=NOPTS;   /* PTS NUMBER INIT TO 0          */
         SLR   @06,@06                                          03S0246
         STH   @06,CVRPTS(,REQPTR)                              03S0246
*                   IF CVRFULL=OFF  /* REQUEST ALL BOUND?            */
*                     THEN          /* REQUEST NOT ALL BOUND         */
         TM    CVRFULL(REQPTR),B'00010000'                      03S0247
         BNZ   @RF00247                                         03S0247
*                     DO;           /* SEARCH FOR EXCESS             */
*                       CVRREACH=ON;/* MARK REQUEST REACHED FOR USE
*                                      IN GROUP SCAN                 */
         OI    CVRREACH(REQPTR),B'00100000'                     03S0249
*                       FOUNDSW=OFF;/* NO EXCESS UNITS FOUND FOR THIS
*                                      REQUEST (YET)                 */
*                                                               03S0250
         NI    FOUNDSW,B'10111111'                              03S0250
*                       /*********************************************/
*                       /*                                           */
*                       /* SCAN GROUPS FOR REQUEST LOOKING FOR ONE   */
*                       /* WITH EXCESS UNITS                         */
*                       /*                                           */
*                       /*********************************************/
*                                                               03S0251
*                       GRPPTR=CVRGRPPT;/* LOCATE FIRST GROUP        */
         L     GRPPTR,CVRGRPPT(,REQPTR)                         03S0251
*                       DO INDEX8=1 TO CVRNGRP WHILE(CVRGRPID<=CVRGRPLK
*                             );                                03S0252
         LA    INDEX8,1                                         03S0252
         B     @DE00252                                         03S0252
@DL00252 LH    @06,CVRGRPID(,GRPPTR)                            03S0252
         CH    @06,CVRGRPLK(,PARMPTR)                           03S0252
         BH    @DC00252                                         03S0252
*                         IF CVRGSKP=OFF THEN                   03S0253
         TM    CVRGSKP(GRPPTR),B'10000000'                      03S0253
         BNZ   @RF00253                                         03S0253
*                           DO;                                 03S0254
*                             CNTPTR=CVRGCPTR;/* LOCATE GRPCOUNT
*                                      ENTRY                         */
         L     CNTPTR,CVRGCPTR(,GRPPTR)                         03S0255
*                             IF GRPEXCS>0/* ANY EXCESS UNITS?       */
*                               THEN/* EXCESS UNITS FOUND            */
         ICM   @15,3,GRPEXCS(CNTPTR)                            03S0256
         BNP   @RF00256                                         03S0256
*                               DO;                             03S0257
*                                 FOUNDSW=ON;/* SET FLAG TO SHOW
*                                      EXCESS FOUND                  */
         OI    FOUNDSW,B'01000000'                              03S0258
*                                 WPTS=PTSN;/* FLAG GROUP            */
         L     @01,GRPWPTR(,CNTPTR)                             03S0259
         STH   PTSN,WPTS(,@01)                                  03S0259
*                               END;                            03S0260
*                           END;                                03S0261
*                         ELSE                                  03S0262
*                           ;                                   03S0262
@RF00253 DS    0H                                               03S0263
*                         GRPPTR=GRPPTR+LENGTH(CVRGPLST);       03S0263
@RC00253 AH    GRPPTR,@CH00067                                  03S0263
*                       END;        /* END GROUP SCAN                */
         AH    INDEX8,@CH00051                                  03S0264
@DE00252 CH    INDEX8,CVRNGRP(,REQPTR)                          03S0264
         BNH   @DL00252                                         03S0264
@DC00252 DS    0H                                               03S0265
*                       IF FOUNDSW=ON/* WAS GROUP WITH EXCESS FOUND? */
*                         THEN      /* GROUP FOUND WITH EXCESS       */
         TM    FOUNDSW,B'01000000'                              03S0265
         BNO   @RF00265                                         03S0265
*                         DO;                                   03S0266
*                           EXCESSSW=ON;/* SET GENERAL SWITCH THAT
*                                      EXCESS WAS FOUND FOR SOME
*                                      REQUEST                       */
*                                                               03S0267
         OI    EXCESSSW,B'00100000'                             03S0267
*                           /*****************************************/
*                           /*                                       */
*                           /* SCAN GROUPS FOR THIS REQUEST AGAIN,   */
*                           /* THIS TIME FOR SOLUTION GROUPS.        */
*                           /*                                       */
*                           /*****************************************/
*                                                               03S0268
*                           GRPPTR=CVRGRPPT;                    03S0268
         L     GRPPTR,CVRGRPPT(,REQPTR)                         03S0268
*                           DO INDEX9=1 TO CVRNGRP WHILE(CVRGRPID<=
*                                 CVRGRPLK);                    03S0269
         LA    INDEX9,1                                         03S0269
         B     @DE00269                                         03S0269
@DL00269 LH    @06,CVRGRPID(,GRPPTR)                            03S0269
         CH    @06,CVRGRPLK(,PARMPTR)                           03S0269
         BH    @DC00269                                         03S0269
*                             IF CVRGSKP=OFF THEN               03S0270
         TM    CVRGSKP(GRPPTR),B'10000000'                      03S0270
         BNZ   @RF00270                                         03S0270
*                               DO;                             03S0271
*                                 IF CVRGALL>0/* THIS GROUP USED IN
*                                      SOLUTION?                     */
*                                   THEN/* THIS GROUP USED IN   03S0272
*                                      SOLUTION                      */
         SLR   @06,@06                                          03S0272
         CH    @06,CVRGALL(,GRPPTR)                             03S0272
         BNL   @RF00272                                         03S0272
*                                   DO;                         03S0273
*                                    CNTPTR=CVRGCPTR;           03S0274
         L     CNTPTR,CVRGCPTR(,GRPPTR)                         03S0274
*                                    IF WPTS=NOPTS/* GROUP REACHED
*                                      YET?                          */
*                                      THEN/* GROUP NOT REACHED YET  */
         SLR   @15,@15                                          03S0275
         L     @14,GRPWPTR(,CNTPTR)                             03S0275
         CH    @15,WPTS(,@14)                                   03S0275
         BNE   @RF00275                                         03S0275
*                                     WPTS=PTSFLAG;/* FLAG GROUP     */
         MVC   WPTS(2,@14),@CH00125                             03S0276
*                                   END;/* END OF PROCESSING SOLUTION
*                                      GRP                           */
*                               END;                            03S0278
*                             ELSE                              03S0279
*                               ;                               03S0279
@RF00270 DS    0H                                               03S0280
*                             GRPPTR=GRPPTR+LENGTH(CVRGPLST);   03S0280
@RC00270 AH    GRPPTR,@CH00067                                  03S0280
*                           END;    /* END OF GROUP SCAN             */
         AH    INDEX9,@CH00051                                  03S0281
@DE00269 CH    INDEX9,CVRNGRP(,REQPTR)                          03S0281
         BNH   @DL00269                                         03S0281
@DC00269 DS    0H                                               03S0282
*                         END;      /* END OF PROCESSING REQUEST WITH
*                                      EXCESS UNITS                  */
*                     END;          /* END OF SEARCH FOR EXCESS      */
*                   ELSE            /* REQUEST ALL BOUND             */
*                     CVRREACH=OFF; /* REQUEST NOT REACHED           */
         B     @RC00247                                         03S0284
@RF00247 NI    CVRREACH(REQPTR),B'11011111'                     03S0284
*                 END;              /* END OF PROCESSING REQUEST     */
@RC00247 DS    0H                                               03S0286
*               REQPTR=REQPTR+LENGTH(CVRRQLST);/* LOCATE NEXT REQUEST*/
@RF00244 AH    REQPTR,@CH00250                                  03S0286
*             END;                  /* END OF REQUEST SCAN           */
         AH    INDEX7,@CH00051                                  03S0287
@DE00243 CH    INDEX7,CVRNREQ(,PARMPTR)                         03S0287
         BNH   @DL00243                                         03S0287
*           END;                    /* END OF FINDEXCS               */
*           IF EXCESSSW=ON          /* ARE THERE ANY USABLE GROUPS
*                                      WITH EXCESS UNITS?            */
*             THEN                  /* THERE ARE GRPS WITH EXCESS    */
         TM    EXCESSSW,B'00100000'                             02S0289
         BNO   @RF00289                                         02S0289
*             DO;                                               02S0290
*               CALL COLREACH;      /* FIND GROUP REACH OF THESE GRPS*/
         BAL   @14,COLREACH                                     02S0291
*               CALL FINDROWS;      /* FIND REQUESTS USING THESE NEW
*                                      GROUPS                        */
         BAL   @14,FINDROWS                                     02S0292
*               PTSN=PTSN+PTSINCR;  /* SET ID TO NEXT PTS NUMBER     */
         AH    PTSN,@CH00051                                    02S0293
*             END;                  /* END OF PROCESSING CASE WHERE
*                                      THERE IS EXCESS               */
*           DONESW=OFF;             /* INIT LOOP CONTROL VAR         */
*                                                               02S0295
@RF00289 NI    DONESW,B'01111111'                               02S0295
*           /*********************************************************/
*           /*                                                       */
*           /* LOCATE REQUEST NOT YET IN PTS AND FIND PTS CONTAINING */
*           /* IT. TERMINATE LOOP WHEN ALL ACTIVE REQUESTS ARE IN    */
*           /* PTS.                                                  */
*           /*                                                       */
*           /*********************************************************/
*                                                               02S0296
*           DO WHILE(DONESW=OFF);   /* ITERATE UNTIL ALL REQUESTS ARE
*                                      IN PTS                        */
         B     @DE00296                                         02S0296
@DL00296 DS    0H                                               02S0297
*                                                               03S0297
*/********************************************************************/
*/*                                                                  */
*/* SEGMENT NAME - FINDSTRT                                          */
*/*                                                                  */
*/* DESCRIPTIVE NAME - FIND FIRST REQUEST                            */
*/*                                                                  */
*/* FUNCTION - TO FIND FIRST REQUEST NOT IN PTS OR TO DETECT         */
*/*            COMPLETION                                            */
*/*                                                                  */
*/* OPERATION -                                                      */
*/*      REQUEST SCAN - SCAN ACTIVE REQUESTS TURNING OFF REACH FLAG  */
*/*            AND SEARCHING FOR FIRST REQUEST NOT IN ANY PTS.  PUT  */
*/*            POINTER TO THIS REQUEST INTO STARTR.  IF NO REQUEST   */
*/*            IS FOUND, SET DONE FLAG ON.                           */
*/*      WORK AREA SCAN - EXECUTED ONLY IF REQUEST NOT IN PTS WAS    */
*/*            FOUND.  TURN OFF USED FLAG FOR EACH GROUP             */
*/*                                                                  */
*/* ENTRY - (INLINE SUBROUTINE - ENTERED AT TOP)                     */
*/*                                                                  */
*/*   INPUT  - CVRRQLST  CVRPTS    0 - REQUEST NOT IN PTS            */
*/*                                OTHER - REQUEST IN PTS            */
*/*                      CVRFULL   1 - REQUEST TO BE IGNORED         */
*/*                                                                  */
*/* EXIT - (INLINE SUBROUTINE - EXITS AT BOTTOM)                     */
*/*                                                                  */
*/*   OUTPUT - CVRRQLST  CVRREACH  INIT TO 0                         */
*/*            CVRWORKD  WGUSED    INIT TO 0                         */
*/*            STARTR              FIRST REQUEST NOT IN PTS OR       */
*/*                                0 IF ALL IN PTS                   */
*/*            DONESW              1 IF ALL ACTIVE REQUESTS IN PTS   */
*/*                                                                  */
*/********************************************************************/
*                                                               03S0297
*             DO;                   /* START OF FINDSTRT             */
*               STARTR=INITVAL;     /* INITIALIZE PTR TO FIRST  03S0298
*                                      REQUEST NOT IN PTS            */
*                                                               03S0298
         SLR   STARTR,STARTR                                    03S0298
*               /*****************************************************/
*               /*                                                   */
*               /* SCAN REQUESTS INITIALIZING FLAGS AND LOOKING FOR  */
*               /* ONE NOT YET IN ANY PTS (CVRPTS=0).                */
*               /*                                                   */
*               /*****************************************************/
*                                                               03S0299
*               REQPTR=CVRRQPTR;    /* LOCATE FIRST REQUEST          */
         L     REQPTR,CVRRQPTR(,PARMPTR)                        03S0299
*               DO INDEX15=1 TO CVRNREQ;/* SET UP LOOP CONTROL FOR
*                                      SCAN                          */
         LA    INDEX15,1                                        03S0300
         B     @DE00300                                         03S0300
@DL00300 DS    0H                                               03S0301
*                 IF CVRSKFLG=OFF   /* IS REQUEST TO BE PROCESSED?   */
*                     &CVRFULL=OFF  /* REQUEST ALL BOUND?            */
*                   THEN            /* REQUEST IS TO PROCESSED       */
         TM    CVRSKFLG(REQPTR),B'10010000'                     03S0301
         BNZ   @RF00301                                         03S0301
*                   DO;                                         03S0302
*                     CVRREACH=OFF; /* MARK REQUEST NO YET REACHED   */
         NI    CVRREACH(REQPTR),B'11011111'                     03S0303
*                     IF CVRPTS=NOPTS/* IS THIS FIRST UNUSED REQUEST?*/
*                         &STARTR=INITVAL THEN/* FIRST REQUEST NOT IN
*                                      PTS                           */
         SLR   @06,@06                                          03S0304
         CH    @06,CVRPTS(,REQPTR)                              03S0304
         BNE   @RF00304                                         03S0304
         CR    STARTR,@06                                       03S0304
         BNE   @RF00304                                         03S0304
*                       STARTR=REQPTR;/* SAVE PTR TO REQUEST         */
         LR    STARTR,REQPTR                                    03S0305
*                   END;            /* END PROCESSING FO ONE REQ     */
@RF00304 DS    0H                                               03S0307
*                 REQPTR=REQPTR+LENGTH(CVRRQLST);/* LOCATE NEXT 03S0307
*                                      REQUEST                       */
@RF00301 AH    REQPTR,@CH00250                                  03S0307
*               END;                /* END REQUEST SCAN              */
         AH    INDEX15,@CH00051                                 03S0308
@DE00300 CH    INDEX15,CVRNREQ(,PARMPTR)                        03S0308
         BNH   @DL00300                                         03S0308
*               IF STARTR=INITVAL   /* IS EVERY REQUEST IN A PTS?    */
*                 THEN              /* EVERY REQUEST IS IN PTS       */
         LTR   STARTR,STARTR                                    03S0309
         BNZ   @RF00309                                         03S0309
*                 DONESW=ON;        /* PTS IDENTIFICATION IS DONE    */
         OI    DONESW,B'10000000'                               03S0310
*               ELSE                /* SOME REQUEST NOT IN PTS YET   */
*                 DO;                                           03S0311
*                                                               03S0311
         B     @RC00309                                         03S0311
@RF00309 DS    0H                                               03S0312
*                   /*************************************************/
*                   /*                                               */
*                   /* SCAN CVRWORK TURNING OFF 'USED' BIT FOR EACH  */
*                   /* GROUP                                         */
*                   /*                                               */
*                   /*************************************************/
*                                                               03S0312
*                   WORKPTR=ACVRWORK;/* LOCATE START OF CVRWORK      */
         L     WORKPTR,ACVRWORK                                 03S0312
*                   DO WHILE(WORKPTR->LASTFLAG=OFF);            03S0313
         B     @DE00313                                         03S0313
@DL00313 DS    0H                                               03S0314
*                     WORKPTR->WGUSED=OFF;/* TURN OFF FLAG           */
         NI    WGUSED(WORKPTR),B'10111111'                      03S0314
*                     WORKPTR=WORKPTR+LENGTH(CVRWORKD);/* LOCATE NEXT
*                                      ENTRY                         */
         AH    WORKPTR,@CH00067                                 03S0315
*                   END;            /* END SCAN OF CVRWORK           */
@DE00313 TM    LASTFLAG(WORKPTR),B'10000000'                    03S0316
         BZ    @DL00313                                         03S0316
*                 END;              /* END HANDLING REQUEST NOT IN
*                                      PTS                           */
*             END;                  /* END FINDSTRT                  */
@RC00309 DS    0H                                               03S0319
*             IF DONESW=OFF         /* IS ANY REQUEST NOT IN PTS?    */
*               THEN                /* SOME REQUEST NOT IN PTS       */
         TM    DONESW,B'10000000'                               02S0319
         BNZ   @RF00319                                         02S0319
*               DO;                                             02S0320
*                                                               03S0321
*/********************************************************************/
*/*                                                                  */
*/* SEGMENT NAME - ROWREACH                                          */
*/*                                                                  */
*/* DESCRIPTIVE NAME - FIND REQUEST REACH                            */
*/*                                                                  */
*/* FUNCTION - TO FIND ROW REACH OF STARTR                           */
*/*                                                                  */
*/* OPERATION -                                                      */
*/*      STARTING SCAN - SET PTSFLAG FOR SOLUTION GROUPS FOR         */
*/*            STARTING REQUEST.  IT WILL BE USED BY COLREACH LATER. */
*/*      REACH LOOP - EACH ITERATION FINDS THE DIRECT REACH OF       */
*/*            REQUESTS FOUND IN THE PREVIOUS ITERATION.  A REACHED  */
*/*            REQUEST HAS CVRREACH ON, ONE WHOSE REACH HAS BEEN     */
*/*            FOUND HAS CVRRUSED ON AS WELL.                        */
*/*        REQUEST SCAN 1 - MARK (BY SETTING WGUSED ON) ALL GROUPS   */
*/*            WHICH COULD BE USED BY REACHED REQUESTS WHICH HAVE    */
*/*            NOT YET BEEN USED.  MARK EACH REACHED REQUEST USED.   */
*/*        REQUEST SCAN 2 - FINDS REACHED REQUESTS.  SCAN ALL        */
*/*            UNREACHED REQUESTS.  ANY WHICH HAS A GROUP WITH       */
*/*            WGUSED ON AS A SOLUTION GROUP IS MARKED REACHED.  IF  */
*/*            NONE IS FOUND, SET SWITCH TO TERMINATE OUTER LOOP.    */
*/*                                                                  */
*/*   INPUT  - STARTR              POINTER TO STARTING REQUEST       */
*/*            CVRGPLST  CVRGALL   >0, SOLUTION GROUP                */
*/*                                                                  */
*/* EXIT - NORMAL - (INLINE SUBROUTINE - EXITS AT BOTTOM)            */
*/*                                                                  */
*/*   CONDITION - FUNCTION COMPLETE                                  */
*/*                                                                  */
*/*   OUTPUT - CVRRQLST  CVRREACH  ON FOR REACHED REQUESTS           */
*/*            CVRWORKD  WTPS      -1 FOR SOLUTION GROUPS OF         */
*/*                                   STARTING REQUEST               */
*/*                                                                  */
*/********************************************************************/
*                                                               03S0321
*                 DO;               /* START OF ROWREACH             */
*                   STARTR->CVRREACH=ON;/* MARK STARTING REQUEST
*                                      REACHED                       */
*                   STARTR->CVRRUSED=OFF;/* MARK STARTING REQUEST NOT
*                                      YET USED                      */
*                                                               03S0323
         OI    CVRREACH(STARTR),B'00100000'                     03S0323
         NI    CVRRUSED(STARTR),B'10111111'                     03S0323
*                   /*************************************************/
*                   /*                                               */
*                   /* MARK SOLUTION GROUPS IN STARTING REQUEST FOR  */
*                   /* LATER REFERENCE                               */
*                   /*                                               */
*                   /*************************************************/
*                                                               03S0324
*                   GRPPTR=STARTR->CVRGRPPT;/* LOCATE FIRST GROUP    */
         L     GRPPTR,CVRGRPPT(,STARTR)                         03S0324
*                   DO INDEX16=1 TO STARTR->CVRNGRP WHILE(CVRGRPID<=
*                         CVRGRPLK);/* SET UP LOOP CONTROL OVER 03S0325
*                                      LOCKED GROUPS OF STARTING ROW */
         LA    INDEX16,1                                        03S0325
         B     @DE00325                                         03S0325
@DL00325 LH    @06,CVRGRPID(,GRPPTR)                            03S0325
         CH    @06,CVRGRPLK(,PARMPTR)                           03S0325
         BH    @DC00325                                         03S0325
*                     IF CVRGSKP=OFF THEN                       03S0326
         TM    CVRGSKP(GRPPTR),B'10000000'                      03S0326
         BNZ   @RF00326                                         03S0326
*                       DO;                                     03S0327
*                         IF CVRGALL>0/* IS THIS GROUP A SOLUTION
*                                      GRP?                          */
*                           THEN    /* GROUP IS SOLUTION GROUP       */
         ICM   @06,3,CVRGALL(GRPPTR)                            03S0328
         BNP   @RF00328                                         03S0328
*                           DO;                                 03S0329
*                             CNTPTR=CVRGCPTR;/* LOCATE GRPCOUNT
*                                      ENTRY                         */
         L     CNTPTR,CVRGCPTR(,GRPPTR)                         03S0330
*                             WPTS=PTSFLAG;/* MARK GROUP             */
         L     @04,GRPWPTR(,CNTPTR)                             03S0331
         MVC   WPTS(2,@04),@CH00125                             03S0331
*                           END;    /* END PROCESSING SOLUTION GROUP */
*                         ELSE                                  03S0333
*                           ;       /* NOT A SOLUTION GROUP          */
@RF00328 DS    0H                                               03S0334
*                       END;                                    03S0334
*                     ELSE                                      03S0335
*                       ;                                       03S0335
@RF00326 DS    0H                                               03S0336
*                     GRPPTR=GRPPTR+LENGTH(CVRGPLST);/* LOCATE NEXT
*                                      GROUP                         */
         AH    GRPPTR,@CH00067                                  03S0336
*                   END;            /* END OF GROUP SCAN             */
*                                                               03S0337
         AH    INDEX16,@CH00051                                 03S0337
@DE00325 CH    INDEX16,CVRNGRP(,STARTR)                         03S0337
         BNH   @DL00325                                         03S0337
@DC00325 DS    0H                                               03S0338
*                   /*************************************************/
*                   /*                                               */
*                   /* SCAN ALL REQUESTS LOOKING FOR REQUESTS        */
*                   /* REACHABLE FROM THOSE REQUESTS REACHED IN      */
*                   /* PREVIOUS PASS (OR STARTING REQUEST IF FIRST   */
*                   /* PASS) UNTIL NO MORE REQUESTS ARE REACHED.     */
*                   /*                                               */
*                   /*************************************************/
*                                                               03S0338
*                   RREACHSW=ON;    /* INITIALIZE LOOP CONTROL  03S0338
*                                      VARIABLE TO FORCE LOOP TO BE
*                                      ENTERED                       */
         OI    RREACHSW,B'00001000'                             03S0338
*                   DO WHILE(RREACHSW=ON);/* CONTINUE SEARCH UNTIL NO
*                                      REQUEST IS REACHED            */
*                                                               03S0339
         B     @DE00339                                         03S0339
@DL00339 DS    0H                                               03S0340
*                     /***********************************************/
*                     /*                                             */
*                     /* SCAN REQUESTS LOOKING FOR THOSE WHICH HAVE  */
*                     /* BEEN REACHED BUT NOT USED. THE GROUPS OF    */
*                     /* SUCH REQUESTS ARE MARKED FOR USE IN NEXT    */
*                     /* SCAN OF REQUESTS.                           */
*                     /*                                             */
*                     /***********************************************/
*                                                               03S0340
*                     REQPTR=CVRRQPTR;/* LOCATE FIRST REQUEST        */
         L     REQPTR,CVRRQPTR(,PARMPTR)                        03S0340
*                     DO INDEX17=1 TO CVRNREQ;/* SET UP LOOP CTL OVER
*                                      REQUESTS                      */
         LA    INDEX17,1                                        03S0341
         B     @DE00341                                         03S0341
@DL00341 DS    0H                                               03S0342
*                       IF CVRSKFLG=OFF&CVRREACH=ON&CVRRUSED=OFF THEN
         TM    CVRREACH(REQPTR),B'00100000'                     03S0342
         BNO   @RF00342                                         03S0342
         TM    CVRSKFLG(REQPTR),B'11000000'                     03S0342
         BNZ   @RF00342                                         03S0342
*                                   /* REQ REACHED BUT NOT YET USED  */
*                         DO;                                   03S0343
*                           GRPPTR=CVRGRPPT;/* LOCATE FIRST GROUP    */
*                                                               03S0344
         L     GRPPTR,CVRGRPPT(,REQPTR)                         03S0344
*                           /*****************************************/
*                           /*                                       */
*                           /* MARK ALL GROUPS FOR THIS REQUEST AS   */
*                           /* REACHED                               */
*                           /*                                       */
*                           /*****************************************/
*                                                               03S0345
*                           DO INDEX14=1 TO CVRNGRP WHILE(CVRGRPID<=
*                                 CVRGRPLK);/* SET UP LOOP CONTROL
*                                      OVER LOCKED GROUPS            */
         LA    INDEX14,1                                        03S0345
         B     @DE00345                                         03S0345
@DL00345 LH    @06,CVRGRPID(,GRPPTR)                            03S0345
         CH    @06,CVRGRPLK(,PARMPTR)                           03S0345
         BH    @DC00345                                         03S0345
*                             IF CVRGSKP=OFF THEN               03S0346
         TM    CVRGSKP(GRPPTR),B'10000000'                      03S0346
         BNZ   @RF00346                                         03S0346
*                               DO;                             03S0347
*                                 CNTPTR=CVRGCPTR;/* LOCATE GRPCOUNT
*                                      ENTRY                         */
         L     CNTPTR,CVRGCPTR(,GRPPTR)                         03S0348
*                                 WGUSED=ON;/* MARK GROUP REACHED    */
         L     @01,GRPWPTR(,CNTPTR)                             03S0349
         OI    WGUSED(@01),B'01000000'                          03S0349
*                               END;                            03S0350
*                             ELSE                              03S0351
*                               ;                               03S0351
@RF00346 DS    0H                                               03S0352
*                             GRPPTR=GRPPTR+LENGTH(CVRGPLST);/* 03S0352
*                                      LOCATE NEXT GROUP             */
         AH    GRPPTR,@CH00067                                  03S0352
*                           END;    /* END OF GROUP SCAN             */
         AH    INDEX14,@CH00051                                 03S0353
@DE00345 CH    INDEX14,CVRNGRP(,REQPTR)                         03S0353
         BNH   @DL00345                                         03S0353
@DC00345 DS    0H                                               03S0354
*                           CVRRUSED=ON;/* MARK REQUEST USED         */
         OI    CVRRUSED(REQPTR),B'01000000'                     03S0354
*                         END;      /* END OF PROCESSING OF REACHED
*                                      REQUEST                       */
*                       ELSE                                    03S0356
*                         ;         /* REQ TO BE SKIPPED OR NOT 03S0356
*                                      REACHED OR ALREADY USED       */
@RF00342 DS    0H                                               03S0357
*                       REQPTR=REQPTR+LENGTH(CVRRQLST);/* LOCATE NEXT
*                                      REQUEST                       */
         AH    REQPTR,@CH00250                                  03S0357
*                     END;          /* END OF REQUEST SCAN           */
         AH    INDEX17,@CH00051                                 03S0358
@DE00341 CH    INDEX17,CVRNREQ(,PARMPTR)                        03S0358
         BNH   @DL00341                                         03S0358
*                     RREACHSW=OFF; /* ASSUME NO REACH UNTIL ONE
*                                      FOUND                         */
*                                                               03S0359
         NI    RREACHSW,B'11110111'                             03S0359
*                     /***********************************************/
*                     /*                                             */
*                     /* SCAN ALL REQUESTS WHICH ARE NOT YET IN A PTS*/
*                     /* AND WHICH HAVE NOT BEEN REACHED AND EXAMINE */
*                     /* THEM TO SEE WHETHER A MARKED GROUP IS A     */
*                     /* SOLUTION GROUP FOR THESE REQUESTS. IF A     */
*                     /* REQUEST HAS ONE OF THESE GROUPS FOR A       */
*                     /* SOLUTION GROUP, MARK IT REACHED.            */
*                     /*                                             */
*                     /***********************************************/
*                                                               03S0360
*                     REQPTR=CVRRQPTR;/* LOCATE FIRST REQUEST        */
         L     REQPTR,CVRRQPTR(,PARMPTR)                        03S0360
*                     DO INDEX18=1 TO CVRNREQ;/* SET UP LOOP CONTROL
*                                      OVER REQ                      */
         LA    INDEX18,1                                        03S0361
         B     @DE00361                                         03S0361
@DL00361 DS    0H                                               03S0362
*                       IF CVRSKFLG=OFF&CVRFULL=OFF&^(CVRREACH=ON)&
*                           CVRPTS=NOPTS THEN/* REQUEST NOT REACHED
*                                      OR IN PTS                     */
         TM    CVRSKFLG(REQPTR),B'10110000'                     03S0362
         BNZ   @RF00362                                         03S0362
         ICM   @03,3,CVRPTS(REQPTR)                             03S0362
         BNZ   @RF00362                                         03S0362
*                         DO;                                   03S0363
*                           GRPPTR=CVRGRPPT;/* LOCATE FIRST GROUP    */
*                                                               03S0364
         L     GRPPTR,CVRGRPPT(,REQPTR)                         03S0364
*                           /*****************************************/
*                           /*                                       */
*                           /* EXAMINE GROUPS FOR THIS REQUEST       */
*                           /* LOOKING FOR ONE WHICH HAS BEEN        */
*                           /* REACHED. WHEN ONE IS FOUND, MARK THE  */
*                           /* REQUEST REACHED AND SET FLAG          */
*                           /* INDICATING A REACH HAS BEEN FOUND IN  */
*                           /* THIS PASS.                            */
*                           /*                                       */
*                           /*****************************************/
*                                                               03S0365
*                           DO INDEX19=1 TO CVRNGRP WHILE(CVRGRPID<=
*                                 CVRGRPLK&^(CVRREACH=ON));/* SCAN
*                                      UNLOCKED GROUPS UNTIL ONE IS
*                                      FOUND WHICH IS MARKED         */
         LA    INDEX19,1                                        03S0365
         B     @DE00365                                         03S0365
@DL00365 LH    @06,CVRGRPID(,GRPPTR)                            03S0365
         CH    @06,CVRGRPLK(,PARMPTR)                           03S0365
         BH    @DC00365                                         03S0365
         TM    CVRREACH(REQPTR),B'00100000'                     03S0365
         BO    @DC00365                                         03S0365
*                             IF CVRGSKP=OFF THEN               03S0366
         TM    CVRGSKP(GRPPTR),B'10000000'                      03S0366
         BNZ   @RF00366                                         03S0366
*                               DO;                             03S0367
*                                 CNTPTR=CVRGCPTR;/* LOCATE GRPCOUNT
*                                      ENTRY                         */
         L     CNTPTR,CVRGCPTR(,GRPPTR)                         03S0368
*                                 IF CVRGALL>0&WGUSED=ON/* IS THIS
*                                      MARKED SOLUTION GROUP?        */
*                                   THEN/* SOLUTION GROUP AND MARKED */
         ICM   @15,3,CVRGALL(GRPPTR)                            03S0369
         BNP   @RF00369                                         03S0369
         L     @01,GRPWPTR(,CNTPTR)                             03S0369
         TM    WGUSED(@01),B'01000000'                          03S0369
         BNO   @RF00369                                         03S0369
*                                   DO;                         03S0370
*                                    CVRREACH=ON;/* MARK REQUEST AS
*                                      REACHED                       */
*                                    CVRRUSED=OFF;/* REQUEST NOT USED
*                                      YET                           */
         OI    CVRREACH(REQPTR),B'00100000'                     03S0372
         NI    CVRRUSED(REQPTR),B'10111111'                     03S0372
*                                    RREACHSW=ON;/* REACH FOUND -
*                                      INDICATE NEED ANOTHER PASS    */
         OI    RREACHSW,B'00001000'                             03S0373
*                                   END;/* END HANDLING OF MARKED GRP*/
*                                 ELSE                          03S0375
*                                   ;/* GROUP NOT SOLUTION OR NOT
*                                      MARKED                        */
@RF00369 DS    0H                                               03S0376
*                               END;                            03S0376
*                             ELSE                              03S0377
*                               ;                               03S0377
@RF00366 DS    0H                                               03S0378
*                             GRPPTR=GRPPTR+LENGTH(CVRGPLST);/* 03S0378
*                                      LOCATE NEXT GROUP             */
         AH    GRPPTR,@CH00067                                  03S0378
*                           END;    /* END OF GROUP SCAN             */
         AH    INDEX19,@CH00051                                 03S0379
@DE00365 CH    INDEX19,CVRNGRP(,REQPTR)                         03S0379
         BNH   @DL00365                                         03S0379
@DC00365 DS    0H                                               03S0380
*                         END;      /* END CHECKING OF UNREACHED REQ.*/
*                       ELSE                                    03S0381
*                         ;         /* REQUEST REACHED OR IN PTS     */
@RF00362 DS    0H                                               03S0382
*                       REQPTR=REQPTR+LENGTH(CVRRQLST);/* LOCATE NEXT
*                                      REQUEST                       */
         AH    REQPTR,@CH00250                                  03S0382
*                     END;          /* END OF SCAN OF REQUEST        */
         AH    INDEX18,@CH00051                                 03S0383
@DE00361 CH    INDEX18,CVRNREQ(,PARMPTR)                        03S0383
         BNH   @DL00361                                         03S0383
*                   END;            /* END OF ONE PASS LOOKING FOR
*                                      REQUEST REACH                 */
@DE00339 TM    RREACHSW,B'00001000'                             03S0384
         BO    @DL00339                                         03S0384
*                 END;              /* END OF ROWREACH               */
*                 CALL COLREACH;    /* FIND GROUP REACH OF GROUPS OF
*                                      FIRST REQUEST OVER OTHER REQS */
         BAL   @14,COLREACH                                     02S0386
*                 CALL FINDROWS;    /* FIND REQS WHICH HAVE THESE
*                                      GRPS AS SOLUTION ELEMENTS     */
         BAL   @14,FINDROWS                                     02S0387
*                 PTSN=PTSN+PTSINCR;/* SET ID TO NEXT PTS NUMBER     */
         AH    PTSN,@CH00051                                    02S0388
*               END;                /* END OF PROCESSING OF ONE 02S0389
*                                      STARTING ROW                  */
*           END;                    /* END OF IDENTIFYING PROPER
*                                      TIGHT SETS                    */
@RF00319 DS    0H                                               02S0390
@DE00296 TM    DONESW,B'10000000'                               02S0390
         BZ    @DL00296                                         02S0390
*                                                               03S0391
*/********************************************************************/
*/*                                                                  */
*/* SEGMENT NAME - REDUCE                                            */
*/*                                                                  */
*/* DESCRIPTIVE NAME - FLAG GROUPS NOT ELIGIBLE FOR ALLOCATION       */
*/*                                                                  */
*/* FUNCTION - TO REMOVE INELIGIBLE REQUEST/GROUP COMBINATIONS.      */
*/*                                                                  */
*/* OPERATION -                                                      */
*/*            EACH REQUEST WHICH IS NOT FULLY BOUND IS EXAMINED.    */
*/*            EACH GROUP WHICH IS NOT IN THE SAME PTS AS THE        */
*/*            REQUEST(CVRPTS^=WPTS) IS FLAGGED WITH -1 IN CVRGALL.  */
*/*                                                                  */
*/* ENTRY - (INLINE SUBROUTINE - ENTERED AT TOP)                     */
*/*                                                                  */
*/*   PURPOSE - SEE FUNCTION                                         */
*/*                                                                  */
*/*   INPUT  - CVRRQLST  CVRSKFLG  IS REQUEST TO BE SKIPPED          */
*/*                      CVRPTS    PTS ID FOR REQUEST                */
*/*            CVRWORKD  WPTS      PTS ID FOR GROUP                  */
*/*                                                                  */
*/* EXIT - NORMAL - (INLINE SUBROUTINE - EXITS AT BOTTOM)            */
*/*                                                                  */
*/*   CONDITION - FUNCTION COMPLETE                                  */
*/*                                                                  */
*/*   OUTPUT - CVRGPLST  CVRGALL   FLAGGED IF COMBINATION IS NOT     */
*/*                                ELIGIBLE                          */
*/*                                                                  */
*/********************************************************************/
*                                                               03S0391
*           DO;                     /* START OF REDUCE               */
*                                                               03S0391
*             /*******************************************************/
*             /*                                                     */
*             /* SCAN GROUPS FOR EACH REQUEST TO BE SURE GROUP AND   */
*             /* REQUEST HAVE SAME IDS (PTS NUMBERS). IF THE IDS DO  */
*             /* NOT MATCH, THE COMBINATION IS MARKED INELIGIBLE.    */
*             /*                                                     */
*             /*******************************************************/
*                                                               03S0392
*             REQPTR=CVRRQPTR;      /* LOCATE FIRST REQUEST          */
         L     REQPTR,CVRRQPTR(,PARMPTR)                        03S0392
*             DO INDEX20=1 TO CVRNREQ;/* SET UP LOOP CTL OVER   03S0393
*                                      REQUESTS                      */
         LA    INDEX20,1                                        03S0393
         B     @DE00393                                         03S0393
@DL00393 DS    0H                                               03S0394
*               IF CVRSKFLG=OFF     /* REQUEST TO BE SKIPPED?        */
*                   &CVRFULL=OFF    /* REQUEST ALL BOUND?            */
*                 THEN              /* NO- REQ. TO BE PROCESSED      */
         TM    CVRSKFLG(REQPTR),B'10010000'                     03S0394
         BNZ   @RF00394                                         03S0394
*                 DO;                                           03S0395
*                   GRPPTR=CVRGRPPT;/* LOCATE FIRST GROUP            */
*                                                               03S0396
         L     GRPPTR,CVRGRPPT(,REQPTR)                         03S0396
*                   /*************************************************/
*                   /*                                               */
*                   /* EXAMINE GROUPS FOR REQUEST AND MARK ANY NOT IN*/
*                   /* SAME PTS AS INELIGIBLE (-1 IN CVRGALL).       */
*                   /*                                               */
*                   /*************************************************/
*                                                               03S0397
*                   DO INDEX21=1 TO CVRNGRP WHILE(CVRGRPID<=CVRGRPLK);
         LA    INDEX21,1                                        03S0397
         B     @DE00397                                         03S0397
@DL00397 LH    @08,CVRGRPID(,GRPPTR)                            03S0397
         CH    @08,CVRGRPLK(,PARMPTR)                           03S0397
         BH    @DC00397                                         03S0397
*                                   /* SET UP LOOP CTL OVER LOCKED
*                                      GROUPS                        */
*                     IF CVRGSKP=OFF THEN                       03S0398
         TM    CVRGSKP(GRPPTR),B'10000000'                      03S0398
         BNZ   @RF00398                                         03S0398
*                       DO;                                     03S0399
*                         CNTPTR=CVRGCPTR;/* LOCATE GRPCOUNT ENTRY   */
         L     CNTPTR,CVRGCPTR(,GRPPTR)                         03S0400
*                         IF WPTS^=CVRPTS/* DO PTS NUMBERS MATCH?    */
*                           THEN    /* IDS DON'T MATCH               */
         L     @08,GRPWPTR(,CNTPTR)                             03S0401
         CLC   WPTS(2,@08),CVRPTS(REQPTR)                       03S0401
         BE    @RF00401                                         03S0401
*                           CVRGALL=SKIPFLAG;/* MARK IT INELIGIBLE   */
         MVC   CVRGALL(2,GRPPTR),@CH00125                       03S0402
*                       END;                                    03S0403
*                     ELSE                                      03S0404
*                       ;                                       03S0404
@RF00398 DS    0H                                               03S0405
*                     GRPPTR=GRPPTR+LENGTH(CVRGPLST);/* LOCATE NEXT
*                                      GROUP                         */
@RC00398 AH    GRPPTR,@CH00067                                  03S0405
*                   END;            /* END OF GROUP SCAN             */
         AH    INDEX21,@CH00051                                 03S0406
@DE00397 CH    INDEX21,CVRNGRP(,REQPTR)                         03S0406
         BNH   @DL00397                                         03S0406
@DC00397 DS    0H                                               03S0407
*                 END;              /* END OF PROCESSING 1 REQ.      */
*               REQPTR=REQPTR+LENGTH(CVRRQLST);/* LOCATE NEXT REQUEST*/
@RF00394 AH    REQPTR,@CH00250                                  03S0408
*             END;                  /* END OF REQUEST SCAN           */
         AH    INDEX20,@CH00051                                 03S0409
@DE00393 CH    INDEX20,CVRNREQ(,PARMPTR)                        03S0409
         BNH   @DL00393                                         03S0409
*           END;                    /* END OF REDUCE                 */
*         END;                      /* END PTSREDUC                  */
*       ELSE                                                    01S0412
*         ;                         /* ALLOCATION NOT FULL           */
@RF00229 DS    0H                                               01S0413
*                                                               02S0413
*/********************************************************************/
*/*                                                                  */
*/* SEGMENT NAME - FREEWORK                                          */
*/*                                                                  */
*/* DESCRIPTIVE NAME - FREEMAIN FOR WORKAREA                         */
*/*                                                                  */
*/* FUNCTION - TO FREE WORK AREA AND DELETE REFERENCES TO IT         */
*/*                                                                  */
*/* OPERATION - CVRWORK IS USED TO LOCATE GRPCOUNT ENTRIES FOR THIS  */
*/*            INVOCATION.  THE POINTER TO THE WORKAREA(GRPWPTR) IS  */
*/*            SET TO 0 IN EACH GRPCOUNT ENTRY.  THE WORKAREA IS     */
*/*            FREED.                                                */
*/*                                                                  */
*/* ENTRY - (INLINE SUBROUTINE - ENTERED AT TOP)                     */
*/*                                                                  */
*/*   PURPOSE - SEE FUNCTION                                         */
*/*                                                                  */
*/*   INPUT  - ACVRWORK            ADDRESS OF WORK AREA              */
*/*            SIZE                LENGTH OF WORK AREA               */
*/*                                                                  */
*/* EXIT - (INLINE SUBROUTINE - EXITS AT BOTTOM)                     */
*/*                                                                  */
*/*   CONDITION - FUNCTION COMPLETE                                  */
*/*                                                                  */
*/*   OUTPUT - GRPCOUNT  GRPWPTR   PTR TO WORKAREA RESET TO 0        */
*/*                                                                  */
*/********************************************************************/
*                                                               02S0413
*       DO;                         /* START OF FREEWORK             */
*         WORKPTR=ACVRWORK;         /* LOCATE START OF WORK AREA     */
*                                                               02S0414
         L     WORKPTR,ACVRWORK                                 02S0414
*         /***********************************************************/
*         /*                                                         */
*         /* USE POINTER IN CVRWORK TO LOCATE ENTRIES IN GRPCOUNT AND*/
*         /* RESET POINTERS IN GRPCOUNT TO 0.                        */
*         /*                                                         */
*         /***********************************************************/
*                                                               02S0415
*         RESPECIFY                                             02S0415
*          (CVRWORKD) BASED(WORKPTR);                           02S0415
*         DO WHILE(LASTFLAG=OFF);   /* SCAN ALL OF CVRWORK           */
         B     @DE00416                                         02S0416
@DL00416 DS    0H                                               02S0417
*           WCNTPTR->GRPWPTR=INITVAL;/* RESET ENTRY IN GRPCOUNT      */
         L     @08,WCNTPTR(,WORKPTR)                            02S0417
         SLR   @05,@05                                          02S0417
         ST    @05,GRPWPTR(,@08)                                02S0417
*           WORKPTR=WORKPTR+LENGTH(CVRWORKD);/* LOCATE NEXT ENTRY IN
*                                      CVRWORK                       */
         AH    WORKPTR,@CH00067                                 02S0418
*         END;                      /* END OF SCAN OF CVRWORK        */
@DE00416 TM    LASTFLAG(WORKPTR),B'10000000'                    02S0419
         BZ    @DL00416                                         02S0419
*         RESPECIFY                                             02S0420
*          (R0,                                                 02S0420
*           R1) RESTRICTED;                                     02S0420
*         R1=ACVRWORK;              /* SET UP REGISTERS 0 & 1 FOR
*                                      FREEMAIN                      */
         L     R1,ACVRWORK                                      02S0421
*         R0=SIZE;                                              02S0422
         LR    R0,SIZE                                          02S0422
*         R0=R0|SUBPL230;           /* FREE FROM SUBPOOL 230         */
         O     R0,@CF00128                                      02S0423
*         GEN REFS(R0,R1)(FREEMAIN R,LV=(0),A=(1));/* FREE WORK AREA */
         FREEMAIN R,LV=(0),A=(1)
*         RESPECIFY                                             02S0425
*          (R0,                                                 02S0425
*           R1) UNRESTRICTED;                                   02S0425
*       END;                        /* END OF FREEWORK               */
*     END;                                                      01S0427
*   ELSE                                                        01S0428
*     ;                                                         01S0428
@RF00217 DS    0H                                               01S0429
*   RETURN CODE(RCODE);             /* RETURN CODE SHOWING RESULTS TO
*                                      CALLER                        */
         IC    @02,@OLDKEY                                      01S0429
         L     @13,4(,@13)                                      01S0429
         L     @00,@SIZDATD                                     01S0429
         LR    @01,@11                                          01S0429
         FSPACE   R,LV=(0),A=(1)
         MODESET KEYADDR=(2)
         LR    @15,@09                                          01S0429
         L     @14,12(,@13)                                     01S0429
         LM    @00,@12,20(@13)                                  01S0429
         BR    @14                                              01S0429
*                                                               02S0430
*/********************************************************************/
*/*                                                                  */
*/* SEGMENT NAME - FINDROWS                                          */
*/*                                                                  */
*/* DESCRIPTIVE NAME - LOCATE REQUESTS                               */
*/*                                                                  */
*/* FUNCTION - TO FIND REQUESTS HAVING SOLUTION ELEMENT IN MARKED    */
*/*            GROUPS                                                */
*/*                                                                  */
*/* OPERATION -                                                      */
*/*            SCAN REQUESTS LOOKING FOR ONE WHICH IS NOT YET IN     */
*/*            PTS BUT WHICH HAS BEEN REACHED.  EXAMINE GROUPS FOR   */
*/*            THIS REQUEST.  IF ANY SOLUTION GROUP FOR THIS         */
*/*            IS IN THE CURRENT PTS(WPTS=PTSN), THIS REQUEST IS PUT */
*/*            INTO THE CURRENT PTS(CVRPTS=PTSN) AND THE GROUP SCAN  */
*/*            IS TERMINATED.                                        */
*/*                                                                  */
*/* ENTRY - FINDROWS                                                 */
*/*                                                                  */
*/*   PURPOSE - SEE FUNCTION                                         */
*/*                                                                  */
*/*   INPUT  - CVRGPLST  CVRGALL   >0 - SOLUTION ELEMENT             */
*/*            CVRWORK   WPTS      PTS NUMBER FOR GROUP              */
*/*            PTSN                CURRENT PTS                       */
*/*                                                                  */
*/* EXIT -                                                           */
*/*                                                                  */
*/*   CONDITION - FUNCTION COMPLETE                                  */
*/*                                                                  */
*/*   OUTPUT - CVRRQLST  CVRPTS    PTS NUMBER FOR REQUEST            */
*/*                                                                  */
*/********************************************************************/
*                                                               02S0430
*FINDROWS:                                                      02S0430
*   PROCEDURE;                                                  02S0430
FINDROWS STM   @14,@12,12(@13)                                  02S0430
*   RESPECIFY                                                   02S0431
*    (CVRWORKD) BASED(GRPWPTR);                                 02S0431
*                                                               02S0431
*   /*****************************************************************/
*   /*                                                               */
*   /* SCAN ALL REQUESTS TO FIND THOSE WITH SOLUTION ELEMENT IN      */
*   /* CURRENT PTS                                                   */
*   /*                                                               */
*   /*****************************************************************/
*                                                               02S0432
*   REQPTR=CVRRQPTR;                /* LOCATE FIRST REQUEST          */
         L     REQPTR,CVRRQPTR(,PARMPTR)                        02S0432
*   DO INDEX13=1 TO CVRNREQ;        /* SET UP LOOP CONTROL FOR REQ
*                                      SCAN                          */
*                                                               02S0433
         LA    INDEX13,1                                        02S0433
         B     @DE00433                                         02S0433
@DL00433 DS    0H                                               02S0434
*     /***************************************************************/
*     /*                                                             */
*     /* CONSIDER THOSE REQUESTS WHICH ARE NOT MARKED SKIP AND ARE   */
*     /* NOT YET IN A PTS AND WHICH HAVE BEEN REACHED                */
*     /*                                                             */
*     /***************************************************************/
*                                                               02S0434
*     IF CVRSKFLG=OFF&CVRPTS=NOPTS&CVRREACH=ON THEN/* REQUEST IS
*                                      REACHED AND AVAIL.            */
         TM    CVRSKFLG(REQPTR),B'10000000'                     02S0434
         BNZ   @RF00434                                         02S0434
         ICM   @10,3,CVRPTS(REQPTR)                             02S0434
         BNZ   @RF00434                                         02S0434
         TM    CVRREACH(REQPTR),B'00100000'                     02S0434
         BNO   @RF00434                                         02S0434
*       DO;                                                     02S0435
*                                                               02S0435
*         /***********************************************************/
*         /*                                                         */
*         /* SCAN GROUPS FOR REQUEST LOOKING FOR GROUP WHICH IS      */
*         /* FLAGGED AND USED IN SOLUTION FOR THIS REQUEST. IF ONE IS*/
*         /* FOUND, MARK REQUEST AS BEING IN THIS PTS AND STOP SCAN. */
*         /*                                                         */
*         /***********************************************************/
*                                                               02S0436
*         GRPPTR=CVRGRPPT;                                      02S0436
         L     GRPPTR,CVRGRPPT(,REQPTR)                         02S0436
*         DO INDEX14=1 TO CVRNGRP WHILE(CVRPTS=0&CVRGRPID<=CVRGRPLK);
         LA    INDEX14,1                                        02S0437
         B     @DE00437                                         02S0437
@DL00437 SLR   @10,@10                                          02S0437
         CH    @10,CVRPTS(,REQPTR)                              02S0437
         BNE   @DC00437                                         02S0437
         LH    @09,CVRGRPID(,GRPPTR)                            02S0437
         CH    @09,CVRGRPLK(,PARMPTR)                           02S0437
         BH    @DC00437                                         02S0437
*                                   /* SET UP LOOP CTL FOR GRP SCAN  */
*           IF CVRGSKP=OFF THEN                                 02S0438
         TM    CVRGSKP(GRPPTR),B'10000000'                      02S0438
         BNZ   @RF00438                                         02S0438
*             DO;                                               02S0439
*               CNTPTR=CVRGCPTR;                                02S0440
         L     CNTPTR,CVRGCPTR(,GRPPTR)                         02S0440
*               IF WPTS=PTSN&CVRGALL>0/* IS GROUP IN THIS PTS AND
*                                      USED IN SOLUTION              */
*                 THEN              /* MEETS ABOVE REQUIREMENTS      */
         L     @09,GRPWPTR(,CNTPTR)                             02S0441
         CH    PTSN,WPTS(,@09)                                  02S0441
         BNE   @RF00441                                         02S0441
         CH    @10,CVRGALL(,GRPPTR)                             02S0441
         BNL   @RF00441                                         02S0441
*                 CVRPTS=PTSN;      /* PUT REQUEST INTO THIS PTS     */
         STH   PTSN,CVRPTS(,REQPTR)                             02S0442
*               ELSE                                            02S0443
*                 ;                 /* NO SOLUTION OR NOT IN PTS     */
@RF00441 DS    0H                                               02S0444
*             END;                                              02S0444
*           ELSE                                                02S0445
*             ;                                                 02S0445
@RF00438 DS    0H                                               02S0446
*           GRPPTR=GRPPTR+LENGTH(CVRGPLST);/* LOCATE NEXT GROUP      */
         AH    GRPPTR,@CH00067                                  02S0446
*         END;                      /* END GROUP SCAN                */
         AH    INDEX14,@CH00051                                 02S0447
@DE00437 CH    INDEX14,CVRNGRP(,REQPTR)                         02S0447
         BNH   @DL00437                                         02S0447
@DC00437 DS    0H                                               02S0448
*       END;                        /* END PROCESSING OF ONE REQ     */
*     REQPTR=REQPTR+LENGTH(CVRRQLST);/* LOCATE NEXT REQUEST          */
@RF00434 AH    REQPTR,@CH00250                                  02S0449
*   END;                            /* END OF REQUEST SCAN           */
         AH    INDEX13,@CH00051                                 02S0450
@DE00433 CH    INDEX13,CVRNREQ(,PARMPTR)                        02S0450
         BNH   @DL00433                                         02S0450
*   END FINDROWS;                                               02S0451
@EL00002 DS    0H                                               02S0451
@EF00002 DS    0H                                               02S0451
@ER00002 LM    @14,@12,12(@13)                                  02S0451
         BR    @14                                              02S0451
*                                                               02S0452
*/********************************************************************/
*/*                                                                  */
*/* SEGMENT NAME - COLREACH                                          */
*/*                                                                  */
*/* DESCRIPTIVE NAME - FIND GROUP REACH                              */
*/*                                                                  */
*/* FUNCTION - FIND GROUP REACH OF MARKED GROUPS OVER MARKED REQUESTS*/
*/*                                                                  */
*/* OPERATION -                                                      */
*/*      OVERVIEW - GROUP REACH INVOLVES FINDING A MARKED REQUEST    */
*/*            WHICH COULD USE THE STARTING GROUP AND DOES USE SOME  */
*/*            OTHER GROUP.  THE GROUP USED IS SAID TO BE REACHED.   */
*/*      INITIALLY - WPTS IN CVRWORK CONTAINS -1 FOR THOSE GROUPS    */
*/*            WHOSE REACH IS TO BE FOUND.  CVRREACH FLAG IS ON FOR  */
*/*            THOSE REQUESTS WHICH MAY BE CONSIDERED.               */
*/*      INITIALIZATION - TURN OFF USED FLAG FOR EACH REQUEST.       */
*/*      DIRECT REACH LOOP - EXECUTED UNTIL ONE PASS DOES NOT FIND   */
*/*            ANY FURTHER DIRECT REACH.  CONTROLLED BY CREACHSW.    */
*/*      FINDING DIRECT REACH - EACH REQUEST WHICH HAS BEEN          */
*/*            REACHED BUT NOT USED IS EXAMINED.  IF ANY GROUP       */
*/*            USABLE BY THIS REQUEST HAS BEEN MARKED REACHED,       */
*/*            RESCAN ITS GROUPS MARKING ALL SOLUTION GROUPS REACHED */
*/*            AND MARK THE REQUEST USED.                            */
*/*      CVRWORK SCAN - EXECUTED WHEN COMPLETE GROUP REACH HAS BEEN  */
*/*            FOUND.  CHANGE EACH -1 FLAG TO THE PTS NUMBER.        */
*/*                                                                  */
*/* ENTRY - COLREACH                                                 */
*/*                                                                  */
*/*   PURPOSE - SEE FUNCTION                                         */
*/*                                                                  */
*/*   INPUT  - CVRRQLST  CVRREACH  FLAG MARKING REQ ELIGIBLE         */
*/*            CVRGPLST  CVRGALL   CURRENT ALLOCATION                */
*/*            CVRWORK   WPTS      0 - GROUP NOT REACHED YET         */
*/*                                -1 - GROUP REACHED                */
*/*                                OTHER - GROUP IN PTS              */
*/*            PTSN                CURRENT PTS NUMBER                */
*/*                                                                  */
*/* EXIT - NORMAL                                                    */
*/*                                                                  */
*/*   CONDITION - FUNCTION COMPLETE                                  */
*/*                                                                  */
*/*   OUTPUT - CVRWORK   WPTS      REACHED GROUPS IN PTS             */
*/*                                                                  */
*/********************************************************************/
*                                                               02S0452
*COLREACH:                                                      02S0452
*   PROCEDURE;                                                  02S0452
COLREACH STM   @14,@12,12(@13)                                  02S0452
*   REQPTR=CVRRQPTR;                /* LOCATE FIRST REQUEST          */
*                                                               02S0453
         L     REQPTR,CVRRQPTR(,PARMPTR)                        02S0453
*   /*****************************************************************/
*   /*                                                               */
*   /* MARK ALL ACTIVE REQUESTS NOT USED YET                         */
*   /*                                                               */
*   /*****************************************************************/
*                                                               02S0454
*   DO INDEX22=1 TO CVRNREQ;        /* SET UP LOOP CONTROL OVER REQS */
         LA    INDEX22,1                                        02S0454
         B     @DE00454                                         02S0454
@DL00454 DS    0H                                               02S0455
*     IF CVRSKFLG=OFF THEN                                      02S0455
         TM    CVRSKFLG(REQPTR),B'10000000'                     02S0455
         BNZ   @RF00455                                         02S0455
*       CVRRUSED=OFF;               /* INITIALIZE USED FLAG OFF      */
         NI    CVRRUSED(REQPTR),B'10111111'                     02S0456
*     REQPTR=REQPTR+LENGTH(CVRRQLST);/* LOCATE NEXT REQUEST          */
@RF00455 AH    REQPTR,@CH00250                                  02S0457
*   END;                            /* END OF INITIALIZING LOOP      */
         AH    INDEX22,@CH00051                                 02S0458
@DE00454 CH    INDEX22,CVRNREQ(,PARMPTR)                        02S0458
         BNH   @DL00454                                         02S0458
*   CREACHSW=ON;                    /* INITIALIZE SWITCH FOR LOOP    */
*                                                               02S0459
         OI    CREACHSW,B'00010000'                             02S0459
*   /*****************************************************************/
*   /*                                                               */
*   /* LOOP FINDING DIRECT GROUP REACH UNTIL NO NEW GROUP IS REACHED */
*   /*                                                               */
*   /*****************************************************************/
*                                                               02S0460
*   DO WHILE(CREACHSW=ON);          /* END LOOP WHEN NO GROUPS  02S0460
*                                      REACHED IN LAST PASS          */
         B     @DE00460                                         02S0460
@DL00460 DS    0H                                               02S0461
*     CREACHSW=OFF;                 /* ASSUME NO GROUPS REACHED UNTIL
*                                      ONE IS FOUND                  */
*                                                               02S0461
         NI    CREACHSW,B'11101111'                             02S0461
*     /***************************************************************/
*     /*                                                             */
*     /* EXAMINE EACH REACHED BUT NOT USED REQUEST TO DETERMINE      */
*     /* WHETHER IT COULD USE ANY FLAGGED GROUP. IF IT COULD, MARK   */
*     /* ANY OF ITS SOLUTION GROUPS WHICH HAVE NOT BEEN REACHED AS   */
*     /* REACHED AND RESET CREACHSW TO CONTINUE THE SCAN.            */
*     /*                                                             */
*     /***************************************************************/
*                                                               02S0462
*     REQPTR=CVRRQPTR;              /* LOCATE FIRST REQUEST          */
         L     REQPTR,CVRRQPTR(,PARMPTR)                        02S0462
*     DO INDEX10=1 TO CVRNREQ;      /* LOOP OVER ALL REQUESTS        */
*                                                               02S0463
         LA    INDEX10,1                                        02S0463
         B     @DE00463                                         02S0463
@DL00463 DS    0H                                               02S0464
*       /*************************************************************/
*       /*                                                           */
*       /* CONSIDER ONLY THOSE REQUESTS NOT MARKED SKIP WHICH HAVE   */
*       /* BEEN REACHED BUT NOT USED.                                */
*       /*                                                           */
*       /*************************************************************/
*                                                               02S0464
*       IF CVRSKFLG=OFF&CVRREACH=ON&CVRRUSED=OFF THEN           02S0464
         TM    CVRREACH(REQPTR),B'00100000'                     02S0464
         BNO   @RF00464                                         02S0464
         TM    CVRSKFLG(REQPTR),B'11000000'                     02S0464
         BNZ   @RF00464                                         02S0464
*         DO;                                                   02S0465
*                                                               02S0465
*           /*********************************************************/
*           /*                                                       */
*           /* SCAN GROUPS TO DETERMINE WHETHER REQUEST COULD USE    */
*           /* MARKED GROUP.                                         */
*           /*                                                       */
*           /*********************************************************/
*                                                               02S0466
*           GFOUNDSW=OFF;           /* ASSUME CANNOT USE MARKED GROUP*/
         NI    GFOUNDSW,B'11111011'                             02S0466
*           GRPPTR=CVRGRPPT;        /* LOCATE FIRST GROUP            */
         L     GRPPTR,CVRGRPPT(,REQPTR)                         02S0467
*           DO INDEX11=1 TO CVRNGRP WHILE(CVRGRPID<=CVRGRPLK&GFOUNDSW=
*                 OFF);             /* LOOP OVER LOCKED GROUP UNTIL
*                                      MARKED GROUP IS FOUND         */
         LA    INDEX11,1                                        02S0468
         B     @DE00468                                         02S0468
@DL00468 LH    @10,CVRGRPID(,GRPPTR)                            02S0468
         CH    @10,CVRGRPLK(,PARMPTR)                           02S0468
         BH    @DC00468                                         02S0468
         TM    GFOUNDSW,B'00000100'                             02S0468
         BNZ   @DC00468                                         02S0468
*             IF CVRGSKP=OFF THEN                               02S0469
         TM    CVRGSKP(GRPPTR),B'10000000'                      02S0469
         BNZ   @RF00469                                         02S0469
*               DO;                                             02S0470
*                 CNTPTR=CVRGCPTR;  /* LOCATE COUNT ENTRY            */
         L     CNTPTR,CVRGCPTR(,GRPPTR)                         02S0471
*                 IF WPTS=PTSFLAG   /* IS GROUP MARKED?              */
*                   THEN            /* YES                           */
         L     @10,GRPWPTR(,CNTPTR)                             02S0472
         CLC   WPTS(2,@10),@CH00125                             02S0472
         BNE   @RF00472                                         02S0472
*                   GFOUNDSW=ON;    /* INDICATE REACH POSSIBLE       */
         OI    GFOUNDSW,B'00000100'                             02S0473
*               END;                                            02S0474
*             ELSE                                              02S0475
*               ;                                               02S0475
@RF00469 DS    0H                                               02S0476
*             GRPPTR=GRPPTR+LENGTH(CVRGPLST);/* LOCATE NEXT GROUP    */
@RC00469 AH    GRPPTR,@CH00067                                  02S0476
*           END;                    /* END GROUP SCAN                */
         AH    INDEX11,@CH00051                                 02S0477
@DE00468 CH    INDEX11,CVRNGRP(,REQPTR)                         02S0477
         BNH   @DL00468                                         02S0477
@DC00468 DS    0H                                               02S0478
*           IF GFOUNDSW=ON          /* COULD REQUEST USE MARKED 02S0478
*                                      GROUP?                        */
*             THEN                  /* YES - DETERMINE REACH         */
         TM    GFOUNDSW,B'00000100'                             02S0478
         BNO   @RF00478                                         02S0478
*             DO;                                               02S0479
*                                                               02S0479
*               /*****************************************************/
*               /*                                                   */
*               /* SCAN GROUPS MARKING UNMARKED SOLUTION GROUPS      */
*               /*                                                   */
*               /*****************************************************/
*                                                               02S0480
*               GRPPTR=CVRGRPPT;    /* LOCATE FIRST GROUP            */
         L     GRPPTR,CVRGRPPT(,REQPTR)                         02S0480
*               DO INDEX12=1 TO CVRNGRP WHILE(CVRGRPID<=CVRGRPLK);/*
*                                      LOOP OVER LOCKED GROUPS       */
         LA    INDEX12,1                                        02S0481
         B     @DE00481                                         02S0481
@DL00481 LH    @10,CVRGRPID(,GRPPTR)                            02S0481
         CH    @10,CVRGRPLK(,PARMPTR)                           02S0481
         BH    @DC00481                                         02S0481
*                 IF CVRGSKP=OFF THEN                           02S0482
         TM    CVRGSKP(GRPPTR),B'10000000'                      02S0482
         BNZ   @RF00482                                         02S0482
*                   DO;                                         02S0483
*                     CNTPTR=CVRGCPTR;/* LOCATE COUNT ENTRY          */
         L     CNTPTR,CVRGCPTR(,GRPPTR)                         02S0484
*                     IF CVRGALL>0&WPTS=NOPTS/* SOLUTION GROUP NOT IN
*                                      PTS?                          */
*                       THEN        /* YES                           */
         SLR   @10,@10                                          02S0485
         CH    @10,CVRGALL(,GRPPTR)                             02S0485
         BNL   @RF00485                                         02S0485
         L     @09,GRPWPTR(,CNTPTR)                             02S0485
         CH    @10,WPTS(,@09)                                   02S0485
         BNE   @RF00485                                         02S0485
*                       DO;                                     02S0486
*                         WPTS=PTSFLAG;/* MARK GROUP REACHED         */
         MVC   WPTS(2,@09),@CH00125                             02S0487
*                         CREACHSW=ON;/* INDICATE GROUP REACH FOUND  */
         OI    CREACHSW,B'00010000'                             02S0488
*                       END;                                    02S0489
*                   END;                                        02S0490
*                 ELSE                                          02S0491
*                   ;                                           02S0491
@RF00482 DS    0H                                               02S0492
*                 GRPPTR=GRPPTR+LENGTH(CVRGPLST);/* LOCATE NEXT GROUP*/
@RC00482 AH    GRPPTR,@CH00067                                  02S0492
*               END;                /* END GROUP SCAN                */
         AH    INDEX12,@CH00051                                 02S0493
@DE00481 CH    INDEX12,CVRNGRP(,REQPTR)                         02S0493
         BNH   @DL00481                                         02S0493
@DC00481 DS    0H                                               02S0494
*               CVRRUSED=ON;        /* MARK REQUEST USED             */
         OI    CVRRUSED(REQPTR),B'01000000'                     02S0494
*             END;                  /* END PROCESSING ONE REQUEST    */
*         END;                      /* END PROCESSING REACHED REQUEST*/
@RF00478 DS    0H                                               02S0497
*       REQPTR=REQPTR+LENGTH(CVRRQLST);/* LOCATE NEXT REQUEST        */
@RF00464 AH    REQPTR,@CH00250                                  02S0497
*     END;                          /* END REQUEST SCAN              */
         AH    INDEX10,@CH00051                                 02S0498
@DE00463 CH    INDEX10,CVRNREQ(,PARMPTR)                        02S0498
         BNH   @DL00463                                         02S0498
*   END;                            /* END ONE SEARCH FOR DIRECT
*                                      REACH                         */
@DE00460 TM    CREACHSW,B'00010000'                             02S0499
         BO    @DL00460                                         02S0499
*   RESPECIFY                                                   02S0500
*    (CVRWORKD) BASED(WORKPTR);     /* SET UP TO SCAN CVRWORK        */
*                                                               02S0500
*   /*****************************************************************/
*   /*                                                               */
*   /* SET WPTS IN ALL REACHED GROUPS TO PTS NUMBER                  */
*   /*                                                               */
*   /*****************************************************************/
*                                                               02S0501
*   WORKPTR=ACVRWORK;               /* LOCATE FIRST CVRWORK ENTRY    */
         L     WORKPTR,ACVRWORK                                 02S0501
*   DO WHILE(LASTFLAG=OFF);                                     02S0502
         B     @DE00502                                         02S0502
@DL00502 DS    0H                                               02S0503
*     IF WPTS=PTSFLAG               /* MARKED REQUEST?               */
*       THEN                        /* YES                           */
         CLC   WPTS(2,WORKPTR),@CH00125                         02S0503
         BNE   @RF00503                                         02S0503
*       WPTS=PTSN;                  /* PUT INTO PTS                  */
         STH   PTSN,WPTS(,WORKPTR)                              02S0504
*     WORKPTR=WORKPTR+LENGTH(CVRWORKD);/* LOCATE NEXT ENTRY          */
@RF00503 AH    WORKPTR,@CH00067                                 02S0505
*   END;                            /* END SCAN OF CVRWORK           */
@DE00502 TM    LASTFLAG(WORKPTR),B'10000000'                    02S0506
         BZ    @DL00502                                         02S0506
*   RESPECIFY                                                   02S0507
*    (CVRWORKD) BASED(GRPWPTR);                                 02S0507
*   END COLREACH;                   /* RETURN TO CALLER              */
@EL00003 DS    0H                                               02S0508
@EF00003 DS    0H                                               02S0508
@ER00003 LM    @14,@12,12(@13)                                  02S0508
         BR    @14                                              02S0508
*                                                               02S0509
*/********************************************************************/
*/*                                                                  */
*/* SEGMENT NAME - FINDTRL                                           */
*/*                                                                  */
*/* DESCRIPTIVE NAME - FIND PRELIMINARY SOLUTION                     */
*/*                                                                  */
*/* FUNCTION - TO FIND PRELIMINARY SOLUTION BY INSPECTION.           */
*/*                                                                  */
*/* OPERATION - EACH REQUEST WHICH REQUESTS UNITS IS SCANNED.  IF    */
*/*            ANY GROUP ELIGIBLE FOR THIS REQUEST HAS UNITS         */
*/*            AVAILABLE, THEY ARE ALLOCATED TO THE REQUEST.  IF ANY */
*/*            REQUEST IS NOT FULLY SATISFIED, AN ERROR CODE IS      */
*/*            RETURNED TO INDICATE THAT FURTHER PROCESSING IS       */
*/*            NEEDED.                                               */
*/*                                                                  */
*/* ENTRY - FINDTRL                                                  */
*/*                                                                  */
*/*   PURPOSE - SEE FUNCTION                                         */
*/*                                                                  */
*/*   INPUT  - CVRRQLST  CVRNEED   NUMBER OF UNITS NEEDED FOR REQ.   */
*/*            GRPCOUNT  GRPEXCS   NUMBER OF UNITS ALLOCATABLE FROM  */
*/*                                GROUP                             */
*/*                                                                  */
*/* EXIT -                                                           */
*/*                                                                  */
*/*   CONDITION - FUNCTION COMPLETE                                  */
*/*                                                                  */
*/*   OUTPUT - CVRRQLST  CVRNEED   NUMBER OF UNITS STILL NEEDED      */
*/*            CVRGPLST  CVRGALL   NUMBER OF UNITS ALLOCATED         */
*/*            GRPCOUNT  GRPEXCS   NUMBER OF UNITS STILL ALLOCATABLE */
*/*                                                                  */
*/********************************************************************/
*                                                               02S0509
*FINDTRL:                                                       02S0509
*   PROCEDURE;                                                  02S0509
FINDTRL  STM   @14,@12,12(@13)                                  02S0509
*   FCODE=NOERROR;                  /* INITIALIZE RETURN CODE TO OK  */
*                                                               02S0510
         SLR   FCODE,FCODE                                      02S0510
*   /*****************************************************************/
*   /*                                                               */
*   /* ATTEMPT TO FILL EACH REQUEST FROM ALLOCATABLE UNITS           */
*   /*                                                               */
*   /*****************************************************************/
*                                                               02S0511
*   REQPTR=CVRRQPTR;                /* LOCATE FIRST REQUEST          */
         L     REQPTR,CVRRQPTR(,PARMPTR)                        02S0511
*   DO FINDEX1=1 TO CVRNREQ;        /* SET UP LOOP CTL OVER REQS     */
         LA    FINDEX1,1                                        02S0512
         B     @DE00512                                         02S0512
@DL00512 DS    0H                                               02S0513
*     IF CVRSKFLG=OFF               /* REQUEST TO BE SKIPPED?        */
*       THEN                        /* NO - REQ TO BE PROCESSED      */
         TM    CVRSKFLG(REQPTR),B'10000000'                     02S0513
         BNZ   @RF00513                                         02S0513
*       DO;                                                     02S0514
*                                                               02S0514
*         /***********************************************************/
*         /*                                                         */
*         /* ALLOCATE AS MANY UNITS AS POSSIBLE TO REQUEST FROM EACH */
*         /* GROUP UNTIL REQUEST HAS BEEN FILLED.                    */
*         /*                                                         */
*         /***********************************************************/
*                                                               02S0515
*         GRPPTR=CVRGRPPT;          /* LOCATE FIRST GROUP            */
         L     GRPPTR,CVRGRPPT(,REQPTR)                         02S0515
*         DO FINDEX2=1 TO CVRNGRP WHILE(CVRNEED>0&CVRGRPID<=CVRGRPLK);
         LA    FINDEX2,1                                        02S0516
         B     @DE00516                                         02S0516
@DL00516 SLR   @10,@10                                          02S0516
         LH    @06,CVRNEED(,REQPTR)                             02S0516
         CR    @06,@10                                          02S0516
         BNH   @DC00516                                         02S0516
         LH    @04,CVRGRPID(,GRPPTR)                            02S0516
         CH    @04,CVRGRPLK(,PARMPTR)                           02S0516
         BH    @DC00516                                         02S0516
*                                   /* SET UP LOOP CONTROL OVER 02S0517
*                                      GROUPS, STOPPING WHEN REQ FULL*/
*           IF CVRGSKP=OFF THEN                                 02S0517
         TM    CVRGSKP(GRPPTR),B'10000000'                      02S0517
         BNZ   @RF00517                                         02S0517
*             DO;                                               02S0518
*               CNTPTR=CVRGCPTR;    /* LOCATE GRPCOUNT ENTRY         */
         L     CNTPTR,CVRGCPTR(,GRPPTR)                         02S0519
*               MINX=MIN(CVRNEED,GRPEXCS);/* DETERMINE HOW MANY UNITS
*                                      CAN BE ALLOCATED HERE         */
         LH    @15,CVRNEED(,REQPTR)                             02S0520
         LH    @14,GRPEXCS(,CNTPTR)                             02S0520
         LR    MINX,@14                                         02S0520
         CR    MINX,@15                                         02S0520
         BNH   *+6
         LR    MINX,@15                                         02S0520
*               IF MINX>0           /* CAN ANY BE ALLOCATED?         */
*                 THEN              /* SOME CAN BE ALLOCATED         */
         CR    MINX,@10                                         02S0521
         BNH   @RF00521                                         02S0521
*                 DO;                                           02S0522
*                   CVRNEED=CVRNEED-MINX;/* REDUCE NUMBER NEEDED     */
         SLR   @15,MINX                                         02S0523
         STH   @15,CVRNEED(,REQPTR)                             02S0523
*                   GRPEXCS=GRPEXCS-MINX;/* REDUCE NUMBER ALLOCATABLE*/
         SLR   @14,MINX                                         02S0524
         STH   @14,GRPEXCS(,CNTPTR)                             02S0524
*                   CVRGALL=CVRGALL+MINX;/* INCREASE NUMBER ALLOCATED*/
         LR    @10,MINX                                         02S0525
         AH    @10,CVRGALL(,GRPPTR)                             02S0525
         STH   @10,CVRGALL(,GRPPTR)                             02S0525
*                 END;                                          02S0526
*               ELSE                                            02S0527
*                 ;                                             02S0527
@RF00521 DS    0H                                               02S0528
*             END;                  /* END OF ALLOCATING UNITS       */
*           GRPPTR=GRPPTR+LENGTH(CVRGPLST);/* LOCATE NEXT GROUP      */
@RF00517 AH    GRPPTR,@CH00067                                  02S0529
*         END;                      /* END OF GROUP SCAN             */
         AH    FINDEX2,@CH00051                                 02S0530
@DE00516 CH    FINDEX2,CVRNGRP(,REQPTR)                         02S0530
         BNH   @DL00516                                         02S0530
@DC00516 DS    0H                                               02S0531
*         IF CVRNEED>0              /* REQUEST FULLY ALLOCATED?      */
*           THEN                    /* REQUEST NOT FULLY ALLOCATED   */
         ICM   @10,3,CVRNEED(REQPTR)                            02S0531
         BNP   @RF00531                                         02S0531
*           FCODE=FTRLERR;          /* SET RETURN CODE TO INCOMPLETE */
         LA    FCODE,4                                          02S0532
*       END;                        /* END OF ALLOCATION FOR ONE REQ */
@RF00531 DS    0H                                               02S0534
*     REQPTR=REQPTR+LENGTH(CVRRQLST);/* LOCATE NEXT REQUEST          */
@RF00513 AH    REQPTR,@CH00250                                  02S0534
*   END;                            /* END REQUEST SCAN              */
         AH    FINDEX1,@CH00051                                 02S0535
@DE00512 CH    FINDEX1,CVRNREQ(,PARMPTR)                        02S0535
         BNH   @DL00512                                         02S0535
*   RETURN CODE(FCODE);             /* RETURN TO CALLER              */
         LR    @15,FCODE                                        02S0536
         L     @14,12(,@13)                                     02S0536
         LM    @00,@12,20(@13)                                  02S0536
         BR    @14                                              02S0536
*   END FINDTRL;                                                02S0537
*                                                               02S0538
*/********************************************************************/
*/*                                                                  */
*/* SEGMENT NAME - HUNG                                              */
*/*                                                                  */
*/* DESCRIPTIVE NAME - EXTENDED PRELIMINARY SOLUTION                 */
*/*                                                                  */
*/* FUNCTION - TO EXTEND SOLUTION AS MUCH AS POSSIBLE AND TO DETECT  */
*/*            INFEASIBLE CONDITION IF IT EXISTS                     */
*/* OPERATION -                                                      */
*/*      OUTER LOOP SEARCHES FOR EXTENSION TO SOLUTION AND EXTENDS   */
*/*            IT IF ONE IS FOUND.                                   */
*/*            THE SEARCH CONSISTS OF EXAMINING ALL GROUPS USABLE BY */
*/*            REQUESTS IN NEED OF UNITS TO LOCATE REQUESTS WHICH    */
*/*            USE THEM.  ALL GROUPS USABLE BY THESE REQUESTS ARE    */
*/*            THEN CHECKED UNTIL NO NEW REQUESTS OR GROUPS ARE      */
*/*            LOCATED (FAILURE) OR A GROUP IS REACHED WHICH         */
*/*            CONTAINS EXCESS UNITS (EXTENSION FOUND).  IF AN       */
*/*            EXTENSION IS FOUND, UNITS ARE ALLOCATED FROM THIS     */
*/*            GROUP TO REQUEST WHICH COULD USE THEM.  THIS FREES    */
*/*            UNITS IN GROUP CURRENTLY ALLOCATED TO REQUEST, WHICH  */
*/*            ARE THEN ALLOCATED TO NEXT REQUEST IN CHAIN.          */
*/*            PROCESS CONTINUES UNTIL REQUEST WHICH WAS SHORT OF    */
*/*            UNITS IS REACHED.                                     */
*/*      ALTERNATING SEARCH AND EXTENSION CONTINUES UNTIL AN ERROR   */
*/*            IS DETECTED OR A FULL SOLUTION IS FOUND.              */
*/*                                                                  */
*/* ENTRY - HUNG                                                     */
*/*                                                                  */
*/*   PURPOSE - SEE FUNCTION                                         */
*/*                                                                  */
*/*   INPUT  - CVRRQLST  CVRNEED   UNITS STILL NEEDED FOR FULL       */
*/*                                ALLOCATION                        */
*/*                      CVRSKFLG  1 - SKIP THIS REQUEST             */
*/*            CVRGPLST  CVRGRPID  IDENTIFIER OF GROUP (FOR LOCK)    */
*/*                      CVRGALL   UNITS ALLOCATED TO THIS GROUP     */
*/*            GRPCOUNT  GRPEXCS   UNITS STILL AVAILABLE             */
*/*                      GRPWPTR   CONNECTION TO WORK TABLE          */
*/*            CVRWORK             WORK AREA                         */
*/*                                                                  */
*/* EXIT -                                                           */
*/*                                                                  */
*/*   CONDITION - FUNCTION COMPLETE                                  */
*/*                                                                  */
*/*   OUTPUT - CVRRQLST  CVRNEED   UNITS (IF ANY) STILL NEEDED       */
*/*                      CVRGNEXT  USED AS WORK AREA                 */
*/*                      CVRMIN    USED AS WORK AREA                 */
*/*            CVRGPLST  CVRGALL   EXTENDED SOLUTION                 */
*/*            GRPCOUNT  GRPEXCS   REFLECTS EXTENDED SOLUTION        */
*/*            CVRWORK             WORK AREA                         */
*/*                                                                  */
*/* IN-LINE SUBROUTINES                                              */
*/*            HUNGMAC             DECLARATION OF MACRO VARIABLES    */
*/*            HUNGDCL             DECLARATION OF VARIABLES          */
*/*            HUNGINIT            LOCATES REQUESTS WHICH ARE NOT    */
*/*                                FULL OR DETECTS COMPLETION        */
*/*            SCANREQS            FIRST HALF OF LOCATING EXTENSION  */
*/*            SCANGRPS            SECOND HALF OF LOCATING EXTEN.    */
*/*            BACKTRK             REARRANGE SOLUTION TO INCLUDE     */
*/*                                EXTENSION                         */
*/*                                                                  */
*/********************************************************************/
*                                                               02S0538
*HUNG:                                                          02S0538
*   PROCEDURE;                                                  02S0538
*                                                               02S0538
HUNG     STM   @14,@12,12(@13)                                  02S0538
*/********************************************************************/
*/*                                                                  */
*/* NAME     - HUNGMAC                                               */
*/*                                                                  */
*/* FUNCTION - DECLARATION OF MACRO VARIABLES USED IN HUNG.          */
*/*                                                                  */
*/********************************************************************/
*/********************************************************************/
*/*                                                                  */
*/* NAME     - HUNGDCL                                               */
*/*                                                                  */
*/* FUNCTION - DECLARATION OF LOCAL VARIABLES                        */
*/*                                                                  */
*/********************************************************************/
*                                                               02S0539
*   /*****************************************************************/
*   /*                                                               */
*   /* DECLARATION OF CONSTANTS                                      */
*   /*                                                               */
*   /*****************************************************************/
*                                                               02S0539
*   DCL                                                         02S0539
*     HUNGOK CONSTANT(0),           /* RETURN CODE - SUCCESS         */
*     HUNGERR CONSTANT(8);          /* RETURN CODE - FAILURE         */
*   DCL                                                         02S0540
*     NEEDFLAG CONSTANT(1);         /* FLAGS INCOMPLETE REQUESTS     */
*                                                               02S0540
*   /*****************************************************************/
*   /*                                                               */
*   /* DECLARATION OF LOCAL ARITHMETIC VARIABLES                     */
*   /*                                                               */
*   /*****************************************************************/
*                                                               02S0541
*   DCL                                                         02S0541
*     HCODE FIXED;                  /* HOLDS RETURN CODE             */
*   DCL                                                         02S0542
*     ADDL FIXED;                   /* NUMBER BY WHICH SOLUTION IS TO
*                                      BE EXTENDED                   */
*                                                               02S0542
*   /*****************************************************************/
*   /*                                                               */
*   /* DECLARATION OF LOCAL FLAGS                                    */
*   /*                                                               */
*   /*****************************************************************/
*                                                               02S0543
*   DCL                                                         02S0543
*     1 * BIT(8),                                               02S0543
*      2 FAILSW BIT(1),             /* USED TO DETECT INFEASIBLE
*                                      COND.                         */
*      2 * BIT(1);                                              02S0543
*                                                               02S0543
*   /*****************************************************************/
*   /*                                                               */
*   /* DECLARATION OF DO LOOP INDICES                                */
*   /*                                                               */
*   /*****************************************************************/
*                                                               02S0544
*   DCL                                                         02S0544
*     HINDEX1 FIXED,                                            02S0544
*     HINDEX2 FIXED,                                            02S0544
*     HINDEX3 FIXED,                                            02S0544
*     HINDEX4 FIXED,                                            02S0544
*     HINDEX5 FIXED;                                            02S0544
*   DCL                                                         02S0545
*     SOLUTION PTR(31);             /* 0 NO SOLUTION FOUND 1 FINAL
*                                      SOLUTION FOUND OTHERWISE 02S0545
*                                      POINTS TO EXTENSION           */
*                                                               02S0545
*   /*****************************************************************/
*   /*                                                               */
*   /* BASE STRUCTURES ON LOCAL POINTERS                             */
*   /*                                                               */
*   /*****************************************************************/
*                                                               02S0546
*   RESPECIFY                                                   02S0546
*     CVRRQLST BASED(REQPTR);                                   02S0546
*   RESPECIFY                                                   02S0547
*     CVRGPLST BASED(GRPPTR);                                   02S0547
*   RESPECIFY                                                   02S0548
*     GRPCOUNT BASED(CNTPTR);                                   02S0548
*   RESPECIFY                                                   02S0549
*     CVRWORKD BASED(GRPWPTR);      /* REGARD CVRWORK AS EXTENSION OF
*                                      GRPCOUNT TABLE                */
*   HCODE=HUNGOK;                   /* START WITH SUCCESS INDICATION */
*                                                               02S0550
         SLR   @10,@10                                          02S0550
         LR    HCODE,@10                                        02S0550
*   /*****************************************************************/
*   /*                                                               */
*   /* SEARCH FOR EXTENSION UNTIL SOLUTION IS FOUND OR INFEASIBILITY */
*   /* DETECTED.                                                     */
*   /*                                                               */
*   /*****************************************************************/
*                                                               02S0551
*   SOLUTION=0;                     /* INIT SW FOR LOOP              */
         LR    SOLUTION,@10                                     02S0551
*   DO WHILE(^(SOLUTION=1)&HCODE=HUNGOK);                       02S0552
         B     @DE00552                                         02S0552
@DL00552 DS    0H                                               02S0553
*                                                               03S0553
*/********************************************************************/
*/*                                                                  */
*/* SEGMENT NAME - HUNGINIT                                          */
*/*                                                                  */
*/* DESCRIPTIVE NAME - LOCATE AND MARK UNSATISFIED REQUEST           */
*/*                                                                  */
*/* FUNCTION - TO LOCATE AND MARK UNSATISFIED REQUESTS.  IF NONE     */
*/*            SET FINAL SOLUTION INDICATOR                          */
*/*                                                                  */
*/* OPERATION -                                                      */
*/*      REQUEST SCAN - IF REQUEST IS NOT FULLY SATISFIED, TURN OFF  */
*/*            FINAL SOLUTION INDICATOR(SOLUTION=0) AND FLAG REQUEST */
*/*            (CVRGNEXT=1).  OTHERWISE, SET CVRGNEXT TO 0 TO        */
*/*            INDICATE THAT IT CAN BE USED TO OBTAIN A SOLUTION.    */
*/*      CVRWORK SCAN - INITIALIZE WREQPTR AND WGUSED.               */
*/*                                                                  */
*/* ENTRY - (INLINE ROUTINE - ENTERED AT TOP)                        */
*/*                                                                  */
*/*   PURPOSE - SEE FUNCTION                                         */
*/*                                                                  */
*/*   INPUT  - CVRRQLST  CVRNEED   NUMBER OF UNITS STILL NEEDED      */
*/*                                                                  */
*/* EXIT - NORMAL - (INLINE SUBROUTINE EXITS AT BOTTOM)              */
*/*                                                                  */
*/*   CONDITION - FUNCTION COMPLETE                                  */
*/*                                                                  */
*/*   OUTPUT - CVRRQLST  CVRGNEXT  0  IF REQUEST FILLED              */
*/*                                1  IF STILL NOT SATISFIED         */
*/*                      CVRMIN    NUMBER REQUIRED                   */
*/*                      CVRUSED   INIT TO 0                         */
*/*            CVRWORK   WREQPTR   INIT TO 0                         */
*/*                      WGUSED    INIT TO 0                         */
*/*            SOLUTION            0 IF SOME REQ NOT SATISFIED       */
*/*                                1 IF ALL REQ SATISFIED            */
*/*                                                                  */
*/********************************************************************/
*                                                               03S0553
*     DO;                           /* START OF HUNGINIT             */
*       SOLUTION=1;                 /* SET INDICATION FOR FINAL 03S0554
*                                      SOLUTION FOUND UNTIL TURNED
*                                      OFF                           */
*                                                               03S0554
         LA    @10,1                                            03S0554
         LR    SOLUTION,@10                                     03S0554
*       /*************************************************************/
*       /*                                                           */
*       /* SCAN REQUESTS, INITIALIZING FIELDS AND LOOKING FOR        */
*       /* REQUESTS WHICH ARE NOT FULLY SATISFIED.                   */
*       /*                                                           */
*       /*************************************************************/
*                                                               03S0555
*       REQPTR=CVRRQPTR;            /* LOCATE FIRST REQUEST          */
         L     REQPTR,CVRRQPTR(,PARMPTR)                        03S0555
*       DO HINDEX1=1 TO CVRNREQ;    /* SET UP LOOP CTL OVER REQS.    */
         LR    HINDEX1,@10                                      03S0556
         B     @DE00556                                         03S0556
@DL00556 DS    0H                                               03S0557
*         IF CVRSKFLG=OFF           /* IS THIS REQUEST TO BE    03S0557
*                                      PROCESSED                     */
*           THEN                    /* REQUEST TO BE PROCESSED       */
         TM    CVRSKFLG(REQPTR),B'10000000'                     03S0557
         BNZ   @RF00557                                         03S0557
*           DO;                                                 03S0558
*             IF CVRNEED>0          /* REQUEST FULLY SATISFIED?      */
*               THEN                /* REQUEST NOT FULLY SATISFIED   */
         SLR   @10,@10                                          03S0559
         LH    @09,CVRNEED(,REQPTR)                             03S0559
         CR    @09,@10                                          03S0559
         BNH   @RF00559                                         03S0559
*               DO;                                             03S0560
*                 SOLUTION=0;       /* INDICATE NOT FINAL SOLUTION
*                                      YET                           */
         LR    SOLUTION,@10                                     03S0561
*                 CVRGNEXT=NEEDFLAG;/* SET FLAG TO SHOW REQ. NEEDING
*                                      UNITS                         */
         MVC   CVRGNEXT(4,REQPTR),@CF00051                      03S0562
*                 CVRMIN=CVRNEED;   /* SET MAX. NUMBER FOR THIS PATH.*/
         STH   @09,CVRMIN(,REQPTR)                              03S0563
*               END;                /* END PROCESSING CASE NEEDING
*                                      UNITS                         */
*             ELSE                  /* NO UNITS NEEDED               */
*               CVRGNEXT=INITVAL;   /* INIT FIELD TO NULL VALUE      */
         B     @RC00559                                         03S0565
@RF00559 SLR   @10,@10                                          03S0565
         ST    @10,CVRGNEXT(,REQPTR)                            03S0565
*             CVRRUSED=OFF;         /* MARK REQUEST NOT USED YET     */
@RC00559 NI    CVRRUSED(REQPTR),B'10111111'                     03S0566
*           END;                    /* END PROCESSING ONE NOT-SKIPPED
*                                      REQUEST                       */
*         REQPTR=REQPTR+LENGTH(CVRRQLST);/* LOCATE NEXT REQUEST      */
@RF00557 AH    REQPTR,@CH00250                                  03S0568
*       END;                        /* END SCAN OF REQUEST           */
*                                                               03S0569
         AH    HINDEX1,@CH00051                                 03S0569
@DE00556 CH    HINDEX1,CVRNREQ(,PARMPTR)                        03S0569
         BNH   @DL00556                                         03S0569
*       /*************************************************************/
*       /*                                                           */
*       /* SCAN CVRWORK, SETTING FIELDS TO INITIAL VALUE             */
*       /*                                                           */
*       /*************************************************************/
*                                                               03S0570
*       WORKPTR=ACVRWORK;           /* LOCATE FIRST ENTRY OF CVRWORK */
         L     WORKPTR,ACVRWORK                                 03S0570
*       RESPECIFY                                               03S0571
*        (CVRWORKD) BASED(WORKPTR);                             03S0571
*       DO WHILE(LASTFLAG=OFF);     /* SCAN ALL ACTIVE ENTRIES       */
         B     @DE00572                                         03S0572
@DL00572 DS    0H                                               03S0573
*         WREQPTR=INITVAL;          /* SET REACH INDICATOR TO NULL   */
         SLR   @10,@10                                          03S0573
         ST    @10,WREQPTR(,WORKPTR)                            03S0573
*         WGUSED=OFF;               /* SET USED INDICATOR TO OFF     */
         NI    WGUSED(WORKPTR),B'10111111'                      03S0574
*         WORKPTR=WORKPTR+LENGTH(CVRWORKD);/* LOCATE NEXT ENTRY IN
*                                      CVRWORK                       */
         AH    WORKPTR,@CH00067                                 03S0575
*       END;                        /* END OF SCAN OF CVRWORK        */
@DE00572 TM    LASTFLAG(WORKPTR),B'10000000'                    03S0576
         BZ    @DL00572                                         03S0576
*       RESPECIFY                                               03S0577
*        (CVRWORKD) BASED(GRPWPTR);                             03S0577
*     END;                          /* END OF HUNGINIT               */
*     FAILSW=OFF;                   /* NO FAILURE YET                */
         NI    FAILSW,B'01111111'                               02S0579
*     DO WHILE(SOLUTION=0&FAILSW=OFF);/* CONTINUE UNTIL AN EXTENSION
*                                      IS FOUND OR FAILURE IS   02S0580
*                                      DETECTED                      */
*                                                               02S0580
         B     @DE00580                                         02S0580
@DL00580 DS    0H                                               02S0581
*       /*************************************************************/
*       /*                                                           */
*       /* FIND GROUPS REACHED FROM REQUESTS IDENTIFIED IN LAST PASS */
*       /*                                                           */
*       /*************************************************************/
*                                                               02S0581
*                                                               03S0581
*/********************************************************************/
*/*                                                                  */
*/* SEGMENT NAME - SCANREQS                                          */
*/*                                                                  */
*/* DESCRIPTIVE NAME - FIRST HALF OF LOCATING EXTENSION TO SOLUTION  */
*/*                                                                  */
*/* FUNCTION - TO FIND NEW GROUPS FOR REQUESTS FOUND IN LAST PASS.   */
*/*            IF ONE CONTAINS AVAILABLE UNITS, INDICATE             */
*/*            EXTENSION TO SOLUTION.  IF NO NEW GROUPS ARE FOUND,   */
*/*            INDICATE FAILURE.                                     */
*/* OPERATION -                                                      */
*/*      REQUEST SCAN - EXAMINE GROUPS FOR EACH REQUEST WHICH HAS    */
*/*            BEEN REACHED (CVRGNEXT^=0) BUT NOT YET USED.  IF ANY  */
*/*            GROUP HAS NOT YET BEEN REACHED(WREQPTR=0), SET        */
*/*            WREQPTR TO POINTER TO REQUEST WHICH REACHED IT AND    */
*/*            WGRPPTR TO CVRGPLST ENTRY WHICH REACHED IT.  IF       */
*/*            GROUP HAS UNUSED UNITS, INDICATE THAT AN EXTENSION    */
*/*            HAS BEEN FOUND BY SETTING SOLUTION TO ADDRESS OF      */
*/*            CVRWORK ENTRY.                                        */
*/*                                                                  */
*/* ENTRY - (INLINE SUBROUTINE ENTERED AT TOP)                       */
*/*                                                                  */
*/*   PURPOSE - SEE FUNCTION                                         */
*/*                                                                  */
*/*   INPUT  - CVRRQLST  CVRGNEXT  0 IF REQ NOT YET REACHED          */
*/*                      CVRSKFLG  1 - IGNORE REQUEST                */
*/*                      CVRRUSED  1 - REQUEST ALREADY SCANNED       */
*/*                      CVRMIN    NUMBER TO BE MOVED                */
*/*            GRPCOUNT  GRPEXCS   NUMBER OF UNITS AVAILABLE         */
*/*            CVRWORK   WREQPTR   0 GROUP NOT REACHED YET           */
*/*                                                                  */
*/* EXIT - NORMAL - (INLINE SUBROUTINE - EXITS AT BOTTOM)            */
*/*                                                                  */
*/*   CONDITION - FUNCTION COMPLETE                                  */
*/*                                                                  */
*/*   OUTPUT - CVRRQLST  CVRUSED   INDICATES REQUEST SCANNED         */
*/*            CVRWORK   WREQPTR                                     */
*/*                      WGRPPTR                                     */
*/*                      WMIN                                        */
*/*                                                                  */
*/********************************************************************/
*                                                               03S0581
*       DO;                         /* START OF SCANREQS             */
*         FAILSW=ON;                /* INDICATE FAILURE UNTIL NEW
*                                      GROUP IS FOUND                */
*                                                               03S0582
         OI    FAILSW,B'10000000'                               03S0582
*         /***********************************************************/
*         /*                                                         */
*         /* SCAN REQUESTS LOOKING FOR NEW GROUPS. TERMINATE SCAN IF */
*         /* EXTENSION TO SOLUTION IS FOUND.                         */
*         /*                                                         */
*         /***********************************************************/
*                                                               03S0583
*         REQPTR=CVRRQPTR;          /* LOCATE FIRST REQUEST          */
         L     REQPTR,CVRRQPTR(,PARMPTR)                        03S0583
*         DO HINDEX2=1 TO CVRNREQ WHILE(SOLUTION=0);/* SET UP LOOP
*                                      CONTROL OVER REQS             */
*                                                               03S0584
         LA    HINDEX2,1                                        03S0584
         B     @DE00584                                         03S0584
@DL00584 SLR   @10,@10                                          03S0584
         CR    SOLUTION,@10                                     03S0584
         BNE   @DC00584                                         03S0584
*           /*********************************************************/
*           /*                                                       */
*           /* CONSIDER ONLY THOSE REQUESTS WHICH HAVE BEEN REACHED  */
*           /* IN GROUP SCAN BUT NOT USED IN ANY REQUEST SCAN YET.   */
*           /*                                                       */
*           /*********************************************************/
*                                                               03S0585
*           IF CVRSKFLG=OFF&CVRGNEXT^=INITVAL&^(CVRRUSED=ON) THEN/*
*                                      REQ REACHED BUT NOT USED      */
         TM    CVRSKFLG(REQPTR),B'10000000'                     03S0585
         BNZ   @RF00585                                         03S0585
         C     @10,CVRGNEXT(,REQPTR)                            03S0585
         BE    @RF00585                                         03S0585
         TM    CVRRUSED(REQPTR),B'01000000'                     03S0585
         BO    @RF00585                                         03S0585
*             DO;                                               03S0586
*                                                               03S0586
*               /*****************************************************/
*               /*                                                   */
*               /* SCAN GROUPS FOR THIS REQUEST LOOKING FOR ONE WHICH*/
*               /* HAS NOT BEEN REACHED YET. IF AN UNREACHED GROUP   */
*               /* CONTAINS EXCESS UNITS, AN EXTENSION TO THE        */
*               /* SOLUTION HAS BEEN FOUND AND THE SCAN ENDS.        */
*               /*                                                   */
*               /*****************************************************/
*                                                               03S0587
*               GRPPTR=CVRGRPPT;    /* LOCATE FIRST GROUP            */
         L     GRPPTR,CVRGRPPT(,REQPTR)                         03S0587
*               DO HINDEX3=1 TO CVRNGRP WHILE(CVRGRPID<=CVRGRPLK&
*                     SOLUTION=0);  /* SET UP LOOP CONTROL OVER 03S0588
*                                      GROUPS                        */
         LA    HINDEX3,1                                        03S0588
         B     @DE00588                                         03S0588
@DL00588 LH    @10,CVRGRPID(,GRPPTR)                            03S0588
         CH    @10,CVRGRPLK(,PARMPTR)                           03S0588
         BH    @DC00588                                         03S0588
         SLR   @10,@10                                          03S0588
         CR    SOLUTION,@10                                     03S0588
         BNE   @DC00588                                         03S0588
*                 IF CVRGSKP=OFF THEN                           03S0589
         TM    CVRGSKP(GRPPTR),B'10000000'                      03S0589
         BNZ   @RF00589                                         03S0589
*                   DO;                                         03S0590
*                     CNTPTR=CVRGCPTR;/* LOCATE GRPCOUNT ENTRY       */
         L     CNTPTR,CVRGCPTR(,GRPPTR)                         03S0591
*                     IF WREQPTR=INITVAL/* GROUP REACHED YET?        */
*                       THEN        /* GROUP NOT REACHED YET         */
         L     @15,GRPWPTR(,CNTPTR)                             03S0592
         C     @10,WREQPTR(,@15)                                03S0592
         BNE   @RF00592                                         03S0592
*                       DO;                                     03S0593
*                         WREQPTR=REQPTR;/* INDICATE GROUP REACHED
*                                      AND SAVE POINTER TO REQUEST
*                                      WHICH REACHED IT              */
         ST    REQPTR,WREQPTR(,@15)                             03S0594
*                         WGRPPTR=GRPPTR;/* SAVE PTR TO ENTRY IN
*                                      CVRGPLST                      */
         ST    GRPPTR,WGRPPTR(,@15)                             03S0595
*                         WMIN=CVRMIN;/* NUMBER OF UNITS MOVABLE OVER
*                                      THIS PATH                     */
         MVC   WMIN(2,@15),CVRMIN(REQPTR)                       03S0596
*                         FAILSW=OFF;/* NEW GROUP HAS BEEN REACHED   */
         NI    FAILSW,B'01111111'                               03S0597
*                         IF GRPEXCS>0/* ANY UNUSED UNITS?           */
*                           THEN    /* UNUSED UNITS IN THIS GROUP    */
         CH    @10,GRPEXCS(,CNTPTR)                             03S0598
         BNL   @RF00598                                         03S0598
*                           SOLUTION=GRPWPTR;/* INDICATE EXTENSION   */
         LR    SOLUTION,@15                                     03S0599
*                       END;        /* END OF PROCESSING OF REACHED
*                                      GROUP                         */
*                   END;                                        03S0601
*                 ELSE                                          03S0602
*                   ;                                           03S0602
@RF00589 DS    0H                                               03S0603
*                 GRPPTR=GRPPTR+LENGTH(CVRGPLST);/* LOCATE NEXT GROUP
*                                      FOR REQ                       */
@RC00589 AH    GRPPTR,@CH00067                                  03S0603
*               END;                /* END OF GROUP SCAN             */
         AH    HINDEX3,@CH00051                                 03S0604
@DE00588 CH    HINDEX3,CVRNGRP(,REQPTR)                         03S0604
         BNH   @DL00588                                         03S0604
@DC00588 DS    0H                                               03S0605
*               CVRRUSED=ON;        /* MARK REQUEST AS USED          */
         OI    CVRRUSED(REQPTR),B'01000000'                     03S0605
*             END;                  /* END HANDLING OF REACHED BUT
*                                      NOT USED REQUEST              */
*           REQPTR=REQPTR+LENGTH(CVRRQLST);/* LOCATE NEXT REQUEST    */
@RF00585 AH    REQPTR,@CH00250                                  03S0607
*         END;                      /* END OF REQUEST SCAN           */
         AH    HINDEX2,@CH00051                                 03S0608
@DE00584 CH    HINDEX2,CVRNREQ(,PARMPTR)                        03S0608
         BNH   @DL00584                                         03S0608
@DC00584 DS    0H                                               03S0609
*       END;                        /* END OF SCANREQ                */
*       IF FAILSW=OFF&SOLUTION=0    /* WAS NEW GROUP REACHED OR 02S0610
*                                      SOLUTION FOUND?               */
*         THEN                      /* NEW GROUP REACHED BUT NO 02S0610
*                                                              SOLUTN*/
         TM    FAILSW,B'10000000'                               02S0610
         BNZ   @RF00610                                         02S0610
         LTR   SOLUTION,SOLUTION                                02S0610
         BNZ   @RF00610                                         02S0610
*                                                               03S0611
*/********************************************************************/
*/*                                                                  */
*/* SEGMENT NAME - SCANGRPS                                          */
*/*                                                                  */
*/* DESCRIPTIVE NAME - SECOND HALF OF LOCATING EXTENSION TO SOLUTION */
*/*                                                                  */
*/* FUNCTION - TO FIND AND MARK ALL UNUSED REQUESTS WHICH HAVE       */
*/*            A GROUP FOUND IN SCANREQS AS SOLUTION ELEMENT         */
*/*                                                                  */
*/* OPERATION -                                                      */
*/*      GROUPS TO BE USED IN THIS EXTENSION ARE IDENTIFIED BY       */
*/*            WREQPTR NOT 0.  EACH REQUEST WHICH HAS NOT YET BEEN   */
*/*            REACHED IS CHECKED TO SEE WHETHER IT USES ANY GROUP   */
*/*            WITH THIS CHARACTERISTIC IN ITS SOLUTION.  IF IT DOES */
*/*            CVRGNEXT IS SET TO ADDRESS OF CVRGPLST ENTRY FOR      */
*/*            THIS GROUP.                                           */
*/*                                                                  */
*/* ENTRY - (INLINE SUBROUTINE - ENTERED AT TOP)                     */
*/*                                                                  */
*/*   PURPOSE - SEE FUNCTION                                         */
*/*                                                                  */
*/*   INPUT  - CVRRQLST  CVRGNEXT  0 IF AVAILABLE                    */
*/*                      CVRSKFLG  1 - REQUEST IS TO BE IGNORED      */
*/*            CVRGPLST  CVRGALL   NUMBER ALLOCATED TO THIS REQUEST  */
*/*                                FROM THIS GROUP                   */
*/*            CVRWORK   WREQPTR   ^=0 IF GROUP HAS BEEN REACHED     */
*/*                                                                  */
*/* EXIT - NORMAL - (INLINE SUBROUTINE - EXITS AT BOTTOM)            */
*/*                                                                  */
*/*   CONDITION - FUNCTION COMPLETE                                  */
*/*                                                                  */
*/*   OUTPUT - CVRRQLST  CVRGNEXT  POINTER TO GROUP FROM WHICH REQ   */
*/*                                WAS REACHED                       */
*/*                      CVRMIN    NUMBER OF UNITS WHICH CAN BE ADDED*/
*/*                                                                  */
*/********************************************************************/
*                                                               03S0611
*         DO;                       /* START OF SCANGRPS             */
*           RESPECIFY                                           03S0612
*            (CVRWORKD) BASED(GRPWPTR);                         03S0612
*           FAILSW=ON;              /* INDICATE FAILURE UNTIL A NEW
*                                      REQUEST IS REACHED.           */
*                                                               03S0613
         OI    FAILSW,B'10000000'                               03S0613
*           /*********************************************************/
*           /*                                                       */
*           /* SCAN REQUESTS LOOKING FOR ONE WHICH HAS MARKED GROUP  */
*           /* AS SOLUTION GROUP.                                    */
*           /*                                                       */
*           /*********************************************************/
*                                                               03S0614
*           REQPTR=CVRRQPTR;        /* LOCATE FIRST REQUEST          */
         L     REQPTR,CVRRQPTR(,PARMPTR)                        03S0614
*           DO HINDEX4=1 TO CVRNREQ;/* SET UP LOOP CONTROL OVER REQS */
         LA    HINDEX4,1                                        03S0615
         B     @DE00615                                         03S0615
@DL00615 DS    0H                                               03S0616
*             IF CVRSKFLG=OFF&CVRGNEXT=INITVAL/* IS REQ TO BE   03S0616
*                                      PROCESSED AND NOT REACHED YET?*/
*               THEN                /* PROCESSABLE REQ NOT REACHED   */
         TM    CVRSKFLG(REQPTR),B'10000000'                     03S0616
         BNZ   @RF00616                                         03S0616
         ICM   @10,15,CVRGNEXT(REQPTR)                          03S0616
         BNZ   @RF00616                                         03S0616
*               DO;                                             03S0617
*                                                               03S0617
*                 /***************************************************/
*                 /*                                                 */
*                 /* SCAN GROUPS LOOKING FOR SOLUTION GROUPS WITH    */
*                 /* WREQPTR^=0                                      */
*                 /*                                                 */
*                 /***************************************************/
*                                                               03S0618
*                 GRPPTR=CVRGRPPT;  /* LOCATE FIRST GROUP            */
         L     GRPPTR,CVRGRPPT(,REQPTR)                         03S0618
*                 DO HINDEX5=1 TO CVRNGRP WHILE(CVRGRPID<=CVRGRPLK&
*                       CVRGNEXT=0);/* END SCAN WHEN ALL ARE    03S0619
*                                      EXHAUSTED OR REACH HAS BEEN
*                                      ESTABLISHED                   */
         LA    HINDEX5,1                                        03S0619
         B     @DE00619                                         03S0619
@DL00619 LH    @10,CVRGRPID(,GRPPTR)                            03S0619
         CH    @10,CVRGRPLK(,PARMPTR)                           03S0619
         BH    @DC00619                                         03S0619
         SLR   @10,@10                                          03S0619
         C     @10,CVRGNEXT(,REQPTR)                            03S0619
         BNE   @DC00619                                         03S0619
*                   IF CVRGSKP=OFF THEN                         03S0620
         TM    CVRGSKP(GRPPTR),B'10000000'                      03S0620
         BNZ   @RF00620                                         03S0620
*                     DO;                                       03S0621
*                       CNTPTR=CVRGCPTR;/* LOCATE GRPCOUNT ENTRY     */
         L     CNTPTR,CVRGCPTR(,GRPPTR)                         03S0622
*                       IF CVRGALL>0&WREQPTR^=INITVAL/* REACHED 03S0623
*                                      SOLUTION GROUP?               */
*                         THEN      /* REACHED SOLUTION GROUP        */
         LH    @15,CVRGALL(,GRPPTR)                             03S0623
         CR    @15,@10                                          03S0623
         BNH   @RF00623                                         03S0623
         L     @14,GRPWPTR(,CNTPTR)                             03S0623
         C     @10,WREQPTR(,@14)                                03S0623
         BE    @RF00623                                         03S0623
*                         DO;                                   03S0624
*                           CVRGNEXT=GRPPTR;/* INDICATE REQUEST 03S0625
*                                      REACHED AND SAVE PTR TO GROUP
*                                      WHICH REACHED IT              */
         ST    GRPPTR,CVRGNEXT(,REQPTR)                         03S0625
*                           CVRMIN=MIN(WMIN,CVRGALL);/* NUMBER OF
*                                      UNITS WHICH CAN BE MOVED OVER
*                                      THIS PATH                     */
         LH    @10,WMIN(,@14)                                   03S0626
         CR    @10,@15                                          03S0626
         BNH   *+6
         LR    @10,@15                                          03S0626
         STH   @10,CVRMIN(,REQPTR)                              03S0626
*                           FAILSW=OFF;/* INDICATE NEW REQ REACHED   */
         NI    FAILSW,B'01111111'                               03S0627
*                         END;      /* END OF PROCESSING OF SOLUTION
*                                      GROUP                         */
*                     END;                                      03S0629
*                   ELSE                                        03S0630
*                     ;                                         03S0630
@RF00620 DS    0H                                               03S0631
*                   GRPPTR=GRPPTR+LENGTH(CVRGPLST);/* LOCATE NEXT
*                                      GROUP                         */
@RC00620 AH    GRPPTR,@CH00067                                  03S0631
*                 END;              /* END OF GROUP SCAN             */
         AH    HINDEX5,@CH00051                                 03S0632
@DE00619 CH    HINDEX5,CVRNGRP(,REQPTR)                         03S0632
         BNH   @DL00619                                         03S0632
@DC00619 DS    0H                                               03S0633
*               END;                /* END OF CHECKING ONE REQUEST   */
*             REQPTR=REQPTR+LENGTH(CVRRQLST);/* LOCATE NEXT REQUEST  */
@RF00616 AH    REQPTR,@CH00250                                  03S0634
*           END;                    /* END OF REQUEST SCAN           */
         AH    HINDEX4,@CH00051                                 03S0635
@DE00615 CH    HINDEX4,CVRNREQ(,PARMPTR)                        03S0635
         BNH   @DL00615                                         03S0635
*         END;                      /* END OF SCANGRPS               */
*     END;                          /* END SEARCH FOR EXTENSION      */
@RF00610 DS    0H                                               02S0637
@DE00580 LTR   SOLUTION,SOLUTION                                02S0637
         BNZ   @DC00580                                         02S0637
         TM    FAILSW,B'10000000'                               02S0637
         BZ    @DL00580                                         02S0637
@DC00580 DS    0H                                               02S0638
*     IF^(SOLUTION=0)&^(SOLUTION=1) /* WAS EXTENSION FOUND?          */
*       THEN                        /* EXTENSION WAS FOUND           */
         LTR   SOLUTION,SOLUTION                                02S0638
         BZ    @RF00638                                         02S0638
         CH    SOLUTION,@CH00051                                02S0638
         BE    @RF00638                                         02S0638
*                                                               03S0639
*/********************************************************************/
*/*                                                                  */
*/* SEGMENT NAME - BACKTRK                                           */
*/*                                                                  */
*/* DESCRIPTIVE NAME - REARRANGE SOLUTION                            */
*/*                                                                  */
*/* FUNCTION - TO UPDATE THE COUNTS TO REFLECT THE EXTENDED SOLUTION */
*/*                                                                  */
*/* OPERATION -                                                      */
*/*      AT ENTRY, SOLUTION CONTAINS THE ADDRESS OF THE CVRWORK      */
*/*            ENTRY FOR THE GROUP WHICH CONTAINS EXCESS UNITS.      */
*/*            EACH CVRWORK ENTRY IN CHAIN CONTAINS A POINTER TO     */
*/*            REQUEST WHICH IS TO HAVE UNITS MOVED AND A POINTER TO */
*/*            CVRGPLST TO WHICH THEY ARE TO BE MOVED.  EACH REQUEST */
*/*            IN CHAIN CONTAINS A POINTER TO CVRGPLST ENTRY FROM    */
*/*            WHICH UNITS ARE TO BE MOVED.                          */
*/*      INITIALLY, THE NUMBER OF UNITS TO BE MOVED IS CALCULATED    */
*/*            AND SUBTRACTED FROM THE NUMBER OF EXCESS UNITS        */
*/*            AVAILABLE IN GROUP INIDICATED BY SOLUTION.            */
*/*      BACKTRACKING - THE REQUEST AND GROUP TO WHICH UNITS ARE TO  */
*/*            BE ALLOCATED ARE LOCATED FROM POINTERS IN CVRWORK.    */
*/*            THE ALLOCATION TO THAT GROUP IS INCREASED.  THE GROUP */
*/*            POINTER IN CVRRQLST IS EXAMINED.  IF IT IS THE FLAG   */
*/*            VALUE(1), BACKTRACKING IS COMPLETED.  OTHERWISE,      */
*/*            THE ALLOCATION TO THAT GROUP IS REDUCED, THE CVRWORK  */
*/*            ENTRY CORRESPONDING TO THAT GROUP IS LOCATED, AND     */
*/*            BACKTRACKING CONTINUES.                               */
*/*      CLEAN-UP - REACHED WHEN GROUP POINTER IS FLAG VALUE.  THE   */
*/*            NUMBER NEEDED FOR THIS REQUEST (CVRNEED) IS REDUCED.  */
*/*                                                                  */
*/* ENTRY - THIS CODE IS AN INLINE SUBROUTINE WHICH IS ENTERED AT    */
*/*         THE TOP                                                  */
*/*                                                                  */
*/*   PURPOSE - SEE FUNCTION                                         */
*/*                                                                  */
*/* INPUT    - SOLUTION            GROUP WITH EXCESS UNITS           */
*/*            CVRRQLST CVRNEED    NUMBER OF UNITS NEEDED            */
*/*                     CVRGNEXT   GRP FROM WHICH UNITS ARE REMOVED  */
*/*                                OR COMPLETION FLAG                */
*/*            CVRGPLST CVRGALL    CURRENT SOLUTION                  */
*/*            GRPCOUNT GRPEXCS    NUMBER OF UNITS AVAILABLE         */
*/*            CVRWORK  WMIN       MAX NUMBER MOVABLE                */
*/*                     WREQPTR    REQUEST TO BE CHANGED             */
*/*                     WGRPPTR    GROUP TO BE INCREASED             */
*/*                                                                  */
*/* EXIT - NORMAL (INLINE SUBROUTINE - EXITS AT BOTTOM)              */
*/*                                                                  */
*/*   CONDITION - COUNTS UPDATED                                     */
*/*                                                                  */
*/* OUTPUT   - CVRRQLST CVRNEED    NUMBER OF UNITS STILL NEEDED      */
*/*            CVRGPLST CVRGALL    NEW SOLUTION                      */
*/*            GRPCOUNT GRPEXCS    NUMBER OF UNITS STILL AVAILABLE   */
*/*                                                                  */
*/********************************************************************/
*                                                               03S0639
*       DO;                         /* START OF BACKTRACKING         */
*         CNTPTR=SOLUTION->WCNTPTR; /* LOCATE GRPCOUNT ENTRY FOR
*                                      GROUP WITH EXCESS             */
         L     CNTPTR,WCNTPTR(,SOLUTION)                        03S0640
*         RESPECIFY                                             03S0641
*           CVRWORKD BASED(GRPWPTR);/* CONSIDER CVRWORK AS EXTENSION
*                                      OF GRPCOUNT                   */
*         ADDL=MIN(WMIN,GRPEXCS);   /* CALCULATE NUMBER TO BE MOVED  */
         L     @10,GRPWPTR(,CNTPTR)                             03S0642
         LH    @09,GRPEXCS(,CNTPTR)                             03S0642
         LH    ADDL,WMIN(,@10)                                  03S0642
         CR    ADDL,@09                                         03S0642
         BNH   *+6
         LR    ADDL,@09                                         03S0642
*         GRPEXCS=GRPEXCS-ADDL;     /* REDUCE COUNT OF EXCESS        */
         SLR   @09,ADDL                                         03S0643
         STH   @09,GRPEXCS(,CNTPTR)                             03S0643
*         DONESW=OFF;               /* INITIALIZE SWITCH CONTROLLING
*                                      LOOP                          */
*                                                               03S0644
         NI    DONESW,B'01111111'                               03S0644
*         /***********************************************************/
*         /*                                                         */
*         /* IN EACH EXECUTION OF THIS LOOP, UNITS ARE MOVED FROM ONE*/
*         /* GROUP TO ANOTHER WITHIN THE SAME REQUEST UNTIL THE      */
*         /* REQUEST WHICH REQUIRES MORE UNITS IS REACHED.           */
*         /*                                                         */
*         /***********************************************************/
*                                                               03S0645
*         DO WHILE(^(DONESW=ON));   /* CONTINUE UNTIL FLAG SET       */
         B     @DE00645                                         03S0645
@DL00645 DS    0H                                               03S0646
*           REQPTR=WREQPTR;         /* REQUEST WHICH IS TO HAVE UNITS
*                                      MOVED                         */
         L     @10,GRPWPTR(,CNTPTR)                             03S0646
         L     REQPTR,WREQPTR(,@10)                             03S0646
*           GRPPTR=WGRPPTR;         /* GROUP TO WHICH UNITS ARE TO BE
*                                      ADDED                         */
         L     GRPPTR,WGRPPTR(,@10)                             03S0647
*           CVRGALL=CVRGALL+ADDL;   /* ADD IN UNITS                  */
         LR    @10,ADDL                                         03S0648
         AH    @10,CVRGALL(,GRPPTR)                             03S0648
         STH   @10,CVRGALL(,GRPPTR)                             03S0648
*           IF CVRGNEXT=NEEDFLAG    /* DOES REQUEST NEED UNITS?      */
*             THEN                  /* REQUEST NEEDS UNITS           */
         CLC   CVRGNEXT(4,REQPTR),@CF00051                      03S0649
         BNE   @RF00649                                         03S0649
*             DO;                                               03S0650
*               CVRNEED=CVRNEED-ADDL;/* REDUCE NUMBER NEEDED         */
         LH    @10,CVRNEED(,REQPTR)                             03S0651
         SLR   @10,ADDL                                         03S0651
         STH   @10,CVRNEED(,REQPTR)                             03S0651
*               DONESW=ON;          /* SET FLAG TO INDICATE SOLUTION
*                                      HAS BEEN EXTENDED             */
         OI    DONESW,B'10000000'                               03S0652
*             END;                                              03S0653
*           ELSE                    /* REQUEST DOES NOT NEED UNITS   */
*             DO;                                               03S0654
         B     @RC00649                                         03S0654
@RF00649 DS    0H                                               03S0655
*               GRPPTR=CVRGNEXT;    /* LOCATE GROUP FROM WHICH UNITS
*                                      ARE TO BE REMOVED             */
         L     GRPPTR,CVRGNEXT(,REQPTR)                         03S0655
*               CNTPTR=CVRGCPTR;    /* LOCATE COUNT ENTRY FOR GROUP  */
         L     CNTPTR,CVRGCPTR(,GRPPTR)                         03S0656
*               CVRGALL=CVRGALL-ADDL;/* REDUCE NUMBER ALLOCATED TO
*                                      GRP                           */
         LH    @10,CVRGALL(,GRPPTR)                             03S0657
         SLR   @10,ADDL                                         03S0657
         STH   @10,CVRGALL(,GRPPTR)                             03S0657
*             END;                                              03S0658
*         END;                      /* END OF LOOP TO WORK IN UNITS  */
@RC00649 DS    0H                                               03S0659
@DE00645 TM    DONESW,B'10000000'                               03S0659
         BNO   @DL00645                                         03S0659
*       END;                        /* END OF BACK TRACK             */
*     ELSE                          /* EXTENSION WAS NOT FOUND       */
*       IF FAILSW=ON                /* WAS INFEASIBILITY DETECTED?   */
*         THEN                      /* INFEASIBILITY FOUND           */
         B     @RC00638                                         02S0661
@RF00638 TM    FAILSW,B'10000000'                               02S0661
         BNO   @RF00661                                         02S0661
*         HCODE=HUNGERR;            /* SET RETURN CODE TO ERROR IND. */
         LA    HCODE,8                                          02S0662
*   END;                            /* END ONE PASS SEARCHING FOR
*                                      SOLUTION OR FAILURE           */
@RF00661 DS    0H                                               02S0663
@RC00638 DS    0H                                               02S0663
@DE00552 CH    SOLUTION,@CH00051                                02S0663
         BE    @DC00552                                         02S0663
         LTR   HCODE,HCODE                                      02S0663
         BZ    @DL00552                                         02S0663
@DC00552 DS    0H                                               02S0664
*   RETURN CODE(HCODE);                                         02S0664
         LR    @15,HCODE                                        02S0664
         L     @14,12(,@13)                                     02S0664
         LM    @00,@12,20(@13)                                  02S0664
         BR    @14                                              02S0664
*   END;                                                        02S0665
*   END IEFAB480                                                01S0666
*                                                               01S0666
*/* THE FOLLOWING INCLUDE STATEMENTS WERE FOUND IN THIS PROGRAM.     */
*/*%INCLUDE SYSLIB  (CVRSPEC )                                       */
*/*%INCLUDE SYSLIB  (CVRMAC  )                                       */
*/*%INCLUDE SYSLIB  (IEFZB426)                                       */
*/*%INCLUDE SYSLIB  (CVRLDCL )                                       */
*/*%INCLUDE SYSLIB  (CHKPARM )                                       */
*/*%INCLUDE SYSLIB  (CVRINIT )                                       */
*/*%INCLUDE SYSLIB  (CNTGRPS )                                       */
*/*%INCLUDE SYSLIB  (GETWORK )                                       */
*/*%INCLUDE SYSLIB  (SUMUNITS)                                       */
*/*%INCLUDE SYSLIB  (REDOSOL )                                       */
*/*%INCLUDE SYSLIB  (PTSREDUC)                                       */
*/*%INCLUDE SYSLIB  (FINDEXCS)                                       */
*/*%INCLUDE SYSLIB  (FINDSTRT)                                       */
*/*%INCLUDE SYSLIB  (ROWREACH)                                       */
*/*%INCLUDE SYSLIB  (REDUCE  )                                       */
*/*%INCLUDE SYSLIB  (FREEWORK)                                       */
*/*%INCLUDE SYSLIB  (FINDROWS)                                       */
*/*%INCLUDE SYSLIB  (COLREACH)                                       */
*/*%INCLUDE SYSLIB  (FINDTRL )                                       */
*/*%INCLUDE SYSLIB  (HUNG    )                                       */
*/*%INCLUDE SYSLIB  (HUNGMAC )                                       */
*/*%INCLUDE SYSLIB  (HUNGDCL )                                       */
*/*%INCLUDE SYSLIB  (HUNGINIT)                                       */
*/*%INCLUDE SYSLIB  (SCANREQS)                                       */
*/*%INCLUDE SYSLIB  (SCANGRPS)                                       */
*/*%INCLUDE SYSLIB  (BACKTRK )                                       */
*                                                               01S0666
*       ;                                                       01S0666
@DATA    DS    0H
@CH00067 DC    H'16'
@CH00250 DC    H'28'
@CH00125 DC    H'-1'
@DATD    DSECT
         DS    0F
@SA00001 DS    18F
@PC00001 DS    1F
IEFAB480 CSECT
         DS    0F
@CF00051 DC    F'1'
@CH00051 EQU   @CF00051+2
@CF00128 DC    XL4'E6000000'
@DATD    DSECT
         DS    0D
ALGTABP  DS    A
ACVRWORK DS    A
INDEX23  DS    F
@NM00009 DS    BL1
         ORG   @NM00009
DONESW   DS    BL1
FOUNDSW  EQU   @NM00009+0
EXCESSSW EQU   @NM00009+0
CREACHSW EQU   @NM00009+0
RREACHSW EQU   @NM00009+0
GFOUNDSW EQU   @NM00009+0
@NM00010 EQU   @NM00009+0
         ORG   @NM00009+1
@NM00011 DS    BL1
         ORG   @NM00011
FAILSW   DS    BL1
@NM00012 EQU   @NM00011+0
         ORG   @NM00011+1
@OLDKEY  DS    AL1
IEFAB480 CSECT
         DS    0F
@SIZDATD DC    AL1(230)
         DC    AL3(@ENDDATD-@DATD)
         DS    0D
IEFAB480 CSECT
         DS   0H
PATCHLOC DC ((@DATA-@PSTART)/20)X'00'
@DATD    DSECT
        DS 0F
GETMAIN GETMAIN EC,MF=L
@DATD    DSECT
         ORG   *+1-(*-@DATD)/(*-@DATD) INSURE DSECT DATA
@ENDDATD EQU   *
IEFAB480 CSECT
@00      EQU   00                      EQUATES FOR REGISTERS 0-15
@01      EQU   01
@02      EQU   02
@03      EQU   03
@04      EQU   04
@05      EQU   05
@06      EQU   06
@07      EQU   07
@08      EQU   08
@09      EQU   09
@10      EQU   10
@11      EQU   11
@12      EQU   12
@13      EQU   13
@14      EQU   14
@15      EQU   15
SOLUTION EQU   @07
HINDEX5  EQU   @09
HINDEX4  EQU   @04
HINDEX3  EQU   @09
HINDEX2  EQU   @04
HINDEX1  EQU   @03
ADDL     EQU   @04
HCODE    EQU   @08
PARMPTR  EQU   @05
WORKPTR  EQU   @04
CNTPTR   EQU   @06
GRPPTR   EQU   @03
REQPTR   EQU   @02
FINDEX2  EQU   @09
FINDEX1  EQU   @08
INDEX22  EQU   @03
INDEX21  EQU   @07
INDEX20  EQU   @04
INDEX19  EQU   @07
INDEX18  EQU   @04
INDEX17  EQU   @07
INDEX16  EQU   @02
INDEX15  EQU   @03
INDEX14  EQU   @04
INDEX13  EQU   @07
INDEX12  EQU   @04
INDEX11  EQU   @04
INDEX10  EQU   @07
INDEX9   EQU   @04
INDEX8   EQU   @04
INDEX7   EQU   @07
INDEX6   EQU   @07
INDEX5   EQU   @06
INDEX4   EQU   @08
INDEX3   EQU   @07
INDEX2   EQU   @10
INDEX1   EQU   @08
FLAGCNT  EQU   @02
MINX     EQU   @04
FCODE    EQU   @07
RCODE    EQU   @09
ALCOUNT  EQU   @04
STARTR   EQU   @07
PTSN     EQU   @08
SIZE     EQU   @10
COUNT    EQU   @07
R0       EQU   @00
R1       EQU   @01
R2       EQU   @02
R3       EQU   @03
R15      EQU   @15
ALGPTRS  EQU   0
CVRPARM  EQU   0
CVRRQPTR EQU   CVRPARM
CVRNREQ  EQU   CVRPARM+4
CVRGRPLK EQU   CVRPARM+6
CVRFLG1  EQU   CVRPARM+8
CVRAVFLG EQU   CVRFLG1
CVRALFLG EQU   CVRFLG1
CVROFFLG EQU   CVRFLG1
CVRFCALL EQU   CVRFLG1
CVRRQLST EQU   0
CVRREQ1  EQU   CVRRQLST+4
CVRALLCT EQU   CVRRQLST+6
CVRNEED  EQU   CVRRQLST+8
CVRMIN   EQU   CVRRQLST+10
CVRPTS   EQU   CVRMIN
CVRGNEXT EQU   CVRRQLST+12
CVRFLG2  EQU   CVRRQLST+16
CVRSKFLG EQU   CVRFLG2
CVRRUSED EQU   CVRFLG2
CVRREACH EQU   CVRFLG2
CVRFULL  EQU   CVRFLG2
CVRNGRP  EQU   CVRRQLST+18
CVRGRPPT EQU   CVRRQLST+20
CVRGPLST EQU   0
CVRGCPTR EQU   CVRGPLST
CVRGRPID EQU   CVRGPLST+4
CVRGRPAL EQU   CVRGPLST+6
CVRGALL  EQU   CVRGPLST+8
CVRBOUND EQU   CVRGPLST+10
CVRFLG3  EQU   CVRGPLST+12
CVRGSKP  EQU   CVRFLG3
GRPCOUNT EQU   0
GRPAVAIL EQU   GRPCOUNT
GRPALLCT EQU   GRPCOUNT+2
GRPOFFLN EQU   GRPCOUNT+4
GRPEXCS  EQU   GRPCOUNT+8
GRPIDENT EQU   GRPCOUNT+10
GRPWPTR  EQU   GRPCOUNT+12
CVRWORKD EQU   0
WMIN     EQU   CVRWORKD
WPTS     EQU   WMIN
@NM00007 EQU   CVRWORKD+2
LASTFLAG EQU   @NM00007
WGUSED   EQU   @NM00007
WGRPPTR  EQU   CVRWORKD+4
WREQPTR  EQU   CVRWORKD+8
WCNTPTR  EQU   CVRWORKD+12
PARMPTR2 EQU   0
         AGO   .@UNREFD                START UNREFERENCED COMPONENTS
@NM00008 EQU   CVRWORKD+3
GRPTOTAL EQU   GRPCOUNT+6
@NM00006 EQU   CVRGPLST+13
@NM00005 EQU   CVRFLG3
CVRFORCI EQU   CVRFLG3
@NM00004 EQU   CVRRQLST+26
CVRWUCBP EQU   CVRRQLST+24
@NM00003 EQU   CVRFLG2+1
CVRDUPLI EQU   CVRFLG2+1
CVRWMOVE EQU   CVRFLG2
CVRIGNOR EQU   CVRFLG2
CVRMULTI EQU   CVRFLG2
CVRSCRTH EQU   CVRFLG2
CVRVUPTR EQU   CVRRQLST
@NM00002 EQU   CVRPARM+9
@NM00001 EQU   CVRFLG1
ALGGCNTP EQU   ALGPTRS+12
ALGGLSTP EQU   ALGPTRS+8
ALGRQLTP EQU   ALGPTRS+4
ALGPARMP EQU   ALGPTRS
.@UNREFD ANOP                          END UNREFERENCED COMPONENTS
@RC00093 EQU   @RC00090
@RC00096 EQU   @RC00090
@RF00162 EQU   @RC00138
@RF00256 EQU   @RC00253
@RF00272 EQU   @RC00270
@RF00275 EQU   @RC00270
@RF00265 EQU   @RC00247
@RF00401 EQU   @RC00398
@RF00472 EQU   @RC00469
@RF00485 EQU   @RC00482
@RF00592 EQU   @RC00589
@RF00598 EQU   @RC00589
@RF00623 EQU   @RC00620
@ENDDATA EQU   *
         END   IEFAB480,(C'PLS0504',0603,74212)
