         TITLE 'IEFAB485 - RECOVERY ALLOCATION                         *
                        '
IEFAB485 CSECT ,                                                01S0001
@MAINENT DS    0H                                               01S0001
         USING *,@15                                            01S0001
         B     @PROLOG                                          01S0001
         DC    AL1(24)                                          01S0001
         DC    C'IEFAB485 78089  UZ17548 '                      01S0001
         DROP  @15
@PROLOG  STM   @14,@12,12(@13)                                  01S0001
         BALR  @12,0                                            01S0001
@PSTART  LA    @11,4095(,@12)                                   01S0001
         USING @PSTART,@12                                      01S0001
         USING @PSTART+4095,@11                                 01S0001
         L     @00,@SIZDATD                                     01S0001
         GSPACE   R,LV=(0)
         LR    @10,@01                                          01S0001
         USING @DATD,@10                                        01S0001
         ST    @13,@SA00001+4                                   01S0001
         LM    @00,@01,20(@13)                                  01S0001
         ST    @10,8(,@13)                                      01S0001
         LR    @13,@10                                          01S0001
         MVC   @PC00001(4),0(@01)                               01S0001
*WAITMASK(1:GMTENTLN)=WAITMASK(1:GMTENTLN)&&WAITMASK(1:GMTENTLN);
         L     @02,@PC00001                                     01S0069
         L     @02,ALCWAPTR(,@02)                               01S0069
         L     @01,WMASK2P(,@02)                                01S0069
         L     @15,EDTABPTR(,@02)                               01S0069
         L     @15,EDTMSKTP(,@15)                               01S0069
         L     @15,GMTENTLN(,@15)                               01S0069
         BCTR  @15,0                                            01S0069
         EX    @15,@SX01149                                     01S0069
*RTNCODE = SUCCESS;                    /*ZERO RETURN CODE            */
         SLR   RTNCODE,RTNCODE                                  01S0070
*ALCWAREC = ON;                        /*INDICATE RECOVERY CODE      */
         OI    ALCWAREC(@02),B'00100000'                        01S0071
*/***********************************************************@ZA03616*/
*/*                                                          @ZA03616*/
*/* SEGMENT NAME - TAPEVALI                                  @ZA03616*/
*/*                                                          @ZA03616*/
*/* DESCRIPTIVE NAME - ALLOCATE VALIDITY-ERROR TAPE REQUESTS @ZA03616*/
*/*                                                          @ZA03616*/
*/* FUNCTION -                                               @ZA03616*/
*/*     THIS ROUTINE ALLOCATES TAPE REQUESTS WHICH COULD NOT @ZA03616*/
*/*     BE ALLOCATED BY GENERIC ALLOCATION BECAUSE THE       @ZA03616*/
*/*     VOLUMES WANTED WERE MOUNTED ON DIFFERENT GENERIC     @ZA03616*/
*/*     DEVICE TYPES THAN THOSE PICKED FOR ALLOCATION.       @ZA03616*/
*/*     THESE REQUESTS CAN BE ALLOCATED IN RECOVERY          @ZA03616*/
*/*     ALLOCATION SINCE ALL NEEDED TAPE GENERICS ARE        @ZA03616*/
*/*     LOCKED BY THIS TIME.                                 @ZA03616*/
*/*                                                          @ZA03616*/
*/* OPERATION -                                              @ZA03616*/
*/*     ALL REQUESTS THAT ARE MARKED AS VALIDITY-ERROR AND   @ZA03616*/
*/*     ARE ALLOCATED ARE NOW UNALLOCATED BY INVOKING        @ZA03616*/
*/*     IEFAB477. NEXT, DEMAND REQUESTS, SPECIFIC REQUESTS,  @ZA03616*/
*/*     AND PUBLIC REQUESTS ARE ALLOCATED USING IEFAB479,    @ZA03616*/
*/*     IEFAB433 AND IEFAB436. IF ANY TAPE VALIDITY ERROR    @ZA03616*/
*/*     REQUESTS REMAIN TO BE ALLOCATED AFTER THIS AND       @ZA03616*/
*/*     VOLUME MOUNTING IS ALLOWED, THE ALGORITHM IS         @ZA03616*/
*/*     INVOKED. IF REQUESTS REMAIN AND VOLUME MOUNTING      @ZA03616*/
*/*     IS NOT ALLOWED, THE REQUEST IS FAILED.               @ZA03616*/
*/*                                                          @ZA03616*/
*/* ENTRY - (IN-LINE SUBROUTINE)                             @ZA03616*/
*/*                                                          @ZA03616*/
*/*  PURPOSE - SEE FUNCTION                                  @ZA03616*/
*/*                                                          @ZA03616*/
*/*  INPUT -                                                 @ZA03616*/
*/*    ALCWA - ALLOCATION WORK AREA                          @ZA03616*/
*/*      DSSTAPE - IF ON, INDICATES THERE ARE TAPE REQUESTS  @ZA03616*/
*/*      VOLUNPTR - PTR TO THE VOLUNIT TABLE                 @ZA03616*/
*/*      TOTREQS - NUMBER OF SIOTS STILL UNALLOCATED         @ZA03616*/
*/*      VOLUNSZE - SIZE OF THE VOLUNIT TABLE                @ZA03616*/
*/*      VOLMNTSW - VOLUME MOUNTING ALLOWED                  @ZA03616*/
*/*    SIOT                                                  @ZA03616*/
*/*      SIOTDMND - DEMAND REQUEST                           @ZA03616*/
*/*    VOLUNIT TABLE -                                       @ZA03616*/
*/*      VUDNALOC - VU ENTRY NEEDS RECOVERY                  @ZA03616*/
*/*      VUVINELG - TAPE VALIDITY ERROR                      @ZA03616*/
*/*      VOLALOC - THIS VU IS ALLOCATED                      @ZA03616*/
*/*                                                          @ZA03616*/
*/* EXIT - NORMAL - (IN-LINE SUBROUTINE)                     @ZA03616*/
*/*                                                          @ZA03616*/
*/*   CONDITION - ALL VALIDITY-ERROR TAPE REQS ALLOCATED     @ZA03616*/
*/*                                                          @ZA03616*/
*/*   OUTPUT -                                               @ZA03616*/
*/*     VUDNALOC AND VUVINELG BITS TURNED OFF.               @ZA03616*/
*/*     TOTREQS DECREMENTED                                  @ZA03616*/
*/*     REQUESTS ALLOCATED                                   @ZA03616*/
*/*                                                          @ZA03616*/
*/*   RETURN CODES - RTNCODE SET TO 0                        @ZA03616*/
*/*                                                          @ZA03616*/
*/* EXIT - ERROR - (IN-LINE SUBROUTINE)                      @ZA03616*/
*/*                                                          @ZA03616*/
*/*   CONDITION - ERROR DETECTED BY ONE OF THE CALLED RTNS   @ZA03616*/
*/*                                                          @ZA03616*/
*/*   OUTPUT -                                               @ZA03616*/
*/*     A STEP OR DD RELATED REASON CODE SET BY THE          @ZA03616*/
*/*     ROUTINE DETECTING THE ERROR.                         @ZA03616*/
*/*                                                          @ZA03616*/
*/*   RETURN CODE - RTNCODE SET TO NON-ZERO                  @ZA03616*/
*/*                                                          @ZA03616*/
*/* EXIT - ERROR - (INLINE SUBROUTINE)                       @ZA03616*/
*/*                                                          @ZA03616*/
*/*   CONDITION - MOUNT NEEDED BUT VOLUME MOUNTING NOT       @ZA03616*/
*/*               ALLOWED.                                   @ZA03616*/
*/*                                                          @ZA03616*/
*/*   OUTPUT -                                               @ZA03616*/
*/*     SIOTRSNC - SET TO 56 (NOMOUNT)                       @ZA03616*/
*/*   RETURN CODE - RTNCODE SET TO NON-ZERO                  @ZA03616*/
*/*                                                          @ZA03616*/
*/***********************************************************@ZA03616*/
*IF DSSTAPE = ON THEN                  /*ANY TAPE REQUESTS   @ZA03616*/
         TM    DSSTAPE(@02),B'00001000'                         02S0072
         BNO   @RF00072                                         02S0072
*  DO;                                 /*LOOK FOR VAL ERRORS @ZA03616*/
*    NEEDTALC = OFF;                   /*INIT ALLOC NEEDED SW@ZA03616*/
         NI    NEEDTALC,B'11011111'                             02S0074
*    CALLREAR = OFF;                   /*INIT REARRANGE NEED @ZA03616*/
         NI    CALLREAR,B'01111111'                             02S0075
*    VUPTR = VOLUNPTR;                 /*SEARCH VOLUNITS     @ZA03616*/
         L     @15,@PC00001                                     02S0076
         L     @15,ALCWAPTR(,@15)                               02S0076
         L     VUPTR,VOLUNPTR(,@15)                             02S0076
*    RFY INDMSIOT BASED(VOLSIOTP);     /*SIOT FROM VU        @ZA03616*/
*    DO VUCTR = ONE TO VOLUNSZE/LENGTH(VOLUNTAB); /*SCAN VUS @ZA03616*/
         LA    VUCTR,1                                          02S0078
         B     @DE00078                                         02S0078
@DL00078 DS    0H                                               02S0079
*      IF VUDNALOC = ON & VUVINELG = ON THEN /*VAL FAILURE   @ZA03616*/
         TM    VUDNALOC(VUPTR),B'00001010'                      02S0079
         BNO   @RF00079                                         02S0079
*        DO;                           /*SET UP TO RE-ALLOC  @ZA03616*/
*          NEEDTALC = ON;              /*ALLOC NEEDED        @ZA03616*/
         OI    NEEDTALC,B'00100000'                             02S0081
*          IF VOLALOC = ON THEN        /*VU WAS ALLOCD       @ZA03616*/
         TM    VOLALOC(VUPTR),B'10000000'                       02S0082
         BNO   @RF00082                                         02S0082
*            DO;                       /*SET UP TO UNALLOC   @ZA03616*/
*              CALLREAR = ON;          /*REARRANGE NEEDED    @ZA03616*/
         OI    CALLREAR,B'10000000'                             02S0084
*              VUREALOC = ON;          /*UNALLOC THIS VU     @ZA03616*/
         OI    VUREALOC(VUPTR),B'01000000'                      02S0085
*            END;                      /*END SET UP UNALLOC  @ZA03616*/
*        END;                          /*END SET UP REALLOC  @ZA03616*/
@RF00082 DS    0H                                               02S0088
*      VUPTR = VUPTR + LENGTH(VOLUNTAB); /*NEXT VU ENTRY     @ZA03616*/
@RF00079 AH    VUPTR,@CH01135                                   02S0088
*    END;                              /*END SCAN VUS        @ZA03616*/
         AH    VUCTR,@CH00055                                   02S0089
@DE00078 L     @07,@PC00001                                     02S0089
         L     @07,ALCWAPTR(,@07)                               02S0089
         L     @00,VOLUNSZE(,@07)                               02S0089
         SRDA  @00,32                                           02S0089
         D     @00,@CF01135                                     02S0089
         CR    VUCTR,@01                                        02S0089
         BNH   @DL00078                                         02S0089
*    IF CALLREAR = ON THEN             /*NEED TO UNALLOC     @ZA03616*/
         TM    CALLREAR,B'10000000'                             02S0090
         BNO   @RF00090                                         02S0090
*      DO;                             /*UNALLOCATE REQS     @ZA03616*/
*        FUNC477 = FUNC477 && FUNC477; /*CLEAR FUNC MAP      @ZA03616*/
         XC    FUNC477(1),FUNC477                               02S0092
*        DONTUNLD = ON;                /*DONT UNLOAD VOLS    @ZA03616*/
         OI    DONTUNLD,B'01000000'                             02S0093
*        CALL IEFAB477(ALCWAPTR,FUNC477); /*UNALLOCATE       @ZA03616*/
         L     @02,@PC00001                                     02S0094
         ST    @02,@AL00001                                     02S0094
         LA    @02,FUNC477                                      02S0094
         ST    @02,@AL00001+4                                   02S0094
         L     @15,@CV00171                                     02S0094
         LA    @01,@AL00001                                     02S0094
         BALR  @14,@15                                          02S0094
*        RTNCODE = REG15;              /*SAVE RETURN CODE    @ZA03616*/
         LR    RTNCODE,REG15                                    02S0095
*      END;                            /*END UNALLOCATE      @ZA03616*/
*    IF NEEDTALC = ON & RTNCODE = ZERO THEN /*ALLOC NEEDED   @ZA03616*/
@RF00090 TM    NEEDTALC,B'00100000'                             02S0097
         BNO   @RF00097                                         02S0097
         LTR   RTNCODE,RTNCODE                                  02S0097
         BNZ   @RF00097                                         02S0097
*      DO;                             /*ALLOCATE REQUESTS   @ZA03616*/
*        DO;                           /*ALLOC TO MNTD VOLS  @ZA03616*/
*/***********************************************************@ZA03616*/
*/*                                                          @ZA03616*/
*/* SEGMENT NAME - ALOCMTDS                                  @ZA03616*/
*/*                                                          @ZA03616*/
*/* DESCRIPTIVE NAME - ALLOCATE TAPE VALIDITY-ERROR REQUESTS @ZA03616*/
*/*                    TO MOUNTED VOLUMES                    @ZA03616*/
*/*                                                          @ZA03616*/
*/* FUNCTION -                                               @ZA03616*/
*/*   THIS ROUTINE ATTEMPTS TO ALLOCATE TAPE VALIDITY        @ZA03616*/
*/*   ERROR REQUESTS TO MOUNTED VOLUMES USING IEFAB479       @ZA03616*/
*/*   (DEMAND ALLOCATION), IEFAB433 (SPECIFIC VOLUME         @ZA03616*/
*/*   ALLOCATION), AND IEFAB436 (PUBLIC/STORAGE ALLOCATION). @ZA03616*/
*/*                                                          @ZA03616*/
*/* OPERATION - DOCUMENTED BY THE CODE                       @ZA03616*/
*/*                                                          @ZA03616*/
*/* ENTRY - (INLINE SUBROUTINE)                              @ZA03616*/
*/*                                                          @ZA03616*/
*/*   PURPOSE - SEE FUNCTION                                 @ZA03616*/
*/*                                                          @ZA03616*/
*/*   INPUT -                                                @ZA03616*/
*/*     ALCWA - ALLOCATION WORK AREA                         @ZA03616*/
*/*       VOLUNPTR - POINTER TO THE VOLUNIT TABLE            @ZA03616*/
*/*     VOLUNIT TABLE -                                      @ZA03616*/
*/*       VUDNALOC - RECOVERY NEEDED FOR THIS ENTRY          @ZA03616*/
*/*       VUVINELG - TAPE VALIDITY ERROR                     @ZA03616*/
*/*       VOLPUB - PUBLIC REQUEST                            @ZA03616*/
*/*       VOLPRV - PRIVATE REQUEST                           @ZA03616*/
*/*     SIOT -                                               @ZA03616*/
*/*       SIOTDMND - DEMAND REQUEST                          @ZA03616*/
*/*                                                          @ZA03616*/
*/* EXIT - NORMAL - (INLINE SUBROUTINE)                      @ZA03616*/
*/*                                                          @ZA03616*/
*/*   CONDITION - DEMAND REQUESTS AND REQUESTS ELIGIBLE      @ZA03616*/
*/*               TO MOUNTED VOLUMES ALLOCATED               @ZA03616*/
*/*                                                          @ZA03616*/
*/*   OUTPUT -                                               @ZA03616*/
*/*     VUDNALOC AND VUVINELG BITS TURNED OFF                @ZA03616*/
*/*     TOTREQS DECREMENTED                                  @ZA03616*/
*/*     REQUESTS ALLOCATED                                   @ZA03616*/
*/*                                                          @ZA03616*/
*/*   RETURN CODE - RTNCODE SET TO 0                         @ZA03616*/
*/*                                                          @ZA03616*/
*/* EXIT - ERROR - (INLINE SUBROUTINE)                       @ZA03616*/
*/*                                                          @ZA03616*/
*/*   CONDITION - ERROR DETECTED BY ONE OF THE CALLED RTNS   @ZA03616*/
*/*                                                          @ZA03616*/
*/*   OUTPUT -                                               @ZA03616*/
*/*     A STEP OR DD RELATED REASON CODE SET BY THE          @ZA03616*/
*/*     ROUTINE DETECTING THE ERROR                          @ZA03616*/
*/*                                                          @ZA03616*/
*/*   RETURN CODE - RTNCODE SET TO NON-ZERO                  @ZA03616*/
*/*                                                          @ZA03616*/
*/***********************************************************@ZA03616*/
*NEEDMND = OFF;                        /*DEMAND NEEDED SW    @ZA03616*/
         NI    NEEDMND,B'11101111'                              03S0100
*VUPTR = VOLUNPTR;                     /*FIRST VU ENTRY      @ZA03616*/
         L     @15,@PC00001                                     03S0101
         L     @01,ALCWAPTR(,@15)                               03S0101
         L     VUPTR,VOLUNPTR(,@01)                             03S0101
*DO VUCTR = ONE TO VOLUNSZE/LENGTH(VOLUNTAB); /*SCAN VUS     @ZA03616*/
         LA    VUCTR,1                                          03S0102
         B     @DE00102                                         03S0102
@DL00102 DS    0H                                               03S0103
*  IF VUPTR = SVOLUNAD THEN            /*FIRST VU FOR SIOT   @ZA03616*/
         L     @07,VOLSIOTP(,VUPTR)                             03S0103
         C     VUPTR,SVOLUNAD(,@07)                             03S0103
         BNE   @RF00103                                         03S0103
*    SIOTGIGN = ON;                    /*MAKE SIOT IGNORE    @ZA03616*/
         OI    SIOTGIGN(@07),B'00001000'                        03S0104
*  IF VUDNALOC = ON & VUVINELG = ON &  /*VAL CHECK FAILURE   @ZA03616*/
*     SIOTDMND = ON THEN               /*DEMAND REQUEST      @ZA03616*/
@RF00103 TM    VUDNALOC(VUPTR),B'00001010'                      03S0105
         BNO   @RF00105                                         03S0105
         L     @07,VOLSIOTP(,VUPTR)                             03S0105
         TM    SIOTDMND(@07),B'10000000'                        03S0105
         BNO   @RF00105                                         03S0105
*    DO;                               /*MARK SIOT & VU ENTRY@ZA03616*/
*      SIOTGIGN = OFF;                 /*PROCESS THIS SIOT   @ZA03616*/
         NI    SIOTGIGN(@07),B'11110111'                        03S0107
*      NEEDMND = ON;                   /*479 NEEDED          @ZA03616*/
         OI    NEEDMND,B'00010000'                              03S0108
*      VUDNALOC = OFF;                 /*PROCESS THIS VU     @ZA03616*/
*      VUVINELG = OFF;                 /*RESET VAL CHK SW    @ZA03616*/
         NI    VUDNALOC(VUPTR),B'11110101'                      03S0110
*    END;                              /*END MARK SIOT       @ZA03616*/
*  VUPTR = VUPTR + LENGTH(VOLUNTAB);   /*NEXT VU ENTRY       @ZA03616*/
@RF00105 AL    VUPTR,@CF01135                                   03S0112
*END;                                  /*END SCAN VUS        @ZA03616*/
         AH    VUCTR,@CH00055                                   03S0113
@DE00102 L     @07,@PC00001                                     03S0113
         L     @07,ALCWAPTR(,@07)                               03S0113
         L     @00,VOLUNSZE(,@07)                               03S0113
         SRDA  @00,32                                           03S0113
         D     @00,@CF01135                                     03S0113
         CR    VUCTR,@01                                        03S0113
         BNH   @DL00102                                         03S0113
*IF NEEDMND = ON THEN                  /*479 SHOULD BE CALLED@ZA03616*/
         TM    NEEDMND,B'00010000'                              03S0114
         BNO   @RF00114                                         03S0114
*  DO;                                 /*ALLOC DEMANDS       @ZA03616*/
*    FUNC479 = FUNC479 && FUNC479;     /*CLEAR FUNC MAP      @ZA03616*/
         XC    FUNC479(1),FUNC479                               03S0116
*    DOSPEC = ON;                      /*ALLOC SPECIFICS     @ZA03616*/
*    VOLSWOK = ON;                     /*VOL SWITCHING OK    @ZA03616*/
         OI    DOSPEC,B'01100000'                               03S0118
*    CALL IEFAB479(ALCWAPTR,FUNC479);  /*ALLOCATE DEMANDS    @ZA03616*/
         L     @02,@PC00001                                     03S0119
         ST    @02,@AL00001                                     03S0119
         LA    @02,FUNC479                                      03S0119
         ST    @02,@AL00001+4                                   03S0119
         L     @15,@CV00169                                     03S0119
         LA    @01,@AL00001                                     03S0119
         BALR  @14,@15                                          03S0119
*    RTNCODE = REG15;                  /*RETURN CODE FROM 479@ZA03616*/
         LR    RTNCODE,REG15                                    03S0120
*  END;                                /*END ALLOC DEMANDS   @ZA03616*/
*IF RTNCODE = ZERO & TOTREQS > ZERO THEN /*CHECK FOR MORE    @ZA03616*/
@RF00114 SLR   @02,@02                                          03S0122
         CR    RTNCODE,@02                                      03S0122
         BNE   @RF00122                                         03S0122
         L     @15,@PC00001                                     03S0122
         L     @15,ALCWAPTR(,@15)                               03S0122
         C     @02,TOTREQS(,@15)                                03S0122
         BNL   @RF00122                                         03S0122
*  DO;                                 /*SEARCH VU TABLE     @ZA03616*/
*    NEED433 = OFF;                    /*INIT 433 NEEDED     @ZA03616*/
*    NEED436 = OFF;                    /*INIT 436 NEEDED     @ZA03616*/
         NI    NEED433,B'11001111'                              03S0125
*    VUPTR = VOLUNPTR;                 /*FIRST VU ENTRY      @ZA03616*/
         L     VUPTR,VOLUNPTR(,@15)                             03S0126
*    DO VUCTR = ONE TO VOLUNSZE/LENGTH(VOLUNTAB);/*SCAN VUS  @ZA03616*/
         LA    VUCTR,1                                          03S0127
         B     @DE00127                                         03S0127
@DL00127 DS    0H                                               03S0128
*      IF VUDNALOC = ON & VUVINELG = ON THEN /*VAL FAIL VU   @ZA03616*/
         TM    VUDNALOC(VUPTR),B'00001010'                      03S0128
         BNO   @RF00128                                         03S0128
*        DO;                           /*SET UP TO ALLOCATE  @ZA03616*/
*          NEED433 = ON;               /*CALL 433 FOR SPECS  @ZA03616*/
         OI    NEED433,B'00100000'                              03S0130
*          IF VOLPUB = ON & VOLPRV = OFF THEN /*PUBLIC REQ   @ZA03616*/
         TM    VOLPUB(VUPTR),B'10000000'                        03S0131
         BNO   @RF00131                                         03S0131
         TM    VOLPRV(VUPTR),B'01000000'                        03S0131
         BNZ   @RF00131                                         03S0131
*            NEED436 = ON;             /*TRY ALLOC TO MNTD   @ZA03616*/
         OI    NEED436,B'00010000'                              03S0132
*          VUDNALOC = OFF;             /*THIS VU OK TO ALLOC @ZA03616*/
@RF00131 DS    0H                                               03S0134
*          VUVINELG = OFF;             /*RESET VAL CHK SW    @ZA03616*/
         NI    VUDNALOC(VUPTR),B'11110101'                      03S0134
*          SIOTGIGN = OFF;             /*PROCESS THIS SIOT   @ZA03616*/
         L     @07,VOLSIOTP(,VUPTR)                             03S0135
         NI    SIOTGIGN(@07),B'11110111'                        03S0135
*        END;                          /*END SET UP TO ALLOC @ZA03616*/
*      VUPTR = VUPTR + LENGTH(VOLUNTAB);/*NEXT VU ENTRY      @ZA03616*/
@RF00128 AL    VUPTR,@CF01135                                   03S0137
*    END;                              /*END SCAN VUS        @ZA03616*/
         AH    VUCTR,@CH00055                                   03S0138
@DE00127 L     @07,@PC00001                                     03S0138
         L     @07,ALCWAPTR(,@07)                               03S0138
         L     @00,VOLUNSZE(,@07)                               03S0138
         SRDA  @00,32                                           03S0138
         D     @00,@CF01135                                     03S0138
         CR    VUCTR,@01                                        03S0138
         BNH   @DL00127                                         03S0138
*    IF NEED433 = ON THEN              /*433 NEEDED          @ZA03616*/
         TM    NEED433,B'00100000'                              03S0139
         BNO   @RF00139                                         03S0139
*      DO;                             /*SET UP FOR 433      @ZA03616*/
*        FUNCMAP1 = FUNC433;           /*FUNC MAP FOR 433    @ZA03616*/
         MVC   FUNCMAP1(1),FUNC433                              03S0141
*        CALL IEFAB433(ALCWAPTR,ADDR(FUNCLIST));/*ALLOC SPECIFICS TO
*                                        MOUNTED VOLS        @ZA03616*/
         L     @02,@PC00001                                     03S0142
         ST    @02,@AL00001                                     03S0142
         LA    @02,FUNCLIST                                     03S0142
         ST    @02,@TF00001                                     03S0142
         LA    @02,@TF00001                                     03S0142
         ST    @02,@AL00001+4                                   03S0142
         L     @15,@CV00166                                     03S0142
         LA    @01,@AL00001                                     03S0142
         BALR  @14,@15                                          03S0142
*        RTNCODE = REG15;              /*RETURN CODE FROM 433@ZA03616*/
         LR    RTNCODE,REG15                                    03S0143
*      END;                            /*END SET UP FOR 433  @ZA03616*/
*    IF NEED436 = ON & TOTREQS > ZERO &/*PUBLIC REQS TO DO   @ZA03616*/
*       RTNCODE = ZERO THEN            /*433 DID NOT FAIL    @ZA03616*/
@RF00139 TM    NEED436,B'00010000'                              03S0145
         BNO   @RF00145                                         03S0145
         SLR   @02,@02                                          03S0145
         L     @15,@PC00001                                     03S0145
         L     @01,ALCWAPTR(,@15)                               03S0145
         C     @02,TOTREQS(,@01)                                03S0145
         BNL   @RF00145                                         03S0145
         CR    RTNCODE,@02                                      03S0145
         BNE   @RF00145                                         03S0145
*      DO;                             /*ALLOC PUB TO MTDS   @ZA03616*/
*        DOPRTAL = OFF;                /*ALLOC ALL PUBS      @ZA03616*/
         NI    DOPRTAL,B'11110111'                              03S0147
*        CALL SCRATMNT;                /*ALLOCATE            @ZA03616*/
         BAL   @14,SCRATMNT                                     03S0148
*      END;                            /*END ALLOC PUB       @ZA03616*/
*  END;                                /*END SEARCH VU TABLE @ZA03616*/
@RF00145 DS    0H                                               03S0151
*        END;                          /*END ALLOC TO MTDS   @ZA03616*/
@RF00122 DS    0H                                               02S0152
*        IF RTNCODE = SUCCESS &        /*OK SO FAR           @ZA03616*/
*           TOTREQS > ZERO THEN        /*MORE REQS TO DO     @ZA03616*/
         SLR   @02,@02                                          02S0152
         CR    RTNCODE,@02                                      02S0152
         BNE   @RF00152                                         02S0152
         L     @15,@PC00001                                     02S0152
         L     @15,ALCWAPTR(,@15)                               02S0152
         C     @02,TOTREQS(,@15)                                02S0152
         BNL   @RF00152                                         02S0152
*          DO;                         /*CHECK FOR MORE TAPES@ZA03616*/
*            VUPTR = VOLUNPTR;         /*FIRST VU ENTRY      @ZA03616*/
         L     VUPTR,VOLUNPTR(,@15)                             02S0154
*            DONESW = OFF;             /*LOOP CTL SWITCH     @ZA03616*/
         NI    DONESW,B'10111111'                               02S0155
*            DO VUCTR = ONE TO VOLUNSZE/LENGTH(VOLUNTAB)   /*@ZA03616*/
*               WHILE DONESW = OFF;    /*LOOP THRU VUS       @ZA03616*/
         LA    VUCTR,1                                          02S0156
         B     @DE00156                                         02S0156
@DL00156 TM    DONESW,B'01000000'                               02S0156
         BNZ   @DC00156                                         02S0156
*              IF SIOTGIGN = OFF &     /*SIOT WAS LOOKED AT  @ZA03616*/
*                 VOLALOC = OFF THEN   /*VU NOT ALLOCATED    @ZA03616*/
         L     @07,VOLSIOTP(,VUPTR)                             02S0157
         TM    SIOTGIGN(@07),B'00001000'                        02S0157
         BNZ   @RF00157                                         02S0157
         TM    VOLALOC(VUPTR),B'10000000'                       02S0157
         BNZ   @RF00157                                         02S0157
*                IF VOLMNTSW = ON THEN /*MNTING OK           @ZA03616*/
         L     @07,@PC00001                                     02S0158
         L     @03,ALCWAPTR(,@07)                               02S0158
         L     @03,FMAPPTR(,@03)                                02S0158
         TM    VOLMNTSW(@03),B'10000000'                        02S0158
         BNO   @RF00158                                         02S0158
*                  DO;                 /*ALLOC VIA ALG       @ZA03616*/
*                    DONESW = ON;      /*GET OUT OF LOOP     @ZA03616*/
         OI    DONESW,B'01000000'                               02S0160
*                    FUNC476 = TAPE476; /*FUNC MAP FOR 476   @ZA03616*/
         MVC   FUNC476(1),TAPE476                               02S0161
*                    CALL IEFAB476(ALCWAPTR,FUNC476); /*ALG  @ZA03616*/
         ST    @07,@AL00001                                     02S0162
         LA    @07,FUNC476                                      02S0162
         ST    @07,@AL00001+4                                   02S0162
         L     @15,@CV00168                                     02S0162
         LA    @01,@AL00001                                     02S0162
         BALR  @14,@15                                          02S0162
*                    RTNCODE = REG15;  /*RETURN CODE FROM 476@ZA03616*/
         LR    RTNCODE,REG15                                    02S0163
*                  END;                /*END ALLOC VIA ALG   @ZA03616*/
*                ELSE                  /*MOUNTING NOT ALLOWED@ZA03616*/
*                  DO;                 /*FAIL THE REQUEST    @ZA03616*/
         B     @RC00158                                         02S0165
@RF00158 DS    0H                                               02S0166
*                    DONESW = ON;      /*GET OUT OF LOOP     @ZA03616*/
         OI    DONESW,B'01000000'                               02S0166
*                    SIOTRSNC = NOMOUNT;/*MOUNTING NOT ALLOWD@ZA03616*/
         L     @07,VOLSIOTP(,VUPTR)                             02S0167
         MVC   SIOTRSNC(2,@07),@CH00138                         02S0167
*                    RTNCODE = FAILURE;/*BAD RETURN CODE     @ZA03616*/
         LA    RTNCODE,4                                        02S0168
*                  END;                /*END FAIL THE REQUEST@ZA03616*/
*              VUPTR = VUPTR + LENGTH(VOLUNTAB);/*NEXT VU    @ZA03616*/
@RC00158 DS    0H                                               02S0170
@RF00157 AL    VUPTR,@CF01135                                   02S0170
*            END;                      /*END LOOP THRU VUS   @ZA03616*/
         AH    VUCTR,@CH00055                                   02S0171
@DE00156 L     @07,@PC00001                                     02S0171
         L     @07,ALCWAPTR(,@07)                               02S0171
         L     @00,VOLUNSZE(,@07)                               02S0171
         SRDA  @00,32                                           02S0171
         D     @00,@CF01135                                     02S0171
         CR    VUCTR,@01                                        02S0171
         BNH   @DL00156                                         02S0171
@DC00156 DS    0H                                               02S0172
*          END;                        /*END CHECK FOR MORE  @ZA03616*/
*      END;                            /*END ALLOC REQUESTS  @ZA03616*/
@RF00152 DS    0H                                               02S0174
*  END;                                /*END LOOK FOR ERRORS @ZA03616*/
@RF00097 DS    0H                                               02S0175
*RFY INDMSIOT BASED(SIOTPTR);          /*                    @ZA03616*/
@RF00072 DS    0H                                               02S0176
*IF TOTREQS>ZERO & RTNCODE=SUCCESS THEN /*STILL REQS TO ALLOCATE ?   */
         SLR   @02,@02                                          01S0176
         L     @15,@PC00001                                     01S0176
         L     @01,ALCWAPTR(,@15)                               01S0176
         C     @02,TOTREQS(,@01)                                01S0176
         BNL   @RF00176                                         01S0176
         CR    RTNCODE,@02                                      01S0176
         BNE   @RF00176                                         01S0176
*  DO;                                 /*YES, ..                     */
*/********************************************************************/
*/*                                                                  */
*/* SEGMENT NAME - DADAFFER                                          */
*/*                                                                  */
*/* DESCRIPTIVE NAME - ALLOCATE VOLAFF DADSM-ERROR REQUESTS          */
*/*                                                                  */
*/* FUNCTION -                                                       */
*/*     THIS ROUTINE UNALLOCATES (VIA IEFAB477) ANY ALLOCATED        */
*/*     NONSPECIFIC DA VOLUME REQUESTS WHICH HAVE VOLUME AFFINITY    */
*/*     TO ANOTHER REQUEST WHICH HAD A DADSM ERROR.                  */
*/*     NEXT, IEFAB436 IS CALLED TO TRY TO REALLOCATE ANY REQUESTS,  */
*/*     JUST UNALLOCATED,TO DIFFERENT MOUNTED VOLUMES (SEE SEGMENT   */
*/*     'DAFERALC').                                                 */
*/*                                                                  */
*/*   OPERATION -                                                    */
*/*       SINCE THE SAME TYPE OF VOLAFF DADSM-ERROR SITUATION COULD  */
*/*       ARISE IN TRYING TO REALLOCATE REQUESTS VIA IEFAB436, THIS  */
*/*       ROUTINE LOOPS UNTIL ON ONE SCAN OF ALL REQUESTS NO VOLAFF  */
*/*       ROUTINE WILL ONLY MAKE ONE ATTEMPT TO REALLOCATE   @ZA04836*/
*/*       VIA IEFAB436.                                      @ZA04836*/
*/*                                                                  */
*/* ENTRY - (INLINE SUBROUTINE)                                      */
*/*                                                                  */
*/*   PURPOSE - (SEE FUNCTION)                                       */
*/*                                                                  */
*/*   INPUT -                                                        */
*/*      ALCWAPTR - PTR TO ALLOCATION WORK AREA, WHICH CONTAINS      */
*/*        VOLUNPTR - PTR TO VOLUNIT TABLE                           */
*/*      RTNCODE = 0                                                 */
*/*      VOLUNIT ENTRY BIT 'VUDADSME' INDICATES VOLAFF DADSM-ERROR   */
*/*                                                                  */
*/* EXIT - NORMAL - (INLINE SUBROUTINE)                              */
*/*                                                                  */
*/*   CONDITIONS - ALL VOLAFF DADSM-ERROR REQS UNALLOCATED           */
*/*                SUCCESSFULLY AND POSSIBLY REALLOCATED TO OTHER    */
*/*                MOUNTED VOLUMES                                   */
*/*                                                                  */
*/*   OUTPUT - VUDADSME=0 AND VUDNALOC=0 FOR ALL FORMER VOLAFF       */
*/*            DADSM-ERROR REQUESTS.                                 */
*/*                                                                  */
*/*   RETURN CODES - RTNCODE 0                                       */
*/*                                                                  */
*/* EXIT - ERROR - (INLINE SUBROUTINE)                               */
*/*                                                                  */
*/*   CONDITIONS - FAILING ERROR DETECTED DURING UNALLOC/REALLOC     */
*/*                PROCESSING                                        */
*/*                                                                  */
*/*   OUTPUT - STEP- OR DD-RELATED ERROR SET BY INVOKED ROUTINE      */
*/*            DETECTING THE ERROR.                                  */
*/*                                                                  */
*/*   RETURN CODES - RTNCODE SET NON-ZERO                            */
*/*                                                                  */
*/********************************************************************/
*DADERRSW =  ON;                       /*SCAN VU'S AT LEAST ONCE     */
         OI    DADERRSW,B'10000000'                             02S0178
*DO WHILE (DADERRSW=ON & RTNCODE=SUCCESS); /*SCAN VU'S UNTIL NO ERRS */
         B     @DE00179                                         02S0179
@DL00179 DS    0H                                               02S0180
*  ALCBITS = ZERO;                     /*INITIALIZE SWITCHES         */
         MVI   ALCBITS,X'00'                                    02S0180
*  VUPTR = VOLUNPTR;                   /*POINT TO FIRST VOLUNIT ENTRY*/
         L     @15,@PC00001                                     02S0181
         L     @01,ALCWAPTR(,@15)                               02S0181
         L     VUPTR,VOLUNPTR(,@01)                             02S0181
*  DO VUCTR = ONE TO VOLUNSZE/LENGTH(VOLUNTAB); /*SCAN ALL VU ENTRIES*/
         LA    VUCTR,1                                          02S0182
         B     @DE00182                                         02S0182
@DL00182 DS    0H                                               02S0183
*    VUREALOC = OFF;                   /*ASSUME UNALLOC NOT NEEDED   */
         NI    VUREALOC(VUPTR),B'10111111'                      02S0183
*    IF VUDADSME=ON THEN               /*DADSM-ERR VOLAFF REQ ?      */
         TM    VUDADSME(VUPTR),B'00000100'                      02S0184
         BNO   @RF00184                                         02S0184
*      DO;                             /*YES, PROCESS                */
*        VOLSIOTP->SIOTRSNC = ZERO;    /*ZERO REASON CODE            */
         L     @07,VOLSIOTP(,VUPTR)                             02S0186
         SLR   @15,@15                                          02S0186
         STH   @15,SIOTRSNC(,@07)                               02S0186
*        VUDNALOC = OFF;               /*INDICATE REQ IS OK TO ALLOC */
*        VUDADSME = OFF;               /*TURN OFF DADSM ERROR SWITCH */
         NI    VUDNALOC(VUPTR),B'11110011'                      02S0188
*        IF VURECVRY = OFF THEN        /*RECOVERY TRIED?     @ZA04836*/
         TM    VURECVRY(VUPTR),B'00000100'                      02S0189
         BNZ   @RF00189                                         02S0189
*          DO;                         /*                    @ZA04836*/
*            VURECVRY = ON;            /*NO, SET INDICATOR   @ZA04836*/
         OI    VURECVRY(VUPTR),B'00000100'                      02S0191
*            CALLALOC = ON;            /*TO TRY REALLOCATION @ZA04836*/
         OI    CALLALOC,B'00000001'                             02S0192
*          END;                        /*                    @ZA04836*/
*        IF VOLALOC = ON THEN          /*WAS REQ ALREADY ALLOCATED ? */
@RF00189 TM    VOLALOC(VUPTR),B'10000000'                       02S0194
         BNO   @RF00194                                         02S0194
*          DO;                         /*YES, INDICATE UNALOC/REALOC */
*            VUREALOC = ON;                                     02S0196
         OI    VUREALOC(VUPTR),B'01000000'                      02S0196
*            CALLREAR = ON;                                     02S0197
         OI    CALLREAR,B'10000000'                             02S0197
*          END;                        /*                    @ZA04836*/
*        IF VOLSTG = ON THEN           /*STORAGE REQUEST ?           */
@RF00194 TM    VOLSTG(VUPTR),B'00010000'                        02S0199
         BNO   @RF00199                                         02S0199
*            ALCSTOR = ON;             /*YES, INDICATE FOR IEFAB436  */
         OI    ALCSTOR,B'00000100'                              02S0200
*        ELSE                          /*PUBLIC REQ,INDICATE FOR 436 */
*            ALCPUB = ON;                                       02S0201
         B     @RC00199                                         02S0201
@RF00199 OI    ALCPUB,B'00000010'                               02S0201
*      END;                                                     02S0202
*    ELSE;                             /*NOT VOLAFF DADSM-ERR REQ    */
@RF00184 DS    0H                                               02S0204
*    VUPTR = VUPTR + LENGTH(VOLUNTAB); /*POINT TO NEXT VOLUNIT ENTRY */
@RC00184 AL    VUPTR,@CF01135                                   02S0204
*  END;                                                         02S0205
         AH    VUCTR,@CH00055                                   02S0205
@DE00182 L     @07,@PC00001                                     02S0205
         L     @07,ALCWAPTR(,@07)                               02S0205
         L     @00,VOLUNSZE(,@07)                               02S0205
         SRDA  @00,32                                           02S0205
         D     @00,@CF01135                                     02S0205
         CR    VUCTR,@01                                        02S0205
         BNH   @DL00182                                         02S0205
*  IF CALLREAR = ON THEN               /*ANY UNALLOCS TO DO ?        */
         TM    CALLREAR,B'10000000'                             02S0206
         BNO   @RF00206                                         02S0206
*    DO;                               /*YES, UNALLOC VU'S MARKED    */
*      FUNC477 = FUNC477 && FUNC477;   /*CLEAR FUNC MAP      @ZA03616*/
         XC    FUNC477(1),FUNC477                               02S0208
*      UNLDPMNT = ON;                  /*UNLD MNT PEND DA    @ZA03616*/
         OI    UNLDPMNT,B'10000000'                             02S0209
*      CALL IEFAB477 (ALCWAPTR,FUNC477);                        02S0210
         L     @02,@PC00001                                     02S0210
         ST    @02,@AL00001                                     02S0210
         LA    @02,FUNC477                                      02S0210
         ST    @02,@AL00001+4                                   02S0210
         L     @15,@CV00171                                     02S0210
         LA    @01,@AL00001                                     02S0210
         BALR  @14,@15                                          02S0210
*      RTNCODE = REG15;                /*SAVE THE RETURN CODE        */
         LR    RTNCODE,REG15                                    02S0211
*    END;                                                       02S0212
*  IF RTNCODE = SUCCESS &              /*ANY ERRORS ?        @ZA04836*/
*     CALLALOC = ON THEN               /*                    @ZA04836*/
@RF00206 LTR   RTNCODE,RTNCODE                                  02S0213
         BNZ   @RF00213                                         02S0213
         TM    CALLALOC,B'00000001'                             02S0213
         BNO   @RF00213                                         02S0213
*    DO;                               /*NO,REALLOCATE REQS UNALLOC'D*/
*/********************************************************************/
*/*                                                                  */
*/* SEGMENT NAME - DAFERALC                                          */
*/*                                                                  */
*/* DESCRIPTIVE NAME - REALLOCATE VOLAFF DADSM-ERROR REQS UNALLOCATED*/
*/*                                                                  */
*/* FUNCTION -                                                       */
*/*     THIS ROUTINE BUILDS A LIST OF ALL DA UCBS WITH NON-PRIVATE   */
*/*     VOLUMES MOUNTED AND CALLS IEFAB436 (ONCE FOR STORAGE REQS    */
*/*     AND AGAIN FOR PUBLIC REQS TO ALLOCATE REQUESTS TO THESE      */
*/*     MOUNTED VOLUMES.                                             */
*/*                                                                  */
*/*   OPERATION - (THE OPERATION IS DOCUMENTED BY THE CODE ITSELF).  */
*/*                                                                  */
*/* ENTRY - (INLINE SUBROUTINE)                                      */
*/*                                                                  */
*/*   PURPOSE - (SEE FUNCTION)                                       */
*/*                                                                  */
*/*   INPUT -                                                        */
*/*       ALCWAPTR - PTR TO ALLOCATION WORK AREA, WHICH CONTAINS     */
*/*         EDTABPTR - PTR TO EDT (FOR SEGMENT 'DAFERLST')           */
*/*         FAILRSCP - PTR TO STEP REASON CODE AREA                  */
*/*       ALCSTOR - 1 INDICATES STORAGE REQ ALLOCATION NEEDED        */
*/*       ALCPUB - 1 INDICATES PUBLIC REQS ALLOCATION NEEDED         */
*/*       ALCNUCBS - NUMBER OF UCB'S IN SYSTEM               @Z40FPPJ*/
*/*                                                                  */
*/* EXIT - NORMAL - (INLINE SUBROUTINE)                              */
*/*                                                                  */
*/*   CONDITIONS - FUNCTION COMPLETED SUCCESSFULLY                   */
*/*                                                                  */
*/*   OUTPUT -                                                       */
*/*       GENERAL: SOME REQS MAY BE ALLOCATED BY IEFAB436            */
*/*                                                                  */
*/*   RETURN CODES - RTNCODE 0                                       */
*/*                                                                  */
*/* EXIT - ERROR - (INLINE SUBROUTINE)                               */
*/*                                                                  */
*/*   CONDITIONS - GETMAIN ERROR                                     */
*/*                                                                  */
*/*   OUTPUT - STEP REASON CODE 'REASONCD' SET TO 2                  */
*/*                                                                  */
*/*   RETURN CODES - RTNCODE SET TO 4                                */
*/*                                                                  */
*/* EXIT - ERROR - (INLINE SUBROUTINE)                               */
*/*                                                                  */
*/*   CONDITIONS - ERROR DETECTED BY MODULE IEFAB436                 */
*/*                                                                  */
*/*   OUTPUT - STEP- OR DD-RELATED ERROR CODE SET BY IEFAB436        */
*/*                                                                  */
*/*   RETURN CODES - RTNCODE SET NON-ZERO                            */
*/*                                                                  */
*/********************************************************************/
*UCBSLGN = (ALCNUCBS * TWO) + TWO;      /*CALCULATE SIZE OF UCB LIST  *
         L     @08,@PC00001                                     03S0215
         L     @08,ALCWAPTR(,@08)                               03S0215
         L     @08,ALCNUCBS(,@08)                               03S0215
         ALR   @08,@08                                          03S0215
         AH    @08,@CH00134                                     03S0215
         ST    @08,UCBSLGN                                      03S0215
* /* ?GETSTORG (SUBP,UCBSLGN,UCBLISTP);*/                       03S0216
*   /* DEFINITIONS OF GETMAIN PARMS */                          03S0216
*   DCL                                                         03S0216
*     GTSTR0   FIXED(31) REG(0),/*GTMN PARM REG*/               03S0216
*     GTSTR1   FIXED(31) REG(1),/*GTMN PARM REG*/               03S0216
*     GTSTR2   PTR(31)   REG(2),/*GTMN PARM REG*/               03S0216
*     GTSTR15  FIXED(31) REG(15),/*GTMN RET COD*/               03S0216
*     GTSTRTCD FIXED(31); /* GETMAIN RTN CODE  */               03S0216
*   DCL                                                         03S0217
*     GTSTR3   FIXED(31) REG(3),/* CLEARING REG*/               03S0217
*     GTSTR4   FIXED(31) REG(4),/* CLEARING REG*/               03S0217
*     GTSTR5   FIXED(31) REG(5),/* CLEARING REG*/               03S0217
*     GTSTR6   FIXED(31) REG(6),/* CLEARING REG*/               03S0217
*     GTSTR7   FIXED(31) REG(7),/* CLEARING REG*/               03S0217
*     GTSTR8   FIXED(31) REG(8),/* CLEARING REG*/               03S0217
*     GTSTZERO FIXED(31) INIT(0),                               03S0217
*     GTST253  FIXED(31) CONSTANT(253);                         03S0217
*   RFY (GTSTR0,GTSTR1,GTSTR2) RSTD; /*SAVE RGS*/               03S0218
*   GTSTR0 = UCBSLGN; /* SET AMOUNT*/                           03S0219
         LR    GTSTR0,@08                                       03S0219
*   GTSTR2 = SUBP; /* SET SUBPOOL*/                             03S0220
         LA    GTSTR2,230                                       03S0220
*   GENERATE CODE;                                              03S0221
     GETMAIN RC,LV=(0),SP=(2)  DO GETMAIN
*   GTSTRTCD = GTSTR15; /* SAVE GETMAIN RET COD*/               03S0222
         LR    GTSTRTCD,GTSTR15                                 03S0222
*   UCBLISTP = GTSTR1; /* ADDR OF GOTN STORG*/                  03S0223
         ST    GTSTR1,UCBLISTP                                  03S0223
*   RFY (GTSTR0,GTSTR1,GTSTR2) UNRSTD; /*RLSE */                03S0224
*   IF GTSTRTCD = 0 THEN /*GETMAIN SUCCESSFUL? */               03S0225
         LTR   GTSTRTCD,GTSTRTCD                                03S0225
         BNZ   @RF00225                                         03S0225
*     DO;               /* YES, CLEAR STORAGE.*/                03S0226
*       RFY (GTSTR2,GTSTR4,GTSTR5,GTSTR6,                       03S0227
*                          GTSTR7,GTSTR8) RSTD;                 03S0227
*       GTSTR4 = UCBLISTP; /*STORG PTR*/                        03S0228
         L     @03,UCBLISTP                                     03S0228
         LR    GTSTR4,@03                                       03S0228
*       GTSTR5 = UCBSLGN; /*STORG AMNT*/                        03S0229
         L     GTSTR5,UCBSLGN                                   03S0229
*       GTSTR7 = '00000000'X; /*PAD CHAR & LNTH*/               03S0230
         SLR   GTSTR7,GTSTR7                                    03S0230
*       IF SUBP = GTST253 THEN                                  03S0231
         B     @RF00231                                         03S0231
*      GEN                                                      03S0232
*   (MODESET KEYADDR=GTSTZERO,SAVEKEY=(2),WORKREG=8);           03S0232
         MODESET KEYADDR=GTSTZERO,SAVEKEY=(2),WORKREG=8
*       GEN REFS(GTSTR4,GTSTR6);                                03S0233
@RF00231 DS    0H                                               03S0233
          MVCL  GTSTR4,GTSTR6 CLEAR GOTTEN STORG
*       IF SUBP = GTST253 THEN                                  03S0234
         B     @RF00234                                         03S0234
*         GEN (MODESET KEYADDR=(2));                            03S0235
         MODESET KEYADDR=(2)
*       RFY (GTSTR2,GTSTR4,GTSTR5,GTSTR6,                       03S0236
*                          GTSTR7,GTSTR8) UNRSTD;               03S0236
@RF00234 DS    0H                                               03S0237
*     END;       /* STORAGE CLEARING COMPLETED */               03S0237
*   ELSE                                                        03S0238
*   UCBLISTP= 0;   /* CLEAR RETURN ADDR. */                     03S0238
         B     @RC00225                                         03S0238
@RF00225 SLR   @08,@08                                          03S0238
         ST    @08,UCBLISTP                                     03S0238
*   GTSTR15 = GTSTRTCD;    /* GTMN RETURN CODE */               03S0239
@RC00225 LR    GTSTR15,GTSTRTCD                                 03S0239
*                                      /* RESTORE LIST PRINT STATUS  */
*    /*GET CORE FOR LIST           */                           03S0240
*RTNCODE = REG15;                      /*SAVE THE RETURN CODE        */
         LR    RTNCODE,REG15                                    03S0240
*IF RTNCODE = SUCCESS THEN             /*ANY ERRORS ?                */
         LTR   RTNCODE,RTNCODE                                  03S0241
         BNZ   @RF00241                                         03S0241
*  DO;                                 /*NO, PROCESS                 */
*    CALL DAFERLST;                    /*FILL IN CANDIDATE LIST      */
         BAL   @14,DAFERLST                                     03S0243
*    PSUCBP (MAXMNTS + ONE) = ZERO;     /*INDICATE THE LAST LIST ENT */
         LR    @05,MAXMNTS                                      03S0244
         ALR   @05,@05                                          03S0244
         L     @02,UCBLISTP                                     03S0244
         ALR   @02,@05                                          03S0244
         SLR   @05,@05                                          03S0244
         STH   @05,PSUCBP(,@02)                                 03S0244
*    IF ALCSTOR = ON THEN              /*ANY STORAGE REQS TO ALLOC ? */
         TM    ALCSTOR,B'00000100'                              03S0245
         BNO   @RF00245                                         03S0245
*      DO;                             /*YES,ALLOCATE TO MNTED VOLS  */
*        FUNCMAP1 = STORFUNC;          /*SET IEFAB436 FUNCTION MAP   */
         MVC   FUNCMAP1(1),STORFUNC                             03S0247
*        CALL IEFAB436 (ALCWAPTR,UCBLISTP,ADDR(FUNCLIST));      03S0248
         L     @02,@PC00001                                     03S0248
         ST    @02,@AL00001                                     03S0248
         LA    @02,UCBLISTP                                     03S0248
         ST    @02,@AL00001+4                                   03S0248
         LA    @02,FUNCLIST                                     03S0248
         ST    @02,@TF00001                                     03S0248
         LA    @02,@TF00001                                     03S0248
         ST    @02,@AL00001+8                                   03S0248
         L     @15,@CV00167                                     03S0248
         LA    @01,@AL00001                                     03S0248
         BALR  @14,@15                                          03S0248
*        RTNCODE = REG15;              /*SAVE THE RETURN CODE        */
         LR    RTNCODE,REG15                                    03S0249
*      END;                                                     03S0250
*    ELSE;                             /*NO STORAGE REQS             */
@RF00245 DS    0H                                               03S0252
*    IF ALCPUB=ON & RTNCODE=SUCCESS THEN /*ANY PUBLIC REQS TO ALLOC  */
         TM    ALCPUB,B'00000010'                               03S0252
         BNO   @RF00252                                         03S0252
         LTR   RTNCODE,RTNCODE                                  03S0252
         BNZ   @RF00252                                         03S0252
*      DO;                             /*YES,ALLOCATE TO MNTED VOLS  */
*        FUNCMAP1 = PUBFUNC;           /*SET IEFAB436 FUNCTION MAP   */
         MVC   FUNCMAP1(1),PUBFUNC                              03S0254
*        CALL IEFAB436 (ALCWAPTR,UCBLISTP,ADDR(FUNCLIST));      03S0255
         L     @02,@PC00001                                     03S0255
         ST    @02,@AL00001                                     03S0255
         LA    @02,UCBLISTP                                     03S0255
         ST    @02,@AL00001+4                                   03S0255
         LA    @02,FUNCLIST                                     03S0255
         ST    @02,@TF00001                                     03S0255
         LA    @02,@TF00001                                     03S0255
         ST    @02,@AL00001+8                                   03S0255
         L     @15,@CV00167                                     03S0255
         LA    @01,@AL00001                                     03S0255
         BALR  @14,@15                                          03S0255
*        RTNCODE = REG15;                                       03S0256
         LR    RTNCODE,REG15                                    03S0256
*      END;                                                     03S0257
*    ELSE;                             /*NO PUBLIC REQUESTS TO ALLOC */
@RF00252 DS    0H                                               03S0259
*    RFY (REG0,REG1) RSTD;                                      03S0259
*    REG0 = UCBSLGN;                   /*LENGTH OF UCB LIST          */
         L     REG0,UCBSLGN                                     03S0260
*    REG0 = REG0 | SUBP230;                                     03S0261
         O     REG0,@CF00158                                    03S0261
*    REG1 = UCBLISTP;                  /*PTR TO UCB LIST             */
         L     REG1,UCBLISTP                                    03S0262
*    GEN ( FREEMAIN R,LV=(0),A=(1));   /*FREE THE UCB LIST           */
          FREEMAIN R,LV=(0),A=(1)
*    RFY (REG0,REG1) UNRSTD;                                    03S0264
*  END;                                                         03S0265
*ELSE                                  /*GETMAIN ERROR               */
*  DO;                                                          03S0266
         B     @RC00241                                         03S0266
@RF00241 DS    0H                                               03S0267
*    REASONCD = GETMNERR;              /*SET GETMAIN ERROR REASON CD */
         L     @02,@PC00001                                     03S0267
         L     @02,ALCWAPTR(,@02)                               03S0267
         L     @02,FAILRSCP(,@02)                               03S0267
         MVC   REASONCD(2,@02),@CH00134                         03S0267
*  END;                                                         03S0268
*    END;                                                       02S0269
*  ELSE                                /*NO REQS TO UNALLOC          */
*    DO;                                                        02S0270
         B     @RC00213                                         02S0270
@RF00213 DS    0H                                               02S0271
*      DADERRSW = OFF;                 /*END SCAN OF VU'S            */
         NI    DADERRSW,B'01111111'                             02S0271
*    END;                                                       02S0272
*END;                                                           02S0273
@RC00213 DS    0H                                               02S0273
@DE00179 TM    DADERRSW,B'10000000'                             02S0273
         BNO   @DC00179                                         02S0273
         LTR   RTNCODE,RTNCODE                                  02S0273
         BZ    @DL00179                                         02S0273
@DC00179 DS    0H                                               02S0274
*  END;                                                         01S0274
*ELSE;                                 /*ERROR OR NO REQS TO ALLOCATE*/
@RF00176 DS    0H                                               01S0276
*IF TOTREQS>ZERO & RTNCODE=SUCCESS THEN /*STILL REQS TO ALLOCATE
*                                                            @YM04246*/
         SLR   @02,@02                                          01S0276
         L     @15,@PC00001                                     01S0276
         L     @15,ALCWAPTR(,@15)                               01S0276
         C     @02,TOTREQS(,@15)                                01S0276
         BNL   @RF00276                                         01S0276
         CR    RTNCODE,@02                                      01S0276
         BNE   @RF00276                                         01S0276
*  DO;                                 /*YES, ..                     */
*/********************************************************************/
*/*                                                                  */
*/* SEGMENT NAME - SCRATALG                                          */
*/*                                                                  */
*/* DESCRIPTIVE NAME - ALLOCATE SCRATCH REQS VIA ALGORITHM           */
*/*                                                                  */
*/* FUNCTION -                                                       */
*/*     THIS ROUTINE DETERMINES IF THERE ARE ANY SCRATCH REQS NOT    */
*/*     YET ALLOCATED. IF SO, THE FOLLOWING PROCESSING IS DONE:      */
*/*       .IF THERE ARE MULTI-UNIT SCRATCH REQUESTS, IEFAB436 IS     */
*/*        CALLED TO TRY TO ALLOCATE SECONDARY UNIT REQUESTS TO      */
*/*        MOUNTED VOLUMES IN THE GENERIC WITH THE MOST ELIGIBLE     */
*/*        VOLUMES.                                                  */
*/*       .IEFAB476 IS CALLED TO ALLOCATE THE PRIMARY SCRATCH        */
*/*        REQS AND ANY REMAINING SECONDARY REQS VIA THE ALGORITHM   */
*/*        TO AVAILABLE (ONLINE,UNALLOCATED) UNITS.                  */
*/*                                                                  */
*/*   OPERATION - (THE OPERATION IS DOCUMENTED BY THE CODE ITSELF)   */
*/*                                                                  */
*/* ENTRY - (INLINE SUBROUTINE)                                      */
*/*                                                                  */
*/*   PURPOSE - (SEE FUNCTION)                                       */
*/*                                                                  */
*/*   INPUT -                                                        */
*/*     ALCWAPTR - PTR TO ALLOCATION WORK AREA, WHICH CONTAINS       */
*/*       VOLUNPTR - PTR TO VOLUNIT TABLE                            */
*/*       VOLMNTSW - INDICATE IF VOL MOUNTING IS ALLOWED     @YM04246*/
*/*     RTNCODE = 0                                                  */
*/*     VOLUNIT ENTRY FIELD 'VOLALGTP' POINT TO ALG TABLE ENTRY,     */
*/*       CVRSCRTH - SCRATCH REQ INDICATOR IN ALG TABLE ENTRIES      */
*/*       VOLUNIT ENTRY FIELD 'VOLSIOTP' POINTS TO THE SIOT,         */
*/*       SIOT FIELDS: SIOTAFID, SIOPSCNT, SIOTEDLP, SVOLUNAD,       */
*/*       AND SIOTGIGN                                               */
*/*                                                                  */
*/* EXIT - NORMAL - (INLINE SUBROUTINE)                              */
*/*                                                                  */
*/*   CONDITIONS - FUNCTION COMPLETED SUCCESSFULLY                   */
*/*                                                                  */
*/*   OUTPUT -                                                       */
*/*       GENERAL: SOME REQS MAY BE ALLOCATED BY IEFAB436 OR         */
*/*                IEFAB476                                          */
*/*                                                                  */
*/*       RETURN CODES - RTNCODE 0                                   */
*/*                                                                  */
*/* EXIT - ERROR - (INLINE SUBROUTINE)                               */
*/*                                                                  */
*/*   CONDITIONS - GETMAIN ERROR                                     */
*/*                                                                  */
*/*   OUTPUT - STEP REASON CODE 'REASONCD' SET TO 2                  */
*/*                                                                  */
*/*   RETURN CODES - RTNCODE SET TO 4                                */
*/*                                                          @YM04246*/
*/* EXIT - ERROR - (INLINE SUBROUTINE)                       @YM04246*/
*/*                                                          @YM04246*/
*/*   CONDITIONS - VOL MOUNTING NEEDED BUT NOT ALLOWED       @YM04246*/
*/*                                                          @YM04246*/
*/*   OUTPUT - DD - ERROR CODE(SIOTRSNC) SET TO 56           @YM04246*/
*/*                                                          @YM04246*/
*/*   RETURN CODES - RTNCODE SET TO 4                        @YM04246*/
*/*                                                                  */
*/* EXIT - ERROR - (INLINE SUBROUTINE)                               */
*/*                                                                  */
*/*   CONDITIONS - ERROR DETECTED BY MODULE IEFAB436 OR IEFAB476     */
*/*                                                                  */
*/*   OUTPUT - STEP- OR DD-RELATED ERROR CODE SET BY IEFAB436 OR     */
*/*            IEFAB476                                              */
*/*                                                                  */
*/*   RETURN CODES - RTNCODE SET NON-ZERO                            */
*/*                                                                  */
*/********************************************************************/
*SNEEDMNT = OFF;                       /*ASSUME IEFAB436 NOT NEEDED  */
*SNEEDALG = OFF;                       /*ASSUME IEFAB476 NOT NEEDED  */
         NI    SNEEDMNT,B'11110011'                             02S0279
*RFY INDMSIOT BASED(VOLSIOTP);         /*BASE SIOT ON VU ENTRY PTR   */
*VUPTR = VOLUNPTR;                     /*POINT TO THE FIRST VU ENTRY */
         L     VUPTR,VOLUNPTR(,@15)                             02S0281
*DO VUCTR = ONE TO VOLUNSZE/LENGTH(VOLUNTAB); /*SCAN ALL VU ENTRIES  */
         LA    VUCTR,1                                          02S0282
         B     @DE00282                                         02S0282
@DL00282 DS    0H                                               02S0283
*  IF VUPTR = SVOLUNAD THEN            /*FIRST VU ENTRY FOR SIOT ?   */
         L     @07,VOLSIOTP(,VUPTR)                             02S0283
         C     VUPTR,SVOLUNAD(,@07)                             02S0283
         BNE   @RF00283                                         02S0283
*    SIOTGIGN = ON;                    /*YES, MAKE SIOT 'IGNORE'     */
         OI    SIOTGIGN(@07),B'00001000'                        02S0284
*  ELSE;                               /*NOT THE FIRST VU FOR SIOT   */
@RF00283 DS    0H                                               02S0286
*  IF VOLALOC = OFF                    /*UNALLOC,DEVICE-REQ'D,SCRATCH*/
*      & VDEVREQD = ON                 /*..REQ THE ALG CAN CONSIDER? */
*      & VOLALGTP->CVRSCRTH = ON                                02S0286
*      & VOLALGTP->CVRIGNOR = OFF                               02S0286
*      & VOLALGTP->CVRDUPLI = OFF THEN                          02S0286
         TM    VDEVREQD(VUPTR),B'00100000'                      02S0286
         BNO   @RF00286                                         02S0286
         TM    VOLALOC(VUPTR),B'10000000'                       02S0286
         BNZ   @RF00286                                         02S0286
         L     @07,VOLALGTP(,VUPTR)                             02S0286
         TM    CVRSCRTH(@07),B'00001000'                        02S0286
         BNO   @RF00286                                         02S0286
         TM    CVRIGNOR(@07),B'00000010'                        02S0286
         BNZ   @RF00286                                         02S0286
         TM    CVRDUPLI(@07),B'10000000'                        02S0286
         BNZ   @RF00286                                         02S0286
*    DO;                               /*YES, PROCESS                */
*      IF VOLMNTSW = ON THEN           /*VOL MNT'ING ALLOWED @YM04246*/
         L     @15,@PC00001                                     02S0288
         L     @01,ALCWAPTR(,@15)                               02S0288
         L     @01,FMAPPTR(,@01)                                02S0288
         TM    VOLMNTSW(@01),B'10000000'                        02S0288
         BNO   @RF00288                                         02S0288
*        DO;                           /*YES, CONTINUE       @YM04246*/
*          VOLALGTP->CVRSKFLG = OFF;   /*ALLOW THE ALG TO CONSIDER   */
         NI    CVRSKFLG(@07),B'01111111'                        02S0290
*          SNEEDALG = ON;              /*INDICATE THE ALG IS NEEDED  */
         OI    SNEEDALG,B'00001000'                             02S0291
*          IF EDLMGENS=OFF             /*MULTI-GENERICS TABOO        */
*          & SIOPSCNT > ONE THEN       /*AND MORE THAN 1 SCR REQ?    */
         L     @07,VOLSIOTP(,VUPTR)                             02S0292
         L     @15,SIOTEDLP(,@07)                               02S0292
         TM    EDLMGENS(@15),B'01000000'                        02S0292
         BNZ   @RF00292                                         02S0292
         CLI   SIOPSCNT(@07),1                                  02S0292
         BNH   @RF00292                                         02S0292
*            DO;                       /*YES, PROCESS                */
*              SIOTGIGN = OFF;         /*ALLOW IEFAB436 TO CONSIDER  */
         NI    SIOTGIGN(@07),B'11110111'                        02S0294
*              IF SIOTAFID ^= ZERO THEN /*MULTI-UNIT/GEN REQ ?       */
         SLR   @14,@14                                          02S0295
         CH    @14,SIOTAFID(,@07)                               02S0295
         BE    @RF00295                                         02S0295
*                DO;                   /*YES, PICK GEN WITH MOST MNTS*/
*/********************************************************************/
*/*                                                                  */
*/* SEGMENT NAME - PICSCRAG                                          */
*/*                                                                  */
*/* DESCRIPTIVE NAME - PICK A GENERIC FOR SCRATCH REQS               */
*/*                                                                  */
*/* FUNCTION -                                                       */
*/*     THIS ROUTINE PICKS A GENERIC FOR A MULTI-UNIT, MULTI-GENERIC */
*/*     SCRATCH REQUEST AND MARKS ALL OTHER GENERICS INELIGIBLE IN   */
*/*     THE EDL AND ALGORITHM INTERFACE TABLES.                      */
*/*                                                                  */
*/*     THE GENERIC PICKED WILL BE THE ONE WITH THE MOST ELIGIBLE    */
*/*     MOUNTED VOLUMES (EDLNSCNT). IF NONE OF THE ELIGIBLE          */
*/*     GENERICS HAD ANY MOUNTED VOLUMES, NO GENERIC IS PICKED AND   */
*/*     'SIOTGIGN' IS TURNED ON SO THAT IEFAB436 WILL NOT PROCESS    */
*/*     THIS REQUEST.                                                */
*/*                                                                  */
*/*   OPERATION - (THE OPERATION IS DOCUMENTED BY THE CODE ITSELF)   */
*/*                                                                  */
*/* ENTRY - (INLINE SUBROUTINE)                                      */
*/*                                                                  */
*/*   PURPOSE - (SEE FUNCTION)                                       */
*/*                                                                  */
*/*   INPUT -                                                        */
*/*      VUPTR - PTR TO THE VOLUNIT ENTRY BEING PROCESSED            */
*/*      SIOTGIGN = 0                                                */
*/*                                                                  */
*/* EXIT - NORMAL - (INLINE SUBROUTINE)                              */
*/*                                                                  */
*/*   CONDITIONS - GENERIC PICKED FOR REQ                            */
*/*                                                                  */
*/*   OUTPUT - OTHER GENERICS MARKED INELIGIBLE (SEE IEFAB481)       */
*/*                                                                  */
*/*   RETURN CODES - RTNCODE SET TO 0                                */
*/*                                                                  */
*/* EXIT - NORMAL - (INLINE SUBROUTINE)                              */
*/*                                                                  */
*/*   CONDITIONS - NO GENERIC WITH ELIGIBLE MOUNTED VOLUMES FOUND    */
*/*                                                                  */
*/*   OUTPUT - SIOTGIGN=1                                            */
*/*                                                                  */
*/*   RETURN CODES - (NONE)                                          */
*/*                                                                  */
*/********************************************************************/
*MOSTNUM = ZERO;                       /*ZERO NUMBER MOUNTED VOLUMES */
         SLR   MOSTNUM,MOSTNUM                                  03S0297
*GENPICK = ZERO;                       /*ZERO GENERIC CHOICE FIELD   */
         ST    @14,GENPICK                                      03S0298
*EDLPTR = EDLFGENP;                    /*POINT TO THE FIRST EDL GEN  */
         L     EDLPTR,EDLFGENP(,@15)                            03S0299
*DO EGENCTR = ONE TO EDLGENNO;         /*SCAN ALL GENERIC           */
         LA    EGENCTR,1                                        03S0300
         B     @DE00300                                         03S0300
@DL00300 DS    0H                                               03S0301
*  IF EINDEVTP = OFF                   /*DOES GEN HAVE MORE MNTED VOL*/
*      & EDLNSCNT > MOSTNUM THEN                                03S0301
         TM    EINDEVTP(EDLPTR),B'10000000'                     03S0301
         BNZ   @RF00301                                         03S0301
         LH    @15,EDLNSCNT(,EDLPTR)                            03S0301
         CR    @15,MOSTNUM                                      03S0301
         BNH   @RF00301                                         03S0301
*    DO;                               /*YES,TENTATIVELY PICK GENERIC*/
*      MOSTNUM = EDLNSCNT;             /*STORE NUMBER OF MNTEDS      */
         LR    MOSTNUM,@15                                      03S0303
*      GENPICK = EDLDEVT;              /*COPY GENERIC DEVICE TYPE    */
         MVC   GENPICK(4),EDLDEVT(EDLPTR)                       03S0304
*    END;                                                       03S0305
*  ELSE;                               /*GEN DOESN'T HAVE MORE MNTEDS*/
@RF00301 DS    0H                                               03S0307
*  EDLPTR = EDLNXTNT;                  /*POINT TO THE NEXT GENERIC   */
         L     EDLPTR,EDLNXTNT(,EDLPTR)                         03S0307
*END;                                                           03S0308
         AH    EGENCTR,@CH00055                                 03S0308
@DE00300 L     @01,VOLSIOTP(,VUPTR)                             03S0308
         L     @01,SIOTEDLP(,@01)                               03S0308
         C     EGENCTR,EDLGENNO(,@01)                           03S0308
         BNH   @DL00300                                         03S0308
*IF GENPICK ^= ZERO THEN               /*WAS A GEN WITH MNTEDS FOUND?*/
         ICM   @07,15,GENPICK                                   03S0309
         BZ    @RF00309                                         03S0309
*  DO;                                 /*YES, ELIMINATE ALL OTHER GEN*/
*    SAVAFID = SIOTAFID;               /*COPY SIOT'S AFID            */
         L     @05,VOLSIOTP(,VUPTR)                             03S0311
         LH    SAVAFID,SIOTAFID(,@05)                           03S0311
*    SIOTPTR = SIOT1P;                 /*POINT TO FIRST SIOT         */
         L     @15,@PC00001                                     03S0312
         L     @01,ALCWAPTR(,@15)                               03S0312
         L     SIOTPTR,SIOT1P(,@01)                             03S0312
*    DO WHILE SIOTPTR ^= ZERO;         /*SCAN SIOTS                  */
         B     @DE00313                                         03S0313
@DL00313 DS    0H                                               03S0314
*      IF SIOTPTR->SIOTAFID = SAVAFID THEN  /*AFID GROUP REQ         */
         CH    SAVAFID,SIOTAFID(,SIOTPTR)                       03S0314
         BNE   @RF00314                                         03S0314
*        DO;                                                    03S0315
*          CALL IEFAB481(VOLSIOTP,GENPICK);/*UPDATE EDL+ALGORITHM TAB*/
         LA    @05,VOLSIOTP(,VUPTR)                             03S0316
         ST    @05,@AL00001                                     03S0316
         LA    @05,GENPICK                                      03S0316
         ST    @05,@AL00001+4                                   03S0316
         L     @15,@CV00172                                     03S0316
         LA    @01,@AL00001                                     03S0316
         BALR  @14,@15                                          03S0316
*          RTNCODE = REG15;            /*SAVE THE RETURN CODE        */
         LR    RTNCODE,REG15                                    03S0317
*        END;                                                   03S0318
*      ELSE;                           /*NOT IN AFID GROUP           */
@RF00314 DS    0H                                               03S0320
*      SIOTPTR = SIOTPTR->SIOTNPTR;    /*POINT TO NEXT SIOT          */
         L     SIOTPTR,SIOTNPTR(,SIOTPTR)                       03S0320
*    END;                                                       03S0321
@DE00313 LTR   SIOTPTR,SIOTPTR                                  03S0321
         BNZ   @DL00313                                         03S0321
*  END;                                                         03S0322
*ELSE                                  /*NO GEN FOUND WITH MNTED VOLS*/
*  DO;                                                          03S0323
         B     @RC00309                                         03S0323
@RF00309 DS    0H                                               03S0324
*    SIOTGIGN = ON;                    /*DON'T HAVE IEFAB436 CONSIDER*/
         L     @07,VOLSIOTP(,VUPTR)                             03S0324
         OI    SIOTGIGN(@07),B'00001000'                        03S0324
*  END;                                                         03S0325
*                END;                                           02S0326
*              ELSE;                   /*NOT A MULTI-UNIT/GEN REQ    */
@RF00295 DS    0H                                               02S0328
*              IF SIOTGIGN = OFF THEN  /*IS IEFAB436 TO PROCESS REQ  */
@RC00295 L     @07,VOLSIOTP(,VUPTR)                             02S0328
         TM    SIOTGIGN(@07),B'00001000'                        02S0328
         BNZ   @RF00328                                         02S0328
*                SNEEDMNT = ON;        /*YES,INDICATE IEFAB436 NEEDED*/
         OI    SNEEDMNT,B'00000100'                             02S0329
*              ELSE;                   /*IEFAB436 NOT TO CONSIDER REQ*/
@RF00328 DS    0H                                               02S0331
*            END;                                               02S0331
*          ELSE;                       /*ONLY 1 SCR REQ OR MGENS OK  */
@RF00292 DS    0H                                               02S0333
*        END;                          /*                    @YM04246*/
*    ELSE                              /*VOL MNTING NOT ALOWD@YM04246*/
*      DO;                             /*                    @YM04246*/
         B     @RC00288                                         02S0334
@RF00288 DS    0H                                               02S0335
*        RTNCODE = FAILURE;            /*SET ERROR RETURN    @YM04246*/
         LA    RTNCODE,4                                        02S0335
*        SIOTRSNC = NOMOUNT;           /*SET REASON CODE     @YM04246*/
         L     @07,VOLSIOTP(,VUPTR)                             02S0336
         MVC   SIOTRSNC(2,@07),@CH00138                         02S0336
*      END;                            /*                    @YM04246*/
*    END;                                                       02S0338
*  ELSE;                               /*NOT UNALLOC SCR FOR ALG     */
@RF00286 DS    0H                                               02S0340
*    IF VOLALGTP ^= ZERO THEN          /*ALG TABLE ENTRY ?           */
@RC00286 L     @07,VOLALGTP(,VUPTR)                             02S0340
         LTR   @07,@07                                          02S0340
         BZ    @RF00340                                         02S0340
*      VOLALGTP->CVRSCRTH=OFF;         /*TURN OFF SCRATCH INDICATOR  */
         NI    CVRSCRTH(@07),B'11110111'                        02S0341
*    ELSE;                             /*NO ALG TABLE ENTRY          */
@RF00340 DS    0H                                               02S0343
*  VUPTR = VUPTR + LENGTH(VOLUNTAB);   /*POINT TO THE NEXT VU ENTRY  */
         AL    VUPTR,@CF01135                                   02S0343
*END;                                                           02S0344
         AH    VUCTR,@CH00055                                   02S0344
@DE00282 L     @07,@PC00001                                     02S0344
         L     @07,ALCWAPTR(,@07)                               02S0344
         L     @00,VOLUNSZE(,@07)                               02S0344
         SRDA  @00,32                                           02S0344
         D     @00,@CF01135                                     02S0344
         CR    VUCTR,@01                                        02S0344
         BNH   @DL00282                                         02S0344
*RFY INDMSIOT BASED(SIOTPTR);                                   02S0345
*IF SNEEDMNT = ON                      /*ALLOC SCR TO MOUNTEDS NEEDED*/
*  & RTNCODE = SUCCESS THEN            /*IF NO ERRORS        @YM04246*/
         TM    SNEEDMNT,B'00000100'                             02S0346
         BNO   @RF00346                                         02S0346
         LTR   RTNCODE,RTNCODE                                  02S0346
         BNZ   @RF00346                                         02S0346
*  DO;                                 /*YES,INVOKE IEFAB436 TO ALLOC*/
*    DOPRTAL = ON;                     /*ALLOC SECONDARY ONLY@ZA03616*/
         OI    DOPRTAL,B'00001000'                              02S0348
*    CALL SCRATMNT;                    /*SECONDARY SCTCH REQS@ZA03616*/
         BAL   @14,SCRATMNT                                     02S0349
*  END;                                                         02S0350
*ELSE;                                 /*IEFAB436 NOT NEEDED         */
@RF00346 DS    0H                                               02S0352
*IF SNEEDALG=ON & RTNCODE=SUCCESS THEN /*IS THE ALG NEEDED ?         */
         TM    SNEEDALG,B'00001000'                             02S0352
         BNO   @RF00352                                         02S0352
         LTR   RTNCODE,RTNCODE                                  02S0352
         BNZ   @RF00352                                         02S0352
*  DO;                                 /*YES, ALLOC VIA ALGORITHM    */
*    FUNC476 = SCRAT476;               /*COPY THE FUNCTION MAP       */
         MVC   FUNC476(1),SCRAT476                              02S0354
*    CALL IEFAB476 (ALCWAPTR,FUNC476);                          02S0355
         L     @02,@PC00001                                     02S0355
         ST    @02,@AL00001                                     02S0355
         LA    @02,FUNC476                                      02S0355
         ST    @02,@AL00001+4                                   02S0355
         L     @15,@CV00168                                     02S0355
         LA    @01,@AL00001                                     02S0355
         BALR  @14,@15                                          02S0355
*    RTNCODE = REG15;                  /*SAVE THE RETURN CODE        */
         LR    RTNCODE,REG15                                    02S0356
*  END;                                                         02S0357
*ELSE;                                 /*NO SCRATCH REQS FOR ALG     */
@RF00352 DS    0H                                               02S0359
*  END;                                                         01S0359
*ELSE;                                 /*ERROR OR NO REQS TO ALLOCATE*/
@RF00276 DS    0H                                               01S0361
*IF TOTREQS>ZERO & RTNCODE=SUCCESS THEN /*STILL REQS TO ALLOCATE  ?  */
         SLR   @02,@02                                          01S0361
         L     @15,@PC00001                                     01S0361
         L     @15,ALCWAPTR(,@15)                               01S0361
         C     @02,TOTREQS(,@15)                                01S0361
         BNL   @RF00361                                         01S0361
         CR    RTNCODE,@02                                      01S0361
         BNE   @RF00361                                         01S0361
*  DO;                                 /*YES, PROCESS                */
*    IF UWAITSW=OFF & OFFDEVSW=OFF THEN /*CAN OFFLINE OR ALCD BE USED*/
         L     @01,FMAPPTR(,@15)                                01S0363
         TM    UWAITSW(@01),B'00100100'                         01S0363
         BNZ   @RF00363                                         01S0363
*      DO;                             /*NO, INDICATE ERROR          */
*        RFY VOLUNTAB BASED(CVRVUPTR); /*ASSOCIATE VU TABLE ENTRY AND
*                                        COVER REQ LIST ENTRY@ZA01569*/
*        RFY INDMSIOT BASED(VOLSIOTP); /*ASSOCIATE VU ENTRY WITH ITS
*                                        SIOT                @ZA01569*/
*        AREQPTR = ALGRQLTP;           /*FIRST REQ LIST ENTRY@ZA01569*/
         L     @01,ALGTABP(,@15)                                01S0367
         L     AREQPTR,ALGRQLTP(,@01)                           01S0367
*        RTNCODE = FAILURE;            /*INDICATE ERROR      @ZA01569*/
         LA    RTNCODE,4                                        01S0368
*        DO AREQCTR = ONE TO CVRNREQ;  /*SCAN ALL ENTRIES    @ZA01569*/
         LA    AREQCTR,1                                        01S0369
         B     @DE00369                                         01S0369
@DL00369 DS    0H                                               01S0370
*          IF VDEVREQD = ON &          /*REQ REQUIRES UNITS? @ZA01569*/
*             VOLALOC = OFF &          /*NOT ALLOCATED YET?  @ZA01569*/
*             CVRSKFLG = OFF &         /*ALG DID NOT SKIP?   @ZA01569*/
*             CVRNEED > ZERO THEN      /*ARE UNITS STILL REQUIRED
*                                        FOR THIS REQUEST?   @ZA01569*/
         L     @05,CVRVUPTR(,AREQPTR)                           01S0370
         TM    VDEVREQD(@05),B'00100000'                        01S0370
         BNO   @RF00370                                         01S0370
         TM    VOLALOC(@05),B'10000000'                         01S0370
         BNZ   @RF00370                                         01S0370
         TM    CVRSKFLG(AREQPTR),B'10000000'                    01S0370
         BNZ   @RF00370                                         01S0370
         ICM   @15,3,CVRNEED(AREQPTR)                           01S0370
         BNP   @RF00370                                         01S0370
*            DO;                       /*YES-                @ZA01569*/
*              SIOTRSNC = NORECODE;    /*SET DD-RELATED CODE FOR
*                                        UNABLE TO ALLOCATE  @ZA01569*/
         L     @05,VOLSIOTP(,@05)                               01S0372
         MVC   SIOTRSNC(2,@05),@CH00140                         01S0372
*            END;                      /*                    @ZA01569*/
*          ELSE;                       /*                    @ZA01569*/
@RF00370 DS    0H                                               01S0375
*          AREQPTR = AREQPTR + LENGTH(CVRRQLST); /*PICK UP NEXT 01S0375
*                                        REQUEST LIST ENTRY  @ZA01569*/
         AL    AREQPTR,@CF01135                                 01S0375
*        END;                          /*END SCAN            @ZA01569*/
         AH    AREQCTR,@CH00055                                 01S0376
@DE00369 L     @05,@PC00001                                     01S0376
         L     @05,ALCWAPTR(,@05)                               01S0376
         L     @05,ALGTABP(,@05)                                01S0376
         L     @05,ALGPARMP(,@05)                               01S0376
         CH    AREQCTR,CVRNREQ(,@05)                            01S0376
         BNH   @DL00369                                         01S0376
*        RFY VOLUNTAB BASED(VUPTR);    /*RESET VU TABLE BASE @ZA01569*/
*        RFY INDMSIOT BASED(SIOTPTR);  /*RESET SIOT BASE     @ZA01569*/
*      END;                                                     01S0379
*    ELSE                              /*CONSIDER OFFLINES/ALLOCATEDS*/
*      DO;                                                      01S0380
         B     @RC00363                                         01S0380
@RF00363 DS    0H                                               01S0381
*        CALL IEFAB486 (ALCWAPTR);                              01S0381
         L     @02,@PC00001                                     01S0381
         ST    @02,@AL00001                                     01S0381
         L     @15,@CV00173                                     01S0381
         LA    @01,@AL00001                                     01S0381
         BALR  @14,@15                                          01S0381
*        RTNCODE = REG15;              /*SAVE THE RETURN CODE        */
         LR    RTNCODE,REG15                                    01S0382
*      END;                                                     01S0383
*  END;                                                         01S0384
*ELSE;                                 /*ERROR OR NO REQS TO ALLOCATE*/
@RF00361 DS    0H                                               01S0386
*IF RTNCODE = SUCCESS THEN             /*ANY ERRORS ?                */
@RC00361 LTR   RTNCODE,RTNCODE                                  01S0386
         BNZ   @RF00386                                         01S0386
*  DO;                                 /*NO, FREE GROUPS NOT NEEDED  */
*    DO MASKBYTE = ONE TO GMTENTLN;    /*SET MASK OF GROUPS NOT NEED */
         LA    MASKBYTE,1                                       01S0388
         B     @DE00388                                         01S0388
@DL00388 DS    0H                                               01S0389
*      IF INDWAIT = OFF THEN           /*WAIT HOLDING RESOURCES?     */
         L     @03,@PC00001                                     01S0389
         L     @03,ALCWAPTR(,@03)                               01S0389
         TM    INDWAIT(@03),B'10000000'                         01S0389
         BNZ   @RF00389                                         01S0389
*        KEEPMASK(MASKBYTE) = ZERO;    /*NO, NO GROUPS TO KEEP       */
         L     @03,WMASKPTR(,@03)                               01S0390
         SLR   @15,@15                                          01S0390
         BCTR  @03,0                                            01S0390
         STC   @15,KEEPMASK(MASKBYTE,@03)                       01S0390
*        UNLKMASK(MASKBYTE)=VERIFYMK(MASKBYTE) | WAITMASK(MASKBYTE) |
*        KEEPMASK(MASKBYTE);                                    01S0391
@RF00389 LA    @03,UNLKMASK-1(MASKBYTE)                         01S0391
         L     @15,@PC00001                                     01S0391
         L     @15,ALCWAPTR(,@15)                               01S0391
         L     @01,WORK3MP(,@15)                                01S0391
         L     @14,WMASK2P(,@15)                                01S0391
         ALR   @01,MASKBYTE                                     01S0391
         BCTR  @01,0                                            01S0391
         MVC   0(1,@03),VERIFYMK(@01)                           01S0391
         ALR   @14,MASKBYTE                                     01S0391
         BCTR  @14,0                                            01S0391
         OC    0(1,@03),WAITMASK(@14)                           01S0391
         L     @01,WMASKPTR(,@15)                               01S0391
         ALR   @01,MASKBYTE                                     01S0391
         BCTR  @01,0                                            01S0391
         OC    0(1,@03),KEEPMASK(@01)                           01S0391
*        UNLKMASK(MASKBYTE)=UNLKMASK(MASKBYTE) && ALLONES;      01S0392
         LA    @03,UNLKMASK-1(MASKBYTE)                         01S0392
         XI    0(@03),X'FF'                                     01S0392
*    END;                                                       01S0393
         AH    MASKBYTE,@CH00055                                01S0393
@DE00388 L     @03,@PC00001                                     01S0393
         L     @03,ALCWAPTR(,@03)                               01S0393
         L     @03,EDTABPTR(,@03)                               01S0393
         L     @03,EDTMSKTP(,@03)                               01S0393
         C     MASKBYTE,GMTENTLN(,@03)                          01S0393
         BNH   @DL00388                                         01S0393
*    QMGRRBP->AQMECODE = RLSEFUNC;     /*INDICATE 'RELEASE' FUNC CODE*/
         L     @02,@PC00001                                     01S0394
         L     @02,ALCWAPTR(,@02)                               01S0394
         L     @15,QMGRRBP(,@02)                                01S0394
         MVC   AQMECODE(2,@15),@CH00064                         01S0394
*    QMGRRBP->AQMMASKP=ADDR(UNLKMASK); /*POINT TO GROUPS TO FREE     */
         LA    @14,UNLKMASK                                     01S0395
         ST    @14,AQMMASKP(,@15)                               01S0395
*    CALL IEFAB4FA (QMGRRBP,EXITPRMP); /*RELEASE GROUPS NOT NEEDED   */
         LA    @15,QMGRRBP(,@02)                                01S0396
         ST    @15,@AL00001                                     01S0396
         LA    @02,EXITPRMP(,@02)                               01S0396
         ST    @02,@AL00001+4                                   01S0396
         L     @15,@CV00174                                     01S0396
         LA    @01,@AL00001                                     01S0396
         BALR  @14,@15                                          01S0396
*    RTNCODE = REG15;                  /*SAVE THE RETURN CODE        */
         LR    RTNCODE,REG15                                    01S0397
*  END;                                                         01S0398
*ELSE;                                 /*ERROR                       */
@RF00386 DS    0H                                               01S0400
*RETURN CODE(RTNCODE);                 /*RETURN TO CALLER            */
         L     @13,4(,@13)                                      01S0400
         L     @00,@SIZDATD                                     01S0400
         LR    @01,@10                                          01S0400
         FSPACE   R,LV=(0),A=(1)
         LR    @15,@03                                          01S0400
         L     @14,12(,@13)                                     01S0400
         LM    @00,@12,20(@13)                                  01S0400
         BR    @14                                              01S0400
*SCRAMLST: PROC;                                                02S0401
@EL00001 L     @13,4(,@13)                                      02S0401
@EF00001 L     @00,@SIZDATD                                     02S0401
         LR    @01,@10                                          02S0401
         FSPACE   R,LV=(0),A=(1)
@ER00001 LM    @14,@12,12(@13)                                  02S0401
         BR    @14                                              02S0401
SCRAMLST STM   @14,@03,12(@13)                                  02S0401
         STM   @05,@12,40(@13)                                  02S0401
*/********************************************************************/
*/*                                                                  */
*/* SEGMENT NAME - SCRAMLST                                          */
*/*                                                                  */
*/* DESCRIPTIVE NAME - BUILD LIST OF UCBS WITH MOUNTED VOLUMES       */
*/*                                                                  */
*/* FUNCTION -                                                       */
*/*     THIS ROUTINE DETERMINES ALL THE DIRECT-ACCESS UCBS WHICH     */
*/*     HAVE NON-PRIVATE VOLUMES MOUNTED (WHICH COULD BE             */
*/*     ELIGIBLE TO ALLOCATE NON-SPECIFIC VOLUME REQS).              */
*/*     FOR EACH SUCH UCB FOUND, THIS ROUTINE INCREMENTS A COUNT     */
*/*     'MAXMNTS' AND, IF REQUESTED, PUTS A POINTER TO THE UCB IN    */
*/*     A CANDIDATE LIST ENTRY.                                      */
*/*                                                                  */
*/*    OPERATION - ALL DA AND TAPE UCBS ARE LOCATED VIA THE IOS UCB  */
*/*                LOOKUP TABLE.                                     */
*/*                                                                  */
*/* ENTRY - SCRAMLST                                                 */
*/*                                                                  */
*/*   PURPOSE - (SEE FUNCTION)                                       */
*/*                                                                  */
*/*   INPUT -                                                        */
*/*     ALCWAPTR - PTR TO ALLOCATION WORK AREA , WHICH CONTAINS      */
*/*       IOSLUTP  - PTR TO IOS UCB LOOKUP TABLE                     */
*/*       VOLUNPTR - PTR TO VOLUNIT TABLE                            */
*/*       WAITIGEN - 1 INDICATES REQS MUST WAIT FOR UNALLOCATIONS    */
*/*     FILLIST - 1 INDICATES UCB PTRS SHOULD BE PUT IN A CANDIDATE  */
*/*               LIST.                                              */
*/*     UCBLISTP - PTR TO UCB CANDIDATE LIST                         */
*/*                                                                  */
*/* EXIT - NORMAL - RETURN TO CALLER                                 */
*/*                                                                  */
*/*   CONDITIONS - FUNCTION COMPLETED                                */
*/*                                                                  */
*/*   OUTPUT -                                                       */
*/*     .MAXMNTS - NUMBER OF UCB CANDIDATES                          */
*/*     .UCB CANDIDATE LIST ENTRIES (PSUCBP) CONTAIN PTRS TO UCBS    */
*/*      (IF FILLIST=1)                                              */
*/*                                                                  */
*/*   RETURN CODES - (NONE)                                          */
*/*                                                                  */
*/********************************************************************/
*ANYCANDS=OFF;                         /*INIT CANDIDATE FOUND   02S0402
*                                        INDICATORS. USED ONLY IN FIRST
*                                        CALL TO THIS ROUTINE   02S0402
*                                                            @Z40FPPJ*/
         NI    ANYCANDS,B'01111111'                             02S0402
*MAXMNTS = ZERO;                       /*ZERO COUNT OF UCB CANDIDATES*/
         SLR   MAXMNTS,MAXMNTS                                  02S0403
*DO LUTNO=ONE BY ONE WHILE((IOSLUT(LUTNO)^=LUTEND)&ANYCANDS=OFF);
         LA    LUTNO,1                                          02S0404
         B     @DE00404                                         02S0404
@DL00404 DS    0H                                               02S0405
*                                      /*SCAN ALL UCBS       @Z40FPPJ*/
*  IF IOSLUT(LUTNO) ^= ZERO THEN       /*IS THERE A UCB ADDRESS ?    */
         LR    @15,LUTNO                                        02S0405
         ALR   @15,@15                                          02S0405
         L     @14,@PC00001                                     02S0405
         L     @01,ALCWAPTR(,@14)                               02S0405
         L     @01,IOSLUTP(,@01)                                02S0405
         ALR   @01,@15                                          02S0405
         BCTR  @01,0                                            02S0405
         BCTR  @01,0                                            02S0405
         SLR   @15,@15                                          02S0405
         ICM   @15,3,IOSLUT(@01)                                02S0405
         LTR   @15,@15                                          02S0405
         BZ    @RF00405                                         02S0405
*    DO;                               /*YES, PROCESS ..             */
*      UCBPTR = IOSLUT(LUTNO);                                  02S0407
         LR    UCBPTR,@15                                       02S0407
*      IF ((UCB3DACC=ON & UCBBSVL=OFF) /*IS UCB SHAREABLE DA ..      */
*          | (UCB3TAPE=ON & UCBALOC=OFF)) /*..OR UNALLOCATED TAPE,   */
*          & UCBONLI = ON              /*IS THE UCB ONLINE,          */
*          & UCBCHGS = OFF             /*NOT PENDING OFFLINE         */
*          & UCBNALOC = OFF            /*USEABLE BY ALLOCATION,      */
*          & UCBUNLD = OFF             /*NOT PENDING UNLOAD,         */
*          & UCBNOTRD = OFF            /*READY                       */
*          & UCBMOUNT = OFF            /*WITHOUT A MOUNT PENDING,    */
*          & UCBBPRV = OFF             /*NOT PRIVATE,                */
*          & (UCBBPUB=ON | UCBBSTR=ON) THEN /*AND HAS USE-ATTRIBUTE? */
         TM    UCB3DACC(UCBPTR),B'00100000'                     02S0408
         BNO   @GL00029                                         02S0408
         TM    UCBBSVL(UCBPTR),B'10000000'                      02S0408
         BZ    @GL00028                                         02S0408
@GL00029 TM    UCB3TAPE(UCBPTR),B'10000000'                     02S0408
         BNO   @RF00408                                         02S0408
         TM    UCBALOC(UCBPTR),B'00001000'                      02S0408
         BNZ   @RF00408                                         02S0408
@GL00028 TM    UCBONLI(UCBPTR),B'10000000'                      02S0408
         BNO   @RF00408                                         02S0408
         TM    UCBCHGS(UCBPTR),B'01000000'                      02S0408
         BNZ   @RF00408                                         02S0408
         TM    UCBNALOC(UCBPTR),B'00000100'                     02S0408
         BNZ   @RF00408                                         02S0408
         TM    UCBUNLD(UCBPTR),B'00010000'                      02S0408
         BNZ   @RF00408                                         02S0408
         TM    UCBNOTRD(UCBPTR),B'01000000'                     02S0408
         BNZ   @RF00408                                         02S0408
         TM    UCBMOUNT(UCBPTR),B'10000000'                     02S0408
         BNZ   @RF00408                                         02S0408
         TM    UCBBPRV(UCBPTR),B'00010000'                      02S0408
         BNZ   @RF00408                                         02S0408
         TM    UCBBPUB(UCBPTR),B'00001100'                      02S0408
         BZ    @RF00408                                         02S0408
*        DO;                           /*YES,CONSIDER A POSSIBLE CAND*/
*          USEUCBSW = ON;              /*INDICATE AS POSSIBLE CAND   */
         OI    USEUCBSW,B'00000010'                             02S0410
*          IF WAITIGEN = ON THEN       /*ANY REQS WAITING FOR UNALOC?*/
         L     @02,@PC00001                                     02S0411
         L     @02,ALCWAPTR(,@02)                               02S0411
         TM    WAITIGEN(@02),B'01000000'                        02S0411
         BNO   @RF00411                                         02S0411
*            DO;                       /*YES,SEE IF WAIT FOR THIS UCB*/
*              VUPTR = VOLUNPTR;       /*POINT TO FIRST VOLUNIT ENTRY*/
         L     @15,@PC00001                                     02S0413
         L     @15,ALCWAPTR(,@15)                               02S0413
         L     VUPTR,VOLUNPTR(,@15)                             02S0413
*              DO VUCTR=ONE TO VOLUNSZE/LENGTH(VOLUNTAB); /*SCAN VUS */
         LA    VUCTR,1                                          02S0414
         B     @DE00414                                         02S0414
@DL00414 DS    0H                                               02S0415
*                IF VOLALGTP ^= ZERO &                          02S0415
*                   VOLALGTP->CVRWUCBP=UCBPTR THEN /*WAIT FOR THE UCB*/
         L     @07,VOLALGTP(,VUPTR)                             02S0415
         LTR   @07,@07                                          02S0415
         BZ    @RF00415                                         02S0415
         SLR   @15,@15                                          02S0415
         ICM   @15,3,CVRWUCBP(@07)                              02S0415
         CR    UCBPTR,@15                                       02S0415
         BNE   @RF00415                                         02S0415
*                    USEUCBSW = OFF;   /*YES,DONT USE AS CANDIDATE   */
         NI    USEUCBSW,B'11111101'                             02S0416
*                ELSE;                 /*NOT WAITING FOR THIS UCB    */
@RF00415 DS    0H                                               02S0418
*                VUPTR=VUPTR+LENGTH(VOLUNTAB); /*POINT TO NEXT VU    */
         AL    VUPTR,@CF01135                                   02S0418
*              END;                                             02S0419
         AH    VUCTR,@CH00055                                   02S0419
@DE00414 L     @07,@PC00001                                     02S0419
         L     @07,ALCWAPTR(,@07)                               02S0419
         L     @00,VOLUNSZE(,@07)                               02S0419
         SRDA  @00,32                                           02S0419
         D     @00,@CF01135                                     02S0419
         CR    VUCTR,@01                                        02S0419
         BNH   @DL00414                                         02S0419
*            END;                                               02S0420
*          ELSE;                       /*NO REQS WAITING FOR UNALLOCS*/
@RF00411 DS    0H                                               02S0422
*          IF USEUCBSW = ON THEN       /*CAN UCB BE A CANDIDATE ?    */
         TM    USEUCBSW,B'00000010'                             02S0422
         BNO   @RF00422                                         02S0422
*            DO;                       /*YES, PROCESS                */
*              MAXMNTS = MAXMNTS + ONE; /*INCREMENT COUNT OF CAND    */
         AH    MAXMNTS,@CH00055                                 02S0424
*              IF FILLIST = ON         /*SHOULD LIST ENTRY BE FILLED?*/
*                  & MAXMNTS * TWO < UCBSLGN THEN               02S0425
         TM    FILLIST,B'01000000'                              02S0425
         BNO   @RF00425                                         02S0425
         LR    @02,MAXMNTS                                      02S0425
         ALR   @02,@02                                          02S0425
         C     @02,UCBSLGN                                      02S0425
         BNL   @RF00425                                         02S0425
*                DO;                   /*YES, PUT UCBPTR IN LIST     */
*                  PSUCBP(MAXMNTS) = UCBPTR;                    02S0427
         L     @01,UCBLISTP                                     02S0427
         BCTR  @01,0                                            02S0427
         BCTR  @01,0                                            02S0427
         STH   UCBPTR,PSUCBP(@02,@01)                           02S0427
*                END;                                           02S0428
*              ELSE                    /*DONT PUT UCBPTR TO THE LIST */
*                ANYCANDS=ON;          /*INDICATE AT LEAST ON   02S0429
*                                        CANDIDATE EXISTS    @Z40FPPJ*/
         B     @RC00425                                         02S0429
@RF00425 OI    ANYCANDS,B'10000000'                             02S0429
*            END;                                               02S0430
*          ELSE;                       /*UCB IS NOT A CANDIDATE      */
@RF00422 DS    0H                                               02S0432
*        END;                                                   02S0432
*      ELSE;                           /*UCB CANNOT BE A CANDIDATE   */
@RF00408 DS    0H                                               02S0434
*    END;                                                       02S0434
*  ELSE;                               /*ZERO UCB POINTER            */
@RF00405 DS    0H                                               02S0436
*END;                                                           02S0436
@RC00405 AH    LUTNO,@CH00055                                   02S0436
@DE00404 LR    @15,LUTNO                                        02S0436
         ALR   @15,@15                                          02S0436
         L     @14,@PC00001                                     02S0436
         L     @01,ALCWAPTR(,@14)                               02S0436
         L     @01,IOSLUTP(,@01)                                02S0436
         ALR   @01,@15                                          02S0436
         BCTR  @01,0                                            02S0436
         BCTR  @01,0                                            02S0436
         CLC   IOSLUT(2,@01),LUTEND                             02S0436
         BE    @DC00404                                         02S0436
         TM    ANYCANDS,B'10000000'                             02S0436
         BZ    @DL00404                                         02S0436
@DC00404 DS    0H                                               02S0437
*RETURN;                               /*RETURN TO CALLER            */
@EL00002 DS    0H                                               02S0437
@EF00002 DS    0H                                               02S0437
@ER00002 LM    @14,@03,12(@13)                                  02S0437
         LM    @05,@12,40(@13)                                  02S0437
         BR    @14                                              02S0437
*END SCRAMLST;                                                  02S0438
*DAFERLST : PROC;                                               02S0439
DAFERLST STM   @14,@03,12(@13)                                  02S0439
         STM   @05,@12,40(@13)                                  02S0439
*/********************************************************************/
*/*                                                                  */
*/* SEGMENT NAME - DAFERLST                                          */
*/*                                                                  */
*/* DESCRIPTIVE NAME - BUILD LIST OF DA UCBS WITH MOUNTED VOLS       */
*/*                                                          @Z40FPPJ*/
*/*                                                                  */
*/* FUNCTION -                                                       */
*/*     THIS ROUTINE DETERMINES ALL THE DIRECT-ACCESS UCBS WHICH     */
*/*     HAVE NON-PRIVATE, SHAREABLE VOLUMES MOUNTED (WHICH WOULD BE  */
*/*     ELIGIBLE TO ALLOCATE NON-SPECIFIC VOLUME REQS).              */
*/*     FOR EACH SUCH UCB FOUND, THIS ROUTINE INCREMENTS A COUNT     */
*/*     'MAXMNTS' AND , PUTS A POINTER TO THE UCB IN         @Z40FPPJ*/
*/*     A CANDIDATE LIST ENTRY.                                      */
*/*                                                                  */
*/*   OPERATION - ALL DA UCBS ARE LOCATED VIA THE 'SYSALLDA' LOOKUP  */
*/*               VALUE ENTRY IN THE EDT.                            */
*/*                                                                  */
*/* ENTRY - DAFERLST                                                 */
*/*                                                                  */
*/*   PURPOSE - (SEE FUNCTION)                                       */
*/*                                                                  */
*/*   INPUT -                                                        */
*/*     ALCWAPTR - PTR TO ALLOCATION WORK AREA , WHICH CONTAINS      */
*/*       EDTABPTR - PTR TO ELIGIBLE DEVICES TABLE (EDT)             */
*/*       IOSLUTP  - PTR TO IOS UCB LOOKUP TABLE                     */
*/*       VOLUNPTR - PTR TO VOLUNIT TABLE                            */
*/*       WAITIGEN - 1 INDICATES REQS MUST WAIT FOR UNALLOCATIONS    */
*/*       ALCNUCBS - NUMBER OF UCBS IN SYSTEM                @Z40FPPJ*/
*/*     FILLIST - 1 INDICATES UCB PTRS SHOULD BE PUT IN A CANDIDATE  */
*/*               LIST.                                              */
*/*     UCBLISTP - PTR TO UCB CANDIDATE LIST                         */
*/*                                                                  */
*/* EXIT - NORMAL - RETURN TO CALLER                                 */
*/*                                                                  */
*/*   CONDITIONS - FUNCTION COMPLETED                                */
*/*                                                                  */
*/*   OUTPUT -                                                       */
*/*     .MAXMNTS - NUMBER OF UCB CANDIDATES                          */
*/*     .UCB CANDIDATE LIST ENTRIES (PSUCBP) CONTAIN PTRS TO UCBS    */
*/*      (IF FILLIST=1)                                              */
*/*                                                                  */
*/*   RETURN CODES - (NONE)                                          */
*/*                                                                  */
*/********************************************************************/
*LUVPTR = EDTLUVSP + LENGTH(LUVHDR)    /*POINT TO 'SYSALLDA' ENTRY   */
*                  + ((LUVENTNO-1)*LUVENTLN);                   02S0440
         L     @15,@PC00001                                     02S0440
         L     @01,ALCWAPTR(,@15)                               02S0440
         L     @01,EDTABPTR(,@01)                               02S0440
         L     @15,EDTLUVSP(,@01)                               02S0440
         LA    LUVPTR,8                                         02S0440
         ALR   LUVPTR,@15                                       02S0440
         L     @01,LUVENTNO(,@15)                               02S0440
         BCTR  @01,0                                            02S0440
         M     @00,LUVENTLN(,@15)                               02S0440
         ALR   LUVPTR,@01                                       02S0440
*MAXMNTS = ZERO;                       /*ZERO COUNT OF UCB CANDIDATES*/
         SLR   MAXMNTS,MAXMNTS                                  02S0441
*GENPTR = LUVGENP;                     /*POINT TO FIRST GEN ENTRY    */
         L     GENPTR,LUVGENP(,LUVPTR)                          02S0442
*DO GENCTR  = ONE TO LUVGENNO;         /*SCAN ALL GENS FOR SYSALLDA  */
         LA    @09,1                                            02S0443
         B     @DE00443                                         02S0443
@DL00443 DS    0H                                               02S0444
*  GRPTABP = GENGRPTR;                 /*POINT TO FIRST GROUP ENTRY  */
         L     GRPTABP,GENGRPTR(,GENPTR)                        02S0444
*  DO GRPCTR = ONE TO GENGRPNO;        /*SCAN ALL GROUP ENTRIES      */
         LA    @09,1                                            02S0445
         B     @DE00445                                         02S0445
@DL00445 DS    0H                                               02S0446
*    DO UCBCTR = ONE TO GRPUCBNO;      /*SCAN ALL UCBS IN THE GROUP  */
         LA    UCBCTR,1                                         02S0446
         B     @DE00446                                         02S0446
@DL00446 DS    0H                                               02S0447
*      UCBPTR = IOSLUT(EUCBTPOS(UCBCTR)+1); /*GET ADDRESSABLE TO UCB */
         LR    @06,UCBCTR                                       02S0447
         ALR   @06,@06                                          02S0447
         L     @01,GRPTR(,GRPTABP)                              02S0447
         L     @01,GRPUCBP(,@01)                                02S0447
         BCTR  @01,0                                            02S0447
         BCTR  @01,0                                            02S0447
         LH    @06,EUCBTPOS(@06,@01)                            02S0447
         ALR   @06,@06                                          02S0447
         L     @15,@PC00001                                     02S0447
         L     @15,ALCWAPTR(,@15)                               02S0447
         L     @01,IOSLUTP(,@15)                                02S0447
         ALR   @01,@06                                          02S0447
         SLR   UCBPTR,UCBPTR                                    02S0447
         ICM   UCBPTR,3,IOSLUT(@01)                             02S0447
*      IF UCBONLI = ON                 /*IS THE UCB ONLINE,          */
*          & UCBCHGS = OFF             /*NOT PENDING OFFLINE,        */
*          & UCBNALOC = OFF            /*USEABLE BY ALLOCATION,      */
*          & UCBUNLD = OFF             /*NOT PENDING UNLOAD,         */
*          & UCBNOTRD = OFF            /*READY                       */
*          & UCBMOUNT = OFF            /*WITHOUT A MOUNT PENDING,    */
*          & UCBBPRV = OFF             /*NOT PRIVATE,                */
*          & (UCBBPUB = ON | UCBBSTR = ON) /*HAS A USE ATTRIBUTE,    */
*          & UCBBSVL = OFF THEN        /*AND SHAREABLE ?             */
         TM    UCBONLI(UCBPTR),B'10000000'                      02S0448
         BNO   @RF00448                                         02S0448
         TM    UCBCHGS(UCBPTR),B'01000000'                      02S0448
         BNZ   @RF00448                                         02S0448
         TM    UCBNALOC(UCBPTR),B'00000100'                     02S0448
         BNZ   @RF00448                                         02S0448
         TM    UCBUNLD(UCBPTR),B'00010000'                      02S0448
         BNZ   @RF00448                                         02S0448
         TM    UCBNOTRD(UCBPTR),B'01000000'                     02S0448
         BNZ   @RF00448                                         02S0448
         TM    UCBMOUNT(UCBPTR),B'10000000'                     02S0448
         BNZ   @RF00448                                         02S0448
         TM    UCBBPRV(UCBPTR),B'00010000'                      02S0448
         BNZ   @RF00448                                         02S0448
         TM    UCBBPUB(UCBPTR),B'00001100'                      02S0448
         BZ    @RF00448                                         02S0448
         TM    UCBBSVL(UCBPTR),B'10000000'                      02S0448
         BNZ   @RF00448                                         02S0448
*        DO;                           /*YES,CONSIDER A POSSIBLE CAND*/
*          USEUCBSW = ON;              /*INDICATE AS POSSIBLE CAND   */
         OI    USEUCBSW,B'00000010'                             02S0450
*          IF WAITIGEN = ON THEN       /*ANY REQS WAITING FOR UNALOC?*/
         TM    WAITIGEN(@15),B'01000000'                        02S0451
         BNO   @RF00451                                         02S0451
*            DO;                       /*YES,SEE IF WAIT FOR THIS UCB*/
*              VUPTR = VOLUNPTR;       /*POINT TO FIRST VOLUNIT ENTRY*/
         L     VUPTR,VOLUNPTR(,@15)                             02S0453
*              DO VUCTR=ONE TO VOLUNSZE/LENGTH(VOLUNTAB); /*SCAN VUS */
         LA    VUCTR,1                                          02S0454
         B     @DE00454                                         02S0454
@DL00454 DS    0H                                               02S0455
*                IF VOLALGTP ^= ZERO &                          02S0455
*                   VOLALGTP->CVRWUCBP=UCBPTR THEN /*WAIT FOR THE UCB*/
         L     @15,VOLALGTP(,VUPTR)                             02S0455
         LTR   @15,@15                                          02S0455
         BZ    @RF00455                                         02S0455
         SLR   @14,@14                                          02S0455
         ICM   @14,3,CVRWUCBP(@15)                              02S0455
         CR    UCBPTR,@14                                       02S0455
         BNE   @RF00455                                         02S0455
*                    USEUCBSW = OFF;   /*YES,DONT USE AS CANDIDATE   */
         NI    USEUCBSW,B'11111101'                             02S0456
*                ELSE;                 /*NOT WAITING FOR THIS UCB    */
@RF00455 DS    0H                                               02S0458
*                VUPTR=VUPTR+LENGTH(VOLUNTAB); /*POINT TO NEXT VU    */
         AL    VUPTR,@CF01135                                   02S0458
*              END;                                             02S0459
         AH    VUCTR,@CH00055                                   02S0459
@DE00454 L     @15,@PC00001                                     02S0459
         L     @01,ALCWAPTR(,@15)                               02S0459
         L     @00,VOLUNSZE(,@01)                               02S0459
         SRDA  @00,32                                           02S0459
         D     @00,@CF01135                                     02S0459
         CR    VUCTR,@01                                        02S0459
         BNH   @DL00454                                         02S0459
*            END;                                               02S0460
*          ELSE;                       /*NO REQS WAITING FOR UNALLOCS*/
@RF00451 DS    0H                                               02S0462
*          IF USEUCBSW = ON THEN       /*CAN UCB BE A CANDIDATE ?    */
         TM    USEUCBSW,B'00000010'                             02S0462
         BNO   @RF00462                                         02S0462
*            DO;                       /*YES, PROCESS                */
*              MAXMNTS = MAXMNTS + ONE; /*INCREMENT COUNT OF CAND    */
         AH    MAXMNTS,@CH00055                                 02S0464
*              PSUCBP(MAXMNTS) = UCBPTR;                        02S0465
         LR    @06,MAXMNTS                                      02S0465
         ALR   @06,@06                                          02S0465
         L     @02,UCBLISTP                                     02S0465
         BCTR  @02,0                                            02S0465
         BCTR  @02,0                                            02S0465
         STH   UCBPTR,PSUCBP(@06,@02)                           02S0465
*            END;                                               02S0466
*          ELSE;                       /*UCB IS NOT A CANDIDATE      */
@RF00462 DS    0H                                               02S0468
*        END;                                                   02S0468
*      ELSE;                           /*UCB CANNOT BE A CANDIDATE   */
@RF00448 DS    0H                                               02S0470
*    END;                                                       02S0470
         AH    UCBCTR,@CH00055                                  02S0470
@DE00446 L     @06,GRPTR(,GRPTABP)                              02S0470
         C     UCBCTR,GRPUCBNO(,@06)                            02S0470
         BNH   @DL00446                                         02S0470
*    GRPTABP = GRPTABP + LENGTH(GRPTRTAB); /*POINT TO NEXT GROUP ENT */
         AH    GRPTABP,@CH00064                                 02S0471
*  END;                                                         02S0472
         LA    @09,1                                            02S0472
         AL    @09,GRPCTR                                       02S0472
@DE00445 ST    @09,GRPCTR                                       02S0472
         C     @09,GENGRPNO(,GENPTR)                            02S0472
         BNH   @DL00445                                         02S0472
*  GENPTR = GENPTR + LENGTH(GENENTRY); /*POINT TO NEXT GENERIC ENTRY */
         AH    GENPTR,@CH00033                                  02S0473
*END;                                                           02S0474
         LA    @09,1                                            02S0474
         AL    @09,GENCTR                                       02S0474
@DE00443 ST    @09,GENCTR                                       02S0474
         C     @09,LUVGENNO(,LUVPTR)                            02S0474
         BNH   @DL00443                                         02S0474
*RETURN;                               /*RETURN TO CALLER            */
@EL00003 DS    0H                                               02S0475
@EF00003 DS    0H                                               02S0475
@ER00003 LM    @14,@03,12(@13)                                  02S0475
         LM    @05,@12,40(@13)                                  02S0475
         BR    @14                                              02S0475
*END DAFERLST;                                                  02S0476
*SCRATMNT: PROC;                       /*                    @ZA03616*/
SCRATMNT STM   @14,@02,@SA00004                                 02S0477
         STM   @04,@12,@SA00004+20                              02S0477
*/********************************************************************/
*/*                                                                  */
*/* SEGMENT NAME - SCRATMNT                                          */
*/*                                                                  */
*/* DESCRIPTIVE NAME - ALLOCATE SECONDARY SCRATCH REQUESTS           */
*/*                                                                  */
*/* FUNCTION -                                                       */
*/*     THIS ROUTINE BUILDS A LIST OF ALL DIRECT-ACCESS AND TAPE     */
*/*     UCBS WITH NON-PRIVATE VOLUMES MOUNTED AND CALLS IEFAB436     */
*/*     TO ALLOCATE SECONDARY SCRATCH REQUESTS TO THESE MOUNTED      */
*/*     VOLUMES.                                                     */
*/*                                                                  */
*/*   OPERATION - (THE OPERATION IS DOCUMENTED BY THE CODE ITSELF).  */
*/*                                                                  */
*/* ENTRY - SCRATMNT                                                 */
*/*                                                                  */
*/*   PURPOSE - (SEE FUNCTION)                                       */
*/*                                                                  */
*/*   INPUT -                                                        */
*/*       ALCWAPTR - PTR TO ALLOCATION WORK AREA, WHICH CONTAINS     */
*/*         IOSLUTP - PTR TO IOS UCB LOOKUP TABLE                    */
*/*         FAILRSCP - PTR TO STEP REASON CODE AREA                  */
*/*         ALCNUCBS - NUMBER OF UCBS IN SYSTEM              @Z40FPPJ*/
*/*                                                                  */
*/* EXIT - NORMAL - RETURN TO CALLER                                 */
*/*                                                                  */
*/*   CONDITIONS - FUNCTION COMPLETED SUCCESSFULLY                   */
*/*                                                                  */
*/*   OUTPUT -                                                       */
*/*       GENERAL: SOME REQS MAY BE ALLOCATED BY IEFAB436            */
*/*                                                                  */
*/*   RETURN CODES - RTNCODE 0                                       */
*/*                                                                  */
*/* EXIT - ERROR - SCRATMNT                                          */
*/*                                                                  */
*/*   CONDITIONS - GETMAIN ERROR                                     */
*/*                                                                  */
*/*   OUTPUT - STEP REASON CODE 'REASONCD' SET TO 2                  */
*/*                                                                  */
*/*   RETURN CODES - RTNCODE SET TO 4                                */
*/*                                                                  */
*/* EXIT - ERROR - SCRATMNT                                          */
*/*                                                                  */
*/*   CONDITIONS - ERROR DETECTED BY MODULE IEFAB436                 */
*/*                                                                  */
*/*   OUTPUT - STEP- OR DD-RELATED ERROR CODE SET BY IEFAB436        */
*/*                                                                  */
*/*   RETURN CODES - RTNCODE SET NON-ZERO                            */
*/*                                                                  */
*/********************************************************************/
*FILLIST = OFF;                        /*INDICATE 'COUNT CANDIDATES' */
         NI    FILLIST,B'10111111'                              02S0478
*CALL SCRAMLST;                        /*DETERMINE NUMBER OF CAND    */
         BAL   @14,SCRAMLST                                     02S0479
*IF ANYCANDS = ON THEN                 /*ANY CANDIDATES FOR IEFAB436 */
         TM    ANYCANDS,B'10000000'                             02S0480
         BNO   @RF00480                                         02S0480
*  DO;                                 /*YES, PROCESS                */
*    UCBSLGN = (ALCNUCBS * TWO) + TWO; /*CALCULATE SIZE OF UCB LIST  */
         L     @08,@PC00001                                     02S0482
         L     @08,ALCWAPTR(,@08)                               02S0482
         L     @08,ALCNUCBS(,@08)                               02S0482
         ALR   @08,@08                                          02S0482
         AH    @08,@CH00134                                     02S0482
         ST    @08,UCBSLGN                                      02S0482
*     /* ?GETSTORG (SUBP,UCBSLGN,UCBLISTP);*/                   02S0483
*       RFY (GTSTR0,GTSTR1,GTSTR2) RSTD; /*SAVE RGS*/           02S0483
*       GTSTR0 = UCBSLGN; /* SET AMOUNT*/                       02S0484
         LR    GTSTR0,@08                                       02S0484
*       GTSTR2 = SUBP; /* SET SUBPOOL*/                         02S0485
         LA    GTSTR2,230                                       02S0485
*       GENERATE CODE;                                          02S0486
         GETMAIN RC,LV=(0),SP=(2)  DO GETMAIN
*       GTSTRTCD = GTSTR15; /* SAVE GETMAIN RET COD*/           02S0487
         LR    GTSTRTCD,GTSTR15                                 02S0487
*       UCBLISTP = GTSTR1; /* ADDR OF GOTN STORG*/              02S0488
         ST    GTSTR1,UCBLISTP                                  02S0488
*       RFY (GTSTR0,GTSTR1,GTSTR2) UNRSTD; /*RLSE */            02S0489
*       IF GTSTRTCD = 0 THEN /*GETMAIN SUCCESSFUL? */           02S0490
         LTR   GTSTRTCD,GTSTRTCD                                02S0490
         BNZ   @RF00490                                         02S0490
*         DO;               /* YES, CLEAR STORAGE.*/            02S0491
*           RFY (GTSTR2,GTSTR4,GTSTR5,GTSTR6,                   02S0492
*                              GTSTR7,GTSTR8) RSTD;             02S0492
*           GTSTR4 = UCBLISTP; /*STORG PTR*/                    02S0493
         L     @03,UCBLISTP                                     02S0493
         LR    GTSTR4,@03                                       02S0493
*           GTSTR5 = UCBSLGN; /*STORG AMNT*/                    02S0494
         L     GTSTR5,UCBSLGN                                   02S0494
*           GTSTR7 = '00000000'X; /*PAD CHAR & LNTH*/           02S0495
         SLR   GTSTR7,GTSTR7                                    02S0495
*           IF SUBP = GTST253 THEN                              02S0496
         B     @RF00496                                         02S0496
*          GEN                                                  02S0497
*       (MODESET KEYADDR=GTSTZERO,SAVEKEY=(2),WORKREG=8);       02S0497
         MODESET KEYADDR=GTSTZERO,SAVEKEY=(2),WORKREG=8
*           GEN REFS(GTSTR4,GTSTR6);                            02S0498
@RF00496 DS    0H                                               02S0498
              MVCL  GTSTR4,GTSTR6 CLEAR GOTTEN STORG
*           IF SUBP = GTST253 THEN                              02S0499
         B     @RF00499                                         02S0499
*             GEN (MODESET KEYADDR=(2));                        02S0500
         MODESET KEYADDR=(2)
*           RFY (GTSTR2,GTSTR4,GTSTR5,GTSTR6,                   02S0501
*                              GTSTR7,GTSTR8) UNRSTD;           02S0501
@RF00499 DS    0H                                               02S0502
*         END;       /* STORAGE CLEARING COMPLETED */           02S0502
*       ELSE                                                    02S0503
*       UCBLISTP= 0;   /* CLEAR RETURN ADDR. */                 02S0503
         B     @RC00490                                         02S0503
@RF00490 SLR   @08,@08                                          02S0503
         ST    @08,UCBLISTP                                     02S0503
*       GTSTR15 = GTSTRTCD;    /* GTMN RETURN CODE */           02S0504
@RC00490 LR    GTSTR15,GTSTRTCD                                 02S0504
*                                      /* RESTORE LIST PRINT STATUS  */
*/*GET CORE FOR LIST           */                               02S0505
*    RTNCODE = REG15;                  /*SAVE THE RETURN CODE        */
         LR    RTNCODE,REG15                                    02S0505
*    IF RTNCODE = SUCCESS THEN         /*ANY ERRORS ?                */
         LTR   RTNCODE,RTNCODE                                  02S0506
         BNZ   @RF00506                                         02S0506
*      DO;                             /*NO, PROCESS                 */
*        FILLIST = ON;                 /*INDICATE 'FILL IN LIST' FUNC*/
         OI    FILLIST,B'01000000'                              02S0508
*        CALL SCRAMLST;                /*FILL IN CANDIDATE LIST      */
         BAL   @14,SCRAMLST                                     02S0509
*        PSUCBP(MAXMNTS + ONE) = ZERO; /*INDICATE LAST LIST ENTRY    */
         LR    @05,MAXMNTS                                      02S0510
         ALR   @05,@05                                          02S0510
         L     @01,UCBLISTP                                     02S0510
         ALR   @01,@05                                          02S0510
         SLR   @05,@05                                          02S0510
         STH   @05,PSUCBP(,@01)                                 02S0510
*        FUNCMAP1 = FUNCMAP1 && FUNCMAP1; /*CLR FUNC MAP     @ZA03616*/
         XC    FUNCMAP1(1),FUNCMAP1                             02S0511
*        PUBSTOR = ON;                 /*PUB TO PUB & STRG   @ZA03616*/
*        MOUNTED = ON;                 /*ALLOC TO MTDS       @ZA03616*/
         OI    PUBSTOR,B'00101000'                              02S0513
*        IF DOPRTAL = ON THEN          /*DO SECONDARY ONLY   @ZA03616*/
         TM    DOPRTAL,B'00001000'                              02S0514
         BNO   @RF00514                                         02S0514
*          PARTALOC = ON;              /*TELL 436            @ZA03616*/
         OI    PARTALOC,B'00000001'                             02S0515
*        CALL IEFAB436 (ALCWAPTR,UCBLISTP,ADDR(FUNCLIST));      02S0516
@RF00514 L     @02,@PC00001                                     02S0516
         ST    @02,@AL00001                                     02S0516
         LA    @02,UCBLISTP                                     02S0516
         ST    @02,@AL00001+4                                   02S0516
         LA    @02,FUNCLIST                                     02S0516
         ST    @02,@TF00001                                     02S0516
         LA    @02,@TF00001                                     02S0516
         ST    @02,@AL00001+8                                   02S0516
         L     @15,@CV00167                                     02S0516
         LA    @01,@AL00001                                     02S0516
         BALR  @14,@15                                          02S0516
*        RTNCODE = REG15;              /*SAVE THE RETURN CODE        */
         LR    RTNCODE,REG15                                    02S0517
*        RFY (REG0,REG1) RSTD;                                  02S0518
*        REG0 = UCBSLGN;               /*LENGTH OF UCB LIST          */
         L     REG0,UCBSLGN                                     02S0519
*        REG0 = REG0 | SUBP230;                                 02S0520
         O     REG0,@CF00158                                    02S0520
*        REG1 = UCBLISTP;              /*PTR TO UCB LIST             */
         L     REG1,UCBLISTP                                    02S0521
*        GEN ( FREEMAIN R,LV=(0),A=(1)); /*FREE THE UCB LIST         */
          FREEMAIN R,LV=(0),A=(1)
*        RFY (REG0,REG1) UNRSTD;                                02S0523
*      END;                                                     02S0524
*    ELSE                              /*GETMAIN ERROR               */
*      DO;                                                      02S0525
         B     @RC00506                                         02S0525
@RF00506 DS    0H                                               02S0526
*        REASONCD = GETMNERR;          /*SET GETMAIN ERROR REASON CD */
         L     @02,@PC00001                                     02S0526
         L     @02,ALCWAPTR(,@02)                               02S0526
         L     @02,FAILRSCP(,@02)                               02S0526
         MVC   REASONCD(2,@02),@CH00134                         02S0526
*      END;                                                     02S0527
*  END;                                                         02S0528
*ELSE;                                 /*NO CANDIDATES FOR IEFAB436  */
@RF00480 DS    0H                                               02S0530
*END SCRATMNT;                         /*                    @ZA03616*/
@EL00004 DS    0H                                               02S0530
@EF00004 DS    0H                                               02S0530
@ER00004 LM    @14,@02,@SA00004                                 02S0530
         LM    @04,@12,@SA00004+20                              02S0530
         BR    @14                                              02S0530
*END IEFAB485                          /*END OF RECOVERY ALLOCATION  */
*/* THE FOLLOWING INCLUDE STATEMENTS WERE FOUND IN THIS PROGRAM.      *
*/*%INCLUDE SYSLIB  (A485SPEC)                                        *
*/*%INCLUDE SYSLIB  (A485DATA)                                        *
*/*%INCLUDE SYSLIB  (IEFZB421)                                        *
*/*%INCLUDE SYSLIB  (IEFZB422)                                        *
*/*%INCLUDE SYSLIB  (IEFZB423)                                        *
*/*%INCLUDE SYSLIB  (IEFZB425)                                        *
*/*%INCLUDE SYSLIB  (IEFZB426)                                        *
*/*%INCLUDE SYSLIB  (IEFZB427)                                        *
*/*%INCLUDE SYSLIB  (IEFZB428)                                        *
*/*%INCLUDE SYSLIB  (IEFZB431)                                        *
*/*%INCLUDE SYSLIB  (IEFUCBOB)                                        *
*/*%INCLUDE SYSLIB  (IEFASIOT)                                        *
*/*%INCLUDE SYSLIB  (TAPEVALI)                                        *
*/*%INCLUDE SYSLIB  (TVALSPEC)                                        *
*/*%INCLUDE SYSLIB  (ALOCMTDS)                                        *
*/*%INCLUDE SYSLIB  (ALOCSPEC)                                        *
*/*%INCLUDE SYSLIB  (DADAFFER)                                        *
*/*%INCLUDE SYSLIB  (DADASPEC)                                        *
*/*%INCLUDE SYSLIB  (DAFERALC)                                        *
*/*%INCLUDE SYSLIB  (DALCSPEC)                                        *
*/*%INCLUDE SYSLIB  (SCRATALG)                                        *
*/*%INCLUDE SYSLIB  (SALGSPEC)                                        *
*/*%INCLUDE SYSLIB  (PICSCRAG)                                        *
*/*%INCLUDE SYSLIB  (PICKSPEC)                                        *
*/*%INCLUDE SYSLIB  (SCRAMLST)                                        *
*/*%INCLUDE SYSLIB  (SLSTSPEC)                                        *
*/*%INCLUDE SYSLIB  (DAFERLST)                                        *
*/*%INCLUDE SYSLIB  (DLSTSPEC)                                        *
*/*%INCLUDE SYSLIB  (SCRATMNT)                                        *
*/*%INCLUDE SYSLIB  (SMNTSPEC)                                        *
*;                                                              01S0531
@DATA    DS    0H
@CH00055 DC    H'1'
@CH00134 DC    H'2'
@CH00064 DC    H'4'
@CH00140 DC    H'6'
@CH00033 DC    H'12'
@CH00138 DC    H'56'
@SX01149 XC    WAITMASK(0,@01),WAITMASK(@01)
@DATD    DSECT
         DS    0F
@SA00001 DS    18F
@PC00001 DS    1F
@SA00004 DS    14F
@AL00001 DS    3A
@TF00001 DS    F
IEFAB485 CSECT
         DS    0F
@CF01135 DC    F'28'
@CH01135 EQU   @CF01135+2
@CF00158 DC    XL4'E6000000'
@DATD    DSECT
         DS    0D
UCBLISTP DS    A
VMVREQBP DS    A
GENCTR   DS    F
GRPCTR   DS    F
EDTPTR   DS    A
GRPPTR   DS    A
EDLGNTP  DS    A
EDLUCBLP DS    A
ALCBITS  DS    BL1
         ORG   ALCBITS
CALLREAR DS    BL1
DONESW   EQU   ALCBITS+0
NEED433  EQU   ALCBITS+0
NEED436  EQU   ALCBITS+0
DOPRTAL  EQU   ALCBITS+0
ALCSTOR  EQU   ALCBITS+0
ALCPUB   EQU   ALCBITS+0
CALLALOC EQU   ALCBITS+0
         ORG   ALCBITS+1
         DS    CL3
FUNCLIST DS    CL8
         ORG   FUNCLIST
FUNCMAP1 DS    BL1
         ORG   FUNCMAP1
PSPUB    DS    BL1
PSSTRG   EQU   FUNCMAP1+0
PUBSTOR  EQU   FUNCMAP1+0
PERMRES  EQU   FUNCMAP1+0
MOUNTED  EQU   FUNCMAP1+0
ONEGNRIC EQU   FUNCMAP1+0
PSVLSWOK EQU   FUNCMAP1+0
PARTALOC EQU   FUNCMAP1+0
         ORG   FUNCLIST+1
@NM00001 DS    AL3
UCBSLGN  DS    FL4
         ORG   FUNCLIST+8
FUNC476  DS    BL1
FUNC477  DS    BL1
         ORG   FUNC477
UNLDPMNT DS    BL1
DONTUNLD EQU   FUNC477+0
         ORG   FUNC477+1
FUNC479  DS    BL1
         ORG   FUNC479
@NM00002 DS    BL1
VOLSWOK  EQU   FUNC479+0
DOSPEC   EQU   FUNC479+0
         ORG   FUNC479+1
GENPICK  DS    CL4
SWITCHES DS    BL2
         ORG   SWITCHES
DADERRSW DS    BL1
FILLIST  EQU   SWITCHES+0
NEEDTALC EQU   SWITCHES+0
NEEDMND  EQU   SWITCHES+0
SNEEDALG EQU   SWITCHES+0
SNEEDMNT EQU   SWITCHES+0
USEUCBSW EQU   SWITCHES+0
VOLFND   EQU   SWITCHES+0
ANYCANDS DS    BL1
@NM00003 EQU   SWITCHES+1
         ORG   SWITCHES+2
UNLKMASK DS    CL240
VMVRB    DS    CL52
IEFAB485 CSECT
         DS    0F
@SIZDATD DC    AL1(230)
         DC    AL3(@ENDDATD-@DATD)
@CV00166 DC    V(IEFAB433)
@CV00167 DC    V(IEFAB436)
@CV00168 DC    V(IEFAB476)
@CV00169 DC    V(IEFAB479)
@CV00171 DC    V(IEFAB477)
@CV00172 DC    V(IEFAB481)
@CV00173 DC    V(IEFAB486)
@CV00174 DC    V(IEFAB4FA)
@CA00170 DC    A(IEFAB49C)
         DS    0D
GTSTZERO DC    F'0'
LUTEND   DC    XL2'FFFF'
FUNC433  DC    B'00001010'
PUBFUNC  DC    B'00101000'
SCRAT476 DC    B'00001000'
STORFUNC DC    B'01010000'
TAPE476  DC    B'00001000'
IEFAB485 CSECT
         DS   0H
PATCHLOC DC ((@DATA-@PSTART)/20)X'00'
@DATD    DSECT
         ORG   *+1-(*-@DATD)/(*-@DATD) INSURE DSECT DATA
@ENDDATD EQU   *
IEFAB485 CSECT
@00      EQU   00                      EQUATES FOR REGISTERS 0-15
@01      EQU   01
@02      EQU   02
@03      EQU   03
@04      EQU   04
@05      EQU   05
@06      EQU   06
@07      EQU   07
@08      EQU   08
@09      EQU   09
@10      EQU   10
@11      EQU   11
@12      EQU   12
@13      EQU   13
@14      EQU   14
@15      EQU   15
GTSTRTCD EQU   @09
VUCTR    EQU   @06
UCBCTR   EQU   @09
SAVAFID  EQU   @07
RTNCODE  EQU   @03
MOSTNUM  EQU   @05
MAXMNTS  EQU   @04
MASKBYTE EQU   @02
LUTNO    EQU   @05
AREQCTR  EQU   @04
EGENCTR  EQU   @07
VUPTR    EQU   @02
UCBPTR   EQU   @03
SIOTPTR  EQU   @04
LUVPTR   EQU   @08
GRPTABP  EQU   @07
GENPTR   EQU   @05
EDLPTR   EQU   @04
AREQPTR  EQU   @02
REG0     EQU   @00
REG1     EQU   @01
REG15    EQU   @15
GTSTR0   EQU   @00
GTSTR1   EQU   @01
GTSTR2   EQU   @02
GTSTR15  EQU   @15
GTSTR4   EQU   @04
GTSTR5   EQU   @05
GTSTR6   EQU   @06
GTSTR7   EQU   @07
GTSTR8   EQU   @08
GTSTR3   EQU   @03
         EXTRN IEFAB49C
PSUCBP   EQU   0
IOSLUT   EQU   0
KEEPMASK EQU   0
REASONCD EQU   0
VERIFYMK EQU   0
WAITMASK EQU   0
EDTHDR   EQU   0
EDTLUVSP EQU   EDTHDR
EDTGENSP EQU   EDTHDR+4
EDTGRPSP EQU   EDTHDR+8
EDTUCBSP EQU   EDTHDR+12
EDTMSKTP EQU   EDTHDR+16
LUVSECT  EQU   0
LUVHDR   EQU   LUVSECT
LUVENTNO EQU   LUVHDR
LUVENTLN EQU   LUVHDR+4
LUVENTRY EQU   0
LUVGMTP  EQU   LUVENTRY+12
LUVGENNO EQU   LUVENTRY+16
LUVGENP  EQU   LUVENTRY+20
LUVFLAGS EQU   LUVENTRY+24
GENSECT  EQU   0
GENHDR   EQU   GENSECT
GENENTRY EQU   0
GENGRPNO EQU   GENENTRY+4
GENGRPTR EQU   GENENTRY+8
GRPTRTAB EQU   0
GRPTR    EQU   GRPTRTAB
GRPSECT  EQU   0
GRPHDR   EQU   GRPSECT
GRPENTRY EQU   0
GRPUCBNO EQU   GRPENTRY+4
GRPUCBP  EQU   GRPENTRY+8
EUCBSECT EQU   0
EUCBHDR  EQU   EUCBSECT
EUCBENTY EQU   0
EUCBTPOS EQU   EUCBENTY
GRMSKTAB EQU   0
GMTHDR   EQU   GRMSKTAB
GMTENTLN EQU   GMTHDR+4
GMTENTRY EQU   0
IEFEDL   EQU   0
EDLHDR   EQU   IEFEDL
EDLGENNO EQU   EDLHDR+4
EDLFGENP EQU   EDLHDR+8
EDLUVFLG EQU   EDLHDR+16
EDLMGENS EQU   EDLUVFLG
EDLENTRY EQU   0
EDLNXTNT EQU   EDLENTRY
EDLDEVT  EQU   EDLENTRY+4
EDLNSCNT EQU   EDLENTRY+16
EDLDTFLG EQU   EDLENTRY+20
EINDEVTP EQU   EDLDTFLG
EDLGNTRY EQU   0
EDLGRFLG EQU   EDLGNTRY+16
EDLUCBL  EQU   0
EDLINDIC EQU   EDLUCBL+2
VOLUNTAB EQU   0
VOLSTAT  EQU   VOLUNTAB+6
VOLSTATA EQU   VOLSTAT
VOLPUB   EQU   VOLSTATA
VOLPRV   EQU   VOLSTATA
VOLSTG   EQU   VOLSTATA
VOLSTATB EQU   VOLSTAT+1
VOLALOC  EQU   VOLSTATB
VDEVREQD EQU   VOLSTATB
VUDNALOC EQU   VOLSTATB
VUDADSME EQU   VOLSTATB
VUVINELG EQU   VOLSTATB
VOLSTATC EQU   VOLSTAT+2
VURECVRY EQU   VOLSTATC
VOLSTATD EQU   VOLSTAT+3
VUREALOC EQU   VOLSTATD
VOLALGTP EQU   VOLUNTAB+12
VOLSIOTP EQU   VOLUNTAB+16
VUUCBP   EQU   VOLUNTAB+20
VUGRID   EQU   VOLUNTAB+24
VUPOOL   EQU   0
VUGRLST  EQU   0
VUGRLENT EQU   VUGRLST
VUGRLFLG EQU   VUGRLENT+4
ALCWA    EQU   0
FMAPPTR  EQU   ALCWA+4
SIOT1P   EQU   ALCWA+8
IOSLUTP  EQU   ALCWA+16
FAILRSCP EQU   ALCWA+20
EDTABPTR EQU   ALCWA+24
CNTABLE  EQU   ALCWA+28
TOTREQS  EQU   CNTABLE+36
VOLUNPTR EQU   ALCWA+80
VOLUNSZE EQU   ALCWA+84
ALGTABP  EQU   ALCWA+88
QMGRRBP  EQU   ALCWA+108
INDICATE EQU   ALCWA+112
INDWAIT  EQU   INDICATE
DSSTAPE  EQU   INDICATE
@NM00011 EQU   ALCWA+113
WAITIGEN EQU   @NM00011
ALCWAREC EQU   @NM00011
TIOTHDRP EQU   ALCWA+120
WMASKPTR EQU   ALCWA+128
WMASK2P  EQU   ALCWA+132
WORK3MP  EQU   ALCWA+136
CANCELP  EQU   ALCWA+140
EXITPRMP EQU   ALCWA+144
ALCNUCBS EQU   ALCWA+148
NAMES    EQU   0
ALGPTRS  EQU   0
ALGPARMP EQU   ALGPTRS
ALGRQLTP EQU   ALGPTRS+4
CVRPARM  EQU   0
CVRNREQ  EQU   CVRPARM+4
CVRFLG1  EQU   CVRPARM+8
CVRRQLST EQU   0
CVRVUPTR EQU   CVRRQLST
CVRNEED  EQU   CVRRQLST+8
CVRMIN   EQU   CVRRQLST+10
CVRFLG2  EQU   CVRRQLST+16
CVRSKFLG EQU   CVRFLG2
CVRSCRTH EQU   CVRFLG2
CVRIGNOR EQU   CVRFLG2
CVRDUPLI EQU   CVRFLG2+1
CVRWUCBP EQU   CVRRQLST+24
CVRGPLST EQU   0
CVRFLG3  EQU   CVRGPLST+12
GRPCOUNT EQU   0
AQMPARAM EQU   0
AQMECODE EQU   AQMPARAM
AQMMASKP EQU   AQMPARAM+4
AQMNORMP EQU   AQMPARAM+20
FUNCMAP  EQU   0
VOLMNTSW EQU   FUNCMAP
WRTMSGSW EQU   FUNCMAP
UWAITSW  EQU   FUNCMAP
VWAITSW  EQU   FUNCMAP
MSSTRMSW EQU   FUNCMAP
OFFDEVSW EQU   FUNCMAP
CCLMNTSW EQU   FUNCMAP
GENLOKSW EQU   FUNCMAP
SSEMSGSW EQU   FUNCMAP+1
HDRMSGSW EQU   FUNCMAP+1
MTRJOBSW EQU   FUNCMAP+1
NOTIOTNQ EQU   FUNCMAP+1
TRKMSW   EQU   FUNCMAP+1
WAITOKSW EQU   FUNCMAP+1
ASNMSW   EQU   FUNCMAP+1
VMVRQBLK EQU   0
VMVFNMAP EQU   VMVRQBLK
VMVOPTB1 EQU   VMVFNMAP
VMVOPTB2 EQU   VMVFNMAP+1
VMVOPTB3 EQU   VMVFNMAP+2
VMVMINFO EQU   VMVRQBLK+40
VMVACTON EQU   VMVMINFO
VMVUSER  EQU   VMVRQBLK+48
UCB      EQU   0
UCBOB    EQU   0
UCBJBNR  EQU   UCBOB
UCBFL5   EQU   UCBOB+1
UCBAF    EQU   UCBFL5
UCBNALOC EQU   UCBFL5
UCBSTAT  EQU   UCBOB+3
UCBONLI  EQU   UCBSTAT
UCBCHGS  EQU   UCBSTAT
UCBUNLD  EQU   UCBSTAT
UCBALOC  EQU   UCBSTAT
UCBCHAN  EQU   UCBOB+4
UCBSFLS  EQU   UCBOB+6
UCBFLA   EQU   UCBSFLS
UCBFL1   EQU   UCBFLA
UCBBSY   EQU   UCBFL1
UCBNRY   EQU   UCBFL1
UCBNOTRD EQU   UCBNRY
UCBPST   EQU   UCBFL1
UCBCUB   EQU   UCBFL1
UCBFLB   EQU   UCBSFLS+1
UCBCHM   EQU   UCBOB+8
UCBCHM1  EQU   UCBCHM
UCBPTH0  EQU   UCBCHM1
UCBPTH1  EQU   UCBCHM1
UCBWGT   EQU   UCBOB+12
UCBTYP   EQU   UCBOB+16
UCBTBYT1 EQU   UCBTYP
UCB1FEA5 EQU   UCBTBYT1
UCB1FEA6 EQU   UCBTBYT1
UCBTBYT2 EQU   UCBTYP+1
UCB2OPT2 EQU   UCBTBYT2
UCBDUDN1 EQU   UCB2OPT2
UCB2OPT3 EQU   UCBTBYT2
UCBDUDN2 EQU   UCB2OPT3
UCB2OPT4 EQU   UCBTBYT2
UCBRWTAU EQU   UCB2OPT4
UCB2OPT6 EQU   UCBTBYT2
UCB2OPT7 EQU   UCBTBYT2
UCBTBYT3 EQU   UCBTYP+2
UCBDVCLS EQU   UCBTBYT3
UCB3TAPE EQU   UCBDVCLS
UCB3DACC EQU   UCBDVCLS
UCBTBYT4 EQU   UCBTYP+3
UCBEXTPT EQU   UCBOB+20
UCBFLC   EQU   UCBEXTPT
UCBDEV   EQU   UCBOB+24
UCBCMEXT EQU   0
UCBATI   EQU   UCBCMEXT+3
@NM00027 EQU   UCBATI
UCBFLP1  EQU   UCBCMEXT+5
UCBMT    EQU   0
UCBOCR   EQU   0
UCB3540X EQU   0
UCBDKBYT EQU   UCB3540X+6
UCB3800X EQU   0
UCBOPTNS EQU   UCB3800X
UCBACTIV EQU   UCB3800X+3
UCBMDRBF EQU   UCB3800X+36
UCBUCS   EQU   0
UCBUCSOP EQU   UCBUCS+4
UCBFCBOP EQU   UCBUCS+5
INDMSIOT EQU   0
SCTUSADD EQU   INDMSIOT+20
SIOTAFID EQU   INDMSIOT+26
SIOPSCNT EQU   INDMSIOT+42
SIOTBYT1 EQU   INDMSIOT+43
SIOTBYT3 EQU   INDMSIOT+46
SIOTTSTC EQU   INDMSIOT+47
SIOTBYT0 EQU   INDMSIOT+52
SIOTGIGN EQU   SIOTBYT0
SCTSDISP EQU   INDMSIOT+55
SCTSBYT1 EQU   INDMSIOT+56
SCTSBYT2 EQU   INDMSIOT+57
SCTSBYT3 EQU   INDMSIOT+58
SCTSBYT4 EQU   INDMSIOT+59
SCTUTYPE EQU   INDMSIOT+60
SIOTDEVT EQU   SCTUTYPE
SIOUBYT3 EQU   SIOTDEVT+2
SIOTBYT4 EQU   INDMSIOT+81
SIOTALTD EQU   INDMSIOT+92
SIOTBYT2 EQU   INDMSIOT+103
SIOTDMND EQU   SIOTBYT2
SIOTRSNC EQU   INDMSIOT+130
SIOTEDLP EQU   INDMSIOT+136
SVOLUNAD EQU   INDMSIOT+140
SIOTNPTR EQU   INDMSIOT+152
CANCLECB EQU   0
UCBBGN   EQU   0
ALCWAPTR EQU   0
UCBOBS01 EQU   UCBDEV
UCBSTAB  EQU   UCBOBS01+10
UCBBSVL  EQU   UCBSTAB
UCBPRSRS EQU   UCBSTAB
UCBBPRV  EQU   UCBSTAB
UCBBPUB  EQU   UCBSTAB
UCBBSTR  EQU   UCBSTAB
UCBDMCT  EQU   UCBOBS01+11
UCBMOUNT EQU   UCBDMCT
UCBFL4   EQU   UCBOBS01+13
UCBOBS02 EQU   UCBDEV
UCBTFL1  EQU   UCBOBS02+19
UCBXTN   EQU   UCBOBS02+20
UCBVOPT  EQU   UCBXTN
UCBOBS03 EQU   UCBDEV
UCBXTADR EQU   UCBOBS03
UCBOBS04 EQU   UCBDEV
UCBBTA   EQU   UCBOBS04+12
UCBOBS06 EQU   UCBDEV
UCBAOF   EQU   UCBOBS06
UCBAOF1  EQU   UCBAOF
UCBAOF2  EQU   UCBAOF+1
@NM00026 EQU   UCBOBS06+3
UCBIRB   EQU   UCBOBS06+4
UCBGRAF  EQU   UCBIRB
UCBLDNCA EQU   UCBOBS06+8
UCBRDYQ  EQU   UCBLDNCA
UCBIRLN  EQU   UCBRDYQ
UCBLDNCB EQU   UCBRDYQ+1
UCBCTLNK EQU   UCBOBS06+12
UCBOBS07 EQU   UCBDEV
UCBOBS08 EQU   UCBDEV
UCBCTCAD EQU   UCBOBS08
UCBCTCF1 EQU   UCBOBS08+4
UCBOBS09 EQU   UCBDEV
         AGO   .@UNREFD                START UNREFERENCED COMPONENTS
UCBRV066 EQU   UCBOBS09+4
UCBIOSBA EQU   UCBOBS09
UCBRV042 EQU   UCBOBS08+5
UCBRV082 EQU   UCBCTCF1
UCBRV081 EQU   UCBCTCF1
UCBRV080 EQU   UCBCTCF1
UCBRV079 EQU   UCBCTCF1
UCBRV078 EQU   UCBCTCF1
UCBRV077 EQU   UCBCTCF1
UCBRV076 EQU   UCBCTCF1
UCBCTC80 EQU   UCBCTCF1
UCBCTCAL EQU   UCBCTCAD
UCBICNCB EQU   UCBOBS07+4
UCBRV040 EQU   UCBOBS07
UCBCTLNA EQU   UCBCTLNK+1
UCBRLN   EQU   UCBCTLNK
UCBRDYQA EQU   UCBLDNCB
UCBINRLN EQU   UCBIRLN
UCBIRBA  EQU   UCBIRB+1
UCBRV039 EQU   UCBGRAF
UCBDWNR  EQU   UCBGRAF
UCBRPND  EQU   UCBGRAF
UCBUPM   EQU   UCBGRAF
UCBBTAM  EQU   UCBGRAF
UCBDRNO  EQU   UCBGRAF
UCBDRO   EQU   UCBGRAF
UCBOIP   EQU   UCBGRAF
UCBATRCD EQU   @NM00026
UCBSKPFG EQU   @NM00026
UCBRIPND EQU   @NM00026
UCBRTIAC EQU   @NM00026
UCBRSV79 EQU   @NM00026
UCBRSV78 EQU   @NM00026
UCBRSV77 EQU   @NM00026
UCBOLTEP EQU   @NM00026
UCBATNCT EQU   UCBOBS06+2
UCBRSV76 EQU   UCBAOF2
UCBRSV75 EQU   UCBAOF2
UCBRSV74 EQU   UCBAOF2
UCBRSV73 EQU   UCBAOF2
UCBRSV72 EQU   UCBAOF2
UCBRSV71 EQU   UCBAOF2
UCBRSV70 EQU   UCBAOF2
UCBRSV69 EQU   UCBAOF2
UCBRSV68 EQU   UCBAOF1
UCBRSV67 EQU   UCBAOF1
UCBRSV66 EQU   UCBAOF1
UCBRSV65 EQU   UCBAOF1
UCBRSV64 EQU   UCBAOF1
UCBOFNL  EQU   UCBAOF1
UCBOFSP  EQU   UCBAOF1
UCBOFMCR EQU   UCBAOF1
UCBBTB   EQU   UCBBTA+1
UCBDI    EQU   UCBBTA
UCBSNS   EQU   UCBOBS04+8
UCBTEB   EQU   UCBOBS04+4
UCBGCB   EQU   UCBOBS04+3
UCBOPEN  EQU   UCBOBS04+2
UCBSTART EQU   UCBOBS04
UCBXTNB  EQU   UCBXTN+1
UCBRSV22 EQU   UCBVOPT
UCBRSV21 EQU   UCBVOPT
UCBRSV20 EQU   UCBVOPT
UCBESVE  EQU   UCBVOPT
UCBERPC  EQU   UCBVOPT
UCBESVC  EQU   UCBVOPT
UCBEVA   EQU   UCBVOPT
UCBESV   EQU   UCBVOPT
UCBRV009 EQU   UCBTFL1
UCBRV008 EQU   UCBTFL1
UCBRV007 EQU   UCBTFL1
UCBRV006 EQU   UCBTFL1
UCBRV005 EQU   UCBTFL1
UCBDQDSP EQU   UCBTFL1
UCBNSLTP EQU   UCBTFL1
UCBNLTP  EQU   UCBTFL1
UCBRES1B EQU   UCBOBS02+18
UCBFSER  EQU   UCBOBS02+12
@NM00025 EQU   UCBOBS02+4
UCBFSEQ  EQU   UCBOBS02+2
UCBFSCT  EQU   UCBOBS02
UCBNEXP  EQU   UCBOBS01+20
UCBBASE  EQU   UCBOBS01+16
UCBRES1A EQU   UCBOBS01+15
UCBUSER  EQU   UCBOBS01+14
UCBFL47  EQU   UCBFL4
UCBFL46  EQU   UCBFL4
UCBFL45  EQU   UCBFL4
UCBRV065 EQU   UCBFL4
UCBDSS   EQU   UCBFL4
UCBRESVP EQU   UCBFL4
UCBWDAV  EQU   UCBFL4
UCBDAVV  EQU   UCBFL4
UCBSQC   EQU   UCBOBS01+12
UCBDATP  EQU   UCBOBS01+12
UCBDMC   EQU   UCBDMCT
UCBBNUL  EQU   UCBSTAB
UCBSHAR  EQU   UCBSTAB
UCBBALB  EQU   UCBPRSRS
UCBPGFL  EQU   UCBSTAB
UCBDVSHR EQU   UCBBSVL
UCBVOLI  EQU   UCBOBS01+4
UCBVTOC  EQU   UCBOBS01
SIODDSNL EQU   INDMSIOT+173
SIOVDSNL EQU   INDMSIOT+172
SIOVDSNT EQU   INDMSIOT+170
SVOLUNNO EQU   INDMSIOT+168
SIOTVMVP EQU   INDMSIOT+164
SIOTJFX  EQU   INDMSIOT+160
SJFCBPTR EQU   INDMSIOT+156
SIOTETIO EQU   INDMSIOT+148
SIOTATE  EQU   INDMSIOT+144
SIOTEDLS EQU   INDMSIOT+132
SCTANAME EQU   INDMSIOT+122
SIOTSSIC EQU   INDMSIOT+120
@NM00040 EQU   INDMSIOT+108
SIOTSSNM EQU   INDMSIOT+104
@NM00039 EQU   SIOTBYT2
SIOTCVOL EQU   SIOTBYT2
SIOTCNEW EQU   SIOTBYT2
SIOTCALC EQU   SIOTBYT2
SIOTGALL EQU   SIOTBYT2
SIOTDSPD EQU   SIOTBYT2
SIOTOPUC EQU   INDMSIOT+99
SIOTOUTR EQU   INDMSIOT+97
SIOTOUTC EQU   INDMSIOT+96
SIOTSSWA EQU   INDMSIOT+93
SIOTAUNC EQU   SIOTALTD
SIOTACAT EQU   SIOTALTD
SIOTADEL EQU   SIOTALTD
SIOTAKEP EQU   SIOTALTD
SIOTNPRV EQU   SIOTALTD
SIOJCATS EQU   SIOTALTD
@NM00038 EQU   SIOTALTD
@NM00037 EQU   SIOTALTD
@NM00036 EQU   INDMSIOT+91
SIOTNDSB EQU   INDMSIOT+88
@NM00035 EQU   INDMSIOT+84
SIOTDPCD EQU   INDMSIOT+82
@NM00034 EQU   SIOTBYT4
SIOTRACT EQU   SIOTBYT4
SIOTRACD EQU   SIOTBYT4
SIOTPROT EQU   SIOTBYT4
SCTOUTPN EQU   INDMSIOT+80
SCTOUTNO EQU   INDMSIOT+76
SCTOUTNM EQU   INDMSIOT+68
SIOUCBAD EQU   SCTUTYPE+5
SIOUCNVT EQU   SCTUTYPE+4
SIOUBYT4 EQU   SIOTDEVT+3
@NM00033 EQU   SIOUBYT3
SIO3UREC EQU   SIOUBYT3
SIO3DISP EQU   SIOUBYT3
SIO3DACC EQU   SIOUBYT3
SIO3COMM EQU   SIOUBYT3
SIO3TAPE EQU   SIOUBYT3
SIOUBYT2 EQU   SIOTDEVT+1
SIOUBYT1 EQU   SIOTDEVT
SIOTOMN  EQU   SCTSBYT4
SIOTIPDI EQU   SCTSBYT4
SIOTVAFF EQU   SCTSBYT4
SIOTSTEP EQU   SCTSBYT4
SIOTASCI EQU   SCTSBYT4
@NM00032 EQU   SCTSBYT4
SIOTGDGA EQU   SCTSBYT4
SCTSGDGS EQU   SCTSBYT4
SCTSOLD  EQU   SCTSBYT3
SCTSMOD  EQU   SCTSBYT3
SCTSNEW  EQU   SCTSBYT3
SCTSYSOU EQU   SCTSBYT3
SCTVREF  EQU   SCTSBYT3
SCTALCHK EQU   SCTSBYT3
SCTSYSNE EQU   SCTSBYT3
SCTDSNRF EQU   SCTSBYT3
SCTRECVD EQU   SCTSBYT2
SCTDEFER EQU   SCTSBYT2
SCTLABEL EQU   SCTSBYT2
SCTUNLBD EQU   SCTSBYT2
SCTJOBLB EQU   SCTSBYT2
SCTVOLAF EQU   SCTSBYT2
SIOTCATL EQU   SCTSBYT2
SIOCLUNL EQU   SCTSBYT2
SIOTJSCT EQU   SCTSBYT1
SCTUNAFF EQU   SCTSBYT1
SCTPARLM EQU   SCTSBYT1
SIOTQDSN EQU   SCTSBYT1
SIOTGDSN EQU   SCTSBYT1
SIOTCCAT EQU   SCTSBYT1
SCTSYSIN EQU   SCTSBYT1
SCTDUMMY EQU   SCTSBYT1
SIOTUNCT EQU   SCTSDISP
SIOTCTLG EQU   SCTSDISP
SIOTDLET EQU   SCTSDISP
SIOTKEEP EQU   SCTSDISP
SIOTPASS EQU   SCTSDISP
SIOTPRIV EQU   SCTSDISP
S3400DSP EQU   SCTSDISP
SIOTRETN EQU   SCTSDISP
SIOTVLCT EQU   INDMSIOT+54
SCTNMBUT EQU   INDMSIOT+53
SIOTRTRY EQU   SIOTBYT0
SIOTPUPV EQU   SIOTBYT0
SIOTNOPV EQU   SIOTBYT0
SPVTAMSG EQU   SIOTBYT0
SIOTFUDA EQU   SIOTBYT0
SIOTDYAL EQU   SIOTBYT0
SIOTSSDS EQU   SIOTBYT0
SIOTGIID EQU   INDMSIOT+50
SCTVOLCT EQU   INDMSIOT+49
SCTSPOOL EQU   INDMSIOT+48
SIOTQNAM EQU   SIOTTSTC
SIOTDSNM EQU   SIOTTSTC
SIOTTRKM EQU   SIOTTSTC
SIOTSSMG EQU   SIOTTSTC
SIOTSSGP EQU   SIOTTSTC
@NM00031 EQU   SIOTTSTC
SIOTTERM EQU   SIOTTSTC
SIOTINFC EQU   SIOTTSTC
@NM00030 EQU   SIOTBYT3
SIOTDSID EQU   SIOTBYT3
S3400OFF EQU   SIOTBYT3
SIOTJES3 EQU   SIOTBYT3
SIOCDEVT EQU   SIOTBYT3
SIOALIAS EQU   SIOTBYT3
SCTDDINO EQU   INDMSIOT+44
SIOTDDNT EQU   SIOTBYT1
SIOTALCD EQU   SIOTBYT1
SIODADSM EQU   SIOTBYT1
SIOTDADR EQU   SIOTBYT1
SIODUNAL EQU   SIOTBYT1
SIOVAMDS EQU   SIOTBYT1
SIOTHOLD EQU   SIOTBYT1
SIOTOCKP EQU   SIOTBYT1
SIOTREFN EQU   INDMSIOT+40
SIOTOTUN EQU   INDMSIOT+39
SIOTVRSB EQU   INDMSIOT+36
@NM00029 EQU   INDMSIOT+35
SCTPJFCB EQU   INDMSIOT+32
@NM00028 EQU   INDMSIOT+31
SCTPSIOT EQU   INDMSIOT+28
SIOTVLSP EQU   INDMSIOT+24
SIODSNTE EQU   INDMSIOT+22
SIOTUNAF EQU   SCTUSADD
SIOTDEST EQU   INDMSIOT+12
SCTDDNAM EQU   INDMSIOT+4
SIOTTYPE EQU   INDMSIOT+3
SIOTDSKA EQU   INDMSIOT
UCBERADR EQU   UCBUCS+12
UCBFCBID EQU   UCBUCS+8
UCBERCNT EQU   UCBUCS+7
UCBRSV51 EQU   UCBUCS+6
UCBFCBPE EQU   UCBFCBOP
UCBRSV49 EQU   UCBFCBOP
UCBRSV48 EQU   UCBFCBOP
UCBRSV47 EQU   UCBFCBOP
UCBRSV46 EQU   UCBFCBOP
UCBRSV45 EQU   UCBFCBOP
UCBRSV44 EQU   UCBFCBOP
UCBFCBO1 EQU   UCBFCBOP
UCBUCSPE EQU   UCBUCSOP
UCBRSV43 EQU   UCBUCSOP
UCBRSV42 EQU   UCBUCSOP
UCBRSV41 EQU   UCBUCSOP
UCBRSV40 EQU   UCBUCSOP
UCBRSV39 EQU   UCBUCSOP
UCBUCSO2 EQU   UCBUCSOP
UCBUCSO1 EQU   UCBUCSOP
UCBUCSID EQU   UCBUCS
UCBMDRBA EQU   UCBMDRBF+1
UCBRV075 EQU   UCBMDRBF
UCBRV074 EQU   UCB3800X+32
UCBIMAGE EQU   UCB3800X+28
UCBFCBNM EQU   UCB3800X+24
UCBCHAR4 EQU   UCB3800X+20
UCBCHAR3 EQU   UCB3800X+16
UCBCHAR2 EQU   UCB3800X+12
UCBCHAR1 EQU   UCB3800X+8
UCBCGMID EQU   UCB3800X+4
UCBBRSTA EQU   UCBACTIV
UCBRV063 EQU   UCBACTIV
UCBRV062 EQU   UCBACTIV
UCBRV061 EQU   UCBACTIV
UCBRV060 EQU   UCBACTIV
UCBRV059 EQU   UCBACTIV
UCBRV058 EQU   UCBACTIV
UCBRV057 EQU   UCBACTIV
UCBRV050 EQU   UCB3800X+2
UCBCGMNO EQU   UCB3800X+1
UCBRV083 EQU   UCBOPTNS
UCBBRSTR EQU   UCBOPTNS
UCBRV056 EQU   UCBOPTNS
UCBRV055 EQU   UCBOPTNS
UCBRV054 EQU   UCBOPTNS
UCBRV053 EQU   UCBOPTNS
UCBRV052 EQU   UCBOPTNS
UCBRV051 EQU   UCBOPTNS
UCBRV073 EQU   UCB3540X+7
UCBRV072 EQU   UCBDKBYT
UCBRV071 EQU   UCBDKBYT
UCBRV070 EQU   UCBDKBYT
UCBRV069 EQU   UCBDKBYT
UCBRV068 EQU   UCBDKBYT
UCBRV067 EQU   UCBDKBYT
UCBVLVER EQU   UCBDKBYT
UCBDKAMX EQU   UCBDKBYT
UCBVLSER EQU   UCB3540X
UCBRDATA EQU   UCBOCR+4
UCBFRID  EQU   UCBOCR
UCBCLN   EQU   UCBMT+14
UCBERG   EQU   UCBMT+12
UCBMS    EQU   UCBMT+11
UCBNB    EQU   UCBMT+10
UCBPW    EQU   UCBMT+9
UCBPR    EQU   UCBMT+8
UCBSIO   EQU   UCBMT+6
UCBTW    EQU   UCBMT+5
UCBTR    EQU   UCBMT+4
UCBTWT   EQU   UCBMT+3
UCBTRT   EQU   UCBMT+2
UCBCTD   EQU   UCBMT
UCBWTOID EQU   UCBCMEXT+17
UCBRV043 EQU   UCBCMEXT+16
UCBASID  EQU   UCBCMEXT+14
UCBMFCNT EQU   UCBCMEXT+12
UCBPMSK  EQU   UCBCMEXT+10
UCBCCWOF EQU   UCBCMEXT+8
UCBRV041 EQU   UCBCMEXT+6
UCBRV036 EQU   UCBFLP1
UCBRV035 EQU   UCBFLP1
UCBERLOG EQU   UCBFLP1
UCBRV033 EQU   UCBFLP1
UCBINHIO EQU   UCBFLP1
UCBNSWAP EQU   UCBFLP1
UCBSHRUP EQU   UCBFLP1
UCBNSRCH EQU   UCBFLP1
UCBSNSCT EQU   UCBCMEXT+4
UCBHPDV  EQU   @NM00027
UCBHALI  EQU   @NM00027
UCBRSV09 EQU   @NM00027
UCBRSV08 EQU   @NM00027
UCBRSV07 EQU   @NM00027
UCBRSV06 EQU   @NM00027
UCBRSV05 EQU   @NM00027
UCBRSV04 EQU   @NM00027
UCBDTI   EQU   UCBCMEXT+2
UCBSTI   EQU   UCBCMEXT+1
UCBETI   EQU   UCBCMEXT
UCBEXTP  EQU   UCBEXTPT+1
UCBDDRSW EQU   UCBFLC
UCBTICBT EQU   UCBFLC
UCBIVRR  EQU   UCBFLC
UCBIVRS  EQU   UCBFLC
UCBITF   EQU   UCBFLC
UCBUDE   EQU   UCBFLC
UCBWAA   EQU   UCBFLC
UCBATTP  EQU   UCBFLC
UCBUNTYP EQU   UCBTBYT4
UCBRSV11 EQU   UCBDVCLS
UCBRSV10 EQU   UCBDVCLS
UCB3CHAR EQU   UCBDVCLS
UCB3UREC EQU   UCBDVCLS
UCB3DISP EQU   UCBDVCLS
UCB3COMM EQU   UCBDVCLS
UCBDVPWR EQU   UCB2OPT7
UCBVLPWR EQU   UCB2OPT6
UCB2OPT5 EQU   UCBTBYT2
UCBRVDEV EQU   UCBRWTAU
UCBRPS   EQU   UCBDUDN2
UCBRR    EQU   UCBDUDN1
UCB2OPT1 EQU   UCBTBYT2
UCB2OPT0 EQU   UCBTBYT2
UCB1FEA7 EQU   UCBTBYT1
UCBD6250 EQU   UCB1FEA6
UCBD1600 EQU   UCB1FEA5
UCB1FEA4 EQU   UCBTBYT1
UCB1FEA3 EQU   UCBTBYT1
UCB1FEA2 EQU   UCBTBYT1
UCB1FEA1 EQU   UCBTBYT1
UCB1FEA0 EQU   UCBTBYT1
UCBNAME  EQU   UCBOB+13
UCBRV029 EQU   UCBWGT
UCBVHRSN EQU   UCBWGT
UCBVORSN EQU   UCBWGT
UCBMTPXP EQU   UCBWGT
UCBREW   EQU   UCBWGT
UCBPUB   EQU   UCBWGT
UCBOUT   EQU   UCBWGT
UCBIN    EQU   UCBWGT
UCBCPU   EQU   UCBOB+11
UCBLCI   EQU   UCBOB+10
UCBCNT   EQU   UCBOB+9
UCBRV017 EQU   UCBCHM1
UCBRV016 EQU   UCBCHM1
UCBRV015 EQU   UCBCHM1
UCBRV014 EQU   UCBCHM1
UCBSPB   EQU   UCBPTH1
UCBPPB   EQU   UCBPTH1
UCBSPA   EQU   UCBPTH0
UCBPPA   EQU   UCBPTH0
UCBSIGP  EQU   UCBFLB
UCBVALPH EQU   UCBFLB
UCBCRHSN EQU   UCBFLB
UCBCRHRV EQU   UCBFLB
UCBRESVH EQU   UCBFLB
UCBSPST  EQU   UCBFLB
UCBASNS  EQU   UCBFLB
UCBIORST EQU   UCBFLB
UCBQISCE EQU   UCBFL1
UCBACTV  EQU   UCBFL1
UCBSAP   EQU   UCBFL1
UCBNOTRC EQU   UCBCUB
UCBPSNS  EQU   UCBFL1
UCBUSING EQU   UCBPST
UCBBUSYD EQU   UCBBSY
UCBUA    EQU   UCBCHAN+1
UCBCHA   EQU   UCBCHAN
UCBDADI  EQU   UCBSTAT
UCBSYSR  EQU   UCBSTAT
UCBPRES  EQU   UCBSTAT
UCBRESV  EQU   UCBSTAT
UCBID    EQU   UCBOB+2
UCBALTPH EQU   UCBFL5
UCBALTCU EQU   UCBFL5
UCBENVRD EQU   UCBFL5
UCBVSDR  EQU   UCBFL5
UCBSASK  EQU   UCBFL5
UCBAMV   EQU   UCBAF
UCBDCC   EQU   UCBFL5
UCBMONT  EQU   UCBJBNR
UCBRV011 EQU   UCBJBNR
UCBMMSGP EQU   UCBJBNR
UCBOLDSM EQU   UCBJBNR
UCBRV003 EQU   UCBJBNR
UCBDUC   EQU   UCBJBNR
UCBJES3  EQU   UCBJBNR
UCBVRDEV EQU   UCBJBNR
UCBCMSEG EQU   UCBOB
UCBPFXND EQU   UCB+512
UCBIOQ   EQU   UCB+508
UCBLOCK  EQU   UCB+504
UCBPXST  EQU   UCB+504
@NM00024 EQU   UCB
@NM00023 EQU   VMVUSER
VMVPROCD EQU   VMVUSER
VMVVUNTP EQU   VMVRQBLK+44
@NM00022 EQU   VMVMINFO+1
@NM00021 EQU   VMVACTON
VMVRTAIN EQU   VMVACTON
VMVDSMT  EQU   VMVACTON
VMVKEEP  EQU   VMVACTON
VMVRETCD EQU   VMVRQBLK+36
VMVJSNMP EQU   VMVRQBLK+32
VMVDSNMP EQU   VMVRQBLK+28
VMVJBNMP EQU   VMVRQBLK+24
VMVMVLSR EQU   VMVRQBLK+18
VMVUVLSR EQU   VMVRQBLK+12
VMVUCBP  EQU   VMVRQBLK+9
@NM00020 EQU   VMVRQBLK+8
VMVNREQP EQU   VMVRQBLK+4
VMVOPTB4 EQU   VMVFNMAP+3
@NM00019 EQU   VMVOPTB3
VMVNUMSG EQU   VMVOPTB3
VMVCUVOL EQU   VMVOPTB3
VMVDUPVL EQU   VMVOPTB3
VMVNSPVT EQU   VMVOPTB2
VMVNSLTP EQU   VMVOPTB2
VMVSLTAP EQU   VMVOPTB2
VMVNLTAP EQU   VMVOPTB2
VMVALTAP EQU   VMVOPTB2
VMVSTRG  EQU   VMVOPTB2
VMVPUBLC EQU   VMVOPTB2
VMVPRIVT EQU   VMVOPTB2
VMVVDEND EQU   VMVOPTB1
VMVVRLBL EQU   VMVOPTB1
VMVDWTOR EQU   VMVOPTB1
VMVMTMSG EQU   VMVOPTB1
VMVMOUNT EQU   VMVOPTB1
VMVREWND EQU   VMVOPTB1
VMVUCB   EQU   VMVOPTB1
VMVUNLOD EQU   VMVOPTB1
EXTRACAL EQU   FUNCMAP+1
ALCASDSN EQU   ASNMSW
ALCSUBWT EQU   WAITOKSW
ALCATRKM EQU   TRKMSW
ALCNOENQ EQU   NOTIOTNQ
ALCJOBNM EQU   MTRJOBSW
ALCHDMSG EQU   HDRMSGSW
ALCSSMSG EQU   SSEMSGSW
ALCGENER EQU   GENLOKSW
ALCCANCL EQU   CCLMNTSW
ALCOFFDV EQU   OFFDEVSW
ALCMSSTM EQU   MSSTRMSW
ALCWTVOL EQU   VWAITSW
ALCWTUNT EQU   UWAITSW
ALCMSGLV EQU   WRTMSGSW
ALCMOUNT EQU   VOLMNTSW
AQMQBPTR EQU   AQMPARAM+24
AQMPFLG  EQU   AQMNORMP
AQMCANCP EQU   AQMPARAM+16
AQMLENGT EQU   AQMPARAM+12
AQMASID  EQU   AQMPARAM+8
AQMQCODE EQU   AQMPARAM+2
GRPWPTR  EQU   GRPCOUNT+12
GRPIDENT EQU   GRPCOUNT+10
GRPEXCS  EQU   GRPCOUNT+8
GRPTOTAL EQU   GRPCOUNT+6
GRPOFFLN EQU   GRPCOUNT+4
GRPALLCT EQU   GRPCOUNT+2
GRPAVAIL EQU   GRPCOUNT
@NM00018 EQU   CVRGPLST+13
@NM00017 EQU   CVRFLG3
CVRFORCI EQU   CVRFLG3
CVRGSKP  EQU   CVRFLG3
CVRBOUND EQU   CVRGPLST+10
CVRGALL  EQU   CVRGPLST+8
CVRGRPAL EQU   CVRGPLST+6
CVRGRPID EQU   CVRGPLST+4
CVRGCPTR EQU   CVRGPLST
@NM00016 EQU   CVRRQLST+26
CVRGRPPT EQU   CVRRQLST+20
CVRNGRP  EQU   CVRRQLST+18
@NM00015 EQU   CVRFLG2+1
CVRWMOVE EQU   CVRFLG2
CVRMULTI EQU   CVRFLG2
CVRFULL  EQU   CVRFLG2
CVRREACH EQU   CVRFLG2
CVRRUSED EQU   CVRFLG2
CVRGNEXT EQU   CVRRQLST+12
CVRPTS   EQU   CVRMIN
CVRALLCT EQU   CVRRQLST+6
CVRREQ1  EQU   CVRRQLST+4
@NM00014 EQU   CVRPARM+9
@NM00013 EQU   CVRFLG1
CVRFCALL EQU   CVRFLG1
CVROFFLG EQU   CVRFLG1
CVRALFLG EQU   CVRFLG1
CVRAVFLG EQU   CVRFLG1
CVRGRPLK EQU   CVRPARM+6
CVRRQPTR EQU   CVRPARM
ALGGCNTP EQU   ALGPTRS+12
ALGGLSTP EQU   ALGPTRS+8
ALCPROCN EQU   NAMES+16
ALCSTEPN EQU   NAMES+8
ALCJOBN  EQU   NAMES
LOJSSNMP EQU   ALCWA+164
SSERBLKP EQU   ALCWA+160
GROUPSZ  EQU   ALCWA+156
GRIDPTR  EQU   ALCWA+152
LGENLOCK EQU   ALCWA+124
TCBP     EQU   ALCWA+116
ALCWASID EQU   ALCWA+114
@NM00012 EQU   @NM00011
NODEVERR EQU   @NM00011
NEEDRCVY EQU   @NM00011
UNITRECS EQU   @NM00011
ALCWADUL EQU   INDICATE
ALCWISAM EQU   INDICATE
DSSUNIT  EQU   INDICATE
PRIVASUM EQU   INDICATE
INDREQU  EQU   INDICATE
INDRETRY EQU   INDICATE
RIMTABCT EQU   ALCWA+104
RIMTABLN EQU   ALCWA+100
RIMTABP  EQU   ALCWA+96
ALGTABSZ EQU   ALCWA+92
@NM00010 EQU   ALCWA+78
LTUNITID EQU   ALCWA+76
TOTVOLUN EQU   CNTABLE+44
NUMREQS  EQU   CNTABLE+40
OTHEREQS EQU   CNTABLE+32
SUBSREQS EQU   CNTABLE+28
STRGREQS EQU   CNTABLE+24
PUBLREQS EQU   CNTABLE+20
PVTNREQS EQU   CNTABLE+16
SPECREQS EQU   CNTABLE+12
TPREQS   EQU   CNTABLE+8
VAMREQS  EQU   CNTABLE+4
DMYREQS  EQU   CNTABLE
JSCBPTR  EQU   ALCWA+12
WASIZE   EQU   ALCWA
@NM00009 EQU   VUGRLENT+5
@NM00008 EQU   VUGRLFLG
VUGRALCD EQU   VUGRLFLG
VUGRLIDS EQU   VUGRLENT
VUCBS    EQU   VUPOOL+4
VUPOOL#  EQU   VUPOOL
VOLUNTID EQU   VOLUNTAB+10
VURCVYPR EQU   VOLSTATD
VUVLUNIQ EQU   VOLSTATD
VUDMUNIQ EQU   VOLSTATD
VUUNALSW EQU   VOLSTATD
VUDMNDAL EQU   VOLSTATD
VUDMNDOF EQU   VOLSTATD
VUMUGDON EQU   VOLSTATD
@NM00007 EQU   VOLSTATC
@NM00006 EQU   VOLSTATC
VOLURREQ EQU   VOLSTATC
VOLGRREQ EQU   VOLSTATC
VOLDAREQ EQU   VOLSTATC
VOLCOREQ EQU   VOLSTATC
VOLTAREQ EQU   VOLSTATC
VUAFFWRK EQU   VOLSTATB
VUPROCED EQU   VOLSTATB
VOLMNTD  EQU   VOLSTATB
VOLDEFER EQU   VOLSTATA
VUDADSM  EQU   VOLSTATA
VOLRESVE EQU   VOLSTATA
VOLNSHR  EQU   VOLSTATA
VOLSPEC  EQU   VOLSTATA
VOLID    EQU   VOLUNTAB
EDLNOJES EQU   EDLINDIC
EDLVOLAF EQU   EDLINDIC
EDLENQ   EQU   EDLINDIC
EDLDADSM EQU   EDLINDIC
EDLALCD  EQU   EDLINDIC
EDLUCBAD EQU   EDLUCBL
EDLJINEL EQU   EDLGRFLG
EDLGRID  EQU   EDLGNTRY+12
EDLLISTP EQU   EDLGNTRY+8
EDLUCBNO EQU   EDLGNTRY+4
EDLNXGRP EQU   EDLGNTRY
@NM00005 EQU   EDLENTRY+18
EDLGRPTR EQU   EDLENTRY+12
EDLGRPNO EQU   EDLENTRY+8
EDLVAM   EQU   EDLUVFLG
EDLGMTP  EQU   EDLHDR+12
EDLLUV   EQU   EDLHDR
GRPMASK  EQU   GMTENTRY
GMTENTNO EQU   GMTHDR
EUCBENLN EQU   EUCBHDR+4
EUCBENNO EQU   EUCBHDR
GRPID    EQU   GRPENTRY
GRPENTLN EQU   GRPHDR+4
GRPENTNO EQU   GRPHDR
GENDEVT  EQU   GENENTRY
GENENTLN EQU   GENHDR+4
GENENTNO EQU   GENHDR
LUVAGMTP EQU   LUVENTRY+28
@NM00004 EQU   LUVFLAGS
LUVMGENS EQU   LUVFLAGS
LUVAGMSK EQU   LUVFLAGS
LUVVAM   EQU   LUVFLAGS
LUVALUE  EQU   LUVENTRY+8
UNITNAME EQU   LUVENTRY
.@UNREFD ANOP                          END UNREFERENCED COMPONENTS
@RC00199 EQU   @RC00184
@RC00241 EQU   @RC00213
@RC00309 EQU   @RC00295
@RC00288 EQU   @RC00286
@RC00363 EQU   @RC00361
@RC00408 EQU   @RC00405
@RC00480 EQU   @EL00004
@RC00422 EQU   @RC00408
@RC00506 EQU   @RC00480
@RC00425 EQU   @RC00422
@ENDDATA EQU   *
         END   IEFAB485,(C'PLS1229',0701,78089)
