         TITLE 'IEFAB487 - ALLOCATION RECOVERY OPERATOR INTERFACE      *
                        '
IEFAB487 CSECT ,                                                01S0001
@MAINENT DS    0H                                               01S0001
         USING *,@15                                            01S0001
         B     @PROLOG                                          01S0001
         DC    AL1(16)                                          01S0001
         DC    C'IEFAB487  78.124'                              01S0001
         DROP  @15
@PROLOG  STM   @14,@12,12(@13)                                  01S0001
         BALR  @12,0                                            01S0001
@PSTART  LA    @11,4095(,@12)                                   01S0001
         USING @PSTART,@12                                      01S0001
         USING @PSTART+4095,@11                                 01S0001
         L     @00,@SIZDATD                                     01S0001
         MODESET EXTKEY=SCHED,SAVEKEY=(2)
         GSPACE   R,LV=(0)
         LR    @10,@01                                          01S0001
         USING @DATD,@10                                        01S0001
         ST    @13,@SA00001+4                                   01S0001
         STC   @02,@OLDKEY                                      01S0001
         MODESET KEYADDR=(2)
         LM    @00,@02,20(@13)                                  01S0001
         ST    @10,8(,@13)                                      01S0001
         LR    @13,@10                                          01S0001
         MODESET EXTKEY=ZERO
         MVC   @PC00001(4),0(@01)                               01S0001
         MODESET EXTKEY=SCHED
*RETCODE = ZERO;                       /*INIT RETURN CODE AREA       */
         SLR   RETCODE,RETCODE                                  01S0089
*COMPRTEC = ZERO;                      /*INIT COMPOSITE RT'NG CODES  */
         MVI   COMPRTEC,X'00'                                   01S0090
*RPLYDATA = RPLYDATA && RPLYDATA;      /*CLEAR REPLY RTN'S DATA AREA */
         XC    RPLYDATA(8),RPLYDATA                             01S0091
*WPLPTR = ADDR(WTOL);                  /*SET PTR TO WTO P-LIST       */
         LA    WPLPTR,WTOL                                      01S0092
*/********************************************************************/
*/*                                                                  */
*/* SEGMENT NAME - RHDRMSGS                                          */
*/*                                                                  */
*/* DESCRIPTIVE NAME - RECOVERY HEADER MESSAGES                      */
*/*                                                                  */
*/* FUNCTION -                                                       */
*/*   THIS ROUTINE BUILDS AND ISSUES THE RECOVERY HEADER MESSAGE     */
*/*   (IEF244I) TO THE SYSTEM OPERATOR. THE MESSAGE INFORMS THE      */
*/*   OPERATOR OF THE RECOVERY STATUS BY INDICATING THE TOTAL NUMBER */
*/*   OF UNITS NEEDED TO SATISFY THIS ALLOCATION. THE MINIMUM NUMBER */
*/*   OF ALLOCATED AND/OR OFFLINE UNITS WHICH WILL BE NEEDED IS      */
*/*   CALCULATED (IF POSSIBLE - SEE OPERATION) AND INSERTED INTO     */
*/*   THE SECOND LINE OF THE HEADER MESSAGE.                         */
*/*                                                                  */
*/*   OPERATION -                                                    */
*/*     .DETERMINE UNITS NEEDED                                      */
*/*      FOR EACH UNALLOCATED VOLUNIT ENTRY THE ROUTINE WILL:        */
*/*      A) INCREMENT THE TOTAL NUMER OF UNITS NEEDED IF 1) THE ENTRY*/
*/*         REQUIRES A DEVICE AND IS COVERED BY THE ALGORITHM, OR 2) */
*/*         THE ENTRY REPRESENTS A DEMAND REQUEST, OR 3) THE ENTRY   */
*/*         DOES NOT REQUIRE A DEVICE BUT SPECIFIES A VOLUME WHICH   */
*/*         IS CURRENTLY ALLOCATED TO ANOTHER JOB.                   */
*/*      B) INCREMENT THE NUMBER OF ALLOCATED UNITS NEEDED IF 1) THE */
*/*         ENTRY REQUIRES A DEVICE, IS COVERED BY THE ALGORITHM     */
*/*         AND THERE ARE ONLY ALLOCATED UNITS AVAILABLE IN THE      */
*/*         GROUPS ELIGIBLE TO THIS ENTRY, OR 2) THE DEMAND ENTRY    */
*/*         INDICATES A NEED FOR AN ALLOCATED UNIT (VUDMNDAL=1), OR  */
*/*         3) (SAME AS 3 F OR A)).                                  */
*/*      C) INCREMENT THE NUMBER OF OFFLINE UNITS NEEDED IF 1) THE   */
*/*         ENTRY REQUIRES A DEVICE, IS COVERED BY THE ALGORITHM     */
*/*         AND THERE ARE ONLY OFFLINE UNITS AVAILABLE IN THE GROUPS */
*/*         ELIGIBLE TO THIS ENTRY, OR 2) THE UNIQUE DEMAND ENTRY    */
*/*         INDICATES A NEED FOR AN OFFLINE UNIT (VUDMNDOF=1).       */
*/*      NOTE THAT FOR THE VOLUNIT ENTRIES COVERED BY THE ALGORITHM, */
*/*      THE PRESENCE OF BOTH ALLOCATED AND OFFLINE UNITS IN THE     */
*/*      ELIGIBLE GROUPS IS CONSIDERED TO BE AN INDERTERMINATE       */
*/*      CONDITION SO NEITHER COUNT IS UPDATED.                      */
*/*                                                                  */
*/*     .BUILD AND ISSUE MESSAGE LINE(S)                             */
*/*      THE FIRST LINE OF THE HEADER MESSAGE IS ALWAYS BUILT. IF    */
*/*      THERE IS ANY DATA FOR THE SECOND LINE THE NECESSARY TEXT    */
*/*      IS ADDED TO THE MESSAGE BUFFER. THE MESSAGE IS ISSUED TO    */
*/*      THE SYSTEM OPERATOR VIA THE MLWTO INTERFACE. THE MESSAGE    */
*/*      IS ALSO ROUTED TO THE DA, TAPE AND/OR UNIT RECORD POOLS     */
*/*      AS REQUIRED.                                                */
*/*                                                                  */
*/* ENTRY - IN-LINE SEGMENT                                          */
*/*   PURPOSE - ISSUE RECOVERY HEADER MESSAGE LINE(S)                */
*/*   INPUT -                                                        */
*/*     PTR TO START OF VOLUNIT TABLE. EACH ENTRY CONTAINS --        */
*/*       VOLALOC - IF OFF, ENTRY HAS NOT BEEN ALLOCATED             */
*/*       VDEVREQD - IF ON, ENTRY REQUIRES A DEVICE                  */
*/*       VOLSIOTP - PTR TO SIOT  (SIOTDMND INDICATES DEMAND REQUEST)*/
*/*       VOLALGTP - PTR TO REQUEST LIST ENTRY                       */
*/*     REQUEST LIST ENTRY --                                        */
*/*       CVRSKFLG - IF OFF, ALGORITHM CAN PROCESS REQ ENTRY         */
*/*       CVRNGRP - NUMBER OF ELIGIBLE GROUPS                        */
*/*       CVRGRPPT - PTR TO FIRST GROUP LIST ENTRY FOR REQ ENTRY     */
*/*     GROUP LIST ENTRY --                                          */
*/*       CVRGALL - IF NON-NEGATIVE, POSSIBLE SOLUTION IN THIS GROUP */
*/*       CVRGSKP - IF OFF, GROUP CONSIDERED BY ALGORITHM            */
*/*       CVRGCPTR - PTR TO GROUP COUNT ENTRY                        */
*/*     GROUP COUNT ENTRY --                                         */
*/*       GRPALLCT - NUMBER ALLOCATED UNITS IN GROUP                 */
*/*       GRPOFFLN - NUMBER OFFLINE UNITS IN GROUP                   */
*/*                                                                  */
*/* EXITS -                                                          */
*/*   CONDITION - FUNCTION COMPLETED                                 */
*/*     OUTPUT -                                                     */
*/*       RECOVERY HEADER MESSAGE LINE(S) ISSUED                     */
*/*       RETURN CODES - NONE                                        */
*/********************************************************************/
*LCLFLGS = LCLFLGS && LCLFLGS;         /*CLEAR LOCAL WTO FLAGS AREA  */
         XC    LCLFLGS(1),LCLFLGS                               02S0093
*LCLFLGB = ON;                         /*SET RTE CDE-MASTER CONSOLE  */
         OI    LCLFLGB,B'01000000'                              02S0094
*/********************************************************************/
*/*                                                                  */
*/* SEGMENT NAME - GUNITCTS                                          */
*/*                                                                  */
*/* DESCRIPTIVE NAME - GET UNIT COUNTS                               */
*/*                                                                  */
*/* FUNCTION -                                                       */
*/*   THIS ROUTINE CALCULATES THE TOTAL NUMBER OF UNITS NEEDED TO    */
*/*   COMPLETE THIS ALLOCATION. IN ADDITION, THE ROUTINE ATTEMPTS    */
*/*   TO DETERMINE THE MINIMUM NUMBER OF ALLOCATED AND/OR            */
*/*   OFFLINE UNITS NEEDED.                                          */
*/*                                                                  */
*/*   OPERATION -                                                    */
*/*     AS DESCRIBED IN 'RHDRSPEC', THE ROUTINE USES INFORMATION     */
*/*     FROM THE REQUEST LIST ENTRY, THE GROUP LIST ENTRIES AND THE  */
*/*     GROUP COUNT ENTRY ASSOCIATED WITH EACH UNALLOCATED VOLUNIT   */
*/*     TABLE ENTRY (AS WELL AS THE VOLUNIT ENTRY ITSELF) TO CALCU-  */
*/*     LATE THE REQUIRED DATA.                                      */
*/*                                                                  */
*/* ENTRY - IN-LINE SEGMENT                                          */
*/*   PURPOSE - (SEE FUNCTION)                                       */
*/*   INPUT -                                                        */
*/*     VOLUNIT TABLE                                                */
*/*       REQUEST LIST ENTRY                                         */
*/*         GROUP LIST ENTRY                                         */
*/*           GROUP COUNT ENTRY                                      */
*/*     (FOR SPECIFIC FIELDS SEE 'RHDRSPEC')                         */
*/*                                                                  */
*/* EXITS -                                                          */
*/*   CONDITION - FUNCTION COMPLETED                                 */
*/*     OUTPUT -                                                     */
*/*       TOTUNITS - TOTAL NUMBER OF UNITS NEEDED                    */
*/*       ALCUNITS - NUMBER OF ALLOCATED UNITS NEEDED                */
*/*       OFLUNITS - NUMBER OF OFFLINE UNITS NEEDED                  */
*/*       LCLFLGS - DEVICE POOL ROUTING CODES                        */
*/*     RETURN CODES - NONE                                          */
*/********************************************************************/
*ALCUNITS = ZERO;                      /*INIT ALLOC'D UNITS COUNTER  */
         SLR   @09,@09                                          03S0095
         ST    @09,ALCUNITS                                     03S0095
*OFLUNITS = ZERO;                      /*INIT OFFLINE UNITS COUNTER  */
         ST    @09,OFLUNITS                                     03S0096
*TOTUNITS = ZERO;                      /*INIT TOTAL UNITS COUNTER    */
         ST    @09,TOTUNITS                                     03S0097
*PRVTOTAL = ZERO;                      /*INIT PREVIOUS TOTAL FIELD   */
         SLR   PRVTOTAL,PRVTOTAL                                03S0098
*VUPTR = VOLUNPTR;                     /*SET PTR TO FIRST VU ENTRY   */
         L     @09,@PC00001                                     03S0099
         L     @09,ALCWAPTR(,@09)                               03S0099
         L     VUPTR,VOLUNPTR(,@09)                             03S0099
*DO VUCTR = 1 TO VOLUNSZE/LENGTH(VOLUNTAB); /*SCAN VOLUNIT TABLE     */
         LA    VUCTR,1                                          03S0100
         B     @DE00100                                         03S0100
@DL00100 DS    0H                                               03S0101
*  IF VOLALOC = NO &                   /*ENTRY NOT ALLOCATED         */
*     VOLALGTP ^= ZERO THEN            /*HAS REQ LIST ENTRY          */
         TM    VOLALOC(VUPTR),B'10000000'                       03S0101
         BNZ   @RF00101                                         03S0101
         L     @06,VOLALGTP(,VUPTR)                             03S0101
         LTR   @06,@06                                          03S0101
         BZ    @RF00101                                         03S0101
*    DO;                                                        03S0102
*      RQLSTPTR = VOLALGTP;            /*POINT TO REQUEST LIST ENTRY */
         LR    RQLSTPTR,@06                                     03S0103
*      IF CVRSKFLG = NO THEN           /*ALLOCATABLE BY ALGORITHM    */
         TM    CVRSKFLG(RQLSTPTR),B'10000000'                   03S0104
         BNZ   @RF00104                                         03S0104
*        IF VURCVYPR = NO THEN         /*AND NOT ALREADY PROC'D      */
         TM    VURCVYPR(VUPTR),B'00000001'                      03S0105
         BNZ   @RF00105                                         03S0105
*          DO;                                                  03S0106
*            TOTUNITS = TOTUNITS + ONE;/*INCREMENT TOTAL UNITS COUNT */
         LA    @06,1                                            03S0107
         L     @15,TOTUNITS                                     03S0107
         ALR   @15,@06                                          03S0107
         ST    @15,TOTUNITS                                     03S0107
*            GPLSTPTR = CVRGRPPT;      /*POINT TO GROUP LIST ENTRY   */
         L     GPLSTPTR,CVRGRPPT(,RQLSTPTR)                     03S0108
*            ALCGRPSW = OFF;           /*ASSUME NO GROUP HAS ALOC'DS */
*            OFLGRPSW = OFF;           /*ASSUME NO GROUP HAS OFFLINES*/
         NI    ALCGRPSW,B'00111111'                             03S0110
*            DO GRPCTR = 1 TO CVRNGRP; /*CHECK ALL ELIGIBLE GROUPS   */
         B     @DE00111                                         03S0111
@DL00111 DS    0H                                               03S0112
*              IF CVRGSKP = NO &       /*THIS GROUP CAN COVER REQUEST*/
*                  CVRGALL => ZERO THEN                         03S0112
         TM    CVRGSKP(GPLSTPTR),B'10000000'                    03S0112
         BNZ   @RF00112                                         03S0112
         SLR   @06,@06                                          03S0112
         CH    @06,CVRGALL(,GPLSTPTR)                           03S0112
         BH    @RF00112                                         03S0112
*                DO;                                            03S0113
*                  GPCNTPTR = CVRGCPTR;/*POINT TO GROUP COUNT ENTRY  */
         L     GPCNTPTR,CVRGCPTR(,GPLSTPTR)                     03S0114
*                  IF GRPALLCT > ZERO THEN /*GROUP CONTAINS ALLOC'D
*                                            UNITS                   */
         SLR   @15,@15                                          03S0115
         CH    @15,GRPALLCT(,GPCNTPTR)                          03S0115
         BNL   @RF00115                                         03S0115
*                    ALCGRPSW = ON;    /*SET INDICATOR               */
         OI    ALCGRPSW,B'10000000'                             03S0116
*                  IF GRPOFFLN > ZERO THEN /*GROUP HAS OFFLINE UNITS */
@RF00115 ICM   @15,3,GRPOFFLN(GPCNTPTR)                         03S0117
         BNP   @RF00117                                         03S0117
*                    OFLGRPSW = ON;    /*SET INDICATOR               */
         OI    OFLGRPSW,B'01000000'                             03S0118
*                END;                                           03S0119
*              ELSE;                   /*REQ NOT COVERED BY GROUP    */
@RF00112 DS    0H                                               03S0121
*              GPLSTPTR = GPLSTPTR + LENGTH(CVRGPLST); /*POINT TO
*                                        NEXT GROUP LIST ENTRY       */
@RC00112 AH    GPLSTPTR,@CH00065                                03S0121
*            END;                                               03S0122
         LA    @06,1                                            03S0122
         AL    @06,GRPCTR                                       03S0122
@DE00111 ST    @06,GRPCTR                                       03S0122
         CH    @06,CVRNGRP(,RQLSTPTR)                           03S0122
         BNH   @DL00111                                         03S0122
*            IF ALCGRPSW = YES &       /*ONLY ALLOC'DS IN ELIG GROUPS*/
*                OFLGRPSW = NO THEN                             03S0123
         TM    ALCGRPSW,B'10000000'                             03S0123
         BNO   @RF00123                                         03S0123
         TM    OFLGRPSW,B'01000000'                             03S0123
         BNZ   @RF00123                                         03S0123
*              ALCUNITS = ALCUNITS + ONE;/*INCREMENT COUNT OF ALLOC'D*/
         LA    @06,1                                            03S0124
         AL    @06,ALCUNITS                                     03S0124
         ST    @06,ALCUNITS                                     03S0124
*            IF ALCGRPSW = NO &        /*ONLY OFFLINES IN ELIG GROUPS*/
*                OFLGRPSW = YES THEN                            03S0125
@RF00123 TM    OFLGRPSW,B'01000000'                             03S0125
         BNO   @RF00125                                         03S0125
         TM    ALCGRPSW,B'10000000'                             03S0125
         BNZ   @RF00125                                         03S0125
*              OFLUNITS = OFLUNITS + ONE;/*INCREMENT COUNT OF OFFLINE*/
         LA    @06,1                                            03S0126
         AL    @06,OFLUNITS                                     03S0126
         ST    @06,OFLUNITS                                     03S0126
*          END;                                                 03S0127
*        ELSE;                         /*ENTRY ALREADY PROCESSED     */
@RF00105 DS    0H                                               03S0129
*      ELSE                            /*ENTRY SKIPPED BY ALGORITHM  */
*        IF VOLSIOTP->SIOTDMND = YES & /*DEMAND REQUEST         03S0129
*                                                                    */
*            VUDMUNIQ = YES THEN       /*UNIQUE REQUEST FOR UNIT     */
         B     @RC00104                                         03S0129
@RF00104 L     @06,VOLSIOTP(,VUPTR)                             03S0129
         TM    SIOTDMND(@06),B'10000000'                        03S0129
         BNO   @RF00129                                         03S0129
         TM    VUDMUNIQ(VUPTR),B'00000100'                      03S0129
         BNO   @RF00129                                         03S0129
*          DO;                                                  03S0130
*            TOTUNITS = TOTUNITS + ONE;/*INCREMENT TOTAL UNITS COUNT */
         LA    @06,1                                            03S0131
         L     @03,TOTUNITS                                     03S0131
         ALR   @03,@06                                          03S0131
         ST    @03,TOTUNITS                                     03S0131
*            IF VUDMNDAL = YES THEN    /*ALLOCATED UNIT REQUIRED     */
         TM    VUDMNDAL(VUPTR),B'00010000'                      03S0132
         BNO   @RF00132                                         03S0132
*              ALCUNITS = ALCUNITS + ONE;/*INCREMENT COUNT OF ALLOC'D*/
         AL    @06,ALCUNITS                                     03S0133
         ST    @06,ALCUNITS                                     03S0133
*            ELSE                                               03S0134
*              IF VUDMNDOF = YES THEN  /*OFFLINE UNIT REQUIRED       */
         B     @RC00132                                         03S0134
@RF00132 TM    VUDMNDOF(VUPTR),B'00100000'                      03S0134
         BNO   @RF00134                                         03S0134
*                 OFLUNITS = OFLUNITS + ONE; /*INCREMENT COUNT OF
*                                        OFFLINES                    */
         LA    @06,1                                            03S0135
         AL    @06,OFLUNITS                                     03S0135
         ST    @06,OFLUNITS                                     03S0135
*          END;                                                 03S0136
*        ELSE;                         /*NOT DEMAND REQUEST          */
@RF00129 DS    0H                                               03S0138
*      IF CVRWUCBP ^= ZERO &           /*REQUEST NEEDS ALLOC'D VOLUME*/
*         VUVLUNIQ = YES THEN          /*UNIQUE REQ FOR THIS VOLUME  */
@RC00129 DS    0H                                               03S0138
@RC00104 ICM   @06,3,CVRWUCBP(RQLSTPTR)                         03S0138
         BZ    @RF00138                                         03S0138
         TM    VUVLUNIQ(VUPTR),B'00000010'                      03S0138
         BNO   @RF00138                                         03S0138
*        DO;                                                    03S0139
*          TOTUNITS = TOTUNITS + ONE;  /*INCREMENT TOTAL UNITS NEEDED*/
         LA    @06,1                                            03S0140
         L     @05,TOTUNITS                                     03S0140
         ALR   @05,@06                                          03S0140
         ST    @05,TOTUNITS                                     03S0140
*          ALCUNITS = ALCUNITS + ONE;  /*INCREMENT COUNT OF ALLOC'DS */
         AL    @06,ALCUNITS                                     03S0141
         ST    @06,ALCUNITS                                     03S0141
*        END;                                                   03S0142
*      IF PRVTOTAL < TOTUNITS THEN     /*TOTUNITS WAS INCREMENTED    */
@RF00138 C     PRVTOTAL,TOTUNITS                                03S0143
         BNL   @RF00143                                         03S0143
*        DO;                           /*UPDATE LCL RTE CODES        */
*          IF VOLDAREQ = YES THEN      /*D.A. REQUEST                */
         TM    VOLDAREQ(VUPTR),B'00100000'                      03S0145
         BNO   @RF00145                                         03S0145
*            LCLFLGD = ON;             /*ROUTE TO D.A. POOL          */
         OI    LCLFLGD,B'00010000'                              03S0146
*          ELSE                        /*NOT D.A. REQUEST            */
*            IF VOLTAREQ = YES THEN    /*TAPE REQUEST                */
         B     @RC00145                                         03S0147
@RF00145 TM    VOLTAREQ(VUPTR),B'10000000'                      03S0147
         BNO   @RF00147                                         03S0147
*              LCLFLGC = ON;           /*ROUTE TO TAPE POOL          */
         OI    LCLFLGC,B'00100000'                              03S0148
*            ELSE                      /*NOT D.A. OR TAPE            */
*              IF VOLURREQ = YES THEN  /*UNIT RECORD REQ             */
         B     @RC00147                                         03S0149
@RF00147 TM    VOLURREQ(VUPTR),B'00001000'                      03S0149
         BNO   @RF00149                                         03S0149
*                LCLFLGG = ON;         /*ROUTE TO UNIT RCD POOL      */
         OI    LCLFLGG,B'00000010'                              03S0150
*        END;                                                   03S0151
*    END;                              /*NO PRC'NG NEEDED FOR VU     */
*  ELSE;                                                        03S0153
@RF00101 DS    0H                                               03S0154
*  PRVTOTAL = TOTUNITS;                /*SAVE CURRENT TOTAL          */
@RC00101 L     PRVTOTAL,TOTUNITS                                03S0154
*  VUPTR = VUPTR + LENGTH(VOLUNTAB);   /*POINT TO NEXT VOLUNIT ENTRY */
         AH    VUPTR,@CH01268                                   03S0155
*END;                                                           03S0156
         AH    VUCTR,@CH00069                                   03S0156
@DE00100 L     @06,@PC00001                                     03S0156
         L     @06,ALCWAPTR(,@06)                               03S0156
         L     @00,VOLUNSZE(,@06)                               03S0156
         SRDA  @00,32                                           03S0156
         D     @00,@CF01268                                     03S0156
         CR    VUCTR,@01                                        03S0156
         BNH   @DL00100                                         03S0156
*WPLTXT = '';                          /*BLANK OUT MSG BUFFER        */
         MVI   WPLTXT(WPLPTR),C' '                              02S0157
         MVC   WPLTXT+1(125,WPLPTR),WPLTXT(WPLPTR)              02S0157
*TXTLNTH = MSG1LNTH;                   /*SET LENGTH OF LINE 1        */
         L     @09,@CA00146                                     02S0158
         LH    @05,MSG1LNTH-HDRMSG1(,@09)                       02S0158
         ST    @05,TXTLNTH                                      02S0158
*WPLTXT(1:TXTLNTH) = HDRLINE1(1:TXTLNTH); /*MOVE MSG TEXT TO BUFFER  */
         BCTR  @05,0                                            02S0159
         EX    @05,@SM01280                                     02S0159
*CALL CONVERT(TOTUNITS,TUNEEDED);      /*CNVRT TOTAL UNITS AND INSERT
*                                        IN BUFFER                   */
         LA    @05,TOTUNITS                                     02S0160
         ST    @05,@AL00001                                     02S0160
         LA    @05,WPLTXT(,WPLPTR)                              02S0160
         SLR   @15,@15                                          02S0160
         IC    @15,NOUNOFFS-HDRMSG1(,@09)                       02S0160
         ALR   @05,@15                                          02S0160
         ST    @05,@AL00001+4                                   02S0160
         LA    @01,@AL00001                                     02S0160
         BAL   @14,CONVERT                                      02S0160
*MSGJNAME = ALCJOBN;                   /*INSERT JOB NAME             */
         LA    @09,4                                            02S0161
         ALR   @09,WPLPTR                                       02S0161
         L     @05,@PC00001                                     02S0161
         L     @05,ALCWAPTR(,@05)                               02S0161
         L     @05,TIOTHDRP(,@05)                               02S0161
         MVC   MSGJNAME(8,@09),ALCJOBN(@05)                     02S0161
*MSGSNAME = ALCSTEPN;                  /*INSERT STEP NAME            */
         MVC   MSGSNAME(8,@09),ALCSTEPN(@05)                    02S0162
*MSGPSNME = ALCPROCN;                  /*INSERT PROC STEP NAME        *
         MVC   MSGPSNME(8,@09),ALCPROCN(@05)                    02S0163
*CALL IEFAB4F3                         /*COMPRESS BLANKS FROM MSG    */
*    (ADDR(WPLTXT),TXTLNTH,MSGLNTH);                            02S0164
         LA    @09,WPLTXT(,WPLPTR)                              02S0164
         ST    @09,@TF00001                                     02S0164
         LA    @09,@TF00001                                     02S0164
         ST    @09,@AL00001                                     02S0164
         LA    @09,TXTLNTH                                      02S0164
         ST    @09,@AL00001+4                                   02S0164
         LA    @09,MSGLNTH                                      02S0164
         ST    @09,@AL00001+8                                   02S0164
         L     @15,@CV00165                                     02S0164
         LA    @01,@AL00001                                     02S0164
         BALR  @14,@15                                          02S0164
*WPLMCSF = ZERO;                       /*CLEAR MCS FLAGS AREA        */
         SLR   @09,@09                                          02S0165
         STH   @09,WPLMCSF(,WPLPTR)                             02S0165
*WPLMCSFA = ON;                        /*INDIC RTE/DESC CODES SPEC'D */
         OI    WPLMCSFA(WPLPTR),B'10000000'                     02S0166
*WPLFLGS = WPLFLGS && WPLFLGS;         /*CLEAR RTE/DESC CODES AREA   */
         L     @05,MSGLNTH                                      02S0167
         LA    @15,WPLTXT(,WPLPTR)                              02S0167
         ALR   @15,@05                                          02S0167
         XC    WPLFLGS(8,@15),WPLFLGS(@15)                      02S0167
*WPLDESCF = ON;                        /*INDICATE JOB STATUS MSG     */
         OI    WPLDESCF(@15),B'00000100'                        02S0168
*WPLROUT1 = LCLFLGS;                   /*MOVE LCL RTE CDES TO FLAGS  */
         MVC   WPLROUT1(1,@15),LCLFLGS                          02S0169
*WPLLGH = MSGLNTH + FOUR;              /*SET MESSAGE LENGTH          */
         AH    @05,@CH00055                                     02S0170
         STH   @05,WPLLGH(,WPLPTR)                              02S0170
*IF ALCUNITS ^= ZERO |                 /*NEED SECOND LINE OF MSG     */
*    OFLUNITS ^= ZERO THEN                                      02S0171
         C     @09,ALCUNITS                                     02S0171
         BNE   @RT00171                                         02S0171
         C     @09,OFLUNITS                                     02S0171
         BE    @RF00171                                         02S0171
@RT00171 DS    0H                                               02S0172
*  DO;                                                          02S0172
*    WPLMCSFJ = ON;                    /*SET MULTI-LINE IDICATOR     */
         OI    WPLMCSFJ(WPLPTR),B'01000000'                     02S0173
*    WPLLS01 = WPLLS01 && WPLLS01;     /*CLEAR MLWTO EXTENSION AREA  */
         LA    @09,WPLTXT(,WPLPTR)                              02S0174
         AL    @09,MSGLNTH                                      02S0174
         AL    @09,WTOFLGLN                                     02S0174
         XC    WPLLS01(4,@09),WPLLS01(@09)                      02S0174
*    WPLLTFC = ON;                     /*INDICATE DATA LINE          */
         OI    WPLLTFC(@09),B'00100000'                         02S0175
*    WPLLINES = TWO;                   /*SET NUMBER MSG LINES        */
         MVI   WPLLINES(@09),X'02'                              02S0176
*    LINE2PTR = ADDR(WPLLS01)+LENGTH(WPLLS01); /*SET PTR TO LINE 2   */
         AH    @09,@CH00055                                     02S0177
         LR    LINE2PTR,@09                                     02S0177
*    WPLMLTXT = '';                    /*BLANK OUT BUFFER            */
         MVI   WPLMLTXT(LINE2PTR),C' '                          02S0178
         MVC   WPLMLTXT+1(125,LINE2PTR),WPLMLTXT(LINE2PTR)      02S0178
*    MSGOFFS = FULLHDR2;               /*ASSUME ISSUING FULL MESSAGE */
         LA    MSGOFFS,3                                        02S0179
*    IF ALCUNITS = ZERO THEN           /*HAVE TOTAL OFFLINE UNITS    */
         ICM   @09,15,ALCUNITS                                  02S0180
         BNZ   @RF00180                                         02S0180
*      MSGOFFS = OFLONLY;              /*SET OFFSET TO MSG TEXT      */
         LA    MSGOFFS,2                                        02S0181
*    ELSE                              /*HAVE NON-0 ALLOCATED UNITS  */
*      IF OFLUNITS = ZERO THEN         /*HAVE NO OFFLINE TOTAL       */
         B     @RC00180                                         02S0182
@RF00180 ICM   @09,15,OFLUNITS                                  02S0182
         BNZ   @RF00182                                         02S0182
*        MSGOFFS = ALCONLY;            /*SET OFFSET FOR ONLY ALOC'DS */
         LA    MSGOFFS,1                                        02S0183
*    TXTLNTH = HMSGTXTL(MSGOFFS);      /*GET LENGTH OF MESSAGE TEXT  */
@RF00182 DS    0H                                               02S0184
@RC00180 LR    @09,MSGOFFS                                      02S0184
         SLA   @09,2                                            02S0184
         L     @07,@CA00149                                     02S0184
         LA    @03,0(@09,@07)                                   02S0184
         BCTR  @03,0                                            02S0184
         BCTR  @03,0                                            02S0184
         LH    @03,HMSGTXTL-HDR2OFFS-2(,@03)                    02S0184
         ST    @03,TXTLNTH                                      02S0184
*    TXTPTR = ADDR(HDRMSG2)            /*SET PTR TO TEXT IN MSG MOD  */
*        + HMSGOFFS(MSGOFFS);                                   02S0185
         L     TXTPTR,@CA00164                                  02S0185
         AL    @07,@CF01283                                     02S0185
         AH    TXTPTR,HMSGOFFS-HDR2OFFS(@09,@07)                02S0185
*    BEGL2TXT(1:TXTLNTH) = MSGTXT(1:TXTLNTH); /*MOVE TEXT TO BUFFER  */
         LA    @09,4                                            02S0186
         ALR   @09,LINE2PTR                                     02S0186
         LR    @15,@03                                          02S0186
         BCTR  @15,0                                            02S0186
         EX    @15,@SM01284                                     02S0186
*    IF ALCUNITS ^= ZERO THEN                                   02S0187
         ICM   @15,15,ALCUNITS                                  02S0187
         BZ    @RF00187                                         02S0187
*      DO;                                                      02S0188
*        CALL CONVERT(ALCUNITS,AUNEEDED);/*CONVERT NUMBER TO EBCDIC
*                                        AND INSERT IN BUFFER        */
         LA    @15,ALCUNITS                                     02S0189
         ST    @15,@AL00001                                     02S0189
         LA    @09,BEGL2TXT(,@09)                               02S0189
         ALR   @03,TXTPTR                                       02S0189
         SLR   @15,@15                                          02S0189
         IC    @15,VAROFS1(,@03)                                02S0189
         ALR   @09,@15                                          02S0189
         ST    @09,@AL00001+4                                   02S0189
         LA    @01,@AL00001                                     02S0189
         BAL   @14,CONVERT                                      02S0189
*      END;                                                     02S0190
*    IF OFLUNITS ^= ZERO THEN                                   02S0191
@RF00187 ICM   @09,15,OFLUNITS                                  02S0191
         BZ    @RF00191                                         02S0191
*      DO;                                                      02S0192
*        CALL CONVERT(OFLUNITS,OUNEEDED); /*CONVERT NUMBER TO EBCDIC
*                                         AND INSERT IN BUFFER       */
         LA    @09,OFLUNITS                                     02S0193
         ST    @09,@AL00001                                     02S0193
         LA    @09,BEGL2TXT+4(,LINE2PTR)                        02S0193
         LR    @03,TXTPTR                                       02S0193
         AL    @03,TXTLNTH                                      02S0193
         SLR   @15,@15                                          02S0193
         IC    @15,VAROFS2(,@03)                                02S0193
         ALR   @09,@15                                          02S0193
         ST    @09,@AL00001+4                                   02S0193
         LA    @01,@AL00001                                     02S0193
         BAL   @14,CONVERT                                      02S0193
*      END;                                                     02S0194
*    CALL IEFAB4F3                     /*COMPRESS BLANKS FROM TEXT   */
*        (ADDR(BEGL2TXT),TXTLNTH,MSGLNTH);                      02S0195
@RF00191 LA    @09,BEGL2TXT+4(,LINE2PTR)                        02S0195
         ST    @09,@TF00001                                     02S0195
         LA    @09,@TF00001                                     02S0195
         ST    @09,@AL00001                                     02S0195
         LA    @09,TXTLNTH                                      02S0195
         ST    @09,@AL00001+4                                   02S0195
         LA    @09,MSGLNTH                                      02S0195
         ST    @09,@AL00001+8                                   02S0195
         L     @15,@CV00165                                     02S0195
         LA    @01,@AL00001                                     02S0195
         BALR  @14,@15                                          02S0195
*    WPLML0 = ZERO;                    /*CLEAR H-0 BYTE OF LGTH FIELD*/
         MVI   WPLML0(LINE2PTR),X'00'                           02S0196
*    WPLMLLEN = MSGLNTH                /*SET LENGTH OF MSG           */
*        +LENGTH(BEGLINE2) + FOUR;     /*INCLUDE LEADING BLANKS      */
         LA    @09,12                                           02S0197
         AL    @09,MSGLNTH                                      02S0197
         STC   @09,WPLMLLEN(,LINE2PTR)                          02S0197
*    WPLMLLTF = WPLMLLTF && WPLMLLTF;  /*CLEAR LINE TYPE FLAGS       */
         XC    WPLMLLTF(2,LINE2PTR),WPLMLLTF(LINE2PTR)          02S0198
*    WPLMLLTC = ON;                    /*SET DATA LINE INDICATOR     */
*    WPLMLLTD = ON;                    /*SET END LINE INDICATOR      */
         OI    WPLMLLTC(LINE2PTR),B'00110000'                   02S0200
*  END;                                                         02S0201
*ELSE;                                 /*NO SECOND LINE NEEDED       */
@RF00171 DS    0H                                               02S0203
*RFY (REG0) RSTD;                                               02S0203
*REG0 = ZERO;                                                   02S0204
         SLR   REG0,REG0                                        02S0204
*GEN(WTO MF=(E,WTOL));                                          02S0205
         WTO MF=(E,WTOL)
*RFY (REG0) UNRSTD;                                             02S0206
*IF UWAITSW = YES THEN                 /*CAN WAIT FOR UNITS          */
         L     @09,@PC00001                                     01S0207
         L     @09,ALCWAPTR(,@09)                               01S0207
         L     @05,FMAPPTR(,@09)                                01S0207
         TM    UWAITSW(@05),B'00100000'                         01S0207
         BNO   @RF00207                                         01S0207
*  DO;                                 /*PROCESS SPECIFIC WAITS      */
*/********************************************************************/
*/*                                                                  */
*/* SEGMENT NAME - SPECWAIT                                          */
*/*                                                                  */
*/* DESCRIPTIVE NAME - PROCESS SPECIFIC WAITS                        */
*/*                                                                  */
*/* FUNCTION -                                                       */
*/*   THIS ROUTINE DETERMINES WHICH REQUESTS MUST WAIT FOR A         */
*/*   SPECIFIC UNIT (OR VOLUME) TO BECOME AVAILABLE. THE SYSTEM      */
*/*   OPERATOR IS INFORMED OF ALL SUCH REQUESTS AND WILL BE          */
*/*   GIVEN THE OPTION TO WAIT FOR THE UNITS AND/OR VOLUMES OR       */
*/*   TO CANCEL THE JOB (SEE A487SPEC).                              */
*/*                                                                  */
*/*   OPERATION -                                                    */
*/*     FOR EACH UNALLOCATED VOLUNIT ENTRY THE ROUTINE DOES THE      */
*/*     FOLLOWING:                                                   */
*/*       .CHECKS THE WAIT UCB PTR IN THE REQUEST LIST ENTRY. IF     */
*/*        THE FIELD IS NON-ZERO, THE REQUEST MUST WAIT FOR A VOLUME.*/
*/*        THE OFFSET TO THE MESSAGE AND THE PTR TO THE UCB ARE      */
*/*        SET AND A SUBROUTINE TO BUILD THE MESSAGE IS INVOKED.     */
*/*       .IF THE SIOT REPRESENTS A DEMAND REQUEST AND MUST WAIT     */
*/*        FOR THE REQUESTED UNIT, THE PTR TO THE UCB IS RETREIVED   */
*/*        FROM THE EDL. THE UCB PTR AND THE OFFSET TO THE MESSAGE   */
*/*        ARE PASSED TO THE MESSAGE BUILD SUBROUTINE.               */
*/*                                                                  */
*/*     A MESSAGE WILL ONLY BE ISSUED ONCE FOR EACH VOLUME AND/OR    */
*/*     UNIT REQUIRED. THE 'VUVLUNIQ' AND 'VUDMUNIQ' INDICATORS      */
*/*     IN THE VOLUNIT ENTRY ARE USED TO DETERMINE IF THE MESSAGE    */
*/*     SHOULD BE ISSUED.                                            */
*/*                                                                  */
*/*     THE DDNAME OF THE REQUEST BEING PROCESSED WILL NORMALLY      */
*/*     APPEAR IN THE MESSAGE ISSUED. IF THE REQUEST IS A MEMBER     */
*/*     OF A CONCATENATED GROUP (I.E., HAS A BLANK DDNAME FIELD IN   */
*/*     THE SIOT) THEN THE RELATIVE POSITION FROM THE START OF THE   */
*/*     GROUP IS AFFIXED TO THE DDNAME OF THE FIRST DD IN THE GROUP. */
*/*                                                                  */
*/* ENTRY - IN-LINE SEGMENT                                          */
*/*   PURPOSE - SEE FUNCTION                                         */
*/*   INPUT -                                                        */
*/*     SIOT1P - PTR TO FIRST SIOT                                   */
*/*       SVOLUNAD - PTR TO FIRST VOLUNIT ENTRY                      */
*/*       SVOLUNNO - NUMBER OF VOLUNIT ENTRIES                       */
*/*       SIOTEDLP - PTR TO EDL                                      */
*/*       SIOTALCD - IF ON, REQUEST HAS BEEN ALLOCATED               */
*/*     VOLUNIT ENTRIES -                                            */
*/*       VOLALGTP - PTR TO REQUEST LIST ENTRY                       */
*/*       VOLALOC - IF ON, UNIT HAS BEEN ALLOCATED FOR ENTRY         */
*/*       VUVLUNIQ - IF ON, UNIQUE REQUEST FOR VOLUME                */
*/*       VUDMNDAL - IF ON, DEMAND REQUEST REQUIRES ALLOCATED UNIT   */
*/*       VUDMUNIQ - IF ON, UNIQUE DEMAND REQUEST FOR UNIT           */
*/*     REQUEST LIST ENTRIES -                                       */
*/*       CVRWUCBP - PTR TO UCB OF UNIT WITH ALLOCATED VOLUME        */
*/*     EDL -                                                        */
*/*       EDLUCBAD - PTR TO UCB REQUIRED FOR DEMAND REQUEST          */
*/*                                                                  */
*/* EXIT - NORMAL                                                    */
*/*   CONDITION - AT LEAST ONE SPECIFIC WAIT MESSAGE ISSUED          */
*/*     OUTPUT -                                                     */
*/*       MESSAGES ISSUED TO OPERATOR                                */
*/*       SWAITSW = ON                                               */
*/*       RPLYRTEC - ROUTING CODES FOR REPLY MSG                     */
*/*     RETURN CODES - NONE                                          */
*/*   CONDITION - NO MESSAGES REQUIRED                               */
*/*     OUTPUT -                                                     */
*/*       SWAITSW = OFF                                              */
*/*     RETURN CODES - NONE                                          */
*/*                                                                  */
*/********************************************************************/
*SWAITSW = OFF;                        /*INIT SPECIFIC WAIT INDICATOR*/
         NI    SWAITSW,B'01111111'                              02S0209
*SIOTPTR  = SIOT1P;                    /*POINT TO FIRST SIOT         */
         L     SIOTPTR,SIOT1P(,@09)                             02S0210
*DO WHILE(SIOTPTR ^= ZERO);            /*SCAN ALL SIOTS              */
         B     @DE00211                                         02S0211
@DL00211 DS    0H                                               02S0212
*  IF SCTDDNAM(1) ^= BLANK THEN        /*NON-BLANK DD NAME           */
         CLI   SCTDDNAM(SIOTPTR),C' '                           02S0212
         BE    @RF00212                                         02S0212
*    DO;                                                        02S0213
*      SAVDDNM = SCTDDNAM;             /*SAVE DD NAME                */
         MVC   SAVDDNM(8),SCTDDNAM(SIOTPTR)                     02S0214
*      CCATCTR = ZERO;                 /*INIT CONCATENATION COUNTER  */
         SLR   @09,@09                                          02S0215
         ST    @09,CCATCTR                                      02S0215
*    END;                                                       02S0216
*  ELSE                                /*BLANK DD NAME               */
*    CCATCTR =  CCATCTR + ONE;         /*INCREMENT RELATIVE POSITION */
         B     @RC00212                                         02S0217
@RF00212 LA    @09,1                                            02S0217
         AL    @09,CCATCTR                                      02S0217
         ST    @09,CCATCTR                                      02S0217
*  LCLFLGS = LCLFLGS && LCLFLGS;       /*CLEAR LOCAL MSG FLAGS AREA  */
@RC00212 XC    LCLFLGS(1),LCLFLGS                               02S0218
*  VUPTR = SVOLUNAD;                   /*PT TO FIRST VU ENTRY FOR REQ*/
         L     VUPTR,SVOLUNAD(,SIOTPTR)                         02S0219
*  IF SIOTALCD = NO THEN               /*REQUEST NOT ALLOCATED       */
         TM    SIOTALCD(SIOTPTR),B'00000010'                    02S0220
         BNZ   @RF00220                                         02S0220
*    DO VUCTR = 1 TO SVOLUNNO;         /*SCAN VOLUNIT ENTRIES        */
         LA    VUCTR,1                                          02S0221
         B     @DE00221                                         02S0221
@DL00221 DS    0H                                               02S0222
*      IF VOLALOC = NO THEN            /*ENTRY NOT ALLOCATED         */
         TM    VOLALOC(VUPTR),B'10000000'                       02S0222
         BNZ   @RF00222                                         02S0222
*        DO;                           /*SEE IF VOLUME/UNIT NEEDED   */
*          RQLSTPTR = VOLALGTP;        /*POINT TO REQUEST LIST ENTRY */
         L     RQLSTPTR,VOLALGTP(,VUPTR)                        02S0224
*          IF CVRWUCBP ^= ZERO &       /*NEED ALLOCATED VOLUME       */
*              VUVLUNIQ = YES THEN     /*UNIQUE REQUEST FOR VOLUME   */
         SLR   @15,@15                                          02S0225
         ICM   @15,3,CVRWUCBP(RQLSTPTR)                         02S0225
         LTR   @15,@15                                          02S0225
         BZ    @RF00225                                         02S0225
         TM    VUVLUNIQ(VUPTR),B'00000010'                      02S0225
         BNO   @RF00225                                         02S0225
*            DO;                       /*SET UP FOR MESSAGE SUBRTN   */
*              UCBPTR = CVRWUCBP;      /*SET PTR TO UCB FROM REQ LIST*/
         LR    UCBPTR,@15                                       02S0227
*              MSGOFFS = VOLWAIT;      /*SET OFFSET TO MESSAGE ENTRY */
         LA    MSGOFFS,2                                        02S0228
*              CALL BLDSWMSG;          /*BUILD/ISSUE SPECIFIC WAIT
*                                        FOR VOLUME MESSAGE          */
         BAL   @14,BLDSWMSG                                     02S0229
*            END;                                               02S0230
*          IF SIOTDMND = YES &         /*DEMAND REQUEST              */
*              VUDMNDAL = YES &        /*REQUIRED UNIT IS ALLOCATED  */
*              VUDMUNIQ = YES THEN     /*UNIQUE REQUEST FOR UNIT     */
@RF00225 TM    SIOTDMND(SIOTPTR),B'10000000'                    02S0231
         BNO   @RF00231                                         02S0231
         TM    VUDMNDAL(VUPTR),B'00010100'                      02S0231
         BNO   @RF00231                                         02S0231
*            DO;                       /*SET UP FOR MSG SUBROUTINE   */
*              UCBPTR = SIOUCBAD;      /*SET PTR TO UCB FROM SIOT    */
         SLR   UCBPTR,UCBPTR                                    02S0233
         ICM   UCBPTR,7,SIOUCBAD(SIOTPTR)                       02S0233
*              MSGOFFS = UNITWAIT;     /*SET INDEX TO MSG TEXT ENTRY */
         LA    MSGOFFS,1                                        02S0234
*              CALL BLDSWMSG;          /*INVOKE MSG BUILD SUBRTN     */
         BAL   @14,BLDSWMSG                                     02S0235
*              VURCVYPR = ON;          /*INDICATE ENTRY PROCESSED    */
         OI    VURCVYPR(VUPTR),B'00000001'                      02S0236
*            END;                                               02S0237
*        END;                                                   02S0238
*      ELSE;                           /*VU ENTRY ALLOCATED          */
@RF00222 DS    0H                                               02S0240
*      VUPTR = VUPTR + LENGTH(VOLUNTAB); /*POINT TO NEXT ENTRY       */
@RC00222 AL    VUPTR,@CF01268                                   02S0240
*    END;                                                       02S0241
         AH    VUCTR,@CH00069                                   02S0241
@DE00221 CH    VUCTR,SVOLUNNO(,SIOTPTR)                         02S0241
         BNH   @DL00221                                         02S0241
*  ELSE;                               /*REQUEST HAS BEEN ALLOCATED  */
@RF00220 DS    0H                                               02S0243
*  SIOTPTR = SIOTNPTR;                 /*PT TO NEXT SIOT             */
         L     SIOTPTR,SIOTNPTR(,SIOTPTR)                       02S0243
*END;                                                           02S0244
@DE00211 LTR   SIOTPTR,SIOTPTR                                  02S0244
         BNZ   @DL00211                                         02S0244
*    IF SWAITSW = ON THEN              /*MUST WAIT FOR SPECIFIC UNITS*/
         TM    SWAITSW,B'10000000'                              01S0245
         BNO   @RF00245                                         01S0245
*      DO;                                                      01S0246
*        COMPRTEC = COMPRTEC | RPLYRTEC;/*SET DEV POOL RTE CODES USED*/
         OC    COMPRTEC(1),RPLYRTEC                             01S0247
*        RPLYOPT = WAITCNCL;           /*SET WAIT/CANCEL OPT CODE    */
         MVI   RPLYOPT,X'01'                                    01S0248
*        CALL IEFAB488(ALCWAPTR,RPLYDATA); /*GIVE OPTS/PROCESS REPLY */
         L     @09,@PC00001                                     01S0249
         ST    @09,@AL00001                                     01S0249
         LA    @09,RPLYDATA                                     01S0249
         ST    @09,@AL00001+4                                   01S0249
         L     @15,@CV00166                                     01S0249
         LA    @01,@AL00001                                     01S0249
         BALR  @14,@15                                          01S0249
*        RETCODE = REG15;              /*SAVE RETURN CODE            */
         LR    RETCODE,REG15                                    01S0250
*        SWAITSW = OFF;                /*RESET INDICATOR             */
         NI    SWAITSW,B'01111111'                              01S0251
*      END;                                                     01S0252
*  END;                                                         01S0253
@RF00245 DS    0H                                               01S0254
*IF RETCODE = ZERO THEN                /*NO ERROR/JOB NOT CANCELED   */
@RF00207 LTR   RETCODE,RETCODE                                  01S0254
         BNZ   @RF00254                                         01S0254
*  DO;                                 /*PROCESS OFFLINES/ALLOCATEDS */
*    CALL IEFAB48A(ALCWAPTR,RPLYDATA,COMPRTEC);                 01S0256
         L     @09,@PC00001                                     01S0256
         ST    @09,@AL00001                                     01S0256
         LA    @09,RPLYDATA                                     01S0256
         ST    @09,@AL00001+4                                   01S0256
         LA    @09,COMPRTEC                                     01S0256
         ST    @09,@AL00001+8                                   01S0256
         L     @15,@CV00167                                     01S0256
         LA    @01,@AL00001                                     01S0256
         BALR  @14,@15                                          01S0256
*    RETCODE = REG15;                  /*SAVE RETURN CODE            */
         LR    RETCODE,REG15                                    01S0257
*  END;                                                         01S0258
*IF RETCODE = ZERO &                   /*NO ERROR/JOB NOT CANCELED   */
*    WAITRSW = ON THEN                 /*WAIT REPLY PROCESSED        */
@RF00254 LTR   RETCODE,RETCODE                                  01S0259
         BNZ   @RF00259                                         01S0259
         TM    WAITRSW,B'01000000'                              01S0259
         BNO   @RF00259                                         01S0259
*  DO;                                 /*GET TYPE OF WAIT            */
*/********************************************************************/
*/*                                                                  */
*/* SEGMENT NAME - GWAITYPE                                          */
*/*                                                                  */
*/* DESCRIPTIVE NAME - GET WAIT TYPE                                 */
*/*                                                                  */
*/* FUNCTION -                                                       */
*/*   THIS ROUTINE REQUESTS THAT A SYSTEM OPERATOR INDICATE WHETHER  */
*/*   THE JOB IS TO WAIT HOLDING RESOURCES OR NOT. THE ACCEPTED      */
*/*   REPLY IS EITHER 'HOLD' OR 'NO HOLD'.                           */
*/*                                                                  */
*/*   OPERATION -                                                    */
*/*     THIS ROUTINE BUILDS AND ISSUES THE 'WAIT REQUESTED'          */
*/*     MESSAGE VIA THE WTOR MACRO INTERFACE. IF A VALID REPLY       */
*/*     IS NOT RECEIVED IN RESPONSE TO THIS MESSAGE, AN 'INVALID     */
*/*     REPLY' MESSAGE IS ISSUED WHICH REPEATS THE REPLY OPTIONS     */
*/*     GIVEN ORIGINALLY. THE ROUTINE WILL RECURSIVELY ISSUE THE     */
*/*     LATTER MESSAGE UNTIL A VALID REPLY IS RECEIVED. THE TEXT     */
*/*     OF EACH MESSAGE IS RETRIEVED FROM MESSAGE MODULE, IEFAB4M9.  */
*/*     TO ALLOW OTHER UNLOADS AND UNALLOCATIONS             @YM04401*/
*/*     TO PROCEED DURING THE WAIT, 'CHNGDEVS'               @YM04401*/
*/*     IS DEQUEUED AROUND THE WTOR AND                      @YM04401*/
*/*     ITS WAIT AND DOM.                                    @YM04401*/
*/*     DEQ'ING OFF DDR RESOURCES ALLOWS DDR TO PROCESS      @YM08377*/
*/*     AND PREVENTS POSSIBLE INTERLOCKS WHEN RE-ENQING      @YM08377*/
*/*     'CHNGDEVS'.                                          @YM08377*/
*/*   NOTE - THE ENQ PARAMETER LIST IN GOTTEN CORE (ENQCORE) @ZA32215*/
*/*          MUST BE REINITIALIZED AFTER DEQ RET=HAVE WHICH  @ZA32215*/
*/*          DESTROYS THE SHARE OPTION IN THE ENQ LIST.      @ZA32215*/
*/*                                                                  */
*/* ENTRY - IN-LINE SEGMENT                                          */
*/*   PURPOSE - SEE FUNCTION                                         */
*/*   INPUT -                                                        */
*/*     RPLYRTEC - DEVICE POOL ROUTING CODES                         */
*/*     ALCWAPTR - PTR TO ALLOCATION WORK AREA                       */
*/*                                                                  */
*/* EXITS - NORMAL                                                   */
*/*   CONDITION  - 'HOLD' REPLY RECEIVED                             */
*/*     OUTPUT -                                                     */
*/*       INDWAIT SET ON IN ALCWA                                    */
*/*     RETURN CODES - NONE                                          */
*/*   CONDITION - 'NOHOLD' REPLY RECEIVED                            */
*/*     OUTPUT -                                                     */
*/*       INDREQU SET ON IN ALCWA                                    */
*/*     RETURN CODES - NONE                                          */
*/********************************************************************/
*TXTPTR = ADDR(RWATMTXT);              /*PTR TO WAIT TYPE OPT'NS MSG */
         L     TXTPTR,@CA00155                                  02S0261
         LA    @09,RWATMTXT-RPLYWAIT(,TXTPTR)                   02S0261
         LR    TXTPTR,@09                                       02S0261
*TXTLNTH = RWATMSGL;                   /*SET MESSAGE LENGTH          */
         L     @09,@CA00155                                     02S0262
         LH    @09,RWATMSGL-RPLYWAIT(,@09)                      02S0262
         ST    @09,TXTLNTH                                      02S0262
*INVLRSW = ON;                         /*ASSUME AN INVALID REPLY     */
         OI    INVLRSW,B'00100000'                              02S0263
*DO WHILE(INVLRSW = ON);               /*REPEAT UNTIL VALID REPLY
*                                        RECEIVED                    */
         B     @DE00264                                         02S0264
@DL00264 DS    0H                                               02S0265
*  WPLTXT = '';                        /*CLEAR TEXT AREA OF PARM-LIST*/
         MVI   WPLTXT(WPLPTR),C' '                              02S0265
         MVC   WPLTXT+1(125,WPLPTR),WPLTXT(WPLPTR)              02S0265
*  WPLTXT(1:TXTLNTH) = MSGTXT(1:TXTLNTH); /*MOVE TEXT TO P-LIST      */
         L     @09,TXTLNTH                                      02S0266
         BCTR  @09,0                                            02S0266
         EX    @09,@SM01288                                     02S0266
*  MSGJNAME = ALCJOBN;                 /*INSERT JOB NAME             */
         L     @09,@PC00001                                     02S0267
         L     @09,ALCWAPTR(,@09)                               02S0267
         L     @09,TIOTHDRP(,@09)                               02S0267
         MVC   MSGJNAME+4(8,WPLPTR),ALCJOBN(@09)                02S0267
*  CALL IEFAB4F3                       /*REMOVE EMBEDDED BLANKS      */
*       (ADDR(WPLTXT),TXTLNTH,MSGLNTH);                         02S0268
         LA    @09,WPLTXT(,WPLPTR)                              02S0268
         ST    @09,@TF00001                                     02S0268
         LA    @09,@TF00001                                     02S0268
         ST    @09,@AL00001                                     02S0268
         LA    @09,TXTLNTH                                      02S0268
         ST    @09,@AL00001+4                                   02S0268
         LA    @09,MSGLNTH                                      02S0268
         ST    @09,@AL00001+8                                   02S0268
         L     @15,@CV00165                                     02S0268
         LA    @01,@AL00001                                     02S0268
         BALR  @14,@15                                          02S0268
*  WPLLGH = MSGLNTH + FOUR;            /*SET P-LIST LENGTH           */
         L     @09,MSGLNTH                                      02S0269
         LA    @15,4                                            02S0269
         ALR   @15,@09                                          02S0269
         STH   @15,WPLLGH(,WPLPTR)                              02S0269
*  WPLMCSF = WPLMCSF && WPLMCSF;       /*CLEAR MCS FLAGS AREA        */
         XC    WPLMCSF(2,WPLPTR),WPLMCSF(WPLPTR)                02S0270
*  WPLMCSFA = ON;                      /*SHOW RTE/DESC CODES PRESENT */
         OI    WPLMCSFA(WPLPTR),B'10000000'                     02S0271
*  WPLFLGS = WPLFLGS && WPLFLGS;       /*CLEAR RTE/DESC CODES AREA   */
         LA    @15,WPLTXT(,WPLPTR)                              02S0272
         ALR   @15,@09                                          02S0272
         XC    WPLFLGS(8,@15),WPLFLGS(@15)                      02S0272
*  WPLDESCB = ON;                      /*SET IMMEDIATE ACTION INDIC  */
*  WPLDESCF = ON;                      /*SET JOB STATUS INDICATOR    */
         OI    WPLDESCB(@15),B'01000100'                        02S0274
*  WPLROUT1 = COMPRTEC;                /*SET DEVICE POOL RTE CODES   */
         MVC   WPLROUT1(1,@15),COMPRTEC                         02S0275
*  WPLROUTB = ON;                      /*ROUTE TO MASTER CONSOLE TOO */
         OI    WPLROUTB(@15),B'01000000'                        02S0276
*  RPLYBUFR = '';                      /*CLEAR REPLY BUFFER AREA     */
         MVI   RPLYBUFR,C' '                                    02S0277
         MVC   RPLYBUFR+1(5),RPLYBUFR                           02S0277
*  RPLYECB = ZERO;                     /*INIT WAIT ECB               */
         SLR   @09,@09                                          02S0278
         ST    @09,RPLYECB                                      02S0278
*  WPLRPTRA = ADDR(RPLYBUFR);          /*SET PTR TO REPLY BUFFER     */
         LA    @09,WTORL                                        02S0279
         LA    @15,RPLYBUFR                                     02S0279
         STCM  @15,7,WPLRPTRA(@09)                              02S0279
*  WPLRLN = LENGTH(RPLYBUFR);          /*SET LENGTH OF BUFFER        */
         MVI   WPLRLN(@09),X'06'                                02S0280
*  WPLRECB = ADDR(RPLYECB);            /*SET ADDRESS OF WAIT ECB     */
         LA    @15,RPLYECB                                      02S0281
         ST    @15,WPLRECB(,@09)                                02S0281
*  ENQCORE(1:ENQLNTH)=ENQLIST(1:ENQLNTH); /*MOVE ENQ LIST TO LOCAL
*                                        CORE                @YM04401*/
         L     @09,ENQLNTH                                      02S0282
         BCTR  @09,0                                            02S0282
         EX    @09,@SM01290                                     02S0282
*  GEN REFS(ENQCORE);                  /*ALLOW UNLOADS, ETC. @YM04401*/
    DEQ (,ALLOCMIN,8),MF=(E,ENQCORE)                          @YM04401
    DEQ (,DDRDAMIN,5),RET=HAVE,MF=(E,ENQCORE)               @ZA32215*/
    DEQ (,DDRTUMIN,7),RET=HAVE,MF=(E,ENQCORE)               @ZA32215*/
*  RFY (REG0,REG1) RSTD;                                        02S0284
*  REG0 = ZERO;                        /*CLEAR R0 FOR WTOR           */
         SLR   REG0,REG0                                        02S0285
*  GEN(WTOR MF=(E,WTORL));             /*ISSUE MESSAGE               */
         WTOR MF=(E,WTORL)
*  MSGID = REG1;                       /*SAVE MESSAGE ID FOR DOM     */
         ST    REG1,MSGID                                       02S0287
*  REG1 = ADDR(RPLYECB);               /*POINT TO WAIT ECB           */
         LA    REG1,RPLYECB                                     02S0288
*  GEN(WAIT ECB=(1),LONG=YES);         /*WAIT FOR REPLY      @YM05089*/
         WAIT ECB=(1),LONG=YES
*  RFY (REG0,REG1) UNRSTD;                                      02S0290
*                                                               02S0290
*   DO; /* DOM MSG(MSGID(2:4))*/                                02S0291
*     RFY (GPR00F,GPR01F) RSTD; /*RESTRICT REGISTERS*/          02S0292
*     GPR01F = MSGID(2:4); /* MOVE IN MESSAGE ID */             02S0293
         SLR   GPR01F,GPR01F                                    02S0293
         ICM   GPR01F,7,MSGID+1                                 02S0293
*     GPR00F = 0; /* SHOW MSG SPECIFIED*/                       02S0294
         SLR   GPR00F,GPR00F                                    02S0294
*     SVC (87); /* ISSUE DOM SVC */                             02S0295
         SVC   87                                               02S0295
*     RFY (GPR00F,GPR01F) UNRSTD; /* RELEASE REGISTERS */       02S0296
*   END; /* DOM MSG(MSGID(2:4))*/               /*DELETE THE MESSAGE
*      */                                                       02S0297
*  ENQCORE(1:ENQLNTH)=ENQLIST(1:ENQLNTH); /*REINITIALIZE ENQ    02S0298
*                                           LIST             @ZA32215*/
         L     @09,ENQLNTH                                      02S0298
         BCTR  @09,0                                            02S0298
         EX    @09,@SM01290                                     02S0298
*  GEN REFS(ENQCORE);                  /*SERIALIZE UNLOAD,ETC@YM04401*/
    ENQ (,ALLOCMIN,,8),MF=(E,ENQCORE)                       @YM04401
*  IF DDRTPUR = ON THEN                /*ANY TAPE|UR REQUESTS@ZA32215*/
         L     @09,@PC00001                                     02S0300
         L     @09,ALCWAPTR(,@09)                               02S0300
         TM    DDRTPUR(@09),B'00000100'                         02S0300
         BNO   @RF00300                                         02S0300
*    DO;                               /*YES, ENQ DDR TAPE|UR@ZA32215*/
*      GEN REFS(ENQCORE);              /*                    @ZA32215*/
        ENQ (,DDRTUMIN,,7),MF=(E,ENQCORE)                   @ZA32215*/
*    END;                              /*END ENQ DDR TAPE|UR @ZA32215*/
*  IF DDRDA = ON THEN                  /*ANY DA REQUESTS     @ZA32215*/
@RF00300 L     @09,@PC00001                                     02S0304
         L     @09,ALCWAPTR(,@09)                               02S0304
         TM    DDRDA(@09),B'00000010'                           02S0304
         BNO   @RF00304                                         02S0304
*    DO;                               /*YES ENQ DDR DA      @ZA32215*/
*      GEN REFS(ENQCORE);              /*                    @ZA32215*/
        ENQ (,DDRDAMIN,,5),MF=(E,ENQCORE)                   @ZA32215*/
*    END;                              /*END ENQ DDR DA      @ZA32215*/
*  RPLYBUFR = RPLYBUFR | FOLDRPLY;     /*FOLD REPLY TO UPPER CASE    */
@RF00304 OC    RPLYBUFR(6),@CB00197                             02S0308
*  IF RPLYBUFR(1:6) = HOLD THEN        /*REPLY WAS 'HOLD'    @YM07289*/
         CLC   RPLYBUFR(6),@CC00202                             02S0309
         BNE   @RF00309                                         02S0309
*    DO;                                                        02S0310
*      INVLRSW = OFF;                  /*INDICATE VALID REPLY REC'VD */
         NI    INVLRSW,B'11011111'                              02S0311
*      INDWAIT = ON;                   /*SET 'WAIT HOLDING RESOURCES'*/
         L     @09,@PC00001                                     02S0312
         L     @09,ALCWAPTR(,@09)                               02S0312
         OI    INDWAIT(@09),B'10000000'                         02S0312
*    END;                                                       02S0313
*  ELSE                                /*REPLY NOT 'HOLD'            */
*    IF RPLYBUFR = NOHOLD THEN         /*REPLY WAS 'NOHOLD'          */
         B     @RC00309                                         02S0314
@RF00309 CLC   RPLYBUFR(6),@CC00206                             02S0314
         BNE   @RF00314                                         02S0314
*      DO;                                                      02S0315
*        INVLRSW = OFF;                /*INDICATE VALID REPLY REC'VD */
         NI    INVLRSW,B'11011111'                              02S0316
*        INDREQU = ON;                 /*SET 'WAIT WITHOUT HOLDING
*                                        RESOURCES                   */
         L     @09,@PC00001                                     02S0317
         L     @09,ALCWAPTR(,@09)                               02S0317
         OI    INDREQU(@09),B'00100000'                         02S0317
*      END;                                                     02S0318
*    ELSE                              /*NO VALID REPLY RECEIVED     */
*      DO;                             /*SET UP TO REPEAT REQUEST    */
         B     @RC00314                                         02S0319
@RF00314 DS    0H                                               02S0320
*        TXTPTR = ADDR(INVWMTXT);      /*POINT TO INVALID REPLY MSG  */
         L     TXTPTR,@CA00152                                  02S0320
         LA    @09,INVWMTXT-INVWTMSG(,TXTPTR)                   02S0320
         LR    TXTPTR,@09                                       02S0320
*        TXTLNTH = INVWMSGL;           /*SET LENGTH OF MESSAGE       */
         L     @09,@CA00152                                     02S0321
         LH    @09,INVWMSGL-INVWTMSG(,@09)                      02S0321
         ST    @09,TXTLNTH                                      02S0321
*      END;                                                     02S0322
*END;                                                           02S0323
@RC00314 DS    0H                                               02S0323
@RC00309 DS    0H                                               02S0323
@DE00264 TM    INVLRSW,B'00100000'                              02S0323
         BO    @DL00264                                         02S0323
*  END;                                                         01S0324
*ELSE                                                           01S0325
*  IF RETCODE = RETRY THEN             /*RETRY RETURN CODE SET       */
         B     @RC00259                                         01S0325
@RF00259 CH    RETCODE,@CH00213                                 01S0325
         BNE   @RF00325                                         01S0325
*    RETCODE = ZERO;                   /*RESET TO NON-ERROR CODE     */
*                                                               01S0326
*                                                               01S0326
         SLR   RETCODE,RETCODE                                  01S0326
* DECLARE /*GENERAL PURPOSE REGISTERS */                        01S0327
*   GPR00F FIXED(31) REG(0),                                    01S0327
*   GPR01F FIXED(31) REG(1);                                    01S0327
*                                                               01S0327
@RF00325 DS    0H                                               01S0327
@RC00259 DS    0H                                               01S0328
* DECLARE /* COMMON VARIABLES */                                01S0328
*   I256C CHAR(256) BASED,                                      01S0328
*   I031F FIXED(31) BASED,                                      01S0328
*   I031P PTR(31)   BASED,                                      01S0328
*   I015F FIXED(15) BASED,                                      01S0328
*   I015P PTR(15)   BASED,                                      01S0328
*   I008P PTR(8)    BASED,                                      01S0328
*   I001C CHAR(1)   BASED;                                      01S0328
*RETURN CODE(RETCODE);                                          01S0329
         IC    @02,@OLDKEY                                      01S0329
         L     @13,4(,@13)                                      01S0329
         L     @00,@SIZDATD                                     01S0329
         LR    @01,@10                                          01S0329
         FSPACE   R,LV=(0),A=(1)
         MODESET KEYADDR=(2)
         LR    @15,@08                                          01S0329
         L     @14,12(,@13)                                     01S0329
         LM    @00,@12,20(@13)                                  01S0329
         BR    @14                                              01S0329
*/********************************************************************/
*/*                                                                  */
*/* SEGMENT NAME - CONVERT                                           */
*/*                                                                  */
*/* DESCRIPTIVE NAME - CONVERT BINARY DATA TO EBCDIC                 */
*/*                                                                  */
*/* FUNCTION -                                                       */
*/*   THIS ROUTINE WILL CONVERT THE INPUT BINARY NUMBER TO ITS       */
*/*   EBCDIC EQUIVALENT. THE ROUTINE WILL ALSO REPLACE LEADING       */
*/*   ZEROES, IN THE CONVERTED NUMBER, WITH BLANKS.                  */
*/*                                                                  */
*/*                                                                  */
*/* ENTRY - CONVERT (INTERNAL PROCEDURE)                             */
*/*   PURPOSE - SEE FUNCTION                                         */
*/*   INPUT -                                                        */
*/*     CNVTIN - NUMBER TO BE CONVERTED (FULL-WORD)                  */
*/*     CNVTOUT - OUTPUT AREA (4-BYTES)                              */
*/*                                                                  */
*/* EXIT - RETURN TO CALLER                                          */
*/*   CONDITION - CONVERSION COMPLETED                               */
*/*     OUTPUT -                                                     */
*/*       CNVTOUT - EBCDIC VALUE OF INPUT SANS LEADING ZEROES        */
*/*     RETURN CODES - NONE                                          */
*/********************************************************************/
*CONVERT:                                                       02S0330
*  PROC (CNVTIN,CNVTOUT);                                       02S0330
CONVERT  STM   @14,@12,12(@13)                                  02S0330
         MVC   @PC00002(8),0(@01)                               02S0330
*CVD(CNVTIN,CNVTDNUM);                 /*CONVERT INPUT NUMBER TO DEC */
         L     @15,@PC00002                                     02S0331
         L     @15,CNVTIN(,@15)                                 02S0331
         CVD   @15,CNVTDNUM                                     02S0331
*UNPK(CNVTOUT,CNVTDNUM(6:8));          /*UNPACK IT INTO OUTPUT AREA  */
         L     @15,@PC00002+4                                   02S0332
         UNPK  CNVTOUT(4,@15),CNVTDNUM+5(3)                     02S0332
*MVZ(CNVTOUT(LENGTH(CNVTOUT)),CNVTZONE);/*INSERT ZONE IN LAST BYTE   */
         MVZ   CNVTOUT+3(1,@15),@CB00231                        02S0333
*DO CNVTCTR = 1 TO LENGTH(CNVTOUT)     /*SCAN FOR LEADING ZEROES     */
*    WHILE(CNVTOUT(CNVTCTR) = CNVTZERO);                        02S0334
         LA    CNVTCTR,1                                        02S0334
@DL00334 L     @03,@PC00002+4                                   02S0334
         LR    @01,@03                                          02S0334
         ALR   @01,CNVTCTR                                      02S0334
         BCTR  @01,0                                            02S0334
         CLI   CNVTOUT(@01),C'0'                                02S0334
         BNE   @DC00334                                         02S0334
*  CNVTOUT(CNVTCTR) = CNVTBLNK;        /*REPLACE ZERO WITH BLANK     */
         ALR   @03,CNVTCTR                                      02S0335
         BCTR  @03,0                                            02S0335
         MVI   CNVTOUT(@03),C' '                                02S0335
*END;                                                           02S0336
         AH    CNVTCTR,@CH00069                                 02S0336
         CH    CNVTCTR,@CH00055                                 02S0336
         BNH   @DL00334                                         02S0336
@DC00334 DS    0H                                               02S0337
*RETURN;                                                        02S0337
@EL00002 DS    0H                                               02S0337
@EF00002 DS    0H                                               02S0337
@ER00002 LM    @14,@12,12(@13)                                  02S0337
         BR    @14                                              02S0337
*END CONVERT;                                                   02S0338
*/********************************************************************/
*/*                                                                  */
*/* SEGMENT NAME - BLDSWMSG                                          */
*/*                                                                  */
*/* DESCRIPTIVE NAME - BUILD SPECIFIC WAIT MESSAGE                   */
*/*                                                                  */
*/* FUNCTION -                                                       */
*/*   THIS ROUTINE BUILDS AND ISSUES THE SPECIFIC WAIT MESSAGE FOR   */
*/*   ALLOCATION RECOVERY PROCESSING. EITHER THE 'WAIT FOR UNIT'     */
*/*   MESSAGE OR THE 'WAIT FOR VOLUME ON UNIT' MESSAGE IS ISSUED TO  */
*/*   THE SYSTEM OPERATOR (AND INDICATED DEVICE POOLS) ON EACH CALL  */
*/*   TO THIS ROUTINE.                                               */
*/*                                                                  */
*/*   OPERATION -                                                    */
*/*     THE APPROPRIATE MESSAGE IS BUILT IN TWO PARTS. THE FIRST,    */
*/*     THE ID PORTION, IS RETRIEVED FROM THE MESSAGE MODULE AND     */
*/*     THE DDNAME INSERTED (AS WELL AS THE RELATIVE POSITION, IF    */
*/*     NECESSARY). THIS PORTION OF THE MESSAGE IS PASSED TO IEFAB4F3*/
*/*     TO REMOVE ANY EMBEDDED BLANKS IN THE MESSAGE.                */
*/*                                                                  */
*/*     THE VARIABLE PART OF THE MESSAGE IS RETREIVED USING THE      */
*/*     INPUT OFFSET VALUE AS AN INDEX INTO THE OFFSET TABLE OF      */
*/*     THE MESSAGE MODULE. THIS TEXT IS MOVED INTO THE BUFFER       */
*/*     IMMEDIATELY FOLLOWING THE ID TEXT. THE VARIABLE INFORMATION, */
*/*     UNIT NAME AND/OR VOLSER IS THEN INSERTED. IT SHOULD BE  NOTED*/
*/*     THAT THE FULL MESSAGE CANNOT BE COMPRESSED BECAUSE EMBEDDED  */
*/*     BLANKS ARE VALID IN A VOLSER.                                */
*/*                                                                  */
*/* ENTRY - BLDSWMSG (INTERNAL PROC)                                 */
*/*   PURPOSE - SEE FUNCTION                                         */
*/*   INPUT -                                                        */
*/*     MSGOFFS - OFFSET INDEX                                       */
*/*     UCBPTR - PTR TO UCB OF REQUIRED UNIT                         */
*/*     LCLFLGS - LOCAL FLAGS AREA INDICATING DEVICE POOLS TO        */
*/*               RECEIVE MSG                                        */
*/* EXIT -                                                           */
*/*   CONDITION - MESSAGE ISSUED                                     */
*/*     OUTPUT -                                                     */
*/*       MESSAGE IEF488I ISSUED                                     */
*/*       SWAITSW SET TO INDICATE A SPECIFIC WAIT MSG HAS BEEN ISSUED*/
*/*     RETURN CODES - NONE                                          */
*/*                                                                  */
*/********************************************************************/
*BLDSWMSG:                             /*BUILD SPECIFIC WAIT MSG     */
*  PROC;                                                        02S0339
BLDSWMSG STM   @14,@12,@SA00003                                 02S0339
*SWAITSW = ON;                         /*INDICATE MESSAGE ISSUED     */
         OI    SWAITSW,B'10000000'                              02S0340
*IF UCB3DACC = YES THEN                /*D.A. UNIT REQUIRED          */
         TM    UCB3DACC(UCBPTR),B'00100000'                     02S0341
         BNO   @RF00341                                         02S0341
*  LCLFLGD = ON;                       /*ROUTE MSG TO D.A. POOL      */
         OI    LCLFLGD,B'00010000'                              02S0342
*ELSE                                  /*NOT D.A. UNIT               */
*  IF UCB3TAPE = YES THEN              /*TAPE UNIT REQUIRED          */
         B     @RC00341                                         02S0343
@RF00341 TM    UCB3TAPE(UCBPTR),B'10000000'                     02S0343
         BNO   @RF00343                                         02S0343
*    LCLFLGC = ON;                     /*ROUTE TO TAPE POOL          */
         OI    LCLFLGC,B'00100000'                              02S0344
*  ELSE                                /*NOT TAPE OR D.A. UNIT       */
*    IF UCB3UREC = YES THEN            /*UNIT RCD DEVICE REQUIRED    */
         B     @RC00343                                         02S0345
@RF00343 TM    UCB3UREC(UCBPTR),B'00001000'                     02S0345
         BNO   @RF00345                                         02S0345
*      LCLFLGG = ON;                   /*ROUTE MSG TO UNIT REC POOL  */
         OI    LCLFLGG,B'00000010'                              02S0346
*RPLYRTEC = RPLYRTEC | LCLFLGS;        /*SET IN REPLY MSG DATA AREA  */
@RF00345 DS    0H                                               02S0347
@RC00343 DS    0H                                               02S0347
@RC00341 OC    RPLYRTEC(1),LCLFLGS                              02S0347
*LCLFLGB = ON;                         /*ROUTE MSG TO MASTER CONSOLE */
         OI    LCLFLGB,B'01000000'                              02S0348
*WPLTXT = '';                          /*CLEAR TXT AREA OF WTO P-LIST*/
         MVI   WPLTXT(WPLPTR),C' '                              02S0349
         MVC   WPLTXT+1(125,WPLPTR),WPLTXT(WPLPTR)              02S0349
*TXTLNTH = SWIDMSGL;                   /*GET LENGTH OF BEG'NG MSG TXT*/
         L     @05,@CA00158                                     02S0350
         LH    @15,SWIDMSGL-SWMSGID(,@05)                       02S0350
         ST    @15,TXTLNTH                                      02S0350
*SWMID(1:TXTLNTH) = SWIDMTXT(1:TXTLNTH); /*MOVE TEXT TO BUFFER       */
         LA    @14,4                                            02S0351
         ALR   @14,WPLPTR                                       02S0351
         BCTR  @15,0                                            02S0351
         EX    @15,@SM01293                                     02S0351
*MSGJNAME = ALCJOBN;                   /*INSERT JOB NAME             */
         L     @05,@PC00001                                     02S0352
         L     @05,ALCWAPTR(,@05)                               02S0352
         L     @05,TIOTHDRP(,@05)                               02S0352
         MVC   MSGJNAME(8,@14),ALCJOBN(@05)                     02S0352
*SWMSGDDN = SAVDDNM;                   /*INSERT DD NAME IN BUFFER    */
         MVC   SWMSGDDN(8,@14),SAVDDNM                          02S0353
*IF CCATCTR ^= ZERO THEN               /*DD IS CONCAT'N GROUP MEMBER */
         ICM   @05,15,CCATCTR                                   02S0354
         BZ    @RF00354                                         02S0354
*  DO;                                                          02S0355
*    CALL CONVERT(CCATCTR,MSGRPOS);    /*CONVERT RELATIVE POSITION   */
         LA    @05,CCATCTR                                      02S0356
         ST    @05,@AL00001                                     02S0356
         LA    @05,MSGRPOS                                      02S0356
         ST    @05,@AL00001+4                                   02S0356
         LA    @01,@AL00001                                     02S0356
         BAL   @14,CONVERT                                      02S0356
*    SWMRPOS = MSGRPOS(2:4);           /*MOVE EBCDIC VALUE TO BUFFER */
         MVC   SWMRPOS+4(3,WPLPTR),MSGRPOS+1                    02S0357
*  END;                                                         02S0358
*ELSE                                                           02S0359
*  SWMSGCCN = '';                      /*BLANK OUT REL POS'N FIELD   */
         B     @RC00354                                         02S0359
@RF00354 MVI   SWMSGCCN+4(WPLPTR),C' '                          02S0359
         MVC   SWMSGCCN+5(3,WPLPTR),SWMSGCCN+4(WPLPTR)          02S0359
*CALL IEFAB4F3(ADDR(SWMID),TXTLNTH,MSGLNTH); /*REMOVE EMBEDDED BLANKS
*                                        FROM THIS PART OF MESSAGE   */
@RC00354 LA    @15,4                                            02S0360
         ALR   @15,WPLPTR                                       02S0360
         ST    @15,@TF00001                                     02S0360
         LA    @15,@TF00001                                     02S0360
         ST    @15,@AL00001                                     02S0360
         LA    @15,TXTLNTH                                      02S0360
         ST    @15,@AL00001+4                                   02S0360
         LA    @15,MSGLNTH                                      02S0360
         ST    @15,@AL00001+8                                   02S0360
         L     @15,@CV00165                                     02S0360
         LA    @01,@AL00001                                     02S0360
         BALR  @14,@15                                          02S0360
*TXTPTR = ADDR(SWMSGOPS)               /*PT TO VARIABLE TEXT ENTRY   */
*    + SPWTOFFS(MSGOFFS);                                       02S0361
         L     TXTPTR,@CA00168                                  02S0361
         LR    @15,MSGOFFS                                      02S0361
         SLA   @15,2                                            02S0361
         L     @14,@CA00161                                     02S0361
         LA    @01,0(@15,@14)                                   02S0361
         AL    @01,@CF01283                                     02S0361
         AH    TXTPTR,SPWTOFFS-SWMSGOFS(,@01)                   02S0361
*TXTLNTH = SPWMTXTL(MSGOFFS);          /*GET LENGTH OF REMAINING TEXT*/
         BCTR  @14,0                                            02S0362
         BCTR  @14,0                                            02S0362
         LH    @15,SPWMTXTL-SWMSGOFS-2(@15,@14)                 02S0362
         ST    @15,TXTLNTH                                      02S0362
*SWMVAR(1:TXTLNTH) =                   /*MOVE TEXT TO BUFFER         */
*    MSGTXT(1:TXTLNTH);                                         02S0363
         LA    @14,WPLTXT(,WPLPTR)                              02S0363
         AL    @14,MSGLNTH                                      02S0363
         LR    @09,@15                                          02S0363
         BCTR  @09,0                                            02S0363
         EX    @09,@SM01295                                     02S0363
*SWMUNIT = UCBNAME;                    /*MOVE UNIT NAME TO BUFFER    */
         ALR   @15,TXTPTR                                       02S0364
         SLR   @09,@09                                          02S0364
         IC    @09,VAROFS2(,@15)                                02S0364
         ALR   @09,@14                                          02S0364
         MVC   SWMUNIT(3,@09),UCBNAME(UCBPTR)                   02S0364
*IF MSGOFFS = VOLWAIT THEN             /*'WAIT FOR VOL ON UNIT' MSG  */
         CH    MSGOFFS,@CH00078                                 02S0365
         BNE   @RF00365                                         02S0365
*  SWMVOL = UCBVOLI;                   /*MOVE IN VOLSER              */
         SLR   @06,@06                                          02S0366
         IC    @06,VAROFS1(,@15)                                02S0366
         ALR   @14,@06                                          02S0366
         MVC   SWMVOL(6,@14),UCBVOLI(UCBPTR)                    02S0366
*MSGLNTH = MSGLNTH + TXTLNTH;          /*GET TOTAL MESSAGE LENGTH    */
@RF00365 L     @05,MSGLNTH                                      02S0367
         AL    @05,TXTLNTH                                      02S0367
         ST    @05,MSGLNTH                                      02S0367
*WPLLGH = MSGLNTH + FOUR;              /*SET LENGTH OF MSG IN P-LIST */
         LA    @15,4                                            02S0368
         ALR   @15,@05                                          02S0368
         STH   @15,WPLLGH(,WPLPTR)                              02S0368
*WPLMCSF = WPLMCSF && WPLMCSF;         /*CLEAR MCS FLAGS AREA        */
         XC    WPLMCSF(2,WPLPTR),WPLMCSF(WPLPTR)                02S0369
*WPLMCSFA = ON;                        /*INIC PRESENCE OF RTE/DESC
*                                        CODES                       */
         OI    WPLMCSFA(WPLPTR),B'10000000'                     02S0370
*WPLFLGS = WPLFLGS && WPLFLGS;         /*CLEAR RTE/DESC CODES AREA   */
         LA    @15,WPLTXT(,WPLPTR)                              02S0371
         ALR   @15,@05                                          02S0371
         XC    WPLFLGS(8,@15),WPLFLGS(@15)                      02S0371
*WPLDESCF = ON;                        /*SET JOB STATUS DESC'TR CODE */
         OI    WPLDESCF(@15),B'00000100'                        02S0372
*WPLROUT1 = LCLFLGS;                   /*SET RT'NG CODES FROM LOCAL
*                                        AREA                        */
         MVC   WPLROUT1(1,@15),LCLFLGS                          02S0373
*RFY (REG0) RSTD;                                               02S0374
*REG0 = ZERO;                          /*CLEAR R0 FOR WTO            */
         SLR   REG0,REG0                                        02S0375
*GEN(WTO MF=(E,WTOL));                 /*ISSUE WTO                   */
         WTO MF=(E,WTOL)
*RFY (REG0) UNRSTD;                                             02S0377
*RETURN;                               /*RETURN TO CALLER            */
@EL00003 DS    0H                                               02S0378
@EF00003 DS    0H                                               02S0378
@ER00003 LM    @14,@12,@SA00003                                 02S0378
         BR    @14                                              02S0378
*END BLDSWMSG;                                                  02S0379
*END IEFAB487                                                   01S0380
*/* THE FOLLOWING INCLUDE STATEMENTS WERE FOUND IN THIS PROGRAM.      *
*/*%INCLUDE SYSLIB  (A487SPEC)                                        *
*/*%INCLUDE SYSLIB  (A487DATA)                                        *
*/*%INCLUDE SYSLIB  (CNVTDATA)                                        *
*/*%INCLUDE SYSLIB  (IEFASIOT)                                        *
*/*%INCLUDE SYSLIB  (IEFUCBOB)                                        *
*/*%INCLUDE SYSLIB  (IEFZB421)                                        *
*/*%INCLUDE SYSLIB  (IEFZB422)                                        *
*/*%INCLUDE SYSLIB  (IEFZB423)                                        *
*/*%INCLUDE SYSLIB  (IEFZB425)                                        *
*/*%INCLUDE SYSLIB  (IEFZB426)                                        *
*/*%INCLUDE SYSLIB  (IEFZB428)                                        *
*/*%INCLUDE SYSLIB  (IEZWPL  )                                        *
*/*%INCLUDE SYSLIB  (RHDRMSGS)                                        *
*/*%INCLUDE SYSLIB  (RHDRSPEC)                                        *
*/*%INCLUDE SYSLIB  (GUNITCTS)                                        *
*/*%INCLUDE SYSLIB  (GUCTSPEC)                                        *
*/*%INCLUDE SYSLIB  (SPECWAIT)                                        *
*/*%INCLUDE SYSLIB  (SPWTSPEC)                                        *
*/*%INCLUDE SYSLIB  (GWAITYPE)                                        *
*/*%INCLUDE SYSLIB  (GWTSPEC )                                        *
*/*%INCLUDE SYSLIB  (CONVERT )                                        *
*/*%INCLUDE SYSLIB  (CNVTSPEC)                                        *
*/*%INCLUDE SYSLIB  (BLDSWMSG)                                        *
*/*%INCLUDE SYSLIB  (BSWMSPEC)                                        *
*;                                                              01S0380
@DATA    DS    0H
@CH00069 DC    H'1'
@CH00078 DC    H'2'
@CH00055 DC    H'4'
@CH00065 DC    H'16'
@CH00213 DC    H'20'
@SM01280 MVC   WPLTXT(0,WPLPTR),HDRLINE1-HDRMSG1(@09)
@SM01284 MVC   BEGL2TXT(0,@09),MSGTXT(TXTPTR)
@SM01288 MVC   WPLTXT(0,WPLPTR),MSGTXT(TXTPTR)
@SM01290 MVC   ENQCORE(0),ENQLIST
@SM01293 MVC   SWMID(0,@14),SWIDMTXT-SWMSGID(@05)
@SM01295 MVC   SWMVAR(0,@14),MSGTXT(TXTPTR)
@DATD    DSECT
         DS    0F
@SA00001 DS    18F
@PC00001 DS    1F
@PC00002 DS    2F
@SA00003 DS    15F
@AL00001 DS    3A
@TF00001 DS    F
IEFAB487 CSECT
         DS    0F
@CF01268 DC    F'28'
@CH01268 EQU   @CF01268+2
@CF01283 DC    F'-4'
@DATD    DSECT
         DS    0D
EDLUCBLP DS    A
GRPPTR   DS    A
ALCUNITS DS    F
CCATCTR  DS    F
GRPCTR   DS    F
MSGLNTH  DS    F
OFLUNITS DS    F
RPLYECB  DS    F
TXTLNTH  DS    F
TOTUNITS DS    F
EDTPTR   DS    A
LUVPTR   DS    A
GENPTR   DS    A
GRPTABP  DS    A
EDLPTR   DS    A
EDLGNTP  DS    A
DEVCTR   DS    F
SPTR     DS    A
TMPVUCTR DS    F
TMPVUPTR DS    A
COMPRTEC DS    BL1
INTNLSWS DS    BL1
         ORG   INTNLSWS
ALCGRPSW DS    BL1
OFLGRPSW EQU   INTNLSWS+0
INVLRSW  EQU   INTNLSWS+0
         ORG   INTNLSWS+1
LCLFLGS  DS    BL1
         ORG   LCLFLGS
@NM00001 DS    BL1
LCLFLGB  EQU   LCLFLGS+0
LCLFLGC  EQU   LCLFLGS+0
LCLFLGD  EQU   LCLFLGS+0
@NM00002 EQU   LCLFLGS+0
LCLFLGG  EQU   LCLFLGS+0
         ORG   LCLFLGS+1
         DS    CL1
MSGID    DS    CL4
MSGRPOS  DS    CL4
RPLYBUFR DS    CL6
         DS    CL2
RPLYDATA DS    CL8
         ORG   RPLYDATA
RPLYSWS  DS    BL1
         ORG   RPLYSWS
SWAITSW  DS    BL1
WAITRSW  EQU   RPLYSWS+0
@NM00006 EQU   RPLYSWS+0
@NM00007 EQU   RPLYSWS+0
@NM00008 EQU   RPLYSWS+0
@NM00009 EQU   RPLYSWS+0
@NM00010 EQU   RPLYSWS+0
@NM00011 EQU   RPLYSWS+0
         ORG   RPLYDATA+1
RPLYRTEC DS    BL1
RPLYOPT  DS    FL1
@NM00012 DS    FL1
RPLYVUP  DS    AL4
         ORG   RPLYDATA+8
SAVDDNM  DS    CL8
CNVTDNUM DS    CL8
WTORL    DS    CL280
         ORG   WTORL
@NM00052 DS    CL8
WTOL     DS    CL138
         ORG   WTOL
@NM00053 DS    CL130
@NM00054 DS    CL8
         ORG   WTORL+146
MLWTOL   DS    CL134
         ORG   MLWTOL
@NM00055 DS    CL4
@NM00056 DS    CL130
         ORG   WTORL+280
@OLDKEY  DS    AL1
IEFAB487 CSECT
         DS    0F
@SIZDATD DC    AL1(230)
         DC    AL3(@ENDDATD-@DATD)
@CA00146 DC    A(HDRMSG1)
@CA00149 DC    A(HDR2OFFS)
@CA00152 DC    A(INVWTMSG)
@CA00155 DC    A(RPLYWAIT)
@CA00158 DC    A(SWMSGID)
@CA00161 DC    A(SWMSGOFS)
@CA00164 DC    A(HDRMSG2)
@CV00165 DC    V(IEFAB4F3)
@CV00166 DC    V(IEFAB488)
@CV00167 DC    V(IEFAB48A)
@CA00168 DC    A(SWMSGOPS)
         DS    0D
WTOFLGLN DC    AL4(2+2)
@CC00202 DC    C'HOLD  '
@CC00206 DC    C'NOHOLD'
@CB00197 DC    X'404040404040'
@CB00231 DC    X'F0'
ALLOCMAJ DC    CL8'SYSIEFSD'
ALLOCMIN DC    CL8'CHNGDEVS'
DDRDAMIN DC    CL5'DDRDA'
DDRTUMIN DC    CL7'DDRTPUR'
IEFAB487 CSECT
ENQLIST ENQ (ALLOCMAJ,ALLOCMIN,S,8,SYSTEM),MF=L ENQ/DEQ LIST FORM
ENQLNTH DC A(*-ENQLIST)               LENGTH OF LIST        @YM04401
@DATD    DSECT
ENQCORE ENQ (,,S,,SYSTEM),MF=L                              @YM04401
IEFAB487 CSECT
         DS   0H
A487PTCH DC ((@DATA-@PSTART)/20)X'00'
@DATD    DSECT
         ORG   *+1-(*-@DATD)/(*-@DATD) INSURE DSECT DATA
@ENDDATD EQU   *
IEFAB487 CSECT
@00      EQU   00                      EQUATES FOR REGISTERS 0-15
@01      EQU   01
@02      EQU   02
@03      EQU   03
@04      EQU   04
@05      EQU   05
@06      EQU   06
@07      EQU   07
@08      EQU   08
@09      EQU   09
@10      EQU   10
@11      EQU   11
@12      EQU   12
@13      EQU   13
@14      EQU   14
@15      EQU   15
CNVTCTR  EQU   @02
VUCTR    EQU   @09
RETCODE  EQU   @08
PRVTOTAL EQU   @07
MSGOFFS  EQU   @06
WPLPTR   EQU   @04
VUPTR    EQU   @02
UCBPTR   EQU   @07
TXTPTR   EQU   @05
SIOTPTR  EQU   @03
RQLSTPTR EQU   @05
LINE2PTR EQU   @02
GPLSTPTR EQU   @03
GPCNTPTR EQU   @06
REG1     EQU   @01
REG0     EQU   @00
REG15    EQU   @15
GPR00F   EQU   @00
GPR01F   EQU   @01
         EXTRN HDRMSG1
         EXTRN HDR2OFFS
         EXTRN INVWTMSG
         EXTRN RPLYWAIT
         EXTRN SWMSGID
         EXTRN SWMSGOFS
         EXTRN HDRMSG2
         EXTRN SWMSGOPS
AUNEEDED EQU   0
MSGNAMES EQU   0
MSGJNAME EQU   MSGNAMES+8
MSGSNAME EQU   MSGNAMES+17
MSGPSNME EQU   MSGNAMES+26
MSGL2FMT EQU   0
BEGLINE2 EQU   MSGL2FMT
BEGL2TXT EQU   MSGL2FMT+8
MSGTXT   EQU   0
OUNEEDED EQU   0
SWMIDFMT EQU   0
SWMID    EQU   SWMIDFMT
SWMSGDDN EQU   SWMID+19
SWMSGCCN EQU   SWMID+28
SWMRPOS  EQU   SWMSGCCN+1
SWMVAR   EQU   0
SWMVOL   EQU   0
SWMUNIT  EQU   0
TUNEEDED EQU   0
VAROFFS  EQU   0
VAROFS1  EQU   VAROFFS
VAROFS2  EQU   VAROFFS+1
INDMSIOT EQU   0
SCTDDNAM EQU   INDMSIOT+4
SCTUSADD EQU   INDMSIOT+20
SIOTBYT1 EQU   INDMSIOT+43
SIOTALCD EQU   SIOTBYT1
SIOTBYT3 EQU   INDMSIOT+46
SIOTTSTC EQU   INDMSIOT+47
SIOTBYT0 EQU   INDMSIOT+52
SCTSDISP EQU   INDMSIOT+55
SCTSBYT1 EQU   INDMSIOT+56
SCTSBYT2 EQU   INDMSIOT+57
SCTSBYT3 EQU   INDMSIOT+58
SCTSBYT4 EQU   INDMSIOT+59
SCTUTYPE EQU   INDMSIOT+60
SIOTDEVT EQU   SCTUTYPE
SIOUBYT3 EQU   SIOTDEVT+2
SIOUCBAD EQU   SCTUTYPE+5
SIOTBYT4 EQU   INDMSIOT+81
SIOTALTD EQU   INDMSIOT+92
SIOTBYT2 EQU   INDMSIOT+103
SIOTDMND EQU   SIOTBYT2
SIOTEDLP EQU   INDMSIOT+136
SVOLUNAD EQU   INDMSIOT+140
SIOTNPTR EQU   INDMSIOT+152
SVOLUNNO EQU   INDMSIOT+168
UCB      EQU   0
UCBOB    EQU   0
UCBJBNR  EQU   UCBOB
UCBFL5   EQU   UCBOB+1
UCBAF    EQU   UCBFL5
UCBSTAT  EQU   UCBOB+3
UCBCHAN  EQU   UCBOB+4
UCBSFLS  EQU   UCBOB+6
UCBFLA   EQU   UCBSFLS
UCBFL1   EQU   UCBFLA
UCBBSY   EQU   UCBFL1
UCBNRY   EQU   UCBFL1
UCBPST   EQU   UCBFL1
UCBCUB   EQU   UCBFL1
UCBFLB   EQU   UCBSFLS+1
UCBCHM   EQU   UCBOB+8
UCBCHM1  EQU   UCBCHM
UCBPTH0  EQU   UCBCHM1
UCBPTH1  EQU   UCBCHM1
UCBWGT   EQU   UCBOB+12
UCBNAME  EQU   UCBOB+13
UCBTYP   EQU   UCBOB+16
UCBTBYT1 EQU   UCBTYP
UCB1FEA5 EQU   UCBTBYT1
UCB1FEA6 EQU   UCBTBYT1
UCBTBYT2 EQU   UCBTYP+1
UCB2OPT2 EQU   UCBTBYT2
UCBDUDN1 EQU   UCB2OPT2
UCB2OPT3 EQU   UCBTBYT2
UCBDUDN2 EQU   UCB2OPT3
UCB2OPT4 EQU   UCBTBYT2
UCBRWTAU EQU   UCB2OPT4
UCB2OPT6 EQU   UCBTBYT2
UCB2OPT7 EQU   UCBTBYT2
UCBTBYT3 EQU   UCBTYP+2
UCBDVCLS EQU   UCBTBYT3
UCB3TAPE EQU   UCBDVCLS
UCB3DACC EQU   UCBDVCLS
UCB3UREC EQU   UCBDVCLS
UCBTBYT4 EQU   UCBTYP+3
UCBEXTPT EQU   UCBOB+20
UCBFLC   EQU   UCBEXTPT
UCBDEV   EQU   UCBOB+24
UCBCMEXT EQU   0
UCBATI   EQU   UCBCMEXT+3
@NM00033 EQU   UCBATI
UCBFLP1  EQU   UCBCMEXT+5
UCBMIHTI EQU   UCBCMEXT+16
@NM00034 EQU   UCBMIHTI
UCBMT    EQU   0
UCBOCR   EQU   0
UCB3540X EQU   0
UCBDKBYT EQU   UCB3540X+6
UCB3800X EQU   0
UCBOPTNS EQU   UCB3800X
UCBACTIV EQU   UCB3800X+3
UCBMDRBF EQU   UCB3800X+36
UCBUCS   EQU   0
UCBUCSOP EQU   UCBUCS+4
UCBFCBOP EQU   UCBUCS+5
EDTHDR   EQU   0
EDTLUVSP EQU   EDTHDR
EDTGENSP EQU   EDTHDR+4
EDTGRPSP EQU   EDTHDR+8
EDTUCBSP EQU   EDTHDR+12
EDTMSKTP EQU   EDTHDR+16
LUVSECT  EQU   0
LUVHDR   EQU   LUVSECT
LUVENTRY EQU   0
LUVGMTP  EQU   LUVENTRY+12
LUVFLAGS EQU   LUVENTRY+24
GENSECT  EQU   0
GENHDR   EQU   GENSECT
GENENTRY EQU   0
GRPTRTAB EQU   0
GRPSECT  EQU   0
GRPHDR   EQU   GRPSECT
GRPENTRY EQU   0
GRPUCBP  EQU   GRPENTRY+8
EUCBSECT EQU   0
EUCBHDR  EQU   EUCBSECT
EUCBENTY EQU   0
GRMSKTAB EQU   0
GMTHDR   EQU   GRMSKTAB
GMTENTRY EQU   0
IEFEDL   EQU   0
EDLHDR   EQU   IEFEDL
EDLUVFLG EQU   EDLHDR+16
EDLENTRY EQU   0
EDLDTFLG EQU   EDLENTRY+20
EDLGNTRY EQU   0
EDLGRFLG EQU   EDLGNTRY+16
EDLUCBL  EQU   0
EDLINDIC EQU   EDLUCBL+2
VOLUNTAB EQU   0
VOLSTAT  EQU   VOLUNTAB+6
VOLSTATA EQU   VOLSTAT
VOLSTATB EQU   VOLSTAT+1
VOLALOC  EQU   VOLSTATB
VOLSTATC EQU   VOLSTAT+2
VOLTAREQ EQU   VOLSTATC
VOLDAREQ EQU   VOLSTATC
VOLURREQ EQU   VOLSTATC
VOLSTATD EQU   VOLSTAT+3
VUDMNDOF EQU   VOLSTATD
VUDMNDAL EQU   VOLSTATD
VUDMUNIQ EQU   VOLSTATD
VUVLUNIQ EQU   VOLSTATD
VURCVYPR EQU   VOLSTATD
VOLALGTP EQU   VOLUNTAB+12
VOLSIOTP EQU   VOLUNTAB+16
VUUCBP   EQU   VOLUNTAB+20
VUGRID   EQU   VOLUNTAB+24
VUPOOL   EQU   0
VUGRLST  EQU   0
VUGRLENT EQU   VUGRLST
VUGRLFLG EQU   VUGRLENT+4
ALCWA    EQU   0
FMAPPTR  EQU   ALCWA+4
SIOT1P   EQU   ALCWA+8
IOSLUTP  EQU   ALCWA+16
FAILRSCP EQU   ALCWA+20
CNTABLE  EQU   ALCWA+28
VOLUNPTR EQU   ALCWA+80
VOLUNSZE EQU   ALCWA+84
ALGTABP  EQU   ALCWA+88
INDICATE EQU   ALCWA+112
INDWAIT  EQU   INDICATE
INDREQU  EQU   INDICATE
@NM00043 EQU   ALCWA+113
DDRTPUR  EQU   @NM00043
DDRDA    EQU   @NM00043
TIOTHDRP EQU   ALCWA+120
NAMES    EQU   0
ALCJOBN  EQU   NAMES
ALCSTEPN EQU   NAMES+8
ALCPROCN EQU   NAMES+16
ALGPTRS  EQU   0
CVRPARM  EQU   0
CVRFLG1  EQU   CVRPARM+8
CVRRQLST EQU   0
CVRMIN   EQU   CVRRQLST+10
CVRFLG2  EQU   CVRRQLST+16
CVRSKFLG EQU   CVRFLG2
CVRNGRP  EQU   CVRRQLST+18
CVRGRPPT EQU   CVRRQLST+20
CVRWUCBP EQU   CVRRQLST+24
CVRGPLST EQU   0
CVRGCPTR EQU   CVRGPLST
CVRGALL  EQU   CVRGPLST+8
CVRFLG3  EQU   CVRGPLST+12
CVRGSKP  EQU   CVRFLG3
GRPCOUNT EQU   0
GRPALLCT EQU   GRPCOUNT+2
GRPOFFLN EQU   GRPCOUNT+4
FUNCMAP  EQU   0
VOLMNTSW EQU   FUNCMAP
WRTMSGSW EQU   FUNCMAP
UWAITSW  EQU   FUNCMAP
VWAITSW  EQU   FUNCMAP
MSSTRMSW EQU   FUNCMAP
OFFDEVSW EQU   FUNCMAP
CCLMNTSW EQU   FUNCMAP
GENLOKSW EQU   FUNCMAP
SSEMSGSW EQU   FUNCMAP+1
HDRMSGSW EQU   FUNCMAP+1
MTRJOBSW EQU   FUNCMAP+1
NOTIOTNQ EQU   FUNCMAP+1
TRKMSW   EQU   FUNCMAP+1
WAITOKSW EQU   FUNCMAP+1
ASNMSW   EQU   FUNCMAP+1
WPLRF    EQU   0
WPLRPTR  EQU   WPLRF
WPLRLN   EQU   WPLRPTR
WPLRPTRA EQU   WPLRPTR+1
WPLRECB  EQU   WPLRF+4
WPL      EQU   0
WPLLGH   EQU   WPL
WPLMCSF  EQU   WPL+2
WPLMCSF1 EQU   WPLMCSF
WPLMCSFA EQU   WPLMCSF1
WPLMCSF2 EQU   WPLMCSF+1
WPLMCSFJ EQU   WPLMCSF2
WPLTXT   EQU   WPL+4
WPLFLGS  EQU   0
WPLDESC  EQU   WPLFLGS
WPLDESC1 EQU   WPLDESC
WPLDESCB EQU   WPLDESC1
WPLDESCF EQU   WPLDESC1
WPLDESC2 EQU   WPLDESC+1
WPLROUT  EQU   WPLFLGS+2
WPLROUT1 EQU   WPLROUT
WPLROUTB EQU   WPLROUT1
WPLROUT2 EQU   WPLROUT+1
WPLMSGTY EQU   WPLFLGS+4
WPLMSGT1 EQU   WPLMSGTY
WPLMSGT2 EQU   WPLMSGTY+1
WPLLS01  EQU   0
WPLLTF   EQU   WPLLS01
WPLLTF1  EQU   WPLLTF
WPLLTFC  EQU   WPLLTF1
WPLLINES EQU   WPLLS01+3
WPLML    EQU   0
WPLML0   EQU   WPLML
WPLMLLEN EQU   WPLML+1
WPLMLLTF EQU   WPLML+2
WPLMLLT1 EQU   WPLMLLTF
WPLMLLTC EQU   WPLMLLT1
WPLMLLTD EQU   WPLMLLT1
WPLMLTXT EQU   WPLML+4
IOSLUT   EQU   0
I001C    EQU   0
I008P    EQU   0
I015F    EQU   0
I015P    EQU   0
I031F    EQU   0
I031P    EQU   0
I256C    EQU   0
RSNCODE  EQU   0
UCBBGN   EQU   0
MSG1LNTH EQU   HDRMSG1
NOUNOFFS EQU   HDRMSG1+2
HDRLINE1 EQU   HDRMSG1+3
HMSGOFFS EQU   HDR2OFFS
HMSGTXTL EQU   HDR2OFFS+2
INVWMSGL EQU   INVWTMSG
INVWMTXT EQU   INVWTMSG+2
RWATMSGL EQU   RPLYWAIT
RWATMTXT EQU   RPLYWAIT+2
SWIDMSGL EQU   SWMSGID
SWIDMTXT EQU   SWMSGID+2
SPWTOFFS EQU   SWMSGOFS
SPWMTXTL EQU   SWMSGOFS+2
ALCWAPTR EQU   0
CNVTIN   EQU   0
CNVTOUT  EQU   0
UCBOBS01 EQU   UCBDEV
UCBVOLI  EQU   UCBOBS01+4
UCBSTAB  EQU   UCBOBS01+10
UCBBSVL  EQU   UCBSTAB
UCBPRSRS EQU   UCBSTAB
UCBDMCT  EQU   UCBOBS01+11
UCBFL4   EQU   UCBOBS01+13
UCBOBS02 EQU   UCBDEV
UCBTFL1  EQU   UCBOBS02+19
UCBXTN   EQU   UCBOBS02+20
UCBVOPT  EQU   UCBXTN
UCBOBS03 EQU   UCBDEV
UCBXTADR EQU   UCBOBS03
UCBOBS04 EQU   UCBDEV
UCBBTA   EQU   UCBOBS04+12
UCBOBS06 EQU   UCBDEV
UCBAOF   EQU   UCBOBS06
UCBAOF1  EQU   UCBAOF
UCBAOF2  EQU   UCBAOF+1
@NM00032 EQU   UCBOBS06+3
UCBIRB   EQU   UCBOBS06+4
UCBGRAF  EQU   UCBIRB
UCBLDNCA EQU   UCBOBS06+8
UCBRDYQ  EQU   UCBLDNCA
UCBIRLN  EQU   UCBRDYQ
UCBLDNCB EQU   UCBRDYQ+1
UCBCTLNK EQU   UCBOBS06+12
UCBOBS07 EQU   UCBDEV
UCBOBS08 EQU   UCBDEV
UCBCTCAD EQU   UCBOBS08
UCBCTCF1 EQU   UCBOBS08+4
UCBOBS09 EQU   UCBDEV
         AGO   .@UNREFD                START UNREFERENCED COMPONENTS
UCBRV066 EQU   UCBOBS09+4
UCBIOSBA EQU   UCBOBS09
UCBRV042 EQU   UCBOBS08+5
UCBRV082 EQU   UCBCTCF1
UCBRV081 EQU   UCBCTCF1
UCBRV080 EQU   UCBCTCF1
UCBRV079 EQU   UCBCTCF1
UCBRV078 EQU   UCBCTCF1
UCBRV077 EQU   UCBCTCF1
UCBRV076 EQU   UCBCTCF1
UCBCTC80 EQU   UCBCTCF1
UCBCTCAL EQU   UCBCTCAD
UCBICNCB EQU   UCBOBS07+4
UCBRV040 EQU   UCBOBS07
UCBCTLNA EQU   UCBCTLNK+1
UCBRLN   EQU   UCBCTLNK
UCBRDYQA EQU   UCBLDNCB
UCBINRLN EQU   UCBIRLN
UCBIRBA  EQU   UCBIRB+1
UCBRV039 EQU   UCBGRAF
UCBDWNR  EQU   UCBGRAF
UCBRPND  EQU   UCBGRAF
UCBUPM   EQU   UCBGRAF
UCBBTAM  EQU   UCBGRAF
UCBDRNO  EQU   UCBGRAF
UCBDRO   EQU   UCBGRAF
UCBOIP   EQU   UCBGRAF
UCBATRCD EQU   @NM00032
UCBSKPFG EQU   @NM00032
UCBRIPND EQU   @NM00032
UCBRTIAC EQU   @NM00032
UCBRSV79 EQU   @NM00032
UCBRSV78 EQU   @NM00032
UCBRSV77 EQU   @NM00032
UCBOLTEP EQU   @NM00032
UCBATNCT EQU   UCBOBS06+2
UCBRSV76 EQU   UCBAOF2
UCBRSV75 EQU   UCBAOF2
UCBRSV74 EQU   UCBAOF2
UCBRSV73 EQU   UCBAOF2
UCBRSV72 EQU   UCBAOF2
UCBRSV71 EQU   UCBAOF2
UCBRSV70 EQU   UCBAOF2
UCBRSV69 EQU   UCBAOF2
UCBRSV68 EQU   UCBAOF1
UCBRSV67 EQU   UCBAOF1
UCBRSV66 EQU   UCBAOF1
UCBRSV65 EQU   UCBAOF1
UCBRSV64 EQU   UCBAOF1
UCBOFNL  EQU   UCBAOF1
UCBOFSP  EQU   UCBAOF1
UCBOFMCR EQU   UCBAOF1
UCBBTB   EQU   UCBBTA+1
UCBDI    EQU   UCBBTA
UCBSNS   EQU   UCBOBS04+8
UCBTEB   EQU   UCBOBS04+4
UCBGCB   EQU   UCBOBS04+3
UCBOPEN  EQU   UCBOBS04+2
UCBSTART EQU   UCBOBS04
UCBXTNB  EQU   UCBXTN+1
UCBRSV22 EQU   UCBVOPT
UCBRSV21 EQU   UCBVOPT
UCBRSV20 EQU   UCBVOPT
UCBESVE  EQU   UCBVOPT
UCBERPC  EQU   UCBVOPT
UCBESVC  EQU   UCBVOPT
UCBEVA   EQU   UCBVOPT
UCBESV   EQU   UCBVOPT
UCBRV009 EQU   UCBTFL1
UCBRV008 EQU   UCBTFL1
UCBRV007 EQU   UCBTFL1
UCBRV006 EQU   UCBTFL1
UCBRV005 EQU   UCBTFL1
UCBDQDSP EQU   UCBTFL1
UCBNSLTP EQU   UCBTFL1
UCBNLTP  EQU   UCBTFL1
UCBRES1B EQU   UCBOBS02+18
UCBFSER  EQU   UCBOBS02+12
@NM00031 EQU   UCBOBS02+4
UCBFSEQ  EQU   UCBOBS02+2
UCBFSCT  EQU   UCBOBS02
UCBNEXP  EQU   UCBOBS01+20
UCBBASE  EQU   UCBOBS01+16
UCBRES1A EQU   UCBOBS01+15
UCBUSER  EQU   UCBOBS01+14
UCBFL47  EQU   UCBFL4
UCBFL46  EQU   UCBFL4
UCBFL45  EQU   UCBFL4
UCBRV065 EQU   UCBFL4
UCBDSS   EQU   UCBFL4
UCBRESVP EQU   UCBFL4
UCBWDAV  EQU   UCBFL4
UCBDAVV  EQU   UCBFL4
UCBSQC   EQU   UCBOBS01+12
UCBDATP  EQU   UCBOBS01+12
UCBDMC   EQU   UCBDMCT
UCBMOUNT EQU   UCBDMCT
UCBBNUL  EQU   UCBSTAB
UCBSHAR  EQU   UCBSTAB
UCBBSTR  EQU   UCBSTAB
UCBBPUB  EQU   UCBSTAB
UCBBPRV  EQU   UCBSTAB
UCBBALB  EQU   UCBPRSRS
UCBPGFL  EQU   UCBSTAB
UCBDVSHR EQU   UCBBSVL
UCBVTOC  EQU   UCBOBS01
WPLMLLT2 EQU   WPLMLLTF+1
WPLRSV24 EQU   WPLMLLT1
WPLRSV23 EQU   WPLMLLT1
WPLRSV22 EQU   WPLMLLT1
WPLRSV21 EQU   WPLMLLT1
WPLMLLTB EQU   WPLMLLT1
WPLMLLTA EQU   WPLMLLT1
WPLAREA  EQU   WPLLS01+2
WPLLTF2  EQU   WPLLTF+1
WPLRSV20 EQU   WPLLTF1
WPLRSV19 EQU   WPLLTF1
WPLRSV18 EQU   WPLLTF1
WPLRSV17 EQU   WPLLTF1
WPLLTFD  EQU   WPLLTF1
WPLLTFB  EQU   WPLLTF1
WPLLTFA  EQU   WPLLTF1
WPLQID   EQU   WPLFLGS+6
WPLRSV32 EQU   WPLMSGT2
WPLRSV31 EQU   WPLMSGT2
WPLRSV30 EQU   WPLMSGT2
WPLRSV29 EQU   WPLMSGT2
WPLRSV28 EQU   WPLMSGT2
WPLRSV27 EQU   WPLMSGT2
WPLRSV26 EQU   WPLMSGT2
WPLRSV25 EQU   WPLMSGT2
WPLRSV16 EQU   WPLMSGT1
WPLRSV15 EQU   WPLMSGT1
WPLMSGTF EQU   WPLMSGT1
WPLRSV14 EQU   WPLMSGT1
WPLMSGTD EQU   WPLMSGT1
WPLMSGTC EQU   WPLMSGT1
WPLMSGTB EQU   WPLMSGT1
WPLMSGTA EQU   WPLMSGT1
WPLRSV13 EQU   WPLROUT2
WPLROUTO EQU   WPLROUT2
WPLROUTN EQU   WPLROUT2
WPLROUTM EQU   WPLROUT2
WPLROUTL EQU   WPLROUT2
WPLROUTK EQU   WPLROUT2
WPLROUTJ EQU   WPLROUT2
WPLROUTI EQU   WPLROUT2
WPLROUTH EQU   WPLROUT1
WPLROUTG EQU   WPLROUT1
WPLROUTF EQU   WPLROUT1
WPLROUTE EQU   WPLROUT1
WPLROUTD EQU   WPLROUT1
WPLROUTC EQU   WPLROUT1
WPLROUTA EQU   WPLROUT1
WPLRSV12 EQU   WPLDESC2
WPLRSV11 EQU   WPLDESC2
WPLRSV10 EQU   WPLDESC2
WPLRSV09 EQU   WPLDESC2
WPLRSV08 EQU   WPLDESC2
WPLRSV07 EQU   WPLDESC2
WPLDESCJ EQU   WPLDESC2
WPLDESCI EQU   WPLDESC2
WPLDESCH EQU   WPLDESC1
WPLDESCG EQU   WPLDESC1
WPLDESCE EQU   WPLDESC1
WPLDESCD EQU   WPLDESC1
WPLDESCC EQU   WPLDESC1
WPLDESCA EQU   WPLDESC1
WPLTXTL  EQU   WPLTXT+125
@NM00051 EQU   WPLTXT
WPLRSV05 EQU   WPLMCSF2
WPLRSV04 EQU   WPLMCSF2
WPLMCSFN EQU   WPLMCSF2
WPLRSV03 EQU   WPLMCSF2
WPLNOWTP EQU   WPLMCSF2
WPLMCSFK EQU   WPLMCSF2
WPLMCSFI EQU   WPLMCSF2
WPLMCSFH EQU   WPLMCSF1
WPLMCSFG EQU   WPLMCSF1
WPLMCSFF EQU   WPLMCSF1
WPLMCSFE EQU   WPLMCSF1
WPLMCSFD EQU   WPLMCSF1
WPLMCSFC EQU   WPLMCSF1
WPLMCSFB EQU   WPLMCSF1
EXTRACAL EQU   FUNCMAP+1
ALCASDSN EQU   ASNMSW
ALCSUBWT EQU   WAITOKSW
ALCATRKM EQU   TRKMSW
ALCNOENQ EQU   NOTIOTNQ
ALCJOBNM EQU   MTRJOBSW
ALCHDMSG EQU   HDRMSGSW
ALCSSMSG EQU   SSEMSGSW
ALCGENER EQU   GENLOKSW
ALCCANCL EQU   CCLMNTSW
ALCOFFDV EQU   OFFDEVSW
ALCMSSTM EQU   MSSTRMSW
ALCWTVOL EQU   VWAITSW
ALCWTUNT EQU   UWAITSW
ALCMSGLV EQU   WRTMSGSW
ALCMOUNT EQU   VOLMNTSW
GRPWPTR  EQU   GRPCOUNT+12
GRPIDENT EQU   GRPCOUNT+10
GRPEXCS  EQU   GRPCOUNT+8
GRPTOTAL EQU   GRPCOUNT+6
GRPAVAIL EQU   GRPCOUNT
@NM00050 EQU   CVRGPLST+13
@NM00049 EQU   CVRFLG3
CVRFORCI EQU   CVRFLG3
CVRBOUND EQU   CVRGPLST+10
CVRGRPAL EQU   CVRGPLST+6
CVRGRPID EQU   CVRGPLST+4
@NM00048 EQU   CVRRQLST+26
@NM00047 EQU   CVRFLG2+1
CVRDUPLI EQU   CVRFLG2+1
CVRWMOVE EQU   CVRFLG2
CVRIGNOR EQU   CVRFLG2
CVRMULTI EQU   CVRFLG2
CVRSCRTH EQU   CVRFLG2
CVRFULL  EQU   CVRFLG2
CVRREACH EQU   CVRFLG2
CVRRUSED EQU   CVRFLG2
CVRGNEXT EQU   CVRRQLST+12
CVRPTS   EQU   CVRMIN
CVRNEED  EQU   CVRRQLST+8
CVRALLCT EQU   CVRRQLST+6
CVRREQ1  EQU   CVRRQLST+4
CVRVUPTR EQU   CVRRQLST
@NM00046 EQU   CVRPARM+9
@NM00045 EQU   CVRFLG1
CVRFCALL EQU   CVRFLG1
CVROFFLG EQU   CVRFLG1
CVRALFLG EQU   CVRFLG1
CVRAVFLG EQU   CVRFLG1
CVRGRPLK EQU   CVRPARM+6
CVRNREQ  EQU   CVRPARM+4
CVRRQPTR EQU   CVRPARM
ALGGCNTP EQU   ALGPTRS+12
ALGGLSTP EQU   ALGPTRS+8
ALGRQLTP EQU   ALGPTRS+4
ALGPARMP EQU   ALGPTRS
LOJSSNMP EQU   ALCWA+164
SSERBLKP EQU   ALCWA+160
GROUPSZ  EQU   ALCWA+156
GRIDPTR  EQU   ALCWA+152
ALCNUCBS EQU   ALCWA+148
EXITPRMP EQU   ALCWA+144
CANCELP  EQU   ALCWA+140
WORK3MP  EQU   ALCWA+136
WMASK2P  EQU   ALCWA+132
WMASKPTR EQU   ALCWA+128
LGENLOCK EQU   ALCWA+124
TCBP     EQU   ALCWA+116
ALCWASID EQU   ALCWA+114
@NM00044 EQU   @NM00043
NODEVERR EQU   @NM00043
NEEDRCVY EQU   @NM00043
ALCWAREC EQU   @NM00043
WAITIGEN EQU   @NM00043
UNITRECS EQU   @NM00043
ALCWADUL EQU   INDICATE
ALCWISAM EQU   INDICATE
DSSUNIT  EQU   INDICATE
DSSTAPE  EQU   INDICATE
PRIVASUM EQU   INDICATE
INDRETRY EQU   INDICATE
QMGRRBP  EQU   ALCWA+108
RIMTABCT EQU   ALCWA+104
RIMTABLN EQU   ALCWA+100
RIMTABP  EQU   ALCWA+96
ALGTABSZ EQU   ALCWA+92
@NM00042 EQU   ALCWA+78
LTUNITID EQU   ALCWA+76
TOTVOLUN EQU   CNTABLE+44
NUMREQS  EQU   CNTABLE+40
TOTREQS  EQU   CNTABLE+36
OTHEREQS EQU   CNTABLE+32
SUBSREQS EQU   CNTABLE+28
STRGREQS EQU   CNTABLE+24
PUBLREQS EQU   CNTABLE+20
PVTNREQS EQU   CNTABLE+16
SPECREQS EQU   CNTABLE+12
TPREQS   EQU   CNTABLE+8
VAMREQS  EQU   CNTABLE+4
DMYREQS  EQU   CNTABLE
EDTABPTR EQU   ALCWA+24
JSCBPTR  EQU   ALCWA+12
WASIZE   EQU   ALCWA
@NM00041 EQU   VUGRLENT+5
@NM00040 EQU   VUGRLFLG
VUGRALCD EQU   VUGRLFLG
VUGRLIDS EQU   VUGRLENT
VUCBS    EQU   VUPOOL+4
VUPOOL#  EQU   VUPOOL
VOLUNTID EQU   VOLUNTAB+10
VUUNALSW EQU   VOLSTATD
VUREALOC EQU   VOLSTATD
VUMUGDON EQU   VOLSTATD
@NM00039 EQU   VOLSTATC
@NM00038 EQU   VOLSTATC
VURECVRY EQU   VOLSTATC
VOLGRREQ EQU   VOLSTATC
VOLCOREQ EQU   VOLSTATC
VUAFFWRK EQU   VOLSTATB
VUVINELG EQU   VOLSTATB
VUDADSME EQU   VOLSTATB
VUDNALOC EQU   VOLSTATB
VUPROCED EQU   VOLSTATB
VDEVREQD EQU   VOLSTATB
VOLMNTD  EQU   VOLSTATB
VOLDEFER EQU   VOLSTATA
VUDADSM  EQU   VOLSTATA
VOLRESVE EQU   VOLSTATA
VOLNSHR  EQU   VOLSTATA
VOLSTG   EQU   VOLSTATA
VOLSPEC  EQU   VOLSTATA
VOLPRV   EQU   VOLSTATA
VOLPUB   EQU   VOLSTATA
VOLID    EQU   VOLUNTAB
EDLNOJES EQU   EDLINDIC
EDLVOLAF EQU   EDLINDIC
EDLENQ   EQU   EDLINDIC
EDLDADSM EQU   EDLINDIC
EDLALCD  EQU   EDLINDIC
EDLUCBAD EQU   EDLUCBL
EDLJINEL EQU   EDLGRFLG
EDLGRID  EQU   EDLGNTRY+12
EDLLISTP EQU   EDLGNTRY+8
EDLUCBNO EQU   EDLGNTRY+4
EDLNXGRP EQU   EDLGNTRY
EINDEVTP EQU   EDLDTFLG
@NM00037 EQU   EDLENTRY+18
EDLNSCNT EQU   EDLENTRY+16
EDLGRPTR EQU   EDLENTRY+12
EDLGRPNO EQU   EDLENTRY+8
EDLDEVT  EQU   EDLENTRY+4
EDLNXTNT EQU   EDLENTRY
EDLMGENS EQU   EDLUVFLG
EDLVAM   EQU   EDLUVFLG
EDLGMTP  EQU   EDLHDR+12
EDLFGENP EQU   EDLHDR+8
EDLGENNO EQU   EDLHDR+4
EDLLUV   EQU   EDLHDR
GRPMASK  EQU   GMTENTRY
GMTENTLN EQU   GMTHDR+4
GMTENTNO EQU   GMTHDR
EUCBTPOS EQU   EUCBENTY
EUCBENLN EQU   EUCBHDR+4
EUCBENNO EQU   EUCBHDR
GRPUCBNO EQU   GRPENTRY+4
GRPID    EQU   GRPENTRY
GRPENTLN EQU   GRPHDR+4
GRPENTNO EQU   GRPHDR
GRPTR    EQU   GRPTRTAB
GENGRPTR EQU   GENENTRY+8
GENGRPNO EQU   GENENTRY+4
GENDEVT  EQU   GENENTRY
GENENTLN EQU   GENHDR+4
GENENTNO EQU   GENHDR
LUVAGMTP EQU   LUVENTRY+28
@NM00036 EQU   LUVFLAGS
LUVMGENS EQU   LUVFLAGS
LUVAGMSK EQU   LUVFLAGS
LUVVAM   EQU   LUVFLAGS
LUVGENP  EQU   LUVENTRY+20
LUVGENNO EQU   LUVENTRY+16
LUVALUE  EQU   LUVENTRY+8
UNITNAME EQU   LUVENTRY
LUVENTLN EQU   LUVHDR+4
LUVENTNO EQU   LUVHDR
UCBERADR EQU   UCBUCS+12
UCBFCBID EQU   UCBUCS+8
UCBERCNT EQU   UCBUCS+7
UCBRSV51 EQU   UCBUCS+6
UCBFCBPE EQU   UCBFCBOP
UCBRSV49 EQU   UCBFCBOP
UCBRSV48 EQU   UCBFCBOP
UCBRSV47 EQU   UCBFCBOP
UCBRSV46 EQU   UCBFCBOP
UCBRSV45 EQU   UCBFCBOP
UCBRSV44 EQU   UCBFCBOP
UCBFCBO1 EQU   UCBFCBOP
UCBUCSPE EQU   UCBUCSOP
UCBRSV43 EQU   UCBUCSOP
UCBRSV42 EQU   UCBUCSOP
UCBRSV41 EQU   UCBUCSOP
UCBRSV40 EQU   UCBUCSOP
UCBRSV39 EQU   UCBUCSOP
UCBUCSO2 EQU   UCBUCSOP
UCBUCSO1 EQU   UCBUCSOP
UCBUCSID EQU   UCBUCS
UCBMDRBA EQU   UCBMDRBF+1
UCBRV075 EQU   UCBMDRBF
UCBRV074 EQU   UCB3800X+32
UCBIMAGE EQU   UCB3800X+28
UCBFCBNM EQU   UCB3800X+24
UCBCHAR4 EQU   UCB3800X+20
UCBCHAR3 EQU   UCB3800X+16
UCBCHAR2 EQU   UCB3800X+12
UCBCHAR1 EQU   UCB3800X+8
UCBCGMID EQU   UCB3800X+4
UCBBRSTA EQU   UCBACTIV
UCBRV063 EQU   UCBACTIV
UCBRV062 EQU   UCBACTIV
UCBRV061 EQU   UCBACTIV
UCBRV060 EQU   UCBACTIV
UCBRV059 EQU   UCBACTIV
UCBRV058 EQU   UCBACTIV
UCBRV057 EQU   UCBACTIV
UCBRV050 EQU   UCB3800X+2
UCBCGMNO EQU   UCB3800X+1
UCBRV083 EQU   UCBOPTNS
UCBBRSTR EQU   UCBOPTNS
UCBRV056 EQU   UCBOPTNS
UCBRV055 EQU   UCBOPTNS
UCBRV054 EQU   UCBOPTNS
UCBRV053 EQU   UCBOPTNS
UCBRV052 EQU   UCBOPTNS
UCBRV051 EQU   UCBOPTNS
UCBRV073 EQU   UCB3540X+7
UCBRV072 EQU   UCBDKBYT
UCBRV071 EQU   UCBDKBYT
UCBRV070 EQU   UCBDKBYT
UCBRV069 EQU   UCBDKBYT
UCBRV068 EQU   UCBDKBYT
UCBRV067 EQU   UCBDKBYT
UCBVLVER EQU   UCBDKBYT
UCBDKAMX EQU   UCBDKBYT
UCBVLSER EQU   UCB3540X
UCBRDATA EQU   UCBOCR+4
UCBFRID  EQU   UCBOCR
UCBCLN   EQU   UCBMT+14
UCBERG   EQU   UCBMT+12
UCBMS    EQU   UCBMT+11
UCBNB    EQU   UCBMT+10
UCBPW    EQU   UCBMT+9
UCBPR    EQU   UCBMT+8
UCBSIO   EQU   UCBMT+6
UCBTW    EQU   UCBMT+5
UCBTR    EQU   UCBMT+4
UCBTWT   EQU   UCBMT+3
UCBTRT   EQU   UCBMT+2
UCBCTD   EQU   UCBMT
UCBWTOID EQU   UCBCMEXT+17
@NM00035 EQU   @NM00034
UCBMIHSF EQU   @NM00034
UCBASID  EQU   UCBCMEXT+14
UCBMFCNT EQU   UCBCMEXT+12
UCBPMSK  EQU   UCBCMEXT+10
UCBCCWOF EQU   UCBCMEXT+8
UCBRV041 EQU   UCBCMEXT+6
UCBMIHPB EQU   UCBFLP1
UCBMIHTB EQU   UCBFLP1
UCBERLOG EQU   UCBFLP1
UCBSWAPF EQU   UCBFLP1
UCBINHIO EQU   UCBFLP1
UCBNSWAP EQU   UCBFLP1
UCBSHRUP EQU   UCBFLP1
UCBNSRCH EQU   UCBFLP1
UCBSNSCT EQU   UCBCMEXT+4
UCBHPDV  EQU   @NM00033
UCBHALI  EQU   @NM00033
UCBRSV09 EQU   @NM00033
UCBRSV08 EQU   @NM00033
UCBRSV07 EQU   @NM00033
UCBRSV06 EQU   @NM00033
UCBRSV05 EQU   @NM00033
UCBRSV04 EQU   @NM00033
UCBDTI   EQU   UCBCMEXT+2
UCBSTI   EQU   UCBCMEXT+1
UCBETI   EQU   UCBCMEXT
UCBEXTP  EQU   UCBEXTPT+1
UCBDDRSW EQU   UCBFLC
UCBTICBT EQU   UCBFLC
UCBIVRR  EQU   UCBFLC
UCBIVRS  EQU   UCBFLC
UCBITF   EQU   UCBFLC
UCBUDE   EQU   UCBFLC
UCBWAA   EQU   UCBFLC
UCBATTP  EQU   UCBFLC
UCBUNTYP EQU   UCBTBYT4
UCBRSV11 EQU   UCBDVCLS
UCBRSV10 EQU   UCBDVCLS
UCB3CHAR EQU   UCBDVCLS
UCB3DISP EQU   UCBDVCLS
UCB3COMM EQU   UCBDVCLS
UCBDVPWR EQU   UCB2OPT7
UCBVLPWR EQU   UCB2OPT6
UCB2OPT5 EQU   UCBTBYT2
UCBRVDEV EQU   UCBRWTAU
UCBRPS   EQU   UCBDUDN2
UCBRR    EQU   UCBDUDN1
UCB2OPT1 EQU   UCBTBYT2
UCB2OPT0 EQU   UCBTBYT2
UCB1FEA7 EQU   UCBTBYT1
UCBD6250 EQU   UCB1FEA6
UCBD1600 EQU   UCB1FEA5
UCB1FEA4 EQU   UCBTBYT1
UCB1FEA3 EQU   UCBTBYT1
UCB1FEA2 EQU   UCBTBYT1
UCB1FEA1 EQU   UCBTBYT1
UCB1FEA0 EQU   UCBTBYT1
UCBRV029 EQU   UCBWGT
UCBVHRSN EQU   UCBWGT
UCBVORSN EQU   UCBWGT
UCBMTPXP EQU   UCBWGT
UCBREW   EQU   UCBWGT
UCBPUB   EQU   UCBWGT
UCBOUT   EQU   UCBWGT
UCBIN    EQU   UCBWGT
UCBCPU   EQU   UCBOB+11
UCBLCI   EQU   UCBOB+10
UCBCNT   EQU   UCBOB+9
UCBRV017 EQU   UCBCHM1
UCBRV016 EQU   UCBCHM1
UCBRV015 EQU   UCBCHM1
UCBRV014 EQU   UCBCHM1
UCBSPB   EQU   UCBPTH1
UCBPPB   EQU   UCBPTH1
UCBSPA   EQU   UCBPTH0
UCBPPA   EQU   UCBPTH0
UCBSIGP  EQU   UCBFLB
UCBVALPH EQU   UCBFLB
UCBCRHSN EQU   UCBFLB
UCBCRHRV EQU   UCBFLB
UCBRESVH EQU   UCBFLB
UCBSPST  EQU   UCBFLB
UCBASNS  EQU   UCBFLB
UCBIORST EQU   UCBFLB
UCBQISCE EQU   UCBFL1
UCBACTV  EQU   UCBFL1
UCBSAP   EQU   UCBFL1
UCBNOTRC EQU   UCBCUB
UCBPSNS  EQU   UCBFL1
UCBUSING EQU   UCBPST
UCBNOTRD EQU   UCBNRY
UCBBUSYD EQU   UCBBSY
UCBUA    EQU   UCBCHAN+1
UCBCHA   EQU   UCBCHAN
UCBDADI  EQU   UCBSTAT
UCBSYSR  EQU   UCBSTAT
UCBPRES  EQU   UCBSTAT
UCBALOC  EQU   UCBSTAT
UCBUNLD  EQU   UCBSTAT
UCBRESV  EQU   UCBSTAT
UCBCHGS  EQU   UCBSTAT
UCBONLI  EQU   UCBSTAT
UCBID    EQU   UCBOB+2
UCBALTPH EQU   UCBFL5
UCBALTCU EQU   UCBFL5
UCBNALOC EQU   UCBFL5
UCBENVRD EQU   UCBFL5
UCBVSDR  EQU   UCBFL5
UCBSASK  EQU   UCBFL5
UCBAMV   EQU   UCBAF
UCBDCC   EQU   UCBFL5
UCBMONT  EQU   UCBJBNR
UCBRV011 EQU   UCBJBNR
UCBMMSGP EQU   UCBJBNR
UCBOLDSM EQU   UCBJBNR
UCBRV003 EQU   UCBJBNR
UCBDUC   EQU   UCBJBNR
UCBJES3  EQU   UCBJBNR
UCBVRDEV EQU   UCBJBNR
UCBCMSEG EQU   UCBOB
UCBPFXND EQU   UCB+512
UCBIOQ   EQU   UCB+508
UCBLOCK  EQU   UCB+504
UCBPXST  EQU   UCB+504
@NM00030 EQU   UCB
SIODDSNL EQU   INDMSIOT+173
SIOVDSNL EQU   INDMSIOT+172
SIOVDSNT EQU   INDMSIOT+170
SIOTVMVP EQU   INDMSIOT+164
SIOTJFX  EQU   INDMSIOT+160
SJFCBPTR EQU   INDMSIOT+156
SIOTETIO EQU   INDMSIOT+148
SIOTATE  EQU   INDMSIOT+144
SIOTEDLS EQU   INDMSIOT+132
SIOTRSNC EQU   INDMSIOT+130
SCTANAME EQU   INDMSIOT+122
SIOTSSIC EQU   INDMSIOT+120
@NM00029 EQU   INDMSIOT+108
SIOTSSNM EQU   INDMSIOT+104
@NM00028 EQU   SIOTBYT2
SIOTCVOL EQU   SIOTBYT2
SIOTCNEW EQU   SIOTBYT2
SIOTCALC EQU   SIOTBYT2
SIOTGALL EQU   SIOTBYT2
SIOTDSPD EQU   SIOTBYT2
SIOTOPUC EQU   INDMSIOT+99
SIOTOUTR EQU   INDMSIOT+97
SIOTOUTC EQU   INDMSIOT+96
SIOTSSWA EQU   INDMSIOT+93
SIOTAUNC EQU   SIOTALTD
SIOTACAT EQU   SIOTALTD
SIOTADEL EQU   SIOTALTD
SIOTAKEP EQU   SIOTALTD
SIOTNPRV EQU   SIOTALTD
SIOJCATS EQU   SIOTALTD
@NM00027 EQU   SIOTALTD
@NM00026 EQU   SIOTALTD
@NM00025 EQU   INDMSIOT+91
SIOTNDSB EQU   INDMSIOT+88
@NM00024 EQU   INDMSIOT+84
SIOTDPCD EQU   INDMSIOT+82
@NM00023 EQU   SIOTBYT4
SIOTRACT EQU   SIOTBYT4
SIOTRACD EQU   SIOTBYT4
SIOTPROT EQU   SIOTBYT4
SCTOUTPN EQU   INDMSIOT+80
SCTOUTNO EQU   INDMSIOT+76
SCTOUTNM EQU   INDMSIOT+68
SIOUCNVT EQU   SCTUTYPE+4
SIOUBYT4 EQU   SIOTDEVT+3
@NM00022 EQU   SIOUBYT3
SIO3UREC EQU   SIOUBYT3
SIO3DISP EQU   SIOUBYT3
SIO3DACC EQU   SIOUBYT3
SIO3COMM EQU   SIOUBYT3
SIO3TAPE EQU   SIOUBYT3
SIOUBYT2 EQU   SIOTDEVT+1
SIOUBYT1 EQU   SIOTDEVT
SIOTOMN  EQU   SCTSBYT4
SIOTIPDI EQU   SCTSBYT4
SIOTVAFF EQU   SCTSBYT4
SIOTSTEP EQU   SCTSBYT4
SIOTASCI EQU   SCTSBYT4
@NM00021 EQU   SCTSBYT4
SIOTGDGA EQU   SCTSBYT4
SCTSGDGS EQU   SCTSBYT4
SCTSOLD  EQU   SCTSBYT3
SCTSMOD  EQU   SCTSBYT3
SCTSNEW  EQU   SCTSBYT3
SCTSYSOU EQU   SCTSBYT3
SCTVREF  EQU   SCTSBYT3
SCTALCHK EQU   SCTSBYT3
SCTSYSNE EQU   SCTSBYT3
SCTDSNRF EQU   SCTSBYT3
SCTRECVD EQU   SCTSBYT2
SCTDEFER EQU   SCTSBYT2
SCTLABEL EQU   SCTSBYT2
SCTUNLBD EQU   SCTSBYT2
SCTJOBLB EQU   SCTSBYT2
SCTVOLAF EQU   SCTSBYT2
SIOTCATL EQU   SCTSBYT2
SIOCLUNL EQU   SCTSBYT2
SIOTJSCT EQU   SCTSBYT1
SCTUNAFF EQU   SCTSBYT1
SCTPARLM EQU   SCTSBYT1
SIOTQDSN EQU   SCTSBYT1
SIOTGDSN EQU   SCTSBYT1
SIOTCCAT EQU   SCTSBYT1
SCTSYSIN EQU   SCTSBYT1
SCTDUMMY EQU   SCTSBYT1
SIOTUNCT EQU   SCTSDISP
SIOTCTLG EQU   SCTSDISP
SIOTDLET EQU   SCTSDISP
SIOTKEEP EQU   SCTSDISP
SIOTPASS EQU   SCTSDISP
SIOTPRIV EQU   SCTSDISP
S3400DSP EQU   SCTSDISP
SIOTRETN EQU   SCTSDISP
SIOTVLCT EQU   INDMSIOT+54
SCTNMBUT EQU   INDMSIOT+53
SIOTRTRY EQU   SIOTBYT0
SIOTPUPV EQU   SIOTBYT0
SIOTNOPV EQU   SIOTBYT0
SIOTGIGN EQU   SIOTBYT0
SPVTAMSG EQU   SIOTBYT0
SIOTFUDA EQU   SIOTBYT0
SIOTDYAL EQU   SIOTBYT0
SIOTSSDS EQU   SIOTBYT0
SIOTGIID EQU   INDMSIOT+50
SCTVOLCT EQU   INDMSIOT+49
SCTSPOOL EQU   INDMSIOT+48
SIOTQNAM EQU   SIOTTSTC
SIOTDSNM EQU   SIOTTSTC
SIOTTRKM EQU   SIOTTSTC
SIOTSSMG EQU   SIOTTSTC
SIOTSSGP EQU   SIOTTSTC
@NM00020 EQU   SIOTTSTC
SIOTTERM EQU   SIOTTSTC
SIOTINFC EQU   SIOTTSTC
@NM00019 EQU   SIOTBYT3
SIOTDSID EQU   SIOTBYT3
S3400OFF EQU   SIOTBYT3
SIOTJES3 EQU   SIOTBYT3
SIOCDEVT EQU   SIOTBYT3
SIOALIAS EQU   SIOTBYT3
SCTDDINO EQU   INDMSIOT+44
SIOTDDNT EQU   SIOTBYT1
SIODADSM EQU   SIOTBYT1
SIOTDADR EQU   SIOTBYT1
SIODUNAL EQU   SIOTBYT1
SIOVAMDS EQU   SIOTBYT1
SIOTHOLD EQU   SIOTBYT1
SIOTOCKP EQU   SIOTBYT1
SIOPSCNT EQU   INDMSIOT+42
SIOTREFN EQU   INDMSIOT+40
SIOTOTUN EQU   INDMSIOT+39
SIOTVRSB EQU   INDMSIOT+36
@NM00018 EQU   INDMSIOT+35
SCTPJFCB EQU   INDMSIOT+32
@NM00017 EQU   INDMSIOT+31
SCTPSIOT EQU   INDMSIOT+28
SIOTAFID EQU   INDMSIOT+26
SIOTVLSP EQU   INDMSIOT+24
SIODSNTE EQU   INDMSIOT+22
SIOTUNAF EQU   SCTUSADD
SIOTDEST EQU   INDMSIOT+12
SIOTTYPE EQU   INDMSIOT+3
SIOTDSKA EQU   INDMSIOT
@NM00016 EQU   SWMID+32
@NM00015 EQU   SWMSGCCN
@NM00014 EQU   SWMID+27
@NM00013 EQU   SWMID
@NM00005 EQU   MSGNAMES+25
@NM00004 EQU   MSGNAMES+16
@NM00003 EQU   MSGNAMES
.@UNREFD ANOP                          END UNREFERENCED COMPONENTS
@RF00117 EQU   @RC00112
@RC00105 EQU   @RC00104
@RF00134 EQU   @RC00129
@RC00132 EQU   @RC00129
@RF00143 EQU   @RC00101
@RF00149 EQU   @RC00101
@RC00147 EQU   @RC00101
@RC00145 EQU   @RC00101
@RF00231 EQU   @RC00222
@RF00125 EQU   @RC00105
@ENDDATA EQU   *
         END   IEFAB487,(C'PLS1150',0701,78124)
