         TITLE 'IEFAB4A3 - SPECIAL SCRATCH PROCESSING                  *
                        '
IEFAB4A3 CSECT ,                                                01S0001
@MAINENT DS    0H                                               01S0001
         USING *,@15                                            01S0001
         B     @PROLOG                                          01S0001
         DC    AL1(16)                                          01S0001
         DC    C'IEFAB4A3  76.279'                              01S0001
         DROP  @15
@PROLOG  STM   @14,@12,12(@13)                                  01S0001
         BALR  @12,0                                            01S0001
@PSTART  DS    0H                                               01S0001
         USING @PSTART,@12                                      01S0001
         L     @00,@SIZDATD                                     01S0001
         GSPACE   R,LV=(0)
         LR    @11,@01                                          01S0001
         USING @DATD,@11                                        01S0001
         ST    @13,@SA00001+4                                   01S0001
         LM    @00,@01,20(@13)                                  01S0001
         ST    @11,8(,@13)                                      01S0001
         LR    @13,@11                                          01S0001
         MVC   @PC00001(20),0(@01)                              01S0001
JSCBDISP EQU 188
JSCBAOS1 EQU  72
JSCBAOS2 EQU 192
*/*                                                                  */
*/********************************************************************/
*RETCODE = ZERO;                                                01S0040
         SLR   @10,@10                                          01S0040
         ST    @10,RETCODE                                      01S0040
*CATRETCD = ZERO;                      /* INITIALIZE RETURN  @ZA06981*/
         ST    @10,CATRETCD                                     01S0041
*IF INIT = ON THEN                     /* INITIALIZATION FUNCTION?   */
         L     @10,@PC00001                                     01S0042
         TM    INIT(@10),B'10000000'                            01S0042
         BNO   @RF00042                                         01S0042
*  DO;                                                          01S0043
*/********************************************************************/
*/*                                                                  */
*/* SEGMENT NAME - INITTIOT                                          */
*/*                                                                  */
*/* DESCRIPTIVE NAME - INITIALIZE TIOT AND DSAB QDB                  */
*/*                                                                  */
*/* FUNCTION -                                                       */
*/*   THIS ROUTINE BUILDS A TIOT MANAGER REQUEST BLOCK REQUESTING    */
*/*   BUILDING OF THE TIOT AND DSAB QDB, AND CALLS THE TIOT          */
*/*   MANAGER ROUTINE, WHICH INITIALIZES THE TIOT CORE AND THE       */
*/*   DSAB QDB.                                                      */
*/*   IF TIOT INITIALIZATION IS SUCCESSFUL, THEN PUT THE     @ZA13873*/
*/*   ADDRESS OF THE TIOT IN THE INITIATOR'S TCB SO THAN     @ZA13873*/
*/*   OPEN (SVC19) CAN USE IT FOR OPENING PRIVATE CATALOGS.  @ZA13873*/
*/*                                                                  */
*/* OPERATION -                                                      */
*/*   SEE FUNCTION                                                   */
*/*                                                                  */
*/* ENTRY - IN-LINE SEGMENT                                          */
*/*                                                                  */
*/*   PURPOSE - SEE FUNCTION                                         */
*/*                                                                  */
*/*   INPUT -                                                        */
*/*                                                                  */
*/*     JSCBPTR  - JSCB PTR TO PASS TO TIOT MGR                      */
*/*     MAXSIZE  - MAXIMUM AMOUNT OF CORE REQUIRED FOR TIOT          */
*/*                                                                  */
*/* EXIT -                                                           */
*/*                                                                  */
*/*   CONDITION - TIOT AND DSAB QDB INITIALIZED                      */
*/*     OUTPUT -                                                     */
*/*       TIOT CORE INITIALIZED                                      */
*/*       CURDSABP - SET TO ZERO                                     */
*/*       DSAB QDB BUILT                                             */
*/*       JSCB UPDATED TO POINT TO DSAB QDB                          */
*/*       REASON CODES - NONE                                        */
*/*     RETURN CODES -                                               */
*/*       RETCODE - SAME AS ON ENTRY                                 */
*/*                                                                  */
*/*   CONDITION - TIOT MANAGER FAILURE                               */
*/*     OUTPUT - NONE                                                */
*/*     RETURN CODES -                                               */
*/*       RETCODE - 4                                                */
*/*                                                                  */
*/********************************************************************/
*TMRBCORE = TMRBCORE && TMRBCORE;      /* CLEAR CORE FOR TIOT MGR RB */
         XC    TMRBCORE(38),TMRBCORE                            02S0044
*TIORBPTR = ADDR(TMRBCORE);            /* GET BASE FOR TIOT MGR RB   */
         LA    @10,TMRBCORE                                     02S0045
         ST    @10,TIORBPTR                                     02S0045
*TIOMBLD = ON;                         /* CREAT TIOT & DSAB QDB.     */
         OI    TIOMBLD(@10),B'10000000'                         02S0046
*TIOMTSZE = MAXSIZE;                   /* SET TIOT SIZE.             */
         LH    @03,MAXSIZE                                      02S0047
         STH   @03,TIOMTSZE(,@10)                               02S0047
*TIOMJSCP = JSCBPTR;                   /* PASS JSCB PTR.             */
         L     @03,@PC00001+4                                   02S0048
         L     @03,JSCBPTR(,@03)                                02S0048
         ST    @03,TIOMJSCP(,@10)                               02S0048
*TIOTPTR = TCBTIO;                     /* POINT TO CURRENT TIOT.     */
         L     @01,CVTPTR                                       02S0049
         L     @01,CVTTCBP(,@01)                                02S0049
         L     @01,TCBPTR(,@01)                                 02S0049
         L     TIOTPTR,TCBTIO(,@01)                             02S0049
*TIOMJNMP = ADDR(TIOCNJOB);            /* JOBNAME PTR                */
         ST    TIOTPTR,TIOMJNMP(,@10)                           02S0050
*TIOMSNMP = ADDR(TIOCSTEP);            /* STEP NAME PTR              */
         LA    @03,TIOCSTEP(,TIOTPTR)                           02S0051
         ST    @03,TIOMSNMP(,@10)                               02S0051
*TIOMPSNP = ADDR(PSTPNAME);            /* PROCSTEP NAME PTR          */
         LA    @03,PSTPNAME(,TIOTPTR)                           02S0052
         ST    @03,TIOMPSNP(,@10)                               02S0052
*TIOMRETP = ADDR(TIOTLP);              /* RETURN AREA FOR TIOT LIST
*                                         PTR                        */
         LA    @15,TIOTLP                                       02S0053
         ST    @15,TIOMRETP(,@10)                               02S0053
*CALL IEFAB4FC(TIORBPTR);              /* CALL TIOT MANAGER TO GET
*                                         AND INITIALIZE CORE FOR
*                                         TIOT & DSAB QDB.           */
         LA    @10,TIORBPTR                                     02S0054
         ST    @10,@AL00001                                     02S0054
         L     @15,@CV00099                                     02S0054
         LA    @01,@AL00001                                     02S0054
         BALR  @14,@15                                          02S0054
*IF REG15 ^= ZERO THEN                 /* TIOT MGR ERROR?            */
         LTR   REG15,REG15                                      02S0055
         BZ    @RF00055                                         02S0055
*  RETCODE = INITERR;                  /* SET INITIALIZATION ERR CODE*/
         MVC   RETCODE(4),@CF00065                              02S0056
*ELSE                                  /* TIOT INITIALIZED   @ZA13873*/
*  DO;                                 /* SWITCH INIT TIOT   @ZA13873*/
         B     @RC00055                                         02S0057
@RF00055 DS    0H                                               02S0058
*     DO; /*MODESET  EXTKEY(ZERO)*/                             02S0058
*       SPKA (0); /*SET PSW KEY*/                               02S0059
         SLR   @10,@10                                          02S0059
         SPKA  0(@10)                                           02S0059
*     END; /*MODESET  EXTKEY(ZERO)*/   /* GET IN ZERO KEY    @ZA13873*/
*    TCBTIO = JSCBPTR->JSCTMCOR+PREFXLTH; /* STORE P/P TION  @ZA13873*/
         L     @10,CVTPTR                                       02S0061
         L     @10,CVTTCBP(,@10)                                02S0061
         L     @10,TCBPTR(,@10)                                 02S0061
         L     @15,@PC00001+4                                   02S0061
         L     @01,JSCBPTR(,@15)                                02S0061
         LA    @00,32                                           02S0061
         AL    @00,JSCTMCOR(,@01)                               02S0061
         ST    @00,TCBTIO(,@10)                                 02S0061
*     DO; /*MODESET  EXTKEY(SCHED)*/                            02S0062
*       SPKA (16); /*SET PSW KEY*/                              02S0063
         LA    @10,16                                           02S0063
         SPKA  0(@10)                                           02S0063
*     END; /*MODESET  EXTKEY(SCHED)*/  /* GET IN SCHED KEY   @ZA13873*/
*  END;                                /* TIOT PTR UPDATED   @ZA13873*/
*CURDSABP = ZERO;                      /* INITIALIZE DSAB PTR TO
*                                         SHOW ETIOT ENTRY DOES NOT
*                                         YET EXIST.                 */
@RC00055 L     @10,@PC00001+8                                   02S0066
         SLR   @15,@15                                          02S0066
         ST    @15,CURDSABP(,@10)                               02S0066
*  END;                                                         01S0067
*ELSE;                                 /* DONT INITIALIZE            */
@RF00042 DS    0H                                               01S0069
*IF RETCODE = ZERO &                   /* ANY ERROR?                 */
*   ALLOC = ON THEN                    /* ALLOCATE FUNCTION?         */
         SLR   @10,@10                                          01S0069
         C     @10,RETCODE                                      01S0069
         BNE   @RF00069                                         01S0069
         L     @15,@PC00001                                     01S0069
         TM    ALLOC(@15),B'01000000'                           01S0069
         BNO   @RF00069                                         01S0069
*  DO;                                                          01S0070
*/********************************************************************/
*/*                                                                  */
*/* SEGMENT NAME - ALOCTIOE                                          */
*/*                                                                  */
*/* DESCRIPTIVE NAME - ALLOCATE ETIOT ENTRY                          */
*/*                                                                  */
*/* FUNCTION -                                                       */
*/*   THIS ROUTINE ALLOCATES AN ETIOT ENTRY(DSAB AND TIOT DD ENTRY)  */
*/*   BY BUILDING AN ETIOT REQUEST BLOCK AND CALLING THE ETIOT       */
*/*   BUILD ROUTINE TO DO THE ACTUAL BUILD OPERATION.                */
*/*                                                                  */
*/*   OPERATION -                                                    */
*/*     A CALL IS MADE TO THE ETIOT BUILD ROUTINE TO BUILD AN        */
*/*     ETIOT ENTRY USING THE UCB PTR FROM THE SIOT.                 */
*/*                                                                  */
*/* ENTRY - IN-LINE SEGMENT                                          */
*/*                                                                  */
*/*   PURPOSE - SEE FUNCTION                                         */
*/*                                                                  */
*/*   INPUT -                                                        */
*/*     JSCBPTR  - JSCB PTR FOR ETIOT BUILD RTN.                     */
*/*     SIOT     - CONTAINS FIELDS USED TO BUILD ETIOT REQUEST BLOCK.*/
*/*                                                                  */
*/* EXIT -                                                           */
*/*                                                                  */
*/*   CONDITION - ETIOT ENTRY BUILT SUCCESFULLY                      */
*/*     OUTPUT -                                                     */
*/*       DSAB CONSTRUCTED                                           */
*/*       TIOT DD ENTRY BUILT                                        */
*/*     RETURN CODES -                                               */
*/*       RETCODE - SAME AS ON ENTRY                                 */
*/*                                                                  */
*/*   CONDITION - ETIOT BUILD ERROR                                  */
*/*     OUTPUT - NONE                                                */
*/*     RETURN CODES -                                               */
*/*       RETCODE - 8                                                */
*/*                                                                  */
*/********************************************************************/
*SIOTPTR= SPTR;                        /* GET SIOT POINTER.  @YM03498*/
         L     @15,@PC00001+12                                  02S0071
         L     SIOTPTR,SPTR(,@15)                               02S0071
*SIOTETIO = ZERO;                      /* CLEAR SIOT'S ETIOT POINTER */
         ST    @10,SIOTETIO(,SIOTPTR)                           02S0072
*EREQPTR = ADDR(TIORBCOR);             /* PTR TO ETIOT REQ BLK       */
         LA    @10,TIORBCOR                                     02S0073
         ST    @10,EREQPTR                                      02S0073
*TIORBCOR = TIORBCOR && TIORBCOR;      /* CLEAR ETIOT REQ BLK        */
         XC    TIORBCOR(42),TIORBCOR                            02S0074
*EREQDDNM = SCTDDNAM;                  /* DDNAME             @YM07034*/
         MVC   EREQDDNM(8,@10),SCTDDNAM(SIOTPTR)                02S0075
*EREQJSVA = SCTPJFCB;                  /* JFCB SVA                   */
         MVC   EREQJSVA(3,@10),SCTPJFCB(SIOTPTR)                02S0076
*EREQSSVA = SIOTDSKA;                  /* SIOT SVA                   */
         MVC   EREQSSVA(3,@10),SIOTDSKA(SIOTPTR)                02S0077
*EREQSIOT = SIOTPTR;                   /* SIOT CORE PTR              */
         ST    SIOTPTR,EREQSIOT(,@10)                           02S0078
*EREQDEVS = ONE;                       /* NO. OF DEVICE ENTRIES 02S0079
*                                                            @ZA00061*/
         MVC   EREQDEVS(2,@10),@CH00045                         02S0079
*EREQJSCB = JSCBPTR;                   /* JSCB PTR                   */
         L     @02,@PC00001+4                                   02S0080
         L     @02,JSCBPTR(,@02)                                02S0080
         ST    @02,EREQJSCB(,@10)                               02S0080
*EREQBLD = ON;                         /* BUILD FUNCTION - 1ST TIME  */
         OI    EREQBLD(@10),B'10000000'                         02S0081
*IF SIOUCNVT = ZERO THEN               /* UNIT TYPE CONVERTED@ZA00061*/
         CLI   SIOUCNVT(SIOTPTR),0                              02S0082
         BNE   @RF00082                                         02S0082
*  EREQUCB = SIOUCBAD;                 /* UCB PTR FOR ETIOT  @ZA00061*/
         L     @02,SIOUCBAD-1(,SIOTPTR)                         02S0083
         LA    @02,0(,@02)                                      02S0083
         ST    @02,EREQUCB(,@10)                                02S0083
*IF SIOVAMDS = ON THEN                 /* VIO DATA SET       @ZA00061*/
@RF00082 TM    SIOVAMDS(SIOTPTR),B'00100000'                    02S0084
         BNO   @RF00084                                         02S0084
*  EREQVAM = ON;                       /* SET VIO INDICATOR  @ZA00061*/
         L     @10,EREQPTR                                      02S0085
         OI    EREQVAM(@10),B'00100000'                         02S0085
*EREQRPOS = ONE;                       /* RELATIVE POSITION OF DEVICE
*                                         ENTRY IN DD ENTRY  @ZA00061*/
@RF00084 L     @10,EREQPTR                                      02S0086
         MVC   EREQRPOS(2,@10),@CH00045                         02S0086
*CALL IEFAB428(EREQPTR,JSCBPTR,ZERO);  /* BUILD ETIOT ENTRY.         */
         LA    @10,EREQPTR                                      02S0087
         ST    @10,@AL00001                                     02S0087
         L     @10,@PC00001+4                                   02S0087
         ST    @10,@AL00001+4                                   02S0087
         LA    @10,@CF00085                                     02S0087
         ST    @10,@AL00001+8                                   02S0087
         L     @15,@CV00102                                     02S0087
         LA    @01,@AL00001                                     02S0087
         BALR  @14,@15                                          02S0087
*IF REG15 ^= ZERO THEN                 /* ETIOT BUILD FAILURE?       */
         LTR   REG15,REG15                                      02S0088
         BZ    @RF00088                                         02S0088
*  RETCODE = ALLOCERR;                 /* SET ALLOC FAILURE RET CODE.*/
         MVC   RETCODE(4),@CF00043                              02S0089
*IF SIOTETIO ^= ZERO THEN              /* DSAB BUILT?                */
@RF00088 L     @10,SIOTETIO(,SIOTPTR)                           02S0090
         LTR   @10,@10                                          02S0090
         BZ    @RF00090                                         02S0090
*  CURDSABP = SIOTETIO;                /* SAVE DSAB PTR              */
         L     @02,@PC00001+8                                   02S0091
         ST    @10,CURDSABP(,@02)                               02S0091
*  END;                                                         01S0092
*ELSE;                                 /* NO ERRORS                  */
@RF00069 DS    0H                                               01S0094
*IF RETCODE = ZERO &                   /* NO ERRORS YET      @ZA06981*/
*   ALLOCCAT = ON THEN                 /* ALLOCATE STEPCATS? @ZA06981*/
@RC00069 SLR   @10,@10                                          01S0094
         C     @10,RETCODE                                      01S0094
         BNE   @RF00094                                         01S0094
         L     @15,@PC00001                                     01S0094
         TM    ALLOCCAT(@15),B'00001000'                        01S0094
         BNO   @RF00094                                         01S0094
*  DO;                                 /*                    @ZA06981*/
*/***********************************************************@ZA06981*/
*/*                                                          @ZA06981*/
*/* SEGMENT NAME - STEPCAT                                   @ZA06981*/
*/*                                                          @ZA06981*/
*/* DESCRIPTIVE NAME - ALLOCATE STEPCAT(S)                   @ZA06981*/
*/*                                                          @ZA06981*/
*/* FUNCTION -                                               @ZA06981*/
*/*   THIS ROUTINE IS RESPONSIBLE FOR ALLOCATING STEPCAT(S)  @ZA06981*/
*/*   CREATING PCCBS AND OPENING THE STEPCATS.               @ZA06981*/
*/*                                                          @ZA06981*/
*/*   OPERATION -                                            @ZA06981*/
*/*     THIS MODULE BUILDS A PARAMETER LIST AND CALLS        @ZA06981*/
*/*     IEFAB4F5 TO ALLOCATE STEPCAT(S), BUILD PCCB(S) AND   @ZA06981*/
*/*     AND OPEN THE STEPCAT(S). ONE CALL IS MADE FOR EACH   @ZA06981*/
*/*     STEPCAT DATA SET NAME.                               @ZA06981*/
*/*                                                          @ZA06981*/
*/* ENTRY - IN-LINE SEGMENT                                  @ZA06981*/
*/*                                                          @ZA06981*/
*/*   PURPOSE - TO ALLOCATE STEPCAT(S) WHEN REQUESTED        @ZA06981*/
*/*                                                          @ZA06981*/
*/*   INPUT - CATALDSN POINTING TO CATDSNT (TABLE DSN PTRS)  @ZA06981*/
*/*                                                          @ZA06981*/
*/* EXIT -                                                   @ZA06981*/
*/*                                                          @ZA06981*/
*/*   CONDITION - STEPCAT(S) ALLOCATED, PCCB(S) CREATED AND  @ZA06981*/
*/*               STEPCAT(S) OPENED                          @ZA06981*/
*/*     OUTPUT -                                             @ZA06981*/
*/*       OPEN STEPCAT(S)                                    @ZA06981*/
*/*     RETURN CODES -                                       @ZA06981*/
*/*       RETCODE - SAME AS ON ENTRY                         @ZA06981*/
*/*                                                          @ZA06981*/
*/* EXIT                                                     @ZA06981*/
*/*                                                                  */
*/*   CONDITION - A NONZERO RETURN CODE FROM IEFAB4F5        @ZA06981*/
*/*                                                                  */
*/*     OUTPUT                                               @ZA06981*/
*/*       NONE                                               @ZA06981*/
*/*     RETURN CODES -                                       @ZA06981*/
*/*       CATRETCD - 12                                      @ZA06981*/
*/*                                                                  */
*/***********************************************************@ZA06981*/
*ACCNTRLS = ZERO;                      /* CLEAR THE CONTROLS @ZA06981*/
         STH   @10,ACCNTRLS                                     02S0096
*ACOFLINE = ON;                        /* CONSIDER OFFLINES  @ZA06981*/
         OI    ACOFLINE,B'00000100'                             02S0097
*ACOK2MNT = ON;                        /* CATALOG MOUNT OK   @ZA06981*/
*ACSTPCAT = ON;                        /* THIS IS A STEPCAT  @ZA06981*/
*ACALCTLG= ON;                         /* ALLOCATE THIS CAT  @ZA06981*/
*ACOPNACB = ON;                        /* OPEN THIS CATALOG  @ZA06981*/
*ACCCPCCB = ON;                        /* PCCBS FOR THIS CAT @ZA06981*/
         OI    ACOK2MNT,B'11111000'                             02S0102
*DO INDEX = ONE TO CATNUM              /* INDEX THRU CATABLE @ZA06981*/
*  WHILE (CATRETCD = ZERO);            /* STOP ON NONZERO RC @ZA06981*/
         LA    INDEX,1                                          02S0103
         B     @DE00103                                         02S0103
@DL00103 L     @10,CATRETCD                                     02S0103
         LTR   @10,@10                                          02S0103
         BNZ   @DC00103                                         02S0103
*  CALL IEFAB4F5                       /* CALL THE ALLOCATE  @ZA06981*/
*      (ACCNTRLS,ADDR(CATRETCD),JSCBPTR,CATDSNP(INDEX),ZERO,ZERO);
         LA    @10,ACCNTRLS                                     02S0104
         ST    @10,@AL00001                                     02S0104
         LA    @10,CATRETCD                                     02S0104
         ST    @10,@TF00001                                     02S0104
         LA    @10,@TF00001                                     02S0104
         ST    @10,@AL00001+4                                   02S0104
         L     @10,@PC00001+4                                   02S0104
         ST    @10,@AL00001+8                                   02S0104
         LR    @10,INDEX                                        02S0104
         SLA   @10,2                                            02S0104
         L     @03,@PC00001+16                                  02S0104
         L     @03,CATALDSN(,@03)                               02S0104
         LA    @10,CATDSNP-4(@10,@03)                           02S0104
         ST    @10,@AL00001+12                                  02S0104
         LA    @10,@CF00085                                     02S0104
         ST    @10,@AL00001+16                                  02S0104
         LA    @10,@CF00085                                     02S0104
         ST    @10,@AL00001+20                                  02S0104
         L     @15,@CV00101                                     02S0104
         LA    @01,@AL00001                                     02S0104
         BALR  @14,@15                                          02S0104
*                                      /* ALLOCATE A STEPCAT @ZA06981*/
*END;                                  /* END OF DO WHILE    @ZA06981*/
         AL    INDEX,@CF00045                                   02S0105
@DE00103 L     @10,@PC00001+16                                  02S0105
         L     @10,CATALDSN(,@10)                               02S0105
         C     INDEX,CATNUM(,@10)                               02S0105
         BNH   @DL00103                                         02S0105
@DC00103 DS    0H                                               02S0106
*IF CATRETCD ^= ZERO THEN              /* CATALOG ALLOC FAIL @ZA06981*/
         L     @10,CATRETCD                                     02S0106
         LTR   @10,@10                                          02S0106
         BZ    @RF00106                                         02S0106
*  CATRETCD = CATALERR;                /* SET CATALOG FAIL   @ZA06981*/
         MVC   CATRETCD(4),@CF00067                             02S0107
*  END;                                /*                    @ZA06981*/
*ELSE;                                 /*                    @ZA06981*/
@RF00094 DS    0H                                               01S0110
*IF CATRETCD = CATALERR |              /* CATALOG ALLOC OKAY @ZA06981*/
*   UNALPCAT = ON THEN                 /* UNALLOC PRIVATCATS @ZA06981*/
@RC00094 CLC   CATRETCD(4),@CF00067                             01S0110
         BE    @RT00110                                         01S0110
         L     @10,@PC00001                                     01S0110
         TM    UNALPCAT(@10),B'00000100'                        01S0110
         BNO   @RF00110                                         01S0110
@RT00110 DS    0H                                               01S0111
*  DO;                                 /*                    @ZA06981*/
*/***********************************************************@ZA06981*/
*/*                                                                  */
*/* SEGMENTNAME - PRIVCATS                                   @ZA06981*/
*/*                                                                  */
*/* DESCRIPTIVE NAME - UNALLOCATE ALL PRIVATE CATALOGS       @ZA06981*/
*/*                                                                  */
*/* FUNCTION -                                               @ZA06981*/
*/*   THIS ROUTINE IS RESPONSIBLE FOR UNALLOCATING ALL       @ZA06981*/
*/*   PRIVATE CATALOGS, CLOSING ACBS AND FREEING PCCBS       @ZA06981*/
*/*                                                                  */
*/*   OPERATION -                                            @ZA06981*/
*/*     THIS MODULE BUILDS A PARAMETER LIST AND CALLS        @ZA06981*/
*/*     IEFAB4F4 ONCE TO UNALLOCATE ALL PRIVATE CATALOGS     @ZA06981*/
*/*     CLOSE ALL ACBS AND FREE ALL PCCBS.                   @ZA06981*/
*/*                                                                  */
*/* ENTRY - IN-LINE SEGMENT                                  @ZA06981*/
*/*                                                                  */
*/*   PURPOSE - TO UNALLOCATE ALL PRIVATE CATALOGS WHEN      @ZA06981*/
*/*             REQUESTED OR WHEN THE CATALOG ALLOCATE FAILS @ZA06981*/
*/*                                                                  */
*/*   INPUT - JSCBPTR FOR CATALOG UNALLOCATION               @ZA06981*/
*/*                                                                  */
*/* EXIT -                                                   @ZA06981*/
*/*                                                                  */
*/*   CONDITION - PRIVATE CATALOGS UNALLOCATED, ACBS CLOSED  @ZA06981*/
*/*               PCCBS FREED.                               @ZA06981*/
*/*     OUTPUT -                                             @ZA06981*/
*/*       PRIVATE CATALOGS UNALLOCATED                       @ZA06981*/
*/*       ACBS CLOSED                                        @ZA06981*/
*/*       PCCBS FREED                                        @ZA06981*/
*/*     RETURN CODES -                                       @ZA06981*/
*/*       RETCODE - SAME AS ON ENTRY                         @ZA06981*/
*/*                                                                  */
*/* EXIT -                                                   @ZA06981*/
*/*                                                                  */
*/*   CONDITION - NONZERO RETURN CODE FROM IEFAB4F5          @ZA06981*/
*/*                                                                  */
*/*     OUTPUT -                                             @ZA06981*/
*/*       NONE                                               @ZA06981*/
*/*     RETURN CODES -                                       @ZA06981*/
*/*       RETCODE - 12                                       @ZA06981*/
*/*                                                                  */
*/********************************************************************/
*UCCNTRLS = ZERO;                      /* CLEAR THE CONTROLS @ZA06981*/
         SLR   @10,@10                                          02S0112
         STH   @10,UCCNTRLS                                     02S0112
*UCALLCAT = ON;                        /* UNALLOCATE ALL CAT @ZA06981*/
*UCALLACB = ON;                        /* CLOSE ALL CAT ACBS @ZA06981*/
*UCALPCCB = ON;                        /* FREE ALL CAT PCCBS @ZA06981*/
         OI    UCALLCAT,B'00010101'                             02S0115
*CALL IEFAB4F4                         /* CALL CATALOG UNAL  @ZA06981*/
*    (UCCNTRLS,ADDR(RETCODE),ZERO,ZERO,ZERO,JSCBPTR);  /*    @ZA06981*/
         LA    @10,UCCNTRLS                                     02S0116
         ST    @10,@AL00001                                     02S0116
         LA    @10,RETCODE                                      02S0116
         ST    @10,@TF00001                                     02S0116
         LA    @10,@TF00001                                     02S0116
         ST    @10,@AL00001+4                                   02S0116
         LA    @10,@CF00085                                     02S0116
         ST    @10,@AL00001+8                                   02S0116
         LA    @10,@CF00085                                     02S0116
         ST    @10,@AL00001+12                                  02S0116
         LA    @10,@CF00085                                     02S0116
         ST    @10,@AL00001+16                                  02S0116
         L     @10,@PC00001+4                                   02S0116
         ST    @10,@AL00001+20                                  02S0116
         L     @15,@CV00100                                     02S0116
         LA    @01,@AL00001                                     02S0116
         BALR  @14,@15                                          02S0116
*RETCODE = CATRETCD;                   /* SET RETURN CODE    @ZA06981*/
         L     @10,CATRETCD                                     02S0117
         ST    @10,RETCODE                                      02S0117
*  END;                                /*                    @ZA06981*/
*ELSE;                                 /*                    @ZA06981*/
@RF00110 DS    0H                                               01S0120
*IF FREE = ON THEN                     /* ETIOT CLEANUP FUNCTION?    */
         L     @10,@PC00001                                     01S0120
         TM    FREE(@10),B'00100000'                            01S0120
         BNO   @RF00120                                         01S0120
*  DO;                                                          01S0121
*/********************************************************************/
*/*                                                                  */
*/* SEGMENT NAME - FREETIOT                                          */
*/*                                                                  */
*/* DESCRIPTIVE NAME - FREE TIOT AND DSAB QDB                        */
*/*                                                                  */
*/* FUNCTION -                                                       */
*/*   THIS ROUTINE IS RESPONSIBLE FOR FREEING THE TIOT AND DSAB QDB  */
*/*   PUT THE INITIATOR'S TIOT POINTER IN THE INITIATOR'S    @ZA13873*/
*/*   TCB BEFORE FREEING THE TIOT AND DSAB QDB.              @ZA13873*/
*/*                                                                  */
*/*   OPERATION -                                                    */
*/*     THE TIOT MANAGER IS CALLED TO FREE THE TIOT CORE AND DSAB    */
*/*     QDB AND TO CLEAR THE TIOT AND DSAB QDB POINTERS IN THE JSCB. */
*/*                                                                  */
*/* ENTRY - IN-LINE SEGMENT                                          */
*/*                                                                  */
*/*   PURPOSE - SEE FUNCTION                                         */
*/*                                                                  */
*/*   INPUT -                                                        */
*/*     JSCBPTR  - JSCB PTR(INPUT TO TIOT MANAGER)                   */
*/*                                                                  */
*/* EXIT -                                                           */
*/*                                                                  */
*/*   CONDITION - TIOT, DSAB QDB FREED                               */
*/*     OUTPUT -                                                     */
*/*       TIOT CORE FREED                                            */
*/*       DSAB CORE FREED                                            */
*/*     RETURN CODES -                                               */
*/*       RETCODE - SAME AS ON ENTRY                                 */
*/*                                                                  */
*/********************************************************************/
* DO; /*MODESET  EXTKEY(ZERO)*/                                 02S0122
*   SPKA (0); /*SET PSW KEY*/                                   02S0123
         SLR   @10,@10                                          02S0123
         SPKA  0(@10)                                           02S0123
* END; /*MODESET  EXTKEY(ZERO)*/       /*GET IN ZERO KEY     @ZA13873*/
*TCBTIO = TCBJSCBB->JSCTMCOR+PREFXLTH; /* POINT TO INIT TIOT @ZA13873*/
         L     @10,CVTPTR                                       02S0125
         L     @10,CVTTCBP(,@10)                                02S0125
         L     @10,TCBPTR(,@10)                                 02S0125
         L     @01,TCBJSCBB-1(,@10)                             02S0125
         LA    @00,32                                           02S0125
         AL    @00,JSCTMCOR(,@01)                               02S0125
         ST    @00,TCBTIO(,@10)                                 02S0125
* DO; /*MODESET  EXTKEY(SCHED)*/                                02S0126
*   SPKA (16); /*SET PSW KEY*/                                  02S0127
         LA    @10,16                                           02S0127
         SPKA  0(@10)                                           02S0127
* END; /*MODESET  EXTKEY(SCHED)*/      /* GET IN SCHED KEY   @ZA13873*/
*TIORBPTR = ADDR(TMRBCORE);            /* PTR TO TIOT MGR REQ BLK.   */
         LA    @10,TMRBCORE                                     02S0129
         ST    @10,TIORBPTR                                     02S0129
*TMRBCORE = TMRBCORE && TMRBCORE;      /* CLEAR REQ BLK.             */
         XC    TMRBCORE(38),TMRBCORE                            02S0130
*TIOMFREE = ON;                        /* 'FREE TIOT' FUNCTION       */
         OI    TIOMFREE(@10),B'00000001'                        02S0131
*TIOMJSCP = JSCBPTR;                   /* JSCB PTR                   */
         L     @15,@PC00001+4                                   02S0132
         L     @15,JSCBPTR(,@15)                                02S0132
         ST    @15,TIOMJSCP(,@10)                               02S0132
*CALL IEFAB4FC(TIORBPTR);              /* CALL TIOT MANAGER.         */
         LA    @10,TIORBPTR                                     02S0133
         ST    @10,@AL00001                                     02S0133
         L     @15,@CV00099                                     02S0133
         LA    @01,@AL00001                                     02S0133
         BALR  @14,@15                                          02S0133
*  END;                                                         01S0134
*ELSE;                                 /* NOT ETIOT CLEANUP          */
@RF00120 DS    0H                                               01S0136
*IF UNAL = ON THEN                     /* UNALLOCATE ETIOT ENTRY?    */
         L     @10,@PC00001                                     01S0136
         TM    UNAL(@10),B'00010000'                            01S0136
         BNO   @RF00136                                         01S0136
*  DO;                                                          01S0137
*/********************************************************************/
*/*                                                                  */
*/* SEGMENT NAME - UNALTIOE                                          */
*/*                                                                  */
*/* DESCRIPTIVE NAME - UNALLOCATE TIOT ENTRY                         */
*/*                                                                  */
*/* FUNCTION -                                                       */
*/*   THIS ROUTINE UNALLOCATES AN ETIOT ENTRY                        */
*/*                                                                  */
*/*   OPERATION -                                                    */
*/*     A TIOT MANAGER REQUEST BLOCK, REQUESTING THE 'UNALLOCATE'    */
*/*     AND RELEASE FUNCTIONS, IS BUILT AND PASSED TO THE TIOT       */
*/*     MANAGER.                                                     */
*/*                                                                  */
*/* ENTRY - UNALTIOE(INTERNAL PROCEDURE)                             */
*/*   PURPOSE - SEE FUNCTION                                         */
*/*   INPUT -                                                        */
*/*     JSCBPTR - JSCB POINTER FOR TIOT MANAGER                      */
*/*     CURDSABP - POINTER TO CURRENT ETIOT ENTRY                    */
*/*                                                                  */
*/* EXIT -                                                           */
*/*   CONDITION - ETIOT ENTRY UNALLOCATED                            */
*/*     OUTPUT -                                                     */
*/*       DSAB FREED                                                 */
*/*       TIOT DD ENTRY 'FREED'                                      */
*/*       CURDSABP - SET TO 0                                        */
*/*     RETURN CODES -                                               */
*/*       RETCODE - SAME AS ON ENTRY                                 */
*/*                                                                  */
*/********************************************************************/
*TIORBPTR = ADDR(TMRBCORE);            /* TIOT MGR REQ BLK PTR       */
         LA    @10,TMRBCORE                                     02S0138
         ST    @10,TIORBPTR                                     02S0138
*TMRBCORE = TMRBCORE && TMRBCORE;      /* CLEAR REQ BLK              */
         XC    TMRBCORE(38),TMRBCORE                            02S0139
*TIOMRENT = ON;                        /* SET 'RELEASE ENTRY' INDIC  */
         OI    TIOMRENT(@10),B'10000000'                        02S0140
*TIOMUNAL = ON;                        /* 'UNALLOCATE' FUNCTION      */
         OI    TIOMUNAL(@10),B'00000010'                        02S0141
*TIOMJSCP = JSCBPTR;                   /* JSCB PTR FOR TIOT MGR      */
         L     @15,@PC00001+4                                   02S0142
         L     @15,JSCBPTR(,@15)                                02S0142
         ST    @15,TIOMJSCP(,@10)                               02S0142
*TIOMDSAP = ADDR(CURDSABP);            /* PASS PTR TO DSAB PTR.      */
         L     @15,@PC00001+8                                   02S0143
         ST    @15,TIOMDSAP(,@10)                               02S0143
*TIOMNDSA = ONE;                       /* NO. OF ENTRIES TO FREE     */
         MVC   TIOMNDSA(2,@10),@CH00045                         02S0144
*CALL IEFAB4FC(TIORBPTR);              /* CALL TIOT MANAGER.         */
         LA    @10,TIORBPTR                                     02S0145
         ST    @10,@AL00001                                     02S0145
         L     @15,@CV00099                                     02S0145
         LA    @01,@AL00001                                     02S0145
         BALR  @14,@15                                          02S0145
*CURDSABP = ZERO;                      /* CLEAR CURRENT ETIOT PTR    */
         L     @10,@PC00001+8                                   02S0146
         SLR   @15,@15                                          02S0146
         ST    @15,CURDSABP(,@10)                               02S0146
*  END;                                                         01S0147
*ELSE;                                 /* DONT UNALLOCATE            */
@RF00136 DS    0H                                               01S0149
*RETURN CODE(RETCODE);                 /* RETURN TO CALLER           */
         L     @10,RETCODE                                      01S0149
         L     @13,4(,@13)                                      01S0149
         L     @00,@SIZDATD                                     01S0149
         LR    @01,@11                                          01S0149
         FSPACE   R,LV=(0),A=(1)
         LR    @15,@10                                          01S0149
         L     @14,12(,@13)                                     01S0149
         LM    @00,@12,20(@13)                                  01S0149
         BR    @14                                              01S0149
*END IEFAB4A3                                                   01S0150
*/* THE FOLLOWING INCLUDE STATEMENTS WERE FOUND IN THIS PROGRAM.      *
*/*%INCLUDE SYSLIB  (A4A3SPEC)                                        *
*/*%INCLUDE SYSLIB  (A4A3DATA)                                        *
*/*%INCLUDE SYSLIB  (CVT     )                                        *
*/*%INCLUDE SYSLIB  (IEFASIOT)                                        *
*/*%INCLUDE SYSLIB  (IEFTIOT1)                                        *
*/*%INCLUDE SYSLIB  (IEFZB424)                                        *
*/*%INCLUDE SYSLIB  (IEFZB430)                                        *
*/*%INCLUDE SYSLIB  (IKJTCB  )                                        *
*/*%INCLUDE SYSLIB  (IEZJSCB )                                        *
*/*%INCLUDE SYSLIB  (IEFZB442)                                        *
*/*%INCLUDE SYSLIB  (IEFZB443)                                        *
*/*%INCLUDE SYSLIB  (INITTIOT)                                        *
*/*%INCLUDE SYSLIB  (INITSPEC)                                        *
*/*%INCLUDE SYSLIB  (ALOCTIOE)                                        *
*/*%INCLUDE SYSLIB  (ALOCSPEC)                                        *
*/*%INCLUDE SYSLIB  (STEPCAT )                                        *
*/*%INCLUDE SYSLIB  (STCTSPEC)                                        *
*/*%INCLUDE SYSLIB  (PRIVCATS)                                        *
*/*%INCLUDE SYSLIB  (UNCTSPEC)                                        *
*/*%INCLUDE SYSLIB  (FREETIOT)                                        *
*/*%INCLUDE SYSLIB  (FREESPEC)                                        *
*/*%INCLUDE SYSLIB  (UNALTIOE)                                        *
*/*%INCLUDE SYSLIB  (UNALSPEC)                                        *
*;                                                              01S0150
@DATA    DS    0H
@DATD    DSECT
         DS    0F
@SA00001 DS    18F
@PC00001 DS    5F
@AL00001 DS    6A
@TF00001 DS    F
IEFAB4A3 CSECT
         DS    0F
@CF00085 DC    F'0'
@CF00045 DC    F'1'
@CH00045 EQU   @CF00045+2
@CF00065 DC    F'4'
@CF00043 DC    F'8'
@CF00067 DC    F'12'
@DATD    DSECT
         DS    0D
CATRETCD DS    F
RETCODE  DS    F
EREQPTR  DS    A
TIORBPTR DS    A
TIOTLP   DS    A
DSABPTR  DS    A
ACCNTRLS DS    FL2
         ORG   ACCNTRLS
ACNODD   DS    BL1
ACDVWAIT EQU   ACCNTRLS+0
ACRECOVR EQU   ACCNTRLS+0
ACOSCVOL EQU   ACCNTRLS+0
ACVLWAIT EQU   ACCNTRLS+0
ACOFLINE EQU   ACCNTRLS+0
ACNOENQ  EQU   ACCNTRLS+0
ACNUJSCB EQU   ACCNTRLS+0
ACOK2MNT DS    BL1
ACSTPCAT EQU   ACCNTRLS+1
ACALCTLG EQU   ACCNTRLS+1
ACOPNACB EQU   ACCNTRLS+1
ACCCPCCB EQU   ACCNTRLS+1
ACRECOVD EQU   ACCNTRLS+1
@NM00041 EQU   ACCNTRLS+1
         ORG   ACCNTRLS+2
UCCNTRLS DS    FL2
         ORG   UCCNTRLS
UCCAJSCB DS    BL1
UCNTIONQ EQU   UCCNTRLS+0
UCONECAT EQU   UCCNTRLS+0
UCALLCAT EQU   UCCNTRLS+0
UCONEACB EQU   UCCNTRLS+0
UCALLACB EQU   UCCNTRLS+0
UCONPCCB EQU   UCCNTRLS+0
UCALPCCB EQU   UCCNTRLS+0
UCTEMP   DS    BL1
UCSWTIOT EQU   UCCNTRLS+1
@NM00042 EQU   UCCNTRLS+1
         ORG   UCCNTRLS+2
TMRBCORE DS    CL38
TIORBCOR DS    CL42
IEFAB4A3 CSECT
         DS    0F
@SIZDATD DC    AL1(230)
         DC    AL3(@ENDDATD-@DATD)
@CV00099 DC    V(IEFAB4FC)
@CV00100 DC    V(IEFAB4F4)
@CV00101 DC    V(IEFAB4F5)
@CV00102 DC    V(IEFAB428)
         DS    0D
MAXSIZE  DC    AL2(8+16+16+59*4+4+32)
IEFAB4A3 CSECT
         DS   0H
A4A3PTCH DC ((@DATA-@PSTART)/20)X'00'
@DATD    DSECT
         ORG   *+1-(*-@DATD)/(*-@DATD) INSURE DSECT DATA
@ENDDATD EQU   *
IEFAB4A3 CSECT
@00      EQU   00                      EQUATES FOR REGISTERS 0-15
@01      EQU   01
@02      EQU   02
@03      EQU   03
@04      EQU   04
@05      EQU   05
@06      EQU   06
@07      EQU   07
@08      EQU   08
@09      EQU   09
@10      EQU   10
@11      EQU   11
@12      EQU   12
@13      EQU   13
@14      EQU   14
@15      EQU   15
TIOTPTR  EQU   @02
SIOTPTR  EQU   @03
INDEX    EQU   @02
REG15    EQU   @15
CVTPTR   EQU   16
CATDSNT  EQU   0
CATHDR   EQU   CATDSNT
CATNUM   EQU   CATHDR
CATDSNP  EQU   CATDSNT+4
TCBPTRS  EQU   0
TCBPTR   EQU   TCBPTRS+4
CVTMAP   EQU   0
CVTTCBP  EQU   CVTMAP
CVTDAR   EQU   CVTMAP+72
CVTFLGS1 EQU   CVTDAR
CVTDCB   EQU   CVTMAP+116
CVTIERLC EQU   CVTMAP+144
CVTOPTA  EQU   CVTMAP+182
CVTOPTB  EQU   CVTMAP+183
CVTGTF   EQU   CVTMAP+236
CVTGTFST EQU   CVTGTF
CVTGTFS  EQU   CVTGTFST
CVTSTATE EQU   CVTGTFST
CVTTMODE EQU   CVTGTFST
CVTFORM  EQU   CVTGTFST
CVTAQAVT EQU   CVTMAP+240
CVTTCMFG EQU   CVTAQAVT
CVTVOLM2 EQU   CVTMAP+244
CVTTATA  EQU   CVTVOLM2
CVTTSKS  EQU   CVTTATA
CVTVOLF2 EQU   CVTTSKS
CVTTAT   EQU   CVTTATA+1
CVTATER  EQU   CVTMAP+248
CVTEXT1  EQU   CVTMAP+252
CVTPURG  EQU   CVTMAP+260
CVTQMSG  EQU   CVTMAP+268
CVTDMSR  EQU   CVTMAP+272
CVTRSV37 EQU   CVTDMSR
CVTDMSRF EQU   CVTRSV37
CVTERPV  EQU   CVTMAP+316
CVTINTLA EQU   CVTMAP+320
CVTAPF   EQU   CVTMAP+324
CVTEXT2  EQU   CVTMAP+328
CVTHJES  EQU   CVTMAP+332
CVTPGSIA EQU   CVTMAP+348
CVTA1F1  EQU   CVTMAP+356
CVTSYSK  EQU   CVTMAP+357
CVTVOLM1 EQU   CVTMAP+380
CVTVOLF1 EQU   CVTVOLM1
CVTATMCT EQU   CVTMAP+388
CVTXTNT1 EQU   0
CVTXTNT2 EQU   0
CVTDSSV  EQU   CVTXTNT2
CVTFLGBT EQU   CVTXTNT2+5
CVTQID   EQU   CVTXTNT2+24
CVTRV400 EQU   CVTXTNT2+52
CVTRV409 EQU   CVTXTNT2+53
CVTATCVT EQU   CVTXTNT2+64
CVTRV429 EQU   CVTXTNT2+84
CVTRV438 EQU   CVTXTNT2+85
CVTRV457 EQU   CVTXTNT2+112
CVTRV466 EQU   CVTXTNT2+113
CVTFIX   EQU   0
CVTRELNO EQU   CVTFIX+252
INDMSIOT EQU   0
SIOTDSKA EQU   INDMSIOT
SCTDDNAM EQU   INDMSIOT+4
SCTUSADD EQU   INDMSIOT+20
SCTPJFCB EQU   INDMSIOT+32
SIOTBYT1 EQU   INDMSIOT+43
SIOVAMDS EQU   SIOTBYT1
SIOTBYT3 EQU   INDMSIOT+46
SIOTTSTC EQU   INDMSIOT+47
SIOTBYT0 EQU   INDMSIOT+52
SCTSDISP EQU   INDMSIOT+55
SCTSBYT1 EQU   INDMSIOT+56
SCTSBYT2 EQU   INDMSIOT+57
SCTSBYT3 EQU   INDMSIOT+58
SCTSBYT4 EQU   INDMSIOT+59
SCTUTYPE EQU   INDMSIOT+60
SIOTDEVT EQU   SCTUTYPE
SIOUBYT3 EQU   SIOTDEVT+2
SIOUCNVT EQU   SCTUTYPE+4
SIOUCBAD EQU   SCTUTYPE+5
SIOTALTD EQU   INDMSIOT+92
SIOTBYT2 EQU   INDMSIOT+103
SIOTETIO EQU   INDMSIOT+148
TIOT1    EQU   0
TIOCNJOB EQU   TIOT1
TIOCSTEP EQU   TIOT1+8
TIOMGRRB EQU   0
TIOMFMAP EQU   TIOMGRRB
TIOMBLD  EQU   TIOMFMAP
TIOMUNAL EQU   TIOMFMAP
TIOMFREE EQU   TIOMFMAP
TIOMRENT EQU   TIOMFMAP+1
TIOMTSZE EQU   TIOMGRRB+2
TIOMJSCP EQU   TIOMGRRB+4
TIOMJNMP EQU   TIOMGRRB+8
TIOMSNMP EQU   TIOMGRRB+12
TIOMDSAP EQU   TIOMGRRB+20
TIOMRETP EQU   TIOMGRRB+28
TIOMPSNP EQU   TIOMGRRB+32
ETIOTREQ EQU   0
EREQMAP  EQU   ETIOTREQ
EREQBLD  EQU   EREQMAP
EREQSTAT EQU   ETIOTREQ+2
EREQVAM  EQU   EREQSTAT
EREQDDNM EQU   ETIOTREQ+4
EREQJSVA EQU   ETIOTREQ+12
EREQSSVA EQU   ETIOTREQ+16
EREQSIOT EQU   ETIOTREQ+20
EREQUCB  EQU   ETIOTREQ+24
EREQRPOS EQU   ETIOTREQ+28
EREQDEVS EQU   ETIOTREQ+30
EREQJSCB EQU   ETIOTREQ+36
TCBFIX   EQU   0
TCBFRS   EQU   TCBFIX
TCB      EQU   0
TCBPIE   EQU   TCB+4
TCBPMASK EQU   TCBPIE
TCBTIO   EQU   TCB+12
TCBCMP   EQU   TCB+16
TCBCMPF  EQU   TCBCMP
TCBCPP   EQU   TCBCMPF
TCBSTCC  EQU   TCBCMPF
TCBCDBL  EQU   TCBCMPF
TCBCWTO  EQU   TCBCMPF
TCBCIND  EQU   TCBCMPF
TCBCMSG  EQU   TCBCMPF
TCBTRN   EQU   TCB+20
TCBABF   EQU   TCBTRN
TCBMSS   EQU   TCB+24
TCBPKF   EQU   TCB+28
TCBFLGS  EQU   TCB+29
TCBFLGS1 EQU   TCBFLGS
TCBFLGS2 EQU   TCBFLGS+1
TCBFLGS3 EQU   TCBFLGS+2
TCBFLGS4 EQU   TCBFLGS+3
TCBFLGS5 EQU   TCBFLGS+4
TCBABWF  EQU   TCBFLGS5
TCBJPQ   EQU   TCB+44
TCBPURGE EQU   TCBJPQ
TCBGRS   EQU   TCB+48
TCBFSA   EQU   TCB+112
TCBTME   EQU   TCB+120
TCBJSTCB EQU   TCB+124
TCBTSFLG EQU   TCB+148
TCBTSTSK EQU   TCBTSFLG
TCBSTAB  EQU   TCB+160
TCBNSTAE EQU   TCBSTAB
TCBTCT   EQU   TCB+164
TCBTCTGF EQU   TCBTCT
TCBSCNDY EQU   TCB+172
TCBNDSP  EQU   TCBSCNDY
TCBNDSP1 EQU   TCBNDSP+1
TCBNDSP2 EQU   TCBNDSP+2
TCBNDSP3 EQU   TCBNDSP+3
TCBJSCB  EQU   TCB+180
TCBRECDE EQU   TCBJSCB
TCBJSCBB EQU   TCBJSCB+1
TCBEXT1  EQU   TCB+196
TCBBITS  EQU   TCB+200
TCBNDSP4 EQU   TCBBITS
TCBNDSP5 EQU   TCBBITS+1
TCBFLGS6 EQU   TCBBITS+2
TCBFLGS7 EQU   TCBBITS+3
TCBDAR   EQU   TCB+204
TCBDARC  EQU   TCBDAR
TCBEXT2  EQU   TCB+208
TCBFOE   EQU   TCB+244
TCBESTAE EQU   TCB+264
TCBESTRM EQU   TCBESTAE+1
TCBFBYT1 EQU   TCB+276
TCBFBYT2 EQU   TCB+277
TCBRV124 EQU   TCB+278
TCBRV133 EQU   TCB+279
TCBXTNT2 EQU   0
TCBGTF   EQU   TCBXTNT2
TCBTFLG  EQU   TCBGTF
TCBRV146 EQU   TCBXTNT2+28
TCBRV155 EQU   TCBXTNT2+29
TCBRV164 EQU   TCBXTNT2+30
TCBRV173 EQU   TCBXTNT2+31
IEZJSCB  EQU   0
JSCBSEC1 EQU   IEZJSCB+188
JSCHPCE  EQU   JSCBSEC1+4
JSCBDCB  EQU   JSCBSEC1+36
JSCBOPTS EQU   JSCBSEC1+48
JSCBSWT1 EQU   JSCBSEC1+55
JSCBWTP  EQU   JSCBSEC1+64
JSCBWTFG EQU   JSCBWTP
JSCBEND1 EQU   IEZJSCB+260
FUNCMAP  EQU   0
INIT     EQU   FUNCMAP
ALLOC    EQU   FUNCMAP
FREE     EQU   FUNCMAP
UNAL     EQU   FUNCMAP
ALLOCCAT EQU   FUNCMAP
UNALPCAT EQU   FUNCMAP
JSCBPTR  EQU   0
CURDSABP EQU   0
SPTR     EQU   0
CATALDSN EQU   0
TIOENTRY EQU   TIOT1+24
TIOESTTA EQU   TIOENTRY+1
TIOERLOC EQU   TIOENTRY+2
TIOELINK EQU   TIOERLOC+1
TIOESYOT EQU   TIOELINK
TIOESTTC EQU   TIOENTRY+15
TIOESTTB EQU   TIOENTRY+16
POOLSTAR EQU   TIOENTRY+20
TIOTFEND EQU   POOLSTAR+16
TIOEDEVE EQU   TIOESTTB
TIOSTTB  EQU   TIOEDEVE
CVTS01   EQU   CVTPGSIA
CVTLPDIA EQU   CVTS01+12
CVTDIRST EQU   CVTLPDIA
CVTSLIDA EQU   CVTS01+24
CVTCTLFG EQU   CVTS01+50
CVTRV210 EQU   CVTS01+424
CVTRV219 EQU   CVTS01+425
CVTRV228 EQU   CVTS01+426
CVTRV237 EQU   CVTS01+427
CVTMFRTR EQU   CVTS01+452
CVTRV262 EQU   CVTS01+468
CVTRV271 EQU   CVTS01+469
CVTRV280 EQU   CVTS01+470
CVTRV289 EQU   CVTS01+471
CVTGSDA  EQU   CVTS01+600
PSTPNAME EQU   TIOCSTEP+8
TIOMNDSA EQU   TIOMTSZE
JSCBSEC2 EQU   JSCBEND1
JSCBSEC3 EQU   JSCBEND1
JSCBJCT  EQU   JSCBSEC3
JSCBJCTA EQU   JSCBJCT+1
JSCBASID EQU   JSCBSEC3+8
JSCBFBYT EQU   JSCBSEC3+10
JSCBJNL  EQU   JSCBSEC3+28
JSCBJJSB EQU   JSCBJNL
JSCBSUB  EQU   JSCBSEC3+40
JSCSCT   EQU   JSCBSEC3+68
JSCTMCOR EQU   JSCBSEC3+72
JSCRSV45 EQU   JSCBSEC3+112
JSCRSV46 EQU   JSCRSV45
JSCRSV47 EQU   JSCRSV45+2
TIOMELEN EQU   TIOMTSZE
         AGO   .@UNREFD                START UNREFERENCED COMPONENTS
JSCBEND3 EQU   JSCBSEC3+120
JSCRSV52 EQU   JSCBSEC3+116
JSCRSV51 EQU   JSCRSV47+1
JSCRSV50 EQU   JSCRSV47
JSCRSV49 EQU   JSCRSV46+1
JSCRSV48 EQU   JSCRSV46
JSCRSV44 EQU   JSCBSEC3+108
JSCRSV43 EQU   JSCBSEC3+104
JSCRSV42 EQU   JSCBSEC3+100
JSCBASWA EQU   JSCBSEC3+96
JSCBUFPT EQU   JSCBSEC3+92
JSCBACT  EQU   JSCBSEC3+88
JSCBSWSP EQU   JSCBSEC3+87
JSCRSV33 EQU   JSCBSEC3+86
JSCDDNUM EQU   JSCBSEC3+84
JSCRSV53 EQU   JSCBSEC3+82
JSCDDNNO EQU   JSCBSEC3+80
JSCBVATA EQU   JSCBSEC3+76
JSCSCTP  EQU   JSCSCT+1
JSCRSV55 EQU   JSCSCT
JSCRSV54 EQU   JSCBSEC3+64
JSCDSABQ EQU   JSCBSEC3+60
JSCBSSIB EQU   JSCBSEC3+56
JSCBFRBA EQU   JSCBSEC3+48
JSCRSV28 EQU   JSCBSEC3+46
JSCBSONO EQU   JSCBSEC3+44
JSCBSUBA EQU   JSCBSUB+1
JSCRSV31 EQU   JSCBSUB
JSCBSMLR EQU   JSCBSEC3+36
JSCBJNLR EQU   JSCBSEC3+32
JSCBJNLA EQU   JSCBJNL+1
JSCBJSBT EQU   JSCBJJSB
JSCBJSBX EQU   JSCBJJSB
JSCBJSBA EQU   JSCBJJSB
JSCBJSBI EQU   JSCBJJSB
@NM00040 EQU   JSCBJJSB
JSCBJNLE EQU   JSCBJJSB
JSCBJNLF EQU   JSCBJJSB
JSCBJNLN EQU   JSCBJJSB
@NM00039 EQU   JSCBSEC3+24
JSCBJRBA EQU   JSCBSEC3+16
JSCBIECB EQU   JSCBSEC3+12
JSCBRV08 EQU   JSCBSEC3+11
JSCBRV07 EQU   JSCBFBYT
JSCBRV06 EQU   JSCBFBYT
JSCBRV05 EQU   JSCBFBYT
JSCBRV04 EQU   JSCBFBYT
JSCBRV03 EQU   JSCBFBYT
JSCBRV02 EQU   JSCBFBYT
JSCBADSP EQU   JSCBFBYT
JSCBRV01 EQU   JSCBFBYT
JSCBTJID EQU   JSCBASID
JSCBPSCB EQU   JSCBSEC3+4
JSCJCTP  EQU   JSCBJCTA
JSCRSV24 EQU   JSCBJCT
JSCBEND2 EQU   JSCBSEC2
CVTRV628 EQU   CVTS01+728
CVTRV627 EQU   CVTS01+724
CVTRV626 EQU   CVTS01+720
CVTRV625 EQU   CVTS01+716
CVTRV624 EQU   CVTS01+712
CVTRV623 EQU   CVTS01+708
CVTRV622 EQU   CVTS01+704
CVTRV621 EQU   CVTS01+700
CVTIHASU EQU   CVTS01+696
CVTRV619 EQU   CVTS01+692
CVTRV618 EQU   CVTS01+688
CVTRV617 EQU   CVTS01+684
CVTRV616 EQU   CVTS01+680
CVTRV615 EQU   CVTS01+676
CVTRV614 EQU   CVTS01+672
CVTRV613 EQU   CVTS01+668
CVTTCASP EQU   CVTS01+664
CVT0PT03 EQU   CVTS01+660
CVT0PT0E EQU   CVTS01+656
CVTRV609 EQU   CVTS01+652
CVTCGK   EQU   CVTS01+648
CVTRAC   EQU   CVTS01+644
CVTRV606 EQU   CVTS01+640
CVTRV605 EQU   CVTS01+636
CVTRV604 EQU   CVTS01+632
CVTEFF02 EQU   CVTS01+628
CVTCBBR  EQU   CVTS01+624
CVTSSCR  EQU   CVTS01+620
CVTEVENT EQU   CVTS01+616
CVTCRCA  EQU   CVTS01+612
CVTTPIO  EQU   CVTS01+608
CVTADV   EQU   CVTS01+604
CVTGSDAB EQU   CVTGSDA
CVTQV3   EQU   CVTS01+596
CVTQV2   EQU   CVTS01+592
CVTQV1   EQU   CVTS01+588
CVTRPT   EQU   CVTS01+584
CVTSSRB  EQU   CVTS01+580
CVTCSDRL EQU   CVTS01+576
CVTEXP1  EQU   CVTS01+572
CVTRMPMT EQU   CVTS01+568
CVTRMPTT EQU   CVTS01+564
CVTVPSA  EQU   CVTS01+560
CVTVSTOP EQU   CVTS01+556
CVTGTFR8 EQU   CVTS01+552
CVTQUIT  EQU   CVTS01+548
CVTVACR  EQU   CVTS01+544
CVTWTCB  EQU   CVTS01+540
CVTSTPRS EQU   CVTS01+536
CVT0PT02 EQU   CVTS01+532
CVTDARCM EQU   CVTS01+528
CVTIRECM EQU   CVTS01+524
CVTJRECM EQU   CVTS01+520
CVTVEMS0 EQU   CVTS01+516
CVTSPFRR EQU   CVTS01+512
CVTRLSTG EQU   CVTS01+508
CVT0TC0A EQU   CVTS01+504
CVTGMBR  EQU   CVTS01+500
CVTLFRM  EQU   CVTS01+496
CVTRMBR  EQU   CVTS01+492
CVTVIOP  EQU   CVTS01+488
CVTRV307 EQU   CVTS01+486
CVTRV306 EQU   CVTS01+484
CVTRV305 EQU   CVTS01+482
CVTRV304 EQU   CVTS01+480
CVTRV303 EQU   CVTS01+478
CVTRV302 EQU   CVTS01+476
CVTTRCA  EQU   CVTS01+472
CVTRV297 EQU   CVTRV289
CVTRV296 EQU   CVTRV289
CVTRV295 EQU   CVTRV289
CVTRV294 EQU   CVTRV289
CVTRV293 EQU   CVTRV289
CVTRV292 EQU   CVTRV289
CVTRV291 EQU   CVTRV289
CVTRV290 EQU   CVTRV289
CVTRV288 EQU   CVTRV280
CVTRV287 EQU   CVTRV280
CVTRV286 EQU   CVTRV280
CVTRV285 EQU   CVTRV280
CVTRV284 EQU   CVTRV280
CVTRV283 EQU   CVTRV280
CVTRV282 EQU   CVTRV280
CVTRV281 EQU   CVTRV280
CVTRV279 EQU   CVTRV271
CVTRV278 EQU   CVTRV271
CVTRV277 EQU   CVTRV271
CVTRV276 EQU   CVTRV271
CVTRV275 EQU   CVTRV271
CVTRV274 EQU   CVTRV271
CVTRV273 EQU   CVTRV271
CVTRV272 EQU   CVTRV271
CVTRV270 EQU   CVTRV262
CVTRV269 EQU   CVTRV262
CVTRV268 EQU   CVTRV262
CVTRV267 EQU   CVTRV262
CVTRV266 EQU   CVTRV262
CVTRV265 EQU   CVTRV262
CVTRV264 EQU   CVTRV262
CVTRV263 EQU   CVTRV262
CVTVFP   EQU   CVTS01+464
CVTVSI   EQU   CVTS01+460
CVTVPSIB EQU   CVTS01+456
CVTMFACT EQU   CVTMFRTR
CVTMFCTL EQU   CVTS01+448
CVTPVBP  EQU   CVTS01+444
CVTPWI   EQU   CVTS01+440
CVTRV254 EQU   CVTS01+438
CVTRV253 EQU   CVTS01+436
CVTRV252 EQU   CVTS01+434
CVTRV251 EQU   CVTS01+433
CVTRV250 EQU   CVTS01+432
CVTRV249 EQU   CVTS01+431
CVTRV248 EQU   CVTS01+430
CVTRV247 EQU   CVTS01+429
CVTRV246 EQU   CVTS01+428
CVTRV245 EQU   CVTRV237
CVTRV244 EQU   CVTRV237
CVTRV243 EQU   CVTRV237
CVTRV242 EQU   CVTRV237
CVTRV241 EQU   CVTRV237
CVTRV240 EQU   CVTRV237
CVTRV239 EQU   CVTRV237
CVTRV238 EQU   CVTRV237
CVTRV236 EQU   CVTRV228
CVTRV235 EQU   CVTRV228
CVTRV234 EQU   CVTRV228
CVTRV233 EQU   CVTRV228
CVTRV232 EQU   CVTRV228
CVTRV231 EQU   CVTRV228
CVTRV230 EQU   CVTRV228
CVTRV229 EQU   CVTRV228
CVTRV227 EQU   CVTRV219
CVTRV226 EQU   CVTRV219
CVTRV225 EQU   CVTRV219
CVTRV224 EQU   CVTRV219
CVTRV223 EQU   CVTRV219
CVTRV222 EQU   CVTRV219
CVTRV221 EQU   CVTRV219
CVTRV220 EQU   CVTRV219
CVTRV218 EQU   CVTRV210
CVTRV217 EQU   CVTRV210
CVTRV216 EQU   CVTRV210
CVTRV215 EQU   CVTRV210
CVTRV214 EQU   CVTRV210
CVTRV213 EQU   CVTRV210
CVTRV212 EQU   CVTRV210
CVTRV211 EQU   CVTRV210
CVTLCCAT EQU   CVTS01+420
CVTPCCAT EQU   CVTS01+416
CVTIPCRP EQU   CVTS01+412
CVTIPCRI EQU   CVTS01+408
CVTIPCDS EQU   CVTS01+404
CVTAIDVT EQU   CVTS01+400
CVTSSAP  EQU   CVTS01+396
CVTEHCIR EQU   CVTS01+392
CVTEHDEF EQU   CVTS01+388
CVTDAIR  EQU   CVTS01+384
CVTPERFM EQU   CVTS01+380
CVT044R2 EQU   CVTS01+376
CVTFETCH EQU   CVTS01+372
CVTRSTWD EQU   CVTS01+368
CVTSPOST EQU   CVTS01+364
CVTIOBP  EQU   CVTS01+360
CVTASMVT EQU   CVTS01+356
CVTRECRQ EQU   CVTS01+352
CVTWSAC  EQU   CVTS01+348
CVTRV149 EQU   CVTS01+344
CVTWSAL  EQU   CVTS01+340
CVTSPSA  EQU   CVTS01+336
CVTGLMN  EQU   CVTS01+332
CVTVEAC0 EQU   CVTS01+328
CVT062R1 EQU   CVTS01+324
CVTRPOST EQU   CVTS01+320
CVTDQIQE EQU   CVTS01+316
CVTCSD   EQU   CVTS01+312
CVTLKRMA EQU   CVTS01+308
CVTRSPIE EQU   CVTS01+304
CVTRENQ  EQU   CVTS01+300
CVTLQCB  EQU   CVTS01+296
CVTFQCB  EQU   CVTS01+292
CVTQCS01 EQU   CVTS01+288
CVTAPFT  EQU   CVTS01+284
CVTPARRL EQU   CVTS01+280
CVTVWAIT EQU   CVTS01+276
CVTGSPL  EQU   CVTS01+272
CVTLSMQ  EQU   CVTS01+268
CVTGSMQ  EQU   CVTS01+264
CVTEXPRO EQU   CVTS01+260
CVTOPCTP EQU   CVTS01+256
CVTSIC   EQU   CVTS01+252
CVTTPIOS EQU   CVTS01+248
CVTRTMS  EQU   CVTS01+244
CVTSDBF  EQU   CVTS01+240
CVTSCBP  EQU   CVTS01+236
CVTSDMP  EQU   CVTS01+232
CVTSV60  EQU   CVTS01+228
CVTRTMCT EQU   CVTS01+224
CVTASCBL EQU   CVTS01+220
CVTASCBH EQU   CVTS01+216
CVTGDA   EQU   CVTS01+212
CVTASVT  EQU   CVTS01+208
CVTVVMDI EQU   CVTS01+204
CVTAQTOP EQU   CVTS01+200
CVTIOSCS EQU   CVTS01+196
CVTSDRM  EQU   CVTS01+192
CVTOPTE  EQU   CVTS01+188
CVTSTXU  EQU   CVTS01+184
CVTQUIS  EQU   CVTS01+180
CVTPARS  EQU   CVTS01+176
CVTS1EE  EQU   CVTS01+172
CVTFRAS  EQU   CVTS01+168
CVTQSAS  EQU   CVTS01+164
CVTCRAS  EQU   CVTS01+160
CVTCRMN  EQU   CVTS01+156
CVTDELCP EQU   CVTS01+152
CVTFRECL EQU   CVTS01+148
CVTGETCL EQU   CVTS01+144
CVTBLDCP EQU   CVTS01+140
CVTAUTHL EQU   CVTS01+136
CVTSCAN  EQU   CVTS01+132
CVTRV144 EQU   CVTS01+130
CVTMAXMP EQU   CVTS01+128
CVTSTCK  EQU   CVTS01+124
CVTRV139 EQU   CVTS01+123
CVTDSSAC EQU   CVTS01+122
CVTRV513 EQU   CVTS01+121
CVTIOSPL EQU   CVTS01+120
CVTPTGT  EQU   CVTS01+116
CVTCSPIE EQU   CVTS01+112
CVTSMFEX EQU   CVTS01+108
CVTOLT0A EQU   CVTS01+104
CVTSRBRT EQU   CVTS01+100
CVTPUTL  EQU   CVTS01+96
CVTASCRL EQU   CVTS01+92
CVTASCRF EQU   CVTS01+88
CVTRV326 EQU   CVTS01+84
CVTRV325 EQU   CVTS01+80
CVTRV324 EQU   CVTS01+76
CVT0VL01 EQU   CVTS01+72
CVTSHRVM EQU   CVTS01+68
CVTRV332 EQU   CVTS01+64
CVTTAS   EQU   CVTS01+60
CVTRSCN  EQU   CVTS01+56
CVTTRAC2 EQU   CVTS01+54
CVTTRACE EQU   CVTS01+52
CVTAPG   EQU   CVTS01+51
CVTSDTRC EQU   CVTCTLFG
CVTGTRCE EQU   CVTCTLFG
CVTNOMP  EQU   CVTCTLFG
CVTRSV79 EQU   CVTCTLFG
CVTDSTAT EQU   CVTCTLFG
CVTRSV78 EQU   CVTCTLFG
CVTRV333 EQU   CVTCTLFG
CVTRV323 EQU   CVTCTLFG
CVTSPVLK EQU   CVTS01+49
CVTRSV77 EQU   CVTS01+48
CVTRV331 EQU   CVTS01+44
CVTRV330 EQU   CVTS01+40
CVTRV329 EQU   CVTS01+36
CVTRV328 EQU   CVTS01+32
CVTRV322 EQU   CVTS01+28
CVTSLID  EQU   CVTSLIDA+1
CVTSYLK  EQU   CVTSLIDA
CVTRV321 EQU   CVTS01+20
CVTRV320 EQU   CVTS01+16
CVTLPDIR EQU   CVTLPDIA+1
CVTRSV69 EQU   CVTDIRST
CVTRSV68 EQU   CVTDIRST
CVTRSV67 EQU   CVTDIRST
CVTRSV66 EQU   CVTDIRST
CVTRSV65 EQU   CVTDIRST
CVTRSV64 EQU   CVTDIRST
CVTRSV63 EQU   CVTDIRST
CVTDICOM EQU   CVTDIRST
CVTPVTP  EQU   CVTS01+8
CVTLPDSR EQU   CVTS01+4
CVTGETL  EQU   CVTS01
TIOUCBP  EQU   TIOEDEVE+1
TIOVERF  EQU   TIOSTTB
TIOUNLD  EQU   TIOSTTB
TIOMNTD  EQU   TIOSTTB
TIOSETU  EQU   TIOSTTB
TIOVLSR  EQU   TIOSTTB
TIOPVIO  EQU   TIOSTTB
TIOREQD  EQU   TIOSTTB
TIOUSED  EQU   TIOSTTB
TIOPSLOT EQU   POOLSTAR+13
TIOPSTTB EQU   POOLSTAR+12
TIOPPOOL EQU   POOLSTAR+4
TIOPNSRT EQU   POOLSTAR+3
@NM00020 EQU   POOLSTAR+2
TIOPNSLT EQU   POOLSTAR+1
@NM00019 EQU   POOLSTAR
TIOEFSRT EQU   TIOENTRY+17
TIOSVERF EQU   TIOESTTB
TIOSUNLD EQU   TIOESTTB
TIOSMNTD EQU   TIOESTTB
TIOSSETU EQU   TIOESTTB
TIOSVLSR EQU   TIOESTTB
TIOSPVIO EQU   TIOESTTB
TIOSREQD EQU   TIOESTTB
TIOSUSED EQU   TIOESTTB
TIOSBALS EQU   TIOESTTC
TIOSBALP EQU   TIOESTTC
TIOSVOLS EQU   TIOESTTC
TIOSVOLP EQU   TIOESTTC
TIOSAFFS EQU   TIOESTTC
TIOSAFFP EQU   TIOESTTC
TIOSDEFR EQU   TIOESTTC
TIOSDKCR EQU   TIOESTTC
TIOEJFCB EQU   TIOENTRY+12
TIOEDDNM EQU   TIOENTRY+4
TIOTREM  EQU   TIOELINK
TIOESSDS EQU   TIOESYOT
TIOESYIN EQU   TIOELINK
TIOEQNAM EQU   TIOELINK
TIOEDYNM EQU   TIOELINK
TIOTTERM EQU   TIOELINK
TIOTRV01 EQU   TIOELINK
TIOSYOUT EQU   TIOELINK
TIOEWTCT EQU   TIOERLOC
TIOSDSP2 EQU   TIOESTTA
TIOSDSP1 EQU   TIOESTTA
TIOSLABL EQU   TIOESTTA
TIOSDADS EQU   TIOESTTA
TIOSJBLB EQU   TIOESTTA
TIOSPLTS EQU   TIOESTTA
TIOSPLTP EQU   TIOESTTA
TIOSLTYP EQU   TIOESTTA
TIOELNGH EQU   TIOENTRY
@NM00001 EQU   FUNCMAP
JSCBCSCB EQU   JSCBSEC1+68
JSCBPMG  EQU   JSCBWTP+2
JSCBWTSP EQU   JSCBWTP+1
JSCRSV23 EQU   JSCBWTFG
JSCRSV22 EQU   JSCBWTFG
JSCRSV21 EQU   JSCBWTFG
JSCRSV20 EQU   JSCBWTFG
JSCRSV19 EQU   JSCBWTFG
JSCRSV18 EQU   JSCBWTFG
JSCBRET  EQU   JSCBWTFG
JSCBIOFG EQU   JSCBWTFG
@NM00038 EQU   JSCBSEC1+60
JSCBQMPI EQU   JSCBSEC1+56
JSCBPMSG EQU   JSCBSWT1
JSCRSV16 EQU   JSCBSWT1
JSCRSV15 EQU   JSCBSWT1
JSCRSV14 EQU   JSCBSWT1
JSCRSV13 EQU   JSCBSWT1
JSCRSV12 EQU   JSCBSWT1
JSCRSV11 EQU   JSCBSWT1
JSCBPASS EQU   JSCBSWT1
JSCBTTTR EQU   JSCBSEC1+52
JSCRSV10 EQU   JSCBSEC1+49
JSCBAUTH EQU   JSCBOPTS
JSCSIOTS EQU   JSCBOPTS
JSCRSV08 EQU   JSCBOPTS
JSCRSV07 EQU   JSCBOPTS
JSCRSV06 EQU   JSCBOPTS
JSCBLONG EQU   JSCBOPTS
JSCRSV05 EQU   JSCBOPTS
JSCRSV04 EQU   JSCBOPTS
JSCBSECB EQU   JSCBSEC1+44
JSCRSV03 EQU   JSCBSEC1+41
JSCBSTEP EQU   JSCBSEC1+40
JSCBDCBA EQU   JSCBDCB+1
JSCRSV02 EQU   JSCBDCB
JSCBID   EQU   JSCBSEC1+32
JSCBDBTB EQU   JSCBSEC1+28
JSCBIJSC EQU   JSCBSEC1+24
JSCBTCBP EQU   JSCBSEC1+20
JSCBPCC  EQU   JSCBSEC1+16
JSCBTCP  EQU   JSCBSEC1+12
JSCBSHR  EQU   JSCBSEC1+8
JSCHPCEA EQU   JSCHPCE+1
JSCRSV32 EQU   JSCHPCE
JSCRSV01 EQU   JSCBSEC1
@NM00037 EQU   IEZJSCB
@NM00036 EQU   TCBXTNT2+32
TCBRV181 EQU   TCBRV173
TCBRV180 EQU   TCBRV173
TCBRV179 EQU   TCBRV173
TCBRV178 EQU   TCBRV173
TCBRV177 EQU   TCBRV173
TCBRV176 EQU   TCBRV173
TCBRV175 EQU   TCBRV173
TCBRV174 EQU   TCBRV173
TCBRV172 EQU   TCBRV164
TCBRV171 EQU   TCBRV164
TCBRV170 EQU   TCBRV164
TCBRV169 EQU   TCBRV164
TCBRV168 EQU   TCBRV164
TCBRV167 EQU   TCBRV164
TCBRV166 EQU   TCBRV164
TCBRV165 EQU   TCBRV164
TCBRV163 EQU   TCBRV155
TCBRV162 EQU   TCBRV155
TCBRV161 EQU   TCBRV155
TCBRV160 EQU   TCBRV155
TCBRV159 EQU   TCBRV155
TCBRV158 EQU   TCBRV155
TCBRV157 EQU   TCBRV155
TCBRV156 EQU   TCBRV155
TCBRV154 EQU   TCBRV146
TCBRV153 EQU   TCBRV146
TCBRV152 EQU   TCBRV146
TCBRV151 EQU   TCBRV146
TCBRV150 EQU   TCBRV146
TCBRV149 EQU   TCBRV146
TCBRV148 EQU   TCBRV146
TCBRV147 EQU   TCBRV146
TCBRV145 EQU   TCBXTNT2+26
TCBRV144 EQU   TCBXTNT2+24
TCBRV143 EQU   TCBXTNT2+20
TCBRV142 EQU   TCBXTNT2+16
TCBRSV49 EQU   TCBXTNT2+12
TCBEVENT EQU   TCBXTNT2+8
TCBRCMP  EQU   TCBXTNT2+5
TCBRSVAB EQU   TCBXTNT2+4
TCBGTFA  EQU   TCBGTF+1
TCBRSV47 EQU   TCBTFLG
TCBRSV46 EQU   TCBTFLG
TCBRSV45 EQU   TCBTFLG
TCBRSV44 EQU   TCBTFLG
TCBRSV43 EQU   TCBTFLG
TCBDSPIT EQU   TCBTFLG
TCBERRTN EQU   TCBTFLG
TCBASYNC EQU   TCBTFLG
@NM00035 EQU   TCB+296
TCBSVCA2 EQU   TCB+292
TCBSWASA EQU   TCB+288
TCBDBTB  EQU   TCB+284
TCBRPT   EQU   TCB+280
TCBRV141 EQU   TCBRV133
TCBRV140 EQU   TCBRV133
TCBRV139 EQU   TCBRV133
TCBRV138 EQU   TCBRV133
TCBRV137 EQU   TCBRV133
TCBRV136 EQU   TCBRV133
TCBRV135 EQU   TCBRV133
TCBRV134 EQU   TCBRV133
TCBRV132 EQU   TCBRV124
TCBRV131 EQU   TCBRV124
TCBRV130 EQU   TCBRV124
TCBRV129 EQU   TCBRV124
TCBRV128 EQU   TCBRV124
TCBRV127 EQU   TCBRV124
TCBRV126 EQU   TCBRV124
TCBRV125 EQU   TCBRV124
TCBRV123 EQU   TCBFBYT2
TCBRV122 EQU   TCBFBYT2
TCBECBNV EQU   TCBFBYT2
TCBSSSYN EQU   TCBFBYT2
TCBFPRAP EQU   TCBFBYT2
TCBFDW   EQU   TCBFBYT2
TCBFMW   EQU   TCBFBYT2
TCBCNCB  EQU   TCBFBYT2
TCBLLH   EQU   TCBFBYT1
TCBRV113 EQU   TCBFBYT1
TCBEOT   EQU   TCBFBYT1
TCBRTM2  EQU   TCBFBYT1
TCBPGNLY EQU   TCBFBYT1
TCBNDIOS EQU   TCBFBYT1
TCBACTIV EQU   TCBFBYT1
TCBEOTFM EQU   TCBFBYT1
TCBAFFN  EQU   TCB+274
TCBCCPVI EQU   TCB+272
TCBUKYSP EQU   TCB+268
TCBMODE  EQU   TCBESTAE+3
TCBERTYP EQU   TCBESTAE+2
TCBRV314 EQU   TCBESTRM
TCBRV313 EQU   TCBESTRM
TCBRV312 EQU   TCBESTRM
TCBRV311 EQU   TCBESTRM
TCBRV310 EQU   TCBESTRM
TCBRV309 EQU   TCBESTRM
TCBRV308 EQU   TCBESTRM
TCBETERM EQU   TCBESTRM
TCBSCBKY EQU   TCBESTAE
TCBRTM12 EQU   TCB+260
TCBTCBID EQU   TCB+256
TCBRSV96 EQU   TCB+252
TCBSWA   EQU   TCB+248
TCBFOEA  EQU   TCBFOE+1
TCBRSV42 EQU   TCBFOE
TCBRV306 EQU   TCB+240
TCBRSV41 EQU   TCB+239
TCBTID   EQU   TCB+238
TCBRSVAA EQU   TCB+237
TCBABCUR EQU   TCB+236
TCBTMSAV EQU   TCB+232
TCBIOTIM EQU   TCB+228
TCBRTWA  EQU   TCB+224
TCBBACK  EQU   TCB+220
TCBTIRB  EQU   TCB+216
TCBAECB  EQU   TCB+212
TCBEXT2A EQU   TCBEXT2+1
TCBRSV39 EQU   TCBEXT2
TCBSTMCT EQU   TCB+207
TCBSYSCT EQU   TCB+206
TCBRSV37 EQU   TCB+205
TCBEXSVC EQU   TCBDAR
TCBDARMS EQU   TCBDAR
TCBDARWT EQU   TCBDAR
TCBDARO  EQU   TCBDAR
TCBDARMC EQU   TCBDARC
TCBDARD  EQU   TCBDAR
TCBDARS  EQU   TCBDAR
TCBDARP  EQU   TCBDAR
TCBGTOFM EQU   TCBFLGS7
TCBADMP  EQU   TCBFLGS7
TCBRSTSK EQU   TCBFLGS7
TCBSVCS  EQU   TCBFLGS7
TCBSTACK EQU   TCBFLGS7
TCBRSV34 EQU   TCBFLGS7
TCBRSV33 EQU   TCBFLGS7
TCBGPECB EQU   TCBFLGS7
TCBNTJS  EQU   TCBFLGS6
TCBAPG   EQU   TCBFLGS6
TCBMIGR  EQU   TCBFLGS6
TCBRV303 EQU   TCBFLGS6
TCBSPVLK EQU   TCBFLGS6
TCBCPU   EQU   TCBFLGS6
TCBPIE17 EQU   TCBFLGS6
TCBRV    EQU   TCBFLGS6
TCBRSV79 EQU   TCBNDSP5
TCBRSV78 EQU   TCBNDSP5
TCBRSV77 EQU   TCBNDSP5
TCBRSV76 EQU   TCBNDSP5
TCBRSV75 EQU   TCBNDSP5
TCBRSV74 EQU   TCBNDSP5
TCBRSV95 EQU   TCBNDSP5
TCBRSV94 EQU   TCBNDSP5
TCBRSV93 EQU   TCBNDSP4
TCBRSV92 EQU   TCBNDSP4
TCBRSV91 EQU   TCBNDSP4
TCBRSV90 EQU   TCBNDSP4
TCBRSV89 EQU   TCBNDSP4
TCBRSV88 EQU   TCBNDSP4
TCBRSV87 EQU   TCBNDSP4
TCBRSV86 EQU   TCBNDSP4
TCBEXT1A EQU   TCBEXT1+1
TCBRSV32 EQU   TCBEXT1
TCBEXCPD EQU   TCB+192
TCBIOBRC EQU   TCB+188
TCBDDWTC EQU   TCB+186
TCBDDEXC EQU   TCB+184
@NM00034 EQU   TCBRECDE
TCBREC   EQU   TCBRECDE
TCBMDIDS EQU   TCB+176
TCBNDINT EQU   TCBNDSP3
TCBRSV27 EQU   TCBNDSP3
TCBRSV26 EQU   TCBNDSP3
TCBRSV25 EQU   TCBNDSP3
TCBRSV24 EQU   TCBNDSP3
TCBSRBND EQU   TCBNDSP3
TCBRV302 EQU   TCBNDSP3
TCBLJSND EQU   TCBNDSP3
TCBABE   EQU   TCBNDSP2
TCBDSS   EQU   TCBNDSP2
TCBOWAIT EQU   TCBNDSP2
TCBIWAIT EQU   TCBNDSP2
TCBNDTS  EQU   TCBNDSP2
TCBNDSVC EQU   TCBNDSP2
TCBSTPP  EQU   TCBNDSP2
TCBABD   EQU   TCBNDSP2
TCBRSV22 EQU   TCBNDSP1
TCBPIEND EQU   TCBNDSP1
TCBTPSP  EQU   TCBNDSP1
TCBDDRND EQU   TCBNDSP1
TCBRSPND EQU   TCBNDSP1
TCBRSTND EQU   TCBNDSP1
TCBDARPN EQU   TCBNDSP1
TCBDARTN EQU   TCBNDSP1
TCBNDSP0 EQU   TCBNDSP
TCBUSER  EQU   TCB+168
TCBTCTB  EQU   TCBTCT+1
TCBRSV9C EQU   TCBTCTGF
TCBRSV9B EQU   TCBTCTGF
TCBRSV9A EQU   TCBTCTGF
TCBRSV99 EQU   TCBTCTGF
TCBRSV98 EQU   TCBTCTGF
TCBRSV97 EQU   TCBTCTGF
TCBRSV20 EQU   TCBTCTGF
TCBSMFGF EQU   TCBTCTGF
TCBSTABB EQU   TCBSTAB+1
TCBSTCUR EQU   TCBNSTAE
TCBRV301 EQU   TCBNSTAE
TCBSYNCH EQU   TCBNSTAE
TCBHALT  EQU   TCBNSTAE
TCBPPSUP EQU   TCBNSTAE
TCB33E   EQU   TCBNSTAE
TCBQUIES EQU   TCBNSTAE
TCBSTABE EQU   TCBNSTAE
TCBAQE   EQU   TCB+156
TCBPQE   EQU   TCB+152
TCBTSDP  EQU   TCB+151
TCBTSLP  EQU   TCB+150
TCBSTPCT EQU   TCB+149
TCBCPUBN EQU   TCBTSFLG
TCBDYDSP EQU   TCBTSFLG
TCBRSV18 EQU   TCBTSFLG
TCBRSV17 EQU   TCBTSFLG
TCBTIOTG EQU   TCBTSFLG
TCBATT   EQU   TCBTSFLG
TCBSTPPR EQU   TCBTSFLG
TCBRV300 EQU   TCBTSTSK
TCBECB   EQU   TCB+144
TCBIQE   EQU   TCB+140
TCBLTC   EQU   TCB+136
TCBOTC   EQU   TCB+132
TCBNTC   EQU   TCB+128
TCBJSTCA EQU   TCBJSTCB+1
TCBRSV16 EQU   TCBJSTCB
TCBTQET  EQU   TCBTME
TCBTCB   EQU   TCB+116
TCBFSAB  EQU   TCBFSA+1
TCBQEL   EQU   TCBFSA
TCBGRS15 EQU   TCBGRS+60
TCBGRS14 EQU   TCBGRS+56
TCBGRS13 EQU   TCBGRS+52
TCBGRS12 EQU   TCBGRS+48
TCBGRS11 EQU   TCBGRS+44
TCBGRS10 EQU   TCBGRS+40
TCBGRS9  EQU   TCBGRS+36
TCBGRS8  EQU   TCBGRS+32
TCBGRS7  EQU   TCBGRS+28
TCBGRS6  EQU   TCBGRS+24
TCBGRS5  EQU   TCBGRS+20
TCBGRS4  EQU   TCBGRS+16
TCBGRS3  EQU   TCBGRS+12
TCBGRS2  EQU   TCBGRS+8
TCBGRS1  EQU   TCBGRS+4
TCBGRS0  EQU   TCBGRS
TCBJPQB  EQU   TCBJPQ+1
TCBRSV15 EQU   TCBPURGE
TCBRSV14 EQU   TCBPURGE
TCBRSV13 EQU   TCBPURGE
TCBRSV12 EQU   TCBPURGE
TCBRSV11 EQU   TCBPURGE
TCBRSV10 EQU   TCBPURGE
TCBRSV09 EQU   TCBPURGE
TCBJPQF  EQU   TCBPURGE
TCBJLB   EQU   TCB+40
TCBLLS   EQU   TCB+36
TCBDSP   EQU   TCB+35
TCBLMP   EQU   TCB+34
TCBPNDSP EQU   TCBFLGS5
TCBFCD1  EQU   TCBFLGS5
TCBSTP   EQU   TCBFLGS5
TCBSYS   EQU   TCBFLGS5
TCBANDSP EQU   TCBFLGS5
TCBPAGE  EQU   TCBFLGS5
TCBUXNDF EQU   TCBABWF
TCBFC    EQU   TCBFLGS5
TCBONDSP EQU   TCBFLGS4
TCBMPCND EQU   TCBFLGS4
TCBMPCVQ EQU   TCBFLGS4
TCBUXNDV EQU   TCBFLGS4
TCBHNDSP EQU   TCBFLGS4
TCBRQENA EQU   TCBFLGS4
TCBSER   EQU   TCBFLGS4
TCBNDUMP EQU   TCBFLGS4
TCBDWSTA EQU   TCBFLGS3
TCBRSV08 EQU   TCBFLGS3
TCBRSV07 EQU   TCBFLGS3
TCBRSV06 EQU   TCBFLGS3
TCBABGM  EQU   TCBFLGS3
TCBABTRM EQU   TCBFLGS3
TCBADINP EQU   TCBFLGS3
TCBFSM   EQU   TCBFLGS3
TCBFTS   EQU   TCBFLGS2
TCBFETXR EQU   TCBFLGS2
TCBFDSOP EQU   TCBFLGS2
TCBFJMC  EQU   TCBFLGS2
TCBFSMC  EQU   TCBFLGS2
TCBFABOP EQU   TCBFLGS2
TCBFSTI  EQU   TCBFLGS2
TCBFOINP EQU   TCBFLGS2
TCBFX    EQU   TCBFLGS1
TCBFS    EQU   TCBFLGS1
TCBFT    EQU   TCBFLGS1
TCBPDUMP EQU   TCBFLGS1
TCBNONPR EQU   TCBFLGS1
TCBFERA  EQU   TCBFLGS1
TCBFE    EQU   TCBFLGS1
TCBFA    EQU   TCBFLGS1
TCBZERO  EQU   TCBPKF
TCBFLAG  EQU   TCBPKF
TCBMSSB  EQU   TCBMSS+1
TCBRSV03 EQU   TCBMSS
TCBTRNB  EQU   TCBTRN+1
TCBRSV02 EQU   TCBABF
TCBOLTEP EQU   TCBABF
TCBTCP   EQU   TCBABF
TCBTCPP  EQU   TCBABF
TCBRSV01 EQU   TCBABF
TCBGRPH  EQU   TCBABF
TCBNOCHK EQU   TCBABF
TCBMOD91 EQU   TCBABF
TCBCMPC  EQU   TCBCMP+1
TCBRV318 EQU   TCBCMSG
TCBRV317 EQU   TCBCIND
TCBRV316 EQU   TCBCWTO
TCBCASID EQU   TCBCDBL
TCBNOCC  EQU   TCBSTCC
TCBDMPO  EQU   TCBCPP
TCBCSTEP EQU   TCBCMPF
TCBCREQ  EQU   TCBCMPF
TCBDEB   EQU   TCB+8
TCBPIEA  EQU   TCBPIE+1
TCBPM    EQU   TCBPMASK
@NM00033 EQU   TCBPMASK
TCBRBP   EQU   TCB
TCBFRS6  EQU   TCBFRS+24
TCBFRS4  EQU   TCBFRS+16
TCBFRS2  EQU   TCBFRS+8
TCBFRS0  EQU   TCBFRS
EREQCODE EQU   ETIOTREQ+40
EREQGRID EQU   ETIOTREQ+32
@NM00032 EQU   ETIOTREQ+19
@NM00031 EQU   ETIOTREQ+15
@NM00030 EQU   EREQSTAT
EREQCATL EQU   EREQSTAT
EREQJSCT EQU   EREQSTAT
EREQPASS EQU   EREQSTAT
EREQUNAL EQU   EREQSTAT
EREQQNM  EQU   EREQSTAT
EREQTERM EQU   EREQSTAT
@NM00029 EQU   EREQMAP
EREQMOVE EQU   EREQMAP
EREQUPD  EQU   EREQMAP
TIOMIUSL EQU   TIOMGRRB+36
TIOMSIOP EQU   TIOMGRRB+24
TIOMENTP EQU   TIOMGRRB+16
@NM00028 EQU   TIOMFMAP+1
@NM00027 EQU   TIOMFMAP+1
@NM00026 EQU   TIOMFMAP+1
@NM00025 EQU   TIOMFMAP+1
@NM00024 EQU   TIOMFMAP+1
@NM00023 EQU   TIOMFMAP+1
@NM00022 EQU   TIOMFMAP+1
TIOMCCAT EQU   TIOMFMAP
TIOMUPD  EQU   TIOMFMAP
TIOMRLSE EQU   TIOMFMAP
TIOMALOC EQU   TIOMFMAP
@NM00021 EQU   TIOMFMAP
SIODDSNL EQU   INDMSIOT+173
SIOVDSNL EQU   INDMSIOT+172
SIOVDSNT EQU   INDMSIOT+170
SVOLUNNO EQU   INDMSIOT+168
SIOTVMVP EQU   INDMSIOT+164
SIOTJFX  EQU   INDMSIOT+160
SJFCBPTR EQU   INDMSIOT+156
SIOTNPTR EQU   INDMSIOT+152
SIOTATE  EQU   INDMSIOT+144
SVOLUNAD EQU   INDMSIOT+140
SIOTEDLP EQU   INDMSIOT+136
SIOTEDLS EQU   INDMSIOT+132
SIOTRSNC EQU   INDMSIOT+130
SCTANAME EQU   INDMSIOT+122
@NM00018 EQU   INDMSIOT+108
SIOTSSNM EQU   INDMSIOT+104
SIODDQCR EQU   SIOTBYT2
SIOVDQCR EQU   SIOTBYT2
SIOTCVOL EQU   SIOTBYT2
SIOTCNEW EQU   SIOTBYT2
SIOTCALC EQU   SIOTBYT2
SIOTGALL EQU   SIOTBYT2
SIOTDSPD EQU   SIOTBYT2
SIOTDMND EQU   SIOTBYT2
SIOTOPUC EQU   INDMSIOT+99
SIOTOUTR EQU   INDMSIOT+97
SIOTOUTC EQU   INDMSIOT+96
@NM00017 EQU   INDMSIOT+93
SIOTAUNC EQU   SIOTALTD
SIOTACAT EQU   SIOTALTD
SIOTADEL EQU   SIOTALTD
SIOTAKEP EQU   SIOTALTD
SIOTNPRV EQU   SIOTALTD
SIOJCATS EQU   SIOTALTD
@NM00016 EQU   SIOTALTD
@NM00015 EQU   SIOTALTD
@NM00014 EQU   INDMSIOT+91
SIOTNDSB EQU   INDMSIOT+88
@NM00013 EQU   INDMSIOT+84
SIOTDPCD EQU   INDMSIOT+82
@NM00012 EQU   INDMSIOT+81
SCTOUTPN EQU   INDMSIOT+80
SCTOUTNO EQU   INDMSIOT+76
SCTOUTNM EQU   INDMSIOT+68
SIOUBYT4 EQU   SIOTDEVT+3
@NM00011 EQU   SIOUBYT3
SIO3UREC EQU   SIOUBYT3
SIO3DISP EQU   SIOUBYT3
SIO3DACC EQU   SIOUBYT3
SIO3COMM EQU   SIOUBYT3
SIO3TAPE EQU   SIOUBYT3
SIOUBYT2 EQU   SIOTDEVT+1
SIOUBYT1 EQU   SIOTDEVT
SIOTOMN  EQU   SCTSBYT4
SIOTIPDI EQU   SCTSBYT4
SIOTVAFF EQU   SCTSBYT4
SIOTSTEP EQU   SCTSBYT4
SIOTASCI EQU   SCTSBYT4
SIOTAFF  EQU   SCTSBYT4
SIOTGDGA EQU   SCTSBYT4
SCTSGDGS EQU   SCTSBYT4
SCTSOLD  EQU   SCTSBYT3
SCTSMOD  EQU   SCTSBYT3
SCTSNEW  EQU   SCTSBYT3
SCTSYSOU EQU   SCTSBYT3
SCTVREF  EQU   SCTSBYT3
SCTALCHK EQU   SCTSBYT3
SCTSYSNE EQU   SCTSBYT3
SCTDSNRF EQU   SCTSBYT3
SCTRECVD EQU   SCTSBYT2
SCTDEFER EQU   SCTSBYT2
SCTLABEL EQU   SCTSBYT2
SCTUNLBD EQU   SCTSBYT2
SCTJOBLB EQU   SCTSBYT2
SCTVOLAF EQU   SCTSBYT2
SIOTCATL EQU   SCTSBYT2
SIOCLUNL EQU   SCTSBYT2
SIOTJSCT EQU   SCTSBYT1
SCTUNAFF EQU   SCTSBYT1
SCTPARLM EQU   SCTSBYT1
SIOTQDSN EQU   SCTSBYT1
SIOTGDSN EQU   SCTSBYT1
SIOTCCAT EQU   SCTSBYT1
SCTSYSIN EQU   SCTSBYT1
SCTDUMMY EQU   SCTSBYT1
SIOTUNCT EQU   SCTSDISP
SIOTCTLG EQU   SCTSDISP
SIOTDLET EQU   SCTSDISP
SIOTKEEP EQU   SCTSDISP
SIOTPASS EQU   SCTSDISP
SIOTPRIV EQU   SCTSDISP
S3400DSP EQU   SCTSDISP
SIOTRETN EQU   SCTSDISP
SIOTVLCT EQU   INDMSIOT+54
SCTNMBUT EQU   INDMSIOT+53
SIOTRTRY EQU   SIOTBYT0
SIOTPUPV EQU   SIOTBYT0
SIOTNOPV EQU   SIOTBYT0
SIOTGIGN EQU   SIOTBYT0
SPVTAMSG EQU   SIOTBYT0
SIOTFUDA EQU   SIOTBYT0
SIOTDYAL EQU   SIOTBYT0
SIOTSSDS EQU   SIOTBYT0
SIOTGIID EQU   INDMSIOT+50
SCTVOLCT EQU   INDMSIOT+49
SCTSPOOL EQU   INDMSIOT+48
SIOTQNAM EQU   SIOTTSTC
SIOTDSNM EQU   SIOTTSTC
SIOTTRKM EQU   SIOTTSTC
@NM00010 EQU   SIOTTSTC
SIOTTERM EQU   SIOTTSTC
@NM00009 EQU   SIOTTSTC
@NM00008 EQU   SIOTBYT3
SIOTJES3 EQU   SIOTBYT3
SIOCDEVT EQU   SIOTBYT3
SIOALIAS EQU   SIOTBYT3
SCTDDINO EQU   INDMSIOT+44
SIOTDDNT EQU   SIOTBYT1
SIOTALCD EQU   SIOTBYT1
SIODADSM EQU   SIOTBYT1
SIOTDADR EQU   SIOTBYT1
SIODUNAL EQU   SIOTBYT1
SIOTHOLD EQU   SIOTBYT1
SIOTOCKP EQU   SIOTBYT1
SIOPSCNT EQU   INDMSIOT+42
SIOTREFN EQU   INDMSIOT+40
SIOTOTUN EQU   INDMSIOT+39
SIOTVRSB EQU   INDMSIOT+36
@NM00007 EQU   INDMSIOT+35
@NM00006 EQU   INDMSIOT+31
SCTPSIOT EQU   INDMSIOT+28
SIOTAFID EQU   INDMSIOT+26
@NM00005 EQU   INDMSIOT+24
SIODSNTE EQU   INDMSIOT+22
SIOTUNAF EQU   SCTUSADD
SIOTDEST EQU   INDMSIOT+12
SIOTTYPE EQU   INDMSIOT+3
CVTLEVL  EQU   CVTRELNO+2
CVTNUMB  EQU   CVTRELNO
CVTMDL   EQU   CVTFIX+250
@NM00004 EQU   CVTFIX+248
@NM00003 EQU   CVTFIX
CVTRV482 EQU   CVTXTNT2+128
CVTRV481 EQU   CVTXTNT2+124
CVTRV480 EQU   CVTXTNT2+120
CVTRV479 EQU   CVTXTNT2+118
CVTRV478 EQU   CVTXTNT2+117
CVTRV477 EQU   CVTXTNT2+116
CVTRV476 EQU   CVTXTNT2+115
CVTRV475 EQU   CVTXTNT2+114
CVTRV474 EQU   CVTRV466
CVTRV473 EQU   CVTRV466
CVTRV472 EQU   CVTRV466
CVTRV471 EQU   CVTRV466
CVTRV470 EQU   CVTRV466
CVTRV469 EQU   CVTRV466
CVTRV468 EQU   CVTRV466
CVTRV467 EQU   CVTRV466
CVTRV465 EQU   CVTRV457
CVTRV464 EQU   CVTRV457
CVTRV463 EQU   CVTRV457
CVTRV462 EQU   CVTRV457
CVTRV461 EQU   CVTRV457
CVTRV460 EQU   CVTRV457
CVTRV459 EQU   CVTRV457
CVTRV458 EQU   CVTRV457
CVTRV456 EQU   CVTXTNT2+108
CVTRV455 EQU   CVTXTNT2+104
CVTRV454 EQU   CVTXTNT2+100
CVTRV453 EQU   CVTXTNT2+96
CVTRV452 EQU   CVTXTNT2+94
CVTRV451 EQU   CVTXTNT2+92
CVTRV450 EQU   CVTXTNT2+90
CVTRV449 EQU   CVTXTNT2+88
CVTRV448 EQU   CVTXTNT2+87
CVTRV447 EQU   CVTXTNT2+86
CVTRV446 EQU   CVTRV438
CVTRV445 EQU   CVTRV438
CVTRV444 EQU   CVTRV438
CVTRV443 EQU   CVTRV438
CVTRV442 EQU   CVTRV438
CVTRV441 EQU   CVTRV438
CVTRV440 EQU   CVTRV438
CVTRV439 EQU   CVTRV438
CVTRV437 EQU   CVTRV429
CVTRV436 EQU   CVTRV429
CVTRV435 EQU   CVTRV429
CVTRV434 EQU   CVTRV429
CVTRV433 EQU   CVTRV429
CVTRV432 EQU   CVTRV429
CVTRV431 EQU   CVTRV429
CVTRV430 EQU   CVTRV429
CVTRV428 EQU   CVTXTNT2+80
CVTRV427 EQU   CVTXTNT2+76
CVTRV426 EQU   CVTXTNT2+72
CVTRV425 EQU   CVTXTNT2+68
CVTATACT EQU   CVTATCVT
CVTRV423 EQU   CVTXTNT2+62
CVTRV422 EQU   CVTXTNT2+60
CVTRV421 EQU   CVTXTNT2+58
CVTRV420 EQU   CVTXTNT2+56
CVTRV419 EQU   CVTXTNT2+55
CVTRV418 EQU   CVTXTNT2+54
CVTRV417 EQU   CVTRV409
CVTRV416 EQU   CVTRV409
CVTRV415 EQU   CVTRV409
CVTRV414 EQU   CVTRV409
CVTRV413 EQU   CVTRV409
CVTRV412 EQU   CVTRV409
CVTRV411 EQU   CVTRV409
CVTRV410 EQU   CVTRV409
CVTRV408 EQU   CVTRV400
CVTRV407 EQU   CVTRV400
CVTRV406 EQU   CVTRV400
CVTRV405 EQU   CVTRV400
CVTRV404 EQU   CVTRV400
CVTRV403 EQU   CVTRV400
CVTRV402 EQU   CVTRV400
CVTRV401 EQU   CVTRV400
CVTICB   EQU   CVTXTNT2+48
CVTSKTA  EQU   CVTXTNT2+44
CVTRSV99 EQU   CVTXTNT2+40
CVTRSV98 EQU   CVTXTNT2+36
CVTRSV97 EQU   CVTXTNT2+34
CVTRSV96 EQU   CVTXTNT2+32
CVTOLTEP EQU   CVTXTNT2+28
CVTQIDA  EQU   CVTQID+1
CVTRSV95 EQU   CVTQID
CVTRSV94 EQU   CVTXTNT2+20
CVTRSV93 EQU   CVTXTNT2+16
CVTRSV92 EQU   CVTXTNT2+12
CVTDEBVR EQU   CVTXTNT2+8
CVTRSV91 EQU   CVTXTNT2+6
CVTRSV9H EQU   CVTFLGBT
CVTRSV9G EQU   CVTFLGBT
CVTRSV9F EQU   CVTFLGBT
CVTRSV9E EQU   CVTFLGBT
CVTRSV9D EQU   CVTFLGBT
CVTRSV9C EQU   CVTFLGBT
CVTVME   EQU   CVTFLGBT
CVTNPE   EQU   CVTFLGBT
CVTNUCLS EQU   CVTXTNT2+4
CVTDSSVA EQU   CVTDSSV+1
CVTRSV89 EQU   CVTDSSV
CVTRSV88 EQU   CVTXTNT1+8
CVTRSV87 EQU   CVTXTNT1+4
CVTFACHN EQU   CVTXTNT1
CVTRV488 EQU   CVTMAP+412
CVTRV487 EQU   CVTMAP+408
CVTRV486 EQU   CVTMAP+404
CVTRV485 EQU   CVTMAP+400
CVTACTAP EQU   CVTMAP+396
CVTAUTH  EQU   CVTMAP+392
CVTATMCA EQU   CVTATMCT+1
CVTATMST EQU   CVTATMCT
CVTRSV61 EQU   CVTMAP+384
CVTVOLT1 EQU   CVTVOLM1+1
CVTVOLI1 EQU   CVTVOLF1
CVTSTOA  EQU   CVTMAP+376
CVTRSV58 EQU   CVTMAP+374
CVTRSV57 EQU   CVTMAP+372
CVTDDCE  EQU   CVTMAP+368
CVTPNWFR EQU   CVTMAP+364
CVTSMF   EQU   CVTMAP+360
CVTSULK  EQU   CVTMAP+358
CVTSLKO  EQU   CVTSYSK
CVTSLKP  EQU   CVTSYSK
CVTSLKQ  EQU   CVTSYSK
CVTSLKR  EQU   CVTSYSK
CVTRSV56 EQU   CVTSYSK
CVTRSV55 EQU   CVTSYSK
CVTRSV54 EQU   CVTSYSK
CVTRSV53 EQU   CVTSYSK
CVTRSV52 EQU   CVTA1F1
CVTRSV51 EQU   CVTA1F1
CVTRSV50 EQU   CVTA1F1
CVTRSV49 EQU   CVTA1F1
CVTRSV48 EQU   CVTA1F1
CVTRSV47 EQU   CVTA1F1
CVTSRSW  EQU   CVTA1F1
CVTPFSW  EQU   CVTA1F1
CVTPCVT  EQU   CVTMAP+352
CVTRSV46 EQU   CVTMAP+344
CVTRSV45 EQU   CVTMAP+340
CVTRSV44 EQU   CVTMAP+338
CVTRSV43 EQU   CVTMAP+336
CVTHJESA EQU   CVTHJES+1
CVTRSV42 EQU   CVTHJES
CVTEXT2A EQU   CVTEXT2+1
CVTRSV41 EQU   CVTEXT2
CVTAPFA  EQU   CVTAPF+1
CVTRSV40 EQU   CVTAPF
CVTRV518 EQU   CVTINTLA
CVTRV517 EQU   CVTERPV
CVTEORM  EQU   CVTMAP+312
CVTMCHPR EQU   CVTMAP+308
CVTTZ    EQU   CVTMAP+304
CVTJEPS  EQU   CVTMAP+300
CVTJESCT EQU   CVTMAP+296
CVTMODE  EQU   CVTMAP+292
CVTPTRV  EQU   CVTMAP+288
CVTREAL  EQU   CVTMAP+284
CVTRSV39 EQU   CVTMAP+280
CVTRSV38 EQU   CVTMAP+276
CVTDMSRA EQU   CVTDMSR+1
CVTRV634 EQU   CVTDMSRF
CVTRV633 EQU   CVTDMSRF
CVTRV632 EQU   CVTDMSRF
CVTRV631 EQU   CVTDMSRF
CVTRV630 EQU   CVTDMSRF
CVTRV629 EQU   CVTDMSRF
CVTUDUMP EQU   CVTDMSRF
CVTSDUMP EQU   CVTDMSRF
CVTQMSGA EQU   CVTQMSG+1
CVTRSV36 EQU   CVTQMSG
CVTAMFF  EQU   CVTMAP+264
CVTPURGA EQU   CVTPURG+1
CVTRSV35 EQU   CVTPURG
CVTCBSP  EQU   CVTMAP+256
CVTATERA EQU   CVTATER+1
CVTSYST  EQU   CVTATER
CVTVOLT2 EQU   CVTTAT
CVTVOLI2 EQU   CVTVOLF2
CVTAQAVB EQU   CVTAQAVT+1
CVTRSV34 EQU   CVTTCMFG
CVTRSV33 EQU   CVTTCMFG
CVTRSV32 EQU   CVTTCMFG
CVTRSV31 EQU   CVTTCMFG
CVTRSV30 EQU   CVTTCMFG
CVTRSV29 EQU   CVTTCMFG
CVTRSV28 EQU   CVTTCMFG
CVTTCRDY EQU   CVTTCMFG
CVTGTFA  EQU   CVTGTF+1
CVTRSV27 EQU   CVTGTFST
CVTRNIO  EQU   CVTGTFST
CVTUSR   EQU   CVTGTFST
CVTRV318 EQU   CVTFORM
CVTRV317 EQU   CVTTMODE
CVTRV316 EQU   CVTSTATE
CVTRV315 EQU   CVTGTFS
CVTGTFAV EQU   CVTGTFS
CVT0SCR1 EQU   CVTMAP+232
CVTRV515 EQU   CVTMAP+228
CVTRMS   EQU   CVTMAP+224
CVTPATCH EQU   CVTMAP+220
CVTTSCE  EQU   CVTMAP+216
CVTLNKSC EQU   CVTMAP+214
CVTQABST EQU   CVTMAP+212
CVTMDLDS EQU   CVTMAP+208
CVTUSER  EQU   CVTMAP+204
CVTABEND EQU   CVTMAP+200
CVTSMCA  EQU   CVTMAP+196
CVTRSV18 EQU   CVTMAP+192
CVTQLPAQ EQU   CVTMAP+188
CVTQCDSR EQU   CVTMAP+184
CVTRSV17 EQU   CVTOPTB
CVTRSV16 EQU   CVTOPTB
CVTFP    EQU   CVTOPTB
CVTAPTHR EQU   CVTOPTB
CVTNLOG  EQU   CVTOPTB
CVTTOD   EQU   CVTOPTB
CVTCTIMS EQU   CVTOPTB
CVTPROT  EQU   CVTOPTB
CVTXPFP  EQU   CVTOPTA
CVTASCII EQU   CVTOPTA
CVTRSV13 EQU   CVTOPTA
CVTRSV12 EQU   CVTOPTA
CVTNIP   EQU   CVTOPTA
CVTDDR   EQU   CVTOPTA
CVTAPR   EQU   CVTOPTA
CVTCCH   EQU   CVTOPTA
CVTSNCTR EQU   CVTMAP+180
CVTQMWR  EQU   CVTMAP+176
CVTQOCR  EQU   CVTMAP+172
CVT1EF00 EQU   CVTMAP+168
CVTMZ00  EQU   CVTMAP+164
CVTHEAD  EQU   CVTMAP+160
CVTRSV11 EQU   CVTMAP+156
CVT0PT01 EQU   CVTMAP+152
CVTMSER  EQU   CVTMAP+148
CVTRV516 EQU   CVTIERLC
CVTILCH  EQU   CVTMAP+140
CVT0DS   EQU   CVTMAP+136
CVTFBOSV EQU   CVTMAP+132
CVTNUCB  EQU   CVTMAP+128
CVTIXAVL EQU   CVTMAP+124
CVTIOQET EQU   CVTMAP+120
CVTDCBA  EQU   CVTMAP+117
CVTMVS2  EQU   CVTDCB
CVT6DAT  EQU   CVTDCB
CVT4MPS  EQU   CVTDCB
CVTRSV09 EQU   CVTDCB
CVT4MS1  EQU   CVTDCB
CVT2SPS  EQU   CVTDCB
CVT1SSS  EQU   CVTDCB
CVTRSV08 EQU   CVTDCB
CVTSTB   EQU   CVTMAP+112
CVTQTD00 EQU   CVTMAP+108
CVTQTE00 EQU   CVTMAP+104
CVTCUCB  EQU   CVTMAP+100
CVTSJQ   EQU   CVTMAP+96
CVTPBLDL EQU   CVTMAP+92
CVTTPC   EQU   CVTMAP+88
CVTSVDCB EQU   CVTMAP+84
CVTBRET  EQU   CVTMAP+82
CVTEXIT  EQU   CVTMAP+80
CVT0FN00 EQU   CVTMAP+76
CVTDARA  EQU   CVTDAR+1
CVTRSV07 EQU   CVTFLGS1
CVTRSV06 EQU   CVTFLGS1
CVTRSV05 EQU   CVTFLGS1
CVTRSV04 EQU   CVTFLGS1
CVTRSV03 EQU   CVTFLGS1
CVTRSV02 EQU   CVTFLGS1
CVTRSV01 EQU   CVTFLGS1
CVTDMPLK EQU   CVTFLGS1
CVTXITP  EQU   CVTMAP+68
CVTZDTAB EQU   CVTMAP+64
CVTMSLT  EQU   CVTMAP+60
CVTDATE  EQU   CVTMAP+56
CVTBTERM EQU   CVTMAP+52
CVTSYSAD EQU   CVTMAP+48
CVTXTLER EQU   CVTMAP+44
CVTILK2  EQU   CVTMAP+40
CVTILK1  EQU   CVTMAP+36
CVTPRLTV EQU   CVTMAP+32
CVTPCNVT EQU   CVTMAP+28
CVT0VL00 EQU   CVTMAP+24
CVTXAPG  EQU   CVTMAP+20
CVTBUF   EQU   CVTMAP+16
CVTJOB   EQU   CVTMAP+12
CVTLINK  EQU   CVTMAP+8
CVT0EF00 EQU   CVTMAP+4
CVT      EQU   CVTMAP
@NM00002 EQU   TCBPTRS
.@UNREFD ANOP                          END UNREFERENCED COMPONENTS
@RF00090 EQU   @RC00069
@RF00106 EQU   @RC00094
@ENDDATA EQU   *
         END   IEFAB4A3,(C'PLS2037',0701,76279)
