         TITLE 'IEFAB4A6 - DATA SET RELEASE                            *
                        '
IEFAB4A6 CSECT ,                                                01S0001
@MAINENT DS    0H                                               01S0001
         USING *,@15                                            01S0001
         B     @PROLOG                                          01S0001
         DC    AL1(16)                                          01S0001
         DC    C'IEFAB4A6  73.325'                              01S0001
         DROP  @15
@PROLOG  STM   @14,@12,12(@13)                                  01S0001
         BALR  @12,0                                            01S0001
@PSTART  DS    0H                                               01S0001
         USING @PSTART,@12                                      01S0001
         L     @00,@SIZDATD                                     01S0001
         MODESET EXTKEY=SCHED,SAVEKEY=(2)
         GSPACE  R,LV=(0)
         LR    @11,@01                                          01S0001
         USING @DATD,@11                                        01S0001
         ST    @13,@SA00001+4                                   01S0001
         STC   @02,@OLDKEY                                      01S0001
         MODESET KEYADDR=(2)
         LM    @00,@02,20(@13)                                  01S0001
         ST    @11,8(,@13)                                      01S0001
         LR    @13,@11                                          01S0001
         MODESET EXTKEY=ZERO
         MVC   @PC00001(24),0(@01)                              01S0001
         MODESET EXTKEY=SCHED
*RETCODE = ZERO;                       /* INIT RETURN CODE.          */
         SLR   @10,@10                                          01S0022
         LR    RETCODE,@10                                      01S0022
*IF NODSRLST = ON THEN                 /* DSR LIST NON-EXISTENT?     */
         L     @07,@PC00001                                     01S0023
         TM    NODSRLST(@07),B'10000000'                        01S0023
         BNO   @RF00023                                         01S0023
*  DO;                                                          01S0024
*/********************************************************************/
*/*                                                                  */
*/* SEGMENT NAME - READDSNQ                                          */
*/*                                                                  */
*/* DESCRIPTIVE NAME - READ DATA SET ENQUEUE TABLE                   */
*/*                                                                  */
*/* FUNCTION -                                                       */
*/*                                                                  */
*/*   THIS ROUTINE USES THE SWA MANAGER INTERFACE ROUTINE TO READ IN */
*/*   ALL THE BLOCKS OF THE DATA SET ENQUEUE TABLE AND CHAIN THEM    */
*/*   TOGETHER VIA IN-CORE POINTERS.  THE ROUTINE ALSO COUNTS ALL    */
*/*   THE ENTRIES IN THE TABLE WHICH WILL BE RELEASED.  THIS TOTAL   */
*/*   IS USED TO COMPUTE AND OBTAIN THE AMOUNT OF CORE NEEDED FOR    */
*/*   THE DEQ PARAMETER LIST.                                        */
*/*                                                                  */
*/*   OPERATION -                                                    */
*/*                                                                  */
*/*     THE INTERFACE TO THE SWA MANAGER IS INITIALIZED TO REQUEST   */
*/*     CREATION OF A NEW EPA FOR EACH BLOCK READ IN, AND THE READ-  */
*/*     ING OF ONE BLOCK AT A TIME.  THE INPUT SVA OF THE FIRST      */
*/*     DSENQ TABLE BLOCK IS USED FOR THE FIRST READ.  FOR ALL       */
*/*     SUCCEEDING BLOCKS, THE SVA IS OBTAINED FROM THE PREVIOUS     */
*/*     BLOCK READ IN.  THE IN-CORE POINTER TO THE FIRST BLOCK IS    */
*/*     RETURNED BY THE SWA MANAGER INTERFACE ROUTINE IN AN AREA TO  */
*/*     BE USED LATER TO POINT TO THE BEGINNING OF THE CHAIN OF      */
*/*     BLOCKS.  ALL SUCCESSIVE IN-CORE POINTERS ARE RETURNED IN THE */
*/*     FORWARD CHAIN POINTER OF THE PREVIOUS RECORD READ IN,        */
*/*     CREATING A CHAIN OF IN-CORE BLOCKS.                          */
*/*                                                                  */
*/*     THE POINTER TO EACH NEW EPA IS RETURNED BY THE SWA MANAGER.  */
*/*     THE POINTER TO THE FIRST EPA IS SAVED TO BE USED WHEN        */
*/*     WRITING ALL THE RECORDS AND FREEING ALL THE EPA'S.  THE      */
*/*     POINTER TO THE LATEST EPA CREATED IS PASSED TO THE SWA       */
*/*     MANAGER INTERFACE ROUTINE TO BE USED IN CHAINING THE EPA'S   */
*/*     TOGETHER.                                                    */
*/*                                                                  */
*/*     AS EACH BLOCK IS READ IN, ALL ITS DATA SET ENTRIES ARE EX-   */
*/*     AMINED.  EACH ENTRY HAVING THE SAME STEP NUMBER AS THE       */
*/*     CURRENT STEP WILL BE DEQ'D.  FOR EACH SUCH DATA SET ENTRY,   */
*/*     THE AMOUNT OF CORE NEEDED FOR THE DEQ PARAMETER LIST IS      */
*/*     INCREASED BY THE LENGTH OF A DEQ PARAMETER LIST ENTRY.       */
*/*                                                                  */
*/*     WHEN ALL BLOCKS OF THE DATA SET ENQUEUE TABLE HAVE BEEN READ */
*/*     IN, THE FORWARD POINTER IN THE LAST BLOCK IS SET TO ZERO TO  */
*/*     INDICATE THE END OF THE CHAIN OF DATA SET ENQUEUE TABLE      */
*/*     BLOCKS.  AN ATTEMPT IS THEN MADE TO OBTAIN THE CORE NEEDED   */
*/*     FOR THE DEQ PARAMETER LIST.  IF THE ATTEMPT IS UNSUCCESSFUL, */
*/*     A REASON CODE OF '2' IS SET, INDICATING THAT DATA SET        */
*/*     RELEASE WASN'T PERFORMED.                                    */
*/*                                                                  */
*/* ENTRY - IN-LINE SEGMENT                                          */
*/*                                                                  */
*/*   PURPOSE - SEE FUNCTION                                         */
*/*   INPUT -                                                        */
*/*     DSNQTABL - DATA SET ENQUEUE TABLE BLOCKS                     */
*/*       DSNQNSVA - SVA OF NEXT TABLE BLOCK                         */
*/*       DSNQFREE - UNUSED BYTES IN THIS BLOCK                      */
*/*       DSNQENTS - DSN ENTRIES                                     */
*/*       DSNQNTRY - A SINGLE DSN ENTRY                              */
*/*         DSNQSTEP - NUMBER OF STEP IN WHICH LAST REFERENCE TO     */
*/*                    THIS DSN IS MADE                              */
*/*         DSNQDSNL - DSN LENGTH                                    */
*/*         DSNQDSN  - DSN                                           */
*/*     NQTABSVA - SVA OF FIRST DSENQ TABLE BLOCK                    */
*/*                                                                  */
*/* EXIT -                                                           */
*/*                                                                  */
*/*   CONDITION - CORE FOR DEQ PARAMETER LIST SUCCESSFULLY OBTAINED  */
*/*     OUTPUT -                                                     */
*/*       DSNQTABL - READ INTO CORE, BLOCKS CHAINED TOGETHER         */
*/*         DSNQNEXT - IN-CORE POINTER TO NEXT BLOCK                 */
*/*       DEQLSTSZ - AMOUNT OF CORE OBTAINED FOR DEQ PARAMETER LIST  */
*/*       FRSTEPAP - POINTER TO FIRST EPA.                           */
*/*       FRSTBLKP - POINTER TO FIRST DSENQ TABLE BLOCK              */
*/*     RETURN CODE -                                                */
*/*       RETCODE = ZERO                                             */
*/*                                                                  */
*/*   CONDITION - CORE NOT AVAILABLE FOR DEQ PARAMETER LIST          */
*/*     OUTPUT - NONE                                                */
*/*     RETURN CODE -                                                */
*/*       RETCODE - GETMAIN RETURN CODE                              */
*/*       RSNCODE - 2                                                */
*/*                                                                  */
*/*   CONDITION - NO NAMES TO DEQ                                    */
*/*     OUTPUT -                                                     */
*/*       DEQLSTSZ - ZERO                                            */
*/*     RETURN CODE -                                                */
*/*       RETCODE - SAME AS ON ENTRY                                 */
*/*                                                                  */
*/********************************************************************/
*SWACTLS = SWACTLS && SWACTLS;         /* CLEAR SWA CNTRL SWITCHES.  */
         SLR   @07,@07                                          02S0025
         ICM   @07,3,SWACTLS                                    02S0025
         LR    @15,@07                                          02S0025
         XR    @15,@07                                          02S0025
         STH   @15,SWACTLS                                      02S0025
*SWREAD = ON;                          /* REQUEST READ.              */
*SWNEW = ON;                           /* HAVE AN EPA CREATED.       */
         OI    SWREAD,B'00101000'                               02S0027
*NUMBLKS = ONE;                        /* READ ONE BLK AT A TIME.    */
         MVC   NUMBLKS(4),@CF00049                              02S0028
*SVALISTP = ADDR(NQTABSVA);            /* READ 1ST DSENQ TBL BLK.    */
         L     @07,@PC00001+16                                  02S0029
         ST    @07,SVALISTP                                     02S0029
*SVABLSTP = ADDR(FRSTBLKP);            /* SAVE PTR TO FIRST BLK.     */
         LA    @07,FRSTBLKP                                     02S0030
         ST    @07,SVABLSTP                                     02S0030
*FIRSTSW = ON;                         /* SET FIRST-TIME SWITCH.     */
         OI    FIRSTSW,B'00010000'                              02S0031
*DEQLSTSZ = ZERO;                      /* INIT AMOUNT OF CORE TO GET
*                                         FOR DEQ P-LIST TO NONE.    */
         SLR   @07,@07                                          02S0032
         LR    DEQLSTSZ,@07                                     02S0032
*DO WHILE SVALISTP -> NEXTSVA ^= ZERO; /* READ ENTIRE DSENQ TABLE.   */
         B     @DE00033                                         02S0033
@DL00033 DS    0H                                               02S0034
*  CALL IEFAB4F7                       /* READ 1 DSENQ TBL BLK.      */
*       (SWACTLS,LEPACHNP,LEPACHNP,SVALISTP,SVABLSTP,DUMMY,NUMBLKS);
         LA    @07,SWACTLS                                      02S0034
         ST    @07,@AL00001                                     02S0034
         LA    @07,LEPACHNP                                     02S0034
         ST    @07,@AL00001+4                                   02S0034
         LA    @07,LEPACHNP                                     02S0034
         ST    @07,@AL00001+8                                   02S0034
         LA    @07,SVALISTP                                     02S0034
         ST    @07,@AL00001+12                                  02S0034
         LA    @07,SVABLSTP                                     02S0034
         ST    @07,@AL00001+16                                  02S0034
         LA    @07,@CF00110                                     02S0034
         ST    @07,@AL00001+20                                  02S0034
         LA    @07,NUMBLKS                                      02S0034
         ST    @07,@AL00001+24                                  02S0034
         L     @15,@CV00130                                     02S0034
         LA    @01,@AL00001                                     02S0034
         BALR  @14,@15                                          02S0034
*  IF FIRSTSW = ON THEN                /* FIRST BLK JUST READ?       */
         TM    FIRSTSW,B'00010000'                              02S0035
         BNO   @RF00035                                         02S0035
*    DO;                                                        02S0036
*      FIRSTSW = OFF;                  /* SET FIRST-TIME SW OFF.     */
         NI    FIRSTSW,B'11101111'                              02S0037
*      SWCHN = ON;                     /* CHAIN REMAINING EPA'S.     */
         OI    SWCHN,B'10000000'                                02S0038
*      FRSTEPAP = LEPACHNP;            /* SAVE PTR TO FIRST EPA.     */
         MVC   FRSTEPAP(4),LEPACHNP                             02S0039
*      DSNQPTR = FRSTBLKP;             /* SET DSENQ TBL BLK BASE.    */
         MVC   DSNQPTR(4),FRSTBLKP                              02S0040
*    END;                                                       02S0041
*  ELSE                                                         02S0042
*    DSNQPTR = DSNQNEXT;               /* GET PTR TO BLK JUST READ
*                                         FROM PREVIOUS BLK'S FWD
*                                         PTR, WHERE SWA MGR PUT IT. */
         B     @RC00035                                         02S0042
@RF00035 L     @07,DSNQPTR                                      02S0042
         L     @07,DSNQNEXT(,@07)                               02S0042
         ST    @07,DSNQPTR                                      02S0042
*  DSNQENTP = ADDR(DSNQENTS);          /* POINT TO FIRST DSN ENTRY.  */
@RC00035 L     @07,DSNQPTR                                      02S0043
         LA    DSNQENTP,DSNQENTS(,@07)                          02S0043
*  BYTECTR = LENGTH(DSNQENTS) - DSNQFREE; /* GET ENTRIES' TOTAL LNTH.*/
         LA    BYTECTR,162                                      02S0044
         SH    BYTECTR,DSNQFREE(,@07)                           02S0044
*  DO WHILE BYTECTR > ZERO;            /* PROCESS ONE BLK'S ENTRIES. */
         B     @DE00045                                         02S0045
@DL00045 DS    0H                                               02S0046
*    IF DSNQSTEP = STEPNUM THEN        /* DEQ THIS ENTRY'S DSN?      */
         L     @07,@PC00001+8                                   02S0046
         CLC   DSNQSTEP(1,DSNQENTP),STEPNUM(@07)                02S0046
         BNE   @RF00046                                         02S0046
*      DEQLSTSZ = DEQLSTSZ +           /* INCREASE CORE NEEDED.      */
*        LENGTH(DEQENTRY);             /* ADD LNTH OF A P-LIST ENTRY.*/
         AH    DEQLSTSZ,@CH00180                                02S0047
*    BYTECTR = BYTECTR - (LENGTH(DSNQSTEP) +      /*LENGTH OF  DSNQSTEP
* FIELD  */               LENGTH(DSNQFLG1) +      /*LENGTH OF  DSNQFLG1
* FIELD  */               LENGTH(DSNQDSNL) +      /*LENGTH OF  DSNQDSNL
* FIELD  */               DSNQDSNL);/*                          02S0048
*                                         DECREASE AMNT OF BLK TO GO.*/
@RF00046 LA    @07,3                                            02S0048
         SLR   @15,@15                                          02S0048
         IC    @15,DSNQDSNL(,DSNQENTP)                          02S0048
         ALR   @07,@15                                          02S0048
         SLR   BYTECTR,@07                                      02S0048
*    DSNQENTP = DSNQENTP + (LENGTH(DSNQSTEP) +      /*LENGTH OF  DSNQST
*P  FIELD  */               LENGTH(DSNQFLG1) +      /*LENGTH OF  DSNQFL
*1  FIELD  */               LENGTH(DSNQDSNL) +      /*LENGTH OF  DSNQDS
*L  FIELD  */               DSNQDSNL);/*                        02S0049
*                                         POINT TO NEXT DSN ENTRY.   */
         ALR   DSNQENTP,@07                                     02S0049
*  END;                                                         02S0050
@DE00045 LTR   BYTECTR,BYTECTR                                  02S0050
         BP    @DL00045                                         02S0050
*  SVALISTP = ADDR(DSNQNSVA);          /* POINT TO SVA OF NEXT BLK.  */
         L     @07,DSNQPTR                                      02S0051
         LA    @15,DSNQNSVA(,@07)                               02S0051
         ST    @15,SVALISTP                                     02S0051
*  SVABLSTP = ADDR(DSNQNEXT);          /* RETURN AREA FOR NEXT BLK'S
*                                         IN-CORE PTR.               */
         LA    @07,DSNQNEXT(,@07)                               02S0052
         ST    @07,SVABLSTP                                     02S0052
*END;                                                           02S0053
@DE00033 L     @07,SVALISTP                                     02S0053
         ICM   @15,7,NEXTSVA(@07)                               02S0053
         BNZ   @DL00033                                         02S0053
*DSNQNEXT = ZERO;                      /* CLEAR FWD PTR IN LAST BLK. */
         SLR   @07,@07                                          02S0054
         L     @01,DSNQPTR                                      02S0054
         ST    @07,DSNQNEXT(,@01)                               02S0054
*IF DEQLSTSZ > ZERO THEN               /* ANY DSNS TO DEQ?           */
         CR    DEQLSTSZ,@07                                     02S0055
         BNH   @RF00055                                         02S0055
*  DO;                                                          02S0056
*    DEQLSTSZ = DEQLSTSZ + FOUR;       /* ADD SIZE OF TCB ADDR.      */
         AH    DEQLSTSZ,@CH00104                                02S0057
*     /* ?GETSTORG (SPID,DEQLSTSZ,DEQLISTP);*/                  02S0058
*       /* DEFINITIONS OF GETMAIN PARMS */                      02S0058
*       DCL                                                     02S0058
*         GTSTR0   FIXED(31) REG(0),/*GTMN PARM REG*/           02S0058
*         GTSTR1   FIXED(31) REG(1),/*GTMN PARM REG*/           02S0058
*         GTSTR2   PTR(31)   REG(2),/*GTMN PARM REG*/           02S0058
*         GTSTR15  FIXED(31) REG(15),/*GTMN RET COD*/           02S0058
*         GTSTRTCD FIXED(31); /* GETMAIN RTN CODE  */           02S0058
*       DCL                                                     02S0059
*         GTSTR3   FIXED(31) REG(3),/* CLEARING REG*/           02S0059
*         GTSTR4   FIXED(31) REG(4),/* CLEARING REG*/           02S0059
*         GTSTR5   FIXED(31) REG(5),/* CLEARING REG*/           02S0059
*         GTSTR6   FIXED(31) REG(6),/* CLEARING REG*/           02S0059
*         GTSTR7   FIXED(31) REG(7),/* CLEARING REG*/           02S0059
*         GTSTR8   FIXED(31) REG(8),/* CLEARING REG*/           02S0059
*         GTSTZERO FIXED(31) INIT(0),                           02S0059
*         GTST253  FIXED(31) CONSTANT(253);                     02S0059
*       RFY (GTSTR0,GTSTR1,GTSTR2) RSTD; /*SAVE RGS*/           02S0060
*       GTSTR0 = DEQLSTSZ; /* SET AMOUNT*/                      02S0061
         LR    GTSTR0,DEQLSTSZ                                  02S0061
*       GTSTR2 = SPID; /* SET SUBPOOL*/                         02S0062
         LA    GTSTR2,230                                       02S0062
*       GENERATE CODE;                                          02S0063
         GETMAIN RC,LV=(0),SP=(2)  DO GETMAIN
*       GTSTRTCD = GTSTR15; /* SAVE GETMAIN RET COD*/           02S0064
         ST    GTSTR15,GTSTRTCD                                 02S0064
*       DEQLISTP = GTSTR1; /* ADDR OF GOTN STORG*/              02S0065
         ST    GTSTR1,DEQLISTP                                  02S0065
*       RFY (GTSTR0,GTSTR1,GTSTR2) UNRSTD; /*RLSE */            02S0066
*       IF GTSTRTCD = 0 THEN /*GETMAIN SUCCESSFUL? */           02S0067
         L     @15,GTSTRTCD                                     02S0067
         LTR   @15,@15                                          02S0067
         BNZ   @RF00067                                         02S0067
*         DO;               /* YES, CLEAR STORAGE.*/            02S0068
*           RFY (GTSTR2,GTSTR4,GTSTR5,GTSTR6,                   02S0069
*                              GTSTR7,GTSTR8) RSTD;             02S0069
*           GTSTR4 = DEQLISTP; /*STORG PTR*/                    02S0070
         L     @09,DEQLISTP                                     02S0070
         LR    GTSTR4,@09                                       02S0070
*           GTSTR5 = DEQLSTSZ; /*STORG AMNT*/                   02S0071
         LR    GTSTR5,DEQLSTSZ                                  02S0071
*           GTSTR7 = '00000000'X; /*PAD CHAR & LNTH*/           02S0072
         SLR   GTSTR7,GTSTR7                                    02S0072
*           IF SPID = GTST253 THEN                              02S0073
         B     @RF00073                                         02S0073
*          GEN                                                  02S0074
*       (MODESET KEYADDR=GTSTZERO,SAVEKEY=(2),WORKREG=8);       02S0074
         MODESET KEYADDR=GTSTZERO,SAVEKEY=(2),WORKREG=8
*           GEN REFS(GTSTR4,GTSTR6);                            02S0075
@RF00073 DS    0H                                               02S0075
              MVCL  GTSTR4,GTSTR6 CLEAR GOTTEN STORG
*           IF SPID = GTST253 THEN                              02S0076
         B     @RF00076                                         02S0076
*             GEN (MODESET KEYADDR=(2));                        02S0077
         MODESET KEYADDR=(2)
*           RFY (GTSTR2,GTSTR4,GTSTR5,GTSTR6,                   02S0078
*                              GTSTR7,GTSTR8) UNRSTD;           02S0078
@RF00076 DS    0H                                               02S0079
*         END;       /* STORAGE CLEARING COMPLETED */           02S0079
*       ELSE                                                    02S0080
*       DEQLISTP= 0;   /* CLEAR RETURN ADDR. */                 02S0080
         B     @RC00067                                         02S0080
@RF00067 SLR   @15,@15                                          02S0080
         ST    @15,DEQLISTP                                     02S0080
*       GTSTR15 = GTSTRTCD;    /* GTMN RETURN CODE */           02S0081
@RC00067 L     GTSTR15,GTSTRTCD                                 02S0081
*                                      /* RESTORE LIST PRINT STATUS  */
*/* GET CORE FOR DEQ P-LIST.  */                                02S0082
*    RETCODE = REG15;                  /* SAVE GETMAIN RET CODE.     */
         LR    RETCODE,REG15                                    02S0082
*    IF RETCODE ^= ZERO THEN           /* GETMAIN UNSUCCESSFUL?      */
         LTR   RETCODE,RETCODE                                  02S0083
         BZ    @RF00083                                         02S0083
*      RSNCODE = DSRELRSC;             /* SAY DS RELEASE FAILED.     */
         L     @07,@PC00001+20                                  02S0084
         MVC   RSNCODE(2,@07),@CH00108                          02S0084
*  END;                                                         02S0085
*ELSE;                                 /* NO NAMES TO DEQ.           */
@RF00055 DS    0H                                               02S0087
*    IF RETCODE = ZERO &               /* GETMAIN SUCCESSFUL?        */
*       DEQLSTSZ > ZERO THEN           /* ANYTHING TO DEQ?           */
@RC00055 SLR   @07,@07                                          01S0087
         CR    RETCODE,@07                                      01S0087
         BNE   @RF00087                                         01S0087
         CR    DEQLSTSZ,@07                                     01S0087
         BNH   @RF00087                                         01S0087
*      DO;                                                      01S0088
*/********************************************************************/
*/*                                                                  */
*/* SEGMENT NAME - DEQDSNS                                           */
*/*                                                                  */
*/* DESCRIPTIVE NAME - DEQ DATA SET NAMES                            */
*/*                                                                  */
*/* FUNCTION -                                                       */
*/*   THIS ROUTINE USES THE IN-CORE DSENQ TABLE TO BUILD A DEQ       */
*/*   PARAMETER LIST AND DEQ THE DATA SET NAMES TO BE RELEASED IN    */
*/*   THIS STEP.  IT ALSO FREES THE CORE OBTAINED FOR THE DEQ        */
*/*   PARAMETER LIST AND HAS THE DSENQ TABLE BLOCKS WRITTEN BACK TO  */
*/*   SWA.  ENTRIES IN THE DSENQ TABLE WHICH HAD THEIR DSNS DEQ'D    */
*/*   ARE COMPRESSED OUT OF THE TABLE.                               */
*/*                                                                  */
*/*   OPERATION -                                                    */
*/*                                                                  */
*/*     THE INPUT TCB ADDRESS IS PUT INTO THE DEQ PARAMETER LIST.  A */
*/*     LOOP THRU THE DSENQ TABLE ENTRIES IS THEN MADE.  WHENEVER AN */
*/*     ENTRY HAVING THE SAME STEP NUMBER AS THE INPUT STEP NUMBER   */
*/*     IS FOUND, AN ENTRY FOR ITS DSN IS MADE IN THE DEQ PARAMETER  */
*/*     LIST.  SINCE THE END-OF-LIST INDICATOR IS ON IN THE SKELETON */
*/*     ENTRY USED TO INITIALIZE EACH ENTRY, IT IS TURNED OFF IN     */
*/*     EACH ENTRY MADE IN THE LOOP, THEN TURNED BACK ON IN THE LAST */
*/*     ENTRY, OUTSIDE THE LOOP.                                     */
*/*                                                                  */
*/*     THE DEQ IS THEN ISSUED FOR THE ENTIRE LIST.  THE POINTER TO  */
*/*     THE PARAMETER LIST MUST POINT TO THE FIRST ENTRY, WHICH MUST */
*/*     BE IMMEDIATELY PRECEDED BY THE TCB ADDRESS.  AFTER ISSUING   */
*/*     THE DEQ, THE PARAMETER LIST IS FREED.                        */
*/*                                                                  */
*/*     ANOTHER LOOP THRU THE DSENQ TABLE IS MADE, THIS TIME TO      */
*/*     COMPRESS THE ENTRIES WHICH HAVE BEEN DEQUEUED.  WHENEVER AN  */
*/*     ENTRY WITH THE CURRENT STEP NUMBER IS FOUND, THE NUMBER OF   */
*/*     UNUSED BYTES IN THAT BLOCK IS DECREASED BY THE NUMBER OF     */
*/*     BYTES IN THAT ENTRY.  IF THAT ENTRY IS THE LAST ENTRY IN ITS */
*/*     BLOCK, THIS ACTION EFFECTIVELY COMPRESSES THE ENTRY OUT OF   */
*/*     THE BLOCK.  IF THE ENTRY IS NOT THE LAST ONE IN ITS BLOCK,   */
*/*     THE REMAINING ENTRY/IES IS/ARE MOVED UP TO OVERLAY IT.       */
*/*                                                                  */
*/*     AFTER COMPRESSING THE TABLE'S BLOCK/S, THE SWA MANAGER       */
*/*     INTERFACE ROUTINE IS INVOKED TO WRITE THE BLOCK/S BACK TO    */
*/*     SWA AND FREE THE EPA/S.                                      */
*/*                                                                  */
*/* ENTRY - IN-LINE SEGMENT                                          */
*/*                                                                  */
*/*   PURPOSE - SEE FUNCTION                                         */
*/*   INPUT -                                                        */
*/*     DSNQTABL - DATA SET ENQUEUE TABLE                            */
*/*       DSNQNEXT - IN-CORE POINTER TO NEXT TABLE BLOCK             */
*/*       DSNQFREE - NUMBER OF UNUSED BYTES IN THIS BLOCK            */
*/*       DSNQENTS - DSN ENTRIES                                     */
*/*       DSNQNTRY - A SINGLE DSN ENTRY                              */
*/*         DSNQSTEP - STEP NO. OF LAST REFERENCE TO DSN             */
*/*         DSNQDSNL - DSN LENGTH                                    */
*/*         DSNQDSN  - DSN                                           */
*/*     FRSTBLKP - IN-CORE POINTER TO FIRST DSENQ TABLE BLOCK        */
*/*     DEQTCBP  - POINTER TO INIT'S TCB                             */
*/*     DEQLSTSZ - SIZE OF DEQ P-LIST CORE                           */
*/*     DEQLISTP - POINTER TO DEQ P-LIST CORE                        */
*/*     FRSTEPAP - POINTER TO FIRST EPA                              */
*/*                                                                  */
*/* EXIT -                                                           */
*/*                                                                  */
*/*   CONDITION - DSNS DEQUEUED                                      */
*/*   OUTPUT -                                                       */
*/*     DSNQTABL  - DSENQ TABLE WRITTEN BACK TO SWA                  */
*/*       DSNQFREE - NO. OF UNUSED BYTES IN EACH BLOCK INCREASED BY  */
*/*         THE LENGTH/S OF COMPRESSED ENTRY/IES                     */
*/*       DSNQENTS - ENTRIES HAVING HAD THEIR DSNS DEQ'D HAVE BEEN   */
*/*         COMPRESSED OUT OF THE BLOCK                              */
*/*   RETURN CODE -                                                  */
*/*     RETCODE - SAME AS ON ENTRY                                   */
*/*     RSNCODE - SAME AS ON ENTRY                                   */
*/*                                                                  */
*/********************************************************************/
*DSNQPTR = FRSTBLKP;                   /* POINT TO 1ST DSENQ TBL BLK.*/
         MVC   DSNQPTR(4),FRSTBLKP                              02S0089
*DEQTCBA = DEQTCBP;                    /* PUT TCB ADDR IN DEQ P-LIST.*/
         L     @15,@PC00001+12                                  02S0090
         L     @01,DEQLISTP                                     02S0090
         MVC   DEQTCBA(4,@01),DEQTCBP(@15)                      02S0090
*DQLSTCTR = ZERO;                      /* INIT P-LIST ENTRY SUBSCRIPT*/
         ST    @07,DQLSTCTR                                     02S0091
*DO WHILE DSNQPTR ^= ZERO;             /* PROCESS ENTIRE DSENQ TABLE.*/
         B     @DE00092                                         02S0092
@DL00092 DS    0H                                               02S0093
*  BYTECTR = LENGTH(DSNQENTS) - DSNQFREE; /* LNTH OF ENTRIES IN BLK  */
         L     @07,DSNQPTR                                      02S0093
         LA    BYTECTR,162                                      02S0093
         SH    BYTECTR,DSNQFREE(,@07)                           02S0093
*  DSNQENTP = ADDR(DSNQENTS);          /* ADDR OF FIRST ENTRY        */
         LA    DSNQENTP,DSNQENTS(,@07)                          02S0094
*  DO WHILE BYTECTR > ZERO;            /* PROCESS BLK'S ENTRIES.     */
         B     @DE00095                                         02S0095
@DL00095 DS    0H                                               02S0096
*    IF DSNQSTEP = STEPNUM THEN        /* DEQ THIS ENTRY'S DSN?      */
         L     @07,@PC00001+8                                   02S0096
         CLC   DSNQSTEP(1,DSNQENTP),STEPNUM(@07)                02S0096
         BNE   @RF00096                                         02S0096
*      DO;                                                      02S0097
*        DQLSTCTR = DQLSTCTR + ONE;    /* CURRENT P-LIST SUBSCRIPT   */
         LA    @07,1                                            02S0098
         AL    @07,DQLSTCTR                                     02S0098
         ST    @07,DQLSTCTR                                     02S0098
*        DEQENTRY(DQLSTCTR) =          /* GET P-LIST ENTRY SKELETON. */
*          DQLIST(ONE:DQLSTLEN);                                02S0099
         L     @15,DEQLISTP                                     02S0099
         MH    @07,@CH00180                                     02S0099
         ST    @07,@TF00001                                     02S0099
         ALR   @07,@15                                          02S0099
         AL    @07,@CF00189                                     02S0099
         MVI   DEQENTRY-3(@07),C' '                             02S0099
         MVC   DEQENTRY-2(10,@07),DEQENTRY-3(@07)               02S0099
         L     @14,DQLSTLEN                                     02S0099
         BCTR  @14,0                                            02S0099
         EX    @14,@SM00190                                     02S0099
*        DEQEND(DQLSTCTR) = OFF;       /* SET END-OF-LIST SWITCH OFF.*/
         LR    @07,@15                                          02S0100
         AL    @07,@TF00001                                     02S0100
         AL    @07,@CF00189                                     02S0100
         NI    DEQEND-4(@07),B'01111111'                        02S0100
*        DEQMINLN(DQLSTCTR) = DSNQDSNL; /* GET DSN LENGTH.           */
         SLR   @07,@07                                          02S0101
         IC    @07,DSNQDSNL(,DSNQENTP)                          02S0101
         L     @14,@TF00001                                     02S0101
         AL    @14,@CF00193                                     02S0101
         STC   @07,DEQMINLN-5(@14,@15)                          02S0101
*        DEQMINA(DQLSTCTR) = ADDR(DSNQDSN); /* GET DSN PTR.          */
         LA    @07,DSNQDSN(,DSNQENTP)                           02S0102
         L     @14,@TF00001                                     02S0102
         ST    @07,DEQMINA-12(@14,@15)                          02S0102
*      END;                                                     02S0103
*    BYTECTR = BYTECTR - (LENGTH(DSNQSTEP) +      /*LENGTH OF  DSNQSTEP
* FIELD  */               LENGTH(DSNQFLG1) +      /*LENGTH OF  DSNQFLG1
* FIELD  */               LENGTH(DSNQDSNL) +      /*LENGTH OF  DSNQDSNL
* FIELD  */               DSNQDSNL);/*                          02S0104
*                                         DECREASE AMOUNT TO PROCESS.*/
@RF00096 LA    @07,3                                            02S0104
         SLR   @15,@15                                          02S0104
         IC    @15,DSNQDSNL(,DSNQENTP)                          02S0104
         ALR   @07,@15                                          02S0104
         SLR   BYTECTR,@07                                      02S0104
*    DSNQENTP = DSNQENTP + (LENGTH(DSNQSTEP) +      /*LENGTH OF  DSNQST
*P  FIELD  */               LENGTH(DSNQFLG1) +      /*LENGTH OF  DSNQFL
*1  FIELD  */               LENGTH(DSNQDSNL) +      /*LENGTH OF  DSNQDS
*L  FIELD  */               DSNQDSNL);/*                        02S0105
*                                         POINT TO NEXT DSN ENTRY.   */
         ALR   DSNQENTP,@07                                     02S0105
*  END;                                /* END LOOP THRU 1 BLOCK.     */
@DE00095 LTR   BYTECTR,BYTECTR                                  02S0106
         BP    @DL00095                                         02S0106
*  DSNQPTR = DSNQNEXT;                 /* POINT TO NEXT BLOCK.       */
         L     @07,DSNQPTR                                      02S0107
         L     @07,DSNQNEXT(,@07)                               02S0107
         ST    @07,DSNQPTR                                      02S0107
*END;                                  /* END LOOP THRU ENTIRE TABLE.*/
@DE00092 ICM   @07,15,DSNQPTR                                   02S0108
         BNZ   @DL00092                                         02S0108
*DEQEND(DQLSTCTR) = ON;                /* SET END-OF-LIST SW IN LAST
*                                         P-LIST ENTRY.              */
         L     @07,DEQLISTP                                     02S0109
         L     @15,DQLSTCTR                                     02S0109
         MH    @15,@CH00180                                     02S0109
         ALR   @15,@07                                          02S0109
         AL    @15,@CF00189                                     02S0109
         OI    DEQEND-4(@15),B'10000000'                        02S0109
*RFY (REG0,REG1) RSTD;                 /* PROTECT REGS               */
*REG1 = DEQLISTP + FOUR;               /* SET DEQ P-LIST PTR LIKE DEQ
*                                         WANTS IT(POINTS TO WORD
*                                         AFTER TCB ADDR)            */
         AH    @07,@CH00104                                     02S0111
         LR    REG1,@07                                         02S0111
*GEN (DEQ MF=(E,(1)));                 /* DEQ DSNS.                  */
         DEQ MF=(E,(1))
*REG0 = DEQLSTSZ;                      /* SIZE TO FREE               */
         LR    REG0,DEQLSTSZ                                    02S0113
*REG0 = REG0 | SUBPL230;               /* FREE FROM SUBPOOL 230.     */
         O     REG0,@CF00120                                    02S0114
*REG1 = DEQLISTP;                      /* ADDR OF CORE TO FREE.      */
         L     REG1,DEQLISTP                                    02S0115
*GEN (FREEMAIN R,LV=(0),A=(1));        /* FREE P-LIST CORE           */
         FREEMAIN R,LV=(0),A=(1)
*RFY (REG0,REG1) UNRSTD;               /* RELEASE REGS               */
*DSNQPTR = FRSTBLKP;                   /* PTR TO 1ST DSENQ TBL BLK   */
         MVC   DSNQPTR(4),FRSTBLKP                              02S0118
*DO WHILE DSNQPTR ^= ZERO;             /* COMPRESS TABLE BLOCKS      */
         B     @DE00119                                         02S0119
@DL00119 DS    0H                                               02S0120
*  BYTECTR = LENGTH(DSNQENTS) - DSNQFREE; /* LNTH OF ENTRIES IN BLK  */
         L     @10,DSNQPTR                                      02S0120
         LA    BYTECTR,162                                      02S0120
         SH    BYTECTR,DSNQFREE(,@10)                           02S0120
*  DSNQENTP = ADDR(DSNQENTS);          /* PTR TO 1ST ENTRY IN BLK    */
         LA    DSNQENTP,DSNQENTS(,@10)                          02S0121
*  DO WHILE BYTECTR > ZERO;            /* PROCESS ONE BLK'S ENTRIES. */
         B     @DE00122                                         02S0122
@DL00122 DS    0H                                               02S0123
*    BYTECTR = BYTECTR - (LENGTH(DSNQSTEP) +      /*LENGTH OF  DSNQSTEP
* FIELD  */               LENGTH(DSNQFLG1) +      /*LENGTH OF  DSNQFLG1
* FIELD  */               LENGTH(DSNQDSNL) +      /*LENGTH OF  DSNQDSNL
* FIELD  */               DSNQDSNL);/*                          02S0123
*                                         DECREMENT WORKING LENGTH.  */
         LA    @10,3                                            02S0123
         SLR   @07,@07                                          02S0123
         IC    @07,DSNQDSNL(,DSNQENTP)                          02S0123
         ALR   @10,@07                                          02S0123
         SLR   BYTECTR,@10                                      02S0123
*    IF DSNQSTEP = STEPNUM THEN        /* WAS THIS ENTRY'S DSN DEQ'D?*/
         L     @07,@PC00001+8                                   02S0124
         CLC   DSNQSTEP(1,DSNQENTP),STEPNUM(@07)                02S0124
         BNE   @RF00124                                         02S0124
*      DO;                                                      02S0125
*        DSNQFREE = DSNQFREE + (LENGTH(DSNQSTEP) +      /*LENGTH OF  DS
*QSTEP  FIELD  */               LENGTH(DSNQFLG1) +      /*LENGTH OF  DS
*QFLG1  FIELD  */               LENGTH(DSNQDSNL) +      /*LENGTH OF  DS
*QDSNL  FIELD  */               DSNQDSNL);/*                    02S0126
*                                           INCREASE BLK'S FREE SPACE*/
         L     @07,DSNQPTR                                      02S0126
         LH    @04,DSNQFREE(,@07)                               02S0126
         ALR   @04,@10                                          02S0126
         STH   @04,DSNQFREE(,@07)                               02S0126
*        TEMPTR = DSNQENTP;            /* PREVENT PLS 256-BYTE MOVE  */
         LR    TEMPTR,DSNQENTP                                  02S0127
*        IF BYTECTR > ZERO THEN        /* MORE ENTRIES IN BLOCK?     */
         LTR   BYTECTR,BYTECTR                                  02S0128
         BNP   @RF00128                                         02S0128
*          TEMPTR -> DMYTOENT(ONE:BYTECTR) = /* OVERLAY CUR ENTRY.  */
*          (DSNQENTP + (LENGTH(DSNQSTEP) +      /*LENGTH OF  DSNQSTEP
*IELD  */               LENGTH(DSNQFLG1) +      /*LENGTH OF  DSNQFLG1
*IELD  */               LENGTH(DSNQDSNL) +      /*LENGTH OF  DSNQDSNL
*IELD  */               DSNQDSNL)) ->/*                         02S0129
*                                         USE REMAINING ENTRIES.     */
*          DMYFRENT(ONE:BYTECTR);                               02S0129
         LR    @07,BYTECTR                                      02S0129
         BCTR  @07,0                                            02S0129
         ALR   @10,DSNQENTP                                     02S0129
         EX    @07,@SM00194                                     02S0129
*      END;                                                     02S0130
*    ELSE                              /* ENTRY NOT COMPRESSED       */
*      DSNQENTP = DSNQENTP + (LENGTH(DSNQSTEP) +      /*LENGTH OF  DSNQ
*TEP  FIELD  */               LENGTH(DSNQFLG1) +      /*LENGTH OF  DSNQ
*LG1  FIELD  */               LENGTH(DSNQDSNL) +      /*LENGTH OF  DSNQ
*SNL  FIELD  */               DSNQDSNL);/*                      02S0131
*                                         GET NEXT ENTRY(OR BLK END) */
         B     @RC00124                                         02S0131
@RF00124 LA    @10,3                                            02S0131
         SLR   @07,@07                                          02S0131
         IC    @07,DSNQDSNL(,DSNQENTP)                          02S0131
         ALR   @10,@07                                          02S0131
         ALR   DSNQENTP,@10                                     02S0131
*  END;                                /* END OF LOOP THRU BLK       */
@RC00124 DS    0H                                               02S0132
@DE00122 LTR   BYTECTR,BYTECTR                                  02S0132
         BP    @DL00122                                         02S0132
*  DSNQPTR = DSNQNEXT;                 /* GET PTR TO NEXT BLK.       */
         L     @10,DSNQPTR                                      02S0133
         L     @10,DSNQNEXT(,@10)                               02S0133
         ST    @10,DSNQPTR                                      02S0133
*END;                                  /* END OF LOOP THRU TABLE     */
@DE00119 ICM   @10,15,DSNQPTR                                   02S0134
         BNZ   @DL00119                                         02S0134
*SWACTLS = SWACTLS && SWACTLS;         /* CLEAR SWA CONTROL SWITCHES.*/
         SLR   @10,@10                                          02S0135
         ICM   @10,3,SWACTLS                                    02S0135
         LR    @07,@10                                          02S0135
         XR    @07,@10                                          02S0135
         STH   @07,SWACTLS                                      02S0135
*SWOLD = ON;                           /* EPAS ALREADY EXIST.        */
*SWFREE = ON;                          /* FREE THE EPAS.             */
*SWWRT = ON;                           /* WRITE RECORDS.             */
         OI    SWOLD,B'00010101'                                02S0138
*CALL IEFAB4F7                         /* WRITE DSENQ TBL BLOCKS.    */
*     (SWACTLS,FRSTEPAP,DUMMY,DUMMY,DUMMY,DUMMY,DUMMY);         02S0139
         MVC   @AL00001+8(20),@AL00139                          02S0139
         LA    @10,SWACTLS                                      02S0139
         ST    @10,@AL00001                                     02S0139
         LA    @10,FRSTEPAP                                     02S0139
         ST    @10,@AL00001+4                                   02S0139
         L     @15,@CV00130                                     02S0139
         LA    @01,@AL00001                                     02S0139
         BALR  @14,@15                                          02S0139
*      END;                                                     01S0140
*  END;                                                         01S0141
@RF00087 DS    0H                                               01S0142
*IF NODSRLST = OFF THEN                /* DS RELEASE LIST EXIST?     */
@RF00023 L     @10,@PC00001                                     01S0142
         TM    NODSRLST(@10),B'10000000'                        01S0142
         BNZ   @RF00142                                         01S0142
*  DO;                                                          01S0143
*/********************************************************************/
*/*                                                                  */
*/* SEGMENT NAME - A4A6INIT                                          */
*/*                                                                  */
*/* DESCRIPTIVE NAME - INITIALIZATION FOR IEFAB4A6                   */
*/*                                                                  */
*/* FUNCTION                                                         */
*/*                                                                  */
*/*   THIS ROUTINE GETS CORE FOR THE DEQ PARAMETER                   */
*/*   LIST AND, IF THE GETMAIN IS SUCCESSFUL, READS THE FIRST DSENQ  */
*/*   TABLE RECORD.                                                  */
*/*                                                                  */
*/*   OPERATION -                                                    */
*/*                                                                  */
*/*     THE NUMBER OF ENTRIES IN THE CALLER'S DATA SET RELEASE LIST  */
*/*     IS USED TO CALCULATE THE AMOUNT OF CORE TO GET FOR THE DEQ   */
*/*     PARM LIST.  IF THE CORE IS SUCCESSFULLY OBTAINED, THE SWA    */
*/*     MANAGER INTERFACE ROUTINE, IEFAB4F7, IS USED TO READ THE     */
*/*     FIRST RECORD OF THE DSENQ TABLE.  THE INPUT TO THE SWA MAN-  */
*/*     AGER IS THEN SET SO THAT THE REMAINING RECORDS WILL HAVE     */
*/*     THEIR RESPECTIVE EPA'S CHAINED TOGETHER.                     */
*/*                                                                  */
*/*     IF CORE CANNOT BE OBTAINED FOR THE DEQ PARM LIST, THE        */
*/*     GETMAIN RETURN CODE IS PASSED TO THE CALLER, AS WELL AS A    */
*/*     REASON CODE INDICATING FAILURE IN DATA SET RELEASE PROCESSING*/
*/*                                                                  */
*/* ENTRY - IN-LINE SEGMENT                                          */
*/*                                                                  */
*/*   PURPOSE - GET CORE FOR DEQ PARM LIST; SET UP SWA MANAGER       */
*/*     INTERFACE; READ FIRST RECORD OF THE DSENQ TABLE; INITIALIZE  */
*/*     VARIABLES FOR MAIN PROCESSING LOOP.                          */
*/*   INPUT -                                                        */
*/*     DSRLST - INPUT DATA SET RELEASE LIST                         */
*/*       DSRLNO - NUMBER OF ENTRIES IN LIST                         */
*/*     NQTABSVA - SVA OF FIRST DSENQ TABLE RECORD                   */
*/*                                                                  */
*/* EXIT -                                                           */
*/*                                                                  */
*/*   CONDITION - GETMAIN SUCCESSFUL                                 */
*/*     OUTPUT -                                                     */
*/*       FIRST DSENQ TABLE RECORD READ INTO CORE                    */
*/*       DSNQPTR - POINTS TO FIRST DSENQ TBL RECORD                 */
*/*       FRSTEPAP - POINTS TO FIRST EPA                             */
*/*       NUMRCDS - CONTAINS NUMBER OF RECORDS READ.                 */
*/*       DQLSTCTR - CONTAINS ZERO, INDICATING NO ENTRIES HAVE BEEN  */
*/*         MADE IN THE DEQ PARM LIST.                               */
*/*     RETURN CODE -                                                */
*/*       RETCODE = ZERO                                             */
*/*                                                                  */
*/*   CONDITION - GETMAIN UNSUCCESSFUL                               */
*/*     OUTPUT -                                                     */
*/*       RSNCODE - 2 (DATA SET RELEASE FAILURE)                     */
*/*     RETURN CODE -                                                */
*/*       RETCODE - RETURN CODE FROM GETMAIN                         */
*/*                                                                  */
*/********************************************************************/
*DSRLPTR = DSRLP;                      /* GET D.S. RELEASE LIST BASE */
         L     @15,@PC00001+4                                   02S0144
         L     DSRLPTR,DSRLP(,@15)                              02S0144
*DEQLSTSZ = (LENGTH(DEQENTRY) * DSRLNO) + FOUR; /* SIZE OF DEQ P-LIST*/
         L     DEQLSTSZ,DSRLNO(,DSRLPTR)                        02S0145
         MH    DEQLSTSZ,@CH00180                                02S0145
         AH    DEQLSTSZ,@CH00104                                02S0145
* /* ?GETSTORG (SPID,DEQLSTSZ,DEQLISTP);*/                      02S0146
*   RFY (GTSTR0,GTSTR1,GTSTR2) RSTD; /*SAVE RGS*/               02S0146
*   GTSTR0 = DEQLSTSZ; /* SET AMOUNT*/                          02S0147
         LR    GTSTR0,DEQLSTSZ                                  02S0147
*   GTSTR2 = SPID; /* SET SUBPOOL*/                             02S0148
         LA    GTSTR2,230                                       02S0148
*   GENERATE CODE;                                              02S0149
     GETMAIN RC,LV=(0),SP=(2)  DO GETMAIN
*   GTSTRTCD = GTSTR15; /* SAVE GETMAIN RET COD*/               02S0150
         ST    GTSTR15,GTSTRTCD                                 02S0150
*   DEQLISTP = GTSTR1; /* ADDR OF GOTN STORG*/                  02S0151
         ST    GTSTR1,DEQLISTP                                  02S0151
*   RFY (GTSTR0,GTSTR1,GTSTR2) UNRSTD; /*RLSE */                02S0152
*   IF GTSTRTCD = 0 THEN /*GETMAIN SUCCESSFUL? */               02S0153
         L     @08,GTSTRTCD                                     02S0153
         LTR   @08,@08                                          02S0153
         BNZ   @RF00153                                         02S0153
*     DO;               /* YES, CLEAR STORAGE.*/                02S0154
*       RFY (GTSTR2,GTSTR4,GTSTR5,GTSTR6,                       02S0155
*                          GTSTR7,GTSTR8) RSTD;                 02S0155
*       GTSTR4 = DEQLISTP; /*STORG PTR*/                        02S0156
         L     @03,DEQLISTP                                     02S0156
         LR    GTSTR4,@03                                       02S0156
*       GTSTR5 = DEQLSTSZ; /*STORG AMNT*/                       02S0157
         LR    GTSTR5,DEQLSTSZ                                  02S0157
*       GTSTR7 = '00000000'X; /*PAD CHAR & LNTH*/               02S0158
         SLR   GTSTR7,GTSTR7                                    02S0158
*       IF SPID = GTST253 THEN                                  02S0159
         B     @RF00159                                         02S0159
*      GEN                                                      02S0160
*   (MODESET KEYADDR=GTSTZERO,SAVEKEY=(2),WORKREG=8);           02S0160
         MODESET KEYADDR=GTSTZERO,SAVEKEY=(2),WORKREG=8
*       GEN REFS(GTSTR4,GTSTR6);                                02S0161
@RF00159 DS    0H                                               02S0161
          MVCL  GTSTR4,GTSTR6 CLEAR GOTTEN STORG
*       IF SPID = GTST253 THEN                                  02S0162
         B     @RF00162                                         02S0162
*         GEN (MODESET KEYADDR=(2));                            02S0163
         MODESET KEYADDR=(2)
*       RFY (GTSTR2,GTSTR4,GTSTR5,GTSTR6,                       02S0164
*                          GTSTR7,GTSTR8) UNRSTD;               02S0164
@RF00162 DS    0H                                               02S0165
*     END;       /* STORAGE CLEARING COMPLETED */               02S0165
*   ELSE                                                        02S0166
*   DEQLISTP= 0;   /* CLEAR RETURN ADDR. */                     02S0166
         B     @RC00153                                         02S0166
@RF00153 SLR   @08,@08                                          02S0166
         ST    @08,DEQLISTP                                     02S0166
*   GTSTR15 = GTSTRTCD;    /* GTMN RETURN CODE */               02S0167
@RC00153 L     GTSTR15,GTSTRTCD                                 02S0167
*                                      /* RESTORE LIST PRINT STATUS  */
*   /* GET CORE FOR DEQ P-LIST.   */                            02S0168
*RETCODE = REG15;                      /* SAVE GETMAIN RET CODE      */
         LR    RETCODE,REG15                                    02S0168
*IF RETCODE =ZERO THEN                 /* GETMAIN SUCCESSFUL?        */
         LTR   RETCODE,RETCODE                                  02S0169
         BNZ   @RF00169                                         02S0169
*  DO;                                                          02S0170
*    SWACTLS = SWACTLS && SWACTLS;     /* INIT SWITCHES.             */
         SLR   @08,@08                                          02S0171
         ICM   @08,3,SWACTLS                                    02S0171
         LR    @07,@08                                          02S0171
         XR    @07,@08                                          02S0171
         STH   @07,SWACTLS                                      02S0171
*    SWREAD = ON;                      /* READ RECORD.               */
*    SWNEW = ON;                       /* CREATE EPA.                */
         OI    SWREAD,B'00101000'                               02S0173
*    NUMBLKS = ONE;                    /* READ ONE BLK.              */
         MVC   NUMBLKS(4),@CF00049                              02S0174
*    SVALISTP = ADDR(NQTABSVA);        /* POINT TO SVA OF 1ST RECORD */
         L     @08,@PC00001+16                                  02S0175
         ST    @08,SVALISTP                                     02S0175
*    SVABLSTP = ADDR(DSNQPTR);         /* RETURN AREA FOR IN-CORE PTR*/
         LA    @08,DSNQPTR                                      02S0176
         ST    @08,SVABLSTP                                     02S0176
*    CALL IEFAB4F7                     /* HAVE SWA MGR READ A RECORD.*/
*      (SWACTLS,LEPACHNP,DUMMY,SVALISTP,SVABLSTP,DUMMY,NUMBLKS);
         LA    @08,SWACTLS                                      02S0177
         ST    @08,@AL00001                                     02S0177
         LA    @08,LEPACHNP                                     02S0177
         ST    @08,@AL00001+4                                   02S0177
         LA    @08,@CF00110                                     02S0177
         ST    @08,@AL00001+8                                   02S0177
         LA    @08,SVALISTP                                     02S0177
         ST    @08,@AL00001+12                                  02S0177
         LA    @08,SVABLSTP                                     02S0177
         ST    @08,@AL00001+16                                  02S0177
         LA    @08,@CF00110                                     02S0177
         ST    @08,@AL00001+20                                  02S0177
         LA    @08,NUMBLKS                                      02S0177
         ST    @08,@AL00001+24                                  02S0177
         L     @15,@CV00130                                     02S0177
         LA    @01,@AL00001                                     02S0177
         BALR  @14,@15                                          02S0177
*DCL L1 FIXED(31);                           /********* SCAF *********/
*L1 = (DSRLNO * 8) +4;                       /********** SCAF ********/
         L     L1,DSRLNO(,DSRLPTR)                              02S0179
         SLA   L1,3                                             02S0179
         AH    L1,@CH00104                                      02S0179
*    FRSTEPAP = LEPACHNP;              /* SAVE PTR TO FIRST EPA.     */
         MVC   FRSTEPAP(4),LEPACHNP                             02S0180
*    SWCHN = ON;                       /* CHAIN REMAINING EPA'S.     */
         OI    SWCHN,B'10000000'                                02S0181
*    DQLSTCTR = ZERO;                  /* INIT NO OF NAMES BEING DEQD*/
         SLR   @08,@08                                          02S0182
         ST    @08,DQLSTCTR                                     02S0182
*  END;                                                         02S0183
*ELSE                                  /* CORE NOT AVAILABLE         */
*  RSNCODE = DSRELRSC;                 /* 'DATA SET RELEASE FAILED'
*                                         REASON CODE                */
         B     @RC00169                                         02S0184
@RF00169 L     @08,@PC00001+20                                  02S0184
         MVC   RSNCODE(2,@08),@CH00108                          02S0184
*    IF RETCODE = ZERO THEN            /* CORE GOTTEN SUCCESSFULLY?  */
@RC00169 LTR   RETCODE,RETCODE                                  01S0185
         BNZ   @RF00185                                         01S0185
*      DO;                                                      01S0186
*        ELGNMCTR = DSRLNO;            /* SET MAX NO. OF NAMES TO DEQ*/
         L     ELGNMCTR,DSRLNO(,DSRLPTR)                        01S0187
*        STOPSW = OFF;                 /* INIT SCAN LOOP CONTROL.    */
         NI    STOPSW,B'11011111'                               01S0188
*        DO WHILE(STOPSW = OFF);       /* SCAN TO END OF TABLE       */
         B     @DE00189                                         01S0189
@DL00189 DS    0H                                               01S0190
*          DSNQENTP = ADDR(DSNQENTS);  /* POINT TO RECORD'S ENTRIES. */
         L     @08,DSNQPTR                                      01S0190
         LA    DSNQENTP,DSNQENTS(,@08)                          01S0190
*          BYTECTR = LENGTH(DSNQENTS) - DSNQFREE; /* LNTH OF ENTRIES */
         LA    BYTECTR,162                                      01S0191
         SH    BYTECTR,DSNQFREE(,@08)                           01S0191
*          DO WHILE(ELGNMCTR > ZERO &  /* UNLESS INPUT LIST EXHAUSTED*/
*            BYTECTR > ZERO);          /* SEARCH ONE RECORD'S ENTRIES*/
         B     @DE00192                                         01S0192
@DL00192 DS    0H                                               01S0193
*/********************************************************************/
*/*                                                                  */
*/* SEGMENT NAME - DEQLBILD                                          */
*/*                                                                  */
*/* DESCRIPTIVE NAME - DEQ PARM LIST BUILD ROUTINE                   */
*/*                                                                  */
*/* FUNCTION -                                                       */
*/*                                                                  */
*/*   THIS ROUTINE DETERMINES WHETHER THE DSN IN THE CURRENT DSENQ   */
*/*   TABLE ENTRY MAY BE RELEASED.  IF SO, THE NO. OF ENTRIES IN THE */
*/*   DATA SET RELEASE LIST IS DECREMENTED FOR EACH OCCURRENCE OF THE*/
*/*   NAME.  AN ENTRY IS MADE IN THE DEQ PARM LIST FOR THE DSN,      */
*/*   AND THE DSN ENTRY IS DELETED FROM THE DSENQ TABLE.             */
*/*                                                                  */
*/*   OPERATION -                                                    */
*/*                                                                  */
*/*     THE DATA SET RELEASE LIST IS SEARCHED FOR A DSN MATCHING     */
*/*     THAT OF THE CURRENT DSENQ TABLE ENTRY.  WHEN A MATCHING ENTRY*/
*/*     IS FOUND, THE NUMBER OF DSN'S LEFT TO PROCESS IN THE LIST IS */
*/*     DECREMENTED BY ONE.  THE REST OF THE LIST IS THEN SEARCHED   */
*/*     AND THE NUMBER DECREMENTED FOR EACH SUCCESSIVE OCCURRENCE OF */
*/*     THE NAME.                                                    */
*/*                                                                  */
*/*     IF THE DSENQ TABLE ENTRY'S STEP NO. EQUALS THE INPUT STEP NO.*/
*/*     THE DSENQ TABLE ENTRY IS REMOVED FROM THE TABLE BY INCREAS-  */
*/*     ING THE NUMBER OF UNUSED BYTES IN THE RECORD AND BY OVER-    */
*/*     LAYING THE CURRENT ENTRY WITH THE REMAINING ENTRIES, IF      */
*/*     THERE ARE ANY.                                               */
*/*                                                                  */
*/*     AN ENTRY IS THEN BUILT IN THE DEQ PARM LIST, USING THE FIRST */
*/*     MATCHING DATA SET RELEASE LIST ENTRY TO OBTAIN A PTR TO THE  */
*/*     DSN AND THE LENGTH OF THE DSN.                               */
*/*                                                                  */
*/* ENTRY - IN-LINE SEGMENT                                          */
*/*                                                                  */
*/*   PURPOSE - SEE FUNCTION                                         */
*/*   INPUT -                                                        */
*/*     DSNQTABL - DSENQ TABLE                                       */
*/*       DSNQFREE - NO. OF FREE BYTES IN A RECORD                   */
*/*       DSNQNTRY - DSENQ TABLE ENTRY                               */
*/*         DSNQSTEP - STEP NO. OF A DATA SET'S LAST USE             */
*/*         DSNQDSNL - DATA SET NAME LENGTH                          */
*/*         DSNQDSN - DATA SET NAME                                  */
*/*     DSRLST - DATA SET RELEASE LIST                               */
*/*       DSRLNO - NUMBER OF ENTRIES IN LIST                         */
*/*       DSRLENT - LIST ENTRY                                       */
*/*         DSRDSNP - DATA SET NAME POINTER                          */
*/*         DSRDSNLN - DATA SET NAME LENGTH                          */
*/*     DQLSTCTR - SUBSCRIPT OF PREVIOUS DEQ PARM LIST ENTRY         */
*/*     BYTECTR - NUMBER OF BYTES LEFT TO PROCESS IN TABLE RECORD    */
*/*     STEPNUM - CURRENT STEP NUMBER                                */
*/*                                                                  */
*/* EXIT -                                                           */
*/*                                                                  */
*/*   CONDITION - NO DSN MATCH FOUND IN LIST                         */
*/*     OUTPUT -                                                     */
*/*       DEQNAMSW - OFF, INDICATING DSN NOT BEING DEQ'D             */
*/*     RETURN CODE - NONE                                           */
*/*                                                                  */
*/*   CONDITION - DSN MATCH FOUND, DSN NOT BEING DEQ'D               */
*/*     OUTPUT -                                                     */
*/*       DEQNAMSW - OFF, INDICATING DSN NOT BEING DEQ'D             */
*/*       ELGNMCTR - DECREMENTED BY ONE FOR EACH MATCHING LIST ENTRY */
*/*                                                                  */
*/*   CONDITION - DSN TO BE DEQ'D                                    */
*/*     OUTPUT -                                                     */
*/*       DEQNAMSW - ON, INDICATING NAME BEING DEQ'D                 */
*/*       ELGNMCTR - DECREMENTED BY ONE FOR EACH MATCHING LIST ENTRY */
*/*       DEQPLIST - DEQ PARM LIST                                   */
*/*         DEQENTRY - PARM LIST ENTRY                               */
*/*           DEQEND - OFF, INDICATING THIS ENTRY NOT END OF LIST    */
*/*           DEQMINLN - DSN LENGTH                                  */
*/*           DEQMINA - DSN PTR                                      */
*/*       DSNQTABL - DSENQ TABLE                                     */
*/*         DSNQFREE - NO. OF FREE BYTES IN RECORD                   */
*/*         DSNQENTS - DSN ENTRIES(ENTRY FOR DSN BEING DEQ'D REMOVED)*/
*/*       DQLSTCTR - INDEX TO ENTRY JUST BUILT IN DEQ PARM LIST      */
*/*     RETURN CODE - NONE                                           */
*/*                                                                  */
*/********************************************************************/
*DEQNAMSW = OFF;                       /* ASSUME NAME NOT TO BE DEQD.*/
*MATCHSW = OFF;                        /* ASSUME NO DSN MATCH.       */
         NI    DEQNAMSW,B'00111111'                             02S0194
*DO DSENTCTR = ONE TO DSRLNO           /* SEARCH INPUT LIST          */
*  WHILE MATCHSW = OFF;                /* UNTIL DSN MATCH FOUND      */
         LA    DSENTCTR,1                                       02S0195
         B     @DE00195                                         02S0195
@DL00195 TM    MATCHSW,B'10000000'                              02S0195
         BNZ   @DC00195                                         02S0195
*  IF DSNQDSNL = DSRDSNLN(DSENTCTR) &  /* DSN LENGTHS EQUAL?         */
*    DSNQDSN(ONE:DSNQDSNL) =           /* DSN'S EQUAL?               */
*    DSRDSNP(DSENTCTR) -> LISTDSN(ONE:DSNQDSNL) THEN            02S0196
         SLR   @08,@08                                          02S0196
         IC    @08,DSNQDSNL(,DSNQENTP)                          02S0196
         LR    @05,DSENTCTR                                     02S0196
         SLA   @05,3                                            02S0196
         CH    @08,DSRDSNLN-8(@05,DSRLPTR)                      02S0196
         BNE   @RF00196                                         02S0196
         AL    @05,@CF00197                                     02S0196
         L     @05,DSRDSNP-4(@05,DSRLPTR)                       02S0196
         BCTR  @08,0                                            02S0196
         EX    @08,@SC00198                                     02S0196
         BNE   @RF00196                                         02S0196
*    DO;                                                        02S0197
*      MATCHSW=ON;                     /* DSN MATCH FOUND.           */
         OI    MATCHSW,B'10000000'                              02S0198
*      ELGNMCTR = ELGNMCTR - ONE;      /* DECREMENT NO. OF NAMES
*                                         LEFT IN INPUT LIST         */
         BCTR  ELGNMCTR,0                                       02S0199
*      DO LISTCTR = DSENTCTR + ONE TO DSRLNO; /* SEARCH REST OF LIST
*                                         FOR DUPLICATE DSN'S.       */
         LA    LISTCTR,1                                        02S0200
         ALR   LISTCTR,DSENTCTR                                 02S0200
         B     @DE00200                                         02S0200
@DL00200 DS    0H                                               02S0201
*        IF DSNQDSNL = DSRDSNLN(LISTCTR) & /* DSN LENGTHS EQUAL?     */
*          (DSNQDSN(ONE:DSNQDSNL) =    /* DSN'S EQUAL?               */
*           DSRDSNP(LISTCTR) -> LISTDSN(ONE:DSNQDSNL)) THEN     02S0201
         SLR   @08,@08                                          02S0201
         IC    @08,DSNQDSNL(,DSNQENTP)                          02S0201
         LR    @15,LISTCTR                                      02S0201
         SLA   @15,3                                            02S0201
         CH    @08,DSRDSNLN-8(@15,DSRLPTR)                      02S0201
         BNE   @RF00201                                         02S0201
         AL    @15,@CF00197                                     02S0201
         L     @01,DSRDSNP-4(@15,DSRLPTR)                       02S0201
         BCTR  @08,0                                            02S0201
         EX    @08,@SC00200                                     02S0201
         BNE   @RF00201                                         02S0201
*          ELGNMCTR = ELGNMCTR - ONE; /* DECREMENT FOR EACH     02S0202
*                                         DUPLICATE IN LIST.         */
         BCTR  ELGNMCTR,0                                       02S0202
*      END;                                                     02S0203
@RF00201 AH    LISTCTR,@CH00049                                 02S0203
@DE00200 C     LISTCTR,DSRLNO(,DSRLPTR)                         02S0203
         BNH   @DL00200                                         02S0203
*      IF DSNQSTEP = STEPNUM THEN      /* DSN TO BE DEQ'D?           */
         L     @08,@PC00001+8                                   02S0204
         CLC   DSNQSTEP(1,DSNQENTP),STEPNUM(@08)                02S0204
         BNE   @RF00204                                         02S0204
*        DO;                                                    02S0205
*          DEQNAMSW = ON;              /* DSN BEING DEQ'D.           */
         OI    DEQNAMSW,B'01000000'                             02S0206
*          DSNQFREE = DSNQFREE + (LENGTH(DSNQSTEP) +      /*LENGTH OF
*SNQSTEP  FIELD  */               LENGTH(DSNQFLG1) +      /*LENGTH OF
*SNQFLG1  FIELD  */               LENGTH(DSNQDSNL) +      /*LENGTH OF
*SNQDSNL  FIELD  */               DSNQDSNL);/*                  02S0207
*                                             ADD CURRENT ENTRY LNTH
*                                         TO FREE SPACE IN RECORD.   */
         L     @08,DSNQPTR                                      02S0207
         LA    @15,3                                            02S0207
         SLR   @14,@14                                          02S0207
         IC    @14,DSNQDSNL(,DSNQENTP)                          02S0207
         ALR   @15,@14                                          02S0207
         LH    @14,DSNQFREE(,@08)                               02S0207
         ALR   @14,@15                                          02S0207
         STH   @14,DSNQFREE(,@08)                               02S0207
*          BYTECTR = BYTECTR - (LENGTH(DSNQSTEP) +      /*LENGTH OF  DS
*QSTEP  FIELD  */               LENGTH(DSNQFLG1) +      /*LENGTH OF  DS
*QFLG1  FIELD  */               LENGTH(DSNQDSNL) +      /*LENGTH OF  DS
*QDSNL  FIELD  */               DSNQDSNL);/*                    02S0208
*                                           DECREASE AMNT OF RECORD
*                                      LEFT TO PROCESS               */
         SLR   BYTECTR,@15                                      02S0208
*          TEMPTR = DSNQENTP;          /* PREVENT PLS 256-BYTE MOVE  */
         LR    TEMPTR,DSNQENTP                                  02S0209
*          IF BYTECTR > ZERO THEN      /* MORE ENTRIES IN THIS RCD?  */
         LTR   BYTECTR,BYTECTR                                  02S0210
         BNP   @RF00210                                         02S0210
*            TEMPTR -> DMYTOENT(ONE:BYTECTR) = /*YES, ERASE CURRENT
*                                        ENTRY                       */
*            EVAL(DSNQENTP + (LENGTH(DSNQSTEP) +      /*LENGTH OF  DSNQ
*TEP  FIELD  */               LENGTH(DSNQFLG1) +      /*LENGTH OF  DSNQ
*LG1  FIELD  */               LENGTH(DSNQDSNL) +      /*LENGTH OF  DSNQ
*SNL  FIELD  */               DSNQDSNL)) -> DMYFRENT(ONE:BYTECTR);
         LR    @08,BYTECTR                                      02S0211
         BCTR  @08,0                                            02S0211
         ALR   @15,DSNQENTP                                     02S0211
         EX    @08,@SM00203                                     02S0211
*          DQLSTCTR = DQLSTCTR + ONE;  /* MAKE P-LIST INDEX CURRENT  */
@RF00210 LA    @08,1                                            02S0212
         AL    @08,DQLSTCTR                                     02S0212
         ST    @08,DQLSTCTR                                     02S0212
*          DEQENTRY(DQLSTCTR) = DQLIST(ONE:DQLSTLEN);/* SET DEQ PLIST
*                                         SKELETON.                  */
         L     @05,DEQLISTP                                     02S0213
         MH    @08,@CH00180                                     02S0213
         ST    @08,@TF00001                                     02S0213
         ALR   @08,@05                                          02S0213
         AL    @08,@CF00189                                     02S0213
         MVI   DEQENTRY-3(@08),C' '                             02S0213
         MVC   DEQENTRY-2(10,@08),DEQENTRY-3(@08)               02S0213
         L     @15,DQLSTLEN                                     02S0213
         BCTR  @15,0                                            02S0213
         EX    @15,@SM00205                                     02S0213
*          DEQEND(DQLSTCTR) = OFF;     /* TURN OFF END OF LIST INDCTR*/
         LR    @08,@05                                          02S0214
         AL    @08,@TF00001                                     02S0214
         AL    @08,@CF00189                                     02S0214
         NI    DEQEND-4(@08),B'01111111'                        02S0214
*          DEQMINLN(DQLSTCTR) = DSRDSNLN(DSENTCTR);/* DSN LENGTH     */
         LR    @08,DSENTCTR                                     02S0215
         SLA   @08,3                                            02S0215
         LH    @15,DSRDSNLN-8(@08,DSRLPTR)                      02S0215
         L     @14,@TF00001                                     02S0215
         AL    @14,@CF00193                                     02S0215
         STC   @15,DEQMINLN-5(@14,@05)                          02S0215
*          DEQMINA(DQLSTCTR) = DSRDSNP(DSENTCTR);  /* DSN POINTER    */
         AL    @08,@CF00197                                     02S0216
         L     @08,DSRDSNP-4(@08,DSRLPTR)                       02S0216
         L     @01,@TF00001                                     02S0216
         ST    @08,DEQMINA-12(@01,@05)                          02S0216
*        END;                                                   02S0217
*      ELSE;                           /* STEP NUMBERS NOT EQUAL     */
@RF00204 DS    0H                                               02S0219
*    END;                                                       02S0219
*  ELSE;                               /* DSN'S NOT EQUAL.           */
@RF00196 DS    0H                                               02S0221
*END;                                  /* END SEARCH OF INPUT LIST.  */
         AH    DSENTCTR,@CH00049                                02S0221
@DE00195 C     DSENTCTR,DSRLNO(,DSRLPTR)                        02S0221
         BNH   @DL00195                                         02S0221
@DC00195 DS    0H                                               02S0222
*IF DEQNAMSW = OFF THEN                /* DSN ENTRY STILL IN TABLE?  */
         TM    DEQNAMSW,B'01000000'                             02S0222
         BNZ   @RF00222                                         02S0222
*  DO;                                                          02S0223
*    BYTECTR = BYTECTR- (LENGTH(DSNQSTEP) +      /*LENGTH OF  DSNQSTEP
*FIELD  */               LENGTH(DSNQFLG1) +      /*LENGTH OF  DSNQFLG1
*FIELD  */               LENGTH(DSNQDSNL) +      /*LENGTH OF  DSNQDSNL
*FIELD  */               DSNQDSNL);/*                           02S0224
*                                         DECREASE AMNT OF RECORD
*                                         LEFT TO PROCESS            */
         LA    @08,3                                            02S0224
         SLR   @07,@07                                          02S0224
         IC    @07,DSNQDSNL(,DSNQENTP)                          02S0224
         ALR   @08,@07                                          02S0224
         SLR   BYTECTR,@08                                      02S0224
*    DSNQENTP = DSNQENTP + (LENGTH(DSNQSTEP) +      /*LENGTH OF  DSNQST
*P  FIELD  */               LENGTH(DSNQFLG1) +      /*LENGTH OF  DSNQFL
*1  FIELD  */               LENGTH(DSNQDSNL) +      /*LENGTH OF  DSNQDS
*L  FIELD  */               DSNQDSNL);/*                        02S0225
*                                         GET PAST CURRENT      02S0225
*                                         ENTRY.                     */
         ALR   DSNQENTP,@08                                     02S0225
*  END;                                                         02S0226
*          END;                        /* END LOOP THRU ONE RECORD.  */
@RF00222 DS    0H                                               01S0227
@DE00192 SLR   @08,@08                                          01S0227
         CR    ELGNMCTR,@08                                     01S0227
         BNH   @DC00192                                         01S0227
         CR    BYTECTR,@08                                      01S0227
         BH    @DL00192                                         01S0227
@DC00192 DS    0H                                               01S0228
*          IF DSNQNSVA ^= ZERO &       /* MORE RECORDS IN TABLE?     */
*            ELGNMCTR > ZERO THEN      /* INPUT LIST EXHAUSTED?      */
         SLR   @08,@08                                          01S0228
         L     @07,DSNQPTR                                      01S0228
         SLR   @05,@05                                          01S0228
         ICM   @05,7,DSNQNSVA(@07)                              01S0228
         CR    @08,@05                                          01S0228
         BE    @RF00228                                         01S0228
         CR    ELGNMCTR,@08                                     01S0228
         BNH   @RF00228                                         01S0228
*            DO;                                                01S0229
*              SVALISTP = ADDR(DSNQNSVA); /* GET SVA OF NEXT RECORD. */
         LA    @08,DSNQNSVA(,@07)                               01S0230
         ST    @08,SVALISTP                                     01S0230
*              CALL IEFAB4F7           /* READ NEXT DSENQ TBL RECORD */
*                (SWACTLS,DUMMY,LEPACHNP,SVALISTP,SVABLSTP,DUMMY,
*                 NUMBLKS);                                     01S0231
         LA    @08,SWACTLS                                      01S0231
         ST    @08,@AL00001                                     01S0231
         LA    @08,@CF00110                                     01S0231
         ST    @08,@AL00001+4                                   01S0231
         LA    @08,LEPACHNP                                     01S0231
         ST    @08,@AL00001+8                                   01S0231
         LA    @08,SVALISTP                                     01S0231
         ST    @08,@AL00001+12                                  01S0231
         LA    @08,SVABLSTP                                     01S0231
         ST    @08,@AL00001+16                                  01S0231
         LA    @08,@CF00110                                     01S0231
         ST    @08,@AL00001+20                                  01S0231
         LA    @08,NUMBLKS                                      01S0231
         ST    @08,@AL00001+24                                  01S0231
         L     @15,@CV00130                                     01S0231
         LA    @01,@AL00001                                     01S0231
         BALR  @14,@15                                          01S0231
*            END;                                               01S0232
*          ELSE                        /* END OF TABLE               */
*            STOPSW = ON;              /* SET TABLE-SCAN LOOP EXIT.  */
         B     @RC00228                                         01S0233
@RF00228 OI    STOPSW,B'00100000'                               01S0233
*        END;                          /* END TABLE-SCAN LOOP.       */
@RC00228 DS    0H                                               01S0234
@DE00189 TM    STOPSW,B'00100000'                               01S0234
         BZ    @DL00189                                         01S0234
*/********************************************************************/
*/*                                                                  */
*/* SEGMENT NAME - A4A6CLNP                                          */
*/*                                                                  */
*/* DESCRIPTIVE NAME - CLEAN-UP FOR IEFAB4A6                         */
*/*                                                                  */
*/* FUNCTION -                                                       */
*/*                                                                  */
*/*   THIS ROUTINE COMPLETES THE DEQ PARM LIST AND ISSUES THE        */
*/*   DEQ, IF THERE ARE ANY NAMES TO BE DEQ'D.  THIS ROUTINE ALSO    */
*/*   FREES THE CORE OBTAINED FOR THE DEQ PARM LIST AND CALLS        */
*/*   THE SWA MANAGER TO WRITE THE DSENQ TABLE BACK TO SWA AND FREE  */
*/*   THE EPA'S.                                                     */
*/*                                                                  */
*/*   OPERATION -                                                    */
*/*                                                                  */
*/*     IF THE NUMBER OF DSN'S IN THE DEQ PARM LIST IS GREATER       */
*/*     THAN ZERO, THE END-OF-LIST INDICATOR IS TURNED ON IN THE     */
*/*     LAST ENTRY, THE INIT'S TCB ADDR IS PLACED IN THE LIST, AND   */
*/*     THE DEQ IS ISSUED.  THE CORE OBTAINED FOR THE DEQ PARM LIST  */
*/*     IS THEN FREED, AND THE SWA MANAGER INTERFACE ROUTINE,        */
*/*     IEFAB4F7, IS CALLED TO WRITE THE DSENQ TABLE BACK TO SWA AND */
*/*     TO FREE THE EPA'S                                            */
*/*                                                                  */
*/* ENTRY - IN-LINE SEGMENT                                          */
*/*                                                                  */
*/*   PURPOSE - SEE FUNCTION                                         */
*/*   INPUT -                                                        */
*/*     DQLSTCTR - NO. OF DSN'S IN DEQ PARM LIST                     */
*/*     DEQTCBP - PTR TO INIT'S TCB                                  */
*/*     DEQLSTSZ - AMNT OF CORE OBTAINED FOR DEQ PARM LIST           */
*/*     DEQLISTP - PTR TO DEQ PARM LIST CORE                         */
*/*     FRSTEPAP - PTR TO FIRST EPA                                  */
*/*     NUMRCDS - NUMBER OF DSENQ TABLE RECORDS READ IN              */
*/*                                                                  */
*/* EXIT -                                                           */
*/*                                                                  */
*/*   CONDITION - PROCESSING COMPLETE                                */
*/*     OUTPUT -                                                     */
*/*       DEQ ISSUED IF NECESSARY                                    */
*/*       DEQ PARM LIST CORE FREED                                   */
*/*       DSENQ TABLE RECORDS WRITTEN TO SWA                         */
*/*       EPA'S FREED                                                */
*/*     RETURN CODE - NONE                                           */
*/*                                                                  */
*/********************************************************************/
*IF DQLSTCTR > ZERO THEN               /* ANY ENTRIES IN DEQ P-LIST? */
         L     @07,DQLSTCTR                                     02S0235
         LTR   @07,@07                                          02S0235
         BNP   @RF00235                                         02S0235
*  DO;                                                          02S0236
*    DEQEND(DQLSTCTR) = ON;            /* END-OF-LIST INDICATOR IN
*                                         LAST P-LIST ENTRY.         */
         L     @15,DEQLISTP                                     02S0237
         MH    @07,@CH00180                                     02S0237
         ALR   @07,@15                                          02S0237
         AL    @07,@CF00189                                     02S0237
         OI    DEQEND-4(@07),B'10000000'                        02S0237
*    DEQTCBA = DEQTCBP;                /* SET TCB ADDR IN P-LIST.    */
         L     @07,@PC00001+12                                  02S0238
         MVC   DEQTCBA(4,@15),DEQTCBP(@07)                      02S0238
*    RFY (REG0,REG1) RSTD;             /* PRESERVE REGS.             */
*    REG1 = DEQLISTP + FOUR;           /* POINT TO DEQ P-LIST.       */
         AH    @15,@CH00104                                     02S0240
         LR    REG1,@15                                         02S0240
*    GEN (DEQ MF=(E,(1)));             /* DEQ OFF DSN'S              */
         DEQ MF=(E,(1))
*  END;                                                         02S0242
*REG0 = DEQLSTSZ;                      /* SIZE OF DEQ P-LIST CORE.   */
@RF00235 LR    REG0,DEQLSTSZ                                    02S0243
*REG0 = REG0 | SUBPL230;               /* FREE FROM SUBPOOL 230.     */
         O     REG0,@CF00120                                    02S0244
*REG1 = DEQLISTP;                      /* PTR TO DEQ P-LIST CORE     */
         L     REG1,DEQLISTP                                    02S0245
*GEN (FREEMAIN R,LV=(0),A=(1));        /* FREE DEQ P-LIST CORE       */
         FREEMAIN R,LV=(0),A=(1)
*RFY (REG0,REG1) UNRSTD;                                        02S0247
*SWACTLS = SWACTLS && SWACTLS;         /* CLEAR SWITCHES             */
         SLR   @10,@10                                          02S0248
         ICM   @10,3,SWACTLS                                    02S0248
         LR    @07,@10                                          02S0248
         XR    @07,@10                                          02S0248
         STH   @07,SWACTLS                                      02S0248
*SWWRT = ON;                           /* WRITE BLOCKS               */
*SWFREE = ON;                          /* FREE EPA'S                 */
*SWOLD = ON;                           /* EPA'S ARE OLD.             */
         OI    SWWRT,B'00010101'                                02S0251
*CALL IEFAB4F7                         /* WRITE DSENQ TBL,FREE EPA'S */
*  (SWACTLS,FRSTEPAP,DUMMY,DUMMY,DUMMY,DUMMY,DUMMY);            02S0252
         MVC   @AL00001+8(20),@AL00252                          02S0252
         LA    @10,SWACTLS                                      02S0252
         ST    @10,@AL00001                                     02S0252
         LA    @10,FRSTEPAP                                     02S0252
         ST    @10,@AL00001+4                                   02S0252
         L     @15,@CV00130                                     02S0252
         LA    @01,@AL00001                                     02S0252
         BALR  @14,@15                                          02S0252
*      END;                                                     01S0253
*    ELSE;                             /*GETMAIN UNSUCCESSFUL        */
@RF00185 DS    0H                                               01S0255
*  END;                                                         01S0255
*ELSE;                                 /* DS REL LIST NON-EXISTENT   */
@RF00142 DS    0H                                               01S0257
*RETURN CODE(RETCODE);                                          01S0257
         IC    @02,@OLDKEY                                      01S0257
         L     @13,4(,@13)                                      01S0257
         L     @00,@SIZDATD                                     01S0257
         LR    @01,@11                                          01S0257
         FSPACE   R,LV=(0),A=(1)
         MODESET KEYADDR=(2)
         LR    @15,@06                                          01S0257
         L     @14,12(,@13)                                     01S0257
         LM    @00,@12,20(@13)                                  01S0257
         BR    @14                                              01S0257
*END IEFAB4A6                                                   01S0258
*/* THE FOLLOWING INCLUDE STATEMENTS WERE FOUND IN THIS PROGRAM.      *
*/*%INCLUDE SYSLIB  (A4A6SPEC)                                        *
*/*%INCLUDE SYSLIB  (A4A6DATA)                                        *
*/*%INCLUDE SYSLIB  (IEFZB436)                                        *
*/*%INCLUDE SYSLIB  (IEFZB902)                                        *
*/*%INCLUDE SYSLIB  (READDSNQ)                                        *
*/*%INCLUDE SYSLIB  (RDDSSPEC)                                        *
*/*%INCLUDE SYSLIB  (DEQDSNS )                                        *
*/*%INCLUDE SYSLIB  (DEQSPEC )                                        *
*/*%INCLUDE SYSLIB  (A4A6INIT)                                        *
*/*%INCLUDE SYSLIB  (A6INSPEC)                                        *
*/*%INCLUDE SYSLIB  (DEQLBILD)                                        *
*/*%INCLUDE SYSLIB  (DQLBSPEC)                                        *
*/*%INCLUDE SYSLIB  (A4A6CLNP)                                        *
*/*%INCLUDE SYSLIB  (A6CLSPEC)                                        *
*;                                                              01S0258
@DATA    DS    0H
@CH00108 DC    H'2'
@CH00104 DC    H'4'
@CH00180 DC    H'12'
@SM00190 MVC   DEQENTRY-4(0,@07),DQLIST
@SM00194 MVC   DMYTOENT(0,TEMPTR),DMYFRENT(@10)
@SC00198 CLC   DSNQDSN(0,DSNQENTP),LISTDSN(@05)
@SC00200 CLC   DSNQDSN(0,DSNQENTP),LISTDSN(@01)
@SM00203 MVC   DMYTOENT(0,TEMPTR),DMYFRENT(@15)
@SM00205 MVC   DEQENTRY-4(0,@08),DQLIST
         DS    0F
@AL00139 EQU   *                       LIST WITH   5 ARGUMENT(S)
@AL00252 DC    A(@CF00110)             LIST WITH   5 ARGUMENT(S)
         DC    A(@CF00110)
         DC    A(@CF00110)
         DC    A(@CF00110)
         DC    A(@CF00110)
@DATD    DSECT
         DS    0F
@SA00001 DS    18F
@PC00001 DS    6F
@AL00001 DS    7A
@TF00001 DS    F
IEFAB4A6 CSECT
         DS    0F
@CF00110 DC    F'0'
@CF00049 DC    F'1'
@CH00049 EQU   @CF00049+2
@CF00189 DC    F'-8'
@CF00193 DC    F'-7'
@CF00197 DC    F'-4'
@CF00120 DC    XL4'E6000000'
@DATD    DSECT
         DS    0D
DEQLISTP DS    A
DSNQPTR  DS    A
FRSTBLKP DS    A
FRSTEPAP DS    A
LEPACHNP DS    A
SVABLSTP DS    A
SVALISTP DS    A
DQLSTCTR DS    F
NUMBLKS  DS    F
GTSTRTCD DS    F
SWACTLS  DS    FL2
         ORG   SWACTLS
SWASN    DS    BL1
SWDEL    EQU   SWACTLS+0
SWREAD   EQU   SWACTLS+0
SWWRT    EQU   SWACTLS+0
SWNEW    EQU   SWACTLS+0
SWFREE   EQU   SWACTLS+0
SWMOD    EQU   SWACTLS+0
SWOLD    EQU   SWACTLS+0
SWCHN    DS    BL1
@NM00004 EQU   SWACTLS+1
         ORG   SWACTLS+2
SWITCHES DS    BL1
         ORG   SWITCHES
MATCHSW  DS    BL1
DEQNAMSW EQU   SWITCHES+0
STOPSW   EQU   SWITCHES+0
FIRSTSW  EQU   SWITCHES+0
@NM00003 EQU   SWITCHES+0
         ORG   SWITCHES+1
@OLDKEY  DS    AL1
IEFAB4A6 CSECT
         DS    0F
@SIZDATD DC    AL1(230)
         DC    AL3(@ENDDATD-@DATD)
@CV00130 DC    V(IEFAB4F7)
         DS    0D
GTSTZERO DC    F'0'
SYSDSN   DC    CL8'SYSDSN  '
IEFAB4A6 CSECT
         DS   0H
A4A6PTCH DC ((@DATA-@PSTART)/20)X'00'
IEFAB4A6 CSECT
DQLIST DEQ (SYSDSN,,,SYSTEM),RET=HAVE,MF=L,TCB=0  DEQ LIST
DQLSTLEN DC A(*-DQLIST)  LENGTH OF DEQ LIST
@DATD    DSECT
         ORG   *+1-(*-@DATD)/(*-@DATD) INSURE DSECT DATA
@ENDDATD EQU   *
IEFAB4A6 CSECT
@00      EQU   00                      EQUATES FOR REGISTERS 0-15
@01      EQU   01
@02      EQU   02
@03      EQU   03
@04      EQU   04
@05      EQU   05
@06      EQU   06
@07      EQU   07
@08      EQU   08
@09      EQU   09
@10      EQU   10
@11      EQU   11
@12      EQU   12
@13      EQU   13
@14      EQU   14
@15      EQU   15
L1       EQU   @02
RETCODE  EQU   @06
LISTCTR  EQU   @05
ELGNMCTR EQU   @04
DSENTCTR EQU   @07
DEQLSTSZ EQU   @10
BYTECTR  EQU   @03
TEMPTR   EQU   @05
DSRLPTR  EQU   @09
DSNQENTP EQU   @02
REG0     EQU   @00
REG1     EQU   @01
REG15    EQU   @15
GTSTR0   EQU   @00
GTSTR1   EQU   @01
GTSTR2   EQU   @02
GTSTR15  EQU   @15
GTSTR4   EQU   @04
GTSTR5   EQU   @05
GTSTR6   EQU   @06
GTSTR7   EQU   @07
GTSTR8   EQU   @08
GTSTR3   EQU   @03
NEXTSVA  EQU   0
DEQPLIST EQU   0
DEQTCBA  EQU   DEQPLIST
DEQENTRY EQU   DEQPLIST+4
DEQFLGS1 EQU   DEQENTRY
DEQEND   EQU   DEQFLGS1
DEQMINLN EQU   DEQENTRY+1
DEQMINA  EQU   DEQENTRY+8
DSRLST   EQU   0
DSRLHDR  EQU   DSRLST
DSRLNO   EQU   DSRLHDR
DSRLENT  EQU   DSRLST+4
DSRDSNP  EQU   DSRLENT
DSRDSNLN EQU   DSRLENT+4
DMYTOENT EQU   0
DMYFRENT EQU   0
LISTDSN  EQU   0
DSNQTABL EQU   0
DSNQNSVA EQU   DSNQTABL+4
DSNQNEXT EQU   DSNQTABL+8
DSNQFREE EQU   DSNQTABL+12
DSNQENTS EQU   DSNQTABL+14
DSNQNTRY EQU   0
DSNQSTEP EQU   DSNQNTRY
DSNQFLG1 EQU   DSNQNTRY+1
DSNQDSNL EQU   DSNQNTRY+2
DSNQDSN  EQU   DSNQNTRY+3
FUNCMAP  EQU   0
NODSRLST EQU   FUNCMAP
DSRLP    EQU   0
STEPNUM  EQU   0
DEQTCBP  EQU   0
NQTABSVA EQU   0
RSNCODE  EQU   0
         AGO   .@UNREFD                START UNREFERENCED COMPONENTS
@NM00001 EQU   FUNCMAP
DSNQRS02 EQU   DSNQFLG1
DSNQSHR  EQU   DSNQFLG1
DSNQRS01 EQU   DSNQTABL+7
DSNQID   EQU   DSNQTABL+3
DSNQSVA  EQU   DSNQTABL
DSRFLGS  EQU   DSRLENT+6
DEQMAJA  EQU   DEQENTRY+4
DEQRET   EQU   DEQENTRY+3
DEQFLGS2 EQU   DEQENTRY+2
@NM00002 EQU   DEQFLGS1
.@UNREFD ANOP                          END UNREFERENCED COMPONENTS
@RF00083 EQU   @RC00055
@RF00128 EQU   @RC00124
@ENDDATA EQU   *
         END   IEFAB4A6
