         TITLE 'IEFAB4E5 - ALLOCATION RESOURCE MANAGER                 *
                        '
IEFAB4E5 CSECT ,                                                01S0001
@MAINENT DS    0H                                               01S0001
         USING *,@15                                            01S0001
         B     @PROLOG                                          01S0001
         DC    AL1(16)                                          01S0001
         DC    C'IEFAB4E5  76.342'                              01S0001
         DROP  @15
@PROLOG  STM   @14,@12,12(@13)                                  01S0001
         BALR  @10,0                                            01S0001
@PSTART  DS    0H                                               01S0001
         USING @PSTART,@10                                      01S0001
         L     @00,@SIZDATD                                     01S0001
         MODESET EXTKEY=SCHED,SAVEKEY=(2)
         GETMAIN  R,LV=(0)
         LR    @09,@01                                          01S0001
         USING @DATD,@09                                        01S0001
         ST    @13,@SA00001+4                                   01S0001
         STC   @02,@OLDKEY                                      01S0001
         MODESET KEYADDR=(2)
         LM    @00,@02,20(@13)                                  01S0001
         ST    @09,8(,@13)                                      01S0001
         LR    @13,@09                                          01S0001
         MODESET EXTKEY=ZERO
         MVC   @PC00001(4),0(@01)                               01S0001
         MODESET EXTKEY=SCHED
*                                          BY DATA MGR TASK CLOSE
*                                          FOR RB RELATED PURGES     */
*IF RMPLTERM = YES THEN                /*IS MEMORY TERMINATNG@ZA09467*/
         L     @12,@PC00001                                     01S0058
         TM    RMPLTERM(@12),B'01000000'                        01S0058
         BNO   @RF00058                                         01S0058
*  DO;                                 /*NEED TO DO CLEAN-UP         */
*/********************************************************************/
*/*                                                                  */
*/* SEGMENT NAME - QMGRINT                                           */
*/*                                                                  */
*/* DESCRIPTIVE NAME - Q-MGR INTERFACE                               */
*/*                                                                  */
*/* FUNCTION -                                                       */
*/*   THIS ROUTINE DETERMINES IF IT IS NECESSARY TO INVOKE THE       */
*/*   ALLOCATION Q-MGR TO FREE-UP RESOURCES ASSOCIATED WITH THE      */
*/*   TERMINATING MEMORY. IF REQUIRED, A Q-MGR REQUEST BLOCK IS      */
*/*   BUILT REQUESTING THE TERMINATE FUNCTION AND THE Q-MGR ROUTINE, */
*/*   IEFAB4FA, IS INVOKED. THIS PROCESSING IS NECESSARY ONLY IF     */
*/*   THERE IS A Q-MGR INFORMATION BLOCK ON THE QUEUE WHICH CON-     */
*/*   TAINS THE ASID OF THE TERMINATING MEMORY.                      */
*/*                                                                  */
*/* ENTRY - IN-LINE SEGMENT                                          */
*/*   PURPOSE - SEE FUNCTION                                         */
*/*   INPUT -                                                        */
*/*     CVTAQTOP - PTR TO HEAD OF Q-MGR QUEUE STRUCTURE              */
*/*       MAINF - PTR TO FIRST INFO BLOCK                            */
*/*         QMNXTF - PTR TO NEXT BLOCK (LAST BLOCK POINTS TO FIRST)  */
*/*         QMASID - ASID OF ASSOCIATED MEMORY                       */
*/*                                                                  */
*/* EXIT -                                                           */
*/*   CONDITION - NO QUEUE BLOCK FOR THIS ASID                       */
*/*     OUTPUT - NONE                                                */
*/*     RETURN CODES - NONE                                          */
*/*   CONDITION - QUEUE BLOCK FOR THIS ASID                          */
*/*     OUTPUT -                                                     */
*/*       DEVICE GROUPS RELEASED                                     */
*/*       WAITING ALLOCATIONS POSTED                                 */
*/*       QUEUE BLOCK DELETED/CORE FREED                             */
*/*     RETURN CODES - NONE                                          */
*/*                                                                  */
*/********************************************************************/
* DO; /*MODESET  KEYADDR(ZERO)*/                                02S0060
*   SPKA (ZERO); /*SET PSW KEY*/                                02S0061
         SLR   @12,@12                                          02S0061
         SPKA  0(@12)                                           02S0061
* END; /*MODESET  KEYADDR(ZERO)*/                               02S0062
* DO; /* SETLOCK (OBTAIN) MODE(UNCOND) TYPE(LOCAL) REGS(USE) RELATED(AL
*OC-AMGR,IEFAB4E5(QMGRINT)) */                                  02S0063
*   RFY (GPR11P,GPR12P,GPR13P,GPR14P) RSTD;                     02S0064
*   RFY (GPR15P,GPR00P,GPR01P) RSTD;                            02S0065
*   GPR15P = GPR11P; /* SAVE REG. 11 IN REG. 15. */             02S0066
         LR    GPR15P,GPR11P                                    02S0066
*   GPR00P = GPR12P; /* SAVE REG. 12 IN REG. 0. */              02S0067
         LR    GPR00P,GPR12P                                    02S0067
*   GPR01P = GPR13P; /* SAVE REG. 13 IN REG. 1. */              02S0068
         LR    GPR01P,GPR13P                                    02S0068
*   GPR13P = PSALITA; /* ADDRESS OF LOCK INTERFACE TABLE. */    02S0069
         L     GPR13P,PSALITA                                   02S0069
*   GEN(LM GPR11P,GPR13P,576(GPR13P)); /* LOAD LOCKWORD, CLHT AND ENTRY
*ADRS. */                                                       02S0070
         LM GPR11P,GPR13P,576(GPR13P)
*   GEN(BALR GPR14P,GPR13P); /* BALR TO SETLOCK RTN. */         02S0071
         BALR GPR14P,GPR13P
*   GPR11P = GPR15P; /* RESTORE REG. 11. */                     02S0072
         LR    GPR11P,GPR15P                                    02S0072
*   GPR15P = GPR13P; /* SAVE RETURN CODE. */                    02S0073
         LR    GPR15P,GPR13P                                    02S0073
*   GPR12P = GPR00P; /* RESTORE REG. 12 */                      02S0074
         LR    GPR12P,GPR00P                                    02S0074
*   GPR13P = GPR01P; /* RESTORE REG. 13. */                     02S0075
         LR    GPR13P,GPR01P                                    02S0075
*   RFY(GPR15P,GPR00P,GPR01P) UNRSTD;                           02S0076
*   RFY (GPR11P,GPR12P,GPR13P,GPR14P) UNRSTD;                   02S0077
* END; /* SETLOCK (OBTAIN) MODE(UNCOND) TYPE(LOCAL) REGS(USE) RELATED(A
*LOC-AMGR,IEFAB4E5(QMGRINT)) */                                 02S0078
* DO; /* SETLOCK (OBTAIN) MODE(UNCOND) TYPE(CMS) REGS(USE) RELATED(ALLO
*-AMGR,IEFAB4E5(QMGRINT)) */                                    02S0079
*   RFY (GPR11P,GPR12P,GPR13P,GPR14P) RSTD;                     02S0080
*   RFY (GPR15P,GPR00P,GPR01P) RSTD;                            02S0081
*   GPR15P = GPR11P; /* SAVE REG. 11 IN REG. 15. */             02S0082
         LR    GPR15P,GPR11P                                    02S0082
*   GPR00P = GPR12P; /* SAVE REG. 12 IN REG. 0. */              02S0083
         LR    GPR00P,GPR12P                                    02S0083
*   GPR01P = GPR13P; /* SAVE REG. 13 IN REG. 1. */              02S0084
         LR    GPR01P,GPR13P                                    02S0084
*   GPR13P = PSALITA; /* ADDRESS OF LOCK INTERFACE TABLE. */    02S0085
         L     GPR13P,PSALITA                                   02S0085
*   GEN(LM GPR11P,GPR13P,540(GPR13P)); /* LOAD LOCKWORD, CLHT AND ENTRY
*ADRS. */                                                       02S0086
         LM GPR11P,GPR13P,540(GPR13P)
*   GEN(BALR GPR14P,GPR13P); /* BALR TO SETLOCK RTN. */         02S0087
         BALR GPR14P,GPR13P
*   GPR11P = GPR15P; /* RESTORE REG. 11. */                     02S0088
         LR    GPR11P,GPR15P                                    02S0088
*   GPR15P = GPR13P; /* SAVE RETURN CODE. */                    02S0089
         LR    GPR15P,GPR13P                                    02S0089
*   GPR12P = GPR00P; /* RESTORE REG. 12 */                      02S0090
         LR    GPR12P,GPR00P                                    02S0090
*   GPR13P = GPR01P; /* RESTORE REG. 13. */                     02S0091
         LR    GPR13P,GPR01P                                    02S0091
*   RFY(GPR15P,GPR00P,GPR01P) UNRSTD;                           02S0092
*   RFY (GPR11P,GPR12P,GPR13P,GPR14P) UNRSTD;                   02S0093
* END; /* SETLOCK (OBTAIN) MODE(UNCOND) TYPE(CMS) REGS(USE) RELATED(ALL
*C-AMGR,IEFAB4E5(QMGRINT)) */                                   02S0094
*QMBLKPTR = MAINF;                     /*POINT TO FIRST QMGR INFO BLK*/
         L     @12,CVTPTR                                       02S0095
         L     @12,CVTAQTOP(,@12)                               02S0095
         L     QMBLKPTR,MAINF(,@12)                             02S0095
*BLKFOUND = OFF;                       /*INIT LOOP EXIT SWITCH       */
         NI    BLKFOUND,B'01111111'                             02S0096
*DO WHILE(BLKFOUND = OFF &             /*SCAN FOR BLOCK WITH ASID    */
*     QMBLKPTR ^= ADDR(MAINF));        /*STOP IF BACK TO BEG'NG OF
*                                        CHN OR NO BLOCKS EXIST      */
         B     @DE00097                                         02S0097
@DL00097 DS    0H                                               02S0098
*  IF QMASID = RMPLASID THEN           /*Q-BLOCK FOR TERM'NG MEMORY  */
         L     @12,@PC00001                                     02S0098
         CLC   QMASID(2,QMBLKPTR),RMPLASID(@12)                 02S0098
         BNE   @RF00098                                         02S0098
*    BLKFOUND = ON;                    /*INDICATE BLOCK FOUND        */
         OI    BLKFOUND,B'10000000'                             02S0099
*  ELSE                                /*ASID'S DON'T MATCH          */
*    DO;                               /*CONTINUE SEARCH             */
         B     @RC00098                                         02S0100
@RF00098 DS    0H                                               02S0101
*      QMBLKPTR = QMNXTF;              /*GET PTR TO NEXT BLOCK       */
         L     QMBLKPTR,QMNXTF(,QMBLKPTR)                       02S0101
*    END;                                                       02S0102
*END;                                                           02S0103
@RC00098 DS    0H                                               02S0103
@DE00097 TM    BLKFOUND,B'10000000'                             02S0103
         BNZ   @DC00097                                         02S0103
         L     @12,CVTPTR                                       02S0103
         C     QMBLKPTR,CVTAQTOP(,@12)                          02S0103
         BNE   @DL00097                                         02S0103
@DC00097 DS    0H                                               02S0104
* DO; /* SETLOCK (RELEASE) TYPE(CMS) REGS(USE) RELATED(ALLOC-AMGR,IEFAB
*E5(QMGRINT)) */                                                02S0104
*   RFY (GPR11P,GPR12P,GPR13P,GPR14P) RSTD;                     02S0105
*   RFY (GPR15P,GPR00P,GPR01P) RSTD;                            02S0106
*   GPR15P = GPR11P; /* SAVE REG. 11 IN REG. 15. */             02S0107
         LR    GPR15P,GPR11P                                    02S0107
*   GPR00P = GPR12P; /* SAVE REG. 12 IN REG. 0. */              02S0108
         LR    GPR00P,GPR12P                                    02S0108
*   GPR01P = GPR13P; /* SAVE REG. 13 IN REG. 1. */              02S0109
         LR    GPR01P,GPR13P                                    02S0109
*   GPR13P = PSALITA; /* ADDRESS OF LOCK INTERFACE TABLE. */    02S0110
         L     GPR13P,PSALITA                                   02S0110
*   GEN(LM GPR11P,GPR13P,552(GPR13P)); /* LOAD LOCKWORD, CLHT AND ENTRY
*ADRS. */                                                       02S0111
         LM GPR11P,GPR13P,552(GPR13P)
*   GEN(BALR GPR14P,GPR13P); /* BALR TO SETLOCK RTN. */         02S0112
         BALR GPR14P,GPR13P
*   GPR11P = GPR15P; /* RESTORE REG. 11. */                     02S0113
         LR    GPR11P,GPR15P                                    02S0113
*   GPR15P = GPR13P; /* SAVE RETURN CODE. */                    02S0114
         LR    GPR15P,GPR13P                                    02S0114
*   GPR12P = GPR00P; /* RESTORE REG. 12 */                      02S0115
         LR    GPR12P,GPR00P                                    02S0115
*   GPR13P = GPR01P; /* RESTORE REG. 13. */                     02S0116
         LR    GPR13P,GPR01P                                    02S0116
*   RFY(GPR15P,GPR00P,GPR01P) UNRSTD;                           02S0117
*   RFY (GPR11P,GPR12P,GPR13P,GPR14P) UNRSTD;                   02S0118
* END; /* SETLOCK (RELEASE) TYPE(CMS) REGS(USE) RELATED(ALLOC-AMGR,IEFA
*4E5(QMGRINT)) */                                               02S0119
* DO; /* SETLOCK (RELEASE) TYPE(LOCAL) REGS(USE) RELATED(ALLOC-AMGR,IEF
*B4E5(QMGRINT)) */                                              02S0120
*   RFY (GPR11P,GPR12P,GPR13P,GPR14P) RSTD;                     02S0121
*   RFY (GPR15P,GPR00P,GPR01P) RSTD;                            02S0122
*   GPR15P = GPR11P; /* SAVE REG. 11 IN REG. 15. */             02S0123
         LR    GPR15P,GPR11P                                    02S0123
*   GPR00P = GPR12P; /* SAVE REG. 12 IN REG. 0. */              02S0124
         LR    GPR00P,GPR12P                                    02S0124
*   GPR01P = GPR13P; /* SAVE REG. 13 IN REG. 1. */              02S0125
         LR    GPR01P,GPR13P                                    02S0125
*   GPR13P = PSALITA; /* ADDRESS OF LOCK INTERFACE TABLE. */    02S0126
         L     GPR13P,PSALITA                                   02S0126
*   GEN(LM GPR11P,GPR13P,588(GPR13P)); /* LOAD LOCKWORD, CLHT AND ENTRY
*ADRS. */                                                       02S0127
         LM GPR11P,GPR13P,588(GPR13P)
*   GEN(BALR GPR14P,GPR13P); /* BALR TO SETLOCK RTN. */         02S0128
         BALR GPR14P,GPR13P
*   GPR11P = GPR15P; /* RESTORE REG. 11. */                     02S0129
         LR    GPR11P,GPR15P                                    02S0129
*   GPR15P = GPR13P; /* SAVE RETURN CODE. */                    02S0130
         LR    GPR15P,GPR13P                                    02S0130
*   GPR12P = GPR00P; /* RESTORE REG. 12 */                      02S0131
         LR    GPR12P,GPR00P                                    02S0131
*   GPR13P = GPR01P; /* RESTORE REG. 13. */                     02S0132
         LR    GPR13P,GPR01P                                    02S0132
*   RFY(GPR15P,GPR00P,GPR01P) UNRSTD;                           02S0133
*   RFY (GPR11P,GPR12P,GPR13P,GPR14P) UNRSTD;                   02S0134
* END; /* SETLOCK (RELEASE) TYPE(LOCAL) REGS(USE) RELATED(ALLOC-AMGR,IE
*AB4E5(QMGRINT)) */                                             02S0135
* DO; /*MODESET  EXTKEY(SCHED)*/                                02S0136
*   SPKA (16); /*SET PSW KEY*/                                  02S0137
         LA    @12,16                                           02S0137
         SPKA  0(@12)                                           02S0137
* END; /*MODESET  EXTKEY(SCHED)*/                               02S0138
*IF BLKFOUND = ON THEN                 /*FOUND BLOCK FOR THIS MEMORY */
         TM    BLKFOUND,B'10000000'                             02S0139
         BNO   @RF00139                                         02S0139
*  DO;                                 /*SET UP RB FOR Q-MGR         */
*    QMGRRB = QMGRRB && QMGRRB;        /*CLEAR REQUEST BLOCK CORE    */
         XC    QMGRRB(28),QMGRRB                                02S0141
*    AQMECODE = TERMFUNC;              /*INDICATE TERMINATE FCN REQ'D*/
         LA    @12,QMGRRB                                       02S0142
         MVC   AQMECODE(2,@12),@CH00046                         02S0142
*    AQMASID = RMPLASID;               /*SET ID OF TERMING MEMORY    */
         MVI   AQMASID+2(@12),C' '                              02S0143
         MVI   AQMASID+3(@12),C' '                              02S0143
         L     @11,@PC00001                                     02S0143
         MVC   AQMASID(2,@12),RMPLASID(@11)                     02S0143
*    EDTPTR = ADDR(EDTTAB);            /*GET ADDRESSABILITY TO EDT   */
         L     EDTPTR,@CA00070                                  02S0144
*    AQMLENGT = GMTENTLN;              /*GET LENGTH GRP MASK FROM EDT*/
         L     @11,EDTMSKTP(,EDTPTR)                            02S0145
         MVC   AQMLENGT(4,@12),GMTENTLN(@11)                    02S0145
*    AQMQBPTR = QMBLKPTR;              /*SET PTR TO Q-BLOCK WITH ASID*/
         ST    QMBLKPTR,AQMQBPTR(,@12)                          02S0146
*    CALL IEFAB4FA(ADDR(QMGRRB),ZERO); /*CALL Q-MGR TO TERMINATE     */
         ST    @12,@TF00001                                     02S0147
         LA    @12,@TF00001                                     02S0147
         ST    @12,@AL00001                                     02S0147
         LA    @12,@CF00104                                     02S0147
         ST    @12,@AL00001+4                                   02S0147
         L     @15,@CV00071                                     02S0147
         LA    @01,@AL00001                                     02S0147
         BALR  @14,@15                                          02S0147
*  END;                                                         02S0148
*ELSE;                                 /*NO Q-BLK WITH TERM'NG ASID  */
@RF00139 DS    0H                                               02S0150
*                                                               01S0150
*    /****************************************************************/
*    /* FIND MVCA FOR MEMORY,DELETE IT FROM CHAIN, & FREE ITS CORE   */
*    /****************************************************************/
*                                                               01S0150
*    A498PLST = A498PLST && A498PLST;  /*CLEAR PARM AREA FOR IEFAB498*/
         XC    A498PLST(8),A498PLST                             01S0150
*    A498FMAP = SRCHFUNC;              /*INDICATE SEARCH FUNCTION    */
         MVC   A498FMAP(2),@CB00100                             01S0151
*    A498ASID = RMPLASID;              /*SET ASID TO SEARCH FOR      */
         L     @12,@PC00001                                     01S0152
         MVC   A498ASID(2),RMPLASID(@12)                        01S0152
*    CALL IEFAB498(ADDR(A498PLST),ZERO); /*CALL MVCA CHAIN PROCESSOR */
         LA    @12,A498PLST                                     01S0153
         ST    @12,@TF00001                                     01S0153
         LA    @12,@TF00001                                     01S0153
         ST    @12,@AL00001                                     01S0153
         LA    @12,@CF00104                                     01S0153
         ST    @12,@AL00001+4                                   01S0153
         L     @15,@CV00072                                     01S0153
         LA    @01,@AL00001                                     01S0153
         BALR  @14,@15                                          01S0153
*    IF REG15 = FOUND THEN             /*MVCA WITH ASID FOUND        */
         CH    REG15,@CH00079                                   01S0154
         BNE   @RF00154                                         01S0154
*      DO;                             /*DELETE IT FROM CHN/FREE CORE*/
*        A498FMAP = DELFUNC;           /*SET DELETE FUNCTION INDIC   */
         MVC   A498FMAP(2),@CB00077                             01S0156
*        CALL IEFAB498(ADDR(A498PLST),ZERO); /*DELETE MVCA FROM CHAIN*/
         LA    @12,A498PLST                                     01S0157
         ST    @12,@TF00001                                     01S0157
         LA    @12,@TF00001                                     01S0157
         ST    @12,@AL00001                                     01S0157
         LA    @12,@CF00104                                     01S0157
         ST    @12,@AL00001+4                                   01S0157
         L     @15,@CV00072                                     01S0157
         LA    @01,@AL00001                                     01S0157
         BALR  @14,@15                                          01S0157
*        RFY(REG0,REG1) RSTD;                                   01S0158
*        REG0 = LENGTH(MVCA);          /*SET AMOUNT OF CORE TO FREE  */
         LA    REG0,16                                          01S0159
*        REG0 = REG0 | MVCASPNO;       /*SUBPOOL NUMBER INTO H-O BYTE*/
         O     REG0,@CF00088                                    01S0160
*        REG1 = MVCAPTR;               /*POINT TO CORE TO FREE       */
         L     REG1,MVCAPTR                                     01S0161
*        GEN(FREEMAIN R,LV=(0),A=(1)); /*FREE MVCA                   */
         FREEMAIN R,LV=(0),A=(1)
*        RFY (REG0,REG1) UNRSTD;                                01S0163
*      END;                                                     01S0164
*    ELSE;                             /*NO MVCA FOUND FOR THIS MEM  */
@RF00154 DS    0H                                               01S0166
*/********************************************************************/
*/*                                                                  */
*/* SEGMENT NAME - CLNUCBS                                           */
*/*                                                                  */
*/* DESCRIPTIVE NAME - CLEAN-UP UCBS ALLOCATED TO TERMINATING MEMORY */
*/*                                                                  */
*/* FUNCTION -                                                       */
*/*   THIS ROUTINE RETURNS TO ALLOCATABLE STATUS, EACH UCB WHICH     */
*/*   REPRESENTS A NON-SHAREABLE DEVICE ALLOCATED TO THE TERMINATING */
*/*   MEMORY. THE ALLOCATION Q-MGR IS THEN INVOKED TO POST ANY       */
*/*   OTHER ALLOCATIONS WHICH MAY BE WAITING FOR DEVICES.            */
*/*                                                                  */
*/* ENTRY - IN-LINE SEGMENT                                          */
*/*   PURPOSE - SEE FUNCTION                                         */
*/*   INPUT -                                                        */
*/*     CVTILK2 - PTR TO IOS UCB LOOK-UP-TABLE                       */
*/*                                                                  */
*/* EXIT -                                                           */
*/*   CONDITION - PROCESSING COMPLETE                                */
*/*     OUTPUT                                                       */
*/*       UCB(S) UPDATED                                             */
*/*     RETURN CODES - NONE                                          */
*/*                                                                  */
*/********************************************************************/
* DO; /*MODESET  KEYADDR(ZERO)*/                                02S0166
*   SPKA (ZERO); /*SET PSW KEY*/                                02S0167
         SLR   @12,@12                                          02S0167
         SPKA  0(@12)                                           02S0167
* END; /*MODESET  KEYADDR(ZERO)*/               /*GET KEY 0 TO UPDATE U
*B'S   */                                                       02S0168
* DO; /* SETLOCK (OBTAIN) MODE(UNCOND) TYPE(LOCAL) REGS(USE) RELATED(UC
*,IEFAB4E5(CLNUCBS)) */                                         02S0169
*   RFY (GPR11P,GPR12P,GPR13P,GPR14P) RSTD;                     02S0170
*   RFY (GPR15P,GPR00P,GPR01P) RSTD;                            02S0171
*   GPR15P = GPR11P; /* SAVE REG. 11 IN REG. 15. */             02S0172
         LR    GPR15P,GPR11P                                    02S0172
*   GPR00P = GPR12P; /* SAVE REG. 12 IN REG. 0. */              02S0173
         LR    GPR00P,GPR12P                                    02S0173
*   GPR01P = GPR13P; /* SAVE REG. 13 IN REG. 1. */              02S0174
         LR    GPR01P,GPR13P                                    02S0174
*   GPR13P = PSALITA; /* ADDRESS OF LOCK INTERFACE TABLE. */    02S0175
         L     GPR13P,PSALITA                                   02S0175
*   GEN(LM GPR11P,GPR13P,576(GPR13P)); /* LOAD LOCKWORD, CLHT AND ENTRY
*ADRS. */                                                       02S0176
         LM GPR11P,GPR13P,576(GPR13P)
*   GEN(BALR GPR14P,GPR13P); /* BALR TO SETLOCK RTN. */         02S0177
         BALR GPR14P,GPR13P
*   GPR11P = GPR15P; /* RESTORE REG. 11. */                     02S0178
         LR    GPR11P,GPR15P                                    02S0178
*   GPR15P = GPR13P; /* SAVE RETURN CODE. */                    02S0179
         LR    GPR15P,GPR13P                                    02S0179
*   GPR12P = GPR00P; /* RESTORE REG. 12 */                      02S0180
         LR    GPR12P,GPR00P                                    02S0180
*   GPR13P = GPR01P; /* RESTORE REG. 13. */                     02S0181
         LR    GPR13P,GPR01P                                    02S0181
*   RFY(GPR15P,GPR00P,GPR01P) UNRSTD;                           02S0182
*   RFY (GPR11P,GPR12P,GPR13P,GPR14P) UNRSTD;                   02S0183
* END; /* SETLOCK (OBTAIN) MODE(UNCOND) TYPE(LOCAL) REGS(USE) RELATED(U
*B,IEFAB4E5(CLNUCBS)) */                                        02S0184
* DO; /* SETLOCK (OBTAIN) MODE(UNCOND) TYPE(CMS) REGS(USE) RELATED(UCB,
*EFAB4E5(CLNUCBS)) */                                           02S0185
*   RFY (GPR11P,GPR12P,GPR13P,GPR14P) RSTD;                     02S0186
*   RFY (GPR15P,GPR00P,GPR01P) RSTD;                            02S0187
*   GPR15P = GPR11P; /* SAVE REG. 11 IN REG. 15. */             02S0188
         LR    GPR15P,GPR11P                                    02S0188
*   GPR00P = GPR12P; /* SAVE REG. 12 IN REG. 0. */              02S0189
         LR    GPR00P,GPR12P                                    02S0189
*   GPR01P = GPR13P; /* SAVE REG. 13 IN REG. 1. */              02S0190
         LR    GPR01P,GPR13P                                    02S0190
*   GPR13P = PSALITA; /* ADDRESS OF LOCK INTERFACE TABLE. */    02S0191
         L     GPR13P,PSALITA                                   02S0191
*   GEN(LM GPR11P,GPR13P,540(GPR13P)); /* LOAD LOCKWORD, CLHT AND ENTRY
*ADRS. */                                                       02S0192
         LM GPR11P,GPR13P,540(GPR13P)
*   GEN(BALR GPR14P,GPR13P); /* BALR TO SETLOCK RTN. */         02S0193
         BALR GPR14P,GPR13P
*   GPR11P = GPR15P; /* RESTORE REG. 11. */                     02S0194
         LR    GPR11P,GPR15P                                    02S0194
*   GPR15P = GPR13P; /* SAVE RETURN CODE. */                    02S0195
         LR    GPR15P,GPR13P                                    02S0195
*   GPR12P = GPR00P; /* RESTORE REG. 12 */                      02S0196
         LR    GPR12P,GPR00P                                    02S0196
*   GPR13P = GPR01P; /* RESTORE REG. 13. */                     02S0197
         LR    GPR13P,GPR01P                                    02S0197
*   RFY(GPR15P,GPR00P,GPR01P) UNRSTD;                           02S0198
*   RFY (GPR11P,GPR12P,GPR13P,GPR14P) UNRSTD;                   02S0199
* END; /* SETLOCK (OBTAIN) MODE(UNCOND) TYPE(CMS) REGS(USE) RELATED(UCB
*IEFAB4E5(CLNUCBS)) */                                          02S0200
*DO LUTCTR = 1 BY 1                                             02S0201
*     WHILE(IOSLUT(LUTCTR) ^= LUTEND);/*                        02S0201
*                                        SCAN FOR UCBS IN THIS MEMORY*/
         LA    LUTCTR,1                                         02S0201
         B     @DE00201                                         02S0201
@DL00201 DS    0H                                               02S0202
*  UCBPTR = IOSLUT(LUTCTR);            /*SET PTR TO UCB FROM LUT ENT */
         LR    @12,LUTCTR                                       02S0202
         ALR   @12,@12                                          02S0202
         L     @11,CVTPTR                                       02S0202
         L     @11,CVTILK2(,@11)                                02S0202
         ALR   @11,@12                                          02S0202
         BCTR  @11,0                                            02S0202
         BCTR  @11,0                                            02S0202
         SLR   UCBPTR,UCBPTR                                    02S0202
         ICM   UCBPTR,3,IOSLUT(@11)                             02S0202
*  IF UCBPTR ^= ZERO THEN              /*ENTRY WAS NON-ZERO          */
         LTR   UCBPTR,UCBPTR                                    02S0203
         BZ    @RF00203                                         02S0203
*    IF UCBASID = RMPLASID &           /*UCB HAS ASID OF THIS MEMORY */
*        UCBALOC = ON &                /*UNIT STILL ALCD     @ZA02721*/
*        ((UCB3DACC = YES &            /*... IS NON-SHAREABLE D.A.   */
*        UCBBSVL = YES) |                                       02S0204
*        UCB3DACC = NO) THEN           /*... OR NOT D.A. UCB @YM03637*/
         L     @12,UCBEXTPT(,UCBPTR)                            02S0204
         L     @11,@PC00001                                     02S0204
         SLR   @08,@08                                          02S0204
         ICM   @08,3,RMPLASID(@11)                              02S0204
         CH    @08,UCBASID(,@12)                                02S0204
         BNE   @RF00204                                         02S0204
         TM    UCBALOC(UCBPTR),B'00001000'                      02S0204
         BNO   @RF00204                                         02S0204
         TM    UCB3DACC(UCBPTR),B'00100000'                     02S0204
         BNO   @GL00004                                         02S0204
         TM    UCBBSVL(UCBPTR),B'10000000'                      02S0204
         BO    @RT00204                                         02S0204
@GL00004 TM    UCB3DACC(UCBPTR),B'00100000'                     02S0204
         BNZ   @RF00204                                         02S0204
@RT00204 DS    0H                                               02S0205
*      DO;                             /*NON-SHAREABLE UCB WITH ASID */
*        UCBALOC = OFF;                /*TURN OFF ALLOCATED INDICATOR*/
         NI    UCBALOC(UCBPTR),B'11110111'                      02S0206
*        UCBASID = ZERO;               /*CLEAR ASID FIELD            */
         L     @12,UCBEXTPT(,UCBPTR)                            02S0207
         SLR   @11,@11                                          02S0207
         STH   @11,UCBASID(,@12)                                02S0207
*        IF UCB3DACC = YES THEN        /*UCB FOR D.A. DEVICE         */
         TM    UCB3DACC(UCBPTR),B'00100000'                     02S0208
         BNO   @RF00208                                         02S0208
*          DO;                                                  02S0209
*            UCBBSVL = OFF;            /*TURN OFF NON-SHAREABLE INDIC*/
*            UCBSHAR = OFF;            /*TURN OFF NON-SHAREABLE INDIC*/
         NI    UCBBSVL(UCBPTR),B'01111101'                      02S0211
*            UCBUSER = ZERO;           /*CLEAR NO. USERS FIELD       */
         MVI   UCBUSER(UCBPTR),X'00'                            02S0212
*          END;                                                 02S0213
*        IF (UCB3DACC = YES |          /*UCB FOR D.A. OR TAPE DEVICE */
*             UCB3TAPE = YES) THEN                              02S0214
@RF00208 TM    UCB3DACC(UCBPTR),B'10100000'                     02S0214
         BZ    @RF00214                                         02S0214
*          DO;                                                  02S0215
*            IF UCBATI = SCHEDATI THEN /*ATTN TAB INDEX IS SCHED'S   */
         L     @12,UCBEXTPT(,UCBPTR)                            02S0216
         CLI   UCBATI(@12),12                                   02S0216
         BNE   @RF00216                                         02S0216
*              UCBATI = ZERO;          /*CLEAR IT                    */
         MVI   UCBATI(@12),X'00'                                02S0217
*            UCBDMC = CLRDMCT;         /*CLEAR DATA MGMT COUNT FIELD */
@RF00216 NI    UCBDMC(UCBPTR),B'10000000'                       02S0218
*            UCBNSRCH = OFF;           /*CLEAR NON-SCRATCH VOL INDIC */
         L     @12,UCBEXTPT(,UCBPTR)                            02S0219
         NI    UCBNSRCH(@12),B'01111111'                        02S0219
*            IF UCBVOLI = ZEROVLSR THEN /*VOL WAS NEVER MOUNTED      */
         CLC   UCBVOLI(6,UCBPTR),ZEROVLSR                       02S0220
         BNE   @RF00220                                         02S0220
*              DO;                     /*CLEAR PND'NG MNT/ATTRIBUTES */
*                UCBMOUNT = OFF;       /*RESET PENDING MOUNT INDIC   */
         NI    UCBMOUNT(UCBPTR),B'01111111'                     02S0222
*                UCBBPRV = OFF;        /*TURN OFF PRIVATE            */
*                UCBBPUB = OFF;        /*TURN OFF PUBLIC             */
         NI    UCBBPRV(UCBPTR),B'11100111'                      02S0224
*                IF UCB3DACC = YES THEN /*D.A. DEVICE                */
         TM    UCB3DACC(UCBPTR),B'00100000'                     02S0225
         BNO   @RF00225                                         02S0225
*                  UCBBSTR = OFF;      /*TURN OFF STORAGE            */
         NI    UCBBSTR(UCBPTR),B'11111011'                      02S0226
*              END;                                             02S0227
*          END;                                                 02S0228
*      END;                                                     02S0229
*    ELSE;                             /*UCB NOT ALLOC'D TO THIS MEM
*                                        OR IS SHAREABLE             */
@RF00204 DS    0H                                               02S0231
*  ELSE;                               /*ZERO L-U-T ENTRY            */
@RF00203 DS    0H                                               02S0232
*END;                                                           02S0232
@RC00203 AH    LUTCTR,@CH00049                                  02S0232
@DE00201 LR    @12,LUTCTR                                       02S0232
         ALR   @12,@12                                          02S0232
         L     @11,CVTPTR                                       02S0232
         L     @11,CVTILK2(,@11)                                02S0232
         ALR   @11,@12                                          02S0232
         BCTR  @11,0                                            02S0232
         BCTR  @11,0                                            02S0232
         CLC   IOSLUT(2,@11),LUTEND                             02S0232
         BNE   @DL00201                                         02S0232
* DO; /* SETLOCK (RELEASE) TYPE(CMS) REGS(USE) RELATED(UCB,IEFAB4E5(CLN
*CBS)) */                                                       02S0233
*   RFY (GPR11P,GPR12P,GPR13P,GPR14P) RSTD;                     02S0234
*   RFY (GPR15P,GPR00P,GPR01P) RSTD;                            02S0235
*   GPR15P = GPR11P; /* SAVE REG. 11 IN REG. 15. */             02S0236
         LR    GPR15P,GPR11P                                    02S0236
*   GPR00P = GPR12P; /* SAVE REG. 12 IN REG. 0. */              02S0237
         LR    GPR00P,GPR12P                                    02S0237
*   GPR01P = GPR13P; /* SAVE REG. 13 IN REG. 1. */              02S0238
         LR    GPR01P,GPR13P                                    02S0238
*   GPR13P = PSALITA; /* ADDRESS OF LOCK INTERFACE TABLE. */    02S0239
         L     GPR13P,PSALITA                                   02S0239
*   GEN(LM GPR11P,GPR13P,552(GPR13P)); /* LOAD LOCKWORD, CLHT AND ENTRY
*ADRS. */                                                       02S0240
         LM GPR11P,GPR13P,552(GPR13P)
*   GEN(BALR GPR14P,GPR13P); /* BALR TO SETLOCK RTN. */         02S0241
         BALR GPR14P,GPR13P
*   GPR11P = GPR15P; /* RESTORE REG. 11. */                     02S0242
         LR    GPR11P,GPR15P                                    02S0242
*   GPR15P = GPR13P; /* SAVE RETURN CODE. */                    02S0243
         LR    GPR15P,GPR13P                                    02S0243
*   GPR12P = GPR00P; /* RESTORE REG. 12 */                      02S0244
         LR    GPR12P,GPR00P                                    02S0244
*   GPR13P = GPR01P; /* RESTORE REG. 13. */                     02S0245
         LR    GPR13P,GPR01P                                    02S0245
*   RFY(GPR15P,GPR00P,GPR01P) UNRSTD;                           02S0246
*   RFY (GPR11P,GPR12P,GPR13P,GPR14P) UNRSTD;                   02S0247
* END; /* SETLOCK (RELEASE) TYPE(CMS) REGS(USE) RELATED(UCB,IEFAB4E5(CL
*UCBS)) */                                                      02S0248
* DO; /* SETLOCK (RELEASE) TYPE(LOCAL) REGS(USE) RELATED(UCB,IEFAB4E5(C
*NUCBS)) */                                                     02S0249
*   RFY (GPR11P,GPR12P,GPR13P,GPR14P) RSTD;                     02S0250
*   RFY (GPR15P,GPR00P,GPR01P) RSTD;                            02S0251
*   GPR15P = GPR11P; /* SAVE REG. 11 IN REG. 15. */             02S0252
         LR    GPR15P,GPR11P                                    02S0252
*   GPR00P = GPR12P; /* SAVE REG. 12 IN REG. 0. */              02S0253
         LR    GPR00P,GPR12P                                    02S0253
*   GPR01P = GPR13P; /* SAVE REG. 13 IN REG. 1. */              02S0254
         LR    GPR01P,GPR13P                                    02S0254
*   GPR13P = PSALITA; /* ADDRESS OF LOCK INTERFACE TABLE. */    02S0255
         L     GPR13P,PSALITA                                   02S0255
*   GEN(LM GPR11P,GPR13P,588(GPR13P)); /* LOAD LOCKWORD, CLHT AND ENTRY
*ADRS. */                                                       02S0256
         LM GPR11P,GPR13P,588(GPR13P)
*   GEN(BALR GPR14P,GPR13P); /* BALR TO SETLOCK RTN. */         02S0257
         BALR GPR14P,GPR13P
*   GPR11P = GPR15P; /* RESTORE REG. 11. */                     02S0258
         LR    GPR11P,GPR15P                                    02S0258
*   GPR15P = GPR13P; /* SAVE RETURN CODE. */                    02S0259
         LR    GPR15P,GPR13P                                    02S0259
*   GPR12P = GPR00P; /* RESTORE REG. 12 */                      02S0260
         LR    GPR12P,GPR00P                                    02S0260
*   GPR13P = GPR01P; /* RESTORE REG. 13. */                     02S0261
         LR    GPR13P,GPR01P                                    02S0261
*   RFY(GPR15P,GPR00P,GPR01P) UNRSTD;                           02S0262
*   RFY (GPR11P,GPR12P,GPR13P,GPR14P) UNRSTD;                   02S0263
* END; /* SETLOCK (RELEASE) TYPE(LOCAL) REGS(USE) RELATED(UCB,IEFAB4E5(
*LNUCBS)) */                                                    02S0264
* DO; /*MODESET  EXTKEY(SCHED)*/                                02S0265
*   SPKA (16); /*SET PSW KEY*/                                  02S0266
         LA    @12,16                                           02S0266
         SPKA  0(@12)                                           02S0266
* END; /*MODESET  EXTKEY(SCHED)*/               /*RETURN TO SCHEDULER K
*Y     */                                                       02S0267
*QMGRRB = QMGRRB && QMGRRB;            /*CLEAR Q-MGR REQUEST BLK     */
         XC    QMGRRB(28),QMGRRB                                02S0268
*AQMECODE = POSTDCDE;                  /*SET POST FUNCTION CODE      */
         LA    @12,QMGRRB                                       02S0269
         MVC   AQMECODE(2,@12),@CH00096                         02S0269
*AQMASID = RMPLASID;                   /*SET ASID OF THIS MOMORY     */
         MVI   AQMASID+2(@12),C' '                              02S0270
         MVI   AQMASID+3(@12),C' '                              02S0270
         L     @11,@PC00001                                     02S0270
         MVC   AQMASID(2,@12),RMPLASID(@11)                     02S0270
*AQMMASKP = ADDR(GRPMSK);              /*SET PTR TO GROUP MASK       */
         LA    @11,GRPMSK                                       02S0271
         ST    @11,AQMMASKP(,@12)                               02S0271
*CALL IEFAB4FA(ADDR(QMGRRB),ZERO);                              02S0272
         ST    @12,@TF00001                                     02S0272
         LA    @12,@TF00001                                     02S0272
         ST    @12,@AL00001                                     02S0272
         LA    @12,@CF00104                                     02S0272
         ST    @12,@AL00001+4                                   02S0272
         L     @15,@CV00071                                     02S0272
         LA    @01,@AL00001                                     02S0272
         BALR  @14,@15                                          02S0272
*  END;                                                         01S0273
*ELSE;                                 /*NOT ABNORMAL MEMORY TERM'N -
*                                        NO PROCESSING NECESSARY     */
@RF00058 DS    0H                                               01S0275
*RETURN CODE(ZERO);                    /*RETURN TO CALLER            */
*                                                               01S0275
*                                                               01S0275
         IC    @02,@OLDKEY                                      01S0275
         L     @13,4(,@13)                                      01S0275
         L     @00,@SIZDATD                                     01S0275
         LR    @01,@09                                          01S0275
         FREEMAIN R,LV=(0),A=(1)
         MODESET KEYADDR=(2)
         SLR   @15,@15                                          01S0275
         L     @14,12(,@13)                                     01S0275
         LM    @00,@12,20(@13)                                  01S0275
         BR    @14                                              01S0275
* DECLARE /*GENERAL PURPOSE REGISTERS */                        01S0276
*   GPR00P PTR(31) REG(0),                                      01S0276
*   GPR01P PTR(31) REG(1),                                      01S0276
*   GPR11P PTR(31) REG(11),                                     01S0276
*   GPR12P PTR(31) REG(12),                                     01S0276
*   GPR13P PTR(31) REG(13),                                     01S0276
*   GPR14P PTR(31) REG(14),                                     01S0276
*   GPR15P PTR(31) REG(15);                                     01S0276
*                                                               01S0276
* DECLARE /* COMMON VARIABLES */                                01S0277
*   I256C CHAR(256) BASED,                                      01S0277
*   I031F FIXED(31) BASED,                                      01S0277
*   I031P PTR(31)   BASED,                                      01S0277
*   I015F FIXED(15) BASED,                                      01S0277
*   I015P PTR(15)   BASED,                                      01S0277
*   I008P PTR(8)    BASED,                                      01S0277
*   I001C CHAR(1)   BASED;                                      01S0277
*END IEFAB4E5                                                   01S0278
*/* THE FOLLOWING INCLUDE STATEMENTS WERE FOUND IN THIS PROGRAM.      *
*/*%INCLUDE SYSLIB  (A4E5SPEC)                                        *
*/*%INCLUDE SYSLIB  (A4E5DATA)                                        *
*/*%INCLUDE SYSLIB  (CVT     )                                        *
*/*%INCLUDE SYSLIB  (IEFUCBOB)                                        *
*/*%INCLUDE SYSLIB  (IEFZB421)                                        *
*/*%INCLUDE SYSLIB  (IEFZB427)                                        *
*/*%INCLUDE SYSLIB  (IEFZB433)                                        *
*/*%INCLUDE SYSLIB  (IHAPSA  )                                        *
*/*%INCLUDE SYSLIB  (IHARMPL )                                        *
*/*%INCLUDE SYSLIB  (QMGRINT )                                        *
*/*%INCLUDE SYSLIB  (QINTSPEC)                                        *
*/*%INCLUDE SYSLIB  (CLNUCBS )                                        *
*/*%INCLUDE SYSLIB  (CUCBSPEC)                                        *
*;                                                              01S0278
@DATA    DS    0H
@CH00049 DC    H'1'
@CH00046 DC    H'2'
@CH00096 DC    H'6'
@CH00079 DC    H'8'
@DATD    DSECT
         DS    0F
@SA00001 DS    18F
@PC00001 DS    1F
@AL00001 DS    2A
@TF00001 DS    F
IEFAB4E5 CSECT
         DS    0F
@CF00104 DC    F'0'
@CF00088 DC    XL4'F1000000'
@DATD    DSECT
         DS    0D
LUVPTR   DS    A
GENPTR   DS    A
GRPTABP  DS    A
GRPPTR   DS    A
MTENTPTR DS    A
A498PLST DS    CL8
         ORG   A498PLST
A498FMAP DS    BL2
A498ASID DS    CL2
MVCAPTR  DS    AL4
         ORG   A498PLST+8
BLKFOUND DS    BL1
         DS    CL3
QMGRRB   DS    CL28
@OLDKEY  DS    AL1
IEFAB4E5 CSECT
         DS    0F
@SIZDATD DC    AL1(230)
         DC    AL3(@ENDDATD-@DATD)
@CA00070 DC    A(EDTTAB)
@CV00071 DC    V(IEFAB4FA)
@CV00072 DC    V(IEFAB498)
         DS    0D
LUTEND   DC    XL2'FFFF'
@CB00077 DC    X'4000'
@CB00100 DC    X'2000'
ZEROVLSR DC    X'000000000000'
GRPMSK   DC    240X'FF'
IEFAB4E5 CSECT
         DS   0H
A4E5PTCH DC ((@DATA-@PSTART)/20)X'00'
@DATD    DSECT
         ORG   *+1-(*-@DATD)/(*-@DATD) INSURE DSECT DATA
@ENDDATD EQU   *
IEFAB4E5 CSECT
@00      EQU   00                      EQUATES FOR REGISTERS 0-15
@01      EQU   01
@02      EQU   02
@03      EQU   03
@04      EQU   04
@05      EQU   05
@06      EQU   06
@07      EQU   07
@08      EQU   08
@09      EQU   09
@10      EQU   10
@11      EQU   11
@12      EQU   12
@13      EQU   13
@14      EQU   14
@15      EQU   15
LUTCTR   EQU   @03
UCBPTR   EQU   @02
QMBLKPTR EQU   @06
EDTPTR   EQU   @02
REG1     EQU   @01
REG0     EQU   @00
REG15    EQU   @15
GPR11P   EQU   @11
GPR12P   EQU   @12
GPR13P   EQU   @13
GPR14P   EQU   @14
GPR15P   EQU   @15
GPR00P   EQU   @00
GPR01P   EQU   @01
         EXTRN EDTTAB
CVTPTR   EQU   16
PSA      EQU   0
FLCRNPSW EQU   PSA
FLCROPSW EQU   PSA+8
FLCICCW2 EQU   PSA+16
PSAEEPSW EQU   PSA+132
PSAESPSW EQU   PSA+136
FLCSVILC EQU   PSAESPSW+1
PSAEPPSW EQU   PSA+140
FLCPIILC EQU   PSAEPPSW+1
FLCPICOD EQU   PSAEPPSW+2
PSAPICOD EQU   FLCPICOD+1
FLCTEA   EQU   PSAEPPSW+4
FLCPER   EQU   PSA+152
FLCMCLA  EQU   PSA+168
FLCIOEL  EQU   FLCMCLA+4
FLCIOA   EQU   FLCMCLA+16
FLCFSA   EQU   FLCMCLA+80
PSASUPER EQU   PSA+552
PSASUP1  EQU   PSASUPER
PSASUP2  EQU   PSASUPER+1
PSASUP3  EQU   PSASUPER+2
PSASUP4  EQU   PSASUPER+3
PSACLHT  EQU   PSA+640
PSALKSA  EQU   PSA+696
PSAHLHI  EQU   PSA+760
PSALITA  EQU   PSA+764
PSADSSFL EQU   PSA+836
PSADSSF1 EQU   PSADSSFL
PSADSSF3 EQU   PSADSSFL+2
PSADSSF4 EQU   PSADSSFL+3
PSARSVT  EQU   PSA+896
IOSLUT   EQU   0
QMBLK    EQU   0
QMNXTF   EQU   QMBLK
QMMEMID  EQU   QMBLK+20
QMASID   EQU   QMMEMID+2
QMROOT   EQU   0
MAINF    EQU   QMROOT
CVTMAP   EQU   0
CVTILK2  EQU   CVTMAP+40
CVTDAR   EQU   CVTMAP+72
CVTFLGS1 EQU   CVTDAR
CVTDCB   EQU   CVTMAP+116
CVTIERLC EQU   CVTMAP+144
CVTOPTA  EQU   CVTMAP+182
CVTOPTB  EQU   CVTMAP+183
CVTGTF   EQU   CVTMAP+236
CVTGTFST EQU   CVTGTF
CVTGTFS  EQU   CVTGTFST
CVTSTATE EQU   CVTGTFST
CVTTMODE EQU   CVTGTFST
CVTFORM  EQU   CVTGTFST
CVTAQAVT EQU   CVTMAP+240
CVTTCMFG EQU   CVTAQAVT
CVTVOLM2 EQU   CVTMAP+244
CVTTATA  EQU   CVTVOLM2
CVTTSKS  EQU   CVTTATA
CVTVOLF2 EQU   CVTTSKS
CVTTAT   EQU   CVTTATA+1
CVTATER  EQU   CVTMAP+248
CVTEXT1  EQU   CVTMAP+252
CVTPURG  EQU   CVTMAP+260
CVTQMSG  EQU   CVTMAP+268
CVTDMSR  EQU   CVTMAP+272
CVTRSV37 EQU   CVTDMSR
CVTDMSRF EQU   CVTRSV37
CVTERPV  EQU   CVTMAP+316
CVTINTLA EQU   CVTMAP+320
CVTAPF   EQU   CVTMAP+324
CVTEXT2  EQU   CVTMAP+328
CVTHJES  EQU   CVTMAP+332
CVTPGSIA EQU   CVTMAP+348
CVTA1F1  EQU   CVTMAP+356
CVTSYSK  EQU   CVTMAP+357
CVTVOLM1 EQU   CVTMAP+380
CVTVOLF1 EQU   CVTVOLM1
CVTATMCT EQU   CVTMAP+388
CVTXTNT1 EQU   0
CVTXTNT2 EQU   0
CVTDSSV  EQU   CVTXTNT2
CVTFLGBT EQU   CVTXTNT2+5
CVTQID   EQU   CVTXTNT2+24
CVTRV400 EQU   CVTXTNT2+52
CVTRV409 EQU   CVTXTNT2+53
CVTATCVT EQU   CVTXTNT2+64
CVTRV429 EQU   CVTXTNT2+84
CVTRV438 EQU   CVTXTNT2+85
CVTRV457 EQU   CVTXTNT2+112
CVTRV466 EQU   CVTXTNT2+113
CVTFIX   EQU   0
CVTRELNO EQU   CVTFIX+252
UCB      EQU   0
UCBOB    EQU   0
UCBJBNR  EQU   UCBOB
UCBFL5   EQU   UCBOB+1
UCBAF    EQU   UCBFL5
UCBSTAT  EQU   UCBOB+3
UCBALOC  EQU   UCBSTAT
UCBCHAN  EQU   UCBOB+4
UCBSFLS  EQU   UCBOB+6
UCBFLA   EQU   UCBSFLS
UCBFL1   EQU   UCBFLA
UCBBSY   EQU   UCBFL1
UCBNRY   EQU   UCBFL1
UCBPST   EQU   UCBFL1
UCBCUB   EQU   UCBFL1
UCBFLB   EQU   UCBSFLS+1
UCBCHM   EQU   UCBOB+8
UCBCHM1  EQU   UCBCHM
UCBPTH0  EQU   UCBCHM1
UCBPTH1  EQU   UCBCHM1
UCBWGT   EQU   UCBOB+12
UCBTYP   EQU   UCBOB+16
UCBTBYT1 EQU   UCBTYP
UCB1FEA5 EQU   UCBTBYT1
UCB1FEA6 EQU   UCBTBYT1
UCBTBYT2 EQU   UCBTYP+1
UCB2OPT2 EQU   UCBTBYT2
UCBDUDN1 EQU   UCB2OPT2
UCB2OPT3 EQU   UCBTBYT2
UCBDUDN2 EQU   UCB2OPT3
UCB2OPT4 EQU   UCBTBYT2
UCBRWTAU EQU   UCB2OPT4
UCB2OPT6 EQU   UCBTBYT2
UCB2OPT7 EQU   UCBTBYT2
UCBTBYT3 EQU   UCBTYP+2
UCBDVCLS EQU   UCBTBYT3
UCB3TAPE EQU   UCBDVCLS
UCB3DACC EQU   UCBDVCLS
UCBTBYT4 EQU   UCBTYP+3
UCBEXTPT EQU   UCBOB+20
UCBFLC   EQU   UCBEXTPT
UCBDEV   EQU   UCBOB+24
UCBCMEXT EQU   0
UCBATI   EQU   UCBCMEXT+3
@NM00013 EQU   UCBATI
UCBFLP1  EQU   UCBCMEXT+5
UCBNSRCH EQU   UCBFLP1
UCBASID  EQU   UCBCMEXT+14
UCBMT    EQU   0
UCBOCR   EQU   0
UCB3540X EQU   0
UCBDKBYT EQU   UCB3540X+6
UCB3800X EQU   0
UCBOPTNS EQU   UCB3800X
UCBACTIV EQU   UCB3800X+3
UCBMDRBF EQU   UCB3800X+36
UCBUCS   EQU   0
UCBUCSOP EQU   UCBUCS+4
UCBFCBOP EQU   UCBUCS+5
EDTHDR   EQU   0
EDTLUVSP EQU   EDTHDR
EDTGENSP EQU   EDTHDR+4
EDTGRPSP EQU   EDTHDR+8
EDTUCBSP EQU   EDTHDR+12
EDTMSKTP EQU   EDTHDR+16
LUVSECT  EQU   0
LUVHDR   EQU   LUVSECT
LUVENTRY EQU   0
LUVGMTP  EQU   LUVENTRY+12
LUVFLAGS EQU   LUVENTRY+24
GENSECT  EQU   0
GENHDR   EQU   GENSECT
GENENTRY EQU   0
GRPTRTAB EQU   0
GRPSECT  EQU   0
GRPHDR   EQU   GRPSECT
GRPENTRY EQU   0
GRPUCBP  EQU   GRPENTRY+8
EUCBSECT EQU   0
EUCBHDR  EQU   EUCBSECT
EUCBENTY EQU   0
GRMSKTAB EQU   0
GMTHDR   EQU   GRMSKTAB
GMTENTLN EQU   GMTHDR+4
GMTENTRY EQU   0
AQMPARAM EQU   0
AQMECODE EQU   AQMPARAM
AQMMASKP EQU   AQMPARAM+4
AQMASID  EQU   AQMPARAM+8
AQMLENGT EQU   AQMPARAM+12
AQMNORMP EQU   AQMPARAM+20
AQMQBPTR EQU   AQMPARAM+24
MVCA     EQU   0
MVCAXPTR EQU   MVCA+12
MVCAX    EQU   0
MVSWITCH EQU   MVCAX+4
MTENTRY  EQU   0
MTENBASE EQU   MTENTRY
MTDEVPTR EQU   MTENBASE+12
MTDOMPTR EQU   MTENBASE+16
MTDEVENT EQU   0
MTSTATUS EQU   MTDEVENT
I001C    EQU   0
I008P    EQU   0
I015F    EQU   0
I015P    EQU   0
I031F    EQU   0
I031P    EQU   0
I256C    EQU   0
MTDOMIDS EQU   0
UCBBGN   EQU   0
RMPL     EQU   0
RMPLFLG1 EQU   RMPL
RMPLTERM EQU   RMPLFLG1
RMPLASID EQU   RMPL+2
CVTS01   EQU   CVTPGSIA
CVTLPDIA EQU   CVTS01+12
CVTDIRST EQU   CVTLPDIA
CVTSLIDA EQU   CVTS01+24
CVTCTLFG EQU   CVTS01+50
CVTAQTOP EQU   CVTS01+200
CVTRV210 EQU   CVTS01+424
CVTRV219 EQU   CVTS01+425
CVTRV228 EQU   CVTS01+426
CVTRV237 EQU   CVTS01+427
CVTMFRTR EQU   CVTS01+452
CVTRV262 EQU   CVTS01+468
CVTRV271 EQU   CVTS01+469
CVTRV280 EQU   CVTS01+470
CVTRV289 EQU   CVTS01+471
CVTGSDA  EQU   CVTS01+600
UCBOBS01 EQU   UCBDEV
UCBVOLI  EQU   UCBOBS01+4
UCBSTAB  EQU   UCBOBS01+10
UCBBSVL  EQU   UCBSTAB
UCBPRSRS EQU   UCBSTAB
UCBBPRV  EQU   UCBSTAB
UCBBPUB  EQU   UCBSTAB
UCBBSTR  EQU   UCBSTAB
UCBSHAR  EQU   UCBSTAB
UCBDMCT  EQU   UCBOBS01+11
UCBMOUNT EQU   UCBDMCT
UCBDMC   EQU   UCBDMCT
UCBFL4   EQU   UCBOBS01+13
UCBUSER  EQU   UCBOBS01+14
UCBOBS02 EQU   UCBDEV
UCBTFL1  EQU   UCBOBS02+19
UCBXTN   EQU   UCBOBS02+20
UCBVOPT  EQU   UCBXTN
UCBOBS03 EQU   UCBDEV
UCBXTADR EQU   UCBOBS03
UCBOBS04 EQU   UCBDEV
UCBBTA   EQU   UCBOBS04+12
UCBOBS06 EQU   UCBDEV
UCBAOF   EQU   UCBOBS06
UCBAOF1  EQU   UCBAOF
UCBAOF2  EQU   UCBAOF+1
@NM00012 EQU   UCBOBS06+3
UCBIRB   EQU   UCBOBS06+4
UCBGRAF  EQU   UCBIRB
UCBLDNCA EQU   UCBOBS06+8
UCBRDYQ  EQU   UCBLDNCA
UCBIRLN  EQU   UCBRDYQ
UCBLDNCB EQU   UCBRDYQ+1
UCBCTLNK EQU   UCBOBS06+12
UCBOBS07 EQU   UCBDEV
UCBOBS08 EQU   UCBDEV
UCBCTCAD EQU   UCBOBS08
UCBCTCF1 EQU   UCBOBS08+4
UCBOBS09 EQU   UCBDEV
PSARSVTE EQU   PSARSVT
FLC      EQU   PSA
         AGO   .@UNREFD                START UNREFERENCED COMPONENTS
PSARSAV  EQU   PSARSVTE+60
PSARSTK  EQU   PSARSVTE+56
PSAESAV3 EQU   PSARSVTE+52
PSAESTK3 EQU   PSARSVTE+48
PSAESAV2 EQU   PSARSVTE+44
PSAESTK2 EQU   PSARSVTE+40
PSAESAV1 EQU   PSARSVTE+36
PSAESTK1 EQU   PSARSVTE+32
PSAPSAV  EQU   PSARSVTE+28
PSAPSTK  EQU   PSARSVTE+24
PSAMSAV  EQU   PSARSVTE+20
PSAMSTK  EQU   PSARSVTE+16
PSASSAV  EQU   PSARSVTE+12
PSASSTK  EQU   PSARSVTE+8
PSANSTK  EQU   PSARSVTE+4
PSACSTK  EQU   PSARSVTE
UCBRV066 EQU   UCBOBS09+4
UCBIOSBA EQU   UCBOBS09
UCBRV042 EQU   UCBOBS08+5
UCBRV082 EQU   UCBCTCF1
UCBRV081 EQU   UCBCTCF1
UCBRV080 EQU   UCBCTCF1
UCBRV079 EQU   UCBCTCF1
UCBRV078 EQU   UCBCTCF1
UCBRV077 EQU   UCBCTCF1
UCBRV076 EQU   UCBCTCF1
UCBCTC80 EQU   UCBCTCF1
UCBCTCAL EQU   UCBCTCAD
UCBICNCB EQU   UCBOBS07+4
UCBRV040 EQU   UCBOBS07
UCBCTLNA EQU   UCBCTLNK+1
UCBRLN   EQU   UCBCTLNK
UCBRDYQA EQU   UCBLDNCB
UCBINRLN EQU   UCBIRLN
UCBIRBA  EQU   UCBIRB+1
UCBRV039 EQU   UCBGRAF
UCBDWNR  EQU   UCBGRAF
UCBRPND  EQU   UCBGRAF
UCBUPM   EQU   UCBGRAF
UCBBTAM  EQU   UCBGRAF
UCBDRNO  EQU   UCBGRAF
UCBDRO   EQU   UCBGRAF
UCBOIP   EQU   UCBGRAF
UCBATRCD EQU   @NM00012
UCBSKPFG EQU   @NM00012
UCBRIPND EQU   @NM00012
UCBRTIAC EQU   @NM00012
UCBRSV79 EQU   @NM00012
UCBRSV78 EQU   @NM00012
UCBRSV77 EQU   @NM00012
UCBOLTEP EQU   @NM00012
UCBATNCT EQU   UCBOBS06+2
UCBRSV76 EQU   UCBAOF2
UCBRSV75 EQU   UCBAOF2
UCBRSV74 EQU   UCBAOF2
UCBRSV73 EQU   UCBAOF2
UCBRSV72 EQU   UCBAOF2
UCBRSV71 EQU   UCBAOF2
UCBRSV70 EQU   UCBAOF2
UCBRSV69 EQU   UCBAOF2
UCBRSV68 EQU   UCBAOF1
UCBRSV67 EQU   UCBAOF1
UCBRSV66 EQU   UCBAOF1
UCBRSV65 EQU   UCBAOF1
UCBRSV64 EQU   UCBAOF1
UCBOFNL  EQU   UCBAOF1
UCBOFSP  EQU   UCBAOF1
UCBOFMCR EQU   UCBAOF1
UCBBTB   EQU   UCBBTA+1
UCBDI    EQU   UCBBTA
UCBSNS   EQU   UCBOBS04+8
UCBTEB   EQU   UCBOBS04+4
UCBGCB   EQU   UCBOBS04+3
UCBOPEN  EQU   UCBOBS04+2
UCBSTART EQU   UCBOBS04
UCBXTNB  EQU   UCBXTN+1
UCBRSV22 EQU   UCBVOPT
UCBRSV21 EQU   UCBVOPT
UCBRSV20 EQU   UCBVOPT
UCBESVE  EQU   UCBVOPT
UCBERPC  EQU   UCBVOPT
UCBESVC  EQU   UCBVOPT
UCBEVA   EQU   UCBVOPT
UCBESV   EQU   UCBVOPT
UCBRV009 EQU   UCBTFL1
UCBRV008 EQU   UCBTFL1
UCBRV007 EQU   UCBTFL1
UCBRV006 EQU   UCBTFL1
UCBRV005 EQU   UCBTFL1
UCBRV038 EQU   UCBTFL1
UCBNSLTP EQU   UCBTFL1
UCBNLTP  EQU   UCBTFL1
UCBRES1B EQU   UCBOBS02+18
UCBFSER  EQU   UCBOBS02+12
@NM00011 EQU   UCBOBS02+4
UCBFSEQ  EQU   UCBOBS02+2
UCBFSCT  EQU   UCBOBS02
UCBNEXP  EQU   UCBOBS01+20
UCBBASE  EQU   UCBOBS01+16
UCBRES1A EQU   UCBOBS01+15
UCBFL47  EQU   UCBFL4
UCBFL46  EQU   UCBFL4
UCBFL45  EQU   UCBFL4
UCBRV065 EQU   UCBFL4
UCBDSS   EQU   UCBFL4
UCBRESVP EQU   UCBFL4
UCBWDAV  EQU   UCBFL4
UCBDAVV  EQU   UCBFL4
UCBSQC   EQU   UCBOBS01+12
UCBDATP  EQU   UCBOBS01+12
UCBBNUL  EQU   UCBSTAB
UCBBALB  EQU   UCBPRSRS
UCBPGFL  EQU   UCBSTAB
UCBDVSHR EQU   UCBBSVL
UCBVTOC  EQU   UCBOBS01
CVTRV628 EQU   CVTS01+728
CVTRV627 EQU   CVTS01+724
CVTRV626 EQU   CVTS01+720
CVTRV625 EQU   CVTS01+716
CVTRV624 EQU   CVTS01+712
CVTRV623 EQU   CVTS01+708
CVTRV622 EQU   CVTS01+704
CVTRV621 EQU   CVTS01+700
CVTIHASU EQU   CVTS01+696
CVTRV619 EQU   CVTS01+692
CVTRV618 EQU   CVTS01+688
CVTRV617 EQU   CVTS01+684
CVTRV616 EQU   CVTS01+680
CVTRV615 EQU   CVTS01+676
CVTRV614 EQU   CVTS01+672
CVTRV613 EQU   CVTS01+668
CVTTCASP EQU   CVTS01+664
CVT0PT03 EQU   CVTS01+660
CVT0PT0E EQU   CVTS01+656
CVTRV609 EQU   CVTS01+652
CVTCGK   EQU   CVTS01+648
CVTRAC   EQU   CVTS01+644
CVTRV606 EQU   CVTS01+640
CVTRV605 EQU   CVTS01+636
CVTRV604 EQU   CVTS01+632
CVTEFF02 EQU   CVTS01+628
CVTCBBR  EQU   CVTS01+624
CVTSSCR  EQU   CVTS01+620
CVTEVENT EQU   CVTS01+616
CVTCRCA  EQU   CVTS01+612
CVTTPIO  EQU   CVTS01+608
CVTADV   EQU   CVTS01+604
CVTGSDAB EQU   CVTGSDA
CVTQV3   EQU   CVTS01+596
CVTQV2   EQU   CVTS01+592
CVTQV1   EQU   CVTS01+588
CVTRPT   EQU   CVTS01+584
CVTSSRB  EQU   CVTS01+580
CVTCSDRL EQU   CVTS01+576
CVTEXP1  EQU   CVTS01+572
CVTRMPMT EQU   CVTS01+568
CVTRMPTT EQU   CVTS01+564
CVTVPSA  EQU   CVTS01+560
CVTVSTOP EQU   CVTS01+556
CVTGTFR8 EQU   CVTS01+552
CVTQUIT  EQU   CVTS01+548
CVTVACR  EQU   CVTS01+544
CVTWTCB  EQU   CVTS01+540
CVTSTPRS EQU   CVTS01+536
CVT0PT02 EQU   CVTS01+532
CVTDARCM EQU   CVTS01+528
CVTIRECM EQU   CVTS01+524
CVTJRECM EQU   CVTS01+520
CVTVEMS0 EQU   CVTS01+516
CVTSPFRR EQU   CVTS01+512
CVTRLSTG EQU   CVTS01+508
CVT0TC0A EQU   CVTS01+504
CVTGMBR  EQU   CVTS01+500
CVTLFRM  EQU   CVTS01+496
CVTRMBR  EQU   CVTS01+492
CVTVIOP  EQU   CVTS01+488
CVTRV307 EQU   CVTS01+486
CVTRV306 EQU   CVTS01+484
CVTRV305 EQU   CVTS01+482
CVTRV304 EQU   CVTS01+480
CVTRV303 EQU   CVTS01+478
CVTRV302 EQU   CVTS01+476
CVTTRCA  EQU   CVTS01+472
CVTRV297 EQU   CVTRV289
CVTRV296 EQU   CVTRV289
CVTRV295 EQU   CVTRV289
CVTRV294 EQU   CVTRV289
CVTRV293 EQU   CVTRV289
CVTRV292 EQU   CVTRV289
CVTRV291 EQU   CVTRV289
CVTRV290 EQU   CVTRV289
CVTRV288 EQU   CVTRV280
CVTRV287 EQU   CVTRV280
CVTRV286 EQU   CVTRV280
CVTRV285 EQU   CVTRV280
CVTRV284 EQU   CVTRV280
CVTRV283 EQU   CVTRV280
CVTRV282 EQU   CVTRV280
CVTRV281 EQU   CVTRV280
CVTRV279 EQU   CVTRV271
CVTRV278 EQU   CVTRV271
CVTRV277 EQU   CVTRV271
CVTRV276 EQU   CVTRV271
CVTRV275 EQU   CVTRV271
CVTRV274 EQU   CVTRV271
CVTRV273 EQU   CVTRV271
CVTRV272 EQU   CVTRV271
CVTRV270 EQU   CVTRV262
CVTRV269 EQU   CVTRV262
CVTRV268 EQU   CVTRV262
CVTRV267 EQU   CVTRV262
CVTRV266 EQU   CVTRV262
CVTRV265 EQU   CVTRV262
CVTRV264 EQU   CVTRV262
CVTRV263 EQU   CVTRV262
CVTVFP   EQU   CVTS01+464
CVTVSI   EQU   CVTS01+460
CVTVPSIB EQU   CVTS01+456
CVTMFACT EQU   CVTMFRTR
CVTMFCTL EQU   CVTS01+448
CVTPVBP  EQU   CVTS01+444
CVTPWI   EQU   CVTS01+440
CVTRV254 EQU   CVTS01+438
CVTRV253 EQU   CVTS01+436
CVTRV252 EQU   CVTS01+434
CVTRV251 EQU   CVTS01+433
CVTRV250 EQU   CVTS01+432
CVTRV249 EQU   CVTS01+431
CVTRV248 EQU   CVTS01+430
CVTRV247 EQU   CVTS01+429
CVTRV246 EQU   CVTS01+428
CVTRV245 EQU   CVTRV237
CVTRV244 EQU   CVTRV237
CVTRV243 EQU   CVTRV237
CVTRV242 EQU   CVTRV237
CVTRV241 EQU   CVTRV237
CVTRV240 EQU   CVTRV237
CVTRV239 EQU   CVTRV237
CVTRV238 EQU   CVTRV237
CVTRV236 EQU   CVTRV228
CVTRV235 EQU   CVTRV228
CVTRV234 EQU   CVTRV228
CVTRV233 EQU   CVTRV228
CVTRV232 EQU   CVTRV228
CVTRV231 EQU   CVTRV228
CVTRV230 EQU   CVTRV228
CVTRV229 EQU   CVTRV228
CVTRV227 EQU   CVTRV219
CVTRV226 EQU   CVTRV219
CVTRV225 EQU   CVTRV219
CVTRV224 EQU   CVTRV219
CVTRV223 EQU   CVTRV219
CVTRV222 EQU   CVTRV219
CVTRV221 EQU   CVTRV219
CVTRV220 EQU   CVTRV219
CVTRV218 EQU   CVTRV210
CVTRV217 EQU   CVTRV210
CVTRV216 EQU   CVTRV210
CVTRV215 EQU   CVTRV210
CVTRV214 EQU   CVTRV210
CVTRV213 EQU   CVTRV210
CVTRV212 EQU   CVTRV210
CVTRV211 EQU   CVTRV210
CVTLCCAT EQU   CVTS01+420
CVTPCCAT EQU   CVTS01+416
CVTIPCRP EQU   CVTS01+412
CVTIPCRI EQU   CVTS01+408
CVTIPCDS EQU   CVTS01+404
CVTAIDVT EQU   CVTS01+400
CVTSSAP  EQU   CVTS01+396
CVTEHCIR EQU   CVTS01+392
CVTEHDEF EQU   CVTS01+388
CVTDAIR  EQU   CVTS01+384
CVTPERFM EQU   CVTS01+380
CVT044R2 EQU   CVTS01+376
CVTFETCH EQU   CVTS01+372
CVTRSTWD EQU   CVTS01+368
CVTSPOST EQU   CVTS01+364
CVTIOBP  EQU   CVTS01+360
CVTASMVT EQU   CVTS01+356
CVTRECRQ EQU   CVTS01+352
CVTWSAC  EQU   CVTS01+348
CVTRV149 EQU   CVTS01+344
CVTWSAL  EQU   CVTS01+340
CVTSPSA  EQU   CVTS01+336
CVTGLMN  EQU   CVTS01+332
CVTVEAC0 EQU   CVTS01+328
CVT062R1 EQU   CVTS01+324
CVTRPOST EQU   CVTS01+320
CVTDQIQE EQU   CVTS01+316
CVTCSD   EQU   CVTS01+312
CVTLKRMA EQU   CVTS01+308
CVTRSPIE EQU   CVTS01+304
CVTRENQ  EQU   CVTS01+300
CVTLQCB  EQU   CVTS01+296
CVTFQCB  EQU   CVTS01+292
CVTQCS01 EQU   CVTS01+288
CVTAPFT  EQU   CVTS01+284
CVTPARRL EQU   CVTS01+280
CVTVWAIT EQU   CVTS01+276
CVTGSPL  EQU   CVTS01+272
CVTLSMQ  EQU   CVTS01+268
CVTGSMQ  EQU   CVTS01+264
CVTEXPRO EQU   CVTS01+260
CVTOPCTP EQU   CVTS01+256
CVTSIC   EQU   CVTS01+252
CVTTPIOS EQU   CVTS01+248
CVTRTMS  EQU   CVTS01+244
CVTSDBF  EQU   CVTS01+240
CVTSCBP  EQU   CVTS01+236
CVTSDMP  EQU   CVTS01+232
CVTSV60  EQU   CVTS01+228
CVTRTMCT EQU   CVTS01+224
CVTASCBL EQU   CVTS01+220
CVTASCBH EQU   CVTS01+216
CVTGDA   EQU   CVTS01+212
CVTASVT  EQU   CVTS01+208
CVTVVMDI EQU   CVTS01+204
CVTIOSCS EQU   CVTS01+196
CVTSDRM  EQU   CVTS01+192
CVTOPTE  EQU   CVTS01+188
CVTSTXU  EQU   CVTS01+184
CVTQUIS  EQU   CVTS01+180
CVTPARS  EQU   CVTS01+176
CVTS1EE  EQU   CVTS01+172
CVTFRAS  EQU   CVTS01+168
CVTQSAS  EQU   CVTS01+164
CVTCRAS  EQU   CVTS01+160
CVTCRMN  EQU   CVTS01+156
CVTDELCP EQU   CVTS01+152
CVTFRECL EQU   CVTS01+148
CVTGETCL EQU   CVTS01+144
CVTBLDCP EQU   CVTS01+140
CVTAUTHL EQU   CVTS01+136
CVTSCAN  EQU   CVTS01+132
CVTRV144 EQU   CVTS01+130
CVTMAXMP EQU   CVTS01+128
CVTSTCK  EQU   CVTS01+124
CVTRV139 EQU   CVTS01+123
CVTDSSAC EQU   CVTS01+122
CVTRV513 EQU   CVTS01+121
CVTIOSPL EQU   CVTS01+120
CVTPTGT  EQU   CVTS01+116
CVTCSPIE EQU   CVTS01+112
CVTSMFEX EQU   CVTS01+108
CVTOLT0A EQU   CVTS01+104
CVTSRBRT EQU   CVTS01+100
CVTPUTL  EQU   CVTS01+96
CVTASCRL EQU   CVTS01+92
CVTASCRF EQU   CVTS01+88
CVTRV326 EQU   CVTS01+84
CVTRV325 EQU   CVTS01+80
CVTRV324 EQU   CVTS01+76
CVT0VL01 EQU   CVTS01+72
CVTSHRVM EQU   CVTS01+68
CVTRV332 EQU   CVTS01+64
CVTTAS   EQU   CVTS01+60
CVTRSCN  EQU   CVTS01+56
CVTTRAC2 EQU   CVTS01+54
CVTTRACE EQU   CVTS01+52
CVTAPG   EQU   CVTS01+51
CVTSDTRC EQU   CVTCTLFG
CVTGTRCE EQU   CVTCTLFG
CVTNOMP  EQU   CVTCTLFG
CVTRSV79 EQU   CVTCTLFG
CVTDSTAT EQU   CVTCTLFG
CVTRSV78 EQU   CVTCTLFG
CVTRV333 EQU   CVTCTLFG
CVTRV323 EQU   CVTCTLFG
CVTSPVLK EQU   CVTS01+49
CVTRSV77 EQU   CVTS01+48
CVTRV331 EQU   CVTS01+44
CVTRV330 EQU   CVTS01+40
CVTRV329 EQU   CVTS01+36
CVTRV328 EQU   CVTS01+32
CVTRV322 EQU   CVTS01+28
CVTSLID  EQU   CVTSLIDA+1
CVTSYLK  EQU   CVTSLIDA
CVTRV321 EQU   CVTS01+20
CVTRV320 EQU   CVTS01+16
CVTLPDIR EQU   CVTLPDIA+1
CVTRSV69 EQU   CVTDIRST
CVTRSV68 EQU   CVTDIRST
CVTRSV67 EQU   CVTDIRST
CVTRSV66 EQU   CVTDIRST
CVTRSV65 EQU   CVTDIRST
CVTRSV64 EQU   CVTDIRST
CVTRSV63 EQU   CVTDIRST
CVTDICOM EQU   CVTDIRST
CVTPVTP  EQU   CVTS01+8
CVTLPDSR EQU   CVTS01+4
CVTGETL  EQU   CVTS01
RMPLDCBL EQU   RMPL+20
RMPLRMWA EQU   RMPL+16
RMPLRBPA EQU   RMPL+12
RMPLTCBA EQU   RMPL+8
RMPLASCB EQU   RMPL+4
RMPLFLG2 EQU   RMPL+1
@NM00041 EQU   RMPLFLG1
RMPLWT1M EQU   RMPLFLG1
RMPLJST  EQU   RMPLFLG1
RMPLRCOV EQU   RMPLFLG1
RMPLIPUF EQU   RMPLFLG1
RMPLRBPP EQU   RMPLFLG1
RMPLTYPE EQU   RMPLFLG1
MTDVUPTR EQU   MTDEVENT+9
MTSAVNDX EQU   MTDEVENT+8
MTDSNMP  EQU   MTDEVENT+4
MTUCBPTR EQU   MTDEVENT+1
MTVRSVRD EQU   MTSTATUS
MTVRYVFY EQU   MTSTATUS
MTVRYLBL EQU   MTSTATUS
MTVRYPND EQU   MTSTATUS
MTNXTPTR EQU   MTENBASE+8
MTPRVPTR EQU   MTENBASE+4
@NM00016 EQU   MTENBASE+2
MTLENGTH EQU   MTENBASE
MVTPECB  EQU   MVCAX+20
MVDAECB  EQU   MVCAX+16
MVNODEVE EQU   MVCAX+14
MVWTORRA EQU   MVCAX+12
MVENTRYP EQU   MVCAX+8
MVNUMWTS EQU   MVCAX+6
MVWTORSW EQU   MVSWITCH
MVDISDSN EQU   MVSWITCH
MVDEVECB EQU   MVCAX
MVCANXTP EQU   MVCA+8
MVCAPRVP EQU   MVCA+4
MVCAASID EQU   MVCA+2
@NM00015 EQU   MVCA
AQMPFLG  EQU   AQMNORMP
AQMCANCP EQU   AQMPARAM+16
AQMQCODE EQU   AQMPARAM+2
GRPMASK  EQU   GMTENTRY
GMTENTNO EQU   GMTHDR
EUCBTPOS EQU   EUCBENTY
EUCBENLN EQU   EUCBHDR+4
EUCBENNO EQU   EUCBHDR
GRPUCBNO EQU   GRPENTRY+4
GRPID    EQU   GRPENTRY
GRPENTLN EQU   GRPHDR+4
GRPENTNO EQU   GRPHDR
GRPTR    EQU   GRPTRTAB
GENGRPTR EQU   GENENTRY+8
GENGRPNO EQU   GENENTRY+4
GENDEVT  EQU   GENENTRY
GENENTLN EQU   GENHDR+4
GENENTNO EQU   GENHDR
LUVAGMTP EQU   LUVENTRY+28
@NM00014 EQU   LUVFLAGS
LUVMGENS EQU   LUVFLAGS
LUVAGMSK EQU   LUVFLAGS
LUVVAM   EQU   LUVFLAGS
LUVGENP  EQU   LUVENTRY+20
LUVGENNO EQU   LUVENTRY+16
LUVALUE  EQU   LUVENTRY+8
UNITNAME EQU   LUVENTRY
LUVENTLN EQU   LUVHDR+4
LUVENTNO EQU   LUVHDR
UCBERADR EQU   UCBUCS+12
UCBFCBID EQU   UCBUCS+8
UCBERCNT EQU   UCBUCS+7
UCBRSV51 EQU   UCBUCS+6
UCBRSV50 EQU   UCBFCBOP
UCBRSV49 EQU   UCBFCBOP
UCBRSV48 EQU   UCBFCBOP
UCBRSV47 EQU   UCBFCBOP
UCBRSV46 EQU   UCBFCBOP
UCBRSV45 EQU   UCBFCBOP
UCBRSV44 EQU   UCBFCBOP
UCBFCBO1 EQU   UCBFCBOP
UCBUCSPE EQU   UCBUCSOP
UCBRSV43 EQU   UCBUCSOP
UCBRSV42 EQU   UCBUCSOP
UCBRSV41 EQU   UCBUCSOP
UCBRSV40 EQU   UCBUCSOP
UCBRSV39 EQU   UCBUCSOP
UCBUCSO2 EQU   UCBUCSOP
UCBUCSO1 EQU   UCBUCSOP
UCBUCSID EQU   UCBUCS
UCBMDRBA EQU   UCBMDRBF+1
UCBRV075 EQU   UCBMDRBF
UCBRV074 EQU   UCB3800X+32
UCBIMAGE EQU   UCB3800X+28
UCBFCBNM EQU   UCB3800X+24
UCBCHAR4 EQU   UCB3800X+20
UCBCHAR3 EQU   UCB3800X+16
UCBCHAR2 EQU   UCB3800X+12
UCBCHAR1 EQU   UCB3800X+8
UCBCGMID EQU   UCB3800X+4
UCBBRSTA EQU   UCBACTIV
UCBRV063 EQU   UCBACTIV
UCBRV062 EQU   UCBACTIV
UCBRV061 EQU   UCBACTIV
UCBRV060 EQU   UCBACTIV
UCBRV059 EQU   UCBACTIV
UCBRV058 EQU   UCBACTIV
UCBRV057 EQU   UCBACTIV
UCBRV050 EQU   UCB3800X+2
UCBCGMNO EQU   UCB3800X+1
UCBRV083 EQU   UCBOPTNS
UCBBRSTR EQU   UCBOPTNS
UCBRV056 EQU   UCBOPTNS
UCBRV055 EQU   UCBOPTNS
UCBRV054 EQU   UCBOPTNS
UCBRV053 EQU   UCBOPTNS
UCBRV052 EQU   UCBOPTNS
UCBRV051 EQU   UCBOPTNS
UCBRV073 EQU   UCB3540X+7
UCBRV072 EQU   UCBDKBYT
UCBRV071 EQU   UCBDKBYT
UCBRV070 EQU   UCBDKBYT
UCBRV069 EQU   UCBDKBYT
UCBRV068 EQU   UCBDKBYT
UCBRV067 EQU   UCBDKBYT
UCBVLVER EQU   UCBDKBYT
UCBDKAMX EQU   UCBDKBYT
UCBVLSER EQU   UCB3540X
UCBRDATA EQU   UCBOCR+4
UCBFRID  EQU   UCBOCR
UCBCLN   EQU   UCBMT+14
UCBERG   EQU   UCBMT+12
UCBMS    EQU   UCBMT+11
UCBNB    EQU   UCBMT+10
UCBPW    EQU   UCBMT+9
UCBPR    EQU   UCBMT+8
UCBSIO   EQU   UCBMT+6
UCBTW    EQU   UCBMT+5
UCBTR    EQU   UCBMT+4
UCBTWT   EQU   UCBMT+3
UCBTRT   EQU   UCBMT+2
UCBCTD   EQU   UCBMT
UCBWTOID EQU   UCBCMEXT+17
UCBRV043 EQU   UCBCMEXT+16
UCBMFCNT EQU   UCBCMEXT+12
UCBPMSK  EQU   UCBCMEXT+10
UCBCCWOF EQU   UCBCMEXT+8
UCBRV041 EQU   UCBCMEXT+6
UCBRV036 EQU   UCBFLP1
UCBRV035 EQU   UCBFLP1
UCBERLOG EQU   UCBFLP1
UCBRV033 EQU   UCBFLP1
UCBRV032 EQU   UCBFLP1
UCBRV031 EQU   UCBFLP1
UCBSHRUP EQU   UCBFLP1
UCBSNSCT EQU   UCBCMEXT+4
UCBHPDV  EQU   @NM00013
UCBHALI  EQU   @NM00013
UCBRSV09 EQU   @NM00013
UCBRSV08 EQU   @NM00013
UCBRSV07 EQU   @NM00013
UCBRSV06 EQU   @NM00013
UCBRSV05 EQU   @NM00013
UCBRSV04 EQU   @NM00013
UCBDTI   EQU   UCBCMEXT+2
UCBSTI   EQU   UCBCMEXT+1
UCBETI   EQU   UCBCMEXT
UCBEXTP  EQU   UCBEXTPT+1
UCBDDRSW EQU   UCBFLC
UCBTICBT EQU   UCBFLC
UCBIVRR  EQU   UCBFLC
UCBIVRS  EQU   UCBFLC
UCBITF   EQU   UCBFLC
UCBUDE   EQU   UCBFLC
UCBWAA   EQU   UCBFLC
UCBATTP  EQU   UCBFLC
UCBUNTYP EQU   UCBTBYT4
UCBRSV11 EQU   UCBDVCLS
UCBRSV10 EQU   UCBDVCLS
UCB3CHAR EQU   UCBDVCLS
UCB3UREC EQU   UCBDVCLS
UCB3DISP EQU   UCBDVCLS
UCB3COMM EQU   UCBDVCLS
UCBDVPWR EQU   UCB2OPT7
UCBVLPWR EQU   UCB2OPT6
UCB2OPT5 EQU   UCBTBYT2
UCBRVDEV EQU   UCBRWTAU
UCBRPS   EQU   UCBDUDN2
UCBRR    EQU   UCBDUDN1
UCB2OPT1 EQU   UCBTBYT2
UCB2OPT0 EQU   UCBTBYT2
UCB1FEA7 EQU   UCBTBYT1
UCBD6250 EQU   UCB1FEA6
UCBD1600 EQU   UCB1FEA5
UCB1FEA4 EQU   UCBTBYT1
UCB1FEA3 EQU   UCBTBYT1
UCB1FEA2 EQU   UCBTBYT1
UCB1FEA1 EQU   UCBTBYT1
UCB1FEA0 EQU   UCBTBYT1
UCBNAME  EQU   UCBOB+13
UCBRV029 EQU   UCBWGT
UCBVHRSN EQU   UCBWGT
UCBVORSN EQU   UCBWGT
UCBMTPXP EQU   UCBWGT
UCBREW   EQU   UCBWGT
UCBPUB   EQU   UCBWGT
UCBOUT   EQU   UCBWGT
UCBIN    EQU   UCBWGT
UCBCPU   EQU   UCBOB+11
UCBLCI   EQU   UCBOB+10
UCBCNT   EQU   UCBOB+9
UCBRV017 EQU   UCBCHM1
UCBRV016 EQU   UCBCHM1
UCBRV015 EQU   UCBCHM1
UCBRV014 EQU   UCBCHM1
UCBSPB   EQU   UCBPTH1
UCBPPB   EQU   UCBPTH1
UCBSPA   EQU   UCBPTH0
UCBPPA   EQU   UCBPTH0
UCBSIGP  EQU   UCBFLB
UCBVALPH EQU   UCBFLB
UCBCRHSN EQU   UCBFLB
UCBCRHRV EQU   UCBFLB
UCBRESVH EQU   UCBFLB
UCBSPST  EQU   UCBFLB
UCBASNS  EQU   UCBFLB
UCBIORST EQU   UCBFLB
UCBQISCE EQU   UCBFL1
UCBACTV  EQU   UCBFL1
UCBSAP   EQU   UCBFL1
UCBNOTRC EQU   UCBCUB
UCBPSNS  EQU   UCBFL1
UCBUSING EQU   UCBPST
UCBNOTRD EQU   UCBNRY
UCBBUSYD EQU   UCBBSY
UCBUA    EQU   UCBCHAN+1
UCBCHA   EQU   UCBCHAN
UCBDADI  EQU   UCBSTAT
UCBSYSR  EQU   UCBSTAT
UCBPRES  EQU   UCBSTAT
UCBUNLD  EQU   UCBSTAT
UCBRESV  EQU   UCBSTAT
UCBCHGS  EQU   UCBSTAT
UCBONLI  EQU   UCBSTAT
UCBID    EQU   UCBOB+2
UCBALTPH EQU   UCBFL5
UCBALTCU EQU   UCBFL5
UCBNALOC EQU   UCBFL5
UCBENVRD EQU   UCBFL5
UCBVSDR  EQU   UCBFL5
UCBSASK  EQU   UCBFL5
UCBAMV   EQU   UCBAF
UCBDCC   EQU   UCBFL5
UCBMONT  EQU   UCBJBNR
UCBRV011 EQU   UCBJBNR
UCBMMSGP EQU   UCBJBNR
UCBOLDSM EQU   UCBJBNR
UCBRV003 EQU   UCBJBNR
UCBDUC   EQU   UCBJBNR
UCBJES3  EQU   UCBJBNR
UCBVRDEV EQU   UCBJBNR
UCBCMSEG EQU   UCBOB
UCBPFXND EQU   UCB+512
UCBIOQ   EQU   UCB+508
UCBLOCK  EQU   UCB+504
UCBPXST  EQU   UCB+504
@NM00010 EQU   UCB
CVTLEVL  EQU   CVTRELNO+2
CVTNUMB  EQU   CVTRELNO
CVTMDL   EQU   CVTFIX+250
@NM00009 EQU   CVTFIX+248
@NM00008 EQU   CVTFIX
CVTRV482 EQU   CVTXTNT2+128
CVTRV481 EQU   CVTXTNT2+124
CVTRV480 EQU   CVTXTNT2+120
CVTRV479 EQU   CVTXTNT2+118
CVTRV478 EQU   CVTXTNT2+117
CVTRV477 EQU   CVTXTNT2+116
CVTRV476 EQU   CVTXTNT2+115
CVTRV475 EQU   CVTXTNT2+114
CVTRV474 EQU   CVTRV466
CVTRV473 EQU   CVTRV466
CVTRV472 EQU   CVTRV466
CVTRV471 EQU   CVTRV466
CVTRV470 EQU   CVTRV466
CVTRV469 EQU   CVTRV466
CVTRV468 EQU   CVTRV466
CVTRV467 EQU   CVTRV466
CVTRV465 EQU   CVTRV457
CVTRV464 EQU   CVTRV457
CVTRV463 EQU   CVTRV457
CVTRV462 EQU   CVTRV457
CVTRV461 EQU   CVTRV457
CVTRV460 EQU   CVTRV457
CVTRV459 EQU   CVTRV457
CVTRV458 EQU   CVTRV457
CVTRV456 EQU   CVTXTNT2+108
CVTRV455 EQU   CVTXTNT2+104
CVTRV454 EQU   CVTXTNT2+100
CVTRV453 EQU   CVTXTNT2+96
CVTRV452 EQU   CVTXTNT2+94
CVTRV451 EQU   CVTXTNT2+92
CVTRV450 EQU   CVTXTNT2+90
CVTRV449 EQU   CVTXTNT2+88
CVTRV448 EQU   CVTXTNT2+87
CVTRV447 EQU   CVTXTNT2+86
CVTRV446 EQU   CVTRV438
CVTRV445 EQU   CVTRV438
CVTRV444 EQU   CVTRV438
CVTRV443 EQU   CVTRV438
CVTRV442 EQU   CVTRV438
CVTRV441 EQU   CVTRV438
CVTRV440 EQU   CVTRV438
CVTRV439 EQU   CVTRV438
CVTRV437 EQU   CVTRV429
CVTRV436 EQU   CVTRV429
CVTRV435 EQU   CVTRV429
CVTRV434 EQU   CVTRV429
CVTRV433 EQU   CVTRV429
CVTRV432 EQU   CVTRV429
CVTRV431 EQU   CVTRV429
CVTRV430 EQU   CVTRV429
CVTRV428 EQU   CVTXTNT2+80
CVTRV427 EQU   CVTXTNT2+76
CVTRV426 EQU   CVTXTNT2+72
CVTRV425 EQU   CVTXTNT2+68
CVTATACT EQU   CVTATCVT
CVTRV423 EQU   CVTXTNT2+62
CVTRV422 EQU   CVTXTNT2+60
CVTRV421 EQU   CVTXTNT2+58
CVTRV420 EQU   CVTXTNT2+56
CVTRV419 EQU   CVTXTNT2+55
CVTRV418 EQU   CVTXTNT2+54
CVTRV417 EQU   CVTRV409
CVTRV416 EQU   CVTRV409
CVTRV415 EQU   CVTRV409
CVTRV414 EQU   CVTRV409
CVTRV413 EQU   CVTRV409
CVTRV412 EQU   CVTRV409
CVTRV411 EQU   CVTRV409
CVTRV410 EQU   CVTRV409
CVTRV408 EQU   CVTRV400
CVTRV407 EQU   CVTRV400
CVTRV406 EQU   CVTRV400
CVTRV405 EQU   CVTRV400
CVTRV404 EQU   CVTRV400
CVTRV403 EQU   CVTRV400
CVTRV402 EQU   CVTRV400
CVTRV401 EQU   CVTRV400
CVTICB   EQU   CVTXTNT2+48
CVTSKTA  EQU   CVTXTNT2+44
CVTRSV99 EQU   CVTXTNT2+40
CVTRSV98 EQU   CVTXTNT2+36
CVTRSV97 EQU   CVTXTNT2+34
CVTRSV96 EQU   CVTXTNT2+32
CVTOLTEP EQU   CVTXTNT2+28
CVTQIDA  EQU   CVTQID+1
CVTRSV95 EQU   CVTQID
CVTRSV94 EQU   CVTXTNT2+20
CVTRSV93 EQU   CVTXTNT2+16
CVTRSV92 EQU   CVTXTNT2+12
CVTDEBVR EQU   CVTXTNT2+8
CVTRSV91 EQU   CVTXTNT2+6
CVTRSV9H EQU   CVTFLGBT
CVTRSV9G EQU   CVTFLGBT
CVTRSV9F EQU   CVTFLGBT
CVTRSV9E EQU   CVTFLGBT
CVTRSV9D EQU   CVTFLGBT
CVTRSV9C EQU   CVTFLGBT
CVTVME   EQU   CVTFLGBT
CVTNPE   EQU   CVTFLGBT
CVTNUCLS EQU   CVTXTNT2+4
CVTDSSVA EQU   CVTDSSV+1
CVTRSV89 EQU   CVTDSSV
CVTRSV88 EQU   CVTXTNT1+8
CVTRSV87 EQU   CVTXTNT1+4
CVTFACHN EQU   CVTXTNT1
CVTRV488 EQU   CVTMAP+412
CVTRV487 EQU   CVTMAP+408
CVTRV486 EQU   CVTMAP+404
CVTRV485 EQU   CVTMAP+400
CVTACTAP EQU   CVTMAP+396
CVTAUTH  EQU   CVTMAP+392
CVTATMCA EQU   CVTATMCT+1
CVTATMST EQU   CVTATMCT
CVTRSV61 EQU   CVTMAP+384
CVTVOLT1 EQU   CVTVOLM1+1
CVTVOLI1 EQU   CVTVOLF1
CVTSTOA  EQU   CVTMAP+376
CVTRSV58 EQU   CVTMAP+374
CVTRSV57 EQU   CVTMAP+372
CVTDDCE  EQU   CVTMAP+368
CVTPNWFR EQU   CVTMAP+364
CVTSMF   EQU   CVTMAP+360
CVTSULK  EQU   CVTMAP+358
CVTSLKO  EQU   CVTSYSK
CVTSLKP  EQU   CVTSYSK
CVTSLKQ  EQU   CVTSYSK
CVTSLKR  EQU   CVTSYSK
CVTRSV56 EQU   CVTSYSK
CVTRSV55 EQU   CVTSYSK
CVTRSV54 EQU   CVTSYSK
CVTRSV53 EQU   CVTSYSK
CVTRSV52 EQU   CVTA1F1
CVTRSV51 EQU   CVTA1F1
CVTRSV50 EQU   CVTA1F1
CVTRSV49 EQU   CVTA1F1
CVTRSV48 EQU   CVTA1F1
CVTRSV47 EQU   CVTA1F1
CVTSRSW  EQU   CVTA1F1
CVTPFSW  EQU   CVTA1F1
CVTPCVT  EQU   CVTMAP+352
CVTRSV46 EQU   CVTMAP+344
CVTRSV45 EQU   CVTMAP+340
CVTRSV44 EQU   CVTMAP+338
CVTRSV43 EQU   CVTMAP+336
CVTHJESA EQU   CVTHJES+1
CVTRSV42 EQU   CVTHJES
CVTEXT2A EQU   CVTEXT2+1
CVTRSV41 EQU   CVTEXT2
CVTAPFA  EQU   CVTAPF+1
CVTRSV40 EQU   CVTAPF
CVTRV518 EQU   CVTINTLA
CVTRV517 EQU   CVTERPV
CVTEORM  EQU   CVTMAP+312
CVTMCHPR EQU   CVTMAP+308
CVTTZ    EQU   CVTMAP+304
CVTJEPS  EQU   CVTMAP+300
CVTJESCT EQU   CVTMAP+296
CVTMODE  EQU   CVTMAP+292
CVTPTRV  EQU   CVTMAP+288
CVTREAL  EQU   CVTMAP+284
CVTRSV39 EQU   CVTMAP+280
CVTRSV38 EQU   CVTMAP+276
CVTDMSRA EQU   CVTDMSR+1
CVTRV634 EQU   CVTDMSRF
CVTRV633 EQU   CVTDMSRF
CVTRV632 EQU   CVTDMSRF
CVTRV631 EQU   CVTDMSRF
CVTRV630 EQU   CVTDMSRF
CVTRV629 EQU   CVTDMSRF
CVTUDUMP EQU   CVTDMSRF
CVTSDUMP EQU   CVTDMSRF
CVTQMSGA EQU   CVTQMSG+1
CVTRSV36 EQU   CVTQMSG
CVTAMFF  EQU   CVTMAP+264
CVTPURGA EQU   CVTPURG+1
CVTRSV35 EQU   CVTPURG
CVTCBSP  EQU   CVTMAP+256
CVTATERA EQU   CVTATER+1
CVTSYST  EQU   CVTATER
CVTVOLT2 EQU   CVTTAT
CVTVOLI2 EQU   CVTVOLF2
CVTAQAVB EQU   CVTAQAVT+1
CVTRSV34 EQU   CVTTCMFG
CVTRSV33 EQU   CVTTCMFG
CVTRSV32 EQU   CVTTCMFG
CVTRSV31 EQU   CVTTCMFG
CVTRSV30 EQU   CVTTCMFG
CVTRSV29 EQU   CVTTCMFG
CVTRSV28 EQU   CVTTCMFG
CVTTCRDY EQU   CVTTCMFG
CVTGTFA  EQU   CVTGTF+1
CVTRSV27 EQU   CVTGTFST
CVTRNIO  EQU   CVTGTFST
CVTUSR   EQU   CVTGTFST
CVTRV318 EQU   CVTFORM
CVTRV317 EQU   CVTTMODE
CVTRV316 EQU   CVTSTATE
CVTRV315 EQU   CVTGTFS
CVTGTFAV EQU   CVTGTFS
CVT0SCR1 EQU   CVTMAP+232
CVTRV515 EQU   CVTMAP+228
CVTRMS   EQU   CVTMAP+224
CVTPATCH EQU   CVTMAP+220
CVTTSCE  EQU   CVTMAP+216
CVTLNKSC EQU   CVTMAP+214
CVTQABST EQU   CVTMAP+212
CVTMDLDS EQU   CVTMAP+208
CVTUSER  EQU   CVTMAP+204
CVTABEND EQU   CVTMAP+200
CVTSMCA  EQU   CVTMAP+196
CVTRSV18 EQU   CVTMAP+192
CVTQLPAQ EQU   CVTMAP+188
CVTQCDSR EQU   CVTMAP+184
CVTRSV17 EQU   CVTOPTB
CVTRSV16 EQU   CVTOPTB
CVTFP    EQU   CVTOPTB
CVTAPTHR EQU   CVTOPTB
CVTNLOG  EQU   CVTOPTB
CVTTOD   EQU   CVTOPTB
CVTCTIMS EQU   CVTOPTB
CVTPROT  EQU   CVTOPTB
CVTXPFP  EQU   CVTOPTA
CVTASCII EQU   CVTOPTA
CVTRSV13 EQU   CVTOPTA
CVTRSV12 EQU   CVTOPTA
CVTNIP   EQU   CVTOPTA
CVTDDR   EQU   CVTOPTA
CVTAPR   EQU   CVTOPTA
CVTCCH   EQU   CVTOPTA
CVTSNCTR EQU   CVTMAP+180
CVTQMWR  EQU   CVTMAP+176
CVTQOCR  EQU   CVTMAP+172
CVT1EF00 EQU   CVTMAP+168
CVTMZ00  EQU   CVTMAP+164
CVTHEAD  EQU   CVTMAP+160
CVTRSV11 EQU   CVTMAP+156
CVT0PT01 EQU   CVTMAP+152
CVTMSER  EQU   CVTMAP+148
CVTRV516 EQU   CVTIERLC
CVTILCH  EQU   CVTMAP+140
CVT0DS   EQU   CVTMAP+136
CVTFBOSV EQU   CVTMAP+132
CVTNUCB  EQU   CVTMAP+128
CVTIXAVL EQU   CVTMAP+124
CVTIOQET EQU   CVTMAP+120
CVTDCBA  EQU   CVTMAP+117
CVTMVS2  EQU   CVTDCB
CVT6DAT  EQU   CVTDCB
CVT4MPS  EQU   CVTDCB
CVTRSV09 EQU   CVTDCB
CVT4MS1  EQU   CVTDCB
CVT2SPS  EQU   CVTDCB
CVT1SSS  EQU   CVTDCB
CVTRSV08 EQU   CVTDCB
CVTSTB   EQU   CVTMAP+112
CVTQTD00 EQU   CVTMAP+108
CVTQTE00 EQU   CVTMAP+104
CVTCUCB  EQU   CVTMAP+100
CVTSJQ   EQU   CVTMAP+96
CVTPBLDL EQU   CVTMAP+92
CVTTPC   EQU   CVTMAP+88
CVTSVDCB EQU   CVTMAP+84
CVTBRET  EQU   CVTMAP+82
CVTEXIT  EQU   CVTMAP+80
CVT0FN00 EQU   CVTMAP+76
CVTDARA  EQU   CVTDAR+1
CVTRSV07 EQU   CVTFLGS1
CVTRSV06 EQU   CVTFLGS1
CVTRSV05 EQU   CVTFLGS1
CVTRSV04 EQU   CVTFLGS1
CVTRSV03 EQU   CVTFLGS1
CVTRSV02 EQU   CVTFLGS1
CVTRSV01 EQU   CVTFLGS1
CVTDMPLK EQU   CVTFLGS1
CVTXITP  EQU   CVTMAP+68
CVTZDTAB EQU   CVTMAP+64
CVTMSLT  EQU   CVTMAP+60
CVTDATE  EQU   CVTMAP+56
CVTBTERM EQU   CVTMAP+52
CVTSYSAD EQU   CVTMAP+48
CVTXTLER EQU   CVTMAP+44
CVTILK1  EQU   CVTMAP+36
CVTPRLTV EQU   CVTMAP+32
CVTPCNVT EQU   CVTMAP+28
CVT0VL00 EQU   CVTMAP+24
CVTXAPG  EQU   CVTMAP+20
CVTBUF   EQU   CVTMAP+16
CVTJOB   EQU   CVTMAP+12
CVTLINK  EQU   CVTMAP+8
CVT0EF00 EQU   CVTMAP+4
CVTTCBP  EQU   CVTMAP
CVT      EQU   CVTMAP
@NM00007 EQU   QMROOT+4
@NM00006 EQU   QMBLK+24
@NM00005 EQU   QMMEMID
@NM00004 EQU   QMBLK+16
@NM00003 EQU   QMBLK+12
@NM00002 EQU   QMBLK+8
@NM00001 EQU   QMBLK+4
@NM00040 EQU   PSA+3668
PSASTAK  EQU   PSA+3072
@NM00039 EQU   PSA+1048
PSAUSEND EQU   PSA+1048
PSARV062 EQU   PSA+1044
PSACDAL  EQU   PSA+1040
PSAWTCOD EQU   PSA+1036
PSAATCVT EQU   PSA+1032
PSAPCPSW EQU   PSA+1024
PSAPIR2  EQU   PSA+1020
PSARV059 EQU   PSA+1018
PSASVC13 EQU   PSA+1016
PSALSFCC EQU   PSA+1012
PSASFACC EQU   PSA+1008
PSASTOP  EQU   PSA+992
PSASTART EQU   PSA+976
PSARSPSW EQU   PSA+968
PSASRPSW EQU   PSA+960
PSARV045 EQU   PSA+892
PSARV044 EQU   PSA+888
PSARV043 EQU   PSA+884
PSARV042 EQU   PSA+880
PSARV041 EQU   PSA+876
PSARV040 EQU   PSA+872
PSARV025 EQU   PSA+868
PSADSSED EQU   PSA+868
PSADSSPR EQU   PSA+864
PSADSSFW EQU   PSA+860
PSADSS14 EQU   PSA+856
PSADSSPP EQU   PSA+848
PSADSSRP EQU   PSA+840
PSADSS05 EQU   PSADSSF4
PSADSS10 EQU   PSADSSF4
PSADSSVE EQU   PSADSSF4
PSADSSDE EQU   PSADSSF4
PSADSSC0 EQU   PSADSSF4
PSADSSIE EQU   PSADSSF4
PSADSS12 EQU   PSADSSF4
PSADSSRC EQU   PSADSSF4
PSARV057 EQU   PSADSSF3
PSARV056 EQU   PSADSSF3
PSARV055 EQU   PSADSSF3
PSADSSMC EQU   PSADSSF3
PSADSSRW EQU   PSADSSF3
PSADSSNM EQU   PSADSSF3
PSADSSES EQU   PSADSSF3
PSADSSGP EQU   PSADSSF3
PSADSSF2 EQU   PSADSSFL+1
PSADSSPI EQU   PSADSSF1
PSADSSOI EQU   PSADSSF1
PSADSSSP EQU   PSADSSF1
PSADSSTP EQU   PSADSSF1
PSADSSDW EQU   PSADSSF1
PSADSSDD EQU   PSADSSF1
PSADSSDM EQU   PSADSSF1
PSADSSMV EQU   PSADSSF1
PSADSSTS EQU   PSA+816
PSADSSWK EQU   PSA+812
PSADSSR3 EQU   PSA+808
PSADSSR2 EQU   PSA+804
PSADSSRS EQU   PSA+800
PSASTOR  EQU   PSA+796
PSACPUSA EQU   PSA+794
PSAVSTAP EQU   PSA+792
PSAWKVAP EQU   PSA+788
PSAWKRAP EQU   PSA+784
PSAMCHIC EQU   PSA+783
PSARV061 EQU   PSA+782
PSASYMSK EQU   PSA+781
PSAMCHFL EQU   PSA+780
PSACR0   EQU   PSA+776
PSAPSWSV EQU   PSA+768
PSACLHS  EQU   PSAHLHI
PSALKR15 EQU   PSALKSA+60
PSALKR14 EQU   PSALKSA+56
PSALKR13 EQU   PSALKSA+52
PSALKR12 EQU   PSALKSA+48
PSALKR11 EQU   PSALKSA+44
PSALKR10 EQU   PSALKSA+40
PSALKR9  EQU   PSALKSA+36
PSALKR8  EQU   PSALKSA+32
PSALKR7  EQU   PSALKSA+28
PSALKR6  EQU   PSALKSA+24
PSALKR5  EQU   PSALKSA+20
PSALKR4  EQU   PSALKSA+16
PSALKR3  EQU   PSALKSA+12
PSALKR2  EQU   PSALKSA+8
PSALKR1  EQU   PSALKSA+4
PSALKR0  EQU   PSALKSA
PSARV023 EQU   PSACLHT+52
PSALOCAL EQU   PSACLHT+48
PSACMSL  EQU   PSACLHT+44
PSAOPTL  EQU   PSACLHT+40
PSATPACL EQU   PSACLHT+36
PSATPDNL EQU   PSACLHT+32
PSATPNCL EQU   PSACLHT+28
PSAIOSLL EQU   PSACLHT+24
PSAIOSUL EQU   PSACLHT+20
PSAIOSCL EQU   PSACLHT+16
PSAIOSSL EQU   PSACLHT+12
PSASALCL EQU   PSACLHT+8
PSAASML  EQU   PSACLHT+4
PSADISPL EQU   PSACLHT
PSASRSA  EQU   PSA+636
PSARV050 EQU   PSA+634
PSADSSGO EQU   PSA+633
PSARECUR EQU   PSA+632
PSAHLHIS EQU   PSA+628
PSAIPCSA EQU   PSA+624
@NM00038 EQU   PSA+621
PSAIPCDM EQU   PSA+620
PSAIPCD  EQU   PSA+616
@NM00037 EQU   PSA+613
PSAIPCRM EQU   PSA+612
PSAIPCR  EQU   PSA+608
PSAMCHEX EQU   PSA+600
PSAMPSW  EQU   PSA+592
PSAEXPS2 EQU   PSA+584
PSAEXPS1 EQU   PSA+576
PSAPIREG EQU   PSA+572
PSARSREG EQU   PSA+568
PSAGPREG EQU   PSA+556
PSARV022 EQU   PSASUP4
PSARV021 EQU   PSASUP4
PSARV020 EQU   PSASUP4
PSARV019 EQU   PSASUP4
PSARV018 EQU   PSASUP4
PSARV017 EQU   PSASUP4
PSARV016 EQU   PSASUP4
PSARV015 EQU   PSASUP4
PSARV014 EQU   PSASUP3
PSARV013 EQU   PSASUP3
PSARV012 EQU   PSASUP3
PSAESTA  EQU   PSASUP3
PSASPR   EQU   PSASUP3
PSAPSREG EQU   PSASUP3
PSAPI2   EQU   PSASUP3
PSAIOSUP EQU   PSASUP3
PSALCR   EQU   PSASUP2
PSARTM   EQU   PSASUP2
PSAACR   EQU   PSASUP2
PSAIPCE2 EQU   PSASUP2
PSAIPCES EQU   PSASUP2
PSAIPCEC EQU   PSASUP2
PSAGTF   EQU   PSASUP2
PSAIPCRI EQU   PSASUP2
PSATYPE6 EQU   PSASUP1
PSATCTL  EQU   PSASUP1
PSADISP  EQU   PSASUP1
PSALOCK  EQU   PSASUP1
PSAPI    EQU   PSASUP1
PSAEXT   EQU   PSASUP1
PSASVC   EQU   PSASUP1
PSAIO    EQU   PSASUP1
PSAAOLD  EQU   PSA+548
PSAANEW  EQU   PSA+544
PSATOLD  EQU   PSA+540
PSATNEW  EQU   PSA+536
PSALCCAR EQU   PSA+532
PSALCCAV EQU   PSA+528
PSAPCCAR EQU   PSA+524
PSAPCCAV EQU   PSA+520
PSACPULA EQU   PSA+518
PSACPUPA EQU   PSA+516
PSAPSA   EQU   PSA+512
FLCHDEND EQU   PSA+512
FLCCRSAV EQU   FLCMCLA+280
FLCGRSAV EQU   FLCMCLA+216
FLCFPSAV EQU   FLCMCLA+184
FLCFLA   EQU   FLCMCLA+88
FLCRGNCD EQU   FLCMCLA+84
FLCFSAA  EQU   FLCFSA+1
@NM00036 EQU   FLCFSA
@NM00035 EQU   FLCMCLA+72
FLCMCIC  EQU   FLCMCLA+64
@NM00034 EQU   FLCMCLA+20
FLCIOAA  EQU   FLCIOA+1
@NM00033 EQU   FLCIOA
@NM00032 EQU   FLCMCLA+15
@NM00031 EQU   FLCMCLA+14
@NM00030 EQU   FLCMCLA+12
FLCLCL   EQU   FLCMCLA+8
FLCIOELA EQU   FLCIOEL+1
@NM00029 EQU   FLCIOEL
FLCCHNID EQU   FLCMCLA
@NM00028 EQU   PSA+160
FLCMTRCD EQU   PSA+157
@NM00027 EQU   PSA+156
FLCPERA  EQU   FLCPER+1
@NM00026 EQU   FLCPER
@NM00025 EQU   PSA+151
FLCPERCD EQU   PSA+150
FLCMCNUM EQU   PSA+149
@NM00024 EQU   PSA+148
FLCTEAA  EQU   FLCTEA+1
@NM00023 EQU   FLCTEA
PSAPIPC  EQU   PSAPICOD
PSAPIMC  EQU   PSAPICOD
PSAPIPER EQU   PSAPICOD
PSARV049 EQU   FLCPICOD
FLCPILCB EQU   FLCPIILC
@NM00022 EQU   FLCPIILC
@NM00021 EQU   PSAEPPSW
FLCSVCN  EQU   PSAESPSW+2
FLCSILCB EQU   FLCSVILC
@NM00020 EQU   FLCSVILC
@NM00019 EQU   PSAESPSW
FLCEICOD EQU   PSAEEPSW+2
PSASPAD  EQU   PSAEEPSW
@NM00018 EQU   PSA+128
FLCINPSW EQU   PSA+120
FLCMNPSW EQU   PSA+112
FLCPNPSW EQU   PSA+104
FLCSNPSW EQU   PSA+96
FLCENPSW EQU   PSA+88
FLCTRACE EQU   PSA+84
FLCTIMER EQU   PSA+80
FLCCVT2  EQU   PSA+76
FLCCAW   EQU   PSA+72
FLCCSW   EQU   PSA+64
FLCIOPSW EQU   PSA+56
FLCMOPSW EQU   PSA+48
FLCPOPSW EQU   PSA+40
FLCSOPSW EQU   PSA+32
FLCEOPSW EQU   PSA+24
@NM00017 EQU   FLCICCW2+4
FLCCVT   EQU   FLCICCW2
FLCICCW1 EQU   FLCROPSW
FLCIPPSW EQU   FLCRNPSW
.@UNREFD ANOP                          END UNREFERENCED COMPONENTS
@RC00204 EQU   @RC00203
@RF00214 EQU   @RC00204
@RF00220 EQU   @RC00204
@RF00225 EQU   @RC00204
@ENDDATA EQU   *
         END   IEFAB4E5,(C'PLS1525',0701,76342)
