         TITLE 'IEFAB4EA - ESTAE EXIT ROUTINE                          *
                        '
IEFAB4EA CSECT
@MAINENT DS 0H
         USING *,15
         B PROLOG
         DC AL1(16)
         DC C'IEFAB4EA  75.151'                               @Z40FPPG
         DROP 15
PROLOG   BALR 12,0
         USING *,12
         LA 11,12
         CR 0,11   SEE IF AN SDWA EXISTS
         BNE GETPPTR         THERE IS AN SDWA
         LR 11,2   GET PARMPTR FROM REG2
         B COMMON
GETPPTR  L 11,0(1) GET PARMPTR FROM SDWA
COMMON   EQU *
         USING @DATD,11
JSCBDISP EQU 188
JSCBAOS1 EQU  72
JSCBAOS2 EQU 192
*   REG13SVE=REG13;                 /* SAVE REG 13           @Z40FPPG*/
         LR    REG13SVE,REG13                                   01S0038
*   REG14SVE=REG14;                 /* SAVE RETURN ADDRESS           */
         LR    REG14SVE,REG14                                   01S0039
*   EPRMLSTP=REG11;                 /* PTR TO ESTAE EXIT PARMS       */
         LR    EPRMLSTP,REG11                                   01S0040
*   REG13=REG11;                    /* PTR TO SAVE AREA - FIRST 01S0041
*                                      SECTION OF PARMLIST IS   01S0041
*                                      AUTODATA AREA CONTAINING SAVE
*                                      AREA + DYN. STORAGE           */
         LR    REG13,REG11                                      01S0041
*   SDWAPTR=0;                      /* CLEAR SDWA POINTER            */
         SLR   SDWAPTR,SDWAPTR                                  01S0042
*   IF REG0^=NOSDWA THEN            /* SDWA SUPPLIED                 */
         C     REG0,@CF00033                                    01S0043
         BE    @RF00043                                         01S0043
*     SDWAPTR=REG1;                 /* INITIALIZE PTR TO SDWA        */
         LR    SDWAPTR,REG1                                     01S0044
*   RFY                                                         01S0045
*    (REG0,                                                     01S0045
*     REG1) UNRSTD;                                             01S0045
*                                                               01S0045
@RF00043 DS    0H                                               01S0046
*/*** DEQUEUE PCCB CHAIN (RET=HAVE) IN CASE IT HAS NOT BEEN DONE   ***/
*                                                               01S0046
*   DCORE(1:DLENGTH)=DLIST(1:DLENGTH);/* MOVE LIST TO DSECT          */
         L     @10,DLENGTH                                      01S0046
         BCTR  @10,0                                            01S0046
         EX    @10,@SM01019                                     01S0046
*   GEN REFS(DCORE);                                            01S0047
     DEQ MF=(E,DCORE)
*   IF SDWAPTR^=0 THEN              /* SDWA EXISTS - SO DO CLEANUP   */
         SLR   @10,@10                                          01S0048
         CR    SDWAPTR,@10                                      01S0048
         BE    @RF00048                                         01S0048
*     DO;                                                       01S0049
*                                                               02S0050
*/********************************************************************/
*/*                                                                  */
*/* SEGMENT NAME - ECLEANUP                                          */
*/*                                                                  */
*/* DESCRIPTIVE NAME - ESTAE CLEANUP                                 */
*/*                                                                  */
*/* FUNCTION - RELEASE RESOURCES HELD BY HSKP AND ALLOCATE           */
*/*     CATALOG ROUTINE.                                             */
*/*     INSURE CONTROL BLOCKS ARE REINSTATED.                @YM03975*/
*/*                                                                  */
*/*     OPERATION -                                                  */
*/*             1. REINSTATE ACTIVE JSCB PTR IF NECESSARY            */
*/*             2. IF ALL PRIVATE CATALOGS ARE TO BE CLOSED AND      */
*/*                UNALLOCATED AND HAVE REPRESENTATIVE PCCBS FREED   */
*/*                AND IF A PCCB CHAIN PTR EXISTS IN THE ACTIVE JSCB,*/
*/*                THEN UNALLOCATE CATALOG CONTROL(IEFAB4F4) WILL BE */
*/*                CALLED.                                           */
*/*             3. IF A CATALOG WAS ALLOCATED AND/OR OPENED IN       */
*/*                IEFAB4F5 AND A FAILURE OCCURED PRIOR TO A PCCB    */
*/*                BEING CREATED TO REPRESENT THAT CATALOG(CALLED A  */
*/*                CURRENT CATALOG), SPECIFIC INPUT(DDNAME/ACB PTR)  */
*/*                IS PASSED TO THIS ROUTINE. IEFAB4F4 IS CALLED IF  */
*/*                EITHER OR BOTH INPUT EXISTS IN ORDER TO UNALLOCATE*/
*/*                AND/OR CLOSE THIS 'CURRENT' CATALOG.              */
*/*             4. REINSTATE INITIATOR'S TIOT POINTER.       @YM03975*/
*/*                                                                  */
*/* ENTRY - INLINE SEGMENT                                           */
*/*                                                                  */
*/*     INPUT - SEGMENT USES INPUT TO IEFAB4EA                       */
*/*                                                                  */
*/* EXIT - N/A                                                       */
*/*                                                                  */
*/*     CONDITION - CLEANUP PERFORMED                                */
*/*                                                                  */
*/*     OUTPUT DATA - NONE                                           */
*/*                                                                  */
*/********************************************************************/
*                                                               02S0050
*       IF EERAJSCP=ON THEN         /* REINSTATE ACTIVE JSCB PTR TO
*                                      ENSURE CORRECT JSCB CHAINING  */
         TM    EERAJSCP(EPRMLSTP),B'00000100'                   02S0050
         BNO   @RF00050                                         02S0050
*         DO;                                                   02S0051
*           ECJSCBP->JSCBACT=EAJSCBP;                           02S0052
         L     @15,ECJSCBP(,EPRMLSTP)                           02S0052
         L     @14,EAJSCBP(,EPRMLSTP)                           02S0052
         ST    @14,JSCBACT(,@15)                                02S0052
*           ECJSCBP->JSCBASWA=ZERO; /* FIELD SHOULD BE ZERO NOW IN
*                                      CURRENT               @Z40FPPG*/
         ST    @10,JSCBASWA(,@15)                               02S0053
*           UCCAJSCB=ON;            /* ACT. JSCB SHOULD BE           */
         OI    UCCAJSCB,B'10000000'                             02S0054
*         END;                      /* SWITCHED IF IEFAB4F4 IS CALLED*/
*       IF ECJSCBP->JSCBACT->JSCBPCC^=0&/* CHECK FOR PCCB &  @YM06351*/
*           EENOUNCT=OFF&           /* IEFAB4F4 IS 'CALLABLE'   02S0056
*                                                            @YM03975*/
*           EEDYNAM=OFF THEN        /* O.K. TO FREE RESOURCES        */
@RF00050 L     @10,ECJSCBP(,EPRMLSTP)                           02S0056
         L     @10,JSCBACT(,@10)                                02S0056
         L     @10,JSCBPCC(,@10)                                02S0056
         LTR   @10,@10                                          02S0056
         BZ    @RF00056                                         02S0056
         TM    EENOUNCT(EPRMLSTP),B'01000000'                   02S0056
         BNZ   @RF00056                                         02S0056
         TM    EEDYNAM(EPRMLSTP),B'00000010'                    02S0056
         BNZ   @RF00056                                         02S0056
*         DO;                                                   02S0057
*           IF EEDNENQT=ON THEN     /* DON'T ENQUE                   */
         TM    EEDNENQT(EPRMLSTP),B'00000001'                   02S0058
         BNO   @RF00058                                         02S0058
*             UCNTIONQ=ON;          /* ON TIOT IF ALREADY DONE       */
         OI    UCNTIONQ,B'01000000'                             02S0059
*           IF EEUALCAT=ON THEN     /* SET INDICATOR TO UNALLOCATE   */
@RF00058 TM    EEUALCAT(EPRMLSTP),B'10000000'                   02S0060
         BNO   @RF00060                                         02S0060
*             UCALLCAT=ON;          /* ALL CATALOGS                  */
         OI    UCALLCAT,B'00010000'                             02S0061
*           IF EECLACAT=ON THEN     /* SET INDICATOR TO CLOSE ALL    */
@RF00060 TM    EECLACAT(EPRMLSTP),B'01000000'                   02S0062
         BNO   @RF00062                                         02S0062
*             UCALLACB=ON;          /* CATALOG ACB(S)                */
         OI    UCALLACB,B'00000100'                             02S0063
*           IF EEFAPCCB=ON THEN     /* SET INDICATOR TO FREE ALL     */
@RF00062 TM    EEFAPCCB(EPRMLSTP),B'00100000'                   02S0064
         BNO   @RF00064                                         02S0064
*             UCALPCCB=ON;          /* PCCB(S)                       */
         OI    UCALPCCB,B'00000001'                             02S0065
*           DO;                     /* MODESET EXTKEY(SCHED)         */
@RF00064 DS    0H                                               02S0067
*             SPKA(16);             /* SET PSW KEY                   */
         LA    @10,16                                           02S0067
         SPKA  0(@10)                                           02S0067
*           END;                    /* MODESET EXTKEY(SCHED) SCHED
*                                      KEY FOR CALL          @ZM32370*/
*           CALL IEFAB4F4(UCCNTRLS,ADDR(ERETURNS),0,0,0,ECJSCBP);/*
*                                      UNALLOCATE CATALOG ROUTINE    */
         LA    @10,UCCNTRLS                                     02S0069
         ST    @10,@AL00001                                     02S0069
         LA    @10,ERETURNS(,EPRMLSTP)                          02S0069
         ST    @10,@TF00001                                     02S0069
         LA    @10,@TF00001                                     02S0069
         ST    @10,@AL00001+4                                   02S0069
         LA    @10,@CF00066                                     02S0069
         ST    @10,@AL00001+8                                   02S0069
         LA    @10,@CF00066                                     02S0069
         ST    @10,@AL00001+12                                  02S0069
         LA    @10,@CF00066                                     02S0069
         ST    @10,@AL00001+16                                  02S0069
         LA    @10,ECJSCBP(,EPRMLSTP)                           02S0069
         ST    @10,@AL00001+20                                  02S0069
         L     @15,@CV00073                                     02S0069
         LA    @01,@AL00001                                     02S0069
         BALR  @14,@15                                          02S0069
*           DO;                     /* MODESET KEYADDR(ZERO)         */
*             SPKA(ZERO);           /* SET PSW KEY                   */
         SLR   @10,@10                                          02S0071
         SPKA  0(@10)                                           02S0071
*           END;                    /* MODESET KEYADDR(ZERO) BACK TO
*                                      KEY ZERO              @ZM32370*/
*         END;                      /* IF A CURRENT CATALOG TO BE    */
*       IF(EEUCUCAT=ON|             /* UNALLOCATED                   */
*           EECCUCAT=ON)&           /* AND OR CLOSED AND             */
*           EEDYNAM=OFF THEN        /* NOT ON BEHALF OF DYNAMIC      */
@RF00056 TM    EEUCUCAT(EPRMLSTP),B'00011000'                   02S0074
         BZ    @RF00074                                         02S0074
         TM    EEDYNAM(EPRMLSTP),B'00000010'                    02S0074
         BNZ   @RF00074                                         02S0074
*         DO;                       /* ALLOCATION                    */
*           DDNAMPTR=0;             /* CLEAR DDNAME POINTER          */
         SLR   @10,@10                                          02S0076
         ST    @10,DDNAMPTR                                     02S0076
*           CACBPTR=0;              /* CLEAR ACB POINTER             */
         ST    @10,CACBPTR                                      02S0077
*           IF EEUCUCAT=ON THEN     /* CURRENT CATALOG TO            */
         TM    EEUCUCAT(EPRMLSTP),B'00010000'                   02S0078
         BNO   @RF00078                                         02S0078
*             DO;                   /* UNALLOCATE                    */
*               UCONECAT=ON;        /* SET INDICATOR TO UNALLOCATE   */
         OI    UCONECAT,B'00100000'                             02S0080
*               DDNAMPTR=ADDR(EDDNAME);/* CATALOG PASSING DDNAME     */
         LA    @10,EDDNAME(,EPRMLSTP)                           02S0081
         ST    @10,DDNAMPTR                                     02S0081
*             END;                                              02S0082
*           IF EECCUCAT=ON THEN     /* CURRENT CATALOG ACB TO        */
@RF00078 TM    EECCUCAT(EPRMLSTP),B'00001000'                   02S0083
         BNO   @RF00083                                         02S0083
*             DO;                   /* CLOSE                         */
*               UCONEACB=ON;        /* SET INDICATOR TO CLOSE        */
         OI    UCONEACB,B'00001000'                             02S0085
*               CACBPTR=EACBPTR;    /* CURRENT CATALOG ACB           */
         L     @10,EACBPTR(,EPRMLSTP)                           02S0086
         ST    @10,CACBPTR                                      02S0086
*             END;                  /* PASSING ACB POINTER           */
*           IF EEDNENQT=ON THEN     /* DON'T ENQUE                   */
@RF00083 TM    EEDNENQT(EPRMLSTP),B'00000001'                   02S0088
         BNO   @RF00088                                         02S0088
*             UCNTIONQ=ON;          /* ON TIOT IF ALREADY DONE       */
         OI    UCNTIONQ,B'01000000'                             02S0089
*           DO;                     /* MODESET EXTKEY(SCHED)         */
@RF00088 DS    0H                                               02S0091
*             SPKA(16);             /* SET PSW KEY                   */
         LA    @10,16                                           02S0091
         SPKA  0(@10)                                           02S0091
*           END;                    /* MODESET EXTKEY(SCHED) SCHED
*                                      KEY FOR CALL          @ZM32370*/
*           CALL IEFAB4F4(UCCNTRLS,ADDR(ERETURNS),0,DDNAMPTR,CACBPTR,
*               ECJSCBP);                                       02S0093
         LA    @10,UCCNTRLS                                     02S0093
         ST    @10,@AL00001                                     02S0093
         LA    @10,ERETURNS(,EPRMLSTP)                          02S0093
         ST    @10,@TF00001                                     02S0093
         LA    @10,@TF00001                                     02S0093
         ST    @10,@AL00001+4                                   02S0093
         LA    @10,@CF00066                                     02S0093
         ST    @10,@AL00001+8                                   02S0093
         LA    @10,DDNAMPTR                                     02S0093
         ST    @10,@AL00001+12                                  02S0093
         LA    @10,CACBPTR                                      02S0093
         ST    @10,@AL00001+16                                  02S0093
         LA    @10,ECJSCBP(,EPRMLSTP)                           02S0093
         ST    @10,@AL00001+20                                  02S0093
         L     @15,@CV00073                                     02S0093
         LA    @01,@AL00001                                     02S0093
         BALR  @14,@15                                          02S0093
*           DO;                     /* MODESET KEYADDR(ZERO)         */
*             SPKA(ZERO);           /* SET PSW KEY                   */
         SLR   @10,@10                                          02S0095
         SPKA  0(@10)                                           02S0095
*           END;                    /* MODESET KEYADDR(ZERO) BACK TO
*                                      KEY ZERO              @ZM32370*/
*         END;                                                  02S0097
*       IF EESWTIOT=ON THEN         /* REINSTATE TIOT        @YM03975*/
@RF00074 TM    EESWTIOT(EPRMLSTP),B'10000000'                   02S0098
         BNO   @RF00098                                         02S0098
*         TCBTIO=EEINTIOT;          /* PTR WITH INIT'S.      @YM03975*/
         L     @10,ETCBP(,EPRMLSTP)                             02S0099
         L     @15,EEINTIOT(,EPRMLSTP)                          02S0099
         ST    @15,TCBTIO(,@10)                                 02S0099
*     END;                                                      01S0100
@RF00098 DS    0H                                               01S0101
*   RFY                                                         01S0101
*    (REG1) RSTD;                                               01S0101
@RF00048 DS    0H                                               01S0102
*   REG1=SDWAPTR;                   /* RESTORE POINTER TO SDWA       */
         LR    REG1,SDWAPTR                                     01S0102
*   REG13=REG13SVE;                 /* RESTORE REG 13 /@Z40FPPG      */
         LR    REG13,REG13SVE                                   01S0103
*   REG14=REG14SVE;                 /* RESTORE REGISTER 14           */
         LR    REG14,REG14SVE                                   01S0104
*   GEN;                                                        01S0105
          SR 15,15
          BR 14
*   END IEFAB4EA                                                01S0106
*                                                               01S0106
*/* THE FOLLOWING INCLUDE STATEMENTS WERE FOUND IN THIS PROGRAM.     */
*/*%INCLUDE SYSUT5  (EEXITPRG)                                       */
*/*%INCLUDE SYSUT5  (EEXITDCL)                                       */
*/*%INCLUDE SYSLIB  (IEFZB443)                                       */
*/*%INCLUDE SYSLIB  (IEFZB444)                                       */
*/*%INCLUDE SYSLIB  (IHASDWA )                                       */
*/*%INCLUDE SYSLIB  (IEZJSCB )                                       */
*/*%INCLUDE SYSLIB  (IKJTCB  )                                       */
*/*%INCLUDE SYSUT5  (ECLEANSP)                                       */
*/*%INCLUDE SYSUT5  (ECLEANUP)                                       */
*                                                               01S0106
*       ;                                                       01S0106
@DATA    DS    0H
@SM01019 MVC   DCORE(0),DLIST
@DATD    DSECT
         DS    0F
@SA00001 DS    18F
@AL00001 DS    6A
@TF00001 DS    F
IEFAB4EA CSECT
         DS    0F
@CF00066 DC    F'0'
@CF00033 DC    F'12'
@DATD    DSECT
         DS    0D
DDNAMPTR DS    A
CACBPTR  DS    A
UCCNTRLS DS    FL2
         ORG   UCCNTRLS
UCCAJSCB DS    BL1
UCNTIONQ EQU   UCCNTRLS+0
UCONECAT EQU   UCCNTRLS+0
UCALLCAT EQU   UCCNTRLS+0
UCONEACB EQU   UCCNTRLS+0
UCALLACB EQU   UCCNTRLS+0
UCONPCCB EQU   UCCNTRLS+0
UCALPCCB EQU   UCCNTRLS+0
UCTEMP   DS    BL1
UCSWTIOT EQU   UCCNTRLS+1
@NM00001 EQU   UCCNTRLS+1
         ORG   UCCNTRLS+2
IEFAB4EA CSECT
         NOPR  ((@ENDDATD-@DATD)/201*16)
         DS    0F
@SIZDATD DC    AL1(0)
         DC    AL3(@ENDDATD-@DATD)
@CV00073 DC    V(IEFAB4F4)
         DS    0D
QNAME    DC    CL8'SYSZPCCB'
RNAME    DC    CL4'PCCB'
IEFAB4EA CSECT
         DS   0H
PATCHLOC DC (50)X'00'
IEFAB4EA CSECT
DLIST DEQ (QNAME,RNAME,4,SYSTEM),RET=HAVE,MF=L
DLENGTH DC A(*-DLIST)
@DATD    DSECT
DCORE DEQ (QNAME,RNAME,4,SYSTEM),RET=HAVE,MF=L
@DATD    DSECT
         ORG   *+1-(*-@DATD)/(*-@DATD) INSURE DSECT DATA
@ENDDATD EQU   *
IEFAB4EA CSECT
@00      EQU   00                      EQUATES FOR REGISTERS 0-15
@01      EQU   01
@02      EQU   02
@03      EQU   03
@04      EQU   04
@05      EQU   05
@06      EQU   06
@07      EQU   07
@08      EQU   08
@09      EQU   09
@10      EQU   10
@11      EQU   11
@12      EQU   12
@13      EQU   13
@14      EQU   14
@15      EQU   15
REG14SVE EQU   @09
REG13SVE EQU   @08
SDWAPTR  EQU   @07
EPRMLSTP EQU   @06
REG0     EQU   @00
REG1     EQU   @01
REG11    EQU   @11
REG13    EQU   @13
REG14    EQU   @14
REG2     EQU   @02
EPARMLST EQU   0
EECNTRLS EQU   EPARMLST+400
EEUALCAT EQU   EECNTRLS
EECLACAT EQU   EECNTRLS
EEFAPCCB EQU   EECNTRLS
EEUCUCAT EQU   EECNTRLS
EECCUCAT EQU   EECNTRLS
EERAJSCP EQU   EECNTRLS
EEDYNAM  EQU   EECNTRLS
EEDNENQT EQU   EECNTRLS
EESWTIOT EQU   EECNTRLS+1
EENOUNCT EQU   EECNTRLS+1
ECJSCBP  EQU   EPARMLST+404
EAJSCBP  EQU   EPARMLST+408
EACBPTR  EQU   EPARMLST+412
EDDNAME  EQU   EPARMLST+416
ERETURNS EQU   EPARMLST+424
EEINTIOT EQU   EPARMLST+428
ETCBP    EQU   EPARMLST+432
SDWA     EQU   0
SDWAFIOB EQU   SDWA+4
SDWAABCC EQU   SDWAFIOB
SDWACMPF EQU   SDWAABCC
SDWACTL1 EQU   SDWA+8
SDWACMKA EQU   SDWACTL1
SDWAMWPA EQU   SDWACTL1+1
SDWAPMKA EQU   SDWACTL1+4
SDWACTL2 EQU   SDWA+16
SDWACMKP EQU   SDWACTL2
SDWAMWPP EQU   SDWACTL2+1
SDWAPMKP EQU   SDWACTL2+4
SDWAGRSV EQU   SDWA+24
SDWANAME EQU   SDWA+88
SDWAEC1  EQU   SDWA+104
SDWAEMK1 EQU   SDWAEC1
SDWAMWP1 EQU   SDWAEC1+1
SDWAINT1 EQU   SDWAEC1+2
SDWANXT1 EQU   SDWAEC1+4
SDWAAEC1 EQU   SDWA+112
SDWAILC1 EQU   SDWAAEC1+1
SDWAINC1 EQU   SDWAAEC1+2
SDWAICD1 EQU   SDWAINC1+1
SDWAEC2  EQU   SDWA+120
SDWAEMK2 EQU   SDWAEC2
SDWAMWP2 EQU   SDWAEC2+1
SDWAINT2 EQU   SDWAEC2+2
SDWANXT2 EQU   SDWAEC2+4
SDWAAEC2 EQU   SDWA+128
SDWAILC2 EQU   SDWAAEC2+1
SDWAINC2 EQU   SDWAAEC2+2
SDWAICD2 EQU   SDWAINC2+1
SDWASRSV EQU   SDWA+136
SDWAIDNT EQU   SDWA+200
SDWAMCH  EQU   SDWA+204
SDWASTCK EQU   SDWAMCH
SDWAMCHI EQU   SDWAMCH+8
SDWAMCHS EQU   SDWAMCHI
SDWAMCHD EQU   SDWAMCHI+1
SDWARSR1 EQU   SDWAMCH+12
SDWARSR2 EQU   SDWAMCH+13
SDWAFLGS EQU   SDWA+232
SDWAERRA EQU   SDWAFLGS
SDWAERRB EQU   SDWAFLGS+1
SDWAERRC EQU   SDWAFLGS+2
SDWAERRD EQU   SDWAFLGS+3
SDWAIOFS EQU   SDWA+238
SDWACPUA EQU   SDWA+248
SDWAPARQ EQU   SDWA+252
SDWAACF2 EQU   SDWAPARQ+1
SDWAACF3 EQU   SDWAPARQ+2
SDWAACF4 EQU   SDWAPARQ+3
SDWALKWA EQU   SDWA+256
SDWALKWS EQU   SDWALKWA
SDWARECP EQU   SDWA+292
SDWASNPA EQU   SDWA+320
SDWADUMP EQU   SDWASNPA
SDWADPFS EQU   SDWADUMP+1
SDWADDAT EQU   SDWASNPA+4
SDWASDAT EQU   SDWADDAT
SDWAPDAT EQU   SDWADDAT+2
SDWADPSA EQU   SDWA+328
SDWADPSL EQU   SDWADPSA
SDWARA   EQU   SDWA+400
SDWADPVA EQU   SDWARA+2
IEZJSCB  EQU   0
JSCBSEC1 EQU   IEZJSCB+188
JSCHPCE  EQU   JSCBSEC1+4
JSCBPCC  EQU   JSCBSEC1+16
JSCBDCB  EQU   JSCBSEC1+36
JSCBOPTS EQU   JSCBSEC1+48
JSCBSWT1 EQU   JSCBSEC1+55
JSCBWTP  EQU   JSCBSEC1+64
JSCBWTFG EQU   JSCBWTP
JSCBEND1 EQU   IEZJSCB+260
TCBFIX   EQU   0
TCBFRS   EQU   TCBFIX
TCB      EQU   0
TCBPIE   EQU   TCB+4
TCBPMASK EQU   TCBPIE
TCBTIO   EQU   TCB+12
TCBCMP   EQU   TCB+16
TCBCMPF  EQU   TCBCMP
TCBCPP   EQU   TCBCMPF
TCBSTCC  EQU   TCBCMPF
TCBCDBL  EQU   TCBCMPF
TCBCWTO  EQU   TCBCMPF
TCBCIND  EQU   TCBCMPF
TCBCMSG  EQU   TCBCMPF
TCBTRN   EQU   TCB+20
TCBABF   EQU   TCBTRN
TCBMSS   EQU   TCB+24
TCBPKF   EQU   TCB+28
TCBFLGS  EQU   TCB+29
TCBFLGS1 EQU   TCBFLGS
TCBFLGS2 EQU   TCBFLGS+1
TCBFLGS3 EQU   TCBFLGS+2
TCBFLGS4 EQU   TCBFLGS+3
TCBFLGS5 EQU   TCBFLGS+4
TCBABWF  EQU   TCBFLGS5
TCBJPQ   EQU   TCB+44
TCBPURGE EQU   TCBJPQ
TCBGRS   EQU   TCB+48
TCBFSA   EQU   TCB+112
TCBTME   EQU   TCB+120
TCBJSTCB EQU   TCB+124
TCBTSFLG EQU   TCB+148
TCBTSTSK EQU   TCBTSFLG
TCBSTAB  EQU   TCB+160
TCBNSTAE EQU   TCBSTAB
TCBTCT   EQU   TCB+164
TCBTCTGF EQU   TCBTCT
TCBSCNDY EQU   TCB+172
TCBNDSP  EQU   TCBSCNDY
TCBNDSP1 EQU   TCBNDSP+1
TCBNDSP2 EQU   TCBNDSP+2
TCBNDSP3 EQU   TCBNDSP+3
TCBJSCB  EQU   TCB+180
TCBRECDE EQU   TCBJSCB
TCBEXT1  EQU   TCB+196
TCBBITS  EQU   TCB+200
TCBNDSP4 EQU   TCBBITS
TCBNDSP5 EQU   TCBBITS+1
TCBFLGS6 EQU   TCBBITS+2
TCBFLGS7 EQU   TCBBITS+3
TCBDAR   EQU   TCB+204
TCBDARC  EQU   TCBDAR
TCBEXT2  EQU   TCB+208
TCBFOE   EQU   TCB+244
TCBESTAE EQU   TCB+264
TCBESTRM EQU   TCBESTAE+1
TCBFBYT1 EQU   TCB+276
TCBFBYT2 EQU   TCB+277
TCBRV124 EQU   TCB+278
TCBRV133 EQU   TCB+279
TCBXTNT2 EQU   0
TCBGTF   EQU   TCBXTNT2
TCBTFLG  EQU   TCBGTF
TCBRV146 EQU   TCBXTNT2+28
TCBRV155 EQU   TCBXTNT2+29
TCBRV164 EQU   TCBXTNT2+30
TCBRV173 EQU   TCBXTNT2+31
JSCBSEC2 EQU   JSCBEND1
JSCBSEC3 EQU   JSCBEND1
JSCBJCT  EQU   JSCBSEC3
JSCBJCTA EQU   JSCBJCT+1
JSCBASID EQU   JSCBSEC3+8
JSCBFBYT EQU   JSCBSEC3+10
JSCBJNL  EQU   JSCBSEC3+28
JSCBJJSB EQU   JSCBJNL
JSCBSUB  EQU   JSCBSEC3+40
JSCSCT   EQU   JSCBSEC3+68
JSCBACT  EQU   JSCBSEC3+88
JSCBASWA EQU   JSCBSEC3+96
JSCRSV45 EQU   JSCBSEC3+112
JSCRSV46 EQU   JSCRSV45
JSCRSV47 EQU   JSCRSV45+2
         AGO   .@UNREFD                START UNREFERENCED COMPONENTS
JSCBEND3 EQU   JSCBSEC3+120
JSCRSV52 EQU   JSCBSEC3+116
JSCRSV51 EQU   JSCRSV47+1
JSCRSV50 EQU   JSCRSV47
JSCRSV49 EQU   JSCRSV46+1
JSCRSV48 EQU   JSCRSV46
JSCRSV44 EQU   JSCBSEC3+108
JSCRSV43 EQU   JSCBSEC3+104
JSCRSV42 EQU   JSCBSEC3+100
JSCBUFPT EQU   JSCBSEC3+92
JSCBSWSP EQU   JSCBSEC3+87
JSCRSV33 EQU   JSCBSEC3+86
JSCDDNUM EQU   JSCBSEC3+84
JSCRSV53 EQU   JSCBSEC3+82
JSCDDNNO EQU   JSCBSEC3+80
JSCBVATA EQU   JSCBSEC3+76
JSCTMCOR EQU   JSCBSEC3+72
JSCSCTP  EQU   JSCSCT+1
JSCRSV55 EQU   JSCSCT
JSCRSV54 EQU   JSCBSEC3+64
JSCDSABQ EQU   JSCBSEC3+60
JSCBSSIB EQU   JSCBSEC3+56
JSCBFRBA EQU   JSCBSEC3+48
JSCRSV28 EQU   JSCBSEC3+46
JSCBSONO EQU   JSCBSEC3+44
JSCBSUBA EQU   JSCBSUB+1
JSCRSV31 EQU   JSCBSUB
JSCBSMLR EQU   JSCBSEC3+36
JSCBJNLR EQU   JSCBSEC3+32
JSCBJNLA EQU   JSCBJNL+1
JSCBJSBT EQU   JSCBJJSB
JSCBJSBX EQU   JSCBJJSB
JSCBJSBA EQU   JSCBJJSB
JSCBJSBI EQU   JSCBJJSB
@NM00056 EQU   JSCBJJSB
JSCBJNLE EQU   JSCBJJSB
JSCBJNLF EQU   JSCBJJSB
JSCBJNLN EQU   JSCBJJSB
@NM00055 EQU   JSCBSEC3+24
JSCBJRBA EQU   JSCBSEC3+16
JSCBIECB EQU   JSCBSEC3+12
JSCBRV08 EQU   JSCBSEC3+11
JSCBRV07 EQU   JSCBFBYT
JSCBRV06 EQU   JSCBFBYT
JSCBRV05 EQU   JSCBFBYT
JSCBRV04 EQU   JSCBFBYT
JSCBRV03 EQU   JSCBFBYT
JSCBRV02 EQU   JSCBFBYT
JSCBADSP EQU   JSCBFBYT
JSCBRV01 EQU   JSCBFBYT
JSCBTJID EQU   JSCBASID
JSCBPSCB EQU   JSCBSEC3+4
JSCJCTP  EQU   JSCBJCTA
JSCRSV24 EQU   JSCBJCT
JSCBEND2 EQU   JSCBSEC2
@NM00060 EQU   TCBXTNT2+32
TCBRV181 EQU   TCBRV173
TCBRV180 EQU   TCBRV173
TCBRV179 EQU   TCBRV173
TCBRV178 EQU   TCBRV173
TCBRV177 EQU   TCBRV173
TCBRV176 EQU   TCBRV173
TCBRV175 EQU   TCBRV173
TCBRV174 EQU   TCBRV173
TCBRV172 EQU   TCBRV164
TCBRV171 EQU   TCBRV164
TCBRV170 EQU   TCBRV164
TCBRV169 EQU   TCBRV164
TCBRV168 EQU   TCBRV164
TCBRV167 EQU   TCBRV164
TCBRV166 EQU   TCBRV164
TCBRV165 EQU   TCBRV164
TCBRV163 EQU   TCBRV155
TCBRV162 EQU   TCBRV155
TCBRV161 EQU   TCBRV155
TCBRV160 EQU   TCBRV155
TCBRV159 EQU   TCBRV155
TCBRV158 EQU   TCBRV155
TCBRV157 EQU   TCBRV155
TCBRV156 EQU   TCBRV155
TCBRV154 EQU   TCBRV146
TCBRV153 EQU   TCBRV146
TCBRV152 EQU   TCBRV146
TCBRV151 EQU   TCBRV146
TCBRV150 EQU   TCBRV146
TCBRV149 EQU   TCBRV146
TCBRV148 EQU   TCBRV146
TCBRV147 EQU   TCBRV146
TCBRV145 EQU   TCBXTNT2+26
TCBRV144 EQU   TCBXTNT2+24
TCBCAUF  EQU   TCBXTNT2+20
TCBRV142 EQU   TCBXTNT2+16
TCBRSV49 EQU   TCBXTNT2+12
TCBEVENT EQU   TCBXTNT2+8
TCBRCMP  EQU   TCBXTNT2+5
TCBRSVAB EQU   TCBXTNT2+4
TCBGTFA  EQU   TCBGTF+1
TCBRSV47 EQU   TCBTFLG
TCBRSV46 EQU   TCBTFLG
TCBRSV45 EQU   TCBTFLG
TCBRSV44 EQU   TCBTFLG
TCBRSV43 EQU   TCBTFLG
TCBDSPIT EQU   TCBTFLG
TCBERRTN EQU   TCBTFLG
TCBASYNC EQU   TCBTFLG
@NM00059 EQU   TCB+296
TCBSVCA2 EQU   TCB+292
TCBSWASA EQU   TCB+288
TCBDBTB  EQU   TCB+284
TCBRPT   EQU   TCB+280
TCBRV141 EQU   TCBRV133
TCBRV140 EQU   TCBRV133
TCBRV139 EQU   TCBRV133
TCBRV138 EQU   TCBRV133
TCBRV137 EQU   TCBRV133
TCBRV136 EQU   TCBRV133
TCBRV135 EQU   TCBRV133
TCBRV134 EQU   TCBRV133
TCBRV132 EQU   TCBRV124
TCBRV131 EQU   TCBRV124
TCBRV130 EQU   TCBRV124
TCBRV129 EQU   TCBRV124
TCBRV128 EQU   TCBRV124
TCBRV127 EQU   TCBRV124
TCBRV126 EQU   TCBRV124
TCBRV125 EQU   TCBRV124
TCBRV123 EQU   TCBFBYT2
TCBRV122 EQU   TCBFBYT2
TCBECBNV EQU   TCBFBYT2
TCBSSSYN EQU   TCBFBYT2
TCBFPRAP EQU   TCBFBYT2
TCBFDW   EQU   TCBFBYT2
TCBFMW   EQU   TCBFBYT2
TCBCNCB  EQU   TCBFBYT2
TCBLLH   EQU   TCBFBYT1
TCBRV113 EQU   TCBFBYT1
TCBEOT   EQU   TCBFBYT1
TCBRTM2  EQU   TCBFBYT1
TCBPGNLY EQU   TCBFBYT1
TCBNDIOS EQU   TCBFBYT1
TCBACTIV EQU   TCBFBYT1
TCBEOTFM EQU   TCBFBYT1
TCBAFFN  EQU   TCB+274
TCBCCPVI EQU   TCB+272
TCBUKYSP EQU   TCB+268
TCBMODE  EQU   TCBESTAE+3
TCBERTYP EQU   TCBESTAE+2
TCBRV314 EQU   TCBESTRM
TCBRV313 EQU   TCBESTRM
TCBRV312 EQU   TCBESTRM
TCBRV311 EQU   TCBESTRM
TCBRV310 EQU   TCBESTRM
TCBRV309 EQU   TCBESTRM
TCBRV308 EQU   TCBESTRM
TCBETERM EQU   TCBESTRM
TCBSCBKY EQU   TCBESTAE
TCBRTM12 EQU   TCB+260
TCBTCBID EQU   TCB+256
TCBRSV96 EQU   TCB+252
TCBSWA   EQU   TCB+248
TCBFOEA  EQU   TCBFOE+1
TCBRSV42 EQU   TCBFOE
TCBRV306 EQU   TCB+240
TCBRSV41 EQU   TCB+239
TCBTID   EQU   TCB+238
TCBRSVAA EQU   TCB+237
TCBABCUR EQU   TCB+236
TCBTMSAV EQU   TCB+232
TCBIOTIM EQU   TCB+228
TCBRTWA  EQU   TCB+224
TCBBACK  EQU   TCB+220
TCBTIRB  EQU   TCB+216
TCBAECB  EQU   TCB+212
TCBEXT2A EQU   TCBEXT2+1
TCBRSV39 EQU   TCBEXT2
TCBSTMCT EQU   TCB+207
TCBSYSCT EQU   TCB+206
TCBRSV37 EQU   TCB+205
TCBEXSVC EQU   TCBDAR
TCBDARMS EQU   TCBDAR
TCBDARWT EQU   TCBDAR
TCBDARO  EQU   TCBDAR
TCBDARMC EQU   TCBDARC
TCBDARD  EQU   TCBDAR
TCBDARS  EQU   TCBDAR
TCBDARP  EQU   TCBDAR
TCBGTOFM EQU   TCBFLGS7
TCBADMP  EQU   TCBFLGS7
TCBRSTSK EQU   TCBFLGS7
TCBSVCS  EQU   TCBFLGS7
TCBSTACK EQU   TCBFLGS7
TCBRSV34 EQU   TCBFLGS7
TCBRSV33 EQU   TCBFLGS7
TCBGPECB EQU   TCBFLGS7
TCBNTJS  EQU   TCBFLGS6
TCBAPG   EQU   TCBFLGS6
TCBMIGR  EQU   TCBFLGS6
TCBRV303 EQU   TCBFLGS6
TCBSPVLK EQU   TCBFLGS6
TCBCPU   EQU   TCBFLGS6
TCBPIE17 EQU   TCBFLGS6
TCBRV    EQU   TCBFLGS6
TCBRSV79 EQU   TCBNDSP5
TCBRSV78 EQU   TCBNDSP5
TCBRSV77 EQU   TCBNDSP5
TCBRSV76 EQU   TCBNDSP5
TCBRSV75 EQU   TCBNDSP5
TCBRSV74 EQU   TCBNDSP5
TCBRSV95 EQU   TCBNDSP5
TCBRSV94 EQU   TCBNDSP5
TCBRSV93 EQU   TCBNDSP4
TCBRSV92 EQU   TCBNDSP4
TCBRSV91 EQU   TCBNDSP4
TCBRSV90 EQU   TCBNDSP4
TCBRSV89 EQU   TCBNDSP4
TCBRSV88 EQU   TCBNDSP4
TCBRSV87 EQU   TCBNDSP4
TCBRSV86 EQU   TCBNDSP4
TCBEXT1A EQU   TCBEXT1+1
TCBRSV32 EQU   TCBEXT1
TCBEXCPD EQU   TCB+192
TCBIOBRC EQU   TCB+188
TCBDDWTC EQU   TCB+186
TCBDDEXC EQU   TCB+184
TCBJSCBB EQU   TCBJSCB+1
@NM00058 EQU   TCBRECDE
TCBREC   EQU   TCBRECDE
TCBMDIDS EQU   TCB+176
TCBNDINT EQU   TCBNDSP3
TCBRSV27 EQU   TCBNDSP3
TCBRSV26 EQU   TCBNDSP3
TCBRSV25 EQU   TCBNDSP3
TCBRSV24 EQU   TCBNDSP3
TCBSRBND EQU   TCBNDSP3
TCBRV302 EQU   TCBNDSP3
TCBLJSND EQU   TCBNDSP3
TCBABE   EQU   TCBNDSP2
TCBDSS   EQU   TCBNDSP2
TCBOWAIT EQU   TCBNDSP2
TCBIWAIT EQU   TCBNDSP2
TCBNDTS  EQU   TCBNDSP2
TCBNDSVC EQU   TCBNDSP2
TCBSTPP  EQU   TCBNDSP2
TCBABD   EQU   TCBNDSP2
TCBRSV22 EQU   TCBNDSP1
TCBPIEND EQU   TCBNDSP1
TCBTPSP  EQU   TCBNDSP1
TCBDDRND EQU   TCBNDSP1
TCBRSPND EQU   TCBNDSP1
TCBRSTND EQU   TCBNDSP1
TCBDARPN EQU   TCBNDSP1
TCBDARTN EQU   TCBNDSP1
TCBNDSP0 EQU   TCBNDSP
TCBUSER  EQU   TCB+168
TCBTCTB  EQU   TCBTCT+1
TCBRSV9C EQU   TCBTCTGF
TCBRSV9B EQU   TCBTCTGF
TCBRSV9A EQU   TCBTCTGF
TCBRSV99 EQU   TCBTCTGF
TCBRSV98 EQU   TCBTCTGF
TCBRSV97 EQU   TCBTCTGF
TCBRSV20 EQU   TCBTCTGF
TCBSMFGF EQU   TCBTCTGF
TCBSTABB EQU   TCBSTAB+1
TCBSTCUR EQU   TCBNSTAE
TCBRV301 EQU   TCBNSTAE
TCBSYNCH EQU   TCBNSTAE
TCBHALT  EQU   TCBNSTAE
TCBPPSUP EQU   TCBNSTAE
TCB33E   EQU   TCBNSTAE
TCBQUIES EQU   TCBNSTAE
TCBSTABE EQU   TCBNSTAE
TCBAQE   EQU   TCB+156
TCBPQE   EQU   TCB+152
TCBTSDP  EQU   TCB+151
TCBTSLP  EQU   TCB+150
TCBSTPCT EQU   TCB+149
TCBCPUBN EQU   TCBTSFLG
TCBDYDSP EQU   TCBTSFLG
TCBRSV18 EQU   TCBTSFLG
TCBRSV17 EQU   TCBTSFLG
TCBTIOTG EQU   TCBTSFLG
TCBATT   EQU   TCBTSFLG
TCBSTPPR EQU   TCBTSFLG
TCBRV300 EQU   TCBTSTSK
TCBECB   EQU   TCB+144
TCBIQE   EQU   TCB+140
TCBLTC   EQU   TCB+136
TCBOTC   EQU   TCB+132
TCBNTC   EQU   TCB+128
TCBJSTCA EQU   TCBJSTCB+1
TCBRSV16 EQU   TCBJSTCB
TCBTQET  EQU   TCBTME
TCBTCB   EQU   TCB+116
TCBFSAB  EQU   TCBFSA+1
TCBQEL   EQU   TCBFSA
TCBGRS15 EQU   TCBGRS+60
TCBGRS14 EQU   TCBGRS+56
TCBGRS13 EQU   TCBGRS+52
TCBGRS12 EQU   TCBGRS+48
TCBGRS11 EQU   TCBGRS+44
TCBGRS10 EQU   TCBGRS+40
TCBGRS9  EQU   TCBGRS+36
TCBGRS8  EQU   TCBGRS+32
TCBGRS7  EQU   TCBGRS+28
TCBGRS6  EQU   TCBGRS+24
TCBGRS5  EQU   TCBGRS+20
TCBGRS4  EQU   TCBGRS+16
TCBGRS3  EQU   TCBGRS+12
TCBGRS2  EQU   TCBGRS+8
TCBGRS1  EQU   TCBGRS+4
TCBGRS0  EQU   TCBGRS
TCBJPQB  EQU   TCBJPQ+1
TCBRSV15 EQU   TCBPURGE
TCBRSV14 EQU   TCBPURGE
TCBRSV13 EQU   TCBPURGE
TCBRSV12 EQU   TCBPURGE
TCBRSV11 EQU   TCBPURGE
TCBRSV10 EQU   TCBPURGE
TCBRSV09 EQU   TCBPURGE
TCBJPQF  EQU   TCBPURGE
TCBJLB   EQU   TCB+40
TCBLLS   EQU   TCB+36
TCBDSP   EQU   TCB+35
TCBLMP   EQU   TCB+34
TCBPNDSP EQU   TCBFLGS5
TCBFCD1  EQU   TCBFLGS5
TCBSTP   EQU   TCBFLGS5
TCBSYS   EQU   TCBFLGS5
TCBANDSP EQU   TCBFLGS5
TCBPAGE  EQU   TCBFLGS5
TCBUXNDF EQU   TCBABWF
TCBFC    EQU   TCBFLGS5
TCBONDSP EQU   TCBFLGS4
TCBMPCND EQU   TCBFLGS4
TCBMPCVQ EQU   TCBFLGS4
TCBUXNDV EQU   TCBFLGS4
TCBHNDSP EQU   TCBFLGS4
TCBRQENA EQU   TCBFLGS4
TCBSER   EQU   TCBFLGS4
TCBNDUMP EQU   TCBFLGS4
TCBDWSTA EQU   TCBFLGS3
TCBRSV08 EQU   TCBFLGS3
TCBRSV07 EQU   TCBFLGS3
TCBRSV06 EQU   TCBFLGS3
TCBABGM  EQU   TCBFLGS3
TCBABTRM EQU   TCBFLGS3
TCBADINP EQU   TCBFLGS3
TCBFSM   EQU   TCBFLGS3
TCBFTS   EQU   TCBFLGS2
TCBFETXR EQU   TCBFLGS2
TCBFDSOP EQU   TCBFLGS2
TCBFJMC  EQU   TCBFLGS2
TCBFSMC  EQU   TCBFLGS2
TCBFABOP EQU   TCBFLGS2
TCBFSTI  EQU   TCBFLGS2
TCBFOINP EQU   TCBFLGS2
TCBFX    EQU   TCBFLGS1
TCBFS    EQU   TCBFLGS1
TCBFT    EQU   TCBFLGS1
TCBPDUMP EQU   TCBFLGS1
TCBNONPR EQU   TCBFLGS1
TCBFERA  EQU   TCBFLGS1
TCBFE    EQU   TCBFLGS1
TCBFA    EQU   TCBFLGS1
TCBZERO  EQU   TCBPKF
TCBFLAG  EQU   TCBPKF
TCBMSSB  EQU   TCBMSS+1
TCBRSV03 EQU   TCBMSS
TCBTRNB  EQU   TCBTRN+1
TCBRSV02 EQU   TCBABF
TCBOLTEP EQU   TCBABF
TCBTCP   EQU   TCBABF
TCBTCPP  EQU   TCBABF
TCBRSV01 EQU   TCBABF
TCBGRPH  EQU   TCBABF
TCBNOCHK EQU   TCBABF
TCBMOD91 EQU   TCBABF
TCBCMPC  EQU   TCBCMP+1
TCBRV318 EQU   TCBCMSG
TCBRV317 EQU   TCBCIND
TCBRV316 EQU   TCBCWTO
TCBCASID EQU   TCBCDBL
TCBNOCC  EQU   TCBSTCC
TCBDMPO  EQU   TCBCPP
TCBCSTEP EQU   TCBCMPF
TCBCREQ  EQU   TCBCMPF
TCBDEB   EQU   TCB+8
TCBPIEA  EQU   TCBPIE+1
TCBPM    EQU   TCBPMASK
@NM00057 EQU   TCBPMASK
TCBRBP   EQU   TCB
TCBFRS6  EQU   TCBFRS+24
TCBFRS4  EQU   TCBFRS+16
TCBFRS2  EQU   TCBFRS+8
TCBFRS0  EQU   TCBFRS
JSCBCSCB EQU   JSCBSEC1+68
JSCBPMG  EQU   JSCBWTP+2
JSCBWTSP EQU   JSCBWTP+1
JSCRSV23 EQU   JSCBWTFG
JSCRSV22 EQU   JSCBWTFG
JSCRSV21 EQU   JSCBWTFG
JSCRSV20 EQU   JSCBWTFG
JSCRSV19 EQU   JSCBWTFG
JSCRSV18 EQU   JSCBWTFG
JSCBRET  EQU   JSCBWTFG
JSCBIOFG EQU   JSCBWTFG
@NM00054 EQU   JSCBSEC1+60
JSCBQMPI EQU   JSCBSEC1+56
JSCBPMSG EQU   JSCBSWT1
JSCRSV16 EQU   JSCBSWT1
JSCRSV15 EQU   JSCBSWT1
JSCRSV14 EQU   JSCBSWT1
JSCRSV13 EQU   JSCBSWT1
JSCRSV12 EQU   JSCBSWT1
JSCRSV11 EQU   JSCBSWT1
JSCBPASS EQU   JSCBSWT1
JSCBTTTR EQU   JSCBSEC1+52
JSCRSV10 EQU   JSCBSEC1+49
JSCBAUTH EQU   JSCBOPTS
JSCSIOTS EQU   JSCBOPTS
JSCRSV08 EQU   JSCBOPTS
JSCRSV07 EQU   JSCBOPTS
JSCRSV06 EQU   JSCBOPTS
JSCBLONG EQU   JSCBOPTS
JSCRSV05 EQU   JSCBOPTS
JSCRSV04 EQU   JSCBOPTS
JSCBSECB EQU   JSCBSEC1+44
JSCRSV03 EQU   JSCBSEC1+41
JSCBSTEP EQU   JSCBSEC1+40
JSCBDCBA EQU   JSCBDCB+1
JSCRSV02 EQU   JSCBDCB
JSCBID   EQU   JSCBSEC1+32
JSCBDBTB EQU   JSCBSEC1+28
JSCBIJSC EQU   JSCBSEC1+24
JSCBTCBP EQU   JSCBSEC1+20
JSCBTCP  EQU   JSCBSEC1+12
JSCBSHR  EQU   JSCBSEC1+8
JSCHPCEA EQU   JSCHPCE+1
JSCRSV32 EQU   JSCHPCE
JSCRSV01 EQU   JSCBSEC1
@NM00053 EQU   IEZJSCB
@NM00052 EQU   SDWA+512
SDWAVRA  EQU   SDWARA+4
SDWAURAL EQU   SDWARA+3
@NM00051 EQU   SDWADPVA
SDWAEBC  EQU   SDWADPVA
SDWAHEX  EQU   SDWADPVA
SDWAVRAL EQU   SDWARA
@NM00050 EQU   SDWA+396
SDWACOMP EQU   SDWA+392
SDWARCPL EQU   SDWA+364
@NM00049 EQU   SDWADPSA+32
SDWATO4  EQU   SDWADPSL+28
SDWAFRM4 EQU   SDWADPSL+24
SDWATO3  EQU   SDWADPSL+20
SDWAFRM3 EQU   SDWADPSL+16
SDWATO2  EQU   SDWADPSL+12
SDWAFRM2 EQU   SDWADPSL+8
SDWATO1  EQU   SDWADPSL+4
SDWAFRM1 EQU   SDWADPSL
@NM00048 EQU   SDWADDAT+3
@NM00047 EQU   SDWAPDAT
SDWAUSPL EQU   SDWAPDAT
SDWADPSW EQU   SDWAPDAT
SDWATJPA EQU   SDWAPDAT
SDWATLPA EQU   SDWAPDAT
SDWADREG EQU   SDWAPDAT
SDWADSAH EQU   SDWAPDAT
SDWADSAS EQU   SDWAPDAT
@NM00046 EQU   SDWADDAT+1
@NM00045 EQU   SDWASDAT
SDWAQQS  EQU   SDWASDAT
SDWACBS  EQU   SDWASDAT
SDWAGTF  EQU   SDWASDAT
SDWASWA  EQU   SDWASDAT
SDWALSQA EQU   SDWASDAT
SDWASQA  EQU   SDWASDAT
SDWANUC  EQU   SDWASDAT
@NM00044 EQU   SDWADUMP+2
@NM00043 EQU   SDWADPFS
SDWASLST EQU   SDWADPFS
@NM00042 EQU   SDWADPFS
SDWADLST EQU   SDWADPFS
SDWADPT  EQU   SDWADPFS
SDWADPID EQU   SDWADUMP
SDWADPLA EQU   SDWA+316
SDWAREXN EQU   SDWARECP+16
SDWACSCT EQU   SDWARECP+8
SDWAMODN EQU   SDWARECP
@NM00041 EQU   SDWA+290
SDWAASID EQU   SDWA+288
SDWATALW EQU   SDWALKWS+28
SDWATDLW EQU   SDWALKWS+24
SDWATNLW EQU   SDWALKWS+20
SDWAAPLW EQU   SDWALKWS+16
SDWAIPLW EQU   SDWALKWS+12
SDWAILLW EQU   SDWALKWS+8
SDWAIULW EQU   SDWALKWS+4
SDWAICLW EQU   SDWALKWS
SDWAFLLK EQU   SDWAACF4
SDWACMS  EQU   SDWAACF4
SDWAOPTM EQU   SDWAACF4
SDWATADB EQU   SDWAACF4
SDWATDNB EQU   SDWAACF4
SDWATNCB EQU   SDWAACF4
SDWAILCH EQU   SDWAACF4
SDWAIUCB EQU   SDWAACF4
SDWAICAT EQU   SDWAACF3
SDWAIPRG EQU   SDWAACF3
SDWASALL EQU   SDWAACF3
SDWAASMP EQU   SDWAACF3
SDWADISP EQU   SDWAACF3
@NM00040 EQU   SDWAACF3
@NM00039 EQU   SDWAACF2
SDWAFREE EQU   SDWAACF2
SDWAUPRG EQU   SDWAACF2
@NM00038 EQU   SDWAACF2
SDWASPIN EQU   SDWAACF2
@NM00037 EQU   SDWAACF2
SDWARCRD EQU   SDWAACF2
SDWARCDE EQU   SDWAPARQ
SDWALCPU EQU   SDWACPUA+2
@NM00036 EQU   SDWACPUA
SDWARECA EQU   SDWA+244
SDWARTYA EQU   SDWA+240
@NM00035 EQU   SDWA+239
@NM00034 EQU   SDWAIOFS
SDWANIOP EQU   SDWAIOFS
SDWANOIO EQU   SDWAIOFS
SDWAIOHT EQU   SDWAIOFS
SDWAIOQR EQU   SDWAIOFS
SDWAFMID EQU   SDWA+236
@NM00033 EQU   SDWAERRD
SDWAMCIV EQU   SDWAERRD
SDWARPIV EQU   SDWAERRD
SDWAMABD EQU   SDWAERRD
SDWACTS  EQU   SDWAERRD
SDWASTAE EQU   SDWAERRD
SDWANRBE EQU   SDWAERRD
SDWACLUP EQU   SDWAERRD
@NM00032 EQU   SDWAERRC
SDWAEAS  EQU   SDWAERRC
SDWAPERC EQU   SDWAERRC
SDWAIRB  EQU   SDWAERRC
SDWASTAI EQU   SDWAERRC
SDWASTAF EQU   SDWAERRC
SDWASRBM EQU   SDWAERRB
SDWALDIS EQU   SDWAERRB
SDWAENRB EQU   SDWAERRB
SDWATYP1 EQU   SDWAERRB
@NM00031 EQU   SDWAERRB
SDWAPGIO EQU   SDWAERRA
SDWATEXC EQU   SDWAERRA
SDWASVCE EQU   SDWAERRA
SDWAABTM EQU   SDWAERRA
SDWASVCD EQU   SDWAERRA
SDWARKEY EQU   SDWAERRA
SDWAPCHK EQU   SDWAERRA
SDWAMCHK EQU   SDWAERRA
SDWATIME EQU   SDWAMCH+20
SDWARFSA EQU   SDWAMCH+16
@NM00030 EQU   SDWAMCH+14
SDWAVEQR EQU   SDWARSR2
SDWAPGFX EQU   SDWARSR2
SDWAFLSQ EQU   SDWARSR2
SDWAFSQA EQU   SDWARSR2
SDWANUCL EQU   SDWARSR2
SDWASPER EQU   SDWARSR2
SDWAINTC EQU   SDWARSR2
SDWAOFLN EQU   SDWARSR2
SDWACHNG EQU   SDWARSR1
SDWAMSER EQU   SDWARSR1
@NM00029 EQU   SDWARSR1
SDWACPID EQU   SDWAMCH+10
SDWATERR EQU   SDWAMCHD
SDWAFPRX EQU   SDWAMCHD
SDWAINSF EQU   SDWAMCHD
SDWAACR  EQU   SDWAMCHD
SDWASCK  EQU   SDWAMCHD
SDWAPSWU EQU   SDWAMCHD
SDWAREGU EQU   SDWAMCHD
SDWASKYF EQU   SDWAMCHD
@NM00028 EQU   SDWAMCHS
SDWARSRF EQU   SDWAMCHS
SDWARSRC EQU   SDWAMCHS
SDWAINVP EQU   SDWAMCHS
SDWATSVL EQU   SDWAMCHS
SDWARCDF EQU   SDWAMCHS
SDWASRVL EQU   SDWAMCHS
SDWASCKE EQU   SDWASTCK+4
SDWASCKB EQU   SDWASTCK
SDWALNTH EQU   SDWAIDNT+1
SDWASPID EQU   SDWAIDNT
SDWASR15 EQU   SDWASRSV+60
SDWASR14 EQU   SDWASRSV+56
SDWASR13 EQU   SDWASRSV+52
SDWASR12 EQU   SDWASRSV+48
SDWASR11 EQU   SDWASRSV+44
SDWASR10 EQU   SDWASRSV+40
SDWASR09 EQU   SDWASRSV+36
SDWASR08 EQU   SDWASRSV+32
SDWASR07 EQU   SDWASRSV+28
SDWASR06 EQU   SDWASRSV+24
SDWASR05 EQU   SDWASRSV+20
SDWASR04 EQU   SDWASRSV+16
SDWASR03 EQU   SDWASRSV+12
SDWASR02 EQU   SDWASRSV+8
SDWASR01 EQU   SDWASRSV+4
SDWASR00 EQU   SDWASRSV
SDWATRN2 EQU   SDWAAEC2+4
SDWAIPC2 EQU   SDWAICD2
SDWAIMC2 EQU   SDWAICD2
SDWAIPR2 EQU   SDWAICD2
@NM00027 EQU   SDWAINC2
@NM00026 EQU   SDWAILC2
SDWAIL2  EQU   SDWAILC2
@NM00025 EQU   SDWAILC2
@NM00024 EQU   SDWAAEC2
SDWAADD2 EQU   SDWANXT2+1
@NM00023 EQU   SDWANXT2
@NM00022 EQU   SDWAEC2+3
SDWASGN2 EQU   SDWAINT2
SDWAEXP2 EQU   SDWAINT2
SDWADEC2 EQU   SDWAINT2
SDWAFPO2 EQU   SDWAINT2
SDWACC2  EQU   SDWAINT2
@NM00021 EQU   SDWAINT2
SDWAPGM2 EQU   SDWAMWP2
SDWAWAT2 EQU   SDWAMWP2
SDWAMCK2 EQU   SDWAMWP2
SDWAECT2 EQU   SDWAMWP2
SDWAKEY2 EQU   SDWAMWP2
SDWAEXT2 EQU   SDWAEMK2
SDWAIO2  EQU   SDWAEMK2
SDWATRM2 EQU   SDWAEMK2
@NM00020 EQU   SDWAEMK2
SDWAPER2 EQU   SDWAEMK2
@NM00019 EQU   SDWAEMK2
SDWATRAN EQU   SDWAAEC1+4
SDWAIPC1 EQU   SDWAICD1
SDWAIMC1 EQU   SDWAICD1
SDWAIPR1 EQU   SDWAICD1
@NM00018 EQU   SDWAINC1
@NM00017 EQU   SDWAILC1
SDWAIL1  EQU   SDWAILC1
@NM00016 EQU   SDWAILC1
@NM00015 EQU   SDWAAEC1
SDWAADD1 EQU   SDWANXT1+1
@NM00014 EQU   SDWANXT1
@NM00013 EQU   SDWAEC1+3
SDWASGN1 EQU   SDWAINT1
SDWAEXP1 EQU   SDWAINT1
SDWADEC1 EQU   SDWAINT1
SDWAFPO1 EQU   SDWAINT1
SDWACC1  EQU   SDWAINT1
@NM00012 EQU   SDWAINT1
SDWAPGM1 EQU   SDWAMWP1
SDWAWAT1 EQU   SDWAMWP1
SDWAMCK1 EQU   SDWAMWP1
SDWAECT1 EQU   SDWAMWP1
SDWAKEY1 EQU   SDWAMWP1
SDWAEXT1 EQU   SDWAEMK1
SDWAIO1  EQU   SDWAEMK1
SDWATRM1 EQU   SDWAEMK1
@NM00011 EQU   SDWAEMK1
SDWAPER1 EQU   SDWAEMK1
@NM00010 EQU   SDWAEMK1
SDWAIOBR EQU   SDWA+100
SDWAEPA  EQU   SDWA+96
@NM00009 EQU   SDWANAME+4
SDWARBAD EQU   SDWANAME
SDWAGR15 EQU   SDWAGRSV+60
SDWAGR14 EQU   SDWAGRSV+56
SDWAGR13 EQU   SDWAGRSV+52
SDWAGR12 EQU   SDWAGRSV+48
SDWAGR11 EQU   SDWAGRSV+44
SDWAGR10 EQU   SDWAGRSV+40
SDWAGR09 EQU   SDWAGRSV+36
SDWAGR08 EQU   SDWAGRSV+32
SDWAGR07 EQU   SDWAGRSV+28
SDWAGR06 EQU   SDWAGRSV+24
SDWAGR05 EQU   SDWAGRSV+20
SDWAGR04 EQU   SDWAGRSV+16
SDWAGR03 EQU   SDWAGRSV+12
SDWAGR02 EQU   SDWAGRSV+8
SDWAGR01 EQU   SDWAGRSV+4
SDWAGR00 EQU   SDWAGRSV
SDWANXTP EQU   SDWACTL2+5
SDWASGP  EQU   SDWAPMKP
SDWAEUP  EQU   SDWAPMKP
SDWADOP  EQU   SDWAPMKP
SDWAFPP  EQU   SDWAPMKP
SDWACCP  EQU   SDWAPMKP
SDWAILP  EQU   SDWAPMKP
SDWAINTP EQU   SDWACTL2+2
SDWASPVP EQU   SDWAMWPP
SDWAWATP EQU   SDWAMWPP
SDWAMCKP EQU   SDWAMWPP
@NM00008 EQU   SDWAMWPP
SDWAKEYP EQU   SDWAMWPP
SDWAEXTP EQU   SDWACMKP
SDWAIOP  EQU   SDWACMKP
SDWANXTA EQU   SDWACTL1+5
SDWASGA  EQU   SDWAPMKA
SDWAEUA  EQU   SDWAPMKA
SDWADOA  EQU   SDWAPMKA
SDWAFPA  EQU   SDWAPMKA
SDWACCA  EQU   SDWAPMKA
SDWAILA  EQU   SDWAPMKA
SDWAINTA EQU   SDWACTL1+2
SDWASPVA EQU   SDWAMWPA
SDWAWATA EQU   SDWAMWPA
SDWAMCKA EQU   SDWAMWPA
@NM00007 EQU   SDWAMWPA
SDWAKEYA EQU   SDWAMWPA
SDWAEXTA EQU   SDWACMKA
SDWAIOA  EQU   SDWACMKA
SDWACMPC EQU   SDWAABCC+1
@NM00006 EQU   SDWACMPF
SDWASTCC EQU   SDWACMPF
@NM00005 EQU   SDWACMPF
SDWASTEP EQU   SDWACMPF
SDWAREQ  EQU   SDWACMPF
SDWAPARM EQU   SDWA
ERESCD   EQU   ERETURNS+2
ERETCD   EQU   ERETURNS
@NM00004 EQU   EECNTRLS+1
@NM00003 EQU   EECNTRLS+1
@NM00002 EQU   EPARMLST
.@UNREFD ANOP                          END UNREFERENCED COMPONENTS
@ENDDATA EQU   *
         END   IEFAB4EA,(C'PLS1931',0701,78089)
