         TITLE 'IEFAB4ED - ALLOCATION COMMON ESTAE EXIT                *
                        '
IEFAB4ED   CSECT
@MAINENT   DS 0H
           USING *,15
           B @PROLOG                    BRANCH AROUND MODULE ID
           MODID  BR=NO                 MODULE ID             @G24LPSJ
           DROP 15
@PROLOG    BALR 12,0
@PSTART    DS 0H
           USING @PSTART,12
           LA 11,12                     LOAD VALUE OF 12
           CR 0,11                      COMPARE WITH REG 0
           BNE SETPTR                   BR IF REG1 POINTS TO SDWA
           LR 11,2                      NO SDWA; REG2 HAS USER PARM @
           B COMMON
SETPTR     L 11,0(1)                    GET USER PARMS @OUT OF SDWA
COMMON     EQU *
           LR 9,11                      SAVE USER PARMS @
           L 11,32(11)                  AUTO-CORE @ OUT OF USER PARMS
           USING @DATD,11
           LR 13,11                     ADDR OF REG SAVE AREA
JSCBDISP EQU 188
JSCBAOS1 EQU  72
JSCBAOS2 EQU 192
*SAVREG14 = R14;                       /*SAVE RETURN ADDRESS         */
         ST    R14,SAVREG14                                     01S0064
*ASWAPTR1 = R9;                        /*SAVE PTR FOR USER PARMS     */
         LR    ASWAPTR1,R9                                      01S0065
*IF R0 = TWELVE THEN                   /*DOES SDWA EXIST             */
         CH    R0,@CH00032                                      01S0066
         BNE   @RF00066                                         01S0066
*  SDWAPTR = ZERO;                     /*NO ZERO BASE PTR            */
         SLR   SDWAPTR,SDWAPTR                                  01S0067
*ELSE                                  /*YES - SDWA EXISTS           */
*  SDWAPTR = R1;                       /*GET BASE PTR                */
         B     @RC00066                                         01S0068
@RF00066 LR    SDWAPTR,R1                                       01S0068
*RFY (R0,R1,R9,R14) UNRSTD;                                     01S0069
@RC00066 DS    0H                                               01S0070
*TCBPTR = CURNTCBP;                    /*GET CURRENT TCB             */
         L     @09,LOC16PTR                                     01S0070
         L     @09,TCBLISTP(,@09)                               01S0070
         L     TCBPTR,CURNTCBP(,@09)                            01S0070
*JSCBPTR = JSCBACT;                    /*ACTIVE JSCB FROM CURRENT    */
         L     @09,TCBJSCB(,TCBPTR)                             01S0071
         L     JSCBPTR,JSCBACT(,@09)                            01S0071
*RFY IEZJSCB BASED(JSCBPTR);           /*WORK WITH ACTIVE            */
*IF ASWAPTR1-> ASWANOCH = ON THEN      /*IS ASWA CHAINED TO     01S0073
*                                        JSCB                @ZA18154*/
         TM    ASWANOCH(ASWAPTR1),B'00001000'                   01S0073
         BNO   @RF00073                                         01S0073
*  ASWAPTR = ASWAPTR1;                 /*IF NO PROCESS ONLY ONE 01S0074
*                                        ASWA                @ZA18154*/
         LR    ASWAPTR,ASWAPTR1                                 01S0074
*ELSE                                  /*CHECK CHAIN         @ZA18154*/
*  DO;                                                          01S0075
         B     @RC00073                                         01S0075
@RF00073 DS    0H                                               01S0076
*    IF JSCBASWA ^= ZERO &             /*AT LEAST ONE ASWA ON CHAIN? */
*       JSCBASWA -> ASWASCBP = ASWAPTR1 ->ASWASCBP THEN /* AND IS FOR
*                                        SAME ESTAE AS THIS ONE      */
         L     @09,JSCBASWA(,JSCBPTR)                           01S0076
         LTR   @09,@09                                          01S0076
         BZ    @RF00076                                         01S0076
         CLC   ASWASCBP(4,@09),ASWASCBP(ASWAPTR1)               01S0076
         BNE   @RF00076                                         01S0076
*      ASWAPTR = JSCBASWA;             /*START WITH LAST ASWA        */
         LR    ASWAPTR,@09                                      01S0077
*    ELSE                              /*ERROR BEFORE 1ST CHAINED    */
*      ASWAPTR = ASWAPTR1;             /*INPUT 1ST IS ALSO LAST      */
         B     @RC00076                                         01S0078
@RF00076 LR    ASWAPTR,ASWAPTR1                                 01S0078
*    JSCBASWA = ASWAPTR1 -> ASWAOLDP;  /*RESET OLD JSCBASWA IF ANY   */
@RC00076 MVC   JSCBASWA(4,JSCBPTR),ASWAOLDP(ASWAPTR1)           01S0079
*  END;                                                         01S0080
*LASTEXIT = ASWACSCT;                  /*SAVE CSECT OF LAST ASWA     */
@RC00073 MVC   LASTEXIT(8),ASWACSCT(ASWAPTR)                    01S0081
*ASWALPTR = ASWAPTR;                   /*SAVE PTR TO LAST            */
         LR    ASWALPTR,ASWAPTR                                 01S0082
*SWITCHES = ''B;                       /*ZERO INTERNAL SWITCHES      */
         MVI   SWITCHES,X'00'                                   01S0083
*/********************************************************************/
*/*                                                                  */
*/* SEGMENT NAME - DUMPCHEK                                          */
*/*                                                                  */
*/* DESCRIPTIVE NAME - DUMP CHECKS                                   */
*/*                                                                  */
*/* FUNCTION - DETERMINE IF AN SDUMP SHOULD BE ISSUED                */
*/*                                                                  */
*/* OPERATION -                                                      */
*/*            . IF NO SDWA EXISTS, A DUMP SHOULD BE TAKEN           */
*/*            . IF ONE DOES EXIST, ADDITIONAL CHECKS ON THE         */
*/*              NATURE OF THE ERROR ARE MADE TO DETERMINE           */
*/*              IF SDUMP IS APPROPRIATE. THESE CHECKS ARE           */
*/*              DOCUMENTED BY THE CODE.                             */
*/*                                                                  */
*/* ENTRY - INLINE SUBROUTINE ENTERED AT THE TOP                     */
*/*                                                                  */
*/*   PURPOSE - SEE FUNCTION                                         */
*/*                                                                  */
*/*   INPUT -                                                        */
*/*          . SDWAPTR - PTR TO SDWA IF ONE EXISTS                   */
*/*          . ASWAPTR - POINTS TO LAST ASWA ON THE CHAIN - THE ONE  */
*/*                      RELATED TO THE SUB-FUNCTION OF ALLOCATION   */
*/*                      THAT WAS PROCESSING WHEN THE ERROR OCCURRED.*/
*/*                                                                  */
*/* EXIT - INLINE SUBROUTINE THAT EXITS AT THE BOTTOM                */
*/*                                                                  */
*/*   CONDITION - SDUMP DETERMINATION MADE                           */
*/*                                                                  */
*/*   OUTPUT -                                                       */
*/*          . DUMPSW - ON IF SDUMP TO BE ISSUED                     */
*/*          . USERPROB - ON IF PROBLEM WAS DUE TO USER ERROR        */
*/*                                                                  */
*/*   RETURN CODES - NONE                                            */
*/*                                                                  */
*/********************************************************************/
*IF SDWAPTR = ZERO THEN                /*IF NO SDWA EXISTS           */
         LTR   SDWAPTR,SDWAPTR                                  02S0084
         BNZ   @RF00084                                         02S0084
*  DUMPSW = ON;                        /*DUMP TO BE TAKEN            */
         OI    DUMPSW,B'10000000'                               02S0085
*ELSE                                  /*SDWA EXISTS                 */
*  DO;                                 /*MAKE FURTHER CHECKS         */
         B     @RC00084                                         02S0086
@RF00084 DS    0H                                               02S0087
*    IF ASWADYUE = ON  &               /*CHECK FOR DYNAMIC USER ERROR*/
*       USERERSW = ON THEN             /*AND PROBLEM IS USER'S       */
         TM    ASWADYUE(ASWAPTR),B'00010000'                    02S0087
         BNO   @RF00087                                         02S0087
         L     @01,ASWAPRMS(,ASWAPTR)                           02S0087
         L     @01,DEALFMAP(,@01)                               02S0087
         TM    USERERSW(@01),B'00100000'                        02S0087
         BNO   @RF00087                                         02S0087
*      USERPROB = ON;                  /*SAY SO INTERNALLY           */
         OI    USERPROB,B'01000000'                             02S0088
*    IF ASWADYNF = ON THEN             /*CHECK DYNAMIC FRR PERC AND  */
@RF00087 TM    ASWADYNF(ASWAPTR),B'10000000'                    02S0089
         BNO   @RF00089                                         02S0089
*      IF FRRPERSW = ON THEN           /*FRR PERCOLATION FOR SVC99   */
         L     @01,ASWAPRMS(,ASWAPTR)                           02S0090
         L     @01,DEALFMAP(,@01)                               02S0090
         TM    FRRPERSW(@01),B'00000010'                        02S0090
         BNO   @RF00090                                         02S0090
*       FRRPERCD = ON;                 /*SAY SO INTERNALLY           */
         OI    FRRPERCD,B'00100000'                             02S0091
*      ELSE;                           /*NO DYNAMIC FRR PERCOLATION  */
@RF00090 DS    0H                                               02S0093
*    ELSE                              /*NO DYNAMIC FRR CHECK        */
*      IF ASWACOMF = ON THEN           /*CHECK COMMON ALLOC FRR PERC */
         B     @RC00089                                         02S0093
@RF00089 TM    ASWACOMF(ASWAPTR),B'01000000'                    02S0093
         BNO   @RF00093                                         02S0093
*        IF ASWAPRMS -> DUMPOK = ON THEN /*COMMON FRR PERCOLATION?   */
         L     @01,ASWAPRMS(,ASWAPTR)                           02S0094
         TM    DUMPOK(@01),B'00001000'                          02S0094
         BNO   @RF00094                                         02S0094
*          FRRPERCD = ON;              /*SAY SO INTERNALLY           */
         OI    FRRPERCD,B'00100000'                             02S0095
*        ELSE;                         /*NO COMMON FRR PERCOLATION   */
@RF00094 DS    0H                                               02S0097
*      ELSE                            /*NO CHECK FOR COMMON         */
*        IF ASWAVMVF = ON THEN         /*CHECK VM+V FRR PERCOLATION  */
         B     @RC00093                                         02S0097
@RF00093 TM    ASWAVMVF(ASWAPTR),B'00100000'                    02S0097
         BNO   @RF00097                                         02S0097
*          IF ASWAPRMS -> VEXFRR = ON THEN /*WAS THERE ANY           */
         L     @01,ASWAPRMS(,ASWAPTR)                           02S0098
         TM    VEXFRR(@01),B'10000000'                          02S0098
         BNO   @RF00098                                         02S0098
*            FRRPERCD = ON;            /*SAY SO INTERNALLY           */
         OI    FRRPERCD,B'00100000'                             02S0099
*          ELSE;                       /*NO VM+V FRR PERCOLATION     */
@RF00098 DS    0H                                               02S0101
*        ELSE;                         /*NO VM+V CHECK               */
@RF00097 DS    0H                                               02S0102
*    IF (SDWAPCHK = ON  |              /*ERROR IS PROGRAM CHECK      */
*        SDWARKEY = ON  |              /*RESTART KEY HIT             */
*        SYSACODE^=ZEROBIN)&           /*NON USER ABEND      @ZA15017*/
*       (SDWAPERC = OFF |              /*NOT PERCOLATED TO OR        */
*        FRRPERCD = ON)      &         /*YES BUT FROM FRR            */
*        USERPROB = OFF THEN           /*NOT A USER ERROR            */
@RC00093 DS    0H                                               02S0102
@RC00089 TM    SDWAPCHK(SDWAPTR),B'01100000'                    02S0102
         BNZ   @GL00004                                         02S0102
         MVC   @TS00001(2),SYSACODE(SDWAPTR)                    02S0102
         NC    @TS00001(2),@CB02449                             02S0102
         BZ    @RF00102                                         02S0102
@GL00004 TM    SDWAPERC(SDWAPTR),B'00010000'                    02S0102
         BZ    @GL00003                                         02S0102
         TM    FRRPERCD,B'00100000'                             02S0102
         BNO   @RF00102                                         02S0102
@GL00003 TM    USERPROB,B'01000000'                             02S0102
         BNZ   @RF00102                                         02S0102
*      DUMPSW = ON;                    /*DUMP TO BE TAKEN            */
         OI    DUMPSW,B'10000000'                               02S0103
*    ELSE;                             /*NO SDUMP                    */
@RF00102 DS    0H                                               02S0105
*  END;                                /*END IF SDWA EXISTS          */
*IF DUMPSW = ON THEN                   /*SHOULD DUMP BE TAKEN        */
@RC00084 TM    DUMPSW,B'10000000'                               01S0106
         BNO   @RF00106                                         01S0106
*  DO;                                 /*YES,                        */
*    SDMPCORE(ONE:SDMPLENG) = SDMPLIST(ONE:SDMPLENG); /*COPY MF=L    */
         L     @06,SDMPLENG                                     01S0108
         BCTR  @06,0                                            01S0108
         EX    @06,@SM02451                                     01S0108
*    HDRCORE = HEDCORE;                /*COPY CONSTANT HDR SECTION   */
         MVC   HDRCORE(36),HEDCORE                              01S0109
*    HDREXITN = LASTEXIT;              /*MOVE IN EXIT NAME           */
         MVC   HDREXITN(8),LASTEXIT                             01S0110
*    GEN REFS(SDMPCORE,HDRCORE);                                01S0111
    LOAD  EP=IEFW21SD
*                                    LOAD IEFW21SD FOR DUMP   @ZM41393
    SDUMP HDRAD=HDRCORE,MF=(E,SDMPCORE)
    DELETE EP=IEFW21SD
*                                  DELETE IEFW21SD SFTER DUMP @ZM41393
*  END;                                /*END OF SDUMP                */
*/********************************************************************/
*/*                                                                  */
*/* SEGMENT NAME - ROUTER                                            */
*/*                                                                  */
*/* DESCRIPTIVE NAME - ASWA EXITS CONTROL ROUTER                     */
*/*                                                                  */
*/* FUNCTION - GIVE CONTROL TO APPROPRIATE ROUTINES FOR              */
*/*            SPECIFIC RECOVERY PROCESSING                          */
*/*                                                                  */
*/* OPERATION - LOOP BACKWARDS THROUGH THE CHAIN OF ASWA'S           */
*/*             PASSING CONTROL TO THE EXIT ROUTINES POINTED TO.     */
*/*                                                                  */
*/*             NOTE THAT THESE ROUTINES FORMERLY RECEIVED           */
*/*             CONTROL DIRECTLY FROM THE RTM AND HAVE ENTRY         */
*/*             CODE AS SUCH. (SIMILAR TO THE ENTRY CODE OF          */
*/*             THIS MODULE). BRANCHING TO THEM HERE THEREFORE       */
*/*             REQUIRES THE SETTING UP OF THAT SAME INTERFACE,      */
*/*             INCLUDING THE SETTING OF REGS 0,1,2, AND THE         */
*/*             SAVING AND RESTORING OF REGISTERS BEFORE AND         */
*/*             AFTER.                                               */
*/*                                                                  */
*/* ENTRY - INLINE SUBROUTINE ENTERED AT THE TOP                     */
*/*                                                                  */
*/*   PURPOSE - SEE FUNCTION                                         */
*/*                                                                  */
*/*   INPUT -                                                        */
*/*        .SDWAPTR - PTR TO SDWA IF ONE EXISTS                      */
*/*        .ASWALPTR - PTR TO LAST ASWA ON CHAIN                     */
*/*                                                                  */
*/* EXIT - INLINE SUBROUTINE THAT EXITS AT THE BOTTOM                */
*/*                                                                  */
*/*   CONDITION - CONTROL PASSED TO ALL EXIT ROUTINES                */
*/*               WITH ASWA'S ON THE CHAIN                           */
*/*                                                                  */
*/*   OUTPUT - SPECIFIC CLEANUP PROCESSING PERFORMED                 */
*/*            BY ROUTINES BRANCHED TO.                              */
*/*                                                                  */
*/*   RETURN CODES - NONE                                            */
*/*                                                                  */
*/********************************************************************/
*RFY (R0,R1,R2,R13,R14,R15) RSTD;                               02S0113
@RF00106 DS    0H                                               02S0114
*IF SDWAPTR ^= ZERO THEN               /*SDWA EXIST?                 */
         LTR   SDWAPTR,SDWAPTR                                  02S0114
         BZ    @RF00114                                         02S0114
*  DO;                                 /*SET UP REGS FOR THIS        */
*    R0 = ZERO;                        /*SET REG. 0 ^= 12            */
         SLR   R0,R0                                            02S0116
*    R1 = SDWAPTR;                     /*REG1 TO POINT TO SDWA       */
         LR    R1,SDWAPTR                                       02S0117
*    PARMSAVP=SDWAPARM;                /*SAVE PARM PTR               */
         L     PARMSAVP,SDWAPARM(,SDWAPTR)                      02S0118
*  END;                                /*END IF SDWA EXISTS          */
*ELSE                                  /*NO SDWA                     */
*  R0 = TWELVE;                        /*SET REG. 0 ACCORDINGLY      */
         B     @RC00114                                         02S0120
@RF00114 LA    R0,12                                            02S0120
*R13 = ADDR(REGSAVE);                  /*ENSURE POINTING TO SAVE AREA*/
@RC00114 LA    R13,REGSAVE                                      02S0121
*ASWAPTR = ASWALPTR;                   /*POINT TO LAST ASWA          */
         LR    ASWAPTR,ASWALPTR                                 02S0122
*DO WHILE ASWAPTR ^= ZERO;             /*PROCESS ALL ASWA'S          */
         B     @DE00123                                         02S0123
@DL00123 DS    0H                                               02S0124
*  IF R0 = TWELVE THEN                 /*IF NO SDWA                  */
         CH    R0,@CH00032                                      02S0124
         BNE   @RF00124                                         02S0124
*    R2 = ASWAPRMS;                    /*REG.2 TO PROVIDE PARMS      */
         L     R2,ASWAPRMS(,ASWAPTR)                            02S0125
*  ELSE                                /*SDWA EXISTS                 */
*    SDWAPARM = ASWAPRMS;              /*SDWA CONTAINS PARM PTR      */
         B     @RC00124                                         02S0126
@RF00124 MVC   SDWAPARM(4,SDWAPTR),ASWAPRMS(ASWAPTR)            02S0126
*  R15 = ASWARTNP;                     /*GET EXIT ADDR FOR THIS ASWA */
@RC00124 L     R15,ASWARTNP(,ASWAPTR)                           02S0127
*  GEN;                                                         02S0128
     STM 14,12,12(13)                   SAVE REGISTERS
     BALR 14,15                         BRANCH TO EXIT RTN.
     LM  14,12,12(13)                   RESTORE REGISTERS
*  ASWAPTR = ASWACHNP;                 /*POINT TO PRECEEDING ASWA    */
         L     ASWAPTR,ASWACHNP(,ASWAPTR)                       02S0129
*END;                                  /*END ROUTING LOOP            */
@DE00123 SLR   @09,@09                                          02S0130
         CR    ASWAPTR,@09                                      02S0130
         BNE   @DL00123                                         02S0130
*IF SDWAPTR ^= ZERO THEN               /*IF SDWA EXISTS              */
         CR    SDWAPTR,@09                                      02S0131
         BE    @RF00131                                         02S0131
*  SDWAPARM=PARMSAVP;                  /*RESTORE TO ORIGINAL         */
         ST    PARMSAVP,SDWAPARM(,SDWAPTR)                      02S0132
*RFY(R0,R1,R2,R13,R14,R15) UNRSTD;                              02S0133
@RF00131 DS    0H                                               02S0134
*IF SU24BIT = ON &                     /*IF MSS R3 INSTALLED @ZA27004*/
*   CVTICB ^= ZERO THEN                /*AND MSS GEN'D THEN  @ZA27004*/
         L     @10,CVTPTR                                       01S0134
         L     @09,CVTIHASU(,@10)                               01S0134
         TM    SU24BIT(@09),B'10000000'                         01S0134
         BNO   @RF00134                                         01S0134
         L     @10,CVTEXT2(,@10)                                01S0134
         ICM   @09,15,CVTICB(@10)                               01S0134
         BZ    @RF00134                                         01S0134
*  DO;                                 /*                    @G24LPSJ*/
*/***********************************************************@G24LPSJ*/
*/*                                                          @G24LPSJ*/
*/* SEGMENT NAME - TERMCALL                                  @G24LPSJ*/
*/*                                                          @G24LPSJ*/
*/* DESCRIPTIVE NAME - MSSC TERMINATE PROCESSING             @G24LPSJ*/
*/*                                                          @G24LPSJ*/
*/* FUNCTION -                                               @G24LPSJ*/
*/*                                                          @G24LPSJ*/
*/*   THIS SEGMENT WILL ISSUE THE MSS TERMINATE REQUEST IF   @G24LPSJ*/
*/*   THERE HAS BEEN AN ALLOCATION OR UNALLOCATION FAILURE   @G24LPSJ*/
*/*   CAUSING ESTAE TO GAIN CONTROL.                         @G24LPSJ*/
*/*                                                          @G24LPSJ*/
*/* ENTRY - IN-LINE SEGMENT                                  @G24LPSJ*/
*/*                                                          @G24LPSJ*/
*/*   PURPOSE - SEE FUNCTION                                 @G24LPSJ*/
*/*                                                          @G24LPSJ*/
*/*   INPUT - ASCB                                           @G24LPSJ*/
*/*                                                          @G24LPSJ*/
*/* EXIT -                                                   @G24LPSJ*/
*/*                                                          @G24LPSJ*/
*/*   CONDITION - MSSC TERMINATE ISSUED                      @G24LPSJ*/
*/*      OUTPUT -     - NONE                                 @G24LPSJ*/
*/*      RETURN CODES - NONE                                 @G24LPSJ*/
*/*                                                          @G24LPSJ*/
*/***********************************************************@G24LPSJ*/
*RFY TRMRB BASED(ADDR(TERMAREA));    /* SET ADDR FOR TERMINATE  02S0136
*                                       REQUEST BLOCK        @G24LPSJ*/
*TRMRB = TRMRB && TRMRB;             /* CLEAR BLOCK          @G24LPSJ*/
         LA    @10,TERMAREA                                     02S0137
         XC    TRMRB(16,@10),TRMRB(@10)                         02S0137
*TRMRBLEN = LENGTH(TRMRB);           /* SET TERM LENGTH      @G24LPSJ*/
         MVC   TRMRBLEN(4,@10),@CF00038                         02S0138
*TRMRBOPC = TRMOPCD;                 /* SET TERM OP CODE     @G24LPSJ*/
         MVI   TRMRBOPC(@10),X'8A'                              02S0139
*ASCBPTR = PSAAOLD;                  /* SET ASCB PTR         @G24LPSJ*/
         L     ASCBPTR,PSAAOLD                                  02S0140
*TRMJOBID = ASCBASID;                /* SET ASID OF STEP     @G24LPSJ*/
         SLR   @09,@09                                          02S0141
         ICM   @09,3,ASCBASID(ASCBPTR)                          02S0141
         ST    @09,TRMJOBID(,@10)                               02S0141
*RFY R1 RSTD;                        /* RESTRICT REG1        @G24LPSJ*/
*R1 = ADDR(TRMRB);                   /* LOAD ADDR TRMRB      @G24LPSJ*/
         LR    R1,@10                                           02S0143
*SVC (126);                          /* CALL MSSC            @G24LPSJ*/
         SVC   126                                              02S0144
*RFY R1 UNRSTD;                      /* RELEASE REG 1        @G24LPSJ*/
*  END;                                /*                    @G24LPSJ*/
*RFY (R1) RSTD;                                                 01S0147
@RF00134 DS    0H                                               01S0148
*IF SDWAPTR ^= ZERO THEN               /*IF SDWA EXISTS              */
         SLR   @10,@10                                          01S0148
         CR    SDWAPTR,@10                                      01S0148
         BE    @RF00148                                         01S0148
*  DO;                                 /*SETRP PROCESSING            */
*    R1 = SDWAPTR;                     /*SDWA ADDRESS                */
         LR    R1,SDWAPTR                                       01S0150
*    ASWAPTR = ASWAPTR1;               /*RESET TO 1ST ASWA           */
         LR    ASWAPTR,ASWAPTR1                                 01S0151
*    IF ASWACSCT = STEPALEX THEN       /*IF FOR STEP ALLOCATION      */
         CLC   ASWACSCT(8,ASWAPTR),@CC00142                     01S0152
         BNE   @RF00152                                         01S0152
*      DO;                             /*SPECIAL SETRP PROCESS       */
*/********************************************************************/
*/*                                                                  */
*/* SEGMENT NAME - STPSETRP                                          */
*/*                                                                  */
*/* DESCRIPTIVE NAME - SETRP FOR STEP ALLOCATION                     */
*/*                                                                  */
*/* FUNCTION - IF THE EXIT FOR THE FIRST ASWA ON THE CHAIN IS THAT   */
*/*            OF STEP ALLOCATION'S, SPECIAL SETRP PROCESSING        */
*/*            IS NECESSARY TO ALLOW A RETRY ROUTINE TO GET CONTROL. */
*/*            (THIS RETRY ROUTINE CAN THEN BR14 BACK TO THE         */
*/*            INITIATOR, ENABLING HIM TO CONTINUE PROCESSING        */
*/*            NORMALLY.)                                            */
*/*                                                                  */
*/* OPERATION - ALL THE INITIATOR'S REGISTERS ARE PLACED IN THE      */
*/*             REGISTER UPDATE BLOCK (RUB) AND THE APPROPRIATE      */
*/*             SETRP WITH RETRY IS ISSUED.                          */
*/*                                                                  */
*/* ENTRY - INLINE SUBROUTINE ENTERED AT THE TOP                     */
*/*                                                                  */
*/*   PURPOSE - SEE FUNCTION                                         */
*/*                                                                  */
*/*   INPUT -                                                        */
*/*        .ASWAPTR - PTR TO ASWA FOR STEP ALLOCATION                */
*/*        .DUMPSW - ON IF DUMP TAKEN - MEANS RECORD IN SETRP        */
*/*        .LASTEXIT - EXIT NAME FROM LAST ASWA USED IN              */
*/*                    HEADER OF SDUMP                               */
*/*                                                                  */
*/* EXIT - INLINE SUBROUTINE THAT EXITS FROM THE BOTTOM              */
*/*                                                                  */
*/*   CONDITION - SETRP ISSUED                                       */
*/*                                                                  */
*/*   OUTPUT - SDWA UPDATED WITH APPROPRIATE RETURN PARAMETERS       */
*/*                                                                  */
*/*   RETURN CODES - NONE                                            */
*/*                                                                  */
*/********************************************************************/
*REGFLAG = ALLREGS;                    /*SAY ALL REGS TO BE UPDATED  */
         MVC   REGFLAG(2),ALLREGS                               02S0154
*REGS(FOURTEEN) = INITSVP;             /*@ OF INIT'S SAVE AREA TO R13*/
         L     @03,ASWAPRMS(,ASWAPTR)                           02S0155
         L     @03,JAEXSAVE(,@03)                               02S0155
         L     @03,INITSVP(,@03)                                02S0155
         ST    @03,REGS+52                                      02S0155
*REGS(FIFTEEN) = INITREGS(ONE);        /*REG14 WITH INIT'S REG14     */
         MVC   REGS+56(4),INITREGS(@03)                         02S0156
*REGS(SIXTEEN) = INITREGS(TWO);        /*REG15 WITH INIT'S REG15     */
         MVC   REGS+60(4),INITREGS+4(@03)                       02S0157
*INITCNT = THREE;                      /*START W 3RD REG IN SAVE AREA*/
         LA    INITCNT,3                                        02S0158
*DO REGCNT = ZERO TO TWELVE;           /*GET INIT'S REGS 0 THRU 12   */
         LR    REGCNT,@10                                       02S0159
@DL00159 DS    0H                                               02S0160
*  REGS(REGCNT+ONE) = INITREGS(INITCNT); /*INIT REG TO REG UPDATE BLK*/
         LR    @10,REGCNT                                       02S0160
         SLA   @10,2                                            02S0160
         LR    @15,INITCNT                                      02S0160
         SLA   @15,2                                            02S0160
         L     @14,ASWAPRMS(,ASWAPTR)                           02S0160
         L     @14,JAEXSAVE(,@14)                               02S0160
         L     @14,INITSVP(,@14)                                02S0160
         L     @00,INITREGS-4(@15,@14)                          02S0160
         ST    @00,REGS(@10)                                    02S0160
*  INITCNT = INITCNT + ONE;            /*INDEX TO NEXT INIT REG      */
         AH    INITCNT,@CH00093                                 02S0161
*END;                                  /*END INIT REGS TO RUB        */
         AH    REGCNT,@CH00093                                  02S0162
         CH    REGCNT,@CH00032                                  02S0162
         BNH   @DL00159                                         02S0162
*IF DUMPSW = ON THEN                   /*DUMP TAKEN EARLIER?         */
         TM    DUMPSW,B'10000000'                               02S0163
         BNO   @RF00163                                         02S0163
*  DO;                                 /*YES, RECORDING THEN IN SETRP*/
*    RECRDPRM = RECPARMS;              /*COPY STATIC RECORD INFO     */
         MVC   RECRDPRM(28),RECPARMS                            02S0165
*    RECRDCST = LASTEXIT;              /*PUT IN CSECT FROM LAST ASWA */
         MVC   RECRDCST(8),LASTEXIT                             02S0166
*     DO;  /*SETRP RECORD(YES)DUMP(NO)RECPARM(RECRDPRM)FRESDWA(YES)RETA
*DR(IEFAB4E3)RC(4)RETREGS(YES)RUB(REGBLOCK)*/                   02S0167
*       RESPECIFY (GPR00P,GPR01P,GPR14P,GPR15P) RSTD;           02S0168
*       GPR01P->SDWARCDE = 4; /*STORE RC INTO SDWA*/            02S0169
         MVI   SDWARCDE(GPR01P),X'04'                           02S0169
*       GPR01P->SDWARTYA = ADDR(IEFAB4E3);  /*SAVE RETRY ADDRESS*/
         L     @10,@CV00140                                     02S0170
         ST    @10,SDWARTYA(,GPR01P)                            02S0170
*       GPR01P->SDWAFREE = '1'B;  /*SET FLAG TO FREE SDWA*/     02S0171
*       GPR01P->SDWARCRD = '1'B;  /*TURN ON RECORD INDICATOR*/  02S0172
         OI    SDWAFREE(GPR01P),B'10000100'                     02S0172
*       GPR15P = ADDR(RECRDPRM);  /*ACCESS RECORD PARAMETER LIST*/
         LA    GPR15P,RECRDPRM                                  02S0173
*       GPR01P->SDWARECP = GPR15P ->I256C(1:24);  /*COPY RECORD PARAMET
*RS*/                                                           02S0174
         MVC   SDWARECP(24,GPR01P),I256C(GPR15P)                02S0174
*       GPR01P->SDWAREQ = '0'B;  /*TURN OFF DUMP INDICATOR*/    02S0175
         NI    SDWAREQ(GPR01P),B'01111111'                      02S0175
*       GPR01P->SDWAUPRG = '1'B;  /*TURN ON RETREGS INDICATOR*/ 02S0176
         OI    SDWAUPRG(GPR01P),B'00001000'                     02S0176
*       GPR15P = ADDR(REGBLOCK);  /*GET PTR TO REG UPDATE BLOCK*/
         LA    GPR15P,REGBLOCK                                  02S0177
*       GPR00P = GPR15P->I015F;  /*ACCESS REGISTER BIT PATTERN*/
         LH    GPR00P,I015F(,GPR15P)                            02S0178
*       GPR15P = GPR15P + 2;  /*CREATE PTR TO USER REG VALUES*/ 02S0179
         AH    GPR15P,@CH00126                                  02S0179
*       GPR14P = ADDR(GPR01P->SDWASRSV);  /*CREATE PTR TO SDWA SAVE ARE
**/                                                             02S0180
         LA    GPR14P,SDWASRSV(,GPR01P)                         02S0180
*       GEN (SLL   0,16);  /*SHIFT BIT PATTERN TO HIGH ORDER*/  02S0181
         SLL   0,16
*R0004:                                                         02S0182
*       GEN FLOWS(I0004);                                       02S0182
R0004    DS    0H                                               02S0182
        ALR   0,0                    SHIFT BIT TO SIGN POSITION
        BC    12,I0004               BRANCH IF BIT NOT ON
        MVC   0(4,14),0(15)          MODIFY REGISTER IN SDWA
        LA    15,4(15)               UPDATE POINTER
*I0004:                                                         02S0183
*       GENERATE FLOWS(R0004);                                  02S0183
I0004    DS    0H                                               02S0183
        LA    14,4(14)               UPDATE PTR IN SDWA
        BC    5,R0004                TEST ALR CONDITION CODE TO TEST
*                                    IF ALL BITS EXHAUSTED
*       RESPECIFY (GPR00P,GPR01P,GPR14P,GPR15P) UNRSTD;         02S0184
*     END;   /*SETRP WITH RECORDING       */                    02S0185
*  END;                                /*END IF DUMP TAKEN           */
*ELSE                                  /*NO DUMP TAKEN               */
*  DO;                                 /*SETRP W/O RECORDING         */
         B     @RC00163                                         02S0187
@RF00163 DS    0H                                               02S0188
*     DO;  /*SETRP RECORD(NO)DUMP(NO)FRESDWA(YES)RETADDR(IEFAB4E3)RC(4)
*ETREGS(YES)RUB(REGBLOCK)*/                                     02S0188
*       RESPECIFY (GPR00P,GPR01P,GPR14P,GPR15P) RSTD;           02S0189
*       GPR01P->SDWARCDE = 4; /*STORE RC INTO SDWA*/            02S0190
         MVI   SDWARCDE(GPR01P),X'04'                           02S0190
*       GPR01P->SDWARTYA = ADDR(IEFAB4E3);  /*SAVE RETRY ADDRESS*/
         L     @10,@CV00140                                     02S0191
         ST    @10,SDWARTYA(,GPR01P)                            02S0191
*       GPR01P->SDWAFREE = '1'B;  /*SET FLAG TO FREE SDWA*/     02S0192
*       GPR01P->SDWARCRD = '0'B;  /*TURN OFF RECORD INDICATOR*/ 02S0193
         OI    SDWAFREE(GPR01P),B'00000100'                     02S0193
         NI    SDWARCRD(GPR01P),B'01111111'                     02S0193
*       GPR01P->SDWAREQ = '0'B;  /*TURN OFF DUMP INDICATOR*/    02S0194
         NI    SDWAREQ(GPR01P),B'01111111'                      02S0194
*       GPR01P->SDWAUPRG = '1'B;  /*TURN ON RETREGS INDICATOR*/ 02S0195
         OI    SDWAUPRG(GPR01P),B'00001000'                     02S0195
*       GPR15P = ADDR(REGBLOCK);  /*GET PTR TO REG UPDATE BLOCK*/
         LA    GPR15P,REGBLOCK                                  02S0196
*       GPR00P = GPR15P->I015F;  /*ACCESS REGISTER BIT PATTERN*/
         LH    GPR00P,I015F(,GPR15P)                            02S0197
*       GPR15P = GPR15P + 2;  /*CREATE PTR TO USER REG VALUES*/ 02S0198
         AH    GPR15P,@CH00126                                  02S0198
*       GPR14P = ADDR(GPR01P->SDWASRSV);  /*CREATE PTR TO SDWA SAVE ARE
**/                                                             02S0199
         LA    GPR14P,SDWASRSV(,GPR01P)                         02S0199
*       GEN (SLL   0,16);  /*SHIFT BIT PATTERN TO HIGH ORDER*/  02S0200
         SLL   0,16
*R0006:                                                         02S0201
*       GEN FLOWS(I0006);                                       02S0201
R0006    DS    0H                                               02S0201
        ALR   0,0                    SHIFT BIT TO SIGN POSITION
        BC    12,I0006               BRANCH IF BIT NOT ON
        MVC   0(4,14),0(15)          MODIFY REGISTER IN SDWA
        LA    15,4(15)               UPDATE POINTER
*I0006:                                                         02S0202
*       GENERATE FLOWS(R0006);                                  02S0202
I0006    DS    0H                                               02S0202
        LA    14,4(14)               UPDATE PTR IN SDWA
        BC    5,R0006                TEST ALR CONDITION CODE TO TEST
*                                    IF ALL BITS EXHAUSTED
*       RESPECIFY (GPR00P,GPR01P,GPR14P,GPR15P) UNRSTD;         02S0203
*     END;               /*SETRP W/O RECORDING         */       02S0204
*  END;                                                         02S0205
*      END;                            /*END IF STEP ALLOC           */
*    ELSE                              /*NO STEP ALLOCATION          */
*      IF DUMPSW = ON THEN             /*WAS DUMP TAKEN              */
         B     @RC00152                                         01S0207
@RF00152 TM    DUMPSW,B'10000000'                               01S0207
         BNO   @RF00207                                         01S0207
*        DO;                           /*RECORDING IN SETRP          */
*          RECRDPRM = RECPARMS;        /*COPY STATIC RECORD INFO     */
         MVC   RECRDPRM(28),RECPARMS                            01S0209
*          RECRDCST = LASTEXIT;        /*PUT IN CSECT FOR LAST ASWA  */
         MVC   RECRDCST(8),LASTEXIT                             01S0210
*           DO;  /*SETRP RECORD(YES)DUMP(NO)RECPARM(RECRDPRM)*/ 01S0211
*             RESPECIFY (GPR00P,GPR01P,GPR14P,GPR15P) RSTD;     01S0212
*             GPR01P->SDWARCDE = 0;  /*SAVE RC VALUE*/          01S0213
         MVI   SDWARCDE(GPR01P),X'00'                           01S0213
*             GPR01P->SDWARCRD = '1'B;  /*TURN ON RECORD INDICATOR*/
         OI    SDWARCRD(GPR01P),B'10000000'                     01S0214
*             GPR15P = ADDR(RECRDPRM);  /*ACCESS RECORD PARAMETER LIST*
*                                                               01S0215
         LA    GPR15P,RECRDPRM                                  01S0215
*             GPR01P->SDWARECP = GPR15P ->I256C(1:24);  /*COPY RECORD P
*RAMETERS*/                                                     01S0216
         MVC   SDWARECP(24,GPR01P),I256C(GPR15P)                01S0216
*             GPR01P->SDWAREQ = '0'B;  /*TURN OFF DUMP INDICATOR*/
         NI    SDWAREQ(GPR01P),B'01111111'                      01S0217
*             RESPECIFY (GPR00P,GPR01P,GPR14P,GPR15P) UNRSTD;   01S0218
*           END;                                                01S0219
*                                      /*SETRP WITH RECORDING        */
*        END;                          /*END IF DUMP TAKEN           */
*      ELSE                            /*NO RECORDING DONE           */
*        IF USERPROB = ON THEN         /*IF ERROR DUE TO USER        */
         B     @RC00207                                         01S0221
@RF00207 TM    USERPROB,B'01000000'                             01S0221
         BNO   @RF00221                                         01S0221
*          DO;                         /*DUMP IN SETRP               */
*             DO;  /*SETRP RECORD(NO)DUMP(YES)*/                01S0223
*               RESPECIFY (GPR00P,GPR01P,GPR14P,GPR15P) RSTD;   01S0224
*               GPR01P->SDWARCDE = 0;  /*SAVE RC VALUE*/        01S0225
         MVI   SDWARCDE(GPR01P),X'00'                           01S0225
*               GPR01P->SDWARCRD = '0'B;  /*TURN OFF RECORD INDICATOR*/
         NI    SDWARCRD(GPR01P),B'01111111'                     01S0226
*               GPR01P->SDWAREQ = '1'B;  /*TURN ON DUMP INDICATOR*/
         OI    SDWAREQ(GPR01P),B'10000000'                      01S0227
*               RESPECIFY (GPR00P,GPR01P,GPR14P,GPR15P) UNRSTD; 01S0228
*             END;   /*SETRP WITH DUMP          */              01S0229
*          END;                        /*END IF USER ERROR           */
*        ELSE                          /*NO USER ERROR; SYSTEM ERROR */
*          DO;                         /*NORMAL SETRP                */
         B     @RC00221                                         01S0231
@RF00221 DS    0H                                               01S0232
*             DO;  /*SETRP RECORD(NO)DUMP(NO)*/                 01S0232
*               RESPECIFY (GPR00P,GPR01P,GPR14P,GPR15P) RSTD;   01S0233
*               GPR01P->SDWARCDE = 0;  /*SAVE RC VALUE*/        01S0234
         MVI   SDWARCDE(GPR01P),X'00'                           01S0234
*               GPR01P->SDWARCRD = '0'B;  /*TURN OFF RECORD INDICATOR*/
         NI    SDWARCRD(GPR01P),B'01111111'                     01S0235
*               GPR01P->SDWAREQ = '0'B;  /*TURN OFF DUMP INDICATOR*/
         NI    SDWAREQ(GPR01P),B'01111111'                      01S0236
*               RESPECIFY (GPR00P,GPR01P,GPR14P,GPR15P) UNRSTD; 01S0237
*             END;   /*SETRP W/O DUMP OR RECORD  */             01S0238
*          END;                        /*END OF NORMAL SETRP         */
*  END;                                /*END IF SDWA EXISTS          */
*ELSE;                                 /*NO SDWA-NO SETRP            */
@RF00148 DS    0H                                               01S0242
*RFY (R1,R14,R15) RSTD;                                         01S0242
@RC00148 DS    0H                                               01S0243
*R15 = ZERO;                           /*NO RETRY- NEEDED IF NO SDWA */
         SLR   R15,R15                                          01S0243
*R1 = SDWAPTR;                         /*REG1 HAS SDWA IF ONE EXISTS */
         LR    R1,SDWAPTR                                       01S0244
*R14 = SAVREG14;                       /*GET RETURN ADDRESS          */
         L     R14,SAVREG14                                     01S0245
*GEN (BR 14);                          /*NORMAL RETURN               */
*                                                               01S0246
*                                                               01S0246
         BR 14
* DECLARE /*GENERAL PURPOSE REGISTERS */                        01S0247
*   GPR00P PTR(31) REG(0),                                      01S0247
*   GPR01P PTR(31) REG(1),                                      01S0247
*   GPR14P PTR(31) REG(14),                                     01S0247
*   GPR15P PTR(31) REG(15);                                     01S0247
*                                                               01S0247
* DECLARE /* COMMON VARIABLES */                                01S0248
*   I256C CHAR(256) BASED,                                      01S0248
*   I031F FIXED(31) BASED,                                      01S0248
*   I031P PTR(31)   BASED,                                      01S0248
*   I015F FIXED(15) BASED,                                      01S0248
*   I015P PTR(15)   BASED,                                      01S0248
*   I008P PTR(8)    BASED,                                      01S0248
*   I001C CHAR(1)   BASED;                                      01S0248
*END IEFAB4ED                                                   01S0249
*/* THE FOLLOWING INCLUDE STATEMENTS WERE FOUND IN THIS PROGRAM.      *
*/*%INCLUDE SYSLIB  (AB4EDSPC)                                        *
*/*%INCLUDE SYSLIB  (COMESTDT)                                        *
*/*%INCLUDE SYSLIB  (IEFZB453)                                        *
*/*%INCLUDE SYSLIB  (IEFZB4D9)                                        *
*/*%INCLUDE SYSLIB  (IEFZB4D7)                                        *
*/*%INCLUDE SYSLIB  (IEFZB447)                                        *
*/*%INCLUDE SYSLIB  (IEFZB452)                                        *
*/*%INCLUDE SYSLIB  (IEZJSCB )                                        *
*/*%INCLUDE SYSLIB  (IKJTCB  )                                        *
*/*%INCLUDE SYSLIB  (IHASDWA )                                        *
*/*%INCLUDE SYSLIB  (CVT     )                                        *
*/*%INCLUDE SYSLIB  (IHASUBIT)                                        *
*/*%INCLUDE SYSLIB  (IHAPSA  )                                        *
*/*%INCLUDE SYSLIB  (IHAASCB )                                        *
*/*%INCLUDE SYSLIB  (DUMPCHEK)                                        *
*/*%INCLUDE SYSLIB  (DUMPCKSP)                                        *
*/*%INCLUDE SYSLIB  (ROUTER  )                                        *
*/*%INCLUDE SYSLIB  (ROUTERSP)                                        *
*/*%INCLUDE SYSLIB  (TERMCALL)                                        *
*/*%INCLUDE SYSLIB  (TERMSPEC)                                        *
*/*%INCLUDE SYSLIB  (STPSETRP)                                        *
*/*%INCLUDE SYSLIB  (STPSETSP)                                        *
*;                                                              01S0249
@DATA    DS    0H
@CH00093 DC    H'1'
@CH00126 DC    H'2'
@CH00032 DC    H'12'
@SM02451 MVC   SDMPCORE(0),SDMPLIST
@DATD    DSECT
         DS    0F
@SA00001 DS    18F
IEFAB4ED CSECT
         DS    0F
@CF00038 DC    F'16'
@DATD    DSECT
         DS    0D
SAVREG14 DS    A
EXITPRMP DS    A
VMVEXITP DS    A
@TS00001 DS    CL2
         DS    CL2
REGSAVE  DS    CL76
         ORG   REGSAVE
@NM00001 DS    CL12
REGSTERS DS    16F
         ORG   REGSAVE+76
HDRCORE  DS    CL36
         ORG   HDRCORE
HDRLNG   DS    AL1
HDRLOAD  DS    CL18
         ORG   HDRLOAD
HDRWRDS1 DS    CL9
HDRLDMOD DS    CL9
         ORG   HDRCORE+19
HDRCSECT DS    CL17
         ORG   HDRCSECT
HDRWRDS2 DS    CL9
HDREXITN DS    CL8
         ORG   HDRCORE+36
LASTEXIT DS    CL8
RECRDPRM DS    CL28
         ORG   RECRDPRM
RECRDMOD DS    CL8
RECRDCST DS    CL8
RECRDFRR DS    CL8
RECRDVAR DS    AL4
         ORG   RECRDPRM+28
         DS    CL2
REGBLOCK DS    CL66
         ORG   REGBLOCK
REGFLAG  DS    BL2
REGS     DS    16F
         ORG   REGBLOCK+66
SWITCHES DS    BL1
         ORG   SWITCHES
DUMPSW   DS    BL1
USERPROB EQU   SWITCHES+0
FRRPERCD EQU   SWITCHES+0
@NM00005 EQU   SWITCHES+0
         ORG   SWITCHES+1
TERMAREA DS    CL16
IEFAB4ED CSECT
         NOPR  ((@ENDDATD-@DATD)/501*16)
         DS    0F
@SIZDATD DC    AL1(0)
         DC    AL3(@ENDDATD-@DATD)
@CV00140 DC    V(IEFAB4E3)
         DS    0D
@CC00142 DC    C'IEFAB4E4'
@CB02449 DC    B'1111111111110000'
ALLREGS  DC    X'FFFF'
HEDCORE  DS    CL36
         ORG   HEDCORE
HEDLNG   DC    AL1(35)
HEDLOAD  DS    CL18
         ORG   HEDLOAD
HEDWRDS1 DC    CL9'LOAD MOD-'
HEDLDMOD DC    CL9'IEFW21SD '
         ORG   HEDCORE+19
HEDCSECT DS    CL17
         ORG   HEDCSECT
HEDWRDS2 DC    CL9'EXIT RTN-'
HEDEXITN DC    CL8'        '
         ORG   HEDCORE+36
RECPARMS DS    CL28
         ORG   RECPARMS
RECMODNM DC    CL8'IEFW21SD'
RECCSECT DC    CL8'        '
RECFRR   DC    CL8'        '
RECVARPT DC    A(0)
         ORG   RECPARMS+28
@DATD    DSECT
SDMPCORE SDUMP SDATA=(NUC,RGN,LPA,TRT,CSA,ALLPSA,SQA),                **
               QUIESCE=YES,MF=L
*                                                             @ZA10071
IEFAB4ED CSECT
SDMPLIST SDUMP SDATA=(NUC,RGN,LPA,TRT,CSA,ALLPSA,SQA),                **
               QUIESCE=YES,MF=L
*                                                             @ZA10071
SDMPLENG DC A(*-SDMPLIST)
IEFAB4ED CSECT
         DS   0H
PATCHLOC DC ((@DATA-@PSTART)/20)X'00'
@DATD    DSECT
         ORG   *+1-(*-@DATD)/(*-@DATD) INSURE DSECT DATA
@ENDDATD EQU   *
IEFAB4ED CSECT
@00      EQU   00                      EQUATES FOR REGISTERS 0-15
@01      EQU   01
@02      EQU   02
@03      EQU   03
@04      EQU   04
@05      EQU   05
@06      EQU   06
@07      EQU   07
@08      EQU   08
@09      EQU   09
@10      EQU   10
@11      EQU   11
@12      EQU   12
@13      EQU   13
@14      EQU   14
@15      EQU   15
REGCNT   EQU   @03
INITCNT  EQU   @02
SDWAPTR  EQU   @07
TCBPTR   EQU   @04
PARMSAVP EQU   @10
JSCBPTR  EQU   @02
ASWAPTR1 EQU   @08
ASWALPTR EQU   @09
ASWAPTR  EQU   @06
ASCBPTR  EQU   @02
R0       EQU   @00
R1       EQU   @01
R2       EQU   @02
R9       EQU   @09
R13      EQU   @13
R14      EQU   @14
R15      EQU   @15
GPR00P   EQU   @00
GPR01P   EQU   @01
GPR14P   EQU   @14
GPR15P   EQU   @15
CVTPTR   EQU   16
LOC16PTR EQU   16
PSA      EQU   0
FLCRNPSW EQU   PSA
FLCROPSW EQU   PSA+8
FLCICCW2 EQU   PSA+16
PSAEEPSW EQU   PSA+132
PSAESPSW EQU   PSA+136
FLCSVILC EQU   PSAESPSW+1
PSAEPPSW EQU   PSA+140
FLCPIILC EQU   PSAEPPSW+1
FLCPICOD EQU   PSAEPPSW+2
PSAPICOD EQU   FLCPICOD+1
FLCTEA   EQU   PSAEPPSW+4
FLCPER   EQU   PSA+152
FLCMCLA  EQU   PSA+168
FLCIOEL  EQU   FLCMCLA+4
FLCIOA   EQU   FLCMCLA+16
FLCFSA   EQU   FLCMCLA+80
PSAAOLD  EQU   PSA+548
PSASUPER EQU   PSA+552
PSASUP1  EQU   PSASUPER
PSASUP2  EQU   PSASUPER+1
PSASUP3  EQU   PSASUPER+2
PSASUP4  EQU   PSASUPER+3
PSACLHT  EQU   PSA+640
PSALKSA  EQU   PSA+696
PSAHLHI  EQU   PSA+760
PSADSSFL EQU   PSA+836
PSADSSF1 EQU   PSADSSFL
PSADSSF3 EQU   PSADSSFL+2
PSADSSF4 EQU   PSADSSFL+3
PSARSVT  EQU   PSA+896
TCBLISTP EQU   0
TWOTCBPS EQU   0
CURNTCBP EQU   TWOTCBPS+4
BB401SVE EQU   0
INITSVP  EQU   BB401SVE+4
INITSAVE EQU   0
INITREGS EQU   INITSAVE+12
JAEXPARM EQU   0
JAEXSAVE EQU   JAEXPARM+260
JAEXFLAG EQU   JAEXPARM+268
ASWA     EQU   0
ASWACSCT EQU   ASWA+4
ASWARTNP EQU   ASWA+12
ASWAPRMS EQU   ASWA+16
ASWASCBP EQU   ASWA+20
ASWAOLDP EQU   ASWA+24
ASWAFLGS EQU   ASWA+28
ASWADSWS EQU   ASWAFLGS
ASWADYNF EQU   ASWADSWS
ASWACOMF EQU   ASWADSWS
ASWAVMVF EQU   ASWADSWS
ASWADYUE EQU   ASWADSWS
ASWANOCH EQU   ASWADSWS
ASWACHNP EQU   ASWA+36
DEPARMS  EQU   0
DEALFMAP EQU   DEPARMS+200
DENQRETN EQU   DEPARMS+232
DEDMYEPA EQU   DEPARMS+240
DEDMYAS  EQU   DEPARMS+260
ALFNCMAP EQU   0
INPUTSW  EQU   ALFNCMAP
PROCESSW EQU   ALFNCMAP+6
ERRPROSW EQU   PROCESSW
FRRPERSW EQU   PROCESSW
USERERSW EQU   PROCESSW+1
PRMESTAE EQU   0
PRMRESC  EQU   PRMESTAE+252
PRMFUNC  EQU   PRMESTAE+253
DUMPOK   EQU   PRMFUNC
VMVEPRMS EQU   0
VEXFLAGS EQU   VMVEPRMS+196
VEXFRR   EQU   VEXFLAGS
IEZJSCB  EQU   0
JSCBSEC1 EQU   IEZJSCB+188
JSCHPCE  EQU   JSCBSEC1+4
JSCBDCB  EQU   JSCBSEC1+36
JSCBOPTS EQU   JSCBSEC1+48
JSCBSWT1 EQU   JSCBSEC1+55
JSCBWTP  EQU   JSCBSEC1+64
JSCBWTFG EQU   JSCBWTP
JSCBEND1 EQU   IEZJSCB+260
TCBFIX   EQU   0
TCBFRS   EQU   TCBFIX
TCB      EQU   0
TCBPIE   EQU   TCB+4
TCBPMASK EQU   TCBPIE
TCBCMP   EQU   TCB+16
TCBCMPF  EQU   TCBCMP
TCBCPP   EQU   TCBCMPF
TCBSTCC  EQU   TCBCMPF
TCBCDBL  EQU   TCBCMPF
TCBCWTO  EQU   TCBCMPF
TCBCIND  EQU   TCBCMPF
TCBCMSG  EQU   TCBCMPF
TCBTRN   EQU   TCB+20
TCBABF   EQU   TCBTRN
TCBMSS   EQU   TCB+24
TCBPKF   EQU   TCB+28
TCBFLGS  EQU   TCB+29
TCBFLGS1 EQU   TCBFLGS
TCBFLGS2 EQU   TCBFLGS+1
TCBFLGS3 EQU   TCBFLGS+2
TCBFLGS4 EQU   TCBFLGS+3
TCBFLGS5 EQU   TCBFLGS+4
TCBABWF  EQU   TCBFLGS5
TCBJPQ   EQU   TCB+44
TCBPURGE EQU   TCBJPQ
TCBGRS   EQU   TCB+48
TCBFSA   EQU   TCB+112
TCBTME   EQU   TCB+120
TCBJSTCB EQU   TCB+124
TCBTSFLG EQU   TCB+148
TCBTSTSK EQU   TCBTSFLG
TCBSTAB  EQU   TCB+160
TCBNSTAE EQU   TCBSTAB
TCBTCT   EQU   TCB+164
TCBTCTGF EQU   TCBTCT
TCBSCNDY EQU   TCB+172
TCBNDSP  EQU   TCBSCNDY
TCBNDSP1 EQU   TCBNDSP+1
TCBNDSP2 EQU   TCBNDSP+2
TCBNDSP3 EQU   TCBNDSP+3
TCBJSCB  EQU   TCB+180
TCBRECDE EQU   TCBJSCB
TCBEXT1  EQU   TCB+196
TCBBITS  EQU   TCB+200
TCBNDSP4 EQU   TCBBITS
TCBNDSP5 EQU   TCBBITS+1
TCBFLGS6 EQU   TCBBITS+2
TCBFLGS7 EQU   TCBBITS+3
TCBDAR   EQU   TCB+204
TCBDARC  EQU   TCBDAR
TCBEXT2  EQU   TCB+208
TCBXSCT  EQU   TCB+240
TCBXSCT1 EQU   TCBXSCT
TCBFOE   EQU   TCB+244
TCBSTAWA EQU   TCB+252
TCBESTAE EQU   TCB+264
TCBESTRM EQU   TCBESTAE+1
TCBFBYT1 EQU   TCB+276
TCBFBYT2 EQU   TCB+277
TCBRV124 EQU   TCB+278
TCBRV133 EQU   TCB+279
TCBXTNT2 EQU   0
TCBGTF   EQU   TCBXTNT2
TCBTFLG  EQU   TCBGTF
TCBRV146 EQU   TCBXTNT2+28
TCBRV155 EQU   TCBXTNT2+29
TCBRV164 EQU   TCBXTNT2+30
TCBRV173 EQU   TCBXTNT2+31
SDWA     EQU   0
SDWAPARM EQU   SDWA
SDWAFIOB EQU   SDWA+4
SDWAABCC EQU   SDWAFIOB
SDWACMPF EQU   SDWAABCC
SDWAREQ  EQU   SDWACMPF
SDWACMPC EQU   SDWAABCC+1
SDWACTL1 EQU   SDWA+8
SDWACMKA EQU   SDWACTL1
SDWAMWPA EQU   SDWACTL1+1
SDWAPMKA EQU   SDWACTL1+4
SDWACTL2 EQU   SDWA+16
SDWACMKP EQU   SDWACTL2
SDWAMWPP EQU   SDWACTL2+1
SDWAPMKP EQU   SDWACTL2+4
SDWAGRSV EQU   SDWA+24
SDWANAME EQU   SDWA+88
SDWAEC1  EQU   SDWA+104
SDWAEMK1 EQU   SDWAEC1
SDWAMWP1 EQU   SDWAEC1+1
SDWAINT1 EQU   SDWAEC1+2
SDWANXT1 EQU   SDWAEC1+4
SDWAAEC1 EQU   SDWA+112
SDWAILC1 EQU   SDWAAEC1+1
SDWAINC1 EQU   SDWAAEC1+2
SDWAICD1 EQU   SDWAINC1+1
SDWAEC2  EQU   SDWA+120
SDWAEMK2 EQU   SDWAEC2
SDWAMWP2 EQU   SDWAEC2+1
SDWAINT2 EQU   SDWAEC2+2
SDWANXT2 EQU   SDWAEC2+4
SDWAAEC2 EQU   SDWA+128
SDWAILC2 EQU   SDWAAEC2+1
SDWAINC2 EQU   SDWAAEC2+2
SDWAICD2 EQU   SDWAINC2+1
SDWASRSV EQU   SDWA+136
SDWAIDNT EQU   SDWA+200
SDWAMCH  EQU   SDWA+204
SDWASTCK EQU   SDWAMCH
SDWAMCHI EQU   SDWAMCH+8
SDWAMCHS EQU   SDWAMCHI
SDWAMCHD EQU   SDWAMCHI+1
SDWARSR1 EQU   SDWAMCH+12
SDWARSR2 EQU   SDWAMCH+13
SDWAFLGS EQU   SDWA+232
SDWAERRA EQU   SDWAFLGS
SDWAPCHK EQU   SDWAERRA
SDWARKEY EQU   SDWAERRA
SDWAERRB EQU   SDWAFLGS+1
SDWAERRC EQU   SDWAFLGS+2
SDWAPERC EQU   SDWAERRC
SDWAERRD EQU   SDWAFLGS+3
SDWAIOFS EQU   SDWA+238
SDWARTYA EQU   SDWA+240
SDWACPUA EQU   SDWA+248
SDWAPARQ EQU   SDWA+252
SDWARCDE EQU   SDWAPARQ
SDWAACF2 EQU   SDWAPARQ+1
SDWARCRD EQU   SDWAACF2
SDWAUPRG EQU   SDWAACF2
SDWAFREE EQU   SDWAACF2
SDWAACF3 EQU   SDWAPARQ+2
SDWAACF4 EQU   SDWAPARQ+3
SDWALKWA EQU   SDWA+256
SDWALKWS EQU   SDWALKWA
SDWARECP EQU   SDWA+292
SDWASNPA EQU   SDWA+320
SDWADUMP EQU   SDWASNPA
SDWADPFS EQU   SDWADUMP+1
SDWADDAT EQU   SDWASNPA+4
SDWASDAT EQU   SDWADDAT
SDWAPDAT EQU   SDWADDAT+2
SDWADPSA EQU   SDWA+328
SDWADPSL EQU   SDWADPSA
SDWARA   EQU   SDWA+400
SDWADPVA EQU   SDWARA+2
CVTMAP   EQU   0
CVTDAR   EQU   CVTMAP+72
CVTFLGS1 EQU   CVTDAR
CVTDCB   EQU   CVTMAP+116
CVTIOQET EQU   CVTMAP+120
CVTIERLC EQU   CVTMAP+144
CVTHEAD  EQU   CVTMAP+160
CVTSV76C EQU   CVTHEAD
CVTOPTA  EQU   CVTMAP+182
CVTOPTB  EQU   CVTMAP+183
CVTGTF   EQU   CVTMAP+236
CVTGTFST EQU   CVTGTF
CVTGTFS  EQU   CVTGTFST
CVTSTATE EQU   CVTGTFST
CVTTMODE EQU   CVTGTFST
CVTFORM  EQU   CVTGTFST
CVTAQAVT EQU   CVTMAP+240
CVTTCMFG EQU   CVTAQAVT
CVTVOLM2 EQU   CVTMAP+244
CVTTATA  EQU   CVTVOLM2
CVTTSKS  EQU   CVTTATA
CVTVOLF2 EQU   CVTTSKS
CVTTAT   EQU   CVTTATA+1
CVTATER  EQU   CVTMAP+248
CVTEXT1  EQU   CVTMAP+252
CVTPURG  EQU   CVTMAP+260
CVTQMSG  EQU   CVTMAP+268
CVTDMSR  EQU   CVTMAP+272
CVTRSV37 EQU   CVTDMSR
CVTDMSRF EQU   CVTRSV37
CVTERPV  EQU   CVTMAP+316
CVTINTLA EQU   CVTMAP+320
CVTAPF   EQU   CVTMAP+324
CVTEXT2  EQU   CVTMAP+328
CVTHJES  EQU   CVTMAP+332
CVTPGSIA EQU   CVTMAP+348
CVTA1F1  EQU   CVTMAP+356
CVTSYSK  EQU   CVTMAP+357
CVTVOLM1 EQU   CVTMAP+380
CVTVOLF1 EQU   CVTVOLM1
CVTATMCT EQU   CVTMAP+388
CVTXTNT1 EQU   0
CVTXTNT2 EQU   0
CVTDSSV  EQU   CVTXTNT2
CVTFLGBT EQU   CVTXTNT2+5
CVTQID   EQU   CVTXTNT2+24
CVTICB   EQU   CVTXTNT2+48
CVTRV400 EQU   CVTXTNT2+52
CVTRV409 EQU   CVTXTNT2+53
CVTATCVT EQU   CVTXTNT2+64
CVTRV429 EQU   CVTXTNT2+84
CVTRV438 EQU   CVTXTNT2+85
CVTRV457 EQU   CVTXTNT2+112
CVTRV466 EQU   CVTXTNT2+113
CVTFIX   EQU   0
CVTRELNO EQU   CVTFIX+252
SUBITS   EQU   0
SUBYTE1  EQU   SUBITS
SUBYTE2  EQU   SUBITS+1
SUBYTE3  EQU   SUBITS+2
SUBYTE4  EQU   SUBITS+3
SU24BIT  EQU   SUBYTE4
SUBYTE5  EQU   SUBITS+4
SUBYTE6  EQU   SUBITS+5
SUBYTE7  EQU   SUBITS+6
SUBYTE8  EQU   SUBITS+7
SUBYTE9  EQU   SUBITS+8
SUBYTE10 EQU   SUBITS+9
SUBYTE11 EQU   SUBITS+10
SUBYTE12 EQU   SUBITS+11
SUBYTE13 EQU   SUBITS+12
ASCB     EQU   0
ASCBSUPC EQU   ASCB+16
ASCBASID EQU   ASCB+36
ASCBRSM  EQU   ASCB+52
ASCBRSMF EQU   ASCBRSM
ASCBFW1  EQU   ASCB+100
ASCBRCTF EQU   ASCBFW1+2
ASCBFLG1 EQU   ASCBFW1+3
ASCBDSP1 EQU   ASCB+114
ASCBFLG2 EQU   ASCB+115
ASCBLKGP EQU   ASCB+128
ASCBSRQ  EQU   ASCB+180
ASCBSRQ1 EQU   ASCBSRQ
ASCBSRQ2 EQU   ASCBSRQ+1
ASCBSRQ3 EQU   ASCBSRQ+2
ASCBSRQ4 EQU   ASCBSRQ+3
TRMRB    EQU   0
TRMRBLEN EQU   TRMRB
TRMRBOPC EQU   TRMRB+4
TRMFLAGS EQU   TRMRB+5
TRMJOBID EQU   TRMRB+8
I256C    EQU   0
I015F    EQU   0
AB4EDPMS EQU   0
I001C    EQU   0
I008P    EQU   0
I015P    EQU   0
I031F    EQU   0
I031P    EQU   0
ABENDCMP EQU   SDWACMPC
SYSACODE EQU   ABENDCMP
JSCBSEC2 EQU   JSCBEND1
JSCBSEC3 EQU   JSCBEND1
JSCBJCT  EQU   JSCBSEC3
JSCBJCTA EQU   JSCBJCT+1
JSCBASID EQU   JSCBSEC3+8
JSCBFBYT EQU   JSCBSEC3+10
JSCBJNL  EQU   JSCBSEC3+28
JSCBJJSB EQU   JSCBJNL
JSCBSUB  EQU   JSCBSEC3+40
JSCSCT   EQU   JSCBSEC3+68
JSCBACT  EQU   JSCBSEC3+88
JSCBASWA EQU   JSCBSEC3+96
JSCRSV45 EQU   JSCBSEC3+112
JSCRSV46 EQU   JSCRSV45
JSCRSV47 EQU   JSCRSV45+2
CVTS01   EQU   CVTPGSIA
CVTLPDIA EQU   CVTS01+12
CVTDIRST EQU   CVTLPDIA
CVTSLIDA EQU   CVTS01+24
CVTCTLFG EQU   CVTS01+50
CVTRV210 EQU   CVTS01+424
CVTRV219 EQU   CVTS01+425
CVTRV228 EQU   CVTS01+426
CVTRV237 EQU   CVTS01+427
CVTMFRTR EQU   CVTS01+452
CVTRV262 EQU   CVTS01+468
CVTRV271 EQU   CVTS01+469
CVTRV280 EQU   CVTS01+470
CVTRV289 EQU   CVTS01+471
CVTGSDA  EQU   CVTS01+600
CVTIHASU EQU   CVTS01+696
PSARSVTE EQU   PSARSVT
FLC      EQU   PSA
         AGO   .@UNREFD                START UNREFERENCED COMPONENTS
PSARSAV  EQU   PSARSVTE+60
PSARSTK  EQU   PSARSVTE+56
PSAESAV3 EQU   PSARSVTE+52
PSAESTK3 EQU   PSARSVTE+48
PSAESAV2 EQU   PSARSVTE+44
PSAESTK2 EQU   PSARSVTE+40
PSAESAV1 EQU   PSARSVTE+36
PSAESTK1 EQU   PSARSVTE+32
PSAPSAV  EQU   PSARSVTE+28
PSAPSTK  EQU   PSARSVTE+24
PSAMSAV  EQU   PSARSVTE+20
PSAMSTK  EQU   PSARSVTE+16
PSASSAV  EQU   PSARSVTE+12
PSASSTK  EQU   PSARSVTE+8
PSANSTK  EQU   PSARSVTE+4
PSACSTK  EQU   PSARSVTE
CVTRV628 EQU   CVTS01+728
CVTRV627 EQU   CVTS01+724
CVTRV626 EQU   CVTS01+720
CVTRV625 EQU   CVTS01+716
CVTRV624 EQU   CVTS01+712
CVTRV623 EQU   CVTS01+708
CVTRV622 EQU   CVTS01+704
CVTRV621 EQU   CVTS01+700
CVTSUSP  EQU   CVTS01+692
CVTT6SVC EQU   CVTS01+688
CVTCDAL  EQU   CVTS01+684
CVTTCTL  EQU   CVTS01+680
CVTRSUME EQU   CVTS01+676
CVTJTERM EQU   CVTS01+672
CVTASMRM EQU   CVTS01+668
CVTTCASP EQU   CVTS01+664
CVT0PT03 EQU   CVTS01+660
CVT0PT0E EQU   CVTS01+656
CVTRV609 EQU   CVTS01+652
CVTCGK   EQU   CVTS01+648
CVTRAC   EQU   CVTS01+644
CVTHSM   EQU   CVTS01+640
CVTRV605 EQU   CVTS01+636
CVTRV604 EQU   CVTS01+632
CVTEFF02 EQU   CVTS01+628
CVTCBBR  EQU   CVTS01+624
CVTSSCR  EQU   CVTS01+620
CVTEVENT EQU   CVTS01+616
CVTCRCA  EQU   CVTS01+612
CVTTPIO  EQU   CVTS01+608
CVTADV   EQU   CVTS01+604
CVTGSDAB EQU   CVTGSDA
CVTQV3   EQU   CVTS01+596
CVTQV2   EQU   CVTS01+592
CVTQV1   EQU   CVTS01+588
CVTRPT   EQU   CVTS01+584
CVTSSRB  EQU   CVTS01+580
CVTCSDRL EQU   CVTS01+576
CVTEXP1  EQU   CVTS01+572
CVTRMPMT EQU   CVTS01+568
CVTRMPTT EQU   CVTS01+564
CVTVPSA  EQU   CVTS01+560
CVTVSTOP EQU   CVTS01+556
CVTGTFR8 EQU   CVTS01+552
CVTQUIT  EQU   CVTS01+548
CVTVACR  EQU   CVTS01+544
CVTWTCB  EQU   CVTS01+540
CVTSTPRS EQU   CVTS01+536
CVT0PT02 EQU   CVTS01+532
CVTDARCM EQU   CVTS01+528
CVTIRECM EQU   CVTS01+524
CVTJRECM EQU   CVTS01+520
CVTVEMS0 EQU   CVTS01+516
CVTSPFRR EQU   CVTS01+512
CVTRLSTG EQU   CVTS01+508
CVT0TC0A EQU   CVTS01+504
CVTGMBR  EQU   CVTS01+500
CVTLFRM  EQU   CVTS01+496
CVTRMBR  EQU   CVTS01+492
CVTVIOP  EQU   CVTS01+488
CVTRV307 EQU   CVTS01+486
CVTRV306 EQU   CVTS01+484
CVTRV305 EQU   CVTS01+482
CVTRV304 EQU   CVTS01+480
CVTRV303 EQU   CVTS01+478
CVTRV302 EQU   CVTS01+476
CVTTRCA  EQU   CVTS01+472
CVTRV297 EQU   CVTRV289
CVTRV296 EQU   CVTRV289
CVTRV295 EQU   CVTRV289
CVTRV294 EQU   CVTRV289
CVTRV293 EQU   CVTRV289
CVTRV292 EQU   CVTRV289
CVTRV291 EQU   CVTRV289
CVTRV290 EQU   CVTRV289
CVTRV288 EQU   CVTRV280
CVTRV287 EQU   CVTRV280
CVTRV286 EQU   CVTRV280
CVTRV285 EQU   CVTRV280
CVTRV284 EQU   CVTRV280
CVTRV283 EQU   CVTRV280
CVTRV282 EQU   CVTRV280
CVTRV281 EQU   CVTRV280
CVTRV279 EQU   CVTRV271
CVTRV278 EQU   CVTRV271
CVTRV277 EQU   CVTRV271
CVTRV276 EQU   CVTRV271
CVTRV275 EQU   CVTRV271
CVTRV274 EQU   CVTRV271
CVTRV273 EQU   CVTRV271
CVTRV272 EQU   CVTRV271
CVTRV270 EQU   CVTRV262
CVTRV269 EQU   CVTRV262
CVTRV268 EQU   CVTRV262
CVTRV267 EQU   CVTRV262
CVTRV266 EQU   CVTRV262
CVTRV265 EQU   CVTRV262
CVTRV264 EQU   CVTRV262
CVTRV263 EQU   CVTRV262
CVTVFP   EQU   CVTS01+464
CVTVSI   EQU   CVTS01+460
CVTVPSIB EQU   CVTS01+456
CVTMFACT EQU   CVTMFRTR
CVTMFCTL EQU   CVTS01+448
CVTPVBP  EQU   CVTS01+444
CVTPWI   EQU   CVTS01+440
CVTRV254 EQU   CVTS01+438
CVTRV253 EQU   CVTS01+436
CVTRV252 EQU   CVTS01+434
CVTRV251 EQU   CVTS01+433
CVTRV250 EQU   CVTS01+432
CVTRV249 EQU   CVTS01+431
CVTRV248 EQU   CVTS01+430
CVTRV247 EQU   CVTS01+429
CVTRV246 EQU   CVTS01+428
CVTRV245 EQU   CVTRV237
CVTRV244 EQU   CVTRV237
CVTRV243 EQU   CVTRV237
CVTRV242 EQU   CVTRV237
CVTRV241 EQU   CVTRV237
CVTRV240 EQU   CVTRV237
CVTRV239 EQU   CVTRV237
CVTRV238 EQU   CVTRV237
CVTRV236 EQU   CVTRV228
CVTRV235 EQU   CVTRV228
CVTRV234 EQU   CVTRV228
CVTRV233 EQU   CVTRV228
CVTRV232 EQU   CVTRV228
CVTRV231 EQU   CVTRV228
CVTRV230 EQU   CVTRV228
CVTRV229 EQU   CVTRV228
CVTRV227 EQU   CVTRV219
CVTRV226 EQU   CVTRV219
CVTRV225 EQU   CVTRV219
CVTRV224 EQU   CVTRV219
CVTRV223 EQU   CVTRV219
CVTRV222 EQU   CVTRV219
CVTRV221 EQU   CVTRV219
CVTRV220 EQU   CVTRV219
CVTRV218 EQU   CVTRV210
CVTRV217 EQU   CVTRV210
CVTRV216 EQU   CVTRV210
CVTRV215 EQU   CVTRV210
CVTRV214 EQU   CVTRV210
CVTRV213 EQU   CVTRV210
CVTRV212 EQU   CVTRV210
CVTRV211 EQU   CVTRV210
CVTLCCAT EQU   CVTS01+420
CVTPCCAT EQU   CVTS01+416
CVTIPCRP EQU   CVTS01+412
CVTIPCRI EQU   CVTS01+408
CVTIPCDS EQU   CVTS01+404
CVTAIDVT EQU   CVTS01+400
CVTSSAP  EQU   CVTS01+396
CVTEHCIR EQU   CVTS01+392
CVTEHDEF EQU   CVTS01+388
CVTDAIR  EQU   CVTS01+384
CVTPERFM EQU   CVTS01+380
CVT044R2 EQU   CVTS01+376
CVTFETCH EQU   CVTS01+372
CVTRSTWD EQU   CVTS01+368
CVTSPOST EQU   CVTS01+364
CVTIOBP  EQU   CVTS01+360
CVTASMVT EQU   CVTS01+356
CVTRECRQ EQU   CVTS01+352
CVTWSAC  EQU   CVTS01+348
CVTRV149 EQU   CVTS01+344
CVTWSAL  EQU   CVTS01+340
CVTSPSA  EQU   CVTS01+336
CVTGLMN  EQU   CVTS01+332
CVTVEAC0 EQU   CVTS01+328
CVT062R1 EQU   CVTS01+324
CVTRPOST EQU   CVTS01+320
CVTDQIQE EQU   CVTS01+316
CVTCSD   EQU   CVTS01+312
CVTLKRMA EQU   CVTS01+308
CVTRSPIE EQU   CVTS01+304
CVTRENQ  EQU   CVTS01+300
CVTLQCB  EQU   CVTS01+296
CVTFQCB  EQU   CVTS01+292
CVTQCS01 EQU   CVTS01+288
CVTAPFT  EQU   CVTS01+284
CVTPARRL EQU   CVTS01+280
CVTVWAIT EQU   CVTS01+276
CVTGSPL  EQU   CVTS01+272
CVTLSMQ  EQU   CVTS01+268
CVTGSMQ  EQU   CVTS01+264
CVTEXPRO EQU   CVTS01+260
CVTOPCTP EQU   CVTS01+256
CVTSIC   EQU   CVTS01+252
CVTTPIOS EQU   CVTS01+248
CVTRTMS  EQU   CVTS01+244
CVTSDBF  EQU   CVTS01+240
CVTSCBP  EQU   CVTS01+236
CVTSDMP  EQU   CVTS01+232
CVTSV60  EQU   CVTS01+228
CVTRTMCT EQU   CVTS01+224
CVTASCBL EQU   CVTS01+220
CVTASCBH EQU   CVTS01+216
CVTGDA   EQU   CVTS01+212
CVTASVT  EQU   CVTS01+208
CVTVVMDI EQU   CVTS01+204
CVTAQTOP EQU   CVTS01+200
CVTIOSCS EQU   CVTS01+196
CVTSDRM  EQU   CVTS01+192
CVTOPTE  EQU   CVTS01+188
CVTSTXU  EQU   CVTS01+184
CVTQUIS  EQU   CVTS01+180
CVTPARS  EQU   CVTS01+176
CVTS1EE  EQU   CVTS01+172
CVTFRAS  EQU   CVTS01+168
CVTQSAS  EQU   CVTS01+164
CVTCRAS  EQU   CVTS01+160
CVTCRMN  EQU   CVTS01+156
CVTDELCP EQU   CVTS01+152
CVTFRECL EQU   CVTS01+148
CVTGETCL EQU   CVTS01+144
CVTBLDCP EQU   CVTS01+140
CVTAUTHL EQU   CVTS01+136
CVTSCAN  EQU   CVTS01+132
CVTRV144 EQU   CVTS01+130
CVTMAXMP EQU   CVTS01+128
CVTSTCK  EQU   CVTS01+124
CVTRV139 EQU   CVTS01+123
CVTDSSAC EQU   CVTS01+122
CVTRV513 EQU   CVTS01+121
CVTIOSPL EQU   CVTS01+120
CVTPTGT  EQU   CVTS01+116
CVTCSPIE EQU   CVTS01+112
CVTSMFEX EQU   CVTS01+108
CVTOLT0A EQU   CVTS01+104
CVTSRBRT EQU   CVTS01+100
CVTPUTL  EQU   CVTS01+96
CVTASCRL EQU   CVTS01+92
CVTASCRF EQU   CVTS01+88
CVTRV326 EQU   CVTS01+84
CVTRV325 EQU   CVTS01+80
CVTRV324 EQU   CVTS01+76
CVT0VL01 EQU   CVTS01+72
CVTSHRVM EQU   CVTS01+68
CVTRV332 EQU   CVTS01+64
CVTTAS   EQU   CVTS01+60
CVTRSCN  EQU   CVTS01+56
CVTTRAC2 EQU   CVTS01+54
CVTTRACE EQU   CVTS01+52
CVTAPG   EQU   CVTS01+51
CVTSDTRC EQU   CVTCTLFG
CVTGTRCE EQU   CVTCTLFG
CVTNOMP  EQU   CVTCTLFG
CVTRSV79 EQU   CVTCTLFG
CVTDSTAT EQU   CVTCTLFG
CVTRSV78 EQU   CVTCTLFG
CVTRV333 EQU   CVTCTLFG
CVTRV323 EQU   CVTCTLFG
CVTSPVLK EQU   CVTS01+49
CVTRSV77 EQU   CVTS01+48
CVTRV331 EQU   CVTS01+44
CVTRV330 EQU   CVTS01+40
CVTRV329 EQU   CVTS01+36
CVTRV328 EQU   CVTS01+32
CVTRV322 EQU   CVTS01+28
CVTSLID  EQU   CVTSLIDA+1
CVTSYLK  EQU   CVTSLIDA
CVTRV321 EQU   CVTS01+20
CVTRV320 EQU   CVTS01+16
CVTLPDIR EQU   CVTLPDIA+1
CVTRSV69 EQU   CVTDIRST
CVTRSV68 EQU   CVTDIRST
CVTRSV67 EQU   CVTDIRST
CVTRSV66 EQU   CVTDIRST
CVTRSV65 EQU   CVTDIRST
CVTRSV64 EQU   CVTDIRST
CVTRSV63 EQU   CVTDIRST
CVTDICOM EQU   CVTDIRST
CVTPVTP  EQU   CVTS01+8
CVTLPDSR EQU   CVTS01+4
CVTGETL  EQU   CVTS01
JSCBEND3 EQU   JSCBSEC3+120
JSCRSV52 EQU   JSCBSEC3+116
JSCRSV51 EQU   JSCRSV47+1
JSCRSV50 EQU   JSCRSV47
JSCRSV49 EQU   JSCRSV46+1
JSCRSV48 EQU   JSCRSV46
JSCRSV44 EQU   JSCBSEC3+108
JSCRSV43 EQU   JSCBSEC3+104
JSCRSV42 EQU   JSCBSEC3+100
JSCBUFPT EQU   JSCBSEC3+92
JSCBSWSP EQU   JSCBSEC3+87
JSCRSV33 EQU   JSCBSEC3+86
JSCDDNUM EQU   JSCBSEC3+84
JSCRSV53 EQU   JSCBSEC3+82
JSCDDNNO EQU   JSCBSEC3+80
JSCBVATA EQU   JSCBSEC3+76
JSCTMCOR EQU   JSCBSEC3+72
JSCSCTP  EQU   JSCSCT+1
JSCRSV55 EQU   JSCSCT
JSCRSV54 EQU   JSCBSEC3+64
JSCDSABQ EQU   JSCBSEC3+60
JSCBSSIB EQU   JSCBSEC3+56
JSCBFRBA EQU   JSCBSEC3+48
JSCRSV28 EQU   JSCBSEC3+46
JSCBSONO EQU   JSCBSEC3+44
JSCBSUBA EQU   JSCBSUB+1
JSCRSV31 EQU   JSCBSUB
JSCBSMLR EQU   JSCBSEC3+36
JSCBJNLR EQU   JSCBSEC3+32
JSCBJNLA EQU   JSCBJNL+1
JSCBJSBT EQU   JSCBJJSB
JSCBJSBX EQU   JSCBJJSB
JSCBJSBA EQU   JSCBJJSB
JSCBJSBI EQU   JSCBJJSB
@NM00019 EQU   JSCBJJSB
JSCBJNLE EQU   JSCBJJSB
JSCBJNLF EQU   JSCBJJSB
JSCBJNLN EQU   JSCBJJSB
@NM00018 EQU   JSCBSEC3+24
JSCBJRBA EQU   JSCBSEC3+16
JSCBIECB EQU   JSCBSEC3+12
JSCBRV08 EQU   JSCBSEC3+11
JSCBRV07 EQU   JSCBFBYT
JSCBRV06 EQU   JSCBFBYT
JSCBRV05 EQU   JSCBFBYT
JSCBRV04 EQU   JSCBFBYT
JSCBRV03 EQU   JSCBFBYT
JSCBRV02 EQU   JSCBFBYT
JSCBADSP EQU   JSCBFBYT
JSCBRV01 EQU   JSCBFBYT
JSCBTJID EQU   JSCBASID
JSCBPSCB EQU   JSCBSEC3+4
JSCJCTP  EQU   JSCBJCTA
JSCRSV24 EQU   JSCBJCT
JSCBEND2 EQU   JSCBSEC2
USEABEND EQU   ABENDCMP+1
TRMSTHDR EQU   TRMRB+12
@NM00099 EQU   TRMRB+6
@NM00098 EQU   TRMFLAGS
TRMSCHAB EQU   TRMFLAGS
TRMALLOK EQU   TRMFLAGS
ASCBEND  EQU   ASCB+208
ASCBSRBT EQU   ASCB+200
ASCBSWTL EQU   ASCB+196
ASCBRS14 EQU   ASCB+195
ASCBSMCT EQU   ASCB+194
ASCBRS12 EQU   ASCB+192
ASCBPCTT EQU   ASCB+188
ASCBVGTT EQU   ASCB+184
ASCBRV43 EQU   ASCBSRQ4
ASCBRV42 EQU   ASCBSRQ4
ASCBRV41 EQU   ASCBSRQ4
ASCBRV40 EQU   ASCBSRQ4
ASCBRV39 EQU   ASCBSRQ4
ASCBRV38 EQU   ASCBSRQ4
ASCBRV37 EQU   ASCBSRQ4
ASCBRV36 EQU   ASCBSRQ4
ASCBRV35 EQU   ASCBSRQ3
ASCBRV34 EQU   ASCBSRQ3
ASCBRV33 EQU   ASCBSRQ3
ASCBRV32 EQU   ASCBSRQ3
ASCBRV31 EQU   ASCBSRQ3
ASCBRV30 EQU   ASCBSRQ3
ASCBRV29 EQU   ASCBSRQ3
ASCBRV28 EQU   ASCBSRQ3
ASCBRV27 EQU   ASCBSRQ2
ASCBRV26 EQU   ASCBSRQ2
ASCBRV25 EQU   ASCBSRQ2
ASCBRV24 EQU   ASCBSRQ2
ASCBRV23 EQU   ASCBSRQ2
ASCBRV22 EQU   ASCBSRQ2
ASCBRV21 EQU   ASCBSRQ2
ASCBRV20 EQU   ASCBSRQ2
ASCBRV19 EQU   ASCBSRQ1
ASCBRV18 EQU   ASCBSRQ1
ASCBRV17 EQU   ASCBSRQ1
ASCBRV16 EQU   ASCBSRQ1
ASCBRV15 EQU   ASCBSRQ1
ASCBRV14 EQU   ASCBSRQ1
ASCBRV13 EQU   ASCBSRQ1
ASCBSTA  EQU   ASCBSRQ1
ASCBJBNS EQU   ASCB+176
ASCBJBNI EQU   ASCB+172
ASCBMCC  EQU   ASCB+168
ASCBRTWA EQU   ASCB+164
ASCBIQEA EQU   ASCB+160
ASCBXMPQ EQU   ASCB+156
ASCBRS01 EQU   ASCB+154
ASCBFMCT EQU   ASCB+152
ASCBOUXB EQU   ASCB+148
ASCBOUCB EQU   ASCB+144
ASCBMECB EQU   ASCB+140
ASCBQECB EQU   ASCB+136
ASCBLSQH EQU   ASCBLKGP+4
ASCBLOCK EQU   ASCBLKGP
ASCBTCBS EQU   ASCB+124
ASCBNVSC EQU   ASCB+122
ASCBVSC  EQU   ASCB+120
ASCBSRBS EQU   ASCB+118
ASCBSSRB EQU   ASCB+116
ASCBRV06 EQU   ASCBFLG2
ASCBRV05 EQU   ASCBFLG2
ASCBRV04 EQU   ASCBFLG2
ASCBSNQS EQU   ASCBFLG2
ASCBS2S  EQU   ASCBFLG2
ASCBCEXT EQU   ASCBFLG2
ASCBPXMT EQU   ASCBFLG2
ASCBXMPT EQU   ASCBFLG2
ASCBRF07 EQU   ASCBDSP1
ASCBRF06 EQU   ASCBDSP1
ASCBRF05 EQU   ASCBDSP1
ASCBRF04 EQU   ASCBDSP1
ASCBRF03 EQU   ASCBDSP1
ASCBRF02 EQU   ASCBDSP1
ASCBFAIL EQU   ASCBDSP1
ASCBNOQ  EQU   ASCBDSP1
ASCBSWCT EQU   ASCB+112
ASCBASXB EQU   ASCB+108
ASCBTMCH EQU   ASCB+104
ASCBNSWP EQU   ASCBFLG1
ASCBTYP1 EQU   ASCBFLG1
ASCBSTND EQU   ASCBFLG1
ASCBABNT EQU   ASCBFLG1
ASCBTERM EQU   ASCBFLG1
ASCBS3S  EQU   ASCBFLG1
ASCBCMSH EQU   ASCBFLG1
ASCBTOFF EQU   ASCBFLG1
ASCBRF01 EQU   ASCBRCTF
ASCBTMLW EQU   ASCBRCTF
ASCBOUT  EQU   ASCBRCTF
ASCBWAIT EQU   ASCBRCTF
ASCBRV08 EQU   ASCBRCTF
ASCBFQU  EQU   ASCBRCTF
ASCBFRS  EQU   ASCBRCTF
ASCBTMNO EQU   ASCBRCTF
ASCBAFFN EQU   ASCBFW1
ASCBDUMP EQU   ASCB+96
ASCBRV44 EQU   ASCB+92
ASCBUBET EQU   ASCB+88
ASCBECB  EQU   ASCB+84
ASCBJSTL EQU   ASCB+80
ASCBEWST EQU   ASCB+72
ASCBEJST EQU   ASCB+64
ASCBTSB  EQU   ASCB+60
ASCBCSCB EQU   ASCB+56
ASCBRSMA EQU   ASCBRSM+1
ASCBRV54 EQU   ASCBRSMF
ASCBRV53 EQU   ASCBRSMF
ASCBRV52 EQU   ASCBRSMF
ASCBRV51 EQU   ASCBRSMF
ASCBVEQR EQU   ASCBRSMF
ASCBN2LP EQU   ASCBRSMF
ASCB1LPU EQU   ASCBRSMF
ASCB2LPU EQU   ASCBRSMF
ASCBLDA  EQU   ASCB+48
ASCBSTOR EQU   ASCB+44
ASCBDP   EQU   ASCB+43
ASCBRV07 EQU   ASCB+42
ASCBIOSM EQU   ASCB+40
ASCBSEQN EQU   ASCB+38
ASCBCPUS EQU   ASCB+32
ASCBSPL  EQU   ASCB+28
ASCBIOSP EQU   ASCB+24
ASCBSYNC EQU   ASCBSUPC+4
ASCBSVRB EQU   ASCBSUPC
ASCBCMSF EQU   ASCB+12
ASCBBWDP EQU   ASCB+8
ASCBFWDP EQU   ASCB+4
ASCBASCB EQU   ASCB
ASCBEGIN EQU   ASCB
SURV104  EQU   SUBITS+13
SURV103  EQU   SUBYTE13
SURV102  EQU   SUBYTE13
SURV101  EQU   SUBYTE13
SU100BT  EQU   SUBYTE13
SU99BIT  EQU   SUBYTE13
SU98BIT  EQU   SUBYTE13
SU97BIT  EQU   SUBYTE13
SU96BIT  EQU   SUBYTE13
SU95BIT  EQU   SUBYTE12
SU94BIT  EQU   SUBYTE12
SU93BIT  EQU   SUBYTE12
SU92BIT  EQU   SUBYTE12
SU91BIT  EQU   SUBYTE12
SU90BIT  EQU   SUBYTE12
SU89BIT  EQU   SUBYTE12
SU88BIT  EQU   SUBYTE12
SU87BIT  EQU   SUBYTE11
SU86BIT  EQU   SUBYTE11
SU85BIT  EQU   SUBYTE11
SU84BIT  EQU   SUBYTE11
SU83BIT  EQU   SUBYTE11
SU82BIT  EQU   SUBYTE11
SU81BIT  EQU   SUBYTE11
SU80BIT  EQU   SUBYTE11
SU79BIT  EQU   SUBYTE10
SU78BIT  EQU   SUBYTE10
SU77BIT  EQU   SUBYTE10
SU76BIT  EQU   SUBYTE10
SU75BIT  EQU   SUBYTE10
SU74BIT  EQU   SUBYTE10
SU73BIT  EQU   SUBYTE10
SU72BIT  EQU   SUBYTE10
SU71BIT  EQU   SUBYTE9
SU70BIT  EQU   SUBYTE9
SU69BIT  EQU   SUBYTE9
SU68BIT  EQU   SUBYTE9
SU67BIT  EQU   SUBYTE9
SU66BIT  EQU   SUBYTE9
SU65BIT  EQU   SUBYTE9
SU64BIT  EQU   SUBYTE9
SU63BIT  EQU   SUBYTE8
SU62BIT  EQU   SUBYTE8
SU61BIT  EQU   SUBYTE8
SU60BIT  EQU   SUBYTE8
SU59BIT  EQU   SUBYTE8
SU58BIT  EQU   SUBYTE8
SU57BIT  EQU   SUBYTE8
SU56BIT  EQU   SUBYTE8
SU55BIT  EQU   SUBYTE7
SU54BIT  EQU   SUBYTE7
SU53BIT  EQU   SUBYTE7
SU52BIT  EQU   SUBYTE7
SU51BIT  EQU   SUBYTE7
SU50BIT  EQU   SUBYTE7
SU49BIT  EQU   SUBYTE7
SU48BIT  EQU   SUBYTE7
SU47BIT  EQU   SUBYTE6
SU46BIT  EQU   SUBYTE6
SU45BIT  EQU   SUBYTE6
SU44BIT  EQU   SUBYTE6
SU43BIT  EQU   SUBYTE6
SU42BIT  EQU   SUBYTE6
SU41BIT  EQU   SUBYTE6
SU40BIT  EQU   SUBYTE6
SU39BIT  EQU   SUBYTE5
SU38BIT  EQU   SUBYTE5
SU37BIT  EQU   SUBYTE5
SU36BIT  EQU   SUBYTE5
SU35BIT  EQU   SUBYTE5
SU34BIT  EQU   SUBYTE5
SU33BIT  EQU   SUBYTE5
SU32BIT  EQU   SUBYTE5
SU31BIT  EQU   SUBYTE4
SU30BIT  EQU   SUBYTE4
SU29BIT  EQU   SUBYTE4
SU28BIT  EQU   SUBYTE4
SU27BIT  EQU   SUBYTE4
SU26BIT  EQU   SUBYTE4
SU25BIT  EQU   SUBYTE4
SU23BIT  EQU   SUBYTE3
SU22BIT  EQU   SUBYTE3
SU21BIT  EQU   SUBYTE3
SU20BIT  EQU   SUBYTE3
SU19BIT  EQU   SUBYTE3
SU18BIT  EQU   SUBYTE3
SU17BIT  EQU   SUBYTE3
SU16BIT  EQU   SUBYTE3
SU15BIT  EQU   SUBYTE2
SU14BIT  EQU   SUBYTE2
SU13BIT  EQU   SUBYTE2
SU12BIT  EQU   SUBYTE2
SU11BIT  EQU   SUBYTE2
SU10BIT  EQU   SUBYTE2
SU9BIT   EQU   SUBYTE2
SU8BIT   EQU   SUBYTE2
SU7BIT   EQU   SUBYTE1
SU6BIT   EQU   SUBYTE1
SU5BIT   EQU   SUBYTE1
SU4BIT   EQU   SUBYTE1
SU3BIT   EQU   SUBYTE1
SU2BIT   EQU   SUBYTE1
SU1BIT   EQU   SUBYTE1
SU0BIT   EQU   SUBYTE1
CVTLEVL  EQU   CVTRELNO+2
CVTNUMB  EQU   CVTRELNO
CVTMDL   EQU   CVTFIX+250
@NM00073 EQU   CVTFIX+248
@NM00072 EQU   CVTFIX
CVTRV482 EQU   CVTXTNT2+128
CVTRV481 EQU   CVTXTNT2+124
CVTRV480 EQU   CVTXTNT2+120
CVTRV479 EQU   CVTXTNT2+118
CVTRV478 EQU   CVTXTNT2+117
CVTRV477 EQU   CVTXTNT2+116
CVTRV476 EQU   CVTXTNT2+115
CVTRV475 EQU   CVTXTNT2+114
CVTRV474 EQU   CVTRV466
CVTRV473 EQU   CVTRV466
CVTRV472 EQU   CVTRV466
CVTRV471 EQU   CVTRV466
CVTRV470 EQU   CVTRV466
CVTRV469 EQU   CVTRV466
CVTRV468 EQU   CVTRV466
CVTRV467 EQU   CVTRV466
CVTRV465 EQU   CVTRV457
CVTRV464 EQU   CVTRV457
CVTRV463 EQU   CVTRV457
CVTRV462 EQU   CVTRV457
CVTRV461 EQU   CVTRV457
CVTRV460 EQU   CVTRV457
CVTRV459 EQU   CVTRV457
CVTRV458 EQU   CVTRV457
CVTRV456 EQU   CVTXTNT2+108
CVTRV455 EQU   CVTXTNT2+104
CVTRV454 EQU   CVTXTNT2+100
CVTRV453 EQU   CVTXTNT2+96
CVTRV452 EQU   CVTXTNT2+94
CVTRV451 EQU   CVTXTNT2+92
CVTRV450 EQU   CVTXTNT2+90
CVTRV449 EQU   CVTXTNT2+88
CVTRV448 EQU   CVTXTNT2+87
CVTRV447 EQU   CVTXTNT2+86
CVTRV446 EQU   CVTRV438
CVTRV445 EQU   CVTRV438
CVTRV444 EQU   CVTRV438
CVTRV443 EQU   CVTRV438
CVTRV442 EQU   CVTRV438
CVTRV441 EQU   CVTRV438
CVTRV440 EQU   CVTRV438
CVTRV439 EQU   CVTRV438
CVTRV437 EQU   CVTRV429
CVTRV436 EQU   CVTRV429
CVTRV435 EQU   CVTRV429
CVTRV434 EQU   CVTRV429
CVTRV433 EQU   CVTRV429
CVTRV432 EQU   CVTRV429
CVTRV431 EQU   CVTRV429
CVTRV430 EQU   CVTRV429
CVTRV428 EQU   CVTXTNT2+80
CVTRV427 EQU   CVTXTNT2+76
CVTRV426 EQU   CVTXTNT2+72
CVTRV425 EQU   CVTXTNT2+68
CVTATACT EQU   CVTATCVT
CVTRV423 EQU   CVTXTNT2+62
CVTRV422 EQU   CVTXTNT2+60
CVTRV421 EQU   CVTXTNT2+58
CVTRV420 EQU   CVTXTNT2+56
CVTRV419 EQU   CVTXTNT2+55
CVTRV418 EQU   CVTXTNT2+54
CVTRV417 EQU   CVTRV409
CVTRV416 EQU   CVTRV409
CVTRV415 EQU   CVTRV409
CVTRV414 EQU   CVTRV409
CVTRV413 EQU   CVTRV409
CVTRV412 EQU   CVTRV409
CVTRV411 EQU   CVTRV409
CVTRV410 EQU   CVTRV409
CVTRV408 EQU   CVTRV400
CVTRV407 EQU   CVTRV400
CVTRV406 EQU   CVTRV400
CVTRV405 EQU   CVTRV400
CVTRV404 EQU   CVTRV400
CVTRV403 EQU   CVTRV400
CVTRV402 EQU   CVTRV400
CVTRV401 EQU   CVTRV400
CVTSKTA  EQU   CVTXTNT2+44
CVTCCVT  EQU   CVTXTNT2+40
CVTRSV98 EQU   CVTXTNT2+36
CVTRSV97 EQU   CVTXTNT2+34
CVTRSV96 EQU   CVTXTNT2+32
CVTOLTEP EQU   CVTXTNT2+28
CVTQIDA  EQU   CVTQID+1
CVTRSV95 EQU   CVTQID
CVTRSV94 EQU   CVTXTNT2+20
CVTRSV93 EQU   CVTXTNT2+16
CVTRSV92 EQU   CVTXTNT2+12
CVTDEBVR EQU   CVTXTNT2+8
CVTRSV91 EQU   CVTXTNT2+6
CVTRSV9H EQU   CVTFLGBT
CVTRSV9G EQU   CVTFLGBT
CVTRSV9F EQU   CVTFLGBT
CVTRSV9E EQU   CVTFLGBT
CVTRSV9D EQU   CVTFLGBT
CVTRSV9C EQU   CVTFLGBT
CVTVME   EQU   CVTFLGBT
CVTNPE   EQU   CVTFLGBT
CVTNUCLS EQU   CVTXTNT2+4
CVTDSSVA EQU   CVTDSSV+1
CVTRSV89 EQU   CVTDSSV
CVTRSV88 EQU   CVTXTNT1+8
CVTRSV87 EQU   CVTXTNT1+4
CVTFACHN EQU   CVTXTNT1
CVTRV488 EQU   CVTMAP+412
CVTRV487 EQU   CVTMAP+408
CVTRV486 EQU   CVTMAP+404
CVTRV485 EQU   CVTMAP+400
CVTACTAP EQU   CVTMAP+396
CVTAUTH  EQU   CVTMAP+392
CVTATMCA EQU   CVTATMCT+1
CVTATMST EQU   CVTATMCT
CVTRSV61 EQU   CVTMAP+384
CVTVOLT1 EQU   CVTVOLM1+1
CVTVOLI1 EQU   CVTVOLF1
CVTSTOA  EQU   CVTMAP+376
CVTRSV58 EQU   CVTMAP+374
CVTRSV57 EQU   CVTMAP+372
CVTDDCE  EQU   CVTMAP+368
CVTPNWFR EQU   CVTMAP+364
CVTSMF   EQU   CVTMAP+360
CVTSULK  EQU   CVTMAP+358
CVTSLKO  EQU   CVTSYSK
CVTSLKP  EQU   CVTSYSK
CVTSLKQ  EQU   CVTSYSK
CVTSLKR  EQU   CVTSYSK
CVTRSV56 EQU   CVTSYSK
CVTRSV55 EQU   CVTSYSK
CVTRSV54 EQU   CVTSYSK
CVTRSV53 EQU   CVTSYSK
CVTRSV52 EQU   CVTA1F1
CVTRSV51 EQU   CVTA1F1
CVTRSV50 EQU   CVTA1F1
CVTRSV49 EQU   CVTA1F1
CVTRSV48 EQU   CVTA1F1
CVTRSV47 EQU   CVTA1F1
CVTSRSW  EQU   CVTA1F1
CVTPFSW  EQU   CVTA1F1
CVTPCVT  EQU   CVTMAP+352
CVTRSV46 EQU   CVTMAP+344
CVTRSV45 EQU   CVTMAP+340
CVTRSV44 EQU   CVTMAP+338
CVTRSV43 EQU   CVTMAP+336
CVTHJESA EQU   CVTHJES+1
CVTRSV42 EQU   CVTHJES
CVTEXT2A EQU   CVTEXT2+1
CVTRSV41 EQU   CVTEXT2
CVTAPFA  EQU   CVTAPF+1
CVTRSV40 EQU   CVTAPF
CVTRV518 EQU   CVTINTLA
CVTRV517 EQU   CVTERPV
CVTEORM  EQU   CVTMAP+312
CVTMCHPR EQU   CVTMAP+308
CVTTZ    EQU   CVTMAP+304
CVTJEPS  EQU   CVTMAP+300
CVTJESCT EQU   CVTMAP+296
CVTMODE  EQU   CVTMAP+292
CVTPTRV  EQU   CVTMAP+288
CVTREAL  EQU   CVTMAP+284
CVTRSV39 EQU   CVTMAP+280
CVTRSV38 EQU   CVTMAP+276
CVTDMSRA EQU   CVTDMSR+1
CVTRV634 EQU   CVTDMSRF
CVTRV633 EQU   CVTDMSRF
CVTRV632 EQU   CVTDMSRF
CVTRV631 EQU   CVTDMSRF
CVTRV630 EQU   CVTDMSRF
CVTRV629 EQU   CVTDMSRF
CVTUDUMP EQU   CVTDMSRF
CVTSDUMP EQU   CVTDMSRF
CVTQMSGA EQU   CVTQMSG+1
CVTRSV36 EQU   CVTQMSG
CVTAMFF  EQU   CVTMAP+264
CVTPURGA EQU   CVTPURG+1
CVTRSV35 EQU   CVTPURG
CVTCBSP  EQU   CVTMAP+256
CVTATERA EQU   CVTATER+1
CVTSYST  EQU   CVTATER
CVTVOLT2 EQU   CVTTAT
CVTVOLI2 EQU   CVTVOLF2
CVTAQAVB EQU   CVTAQAVT+1
CVTRSV34 EQU   CVTTCMFG
CVTRSV33 EQU   CVTTCMFG
CVTRSV32 EQU   CVTTCMFG
CVTRSV31 EQU   CVTTCMFG
CVTRSV30 EQU   CVTTCMFG
CVTRSV29 EQU   CVTTCMFG
CVTLDEV  EQU   CVTTCMFG
CVTTCRDY EQU   CVTTCMFG
CVTGTFA  EQU   CVTGTF+1
CVTRSV27 EQU   CVTGTFST
CVTRNIO  EQU   CVTGTFST
CVTUSR   EQU   CVTGTFST
CVTRV318 EQU   CVTFORM
CVTRV317 EQU   CVTTMODE
CVTRV316 EQU   CVTSTATE
CVTRV315 EQU   CVTGTFS
CVTGTFAV EQU   CVTGTFS
CVT0SCR1 EQU   CVTMAP+232
CVTRV515 EQU   CVTMAP+228
CVTRMS   EQU   CVTMAP+224
CVTPATCH EQU   CVTMAP+220
CVTTSCE  EQU   CVTMAP+216
CVTLNKSC EQU   CVTMAP+214
CVTQABST EQU   CVTMAP+212
CVTMDLDS EQU   CVTMAP+208
CVTUSER  EQU   CVTMAP+204
CVTABEND EQU   CVTMAP+200
CVTSMCA  EQU   CVTMAP+196
CVTRSV18 EQU   CVTMAP+192
CVTQLPAQ EQU   CVTMAP+188
CVTQCDSR EQU   CVTMAP+184
CVTRSV17 EQU   CVTOPTB
CVTRSV16 EQU   CVTOPTB
CVTFP    EQU   CVTOPTB
CVTAPTHR EQU   CVTOPTB
CVTNLOG  EQU   CVTOPTB
CVTTOD   EQU   CVTOPTB
CVTCTIMS EQU   CVTOPTB
CVTPROT  EQU   CVTOPTB
CVTXPFP  EQU   CVTOPTA
CVTASCII EQU   CVTOPTA
CVTRSV13 EQU   CVTOPTA
CVTRSV12 EQU   CVTOPTA
CVTNIP   EQU   CVTOPTA
CVTDDR   EQU   CVTOPTA
CVTAPR   EQU   CVTOPTA
CVTCCH   EQU   CVTOPTA
CVTSNCTR EQU   CVTMAP+180
CVTQMWR  EQU   CVTMAP+176
CVTQOCR  EQU   CVTMAP+172
CVT1EF00 EQU   CVTMAP+168
CVTMZ00  EQU   CVTMAP+164
CVTSV76Q EQU   CVTSV76C
CVTRSV11 EQU   CVTMAP+156
CVT0PT01 EQU   CVTMAP+152
CVTMSER  EQU   CVTMAP+148
CVTRV516 EQU   CVTIERLC
CVTILCH  EQU   CVTMAP+140
CVT0DS   EQU   CVTMAP+136
CVTFBOSV EQU   CVTMAP+132
CVTNUCB  EQU   CVTMAP+128
CVTIXAVL EQU   CVTMAP+124
CVTSV76M EQU   CVTIOQET
CVTDCBA  EQU   CVTMAP+117
CVTMVS2  EQU   CVTDCB
CVT6DAT  EQU   CVTDCB
CVT4MPS  EQU   CVTDCB
CVTRSV09 EQU   CVTDCB
CVT4MS1  EQU   CVTDCB
CVT2SPS  EQU   CVTDCB
CVT1SSS  EQU   CVTDCB
CVTRSV08 EQU   CVTDCB
CVTSTB   EQU   CVTMAP+112
CVTQTD00 EQU   CVTMAP+108
CVTQTE00 EQU   CVTMAP+104
CVTCUCB  EQU   CVTMAP+100
CVTSJQ   EQU   CVTMAP+96
CVTPBLDL EQU   CVTMAP+92
CVTTPC   EQU   CVTMAP+88
CVTSVDCB EQU   CVTMAP+84
CVTBRET  EQU   CVTMAP+82
CVTEXIT  EQU   CVTMAP+80
CVT0FN00 EQU   CVTMAP+76
CVTDARA  EQU   CVTDAR+1
CVTRSV07 EQU   CVTFLGS1
CVTRSV06 EQU   CVTFLGS1
CVTRSV05 EQU   CVTFLGS1
CVTRSV04 EQU   CVTFLGS1
CVTRSV03 EQU   CVTFLGS1
CVTRSV02 EQU   CVTFLGS1
CVTRSV01 EQU   CVTFLGS1
CVTDMPLK EQU   CVTFLGS1
CVTXITP  EQU   CVTMAP+68
CVTZDTAB EQU   CVTMAP+64
CVTMSLT  EQU   CVTMAP+60
CVTDATE  EQU   CVTMAP+56
CVTBTERM EQU   CVTMAP+52
CVTSYSAD EQU   CVTMAP+48
CVTXTLER EQU   CVTMAP+44
CVTILK2  EQU   CVTMAP+40
CVTILK1  EQU   CVTMAP+36
CVTPRLTV EQU   CVTMAP+32
CVTPCNVT EQU   CVTMAP+28
CVT0VL00 EQU   CVTMAP+24
CVTXAPG  EQU   CVTMAP+20
CVTBUF   EQU   CVTMAP+16
CVTJOB   EQU   CVTMAP+12
CVTLINK  EQU   CVTMAP+8
CVT0EF00 EQU   CVTMAP+4
CVTTCBP  EQU   CVTMAP
CVT      EQU   CVTMAP
@NM00071 EQU   SDWA+512
SDWAVRA  EQU   SDWARA+4
SDWAURAL EQU   SDWARA+3
@NM00070 EQU   SDWADPVA
SDWAEBC  EQU   SDWADPVA
SDWAHEX  EQU   SDWADPVA
SDWAVRAL EQU   SDWARA
@NM00069 EQU   SDWA+396
SDWACOMP EQU   SDWA+392
SDWARCPL EQU   SDWA+364
@NM00068 EQU   SDWADPSA+32
SDWATO4  EQU   SDWADPSL+28
SDWAFRM4 EQU   SDWADPSL+24
SDWATO3  EQU   SDWADPSL+20
SDWAFRM3 EQU   SDWADPSL+16
SDWATO2  EQU   SDWADPSL+12
SDWAFRM2 EQU   SDWADPSL+8
SDWATO1  EQU   SDWADPSL+4
SDWAFRM1 EQU   SDWADPSL
@NM00067 EQU   SDWADDAT+3
@NM00066 EQU   SDWAPDAT
SDWAUSPL EQU   SDWAPDAT
SDWADPSW EQU   SDWAPDAT
SDWATJPA EQU   SDWAPDAT
SDWATLPA EQU   SDWAPDAT
SDWADREG EQU   SDWAPDAT
SDWADSAH EQU   SDWAPDAT
SDWADSAS EQU   SDWAPDAT
@NM00065 EQU   SDWADDAT+1
@NM00064 EQU   SDWASDAT
SDWAQQS  EQU   SDWASDAT
SDWACBS  EQU   SDWASDAT
SDWAGTF  EQU   SDWASDAT
SDWASWA  EQU   SDWASDAT
SDWALSQA EQU   SDWASDAT
SDWASQA  EQU   SDWASDAT
SDWANUC  EQU   SDWASDAT
@NM00063 EQU   SDWADUMP+2
@NM00062 EQU   SDWADPFS
SDWASLST EQU   SDWADPFS
@NM00061 EQU   SDWADPFS
SDWADLST EQU   SDWADPFS
SDWADPT  EQU   SDWADPFS
SDWADPID EQU   SDWADUMP
SDWADPLA EQU   SDWA+316
SDWAREXN EQU   SDWARECP+16
SDWACSCT EQU   SDWARECP+8
SDWAMODN EQU   SDWARECP
@NM00060 EQU   SDWA+290
SDWAASID EQU   SDWA+288
SDWATALW EQU   SDWALKWS+28
SDWATDLW EQU   SDWALKWS+24
SDWATNLW EQU   SDWALKWS+20
SDWAAPLW EQU   SDWALKWS+16
SDWAIPLW EQU   SDWALKWS+12
SDWAILLW EQU   SDWALKWS+8
SDWAIULW EQU   SDWALKWS+4
SDWAICLW EQU   SDWALKWS
SDWAFLLK EQU   SDWAACF4
SDWACMS  EQU   SDWAACF4
SDWAOPTM EQU   SDWAACF4
SDWATADB EQU   SDWAACF4
SDWATDNB EQU   SDWAACF4
SDWATNCB EQU   SDWAACF4
SDWAILCH EQU   SDWAACF4
SDWAIUCB EQU   SDWAACF4
SDWAICAT EQU   SDWAACF3
SDWAIPRG EQU   SDWAACF3
SDWASALL EQU   SDWAACF3
SDWAASMP EQU   SDWAACF3
SDWADISP EQU   SDWAACF3
@NM00059 EQU   SDWAACF3
@NM00058 EQU   SDWAACF2
@NM00057 EQU   SDWAACF2
SDWASPIN EQU   SDWAACF2
@NM00056 EQU   SDWAACF2
SDWALCPU EQU   SDWACPUA+2
@NM00055 EQU   SDWACPUA
SDWARECA EQU   SDWA+244
@NM00054 EQU   SDWA+239
@NM00053 EQU   SDWAIOFS
SDWANIOP EQU   SDWAIOFS
SDWANOIO EQU   SDWAIOFS
SDWAIOHT EQU   SDWAIOFS
SDWAIOQR EQU   SDWAIOFS
SDWAFMID EQU   SDWA+236
@NM00052 EQU   SDWAERRD
SDWAMCIV EQU   SDWAERRD
SDWARPIV EQU   SDWAERRD
SDWAMABD EQU   SDWAERRD
SDWACTS  EQU   SDWAERRD
SDWASTAE EQU   SDWAERRD
SDWANRBE EQU   SDWAERRD
SDWACLUP EQU   SDWAERRD
@NM00051 EQU   SDWAERRC
SDWAEAS  EQU   SDWAERRC
SDWAIRB  EQU   SDWAERRC
SDWASTAI EQU   SDWAERRC
SDWASTAF EQU   SDWAERRC
SDWASRBM EQU   SDWAERRB
SDWALDIS EQU   SDWAERRB
SDWAENRB EQU   SDWAERRB
SDWATYP1 EQU   SDWAERRB
@NM00050 EQU   SDWAERRB
SDWAPGIO EQU   SDWAERRA
SDWATEXC EQU   SDWAERRA
SDWASVCE EQU   SDWAERRA
SDWAABTM EQU   SDWAERRA
SDWASVCD EQU   SDWAERRA
SDWAMCHK EQU   SDWAERRA
SDWATIME EQU   SDWAMCH+20
SDWARFSA EQU   SDWAMCH+16
@NM00049 EQU   SDWAMCH+14
SDWAVEQR EQU   SDWARSR2
SDWAPGFX EQU   SDWARSR2
SDWAFLSQ EQU   SDWARSR2
SDWAFSQA EQU   SDWARSR2
SDWANUCL EQU   SDWARSR2
SDWASPER EQU   SDWARSR2
SDWAINTC EQU   SDWARSR2
SDWAOFLN EQU   SDWARSR2
SDWACHNG EQU   SDWARSR1
SDWAMSER EQU   SDWARSR1
@NM00048 EQU   SDWARSR1
SDWACPID EQU   SDWAMCH+10
SDWATERR EQU   SDWAMCHD
SDWAFPRX EQU   SDWAMCHD
SDWAINSF EQU   SDWAMCHD
SDWAACR  EQU   SDWAMCHD
SDWASCK  EQU   SDWAMCHD
SDWAPSWU EQU   SDWAMCHD
SDWAREGU EQU   SDWAMCHD
SDWASKYF EQU   SDWAMCHD
@NM00047 EQU   SDWAMCHS
SDWARSRF EQU   SDWAMCHS
SDWARSRC EQU   SDWAMCHS
SDWAINVP EQU   SDWAMCHS
SDWATSVL EQU   SDWAMCHS
SDWARCDF EQU   SDWAMCHS
SDWASRVL EQU   SDWAMCHS
SDWASCKE EQU   SDWASTCK+4
SDWASCKB EQU   SDWASTCK
SDWALNTH EQU   SDWAIDNT+1
SDWASPID EQU   SDWAIDNT
SDWASR15 EQU   SDWASRSV+60
SDWASR14 EQU   SDWASRSV+56
SDWASR13 EQU   SDWASRSV+52
SDWASR12 EQU   SDWASRSV+48
SDWASR11 EQU   SDWASRSV+44
SDWASR10 EQU   SDWASRSV+40
SDWASR09 EQU   SDWASRSV+36
SDWASR08 EQU   SDWASRSV+32
SDWASR07 EQU   SDWASRSV+28
SDWASR06 EQU   SDWASRSV+24
SDWASR05 EQU   SDWASRSV+20
SDWASR04 EQU   SDWASRSV+16
SDWASR03 EQU   SDWASRSV+12
SDWASR02 EQU   SDWASRSV+8
SDWASR01 EQU   SDWASRSV+4
SDWASR00 EQU   SDWASRSV
SDWATRN2 EQU   SDWAAEC2+4
SDWAIPC2 EQU   SDWAICD2
SDWAIMC2 EQU   SDWAICD2
SDWAIPR2 EQU   SDWAICD2
@NM00046 EQU   SDWAINC2
@NM00045 EQU   SDWAILC2
SDWAIL2  EQU   SDWAILC2
@NM00044 EQU   SDWAILC2
@NM00043 EQU   SDWAAEC2
SDWAADD2 EQU   SDWANXT2+1
@NM00042 EQU   SDWANXT2
@NM00041 EQU   SDWAEC2+3
SDWASGN2 EQU   SDWAINT2
SDWAEXP2 EQU   SDWAINT2
SDWADEC2 EQU   SDWAINT2
SDWAFPO2 EQU   SDWAINT2
SDWACC2  EQU   SDWAINT2
@NM00040 EQU   SDWAINT2
SDWAPGM2 EQU   SDWAMWP2
SDWAWAT2 EQU   SDWAMWP2
SDWAMCK2 EQU   SDWAMWP2
SDWAECT2 EQU   SDWAMWP2
SDWAKEY2 EQU   SDWAMWP2
SDWAEXT2 EQU   SDWAEMK2
SDWAIO2  EQU   SDWAEMK2
SDWATRM2 EQU   SDWAEMK2
@NM00039 EQU   SDWAEMK2
SDWAPER2 EQU   SDWAEMK2
@NM00038 EQU   SDWAEMK2
SDWATRAN EQU   SDWAAEC1+4
SDWAIPC1 EQU   SDWAICD1
SDWAIMC1 EQU   SDWAICD1
SDWAIPR1 EQU   SDWAICD1
@NM00037 EQU   SDWAINC1
@NM00036 EQU   SDWAILC1
SDWAIL1  EQU   SDWAILC1
@NM00035 EQU   SDWAILC1
@NM00034 EQU   SDWAAEC1
SDWAADD1 EQU   SDWANXT1+1
@NM00033 EQU   SDWANXT1
@NM00032 EQU   SDWAEC1+3
SDWASGN1 EQU   SDWAINT1
SDWAEXP1 EQU   SDWAINT1
SDWADEC1 EQU   SDWAINT1
SDWAFPO1 EQU   SDWAINT1
SDWACC1  EQU   SDWAINT1
@NM00031 EQU   SDWAINT1
SDWAPGM1 EQU   SDWAMWP1
SDWAWAT1 EQU   SDWAMWP1
SDWAMCK1 EQU   SDWAMWP1
SDWAECT1 EQU   SDWAMWP1
SDWAKEY1 EQU   SDWAMWP1
SDWAEXT1 EQU   SDWAEMK1
SDWAIO1  EQU   SDWAEMK1
SDWATRM1 EQU   SDWAEMK1
@NM00030 EQU   SDWAEMK1
SDWAPER1 EQU   SDWAEMK1
@NM00029 EQU   SDWAEMK1
SDWAIOBR EQU   SDWA+100
SDWAEPA  EQU   SDWA+96
@NM00028 EQU   SDWANAME+4
SDWARBAD EQU   SDWANAME
SDWAGR15 EQU   SDWAGRSV+60
SDWAGR14 EQU   SDWAGRSV+56
SDWAGR13 EQU   SDWAGRSV+52
SDWAGR12 EQU   SDWAGRSV+48
SDWAGR11 EQU   SDWAGRSV+44
SDWAGR10 EQU   SDWAGRSV+40
SDWAGR09 EQU   SDWAGRSV+36
SDWAGR08 EQU   SDWAGRSV+32
SDWAGR07 EQU   SDWAGRSV+28
SDWAGR06 EQU   SDWAGRSV+24
SDWAGR05 EQU   SDWAGRSV+20
SDWAGR04 EQU   SDWAGRSV+16
SDWAGR03 EQU   SDWAGRSV+12
SDWAGR02 EQU   SDWAGRSV+8
SDWAGR01 EQU   SDWAGRSV+4
SDWAGR00 EQU   SDWAGRSV
SDWANXTP EQU   SDWACTL2+5
SDWASGP  EQU   SDWAPMKP
SDWAEUP  EQU   SDWAPMKP
SDWADOP  EQU   SDWAPMKP
SDWAFPP  EQU   SDWAPMKP
SDWACCP  EQU   SDWAPMKP
SDWAILP  EQU   SDWAPMKP
SDWAINTP EQU   SDWACTL2+2
SDWASPVP EQU   SDWAMWPP
SDWAWATP EQU   SDWAMWPP
SDWAMCKP EQU   SDWAMWPP
@NM00027 EQU   SDWAMWPP
SDWAKEYP EQU   SDWAMWPP
SDWAEXTP EQU   SDWACMKP
SDWAIOP  EQU   SDWACMKP
SDWANXTA EQU   SDWACTL1+5
SDWASGA  EQU   SDWAPMKA
SDWAEUA  EQU   SDWAPMKA
SDWADOA  EQU   SDWAPMKA
SDWAFPA  EQU   SDWAPMKA
SDWACCA  EQU   SDWAPMKA
SDWAILA  EQU   SDWAPMKA
SDWAINTA EQU   SDWACTL1+2
SDWASPVA EQU   SDWAMWPA
SDWAWATA EQU   SDWAMWPA
SDWAMCKA EQU   SDWAMWPA
@NM00026 EQU   SDWAMWPA
SDWAKEYA EQU   SDWAMWPA
SDWAEXTA EQU   SDWACMKA
SDWAIOA  EQU   SDWACMKA
@NM00025 EQU   SDWACMPF
SDWASTCC EQU   SDWACMPF
@NM00024 EQU   SDWACMPF
SDWASTEP EQU   SDWACMPF
@NM00023 EQU   TCBXTNT2+32
TCBRV181 EQU   TCBRV173
TCBRV180 EQU   TCBRV173
TCBRV179 EQU   TCBRV173
TCBRV178 EQU   TCBRV173
TCBRV177 EQU   TCBRV173
TCBRV176 EQU   TCBRV173
TCBRV175 EQU   TCBRV173
TCBRV174 EQU   TCBRV173
TCBRV172 EQU   TCBRV164
TCBRV171 EQU   TCBRV164
TCBRV170 EQU   TCBRV164
TCBRV169 EQU   TCBRV164
TCBRV168 EQU   TCBRV164
TCBRV167 EQU   TCBRV164
TCBRV166 EQU   TCBRV164
TCBRV165 EQU   TCBRV164
TCBRV163 EQU   TCBRV155
TCBRV162 EQU   TCBRV155
TCBRV161 EQU   TCBRV155
TCBRV160 EQU   TCBRV155
TCBRV159 EQU   TCBRV155
TCBRV158 EQU   TCBRV155
TCBRV157 EQU   TCBRV155
TCBRV156 EQU   TCBRV155
TCBRV154 EQU   TCBRV146
TCBRV153 EQU   TCBRV146
TCBRV152 EQU   TCBRV146
TCBRV151 EQU   TCBRV146
TCBRV150 EQU   TCBRV146
TCBRV149 EQU   TCBRV146
TCBRV148 EQU   TCBRV146
TCBRV147 EQU   TCBRV146
TCBRV145 EQU   TCBXTNT2+26
TCBRV144 EQU   TCBXTNT2+24
TCBCAUF  EQU   TCBXTNT2+20
TCBRV142 EQU   TCBXTNT2+16
TCBRSV49 EQU   TCBXTNT2+12
TCBEVENT EQU   TCBXTNT2+8
TCBRCMP  EQU   TCBXTNT2+5
TCBRSVAB EQU   TCBXTNT2+4
TCBGTFA  EQU   TCBGTF+1
TCBRSV47 EQU   TCBTFLG
TCBRSV46 EQU   TCBTFLG
TCBRSV45 EQU   TCBTFLG
TCBRSV44 EQU   TCBTFLG
TCBRSV43 EQU   TCBTFLG
TCBDSPIT EQU   TCBTFLG
TCBERRTN EQU   TCBTFLG
TCBASYNC EQU   TCBTFLG
@NM00022 EQU   TCB+296
TCBSVCA2 EQU   TCB+292
TCBSWASA EQU   TCB+288
TCBDBTB  EQU   TCB+284
TCBRPT   EQU   TCB+280
TCBRV141 EQU   TCBRV133
TCBRV140 EQU   TCBRV133
TCBRV139 EQU   TCBRV133
TCBRV138 EQU   TCBRV133
TCBRV137 EQU   TCBRV133
TCBRV136 EQU   TCBRV133
TCBRV135 EQU   TCBRV133
TCBRV134 EQU   TCBRV133
TCBRV132 EQU   TCBRV124
TCBRV131 EQU   TCBRV124
TCBRV130 EQU   TCBRV124
TCBRV129 EQU   TCBRV124
TCBRV128 EQU   TCBRV124
TCBRV127 EQU   TCBRV124
TCBRV126 EQU   TCBRV124
TCBRV125 EQU   TCBRV124
TCBRV123 EQU   TCBFBYT2
TCBRV122 EQU   TCBFBYT2
TCBECBNV EQU   TCBFBYT2
TCBSSSYN EQU   TCBFBYT2
TCBFPRAP EQU   TCBFBYT2
TCBFDW   EQU   TCBFBYT2
TCBFMW   EQU   TCBFBYT2
TCBCNCB  EQU   TCBFBYT2
TCBLLH   EQU   TCBFBYT1
TCBRV113 EQU   TCBFBYT1
TCBEOT   EQU   TCBFBYT1
TCBRTM2  EQU   TCBFBYT1
TCBPGNLY EQU   TCBFBYT1
TCBNDIOS EQU   TCBFBYT1
TCBRV327 EQU   TCBFBYT1
TCBEOTFM EQU   TCBFBYT1
TCBAFFN  EQU   TCB+274
TCBRV326 EQU   TCB+272
TCBUKYSP EQU   TCB+268
TCBMODE  EQU   TCBESTAE+3
TCBERTYP EQU   TCBESTAE+2
TCBRV314 EQU   TCBESTRM
TCBRV313 EQU   TCBESTRM
TCBRV312 EQU   TCBESTRM
TCBRV311 EQU   TCBESTRM
TCBRV310 EQU   TCBESTRM
TCBRV309 EQU   TCBESTRM
TCBRV308 EQU   TCBESTRM
TCBETERM EQU   TCBESTRM
TCBSCBKY EQU   TCBESTAE
TCBRTM12 EQU   TCB+260
TCBTCBID EQU   TCB+256
TCBSTAFX EQU   TCBSTAWA
TCBSWA   EQU   TCB+248
TCBFOEA  EQU   TCBFOE+1
TCBRSV42 EQU   TCBFOE
TCBCCPVI EQU   TCBXSCT+2
TCBRV325 EQU   TCBXSCT+1
TCBRV324 EQU   TCBXSCT1
TCBRV323 EQU   TCBXSCT1
TCBRV322 EQU   TCBXSCT1
TCBRV321 EQU   TCBXSCT1
TCBRV320 EQU   TCBXSCT1
TCBRV319 EQU   TCBXSCT1
TCBS3A   EQU   TCBXSCT1
TCBACTIV EQU   TCBXSCT1
TCBRSV41 EQU   TCB+239
TCBTID   EQU   TCB+238
TCBRSVAA EQU   TCB+237
TCBABCUR EQU   TCB+236
TCBTMSAV EQU   TCB+232
TCBIOTIM EQU   TCB+228
TCBRTWA  EQU   TCB+224
TCBBACK  EQU   TCB+220
TCBTIRB  EQU   TCB+216
TCBAECB  EQU   TCB+212
TCBEXT2A EQU   TCBEXT2+1
TCBRSV39 EQU   TCBEXT2
TCBSTMCT EQU   TCB+207
TCBSYSCT EQU   TCB+206
TCBRSV37 EQU   TCB+205
TCBEXSVC EQU   TCBDAR
TCBDARMS EQU   TCBDAR
TCBDARWT EQU   TCBDAR
TCBDARO  EQU   TCBDAR
TCBDARMC EQU   TCBDARC
TCBDARD  EQU   TCBDAR
TCBDARS  EQU   TCBDAR
TCBDARP  EQU   TCBDAR
TCBGTOFM EQU   TCBFLGS7
TCBADMP  EQU   TCBFLGS7
TCBRSTSK EQU   TCBFLGS7
TCBSVCS  EQU   TCBFLGS7
TCBSTACK EQU   TCBFLGS7
TCBRSV34 EQU   TCBFLGS7
TCBRSV33 EQU   TCBFLGS7
TCBGPECB EQU   TCBFLGS7
TCBNTJS  EQU   TCBFLGS6
TCBAPG   EQU   TCBFLGS6
TCBMIGR  EQU   TCBFLGS6
TCBRV303 EQU   TCBFLGS6
TCBSPVLK EQU   TCBFLGS6
TCBCPU   EQU   TCBFLGS6
TCBPIE17 EQU   TCBFLGS6
TCBRV    EQU   TCBFLGS6
TCBRSV79 EQU   TCBNDSP5
TCBRSV78 EQU   TCBNDSP5
TCBRSV77 EQU   TCBNDSP5
TCBRSV76 EQU   TCBNDSP5
TCBRSV75 EQU   TCBNDSP5
TCBRSV74 EQU   TCBNDSP5
TCBRSV95 EQU   TCBNDSP5
TCBRSV94 EQU   TCBNDSP5
TCBRSV93 EQU   TCBNDSP4
TCBRSV92 EQU   TCBNDSP4
TCBRSV91 EQU   TCBNDSP4
TCBRSV90 EQU   TCBNDSP4
TCBRSV89 EQU   TCBNDSP4
TCBRSV88 EQU   TCBNDSP4
TCBRSV87 EQU   TCBNDSP4
TCBRSV86 EQU   TCBNDSP4
TCBEXT1A EQU   TCBEXT1+1
TCBRSV32 EQU   TCBEXT1
TCBEXCPD EQU   TCB+192
TCBIOBRC EQU   TCB+188
TCBDDWTC EQU   TCB+186
TCBDDEXC EQU   TCB+184
TCBJSCBB EQU   TCBJSCB+1
@NM00021 EQU   TCBRECDE
TCBREC   EQU   TCBRECDE
TCBMDIDS EQU   TCB+176
TCBNDINT EQU   TCBNDSP3
TCBRSV27 EQU   TCBNDSP3
TCBRSV26 EQU   TCBNDSP3
TCBRSV25 EQU   TCBNDSP3
TCBRSV24 EQU   TCBNDSP3
TCBSRBND EQU   TCBNDSP3
TCBRV302 EQU   TCBNDSP3
TCBLJSND EQU   TCBNDSP3
TCBABE   EQU   TCBNDSP2
TCBDSS   EQU   TCBNDSP2
TCBOWAIT EQU   TCBNDSP2
TCBIWAIT EQU   TCBNDSP2
TCBNDTS  EQU   TCBNDSP2
TCBNDSVC EQU   TCBNDSP2
TCBSTPP  EQU   TCBNDSP2
TCBABD   EQU   TCBNDSP2
TCBRSV22 EQU   TCBNDSP1
TCBPIEND EQU   TCBNDSP1
TCBTPSP  EQU   TCBNDSP1
TCBDDRND EQU   TCBNDSP1
TCBRSPND EQU   TCBNDSP1
TCBRSTND EQU   TCBNDSP1
TCBDARPN EQU   TCBNDSP1
TCBDARTN EQU   TCBNDSP1
TCBNDSP0 EQU   TCBNDSP
TCBUSER  EQU   TCB+168
TCBTCTB  EQU   TCBTCT+1
TCBRSV9C EQU   TCBTCTGF
TCBRSV9B EQU   TCBTCTGF
TCBRSV9A EQU   TCBTCTGF
TCBRSV99 EQU   TCBTCTGF
TCBRSV98 EQU   TCBTCTGF
TCBRSV97 EQU   TCBTCTGF
TCBRSV20 EQU   TCBTCTGF
TCBSMFGF EQU   TCBTCTGF
TCBSTABB EQU   TCBSTAB+1
TCBSTCUR EQU   TCBNSTAE
TCBRV301 EQU   TCBNSTAE
TCBSYNCH EQU   TCBNSTAE
TCBHALT  EQU   TCBNSTAE
TCBPPSUP EQU   TCBNSTAE
TCB33E   EQU   TCBNSTAE
TCBQUIES EQU   TCBNSTAE
TCBSTABE EQU   TCBNSTAE
TCBAQE   EQU   TCB+156
TCBPQE   EQU   TCB+152
TCBTSDP  EQU   TCB+151
TCBTSLP  EQU   TCB+150
TCBSTPCT EQU   TCB+149
TCBCPUBN EQU   TCBTSFLG
TCBDYDSP EQU   TCBTSFLG
TCBRSV18 EQU   TCBTSFLG
TCBRSV17 EQU   TCBTSFLG
TCBTIOTG EQU   TCBTSFLG
TCBATT   EQU   TCBTSFLG
TCBSTPPR EQU   TCBTSFLG
TCBRV300 EQU   TCBTSTSK
TCBECB   EQU   TCB+144
TCBIQE   EQU   TCB+140
TCBLTC   EQU   TCB+136
TCBOTC   EQU   TCB+132
TCBNTC   EQU   TCB+128
TCBJSTCA EQU   TCBJSTCB+1
TCBRSV16 EQU   TCBJSTCB
TCBTQET  EQU   TCBTME
TCBTCB   EQU   TCB+116
TCBFSAB  EQU   TCBFSA+1
TCBQEL   EQU   TCBFSA
TCBGRS15 EQU   TCBGRS+60
TCBGRS14 EQU   TCBGRS+56
TCBGRS13 EQU   TCBGRS+52
TCBGRS12 EQU   TCBGRS+48
TCBGRS11 EQU   TCBGRS+44
TCBGRS10 EQU   TCBGRS+40
TCBGRS9  EQU   TCBGRS+36
TCBGRS8  EQU   TCBGRS+32
TCBGRS7  EQU   TCBGRS+28
TCBGRS6  EQU   TCBGRS+24
TCBGRS5  EQU   TCBGRS+20
TCBGRS4  EQU   TCBGRS+16
TCBGRS3  EQU   TCBGRS+12
TCBGRS2  EQU   TCBGRS+8
TCBGRS1  EQU   TCBGRS+4
TCBGRS0  EQU   TCBGRS
TCBJPQB  EQU   TCBJPQ+1
TCBRSV15 EQU   TCBPURGE
TCBRSV14 EQU   TCBPURGE
TCBRSV13 EQU   TCBPURGE
TCBRSV12 EQU   TCBPURGE
TCBRSV11 EQU   TCBPURGE
TCBRSV10 EQU   TCBPURGE
TCBRSV09 EQU   TCBPURGE
TCBJPQF  EQU   TCBPURGE
TCBJLB   EQU   TCB+40
TCBLLS   EQU   TCB+36
TCBDSP   EQU   TCB+35
TCBLMP   EQU   TCB+34
TCBPNDSP EQU   TCBFLGS5
TCBFCD1  EQU   TCBFLGS5
TCBSTP   EQU   TCBFLGS5
TCBSYS   EQU   TCBFLGS5
TCBANDSP EQU   TCBFLGS5
TCBPAGE  EQU   TCBFLGS5
TCBUXNDF EQU   TCBABWF
TCBFC    EQU   TCBFLGS5
TCBONDSP EQU   TCBFLGS4
TCBMPCND EQU   TCBFLGS4
TCBMPCVQ EQU   TCBFLGS4
TCBUXNDV EQU   TCBFLGS4
TCBHNDSP EQU   TCBFLGS4
TCBRQENA EQU   TCBFLGS4
TCBSER   EQU   TCBFLGS4
TCBNDUMP EQU   TCBFLGS4
TCBDWSTA EQU   TCBFLGS3
TCBRSV08 EQU   TCBFLGS3
TCBRSV07 EQU   TCBFLGS3
TCBRSV06 EQU   TCBFLGS3
TCBABGM  EQU   TCBFLGS3
TCBABTRM EQU   TCBFLGS3
TCBADINP EQU   TCBFLGS3
TCBFSM   EQU   TCBFLGS3
TCBFTS   EQU   TCBFLGS2
TCBFETXR EQU   TCBFLGS2
TCBFDSOP EQU   TCBFLGS2
TCBFJMC  EQU   TCBFLGS2
TCBFSMC  EQU   TCBFLGS2
TCBFABOP EQU   TCBFLGS2
TCBFSTI  EQU   TCBFLGS2
TCBFOINP EQU   TCBFLGS2
TCBFX    EQU   TCBFLGS1
TCBFS    EQU   TCBFLGS1
TCBFT    EQU   TCBFLGS1
TCBPDUMP EQU   TCBFLGS1
TCBNONPR EQU   TCBFLGS1
TCBFERA  EQU   TCBFLGS1
TCBFE    EQU   TCBFLGS1
TCBFA    EQU   TCBFLGS1
TCBZERO  EQU   TCBPKF
TCBFLAG  EQU   TCBPKF
TCBMSSB  EQU   TCBMSS+1
TCBRSV03 EQU   TCBMSS
TCBTRNB  EQU   TCBTRN+1
TCBRSV02 EQU   TCBABF
TCBOLTEP EQU   TCBABF
TCBTCP   EQU   TCBABF
TCBTCPP  EQU   TCBABF
TCBRSV01 EQU   TCBABF
TCBGRPH  EQU   TCBABF
TCBNOCHK EQU   TCBABF
TCBMOD91 EQU   TCBABF
TCBCMPC  EQU   TCBCMP+1
TCBRV318 EQU   TCBCMSG
TCBRV317 EQU   TCBCIND
TCBRV316 EQU   TCBCWTO
TCBCASID EQU   TCBCDBL
TCBNOCC  EQU   TCBSTCC
TCBDMPO  EQU   TCBCPP
TCBCSTEP EQU   TCBCMPF
TCBCREQ  EQU   TCBCMPF
TCBTIO   EQU   TCB+12
TCBDEB   EQU   TCB+8
TCBPIEA  EQU   TCBPIE+1
TCBPM    EQU   TCBPMASK
@NM00020 EQU   TCBPMASK
TCBRBP   EQU   TCB
TCBFRS6  EQU   TCBFRS+24
TCBFRS4  EQU   TCBFRS+16
TCBFRS2  EQU   TCBFRS+8
TCBFRS0  EQU   TCBFRS
JSCBCSCB EQU   JSCBSEC1+68
JSCBPMG  EQU   JSCBWTP+2
JSCBWTSP EQU   JSCBWTP+1
JSCRSV23 EQU   JSCBWTFG
JSCRSV22 EQU   JSCBWTFG
JSCRSV21 EQU   JSCBWTFG
JSCRSV20 EQU   JSCBWTFG
JSCRSV19 EQU   JSCBWTFG
JSCRSV18 EQU   JSCBWTFG
JSCBRET  EQU   JSCBWTFG
JSCBIOFG EQU   JSCBWTFG
@NM00017 EQU   JSCBSEC1+60
JSCBQMPI EQU   JSCBSEC1+56
JSCBPMSG EQU   JSCBSWT1
JSCRSV16 EQU   JSCBSWT1
JSCRSV15 EQU   JSCBSWT1
JSCRSV14 EQU   JSCBSWT1
JSCRSV13 EQU   JSCBSWT1
JSCRSV12 EQU   JSCBSWT1
JSCRSV11 EQU   JSCBSWT1
JSCBPASS EQU   JSCBSWT1
JSCBTTTR EQU   JSCBSEC1+52
JSCRSV10 EQU   JSCBSEC1+49
JSCBAUTH EQU   JSCBOPTS
JSCSIOTS EQU   JSCBOPTS
JSCRSV08 EQU   JSCBOPTS
JSCRSV07 EQU   JSCBOPTS
JSCRSV06 EQU   JSCBOPTS
JSCBLONG EQU   JSCBOPTS
JSCRSV05 EQU   JSCBOPTS
JSCRSV04 EQU   JSCBOPTS
JSCBSECB EQU   JSCBSEC1+44
JSCRSV03 EQU   JSCBSEC1+41
JSCBSTEP EQU   JSCBSEC1+40
JSCBDCBA EQU   JSCBDCB+1
JSCRSV02 EQU   JSCBDCB
JSCBID   EQU   JSCBSEC1+32
JSCBDBTB EQU   JSCBSEC1+28
JSCBIJSC EQU   JSCBSEC1+24
JSCBTCBP EQU   JSCBSEC1+20
JSCBPCC  EQU   JSCBSEC1+16
JSCBTCP  EQU   JSCBSEC1+12
JSCBSHR  EQU   JSCBSEC1+8
JSCHPCEA EQU   JSCHPCE+1
JSCRSV32 EQU   JSCHPCE
JSCRSV01 EQU   JSCBSEC1
@NM00016 EQU   IEZJSCB
VEXASID  EQU   VMVEPRMS+198
@NM00015 EQU   VEXFLAGS
VEXMVCAF EQU   VEXFLAGS
VEXMVCAP EQU   VMVEPRMS+192
VMVEAUTO EQU   VMVEPRMS
PRMWTOID EQU   PRMESTAE+292
PRMNELM  EQU   PRMESTAE+288
PRMDSQF  EQU   PRMESTAE+284
PRMDSQL  EQU   PRMESTAE+280
PRMQDBP  EQU   PRMESTAE+276
PRMQMBP  EQU   PRMESTAE+272
PRMQMBLN EQU   PRMESTAE+268
PRMQMGP  EQU   PRMESTAE+264
PRMUCBP  EQU   PRMESTAE+260
PRMSIOTP EQU   PRMESTAE+256
PRMASID  EQU   PRMESTAE+254
@NM00014 EQU   PRMFUNC
VMVCALL  EQU   PRMFUNC
FREECORE EQU   PRMFUNC
TIOTBLT  EQU   PRMFUNC
DSABCHN  EQU   PRMFUNC
UPDSABCK EQU   PRMFUNC
GENCLNUP EQU   PRMFUNC
@NM00013 EQU   PRMRESC
MLWTO    EQU   PRMRESC
TPQ      EQU   PRMRESC
DSSUNREC EQU   PRMRESC
DSSTAP   EQU   PRMRESC
CHNGQ    EQU   PRMRESC
DDRQ     EQU   PRMRESC
ENQQ4    EQU   PRMRESC
@NM00012 EQU   PRMESTAE
@NM00011 EQU   PROCESSW+1
DYNMSSOK EQU   PROCESSW+1
HSKPDQSW EQU   PROCESSW+1
DISMSGSW EQU   PROCESSW+1
EPALSISW EQU   PROCESSW+1
EPASCTSW EQU   PROCESSW+1
EPAJCTSW EQU   PROCESSW
DCBSPCSW EQU   PROCESSW
NQEXCLSW EQU   PROCESSW
UNALOCSW EQU   ERRPROSW
DEQDSNSW EQU   ERRPROSW
COPYSW   EQU   PROCESSW
DYNMSSTM EQU   PROCESSW
@NM00010 EQU   INPUTSW+3
PCATINIT EQU   INPUTSW+3
UNITDEVT EQU   INPUTSW+3
MOUNTSW  EQU   INPUTSW+2
CATLOGSW EQU   INPUTSW+2
TIOTNQSW EQU   INPUTSW+2
OFFLINSW EQU   INPUTSW+2
WTUNTSW  EQU   INPUTSW+2
NORESSW  EQU   INPUTSW+2
WTDSNSW  EQU   INPUTSW+2
WTVOLSW  EQU   INPUTSW+2
@NM00009 EQU   INPUTSW
JOBRLSYS EQU   INPUTSW
NOMONTSW EQU   INPUTSW
NOCNVTSW EQU   INPUTSW
ONCNVTSW EQU   INPUTSW
@NM00008 EQU   DEPARMS+304
DETCTIOL EQU   DEPARMS+300
DETCTIOP EQU   DEPARMS+296
DETDQLST EQU   DEPARMS+280
DEALASTP EQU   DEPARMS+276
DEASGNP  EQU   DEDMYAS+12
@NM00007 EQU   DEDMYAS
DEWLASTP EQU   DEPARMS+256
DEWRITP  EQU   DEDMYEPA+12
@NM00006 EQU   DEDMYEPA
DEDSNQRC EQU   DENQRETN+4
DEDSNQEN EQU   DENQRETN
DECPYLEN EQU   DEPARMS+228
DECPYLOC EQU   DEPARMS+224
DEJSCB   EQU   DEPARMS+220
DESCT    EQU   DEPARMS+216
DEJCT    EQU   DEPARMS+212
DESIOT   EQU   DEPARMS+208
DETCB    EQU   DEPARMS+204
DECORE   EQU   DEPARMS
ASWAAUTO EQU   ASWA+32
ASWRSV02 EQU   ASWAFLGS+1
ASWRSV01 EQU   ASWADSWS
ASWAID   EQU   ASWA
@NM00004 EQU   JAEXFLAG
SOMEALC  EQU   JAEXFLAG
JAEXEPAP EQU   JAEXPARM+264
JAEXLCTP EQU   JAEXPARM+256
JAEXAUTO EQU   JAEXPARM
@NM00003 EQU   INITSAVE
@NM00002 EQU   BB401SVE
NEXTTCBP EQU   TWOTCBPS
@NM00097 EQU   PSA+3668
PSASTAK  EQU   PSA+3072
@NM00096 EQU   PSA+1048
PSAUSEND EQU   PSA+1048
PSARV062 EQU   PSA+1044
PSACDAL  EQU   PSA+1040
PSAWTCOD EQU   PSA+1036
PSAATCVT EQU   PSA+1032
PSAPCPSW EQU   PSA+1024
PSAPIR2  EQU   PSA+1020
PSARV059 EQU   PSA+1018
PSASVC13 EQU   PSA+1016
PSALSFCC EQU   PSA+1012
PSASFACC EQU   PSA+1008
PSASTOP  EQU   PSA+992
PSASTART EQU   PSA+976
PSARSPSW EQU   PSA+968
PSASRPSW EQU   PSA+960
PSARV045 EQU   PSA+892
PSARV044 EQU   PSA+888
PSARV043 EQU   PSA+884
PSARV042 EQU   PSA+880
PSARV041 EQU   PSA+876
PSARV040 EQU   PSA+872
PSARV025 EQU   PSA+868
PSADSSED EQU   PSA+868
PSADSSPR EQU   PSA+864
PSADSSFW EQU   PSA+860
PSADSS14 EQU   PSA+856
PSADSSPP EQU   PSA+848
PSADSSRP EQU   PSA+840
PSADSS05 EQU   PSADSSF4
PSADSS10 EQU   PSADSSF4
PSADSSVE EQU   PSADSSF4
PSADSSDE EQU   PSADSSF4
PSADSSC0 EQU   PSADSSF4
PSADSSIE EQU   PSADSSF4
PSADSS12 EQU   PSADSSF4
PSADSSRC EQU   PSADSSF4
PSARV057 EQU   PSADSSF3
PSARV056 EQU   PSADSSF3
PSARV055 EQU   PSADSSF3
PSADSSMC EQU   PSADSSF3
PSADSSRW EQU   PSADSSF3
PSADSSNM EQU   PSADSSF3
PSADSSES EQU   PSADSSF3
PSADSSGP EQU   PSADSSF3
PSADSSF2 EQU   PSADSSFL+1
PSADSSPI EQU   PSADSSF1
PSADSSOI EQU   PSADSSF1
PSADSSSP EQU   PSADSSF1
PSADSSTP EQU   PSADSSF1
PSADSSDW EQU   PSADSSF1
PSADSSDD EQU   PSADSSF1
PSADSSDM EQU   PSADSSF1
PSADSSMV EQU   PSADSSF1
PSADSSTS EQU   PSA+816
PSADSSWK EQU   PSA+812
PSADSSR3 EQU   PSA+808
PSADSSR2 EQU   PSA+804
PSADSSRS EQU   PSA+800
PSASTOR  EQU   PSA+796
PSACPUSA EQU   PSA+794
PSAVSTAP EQU   PSA+792
PSAWKVAP EQU   PSA+788
PSAWKRAP EQU   PSA+784
PSAMCHIC EQU   PSA+783
PSARV061 EQU   PSA+782
PSASYMSK EQU   PSA+781
PSAMCHFL EQU   PSA+780
PSACR0   EQU   PSA+776
PSAPSWSV EQU   PSA+768
PSALITA  EQU   PSA+764
PSACLHS  EQU   PSAHLHI
PSALKR15 EQU   PSALKSA+60
PSALKR14 EQU   PSALKSA+56
PSALKR13 EQU   PSALKSA+52
PSALKR12 EQU   PSALKSA+48
PSALKR11 EQU   PSALKSA+44
PSALKR10 EQU   PSALKSA+40
PSALKR9  EQU   PSALKSA+36
PSALKR8  EQU   PSALKSA+32
PSALKR7  EQU   PSALKSA+28
PSALKR6  EQU   PSALKSA+24
PSALKR5  EQU   PSALKSA+20
PSALKR4  EQU   PSALKSA+16
PSALKR3  EQU   PSALKSA+12
PSALKR2  EQU   PSALKSA+8
PSALKR1  EQU   PSALKSA+4
PSALKR0  EQU   PSALKSA
PSARV023 EQU   PSACLHT+52
PSALOCAL EQU   PSACLHT+48
PSACMSL  EQU   PSACLHT+44
PSAOPTL  EQU   PSACLHT+40
PSATPACL EQU   PSACLHT+36
PSATPDNL EQU   PSACLHT+32
PSATPNCL EQU   PSACLHT+28
PSAIOSLL EQU   PSACLHT+24
PSAIOSUL EQU   PSACLHT+20
PSAIOSCL EQU   PSACLHT+16
PSAIOSSL EQU   PSACLHT+12
PSASALCL EQU   PSACLHT+8
PSAASML  EQU   PSACLHT+4
PSADISPL EQU   PSACLHT
PSASRSA  EQU   PSA+636
PSARV050 EQU   PSA+634
PSADSSGO EQU   PSA+633
PSARECUR EQU   PSA+632
PSAHLHIS EQU   PSA+628
PSAIPCSA EQU   PSA+624
@NM00095 EQU   PSA+621
PSAIPCDM EQU   PSA+620
PSAIPCD  EQU   PSA+616
@NM00094 EQU   PSA+613
PSAIPCRM EQU   PSA+612
PSAIPCR  EQU   PSA+608
PSAMCHEX EQU   PSA+600
PSAMPSW  EQU   PSA+592
PSAEXPS2 EQU   PSA+584
PSAEXPS1 EQU   PSA+576
PSAPIREG EQU   PSA+572
PSARSREG EQU   PSA+568
PSAGPREG EQU   PSA+556
PSARV022 EQU   PSASUP4
PSARV021 EQU   PSASUP4
PSARV020 EQU   PSASUP4
PSARV019 EQU   PSASUP4
PSARV018 EQU   PSASUP4
PSARV017 EQU   PSASUP4
PSARV016 EQU   PSASUP4
PSARV015 EQU   PSASUP4
PSARV014 EQU   PSASUP3
PSAULCMS EQU   PSASUP3
PSARV012 EQU   PSASUP3
PSAESTA  EQU   PSASUP3
PSASPR   EQU   PSASUP3
PSAPSREG EQU   PSASUP3
PSAPI2   EQU   PSASUP3
PSAIOSUP EQU   PSASUP3
PSALCR   EQU   PSASUP2
PSARTM   EQU   PSASUP2
PSAACR   EQU   PSASUP2
PSAIPCE2 EQU   PSASUP2
PSAIPCES EQU   PSASUP2
PSAIPCEC EQU   PSASUP2
PSAGTF   EQU   PSASUP2
PSAIPCRI EQU   PSASUP2
PSATYPE6 EQU   PSASUP1
PSATCTL  EQU   PSASUP1
PSADISP  EQU   PSASUP1
PSALOCK  EQU   PSASUP1
PSAPI    EQU   PSASUP1
PSAEXT   EQU   PSASUP1
PSASVC   EQU   PSASUP1
PSAIO    EQU   PSASUP1
PSAANEW  EQU   PSA+544
PSATOLD  EQU   PSA+540
PSATNEW  EQU   PSA+536
PSALCCAR EQU   PSA+532
PSALCCAV EQU   PSA+528
PSAPCCAR EQU   PSA+524
PSAPCCAV EQU   PSA+520
PSACPULA EQU   PSA+518
PSACPUPA EQU   PSA+516
PSAPSA   EQU   PSA+512
FLCHDEND EQU   PSA+512
FLCCRSAV EQU   FLCMCLA+280
FLCGRSAV EQU   FLCMCLA+216
FLCFPSAV EQU   FLCMCLA+184
FLCFLA   EQU   FLCMCLA+88
FLCRGNCD EQU   FLCMCLA+84
FLCFSAA  EQU   FLCFSA+1
@NM00093 EQU   FLCFSA
@NM00092 EQU   FLCMCLA+72
FLCMCIC  EQU   FLCMCLA+64
@NM00091 EQU   FLCMCLA+20
FLCIOAA  EQU   FLCIOA+1
@NM00090 EQU   FLCIOA
@NM00089 EQU   FLCMCLA+15
@NM00088 EQU   FLCMCLA+14
@NM00087 EQU   FLCMCLA+12
FLCLCL   EQU   FLCMCLA+8
FLCIOELA EQU   FLCIOEL+1
@NM00086 EQU   FLCIOEL
FLCCHNID EQU   FLCMCLA
@NM00085 EQU   PSA+160
FLCMTRCD EQU   PSA+157
@NM00084 EQU   PSA+156
FLCPERA  EQU   FLCPER+1
@NM00083 EQU   FLCPER
@NM00082 EQU   PSA+151
FLCPERCD EQU   PSA+150
FLCMCNUM EQU   PSA+149
@NM00081 EQU   PSA+148
FLCTEAA  EQU   FLCTEA+1
@NM00080 EQU   FLCTEA
PSAPIPC  EQU   PSAPICOD
PSAPIMC  EQU   PSAPICOD
PSAPIPER EQU   PSAPICOD
PSARV049 EQU   FLCPICOD
FLCPILCB EQU   FLCPIILC
@NM00079 EQU   FLCPIILC
@NM00078 EQU   PSAEPPSW
FLCSVCN  EQU   PSAESPSW+2
FLCSILCB EQU   FLCSVILC
@NM00077 EQU   FLCSVILC
@NM00076 EQU   PSAESPSW
FLCEICOD EQU   PSAEEPSW+2
PSASPAD  EQU   PSAEEPSW
@NM00075 EQU   PSA+128
FLCINPSW EQU   PSA+120
FLCMNPSW EQU   PSA+112
FLCPNPSW EQU   PSA+104
FLCSNPSW EQU   PSA+96
FLCENPSW EQU   PSA+88
FLCTRACE EQU   PSA+84
FLCTIMER EQU   PSA+80
FLCCVT2  EQU   PSA+76
FLCCAW   EQU   PSA+72
FLCCSW   EQU   PSA+64
FLCIOPSW EQU   PSA+56
FLCMOPSW EQU   PSA+48
FLCPOPSW EQU   PSA+40
FLCSOPSW EQU   PSA+32
FLCEOPSW EQU   PSA+24
@NM00074 EQU   FLCICCW2+4
FLCCVT   EQU   FLCICCW2
FLCICCW1 EQU   FLCROPSW
FLCIPPSW EQU   FLCRNPSW
.@UNREFD ANOP                          END UNREFERENCED COMPONENTS
@RC00221 EQU   @RC00148
@RC00207 EQU   @RC00148
@RC00152 EQU   @RC00148
@RC00163 EQU   @RC00152
@ENDDATA EQU   *
         END   IEFAB4ED,(C'PLS1955',0701,78006)
