         TITLE 'IEFAB4F5 - ALLOCATE CATALOG CONTROL                    *
                        '
IEFAB4F5 CSECT ,                                                01S0001
@MAINENT DS    0H                                               01S0001
         USING *,@15                                            01S0001
         B     @PROLOG                                          01S0001
         DC    AL1(24)                                          01S0001
         DC    C'IEFAB4F5 78089  UZ17788 '                      01S0001
         DROP  @15
@PROLOG  STM   @14,@12,12(@13)                                  01S0001
         BALR  @12,0                                            01S0001
@PSTART  DS    0H                                               01S0001
         USING @PSTART,@12                                      01S0001
         L     @00,@SIZDATD                                     01S0001
         MODESET EXTKEY=SCHED,SAVEKEY=(2)
         GSPACE   R,LV=(0)
         LR    @11,@01                                          01S0001
         USING @DATD,@11                                        01S0001
         ST    @13,@SA00001+4                                   01S0001
         LR    KEYSAVE,@02                                      01S0001
         MODESET KEYADDR=(2)
         LM    @00,@02,20(@13)                                  01S0001
         ST    @11,8(,@13)                                      01S0001
         LR    @13,@11                                          01S0001
         MODESET EXTKEY=ZERO
         MVC   @PC00001(24),0(@01)                              01S0001
         MODESET EXTKEY=SCHED
JSCBDISP EQU 188
JSCBAOS1 EQU  72
JSCBAOS2 EQU 192
*   RTCDPTR=ADDR(RETCOD);           /* ADDR OF LOCAL RTN INFO        */
         LA    @10,RETCOD                                       01S0056
         ST    @10,RTCDPTR                                      01S0056
*   RETCOD=0;                       /* INIT LOCAL RETURN INFO        */
         SLR   @10,@10                                          01S0057
         STCM  @10,15,RETCOD                                    01S0057
*                                                               02S0058
*/********************************************************************/
*/*                                                                  */
*/* SEGMENT NAME -  ACESTAE                                          */
*/*                                                                  */
*/* DESCRIPTIVE NAME - ALLOCATE CATALOG RTN ESTAE SETUP              */
*/*                                                                  */
*/* FUNCTION - OBTAIN AND INITIALIZE THE ESTAE EXIT PARMLIST.        */
*/*            SET UP APPROPRIATE ESTAE ENVIRONMENT          @Z40FPPG*/
*/*                                                                  */
*/*    OPERATION - 1. ISSUE GETMAIN FOR PARMLIST                     */
*/*                2. INITIALIZE FIELDS WITHIN PARMLIST              */
*/*                3. SET UP ENVIRONMENT                     @Z40FPPG*/
*/*                4. SET FAILING RETURN AND REASON CODES.           */
*/*                                                                  */
*/* ENTRY - INLINE SEGMENT                                           */
*/*                                                                  */
*/*    INPUT - SEGMENT USES INPUT TO IEFAB4F5 TO INITIALIZE PARMLIST */
*/*                                                                  */
*/* EXIT - N/A                                                       */
*/*                                                                  */
*/*    CONDITION - IF SUCCESSFUL ,RSCD = 0                           */
*/*                IF UNSUCCESSFUL,  RSCD = 16                       */
*/*                                                                  */
*/*    OUTPUT DATA - INITIALIZED ESTAE PARMLIST                      */
*/*                                                                  */
*/*    RETURN CODE - 0 SUCCESS, 8 FAILURE                            */
*/*                                                                  */
*/********************************************************************/
*                                                               02S0058
*                                                               02S0058
*/********************************************************************/
*                                                               02S0058
*   SBPOOL=SUBPOOOL;                /* SET SUBPOOL NUMBER            */
         MVI   SBPOOL,X'E6'                                     02S0058
*   LENTH=LENGTH(EPARMLST);         /* LENGTH OF ESTAE PARMLIST      */
         MVC   LENTH(3),@CF01110+1                              02S0059
*   REG0=SPLEN;                     /* SET SUBPOOL+LENGTH IN REG 0   */
         L     REG0,SPLEN                                       02S0060
*   GEN(GETMAIN R,LV=(0));                                      02S0061
         GETMAIN R,LV=(0)
*   EPRMLSTP=REG1;                                              02S0062
         LR    EPRMLSTP,REG1                                    02S0062
*   RFY                                                         02S0063
*    (RTCDREG) RSTD;                /*                       @Z40FPPG*/
*   EECNTRLS=0;                     /* CLEAR CONTROLS                */
         SLR   @14,@14                                          02S0064
         ST    @14,EECNTRLS(,EPRMLSTP)                          02S0064
*   IF ACNOENQ=ON THEN              /* ENQ ON TIOT                   */
         L     @14,@PC00001                                     02S0065
         TM    ACNOENQ(@14),B'00000010'                         02S0065
         BNO   @RF00065                                         02S0065
*     EEDNENQT=ON;                  /* ONLY IF CALLER DIDN'T         */
         OI    EEDNENQT(EPRMLSTP),B'00000001'                   02S0066
*   IF ACNUJSCB=ON THEN             /* REINSTATE JSCB PTR(S) IF      */
@RF00065 L     @14,@PC00001                                     02S0067
         TM    ACNUJSCB(@14),B'00000001'                        02S0067
         BNO   @RF00067                                         02S0067
*     EERAJSCP=ON;                  /* SWITCHING WAS ALLOWED         */
         OI    EERAJSCP(EPRMLSTP),B'00000100'                   02S0068
*   IF ACRECOVR=ON THEN             /* CATALOG UNALLOCATION          */
@RF00067 L     @14,@PC00001                                     02S0069
         TM    ACRECOVR(@14),B'00100000'                        02S0069
         BNO   @RF00069                                         02S0069
*     DO;                           /* ALLOWED                       */
*       EEUALCAT=ON;                /* UNALLOCATE ALL PVT.CATALOGS   */
*       EECLACAT=ON;                /* CLOSE ALL PVT.CATALOGS        */
*       EEFAPCCB=ON;                /* FREE ALL PVT.CATALOG PCCBS    */
         OI    EEUALCAT(EPRMLSTP),B'11100000'                   02S0073
*     END;                                                      02S0074
*   ELSE                                                        02S0075
*     EEDYNAM=ON;                   /* DO NOT ALLOW CATALOG     02S0075
*                                      UNALLOCATION - DYN.ALLOC.     */
         B     @RC00069                                         02S0075
@RF00069 OI    EEDYNAM(EPRMLSTP),B'00000010'                    02S0075
*   ECJSCBP=JSCBPTR;                /* CURRENT JSCBPTR               */
@RC00069 L     @14,@PC00001+8                                   02S0076
         L     @14,JSCBPTR(,@14)                                02S0076
         ST    @14,ECJSCBP(,EPRMLSTP)                           02S0076
*   EAJSCBP=JSCBPTR->JSCBACT;       /* ACTIVE JSCB PTR               */
         L     @14,JSCBACT(,@14)                                02S0077
         ST    @14,EAJSCBP(,EPRMLSTP)                           02S0077
*                                                               03S0078
*/********************************************************************/
*/*                                                          @Z40FPPG*/
*/* SEGMENT NAME - ESTAECOD                                  @Z40FPPG*/
*/*                                                          @Z40FPPG*/
*/* DESCRIPTIVE NAME - ESTAE CODE                            @Z40FPPG*/
*/*                                                          @Z40FPPG*/
*/* FUNCTION - SET UP THE APPROPRIATE ESTAE ENVIRONMENT      @Z40FPPG*/
*/*                                                          @Z40FPPG*/
*/* OPERATION -                                              @Z40FPPG*/
*/*          . AN ALLOCATION STAE WORK AREA (ASWA) IS FILLED @Z40FPPG*/
*/*            IN. THIS ALLOWS THE ALLOCATION COMMON ESTAE   @Z40FPPG*/
*/*            EXIT (IEFAB4ED) TO ROUTE CONTROL TO THE       @ZA18154*/
*/*            APPROPRIATE EXIT ROUTINES FOR SPECIFIC        @Z40FPPG*/
*/*            RECOVERY PROCESSING.                          @Z40FPPG*/
*/*          . AN ESTAE IS ALWAYS ISSUED AND AN ASWA ALWAYS  @ZA18154*/
*/*            CREATED WHEN THIS ROUTINE IS INVOKED. THE ASWA@ZA18154*/
*/*            HOWEVER IS NEVER CHAINED TO AN EXISTING ASWA  @ZA18154*/
*/*            NOR TO JSCBASWA. THIS IS DONE BECAUSE THERE IS@ZA18154*/
*/*            NO WAY TO SERIALIZE ON THIS CHAIN. THUS IF AN @ZA18154*/
*/*            ERROR OCCURS, THE ESTAE ISSUED BY THIS ROUTINE@ZA18154*/
*/*            WILL RECEIVE CONTROL THROUGH PERCOLATION OR AS@ZA18154*/
*/*            A RESULT OF BEING THE LAST ESTAE ISSUED FOR   @ZA18154*/
*/*            THIS TASK. THE ASWA IS BUILT SO THAT IEFAB4ED @ZA18154*/
*/*            CAN ROUTE CONTROL TO THE ESTAE EXIT AND       @ZA18154*/
*/*            PERFORM ITS OTHER NORMAL FUNCTIONS. SINCE NO  @ZA18154*/
*/*            ASWA WILL BE CHAINED TO THE ASWA CREATED BY   @ZA18154*/
*/*            THIS ROUTINE ONLY IEFAB4EA WILL RECEIVE       @ZA18154*/
*/*            CONTROL.  OTHER ASWAS WILL BE PROCESSED WHEN  @ZA18154*/
*/*            THE ESTAE UNDER WHICH THEY ARE PROTECTED IS   @ZA18154*/
*/*            PERCOLATED TO.                                @ZA18154*/
*/*                                                          @Z40FPPG*/
*/* ENTRY - INLINE SUBROUTINE ENTERED AT THE TOP             @Z40FPPG*/
*/*                                                          @Z40FPPG*/
*/*   PURPOSE - SEE FUNCTION                                 @Z40FPPG*/
*/*   INPUT -                                                @Z40FPPG*/
*/*        .TCBSTABB - PTR TO CURRENT STAE CONTROL BLOCK     @Z40FPPG*/
*/*        .EPRMLSTP - PTR TO PARMS FOR IEFAB4EA             @Z40FPPG*/
*/*                                                          @Z40FPPG*/
*/* EXIT - INLINE SUBROUTINE THAT EXISTS AT THE BOTTOM       @Z40FPPG*/
*/*                                                          @Z40FPPG*/
*/*   CONDITION - ESTAE SETUP COMPLETED                      @Z40FPPG*/
*/*                                                          @Z40FPPG*/
*/*   OUTPUT -                                               @Z40FPPG*/
*/*           .ASWA - FILLED IN AND PLACED ON THE CHAIN      @Z40FPPG*/
*/*                                                          @Z40FPPG*/
*/*   RETURN CODES - RTCDREG HAS ESTAE RETURN CODE           @Z40FPPG*/
*/*                  IF ONE WAS ISSUED. (ZERO OTHERWISE)     @Z40FPPG*/
*/*                                                          @Z40FPPG*/
*/********************************************************************/
*                                                               03S0078
*   RTCDREG=ZERO;                   /* INIT RETURN CODE      @Z40FPPG*/
         SLR   RTCDREG,RTCDREG                                  03S0078
*   ASWAPTR=ADDR(ASWACORE);         /* ADDRESS ASWA CORE     @Z40FPPG*/
         LA    ASWAPTR,ASWACORE                                 03S0079
*   ASWA=ASWA&&ASWA;                /* ZERO OUT ASWA         @Z40FPPG*/
         XC    ASWA(40,ASWAPTR),ASWA(ASWAPTR)                   03S0080
*   ASWAID=CHARASWA;                /* FILL IN BLOCK ID      @Z40FPPG*/
         MVC   ASWAID(4,ASWAPTR),@CC00150                       03S0081
*   ASWACSCT=EXITCSCT;              /* CSECT NAME OF EXIT    @Z40FPPG*/
         MVC   ASWACSCT(8,ASWAPTR),@CC00148                     03S0082
*   ASWARTNP=ADDR(IEFAB4EA);        /* ADDRESS OF EXIT RTN   @Z40FPPG*/
         L     @14,@CV00168                                     03S0083
         STCM  @14,15,ASWARTNP(ASWAPTR)                         03S0083
*   ASWAPRMS=EPRMLSTP;              /* PARMS FOR THIS EXIT   @Z40FPPG*/
         STCM  EPRMLSTP,15,ASWAPRMS(ASWAPTR)                    03S0084
*   TCBPTR=CURNTCBP;                /* ADDRESS CURRENT TCB   @Z40FPPG*/
         L     @14,LOC16PTR                                     03S0085
         L     @14,TCBLISTP(,@14)                               03S0085
         L     TCBPTR,CURNTCBP(,@14)                            03S0085
*   ASWAAUTO=ADDR(AB4EDCOR);        /* 1ST ASWA GIVES W/A    @Z40FPPG*/
         LA    @14,AB4EDCOR                                     03S0086
         STCM  @14,15,ASWAAUTO(ASWAPTR)                         03S0086
*   ASWANOCH=ON;                    /* INDICATE ASWA NOT CHAINED TO
*                                      JSCBASWA              @ZA18154*/
         OI    ASWANOCH(ASWAPTR),B'00001000'                    03S0087
*   RFY                                                         03S0088
*    (REG2,                                                     03S0088
*     REG3) RSTD;                   /* RESTRICT WORK REGS    @Z40FPPG*/
*   REG2=ADDR(IEFAB4ED);            /* COMMON ESTAE EXIT     @Z40FPPG*/
         L     REG2,@CV00169                                    03S0089
*   REG3=ASWAPTR;                   /* ASWA IS EXIT PARMS    @Z40FPPG*/
         LR    REG3,ASWAPTR                                     03S0090
*   ESTAECOR(1:ESTAELEN)=ESTAELST(1:ESTAELEN);/* MOVE TO AUTO CORE
*                                                            @Z40FPPG*/
         L     @14,ESTAELEN                                     03S0091
         BCTR  @14,0                                            03S0091
         EX    @14,@SM01123                                     03S0091
*   GEN REFS(ESTAECOR) SETS(RTCDREG,TCBSTABB);                  03S0092
      ESTAE (2),PARAM=(3),RECORD=YES,TERM=YES,MF=(E,ESTAECOR)
*   RFY                                                         03S0093
*    (REG2,                                                     03S0093
*     REG3) UNRSTD;                                             03S0093
*   IF RTCDREG=ZERO THEN            /* IF ESTAE SUCCESSFUL   @Z40FPPG*/
         LTR   RTCDREG,RTCDREG                                  03S0094
         BNZ   @RF00094                                         03S0094
*     ASWASCBP=TCBSTABB;            /* CURRENT SCB @         @Z40FPPG*/
         L     @14,TCBSTABB-1(,TCBPTR)                          03S0095
         LA    @14,0(,@14)                                      03S0095
         STCM  @14,15,ASWASCBP(ASWAPTR)                         03S0095
*   IF RTCDREG^=0 THEN              /* ESTAE ENVIRONMENT NOT SET     */
@RF00094 LTR   RTCDREG,RTCDREG                                  02S0096
         BZ    @RF00096                                         02S0096
*     DO;                           /* - FAILING SITUATION           */
*       RFY                                                     02S0098
*        (REG0,                                                 02S0098
*         REG1) RSTD;                                           02S0098
*       REG0=SPLEN;                 /* SET SUBPOOL+LENGTH IN REG 0   */
         L     REG0,SPLEN                                       02S0099
*       REG1=EPRMLSTP;              /* PTR TO PARMLIST               */
         LR    REG1,EPRMLSTP                                    02S0100
*       GEN(FREEMAIN R,LV=(0),A=(1));                           02S0101
         FREEMAIN R,LV=(0),A=(1)
*       RFY                                                     02S0102
*        (REG0,                                                 02S0102
*         REG1) UNRSTD;                                         02S0102
*       RTCD=STPERROR;              /* 8 - ESTAE ENVIRONMENT-        */
         MVC   RTCD(2),@CH00075                                 02S0103
*       RSCD=ESTAEERR;              /* 16 - ESTABLISHMENT ERROR      */
         MVC   RSCD(2),@CH00059                                 02S0104
*     END;                                                      02S0105
*   RFY                                                         02S0106
*    (RTCDREG) UNRSTD;              /*                       @Z40FPPG*/
@RF00096 DS    0H                                               02S0107
*   IF RTCD=0 THEN                  /* ESTAE ENVIRONMENT SET         */
         SLR   @10,@10                                          01S0107
         CH    @10,RTCD                                         01S0107
         BNE   @RF00107                                         01S0107
*     DO;                                                       01S0108
*       SAVJSCBP=JSCBACT;           /* SAVE ACTIVE JSCB PTR          */
         L     @07,@PC00001+8                                   01S0109
         L     @07,JSCBPTR(,@07)                                01S0109
         L     @05,JSCBACT(,@07)                                01S0109
         ST    @05,SAVJSCBP                                     01S0109
*       IF ACNUJSCB=ON THEN         /* ALLOCATE CTG TO ACTIVE TASK   */
         L     @05,@PC00001                                     01S0110
         TM    ACNUJSCB(@05),B'00000001'                        01S0110
         BNO   @RF00110                                         01S0110
*         DO;                                                   01S0111
*           DO;                     /* MODESET KEYADDR(0)            */
*             SPKA(0);              /* SET PSW KEY                   */
         SPKA  0(@10)                                           01S0113
*           END;                    /* MODESET KEYADDR(0) KEY 0 TO
*                                      ALTER JSCB                    */
*           JSCBACT=JSCBPTR;        /* NEW ACTIVE JSCB               */
         ST    @07,JSCBACT(,@07)                                01S0115
*           DO;                     /* MODESET EXTKEY(SCHED)         */
*             SPKA(16);             /* SET PSW KEY                   */
         LA    @10,16                                           01S0117
         SPKA  0(@10)                                           01S0117
*           END;                    /* MODESET EXTKEY(SCHED) BACK TO
*                                      KEY 1                         */
*         END;                                                  01S0119
*       DDNAMPTR=0;                 /* DDNAME NOT CREATED YET        */
@RF00110 SLR   @10,@10                                          01S0120
         ST    @10,DDNAMPTR                                     01S0120
*       ACBPTR=0;                   /* NO ACB EXISTS YET             */
         ST    @10,ACBPTR                                       01S0121
*       VSERPTR=0;                  /* NO VOLUME SERIAL OF CATALOG   */
         ST    @10,VSERPTR                                      01S0122
*       PCCNTRLS=0;                 /* CONTROLS FOR PCCB ROUTINE     */
         STH   @10,PCCNTRLS                                     01S0123
*       CJUSTALC=OFF;               /* RESET ERROR-CORRECT CONTROLS  */
         NI    CJUSTALC,B'01111111'                             01S0124
*       CATSUNAL=OFF;               /* RESET 'CATALOGS UNALLOCATED'  */
         NI    CATSUNAL,B'01111111'                             01S0125
*       CTGOPEND=OFF;                                           01S0126
         NI    CTGOPEND,B'01111111'                             01S0126
*       ALOCOPEN=ON;                /* ALOC,OPEN CATLG       @ZA00870*/
         OI    ALOCOPEN,B'10000000'                             01S0127
*       CATALCTD=OFF;               /* RESET 'ANY-CATLG-ALLOCATED'   */
         NI    CATALCTD,B'01111111'                             01S0128
*       NQCORE(1:NQLENGTH)=PCNQLIST(1:NQLENGTH);/* ENQ LST TO DSECT
*                                                            @ZA00870*/
         L     @10,NQLENGTH                                     01S0129
         BCTR  @10,0                                            01S0129
         EX    @10,@SM01127                                     01S0129
*       GEN REFS(NQCORE);                                       01S0130
*                                     /*                    @ZA00870*/
      ENQ    MF=(E,NQCORE)            /*                    @ZA00870*/
*       PCCBPTR=SAVJSCBP->JSCBPCC;  /* FIRST PCCB ADDRESS ACCURATE
*                                      ONLY AFTER ENQUEUE    @ZA00870*/
         L     @10,SAVJSCBP                                     01S0131
         L     PCCBPTR,JSCBPCC(,@10)                            01S0131
*       DO WHILE(PCCBPTR^=0&(CATALCTD=OFF|ALOCOPEN=ON));/*   @ZA00870*/
         B     @DE00132                                         01S0132
@DL00132 DS    0H                                               01S0133
*         IF PCCDDNAM(1:4)^=0 THEN  /* A CATLG IS ALLOC'D    @ZA00870*/
         ICM   @10,15,PCCDDNAM(PCCBPTR)                         01S0133
         BZ    @RF00133                                         01S0133
*           CATALCTD=ON;                                        01S0134
         OI    CATALCTD,B'10000000'                             01S0134
*         IF CTGDSN=PCCDSNAM THEN   /* PCCB FOR THIS CATLG?  @ZA00870*/
@RF00133 L     @10,@PC00001+12                                  01S0135
         L     @10,CTGDSNP(,@10)                                01S0135
         CLC   CTGDSN(44,@10),PCCDSNAM(PCCBPTR)                 01S0135
         BNE   @RF00135                                         01S0135
*           DO;                     /* YES.                  @ZA00870*/
*             IF PCCDDNAM(1:4)^=0 THEN/* IS THE CATALOG ALLOCATED?
*                                                            @ZA00870*/
         SLR   @10,@10                                          01S0137
         ICM   @07,15,PCCDDNAM(PCCBPTR)                         01S0137
         CLR   @10,@07                                          01S0137
         BE    @RF00137                                         01S0137
*               DO;                 /* YES.                  @ZA00870*/
*                 ALOCOPEN=OFF;     /* DON'T ALLOC OR OPEN@ZA00870   */
         NI    ALOCOPEN,B'01111111'                             01S0139
*                 ACBPTR=0;         /* GIVE PCCB ROUTINE     @ZA00870*/
         ST    @10,ACBPTR                                       01S0140
*                 DDNAMPTR=0;       /* 0 PTRS SO IT CAN      @ZA00870*/
         ST    @10,DDNAMPTR                                     01S0141
*               END;                /* HANDLE ALIAS PCCB     @ZA00870*/
*           END;                    /*                       @ZA00870*/
@RF00137 DS    0H                                               01S0144
*         PCCBPTR=PCCNEXTP;         /* GET NEXT PCCB, IF ANY.   01S0144
*                                                            @ZA00870*/
@RF00135 L     PCCBPTR,PCCNEXTP(,PCCBPTR)                       01S0144
*       END;                        /* PCCB SEARCH LOOP      @ZA00870*/
@DE00132 LTR   PCCBPTR,PCCBPTR                                  01S0145
         BZ    @DC00132                                         01S0145
         TM    CATALCTD,B'10000000'                             01S0145
         BZ    @DL00132                                         01S0145
         TM    ALOCOPEN,B'10000000'                             01S0145
         BO    @DL00132                                         01S0145
@DC00132 DS    0H                                               01S0146
*       GEN REFS(NQCORE);                                       01S0146
*                                     /*                    @ZA00870*/
      DEQ    MF=(E,NQCORE)            /*                    @ZA00870*/
*       IF ALOCOPEN=ON THEN         /* CTLG ALREADY ALLOC & OPEN?
*                                                            @ZA00870*/
         TM    ALOCOPEN,B'10000000'                             01S0147
         BNO   @RF00147                                         01S0147
*         DO;                       /* NO                    @ZA00870*/
*           IF ACALCTLG=ON THEN     /* SET UP TO DYNAMICALLY         */
         L     @10,@PC00001                                     01S0149
         TM    ACALCTLG(@10),B'00100000'                        01S0149
         BNO   @RF00149                                         01S0149
*             DO;                   /* ALLOCATE THE CATALOG          */
*                                                               02S0151
*/********************************************************************/
*/*                                                                  */
*/* SEGMENT NAME - ALCATLG                                           */
*/*                                                                  */
*/* DESCRIPTIVE NAME - ALLOCATE CATALOG INTERFACE                    */
*/*                                                                  */
*/* FUNCTION - PREPARES THE PARAMETER AREA FOR DYNAMIC ALLOCATION    */
*/*            OF A CATALOG AND REQUESTS ALLOCATION (SVC 99)         */
*/*                                                                  */
*/*   OPERATION -                                                    */
*/*            THE WAIT-FOR-VOLUMES/DEVICES BITS IN THE INPUT        */
*/*            PARAMETERS WILL BE MAPPED INTO THE DYNAMIC ALLOCATION */
*/*            REQUEST BLOCK (PARAMETER AREA) ONLY IF NO OTHER       */
*/*            CATALOGS ARE ALLOCATED TO THIS STEP ( PCCBS, IF ANY,  */
*/*            HAVE NO CATALOG DD NAME).                             */
*/*            THE POINTERS,COMMANDS,TEXT UNITS ETC. ARE INITIALIZED */
*/*            IN THE AFOREMENTIONED REQUEST BLOCK.                  */
*/*            THE REQUEST BLOCK IS ADDRESSED BY REGISTER 1 AND      */
*/*            SVC 99 IS ISSUED.                                     */
*/*            RECOVERABLE RETURN CODES (VOLUME REQUESTED OR DEVICES */
*/*            ARE UNAVAILABLE), IF AUTHORIZED BY THE CALLER, WILL   */
*/*            CAUSE SEGMENT 'RECOVERY' TO ATTEMPT UNALLOCATION OF   */
*/*            ALL CATALOGS TO FREE SYSTEM RESOURCES AND, IF         */
*/*            AUTHORIZED BY THE CALLER (STEP INITIATION), ALLOW     */
*/*            WAITING FOR VOLUMES OR DEVICES AND REISSUE SVC99.     */
*/*            OTHER ERRORS WILL TERMINATE PROCESSING WITH           */
*/*            RETURN/REASON CODES PASSED BACK TO THE CALLER.        */
*/*            A POINTER IS INITIALIZED TO THE DDNAME RETURNED BY    */
*/*            DYNAMIC ALLOCATION AS RESULT OF SUCCESSFUL            */
*/*            ALLOCATION OF THE PRIVATE CATALOG.                    */
*/*                                                                  */
*/* ENTRY - IF CATALOG IS TO BE ALLOCATED                            */
*/*                                                                  */
*/*   PURPOSE - SEE FUNCTION                                         */
*/*                                                                  */
*/*   INPUT DATA - SAME AS INPUT TO IEFAB4F5                         */
*/*                                                                  */
*/* EXIT - IN LINE                                                   */
*/*                                                                  */
*/*   CONDITION - ALL                                                */
*/*                                                                  */
*/*   OUTPUT DATA - DDNAME POINTER OR                                */
*/*               - REASON CODES MAPPED FROM REG15 IN CASE OF ERROR  */
*/*               - OR REASON CODE OF 1 IF CATALOG MOUNT REQUIRED    */
*/*               - AND NOT AUTHORIZED                               */
*/*   RETURN CODE - 0 SUCCESS                                        */
*/*               - 4 FAILURE                                        */
*/*               - 8 CATALOG MOUNT NEEDED AND NOT AUTHORIZED        */
*/********************************************************************/
*                                                               02S0151
*               S99RB=S99RB&&S99RB; /* CLEAR PARAMETER AREA          */
         XC    S99RB(20),S99RB                                  02S0151
*               S99RBPTR=ADDR(S99RB);/* REQUEST BLOCK POINTER        */
         LA    @07,S99RB                                        02S0152
         ST    @07,S99RBPTR                                     02S0152
*               S99RBPND=ON;        /* ONE REQUEST BLOCK             */
         OI    S99RBPND,B'10000000'                             02S0153
*               S99RBLN=LENGTH(S99RB);/* REQUEST BLOCK LENGTH        */
         MVI   S99RBLN,X'14'                                    02S0154
*               S99VERB=S99VRBAL;   /* VERB - ALLOCATE               */
         MVI   S99VERB,X'01'                                    02S0155
*               S99NOCNV=ON;        /* NEW ALLOCATION ONLY           */
         OI    S99NOCNV,B'01000000'                             02S0156
*               S99NORES=ON;        /* DO NO DSNAME ENQUEUE          */
         OI    S99NORES,B'00100000'                             02S0157
*               S99TXTPP=ADDR(UNITPTR(1));/* PTR TO TEXT UNIT   02S0158
*                                      POINTERS                      */
         LA    @07,UNITPTR                                      02S0158
         ST    @07,S99TXTPP                                     02S0158
*               UNITPTR(1)=ADDR(UNIT1);/* SET THE TEXT UNIT POINTERS */
         LA    @07,UNIT1                                        02S0159
         ST    @07,UNITPTR                                      02S0159
*               UNITPTR(2)=ADDR(UNIT2);/* TO POINT TO MY DATA        */
         LA    @07,UNIT2                                        02S0160
         ST    @07,UNITPTR+4                                    02S0160
*               UNITPTR(3)=ADDR(UNIT3);                         02S0161
         LA    @07,UNIT3                                        02S0161
         ST    @07,UNITPTR+8                                    02S0161
*               UNITPTR(4)=ADDR(UNIT4);                         02S0162
         LA    @07,UNIT4                                        02S0162
         ST    @07,UNITPTR+12                                   02S0162
*               LASTPTR(4)=ON;      /* LAST TEXT UNIT PTR IND.       */
         OI    LASTPTR+12,B'10000000'                           02S0163
*               UNITPTR(1)->S99TUKEY=DALDSNAM;/* KEY OF DSNAME       */
         L     @07,UNITPTR                                      02S0164
         MVC   S99TUKEY(2,@07),@CB00317                         02S0164
*               UNITPTR(1)->S99TUNUM=1;/* ONE PARAMETER IN TEXT UNIT */
         LA    @05,1                                            02S0165
         STCM  @05,3,S99TUNUM(@07)                              02S0165
*               UNITPTR(1)->S99TULNG=LENGTH(CTGDSN);/* LENGTH OF PARM
*                                      - 44                          */
         MVC   S99TULNG(2,@07),@CH00108                         02S0166
*               DSNPARM=CTGDSN;     /* DSNAME TO ALLOCATE            */
         L     @07,@PC00001+12                                  02S0167
         L     @07,CTGDSNP(,@07)                                02S0167
         MVC   DSNPARM(44),CTGDSN(@07)                          02S0167
*               UNITPTR(2)->S99TUKEY=DALSTATS;/* KEY OF STATUS -
*                                      SHARE                         */
         L     @07,UNITPTR+4                                    02S0168
         MVC   S99TUKEY(2,@07),@CB00321                         02S0168
*               UNITPTR(2)->S99TUNUM=1;/* ONE PARAMETER              */
         STCM  @05,3,S99TUNUM(@07)                              02S0169
*               UNITPTR(2)->S99TULNG=1;/* STATUS IS ONE BYTE         */
         STCM  @05,3,S99TULNG(@07)                              02S0170
*               UNIT2(7)=SHRDISP;   /* DISPOSITION - SHARE           */
         LA    @07,8                                            02S0171
         STC   @07,UNIT2+6                                      02S0171
*               UNITPTR(3)->S99TUKEY=DALRTDDN;/* KEY OF DD NAME 02S0172
*                                      RETURN                        */
         L     @03,UNITPTR+8                                    02S0172
         MVC   S99TUKEY(2,@03),@CB00483                         02S0172
*               UNITPTR(3)->S99TUNUM=1;/* ONE PARAMETER              */
         STCM  @05,3,S99TUNUM(@03)                              02S0173
*               UNITPTR(3)->S99TULNG=LENGTH(DDNAME);/* DDNAME RETURN
*                                      AREA                          */
         STCM  @07,3,S99TULNG(@03)                              02S0174
*               UNITPTR(4)->S99TUKEY=DALRTVOL;/* KEY TO REQUEST 02S0175
*                                      VOLUME SERIAL                 */
         L     @07,UNITPTR+12                                   02S0175
         MVC   S99TUKEY(2,@07),@CB00499                         02S0175
*               UNITPTR(4)->S99TUNUM=1;/* ONE PARAMETER              */
         STCM  @05,3,S99TUNUM(@07)                              02S0176
*               UNITPTR(4)->S99TULNG=LENGTH(CATVSER);/* VOL-SER 02S0177
*                                      RETURN AREA                   */
         MVC   S99TULNG(2,@07),@CH00106                         02S0177
*               PCCBPTR=SAVJSCBP->JSCBPCC;/* FIRST PCCB IF ANY       */
         L     @07,SAVJSCBP                                     02S0178
         L     PCCBPTR,JSCBPCC(,@07)                            02S0178
*               IF ACNODD=ON THEN   /* NO DD SHOULD BE CREATED BY    */
         TM    ACNODD(@10),B'10000000'                          02S0179
         BNO   @RF00179                                         02S0179
*                 S99CATLG=ON;      /* DYNAMIC ALLOC FOR THIS CATLG  */
         OI    S99CATLG,B'00000010'                             02S0180
*               ELSE                /* ALLOCATION FOR BATCH  @Y30QPPB*/
*                 S99PCINT=ON;      /* TELL SVC 99           @Y30QPPB*/
         B     @RC00179                                         02S0181
@RF00179 OI    S99PCINT,B'01000000'                             02S0181
*               IF ACNOENQ=ON THEN  /* CAUSE DYNAMIC ALLOCATION NOT  */
@RC00179 L     @10,@PC00001                                     02S0182
         TM    ACNOENQ(@10),B'00000010'                         02S0182
         BNO   @RF00182                                         02S0182
*                 S99TIONQ=ON;      /* TO ENQUEUE ON THE TIOT        */
         OI    S99TIONQ,B'00000100'                             02S0183
*               IF ACOFLINE=ON THEN /* DYNAMIC ALLOCATION MAY        */
@RF00182 L     @10,@PC00001                                     02S0184
         TM    ACOFLINE(@10),B'00000100'                        02S0184
         BNO   @RF00184                                         02S0184
*                 S99OFFLN=ON;      /* CONSIDER OFFLINE DEVICES      */
         OI    S99OFFLN,B'00001000'                             02S0185
*               IF ACOK2MNT=ON THEN /* CATALOG MOUNT AUTHORIZATION   */
@RF00184 L     @10,@PC00001                                     02S0186
         TM    ACOK2MNT(@10),B'10000000'                        02S0186
         BNO   @RF00186                                         02S0186
*                 S99MOUNT=ON;                                  02S0187
         OI    S99MOUNT,B'00000001'                             02S0187
*               ELSE                /* MOUNTING NOT ALLOWED@ZA16793  */
*                 S99NOMNT=ON;      /* SET NO-MOUNT BIT ON   @ZA16793*/
         B     @RC00186                                         02S0188
@RF00186 OI    S99NOMNT,B'00100000'                             02S0188
*               IF ACVLWAIT=ON THEN /* WAIT OK FOR VOLUME            */
@RC00186 L     @10,@PC00001                                     02S0189
         TM    ACVLWAIT(@10),B'00001000'                        02S0189
         BNO   @RF00189                                         02S0189
*                 S99WTVOL=ON;                                  02S0190
         OI    S99WTVOL,B'10000000'                             02S0190
*               IF ACDVWAIT=ON THEN /* WAIT OK FOR UNITS             */
@RF00189 L     @10,@PC00001                                     02S0191
         TM    ACDVWAIT(@10),B'01000000'                        02S0191
         BNO   @RF00191                                         02S0191
*                 S99WTUNT=ON;                                  02S0192
         OI    S99WTUNT,B'00010000'                             02S0192
*               IF(ACVLWAIT=ON|     /* WAIT AUTHORIZED ONLY          */
*                   ACDVWAIT=ON)&   /* IF NO CATALOGS ALLOCATED.     */
*                   CATALCTD=ON THEN/* CATALOG IS ALLOCATED, @ZA00870*/
@RF00191 L     @10,@PC00001                                     02S0193
         TM    ACVLWAIT(@10),B'01001000'                        02S0193
         BZ    @RF00193                                         02S0193
         TM    CATALCTD,B'10000000'                             02S0193
         BNO   @RF00193                                         02S0193
*                 DO;               /* INSURE THERE ARE NO           */
*                   S99WTVOL=OFF;   /* WAIT AUTHORIZATIONS           */
*                   S99WTUNT=OFF;                               02S0196
         NI    S99WTVOL,B'01101111'                             02S0196
*                 END;                                          02S0197
*               PARAMREG=ADDR(S99RBPTR);/* DYNAMIC ALLOCATION PARM
*                                      AREA                          */
@RF00193 LA    PARAMREG,S99RBPTR                                02S0198
*/* MACDATE Y-2 73082                                                */
*                                                               02S0199
*               SVC(99);            /* DYNAMIC ALLOCATION            */
         SVC   99                                               02S0199
*               RTCD=RTCDREG;       /* SAVE REG15                    */
         STH   RTCDREG,RTCD                                     02S0200
*               IF RTCD=RECOVER&    /* RECOVERABLE ERROR (UNITS      */
*                   (S99ERROR=NOUNIT|S99ERROR=NOVOL)&/* OR VOLUMES)  */
*                   ACRECOVR=ON THEN/* AND 'RECOVERY AUTHORIZED'     */
         LH    @10,RTCD                                         02S0201
         C     @10,@CF00063                                     02S0201
         BNE   @RF00201                                         02S0201
         CLC   S99ERROR(2),@CB00134                             02S0201
         BE    @GL00004                                         02S0201
         CLC   S99ERROR(2),@CB00138                             02S0201
         BNE   @RF00201                                         02S0201
@GL00004 L     @10,@PC00001                                     02S0201
         TM    ACRECOVR(@10),B'00100000'                        02S0201
         BNO   @RF00201                                         02S0201
*                 DO;                                           02S0202
*                                                               03S0203
*/********************************************************************/
*/*                                                                  */
*/* SEGMENT NAME - RECOVERY                                          */
*/*                                                                  */
*/* DESCRIPTIVE NAME - RECOVERABLE RETURN CODE PROCESSING            */
*/*                                                                  */
*/* FUNCTION - UNALLOCATE ALLOCATED CATALOGS TO MAKE SYSTEM          */
*/*            RESOURCES AVAILABLE TO DYNAMIC ALLOCATION TO MOUNT    */
*/*            THE VOLUME REQUESTED AND/OR TO BE ABLE TO WAIT FOR    */
*/*            ACCESS TO THE REQUIRED VOLUME.                        */
*/*                                                                  */
*/* OPERATION- THE PCCB CHAIN IS SCANNED AND IF ANY CATALOGS ARE     */
*/*            ALLOCATED: - ALL CATALOGS WILL BE UNALLOCATED BY      */
*/*                           IEFAB4F4 - CATALOG UNALLOCATION        */
*/*                       IF NO ERROR DETECTED BY UNALLOCATION, THEN */
*/*                       - WAIT AUTHORIZATION, IF REQUESTED, AND A  */
*/*                           ZERO REASON CODE ARE PLACED INTO THE   */
*/*                           DYNAMIC ALLOCATION PARAMETER AREA,     */
*/*                           AND THE SVC 99 IS REISSUED.            */
*/*                       - RETURN/REASON CODES ARE SET IF THE       */
*/*                           CATALOG STILL CANNOT BE ALLOCATED.     */
*/*                                                                  */
*/* ENTRY - IF RECOVERABLE RETURN CODES FROM SVC 99                  */
*/*                                                                  */
*/*   PURPOSE - UNALLOCATE CATALOGS TO OBTAIN RESOURCES              */
*/*                                                                  */
*/*   INPUT DATA - RETURN CODE AND PCCBS                             */
*/*                                                                  */
*/* EXIT - IN LINE                                                   */
*/*                                                                  */
*/*   CONDITION - CATALOG ALLOCATED OR ERROR                         */
*/*                                                                  */
*/*   OUTPUT DATA - REASON CODES FROM REG 15 FROM CALLED ROUTINES    */
*/*                                                                  */
*/*   RETURN CODE - 0 SUCCESSFUL ALLOCATION                          */
*/*                 4 ERROR                                          */
*/********************************************************************/
*                                                               03S0203
*                   GEN REFS(NQCORE);                           03S0203
      ENQ    MF=(E,NQCORE)
*                   CATALCTD=OFF;   /* SVC 99 REISSUE CONTROL        */
         NI    CATALCTD,B'01111111'                             03S0204
*                   PCCBPTR=SAVJSCBP->JSCBPCC;/* ADDRESS OF FIRST
*                                      PCCB                          */
         L     @10,SAVJSCBP                                     03S0205
         L     PCCBPTR,JSCBPCC(,@10)                            03S0205
*                   DO WHILE(CATALCTD=OFF&/* SCAN PCCB(S) FOR AN
*                                      ALLOCATED                     */
*                         PCCBPTR^=0);/* CATALOG..(DDNAME PRESENT).  */
         B     @DE00206                                         03S0206
@DL00206 DS    0H                                               03S0207
*                     IF PCCDDNAM(1:4)^=0 THEN/* THIS CATALOG IS
*                                      ALLOCATED                     */
         ICM   @10,15,PCCDDNAM(PCCBPTR)                         03S0207
         BZ    @RF00207                                         03S0207
*                       CATALCTD=ON;/* SVC 99 WILL BE REISSUED       */
         OI    CATALCTD,B'10000000'                             03S0208
*                     PCCBPTR=PCCNEXTP;/* NEXT PCCB                  */
@RF00207 L     PCCBPTR,PCCNEXTP(,PCCBPTR)                       03S0209
*                   END;                                        03S0210
@DE00206 TM    CATALCTD,B'10000000'                             03S0210
         BNZ   @DC00206                                         03S0210
         LTR   PCCBPTR,PCCBPTR                                  03S0210
         BNZ   @DL00206                                         03S0210
@DC00206 DS    0H                                               03S0211
*                   GEN REFS(NQCORE);                           03S0211
      DEQ    MF=(E,NQCORE)
*                   IF CATALCTD=ON THEN/* CATALOG(S) ARE AVAILABLE
*                                      FOR                           */
         TM    CATALCTD,B'10000000'                             03S0212
         BNO   @RF00212                                         03S0212
*                     DO;           /* UNALLOCATION                  */
*                       RETCOD=0;   /* RECOVERY MAY BE SUCCESSFUL    */
         SLR   @10,@10                                          03S0214
         STCM  @10,15,RETCOD                                    03S0214
*                       UCCNTRLS=0; /* SETUP CONTROLS FOR IEFAB4F4.  */
         STH   @10,UCCNTRLS                                     03S0215
*                       UCALLCAT=ON;/* UNALLOCATE ALL CATALOGS, AND  */
*                       UCALLACB=ON;/* CLOSE ALL ASSOCIATED ACB(S)   */
         OI    UCALLCAT,B'00010100'                             03S0217
*                       IF ACNOENQ=ON THEN/* TIOT ENQ NOT ALLOWED    */
         L     @10,@PC00001                                     03S0218
         TM    ACNOENQ(@10),B'00000010'                         03S0218
         BNO   @RF00218                                         03S0218
*                         UCNTIONQ=ON;                          03S0219
         OI    UCNTIONQ,B'01000000'                             03S0219
*                       RETCOD=0;   /* PREVIOUS ERRORS INVALID       */
@RF00218 SLR   @10,@10                                          03S0220
         STCM  @10,15,RETCOD                                    03S0220
*                       IF ACNUJSCB=ON THEN/* ACTIVE JSCB SWITCHED?
*                                                            @ZA11903*/
         L     @07,@PC00001                                     03S0221
         TM    ACNUJSCB(@07),B'00000001'                        03S0221
         BNO   @RF00221                                         03S0221
*                         DO;       /* POINT ACT TO PP JSCB  @ZA11903*/
*                           UCCAJSCB=ON;/* UNALLOC FROM INIT JSCB
*                                                            @ZA11903*/
         OI    UCCAJSCB,B'10000000'                             03S0223
*                           DO;     /* MODESET KEYADDR(0)            */
*                             SPKA(0);/* SET PSW KEY                 */
         SPKA  0(@10)                                           03S0225
*                           END;    /* MODESET KEYADDR(0) KEY ZERO
*                                                            @ZA11903*/
*                           JSCBACT=SAVJSCBP;/* GET INIT JSCB ADDR
*                                                            @ZA11903*/
         L     @10,@PC00001+8                                   03S0227
         L     @07,JSCBPTR(,@10)                                03S0227
         L     @05,SAVJSCBP                                     03S0227
         ST    @05,JSCBACT(,@07)                                03S0227
*                           DO;     /* MODESET EXTKEY(SCHED)         */
*                             SPKA(16);/* SET PSW KEY                */
         LA    @07,16                                           03S0229
         SPKA  0(@07)                                           03S0229
*                           END;    /* MODESET EXTKEY(SCHED) BACK TO
*                                      KEY 1                 @ZA11903*/
*                           CALL IEFAB4F4(UCCNTRLS,RTCDPTR,0,0,0,
*                               JSCBPTR);/*                  @ZA11903*/
         LA    @07,UCCNTRLS                                     03S0231
         ST    @07,@AL00001                                     03S0231
         LA    @07,RTCDPTR                                      03S0231
         ST    @07,@AL00001+4                                   03S0231
         LA    @07,@CF00146                                     03S0231
         ST    @07,@AL00001+8                                   03S0231
         LA    @07,@CF00146                                     03S0231
         ST    @07,@AL00001+12                                  03S0231
         LA    @07,@CF00146                                     03S0231
         ST    @07,@AL00001+16                                  03S0231
         ST    @10,@AL00001+20                                  03S0231
         L     @15,@CV00171                                     03S0231
         LA    @01,@AL00001                                     03S0231
         BALR  @14,@15                                          03S0231
*                           DO;     /* MODESET KEYADDR(0)            */
*                             SPKA(0);/* SET PSW KEY                 */
         SLR   @10,@10                                          03S0233
         SPKA  0(@10)                                           03S0233
*                           END;    /* MODESET KEYADDR(0)    @ZA11903*/
*                           JSCBACT=JSCBPTR;/* POINT TO CURRENT JSCB
*                                                            @ZA11903*/
         L     @10,@PC00001+8                                   03S0235
         L     @10,JSCBPTR(,@10)                                03S0235
         ST    @10,JSCBACT(,@10)                                03S0235
*                           DO;     /* MODESET EXTKEY(SCHED)         */
*                             SPKA(16);/* SET PSW KEY                */
         LA    @10,16                                           03S0237
         SPKA  0(@10)                                           03S0237
*                           END;    /* MODESET EXTKEY(SCHED) BACK TO
*                                      KEY 1                 @ZA11903*/
*                         END;      /*                       @ZA11903*/
*                       ELSE        /*                       @ZA11903*/
*                         CALL IEFAB4F4(UCCNTRLS,RTCDPTR,0,0,0,JSCBPTR)
*                           ;       /*                       @ZA11903*/
         B     @RC00221                                         03S0240
@RF00221 LA    @10,UCCNTRLS                                     03S0240
         ST    @10,@AL00001                                     03S0240
         LA    @10,RTCDPTR                                      03S0240
         ST    @10,@AL00001+4                                   03S0240
         LA    @10,@CF00146                                     03S0240
         ST    @10,@AL00001+8                                   03S0240
         LA    @10,@CF00146                                     03S0240
         ST    @10,@AL00001+12                                  03S0240
         LA    @10,@CF00146                                     03S0240
         ST    @10,@AL00001+16                                  03S0240
         L     @10,@PC00001+8                                   03S0240
         ST    @10,@AL00001+20                                  03S0240
         L     @15,@CV00171                                     03S0240
         LA    @01,@AL00001                                     03S0240
         BALR  @14,@15                                          03S0240
*                       IF RTCD=0 THEN/* ALL CATALOGS UNALLOCATED    */
@RC00221 LH    @10,RTCD                                         03S0241
         LTR   @10,@10                                          03S0241
         BNZ   @RF00241                                         03S0241
*                         DO;       /* SET UP AND REISSUE SVC99      */
*                           IF ACDVWAIT=ON THEN/* DEVICE WAIT OK     */
         L     @10,@PC00001                                     03S0243
         TM    ACDVWAIT(@10),B'01000000'                        03S0243
         BNO   @RF00243                                         03S0243
*                             S99WTUNT=ON;                      03S0244
         OI    S99WTUNT,B'00010000'                             03S0244
*                           IF ACVLWAIT=ON THEN/* VOLUME WAIT OK     */
@RF00243 L     @10,@PC00001                                     03S0245
         TM    ACVLWAIT(@10),B'00001000'                        03S0245
         BNO   @RF00245                                         03S0245
*                             S99WTVOL=ON;                      03S0246
         OI    S99WTVOL,B'10000000'                             03S0246
*                           S99RSC=0;/* RESET REASON/INFO AREA       */
@RF00245 SLR   @10,@10                                          03S0247
         ST    @10,S99RSC                                       03S0247
*                           CATSUNAL=ON;/* ENABLE CALLER INDICATION
*                                      THAT CATALOGS WERE UNALLOCATED*/
         OI    CATSUNAL,B'10000000'                             03S0248
*                           PARAMREG=ADDR(S99RBPTR);/* POINT REG 1 TO
*                                      PARMS                         */
*                                                               03S0249
         LA    PARAMREG,S99RBPTR                                03S0249
*                           /*****************************************/
*                           /*                                       */
*                           /* MACDATE Y-2 73082                     */
*                           /*                                       */
*                           /*****************************************/
*                                                               03S0250
*                           SVC(99);/* ATTEMPT ALLOCATION AGAIN      */
         SVC   99                                               03S0250
*                           RTCD=RTCDREG;/* SAVE RETURN CODE         */
         STH   RTCDREG,RTCD                                     03S0251
*                         END;                                  03S0252
*                     END;                                      03S0253
@RF00241 DS    0H                                               03S0254
*                 END;              /* END OF 'RECOVERY'             */
@RF00212 DS    0H                                               02S0255
*               IF RTCD=0 THEN      /* IF NO ERRORS, THEN UPDATE     */
@RF00201 LH    @10,RTCD                                         02S0255
         LTR   @10,@10                                          02S0255
         BNZ   @RF00255                                         02S0255
*                 DO;                                           02S0256
*                   EDDNAME=UNITPTR(3)->S99TUPAR(1:8);/* DDN TO ESTAE
*                                      PARMLIST                      */
         L     @10,UNITPTR+8                                    02S0257
         MVC   EDDNAME(8,EPRMLSTP),S99TUPAR(@10)                02S0257
*                   EEUCUCAT=ON;    /* SET CURRENT CATALOG ALLOCATED */
         OI    EEUCUCAT(EPRMLSTP),B'00010000'                   02S0258
*                   DDNAMPTR=ADDR(UNITPTR(3)->S99TUPAR);/* PTR TO NEW
*                                      DD NAME                       */
         LA    @10,S99TUPAR(,@10)                               02S0259
         ST    @10,DDNAMPTR                                     02S0259
*                   VSERPTR=ADDR(CATVSER);/* CATALOG'S VOLUME SERIAL */
         LA    @10,CATVSER                                      02S0260
         ST    @10,VSERPTR                                      02S0260
*                   CJUSTALC=ON;    /* ERROR CORRECT CONTROL         */
         OI    CJUSTALC,B'10000000'                             02S0261
*                 END;                                          02S0262
*               ELSE                /* UNRECOVERABLE ERROR           */
*                 IF S99ERROR=CANTMNT THEN/* CATALOG MOUNT NEEDED,
*                                      BUT                           */
         B     @RC00255                                         02S0263
@RF00255 CLC   S99ERROR(2),@CB00136                             02S0263
         BNE   @RF00263                                         02S0263
*                   DO;             /* MOUNTING IS NOT AUTHORIZED    */
*                     RTCD=STPERROR;/* RETURN CODE - 8               */
         MVC   RTCD(2),@CH00075                                 02S0265
*                     RSCD=NOAUTH;  /* REASON CODE - 1               */
         MVC   RSCD(2),@CH00065                                 02S0266
*                   END;                                        02S0267
*             END;                                              01S0268
@RF00263 DS    0H                                               01S0268
@RC00255 DS    0H                                               01S0269
*           IF RTCD=0&              /* NO ERROR FROM DYNALLOC AND    */
*               ACOPNACB=ON THEN    /* OPEN OF CATALOG REQUESTED     */
@RF00149 LH    @10,RTCD                                         01S0269
         LTR   @10,@10                                          01S0269
         BNZ   @RF00269                                         01S0269
         L     @10,@PC00001                                     01S0269
         TM    ACOPNACB(@10),B'00010000'                        01S0269
         BNO   @RF00269                                         01S0269
*             DO;                                               01S0270
*                                                               02S0271
*/********************************************************************/
*/*                                                                  */
*/* SEGMENT NAME - OPENCTLG                                          */
*/*                                                                  */
*/* DESCRIPTIVE NAME - INTERFACE TO OPEN CATALOG ROUTINE             */
*/*                                                                  */
*/* OPERATION - IF THE CATALOG HAS NOT JUST BEEN ALLOCATED (THE      */
*/*             INPUT DDNAME PTR IS NON-ZERO), AND NOT IDENTIFIED    */
*/*             AS A CVOL BY THE CALLER, THE PCCB CHAIN IS ENQUEUED  */
*/*             AND SCANNED TO INSURE THAT THE CATALOG, IF IT IS     */
*/*             REPRESENTED BY A PRIVATE CATALOG CONTROL BLOCK, IS   */
*/*             NOT A CVOL, WHICH ARE OPENED ONLY BY CATALOG         */
*/*             MANAGEMENT.                                          */
*/*               (SOME CALLERS, SUCH AS THE INITIATOR, WISHING      */
*/*                ONLY TO HAVE THE CATALOG OPENED MAY NOT BE        */
*/*                AWARE OF CVOLS, AND AS SUCH WILL NOT INDICATE     */
*/*                THIS IN THE INPUT CONTROLS.  HOWEVER, CALLERS     */
*/*                WISHING TO HAVE THE CATALOG ALLOCATED AS WELL     */
*/*                AS OPENED, SUCH AS JFCB HOUSEKEEPING, WILL        */
*/*                ALWAYS INDICATE 'CVOL' IF NECESSARY.  HENCE THE   */
*/*                NEED TO VERIFY CATALOGS AS CVOLS IF THE CALLER    */
*/*                DID NOT REQUEST THE CATALOG ALLOCATED.)           */
*/*             SATISFIED THAT THE CATALOG IS NOT A CVOL, THIS       */
*/*             ROUTINE WILL INITIALIZE THE PARAMETER LIST AND       */
*/*             CALL 'OPENCAT' (IDACAT11).                           */
*/*             SUCCESSFUL OPENING OF THE CATALOG WILL ALLOW THE     */
*/*             UPDATING OF THE ESTAE PARAMETER LIST.                */
*/*                                                                  */
*/* ENTRY - IF 'OPEN THE CATALOG' IS REQUESTED                       */
*/*                                                                  */
*/*   PURPOSE - SINGLE ENTRY POINT                                   */
*/*                                                                  */
*/*   INPUT DATA - MODULE INPUT AND THE ADDRESS OF THE PCCB CHAIN    */
*/*                                                                  */
*/* EXIT - INLINE                                                    */
*/*                                                                  */
*/*   CONDITION - SINGLE EXIT POINT                                  */
*/*                                                                  */
*/*   OUTPUT DATA - SUCCESS - ACB POINTER FROM OPEN                  */
*/*               - FAILURE - REASON CODE - 4                        */
*/*                                                                  */
*/*   RETURN CODE - SUCCESS - 0                                      */
*/*               - FAILURE - 4                                      */
*/*                                                                  */
*/********************************************************************/
*                                                               02S0271
*               IF ACOSCVOL=OFF THEN/* CALLER DID NOT INDICATE 'CVOL'*/
         TM    ACOSCVOL(@10),B'00010000'                        02S0271
         BNZ   @RF00271                                         02S0271
*                 DO;                                           02S0272
*                   OK2OPEN=ON;     /* INITIALIZE NON-CVOL SWITCH    */
         OI    OK2OPEN,B'10000000'                              02S0273
*                   IF CJUSTALC=OFF THEN/* CATALOG NOT JUST ALLOCATED*/
         TM    CJUSTALC,B'10000000'                             02S0274
         BNZ   @RF00274                                         02S0274
*                     DO;           /* ENQUEUE PCCB CHAIN AND INSURE */
*                       DDNAMPTR=DDNAMP;/* CATALOG IS NOT A CVOL     */
         L     @10,@PC00001+20                                  02S0276
         L     @10,DDNAMP(,@10)                                 02S0276
         ST    @10,DDNAMPTR                                     02S0276
*                       OK2OPEN=OFF;/* CATALOG MAY BE CVOL           */
         NI    OK2OPEN,B'01111111'                              02S0277
*                       NQCORE(1:NQLENGTH)=PCNQLIST(1:NQLENGTH);
         L     @10,NQLENGTH                                     02S0278
         BCTR  @10,0                                            02S0278
         EX    @10,@SM01127                                     02S0278
*                       GEN REFS(NQCORE);                       02S0279
        ENQ    MF=(E,NQCORE)
*                       PCCBPTR=SAVJSCBP->JSCBPCC;/* SCAN ACTIVE PCCB*/
         L     @10,SAVJSCBP                                     02S0280
         L     PCCBPTR,JSCBPCC(,@10)                            02S0280
*                       CVOLSW=OFF; /* INTERNAL CVOL SW.     @YM04956*/
         NI    CVOLSW,B'01111111'                               02S0281
*                       DO WHILE(PCCBPTR^=0&/* CHAIN TO END OR UNTIL */
*                             CVOLSW=OFF&/* CVOL PCCB OR DDNAME 02S0282
*                                                            @YM04956*/
*                             PCCDDNAM^=DDNAMPTR->DDNAME);/* PCCB
*                                      FOUND                         */
         B     @DE00282                                         02S0282
@DL00282 DS    0H                                               02S0283
*                         IF PCOSCVOL=ON/* CVOL WITH NAME    @YM04956*/
*                             &(CTGDSN=PCCDSNAM|CTGDSN=PCCTGCON) THEN
         TM    PCOSCVOL(PCCBPTR),B'00010000'                    02S0283
         BNO   @RF00283                                         02S0283
         L     @10,@PC00001+12                                  02S0283
         L     @10,CTGDSNP(,@10)                                02S0283
         CLC   CTGDSN(44,@10),PCCDSNAM(PCCBPTR)                 02S0283
         BE    @RT00283                                         02S0283
         CLC   CTGDSN(44,@10),PCCTGCON(PCCBPTR)                 02S0283
         BNE   @RF00283                                         02S0283
@RT00283 DS    0H                                               02S0284
*                           CVOLSW=ON;/* PASSED, STOP LOOP.  @YM04956*/
         OI    CVOLSW,B'10000000'                               02S0284
*                         ELSE      /* GET NEXT PCCB.        @YM04956*/
*                           PCCBPTR=PCCNEXTP;/* WITH CORRECT DDNAME  */
         B     @RC00283                                         02S0285
@RF00283 L     PCCBPTR,PCCNEXTP(,PCCBPTR)                       02S0285
*                       END;                                    02S0286
@RC00283 DS    0H                                               02S0286
@DE00282 LTR   PCCBPTR,PCCBPTR                                  02S0286
         BZ    @DC00282                                         02S0286
         TM    CVOLSW,B'10000000'                               02S0286
         BNZ   @DC00282                                         02S0286
         L     @10,DDNAMPTR                                     02S0286
         CLC   PCCDDNAM(8,PCCBPTR),DDNAME(@10)                  02S0286
         BNE   @DL00282                                         02S0286
@DC00282 DS    0H                                               02S0287
*                       IF PCCBPTR=0|/* CATALOG NEVER ALLOCATED OR   */
*                           PCOSCVOL=OFF THEN/* IT IS NOT A CVOL,    */
         LTR   PCCBPTR,PCCBPTR                                  02S0287
         BZ    @RT00287                                         02S0287
         TM    PCOSCVOL(PCCBPTR),B'00010000'                    02S0287
         BNZ   @RF00287                                         02S0287
@RT00287 DS    0H                                               02S0288
*                         OK2OPEN=ON;/* THEN CATALOG MAY BE OPENED   */
         OI    OK2OPEN,B'10000000'                              02S0288
*                       GEN REFS(NQCORE);                       02S0289
@RF00287 DS    0H                                               02S0289
*                                  /* DEQUEUE PCCB CHAIN            */
        DEQ    MF=(E,NQCORE)
*                     END;          /* PCCB CHAIN ENQUEUE LOOP       */
*                   IF OK2OPEN=ON THEN/* CATALOG IS NOT A CVOL       */
@RF00274 TM    OK2OPEN,B'10000000'                              02S0291
         BNO   @RF00291                                         02S0291
*                     DO;                                       02S0292
*                       OPNFLAGS=OPNFLAGS&&OPNFLAGS;/* OPEN CONTROLS */
         XC    OPNFLAGS(4),OPNFLAGS                             02S0293
*                       IF ACNOENQ=ON THEN/* DO NOT ENQUEUE ON THE
*                                      TIOT                          */
         L     @10,@PC00001                                     02S0294
         TM    ACNOENQ(@10),B'00000010'                         02S0294
         BNO   @RF00294                                         02S0294
*                         OPNOTINQ=ON;                          02S0295
         OI    OPNOTINQ,B'00000100'                             02S0295
*                       PARAMREG=ADDR(CATPARMS);/* POINT REG 1 TO    */
@RF00294 LA    PARAMREG,CATPARMS                                02S0296
*                       CALL IDACAT11;/* CATALOG PARMS               */
         L     @15,@CV00167                                     02S0297
         BALR  @14,@15                                          02S0297
*                       RTCD=RTCDREG;/* SAVE RETURN CODE             */
         STH   RTCDREG,RTCD                                     02S0298
*                       IF RTCD=0 THEN/* CTLG JUST OPENED            */
         LH    @10,RTCD                                         02S0299
         LTR   @10,@10                                          02S0299
         BNZ   @RF00299                                         02S0299
*                         DO;                                   02S0300
*                           CTGOPEND=ON;/* REMEMBER FOR ERROR CHECK  */
         OI    CTGOPEND,B'10000000'                             02S0301
*                           EACBPTR=ACBPTR;/* ACB PTR TO ESTAE  02S0302
*                                      PARMLIST                      */
         L     @10,ACBPTR                                       02S0302
         ST    @10,EACBPTR(,EPRMLSTP)                           02S0302
*                           EECCUCAT=ON;/* SET CURRENT CATALOG OPENED*/
         OI    EECCUCAT(EPRMLSTP),B'00001000'                   02S0303
*                         END;                                  02S0304
*                     END;          /* OPEN LOOP                     */
*                   ELSE            /* CVOL (FROM PCCB CHECK)        */
*                     PCCVOL=ON;    /* CONTROL TO PCCB ROUTINE       */
         B     @RC00291                                         02S0306
@RF00291 OI    PCCVOL,B'00001000'                               02S0306
*                 END;              /* NOT A CVOL (PARM)             */
@RC00291 DS    0H                                               02S0308
*             END;                                              01S0308
@RF00271 DS    0H                                               01S0309
*         END;                      /* END CTLG NOT ALLOC'D@ZA00870  */
@RF00269 DS    0H                                               01S0310
*       IF ACNUJSCB=ON THEN         /* CTLG ALLOCATED TO ACTIVE TASK */
@RF00147 L     @10,@PC00001                                     01S0310
         TM    ACNUJSCB(@10),B'00000001'                        01S0310
         BNO   @RF00310                                         01S0310
*         DO;                                                   01S0311
*           DO;                     /* MODESET KEYADDR(0)            */
*             SPKA(0);              /* SET PSW KEY                   */
         SLR   @10,@10                                          01S0313
         SPKA  0(@10)                                           01S0313
*           END;                    /* MODESET KEYADDR(0) KEY 0 TO
*                                      ALTER JSCB                    */
*           JSCBACT=SAVJSCBP;       /* RESET ACTIVE JSCB PTR         */
         L     @10,@PC00001+8                                   01S0315
         L     @10,JSCBPTR(,@10)                                01S0315
         L     @07,SAVJSCBP                                     01S0315
         ST    @07,JSCBACT(,@10)                                01S0315
*           DO;                     /* MODESET EXTKEY(SCHED)         */
*             SPKA(16);             /* SET PSW KEY                   */
         LA    @10,16                                           01S0317
         SPKA  0(@10)                                           01S0317
*           END;                    /* MODESET EXTKEY(SCHED) BACK TO
*                                      KEY 1                         */
*         END;                                                  01S0319
*       IF RTCD=0&                  /* NO ERROR AND          @YM04235*/
*           ACCCPCCB=ON THEN        /* PCCB ROUTINE REQUESTED        */
@RF00310 LH    @10,RTCD                                         01S0320
         LTR   @10,@10                                          01S0320
         BNZ   @RF00320                                         01S0320
         L     @10,@PC00001                                     01S0320
         TM    ACCCPCCB(@10),B'00001000'                        01S0320
         BNO   @RF00320                                         01S0320
*         DO;                                                   01S0321
*           IF ACSTPCAT=ON THEN     /* STEPCAT                       */
         TM    ACSTPCAT(@10),B'01000000'                        01S0322
         BNO   @RF00322                                         01S0322
*             PCCSTPCT=ON;                                      01S0323
         OI    PCCSTPCT,B'00100000'                             01S0323
*           IF ACOSCVOL=ON THEN     /* CALLER INDICATES 'CVOL',      */
@RF00322 L     @10,@PC00001                                     01S0324
         TM    ACOSCVOL(@10),B'00010000'                        01S0324
         BNO   @RF00324                                         01S0324
*             PCCVOL=ON;            /* INDICATE TO PCCB ROUTINE      */
         OI    PCCVOL,B'00001000'                               01S0325
*           PCCMAKE=ON;             /* CREATE/CHAIN OR MODIFY PCCB   */
@RF00324 OI    PCCMAKE,B'10000000'                              01S0326
*           IF DDNAMP^=0 THEN       /* DDNAME PTR FROM PARAMETERS    */
         L     @10,@PC00001+20                                  01S0327
         L     @10,DDNAMP(,@10)                                 01S0327
         LTR   @10,@10                                          01S0327
         BZ    @RF00327                                         01S0327
*             DDNAMPTR=DDNAMP;      /* OR DYNAM ALLOCATION           */
         ST    @10,DDNAMPTR                                     01S0328
*           CALL IEFAB4EF(PCCNTRLS,RTCDPTR,SAVJSCBP,CTGDSNP,CTGCONP,
*               ACBPTR,DDNAMPTR,0,VSERPTR);/* PCCB ROUTINE           */
@RF00327 LA    @10,PCCNTRLS                                     01S0329
         ST    @10,@AL00001                                     01S0329
         LA    @10,RTCDPTR                                      01S0329
         ST    @10,@AL00001+4                                   01S0329
         LA    @10,SAVJSCBP                                     01S0329
         ST    @10,@AL00001+8                                   01S0329
         L     @10,@PC00001+12                                  01S0329
         ST    @10,@AL00001+12                                  01S0329
         L     @10,@PC00001+16                                  01S0329
         ST    @10,@AL00001+16                                  01S0329
         LA    @10,ACBPTR                                       01S0329
         ST    @10,@AL00001+20                                  01S0329
         LA    @10,DDNAMPTR                                     01S0329
         ST    @10,@AL00001+24                                  01S0329
         LA    @10,@CF00146                                     01S0329
         ST    @10,@AL00001+28                                  01S0329
         LA    @10,VSERPTR                                      01S0329
         ST    @10,@AL00001+32                                  01S0329
         L     @15,@CV00170                                     01S0329
         LA    @01,@AL00001                                     01S0329
         BALR  @14,@15                                          01S0329
*           IF RTCD=0 THEN          /* SUCCESSFUL PCCB FUNCTION      */
         LH    @10,RTCD                                         01S0330
         LTR   @10,@10                                          01S0330
         BNZ   @RF00330                                         01S0330
*             DO;                   /* RESET ESTAE INDICATORS        */
*               EEUCUCAT=OFF;       /* CURRENT CAT. ALLOCATED        */
*               EECCUCAT=OFF;       /* CURRENT CAT. OPEN             */
         NI    EEUCUCAT(EPRMLSTP),B'11100111'                   01S0333
*             END;                                              01S0334
*           IF RTCD=DUPCATLG THEN   /* IF AB4EF FOUND A DUPL PVT
*                                      CATALOG THEN IGNORE THIS 01S0335
*                                      REQUEST               @ZA06641*/
@RF00330 CLC   RTCD(2),@CH00063                                 01S0335
         BNE   @RF00335                                         01S0335
*             RETCOD=0;             /*                       @ZA06641*/
         SLR   @10,@10                                          01S0336
         STCM  @10,15,RETCOD                                    01S0336
*         END;                      /* PCCB ROUTINE REQUEST          */
@RF00335 DS    0H                                               01S0338
*       IF RTCD^=0 THEN             /* ERROR IN PROCESSING           */
@RF00320 SLR   @10,@10                                          01S0338
         CH    @10,RTCD                                         01S0338
         BE    @RF00338                                         01S0338
*         DO;                       /* UNALLOCATE/CLOSE CATALOG      */
*           UCCNTRLS=0;             /* PRESERVING THE ORIGINAL RTCD  */
         STH   @10,UCCNTRLS                                     01S0340
*           IF CJUSTALC=ON THEN     /* CATALOG WAS JUST ALLOCATED    */
         TM    CJUSTALC,B'10000000'                             01S0341
         BNO   @RF00341                                         01S0341
*             UCONECAT=ON;          /* UNALLOCATE IT                 */
         OI    UCONECAT,B'00100000'                             01S0342
*           IF CTGOPEND=ON THEN     /* CATALOG WAS OPENED            */
@RF00341 TM    CTGOPEND,B'10000000'                             01S0343
         BNO   @RF00343                                         01S0343
*             UCONEACB=ON;          /* CLOSE IT                      */
         OI    UCONEACB,B'00001000'                             01S0344
*           IF UCCNTRLS^=0 THEN     /* CTLG WAS ALLOCATED OR OPENED  */
@RF00343 LH    @10,UCCNTRLS                                     01S0345
         N     @10,@CF01132                                     01S0345
         LTR   @10,@10                                          01S0345
         BZ    @RF00345                                         01S0345
*             DO;                                               01S0346
*               IF ACNUJSCB=ON THEN /* USING THE INITIATOR'S JSCB    */
         L     @10,@PC00001                                     01S0347
         TM    ACNUJSCB(@10),B'00000001'                        01S0347
         BNO   @RF00347                                         01S0347
*                 UCCAJSCB=ON;      /* INDICATE SAME TO UNALLOC CTLG */
         OI    UCCAJSCB,B'10000000'                             01S0348
*               IF ACNOENQ=ON THEN  /* TIOT ENQ NOT ALLOWED          */
@RF00347 L     @10,@PC00001                                     01S0349
         TM    ACNOENQ(@10),B'00000010'                         01S0349
         BNO   @RF00349                                         01S0349
*                 UCNTIONQ=ON;                                  01S0350
         OI    UCNTIONQ,B'01000000'                             01S0350
*               IF UCONECAT=ON THEN /* UNALLOC. ONE WAS REQUESTED    */
@RF00349 TM    UCONECAT,B'00100000'                             01S0351
         BNO   @RF00351                                         01S0351
*                 EEUCUCAT=OFF;     /* UNALLOC. CURRENT CATALOG BIT  */
         NI    EEUCUCAT(EPRMLSTP),B'11101111'                   01S0352
*               IF UCONEACB=ON THEN /* CLOSE ONE WAS REQUESTED       */
@RF00351 TM    UCONEACB,B'00001000'                             01S0353
         BNO   @RF00353                                         01S0353
*                 EECCUCAT=OFF;     /* CLOSE CURRENT CATALOG BIT     */
         NI    EECCUCAT(EPRMLSTP),B'11110111'                   01S0354
*               CALL IEFAB4F4(UCCNTRLS,ADDR(DUMMYRTN),0,DDNAMPTR,ACBPTR
*                   ,JSCBPTR);      /* MUST PRESERVE REAL RTN INFO   */
@RF00353 LA    @10,UCCNTRLS                                     01S0355
         ST    @10,@AL00001                                     01S0355
         LA    @10,DUMMYRTN                                     01S0355
         ST    @10,@TF00001                                     01S0355
         LA    @10,@TF00001                                     01S0355
         ST    @10,@AL00001+4                                   01S0355
         LA    @10,@CF00146                                     01S0355
         ST    @10,@AL00001+8                                   01S0355
         LA    @10,DDNAMPTR                                     01S0355
         ST    @10,@AL00001+12                                  01S0355
         LA    @10,ACBPTR                                       01S0355
         ST    @10,@AL00001+16                                  01S0355
         L     @10,@PC00001+8                                   01S0355
         ST    @10,@AL00001+20                                  01S0355
         L     @15,@CV00171                                     01S0355
         LA    @01,@AL00001                                     01S0355
         BALR  @14,@15                                          01S0355
*             END;                                              01S0356
*           IF RSCD^=NOAUTH THEN    /* DO NOT OVERLAY STEP RETURN    */
@RF00345 CLC   RSCD(2),@CH00065                                 01S0357
         BE    @RF00357                                         01S0357
*             DO;                   /* AND REASON CODES              */
*               RTCD=STPERROR;      /* 8 - UNABLE TO ALLOCATE        */
         MVC   RTCD(2),@CH00075                                 01S0359
*               RSCD=NOALC;         /* 19 - AND/OR OPEN CATALOG      */
         MVC   RSCD(2),@CH00127                                 01S0360
*             END;                                              01S0361
*         END;                      /* ERROR PROCESSING              */
@RF00357 DS    0H                                               01S0363
*       GEN REFS(ESTAECOR);                                     01S0363
@RF00338 DS    0H                                               01S0363
      ESTAE 0,MF=(E,ESTAECOR)
*       RFY                                                     01S0364
*        (REG0,                                                 01S0364
*         REG1) RSTD;               /* ESTAE PARMLIST TO BE FREED    */
*       REG0=SPLEN;                 /* SET SUBPOOL NUMBER            */
         L     REG0,SPLEN                                       01S0365
*       REG1=EPRMLSTP;              /* PTR TO PARMLIST TO FREE       */
         LR    REG1,EPRMLSTP                                    01S0366
*       GEN(FREEMAIN R,LV=(0),A=(1));                           01S0367
         FREEMAIN R,LV=(0),A=(1)
*       RFY                                                     01S0368
*        (REG0,                                                 01S0368
*         REG1) UNRSTD;                                         01S0368
*     END;                          /* END - ESTAE SUCCESSFUL        */
*/*** GET IN KEY OF CALLER TO RETURN THE RETURN INFORMATION        ***/
*                                                               01S0370
*   DO;                             /* MODESET KEYADDR(KEYSAVE)      */
@RF00107 DS    0H                                               01S0371
*     SPKA(KEYSAVE);                /* SET PSW KEY                   */
         SPKA  0(KEYSAVE)                                       01S0371
*   END;                            /* MODESET KEYADDR(KEYSAVE) KEY
*                                      OF CALLER                     */
*   RETURNS=RETCOD;                 /* RETURN INFO TO CALLER         */
         L     @10,@PC00001+4                                   01S0373
         L     @10,RTNINFOP(,@10)                               01S0373
         MVC   RETURNS(4,@10),RETCOD                            01S0373
*   IF CATSUNAL=ON THEN             /* INDICATE CATALOGS UNALLOCATED */
         TM    CATSUNAL,B'10000000'                             01S0374
         BNO   @RF00374                                         01S0374
*     ACRECOVD=ON;                  /* TO CALLER                     */
         L     @10,@PC00001                                     01S0375
         OI    ACRECOVD(@10),B'00000100'                        01S0375
*   DO;                             /* MODESET EXTKEY(SCHED)         */
@RF00374 DS    0H                                               01S0377
*     SPKA(16);                     /* SET PSW KEY                   */
         LA    @10,16                                           01S0377
         SPKA  0(@10)                                           01S0377
*   END;                            /* MODESET EXTKEY(SCHED) BACK TO
*                                      OUR KEY                       */
*   END IEFAB4F5                                                01S0379
*                                                               01S0379
*/* THE FOLLOWING INCLUDE STATEMENTS WERE FOUND IN THIS PROGRAM.     */
*/*%INCLUDE SYSUT5  (SPEC4F5 )                                       */
*/*%INCLUDE SYSUT5  (DCLS4F5 )                                       */
*/*%INCLUDE SYSLIB  (IEFZB442)                                       */
*/*%INCLUDE SYSLIB  (IEFZB443)                                       */
*/*%INCLUDE SYSLIB  (IEFZB444)                                       */
*/*%INCLUDE SYSLIB  (IEFZB450)                                       */
*/*%INCLUDE SYSLIB  (IEFZB453)                                       */
*/*%INCLUDE SYSLIB  (IEFZB4D0)                                       */
*/*%INCLUDE SYSLIB  (IEFZB4D2)                                       */
*/*%INCLUDE SYSLIB  (IEZJSCB )                                       */
*/*%INCLUDE SYSLIB  (IEFPCCB )                                       */
*/*%INCLUDE SYSLIB  (IKJTCB  )                                       */
*/*%INCLUDE SYSUT5  (ACESTAES)                                       */
*/*%INCLUDE SYSUT5  (ACESTAE )                                       */
*/*%INCLUDE SYSLIB  (ESTAECOD)                                       */
*/*%INCLUDE SYSLIB  (ESTAESPC)                                       */
*/*%INCLUDE SYSUT5  (ALCTSPEC)                                       */
*/*%INCLUDE SYSUT5  (ALCATLG )                                       */
*/*%INCLUDE SYSUT5  (RECVSPEC)                                       */
*/*%INCLUDE SYSUT5  (RECOVERY)                                       */
*/*%INCLUDE SYSUT5  (OPENSPEC)                                       */
*/*%INCLUDE SYSUT5  (OPENCTLG)                                       */
*                                                               01S0379
*       ;                                                       01S0379
@EL00001 LR    @02,KEYSAVE                                      01S0379
         L     @13,4(,@13)                                      01S0379
@EF00001 L     @00,@SIZDATD                                     01S0379
         LR    @01,@11                                          01S0379
         FSPACE   R,LV=(0),A=(1)
         MODESET KEYADDR=(2)
@ER00001 LM    @14,@12,12(@13)                                  01S0379
         BR    @14                                              01S0379
@DATA    DS    0H
@CH00065 DC    H'1'
@CH00106 DC    H'6'
@CH00075 DC    H'8'
@CH00059 DC    H'16'
@CH00127 DC    H'19'
@CH00108 DC    H'44'
@SM01123 MVC   ESTAECOR(0),ESTAELST
@SM01127 MVC   NQCORE(0),PCNQLIST
@DATD    DSECT
         DS    0F
@SA00001 DS    18F
@PC00001 DS    6F
@AL00001 DS    9A
@TF00001 DS    F
IEFAB4F5 CSECT
         DS    0F
@CF00146 DC    F'0'
@CF00063 DC    F'4'
@CH00063 EQU   @CF00063+2
@CF01110 DC    F'436'
@CF01132 DC    XL4'0000FFFF'
@DATD    DSECT
         DS    0D
S99TUFP  DS    A
RTCDPTR  DS    A
VSERPTR  DS    A
SAVJSCBP DS    A
DUMMYRTN DS    F
S99RBPTR DS    AL4
         ORG   S99RBPTR
S99RBPND DS    BL1
         ORG   S99RBPTR+4
JSCBWRKP DS    A
UCCNTRLS DS    FL2
         ORG   UCCNTRLS
UCCAJSCB DS    BL1
UCNTIONQ EQU   UCCNTRLS+0
UCONECAT EQU   UCCNTRLS+0
UCALLCAT EQU   UCCNTRLS+0
UCONEACB EQU   UCCNTRLS+0
UCALLACB EQU   UCCNTRLS+0
UCONPCCB EQU   UCCNTRLS+0
UCALPCCB EQU   UCCNTRLS+0
UCTEMP   DS    BL1
UCSWTIOT EQU   UCCNTRLS+1
@NM00005 EQU   UCCNTRLS+1
         ORG   UCCNTRLS+2
PCCNTRLS DS    FL2
         ORG   PCCNTRLS
PCCMAKE  DS    BL1
PCCFREE  EQU   PCCNTRLS+0
PCCSTPCT EQU   PCCNTRLS+0
PCCFREAL EQU   PCCNTRLS+0
PCCVOL   EQU   PCCNTRLS+0
@NM00009 EQU   PCCNTRLS+0
         ORG   PCCNTRLS+2
RETCOD   DS    CL4
         ORG   RETCOD
RTCD     DS    FL2
RSCD     DS    FL2
         ORG   RETCOD+4
SPLEN    DS    CL4
         ORG   SPLEN
SBPOOL   DS    FL1
LENTH    DS    FL3
         ORG   SPLEN+4
CATPARMS DS    CL12
         ORG   CATPARMS
DDNAMPTR DS    AL4
ACBPTR   DS    AL4
OPNFLAGS DS    BL4
         ORG   OPNFLAGS
@NM00001 DS    BL1
OPNOTINQ EQU   OPNFLAGS+0
@NM00002 EQU   OPNFLAGS+0
         ORG   CATPARMS+12
AB4EDCOR DS    CL500
ASWACORE DS    CL40
UNIT1    DS    CL50
         ORG   UNIT1
UNITCODE DS    CL6
DSNPARM  DS    CL44
         ORG   UNIT1+50
UNIT2    DS    CL7
UNIT3    DS    CL14
UNIT4    DS    CL12
         ORG   UNIT4
@NM00003 DS    CL6
CATVSER  DS    CL6
         ORG   UNIT4+12
CJUSTALC DS    BL1
CATSUNAL DS    BL1
OK2OPEN  DS    BL1
CTGOPEND DS    BL1
ALOCOPEN DS    BL1
CVOLSW   DS    BL1
CATALCTD DS    BL1
         DS    CL2
S99RB    DS    CL20
         ORG   S99RB
S99RBLN  DS    CL1
S99VERB  DS    CL1
S99FLAG1 DS    CL2
         ORG   S99FLAG1
S99FLG11 DS    CL1
         ORG   S99FLG11
S99ONCNV DS    BL1
S99NOCNV EQU   S99FLG11+0
S99NOMNT EQU   S99FLG11+0
S99JBSYS EQU   S99FLG11+0
         ORG   S99FLAG1+1
S99FLG12 DS    CL1
         ORG   S99RB+4
S99RSC   DS    CL4
         ORG   S99RSC
S99ERROR DS    CL2
S99INFO  DS    CL2
         ORG   S99RB+8
S99TXTPP DS    AL4
S99RSV01 DS    FL4
S99FLAG2 DS    CL4
         ORG   S99FLAG2
S99FLG21 DS    CL1
         ORG   S99FLG21
S99WTVOL DS    BL1
S99WTDSN EQU   S99FLG21+0
S99NORES EQU   S99FLG21+0
S99WTUNT EQU   S99FLG21+0
S99OFFLN EQU   S99FLG21+0
S99TIONQ EQU   S99FLG21+0
S99CATLG EQU   S99FLG21+0
S99MOUNT EQU   S99FLG21+0
         ORG   S99FLAG2+1
S99FLG22 DS    CL1
         ORG   S99FLG22
S99UDEVT DS    BL1
S99PCINT EQU   S99FLG22+0
         ORG   S99FLAG2+2
S99FLG23 DS    CL1
S99FLG24 DS    CL1
         ORG   S99RB+20
UNITPTR  DS    AL4
         ORG   UNITPTR+0
LASTPTR  DS    BL1
         ORG   UNITPTR+16
IEFAB4F5 CSECT
         DS    0F
@SIZDATD DC    AL1(230)
         DC    AL3(@ENDDATD-@DATD)
@CV00167 DC    V(IDACAT11)
@CV00168 DC    V(IEFAB4EA)
@CV00169 DC    V(IEFAB4ED)
@CV00170 DC    V(IEFAB4EF)
@CV00171 DC    V(IEFAB4F4)
         DS    0D
@CC00148 DC    C'IEFAB4EA'
@CC00150 DC    C'ASWA'
@CB00134 DC    X'0214'
@CB00136 DC    X'0218'
@CB00138 DC    X'0220'
@CB00317 DC    X'0002'
@CB00321 DC    X'0004'
@CB00483 DC    X'0055'
@CB00499 DC    X'005D'
QNAME    DC    CL8'SYSZPCCB'
RNAME    DC    CL4'PCCB'
IEFAB4F5 CSECT
PCNQLIST ENQ (QNAME,RNAME,S,,SYSTEM),MF=L
NQLENGTH DC A(*-PCNQLIST)
@DATD    DSECT
NQCORE   ENQ (QNAME,RNAME,S,,SYSTEM),MF=L
IEFAB4F5 CSECT
ESTAELST ESTAE RECORD=YES,TERM=YES,MF=L
ESTAELEN DC A(*-ESTAELST)
@DATD    DSECT
ESTAECOR ESTAE RECORD=YES,TERM=YES,MF=L
IEFAB4F5 CSECT
         DS   0H
PATCHLOC DC ((@DATA-@PSTART)/20)X'00'
@DATD    DSECT
         ORG   *+1-(*-@DATD)/(*-@DATD) INSURE DSECT DATA
@ENDDATD EQU   *
IEFAB4F5 CSECT
@00      EQU   00                      EQUATES FOR REGISTERS 0-15
@01      EQU   01
@02      EQU   02
@03      EQU   03
@04      EQU   04
@05      EQU   05
@06      EQU   06
@07      EQU   07
@08      EQU   08
@09      EQU   09
@10      EQU   10
@11      EQU   11
@12      EQU   12
@13      EQU   13
@14      EQU   14
@15      EQU   15
TCBPTR   EQU   @08
ASWAPTR  EQU   @07
PCCBPTR  EQU   @02
EPRMLSTP EQU   @06
KEYSAVE  EQU   @04
REG0     EQU   @00
REG1     EQU   @01
REG2     EQU   @02
REG3     EQU   @03
PARAMREG EQU   @01
RTCDREG  EQU   @15
LOC16PTR EQU   16
TCBLISTP EQU   0
TWOTCBPS EQU   0
CURNTCBP EQU   TWOTCBPS+4
RETURNS  EQU   0
AB4EDPMS EQU   0
ASWA     EQU   0
ASWAID   EQU   ASWA
ASWACSCT EQU   ASWA+4
ASWARTNP EQU   ASWA+12
ASWAPRMS EQU   ASWA+16
ASWASCBP EQU   ASWA+20
ASWAFLGS EQU   ASWA+28
ASWADSWS EQU   ASWAFLGS
ASWANOCH EQU   ASWADSWS
ASWAAUTO EQU   ASWA+32
CTGDSN   EQU   0
DDNAME   EQU   0
EPARMLST EQU   0
EECNTRLS EQU   EPARMLST+400
EEUALCAT EQU   EECNTRLS
EECLACAT EQU   EECNTRLS
EEFAPCCB EQU   EECNTRLS
EEUCUCAT EQU   EECNTRLS
EECCUCAT EQU   EECNTRLS
EERAJSCP EQU   EECNTRLS
EEDYNAM  EQU   EECNTRLS
EEDNENQT EQU   EECNTRLS
ECJSCBP  EQU   EPARMLST+404
EAJSCBP  EQU   EPARMLST+408
EACBPTR  EQU   EPARMLST+412
EDDNAME  EQU   EPARMLST+416
ERETURNS EQU   EPARMLST+424
S99TUPL  EQU   0
S99TUPTR EQU   S99TUPL
S99TUP   EQU   0
S99TUNIT EQU   0
S99TUKEY EQU   S99TUNIT
S99TUNUM EQU   S99TUNIT+2
S99TUENT EQU   S99TUNIT+4
S99TULNG EQU   S99TUENT
S99TUPAR EQU   S99TUENT+2
S99TUFLD EQU   0
IEZJSCB  EQU   0
JSCBSEC1 EQU   IEZJSCB+188
JSCHPCE  EQU   JSCBSEC1+4
JSCBPCC  EQU   JSCBSEC1+16
JSCBDCB  EQU   JSCBSEC1+36
JSCBOPTS EQU   JSCBSEC1+48
JSCBSWT1 EQU   JSCBSEC1+55
JSCBWTP  EQU   JSCBSEC1+64
JSCBWTFG EQU   JSCBWTP
JSCBEND1 EQU   IEZJSCB+260
IEFPCCB  EQU   0
PCCNEXTP EQU   IEFPCCB+4
PCCSTATS EQU   IEFPCCB+12
PCCSTAT1 EQU   PCCSTATS
PCOSCVOL EQU   PCCSTAT1
PCCDDNAM EQU   IEFPCCB+20
PCCDSNAM EQU   IEFPCCB+28
PCCTGCON EQU   IEFPCCB+72
TCBFIX   EQU   0
TCBFRS   EQU   TCBFIX
TCB      EQU   0
TCBPIE   EQU   TCB+4
TCBPMASK EQU   TCBPIE
TCBCMP   EQU   TCB+16
TCBCMPF  EQU   TCBCMP
TCBCPP   EQU   TCBCMPF
TCBSTCC  EQU   TCBCMPF
TCBCDBL  EQU   TCBCMPF
TCBCWTO  EQU   TCBCMPF
TCBCIND  EQU   TCBCMPF
TCBCMSG  EQU   TCBCMPF
TCBTRN   EQU   TCB+20
TCBABF   EQU   TCBTRN
TCBMSS   EQU   TCB+24
TCBPKF   EQU   TCB+28
TCBFLGS  EQU   TCB+29
TCBFLGS1 EQU   TCBFLGS
TCBFLGS2 EQU   TCBFLGS+1
TCBFLGS3 EQU   TCBFLGS+2
TCBFLGS4 EQU   TCBFLGS+3
TCBFLGS5 EQU   TCBFLGS+4
TCBABWF  EQU   TCBFLGS5
TCBJPQ   EQU   TCB+44
TCBPURGE EQU   TCBJPQ
TCBGRS   EQU   TCB+48
TCBFSA   EQU   TCB+112
TCBTME   EQU   TCB+120
TCBJSTCB EQU   TCB+124
TCBTSFLG EQU   TCB+148
TCBTSTSK EQU   TCBTSFLG
TCBSTAB  EQU   TCB+160
TCBNSTAE EQU   TCBSTAB
TCBSTABB EQU   TCBSTAB+1
TCBTCT   EQU   TCB+164
TCBTCTGF EQU   TCBTCT
TCBSCNDY EQU   TCB+172
TCBNDSP  EQU   TCBSCNDY
TCBNDSP1 EQU   TCBNDSP+1
TCBNDSP2 EQU   TCBNDSP+2
TCBNDSP3 EQU   TCBNDSP+3
TCBJSCB  EQU   TCB+180
TCBRECDE EQU   TCBJSCB
TCBEXT1  EQU   TCB+196
TCBBITS  EQU   TCB+200
TCBNDSP4 EQU   TCBBITS
TCBNDSP5 EQU   TCBBITS+1
TCBFLGS6 EQU   TCBBITS+2
TCBFLGS7 EQU   TCBBITS+3
TCBDAR   EQU   TCB+204
TCBDARC  EQU   TCBDAR
TCBEXT2  EQU   TCB+208
TCBFOE   EQU   TCB+244
TCBESTAE EQU   TCB+264
TCBESTRM EQU   TCBESTAE+1
TCBFBYT1 EQU   TCB+276
TCBFBYT2 EQU   TCB+277
TCBRV124 EQU   TCB+278
TCBRV133 EQU   TCB+279
TCBXTNT2 EQU   0
TCBGTF   EQU   TCBXTNT2
TCBTFLG  EQU   TCBGTF
TCBRV146 EQU   TCBXTNT2+28
TCBRV155 EQU   TCBXTNT2+29
TCBRV164 EQU   TCBXTNT2+30
TCBRV173 EQU   TCBXTNT2+31
CTGCON   EQU   0
ACCNTRLS EQU   0
ACNODD   EQU   ACCNTRLS
ACDVWAIT EQU   ACCNTRLS
ACRECOVR EQU   ACCNTRLS
ACOSCVOL EQU   ACCNTRLS
ACVLWAIT EQU   ACCNTRLS
ACOFLINE EQU   ACCNTRLS
ACNOENQ  EQU   ACCNTRLS
ACNUJSCB EQU   ACCNTRLS
ACOK2MNT EQU   ACCNTRLS+1
ACSTPCAT EQU   ACCNTRLS+1
ACALCTLG EQU   ACCNTRLS+1
ACOPNACB EQU   ACCNTRLS+1
ACCCPCCB EQU   ACCNTRLS+1
ACRECOVD EQU   ACCNTRLS+1
RTNINFOP EQU   0
JSCBPTR  EQU   0
CTGDSNP  EQU   0
CTGCONP  EQU   0
DDNAMP   EQU   0
JSCBSEC2 EQU   JSCBEND1
JSCBSEC3 EQU   JSCBEND1
JSCBJCT  EQU   JSCBSEC3
JSCBJCTA EQU   JSCBJCT+1
JSCBASID EQU   JSCBSEC3+8
JSCBFBYT EQU   JSCBSEC3+10
JSCBJNL  EQU   JSCBSEC3+28
JSCBJJSB EQU   JSCBJNL
JSCBSUB  EQU   JSCBSEC3+40
JSCSCT   EQU   JSCBSEC3+68
JSCBACT  EQU   JSCBSEC3+88
JSCRSV45 EQU   JSCBSEC3+112
JSCRSV46 EQU   JSCRSV45
JSCRSV47 EQU   JSCRSV45+2
         AGO   .@UNREFD                START UNREFERENCED COMPONENTS
JSCBEND3 EQU   JSCBSEC3+120
JSCRSV52 EQU   JSCBSEC3+116
JSCRSV51 EQU   JSCRSV47+1
JSCRSV50 EQU   JSCRSV47
JSCRSV49 EQU   JSCRSV46+1
JSCRSV48 EQU   JSCRSV46
JSCRSV44 EQU   JSCBSEC3+108
JSCRSV43 EQU   JSCBSEC3+104
JSCRSV42 EQU   JSCBSEC3+100
JSCBASWA EQU   JSCBSEC3+96
JSCBUFPT EQU   JSCBSEC3+92
JSCBSWSP EQU   JSCBSEC3+87
JSCRSV33 EQU   JSCBSEC3+86
JSCDDNUM EQU   JSCBSEC3+84
JSCRSV53 EQU   JSCBSEC3+82
JSCDDNNO EQU   JSCBSEC3+80
JSCBVATA EQU   JSCBSEC3+76
JSCTMCOR EQU   JSCBSEC3+72
JSCSCTP  EQU   JSCSCT+1
JSCRSV55 EQU   JSCSCT
JSCRSV54 EQU   JSCBSEC3+64
JSCDSABQ EQU   JSCBSEC3+60
JSCBSSIB EQU   JSCBSEC3+56
JSCBFRBA EQU   JSCBSEC3+48
JSCRSV28 EQU   JSCBSEC3+46
JSCBSONO EQU   JSCBSEC3+44
JSCBSUBA EQU   JSCBSUB+1
JSCRSV31 EQU   JSCBSUB
JSCBSMLR EQU   JSCBSEC3+36
JSCBJNLR EQU   JSCBSEC3+32
JSCBJNLA EQU   JSCBJNL+1
JSCBJSBT EQU   JSCBJJSB
JSCBJSBX EQU   JSCBJJSB
JSCBJSBA EQU   JSCBJJSB
JSCBJSBI EQU   JSCBJJSB
@NM00013 EQU   JSCBJJSB
JSCBJNLE EQU   JSCBJJSB
JSCBJNLF EQU   JSCBJJSB
JSCBJNLN EQU   JSCBJJSB
@NM00012 EQU   JSCBSEC3+24
JSCBJRBA EQU   JSCBSEC3+16
JSCBIECB EQU   JSCBSEC3+12
JSCBRV08 EQU   JSCBSEC3+11
JSCBRV07 EQU   JSCBFBYT
JSCBRV06 EQU   JSCBFBYT
JSCBRV05 EQU   JSCBFBYT
JSCBRV04 EQU   JSCBFBYT
JSCBRV03 EQU   JSCBFBYT
JSCBRV02 EQU   JSCBFBYT
JSCBADSP EQU   JSCBFBYT
JSCBRV01 EQU   JSCBFBYT
JSCBTJID EQU   JSCBASID
JSCBPSCB EQU   JSCBSEC3+4
JSCJCTP  EQU   JSCBJCTA
JSCRSV24 EQU   JSCBJCT
JSCBEND2 EQU   JSCBSEC2
@NM00004 EQU   ACCNTRLS+1
@NM00018 EQU   TCBXTNT2+32
TCBRV181 EQU   TCBRV173
TCBRV180 EQU   TCBRV173
TCBRV179 EQU   TCBRV173
TCBRV178 EQU   TCBRV173
TCBRV177 EQU   TCBRV173
TCBRV176 EQU   TCBRV173
TCBRV175 EQU   TCBRV173
TCBRV174 EQU   TCBRV173
TCBRV172 EQU   TCBRV164
TCBRV171 EQU   TCBRV164
TCBRV170 EQU   TCBRV164
TCBRV169 EQU   TCBRV164
TCBRV168 EQU   TCBRV164
TCBRV167 EQU   TCBRV164
TCBRV166 EQU   TCBRV164
TCBRV165 EQU   TCBRV164
TCBRV163 EQU   TCBRV155
TCBRV162 EQU   TCBRV155
TCBRV161 EQU   TCBRV155
TCBRV160 EQU   TCBRV155
TCBRV159 EQU   TCBRV155
TCBRV158 EQU   TCBRV155
TCBRV157 EQU   TCBRV155
TCBRV156 EQU   TCBRV155
TCBRV154 EQU   TCBRV146
TCBRV153 EQU   TCBRV146
TCBRV152 EQU   TCBRV146
TCBRV151 EQU   TCBRV146
TCBRV150 EQU   TCBRV146
TCBRV149 EQU   TCBRV146
TCBRV148 EQU   TCBRV146
TCBRV147 EQU   TCBRV146
TCBRV145 EQU   TCBXTNT2+26
TCBRV144 EQU   TCBXTNT2+24
TCBCAUF  EQU   TCBXTNT2+20
TCBRV142 EQU   TCBXTNT2+16
TCBRSV49 EQU   TCBXTNT2+12
TCBEVENT EQU   TCBXTNT2+8
TCBRCMP  EQU   TCBXTNT2+5
TCBRSVAB EQU   TCBXTNT2+4
TCBGTFA  EQU   TCBGTF+1
TCBRSV47 EQU   TCBTFLG
TCBRSV46 EQU   TCBTFLG
TCBRSV45 EQU   TCBTFLG
TCBRSV44 EQU   TCBTFLG
TCBRSV43 EQU   TCBTFLG
TCBDSPIT EQU   TCBTFLG
TCBERRTN EQU   TCBTFLG
TCBASYNC EQU   TCBTFLG
@NM00017 EQU   TCB+296
TCBSVCA2 EQU   TCB+292
TCBSWASA EQU   TCB+288
TCBDBTB  EQU   TCB+284
TCBRPT   EQU   TCB+280
TCBRV141 EQU   TCBRV133
TCBRV140 EQU   TCBRV133
TCBRV139 EQU   TCBRV133
TCBRV138 EQU   TCBRV133
TCBRV137 EQU   TCBRV133
TCBRV136 EQU   TCBRV133
TCBRV135 EQU   TCBRV133
TCBRV134 EQU   TCBRV133
TCBRV132 EQU   TCBRV124
TCBRV131 EQU   TCBRV124
TCBRV130 EQU   TCBRV124
TCBRV129 EQU   TCBRV124
TCBRV128 EQU   TCBRV124
TCBRV127 EQU   TCBRV124
TCBRV126 EQU   TCBRV124
TCBRV125 EQU   TCBRV124
TCBRV123 EQU   TCBFBYT2
TCBRV122 EQU   TCBFBYT2
TCBECBNV EQU   TCBFBYT2
TCBSSSYN EQU   TCBFBYT2
TCBFPRAP EQU   TCBFBYT2
TCBFDW   EQU   TCBFBYT2
TCBFMW   EQU   TCBFBYT2
TCBCNCB  EQU   TCBFBYT2
TCBLLH   EQU   TCBFBYT1
TCBRV113 EQU   TCBFBYT1
TCBEOT   EQU   TCBFBYT1
TCBRTM2  EQU   TCBFBYT1
TCBPGNLY EQU   TCBFBYT1
TCBNDIOS EQU   TCBFBYT1
TCBACTIV EQU   TCBFBYT1
TCBEOTFM EQU   TCBFBYT1
TCBAFFN  EQU   TCB+274
TCBCCPVI EQU   TCB+272
TCBUKYSP EQU   TCB+268
TCBMODE  EQU   TCBESTAE+3
TCBERTYP EQU   TCBESTAE+2
TCBRV314 EQU   TCBESTRM
TCBRV313 EQU   TCBESTRM
TCBRV312 EQU   TCBESTRM
TCBRV311 EQU   TCBESTRM
TCBRV310 EQU   TCBESTRM
TCBRV309 EQU   TCBESTRM
TCBRV308 EQU   TCBESTRM
TCBETERM EQU   TCBESTRM
TCBSCBKY EQU   TCBESTAE
TCBRTM12 EQU   TCB+260
TCBTCBID EQU   TCB+256
TCBRSV96 EQU   TCB+252
TCBSWA   EQU   TCB+248
TCBFOEA  EQU   TCBFOE+1
TCBRSV42 EQU   TCBFOE
TCBRV306 EQU   TCB+240
TCBRSV41 EQU   TCB+239
TCBTID   EQU   TCB+238
TCBRSVAA EQU   TCB+237
TCBABCUR EQU   TCB+236
TCBTMSAV EQU   TCB+232
TCBIOTIM EQU   TCB+228
TCBRTWA  EQU   TCB+224
TCBBACK  EQU   TCB+220
TCBTIRB  EQU   TCB+216
TCBAECB  EQU   TCB+212
TCBEXT2A EQU   TCBEXT2+1
TCBRSV39 EQU   TCBEXT2
TCBSTMCT EQU   TCB+207
TCBSYSCT EQU   TCB+206
TCBRSV37 EQU   TCB+205
TCBEXSVC EQU   TCBDAR
TCBDARMS EQU   TCBDAR
TCBDARWT EQU   TCBDAR
TCBDARO  EQU   TCBDAR
TCBDARMC EQU   TCBDARC
TCBDARD  EQU   TCBDAR
TCBDARS  EQU   TCBDAR
TCBDARP  EQU   TCBDAR
TCBGTOFM EQU   TCBFLGS7
TCBADMP  EQU   TCBFLGS7
TCBRSTSK EQU   TCBFLGS7
TCBSVCS  EQU   TCBFLGS7
TCBSTACK EQU   TCBFLGS7
TCBRSV34 EQU   TCBFLGS7
TCBRSV33 EQU   TCBFLGS7
TCBGPECB EQU   TCBFLGS7
TCBNTJS  EQU   TCBFLGS6
TCBAPG   EQU   TCBFLGS6
TCBMIGR  EQU   TCBFLGS6
TCBRV303 EQU   TCBFLGS6
TCBSPVLK EQU   TCBFLGS6
TCBCPU   EQU   TCBFLGS6
TCBPIE17 EQU   TCBFLGS6
TCBRV    EQU   TCBFLGS6
TCBRSV79 EQU   TCBNDSP5
TCBRSV78 EQU   TCBNDSP5
TCBRSV77 EQU   TCBNDSP5
TCBRSV76 EQU   TCBNDSP5
TCBRSV75 EQU   TCBNDSP5
TCBRSV74 EQU   TCBNDSP5
TCBRSV95 EQU   TCBNDSP5
TCBRSV94 EQU   TCBNDSP5
TCBRSV93 EQU   TCBNDSP4
TCBRSV92 EQU   TCBNDSP4
TCBRSV91 EQU   TCBNDSP4
TCBRSV90 EQU   TCBNDSP4
TCBRSV89 EQU   TCBNDSP4
TCBRSV88 EQU   TCBNDSP4
TCBRSV87 EQU   TCBNDSP4
TCBRSV86 EQU   TCBNDSP4
TCBEXT1A EQU   TCBEXT1+1
TCBRSV32 EQU   TCBEXT1
TCBEXCPD EQU   TCB+192
TCBIOBRC EQU   TCB+188
TCBDDWTC EQU   TCB+186
TCBDDEXC EQU   TCB+184
TCBJSCBB EQU   TCBJSCB+1
@NM00016 EQU   TCBRECDE
TCBREC   EQU   TCBRECDE
TCBMDIDS EQU   TCB+176
TCBNDINT EQU   TCBNDSP3
TCBRSV27 EQU   TCBNDSP3
TCBRSV26 EQU   TCBNDSP3
TCBRSV25 EQU   TCBNDSP3
TCBRSV24 EQU   TCBNDSP3
TCBSRBND EQU   TCBNDSP3
TCBRV302 EQU   TCBNDSP3
TCBLJSND EQU   TCBNDSP3
TCBABE   EQU   TCBNDSP2
TCBDSS   EQU   TCBNDSP2
TCBOWAIT EQU   TCBNDSP2
TCBIWAIT EQU   TCBNDSP2
TCBNDTS  EQU   TCBNDSP2
TCBNDSVC EQU   TCBNDSP2
TCBSTPP  EQU   TCBNDSP2
TCBABD   EQU   TCBNDSP2
TCBRSV22 EQU   TCBNDSP1
TCBPIEND EQU   TCBNDSP1
TCBTPSP  EQU   TCBNDSP1
TCBDDRND EQU   TCBNDSP1
TCBRSPND EQU   TCBNDSP1
TCBRSTND EQU   TCBNDSP1
TCBDARPN EQU   TCBNDSP1
TCBDARTN EQU   TCBNDSP1
TCBNDSP0 EQU   TCBNDSP
TCBUSER  EQU   TCB+168
TCBTCTB  EQU   TCBTCT+1
TCBRSV9C EQU   TCBTCTGF
TCBRSV9B EQU   TCBTCTGF
TCBRSV9A EQU   TCBTCTGF
TCBRSV99 EQU   TCBTCTGF
TCBRSV98 EQU   TCBTCTGF
TCBRSV97 EQU   TCBTCTGF
TCBRSV20 EQU   TCBTCTGF
TCBSMFGF EQU   TCBTCTGF
TCBSTCUR EQU   TCBNSTAE
TCBRV301 EQU   TCBNSTAE
TCBSYNCH EQU   TCBNSTAE
TCBHALT  EQU   TCBNSTAE
TCBPPSUP EQU   TCBNSTAE
TCB33E   EQU   TCBNSTAE
TCBQUIES EQU   TCBNSTAE
TCBSTABE EQU   TCBNSTAE
TCBAQE   EQU   TCB+156
TCBPQE   EQU   TCB+152
TCBTSDP  EQU   TCB+151
TCBTSLP  EQU   TCB+150
TCBSTPCT EQU   TCB+149
TCBCPUBN EQU   TCBTSFLG
TCBDYDSP EQU   TCBTSFLG
TCBRSV18 EQU   TCBTSFLG
TCBRSV17 EQU   TCBTSFLG
TCBTIOTG EQU   TCBTSFLG
TCBATT   EQU   TCBTSFLG
TCBSTPPR EQU   TCBTSFLG
TCBRV300 EQU   TCBTSTSK
TCBECB   EQU   TCB+144
TCBIQE   EQU   TCB+140
TCBLTC   EQU   TCB+136
TCBOTC   EQU   TCB+132
TCBNTC   EQU   TCB+128
TCBJSTCA EQU   TCBJSTCB+1
TCBRSV16 EQU   TCBJSTCB
TCBTQET  EQU   TCBTME
TCBTCB   EQU   TCB+116
TCBFSAB  EQU   TCBFSA+1
TCBQEL   EQU   TCBFSA
TCBGRS15 EQU   TCBGRS+60
TCBGRS14 EQU   TCBGRS+56
TCBGRS13 EQU   TCBGRS+52
TCBGRS12 EQU   TCBGRS+48
TCBGRS11 EQU   TCBGRS+44
TCBGRS10 EQU   TCBGRS+40
TCBGRS9  EQU   TCBGRS+36
TCBGRS8  EQU   TCBGRS+32
TCBGRS7  EQU   TCBGRS+28
TCBGRS6  EQU   TCBGRS+24
TCBGRS5  EQU   TCBGRS+20
TCBGRS4  EQU   TCBGRS+16
TCBGRS3  EQU   TCBGRS+12
TCBGRS2  EQU   TCBGRS+8
TCBGRS1  EQU   TCBGRS+4
TCBGRS0  EQU   TCBGRS
TCBJPQB  EQU   TCBJPQ+1
TCBRSV15 EQU   TCBPURGE
TCBRSV14 EQU   TCBPURGE
TCBRSV13 EQU   TCBPURGE
TCBRSV12 EQU   TCBPURGE
TCBRSV11 EQU   TCBPURGE
TCBRSV10 EQU   TCBPURGE
TCBRSV09 EQU   TCBPURGE
TCBJPQF  EQU   TCBPURGE
TCBJLB   EQU   TCB+40
TCBLLS   EQU   TCB+36
TCBDSP   EQU   TCB+35
TCBLMP   EQU   TCB+34
TCBPNDSP EQU   TCBFLGS5
TCBFCD1  EQU   TCBFLGS5
TCBSTP   EQU   TCBFLGS5
TCBSYS   EQU   TCBFLGS5
TCBANDSP EQU   TCBFLGS5
TCBPAGE  EQU   TCBFLGS5
TCBUXNDF EQU   TCBABWF
TCBFC    EQU   TCBFLGS5
TCBONDSP EQU   TCBFLGS4
TCBMPCND EQU   TCBFLGS4
TCBMPCVQ EQU   TCBFLGS4
TCBUXNDV EQU   TCBFLGS4
TCBHNDSP EQU   TCBFLGS4
TCBRQENA EQU   TCBFLGS4
TCBSER   EQU   TCBFLGS4
TCBNDUMP EQU   TCBFLGS4
TCBDWSTA EQU   TCBFLGS3
TCBRSV08 EQU   TCBFLGS3
TCBRSV07 EQU   TCBFLGS3
TCBRSV06 EQU   TCBFLGS3
TCBABGM  EQU   TCBFLGS3
TCBABTRM EQU   TCBFLGS3
TCBADINP EQU   TCBFLGS3
TCBFSM   EQU   TCBFLGS3
TCBFTS   EQU   TCBFLGS2
TCBFETXR EQU   TCBFLGS2
TCBFDSOP EQU   TCBFLGS2
TCBFJMC  EQU   TCBFLGS2
TCBFSMC  EQU   TCBFLGS2
TCBFABOP EQU   TCBFLGS2
TCBFSTI  EQU   TCBFLGS2
TCBFOINP EQU   TCBFLGS2
TCBFX    EQU   TCBFLGS1
TCBFS    EQU   TCBFLGS1
TCBFT    EQU   TCBFLGS1
TCBPDUMP EQU   TCBFLGS1
TCBNONPR EQU   TCBFLGS1
TCBFERA  EQU   TCBFLGS1
TCBFE    EQU   TCBFLGS1
TCBFA    EQU   TCBFLGS1
TCBZERO  EQU   TCBPKF
TCBFLAG  EQU   TCBPKF
TCBMSSB  EQU   TCBMSS+1
TCBRSV03 EQU   TCBMSS
TCBTRNB  EQU   TCBTRN+1
TCBRSV02 EQU   TCBABF
TCBOLTEP EQU   TCBABF
TCBTCP   EQU   TCBABF
TCBTCPP  EQU   TCBABF
TCBRSV01 EQU   TCBABF
TCBGRPH  EQU   TCBABF
TCBNOCHK EQU   TCBABF
TCBMOD91 EQU   TCBABF
TCBCMPC  EQU   TCBCMP+1
TCBRV318 EQU   TCBCMSG
TCBRV317 EQU   TCBCIND
TCBRV316 EQU   TCBCWTO
TCBCASID EQU   TCBCDBL
TCBNOCC  EQU   TCBSTCC
TCBDMPO  EQU   TCBCPP
TCBCSTEP EQU   TCBCMPF
TCBCREQ  EQU   TCBCMPF
TCBTIO   EQU   TCB+12
TCBDEB   EQU   TCB+8
TCBPIEA  EQU   TCBPIE+1
TCBPM    EQU   TCBPMASK
@NM00015 EQU   TCBPMASK
TCBRBP   EQU   TCB
TCBFRS6  EQU   TCBFRS+24
TCBFRS4  EQU   TCBFRS+16
TCBFRS2  EQU   TCBFRS+8
TCBFRS0  EQU   TCBFRS
PCCRSVD2 EQU   IEFPCCB+128
PCCLACBP EQU   IEFPCCB+124
PCCRSVD1 EQU   IEFPCCB+122
PCVOLSER EQU   IEFPCCB+116
PCCACBP  EQU   IEFPCCB+16
PCCSTAT4 EQU   PCCSTATS+3
PCCSTAT3 EQU   PCCSTATS+2
PCCSTAT2 EQU   PCCSTATS+1
@NM00014 EQU   PCCSTAT1
PCCTCL   EQU   PCCSTAT1
PCCACTIV EQU   PCCSTAT1
PCCALIAS EQU   PCCSTAT1
PCCSTEPC EQU   PCCSTAT1
PCCPREVP EQU   IEFPCCB+8
PCCACRO  EQU   IEFPCCB
JSCBCSCB EQU   JSCBSEC1+68
JSCBPMG  EQU   JSCBWTP+2
JSCBWTSP EQU   JSCBWTP+1
JSCRSV23 EQU   JSCBWTFG
JSCRSV22 EQU   JSCBWTFG
JSCRSV21 EQU   JSCBWTFG
JSCRSV20 EQU   JSCBWTFG
JSCRSV19 EQU   JSCBWTFG
JSCRSV18 EQU   JSCBWTFG
JSCBRET  EQU   JSCBWTFG
JSCBIOFG EQU   JSCBWTFG
@NM00011 EQU   JSCBSEC1+60
JSCBQMPI EQU   JSCBSEC1+56
JSCBPMSG EQU   JSCBSWT1
JSCRSV16 EQU   JSCBSWT1
JSCRSV15 EQU   JSCBSWT1
JSCRSV14 EQU   JSCBSWT1
JSCRSV13 EQU   JSCBSWT1
JSCRSV12 EQU   JSCBSWT1
JSCRSV11 EQU   JSCBSWT1
JSCBPASS EQU   JSCBSWT1
JSCBTTTR EQU   JSCBSEC1+52
JSCRSV10 EQU   JSCBSEC1+49
JSCBAUTH EQU   JSCBOPTS
JSCSIOTS EQU   JSCBOPTS
JSCRSV08 EQU   JSCBOPTS
JSCRSV07 EQU   JSCBOPTS
JSCRSV06 EQU   JSCBOPTS
JSCBLONG EQU   JSCBOPTS
JSCRSV05 EQU   JSCBOPTS
JSCRSV04 EQU   JSCBOPTS
JSCBSECB EQU   JSCBSEC1+44
JSCRSV03 EQU   JSCBSEC1+41
JSCBSTEP EQU   JSCBSEC1+40
JSCBDCBA EQU   JSCBDCB+1
JSCRSV02 EQU   JSCBDCB
JSCBID   EQU   JSCBSEC1+32
JSCBDBTB EQU   JSCBSEC1+28
JSCBIJSC EQU   JSCBSEC1+24
JSCBTCBP EQU   JSCBSEC1+20
JSCBTCP  EQU   JSCBSEC1+12
JSCBSHR  EQU   JSCBSEC1+8
JSCHPCEA EQU   JSCHPCE+1
JSCRSV32 EQU   JSCHPCE
JSCRSV01 EQU   JSCBSEC1
@NM00010 EQU   IEZJSCB
S99TUPRM EQU   S99TUFLD+2
S99TULEN EQU   S99TUFLD
S99TUPND EQU   S99TUP
S99TUPLN EQU   S99TUPTR
ETCBP    EQU   EPARMLST+432
EEINTIOT EQU   EPARMLST+428
ERESCD   EQU   ERETURNS+2
ERETCD   EQU   ERETURNS
@NM00008 EQU   EECNTRLS+1
@NM00007 EQU   EECNTRLS+1
EENOUNCT EQU   EECNTRLS+1
EESWTIOT EQU   EECNTRLS+1
@NM00006 EQU   EPARMLST
ASWACHNP EQU   ASWA+36
ASWRSV02 EQU   ASWAFLGS+1
ASWRSV01 EQU   ASWADSWS
ASWADYUE EQU   ASWADSWS
ASWAVMVF EQU   ASWADSWS
ASWACOMF EQU   ASWADSWS
ASWADYNF EQU   ASWADSWS
ASWAOLDP EQU   ASWA+24
RESCD    EQU   RETURNS+2
RETCD    EQU   RETURNS
NEXTTCBP EQU   TWOTCBPS
.@UNREFD ANOP                          END UNREFERENCED COMPONENTS
@RF00299 EQU   @RC00291
@ENDDATA EQU   *
         END   IEFAB4F5,(C'PLS2117',0701,78089)
