         TITLE 'IEFDB460 - DECONCATENATION ROUTINE                     *
                        '
IEFDB460 CSECT ,                                                01S0001
@MAINENT DS    0H                                               01S0001
         USING *,@15                                            01S0001
         B     @PROLOG                                          01S0001
         DC    AL1(16)                                          01S0001
         DC    C'IEFDB460  75.024'                              01S0001
         DROP  @15
@PROLOG  STM   @14,@12,12(@13)                                  01S0001
         BALR  @12,0                                            01S0001
@PSTART  DS    0H                                               01S0001
         USING @PSTART,@12                                      01S0001
         L     @00,@SIZDATD                                     01S0001
         GSPACE   R,LV=(0)
         LR    @11,@01                                          01S0001
         USING @DATD,@11                                        01S0001
         ST    @13,@SA00001+4                                   01S0001
         LM    @00,@01,20(@13)                                  01S0001
         ST    @11,8(,@13)                                      01S0001
         LR    @13,@11                                          01S0001
         MVC   @PC00001(28),0(@01)                              01S0001
JSCBDISP EQU 188
JSCBAOS1 EQU  72
JSCBAOS2 EQU 192
*RETINFO = ZERO;                       /* ZERO RETURN AREA           */
         SLR   @10,@10                                          01S0045
         L     @03,@PC00001+4                                   01S0045
         STCM  @10,15,RETINFO(@03)                              01S0045
*/********************************************************************/
*/*                                                                  */
*/* SEGMENT NAME - SYNCK460                                          */
*/*                                                                  */
*/* DESCRIPTIVE NAME - SYNTAX CHECKER FOR DECONCAT                   */
*/*                                                                  */
*/* FUNCTION - DETERMINE IF THE INPUT TEXT CONTAINS A VALID REQUEST  */
*/*            FOR DECONCATENATION.                                  */
*/*                                                                  */
*/* OPERATION - IEFDB4FF IS INVOKED TO CHECK TEXT UNIT SYNTAX.       */
*/*             IF VALID, THE TEXT IS CHECKED TO DETERMINE IF        */
*/*             THE REQUIRED KEY IS PRESENT, IF THE DDNAME IS        */
*/*             BLANK, OR IF A RESERVED DDNAME HAS BEEN SPECIFIED.   */
*/*             IF ANY OF THE ABOVE ERRORS ARE FOUND(OR THE          */
*/*             TEXT WAS INVALID) AN ERROR CODE IS SET(SEE           */
*/*             RETURN CODE).  IF NO ERROR IS FOUND, ERRCODE         */
*/*             REMAINS ZERO(0).                                     */
*/*                                                                  */
*/* ENTRY - SYNCK460(INCLUDED SEGMENT)                               */
*/*                                                                  */
*/*  PURPOSE - SEE FUNCTION                                          */
*/*                                                                  */
*/*  INPUT - TEXT UNIT PTRS - POINTER TO TEXT UNITS                  */
*/*                                                                  */
*/* EXITS - ALL ARE TO NEXT SEQUENTIAL INSTRUCTION                   */
*/*  NORMAL - SYNTAX IS GOOD                                         */
*/*                                                                  */
*/*   RETURN CODE - ERRCODE = ZERO(0)                                */
*/*                                                                  */
*/*  ERROR - TEXT IS NOT VALID OR KEY IS MISSING                     */
*/*                                                                  */
*/*   RETURN CODE - ERROR CODE = ONE OF THE FOLLOWING HEX CODES      */
*/*                1. RCINPARM - BLANK DDNAME SPECIFIED              */
*/*                         '0001'X (FAILING KEY) STORED IN INFO CODE*/
*/*                2. RCINVKEY - INVALID KEY SPECIFIED IN TEXT       */
*/*                3. RCRSVDDN - JOBLIB/STEPLIB/JOBCAT/STEPCAT REQ   */
*/*                4. RCINNUMB - INVALID NUMBER OF KEY PARAMETERS    */
*/*                5. RCDUPKEY - DUPLICATE KEYS SPECIFIED IN TEXT    */
*/*                6. RCINKEYL - INVALID KEY PARAMETER LENGTH        */
*/*                7. RCKEYREQ - REQUIRED KEY NOT SPECIFIED          */
*/*                                                                  */
*/********************************************************************/
*RETAREA=ZERO;                         /* ZERO OUT RETURN AREA       */
         ST    @10,RETAREA                                      02S0046
*KEYMASK1=ZERO;                        /* INIT. DUPLICATE KEY MASK   */
         MVI   KEYMASK1,X'00'                                   02S0047
*KEYMASK2=ZERO;                        /* INIT. MUTUALLY EXCL. MASK  */
         MVI   KEYMASK2,X'00'                                   02S0048
*CALL IEFDB4FF (S99TXTPP,ADDR(KEYDICT),ADDR(KEYMASK1),ADDR(KEYMASK2),
*               ADDR(RETAREA),RETINFO);/* SYNTAX CHECK TEXT UNITS    */
         L     @10,@PC00001                                     02S0049
         ST    @10,@AL00001                                     02S0049
         LA    @10,KEYDICT                                      02S0049
         ST    @10,@TF00001                                     02S0049
         LA    @10,@TF00001                                     02S0049
         ST    @10,@AL00001+4                                   02S0049
         LA    @10,KEYMASK1                                     02S0049
         ST    @10,@TF00002                                     02S0049
         LA    @10,@TF00002                                     02S0049
         ST    @10,@AL00001+8                                   02S0049
         LA    @10,KEYMASK2                                     02S0049
         ST    @10,@TF00003                                     02S0049
         LA    @10,@TF00003                                     02S0049
         ST    @10,@AL00001+12                                  02S0049
         LA    @10,RETAREA                                      02S0049
         ST    @10,@TF00004                                     02S0049
         LA    @10,@TF00004                                     02S0049
         ST    @10,@AL00001+16                                  02S0049
         ST    @03,@AL00001+20                                  02S0049
         L     @15,@CV00077                                     02S0049
         LA    @01,@AL00001                                     02S0049
         BALR  @14,@15                                          02S0049
*IF ERRCODE=ZERO THEN                  /* VALID KEYS AND PARM LENGTHS*/
         SLR   @10,@10                                          02S0050
         L     @03,@PC00001+4                                   02S0050
         SLR   @15,@15                                          02S0050
         ICM   @15,3,ERRCODE(@03)                               02S0050
         CR    @10,@15                                          02S0050
         BNE   @RF00050                                         02S0050
*  IF RETAREA^=ZERO THEN               /* REQUIRED KEY SPECIFIED ?   */
         L     @03,RETAREA                                      02S0051
         CR    @03,@10                                          02S0051
         BE    @RF00051                                         02S0051
*    DO;                                                        02S0052
*      RESPECIFY TEXTUNIT BASED(RETAREA);                       02S0053
*      IF TEXTUPAR(1)^=BLANK THEN      /* DDNAME NON-BLANK?          */
         CLC   TEXTUPAR(1,@03),BLANK                            02S0054
         BE    @RF00054                                         02S0054
*        DO;                           /* CHECK FOR RESTRICTED DDNAME*/
*          DDNAME= '';                 /* BLANK OUT WORK DD-FIELD    */
         MVI   DDNAME,C' '                                      02S0056
         MVC   DDNAME+1(7),DDNAME                               02S0056
*          DDNAME(1:TEXTULNG)=TEXTUPAR(1:TEXTULNG);             02S0057
         ICM   @10,12,TEXTULNG(@03)                             02S0057
         SRA   @10,16                                           02S0057
         BCTR  @10,0                                            02S0057
         EX    @10,@SM01056                                     02S0057
*                                      /* USER DDNAME IN TEMP LOCAT'N*/
*          IF DDNAME=JOBCAT | DDNAME=JOBLIB                     02S0058
*            | DDNAME=STEPCAT | DDNAME=STEPLIB THEN             02S0058
         CLC   DDNAME(8),@CC00098                               02S0058
         BE    @RT00058                                         02S0058
         CLC   DDNAME(8),@CC00100                               02S0058
         BE    @RT00058                                         02S0058
         CLC   DDNAME(8),@CC00106                               02S0058
         BE    @RT00058                                         02S0058
         CLC   DDNAME(8),@CC00108                               02S0058
         BNE   @RF00058                                         02S0058
@RT00058 DS    0H                                               02S0059
*            ERRCODE = RCRSVDDN;       /* SET ERRCODE TO RCRSVDDN
*                                         (RESERVED DDNAME REQUEST)  */
         L     @10,@PC00001+4                                   02S0059
         MVC   ERRCODE(2,@10),@CB00829                          02S0059
*        END;                          /* END RESTRICTED NAME TEST   */
*      ELSE                            /* ELSE DDNAME IS BLANK       */
*        DO;                           /* INVALID PARM               */
         B     @RC00054                                         02S0061
@RF00054 DS    0H                                               02S0062
*          INFOCODE = DDCDDNAM;        /* FAILING KEY                */
         L     @10,@PC00001+4                                   02S0062
         MVC   INFOCODE(2,@10),@CB00083                         02S0062
*          ERRCODE = RCINPARM;         /* SET ERRCODE TO RCINPARM
*                                         (INVALID PARAMETER)        */
         MVC   ERRCODE(2,@10),@CB00825                          02S0063
*        END;                          /* END FAILING KEY PROCESSING */
*    END;                              /* END REQUIRED KEY TEST      */
*  ELSE                                /* REQUIRED KEY NOT FOUND     */
*    ERRCODE= RCKEYREQ;                /* ERROR, REQ. KEY NOT FOUND  */
         B     @RC00051                                         02S0066
@RF00051 L     @10,@PC00001+4                                   02S0066
         MVC   ERRCODE(2,@10),@CB00845                          02S0066
*ELSE;                                                          02S0067
@RF00050 DS    0H                                               02S0068
*IF ERRCODE=ZERO THEN                  /* NO SYNTAX ERRORS ?         */
@RC00050 SLR   @10,@10                                          01S0068
         L     @03,@PC00001+4                                   01S0068
         SLR   @15,@15                                          01S0068
         ICM   @15,3,ERRCODE(@03)                               01S0068
         CR    @10,@15                                          01S0068
         BNE   @RF00068                                         01S0068
*  DO;                                                          01S0069
*/********************************************************************/
*/*                                                                  */
*/* SEGMENT NAME - ENVIRNCK                                          */
*/*                                                                  */
*/* DESCRIPTIVE NAME - DECONCAT ENVIRONMENT CHECK                    */
*/*                                                                  */
*/* FUNCTION - DETERMINE IF THE DECONCATENATION REQUEST CAUSES AN    */
*/*            ERROR WITHIN THE TASK ENVIRONMENT                     */
*/*                                                                  */
*/* OPERATION - IEFDB4FC IS INVOKED TO SEARCH FOR THE SPECIFIED      */
*/*             DDNAME IN THE TIOT.  IF NOT FOUND, ERRCODE IS        */
*/*             SET TO RCDDNFND AND NO FURTHER PROCESSING IS DONE.   */
*/*             IF FOUND, A TEST IS MADE TO DETERMINE IF THE         */
*/*             DDNAME IS ASSOCIATED WITH ANY OPEN DATA SETS.        */
*/*             IF OPEN, ERRCODE IS SET TO RCOPENDS AND NO FURTHER   */
*/*             PROCESSING IS DONE.  IF THE DDNAME IS NOT            */
*/*             ASSOCIATED WITH ANY OPEN DATASETS, SIOTDDCK          */
*/*             (ANOTHER SEGMENT) IS INVOKED TO DETERMINE IF         */
*/*             DECONCATENATION WOULD CAUSE DUPLICATE NAMES IN THE   */
*/*             TIOT.  IF SO, ERRCODE IS SET TO RCDCONDD AND NO      */
*/*             FURTHER PROCESSING IS DONE.  IF NO ERROR IS FOUND,   */
*/*             ERRCODE REMAINS ZERO(0).                             */
*/*                                                                  */
*/* ENTRY - ENVIRNCK(INCLUDED SEGMENT)                               */
*/*                                                                  */
*/*   PURPOSE - SEE FUNCTION                                         */
*/*                                                                  */
*/* INPUT DATA - ADDRESS OF THE DSAB CHAIN AND THE SUPPLIED DDNAME   */
*/*                                                                  */
*/* EXITS - ALL ARE TO NEXT SEQUENTIAL INSTRUCTION                   */
*/*  NORMAL - SEARCH OF SIOTS AND TIOT SHOW NO DUPLICATE NAMES       */
*/*           WILL RESULT FROM DECONCATENATION                       */
*/*                                                                  */
*/*  RETURN CODE - ERRCODE REMAINS ZERO(0)                           */
*/*                                                                  */
*/*  ERROR - DDNAME NOT FOUND IN TIOT, DECONCATENATION WOULD         */
*/*          RESULT IN DUPLICATE DDNAMES IN TIOT OR DDNAME IS        */
*/*          ASSOCIATED WITH OPEN DATA SET                           */
*/*                                                                  */
*/*  RETURN CODE - ERRCODE = ONE OF THE FOLLOWING HEX CODES          */
*/*                RCOPENDS - DDNAME ASSOCIATED WITH AN OPEN         */
*/*                           DATA SET                               */
*/*                RCDCONDD - REQUEST WOULD RESULT IN DUPLICATE      */
*/*                           DDNAMES IN THE TIOT                    */
*/*                RCDDNFND - DDNAME NOT FOUND IN TIOT               */
*/*                                                                  */
*/********************************************************************/
*DDNRTRN = ZERO;                       /* ZERO RETURN ADDRESS AREA   */
         ST    @10,DDNRTRN                                      02S0070
*CALL IEFDB4FC (DSQFRSTP,ADDR(DDNAME),ADDR(DDNRTRN)); /* DDN SEARCH  */
         L     @10,@PC00001+8                                   02S0071
         L     @10,JSCBP(,@10)                                  02S0071
         L     @10,JSCDSABQ(,@10)                               02S0071
         LA    @10,DSQFRSTP(,@10)                               02S0071
         ST    @10,@AL00001                                     02S0071
         LA    @10,DDNAME                                       02S0071
         ST    @10,@TF00001                                     02S0071
         LA    @10,@TF00001                                     02S0071
         ST    @10,@AL00001+4                                   02S0071
         LA    @10,DDNRTRN                                      02S0071
         ST    @10,@TF00002                                     02S0071
         LA    @10,@TF00002                                     02S0071
         ST    @10,@AL00001+8                                   02S0071
         L     @15,@CV00076                                     02S0071
         LA    @01,@AL00001                                     02S0071
         BALR  @14,@15                                          02S0071
*IF DDNRTRN^=ZERO THEN                 /* DDNAME FOUND IN THE TIOT   */
         L     @10,DDNRTRN                                      02S0072
         SLR   @03,@03                                          02S0072
         CR    @10,@03                                          02S0072
         BE    @RF00072                                         02S0072
*  DO;                                 /* CHECK ENVIRONMENT          */
*    DSABPTR=DDNRTRN;                  /* ADDRESS CONCAT DDNAME DSAB */
         LR    DSABPTR,@10                                      02S0074
*    IF DSABOPCT=ZERO THEN             /* NO ASSOCIATED OPEN DATASETS*/
         CH    @03,DSABOPCT(,DSABPTR)                           02S0075
         BNE   @RF00075                                         02S0075
*      DO;                             /* CHECK SIOTS FOR DUPLICATES */
*        LOCATDDP= DSABPTR;            /* SAVE @ GROUP DDNAME DSAB   */
         LR    LOCATDDP,DSABPTR                                 02S0077
*/********************************************************************/
*/*                                                                  */
*/* SEGMENT NAME - SIOTDDCK                                          */
*/*                                                                  */
*/* DESCRIPTIVE NAME - DUPLICATE DDNAME CHECK                        */
*/*                                                                  */
*/* FUNCTION - FOR EACH MEMBER OF A CONCATENATED GROUP THAT REQUIRES */
*/*            RESTORATION OF A DDNAME FROM ITS SIOT TO THE TIOT,    */
*/*            DETERMINE IF THIS DDNAME-RESTORE WILL RESULT IN A     */
*/*            DUPLICATE DDNAME IN THE TIOT.                         */
*/*                                                                  */
*/* OPERATION - EACH NON-BLANK SIOT DDNAME(NON-PERMANENTLY CONCAT)   */
*/*             IS COMPARED TO ALL TIOT DDNAMES FOR THIS TASK TO     */
*/*             DETERMINE IF DECONCATENATION WOULD CAUSE DUPLICATE   */
*/*             DDNAMES IN THE TIOT ENTRIES.  IF SO, ERRCODE IS SET  */
*/*             TO RCDCONDD AND NO FURTHER PROCESSING IS DONE.  IF   */
*/*             THE SIOT DDNAME IS NOT FOUND IN ANY TIOT ENTRY, IT   */
*/*             IS COMPARED TO EVERY SIOT DDNAME IN THE CONCAT GROUP */
*/*             TO DETERMINE IF DECONCATENATION WOULD CAUSE          */
*/*             DUPLICATE DDNAMES.  IF SO, ERRCODE IS SET TO         */
*/*             RCDCONDD AND NO FURTHER PROCESSING IS DONE.          */
*/*                                                                  */
*/* ENTRY - SIOTDDCK(INCLUDED SEGMENT)                               */
*/*                                                                  */
*/*  PURPOSE - SEE FUNCTION                                          */
*/*                                                                  */
*/*  INPUT -                                                         */
*/*        - DSABPTR - DSAB ADDRESS OF DDNAME OF CONCAT GROUP        */
*/*                                                                  */
*/* EXITS - ALL ARE TO NEXT SEQUENTIAL INSTRUCTION                   */
*/*  NORMAL - NO DUPLICATE NAME CONDITION EXISTS                     */
*/*                                                                  */
*/*   RETURN CODE - ERRCODE REMAINS ZERO(0)                          */
*/*                                                                  */
*/*  ERROR - DUPLICATE NAMES WOULD RESULT IF DECONCATENATION         */
*/*          TOOK PLACE                                              */
*/*                                                                  */
*/*   RETURN CODE - ERRCODE = THE FOLLOWING HEX CODE                 */
*/*                 RCDCONDD - DECONCATENATION WOULD RESULT IN       */
*/*                            DUPLICATE DDNAMES                     */
*/*                                                                  */
*/********************************************************************/
*DSABPTR = DSABFCHN;                   /* GET 1ST BLANK DDN MEMBER   */
         L     DSABPTR,DSABFCHN(,DSABPTR)                       03S0078
*DO WHILE (DSABPTR ^= ZERO & ERRCODE = ZERO & TIOEDDNM(1) = BLANK);
         B     @DE00079                                         03S0079
@DL00079 DS    0H                                               03S0080
*                                      /* SEARCH LOOP CONTROL        */
*  IF SCTDDNAM(1) ^= BLANK THEN        /* PERM CONCAT MEMBER ?       */
         L     @10,DSABSIOT(,DSABPTR)                           03S0080
         CLC   SCTDDNAM(1,@10),BLANK                            03S0080
         BE    @RF00080                                         03S0080
*    DO;                               /* NO, CHECK SIOT DDNAME      */
*      DDNAME = SCTDDNAM;              /* GET DDNAME FOR TIOT SEARCH */
         MVC   DDNAME(8),SCTDDNAM(@10)                          03S0082
*      CALL IEFDB4FC(DSQFRSTP,ADDR(DDNAME),ADDR(DDNRTRN));      03S0083
         L     @10,@PC00001+8                                   03S0083
         L     @10,JSCBP(,@10)                                  03S0083
         L     @10,JSCDSABQ(,@10)                               03S0083
         LA    @10,DSQFRSTP(,@10)                               03S0083
         ST    @10,@AL00001                                     03S0083
         LA    @10,DDNAME                                       03S0083
         ST    @10,@TF00001                                     03S0083
         LA    @10,@TF00001                                     03S0083
         ST    @10,@AL00001+4                                   03S0083
         LA    @10,DDNRTRN                                      03S0083
         ST    @10,@TF00002                                     03S0083
         LA    @10,@TF00002                                     03S0083
         ST    @10,@AL00001+8                                   03S0083
         L     @15,@CV00076                                     03S0083
         LA    @01,@AL00001                                     03S0083
         BALR  @14,@15                                          03S0083
*                                      /* SEARCH FOR DUPLICATE DDNAME
*                                         IN TIOT                    */
*      IF DDNRTRN ^= ZERO THEN         /* WAS A DUPLICATE DDN FOUND ?*/
         L     @10,DDNRTRN                                      03S0084
         LTR   @10,@10                                          03S0084
         BZ    @RF00084                                         03S0084
*        ERRCODE = RCDCONDD;           /* YES, INDICATE DUPLICATE DDN*/
         L     @10,@PC00001+4                                   03S0085
         MVC   ERRCODE(2,@10),@CB00861                          03S0085
*      ELSE                            /* NO DUPLICATE FOUND         */
*        DO;                           /* SEARCH SIOTS FOR DUPE DDN  */
         B     @RC00084                                         03S0086
@RF00084 DS    0H                                               03S0087
*          FRSTDSAB = DSABPTR;         /* SAVE STARTING DSAB ADDRESS */
         LR    FRSTDSAB,DSABPTR                                 03S0087
*          DSABPTR = DSABFCHN;         /* GET NEXT DSAB ADDRESS      */
         L     DSABPTR,DSABFCHN(,DSABPTR)                       03S0088
*          DO WHILE (DSABPTR ^= ZERO & ERRCODE = ZERO           03S0089
*            & TIOEDDNM(1) = BLANK);   /* SIOT SEARCH CONTROL        */
         B     @DE00089                                         03S0089
@DL00089 DS    0H                                               03S0090
*            IF SCTDDNAM = DDNAME THEN /* SAME DDN IN ANOTHER SIOT ? */
         L     @10,DSABSIOT(,DSABPTR)                           03S0090
         CLC   SCTDDNAM(8,@10),DDNAME                           03S0090
         BNE   @RF00090                                         03S0090
*              ERRCODE = RCDCONDD;     /* YES, INDICATE DUPLICATE DDN*/
         L     @10,@PC00001+4                                   03S0091
         MVC   ERRCODE(2,@10),@CB00861                          03S0091
*            ELSE                      /* NO DUPLICATE FOUND YET     */
*              DSABPTR = DSABFCHN;     /* GET NEXT DSAB ADDRESS      */
         B     @RC00090                                         03S0092
@RF00090 L     DSABPTR,DSABFCHN(,DSABPTR)                       03S0092
*          END;                        /* END SIOT SEARCH CONTROL    */
@RC00090 DS    0H                                               03S0093
@DE00089 SLR   @10,@10                                          03S0093
         CR    DSABPTR,@10                                      03S0093
         BE    @DC00089                                         03S0093
         L     @05,@PC00001+4                                   03S0093
         SLR   @15,@15                                          03S0093
         ICM   @15,3,ERRCODE(@05)                               03S0093
         CR    @10,@15                                          03S0093
         BNE   @DC00089                                         03S0093
         L     @10,DSABTIOT(,DSABPTR)                           03S0093
         CLC   TIOEDDNM(1,@10),BLANK                            03S0093
         BE    @DL00089                                         03S0093
@DC00089 DS    0H                                               03S0094
*          DSABPTR = FRSTDSAB;         /* RESTORE STARTING DSAB ADDR */
         LR    DSABPTR,FRSTDSAB                                 03S0094
*        END;                          /* END SIOT SEARCH            */
*    END;                              /* END NON-PERM CONCAT PROCESS*/
@RC00084 DS    0H                                               03S0097
*  DSABPTR = DSABFCHN;                 /* GET NEXT DSAB ADDRESS TO
*                                         CONTINUE DUPLICATE DDN SRCH*/
@RF00080 L     DSABPTR,DSABFCHN(,DSABPTR)                       03S0097
*END;                                  /* END SEARCH LOOP CONTROL    */
@DE00079 SLR   @10,@10                                          03S0098
         CR    DSABPTR,@10                                      03S0098
         BE    @DC00079                                         03S0098
         L     @05,@PC00001+4                                   03S0098
         SLR   @03,@03                                          03S0098
         ICM   @03,3,ERRCODE(@05)                               03S0098
         CR    @10,@03                                          03S0098
         BNE   @DC00079                                         03S0098
         L     @10,DSABTIOT(,DSABPTR)                           03S0098
         CLC   TIOEDDNM(1,@10),BLANK                            03S0098
         BE    @DL00079                                         03S0098
@DC00079 DS    0H                                               03S0099
*        DSABPTR = LOCATDDP;           /* RESTORE @ GROUP DDNAME DSAB*/
         LR    DSABPTR,LOCATDDP                                 02S0099
*      END;                            /* END SEARCH FOR DUPLICATES  */
*    ELSE                              /* OPEN D.S. ASSOC. W/DDNAME  */
*      ERRCODE= RCOPENDS;              /* SET ERRCODE TO RCOPENDS    */
         B     @RC00075                                         02S0101
@RF00075 L     @10,@PC00001+4                                   02S0101
         MVC   ERRCODE(2,@10),@CB00859                          02S0101
*  END;                                                         02S0102
*ELSE                                  /* DDNAME NOT FOUND           */
*  ERRCODE = RCDDNFND;                 /* SET ERRCODE TO RCDDNFND    */
         B     @RC00072                                         02S0103
@RF00072 L     @10,@PC00001+4                                   02S0103
         MVC   ERRCODE(2,@10),@CB00865                          02S0103
*    IF ERRCODE=ZERO THEN              /* NO ERRORS W/ENVIRONMENT    */
@RC00072 L     @10,@PC00001+4                                   01S0104
         ICM   @03,3,ERRCODE(@10)                               01S0104
         BNZ   @RF00104                                         01S0104
*      DO;                             /* RESTORE DDNAMES TO TIOT AND
*                                         TURN OFF DSAB CONCAT. BITS */
*        DCONCTSW = OFF;               /* INITIALIZE SWITCH INDICATING
*                                         NO DECONCATENATION DONE    */
         NI    DCONCTSW,B'01111111'                             01S0106
*        DSABDCAT=OFF;                 /* TURN OFF DYN/CONCAT BIT    */
         NI    DSABDCAT(DSABPTR),B'11110111'                    01S0107
*        IF DSABPCAT=OFF THEN          /* FIRST DSAB NOT PERM.CAT    */
         TM    DSABPCAT(DSABPTR),B'00000100'                    01S0108
         BNZ   @RF00108                                         01S0108
*          DSABCATM=OFF;               /* TURN OFF MEMBER.CONCAT GP  */
         NI    DSABCATM(DSABPTR),B'11111101'                    01S0109
*        DSABPTR =DSABFCHN;            /* GET NEXT DSAB ON CHAIN     */
@RF00108 L     DSABPTR,DSABFCHN(,DSABPTR)                       01S0110
*        DO WHILE (TIOEDDNM(1) = BLANK & DSABPTR ^= ZERO);      01S0111
         B     @DE00111                                         01S0111
@DL00111 DS    0H                                               01S0112
*                                      /* RESTORE UNTIL END OF  01S0112
*                                         GROUP OR END OF TIOT       */
*          IF SCTDDNAM(1)^=BLANK THEN  /* DDNAME IN SIOT ?           */
         L     @10,DSABSIOT(,DSABPTR)                           01S0112
         CLC   SCTDDNAM(1,@10),BLANK                            01S0112
         BE    @RF00112                                         01S0112
*            DO;                       /* YES, RESTORE DDNAME        */
*              TIOEDDNM=SCTDDNAM;      /* RESTORE DDNAME FROM SIOT   */
         L     @03,DSABTIOT(,DSABPTR)                           01S0114
         MVC   TIOEDDNM(8,@03),SCTDDNAM(@10)                    01S0114
*              IF DSABPCAT = OFF THEN  /* IS THIS A PCAT MEMBER ?    */
         TM    DSABPCAT(DSABPTR),B'00000100'                    01S0115
         BNZ   @RF00115                                         01S0115
*                DSABCATM=OFF;         /* NO, TURN OFF CONCAT MBR BIT*/
         NI    DSABCATM(DSABPTR),B'11111101'                    01S0116
*              DCONCTSW = ON;          /* INDICATE DECONCATENATION
*                                         HAS BEEN DONE              */
@RF00115 OI    DCONCTSW,B'10000000'                             01S0117
*            END;                      /* END RESTORE DDNAMES        */
*          DSABDCAT=OFF;               /* TURN OFF DYN/CONCAT BIT    */
@RF00112 NI    DSABDCAT(DSABPTR),B'11110111'                    01S0119
*          DSABPTR = DSABFCHN;         /* GET NEXT MEMBER CAT.GROUP  */
         L     DSABPTR,DSABFCHN(,DSABPTR)                       01S0120
*        END;                          /*ENDWHILE FOR DECONCATENATION*/
@DE00111 L     @10,DSABTIOT(,DSABPTR)                           01S0121
         CLC   TIOEDDNM(1,@10),BLANK                            01S0121
         BNE   @DC00111                                         01S0121
         LTR   DSABPTR,DSABPTR                                  01S0121
         BNZ   @DL00111                                         01S0121
@DC00111 DS    0H                                               01S0122
*        IF DCONCTSW = ON THEN         /* DID A DECONCAT OCCURR ?    */
         TM    DCONCTSW,B'10000000'                             01S0122
         BNO   @RF00122                                         01S0122
*          DO;                         /* YES, CALL SMF MODULE       */
*            FUNCMAP = '04'X;          /* INDICATE DECONCAT CALL     */
         MVI   FUNCMAP,X'04'                                    01S0124
*            CALL IEFDB4F9(FUNCMAP,TCBP,0,DEPARMS,JSCDSABQ,SMFPARMS);
         LA    @10,FUNCMAP                                      01S0125
         ST    @10,@AL00001                                     01S0125
         L     @10,@PC00001+8                                   01S0125
         LA    @15,TCBP(,@10)                                   01S0125
         ST    @15,@AL00001+4                                   01S0125
         LA    @15,@CF00111                                     01S0125
         ST    @15,@AL00001+8                                   01S0125
         L     @15,@PC00001+16                                  01S0125
         ST    @15,@AL00001+12                                  01S0125
         L     @10,JSCBP(,@10)                                  01S0125
         LA    @10,JSCDSABQ(,@10)                               01S0125
         ST    @10,@AL00001+16                                  01S0125
         L     @10,@PC00001+24                                  01S0125
         ST    @10,@AL00001+20                                  01S0125
         L     @15,@CV00075                                     01S0125
         LA    @01,@AL00001                                     01S0125
         BALR  @14,@15                                          01S0125
*                                      /* CALL SMF MODULE    @ZA02706*/
*          END;                        /* END CALL TO SMF MODULE     */
*      END;                            /* COMPLETED DECONCATENATION  */
*    ELSE;                             /* NO PROCESSING FOR     01S0128
*                                         ENVIRONMENTAL ERROR        */
@RF00104 DS    0H                                               01S0129
*  END;                                                         01S0129
*ELSE;                                 /* INVALID SYNTAX-NO PROCESS  */
@RF00068 DS    0H                                               01S0131
*RETURN CODE(ZERO);                    /* RETURN RETCODE IN REG.15   */
@RC00068 L     @13,4(,@13)                                      01S0131
         L     @00,@SIZDATD                                     01S0131
         LR    @01,@11                                          01S0131
         FSPACE   R,LV=(0),A=(1)
         SLR   @15,@15                                          01S0131
         L     @14,12(,@13)                                     01S0131
         LM    @00,@12,20(@13)                                  01S0131
         BR    @14                                              01S0131
*END IEFDB460                                                   01S0132
*/* THE FOLLOWING INCLUDE STATEMENTS WERE FOUND IN THIS PROGRAM.      *
*/*%INCLUDE SYSLIB  (DECONSPC)                                        *
*/*%INCLUDE SYSLIB  (DECONDAT)                                        *
*/*%INCLUDE SYSLIB  (IEZJSCB )                                        *
*/*%INCLUDE SYSLIB  (IEFASIOT)                                        *
*/*%INCLUDE SYSLIB  (IEFTIOT1)                                        *
*/*%INCLUDE SYSLIB  (IEFZB4D1)                                        *
*/*%INCLUDE SYSLIB  (IEFZB4D2)                                        *
*/*%INCLUDE SYSLIB  (IEFZB4D5)                                        *
*/*%INCLUDE SYSLIB  (IEFZB4D7)                                        *
*/*%INCLUDE SYSLIB  (IEFZB4D9)                                        *
*/*%INCLUDE SYSLIB  (IEFZB4DA)                                        *
*/*%INCLUDE SYSLIB  (IHAQDB  )                                        *
*/*%INCLUDE SYSLIB  (IHADSAB )                                        *
*/*%INCLUDE SYSLIB  (SYNCK460)                                        *
*/*%INCLUDE SYSLIB  (CK460SPC)                                        *
*/*%INCLUDE SYSLIB  (ENVIRNCK)                                        *
*/*%INCLUDE SYSLIB  (ENVIRSPC)                                        *
*/*%INCLUDE SYSLIB  (SIOTDDCK)                                        *
*/*%INCLUDE SYSLIB  (SIODDSPC)                                        *
*;                                                              01S0132
@DATA    DS    0H
@SM01056 MVC   DDNAME(0),TEXTUPAR(@03)
@DATD    DSECT
         DS    0F
@SA00001 DS    18F
@PC00001 DS    7F
@AL00001 DS    6A
@TF00001 DS    F
@TF00002 DS    F
@TF00003 DS    F
@TF00004 DS    F
IEFDB460 CSECT
         DS    0F
@CF00111 DC    F'0'
@DATD    DSECT
         DS    0D
DDNRTRN  DS    A
RETAREA  DS    F
TCBJSCB  DS    A
SIOTPTR  DS    A
TIOTPTR  DS    A
TXTUFLDP DS    A
QDBPTR   DS    A
DDNAME   DS    CL8
FUNCMAP  DS    CL1
KEYMASK1 DS    CL1
KEYMASK2 DS    CL1
SWITCHES DS    CL1
         ORG   SWITCHES
DCONCTSW DS    BL1
@NM00001 EQU   SWITCHES+0
         ORG   SWITCHES+1
PARMAREA DS    CL8
         ORG   *+1-(*-@DATD)/(*-@DATD) INSURE DSECT DATA
@ENDDATD EQU   *
IEFDB460 CSECT
         DS    0F
@SIZDATD DC    AL1(230)
         DC    AL3(@ENDDATD-@DATD)
@CV00075 DC    V(IEFDB4F9)
@CV00076 DC    V(IEFDB4FC)
@CV00077 DC    V(IEFDB4FF)
         DS    0D
@CC00098 DC    C'JOBCAT  '
@CC00100 DC    C'JOBLIB  '
@CC00106 DC    C'STEPCAT '
@CC00108 DC    C'STEPLIB '
@CB00083 DC    X'0001'
@CB00825 DC    X'035C'
@CB00829 DC    X'0364'
@CB00845 DC    X'0388'
@CB00859 DC    X'0420'
@CB00861 DC    X'0424'
@CB00865 DC    X'0438'
         DS    CL2
KEYDICT  DS    CL16
         ORG   KEYDICT
KEYENT1  DS    CL13
         ORG   KEYENT1
ENTLEN1  DC    AL1(13)
KEY1     DC    X'0001'
KEYMAXL  DC    X'0008'
KEYMINL  DC    X'0001'
KEYMAXNO DC    X'0001'
KEYMINNO DC    X'0001'
KEYRTAP  DC    X'0000'
         ORG   KEYDICT+13
KEYENT2  DS    CL3
         ORG   KEYENT2
ENTLEN2  DC    AL1(3)
ENDHEX   DC    X'FFFF'
         ORG   KEYDICT+16
BLANK    DC    CL1' '
@00      EQU   00                      EQUATES FOR REGISTERS 0-15
@01      EQU   01
@02      EQU   02
@03      EQU   03
@04      EQU   04
@05      EQU   05
@06      EQU   06
@07      EQU   07
@08      EQU   08
@09      EQU   09
@10      EQU   10
@11      EQU   11
@12      EQU   12
@13      EQU   13
@14      EQU   14
@15      EQU   15
LOCATDDP EQU   @04
FRSTDSAB EQU   @03
DSABPTR  EQU   @02
IEZJSCB  EQU   0
JSCBSEC1 EQU   IEZJSCB+188
JSCHPCE  EQU   JSCBSEC1+4
JSCBDCB  EQU   JSCBSEC1+36
JSCBOPTS EQU   JSCBSEC1+48
JSCBSWT1 EQU   JSCBSEC1+55
JSCBWTP  EQU   JSCBSEC1+64
JSCBWTFG EQU   JSCBWTP
JSCBEND1 EQU   IEZJSCB+260
INDMSIOT EQU   0
SCTDDNAM EQU   INDMSIOT+4
SCTUSADD EQU   INDMSIOT+20
SIOTBYT1 EQU   INDMSIOT+43
SIOTBYT3 EQU   INDMSIOT+46
SIOTTSTC EQU   INDMSIOT+47
SIOTBYT0 EQU   INDMSIOT+52
SCTSDISP EQU   INDMSIOT+55
SCTSBYT1 EQU   INDMSIOT+56
SCTSBYT2 EQU   INDMSIOT+57
SCTSBYT3 EQU   INDMSIOT+58
SCTSBYT4 EQU   INDMSIOT+59
SCTUTYPE EQU   INDMSIOT+60
SIOTDEVT EQU   SCTUTYPE
SIOUBYT3 EQU   SIOTDEVT+2
SIOTALTD EQU   INDMSIOT+92
SIOTBYT2 EQU   INDMSIOT+103
TIOT1    EQU   0
TIOENTRY EQU   0
TIOESTTA EQU   TIOENTRY+1
TIOERLOC EQU   TIOENTRY+2
TIOELINK EQU   TIOERLOC+1
TIOESYOT EQU   TIOELINK
TIOEDDNM EQU   TIOENTRY+4
TIOESTTC EQU   TIOENTRY+15
TIOESTTB EQU   TIOENTRY+16
POOLSTAR EQU   TIOENTRY+20
TXTUPLST EQU   0
TXTUNITP EQU   TXTUPLST
TXTUPELM EQU   0
TXTPLENT EQU   TXTUPELM
TEXTUNIT EQU   0
TEXTUENT EQU   TEXTUNIT+4
TEXTULNG EQU   TEXTUENT
TEXTUPAR EQU   TEXTUENT+2
TEXTUFLD EQU   0
QDB      EQU   0
DSAB     EQU   0
DSABFCHN EQU   DSAB+4
DSABOPCT EQU   DSAB+14
DSABTIOT EQU   DSAB+16
DSABGIDP EQU   DSAB+24
DSABANMP EQU   DSAB+28
DSABORG  EQU   DSAB+32
DSABORG1 EQU   DSABORG
DSABORG2 EQU   DSABORG+1
DSABFLG1 EQU   DSAB+34
DSABDCAT EQU   DSABFLG1
DSABPCAT EQU   DSABFLG1
DSABCATM EQU   DSABFLG1
DSABFLG2 EQU   DSAB+35
DSABFLG3 EQU   DSAB+36
DSABFLG4 EQU   DSAB+37
DSABSIOT EQU   DSAB+64
DSABANMI EQU   0
DSABGIDL EQU   0
S99TXTPP EQU   0
RETINFO  EQU   0
ERRCODE  EQU   RETINFO
INFOCODE EQU   RETINFO+2
DECONLP  EQU   0
JSCBP    EQU   DECONLP
TCBP     EQU   DECONLP+8
ALFNCMAP EQU   0
INPUTSW  EQU   ALFNCMAP
PROCESSW EQU   ALFNCMAP+6
ERRPROSW EQU   PROCESSW
DEPARMS  EQU   0
DENQRETN EQU   DEPARMS+232
DEDMYEPA EQU   DEPARMS+240
DEDMYAS  EQU   DEPARMS+260
LASTEPAP EQU   0
SMFPARMS EQU   0
JSCBSEC2 EQU   JSCBEND1
JSCBSEC3 EQU   JSCBEND1
JSCBJCT  EQU   JSCBSEC3
JSCBJCTA EQU   JSCBJCT+1
JSCBASID EQU   JSCBSEC3+8
JSCBJNL  EQU   JSCBSEC3+28
JSCBJJSB EQU   JSCBJNL
JSCBSUB  EQU   JSCBSEC3+40
JSCDSABQ EQU   JSCBSEC3+60
JSCSCT   EQU   JSCBSEC3+68
JSCRSV35 EQU   JSCBSEC3+96
JSCRSV36 EQU   JSCRSV35
JSCRSV37 EQU   JSCRSV35+2
JSCRSV45 EQU   JSCBSEC3+112
JSCRSV46 EQU   JSCRSV45
JSCRSV47 EQU   JSCRSV45+2
TIOEDEVE EQU   TIOESTTB
TIOSTTB  EQU   TIOEDEVE
DSABQDB  EQU   QDB
DSQFRSTP EQU   DSABQDB+12
DSQLASTP EQU   DSABQDB+16
         AGO   .@UNREFD                START UNREFERENCED COMPONENTS
@NM00025 EQU   DSABQDB+24
DSQBDSP  EQU   DSABQDB+22
DSQFDSP  EQU   DSABQDB+20
DSQBADFC EQU   DSQLASTP
DSQBADBC EQU   DSQFRSTP
DSQNELMS EQU   DSABQDB+8
DSQDBLN  EQU   DSABQDB+6
DSQATTRS EQU   DSABQDB+4
DSQDBID  EQU   DSABQDB
TIOUCBP  EQU   TIOEDEVE+1
TIOVERF  EQU   TIOSTTB
TIOUNLD  EQU   TIOSTTB
TIOMNTD  EQU   TIOSTTB
TIOSETU  EQU   TIOSTTB
TIOVLSR  EQU   TIOSTTB
TIOPVIO  EQU   TIOSTTB
TIOREQD  EQU   TIOSTTB
TIOUSED  EQU   TIOSTTB
JSCBEND3 EQU   JSCBSEC3+120
JSCRSV52 EQU   JSCBSEC3+116
JSCRSV51 EQU   JSCRSV47+1
JSCRSV50 EQU   JSCRSV47
JSCRSV49 EQU   JSCRSV46+1
JSCRSV48 EQU   JSCRSV46
JSCRSV44 EQU   JSCBSEC3+108
JSCRSV43 EQU   JSCBSEC3+104
JSCRSV42 EQU   JSCBSEC3+100
JSCRSV41 EQU   JSCRSV37+1
JSCRSV40 EQU   JSCRSV37
JSCRSV39 EQU   JSCRSV36+1
JSCRSV38 EQU   JSCRSV36
JSCBUFPT EQU   JSCBSEC3+92
JSCBACT  EQU   JSCBSEC3+88
JSCBSWSP EQU   JSCBSEC3+87
JSCRSV33 EQU   JSCBSEC3+86
JSCDDNUM EQU   JSCBSEC3+84
JSCRSV53 EQU   JSCBSEC3+82
JSCDDNNO EQU   JSCBSEC3+80
JSCBVATA EQU   JSCBSEC3+76
JSCTMCOR EQU   JSCBSEC3+72
JSCSCTP  EQU   JSCSCT+1
JSCRSV55 EQU   JSCSCT
JSCRSV54 EQU   JSCBSEC3+64
JSCBSSIB EQU   JSCBSEC3+56
JSCBFRBA EQU   JSCBSEC3+48
JSCRSV28 EQU   JSCBSEC3+46
JSCBSONO EQU   JSCBSEC3+44
JSCBSUBA EQU   JSCBSUB+1
JSCRSV31 EQU   JSCBSUB
JSCBSMLR EQU   JSCBSEC3+36
JSCBJNLR EQU   JSCBSEC3+32
JSCBJNLA EQU   JSCBJNL+1
JSCBJSBT EQU   JSCBJJSB
JSCBJSBX EQU   JSCBJJSB
JSCBJSBA EQU   JSCBJJSB
JSCBJSBI EQU   JSCBJJSB
@NM00005 EQU   JSCBJJSB
JSCBJNLE EQU   JSCBJJSB
JSCBJNLF EQU   JSCBJJSB
JSCBJNLN EQU   JSCBJJSB
@NM00004 EQU   JSCBSEC3+24
JSCBJRBA EQU   JSCBSEC3+16
JSCBIECB EQU   JSCBSEC3+12
JSCRSV25 EQU   JSCBSEC3+10
JSCBTJID EQU   JSCBASID
JSCBPSCB EQU   JSCBSEC3+4
JSCJCTP  EQU   JSCBJCTA
JSCRSV24 EQU   JSCBJCT
JSCBEND2 EQU   JSCBSEC2
SMFBUF2P EQU   SMFPARMS+4
SMFBUF1P EQU   SMFPARMS
@NM00032 EQU   DEPARMS+304
DETCTIOL EQU   DEPARMS+300
DETCTIOP EQU   DEPARMS+296
DETDQLST EQU   DEPARMS+280
DEALASTP EQU   DEPARMS+276
DEASGNP  EQU   DEDMYAS+12
@NM00031 EQU   DEDMYAS
DEWLASTP EQU   DEPARMS+256
DEWRITP  EQU   DEDMYEPA+12
@NM00030 EQU   DEDMYEPA
DEDSNQRC EQU   DENQRETN+4
DEDSNQEN EQU   DENQRETN
DECPYLEN EQU   DEPARMS+228
DECPYLOC EQU   DEPARMS+224
DEJSCB   EQU   DEPARMS+220
DESCT    EQU   DEPARMS+216
DEJCT    EQU   DEPARMS+212
DESIOT   EQU   DEPARMS+208
DETCB    EQU   DEPARMS+204
DEALFMAP EQU   DEPARMS+200
DECORE   EQU   DEPARMS
@NM00029 EQU   PROCESSW+1
HSKPDQSW EQU   PROCESSW+1
DISMSGSW EQU   PROCESSW+1
USERERSW EQU   PROCESSW+1
EPALSISW EQU   PROCESSW+1
EPASCTSW EQU   PROCESSW+1
EPAJCTSW EQU   PROCESSW
FRRPERSW EQU   PROCESSW
DCBSPCSW EQU   PROCESSW
NQEXCLSW EQU   PROCESSW
UNALOCSW EQU   ERRPROSW
DEQDSNSW EQU   ERRPROSW
COPYSW   EQU   PROCESSW
@NM00028 EQU   PROCESSW
@NM00027 EQU   INPUTSW+3
PCATINIT EQU   INPUTSW+3
UNITDEVT EQU   INPUTSW+3
MOUNTSW  EQU   INPUTSW+2
CATLOGSW EQU   INPUTSW+2
TIOTNQSW EQU   INPUTSW+2
OFFLINSW EQU   INPUTSW+2
WTUNTSW  EQU   INPUTSW+2
NORESSW  EQU   INPUTSW+2
WTDSNSW  EQU   INPUTSW+2
WTVOLSW  EQU   INPUTSW+2
@NM00026 EQU   INPUTSW
JOBRLSYS EQU   INPUTSW
NOMONTSW EQU   INPUTSW
NOCNVTSW EQU   INPUTSW
ONCNVTSW EQU   INPUTSW
SCTP     EQU   DECONLP+16
JCTP     EQU   DECONLP+12
ASCBP    EQU   DECONLP+4
DSABGRID EQU   DSABGIDL+4
DSABLLEN EQU   DSABGIDL
DSABANAM EQU   DSABANMI+1
DSABANML EQU   DSABANMI
DSABRS04 EQU   DSAB+68
DSABRS03 EQU   DSAB+62
DSABDCBM EQU   DSAB+56
DSABSSCM EQU   DSAB+52
DSABSSNM EQU   DSAB+48
DSABPTTR EQU   DSAB+44
DSABTCBP EQU   DSAB+40
DSABRS02 EQU   DSAB+38
@NM00037 EQU   DSABFLG4
DSABCKSI EQU   DSABFLG4
DSABCKVL EQU   DSABFLG4
DSABCKDS EQU   DSABFLG4
@NM00036 EQU   DSABFLG3
DSABJSCT EQU   DSABFLG3
DSABCATL EQU   DSABFLG3
DSABVMSC EQU   DSABFLG3
DSABVAM  EQU   DSABFLG3
DSABPASS EQU   DSABFLG3
DSABDEFR EQU   DSABFLG3
@NM00035 EQU   DSABFLG2
DSABUNAL EQU   DSABFLG2
DSABIRM  EQU   DSABFLG2
DSABOPEN EQU   DSABFLG2
DSABNUSE EQU   DSABFLG1
DSABCONV EQU   DSABFLG1
DSABDCNV EQU   DSABFLG1
DSABPALC EQU   DSABFLG1
DSABDALC EQU   DSABFLG1
@NM00034 EQU   DSABORG2
DSABTR   EQU   DSABORG2
DSABAM   EQU   DSABORG2
@NM00033 EQU   DSABORG2
DSABTQ   EQU   DSABORG2
DSABTX   EQU   DSABORG2
DSABGS   EQU   DSABORG2
DSABU    EQU   DSABORG1
DSABPO   EQU   DSABORG1
DSABMQ   EQU   DSABORG1
DSABCQ   EQU   DSABORG1
DSABCX   EQU   DSABORG1
DSABDA   EQU   DSABORG1
DSABPS   EQU   DSABORG1
DSABIS   EQU   DSABORG1
DSABSSVA EQU   DSAB+21
DSABRS01 EQU   DSAB+20
DSABLNTH EQU   DSAB+12
DSABBCHN EQU   DSAB+8
DSABID   EQU   DSAB
QDBRV002 EQU   QDB+28
QDBPRDS  EQU   QDB+26
QDBPRSZ  EQU   QDB+24
QDBBPTDS EQU   QDB+22
QDBFPTDS EQU   QDB+20
QDBLELMP EQU   QDB+16
QDBFELMP EQU   QDB+12
QDBNELMS EQU   QDB+8
QDBRV001 EQU   QDB+6
QDBATTR  EQU   QDB+4
QDBQDB   EQU   QDB
TEXTUPRM EQU   TEXTUFLD+2
TEXTULEN EQU   TEXTUFLD
TEXTUNUM EQU   TEXTUNIT+2
TEXTUKEY EQU   TEXTUNIT
TXTPLEND EQU   TXTPLENT
TXTUPEND EQU   TXTUNITP
TIOTFEND EQU   POOLSTAR+16
TIOPSLOT EQU   POOLSTAR+13
TIOPSTTB EQU   POOLSTAR+12
TIOPPOOL EQU   POOLSTAR+4
TIOPNSRT EQU   POOLSTAR+3
@NM00024 EQU   POOLSTAR+2
TIOPNSLT EQU   POOLSTAR+1
@NM00023 EQU   POOLSTAR
TIOEFSRT EQU   TIOENTRY+17
TIOSVERF EQU   TIOESTTB
TIOSUNLD EQU   TIOESTTB
TIOSMNTD EQU   TIOESTTB
TIOSSETU EQU   TIOESTTB
TIOSVLSR EQU   TIOESTTB
TIOSPVIO EQU   TIOESTTB
TIOSREQD EQU   TIOESTTB
TIOSUSED EQU   TIOESTTB
TIOSBALS EQU   TIOESTTC
TIOSBALP EQU   TIOESTTC
TIOSVOLS EQU   TIOESTTC
TIOSVOLP EQU   TIOESTTC
TIOSAFFS EQU   TIOESTTC
TIOSAFFP EQU   TIOESTTC
TIOSDEFR EQU   TIOESTTC
TIOSDKCR EQU   TIOESTTC
TIOEJFCB EQU   TIOENTRY+12
TIOTREM  EQU   TIOELINK
TIOESSDS EQU   TIOESYOT
TIOESYIN EQU   TIOELINK
TIOEQNAM EQU   TIOELINK
TIOEDYNM EQU   TIOELINK
TIOTTERM EQU   TIOELINK
TIOTRV01 EQU   TIOELINK
TIOSYOUT EQU   TIOELINK
TIOEWTCT EQU   TIOERLOC
TIOSDSP2 EQU   TIOESTTA
TIOSDSP1 EQU   TIOESTTA
TIOSLABL EQU   TIOESTTA
TIOSDADS EQU   TIOESTTA
TIOSJBLB EQU   TIOESTTA
TIOSPLTS EQU   TIOESTTA
TIOSPLTP EQU   TIOESTTA
TIOSLTYP EQU   TIOESTTA
TIOELNGH EQU   TIOENTRY
TIOCSTEP EQU   TIOT1+8
TIOCNJOB EQU   TIOT1
SIODDSNL EQU   INDMSIOT+173
SIOVDSNL EQU   INDMSIOT+172
SIOVDSNT EQU   INDMSIOT+170
SVOLUNNO EQU   INDMSIOT+168
SIOTVMVP EQU   INDMSIOT+164
SIOTJFX  EQU   INDMSIOT+160
SJFCBPTR EQU   INDMSIOT+156
SIOTNPTR EQU   INDMSIOT+152
SIOTETIO EQU   INDMSIOT+148
SIOTATE  EQU   INDMSIOT+144
SVOLUNAD EQU   INDMSIOT+140
SIOTEDLP EQU   INDMSIOT+136
SIOTEDLS EQU   INDMSIOT+132
SIOTRSNC EQU   INDMSIOT+130
SCTANAME EQU   INDMSIOT+122
@NM00022 EQU   INDMSIOT+108
SIOTSSNM EQU   INDMSIOT+104
SIODDQCR EQU   SIOTBYT2
SIOVDQCR EQU   SIOTBYT2
SIOTCVOL EQU   SIOTBYT2
SIOTCNEW EQU   SIOTBYT2
SIOTCALC EQU   SIOTBYT2
SIOTGALL EQU   SIOTBYT2
SIOTDSPD EQU   SIOTBYT2
SIOTDMND EQU   SIOTBYT2
SIOTOPUC EQU   INDMSIOT+99
SIOTOUTR EQU   INDMSIOT+97
SIOTOUTC EQU   INDMSIOT+96
@NM00021 EQU   INDMSIOT+93
SIOTAUNC EQU   SIOTALTD
SIOTACAT EQU   SIOTALTD
SIOTADEL EQU   SIOTALTD
SIOTAKEP EQU   SIOTALTD
SIOTNPRV EQU   SIOTALTD
SIOJCATS EQU   SIOTALTD
@NM00020 EQU   SIOTALTD
@NM00019 EQU   SIOTALTD
@NM00018 EQU   INDMSIOT+91
SIOTNDSB EQU   INDMSIOT+88
@NM00017 EQU   INDMSIOT+84
SIOTDPCD EQU   INDMSIOT+82
@NM00016 EQU   INDMSIOT+81
SCTOUTPN EQU   INDMSIOT+80
SCTOUTNO EQU   INDMSIOT+76
SCTOUTNM EQU   INDMSIOT+68
SIOUCBAD EQU   SCTUTYPE+5
SIOUCNVT EQU   SCTUTYPE+4
SIOUBYT4 EQU   SIOTDEVT+3
@NM00015 EQU   SIOUBYT3
SIO3UREC EQU   SIOUBYT3
SIO3DISP EQU   SIOUBYT3
SIO3DACC EQU   SIOUBYT3
SIO3COMM EQU   SIOUBYT3
SIO3TAPE EQU   SIOUBYT3
SIOUBYT2 EQU   SIOTDEVT+1
SIOUBYT1 EQU   SIOTDEVT
SIOTOMN  EQU   SCTSBYT4
SIOTIPDI EQU   SCTSBYT4
SIOTVAFF EQU   SCTSBYT4
SIOTSTEP EQU   SCTSBYT4
SIOTASCI EQU   SCTSBYT4
@NM00014 EQU   SCTSBYT4
SIOTGDGA EQU   SCTSBYT4
SCTSGDGS EQU   SCTSBYT4
SCTSOLD  EQU   SCTSBYT3
SCTSMOD  EQU   SCTSBYT3
SCTSNEW  EQU   SCTSBYT3
SCTSYSOU EQU   SCTSBYT3
SCTVREF  EQU   SCTSBYT3
@NM00013 EQU   SCTSBYT3
SCTSYSNE EQU   SCTSBYT3
SCTDSNRF EQU   SCTSBYT3
SCTRECVD EQU   SCTSBYT2
SCTDEFER EQU   SCTSBYT2
SCTLABEL EQU   SCTSBYT2
SCTUNLBD EQU   SCTSBYT2
SCTJOBLB EQU   SCTSBYT2
SCTVOLAF EQU   SCTSBYT2
SIOTCATL EQU   SCTSBYT2
SIOCLUNL EQU   SCTSBYT2
SIOTJSCT EQU   SCTSBYT1
SCTUNAFF EQU   SCTSBYT1
SCTPARLM EQU   SCTSBYT1
SIOTQDSN EQU   SCTSBYT1
SIOTGDSN EQU   SCTSBYT1
SIOTCCAT EQU   SCTSBYT1
SCTSYSIN EQU   SCTSBYT1
SCTDUMMY EQU   SCTSBYT1
SIOTUNCT EQU   SCTSDISP
SIOTCTLG EQU   SCTSDISP
SIOTDLET EQU   SCTSDISP
SIOTKEEP EQU   SCTSDISP
SIOTPASS EQU   SCTSDISP
SIOTPRIV EQU   SCTSDISP
S3400DSP EQU   SCTSDISP
@NM00012 EQU   SCTSDISP
SIOTVLCT EQU   INDMSIOT+54
SCTNMBUT EQU   INDMSIOT+53
SIOTRTRY EQU   SIOTBYT0
SIOTPUPV EQU   SIOTBYT0
SIOTNOPV EQU   SIOTBYT0
SIOTGIGN EQU   SIOTBYT0
SPVTAMSG EQU   SIOTBYT0
SIOTFUDA EQU   SIOTBYT0
SIOTDYAL EQU   SIOTBYT0
SIOTSSDS EQU   SIOTBYT0
SIOTGIID EQU   INDMSIOT+50
SCTVOLCT EQU   INDMSIOT+49
SCTSPOOL EQU   INDMSIOT+48
SIOTQNAM EQU   SIOTTSTC
@NM00011 EQU   SIOTTSTC
SIOTTERM EQU   SIOTTSTC
@NM00010 EQU   SIOTTSTC
@NM00009 EQU   SIOTBYT3
SIOTJES3 EQU   SIOTBYT3
SIOCDEVT EQU   SIOTBYT3
SIOALIAS EQU   SIOTBYT3
SCTDDINO EQU   INDMSIOT+44
SIOTDDNT EQU   SIOTBYT1
SIOTALCD EQU   SIOTBYT1
SIODADSM EQU   SIOTBYT1
SIOTDADR EQU   SIOTBYT1
SIODUNAL EQU   SIOTBYT1
SIOVAMDS EQU   SIOTBYT1
SIOTHOLD EQU   SIOTBYT1
SIOTOCKP EQU   SIOTBYT1
SIOPSCNT EQU   INDMSIOT+42
SIOTREFN EQU   INDMSIOT+40
SIOTOTUN EQU   INDMSIOT+39
SIOTVRSB EQU   INDMSIOT+36
@NM00008 EQU   INDMSIOT+35
SCTPJFCB EQU   INDMSIOT+32
@NM00007 EQU   INDMSIOT+31
SCTPSIOT EQU   INDMSIOT+28
SIOTAFID EQU   INDMSIOT+26
@NM00006 EQU   INDMSIOT+24
SIODSNTE EQU   INDMSIOT+22
SIOTUNAF EQU   SCTUSADD
SIOTDEST EQU   INDMSIOT+12
SIOTTYPE EQU   INDMSIOT+3
SIOTDSKA EQU   INDMSIOT
JSCBCSCB EQU   JSCBSEC1+68
JSCBPMG  EQU   JSCBWTP+2
JSCBWTSP EQU   JSCBWTP+1
JSCRSV23 EQU   JSCBWTFG
JSCRSV22 EQU   JSCBWTFG
JSCRSV21 EQU   JSCBWTFG
JSCRSV20 EQU   JSCBWTFG
JSCRSV19 EQU   JSCBWTFG
JSCRSV18 EQU   JSCBWTFG
JSCBRET  EQU   JSCBWTFG
JSCBIOFG EQU   JSCBWTFG
@NM00003 EQU   JSCBSEC1+60
JSCBQMPI EQU   JSCBSEC1+56
JSCBPMSG EQU   JSCBSWT1
JSCRSV16 EQU   JSCBSWT1
JSCRSV15 EQU   JSCBSWT1
JSCRSV14 EQU   JSCBSWT1
JSCRSV13 EQU   JSCBSWT1
JSCRSV12 EQU   JSCBSWT1
JSCRSV11 EQU   JSCBSWT1
JSCBPASS EQU   JSCBSWT1
JSCBTTTR EQU   JSCBSEC1+52
JSCRSV10 EQU   JSCBSEC1+49
JSCBAUTH EQU   JSCBOPTS
JSCSIOTS EQU   JSCBOPTS
JSCRSV08 EQU   JSCBOPTS
JSCRSV07 EQU   JSCBOPTS
JSCRSV06 EQU   JSCBOPTS
JSCBLONG EQU   JSCBOPTS
JSCRSV05 EQU   JSCBOPTS
JSCRSV04 EQU   JSCBOPTS
JSCBSECB EQU   JSCBSEC1+44
JSCRSV03 EQU   JSCBSEC1+41
JSCBSTEP EQU   JSCBSEC1+40
JSCBDCBA EQU   JSCBDCB+1
JSCRSV02 EQU   JSCBDCB
JSCBID   EQU   JSCBSEC1+32
JSCBDBTB EQU   JSCBSEC1+28
JSCBIJSC EQU   JSCBSEC1+24
JSCBTCBP EQU   JSCBSEC1+20
JSCBPCC  EQU   JSCBSEC1+16
JSCBTCP  EQU   JSCBSEC1+12
JSCBSHR  EQU   JSCBSEC1+8
JSCHPCEA EQU   JSCHPCE+1
JSCRSV32 EQU   JSCHPCE
JSCRSV01 EQU   JSCBSEC1
@NM00002 EQU   IEZJSCB
.@UNREFD ANOP                          END UNREFERENCED COMPONENTS
@RC00051 EQU   @RC00050
@RC00075 EQU   @RC00072
@RC00104 EQU   @RC00068
@RC00054 EQU   @RC00051
@RF00122 EQU   @RC00104
@RF00058 EQU   @RC00054
@ENDDATA EQU   *
         END   IEFDB460,(C'PLS0212',0603,75024)
