         TITLE 'IEFDB470 - DYNAMIC INFORMATION RETRIEVAL               *
                        '
IEFDB470 CSECT ,                                                01S0001
@MAINENT DS    0H                                               01S0001
         USING *,@15                                            01S0001
         B     @PROLOG                                          01S0001
         DC    AL1(16)                                          01S0001
         DC    C'IEFDB470  78.089'                              01S0001
         DROP  @15
@PROLOG  STM   @14,@12,12(@13)                                  01S0001
         BALR  @12,0                                            01S0001
@PSTART  DS    0H                                               01S0001
         USING @PSTART,@12                                      01S0001
         L     @00,@SIZDATD                                     01S0001
         GSPACE   R,LV=(0)
         LR    @11,@01                                          01S0001
         USING @DATD,@11                                        01S0001
         ST    @13,@SA00001+4                                   01S0001
         LM    @00,@01,20(@13)                                  01S0001
         ST    @11,8(,@13)                                      01S0001
         LR    @13,@11                                          01S0001
         MVC   @PC00001(24),0(@01)                              01S0001
JSCBDISP EQU 188
JSCBAOS1 EQU  72
JSCBAOS2 EQU 192
*/********************************************************************/
*/*                                                                  */
*/* SEGMENT NAME - DINSYNCK                                          */
*/*                                                                  */
*/* DESCRIPTIVE NAME - DYNAMIC INFORMATION RETRIEVAL SYNTAX CHECK    */
*/*                                                                  */
*/* FUNCTION - THIS ROUTINE DETERMINES IF THE TEXT ENTERED IS VALID  */
*/*                                                                  */
*/* OPERATION - IEFBD4FF IS INVOKED TO CHECK TEXT UNIT SYNTAX        */
*/*                                                                  */
*/* ENTRY - DINSYNCK (INCLUDED SEGMENT)                              */
*/*                                                                  */
*/* PURPOSE - SEE FUNCTION                                           */
*/*                                                                  */
*/* INPUT DATA - TEXT UNITS                                          */
*/*                                                                  */
*/* EXITS - ALL ARE TO NEXT SEQUENTIAL INSTRUCTION                   */
*/*                                                                  */
*/*  NORMAL - SYNTAX IS GOOD AND ERRCODE IS SET TO ZERO              */
*/*                                                                  */
*/*  ERROR  - ERRCODE IS ONE OF THE FOLLOWING                        */
*/*           1. RCINVKEY - INVALID KEY SPECIFIED IN TEXT            */
*/*           2. RCINNUMB - INVALID NUMBER OF KEY PARAMETERS         */
*/*           3. RCDUPKEY - DUPLICATE KEYS SPECIFIED IN TEXT         */
*/*           4. RCINKEYL - INVALID KEY PARAMETER LENGTH             */
*/*           5. RCKEYREQ - REQUIRED KEY NOT SPECIFIED               */
*/*                                                                  */
*/* OUTPUT DATA - KEY TABLE FILLED IN WITH TEXT UNIT ADDRESSES       */
*/*                                                                  */
*/********************************************************************/
*KEYTABLE = KEYTABLE && KEYTABLE;      /* ZERO KEYTABLE              */
         XC    KEYTABLE(56),KEYTABLE                            02S0073
*MASKS = MASKS && MASKS;               /* ZERO MUTUAL & DUPE MASKS   */
         XC    MASKS(4),MASKS                                   02S0074
*CALL IEFDB4FF                         /* CALL SYNTAX CHECKER        */
*             (DINRTVTP,ADDR(KEYDICT),ADDR(DUPEMASK),ADDR(MUTEMASK),
*              ADDR(KEYTABLE),DINRTRN);                         02S0075
         L     @10,@PC00001                                     02S0075
         ST    @10,@AL00001                                     02S0075
         LA    @10,KEYDICT                                      02S0075
         ST    @10,@TF00001                                     02S0075
         LA    @10,@TF00001                                     02S0075
         ST    @10,@AL00001+4                                   02S0075
         LA    @10,DUPEMASK                                     02S0075
         ST    @10,@TF00002                                     02S0075
         LA    @10,@TF00002                                     02S0075
         ST    @10,@AL00001+8                                   02S0075
         LA    @10,MUTEMASK                                     02S0075
         ST    @10,@TF00003                                     02S0075
         LA    @10,@TF00003                                     02S0075
         ST    @10,@AL00001+12                                  02S0075
         LA    @10,KEYTABLE                                     02S0075
         ST    @10,@TF00004                                     02S0075
         LA    @10,@TF00004                                     02S0075
         ST    @10,@AL00001+16                                  02S0075
         L     @10,@PC00001+4                                   02S0075
         ST    @10,@AL00001+20                                  02S0075
         L     @15,@CV00126                                     02S0075
         LA    @01,@AL00001                                     02S0075
         BALR  @14,@15                                          02S0075
*IF ERRCODE = ZERO THEN                /* WAS SYNTAX OK ?            */
         SLR   @10,@10                                          02S0076
         L     @15,@PC00001+4                                   02S0076
         SLR   @14,@14                                          02S0076
         ICM   @14,3,ERRCODE(@15)                               02S0076
         CR    @10,@14                                          02S0076
         BNE   @RF00076                                         02S0076
*  DO;                                 /* YES                        */
*    IF DDNAMTUP = ZERO & DSNAMTUP = ZERO & RELNOTUP = ZERO THEN
         C     @10,DDNAMTUP                                     02S0078
         BNE   @RF00078                                         02S0078
         C     @10,DSNAMTUP                                     02S0078
         BNE   @RF00078                                         02S0078
         C     @10,RELNOTUP                                     02S0078
         BNE   @RF00078                                         02S0078
*      ERRCODE = RCKEYREQ;             /* SET ERRCODE IF REQUIRED KEY
*                                         NOT SPECIFIED              */
         MVC   ERRCODE(2,@15),@CB01331                          02S0079
*  END;                                /* END TEST FOR REQUIRED KEY  */
@RF00078 DS    0H                                               02S0081
*IF ERRCODE = ZERO THEN                /* IS ERRCODE ZERO ?          */
@RF00076 SLR   @10,@10                                          01S0081
         L     @15,@PC00001+4                                   01S0081
         SLR   @14,@14                                          01S0081
         ICM   @14,3,ERRCODE(@15)                               01S0081
         CR    @10,@14                                          01S0081
         BNE   @RF00081                                         01S0081
*  DO;                                 /* YES, REQUIRED KEYS ARE
*                                         PRESENT AND SYNTAX IS GOOD */
*    DSABPTR = DSQFRSTP;               /* GET FIRST DSAB ADDRESS     */
         L     @15,@PC00001+8                                   01S0083
         L     @01,DINJSCBP(,@15)                               01S0083
         L     @01,JSCDSABQ(,@01)                               01S0083
         L     @15,DSQFRSTP(,@01)                               01S0083
         ST    @15,DSABPTR                                      01S0083
*/********************************************************************/
*/*                                                                  */
*/* SEGMENT NAME - DINRTSRC                                          */
*/*                                                                  */
*/* DESCRIPTIVE NAME - DYNAMIC INFORMATION RETRIEVAL SEARCH ROUTINE  */
*/*                                                                  */
*/* FUNCTION - THIS ROUTINE SEARCHES THE DSAB CHAIN BY DDNAME, DSNAME*/
*/*            OR BY RELATIVE NUMBER, DEPENDING ON THE TEXT UNIT     */
*/*            PRESENT, TO FIND A DSAB THAT CORRESPONDS TO           */
*/*            THE REQUEST.                                          */
*/*                                                                  */
*/* OPERATION - THIS ROUTINE IS ENTERED ONLY IF THE SYNTAX IS VALID  */
*/*            AND THERE ARE NO MUTUALLY EXCLUSIVE KEYS PRESENT.     */
*/*            THEREFORE, THE SEARCH WILL BE DONE IN ONE OF THREE    */
*/*            WAYS, DEPENDING ON THE TEXT UNIT POINTER PRESENT      */
*/*            IN THE KEY TABLE.                                     */
*/*                                                                  */
*/*            1. IF THE DDNAME TEXT UNIT PTR IS NON-ZERO, THEN      */
*/*               IEFDB4FC IS INVOKED TO SEARCH FOR THE SPECIFIED    */
*/*               DDNAME.                                            */
*/*            2. IF THE DSNAME TEXT UNIT PTR IS NON-ZERO, THEN      */
*/*               IEFDB4FA IS INVOKED TO SEARCH THE SIOTS            */
*/*               AND JFCB'S FOR THE SPECIFIED DSNAME.               */
*/*            3. THE DSAB CHAIN IS SEARCHED, STARTING FROM THE      */
*/*               FIRST DSAB, UNTIL THE RELATIVE ENTRY IS FOUND OR   */
*/*               THE END OF THE DSAB CHAIN IS REACHED.              */
*/*                                                                  */
*/* ENTRY - DINRTSRC(INCLUDED SEGMENT)                               */
*/*                                                                  */
*/* PURPOSE - SEE FUNCTION                                           */
*/*                                                                  */
*/* INPUT DATA - DSABPTR,JSCBPTR,TEXT PTRS                           */
*/*                                                                  */
*/* EXITS - ALL ARE TO NEXT SEQUENTIAL INSTRUCTION                   */
*/*                                                                  */
*/*  NORMAL - DDNAME,DSNAME OR RELATIVE ENTRY FOUND                  */
*/*                                                                  */
*/*  ERROR - DDNAME,DSNAME OR RELATIVE ENTRY NOT FOUND               */
*/*                                                                  */
*/* OUTPUT - IF NO ERROR, THE DSABPTR HAS THE ADDRESS OF THE DSAB    */
*/*          THAT CORRESPONDS TO THE SPECIFIED DDNAME, DSNAME OR     */
*/*          RELATIVE ENTRY NUMBER.                                  */
*/*                                                                  */
*/*          IF THE SEARCH WAS DONE BY DSNAME, THEN FSTDSBSW IS ON   */
*/*          INDICATING SIOTS AND JFCBS HAVE BEEN READ STARTING AT   */
*/*          THE FIRST DSAB IN THE CHAIN.                            */
*/*                                                                  */
*/*          IF ERROR, ERRCODE IS SET TO:                            */
*/*             1. RCDDNFND IF DDNAME NOT FOUND                      */
*/*             2. RCDSNFND IF DSNAME NOT FOUND                      */
*/*             3. RCRELNNF IF RELATIVE ENTRY NOT FOUND              */
*/*                                                                  */
*/********************************************************************/
*    SWITCHES = ''B;                   /* CLEAR SWITCHES             */
         MVI   SWITCHES,X'00'                                   02S0084
*    IF DDNAMTUP ^= ZERO THEN          /* IS DDNAME TEXT UNIT PRESENT*/
         L     @15,DDNAMTUP                                     02S0085
         CR    @15,@10                                          02S0085
         BE    @RF00085                                         02S0085
*      DO;                             /* YES, SEARCH DSABS BY DDNAME*/
*        TEXTPTR = DDNAMTUP;           /* GET ADDRESS OF TEXT UNIT   */
         LR    TEXTPTR,@15                                      02S0087
*        DDNAREA = '';                 /* BLANK DDNAME AREA          */
         MVI   DDNAREA,C' '                                     02S0088
         MVC   DDNAREA+1(7),DDNAREA                             02S0088
*        DDNAREA(1:TEXTULNG) = TEXTUPAR(1:TEXTULNG); /* MOVE DDNAME  */
         ICM   @03,12,TEXTULNG(TEXTPTR)                         02S0089
         SRA   @03,16                                           02S0089
         BCTR  @03,0                                            02S0089
         EX    @03,@SM01719                                     02S0089
*        DDNAMEP = ADDR(DDNAREA);      /* GET ADDR OF DDNAME AREA    */
         LA    @15,DDNAREA                                      02S0090
         ST    @15,DDNAMEP                                      02S0090
*        RTNADDR = ZERO;               /* ZERO RETURN AREA ADDRESS   */
         ST    @10,RTNADDR                                      02S0091
*        CALL IEFDB4FC                 /* CALL DDNAME SEARCH         */
*                     (DSABPTR,DDNAMEP,ADDR(RTNADDR));          02S0092
         LA    @10,DSABPTR                                      02S0092
         ST    @10,@AL00001                                     02S0092
         LA    @10,DDNAMEP                                      02S0092
         ST    @10,@AL00001+4                                   02S0092
         LA    @10,RTNADDR                                      02S0092
         ST    @10,@TF00001                                     02S0092
         LA    @10,@TF00001                                     02S0092
         ST    @10,@AL00001+8                                   02S0092
         L     @15,@CV00124                                     02S0092
         LA    @01,@AL00001                                     02S0092
         BALR  @14,@15                                          02S0092
*        IF RTNADDR = ZERO THEN        /* WAS DDNAME FOUND IN DSABS ?*/
         L     @10,RTNADDR                                      02S0093
         LTR   @10,@10                                          02S0093
         BNZ   @RF00093                                         02S0093
*          ERRCODE = RCDDNFND;         /* NO, SET DD NOT FND ERR CODE*/
         L     @10,@PC00001+4                                   02S0094
         MVC   ERRCODE(2,@10),@CB01355                          02S0094
*        ELSE                          /* YES, DDNAME WAS FOUND      */
*          DSABPTR = RTNADDR;          /* POINT TO PROPER DSAB       */
         B     @RC00093                                         02S0095
@RF00093 L     @10,RTNADDR                                      02S0095
         ST    @10,DSABPTR                                      02S0095
*      END;                            /* END DDNAME SEARCH          */
*    ELSE;                             /* FALL THROUGH-DDNAME NOT
*                                         SPECIFIED                  */
@RF00085 DS    0H                                               02S0098
*    IF DSNAMTUP ^= ZERO THEN          /* IS DSNAME TEXT UNIT PRESENT*/
@RC00085 L     @10,DSNAMTUP                                     02S0098
         LTR   @10,@10                                          02S0098
         BZ    @RF00098                                         02S0098
*      DO;                             /* YES,SEARCH BY DSNAME       */
*        RESPECIFY S99TUNIT BASED(DSNAMTUP);                    02S0100
*        IF S99TUPAR(1:2) = '&&' THEN  /* IS DSN OF FORM,&&NAME      */
         CLC   S99TUPAR(2,@10),@CC01704                         02S0101
         BNE   @RF00101                                         02S0101
*          DO;                         /* YES, MAKE TU OF FORM,&NAME */
*            DSNAMKEY = S99TUKEY;      /* MOVE IN DSNAME KEY         */
         MVC   DSNAMKEY(2),S99TUKEY(@10)                        02S0103
*            DSNAMNUM = S99TUNUM;      /* MOVE IN NUMBER OF PARMS    */
         MVC   DSNAMNUM(2),S99TUNUM(@10)                        02S0104
*            DSNAMLEN = S99TULNG - 1;  /* SET LENGTH FOR &NAME       */
         ICM   @15,12,S99TULNG(@10)                             02S0105
         SRA   @15,16                                           02S0105
         LR    @14,@15                                          02S0105
         BCTR  @14,0                                            02S0105
         STH   @14,DSNAMLEN                                     02S0105
*            DSNAMPAR = S99TUPAR(2:S99TULNG); /* MOVE &NAME TO TU    */
         MVI   DSNAMPAR+1,C' '                                  02S0106
         MVC   DSNAMPAR+2(42),DSNAMPAR+1                        02S0106
         BCTR  @15,0                                            02S0106
         BCTR  @15,0                                            02S0106
         EX    @15,@SM01721                                     02S0106
*            DSNAMTUP = ADDR(DSNAMTU); /* SET PTR TO NEW TEXT UNIT   */
         LA    @10,DSNAMTU                                      02S0107
         ST    @10,DSNAMTUP                                     02S0107
*          END;                                                 02S0108
*        TEXTPTR = DSNAMTUP;           /* GET ADDRESS OF TEXT UNIT   */
@RF00101 L     TEXTPTR,DSNAMTUP                                 02S0109
*        DSNPTR = ADDR(TEXTUENT);      /* GET ADDR OF DSNAME INFO    */
         LA    @10,TEXTUENT(,TEXTPTR)                           02S0110
         ST    @10,DSNPTR                                       02S0110
*        FUNCTION = FUNCTION && FUNCTION; /* ZERO FUNCTION MAP       */
         XC    FUNCTION(2),FUNCTION                             02S0111
*        JFCBALNM = ON;                /* INDICATE SEARCH JFCB AND
*                                         ALTERNATE NAME             */
         OI    JFCBALNM,B'00100000'                             02S0112
*        RTNADDR = ZERO;               /* ZERO RETURN AREA           */
         SLR   @10,@10                                          02S0113
         ST    @10,RTNADDR                                      02S0113
*        CALL IEFDB4FA                 /* CALL DSNAME SEARCH ROUTINE */
*                     (DSABPTR,DSNPTR,RTNADDR,FUNCTION);        02S0114
         LA    @10,DSABPTR                                      02S0114
         ST    @10,@AL00001                                     02S0114
         LA    @10,DSNPTR                                       02S0114
         ST    @10,@AL00001+4                                   02S0114
         LA    @10,RTNADDR                                      02S0114
         ST    @10,@AL00001+8                                   02S0114
         LA    @10,FUNCTION                                     02S0114
         ST    @10,@AL00001+12                                  02S0114
         L     @15,@CV00123                                     02S0114
         LA    @01,@AL00001                                     02S0114
         BALR  @14,@15                                          02S0114
*        IF RTNADDR = ZERO THEN        /* WAS DSNAME FOUND ?         */
         L     @10,RTNADDR                                      02S0115
         LTR   @10,@10                                          02S0115
         BNZ   @RF00115                                         02S0115
*          ERRCODE = RCDSNFND;         /* SET DSNAME NOT FOUND ERRCDE*/
         L     @10,@PC00001+4                                   02S0116
         MVC   ERRCODE(2,@10),@CB01359                          02S0116
*        ELSE                          /* OTHERWISE, DSNAME FOUND    */
*          DSABPTR = RTNADDR;          /* POINT TO PROPER DSAB       */
         B     @RC00115                                         02S0117
@RF00115 L     @10,RTNADDR                                      02S0117
         ST    @10,DSABPTR                                      02S0117
*      END;                            /* END DSNAME TEXT UNIT PRESENT
*                                         PROCESSING                 */
*    ELSE;                             /* FALL THROUGH - DSNAME NOT
*                                         SPECIFIED                  */
@RF00098 DS    0H                                               02S0120
*    IF RELNOTUP ^= ZERO THEN          /* IS RELATIVE # TEXT PRESENT */
@RC00098 L     @10,RELNOTUP                                     02S0120
         SLR   @15,@15                                          02S0120
         CR    @10,@15                                          02S0120
         BE    @RF00120                                         02S0120
*      DO;                             /* YES, SEARCH BY RELATIVE #  */
*        TEXTPTR = RELNOTUP;           /* GET ADDRESS OF TEXT UNIT   */
         LR    TEXTPTR,@10                                      02S0122
*        IF TEXTUPAR(1:2) <= ZERO | DSABPTR = ZERO THEN /* IS RELATIVE
*                                       # <= 0 OR NO DSABS PRESENT ? */
         SLR   @10,@10                                          02S0123
         ICM   @10,3,TEXTUPAR(TEXTPTR)                          02S0123
         CR    @15,@10                                          02S0123
         BNL   @RT00123                                         02S0123
         C     @15,DSABPTR                                      02S0123
         BNE   @RF00123                                         02S0123
@RT00123 DS    0H                                               02S0124
*          ERRCODE = RCRELNNF;         /* YES SET ERRCODE            */
         L     @10,@PC00001+4                                   02S0124
         MVC   ERRCODE(2,@10),@CB01361                          02S0124
*        CONTINUE = ON;                /* INITIALIZE SWITCH          */
@RF00123 OI    CONTINUE,B'10000000'                             02S0125
*        DSABNBR = 1;                  /* SET DSAB COUNT TO 1        */
         LA    DSABNBR,1                                        02S0126
*        DO WHILE (ERRCODE = ZERO & CONTINUE = ON); /* LOOP CONTROL  */
         B     @DE00127                                         02S0127
@DL00127 DS    0H                                               02S0128
*          IF DSABNBR = TEXTUPAR(1:2) THEN /*WAS RELATIVE DSAB FOUND?*/
         SLR   @10,@10                                          02S0128
         ICM   @10,3,TEXTUPAR(TEXTPTR)                          02S0128
         CR    DSABNBR,@10                                      02S0128
         BNE   @RF00128                                         02S0128
*            CONTINUE = OFF;           /* YES, STOP PROCESSING       */
         NI    CONTINUE,B'01111111'                             02S0129
*          ELSE                        /* OTHERWISE, CONTINUE SEARCH */
*            DO;                       /* CONTINUE DSAB SEARCH       */
         B     @RC00128                                         02S0130
@RF00128 DS    0H                                               02S0131
*              IF DSABFCHN ^= ZERO THEN /* END OF DSAB CHAIN ?       */
         L     @10,DSABPTR                                      02S0131
         L     @10,DSABFCHN(,@10)                               02S0131
         LTR   @10,@10                                          02S0131
         BZ    @RF00131                                         02S0131
*                DO;                   /* NO, UPDATE POINTER & COUNT */
*                  DSABPTR = DSABFCHN; /* UPDATE DSABPTR             */
         ST    @10,DSABPTR                                      02S0133
*                  DSABNBR = DSABNBR + 1; /* INCREMENT DSAB COUNT    */
         AL    DSABNBR,@CF00084                                 02S0134
*                END;                  /* END OF PTR UPDATE          */
*              ELSE                    /* OTHERWISE, END OF DSAB CHN */
*                ERRCODE = RCRELNNF;   /* SET DSAB NOT FOUND ERRCODE */
         B     @RC00131                                         02S0136
@RF00131 L     @10,@PC00001+4                                   02S0136
         MVC   ERRCODE(2,@10),@CB01361                          02S0136
*            END;                      /* END DSAB SEARCH            */
@RC00131 DS    0H                                               02S0138
*        END;                          /* END OF LOOP CONTROL        */
@RC00128 DS    0H                                               02S0138
@DE00127 L     @10,@PC00001+4                                   02S0138
         ICM   @15,3,ERRCODE(@10)                               02S0138
         BNZ   @DC00127                                         02S0138
         TM    CONTINUE,B'10000000'                             02S0138
         BO    @DL00127                                         02S0138
@DC00127 DS    0H                                               02S0139
*      END;                            /* END RELATIVE # PROCESSING  */
*    ELSE;                             /* RELATIVE # NOT SPECIFIED   */
@RF00120 DS    0H                                               02S0141
*  END;                                /* END SEARCH FOR PROPER DSAB */
*IF ERRCODE = ZERO THEN                /* IF ERRCODE = 0, THEN PROPER
*                                         DSAB FOUND                 */
@RF00081 SLR   @10,@10                                          01S0142
         L     @15,@PC00001+4                                   01S0142
         SLR   @14,@14                                          01S0142
         ICM   @14,3,ERRCODE(@15)                               01S0142
         CR    @10,@14                                          01S0142
         BNE   @RF00142                                         01S0142
*  DO;                                 /* 0 ERRCODE, RETRIEVE DATA   */
*/********************************************************************/
*/*                                                                  */
*/* SEGMENT NAME - RETRIEVE                                          */
*/*                                                                  */
*/* DESCRIPTIVE NAME - RETRIEVE REQUESTED INFORMATION                */
*/*                                                                  */
*/* FUNCTION - THIS ROUTINE DETERMINES WHAT INFORMATION HAS BEEN     */
*/*            REQUESTED AND EXAMINES CONTROL BLOCKS IN ORDER TO     */
*/*            OBTAIN THE NECESSARY DATA. THE DATA IS STORED         */
*/*            INTO THE TEXT UNIT PARM FIELDS.                       */
*/*                                                                  */
*/* OPERATION - THE KEY TABLE IS INTERROGATED TO DETERMINE WHICH KEYS*/
*/*             HAVE BEEN SPECIFIED.  THE DATA IS THEN STORED INTO   */
*/*             THE ASSOCIATED TEXT UNITS, AFTER RETRIEVING IT       */
*/*             FROM THE APPROPRIATE CONTROL BLOCKS.                 */
*/*                                                                  */
*/*             IF RETURN DSORG (KEY DINRTORG) HAS BEEN SPECIFIED,   */
*/*             IEFDB4FE IS INVOKED ONLY IF THE DSORG FIELD IN       */
*/*             THE DSAB IS 0.                                       */
*/*                                                                  */
*/* ENTRY - RETRIEVE (INCLUDED SEGMENT)                              */
*/*                                                                  */
*/* PURPOSE - SEE FUNCTION                                           */
*/*                                                                  */
*/* INPUT DATA - TEXT UNITS,KEY TABLE                                */
*/*                                                                  */
*/* EXITS - ALL ARE TO NEXT SEQUENTIAL INSTRUCTION                   */
*/*                                                                  */
*/*  NORMAL - ERRCODE IS ZERO AND ALL REQUESTED DATA RETURNED        */
*/*                                                                  */
*/*  ERROR - NONE                                                    */
*/*                                                                  */
*/* OUTPUT DATA - TEXT UNITS CONTAIN DATA REQUESTED.                 */
*/*                                                                  */
*/********************************************************************/
*    IF RTDDNTUP  ^= ZERO THEN         /* RETURN DDNAME REQUESTED ?  */
         L     @15,RTDDNTUP                                     02S0144
         CR    @15,@10                                          02S0144
         BE    @RF00144                                         02S0144
*      DO;                             /* YES                        */
*        TEXTPTR = RTDDNTUP;           /* GET TEXT UNIT POINTER      */
         LR    TEXTPTR,@15                                      02S0146
*        LIMIT = 8;                    /* SET MAX # OF CHAR TO SCAN  */
         LA    LIMIT,8                                          02S0147
*        CHARPTR = ADDR(TIOEDDNM);     /* ADDR OF FIELD TO SCAN      */
         L     @10,DSABPTR                                      02S0148
         L     CHARPTR,DSABTIOT(,@10)                           02S0148
         LA    CHARPTR,TIOEDDNM(,CHARPTR)                       02S0148
*        CALL BLNKSCAN;                /* CALL ROUTINE TO SCAN FOR
*                                         BLANKS AND MOVE FIELD      */
         BAL   @14,BLNKSCAN                                     02S0149
*      END;                            /* END RETURN DDNAME REQUEST  */
*                                                               02S0150
*    IF RTDSNTUP ^= ZERO THEN          /* RETURN DSNAME REQUESTED?   */
@RF00144 L     @10,RTDSNTUP                                     02S0151
         LTR   @10,@10                                          02S0151
         BZ    @RF00151                                         02S0151
*      DO;                             /* YES                        */
*        TEXTPTR = RTDSNTUP;           /* GET TEXT UNIT POINTER      */
         LR    TEXTPTR,@10                                      02S0153
*        LIMIT = 44;                   /* SET MAX # OF CHAR TO SCAN  */
         LA    LIMIT,44                                         02S0154
*        CHARPTR = ADDR(JFCBDSNM);     /* GET ADDRESS OF DSNAME FIELD*/
         L     @10,DSABPTR                                      02S0155
         L     @10,DSABSIOT(,@10)                               02S0155
         L     CHARPTR,SJFCBPTR(,@10)                           02S0155
*        CALL BLNKSCAN;                /* CALL ROUTINE TO SCAN FOR
*                                         BLANKS AND MOVE FIELD      */
         BAL   @14,BLNKSCAN                                     02S0156
*      END;                            /* END RETURN DSNAME REQUEST  */
*                                                               02S0157
*    IF RTMEMTUP ^= ZERO THEN          /* RETURN MEMBERNAME REQUESTED*/
@RF00151 L     @10,RTMEMTUP                                     02S0158
         LTR   @10,@10                                          02S0158
         BZ    @RF00158                                         02S0158
*      DO;                             /* YES                        */
*        TEXTPTR = RTMEMTUP;           /* GET TEXT UNIT POINTER      */
         LR    TEXTPTR,@10                                      02S0160
*        LIMIT = 8;                    /* SET MAX # OF CHAR TO SCAN  */
         LA    LIMIT,8                                          02S0161
*        CHARPTR = ADDR(JFCBELNM);     /* ADDR OF FIELD TO SCAN      */
         L     @10,DSABPTR                                      02S0162
         L     @10,DSABSIOT(,@10)                               02S0162
         L     CHARPTR,SJFCBPTR(,@10)                           02S0162
         LA    CHARPTR,JFCBELNM(,CHARPTR)                       02S0162
*        CALL BLNKSCAN;                /* CALL ROUTINE TO SCAN FOR
*                                         BLANKS AND MOVE FIELD      */
         BAL   @14,BLNKSCAN                                     02S0163
*      END;                            /* END RETURN MBRNAME REQUEST */
*                                                               02S0164
*    IF RTSTATUP ^= ZERO THEN          /* RETURN STATUS REQUESTED ?  */
@RF00158 L     @10,RTSTATUP                                     02S0165
         LTR   @10,@10                                          02S0165
         BZ    @RF00165                                         02S0165
*      DO;                             /* YES                        */
*        TEXTPTR = RTSTATUP;           /* GET TEXT UNIT POINTER      */
         LR    TEXTPTR,@10                                      02S0167
*        IF SCTSOLD = ON & JFCSHARE = ON THEN     /* IS STATUS SHR ? */
         L     @10,DSABPTR                                      02S0168
         L     @10,DSABSIOT(,@10)                               02S0168
         TM    SCTSOLD(@10),B'00000001'                         02S0168
         BNO   @RF00168                                         02S0168
         L     @10,SJFCBPTR(,@10)                               02S0168
         TM    JFCSHARE(@10),B'00001000'                        02S0168
         BNO   @RF00168                                         02S0168
*          TEXTUPAR(1) = '08'X;        /* YES, SET TO SHR            */
         MVI   TEXTUPAR(TEXTPTR),X'08'                          02S0169
*        ELSE                          /* OTHERWISE NOT SHR          */
*          DO;                         /* SET STATUS                 */
         B     @RC00168                                         02S0170
@RF00168 DS    0H                                               02S0171
*            IF JFCDISP = '10'B | JFCMODNW = ON THEN  /* STATUS MOD? */
         L     @10,DSABPTR                                      02S0171
         L     @10,DSABSIOT(,@10)                               02S0171
         L     @10,SJFCBPTR(,@10)                               02S0171
         TM    JFCDISP(@10),B'10000000'                         02S0171
         BNO   @GL00006                                         02S0171
         TM    JFCDISP(@10),B'01000000'                         02S0171
         BZ    @RT00171                                         02S0171
@GL00006 L     @10,DSABPTR                                      02S0171
         L     @10,DSABSIOT(,@10)                               02S0171
         L     @10,SJFCBPTR(,@10)                               02S0171
         TM    JFCMODNW(@10),B'00010000'                        02S0171
         BNO   @RF00171                                         02S0171
@RT00171 DS    0H                                               02S0172
*              TEXTUPAR(1) = '02'X;    /* RETURN MOD STATUS          */
         MVI   TEXTUPAR(TEXTPTR),X'02'                          02S0172
*            ELSE                      /* NOT MOD                    */
*              DO;                     /* RETURN STATUS              */
         B     @RC00171                                         02S0173
@RF00171 DS    0H                                               02S0174
*                TEXTUPAR(1) = SCTSBYT3; /* MOVE STATUS BYTE         */
         L     @10,DSABPTR                                      02S0174
         L     @10,DSABSIOT(,@10)                               02S0174
         MVC   TEXTUPAR(1,TEXTPTR),SCTSBYT3(@10)                02S0174
*                TEXTUPAR(1) = TEXTUPAR(1) & '07'X; /* CLEAR BITS NOT
*                                                      NECESSARY     */
         NI    TEXTUPAR(TEXTPTR),X'07'                          02S0175
*              END;                    /* END STATUS RETURN          */
*          END;                        /* END STATUS BYTE MOVE       */
@RC00171 DS    0H                                               02S0178
*      END;                            /* END RETURN STATUS REQUEST  */
*                                                               02S0178
@RC00168 DS    0H                                               02S0179
*    IF RTNDPTUP ^= ZERO THEN          /* RETURN NORMAL DISP REQUEST?*/
@RF00165 L     @10,RTNDPTUP                                     02S0179
         LTR   @10,@10                                          02S0179
         BZ    @RF00179                                         02S0179
*      DO;                             /* YES                        */
*        TEXTPTR = RTNDPTUP;           /* GET TEXT UNIT POINTER      */
         LR    TEXTPTR,@10                                      02S0181
*        TEXTUPAR(1) = SCTSDISP;       /* MOVE DISP FIELD            */
         L     @10,DSABPTR                                      02S0182
         L     @10,DSABSIOT(,@10)                               02S0182
         MVC   TEXTUPAR(1,TEXTPTR),SCTSDISP(@10)                02S0182
*        TEXTUPAR(1) = TEXTUPAR(1) & '1F'X;  /* CLEAR UNEEDED BITS   */
         NI    TEXTUPAR(TEXTPTR),X'1F'                          02S0183
*      END;                            /* END RETURN NORMAL DISP REQ */
*    IF RTCDPTUP ^= ZERO THEN          /* RETURN CONDITION DISP REQ  */
@RF00179 L     @10,RTCDPTUP                                     02S0185
         LTR   @10,@10                                          02S0185
         BZ    @RF00185                                         02S0185
*      DO;                             /* YES                        */
*        TEXTPTR = RTCDPTUP;           /* GET TEXT UNIT POINTER      */
         LR    TEXTPTR,@10                                      02S0187
*        TEXTUPAR(1) = SIOTALTD;       /* MOVE CONDITIONAL DISP FIELD*/
         L     @10,DSABPTR                                      02S0188
         L     @10,DSABSIOT(,@10)                               02S0188
         MVC   TEXTUPAR(1,TEXTPTR),SIOTALTD(@10)                02S0188
*        TEXTUPAR(1) = TEXTUPAR(1) & '0F'X; /* CLEAR UNEEDED BITS    */
         NI    TEXTUPAR(TEXTPTR),X'0F'                          02S0189
*      END;                            /* END RETURN COND DISP REQ   */
*                                                               02S0190
*    IF RTORGTUP ^= ZERO THEN          /* RETURN DSORG REQUEST ?     */
@RF00185 SLR   @10,@10                                          02S0191
         C     @10,RTORGTUP                                     02S0191
         BE    @RF00191                                         02S0191
*      DO;                             /* YES                        */
*        IF DSABORG = 0 THEN           /* IS DSORG FILLED IN IN DSAB */
         L     @01,DSABPTR                                      02S0193
         LH    @15,DSABORG(,@01)                                02S0193
         N     @15,@CF01726                                     02S0193
         CR    @10,@15                                          02S0193
         BNE   @RF00193                                         02S0193
*          CALL IEFDB4FE (DSABPTR);    /* CALL RETURN DSORG ROUTINE  */
         LA    @10,DSABPTR                                      02S0194
         ST    @10,@AL00001                                     02S0194
         L     @15,@CV00125                                     02S0194
         LA    @01,@AL00001                                     02S0194
         BALR  @14,@15                                          02S0194
*        ELSE;                         /* DSORG IS PRESENT           */
@RF00193 DS    0H                                               02S0196
*        TEXTPTR = RTORGTUP;           /* GET TEXT UNIT POINTER      */
         L     TEXTPTR,RTORGTUP                                 02S0196
*        TEXTUPAR(1:2) = DSABORG(1:2); /* MOVE DSORG FROM DSAB TO
*                                         TEXT UNIT PARM FIELD       */
         L     @10,DSABPTR                                      02S0197
         MVC   TEXTUPAR(2,TEXTPTR),DSABORG(@10)                 02S0197
*      END;                            /* END RETURN DSORG REQUEST   */
*    IF RTLIMTUP ^= ZERO THEN          /* RETURN LIMIT REQUEST ?     */
@RF00191 L     @10,RTLIMTUP                                     02S0199
         LTR   @10,@10                                          02S0199
         BZ    @RF00199                                         02S0199
*      DO;                             /* YES                        */
*        TEXTPTR = RTLIMTUP;           /* GET TEXT UNIT ADDRESS      */
         LR    TEXTPTR,@10                                      02S0201
*        LOOPPTR = DSQFRSTP;           /* GET FIRST DSAB ADDRESS     */
         L     @10,@PC00001+8                                   02S0202
         L     @10,DINJSCBP(,@10)                               02S0202
         L     @10,JSCDSABQ(,@10)                               02S0202
         L     LOOPPTR,DSQFRSTP(,@10)                           02S0202
*        NUSECNT = ZERO;               /* ZERO NOT IN-USE COUNT      */
         SLR   NUSECNT,NUSECNT                                  02S0203
*        DO WHILE (LOOPPTR ^= ZERO);   /* COUNT NOT IN-USE PALC DSABS*/
         B     @DE00204                                         02S0204
@DL00204 DS    0H                                               02S0205
*          IF LOOPPTR -> DSABNUSE = OFF /* NOT INUSE ?               */
*          & LOOPPTR ->  DSABOPCT = 0  /* NOT OPEN ?                 */
*          & LOOPPTR -> DSABPALC = ON  /* PERM ALLOC ?               */
*          & LOOPPTR -> DSABSIOT -> SIOTGDGA = OFF THEN /* NOT SYSTEM
*                                         GENERATED REQUEST ?        */
         TM    DSABNUSE(LOOPPTR),B'00000001'                    02S0205
         BNZ   @RF00205                                         02S0205
         LH    @10,DSABOPCT(,LOOPPTR)                           02S0205
         LTR   @10,@10                                          02S0205
         BNZ   @RF00205                                         02S0205
         TM    DSABPALC(LOOPPTR),B'01000000'                    02S0205
         BNO   @RF00205                                         02S0205
         L     @10,DSABSIOT(,LOOPPTR)                           02S0205
         TM    SIOTGDGA(@10),B'01000000'                        02S0205
         BNZ   @RF00205                                         02S0205
*            NUSECNT = NUSECNT + 1;    /* INCREMENT COUNT            */
         AL    NUSECNT,@CF00084                                 02S0206
*          LOOPPTR =  LOOPPTR -> DSABFCHN; /* GET NEXT DSAB ADDR     */
@RF00205 L     LOOPPTR,DSABFCHN(,LOOPPTR)                       02S0207
*        END;                          /* END NOT-IN-USE COUNT LOOP  */
@DE00204 SLR   @10,@10                                          02S0208
         CR    LOOPPTR,@10                                      02S0208
         BNE   @DL00204                                         02S0208
*        TEXTUPAR(1:2) = (NUSECNT - SCTNIUSL); /* RETURN LIMIT       */
         L     @05,@PC00001+8                                   02S0209
         L     @05,DINSCTP(,@05)                                02S0209
         LR    @03,NUSECNT                                      02S0209
         LH    @05,SCTNIUSL(,@05)                               02S0209
         N     @05,@CF01726                                     02S0209
         SLR   @03,@05                                          02S0209
         STCM  @03,3,TEXTUPAR(TEXTPTR)                          02S0209
*        IF (NUSECNT - SCTNIUSL) < ZERO THEN /* IS LIMIT NEGATIVE ?  */
         CR    @03,@10                                          02S0210
         BNL   @RF00210                                         02S0210
*           TEXTUPAR(1:2) = 0;         /* SET IT TO ZERO             */
         STCM  @10,3,TEXTUPAR(TEXTPTR)                          02S0211
*      END;                            /* END RETURN LIMIT REQUEST   */
@RF00210 DS    0H                                               02S0213
*    IF RTATTTUP ^= ZERO THEN          /* RETURN ATTRIBUTE REQUEST ? */
@RF00199 L     @10,RTATTTUP                                     02S0213
         LTR   @10,@10                                          02S0213
         BZ    @RF00213                                         02S0213
*      DO;                             /* YES                        */
*        TEXTPTR = RTATTTUP;           /* GET TEXT UNIT POINTER      */
         LR    TEXTPTR,@10                                      02S0215
*        TEXTUPAR(1) = '00'X;          /* ZERO PARM FIELD            */
         MVI   TEXTUPAR(TEXTPTR),X'00'                          02S0216
*        IF DSABPCAT = ON THEN         /* PERM CONCAT BIT ON ?       */
         L     @10,DSABPTR                                      02S0217
         TM    DSABPCAT(@10),B'00000100'                        02S0217
         BNO   @RF00217                                         02S0217
*          TEXTUPAR(1) = TEXTUPAR(1) | '80'X; /* INDICATE PERM CONCAT*/
         OI    TEXTUPAR(TEXTPTR),X'80'                          02S0218
*        IF DSABNUSE = ON | DSABOPCT > 0 THEN /* IS DSAB IN-USE ?    */
@RF00217 L     @10,DSABPTR                                      02S0219
         TM    DSABNUSE(@10),B'00000001'                        02S0219
         BO    @RT00219                                         02S0219
         LH    @10,DSABOPCT(,@10)                               02S0219
         LTR   @10,@10                                          02S0219
         BNP   @RF00219                                         02S0219
@RT00219 DS    0H                                               02S0220
*          TEXTUPAR(1) = TEXTUPAR(1) | '40'X; /* INDICATE IN-USE     */
         OI    TEXTUPAR(TEXTPTR),X'40'                          02S0220
*                                      /* CONTINUE                   */
*        IF DSABPALC = ON THEN         /* IS DSAB MARKED PERM ALLOC ?*/
@RF00219 L     @10,DSABPTR                                      02S0221
         TM    DSABPALC(@10),B'01000000'                        02S0221
         BNO   @RF00221                                         02S0221
*          TEXTUPAR(1) = TEXTUPAR(1) | '20'X; /* INDICATE PALOC      */
         OI    TEXTUPAR(TEXTPTR),X'20'                          02S0222
*        IF DSABCONV = ON THEN         /* IS DSAB MARKED CONVERTIBLE?*/
@RF00221 L     @10,DSABPTR                                      02S0223
         TM    DSABCONV(@10),B'00010000'                        02S0223
         BNO   @RF00223                                         02S0223
*          TEXTUPAR(1) = TEXTUPAR(1) | '10'X; /* INDICATE CONV       */
         OI    TEXTUPAR(TEXTPTR),X'10'                          02S0224
*        IF DSABDALC=ON THEN           /* IF DSAB MARKED DYNAMICALLY
*                                         ALLOCATED THEN     @Z40NQPE*/
@RF00223 L     @10,DSABPTR                                      02S0225
         TM    DSABDALC(@10),B'10000000'                        02S0225
         BNO   @RF00225                                         02S0225
*          TEXTUPAR(1)=TEXTUPAR(1) | '08'X; /*INDICATE DYNAMICALLY
*                                         ALLOCATED ATTRIBUTE IN TEXT
*                                         UNIT PARM FIELD.   @Z40NQPE*/
         OI    TEXTUPAR(TEXTPTR),X'08'                          02S0226
*      END;                            /* END RETURN ATTRIBUTE       */
@RF00225 DS    0H                                               02S0228
*    IF RTLSTTUP ^= ZERO THEN          /* RETURN LAST DSAB INDICATOR?*/
@RF00213 L     @10,RTLSTTUP                                     02S0228
         SLR   @15,@15                                          02S0228
         CR    @10,@15                                          02S0228
         BE    @RF00228                                         02S0228
*      DO;                             /* YES                        */
*        TEXTPTR = RTLSTTUP;           /* GET TEXT UNIT POINTER      */
         LR    TEXTPTR,@10                                      02S0230
*        IF DSABFCHN = ZERO THEN       /* LAST ENTRY ?               */
         L     @10,DSABPTR                                      02S0231
         C     @15,DSABFCHN(,@10)                               02S0231
         BNE   @RF00231                                         02S0231
*          TEXTUPAR(1) = '80'X;        /* YES, INDICATE LAST ENTRY   */
         MVI   TEXTUPAR(TEXTPTR),X'80'                          02S0232
*        ELSE                          /* OTHERWISE NOT LAST ENTRY   */
*          TEXTUPAR(1) = '00'X;        /* INDICATE NOT LAST ENTRY    */
         B     @RC00231                                         02S0233
@RF00231 MVI   TEXTUPAR(TEXTPTR),X'00'                          02S0233
*      END;                            /* END RETURN LAST DSAB CODE  */
*                                                               02S0234
@RC00231 DS    0H                                               02S0235
*    IF RTTYPTUP ^= ZERO THEN          /* RETURN DATASET TYPE REQ ?  */
@RF00228 L     @10,RTTYPTUP                                     02S0235
         LTR   @10,@10                                          02S0235
         BZ    @RF00235                                         02S0235
*      DO;                             /* YES                        */
*        TEXTPTR = RTTYPTUP;           /* GET TEXT UNIT POINTER      */
         LR    TEXTPTR,@10                                      02S0237
*        IF TIOTTERM = ON THEN         /* TERMINAL DATASET ?         */
         L     @10,DSABPTR                                      02S0238
         L     @10,DSABTIOT(,@10)                               02S0238
         TM    TIOTTERM(@10),B'00100000'                        02S0238
         BNO   @RF00238                                         02S0238
*          TEXTUPAR(1) = '40'X;        /* YES, SET TERMINAL INDICATOR*/
         MVI   TEXTUPAR(TEXTPTR),X'40'                          02S0239
*        ELSE                          /* NOT A TERMINAL DATASET     */
*          IF SCTDUMMY = ON & TIOEQNAM = OFF THEN /* IS THIS A DUMMY?*/
         B     @RC00238                                         02S0240
@RF00238 L     @10,DSABPTR                                      02S0240
         L     @03,DSABSIOT(,@10)                               02S0240
         TM    SCTDUMMY(@03),B'10000000'                        02S0240
         BNO   @RF00240                                         02S0240
         L     @10,DSABTIOT(,@10)                               02S0240
         TM    TIOEQNAM(@10),B'00001000'                        02S0240
         BNZ   @RF00240                                         02S0240
*            TEXTUPAR(1) = '80'X;      /* YES, SET DUMMY INDICATOR   */
         MVI   TEXTUPAR(TEXTPTR),X'80'                          02S0241
*          ELSE                        /* NON DUMMY                  */
*            TEXTUPAR(1) = '00'X;      /* NON-DUMMY/NON-TERMINAL     */
         B     @RC00240                                         02S0242
@RF00240 MVI   TEXTUPAR(TEXTPTR),X'00'                          02S0242
*      END;                            /* END RETURN DATASET TYPE    */
@RC00240 DS    0H                                               02S0243
@RC00238 DS    0H                                               02S0244
*  END;                                /* END DSAB FOUND PROCESSING  */
@RF00235 DS    0H                                               01S0245
*RETURN CODE(0);                       /* PASS RETURN CODE           */
@RF00142 L     @13,4(,@13)                                      01S0245
         L     @00,@SIZDATD                                     01S0245
         LR    @01,@11                                          01S0245
         FSPACE   R,LV=(0),A=(1)
         SLR   @15,@15                                          01S0245
         L     @14,12(,@13)                                     01S0245
         LM    @00,@12,20(@13)                                  01S0245
         BR    @14                                              01S0245
*/********************************************************************/
*/*                                                                  */
*/* SEGMENT NAME - BLNKSCAN                                          */
*                                      /*                    @ZA02706*/
*/*                                                                  */
*/* A 002843,004973-005013                                   @ZA02706*/
*/* C 011923                                                 @ZA02706*/
*/* DESCRIPTIVE NAME - BLANK SCAN ROUTINE                            */
*/*                                                                  */
*/* FUNCTION - THIS ROUTINE IS INVOKED WHEN IT IS NECESSARY TO RETURN*/
*/*            THE DDNAME, DSNAME OR MEMBERNAME AND ITS LENGTH.      */
*/*                                                                  */
*/* OPERATION - TO DETERMINE THE LENGTH OF A NAME, THE FIELD IS      */
*/*             SEARCHED FOR A BLANK, COUNTING THE NON-BLANK         */
*/*             CHARACTERS UNTIL A BLANK IS FOUND OR THE MAXIMUM     */
*/*             LENGTH OF THE FIELD HAS BEEN SCANNED. THE NAME AND   */
*/*             LENGTH ARE STORED IN THE APPROPRIATE TEXT UNIT.      */
*/*                                                                  */
*/* ENTRY - BLNKSCAN (INTERNAL PROCEDURE)                            */
*/*                                                                  */
*/* PURPOSE - SEE FUNCTION                                           */
*/*                                                                  */
*/* INPUT DATA - LIMIT - THE MAXIMUM SIZE OF FIELD TO BE SCANNED     */
*/*              CHARPTR - POINTER TO FIELD TO BE SCANNED            */
*/*              TEXTPTR - POINTER TO TEXT UNIT TO STORE INTO        */
*/*                                                                  */
*/* EXITS - ALL ARE TO NEXT SEQUENTIAL INSTRUCTION                   */
*/*                                                                  */
*/*  NORMAL - RETURN VIA REG 14                                      */
*/*                                                                  */
*/*  ERROR - NONE                                                    */
*/*                                                                  */
*/* OUTPUT DATA - NAME AND LENGTH STORED INTO TEXT UNIT              */
*/*                                                                  */
*/********************************************************************/
*BLNKSCAN: PROC;                                                02S0246
BLNKSCAN STM   @14,@12,12(@13)                                  02S0246
*CHARCNT = ZERO;                       /* INIT CHAR COUNT TO 0       */
         SLR   CHARCNT,CHARCNT                                  02S0247
*DO WHILE (CHARCNT < LIMIT & DATA ^= ' '); /* SCAN FIELD FOR A BLANK */
         B     @DE00248                                         02S0248
@DL00248 DS    0H                                               02S0249
*  CHARCNT = CHARCNT + 1;              /* INCREMENT CHARACTER COUNT  */
         LA    @10,1                                            02S0249
         ALR   CHARCNT,@10                                      02S0249
*  CHARPTR = CHARPTR + 1;              /* INCREMENT PTR TO NEXT CHAR */
         ALR   CHARPTR,@10                                      02S0250
*END;                                  /* END CHARACTER SCAN         */
@DE00248 CR    CHARCNT,LIMIT                                    02S0251
         BNL   @DC00248                                         02S0251
         CLI   DATA(CHARPTR),C' '                               02S0251
         BNE   @DL00248                                         02S0251
@DC00248 DS    0H                                               02S0252
*IF CHARCNT > 0 THEN                   /* WAS NON-BLANK FOUND        */
         LTR   CHARCNT,CHARCNT                                  02S0252
         BNP   @RF00252                                         02S0252
*  TEXTUPAR(1:CHARCNT) = DATFIELD(1:CHARCNT);/*MOVE DATA TO TEXT UNIT*/
         LR    @10,CHARCNT                                      02S0253
         BCTR  @10,0                                            02S0253
         LR    @05,CHARPTR                                      02S0253
         SLR   @05,CHARCNT                                      02S0253
         EX    @10,@SM01727                                     02S0253
*ELSE;                                 /* NOTHING TO MOVE            */
@RF00252 DS    0H                                               02S0255
*TEXTULNG = CHARCNT;                   /* STORE LENGTH EVEN IF ZERO  */
         STCM  CHARCNT,3,TEXTULNG(TEXTPTR)                      02S0255
*END BLNKSCAN;                                                  02S0256
@EL00002 DS    0H                                               02S0256
@EF00002 DS    0H                                               02S0256
@ER00002 LM    @14,@12,12(@13)                                  02S0256
         BR    @14                                              02S0256
*END IEFDB470                                                   01S0257
*/* THE FOLLOWING INCLUDE STATEMENTS WERE FOUND IN THIS PROGRAM.      *
*/*%INCLUDE SYSLIB  (DINRTVSP)                                        *
*/*%INCLUDE SYSLIB  (DINRTVDT)                                        *
*/*%INCLUDE SYSLIB  (IEFASCTB)                                        *
*/*%INCLUDE SYSLIB  (IEFASIOT)                                        *
*/*%INCLUDE SYSLIB  (IEFJFCBN)                                        *
*/*%INCLUDE SYSLIB  (IEFTIOT1)                                        *
*/*%INCLUDE SYSLIB  (IEFZB4D0)                                        *
*/*%INCLUDE SYSLIB  (IEFZB4D1)                                        *
*/*%INCLUDE SYSLIB  (IEFZB4D2)                                        *
*/*%INCLUDE SYSLIB  (IEFZB4D5)                                        *
*/*%INCLUDE SYSLIB  (IEFZB4D7)                                        *
*/*%INCLUDE SYSLIB  (IEFZB4D9)                                        *
*/*%INCLUDE SYSLIB  (IEFZB4DA)                                        *
*/*%INCLUDE SYSLIB  (IEZJSCB )                                        *
*/*%INCLUDE SYSLIB  (IHADSAB )                                        *
*/*%INCLUDE SYSLIB  (IHAQDB  )                                        *
*/*%INCLUDE SYSLIB  (DINSYNCK)                                        *
*/*%INCLUDE SYSLIB  (DINSYNSP)                                        *
*/*%INCLUDE SYSLIB  (DINRTSRC)                                        *
*/*%INCLUDE SYSLIB  (DINRTSSP)                                        *
*/*%INCLUDE SYSLIB  (RETRIEVE)                                        *
*/*%INCLUDE SYSLIB  (RETRVESP)                                        *
*/*%INCLUDE SYSLIB  (BLNKSCAN)                                        *
*/*%INCLUDE SYSLIB  (SCANSPEC)                                        *
*;                                                              01S0257
@DATA    DS    0H
@SM01719 MVC   DDNAREA(0),TEXTUPAR(TEXTPTR)
@SM01721 MVC   DSNAMPAR(0),S99TUPAR+1(@10)
@SM01727 MVC   TEXTUPAR(0,TEXTPTR),DATFIELD(@05)
@DATD    DSECT
         DS    0F
@SA00001 DS    18F
@PC00001 DS    6F
@AL00001 DS    6A
@TF00001 DS    F
@TF00002 DS    F
@TF00003 DS    F
@TF00004 DS    F
IEFDB470 CSECT
         DS    0F
@CF00084 DC    F'1'
@CF01726 DC    XL4'0000FFFF'
@DATD    DSECT
         DS    0D
DDNAMEP  DS    A
DSABPTR  DS    A
DSNPTR   DS    A
RTNADDR  DS    A
SCTPTR   DS    A
SIOTPTR  DS    A
JFCBPTR  DS    A
TIOTPTR  DS    A
S99RBPTR DS    AL4
         ORG   S99RBPTR
S99RBPND DS    BL1
         ORG   S99RBPTR+4
S99TUFP  DS    A
TXTUFLDP DS    A
TCBJSCB  DS    A
QDBPTR   DS    A
SVABSCT  DS    A
SMFPARMS DS    CL8
         ORG   SMFPARMS
SMFBUF1P DS    AL4
SMFUBFLP DS    AL4
         ORG   SMFPARMS+8
MASKS    DS    CL4
         ORG   MASKS
DUPEMASK DS    BL2
MUTEMASK DS    BL2
         ORG   MASKS+4
DDNAREA  DS    CL8
SWITCHES DS    BL1
         ORG   SWITCHES
CONTINUE DS    BL1
ERRORSW  EQU   SWITCHES+0
@NM00001 EQU   SWITCHES+0
         ORG   SWITCHES+1
FUNCTION DS    CL2
         ORG   FUNCTION
JFCSERCH DS    BL1
ALNMSRCH EQU   FUNCTION+0
JFCBALNM EQU   FUNCTION+0
@NM00002 EQU   FUNCTION+0
         ORG   FUNCTION+2
         DS    CL1
DSNAMTU  DS    CL50
         ORG   DSNAMTU
DSNAMKEY DS    CL2
DSNAMNUM DS    FL2
DSNAMLEN DS    FL2
DSNAMPAR DS    CL44
         ORG   DSNAMTU+50
         DS    CL2
KEYTABLE DS    CL56
         ORG   KEYTABLE
DDNAMTUP DS    AL4
DSNAMTUP DS    AL4
RELNOTUP DS    AL4
RTDDNTUP DS    AL4
RTDSNTUP DS    AL4
RTMEMTUP DS    AL4
RTSTATUP DS    AL4
RTNDPTUP DS    AL4
RTCDPTUP DS    AL4
RTORGTUP DS    AL4
RTLIMTUP DS    AL4
RTATTTUP DS    AL4
RTLSTTUP DS    AL4
RTTYPTUP DS    AL4
         ORG   KEYTABLE+56
S99RB    DS    CL20
         ORG   S99RB
S99RBLN  DS    CL1
S99VERB  DS    CL1
S99FLAG1 DS    CL2
         ORG   S99FLAG1
S99FLG11 DS    CL1
         ORG   S99FLG11
S99ONCNV DS    BL1
S99NOCNV EQU   S99FLG11+0
S99NOMNT EQU   S99FLG11+0
S99JBSYS EQU   S99FLG11+0
         ORG   S99FLAG1+1
S99FLG12 DS    CL1
         ORG   S99RB+4
S99RSC   DS    CL4
         ORG   S99RSC
S99ERROR DS    CL2
S99INFO  DS    CL2
         ORG   S99RB+8
S99TXTPP DS    AL4
S99RSV01 DS    FL4
S99FLAG2 DS    CL4
         ORG   S99FLAG2
S99FLG21 DS    CL1
         ORG   S99FLG21
S99WTVOL DS    BL1
S99WTDSN EQU   S99FLG21+0
S99NORES EQU   S99FLG21+0
S99WTUNT EQU   S99FLG21+0
S99OFFLN EQU   S99FLG21+0
S99TIONQ EQU   S99FLG21+0
S99CATLG EQU   S99FLG21+0
S99MOUNT EQU   S99FLG21+0
         ORG   S99FLAG2+1
S99FLG22 DS    CL1
         ORG   S99FLG22
S99UDEVT DS    BL1
S99PCINT EQU   S99FLG22+0
         ORG   S99FLAG2+2
S99FLG23 DS    CL1
S99FLG24 DS    CL1
         ORG   S99RB+20
IEFDB470 CSECT
         DS    0F
@SIZDATD DC    AL1(230)
         DC    AL3(@ENDDATD-@DATD)
@CV00123 DC    V(IEFDB4FA)
@CV00124 DC    V(IEFDB4FC)
@CV00125 DC    V(IEFDB4FE)
@CV00126 DC    V(IEFDB4FF)
         DS    0D
@CC01704 DC    C'&&&&'
@CB01331 DC    X'0388'
@CB01355 DC    X'0438'
@CB01359 DC    X'0440'
@CB01361 DC    X'0444'
KEYDICT  DS    CL197
         ORG   KEYDICT
KYDDNAME DS    CL17
         ORG   KYDDNAME
DDNAMLEN DC    AL1(17)
DDNAMHEX DC    X'0001'
DDNAMMXL DC    X'0008'
DDNAMMNL DC    X'0001'
DDNAMMXN DC    X'0001'
DDNAMMNN DC    X'0001'
DDNAMKTB DC    X'0000'
DDNAMMEX DS    CL4
         ORG   DDNAMMEX
DDNAMEX1 DC    X'0002'
DDNAMEX2 DC    X'000F'
         ORG   KEYDICT+17
KYDSNAME DS    CL17
         ORG   KYDSNAME
DSNKYLEN DC    AL1(17)
DSNAMHEX DC    X'0002'
DSNAMMXL DC    X'002C'
DSNAMMNL DC    X'0001'
DSNAMMXN DC    X'0001'
DSNAMMNN DC    X'0001'
DSNAMKTB DC    X'0004'
DSNAMMEX DS    CL4
         ORG   DSNAMMEX
DSNAMEX1 DC    X'0001'
DSNAMEX2 DC    X'000F'
         ORG   KEYDICT+34
KYRELNO  DS    CL17
         ORG   KYRELNO
RELNOLEN DC    AL1(17)
RELNOHEX DC    X'000F'
RELNOMXL DC    X'0002'
RELNOMNL DC    X'0002'
RELNOMXN DC    X'0001'
RELNOMNN DC    X'0001'
RELNOKTB DC    X'0008'
RELNOMEX DS    CL4
         ORG   RELNOMEX
RELNOMX1 DC    X'0001'
RELNOMX2 DC    X'0002'
         ORG   KEYDICT+51
KYRTDDN  DS    CL13
         ORG   KYRTDDN
RTDDNLEN DC    AL1(13)
RTDDNHEX DC    X'0004'
RTDDNMXL DC    X'0008'
RTDDNMNL DC    X'0008'
RTDDNMXN DC    X'0001'
RTDDNMNN DC    X'0001'
RTDDNKTB DC    X'000C'
         ORG   KEYDICT+64
KYRTDSN  DS    CL13
         ORG   KYRTDSN
RTDSNLEN DC    AL1(13)
RTDSNHEX DC    X'0005'
RTDSNMXL DC    X'002C'
RTDSNMNL DC    X'002C'
RTDSNMXN DC    X'0001'
RTDSNMNN DC    X'0001'
RTDSNKTB DC    X'0010'
         ORG   KEYDICT+77
KYRTMEM  DS    CL13
         ORG   KYRTMEM
RTMEMLEN DC    AL1(13)
RTMEMHEX DC    X'0006'
RTMEMMXL DC    X'0008'
RTMEMMNL DC    X'0008'
RTMEMMXN DC    X'0001'
RTMEMMNN DC    X'0001'
RTMEMKTB DC    X'0014'
         ORG   KEYDICT+90
KYRTSTA  DS    CL13
         ORG   KYRTSTA
RTSTALEN DC    AL1(13)
RTSTAHEX DC    X'0007'
RTSTAMXL DC    X'0001'
RTSTAMNL DC    X'0001'
RTSTAMXN DC    X'0001'
RTSTAMNN DC    X'0001'
RTSTAKTB DC    X'0018'
         ORG   KEYDICT+103
KYRTNDP  DS    CL13
         ORG   KYRTNDP
RTNDPLEN DC    AL1(13)
RTNDPHEX DC    X'0008'
RTNDPMXL DC    X'0001'
RTNDPMNL DC    X'0001'
RTNDPMXN DC    X'0001'
RTNDPMNN DC    X'0001'
RTNDPKTB DC    X'001C'
         ORG   KEYDICT+116
KYRTCDP  DS    CL13
         ORG   KYRTCDP
RTCDPLEN DC    AL1(13)
RTCDPHEX DC    X'0009'
RTCDPMXL DC    X'0001'
RTCDPMNL DC    X'0001'
RTCDPMXN DC    X'0001'
RTCDPMNN DC    X'0001'
RTCDPKTB DC    X'0020'
         ORG   KEYDICT+129
KYRTORG  DS    CL13
         ORG   KYRTORG
RTORGLEN DC    AL1(13)
RTORGHEX DC    X'000A'
RTORGMXL DC    X'0002'
RTORGMNL DC    X'0002'
RTORGMXN DC    X'0001'
RTORGMNN DC    X'0001'
RTORGKTB DC    X'0024'
         ORG   KEYDICT+142
KYRTLIM  DS    CL13
         ORG   KYRTLIM
RTLIMLEN DC    AL1(13)
RTLIMHEX DC    X'000B'
RTLIMMXL DC    X'0002'
RTLIMMNL DC    X'0002'
RTLIMMXN DC    X'0001'
RTLIMMNN DC    X'0001'
RTLIMKTB DC    X'0028'
         ORG   KEYDICT+155
KYRTATT  DS    CL13
         ORG   KYRTATT
RTATTLEN DC    AL1(13)
RTATTHEX DC    X'000C'
RTATTMXL DC    X'0001'
RTATTMNL DC    X'0001'
RTATTMXN DC    X'0001'
RTATTMNN DC    X'0001'
RTATTKTB DC    X'002C'
         ORG   KEYDICT+168
KYRTLST  DS    CL13
         ORG   KYRTLST
RTLSTLEN DC    AL1(13)
RTLSTHEX DC    X'000D'
RTLSTMXL DC    X'0001'
RTLSTMNL DC    X'0001'
RTLSTMXN DC    X'0001'
RTLSTMNN DC    X'0001'
RTLSTKTB DC    X'0030'
         ORG   KEYDICT+181
KYRTTYP  DS    CL13
         ORG   KYRTTYP
RTTYPLEN DC    AL1(13)
RTTYPHEX DC    X'000E'
RTTYPMXL DC    X'0001'
RTTYPMNL DC    X'0001'
RTTYPMXN DC    X'0001'
RTTYPMNN DC    X'0001'
RTTYPKTB DC    X'0034'
         ORG   KEYDICT+194
KYENDDCT DS    CL3
         ORG   KYENDDCT
ENDDCLEN DC    AL1(3)
ENDDCHEX DC    X'FFFF'
         ORG   KEYDICT+197
IEFDB470 CSECT
         DS   0H
PATCHLOC DC ((@DATA-@PSTART)/20)X'00'
@DATD    DSECT
         ORG   *+1-(*-@DATD)/(*-@DATD) INSURE DSECT DATA
@ENDDATD EQU   *
IEFDB470 CSECT
@00      EQU   00                      EQUATES FOR REGISTERS 0-15
@01      EQU   01
@02      EQU   02
@03      EQU   03
@04      EQU   04
@05      EQU   05
@06      EQU   06
@07      EQU   07
@08      EQU   08
@09      EQU   09
@10      EQU   10
@11      EQU   11
@12      EQU   12
@13      EQU   13
@14      EQU   14
@15      EQU   15
NUSECNT  EQU   @04
LIMIT    EQU   @05
DSABNBR  EQU   @03
CHARCNT  EQU   @03
TEXTPTR  EQU   @02
LOOPPTR  EQU   @03
CHARPTR  EQU   @04
R0       EQU   @00
R1       EQU   @01
R15      EQU   @15
DATA     EQU   0
DATFIELD EQU   0
INSMSCT  EQU   0
SCTSSTAT EQU   INSMSCT+4
SCTSTYPE EQU   INSMSCT+67
SCTNIUSL EQU   INSMSCT+92
SCTSDPTY EQU   INSMSCT+94
SCTSTAT2 EQU   INSMSCT+104
SCTBCT   EQU   SCTSTAT2
SCTCDENT EQU   INSMSCT+118
SCTSTEND EQU   INSMSCT+172
@NM00024 EQU   0
SCTABCND EQU   @NM00024
INDMSIOT EQU   0
SCTUSADD EQU   INDMSIOT+20
SIOTBYT1 EQU   INDMSIOT+43
SIOTBYT3 EQU   INDMSIOT+46
SIOTTSTC EQU   INDMSIOT+47
SIOTBYT0 EQU   INDMSIOT+52
SCTSDISP EQU   INDMSIOT+55
SCTSBYT1 EQU   INDMSIOT+56
SCTDUMMY EQU   SCTSBYT1
SCTSBYT2 EQU   INDMSIOT+57
SCTSBYT3 EQU   INDMSIOT+58
SCTSOLD  EQU   SCTSBYT3
SCTSBYT4 EQU   INDMSIOT+59
SIOTGDGA EQU   SCTSBYT4
SCTUTYPE EQU   INDMSIOT+60
SIOTDEVT EQU   SCTUTYPE
SIOUBYT3 EQU   SIOTDEVT+2
SIOTBYT4 EQU   INDMSIOT+81
SIOTALTD EQU   INDMSIOT+92
SIOTBYT2 EQU   INDMSIOT+103
SJFCBPTR EQU   INDMSIOT+156
INFMJFCB EQU   0
JFCBDSNM EQU   INFMJFCB
JFCBELNM EQU   INFMJFCB+44
JFCBTSDM EQU   INFMJFCB+52
JFCFCBID EQU   INFMJFCB+56
JFCBFRID EQU   JFCFCBID
JFCBLTYP EQU   INFMJFCB+66
JFCBOTTR EQU   INFMJFCB+67
JFCBUFOF EQU   JFCBOTTR
JFCBFLSQ EQU   JFCBOTTR+1
JFCFUNC  EQU   JFCBFLSQ
JFCBMASK EQU   INFMJFCB+72
JFCBFLG1 EQU   JFCBMASK+5
JFCOPEN  EQU   JFCBFLG1
JFCBFLG2 EQU   JFCBMASK+6
JFCDEFER EQU   JFCBFLG2
JFCMODNW EQU   JFCBFLG2
JFCBIND1 EQU   INFMJFCB+86
JFCBIND2 EQU   INFMJFCB+87
JFCDISP  EQU   JFCBIND2
JFCSHARE EQU   JFCBIND2
JFCAMPTR EQU   INFMJFCB+88
JFCBUFRQ EQU   JFCAMPTR
JFCBUFNO EQU   JFCBUFRQ
JFCBGNCP EQU   JFCAMPTR+1
JFCBHIAR EQU   JFCBGNCP
JFCBFALN EQU   JFCBHIAR
JFCBFTEK EQU   JFCBFALN
JFCBBFTA EQU   JFCBFTEK
JFCEROPT EQU   INFMJFCB+92
JFCTRTCH EQU   INFMJFCB+93
TIOT1    EQU   0
TIOENTRY EQU   0
TIOESTTA EQU   TIOENTRY+1
TIOERLOC EQU   TIOENTRY+2
TIOELINK EQU   TIOERLOC+1
TIOTTERM EQU   TIOELINK
TIOEQNAM EQU   TIOELINK
TIOESYOT EQU   TIOELINK
TIOEDDNM EQU   TIOENTRY+4
TIOESTTC EQU   TIOENTRY+15
TIOESTTB EQU   TIOENTRY+16
POOLSTAR EQU   TIOENTRY+20
S99TUPL  EQU   0
S99TUPTR EQU   S99TUPL
S99TUP   EQU   0
S99TUNIT EQU   0
S99TUKEY EQU   S99TUNIT
S99TUNUM EQU   S99TUNIT+2
S99TUENT EQU   S99TUNIT+4
S99TULNG EQU   S99TUENT
S99TUPAR EQU   S99TUENT+2
S99TUFLD EQU   0
TEXTUNIT EQU   0
TEXTUENT EQU   TEXTUNIT+4
TEXTULNG EQU   TEXTUENT
TEXTUPAR EQU   TEXTUENT+2
TXTUPLST EQU   0
TXTUNITP EQU   TXTUPLST
TXTUPELM EQU   0
TXTPLENT EQU   TXTUPELM
TEXTUFLD EQU   0
QDB      EQU   0
IEZJSCB  EQU   0
JSCBSEC1 EQU   IEZJSCB+188
JSCHPCE  EQU   JSCBSEC1+4
JSCBDCB  EQU   JSCBSEC1+36
JSCBOPTS EQU   JSCBSEC1+48
JSCBSWT1 EQU   JSCBSEC1+55
JSCBWTP  EQU   JSCBSEC1+64
JSCBWTFG EQU   JSCBWTP
JSCBEND1 EQU   IEZJSCB+260
DSAB     EQU   0
DSABFCHN EQU   DSAB+4
DSABOPCT EQU   DSAB+14
DSABTIOT EQU   DSAB+16
DSABGIDP EQU   DSAB+24
DSABANMP EQU   DSAB+28
DSABORG  EQU   DSAB+32
DSABORG1 EQU   DSABORG
DSABORG2 EQU   DSABORG+1
DSABFLG1 EQU   DSAB+34
DSABDALC EQU   DSABFLG1
DSABPALC EQU   DSABFLG1
DSABCONV EQU   DSABFLG1
DSABPCAT EQU   DSABFLG1
DSABNUSE EQU   DSABFLG1
DSABFLG2 EQU   DSAB+35
DSABFLG3 EQU   DSAB+36
DSABFLG4 EQU   DSAB+37
DSABSIOT EQU   DSAB+64
DSABANMI EQU   0
DSABGIDL EQU   0
INDMDSNT EQU   0
DINRTVTP EQU   0
DINRTRN  EQU   0
ERRCODE  EQU   DINRTRN
DINCTRLP EQU   0
DINJSCBP EQU   DINCTRLP
DINSCTP  EQU   DINCTRLP+16
ALFNCMAP EQU   0
INPUTSW  EQU   ALFNCMAP
PROCESSW EQU   ALFNCMAP+6
ERRPROSW EQU   PROCESSW
DEPARMS  EQU   0
DENQRETN EQU   DEPARMS+232
DEDMYEPA EQU   DEPARMS+240
DEDMYAS  EQU   DEPARMS+260
LASTEPAP EQU   0
JFCKEYLE EQU   JFCTRTCH
JFCCODE  EQU   JFCKEYLE
JFCSTACK EQU   JFCTRTCH
JFCMODE  EQU   JFCSTACK
JFCSPPRT EQU   JFCTRTCH
JFCBABFS EQU   JFCSPPRT+2
JFCLIMCT EQU   JFCBABFS
JFCDSORG EQU   JFCSPPRT+5
JFCDSRG1 EQU   JFCDSORG
JFCDSRG2 EQU   JFCDSORG+1
JFCRECFM EQU   JFCSPPRT+7
JFCRCFM  EQU   JFCRECFM
JFCOPTCD EQU   JFCSPPRT+8
JFCWVCSP EQU   JFCOPTCD
JFCWVCIS EQU   JFCWVCSP
JFCWVCBD EQU   JFCWVCIS
JFCALLOW EQU   JFCOPTCD
JFCRSV17 EQU   JFCALLOW
JFCOVER  EQU   JFCRSV17
JFCPCIBT EQU   JFCOPTCD
JFCMAST  EQU   JFCPCIBT
JFCEXT   EQU   JFCMAST
JFCBCKPT EQU   JFCOPTCD
JFCIND   EQU   JFCBCKPT
JFCRSV18 EQU   JFCOPTCD
JFCCYL   EQU   JFCRSV18
JFCACT   EQU   JFCCYL
JFCREDUC EQU   JFCOPTCD
JFCRSV19 EQU   JFCREDUC
JFCRSV20 EQU   JFCRSV19
JFCRSV21 EQU   JFCOPTCD
JFCDEL   EQU   JFCRSV21
JFCOPTJ  EQU   JFCOPTCD
JFCREORG EQU   JFCOPTJ
JFCBLKSI EQU   JFCSPPRT+9
JFCBUFSI EQU   JFCBLKSI
JFCAMSYN EQU   JFCSPPRT+11
JFCNCP   EQU   JFCAMSYN+2
JFCNTM   EQU   JFCAMSYN+3
JFCBFSEQ EQU   JFCNTM
JFCPCI   EQU   JFCBFSEQ
JFCRESRV EQU   JFCAMSYN+4
JFCUCSEG EQU   JFCRESRV
JFCUCSOP EQU   JFCUCSEG+4
JFCOUTLI EQU   JFCUCSEG+5
JFCTHRSH EQU   JFCOUTLI
JFCCPRI  EQU   JFCTHRSH
JFCBVOLS EQU   JFCUCSEG+10
JFCBS001 EQU   JFCBVOLS
JFCBPQTY EQU   JFCBS001+34
JFCBCTRI EQU   JFCBS001+37
JFCBSQTY EQU   JFCBS001+38
JFCFLGS1 EQU   JFCBS001+41
JFCBSPNM EQU   JFCBS001+45
JFCBFLG3 EQU   JFCBSPNM
TIOEDEVE EQU   TIOESTTB
TIOSTTB  EQU   TIOEDEVE
DSABQDB  EQU   QDB
DSQFRSTP EQU   DSABQDB+12
DSQLASTP EQU   DSABQDB+16
JSCBSEC2 EQU   JSCBEND1
JSCBSEC3 EQU   JSCBEND1
JSCBJCT  EQU   JSCBSEC3
JSCBJCTA EQU   JSCBJCT+1
JSCBASID EQU   JSCBSEC3+8
JSCBFBYT EQU   JSCBSEC3+10
JSCBJNL  EQU   JSCBSEC3+28
JSCBJJSB EQU   JSCBJNL
JSCBSUB  EQU   JSCBSEC3+40
JSCDSABQ EQU   JSCBSEC3+60
JSCSCT   EQU   JSCBSEC3+68
JSCRSV45 EQU   JSCBSEC3+112
JSCRSV46 EQU   JSCRSV45
JSCRSV47 EQU   JSCRSV45+2
         AGO   .@UNREFD                START UNREFERENCED COMPONENTS
JSCBEND3 EQU   JSCBSEC3+120
JSCRSV52 EQU   JSCBSEC3+116
JSCRSV51 EQU   JSCRSV47+1
JSCRSV50 EQU   JSCRSV47
JSCRSV49 EQU   JSCRSV46+1
JSCRSV48 EQU   JSCRSV46
JSCRSV44 EQU   JSCBSEC3+108
JSCRSV43 EQU   JSCBSEC3+104
JSCRSV42 EQU   JSCBSEC3+100
JSCBASWA EQU   JSCBSEC3+96
JSCBUFPT EQU   JSCBSEC3+92
JSCBACT  EQU   JSCBSEC3+88
JSCBSWSP EQU   JSCBSEC3+87
JSCRSV33 EQU   JSCBSEC3+86
JSCDDNUM EQU   JSCBSEC3+84
JSCRSV53 EQU   JSCBSEC3+82
JSCDDNNO EQU   JSCBSEC3+80
JSCBVATA EQU   JSCBSEC3+76
JSCTMCOR EQU   JSCBSEC3+72
JSCSCTP  EQU   JSCSCT+1
JSCRSV55 EQU   JSCSCT
JSCRSV54 EQU   JSCBSEC3+64
JSCBSSIB EQU   JSCBSEC3+56
JSCBFRBA EQU   JSCBSEC3+48
JSCRSV28 EQU   JSCBSEC3+46
JSCBSONO EQU   JSCBSEC3+44
JSCBSUBA EQU   JSCBSUB+1
JSCRSV31 EQU   JSCBSUB
JSCBSMLR EQU   JSCBSEC3+36
JSCBJNLR EQU   JSCBSEC3+32
JSCBJNLA EQU   JSCBJNL+1
JSCBJSBT EQU   JSCBJJSB
JSCBJSBX EQU   JSCBJJSB
JSCBJSBA EQU   JSCBJJSB
JSCBJSBI EQU   JSCBJJSB
@NM00056 EQU   JSCBJJSB
JSCBJNLE EQU   JSCBJJSB
JSCBJNLF EQU   JSCBJJSB
JSCBJNLN EQU   JSCBJJSB
@NM00055 EQU   JSCBSEC3+24
JSCBJRBA EQU   JSCBSEC3+16
JSCBIECB EQU   JSCBSEC3+12
JSCBRV08 EQU   JSCBSEC3+11
JSCBRV07 EQU   JSCBFBYT
JSCBRV06 EQU   JSCBFBYT
JSCBRV05 EQU   JSCBFBYT
JSCBRV04 EQU   JSCBFBYT
JSCBRV03 EQU   JSCBFBYT
JSCBRV02 EQU   JSCBFBYT
JSCBADSP EQU   JSCBFBYT
JSCBRV01 EQU   JSCBFBYT
JSCBTJID EQU   JSCBASID
JSCBPSCB EQU   JSCBSEC3+4
JSCJCTP  EQU   JSCBJCTA
JSCRSV24 EQU   JSCBJCT
JSCBEND2 EQU   JSCBSEC2
@NM00046 EQU   DSABQDB+24
DSQBDSP  EQU   DSABQDB+22
DSQFDSP  EQU   DSABQDB+20
DSQBADFC EQU   DSQLASTP
DSQBADBC EQU   DSQFRSTP
DSQNELMS EQU   DSABQDB+8
DSQDBLN  EQU   DSABQDB+6
DSQATTRS EQU   DSABQDB+4
DSQDBID  EQU   DSABQDB
TIOUCBP  EQU   TIOEDEVE+1
TIOVERF  EQU   TIOSTTB
TIOUNLD  EQU   TIOSTTB
TIOMNTD  EQU   TIOSTTB
TIOSETU  EQU   TIOSTTB
TIOVLSR  EQU   TIOSTTB
TIOPVIO  EQU   TIOSTTB
TIOREQD  EQU   TIOSTTB
TIOUSED  EQU   TIOSTTB
JFCBEND  EQU   JFCBS001+58
JFCBSPTN EQU   JFCBS001+57
JFCBVLCT EQU   JFCBS001+56
JFCBDRLH EQU   JFCBS001+53
JFCBSBNM EQU   JFCBS001+50
JFCBABST EQU   JFCBS001+48
JFCBRV08 EQU   JFCBSPNM+1
JFCBRV07 EQU   JFCBFLG3
JFCBRV06 EQU   JFCBFLG3
JFCBRV05 EQU   JFCBFLG3
JFCBRV04 EQU   JFCBFLG3
JFCBRV03 EQU   JFCBFLG3
JFCBRV02 EQU   JFCBFLG3
JFCBEXP  EQU   JFCBFLG3
JFCDQDSP EQU   JFCBFLG3
JFCBDQTY EQU   JFCBS001+42
JFCBUAFF EQU   JFCFLGS1
JFCRSV45 EQU   JFCFLGS1
JFCVRDS  EQU   JFCFLGS1
JFCBCEOV EQU   JFCFLGS1
JFCRSV42 EQU   JFCFLGS1
JFCBADSP EQU   JFCFLGS1
JFCTOPEN EQU   JFCFLGS1
JFCBDLET EQU   JFCFLGS1
JFCRQID  EQU   JFCBSQTY
JFCROUND EQU   JFCBCTRI
JFCALX   EQU   JFCBCTRI
JFCMIXG  EQU   JFCBCTRI
JFCONTIG EQU   JFCBCTRI
JFCRSV29 EQU   JFCBCTRI
JFCBMSGP EQU   JFCBCTRI
JFCBSPAC EQU   JFCBCTRI
JFCRUNIT EQU   JFCBPQTY
JFCBEXAD EQU   JFCBS001+31
JFCBEXTL EQU   JFCBS001+30
JFCMSVGP EQU   JFCBS001+22
@NM00043 EQU   JFCBS001
JFCAVOLS EQU   JFCBVOLS
JFCBNVOL EQU   JFCUCSEG+9
JFCBNTCS EQU   JFCUCSEG+8
JFCSOWA  EQU   JFCOUTLI+1
JFCSEND  EQU   JFCCPRI
JFCEQUAL EQU   JFCCPRI
JFCRECV  EQU   JFCCPRI
JFCRSV34 EQU   JFCCPRI
JFCRSV33 EQU   JFCCPRI
JFCRSV55 EQU   JFCCPRI
JFCRSV54 EQU   JFCCPRI
JFCRSV53 EQU   JFCCPRI
JFCRSV27 EQU   JFCUCSOP
JFCRSV26 EQU   JFCUCSOP
JFCFCBVR EQU   JFCUCSOP
JFCFCBAL EQU   JFCUCSOP
JFCVER   EQU   JFCUCSOP
JFCRSV25 EQU   JFCUCSOP
JFCFOLD  EQU   JFCUCSOP
JFCBEXTP EQU   JFCUCSOP
JFCUCSID EQU   JFCUCSEG
JFCINTVL EQU   JFCSPPRT+19
JFCDBUFN EQU   JFCRESRV+3
JFCCYLOF EQU   JFCRESRV+2
JFCRKP   EQU   JFCRESRV
JFCPCIR2 EQU   JFCPCI
JFCPCIR1 EQU   JFCPCI
JFCPCIN2 EQU   JFCPCI
JFCPCIN1 EQU   JFCPCI
JFCPCIA2 EQU   JFCPCI
JFCPCIA1 EQU   JFCPCI
JFCPCIX2 EQU   JFCPCI
JFCPCIX1 EQU   JFCPCI
JFCBUFMX EQU   JFCNCP
JFCLRECL EQU   JFCAMSYN
JFCBAXBF EQU   JFCBUFSI
JFCREL   EQU   JFCREORG
JFCRSV22 EQU   JFCDEL
JFCSRCHD EQU   JFCRSV20
JFCOPTQ  EQU   JFCACT
JFCFEED  EQU   JFCIND
JFCCBWU  EQU   JFCEXT
JFCWUMSG EQU   JFCOVER
JFCSDNAM EQU   JFCWVCBD
@NM00042 EQU   JFCRECFM
JFCCHAR  EQU   JFCRECFM
JFCRFS   EQU   JFCRECFM
JFCRFB   EQU   JFCRECFM
JFCRFO   EQU   JFCRCFM
JFCFMREC EQU   JFCRCFM
JFCRSV16 EQU   JFCDSRG2
JFCRSV15 EQU   JFCDSRG2
JFCORGTR EQU   JFCDSRG2
JFCORGAM EQU   JFCDSRG2
JFCRSV13 EQU   JFCDSRG2
JFCORGTQ EQU   JFCDSRG2
JFCORGTX EQU   JFCDSRG2
JFCORGGS EQU   JFCDSRG2
JFCORGU  EQU   JFCDSRG1
JFCORGPO EQU   JFCDSRG1
JFCORGMQ EQU   JFCDSRG1
JFCORGCQ EQU   JFCDSRG1
JFCORGCX EQU   JFCDSRG1
JFCORGDA EQU   JFCDSRG1
JFCORGPS EQU   JFCDSRG1
JFCORGIS EQU   JFCDSRG1
JFCTRKBL EQU   JFCLIMCT+1
@NM00041 EQU   JFCLIMCT
JFCDEN   EQU   JFCSPPRT+1
JFCPRTSP EQU   JFCSPPRT
JFCONE   EQU   JFCMODE
JFCTWO   EQU   JFCMODE
JFCRSV07 EQU   JFCMODE
JFCRSV06 EQU   JFCMODE
JFCMODER EQU   JFCMODE
JFCMODEO EQU   JFCMODE
JFCEBCD  EQU   JFCMODE
JFCBIN   EQU   JFCMODE
JFCRSV32 EQU   JFCCODE
JFCTTY   EQU   JFCCODE
JFCASCII EQU   JFCCODE
JFCNCR   EQU   JFCCODE
JFCBUR   EQU   JFCCODE
JFCFRI   EQU   JFCCODE
JFCBCD   EQU   JFCCODE
JFCNOCON EQU   JFCCODE
@NM00052 EQU   DEPARMS+304
DETCTIOL EQU   DEPARMS+300
DETCTIOP EQU   DEPARMS+296
DETDQLST EQU   DEPARMS+280
DEALASTP EQU   DEPARMS+276
DEASGNP  EQU   DEDMYAS+12
@NM00051 EQU   DEDMYAS
DEWLASTP EQU   DEPARMS+256
DEWRITP  EQU   DEDMYEPA+12
@NM00050 EQU   DEDMYEPA
DEDSNQRC EQU   DENQRETN+4
DEDSNQEN EQU   DENQRETN
DECPYLEN EQU   DEPARMS+228
DECPYLOC EQU   DEPARMS+224
DEJSCB   EQU   DEPARMS+220
DESCT    EQU   DEPARMS+216
DEJCT    EQU   DEPARMS+212
DESIOT   EQU   DEPARMS+208
DETCB    EQU   DEPARMS+204
DEALFMAP EQU   DEPARMS+200
DECORE   EQU   DEPARMS
@NM00049 EQU   PROCESSW+1
DYNMSSOK EQU   PROCESSW+1
HSKPDQSW EQU   PROCESSW+1
DISMSGSW EQU   PROCESSW+1
USERERSW EQU   PROCESSW+1
EPALSISW EQU   PROCESSW+1
EPASCTSW EQU   PROCESSW+1
EPAJCTSW EQU   PROCESSW
FRRPERSW EQU   PROCESSW
DCBSPCSW EQU   PROCESSW
NQEXCLSW EQU   PROCESSW
UNALOCSW EQU   ERRPROSW
DEQDSNSW EQU   ERRPROSW
COPYSW   EQU   PROCESSW
DYNMSSTM EQU   PROCESSW
@NM00048 EQU   INPUTSW+3
PCATINIT EQU   INPUTSW+3
UNITDEVT EQU   INPUTSW+3
MOUNTSW  EQU   INPUTSW+2
CATLOGSW EQU   INPUTSW+2
TIOTNQSW EQU   INPUTSW+2
OFFLINSW EQU   INPUTSW+2
WTUNTSW  EQU   INPUTSW+2
NORESSW  EQU   INPUTSW+2
WTDSNSW  EQU   INPUTSW+2
WTVOLSW  EQU   INPUTSW+2
@NM00047 EQU   INPUTSW
JOBRLSYS EQU   INPUTSW
NOMONTSW EQU   INPUTSW
NOCNVTSW EQU   INPUTSW
ONCNVTSW EQU   INPUTSW
DINJCTP  EQU   DINCTRLP+12
DINTCBP  EQU   DINCTRLP+8
DINASCBP EQU   DINCTRLP+4
INFOCODE EQU   DINRTRN+2
DSABGRID EQU   DSABGIDL+4
DSABLLEN EQU   DSABGIDL
DSABANAM EQU   DSABANMI+1
DSABANML EQU   DSABANMI
DSABRS04 EQU   DSAB+68
DSABRS03 EQU   DSAB+62
DSABDCBM EQU   DSAB+56
DSABSSCM EQU   DSAB+52
DSABSSNM EQU   DSAB+48
DSABPTTR EQU   DSAB+44
DSABTCBP EQU   DSAB+40
DSABRS02 EQU   DSAB+38
@NM00061 EQU   DSABFLG4
DSABCKSI EQU   DSABFLG4
DSABCKVL EQU   DSABFLG4
DSABCKDS EQU   DSABFLG4
@NM00060 EQU   DSABFLG3
DSABJSCT EQU   DSABFLG3
DSABCATL EQU   DSABFLG3
DSABVMSC EQU   DSABFLG3
DSABVAM  EQU   DSABFLG3
DSABPASS EQU   DSABFLG3
DSABDEFR EQU   DSABFLG3
@NM00059 EQU   DSABFLG2
DSABUNAL EQU   DSABFLG2
DSABIRM  EQU   DSABFLG2
DSABOPEN EQU   DSABFLG2
DSABCATM EQU   DSABFLG1
DSABDCAT EQU   DSABFLG1
DSABDCNV EQU   DSABFLG1
@NM00058 EQU   DSABORG2
DSABTR   EQU   DSABORG2
DSABAM   EQU   DSABORG2
@NM00057 EQU   DSABORG2
DSABTQ   EQU   DSABORG2
DSABTX   EQU   DSABORG2
DSABGS   EQU   DSABORG2
DSABU    EQU   DSABORG1
DSABPO   EQU   DSABORG1
DSABMQ   EQU   DSABORG1
DSABCQ   EQU   DSABORG1
DSABCX   EQU   DSABORG1
DSABDA   EQU   DSABORG1
DSABPS   EQU   DSABORG1
DSABIS   EQU   DSABORG1
DSABSSVA EQU   DSAB+21
DSABRS01 EQU   DSAB+20
DSABLNTH EQU   DSAB+12
DSABBCHN EQU   DSAB+8
DSABID   EQU   DSAB
JSCBCSCB EQU   JSCBSEC1+68
JSCBPMG  EQU   JSCBWTP+2
JSCBWTSP EQU   JSCBWTP+1
JSCRSV23 EQU   JSCBWTFG
JSCRSV22 EQU   JSCBWTFG
JSCRSV21 EQU   JSCBWTFG
JSCRSV20 EQU   JSCBWTFG
JSCRSV19 EQU   JSCBWTFG
JSCRSV18 EQU   JSCBWTFG
JSCBRET  EQU   JSCBWTFG
JSCBIOFG EQU   JSCBWTFG
@NM00054 EQU   JSCBSEC1+60
JSCBQMPI EQU   JSCBSEC1+56
JSCBPMSG EQU   JSCBSWT1
JSCRSV16 EQU   JSCBSWT1
JSCRSV15 EQU   JSCBSWT1
JSCRSV14 EQU   JSCBSWT1
JSCRSV13 EQU   JSCBSWT1
JSCRSV12 EQU   JSCBSWT1
JSCRSV11 EQU   JSCBSWT1
JSCBPASS EQU   JSCBSWT1
JSCBTTTR EQU   JSCBSEC1+52
JSCRSV10 EQU   JSCBSEC1+49
JSCBAUTH EQU   JSCBOPTS
JSCSIOTS EQU   JSCBOPTS
JSCRSV08 EQU   JSCBOPTS
JSCRSV07 EQU   JSCBOPTS
JSCRSV06 EQU   JSCBOPTS
JSCBLONG EQU   JSCBOPTS
JSCRSV05 EQU   JSCBOPTS
JSCRSV04 EQU   JSCBOPTS
JSCBSECB EQU   JSCBSEC1+44
JSCRSV03 EQU   JSCBSEC1+41
JSCBSTEP EQU   JSCBSEC1+40
JSCBDCBA EQU   JSCBDCB+1
JSCRSV02 EQU   JSCBDCB
JSCBID   EQU   JSCBSEC1+32
JSCBDBTB EQU   JSCBSEC1+28
JSCBIJSC EQU   JSCBSEC1+24
JSCBTCBP EQU   JSCBSEC1+20
JSCBPCC  EQU   JSCBSEC1+16
JSCBTCP  EQU   JSCBSEC1+12
JSCBSHR  EQU   JSCBSEC1+8
JSCHPCEA EQU   JSCHPCE+1
JSCRSV32 EQU   JSCHPCE
JSCRSV01 EQU   JSCBSEC1
@NM00053 EQU   IEZJSCB
QDBRV002 EQU   QDB+28
QDBPRDS  EQU   QDB+26
QDBPRSZ  EQU   QDB+24
QDBBPTDS EQU   QDB+22
QDBFPTDS EQU   QDB+20
QDBLELMP EQU   QDB+16
QDBFELMP EQU   QDB+12
QDBNELMS EQU   QDB+8
QDBRV001 EQU   QDB+6
QDBATTR  EQU   QDB+4
QDBQDB   EQU   QDB
TEXTUPRM EQU   TEXTUFLD+2
TEXTULEN EQU   TEXTUFLD
TXTPLEND EQU   TXTPLENT
TXTUPEND EQU   TXTUNITP
TEXTUNUM EQU   TEXTUNIT+2
TEXTUKEY EQU   TEXTUNIT
S99TUPRM EQU   S99TUFLD+2
S99TULEN EQU   S99TUFLD
S99TUPND EQU   S99TUP
S99TUPLN EQU   S99TUPTR
TIOTFEND EQU   POOLSTAR+16
TIOPSLOT EQU   POOLSTAR+13
TIOPSTTB EQU   POOLSTAR+12
TIOPPOOL EQU   POOLSTAR+4
TIOPNSRT EQU   POOLSTAR+3
@NM00045 EQU   POOLSTAR+2
TIOPNSLT EQU   POOLSTAR+1
@NM00044 EQU   POOLSTAR
TIOEFSRT EQU   TIOENTRY+17
TIOSVERF EQU   TIOESTTB
TIOSUNLD EQU   TIOESTTB
TIOSMNTD EQU   TIOESTTB
TIOSSETU EQU   TIOESTTB
TIOSVLSR EQU   TIOESTTB
TIOSPVIO EQU   TIOESTTB
TIOSREQD EQU   TIOESTTB
TIOSUSED EQU   TIOESTTB
TIOSBALS EQU   TIOESTTC
TIOSBALP EQU   TIOESTTC
TIOSVOLS EQU   TIOESTTC
TIOSVOLP EQU   TIOESTTC
TIOSAFFS EQU   TIOESTTC
TIOSAFFP EQU   TIOESTTC
TIOSDEFR EQU   TIOESTTC
TIOSDKCR EQU   TIOESTTC
TIOEJFCB EQU   TIOENTRY+12
TIOTREM  EQU   TIOELINK
TIOESSDS EQU   TIOESYOT
TIOESYIN EQU   TIOELINK
TIOEDYNM EQU   TIOELINK
TIOTRV01 EQU   TIOELINK
TIOSYOUT EQU   TIOELINK
TIOEWTCT EQU   TIOERLOC
TIOSDSP2 EQU   TIOESTTA
TIOSDSP1 EQU   TIOESTTA
TIOSLABL EQU   TIOESTTA
TIOSDADS EQU   TIOESTTA
TIOSJBLB EQU   TIOESTTA
TIOSPLTS EQU   TIOESTTA
TIOSPLTP EQU   TIOESTTA
TIOSLTYP EQU   TIOESTTA
TIOELNGH EQU   TIOENTRY
TIOCSTEP EQU   TIOT1+8
TIOCNJOB EQU   TIOT1
JFCRSV05 EQU   JFCEROPT
JFCRSV04 EQU   JFCEROPT
JFCRSV03 EQU   JFCEROPT
JFCRSV02 EQU   JFCEROPT
JFCTOPT  EQU   JFCEROPT
JFCABN   EQU   JFCEROPT
JFCSKP   EQU   JFCEROPT
JFCACC   EQU   JFCEROPT
JFCBUFL  EQU   JFCAMPTR+2
JFCFWORD EQU   JFCBFTEK
JFCDWORD EQU   JFCBFTEK
JFCHIER1 EQU   JFCBFTEK
JFCDYN   EQU   JFCBFTEK
JFCEXC   EQU   JFCBFTEK
JFCBBFTR EQU   JFCBBFTA
JFCSIM   EQU   JFCBBFTA
JFCHIER  EQU   JFCBFTEK
JFCBFOUT EQU   JFCBUFNO
JFCBUFIN EQU   JFCBUFNO
JFCTEMP  EQU   JFCBIND2
JFCREQ   EQU   JFCBIND2
JFCENT   EQU   JFCBIND2
JFCSECUR EQU   JFCBIND2
JFCPDS   EQU   JFCBIND1
JFCGDG   EQU   JFCBIND1
JFCADDED EQU   JFCBIND1
JFCLOC   EQU   JFCBIND1
JFCRLSE  EQU   JFCBIND1
JFCBXPDT EQU   INFMJFCB+83
JFCBCRDT EQU   INFMJFCB+80
JFCBOPS2 EQU   JFCBMASK+7
JFCRCTLG EQU   JFCBFLG2
JFCBBUFF EQU   JFCBFLG2
JFCTRACE EQU   JFCBFLG2
JFCSDRPS EQU   JFCBFLG2
JFCNRPS  EQU   JFCDEFER
JFCOUTOP EQU   JFCBFLG2
JFCINOP  EQU   JFCBFLG2
JFCBPWBP EQU   JFCOPEN
@NM00040 EQU   JFCOPEN
JFCDUAL  EQU   JFCBFLG1
JFCSLDES EQU   JFCBFLG1
JFCSLCRE EQU   JFCBFLG1
JFCSTAND EQU   JFCBFLG1
JFCBOPS1 EQU   JFCBMASK
JFCBVLSQ EQU   INFMJFCB+70
JFCRSV31 EQU   JFCFUNC
JFCFNCBT EQU   JFCFUNC
JFCFNCBX EQU   JFCFUNC
JFCFNCBD EQU   JFCFUNC
JFCFNCBW EQU   JFCFUNC
JFCFNCBP EQU   JFCFUNC
JFCFNCBR EQU   JFCFUNC
JFCFNCBI EQU   JFCFUNC
JFCBFOFL EQU   JFCBUFOF
JFCNL    EQU   JFCBLTYP
JFCSL    EQU   JFCBLTYP
JFCNSL   EQU   JFCBLTYP
JFCSUL   EQU   JFCBLTYP
JFCBLP   EQU   JFCBLTYP
JFCBLTM  EQU   JFCBLTYP
JFCBAL   EQU   JFCBLTYP
JFCRSV38 EQU   JFCBLTYP
JFCVINDX EQU   INFMJFCB+64
JFCNLREC EQU   INFMJFCB+62
JFCBADBF EQU   INFMJFCB+60
JFCAMSTR EQU   JFCBFRID+2
JFCAMCRO EQU   JFCBFRID
JFCBDSCB EQU   INFMJFCB+53
JFCPAT   EQU   JFCBTSDM
JFCNDCB  EQU   JFCBTSDM
JFCNDSCB EQU   JFCBTSDM
JFCNWRIT EQU   JFCBTSDM
JFCTTR   EQU   JFCBTSDM
JFCSDS   EQU   JFCBTSDM
JFCVSL   EQU   JFCBTSDM
JFCCAT   EQU   JFCBTSDM
JFCIPLTX EQU   JFCBELNM
JFCBQNAM EQU   JFCBDSNM
SIODDSNL EQU   INDMSIOT+173
SIOVDSNL EQU   INDMSIOT+172
SIOVDSNT EQU   INDMSIOT+170
SVOLUNNO EQU   INDMSIOT+168
SIOTVMVP EQU   INDMSIOT+164
SIOTJFX  EQU   INDMSIOT+160
SIOTNPTR EQU   INDMSIOT+152
SIOTETIO EQU   INDMSIOT+148
SIOTATE  EQU   INDMSIOT+144
SVOLUNAD EQU   INDMSIOT+140
SIOTEDLP EQU   INDMSIOT+136
SIOTEDLS EQU   INDMSIOT+132
SIOTRSNC EQU   INDMSIOT+130
SCTANAME EQU   INDMSIOT+122
SIOTSSIC EQU   INDMSIOT+120
@NM00039 EQU   INDMSIOT+108
SIOTSSNM EQU   INDMSIOT+104
@NM00038 EQU   SIOTBYT2
SIOTCVOL EQU   SIOTBYT2
SIOTCNEW EQU   SIOTBYT2
SIOTCALC EQU   SIOTBYT2
SIOTGALL EQU   SIOTBYT2
SIOTDSPD EQU   SIOTBYT2
SIOTDMND EQU   SIOTBYT2
SIOTOPUC EQU   INDMSIOT+99
SIOTOUTR EQU   INDMSIOT+97
SIOTOUTC EQU   INDMSIOT+96
SIOTSSWA EQU   INDMSIOT+93
SIOTAUNC EQU   SIOTALTD
SIOTACAT EQU   SIOTALTD
SIOTADEL EQU   SIOTALTD
SIOTAKEP EQU   SIOTALTD
SIOTNPRV EQU   SIOTALTD
SIOJCATS EQU   SIOTALTD
@NM00037 EQU   SIOTALTD
@NM00036 EQU   SIOTALTD
@NM00035 EQU   INDMSIOT+91
SIOTNDSB EQU   INDMSIOT+88
@NM00034 EQU   INDMSIOT+84
SIOTDPCD EQU   INDMSIOT+82
@NM00033 EQU   SIOTBYT4
SIOTRACT EQU   SIOTBYT4
SIOTRACD EQU   SIOTBYT4
SIOTPROT EQU   SIOTBYT4
SCTOUTPN EQU   INDMSIOT+80
SCTOUTNO EQU   INDMSIOT+76
SCTOUTNM EQU   INDMSIOT+68
SIOUCBAD EQU   SCTUTYPE+5
SIOUCNVT EQU   SCTUTYPE+4
SIOUBYT4 EQU   SIOTDEVT+3
@NM00032 EQU   SIOUBYT3
SIO3UREC EQU   SIOUBYT3
SIO3DISP EQU   SIOUBYT3
SIO3DACC EQU   SIOUBYT3
SIO3COMM EQU   SIOUBYT3
SIO3TAPE EQU   SIOUBYT3
SIOUBYT2 EQU   SIOTDEVT+1
SIOUBYT1 EQU   SIOTDEVT
SIOTOMN  EQU   SCTSBYT4
SIOTIPDI EQU   SCTSBYT4
SIOTVAFF EQU   SCTSBYT4
SIOTSTEP EQU   SCTSBYT4
SIOTASCI EQU   SCTSBYT4
@NM00031 EQU   SCTSBYT4
SCTSGDGS EQU   SCTSBYT4
SCTSMOD  EQU   SCTSBYT3
SCTSNEW  EQU   SCTSBYT3
SCTSYSOU EQU   SCTSBYT3
SCTVREF  EQU   SCTSBYT3
SCTALCHK EQU   SCTSBYT3
SCTSYSNE EQU   SCTSBYT3
SCTDSNRF EQU   SCTSBYT3
SCTRECVD EQU   SCTSBYT2
SCTDEFER EQU   SCTSBYT2
SCTLABEL EQU   SCTSBYT2
SCTUNLBD EQU   SCTSBYT2
SCTJOBLB EQU   SCTSBYT2
SCTVOLAF EQU   SCTSBYT2
SIOTCATL EQU   SCTSBYT2
SIOCLUNL EQU   SCTSBYT2
SIOTJSCT EQU   SCTSBYT1
SCTUNAFF EQU   SCTSBYT1
SCTPARLM EQU   SCTSBYT1
SIOTQDSN EQU   SCTSBYT1
SIOTGDSN EQU   SCTSBYT1
SIOTCCAT EQU   SCTSBYT1
SCTSYSIN EQU   SCTSBYT1
SIOTUNCT EQU   SCTSDISP
SIOTCTLG EQU   SCTSDISP
SIOTDLET EQU   SCTSDISP
SIOTKEEP EQU   SCTSDISP
SIOTPASS EQU   SCTSDISP
SIOTPRIV EQU   SCTSDISP
S3400DSP EQU   SCTSDISP
SIOTRETN EQU   SCTSDISP
SIOTVLCT EQU   INDMSIOT+54
SCTNMBUT EQU   INDMSIOT+53
SIOTRTRY EQU   SIOTBYT0
SIOTPUPV EQU   SIOTBYT0
SIOTNOPV EQU   SIOTBYT0
SIOTGIGN EQU   SIOTBYT0
SPVTAMSG EQU   SIOTBYT0
SIOTFUDA EQU   SIOTBYT0
SIOTDYAL EQU   SIOTBYT0
SIOTSSDS EQU   SIOTBYT0
SIOTGIID EQU   INDMSIOT+50
SCTVOLCT EQU   INDMSIOT+49
SCTSPOOL EQU   INDMSIOT+48
SIOTQNAM EQU   SIOTTSTC
SIOTDSNM EQU   SIOTTSTC
SIOTTRKM EQU   SIOTTSTC
SIOTSSMG EQU   SIOTTSTC
SIOTSSGP EQU   SIOTTSTC
@NM00030 EQU   SIOTTSTC
SIOTTERM EQU   SIOTTSTC
SIOTINFC EQU   SIOTTSTC
@NM00029 EQU   SIOTBYT3
SIOTDSID EQU   SIOTBYT3
S3400OFF EQU   SIOTBYT3
SIOTJES3 EQU   SIOTBYT3
SIOCDEVT EQU   SIOTBYT3
SIOALIAS EQU   SIOTBYT3
SCTDDINO EQU   INDMSIOT+44
SIOTDDNT EQU   SIOTBYT1
SIOTALCD EQU   SIOTBYT1
SIODADSM EQU   SIOTBYT1
SIOTDADR EQU   SIOTBYT1
SIODUNAL EQU   SIOTBYT1
SIOVAMDS EQU   SIOTBYT1
SIOTHOLD EQU   SIOTBYT1
SIOTOCKP EQU   SIOTBYT1
SIOPSCNT EQU   INDMSIOT+42
SIOTREFN EQU   INDMSIOT+40
SIOTOTUN EQU   INDMSIOT+39
SIOTVRSB EQU   INDMSIOT+36
@NM00028 EQU   INDMSIOT+35
SCTPJFCB EQU   INDMSIOT+32
@NM00027 EQU   INDMSIOT+31
SCTPSIOT EQU   INDMSIOT+28
SIOTAFID EQU   INDMSIOT+26
SIOTVLSP EQU   INDMSIOT+24
SIODSNTE EQU   INDMSIOT+22
SIOTUNAF EQU   SCTUSADD
SIOTDEST EQU   INDMSIOT+12
SCTDDNAM EQU   INDMSIOT+4
SIOTTYPE EQU   INDMSIOT+3
SIOTDSKA EQU   INDMSIOT
@NM00026 EQU   @NM00024+1
SCTONLY  EQU   SCTABCND
SCTEVEN  EQU   SCTABCND
SCTABEND EQU   SCTABCND
SCTONLYC EQU   SCTABCND
SCTABCAN EQU   SCTABCND
@NM00025 EQU   SCTABCND
@NM00023 EQU   INSMSCT+173
@NM00022 EQU   SCTSTEND
SCTSYSCK EQU   SCTSTEND
SCTSTPND EQU   SCTSTEND
SCTSTSRT EQU   SCTSTEND
@NM00021 EQU   INSMSCT+168
SCTCATCT EQU   INSMSCT+166
SCTSDPSA EQU   SCTCDENT+3
SCTSDPOP EQU   SCTCDENT+2
SCTSDPCD EQU   SCTCDENT
@NM00020 EQU   INSMSCT+117
SCTPRFMF EQU   INSMSCT+116
SCTPGMNM EQU   INSMSCT+108
SCTTIOT  EQU   INSMSCT+105
@NM00019 EQU   SCTBCT
SCTJBEND EQU   SCTBCT
SCTSPSYS EQU   SCTBCT
SCTSTPLB EQU   SCTBCT
@NM00018 EQU   SCTBCT
SCTMCVOL EQU   SCTBCT
@NM00017 EQU   SCTBCT
SCTGOTTR EQU   INSMSCT+100
SCTSMF   EQU   INSMSCT+96
@NM00016 EQU   SCTSDPTY+1
SCTSDP   EQU   SCTSDPTY
SCTFSTEP EQU   SCTSDPTY
@NM00015 EQU   SCTSDPTY
@NM00014 EQU   SCTSDPTY
@NM00013 EQU   INSMSCT+90
SCTMSSZE EQU   INSMSCT+88
SCTPCAT  EQU   INSMSCT+84
SCTLDSTB EQU   INSMSCT+80
SCTSRBT  EQU   INSMSCT+76
SCTMSADR EQU   INSMSCT+72
@NM00012 EQU   INSMSCT+71
SCTXBTTR EQU   INSMSCT+68
SCTJSCAT EQU   SCTSTYPE
SCTINITB EQU   SCTSTYPE
SCTSJFHK EQU   SCTSTYPE
SCTOUTMC EQU   SCTSTYPE
SCTINPUT EQU   SCTSTYPE
SCTGOSTP EQU   SCTSTYPE
@NM00011 EQU   INSMSCT+66
SCTNSMSG EQU   INSMSCT+65
SCTSNUMB EQU   INSMSCT+64
@NM00010 EQU   INSMSCT+62
SCTRPACT EQU   INSMSCT+60
SCTSNAME EQU   INSMSCT+52
SCTSCLPC EQU   INSMSCT+44
@NM00009 EQU   INSMSCT+43
SCTADSTB EQU   INSMSCT+40
@NM00008 EQU   INSMSCT+36
@NM00007 EQU   INSMSCT+35
SCTAFACT EQU   INSMSCT+32
SCTDDNT  EQU   INSMSCT+28
@NM00006 EQU   INSMSCT+27
SCTLSIOT EQU   INSMSCT+24
@NM00005 EQU   INSMSCT+23
SCTANSCT EQU   INSMSCT+20
@NM00004 EQU   INSMSCT+19
SCTAALOC EQU   INSMSCT+16
@NM00003 EQU   INSMSCT+15
SCTFSIOT EQU   INSMSCT+12
SCTLALOC EQU   INSMSCT+10
SCTSEXEC EQU   INSMSCT+8
SCTSTIME EQU   INSMSCT+5
INCMSSTS EQU   SCTSSTAT
SCTGRPH  EQU   SCTSSTAT
SCTKEY0  EQU   SCTSSTAT
SCTDORST EQU   SCTSSTAT
SCTNOCKP EQU   SCTSSTAT
SCTNORST EQU   SCTSSTAT
EACAUSER EQU   SCTSSTAT
EAADDRBT EQU   SCTSSTAT
SCTTBLID EQU   INSMSCT+3
SCTDISKA EQU   INSMSCT
.@UNREFD ANOP                          END UNREFERENCED COMPONENTS
@RC00093 EQU   @RC00085
@RC00115 EQU   @RC00098
@ENDDATA EQU   *
         END   IEFDB470,(C'PLS1752',0701,78089)
