         TITLE 'IEFIB650, INITIATOR MESSAGE MODULE'
IEFIB650 CSECT
*        SEE CHANGE LEVEL IN PROLOG FOR FLAGGING INFORMATION.
***********************************************************************
*
* MODULE NAME
*    IEFIB650
* DESCRIPTIVE NAME
*    INITIATOR MESSAGE MODULE
* COPYRIGHT
*    NONE
* STATUS
*     8/06/76                                                  @G32HPPJ
* FUNCTION
*    THIS MODULE CONTAINS THE TEXT OF THE NEW AND CHANGED MESSAGES
*    ISSUED BY THE INITIATOR. THE FIRST PORTION OF THIS MODULE HAS AN
*    ENTRY FOR EACH MESSAGE CONSISTING OF:
*
*    1) AN IDENTIFIER FOR EACH MESSAGE
*    2) THE LENGTH OF THE MESSAGE (INCLUDING DESCRIPTOR AND ROUTING
*       CODES)
*    3) THE DISPLACEMENT OF THE TEXT OF THE MESSAGE WITHIN THE MODULE
*
*    THE SECOND PORTION OF THE MODULE CONTAINS THE MESSAGES. THE
*    MESSAGES INCLUDED AND THE RESPECTIVE ID'S ARE LISTED BELOW:
*
*         IEF090E   01
*         IEF091I   02
*         IEF092I   03
*         IEF099I   04
*         IEF100I   05
*         IEF188I   06                                           Y02656
*         IEF861I   07
*         IEF863I   08
*         IEF085I   09
*         IEF186I   0A                                           Y02669
*         IEF187I   0B                                           Y02653
*         IEF172E   0C                                           Y02651
*         IEF173I   0D                                           Y02651
*         IEF7221   0E                                         @Z40RPPJ
*         IEF689I   0F                                         @ZA07506
* ENTRY POINTS
*    NONE
* INPUT
*    NONE
* OUTPUT
*    NONE
* EXTERNAL REFERENCES
*    NONE
* EXITS, NORMAL
*    NONE
* EXITS, ERROR
*    NONE
* TABLES/WORK AREAS
*    EACH MESSAGE CONTAINED IN THE MODULE REQUIRES AN ENTRY OF FOUR
*    BYTES IN THE TABLE AT THE BEGINNING OF THE MODULE.
*    THE FIRST BYTE OF EACH ENTRY IN THE TABLE CONTAINS THE ID FOR THAT
*    MESSAGE.
*    THE SECOND BYTE CONTAINS THE LENGTH OF THE MESSAGE.
*    THE THIRD AND FOURTH BYTES CONTAIN THE DISPLACEMENT WITHIN THE
*    MODULE OF THE MESSAGE TEXT.
*    THE FIRST BYTE OF THE WORD IN THE TABLE FOR THE LAST MESSAGE IS
*    SET TO X'FF'.
* ATTRIBUTES
*    N/A
* CHARACTER CODE DEPENDENCY
*    THIS MODULE IS NOT CHARACTER CODE DEPENDENT.
* NOTES
*    THIS MODULE IS NOT-EXECUTABLE.
* CHANGE LEVEL
*    SEE MODID MACRO AT END OF MODULE
*    CODE HAS BEEN ADDED FOR THE FOLLOWING SUPPORT CODES:
*                                                                Y02653
*                                                                Y02656
*                                                                Y02669
*                                                                Y02651
*                                                          APAR OZ05168
*                                                              @Z40RPPJ
*                                                          APAR OZ07506
*                                                              @G32HPPJ
***********************************************************************
         EJECT
TABLE    EQU   *
         DC    X'01'               ID OF FIRST MESSAGE
         DC    AL1(MS1E-MSG1)      LENGTH OF FIRST MESSAGE
         DC    AL2(MSG1-TABLE)     DISPLACEMENT OF FIRST MESSAGE
         SPACE
         DC    X'02'
         DC    AL1(MS2E-MSG2)
         DC    AL2(MSG2-TABLE)
         SPACE
         DC    X'03'
         DC    AL1(MS3E-MSG3)
         DC    AL2(MSG3-TABLE)
         SPACE
         DC    X'04'
         DC    AL1(MS4E-MSG4)
         DC    AL2(MSG4-TABLE)
         SPACE
         DC    X'05'
         DC    AL1(MS5E-MSG5)
         DC    AL2(MSG5-TABLE)
         SPACE
         DC    X'06'
         DC    AL1(MS6E-MSG6)
         DC    AL2(MSG6-TABLE)
         SPACE
         DC    X'07'
         DC    AL1(MS7E-MSG7)
         DC    AL2(MSG7-TABLE)
         SPACE
         DC    X'08'
         DC    AL1(MS8E-MSG8)
         DC    AL2(MSG8-TABLE)
         SPACE
         DC    X'09'
         DC    AL1(MS9E-MSG9)
         DC    AL2(MSG9-TABLE)
         SPACE
         DC    X'0A'
         DC    AL1(MSAE-MSGA)
         DC    AL2(MSGA-TABLE)
         SPACE
         DC    X'0B'                                             Y02653
         DC    AL1(MSBE-MSGB)                                    Y02653
         DC    AL2(MSGB-TABLE)                                   Y02653
         SPACE
         DC    X'0C'                                             Y02651
         DC    AL1(MSCE-MSGC)                                    Y02651
         DC    AL2(MSGC-TABLE)                                   Y02651
         SPACE
         DC    X'0D'                                             Y02651
         DC    AL1(MSDE-MSGD)                                    Y02651
         DC    AL2(MSGD-TABLE)                                   Y02651
         SPACE
         DC    X'0E'                                           @Z40RPPJ
         DC    AL1(MSEE-MSGE)                                  @Z40RPPJ
         DC    AL2(MSGE-TABLE)                                 @Z40RPPJ
         SPACE 1                                               @Z40RPPJ
         DC    X'0F'                                           @ZA07506
         DC    AL1(MSFE-MSGF)                                  @ZA07506
         DC    AL2(MSGF-TABLE)                                 @ZA07506
         SPACE
         DC    X'FF'               TO MARK END OF TABLE AT BEGINNING OF
         DC    XL3'00'             THIS MODULE
         SPACE
         DC    F'0'                TO USE TO PATCH A MESSAGE     Y02652
         EJECT
MSG1     WTO   'IEF090E PROTECT KEY UNAVAILABLE          PLACED ON HOLD*
               Q',MF=L,ROUTCDE=(1),DESC=(3)
MS1E     EQU   *
         SPACE
MSG2     WTO   'IEF091I PROTECT KEY UNAVAILABLE START          REJECTED*
               ',MF=L,ROUTCDE=(2),DESC=(4),MCSFLAG=(REG0)
MS2E     EQU   *
         SPACE
MSG3     WTO   'IEF092I                            WAITING FOR      K R*
               EAL STORAGE',MF=L,ROUTCDE=(2),DESC=(6)           Y02669
MS3E     EQU   *
         SPACE
MSG4     WTO   'IEF099I JOB          WAITING FOR DATA SETS',MF=L,      *
               ROUTCDE=(2),DESC=(2)                            @ZA05168
MS4E     EQU   *
         SPACE
MSG5     WTO   'IEF100I JOB          CANCELED BY SYSTEM',MF=L,         *
               ROUTCDE=(2),DESC=(6)
MS5E     EQU   *
         SPACE
MSG6     WTO   'IEF188I PROBLEM PROGRAM ATTRIBUTES ASSIGNED',MF=L,     *
               ROUTCDE=(11)                                      Y02656
MS6E     EQU   *
         SPACE
MSG7     WTO   'IEF861I FOLLOWING RESERVED DATA SET NAMES UNAVAILABLE T*
               O         ',MF=L,ROUTCDE=(2),DESC=(6)
MS7E     EQU   *
         SPACE
MSG8     WTO   'IEF863I DSN=                                           *
                 - PERMANENTLY',MF=L,ROUTCDE=(2),DESC=(6)
MS8E     EQU   *
         SPACE
MSG9     WTO   'IEF085I REGION UNAVAILABLE, ERROR CODE=  ',MF=L,       *
               ROUTCDE=(11)                                      Y02669
MS9E     EQU   *
         SPACE
MSGA     WTO   'IEF186I REGION UNAVAILABLE FOR RESTART, ERROR CODE=  ',*
               MF=L,ROUTCDE=(11)                                 Y02669
MSAE     EQU   *
MSGB     WTO   'IEF187I          FAILED - SYSTEM ERROR IN INITIATOR',  *
               MF=L,ROUTCDE=(2,11),DESC=(6)                      Y02653
MSBE     EQU   *
         SPACE
MSGC     WTO   'IEF172E          HELD, CPU (                           *
                   ) OFFLINE',MF=L,ROUTCDE=1,DESC=3              Y02651
MSCE     EQU   *                                                 Y02651
         SPACE
MSGD     WTO   'IEF173I          FAILED, CPU (                         *
                     ) OFFLINE',MF=L,ROUTCDE=(2,11),DESC=6,      Y02651*
               MCSFLAG=(REG0)                                    Y02651
MSDE     EQU   *                                                 Y02651
        SPACE
MSGE     WTO   'IEF722I JJJJJJJJ - FAILED - XXXXXXXXXXXXXXXXXXXXXX',   *
               MF=L,ROUTCDE=(2,11),DESC=(6),MCSFLAG=(REG0)     @G32HPPJ
MSEE     EQU   *
REASN00  DC    C'RETURN CODE NOT VALID '                       @G32HPPJ
REASN04  DC    C'USER PROFILE NOT FOUND'                       @Z40RPPJ
REASN08  DC    C'INVALID PASSWORD GIVEN'                       @Z40RPPJ
REASN0C  DC    C'EXPIRED PASSWORD GIVEN'                       @Z40RPPJ
REASN10  DC    C'NEW PASSWORD NOT VALID'                       @Z40RPPJ
REASN14  DC    C'USER NOT PART OF GROUP'                       @Z40RPPJ
REASN18  DC    C'FAILED BY INSTALLATION'                       @Z40RPPJ
REASN1C  DC    C'USER ACCESS IS REVOKED'                       @Z40RPPJ
REASN20  DC    C'NO MSG TEXT FOR CODE32'                       @Z40RPPJ
REASN24  DC    C'GROUP ACCESS REVOKED  '                       @G32HPPJ
REASN28  DC    C'OIDCARD WAS REQUIRED  '                       @G32HPPJ
         SPACE 1                                               @Z40RPPJ
MSGF     WTO   'IEF689I JOB JJJJJJJJ FAILED DDDDDDDD DID NOT OPEN',    *
               MF=L,ROUTCDE=(11)                               @ZA07506
MSFE     EQU   *                                               @ZA07506
         SPACE
PATCH    DC    XL80'00'            PATCH AREA                    Y02652
         SPACE
IEFIB650 MODID BRANCH=NO                                         Y02652
         END
