*%        GO TO JCLSLAB1;
* /*******************************************************************/
* /*                                                                 */
* /* STATUS --                                                       */
* /*    RELEASE 20, MODIFICATION LEVEL 00                            */
* /*    0-999999                                               20029 */
* /*                                                                 */
* /* FUNCTION --                                                     */
* /*    DESCRIBE A JOB CONTROL LANGUAGE SET                          */
* /*                                                                 */
* /* ENTRY POINTS --                                                 */
* /*         NONE                                                    */
* /*                                                                 */
* /* INPUT --                                                        */
* /*    NONE                                                         */
* /*                                                                 */
* /* OUTPUT --                                                       */
* /*    A BSL OR ASSEMBLER LANGUAGE DECLARATION A JOB CONTROL        */
* /*    LANGUAGE SET                                                 */
* /*                                                                 */
* /* EXTERNAL REFERENCES --                                          */
* /*         NONE                                                    */
* /*                                                                 */
* /* EXITS, NORMAL --                                                */
* /*         NONE                                                    */
* /*                                                                 */
* /* EXITS, ERROR --                                                 */
* /*         NONE                                                    */
* /*                                                                 */
* /* TABLE/WORK AREAS --                                             */
* /*         NONE                                                    */
* /*                                                                 */
* /* ATTRIBUTES --                                                   */
* /*         NOT APPLICABLE                                          */
* /*                                                                 */
* /* NOTES --                                                        */
* /*    NONE                                                         */
* /*                                                                 */
* /*******************************************************************/
* /* START OF SPECIFICATIONS ****
*1MODULE-NAME = IEFJCLS
*  2PROCESSOR = ASSEMBLER, BSL
** THE RELEASE FOR WHICH THIS MODULE WAS MOST RECENTLY UPDATED
*1STATUS = 20
**********************************************************************/
* /********************************************************************
*1DESCRIPTIVE-NAME = JOB CONTROL LANGUAGE SET MAPPING
*1DESCRIPTION = PROVIDE A MAPPING OF THE CHAINED STRUCTURES USED BY  -
*THE SYSTEM TASK CONTROL ROUTINE AND TSO LOGON TO CONTAIN THE JOB    -
*CONTROL LANGUAGE REQUIRED TO PROCESS THE START AND MOUNT OPERATOR   -
*COMMANDS AND THE LOGON FOREGROUND COMMAND RESPECTIVELY.
*1FUNCTION = SEE DESCRIPTION
*1MODULE-TYPE = MACRO
*1GLOBAL-ARITHMETIC-VARIABLES = LENJCLS
*1MACRO-SIZE = 188 STATEMENTS
*1PARAMETER-RECEIVED = NONE
*1SYSTEM-MACROS = NONE
*1EXTERNAL-TABLE = JCLS
*  2PURPOSE = PROVIDE A MAPPING OF A JOB CONTROL LANGUAGE SET
*  2REMARKS-ON-USE = AS OF RELEASE 20 ALL NEW USERS OF THE JOB       -
*  CONTROL LANGUAGE SET SHOULD UTILIZE THIS MACRO-INSTRUCTION. IN    -
*  THE FOLLOWING DISCUSSION 'REFERENCE-TYPE' REFERS TO THE TREATMENT -
*  GIVEN EACH INDIVIDUAL FIELD BY IEEVRJCL, THE PSEUDO-ACCESS METHOD -
*  NORMALLY USED TO PASS EACH JCLS TO THE READER/INTERPRETER
*  2SCOPE = EXTERNAL
*  2TABLE-SIZE = 88 BYTES
*  2MAPPING-MACRO = IEFJCLS
*  *******************************************************************/
*  /*******************************************************************
*  2FIELD = JCLSHDR
*    3REFERENCE-TYPE = READ
*    3DISPLACEMENT = 0 BYTES
*    3TYPE = TABLE
*    3SCOPE = EXTERNAL
*    3TABLE-SIZE = 8 BYTES
*    3MAPPING-MACRO = IEFJCLS
*    *****************************************************************/
*    /*****************************************************************
*    3FIELD = JCLSJCLS
*      4REFERENCE-TYPE = READ
*      4DISPLACEMENT = 0 BYTES
*      4TYPE = ADDRESS
*      4ADDRESS-LENGTH = 32 BITS
*      4ADDRESS-OF = JCLS
*        5REFERENCE-TYPE = READ
*        5TYPE-ADDRESSED = TABLE
*        5PURPOSE = NEXT JCLS IN STREAM
*        5REMARKS-ON-USE = IF JCLSJCLS POINTER IS ZERO, THE END OF   -
*        THE CHAIN IS INDICATED.
*        5SCOPE = EXTERNAL
*        5MAPPING-MACRO = IEFJCLS
*    *****************************************************************/
*    /*****************************************************************
*    3FIELD = *
*      4DISPLACEMENT = 4 BYTES
*      4TYPE = RESERVED
*  *******************************************************************/
*  /*******************************************************************
*  2FIELD = JCLSCARD
*    3REFERENCE-TYPE = READ
*    3DISPLACEMENT = 8 BYTES
*    3TYPE = TABLE
*    3PURPOSE = CONTAIN ONE JCL CARD IMAGE
*    3SCOPE = EXTERNAL
*    3TABLE-SIZE = 80 BYTES
*    3MAPPING-MACRO = IEFJCLS
*    *****************************************************************/
*    /*****************************************************************
*    3FIELD = JCLSLASH
*      4REFERENCE-TYPE = READ
*      4DISPLACEMENT = 0 BYTES
*      4TYPE = CHARACTER STRING
*      4LENGTH+MODE = 2 CHARACTERS
*      4VALUE = '//' OR '/*'
*    *****************************************************************/
*    /*****************************************************************
*    3FIELD = JCLSLABL
*      4REFERENCE-TYPE = READ
*      4DISPLACEMENT = 2 BYTES
*      4TYPE = CHARACTER STRING
*      4LENGTH+MODE = 8 CHARACTERS
*      4VALUE = LABEL OF JCL CARD
*    *****************************************************************/
*    /*****************************************************************
*    3FIELD = JCLSTYPE
*      4REFERENCE-TYPE = READ
*      4DISPLACEMENT = 10 BYTES
*      4TYPE = CHARACTER STRING
*      4LENGTH+MODE = 5 CHARACTERS
*      4VALUE = 'JOB', 'EXEC', 'DD', ...
*    *****************************************************************/
*    /*****************************************************************
*    3FIELD = JCLSBODY
*      4REFERENCE-TYPE = READ
*      4DISPLACEMENT = 15 BYTES
*      4TYPE = CHARACTER STRING
*      4LENGTH+MODE = 56 CHARACTERS
*      4VALUE = BODY OF JCL CARD
*    *****************************************************************/
*    /*****************************************************************
*    3FIELD = JCLSCNTN
*      4REFERENCE-TYPE = READ
*      4DISPLACEMENT = 1 BYTE
*      4TYPE = CHARACTER STRING
*      4LENGTH+MODE = 71 CHARACTERS
*      4VALUE = CONTINUATION FIELD OF JCL CARD
*    *****************************************************************/
*    /*****************************************************************
*    3FIELD = JCLSSEQ
*      4REFERENCE-TYPE = READ
*      4DISPLACEMENT = 8 BYTES
*      4TYPE = CHARACTER STRING
*      4LENGTH+MODE = 72 CHARACTERS
*      4VALUE = SEQUENCE FIELD OF JCL CARD
*
**** END OF SPECIFICATIONS ***/
         MACRO
         IEFJCLS
JCLS     DS   CL88           DEFINE A JOB CONTROL LANGUAGE SET (JCLS)
         ORG  JCLS           MOVE BACK AND DEFINE THE FIELDS
JCLSHDR  DS   CL8            JCLS HEADER
         ORG  JCLSHDR        STRUCTURE THE HEADER
JCLSJCLS DS   AL4            POINTER TO NEXT JCLS
         DS   1F             RESERVED
JCLSCARD DS   CL80           JCL CARD IMAGE
         ORG  JCLSCARD       MOVE BACK AND STRUCTURE THE CARD
JCLSLASH DS   CL2            //
JCLSLABL DS   CL8            LABEL FIELD
JCLSTYPE DS   CL5            JOB, EXEC, DD, ...
JCLSBODY DS   CL56           BODY OF CARD IMAGE
JCLSCNTN DS   1C             CONTINUATION COLUMN
JCLSSEQ  DS   CL8            SEQUENCE NUMBER FIELD
         MEND
*%JCLSLAB1:;
* /********************************************************************
*         DEFINE A JOB CONTROL LANGUAGE SET
* ********************************************************************/
* DECLARE
*         1     JCLS BASED(JCLSPTR) BOUNDARY(DWORD),
*               /******************************************************
*                  JCLS HEADER
*               ******************************************************/
*               2  JCLSHDR,
*                  /***************************************************
*                     POINTER TO NEXT JCLS -- ZERO FOR LAST
*                  ***************************************************/
*                  3  JCLSJCLS POINTER(31),
*                  /***************************************************
*                     RESERVED
*                  ***************************************************/
*                  3  * FIXED(31),
*               /******************************************************
*                  JCL CARD IMAGE
*               ******************************************************/
*               2  JCLSCARD CHARACTER(80),
*                  /***************************************************
*                     // OR /*
*                  ***************************************************/
*                  3  JCLSLASH CHARACTER(2),
*                  /***************************************************
*                     LABEL FIELD
*                  ***************************************************/
*                  3    JCLSLABL CHARACTER(8),
*                  /***************************************************
*                     JOB, EXEC, DD, ...
*                  ***************************************************/
*                  3    JCLSTYPE CHARACTER(5),
*                  /***************************************************
*                     BODY OF CARD IMAGE
*                  ***************************************************/
*                  3    JCLSBODY CHARACTER(56),
*                  /***************************************************
*                     CONTINUATION COLUMN
*                  ***************************************************/
*                  3    JCLSCNTN CHARACTER(1),
*                  /***************************************************
*                     SEQUENCE NUMBER FIELD
*                  ***************************************************/
*                  3    JCLSSEQ CHARACTER(8);
*%/********************************************************************
*         DEFINE THE LENGTH OF A JOB CONTROL LANGUAGE SET
**********************************************************************/
*         DECLARE LENJCLS FIXED;
*%        LENJCLS = 88;
