         TITLE 'IEFSD095 BLOCK LETTER AND NUMBER ROUTINE'
***********************************************************************
*                                                                     *
*STATUS - CHANGE LEVEL 000                                            *
*                                                                     *
*FUNCTION -                                                           *
*                                                                     *
*   BUILD IN OUT AREA ONE LINE TO BE LATER PUT OUT ON PRINTER         *
*                                                                     *
*OPERATION -                                                          *
*                                                                     *
*ENTRY POINT -  IEFSD095                                              *
*                                                                     *
*INPUT -                                                              *
*   REGISTER 1 POINTS TO THE PARAMETER LIST CONTAINING THE ADDRESS OF *
*   CHARACTERS WHICH ARE TO BE CONSTRUCTED IN BLOCK FORM,THE ADDRESS  *
*   OF THE LINE COUNT,THE ADDRESS OF THE CONSTRUCTION AREA , AND THE  *
*   ADDRESS OF THE THE NUMBER OF CHARACTERS IN THE STRING .           *
*                                                                     *
*EXIT POINT - RETURN TO CALLING PROGRAM WITH REGISTERS INTACT         *
*                                                                     *
*OUTPUT -                                                             *
*   SAME AS INPUT PLUS OUT AREA HAS BEEN FILLED WITH STRING OF CHARS. *
*                                                                     *
*EXTERNAL ROUTINES -                                                  *
*                                                                     *
*             NONE                                                    *
*                                                                     *
*TABLES/WORK AREAS -                                                  *
*                                                                     *
*                                                                     *
*   THE WORK AREA FOR THIS MODULE APPEARS AS FOLLOWS :                *
*                   /     SAVE CHARACTER       /                      *
*                   /--------------------------/                      *
*                   /      SAVE REGISTERS      /                      *
*                   /--------------------------/                      *
*                   /      6 UNUSED WORDS      /                      *
*                   /--------------------------/                      *
*                   .                          .                      *
*                   .                          .                      *
*                   .                          .                      *
*                   /--------------------------/                      *
*                                                                     *
*                                                                     *
*ATTRIBUTES - REENTRANT                                               *
*                                                                     *
***********************************************************************
*                         NEEDED DSECT                                *
*
R0       EQU   0
R1       EQU   1
R2       EQU   2
R3       EQU   3
R4       EQU   4
R5       EQU   5
R6       EQU   6
R7       EQU   7
R8       EQU   8
R9       EQU   9
R10      EQU   10
R11      EQU   11
R12      EQU   12
R13      EQU   13
R14      EQU   14
R15      EQU   15
WORKAREA DSECT
         DS    0F
SAVECHAR DS    F
SAVEREGR DS    F
UNUSEDPT DS    6F
WORKEND  EQU   *
*INITIALIZE
IEFSD095 CSECT
         SAVE  (14,12)             SAVE REGISTERS
         BALR  R9,0                SET BASE REGISTER
         USING *,R9
         L     R3,4(R1)
         L     R3,0(R3)
         L     R4,8(R1)
         L     R11,12(R1)
         L     R11,0(R11)
         L     R1,0(R1)
         LR    R10,R1                  SAVE R1
         LA    R0,WORKEND-WORKAREA
         GETMAIN R,LV=(0)              GET CORE FOR WORK AREA
         LR    R12,R1
         USING WORKAREA,R12
         LR    R1,R10                  RESTORE R1
         ST    R13,SAVEREGR            SAVE R 13
         XC    SAVECHAR(4),SAVECHAR    ZERO SAVECHARACTER
LOOP     MVC   SAVECHAR+3(1),0(R1)     GET CHARACTER
         L     R2,SAVECHAR             PUT IT IN R2
         LR    R10,R2                  SAVE IT IN R10
         C     R2,BNK                    IS IT BLANK IF SO
         BE    FBL                       BRANCH TO FBL
         C     R2,C1                     IS IT LESS THAN C1 IF SO
         BL    TROUBLE                   BRANCH TO TROUBLE
         C     R2,CA                     IS IT LESS THAN CA IF SO
         BL    TEST2                     BRANCH TO TEST2
         C     R2,D1                     IS IT LESS THAN D1 IF SO
         BL    TROUBLE                   BRANCH TO TROUBLE
         C     R2,DA                     IS IT LESS THAN DA IF SO
         BL    TEST3                     BRANCH TO TEST3
         C     R2,E2                     IS IT LESS THAN E2 IF SO
         BL    TROUBLE                   BRANCH TO TROUBLE
         C     R2,EA                     IS IT LESS THAN EA IF SO
         BL    TEST4                     BRANCH TO TEST4
         C     R2,F0                     IS IT LESS THAN F0 IF SO
         BL    TROUBLE                   BRANCH TO TROUBLE
         C     R2,FA                     IS IT LESS THAN FA IF SO
         BL    TEST5                     BRANCH TO TEST5
TROUBLE  B     FBL                 SET ILLEGAL CHARACTER TO BLANK
FBL      LA    R6,CHARACTR-1       SET R6 TO ADDR OF BLANK
         B     EXIT1               GO TO EXIT1
TEST2    S     R2,C0               GET OFF SET
         MH    R2,TWLV+2
         LA    R6,CHARACTR-1       SET R6 TO ADDR OF LETTER
         AR    R6,R2
         B     EXIT1
TEST3    S     R2,D0               GET OFF SET
         MH    R2,TWLV+2
         A     R2,ONZET
         LA    R6,CHARACTR-1       SET R6 TO ADDR OF LETTER
         AR    R6,R2
         B     EXIT1
TEST4    S     R2,E1               GET OFF SET
         MH    R2,TWLV+2
         A     R2,TWOSX
         LA    R6,CHARACTR-1       SET R6 TO ADDR OF LETTER
         AR    R6,R2
         B     EXIT1
TEST5    S     R2,EF               GET OFF SET
         MH    R2,TWLV+2
         A     R2,TROTW
         LA    R6,CHARACTR-1       SET R6 TO ADDR OF LETTER
         AR    R6,R2
*GET POINTER TO LINE PATTERN
EXIT1    XR    R7,R7               ZERO R7
         AR    R6,R3
         IC    R7,0(R6)
*                                  LINE PATTERN FROM LINEPATN
         LA    R8,LINEPATN
         AR    R7,R8
         LH    R5,0(R7)                              *
         SLL   R5,19                                ***
         O     R5,ONEX
         BXH   R5,R5,LP1                           * * *
        STC   R10,0(R4)                              *
LP1      BXH   R5,R5,LP2                             *
        STC   R10,1(R4)                              *
LP2      BXH   R5,R5,LP3                             *
        STC   R10,2(R4)                              *
LP3      BXH   R5,R5,LP4                             *
        STC   R10,3(R4)                              *
LP4      BXH   R5,R5,LP5                             *
        STC   R10,4(R4)                              *
LP5      BXH   R5,R5,LP6           THIS SECTION OF CODE STORES THE
        STC   R10,5(R4)            CHARACTER IF THE BIT IS ON
LP6      BXH   R5,R5,LP7           LINE PATTERN,OTHERWISE NO STORE
        STC   R10,6(R4)                              *
LP7      BXH   R5,R5,LP8                             *
        STC   R10,7(R4)                              *
LP8      BXH   R5,R5,LP9                             *
        STC   R10,8(R4)                              *
LP9      BXH   R5,R5,LP10                            *
        STC   R10,9(R4)                              *
LP10     BXH   R5,R5,LP11                            *
        STC   R10,10(R4)                           * * *
LP11     BXH   R5,R5,LP12                           ***
        STC   R10,11(R4)                             *
LP12     A     R4,FORT             ADD 14 TO ADDR OF OUT AREA FOR NEXT
*                                  CHARACTER TO BEGIN AT
         A     R1,ONEX             ADD 1 TO ADDR OF CHARACTER STRING
*                                  TO POINT TO NEXT CHARACTER
         S     R11,ONEX            SUBTRACT 1 FROM NUMBER OF CHARACTERS
         XR    R8,R8               ZERO R8
         CR    R11,R8              IS R11 GREATER THAN ZERO IF SO
         BH    LOOP                BRANCH TO DO NEXT CHARACTER
         L     R13,SAVEREGR        RESTORE R13
         LA    R0,WORKEND-WORKAREA
         LR    R1,R12
         FREEMAIN R,LV=(0),A=(1)   FREE CORE
         RETURN (14,12)            RETURN TO CALLING PROGRAM
*CONSTANTS
         DS    0F
BNK      DC    XL4'40'
C1       DC    XL4'C1'
CA       DC    XL4'CA'
D1       DC    XL4'D1'
DA       DC    XL4'DA'
E2       DC    XL4'E2'
EA       DC    XL4'EA'
F0       DC    XL4'F0'
FA       DC    XL4'FA'
C0       DC    XL4'C0'
D0       DC    XL4'D0'
E1       DC    XL4'E1'
EF       DC    XL4'EF'
TWLV     DC    XL4'0C'
ONZET    DC    XL4'6C'
TWOSX    DC    XL4'D8'
TROTW    DC    XL4'0138'
FORT     DC    XL4'0E'
ONEX     DC    XL4'01'
***********************************************************************
*                                                                     *
*        FOLLOWING IS THE CHARACTER PARM LIST CONTAINING 444 BYTES    *
*        WHERE EACH BYTE IS THE OFF SET FROM L1 IN THE LINE PARAMETER *
*        LIST WHERE ONE LINE PATTERN OF A PARTICULAL CHARACTER IS     *
*        STORED . A CHARACTER IS REPRESENTED BY 12 ORDERED LINE       *
*        PATTERNS .FOR EXAMPLE A IS REPRESENTED BY THE  FOLLOWING     *
*        ORDERED LINE PATTERNS  L2,L1,L5,L5,L5,L1,L1,L5,L5,L5,L5,L5   *
*        AND WILL APPEAR ON THE PRINTER AS FOLLOWS                    *
*                                                                     *
*                             AAAAAAAAAA                              *
*                            AAAAAAAAAAAA                             *
*                            AA        AA                             *
*                            AA        AA                             *
*                            AA        AA                             *
*                            AAAAAAAAAAAA                             *
*                            AAAAAAAAAAAA                             *
*                            AA        AA                             *
*                            AA        AA                             *
*                            AA        AA                             *
*                            AA        AA                             *
*                            AA        AA                             *
*                                                                     *
***********************************************************************
CHARACTR DS    0F
BLANK    DC    12X'4C'
A        DC    X'020008080800000808080808'
B        DC    X'2C000808322A2A320808002C'
C        DC    X'020008262626262626080002'
D        DC    X'282A32080808080808322A28'
E        DC    X'000026262668682626260000'
F        DC    X'000026262668682626262626'
G        DC    X'020008262626343408080002'
H        DC    X'080808080800000808080808'
I        DC    X'020214141414141414140202'
J        DC    X'66660A0A0A0A0A0A3A3A686A'
K        DC    X'08322E3C3A36363A3C2E3208'
L        DC    X'262626262626262626260000'
M        DC    X'083E40424446080808080808'
N        DC    X'086C6E484A464E5052540876'
O        DC    X'000008080808080808080000'
P        DC    X'2C00080808002C2626262626'
Q        DC    X'020008080808084E50522C56'
R        DC    X'2C00080808002C3A3C2E3208'
S        DC    X'02000826585A5C5E64080002'
T        DC    X'000014141414141414141414'
U        DC    X'080808080808080808080002'
V        DC    X'080808080808083062206014'
W        DC    X'080808080808464442403E08'
X        DC    X'080830622060602062300808'
Y        DC    X'080830622060141414141414'
Z        DC    X'00001070120A147216742400'
ZERO     DC    X'040208080808080808080204'
ONE      DC    X'140C0E141414141414140202'
TWO      DC    X'020008646410121416180000'
THREE    DC    X'02000864641A1A6464080002'
FOUR     DC    X'061C1E202224001212121212'
FIVE     DC    X'0000262626282A106464002C'
SIX      DC    X'02000826262C000808080002'
SEVEN    DC    X'002C2E120A14141414141414'
EIGHT    DC    X'020008083004043008080002'
NINE     DC    X'020008080800006464080002'
***********************************************************************
*                                                                     *
*        FOLLOWING IS THE LINE PARAMETER LIST CONTAINING 60           *
*        DISTINCT LINE PATTERNS . IF THE BIT IS ON THE CHARACTER      *
*        THE CHARACTER IS SUPPRESSED . A COMBINATION OF 12 LINE       *
*        PATTERNS ( AS SPECIFIED IN THE CHARACTER REPRESENTATION      *
*        LIST ) REPRESENTS EITHER A BLANK , A LETTER FROM A TO Z,     *
*        OR A NUMBER FROM 0 TO 9 .                                    *
*                                                                     *
***********************************************************************
LINEPATN DS    0F
L1       DC    BL2'111111111111'
L2       DC    BL2'011111111110'
L3       DC    BL2'001111111100'
L4       DC    BL2'000000111000'
L5       DC    BL2'110000000011'
L6       DC    BL2'000000110000'
L7       DC    BL2'000011100000'
L8       DC    BL2'000111100000'
*        WILL BE PRINTED AND IF THE BIT IS OFF THE PRINTING OF        *
L9       DC    BL2'000000000110'
L10      DC    BL2'000000011000'
L11      DC    BL2'000001100000'
L12      DC    BL2'000110000000'
L13      DC    BL2'011000000000'
L14      DC    BL2'000000011110'
L15      DC    BL2'000001111000'
*                                                                     *
*                                                                     *
*                   /--------------------------/                      *
L16      DC    BL2'000011011000'
L17      DC    BL2'000110011000'
L18      DC    BL2'001100011000'
L19      DC    BL2'011111111111'
L20      DC    BL2'110000000000'
L21      DC    BL2'111111111000'
L22      DC    BL2'111111111100'
L23      DC    BL2'111111111110'
L24      DC    BL2'110000001100'
L25      DC    BL2'011000000110'
L26      DC    BL2'110000000110'
L27      DC    BL2'110000011111'
L28      DC    BL2'111111100000'
L29      DC    BL2'110001100000'
L30      DC    BL2'110000110000'
L31      DC    BL2'110000011000'
L32      DC    BL2'111000000111'
L33      DC    BL2'111100001111'
L34      DC    BL2'110110011011'
L35      DC    BL2'110011110011'
L36      DC    BL2'110001100011'
L37      DC    BL2'110110000011'
L38      DC    BL2'110011000011'
L39      DC    BL2'000000000000'
L40      DC    BL2'110000110011'
L41      DC    BL2'110000011011'
L42      DC    BL2'110000001111'
L43      DC    BL2'110000000111'
L44      DC    BL2'011111111011'
L45      DC    BL2'111000000000'
L46      DC    BL2'011111111100'
L47      DC    BL2'001111111110'
L48      DC    BL2'000000000111'
L49      DC    BL2'000011110000'
L50      DC    BL2'001100001100'
L51      DC    BL2'000000000011'
L52      DC    BL2'001111111111'
L53      DC    BL2'111111110000'
L54      DC    BL2'011111100000'
L55      DC    BL2'111000000011'
L56      DC    BL2'111100000011'
L57      DC    BL2'000000001100'
L58      DC    BL2'000011000000'
L59      DC    BL2'001100000000'
L60      DC    BL2'110000000001'
         END
