* %      GOTO JSOLPLS;
* /*******************************************************************/
* /*                                                                 */
* /* STATUS --                                                       */
* /*    RELEASE OS/VS2 RELEASE 4, MODIFICATION LEVEL 00              */
* /*                                                                 */
* /* FUNCTION --                                                     */
* /*    DEFINE THE STRUCTURE AND PROPER USE OF THE JOB SCHEDULING    */
* /*    OPTIONS LIST (JSOL)                                          */
* /*                                                                 */
* /* ENTRY POINTS --                                                 */
* /*         NONE                                                    */
* /*                                                                 */
* /* INPUT --                                                        */
* /*    NONE                                                         */
* /*                                                                 */
* /* OUTPUT --                                                       */
* /*    DATA CONSTANTS (ASSEMBLER) OR DECLARATIONS OF THE VARIABLES  */
* /*    WHICH CONSTITUTE THE JSOL.                                   */
* /*                                                                 */
* /* EXTERNAL REFERENCES --                                          */
* /*         NONE                                                    */
* /*                                                                 */
* /* EXITS, NORMAL --                                                */
* /*         NONE                                                    */
* /*                                                                 */
* /* EXITS, ERROR --                                                 */
* /*         NONE                                                    */
* /*                                                                 */
* /* TABLE/WORK AREAS --                                             */
* /*         NONE                                                    */
* /*                                                                 */
* /* ATTRIBUTES --                                                   */
* /*         NOT APPLICABLE                                          */
* /*                                                                 */
* /* NOTES --                                                        */
* /*    NONE                                                         */
* /*                                                                 */
* /*******************************************************************/
* /* START OF SPECIFICATIONS ****
*1MODULE-NAME = IEFVJSOL
*  2PROCESSOR = ASSEMBLER
**** END OF SPECIFICATIONS ***/
* /*******************************************************************/
         MACRO
&NAME    IEFVJSOL &PREFIX=JSOL /*
&NAME    DS   0D             ALIGN THE JSOL ON A DOUBLEWORD BOUNDARY
&PREFIX.LGTH DC AL2(&PREFIX.END-&PREFIX)    LENGTH OF THE JSOL
&PREFIX.FLAG DC   X'00'      FLAG BYTE
&PREFIX.NSYS EQU  X'80'           NO SYSTEM TASKS                Y02669
&PREFIX.RAC  EQU  X'40'      BYPASS RACINIT                    @Z40RPSQ
*            EQU  X'20'           RESERVED
*            EQU  X'10'           RESERVED
&PREFIX.SMS1 EQU  X'08'      SUPPRESS SYSTEM TASK CONTROL MESSAGES
*            EQU  X'04'           RESERVED
*            EQU  X'02'           RESERVED
*            EQU  X'01'           RESERVED
&PREFIX.OPTS DC AL1(0)       OPTIONS FOR THE JOB SCHEDULING SUBROUTINE
*                                                                 01012
&PREFIX.RCVY EQU X'80'       INDICATES ANY JOB REQUIRING ALLOCATION
*                            RECOVERY IS TO BE FAILED             01012
*            EQU X'40'            RESERVED
*            EQU X'20'            RESERVED
&PREFIX.ENQU EQU X'10'       INDICATES THE JOB IS TO BE FAILED IF THE
*                            DATA SETS WHICH ARE REQUIRED CANNOT BE
*                            OBTAINED IMMEDIATELY OR CANNOT BE OBTAINED
*                            AT ALL.                              01012
*            EQU  X'08'           RESERVED
*            EQU  X'04'           RESERVED
*            EQU  X'02'           RESERVED                        01018
*            EQU  X'01'           RESERVED                        01018
&PREFIX.RSV1 DC   F'0'            RESERVED
&PREFIX.DEST DC  CL8' '           DEFAULT USERID FOR SYSOUT      Y02664
*                                 DESTINATION                    Y02664
&PREFIX.TPR  DS CL24         TIOT PROLOGUE TO BE SUBSTITUTED FOR THE   *
                             PROLOGUE OF THE MODEL TIOT
         ORG  &PREFIX.TPR
&PREFIX.TJOB DC CL8' '       JOBNAME FIELD FOR TIOT PROLOGUE
&PREFIX.TSTE DC CL8' '       STEPNAME FIELD FOR TIOT PROLOGUE
&PREFIX.TPRO DC CL8' '       PROCSTEPNAME FIELD FOR TIOT PROLOGUE
&PREFIX.END EQU *            END OF JOB SCHEDULING OPTIONS LIST
         ORG  &PREFIX.LGTH
&PREFIX  DS   CL(&PREFIX.END-&PREFIX.LGTH)
         MEND
**/ %    JSOLPLS: ;
* /*******************************************************************/
* /*      DEFINE THE JOB SCHEDULING OPTIONS LIST                     */
* /*******************************************************************/
* DECLARE
* 1       IEFVJSOL BASED( JSOLPTR) BOUNDARY( DWORD),
*
*         /*    HALFWORD BINARY INTEGER FIELD PROVIDING THE LENGTH   */
*         /*    OF THE JSOL IN BYTES                                 */
*         2     JSOLLGTH FIXED(15),
*
*         /*    EIGHT-BIT BIT STRING FIELD                           */
*         2     JSOLFLAG BIT(8),
*
*               3 JSOLNSYS BIT(1),  /* NO SYSTEM TASKS        Y02669 */
*               3 JSOLRAC  BIT(1),  /* BYPASS RACINIT        @Z40RPSQ*/
*
*               3  *        BIT(2), /* RESERVED              @Z40RPSQ*/
*
*               /* BIT INDICATING THAT SYSTEM TASK CONTROL MESSAGES  */
*               /* ARE TO BE SUPPRESSED                              */
*               3  JSOLSMS1 BIT(1),
*
*               3  *        BIT(3), /* RESERVED                      */
*
*         /*    OPTIONS OF THE JOB SCHEDULING SUBROUTINE       01012 */
*         2     JSOLOPTS BIT(8),
*
*         /*    INDICATES ANY JOB WHICH ALLOCATION RECOVERY IN       */
*         /*       ORDER TO BE RUN IS TO BE FAILED.            01012 */
*               3 JSOLRCVY BIT(1),
*
*               3 *        BIT(2),  /* RESERVED                      */
*
*         /*    JOBS TO BE SCHEDULED BY THE JOB SCHEDULING SUBROUTINE*/
*         /*       ARE TO BE FAILED IF THE DATA SETS WHICH THEY      */
*         /*       REQUIRE CANNOT BE OBTAINED IMMEDIATELY      01012 */
*               3 JSOLENQU  BIT(1),
*
*               3 *         BIT(4), /* RESERVED                      */
*
*         2     *       FIXED(31),  /* RESERVED                      */
*
*         2     JSOLDEST CHAR(8), /* DEFAULT USER ID FOR       Y02664
*                                    SYSOUT DESTINATION        Y02664*/
*
*         /*    TIOT PROLOGUE FIELD                                  */
*         2     JSOLTPR CHARACTER(24),
*
*               /*   TIOT PROLOGUE JOBNAME FIELD                     */
*               3    JSOLTJOB CHARACTER(8),
*
*               /*   TIOT PROLOGUE STEPNAME FIELD                    */
*               3    JSOLTSTE CHARACTER(8),
*
*               /* TIOT PROLOGUE PROCSTEPNAME FIELD   */
*               3  JSOLTPRO CHARACTER(8);
*%        DECLARE
*         LENJSOL FIXED;
*%        LENJSOL = 40;
