 /********************************************************************/
 /*                                                                  */
 /* NAME - IEFZB432                                                  */
 /*                                                                  */
 /* DESCRIPTIVE NAME - ALLOCATION COMMUNICATION AREA                 */
 /*                                                                  */
 /* SUPPORT CODE - YO2670                                            */
 /*                                                                  */
 /* FUNCTION -                                                       */
 /*   THIS STRUCTURE MAPS THE NUCLEUS RESIDENT CSECT, QMWR (ASSEMBLY */
 /*   MODULE IEFATECB), WHICH CONTAINS UNIVERSAL INFORMATION FOR ALL */
 /*   ALLOCATIONS IN THE SYSTEM. SPECIFICALLY, IT IS USED BY THE     */
 /*   VOLUME MOUNT AND VERIFY ROUTINES TO LOCATE THE MVCA CHAIN, AND */
 /*   BY IEFAB424 (BUILD EDL) TO LOCATE THE NUCLEUS RESIDENT ROUTINE,*/
 /*   IEFAB438 (DDR COUNT ROUTINE). THE CVT CONTAINS THE ADDRESS OF  */
 /*   THE QMWR CSECT.                                                */
 /*   NOTE: THIS STRUCTURE REPLACES THE ALLOCATION/TERMINATION       */
 /*   COMMUNICATION AREA OF OS/VS2 RELEASE 1.                        */
 /*                                                                  */
 /* METHOD OF ACCESS                                                 */
 /*   PL/S - DCL ACTAPTR PTR(31)                                     */
 /*          OR RFY ATCA BASED(CVTQMWR)                              */
 /*                                                                  */
 /********************************************************************/
 DCL
   1 ATCA BASED(ATCAPTR) BDY(WORD),    /*ATCA                        */
     2 ATCA438P PTR(31),               /*PTR TO DDR COUNT ROUTINE    */
     2 *        FIXED(31),             /*RESERVED                    */
     2 *        PTR(31),               /*RESERVED                    */
     2 ATCAMVCP PTR(31);               /*PTR TO FIRST MVCA ON CHAIN  */
 DCL
   IEFAB438 ENTRY BASED(ATCA438P);
