*TITLE 'IEHMVXSF                                                      *
*FUNCTION/OPERATION: THE FUNCTION OF IEHMVXSF IS TO ADJUST THE INPUT  *
*PARAMETERS FOR THE VOLUME MOUNT ROUTINE, IEHMVSSF; PASS CONTROL TO   *
*THAT ROUTINE AND UPON RETURN XCTL TO THE ROUTINE WHICH XCTL'ED TO    *
*IEHMVXSF                                                             *
*ENTRY POINTS: IEHMVXSF                                               *
*INPUT: REGISTER 3 - POINTER TO PARAMETER LIST REGISTER 4 - LAST TWO  *
*CHARACTERS OF ROUTINE WHICH IS TO BE RETURNED TO REGISTER 1 -        *
*PARAMETER LIST POINTER PASSED TO IEHMVSSF                            *
*EXTERNAL ROUTINES: IEHMVSSF                                          *
*EXITS - NORMAL TO ROUTINE SPECIFIED AS INPUT TO IEHMVXSF             *
*ERRORS: NONE                                                         *
*TABLES/WORK AREAS: NONE                                              *
*ATTRIBUTES: REUSEABLE                                                *
*NOTES: IN LOAD MODULE WITH IEHMVSSF AND DEVICE MASK TABLE            *
*
*
*
IEHMVXSF CSECT
*
*                             REGISTER NOTATION AND USAGE
*
R0       EQU   0                        PARAM REG
R1       EQU   1                        PARAM REG
R3       EQU   3                        WORK REG
R4       EQU   4                        WORK REG
R12      EQU   12                       BASE FOR COMMUNICATION AREA
R14      EQU   14                       RETURN REG
R15      EQU   15                       BASE AND ENTRY POINT REG
*
*                             THIS CONTROL SECTION EXISTS FOR THE
*                             PURPOSE OF ADJUSTING THE LINKAGE REGISTER
*                             VALUES TO CONFORM TO STANDARD USAGE PRIOR
*                             TO PASSING CONTROL TO THE VOLUME MOUNTING
*                             ROUTINE.
*
         USING IEHMVXSF,R15             SET UP ADDRESSABILITY
         LR    R1,R3                    ADJUST PARAMETERS
         LR    R0,R14
         L     R15,VOLMT                GET ADDRESS OF VOLUME MOUNT RTN
         BALR  R14,R15                  GO TO VOLUME MOUNT ROUTINE
         USING IEHMVV,R12
         DROP  R15
         USING *,R15                    RELOAD ADDRESSABILITY
         LR    R15,R14
         LR    R14,R0                   ON RETURN FROM VOLUME MOUNT,
         STH   R4,RETURNTO             SET UP RETURN NAME AND XCTL
         OI    IEHMVV20+4,X'10'              INDICATION
         XCTL  EPLOC=XCTL
    DS   0F
XCTL     DC    C'IEHMVE'
RETURNTO DC    C'  '
VOLMT    DC    A(IEHVOLMT)
    EXTRN  IEHVOLMT
         IEHMVV
         END
