*/*********************************************************************
*                                                                     *
*   THIS MACRO DESCRIBES THE COMMUNICATION AREA OF THE I/O MANAGER.   *
*   IT IS LOCATED IN THE NUCLEUS AND IS ADDRESSED BY THE CVT          *
*   (CVTIOBP).  IT CONTAINS THE ADDRESSES OF I/O MANAGER MODULES      *
*   LOCATED IN THE NUCLEUS.  THESE ARE NEEDED BY I/O MANAGER AND ITS  *
*   USERS.                                                            *
*                                                                     *
*    03/09/73          LEVEL=00                                       *
*                                                                     *
**********************************************************************/
* %      GO TO ABPPLS;              /* GO TO THE PLS VERSION         */
         MACRO
         IEZABP
ABP      DSECT
         SPACE 1
         DS    0F
ABPID    DS    BL1                  ABP CONTROL BLOCK IDENTIFIER
ABPLEN   DS    BL1                  LENGTH OF IEZABP
ABPBR14  DS    H                    BRANCH ON REGISTER 14
ABPSIOD  DS    F                    SUPERVISOR STATE I/O DRIVER ADDRESS
ABPABP   DS    F                    ACTUAL BLOCK PROCESSOR ADDRESS
ABPNE    DS    F                    NORMAL END ROUTINE ADDRESS
ABPAE    DS    F                    ABNORMAL END ROUTINE ADDRESS
         MEND
         EJECT
*%ABPPLS: ;
* /* ABP (ACTUAL BLOCK PROCESSOR) DECLARATION                        */
* /*                                                                 */
* /*                                                                 */
*%GO TO ABPPLS1;
* /*    ABP DIAGRAM                                                  */
* /*                                                                 */
* /*  0  ________________________________________________            */
* /*    |           |           |                        |           */
* /*    |   ABPID   |  ABPLEN   |       ABPBR14          |           */
* /*  4 |___________|___________|________________________|           */
* /*    |                                                |           */
* /*    |                   ABPSIOD                      |           */
* /*  8 |________________________________________________|           */
* /*    |                                                |           */
* /*    |                   ABPABP                       |           */
* /* 12 |________________________________________________|           */
* /*    |                                                |           */
* /*    |                   ABPNE                        |           */
* /* 16 |________________________________________________|           */
* /*    |                                                |           */
* /*    |                   ABPAE                        |           */
* /* 20 |________________________________________________|           */
* /*                                                                 */
* /*    ABP DECLARATION                                              */
* /*                                                                 */
*%ABPPLS1:;
*/*                                                                  */
*  DCL 1 IEZABP BDY(WORD) BASED(CVTIOBP),
*        2 ABPID    CHAR(1),        /* ABP CONTROL BLOCK IDENTIFIER  */
*        2 ABPLEN   PTR(8),         /* LENGTH OF IEZABP              */
*        2 ABPBR14  CHAR(2),        /* BRANCH ON REGISTER 14         */
*        2 ABPSIOD  PTR(31),        /* SUPERVISOR STATE I/O DRVR ADDR*/
*        2 ABPABP   PTR(31),        /* ACTUAL BLOCK PROCESSOR ADDRESS*/
*        2 ABPNE    PTR(31),        /* NORMAL END ROUTINE ADDRESS    */
*        2 ABPAE    PTR(31);        /* ABNORMAL END ROUTINE ADDRESS  */
