 /********************************************************************/
 /*          MACCOMP  Y30LB22          SC1DR/BL0019          @Y30LB22*/
 /*          MACSTAT  Y30LB22          74/192/341040         @Y30LB22*/
 /*                                                                  */
 /*          NAME: IEZBASEV                                  @Y30LB22*/
 /*                                                                   */
 /*          FUNCTION:                                       @Y30LB22*/
 /*          A BASE VOLUME RECORD IS CONTAINED IN THE MSVI   @Y30LB22*/
 /*          DATA SET FOR EACH MASS STORAGE VOL (EXCLUDING   @Y30LB22*/
 /*          COPY VOLUMES AND DUPLICATE VOLUME SERIAL        @Y30LB22*/
 /*          NUMBER VOLUMES) CONTAINED IN THE MASS STORAGE   @Y30LB22*/
 /*          FACILITY                                        @Y30LB22*/
 /*                                                          @Y30LB22*/
 /*          STATUS:  CHANGE LEVEL = 1                       @ZA11665*/
 /*                                                          #Y30LB22*/
 /*     CHANGE 01 07/12/76  FIX TO EXPIR DATE                @ZA11665*/
 /*                                                          #Y30LB22*/
 /********************************************************************/
 DCL  1         BASEV BASED(BASEVPTR) BDY(WORD),           /*@Y30LB22*/
         2      BASNAME   CHAR(13),  /*KEY  OF VOL           @Y30LB22*/
           3    BASEVKEY  CHAR(5),   /*LETTER V AND 4 BLANKS @Y30LB22*/
           3    BASSERNO  CHAR(6),   /*VOLUME SER. NO.       @Y30LB22*/
           3    BASID     CHAR(2),   /*RECORD ID             @Y30LB22*/
             4  BASBLANK  CHAR(1),   /*BLANK                 @Y30LB22*/
             4  BASZERO   FIXED(8),  /*BINARY ZEROS          @Y30LB22*/
         2      BASRES7   CHAR(1),   /*RESERVED              @Y30LB22*/
         2      BASFLAGA  BIT(32),   /*FIELD INDICATOR FLGS  @Y30LB22*/
           3    BASTYPE   BIT(16),   /*RECORD TYPE FLAGS     @Y30LB22*/
             4  BASRES1   BIT(2),    /*RESERVED              @Y30LB22*/
             4  BASBASVR  BIT(1),    /*BASE VOLUME RECORD    @Y30LB22*/
             4  BASRES2   BIT(13),   /*RESERVED              @Y30LB22*/
           3    BASDLSF   BIT(1),    /*DOWN LEVEL SPACE FLAG @Y30LB22*/
           3    BASNOCPY  BIT(1),    /*IF ON-NO COPY         @Y30LB22*/
           3    BASGRPV   BIT(1),    /*VOL BELONGS TO GROUP  @Y30LB22*/
           3    BASGENUS  BIT(1),    /*GENERAL USE TYPE VOL  @Y30LB22*/
           3    BASRSTD   BIT(1),    /*RESTRICTED TYPE VOL   @Y30LB22*/
           3    BASINAC   BIT(1),    /*INACTIVE TYPE VOLUME  @Y30LB22*/
           3    BASBIND   BIT(1),    /*ATTR FOR VOL IS BIND  @Y30LB22*/
           3    BASEXCL   BIT(1),    /*ATTRIB IS EXCLUSIVE   @Y30LB22*/
           3    BASDAERA  BIT(1),    /*ATTRIB IS DASDERASE   @Y30LB22*/
           3    BASRONLY  BIT(1),    /*ATTRIB IS READ ONLY   @Y30LB22*/
           3    BASREASS  BIT(1),    /*CARTRIDGES REASSIGNED @Y30LB22*/
           3    BASFIRST  BIT(1),    /*FIRST VOL IN CHAIN    @Y30LB22*/
           3    BASLAST   BIT(1),    /*LAST VOL IN CHAIN     @Y30LB22*/
           3    *         BIT(3),    /*UNUSED                @Y30LB22*/
         2      BASCPUID  BIT(16),   /*CPU ASSOCIATION MAP   @Y30LB22*/
         2      BASRCVYF  BIT(32),   /*RECOVERY FIELDS       @Y30LB22*/
           3    BASSATIA  BIT(16),   /*STATUS INDICATOR AREA @Y30LB22*/
             4  BASIVCRE  BIT(1),    /*INCOMPLETE VOL CREATE @Y30LB22*/
             4  BASIVCPY  BIT(1),    /*INCOMPLETE VOL. COPY  @Y30LB22*/
             4  BASVSMIS  BIT(1),    /*VOL. SER. MISMATCH    @Y30LB22*/
             4  BASRES8   BIT(13),   /*RESERVED              @Y30LB22*/
           3    BASMISCF  BIT(16),   /*MISCL. FLAGS          @Y30LB22*/
             4  BASHOLD   BIT(1),    /*PLACEHOLDER RECORD    @Y30LB22*/
             4  BASRES3   BIT(15),   /*RESERVED              @Y30LB22*/
         2      BASCSN1   CHAR(12),  /*SER # - 1ST CARTRIDGE @Y30LB22*/
         2      BASLIB1   FIXED(8),  /*ID OF LIB FOR CSN1    @Y30LB22*/
           3    BASRES4   BIT(6),    /*RESERVED              @Y30LB22*/
           3    BASLID1   BIT(2),    /*LIBRARY ID 1          @Y30LB22*/
             4  BAS1BIT1  BIT(1),    /*LIBRARY NO.           @Y30LB22*/
             4  BAS1BIT2  BIT(1),    /*LIBRARY NO.           @Y30LB22*/
         2      BASCSN2   CHAR(12),  /*SER # - 2ND CARTRIDGE @Y30LB22*/
         2      BASLIB2   FIXED(8),  /*LIBRARY ID FOR CSN2   @Y30LB22*/
           3    BASRES5   BIT(6),    /*RESERVED              @Y30LB22*/
           3    BASLID2   BIT(2),    /*LIBRARY ID 2          @Y30LB22*/
             4  BAS2BIT1  BIT(1),    /*LIBRARY NO.           @Y30LB22*/
             4  BAS2BIT2  BIT(1),    /*LIBRARY NO.           @Y30LB22*/
         2      BASPREV   CHAR(6),   /*VOL SER OF PREV VOL   @Y30LB22*/
         2      BASNEXTV  CHAR(6),   /*VOL SER OF NEXT VOL   @Y30LB22*/
         2      BASNCOPY  FIXED(8),  /*# COPIES OF THIS VOL  @Y30LB22*/
         2      BASNBKUP  FIXED(8),  /*# BKUP COPYIES OF VOL @Y30LB22*/
         2      BASBKLMT  FIXED(8),  /*MAX # - BACKUP COPIES @Y30LB22*/
         2      *         CHAR(3),   /*UNUSED                @Y30LB22*/
         2      BASFRESP  FIXED(16), /*NO. OF FREE CYLINDERS @Y30LB22*/
         2      BASLEXT   FIXED(16), /*CYL LARGEST FREE EXT  @Y30LB22*/
         2      BASFREXT  FIXED(32), /*FREE EXTENTS ON VOL   @Y30LB22*/
         2      BASKLCPY  CHAR(13),  /*LAST COPY OF VOL KEY  @Y30LB22*/
           3    BASCOPV   CHAR(5),   /* LETTER V & 4 BLANKS  @Y30LB22*/
           3    BASCOPSN  CHAR(6),   /* SER NO OF COPIED VOL @Y30LB22*/
           3    BASCOPID  CHAR(2),   /* RECORD NUMBER ID     @Y30LB22*/
             4  BASCOPBK  CHAR(1),   /* BLANK                @Y30LB22*/
             4  BASCOPNO  FIXED(8),  /* BIN NO OF COPIED REC @Y30LB22*/
         2      BASRES6   CHAR(3),   /*RESERVED              @Y30LB22*/
         2      BASDLMTD  CHAR(4),   /*DATE WHEN LAST MTD    @Y30LB22*/
         2      BASEXPDT  CHAR(4),   /*EXP DATE FOR VOL      @Y30LB22*/
         2      BASDTREM  CHAR(4),   /*DATE VOL WAS EJECTED  @Y30LB22*/
         2      BASDESCR  CHAR(30),  /*DESCR INFO ABOUT VOL  @Y30LB22*/
         2      BASOWNER  CHAR(10),  /*NAME/ID OF VOL OWNER  @Y30LB22*/
         2      BASDEST   CHAR(30),  /*DEST AFTER EJECTION   @Y30LB22*/
         2      BASRECOV  CHAR(6),   /*SER # FOR RECOVERY    @Y30LB22*/
         2      BASGROUP  CHAR(8),   /*GROUP VOL BELONGS TO  @Y30LB22*/
         2      BASXPDT2  CHAR(4),   /*OLD EXPIRATION DATE   @ZA11665*/
         2      *         CHAR(32);  /*UNUSED                @ZA11665*/
