 /********************************************************************/
 /*          MACCOMP  Y30LB22          SC1DR/BL0019          @Y30LB22*/
 /*          MACSTAT  Y30LB22          74/192/341040         @Y30LB22*/
 /*                                                                   */
 /*          NAME: IEZBCDV                                   @Y30LB22*/
 /*                                                                   */
 /*          FUNCTION: MAPPING MACRO                         @Y30LB22*/
 /*          THIS MACRO MAPS THE COMMON PARTS OF THE BASE,   @Y30LB22*/
 /*          COPY, AND DUPLICATE VOLUME RECORDS.             @Y30LB22*/
 /*                                                                   */
 /*          STATUS:  CHANGE LEVEL = 0                       @Y30LB22*/
 /*                                                                   */
 /********************************************************************/
     DCL
       1        BCDV BASED(BCDVPTR) BDY(WORD),             /*@Y30LB22*/
         2      BCDNAME   CHAR(13),  /* KEY OF VOLUME        @Y30LB22*/
           3    BCDPREFX  CHAR(5),   /* A LETTER & 4 BLANKS  @Y30LB22*/
             4  BCDALPHA  CHAR(1),   /* ALPHA CHARACTER      @Y30LB22*/
             4  BCDBLNK1  CHAR(4),   /* BLANK                @Y30LB22*/
           3    BCDSERNO  CHAR(6),   /* VOL SER NUMBER       @Y30LB22*/
           3    BCDID     CHAR(2),   /* RECORD ID            @Y30LB22*/
             4  BCDBLNK2  CHAR(1),   /* BLANK                @Y30LB22*/
             4  BCDINDEX  FIXED(8),  /* RECORD INDEX NO.     @Y30LB22*/
         2      BCDRES9   CHAR(1),   /* RESERVED             @Y30LB22*/
         2      BCDFLAGA  BIT(32),   /* INDICATOR FLAGS      @Y30LB22*/
           3    BCDTYPE   BIT(16),   /* RECORD TYPE FLAGS    @Y30LB22*/
             4  BCDRES1   BIT(2),    /* RESERVED             @Y30LB22*/
             4  BCDBASE   BIT(1),    /* BASE VOLUME RECORD   @Y30LB22*/
             4  BCDCOPY   BIT(1),    /* COPY VOLUME RECORD   @Y30LB22*/
             4  BCDRES2   BIT(1),    /* RESERVED             @Y30LB22*/
             4  BCDDUP    BIT(1),    /* DUPLICATE VOL RECORD @Y30LB22*/
             4  BCDRES3   BIT(10),   /* RESERVED             @Y30LB22*/
           3    BCDFLAGB  BIT(16),   /* SCRATCH FLAGS        @Y30LB22*/
             4  BCDRES4   BIT(10),   /* RESERVED             @Y30LB22*/
             4  BCDREASS  BIT(1),    /* CARTRIDGE REASSIGNED @Y30LB22*/
             4  BCDRES5   BIT(5),    /* RESERVED             @Y30LB22*/
         2      BCDCPUID  BIT(16),   /* CPU ASSOC BIT MAP    @Y30LB22*/
         2      BCDRCVYF  BIT(32),   /* RECOVERY FIELDS      @Y30LB22*/
           3    BCDSATIA  BIT(16),   /* STATUS INDICATOR     @Y30LB22*/
             4  BCDIVCRE  BIT(1),    /* INCOMPLETE VOL CREAT @Y30LB22*/
             4  BCDIVCPY  BIT(1),    /* INCOMPLETE VOL COPY  @Y30LB22*/
             4  BCDVSMIS  BIT(1),    /* VOL SER MISMATCH     @Y30LB22*/
             4  BCDRES7   BIT(13),   /* RESERVED             @Y30LB22*/
           3    BCDMISCF  BIT(16),   /* MISCL. FLAGS         @Y30LB22*/
             4  BCDHOLD   BIT(1),    /* PLACEHOLDER RECORD   @Y30LB22*/
             4  BCDRES7A  BIT(15),   /* RESERVED             @Y30LB22*/
         2      BCDCSN1   CHAR(12),  /* SER NO OF 1ST CART.  @Y30LB22*/
         2      BCDLIB1   FIXED(8),  /* ID OF LIB FOR CSN1   @Y30LB22*/
           3    BCDRE10   BIT(6),    /* RESERVED             @Y30LB22*/
           3    BCDLID1   BIT(2),    /* LIBRARY ID 1         @Y30LB22*/
             4  BCD1BIT1  BIT(1),    /* LIBRARY NO.          @Y30LB22*/
             4  BCD1BIT2  BIT(1),    /* LIBRARY NO.          @Y30LB22*/
         2      BCDCSN2   CHAR(12),  /* SER NO OF 2ND CART.  @Y30LB22*/
         2      BCDLIB2   FIXED(8),  /* ID OF LIB FOR CSN2   @Y30LB22*/
           3    BCDRES8   BIT(6),    /* RESERVED             @Y30LB22*/
           3    BCDLID2   BIT(2),    /* LIBRARY ID 2         @Y30LB22*/
             4  BCD2BIT1  BIT(1),    /* LIBRARY NO.          @Y30LB22*/
             4  BCD2BIT2  BIT(1);    /* LIBRARY NO.          @Y30LB22*/
