 /********************************************************************/
 /*          MACCOMP  Y30LB22          SC1DR/BL0019          @Y30LB22*/
 /*          MACSTAT  Y30LB22          74/192/341040         @Y30LB22*/
 /*                                                                   */
 /*          NAME: IEZCOPYV                                  @Y30LB22*/
 /*                                                                   */
 /*          FUNCTION: MAPPING MACRO                         @Y30LB22*/
 /*          A COPY VOL RECORD IS  CONTAINED IN THE MSVI     @Y30LB22*/
 /*          DATA SET FOR EACH COPY VOLUME  CONTAINED        @Y30LB22*/
 /*          IN THE MASS STORAGE FACILITY                    @Y30LB22*/
 /*                                                          @Y30LB22*/
 /*          STATUS:  CHANGE LEVEL = 0                       @Y30LB22*/
 /*                                                                   */
 /********************************************************************/
     DCL
       1        COPYV BASED(COPYVPTR) BDY(WORD),           /*@Y30LB22*/
         2      COPNAME   CHAR(13),  /* KEY OF VOLUME        @Y30LB22*/
           3    COPV      CHAR(5),   /* LETTER V & 4 BLANKS  @Y30LB22*/
           3    COPSERNO  CHAR(6),   /* SER NO OF COPIED VOL @Y30LB22*/
           3    COPID     CHAR(2),   /* RECORD NUMBER ID     @Y30LB22*/
             4  COPBLANK  CHAR(1),   /* BLANK                @Y30LB22*/
             4  COPNO     FIXED(8),  /* BIN NO OF COPIED REC @Y30LB22*/
         2      COPRES6   CHAR(1),   /* RESERVED             @Y30LB22*/
         2      COPFLAGA  BIT(32),   /* INDICATOR FLAGS      @Y30LB22*/
           3    COPTYPE   BIT(16),   /* RECORD TYPE FLAGS    @Y30LB22*/
             4  COPRES1   BIT(3),    /* RESERVED             @Y30LB22*/
             4  COPCOPYV  BIT(1),    /* COPY VOL RECORD      @Y30LB22*/
             4  COPRES2   BIT(12),   /* RESERVED             @Y30LB22*/
           3    COPGROUP  BIT(1),    /* VOL BELONGS TO GROUP @Y30LB22*/
           3    COPVSAM   BIT(1),    /* BELONGS TO VSAM CAT  @Y30LB22*/
           3    COPGENUS  BIT(1),    /* GENERAL USE TYPE VOL @Y30LB22*/
           3    COPRSTD   BIT(1),    /* RESTRICTED TYPE VOL  @Y30LB22*/
           3    COPBKUP   BIT(1),    /* COPY IS A BKUP COPY  @Y30LB22*/
           3    COPBIND   BIT(1),    /* ATTRIBUTE WAS BIND   @Y30LB22*/
           3    COPEXCL   BIT(1),    /* ATTRIBUTE-EXCLUSIVE  @Y30LB22*/
           3    COPDAERA  BIT(1),    /* ATTRIBUTE DASDERASE  @Y30LB22*/
           3    COPRONLY  BIT(1),    /* ATTRIBUTE-READ ONLY  @Y30LB22*/
           3    COPDLSPF  BIT(1),    /* DOWN LEVEL SPACE FLG @Y30LB22*/
           3    *         BIT(6),    /* UNUSED               @Y30LB22*/
         2      *         BIT(16),   /* UNUSED               @Y30LB22*/
         2      COPRCVYF  BIT(32),   /* RECOVERY FIELDS      @Y30LB22*/
           3    COPSATIA  BIT(16),   /* STATUS INDICATOR     @Y30LB22*/
             4  COPIVCRE  BIT(1),    /* INCOMPLETE CREATE    @Y30LB22*/
             4  COPIVCPY  BIT(1),    /* INCOMPLETE VOL. COPY @Y30LB22*/
             4  COPVSMIS  BIT(1),    /* VOL SER. MISMATCH    @Y30LB22*/
             4  COPRES3   BIT(13),   /* RESERVED             @Y30LB22*/
           3    COPMISCF  BIT(16),   /* MISCL. FLAG          @Y30LB22*/
             4  COPHOLD   BIT(1),    /* COPY PLACEHOLDER     @Y30LB22*/
             4  *         BIT(15),   /* UNUSED               @Y30LB22*/
         2      COPCSN1   CHAR(12),  /* SER NO OF 1ST CART.  @Y30LB22*/
         2      COPLIB1   FIXED(8),  /* ID OF LIB FOR CSN1   @Y30LB22*/
           3    COPRES4   BIT(6),    /* RESERVED             @Y30LB22*/
           3    COPLID1   BIT(2),    /* LIBRARY ID 1         @Y30LB22*/
             4  COP1BIT1  BIT(1),    /* LIBRARY NO.          @Y30LB22*/
             4  COP1BIT2  BIT(1),    /* LIBRARY NO.          @Y30LB22*/
         2      COPCSN2   CHAR(12),  /* SER NO OF 2ND CART.  @Y30LB22*/
         2      COPLIB2   FIXED(8),  /* ID OF LIB FOR CSN2   @Y30LB22*/
           3    COPRES5   BIT(6),    /* RESERVED             @Y30LB22*/
           3    COPLID2   BIT(2),    /* LIBRARY ID 2         @Y30LB22*/
             4  COP2BIT1  BIT(1),    /* LIBRARY NO.          @Y30LB22*/
             4  COP2BIT2  BIT(1),    /* LIBRARY NO.          @Y30LB22*/
         2      COPDATE   CHAR(4),   /* DATE COPY WAS MADE   @Y30LB22*/
         2      COPDTREM  CHAR(4),   /* DATE VOL WAS EJECTED @Y30LB22*/
         2      COPDESCR  CHAR(30),  /* DESCRIPTIVE INFO     @Y30LB22*/
         2      COPDEST   CHAR(30),  /* DEST. AFTER EJECTED  @Y30LB22*/
         2      COPOWNER  CHAR(10),  /* NAME/ID OF OWNER     @Y30LB22*/
         2      COPFRESP  FIXED(15), /* NO OF FREE CYL ON    @Y30LB22
                                        VOL AT TIME OF COPY  @Y30LB22*/
         2      COPLEXT   FIXED(15), /* NO. CYL IN LARGEST   @Y30LB22
                                        FREE EXTENT AT TIME  @Y30LB22
                                        OF COPY              @Y30LB22*/
         2      COPFREXT  FIXED(31), /* NO. OF FREE EXTENTS  @Y30LB22
                                        AT TIME OF COPY      @Y30LB22*/
         2      *         CHAR(28);  /* UNUSED               @Y30LB22*/
