 /********************************************************************/
 /*          MACCOMP  Y30LB22          SC1DR/BL0019          @Y30LB22*/
 /*          MACSTAT  Y30LB22          74/170/341040         @Y30LB22*/
 /*                                                                   */
 /*          NAME: IEZCOVCE                                  @Y30LB22*/
 /*                                                                   */
 /*          FUNCTION:                                       @Y30LB22*/
 /*          MAPS THE REQUEST BLOCK EXTENSION WHICH          @Y30LB22*/
 /*          IS USED TO PASS ADDITIONAL INFORMATION TO MASS  @Y30LB22*/
 /*          STORAGE VOLUME CONTROL DURING AN COPY           @Y30LB22*/
 /*          CARTRIDGE OR COPY VOLUME REQUEST.               @Y30LB22*/
 /*                                                                   */
 /*          STATUS:  CHANGE LEVEL = 0                       @Y30LB22*/
 /*                                                                   */
 /********************************************************************/
    /* CONSTANTS FOR IEZCOVCE                                @Y30LB22*/
     DCL  COVLEN  FIXED(15) INIT(LENGTH(COVCE)); /* LENGTH   @Y30LB22
                                            OF EXTENSION     @Y30LB22*/
     DCL
       1        COVCE BASED(COVCEPTR) BDY(WORD),
         2      COVLNGTH  FIXED(31), /* LENGTH OF EXTENSION  @Y30LB22*/
         2      COVDESCR  CHAR(30),  /* DESCRIPTIVE INFO     @Y30LB22*/
         2      COVFLAGA  BIT(8),    /* SPECIFICATION FLAG   @Y30LB22*/
           3    COVSPDES  BIT(1),    /* COVDESCR SPECIFIED   @Y30LB22*/
           3    *         BIT(7),    /* UNUSED               @Y30LB22*/
         2      COVFLAGB  BIT(32),   /* INDICATOR FLAGS      @Y30LB22*/
           3    COVSETFL  BIT(8),    /* RECOVERY FLAGS       @Y30LB22
                                        INDICATORS           @Y30LB22*/
             4  COVSRCVY  BIT(1),    /* SET RECOVERY FLAGS   @Y30LB22*/
             4  COVCRCVY  BIT(1),    /* CLEAR RECOVERY FLAGS @Y30LB22*/
             4  *         BIT(6),    /* UNUSED               @Y30LB22*/
           3    COVRECFL  BIT(8),    /* RECOVERY FLAGS       @Y30LB22*/
             4  COVICOPY  BIT(1),    /* INCOMPLETE COPY OPER @Y30LB22*/
             4  COVCREAT  BIT(1),    /* INCOMPLETE CREATION  @Y30LB22*/
             4  COVLAMIS  BIT(1),    /* VOL LABEL MISMATCH   @Y30LB22*/
             4  *         BIT(5),    /* UNUSED               @Y30LB22*/
           3    COVTYPE   BIT(8),    /* VOLUME TYPE FLAG     @Y30LB22*/
             4  COVSAM    BIT(1),    /* VSAM TYPE VOLUME     @Y30LB22*/
             4  COVREUSE  BIT(1),    /* REUSE OLD COPY REC.  @Y30LB22*/
             4  *         BIT(6),    /* UNUSED               @Y30LB22*/
           3    *         BIT(8),    /* UNUSED               @Y30LB22*/
         2      *         CHAR(4);   /* UNUSED               @Y30LB22*/
