*  %GO TO CTGFLX01;
*  /*
         MACRO
         IEZCTGFL ,
CTGFL    DSECT ,                        */
*%CTGFLX01:;
*/********************************************************************/
*/*                                                                  */
*/*   MACRO NAME = IEZCTGFL                                          */
*/*                                                                  */
*/*   DESCRIPTIVE NAME = CATALOG FIELD PARAMETER LIST                */
*/*                                                                  */
*/*   FUNCTION = THE FIELD PARAMETER LIST (CTGFL) DEFINES ONE OF     */
*/*              THE CATALOG RECORD'S FIELDS OR A GROUP OF           */
*/*              LOGICALLY RELATED FIELDS.  THE CTGFL IS BUILT       */
*/*              BEFORE AN OS/VS COMPONENT ISSUES THE CATLG          */
*/*              MACRO INSTRUCTION (SVC 26) TO PROCESS A             */
*/*              CATALOG RECORD.  THE CTGFL IS USED IN TWO           */
*/*              SITUATIONS:                                         */
*/*                (1)  IT IDENTIFIES CATALOG RECORD INFORMATION     */
*/*                     TO RETRIEVE OR UPDATE.  THE CTGPL CONTAINS   */
*/*                     THE ADDRESS OF EACH CTGFL USED IN THIS WAY.  */
*/*                (2)  IT IDENTIFIES CATALOG RECORD INFORMATION     */
*/*                     TO COMPARE AGAINST CALLER-SUPPLIED DATA.     */
*/*                     THIS IS A "TEST" CTGFL AND IS ADDRESSED BY   */
*/*                     ANOTHER CTGFL.                               */
*/*                                                                  */
*/*   CONTROL BLOCK STRUCTURE = THE CTGFL IS POINTED TO BY THE       */
*/*                             CCA ('CCAFLPT' OR 'CCATEST').        */
*/*                                                                  */
*/*   INCLUDED MACROS = NONE                                         */
*/*                                                                  */
*/*   METHOD OF ACCESS = PL/S - NO DECLARES NECESSARY                */
*/*                                                                  */
*/*   STATUS = VS/2 RELEASE 3   (CHANGE FLAG @Y30SSXX)               */
*/*                                                                  */
*/*   DATE OF LAST CHANGE = 17 JUL 74                                */
*/*                                                                  */
*/********************************************************************/
*%DECLARE (CTGFLLEN, CTGFL999, CTGFLLVL) CHAR;
*%CTGFLLEN = 'LENGTH(CTGFL)';       /* LENGTH OF CTGFL               */
*%GOTO CTGFLX03;
* /*
         AGO   .CTGFL01                 */
*%CTGFLX03:;
*%IF CTGFL999 ^= ','                /* IF BLOCK NOT CONTINUED,       */
*  %THEN %CTGFL999 = ';';           /*   THEN CLOSE DECLARE STMNT    */
*%IF CTGFLLVL  = ''                 /* IF BLOCK NOT CONCATENATED,    */
*  %THEN %GOTO CTGFL001;            /*   THEN GENERATE DECLARE       */
*%CTGFLDUM = CTGFLLVL||' CTGFL';    /* SET MINOR LEVEL NUMBER        */
*   CTGFLDUM                        /* CTGFL CONCATENATED LEVEL      */
*%GOTO CTGFL002;                    /* SKIP DECLARE                  */
*%CTGFL001:;                        /* DECLARE                       */
    DECLARE
*     1 CTGFL BASED(CTGFLPTR)       /* DECLARE CTGFL LEVEL ONE       */
*%CTGFL002:;                        /* SKIP DECLARE                  */
*        BDY(WORD),                 /* WORD BOUNDARY                 */
*       5 CTGFLDNO PTR(8),          /* NO. PAIRS DATA LENGTH/ADDR    */
*       5 CTGFLDCD BIT(8),          /* TEST CONDITION                */
*       5 CTGFLDGC PTR(8),          /* GROUP CODE NUMBER             */
*       5 CTGFLDRE BIT(8),          /* TEST RESULT                   */
*         10 *        BIT(7),       /* RESERVED                      */
*         10 CTGFLDTS BIT(1),       /* 0 = SUCCESSFUL TEST,          */
*                                   /* 1 = TEST FAILED               */
*       5 CTGFLDWA BIT(32),         /* CATALOG WORK AREA             */
*       5 CTGFLDNM PTR(31),         /* FIELD NAME ADDRESS            */
*       5 CTGFLCHN PTR(31),         /* ADDR OF NEXT FIELD MACRO      */
*                                   /* OR ZERO                       */
*       5 CTGFLDAT(*),              /* PAIRS OF DATA LENGTH/ADDR     */
*         10 CTGFLNG FIXED(31),     /* DATA LENGTH                   */
*         10 CTGFLPT  PTR(31) CTGFL999 /* DATA ADDRESS               */
*/********************************************************************/
*/*     CONSTANTS USED TO SET AND/OR TEST FIELDS DECLARED ABOVE      */
*/********************************************************************/
    DECLARE                         /* TEST CONDITION - CTGFLDCD     */
      CTGFLDEQ BIT(8) CONSTANT('80'X), /* EQUAL                      */
      CTGFLDNE BIT(8) CONSTANT('60'X), /* NOT EQUAL                  */
      CTGFLDGT BIT(8) CONSTANT('20'X), /* GREATER THAN               */
      CTGFLDLT BIT(8) CONSTANT('40'X), /* LESS THAN                  */
      CTGFLDGE BIT(8) CONSTANT('A0'X), /* GREATER THAN OR EQUAL      */
      CTGFLDLE BIT(8) CONSTANT('C0'X), /* LESS THAN OR EQUAL         */
      CTGFLDZ  BIT(8) CONSTANT('80'X), /* TEST UNDER MASK FOR ZEROES */
      CTGFLDON BIT(8) CONSTANT('10'X), /* TEST UNDER MASK FOR ONES   */
      CTGFLDMX BIT(8) CONSTANT('40'X); /* TEST UNDER MASK FOR MIXED  */
* %GO TO CTGFLX02;
*/*
.CTGFL01 ANOP
*
CTGFLDNO DS    XL1                      NUMBER PAIRS DATA LNG/ADDR
*
CTGFLDCD DS    XL1                      TEST CONDITION
CTGFLDEQ EQU   X'80'                    EQUAL
CTGFLDNE EQU   X'60'                    NOT EQUAL
CTGFLDGT EQU   X'20'                    GREATER THAN
CTGFLDLT EQU   X'40'                    LESS THAN
CTGFLDGE EQU   X'A0'                    GREATER THAN OR EQUAL
CTGFLDLE EQU   X'C0'                    LESS THAN OR EQUAL
CTGFLDZ  EQU   X'80'                    TEST UNDER MASK FOR ZEROES
CTGFLDON EQU   X'10'                    TEST UNDER MASK FOR ONES
CTGFLDMX EQU   X'40'                    TEST UNDER MASK FOR MIXED
*
CTGFLDGC DS    XL1                      GROUP CODE NUMBER
*
CTGFLDRE DS    XL1                      TEST RESULT
CTGFLDTS EQU   X'01'                    TEST MASK - CTGFLDRE
*                                       = 0 - SUCCESSFUL TEST,
*                                       = 1 - TEST FAILED
*
CTGFLDWA DS    F                        CATALOG WORK AREA
*
CTGFLDNM DS    A                        FIELD NAME ADDRESS
*
CTGFLCHN DS    A                        ADDRESS OF NEXT FIELD
*
*
CTGFLDAT DS    0CL8                     PAIRS OF DATA LENGTH/ADDRESS
CTGFLNG  DS    F                        DATA LENGTH
CTGFLPT  DS    A                        DATA ADDRESS
*
*
         MEND  ,                        */
* %CTGFLX02:;
