* %GOTO CTGPLX01; /*
         MACRO
         IEZCTGPL ,
         DSECT ,                        */
* %CTGPLX01:;
*/********************************************************************/
*/*                                                                  */
*/*   MACRO NAME = IEZCTGPL                                          */
*/*                                                                  */
*/*   DESCRIPTIVE NAME = CATALOG PARAMETER LIST                      */
*/*                                                                  */
*/*   FUNCTION = THE CATALOG PARAMETER LIST (CTGPL) DEFINES THE      */
*/*              CATALOG MANAGEMENT REQUEST AND ITS OPTIONS, THE     */
*/*              CATALOG RECORD TO BE PROCESSED, AND THE VSAM        */
*/*              CATALOG THAT CONTAINES THE RECORD.  THE CTGPL IS    */
*/*              BUILT BEFORE AN OS/VS COMPONENT ISSUES THE CATLG    */
*/*              MACRO INSTRUCTION (SVC 26) TO PROCESS A CATALOG     */
*/*              RECORD.  WHEN THE CATALOG MANAGEMENT ROUTINES       */
*/*              BUILD A CCA TO SUPPORT THE REQUEST, THE ADDRESS     */
*/*              OF THE CTGPL IS PUT INTO THE CCA (CCACPL).          */
*/*                                                                  */
*/*   CONTROL BLOCK STRUCTURE = THE CTGPL IS POINTED TO BY           */
*/*                             REGISTER 1.                          */
*/*                                                                  */
*/*   INCLUDED MACROS = NONE                                         */
*/*                                                                  */
*/*   METHOD OF ACCESS = PL/S - NO DECLARES NECESSARY                */
*/*                                                                  */
*/*   STATUS = VS/2 RELEASE 4   (CHANGE FLAG @Z40WSXX)       @Z40WSSG*/
*/*                                                                  */
*/*   DATE OF LAST CHANGE = 16 AUG 77                        @ZA20773*/
*/*                                                                  */
*/********************************************************************/
*%GOTO CTGPLX03;
*/*
         AGO   .CTGPL01                 */
*%CTGPLX03:;
*%DECLARE (CTGPLLEN, CTGPL999, CTGPLLVL) CHAR;
*%CTGPLLEN = 'LENGTH(CTGPL)';       /* LENGTH OF CTGPL               */
*%IF CTGPL999 ^= ','                /* IF BLOCK NOT CONTINUED,       */
*   %THEN %CTGPL999 = ';';          /*   THEN CLOSE DCL STATEMENT    */
*%IF CTGPLLVL  = ''                 /* IF BLOCK NOT CONCATENATED,    */
*   %THEN %GOTO CTGPL001;           /*   THEN GENERATE DCL           */
*%CTGPLDUM = CTGPLLVL||' CTGPL';    /* SET MINOR LEVEL NUMBER        */
*        CTGPLDUM                   /* CTGPL CONCATENATED LEVEL      */
*%GOTO CTGPL002;                    /* SKIP DECLARE                  */
*%CTGPL001:;                        /* DECLARE                       */
*   DECLARE
*     1 CTGPL BASED(CTGPLPTR)       /* DECLARE CTGPL LEVEL ONE       */
*%CTGPL002:;                        /* SKIP DECLARE                  */
*        BDY(WORD),                 /* WORD BOUNDARY                 */
*       5 CTGOPTN1 BIT(8),          /* FIRST OPTION INDICATOR        */
*         10 CTGBYPSS BIT(1),       /* BYPASS                        */
*         10 CTGMAST  BIT(1),       /* VERIFY MASTER PASSWORD        */
*         10 CTGCI    BIT(1),       /* VERIFY CONTROL INTERVAL       */
*         10 CTGUPD   BIT(1),       /* VERIFY UPDATE                 */
*         10 CTGREAD  BIT(1),       /* VERIFY READ                   */
*         10 CTGNAME  BIT(1),       /* 1 = 44-BYTE NAME OR VOL SER,  */
*                                   /* 0 = ENTRY ID NUMBER           */
*         10 CTGCNAME BIT(1),       /* 1 = 44-BYTE NAME,             */
*                                   /* 0 = ACB ADDRESS               */
*         10 CTGGENLD BIT(1),       /* GENERIC LOCATE REQUEST  Y02020*/
*       5 CTGOPTN2 BIT(8),          /* SECOND OPTION INDICATOR       */
*         10 CTGEXT   BIT(1),       /* EXTEND       (UPDATE)         */
*            15 CTGNSVS BIT(1),     /* CATLG CLEANUP REQUEST @ZA00605*/
*         10 CTGERASE BIT(1),       /* ERASE        (DELETE)         */
*            15 CTGSMF   BIT(1),    /* WRITE SMF    (LSPACE)         */
*               20 CTGREL   BIT(1), /* RELEASE      (UPDATE)         */
*                  25 CTGGTALL BIT(1),/* CONCAT SEARCH  FOR    Y02020*/
*                                   /* (LISTCAT)               Y02020*/
*         10 CTGPURG  BIT(1),       /* PURGE        (DELETE)         */
*           15 CTGVMNT BIT(1),      /* VOLUME MOUNT CALLER           */
*              20 CTGRCATN BIT(1),  /* RTN CATLG NAME(GLOC)    Y02020*/
*                 25 CTGSWAP BIT(1),/* SWAPSPACE (DEFINE)    @Z40WSSG*/
*         10 CTGGTNXT BIT(1),       /* GET NEXT     (LIST CATALOG)   */
*         10 CTGDISC BIT(1),        /* DISCONNECT   (DELETE)         */
*         10 CTGOVRID BIT(1),       /* ERASE OVERRIDE (DELETE)       */
*         10 CTGSCR   BIT(1),       /* SCRATCH SPACE (DELETE)        */
*         10 *        BIT(1),       /* RESERVED                      */
*       5 CTGOPTN3 BIT(8),          /* THIRD OPTION INDICATOR        */
*         10 CTGFUNC  BIT(3),       /* CATALOG FUNCTION              */
*         10 CTGSUPLT BIT(1),       /* SUPER LOCATE                  */
*         10 CTGGDGL  BIT(1),       /* GDG LOCATE REQUEST      Y02020*/
*                                   /* WITH BASE LEVEL GIVEN   Y02020*/
*                                   /* (CTGWAGB IN CTGWA)      Y02020*/
*         10 CTGSRH   BIT(1),       /* 0 = SEARCH MASTER CATLG Y02020*/
*                                   /*     ONLY                Y02020*/
*                                   /* 1 = SEARCH OS CATALOG FIRST   */
*         10 CTGNUM   BIT(1),       /* 0 = SEARCH BOTH CATALOGS,     */
*                                   /* 1 = SEARCH ONE CATALOG        */
*         10 CTGAM0   BIT(1),       /* VSAM REQ VERSUS NONVSAM       */
*       5 CTGOPTN4 BIT(8),          /* GDG FLAGS                     */
*         10 CTGLBASE BIT(1),       /* LOCATE GDG BASE ONLY Y02020   */
*         10 CTGDOCAT BIT(1),       /* DO NOT OPEN NEEDED CATALOG    */
*         10 CTGNPROF BIT(1),       /* NO (RAC) PROFILE SHOULD BE
*                                      DEFINED OR DELETED    @Z40RSRC*/
*         10 CTGCOIN  BIT(1),       /* CONTROLLER INTERCEPT REQUESTED
*                                                            @ZA20773*/
*         10 CTGBYPMT BIT(1),       /* BYPASS SECURITY PROMPTING
*                                       TO SYSTEM OPERATOR   @ZA07531*/
*         10 CTGTIOT  BIT(1),       /* CALLER OWNS SYSZTIOT EXCLUSIVE
*                                                            @ZA20773*/
*         10 *        BIT(2),       /* RESERVED              @ZA20773*/
*       5 CTGENT   PTR(31),         /* USER ENTRY ADDR OR PTR TO VOLUME
*                                        SERIAL NUMBER (LSPACE)      */
*         10 CTGFVT   PTR(31),      /* FVT ADDRESS (DEFINE, ALTER)   */
*       5 CTGCAT   PTR(31),         /* CATALOG POINTER               */
*         10 CTGCVOL PTR(31),       /* CVOL PTR (SUPER LOCATE)       */
*       5 CTGWKA  PTR(31),          /* WORKAREA ADDR                 */
*       5 CTGDSORG CHAR(2),         /* DATA SET ORG - SUPERLOCATE    */
*         10 CTGOPTNS BIT(5),       /* CMS OPTIONS                   */
*         10 *        BIT(11),      /* RESERVED                      */
*       5 CTGTYPE  CHAR(1),         /* ENTRY TYPE - LISTCAT, DELETE  */
*       5 CTGNOFLD PTR(8),          /* NUMBER OF FIELD POINTERS      */
*       5 CTGDDNM PTR(31),          /* DD NAME ADDR                  */
*         10 CTGNEWNM PTR(31),      /* NEWNAME ADDRESS - ALTER       */
*            15 CTGFDBK  PTR(16),   /* SUPER LOCATE FEEDBACK         */
*            15 CTGFBFLG BIT(16),   /* SUPER LOCATE FLAGS            */
*               20 CTGPAR   BIT(1), /* PARALLEL MOUNT -SUPERLOCATE   */
*               20 CTGKEEP  BIT(1), /* FORCED KEEP - SUPERLOCATE     */
*               20 CTGGDGB  BIT(1), /* GDG BASE LOCATE         Y02020*/
*               20 CTGNGDSN BIT(1), /* GDG NAME GENERATED      Y02020*/
*               20 *        BIT(12), /* RESERVED               Y02020*/
*       5 CTGJSCB  PTR(31),         /* JSCB ADDR                     */
*         10 CTGPSWD  PTR(31),      /* PASSWORD ADDR                 */
*       5 CTGFIELD(*) PTR(31) CTGPL999 /* FIELD POINTERS             */
*/********************************************************************/
*/*     CONSTANTS USED TO SET AND/OR TEST FIELDS DECLARED ABOVE      */
*/********************************************************************/
*   DECLARE                         /* CATALOG FUNCTION - CTGFUNC    */
*     CTGLOC   BIT(3) CONSTANT('001'B), /* LOCATE                    */
*     CTGLSP   BIT(3) CONSTANT('010'B), /* LSPACE                    */
*     CTGUPDAT BIT(3) CONSTANT('011'B), /* UPDATE                    */
*     CTGCMS   BIT(3) CONSTANT('100'B); /* CMS FUNCTION              */
*   DECLARE                         /* CMS OPTIONS - CTGOPTNS        */
*     CTGDEFIN BIT(5) CONSTANT('00001'B), /* DEFINE                  */
*     CTGALTER BIT(5) CONSTANT('00010'B), /* ALTER                   */
*     CTGDELET BIT(5) CONSTANT('00011'B), /* DELETE                  */
*     CTGLTCAT BIT(5) CONSTANT('00100'B), /* LIST CATALOG            */
*     CTGCNVTV BIT(5) CONSTANT('00110'B); /* CONVERTV        @Y30LSPS*/
*   DECLARE                           /* RECORD ENTRY TYPE - CTGTYPE */
*     CTGTDATA CHAR(1) CONSTANT('D'), /* DATA                        */
*     CTGTINDX CHAR(1) CONSTANT('I'), /* INDEX                       */
*     CTGTALIN CHAR(1) CONSTANT('A'), /* ALIEN                       */
*     CTGTUCAT CHAR(1) CONSTANT('U'), /* USER CATALOG                */
*     CTGTVOL  CHAR(1) CONSTANT('V'), /* VOLUME                      */
*     CTGTCL   CHAR(1) CONSTANT('C'), /* CLUSTER                     */
*     CTGTAIX  CHAR(1) CONSTANT('G'), /* ALTERNATE INDEX     @Y30SSPJ*/
*     CTGTPATH CHAR(1) CONSTANT('R'), /* PATH                @Y30SSPJ*/
*     CTGTFREE CHAR(1) CONSTANT('F'), /* FREE                @Y30SSPJ*/
*     CTGTPTH  CHAR(1) CONSTANT('R'), /* PATH                @Y30SSSB*/
*     CTGTUPG  CHAR(1) CONSTANT('Y'), /* UPGRADE             @Y30SSSB*/
*     CTGTGBS  CHAR(1) CONSTANT('B'), /* GDG BASE              Y02020*/
*     CTGTANM  CHAR(1) CONSTANT('X'), /* ALIAS NAME            Y02020*/
*     CTGTPGSP CHAR(1) CONSTANT('P'), /* PAGE SPACE            Y02020*/
*     CTGTMCAT CHAR(1) CONSTANT('M'); /* MASTER CATALOG              */
*/********************************************************************/
*/*                 PROBLEM  DETERMINATION  FIELDS                   */
*/********************************************************************/
*   DECLARE
*     1 * DEF(CTGDDNM),             /* PROBLEM DETERMINATION @Y30SSJG*/
*       2 CTGPROB CHAR(4),          /* PROBLEM DETERMINATION @Y30SSJG*/
*         3 CTGMODID CHAR(2),       /* MODULE IDENTIFICATION @Y30SSJG*/
*         3 CTGREASN CHAR(2),       /* REASON CODE           @Y30SSJG*/
*           4 CTGREAS1 CHAR(1),     /* HIGH ORDER BYTE ZERO  @Y30SSJG*/
*           4 CTGREAS2 CHAR(1);     /* REASON CODE LOW BYTE  @Y30SSJG*/
* %GOTO CTGPLX02;                                                   /*
.CTGPL01 ANOP
*
CTGPL    DS    0H
*
CTGOPTN1 DS    XL1                      FIRST OPTION INDICATOR
CTGBYPSS EQU   X'80'                    BYPASS
CTGMAST  EQU   X'40'                    VERIFY MASTER PASSWORD
CTGCI    EQU   X'20'                    VERIFY CONTROL INDICATOR
CTGUPD   EQU   X'10'                    VERIFY UPDATE
CTGREAD  EQU   X'08'                    VERIFY READ
CTGNAME  EQU   X'04'                    1 - 44-BYTE NAME OR VOLSER
*                                       0 - ENTRY ID NUMBER
CTGCNAME EQU   X'02'                    1 - 44-BYTE NAME
*                                       0 - ACB ADDRESS
CTGGENLD EQU   X'01'                    GENERIC LOCATE REQUEST
*
CTGOPTN2 DS    XL1                      SECOND OPTION INDICATOR
CTGEXT   EQU   X'80'                    EXTEND(UPDATE)
CTGERASE EQU   X'40'                    ERASE(DELETE)
CTGSMF   EQU   X'40'                    WRITE SMF(LSPACE)
CTGREL   EQU   X'40'                    RELEASE(UPDATE)
CTGGTALL EQU   X'40'                    CONCAT SEARCH (LISTCAT) Y02020
CTGPURG  EQU   X'20'                    PURGE (DELETE)
CTGVMNT  EQU   X'20'                    VOLUME MOUNT CALLER
CTGRCATN EQU   X'20'                    RTN CAT NAME(GLOC)      Y02020
CTGGTNXT EQU   X'10'                    GET NEXT (LIST CTLG)
CTGDISC  EQU   X'08'                    DISCONNECT (DELETE)
CTGOVRID EQU   X'04'                    ERASE OVERRIDE (DELETE)
CTGSCR   EQU   X'02'                    SCRATCH SPACE (DELETE)
*    X'01' - RESERVED
*
CTGOPTN3 DS    XL1                      THIRD OPTION INDICATOR
CTGFUNC  EQU   X'E0'                    HIGH ORDER THREE BITS DEFINE
*                                       FUNCTION
*   LOCATE     -   001* ****
CTGLOC   EQU   X'20'                    LOCATE - BITS ON
*   LSPACE     -   010* ****
CTGLSP   EQU   X'40'                    LSPACE - BITS ON
*   UPDATE     -   011* ****
CTGUPDAT EQU   X'60'                    UPDATE - BITS ON
*   CMS FUNCTION - 100* ****
CTGCMS   EQU   X'80'                    CMS FUNCTION - BITS ON
*
CTGSUPLT EQU   X'10'                    SUPER LOCATE
CTGGDGL  EQU   X'08'                    GDG LOCATE FUNCTION (CTGWAGB IN
*                                       CTGWA)
CTGSRH   EQU   X'04'                    0 - SEARCH MASTER CAT ONLY
*                                       1 - SEARCH OS CAT FIRST
CTGNUM   EQU   X'02'                    0 - SEARCH BOTH CATALOGS
*                                       1 - SEARCH ONE CATALOG
CTGAM0   EQU   X'01'                    VSAM REQ VERSUS NONVSAM
*
CTGOPTN4 DS    XL1                      FOURTH OPTION INDICATOR  Y02020
CTGLBASE EQU   X'80'                    LOCATE GDG BASE ONLY
CTGDOCAT EQU   X'40'                    DO NOT OPEN NEEDED CATLG
CTGNPROF EQU   X'20'                    NO (RAC) PROFILE SHOULD BE
*                                       DEFINED OR DELETED     @Z40RSRC
CTGCOIN  EQU   X'10'                    CONTROLLER INTERCEPT REQUESTED
*                                                              @ZA20773
CTGBYPMT EQU   X'08'                    BYPASS SECURITY PROMPTING TO
*                                       SYSTEM OPERATOR        @ZA07531
CTGTIOT  EQU   X'04'                    CALLER OWNS SYSZTIOT EXCLUSIVE
*                                                              @ZA20773
*        BITS 7-8 RESERVED                                     @ZA20773
CTGENT   DS    0A                       USER ENTRY ADDRESS OR POINTER
*                                       TO VOLUME SERIAL NUMBER(LSPACE)
CTGFVT   DS    A                        FVT ADDRESS (DEFINE, ALTER)
CTGCAT   DS    0A                       CATALOG POINTER
*
CTGCVOL  DS    A                        CVOL PTR (SUPER LOCATE)
*
CTGWKA   DS    A                        WORKAREA ADDRESS
*
CTGDSORG DS    CL2                      DATA SET ORG (SUPER LOCATE)
*   BITS 0-4 DEFINE ORGANIZATION
CTGOPTNS EQU   X'F8'                    TOP 5 BITS
*   DEFINE          - 0000 1*** **** ****
CTGDEFIN EQU   X'08'                    DEFINE
*   ALTER           - 0001 0*** **** ****
CTGALTER EQU   X'10'                    ALTER
*   DELETE          - 0001 1*** **** ****
CTGDELET EQU   X'18'                    DELETE
*   LIST CATALOG    - 0010 0*** **** ****
CTGLTCAT EQU   X'20'                    LIST CATALOG
*   CONVERTV        - 0011 0*** **** ****
CTGCNVTV EQU   X'30'                    CONVERTV
*   BITS 6-16 RESERVED
*
CTGTYPE  DS    CL1                      ENTRY TYPE-LISTCAT,DELETE
CTGTDATA EQU   C'D'                     DATA - D
CTGTINDX EQU   C'I'                     INDEX - I
CTGTALIN EQU   C'A'                     ALIEN - A
CTGTUCAT EQU   C'U'                     USER CATALOG - U
CTGTVOL  EQU   C'V'                     VOLUME - V
CTGTCL   EQU   C'C'                     CLUSTER - C
CTGTMCAT EQU   C'M'                     MASTER CATALOG - M
CTGTGBS  EQU   C'B'                     GDG BASE - B
CTGTANM  EQU   C'X'                     ALIAS BASE -X
CTGTPGSP EQU   C'P'                     PAGE SPACE - P
*
CTGNOFLD DS    XL1                      NUMBER FIELD POINTERS
CTGDDNM  DS    0A                       DD NAME ADDRESS
CTGNEWNM DS    0A                       NEWNAME ADDRESS - ALTER
CTGFDBK  DS    XL2                      SUPER LOCATE FEEDBACK
CTGFBFLG DS    XL2                      SUPER LOCATE FLAGS
CTGPAR   EQU   X'80'                    PARALLEL MOUNT - SUPER LOC
CTGKEEP  EQU   X'40'                    FORCED KEEP = SUPER LOCATE
CTGGDGB  EQU   X'20'                    GDG BASE LOCATED
CTGNGDSN EQU   X'10'                    GDG NAME GENERATED
*   BITS 5-16 RESERVED
*
CTGJSCB  DS    0A                       JSCB ADDRESS
CTGPSWD  DS    A                        PASSWORD ADDRESS
CTGFIELD DS    A                        FIELD POINTERS - MAY BE MORE
*                                       THAN ONE
CTGPLLEN EQU   *-CTGPL                  LENGTH OF CTG WITH ONE FIELD
*                                       POINTER
         MEND
* */ %CTGPLX02:;
