 /********************************************************************/
 /*                                                                  */
 /*   MACRO NAME = IEZCTGVL                                          */
 /*                                                                  */
 /*   DESCRIPTIVE NAME = VSAM CATALOG VOLUME LIST AND EXTENSION      */
 /*                                                                  */
 /*   FUNCTION = MAPPING MACRO FOR THE CATALOG VOLUME LIST           */
 /*              AND THE VOLUME LIST EXTENSION.                      */
 /*                                                                  */
 /*   CONTROL BLOCK STRUCTURE = THE CTGVL IS POINTED TO BY THE       */
 /*                             CTGWA (CTGWAVL).                     */
 /*                                                                  */
 /*   INCLUDED MACROS = NONE                                         */
 /*                                                                  */
 /*   METHOD OF ACCESS = PL/S - NO DECLARES NECESSARY                */
 /*                                                                  */
 /*   STATUS = VS/2 RELEASE 3   (CHANGE FLAG @Y30SSXX)               */
 /*                                                                  */
 /*   DATE OF LAST CHANGE = 18 JUL 74                                */
 /*                                                                  */
 /********************************************************************/
 %DECLARE (CTGVLLEN, CTGVLXLN, CTGVL999, CTGVLLVL) CHAR;
*%CTGVLLEN = 'LENGTH(CTGVL)';       /* LENGTH OF CTGVL               */
*%CTGVLXLN = 'LENGTH(CTGVLX)';      /* LENGTH OF CTGVLX              */
*%IF CTGVL999 ^= ','                /* IF BLOCK NOT CONTINUED,       */
*  %THEN %CTGVL999 = ';';           /*   THEN CLOSE DECLARE STMNT    */
*%IF CTGVLLVL  = ''                 /* IF BLOCK NOT CONCATENATED,    */
*  %THEN %GOTO CTGVL001;            /*   THEN GENERATE DECLARE       */
*%CTGVLDUM = CTGVLLVL||' CTGVL(*)'; /* SET MINOR LEVEL NUMBER        */
*   CTGVLDUM                        /* CTGVL CONCATENATED LEVEL      */
*%GOTO CTGVL002;                    /* SKIP DECLARE                  */
*%CTGVL001:;                        /* DECLARE                       */
 /********************************************************************/
 /*                     CATALOG  VOLUME  LIST                        */
 /********************************************************************/
    DECLARE
*     1 CTGVL(*) BASED(CTGWAVL)     /* DECLARE CTGVL LEVEL ONE       */
*%CTGVL002:;                        /* SKIP DECLARE                  */
*                   BDY(WORD),      /* WORD BOUNDARY                 */
*       5 CTGVLVOL CHAR(6),         /* VOLUME SERIAL NUMBER          */
*       5 CTGVLDEV CHAR(4),         /* DEVICE TYPE                   */
*       5 CTGVLSEQ FIXED(15);       /* FILE SEQUENCE NUMBER          */
 /********************************************************************/
 /*                     VOLUME  LIST  EXTENSION                      */
 /********************************************************************/
    DECLARE
*     1 CTGVLX BASED(ADDR(CTGVL))   /* VOLUME LIST EXTENSION         */
*                BDY(WORD),         /* WORD BOUNDARY                 */
*       5 *        CHAR(LENGTH(CTGVL)), /* VOLUME LIST BASE          */
*       5 CTGVLTTR CHAR(3) CTGVL999 /* FORMAT 1 DSCB TTR             */
