 /********************************************************************/
 /*          MACCOMP  Y30LB22          SC1DR/BL0019          @Y30LB22*/
 /*          MACSTAT  Y30LB22          74/317/341040         @Y30LB22*/
 /*                                                          @Y30LB22*/
 /*          NAME: IEZDEFVE                                  @Y30LB22*/
 /*                                                          @Y30LB22*/
 /*          FUNCTION:                                       @Y30LB22*/
 /*          MAPS THE REQUEST BLOCK EXTENSION                @Y30LB22*/
 /*          WHICH IS USED TO PASS ADDITIONAL INFORMATION    @Y30LB22*/
 /*          TO MSVC DURING AN DEFINE VOLUME MASS STORAGE REQUEST.   */
 /*                                                          @Y30LB22*/
 /*          STATUS: CHANGE LEVEL = 0                        @Y30LB22*/
 /*                                                          @Y30LB22*/
 /********************************************************************/
    /* CONSTANTS FOR IEZDEFVE                                @Y30LB22*/
     DCL  DEFLEN  FIXED(15) INIT(LENGTH(DEFVE)); /* LENGTH   @Y30LB22
                                           OF EXTENSION      @Y30LB22*/
     DCL
       1        DEFVE BASED(DEFVEPTR) BDY(WORD),           /*@Y30LB22*/
         2      DEFLNGTH  FIXED(31), /* LENGTH OF EXTENSION  @Y30LB22*/
         2      DEFGROUP  CHAR(8),   /* NAME OF USER MSVGP   @Y30LB22*/
         2      DEFDESCR  CHAR(30),  /* DESCRIPTIVE INFO     @Y30LB22*/
         2      DEFTO     CHAR(4),   /* EXPIRATION DATE      @Y30LB22*/
         2      DEFFOR    FIXED(15), /* NO DAYS USED IN CAL- @Y30LB22
                                        CULATING EXP. DATE   @Y30LB22*/
         2      DEFBKUPN  FIXED(8),  /* MAX. NO. BKUP COPIES @Y30LB22*/
         2      DEFLABEL  CHAR(6),   /* SER. NO IN SOFTWARE  @Y30LB22
                                        LABEL                @Y30LB22*/
         2      DEFFLAGA  BIT(8),    /* INDICATOR FLAGS      @Y30LB22*/
           3    DEFPFOR   BIT(1),    /* DEFFOR IS SPECIFIED  @Y30LB22*/
           3    DEFPVLAB  BIT(1),    /* DEFLABEL SPECIFIED   @Y30LB22*/
           3    DEFPGRO   BIT(1),    /* DEFGROUP SPECIFIED   @Y30LB22*/
           3    DEFPDESC  BIT(1),    /* DEFDESCR SPECIFIED   @Y30LB22*/
           3    DEFPTO    BIT(1),    /* DEFTO IS SPECIFIED   @Y30LB22*/
           3    DEFPBKUP  BIT(1),    /* DEFBKUPN SPECIFIED   @Y30LB22*/
           3    *         BIT(2),    /* UNUSED               @Y30LB22*/
         2      DEFFLAGB  CHAR(4),   /* STATUS FLAGS         @Y30LB22*/
           3    DEFSETFL  BIT(8),    /* RECOVERY FLAGS       @Y30LB22
                                        INDICATORS           @Y30LB22*/
             4  DEFSRCVY  BIT(1),    /* SET RECOVERY FLAGS   @Y30LB22*/
             4  DEFCRCVY  BIT(1),    /* CLEAR RECOVERY FLAGS @Y30LB22*/
             4  *         BIT(6),    /* UNUSED               @Y30LB22*/
           3    DEFRECFL  BIT(8),    /* RECOVERY FLAGS       @Y30LB22*/
             4  DEFICOPY  BIT(1),    /* INCOMPLETE COPY OPER @Y30LB22*/
             4  DEFCREAT  BIT(1),    /* INCOMPLETE CREATION  @Y30LB22*/
             4  DEFLAMIS  BIT(1),    /* VOL LABEL MISMATCH   @Y30LB22*/
             4  *         BIT(5),    /* UNUSED               @Y30LB22*/
           3    DEFTYPFL  BIT(8),    /* VOLUME TYPE FLAGS    @Y30LB22*/
             4  DEFGENUS  BIT(1),    /* GENERAL USE TYPE VOL @Y30LB22*/
             4  DEFRSTD   BIT(1),    /* RESTRICTED TYPE VOL  @Y30LB22*/
             4  DEFDUP    BIT(1),    /* DUPLICATE TYPE VOL   @Y30LB22*/
             4  DEFCOPY   BIT(1),    /* COPY TYPE VOLUME     @Y30LB22*/
             4  *         BIT(4),    /* UNUSED               @Y30LB22*/
           3    DEFNULFL  BIT(8),    /* NULLIFY FLAGS        @Y30LB22*/
             4  DEFNGRP   BIT(1),    /* CHANGE TO NONGROUP   @Y30LB22*/
             4  DEFNDESC  BIT(1),    /* NULLIFY THE DESCR    @Y30LB22*/
             4  DEFNEXPD  BIT(1),    /* NULLIFY THE EXP DATE @Y30LB22*/
             4  *         BIT(5),    /* UNUSED               @Y30LB22*/
         2      *         CHAR(4);   /* UNUSED               @Y30LB22*/
