 /********************************************************************/
 /*          MACCOMP  Y30LB22          SC1DR/BL0019          @Y30LB22*/
 /*          MACSTAT  Y30LB22          74/192/341040         @Y30LB22*/
 /*                                                                   */
 /*          NAME: IEZDUPV                                   @Y30LB22*/
 /*                                                                   */
 /*          FUNCTION: MAPPING MACRO                         @Y30LB22*/
 /*          A DUPLICATE VOLUME RECORD EXISTS FOR EACH       @Y30LB22*/
 /*          VOLUME ENTERED INTO THE MASS STORAGE FACILITY   @Y30LB22*/
 /*          AT THE CARTRIDGE ACCESS STATION, PROVIDED       @Y30LB22*/
 /*          THE VOLUME SERIAL NUMBER OF THE VOLUME          @Y30LB22*/
 /*          BEING ENTERED IS DUPLICATED BY AN EXISTING      @Y30LB22*/
 /*          VOLUME ALREADY REPRESENTED IN THE MSVI DATA SET @Y30LB22*/
 /*                                                                   */
 /*          STATUS:  CHANGE LEVEL = 0                       @Y30LB22*/
 /*                                                                   */
 /********************************************************************/
     DCL
       1        DUPV BASED(DUPVPTR) BDY(WORD),             /*@Y30LB22*/
         2      DUPNAME   CHAR(13),  /* KEY OF VOLUME        @Y30LB22*/
           3    DUPD      CHAR(5),   /* 'D' AND 4 BLANKS     @Y30LB22*/
           3    DUPSERNO  CHAR(6),   /* VOLUME SER. NO.      @Y30LB22*/
           3    DUPID     CHAR(2),   /* RECORD ID FOR VOLUME @Y30LB22*/
             4  DUPBLANK  CHAR(1),   /* BLANK                @Y30LB22*/
             4  DUPNO     FIXED(8),  /* BIN NO OF DUPLICATE  @Y30LB22*/
         2      DUPRES5   CHAR(1),   /* RESERVED             @Y30LB22*/
         2      DUPFLAGA  BIT(32),   /* INDICATOR FLAGS      @Y30LB22*/
           3    DUPTYPE   BIT(16),   /* RECORD TYPE FLAGS    @Y30LB22*/
             4  DUPRES1   BIT(5),    /* RESERVED             @Y30LB22*/
             4  DUPDUPLR  BIT(1),    /* DUPL. VOL SER NO REC @Y30LB22*/
             4  DUPRES2   BIT(10),   /* RESERVED             @Y30LB22*/
           3    *         BIT(16),   /* RESERVED             @Y30LB22*/
         2      *         BIT(16),   /* UNASSIGNED           @Y30LB22*/
         2      DUPRCVYF  BIT(32),   /* RECOVERY FIELDS      @Y30LB22*/
           3    DUPSATIA  BIT(16),   /* STATUS INDICATOR     @Y30LB22*/
           3    DUPMISCF  BIT(16),   /* MISCL. FLAGS         @Y30LB22*/
         2      DUPCSN1   CHAR(12),  /* SER NO. OF 1ST CART. @Y30LB22*/
         2      DUPLIB1   FIXED(8),  /* ID OF LIB FOR CSN1   @Y30LB22*/
           3    DUPRES3   BIT(6),    /* RESERVED             @Y30LB22*/
           3    DUPLID1   BIT(2),    /* LIBRARY ID 1         @Y30LB22*/
             4  DUP1BIT1  BIT(1),    /* LIBRARY NO.          @Y30LB22*/
             4  DUP1BIT2  BIT(1),    /* LIBRARY NO.          @Y30LB22*/
         2      DUPCSN2   CHAR(12),  /* SER NO. OF 2ND CART. @Y30LB22*/
         2      DUPLIB2   FIXED(8),  /* ID OF LIB FOR CSN2   @Y30LB22*/
           3    DUPRES4   BIT(6),    /* RESERVED             @Y30LB22*/
           3    DUPLID2   BIT(2),    /* LIBRARY ID 2         @Y30LB22*/
             4  DUP2BIT1  BIT(1),    /* LIBRARY NO.          @Y30LB22*/
             4  DUP2BIT2  BIT(1),    /* LIBRARY NO.          @Y30LB22*/
         2      *         CHAR(15);  /* UNUSED               @Y30LB22*/
