 /********************************************************************/
 /*     MACCOMP  Z40LB02                                             */
 /*     MACSTAT  Z40LB02                                             */
 /*                                                                  */
 /*     NAME     IEZFMSWA                                            */
 /*                                                                  */
 /*     FUNCTION-MAPS THE FORMAT SENSE WORK AREA(TRANSLATE AREAS FOR */
 /*              X,Y,Z,MSF,CYLINDER AND SSID VALUES.                 */
 /*                                                                  */
 /*     STATUS CHANGE LEVEL=0                                        */
 /********************************************************************/
     /*FORMAT SENSE WORK AREA #1 CONTAINS SWITCHES USED IN   @Z40LB02*/
     /*FORMAT LOAD MODULES, THE MESSAGE INDEX, AND THE       @Z40LB02*/
     /*ALTERNATE CONSOLE VALUE AND TRANSLATE SAVE AREA.      @Z40LB02*/
 DCL 1 FMTSNWA1 CHAR(160) BDY(WORD) BASED(FSWAPTR),
       2 FMTSWTCH BIT(8),              /*1 BYTE FOR SWITCHES @Z40LB02*/
         3 FSEXIT BIT(1),              /*EXIT SWITCH         @Z40LB02*/
         3 MSGBLT BIT(1),              /*MESSAGE SWITCH      @Z40LB02*/
       2 MSGNUM FIXED(8),              /*MESSAGE INDEX       @Z40LB02
                                         USED TO NOTE MSG    @Z40LB02
                                         TO BE BUILT         @Z40LB02*/
       2 ALTCON BIT(16),               /*ALTCON VALUE        @Z40LB02*/
       2 FMTWORK CHAR(11),             /*WORK AREA           @Z40LB02*/
         3 YVAL CHAR(2),               /*DECIMAL Y VALUE     @Z40LB02*/
         3 ZVAL CHAR(1),               /*DECIMAL Z VALUE     @Z40LB02*/
         3 MSFVAL CHAR(1),             /*DECIMAL MSF VALUE   @Z40LB02*/
         3 XVAL CHAR(3),               /*DECIMAL X VALUE     @Z40LB02*/
         3 SSIDAREA CHAR(3),           /*PRNTLE SSID VALUE   @Z40LB02*/
         3 *    CHAR(1),               /*1 BYTE  UNUSED      @Z40LB02*/
     /*FORMAT SENSE WORK AREA #3 IS AN 87 BYTE REPRESENTA    @Z40LB02*/
     /*TION OF THE WTO LIST FORM MACRO.  FIELDS SET IN THE   @Z40LB02*/
     /*LIST FORM WILL APPLY HERE                             @Z40LB02*/
       2 FMTSNWA3 CHAR(87) ,           /*WTO LIST FORM       @Z40LB02*/
         3 FMTWT01 FIXED(15),          /*TEXT LENGTH         @Z40LB02*/
         3 FMTWT02 BIT(16),            /*MCS FLAG            @Z40LB02*/
         3 FMTWT03 CHAR(79),           /*MESSAGE TEXT        @Z40LB02*/
         3 FMTWT04 BIT(16),            /*DESCRIPTOR CODES    @Z40LB02*/
         3 FMTWT05 BIT(16),            /*ROUTING CODES       @Z40LB02*/
       2 FSWSAVE CHAR(58),             /*SAVE & TRANSL AREA  @Z40LB02*/
         3 SAVER1 PTR(31),             /*R1 SAVE AREA        @Z40LB02*/
         3 SAVR12 PTR(31),             /*REG 12 SAVE AREA    @Z40LB02*/
         3 VVIPTR PTR(31),             /*MSVC CNTL BLK PTR   @Z40LB02*/
         3 SRBPTR PTR(31),             /*SRB POINTER         @Z40LB02*/
     /*CONVERSION AREA FOR SENSE DATA                        @Z40LB02*/
         3 FMTRANL CHAR(9) ,       /*9 CHAR TRANSL AREA      @Z40LB02*/
           4 FMTTRSN CHAR(8),      /*8 CHARS OF TRANSLD SNS  @Z40LB02*/
             5 FMTRAN CHAR(5),    /*SNS AREA & 1 BYTE FILL   @Z40LB02*/
               6 FMTRES1 CHAR(4), /*4 BYTES OF SENSE         @Z40LB02*/
               6 *       CHAR(1), /*1 BYTE FILL FOR UNPK     @Z40LB02*/
             5 *   CHAR(3),       /*UNPACK AREA              @Z40LB02*/
           4 *    CHAR(1),         /*UNPACK AREA             @Z40LB02*/
     /*CYLINDER CONVERSION WORKAREA                          @Z40LB02*/
         3 CYLINDER CHAR(5) ,      /*5 CHAR CYL TRANSL       @Z40LB02*/
           4 CYLTRAN CHAR(4),      /*4 BYTE CYL VALUE        @Z40LB02*/
             5 *    CHAR(1),       /*UNPACK AREA             @Z40LB02*/
             5 CYLIND CHAR(3),     /*UNPACK AREA             @Z40LB02*/
              6 CYLIND1 CHAR(2),   /*2 BYTE CYL VALUE        @Z40LB02*/
              6 *       CHAR(1),
           4 CYLFILL CHAR(1) ,     /*SIGN BYTE FOR UNPK      @Z40LB02*/
     /*GENERAL CONVERSION WORKAREA                           @Z40LB02*/
         3 GENTRAN CHAR(5) ,       /*5 CHAR GEN TRANSL       @Z40LB02*/
           4 TRVAL3CH CHAR(3),     /*3 CHAR TRANSLATE        @Z40LB02*/
             5 CHAR2INP CHAR(2),      /*2 BYTE INPUT/VAL     @Z40LB02*/
               6 CHAR2FIX FIXED(16),  /*FIXED REPRESENT      @Z40LB02*/
                 7 CHAR1INP FIXED(8), /*1 BYTE INPUT AREA    @Z40LB02*/
                 7 CHAR1VAL CHAR(1),  /*1 BYTE VALUE AREA    @Z40LB02*/
                   8 FIXVAL FIXED(8), /*1 BYTE FIXED REP     @Z40LB02*/
             5 *      CHAR(1),        /*UNPACK AREA          @Z40LB02*/
           4 *       CHAR(1) ,        /*SIGN BYTE FOR UNPK   @Z40LB02*/
           4 *       CHAR(1) ,        /*SIGN BYTE FOR UNPK   @Z40LB02*/
         3 CONVERT CHAR(2),           /*2 CHA CONVERSION FLD @Z40LB02*/
         3 I FIXED (8),               /*LOOP CONTROL         @Z40LB02*/
         3 DATASTOR CHAR(20);        /*DATA AREA             @Z40LB02*/
