 /********************************************************************/
 /*                                                                  */
 /*          MACCOMP  Y30LB22          SC1DR/BL0019          @Y30LB22*/
 /*          MACSTAT  Y30LB22          74/170/341040         @Y30LB22*/
 /*                                                          @G24LB37*/
 /*          NAME: IEZGROUP                                  @Y30LB22*/
 /*                                                          @G24LB37*/
 /*          FUNCTION: MAPPING MACRO                         @Y30LB22*/
 /*          A GROUP RECORD IS CONTAINED IN THE MSVI         @Y30LB22*/
 /*          DATA SET FOR EACH VOLUME GROUP AND FOR THE      @Y30LB22*/
 /*          DEFAULT GROUP 'SYSGROUP'.                       @Y30LB22*/
 /*                                                          @Y30LB22*/
 /*          STATUS:  MVS                                    @G24LB37*/
 /*                                                          @Y30LB22*/
 /*          CHANGE LEVEL:                                   @G24LB37*/
 /*          @G24LB37  ALLOCATE TO MOUNTED VOLUMES  06/07/76 @G24LB37*/
 /*                                                                  */
 /********************************************************************/
  DCL
   1    GROUP BASED(GROUPPTR) BDY(WORD),                   /*@Y30LB22*/
       2   GRONAME        CHAR(13),  /* MSVGP RECORD KEY     @Y30LB22*/
        3  GROG           CHAR(3),   /* 'G' AND TWO BLANKS   @Y30LB22*/
        3  GROVVGRP       CHAR(8),   /* ACTUAL GROUP NAME    @Y30LB22*/
        3  GROID          CHAR(2),   /* RECORD ID            @Y30LB22*/
         4 GROBLANK       CHAR(1),   /* THIS FIELD IS BLANK  @Y30LB22*/
         4 GROZERO        FIXED(8),  /* FIELD OF BIN ZEROS   @Y30LB22*/
       2   GROFLAGA       BIT(32),   /* INDICATOR FLAGS      @Y30LB22*/
        3  GROTYPE        BIT(16),   /* RECORD TYPE FLAGS    @Y30LB22*/
         4 GROGVR         BIT(1),    /* GROUP RECORD         @Y30LB22*/
         4 GRORES1        BIT(15),   /* RESERVED             @Y30LB22*/
        3  GROBIND        BIT(1),    /* ATTRIBUTE IS BIND    @Y30LB22*/
        3  GROEXCL        BIT(1),    /* ATTRIBUTE-EXCLUSIVE  @Y30LB22*/
        3  GRODAERA       BIT(1),    /* ATTRIBUTE-DASDERASE  @Y30LB22*/
        3  GRORONLY       BIT(1),    /* ATTRIBUTE-READ ONLY  @Y30LB22*/
        3  GRORLSE        BIT(1),    /* RLSE SPACE OPTION    @Y30LB22*/
        3  GRORETN        BIT(1),    /* RET DATE SPECIFIED   @Y30LB22*/
        3  GROMSG1        BIT(1),    /* MSG. SENT TO OP/LIB  @Y30LB22
                                        FLAG CONCERNING GRP. @Y30LB22
                                        SPACE THRESHOLD      @Y30LB22*/
        3  *              BIT(9),    /* UNUSED               @Y30LB22*/
       2   GROFSN         CHAR(6),   /* SER NO. OF 1ST VOL   @Y30LB22*/
       2   GROLSN         CHAR(6),   /* SER NO. OF LAST VOL  @Y30LB22*/
       2   GROPCENT       FIXED(8),  /* THRESHOLD PERCENT    @Y30LB22*/
       2   GRONGEN        FIXED(15), /*NO. OF GEN USE VOL    @Y30LB22*/
       2   GRONRSTD       FIXED(15), /*NO. OF RSTD VOLS.     @Y30LB22*/
       2   GRONINAC       FIXED(15), /*NO. OF INACTIVE VOLS  @Y30LB22*/
       2   GROPSPD        FIXED(15), /*PRIMARY SPACE DEFAULT @Y30LB22*/
       2   GROSSPD        FIXED(15), /*SECONDARY SPACE       @Y30LB22
                                       DEFAULT               @Y30LB22*/
       2   GROSTRSH       FIXED(31), /*GROUP SPACE THRESHOLD @Y30LB22*/
       2   GROFRESP       FIXED(31), /*GROUP FREE SPACE      @Y30LB22*/
       2   GROFREXT       FIXED(31), /*GROUP FREE EXTENTS    @Y30LB22*/
       2   GRORETPD       FIXED(31), /*GRP RETENTION PERIOD  @Y30LB22*/
       2   GROERRTS       CHAR(8),   /*GRP ERROR TIME STAMP  @Y30LB22*/
         3 GROERRDT       CHAR(4),   /*TIME STAMP DATE       @Y30LB22*/
         3 GROERRTM       CHAR(4),   /*TIME STAMP TIME       @Y30LB22*/
       2   GRODESCR       CHAR(30),  /*GRP DESCRIPTIVE INFO  @Y30LB22*/
       2   GROCONUS       FIXED(8),  /*MAXIMUM NUMBER        @G24LB37
                                       OF CONCURRENT USERS   @G24LB37
                                       PER HOST TO A VOLUME  @G24LB37
                                       FOR THIS GROUP        @G24LB37*/
       2   GRORESSP       FIXED(8),  /*PERCENT OF RESERVED   @G24LB37
                                       SPACE PER VOLUME      @G24LB37
                                       FOR THIS GROUP        @G24LB37*/
       2   GROOWNER       CHAR(10),  /*NAME/ID OF GRP OWNER  @Y30LB22*/
       2   GROADDR        CHAR(30),  /*ADDR OF GROUP OWNER   @Y30LB22*/
       2   *              CHAR(28);  /*UNUSED                @Y30LB22*/
