 /********************************************************************/
 /*                                                                  */
 /*          MACCOMP  Y30LB22          SC1DR/BL0019          @Y30LB22*/
 /*          MACSTAT  Y30LB22          74/170/341040         @Y30LB22*/
 /*                                                          @Y30LB22*/
 /*          NAME: IEZGVSNE                                  @Y30LB22*/
 /*                                                          @Y30LB22*/
 /*          FUNCTION: MAPPING MACRO                         @Y30LB22*/
 /*          THE GROUP EXTENSION RECORD PROVIDES MOUNT AND   @Y30LB22*/
 /*          SPACE INFORMATION FOR THE 'GENERAL' USE         @Y30LB22*/
 /*          VOLUMES IN THE GROUP                            @Y30LB22*/
 /*                                                          @Y30LB22*/
 /*          STATUS: MVS                                     @G24LB37*/
 /*                                                          @Y30LB22*/
 /*          CHANGE LEVEL:                                   @G24LB37*/
 /*          @G24LB37  ALLOCATE TO MOUNTED VOLUMES  06/07/76 @G24LB37*/
 /*                                                                  */
 /********************************************************************/
 DCL    GVSNSLOT FIXED(31) CONSTANT(48); /* NO. OF SLOTS     @Y30LB22*/
 /********************************************************************/
 DCL    1          GVSNE BASED(GVSNEPTR) BDY(WORD),        /*@Y30LB22*/
          2        GVSHDR,              /* HEADER FIELD      @Y30LB22*/
            3      GVSNAME   CHAR(13),  /* KEY FOR GVSNE     @Y30LB22
                                           RECORD            @Y30LB22*/
              4    GVSG      CHAR(3),   /* G AND 2 BLANKS    @Y30LB22*/
              4    GVSVVGRP  CHAR(8),   /* MSVGP NAME        @Y30LB22*/
              4    GVSID     CHAR(2),   /* EXTENSION RCD ID  @Y30LB22*/
                5  GVSRES1   CHAR(1),   /* RESERVED          @G24LB37*/
                5  GVSNO     FIXED(8),  /* BINARY NO FOR THE @Y30LB22
                                           EXTENSION RECORD  @Y30LB22*/
            3      GVSFLAGA  BIT(32),   /* INDICATOR FLAGS   @Y30LB22*/
              4    GVSTYPE   BIT(16),   /* RECORD TYPE       @Y30LB22*/
                5  *         BIT(1),    /* UNUSED            @G24LB37*/
                5  GVSGVSEX  BIT(1),    /* VOL SER EXTENSION @Y30LB22*/
                5  *         BIT(14),   /* UNUSED            @G24LB37*/
              4    GVSEX     BIT(1),    /* ANOTHER EXTENSION @Y30LB22
                                           RECORD EXISTS     @Y30LB22*/
              4    *         BIT(15),   /* UNUSED            @Y30LB22*/
            3      *         CHAR(1),   /* UNUSED            @Y30LB22*/
            3      GVSESIND  FIXED(15), /* NEXT EMPTY SLOT   @Y30LB22
                                           INDEX             @Y30LB22*/
            3      *         CHAR(8),   /* UNUSED            @Y30LB22*/
          2        GVSSLOTS (GVSNSLOT) BDY(HWORD),         /*@Y30LB22
                                           SLOT ARRAY        @Y30LB22*/
            3      GVSVOLID  CHAR(6),   /* SER NO OF VOL IN  @Y30LB22
                                           THIS SLOT         @Y30LB22*/
            3      GVSVOLFL  BIT(32),   /* INDICATOR FLAGS   @Y30LB22*/
              4    GVSCPUBM  BIT(16),   /* CPU ASSOC BIT MAP @Y30LB22*/
              4    GVSRCFSI  BIT(1),    /* RUNNING COUNT     @G24LB37
                                           (GVSMTDSP) IS     @G24LB37
                                           INVALID           @G24LB37*/
              4    GVSMTNSH  BIT(1),    /* MOUNTED TO HOST   @G24LB37
                                           NON-SHARED        @G24LB37*/
              4    *         BIT(14),   /* UNUSED            @G24LB37*/
            3      GVSFRESP  FIXED(15), /* NO OF FREE CYL    @Y30LB22*/
            3      GVSLEXT  FIXED(15),  /* NO OF CYL IN THE  @Y30LB22
                                           LARGEST FREE EXT  @Y30LB22*/
            3      GVSEXPDT  CHAR(4),   /* EXPIRATION DATE   @Y30LB22*/
            3      GVSMTDSP  FIXED(15); /* RUNNING COUNT OF  @G24LB37
                                           AVAILABLE SPACE   @G24LB37
                                           REMAINING ON VOL  @G24LB37
                                           IN CYLINDERS      @G24LB37*/
