 /********************************************************************/
 /*                                                                  */
 /*          MACCOMP  Y30LB22          SC1DR/BL0019          @Y30LB22*/
 /*          MACSTAT  Y30LB22          74/172/341040         @Y30LB22*/
 /*                                                          @G24LB37*/
 /*          NAME: IEZMGP                                    @G24LB37*/
 /*                                                          @G24LB37*/
 /*          FUNCTION:                                       @Y30LB22*/
 /*          MAPS THE REQUEST BLOCK FOR A CREATE OR MODIFY   @Y30LB22*/
 /*          GROUP RECORD REQUEST.  REGISTER 1 MUST          @Y30LB22*/
 /*          POINT TO THE REQUEST BLOCK WHEN THE REQUEST IS  @Y30LB22*/
 /*          EXECUTED  (MACRO ICBVVIC - SVC 126).            @G24LB37*/
 /*                                                          @G24LB37*/
 /*          STATUS:  MVS                                    @G24LB37*/
 /*                                                          @G24LB37*/
 /*          CHANGE LEVEL:                                   @G24LB37*/
 /*          @G24LB37  ALLOCATE TO MOUNTED VOLUMES  06/07/76 @G24LB37*/
 /*                                                                  */
 /********************************************************************/
    /*  CONSTANTS                                            @Y30LB22*/
     DCL   MGPCGOP  BIT(8)    CONSTANT('82'X);             /*@Y30LB22*/
                              /* CREATE GRP REQ. OP CODE     @Y30LB22*/
     DCL   MGPMGOP  BIT(8)    CONSTANT('83'X);             /*@Y30LB22*/
                              /* MODIFY GRP REQ. OP CODE     @Y30LB22*/
     DCL   MGPLEN   FIXED(15) INIT (LENGTH(MGP));          /*@Y30LB22*/
                              /* REQUEST BLOCK LENGTH        @Y30LB22*/
     DCL
       1        MGP BASED(MGPPTR) BDY(WORD),               /*@Y30LB22*/
         2      MGPLNGTH  FIXED(31), /* REQ BLK LENGTH       @Y30LB22*/
         2      MGPCODE   CHAR(4),   /* OPERATION ID         @Y30LB22*/
           3    MGPOPCD   BIT(8),    /* OP CODE              @Y30LB22*/
           3    *         CHAR(3),   /* UNUSED               @Y30LB22*/
         2      MGPGROUP  CHAR(8),   /* USER DEFINED MSVGP   @Y30LB22*/
         2      MGPOWNER  CHAR(10),  /* NAME/ID OF OWNER     @Y30LB22*/
         2      MGPRI     FIXED(15), /* PRIM SPACE DEFAULT   @Y30LB22*/
         2      MGPSEC    FIXED(15), /* SEC SPACE DEFAULT    @Y30LB22*/
         2      MGPRETPD  FIXED(15), /* GRP RETENTION PERIOD @Y30LB22*/
         2      MGPTHOLD  FIXED(8),  /* GRP THREHOLD PERCENT @Y30LB22*/
         2      MGPCONUS  FIXED(8),  /* MAXIMUM NUMBER       @G24LB37
                                        OF CONCURRENT USERS  @G24LB37
                                        PER HOST TO A VOLUME @G24LB37
                                        WITHIN A GROUP       @G24LB37*/
         2      MGPRESSP  FIXED(8),  /* PERCENT OF RESERVED  @G24LB37
                                        SPACE PER VOLUME     @G24LB37
                                        WITHIN A  GROUP      @G24LB37*/
         2      *         CHAR(1),   /* UNUSED               @G24LB37*/
         2      MGPDESCR  CHAR(30),  /* DESCRIPTIVE INFO     @Y30LB22*/
         2      MGPADDR   CHAR(30),  /* MAILING ADDRESS      @Y30LB22*/
         2      MGPFLAGA  BIT(32),   /* INDICATOR FLAGS      @Y30LB22*/
           3    MGPRLSE   BIT(1),    /* UNUSED SPACE TO BE   @Y30LB22
                                        RELEASED             @Y30LB22*/
           3    MGPNRLSE  BIT(1),    /* UNUSED SPACE NOT TO  @Y30LB22
                                        BE RELEASED          @Y30LB22*/
           3    MGPBIND   BIT(1),    /* RESERVE ENTIRE VOL   @Y30LB22*/
           3    MGPNBIND  BIT(1),    /* VOL WILL NOT BE      @Y30LB22
                                        BOUND TO THE         @Y30LB22
                                        STAGING VOLUME       @Y30LB22*/
           3    MGPEXCL   BIT(1),    /* EXCLUSIVE USE        @Y30LB22*/
           3    MGPSHARE  BIT(1),    /* SHAREABLE            @Y30LB22*/
           3    MGPRONLY  BIT(1),    /* READ ONLY            @Y30LB22*/
           3    MGPRW     BIT(1),    /* VOL IS READ/WRITE    @Y30LB22*/
           3    MGPDERAS  BIT(1),    /* MSS HDWR WILL ERASE  @Y30LB22
                                        DATA ON DESTAGED VOL @Y30LB22*/
           3    MGPNDERA  BIT(1),    /* MSS HDWR WILL NOT    @Y30LB22
                                        ERASE DATA  ON       @Y30LB22
                                        DESTAGED VOLUME      @Y30LB22*/
           3    MGPFLGRO  BIT(1),    /* MGPGROUP  SPECIFIED  @Y30LB22*/
           3    MGPFLOWN  BIT(1),    /* MGPOWNER  SPECIFIED  @Y30LB22*/
           3    MGPFLPRI  BIT(1),    /* MGPPRI IS SPECIFIED  @Y30LB22*/
           3    MGPFLSEC  BIT(1),    /* MGPSEC IS SPECIFIED  @Y30LB22*/
           3    MGPFLTHO  BIT(1),    /* MGPTHOLD  SPECIFIED  @Y30LB22*/
           3    MGPFLRET  BIT(1),    /* MGPRETPD  SPECIFIED  @Y30LB22*/
           3    MGPFLDES  BIT(1),    /* MGPDESCR  SPECIFIED  @Y30LB22*/
           3    MGPFLADD  BIT(1),    /* MGPADDR IS SPECIFIED @Y30LB22*/
           3    MGPNTHLD  BIT(1),    /* NULLIFY THRESHOLD    @Y30LB22
                                        PERCENT              @Y30LB22*/
           3    MGPNOWNR  BIT(1),    /* NULLIFY OWNER        @Y30LB22*/
           3    MGPNRETP  BIT(1),    /* NULLIFY RETEN PERIOD @Y30LB22*/
           3    MGPNDESC  BIT(1),    /* NULLIFY DESCRIPTION  @Y30LB22*/
           3    MGPNADDR  BIT(1),    /* NULLIFY ADDRESS      @Y30LB22*/
           3    MGPFLCON  BIT(1),    /* MGPCONUS SPECIFIED   @G24LB37*/
           3    MGPFLRES  BIT(1),    /* MGPRESSP SPECIFIED   @G24LB37*/
           3    *         BIT(7),    /* UNUSED               @G24LB37*/
         2      *         CHAR(4);   /* UNUSED               @Y30LB22*/
