 /********************************************************************/
 /*          MACCOMP  Y30LB22          SC1DR/BL0019          @Y30LB22*/
 /*          MACSTAT  Y30LB22          74/170/341040         @Y30LB22*/
 /*                                                          @Y30LB22*/
 /*          NAME: IEZMVR                                    @Y30LB22*/
 /*                                                          @Y30LB22*/
 /*          FUNCTION:                                       @Y30LB22*/
 /*                  MAPS THE REQUEST BLOCK FOR A MODIFY     @Y30LB22*/
 /*                  BASE OR COPY VOLUME RECORD REQUEST.     @Y30LB22*/
 /*                  REGISTER 1 MUST POINT TO THE REQUEST    @Y30LB22*/
 /*                  BLOCK WHEN THE REQUEST IS EXECUTED      @Y30LB22*/
 /*                  (MACRO ICBVVIC - SVC 126).              @Y30LB22*/
 /*                                                          @Y30LB22*/
 /*          STATUS:  CHANGE LEVEL = 0                       @Y30LB22*/
 /*                                                          @Y30LB22*/
 /********************************************************************/
   /* CONSTANTS                                              @Y30LB22*/
    DCL MVRLEN FIXED(15) INIT (LENGTH(MVR)); /* LENGTH       @Y30LB22
                                           OF REQUEST BLOCK  @Y30LB22*/
    DCL MVROP  BIT(8) CONSTANT('85'X); /* REQUEST OP CODE    @Y30LB22*/
   /* MAPPING MACRO                                          @Y30LB22*/
     DCL
       1        MVR BASED(MVRPTR) BDY(WORD),               /*@Y30LB22*/
         2      MVRLNGTH  FIXED(31), /* LENGTH OF REQ. BLK   @Y30LB22*/
         2      MVRCODE   CHAR(4),   /* OPERATION IDENTIFIER @Y30LB22*/
           3    MVROPCD   BIT(8),    /* OP CODE              @Y30LB22*/
           3    *         CHAR(3),   /* UNUSED               @Y30LB22*/
         2      MVRFLAGA  BIT(32),   /* INDICATOR FLAGS      @Y30LB22*/
           3    MVRFLFOR  BIT(1),    /* MVRFOR IS SPECIFIED  @Y30LB22*/
           3    MVRFLGRO  BIT(1),    /* MVRGROUP  SPECIFIED  @Y30LB22*/
           3    MVRFLBAS  BIT(1),    /* MVRBVOL IS SPECIFIED @Y30LB22*/
           3    MVRFLDES  BIT(1),    /* MVRDES IS SPECIFIED  @Y30LB22*/
           3    MVRFLTO   BIT(1),    /* MVRTO IS SPECIFIED   @Y30LB22*/
           3    MVRFLCSN  BIT(1),    /* MVRCSN IS SPECIFIED  @Y30LB22*/
           3    MVRFLBK   BIT(1),    /* MVRBKUPN SPECIFIED   @Y30LB22*/
           3    MVRFLLAB  BIT(1),    /* MVRLABEL SPECIFIED   @Y30LB22*/
           3    MVRGEN    BIT(1),    /* GENERAL VOLUME       @Y30LB22*/
           3    MVRRSTD   BIT(1),    /* RESTRICTED VOLUME    @Y30LB22*/
           3    MVRNGRP   BIT(1),    /* CHANGE VOL TO NON-   @Y30LB22
                                        GROUPED              @Y30LB22*/
           3    MVRBKUP   BIT(1),    /* CHANGE COPY TO BCKUP @Y30LB22*/
           3    MVRNDESC  BIT(1),    /* NULLIFY DESCRIPTION  @Y30LB22*/
           3    MVRNEXPD  BIT(1),    /* NULLIFY EXP. DATE    @Y30LB22*/
           3    MVRSLMIS  BIT(1),    /* SET VOL. LABEL       @Y30LB22
                                        MISMATCH FLAG        @Y30LB22*/
           3    MVRCLMIS  BIT(1),    /* CLEAR VOL. LABEL     @Y30LB22
                                        MISMATCH FLAG        @Y30LB22*/
           3    MVRCIVCF  BIT(1),    /* CLEAR INCOMPLETE VOL @Y30LB22
                                        CREATION FLAG        @Y30LB22*/
           3    MVRCICPY  BIT(1),    /* CLEAR INCOMPLETE VOL @Y30LB22
                                        COPY FLAG            @Y30LB22*/
           3    *         BIT(14),   /* UNUSED               @Y30LB22*/
         2      MVRBVOL   CHAR(6),   /* VOLID OF BASE OR     @Y30LB22
                                        COPY RECORD          @Y30LB22
                                        TO BE MODIFIED       @Y30LB22*/
         2      MVRFOR    FIXED(15), /* NO. OF DAYS USED IN  @Y30LB22
                                        CALCULATING EXP DATE @Y30LB22*/
         2      MVRGROUP  CHAR(8),   /* USER SPECIFIED MSVGP @Y30LB22*/
         2      MVRDES    CHAR(30),  /* DESCRIPTIVE INFO     @Y30LB22*/
         2      MVRTO     CHAR(4),   /* JULIAN EXP. DATE     @Y30LB22*/
         2      MVRCSN    CHAR(12),  /* CARTRIDGE SERIAL     @Y30LB22
                                        NUMBER OF THE VOL    @Y30LB22*/
         2      MVRBKUPN  FIXED(8),  /* MAX NO. OF ALLOWED   @Y30LB22
                                        BACKUP COPIES        @Y30LB22*/
         2      MVRBLNK1  CHAR(1),   /* BLANK                @Y30LB22*/
         2      MVRLABEL  CHAR(6),   /* SER. NO IN SOFTWARE  @Y30LB22*/
                                     /* LABEL                @Y30LB22*/
         2      *         CHAR(6);   /* UNUSED               @Y30LB22*/
