 /********************************************************************/
 /*          MACCOMP  Y30LB22          SC1DR/BL0019          @Y30LB22*/
 /*          MACSTAT  Y30LB22          74/170/341040         @Y30LB22*/
 /*                                                                   */
 /*          NAME: IEZRPLV                                   @Y30LB22*/
 /*                                                                   */
 /*          FUNCTION:                                                */
 /*          A MSVC REQUEST PARAMETER LIST IS CREATED BY     @Y30LB22*/
 /*          ICBVPI00, ICBVIN01, ICBVIN02, OR ICBVQM00       @Y30LB22*/
 /*          TO HAVE A SERVICE FUNCTION PROCESSED BY         @Y30LB22*/
 /*          THE MSVC SUBTASK                                @Y30LB22*/
 /*                                                                   */
 /*          STATUS:  CHANGE LEVEL = 2                       @OZ09545*/
 /*      CHANGE 01 04/14/76 ADD NEW FIELD TO SAVE RCODE      @OZ09545*/
 /*      CHANGE 02 08/25/76 RECORD THE DATE THE RPLV WAS     @ZA13484*/
 /*                         CREATED BY ICBVQM00 FOR RECOVERY @ZA13484*/
 /*                                                          @Y30LB22*/
 /********************************************************************/
    /* CONSTANTS                                             @Y30LB22*/
 DCL RPLVREAD  FIXED(8) CONSTANT(0); /* READ REQUEST         @Y30LB22*/
 DCL RPLVPUT   FIXED(8) CONSTANT(1); /* PUT REQUEST          @Y30LB22*/
 DCL RPLVDEL   FIXED(8) CONSTANT(5); /* DELETE REQUEST       @Y30LB22*/
 DCL RPLVENDR  FIXED(8) CONSTANT(4); /* END REQUEST          @Y30LB22*/
    /* MAPPING MACRO                                         @Y30LB22*/
 DCL  1        RPLV      BASED(RPLVPTR) BDY(WORD),         /*@Y30LB22*/
        2      RPLVQPTR  PTR(31),   /* CHAIN AHEAD POINTER   @Y30LB22*/
        2      RPLVECB   PTR(31),   /* ECB                   @Y30LB22*/
        2      RPLTCBPR  PTR(31),   /* VS/1 TCB POINTER      @Y30LB22*/
          3    RPLASCBP  PTR(31),   /* VS/2 ASCB POINTER     @Y30LB22*/
        2      RPLVVICB  PTR(31),   /* VVICB POINTER         @Y30LB22*/
        2      RPLVRSV1  PTR(31),   /* RESERVED FOR SUBTASK  @Y30LB22
                                       POST                  @Y30LB22*/
        2      RPLVRSV2  PTR(31),   /* RESERVED FOR SUBTASK  @Y30LB22
                                       POST                  @Y30LB22*/
        2      RPLVRSV3  PTR(31),   /* RESERVED FOR SUBTASK  @Y30LB22
                                       POST                  @Y30LB22*/
        2      RPLFLAGA  CHAR(2),   /* STATUS FLAGS          @Y30LB22*/
          3    RPLFTIME  BIT(1),    /* 1ST TIME FOR THIS REQ @Y30LB22
                                       IF BIT 0=0 (OFF)      @Y30LB22
                                       2ND TIME FOR THIS REQ @Y30LB22
                                       IF BIT 0=1 (ON)       @Y30LB22*/
          3    RPLVPOST  BIT(1),    /* ECB TO BE POSTED      @Y30LB22*/
          3    RPLVPROG  BIT(1),    /* REQUEST IN PROGRESS   @Y30LB22*/
          3    RPLVCOMP  BIT(1),    /* REQUEST LST COMPLETED @Y30LB22*/
          3    RPLVVIN   BIT(1),    /* VIN CALL TO VSP       @Y30LB22*/
          3    RPLVVOP   BIT(1),    /* VOP CALL TO VJL       @Y30LB22*/
          3    RPLJRCVY  BIT(1),    /* JRNL RECOVERY RPLV    @Y30LB22*/
          3    RPLVJRNL  BIT(1),    /* RPLV JOURNALLED       @Y30LB22*/
          3    RPLVRES1  BIT(8),    /* RESERVED              @Y30LB22*/
        2      RPLVTLEN  FIXED(15), /* TOTAL RPLV LENGTH     @Y30LB22*/
        2      RPLRCODE  BIT(16),   /* REASON CODE           @Y30LB22*/
        2      RPLVRETC  BIT(16),   /* RETURN CODE           @Y30LB22*/
        2      RPLRMSCC  BIT(16),   /* REASON CODE           @OZ09545*/
        2      RPLVDATE  CHAR(4),   /* DATE RPLV CREATED     @ZA13484*/
        2      *         CHAR(14),  /* UNUSED                @OZ09545*/
        2      RPLVSAM   CHAR(76)  BDY(WORD), /*VSAM I/O RPL @Y30LB22*/
          3    *         CHAR(2),   /* RESERVED              @Y30LB22*/
          3    RPLVTYP   PTR(8),    /* I/O TYPE              @Y30LB22*/
          3    *         CHAR(21),  /* RESERVED              @Y30LB22*/
          3    RPLVACB   PTR(31),   /* ACB POINTER           @Y30LB22*/
          3    *         CHAR(4),   /* RESERVED              @Y30LB22*/
          3    RPLVBUF   PTR(31),   /* DATA BUFFER PTR       @Y30LB22*/
          3    RPLVKEY   PTR(31),   /* KEY POINTER           @Y30LB22*/
          3    RPLVOPT   CHAR(4),   /* I/O OPTIONS           @Y30LB22*/
            4  RPLVLOC   BIT(1),    /* MOVE MODE IF OFF      @Y30LB22
                                       LOCATE MODE IF ON     @Y30LB22*/
            4  RPLVDIR   BIT(1),    /* DIRECT KEY PROCESSING #Y30LB22*/
            4  RPLVNEXT  BIT(1),    /* NEXT SEQUENTIAL KEY   #Y30LB22
                                       PROCESSING            @Y30LB22*/
            4  *         BIT(2),    /* RESERVED              @Y30LB22*/
            4  RPLVKGE   BIT(1),    /* SEARCH KEY GT/EQ      @Y30LB22
                                       SEARCH KEY EQ IF OFF  @Y30LB22*/
            4  *         BIT(8),    /* RESERVED              @Y30LB22*/
            4  RPLVUPD   BIT(1),    /* READ/PUT UPDATE MODE  @Y30LB22
                                       RETRIEVAL-READ OR     @Y30LB22
                                       NEW-PUT IF OFF        @Y30LB22*/
          3    *         CHAR(4),   /* RESERVED              @Y30LB22*/
          3    RPLVRLN   FIXED(31), /* LENGTH OF RECORD      @Y30LB22*/
          3    RPLVBLN   FIXED(31), /* LENGTH OF DATA BUFFER @Y30LB22*/
        2      RPLVUTIL  CHAR(*) BDY(WORD);/* SVC 126 REQUEST BLOCK
                                              AND POSSIBLY REQUEST
                                              BLOCK EXTENSION OR
                                              JFCB.          @Y30LB22*/
