 /********************************************************************/
 /*          MACCOMP  Y30LB22          SC1DR/BL0019          @Y30LB22*/
 /*          MACSTAT  Y30LB22          74/170/341040         @Y30LB22*/
 /*                                                          @Y30LB22*/
 /*          NAME: IEZRVR                                    @Y30LB22*/
 /*                                                          @Y30LB22*/
 /*          FUNCTION:                                       @Y30LB22*/
 /*                  MAPS THE REQUEST BLOCK FOR A REMOVE     @Y30LB22*/
 /*                  BASE OR COPY VOLUME RECORD REQUEST      @Y30LB22*/
 /*                  REGISTER 1 MUST POINT TO THE REQUEST    @Y30LB22*/
 /*                  BLOCK WHEN THE REQUEST IS EXECUTED      @Y30LB22*/
 /*                  (MACRO ICBVVIC - SVC 126).              @Y30LB22*/
 /*                                                          @Y30LB22*/
 /*          STATUS:  CHANGE LEVEL = 0                       @Y30LB22*/
 /*                                                          @Y30LB22*/
 /********************************************************************/
    /*                CONSTANTS                              @Y30LB22*/
     DCL  RVRLEN  FIXED(15) INIT (LENGTH(RVR)); /* LENGTH OF @Y30LB22
                                              REQUEST BLOCK  @Y30LB22*/
     DCL  RVROP   BIT(8) CONSTANT('81'X); /*REQUEST OP CODE  @Y30LB22*/
 /********************************************************************/
    /*               MAPPING MACRO                           @Y30LB22*/
 /********************************************************************/
     DCL
       1        RVR BASED(RVRPTR) BDY(WORD),               /*@Y30LB22*/
         2      RVRLNGTH  FIXED(31), /* LENGTH OF REQ BLK    @Y30LB22*/
         2      RVRCODE   CHAR(4),   /* OPERATION IDENTIFIER @Y30LB22*/
           3    RVROPCD   BIT(8),    /* OPCODE               @Y30LB22*/
           3    *         CHAR(3),   /* UNUSED               @Y30LB22*/
         2      RVRVOLID  CHAR(6),   /* SER NO OF VOL WHOSE  @Y30LB22
                                        REC IS TO BE REMOVED @Y30LB22*/
         2      RVRBLNK1  CHAR(1),   /* BLANK                @Y30LB22*/
         2      RVRCPYID  FIXED(8),  /* ID OF A COPY RECORD  @Y30LB22*/
         2      RVRFLAGA  BIT(32),   /* INDICATOR FLAGS      @Y30LB22*/
           3    RVRBASEV  BIT(1),    /* THE BASE VOLUME REC  @Y30LB22
                                        IS TO BE REMOVED     @Y30LB22*/
           3    RVRCOPYV  BIT(1),    /* THE COPY VOLUME REC  @Y30LB22
                                        IS TO BE REMOVED     @Y30LB22*/
           3    *         BIT(30),   /* UNUSED               @Y30LB22*/
         2      *         CHAR(4);   /* UNUSED               @Y30LB22*/
