 /********************************************************************/
 /*          MACCOMP  Y30LB22          SC1DR/BL0019          @Y30LB22*/
 /*          MACSTAT  Y30LB22          74/171/341040         @Y30LB22*/
 /*                                                                   */
 /*          NAME: IEZRVVI                                   @Y30LB22*/
 /*                                                                   */
 /*          FUNCTION:                                       @Y30LB22*/
 /*          MAPS THE REQUEST BLOCK FOR A READ  RECORD       @Y30LB22*/
 /*          REQUEST.  REGISTER 1 MUST POINT TO THE REQUEST  @Y30LB22*/
 /*          BLOCK WHEN THE REQUEST IS EXECUTED              @Y30LB22*/
 /*          (MACRO ICBVVIC - SVC 126).                      @Y30LB22*/
 /*                                                                   */
 /*          STATUS:  CHANGE LEVEL = 03                      @ZDR2053*/
 /*                                                          @Z40LB66*/
 /* CHANGE 01  2/14/75  ADD RVVCIRCD FLAG                    @Z40LB66*/
 /* CHANGE 02  4/16/75  ADD RVVCPURC FLAG                    @Z40LB66*/
 /* CHANGE 03  7/4/76   ADD PLACE HOLDER FLAGS               @ZDR2053*/
 /*                                                                   */
 /********************************************************************/
     /* CONSTANTS                                            @Y30LB22*/
     DCL    RVVLEN   FIXED(15) INIT(LENGTH(RVVI)); /*        @Y30LB22
                                        REQUEST BLOCK LENGTH @Y30LB22*/
     DCL    RVVOP    BIT(8)    CONSTANT('87'X); /* REQUEST   @Y30LB22
                                                   OP CODE   @Y30LB22*/
     /* MAPPING MACRO                                        @Y30LB22*/
     DCL
       1        RVVI BASED(RVVIPTR) BDY(WORD),             /*@Y30LB22*/
         2      RVVLNGTH  FIXED(31), /* LENGTH OF REQ. BLK   @Y30LB22*/
         2      RVVOPCOD  CHAR(4),   /* OPERATION IDENTIFIER @Y30LB22*/
           3    RVVCODE   BIT(8),    /* OPCODE               @Y30LB22*/
           3    *         CHAR(3),   /* UNUSED               @Y30LB22*/
         2      RVVOLUME  CHAR(6),   /* VOLID OF RECORD TO   @Y30LB22
                                         BE RETRIEVED        @Y30LB22*/
         2      RVVGROUP  CHAR(8),   /* GROUP NAME OF GRP    @Y30LB22
                                        REC. TO BE RETRIEVED @Y30LB22*/
         2      RVVARLN   FIXED(15), /* RESERVED FOR SUBTASK @Y30LB22*/
         2      RVVAREA   PTR(31),   /* RESERVED FOR SUBTASK @Y30LB22*/
         2      *         CHAR(2),   /* UNUSED               @Y30LB22*/
         2      RVVBUFLN  FIXED(15), /* LENGTH OF CALLER     @Y30LB22
                                        PROVIDED REC BUFFER  @Y30LB22*/
         2      RVVRTBUF  PTR(31),   /* PTR TO THE CALLER    @Y30LB22
                                        PROVIDED REC BUFFER  @Y30LB22*/
         2      RVVEXPIR  FIXED(15), /* SPECIFIED NO OF DAYS @Y30LB22*/
         2      RVVCDATE  CHAR(4),   /* DATE VOL WAS COPIED  @Y30LB22*/
         2      RVVBLNK1  CHAR(1),   /* BLANK                @Y30LB22*/
         2      RVVRDSEQ  FIXED(8),  /* SEQ. NO. OF THE COPY @Y30LB22*/
         2      RVVRDCSN  CHAR(12),  /* SER. NO. OF CART.    @Y30LB22*/
         2      RVVCPYID  FIXED(8),  /* COPY RECORD ID       @Y30LB22*/
         2      RVVDUPID  FIXED(8),  /* DUPLICATE RECORD ID  @Y30LB22*/
         2      RVVFLAGA  BIT(48),   /* INDICATOR FLAGS      @Y30LB22*/
           3    RVVRMODE  BIT(8),    /* TYPE OF LOCATE       @Y30LB22
                                        TO PERFORM           @Y30LB22*/
             4  RVVRDR    BIT(1),    /* READ RECORD DIRECT   @Y30LB22*/
             4  RVVRDNR   BIT(1),    /* READ NEXT RECORD     @Y30LB22*/
             4  RVVRDCH   BIT(1),    /* READ RECORD CHAIN    @Y30LB22*/
             4  *         BIT(5),    /* UNUSED               @Y30LB22*/
           3    RVVCHAIN  BIT(8),    /* INDICATES TYPE CHAIN @Y30LB22*/
             4  RVVGPVOL  BIT(1),    /* LOC A GROUP RECORD   @Y30LB22*/
             4  RVVNGVOL  BIT(1),    /* LOC NONGROUP RECORD  @Y30LB22*/
             4  *         BIT(6),    /* UNUSED               @Y30LB22*/
           3    RVVRDRCD  BIT(8),    /* INDICATE TYPE RECORD @Y30LB22*/
             4  RVVBVRCD  BIT(1),    /* LOC. A BASE VOL REC. @Y30LB22*/
             4  RVVGRPRC  BIT(1),    /* LOC A GROUP RECORD   @Y30LB22*/
             4  RVVCPYRC  BIT(1),    /* LOC A COPY VOL REC.  @Y30LB22*/
             4  RVVDUPRC  BIT(1),    /* LOC A DUPL VOL REC.  @Y30LB22*/
             4  RVVRUNKN  BIT(1),    /* READ AN UNKNOWN REC  @Y30LB22*/
             4  RVVCIRCD  BIT(1),    /* READ CART INDEX REC. @Z40LB66*/
             4  RVVCPURC  BIT(1),    /* READ CPU RECORD      @Z40LB66*/
             4  RVVALL    BIT(1),    /* READ VOLUME & PLACE  @ZDR2053*/
                                     /* HOLDER RECORDS       @ZDR2053*/
           3    RVVRTEST  BIT(8),    /* TEST TO MAKE         @Y30LB22*/
             4  RVVEXPDT  BIT(1),    /* EXP DATE SPECIFIED   @Y30LB22*/
             4  RVVTHOLD  BIT(1),    /* PAST THRESHOLD REQ'D @Y30LB22*/
             4  RVVGSVOL  BIT(1),    /* GENERAL USE VOL REQ  @Y30LB22*/
             4  RVVRSTD   BIT(1),    /* RESTRICTED VOL REQ'D @Y30LB22*/
             4  RVVINACT  BIT(1),    /* INACTIVE VOL REQ'D   @Y30LB22*/
             4  RVVACTV   BIT(1),    /* ACTIVE VOLUME REQ'D  @Y30LB22*/
             4  RVVDVOL   BIT(1),    /* DUP VOLID ONLY       @Y30LB22
                                        SPECIFIED            @Y30LB22*/
             4  RVVBPLHD  BIT(1),    /* BASE PLACE HOLDER    @ZDR2053*/
           3    RVVCPYTP  BIT(8),    /* TYPE OF COPY RECORD  @Y30LB22
                                         TO BE RETURNED      @Y30LB22*/
             4  RVVLBKUP  BIT(1),    /* LATEST BKUP REC REQ  @Y30LB22*/
             4  RVVOBKUP  BIT(1),    /* OLDEST BKUP REC REQ  @Y30LB22*/
             4  RVVLCOPY  BIT(1),    /* LATEST COPY REC REQ  @Y30LB22*/
             4  RVVCPLHD  BIT(1),    /* COPY PLACE HOLDER    @ZDR2053*/
             4  *         BIT(4),    /* UNUSED               @ZDR2053*/
           3    RVVSPEC   BIT(8),    /* SPECIFICATION FIELD  @Y30LB22*/
             4  RVVSGRP   BIT(1),    /* RVVGROUP SPECIFIED   @Y30LB22*/
             4  RVVSEXP   BIT(1),    /* RVVEXPIR SPECIFIED   @Y30LB22*/
             4  RVVSDTE   BIT(1),    /* RVVCDATE SPECIFIED   @Y30LB22*/
             4  RVVSSEQ   BIT(1),    /* RVVRDSEQ SPECIFIED   @Y30LB22*/
             4  RVVSCSN   BIT(1),    /* RVVRDCSN SPECIFIED   @Y30LB22*/
             4  RVVSCPY   BIT(1),    /* RVVCPYID SPECIFIED   @Y30LB22*/
             4  RVVSDUP   BIT(1),    /* RVVDUPID SPECIFIED   @Y30LB22*/
             4  RVVSVOL   BIT(1),    /* RVVOLUME SPECIFIED   @Y30LB22*/
         2      *         CHAR(4);   /* UNUSED               @Y30LB22*/
