 /********************************************************************/
 /*     MACCOMP  Z40LB02                                             */
 /*     MACSTAT  Z40LB02                                             */
 /*                                                                  */
 /*     NAME     IEZSENSE                                            */
 /*                                                                  */
 /*     FUNCTION-MAPS THE SENSE DATA AS IT APPEARS IN STORAGE        */
 /*                                                                  */
 /*     STATUS CHANGE LEVEL=0                                        */
 /********************************************************************/
     /*SENSE DATA MAPPING                                    @Z40LB02*/
 DCL 1  EWOSNS BASED(SNSPTR),          /*STRUCTURE FOR 32    @Z40LB02
                                        BYTES OF SENSE DATA  @Z40LB02*/
         2 EWOSNS0 BIT(8),             /*SENSE BYTE 0        @Z40LB02*/
           3 CREJ BIT(1),              /*COMMAND REJECT      @Z40LB02*/
           3 INTV BIT(1),              /*INTERVENTION REQD   @Z40LB02*/
           3 BUSO BIT(1),              /*BUS OUT PARITY      @Z40LB02*/
           3 EQU BIT(1),               /*EQUIPMENT CHECK     @Z40LB02*/
           3 *   BIT(1),               /*NOT USED            @Z40LB02*/
           3 HRET BIT(1),              /*HOST RETRY          @Z40LB02*/
           3 PERR BIT(1),              /*PERMANENT ERROR     @Z40LB02*/
           3 ENV BIT(1),               /*ENVIRONMENTAL DATA  @Z40LB02*/
         2 EWOSSID BIT(16),            /*SSID FIELD          @Z40LB02*/
           3 EWOSNS1 BIT(8),           /*SENSE BYTE 1        @Z40LB02*/
             4 CEM BIT(1),             /*CE MESSAGE          @Z40LB02*/
             4 SUU BIT(1),             /*SUBSYSTEM UNIT      @Z40LB02
                                         UNUSABLE            @Z40LB02*/
             4  *   BIT(2),            /*MSG TYPE ETC        @Z40LB02*/
             4  EWOSSID1  BIT(4),      /*1ST CHAR OF SSID    @Z40LB02*/
           3 EWOSNS2 BIT(8),           /*SENSE BYTE 2        @Z40LB02*/
             4  EWOSSID2  BIT(8),      /*2-3 CHARS OF SSID   @Z40LB02*/
         2 EWOSNS3 BIT(8),             /*SENSE BYTE 3        @Z40LB02*/
           3 FORMAT0 BIT(1),           /*FORMAT 0 - '80'X    @Z40LB02*/
           3 FORMAT1 BIT(1),           /*FORMAT 1 - '40'X    @Z40LB02*/
           3 FORMAT2 BIT(1),           /*FORMAT 2 - '20'X    @Z40LB02*/
           3 FORMAT3 BIT(1),           /*FORMAT 3 - '10'X    @Z40LB02*/
           3 FORMAT4 BIT(1),           /*FORMAT 4 - '08'X    @Z40LB02*/
           3 FORMAT5 BIT(1),           /*FORMAT 5 - '04'X    @Z40LB02*/
         2 EWOVOLID CHAR(6),           /*BYTES 4-9 -VOLID    @Z40LB02*/
           3 EWOSNS4 BIT(8),           /*SENSE BYTE 4        @Z40LB02*/
             4 *    BIT(1),            /*NOT USED            @Z40LB02*/
             4 INTVREQ BIT(1),         /*INTERVENTION REQD   @Z40LB02*/
             4 CHBOPAR BIT(1),         /*BUS OUT PAR         @Z40LB02*/
             4 EQCHK BIT(1),           /*EQUIPMENT CHECK     @Z40LB02*/
             4 DATACHK BIT(1),         /*DATA CHECK          @Z40LB02*/
           3 EWOSNS5 BIT(8),           /*SENSE BYTE 5        @Z40LB02*/
             4 *     BIT(1),           /*BIT NOT USED        @Z40LB02*/
             4 RECON BIT(1),           /*RECONFIGURATION BIT @Z40LB02*/
           3 EWOSNS6 BIT(8),           /*SENSE BYTE 6        @Z40LB02*/
           3 EWOSNS7 BIT(8),           /*SENSE BYTE 7        @Z40LB02*/
           3 EWOSNS8 BIT(8),           /*SENSE BYTE 8        @Z40LB02*/
           3 EWOSNS9 BIT(8),           /*SENSE BYTE 9        @Z40LB02*/
         2 EWOSNS10 BIT(8),            /*TABLE 10 IF AVAIL   @Z40LB02*/
         2 EWOSNS11 BIT(8),            /*SENSE BYTE 11       @Z40LB02*/
           3 EWOCHECK BIT(8),          /*EQ OR DATA CHECK    @Z40LB02*/
             4 EWOMSGCD BIT(8),        /*MESSAGE CODE        @Z40LB02*/
         2 EWOSNS12 BIT(8),            /*TERMINATION CODE    @Z40LB02*/
           3 EWOCCOND BIT(4),          /*THIS VALUE MAY BE   @Z40LB02
                                         0, A, OR C          @Z40LB02*/
           3 EWOCNUM BIT(4),           /*CASE NUMBER         @Z40LB02*/
         2 EWOSNS13 BIT(8),            /*SENSE BYTE 13       @Z40LB02*/
         2 EWOLZYX FIXED(16),          /*LZYX VALUE          @Z40LB02*/
           3 EWOLZYX1 BIT(8),          /*MSF/ZY VALUE        @Z40LB02*/
             4 MSFVALUE BIT(2),        /*MSF VALUE           @Z40LB02*/
             4 ZVALUE BIT(1),          /*Z VALUE             @Z40LB02*/
             4 YVALUE BIT(5),          /*Y VALUE             @Z40LB02*/
           3 XVALUE BIT(8),            /*X VALUE             @Z40LB02*/
         2 EWOCSN CHAR(12),            /*CARTRIDGE SERIAL    @Z40LB02
                                         NUMBER-BYTES 16
                                         THRU 27             @Z40LB02*/
           3 EWOSNS16 CHAR(1),         /*SENSE BYTE 16       @Z40LB02*/
           3 EWOSNS17 CHAR(1),         /*SENSE BYTE 17       @Z40LB02*/
           3 EWOSNS18 CHAR(1),         /*SENSE BYTE 18       @Z40LB02*/
           3 EWOSNS19 CHAR(1),         /*SENSE BYTE 19       @Z40LB02*/
           3 EWOSNS20 CHAR(1),         /*SENSE BYTE 20       @Z40LB02*/
           3 EWOSNS21 CHAR(1),         /*SENSE BYTE 21       @Z40LB02*/
           3 EWOSNS22 CHAR(1),         /*SENSE BYTE 22       @Z40LB02*/
           3 EWOSNS23 CHAR(1),         /*SENSE BYTE 23       @Z40LB02*/
           3 EWOSNS24 CHAR(1),         /*SENSE BYTE 24       @Z40LB02*/
           3 EWOSNS25 CHAR(1),         /*SENSE BYTE 25       @Z40LB02*/
           3 EWOFSC CHAR(2),           /*FAULT SYMP CODE     @Z40LB02*/
             4 EWOSNS26 CHAR(1),       /*SENSE BYTE 26       @Z40LB02*/
             4 EWOSNS27 CHAR(1),       /*SENSE BYTE 27       @Z40LB02*/
         2 EWOCYL CHAR(4),             /*SENSE BYTES 28-31   @Z40LB02
                                         WILL CONTAIN CYL    @Z40LB02
                                         IF AVAILABLE        @Z40LB02*/
           3 CCHHR CHAR(4),            /*CCHHR VALUE         @Z40LB02*/
             4 EWOCC CHAR(2);          /*CYLINDER INFO       @Z40LB02*/
