 /*********************************************************  @G24LB18*/
 /*                                                          @G24LB18*/
 /* NAME - IEZSTPTB (MSVC STEP TABLE MAPPING MACRO)          @G24LB18*/
 /*                                                          @G24LB18*/
 /* STATUS - MVS                                             @G24LB18*/
 /*                                                          @G24LB18*/
 /* FUNCTION - MAPPING MACRO FOR THE MSVC STEP TABLES BUILT  @G24LB18*/
 /*            AND MAINTAINED BY THE MSVC TABLE PROCESSOR    @G24LB18*/
 /*            (ICBVTP00). THESE TABLES CONTAIN DD           @G24LB18*/
 /*            INFORMATION ON A JOB STEP BASIS WHICH MSVC    @G24LB18*/
 /*            USES IN SELECTING VOLUMES TO SATISFY MSVGP    @G24LB18*/
 /*            REQUESTS AND IN KEEPING TRACK OF AVAILABLE    @G24LB18*/
 /*            SPACE ON GENERAL-USE GROUP VOLUMES. EACH STEP @G24LB18*/
 /*            TABLE CONSISTS OF A HEADER (STPTB) FOR THE    @G24LB18*/
 /*            STEP AND A DD ENTRY (STPDDENT) FOR EACH       @G24LB18*/
 /*            VIRTUAL DD IN THE STEP.                       @G24LB18*/
 /*                                                          @G24LB18*/
 /*********************************************************  @G24LB18*/
 DCL
    1  STPTB  BDY(WORD) BASED,      /* MSVC STEP TABLE       @G24LB18*/
                                    /* HEADER                @G24LB18*/
       2  STPNXTTB PTR(31),         /* NEXT STEP TABLE PTR   @G24LB18*/
       2  STPPRVTB PTR(31),         /* PREVIOUS STEP TABLE   @G24LB18*/
                                    /* PTR                   @G24LB18*/
       2  STPJOBID FIXED(31),       /* TCB ADDR(VS1) OR      @G24LB18*/
                                    /* ASID(MVS)             @G24LB18*/
       2  STPHDRLN FIXED(15),       /* LENGTH OF HEADER      @G24LB18*/
       2  STPFLAGS,                 /* STEP FLAGS            @G24LB18*/
          3  STPINVAL BIT(1),       /* STEP TABLE INVALID    @G24LB18*/
          3  STPNOFRE BIT(1),       /* DON'T FREE STEP TABLE @G24LB18*/
          3  *        BIT(6),       /* UNUSED                @G24LB18*/
       2  STPICCGR FIXED(8),        /* INITIAL CALL COUNTER  @G24LB18*/
       2  STPDDPTR PTR(31);         /* 1ST DD ENTRY PTR      @G24LB18*/
 DCL
    1  STPDDENT BASED,              /* DD ENTRY              @G24LB18*/
       2  STPDDNXT PTR(31),         /* NEXT DD ENTRY PTR     @G24LB18*/
       2  STPDDLEN FIXED(15),       /* LENGTH OF ENTRY       @G24LB18*/
       2  STPDDNUM FIXED(15),        /* INTERNAL DD NUMBER    @G24LB18*/
       2  STPDDDVT CHAR(4),         /* INTERNAL DEVICE TYPE  @G24LB18*/
                                    /* OR UCB ADDR IF        @G24LB18*/
                                    /* SPECIFIC UNIT ADDR    @G24LB18*/
                                    /* REQUEST               @G24LB18*/
       2  STPDDGPN CHAR(8),         /* GROUP NAME            @G24LB18*/
       2  STPDDGPI FIXED(8),        /* GROUP EXTENSION INDEX @G24LB18*/
       2  STPDDGPS FIXED(8),        /* GROUP EXTENSION SLOT  @G24LB18*/
                                    /* NUMBER                @G24LB18*/
       2  STPDDPRM FIXED(15),       /* PRIMARY SPACE IN CYL  @G24LB18*/
       2  STPDDFLG,                 /* DD FLAGS              @G24LB18*/
          3  STPDDEXC BIT(1),       /* EXCLUSIVE USE REQUEST @G24LB18*/
          3  STPDDSPL BIT(1),       /* PRIMARY OR SECONDARY  @G24LB18*/
                                    /* SPLIT                 @G24LB18*/
          3  *        BIT(6),       /* UNUSED                @G24LB18*/
       2  STPDDNVL FIXED(8),        /* NO. OF VOL SERS       @G24LB18*/
       2  STPDDVOL(*) CHAR(6);      /* VOL SER(S)            @G24LB18*/
