 /*********************************************************  @G24LB18*/
 /*                                                          @G24LB18*/
 /* NAME - IEZTABP (TABLE PROCESSOR PARAMETER LIST MAPPING   @G24LB18*/
 /*                 MACRO)                                   @G24LB18*/
 /*                                                          @G24LB18*/
 /* STATUS - MVS                                             @G24LB18*/
 /*                                                          @G24LB18*/
 /* FUNCTION - MAPPING MACRO FOR THE MSVC TABLE PROCESSOR    @G24LB18*/
 /*            (ICBVTP00) PARAMETER LIST. THIS LIST DEFINES  @G24LB18*/
 /*            THE FUNCTION TO BE PERFORMED BY THE TABLE     @G24LB18*/
 /*            PROCESSOR AND CONTAINS THE INPUTS TO THE      @G24LB18*/
 /*            TABLE PROCESSOR AND THE OUTPUTS FROM THE      @G24LB18*/
 /*            TABLE PROCESSOR.                              @G24LB18*/
 /*                                                          @G24LB18*/
 /*********************************************************  @G24LB18*/
 DCL
    1 TABP  BDY(WORD) BASED,        /* TABLE PROCESSOR REQ   @G24LB18*/
                                    /* PARM LIST             @G24LB18*/
      2  TABFLAGS,                  /* TABLE PROCESSOR FUNC  @G24LB18*/
         3  TABFBLDE BIT(1),        /* BUILD DD ENTRY FUNC   @G24LB18*/
         3  TABFSRCD BIT(1),        /* SEARCH FOR DD ENTRY   @G24LB18*/
                                    /* FUNC                  @G24LB18*/
         3  TABFBFIT BIT(1),        /* UPDATE BEST FIT TABLE @G24LB18*/
                                    /* FUNC                  @G24LB18*/
         3  TABFTSPC BIT(1),        /* GET TOTAL SPACE FOR   @G24LB18*/
                                    /* VOLSER FUNC           @G24LB18*/
         3  TABFUTRM BIT(1),        /* UNSUCCESSFUL          @G24LB18*/
                                    /* TERMINATION FUNC      @G24LB18*/
         3  TABFFREE BIT(1),        /* FREE STEP TABLE FUNC  @G24LB18*/
         3  *        BIT(2),        /* UNUSED                @G24LB18*/
      2  *        CHAR(1),          /* UNUSED                @G24LB18*/
      2  TABVOLID CHAR(6),          /* VOL SER FOR SEARCH    @G24LB18*/
         3  TABDDNUM FIXED(15),     /* DD # FOR SEARCH       @G24LB18*/
         3  TABSELRB PTR(31),       /* SELECT REQ BLOCK ADDR @G24LB18*/
            4  TABJOBID FIXED(31),  /* TCB ADDR(VS1) OR      @G24LB18*/
                                    /* ASID(MVS)             @G24LB18*/
               5  TABBFTBL PTR(31), /* BEST FIT TABLE ADDR   @G24LB18*/
      2  TABDDRET PTR(31),          /* DD ENTRY ADDR RET     @G24LB18*/
                                    /* AREA                  @G24LB18*/
         3  TABHDRET PTR(31),       /* STEP TABLE HEADER     @G24LB18*/
                                    /* ENTRY ADDR RETURN     @G24LB18*/
                                    /* AREA                  @G24LB18*/
            4  TABSPRET FIXED(15),  /* SELECTED SPACE RET    @G24LB18*/
                                    /* AREA                  @G24LB18*/
            4  *        CHAR(2);    /* UNUSED                @G24LB18*/
