 /*********************************************************  @G24LB18*/
 /*                                                          @G24LB18*/
 /* NAME - IEZVOLRT (VOL SER RETURN AREA MAPPING MACRO)      @G24LB18*/
 /*                                                          @G24LB18*/
 /* STATUS - MVS                                             @G24LB18*/
 /*                                                          @G24LB18*/
 /* FUNCTION - MAPPING MACRO FOR THE VOL SER RETURN AREA.    @G24LB18*/
 /*            THIS AREA IS PASSED TO MSVC BY ALLOCATION     @G24LB18*/
 /*            FOR EACH MSVGP DD WHICH REQUIRES SELECTION    @G24LB18*/
 /*            OF VOLUMES BY MSVC. MSVC PLACES THE VOL SERS  @G24LB18*/
 /*            OF THE SELECTED VOLUMES IN THIS AREA AND      @G24LB18*/
 /*            RETURNS IT TO ALLOCATION. THE AREA IS POINTED @G24LB18*/
 /*            TO BY THE SELECT REQUEST BLOCK (FIELD         @G24LB18*/
 /*            SELVLRET). ALLOCATION FILLS IN THE LENGTH OF  @G24LB18*/
 /*            THE AREA AND MSVC FILLS IN THE NUMBER OF      @G24LB18*/
 /*            VOLUMES SELECTED AND THE SELECTED VOL SERS.   @G24LB18*/
 /*                                                          @G24LB18*/
 /*********************************************************  @G24LB18*/
 DCL
    1  VOLRT  BDY(WORD) BASED(SELVLRET), /* VOL SER RETURN   @G24LB18*/
                                    /*AREA                   @G24LB18*/
       2  VOLLEN   FIXED(15),       /* LENGTH OF RET AREA    @G24LB18*/
       2  VOLNUM   FIXED(15),       /* NO. OF VOL SERS       @G24LB18*/
       2  VOLSER(*) CHAR(6);        /* VOL SER(S)            @G24LB18*/
