*/********************************************************************/
*/*          MACCOMP  Y30LB22          SC1DR/BL0019          @Y30LB22*/
*/*          MACSTAT  Y30LB22          74/213/341040         @Y30LB22*/
*/*                                                          @Y30LB22*/
*/*          NAME: IEZVVICB                                  @Y30LB22*/
*/*                                                          @Y30LB22*/
*/*          FUNCTION:                                       @Y30LB22*/
*/*                  MAPS THE MSSC VOLUME CONTROL BLOCK      @Y30LB22*/
*/*                                                          @Y30LB22*/
*/*          STATUS:  MVS                                    @G24LB04*/
*/*                                                          @Y30LB22*/
*/*   CHANGE-ACTIVITY = AS FOLLOWS                           @YM31134*/
*/*      CHANGE 01 10/14/75 MSVI MULTI-HOST SHARABILITY      @YM31134*/
*/*      CHANGE 02 05/13/76 ALLOCATE TO MOUNTED VOLUMES      @G24LB04*/
*/*      CHANGE 03 07/14/77 SAVE AREA FOR OPCODE             @ZA26243*/
*/*      CHANGE 04 10/20/77 ELIMINATE REDUN ACQUIRE          @ZA27588*/
*/*                                                          @YM31134*/
*/********************************************************************/
*DCL
*  1   VVICB     BASED (VVIPTR) BDY(WORD),                 /*@Y30LB22*/
*     2   VVICID        CHAR(4),    /* CTL BLOCK ID  'MSVC'  @Y30LB22*/
*     2   VVIUCAT       CHAR(8),    /* USER CATALOG NAME     @Y30LB22*/
*     2   VVICPUID      CHAR(2),    /* CPU ASSOCIATION MASK  @Y30LB22*/
*     2   VVIALCON      CHAR(1),    /* LIB ALTERNATE CONSOLE @Y30LB22*/
*     2   VVIFLGA       CHAR(1),    /* STATUS FLAG           @Y30LB22*/
*       3   VVIFLG0       BIT(1),   /* BIT 0=1 TOTAL DISABLE @Y30LB22*/
*       3   VVIFLG1       BIT(1),   /* BIT 1=1 INTERNAL      @YM31134
                                       DISABLE               @YM31134*/
*       3   VVIFLG2       BIT(1),   /* BIT 2=1 JRNL. DISABLE @Y30LB22*/
*       3   VVIFLG3       BIT(1),   /* BIT 3=1 MSGS JRNL.    @Y30LB22*/
*       3   VVIFLG4       BIT(1),   /* BIT 4=1 DEQ REQ'D     @Y30LB22
                                       FOR INVENTORY         @Y30LB22*/
*       3   VVIFLG5       BIT(1),   /* BIT 5=1 DEQ REQ'D     @Y30LB22
                                       FOR JOURNAL           @Y30LB22*/
*       3   VVIFLG6       BIT(1),   /* BIT 6=1 WHEN SUBTASK  @G24LB04
                                       HOLDS LOCAL LOCK      @G24LB04*/
*       3   VVIFLG7       BIT(1),   /* BIT 7=1 WHEN SUBTASK  @G24LB04
                                       HOLDS CMS LOCK        @G24LB04*/
*     2   VVIACBAD      PTR(31),    /* USERCAT ACB ADDR      @Y30LB22*/
*     2   VVIDCBAD      PTR(31),    /* USERCAT JRNL DCB ADDR @Y30LB22*/
*     2   VVICATAD      PTR(31),    /* USER CATALOG ACB ADDR @Y30LB22*/
*     2   VVIECB1       PTR(31),    /* ICBVVI00 ECB          @Y30LB22*/
*     2   VVIVQMP       PTR(31),    /* QUEUE MANAGER POINTER @Y30LB22*/
*     2   VVIOPCD       CHAR(1),    /* SAVE AREA FOR OPCODE  @ZA26243*/
*     2   VVIVTRK       CHAR(3),    /* VOL TRKING COUNT      @ZA27588*/
*     2   VVIQRPL1      PTR(31),    /* HIGH PRI RPLV QUE PTR @Y30LB22*/
*     2   VVIQRPL2      PTR(31),    /* LOW PRI RPLV QUE PTR  @Y30LB22*/
*     2   VVIQLSPL      PTR(31),    /* DEMOUNT LSPACE        @Y30LB22
*                                      PARAMETER LIST        @Y30LB22*/
*     2   VVIVRR        PTR(31),    /* RES/REL W/AREA PTR    @Y30LB22*/
*     2   VVIVJL        PTR(31),    /* JRNL PROC W/AREA PTR  @Y30LB22*/
*     2   VVIUCB        PTR(31),    /* UCB ADDR TABLE PTR    @Y30LB22*/
*     2   VVIRES4       PTR(31),    /* RES - USER TASK POST  @Y30LB22*/
*     2   VVIRES5       PTR(31),    /* RES - USER TASK POST  @Y30LB22*/
*     2   VVIRES6       PTR(31),    /* RES - USER TASK POST  @Y30LB22*/
*     2   VVIIUCB       PTR(31),    /* MSVI UCB PTR          @YM31134*/
*     2   VVIJUCB       PTR(31),    /* JRNL UCB PTR          @YM31134*/
*     2   VVIDVMTA      PTR(31),    /* DEVICE MASK TABLE     @G24LB04
                                       ADDRESS               @G24LB04*/
*     2   VVISTPTB      PTR(31),    /* MSVC STEP TABLE ADDR  @G24LB04*/
*     2   VVIVSCRA      PTR(31),    /* MSVC SCREENING MODULE @G24LB04
                                       ADDRESS               @G24LB04*/
*     2   VVISSOBA      PTR(31),    /* ADDR OF SSOB FOR      @G24LB04
                                        ALLOCATE TO MTD VOL  @G24LB04*/
*     2   VVIVBSTF      PTR(31),    /* ADDR OF EXTRA STORAGE @G24LB04
                                      FOR VOL BEST FIT TABLE @G24LB04*/
*     2   VVIDVMEL      FIXED(31),  /* LENGTH OF MASK IN DEV @G24LB04
                                       MASK TABLE ENTRY      @G24LB04*/
*     2   VVITPFCH      PTR(31),    /* MSVC FREE CHAIN PTR   @G24LB04*/
*     2   VVINUSDC      CHAR(4),    /* UNUSED                @G24LB04*/
*     2   VVIUNUSD      FIXED(31);  /* UNUSED                @G24LB04*/
