         TITLE 'IFCE0115 - MCH EDIT TABLE FOR 115 CPU'
***********************************************************************
**                                                                   **
**                                                                   **
**  MODULE NAME:   IFCE0115                                          **
**                                                                   **
**  DESCRIPTIVE-NAME:   EDIT TABLE FOR 0115 CPU                      **
**                                                                   **
**  COPYRIGHT:  NONE                                                 **
**                                                                   **
**  STATUS:     N/A                                                  **
**                                                                   **
**  FUNCTION:   PROVIDES DEVICE EDIT SUPPORT FOR 0115 MCH RECORDS    **
**                                                                   **
**  NOTES:                                                           **
**                                                                   **
**    DEPENDENCIES:   THIS MODULE WAS ASSEMBLED USING THE EBCDIC     **
**                 CHARACTER SET.  IT MUST BE REASSEMBLED IF ANOTHER **
**                CHARACTER SET IS TO BE USED AT EXECUTION.         **
**                                                                   **
**    RESTRICTIONS:   N/A                                            **
**                                                                   **
**    REGISTER-CONVENTIONS:                                          **
**          REG 2  = POINTER TO THE MCH RECORD                       **
**          REG 3  = POINTER TO THE PRINT BUFFER                     **
**          REG 4  = POINTER TO DATA ITEM REFERENCED IN 'ROUTINE'    **
**          REG 14 = RETURN POINT FROM 'ROUTINE'                     **
**          REG 15 = SET TO ZERO TO SUPPRESS PRINTING LINE           **
**                                                                   **
**    PATCH-LABEL:  PATCH                                            **
**                                                                   **
**  MODULE TYPE:    DATA                                             **
**                                                                   **
**    PROCESSOR:    370 ASSEMBLER                                    **
**                                                                   **
**    MODULE-SIZE:                                                   **
**                                                                   **
**    ATTRIBUTES:   SERIALLY REUSABLE                                **
**                                                                   **
**  ENTRY-POINT:    N/A                                              **
**                                                                   **
**    LINKAGE:      N/A                                              **
**                                                                   **
**  INPUT:     N/A                                                   **
**                                                                   **
**  OUTPUT:    N/A                                                   **
**                                                                   **
**  EXIT-NORMAL:     N/A                                             **
**                                                                   **
**  EXIT-ERROR:      N/A                                             **
**                                                                   **
**  EXTERNAL-REFERENCES:                                             **
**                                                                   **
**    ROUTINES:        NONE                                          **
**                                                                   **
**    DATA-AREAS:      NONE                                          **
**                                                                   **
**    CONTROL-BLOCKS:  NONE                                          **
**                                                                   **
**    TABLES:          NONE                                          **
**                                                                   **
**    MACROS:    EDIT TABLE MACROS                                   **
**                                                                   **
***********************************************************************
         EJECT
         GBLC  &CSECT,&DSECT
         PROLOG NAME=IFCE0115
         DSGEN (RECTYP,8),(LEVEL,8),(FLAG1,8),(FLAG2,8)
         DSGEN (RSVD1,16),(NOFN,8),(RSVD2,8)
         DSGEN (DATE,32),(TIME,32),(VERSION,8),(SERIAL,24)
         DSGEN (CPUID,16),(MCEL,16),(PROGID,64),(JOBID,64)
         DSGEN (PSWA,24),(PSWB,24),(PSWC,16)
         DSGEN (SUBCD,1,0,7),(TNSCD,1,0,7),(STPVB,1,0,7),(VLDCD,1,0,7)
         DSGEN (RSVD3,16),(EXTLOG,16),(RSVD4,64),(FSA,32)
         DSGEN (CWA,16),(ECC,16)
         DS    CL96                RESERVED
         DSGEN (FPR,32,0,7)
         SPACE 3
         DSGEN (GPR,32,0,15),(CR,32,0,15)
         ORG   SUBCD0
         DSGEN (DLOG,32,0,5,0,11)
         EJECT
&CSECT   CSECT
***********************************************************************
**                        SPECIAL ROUTINES                           **
***********************************************************************
SETID    MVC   L0(L8,R3),L0(R4)
         BR    R14
         SPACE 3
SETDATE  UNPK  WORKX(L5),DATE+1(L3)
         MVC   L0(L3,R3),WORKX+2
         MVC   L6(L2,R3),WORKX
         BR    R14
         SPACE 3
WORKX    DC    D'0'
**----------------------------PATCH AREA-----------------------------**
         DC    S(PATCH)
PATCH    DC    5CL11'PATCH AREA '
         EJECT
         ENTRIES PAGE
         LINE  (1,1),(44,1),SKIP=3
         LABEL '--- MACHINE CHECK DATA EDITING ---'
         SPACE 2
         LINE  (36,31),(1,10),SKIP=2
         HEX   (SERIAL,0,3B)
         ROUTINE JOBID,SETID
         ROUTINE PROGID,SETID
         LABEL 'MODEL 0115',,'SERIAL NUMBER',,,'JOB IDENTITY -',,,'PROG*
                IDENTITY -'
         SPACE 2
         LINE  ,(75,20),SKIP=1
         LABEL 'DAY  YEAR','HH MM SS'
         SPACE 2
         LINE  (75,20),(68,20),SKIP=1
         ROUTINE DATE,SETDATE
         HEX   (TIME,1,3B)
         LABEL 'DATE -','TIME -'
         SPACE 2
         LINE  ,(25,1),SKIP=1
         LABEL 'SM KS  IC  CM   IA'
         SPACE 2
         LINE  (25,8),(1,1),SKIP=2
         HEX   (PSWA,1,3B),(PSWB,1,3B),(PSWC,0,2B)
         LABEL 'OLD MACHINE CHECK PSW'
         SPACE 2
         LINE  ,,SKIP=3
         LABEL ''
         SPACE 2
         LINE  ,(26,1),SKIP=2
         LABEL '--- MACHINE CHECK INTERRUPT CODE ---'
         SPACE 2
         LINE  ,(10,1),SKIP=2
         LABEL '--- SUB CLASS ---'
         SPACE 2
         LINE  (24,55),(1,55),SKIP=1
         BIN   (SUBCD0),(SUBCD4)
         LABEL 'SYSTEM DAMAGE (SD)','CLOCK DAMAGE (CD)'
         SPACE 2
         LINE
         BIN   (SUBCD1),(SUBCD5)
         LABEL 'PROC. DAMAGE (PD)','EXTERNAL DAMAGE (ED)'
         SPACE 2
         LINE
         BIN   (SUBCD2),(SUBCD7)
         LABEL 'SYSTEM RECOVERY (SR)','AUTO-CONFIG (AC)'
         SPACE 2
         LINE  ,,SKIP=2
         BIN   (SUBCD3),(TNSCD3)
         LABEL 'TIMER DAMAGE (TD)','WARNING (W)'
         SPACE 2
         LINE  ,(28,1),SKIP=2
         LABEL '--- INTERRUPT TENSE CODES ---'
         SPACE 2
         LINE  ,(1,55),SKIP=2
         BIN   (TNSCD6),(TNSCD7)
         LABEL 'BACK-UP (B)','DELAYED (D)'
         SPACE 2
         LINE  ,(24,1),SKIP=2
         LABEL '--- STORAGE AND PROTECTION ERROR CODES ---'
         SPACE 2
         LINE  (36,58),(1,55),SKIP=1
         BIN   (STPVB0),(STPVB2)
         LABEL 'UNCORRECTED STORAGE ERRORS (SE)','UNCORRECTED PROTECTIO*
               N ERRORS (PE)'
         SPACE 2
         LINE  ,,SKIP=2
         BIN   (STPVB1)
         LABEL 'CORRECTED STORAGE ERRORS (SC)'
         SPACE 2
         LINE  ,(36,1),SKIP=2
         LABEL '--- PSW VALIDITY CODES ---'
         SPACE 2
         LINE  (41,55),(1,55),SKIP=1
         BIN   (STPVB4),(STPVB5)
         LABEL 'AMWP BITS OF M.C. OLD ARE VALID (WP)','SYSTEM MASK OF M*
               .C. OLD IS VALID (MS)'
         SPACE 2
         LINE  ,,SKIP=2
         BIN   (STPVB6),(STPVB7)
         LABEL 'PROGRAM MASK OF M.C. OLD IS VALID (PM)','INSTR ADDR OF *
               M.C. OLD IS VALID (IA)'
         SPACE 2
         LINE  ,(34,1),SKIP=2
         LABEL '--- MISC VALIDITY CODES ---'
         SPACE 2
         LINE  (39,52),(1,55),SKIP=1
         BIN   (VLDCD0),(VLDCD1)
         LABEL 'FAILING STORAGE ADDR IS VALID (FA)','REGION CODE IS VAL*
               ID (RC)'
         SPACE 2
         LINE
         BIN   (VLDCD3),(VLDCD4)
         LABEL 'FP REGS STORED ARE VALID (FP)','GP REGS STORED ARE VALI*
               D (GP)'
         SPACE 2
         LINE
         BIN   (VLDCD5),(VLDCD6)
         LABEL 'CONTROL REGS STORED ARE VALID (CR)','EXTENDED LOGOUT AR*
               EA IS VALID (LG)'
         SPACE 2
         LINE  ,,SKIP=2
         BIN   VLDCD7
         LABEL 'INSTR MODIFIED STORAGE IS VALID (ST)'
         SPACE 2
         LINE  (34,54),(1,59),SKIP=2
         HEX   (EXTLOG,0,2B),(FSA,0,4B)
         LABEL 'EXTENDED LOGOUT LENGTH','FAILING STORAGE ADDRESS'
         SPACE 2
         LINE  ,(37,1),SKIP=1
         LABEL '--- REGION CODE ---'
         SPACE 2
         LINE  (30,54),(1,55),SKIP=2
         HEX   (ECC,0,2B),(CWA,0,2B)
         LABEL 'ERROR CORRECTION CODES','CONTROL WORD ADDRESS'
         SPACE 2
         LINE  ,(24,1),SKIP=1
         LABEL '******************************************************'
         SPACE 2
         LINE  ,,SKIP=E
         LABEL ''
         SPACE 2
         LINE  ,(44,1),SKIP=3
         LABEL '--- MACHINE CHECK DATA EDITING ---'
         SPACE 2
         LINE  ,(1,1),SKIP=2
         LABEL '--- FLOATING POINT REGISTERS ---'
         SPACE 2
         LINE  (15,14),(1,1),SKIP=1
         HEX   (FPR0,1,4B),(FPR1,1,4B),(FPR2,1,4B),(FPR3,1,4B)
         LABEL 'FP REGS 0,2'
         SPACE 2
         LINE  ,,SKIP=2
         HEX   (FPR4,1,4B),(FPR5,1,4B),(FPR6,1,4B),(FPR7,1,4B)
         LABEL 'FP REGS 4,6'
         SPACE 2
         LINE  ,,SKIP=2
         LABEL '--- GENERAL PURPOSE REGISTERS ---'
         SPACE 2
         LINE  ,,SKIP=1
         HEX   (GPR0,1,4B),(GPR1,1,4B),(GPR2,1,4B),(GPR3,1,4B)
         LABEL 'GP REGS 0-3'
         SPACE 2
         LINE
         HEX   (GPR4,1,4B),(GPR5,1,4B),(GPR6,1,4B),(GPR7,1,4B)
         LABEL 'GP REGS 4-7'
         SPACE 2
         LINE
         HEX   (GPR8,1,4B),(GPR9,1,4B),(GPR10,1,4B),(GPR11,1,4B)
         LABEL 'GP REGS 8-B'
         SPACE 2
         LINE  ,,SKIP=2
         HEX   (GPR12,1,4B),(GPR13,1,4B),(GPR14,1,4B),(GPR15,1,4B)
         LABEL 'GP REGS C-F'
         SPACE 2
         LINE  ,,SKIP=2
         LABEL '--- CONTROL REGISTERS ---'
         SPACE 2
         LINE  ,,SKIP=1
         HEX   (CR0,1,4B),(CR1,1,4B),(CR2,1,4B),(CR3,1,4B)
         LABEL 'CT REGS 0-3'
         SPACE 2
         LINE
         HEX   (CR4,1,4B),(CR5,1,4B),(CR6,1,4B),(CR7,1,4B)
         LABEL 'CT REGS 4-7'
         SPACE 2
         LINE
         HEX   (CR8,1,4B),(CR9,1,4B),(CR10,1,4B),(CR11,1,4B)
         LABEL 'CT REGS 8-B'
         SPACE 2
         LINE  ,,SKIP=3
         HEX   (CR12,1,4B),(CR13,1,4B),(CR14,1,4B),(CR15,1,4B)
         LABEL 'CT REGS C-F'
         SPACE 2
         LINE  ,,SKIP=2
         LABEL '--- MACHINE CHECK LOGOUT BYTES ---'
         SPACE 2
         LINE  (7,10),(1,1),SKIP=1
         HEX   (DLOG00,0,4B),(DLOG01,B1,4B)
         HEX   (DLOG02,B2,4B),(DLOG03,B3,4B)
         HEX   (DLOG04,B2,4B),(DLOG05,B3,4B)
         HEX   (DLOG06,B4,4B),(DLOG07,B5,4B)
         HEX   (DLOG08,B4,4B),(DLOG09,B5,4B)
         HEX   (DLOG010,B6,4B),(DLOG011,B7,4B)
         LABEL '0000'
         SPACE 2
         LINE
         HEX   (DLOG10,0,4B),(DLOG11,B1,4B)
         HEX   (DLOG12,B2,4B),(DLOG13,B3,4B)
         HEX   (DLOG14,B2,4B),(DLOG15,B3,4B)
         HEX   (DLOG16,B4,4B),(DLOG17,B5,4B)
         HEX   (DLOG18,B4,4B),(DLOG19,B5,4B)
         HEX   (DLOG110,B6,4B),(DLOG111,B7,4B)
         LABEL '0030'
         SPACE 2
         LINE
         HEX   (DLOG20,0,4B),(DLOG21,B1,4B)
         HEX   (DLOG22,B2,4B),(DLOG23,B3,4B)
         HEX   (DLOG24,B2,4B),(DLOG25,B3,4B)
         HEX   (DLOG26,B4,4B),(DLOG27,B5,4B)
         HEX   (DLOG28,B4,4B),(DLOG29,B5,4B)
         HEX   (DLOG210,B6,4B),(DLOG211,B7,4B)
         LABEL '0060'
         SPACE 2
         LINE
         HEX   (DLOG30,0,4B),(DLOG31,B1,4B)
         HEX   (DLOG32,B2,4B),(DLOG33,B3,4B)
         HEX   (DLOG34,B2,4B),(DLOG35,B3,4B)
         HEX   (DLOG36,B4,4B),(DLOG37,B5,4B)
         HEX   (DLOG38,B4,4B),(DLOG39,B5,4B)
         HEX   (DLOG310,B6,4B),(DLOG311,B7,4B)
         LABEL '0090'
         SPACE 2
         LINE
         HEX   (DLOG40,0,4B),(DLOG41,B1,4B)
         HEX   (DLOG42,B2,4B),(DLOG43,B3,4B)
         HEX   (DLOG44,B2,4B),(DLOG45,B3,4B)
         HEX   (DLOG46,B4,4B),(DLOG47,B5,4B)
         HEX   (DLOG48,B4,4B),(DLOG49,B5,4B)
         HEX   (DLOG410,B6,4B),(DLOG411,B7,4B)
         LABEL '00C0'
         SPACE 2
         LINE  ,,SKIP=2
         HEX   (DLOG50,0,4B),(DLOG51,B1,4B)
         HEX   (DLOG52,B2,4B),(DLOG53,B3,4B)
         HEX   (DLOG54,B2,4B),(DLOG55,B3,4B)
         HEX   (DLOG56,B4,4B),(DLOG57,B5,4B)
         HEX   (DLOG58,B4,4B),(DLOG59,B5,4B)
         LABEL '00F0'
         SPACE 2
         ETEPILOG RLEN=190
         END
