**********************************************************************
*                                                                     *
****   MODULE IFCE0125 - 125 MACHINE CHECK EDIT TABLE                 *
*                                                                     *
** FUNCTION:                                                          *
*                                                                     *
*       IFCE0125 IS THE EREPEDIT TABLE WHICH PROCESSES THE MODEL 125  *
*       LOGOUT FOR THE MACHINE CHECK ERROR RECORDS                    *
*                                                                     *
** ENTRY POINTS:                                                      *
*                                                                     *
*       THE PROCESSING OF THIS TABLE BEGINS AT 10 PAST ITS ORIGIN     *
*                                                                     *
** INPUT:                                                             *
*                                                                     *
*       ALL IN/OUT FOR THIS TABLE IS HANDLED BY THE EREPREAD          *
*       SUBROUTINE WHICH READS FROM EITHER THE SYSREC FILE OR THE     *
*       HISTORY/RDE FILE                                              *
*                                                                     *
** OUTPUT:                                                            *
*                                                                     *
*       THIS TABLE DESCRIBES THE WAY IN WHICH THE OUTPUT AREA WILL    *
*       BE FORMATTED AND PRINTED BY THE EREPEDIT LIST PROCESSOR. THE  *
*       EREPEDIT OUTPUT SUBROUTINE OUTPUTS TO SYSLIST.                *
*                                                                     *
** EXTERNAL REFERENCES:                                               *
*                                                                     *
*       INPUT -  THE INPUT AREA IN EREPEDIT                           *
*       OUTPUT - THE OUTPUT AREA IN EREPEDIT                          *
*                                                                     *
** NORMAL EXITS:                                                      *
*                                                                     *
*       EXIT AT END OF PROCESSING                                     *
*                                                                     *
** ERROR EXITS:                                                       *
*                                                                     *
*       N/A                                                           *
*                                                                     *
** TABLES/WORK AREAS:                                                 *
*                                                                     *
*       N/A                                                           *
*                                                                     *
** ATTRIBUTES:                                                        *
*                                                                     *
*        SELF-RELOCATABLE, REUSABLE, NON-PRIVILEGED                   *
*                                                                     *
** REGISTER USAGE:                                                    *
*                                                                     *
*        R2  - BASE REGISTER FOR OUTPUT AREA                          *
*        R3  - POINTS TO THE CURRENT LOCATION IN THE OUTPUT AREA      *
*        R4  - POINTS TO THE CURRENT LOCATION IN THE INPUT AREA       *
*        R5-R8 - WORK REGISTERS                                       *
*        R9  - BASE REGISTER FOR LINE/LABEL CODE                      *
*        R10 - PROGRAM BASE REGISTER                                  *
*        R13 -                                                        *
*        R14 - RETURN FROM USER CODE SECTIONS                         *
*        R15 - BRANCHING REGISTER                                     *
*                                                                     *
*                                                                     *
* CODE PROCEEDURES/STANDARDS:                                         *
*                                                                     *
*        ALL BIT/BYTE COUNTS START AT 0; BYTE 1 IS THE SECOND BYTE    *
*        OF THE ITEM                                                  *
*                                                                     *
*        DATA BITS IN A GIVEN BYTE ARE LABELED AS FOLLOWS:            *
*                                                                     *
*               NAME'BYTE #'BIT MASK'                                 *
*                                                                     *
*            A. BYTE#     -  BYTE NUMBER OF THE ITEM STARTING AT 0    *
*            B. BIT MASK  -  MASK VALUE THAT SPECIFIES THE DESIRED    *
*               BITS,  SIMILIAR TO THE MASK OF THE TEST UNDER MASK    *
*               INSTRUCTION                                           *
*                                                                     *
*        EXAMPLE OF BIT/BYTE NAME USAGE                               *
*                                                                     *
*               ZONER080  -  BYTE 0, BIT 0                            *
*               ZONER00F  -  BYTE 0, BITS 4-7                         *
*               ZONER1FF  -  BYTE 1, BITS 0-7                         *
*                                                                     *
  EJECT                                                        @D35UGGB
*                                                              @D35UGGB
*        DEFINE CODE AND DATA DEFINITION AREAS                 @D35UGGB
*                                                              @D35UGGB
         SPACE 2                                               @D35UGGB
*                                                              @D35UGGB
         PRINT NOGEN                                           @D35UGGB
         TITLE  'IFCE0125'                                     @D35UGGB
         GBLC &DSECT,&CSECT                                    @D35UGGB
         PROLOG NAME=IFCE0125                                  @D35UGGB
         EJECT                                                 @D35UGGB
*                                                              @D35UGGB
*         MACHINE CHECK RECORD FORMAT FOR MODEL 125            @D35UGGB
*                                                              @D35UGGB
         SPACE 2                                               @D35UGGB
*                                                              @D35UGGB
HEADER   EQU   *                                               @D35UGGB
*                                                              @D35UGGB
         DSGEN (RECTYPE,8),        RECORD TYPE CODE            @D35UGGB*
               (LEVEL,8),          RELEASE LEVEL               @D35UGGB*
               (FLAG1,8),          RECORD INDEPENDENT SWITCHES @D35UGGB*
               (FLAG2,8),          SWITCHES BYTE 2             @D35UGGB*
               (RES1,16),          RESERVED                    @D35UGGB*
               (NOFN,8),           RECORD NUMBER,TORAL NUMBER  @D35UGGB*
               (RES4,8),           RESERVED                    @D35UGGB*
               (DATE,32),          DATE                        @D35UGGB*
               (TIME,32),          TIME                        @D35UGGB*
               (VERSION,8),        VERSION CODE                @D35UGGB*
               (SERIAL,24),        CPU SERIAL NUMBER           @D35UGGB*
               (CPUID,16),         CPU IDENTIFICATION          @D35UGGB*
               (MCEL,16)           MACHINE CHECK EXTENDED LOGOUT LENGTH
         SPACE 2                                               @D35UGGB
*                                                              @D35UGGB
REC1     EQU   *                                               @D35UGGB
*                                                              @D35UGGB
*                                                              @D35UGGB
         SPACE 2                                               @D35UGGB
         DSGEN (PROGID,64),        PROGRAM NAME                @D35UGGB*
               (JOBID,64),         JOB NAME                    @D35UGGB*
               (PSWA,24),          PROGRAM STATUS WORDS        @D35UGGB*
               (PSWB,24),                                      @D35UGGB*
               (PSWC,16)                                       @D35UGGB
         SPACE 2                                               @D35UGGB
         DSGEN (SUBCD,1,0,7),      SUBCLASS CODES              @D35UGGB*
               (SUBCODE,8,EQU,SUBCD0),   BITS 0-7  OVERLAY     @D35UGGB*
               (TNSCD,1,0,7),      TENSE CODES                 @D35UGGB*
               (STPVB,1,0,7),      STORAGE ERROR/PSW VALIDITY BITS     *
               (VLDCD,1,0,7),      MISC.VALIDITY CODES         @D35UGGB*
               (RES5,16),          RESERVED                    @D35UGGB*
               (EXTLOG,16),        EXTENDED LOGOUT LENGTH      @D35UGGB*
               (RES6,64),          RESERVED                    @D35UGGB*
               (FSA,32),           FAILING STORAGE ADDRESS     @D35UGGB*
               (CWA0,8),           BYTE 0                      @D35UGGB*
               (CWA1,8),           BYTE 1                      @D35UGGB*
               (CWA,16,EQU,CWA0),  2 BYTE DATA                 @D35UGGB*
               (ECC,16)                                        @D35UGGB
         SPACE 2                                               @D35UGGB
*                                                              @D35UGGB
REC2     EQU   *                                               @D35UGGB
*                                                              @D35UGGB
*                                                              @D35UGGB
         SPACE 2                                               @D35UGGB
         DSGEN (CPUCK080,1),       BIT 0 - BYTE 0 - CPU CHECKS @D35UGGB*
               (CPUCK040,1),       BIT 1                       @D35UGGB*
               (CPUCK020,1),       BIT 2                       @D35UGGB*
               (CPUCK010,1),       BIT 3                       @D35UGGB*
               (CPUCK008,1),       BIT 4                       @D35UGGB*
               (CPUCK004,1),       BIT 5                       @D35UGGB*
               (CPUCK002,1),       BIT 6                       @D35UGGB*
               (CPUCK001,1),       BIT 7                       @D35UGGB*
               (CPUCK0FF,8,EQU,CPUCK080),  BITS 1-7  BYTE 0  OVERLAY   *
               (CPUCK180,1),       BIT 0 - BYTE 1 - CPU CHECKS @D35UGGB*
               (CPUCK140,1),       BIT 1                       @D35UGGB*
               (CPUCK120,1),       BIT 2                       @D35UGGB*
               (CPUCK110,1),       BIT 3                       @D35UGGB*
               (CPUCK108,1),       BIT 4                       @D35UGGB*
               (CPUCK104,1),       BIT 5                       @D35UGGB*
               (CPUCK102,1),       BIT 6                       @D35UGGB*
               (CPUCK101,1),       BIT 7                       @D35UGGB*
               (CPUCK1FF,8,EQU,CPUCK180),  BITS 0-7  BYTE 1  OVERLAY   *
               (CPUCK280,1),       BIT 0 - BYTE 2 - CPU CHECKS @D35UGGB*
               (CPUCK240,1),       BIT 1                       @D35UGGB*
               (CPUCK220,1),       BIT 2                       @D35UGGB*
               (CPUCK210,1),       BIT 3                       @D35UGGB*
               (CPUCK208,1),       BIT 4                       @D35UGGB*
               (CPUCK204,1),       BIT 5                       @D35UGGB*
               (CPUCK202,1),       BIT 6                       @D35UGGB*
               (CPUCK201,1),       BIT 7                       @D35UGGB*
               (CPUCK2FF,8,EQU,CPUCK280),  BITS 1-7  BYTE 2  OVERLAY   *
               (CPUCK380,1),       BIT 0 - BYTE 3 - CPU CHECKS @D35UGGB*
               (CPUCK340,1),       BIT 1                       @D35UGGB*
               (CPUCK320,1),       BIT 2                       @D35UGGB*
               (CPUCK310,1),       BIT 3                       @D35UGGB*
               (CPUCK308,1),       BIT 4                       @D35UGGB*
               (CPUCK304,1),       BIT 5                       @D35UGGB*
               (CPUCK302,1),       BIT 6                       @D35UGGB*
               (CPUCK301,1),       BIT 7                       @D35UGGB*
               (CPUCK3FF,8,EQU,CPUCK380)   BITS 1-7  BYTE 3  OVERLAY
         SPACE 2                                               @D35UGGB
*                                                              @D35UGGB
         DSGEN (BAR,16)             BUFFER ADDRESS REGESTER (1 BYTE)
         SPACE 2                                               @D35UGGB
*                                                              @D35UGGB
         DSGEN (ZONER080,1),       BIT 0    BYTE 0 ZONE IN ERROR (2)   *
               (ZONER070,3),       BITS 1-3                    @D35UGGB*
               (ZONER00F,4),       BITS 4-7                    @D35UGGB*
               (ZONERR,8,EQU,ZONER080),     BITS 0-7  BYTE 1,OVERLAY   *
               (ZONER1FF,8)        BITS 1-7 BYTE 1  ZONE IN ERROR
         SPACE 2                                               @D35UGGB
*                                                              @D35UGGB
         DSGEN (SAR,16)             STORAGE ADDRESS REGISTER (1 BYTE)
         SPACE 2                                               @D35UGGB
*                                                              @D35UGGB
         DSGEN (RTRYLT80,1),       BIT 0 - RETRY THRESHOLD LATCHES (1) *
               (RTRYLT40,1),       BIT 1                       @D35UGGB*
               (RTRYLT20,1),       BIT 2                       @D35UGGB*
               (RTRYLT10,1),       BIT 3                       @D35UGGB*
               (RTRYLT08,1),       BIT 4                       @D35UGGB*
               (RTRYLT04,1),       BIT 5                       @D35UGGB*
               (RTRYLT02,1),       BIT 6                       @D35UGGB*
               (RTRYLT01,1)        BIT 7                       @D35UGGB
         SPACE 2                                               @D35UGGB
*                                                              @D35UGGB
         DSGEN (RTRYFL80,1),       BIT 0 - RETRY FLAG/COUNT (1)        *
               (RTRYFL70,3),       BITS 1-3 BYTE 0             @D35UGGB*
               (RTRYFL0F,4),       BITS 4-7 BYTE 0             @D35UGGB*
               (RTRYFLAG,8,EQU,RTRYFL80)   BITS 0-7  OVERLAY   @D35UGGB
         SPACE 2                                               @D35UGGB
*                                                              @D35UGGB
         DSGEN (INTRL080,1),       BIT 0 - BYTE 0  INTERRUPT STATUS    *
               (INTRL040,1),       BIT 1           LATCHES (2 BYTES)   *
               (INTRL020,1),       BIT 2                       @D35UGGB*
               (INTRL010,1),       BIT 3                       @D35UGGB*
               (INTRL008,1),       BIT 4                       @D35UGGB*
               (INTRL004,1),       BIT 5                       @D35UGGB*
               (INTRL002,1),       BIT 6                       @D35UGGB*
               (INTRL001,1),       BIT 7                       @D35UGGB*
               (INTRL180,1),       BIT 0 - BYTE 1  INTERRUPT STATUS    *
               (INTRL140,1),       BIT 1                       @D35UGGB*
               (INTRL120,1),       BIT 2                       @D35UGGB*
               (INTRL110,1),       BIT 3                       @D35UGGB*
               (INTRL108,1),       BIT 4                       @D35UGGB*
               (INTRL104,1),       BIT 5                       @D35UGGB*
               (INTRL102,1),       BIT 6                       @D35UGGB*
               (INTRL101,1)        BIT 7                       @D35UGGB
         SPACE 2                                               @D35UGGB
*                                                              @D35UGGB
         DSGEN (NOTUSED,48)        NOT USED/RESERVED (6 BYTES) @D35UGGB
         SPACE 2                                               @D35UGGB
*                                                              @D35UGGB
         DSGEN (ICA,8),            ICA CHECK BYTE (1 BYTE)     @D35UGGB*
               (SEL1CH,8),         FIRST SELECTOR CHANNEL      @D35UGGB*
               (IFA,8),            I.F.A.  (1 BYTE)            @D35UGGB*
               (SEL2CH,8)          SECOND SELECTOR CHANNEL     @D35UGGB
         SPACE 2                                               @D35UGGB
*                                                              @D35UGGB
         DSGEN (RES2,576)          RESERVED (72 BYTES)         @D35UGGB
*                                  CCH RECORD DATA GOES HERE   @D35UGGB
         SPACE 2                                               @D35UGGB
*                                                              @D35UGGB
REC3     EQU   *                                               @D35UGGB
*                                                              @D35UGGB
         SPACE 2                                               @D35UGGB
*                                                              @D35UGGB
         DSGEN (FPR0,32),(FPR1,32),   REG 0-FLOATING POINT REGISTERS   *
               (FPR2,32),(FPR3,32),   REG 2                    @D35UGGB*
               (FPR4,32),(FPR5,32),   REG 4                    @D35UGGB*
               (FPR6,32),(FPR7,32)    REG 6                    @D35UGGB
         SPACE 2                                               @D35UGGB
         DSGEN (GPR0,32),                GPR 0-GENERAL PURPOSE @D35UGGB*
               (GPR1,32),                GPR 1                 @D35UGGB*
               (GPR2,32),                GPR 2                 @D35UGGB*
               (GPR3,32),                GPR 3                 @D35UGGB*
               (GPR4,32),                GPR 4                 @D35UGGB*
               (GPR5,32),                GPR 5                 @D35UGGB*
               (GPR6,32),                GPR 6                 @D35UGGB*
               (GPR7,32),                GPR 7                 @D35UGGB*
               (GPR8,32),                GPR 8                 @D35UGGB*
               (GPR9,32),                GPR 9                 @D35UGGB*
               (GPR10,32),               GPR 10/A              @D35UGGB*
               (GPR11,32),               GPR 11/B              @D35UGGB*
               (GPR12,32),               GPR 12/C              @D35UGGB*
               (GPR13,32),               GPR 13/D              @D35UGGB*
               (GPR14,32),               GPR 14/E              @D35UGGB*
               (GPR15,32)                GPR 15/F              @D35UGGB
         SPACE 2                                               @D35UGGB
         DSGEN (CR0,32),           CONTROL REGISTERS           @D35UGGB*
               (CR1,32),           REG 1                       @D35UGGB*
               (CR2,32),           REG 2                       @D35UGGB*
               (CR3,32),           REG 3                       @D35UGGB*
               (CR4,32),           REG 4                       @D35UGGB*
               (CR5,32),           REG 5                       @D35UGGB*
               (CR6,32),           REG 6                       @D35UGGB*
               (CR7,32),           REG 7                       @D35UGGB*
               (CR8,32),           REG 8                       @D35UGGB*
               (CR9,32),           REG 9                       @D35UGGB*
               (CR10,32),          REG 10/A                    @D35UGGB*
               (CR11,32),          REG 11/B                    @D35UGGB*
               (CR12,32),          REG 12/C                    @D35UGGB*
               (CR13,32),          REG 13/D                    @D35UGGB*
               (CR14,32),          REG 14/E                    @D35UGGB*
               (CR15,32)           REG 15/F                    @D35UGGB
         SPACE 2                                               @D35UGGB
         ORG   SUBCD0                                          @D35UGGB
         DSGEN (DLOG,32,0,5,0,11)  MACHINE CHECK LOGOUT        @D35UGGB
         EJECT                                                 @D35UGGB
*                                                              @D35UGGB
** EQUATES:                                                          *
*                                                              @D35UGGB
         SPACE 2                                               @D35UGGB
CED      EQU   X'04'               EXTERNAL DAMAGE             @D35UGGB
CES      EQU   X'3B'               EXTERNAL SIGNAL             @D35UGGB
CIN      EQU   X'80'               INTERRUPT                   @D35UGGB
CTF      EQU   X'3A'               TIMER FACILITIES            @D35UGGB
  EJECT                                                        @D35UGGB
*                                                              @D35UGGB
*          DECLARE BASE REGISTERS                              @D35UGGB
*                                                              @D35UGGB
         SPACE 2                                               @D35UGGB
&CSECT   CSECT                                                 @D35UGGB
         SPACE 2                                               @D35UGGB
*                                                              @D35UGGB
*          DECLARES                                            @D35UGGB
*                                                              @D35UGGB
         SPACE 2                                               @D35UGGB
CBM      DC    X'00F0'             BYTE MULTIPLEXER            @D35UGGB
CND      DC    X'0100'             TIMER FACILITIES            @D35UGGB
CNT      DC    X'0200'             NATIVE TAPE                 @D35UGGB
CRD      DC    X'000E'             CARD DEVICES                @D35UGGB
CTP      DC    X'0020'             TELE-PROCESSING             @D35UGGB
CVD      DC    X'001F'             DEVICE                      @D35UGGB
XSAVE    DC    4F'0'                                           @D35UGGB
MSG590   DC    C'DAMAGE DURING I/O INSTRUCTION'                @D35UGGB
MSG591   DC    C'DAMAGE DURING INTERRUPT HANDLING'             @D35UGGB
MSG592   DC    C'TIMER FACILITIES'                             @D35UGGB
MSG593   DC    C'EXTERNAL SIGNALS'                             @D35UGGB
MSG594   DC    C'DEVICE'                                       @D35UGGB
MSG595   DC    C'CARD I/O - PRINTER'                           @D35UGGB
MSG596   DC    C'VIDEO CONSOLE'                                @D35UGGB
MSG597   DC    C'TELE-COMMUNICATION'                           @D35UGGB
MSG598   DC    C'REAL BYTE MULTIPLEXER'                        @D35UGGB
MSG599   DC    C'NATIVE DISK'                                  @D35UGGB
MSG59A   DC    C'NATIVE TAPE'                                  @D35UGGB
MSG59B   DC    C'NOT APPLICABLE'                               @D35UGGB
MSG160   DC    C'--- I/O CHECKS ---'                           @D35UGGB
MSG161   DC    C'ERROR        ZONE'                            @D35UGGB
  EJECT                                                        @D35UGGB
*                                                              @D35UGGB
*         SPECIAL ROUTINE SECTION                              @D35UGGB
*                                                              @D35UGGB
         SPACE 2                                               @D35UGGB
ADV52    DS    0H                                              @D35UGGB
         LA    R3,52(R3)                                       @D35UGGB
ADVANCE  BR    R14                                             @D35UGGB
         SPACE 2                                               @D35UGGB
ASTRK72  DS    0H                                              @D35UGGB
         MVI   0(R3),C'*'                                      @D35UGGB
         MVC   1(71,R3),0(R3)                                  @D35UGGB
         BR    R14                                             @D35UGGB
         SPACE 2                                               @D35UGGB
ASTRK120 DS    0H                                              @D35UGGB
         MVI   0(R3),C'*'                                      @D35UGGB
         MVC   1(119,R3),0(R3)                                 @D35UGGB
         BR    R14                                             @D35UGGB
         SPACE 2                                               @D35UGGB
WRKZONE  ST    R5,XSAVE                                        @D35UGGB
         IC    R5,ZONERR                                       @D35UGGB
         SLL   R5,25                                           @D35UGGB
         SRL   R5,29                                           @D35UGGB
         STC   R5,NOTUSED                                      @D35UGGB
         L     R5,XSAVE                                        @D35UGGB
         BR    R14                                             @D35UGGB
         SPACE 2                                               @D35UGGB
SETID    MVC   0(8,R3),0(R4)                                   @D35UGGB
         BR    R14                                             @D35UGGB
         SPACE 3                                               @D35UGGB
SETDATE  UNPK  WORKX(5),DATE+1(3)                              @D35UGGB
         MVC   0(3,R3),WORKX+2                                 @D35UGGB
         MVC   6(2,R3),WORKX                                   @D35UGGB
         BR    R14                                             @D35UGGB
         SPACE 3                                               @D35UGGB
WORKX    DC    D'0'                                            @D35UGGB
         SPACE 2                                               @D35UGGB
*                                                              @D35UGGB
CHKITOUT EQU   *                                               @D35UGGB
ED       TM    SUBCODE,CED              X'04' - EXTERNAL DAMAGE ?
         BO    TF                       YES-BRANCH             @D35UGGB
         MVC   0(L'MSG59B,R3),MSG59B    'NOT APPLICABLE'       @D35UGGB
         BR    R14                      RETURN                 @D35UGGB
TF       CLI   CWA1,CTF                 X'3A' - TIMER FACILITIES ?
         BNE   ES                       NO-BRANCH              @D35UGGB
         MVC   0(L'MSG592,R3),MSG592    'TIMER FACILITIES'     @D35UGGB
         BR    R14                      RETURN                 @D35UGGB
ES       CLI   CWA1,CES                 X'3B' - EXTERNAL SIGNAL ?
         BNE   IN                       NO-BRANCH              @D35UGGB
         MVC   0(L'MSG593,R3),MSG593    YES  'EXTERNAL SIGNALS'
         BR    R14                      RETURN                 @D35UGGB
IN       TM    CWA0,CIN                 X'80' - DAMAGE ON INTERRUPT ?
         BNO   IO                       NO-CONTINUE PROCESSING @D35UGGB
         MVC   0(L'MSG591,R3),MSG591    YES-'DAMAGE DURING INTERRUPT'
         B     EXTB                     NO-CONTINUE PROCESSING @D35UGGB
IO       MVC   0(L'MSG590,R3),MSG590    YES  'DAMAGE DURING I/O INST.'
EXTB     LA    R3,40(R3)                ADVANCE COLUMN PTR.    @D35UGGB
         NI    CWA,X'7F'                RESET INTERRUPT SWITCH @D35UGGB
         CLC   CWA(2),CRD               X'000E' - CARD DEVICES ?
         BNE   VD                       NO-BRANCH              @D35UGGB
         MVC   0(L'MSG595,R3),MSG595    YES  'CARD I/O-PRINTER'
         BR    R14                      RETURN                 @D35UGGB
VD       CLC   CWA(2),CVD           X'001F' - VIDEO CONSOLE DAMAGE?
         BNE   TP                       NO-BRANCH              @D35UGGB
         MVC   0(L'MSG596,R3),MSG596    YES  'VIDEO CONSOLE'   @D35UGGB
         BR    R14                      RETURN                 @D35UGGB
TP       CLC   CWA(2),CTP           X'0020' - TELE-PROCESSING ?
         BNE   BM                       NO-BRANCH              @D35UGGB
         MVC   0(L'MSG597,R3),MSG597    YES  'TELE COMMUNICATION'
         BR    R14                      RETURN                 @D35UGGB
BM       CLC   CWA(2),CBM           X'00F0' - BYTE MULTIPLEXER ?
         BNE   ND                       NO-BRANCH              @D35UGGB
         MVC   0(L'MSG598,R3),MSG598    YES  'REAL BYTE MULTIPLEXER'
         BR    R14                      RETURN                 @D35UGGB
ND       CLC   CWA(2),CND           NATIVE DISK ?              @D35UGGB
         BNE   NT                       NO-BRANCH              @D35UGGB
         MVC   0(L'MSG599,R3),MSG599    YES  'NATIVE DISK'     @D35UGGB
         BR    R14                      RETURN                 @D35UGGB
NT       CLC   CWA(2),CNT           NATIVE TAPE ?              @D35UGGB
         BNE   DV                       NO-BRANCH              @D35UGGB
         MVC   0(L'MSG59A,R3),MSG59A    YES  'NATIVE TAPE'     @D35UGGB
         BR    R14                      RETURN                 @D35UGGB
DV       MVC   0(L'MSG594,R3),MSG594    'DEVICE'               @D35UGGB
         LA    R3,15(R3)                                       @D35UGGB
*                                                              @D35UGGB
*   CONVERT 4 HEX BYTES TO EBCIDIC                             @D35UGGB
*                                                              @D35UGGB
BRCNT    STM   R5,R8,XSAVE         SAVE                        @D35UGGB
         LA    R4,20(R4)                                       @D35UGGB
         ICM   R7,B'1100',L0(R4)   GET CHARS TO CONVERT        @D35UGGB
         LA    R5,L4               PRINT OUT 4 CHARACTORS      @D35UGGB
LPBRCNT  XR    R6,R6               CLEAR REG                   @D35UGGB
         SLDL  R6,L4               GET HIGH ORDER 1/2 BYTE     @D35UGGB
         LA    R6,CHARS(R6)        INDEX INTO CHARACTER LIST   @D35UGGB
         MVC   L0(L1,R3),L0(R6)    MOVE CHARACTER TO OUTPUT    @D35UGGB
         LA    R3,L1(R3)           NEXT OUTPUT POSITION        @D35UGGB
         BCT   R5,LPBRCNT          REPEAT                      @D35UGGB
         LM    R5,R8,XSAVE         RESTORE REGS                @D35UGGB
         BR    R14                 RETURN                      @D35UGGB
CHARS    DC    C'0123456789ABCDEF'                             @D35UGGB
         SPACE 2                                               @D35UGGB
**----------------------------PATCH AREA-----------------------------**
         DC    S(PATCH)                                        @D35UGGB
PATCH    DC    5CL11'PATCH AREA '                              @D35UGGB
   EJECT                                                       @D35UGGB
*                                                              @D35UGGB
*          LINE/LABEL INSTRUCTION LIST                         @D35UGGB
*                                                              @D35UGGB
         SPACE 2                                               @D35UGGB
         ENTRIES PAGE                                          @D35UGGB
         LINE  (1,1),(44,1),SKIP=2                             @D35UGGB
         LABEL '--- MACHINE CHECK DATA EDITING ---'            @D35UGGB
         SPACE 2                                               @D35UGGB
         LINE  (1,1),(1,1),SKIP=3                              @D35UGGB
       ROUTINE NOTUSED,ASTRK120                                @D35UGGB
         LABEL ''                                              @D35UGGB
         SPACE 2                                               @D35UGGB
         LINE  (36,32),(1,10),SKIP=2                           @D35UGGB
         HEX   (SERIAL,0,3B)                                   @D35UGGB
         ROUTINE JOBID,SETID                                   @D35UGGB
         ROUTINE PROGID,SETID                                  @D35UGGB
         LABEL 'MODEL 0125',,'SERIAL NUMBER',,,'JOB IDENTITY -',,,     *
               'PROGRAM IDENTITY -'                            @D35UGGB
         SPACE 2                                               @D35UGGB
         LINE  ,(75,20),SKIP=1                                 @D35UGGB
         LABEL 'DAY  YEAR','HH MM SS'                          @D35UGGB
         SPACE 2                                               @D35UGGB
         LINE  (75,20),(68,20),SKIP=1                          @D35UGGB
         ROUTINE DATE,SETDATE                                  @D35UGGB
         HEX   (TIME,1,3B)                                     @D35UGGB
         LABEL 'DATE -','TIME -'                               @D35UGGB
         SPACE 2                                               @D35UGGB
         LINE  ,(25,1),SKIP=1                                  @D35UGGB
         LABEL 'SM KS  IC  CM   IA'                            @D35UGGB
         SPACE 2                                               @D35UGGB
         LINE  (25,8),(1,1),SKIP=3                             @D35UGGB
         HEX   (PSWA,1,3B),(PSWB,1,3B),(PSWC,0,2B)             @D35UGGB
         LABEL 'OLD MACHINE CHECK PSW'                         @D35UGGB
         SPACE 2                                               @D35UGGB
         LINE  (24,1),(1,1),SKIP=3                             @D35UGGB
       ROUTINE NOTUSED,ASTRK72                                 @D35UGGB
         LABEL ''                                              @D35UGGB
         SPACE 2                                               @D35UGGB
         LINE  ,(26,1),SKIP=2                                  @D35UGGB
         LABEL '--- MACHINE CHECK INTERRUPT CODE ---'          @D35UGGB
         SPACE 2                                               @D35UGGB
         LINE  ,(10,1),SKIP=2                                  @D35UGGB
         LABEL '--- SUB CLASS ---'                             @D35UGGB
         SPACE 2                                               @D35UGGB
         LINE  (24,55),(1,55),SKIP=1                           @D35UGGB
         BIN   (SUBCD0),(SUBCD4)                               @D35UGGB
         LABEL 'SYSTEM DAMAGE (SD)','CLOCK DAMAGE (CD)'        @D35UGGB
         SPACE 2                                               @D35UGGB
         LINE  ,                                               @D35UGGB
         BIN   (SUBCD1),(SUBCD5)                               @D35UGGB
         LABEL 'PROC. DAMAGE (PD)','EXTERNAL DAMAGE (ED)'      @D35UGGB
         SPACE 2                                               @D35UGGB
         LINE  ,                                               @D35UGGB
         BIN   (SUBCD2),(SUBCD7)                               @D35UGGB
         LABEL 'SYSTEM RECOVERY (SR)','AUTO-CONFIG (AC)'       @D35UGGB
         SPACE 2                                               @D35UGGB
         LINE  ,,SKIP=2                                        @D35UGGB
         BIN   (SUBCD3),(TNSCD3)                               @D35UGGB
         LABEL 'TIMER DAMAGE (TD)','WARNING (W)'               @D35UGGB
         SPACE 2                                               @D35UGGB
         LINE  ,(28,1),SKIP=2                                  @D35UGGB
         LABEL '--- INTERRUPT TENSE CODES ---'                 @D35UGGB
         SPACE 2                                               @D35UGGB
         LINE  ,(1,55),SKIP=2                                  @D35UGGB
         BIN   (TNSCD6),(TNSCD7)                               @D35UGGB
         LABEL 'BACK-UP (B)','DELAYED (D)'                     @D35UGGB
         SPACE 2                                               @D35UGGB
         LINE  ,(24,1),SKIP=2                                  @D35UGGB
         LABEL '--- STORAGE AND PROTECTION ERROR CODES ---'    @D35UGGB
         SPACE 2                                               @D35UGGB
         LINE  (36,58),(1,55),SKIP=1                           @D35UGGB
         BIN   (STPVB0),(STPVB2)                               @D35UGGB
         LABEL 'UNCORRECTED STORAGE ERRORS (SE)','UNCORRECTED PROTECTIO*
               N ERRORS (PE)'                                  @D35UGGB
         SPACE 2                                               @D35UGGB
         LINE  ,,SKIP=2                                        @D35UGGB
         BIN   (STPVB1)                                        @D35UGGB
         LABEL 'CORRECTED STORAGE ERRORS (SC)'                 @D35UGGB
         SPACE 2                                               @D35UGGB
         LINE  ,(36,1),SKIP=2                                  @D35UGGB
         LABEL '--- PSW VALIDITY CODES ---'                    @D35UGGB
         SPACE 2                                               @D35UGGB
         LINE  (41,55),(1,55),SKIP=1                           @D35UGGB
         BIN   (STPVB4),(STPVB5)                               @D35UGGB
         LABEL 'AMWP BITS OF M.C. OLD ARE VALID (WP)','SYSTEM MASK OF M*
               .C. OLD IS VALID (MS)'                          @D35UGGB
         SPACE 2                                               @D35UGGB
         LINE  ,,SKIP=2                                        @D35UGGB
         BIN   (STPVB6),(STPVB7)                               @D35UGGB
         LABEL 'PROGRAM MASK OF M.C. OLD IS VALID (PM)','INSTR ADDR OF *
               M.C. OLD IS VALID (IA)'                         @D35UGGB
         SPACE 2                                               @D35UGGB
         LINE  ,(34,1),SKIP=2                                  @D35UGGB
         LABEL '--- MISC VALIDITY CODES ---'                   @D35UGGB
         SPACE 2                                               @D35UGGB
         LINE  (39,52),(1,55),SKIP=1                           @D35UGGB
         BIN   (VLDCD0),(VLDCD1)                               @D35UGGB
         LABEL 'FAILING STORAGE ADDR IS VALID (FA)','REGION CODE IS VAL*
               ID (RC)'                                        @D35UGGB
         SPACE 2                                               @D35UGGB
         LINE  ,                                               @D35UGGB
         BIN   (VLDCD3),(VLDCD4)                               @D35UGGB
         LABEL 'FP REGS STORED ARE VALID (FP)','GP REGS STORED ARE VALI*
               D (GP)'                                         @D35UGGB
         SPACE 2                                               @D35UGGB
         LINE  ,                                               @D35UGGB
         BIN   (VLDCD5),(VLDCD6)                               @D35UGGB
         LABEL 'CONTROL REGS STORED ARE VALID (CR)','EXTENDED LOGOUT AR*
               EA IS VALID (LG)'                               @D35UGGB
         SPACE 2                                               @D35UGGB
         LINE  ,,SKIP=2                                        @D35UGGB
         BIN   VLDCD7                                          @D35UGGB
         LABEL 'INSTR MODIFIED STORAGE IS VALID (ST)'          @D35UGGB
         SPACE 2                                               @D35UGGB
         LINE  (34,54),(1,59),SKIP=2                           @D35UGGB
         HEX   (EXTLOG,0,2B),(FSA,0,4B)                        @D35UGGB
         LABEL 'EXTENDED LOGOUT LENGTH','FAILING STORAGE ADDRESS'
         SPACE 2                                               @D35UGGB
         LINE  ,(37,1),SKIP=2                                  @D35UGGB
         LABEL '--- REGION CODE ---'                           @D35UGGB
  SPACE 2                                                      @D35UGGB
         LINE  (1,1),(1,1),SKIP=3                              @D35UGGB
       ROUTINE SUBCODE,CHKITOUT          TEST FOR 125 EXTERNAL DAMAGE
         LABEL ''                                              @D35UGGB
  SPACE 2                                                      @D35UGGB
         LINE  (24,1),(1,1)                                    @D35UGGB
       ROUTINE NOTUSED,ASTRK72                                 @D35UGGB
         LABEL ''                                              @D35UGGB
  SPACE 2                                                      @D35UGGB
         LINE  ,,SKIP=E                                        @D35UGGB
         LABEL ''                                              @D35UGGB
  SPACE 2                                                      @D35UGGB
         LINE  (1,1),(44,1),SKIP=2                             @D35UGGB
         LABEL '--- MACHINE CHECK DATA EDITING ---'            @D35UGGB
         SPACE 2                                               @D35UGGB
         LINE  ,(1,1)                ,  MSG010                 @D35UGGB
         LABEL '--- CPU INDEPENDENT LOGOUT ---'                @D35UGGB
  SPACE 2                                                      @D35UGGB
         LINE  ,(15,60),SKIP=1       ,  MSG020,021             @D35UGGB
         LABEL '--- CPU CHECKS 0 ---','--- CPU CHECKS 1 ---'   @D35UGGB
  SPACE 2                                                      @D35UGGB
         LINE  (21,30),(1,30)        ,  MSG022,030,040,600     @D35UGGB
         BIN   CPUCK080                                        @D35UGGB
         BIN   CPUCK180                                        @D35UGGB
         BIN   CPUCK280                                        @D35UGGB
         BIN   CPUCK380                                        @D35UGGB
         LABEL 'EARLY CHECK','BUS IN','ALU BYTE 0','SPARE'     @D35UGGB
  SPACE 2                                                      @D35UGGB
         LINE  ,                     ,  MSG023,031,041,074     @D35UGGB
         BIN   CPUCK040                                        @D35UGGB
         BIN   CPUCK140                                        @D35UGGB
         BIN   CPUCK240                                        @D35UGGB
         BIN   CPUCK340                                        @D35UGGB
         LABEL 'LATE CHECK','DISPLAY BUS BYTE 0','ALU BYTE 1','ALU AUX'
  SPACE 2                                                      @D35UGGB
         LINE  ,                     ,  MSG032,075,042,052     @D35UGGB
         BIN   CPUCK020                                        @D35UGGB
         BIN   CPUCK120                                        @D35UGGB
         BIN   CPUCK220                                        @D35UGGB
         BIN   CPUCK320                                        @D35UGGB
         LABEL 'STOR INPUT DATA','ALU SHIFT','ALU CONTROLS',   @D35UGGB*
               'PROTECTION KEY'                                @D35UGGB
  SPACE 2                                                      @D35UGGB
         LINE  ,                     ,  MSG025,033,043,053     @D35UGGB
         BIN   CPUCK010                                        @D35UGGB
         BIN   CPUCK110                                        @D35UGGB
         BIN   CPUCK210                                        @D35UGGB
         BIN   CPUCK310                                        @D35UGGB
         LABEL 'WS OUTPUT','SINGLE ERROR','T CARD','STORAGE KEY'       *
               'PROTECTION KEY'                                @D35UGGB
  SPACE 2                                                      @D35UGGB
         LINE  ,                     ,  MSG026,034,044,054     @D35UGGB
         BIN   CPUCK008                                        @D35UGGB
         BIN   CPUCK108                                        @D35UGGB
         BIN   CPUCK208                                        @D35UGGB
         BIN   CPUCK308                                        @D35UGGB
         LABEL 'SELECT LATCHES','DOUBLE ERROR','CDR DECODE',   @D35UGGB*
               'FIELD LENGTH CTR'                              @D35UGGB
  SPACE 2                                                      @D35UGGB
         LINE  ,                     ,  MSG027,035,045,601     @D35UGGB
         BIN   CPUCK004                                        @D35UGGB
         BIN   CPUCK104                                        @D35UGGB
         BIN   CPUCK204                                        @D35UGGB
         BIN   CPUCK304                                        @D35UGGB
         LABEL 'WSAR','ECC ADDR CHECK','BRANCH DECODE','RESERVED'
  SPACE 2                                                      @D35UGGB
         LINE  ,                     ,  MSG028,036,046,601     @D35UGGB
         BIN   CPUCK002                                        @D35UGGB
         BIN   CPUCK102                                        @D35UGGB
         BIN   CPUCK202                                        @D35UGGB
         BIN   CPUCK302                                        @D35UGGB
         LABEL 'ASAR','CPU SAR CHECK','MICROPROGRAM','RESERVED'
  SPACE 2                                                      @D35UGGB
         LINE  ,,SKIP=2              ,  MSG024,037             @D35UGGB
         BIN   CPUCK001                                        @D35UGGB
         BIN   CPUCK101                                        @D35UGGB
         LABEL 'DISPLAY BUS BYTE 1','MS LAST ACCESS BIT'       @D35UGGB
  SPACE 2                                                      @D35UGGB
         LINE  ,(3,1)                                          @D35UGGB
         LABEL '--- CPU CHECKS ---'                            @D35UGGB
  SPACE 2                                                      @D35UGGB
         LINE  (78,28),(61,30)                                 @D35UGGB
         HEX   BAR,0,2B                                        @D35UGGB
         HEX   ZONER1FF,0,1R                                   @D35UGGB
         HEX   SAR,B26,2B                                      @D35UGGB
         LABEL 'BAR','SAR + EXIT'                              @D35UGGB
  SPACE 2                                                      @D35UGGB
         LINE  ,(3,10)                                         @D35UGGB
         LABEL 'CHECKS 0','CHECKS 1'                           @D35UGGB
  SPACE 2                                                      @D35UGGB
         LINE  (4,5),(61,1),SKIP=1                             @D35UGGB
         HEX   CPUCK0FF,0,1B                                   @D35UGGB
         HEX   CPUCK1FF,B1,1B                                  @D35UGGB
         HEX   CPUCK2FF,0,1B                                   @D35UGGB
         HEX   CPUCK3FF,B1,1B                                  @D35UGGB
       ROUTINE NOTUSED,ADV52            ADVANCE COLUMN PTR.    @D35UGGB
         BIN   ZONER080           ,  BIT 0 BYTE 0 ZONERR       @D35UGGB
        LABEL  'CYCLE STEAL'                                   @D35UGGB
  SPACE 2                                                      @D35UGGB
        LINE (79,1)                                            @D35UGGB
      ROUTINE ZONERR,WRKZONE                                   @D35UGGB
        HEX    NOTUSED,0,1R                                    @D35UGGB
        LABEL 'CYCLE STEAL ZONE'                               @D35UGGB
  SPACE 2                                                      @D35UGGB
        LINE  (80,1),,SKIP=2                                   @D35UGGB
        HEX  ZONERR,0,1R           ,  BITS 4-7 BYTE 0          @D35UGGB
        LABEL 'DATA FLOW ZONE'                                 @D35UGGB
  SPACE 2                                                      @D35UGGB
        LINE   ,(1,32)                                         @D35UGGB
        LABEL  '--- RETRY THRESHOLD ---','--- CPU RETRY ---',  @D35UGGB*
               '      --- INTERRUPT STATUS LATCHES ---'        @D35UGGB
  SPACE 2                                                      @D35UGGB
        LINE  (21,30),(1,30),SKIP=1                            @D35UGGB
        BIN   RTRYLT80                                         @D35UGGB
        BIN   RTRYFL80                                         @D35UGGB
        BIN   INTRL080                                         @D35UGGB
        BIN   INTRL180                                         @D35UGGB
        LABEL  'GPR/STOR ALTERED','CPU RETRY FLAG',            @D35UGGB*
               'HRT OVERFLOW LATCH','TIMER ENABLED'            @D35UGGB
  SPACE 2                                                      @D35UGGB
        LINE  ,                     ,  MSG094,101,111,121      @D35UGGB
        BIN   RTRYLT40                                         @D35UGGB
        HEX   RTRYFLAG,B1,1R                                   @D35UGGB
        BIN   INTRL040                                         @D35UGGB
        BIN   INTRL140                                         @D35UGGB
       LABEL 'SYSTEM DAMAGE','UNSUCCESSFUL','NEW BYTE 83','START LATCH'
  SPACE 2                                                      @D35UGGB
        LINE  ,                      ,  MSG095,102,112,122     @D35UGGB
        BIN   RTRYLT20                                         @D35UGGB
     ROUTINE  NOTUSED,ADVANCE             ADVANCE LINE PTR. 30 COLUMNS
        BIN   INTRL020                                         @D35UGGB
        BIN   INTRL120                                         @D35UGGB
       LABEL 'PSW/CR ALTERED','  RETRY','PER REQUEST',         @D35UGGB*
               'M/C CHECK THRESHOLD'                           @D35UGGB
  SPACE 2                                                      @D35UGGB
       LINE  ,                       ,  MSG096,103,113,123     @D35UGGB
       BIN   RTRYLT10                                          @D35UGGB
    ROUTINE NOTUSED,ADVANCE               ADVANCE LINE PTR. 30 COLUMNS
       BIN   INTRL010                                          @D35UGGB
       BIN   INTRL110                                          @D35UGGB
       LABEL 'SECOND ERROR','  COUNT','SUCCESSFUL BRANCH','IC DUMPED'
  SPACE 2                                                      @D35UGGB
       LINE  ,                       ,  MSG097,114,124         @D35UGGB
       BIN   RTRYLT08                                          @D35UGGB
    ROUTINE NOTUSED,ADVANCE               ADVANCE LINE PTR. 30 COLUMNS
       BIN   INTRL008                                          @D35UGGB
       BIN   INTRL108                                          @D35UGGB
       LABEL 'PER ZONE 1',' ','RESTART BUTTON','ALTER/DISPLAY REQ'
  SPACE 2                                                      @D35UGGB
       LINE  ,                       ,  MSG0601,115,125        @D35UGGB
       BIN   RTRYLT04                                          @D35UGGB
     ROUTINE NOTUSED,ADVANCE              ADVANCE LINE PTR. 30 COLUMNS
       BIN   INTRL004                                          @D35UGGB
       BIN   INTRL104                                          @D35UGGB
       LABEL 'RESERVED',' ','STOP LATCH','MANUAL STATE'        @D35UGGB
  SPACE 2                                                      @D35UGGB
       LINE  (81,30),(61,30)         ,  MSG116,126             @D35UGGB
       BIN   INTRL002                                          @D35UGGB
       BIN   INTRL102                                          @D35UGGB
       LABEL 'PRI SAMPLE','PER LOG LATCH'                      @D35UGGB
  SPACE 2                                                      @D35UGGB
       LINE  ,,SKIP=3                                          @D35UGGB
       BIN   INTRL001                                          @D35UGGB
       BIN   INTRL101                                          @D35UGGB
       LABEL 'PER INSTR.FETCH','TOD CLOCK PRI'                 @D35UGGB
  SPACE 2                                                      @D35UGGB
       LINE    (24,1),(1,1)                                    @D35UGGB
     ROUTINE NOTUSED,ASTRK72                                   @D35UGGB
         LABEL ''                                              @D35UGGB
         SPACE 2                                               @D35UGGB
         LINE  ,,SKIP=E                                        @D35UGGB
         LABEL ''                                              @D35UGGB
         SPACE 2                                               @D35UGGB
         LINE  (1,1),(44,1),SKIP=2                             @D35UGGB
         LABEL '--- MACHINE CHECK DATA EDITING ---'            @D35UGGB
         SPACE 2                                               @D35UGGB
         LINE  ,(1,1),SKIP=2                                   @D35UGGB
         LABEL '--- FLOATING POINT REGISTERS ---'              @D35UGGB
         SPACE 2                                               @D35UGGB
         LINE  (15,14),(1,1),SKIP=1                            @D35UGGB
         HEX   (FPR0,1,4B),(FPR1,1,4B),(FPR2,1,4B),(FPR3,1,4B) @D35UGGB
         LABEL 'FP REGS 0,2'                                   @D35UGGB
         SPACE 2                                               @D35UGGB
         LINE  ,,SKIP=2                                        @D35UGGB
         HEX   (FPR4,1,4B),(FPR5,1,4B),(FPR6,1,4B),(FPR7,1,4B) @D35UGGB
         LABEL 'FP REGS 4,6'                                   @D35UGGB
         SPACE 2                                               @D35UGGB
         LINE  ,,SKIP=2                                        @D35UGGB
         LABEL '--- GENERAL PURPOSE REGISTERS ---'             @D35UGGB
         SPACE 2                                               @D35UGGB
         LINE  ,,SKIP=1                                        @D35UGGB
         HEX   (GPR0,1,4B),(GPR1,1,4B),(GPR2,1,4B),(GPR3,1,4B) @D35UGGB
         LABEL 'GP REGS 0-3'                                   @D35UGGB
         SPACE 2                                               @D35UGGB
         LINE  ,                                               @D35UGGB
         HEX   (GPR4,1,4B),(GPR5,1,4B),(GPR6,1,4B),(GPR7,1,4B) @D35UGGB
         LABEL 'GP REGS 4-7'                                   @D35UGGB
         SPACE 2                                               @D35UGGB
         LINE  ,                                               @D35UGGB
         HEX   (GPR8,1,4B),(GPR9,1,4B),(GPR10,1,4B),(GPR11,1,4B)
         LABEL 'GP REGS 8-B'                                   @D35UGGB
         SPACE 2                                               @D35UGGB
         LINE  ,,SKIP=2                                        @D35UGGB
         HEX   (GPR12,1,4B),(GPR13,1,4B),(GPR14,1,4B),(GPR15,1,4B)
         LABEL 'GP REGS C-F'                                   @D35UGGB
         SPACE 2                                               @D35UGGB
         LINE  ,,SKIP=2                                        @D35UGGB
         LABEL '--- CONTROL REGISTERS ---'                     @D35UGGB
         SPACE 2                                               @D35UGGB
         LINE  ,,SKIP=1                                        @D35UGGB
         HEX   (CR0,1,4B),(CR1,1,4B),(CR2,1,4B),(CR3,1,4B)     @D35UGGB
         LABEL 'CT REGS 0-3'                                   @D35UGGB
         SPACE 2                                               @D35UGGB
         LINE  ,                                               @D35UGGB
         HEX   (CR4,1,4B),(CR5,1,4B),(CR6,1,4B),(CR7,1,4B)     @D35UGGB
         LABEL 'CT REGS 4-7'                                   @D35UGGB
         SPACE 2                                               @D35UGGB
         LINE  ,                                               @D35UGGB
         HEX   (CR8,1,4B),(CR9,1,4B),(CR10,1,4B),(CR11,1,4B)   @D35UGGB
         LABEL 'CT REGS 8-B'                                   @D35UGGB
         SPACE 2                                               @D35UGGB
         LINE  ,,SKIP=3                                        @D35UGGB
         HEX   (CR12,1,4B),(CR13,1,4B),(CR14,1,4B),(CR15,1,4B) @D35UGGB
         LABEL 'CT REGS C-F'                                   @D35UGGB
         SPACE 2                                               @D35UGGB
         LINE  ,,SKIP=2                                        @D35UGGB
         LABEL '--- MACHINE CHECK LOGOUT BYTES ---'            @D35UGGB
         SPACE 2                                               @D35UGGB
         LINE  (7,10),(1,1),SKIP=1                             @D35UGGB
         HEX   (DLOG00,0,4B),(DLOG01,B1,4B)                    @D35UGGB
         HEX   (DLOG02,B2,4B),(DLOG03,B3,4B)                   @D35UGGB
         HEX   (DLOG04,B2,4B),(DLOG05,B3,4B)                   @D35UGGB
         HEX   (DLOG06,B4,4B),(DLOG07,B5,4B)                   @D35UGGB
         HEX   (DLOG08,B4,4B),(DLOG09,B5,4B)                   @D35UGGB
         HEX   (DLOG010,B6,4B),(DLOG011,B7,4B)                 @D35UGGB
         LABEL '0000'                                          @D35UGGB
         SPACE 2                                               @D35UGGB
         LINE  ,                                               @D35UGGB
         HEX   (DLOG10,0,4B),(DLOG11,B1,4B)                    @D35UGGB
         HEX   (DLOG12,B2,4B),(DLOG13,B3,4B)                   @D35UGGB
         HEX   (DLOG14,B2,4B),(DLOG15,B3,4B)                   @D35UGGB
         HEX   (DLOG16,B4,4B),(DLOG17,B5,4B)                   @D35UGGB
         HEX   (DLOG18,B4,4B),(DLOG19,B5,4B)                   @D35UGGB
         HEX   (DLOG110,B6,4B),(DLOG111,B7,4B)                 @D35UGGB
         LABEL '0030'                                          @D35UGGB
         SPACE 2                                               @D35UGGB
         LINE  ,                                               @D35UGGB
         HEX   (DLOG20,0,4B),(DLOG21,B1,4B)                    @D35UGGB
         HEX   (DLOG22,B2,4B),(DLOG23,B3,4B)                   @D35UGGB
         HEX   (DLOG24,B2,4B),(DLOG25,B3,4B)                   @D35UGGB
         HEX   (DLOG26,B4,4B),(DLOG27,B5,4B)                   @D35UGGB
         HEX   (DLOG28,B4,4B),(DLOG29,B5,4B)                   @D35UGGB
         HEX   (DLOG210,B6,4B),(DLOG211,B7,4B)                 @D35UGGB
         LABEL '0060'                                          @D35UGGB
         SPACE 2                                               @D35UGGB
         LINE  ,                                               @D35UGGB
         HEX   (DLOG30,0,4B),(DLOG31,B1,4B)                    @D35UGGB
         HEX   (DLOG32,B2,4B),(DLOG33,B3,4B)                   @D35UGGB
         HEX   (DLOG34,B2,4B),(DLOG35,B3,4B)                   @D35UGGB
         HEX   (DLOG36,B4,4B),(DLOG37,B5,4B)                   @D35UGGB
         HEX   (DLOG38,B4,4B),(DLOG39,B5,4B)                   @D35UGGB
         HEX   (DLOG310,B6,4B),(DLOG311,B7,4B)                 @D35UGGB
         LABEL '0090'                                          @D35UGGB
         SPACE 2                                               @D35UGGB
         LINE  ,                                               @D35UGGB
         HEX   (DLOG40,0,4B),(DLOG41,B1,4B)                    @D35UGGB
         HEX   (DLOG42,B2,4B),(DLOG43,B3,4B)                   @D35UGGB
         HEX   (DLOG44,B2,4B),(DLOG45,B3,4B)                   @D35UGGB
         HEX   (DLOG46,B4,4B),(DLOG47,B5,4B)                   @D35UGGB
         HEX   (DLOG48,B4,4B),(DLOG49,B5,4B)                   @D35UGGB
         HEX   (DLOG410,B6,4B),(DLOG411,B7,4B)                 @D35UGGB
         LABEL '00C0'                                          @D35UGGB
         SPACE 2                                               @D35UGGB
         LINE  ,,SKIP=2                                        @D35UGGB
         HEX   (DLOG50,0,4B),(DLOG51,B1,4B)                    @D35UGGB
         HEX   (DLOG52,B2,4B),(DLOG53,B3,4B)                   @D35UGGB
         HEX   (DLOG54,B2,4B),(DLOG55,B3,4B)                   @D35UGGB
         HEX   (DLOG56,B4,4B),(DLOG57,B5,4B)                   @D35UGGB
         HEX   (DLOG58,B4,4B),(DLOG59,B5,4B)                   @D35UGGB
         LABEL '00F0'                                          @D35UGGB
         SPACE 2                                               @D35UGGB
         LINE  ,,SKIP=1                                        @D35UGGB
*****    RESET SKIP TO 1 SO DUMP DOESN'T SPACE OUT    *****    @D35UGGB
         LABEL ''                                              @D35UGGB
         PRINT GEN                                             @D35UGGB
         ETEPILOG RLEN=148
         END
