         TITLE 'IFCE0135 MODEL  135 MACHINE CHECK EDIT'
         MACRO
&NAME    DSGEN
.*                            THIS MACRO GENERATES ONE DSECT WORD
.*                                 FORMATTED FOR THE SUBJECT LOG RECORD
.*                                 EACH OPERAND HAS TWO SUB LISTS. THE
.*                                 FIRST IS THE NAME OF THE LOG ITEM
.*                                 WHILE THE SECOND IS THE # OF BITS TO
.*                                 ALLOCATE FOR THIS ITEM. ITEMS MUST
.*                                 BE DEFINED CONTIGUOUSLY WITHOUT GAPS
.*                                 UNUSED BIT GROUPS MUST BE GIVEN
.*                                 DUMMY NAMES. THE NAMES PROVIDED FOR
.*                                 THE LOG ITEMS MAY THEN BE USED IN
.*                                 THE CONVERSION MACRO INSTRUCTIONS.
         GBLC &ITEM(1000)
         GBLA &ITEMNBR,&BITS(1000),&SHIFT(1000)
         LCLB  &ONLY1,&CTIND
         LCLA  &START1,&START2,&END1,&END2
         LCLC  &SYMBOL,&EQUSYM
         LCLA  &OP,&COUNT,&BYTE,&EQUCNT
         ACTR  100000
.START   AIF   (N'&SYSLIST(&OP+1) LT 3).LOOP
         AIF   ('&SYSLIST(&OP+1,3)' EQ 'EQU').LOOP     TEST FOR EQU
  AIF   ('&SYSLIST(&OP+1,3)' EQ '' AND '&SYSLIST(&OP+1,4)' EQ '').ERR1
  AIF   ('&SYSLIST(&OP+1,3)' EQ '' OR '&SYSLIST(&OP+1,4)' EQ '').ERR1
         AIF   ('&SYSLIST(&OP+1,3)' GT '&SYSLIST(&OP+1,4)').ERR3
&START1  SETA  &SYSLIST(&OP+1,3)        GET START COUNT OF 1
&START2  SETA  &SYSLIST(&OP+1,4)        GET FIRST END COUNT
         AGO   .SET2A                   BRANCH AROUND
.ERR1    MNOTE '**FIRST SYMBOL CONCATENATION INCOMPLETE**'
         MEXIT
.SET2A   AIF   ('&SYSLIST(&OP+1,5)' EQ ''AND '&SYSLIST(&OP+1,6)' EQ '' X
               ).SET2                   TEST FOR NO SECOND
  AIF   ('&SYSLIST(&OP+1,5)' EQ '' OR '&SYSLIST(&OP+1,6)' EQ '').ERR2
         AIF   ('&SYSLIST(&OP+1,5)' GT '&SYSLIST(&OP+1,6)').ERR3
&END1    SETA  &SYSLIST(&OP+1,5)        GET START COUNT OF 2
&END2    SETA  &SYSLIST(&OP+1,6)        GET END COUNT OF 2
         AGO   .LOOP
.SET2    ANOP
&ONLY1   SETB  1                        INDICATE ONLY ONE CONCATENATION
         AGO   .LOOP
.ERR2    MNOTE '**SECOND SYMBOL CONCATENATION INCOMPLETE**'
         MEXIT
.ERR3    MNOTE '**START GREATER THAN END CONCATENATION**'
         MEXIT
.LOOP    ANOP
&OP      SETA  &OP+1
         AIF   (&OP GT N'&SYSLIST).DONE      TEST IF ALL DONE
&ITEMNBR SETA  &ITEMNBR+1
         AIF   ('&SYSLIST(&OP,2)' NE '').OK1
         MNOTE '**NULL BIT COUNT FIELD**'
         MEXIT
.OK1     ANOP
&SYMBOL  SETC  '&SYSLIST(&OP,1)'
         AIF   ('&SYMBOL' NE '').OK
*              *****     LOG ITEM SYMBOL NOT PROVIDED     *****
         AIF   ('&SYSLIST(&OP,3)' NE 'EQU').CNT
         AGO   .START                   GET NEXT
.OK      AIF   (N'&SYSLIST(&OP) LT 3).NO3    TEST FOR OLD FORMAT
         AIF   ('&SYSLIST(&OP,3)' EQ 'EQU').EQU   TEST FOR EQU
         AIF   (&ONLY1).OK2             TEST FOR ONLY ONE CONCAT
&SYMBOL  SETC  '&SYMBOL.&START1.&END1'       GET 1 AND 2 CONCAT
         AGO   .NO3                     BRANCH AROUND
.OK2     ANOP
&SYMBOL  SETC  '&SYMBOL.&START1'        GET 1 CONCATENATED
.NO3     ANOP
&SYMBOL  EQU   *+&BYTE
&ITEM(&ITEMNBR) SETC '&SYMBOL'          GET LABEL IN GLOBAL
&BITS(&ITEMNBR) SETA &SYSLIST(&OP,2)
&SHIFT(&ITEMNBR) SETA &COUNT-&BYTE*8
.CNT     ANOP
&CTIND   SETB  1                        SET COUNT INDICATOR
&COUNT   SETA  &COUNT+&SYSLIST(&OP,2)
&BYTE    SETA  &COUNT/8
         AIF   (N'&SYSLIST(&OP) LT 3).START  TEST FOR OLD FORMAT
         AIF   (&ONLY1).TSTST           TEST FOR ONLY ONE CONCAT
         AIF   (&END1 EQ &END2).TSTST   TEST FOR SECOND END
&END1    SETA  &END1+1                  INCREMENT COUNT
&OP      SETA  &OP-1                    DECREMENT INCREMENT
         AGO   .LOOP                    GENERATE NEXT
.TSTST   ANOP
         AIF   (&START1 EQ &START2).LPDONE   TEST FOR END
         AIF   (&ONLY1).NSET1           TEST FOR ONLY ONE CONCAT
&END1    SETA  &SYSLIST(&OP,5)          RE-INIT SECOND START COUNT
.NSET1   ANOP
&OP      SETA  &OP-1                    DECREMENT INDEX
&START1  SETA  &START1+1                INCREMENT FIRST COUNT
         AGO   .LOOP                    GO DO NEXT
.LPDONE  ANOP
&ONLY1   SETB  0                        CLEAR INDICATOR
         AGO   .START                   GO TEST FOR MORE SUB-LISTS
.DONE    AIF   (&COUNT-&COUNT/8*8 NE 0).ERR  TEST FOR MULTIPLE OF EIGHT
         AIF   (&CTIND EQ 0).END        NO DS IF NO COUNT
&COUNT   SETA  &COUNT/8                 GET NUMBER OF BYTES
&NAME    DS    &COUNT.C
.END     MEXIT
.ERR     MNOTE '**BIT COUNT FLDS DO NOT TOTAL MULTIPLE OF 8**'
         MEXIT
.EQU     AIF   ('&SYSLIST(&OP,4)' NE '').EQU1     TEST FOR NULL LABEL
.ERR4    MNOTE '**EQU OPERAND OMITTED OR NOT FOUND**'
         MEXIT
.EQU1    AIF   (&SYSLIST(&OP,2) LT 16).EQU2  COUNT OVER FIFTEEN
*****               THE FOLLOWING STATEMENT                *****
*****     NUMBER OF BITS EXCEED 15 - DO NOT USE AS BIN     *****
.EQU2    ANOP
&EQUCNT  SETA  0                        CLEAR COUNTER
&EQUSYM  SETC  '&SYSLIST(&OP,4)'        GET EQU OPERAND
.EQULOP  ANOP
&EQUCNT  SETA  &EQUCNT+1                INCREMENT INDEX
         AIF   ('&ITEM(&EQUCNT)' EQ '&EQUSYM').EQUOUT  LABEL FOUND?
         AIF   (&EQUCNT EQ &ITEMNBR).ERR4    ALL TESTED?
         AGO   .EQULOP                  NO-GET NEXT
.EQUOUT  ANOP
&ITEM(&ITEMNBR) SETC '&SYMBOL'          GET LABEL NAME
&BITS(&ITEMNBR) SETA &SYSLIST(&OP,2)    GET NUMBER OF BITS
&SHIFT(&ITEMNBR) SETA &SHIFT(&EQUCNT)   GET SHIFT COUNT
&SYMBOL  EQU   &EQUSYM                  THIS SYMBOL EQUATED
         AGO   .START                   RETURN FOR NEXT
         MEND
         EJECT
*  LINE MACRO     LINE MACRO     LINE MACRO     LINE MACRO            *
         SPACE 2
         MACRO
&NAME    LINE  &DATA,&LABEL,&SKIP=
.*                            THIS MACRO ESTABLISHES THE MARGINS OR
.*                                 COLUMN SETTINGS FOR EACH LINE. IT
.*                                 GENERATES NECESSARY CARRIAGE CONTROL
.*                                 ENTRIES. LASTLY IT DETERMINES THE
.*                                 NUMBER OF ENTRIES ASSOCIATED WITH
.*                                 THE PREVIOUS LINE AND STORES THAT #
.*                                 INTO THE APPROPRIATE BYTE.
.*                            &DATA(1) - CHARACTER POSITION TO BEGIN
.*                                 DATA.
.*                            &DATA(2) - # OF SPACES BETWEEN SUCCESSIVE
.*                                 DATA COLUMN STARTING CHARACTERS.
.*                            &LABEL(1) - CHAR. POS. TO BEGIN LABELS.
.*                            &LABEL(2) - # SPACES BETWEEN LINE'S LABEL
.*                                 STARTING CHARACTERS.
.*                            &SKIP= - # OF LINES TO ADVANCE CARRIAGE
.*                                 TO BEGIN NEXT PRINTED LINE.
.*                            NEW ENTRIES ARE GENERATED ONLY WHEN
.*                                 NECESSARY. OMISSION OF ITEMS MEANS
.*                                 THEY HAVE NOT CHANGED SINCE PREVIOUS
.*                                 SETTINGS. A LINE MACRO IS REQUIRED
.*                                 FOR EACH PRINTED LINE. IF NO SETTING
.*                                 CHANGES ARE REQUIRED ALL OPERANDS
.*                                 ARE OMITTED IN WHICH CASE ONLY THE
.*                                 # OF ENTRIES FOR THE PREVIOUS LINE
.*                                 IS COMPUTED. THIS MACRO MUST BE THE
.*                                 FIRST MACRO INSTRUCTION ISSUED FOR
.*                                 THE SUBJECT LINE
         GBLA  &DB,&DT,&LB,&LT,&NRENTS
         GBLA  &LASTCC,&INITIAL
         GBLC  &NRENTSX
         GBLC  &CARRCON
         GBLB  &TEST
         LCLA  &S
&NAME    DS    0C
         AIF   (&INITIAL EQ 0).FIRSTLN
         LINEND
         AGO   .NTFIRST
.FIRSTLN ANOP
&NRENTSX SETC  'N&SYSNDX'
&INITIAL SETA  1
N&SYSNDX EQU   *
.NTFIRST ANOP
         DC    AL1(0)
         AIF   ('&DATA(1)' EQ '').CKDTABS
         AIF   (&DATA(1) EQ &DB).CKDTABS
&DB      SETA  &DATA(1)
         AGO   .AA
.CKDTABS AIF   ('&DATA(2)' EQ '').NCDATA
         AIF   (&DATA(2) EQ &DT).NCDATA
         AGO   .CC
.AA      AIF   ('&DATA(2)' EQ '').BB
         AIF   (&DATA(2) EQ &DT).BB
.CC      ANOP
&DT      SETA  &DATA(2)
.BB      DC    XL2'FFFE'
         DC    FL1'&DB'
         DC    FL1'&DT'
&NRENTS  SETA  &NRENTS+1
.NCDATA  ANOP
         AIF   ('&LABEL(1)' EQ '').CKLTABS
         AIF   (&LABEL(1) EQ &LB).CKLTABS
&LB      SETA  &LABEL(1)
         AGO   .AAA
.CKLTABS AIF   ('&LABEL(2)' EQ '').NCLABEL
         AIF   (&LABEL(2) EQ &LT).NCLABEL
         AGO   .CCC
.AAA     AIF   ('&LABEL(2)' EQ '').BBB
         AIF   (&LABEL(2) EQ &LT).BBB
.CCC     ANOP
&LT      SETA  &LABEL(2)
.BBB     DC    XL2'FFFF'
         DC    FL1'&LB'
         DC    FL1'&LT'
&NRENTS  SETA  &NRENTS+1
.NCLABEL ANOP
         AIF   ('&SKIP' NE '').CONT
         AIF   (&TEST EQ 0).NOCHANG
&S       SETA  &LASTCC
         AGO   .DEFAULT
.CONT    ANOP
         AIF   (&TEST EQ 0).AB
&S       SETA  &SKIP
.DEFAULT ANOP
         ORG   &CARRCON+3
         DC    AL.3(0),AL.2(&S),AL.3(1)
         ORG
&LASTCC  SETA  &S
&TEST    SETB  0
         AGO   .DD
.AB      AIF   (&SKIP EQ &LASTCC).NOCHANG
A&SYSNDX DC    XL2'FFFB'
         DC    AL.3(0),AL.2(&SKIP),AL.3(1)
         DC    FL1'9'
&LASTCC  SETA  &SKIP
&TEST    SETB  1
&CARRCON SETC  'A&SYSNDX'
&NRENTS  SETA  &NRENTS+1
.DD      ANOP
.NOCHANG ANOP
         MEND
         EJECT
         MACRO
         LINEND
.*                            THIS MACRO IS USED ONLY BY THE LINE
.*                                 MACRO TO SET THE NUMBER OF ENTRIES
.*                                 ASSOCIATED WITH EACH LINE.
         GBLA  &NRENTS
         GBLC &NRENTSX
         AIF   (&NRENTS EQ 0).NORENTS   TEST FOR NO COUNT
         ORG   &NRENTSX
         DC    FL1'&NRENTS'
         ORG
&NRENTS  SETA  0
.NORENTS ANOP
B&SYSNDX EQU   *
&NRENTSX SETC  'B&SYSNDX'
         MEND
         MACRO
         BIN   &LOGITEM,&SKIP$OR
.*                                 &LOGITEM - NAME OF ITEM IN LOG
.*                                      RECORD DSECT
.*                                 &SKIP$OR - NBR OF SPACES TO SKIP ON
.*                                 MULTIPLE PRINT OR NBR OF SPACES
.*                                      TO BACK UP FROM COLUMN FOR
.*                                      START OF PRINTING. THE LETTER
.*                                      B PRECEEDS THE NUMBER (B5) IF
.*                                      THE LATTER IS DESIRED. OMISSION
.*                                      OF THIS OPERAND FORCES OPTION 2
.*                                      WITH BACKUP SPACING EQUAL TO
.*                                 THE NUMBER OF BITS IN THE ITEM
.*                                 DEFINITION (VIA MACRO 'DSGEN').
.*                            A LIMIT OF 15 BITS IS IMPOSED FOR THE
.*                                 TOTAL NUMBER OF BITS TO PRINT.
         GBLC &ITEM(1000)
         GBLA &ITEMNBR,&BITS(1000),&SHIFT(1000),&NRENTS
         GBLC  &DSECT
         LCLB  &B
         LCLA  &IBITS,&NDX,&ISHIFT,&K
         LCLA  &TEMP,&T
         LCLC  &S
.LOOP    ANOP
&NDX     SETA  &NDX+1
         AIF   ('&ITEM(&NDX)' EQ '&LOGITEM').FOUND
         AIF   (&NDX LT &ITEMNBR).LOOP
         MNOTE *,'YOU BLEW IT'
         ROUTINE DUM,SKIPPER
         MEXIT
.FOUND   ANOP
&ISHIFT  SETA  &SHIFT(&NDX)
&IBITS   SETA  &BITS(&NDX)
&T       SETA  &IBITS-1
&B       SETB  0
         AIF   ('&SKIP$OR' EQ '').BACKUP
&K       SETA  K'&SKIP$OR
&B       SETB  ('&SKIP$OR'(1,1) EQ 'B')
&S       SETC  '&SKIP$OR'(&B+1,&K-&B)
&T       SETA  &S
.BACKUP  ANOP
&NRENTS  SETA  &NRENTS+1
&TEMP    SETA  &ISHIFT
         AIF   (&IBITS NE 1 OR &B NE 0).BIN2
         DC    AL.12(&LOGITEM-&DSECT),XL.4'&TEMP'
         MEXIT
.BIN2    AIF   ('&SKIP$OR' NE '').BIN3
&B       SETB  1
.BIN3    ANOP
         DC    AL.12(&LOGITEM-&DSECT),XL.4'C'
         DC    BL.1'&B',AL.7(&T),AL.4(&IBITS),FL.4'&ISHIFT'
.OUT     ANOP
         MEND
         MACRO
         HEX   &LOGITEM,&SKIP$OR,&BYTES
.*                            THIS MACRO FACILITATES GENERATION OF THE
.*                                 TABLE ENTRIES SPECIFYING HEX TYPE
.*                                 CONVERSIONS.
.*                            &LOGITEM - NAME OF DATA ITEM TO BE
.*                                 CONVERTED
.*                            &SKIP$OR - NUMBER OF SPACES TO SKIP ON
.*                                 MULTIPLE PRINT OR NBR OF SPACES TO
.*                                 BACK UP FROM COLUMN FOR START OF
.*                                 PRINTING. THE LETTER B PRECEEDS THE
.*                                 NUMBER (B8) IF THE LATTER OPTION IS
.*                                 DESIRED. OMISSION OF THIS OPERAND
.*                                 FORCES OPTION 2 WITH BACKUP SPACING
.*                                 EQUAL TO THE NUMBER OF BYTES SPECI-
.*                                 FIED BY THE NEXT OPERAND (TWICE THIS
.*                                 NUMBER IF SUFFIX IS EXPLICITLY OR
.*                                 IMPLICITLY B).
.*                            &BYTES - NUMBER OF TOTAL INPUT BYTES TO
.*                                 PROCESS. THIS NUMBER IS SUFFIXED
.*                                 WITH AN L,R, OR B TO STIPULATE
.*                                 PRINTING OF THE LEFT HALF, RIGHT
.*                                 HALF, OR BOTH HALVES OF THE BYTE
.*                                 RESPECTIVELY. OMISSION OF THIS
.*                                 OPERAND DEFAULTS TO B WITH THE NUM-
.*                                 BER OF BYTES EQUAL TO THE ITEM LNGTH
.*                            A NEW ENTRY IS GENERATED ONLY WHEN NECES-
.*                                 SARY. THIS MACRO MUST BE THE FIRST
.*                                 MACRO INSTRUCTION ISSUED FOR THE
.*                                 SUBJECT LINE(S).
         GBLC &ITEM(1000),&DSECT
         GBLA &ITEMNBR,&BITS(1000),&SHIFT(1000),&NRENTS
         LCLB  &B
         LCLA  &IBITS,&NDX,&ISHIFT,&K,&T,&CODE,&BYTESP
         LCLC  &S,&LETTER
.LOOP    ANOP
&NDX     SETA  &NDX+1
         AIF   ('&ITEM(&NDX)' EQ '&LOGITEM').FOUND
         AIF   (&NDX LT &ITEMNBR).LOOP
         MNOTE *,'LOG ITEM NOT DEFINED'
         MEXIT
.FOUND   ANOP
&ISHIFT  SETA  &SHIFT(&NDX)
&IBITS   SETA  &BITS(&NDX)
&CODE    SETA  1
&K       SETA  K'&BYTES
         AIF   (&IBITS-(&IBITS/4)*4 EQ 0).OK
         MNOTE *,'BIT LENGTH SPECIFICATION INCONSISTENT WITH CONTROL'
         MEXIT
.OK      AIF   ('&BYTES' EQ '').USEDEFN
&LETTER  SETC  '&BYTES'(&K,1)
&S       SETC  '&BYTES'(1,&K-1)
&BYTESP  SETA  &S
         AIF   ('&LETTER' EQ 'B').BOTH
         AIF   ('&LETTER' EQ 'L').LEFT
&CODE    SETA  2
         AGO   .L
.LEFT    ANOP
&CODE    SETA  1
         AGO   .L
         AIF   (&ISHIFT EQ 0 OR &ISHIFT EQ 4).OK2
.ERR     MNOTE *,'DATA NOT ALLIGNED ON HEX OR BYTE BOUNDARY'
         MEXIT
.USEDEFN ANOP
&BYTESP  SETA  &IBITS/8
.BOTH    AIF   (&ISHIFT NE 0).ERR
&CODE    SETA  3
&T       SETA  &BYTESP*2-1
&S       SETC  '&T'
.OK2     AIF   (&ISHIFT EQ 0).L
&CODE    SETA  2
.L       ANOP
&B       SETB  1
         AIF   ('&SKIP$OR' EQ '').BACKUP
&K       SETA  K'&SKIP$OR
&B       SETB  ('&SKIP$OR'(1,1) EQ 'B')
&S       SETC  '&SKIP$OR'(&B+1,&K-&B)
.BACKUP  ANOP
&NRENTS  SETA  &NRENTS+1
         DC    AL.12(&LOGITEM-&DSECT),XL.4'A'
         DC    BL.1'&B',FL.7'&S',AL.4(&BYTESP),FL.4'&CODE'
.OUT     ANOP
         MEND
         SPACE 2
*  ROUTINE MACRO     ROUTINE MACRO     ROUTINE MACRO     ROUTINE MACRO*
         SPACE 2
         MACRO
&NAME    ROUTINE &LOGITEM,&RNAME
         GBLC  &DSECT,&CSECT
         GBLC  &ITEM(1000)
         GBLA  &SHIFT(1000),&ITEMNBR
         GBLA  &NRENTS
         LCLA  &ISHIFT,&NDX
.LOOP    ANOP
&NDX     SETA  &NDX+1
         AIF   ('&ITEM(&NDX)' EQ '&LOGITEM').FOUND
         AIF   (&NDX LT &ITEMNBR).LOOP
         MNOTE *,'LOG ITEM NOT DEFINED'
         MEXIT
.FOUND   ANOP
&ISHIFT  SETA  &SHIFT(&NDX)
&NAME    DC    AL.12(&LOGITEM-&DSECT),XL.4'D'
         DC    AL.4(&ISHIFT),AL.12(&RNAME-&CSECT)
&NRENTS  SETA  &NRENTS+1
         MEND
         EJECT
*  LABEL MACRO     LABEL MACRO     LABEL MACRO     LABEL MACRO        *
         SPACE 2
         MACRO
         LABEL &LABEL1,&LABEL2,&LABEL3,&LABEL4,&LABEL5,&LABEL6,        C
               &LABEL7,&LABEL8
.*                            THIS MACRO ALLOWS UP TO ACHT LABELS TO
.*                                 BE SPECIFIED FOR A GIVEN LINE. THE
.*                                 LABELS SHOULD BE ENCLOSED IN QUOTA-
.*                                 TION MARKS. THE COLUMN AND LINE END
.*                                 CONTROLS WILL BE INSERTED BY THE
.*                                 MACRO. OMITTED OPERANDS MEAN NO
.*                                 LABEL REQUIRED FOR RESPECTIVE
.*                                 COLUMN. THIS MACRO WILL ALSO ALERT
.*                                 THE PROGRAMMER TO EXACTLY WHERE THE
.*                                 TABLE MUST BE BROKEN IF NECESSARY
.*                                 TO AVOID EXCEEDING THE MAXIMUM LIMIT
         GBLC &LABELS(1000)
         GBLA  &LABELNR
         GBLA  &NRENTS
         LCLC  &MARGIN,&TACK
         LCLC  &TEXT
         LCLA  &OP,&K,&START,&NRCHAR,&REMAIN
&MARGIN  SETC  '*'
.LOOPOUT ANOP
&OP      SETA  &OP+1
&K       SETA  K'&SYSLIST(&OP)
         AIF (&K GE 2).NORM
&K       SETA  2
.NORM    ANOP
&START   SETA  2
         AIF (&OP LT N'&SYSLIST).NOTLAST
&MARGIN  SETC  '$'
.NOTLAST ANOP
&NRCHAR  SETA  8
&TACK    SETC  ''
.LOOPIN  ANOP
&REMAIN  SETA  &K-&START
         AIF (&REMAIN GE 8).MORE
&TACK    SETC  '&MARGIN'
&NRCHAR  SETA  &REMAIN
.MORE    ANOP
&TEXT    SETC  ''
         AIF (&REMAIN EQ 0).ENDTEXT
&TEXT    SETC  '&SYSLIST(&OP)'(&START,&NRCHAR)
.ENDTEXT ANOP
&LABELNR SETA  &LABELNR+1
&LABELS(&LABELNR) SETC '&TEXT'.'&TACK'
&START   SETA  &START+8
         AIF ('&TACK' EQ '').LOOPIN
         AIF ('&TACK' EQ '*').LOOPOUT
         MEND
         MACRO
         LSTART
.*                            THIS MACRO IS ISSUED WHEN THE LABEL AREA
.*                                 OF THE TABLE IS TO BEGIN.
         GBLC &LABELS(1000)
         GBLA  &LABELNR
         LCLA  &NDX
         LINEND
.LOOP    ANOP
&NDX     SETA  &NDX+1
         DC    C'&LABELS(&NDX)'
         AIF   (&NDX LT &LABELNR).LOOP
         MEND
         GBLC  &DSECT,&CSECT
IFCE0135 CSECT
&CSECT   SETC  'IFCE0135'
&DSECT   SETC  'DSECT135'
DSECT135 DSECT
         DS    0F
         DSGEN (XKEY,8),(XRELN,8),(XSWS0,8),(XSWS8,1),(XSWS9,1),       C
               (XSWS10,1),(XSWS11,1),                                  *
               (XSWS12,1),(XSWS13,1),(XSWS14,1),(XSWS15,1)
         DSGEN (LOGWORK1,8),(LOGWORK2,6),(LOGWORK3,2),(LOGWRK3A,4),    *
               (LOGWRK3B,3),(LOGWRK3C,1),(LOGWORK4,8)
         DSGEN (XDATE,32)
         DSGEN (XTIME,32)
         DSGEN (XDUM2,8),(XSER,24)
         DSGEN (XCPUMOD,16),(XDUM3,16)
         DSGEN (XPGMID,64)
         DSGEN (XJOBID,64)
         DSGEN (XMCKPSW,64)
         DSGEN (SYSDAM,1),(PROCD,1),(SYSREC,1),(TIMDAM,1),(CLOCKD,1),  X
               (EXTDAM,1),(MDUM0,1),(AUTOCON,1),(WARNG,1),             X
               (DUM,5),(BACKUP1,1),(DELAY,1),(UNSTOR,1),               *
               (CORRST,1),(KEYERR,1),(DUMMY001,1),(EMWP,1),            *
               (SYSMSK,1),(PGMSK,1),(IAVLD,1),(FASTVLD,1),             X
               (RCVLD,1),(MDUM3,1),(FLPVLD,1),(GPRVLD,1),              X
               (CTLVLD,1),(LOGVLD,1),(STVLD,1)
         DSGEN (LRBNVLD,1),(RESERVDA,15),(EXTDLOG,16)          @XA20224
         DSGEN (RESRVDB,64)
         DSGEN (FAILSTA,32)
         DSGEN (ERCORCD,16),(CTRLWD,16)
         DSGEN (MCHRG00,1),(MCHRG01,1),(MCHRG02,1),(MCHRG03,1),        X
               (MCHRG04,1),(MCHRG05,1),(MCHRG06,1),(MCHRG07,1),        X
               (MCHRG08,1),(MCHRG09,1),(MCHRG10,1),(MCHRG11,1),        X
               (MCHRG12,1),(MCHRG13,1),(MCHRG14,1),(MCHRG15,1),        X
               (MCHRG16,1),(MCHRG17,1),(MCHRG18,1),(MCHRG19,1),        X
               (MCHRG20,1),(MCHRG21,1),(MCHRG22,1),(MCHRG23,1),        X
               (MCHRG24,1),(MCHRG25,1),(MCHRG26,1),(MCHRG27,1),        X
               (MCHRG28,1),(MCHRG29,1),(MCHRG30,1),(MCHRG31,1)
         DSGEN (BUFADRG,16)
         DSGEN (ZONER00,1),(ZONER01,3),(ZDUMY,1),(ZONER03,3),  @XA06108X
               (SAREG00,24)
SEL135   DSGEN (BFCTRG00,1),(BFCTRG01,1),(BFCTRG02,1),(BFCTRG03,1),    X
               (BFCTRG04,1),(BFCTRG05,1),(BFCTRG06,2),                 X
               (BFCTRG08,1),(BFCTRG09,1),(BFCTRG10,1),(BFCTRG11,1),    X
               (BFCTRG12,1),(BFCTRG13,3),                              X
               (BFCTRG16,1),(BFCTRG17,1),(BFCTRG18,1),(BFCTRG19,1),    X
               (BFCTRG20,1),(BFCTRG21,1),(BFCTRG22,1),(BFCTRG23,1),    X
               (BFCTRG24,1),(BFCTRG25,1),(BFCTRG26,1),(BFCTRG27,1),    X
               (BFCTRG28,1),(BFCTRG29,1),(BFCTRG30,1),(BFCTRG31,1)
         DSGEN (DUMMY00,16)
         DSGEN (CHANTG00,1),(CHANTG01,1),(CHANTG02,1),(CHANTG03,1),    X
               (CHANTG04,1),(CHANTG05,1),(CHANTG06,1),(CHANTG07,1),    X
               (CHANTG08,1),(CHANTG09,1),(CHANTG10,1),(CHANTG11,1),    X
               (CHANTG12,1),(CHANTG13,1),(CHANTG14,1),(CHANTG15,1),    X
               (CHANTG16,1),(CHANTG17,1),(CHANTG18,1),(CHANTG19,1),    X
               (CHANTG20,1),(CHANTG21,1),(CHANTG22,1),(CHANTG23,1),    X
               (CHANTG24,1),(CHANTG25,1),(CHANTG26,1),(CHANTG27,1),    X
               (CHANTG28,1),(CHANTG29,1),(CHANTG30,1),(CHANTG31,1)
         DSGEN (CHCTRG00,1),(CHCTRG01,1),(CHCTRG02,1),(CHCTRG03,1),    X
               (CHCTRG04,1),(CHCTRG05,1),(CHCTRG06,1),(CHCTRG07,1),    X
               (CHCTRG08,1),(CHCTRG09,1),(CHCTRG10,1),(CHCTRG11,1),    X
               (CHCTRG12,1),(CHCTRG13,1),(CHCTRG14,1),(CHCTRG15,1),    X
               (CHCTRG16,1),(CHCTRG17,1),(CHCTRG18,1),(CHCTRG19,1),    X
               (CHCTRG20,1),(CHCTRG21,1),(CHCTRG22,1),(CHCTRG23,1),    X
               (CHCTRG24,1),(CHCTRG25,1),(CHCTRG26,1),(CHCTRG27,1),    X
               (CHCTRG28,1),(CHCTRG29,1),(CHCTRG30,1),(DUMMY,1)
         DSGEN (CHANCK0,1,0,7),(DUM,8,0,2)                      XA00642
         DSGEN (CHK0,16,EQU,MCHRG00),(CHK1,16,EQU,MCHRG16)
         DSGEN (MCRR1,32)
         DSGEN (MCRR2,32)
         DSGEN (ICM90,32)
         DSGEN (STATUS,32)
         DSGEN (FDUM1,32)
         DSGEN (FDUM2,32)
         DSGEN (FDUM3,32)
         DSGEN (FDUM4,32)
         DSGEN (FDUM5,32)
         DSGEN (FDUM6,32)
         DSGEN (FDUM7,32)
         DSGEN (FDUM8,32)
         DSGEN (FDUM9,32)
         DSGEN (FDUM10,32)
         DSGEN (FDUM11,32)
         DSGEN (FDUM12,32)
         DSGEN (FDUM13,32)
         DSGEN (FDUM14,32)
FLOATPTS DSGEN (FP,32,0,7),(GPR,32,0,9),(GP,32,10,15),(CTR,32,0,9),    X
               (CR,32,10,15)
         DSGEN (DARLNGTH,16),(,48)
         DSGEN (SYSSTAT,1,0,7)
         DSGEN (AREADT,1,0,15)
         DSGEN (ERRTYPE,1,0,7)
         DSGEN (RMSACTN,1,0,7)
         DSGEN (RMSINFO,1,0,7)
         DSGEN (WAITSUFF,8),(,8),(MCHFSAR,32),(,32)
         DSGEN (TRNSMOD,32,0,7)
         DSGEN (MCHPDR,1,0,7,0,7)
         DSGEN (MCHFSAV,32),(MCHFSEAV,32),(MCHPDARI,32),(MCHTCBCU,32)
         ORG   ZONER00                                         @XA06108
         DSGEN (ZONER99,8)                                     @XA06108
        ORG    BUFADRG                                         @X60CAFR
        DSGEN  (EXTRA,15),(HILO,1)                             @X60CAFR
        ORG    MCHRG24                                         @X60CAFR
        DSGEN  (ACCEL,8)                                       @X60CAFR
IFCE0135 CSECT
         USING     *,9
ENTRYPTR DC    A(STARTER)
TABLNAME DC    CL8'IFCE0135'
REG9     DC    F'0'
LP       DC    F'0'
SKIPPER  BR        14
R0       EQU   0
R1       EQU   1
R2       EQU   2
R3       EQU   3
R4       EQU   4
R5       EQU   5
R6       EQU   6
R7       EQU   7
R8       EQU   8
R9       EQU   9
R10      EQU   10
R11      EQU   11
R12      EQU   12
         USING DSECT135,2
R13      EQU   13
R14      EQU   14
R15      EQU   15
HEX00    EQU   X'00'
HEX08    EQU   X'08'
HEX13    EQU   X'13'                                           @XA20224
HEX40    EQU   X'40'
HEX80    EQU   X'80'
HEX48    EQU   X'48'
HEXBF    EQU   X'BF'
L0       EQU   0
L1       EQU   1
L2       EQU   2
L3       EQU   3
L4       EQU   4
L5       EQU   5
L6       EQU   6
L7       EQU   7
L8       EQU   8
L12      EQU   12
L19      EQU   19
L29      EQU   29                                              @XA06108
L60      EQU   60
*
SETJOBN  MVC   L0(L8,R3),L0(R4)         MOVE JOB NAME
         BR    R14                      RETURN
*
SETDATE  UNPK  XWORK(L8),L0(L4,R4)      UNPACK DATE
         MVZ   XWORK+L7(L1),XWORK       SET ZONE
         MVC   L0(L3,R3),XWORK+L5       MOVE DAY
         MVC   L6(L2,R3),XWORK+L3 MOVE YEAR
         BR    R14                      RETURN
CONVREL  STM   R5,R8,XSAVE              SAVE WORK REGS
         SR    R6,R6                    CLEAR R6
         IC    R6,L0(R4)                PICK UP REL & SYS VALUES
         SRDL  R6,L5                    SAVE REL NO IN R7
        SLL   R6,L2                    MULTIPLY SYS VALUE BY 4
         L     R8,XLABELP               PICK UP LABEL POINTER
         LA    R6,RELTAB(R6)            INDEX INTO TABLE OF SYSTEMS
         MVC   L0(L4,R8),L0(R6)         MOVE SYSTEM NAME INTO LABEL
         SR    R6,R6                    CLEAR R6
         SLDL  R6,L5                    RETREIVE REL NO.
         LTR   R6,R6                    IS IT ZERO
         BZ    NOREL                    BR-YES
         CVD   R6,WORK                  CONVERT IT
         UNPK  L0(L2,R3),WORK+L6(L2)    UNPACK IT INTO PRINT BUFF
         MVZ   L1(L1,R3),L0(R3)         MOVE ON PROPER ZONE
         B     RETURN                   EXIT
NOREL    MVC   L0(L4,R3),NONE           MOVE IN NONE FOR REL
         B     RETURN
*        ELIMINATE LINE IF NOT MVS                             @XA20224
ISITMVS  CLI   XKEY,HEX13              IS IT MVS               @XA20224
         BE    RETURNA                 YES MVS                 @XA20224
         SR    R15,R15                 ELIM. LINE              @XA20224
RETURNA  BR    R14                                             @XA20224
*
CYCLFLG  STM   R5,R8,XSAVE         SAVE REGS                   @XA06108
         MVC   QSAVE(L1),L0(R4)    CYCLE FLAG TO WORK AREA     @XA06108
         NI    QSAVE,X'80'         SAVE ONLY CYCLE FLAG        @XA06108
         SR    R7,R7               CLEAR REG 7                 @XA06108
         IC    R7,QSAVE            CYCLE FLAG TO REG 7         @XA06108
         SRL   R7,7                CYCLE FLAG TO LOW ORDER     @XA06108
         B     ZONE10              GO TO CHARACTER MOVE        @XA06108
ZONE10   LA    R8,CHARS            GET CHARACTER STRING        @XA06108
         AR    R8,R7               INDEX INTO CHARACTER STRING @XA06108
         L     R6,XLABELP          GET LABEL ADDRESS           @XA06108
         MVC   L29(L1,R6),L0(R8)   MOVE CHARACTER TO LABEL     @XA06108
         B     RETURN                                          @XA06108
CYCLZON  STM   R5,R8,XSAVE         SAVE REGS                   @XA06108
         MVC   QSAVE(L1),L0(R4)    CYCLE ZONE TO WORK AREA     @XA06108
         NI    QSAVE,X'70'         GET CYCLE ZONE ONLY         @XA06108
         SR    R7,R7               CLEAR REG 7                 @XA06108
         IC    R7,QSAVE            CYCLE ZONE TO REG 7         @XA06108
         SRL   R7,4                SHIFT TO LOW ORDER          @XA06108
         B     ZONE10              GO TO CHARACTER MOVE        @XA06108
DATAZON  STM   R5,R8,XSAVE         SAVE REGS                   @XA06108
         MVC   QSAVE(L1),L0(R4)    DATA ZONE TO WORK AREA      @XA06108
         NI    QSAVE,X'07'         GET ONLY DATA ZONE          @XA06108
         SR    R7,R7               CLEAR REG 7                 @XA06108
         IC    R7,QSAVE            DATA ZONE TO REG 7          @XA06108
         B     ZONE10              GO TO CHARACTER MOVE        @XA06108
RETURN   LM    R5,R8,XSAVE         RESTORE WORK REGISTERS
         BR    R14                 RETURN
TSTREC   ST    R5,XSAVE           SAVE REG
         TM    0(R4),HEX80        TEST SHORT FORM RECORD SWITCH
         BZ    TSTRECN            BRANCH IF LONG FORM
         LA    R5,SHORTREC-L4           ADDRESS OF END OF SHORT RECORD
         ST    R5,REG9            INTO ENTRY POINTER
         L     R5,XSAVE                                        @XA20224
         BR    R14
TSTRECN  SR    R15,R15            DON'T PRINT LAST LINE        @XA20224
         BR    R14                RETURN
ROUT3    ST    R3,XSAVE           SAVE REG 3
         TM    0(R4),HEX80        TEST SHORT FORM RECORD SWITCH
         BO    ROUT3A             BRANCH IF SHORT FORM
         SR    R15,R15            DON'T PRINT LAST LINE
ROUT3A   L     R3,XSAVE           RESTORE REG 3
RETURN2  BR    R14                                             @X60CAFR
MASK     ST    R6,XSAVE                                        @X60CAFR
         MVC   HLSAVE(L1),L1(R4)   MOVE DATA TO WORKAREA       @X60CAFR
         NI    L1(R4),X'FE'        SET CONTRL STR HI OFF,IF ON
         BCTR  R3,0                BACK UP PRINT PTR
         B     EXIT1               RETURN
CHKHI    TM    HLSAVE,X'01'        CONTROL STORAGE HI?
         BO    ISHI                YES
         LA    R3,2(R3)            CONTROL STORAGE LOW,4 DIGITS TO PRT
         BR    R14                 RETURN
ISHI     MVI   0(R3),X'F1'         MOVE A 1 TO FIRST POSITION
         LA    R3,3(R3)            CONTROL STORAGE HI,5 DIGITS TO PRT
         BR    R14
IS138    CLI   L1(R4),X'38'        IS THIS A 138?
         BNE   NOPRINT             NO,SKIP THIS LINE
         BR    R14                 THIS IS A 138,PRINT LINE
NOT138   CLI   L1(R4),X'35'        IS THIS A 135?
         BNE   NOPRINT             NO,SKIP THIS LINE
         BR    R14                 THIS IS A 135,PRINT LINE
SETHIGH  ST    R6,XSAVE                                        @X60CAFR
         MVC   L1(L1,R4),HLSAVE    RESTORE DATA                @X60CAFR
         B     EXIT                                            @X60CAFR
SETLOW   ST    R6,XSAVE                                        @X60CAFR
         MVC   L1(L1,R4),HLSAVE    RESTORE DATA                @X60CAFR
         TM    L1(R4),X'01'        CTRL STORAGE HIGH?          @X60CAFR
         BO    CHANGE                                          @X60CAFR
         OI    L1(R4),X'FF'        SET CTRL STORAGE LOW=1      @X60CAFR
         B     EXIT                                            @X60CAFR
CHANGE   NI    L1(R4),X'FE'        SET CTRL STORAGE LOW=0      @X60CAFR
EXIT     LA    R6,30                                           @X60CAFR
         SR    R3,R6               BACKUP BUFFER PTR           @X60CAFR
EXIT1    L     R6,XSAVE                                        @X60CAFR
         BR    R14                                             @X60CAFR
HLSAVE   DC    X'00'                                           @X60CAFR
TYPE02   STM   R5,R8,XSAVE                                     @X60CAFR
         L     R6,XLABELP          GET LABEL POINTER           @X60CAFR
         MVC   QSAVE(L1),L0(R4)    MOVE DATA TO WORKAREA       @X60CAFR
         NI    QSAVE,X'80'         GET TYPE 0 FLAG             @X60CAFR
         SR    R7,R7                                           @X60CAFR
         IC    R7,QSAVE            TYPE 0 FLAG TO REG 7        @X60CAFR
         SRL   R7,7                TYPE 0 TO LOW ORDER         @X60CAFR
         LA    R8,CHARS            GET CHARACTER STRING        @X60CAFR
         AR    R8,R7               INDEX INTO CHARACTER STRING @X60CAFR
         MVC   64(L1,R6),L0(R8)    MOVE CHARACTER TO LABEL     @X60CAFR
         MVC   QSAVE(L1),L0(R4)    MOVE DATA TO WORKAREA       @X60CAFR
         NI    QSAVE,X'20'         GET TYPE 2 FLAG             @X60CAFR
         SR    R7,R7                                           @X60CAFR
         IC    R7,QSAVE            TYPE 2 FLAG TO REG 7        @X60CAFR
         SRL   R7,5                TYPE 2 TO LOW ORDER         @X60CAFR
         LA    R8,CHARS            GET CHARACTER STRING        @X60CAFR
         AR    R8,R7               INDEX INTO CHARACTER STRING @X60CAFR
         MVC   89(L1,R6),L0(R8)    MOVE CHARACTER TO LABEL     @X60CAFR
         B     RETURN                                          @X60CAFR
TYPE13   STM   R5,R8,XSAVE                                     @X60CAFR
         L     R6,XLABELP          GET LABEL POINTER           @X60CAFR
         MVC   QSAVE(L1),L0(R4)    MOVE DATA TO WORKAREA       @X60CAFR
         NI    QSAVE,X'40'         GET TYPE 1 FLAG             @X60CAFR
         SR    R7,R7                                           @X60CAFR
         IC    R7,QSAVE            TYPE 1 FLAG TO REG 7        @X60CAFR
         SRL   R7,6                TYPE 1 TO LOW ORDER         @X60CAFR
         LA    R8,CHARS            GET CHARACTER STRING        @X60CAFR
         AR    R8,R7               INDEX INTO CHARACTER STRING @X60CAFR
         MVC   64(L1,R6),L0(R8)    MOVE CHARACTER TO LABEL     @X60CAFR
         MVC   QSAVE(L1),L0(R4)    MOVE DATA TO WORKAREA       @X60CAFR
         NI    QSAVE,X'10'         GET TYPE 3 FLAG             @X60CAFR
         SR    R7,R7                                           @X60CAFR
         IC    R7,QSAVE            TYPE 3 FLAG TO REG 7        @X60CAFR
         SRL   R7,4                TYPE 3 TO LOW ORDER         @X60CAFR
         LA    R8,CHARS            GET CHARACTER STRING        @X60CAFR
         AR    R8,R7               INDEX INTO CHARACTER STRING @X60CAFR
         MVC   89(L1,R6),L0(R8)    MOVE CHARACTER TO LABEL     @X60CAFR
         B     RETURN                                          @X60CAFR
NOTVIRG  ST    R6,XSAVE                                        @X60CAFR
         CLI   21(R2),X'35'        IS IT A 135?                @X60CAFR
         BE    C135                                            @X60CAFR
NOPRINT  SR    R15,R15             DO NOT PRINT THIS LINE      @X60CAFR
         B     EXIT1                                           @X60CAFR
C135     TM    L0(R4),X'01'        IS IT A 135I?               @X60CAFR
         BO    NOPRINT                                         @X60CAFR
         B     EXIT1                                           @X60CAFR
ISVIRG   ST    R6,XSAVE                                        @X60CAFR
         CLI   21(R2),X'35'        IS IT A 135?                @X60CAFR
         BNE   EXIT1                                           @X60CAFR
CP135    TM    L0(R4),X'01'        IS IT A 135I?               @X60CAFR
         BO    EXIT1                                           @X60CAFR
         B     NOPRINT                                         @X60CAFR
ISIT138  STM   R5,R8,XSAVE         SAVE REGS
         LA    R5,40               NUMBER TO BACK UP
         LR    R6,R3               GET LABEL PTR
         SR    R6,R5               BACK UP TO MODEL NUMBER
         MVI   L0(R6),C'8'         MAKE IT 138
         CLI   21(R2),X'35'        IS IT A 135
         BNE   RETURN              NO,ITS A 138
         MVI   L0(R6),C'5'         MAKE IT A 135
         CLI   L0(R4),X'01'        IS IT A 135I
         BNE   RETURN              NO,ITS A 135
         MVC   L1(L2,R6),LAB135I   MAKE IT IT 135-3 OR 135I
         B     RETURN              DONE
LAB135I  DC    C'-3'
XWORK    DS    D
RELTAB   DS    0C
         DC    C'OS  '
         DC    C'DOS '
         DC    C'VS 1'
         DC    C'V370'
         DC    C'VS 2'
         DC    C'    '
         DC    C'    '
         DC    C'    '
QSAVE    DC    X'00'                                           @XA06108
CHARS    DC    C'0123456789ABCDEF'                             @XA06108
XSAVE    DS    2D
NONE     DC    CL4'NONE'
WORK     EQU   XWORK
XLABELP  EQU   LP
         LTORG
STARTER  DS    0F
         DC    XL4'00010001'
         DC    XL4'00010001'
         DC    A(LABAREA)
         DC    H'0'
         DC    X'01'
         DC    X'000B8B00'
         LABEL     ''
         LINE      ,,SKIP=2
         LABEL     ''
         LINE  (48,1),(1,35),SKIP=2
         HEX   XSER,0,3B
         ROUTINE XDUM2,ISIT138
         LABEL 'MODEL 13','SERIAL NO'
*
         LINE  (10,)
         ROUTINE    XRELN,CONVREL
         LABEL      'XXXX REL.'
         LINE
         LABEL '--- RECORD SOURCE - MCH ---','TYPE - CPU'
*
         LINE  (15,1),(1,1)
         HEX   XMCKPSW,1,8B
         LABEL 'MCK OLD PSW'
         LINE  (21,1),(1,1)
         ROUTINE    XJOBID,SETJOBN
         LABEL      'JOB NAME'
*
         LINE
         ROUTINE    XPGMID,SETJOBN
         LABEL 'PROGRAM NAME'
*
         LINE       ,(8,40),SKIP=1
         ROUTINE XSWS0,SKIPPER
         LABEL      'DAY  YEAR','HH MM SS.TH'
         LINE       (8,40),(1,40),SKIP=2
         ROUTINE    XDATE,SETDATE
         HEX        XTIME,1,4B
         LABEL      'DATE _','TIME _'
**********************************************************************
START    DS    0C
         LINE  (1,1),(5,1),SKIP=1
         LABEL '--- MACHINE CHECK INTERRUPT CODE ---'
         LINE
         LABEL 'SUB CLASS'
         LINE  (23,41),(1,41)
         BIN   SYSDAM
         BIN   CLOCKD
         LABEL 'SYSTEM DAMAGE (SD)','CLOCK DAMAGE (CD)'
         LINE
         BIN   PROCD
         BIN   EXTDAM
         LABEL 'PROC DAMAGE (PD)','EXTERNAL DAMAGE (CD)'
         LINE
         BIN   SYSREC
         BIN   AUTOCON
         LABEL 'SYSTEM RECOVERY (SR)','AUTO-CONFIG (AC)'
         LINE
         BIN   TIMDAM
         BIN   WARNG
         LABEL 'TIMER DAMAGE','WARNING (W)'
         LINE
         LABEL     ''
         LINE  ,(1,1),SKIP=1
         LABEL '--- INTERRUPT SENSE CODES ---'
         LINE  (23,41),(1,41),SKIP=1
         BIN   BACKUP1
         BIN   DELAY
         LABEL 'BACK-UP (B)','DELAYED (D)'
         LINE
         LABEL     ''
         LINE  ,(1,1),SKIP=1
         LABEL '--- STORAGE AND PROTECTION ERROR CODES ---'
         LINE  (41,50),(1,50)
         BIN   UNSTOR
         BIN   KEYERR
         LABEL 'UNCORRECTED STORAGE ERRORS (SE)','UNCORRECTED PROTECTIOX
               N ERROR (PE)'
         LINE
         BIN   CORRST
         LABEL 'CORRECTED STORAGE ERRORS (SC)'
         LINE
         LABEL     ''
         LINE  ,(1,1),SKIP=1
         LABEL '--- PSW VALIDITY CODES'
         LINE  (41,50),(1,50)
         BIN   EMWP
         BIN   SYSMSK
         LABEL 'AMWP BITS OF M.C. OLD ARE VALID (WP)','SYSTEM MASK OF MX
               .C. OLD IS VALID (MS)'
         LINE
         BIN   PGMSK
         BIN   IAVLD
         LABEL 'PROGRAM MASK OF M.C. OLD IS VALID (PM)','INSTR ADDR OF X
               M.C. OLD IS VALID (IA)'
         LINE
         LABEL     ''
         LINE  ,(1,1),SKIP=1
         LABEL '--- MISC VALIDITY CODES ---'
         LINE  (41,50),(1,50)
         BIN   FASTVLD
         BIN   RCVLD
         LABEL 'FAILING STORAGE ADDR IS VALID (FA)','REGION CODE VALID X
                (RC)'
         LINE
         BIN   FLPVLD
         BIN   GPRVLD
         LABEL 'FP REGS STORED ARE VALID (FP)','GP REGS STORED ARE VALIX
               D (GP)'
         LINE
         BIN   CTLVLD
         BIN   LOGVLD
         LABEL 'CONTROL REGS STORED ARE VALID (CR)','EXTENDED LOGOUT ARX
               EA VALID (LG)'
         LINE
         BIN   STVLD
         LABEL 'INSTR MODIFIED STORAGE VALID (ST)'
         LINE
         LABEL ''
         LINE  (58,1),(30,30),SKIP=2                           @XA20224
         BIN   LRBNVLD                                         @XA20224
         ROUTINE  XKEY,ISITMVS                                 @XA20224
         LABEL '--- LRB MAY NOT BE VALID','---'                @XA20224
         LINE  (37,50),(1,50),SKIP=2
         HEX   EXTDLOG,1,2B
         LABEL 'EXTENDED LOGOUT LENGTH'
         LINE      (37,1),(1,1)
         HEX       RESRVDB,1,14B
         ROUTINE   XSWS8,ROUT3
         LABEL     'MC STATUS FIELD'
         LINE  ,(1,1),SKIP=2
         ROUTINE   XSWS8,TSTREC
         LABEL 'ABBREVIATED MACHINE CHECK LOGOUT'
         LINE  (35,1),(1,1),SKIP=2
         HEX   FAILSTA,1,4B
         LABEL 'FAILING STORAGE ADDRESS'
         LINE  ,(1,1),SKIP=2
         LABEL '--- REGION CODE ---'
         LINE  (37,50),(1,50),SKIP=2
         HEX   ERCORCD
         HEX   CTRLWD
         LABEL 'ERROR CORRECTION CODES','CONTROL WORD ADDRESS'
         LINE
         LABEL     ''
         DC    X'01000B8B00'
         LABEL ''
         LINE  ,(5,1),SKIP=2
         LABEL 'CPU DEPENDENT LOGOUT BYTES'
         LINE  ,(16,60)
         LABEL '--- CPU CHECKS 0 ---','--- CPU  CHECKS 1 ---'
         LINE  (25,30),(1,30),SKIP=1
         BIN   MCHRG00
         BIN   MCHRG08
         BIN   MCHRG16
         LABEL 'EARLY CHECK','BUS IN','ALU BYTE 0'
         LINE
         BIN   MCHRG01
         BIN   MCHRG09
         BIN   MCHRG17
         BIN   MCHRG25
         LABEL 'LATE CHECK','DISPLAY BUS BYTE 0','ALU BYTE 1',         X
               'ALU AUXILIARY'
         LINE
         BIN   MCHRG02
         BIN   MCHRG10
         BIN   MCHRG18
         BIN   MCHRG26
         LABEL 'STOR INPUT DATA','ALU SHIFT','ALU CONTROLS',           X
               'SP PROTECTION KEY'
         LINE
         BIN   MCHRG03
         BIN   MCHRG11
         BIN   MCHRG19
         BIN   MCHRG27
         LABEL 'WS OUTPUT','SINGLE BIT ERROR','T REGISTER',      XM5997X
               'SP STOR KEY'                                     XM5997
         LINE
         BIN   MCHRG04
         BIN   MCHRG12
         BIN   MCHRG20
         BIN   MCHRG28
         LABEL 'SELECT LATCHES','DOUBLE BIT ERROR','CDR/CTRL',   XM5997X
               'FIELD LENGTH CTR'
         LINE
         BIN   MCHRG05
         BIN   MCHRG13
         BIN   MCHRG21
         BIN   MCHRG29                                           XM5997
         LABEL 'WSAR','ECC ADDR CHECK','BRANCH DECODE',          XM5997X
               'ASSOC ARRAY'                                     XM5997
         LINE
         BIN   MCHRG06
         BIN   MCHRG14
         BIN   MCHRG22
         BIN   MCHRG30                                           XM5997
         LABEL 'ASAR','CPU SAR CHECK','MICROPROGRAM',            XM5997X
               'PHYSICAL REG'                                    XM5997
         LINE  (25,30),(1,30),SKIP=2
         BIN   MCHRG07
         BIN   MCHRG15
        ROUTINE   XDUM2,NOTVIRG
         LABEL 'DISP BUS BYTE 1','MS LAST ACCESS BIT'
        LINE   ,                                               @X60CAFR
        BIN       MCHRG07                                      @X60CAFR
        BIN       MCHRG15                                      @X60CAFR
        ROUTINE   XDUM2,RETURN2                                @X60CAFR
        BIN       MCHRG31                                      @X60CAFR
        ROUTINE   XDUM2,ISVIRG
         LABEL 'DISP BUS BYTE 1','MS LAST ACCESS BIT',' ',     @X60CAFRX
               'ACCELERATOR CHK'                               @X60CAFR
         LINE  (32,1),(1,1)
         ROUTINE BUFADRG,MASK
         ROUTINE BUFADRG,CHKHI
         HEX   BUFADRG
         ROUTINE XDUM2,ISVIRG
         LABEL 'EFFECTIVE CONTROL STORAGE ADDR'
         LINE  (25,30),(1,30),SKIP=1
         HEX   BUFADRG
         HEX   SAREG00
        ROUTINE   XDUM2,NOTVIRG
         LABEL 'BACKUP ADDR REG','STOR ADDR REG'                 XM5997
        LINE   ,                                               @X60CAFR
        HEX       BUFADRG                                      @X60CAFR
        HEX       SAREG00                                      @X60CAFR
        ROUTINE   BUFADRG,SETLOW                               @X60CAFR
        BIN       HILO                                         @X60CAFR
        ROUTINE   BUFADRG,SETHIGH                              @X60CAFR
        BIN       HILO                                         @X60CAFR
        ROUTINE   XDUM2,ISVIRG
         LABEL 'BACKUP ADDR REG','STOR ADDR REG',              @X60CAFRX
               'CONTROL STORAGE LOW','CONTROL STORAGE HI'      @X60CAFR
         LINE  SKIP=2
         BIN   ZONER00
         BIN   ZONER01
         BIN   ZONER03
         LABEL 'CYCLE STEAL','CYCLE STEAL ZONE','DATA FLOW ZONE'
         LINE  ,(8,30)
         LABEL 'RETRY THRESHOLD','CPU RETRY',                          X
               '    INTERRUPT STATUS LATCHES'
         LINE  (25,30),(1,30),SKIP=1
         BIN   BFCTRG00
         BIN   BFCTRG08
         BIN   BFCTRG16
         BIN   BFCTRG24
         LABEL 'GPR/STOR ALTERED','CPU RETRY FLAG','HRT OVERFLOW',     X
               'TIMER ENABLE'
         LINE
         BIN   BFCTRG01
         BIN   BFCTRG13
         BIN   BFCTRG17
         BIN   BFCTRG25
        LABEL 'SYSTEM DAMAGE','RETRY COUNT','NEW BYTE 83','START LATCH'
         LINE
         BIN   BFCTRG02
         ROUTINE    DUMMY,SKIPPER
         BIN   BFCTRG18
         BIN   BFCTRG26
         LABEL 'PSW/CR ALTERED','','PER REQUEST','M/C CHECK THRESHOLD'
         LINE
         BIN   BFCTRG03
         ROUTINE    DUMMY,SKIPPER
         BIN   BFCTRG19
         BIN   BFCTRG27
         LABEL 'SECOND ERROR','','SUCCESSFUL BRANCH','IC DUMPED'
         LINE
         BIN   BFCTRG04
         ROUTINE    DUMMY,SKIPPER
         BIN   BFCTRG20
         BIN   BFCTRG28
         LABEL 'PER ZONE 1','','RESTART BUTTON',                       X
               'ALTER/DISPLAY REQUEST'
         LINE
         ROUTINE DUMMY,SKIPPER
         ROUTINE    DUMMY,SKIPPER
         BIN   BFCTRG21
         BIN   BFCTRG29
         LABEL '','','STOP LATCH','MANUAL STATE'
         LINE
         ROUTINE    DUMMY,SKIPPER
         ROUTINE    DUMMY,SKIPPER
         BIN   BFCTRG22
         BIN   BFCTRG30
         LABEL '','','PRIO SAMPLE','PER LOG LATCH'
         LINE  (85,30),(61,30),SKIP=2
         BIN   BFCTRG23
         BIN   BFCTRG31
         LABEL 'PER INSTR. FETCH','TOD CLOCK PRI'
         LINE  ,(40,)
         LABEL '-----CHANNEL LOGOUT BYTES-----'
         LINE  (25,30),(6,30),SKIP=2
         ROUTINE XCPUMOD,NOT138
         LABEL 'ICA CHANNEL','SEL CHANNEL A','2319 IFA CHANNEL',       X
               'SEL CHANNEL B'                                 @XA06108
         LINE  (25,30),(6,30),SKIP=2
         ROUTINE XCPUMOD,IS138
         LABEL 'ICA CHANNEL','SEL CHANNEL A',                          X
               'SEL CHANNEL B'
         LINE  (25,30),(1,30),SKIP=1
         BIN   CHCTRG00                                          XM5997
         BIN   CHCTRG08
         BIN   CHCTRG16
         BIN   CHCTRG24
         ROUTINE XCPUMOD,NOT138
         LABEL 'INTERFACE CHECK','CHAN CONTROL','CONTROL',       XM5997X
               'CHAN CONTROL'                                    XM5997
         LINE  (25,30),(1,30),SKIP=1
         BIN   CHCTRG00
         BIN   CHCTRG08
         BIN   CHCTRG24
         ROUTINE XCPUMOD,IS138
         LABEL 'INTERFACE CHECK','CHAN CONTROL',                       X
               'CHAN CONTROL'
         LINE
         BIN   CHCTRG01                                          XM5997
         BIN   CHCTRG09
         BIN   CHCTRG17
         BIN   CHCTRG25
         ROUTINE XCPUMOD,NOT138
         LABEL 'LSAR CHECK','I/F CONTROL CHECK','COUNT',         XM5997X
               'I/F CONTROL CHECK'                               XM5997
         LINE
         BIN   CHCTRG01
         BIN   CHCTRG09
         BIN   CHCTRG25
         ROUTINE XCPUMOD,IS138
         LABEL 'LSAR CHECK','I/F CONTROL CHECK',                       X
               'I/F CONTROL CHECK'
         LINE
         BIN   CHCTRG02                                          XM5997
         BIN   CHCTRG10
         BIN   CHCTRG18
         BIN   CHCTRG26
         ROUTINE XCPUMOD,NOT138
         LABEL 'LSDR CHECK','CARD 1','FMF','CARD 1'              XM5997
         LINE
         BIN   CHCTRG02
         BIN   CHCTRG10
         BIN   CHCTRG26
         ROUTINE XCPUMOD,IS138
         LABEL 'LSDR CHECK','CARD 1','CARD 1'
         LINE
         BIN   CHCTRG03                                          XM5997
         BIN   CHCTRG11
         BIN   CHCTRG19
         BIN   CHCTRG27
         ROUTINE XCPUMOD,NOT138
         LABEL 'ALU OUTPUT CHECK','CARD 2','TIMING','CARD 2'     XM5997
         LINE
         BIN   CHCTRG03
         BIN   CHCTRG11
         BIN   CHCTRG27
         ROUTINE XCPUMOD,IS138
         LABEL 'ALU OUTPUT CHECK','CARD 2','CARD 2'
         LINE
         BIN   CHCTRG04
         BIN   CHCTRG12
         BIN   CHCTRG20
         BIN   CHCTRG28
         ROUTINE XCPUMOD,NOT138
         LABEL 'MINT REQUEST','CARD 3','SER/DES','CARD 3'        XM5997
         LINE
         BIN   CHCTRG04
         BIN   CHCTRG12
         BIN   CHCTRG28
         ROUTINE XCPUMOD,IS138
         LABEL 'MINT REQUEST','CARD 3','CARD 3'
         LINE
         BIN   CHCTRG05
         BIN   CHCTRG13
         BIN   CHCTRG21
         BIN   CHCTRG29
         ROUTINE XCPUMOD,NOT138
         LABEL 'COMMAND END','CARD 4','FBO,FTO','CARD 4'
         LINE
         BIN   CHCTRG05
         BIN   CHCTRG13
         BIN   CHCTRG29
         ROUTINE XCPUMOD,IS138
         LABEL 'COMMAND END','CARD 4','CARD 4'
         LINE
         BIN   CHCTRG06
         BIN   CHCTRG14
         BIN   CHCTRG22
         BIN   CHCTRG30
         ROUTINE XCPUMOD,NOT138
         LABEL 'STACK INTERRUPT','CARD 9','CCB REGS','CARD 9'    XM5997
         LINE
         BIN   CHCTRG06
         BIN   CHCTRG14
         BIN   CHCTRG30
         ROUTINE XCPUMOD,IS138
         LABEL 'STACK INTERRUPT','CARD 9','CARD 9'
         LINE  SKIP=2
         BIN   CHCTRG07
         ROUTINE DUMMY,SKIPPER
         BIN   CHCTRG23
         ROUTINE XCPUMOD,NOT138
         LABEL 'I/O OP','','FED'
         LINE  SKIP=2
         BIN   CHCTRG07
         ROUTINE XCPUMOD,IS138
         LABEL 'I/O OP'
         LINE  (25,30),(6,30),SKIP=2                            XA00642
         ROUTINE DUMMY,SKIPPER                                  XA00642
         LABEL '3330 IFA CHANNEL'                              @XA06108
         LINE  (25,30),(1,30),SKIP=1                            XA00642
         BIN   CHANCK00                                         XA00642
         LABEL 'CONTROL CHECK'                                  XA00642
         LINE
         BIN   CHANCK01                                         XA00642
         LABEL 'FMF/FCF'                                        XA00642
         LINE
         BIN   CHANCK02                                         XA00642
         LABEL 'FDB0/FDB1/SUBTRACTOR'                           XA00642
         LINE
         BIN   CHANCK03                                         XA00642
         LABEL 'BAR'                                            XA00642
         LINE
         BIN   CHANCK04                                         XA00642
         LABEL 'OR/COMPARATOR'                                  XA00642
         LINE
         BIN   CHANCK05                                         XA00642
         LABEL 'TIMING'                                         XA00642
         LINE
         BIN   CHANCK06                                         XA00642
         LABEL 'FBO/FTO'                                        XA00642
         LINE  ,,SKIP=2                                         XA00642
         BIN   CHANCK07                                         XA00642
         LABEL 'FBI/FCM'                                        XA00642
         LINE  ,(5,26),SKIP=2
         LABEL '-----CPU CHECKS-----'
         LINE  (52,1),(1,1),SKIP=2                             @XA06108
         HEX   ZONER99                                         @XA06108
        ROUTINE   XDUM2,NOTVIRG
         LABEL 'CHECKS 0   CHECKS 1   ZONE IN ERROR'           @XA06108
        LINE      (52,1),(1,69),SKIP=2                         @X60CAFR
        HEX       ZONER99                                      @X60CAFR
        ROUTINE   XDUM2,ISVIRG
        LABEL 'CHECKS 0   CHECKS 1  ZONE IN ERROR','ACCELERATOR ERROR'
         LINE  (3,11),(23,1),SKIP=1                            @XA06108
         HEX   CHK0,1,2B
         HEX   CHK1,1,2B
         ROUTINE ZONER00,CYCLFLG                               @XA06108
        ROUTINE   XDUM2,NOTVIRG
         LABEL 'CYCLE STEAL FLAG (BIT 0)            '          @XA06108
        LINE      (3,11),(23,42),SKIP=1                        @X60CAFR
        HEX       CHK0,1,2B                                    @X60CAFR
        HEX       CHK1,1,2B                                    @X60CAFR
        ROUTINE   ZONER00,CYCLFLG                              @X60CAFR
        ROUTINE   CHANTG00,TYPE02                              @X60CAFR
        ROUTINE   XDUM2,ISVIRG
         LABEL 'CYCLE STEAL FLAG (BIT 0)                  R1/R2 PARITY X
               CHK             ACC ASAR CHK                     '
         LINE  ,                                               @XA06108
         ROUTINE ZONER01,CYCLZON                               @XA06108
        ROUTINE   XDUM2,NOTVIRG
         LABEL 'CYCLE STEAL ZONE (BIT 1-3)          '          @XA06108
        LINE   ,                                               @X60CAFR
        ROUTINE   ZONER01,CYCLZON                              @X60CAFR
        ROUTINE   CHANTG00,TYPE13                              @X60CAFR
        ROUTINE   XDUM2,ISVIRG
         LABEL 'CYCLE STEAL ZONE (BIT 1-3)                MODE REGISTERX
                CHK            PAGE CROSS CHK                   '
         LINE  SKIP=2                                          @XA06108
         ROUTINE ZONER03,DATAZON                               @XA06108
         LABEL 'DATA FLOW ZONE   (BIT 5-7)          '          @XA06108
         LINE  ,(5,1)
         LABEL '--- FLOATING POINT REGISTERS ---'
         LINE  (16,15),(1,1)
         HEX   FP0,1,4B
         HEX   FP1,1,4B
         HEX   FP2,1,4B
         HEX   FP3,1,4B
         LABEL 'FP REGS 0,2'
         LINE  (16,15),(1,1)
         HEX   FP4,1,4B
         HEX   FP5,1,4B
         HEX   FP6,1,4B
         HEX   FP7,1,4B
         LABEL 'FP REGS 4,6'
         LINE
         LABEL     ''
         LINE  ,(5,1)
         LABEL '--- GENERAL PURPOSE REGISTERS ---'
         LINE  (16,15),(1,1)
         HEX   GPR0,1,4B
         HEX   GPR1,1,4B
         HEX   GPR2,1,4B
         HEX   GPR3,1,4B
         LABEL 'GP REGS 0-3'
         LINE  (16,15),(1,1)
         HEX   GPR4,1,4B
         HEX   GPR5,1,4B
         HEX   GPR6,1,4B
         HEX   GPR7,1,4B
         LABEL 'GP REGS 4-7'
         LINE  (16,15),(1,1)
         HEX   GPR8,1,4B
         HEX   GPR9,1,4B
         HEX   GP10,1,4B
         HEX   GP11,1,4B
         LABEL 'GP REGS 8-B'
         LINE  (16,15),(1,1)
         HEX   GP12,1,4B
         HEX   GP13,1,4B
         HEX   GP14,1,4B
         HEX   GP15,1,4B
         LABEL 'GP REGS C-F'
         LINE
         LABEL     ''
         LINE  ,(5,1)
         LABEL '--- CONTROL REGISTERS ---'
         LINE  (16,15),(1,1)
         HEX   CTR0,1,4B
         HEX   CTR1,1,4B
         HEX   CTR2,1,4B
         HEX   CTR3,1,4B
         LABEL 'CR REGS 0-3'
         LINE  (16,15),(1,1)
         HEX   CTR4,1,4B
         HEX   CTR5,1,4B
         HEX   CTR6,1,4B
         HEX   CTR7,1,4B
         LABEL 'CR REGS 4-7'
         LINE  (16,15),(1,1)
         HEX   CTR8,1,4B
         HEX   CTR9,1,4B
         HEX   CR10,1,4B
         HEX   CR11,1,4B
         LABEL 'CR REGS 8-B'
         LINE  (16,15),(1,1)
         HEX   CR12,1,4B
         HEX   CR13,1,4B
         HEX   CR14,1,4B
         HEX   CR15,1,4B
         LABEL 'CR REGS C-F'
         DC    X'01000B8B00'
         LABEL ''
         DC    X'01000B8B00'
         LABEL ''
         LINE  ,(30,),SKIP=2
         ROUTINE FDUM8,SKIPPER
         LABEL 'MACHINE CHECK STATUS FIELD'
         LINE  (41,),(1,),SKIP=1
         HEX   DARLNGTH,0,2B
         LABEL 'MCSTATD FIELD LENGTH'
         LINE  ,(5,)
         ROUTINE FDUM8,SKIPPER
         LABEL '--- SYSTEM STATUS ---'
         LINE  (35,35),(1,40)
         BIN   SYSSTAT0
         BIN   SYSSTAT1
         LABEL 'HARDWARE RECOVERY','SOFTWARE RECOVERY'
         LINE
         BIN   SYSSTAT2
         BIN   SYSSTAT3
         LABEL 'TASK ABORTED','TASK SET NON-DISPATCHABLE'
         LINE
         BIN   SYSSTAT4
         BIN   SYSSTAT5
         LABEL 'OPERATING SYSTEM TERMINATION','QUIET MODE IN EFFECT'
         LINE  ,(5,)
         ROUTINE FDUM8,SKIPPER
         LABEL '--- DAMAGE AREA ---'
         LINE  ,(1,40)
         BIN   AREADT0
         BIN   AREADT1
         LABEL 'MAIN STORAGE','BUFFER'
         LINE
         BIN   AREADT2
         BIN   AREADT3
         LABEL 'CONTROL STORAGE','INTERVAL TIMER'
         LINE
         BIN   AREADT4
         BIN   AREADT5
         LABEL 'PROCESSOR','CHANNEL ERROR'
         LINE
         BIN   AREADT6
         BIN   AREADT7
         LABEL 'TOD CLOCK','SYSTEM DAMAGE'
         LINE  ,(5,)
         ROUTINE FDUM8,SKIPPER
         LABEL '--- ERROR TYPE ---'
         LINE  ,(1,40)
         BIN   ERRTYPE0
         BIN   ERRTYPE1
         LABEL 'INTERMITTENT','SOLID'
         LINE
         BIN   ERRTYPE2
         BIN   ERRTYPE3
         LABEL 'DATA','RESERVED'
         LINE
         BIN   ERRTYPE4
         BIN   ERRTYPE5
         LABEL 'RESERVED','PROTECT'
         LINE  ,(5,)
         ROUTINE FDUM8,SKIPPER
         LABEL '--- RMS ACTION DATA ---'
         LINE  ,(1,40)
         BIN   RMSACTN0
         BIN   RMSACTN1
         LABEL 'LOOP TIME OUT','REPAIR'
         LINE
         BIN   RMSACTN2
         BIN   RMSACTN3
         LABEL 'STORAGE RECONFIGURE','BUFFER RECONFIGURE'
         LINE  ,(5,)
         ROUTINE FDUM8,SKIPPER
         LABEL '--- RMS INFORMATION STATUS ---'
         LINE  ,(1,40)
         BIN   RMSINFO0
         BIN   RMSINFO1
         LABEL 'RESERVED','INVALID MCI CODE'
         LINE
         BIN   RMSINFO2
         BIN   RMSINFO3
         LABEL 'INVALID FAILING STORAGE ADDRESS','PROGRAM CHECK IN MCH'
         LINE  (15,),(5,),SKIP=1
         ROUTINE FDUM8,SKIPPER
         LABEL '--- HISTORY OF TRANSIENT MODULES ---'
         LINE  (1,15)
         HEX   TRNSMOD0,1,4B
         HEX   TRNSMOD1,1,4B
         HEX   TRNSMOD2,1,4B
         HEX   TRNSMOD3,1,4B
         LABEL ''
         LINE  ,,SKIP=2
         HEX   TRNSMOD4,1,4B
         HEX   TRNSMOD5,1,4B
         HEX   TRNSMOD6,1,4B
         HEX   TRNSMOD7,1,4B
         LABEL ''
         LINE  ,(5,),SKIP=1
         LABEL '--- PDAR ACTION ---'
         LINE  (35,35),(1,40)
         BIN   MCHPDR00
         BIN   MCHPDR01
         LABEL 'TERMINATION OF CURRENT TASK','RETRY POSSIBLE'
         LINE
         BIN   MCHPDR02
         BIN   MCHPDR03
         LABEL 'BYPASS(AFFECTED TASK) POSSIBLE','REPAIR UNSUCCESSFUL'
         LINE
         BIN   MCHPDR04
         BIN   MCHPDR05
         LABEL 'INDETERMINATE INSTRUCTION COUNTER','RESERVED'
         LINE  ,(5,)
         LABEL '--- FAILURE TYPE ---'
         LINE ,(1,40)
         BIN   MCHPDR10
         BIN   MCHPDR11
         LABEL 'SOLID STORAGE DATA ERROR','INTERMITTENT STOR. DATA ERR'
         LINE
         BIN   MCHPDR12
         BIN   MCHPDR13
         LABEL 'SOLID SPF KEY ERROR','INTERMITTENT SPF KEY ERROR'
         LINE  ,(5,)
         LABEL '--- OPERATING SYSTEM STATUS ---'
         LINE ,(1,40)
         BIN   MCHPDR20
         BIN   MCHPDR21
         LABEL 'WAIT PSEUDO TASK','PAGE SUPERVISOR TASK'
         LINE
         BIN   MCHPDR22
         BIN   MCHPDR23
         LABEL 'MASTER SCHEDULER TASK','SYSTEM TASK'
         LINE
         BIN   MCHPDR24
         BIN   MCHPDR25
         LABEL 'PROBLEM PROGRAM TASK','CURRENT PSW DISABLED FOR I/O'
         LINE  ,(5,)
         LABEL '--- LOCATION OF FAILURE ---'
         LINE ,(1,40)
         BIN   MCHPDR30
         BIN   MCHPDR31
         LABEL 'NUCLEUS','SQA AREA'
         LINE
         BIN   MCHPDR32
         BIN   MCHPDR33
         LABEL 'LSQA AREA','PQA'
         LINE
         BIN   MCHPDR34
         BIN   MCHPDR35
         LABEL 'PAGEABLE AREA','FIXED PAGE AREA'
         LINE
         BIN   MCHPDR36
         BIN   MCHPDR37
         LABEL 'V=R ADDRESS AREA','CRITICAL AREA'
         LINE  ,(5,)
         LABEL '--- REQUESTED OPERATOR AWARENESS ---'
         LINE ,(1,40)
         BIN   MCHPDR50
         BIN   MCHPDR51
         LABEL 'SUPERVISOR DAMAGE MESSAGE','TASK ABNORM TERMINATION MSGC
               '
         LINE
         BIN   MCHPDR52
         BIN   MCHPDR53
         LABEL 'DAMAGED PAGE NOW UNAVAILABLE MSG','DAMAGED PAGE NOW DELC
               ETED MSG'
         LINE
         BIN   MCHPDR54
         BIN   MCHPDR55
         LABEL 'TASK NON-DISPATCHABLE MESSAGE','SOFTWARE RECOVERY MESSAC
               GE'
         LINE  ,(5,)
         LABEL '--- FOOTPRINTS ---'
         LINE ,(1,40)
         BIN   MCHPDR60
         BIN   MCHPDR61
         LABEL 'CHANGE BIT ACTIVE','KEY IN EXTERNAL PAGE TABLE'
         LINE
         BIN   MCHPDR62
         BIN   MCHPDR63
         LABEL 'PAGE RECURSION','PAGE FIX ACTIVE IN LOW END'
         LINE
         BIN   MCHPDR64
         BIN   MCHPDR65
         LABEL 'TRANSLATE ERROR','NO PAGE EXISTS'
         LINE
         BIN   MCHPDR66
         BIN   MCHPDR67
         LABEL 'RELOCATE OFF','LOW END INTERFACE ACTIVE'
         DC    X'01000B8B00'
         LABEL ''
         LINE  ,(5,)
         LABEL '--- FOOTPRINTS - INTERFACES ---'
         LINE ,(1,40)
         BIN   MCHPDR70
         BIN   MCHPDR71
         LABEL 'ABTERM INTERFACE ACTIVE','TRANSLATE INTERFACE ACTIVE'
         LINE
         BIN   MCHPDR72
         BIN   MCHPDR73
         LABEL 'FIND PAGE INTERFACE ACTIVE','PAGE DEQUEUE INTERFACE ACTC
               .'
         LINE
         BIN   MCHPDR74
         BIN   MCHPDR75
         LABEL 'PAGE ENQUEUE INTERFACE ACTIVE',                        C
               'STAT FUNCTION INTERFACE ACT.'
         LINE  ,,SKIP=2
         BIN   MCHPDR76
         BIN   MCHPDR77
         LABEL 'V=R RELEASE INTERFACE ACTIVE','POST INTERFACE ACTIVE'
         LINE  (45,1),(1,),SKIP=1
         HEX   MCHFSAR,0,4B
         LABEL 'FAILING STORAGE REAL ADDRESS'
         LINE
         HEX   MCHFSAV,0,4B
         LABEL 'BEGINNING FAILING STORAGE VIRTUAL ADDRESS'
         LINE
         HEX   MCHFSEAV,0,4B
         LABEL 'ENDING FAILING STORAGE VIRTUAL ADDRESS'
         LINE
         HEX   MCHPDARI,0,4B
         LABEL 'INSTRUCTION ADDRESS AT FAILURE'
         LINE  ,,SKIP=2
         HEX   MCHTCBCU,0,4B
         LABEL 'CURRENT TCB POINTER'
DUMPCODE DC    X'FF'
DUMPSIZE DC    XL2'190'                 SIZE OF LOGOUT
         DC    XL2'30'                  HEADER
ADDRLABL DC    XL2'E8'           RECORD ADDRESS                @XA06108
         LABEL     ''
SHORTREC DC    X'FF'
         DC    XL2'40'
         DC    XL2'30'
         DC    XL2'0'
LABAREA  EQU   *
         LSTART
         END
