         TITLE 'IFCEDASD-PRINTS EDIT DETAIL HEADER FOR 33XX DEVICES'
*                                                          /*@D35UGGB*/
*  *******************************************************************
*
*
*   MODULE NAME = IFCE33XX
*
*   DESCRIPTIVE-NAME = EDIT DETAIL REPORT INTERFACE
*
*   COPYRIGHT = NONE
*
*   STATUS = VERSION 1
*
*   FUNCTION = THIS MODULE WILL CALL MODULE IFCEDASD IF AN OBR
*              RECORD WAS INPUT AND STORE REG 15 IN XR9PTR.
*
*   NOTES
*
*
*     DEPENDENCIES = EBCDIC CHARACTER CODE DEPENDENCES - CORRECTABLE
*                    BY REASSEMBLY.
*
*     RESTRICTIONS = NONE
*
*     REGISTER-CONVENTIONS = R1 POINTS TO COMMUNICATION TABLE
*                            R10 POINTS TO START OF A RECORD
*
*     PATCH-LABEL = PATCH
*
*   MODULE TYPE = EDIT TABLE
*
*     PROCESSOR = ASSEMBLER
*
*     MODULE-SIZE = 10F HEXIDECIMAL BYTES
*
*     ATTRIBUTES = SERIALLY REUSABLE
*
*   ENTRY-POINT =   CALLDASD
*
*     PURPOSE = THIS ENTRY POINT WILL CALL IFCEDASD IF AN OBR RECORD
*               WAS INPUT OR FORCE ANOTHER RECORD TO BE READ IF AN
*               TPER RECORD WAS INPUT.
*
*     LINKAGE =  R14 LOADED WITH RETURN ADDRESS
*                R9 LOADED WITH ENTRY POINT
*                CALLED BY IFCEEDIT
*
*   INPUT = NONE
*
*   OUTPUT = XR9PTR - POINTER TO NAME OF NEXT EDIT TABLE TO LOAD
*
*   EXIT-NORMAL = R15 HAS 0 TO SUPRESS PRINTING LINE
*
*   EXIT-ERROR  = NONE
*
*   EXTERNAL-REFERENCES
*
*     ROUTINES = IFCEDASD
*
*     DATA-AREAS = COMMUNICATION TABLE
*
*     CONTROL-BLOCKS = NONE
*
*   TABLES = NONE
*
*   MACROS = LINE,ROUTINE,LABEL,LSTART,DSGEN
*
*   CHANGE ACTIVITY = NEW MODULE
*
*  *******************************************************************
         GBLC  &DSECT,&CSECT
IFCE33XX CSECT
&CSECT   SETC  'IFCE33XX'
&DSECT   SETC  'XXXC'
*
*                                  SENSE FORMAT 1
*
XXXC     DSECT
         DSGEN (CLASRC,8),(SYSREL,8),(SWITCDUM,16)
         DSGEN (SPARE1,32)
         DSGEN (DAYDUM,32)
         DSGEN (HOUR,32)
         DSGEN (SPARE2,8),(CPUSERL,24)
         DSGEN (CPUID,16),(SPARE3,16)
         DSGEN (JOBID1,32)
         DSGEN (JOBID2,32)
         DSGEN (FCCWCC,8),(FCCWDA,24)
         DSGEN (FCCWFL,8),(FCCW,8),(FCCWCT,16)
         DSGEN (CSWUS1,8),(CSWUS2,24)
         DSGEN (CSWUS3,8),(CSWUS4,8),(CSWUS5,16)
         DSGEN (DEVDPD,8),(SECCUA,24)
         DSGEN (DEVTYP1,16),(DEVTYP2,16)
         DSGEN (SPARE4,8),(CUADUM,24)
         DSGEN (IORET,16),(SBCNT,16)
         DSGEN (VOLLAB1,8),(VOLLAB2,16),(VOLLAB3,8)
         DSGEN (VOLLAB4,8),(VOLLAB5,8),(SPARE5,16)
         DSGEN (LSKAD1,8),(LSKAD2,16),(LSKAD3,8)
         DSGEN (LSKAD4,8),(LSKAD5,16),(LSKAD6,8)
         DSGEN (AHA1,32)
         DSGEN (AHA2,16),(SPARE6,16)
         DSGEN (SNB,1,0,23,0,7)
         EJECT
IFCE33XX CSECT
         USING *,R9
         USING XXXC,R4
*
*
H30      EQU   X'30'             OBR RECORD TYPE
L4       EQU   4
         DC    A(ENTRIES)
         DC    CL8'IFCE33XX'
XR9PTR   DC    F'0'
XLABELP  DC    F'0'
CALLDASD STM   R0,R14,SAVEED+0
         TM    0(R4),H30         TEST FOR AN OBR RECORD
         BO    YESOBR
         LA    R15,TPRLABEL-L4   NO,TPER RECORD,SO GET ANOTHER
         ST    R15,XR9PTR        RECORD
         B     EEDIT             RETURN TO IFCEEDIT
YESOBR   LA    R13,XSAVE         PUT SAVE AREA ADDR IN REG 13
         LR    R4,R2             SAVE REG 2 IN REG 4
         LR    R2,R1             PUT COMMUNICATION TABLE PTR IN REG 2
         LR    R7,R10            PUT OBR RECORD PTR IN REG 10
         L     R15,ADDRDASD      CALL IFCEDASD TO WRITE STANDARD
         BALR  R14,R15           HEADER FOR 33XX DEVICES
         LTR   R15,R15           TEST TO SEE IF ANOTHER EDIT TABLE IS
         BZ    EEDIT             TO BE LOADED
         ST    R15,XR9PTR        SAVE EDIT TABLE NAME FOR IFCEEDIT
EEDIT    SR    R15,R15           SUPRESS PRINTING THE LINE
         LM    R0,R14,SAVEED+0   RETURN TO IFCEEDIT
         BR    R14
XSAVE    DS    18F
SAVEED   DS    16F
TPRLABEL DC    XL1'FF'           FLAG TO FORCE END OF EDIT TABLE
         DC   3XL2'0000'
PATCH    DC   10C'PATCH'
ADDRDASD DC   V(IFCEDASD)
         DC   S(PATCH)
*
* EDIT TABLE FOR SENSE BYTE 0 - 23 ON A 3330
*
ENTRIES  DS   0F
         DC   XL4'00010001'      FORMAT 1
         DC   XL4'00010001'      FORMAT 2
         DC   A(LABELS)          LABEL POINTER
         DC   H'0'               DISPLACEMENT
         LINE
         ROUTINE   CLASRC,CALLDASD
         LABEL ' '
         DC    X'FF'
         DC    XL2'0070'
         DC    XL2'0018'
         DC    XL2'0000'
LABELS   DS   0F
         DC   C'$'
         LSTART
IFCEDASD CSECT ,                                                   0002
@MAINENT DS    0H                                                  0002
         USING *,@15                                               0002
         B     @PROLOG                                             0002
         DC    AL1(16)                                             0002
         DC    C'IFCEDASD  79.011'                                 0002
         DROP  @15
@PROLOG  ST    @14,12(,@13)                                        0002
         STM   @00,@12,20(@13)                                     0002
         BALR  @11,0                                               0002
@PSTART  LA    @12,4095(,@11)                                      0002
         USING @PSTART,@11                                         0002
         USING @PSTART+4095,@12                                    0002
         ST    @13,@SA00001+4                                      0002
         LA    @14,@SA00001                                        0002
         ST    @14,8(,@13)                                         0002
         LR    @13,@14                                             0002
*   ALLSENSE=OBRSENSE;              /* MOVE SENSE BYTES TO LOCAL   0185
*                                      STORAGE                       */
         LA    @10,64                                              0185
         ALR   @10,R7                                              0185
         SLR   @06,@06                                             0185
         IC    @06,OBRDEVDC(,R7)                                   0185
         SLA   @06,3                                               0185
         ALR   @10,@06                                             0185
         SLR   @06,@06                                             0185
         IC    @06,OBRLSDRC(,R7)                                   0185
         ALR   @10,@06                                             0185
         MVC   ALLSENSE(24),OBRSENSE(@10)                          0185
*   CALL LINE1;                     /* PROCESS NEXT LINE OF OUTPUT 0186
*                                                            @D35UGGB*/
         BAL   @14,LINE1                                           0186
*   CALL LINE2;                     /* PROCESS NEXT LINE OF OUTPUT 0187
*                                                            @D35UGGB*/
         BAL   @14,LINE2                                           0187
*   CALL LINE3;                     /* PROCESS NEXT LINE OF OUTPUT 0188
*                                                            @D35UGGB*/
         BAL   @14,LINE3                                           0188
*   CALL LINE4;                     /* PROCESS NEXT LINE OF OUTPUT 0189
*                                                            @D35UGGB*/
         BAL   @14,LINE4                                           0189
*   CALL LINE5;                     /* PROCESS NEXT LINE OF OUTPUT 0190
*                                                            @D35UGGB*/
         BAL   @14,LINE5                                           0190
*   CALL LINE6;                     /* PROCESS NEXT LINE OF OUTPUT 0191
*                                                            @D35UGGB*/
         BAL   @14,LINE6                                           0191
*   CALL LINE7;                     /* PROCESS NEXT LINE OF OUTPUT 0192
*                                                            @D35UGGB*/
         BAL   @14,LINE7                                           0192
*   CALL LINE8;                     /* PROCESS NEXT LINE OF OUTPUT 0193
*                                                            @D35UGGB*/
         BAL   @14,LINE8                                           0193
*   CALL LINE9;                     /* PROCESS NEXT LINE OF OUTPUT 0194
*                                                            @D35UGGB*/
         BAL   @14,LINE9                                           0194
*   CALL LINE10;                    /* PROCESS NEXT LINE OF OUTPUT 0195
*                                                            @D35UGGB*/
         BAL   @14,LINE10                                          0195
*   CALL LINE10A;                   /*                       @D3505GB*/
         BAL   @14,LINE10A                                         0196
*   CALL LINE11;                    /* PROCESS NEXT LINE OF OUTPUT 0197
*                                                            @D35UGGB*/
         BAL   @14,LINE11                                          0197
*   CALL LINE12;                    /* PROCESS NEXT LINE OF OUTPUT 0198
*                                                            @D35UGGB*/
         BAL   @14,LINE12                                          0198
*   CALL LINE13;                    /* PROCESS NEXT LINE OF OUTPUT 0199
*                                                            @D35UGGB*/
         BAL   @14,LINE13                                          0199
*   CALL LINE14;                    /* PROCESS NEXT LINE OF OUTPUT 0200
*                                                            @D35UGGB*/
         BAL   @14,LINE14                                          0200
*   CALL LINE15;                    /* PROCESS NEXT LINE OF OUTPUT 0201
*                                                            @D35UGGB*/
         BAL   @14,LINE15                                          0201
*   CALL LINE16;                    /* PROCESS NEXT LINE OF OUTPUT 0202
*                                                            @D35UGGB*/
         BAL   @14,LINE16                                          0202
*   CALL LINE17;                    /* PROCESS NEXT LINE OF OUTPUT 0203
*                                                            @D35UGGB*/
         BAL   @14,LINE17                                          0203
*   CALL LINE18;                    /* PROCESS NEXT LINE OF OUTPUT 0204
*                                                            @D35UGGB*/
         BAL   @14,LINE18                                          0204
*   CALL EDITTBLE;                  /* DETERMINE NAME OF NEXT EDIT 0205
*                                      TABLE                 @D35UGGB*/
         BAL   @14,EDITTBLE                                        0205
*   RETURN;                         /*                       @D35UGGB*/
@EL00001 L     @13,4(,@13)                                         0206
@EF00001 DS    0H                                                  0206
@ER00001 L     @14,12(,@13)                                        0206
         LM    @00,@12,20(@13)                                     0206
         BR    @14                                                 0206
*                                                                  0207
*/********************************************************************
*                                                                  0207
*   THIS PROC WILL CONVERT A NUMBER (4 BYTES) FROM BINARY TO PRINTABLE
*   CHARACTERS. THE RESULT IS RETURNED WITH LEADING 0'S BLANKED OUT.
*   A MAXIMUM OF 8 CHARACTERS IS OUTPUT. IF THE NUMBER OF SIGNIFICANT
*   DIGITS IS GREATER THAN THE SPACE ALLOWED FOR OUTPUT, '*' S WILL
*   BE PRINTED.                                                    0207
*      PARAMETERS:                                                 0207
*        NUMBER = NUMBER OF CHARACTER TO BE PRINTED (MAX 8)        0207
*        BINWORD = NUMBER TO BE CONVERTED                          0207
*        ADDNXT = ADDRESS OF OUTPUT                                0207
*                                                                  0207
******************************************************************** */
*                                                                  0207
*   RESPECIFY                                                      0207
*    (R6,                                                          0207
*     R8,                                                          0207
*     R9) RESTRICTED;               /*                       @D35UGGB*/
*CONVBIN:                                                          0208
*   PROC;                           /*                       @D35UGGB*/
CONVBIN  STM   @14,@12,@SA00002                                    0208
*   R8=BINWORD;                     /* GET NUMBER TO CONVERT @D35UGGB*/
         L     R8,BINWORD                                          0209
*   GEN(CVD R8,DBLWORK);            /* CONVERT FROM ABINARY TO PACKED
*                                      DECIMAL                       */
         CVD R8,DBLWORK
*   UNPK(WORK(1:8),DBLWORK);        /* FROM PACKED TO UNPACKED     0211
*                                                            @D35UGGB*/
         UNPK  WORK(8),DBLWORK(8)                                  0211
*   WORK(8)=WORK(8)|FOXZERO;        /* CHANGE THE SIGN BIT   @D35UGGB*/
         OI    WORK+7,X'F0'                                        0212
*   SWITCH=OFF;                     /*                       @D35UGGB*/
         NI    SWITCH,B'01111111'                                  0213
*   DO TEMP1=1 BY 1 TO 7 WHILE(SWITCH=OFF);/* DON'T TEST LAST CHAR   */
         LA    @10,1                                               0214
         ST    @10,TEMP1                                           0214
@DL00214 TM    SWITCH,B'10000000'                                  0214
         BNZ   @DC00214                                            0214
*     IF WORKOVER(TEMP1)=FOXZERO THEN/* TEST FOR LEADING 0'S         */
         LA    @03,WORKOVER-1(@10)                                 0215
         CLI   0(@03),X'F0'                                        0215
         BNE   @RF00215                                            0215
*       WORKOVER(TEMP1)=BLANK;      /* MOVE IN BLANK         @D35UGGB*/
         LA    @03,WORKOVER-1(@10)                                 0216
         MVI   0(@03),X'40'                                        0216
*     ELSE                                                         0217
*       SWITCH=ON;                  /* END OF LEADING 0'S    @D35UGGB*/
         B     @RC00215                                            0217
@RF00215 OI    SWITCH,B'10000000'                                  0217
*   END;                            /*                       @D35UGGB*/
@RC00215 LA    @10,1                                               0218
         AL    @10,TEMP1                                           0218
         ST    @10,TEMP1                                           0218
         C     @10,@CF00081                                        0218
         BNH   @DL00214                                            0218
@DC00214 DS    0H                                                  0219
*   IF SWITCH=ON THEN               /* POINT INDEX TEMP1 TO  @D35UGGB*/
         TM    SWITCH,B'10000000'                                  0219
         BNO   @RF00219                                            0219
*     TEMP1=TEMP1-1;                /* FIRST NON - ZERO DIGIT      0220
*                                                            @D35UGGB*/
         L     @10,TEMP1                                           0220
         BCTR  @10,0                                               0220
         ST    @10,TEMP1                                           0220
*   ELSE                                                           0221
*     ;                             /*                       @D35UGGB*/
@RF00219 DS    0H                                                  0222
*   IF(NINE-TEMP1)>NUMBER THEN      /* NO. TO BIG FOR OUTPUT SPACE   */
         LA    @10,9                                               0222
         SL    @10,TEMP1                                           0222
         C     @10,NUMBER                                          0222
         BNH   @RF00222                                            0222
*     WORK='********';              /* PUT OUT * FOR OVERFLOW      0223
*                                                            @D35UGGB*/
         MVC   WORK(8),@CC01399                                    0223
*   ELSE                                                           0224
*     ;                             /*                       @D35UGGB*/
@RF00222 DS    0H                                                  0225
*   R8=ADDR(WORK)+(8-NUMBER);       /* STARTING ADDRESS OF MOVE    0225
*                                                            @D35UGGB*/
         LA    R8,WORK                                             0225
         L     @10,NUMBER                                          0225
         LA    @03,8                                               0225
         SLR   @03,@10                                             0225
         ALR   R8,@03                                              0225
*   R9=NUMBER-1;                    /* LENGTH FOR MVC INSTRUCTION  0226
*                                                            @D35UGGB*/
         BCTR  @10,0                                               0226
         LR    R9,@10                                              0226
*   R6=ADDNXT;                      /* ADDRESS OF OUTPUT     @D35UGGB*/
         L     R6,ADDNXT                                           0227
*   GEN(EX R9,MVCINS);              /* PERFORM MOVE OF OUTPUT      0228
*                                                            @D35UGGB*/
         EX R9,MVCINS
*   GENERATE DATA;                                                 0229
*   RESPECIFY                                                      0230
*    (R6,                                                          0230
*     R8,                                                          0230
*     R9) UNRESTRICTED;             /*                       @D35UGGB*/
*   END CONVBIN;                    /*                       @D35UGGB*/
@EL00002 DS    0H                                                  0231
@EF00002 DS    0H                                                  0231
@ER00002 LM    @14,@12,@SA00002                                    0231
         BR    @14                                                 0231
*                                                                  0232
*/********************************************************************
*                                                                  0232
*   THIS PROC WILL DETERMINE THE NAME OF THE NEXT EDIT TABLE TO BE 0232
*   LOADED TO PRINT THE FIRST EIGHT SENSE BYTES,BASED ON THE TYPE OF
*   DASD DEVICE. THE NAME OF THE EDIT TABLE WILL BE PUT IN R15.    0232
*                                                                  0232
**********************************************************************
*                                                                    */
*                                                                  0232
*   RESPECIFY                                                      0232
*    (R15) RESTRICTED;              /*                       @D35UGGB*/
*EDITTBLE:                                                         0233
*   PROC OPTIONS(SAVE(14));         /*                       @D35UGGB*/
EDITTBLE ST    @14,12(,@13)                                        0233
*   IF OBRDEV=DEV3350|(EMULATE=ON&OBRDEV=DEV3330)|(EMULATE=ON&OBRDEV=
*       DEV33301) THEN              /* 3350,E 3330,E 3330 MOD 11     */
         CLC   OBRDEV(2,R7),DEV3350                                0234
         BE    @RT00234                                            0234
         TM    EMULATE,B'00001000'                                 0234
         BNO   @GL00001                                            0234
         CLC   OBRDEV(2,R7),DEV3330                                0234
         BE    @RT00234                                            0234
@GL00001 TM    EMULATE,B'00001000'                                 0234
         BNO   @RF00234                                            0234
         CLC   OBRDEV(2,R7),DEV33301                               0234
         BNE   @RF00234                                            0234
@RT00234 DS    0H                                                  0235
*     R15=ADDR(F3350)-4;            /*                       @D35UGGB*/
         LA    R15,F3350                                           0235
         SL    R15,@CF00062                                        0235
*   ELSE                                                           0236
*     IF OBRDEV=DEV3340&EMULATE=ON THEN/* DEVICE IS 3344     @D35UGGB*/
         B     @RC00234                                            0236
@RF00234 CLC   OBRDEV(2,R7),DEV3340                                0236
         BNE   @RF00236                                            0236
         TM    EMULATE,B'00001000'                                 0236
         BNO   @RF00236                                            0236
*       R15=ADDR(F3344)-4;          /*                       @D35UGGB*/
         LA    R15,F3344                                           0237
         SL    R15,@CF00062                                        0237
*     ELSE                                                         0238
*       IF OBRDEV=DEV3340 THEN      /* DEVICE IS 3340        @D35UGGB*/
         B     @RC00236                                            0238
@RF00236 CLC   OBRDEV(2,R7),DEV3340                                0238
         BNE   @RF00238                                            0238
*         R15=ADDR(F3340)-4;        /*                       @D35UGGB*/
         LA    R15,F3340                                           0239
         SL    R15,@CF00062                                        0239
*       ELSE                                                       0240
*         IF OBRDEV=DEV3330|OBRDEV=DEV33301 THEN                   0240
         B     @RC00238                                            0240
@RF00238 CLC   OBRDEV(2,R7),DEV3330                                0240
         BE    @RT00240                                            0240
         CLC   OBRDEV(2,R7),DEV33301                               0240
         BNE   @RF00240                                            0240
@RT00240 DS    0H                                                  0241
*           R15=ADDR(F3330)-4;      /* DEVICE IS 3330 ANY MOD      0241
*                                                            @D35UGGB*/
         LA    R15,F3330                                           0241
         SL    R15,@CF00062                                        0241
*         ELSE                                                     0242
*           IF OBRDEV=DEVWOOD THEN                                 0242
         B     @RC00240                                            0242
@RF00240 CLC   OBRDEV(2,R7),DEVWOOD                                0242
         BNE   @RF00242                                            0242
*             R15=ADDR(WOODY)-4;    /* DEVICE IS 88--                */
         LA    R15,WOODY                                           0243
         SL    R15,@CF00062                                        0243
*           ELSE                                                   0244
*             IF OBRDEV=DEV3370 THEN                               0244
         B     @RC00242                                            0244
@RF00242 CLC   OBRDEV(2,R7),DEV3370                                0244
         BNE   @RF00244                                            0244
*               R15=ADDR(D3370)-4;  /*                       @D3506GB*/
         LA    R15,D3370                                           0245
         SL    R15,@CF00062                                        0245
*             ELSE                                                 0246
*               R15=0;              /* DEVICE IS UNKNOWN     @D35UGGB*/
         B     @RC00244                                            0246
@RF00244 SLR   R15,R15                                             0246
*   END EDITTBLE;                   /*                       @D35UGGB*/
@EL00003 DS    0H                                                  0247
@EF00003 DS    0H                                                  0247
@ER00003 L     @14,12(,@13)                                        0247
         BR    @14                                                 0247
*   RESPECIFY                                                      0248
*    (R15) UNRESTRICTED;            /*                       @D35UGGB*/
*                                                                  0249
*/*********************************************************************
*                                                                  0249
*   THIS PROC WILL CONVERT HEX NUMBERS TO CHARACTER FORMAT.        0249
*   NUMBER = NUMBER OF BYTES TO CONVERT                            0249
*   NEXTBY = ADDRESS OF DATA TO BE CONVERTED                       0249
*   ADDNXT = ADDRESS OF RESULT                                     0249
*                                                                  0249
**********************************************************************
*                                                                    */
*                                                                  0249
*   RESPECIFY                                                      0249
*    (R8,                                                          0249
*     R9) RESTRICTED;               /*                       @D35UGGB*/
*HEX:                                                              0250
*   PROC;                           /*                       @D35UGGB*/
HEX      STM   @14,@12,12(@13)                                     0250
*   DO Z=NUMBER BY-1 TO 1;          /*                       @D35UGGB*/
         L     @10,NUMBER                                          0251
         ST    @10,Z                                               0251
         B     @DE00251                                            0251
@DL00251 DS    0H                                                  0252
*     R8=NEXTBYTE(Z);               /* PICK UP NEXT BYTE TO CONVERT
*                                                            @D35UGGB*/
         L     @06,NEXTBY                                          0252
         BCTR  @06,0                                               0252
         SLR   R8,R8                                               0252
         IC    R8,NEXTBYTE(@10,@06)                                0252
*     X=2*Z;                        /* OUTPUT INDEX MUST BE TWICE  0253
*                                      INPUT                 @D35UGGB*/
         LR    @06,@10                                             0253
         ALR   @06,@06                                             0253
         ST    @06,X                                               0253
*     SRDL(R8,4);                   /* SPLIT THE BYTE BETWEEN 2    0254
*                                      REGISTERS             @D35UGGB*/
         SRDL  R8,4                                                0254
*     SRL(R9,28);                   /* RIGHT JUSTIFY DATA    @D35UGGB*/
         SRL   R9,28                                               0255
*     ADDNUM(X-1)=CHARS(R8+1);      /* MOVE CHAR TO PRINT BUFFER     */
         L     @03,ADDNXT                                          0256
         ALR   @06,@03                                             0256
         BCTR  @06,0                                               0256
         BCTR  @06,0                                               0256
         LA    @01,CHARS(R8)                                       0256
         MVC   ADDNUM(1,@06),0(@01)                                0256
*     ADDNUM(X)=CHARS(R9+1);        /* DO NOT USE INDEX OF 0 @D35UGGB*/
         L     @06,X                                               0257
         ALR   @03,@06                                             0257
         BCTR  @03,0                                               0257
         LA    @06,CHARS(R9)                                       0257
         MVC   ADDNUM(1,@03),0(@06)                                0257
*   END;                            /*                       @D35UGGB*/
         BCTR  @10,0                                               0258
         ST    @10,Z                                               0258
@DE00251 LTR   @10,@10                                             0258
         BP    @DL00251                                            0258
*   END HEX;                        /*                       @D35UGGB*/
@EL00004 DS    0H                                                  0259
@EF00004 DS    0H                                                  0259
@ER00004 LM    @14,@12,12(@13)                                     0259
         BR    @14                                                 0259
*   RESPECIFY                                                      0260
*    (R8,                                                          0260
*     R9) UNRESTRICTED;             /*                       @D35UGGB*/
*                                                                  0261
*/*********************************************************************
*                                                                  0261
*   THIS PROC WILL PRINT OUT ONE LINE OF OUTPUT AND BLANK OUT THE  0261
*   BUFFER.                                                        0261
*                                                                  0261
* ********************************************************************
*                                                                    */
*                                                                  0261
*PRINTIT:                                                          0261
*   PROC;                           /*                       @D35UGGB*/
PRINTIT  STM   @14,@12,@SA00005                                    0261
*   PRINTADR=ADDR(PRTLINE1);        /*                       @D35UGGB*/
         LA    @10,PRTLINE1                                        0262
         ST    @10,PRINTADR(,R2)                                   0262
*   CALL IOHND(RITEPRTR);           /*                       @D35UGGB*/
         L     @15,ADIOHND(,R2)                                    0263
         LA    @01,@AL00263                                        0263
         BALR  @14,@15                                             0263
*   END PRINTIT;                    /*                       @D35UGGB*/
@EL00005 DS    0H                                                  0264
@EF00005 DS    0H                                                  0264
@ER00005 LM    @14,@12,@SA00005                                    0264
         BR    @14                                                 0264
*                                                                  0265
*/*********************************************************************
*                                                                  0265
*   THIS PROC WILL BUILD THE FIRST LINE OF THE EDIT DETAIL REPORT  0265
*   HEADER AND CONVERT THE CPU MODEL AND SERIAL NUMBER AND PLACE IN
*   THE OUTPUT BUFFER.                                             0265
*                                                                  0265
* RECORD ENTRY TYPE   SOURCE-OUTBOARD      MODEL XXX   SERIAL.NO. XXX
*                                                                  0265
* ********************************************************************
*                                                                    */
*                                                                  0265
*LINE1:                                                            0265
*   PROC OPTIONS(SAVE(14));         /*                       @D35UGGB*/
LINE1    ST    @14,@SA00006                                        0265
*   PRINTCHR=NEWPAGE;               /* CARRIAGE CONTROL, EJECT A PAGE*/
         MVI   PRINTCHR,X'89'                                      0266
*   CALL PRINTIT;                   /*                       @D35UGGB*/
         BAL   @14,PRINTIT                                         0267
*   NUMBER=2;                       /* CONVERT MODEL NUMBER TO CHAR  */
         MVC   NUMBER(4),@CF00072                                  0268
*   NEXTBY=ADDR(OBRMOD);            /*                       @D35UGGB*/
         LA    @10,OBRMOD(,R7)                                     0269
         ST    @10,NEXTBY                                          0269
*   ADDNXT=ADDR(MODELNO);           /*                       @D35UGGB*/
         LA    @10,MODELNO                                         0270
         ST    @10,ADDNXT                                          0270
*   CALL HEX;                       /*                       @D35UGGB*/
         BAL   @14,HEX                                             0271
*   LABL1A=LABEL1A;                 /* SET 2 LABELS FOR LINE1        */
         MVC   LABL1A(76),LABEL1A                                  0272
*   LABL1B=LABEL1B;                 /*                       @D35UGGB*/
         MVC   LABL1B(13),LABEL1B                                  0273
*   IF OBRMOD^=0 THEN               /* TEST FOR MODEL NUMBER OF 0  0274
*                                                            @D35UGGB*/
         ICM   @10,3,OBRMOD(R7)                                    0274
         BZ    @RF00274                                            0274
*     DO;                           /*                       @D35UGGB*/
*       NUMBER=3;                   /* NON 0 MODEL NUMBER SO         */
         MVC   NUMBER(4),@CF00074                                  0276
*       NEXTBY=ADDR(OBRSER);        /* CONVERT SERIAL NUMBER TO CHAR */
         LA    @10,OBRSER(,R7)                                     0277
         ST    @10,NEXTBY                                          0277
*       ADDNXT=ADDR(SERIAL);        /*                       @D35UGGB*/
         LA    @10,SERIAL                                          0278
         ST    @10,ADDNXT                                          0278
*       CALL HEX;                   /*                       @D35UGGB*/
         BAL   @14,HEX                                             0279
*     END;                          /*                       @D35UGGB*/
*   ELSE                                                           0281
*     NULLMODL=UNISERL;             /* WRITE OUT NO MODEL NO.        */
         B     @RC00274                                            0281
@RF00274 MVC   NULLMODL(28),UNISERL                                0281
*   PRINTCHR=SPACE1;                /* CARRIAGE CONTROL, SKIP 1 LINE
*                                                            @D35UGGB*/
@RC00274 MVI   PRINTCHR,X'09'                                      0282
*   CALL PRINTIT;                   /*                       @D35UGGB*/
         BAL   @14,PRINTIT                                         0283
*   END LINE1;                      /*                       @D35UGGB*/
@EL00006 DS    0H                                                  0284
@EF00006 DS    0H                                                  0284
@ER00006 L     @14,@SA00006                                        0284
         BR    @14                                                 0284
*                                                                  0285
*/*********************************************************************
*                                                                  0285
*   THIS PROC WILL BUILD THE SECOND LINE OF THE EDIT DETAIL REPORT 0285
*   HEADER AND CONVERT THE SYSTEM TYPE AND RELEASE LEVEL TO        0285
*   PRINTABLE CHARACTERS. THE SYSTEM TYPE IS THE HIGH ORDER 3 BITS 0285
*   OF OBRKEY2. THE RELEASE LEVEL IS THE LOW ORDER 5 BITS OF OBRKEY2.
*                                                                  0285
* XXX  REL.  XXX                                                   0285
*                                                                  0285
* ********************************************************************
*                                                                    */
*                                                                  0285
*   RESPECIFY                                                      0285
*    (R8,                                                          0285
*     R9) RESTRICTED;               /*                       @D35UGGB*/
*LINE2:                                                            0286
*   PROC OPTIONS(SAVE(14));         /*                       @D35UGGB*/
LINE2    ST    @14,@SA00007                                        0286
*   R8=OBRKEY2;                     /* PICK UP SYSTEM TYPE AND LEVEL */
         SLR   R8,R8                                               0287
         IC    R8,OBRKEY2(,R7)                                     0287
*   SRDL(R8,5);                     /* KEEP 3 BIT SYSTEM TYPE IN R8
*                                                            @D35UGGB*/
         SRDL  R8,5                                                0288
*   TEMP1=R8+1;                     /* DO NOT INDEX BY 0     @D35UGGB*/
         LA    @10,1                                               0289
         ALR   @10,R8                                              0289
         ST    @10,TEMP1                                           0289
*   SYSTEM=DCLREL(TEMP1);           /* SYSTEM TYPE IS COMPUTED BY  0290
*                                      INDEX TEMP1                   */
         SLA   @10,2                                               0290
         LA    @06,DCLREL-4(@10)                                   0290
         MVC   SYSTEM(4),0(@06)                                    0290
*   SRL(R9,27);                     /* SYSTEM LEVEL IN LO 5 BITS OF
*                                      R9                    @D35UGGB*/
         SRL   R9,27                                               0291
*   IF DCLREL(TEMP1)='DOS ' THEN                                   0292
         LA    @06,DCLREL-4(@10)                                   0292
         CLC   0(4,@06),@CC01296                                   0292
         BNE   @RF00292                                            0292
*     DO;                                                          0293
*       R9=R9+26;                   /* IF DOS ADD 26 TO RELEASE LEVEL
*                                                            @D35UGGB*/
         AL    R9,@CF01422                                         0294
*       IF R9>34 THEN                                              0295
         LA    @10,34                                              0295
         CR    R9,@10                                              0295
         BNH   @RF00295                                            0295
*         R9=R9-34;                                                0296
         SLR   R9,@10                                              0296
*     END;                                                         0297
*   ELSE                                                           0298
*     ;                             /*                       @D35UGGB*/
@RF00292 DS    0H                                                  0299
*   IF R9=0 THEN                    /* TEST FOR NO SYSTEM TYPE     0299
*                                                            @D35UGGB*/
@RC00292 LTR   R9,R9                                               0299
         BNZ   @RF00299                                            0299
*     LEVEL=NONE(1:4);              /* PRINT WORD NO SYSTEM TYPE   0300
*                                                            @D35UGGB*/
         MVC   LEVEL(4),NONE                                       0300
*   ELSE                                                           0301
*     DO;                           /*                       @D35UGGB*/
         B     @RC00299                                            0301
@RF00299 DS    0H                                                  0302
*       NUMBER=2;                   /* NUMBER OF CHARACTERS ON OUTPUT*/
         MVC   NUMBER(4),@CF00072                                  0302
*       BINWORD=R9;                 /* CONVERT LEVEL FORM BINARY TO
*                                      CHAR                          */
         ST    R9,BINWORD                                          0303
*       ADDNXT=ADDR(LEVEL);         /* PUT CHARACTER LEVEL IN BUFFER */
         LA    @10,LEVEL                                           0304
         ST    @10,ADDNXT                                          0304
*       CALL CONVBIN;               /* CONVERT LEVEL FROM BINARY TO
*                                      CHAR                          */
         BAL   @14,CONVBIN                                         0305
*     END;                          /*                       @D35UGGB*/
*   LABL2=LABEL2;                   /* PUT LABEL FOR LINE 2 IN PRINT
*                                      BUFFER                        */
@RC00299 MVC   LABL2(4),LABEL2                                     0307
*   CALL PRINTIT;                   /*                       @D35UGGB*/
         BAL   @14,PRINTIT                                         0308
*   END LINE2;                      /*                       @D35UGGB*/
@EL00007 DS    0H                                                  0309
@EF00007 DS    0H                                                  0309
@ER00007 L     @14,@SA00007                                        0309
         BR    @14                                                 0309
*   RESPECIFY                                                      0310
*    (R8,                                                          0310
*     R9) UNRESTRICTED;             /*                       @D35UGGB*/
*                                                                  0311
*/*********************************************************************
*                                                                  0311
*   THIS PROC BUILDS LINE THREE OF THE EDIT DETAIL REPORT HEADER   0311
*   FOR ALL 33XX DASD DEVICES.                                     0311
*                                                                  0311
*           DAY  YEAR     HH MM SS.TH          JOB IDENTITY  XXX   0311
*                                                                  0311
**********************************************************************
*                                                                    */
*                                                                  0311
*LINE3:                                                            0311
*   PROC OPTIONS(SAVE(14));         /*                       @D35UGGB*/
LINE3    ST    @14,@SA00008                                        0311
*   JOBNAME=OBRJOBID;               /*                       @D35UGGB*/
         MVC   JOBNAME(8),OBRJOBID(R7)                             0312
*   LABL3=LABEL3;                   /* PUT LABEL FOR LINE 3 IN PRINT
*                                      BUFFER                        */
         MVC   LABL3(68),LABEL3                                    0313
*   CALL PRINTIT;                   /*                       @D35UGGB*/
         BAL   @14,PRINTIT                                         0314
*   END LINE3;                      /*                       @D35UGGB*/
@EL00008 DS    0H                                                  0315
@EF00008 DS    0H                                                  0315
@ER00008 L     @14,@SA00008                                        0315
         BR    @14                                                 0315
*                                                                  0316
*/*********************************************************************
*                                                                  0316
*   THIS PROC BUILDS LINE FOUR OF THE EDIT DETAIL REPORT HEADER    0316
*   FOR ALL 33XX DASD DEVICES AND CONVERT THE DATE FROM PACKED DECIMAL
*   AND THE TIME FROM HEX TO CHARACTER DATA AND PUT IN BUFFER AND  0316
*   MOVE THE JOB NAME INTO THE PRINT BUFFER.                       0316
*                                                                  0316
*    DATE - XXX XX             TIME - XX XX XX XX          XXX     0316
*                                                                  0316
* ********************************************************************
*                                                                    */
*                                                                  0316
*LINE4:                                                            0316
*   PROC OPTIONS(SAVE(14));         /*                       @D35UGGB*/
LINE4    ST    @14,@SA00009                                        0316
*/*                                                          @D35UGGB*/
*/*     DATE ,DAY IS 3 BYTES AND YEAR IS 2 BYTES IN PACKED DECIMAL.  */
*/*                                                          @D35UGGB*/
*                                                                  0317
*   UNPK(TEMP2(1:5),OBRDATE(2:4));  /*                       @D35UGGB*/
         UNPK  TEMP2(5),OBRDATE+1(3,R7)                            0317
*   DAY=TEMP2(3:5);                 /*                       @D35UGGB*/
         MVC   DAY(3),TEMP2+2                                      0318
*   YEAR=TEMP2(1:2);                /*                       @D35UGGB*/
         MVC   YEAR(2),TEMP2                                       0319
*/*                                                          @D35UGGB*/
*/*     HOURS                                                @D35UGGB*/
*/*                                                          @D35UGGB*/
*                                                                  0320
*   NUMBER=1;                       /*                       @D35UGGB*/
         MVC   NUMBER(4),@CF00053                                  0320
*   NEXTBY=ADDR(OBRHOUR);           /*                       @D35UGGB*/
         LA    @10,OBRHOUR(,R7)                                    0321
         ST    @10,NEXTBY                                          0321
*   ADDNXT=ADDR(HOURS);             /*                       @D35UGGB*/
         LA    @10,HOURS                                           0322
         ST    @10,ADDNXT                                          0322
*   CALL HEX;                       /*                       @D35UGGB*/
         BAL   @14,HEX                                             0323
*/*                                                          @D35UGGB*/
*/*     MINUTES                                              @D35UGGB*/
*/*                                                          @D35UGGB*/
*                                                                  0324
*   NEXTBY=ADDR(OBRMINTE);          /*                       @D35UGGB*/
         LA    @10,OBRMINTE(,R7)                                   0324
         ST    @10,NEXTBY                                          0324
*   ADDNXT=ADDR(MINUTES);           /*                       @D35UGGB*/
         LA    @10,MINUTES                                         0325
         ST    @10,ADDNXT                                          0325
*   CALL HEX;                       /*                       @D35UGGB*/
         BAL   @14,HEX                                             0326
*/*                                                          @D35UGGB*/
*/*     SECONDS                                              @D35UGGB*/
*/*                                                          @D35UGGB*/
*                                                                  0327
*   NEXTBY=ADDR(OBRSECOD);          /*                       @D35UGGB*/
         LA    @10,OBRSECOD(,R7)                                   0327
         ST    @10,NEXTBY                                          0327
*   ADDNXT=ADDR(SECONDS);           /*                       @D35UGGB*/
         LA    @10,SECONDS                                         0328
         ST    @10,ADDNXT                                          0328
*   CALL HEX;                       /*                       @D35UGGB*/
         BAL   @14,HEX                                             0329
*/*                                                          @D35UGGB*/
*/*     THOUSANDS OF SECONDS                                 @D35UGGB*/
*/*                                                          @D35UGGB*/
*                                                                  0330
*   NEXTBY=ADDR(OBRTHSEC);          /*                       @D35UGGB*/
         LA    @10,OBRTHSEC(,R7)                                   0330
         ST    @10,NEXTBY                                          0330
*   ADDNXT=ADDR(THSECOND);          /*                       @D35UGGB*/
         LA    @10,THSECOND                                        0331
         ST    @10,ADDNXT                                          0331
*   CALL HEX;                       /*                       @D35UGGB*/
         BAL   @14,HEX                                             0332
*/*                                                          @D35UGGB*/
*/*     JOB NAME                                             @D35UGGB*/
*/*                                                          @D35UGGB*/
*                                                                  0333
*   NUMBER=8;                       /*                       @D35UGGB*/
         MVC   NUMBER(4),@CF00064                                  0333
*   NEXTBY=ADDR(OBRJOBID);          /*                       @D35UGGB*/
         LA    @10,OBRJOBID(,R7)                                   0334
         ST    @10,NEXTBY                                          0334
*   ADDNXT=ADDR(HEXJOB);            /*                       @D35UGGB*/
         LA    @10,HEXJOB                                          0335
         ST    @10,ADDNXT                                          0335
*   CALL HEX;                       /*                       @D35UGGB*/
         BAL   @14,HEX                                             0336
*   LABL4A=LABEL4A;                 /* PUT LABEL FOR LINE 4 IN PRINT
*                                      BUFFER                        */
         MVC   LABL4A(7),LABEL4A                                   0337
*   LABL4B=LABEL4B;                 /*                       @D35UGGB*/
         MVC   LABL4B(7),LABEL4B                                   0338
*   PRINTCHR=SPACE2;                /* CARRIAGE CONTROL, SKIP 2 LINES
*                                                            @D35UGGB*/
         MVI   PRINTCHR,X'11'                                      0339
*   CALL PRINTIT;                   /*                       @D35UGGB*/
         BAL   @14,PRINTIT                                         0340
*   PRINTCHR=SPACE1;                /* CARRIAGE CONTROL, SKIP 1 LINE
*                                                            @D35UGGB*/
         MVI   PRINTCHR,X'09'                                      0341
*   END LINE4;                      /*                       @D35UGGB*/
@EL00009 DS    0H                                                  0342
@EF00009 DS    0H                                                  0342
@ER00009 L     @14,@SA00009                                        0342
         BR    @14                                                 0342
*                                                                  0343
*/*********************************************************************
*                                                                  0343
*   THIS PROC WILL BUILD LINE FIVE OF THE EDIT DETAIL REPORT HEADER
*   FOR ALL 33XX DASD DEVICES AND CONVERT THE DEVICE TYPE TO DASD  0343
*   MODEL NUMBER.                                                  0343
*                                                                  0343
*    DEVICE TYPE IS A        XXX                                   0343
*                                                                  0343
* ********************************************************************
*                                                                    */
*                                                                  0343
*LINE5:                                                            0343
*   PROC OPTIONS(SAVE(14));         /*                       @D35UGGB*/
LINE5    ST    @14,@SA00010                                        0343
*   IF OBRDEV=DEV3330 THEN          /* TEST FOR 3330 DEVICE  @D35UGGB*/
         CLC   OBRDEV(2,R7),DEV3330                                0344
         BNE   @RF00344                                            0344
*     TYPE=CH3330;                  /*                       @D35UGGB*/
         MVC   TYPE(8),CH3330                                      0345
*   ELSE                                                           0346
*     IF OBRDEV=DEV3340 THEN        /* TEST FOR 3340 DEVICE  @D35UGGB*/
         B     @RC00344                                            0346
@RF00344 CLC   OBRDEV(2,R7),DEV3340                                0346
         BNE   @RF00346                                            0346
*       TYPE=CH3340;                /*                       @D35UGGB*/
         MVC   TYPE(8),CH3340                                      0347
*     ELSE                                                         0348
*       IF OBRDEV=DEV3350 THEN      /* TEST FOR 3350 DEVICE  @D35UGGB*/
         B     @RC00346                                            0348
@RF00346 CLC   OBRDEV(2,R7),DEV3350                                0348
         BNE   @RF00348                                            0348
*         TYPE=CH3350;              /*                       @D35UGGB*/
         MVC   TYPE(8),CH3350                                      0349
*       ELSE                                                       0350
*         IF OBRDEV=DEV33301 THEN   /* TEST FOR 3330 MOD 11 DEVICE   */
         B     @RC00348                                            0350
@RF00348 CLC   OBRDEV(2,R7),DEV33301                               0350
         BNE   @RF00350                                            0350
*           TYPE=CH33301;           /*                       @D35UGGB*/
         MVC   TYPE(8),CH33301                                     0351
*         ELSE                                                     0352
*           IF OBRDEV=DEVWOOD THEN  /* TEST FOR 3310 DEVICE          */
         B     @RC00350                                            0352
@RF00350 CLC   OBRDEV(2,R7),DEVWOOD                                0352
         BNE   @RF00352                                            0352
*             TYPE=CHWOOD;          /*                       @D35UGGB*/
         MVC   TYPE(8),CHWOOD                                      0353
*           ELSE                                                   0354
*             IF OBRDEV=DEV3370 THEN                               0354
         B     @RC00352                                            0354
@RF00352 CLC   OBRDEV(2,R7),DEV3370                                0354
         BNE   @RF00354                                            0354
*               TYPE=CH3370;        /*                       @D3506GB*/
         MVC   TYPE(8),CH3370                                      0355
*             ELSE                                                 0356
*               TYPE=NONE;          /*                       @D35UGGB*/
         B     @RC00354                                            0356
@RF00354 MVI   TYPE+7,C' '                                         0356
         MVC   TYPE(7),NONE                                        0356
*   IF OBRSBCNT^=HEX18 THEN         /* TEST FOR A VIRTUAL DEVICE     */
@RC00354 DS    0H                                                  0357
@RC00352 DS    0H                                                  0357
@RC00350 DS    0H                                                  0357
@RC00348 DS    0H                                                  0357
@RC00346 DS    0H                                                  0357
@RC00344 CLC   OBRSBCNT(2,R7),@CB01360                             0357
         BE    @RF00357                                            0357
*     FAKEDEVC=VIRTUAL;             /*                       @D35UGGB*/
         MVC   FAKEDEVC(18),VIRTUAL                                0358
*   ELSE                                                           0359
*     IF EMULATE=ON THEN            /* TEST FOR EMULATED DEVICE    0359
*                                                            @D35UGGB*/
         B     @RC00357                                            0359
@RF00357 TM    EMULATE,B'00001000'                                 0359
         BNO   @RF00359                                            0359
*       FAKEDEVC=EMULAT;            /*                       @D35UGGB*/
         MVC   FAKEDEVC(18),EMULAT                                 0360
*     ELSE                                                         0361
*       ;                           /*                       @D35UGGB*/
@RF00359 DS    0H                                                  0362
*   LABL5=LABEL5;                   /* PUT LABEL FOR LINE 5 IN BUFFER*/
@RC00357 MVC   LABL5(16),LABEL5                                    0362
*   CALL PRINTIT;                   /*                       @D35UGGB*/
         BAL   @14,PRINTIT                                         0363
*   END LINE5;                      /*                       @D35UGGB*/
@EL00010 DS    0H                                                  0364
@EF00010 DS    0H                                                  0364
@ER00010 L     @14,@SA00010                                        0364
         BR    @14                                                 0364
*                                                                  0365
*/*********************************************************************
*                                                                  0365
*   THIS PROC WILL BUILD LINE SIX OF THE EDIT DETAIL REPORT HEADER 0365
*   FOR ALL 33XX DASD DEVICES AND CONVERT THE PHYSICAL CHANNEL UNIT
*   ADDRESS TO CHARACTER DATA.                                     0365
*                                                                  0365
*    PHYSICAL CHANNEL UNIT ADDRESS    XXX                          0365
*                                                                  0365
* ********************************************************************
*                                                                    */
*                                                                  0365
*LINE6:                                                            0365
*   PROC OPTIONS(SAVE(14));         /*                       @D35UGGB*/
LINE6    ST    @14,@SA00011                                        0365
*   NUMBER=3;                       /* LENGTH OF PCUA        @D35UGGB*/
         MVC   NUMBER(4),@CF00074                                  0366
*   NEXTBY=ADDR(OBRPCUA);           /* CALL HEX TO CONVERT PCUA TO 0367
*                                      CHAR                  @D35UGGB*/
         LA    @10,OBRPCUA(,R7)                                    0367
         ST    @10,NEXTBY                                          0367
*   ADDNXT=ADDR(PCUA);              /* OUTPUT SPACE          @D35UGGB*/
         LA    @10,PCUA                                            0368
         ST    @10,ADDNXT                                          0368
*   CALL HEX;                       /*                       @D35UGGB*/
         BAL   @14,HEX                                             0369
*   LABL6=LABEL6;                   /* PUT LABEL FOR LINE 6 IN BUFFER*/
         MVC   LABL6(29),LABEL6                                    0370
*   CALL PRINTIT;                   /*                       @D35UGGB*/
         BAL   @14,PRINTIT                                         0371
*   END LINE6;                      /*                       @D35UGGB*/
@EL00011 DS    0H                                                  0372
@EF00011 DS    0H                                                  0372
@ER00011 L     @14,@SA00011                                        0372
         BR    @14                                                 0372
*                                                                  0373
*/*********************************************************************
*                                                                  0373
*   THIS PROC WILL BUILD LINE SEVEN OF THE EDIT DETAIL REPORT HEADER
*   FOR ALL 33XX DASD DEVICES . IT WILL CONVERT THE LOGICAL CHANNEL UNI
*   ADDRESS TO CHARACTER DATA.                                     0373
*                                                                  0373
*    LOGICAL CHANNEL UNIT ADDRESS    XXX                           0373
*                                                                  0373
* ********************************************************************
*                                                                    */
*                                                                  0373
*LINE7:                                                            0373
*   PROC OPTIONS(SAVE(14));         /*                       @D35UGGB*/
LINE7    ST    @14,@SA00012                                        0373
*   NUMBER=3;                       /* LENGTH OF SCUA        @D35UGGB*/
         MVC   NUMBER(4),@CF00074                                  0374
*   NEXTBY=ADDR(OBRSECUA);          /* CONVERT SCUA TO CHAR  @D35UGGB*/
         LA    @10,OBRSECUA(,R7)                                   0375
         ST    @10,NEXTBY                                          0375
*   ADDNXT=ADDR(LCUA);              /*                       @D35UGGB*/
         LA    @10,LCUA                                            0376
         ST    @10,ADDNXT                                          0376
*   CALL HEX;                       /*                       @D35UGGB*/
         BAL   @14,HEX                                             0377
*   LABL7=LABEL7;                   /* PUT LABEL FOR LINE 7 IN BUFFER*/
         MVC   LABL7(28),LABEL7                                    0378
*   CALL PRINTIT;                   /*                       @D35UGGB*/
         BAL   @14,PRINTIT                                         0379
*   END LINE7;                      /*                       @D35UGGB*/
@EL00012 DS    0H                                                  0380
@EF00012 DS    0H                                                  0380
@ER00012 L     @14,@SA00012                                        0380
         BR    @14                                                 0380
*                                                                  0381
*/*********************************************************************
*                                                                  0381
*   THIS PROC WILL BUILD LINE EIGHT OF THE EDIT DETAIL REPORT HEADER
*   FOR NON EMULATED 3330 DEVICES ONLY. IT CONVERTS THE PHYSICAL DRIVE
*   BY CHANGING THE NUMBERS (0-7) FROM THE LO ORDER 3 BITS OF OBRPCUA
*   TO THE CHARACTERS (A-H).                                       0381
*                                                                  0381
*    PHYSICAL DRIVE   XXX                                          0381
*                                                                  0381
* ********************************************************************
*                                                                    */
*                                                                  0381
*   RESPECIFY                                                      0381
*    (R8) RESTRICTED;               /*                       @D35UGGB*/
*LINE8:                                                            0382
*   PROC OPTIONS(SAVE(14));         /*                       @D35UGGB*/
LINE8    ST    @14,@SA00013                                        0382
*   IF(OBRDEV=DEV3330&EMULATE=OFF)|(OBRDEV=DEV33301&EMULATE=OFF) THEN
         CLC   OBRDEV(2,R7),DEV3330                                0383
         BNE   @GL00007                                            0383
         TM    EMULATE,B'00001000'                                 0383
         BZ    @RT00383                                            0383
@GL00007 CLC   OBRDEV(2,R7),DEV33301                               0383
         BNE   @RF00383                                            0383
         TM    EMULATE,B'00001000'                                 0383
         BNZ   @RF00383                                            0383
@RT00383 DS    0H                                                  0384
*     DO;                           /*                       @D35UGGB*/
*       R8=PHYSIDRV;                /* PICK UP PHYSICAL DRIVE + 1 BIT*/
         SLR   R8,R8                                               0385
         IC    R8,PHYSIDRV(,R7)                                    0385
*       R8=R8&HEX07;                /* ZERO ALL BITS BUT PHYSICAL  0386
*                                      DRIVE                         */
         N     R8,@CF01364                                         0386
*       IF R8=0 THEN                                               0387
         LTR   R8,R8                                               0387
         BNZ   @RF00387                                            0387
*         PHDRIVE='A';              /*                       @D35UGGB*/
         MVI   PHDRIVE,C'A'                                        0388
*       ELSE                                                       0389
*         IF R8=1 THEN                                             0389
         B     @RC00387                                            0389
@RF00387 C     R8,@CF00053                                         0389
         BNE   @RF00389                                            0389
*           PHDRIVE='B';            /*                       @D35UGGB*/
         MVI   PHDRIVE,C'B'                                        0390
*         ELSE                                                     0391
*           IF R8=2 THEN                                           0391
         B     @RC00389                                            0391
@RF00389 C     R8,@CF00072                                         0391
         BNE   @RF00391                                            0391
*             PHDRIVE='C';          /*                       @D35UGGB*/
         MVI   PHDRIVE,C'C'                                        0392
*           ELSE                                                   0393
*             IF R8=3 THEN                                         0393
         B     @RC00391                                            0393
@RF00391 C     R8,@CF00074                                         0393
         BNE   @RF00393                                            0393
*               PHDRIVE='D';        /*                       @D35UGGB*/
         MVI   PHDRIVE,C'D'                                        0394
*             ELSE                                                 0395
*               IF R8=4 THEN                                       0395
         B     @RC00393                                            0395
@RF00393 C     R8,@CF00062                                         0395
         BNE   @RF00395                                            0395
*                 PHDRIVE='E';      /*                       @D35UGGB*/
         MVI   PHDRIVE,C'E'                                        0396
*               ELSE                                               0397
*                 IF R8=5 THEN                                     0397
         B     @RC00395                                            0397
@RF00395 C     R8,@CF00077                                         0397
         BNE   @RF00397                                            0397
*                   PHDRIVE='F';    /*                       @D35UGGB*/
         MVI   PHDRIVE,C'F'                                        0398
*                 ELSE                                             0399
*                   IF R8=6 THEN                                   0399
         B     @RC00397                                            0399
@RF00397 C     R8,@CF00079                                         0399
         BNE   @RF00399                                            0399
*                     PHDRIVE='G';  /*                       @D35UGGB*/
         MVI   PHDRIVE,C'G'                                        0400
*                   ELSE                                           0401
*                     IF R8=7 THEN                                 0401
         B     @RC00399                                            0401
@RF00399 C     R8,@CF00081                                         0401
         BNE   @RF00401                                            0401
*                       PHDRIVE='H';/*                       @D35UGGB*/
         MVI   PHDRIVE,C'H'                                        0402
*                     ELSE                                         0403
*                       ;           /*                       @D35UGGB*/
@RF00401 DS    0H                                                  0404
*       LABL8=LABEL8;               /* PUT LABEL FOR LINE 8 IN BUFFER*/
@RC00399 DS    0H                                                  0404
@RC00397 DS    0H                                                  0404
@RC00395 DS    0H                                                  0404
@RC00393 DS    0H                                                  0404
@RC00391 DS    0H                                                  0404
@RC00389 DS    0H                                                  0404
@RC00387 MVC   LABL8(14),LABEL8                                    0404
*       CALL PRINTIT;               /*                       @D35UGGB*/
         BAL   @14,PRINTIT                                         0405
*     END;                          /*                       @D35UGGB*/
*   ELSE                                                           0407
*     ;                             /*                       @D35UGGB*/
@RF00383 DS    0H                                                  0408
*   END LINE8;                      /*                       @D35UGGB*/
@EL00013 DS    0H                                                  0408
@EF00013 DS    0H                                                  0408
@ER00013 L     @14,@SA00013                                        0408
         BR    @14                                                 0408
*   RESPECIFY                                                      0409
*    (R8) UNRESTRICTED;             /*                       @D35UGGB*/
*                                                                  0410
*/*********************************************************************
*                                                                  0410
*   THIS PROC WILL BUILD LINE NINE OF THE EDIT DETAIL REPORT HEADER
*   FOR ALL 33XX DASD DEVICES AND MOVE THE VOLUME LABEL TO THE PRINT
*   BUFFER.                                                        0410
*                                                                  0410
*    VOLUME LABEL     XXX                                          0410
*                                                                  0410
* ********************************************************************
*                                                                    */
*                                                                  0410
*LINE9:                                                            0410
*   PROC OPTIONS(SAVE(14));         /*                       @D35UGGB*/
LINE9    ST    @14,@SA00014                                        0410
*   VOLLABEL=OBRVOL;                /*                       @D35UGGB*/
         MVC   VOLLABEL(6),OBRVOL(R7)                              0411
*   LABL9=LABEL9;                   /* PUT LABEL FOR LINE 9 IN BUFFER*/
         MVC   LABL9(12),LABEL9                                    0412
*   CALL PRINTIT;                   /*                       @D35UGGB*/
         BAL   @14,PRINTIT                                         0413
*   END LINE9;                      /*                       @D35UGGB*/
@EL00014 DS    0H                                                  0414
@EF00014 DS    0H                                                  0414
@ER00014 L     @14,@SA00014                                        0414
         BR    @14                                                 0414
*                                                                  0415
*/*********************************************************************
*                                                                  0415
*   THIS PROC WILL BUILD LINE TEN OF THE EDIT DETAIL REPORT HEADER 0415
*   FOR ALL 33XX DASD DEVICES AND DETERMINE THE TYPE OF ERROR      0415
*   DETECTED IN THE FOLLOWING WAY:                                 0415
*     METHODOLOGY:                                                 0415
*       FORMAT REFERS TO BITS 0-3 IN SENSE BYTE 7                  0415
*       F1 = FORMAT 1,F2 = FORMAT 2 ETC                            0415
*       F1A = FORMAT TYPE = A (SENSE BYTE 7 = '1A'X                0415
*       SENSE BITS DESCRIBED THUS: (0,4) BYTE 0 BIT 4              0415
*     ERRORS:                                                      0415
*       BUS OUT PARITY                                             0415
*         (0,2) IS ON                                              0415
*       OVERRUN                                                    0415
*         (0,5) IS ON                                              0415
*       EQUIPMENT CHECK                                            0415
*         CONTROL UNIT TEMPORARY                                   0415
*           OBRTEMP IS ON & (0,3) IS ON & (^ F1 & ^ F7 & ^F8)      0415
*         CONTROL UNIT PERMANENT                                   0415
*           OBRTEMP IS OFF & (0,3) IS ON & (^ F1 & ^ F7 & ^F8)     0415
*         DRIVE  TEMPORARY                                         0415
*           OBRTEMP IS ON & (0,3) IS ON & ( F1 |  F7 | F8) &       0415
*           (^F1A & ^F1B)                                          0415
*         DRIVE PERMANENT                                          0415
*           OBRTEMP IS OFF & (0,3) IS ON & ( F1 |  F7 | F8) &      0415
*           (^F1A & ^F1B)                                          0415
*       DATA CHECK                                                 0415
*         LOGGING MODE UNCORRECTABLE TEMPORARY                     0415
*           (2,3) IS ON & F4 &(^F49 & ^F4D)                        0415
*         LOGGING MODE CORRECTABLE                                 0415
*           (2,3) IS ON & F5                                       0415
*         CORRECTABLE                                              0415
*           (0,4) IS ON & F5                                       0415
*         UNCORRECTABLE PERMANENT                                  0415
*           (0,4) IS ON & F4 & OBRTEMP IS OFF                      0415
*         UNCORRECTABLE TEMPORARY                                  0415
*           (0,4) IS ON & F4 & OBRTEMP IS ON                       0415
*       CHECK DATA                                                 0415
*         LOGGING MODE TEMPORARY                                   0415
*            FBA DEVICE & (2,3) IS ON & (F49 | F4D)                0415
*         CORRECTABLE                                              0415
*           (2,0) IS ON & FBA DEVICE & F5                          0415
*         TEMPORARY                                                0415
*           (2,0) IS ON & FBA DEVICE & OBRTEMP IS ON  & F4         0415
*         PERMANENT                                                0415
*           (2,0) IS ON & FBA DEVICE & OBRTEMP IS OFF & F4         0415
*       SEEK CHECK                                                 0415
*         LOGGING MODE TEMPORARY                                   0415
*           (2,3) IS ON & (F1A |F1B)                               0415
*         TEMPORARY                                                0415
*           (F1A | F1B) & OBRTEMP IS ON  & (0,3) IS ON     OR      0415
*           (0,7) IS ON & OBRTEMP IS ON                            0415
*         PERMANENT                                                0415
*           (F1A | F1B) & OBRTEMP IS OFF & (0,3) IS ON     OR      0415
*           (0,7) IS ON & OBRTEMP IS OFF                           0415
*       INTERVENTION REQUIRED                                      0415
*         TEMPORARY                                                0415
*           (0,1) IS ON & OBRTEMP IS ON                            0415
*         PERMANENT                                                0415
*           (0,1) IS ON & OBRTEMP IS OFF                           0415
*       COMMAND REJECT                                             0415
*         TREATED AS UNKNOWN                                       0415
*                                                                  0415
*   ERROR DESCRIPTION   XXX                                        0415
*                                                                  0415
**********************************************************************/
*                                                                  0415
*LINE10:                                                           0415
*   PROC OPTIONS(SAVE(14));         /*                       @D35UGGB*/
LINE10   ST    @14,@SA00015                                        0415
*   FORMAT=OBRSENS7&'F0'X;          /* SAVE FORMAT TYPE      @D35UGGB
*                                      TEST EQUIPMENT CHECK BIT (0,3)
*                                      ERRORS                @D35UGGB*/
         MVC   FORMAT(1),OBRSENS7                                  0416
         NI    FORMAT,X'F0'                                        0416
*   IF EQUCK=ON THEN                                               0417
         TM    EQUCK,B'00010000'                                   0417
         BNO   @RF00417                                            0417
*     IF OBRSENS7=F1A|OBRSENS7=F1B THEN/* TEST SENSE BYTE 7          */
         CLI   OBRSENS7,X'1A'                                      0418
         BE    @RT00418                                            0418
         CLI   OBRSENS7,X'1B'                                      0418
         BNE   @RF00418                                            0418
@RT00418 DS    0H                                                  0419
*       IF OBRTEMP='1'B THEN        /* TEST TEMP BIT         @D35UGGB*/
         TM    OBRTEMP(R7),B'01000000'                             0419
         BNO   @RF00419                                            0419
*         ERROR(1:LENGTH(SEKCKT))=SEKCKT;/* SEEK CHECK TEMP          */
         MVC   ERROR(22),SEKCKT                                    0420
*       ELSE                                                       0421
*         ERROR(1:LENGTH(SEKCKP))=SEKCKP;/* SEEK CHECK PERM          */
         B     @RC00419                                            0421
@RF00419 MVC   ERROR(22),SEKCKP                                    0421
*     ELSE                                                         0422
*       IF FORMAT=F1|FORMAT=F7|FORMAT=F8 THEN/* TEST FORMAT          */
         B     @RC00418                                            0422
@RF00418 CLI   FORMAT,X'10'                                        0422
         BE    @RT00422                                            0422
         CLI   FORMAT,X'70'                                        0422
         BE    @RT00422                                            0422
         CLI   FORMAT,X'80'                                        0422
         BNE   @RF00422                                            0422
@RT00422 DS    0H                                                  0423
*         IF OBRTEMP=ON THEN        /* TEST TEMP BIT         @D35UGGB*/
         TM    OBRTEMP(R7),B'01000000'                             0423
         BNO   @RF00423                                            0423
*           ERROR(1:LENGTH(EQIPDT))=EQIPDT;/*                @D35UGGB*/
         MVC   ERROR(35),EQIPDT                                    0424
*         ELSE                                                     0425
*           ERROR(1:LENGTH(EQIPDP))=EQIPDP;/*                @D35UGGB*/
         B     @RC00423                                            0425
@RF00423 MVC   ERROR(35),EQIPDP                                    0425
*       ELSE                                                       0426
*         IF OBRTEMP=ON THEN        /* TEST TEMP BIT                 */
         B     @RC00422                                            0426
@RF00422 TM    OBRTEMP(R7),B'01000000'                             0426
         BNO   @RF00426                                            0426
*           ERROR(1:LENGTH(EQIPCT))=EQIPCT;/*                @D35UGGB*/
         MVC   ERROR(43),EQIPCT                                    0427
*         ELSE                                                     0428
*           ERROR(1:LENGTH(EQIPCP))=EQIPCP;/*                @D35UGGB*/
         B     @RC00426                                            0428
@RF00426 MVC   ERROR(43),EQIPCP                                    0428
*   ELSE                            /* TEST ENVIRONMENTAL DATA BIT 0429
*                                      (2,3) FOR ALL LOGGING MODE  0429
*                                      ERRORS                @D35UGGB*/
*     IF EVR=ON THEN                /* ENVIRONMENT DATA BIT (2,33)   */
         B     @RC00417                                            0429
@RF00417 TM    EVR,B'00010000'                                     0429
         BNO   @RF00429                                            0429
*       IF FORMAT=F4 THEN           /* TEST FOR FORMAT 4     @D35UGGB*/
         CLI   FORMAT,X'40'                                        0430
         BNE   @RF00430                                            0430
*         IF OBRSENS7^=F49&OBRSENS7^=F4D THEN/* BYTE 7 '49' | '4D'   */
         CLI   OBRSENS7,X'49'                                      0431
         BE    @RF00431                                            0431
         CLI   OBRSENS7,X'4D'                                      0431
         BE    @RF00431                                            0431
*           ERROR(1:LENGTH(DATCKUL))=DATCKUL;/* DATA CHECK UNCOR LOG */
         MVC   ERROR(53),DATCKUL                                   0432
*         ELSE                                                     0433
*           IF OBRCLASS=FBA THEN    /* CHECK DATA ERRORS ON FBA ONLY */
         B     @RC00431                                            0433
@RF00431 CLI   OBRCLASS(R7),X'21'                                  0433
         BNE   @RF00433                                            0433
*             ERROR(1:LENGTH(CKDL))=CKDL;/* CHECK DATA LOG           */
         MVC   ERROR(43),CKDL                                      0434
*           ELSE                                                   0435
*             ERROR(1:LENGTH(UNKN))=UNKN;/* UNKNOWN          @D35UGGB*/
         B     @RC00433                                            0435
@RF00433 MVC   ERROR(7),UNKN                                       0435
*       ELSE                                                       0436
*         IF FORMAT=F5 THEN         /* TEST FOR FORMAT 5     @D35UGGB*/
         B     @RC00430                                            0436
@RF00430 CLI   FORMAT,X'50'                                        0436
         BNE   @RF00436                                            0436
*           ERROR(1:LENGTH(DATCKCL))=DATCKCL;/* DATA CHECK LOG       */
         MVC   ERROR(39),DATCKCL                                   0437
*         ELSE                                                     0438
*           IF OBRSENS7=F1A|OBRSENS7=F1B THEN/* TEST FORMAT          */
         B     @RC00436                                            0438
@RF00436 CLI   OBRSENS7,X'1A'                                      0438
         BE    @RT00438                                            0438
         CLI   OBRSENS7,X'1B'                                      0438
         BNE   @RF00438                                            0438
@RT00438 DS    0H                                                  0439
*             ERROR(1:LENGTH(SEKCKL))=SEKCKL;/* SEEK CHECK LOG       */
         MVC   ERROR(37),SEKCKL                                    0439
*           ELSE                                                   0440
*             ERROR(1:LENGTH(UNKN))=UNKN;/* UNKNOWN          @D35UGGB*/
         B     @RC00438                                            0440
@RF00438 MVC   ERROR(7),UNKN                                       0440
*     ELSE                          /* TEST DATA CHECK BIT (0,4) FOR
*                                      FOR ALL DATA CHECK ERRORS     */
*       IF DATACK=ON THEN           /* DATA CHECK BIT (0,4)  @D35UGGB*/
         B     @RC00429                                            0441
@RF00429 TM    DATACK,B'00001000'                                  0441
         BNO   @RF00441                                            0441
*         IF FORMAT=F5 THEN         /* IF FORMAT 5 THEN CORR ERRORS  */
         CLI   FORMAT,X'50'                                        0442
         BNE   @RF00442                                            0442
*           ERROR(1:LENGTH(DATCKC))=DATCKC;/* DATA CHECK CORR        */
         MVC   ERROR(24),DATCKC                                    0443
*         ELSE                                                     0444
*           IF FORMAT=F4 THEN       /* FORMAT 4 MEANS UNCORR @D35UGGB*/
         B     @RC00442                                            0444
@RF00442 CLI   FORMAT,X'40'                                        0444
         BNE   @RF00444                                            0444
*             IF OBRTEMP=ON THEN    /* TEST TEMP BIT         @D35UGGB*/
         TM    OBRTEMP(R7),B'01000000'                             0445
         BNO   @RF00445                                            0445
*               ERROR(1:LENGTH(DATCKUT))=DATCKUT;/* DATA CHECK TEM   */
         MVC   ERROR(38),DATCKUT                                   0446
*             ELSE                                                 0447
*               ERROR(1:LENGTH(DATCKUP))=DATCKUP;/* DATA CHECK PER   */
         B     @RC00445                                            0447
@RF00445 MVC   ERROR(38),DATCKUP                                   0447
*           ELSE                                                   0448
*             ERROR(1:LENGTH(UNKN))=UNKN;/* UNKNOWN          @D35UGGB*/
         B     @RC00444                                            0448
@RF00444 MVC   ERROR(7),UNKN                                       0448
*       ELSE                        /* TEST CHECK DATA BIT (2,0) FOR
*                                      1, TO LOCATE ALL CHECK DATA 0449
*                                      ERRORS.               @D35UGGB*/
*         IF OBRCLASS=FBA&          /* CHECK DATA BIT (2,0)  @D35UGGB*/
*             CHECKDAT=ON THEN      /* CHECK DATA ONLY FBA   @D35UGGB*/
         B     @RC00441                                            0449
@RF00441 CLI   OBRCLASS(R7),X'21'                                  0449
         BNE   @RF00449                                            0449
         TM    CHECKDAT,B'10000000'                                0449
         BNO   @RF00449                                            0449
*           IF FORMAT=F5 THEN       /* FORMAT 5 MEANS CORR   @D35UGGB*/
         CLI   FORMAT,X'50'                                        0450
         BNE   @RF00450                                            0450
*             ERROR(1:LENGTH(CKDC))=CKDC;/* CHECK DATA CORR          */
         MVC   ERROR(30),CKDC                                      0451
*           ELSE                                                   0452
*             IF FORMAT=F4 THEN     /* FORMAT 4 MEANS UNCORR         */
         B     @RC00450                                            0452
@RF00450 CLI   FORMAT,X'40'                                        0452
         BNE   @RF00452                                            0452
*               IF OBRTEMP=ON THEN  /* TEST TEMP BIT                 */
         TM    OBRTEMP(R7),B'01000000'                             0453
         BNO   @RF00453                                            0453
*                 ERROR(1:LENGTH(CKDT))=CKDT;/* CHECK DATA T         */
         MVC   ERROR(28),CKDT                                      0454
*               ELSE                                               0455
*                 ERROR(1:LENGTH(CKDP))=CKDP;/* CHECK DATA P         */
         B     @RC00453                                            0455
@RF00453 MVC   ERROR(28),CKDP                                      0455
*             ELSE                                                 0456
*               ERROR(1:LENGTH(UNKN))=UNKN;/* UNKNOWN                */
         B     @RC00452                                            0456
@RF00452 MVC   ERROR(7),UNKN                                       0456
*         ELSE                      /* TEST SEEK CHECK BIT (0,7) FOR
*                                      1 AND DETERMINE ALL SEEK CHECK
*                                      ERRORS                        */
*           IF SEEKCK=ON THEN       /* SEEK CHECK BIT (0,7)  @D35UGGB*/
         B     @RC00449                                            0457
@RF00449 TM    SEEKCK,B'00000001'                                  0457
         BNO   @RF00457                                            0457
*             IF OBRTEMP=ON THEN    /* TEST TEMP BIT         @D35UGGB*/
         TM    OBRTEMP(R7),B'01000000'                             0458
         BNO   @RF00458                                            0458
*               ERROR(1:LENGTH(SEKCKT))=SEKCKT;/* SEEK CHECK TEMP    */
         MVC   ERROR(22),SEKCKT                                    0459
*             ELSE                                                 0460
*               ERROR(1:LENGTH(SEKCKP))=SEKCKP;/* SEEK CHECK PERM    */
         B     @RC00458                                            0460
@RF00458 MVC   ERROR(22),SEKCKP                                    0460
*           ELSE                    /* TEST OVERRUN BIT (0,5) FOR 1
*                                      TO TEST FOR AN OVERRUN ERROR
*                                                            @D35UGGB*/
*             IF OVERRN=ON THEN     /* TEST OVERRUN BIT (0,5)        */
         B     @RC00457                                            0461
@RF00457 TM    OVERRN,B'00000100'                                  0461
         BNO   @RF00461                                            0461
*               ERROR(1:LENGTH(OVERRUN))=OVERRUN;/*          @D35UGGB*/
         MVC   ERROR(7),OVERRUN                                    0462
*             ELSE                  /* TEST BUS OUT PARITY BIT (0,2)
*                                      FOR 1 TO TEST FOR A BUS OUT 0463
*                                      PARITY ERROR          @D35UGGB*/
*               IF BUSOUT=ON THEN   /* BUS OUT PARITY BIT (0,2)      */
         B     @RC00461                                            0463
@RF00461 TM    BUSOUT,B'00100000'                                  0463
         BNO   @RF00463                                            0463
*                 ERROR(1:LENGTH(BUSPAR))=BUSPAR;/*          @D35UGGB*/
         MVC   ERROR(14),BUSPAR                                    0464
*               ELSE                /* TEST INTERVENTION REQUIRED BIT
*                                      (0,1) FOR 1, TO DETECT THOSE
*                                      ERRORS                        */
*                 IF INTREQ=ON THEN                                0465
         B     @RC00463                                            0465
@RF00463 TM    INTREQ,B'01000000'                                  0465
         BNO   @RF00465                                            0465
*                   IF OBRTEMP=ON THEN                             0466
         TM    OBRTEMP(R7),B'01000000'                             0466
         BNO   @RF00466                                            0466
*                     ERROR(1:LENGTH(INTVREQT))=INTVREQT;          0467
         MVC   ERROR(33),INTVREQT                                  0467
*                   ELSE                                           0468
*                     ERROR(1:LENGTH(INTVREQP))=INTVREQP;          0468
         B     @RC00466                                            0468
@RF00466 MVC   ERROR(33),INTVREQP                                  0468
*                 ELSE                                             0469
*                   ERROR(1:LENGTH(UNKN))=UNKN;/* UNKNOWN            */
         B     @RC00465                                            0469
@RF00465 MVC   ERROR(7),UNKN                                       0469
*   LABL10=LABEL10;                 /*                       @D35UGGB*/
@RC00465 DS    0H                                                  0470
@RC00463 DS    0H                                                  0470
@RC00461 DS    0H                                                  0470
@RC00457 DS    0H                                                  0470
@RC00449 DS    0H                                                  0470
@RC00441 DS    0H                                                  0470
@RC00429 DS    0H                                                  0470
@RC00417 MVC   LABL10(17),LABEL10                                  0470
*   CALL PRINTIT;                   /*                       @D35UGGB*/
         BAL   @14,PRINTIT                                         0471
*   END LINE10;                     /*                       @D35UGGB*/
@EL00015 DS    0H                                                  0472
@EF00015 DS    0H                                                  0472
@ER00015 L     @14,@SA00015                                        0472
         BR    @14                                                 0472
*                                                                  0473
*/********************************************************************
*   THIS PROC WILL PRINT THE STORAGE CONTROL NUMBER IF THIS RECORD 0473
*   IS A FROM A 8830 CONTROLLER                              @D3505GB*/
*                                                                  0473
*LINE10A:                                                          0473
*   PROC;                           /*                       @D3505GB*/
LINE10A  STM   @14,@12,@SA00016                                    0473
*   IF((OBRSENS7&'F0'X)='20'X|(OBRSENS7&'F0'X)='00'X|(OBRSENS7&'F0'X)=
*       '30'X)&((OBRSENS7&'08'X)='08'X) THEN/* 8830 CONTROLLER     0474
*                                                            @D3505GB*/
         MVC   @TS00001(1),OBRSENS7                                0474
         NI    @TS00001,X'F0'                                      0474
         CLI   @TS00001,X'20'                                      0474
         BE    @GL00016                                            0474
         MVC   @TS00001(1),OBRSENS7                                0474
         NI    @TS00001,X'F0'                                      0474
         CLI   @TS00001,X'00'                                      0474
         BE    @GL00016                                            0474
         MVC   @TS00001(1),OBRSENS7                                0474
         NI    @TS00001,X'F0'                                      0474
         CLI   @TS00001,X'30'                                      0474
         BNE   @RF00474                                            0474
@GL00016 MVC   @TS00001(1),OBRSENS7                                0474
         NI    @TS00001,X'08'                                      0474
         CLI   @TS00001,X'08'                                      0474
         BNE   @RF00474                                            0474
*     DO;                           /*                       @D3505GB*/
*       PRTLN10B=STORAGE;           /* MOVE THE LINE TO PRINTABLE  0476
*                                                            @D3505GB*/
         MVC   PRTLN10B(29),STORAGE                                0476
*       NUMBER=1;                   /* NUMBER OF BYTES TO CONVERT TO
*                                      PRINTABLE                     */
         MVC   NUMBER(4),@CF00053                                  0477
*       NEXTBY=ADDR(OBRSEN21);      /* BYTE 21 = STORAGE DIRECTOR ID */
         LA    @10,OBRSEN21                                        0478
         ST    @10,NEXTBY                                          0478
*       ADDNXT=ADDR(PRTLN10A);      /* STORAGE DIRECTOR ID ADDRESS 0479
*                                                            @D3505GB*/
         LA    @10,PRTLN10A                                        0479
         ST    @10,ADDNXT                                          0479
*       CALL HEX;                   /* CONVERT TO PRINTABLE  @D3505GB*/
         BAL   @14,HEX                                             0480
*       CALL PRINTIT;               /* PRINT THE LINE IDENTIFING THE
*                                      STORAGE DIRECTOR              */
         BAL   @14,PRINTIT                                         0481
*     END;                          /*                       @D3505GB*/
*   END LINE10A;                    /*                       @D3505GB*/
@EL00016 DS    0H                                                  0483
@EF00016 DS    0H                                                  0483
@ER00016 LM    @14,@12,@SA00016                                    0483
         BR    @14                                                 0483
*/*********************************************************************
*                                                                  0484
*   THIS PROC WILL BUILD LINE ELEVEN OF THE EDIT DETAIL REPORT     0484
*   HEADER FOR ALL 33XX DEVICES AND CONVERT SENSE BYTES 22 AND 23  0484
*   TO CHARACTER DATA.                                             0484
*                                                                  0484
*   FAULT SYMPTOM CODE   XXX                (N/A IF FORMAT 5)      0484
*                                                                  0484
* ********************************************************************/
*                                                                  0484
*LINE11:                                                           0484
*   PROC OPTIONS(SAVE(14));         /*                       @D35UGGB*/
LINE11   ST    @14,@SA00017                                        0484
*   IF FORMAT^=F5 THEN                                             0485
         CLI   FORMAT,X'50'                                        0485
         BE    @RF00485                                            0485
*     DO;                           /*                       @D35UGGB*/
*       NUMBER=1;                   /* CONVERT SENSE BYTE 22 TO CHAR
*                                                            @D35UGGB*/
         MVC   NUMBER(4),@CF00053                                  0487
*       NEXTBY=ADDR(OBRSEN22);      /*                       @D35UGGB*/
         LA    @10,OBRSEN22                                        0488
         ST    @10,NEXTBY                                          0488
*       ADDNXT=ADDR(FAULT22);       /*                       @D35UGGB*/
         LA    @10,FAULT22                                         0489
         ST    @10,ADDNXT                                          0489
*       CALL HEX;                   /*                       @D35UGGB*/
         BAL   @14,HEX                                             0490
*       NEXTBY=ADDR(OBRSEN23);      /* CONVERT SENSE BYTE 23 TO CHAR */
         LA    @10,OBRSEN23                                        0491
         ST    @10,NEXTBY                                          0491
*       ADDNXT=ADDR(FAULT23);       /*                       @D35UGGB*/
         LA    @10,FAULT23                                         0492
         ST    @10,ADDNXT                                          0492
*       CALL HEX;                   /*                       @D35UGGB*/
         BAL   @14,HEX                                             0493
*       LABL11=LABEL11;             /* PUT LABEL FOR LINE 11 IN    0494
*                                      BUFFER                        */
         MVC   LABL11(18),LABEL11                                  0494
*     END;                          /*                       @D35UGGB*/
*   ELSE                                                           0496
*     ;                             /*                       @D35UGGB*/
@RF00485 DS    0H                                                  0497
*   PRINTCHR=SPACE2;                /* CARRIAGE CONTROL, SKIP 2 LINES
*                                                            @D35UGGB*/
         MVI   PRINTCHR,X'11'                                      0497
*   CALL PRINTIT;                   /*                       @D35UGGB*/
         BAL   @14,PRINTIT                                         0498
*   PRINTCHR=SPACE1;                /* CARRIAGE CONTROL, SKIP 1 LINE
*                                                            @D35UGGB*/
         MVI   PRINTCHR,X'09'                                      0499
*   END LINE11;                     /*                       @D35UGGB*/
@EL00017 DS    0H                                                  0500
@EF00017 DS    0H                                                  0500
@ER00017 L     @14,@SA00017                                        0500
         BR    @14                                                 0500
*                                                                  0501
*/*********************************************************************
*                                                                  0501
*   THIS PROC WILL BUILD LINE TWELVE OF THE EDIT DETAIL REPORT     0501
*   HEADER FOR ALL 33XX DEVICES .                                  0501
*                                                                  0501
*       CC  CA  FL  CT     K   CA  US  CS  CT                      0501
*                                                                  0501
* ********************************************************************
*                                                                    */
*                                                                  0501
*LINE12:                                                           0501
*   PROC OPTIONS(SAVE(14));         /*                       @D35UGGB*/
LINE12   ST    @14,@SA00018                                        0501
*   LABL12=LABEL12;                 /* PUT LABEL FOR LINE 12 IN    0502
*                                      BUFFER                        */
         MVC   LABL12(60),LABEL12                                  0502
*   CALL PRINTIT;                   /*                       @D35UGGB*/
         BAL   @14,PRINTIT                                         0503
*   END LINE12;                     /*                       @D35UGGB*/
@EL00018 DS    0H                                                  0504
@EF00018 DS    0H                                                  0504
@ER00018 L     @14,@SA00018                                        0504
         BR    @14                                                 0504
*                                                                  0505
*/*********************************************************************
*                                                                  0505
*   THIS PROC WILL BUILD LINE THIRTEEN OF THE EDIT DETAIL REPORT   0505
*   HEADER FOR ALL 33XX DEVICES .                                  0505
*                                                                  0505
*    FAILING CCW   XXX            CSW  XXX                         0505
*                                                                  0505
* ********************************************************************
*                                                                    */
*                                                                  0505
*LINE13:                                                           0505
*   PROC OPTIONS(SAVE(14));         /*                       @D35UGGB*/
LINE13   ST    @14,@SA00019                                        0505
*/*   CONVERT CW FIELD OF CCW                                @D35UGGB*/
*                                                                  0506
*   NUMBER=1;                       /*                       @D35UGGB*/
         MVC   NUMBER(4),@CF00053                                  0506
*   NEXTBY=ADDR(CCCCW);             /*                       @D35UGGB*/
         LA    @10,CCCCW(,R7)                                      0507
         ST    @10,NEXTBY                                          0507
*   ADDNXT=ADDR(CCWCC);             /*                       @D35UGGB*/
         LA    @10,CCWCC                                           0508
         ST    @10,ADDNXT                                          0508
*   CALL HEX;                       /*                       @D35UGGB*/
         BAL   @14,HEX                                             0509
*/*   CONVERT CA FIELD OF CCW                                @D35UGGB*/
*                                                                  0510
*   NUMBER=3;                       /*                       @D35UGGB*/
         MVC   NUMBER(4),@CF00074                                  0510
*   NEXTBY=ADDR(CACCW);             /*                       @D35UGGB*/
         LA    @10,CACCW(,R7)                                      0511
         ST    @10,NEXTBY                                          0511
*   ADDNXT=ADDR(CCWCA);             /*                       @D35UGGB*/
         LA    @10,CCWCA                                           0512
         ST    @10,ADDNXT                                          0512
*   CALL HEX;                       /*                       @D35UGGB*/
         BAL   @14,HEX                                             0513
*/*   CONVERT FL FIELD OF CCW                                @D35UGGB*/
*                                                                  0514
*   NUMBER=1;                       /*                       @D35UGGB*/
         MVC   NUMBER(4),@CF00053                                  0514
*   NEXTBY=ADDR(FLCCW);             /*                       @D35UGGB*/
         LA    @10,FLCCW(,R7)                                      0515
         ST    @10,NEXTBY                                          0515
*   ADDNXT=ADDR(CCWFL);             /*                       @D35UGGB*/
         LA    @10,CCWFL                                           0516
         ST    @10,ADDNXT                                          0516
*   CALL HEX;                       /*                       @D35UGGB*/
         BAL   @14,HEX                                             0517
*/*   CONVERT BLANK FIELD OF CCW                             @D35UGGB*/
*                                                                  0518
*   NUMBER=1;                       /*                       @D35UGGB*/
         MVC   NUMBER(4),@CF00053                                  0518
*   NEXTBY=ADDR(BLANKCCW);          /*                       @D35UGGB*/
         LA    @10,BLANKCCW(,R7)                                   0519
         ST    @10,NEXTBY                                          0519
*   ADDNXT=ADDR(CCWBLANK);          /*                       @D35UGGB*/
         LA    @10,CCWBLANK                                        0520
         ST    @10,ADDNXT                                          0520
*   CALL HEX;                       /*                       @D35UGGB*/
         BAL   @14,HEX                                             0521
*/*   CONVERT CT FIELD OF CCW                                @D35UGGB*/
*                                                                  0522
*   NUMBER=2;                       /*                       @D35UGGB*/
         MVC   NUMBER(4),@CF00072                                  0522
*   NEXTBY=ADDR(CTCCW);             /*                       @D35UGGB*/
         LA    @10,CTCCW(,R7)                                      0523
         ST    @10,NEXTBY                                          0523
*   ADDNXT=ADDR(CCWCT);             /*                       @D35UGGB*/
         LA    @10,CCWCT                                           0524
         ST    @10,ADDNXT                                          0524
*   CALL HEX;                       /*                       @D35UGGB*/
         BAL   @14,HEX                                             0525
*/*   CONVERT K FIELD OF CSW                                 @D35UGGB*/
*                                                                  0526
*   NUMBER=1;                       /*                       @D35UGGB*/
         MVC   NUMBER(4),@CF00053                                  0526
*   NEXTBY=ADDR(KCSW);              /*                       @D35UGGB*/
         LA    @10,KCSW(,R7)                                       0527
         ST    @10,NEXTBY                                          0527
*   ADDNXT=ADDR(CSWK);              /*                       @D35UGGB*/
         LA    @10,CSWK                                            0528
         ST    @10,ADDNXT                                          0528
*   CALL HEX;                       /*                       @D35UGGB*/
         BAL   @14,HEX                                             0529
*/*   CONVERT CA FIELD OF CSW                                @D35UGGB*/
*                                                                  0530
*   NUMBER=3;                       /*                       @D35UGGB*/
         MVC   NUMBER(4),@CF00074                                  0530
*   NEXTBY=ADDR(CACSW);             /*                       @D35UGGB*/
         LA    @10,CACSW(,R7)                                      0531
         ST    @10,NEXTBY                                          0531
*   ADDNXT=ADDR(CSWCA);             /*                       @D35UGGB*/
         LA    @10,CSWCA                                           0532
         ST    @10,ADDNXT                                          0532
*   CALL HEX;                       /*                       @D35UGGB*/
         BAL   @14,HEX                                             0533
*/*   CONVERT US FIELD OF CSW                                @D35UGGB*/
*                                                                  0534
*   NUMBER=1;                       /*                       @D35UGGB*/
         MVC   NUMBER(4),@CF00053                                  0534
*   NEXTBY=ADDR(USCSW);             /*                       @D35UGGB*/
         LA    @10,USCSW(,R7)                                      0535
         ST    @10,NEXTBY                                          0535
*   ADDNXT=ADDR(CSWUS);             /*                       @D35UGGB*/
         LA    @10,CSWUS                                           0536
         ST    @10,ADDNXT                                          0536
*   CALL HEX;                       /*                       @D35UGGB*/
         BAL   @14,HEX                                             0537
*/*   CONVERT CS FIELD OF CSW                                @D35UGGB*/
*                                                                  0538
*   NUMBER=1;                       /*                       @D35UGGB*/
         MVC   NUMBER(4),@CF00053                                  0538
*   NEXTBY=ADDR(CSCSW);             /*                       @D35UGGB*/
         LA    @10,CSCSW(,R7)                                      0539
         ST    @10,NEXTBY                                          0539
*   ADDNXT=ADDR(CSWCS);             /*                       @D35UGGB*/
         LA    @10,CSWCS                                           0540
         ST    @10,ADDNXT                                          0540
*   CALL HEX;                       /*                       @D35UGGB*/
         BAL   @14,HEX                                             0541
*/*   CONVERT CT FIELD OF CSW                                @D35UGGB*/
*                                                                  0542
*   NUMBER=2;                       /*                       @D35UGGB*/
         MVC   NUMBER(4),@CF00072                                  0542
*   NEXTBY=ADDR(CTCSW);             /*                       @D35UGGB*/
         LA    @10,CTCSW(,R7)                                      0543
         ST    @10,NEXTBY                                          0543
*   ADDNXT=ADDR(CSWCT);             /*                       @D35UGGB*/
         LA    @10,CSWCT                                           0544
         ST    @10,ADDNXT                                          0544
*   CALL HEX;                       /*                       @D35UGGB*/
         BAL   @14,HEX                                             0545
*   LABL13A=LABEL13A;               /* PUT LABELS FOR LINE 13 IN   0546
*                                      BUFFER                        */
         MVC   LABL13A(11),LABEL13A                                0546
*   LABL13B=LABEL13B;               /*                       @D35UGGB*/
         MVC   LABL13B(3),LABEL13B                                 0547
*   PRINTCHR=SPACE2;                /* CARRIAGE CONTROL, SKIP 2 LINES*/
         MVI   PRINTCHR,X'11'                                      0548
*   CALL PRINTIT;                   /*                       @D35UGGB*/
         BAL   @14,PRINTIT                                         0549
*   PRINTCHR=SPACE1;                /* CARRIAGE CONTROL, SKIP 1 LINE */
         MVI   PRINTCHR,X'09'                                      0550
*   END LINE13;                     /*                       @D35UGGB*/
@EL00019 DS    0H                                                  0551
@EF00019 DS    0H                                                  0551
@ER00019 L     @14,@SA00019                                        0551
         BR    @14                                                 0551
*                                                                  0552
*/*********************************************************************
*                                                                  0552
*   THIS PROC WILL BUILD LINE FOURTEEN OF THE EDIT DETAIL REPORT   0552
*   HEADER FOR ALL 33XX COUNT KEY DEVICES.                         0552
*                                                                  0552
*                         M   BB  CC  HH  R                        0552
*                                                                  0552
* ********************************************************************
*                                                                    */
*                                                                  0552
*LINE14:                                                           0552
*   PROC OPTIONS(SAVE(14));         /*                       @D35UGGB*/
LINE14   ST    @14,@SA00020                                        0552
*   IF OBRCLASS=CKD THEN            /* PRINT ONLY IF CKD DEVICE    0553
*                                                            @D35UGGB*/
         CLI   OBRCLASS(R7),X'20'                                  0553
         BNE   @RF00553                                            0553
*     DO;                           /*                       @D35UGGB*/
*       LABL14=LABEL14;             /* PUT LABEL FOR LINE 14 IN    0555
*                                      BUFFER                        */
         MVC   LABL14(20),LABEL14                                  0555
*       CALL PRINTIT;               /*                       @D35UGGB*/
         BAL   @14,PRINTIT                                         0556
*     END;                          /*                       @D35UGGB*/
*   ELSE                                                           0558
*     ;                             /*                       @D35UGGB*/
@RF00553 DS    0H                                                  0559
*   END LINE14;                     /*                       @D35UGGB*/
@EL00020 DS    0H                                                  0559
@EF00020 DS    0H                                                  0559
@ER00020 L     @14,@SA00020                                        0559
         BR    @14                                                 0559
*                                                                  0560
*/*********************************************************************
*                                                                  0560
*   THIS PROC WILL BUILD LINE FIFTEEN OF THE EDIT DETAIL REPORT    0560
*   HEADER FOR ALL 33XX AND CONVERT THE BLOCK ADDRESS FOR FBA      0560
*   DEVICES AND THE SEEK ADDRESS FOR COUNT KEY DEVICES TO CHARACTER.
*                                                                  0560
*    BLOCK ADDRESS          XXX    (FOR FBA DEVICES)               0560
*    LAST SEEK ADDRESS      XXX    (FOR COUNT KEY DEVICES)         0560
*                                                                  0560
* ********************************************************************
*                                                                    */
*                                                                  0560
*LINE15:                                                           0560
*   PROC OPTIONS(SAVE(14));         /*                       @D35UGGB*/
LINE15   ST    @14,@SA00021                                        0560
*   IF OBRCLASS=FBA THEN                                           0561
         CLI   OBRCLASS(R7),X'21'                                  0561
         BNE   @RF00561                                            0561
*     DO;                           /* CONVERT BLOCK ADDRESS TO    0562
*                                      CHARACTERS            @D35UGGB*/
*       NUMBER=8;                   /* NUMBER OF BYTES IN INPUT    0563
*                                                            @D35UGGB*/
         MVC   NUMBER(4),@CF00064                                  0563
*       NEXTBY=ADDR(OBRBLKAD);      /* ADDR OF INPUT         @D35UGGB*/
         LA    @10,OBRBLKAD(,R7)                                   0564
         ST    @10,NEXTBY                                          0564
*       ADDNXT=ADDR(BLOCKADR);      /* ADDR OF OUTPUT        @D35UGGB*/
         LA    @10,BLOCKADR                                        0565
         ST    @10,ADDNXT                                          0565
*       CALL HEX;                   /*                       @D35UGGB*/
         BAL   @14,HEX                                             0566
*       LABL15A=LABEL15A;           /* PUT LABEL FOR LINE 15 IN    0567
*                                      BUFFER                        */
         MVC   LABL15A(13),LABEL15A                                0567
*       PRINTCHR=SPACE2;            /* CARRIAGE CONTROL, SKIP 2 LINES*/
         MVI   PRINTCHR,X'11'                                      0568
*       CALL PRINTIT;               /*                       @D35UGGB*/
         BAL   @14,PRINTIT                                         0569
*       PRINTCHR=SPACE1;            /* CARRIAGE CONTROL, SKIP 1 LINE */
         MVI   PRINTCHR,X'09'                                      0570
*     END;                          /*                       @D35UGGB*/
*   ELSE                                                           0572
*     IF OBRCLASS=CKD THEN                                         0572
         B     @RC00561                                            0572
@RF00561 CLI   OBRCLASS(R7),X'20'                                  0572
         BNE   @RF00572                                            0572
*       DO;                         /* CONVERT LAST SEEK ADDR TO CHAR
*                                                            @D35UGGB*/
*         NUMBER=1;                 /*                       @D35UGGB*/
         MVC   NUMBER(4),@CF00053                                  0574
*         NEXTBY=ADDR(OBRSEKM);     /* CONVERT M FIELD OF SEEK ADR   */
         LA    @10,OBRSEKM(,R7)                                    0575
         ST    @10,NEXTBY                                          0575
*         ADDNXT=ADDR(M);           /*                       @D35UGGB*/
         LA    @10,M                                               0576
         ST    @10,ADDNXT                                          0576
*         CALL HEX;                 /*                       @D35UGGB*/
         BAL   @14,HEX                                             0577
*         NUMBER=2;                 /*                       @D35UGGB*/
         MVC   NUMBER(4),@CF00072                                  0578
*         NEXTBY=ADDR(OBRSEKBB);    /* CONVERT BB FIELD OF SEEK ADR  */
         LA    @10,OBRSEKBB(,R7)                                   0579
         ST    @10,NEXTBY                                          0579
*         ADDNXT=ADDR(BB);          /*                       @D35UGGB*/
         LA    @10,BB                                              0580
         ST    @10,ADDNXT                                          0580
*         CALL HEX;                 /*                       @D35UGGB*/
         BAL   @14,HEX                                             0581
*         NUMBER=2;                 /*                       @D35UGGB*/
         MVC   NUMBER(4),@CF00072                                  0582
*         NEXTBY=ADDR(OBRSEKCC);    /* CONVERT CC FIELD OF SEEK ADR  */
         LA    @10,OBRSEKCC(,R7)                                   0583
         ST    @10,NEXTBY                                          0583
*         ADDNXT=ADDR(CC);          /*                       @D35UGGB*/
         LA    @10,CC                                              0584
         ST    @10,ADDNXT                                          0584
*         CALL HEX;                 /*                       @D35UGGB*/
         BAL   @14,HEX                                             0585
*         NUMBER=2;                 /*                       @D35UGGB*/
         MVC   NUMBER(4),@CF00072                                  0586
*         NEXTBY=ADDR(OBRSEKHH);    /* CONVERT HH FIELD OF SEEK ADR  */
         LA    @10,OBRSEKHH(,R7)                                   0587
         ST    @10,NEXTBY                                          0587
*         ADDNXT=ADDR(HH);          /*                       @D35UGGB*/
         LA    @10,HH                                              0588
         ST    @10,ADDNXT                                          0588
*         CALL HEX;                 /*                       @D35UGGB*/
         BAL   @14,HEX                                             0589
*         NUMBER=1;                 /*                       @D35UGGB*/
         MVC   NUMBER(4),@CF00053                                  0590
*         NEXTBY=ADDR(OBRSEKR);     /* CONVERT R FIELD OF SEEK ADR   */
         LA    @10,OBRSEKR(,R7)                                    0591
         ST    @10,NEXTBY                                          0591
*         ADDNXT=ADDR(R);           /*                       @D35UGGB*/
         LA    @10,R                                               0592
         ST    @10,ADDNXT                                          0592
*         CALL HEX;                 /*                       @D35UGGB*/
         BAL   @14,HEX                                             0593
*         LABL15B=LABEL15B;         /* PUT LABEL FOR LINE 15 IN    0594
*                                      BUFFER                        */
         MVC   LABL15B(17),LABEL15B                                0594
*         PRINTCHR=SPACE2;          /* CARRIAGE CONTROL, SKIP 2 LINES*/
         MVI   PRINTCHR,X'11'                                      0595
*         CALL PRINTIT;             /*                       @D35UGGB*/
         BAL   @14,PRINTIT                                         0596
*         PRINTCHR=SPACE1;          /* CARRIAGE CONTROL, SKIP 1 LINE */
         MVI   PRINTCHR,X'09'                                      0597
*       END;                        /*                       @D35UGGB*/
*     ELSE                                                         0599
*       ;                           /*                       @D35UGGB*/
@RF00572 DS    0H                                                  0600
*   END LINE15;                     /*                       @D35UGGB*/
@EL00021 DS    0H                                                  0600
@EF00021 DS    0H                                                  0600
@ER00021 L     @14,@SA00021                                        0600
         BR    @14                                                 0600
*                                                                  0601
*/*********************************************************************
*                                                                  0601
*   THIS PROC WILL BUILD LINE SIXTEEN OF THE EDIT DETAIL REPORT    0601
*   HEADER FOR ALL 33XX DEVICES.                                   0601
*                                                                  0601
*     CCHH                                                         0601
*     CCHS                                                         0601
*                                                                  0601
* ********************************************************************
*                                                                    */
*                                                                  0601
*LINE16:                                                           0601
*   PROC OPTIONS(SAVE(14));         /*                       @D35UGGB*/
LINE16   ST    @14,@SA00022                                        0601
*   IF OBRCLASS=CKD THEN                                           0602
         CLI   OBRCLASS(R7),X'20'                                  0602
         BNE   @RF00602                                            0602
*     LABL16A=LABEL16A;             /*                       @D35UGGB*/
         MVC   LABL16A(4),LABEL16A                                 0603
*   ELSE                                                           0604
*     IF OBRCLASS=FBA THEN                                         0604
         B     @RC00602                                            0604
@RF00602 CLI   OBRCLASS(R7),X'21'                                  0604
         BNE   @RF00604                                            0604
*       LABL16B=LABEL16B;           /*                       @D35UGGB*/
         MVC   LABL16B(4),LABEL16B                                 0605
*     ELSE                                                         0606
*       ;                           /*                       @D35UGGB*/
@RF00604 DS    0H                                                  0607
*   CALL PRINTIT;                   /*                       @D35UGGB*/
@RC00602 BAL   @14,PRINTIT                                         0607
*   END LINE16;                     /*                       @D35UGGB*/
@EL00022 DS    0H                                                  0608
@EF00022 DS    0H                                                  0608
@ER00022 L     @14,@SA00022                                        0608
         BR    @14                                                 0608
*                                                                  0609
*/*********************************************************************
*                                                                  0609
*   THIS PROC WILL BUILD LINE SEVENTEEN OF THE EDIT DETAIL REPORT  0609
*   HEADER FOR ALL 33XX AND CONVERT THE ACCESS POSITION TO         0609
*   PRINTABLE CHARACTERS.                                          0609
*                                                                  0609
*     ACCESS POSITION   XXX                                        0609
*                                                                  0609
* ********************************************************************
*                                                                    */
*                                                                  0609
*LINE17:                                                           0609
*   PROC OPTIONS(SAVE(14));         /*                       @D35UGGB*/
LINE17   ST    @14,@SA00023                                        0609
*   NUMBER=4;                       /* CONVERT 3 BYTE ACCESS @D35UGGB*/
         MVC   NUMBER(4),@CF00062                                  0610
*   NEXTBY=ADDR(OBRACCPO);          /* POSITION TO CHAR      @D35UGGB*/
         LA    @10,OBRACCPO(,R7)                                   0611
         ST    @10,NEXTBY                                          0611
*   ADDNXT=ADDR(ACCPOS);            /*                       @D35UGGB*/
         LA    @10,ACCPOS                                          0612
         ST    @10,ADDNXT                                          0612
*   CALL HEX;                       /*                       @D35UGGB*/
         BAL   @14,HEX                                             0613
*   LABL17=LABEL17;                 /* PUT LABEL FOR LINE 17 IN    0614
*                                      BUFFER                @D35UGGB*/
         MVC   LABL17(15),LABEL17                                  0614
*   PRINTCHR=SPACE2;                /* CARRIAGE CONTROL, SKIP 2 LINES
*                                                            @D35UGGB*/
         MVI   PRINTCHR,X'11'                                      0615
*   CALL PRINTIT;                   /*                       @D35UGGB*/
         BAL   @14,PRINTIT                                         0616
*   PRINTCHR=SPACE1;                /* CARRIAGE CONTROL, SKIP 1 LINE
*                                                            @D35UGGB*/
         MVI   PRINTCHR,X'09'                                      0617
*   END LINE17;                     /*                       @D35UGGB*/
@EL00023 DS    0H                                                  0618
@EF00023 DS    0H                                                  0618
@ER00023 L     @14,@SA00023                                        0618
         BR    @14                                                 0618
*                                                                  0619
*/*********************************************************************
*                                                                  0619
*   THIS PROC WILL BUILD LINE EIGHTEEN OF THE EDIT DETAIL REPORT   0619
*   HEADER FOR ALL 33XX AND CONVERT THE SENSE BYTE DATA FORMAT INTO
*   PRINTABLE CHARACTERS.                                          0619
*                                                                  0619
*   SENSE BYTE DATA FORMAT   XXX                                   0619
*                                                                  0619
* ********************************************************************
*                                                                    */
*                                                                  0619
*LINE18:                                                           0619
*   PROC OPTIONS(SAVE(14));         /*                       @D35UGGB*/
LINE18   ST    @14,@SA00024                                        0619
*   NUMBER=1;                       /* CONVERT FORMAT FROM SENSE   0620
*                                                            @D35UGGB*/
         MVC   NUMBER(4),@CF00053                                  0620
*   NEXTBY=ADDR(FORMAT);            /* BYTE 7 TO CHAR        @D35UGGB*/
         LA    @10,FORMAT                                          0621
         ST    @10,NEXTBY                                          0621
*   ADDNXT=ADDR(FOR22);             /*                       @D35UGGB*/
         LA    @10,FOR22                                           0622
         ST    @10,ADDNXT                                          0622
*   CALL HEX;                       /*                       @D35UGGB*/
         BAL   @14,HEX                                             0623
*   FOR22(2)=BLANK;                 /* PRINT ONLY FORMAT HALF OF BYTE
*                                      7                             */
         MVI   FOR22+1,X'40'                                       0624
*   LABL18=LABEL18;                 /* PUT LABEL FOR LINE 18 IN    0625
*                                      BUFFER                        */
         MVC   LABL18(31),LABEL18                                  0625
*   CALL PRINTIT;                   /*                       @D35UGGB*/
         BAL   @14,PRINTIT                                         0626
*   END LINE18;                     /*                       @D35UGGB*/
@EL00024 DS    0H                                                  0627
@EF00024 DS    0H                                                  0627
@ER00024 L     @14,@SA00024                                        0627
         BR    @14                                                 0627
*   END IFCEDASD                    /*                       @D35UGGB*/
*                                                                  0628
*/* THE FOLLOWING INCLUDE STATEMENTS WERE FOUND IN THIS PROGRAM.     */
*/*%INCLUDE SYSLIB  (COMTABLE)                                       */
*                                                                  0628
*       ;                                                          0628
@DATA    DS    0H
         DS    0F
@AL00263 DC    A(@CF00072+2)           LIST WITH   1 ARGUMENT(S)
         DS    0F
@SA00001 DS    18F
@SA00006 DS    1F
@SA00007 DS    1F
@SA00008 DS    1F
@SA00009 DS    1F
@SA00010 DS    1F
@SA00011 DS    1F
@SA00012 DS    1F
@SA00013 DS    1F
@SA00014 DS    1F
@SA00015 DS    1F
@SA00016 DS    15F
@SA00017 DS    1F
@SA00018 DS    1F
@SA00019 DS    1F
@SA00020 DS    1F
@SA00021 DS    1F
@SA00022 DS    1F
@SA00023 DS    1F
@SA00024 DS    1F
@SA00002 DS    15F
@SA00005 DS    15F
         DS    0F
@CF00053 DC    F'1'
@CF00072 DC    F'2'
@CH00072 EQU   @CF00072+2
@CF00074 DC    F'3'
@CF00062 DC    F'4'
@CF00077 DC    F'5'
@CF00079 DC    F'6'
@CF00081 DC    F'7'
@CF00064 DC    F'8'
@CF01422 DC    F'26'
@CF01364 DC    XL4'00000007'
         DS    0D
NEXTBY   DC    F'0'
ADDNXT   DC    F'0'
NUMBER   DC    F'0'
TEMP1    DC    F'0'
X        DC    F'0'
Z        DC    F'0'
@TS00001 DS    CL1
@CC01399 DC    C'********'
@CC01296 DC    C'DOS '
@CB01360 DC    X'0018'
ALLSENSE DS    CL24
         ORG   ALLSENSE
OBRSENS0 DS    CL1
         ORG   OBRSENS0
BIT00    DS    BL1
INTREQ   EQU   OBRSENS0+0
BUSOUT   EQU   OBRSENS0+0
EQUCK    EQU   OBRSENS0+0
DATACK   EQU   OBRSENS0+0
OVERRN   EQU   OBRSENS0+0
BIT06    EQU   OBRSENS0+0
SEEKCK   EQU   OBRSENS0+0
         ORG   ALLSENSE+1
OBRSENS1 DS    CL1
OBRSENS2 DS    CL1
         ORG   OBRSENS2
CHECKDAT DS    BL1
BIT21    EQU   OBRSENS2+0
BIT22    EQU   OBRSENS2+0
EVR      EQU   OBRSENS2+0
EMULATE  EQU   OBRSENS2+0
BIT25    EQU   OBRSENS2+0
BIT26    EQU   OBRSENS2+0
BIT27    EQU   OBRSENS2+0
         ORG   ALLSENSE+3
OBRSENS3 DS    CL1
OBRSENS4 DS    CL1
OBRSENS5 DS    CL1
OBRSENS6 DS    CL1
OBRSENS7 DS    CL1
OBRSENS8 DS    CL1
OBRSENS9 DS    CL1
OBRSEN10 DS    CL1
OBRSEN11 DS    CL1
OBRSEN12 DS    CL1
OBRSEN13 DS    CL1
OBRSEN14 DS    CL1
OBRSEN15 DS    CL1
OBRSEN16 DS    CL1
OBRSEN17 DS    CL1
OBRSEN18 DS    CL1
OBRSEN19 DS    CL1
OBRSEN20 DS    CL1
OBRSEN21 DS    CL1
OBRSEN22 DS    CL1
OBRSEN23 DS    CL1
         ORG   ALLSENSE+24
LABEL1A  DC    CL76'RECORD ENTRY TYPE - UNIT CHECK         SOURCE-OUTBOC
               ARD(OBR)        MODEL - '
LABEL1B  DC    CL13'SERIAL NO. - '
LABEL2   DC    CL4'REL.'
LABEL3   DC    CL68'DAY YEAR                           HH MM SS.TH     C
                    JOB IDENTITY'
LABEL4A  DC    CL7'DATE - '
LABEL4B  DC    CL7'TIME - '
LABEL5   DC    CL16'DEVICE TYPE IS A'
LABEL6   DC    CL29'PHYSICAL CHANNEL UNIT ADDRESS'
LABEL7   DC    CL28'LOGICAL CHANNEL UNIT ADDRESS'
LABEL8   DC    CL14'PHYSICAL DRIVE'
LABEL9   DC    CL12'VOLUME LABEL'
LABEL10  DC    CL17'ERROR DESCRIPTION'
LABEL11  DC    CL18'FAULT SYMPTOM CODE'
LABEL12  DC    CL60'CC   CA   FL     CT                      K   CA   UC
               S CS  CT'
LABEL13A DC    CL11'FAILING CCW'
LABEL13B DC    CL3'CSW'
LABEL14  DC    CL20'M   BB   CC   HH   R'
LABEL15A DC    CL13'BLOCK ADDRESS'
LABEL15B DC    CL17'LAST SEEK ADDRESS'
LABEL16A DC    CL4'CCHH'
LABEL16B DC    CL4'CCHS'
LABEL17  DC    CL15'ACCESS POSITION'
LABEL18  DC    CL31'SENSE BYTE DATA -        FORMAT'
PRTLINE1 DS    CL134
         ORG   PRTLINE1
PPRINTDD DC    X'F0'
PRINTCHR DC    X'89'
PRTLINE  DC    CL132' '
         ORG   PRTLINE1+134
STORAGE  DC    CL29' STORAGE DIRECTOR PHYSICAL ID'
EQIPDT   DC    CL35'EQUIPMENT CHECK - DRIVE - TEMPORARY'
EQIPDP   DC    CL35'EQUIPMENT CHECK - DRIVE - PERMANENT'
EQIPCT   DC    CL43'EQUIPMENT CHECK - CONTROL UNIT - TEMPORARY'
EQIPCP   DC    CL43'EQUIPMENT CHECK - CONTROL UNIT - PERMANENT'
BUSPAR   DC    CL14'BUS OUT PARITY'
DATCKUL  DC    CL53'DATA CHECK - UNCORRECTABLE - LOGGING MODE - TEMPORAC
               RY'
DATCKCL  DC    CL39'DATA CHECK - CORRECTABLE - LOGGING MODE'
DATCKC   DC    CL24'DATA CHECK - CORRECTABLE'
DATCKUP  DC    CL38'DATA CHECK - UNCORRECTABLE - PERMANENT'
DATCKUT  DC    CL38'DATA CHECK - UNCORRECTABLE - TEMPORARY'
CKDT     DC    CL28'CHECK DATA ERROR - TEMPORARY'
CKDP     DC    CL28'CHECK DATA ERROR - PERMANENT'
CKDL     DC    CL43'CHECK DATA ERROR - LOGGING MODE - TEMPORARY'
CKDC     DC    CL30'CHECK DATA ERROR - CORRECTABLE'
OVERRUN  DC    CL7'OVERRUN'
SEKCKL   DC    CL37'SEEK CHECK - LOGGING MODE - TEMPORARY'
SEKCKT   DC    CL22'SEEK CHECK - TEMPORARY'
SEKCKP   DC    CL22'SEEK CHECK - PERMANENT'
INTVREQT DC    CL33'INTERVENTION REQUIRED - TEMPORARY'
INTVREQP DC    CL33'INTERVENTION REQUIRED - PERMANENT'
UNKN     DC    CL7'UNKNOWN'
NONE     DC    CL7'NONE   '
VIRTUAL  DC    CL18'A VIRTUAL DEVICE  '
EMULAT   DC    CL18'AN EMULATED DEVICE'
UNISERL  DC    CL28'UNIVERSIAL SERIAL NO. - NONE'
DEVTABLE DS    CL80
         ORG   DEVTABLE
DEV3330  DC    X'2009'
CH3330   DC    CL8'3330   '
DEV3340  DC    X'200A'
CH3340   DC    CL8'3340   '
DEV3350  DC    X'200B'
CH3350   DC    CL8'3350   '
DEV33301 DC    X'200D'
CH33301  DC    CL8'3330M11'
DEV3370  DC    X'2102'
CH3370   DC    CL8'3370    '
DEVWOOD  DC    X'2101'
CHWOOD   DC    CL8'3310   '
         ORG   DEVTABLE+80
FORMAT   DS    CL1
CHARS    DC    CL16'0123456789ABCDEF'
F3330    DS    CL9
         ORG   F3330
@NM00141 DC    XL1'FE'
@NM00142 DC    CL8'IFCE3330'
         ORG   F3330+9
F3340    DS    CL9
         ORG   F3340
@NM00143 DC    XL1'FE'
@NM00144 DC    CL8'IFCEWIN1'
         ORG   F3340+9
F3344    DS    CL9
         ORG   F3344
@NM00145 DC    XL1'FE'
@NM00146 DC    CL8'IFCEWIN2'
         ORG   F3344+9
F3350    DS    CL9
         ORG   F3350
@NM00147 DC    XL1'FE'
@NM00148 DC    CL8'IFCEMAD1'
         ORG   F3350+9
ELI      DS    CL9
         ORG   ELI
@NM00149 DC    XL1'FE'
@NM00150 DC    CL8'IFCEWHT1'
         ORG   ELI+9
WOODY    DS    CL9
         ORG   WOODY
@NM00151 DC    XL1'FE'
@NM00152 DC    CL8'IFCEWOD1'
         ORG   WOODY+9
D3370    DS    CL9
         ORG   D3370
@NM00153 DC    XL1'FE'
@NM00154 DC    CL8'IFCEWOD1'
         ORG   D3370+9
         DS    CL4
TEMP2    DC    X'00'
         DC    XL15'0'
DBLWORK  DS    CL8
SWITCH   DS    BL1
SUPERZAP DC    3CL10'SUPERZAP'
DCLREL   DC    CL4'OS  '
         DC    CL4'DOS '
         DC    CL4'VS 1'
         DC    CL4'V370'
         DC    CL4'VS 2'
         DC    3CL4'    '
IFCEDASD CSECT
*                                                          /*@G51DGVS*/
         DC    S(SUPERZAP)
IFCEDASD CSECT
*                                                          /*@D35UGGB*/
MVCINS MVC R0(R0,R6),0(R8)
IFCEDASD CSECT
@00      EQU   00                      EQUATES FOR REGISTERS 0-15
@01      EQU   01
@02      EQU   02
@03      EQU   03
@04      EQU   04
@05      EQU   05
@06      EQU   06
@07      EQU   07
@08      EQU   08
@09      EQU   09
@10      EQU   10
@11      EQU   11
@12      EQU   12
@13      EQU   13
@14      EQU   14
@15      EQU   15
R2       EQU   @02
R5       EQU   @05
R6       EQU   @06
R7       EQU   @07
R8       EQU   @08
R9       EQU   @09
R15      EQU   @15
R0       EQU   @00
R1       EQU   @01
R10      EQU   @10
R11      EQU   @11
R12      EQU   @12
R13      EQU   @13
R14      EQU   @14
R3       EQU   @03
R4       EQU   @04
IOHND    EQU   0
PARM     EQU   0
RECTYPE  EQU   PARM
SWITCHES EQU   PARM+2
DEBUG    EQU   PARM+4
DEBUGA   EQU   PARM+8
MISC     EQU   PARM+12
PRINTES  EQU   MISC
OPENCLSE EQU   PARM+13
OPENIO   EQU   OPENCLSE
CLOSEIO  EQU   OPENCLSE+2
DATENOW  EQU   PARM+17
STDT     EQU   PARM+23
STDATE   EQU   STDT
PSTD     EQU   STDATE+1
ENDDT    EQU   PARM+31
ENDDATE  EQU   ENDDT
PEND     EQU   ENDDATE+1
STTIME1  EQU   PARM+39
ENDTIME1 EQU   PARM+43
STTIME2  EQU   PARM+47
ENDTIME2 EQU   PARM+51
STRTDATE EQU   PARM+55
@NM00006 EQU   PARM+72
@NM00007 EQU   PARM+75
ERRID    EQU   PARM+92
IDTIMEA  EQU   ERRID+6
IDTIME   EQU   IDTIMEA
CCHHRLNG EQU   PARM+112
ADIOHND  EQU   PARM+124
ADIFCMSG EQU   PARM+128
ADEDITB  EQU   PARM+132
EVPTR    EQU   PARM+136
SORTADR  EQU   PARM+140
PRINTADR EQU   PARM+148
CUAPTR   EQU   PARM+152
DEVPTR   EQU   PARM+156
MODPTR   EQU   PARM+160
SERPTR   EQU   PARM+164
VOLPTR   EQU   PARM+168
CPUPTR   EQU   PARM+172
CPCUAPTR EQU   PARM+176
LIBADPTR EQU   PARM+180
SYMCDPTR EQU   PARM+184
SYSUMPTR EQU   PARM+188
TRENPTR  EQU   PARM+192
SHAREPTR EQU   PARM+196
MERDCPTR EQU   PARM+208
DUMPTABL EQU   PARM+228
DUMPINFO EQU   DUMPTABL+4
TRENDONE EQU   0
TREGEN   EQU   TRENDONE+8
TRECCH0  EQU   TREGEN+8
TREND2   EQU   0
TRENDKEY EQU   TREND2
TRENDRT  EQU   TRENDKEY+1
TRENCPUS EQU   TRENDKEY+3
TRENDITM EQU   TRENDKEY+4
EVTABLE  EQU   0
EVSTOP   EQU   EVTABLE
EVKEY    EQU   EVTABLE+6
SORTABLE EQU   0
SORTKEY  EQU   SORTABLE
SORTCCHR EQU   SORTABLE+5
SYSUMONE EQU   0
SYSUM2   EQU   0
SYSUMKEY EQU   SYSUM2
SYSRT    EQU   SYSUMKEY+1
SYSCPUS  EQU   SYSUMKEY+3
SYSITEM  EQU   SYSUMKEY+4
SHARE    EQU   0
SHAREIO  EQU   SHARE+2
SHRBASE  EQU   SHAREIO+1
SHRCUCPU EQU   SHAREIO+8
EDITLOAD EQU   0
EDITABLE EQU   EDITLOAD+4
CUA      EQU   0
CUAVAL   EQU   CUA+2
DEVICE   EQU   0
MODELS   EQU   0
DEVSERAL EQU   0
VOLUME   EQU   0
CPUS     EQU   0
CPUCUAS  EQU   0
CPUCUAV  EQU   CPUCUAS+2
LIBADR   EQU   0
SYMCODE  EQU   0
SYMVAL   EQU   SYMCODE+2
MERIDIAN EQU   0
LRTREC   EQU   0
LRTKEY   EQU   LRTREC
LRTSMS   EQU   LRTREC+2
LRTERRID EQU   LRTREC+3
@NM00016 EQU   LRTREC+4
LRTDT    EQU   LRTREC+8
LRTDATE  EQU   LRTDT
LRTYRDAY EQU   LRTDATE+1
LRTTIME  EQU   LRTDT+4
LRTCPU   EQU   LRTREC+16
LRTCPMOD EQU   LRTCPU+1
MCHREC   EQU   0
MCHHEAD  EQU   MCHREC
MCHKEY   EQU   MCHHEAD
MCHSMS   EQU   MCHHEAD+2
MCHCPUID EQU   MCHHEAD+16
CCHREC   EQU   0
CCHHEAD  EQU   CCHREC
CCHKEY   EQU   CCHHEAD
CCHSMS   EQU   CCHHEAD+2
CCHCPUID EQU   CCHHEAD+16
CCHCODE  EQU   CCHREC+68
CCHCODE2 EQU   CCHCODE+2
OBRREC   EQU   0
OBRHEAD  EQU   OBRREC
OBRKEY   EQU   OBRHEAD
OBRKEY2  EQU   OBRKEY+1
OBRSMS   EQU   OBRHEAD+2
MISCSW   EQU   OBRSMS
OBRSUBTP EQU   OBRSMS+1
OBRTEMP  EQU   OBRSUBTP
OBRDATE  EQU   OBRHEAD+8
OBRTIME  EQU   OBRHEAD+12
OBRCPUID EQU   OBRHEAD+16
OBRSER   EQU   OBRCPUID+1
OBRMOD   EQU   OBRCPUID+4
OBRJOBID EQU   OBRREC+24
OBRFCCW  EQU   OBRREC+32
OBRSRDS  EQU   OBRFCCW
OBRCSW   EQU   OBRREC+40
OBRDEVDC EQU   OBRREC+48
OBRSECUA EQU   OBRREC+49
OBRCODE  EQU   OBRREC+52
OBRDEV   EQU   OBRCODE+2
OBRCLASS EQU   OBRDEV
OBRLSDRC EQU   OBRREC+56
OBRPCUA  EQU   OBRREC+57
OBRSBCNT EQU   OBRREC+62
OBRVOL   EQU   OBRREC+64
OBRSEEK  EQU   OBRREC+70
OBRTERMN EQU   OBRSEEK+2
SFTREC   EQU   0
SFTHEAD  EQU   SFTREC
SFTKEY   EQU   SFTHEAD
SFTCPUID EQU   SFTHEAD+16
SFTSDWA  EQU   SFTREC+32
SFTAEC1  EQU   SFTSDWA+96
SFTFLGS  EQU   SFTSDWA+232
SFTRECP  EQU   SFTSDWA+292
IPLREC   EQU   0
IPLHEAD  EQU   IPLREC
IPLKEY   EQU   IPLHEAD
IPLCPUID EQU   IPLHEAD+16
IPLSTIME EQU   IPLREC+52
DDRREC   EQU   0
DDRHEAD  EQU   DDRREC
DDRKEY   EQU   DDRHEAD
DDRSMS   EQU   DDRHEAD+2
DDRCPUID EQU   DDRHEAD+16
@NM00051 EQU   DDRREC+24
DDRFDEV  EQU   DDRREC+48
DDRCODE2 EQU   DDRFDEV+2
DDRTODEV EQU   DDRREC+56
MIHREC   EQU   0
MIHHEAD  EQU   MIHREC
MIHKEY   EQU   MIHHEAD
@NM00053 EQU   MIHHEAD+4
MIHCPUID EQU   MIHHEAD+16
@NM00056 EQU   MIHREC+24
MIHDEV   EQU   MIHREC+44
MIHCODE2 EQU   MIHDEV+2
EODREC   EQU   0
EODHEAD  EQU   EODREC
EODKEY   EQU   EODHEAD
EODCPUID EQU   EODHEAD+16
TPRREC   EQU   0
TPRHEAD  EQU   TPRREC
TPRKEY   EQU   TPRHEAD
TPRBUFC  EQU   TPRHEAD+5
TPRCPUID EQU   TPRHEAD+16
@NM00064 EQU   TPRREC+26
MCFREC   EQU   0
MCFHEAD  EQU   MCFREC
MCFKEY   EQU   MCFHEAD
MCFSMS   EQU   MCFHEAD+2
@NM00072 EQU   MCFHEAD+16
MCFSMO   EQU   MCFHEAD+17
CCFREC   EQU   0
CCFHEAD  EQU   CCFREC
CCFKEY   EQU   CCFHEAD
CCFSMS   EQU   CCFHEAD+2
@NM00080 EQU   CCFHEAD+16
CCFSMO   EQU   CCFHEAD+17
OBRSENSE EQU   0
NEXTBYTE EQU   0
ADDNUM   EQU   0
IFCMSG   EQU   0
PRIMCUA  EQU   OBRPCUA
PHYSIDRV EQU   PRIMCUA+2
CCW      EQU   OBRFCCW
CCCCW    EQU   CCW
CACCW    EQU   CCW+1
FLCCW    EQU   CCW+4
BLANKCCW EQU   CCW+5
CTCCW    EQU   CCW+6
CSWFAIL  EQU   OBRCSW
KCSW     EQU   CSWFAIL
CACSW    EQU   CSWFAIL+1
USCSW    EQU   CSWFAIL+4
CSCSW    EQU   CSWFAIL+5
CTCSW    EQU   CSWFAIL+6
TIME     EQU   OBRTIME
OBRHOUR  EQU   TIME
OBRMINTE EQU   TIME+1
OBRSECOD EQU   TIME+2
OBRTHSEC EQU   TIME+3
OBRSEKAD EQU   OBRREC+72
OBRSEKM  EQU   OBRSEKAD
OBRSEKBB EQU   OBRSEKAD+1
OBRSEKCC EQU   OBRSEKAD+3
OBRSEKHH EQU   OBRSEKAD+5
OBRSEKR  EQU   OBRSEKAD+7
OBRBLKAD EQU   OBRREC+72
OBRACCPO EQU   OBRREC+80
PRTLNE1  EQU   PRTLINE
LABL1A   EQU   PRTLNE1+1
MODELNO  EQU   PRTLNE1+77
NULLMODL EQU   MODELNO
LABL1B   EQU   PRTLNE1+93
SERIAL   EQU   PRTLNE1+106
PRTLNE2  EQU   PRTLINE
SYSTEM   EQU   PRTLNE2+3
LABL2    EQU   PRTLNE2+9
LEVEL    EQU   PRTLNE2+14
PRTLNE3  EQU   PRTLINE
LABL3    EQU   PRTLNE3+25
JOBNAME  EQU   PRTLNE3+95
PRTLNE4  EQU   PRTLINE
LABL4A   EQU   PRTLNE4+18
DAY      EQU   PRTLNE4+25
YEAR     EQU   PRTLNE4+30
LABL4B   EQU   PRTLNE4+53
HOURS    EQU   PRTLNE4+60
MINUTES  EQU   PRTLNE4+63
SECONDS  EQU   PRTLNE4+66
THSECOND EQU   PRTLNE4+69
HEXJOB   EQU   PRTLNE4+95
PRTLNE5  EQU   PRTLINE
LABL5    EQU   PRTLNE5+1
TYPE     EQU   PRTLNE5+35
FAKEDEVC EQU   PRTLNE5+44
PRTLNE6  EQU   PRTLINE
LABL6    EQU   PRTLNE6+1
PCUA     EQU   PRTLNE6+35
PRTLNE7  EQU   PRTLINE
LABL7    EQU   PRTLNE7+1
LCUA     EQU   PRTLNE7+35
PRTLNE8  EQU   PRTLINE
LABL8    EQU   PRTLNE8+1
PHDRIVE  EQU   PRTLNE8+35
PRTLNE9  EQU   PRTLINE
LABL9    EQU   PRTLNE9+1
VOLLABEL EQU   PRTLNE9+35
PRTLNE10 EQU   PRTLINE
LABL10   EQU   PRTLNE10+1
ERROR    EQU   PRTLNE10+35
PRTLN10A EQU   PRTLINE+35
PRTLN10B EQU   PRTLINE
PRTLNE11 EQU   PRTLINE
LABL11   EQU   PRTLNE11+1
FAULT22  EQU   PRTLNE11+35
FAULT23  EQU   PRTLNE11+37
PRTLNE12 EQU   PRTLINE
LABL12   EQU   PRTLNE12+20
PRTLNE13 EQU   PRTLINE
LABL13A  EQU   PRTLNE13+1
CCWCC    EQU   PRTLNE13+20
CCWCA    EQU   PRTLNE13+23
CCWFL    EQU   PRTLNE13+30
CCWBLANK EQU   PRTLNE13+33
CCWCT    EQU   PRTLNE13+36
LABL13B  EQU   PRTLNE13+52
CSWK     EQU   PRTLNE13+60
CSWCA    EQU   PRTLNE13+63
CSWUS    EQU   PRTLNE13+70
CSWCS    EQU   PRTLNE13+73
CSWCT    EQU   PRTLNE13+76
PRTLNE14 EQU   PRTLINE
LABL14   EQU   PRTLNE14+20
PRTLN15A EQU   PRTLINE
LABL15A  EQU   PRTLN15A+1
BLOCKADR EQU   PRTLN15A+20
PRTLN15B EQU   PRTLINE
LABL15B  EQU   PRTLN15B+1
M        EQU   PRTLN15B+20
BB       EQU   PRTLN15B+23
CC       EQU   PRTLN15B+28
HH       EQU   PRTLN15B+33
R        EQU   PRTLN15B+38
PRTLN16A EQU   PRTLINE
LABL16A  EQU   PRTLN16A+21
PRTLN16B EQU   PRTLINE
LABL16B  EQU   PRTLN16B+21
PRTLNE17 EQU   PRTLINE
LABL17   EQU   PRTLNE17+1
ACCPOS   EQU   PRTLNE17+20
PRTLNE18 EQU   PRTLINE
LABL18   EQU   PRTLNE18+1
FOR22    EQU   PRTLNE18+35
WORK     EQU   TEMP2
WORKOVER EQU   TEMP2
BINWORD  EQU   NEXTBY
TRECCH   EQU   TRECCH0
         AGO   .@UNREFD                START UNREFERENCED COMPONENTS
@NM00140 EQU   PRTLNE18+32
@NM00139 EQU   PRTLNE18
@NM00138 EQU   PRTLNE17+16
@NM00137 EQU   PRTLNE17
@NM00136 EQU   PRTLN16B
@NM00135 EQU   PRTLN16A
@NM00134 EQU   PRTLN15B+37
@NM00133 EQU   PRTLN15B+32
@NM00132 EQU   PRTLN15B+27
@NM00131 EQU   PRTLN15B+22
@NM00130 EQU   PRTLN15B+18
@NM00129 EQU   PRTLN15B
@NM00128 EQU   PRTLN15A+14
@NM00127 EQU   PRTLN15A
@NM00126 EQU   PRTLNE14
@NM00125 EQU   PRTLNE13+75
@NM00124 EQU   PRTLNE13+72
@NM00123 EQU   PRTLNE13+69
@NM00122 EQU   PRTLNE13+62
@NM00121 EQU   PRTLNE13+55
@NM00120 EQU   PRTLNE13+40
@NM00119 EQU   PRTLNE13+35
@NM00118 EQU   PRTLNE13+32
@NM00117 EQU   PRTLNE13+29
@NM00116 EQU   PRTLNE13+22
@NM00115 EQU   PRTLNE13+12
@NM00114 EQU   PRTLNE13
@NM00113 EQU   PRTLNE12
@NM00112 EQU   PRTLNE11+19
@NM00111 EQU   PRTLNE11
@NM00110 EQU   PRTLNE10+18
@NM00109 EQU   PRTLNE10
@NM00108 EQU   PRTLNE9+13
@NM00107 EQU   PRTLNE9
@NM00106 EQU   PRTLNE8+15
@NM00105 EQU   PRTLNE8
@NM00104 EQU   PRTLNE7+29
@NM00103 EQU   PRTLNE7
@NM00102 EQU   PRTLNE6+30
@NM00101 EQU   PRTLNE6
@NM00100 EQU   PRTLNE5+43
@NM00099 EQU   PRTLNE5+17
@NM00098 EQU   PRTLNE5
@NM00097 EQU   PRTLNE4+71
@NM00096 EQU   PRTLNE4+68
@NM00095 EQU   PRTLNE4+65
@NM00094 EQU   PRTLNE4+62
@NM00093 EQU   PRTLNE4+32
@NM00092 EQU   PRTLNE4+28
@NM00091 EQU   PRTLNE4
@NM00090 EQU   PRTLNE3+93
@NM00089 EQU   PRTLNE3
@NM00088 EQU   PRTLNE2+13
@NM00087 EQU   PRTLNE2+7
@NM00086 EQU   PRTLNE2
@NM00085 EQU   PRTLNE1+81
@NM00084 EQU   PRTLNE1
@NM00083 EQU   PRIMCUA
CCFFRAME EQU   CCFREC+24
@NM00082 EQU   CCFHEAD+22
CCFMOD   EQU   CCFSMO+3
CCFSER   EQU   CCFSMO
CCFVER   EQU   @NM00080
@NM00081 EQU   @NM00080
CCFTIMD  EQU   CCFHEAD+12
CCFDAT   EQU   CCFHEAD+8
@NM00079 EQU   CCFHEAD+7
CCFCNT   EQU   CCFHEAD+6
@NM00078 EQU   CCFHEAD+4
@NM00077 EQU   CCFSMS+1
CCFCPU   EQU   CCFSMS+1
CCFMP    EQU   CCFSMS+1
@NM00076 EQU   CCFSMS
CCFTIM   EQU   CCFSMS
@NM00075 EQU   CCFSMS
CCFTRU   EQU   CCFSMS
CCFTOD   EQU   CCFSMS
CCFLST   EQU   CCFSMS
CCFKEY2  EQU   CCFKEY+1
CCFKEY1  EQU   CCFKEY
MCFFRAME EQU   MCFREC+24
@NM00074 EQU   MCFHEAD+22
MCFMOD   EQU   MCFSMO+3
MCFSER   EQU   MCFSMO
MCFVER   EQU   @NM00072
@NM00073 EQU   @NM00072
MCFTIMD  EQU   MCFHEAD+12
MCFDAT   EQU   MCFHEAD+8
@NM00071 EQU   MCFHEAD+7
MCFCNT   EQU   MCFHEAD+6
@NM00070 EQU   MCFHEAD+4
@NM00069 EQU   MCFSMS+1
MCFCPU   EQU   MCFSMS+1
MCFMP    EQU   MCFSMS+1
@NM00068 EQU   MCFSMS
MCFTIM   EQU   MCFSMS
@NM00067 EQU   MCFSMS
MCFTRU   EQU   MCFSMS
MCFTOD   EQU   MCFSMS
MCFLST   EQU   MCFSMS
MCFKEY2  EQU   MCFKEY+1
MCFKEY1  EQU   MCFKEY
RMSSCBRY EQU   TPRREC+58
DVBSDRE  EQU   TPRREC+56
@NM00066 EQU   TPRREC+39
TPRMODE  EQU   TPRREC+38
TPRLINAD EQU   TPRREC+36
@NM00065 EQU   TPRREC+34
TPRVOL   EQU   @NM00064
TPRCUA   EQU   TPRREC+24
TPRCEL   EQU   TPRCPUID+6
TPRMODEL EQU   TPRCPUID+4
TPRSER   EQU   TPRCPUID+1
@NM00063 EQU   TPRCPUID
TPRTIME  EQU   TPRHEAD+12
TPRDATE  EQU   TPRHEAD+8
@NM00062 EQU   TPRHEAD+6
TPRLENGT EQU   TPRBUFC
@NM00061 EQU   TPRBUFC
TPRDEV   EQU   TPRHEAD+4
TPRSMS   EQU   TPRHEAD+2
TPRKEY2  EQU   TPRKEY+1
TPRKEY1  EQU   TPRKEY
EODCEL   EQU   EODCPUID+6
EODMODEL EQU   EODCPUID+4
EODSER   EQU   EODCPUID+1
@NM00060 EQU   EODCPUID
EODTIME  EQU   EODHEAD+12
EODDATE  EQU   EODHEAD+8
@NM00059 EQU   EODHEAD+5
EODDEV   EQU   EODHEAD+4
EODSMS   EQU   EODHEAD+2
EODKEY2  EQU   EODKEY+1
EODKEY1  EQU   EODKEY
MIHTYPE  EQU   MIHCODE2+1
MIHCLASS EQU   MIHCODE2
@NM00058 EQU   MIHDEV
MIHVOL   EQU   MIHREC+38
MIHCUA   EQU   MIHREC+35
@NM00057 EQU   @NM00056+8
MIHJOBID EQU   @NM00056
MIHCEL   EQU   MIHCPUID+6
MIHMOD   EQU   MIHCPUID+4
MIHSER   EQU   MIHCPUID+1
@NM00055 EQU   MIHCPUID
MIHTIME  EQU   MIHHEAD+12
MIHDATE  EQU   MIHHEAD+8
@NM00054 EQU   MIHHEAD+6
MIHCSID  EQU   MIHHEAD+5
MIHDEBIT EQU   @NM00053
MIHCEBIT EQU   @NM00053
MIHSMS   EQU   MIHHEAD+2
MIHKEY2  EQU   MIHKEY+1
MIHKEY1  EQU   MIHKEY
DDRDEV2  EQU   DDRTODEV+2
DDRDEV1  EQU   DDRTODEV
DDRTOCUA EQU   DDRREC+53
@NM00052 EQU   DDRREC+52
DDRTYPE  EQU   DDRCODE2+1
DDRCLASS EQU   DDRCODE2
DDRCODE1 EQU   DDRFDEV
DDRFCUA  EQU   DDRREC+45
DDRPHD   EQU   @NM00051+20
DDRVOL2  EQU   @NM00051+14
DDRVOL1  EQU   @NM00051+8
DDRJOBID EQU   @NM00051
DDRCEL   EQU   DDRCPUID+6
DDRMOD   EQU   DDRCPUID+4
DDRSER   EQU   DDRCPUID+1
@NM00050 EQU   DDRCPUID
DDRTIME  EQU   DDRHEAD+12
DDRDATE  EQU   DDRHEAD+8
@NM00049 EQU   DDRHEAD+4
DDRDEPSW EQU   DDRSMS+1
@NM00048 EQU   DDRSMS
DDRKEY2  EQU   DDRKEY+1
DDRKEY1  EQU   DDRKEY
IPLSHSEC EQU   IPLSTIME+3
IPLSSEC  EQU   IPLSTIME+2
IPLSMIN  EQU   IPLSTIME+1
IPLSHOUR EQU   IPLSTIME
IPLSDATE EQU   IPLREC+48
IPLTEMP  EQU   IPLREC+46
IPLHIGH  EQU   IPLREC+42
IPLCHAN  EQU   IPLREC+32
@NM00047 EQU   IPLREC+30
IPLREAS  EQU   IPLREC+28
@NM00046 EQU   IPLREC+25
IPLSYSID EQU   IPLREC+24
IPLCEL   EQU   IPLCPUID+6
IPLMOD   EQU   IPLCPUID+4
IPLSER   EQU   IPLCPUID+1
@NM00045 EQU   IPLCPUID
IPLTIME  EQU   IPLHEAD+12
IPLDATE  EQU   IPLHEAD+8
@NM00044 EQU   IPLHEAD+4
IPLSMS   EQU   IPLHEAD+2
IPLKEY2  EQU   IPLKEY+1
IPLKEY1  EQU   IPLKEY
SFTXDATA EQU   SFTREC+434
SFTLVARA EQU   SFTREC+432
SFTREXN  EQU   SFTRECP+16
SFTCSECT EQU   SFTRECP+8
SFTMODN  EQU   SFTRECP
@NM00043 EQU   SFTSDWA+238
SFTLCPUA EQU   SFTSDWA+236
SFTERRD  EQU   SFTFLGS+3
SFTERRC  EQU   SFTFLGS+2
SFTERRB  EQU   SFTFLGS+1
SFTERRA  EQU   SFTFLGS
@NM00042 EQU   SFTSDWA+136
SFTAAEC1 EQU   SFTSDWA+120
@NM00041 EQU   SFTSDWA+112
SFTPROGC EQU   SFTAEC1+8
@NM00040 EQU   SFTAEC1
@NM00039 EQU   SFTSDWA+88
SFTGRSV  EQU   SFTSDWA+24
SFTABNDC EQU   SFTSDWA
SFTJOBID EQU   SFTREC+24
SFTCEL   EQU   SFTCPUID+6
SFTMOD   EQU   SFTCPUID+4
SFTSER   EQU   SFTCPUID+1
@NM00038 EQU   SFTCPUID
SFTTIME  EQU   SFTHEAD+12
SFTDATE  EQU   SFTHEAD+8
@NM00037 EQU   SFTHEAD+4
SFTSMS   EQU   SFTHEAD+2
SFTKEY2  EQU   SFTKEY+1
SFTKEY1  EQU   SFTKEY
OBR34CT2 EQU   OBRTERMN+5
OBR34CT1 EQU   OBRTERMN+4
@NM00036 EQU   OBRTERMN
@NM00035 EQU   OBRSEEK+1
OBRTCAM  EQU   OBRSEEK
OBRRETRY EQU   OBRREC+60
OBRTYPE  EQU   OBRDEV+1
OBRCODE1 EQU   OBRCODE
OBRSTAT  EQU   OBRCSW+4
@NM00034 EQU   OBRCSW
OBRSDRS2 EQU   OBRSRDS
OBRSDRS1 EQU   OBRSRDS
OBRSCUA  EQU   OBRJOBID+5
OBRSSDRC EQU   OBRJOBID+4
OBRSDEV2 EQU   OBRJOBID+2
OBRSDEV1 EQU   OBRJOBID
OBRCEL   EQU   OBRCPUID+6
@NM00033 EQU   OBRCPUID
@NM00032 EQU   OBRHEAD+4
@NM00031 EQU   OBRSUBTP
DISMOUNT EQU   OBRSUBTP
@NM00030 EQU   OBRSUBTP
SHORTSW  EQU   OBRSUBTP
SDRCOUNT EQU   OBRSUBTP
@NM00029 EQU   MISCSW
TRUNC    EQU   MISCSW
@NM00028 EQU   MISCSW
OBRKEY1  EQU   OBRKEY
CCHLOG   EQU   CCHREC+80
CCHMP    EQU   CCHREC+76
CCHCUA   EQU   CCHREC+74
@NM00027 EQU   CCHREC+73
CCHID    EQU   CCHREC+72
CCHTYPE  EQU   CCHCODE2+1
CCHCLASS EQU   CCHCODE2
CCHCODE1 EQU   CCHCODE
CCHECSW  EQU   CCHREC+64
CCHCSW   EQU   CCHREC+56
CCHFCCW  EQU   CCHREC+48
CCHATIO  EQU   CCHREC+32
CCHJOBID EQU   CCHREC+24
CCHCEL   EQU   CCHCPUID+6
CCHMOD   EQU   CCHCPUID+4
CCHSER   EQU   CCHCPUID+1
@NM00026 EQU   CCHCPUID
CCHTIME  EQU   CCHHEAD+12
CCHDATE  EQU   CCHHEAD+8
@NM00025 EQU   CCHHEAD+4
CCHRINC  EQU   CCHSMS+1
@NM00024 EQU   CCHSMS
CCHRCRH  EQU   CCHSMS
@NM00023 EQU   CCHSMS
CCHKEY2  EQU   CCHKEY+1
CCHKEY1  EQU   CCHKEY
MCHLOG   EQU   MCHREC+48
MCHOPSW  EQU   MCHREC+40
MCHJOBID EQU   MCHREC+32
MCHPGMID EQU   MCHREC+24
MCHCEL   EQU   MCHCPUID+6
MCHMOD   EQU   MCHCPUID+4
MCHSER   EQU   MCHCPUID+1
@NM00022 EQU   MCHCPUID
MCHTIME  EQU   MCHHEAD+12
MCHDATE  EQU   MCHHEAD+8
@NM00021 EQU   MCHHEAD+4
MCHSYSTR EQU   MCHSMS+1
@NM00020 EQU   MCHSMS
MCHKEY2  EQU   MCHKEY+1
MCHKEY1  EQU   MCHKEY
LRTMCEL  EQU   LRTCPU+6
LRTMODEL EQU   LRTCPMOD+3
LRTCPUS  EQU   LRTCPMOD
@NM00019 EQU   LRTCPU
LRTHSECS EQU   LRTTIME+3
LRTSEC   EQU   LRTTIME+2
LRTMIN   EQU   LRTTIME+1
LRTHOUR  EQU   LRTTIME
LRTDAY   EQU   LRTYRDAY+1
LRTYEAR  EQU   LRTYRDAY
LRTDATE0 EQU   LRTDATE
@NM00018 EQU   @NM00016+3
LRTCNT   EQU   @NM00016+2
@NM00017 EQU   @NM00016
LRTDSMNT EQU   LRTERRID
@NM00015 EQU   LRTERRID
LRTSHRT  EQU   LRTERRID
@NM00014 EQU   LRTERRID
@NM00013 EQU   LRTSMS
LRTIMCNV EQU   LRTSMS
@NM00012 EQU   LRTSMS
LRTRUNC  EQU   LRTSMS
LRNS     EQU   LRTSMS
LRTNLAST EQU   LRTSMS
LRTKEY2  EQU   LRTKEY+1
LRTKEY1  EQU   LRTKEY
MODEL    EQU   MERIDIAN+2
MRDNUMBR EQU   MERIDIAN
SYMVAL2  EQU   SYMVAL+2
SYMVAL1  EQU   SYMVAL
SYMCDNUM EQU   SYMCODE
LIBVAL   EQU   LIBADR+2
LIBADNUM EQU   LIBADR
CPUCUX3  EQU   CPUCUAV+5
CPUCUX2  EQU   CPUCUAV+3
CPUCUX1  EQU   CPUCUAV
CPCUANUM EQU   CPUCUAS
CPUVAL   EQU   CPUS+2
CPUNUM   EQU   CPUS
VOLVAL   EQU   VOLUME+2
VOLNUM   EQU   VOLUME
SERVAL   EQU   DEVSERAL+2
SERNUM   EQU   DEVSERAL
MODVAL   EQU   MODELS+2
MODNUM   EQU   MODELS
MDRVAL   EQU   DEVICE+204
MDRNUM   EQU   DEVICE+202
DEVVAL   EQU   DEVICE+2
DEVNUM   EQU   DEVICE
CUA2     EQU   CUAVAL+2
CUA1     EQU   CUAVAL
CUANUM   EQU   CUA
LOADPTR  EQU   EDITABLE+8
LOADNAME EQU   EDITABLE
EDITNUM  EQU   EDITLOAD
SHARLET  EQU   SHAREIO+15
SHRCUAAH EQU   SHRCUCPU+5
SHRCUAAL EQU   SHRCUCPU+3
SHARSERA EQU   SHRCUCPU
SHRCUABH EQU   SHRBASE+5
SHRCUABL EQU   SHRBASE+3
SHARSERB EQU   SHRBASE
SHAREFLG EQU   SHAREIO
SHARENUM EQU   SHARE
SYSTEMP  EQU   SYSUM2+10
SYSPERM  EQU   SYSUM2+8
SYSRANGE EQU   SYSUM2+7
SYSDEV   EQU   SYSUM2+5
SYSOLDA  EQU   SYSITEM
SYS3705  EQU   SYSITEM
SYSOLD   EQU   SYSCPUS
SYSCPU   EQU   SYSCPUS
SYSTROLL EQU   SYSRT+1
SYSSPAN  EQU   SYSRT+1
SYSCUA   EQU   SYSRT
SYSGROUP EQU   SYSUMKEY
SYSUMEOD EQU   SYSUMONE+96
SYSUMPER EQU   SYSUMONE+92
SYSUMPEA EQU   SYSUMONE+88
SYSUMPEI EQU   SYSUMONE+84
SYSUMCH  EQU   SYSUMONE+20
SYSUMMCN EQU   SYSUMONE+16
SYSUMMCR EQU   SYSUMONE+12
SYSUMNXT EQU   SYSUMONE+8
SYSUMIPL EQU   SYSUMONE+4
SYSUMNUM EQU   SYSUMONE
SORTCORE EQU   SORTCCHR
SORTTIME EQU   SORTKEY+1
SORTYEAR EQU   SORTKEY
EVLETTER EQU   EVKEY+5
EVSERIAL EQU   EVKEY+2
EVMODEL  EQU   EVKEY
EVNUM    EQU   EVTABLE+4
EVDAY    EQU   EVSTOP+1
EVYEAR   EQU   EVSTOP
TRETMP   EQU   TREND2+10
TREPRM   EQU   TREND2+8
TRENDDEV EQU   TREND2+6
TRENDDAT EQU   TRENDKEY+5
TRENDOD  EQU   TRENDITM
TREND037 EQU   TRENDITM
TRENDOLD EQU   TRENCPUS
TRENDCPU EQU   TRENCPUS
@NM00011 EQU   TRENDRT+1
TRENDCUA EQU   TRENDRT
TRENDGRP EQU   TRENDKEY
TREPRE   EQU   TREGEN+72
TRECCHF  EQU   TREGEN+68
TRECCHE  EQU   TREGEN+64
TRECCHD  EQU   TREGEN+60
TRECCHC  EQU   TREGEN+56
TRECCHB  EQU   TREGEN+52
TRECCHA  EQU   TREGEN+48
TRECCH9  EQU   TREGEN+44
TRECCH8  EQU   TREGEN+40
TRECCH7  EQU   TREGEN+36
TRECCH6  EQU   TREGEN+32
TRECCH5  EQU   TREGEN+28
TRECCH4  EQU   TREGEN+24
TRECCH3  EQU   TREGEN+20
TRECCH2  EQU   TREGEN+16
TRECCH1  EQU   TREGEN+12
TREMCH   EQU   TREGEN+4
TREIPL   EQU   TREGEN
TRENUM   EQU   TRENDONE+4
TRENEXT  EQU   TRENDONE
DUMPSIZE EQU   DUMPINFO+4
DUMPADR  EQU   DUMPINFO
DUMPNUM  EQU   DUMPTABL
@NM00010 EQU   PARM+212
RECLNGT1 EQU   PARM+204
FRAMEPTR EQU   PARM+200
ADCPUT   EQU   PARM+144
LINECT   EQU   PARM+120
RECLNGTH EQU   CCHHRLNG+6
@NM00009 EQU   CCHHRLNG+5
RECCCHHR EQU   CCHHRLNG
USERPGM  EQU   PARM+102
IDTSEC   EQU   IDTIME+3
IDSEC    EQU   IDTIME+2
IDMIN    EQU   IDTIME+1
IDHOUR   EQU   IDTIME
IDASID   EQU   ERRID+4
IDCPU    EQU   ERRID+3
@NM00008 EQU   ERRID+2
IDVALUE  EQU   ERRID
NUMDAYS  EQU   PARM+88
SORTNUM  EQU   PARM+84
TABSIZE  EQU   PARM+80
SYSRETRN EQU   @NM00007
NUMIN222 EQU   @NM00006
WRTHRSH  EQU   PARM+69
RDTHRSH  EQU   PARM+66
TERM     EQU   PARM+58
EVSDAY   EQU   STRTDATE+1
EVSYEAR  EQU   STRTDATE
PENSEC2  EQU   ENDTIME2+2
PENMIN2  EQU   ENDTIME2+1
PENHOUR2 EQU   ENDTIME2
PSTSEC2  EQU   STTIME2+2
PSTMIN2  EQU   STTIME2+1
PSTHOUR2 EQU   STTIME2
PENSEC1  EQU   ENDTIME1+2
PENMIN1  EQU   ENDTIME1+1
PENHOUR1 EQU   ENDTIME1
PSTSEC1  EQU   STTIME1+2
PSTMIN1  EQU   STTIME1+1
PSTHOUR1 EQU   STTIME1
@NM00005 EQU   ENDDT+4
PENDY    EQU   PEND+1
PENYR    EQU   PEND
@NM00004 EQU   ENDDATE
@NM00003 EQU   STDT+4
PSTDY    EQU   PSTD+1
PSTYR    EQU   PSTD
@NM00002 EQU   STDATE
YEARNOW  EQU   DATENOW+4
@NM00001 EQU   DATENOW+3
DAYNOW   EQU   DATENOW
CSNAP    EQU   CLOSEIO
CDRCTWRK EQU   CLOSEIO
CSYSIN   EQU   CLOSEIO
CACCDEV  EQU   CLOSEIO
CACCIN   EQU   CLOSEIO
CSERLOG  EQU   CLOSEIO
CEREPPT  EQU   CLOSEIO
CTOURIST EQU   CLOSEIO
OSNAP    EQU   OPENIO
ODRCTWRK EQU   OPENIO
OSYSIN   EQU   OPENIO
OACCDEV  EQU   OPENIO
OACCIN   EQU   OPENIO
OSERLOG  EQU   OPENIO
OEREPPT  EQU   OPENIO
OTOURIST EQU   OPENIO
PASSFLAG EQU   MISC
PLOGREC  EQU   MISC
ERRORID  EQU   MISC
PSUM     EQU   PRINTES
PEDIT    EQU   PRINTES
PHIST    EQU   MISC
PACC     EQU   MISC
PZERO    EQU   MISC
DEBUG63  EQU   DEBUGA+3
DEBUG62  EQU   DEBUGA+3
DEBUG61  EQU   DEBUGA+3
DEBUG60  EQU   DEBUGA+3
DEBUG59  EQU   DEBUGA+3
DEBUG58  EQU   DEBUGA+3
DEBUG57  EQU   DEBUGA+3
DEBUG56  EQU   DEBUGA+3
DEBUG55  EQU   DEBUGA+2
DEBUG54  EQU   DEBUGA+2
DEBUG53  EQU   DEBUGA+2
DEBUG52  EQU   DEBUGA+2
DEBUG51  EQU   DEBUGA+2
DEBUG50  EQU   DEBUGA+2
DEBUG49  EQU   DEBUGA+2
DEBUG48  EQU   DEBUGA+2
DEBUG47  EQU   DEBUGA+1
DEBUG46  EQU   DEBUGA+1
DEBUG45  EQU   DEBUGA+1
DEBUG44  EQU   DEBUGA+1
DEBUG43  EQU   DEBUGA+1
DEBUG42  EQU   DEBUGA+1
DEBUG41  EQU   DEBUGA+1
DEBUG40  EQU   DEBUGA+1
DEBUG39  EQU   DEBUGA
DEBUG38  EQU   DEBUGA
DEBUG37  EQU   DEBUGA
DEBUG36  EQU   DEBUGA
DEBUG35  EQU   DEBUGA
DEBUG34  EQU   DEBUGA
DEBUG33  EQU   DEBUGA
DEBUG32  EQU   DEBUGA
DEBUG31  EQU   DEBUG+3
DEBUG30  EQU   DEBUG+3
DEBUG29  EQU   DEBUG+3
DEBUG28  EQU   DEBUG+3
DEBUG27  EQU   DEBUG+3
DEBUG26  EQU   DEBUG+3
DEBUG25  EQU   DEBUG+3
DEBUG24  EQU   DEBUG+3
DEBUG23  EQU   DEBUG+2
DEBUG22  EQU   DEBUG+2
DEBUG21  EQU   DEBUG+2
DEBUG20  EQU   DEBUG+2
DEBUG19  EQU   DEBUG+2
DEBUG18  EQU   DEBUG+2
DEBUG17  EQU   DEBUG+2
DEBUG16  EQU   DEBUG+2
DEBUG15  EQU   DEBUG+1
DEBUG14  EQU   DEBUG+1
DEBUG13  EQU   DEBUG+1
DEBUG12  EQU   DEBUG+1
DEBUG11  EQU   DEBUG+1
DEBUG10  EQU   DEBUG+1
DEBUG9   EQU   DEBUG+1
DEBUG8   EQU   DEBUG+1
DEBUG7   EQU   DEBUG
DEBUG6   EQU   DEBUG
DEBUG5   EQU   DEBUG
DEBUG4   EQU   DEBUG
DEBUG3   EQU   DEBUG
DEBUG2   EQU   DEBUG
DEBUG1   EQU   DEBUG
DEBUG0   EQU   DEBUG
SORTBRK  EQU   SWITCHES+1
COREFAIL EQU   SWITCHES+1
ANALYSIS EQU   SWITCHES+1
SHIFT3RD EQU   SWITCHES+1
DEVEXCL  EQU   SWITCHES+1
ZEROALL  EQU   SWITCHES+1
NOTALL   EQU   SWITCHES+1
NOSDR    EQU   SWITCHES
TIMESEQ  EQU   SWITCHES
SYSUM    EQU   SWITCHES
PARMTHR  EQU   SWITCHES
TREND    EQU   SWITCHES
SHORTOBR EQU   SWITCHES
PARMMES  EQU   SWITCHES
RDESUM   EQU   SWITCHES
PCCHFRAM EQU   RECTYPE+1
PMCHFRAM EQU   RECTYPE+1
PTTYP    EQU   RECTYPE+1
PEOD     EQU   RECTYPE
PMIH     EQU   RECTYPE
PDDR     EQU   RECTYPE
PIPL     EQU   RECTYPE
PSOFT    EQU   RECTYPE
POBR     EQU   RECTYPE
PCHAN    EQU   RECTYPE
PMCH     EQU   RECTYPE
.@UNREFD ANOP                          END UNREFERENCED COMPONENTS
@RC00244 EQU   @EL00003
@RC00242 EQU   @EL00003
@RC00240 EQU   @EL00003
@RC00238 EQU   @EL00003
@RC00236 EQU   @EL00003
@RC00234 EQU   @EL00003
@RF00295 EQU   @RC00292
@RC00426 EQU   @RC00417
@RC00422 EQU   @RC00417
@RC00418 EQU   @RC00417
@RC00438 EQU   @RC00429
@RC00436 EQU   @RC00429
@RC00430 EQU   @RC00429
@RC00444 EQU   @RC00441
@RC00442 EQU   @RC00441
@RC00452 EQU   @RC00449
@RC00450 EQU   @RC00449
@RC00458 EQU   @RC00457
@RC00466 EQU   @RC00465
@RF00474 EQU   @EL00016
@RC00561 EQU   @EL00021
@RC00419 EQU   @RC00418
@RC00423 EQU   @RC00422
@RC00433 EQU   @RC00430
@RC00431 EQU   @RC00430
@RC00445 EQU   @RC00444
@RC00453 EQU   @RC00452
@ENDDATA EQU   *
         END   IFCEDASD
