***********************************************************************
**                                                                   **
**                                                                   **
** MODULE NAME:   IFCE3401                                           **
**                                                                   **
** DESCRIPTIVE-NAME: EDIT TABLE FOR OBR RECORDS FOR THE 8809         **
**                                                                   **
** COPYRIGHT:  NONE                                                  **
**                                                                   **
** STATUS:  N/A                                                      **
**                                                                   **
** FUNCTION:   PROVIDES DEVICE EDITING SUPPORT FOR THE 8809 OBR      **
**             RECORDS                                               **
**                                                                   **
** NOTES:                                                            **
**                                                                   **
**                                                                   **
**   DEPENDENCIES : THIS MODULE WAS ASSEMBLED USING THE EBCDIC       **
**                  CHARACTER SET.  IT MUST BE RE-ASSEMBLED IF       **
**                  ANOTHER CHARACTER SET IS TO BE USED AT EXECUTION **
**                                                                   **
**   RESTRICTIONS: N/A                                               **
**                                                                   **
**   REGISTER-CONVENTIONS :                                          **
**         REG 2 :  POINTER TO THE MDR RECORD                        **
**         REG 3 :  POINTER TO THE PRINT BUFFER                      **
**         REG 4 :  POINTER TO THE DATA ITEM REFERENCED IN 'ROUTINE' **
**         REG 14:  RETURN POINT FROM 'ROUTINE'                      **
**         REG 15:  SET TO ZERO TO SUPPRESS PRINTING LINE            **
**                                                                   **
**   PATCH-LABEL:  PATCH                                             **
**                                                                   **
** MODULE TYPE:  DATA                                                **
**                                                                   **
**   PROCESSOR:  370 ASSEMBLER                                       **
**                                                                   **
**   MODULE-SIZE:                                                    **
**                                                                   **
**   ATTRIBUTES:  SERIALLY RE-USABLE                                 **
**                                                                   **
** ENTRY-POINT:    N/A                                               **
**                                                                   **
**                                                                   **
**   LINKAGE:  N/A                                                   **
**                                                                   **
** INPUT:  N/A                                                       **
**                                                                   **
** OUTPUT:  N/A                                                      **
**                                                                   **
** EXIT-NORMAL:  N/A                                                 **
**                                                                   **
** EXIT-ERROR :  N/A                                                 **
**                                                                   **
** EXTERNAL-REFERENCES:                                              **
**                                                                   **
**   ROUTINES:  NONE                                                 **
**                                                                   **
**   DATA-AREAS:  NONE                                               **
**                                                                   **
**   CONTROL-BLOCKS:  NONE                                           **
**                                                                   **
** TABLES:  NONE                                                     **
**                                                                   **
** MACROS:  EDIT TABLE MACROS                                        **
**                                                                   **
***********************************************************************
 TITLE 'IFCE3401 EDIT TABLE FOR 8809'
 GBLC &CSECT,&DSECT
 PROLOG NAME=IFCE3401
***********************************************************************
*                                                                     *
*                   INPUT DATA TABLE DEFINITIONS                      *
*                                                                     *
***********************************************************************
*        *     *              *    *    *    *                      *
         DSGEN (KEY,8),(LEVEL,8),(INDSW,8),(DEPSW,8),(RSVD1,16)
         DSGEN (RECNUM,8),(RSVD2,8),(DATE,32),(TIME,32),(VERSION,8)
         DSGEN (CPUSER,24),(CPUID,16),(MCEL,16)
         DSGEN (TASKID,64)
         DSGEN (CCWCC,8),(CCWDA,24),(CCWFL,8),(CCWUN,8),(CCWCT,16)
         DSGEN (CSWK,8),(CSWCA,24),(CSWUS,8),(CSWCS,8),(CSWCT,16)
         ORG CSWUS
         DSGEN (CSWUSB,1,0,7),(CSWCSB,1,0,7)
         ORG
         DSGEN (DEVD,8),(RESVD2,8),(SECUA,16),(DEVTYP,32),(SDRLNG,8)
         DSGEN (RESVD3,8),(PCUA,16),(IORETRY,16),(SNSLNG,16)
         DSGEN (VOLSER,48),(BLKLNG,16)
         DSGEN (SDR,8,0,31)
         DSGEN (WORKA,32)
 EJECT
&CSECT CSECT
***********************************************************************
*                                                                     *
*                       SPECIAL ROUTINES                              *
*                                                                     *
***********************************************************************
*        *     *              *    *    *    *                      *
 SPACE 2
SETTID   MVC   0(8,R3),TASKID      MOVE IN TASKID
         BR    R14                 RETURN
SETDATE  UNPK  WORKD(5),DATE+1(3)  UNPACK DATE
         MVC   6(2,R3),WORKD       MOVE IN YEAR
         MVC   0(3,R3),WORKD+2     MOVE IN DAY
         BR    R14                 RETURN
WORKD    DC    D'0'
WORKF    DC    F'0'
 SPACE 2
SETMOD   SH    R3,TOCOL15          MOVE POINTER TO COL.15
         CLI   VERSION,MOD3VER     MODEL 3 ? ? ?
         BNER  R14                 NO - RETURN
         MVC   0(2,R3),MOD3MSG     YES - MOVE IN DATA
         BR    R14  RETURN
MOD3VER  EQU   X'01'               MOD 3 INDICATOR
MOD3MSG  DC    CL2'-3'
TOCOL15  DC    H'9'
 SPACE 2
* SETSYS CODE AND SYSDATA REMOVED FOR SYSRELN CHANGES
WORK3F   DC    3F'0'
 SPACE 2
* SETLEVEL REMOVED FOR SYSRELN CHANGES
ZONE     EQU   X'F0'                  ZONE BIT MASK
 SPACE 2
SETVOL   MVC   0(6,R3),VOLSER      MOVE IN SERIAL NUMBER
         BR    R14                 RETURN
RECTYPE  TM    KEY,MDRMSK          MDR RECORD?
         BNOR  R14                 NO, CONTINUE PROCESSING
         MVC   XR9PTR,ADDROBR      CHANGE TO LOAD OBR EDIT
         SR    R15,R15             DO NOT PRINT LINE
         BR    R14
ADDROBR  DC    A(OBR-4)
MDRMSK   EQU   X'90'
 SPACE 2
MOVAHEAD SR    R4,R2               GET DISPLACEMENT
         AR    R3,R4               ADD TO POINTER
         BR    R14                 RETURN
 SPACE 2
LDZERO   MVI   0(R3),C'0'           INSERT LEADING ZERO
         BR    R14      RETURN
 EJECT
***********************************************************************
*                                                                     *
*      LINE/LABEL CONTROL SECTION                                     *
*                                                                     *
***********************************************************************
*        *     *              *    *    *    *                      *
 SPACE 2
OBR      ETCALL IFCET040
       ENTRIES
         LINE  (1,1),(1,1),SKIP=E
       ROUTINE  KEY,RECTYPE
         LABEL  ''
         LINE  (1,1),(48,1),SKIP=2
         LABEL '--- I/O DEVICE EDITING ---'
 SPACE 2
         LINE  (39,1),(22,20),SKIP=2
       ROUTINE TASKID,SETTID
         LABEL 'TASK IDENTITY',,,'DAY  YEAR','HH MM SS'
 SPACE 2
         LINE  (82,20),(1,10),SKIP=2
       ROUTINE DATE,SETDATE
         HEX   (TIME,1,3B)
         LABEL 'RECORD TYPE - UNIT CHECK',,,,,,,'    DATE -',,         *
               '    TIME -'
 SPACE 2
         LINE  (11,13),(1,20),SKIP=2
         HEX   (CPUID,0,2B)
       ROUTINE VERSION,SETMOD
         HEX   (CPUSER,0,3B)
         LABEL 'CPU MODEL','SERIAL'
 SPACE 2
         LINE  (1,21),(8,1),SKIP=2
       SYSRELN LEVEL,8
         LABEL ''
 SPACE 2
         LINE  (31,23),(1,40),SKIP=2
         HEX   (PCUA,0,2B)
         LABEL 'FAILING CHANNEL/UNIT ADDRESS','DEVICE TYPE  8809'
 SPACE 2
         LINE  ,(15,68),SKIP=2
         LABEL 'CC   DA    FL     CT','K    CA    US CS  CT'
 SPACE 2
         LINE  (15,3),(1,76),SKIP=3
         HEX   (CCWCC,0,1B),(CCWDA,0,3B)
       ROUTINE &DSECT+2,MOVAHEAD
         HEX   (CCWFL,0,1B),(CCWUN,0,1B),(CCWCT,0,2B)
       ROUTINE &DSECT+45,MOVAHEAD
         HEX   (CSWK,0,1B),(CSWCA,0,3B)
       ROUTINE &DSECT+2,MOVAHEAD
         HEX   (CSWUS,0,1B),(CSWCS,0,1B),(CSWCT,0,2B)
         LABEL 'FAILING CCW','CSW'
 SPACE 2
         LINE  ,(15,55),SKIP=2
         LABEL '--- UNIT STATUS ---','--- CHANNEL STATUS ---'
 SPACE 2
         LINE  (19,28),(1,28),SKIP=1
         BIN   (CSWUSB0),(CSWUSB4),(CSWCSB0),(CSWCSB4)
         LABEL 'ATTENTION','CHANNEL END','PRGM-CTLD IRPT',             *
               'CHAN DATA CHECK'
 SPACE 2
         LINE
         BIN   (CSWUSB1),(CSWUSB5),(CSWCSB1),(CSWCSB5)
         LABEL 'STATUS MODIFIER','DEVICE END','INCORRECT LENGTH',      *
               'CHAN CTL CHECK'
 SPACE 2
         LINE
         BIN   (CSWUSB2),(CSWUSB6),(CSWCSB2),(CSWCSB6)
         LABEL 'CONTROL UNIT END','UNIT CHECK','PROGRAM CHECK',        *
               'I/F CTL CHECK'
 SPACE 2
         LINE  ,,SKIP=3
         BIN   (CSWUSB3),(CSWUSB7),(CSWCSB3),(CSWCSB7)
         LABEL 'BUSY','UNIT EXCEPTION','PROTECTION CHECK',             *
               'CHAINING CHECK'
 SPACE 2
         LINE  ,(1,1),SKIP=2
         LABEL 'DEVICE DEPENDENT DATA:'
 SPACE 2
         LINE  (16,1),(1,1),SKIP=1
       ROUTINE VOLSER,SETVOL
         LABEL 'VOLUME SERIAL'
 SPACE 2
         LINE  ,,SKIP=3
       ROUTINE WORKA,LDZERO
         HEX   (BLKLNG,0,2B)
         LABEL 'BLOCK LENGTH'
 SPACE 2
         LINE  ,(1,1),SKIP=2
         LABEL 'SENSE BYTE DATA:'
 SPACE 2
         LINE  ,(42,1),SKIP=1
         LABEL '1   1   1   1   1   1'
 SPACE 2
         LINE  ,(2,40)
         LABEL '0   1   2   3   4   5   6   7   8   9',                *
               '0   1   2   3   4   5'
 SPACE 2
         LINE  (1,4),,SKIP=3
         HEX   (SDR0,0,1B),(SDR1,0,1B),(SDR2,0,1B),(SDR3,0,1B)
         HEX   (SDR4,0,1B),(SDR5,0,1B),(SDR6,0,1B),(SDR7,0,1B)
         HEX   (SDR8,0,1B),(SDR9,0,1B),(SDR10,0,1B),(SDR11,0,1B)
         HEX   (SDR12,0,1B),(SDR13,0,1B),(SDR14,0,1B),(SDR15,0,1B)
         LABEL ''
 SPACE 2
         LINE  ,(2,32),SKIP=1
         LABEL '1   1   1   1   2   2   2   2',                        *
               '2   2   2   2   2   2   3   3'
 SPACE 2
         LINE
         LABEL '6   7   8   9   0   1   2   3',                        *
               '4   5   6   7   8   9   0   1'
 SPACE 2
         LINE  ,,SKIP=3
         HEX   (SDR16,0,1B),(SDR17,0,1B),(SDR18,0,1B),(SDR19,0,1B)
         HEX   (SDR20,0,1B),(SDR21,0,1B),(SDR22,0,1B),(SDR23,0,1B)
         HEX   (SDR24,0,1B),(SDR25,0,1B),(SDR26,0,1B),(SDR27,0,1B)
         HEX   (SDR28,0,1B),(SDR29,0,1B),(SDR30,0,1B),(SDR31,0,1B)
         LABEL ''
 SPACE 2
         LINE  (15,1),(1,1),SKIP=2
         HEX   (SDR30,0,2B)
         LABEL 'SYMPTOM CODE'
  SPACE 2
         ETEPILOG  RLEN=67
         END
