         GBLC  &CSECT,&DSECT
         TITLE 'IFCE5424 -- EDIT TABLE FOR 5424'
***********************************************************************
**                                                                   **
**                                                                   **
**  MODULE NAME:   IFCE5424                                          **
**                                                                   **
**  DESCRIPTIVE-NAME:   EDIT TABLE FOR 5424 (DEVICE CODE ????)       **
**                                                                   **
**  COPYRIGHT:  NONE                                                 **
**                                                                   **
**  STATUS:     N/A                                                  **
**                                                                   **
**  FUNCTION:   PROVIDES DEVICE EDIT SUPPORT FOR 5424 OBR RECORDS    **
**                                                                   **
**  NOTES:                                                           **
**                                                                   **
**    DEPENDENCIES:   THIS MODULE WAS ASSEMBLED USING THE EBCDIC     **
**                 CHARACTER SET.  IT MUST BE REASSEMBLED IF ANOTHER **
**                CHARACTER SET IS TO BE USED AT EXECUTION.         **
**                                                                   **
**    RESTRICTIONS:   N/A                                            **
**                                                                   **
**    REGISTER-CONVENTIONS:                                          **
**          REG 2  = POINTER TO THE OBR RECORD                       **
**          REG 3  = POINTER TO THE PRINT BUFFER                     **
**          REG 4  = POINTER TO DATA ITEM REFERENCED IN 'ROUTINE'    **
**          REG 14 = RETURN POINT FROM 'ROUTINE'                     **
**          REG 15 = SET TO ZERO TO SUPPRESS PRINTING LINE           **
**                                                                   **
**    PATCH-LABEL:  PATCH                                            **
**                                                                   **
**  MODULE TYPE:    DATA                                             **
**                                                                   **
**    PROCESSOR:    370 ASSEMBLER                                    **
**                                                                   **
**    MODULE-SIZE:                                                   **
**                                                                   **
**    ATTRIBUTES:   SERIALLY REUSABLE                                **
**                                                                   **
**  ENTRY-POINT:    N/A                                              **
**                                                                   **
**    LINKAGE:      N/A                                              **
**                                                                   **
**  INPUT:     N/A                                                   **
**                                                                   **
**  OUTPUT:    N/A                                                   **
**                                                                   **
**  EXIT-NORMAL:     N/A                                             **
**                                                                   **
**  EXIT-ERROR:      N/A                                             **
**                                                                   **
**  EXTERNAL-REFERENCES:                                             **
**                                                                   **
**    ROUTINES:        NONE                                          **
**                                                                   **
**    DATA-AREAS:      NONE                                          **
**                                                                   **
**    CONTROL-BLOCKS:  NONE                                          **
**                                                                   **
**    TABLES:          NONE                                          **
**                                                                   **
**    MACROS:    EDIT TABLE MACROS                                   **
**                                                                   **
***********************************************************************
         EJECT
         PROLOG NAME=IFCE5424
         DSGEN (KEY,8),(LEVEL,8),(INDSW,8),(DEPSW,8),(RSVD1,16)
         DSGEN (RECNUM,8),(RSVD2,8),(DATE,32),(TIME,32),(VERSION,8)
         DSGEN (CPUSER,24),(CPUID,16),(MCEL,16)
         DSGEN (TASKID,64)
         DSGEN (CCWCC,8),(CCWDA,24),(CCWFL,8),(CCWUN,8),(CCWCT,16)
         DSGEN (CSWK,8),(CSWCA,24),(CSWUS,8),(CSWCS,8),(CSWCT,16)
         ORG   CSWUS
         DSGEN (CSWUSB,1,0,7),(CSWCSB,1,0,7)
         ORG
         DSGEN (RSVD3,16),(FCUA,16)
         DSGEN (PUBDTC,8),(RSVD4,24),(SDRLNG,8)
         DSGEN (RSVD5,8),(NCUA,16)
         DSGEN (IORETRY,16),(SNSLNG,16)
         DSGEN (SNB,1,0,12,0,7)
         ORG   SNB00
         DSGEN (SNB,8,0,9),(SNBA,8),(SNBB,8),(SNBC,8),(SIOCNT,32)
         EJECT
&CSECT   CSECT
***********************************************************************
**                                                                   **
**                        SPECIAL ROUTINES                           **
**                                                                   **
**===================================================================**
L26      EQU   26
WORKX    DS    D                   DOUBLEWORD WORK AREA
WORKY    DS    F                   FULLWORD WORK AREA
SETTID   MVC   L0(L8,R3),TASKID    MOVE IN TASK ID
         BR    R14                 RETURN
         SPACE 3
SETDATE  UNPK  WORKX(L5),DATE+1(L3) UNPACK DATE
         MVC   L6(L2,R3),WORKX     MOVE IN YEAR
         MVC   L0(L3,R3),WORKX+2   MOVE IN DAY
         BR    R14                 RETURN
         SPACE 3
* SETLEVEL REMOVED FOR SYSRELN CHANGES
ZONE     EQU   X'F0'
         SPACE 3
MOD3     SH    R3,TOCOL15          MOVE POINTER TO COL 15
         CLI   VERSION,MOD3VER     IS IT MODEL 3?
         BNER  R14                 NO...RETURN
         MVC   L0(L2,R3),MOD3MSG
         BR    R14                 RETURN
MOD3VER  EQU   X'01'
MOD3MSG  DC    CL2'-3'
TOCOL15  DC    H'9'
         SPACE 3
MOVAHEAD SR    R4,R2               GET DISPLACEMENT
         AR    R3,R4               ADD TO POINTER
SKIPFLD  BR    R14                 RETURN
         SPACE 3
XCTR1    ST    R5,WORKY            SAVE REG
         IC    R5,0(R4)            GET COUNTER
         N     R5,CNTRM1           MASK OUT UNWANTED PART
         SRL   R5,L3               SHIFT INTO PLACE
         LA    R5,CHARS(R5)        INDEX INTO CHARACTERS
         MVC   L0(L2,R3),0(R5)     MOVE IN CARACTERS
         L     R5,WORKY            RESTORE REG
         BR    R14
CHARS    DC    C' 0 1 2 3 4 5 6 7 8 9101112131415'
CNTRM1   DC    F'240'
CNTRM2   DC    F'15'
         SPACE 3
XCTR2    ST    R5,WORKY            SAVE REG
         IC    R5,0(R4)            GET COUNTER
         N     R5,CNTRM2           MASK OUT UNWANTED PART
         SLL   R5,L1               SHIFT INTO PLACE
         LA    R5,CHARS(R5)        INDEX INTO CHARACTERS
         MVC   L0(L2,R3),0(R5)     MOVE IN CARACTERS
         L     R5,WORKY            RESTORE REG
         BR    R14
         SPACE 3
**-------------------------------------------------------------------**
**                            PATCH AREA                             **
         DC    S(PATCH)
PATCH    DC    XL50'0'
**-------------------------------------------------------------------**
         EJECT
         ENTRIES  PAGE
         LINE  ,(48,1),SKIP=2
         LABEL '--- I/O DEVICE EDITING ---'
         SPACE 2
         LINE  (39,1),(22,20),SKIP=1
         ROUTINE TASKID,SETTID
         LABEL ' TASK IDENTITY',,,'DAY  YEAR','HH MM SS'
         SPACE 2
         LINE  (82,20),(1,10),SKIP=2
         ROUTINE DATE,SETDATE
         HEX   (TIME,1,3B)
         LABEL 'RECORD TYPE - UNIT CHECK',,,,,,,'    DATE -',,'    TIME*
                -'
         SPACE 2
         LINE  (11,13),(1,20),SKIP=1
         HEX   (CPUID,0,2B)
         ROUTINE VERSION,MOD3
         HEX   (CPUSER,0,3B)
         LABEL 'CPU MODEL','SERIAL'
         SPACE 2
         LINE  (19,1),(1,1),SKIP=2
         SYSRELN LEVEL,2
         LABEL ''
         SPACE 2
         LINE  (31,23),(1,40),SKIP=2
         HEX   (FCUA,0,2B)
         LABEL 'FAILING CHANNEL/UNIT ADDRESS','DEVICE TYPE  5424'
         SPACE 2
         LINE  ,(15,68),SKIP=1
         LABEL 'CC   DA    FL     CT','K    CA    US CS  CT'
         SPACE 2
         LINE  (15,3),(1,76),SKIP=2
         HEX   (CCWCC,0,1B),(CCWDA,0,3B)
         ROUTINE &DSECT+2,MOVAHEAD
         HEX   (CCWFL,0,1B),(CCWUN,0,1B),(CCWCT,0,2B)
         ROUTINE &DSECT+45,MOVAHEAD
         HEX   (CSWK,0,1B),(CSWCA,0,3B)
         ROUTINE &DSECT+2,MOVAHEAD
         HEX   (CSWUS,0,1B),(CSWCS,0,1B),(CSWCT,0,2B)
         LABEL 'FAILING CCW','CSW'
         SPACE 2
         LINE  ,(15,55),SKIP=1
         LABEL '--- UNIT STATUS ---','--- CHANNEL STATUS ---'
         SPACE 2
         LINE  (19,28),(1,28)
         BIN   (CSWUSB0),(CSWUSB4),(CSWCSB0),(CSWCSB4)
         LABEL 'ATTENTION','CHANNEL END','PRGM-CTLD IRPT','CHAN DATA CH*
               ECK'
         SPACE 2
         LINE  ,
         BIN   (CSWUSB1),(CSWUSB5),(CSWCSB1),(CSWCSB5)
         LABEL 'STATUS MODIFIER','DEVICE END','INCORRECT LENGTH','CHAN *
               CTL CHECK'
         SPACE 2
         LINE  ,
         BIN   (CSWUSB2),(CSWUSB6),(CSWCSB2),(CSWCSB6)
         LABEL 'CONTROL UNIT END','UNIT CHECK','PROGRAM CHECK','I/F CTL*
                CHECK'
         SPACE 2
         LINE  ,,SKIP=2
         BIN   (CSWUSB3),(CSWUSB7),(CSWCSB3),(CSWCSB7)
         LABEL 'BUSY','UNIT EXCEPTION','PROTECTION CHECK','CHAINING CHE*
               CK'
         SPACE 2
         LINE  (26,27),(1,34),SKIP=2
         CONVT (IORETRY,2,5),(SIOCNT,4,8)
         LABEL 'NUMBER OF I/O RETRIES -','NUMBER OF SIOS -'
         SPACE 2
         LINE  ,(1,1),SKIP=2
         LABEL 'SENSE BYTE DATA'
         SPACE 2
         LINE  ,(5,10),SKIP=1
         LABEL 'BYTE   0','BYTE   1','BYTE   2','BYTE   3','BYTE   4','*
               BYTE   5','BYTES     6-10',,'FAULT SYMPTOM CODE'
         SPACE 2
         LINE  (5,10),,SKIP=2
         BIN   (SNB0,0,8),(SNB1,0,8),(SNB2,0,8)
         HEX   (SNB3,0,1B)
         BIN   (SNB4,0,8),(SNB5,0,8)
         HEX   (SNB6,1,5B)
         ROUTINE &DSECT,SKIPFLD
         ROUTINE &DSECT,SKIPFLD
         HEX   (SNBB,B2,2B)
         LABEL ''
         SPACE 2
         LINE  ,(5,20),SKIP=1
         LABEL 'BYTE   0','BYTE   1','BYTE   2','BYTE   4','BYTE   5'
         SPACE 2
         LINE  (20,20)
         BIN   (SNB00),(SNB10),(SNB20),(SNB40),(SNB50)
         LABEL 'CMND REJECT','READ CHECK','BIT 0','MPLE ERROR','D ROW M*
               SCOM'
         SPACE 2
         LINE  ,
         BIN   (SNB01),(SNB11),(SNB21),(SNB41),(SNB51)
         LABEL 'INTRVN REQD','PUNCH CHECK','BIT 1','TIER CODE','C ROW M*
               SCOM'
         SPACE 2
         LINE  ,
         BIN   (SNB02),(SNB12),(SNB22),(SNB42),(SNB52)
         LABEL 'BUS OUT CHK','C-S OVERRUN','PRIM WAIT','TIER CODE','B R*
               OW MSCOM'
         SPACE 2
         LINE  ,
         BIN   (SNB03),(SNB13),(SNB23),(SNB43),(SNB53)
         LABEL 'EQUIP CHECK','PRT DATA CHK','SEC WAIT','COLUMN GRP','A *
               ROW MSCOM'
         SPACE 2
         LINE  ,
         BIN   (SNB04),(SNB14),(SNB24),(SNB44),(SNB54)
         LABEL 'DATA CHECK','PRINT CL CHK','NPRO ALLOWD','COLUMN GRP','*
               8 ROW MSCOM'
         SPACE 2
         LINE  ,
         BIN   (SNB05),(SNB15),(SNB25),(SNB45),(SNB55)
         LABEL 'BIT 5','HOPPER CHK','HPPR CYCLE','COLUMN GRP','4 ROW MS*
               COM'
         SPACE 2
         LINE  ,
         BIN   (SNB06),(SNB16),(SNB26),(SNB46),(SNB56)
         LABEL 'NO CARD AVL','FEED CHECK','TRANSPT CTR','COLUMN GRP','2*
                ROW MSCOM'
         SPACE 2
         LINE  ,
         BIN   (SNB07),(SNB17),(SNB27),(SNB47),(SNB57)
         LABEL 'BIT 7','PCH DATA CHK','TRANSPT CHK','COLUMN GRP','1 ROW*
                MSCOM'
         SPACE 2
         ETEPILOG RLEN=53
         END
