*
*
*  DSGEN MACRO     DSGEN MACRO     DSGEN MACRO     DSGEN MACRO        *
         SPACE 2
         MACRO
&NAME    DSGEN &X1,&X2,&X3,&X4,&X5,&X6,&X7,&X8,&X9,&X10,&X11,&X12,&X13,X
               &X14,&X15,&X16,&X17,&X18,&X19,&X20,&X21,&X22,&X23,&X24, X
               &X25,&X26,&X27,&X28,&X29,&X30,&X31,&X32
.*                            THIS MACRO GENERATES ONE DSECT WORD
.*                                 FORMATTED FOR THE SUBJECT LOG RECORD
.*                                 EACH OPERAND HAS TWO SUB LISTS. THE
.*                                 FIRST IS THE NAME OF THE LOG ITEM
.*                                 WHILE THE SECOND IS THE # OF BITS TO
.*                                 ALLOCATE FOR THIS ITEM. ITEMS MUST
.*                                 BE DEFINED CONTIGUOUSLY WITHOUT GAPS
.*                                 UNUSED BIT GROUPS MUST BE GIVEN
.*                                 DUMMY NAMES. THE NAMES PROVIDED FOR
.*                                 THE LOG ITEMS MAY THEN BE USED IN
.*                                 THE CONVERSION MACRO INSTRUCTIONS.
         GBLC  &ITEM(2000)
         GBLA  &ITEMNBR,&BITS(2000),&SHIFT(2000)
         LCLC  &SYMBOL
         LCLA  &OP,&COUNT,&BYTE
.LOOP    ANOP
&OP      SETA  &OP+1
&ITEMNBR SETA  &ITEMNBR+1
&SYMBOL  SETC  '&SYSLIST(&OP,1)'
         AIF   ('&SYSLIST(&OP,2)' NE '').OK1
         MNOTE 'NULL BIT COUNT FIELD'
         MEXIT
.OK1     ANOP
         AIF   ('&SYMBOL' NE '').OK
         MNOTE 'LOG ITEM SYMBOL NOT PROVIDED'
         AGO   .CNT
.OK      ANOP
         AIF   ('&SYMBOL'(1,1) EQ '''').CNT                *TEMP*
&SYMBOL  EQU   *+&BYTE
&ITEM(&ITEMNBR)  SETC '&SYSLIST(&OP,1)'
&BITS(&ITEMNBR) SETA &SYSLIST(&OP,2)
&SHIFT(&ITEMNBR) SETA &COUNT-&BYTE*8
.CNT     ANOP
&COUNT   SETA  &COUNT+&SYSLIST(&OP,2)
&BYTE    SETA  &COUNT/8
         AIF (&OP LT N'&SYSLIST).LOOP
         AIF   (&COUNT NE 32).NOT32
&NAME    DS    4C
         MEXIT
.NOT32   AIF   (&COUNT NE 64).ERR
&NAME    DS    8C
         MEXIT
.ERR     MNOTE '**BIT COUNT FIELDS DO NOT TOTAL 32 OR 64**'
         MEND
*
*
         MACRO
&NAME    LINE  &DATA,&LABEL,&SKIP=
.*                            THIS MACRO ESTABLISHES THE MARGINS OR
.*                                 COLUMN SETTINGS FOR EACH LINE. IT
.*                                 GENERATES NECESSARY CARRIAGE CONTROL
.*                                 ENTRIES. LASTLY IT DETERMINES THE
.*                                 NUMBER OF ENTRIES ASSOCIATED WITH
.*                                 THE PREVIOUS LINE AND STORES THAT #
.*                                 INTO THE APPROPRIATE BYTE.
.*
.*                                 &DATA(1) - CHARACTER POSITION TO
.*                                 BEGIN DATA.
.*
.*                                 &DATA(2) - # OF SPACES BETWEEN
.*                                 SUCCESSIVE DATA COLUMN STARTING
.*                                 CHARACTERS.
.*
.*                                 &LABEL(1) - CHARACTER POSITION
.*                                 TO BEGIN LABELS.
.*
.*                                 &LABEL(2) - # OF SPACES BETWEEN
.*                                 LINE'S LABEL STARTING CHARACTERS.
.*
.*                                 &SKIP= - # OF LINES TO ADVANCE
.*                                 CARRIAGE TO BEGIN NEXT PRINTED LINE.
.*
.*                                 NEW ENTRIES ARE GENERATED ONLY WHEN
.*                                 NECESSARY. OMISSION OF ITEMS MEANS
.*                                 THEY HAVE NOT CHANGED SINCE PREVIOUS
.*                                 SETTINGS. A LINE MACRO IS REQUIRED
.*                                 FOR EACH PRINTED LINE. IF NO SETTING
.*                                 CHANGES ARE REQUIRED ALL OPERANDS
.*                                 ARE OMITTED IN WHICH CASE ONLY THE
.*                                 # OF ENTRIES FOR THE PREVIOUS LINE
.*                                 IS COMPUTED. THIS MACRO MUST BE THE
.*                                 FIRST MACRO INSTRUCTION ISSUED FOR
.*                                 THE SUBJECT LINE.
         GBLA  &DB,&DT,&LB,&LT,&NRENTS
         GBLA  &LASTCC,&INITIAL
         GBLC  &NRENTSX
         GBLC  &CARRCON
         GBLB  &TEST
         LCLA  &S
&NAME    DS    0C
         AIF   (&INITIAL EQ 0).FIRSTLN
         LINEND
         AGO   .NTFIRST
.FIRSTLN ANOP
&NRENTSX SETC  'N&SYSNDX'
&INITIAL SETA  1
N&SYSNDX EQU   *
.NTFIRST ANOP
         DC    AL1(0)
         AIF   ('&DATA(1)' EQ '').CKDTABS
         AIF   (&DATA(1) EQ &DB).CKDTABS
&DB      SETA  &DATA(1)
         AGO   .AA
.CKDTABS AIF   ('&DATA(2)' EQ '').NCDATA
         AIF   (&DATA(2) EQ &DT).NCDATA
         AGO   .CC
.AA      AIF   ('&DATA(2)' EQ '').BB
         AIF   (&DATA(2) EQ &DT).BB
.CC      ANOP
&DT      SETA  &DATA(2)
.BB      DC    XL2'FFFE'
         DC    FL1'&DB'
         DC    FL1'&DT'
&NRENTS  SETA  &NRENTS+1
.NCDATA  ANOP
         AIF   ('&LABEL(1)' EQ '').CKLTABS
         AIF   (&LABEL(1) EQ &LB).CKLTABS
&LB      SETA  &LABEL(1)
         AGO   .AAA
.CKLTABS AIF   ('&LABEL(2)' EQ '').NCLABEL
         AIF   (&LABEL(2) EQ &LT).NCLABEL
         AGO   .CCC
.AAA     AIF   ('&LABEL(2)' EQ '').BBB
         AIF   (&LABEL(2) EQ &LT).BBB
.CCC     ANOP
&LT      SETA  &LABEL(2)
.BBB     DC    XL2'FFFF'
         DC    FL1'&LB'
         DC    FL1'&LT'
&NRENTS  SETA  &NRENTS+1
.NCLABEL ANOP
         AIF   ('&SKIP' NE '').CONT
         AIF   (&TEST EQ 0).NOCHANG
&S       SETA  &LASTCC
         AGO   .DEFAULT
.CONT    ANOP
         AIF   (&TEST EQ 0).AB
&S       SETA  &SKIP
.DEFAULT ANOP
         ORG   &CARRCON+3
         DC    AL.3(0),AL.2(&S),AL.3(1)
         ORG
&LASTCC  SETA  &S
&TEST    SETB  0
         AGO   .DD
.AB      AIF   (&SKIP EQ &LASTCC).NOCHANG
A&SYSNDX DC    XL2'FFFB'
         DC    AL.3(0),AL.2(&SKIP),AL.3(1)
         DC    FL1'9'
&LASTCC  SETA  &SKIP
&TEST    SETB  1
&CARRCON SETC  'A&SYSNDX'
&NRENTS  SETA  &NRENTS+1
.DD      ANOP
.NOCHANG ANOP
         MEND
*
*
***********************************************************************
*
*
         MACRO
         BIN   &LOGITEM,&SKIP$OR
.*                                 &LOGITEM - NAME OF ITEM IN LOG DSECT
.*
.*                                 &SKIP$OR - NUMBER OF SPACES TO SKIP
.*                                 ON MULTIPLE PRINT OR NUMBER OF
.*                                 SPACES TO BACK UP FROM COLUMN FOR
.*                                 START OF PRINTING. THE LETTER B
.*                                 PRECEEDS THE NUMBER (B5) IF THE
.*                                 LATTER IS DESIRED. OMISSION OF THIS
.*                                 OPERAND FORCES OPTION 2 WITH BACKUP
.*                                 SPACING EQUAL TO THE NUMBER OF BITS
.*                                 IN THE ITEM DEFINITION (VIA MACRO
.*                                 'DSGEN'). A LIMIT OF 15 BITS IS
.*                                 IMPOSED FOR THE TOTAL NUMBER OF BITS
.*                                 TO PRINT.
         GBLC  &ITEM(2000)
         GBLA  &ITEMNBR,&BITS(2000),&SHIFT(2000),&NRENTS
         GBLC  &DSECT
         LCLB  &B
         LCLA  &IBITS,&NDX,&ISHIFT,&K
         LCLA  &TEMP,&T
         LCLC  &S
.LOOP    ANOP
&NDX     SETA  &NDX+1
         AIF   ('&ITEM(&NDX)' EQ '&LOGITEM').FOUND
         AIF   (&NDX LT &ITEMNBR).LOOP
         MNOTE '**LOG ITEM NOT FOUND**'
         ROUTINE  DUM,SKIPPER
         MEXIT
.FOUND   ANOP
&ISHIFT  SETA  &SHIFT(&NDX)
&IBITS   SETA  &BITS(&NDX)
&T       SETA  &IBITS-1
&B       SETB  0
         AIF   ('&SKIP$OR' EQ '').BACKUP
&K       SETA  K'&SKIP$OR
&B       SETB  ('&SKIP$OR'(1,1) EQ 'B')
&S       SETC  '&SKIP$OR'(&B+1,&K-&B)
&T       SETA  &S
.BACKUP  ANOP
&NRENTS  SETA  &NRENTS+1
&TEMP    SETA  &ISHIFT
A&SYSNDX DC    AL.12(&LOGITEM-&DSECT),XL.4'&TEMP'
         AIF   (&IBITS EQ 1 AND &B EQ 0).OUT
         ORG   A&SYSNDX
&B       SETB  1
         DC    AL.12(&LOGITEM-&DSECT),XL.4'C'
         DC    BL.1'&B',AL.7(&T),AL.4(&IBITS),FL.4'&ISHIFT'
.OUT     ANOP
         MEND
*
*
***********************************************************************
*
*
         MACRO
         HEX   &LOGITEM,&SKIP$OR,&BYTES
.*
.*                                 THIS MACRO FACILITATES GENERATION
.*                                 OF THE TABLE ENTRIES SPECIFYING HEX
.*                                 TYPE CONVERSIONS.
.*
.*                                 &LOGITEM - NAME OF DATA ITEM TO BE
.*                                 CONVERTED.
.*
.*                                 &SKIP$OR - NUMBER OF SPACES TO SKIP
.*                                 ON MULTIPLE PRINT OF NUMBER OF
.*                                 SPACES TO BACK UP FROM COLUMN FOR
.*                                 START OF PRINTING. THE LETTER B
.*                                 PRECEEDS THE NUMBER (B8) IF THE
.*                                 LATTER OPTION IS DESIRED. OMISSION
.*                                 OF THIS OPERAND FORCES OPTION 2 WITH
.*                                 BACKUP SPACING EQUAL TO THE NUMBER
.*                                 OF BYTES SPECIFIED BY THE NEXT
.*                                 OPERAND (TWICE THIS NUMBER IF SUFFIX
.*                                 IS EXPLICITLY OR IMPLICITLY B).
.*
.*                                 &BYTES - NUMBER OF TOTAL INPUT BYTES
.*                                 TO PROCESS. THIS NUMBER IS SUFFIXED
.*                                 WITH A L,R, OR B TO STIPULATE
.*                                 PRINTING OF THE LEFT HALF, RIGHT
.*                                 HALF, OR BOTH HALVES OF THE BYTE
.*                                 RESPECTIVELY. OMISSION OF THIS
.*                                 OPERAND DEFAULTS TO B WITH THE
.*                                 NUMBER OF BYTES EQUAL TO THE ITEM
.*                                 LENGTH.
.*
.*                                 A NEW ENTRY IS GENERATED ONLY WHEN
.*                                 NECESSARY. THIS MACRO MUST BE THE
.*                                 FIRST MACRO INSTRUCTION ISSUED FOR
.*                                 THE SUBJECT LINE(S)
         GBLC  &ITEM(2000),&DSECT
         GBLA  &ITEMNBR,&BITS(2000),&SHIFT(2000),&NRENTS
         LCLB  &B
         LCLA  &IBITS,&NDX,&ISHIFT,&K,&T,&CODE,&BYTESP
         LCLC  &S,&LETTER
.LOOP    ANOP
&NDX     SETA  &NDX+1
         AIF   ('&ITEM(&NDX)' EQ '&LOGITEM').FOUND
         AIF   (&NDX LT &ITEMNBR).LOOP
         MNOTE '**LOG ITEM NOT FOUND**'
         MEXIT
.FOUND   ANOP
&ISHIFT  SETA  &SHIFT(&NDX)
&IBITS   SETA  &BITS(&NDX)
&CODE    SETA  1
&K       SETA  K'&BYTES
         AIF   (&IBITS-(&IBITS/4)*4 EQ 0).OK
         MNOTE 'BIT LENGTH SPECIFICATION INCONSISTENT WITH CONTROL'
         MEXIT
.OK      AIF   ('&BYTES' EQ '').USEDEFN
&LETTER  SETC  '&BYTES'(&K,1)
&S       SETC  '&BYTES'(1,&K-1)
&BYTESP  SETA  &S
         AIF   ('&LETTER' EQ 'B').BOTH
         AIF   ('&LETTER' EQ 'L').LEFT
&CODE    SETA  2
         AGO   .L
.LEFT    ANOP
&CODE    SETA  1
         AGO   .L
         AIF   (&ISHIFT EQ 0 OR &ISHIFT EQ 4).OK2
.ERR     MNOTE 'DATA NOT ALIGNED ON HEX OR BYTE BOUNDARY'
         MEXIT
.USEDEFN ANOP
&BYTESP  SETA  &IBITS/8
.BOTH    AIF   (&ISHIFT NE 0).ERR
&CODE    SETA  3
&T       SETA  &BYTESP*2-1
&S       SETC  '&T'
.OK2     AIF   (&ISHIFT EQ 0).L
&CODE    SETA  2
.L       ANOP
&B       SETB  1
         AIF   ('&SKIP$OR' EQ '').BACKUP
&K       SETA  K'&SKIP$OR
&B       SETB  ('&SKIP$OR'(1,1) EQ 'B')
&S       SETC  '&SKIP$OR'(&B+1,&K-&B)
.BACKUP  ANOP
&NRENTS  SETA  &NRENTS+1
         DC    AL.12(&LOGITEM-&DSECT),XL.4'A'
         DC    BL.1'&B',FL.7'&S',AL.4(&BYTESP),FL.4'&CODE'
.OUT     ANOP
         MEND
*
*
***********************************************************************
*
*
         MACRO
&NAME    ROUTINE  &LOGITEM,&RNAME
         GBLC  &ITEM(2000)
         GBLA  &SHIFT(2000),&ITEMNBR
         GBLC  &DSECT,&CSECT
         GBLA  &NRENTS
         LCLA  &ISHIFT,&NDX
.LOOP    ANOP
&NDX     SETA  &NDX+1
         AIF   ('&ITEM(&NDX)' EQ '&LOGITEM').FOUND
         AIF   (&NDX LT &ITEMNBR).LOOP
         MNOTE 'LOG ITEM NOT DEFINED'
         MEXIT
.FOUND   ANOP
&ISHIFT  SETA  &SHIFT(&NDX)
&NAME    DC    AL.12(&LOGITEM-&DSECT),XL.4'D'
         DC    AL.4(&ISHIFT),AL.12(&RNAME-&CSECT)
&NRENTS  SETA  &NRENTS+1
         MEND
*
*
***********************************************************************
*
*
         MACRO
&NAME    LABEL &LABEL1,&LABEL2,&LABEL3,&LABEL4,&LABEL5,&LABEL6,        C
               &LABEL7,&LABEL8
.*                            THIS MACRO ALLOWS UP TO ACHT LABELS TO
.*                                 BE SPECIFIED FOR A GIVEN LINE. THE
.*                                 LABELS SHOULD BE ENCLOSED IN QUOTA-
.*                                 TION MARKS. THE COLUMN AND LINE END
.*                                 CONTROLS WILL BE INSERTED BY THE
.*                                 MACRO. OMITTED OPERANDS MEAN NO
.*                                 LABEL REQUIRED FOR RESPECTIVE
.*                                 COLUMN. THIS MACRO WILL ALSO ALERT
.*                                 THE PROGRAMMER TO EXACTLY WHERE THE
.*                                 TABLE MUST BE BROKEN IF NECESSARY
.*                                 TO AVOID EXCEEDING THE MAXIMUM LIMIT
         GBLC &LABELS(2000)
         GBLC  &LBL(100)
         GBLA  &LBLCTR(100)
         GBLA  &LABELNR
         GBLA  &NRENTS,&LPTR
         LCLC  &MARGIN,&TACK
         LCLC  &TEXT
         LCLA  &OP,&K,&START,&NRCHAR,&REMAIN
&MARGIN  SETC  '*'
         AIF   ('&NAME' EQ '').LOOPOUT
&LPTR    SETA  &LPTR+1
&LBL(&LPTR) SETC '&NAME'
&LBLCTR(&LPTR) SETA &LABELNR+1
.LOOPOUT ANOP
&OP      SETA  &OP+1
&K       SETA  K'&SYSLIST(&OP)
         AIF (&K GE 2).NORM
&K       SETA  2
.NORM    ANOP
&START   SETA  2
         AIF (&OP LT N'&SYSLIST).NOTLAST
&MARGIN  SETC  '$'
.NOTLAST ANOP
&NRCHAR  SETA  8
&TACK    SETC  ''
.LOOPIN  ANOP
&REMAIN  SETA  &K-&START
         AIF (&REMAIN GE 8).MORE
&TACK    SETC  '&MARGIN'
&NRCHAR  SETA  &REMAIN
.MORE    ANOP
&TEXT    SETC  ''
         AIF (&REMAIN EQ 0).ENDTEXT
&TEXT    SETC  '&SYSLIST(&OP)'(&START,&NRCHAR)
.ENDTEXT ANOP
&LABELNR SETA  &LABELNR+1
&LABELS(&LABELNR) SETC '&TEXT'.'&TACK'
&START   SETA  &START+8
         AIF ('&TACK' EQ '').LOOPIN
         AIF ('&TACK' EQ '*').LOOPOUT
         MEND
         SPACE 2
         MACRO
         LSTART
.*                            THIS MACRO IS ISSUED WHEN THE LABEL AREA
.*                                 OF THE TABLE IS TO BEGIN.
         GBLC &LABELS(2000)
         GBLA  &LABELNR
         GBLC  &LBL(100)
         GBLA  &LBLCTR(100)
         LCLA  &NDX,&CTR
         LINEND
&CTR     SETA  1
.LOOP    ANOP
&NDX     SETA  &NDX+1
         AIF   (&LBLCTR(&CTR) NE &NDX).NOLBL
&LBL(&CTR) DC  C'&LABELS(&NDX)'
&CTR     SETA  &CTR+1
         AGO   .LOOPCTL
.NOLBL   ANOP
         DC    C'&LABELS(&NDX)'
.LOOPCTL AIF   (&NDX LT &LABELNR).LOOP
         MEND
*
*
***********************************************************************
*
*
         MACRO
         LINEND
.*                                 THIS MACRO IS USED ONLY BY THE LINE
.*                                 MACRO TO SET THE NUMBER OF ENTRIES
.*                                 ASSOCIATED WITH EACH LINE.
         GBLA  &NRENTS
         GBLC  &NRENTSX
         ORG   &NRENTSX
         DC    FL1'&NRENTS'
         ORG
&NRENTS  SETA  0
B&SYSNDX EQU   *
&NRENTSX SETC  'B&SYSNDX'
         MEND
*
*
***********************************************************************
*
*
         MACRO
&NAME    BIND  &Z1,&Z2,&Z3,&Z4
.*                                 THIS MACRO HELPS COLLOCATE BITS IN
.*                                 DIFFERENT AREAS OF THE LOG TO MAKE
.*                                 THEM ACCESSIBLE TO THE 'HEX' MACRO.
.*                                 EACH OPERAND HAS 3 SUBFIELDS:1 SPE-
.*                                 CIFIES BY LOGITEM NAME THE BYTE TO
.*                                 BE REFERENCED,2 GIVES THE NUMBER OF
.*                                 UNDESIRED BITS TO THE LEFT OF THE
.*                                 LOG ITEM'S FIRST BIT,3 GIVES THE LOG
.*                                ITEM'S LENGTH IN BITS. THE MACRO
.*                                CAUSES THE INFORMATION TO BE STORED &
.*                                CONTROL IS GIVEN TO THE 'BINDER' ROU-
.*                                TINE,WHICH STORES THE COLLOCATED
.*                                BITS RIGHT-JUSTIFIED IN THE FOUR-
.*                                BYTE WORK AREA INSERTED IN THE LOG,
.*                                BEGINNING AT 'LOGWORK1'
         GBLC      &DSECT
         LCLA  &OP
&NAME    BC    15,BINDER
.LOOP    ANOP
&OP      SETA  &OP+1
         DC    AL.16(&SYSLIST(&OP,1)-&DSECT)
         DC    FL1'&SYSLIST(&OP,2)'
         DC    FL1'&SYSLIST(&OP,3)'
         AIF   (&OP LT N'&SYSLIST).LOOP
         ORG   &NAME+4
         DC    AL.4(&OP),AL.12(&SYSLIST(1,1)-&DSECT)
         ORG
         MEND
         MACRO
&NAME    CKPARITY  &PAR1,&PAR2,&PAR3,&PAR4,&PAR5,&PAR6
.*                                THIS MACRO HELPS SET THE LOCATION
.*                                CONTROLS FOR A SPECIAL ROUTINE TO
.*                                CHECK PARITY ON ITEMS FROM THE LOG
.*                                ALREADY ASSEMBLED FOR PRINTING IN THE
.*                                PRINT BUFFER THAT HAS BEEN SET UP.
.*                                EACH OPERAND (UP TO SIX) HAS THREE
.*                                SUBFIELDS:1 GIVES THE DISPLACEMENT
.*                                FROM PRINT POSITION ZERO TO BEGIN
.*                                THE PARITY CHECK(I.E.,LOC. OF PARITY
.*                                BIT IN BUFFER);2 GIVES THE NUMBER OF
.*                                POSITIONS TO CHECK AGAINST THE PARITY
.*                                BIT (ASSUMING 1 SPACE BETWEEN PAR BIT
.*                                AND THE FIRST POSITION TO BE CHECKED)
.*                                3 GIVES THE NUMBER OF SEQUENTIAL PAR.
.*                                CHECKS OF THIS SORT TO MAKE,ASSUMING
.*                                TWO SPACES BETWEEN THE LAST POSITION
.*                                CHECKED AND NEXT PAR. BIT POSITION
         LCLA  &OP
&NAME    BC    15,PARPUT
         DC    X'0'
.LOOP    ANOP
&OP      SETA  &OP+1
         DC    FL1'&SYSLIST(&OP,1)'
         DC    FL1'&SYSLIST(&OP,2)'
         DC    FL1'&SYSLIST(&OP,3)'
         AIF   (&OP LT N'&SYSLIST).LOOP
         ORG   &NAME+4
         DC    FL1'&OP'
         ORG
         MEND
         GBLC  &DSECT,&CSECT
IFCEC155 CSECT
&CSECT   SETC  'IFCEC155'
&DSECT   SETC  'DSECT155'
DSECT155 DSECT
         DS    0F
         DSGEN (XKEY,16),(XSWS0,8),(XSWS8,1),(XSWS9,1),                *
               (XSWS10,1),(XSWS11,1),                                  *
               (XSWS12,1),(XSWS13,1),(XSWS14,1),(XSWS15,1)
         DSGEN (LOGWORK1,8),(LOGWORK2,6),(LOGWORK3,2),(LOGWRK3A,4),    *
               (LOGWRK3B,3),(LOGWRK3C,1),(LOGWORK4,8)
         DSGEN (XDATE,32)
         DSGEN (XTIME,32)
         DSGEN (XDUM2,8),(XSER,24)
         DSGEN (XCPUMOD,16),(XDUM3,16)
         DSGEN (XPGMID,64)
         DSGEN (XJOBID,64)
         DSGEN (XMCKPSW,64)
         DSGEN (SYSDAM,1),(PROCD,1),(SYSREC,1),(TIMDAM,1),(CLOCKD,1),  X
               (EXTDAM,1),(MDUM0,1),(AUTOCON,1),(WARNG,1),             X
               (DUM,5),(BACKUP1,1),(DELAY,1),(UNSTOR,1),               *
               (CORRST,1),(KEYERR,1),(DUMMY001,1),(EMWP,1),            *
               (SYSMSK,1),(PGMSK,1),(IAVLD,1),(FASTVLD,1),             X
               (RCVLD,1),(MDUM3,1),(FLPVLD,1),(GPRVLD,1),              X
               (CTLVLD,1),(LOGVLD,1),(STVLD,1)
         DSGEN (RESERVDA,16),(EXTDLOG,16)
         DSGEN (RESRVDB,64)
         DSGEN (MDUM4,8),(FAILSTA,24)
         DSGEN (RGNCODE,32)
         DSGEN (DUMMY1,32)
         DSGEN (MCAR,32)
         DSGEN (MCDR1,32)
         DSGEN (MCDR2,32)
         DSGEN (MANTLTH1,32)
         DSGEN (MANTLTH2,32)
         DSGEN (MCRR1,32)
         DSGEN (MCRR2,32)
         DSGEN (ICM90,32)
         DSGEN (STATUS,32)
         DSGEN (FDUM1,32)
         DSGEN (FDUM2,32)
         DSGEN (FDUM3,32)
         DSGEN (FDUM4,32)
         DSGEN (FDUM5,32)
         DSGEN (FDUM6,32)
         DSGEN (FDUM7,32)
         DSGEN (FDUM8,32)
         DSGEN (FDUM9,32)
         DSGEN (FDUM10,32)
         DSGEN (FDUM11,32)
         DSGEN (FDUM12,32)
         DSGEN (FDUM13,32)
         DSGEN (FDUM14,32)
FLOATPTS DSGEN (FP0,32)
         DSGEN (FP1,32)
         DSGEN (FP2,32)
         DSGEN (FP3,32)
         DSGEN (FP4,32)
         DSGEN (FP5,32)
         DSGEN (FP6,32)
         DSGEN (FP7,32)
GENPURPR DSGEN (GPR0,32)
         DSGEN (GPR1,32)
         DSGEN (GPR2,32)
         DSGEN (GPR3,32)
         DSGEN (GPR4,32)
         DSGEN (GPR5,32)
         DSGEN (GPR6,32)
         DSGEN (GPR7,32)
         DSGEN (GPR8,32)
         DSGEN (GPR9,32)
         DSGEN (GP10,32)
         DSGEN (GP11,32)
         DSGEN (GP12,32)
         DSGEN (GP13,32)
         DSGEN (GP14,32)
         DSGEN (GP15,32)
         DSGEN (CTR0,32)
         DSGEN (CTR1,32)
         DSGEN (CTR2,32)
         DSGEN (CTR3,32)
         DSGEN (CTR4,32)
         DSGEN (CTR5,32)
         DSGEN (CTR6,32)
         DSGEN (CTR7,32)
         DSGEN (CTR8,32)
         DSGEN (CTR9,32)
         DSGEN (CR10,32)
         DSGEN (CR11,32)
         DSGEN (CR12,32)
         DSGEN (CR13,32)
         DSGEN (CR14,32)
         DSGEN (CR15,32)
         DSGEN (XBUS0,8),(XBUS1,8),(XBUS2,8),(XBUS3,8)
         DSGEN (YBUS0,8),(YBUS1,8),(YBUS2,8),(YBUS3,8)
         DSGEN (ZBUS0,8),(ZBUS1,8),(ZBUS2,8),(ZBUS3,8)
         DSGEN (UBUS,8),(VBUS,8),(WBUS,8),(FILREG,8)
         DSGEN (STLNK,1),(RABUSRP,1),(RABUSBI,1),(RABUS1P,1),          *
               (RABUS1,4),(RABUS3,8),(BFRBUSY,1),(RBAR1RP,1),          *
               (RBAR1BI,1),(RBAR11P,1),(RBAR11,4),(RBAR13,8)
         DSGEN (LSSSTS,2),(CPURLAR,6),(WRCPULS,1),(DUMMY000,1),        *
               (CPUWLAR,6),(DUMMY002,1),(DUMMY003,1),(IORLAR,6),       *
               (WRIOLS,1),(DUMMY004,1),(IOWLAR,6)
         DSGEN (EXTSW0,8),(EXTSW1,8),(EXTSW2,8),(EXTSW3,8)
         DSGEN (SPARE030,8),(SPARE031,8),(SPARE032,8),(SPARE033,8)
         DSGEN (AREG0,8),(AREG1,8),(AREG2,8),(AREG3,8)
         DSGEN (BREG0,8),(BREG1,8),(BREG2,8),(BREG3,8)
         DSGEN (CREG0,8),(CREG1,8),(CREG2,8),(CREG3,8)
         DSGEN (DREG0,8),(DREG1,8),(DREG2,8),(DREG3,8)
         DSGEN (IOLSD0,8),(IOLSD1,8),(IOLSD2,8),(IOLSD3,8)
         DSGEN (CPULS0,8),(CPULS1,8),(CPULS2,8),(CPULS3,8)
         DSGEN (IOSAR0,8),(IOSAR1,8),(IOSAR2,8),(IOSAR3,8)
         DSGEN (CPUSR0,8),(CPUSR1,8),(CPUSR2,8),(CPUSR3,8)
         DSGEN (SPARE034,8),(IAR1,8),(IAR2,8),(IAR3,8)
         DSGEN (PSWSM,8),(PSWKEY,8),(PSWESM,8),(SPARE035,8)
         DSGEN (RBAR2IO,1),(RBAR2RP,1),(RBAR2BI,1),(RBAR21P,1),        *
               (RBAR21,4),(RBAR23,8),(RBAR3IO,1),(RBAR3RP,1),          *
               (RBAR3BI,1),(RBAR31P,1),(RBAR31,4),(RBAR33,8)
         DSGEN (BS0,4),(BS4P,1),(BS4,3),(ABCTRP,1),                    *
               (ABCTR,3),(CBCTRP,1),(CBCTR,3),(IFTHRS,1),              *
               (IFRES,1),(IFINV,1),(IFPRTC,1),(IFIC,1),                *
               (IFEXS,1),(IFILC,2),(ALUFNR,4),                         *
               (QBIT,1),(CCST,1),(CSA,1),(CSB,1)
         DSGEN (L12CTR,8),(L2SS,1),(CC,2),                             *
               (FNBR,2),(ALWTRP,1),(DUMMY006,1),(NSSMD,1),             *
               (R12CTR,8),(INABRR,3),(INBBRR,4),(HYRST,1)
         DSGEN (SRADAD1,7),(HRDCHK,1),(SERADM,1),(INTDL,1),            *
               (WAITFR,1),(ENGHEAD,1),(INPERR,1),(CLKERR,1),           *
               (ABCOMPS,1),(LOGCMPS,1),(DIAGCTR,8),(SPARE036,8)
         DSGEN (DUMMY007,1),(DUMMY008,1),(INDDISP,1),(CPURA1P,1),      *
               (CPURA1,4),(CPURA3,8),(GPSTL1,4),(GPSTL2P,1),           *
               (GPSTL2,3),(S19,1),(EXTST,1),(ANYEXC,1),                *
               (ICPLUS4,1),(IC1B29,1),(IB0FULL,3)
         DSGEN (SPARE037,8),(SPARE038,8),(SPARE039,8),(SPARE040,8)
         DSGEN (XBUSE,4),(YBUSE,4),(CARRYE,8),(HSUME,4),(ZBUSE,4),     *
               (LSREGE,4),(CISARE,4)
         DSGEN (GPSTE,2),(LCTRE,1),(RCTRE,1),                          *
               (DUMMY009,1),(DUMMY010,1),(ABE,1),(CBE,1),              *
               (PSW0E,1),(PSW1E,1),(PSW2E,1),(PSW3E,1),                *
               (WBUSE,1),(ABCTRE,1),(CBCTRE,1),(MEME,1),               *
               (EXTSWE,4),(EESW0E,1),(HOFFE,1),(ABDLYE,1),(EESW3E,1),  *
               (CLSARE,1),(CH02E,1),(CH35E,1),(MVRHSE,1),              *
               (DUMMY013,1),(MVRFNE,1),(ICE,2)
         DSGEN (ERLYRE,3),(RSYNCE,1),                                  *
               (LATER0E,1),(LATER1E,1),(LATER2E,1),(LATER3E,1),        *
               (MISDECE,1),(SSDECE,1),(CNTDECE,1),(BBRE,1),            *
               (RADRE,1),(ZDECE,1),(CRUCWLS,1),(TMKE,1),               *
               (SPARE041,8),(SPARE042,8)
         DSGEN (CP1R0,4),(CP1R1P,1),(CP1R1,3),(CP2R0P,1),              *
               (CP2NC,1),(CP2SE,1),(CP2DE,1),(CP2IE,1),                *
               (CP2R1P,1),(CP2HC,1),(CP2AC,1),(CP2R3,1),               *
               (ERRCTR,4),(IGNORE1,1),(SERDIS,1),(ENDATA,1),           *
               (SDC,1),(DUMMY015,1),(HARDST,1),(ADRCPST,1),            *
               (DUMMY016,1),(DUMMY017,1),(DUMMY018,1),(DUMMY019,1)
         DSGEN (ABI1,1),(NXA1,3),(NXB1,4),(BRC11,1),                   *
               (ABR1,5),(BBR01,2),(BBR21,2),(IOPR,2),                  *
               (IOSSB,3),(XYALU01,1),(XYALU21,2),(UX1,3),              *
               (VY1,3)
         DSGEN (LRSP,1),(LSWR,4),(LSRD,3),(MISC21,2),                  *
               (CNT1,4),(Z01,2),(Z21,1),(ZW1,4),                       *
               (XYSH1,3),(EMIT1,5),(EMIT2,3)
         DSGEN (SPARE043,8),(SPARE044,8),(SPARE045,8),(SPARE046,8)
         DSGEN (SPARE047,8),(SPARE048,8),(SPARE049,8),(SPARE050,8)
         DSGEN (C0IOSF,2),(C0SVCO,1),(C0ADRO,1),                       *
               (C0HLDO,1),(DUMMY020,1),(C0CMDO,1),(C0SUPO,1),          *
               (C0IOSC,4),(C0IOSD,4),(C0IOSA,4),(C0IOSB,4),            *
               (C0IOSE,2),(C0OPLO,1),(DUMMY021,1),                     *
               (C0DATAO,1),(DUMMY022,1),(DUMMY023,1),(DUMMY024,1)
         DSGEN (DUMMY025,1),(DUMMY026,1),(C0RAR2,1),(C0RAR0P,1),       *
               (C0RAR1,4),(C0RAR3,8),(DUMMY027,1),(DUMMY028,1),        *
               (DUMMY029,1),(DUMMY030,1),(C0SRVI,1),(C0ADRI,1),        *
               (C0SELI,1),(DUMMY031,1),(C0STAI,1),(C0REQI,1),          *
               (C0OPLI,1),(DUMMY032,1),(C0DISCI,1),(DUMMY033,1),       *
               (DUMMY034,1),(C0MRKI,1)
         DSGEN (C0DABP,1),(C0DAB,4),(C0RP,1),(C0IOI,1),                *
               (C0IFCK,1),(DUMMY035,1),(C0CV,1),(DUMMY036,1),          *
               (C0CB5,1),(C0CB6,1),(C0CB7,1),(C0REQIT,1),              *
               (C0ERRIT,1),(DUMMY037,1),(C0INT,1),(C0ONSYS,1),         *
               (DUMMY038,1),(C0LWLUP,1),(C0LWLBU,1),(DUMMY039,1),      *
               (DUMMY040,1),(SPARE051,8)
         DSGEN (SPARE052,8),(SPARE053,8),(SPARE054,8),(SPARE055,8)
         DSGEN (C1IOSF,2),(C1SVCO,1),(C1ADRO,1),                       *
               (C1HLDO,1),(DUMMY041,1),(C1CMDO,1),(C1SUPO,1),          *
               (C1IOSC,4),(C1IOSD,4),(C1IOSA,4),(C1IOSB,4),            *
               (C1IOSE,2),(C1OPLO,1),(DUMMY042,1),                     *
               (C1DATAO,1),(DUMMY043,1),(DUMMY044,1),(DUMMY045,1)
         DSGEN (DUMMY046,1),(DUMMY047,1),(C1RAR2,1),(C1RAR0P,1),       *
               (C1RAR1,4),(C1RAR3,8),(DUMMY048,1),(DUMMY049,1),        *
               (DUMMY050,1),(DUMMY051,1),(C1SRVI,1),(C1ADRI,1),        *
               (C1SELI,1),(DUMMY052,1),(C1STAI,1),(C1REQI,1),          *
               (C1OPLI,1),(DUMMY053,1),(C1DISCI,1),(DUMMY054,1),       *
               (DUMMY055,1),(C1MRKI,1)
         DSGEN (C1DABP,1),(C1DAB,4),(C1RP,1),(C1IOI,1),                *
               (C1IFCK,1),(DUMMY056,1),(C1CV,1),(DUMMY057,1),          *
               (C1CB5,1),(C1CB6,1),(C1CB7,1),(C1REQIT,1),              *
               (C1ERRIT,1),(DUMMY058,1),(C1INT,1),(C1ONSYS,1),         *
               (DUMMY059,1),(C1LWLUP,1),(C1LWLBU,1),(DUMMY060,1),      *
               (DUMMY061,1),(SPARE056,8)
         DSGEN (C1SCTR,4),(C1HCTR0,5),(C1SUPC,3),(C1LWC0,5),           *
               (C1ERB,5),(DUMMY062,1),(DUMMY063,1),(SPARE057,8)
         DSGEN (C2IOSF,2),(C2SVCO,1),(C2ADRO,1),                       *
               (C2HLDO,1),(DUMMY064,1),(C2CMDO,1),(C2SUPO,1),          *
               (C2IOSC,4),(C2IOSD,4),(C2IOSA,4),(C2IOSB,4),            *
               (C2IOSE,2),(C2OPLO,1),(DUMMY065,1),                     *
               (C2DATAO,1),(DUMMY066,1),(DUMMY067,1),(DUMMY068,1)
         DSGEN (DUMMY069,1),(DUMMY070,1),(C2RAR2,1),(C2RAR0P,1),       *
               (C2RAR1,4),(C2RAR3,8),(DUMMY071,1),(DUMMY072,1),        *
               (DUMMY073,1),(DUMMY074,1),(C2SRVI,1),(C2ADRI,1),        *
               (C2SELI,1),(DUMMY075,1),(C2STAI,1),(C2REQI,1),          *
               (C2OPLI,1),(DUMMY076,1),(C2DISCI,1),(DUMMY077,1),       *
               (DUMMY078,1),(C2MRKI,1)
         DSGEN (C2DABP,1),(C2DAB,4),(C2RP,1),(C2IOI,1),                *
               (C2IFCK,1),(DUMMY079,1),(C2CV,1),(DUMMY080,1),          *
               (C2CB5,1),(C2CB6,1),(C2CB7,1),(C2REQIT,1),              *
               (C2ERRIT,1),(DUMMY081,1),(C2INT,1),(C2ONSYS,1),         *
               (DUMMY082,1),(C2LWLUP,1),(C2LWLBU,1),(DUMMY083,1),      *
               (DUMMY084,1),(SPARE058,8)
         DSGEN (C2SCTR,4),(C2HCTR0,5),(C2SUPC,3),(C2LWC0,5),           *
               (C2ERB,5),(DUMMY085,1),(DUMMY086,1),(SPARE059,8)
         DSGEN (C3IOSF,2),(C3SVCO,1),(C3ADRO,1),                       *
               (C3HLDO,1),(DUMMY087,1),(C3CMDO,1),(C3SUPO,1),          *
               (C3IOSC,4),(C3IOSD,4),(C3IOSA,4),(C3IOSB,4),            *
               (C3IOSE,2),(C3OPLO,1),(DUMMY088,1),                     *
               (C3DATAO,1),(DUMMY089,1),(DUMMY090,1),(DUMMY091,1)
         DSGEN (DUMMY092,1),(DUMMY093,1),(C3RAR2,1),(C3RAR0P,1),       *
               (C3RAR1,4),(C3RAR3,8),(DUMMY094,1),(DUMMY095,1),        *
               (DUMMY096,1),(DUMMY097,1),(C3SRVI,1),(C3ADRI,1),        *
               (C3SELI,1),(DUMMY098,1),(C3STAI,1),(C3REQI,1),          *
               (C3OPLI,1),(DUMMY099,1),(C3DISCI,1),(DUMMY100,1),       *
               (DUMMY101,1),(C3MRKI,1)
         DSGEN (C3DABP,1),(C3DAB,4),(C3RP,1),(C3IOI,1),                *
               (C3IFCK,1),(DUMMY102,1),(C3CV,1),(DUMMY103,1),          *
               (C3CB5,1),(C3CB6,1),(C3CB7,1),(C3REQIT,1),              *
               (C3ERRIT,1),(DUMMY104,1),(C3INT,1),(C3ONSYS,1),         *
               (DUMMY105,1),(C3LWLUP,1),(C3LWLBU,1),(DUMMY106,1),      *
               (DUMMY107,1),(SPARE060,8)
         DSGEN (C3SCTR,4),(C3HCTR0,5),(C3SUPC,3),(C3LWC0,5),           *
               (C3ERB,5),(DUMMY108,1),(DUMMY109,1),(SPARE061,8)
         DSGEN (C4IOSF,2),(C4SVCO,1),(C4ADRO,1),                       *
               (C4HLDO,1),(DUMMY110,1),(C4CMDO,1),(C4SUPO,1),          *
               (C4IOSC,4),(C4IOSD,4),(C4IOSA,4),(C4IOSB,4),            *
               (C4IOSE,2),(C4OPLO,1),(DUMMY111,1),                     *
               (C4DATAO,1),(DUMMY112,1),(DUMMY113,1),(DUMMY114,1)
         DSGEN (DUMMY115,1),(DUMMY116,1),(C4RAR2,1),(C4RAR0P,1),       *
               (C4RAR1,4),(C4RAR3,8),(DUMMY117,1),(DUMMY118,1),        *
               (DUMMY119,1),(DUMMY120,1),(C4SRVI,1),(C4ADRI,1),        *
               (C4SELI,1),(DUMMY121,1),(C4STAI,1),(C4REQI,1),          *
               (C4OPLI,1),(DUMMY122,1),(C4DISCI,1),(DUMMY123,1),       *
               (DUMMY124,1),(C4MRKI,1)
         DSGEN (C4DABP,1),(C4DAB,4),(C4RP,1),(C4IOI,1),                *
               (C4IFCK,1),(DUMMY125,1),(C4CV,1),(DUMMY126,1),          *
               (C4CB5,1),(C4CB6,1),(C4CB7,1),(C4REQIT,1),              *
               (C4ERRIT,1),(DUMMY127,1),(C4INT,1),(C4ONSYS,1),         *
               (DUMMY128,1),(C4LWLUP,1),(C4LWLBU,1),(DUMMY129,1),      *
               (DUMMY130,1),(SPARE062,8)
         DSGEN (C4SCTR,4),(C4HCTR0,5),(C4SUPC,3),(C4LWC0,5),           *
               (C4ERB,5),(DUMMY131,1),(DUMMY132,1),(SPARE063,8)
         DSGEN (C5IOSF,2),(C5SVCO,1),(C5ADRO,1),                       *
               (C5HLDO,1),(DUMMY133,1),(C5CMDO,1),(C5SUPO,1),          *
               (C5IOSC,4),(C5IOSD,4),(C5IOSA,4),(C5IOSB,4),            *
               (C5IOSE,2),(C5OPLO,1),(DUMMY134,1),                     *
               (C5DATAO,1),(DUMMY135,1),(DUMMY136,1),(DUMMY137,1)
         DSGEN (DUMMY138,1),(DUMMY139,1),(C5RAR2,1),(C5RAR0P,1),       *
               (C5RAR1,4),(C5RAR3,8),(DUMMY140,1),(DUMMY141,1),        *
               (DUMMY142,1),(DUMMY143,1),(C5SRVI,1),(C5ADRI,1),        *
               (C5SELI,1),(DUMMY144,1),(C5STAI,1),(C5REQI,1),          *
               (C5OPLI,1),(DUMMY145,1),(C5DISCI,1),(DUMMY146,1),       *
               (DUMMY147,1),(C5MRKI,1)
         DSGEN (C5DABP,1),(C5DAB,4),(C5RP,1),(C5IOI,1),                *
               (C5IFCK,1),(DUMMY148,1),(C5CV,1),(DUMMY149,1),          *
               (C5CB5,1),(C5CB6,1),(C5CB7,1),(C5REQIT,1),              *
               (C5ERRIT,1),(DUMMY150,1),(C5INT,1),(C5ONSYS,1),         *
               (DUMMY151,1),(C5LWLUP,1),(C5LWLBU,1),(DUMMY152,1),      *
               (DUMMY153,1),(SPARE064,8)
         DSGEN (C5SCTR,4),(C5HCTR0,5),(C5SUPC,3),(C5LWC0,5),           *
               (C5ERB,5),(DUMMY154,1),(DUMMY155,1),(SPARE065,8)
         DSGEN (C0RCV,1),(DUMMY156,1),(DUMMY157,1),(DUMMY158,1),       *
               (DUMMY159,1),(DUMMY160,1),(DUMMY161,1),(DUMMY162,1),    *
               (DUMMY163,1),(DUMMY164,1),(DUMMY165,1),(DUMMY166,1),    *
               (DUMMY167,1),(DUMMY168,1),(C0ARMRR,1),(C0HSUPO,1),      *
               (C0BIREG,4),(C0BIREQ,1),(C0IDLE,1),(C0SELU,1),          *
               (C0IFRR,1),(C0PR3C0,1),(C0IOS0C,1),(C0IOS4C,1),         *
               (C0HLDOC,1),(C0HADRO,1),(C0HCMDO,1),(C0HHLDO,1),        *
               (C0HSELO,1)
         DSGEN (C1CC,1),(C1SLI,1),(C1UAR,1),(C1AO,1),                  *
               (C1SO,1),(C1CCSO,1),(C1HSUPO,1),(C1BP3RQ,1),            *
               (C1P1REQ,1),(C1HRI0,1),(C1HRI4,1),(C1HRSO,1),           *
               (C1HRCO,1),(DUMMY169,1),(C1DABTD,1),(C1DAB1D,1),        *
               (C1SIFRW,1),(C11RDCD,1),(C1LIOLS,1),(C1LBIB,1),         *
               (C1ERDLD,1),(C1ERBU,1),(C1MSELU,1),(C1BLSR,1),          *
               (C1LSPMD,1),(C1LSR2,1),(C1LSR4,1),(C1IFR2,1),           *
               (C1IFR4,1),(C1MHCO,1),(C1HCC,1),(C1RCV,1)
         DSGEN (C2CC,1),(C2SLI,1),(C2UAR,1),(C2AO,1),                  *
               (C2SO,1),(C2CCSO,1),(C2HSUPO,1),(C2BP3RQ,1),            *
               (C2P1REQ,1),(C2HRI0,1),(C2HRI4,1),(C2HRSO,1),           *
               (C2HRCO,1),(DUMMY170,1),(C2DABTD,1),(C2DAB1D,1),        *
               (C2SIFRW,1),(C21RDCD,1),(C2LIOLS,1),(C2LBIB,1),         *
               (C2ERDLD,1),(C2ERBU,1),(C2MSELU,1),(C2BLSR,1),          *
               (C2LSPMD,1),(C2LSR2,1),(C2LSR4,1),(C2IFR2,1),           *
               (C2IFR4,1),(C2MHCO,1),(C2HCC,1),(C2RCV,1)
         DSGEN (C3CC,1),(C3SLI,1),(C3UAR,1),(C3AO,1),                  *
               (C3SO,1),(C3CCSO,1),(C3HSUPO,1),(C3BP3RQ,1),            *
               (C3P1REQ,1),(C3HRI0,1),(C3HRI4,1),(C3HRSO,1),           *
               (C3HRCO,1),(DUMMY171,1),(C3DABTD,1),(C3DAB1D,1),        *
               (C3SIFRW,1),(C31RDCD,1),(C3LIOLS,1),(C3LBIB,1),         *
               (C3ERDLD,1),(C3ERBU,1),(C3MSELU,1),(C3BLSR,1),          *
               (C3LSPMD,1),(C3LSR2,1),(C3LSR4,1),(C3IFR2,1),           *
               (C3IFR4,1),(C3MHCO,1),(C3HCC,1),(C3RCV,1)
         DSGEN (C4CC,1),(C4SLI,1),(C4UAR,1),(C4AO,1),                  *
               (C4SO,1),(C4CCSO,1),(C4HSUPO,1),(C4BP3RQ,1),            *
               (C4P1REQ,1),(C4HRI0,1),(C4HRI4,1),(C4HRSO,1),           *
               (C4HRCO,1),(DUMMY172,1),(C4DABTD,1),(C4DAB1D,1),        *
               (C4SIFRW,1),(C41RDCD,1),(C4LIOLS,1),(C4LBIB,1),         *
               (C4ERDLD,1),(C4ERBU,1),(C4MSELU,1),(C4BLSR,1),          *
               (C4LSPMD,1),(C4LSR2,1),(C4LSR4,1),(C4IFR2,1),           *
               (C4IFR4,1),(C4MHCO,1),(C4HCC,1),(C4RCV,1)
         DSGEN (C5CC,1),(C5SLI,1),(C5UAR,1),(C5AO,1),                  *
               (C5SO,1),(C5CCSO,1),(C5HSUPO,1),(C5BP3RQ,1),            *
               (C5P1REQ,1),(C5HRI0,1),(C5HRI4,1),(C5HRSO,1),           *
               (C5HRCO,1),(DUMMY173,1),(C5DABTD,1),(C5DAB1D,1),        *
               (C5SIFRW,1),(C51RDCD,1),(C5LIOLS,1),(C5LBIB,1),         *
               (C5ERDLD,1),(C5ERBU,1),(C5MSELU,1),(C5BLSR,1),          *
               (C5LSPMD,1),(C5LSR2,1),(C5LSR4,1),(C5IFR2,1),           *
               (C5IFR4,1),(C5MHCO,1),(C5HCC,1),(C5RCV,1)
         DSGEN (CCLAR0P,1),(CCLAR0,3),(CCLAR1P,1),(CCLAR1,3),          *
               (CCWRLAR,1),(CCWR,1),(CCWRP,1),(CCWR1XX,1),             *
               (CCWRX1X,1),(CCWRXX1,1),(DUMMY174,1),(DUMMY175,1),      *
               (CCRCK1,1),(CCRCK2,1),(CCRTOBR,1),(CCRWDA,1),           *
               (CCRWDB,1),(CCRWDC,1),(CCRWDD,1),(CCRWDI,1),            *
               (CCTHLD0,1),(CCTHLD1,1),(CCTHLD2,1),(CCTHLD3,1),        *
               (CCBRSTA,1),(CCBRSTB,1),(CCUAPC,1),(CCUAC1,1)
         DSGEN (CCLWCT,1),(CCDABB2,1),(CCDABB4,1),(CCENDR,1),          *
               (CCDIFC,1),(CCHDWC2,1),(CCHDWC5,1),(CCMVPC,1),          *
               (CCIOBSP,1),(CCIOBS0,4),(CCIOBSF,1),(CCIOBSL,1),        *
               (CCMVPCL,1),(CC4WDX,1),(CCUCWS,1),(CCLWIND,1),          *
               (DUMMY176,1),(DUMMY177,1),(DUMMY178,1),(DUMMY179,1),    *
               (DUMMY180,1),(DUMMY181,1),(DUMMY182,1),(DUMMY183,1),    *
               (DUMMY184,1),(CCBFRLS,1),(CCBFRB,1),(CCRDLS,1),         *
               (CCIBFIB,1)
         DSGEN (CHSELA0,1),(CHSELA1,1),(CHSELA2,1),(CHIOM,1),          *
               (CHROAR,1),(CHNUM0,1),(CHNUM1,1),(CHNUM2,1),            *
               (CHREQC1,1),(CHREQCB,1),(CIOMLTH,1),(IOMB,1),           *
               (C1PR2,1),(C1PR3,1),(C2PR2,1),(C2PR3,1),                *
               (C3PR2,1),(C3PR3,1),(C4PR2,1),(C4PR3,1),                *
               (C5PR2,1),(C5PR3,1),(MPXOS2,1),(DUMMY185,1),            *
               (DUMMY186,1),(DUMMY187,1),(DUMMY188,1),(DUMMY189,1),    *
               (DUMMY190,1),(ANYIR,1),(CHDIAGM,1),(CHFC,1)
         DSGEN (SPARE066,8),(SPARE067,8),(SPARE068,8),(SPARE069,8)
         DSGEN (C1HCE,1),(C1BCIE,1),(C1BME,1),(C1IRE,1),               *
               (C1LRE,1),(C1SBE,1),(C1SBOE,1),(C1ISE,1),               *
               (C1SPE,1),(C1SWE,1),(C2HCE,1),(C2BCIE,1),               *
               (C2BME,1),(C2IRE,1),(C2LRE,1),(C2SBE,1),                *
               (C2SBOE,1),(C2ISE,1),(C2SPE,1),(C2SWE,1),               *
               (C3HCE,1),(C3BCIE,1),(C3BME,1),(C3IRE,1),               *
               (C3LRE,1),(C3SBE,1),(C3SBOE,1),(C3ISE,1),               *
               (C3SPE,1),(C3SWE,1),(CCCH1E,1),(CCCH2E,1)
         DSGEN (C4HCE,1),(C4BCIE,1),(C4BME,1),(C4IRE,1),               *
               (C4LRE,1),(C4SBE,1),(C4SBOE,1),(C4ISE,1),               *
               (C4SPE,1),(C4SWE,1),(C5HCE,1),(C5BCIE,1),               *
               (C5BME,1),(C5IRE,1),(C5LRE,1),(C5SBE,1),                *
               (C5SBOE,1),(C5ISE,1),(C5SPE,1),(C5SWE,1),               *
               (CCCH3E,1),(CCCH4E,1),(CCCH5E,1),(C3CLE,1),             *
               (C3ITE,1),(C4CLE,1),(C4ITE,1),(C5CLE,1),                *
               (C5ITE,1),(C35SCE,1),(C35ITAE,1),(C35ITBE,1)
         DSGEN (BIRPE,1),(BIRE,1),(C0BCE,1),(C0BOCE,1),                *
               (C0S07E,1),(C0RE,1),(C0UCE,1),(C0CCE,1),                *
               (C0RCE,1),(C0ITE,1),(C0CLE,1),(C1ITE,1),                *
               (C1CLE,1),(C2ITE,1),(C2CLE,1),(UPDE,1),                 *
               (EMITFLE,1),(EMITINE,1),(PSWCKE,1),(L2CNTRE,1),         *
               (CSELCPE,1),(DUMMY191,1),(DUMMY192,1),(DUMMY193,1),     *
               (DUMMY194,1),(DUMMY195,1),(C02ITAE,1),(C02ITBE,1),      *
               (C02STCE,1),(SBPE,1),(OUTTAGE,1),(GRPSELE,1)
         DSGEN (DUMMY196,1),(DUMMY197,1),(ROSINTE,1),(ROSINPE,1),      *
               (LSTOCHE,1),(HDWCHE,1),(HCIE,1),(HRRE,1),               *
               (HLCE,1),(UPLSARE,1),(WRLSUPE,1),(IN1SELE,1),           *
               (IN2ROSE,1),(IN3SELE,1),(LS01INE,1),(LS23INE,1),        *
               (INTCRDE,1),(LOGYINE,1),(LOGRDRE,1),(DUMMY198,1),       *
               (STBBE,1),(STDCDE,1),(YICDCDE,1),(BUSPTYE,1),           *
               (RLCTRE,1),(DUMMY199,1),(DUMMY200,1),(DUMMY201,1),      *
               (LSUCWAE,1),(BIRESPE,1),(SELCNE,1),(MURE,1)
         DSGEN (HCIDE,1),(UPCIDE,1),(C0BOPE,1),(C0BIE,1),              *
               (C1BOPE,1),(C1BIE,1),(C2BOPE,1),(C2BIE,1),              *
               (C3BOPE,1),(C3BIE,1),(C4BOPE,1),(C4BIE,1),              *
               (C5BOPE,1),(C5BIE,1),(HCLE,1),(LSRLOGE,1),              *
               (C0WRLSE,1),(C1WRLSE,1),(C2WRLSE,1),(C3WRLSE,1),        *
               (C4WRLSE,1),(C5WRLSE,1),(C01CXE,1),(C23CXE,1),          *
               (C45CXE,1),(MPCIDE,1),(DUMMY202,1),(DUMMY203,1),        *
               (DUMMY204,1),(DUMMY205,1),(DUMMY206,1),(DUMMY207,1)
         DSGEN (SPARE070,8),(SPARE071,8),(SPARE072,8),(SPARE073,8)
         DSGEN (AIRINE1,4),(AIROE0,4),(ADOE,8),                        *
               (BSMB1E,2),(DUMMY208,1),(TMRLOE,1),                     *
               (TMRHIE,1),(ECCLOE,1),(ECCHIE,1),(UCORHLD,1),           *
               (ECCBB,8)
         DSGEN (CONSDR,8),(CONSECE,1),(CONSTOE,1),(CONSR0E,1),         *
               (CONSR3E,1),(CONSCRL,1),(CONSWR,1),(DUMMY209,1),        *
               (CONSEXC,1),(SPARE074,8),(SPARE075,8)
         DSGEN (SPARE076,8),(SPARE077,8),(SPARE078,8),(SPARE079,8)
         DSGEN (SPARE080,8),(SPARE081,8),(SPARE082,8),(SPARE083,8)
         DSGEN (FALE0,8),(FALE1,8),(FALE2,8),(FALE3,8)
         DSGEN (FALO0,8),(FALO1,8),(FALO2,8),(FALO3,8)
         DSGEN (FAHE0,8),(FAHE1,8),(FAHE2,8),(FAHE3,8)
         DSGEN (FAHO0,8),(FAHO1,8),(FAHO2,8),(FAHO3,8)
         DSGEN (SPARE084,8),(BCUS1,8),(BCUS2,8),(BCUS3,8)
         DSGEN (SPARE085,8),(ASARB1,8),(ASARB2,8),(ASARB3,8)
         DSGEN (EMITE,1),(TIMEOE,1),(SPKEYOE,1),(KEYBUSE,1),           *
               (SAR1E,3),(C40B0E,1),                                   *
               (C40B2E,6),(IDXLE,1),(IDXUE,1),                         *
               (RDCOMPE,1),(BYTEMKE,1),(SDR08E,1),(SDR19E,1),          *
               (SDR210E,1),(SDR311E,1),(SDR412E,1),(SDR513E,1),        *
               (SDR715E,1),(DUMMY210,1),(DUMMY211,1),(DUMMY212,1),     *
               (DUMMY213,1),(DUMMY214,1),(DUMMY215,1),(DUMMY216,1)
         DSGEN (LINDXA,5),(LINDXB,3),(LINDXV1,1),(LINDXV2,1),          *
               (LINDXOK,1),(LOWERBC,1),(LOWERVC,1),(LOWOKO,1),         *
               (LOWERA,1),(MSSELBR,1),(UINDXA,5),(UINDXB,3),           *
               (UINDXV1,1),(UINDXV2,1),(UINDXOK,1),(UPPERBC,1),        *
               (UPPERVC,1),(UPROKO,1),(UPPERA,1),(BACKSBY,1)
         DSGEN (BCUB0,4),(BCUB4P,1),(BCUB4,3),(BCUB8P,1),              *
               (BCUB8,4),(BCUB12P,1),(BCUB12,2),(BCUB15,1),            *
               (ADP2SEL,1),(ADP2ECC,1),(ADP2MCK,1),(DUMMY217,1),       *
               (DUMMY218,1),(DUMMY219,1),(IVA,1),(SPDATA,7),           *
               (SPVIOL,1)
         DSGEN (BCURD,1),(BCUWR,1),(BCUFIB,1),(BCUSPMS,1),             *
               (BCUIECC,1),(BCUDC40,1),(BCUIOMD,1),(ECCMD1,1),         *
               (EDRDECC,1),(DUMMY220,1),(EDTS,1),(DUMMY221,1),         *
               (DUMMY222,1),(EDWTOD,1),(EDWSPK,1),(DUMMY223,1),        *
               (EDVALA,1),(IBRFCH,1),(DUMMY224,1),(DUMMY225,1),        *
               (EDRSPK,1),(EDDEGA,1),(HISTAT,1),(ODDSTAT,1),           *
               (MSIREAD,1),(MSIWR,1),(DUMMY226,1),(MSITS,1),           *
               (DUMMY227,1),(MSIIOOP,1),(MSIRECC,1),(MSIUCWS,1)
         DSGEN (AIROFET,1),(AIROSTO,1),(AIROHRT,1),(AIROTS,1),         *
               (DUMMY228,1),(AIROVRD,1),(AIROECD,1),(AIROBS,1),        *
               (SPARE086,8),(MSCAIDL,1),(DUMMY229,1),(DUMMY230,1),     *
               (MSCCIP,1),(MSCWC,1),(MSCDR2C,1),(MSCAD25,1),           *
               (MSCBD25,1),(SPARE087,8)
         DSGEN (CONSR0,8),(CONSR1,8),(CONSR2,8),(CONSR3,8)
         DSGEN (SPARE124,64)
         DSGEN (SPARE125,64)
         DSGEN (SPARE126,64)
         DSGEN (SPARE127,64)
         DSGEN (SPARE128,64)
         DSGEN (SPARE129,64)
         DSGEN (SPARE130,64)
         DSGEN (SPARE131,64)
         DSGEN (SPARE132,64)
         DSGEN (SPARE133,64)
         DSGEN (SPARE134,64)
         DSGEN (SPARE135,64)
         DSGEN (SPARE136,64)
         DSGEN (SPARE137,64)
         DSGEN (SPARE138,64)
         DSGEN (SPARE139,64)
         DSGEN (SPARE140,64)
         DSGEN (SEQCHAN,8),(UNITADR,8),(RETSEQ,8),(SPARE141,40)
         DSGEN (SPARE142,64)
         DSGEN (SPARE143,64)
         DSGEN (XBUS0P,1),(DUMMY231,1),(XBUS1P,1),(DUMMY232,1),        *
               (XBUS2P,1),(DUMMY233,1),(XBUS3P,1),(DUMMY234,1),        *
               (YBUS0P,1),(DUMMY235,1),(YBUS1P,1),(DUMMY236,1),        *
               (YBUS2P,1),(DUMMY237,1),(YBUS3P,1),(DUMMY238,1),        *
               (ZBUS0P,1),(DUMMY239,1),(ZBUS1P,1),(DUMMY240,1),        *
               (ZBUS2P,1),(DUMMY241,1),(ZBUS3P,1),(DUMMY242,1),        *
               (UBUSP,1),(DUMMY243,1),(VBUSP,1),(DUMMY244,1),          *
               (WBUSP,1),(DUMMY245,1),(FILREGP,1),(DUMMY246,1)
         DSGEN (DUMMY247,1),(DUMMY248,1),(RABUS2,1),(DUMMY249,1),      *
               (HOLDOFF,1),(DUMMY250,1),(RBAR12,1),(DUMMY251,1),       *
               (SPARE088,8),(EXTSW0P,1),(DUMMY252,1),(EXTSW1P,1),      *
               (DUMMY253,1),(EXTSW2P,1),(DUMMY254,1),(EXTSW3P,1),      *
               (DUMMY255,1),(SPARE089,8)
         DSGEN (AREG0P,1),(DUMMY256,1),(AREG1P,1),(DUMMY257,1),        *
               (AREG2P,1),(DUMMY258,1),(AREG3P,1),(DUMMY259,1),        *
               (BREG0P,1),(DUMMY260,1),(BREG1P,1),(DUMMY261,1),        *
               (BREG2P,1),(DUMMY262,1),(BREG3P,1),(DUMMY263,1),        *
               (CREG0P,1),(DUMMY264,1),(CREG1P,1),(DUMMY265,1),        *
               (CREG2P,1),(DUMMY266,1),(CREG3P,1),(DUMMY267,1),        *
               (DREG0P,1),(DUMMY268,1),(DREG1P,1),(DUMMY269,1),        *
               (DREG2P,1),(DUMMY270,1),(DREG3P,1),(DUMMY271,1)
         DSGEN (IOLSD0P,1),(DUMMY272,1),(IOLSD1P,1),(DUMMY273,1),      *
               (IOLSD2P,1),(DUMMY274,1),(IOLSD3P,1),(DUMMY275,1),      *
               (CPULS0P,1),(DUMMY276,1),(CPULS1P,1),(DUMMY277,1),      *
               (CPULS2P,1),(DUMMY278,1),(CPULS3P,1),(DUMMY279,1),      *
               (IOSAR0P,1),(DUMMY280,1),(IOSAR1P,1),(DUMMY281,1),      *
               (IOSAR2P,1),(DUMMY282,1),(IOSAR3P,1),(DUMMY283,1),      *
               (CPUSR0P,1),(DUMMY284,1),(CPUSR1P,1),(DUMMY285,1),      *
               (CPUSR2P,1),(DUMMY286,1),(CPUSR3P,1),(DUMMY287,1)
         DSGEN (DUMMY288,1),(DUMMY289,1),(IAR1P,1),(DUMMY290,1),       *
               (IAR2P,1),(DUMMY291,1),(IAR3P,1),(DUMMY292,1),          *
               (PSWSMP,1),(DUMMY293,1),(PSWKEYP,1),(DUMMY294,1),       *
               (PSWESMP,1),(DUMMY295,1),(DUMMY296,1),(DUMMY297,1),     *
               (DUMMY298,1),(DUMMY299,1),(RBAR22,1),(DUMMY300,1),      *
               (DUMMY301,1),(DUMMY302,1),(RBAR32,1),(DUMMY303,1),      *
               (BS0P,1),(DUMMY304,1),(BS7,1),(DUMMY305,1),             *
               (IFTCHSP,1),(DUMMY306,1),(ALUFNRP,1),(DUMMY307,1)
         DSGEN (L12CTRP,1),(DUMMY308,1),(L1SS,1),(DUMMY309,1),         *
               (R12CTRP,1),(DUMMY310,1),(INABRR0,1),(DUMMY311,1),      *
               (SRADAD0,1),(DUMMY312,1),(BLKCONS,1),(DUMMY313,1),      *
               (CTRERR,1),(DUMMY314,1),(DUMMY315,1),(DUMMY316,1),      *
               (DUMMY317,1),(DUMMY318,1),(CPURA2,1),(DUMMY319,1),      *
               (GPSTL1P,1),(DUMMY320,1),(GPSTL3,1),(DUMMY321,1),       *
               (SPARE090,8)
         DSGEN (SPARE091,8),(SPARE092,8),(SPARE093,8),(CP1R0P,1),      *
               (DUMMY322,1),(CP1R2,1),(DUMMY323,1),(CP2R2,1),          *
               (DUMMY324,1),(DUMMY325,1),(DUMMY326,1)
         DSGEN (R0P1,1),(DUMMY327,1),(BRC01,1),(DUMMY328,1),           *
               (BBR11,1),(DUMMY329,1),(XYALU11,1),(DUMMY330,1),        *
               (R1P1,1),(DUMMY331,1),(MISC11,1),(DUMMY332,1),          *
               (Z11,1),(DUMMY333,1),(R2P1,1),(DUMMY334,1),             *
               (SPARE094,8),(SPARE095,8)
         DSGEN (SPARE096,64)
         DSGEN (SPARE097,64)
         DSGEN (SPARE098,64)
         DSGEN (SPARE099,64)
         DSGEN (SPARE100,64)
         DSGEN (AIRIN1E,1),(DUMMY335,1),(AIRO5E,1),(DUMMY336,1),       *
               (DUMMY337,1),(DUMMY338,1),(ECCBBP,1),(DUMMY339,1),      *
               (CONSEOB,1),(DUMMY340,1),(CONSL2,1),(DUMMY341,1),       *
               (DUMMY342,1),(DUMMY343,1),(DUMMY344,1),(DUMMY345,1),    *
               (SPARE101,16)
         DSGEN (FALE0P,1),(DUMMY346,1),(FALE1P,1),(DUMMY347,1),        *
               (FALE2P,1),(DUMMY348,1),(FALE3P,1),(DUMMY349,1),        *
               (FALO0P,1),(DUMMY350,1),(FALO1P,1),(DUMMY351,1),        *
               (FALO2P,1),(DUMMY352,1),(FALO3P,1),(DUMMY353,1),        *
               (FAHE0P,1),(DUMMY354,1),(FAHE1P,1),(DUMMY355,1),        *
               (FAHE2P,1),(DUMMY356,1),(FAHE3P,1),(DUMMY357,1),        *
               (FAHO0P,1),(DUMMY358,1),(FAHO1P,1),(DUMMY359,1),        *
               (FAHO2P,1),(DUMMY360,1),(FAHO3P,1),(DUMMY361,1)
         DSGEN (DUMMY362,1),(DUMMY363,1),(BCUS1P,1),(DUMMY364,1),      *
               (BCUS2P,1),(DUMMY365,1),(BCUS3P,1),(DUMMY366,1),        *
               (DUMMY367,1),(DUMMY368,1),(ASARB1P,1),(DUMMY369,1),     *
               (ASARB2P,1),(DUMMY370,1),(ASARB3P,1),(DUMMY371,1),      *
               (INSNE,1),(DUMMY372,1),(C40B1E,1),(DUMMY373,1),         *
               (INDXCE,1),(DUMMY374,1),(SDR614E,1),(DUMMY375,1),       *
               (LINDXP,1),(DUMMY376,1),(LINDX19,1),(DUMMY377,1),       *
               (UINDXP,1),(DUMMY378,1),(UINDX19,1),(DUMMY379,1)
         DSGEN (BCUB0P,1),(SPARE102,1),(BCUB7,1),(SPARE103,1),         *
               (BCUB14,1),(SPARE104,1),(SPDATAP,1),(SPARE105,1),       *
               (BCUM9BY,1),(SPARE106,1),(EDRECC,1),(SPARE107,1),       *
               (EDRDC40,1),(SPARE108,1),(MSIP,1),(SPARE109,1),         *
               (AIROP,1),(SPARE110,3),(MSC1024,1),(SPARE111,3),        *
               (CONSR0P,1),(SPARE112,1),(CONSR1P,1),(SPARE113,1),      *
               (CONSR2P,1),(SPARE114,1),(CONSR3P,1),(SPARE115,1)
         DSGEN (SPARE116,64)
         DSGEN (SPARE117,64)
         DSGEN (SPARE118,64)
         DSGEN (SPARE119,64)
         DSGEN (SPARE120,64)
         DSGEN (SPARE121,8),(CPUSER,24)
         DSGEN (DCTRL,1),(SPARE122,1),(DOSEM,1),(SPARE123,5),          *
               (UCWCNT,8),(FEATURES,16)
         DSGEN (CUADR1,64)
         DSGEN (CUADR2,64)
         DSGEN (UNPLUG,64)
         DSGEN (FLDLNGTH,16),(FAILINST,16)
         DS    CL2
         DSGEN (FAILINSR,16),(COMADR0,16)
         DSGEN (COMADR1,16),(INTCTL1,16)
         DSGEN (INTCTL1A,16),(HRDWRCVY,1),(SOFTRCVY,1),(TSKABORT,1),   X
               (TSKNODSP,1),(TERM,1),(XDUMY0,3),(MAINSTG,1),           X
               (BFRSTG,1),(CTLSTG,1),(XMAINSTG,1),(PROCESOR,1),        X
               (CHNERR,1),(TODCLK,1),(XDUMY1,1)
         DSGEN (INTMIT,1),(SOLID,1),(DATA,1),(ADDRESS,1),(MASK,1),     X
               (PROTECT,1),(XDUMY2,2),(RETRY,1),(REPAIR,1),            X
               (RECONFIG,1),(REFRESH,1),(MCIMCH,1),(DOWNCODE,3),       X
               (CPUID,4),(XDUMY3,12)
         DSGEN (XDUMY4,16),(RCDLOST1,16)
         DSGEN (RCDLOST2,32)
         DSGEN (MCSTATD6,32)
         DSGEN (MCSTATD7,32)
         DSGEN (MCSTATD8,32)
         DSGEN (MCSTATD9,32)
         DSGEN (MCSTATDA,32)
         DSGEN (MCSTATDB,32)
         DSGEN (MCSTATDC,32)
         DSGEN (MCSTATDD,32)
         DSGEN (MCSTATDE,32)
         DSGEN (MCSTATDF,32)
         DSGEN (MCSTATDG,32)
         DSGEN (MCSTATDH,32)
IFCEC155 CSECT
         USING     *,9
ENTRYPTR DC    A(STARTER)
TABLNAME DC    CL8'IFCEC155'
REG9     DC    F'0'
LP       DC    F'0'
SKIPPER  BR        14
         USING DSECT155,2
R0       EQU   0
R1       EQU   1
R2       EQU   2
R3       EQU   3
R4       EQU   4
R5       EQU   5
R6       EQU   6
R7       EQU   7
R8       EQU   8
R9       EQU   9
R10      EQU   10
R11      EQU   11
R12      EQU   12
R13      EQU   13
R14      EQU   14
R15      EQU   15
X20      EQU   X'20'                                           @Z02774
HEX00    EQU   X'00'
HEX08    EQU   X'08'
HEX40    EQU   X'40'
HEX80    EQU   X'80'
HEX48    EQU   X'48'
HEXBF    EQU   X'BF'
L0       EQU   0
L1       EQU   1
L2       EQU   2
L3       EQU   3
L4       EQU   4
L5       EQU   5
L6       EQU   6
L7       EQU   7
L8       EQU   8
L12      EQU   12
L19      EQU   19
L60      EQU   60
CK1583   SR    R15,R15             DON'T PRINT THIS LINE       @Z02774
         CLI   21(R2),X'58'        TEST FOR MOD 158            @Z02774
         BNER  R14                 NO, GO BACK                 @Z02774
         CLI   16(R2),X'00'                                    @O
         BE    BASIC                                           @O
         TM    16(R2),X'03'        158-3?                      @Z02774
         BCR   14,R14              BRANCH IF NO                @Z02774
BASIC    ST    R5,XFIVE                      SAVE REG 5        @O
         L     R5,LN1583           CHANGE LINE/LABEL POINTERS  @Z02774
         ST    R5,REG9             FOR 158-3                   @Z02774
         L     R5,LB1583                                       @Z02774
         ST    R5,LP                                           @Z02774
         B     EXIT                                            @Z02774
JUMP     ST    R5,XFIVE            SAVE REG 5                  @Z02774
         L     R5,JUMPLN           JUMP OVER 158-3 PRINT       @Z02774
         ST    R5,REG9                                         @Z02774
         L     R5,JUMPLB                                       @Z02774
         ST    R5,LP                                           @Z02774
         SR    R15,R15             DON'T PRINT THIS LINE       @Z02774
         B     EXIT                                            @Z02774
CHKFET   ST    R5,XFIVE                 STORE REG 5
         CLI   21(R2),X'58'        FET MODEL?                  @Z02774
         BNE   EXIT1               NO, RETURN                  @Z02774
         TM    16(R2),X'03'             M158-3?
         BNO   TRY01
         LA    R5,FETREC-L4             YES SET PTR
         ST    R5,REG9                  STORE  PTR
         B     EXIT
TRY01    TM    16(R2),X'01'                IS IT A PEN MACH
         BO    EXIT1                       RETURN IF YES
         LA    R5,FETREC-L4                SET POINTER
         ST    R5,REG9                     STORE POINTER
EXIT1    SR    R15,R15             DON'T PRINT THIS LINE       @Z02774
EXIT     L     R5,XFIVE                 RESTORE 5
         BR    R14                      GO BACK
NOFET    CLI   16(R2),X'00'
         BCR   7,R14              RETURN TO EDIT CNTRL
         CLI   21(R2),X'58'       TEST FOR MOD 158
         BCR   7,R14              RETURN
         SR    R15,R15            RESET FOR FET ONLY
         BR    R14
YESFET   CLI   16(R2),X'00'       TEST FET
         BNE   NOTFET             BRANCH IF NOT FET
         CLI   21(R2),X'58'       TEST FURTHER
         BCR   8,R14              BRANCH IF FET
NOTFET   SR    R15,R15            RESET FOR NONFET
         BR    R14
XFIVE    DC    F'0'
LN1583   DC    A(LN583-4)                                      @Z02774
LB1583   DC    A(LB583-1)                                      @Z02774
JUMPLN   DC    A(JUMP1-4)                                      @Z02774
JUMPLB   DC    A(JUMP2-1)                                      @Z02774
         LTORG
STARTER  DS    0F
         DC    XL4'00010001'
         DC    XL4'00010001'
         DC    A(LABAREA)
         DC    H'0'
         LINE  ,(1,1)                                          @Z02774
         ROUTINE SPARE083,CK1583                               @Z02774
         LABEL '  '                                            @Z02774
BYTMPXA  LINE      ,(5,23),SKIP=1
         LABEL     '---BYTE MPX CHAN CKS---'
         LINE      ,(31,20),SKIP=1
         LABEL     'CHANNEL 0','CHANNEL 4'
         LINE      (35,20),(4,),SKIP=1
         BIN       BIRPE
         BIN       C4HCE
         LABEL     'BREAK IN REG PTY CK'
         LINE
         BIN       BIRE
         BIN       C4BCIE
         LABEL     'BREAK IN REQ CK'
         LINE
         BIN       C0BCE
         BIN       C4BME
         LABEL     'BFR CONTROL CK'
         LINE  ,                                               @Z02774
         ROUTINE DUMMY111,JUMP                                 @Z02774
         LABEL '  '                                            @Z02774
LN583    LINE  (1,1),(5,73),SKIP=1                             @Z02774
LB583    LABEL '---BYTE MPX CHAN CKS---','---ACTIVE UCW---'    @Z02774
         LINE  (35,61),(31,20)                                 @Z02774
         ROUTINE DUMMY111,SKIPPER                              @Z02774
         HEX   SEQCHAN,0,1L                                    @Z02774
         LABEL 'CHANNEL 0','CHANNEL 4','      SEQ CTRLS'       @Z02774
         LINE  (35,20),(4,73)                                  @Z02774
         BIN   BIRPE                                           @Z02774
         BIN   C4HCE                                           @Z02774
         ROUTINE DUMMY111,SKIPPER                              @Z02774
         HEX   SEQCHAN,0,1R                                    @Z02774
         LABEL 'BREAK IN REG PTY','CHAN NO'                    @Z02774
         LINE  ,                                               @Z02774
         BIN   BIRE                                            @Z02774
         BIN   C4BCIE                                          @Z02774
         ROUTINE DUMMY111,SKIPPER                              @Z02774
         HEX   UNITADR,0,1B                                    @Z02774
         LABEL 'BREAK IN REQ CK','UNIT ADDRESS'                @Z02774
         LINE  ,                                               @Z02774
         BIN   C0BCE                                           @Z02774
         BIN C4BME                                             @Z02774
         ROUTINE DUMMY111,SKIPPER                              @Z02774
         HEX   RETSEQ,0,1B                                     @Z02774
         LABEL 'BFR CONTROL CK','RETRY SEQ'                    @Z02774
JUMP1    LINE  (35,20),(4,20),SKIP=1                           @Z02774
         BIN       C0BOCE
         BIN       C4IRE
JUMP2    LABEL 'BUS OUT LTH CK'                                @Z02774
         LINE
         BIN       C0S07E
         BIN       C4LRE
         LABEL     'I/O STAT 0-7 CK'
         LINE
         BIN       C0RE
         BIN       C4SBE
         ROUTINE DUMMY001,NOFET
         LABEL     'ROSDR 21-25 CK'
         LINE
         BIN   C0RE
         BIN   C4SBE
         ROUTINE DUMMY001,YESFET
         LABEL 'RCSDR 21-25 CK'
         LINE
         BIN       C0UCE
         BIN       C4SBOE
         LABEL     'UNIT ADR COMPARE CK'
         LINE
         BIN       C0CCE
         BIN       C4ISE
         LABEL     'HOLD OUT DLY CTR CK'
         LINE
         BIN       C0RCE
         BIN       C4SPE
         LABEL     'RETRY CK'
         LINE
         BIN       C0ITE
         BIN       C4ITE
         LABEL     'IN-TAG CK'
         LINE
         BIN       C0CLE
         BIN       C4CLE
         LABEL     'CHECK LOG'
         LINE
         BIN       C0BOPE
         BIN       C4BOPE
         LABEL     'BUS OUT LTH PTY CK'
         LINE
         BIN       C0BIE
         BIN       C4BIE
         LABEL     'BUS IN PTY CK'
         LINE      ,,SKIP=2
         BIN       C0WRLSE
         BIN       C4WRLSE
         LABEL     'WRITE LS CK'
         LINE      ,(5,),SKIP=1
         LABEL     '---BLK MPX CHAN CKS---'
         LINE      ,(31,20),SKIP=1
         LABEL     'CHANNEL 1','CHANNEL 2','CHANNEL 3','CHANNEL 5'
         LINE      (35,20),(4,),SKIP=1
         BIN       C1HCE
         BIN       C2HCE
         BIN       C3HCE
         BIN       C5HCE
         LABEL     'HARDWARE CONTROL CK'
         LINE
         BIN       C1BCIE
         BIN       C2BCIE
         BIN       C3BCIE
         BIN       C5BCIE
         LABEL     'BYTE CTR INPUT CK'
         LINE
         BIN       C1BME
         BIN       C2BME
         BIN       C3BME
         BIN       C5BME
         LABEL     'BYTE CTR MLFN CK'
         LINE
         BIN       C1IRE
         BIN       C2IRE
         BIN       C3IRE
         BIN       C5IRE
         LABEL     'INTERFACE RING CK'
         LINE
         BIN       C1LRE
         BIN       C2LRE
         BIN       C3LRE
         BIN       C5LRE
         LABEL     'LS RING CK'
         LINE
         BIN       C1SBE
         BIN       C2SBE
         BIN       C3SBE
         BIN       C5SBE
         LABEL     'SET BUFFER CK'
         LINE
         BIN       C1SBOE
         BIN       C2SBOE
         BIN       C3SBOE
         BIN       C5SBOE
         LABEL     'SET BOL CK'
         LINE
         BIN       C1ISE
         BIN       C2ISE
         BIN       C3ISE
         BIN       C5ISE
         LABEL     'I/O STAT 0-7 CK'
         LINE
         BIN       C1SPE
         BIN       C2SPE
         BIN       C3SPE
         BIN       C5SPE
         LABEL     'SISC PTY CK'
         LINE
         BIN       C1SWE
         BIN       C2SWE
         BIN       C3SWE
         BIN       C5SWE
         LABEL     'SISC WRAP CK'
         LINE
         BIN       C1ITE
         BIN       C2ITE
         BIN       C3ITE
         BIN       C5ITE
         LABEL     'IN TAG CK'
         LINE
         BIN       C1CLE
         BIN       C2CLE
         BIN       C3CLE
         BIN       C5CLE
         LABEL     'CHECK LOG'
         LINE
         BIN       C1BOPE
         BIN       C2BOPE
         BIN       C3BOPE
         BIN       C5BOPE
         LABEL     'BUS OUT LTH PTY CK'
         LINE
         BIN       C1BIE
         BIN       C2BIE
         BIN       C3BIE
         BIN       C5BIE
         LABEL     'BUS IN PTY CK'
         LINE
         BIN       C1WRLSE
         BIN       C2WRLSE
         BIN       C3WRLSE
         BIN       C5WRLSE
         LABEL     'WRITE LS CK'
         LINE  ,                                               @Z02774
         BIN   CCCH1E                                          @Z02774
         BIN   CCCH2E                                          @Z02774
         BIN   CCCH3E                                          @Z02774
         BIN   CCCH5E                                          @Z02774
         ROUTINE SPARE083,CHKFET                               @Z02774
         LABEL 'CC ERR CK'                                     @Z02774
         DC    X'FE'
         DC    CL8'IFCED155'
FETREC   DC    X'FE'
         DC    CL8'IFCEM155'
LABAREA  EQU   *
         LSTART
         END
