       TITLE   'IFCED165 MODEL 165 CPU EDIT TABLE 2'
*  DSGEN MACRO     DSGEN MACRO     DSGEN MACRO     DSGEN MACRO        *
         SPACE 2
         MACRO
&NAME    DSGEN
.*                            THIS MACRO GENERATES ONE DSECT WORD
.*                                 FORMATTED FOR THE SUBJECT LOG RECORD
.*                                 EACH OPERAND HAS TWO SUB LISTS. THE
.*                                 FIRST IS THE NAME OF THE LOG ITEM
.*                                 WHILE THE SECOND IS THE # OF BITS TO
.*                                 ALLOCATE FOR THIS ITEM. ITEMS MUST
.*                                 BE DEFINED CONTIGUOUSLY WITHOUT GAPS
.*                                 UNUSED BIT GROUPS MUST BE GIVEN
.*                                 DUMMY NAMES. THE NAMES PROVIDED FOR
.*                                 THE LOG ITEMS MAY THEN BE USED IN
.*                                 THE CONVERSION MACRO INSTRUCTIONS.
         GBLC &ITEM(2000)
         GBLA &ITEMNBR,&BITS(2000),&SHIFT(2000)
         LCLB  &ONLY1,&CTIND
         LCLA  &START1,&START2,&END1,&END2
         LCLC  &SYMBOL,&EQUSYM
         LCLA  &OP,&COUNT,&BYTE,&EQUCNT
         ACTR  100000
.START   AIF   (N'&SYSLIST(&OP+1) LT 3).LOOP
         AIF   ('&SYSLIST(&OP+1,3)' EQ 'EQU').LOOP     TEST FOR EQU
  AIF   ('&SYSLIST(&OP+1,3)' EQ '' OR '&SYSLIST(&OP+1,4)' EQ '').ERR1
         AIF   ('&SYSLIST(&OP+1,3)' GT '&SYSLIST(&OP+1,4)').ERR3
&START1  SETA  &SYSLIST(&OP+1,3)        GET START COUNT OF 1
&START2  SETA  &SYSLIST(&OP+1,4)        GET FIRST END COUNT
         AGO   .SET2A                   BRANCH AROUND
.ERR1    MNOTE '**FIRST SYMBOL CONCATENATION INCOMPLETE**'
         MEXIT
.SET2A   AIF   ('&SYSLIST(&OP+1,5)' EQ ''AND '&SYSLIST(&OP+1,6)' EQ '' X
               ).SET2                   TEST FOR NO SECOND
  AIF   ('&SYSLIST(&OP+1,5)' EQ '' OR '&SYSLIST(&OP+1,6)' EQ '').ERR2
         AIF   ('&SYSLIST(&OP+1,5)' GT '&SYSLIST(&OP+1,6)').ERR3
&END1    SETA  &SYSLIST(&OP+1,5)        GET START COUNT OF 2
&END2    SETA  &SYSLIST(&OP+1,6)        GET END COUNT OF 2
         AGO   .LOOP
.SET2    ANOP
&ONLY1   SETB  1                        INDICATE ONLY ONE CONCATENATION
         AGO   .LOOP
.ERR2    MNOTE '**SECOND SYMBOL CONCATENATION INCOMPLETE**'
         MEXIT
.ERR3    MNOTE '**START GREATER THAN END CONCATENATION**'
         MEXIT
.LOOP    ANOP
&OP      SETA  &OP+1
         AIF   (&OP GT N'&SYSLIST).DONE      TEST IF ALL DONE
&ITEMNBR SETA  &ITEMNBR+1
         AIF   ('&SYSLIST(&OP,2)' NE '').OK1
         MNOTE '**NULL BIT COUNT FIELD**'
         MEXIT
.OK1     ANOP
&SYMBOL  SETC  '&SYSLIST(&OP,1)'
         AIF   ('&SYMBOL' NE '').OK
*              *****     LOG ITEM SYMBOL NOT PROVIDED     *****
         AIF   ('&SYSLIST(&OP,3)' NE 'EQU').CNT
         AGO   .START                   GET NEXT
.OK      AIF   (N'&SYSLIST(&OP) LT 3).NO3    TEST FOR OLD FORMAT
         AIF   ('&SYSLIST(&OP,3)' EQ 'EQU').EQU   TEST FOR EQU
         AIF   (&ONLY1).OK2             TEST FOR ONLY ONE CONCAT
&SYMBOL  SETC  '&SYMBOL.&START1.&END1'       GET 1 AND 2 CONCAT
         AGO   .NO3                     BRANCH AROUND
.OK2     ANOP
&SYMBOL  SETC  '&SYMBOL.&START1'        GET 1 CONCATENATED
.NO3     ANOP
&SYMBOL  EQU   *+&BYTE
&ITEM(&ITEMNBR) SETC '&SYMBOL'          GET LABEL IN GLOBAL
&BITS(&ITEMNBR) SETA &SYSLIST(&OP,2)
&SHIFT(&ITEMNBR) SETA &COUNT-&BYTE*8
.CNT     ANOP
&CTIND   SETB  1                        SET COUNT INDICATOR
&COUNT   SETA  &COUNT+&SYSLIST(&OP,2)
&BYTE    SETA  &COUNT/8
         AIF   (N'&SYSLIST(&OP) LT 3).START  TEST FOR OLD FORMAT
         AIF   (&ONLY1).TSTST           TEST FOR ONLY ONE CONCAT
         AIF   (&END1 EQ &END2).TSTST   TEST FOR SECOND END
&END1    SETA  &END1+1                  INCREMENT COUNT
&OP      SETA  &OP-1                    DECREMENT INCREMENT
         AGO   .LOOP                    GENERATE NEXT
.TSTST   ANOP
         AIF   (&START1 EQ &START2).LPDONE   TEST FOR END
         AIF   (&ONLY1).NSET1           TEST FOR ONLY ONE CONCAT
&END1    SETA  &SYSLIST(&OP,5)          RE-INIT SECOND START COUNT
.NSET1   ANOP
&OP      SETA  &OP-1                    DECREMENT INDEX
&START1  SETA  &START1+1                INCREMENT FIRST COUNT
         AGO   .LOOP                    GO DO NEXT
.LPDONE  ANOP
&ONLY1   SETB  0                        CLEAR INDICATOR
         AGO   .START                   GO TEST FOR MORE SUB-LISTS
.DONE    AIF   (&COUNT-&COUNT/8*8 NE 0).ERR  TEST FOR MULTIPLE OF EIGHT
         AIF   (&CTIND EQ 0).END        NO DS IF NO COUNT
&COUNT   SETA  &COUNT/8                 GET NUMBER OF BYTES
&NAME    DS    &COUNT.C
.END     MEXIT
.ERR     MNOTE '**BIT COUNT FLDS DO NOT TOTAL MULTIPLE OF 8**'
         MEXIT
.EQU     AIF   ('&SYSLIST(&OP,4)' NE '').EQU1     TEST FOR NULL LABEL
.ERR4    MNOTE '**EQU OPERAND OMITTED OR NOT FOUND**'
         MEXIT
.EQU1    AIF   (&SYSLIST(&OP,2) LT 16).EQU2  COUNT OVER FIFTEEN
*****               THE FOLLOWING STATEMENT                *****
*****     NUMBER OF BITS EXCEED 15 - DO NOT USE AS BIN     *****
.EQU2    ANOP
&EQUCNT  SETA  0                        CLEAR COUNTER
&EQUSYM  SETC  '&SYSLIST(&OP,4)'        GET EQU OPERAND
.EQULOP  ANOP
&EQUCNT  SETA  &EQUCNT+1                INCREMENT INDEX
         AIF   ('&ITEM(&EQUCNT)' EQ '&EQUSYM').EQUOUT  LABEL FOUND?
         AIF   (&EQUCNT EQ &ITEMNBR).ERR4    ALL TESTED?
         AGO   .EQULOP                  NO-GET NEXT
.EQUOUT  ANOP
&ITEM(&ITEMNBR) SETC '&SYMBOL'          GET LABEL NAME
&BITS(&ITEMNBR) SETA &SYSLIST(&OP,2)    GET NUMBER OF BITS
&SHIFT(&ITEMNBR) SETA &SHIFT(&EQUCNT)   GET SHIFT COUNT
&SYMBOL  EQU   &EQUSYM                  THIS SYMBOL EQUATED
         AGO   .START                   RETURN FOR NEXT
         MEND
         MACRO
         LINEND
.*                            THIS MACRO IS USED ONLY BY THE LINE
.*                                 MACRO TO SET THE NUMBER OF ENTRIES
.*                                 ASSOCIATED WITH EACH LINE.
         GBLA  &NRENTS
         GBLC &NRENTSX
         AIF   (&NRENTS EQ 0).NORENTS   TEST FOR NO COUNT
         ORG   &NRENTSX
         DC    FL1'&NRENTS'
         ORG
&NRENTS  SETA  0
.NORENTS ANOP
B&SYSNDX EQU   *
&NRENTSX SETC  'B&SYSNDX'
         MEND
*
         MACRO
         BIN
.*                                 &SYSLIST(&OP,1) - NAME OF LOG ITEM
.*                                      RECORD DSECT
.*                                 $SYSLIST(&OP,2) - NBR OF SPACES
.*                                      TO SKIP ON MULTIPLE
.*                                      PRINT OR NBR OF SPACES
.*                                      TO BACK UP FROM COLUMN FOR
.*                                      START OF PRINTING. THE LETTER
.*                                      B PRECEEDS THE NUMBER (B5) IF
.*                                      THE LATTER IS DESIRED. OMISSION
.*                                      OF THIS OPERAND FORCES OPTION 2
.*                                      WITH BACKUP SPACING EQUAL TO
.*                                 THE NUMBER OF BITS IN THE ITEM
.*                                 DEFINITION (VIA MACRO 'DSGEN').
.*                            A LIMIT OF 15 BITS IS IMPOSED FOR THE
.*                                 TOTAL NUMBER OF BITS TO PRINT.
         GBLA  &INITIAL
         GBLB  &DIAGTST,&DIAGSET,&DIAGLIN
         GBLC &ITEM(2000)
         GBLA &ITEMNBR,&BITS(2000),&SHIFT(2000),&NRENTS
         GBLC  &DSECT
         LCLB  &B,&SUB
         LCLA  &IBITS,&NDX,&ISHIFT,&K
         LCLA  &TEMP,&T,&OP
         LCLC  &S
         AIF   (&DIAGTST EQ 0).NOMSG
         AIF   (&INITIAL EQ 0).NOMSG
         AIF   (&DIAGLIN EQ 1).NOMSG
         MNOTE '**NO LINE ASSOCIATED WITH THIS DATA**'
*****THE FOLLOWING GENERATED FOR TEST PURPOSES*****
*        LINE
         LINE
.NOMSG   ANOP
         AIF   (K'&SYSLIST(1) EQ K'&SYSLIST(1,1)).LOOP
&SUB     SETB  1
.LOOP    ANOP
&OP      SETA  &OP+1
.LOOP1   ANOP
&NDX     SETA  &NDX+1
         AIF   ('&ITEM(&NDX)' EQ '&SYSLIST(&OP,1)').FOUND
         AIF   (&NDX LT &ITEMNBR).LOOP1
         MNOTE '**LOG ITEM NOT DEFINED**'
         MEXIT
.FOUND   ANOP
&ISHIFT  SETA  &SHIFT(&NDX)
&IBITS   SETA  &BITS(&NDX)
&T       SETA  &IBITS-1
&B       SETB  0
         AIF   (&IBITS GT 0 AND &IBITS LT 16).SUB0
         MNOTE '**NO. OF BITS OUTSIDE RANGE OF 1-15**'
         MEXIT
.SUB0    AIF   (&SUB EQ 1).SUBA
         AIF   ('&SYSLIST(2)' EQ '').BACKUP
&K       SETA  K'&SYSLIST(2)
&B       SETB  ('&SYSLIST(2)'(1,1) EQ 'B')
&S       SETC  '&SYSLIST(2)'(&B+1,&K-&B)
         AGO   .SUBB
.SUBA    ANOP
         AIF   ('&SYSLIST(&OP,2)' EQ '').BACKUP
&K       SETA  K'&SYSLIST(&OP,2)
&B       SETB  ('&SYSLIST(&OP,2)'(1,1) EQ 'B')
&S       SETC  '&SYSLIST(&OP,2)'(&B+1,&K-&B)
.SUBB    ANOP
&T       SETA  &S
.BACKUP  ANOP
&NRENTS  SETA  &NRENTS+1
&TEMP    SETA  &ISHIFT
         AIF   (&IBITS NE 1 OR &B NE 0).BIN2
         DC    AL.12(&SYSLIST(&OP,1)-&DSECT),XL.4'&TEMP'
         AGO   .OUT
.BIN2    AIF   ('&SYSLIST(&OP,2)' NE '').BIN3
&B       SETB  1
.BIN3    ANOP
         DC    AL.12(&SYSLIST(&OP,1)-&DSECT),XL.4'C'
         DC    BL.1'&B',AL.7(&T),AL.4(&IBITS),FL.4'&ISHIFT'
.OUT     ANOP
&NDX     SETA  0
         AIF   (&SUB EQ 0).OUTA
         AIF   (&OP LT N'&SYSLIST).LOOP
.OUTA    ANOP
         MEND
         MACRO
         HEX
.*                            THIS MACRO FACILITATES GENERATION OF THE
.*                                 TABLE ENTRIES SPECIFYING HEX TYPE
.*                                 CONVERSIONS.
.*                            &SYSLIST(&OP,1) - NAME OF DATA ITEM TO BE
.*                                 CONVERTED
.*                            &SYSLIST(&OP,2) - # OF SPACES TO SKIP ON
.*                                 MULTIPLE PRINT OR NBR OF SPACES TO
.*                                 BACK UP FROM COLUMN FOR START OF
.*                                 PRINTING. THE LETTER B PRECEEDS THE
.*                                 NUMBER (B8) IF THE LATTER OPTION IS
.*                                 DESIRED. OMISSION OF THIS OPERAND
.*                                 FORCES OPTION 2 WITH BACKUP SPACING
.*                                 EQUAL TO THE NUMBER OF BYTES SPECI-
.*                                 FIED BY THE NEXT OPERAND (TWICE THIS
.*                                 NUMBER IF SUFFIX IS EXPLICITLY OR
.*                                 IMPLICITLY B).
.*                            &SYSLIST(&OP,3) - NUMBER OF BYTES TO
.*                                 PROCESS. THIS NUMBER IS SUFFIXED
.*                                 WITH AN L,R, OR B TO STIPULATE
.*                                 PRINTING OF THE LEFT HALF, RIGHT
.*                                 HALF, OR BOTH HALVES OF THE BYTE
.*                                 RESPECTIVELY. OMISSION OF THIS
.*                                 OPERAND DEFAULTS TO B WITH THE NUM-
.*                                 BER OF BYTES EQUAL TO THE ITEM LNGTH
.*                            A NEW ENTRY IS GENERATED ONLY WHEN NECES-
.*                                 SARY. THIS MACRO MUST BE THE FIRST
.*                                 MACRO INSTRUCTION ISSUED FOR THE
.*                                 SUBJECT LINE(S).
         GBLC &ITEM(2000),&DSECT
         GBLA &ITEMNBR,&BITS(2000),&SHIFT(2000),&NRENTS
         GBLA  &INITIAL
         GBLB  &DIAGTST,&DIAGSET,&DIAGLIN
         LCLB  &B,&SUB
         LCLA  &IBITS,&NDX,&ISHIFT,&K,&T,&CODE,&BYTESP,&OP
         LCLC  &S,&LETTER
         AIF   (&DIAGTST EQ 0).NOMSG
         AIF   (&INITIAL EQ 0).NOMSG
         AIF   (&DIAGLIN EQ 1).NOMSG
         MNOTE '**NO LINE ASSOCIATED WITH THIS DATA**'
*****THE FOLLOWING GENERATED FOR TEST PURPOSES*****
*        LINE
         LINE
.NOMSG   ANOP
         AIF   (K'&SYSLIST(1) EQ K'&SYSLIST(1,1)).LOOP
&SUB     SETB  1
.LOOP    ANOP
&OP      SETA  &OP+1
.LOOP1   ANOP
&NDX     SETA  &NDX+1
         AIF   ('&ITEM(&NDX)' EQ '&SYSLIST(&OP,1)').FOUND
         AIF   (&NDX LT &ITEMNBR).LOOP1
         MNOTE '**LOG ITEM NOT DEFINED**'
         MEXIT
.FOUND   ANOP
&ISHIFT  SETA  &SHIFT(&NDX)
&IBITS   SETA  &BITS(&NDX)
         AIF   (&ISHIFT EQ 0 OR &ISHIFT EQ 4).ALIGN
.ERR     MNOTE '**DATA NOT ALLIGNED ON HEX OR BYTE BOUNDARY**'
         MEXIT
.ALIGN   ANOP
&CODE    SETA  1
         AIF   (&SUB EQ 1).SUBA
&K       SETA  K'&SYSLIST(3)
         AGO   .SUBB
.SUBA    ANOP
&K       SETA  K'&SYSLIST(&OP,3)
.SUBB    ANOP
         AIF   (&IBITS-(&IBITS/4)*4 EQ 0).OK
         MNOTE '**BIT LENGTH SPECIFICATION INCONSISTENT WITH CONTROL**'
         MEXIT
.OK      AIF   (&SUB EQ 1).SUBC
         AIF   ('&SYSLIST(3)' EQ '').USEDEFN
&LETTER  SETC  '&SYSLIST(3)'(&K,1)
&S       SETC  '&SYSLIST(3)'(1,&K-1)
         AGO   .SUBD
.SUBC    ANOP
         AIF   ('&SYSLIST(&OP,3)' EQ '').USEDEFN
&LETTER  SETC  '&SYSLIST(&OP,3)'(&K,1)
&S       SETC  '&SYSLIST(&OP,3)'(1,&K-1)
.SUBD    ANOP
&BYTESP  SETA  &S
         AIF   ('&LETTER' EQ 'B').BOTH
         AIF   ('&LETTER' EQ 'L').LEFT
&CODE    SETA  2
         AGO   .L
.LEFT    ANOP
&CODE    SETA  1
         AGO   .L
.USEDEFN ANOP
&BYTESP  SETA  &IBITS/8
.BOTH    AIF   (&ISHIFT NE 0).ERR
&CODE    SETA  3
&T       SETA  &BYTESP*2-1
&S       SETC  '&T'
.OK2     AIF   (&ISHIFT EQ 0).L
&CODE    SETA  2
.L       ANOP
&B       SETB  1
         AIF   (&SUB EQ 1).SUBE
         AIF   ('&SYSLIST(2)' EQ '').BACKUP
&K       SETA  K'&SYSLIST(2)
&B       SETB  ('&SYSLIST(2)'(1,1) EQ 'B')
&S       SETC  '&SYSLIST(2)'(&B+1,&K-&B)
         AGO   .SUBF
.SUBE    ANOP
         AIF   ('&SYSLIST(&OP,2)' EQ '').BACKUP
&K       SETA  K'&SYSLIST(&OP,2)
&B       SETB  ('&SYSLIST(&OP,2)'(1,1) EQ 'B')
&S       SETC  '&SYSLIST(&OP,2)'(&B+1,&K-&B)
.SUBF    ANOP
.BACKUP  ANOP
&NRENTS  SETA  &NRENTS+1
         AIF   (&BYTESP GT 0 AND &BYTESP LT 16).SUB0
         MNOTE '**NO. OF BYTES OUTSIDE RANGE OF 1-15**'
         MEXIT
.SUB0    AIF   (&SUB EQ 1).SUBG
         DC    AL.12(&SYSLIST(1)-&DSECT),XL.4'A'
         AGO   .SUBH
.SUBG    ANOP
         DC    AL.12(&SYSLIST(&OP,1)-&DSECT),XL.4'A'
.SUBH    ANOP
         DC    BL.1'&B',FL.7'&S',AL.4(&BYTESP),FL.4'&CODE'
.OUT     ANOP
&NDX     SETA  0
         AIF   (&SUB EQ 0).OUTA
         AIF   (&OP LT N'&SYSLIST).LOOP
.OUTA    ANOP
         MEND
         MACRO
         LSTART
.*                            THIS MACRO IS ISSUED WHEN THE LABEL AREA
.*                                 OF THE TABLE IS TO BEGIN.
         GBLA  &LABELNR
         GBLC  &LBL(100)
         GBLC &LABELS(2000)
         GBLA  &LBLCTR(100)
         GBLB  &DIAGTST,&DIAGSET,&DIAGLIN
         LCLA  &NDX,&CTR
         AIF   (&DIAGTST EQ 0).NODIAG
         AIF   (&DIAGSET EQ 0).NODIAG
         MNOTE '**NO LABEL ASSOCIATED WITH LAST SET**'
***** THE FOLLOWING GENERATED FOR TEST PURPOSES *****
*        LABEL '%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%'
               LABEL '%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%'
.NODIAG  ANOP
         LINEND
&CTR     SETA  1
.LOOP    ANOP
&NDX     SETA  &NDX+1
         AIF   (&LBLCTR(&CTR) NE &NDX).NOLBL
&LBL(&CTR) DC  C'&LABELS(&NDX)'
&CTR     SETA  &CTR+1
         AGO   .LOOPCTL
.NOLBL   ANOP
         DC    C'&LABELS(&NDX)'
.LOOPCTL AIF   (&NDX LT &LABELNR).LOOP
         MEND
         MACRO
&NAME    LABEL &LABEL1,&LABEL2,&LABEL3,&LABEL4,&LABEL5,&LABEL6,        C
               &LABEL7,&LABEL8
.*                                 THIS MACRO ALLOWS LABELS TO
.*                                 BE SPECIFIED FOR A GIVEN LINE. THE
.*                                 LABELS SHOULD BE ENCLOSED IN QUOTA-
.*                                 TION MARKS. THE COLUMN AND LINE END
.*                                 CONTROLS WILL BE INSERTED BY THE
.*                                 MACRO. OMITTED OPERANDS MEAN NO
.*                                 LABEL REQUIRED FOR RESPECTIVE
.*                                 COLUMN.
         GBLC &LABELS(2000)
         GBLC  &LBL(100)
         GBLA  &LBLCTR(100)
         GBLA  &LABELNR
         GBLA  &NRENTS,&LPTR,&INITIAL
         GBLB  &DIAGTST,&DIAGSET,&DIAGLIN
         LCLC  &MARGIN,&TACK
         LCLC  &TEXT
         LCLA  &OP,&K,&START,&NRCHAR,&REMAIN
         AIF   (&INITIAL EQ 0).DIAGCLR
         AIF   (&DIAGTST EQ 0).DIAGCLR
         AIF   (&DIAGLIN EQ 1).DIAGCLR
         MNOTE '**NO LINE ASSOCIATED WITH PREVIOUS LABEL**'
***** THE FOLLOWING GENERATED FOR TEST PURPOSES *****
*        LINE
         LINE
.DIAGCLR ANOP
&DIAGSET SETB  0
&DIAGLIN SETB  0
&MARGIN  SETC  '*'
         AIF   ('&NAME' EQ '').LOOPOUT
&LPTR    SETA  &LPTR+1
&LBL(&LPTR) SETC '&NAME'
&LBLCTR(&LPTR) SETA &LABELNR+1
.LOOPOUT ANOP
&OP      SETA  &OP+1
&K       SETA  K'&SYSLIST(&OP)
         AIF (&K GE 2).NORM
&K       SETA  2
.NORM    ANOP
&START   SETA  2
         AIF (&OP LT N'&SYSLIST).NOTLAST
&MARGIN  SETC  '$'
.NOTLAST ANOP
&NRCHAR  SETA  8
&TACK    SETC  ''
.LOOPIN  ANOP
&REMAIN  SETA  &K-&START
         AIF (&REMAIN GE 8).MORE
&TACK    SETC  '&MARGIN'
&NRCHAR  SETA  &REMAIN
.MORE    ANOP
&TEXT    SETC  ''
         AIF (&REMAIN EQ 0).ENDTEXT
&TEXT    SETC  '&SYSLIST(&OP)'(&START,&NRCHAR)
.ENDTEXT ANOP
&LABELNR SETA  &LABELNR+1
&LABELS(&LABELNR) SETC '&TEXT'.'&TACK'
&START   SETA  &START+8
         AIF ('&TACK' EQ '').LOOPIN
         AIF ('&TACK' EQ '*').LOOPOUT
         MEND
         MACRO
&NAME    ROUTINE &LOGITEM,&RNAME
         GBLA  &NRENTS
         GBLC  &DSECT,&CSECT
         GBLA  &INITIAL
         GBLB  &DIAGTST,&DIAGSET,&DIAGLIN
         AIF   (&DIAGTST EQ 0).NOMSG
         AIF   (&INITIAL EQ 0).NOMSG
         AIF   (&DIAGLIN EQ 1).NOMSG
         MNOTE '**NO LINE ASSOCIATED WITH THIS ROUTINE**'
*****THE FOLLOWING GENERATED FOR TEST PURPOSES*****
*        LINE
         LINE
.NOMSG   ANOP
&NAME    DC    AL.12(&LOGITEM-&DSECT),XL.4'D'
         DC    AL2(&RNAME-&CSECT)
&NRENTS  SETA  &NRENTS+1
         MEND
         MACRO
&NAME    LINE  &DATA,&LABEL,&SKIP=
.*                            THIS MACRO ESTABLISHES THE MARGINS OR
.*                                 COLUMN SETTINGS FOR EACH LINE. IT
.*                                 GENERATES NECESSARY CARRIAGE CONTROL
.*                                 ENTRIES. LASTLY IT DETERMINES THE
.*                                 NUMBER OF ENTRIES ASSOCIATED WITH
.*                                 THE PREVIOUS LINE AND STORES THAT #
.*                                 INTO THE APPROPRIATE BYTE.
.*                            &DATA(1) - CHARACTER POSITION TO BEGIN
.*                                 DATA.
.*                            &DATA(2) - # OF SPACES BETWEEN SUCCESSIVE
.*                                 DATA COLUMN STARTING CHARACTERS.
.*                            &LABEL(1) - CHAR. POS. TO BEGIN LABELS.
.*                            &LABEL(2) - # SPACES BETWEEN LINE'S LABEL
.*                                 STARTING CHARACTERS.
.*                            &SKIP= - # OF LINES TO ADVANCE CARRIAGE
.*                                 TO BEGIN NEXT PRINTED LINE.
.*                            NEW ENTRIES ARE GENERATED ONLY WHEN
.*                                 NECESSARY. OMISSION OF ITEMS MEANS
.*                                 THEY HAVE NOT CHANGED SINCE PREVIOUS
.*                                 SETTINGS. A LINE MACRO IS REQUIRED
.*                                 FOR EACH PRINTED LINE. IF NO SETTING
.*                                 CHANGES ARE REQUIRED ALL OPERANDS
.*                                 ARE OMITTED IN WHICH CASE ONLY THE
.*                                 # OF ENTRIES FOR THE PREVIOUS LINE
.*                                 IS COMPUTED. THIS MACRO MUST BE THE
.*                                 FIRST MACRO INSTRUCTION ISSUED FOR
.*                                 THE SUBJECT LINE
         GBLA  &DB,&DT,&LB,&LT,&NRENTS
         GBLA  &LASTCC,&INITIAL
         GBLC  &NRENTSX
         GBLC  &CARRCON
         GBLB  &TEST
         GBLB  &DIAGTST,&DIAGSET,&DIAGLIN
         LCLA  &S
         AIF   (&INITIAL EQ 0 OR &DIAGTST EQ 0).DIAGSET
         AIF   (&DIAGSET EQ 0).DIAGSET
         MNOTE '**NO LABEL ASSOCIATED WITH LAST SET**'
***** THE FOLLOWING GENERATED FOR TEST PURPOSES *****
*        LABEL '%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%'
               LABEL '%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%'
.DIAGSET ANOP
&DIAGSET SETB  1
&DIAGLIN SETB  1
&NAME    DS    0C
         AIF   (&INITIAL EQ 0).FIRSTLN
         LINEND
         AGO   .NTFIRST
.FIRSTLN ANOP
&NRENTSX SETC  'N&SYSNDX'
&INITIAL SETA  1
N&SYSNDX EQU   *
.NTFIRST ANOP
         DC    AL1(0)
         AIF   ('&DATA(1)' EQ '').CKDTABS
         AIF   (&DATA(1) EQ &DB).CKDTABS
&DB      SETA  &DATA(1)
         AGO   .AA
.CKDTABS AIF   ('&DATA(2)' EQ '').NCDATA
         AIF   (&DATA(2) EQ &DT).NCDATA
         AGO   .CC
.AA      AIF   ('&DATA(2)' EQ '').BB
         AIF   (&DATA(2) EQ &DT).BB
.CC      ANOP
&DT      SETA  &DATA(2)
.BB      DC    XL2'FFFE'
         DC    FL1'&DB'
         DC    FL1'&DT'
&NRENTS  SETA  &NRENTS+1
.NCDATA  ANOP
         AIF   ('&LABEL(1)' EQ '').CKLTABS
         AIF   (&LABEL(1) EQ &LB).CKLTABS
&LB      SETA  &LABEL(1)
         AGO   .AAA
.CKLTABS AIF   ('&LABEL(2)' EQ '').NCLABEL
         AIF   (&LABEL(2) EQ &LT).NCLABEL
         AGO   .CCC
.AAA     AIF   ('&LABEL(2)' EQ '').BBB
         AIF   (&LABEL(2) EQ &LT).BBB
.CCC     ANOP
&LT      SETA  &LABEL(2)
.BBB     DC    XL2'FFFF'
         DC    FL1'&LB'
         DC    FL1'&LT'
&NRENTS  SETA  &NRENTS+1
.NCLABEL ANOP
         AIF   ('&SKIP' NE '').CONT
         AIF   (&TEST EQ 0).NOCHANG
         AGO   .DEFALTA
.CONT    ANOP
         AIF   (&TEST EQ 0).AB
         AIF   ('&SKIP' EQ 'E').AB
&S       SETA  &SKIP
.DEFAULT ANOP
         AIF   (&SKIP EQ &LASTCC).DEFALTA
         ORG   &CARRCON+3
         DC    AL.3(0),AL.2(&S),AL.3(1)
         ORG
&LASTCC  SETA  &S
.DEFALTA ANOP
&TEST    SETB  0
         AGO   .DD
.AB      AIF   ('&SKIP' NE 'E').ABB
A&SYSNDX DC    X'FFFB8B00'              EJECT
         AGO   .ABC
.ABB     AIF   (&SKIP EQ &LASTCC).NOCHANG
A&SYSNDX DC    XL2'FFFB'
         DC    AL.3(0),AL.2(&SKIP),AL.3(1)
         DC    AL.3(0),AL.2(&SKIP),AL.3(1)
&LASTCC  SETA  &SKIP
&TEST    SETB  1
.ABC     ANOP
&CARRCON SETC  'A&SYSNDX'
&NRENTS  SETA  &NRENTS+1
.DD      ANOP
.NOCHANG ANOP
         MEND
         EJECT
         GBLC  &DSECT,&CSECT
&DSECT   SETC  'INDEPEND'
&CSECT   SETC  'IFCED165'
IFCED165 CSECT
         USING *,R9
INDEPEND DSECT
         DS    0F
         DSGEN (XKEY,16),(XSWS8,9),(XSWS9,1),(XSWS10,1),(XSWS11,1),    C
               (XSWS12,1),(XSWS13,1),(XSWS14,1),(XSWS15,1)
         DSGEN (XDUM1,32)
         DSGEN (XDATE,32)
         DSGEN (XTIME,32)
         DSGEN (XDUM2,8),(XSER,24)
         DSGEN (XCPUMOD,16),(XDUM3,16)
         DSGEN (XPGMID,64)
         DSGEN (XJOBID,64)
         DSGEN (XMCKPSW,64)
M165     DS    214F
         DSGEN (A1LB,32)
         DSGEN (A1LC,32)
         DSGEN (A1LD,32)
         DSGEN (A1LE,32)
         DSGEN (A1LF,32)
         DSGEN (A1LG,32)
         DSGEN (A1LH,32)
         DSGEN (A1LJ,32)
         DSGEN (A1LK,32)
         DSGEN (A1LL,32)
         DSGEN (A2LB,32)
         DSGEN (A2LC,32)
         DSGEN (A2LD,32)
         DSGEN (A2LE,32)
         DSGEN (A2LF,32)
         DSGEN (A2LG,32)
         DSGEN (A2LH,32)
         DSGEN (A2LJ,32)
         DSGEN (A2LK,32)
         DSGEN (A2LL,32)
         DSGEN (A3LB,32)
         DSGEN (A3LC,32)
         DSGEN (A3LD,32)
         DSGEN (A3LE,32)
         DSGEN (A3LF,32)
         DSGEN (A3LG,32)
         DSGEN (A3LH,32)
         DSGEN (A3LJ,32)
         DSGEN (A3LK,32)
         DSGEN (A3LL,32)
         DSGEN (A4LB,32)
         DSGEN (A4LC,32)
         DSGEN (A4LD,32)
         DSGEN (A4LE,32)
         DSGEN (A4LF,32)
         DSGEN (A4LG,32)
         DSGEN (A4LH,32)
         DSGEN (A4LJ,32)
         DSGEN (A4LK,32)
         DSGEN (A4LL,32)
         DSGEN (A5LB,32)
         DSGEN (A5LC,32)
         DSGEN (A5LD,32)
         DSGEN (A5LE,32)
         DSGEN (A5LF,32)
         DSGEN (A5LG,32)
         DSGEN (A5LH,32)
         DSGEN (A5LJ,32)
         DSGEN (A5LK,32)
         DSGEN (A5LL,32)
         DSGEN (A6LB,32)
         DSGEN (A6LC,32)
         DSGEN (A6LD,32)
         DSGEN (A6LE,32)
         DSGEN (A6LF,32)
         DSGEN (A6LG,32)
         DSGEN (A6LH,32)
         DSGEN (A6LJ,32)
         DSGEN (A6LK,32)
         DSGEN (A6LL,32)
         DSGEN (A7LB,32)
         DSGEN (A7LC,32)
         DSGEN (A7LD,32)
         DSGEN (A7LE,32)
         DSGEN (A7LF,32)
         DSGEN (A7LG,32)
         DSGEN (A7LH,32)
         DSGEN (A7LJ,32)
         DSGEN (A7LK,32)
         DSGEN (A7LL,32)
         DSGEN (B0LB,32)
         DSGEN (B0LC,32)
         DSGEN (B0LD,32)
         DSGEN (B0LE,32)
         DSGEN (B0LF,32)
         DSGEN (B0LG,32)
         DSGEN (B0LH,32)
         DSGEN (B0LJ,32)
         DSGEN (B0LK,32)
         DSGEN (B0LL,32)
         DSGEN (B1LB,32)
         DSGEN (B1LC,32)
         DSGEN (B1LD,32)
         DSGEN (B1LE,32)
         DSGEN (B1LF,32)
         DSGEN (B1LG,32)
         DSGEN (B1LH,32)
         DSGEN (B1LJ,32)
         DSGEN (B1LK,32)
         DSGEN (B1LL,32)
         DSGEN (B2LB,32)
         DSGEN (B2LC,32)
         DSGEN (B2LD,32)
         DSGEN (B2LE,32)
         DSGEN (B2LF,32)
         DSGEN (B2LG,32)
         DSGEN (B2LH,32)
         DSGEN (B2LJ,32)
         DSGEN (B2LK,32)
         DSGEN (B2LL,32)
         DSGEN (B3LB,32)
         DSGEN (B3LC,32)
         DSGEN (B3LD,32)
         DSGEN (B3LE,32)
         DSGEN (B3LF,32)
         DSGEN (B3LG,32)
         DSGEN (B3LH,32)
         DSGEN (B3LJ,32)
         DSGEN (B3LK,32)
         DSGEN (B3LL,32)
         DSGEN (B4LB,32)
         DSGEN (B4LC,32)
         DSGEN (B4LD,32)
         DSGEN (B4LE,32)
         DSGEN (B4LF,32)
         DSGEN (B4LG,32)
         DSGEN (B4LH,32)
         DSGEN (B4LJ,32)
         DSGEN (B4LK,32)
         DSGEN (B4LL,32)
         DSGEN (B5LB,32)
         DSGEN (B5LC,32)
         DSGEN (B5LD,32)
         DSGEN (B5LE,32)
         DSGEN (B5LF,32)
         DSGEN (B5LG,32)
         DSGEN (B5LH,32)
         DSGEN (B5LJ,32)
         DSGEN (B5LK,32)
         DSGEN (B5LL,32)
         DSGEN (B6LB,32)
         DSGEN (B6LC,32)
         DSGEN (B6LD,32)
         DSGEN (B6LE,32)
         DSGEN (B6LF,32)
         DSGEN (B6LG,32)
         DSGEN (B6LH,32)
         DSGEN (B6LJ,32)
         DSGEN (B6LK,32)
         DSGEN (B6LL,32)
         DSGEN (C0LB,32)
         DSGEN (C0LC,32)
         DSGEN (C0LD,32)
         DSGEN (C0LE,32)
         DSGEN (C0LF,32)
         DSGEN (C0LG,32)
         DSGEN (C0LH,32)
         DSGEN (C0LJ,32)
         DSGEN (C0LK,32)
         DSGEN (C0LL,32)
         DSGEN (C1LB,32)
         DSGEN (C1LC,32)
         DSGEN (C1LD,32)
         DSGEN (C1LE,32)
         DSGEN (C1LF,32)
         DSGEN (C1LG,32)
         DSGEN (C1LH,32)
         DSGEN (C1LJ,32)
         DSGEN (C1LK,32)
         DSGEN (C1LL,32)
         DSGEN (C2LB,32)
         DSGEN (C2LC,32)
         DSGEN (C2LD,32)
         DSGEN (C2LE,32)
         DSGEN (C2LF,32)
         DSGEN (C2LG,32)
         DSGEN (C2LH,32)
         DSGEN (C2LJ,32)
         DSGEN (C2LK,32)
         DSGEN (C2LL,32)
         DSGEN (C3LB,32)
         DSGEN (C3LC,32)
         DSGEN (C3LD,32)
         DSGEN (C3LE,32)
         DSGEN (C3LF,32)
         DSGEN (C3LG,32)
         DSGEN (C3LH,32)
         DSGEN (C3LJ,32)
         DSGEN (C3LK,32)
         DSGEN (C3LL,32)
         DSGEN (C4LB,32)
         DSGEN (C4LC,32)
         DSGEN (C4LD,32)
         DSGEN (C4LE,32)
         DSGEN (C4LF,32)
         DSGEN (C4LG,32)
         DSGEN (C4LH,32)
         DSGEN (C4LJ,32)
         DSGEN (C4LK,32)
         DSGEN (C4LL,32)
         DSGEN (C5LB,32)
         DSGEN (C5LC,32)
         DSGEN (C5LD,32)
         DSGEN (C5LE,32)
         DSGEN (C5LF,32)
         DSGEN (C5LG,32)
         DSGEN (C5LH,32)
         DSGEN (C5LJ,32)
         DSGEN (C5LK,32)
         DSGEN (C5LL,32)
         DSGEN (C6LB,32)
         DSGEN (C6LC,32)
         DSGEN (C6LD,32)
         DSGEN (C6LE,32)
         DSGEN (C6LF,32)
         DSGEN (C6LG,32)
         DSGEN (C6LH,32)
         DSGEN (C6LJ,32)
         DSGEN (C6LK,32)
         DSGEN (C6LL,32)
         DSGEN (DARLNGTH,16),(,48)
         DSGEN (SYSSTAT,1,0,7)
         DSGEN (AREADT,1,0,15)
         DSGEN (ERRTYPE,1,0,7)
         DSGEN (RMSACTN,1,0,7)
         DSGEN (RMSINFO,1,0,7)
         DSGEN (WAITSUFF,8),(,8),(LOSTSUM,48),(,16)
         DSGEN (TRNSMOD,32,0,7)
         DSGEN (MCHPDR,1,0,7,0,7)
         DSGEN (FSRADDR,32),(BFSVADDR,32),(EFSVADDR,32),               C
               (INSTADDR,32)
LOGEND   EQU   *-2
IFCED165 CSECT
***********************************************************************
*
***********************************************************************
ENTRYPTR DC    A(FORMAT1)
TABLNAME DC    CL8'IFCED165'
REG9     DS    F
SAVE     DS    F
***
*              ***     SPECIAL ROUTINES AREA     ***
*
***********************************************************************
ROUT0    DS    0C
         STM   R3,R4,SAVER34            SAVE PRINT BFR PTR- LOG START
         BR    R14                      RETURN
ROUT1    DS    0C
         STM   R3,R8,XSAVE              SAVE ROUTINE REGISTERS
         L     R3,SAVER3                LOAD ADR OF PRINT BFR
         L     R7,L0(R4)                LOAD LOG DATA
         LA    R3,L3(R3)                INCREMENT PRINT BFR POINTER
         LA    R8,L4                    LOAD BYTE COUNT
ROUT1A   DS    0C
         LA    R5,L6                    LOAD BIT COUNT
ROUT1B   DS    0C
         SR    R6,R6                    CLEAR REGISTER R6
         MVI   L0(R3),CB                ASSUME 0 - SET BFR TO BLANK
         SLDL  R6,L1                    SHIFT DATA BIT INTO R6
         LTR   R6,R6                    TEST VALUE IN R6
         BZ    ROUT1C                   BRANCH IF R6 ZERO
         MVI   L0(R3),CS                MOVE SPLAT TO PRINT BFR
ROUT1C   DS    0C
         LA    R3,L3(R3)                INCREMENT PRINT BFR POINTER
         BCT   R5,ROUT1B                BRANCH ON BIT COUNT
         SLL   R7,L2                    BYPASS BITS 6 AND 7
         BCT   R8,ROUT1A                BRANCH ON BYTE COUNT
         LM    R3,R8,XSAVE              RESTORE REGISTERS
         BR    R14                      RETURN
         USING  INDEPEND,R2
***********************************************************************
*        THIS ROUTINE CHECKS FOR A M168 MP SYSTEM                     *
***********************************************************************
MPBIT    EQU   X'04'
CKMP     CLI   16(L2),X'81'            LEXINGTON?              @Z402IFR
         BNE   CKMP1                                           @Z402IFR
         MVC   L0(L10,R3),SSCON
         LA    R3,10(R3)                                       @XA20541
         BR    R14                                             @Z402IFR
CKMP1    CLC   XCPUMOD(L2),C168        168 MP?                 @Z402IFR
         BE    INSERT                   YES - GO PUT IN LABEL
         BR    R14                      RETURN
TSTMPBIT TM    XSWS8,MPBIT              Q/ IS THIS AN MP SYSTEM
         BO    INSERT                   YES - GO PUT IN LABEL
         BR    R14                      RETURN
INSERT   MVC   L0(L2,R3),MPCON          MOVE IN LABEL FOR MP FEATURE
         LA    R3,2(R3)                                        @XA20541
         BR    R14                      RETURN
C168     DC    X'0168'
MPCON    DC    C'MP'
SSCON    DC    C'SS PWRWARN'
L14      EQU   14
MODCK    CLC   XCPUMOD(L2),C168         Q/ IS THIS A 168
         BE    INSREM                   YES--PUT IN LABELS
         CLC   XCPUMOD(L2),C3062   3062?                       @Z402IFR
         BE    INSREM                                          @Z402IFR
         BR    R14                      RETURN
INSREM   MVC   L0(L3,R3),REMCON         MOVE IN REM
         BR    R14                      RETURN
REMCON   DC    C'REM'
CKMOD    CLC   XCPUMOD(L2),C168         Q/ IS THIS A 168
         BE    INSLAB                   YES--PUT IN LABELS
         CLC   XCPUMOD(L2),C3062   3062?                       @Z402IFR
         BE    INSLAB                                          @Z402IFR
C3062    DC    X'3062'                                         @Z402IFR
         BR    R14                      RETURN
INSLAB   MVC   L0(L14,R3),LAB168        MOVE IN LABELS
         BR    R14                      RETURN
LAB168   DC    C'PASMA ES EC SC'
CHK1683  CLC   XCPUMOD(L2),C168    168?                        @Z02774
         BE    TSTMOD                                          @Z402IFR
         CLC   XCPUMOD(L2),C3062   3062?                       @Z402IFR
         BNER  R14                                             @Z402IFR
TSTMOD   TM    XDUM2,X'01'                                     @Z402IFR
         BZR   R14                 RETURN IF NO                @Z02774
         ST    R5,XSAVE            SAVE R5                     @Z02774
         L     R5,LN1683           POINT TO 168-3 LINE/        @Z02774
         ST    R5,REG9             LABELS                      @Z02774
         L     R5,LAB1683                                      @Z02774
         ST    R5,SAVE                                         @Z02774
         L     R5,XSAVE            RESTORE REG 5               @Z02774
         SR    R15,R15             DON'T PRINT THIS LINE       @Z02774
         BR    R14                 RETURN TO PRINT 168-3       @Z02774
DID1683  ST    R5,XSAVE            SAVE REG 5                  @Z02774
         L     R5,LN168            POINT TO 168 LINE/          @Z02774
         ST    R5,REG9             LABELS                      @Z02774
         L     R5,LB168                                        @Z02774
         ST    R5,SAVE                                         @Z02774
         L     R5,XSAVE            RESTORE REG 5               @Z02774
         SR    R15,R15             DON'T PRINT THIS LINE       @XA20541
         BR    R14                 RETURN                      @XA20541
         SPACE 3                                               @XA20541
***********************************************************************
**     THIS ROUTINE CHECKS FOR POWER WARNING FEATURE                 **
***********************************************************************
CKPW     TM    1(R4),X'40'         IS PW BIT ON?               @XA20541
         BZR   R14                 NO...RETURN                 @XA20541
         MVC   0(L2,R3),PWCON      MOVE 'PW' IN                @XA20541
         LA    R3,2(R3)            MOVE POINTER                @XA20541
         BR    R14                 RETURN                      @XA20541
         SPACE 3                                               @XA20541
***********************************************************************
**           THIS ROUTINE CHECKS FOR 370 EXTENSION                   **
***********************************************************************
CKEXT    TM    1(R4),X'20'         IS 370-EXT BIT ON?          @XA20541
         BZR   R14                 NO...RETURN                 @XA20541
         MVC   0(L2,R3),EXTCON     MOVE 'EX' IN                @XA20541
         LA    R3,2(R3)            MOVE POINTER                @XA20541
         BR    R14                 RETURN                      @XA20541
         SPACE 3                                               @XA20541
***********************************************************************
**           THIS ROUTINE CHECKS FOR VM ACTIVE                       **
***********************************************************************
CKVMA    TM    1(R4),X'10'         IS VMA BIT ON?              @XA20541
         BZR   R14                 NO...RETURN                 @XA20541
         MVC   0(L3,R3),VMACON     MOVE 'VMA' IN               @XA20541
         LA    R3,3(R3)            MOVE POINTER                @XA20541
         BR    R14                 RETURN                      @XA20541
         SPACE 3                                               @XA20541
PWCON    DC    CL2'PW'                                         @XA20541
EXTCON   DC    CL2'EX'                                         @XA20541
VMACON   DC    CL3'VMA'                                        @XA20541
**------------------END OF ROUTINES----------------------------------**
         EJECT                                                 @XA20541
X01      EQU   X'01'                                           @XA20541
R0       EQU   0
R1       EQU   1
R2       EQU   2
R3       EQU   3
R4       EQU   4
R5       EQU   5
R6       EQU   6
R7       EQU   7
R8       EQU   8
R9       EQU   9
R10      EQU   10
R11      EQU   11
R12      EQU   12
R13      EQU   13
R14      EQU   14
R15      EQU   15
CC1      EQU   1
CC2      EQU   2
CC4      EQU   4
CC7      EQU   7
CC8      EQU   8
L0       EQU   0
L1       EQU   1
L2       EQU   2
L3       EQU   3
L4       EQU   4
L5       EQU   5
L6       EQU   6
L7       EQU   7
L8       EQU   8
L9       EQU   9
L10      EQU   10
CB       EQU   C' '
CS       EQU   C'*'
XWORK    DS    D
XSAVE    DS    6F
SAVER34  DS    2F
LN1683   DC    A(LN683-4)                                      @Z02774
LAB1683  DC    A(LAB683-1)                                     @Z02774
LN168    DC    A(LN68-4)                                       @Z02774
LB168    DC    A(LAB68-1)                                      @Z02774
SAVER3   EQU   SAVER34
SAVER4   EQU   SAVER34+4
***********************************************************************
*
FORMAT1  DC    F'0'
FORMAT2  DC    F'0'
LABELPTR DC    A(LABLAREA)
DISP     DC    FL2'0'
***********************************************************************
         LINE  (1,1),(1,1),SKIP=3
       LABEL  ' '
         LINE  (1,1),(19,1),SKIP=1
         ROUTINE    A1LB,ROUT0
       LABEL  'M/F FRAME A1 STORAGE STATUS'
         LINE  ,(13,1)
       LABEL  'STG CHAIN                / LSU OP /   DIA   CAN    LSU OX
               PER'
         LINE  ,(13,1)
       LABEL  '0  1  2  3                 S  P T/S   MDE          0  1 X
                2  3'
         LINE  ,(1,1)
         ROUTINE    A1LB,ROUT1
       LABEL  'LB'
         LINE  ,(13,1)
       LABEL  'SCU CHAIN     SEL         /SP OP  /STR SP         HLD SEX
               G ECHO MER'                                     @Z02774
         LINE  ,(13,1)
       LABEL  '0  1  2  3    CH          ISKSSKRRB M  C          IND DEX
               T DET  DET'                                     @Z02774
         LINE  ,(1,1)
         ROUTINE    A1LC,ROUT1
       LABEL  'LC'
        LINE  (24,1),(12,27)
         ROUTINE    XCPUMOD,MODCK
       LABEL  'STE SEGM ID','/  SP BUS IN         /'
         LINE  (1,1),(13,1)
       LABEL  'P  0  1  2                 P  0  1  2  3  4  5  6'
         LINE  ,(1,1),SKIP=1
         ROUTINE    A1LD,ROUT1
       LABEL  'LD'
         LINE  (24,1),(13,17)
         ROUTINE    XCPUMOD,MODCK
       LABEL  '/ LSU ID',' DIS      /SP KEY BUS OUT/    SP REF CHG'
         LINE  (1,1),(13,1)
       LABEL  '0  1  2  3    ENC ECC      P  0  1  2  3  4     P BIT BIX
               T'
         LINE  ,(1,1)
         ROUTINE    A1LE,ROUT1
       LABEL  'LE'
         LINE  ,(28,1)
       LABEL  'SOURCE/SINK OUT BITS'
         LINE  ,(13,1)
       LABEL  'P  0  1  2  3  4  5  6  7     P  8  9 10 11 12 13 14 15'
         LINE  ,(1,1)
         ROUTINE    A1LF,ROUT1
       LABEL  'LF'
         LINE  ,(26,1)
       LABEL  'STORAGE ADDRESS BUS BITS'
         LINE  ,(12,1)
       LABEL  'PA  0  1  2  3  4  5  6  7    PB  8  9 10 11 12 13 14'
         LINE  ,(1,1)
         ROUTINE    A1LG,ROUT1
       LABEL  'LG'
         LINE  ,(23,1)
       LABEL  'MARKS               ERROR INDICATION FIELD'
         LINE  ,(13,1)
       LABEL  'P  0  1  2  3  4  5  6  7     0  1  2  3  4  5  6  7'
         LINE  ,(1,1)
         ROUTINE    A1LH,ROUT1
       LABEL  'LH'
         LINE  ,(31,1)
       LABEL  'PROTCT       SSPTR'
         LINE  ,(32,1)
       LABEL  'VIOL        UNEQ'
         LINE  ,(1,1)
         ROUTINE    A1LJ,ROUT1
       LABEL  'LJ'
         LINE  ,(13,1)
       LABEL  'SP      ECC CHCKS   S/S   S/S AR CK STORAGE CHECKS'
         LINE  ,(13,1)
       LABEL  'MCK      CE   UE     P    AL SYN OV  SDB1   MK    ADR'
         LINE  ,(1,1)
         ROUTINE    A1LK,ROUT1
       LABEL  'LK'
         LINE  ,(29,1)
       LABEL  'STOR  UNRTRY    MS'
         LINE  ,(30,1)
       LABEL  'CHK   CHK      CMP'
         LINE  ,(1,1),SKIP=3
         ROUTINE    A1LL,ROUT1
       LABEL  'LL'
         LINE  ,(19,1),SKIP=1
       LABEL  'M/F FRAME A2 STORAGE CONTROL UNIT'
         LINE  ,(9,1)
       LABEL  'SS  MS AD ID    S/S            ST IN RSET'
         LINE
       LABEL  'ST  0  1  2     4  5           KY KY REF'
         LINE  ,(1,1)
         ROUTINE    A2LB,ROUT1
       LABEL  'LB'
         LINE  ,(4,32)
       LABEL  'ADV FXC INV X KY BI RE','INC      INH OUTKY REG BIT FT  X
               R  C'
         LINE
       LABEL  '0  1  2 RQ RQ RQ RQ RQ','DBROA1OA2ADV P  0  1  2  3 PR  X
               F  H'
         LINE  ,(1,1)
         ROUTINE    A2LC,ROUT1
       LABEL  'LC'
         LINE  ,(12,1)
       LABEL  'REM XL IA IA     OA1           OA2       MAINT REQ'
         LINE
       LABEL  'INV RD B  A  FT ST TS ST    FT ST TS ST    ST FT'
         LINE  ,(1,1)
         ROUTINE    A2LD,ROUT1
       LABEL  'LD'
         LINE  ,(18,1)
       LABEL  'OA2IAAIAAIAAIABIAB   INHIBIT        INH MNT'
         LINE
       LABEL  'OA1IABOA1OA2OA1OA2   OA1OA2IAAIAB   ST  FTH'
         LINE  ,(1,1)
         ROUTINE    A2LE,ROUT1
       LABEL  'LE'
         LINE  ,(27,1)
       LABEL  'SNGFAR RQ    INCR FAR   PRIOR BLK FTH'
         LINE
       LABEL  'FTHBSY TR   27 28  P    FAR    0  1'
         LINE  ,(1,1)
         ROUTINE    A2LF,ROUT1
       LABEL  'LF'
         LINE  ,(9,1)
       LABEL  'MAIN A/D    ADD   STAR1 STAR2'
         LINE  ,(9,1)
       LABEL  'DELADDCYC   CMP   RQ BSYRQ BSY'
         LINE  ,(1,1)
         ROUTINE    A2LG,ROUT1
       LABEL  'LG'
         LINE  ,(6,37)
         ROUTINE XDUM2,CHK1683                                 @Z02774
       LABEL  'REPL ALG 16K','RET LATCH C40  ADDR BUS   RET'
         LINE
       LABEL  '0/41/52/63/7','1  2  3  4  5  6  7  8  9 TRG'
         LINE  ,(1,1)
         ROUTINE    A2LH,ROUT1
       LABEL  'LH'
         LINE  ,(6,27)
       LABEL  'REPLACE ALGOR','BFR INST RETAIN LTCH C40 MARK BUS  BYP'
         LINE
       LABEL  '0/10/20/31/21/32/3','8K 16K    P  0  1  2  3  4  5  6  7X
                LTH'
         LINE  ,(1,1)
         ROUTINE    A2LJ,ROUT1
       LABEL  'LJ'
         LINE  ,(9,1)
       LABEL  'SCU CTL8  16 24      BFR CTL         BDBO CHK TRGR BYTE'
LN68     LINE  ,(9,1)                                          @Z02774
LAB68   LABEL 'S/SADR 15 23 28      SCU AD MK       0  1  2  3  4  5  6X
                 7'
         LINE  ,(1,1)
         ROUTINE    A2LK,ROUT1
       LABEL  'LK'
         LINE  ,(9,22)
       LABEL  'HNG','BLKMPLREP'
         LINE
       LABEL  'DET','CMPCMPARY'
         LINE  ,(1,1),SKIP=3
         ROUTINE    A2LL,ROUT1
       LABEL  'LL'
         LINE  ,(19,1),SKIP=1
       LABEL  'M/F FRAME A3 PSW AND INTERRUPTS'
         LINE  ,(4,1)
       LABEL  '    /     SYSTEM MASK     / PSW PARITY / PSW 12-15 /    X
                      LSAL 1'
         LINE  ,(4,1)
       LABEL  'P  0  1  2  3  4  5 IO EXT P1 P2 P3 P4 EC M  W  P       X
                   0  1  2  3'
         LINE  ,(1,1)
         ROUTINE    A3LB,ROUT1
       LABEL  'LB'
         LINE  ,(10,1)
       LABEL  'ILC   STORAGE KEY C-C FXO DO UF SG PR                   X
                LSAL 2'
         LINE  ,(10,1)
       LABEL  '0  1  0  1  2  3  0  1 36 37 38 39 BIT                0 X
                1  2  3'
         LINE  ,(1,1)
         ROUTINE    A3LC,ROUT1
       LABEL  'LC'
         LINE  ,(67,1)
       LABEL  'LSAL 3'
         LINE  ,(64,1)
       LABEL  '0  1  2  3'
         LINE  ,(1,1)
         ROUTINE    A3LD,ROUT1
       LABEL  'LD'
         LINE  ,(22,1)
       LABEL  'PROGRAM INTERRUPT CODE PE MC               LSAL 4'
         LINE  ,(45,1)
       LABEL  '08 09 10 11        0  1  2  3'
         LINE  ,(1,1)
         ROUTINE    A3LE,ROUT1
       LABEL  'LE'
         LINE  ,(7,1)
       LABEL  'I/O INTRPT CHANNEL                   PGM INTPT CODE     X
                   LSAL 5'
         LINE  ,(4,1)
       LABEL  '0  1  2  3  4  5  6  7  8  9  A  B       12 13 14 15    X
                   0  1  2  3'
         LINE  ,(1,1)
         ROUTINE    A3LF,ROUT1
       LABEL  'LF'
         LINE  ,(4,1)
       LABEL  'TM / EXTERNAL INTERRUPTS /            /INTERRUPTS / SUP X
                     LSAL'
         LINE
       LABEL  'UP T  S  2  3  4  5  6  7             MK SV PG IO EX TRMX
                    GPRFL PR'
         LINE  ,(1,1)
         ROUTINE    A3LG,ROUT1
       LABEL  'LG'
         LINE  ,(18,1)
       LABEL  'IRPTS                   PER CODE ALTER'
         LINE  (3,1),(18,1)
         ROUTINE    XCPUMOD,CKMOD
       LABEL  'CLKTMR                     SB IF ST GPR'
         LINE  (1,1),(1,1),SKIP=3
         ROUTINE    A3LH,ROUT1
       LABEL  'LH'
         LINE  ,(1,1),SKIP=3
       LABEL  'LJ'
         LINE  ,(1,1),SKIP=3
       LABEL  'LK'
         LINE  ,(1,1),SKIP=3
       LABEL  'LL'
         LINE  ,(19,1),SKIP=1
       LABEL  'M/F FRAME A4 CONTROL STORAGE'
       LINE  ,(22,1)
       LABEL  'CONTROL STORE BITS  P 0-35,0-21'
         LINE  ,(4,1)
       LABEL  'P  1  2  3  4  5  6  7  8  9 10 11 12 13 14 15 16 17 18 X
               19 20 21'
         LINE  ,(1,1)
         ROUTINE    A4LB,ROUT1
       LABEL  'LB'
         LINE  ,(22,47)
       LABEL  'CONTROL STORE BITS P37-71,22-43','WRT OP'       @YM6450P
         LINE  ,(3,1)
       LABEL  '22 23 24 25 26 27 28 29 30 31 32 33 34 35  P 37 38 39 40X
                 41 42 43 WCS BR'
         LINE  ,(1,1)
         ROUTINE    A4LC,ROUT1
       LABEL  'LC'
         LINE  ,(22,50)
       LABEL  'CONTROL STORE BITS 44-67','EOP'
         LINE  ,(3,1)
       LABEL  '44 45 46 47 48 49 50 51 52 53 54 55 56 57 58 59 60 61 62X
                63 64 65 66 67'
         LINE  ,(1,1)
         ROUTINE    A4LD,ROUT1
       LABEL  'LD'
         LINE  ,(22,1)
       LABEL  'CONTROL STORE BITS P72-107,68-86'
         LINE  ,(3,1)
       LABEL  '68 69 70 71 107 73 74 75 76 77 78 79 80 81 82 83 84 85 8X
               6'
         LINE  ,(1,1)
         ROUTINE    A4LE,ROUT1
       LABEL  'LE'
         LINE  ,(22,1)
       LABEL  'CONTROL STORAGE BITS 87-107'
         LINE  ,(3,1)
       LABEL  '87 88 89 90 91 92 93 94 95 96 97 98 99 00 01 02 03 04 05X
                06 07'
         LINE  ,(1,1),SKIP=3
         ROUTINE    A4LF,ROUT1
       LABEL  'LF'
         LINE  ,(1,1),SKIP=1
       LABEL  'LG'
         LINE  ,(46,1)
       LABEL  'MARK BUFFER BITS P0-7,0-7'
         LINE  ,(46,1)
       LABEL  'P  0  1  2  3  4  5  6  7'
         LINE  ,(1,1),SKIP=1
         ROUTINE    A4LH,ROUT1
       LABEL  'LH'
         LINE  ,(4,1)
       LABEL  'INSTALLED FEATURES'
         LINE  (22,1),(4,1)
         ROUTINE    XSWS8,CKMP
         ROUTINE   A4LJ,CKPW                                   @XA20541
         ROUTINE   A4LJ,CKEXT                                  @XA20541
         ROUTINE   A4LJ,CKVMA                                  @XA20541
       LABEL  'ONHSMECH 94 80 74'
         LINE  (1,1),(1,1)
         ROUTINE    A4LJ,ROUT1
       LABEL  'LJ'
         LINE  ,(40,1)
       LABEL  'CONTROL STORAGE     INV 0 36 72'
         LINE  ,(60,1)
       LABEL  'WD 35 71 107'
         LINE  ,(1,1),SKIP=3
         ROUTINE    A4LK,ROUT1
       LABEL  'LK'
         LINE  ,(1,1),SKIP=3
       LABEL  'LL'
         LINE  ,(19,1),SKIP=1
       LABEL  'M/F FRAME A5 ADDERS AND CHECKS'
         LINE  ,(7,1)
       LABEL  'STATUS TRIGGERS     MVC      SHIFTER INBUS CONTROLS     X
                 WIA WIB'
         LINE  ,(4,1)
       LABEL  'A  B  C  D  E  F  G  H     AREG-BYTES  BREG-BYTES  DREG X
               3SI   WA WB'
         LINE  ,(1,1)
         ROUTINE    A5LB,ROUT1
       LABEL  'LB'
         LINE  ,(3,1)
       LABEL  'QUO         SA  ACAL SN DB    SHFT AMT STAGE B    STAGE X
               C     STAGE D'
         LINE
       LABEL  'INS61 62 63 DE RT LF AR AR           0  1  2  3  0  4  8X
                12  0 16 32 48'
         LINE  ,(1,1)
         ROUTINE    A5LC,ROUT1
       LABEL  'LC'
         LINE  ,(10,1)
       LABEL  'G REGISTER       SET INS   DV PA /PARALLEL ADDER A SIDE X
               LFTLFT'
         LINE  ,(4,1)
       LABEL  '0  1  2  3  4  5  6  7 TST-SET  TR CMP  CNTRL STOR BITS X
               14-17  1  2'
         LINE  ,(1,1)
         ROUTINE    A5LD,ROUT1
       LABEL  'LD'
         LINE  ,(4,1)
       LABEL  'A COUNTER    B COUNTER    FLT PT ADD    PARALLEL ADDERA X
               SIDE LFT LFT T'
         LINE  ,(4,63)
       LABEL  '0  1  2     0  1  2  3 FA EZ WOC H BLK','1  2  X'
         LINE  ,(1,1)
         ROUTINE    A5LE,ROUT1
       LABEL  'LE'
         LINE  ,(8,1)
       LABEL  'WIA  A REG BYTE                PB          ADDER B SIDE'
         LINE  ,(4,1)
       LABEL  '0  1  2  3  4  5  6  7           0 13 47 L1 L2 L3 DL3 R3X
                DC HC D0'
         LINE  ,(1,1)
         ROUTINE    A5LF,ROUT1
       LABEL  'LF'
         LINE  ,(4,1)
       LABEL  'SER ADDR B REG BYTE(WIB)'
         LINE  ,(4,1)
       LABEL  '0  1  2  3  4  5  6  7'
         LINE  ,(1,1)
         ROUTINE    A5LG,ROUT1
       LABEL  'LG'
         LINE  ,(4,1)
       LABEL  'CHANNEL    CTL  TGRS   UA EX BLKBL GREG  CH LK BRNCH    X
               CH   TOD CPU'
         LINE  ,(3,1)
       LABEL  'SC CNACR RL  0  1  2 LD INV   EOPPA HLD TG   U   S US   X
                EQ RN VLDTMR'
         LINE  ,(1,1),SKIP=3
         ROUTINE    A5LH,ROUT1
       LABEL  'LH'
         LINE  ,(1,1),SKIP=1
       LABEL  'LJ'
         LINE  ,(4,1)
       LABEL  'PAR ADDR HALF SUM(BYTE)/PA/EREG/SERADD/ ADD/ERR/CPU /ENTX
               INV/P0 36 72'
         LINE  ,(4,1)
       LABEL  '0  1  2  3  4  5  6  7 HSW 0  1 HS FS    ER/TODTMRCMPERRX
               WD  35 71 07'
         LINE  ,(1,1)
         ROUTINE    A5LK,ROUT1
       LABEL  'LK'
         LINE  ,(4,1)
       LABEL  'PAR ADDR FULL SUM(BYTE)PA/   SHIFTER OUTPUT BYTES /SHFTEX
               R'
         LINE  ,(3,1)
       LABEL  ' 0  1  2  3  4  5  6  7 CRY 0  1  2  3  4  5  6  7 IN CTX
               L'
         LINE  ,(1,1),SKIP=3
         ROUTINE    A5LL,ROUT1
       LABEL  'LL'
         LINE  ,(19,1),SKIP=1
       LABEL  'M/F FRAME A6  I UNIT A'
         LINE  ,(4,29)
       LABEL  'WRAP TR','START UP  DCDE  BUSY SHF      GATE TO INCR'
         LINE
       LABEL  'E  F  G',' J  K  L  M  N OA1OA2 IO      IAAIABOA1OA2'
         LINE  ,(1,1)
         ROUTINE    A6LB,ROUT1
       LABEL  'LB'
         LINE  ,(4,1)
       LABEL  'IC DC ACTV  IRDY  IEXC  E  INS CNTL T  D  D  STRT LST'
         LINE
       LABEL  'A  A  A  B  L  R  L  R  P  J  K  L  M  S SQ OA1OA2OA1'
         LINE  ,(1,1)
         ROUTINE    A6LC,ROUT1
       LABEL  'LC'
         LINE  ,(4,1)
       LABEL  'Q=1  BSY CONF EMU EXC   I B2 BR SUB WRAP IM  USE  PR  SYX
               N'
         LINE
       LABEL  'INOUT    H  I  T IAAIAB F VL IN EXC A  B PS OA1OA2 D  INX
               S'
         LINE  ,(1,1)
         ROUTINE    A6LD,ROUT1
       LABEL  'LD'
         LINE  ,(4,1)
       LABEL  'Q=2  BSY CONF EMU EXC   I B2 BR SUB WRAP IM  USE  PR    X
                   MODE  TGR'
         LINE
       LABEL  'INOUT    H  I  T IAAIAB F VL IN EXC A  B PS OA1OA2 D    X
                   0  1  2  3'
         LINE  ,(1,1)
         ROUTINE    A6LE,ROUT1
       LABEL  'LE'
         LINE  ,(4,1)
       LABEL  'Q=3  BSY CONF EMU EXC   I B2 BR SUB WRAP IM  USE  PR    X
               BK ENDBR PUTCLK'
         LINE
       LABEL  'INOUT    H  I  T IAAIAB F VL IN EXC A  B PS OA1OA2 D    X
                I OP TK AWYTGR'
         LINE  ,(1,1)
         ROUTINE    A6LF,ROUT1
       LABEL  'LF'
         LINE  ,(4,1)
       LABEL  'Q=4  BSY CONF EMU EXC   I B2 BR SUB WRAP IM  USE  PR'
         LINE
       LABEL  'INOUT    H  I  T IAAIAB F VL IN EXC A  B PS OA1OA2 D'
         LINE  ,(1,1)
         ROUTINE    A6LG,ROUT1
       LABEL  'LG'
         LINE  ,(4,1)
       LABEL  'IN   /  E UNIT  / ILC  HLDS     LSAR 3      LSAR 4      X
                  DIS SDIF ADD'
         LINE
       LABEL  'RDY  BSY H  I  T  4  2  A     0  1  2  3  0  1  2  3    X
                  OVL A  B ERR'
        LINE   ,(1,1),SKIP=3
         ROUTINE    A6LH,ROUT1
       LABEL  'LH'
         LINE  ,(1,1)
       LABEL  'LJ'
        LINE   ,(1,1),SKIP=3
       LABEL  'LK'
        LINE   ,(4,1),SKIP=1
       LABEL  ' INST REG        INCR LTH     DIF     HALF SUM    FULL SX
               UM'
        LINE   ,(4,1)
       LABEL  '7 13 23 31       15 23 31     A  B    15 23 31    15 23 X
               31'
         LINE  ,(1,1),SKIP=3
         ROUTINE    A6LL,ROUT1
       LABEL  'LL'
         LINE  ,(19,1),SKIP=1
       LABEL  'M/F FRAME A7 MAINTENANCE CONTROLS'
         LINE  ,(4,1)
       LABEL  'A AUX/EXCP  B AUX/EXCP  IAA CTL TG  IAB CTL TG  OA1 CTL X
               TG  OA2 CTL TG'
         LINE  ,(4,1)
       LABEL  '0  2  4  6  0  2  4  6  A  B  C  D  A  B  C  D  O  P  Q X
                R  O  P  Q  R'
         LINE  ,(1,1)
         ROUTINE    A7LB,ROUT1
       LABEL  'LB'
         LINE  ,(4,1)
       LABEL  'A MAIN/EXC  B MAIN/EXC  A PT   I T  B PT    I T OA1 CTL X
               TG  OA2 CTL TG'
         LINE  ,(4,1)
       LABEL  '0  2  4  6  0  2  4  6 29 30    IAA29 30    IAB S  T  U X
                V  S  T  U  V'
         LINE  ,(1,1)
         ROUTINE    A7LC,ROUT1
       LABEL  'LC'
         LINE  ,(4,1)
       LABEL  'IAA EXC     IAB EXC     OA1 EXC     OA2 EXC     OA1 CTL X
               TG  OA2 CTL TG'
         LINE  ,(4,1)
       LABEL  '0  1  2     0  1  2     0  1  2     0  1  2     W  X  Y X
                Z  W  X  Y  Z'
         LINE  ,(1,1)
         ROUTINE    A7LD,ROUT1
       LABEL  'LD'
         LINE  ,(18,1)
       LABEL  'MCW REGISTER BITS 0-23 FOR CPU A DIAGNOSE'
         LINE  ,(4,1)
       LABEL  '0  1  2  3  4  5  6  7  8  9 10 11 12 13 14 15 16 17 18 X
               19 20 21 22 23'
         LINE  ,(1,1)
         ROUTINE    A7LE,ROUT1
       LABEL  'LE'
         LINE  ,(18,1)
       LABEL  'MCW REGISTER BITS 0-23 FOR CPU B DIAGNOSE'
         LINE  ,(4,1)
       LABEL  '0  1  2  3  4  5  6  7  8  9 10 11 12 13 14 15 16 17 18 X
               19 20 21 22 23'
         LINE  ,(1,1)
         ROUTINE    A7LF,ROUT1
       LABEL  'LF'
         LINE  ,(4,1)
       LABEL  'MCW REGISTER BITS 0-14 FOR CHANNEL DIAGNOSE'
         LINE  ,(4,1)
       LABEL  '0  1  2  3  4  5  6  7  8  9 10 11 12 13 14'
         LINE  ,(1,1)
         ROUTINE    A7LG,ROUT1
       LABEL  'LG'
         LINE  ,(10,1)
       LABEL  'MCW REGISTER BITS 24-39 FOR CPU A'
         LINE  ,(4,1)
       LABEL  '24 25 26 27 28 29 30 31 32 33 34 35 36 37 38 39'
         LINE  ,(1,1)
         ROUTINE    A7LH,ROUT1
       LABEL  'LH'
         LINE  ,(10,1)
       LABEL  'MCW REGISTER BITS 24-39 FOR CPU B'
         LINE  ,(4,1)
       LABEL  '24 25 26 27 28 29 30 31 32 33 34 35 36 37 38 39'
         LINE  ,(1,1)
         ROUTINE    A7LJ,ROUT1
       LABEL  'LJ'
         LINE  ,(23,1)
       LABEL  'CPU MAINTENANCE CONTROL (BITS 40-63)'
         LINE  ,(4,1)
       LABEL  '40 41 42 43 44 45 46 47 48 49 50 51 52 53 54 55 56 57 58X
                59 60 61 62 63'
         LINE  ,(1,1),SKIP=3
         ROUTINE    A7LK,ROUT1
       LABEL  'LK'
         LINE  ,(1,1),SKIP=3
       LABEL  'LL'
         DC    X'FE'                                             S21021
         DC    CL8'IFCEE165'
LN683   LINE  ,(6,29)                                          @Z02774
LAB683  LABEL 'REPL ALGORITHM','2KP     RET LATCH BFR  ADDR BUS   RET'
        LINE  ,                                                @Z02774
        LABEL '0/41/52/63/7','DET  0  1  2  3  4  5  6  7  8  9 TRG'
        LINE  ,(1,1)                                           @Z02774
        ROUTINE A2LH,ROUT1                                     @Z02774
        LABEL 'LH'                                             @Z02774
        LINE  ,(6,37)                                          @Z02774
        LABEL 'REPL ALGORITHM','RETAIN LTCH BFR MARK BUS  BYP' @Z02774
        LINE  ,                                                @Z02774
        LABEL '0/10/20/31/21/32/3','P  0  1  2  3  4  5  6  7 LTH'
        LINE  ,(1,1)                                           @Z02774
        ROUTINE A2LJ,ROUT1                                     @Z02774
        LABEL 'LJ'                                             @Z02774
        LINE  ,(9,1)                                           @Z02774
        LABEL 'SCU CTL8  16 24      BFRBFRBFR       BDBO CHK TRGR BYTE'
        LINE  ,                                                @Z02774
        ROUTINE XDUM2,DID1683                                  @Z02774
        LABEL  '  '                                            @Z02774
LABLAREA EQU   *
         LSTART
         END
