       TITLE   'IFCEE165 MODEL 165 CPU EDIT TABLE 3'
*  DSGEN MACRO     DSGEN MACRO     DSGEN MACRO     DSGEN MACRO        *
         SPACE 2
         MACRO
&NAME    DSGEN
.*                            THIS MACRO GENERATES ONE DSECT WORD
.*                                 FORMATTED FOR THE SUBJECT LOG RECORD
.*                                 EACH OPERAND HAS TWO SUB LISTS. THE
.*                                 FIRST IS THE NAME OF THE LOG ITEM
.*                                 WHILE THE SECOND IS THE # OF BITS TO
.*                                 ALLOCATE FOR THIS ITEM. ITEMS MUST
.*                                 BE DEFINED CONTIGUOUSLY WITHOUT GAPS
.*                                 UNUSED BIT GROUPS MUST BE GIVEN
.*                                 DUMMY NAMES. THE NAMES PROVIDED FOR
.*                                 THE LOG ITEMS MAY THEN BE USED IN
.*                                 THE CONVERSION MACRO INSTRUCTIONS.
         GBLC &ITEM(2000)
         GBLA &ITEMNBR,&BITS(2000),&SHIFT(2000)
         LCLB  &ONLY1,&CTIND
         LCLA  &START1,&START2,&END1,&END2
         LCLC  &SYMBOL,&EQUSYM
         LCLA  &OP,&COUNT,&BYTE,&EQUCNT
         ACTR  100000
.START   AIF   (N'&SYSLIST(&OP+1) LT 3).LOOP
         AIF   ('&SYSLIST(&OP+1,3)' EQ 'EQU').LOOP     TEST FOR EQU
  AIF   ('&SYSLIST(&OP+1,3)' EQ '' OR '&SYSLIST(&OP+1,4)' EQ '').ERR1
         AIF   ('&SYSLIST(&OP+1,3)' GT '&SYSLIST(&OP+1,4)').ERR3
&START1  SETA  &SYSLIST(&OP+1,3)        GET START COUNT OF 1
&START2  SETA  &SYSLIST(&OP+1,4)        GET FIRST END COUNT
         AGO   .SET2A                   BRANCH AROUND
.ERR1    MNOTE '**FIRST SYMBOL CONCATENATION INCOMPLETE**'
         MEXIT
.SET2A   AIF   ('&SYSLIST(&OP+1,5)' EQ ''AND '&SYSLIST(&OP+1,6)' EQ '' X
               ).SET2                   TEST FOR NO SECOND
  AIF   ('&SYSLIST(&OP+1,5)' EQ '' OR '&SYSLIST(&OP+1,6)' EQ '').ERR2
         AIF   ('&SYSLIST(&OP+1,5)' GT '&SYSLIST(&OP+1,6)').ERR3
&END1    SETA  &SYSLIST(&OP+1,5)        GET START COUNT OF 2
&END2    SETA  &SYSLIST(&OP+1,6)        GET END COUNT OF 2
         AGO   .LOOP
.SET2    ANOP
&ONLY1   SETB  1                        INDICATE ONLY ONE CONCATENATION
         AGO   .LOOP
.ERR2    MNOTE '**SECOND SYMBOL CONCATENATION INCOMPLETE**'
         MEXIT
.ERR3    MNOTE '**START GREATER THAN END CONCATENATION**'
         MEXIT
.LOOP    ANOP
&OP      SETA  &OP+1
         AIF   (&OP GT N'&SYSLIST).DONE      TEST IF ALL DONE
&ITEMNBR SETA  &ITEMNBR+1
         AIF   ('&SYSLIST(&OP,2)' NE '').OK1
         MNOTE '**NULL BIT COUNT FIELD**'
         MEXIT
.OK1     ANOP
&SYMBOL  SETC  '&SYSLIST(&OP,1)'
         AIF   ('&SYMBOL' NE '').OK
*              *****     LOG ITEM SYMBOL NOT PROVIDED     *****
         AIF   ('&SYSLIST(&OP,3)' NE 'EQU').CNT
         AGO   .START                   GET NEXT
.OK      AIF   (N'&SYSLIST(&OP) LT 3).NO3    TEST FOR OLD FORMAT
         AIF   ('&SYSLIST(&OP,3)' EQ 'EQU').EQU   TEST FOR EQU
         AIF   (&ONLY1).OK2             TEST FOR ONLY ONE CONCAT
&SYMBOL  SETC  '&SYMBOL.&START1.&END1'       GET 1 AND 2 CONCAT
         AGO   .NO3                     BRANCH AROUND
.OK2     ANOP
&SYMBOL  SETC  '&SYMBOL.&START1'        GET 1 CONCATENATED
.NO3     ANOP
&SYMBOL  EQU   *+&BYTE
&ITEM(&ITEMNBR) SETC '&SYMBOL'          GET LABEL IN GLOBAL
&BITS(&ITEMNBR) SETA &SYSLIST(&OP,2)
&SHIFT(&ITEMNBR) SETA &COUNT-&BYTE*8
.CNT     ANOP
&CTIND   SETB  1                        SET COUNT INDICATOR
&COUNT   SETA  &COUNT+&SYSLIST(&OP,2)
&BYTE    SETA  &COUNT/8
         AIF   (N'&SYSLIST(&OP) LT 3).START  TEST FOR OLD FORMAT
         AIF   (&ONLY1).TSTST           TEST FOR ONLY ONE CONCAT
         AIF   (&END1 EQ &END2).TSTST   TEST FOR SECOND END
&END1    SETA  &END1+1                  INCREMENT COUNT
&OP      SETA  &OP-1                    DECREMENT INCREMENT
         AGO   .LOOP                    GENERATE NEXT
.TSTST   ANOP
         AIF   (&START1 EQ &START2).LPDONE   TEST FOR END
         AIF   (&ONLY1).NSET1           TEST FOR ONLY ONE CONCAT
&END1    SETA  &SYSLIST(&OP,5)          RE-INIT SECOND START COUNT
.NSET1   ANOP
&OP      SETA  &OP-1                    DECREMENT INDEX
&START1  SETA  &START1+1                INCREMENT FIRST COUNT
         AGO   .LOOP                    GO DO NEXT
.LPDONE  ANOP
&ONLY1   SETB  0                        CLEAR INDICATOR
         AGO   .START                   GO TEST FOR MORE SUB-LISTS
.DONE    AIF   (&COUNT-&COUNT/8*8 NE 0).ERR  TEST FOR MULTIPLE OF EIGHT
         AIF   (&CTIND EQ 0).END        NO DS IF NO COUNT
&COUNT   SETA  &COUNT/8                 GET NUMBER OF BYTES
&NAME    DS    &COUNT.C
.END     MEXIT
.ERR     MNOTE '**BIT COUNT FLDS DO NOT TOTAL MULTIPLE OF 8**'
         MEXIT
.EQU     AIF   ('&SYSLIST(&OP,4)' NE '').EQU1     TEST FOR NULL LABEL
.ERR4    MNOTE '**EQU OPERAND OMITTED OR NOT FOUND**'
         MEXIT
.EQU1    AIF   (&SYSLIST(&OP,2) LT 16).EQU2  COUNT OVER FIFTEEN
*****               THE FOLLOWING STATEMENT                *****
*****     NUMBER OF BITS EXCEED 15 - DO NOT USE AS BIN     *****
.EQU2    ANOP
&EQUCNT  SETA  0                        CLEAR COUNTER
&EQUSYM  SETC  '&SYSLIST(&OP,4)'        GET EQU OPERAND
.EQULOP  ANOP
&EQUCNT  SETA  &EQUCNT+1                INCREMENT INDEX
         AIF   ('&ITEM(&EQUCNT)' EQ '&EQUSYM').EQUOUT  LABEL FOUND?
         AIF   (&EQUCNT EQ &ITEMNBR).ERR4    ALL TESTED?
         AGO   .EQULOP                  NO-GET NEXT
.EQUOUT  ANOP
&ITEM(&ITEMNBR) SETC '&SYMBOL'          GET LABEL NAME
&BITS(&ITEMNBR) SETA &SYSLIST(&OP,2)    GET NUMBER OF BITS
&SHIFT(&ITEMNBR) SETA &SHIFT(&EQUCNT)   GET SHIFT COUNT
&SYMBOL  EQU   &EQUSYM                  THIS SYMBOL EQUATED
         AGO   .START                   RETURN FOR NEXT
         MEND
         MACRO
         LINEND
.*                            THIS MACRO IS USED ONLY BY THE LINE
.*                                 MACRO TO SET THE NUMBER OF ENTRIES
.*                                 ASSOCIATED WITH EACH LINE.
         GBLA  &NRENTS
         GBLC &NRENTSX
         AIF   (&NRENTS EQ 0).NORENTS   TEST FOR NO COUNT
         ORG   &NRENTSX
         DC    FL1'&NRENTS'
         ORG
&NRENTS  SETA  0
.NORENTS ANOP
B&SYSNDX EQU   *
&NRENTSX SETC  'B&SYSNDX'
         MEND
*
         MACRO
         BIN
.*                                 &SYSLIST(&OP,1) - NAME OF LOG ITEM
.*                                      RECORD DSECT
.*                                 $SYSLIST(&OP,2) - NBR OF SPACES
.*                                      TO SKIP ON MULTIPLE
.*                                      PRINT OR NBR OF SPACES
.*                                      TO BACK UP FROM COLUMN FOR
.*                                      START OF PRINTING. THE LETTER
.*                                      B PRECEEDS THE NUMBER (B5) IF
.*                                      THE LATTER IS DESIRED. OMISSION
.*                                      OF THIS OPERAND FORCES OPTION 2
.*                                      WITH BACKUP SPACING EQUAL TO
.*                                 THE NUMBER OF BITS IN THE ITEM
.*                                 DEFINITION (VIA MACRO 'DSGEN').
.*                            A LIMIT OF 15 BITS IS IMPOSED FOR THE
.*                                 TOTAL NUMBER OF BITS TO PRINT.
         GBLA  &INITIAL
         GBLB  &DIAGTST,&DIAGSET,&DIAGLIN
         GBLC &ITEM(2000)
         GBLA &ITEMNBR,&BITS(2000),&SHIFT(2000),&NRENTS
         GBLC  &DSECT
         LCLB  &B,&SUB
         LCLA  &IBITS,&NDX,&ISHIFT,&K
         LCLA  &TEMP,&T,&OP
         LCLC  &S
         AIF   (&DIAGTST EQ 0).NOMSG
         AIF   (&INITIAL EQ 0).NOMSG
         AIF   (&DIAGLIN EQ 1).NOMSG
         MNOTE '**NO LINE ASSOCIATED WITH THIS DATA**'
*****THE FOLLOWING GENERATED FOR TEST PURPOSES*****
*        LINE
         LINE
.NOMSG   ANOP
         AIF   (K'&SYSLIST(1) EQ K'&SYSLIST(1,1)).LOOP
&SUB     SETB  1
.LOOP    ANOP
&OP      SETA  &OP+1
.LOOP1   ANOP
&NDX     SETA  &NDX+1
         AIF   ('&ITEM(&NDX)' EQ '&SYSLIST(&OP,1)').FOUND
         AIF   (&NDX LT &ITEMNBR).LOOP1
         MNOTE '**LOG ITEM NOT DEFINED**'
         MEXIT
.FOUND   ANOP
&ISHIFT  SETA  &SHIFT(&NDX)
&IBITS   SETA  &BITS(&NDX)
&T       SETA  &IBITS-1
&B       SETB  0
         AIF   (&IBITS GT 0 AND &IBITS LT 16).SUB0
         MNOTE '**NO. OF BITS OUTSIDE RANGE OF 1-15**'
         MEXIT
.SUB0    AIF   (&SUB EQ 1).SUBA
         AIF   ('&SYSLIST(2)' EQ '').BACKUP
&K       SETA  K'&SYSLIST(2)
&B       SETB  ('&SYSLIST(2)'(1,1) EQ 'B')
&S       SETC  '&SYSLIST(2)'(&B+1,&K-&B)
         AGO   .SUBB
.SUBA    ANOP
         AIF   ('&SYSLIST(&OP,2)' EQ '').BACKUP
&K       SETA  K'&SYSLIST(&OP,2)
&B       SETB  ('&SYSLIST(&OP,2)'(1,1) EQ 'B')
&S       SETC  '&SYSLIST(&OP,2)'(&B+1,&K-&B)
.SUBB    ANOP
&T       SETA  &S
.BACKUP  ANOP
&NRENTS  SETA  &NRENTS+1
&TEMP    SETA  &ISHIFT
         AIF   (&IBITS NE 1 OR &B NE 0).BIN2
         DC    AL.12(&SYSLIST(&OP,1)-&DSECT),XL.4'&TEMP'
         AGO   .OUT
.BIN2    AIF   ('&SYSLIST(&OP,2)' NE '').BIN3
&B       SETB  1
.BIN3    ANOP
         DC    AL.12(&SYSLIST(&OP,1)-&DSECT),XL.4'C'
         DC    BL.1'&B',AL.7(&T),AL.4(&IBITS),FL.4'&ISHIFT'
.OUT     ANOP
&NDX     SETA  0
         AIF   (&SUB EQ 0).OUTA
         AIF   (&OP LT N'&SYSLIST).LOOP
.OUTA    ANOP
         MEND
         MACRO
         HEX
.*                            THIS MACRO FACILITATES GENERATION OF THE
.*                                 TABLE ENTRIES SPECIFYING HEX TYPE
.*                                 CONVERSIONS.
.*                            &SYSLIST(&OP,1) - NAME OF DATA ITEM TO BE
.*                                 CONVERTED
.*                            &SYSLIST(&OP,2) - # OF SPACES TO SKIP ON
.*                                 MULTIPLE PRINT OR NBR OF SPACES TO
.*                                 BACK UP FROM COLUMN FOR START OF
.*                                 PRINTING. THE LETTER B PRECEEDS THE
.*                                 NUMBER (B8) IF THE LATTER OPTION IS
.*                                 DESIRED. OMISSION OF THIS OPERAND
.*                                 FORCES OPTION 2 WITH BACKUP SPACING
.*                                 EQUAL TO THE NUMBER OF BYTES SPECI-
.*                                 FIED BY THE NEXT OPERAND (TWICE THIS
.*                                 NUMBER IF SUFFIX IS EXPLICITLY OR
.*                                 IMPLICITLY B).
.*                            &SYSLIST(&OP,3) - NUMBER OF BYTES TO
.*                                 PROCESS. THIS NUMBER IS SUFFIXED
.*                                 WITH AN L,R, OR B TO STIPULATE
.*                                 PRINTING OF THE LEFT HALF, RIGHT
.*                                 HALF, OR BOTH HALVES OF THE BYTE
.*                                 RESPECTIVELY. OMISSION OF THIS
.*                                 OPERAND DEFAULTS TO B WITH THE NUM-
.*                                 BER OF BYTES EQUAL TO THE ITEM LNGTH
.*                            A NEW ENTRY IS GENERATED ONLY WHEN NECES-
.*                                 SARY. THIS MACRO MUST BE THE FIRST
.*                                 MACRO INSTRUCTION ISSUED FOR THE
.*                                 SUBJECT LINE(S).
         GBLC &ITEM(2000),&DSECT
         GBLA &ITEMNBR,&BITS(2000),&SHIFT(2000),&NRENTS
         GBLA  &INITIAL
         GBLB  &DIAGTST,&DIAGSET,&DIAGLIN
         LCLB  &B,&SUB
         LCLA  &IBITS,&NDX,&ISHIFT,&K,&T,&CODE,&BYTESP,&OP
         LCLC  &S,&LETTER
         AIF   (&DIAGTST EQ 0).NOMSG
         AIF   (&INITIAL EQ 0).NOMSG
         AIF   (&DIAGLIN EQ 1).NOMSG
         MNOTE '**NO LINE ASSOCIATED WITH THIS DATA**'
*****THE FOLLOWING GENERATED FOR TEST PURPOSES*****
*        LINE
         LINE
.NOMSG   ANOP
         AIF   (K'&SYSLIST(1) EQ K'&SYSLIST(1,1)).LOOP
&SUB     SETB  1
.LOOP    ANOP
&OP      SETA  &OP+1
.LOOP1   ANOP
&NDX     SETA  &NDX+1
         AIF   ('&ITEM(&NDX)' EQ '&SYSLIST(&OP,1)').FOUND
         AIF   (&NDX LT &ITEMNBR).LOOP1
         MNOTE '**LOG ITEM NOT DEFINED**'
         MEXIT
.FOUND   ANOP
&ISHIFT  SETA  &SHIFT(&NDX)
&IBITS   SETA  &BITS(&NDX)
         AIF   (&ISHIFT EQ 0 OR &ISHIFT EQ 4).ALIGN
.ERR     MNOTE '**DATA NOT ALLIGNED ON HEX OR BYTE BOUNDARY**'
         MEXIT
.ALIGN   ANOP
&CODE    SETA  1
         AIF   (&SUB EQ 1).SUBA
&K       SETA  K'&SYSLIST(3)
         AGO   .SUBB
.SUBA    ANOP
&K       SETA  K'&SYSLIST(&OP,3)
.SUBB    ANOP
         AIF   (&IBITS-(&IBITS/4)*4 EQ 0).OK
         MNOTE '**BIT LENGTH SPECIFICATION INCONSISTENT WITH CONTROL**'
         MEXIT
.OK      AIF   (&SUB EQ 1).SUBC
         AIF   ('&SYSLIST(3)' EQ '').USEDEFN
&LETTER  SETC  '&SYSLIST(3)'(&K,1)
&S       SETC  '&SYSLIST(3)'(1,&K-1)
         AGO   .SUBD
.SUBC    ANOP
         AIF   ('&SYSLIST(&OP,3)' EQ '').USEDEFN
&LETTER  SETC  '&SYSLIST(&OP,3)'(&K,1)
&S       SETC  '&SYSLIST(&OP,3)'(1,&K-1)
.SUBD    ANOP
&BYTESP  SETA  &S
         AIF   ('&LETTER' EQ 'B').BOTH
         AIF   ('&LETTER' EQ 'L').LEFT
&CODE    SETA  2
         AGO   .L
.LEFT    ANOP
&CODE    SETA  1
         AGO   .L
.USEDEFN ANOP
&BYTESP  SETA  &IBITS/8
.BOTH    AIF   (&ISHIFT NE 0).ERR
&CODE    SETA  3
&T       SETA  &BYTESP*2-1
&S       SETC  '&T'
.OK2     AIF   (&ISHIFT EQ 0).L
&CODE    SETA  2
.L       ANOP
&B       SETB  1
         AIF   (&SUB EQ 1).SUBE
         AIF   ('&SYSLIST(2)' EQ '').BACKUP
&K       SETA  K'&SYSLIST(2)
&B       SETB  ('&SYSLIST(2)'(1,1) EQ 'B')
&S       SETC  '&SYSLIST(2)'(&B+1,&K-&B)
         AGO   .SUBF
.SUBE    ANOP
         AIF   ('&SYSLIST(&OP,2)' EQ '').BACKUP
&K       SETA  K'&SYSLIST(&OP,2)
&B       SETB  ('&SYSLIST(&OP,2)'(1,1) EQ 'B')
&S       SETC  '&SYSLIST(&OP,2)'(&B+1,&K-&B)
.SUBF    ANOP
.BACKUP  ANOP
&NRENTS  SETA  &NRENTS+1
         AIF   (&BYTESP GT 0 AND &BYTESP LT 16).SUB0
         MNOTE '**NO. OF BYTES OUTSIDE RANGE OF 1-15**'
         MEXIT
.SUB0    AIF   (&SUB EQ 1).SUBG
         DC    AL.12(&SYSLIST(1)-&DSECT),XL.4'A'
         AGO   .SUBH
.SUBG    ANOP
         DC    AL.12(&SYSLIST(&OP,1)-&DSECT),XL.4'A'
.SUBH    ANOP
         DC    BL.1'&B',FL.7'&S',AL.4(&BYTESP),FL.4'&CODE'
.OUT     ANOP
&NDX     SETA  0
         AIF   (&SUB EQ 0).OUTA
         AIF   (&OP LT N'&SYSLIST).LOOP
.OUTA    ANOP
         MEND
         MACRO
         LSTART
.*                            THIS MACRO IS ISSUED WHEN THE LABEL AREA
.*                                 OF THE TABLE IS TO BEGIN.
         GBLA  &LABELNR
         GBLC  &LBL(100)
         GBLC &LABELS(2000)
         GBLA  &LBLCTR(100)
         GBLB  &DIAGTST,&DIAGSET,&DIAGLIN
         LCLA  &NDX,&CTR
         AIF   (&DIAGTST EQ 0).NODIAG
         AIF   (&DIAGSET EQ 0).NODIAG
         MNOTE '**NO LABEL ASSOCIATED WITH LAST SET**'
***** THE FOLLOWING GENERATED FOR TEST PURPOSES *****
*        LABEL '%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%'
               LABEL '%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%'
.NODIAG  ANOP
         LINEND
&CTR     SETA  1
.LOOP    ANOP
&NDX     SETA  &NDX+1
         AIF   (&LBLCTR(&CTR) NE &NDX).NOLBL
&LBL(&CTR) DC  C'&LABELS(&NDX)'
&CTR     SETA  &CTR+1
         AGO   .LOOPCTL
.NOLBL   ANOP
         DC    C'&LABELS(&NDX)'
.LOOPCTL AIF   (&NDX LT &LABELNR).LOOP
         MEND
         MACRO
&NAME    LABEL &LABEL1,&LABEL2,&LABEL3,&LABEL4,&LABEL5,&LABEL6,        C
               &LABEL7,&LABEL8
.*                                 THIS MACRO ALLOWS LABELS TO
.*                                 BE SPECIFIED FOR A GIVEN LINE. THE
.*                                 LABELS SHOULD BE ENCLOSED IN QUOTA-
.*                                 TION MARKS. THE COLUMN AND LINE END
.*                                 CONTROLS WILL BE INSERTED BY THE
.*                                 MACRO. OMITTED OPERANDS MEAN NO
.*                                 LABEL REQUIRED FOR RESPECTIVE
.*                                 COLUMN.
         GBLC &LABELS(2000)
         GBLC  &LBL(100)
         GBLA  &LBLCTR(100)
         GBLA  &LABELNR
         GBLA  &NRENTS,&LPTR,&INITIAL
         GBLB  &DIAGTST,&DIAGSET,&DIAGLIN
         LCLC  &MARGIN,&TACK
         LCLC  &TEXT
         LCLA  &OP,&K,&START,&NRCHAR,&REMAIN
         AIF   (&INITIAL EQ 0).DIAGCLR
         AIF   (&DIAGTST EQ 0).DIAGCLR
         AIF   (&DIAGLIN EQ 1).DIAGCLR
         MNOTE '**NO LINE ASSOCIATED WITH PREVIOUS LABEL**'
***** THE FOLLOWING GENERATED FOR TEST PURPOSES *****
*        LINE
         LINE
.DIAGCLR ANOP
&DIAGSET SETB  0
&DIAGLIN SETB  0
&MARGIN  SETC  '*'
         AIF   ('&NAME' EQ '').LOOPOUT
&LPTR    SETA  &LPTR+1
&LBL(&LPTR) SETC '&NAME'
&LBLCTR(&LPTR) SETA &LABELNR+1
.LOOPOUT ANOP
&OP      SETA  &OP+1
&K       SETA  K'&SYSLIST(&OP)
         AIF (&K GE 2).NORM
&K       SETA  2
.NORM    ANOP
&START   SETA  2
         AIF (&OP LT N'&SYSLIST).NOTLAST
&MARGIN  SETC  '$'
.NOTLAST ANOP
&NRCHAR  SETA  8
&TACK    SETC  ''
.LOOPIN  ANOP
&REMAIN  SETA  &K-&START
         AIF (&REMAIN GE 8).MORE
&TACK    SETC  '&MARGIN'
&NRCHAR  SETA  &REMAIN
.MORE    ANOP
&TEXT    SETC  ''
         AIF (&REMAIN EQ 0).ENDTEXT
&TEXT    SETC  '&SYSLIST(&OP)'(&START,&NRCHAR)
.ENDTEXT ANOP
&LABELNR SETA  &LABELNR+1
&LABELS(&LABELNR) SETC '&TEXT'.'&TACK'
&START   SETA  &START+8
         AIF ('&TACK' EQ '').LOOPIN
         AIF ('&TACK' EQ '*').LOOPOUT
         MEND
         MACRO
&NAME    ROUTINE &LOGITEM,&RNAME
         GBLA  &NRENTS
         GBLC  &DSECT,&CSECT
         GBLA  &INITIAL
         GBLB  &DIAGTST,&DIAGSET,&DIAGLIN
         AIF   (&DIAGTST EQ 0).NOMSG
         AIF   (&INITIAL EQ 0).NOMSG
         AIF   (&DIAGLIN EQ 1).NOMSG
         MNOTE '**NO LINE ASSOCIATED WITH THIS ROUTINE**'
*****THE FOLLOWING GENERATED FOR TEST PURPOSES*****
*        LINE
         LINE
.NOMSG   ANOP
&NAME    DC    AL.12(&LOGITEM-&DSECT),XL.4'D'
         DC    AL2(&RNAME-&CSECT)
&NRENTS  SETA  &NRENTS+1
         MEND
         MACRO
&NAME    LINE  &DATA,&LABEL,&SKIP=
.*                            THIS MACRO ESTABLISHES THE MARGINS OR
.*                                 COLUMN SETTINGS FOR EACH LINE. IT
.*                                 GENERATES NECESSARY CARRIAGE CONTROL
.*                                 ENTRIES. LASTLY IT DETERMINES THE
.*                                 NUMBER OF ENTRIES ASSOCIATED WITH
.*                                 THE PREVIOUS LINE AND STORES THAT #
.*                                 INTO THE APPROPRIATE BYTE.
.*                            &DATA(1) - CHARACTER POSITION TO BEGIN
.*                                 DATA.
.*                            &DATA(2) - # OF SPACES BETWEEN SUCCESSIVE
.*                                 DATA COLUMN STARTING CHARACTERS.
.*                            &LABEL(1) - CHAR. POS. TO BEGIN LABELS.
.*                            &LABEL(2) - # SPACES BETWEEN LINE'S LABEL
.*                                 STARTING CHARACTERS.
.*                            &SKIP= - # OF LINES TO ADVANCE CARRIAGE
.*                                 TO BEGIN NEXT PRINTED LINE.
.*                            NEW ENTRIES ARE GENERATED ONLY WHEN
.*                                 NECESSARY. OMISSION OF ITEMS MEANS
.*                                 THEY HAVE NOT CHANGED SINCE PREVIOUS
.*                                 SETTINGS. A LINE MACRO IS REQUIRED
.*                                 FOR EACH PRINTED LINE. IF NO SETTING
.*                                 CHANGES ARE REQUIRED ALL OPERANDS
.*                                 ARE OMITTED IN WHICH CASE ONLY THE
.*                                 # OF ENTRIES FOR THE PREVIOUS LINE
.*                                 IS COMPUTED. THIS MACRO MUST BE THE
.*                                 FIRST MACRO INSTRUCTION ISSUED FOR
.*                                 THE SUBJECT LINE
         GBLA  &DB,&DT,&LB,&LT,&NRENTS
         GBLA  &LASTCC,&INITIAL
         GBLC  &NRENTSX
         GBLC  &CARRCON
         GBLB  &TEST
         GBLB  &DIAGTST,&DIAGSET,&DIAGLIN
         LCLA  &S
         AIF   (&INITIAL EQ 0 OR &DIAGTST EQ 0).DIAGSET
         AIF   (&DIAGSET EQ 0).DIAGSET
         MNOTE '**NO LABEL ASSOCIATED WITH LAST SET**'
***** THE FOLLOWING GENERATED FOR TEST PURPOSES *****
*        LABEL '%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%'
               LABEL '%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%'
.DIAGSET ANOP
&DIAGSET SETB  1
&DIAGLIN SETB  1
&NAME    DS    0C
         AIF   (&INITIAL EQ 0).FIRSTLN
         LINEND
         AGO   .NTFIRST
.FIRSTLN ANOP
&NRENTSX SETC  'N&SYSNDX'
&INITIAL SETA  1
N&SYSNDX EQU   *
.NTFIRST ANOP
         DC    AL1(0)
         AIF   ('&DATA(1)' EQ '').CKDTABS
         AIF   (&DATA(1) EQ &DB).CKDTABS
&DB      SETA  &DATA(1)
         AGO   .AA
.CKDTABS AIF   ('&DATA(2)' EQ '').NCDATA
         AIF   (&DATA(2) EQ &DT).NCDATA
         AGO   .CC
.AA      AIF   ('&DATA(2)' EQ '').BB
         AIF   (&DATA(2) EQ &DT).BB
.CC      ANOP
&DT      SETA  &DATA(2)
.BB      DC    XL2'FFFE'
         DC    FL1'&DB'
         DC    FL1'&DT'
&NRENTS  SETA  &NRENTS+1
.NCDATA  ANOP
         AIF   ('&LABEL(1)' EQ '').CKLTABS
         AIF   (&LABEL(1) EQ &LB).CKLTABS
&LB      SETA  &LABEL(1)
         AGO   .AAA
.CKLTABS AIF   ('&LABEL(2)' EQ '').NCLABEL
         AIF   (&LABEL(2) EQ &LT).NCLABEL
         AGO   .CCC
.AAA     AIF   ('&LABEL(2)' EQ '').BBB
         AIF   (&LABEL(2) EQ &LT).BBB
.CCC     ANOP
&LT      SETA  &LABEL(2)
.BBB     DC    XL2'FFFF'
         DC    FL1'&LB'
         DC    FL1'&LT'
&NRENTS  SETA  &NRENTS+1
.NCLABEL ANOP
         AIF   ('&SKIP' NE '').CONT
         AIF   (&TEST EQ 0).NOCHANG
         AGO   .DEFALTA
.CONT    ANOP
         AIF   (&TEST EQ 0).AB
         AIF   ('&SKIP' EQ 'E').AB
&S       SETA  &SKIP
.DEFAULT ANOP
         AIF   (&SKIP EQ &LASTCC).DEFALTA
         ORG   &CARRCON+3
         DC    AL.3(0),AL.2(&S),AL.3(1)
         ORG
&LASTCC  SETA  &S
.DEFALTA ANOP
&TEST    SETB  0
         AGO   .DD
.AB      AIF   ('&SKIP' NE 'E').ABB
A&SYSNDX DC    X'FFFB8B00'              EJECT
         AGO   .ABC
.ABB     AIF   (&SKIP EQ &LASTCC).NOCHANG
A&SYSNDX DC    XL2'FFFB'
         DC    AL.3(0),AL.2(&SKIP),AL.3(1)
         DC    AL.3(0),AL.2(&SKIP),AL.3(1)
&LASTCC  SETA  &SKIP
&TEST    SETB  1
.ABC     ANOP
&CARRCON SETC  'A&SYSNDX'
&NRENTS  SETA  &NRENTS+1
.DD      ANOP
.NOCHANG ANOP
         MEND
         EJECT
         GBLC  &DSECT,&CSECT
&DSECT   SETC  'INDEPEND'
&CSECT   SETC  'IFCEE165'
IFCEE165 CSECT
         USING *,R9
INDEPEND DSECT
         DS    0F
         DSGEN (XKEY,16),(XSWS8,9),(XSWS9,1),(XSWS10,1),(XSWS11,1),    C
               (XSWS12,1),(XSWS13,1),(XSWS14,1),(XSWS15,1)
         DSGEN (XDUM1,32)
         DSGEN (XDATE,32)
         DSGEN (XTIME,32)
         DSGEN (XDUM2,8),(XSER,24)
         DSGEN (XCPUMOD,16),(XDUM3,16)
         DSGEN (XPGMID,64)
         DSGEN (XJOBID,64)
         DSGEN (XMCKPSW,64)
M165     DS    214F
         DSGEN (A1LB,32)
         DSGEN (A1LC,32)
         DSGEN (A1LD,32)
         DSGEN (A1LE,32)
         DSGEN (A1LF,32)
         DSGEN (A1LG,32)
         DSGEN (A1LH,32)
         DSGEN (A1LJ,32)
         DSGEN (A1LK,32)
         DSGEN (A1LL,32)
         DSGEN (A2LB,32)
         DSGEN (A2LC,32)
         DSGEN (A2LD,32)
         DSGEN (A2LE,32)
         DSGEN (A2LF,32)
         DSGEN (A2LG,32)
         DSGEN (A2LH,32)
         DSGEN (A2LJ,32)
         DSGEN (A2LK,32)
         DSGEN (A2LL,32)
         DSGEN (A3LB,32)
         DSGEN (A3LC,32)
         DSGEN (A3LD,32)
         DSGEN (A3LE,32)
         DSGEN (A3LF,32)
         DSGEN (A3LG,32)
         DSGEN (A3LH,32)
         DSGEN (A3LJ,32)
         DSGEN (A3LK,32)
         DSGEN (A3LL,32)
         DSGEN (A4LB,32)
         DSGEN (A4LC,32)
         DSGEN (A4LD,32)
         DSGEN (A4LE,32)
         DSGEN (A4LF,32)
         DSGEN (A4LG,32)
         DSGEN (A4LH,32)
         DSGEN (A4LJ,32)
         DSGEN (A4LK,32)
         DSGEN (A4LL,32)
         DSGEN (A5LB,32)
         DSGEN (A5LC,32)
         DSGEN (A5LD,32)
         DSGEN (A5LE,32)
         DSGEN (A5LF,32)
         DSGEN (A5LG,32)
         DSGEN (A5LH,32)
         DSGEN (A5LJ,32)
         DSGEN (A5LK,32)
         DSGEN (A5LL,32)
         DSGEN (A6LB,32)
         DSGEN (A6LC,32)
         DSGEN (A6LD,32)
         DSGEN (A6LE,32)
         DSGEN (A6LF,32)
         DSGEN (A6LG,32)
         DSGEN (A6LH,32)
         DSGEN (A6LJ,32)
         DSGEN (A6LK,32)
         DSGEN (A6LL,32)
         DSGEN (A7LB,32)
         DSGEN (A7LC,32)
         DSGEN (A7LD,32)
         DSGEN (A7LE,32)
         DSGEN (A7LF,32)
         DSGEN (A7LG,32)
         DSGEN (A7LH,32)
         DSGEN (A7LJ,32)
         DSGEN (A7LK,32)
         DSGEN (A7LL,32)
         DSGEN (B0LB,32)
         DSGEN (B0LC,32)
         DSGEN (B0LD,32)
         DSGEN (B0LE,32)
         DSGEN (B0LF,32)
         DSGEN (B0LG,32)
         DSGEN (B0LH,32)
         DSGEN (B0LJ,32)
         DSGEN (B0LK,32)
         DSGEN (B0LL,32)
         DSGEN (B1LB,32)
         DSGEN (B1LC,32)
         DSGEN (B1LD,32)
         DSGEN (B1LE,32)
         DSGEN (B1LF,32)
         DSGEN (B1LG,32)
         DSGEN (B1LH,32)
         DSGEN (B1LJ,32)
         DSGEN (B1LK,32)
         DSGEN (B1LL,32)
         DSGEN (B2LB,32)
         DSGEN (B2LC,32)
         DSGEN (B2LD,32)
         DSGEN (B2LE,32)
         DSGEN (B2LF,32)
         DSGEN (B2LG,32)
         DSGEN (B2LH,32)
         DSGEN (B2LJ,32)
         DSGEN (B2LK,32)
         DSGEN (B2LL,32)
         DSGEN (B3LB,32)
         DSGEN (B3LC,32)
         DSGEN (B3LD,32)
         DSGEN (B3LE,32)
         DSGEN (B3LF,32)
         DSGEN (B3LG,32)
         DSGEN (B3LH,32)
         DSGEN (B3LJ,32)
         DSGEN (B3LK,32)
         DSGEN (B3LL,32)
         DSGEN (B4LB,32)
         DSGEN (B4LC,32)
         DSGEN (B4LD,32)
         DSGEN (B4LE,32)
         DSGEN (B4LF,32)
         DSGEN (B4LG,32)
         DSGEN (B4LH,32)
         DSGEN (B4LJ,32)
         DSGEN (B4LK,32)
         DSGEN (B4LL,32)
         DSGEN (B5LB,32)
         DSGEN (B5LC,32)
         DSGEN (B5LD,32)
         DSGEN (B5LE,32)
         DSGEN (B5LF,32)
         DSGEN (B5LG,32)
         DSGEN (B5LH,32)
         DSGEN (B5LJ,32)
         DSGEN (B5LK,32)
         DSGEN (B5LL,32)
         DSGEN (B6LB,32)
         DSGEN (B6LC,32)
         DSGEN (B6LD,32)
         DSGEN (B6LE,32)
         DSGEN (B6LF,32)
         DSGEN (B6LG,32)
         DSGEN (B6LH,32)
         DSGEN (B6LJ,32)
         DSGEN (B6LK,32)
         DSGEN (B6LL,32)
         DSGEN (C0LB,32)
         DSGEN (C0LC,32)
         DSGEN (C0LD,32)
         DSGEN (C0LE,32)
         DSGEN (C0LF,32)
         DSGEN (C0LG,32)
         DSGEN (C0LH,32)
         DSGEN (C0LJ,32)
         DSGEN (C0LK,32)
         DSGEN (C0LL,32)
         DSGEN (C1LB,32)
         DSGEN (C1LC,32)
         DSGEN (C1LD,32)
         DSGEN (C1LE,32)
         DSGEN (C1LF,32)
         DSGEN (C1LG,32)
         DSGEN (C1LH,32)
         DSGEN (C1LJ,32)
         DSGEN (C1LK,32)
         DSGEN (C1LL,32)
         DSGEN (C2LB,32)
         DSGEN (C2LC,32)
         DSGEN (C2LD,32)
         DSGEN (C2LE,32)
         DSGEN (C2LF,32)
         DSGEN (C2LG,32)
         DSGEN (C2LH,32)
         DSGEN (C2LJ,32)
         DSGEN (C2LK,32)
         DSGEN (C2LL,32)
         DSGEN (C3LB,32)
         DSGEN (C3LC,32)
         DSGEN (C3LD,32)
         DSGEN (C3LE,32)
         DSGEN (C3LF,32)
         DSGEN (C3LG,32)
         DSGEN (C3LH,32)
         DSGEN (C3LJ,32)
         DSGEN (C3LK,32)
         DSGEN (C3LL,32)
         DSGEN (C4LB,32)
         DSGEN (C4LC,32)
         DSGEN (C4LD,32)
         DSGEN (C4LE,32)
         DSGEN (C4LF,32)
         DSGEN (C4LG,32)
         DSGEN (C4LH,32)
         DSGEN (C4LJ,32)
         DSGEN (C4LK,32)
         DSGEN (C4LL,32)
         DSGEN (C5LB,32)
         DSGEN (C5LC,32)
         DSGEN (C5LD,32)
         DSGEN (C5LE,32)
         DSGEN (C5LF,32)
         DSGEN (C5LG,32)
         DSGEN (C5LH,32)
         DSGEN (C5LJ,32)
         DSGEN (C5LK,32)
         DSGEN (C5LL,32)
         DSGEN (C6LB,32)
         DSGEN (C6LC,32)
         DSGEN (C6LD,32)
         DSGEN (C6LE,32)
         DSGEN (C6LF,32)
         DSGEN (C6LG,32)
         DSGEN (C6LH,32)
         DSGEN (C6LJ,32)
         DSGEN (C6LK,32)
         DSGEN (C6LL,32)
         DSGEN (DARLNGTH,16),(,48)
         DSGEN (SYSSTAT,1,0,7)
         DSGEN (AREADT,1,0,15)
         DSGEN (ERRTYPE,1,0,7)
         DSGEN (RMSACTN,1,0,7)
         DSGEN (RMSINFO,1,0,7)
         DSGEN (WAITSUFF,8),(,8),(LOSTSUM,48),(,16)
         DSGEN (TRNSMOD,32,0,7)
         DSGEN (MCHPDR,1,0,7,0,7)
         DSGEN (FSRADDR,32),(BFSVADDR,32),(EFSVADDR,32),               C
               (INSTADDR,32)
LOGEND   EQU   *-2
IFCEE165 CSECT
***********************************************************************
*
***********************************************************************
ENTRYPTR DC    A(FORMAT1)
TABLNAME DC    CL8'IFCEE165'
REG9     DS    F
SAVE     DS    F
***
*              ***     SPECIAL ROUTINES AREA     ***
*
***********************************************************************
ROUT0    DS    0C
         STM   R3,R4,SAVER34            SAVE PRINT BFR PTR- LOG START
         BR    R14                      RETURN
ROUT1    DS    0C
         STM   R3,R8,XSAVE              SAVE ROUTINE REGISTERS
         L     R3,SAVER3                LOAD ADR OF PRINT BFR
         L     R7,L0(R4)                LOAD LOG DATA
         LA    R3,L3(R3)                INCREMENT PRINT BFR POINTER
         LA    R8,L4                    LOAD BYTE COUNT
ROUT1A   DS    0C
         LA    R5,L6                    LOAD BIT COUNT
ROUT1B   DS    0C
         SR    R6,R6                    CLEAR REGISTER R6
         MVI   L0(R3),CB                ASSUME 0 - SET BFR TO BLANK
         SLDL  R6,L1                    SHIFT DATA BIT INTO R6
         LTR   R6,R6                    TEST VALUE IN R6
         BZ    ROUT1C                   BRANCH IF R6 ZERO
         MVI   L0(R3),CS                MOVE SPLAT TO PRINT BFR
ROUT1C   DS    0C
         LA    R3,L3(R3)                INCREMENT PRINT BFR POINTER
         BCT   R5,ROUT1B                BRANCH ON BIT COUNT
         SLL   R7,L2                    BYPASS BITS 6 AND 7
         BCT   R8,ROUT1A                BRANCH ON BYTE COUNT
         LM    R3,R8,XSAVE              RESTORE REGISTERS
         BR    R14                      RETURN
         USING INDEPEND,R2
*** THIS ROUTINE DETERMINES MODEL NUMBER ***
MODCK    CLC   XCPUMOD(L2),C168         Q/ IS THIS A 168
         BE    INSERT                   YES--BRANCH
         CLC   XCPUMOD(L2),C3062          3062?                @Z402IFR
         BE    INSERT                                          @Z402IFR
         BR    R14                      RETURN
INSERT   MVC   L0(L2,R3),FPCON          MOVE LABEL
         BR    R14                      RETURN
C168     DC    X'0168'
C3062    DC    X'3062'                                         @Z402IFR
FPCON    DC    C'FP'
CKMOD    CLC   XCPUMOD(L2),C168         Q/ IS THIS A 168
         BE    INSRP                    YES--BRANCH
         CLC   XCPUMOD(L2),C3062   3062?                       @Z402IFR
         BE    INSRP                                           @Z402IFR
         BR    R14                      RETURN
INSRP    MVC   L0(L2,R3),RPCON          MOVE LABEL
         BR    R14                      RETURN
RPCON    DC    C'RP'
CHKEMU   ST    R5,XSAVE                                        @Z402IFR
         TM    L0(R4),X10                                      @Z402IFR
         BO    RETURN                                          @Z402IFR
         TM    L0(R4),X08                                      @Z402IFR
         BNO   TRY7074                                         @Z402IFR
         L     R5,A7080LN                                      @Z402IFR
         ST    R5,REG9                                         @Z402IFR
         L     R5,A7080LB                                      @Z402IFR
         ST    R5,SAVE                                         @Z402IFR
         B     RETURN                                          @Z402IFR
TRY7074  TM    L0(R4),X04                                      @Z402IFR
         BNO   JUMP1                                           @Z402IFR
         L     R5,A7074LN                                      @Z402IFR
         ST    R5,REG9                                         @Z402IFR
         L     R5,A7074LB                                      @Z402IFR
         ST    R5,SAVE                                         @Z402IFR
RETURN   L     R5,XSAVE                                        @Z402IFR
         BR    14                                              @Z402IFR
JUMP     ST    R5,XSAVE                                        @Z402IFR
JUMP1    L     R5,JUMPLN                                       @Z402IFR
         ST    R5,REG9                                         @Z402IFR
         L     R5,JUMPLB                                       @Z402IFR
         ST    R5,SAVE                                         @Z402IFR
         B     RETURN                                          @Z402IFR
WHERETO  ST    R5,XSAVE                                        @Z402IFR
         CLI   21(R2),X'68'        IS IT A 168?                @Z402IFR
         BE    ISTH                                            @Z402IFR
         CLI   21(R2),X'62'        IS IT A 3062?               @Z402IFR
         BNE   GO                                              @Z402IFR
ISTH     TM    16(R2),X'81'        IS A LEXINGTON CPU OR AU?   @Z402IFR
         BNO   GO                                              @Z402IFR
         LA    R5,LEX-4            SET UP FOR LEX LOAD         @Z402IFR
         ST    R5,REG9                                         @Z402IFR
GO       L     R5,XSAVE                                        @Z402IFR
         SR    R15,R15                                         @Z402IFR
         BR    R14                                             @Z402IFR
R0       EQU   0
R1       EQU   1
R2       EQU   2
R3       EQU   3
R4       EQU   4
R5       EQU   5
R6       EQU   6
R7       EQU   7
R8       EQU   8
R9       EQU   9
R10      EQU   10
R11      EQU   11
R12      EQU   12
R13      EQU   13
R14      EQU   14
R15      EQU   15
CC1      EQU   1
CC2      EQU   2
CC4      EQU   4
CC7      EQU   7
CC8      EQU   8
L0       EQU   0
L1       EQU   1
L2       EQU   2
L3       EQU   3
L4       EQU   4
L5       EQU   5
L6       EQU   6
L7       EQU   7
L8       EQU   8
L9       EQU   9
L10      EQU   10
CB       EQU   C' '
CS       EQU   C'*'
X10      EQU   X'10'                                           @YA07735
X08      EQU   X'08'                                           @YA07735
X04      EQU   X'04'                                           @YA07735
XWORK    DS    D
XSAVE    DS    6F
SAVER34  DS    2F
A7074LN  DC    A(LN7074-4)                                     @YA07735
A7074LB  DC    A(LB7074-1)                                     @YA07735
A7080LN  DC    A(LN7080-4)                                     @YA07735
A7080LB  DC    A(LB7080-1)                                     @YA07735
JUMPLN   DC    A(LNJUMP-4)                                     @YA07735
JUMPLB   DC    A(LBJUMP-1)                                     @YA07735
SAVER3   EQU   SAVER34
SAVER4   EQU   SAVER34+4
***********************************************************************
*
FORMAT1  DC    F'0'
FORMAT2  DC    F'0'
LABELPTR DC    A(LABLAREA)
DISP     DC    FL2'0'
***********************************************************************
         LINE  (1,1),(1,1),SKIP=3
         ROUTINE    XKEY,ROUT0
       LABEL  ' '
         LINE       (1,1),(19,1),SKIP=1                          S21021
       LABEL  'M/F FRAME B0 MAINTENANCE CONTROLS'
         LINE  ,(18,1)
       LABEL  'MCW MODE BITS - CPUA'
         LINE  ,(3,1)
       LABEL  'RS SA DO DT OS BD BP BSC C MC AP BV SWC   IR  R  M  C  EC
               '
         LINE  ,(1,1)
         ROUTINE    B0LB,ROUT1
       LABEL  'LB'
         LINE  ,(20,1)
       LABEL  'CPU B MODE BITS'
        LINE  (30,1),(10,28)
         ROUTINE    XCPUMOD,MODCK
       LABEL  'CC       BB AC','DS                   DS FD'
         LINE  (1,1),(1,1)
         ROUTINE    B0LC,ROUT1
       LABEL  'LC'
         LINE  ,(4,1)
       LABEL  'MINNOW FILE ADDRESS BITS                    MINNOW WCS AX
               DDRESS BITS'
         LINE  ,(4,1)
       LABEL  '0  1  2  3  4  5  6  7                 1  2  3  4  5  6 X
                7  8  9 10 11'
         LINE  ,(1,1),SKIP=3
         ROUTINE    B0LD,ROUT1
       LABEL  'LD'
         LINE  ,(1,1),SKIP=1
       LABEL  'LE'
         LINE  ,(6,1)
       LABEL  'MACHINE CHECK INTERRUPT CODE TRIGGERS'
         LINE  ,(4,1)
       LABEL  'SDIPD SR CD ED DI SU SC CU    FV GV CV LV TV CV    HS LDX
                PB'
         LINE  ,(1,1)
         ROUTINE    B0LF,ROUT1
       LABEL  'LF'
         LINE  ,(4,1)
       LABEL  'MAIN CTLS / D R  / RIPPL/ DS ST ST  M DIG I HNG D    BY X
               NORSTO OP'                                      @YM6450P
         LINE  ,(4,1)
       LABEL  '0  1  2  A  E D  WR    RD CH TR LP DI MD BF SYC O    OP X
               ADVVIO INT'                                     @YM6450P
         LINE  ,(1,1)
         ROUTINE    B0LG,ROUT1
       LABEL  'LG'
         LINE  ,(3,1)
       LABEL  'SR OP BE IC OP PG  MLCR EN  E RST   RTRY-CNT SS ST ST   X
                LOGOUT'
         LINE  ,(3,1)
       LABEL  'LC 3B IU VL IV SC  0  1 IN BSY SQ    0  1  2 CK LC EE   X
                BS  LS'
         LINE  ,(1,1)
         ROUTINE    B0LH,ROUT1
       LABEL  'LH'
         LINE  ,(3,1)
       LABEL  'RG ST PT RS EX UR  MSSR     EL'
         LINE  ,(3,1)
       LABEL  'AL AL ST ST SB EV  0  1 IPT CY RIP  CHN LP'
         LINE  ,(1,1),SKIP=3
         ROUTINE    B0LJ,ROUT1
       LABEL  'LJ'
         LINE  ,(1,1),SKIP=3
       LABEL  'LK'
         LINE  ,(1,1),SKIP=3
       LABEL  'LL'
         LINE  ,(19,1),SKIP=1
       LABEL  'M/F FRAME B1  SCU-CH MATRIX CTL-CKS'
         LINE  ,(3,1)
       LABEL  'RIB VD ADDR VALID    IBBSY IP RIB    / CHANNEL ADDR 0 ASX
               SGNED BFR GRP /'
         LINE  ,(3,1)
       LABEL  ' A  B  T LA TA TB     A  B  S ACT    1  2  3  4  5  6  7X
                 9  A  B  C  D'
         LINE  ,(1,1)
         ROUTINE    B1LB,ROUT1
       LABEL  'LB'
         LINE  ,(3,1)
       LABEL  'CS / LSU BUSY / FL  /BI STACK/       / CHANNEL ADDR 1 ASX
               SGNED BFR GRP /'
         LINE  ,(3,1)
       LABEL  'ST  0  1  2  3  B    TM PU  R        1  2  3  4  5  6  7X
                 9  A  B  C  D'
         LINE  ,(1,1)
         ROUTINE    B1LC,ROUT1
       LABEL  'LC'
         LINE  ,(4,1)
       LABEL  'COB  END      PSCH  DIB ACT         / CHANNEL ADDR 2 ASSX
               GNED BFR GRP /'
         LINE  ,(3,1)
       LABEL  'BS EC SQ       SEQ    B  EC          1  2  3  4  5  6  7X
                 9  A  B  C  D'
         LINE  ,(1,1)
         ROUTINE    B1LD,ROUT1
       LABEL  'LD'
         LINE  ,(3,1)
       LABEL   'ADR   KEY   DAT   PROT               / CHANNEL ADDR 3 AX
               SSGNED BFR GRP /'
         LINE  ,(3,1)
       LABEL  'CHK   CHK   CHK   VIOL               1  2  3  4  5  6  7X
                 9  A  B  C  D'
         LINE  ,(1,1)
         ROUTINE    B1LE,ROUT1
       LABEL  'LE'
         LINE  ,(3,1)
       LABEL  'MK    INB   OUT   INV                / CHANNEL ADDR 4 ASX
               SGNED BFR GRP /'
         LINE  ,(3,1)
       LABEL  'CK     CK    CK   ADR                1  2  3  4  5  6  7X
                 9  A  B  C  D'
         LINE  ,(1,1)
         ROUTINE    B1LF,ROUT1
       LABEL  'LF'
         LINE  ,(3,1)
       LABEL  'CH BFR-OUT DATA CHK BYTE             / CHANNEL ADDR 5 ASX
               SGNED BFR GRP /'
         LINE  ,(3,1)
       LABEL  ' 0  1  2  3  4  5  6  7              1  2  3  4  5  6  7X
                 9  A  B  C  D'
         LINE  ,(1,1)
         ROUTINE    B1LG,ROUT1
       LABEL  'LG'
         LINE  ,(40,1)
       LABEL  '/ CHANNEL ADDR 6 ASSGNED BFR GRP /'
         LINE  ,(40,1)
       LABEL  '1  2  3  4  5  6  7  9  A  B  C  D'
         LINE  ,(1,1),SKIP=3
         ROUTINE    B1LH,ROUT1
       LABEL  'LH'
         LINE  ,(1,1),SKIP=1
       LABEL  'LJ'
         LINE  ,(24,1)
       LABEL  'BI STK CK'
         LINE  (28,1),(24,7)
         ROUTINE    XCPUMOD,CKMOD
       LABEL  'PTY','OV'
         LINE  (1,1),(1,1),SKIP=3
         ROUTINE    B1LK,ROUT1
       LABEL  'LK'
         LINE  ,(1,1),SKIP=3
       LABEL  'LL'
         LINE  ,(19,1),SKIP=1
       LABEL  'M/F FRAME B2 SCU- CHANNEL CTLS'
         LINE  ,(26,1)
       LABEL  'REQUEST FOR CHANNEL IN-BUS'
         LINE  ,(4,1)
       LABEL  'GRP1  GRP2  GRP3  GRP4  GRP5  GRP6  GRP7  GRP9  GRPA  GRX
               PB  GRPC  GRPD'
         LINE  ,(1,1)
         ROUTINE    B2LB,ROUT1
       LABEL  'LB'
         LINE  ,(27,1)
       LABEL  'CHANNEL-BUFFER RESPONSE'
         LINE  ,(4,1)
       LABEL  'GRP1  GRP2  GRP3  GRP4  GRP5  GRP6  GRP7  GRP9  GRPA  GRX
               PB  GRPC  GRPD'
         LINE  ,(1,1)
         ROUTINE    B2LC,ROUT1
       LABEL  'LC'
         LINE  ,(30,1)
       LABEL  'REMEMBER RESPONSE'
         LINE  ,(4,1)
       LABEL  'GRP1  GRP2  GRP3  GRP4  GRP5  GRP6  GRP7  GRP9  GRPA  GRX
               PB  GRPC  GRPD'
         LINE  ,(1,1)
         ROUTINE    B2LD,ROUT1
       LABEL  'LD'
         LINE  ,(29,1)
       LABEL  'CHANNEL-BUFFER BUSY'
         LINE  ,(4,1)
       LABEL  'GRP1  GRP2  GRP3  GRP4  GRP5  GRP6  GRP7  GRP9  GRPA  GRX
               PB  GRPC  GRPD'
         LINE  ,(1,1)
         ROUTINE    B2LE,ROUT1
       LABEL  'LE'
         LINE  ,(27,1)
       LABEL  'CHANNEL IN-BUFFER VALID'
         LINE  ,(4,1)
       LABEL  'GRP1  GRP2  GRP3  GRP4  GRP5  GRP6  GRP7  GRP9  GRPA  GRX
               PB  GRPC  GRPD'
         LINE  ,(1,1)
         ROUTINE    B2LF,ROUT1
       LABEL  'LF'
         LINE  ,(27,1)
       LABEL  'CHANNEL OUT-BUFFER VALID'
         LINE  ,(4,1)
       LABEL  'GRP1  GRP2  GRP3  GRP4  GRP5  GRP6  GRP7  GRP9  GRPA  GRX
               PB  GRPC  GRPD'
         LINE  ,(1,1)
         ROUTINE    B2LG,ROUT1
       LABEL  'LG'
         LINE  ,(25,1)
       LABEL  'REQUEST FOR CHANNEL OUT-BUS'
         LINE  ,(4,1)
       LABEL  'GRP1  GRP2  GRP3  GRP4  GRP5  GRP6  GRP7  GRP9  GRPA  GRX
               PB  GRPC  GRPD'
         LINE  ,(1,1)
         ROUTINE    B2LH,ROUT1
       LABEL  'LH'
         LINE  ,(28,1)
       LABEL  'CHANNEL-BUFFER ADVANCE'
         LINE  ,(4,1)
       LABEL  'GRP1  GRP2  GRP3  GRP4  GRP5  GRP6  GRP7  GRP9  GRPA  GRX
               PB  GRPC  GRPD'
         LINE  ,(1,1),SKIP=3
         ROUTINE    B2LJ,ROUT1
       LABEL  'LJ'
         LINE  ,(1,1),SKIP=3
       LABEL  'LK'
         LINE  ,(1,1),SKIP=3
       LABEL  'LL'
         LINE  ,(19,1),SKIP=1
       LABEL  'M/F FRAME B3 HSM AND/OR EXTD CHN'
         LINE   ,(40,1)
       LABEL  '/ CHANNEL ADDR 7 ASSGNED BFR GRP /'
         LINE  ,(40,1)
     LABEL    '1  2  3  4  5  6  7  9  A  B  C  D'
         LINE  ,(1,1)
         ROUTINE    B3LB,ROUT1
       LABEL  'LB'
         LINE  ,(40,1)
       LABEL  '/ CHANNEL ADDR 8 ASSGNED BFR GRP /'
         LINE  ,(40,1)
     LABEL    '1  2  3  4  5  6  7  9  A  B  C  D'
         LINE  ,(1,1)
         ROUTINE    B3LC,ROUT1
       LABEL  'LC'
         LINE  ,(40,1)
       LABEL  '/ CHANNEL ADDR 9 ASSGNED BFR GRP /'
         LINE  ,(40,1)
     LABEL    '1  2  3  4  5  6  7  9  A  B  C  D'
         LINE  ,(1,1)
         ROUTINE    B3LD,ROUT1
       LABEL  'LD'
         LINE  ,(40,1)
       LABEL  '/ CHANNEL ADDR A ASSGNED BFR GRP /'
         LINE  ,(40,1)
     LABEL    '1  2  3  4  5  6  7  9  A  B  C  D'
         LINE  ,(1,1)
         ROUTINE    B3LE,ROUT1
       LABEL  'LE'
         LINE  ,(3,1)
       LABEL  'CLOCK HI  MNOR CYC DECD FLPSHRT      / CHANNEL ADDR B ASX
               SGNED BFR GRP /'
         LINE  ,(4,1)
       LABEL  'C CSAOR  1  2  3  1 IN RR RX        1  2  3  4  5  6  7 X
                9  A  B  C  D'
         LINE  ,(1,1)
         ROUTINE    B3LF,ROUT1
       LABEL  'LF'
         LINE  ,(3,1)
       LABEL  'SPILLADDR          MPLR'
         LINE  ,(4,1)
       LABEL  '2CRYCSA          CPMPAR'
         LINE  ,(1,1)
         ROUTINE    B3LG,ROUT1
       LABEL  'LG'
         LINE  ,(4,1)
       LABEL  'RESIDUE SP  SP SP MPLR REG SPILADDR'
         LINE  ,(3,1)
       LABEL  'MP SUMCRY 0  1  2  0  1  2  0  1  2'
         LINE  ,(1,1)
         ROUTINE    B3LH,ROUT1
       LABEL  'LH'
         LINE  ,(4,1)
       LABEL  'MPCD/SUM/ CARRY /CMPT RSLT/ACT RSLT/'
         LINE  ,(4,1)
       LABEL  '0  1  2  0  1  2  0  1  2  0  1  2'
         LINE  ,(1,1)
         ROUTINE    B3LJ,ROUT1
       LABEL  'LJ'
         LINE  ,(3,1)
       LABEL  'CK MPLMPC/RESIDUE CTL---ACT/'
         LINE  ,(3,1)
       LABEL  'RES P  P MPC S CRYMPLSP RSL'
         LINE  ,(1,1),SKIP=3
         ROUTINE    B3LK,ROUT1
       LABEL  'LK'
         LINE  ,(1,1),SKIP=3
       LABEL  'LL'
         LINE  ,(1,1),SKIP=1                                   @YA07735
         ROUTINE A4LJ,CHKEMU                                   @YA07735
         LABEL '  '                                            @YA07735
         LINE  ,(19,1),SKIP=1
       LABEL  'M/F FRAME B5 7094 EMULATOR FEATURE'
         LINE  ,(23,1)
       LABEL  'CONTROL STORAGE BITS (108-125)'
         LINE  ,(3,1)
       LABEL  '108   109 10 11 12   113 14 15 16 17   118 19 20   121  X
                122   123 24 25'
         LINE  ,(1,1)
         ROUTINE    B5LB,ROUT1
       LABEL  'LB'
         LINE  ,(30,1)
       LABEL  '94 OPERATION CODE'
         LINE  ,(22,1)
       LABEL  'S  1  2  3  4  5  6  7  8  9 10 11'
         LINE  ,(1,1),SKIP=3
         ROUTINE    B5LC,ROUT1
       LABEL  'LC'
         LINE  ,(1,1),SKIP=1
       LABEL  'LD'
         LINE  ,(3,1),SKIP=1
       LABEL  '  SIGN            MODE        /  CONTROL TGRS/          X
                   EMIT TO LSAL'
         LINE  ,(3,1)
       LABEL  'ACC MQ ST      SV 40 CT       WABA4 AR1AR1AR2 LC IA     X
                    0  1  2  3'
         LINE  ,(1,1)
         ROUTINE    B5LE,ROUT1
       LABEL  'LE'
         LINE  ,(3,1)
       LABEL  'BUFFER            MODE             CONTROL TRIGGERS     X
                  EMIT TO LSAL5'
         LINE  ,(3,1)
       LABEL  'ACC MQ HS       MT TT 94         EI IV LC LSD EO HT CS  X
                    0  1  2  3'
         LINE  ,(1,1)
         ROUTINE    B5LF,ROUT1
       LABEL  'LF'
         LINE  ,(38,1)
       LABEL  'CONTROL TRIGGERS'
         LINE  ,(36,1)
       LABEL  'IFI IFIIF AC ST PE ST'
         LINE  ,(1,1),SKIP=3
         ROUTINE    B5LG,ROUT1
       LABEL  'LG'
         LINE  ,(1,1),SKIP=1
       LABEL  'LH'
         LINE  ,(24,1)
       LABEL  '94 INSTRUCTION COUNTER BUFFER'
         LINE  ,(4,1)
       LABEL  'P1 P2 P3 8  9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 X
               24 25 26 27 28'
         LINE  ,(1,1)
         ROUTINE    B5LJ,ROUT1
       LABEL  'LJ'
         LINE  ,(32,1)
       LABEL  'XLTR'
         LINE  ,(33,1)
       LABEL  'IN  CS'
         LINE  ,(1,1),SKIP=3
         ROUTINE    B5LK,ROUT1
       LABEL  'LK'
         LINE  ,(1,1),SKIP=3
       LABEL  'LL'
         LINE  ,(19,1),SKIP=1                                  @YA07735
         LABEL 'M/F FRAME B6  7094 EMULATOR'                   @YA07735
         LINE  ,(3,1),SKIP=1                                   @YA07735
         LABEL 'P1 P9                              94 INSTRUCTION REGIST
               TER'                                            @YA07735
         LINE  ,                                               @YA07735
         LABEL '-8 -16             S  1  2  3  4  5  6  7  8  9 10 11 1X
               2 13 14 15 16 17'                               @YA07735
         LINE  ,(1,1),SKIP=1                                   @YA07735
         ROUTINE B6LB,ROUT1                                    @YA07735
         LABEL 'LB'                                            @YA07735
         LINE  ,(3,1),SKIP=1                                   @YA07735
         LABEL 'P17 25 33                          94 INSTRUCTION REGIST
               TER'                                            @YA07735
         LINE  ,                                               @YA07735
         LABEL '-24 32 35         18 19 20 21 22 23 24 25 26 27 28 29 30
               0 31 32 33 34 35'                               @YA07735
         LINE  ,(1,1),SKIP=3                                   @YA07735
         ROUTINE B6LC,ROUT1                                    @YA07735
         LABEL 'LC'                                            @YA07735
         LINE  ,(1,1),SKIP=1                                   @YA07735
         LABEL 'LD'                                            @YA07735
         LINE  ,(26,1),SKIP=1                                  @YA07735
         LABEL '94 INSTRUCTION COUNTER'                        @YA07735
         LINE  ,(3,1),SKIP=1                                   @YA07735
         LABEL 'P1 P2 P3  8  9 10 11 12 13 14 15 16 17 18 19 20 21 22 23
               3 24 25 26 27 28'                               @YA07735
         LINE  ,(1,1),SKIP=3                                   @YA07735
         ROUTINE B6LE,ROUT1                                    @YA07735
         LABEL 'LE'                                            @YA07735
         LINE  ,(1,1),SKIP=1                                   @YA07735
         ROUTINE B6LF,ROUT1                                    @YA07735
         LABEL 'LF'                                            @YA07735
         LINE  ,(3,1),SKIP=1                                   @YA07735
         LABEL 'INVINV            INV               ADDR REG 1'
         LINE  ,                                               @YA07735
         LABEL 'R2AR2B            P1AP2 P3 14 15 16 17 18 19 20 21 22 23
               3 24 25 26 27 28'                               @YA07735
         LINE  ,(1,1),SKIP=1                                   @YA07735
         ROUTINE B6LG,ROUT1                                    @YA07735
         LABEL 'LG'                                            @YA07735
         LINE  ,(39,1),SKIP=1                                  @YA07735
         LABEL 'ADDR REG 2'                                    @YA07735
         LINE  ,(3,1),SKIP=1                                   @YA07735
         LABEL 'P1 P2 P3  8  9 10 11 12 13 14 15 16 17 18 19 20 21 22 23
               3 24 25 26 27 28'                               @YA07735
         LINE  ,(1,1),SKIP=3                                   @YA07735
         ROUTINE B6LH,ROUT1                                    @YA07735
         LABEL 'LH'                                            @YA07735
         LINE  ,                                               @YA07735
         LABEL 'LJ'                                            @YA07735
         LINE  ,                                               @YA07735
         LABEL 'LK'                                            @YA07735
         LINE  ,                                               @YA07735
         LABEL 'LL'                                            @YA07735
         LINE  ,(1,1),SKIP=1                                   @YA07735
         ROUTINE A4LJ,JUMP                                     @YA07735
         LABEL '  '                                            @YA07735
LN7080   LINE  ,(26,1),SKIP=1                                  @YA07735
LB7080   LABEL 'M/F FRAME B6  7080 EMULATOR'                   @YA07735
         LINE  ,(15,1)                                         @YA07735
         LABEL 'STATUS GROUP 1                     CS BITS'    @YA07735
         LINE  ,(12,1)                                         @YA07735
         LABEL 'CPT SX OT  INDEX   ZC DC         108 09 10 11 12 13'
         LINE  ,(1,1)                                          @YA07735
         ROUTINE B6LB,ROUT1                                    @YA07735
         LABEL 'LB'                                            @YA07735
         LINE  ,(15,1)                                         @YA07735
         LABEL 'STATUS GROUP 2                     CS BITS'    @YA07735
         LINE  ,(12,1)                                         @YA07735
         LABEL 'IN FAC MI IP CHK   AZ MI         114 15 16 17 18 19'
         LINE  ,(1,1)                                          @YA07735
         ROUTINE B6LC,ROUT1                                    @YA07735
         LABEL 'LC'                                            @YA07735
         LINE  ,(15,1)                                         @YA07735
         LABEL 'STATUS GROUP 3                     CS BITS'    @YA07735
         LINE  ,(12,1)                                         @YA07735
         LABEL 'DIL DC 80 05 SW ME 5S 4S         120 21 22 23 24 25'
         LINE  ,(1,1)                                          @YA07735
         ROUTINE B6LD,ROUT1                                    @YA07735
         LABEL 'LD'                                            @YA07735
         LINE  ,(35,1)                                         @YA07735
         LABEL 'STATUS                      EM LCL STOR'       @YA07735
         LINE  ,(35,1)                                         @YA07735
         LABEL 'VALID                        0  1  2  3'       @YA07735
         LINE  ,(1,1)                                          @YA07735
         ROUTINE B6LE,ROUT1                                    @YA07735
         LABEL 'LE'                                            @YA07735
         LINE  ,(12,1)                                         @YA07735
         LABEL 'ADD TLCH 20 40 80                      GW EMIT'
         LINE  ,(12,1)                                         @YA07735
         LABEL '80A A  B WR WR WR IN  5           W PA BR LSAR'
         LINE  ,(1,1)                                          @YA07735
         ROUTINE B6LF,ROUT1                                    @YA07735
         LABEL 'LF'                                            @YA07735
         LINE  ,(54,1)                                         @YA07735
         LABEL 'EMU          BITS'                             @YA07735
         LINE   ,                                              @YA07735
         LABEL 'CS        0  1  2  3'                          @YA07735
         LINE  ,(1,1)                                          @YA07735
         ROUTINE B6LG,ROUT1                                    @YA07735
         LABEL 'LG'                                            @YA07735
         LINE  ,(10,1)                                         @YA07735
         LABEL 'PAGE CHECKS'                                   @YA07735
         LINE   ,                                              @YA07735
         LABEL 'AB20 00 01 10 11'                              @YA07735
         LINE  ,(1,1)                                          @YA07735
         ROUTINE B6LH,ROUT1                                    @YA07735
         LABEL 'LH'                                            @YA07735
         LINE  ,(10,1)                                         @YA07735
         LABEL 'PAGE REMEMBERS'                                @YA07735
         LINE  ,(10,1)                                         @YA07735
         LABEL 'AB20 00 01 10 11'                              @YA07735
         LINE  ,(1,1)                                          @YA07735
         ROUTINE B6LJ,ROUT1                                    @YA07735
         LABEL 'LJ'                                            @YA07735
         LINE  ,(48,1)                                         @YA07735
         LABEL 'S-ADDER'                                       @YA07735
         LINE  ,(45,1)                                         @YA07735
         LABEL 'CS  A  B'                                      @YA07735
         LINE  ,(1,1),SKIP=3                                   @YA07735
         ROUTINE B6LK,ROUT1                                    @YA07735
         LABEL 'LK'                                            @YA07735
         LINE  ,(1,1),SKIP=3                                   @YA07735
         LABEL 'LL'                                            @YA07735
         LINE  ,(1,1),SKIP=1                                   @YA07735
         ROUTINE B6LK,JUMP                                     @YA07735
         LABEL ' '                                             @YA07735
LN7074   LINE  ,(26,1),SKIP=1                                  @YA07735
LB7074   LABEL 'M/F FRAME B6  7074 EMULATOR'                   @YA07735
         LINE  ,(27,1),SKIP=1                                  @YA07735
         LABEL 'CONTROL STORE BITS 108-125'                    @YA07735
         LINE  ,(3,1)                                          @YA07735
         LABEL '108   09 10 11 12   113 14 15 16 17   118 19 20    21  C
                 22   123 24 25'                               @YA07735
         LINE  ,(1,1),SKIP=3                                   @YA07735
         ROUTINE B6LB,ROUT1                                    @YA07735
         LABEL 'LB'                                            @YA07735
         LINE  ,,SKIP=1                                        @YA07735
         LABEL 'LC'                                            @YA07735
         LINE  ,(27,1),SKIP=1                                  @YA07735
         LABEL 'STAT                                MISC 4-LSAL'
         LINE ,(27,1)                                          @YA07735
         LABEL 'VLD    W  X  Y  Z                    0  1  2  3'
         LINE  ,(1,1),SKIP=3                                   @YA07735
         ROUTINE B6LD,ROUT1                                    @YA07735
         LABEL 'LD'                                            @YA07735
         LINE   ,                                              @YA07735
         LABEL 'LE'                                            @YA07735
         LINE   ,                                              @YA07735
         LABEL 'LF'                                            @YA07735
         LINE  ,,SKIP=1                                        @YA07735
         LABEL 'LG'                                            @YA07735
         LINE  ,(10,1)                                         @YA07735
         LABEL 'PAGE CHECKS'                                   @YA07735
         LINE  ,(10,1)                                         @YA07735
         LABEL 'AB18 00 01 10 11'                              @YA07735
         LINE  ,(1,1)                                          @YA07735
         ROUTINE B6LH,ROUT1                                    @YA07735
         LABEL 'LH'                                            @YA07735
         LINE  ,(10,1)                                         @YA07735
         LABEL 'PAGE REMEMBERS'                                @YA07735
         LINE  ,(10,1)                                         @YA07735
         LABEL 'AB18 00 01 10 11'                              @YA07735
         LINE  ,(1,1)                                          @YA07735
         ROUTINE B6LJ,ROUT1                                    @YA07735
         LABEL 'LJ'                                            @YA07735
         LINE  ,(36,1)                                         @YA07735
         LABEL 'CS'                                            @YA07735
         LINE  ,(34,1)                                         @YA07735
         LABEL '108-125'                                       @YA07735
         LINE  ,(1,1),SKIP=3                                   @YA07735
         ROUTINE B6LK,ROUT1                                    @YA07735
         LABEL 'LK'                                            @YA07735
         LINE  ,(1,1)                                          @YA07735
         LABEL 'LL'                                            @YA07735
LNJUMP   LINE  ,(1,1),SKIP=1                                   @YA07735
         ROUTINE XDUM2,WHERETO                                 @Z402IFR
LBJUMP   LABEL '  '                                            @YA07735
         DC    X'FE'                                           @YA07735
         DC    CL8'IFCEF165'
LEX      DC    X'FE'                                           @Z402IFR
         DC    CL8'IFCELEX1'                                   @Z402IFR
LABLAREA EQU   *
         LSTART
         END
