         TITLE 'IFCEI135 MODEL 135 CHANNEL EDIT'
         MACRO
&NAME    DSGEN
.*                            THIS MACRO GENERATES ONE DSECT WORD
.*                                 FORMATTED FOR THE SUBJECT LOG RECORD
.*                                 EACH OPERAND HAS TWO SUB LISTS. THE
.*                                 FIRST IS THE NAME OF THE LOG ITEM
.*                                 WHILE THE SECOND IS THE # OF BITS TO
.*                                 ALLOCATE FOR THIS ITEM. ITEMS MUST
.*                                 BE DEFINED CONTIGUOUSLY WITHOUT GAPS
.*                                 UNUSED BIT GROUPS MUST BE GIVEN
.*                                 DUMMY NAMES. THE NAMES PROVIDED FOR
.*                                 THE LOG ITEMS MAY THEN BE USED IN
.*                                 THE CONVERSION MACRO INSTRUCTIONS.
         GBLC &ITEM(1500)
         GBLA &ITEMNBR,&BITS(1500),&SHIFT(1500)
         LCLB  &ONLY1,&CTIND
         LCLA  &START1,&START2,&END1,&END2
         LCLC  &SYMBOL,&EQUSYM
         LCLA  &OP,&COUNT,&BYTE,&EQUCNT
         ACTR  100000
.START   AIF   (N'&SYSLIST(&OP+1) LT 3).LOOP
         AIF   ('&SYSLIST(&OP+1,3)' EQ 'EQU').LOOP     TEST FOR EQU
  AIF   ('&SYSLIST(&OP+1,3)' EQ '' AND '&SYSLIST(&OP+1,4)' EQ '').ERR1
  AIF   ('&SYSLIST(&OP+1,3)' EQ '' OR '&SYSLIST(&OP+1,4)' EQ '').ERR1
         AIF   ('&SYSLIST(&OP+1,3)' GT '&SYSLIST(&OP+1,4)').ERR3
&START1  SETA  &SYSLIST(&OP+1,3)        GET START COUNT OF 1
&START2  SETA  &SYSLIST(&OP+1,4)        GET FIRST END COUNT
         AGO   .SET2A                   BRANCH AROUND
.ERR1    MNOTE '**FIRST SYMBOL CONCATENATION INCOMPLETE**'
         MEXIT
.SET2A   AIF   ('&SYSLIST(&OP+1,5)' EQ ''AND '&SYSLIST(&OP+1,6)' EQ '' X
               ).SET2                   TEST FOR NO SECOND
  AIF   ('&SYSLIST(&OP+1,5)' EQ '' OR '&SYSLIST(&OP+1,6)' EQ '').ERR2
         AIF   ('&SYSLIST(&OP+1,5)' GT '&SYSLIST(&OP+1,6)').ERR3
&END1    SETA  &SYSLIST(&OP+1,5)        GET START COUNT OF 2
&END2    SETA  &SYSLIST(&OP+1,6)        GET END COUNT OF 2
         AGO   .LOOP
.SET2    ANOP
&ONLY1   SETB  1                        INDICATE ONLY ONE CONCATENATION
         AGO   .LOOP
.ERR2    MNOTE '**SECOND SYMBOL CONCATENATION INCOMPLETE**'
         MEXIT
.ERR3    MNOTE '**START GREATER THAN END CONCATENATION**'
         MEXIT
.LOOP    ANOP
&OP      SETA  &OP+1
         AIF   (&OP GT N'&SYSLIST).DONE      TEST IF ALL DONE
&ITEMNBR SETA  &ITEMNBR+1
         AIF   ('&SYSLIST(&OP,2)' NE '').OK1
         MNOTE '**NULL BIT COUNT FIELD**'
         MEXIT
.OK1     ANOP
&SYMBOL  SETC  '&SYSLIST(&OP,1)'
         AIF   ('&SYMBOL' NE '').OK
*              *****     LOG ITEM SYMBOL NOT PROVIDED     *****
         AIF   ('&SYSLIST(&OP,3)' NE 'EQU').CNT
         AGO   .START                   GET NEXT
.OK      AIF   (N'&SYSLIST(&OP) LT 3).NO3    TEST FOR OLD FORMAT
         AIF   ('&SYSLIST(&OP,3)' EQ 'EQU').EQU   TEST FOR EQU
         AIF   (&ONLY1).OK2             TEST FOR ONLY ONE CONCAT
&SYMBOL  SETC  '&SYMBOL.&START1.&END1'       GET 1 AND 2 CONCAT
         AGO   .NO3                     BRANCH AROUND
.OK2     ANOP
&SYMBOL  SETC  '&SYMBOL.&START1'        GET 1 CONCATENATED
.NO3     ANOP
&SYMBOL  EQU   *+&BYTE
&ITEM(&ITEMNBR) SETC '&SYMBOL'          GET LABEL IN GLOBAL
&BITS(&ITEMNBR) SETA &SYSLIST(&OP,2)
&SHIFT(&ITEMNBR) SETA &COUNT-&BYTE*8
.CNT     ANOP
&CTIND   SETB  1                        SET COUNT INDICATOR
&COUNT   SETA  &COUNT+&SYSLIST(&OP,2)
&BYTE    SETA  &COUNT/8
         AIF   (N'&SYSLIST(&OP) LT 3).START  TEST FOR OLD FORMAT
         AIF   (&ONLY1).TSTST           TEST FOR ONLY ONE CONCAT
         AIF   (&END1 EQ &END2).TSTST   TEST FOR SECOND END
&END1    SETA  &END1+1                  INCREMENT COUNT
&OP      SETA  &OP-1                    DECREMENT INCREMENT
         AGO   .LOOP                    GENERATE NEXT
.TSTST   ANOP
         AIF   (&START1 EQ &START2).LPDONE   TEST FOR END
         AIF   (&ONLY1).NSET1           TEST FOR ONLY ONE CONCAT
&END1    SETA  &SYSLIST(&OP,5)          RE-INIT SECOND START COUNT
.NSET1   ANOP
&OP      SETA  &OP-1                    DECREMENT INDEX
&START1  SETA  &START1+1                INCREMENT FIRST COUNT
         AGO   .LOOP                    GO DO NEXT
.LPDONE  ANOP
&ONLY1   SETB  0                        CLEAR INDICATOR
         AGO   .START                   GO TEST FOR MORE SUB-LISTS
.DONE    AIF   (&COUNT-&COUNT/8*8 NE 0).ERR  TEST FOR MULTIPLE OF EIGHT
         AIF   (&CTIND EQ 0).END        NO DS IF NO COUNT
&COUNT   SETA  &COUNT/8                 GET NUMBER OF BYTES
&NAME    DS    &COUNT.C
.END     MEXIT
.ERR     MNOTE '**BIT COUNT FLDS DO NOT TOTAL MULTIPLE OF 8**'
         MEXIT
.EQU     AIF   ('&SYSLIST(&OP,4)' NE '').EQU1     TEST FOR NULL LABEL
.ERR4    MNOTE '**EQU OPERAND OMITTED OR NOT FOUND**'
         MEXIT
.EQU1    AIF   (&SYSLIST(&OP,2) LT 16).EQU2  COUNT OVER FIFTEEN
*****               THE FOLLOWING STATEMENT                *****
*****     NUMBER OF BITS EXCEED 15 - DO NOT USE AS BIN     *****
.EQU2    ANOP
&EQUCNT  SETA  0                        CLEAR COUNTER
&EQUSYM  SETC  '&SYSLIST(&OP,4)'        GET EQU OPERAND
.EQULOP  ANOP
&EQUCNT  SETA  &EQUCNT+1                INCREMENT INDEX
         AIF   ('&ITEM(&EQUCNT)' EQ '&EQUSYM').EQUOUT  LABEL FOUND?
         AIF   (&EQUCNT EQ &ITEMNBR).ERR4    ALL TESTED?
         AGO   .EQULOP                  NO-GET NEXT
.EQUOUT  ANOP
&ITEM(&ITEMNBR) SETC '&SYMBOL'          GET LABEL NAME
&BITS(&ITEMNBR) SETA &SYSLIST(&OP,2)    GET NUMBER OF BITS
&SHIFT(&ITEMNBR) SETA &SHIFT(&EQUCNT)   GET SHIFT COUNT
&SYMBOL  EQU   &EQUSYM                  THIS SYMBOL EQUATED
         AGO   .START                   RETURN FOR NEXT
         MEND
         EJECT
*  LINE MACRO     LINE MACRO     LINE MACRO     LINE MACRO            *
         SPACE 2
         MACRO
&NAME    LINE  &DATA,&LABEL,&SKIP=
.*                            THIS MACRO ESTABLISHES THE MARGINS OR
.*                                 COLUMN SETTINGS FOR EACH LINE. IT
.*                                 GENERATES NECESSARY CARRIAGE CONTROL
.*                                 ENTRIES. LASTLY IT DETERMINES THE
.*                                 NUMBER OF ENTRIES ASSOCIATED WITH
.*                                 THE PREVIOUS LINE AND STORES THAT #
.*                                 INTO THE APPROPRIATE BYTE.
.*                            &DATA(1) - CHARACTER POSITION TO BEGIN
.*                                 DATA.
.*                            &DATA(2) - # OF SPACES BETWEEN SUCCESSIVE
.*                                 DATA COLUMN STARTING CHARACTERS.
.*                            &LABEL(1) - CHAR. POS. TO BEGIN LABELS.
.*                            &LABEL(2) - # SPACES BETWEEN LINE'S LABEL
.*                                 STARTING CHARACTERS.
.*                            &SKIP= - # OF LINES TO ADVANCE CARRIAGE
.*                                 TO BEGIN NEXT PRINTED LINE.
.*                            NEW ENTRIES ARE GENERATED ONLY WHEN
.*                                 NECESSARY. OMISSION OF ITEMS MEANS
.*                                 THEY HAVE NOT CHANGED SINCE PREVIOUS
.*                                 SETTINGS. A LINE MACRO IS REQUIRED
.*                                 FOR EACH PRINTED LINE. IF NO SETTING
.*                                 CHANGES ARE REQUIRED ALL OPERANDS
.*                                 ARE OMITTED IN WHICH CASE ONLY THE
.*                                 # OF ENTRIES FOR THE PREVIOUS LINE
.*                                 IS COMPUTED. THIS MACRO MUST BE THE
.*                                 FIRST MACRO INSTRUCTION ISSUED FOR
.*                                 THE SUBJECT LINE
         GBLA  &DB,&DT,&LB,&LT,&NRENTS
         GBLA  &LASTCC,&INITIAL
         GBLC  &NRENTSX
         GBLC  &CARRCON
         GBLB  &TEST
         LCLA  &S
&NAME    DS    0C
         AIF   (&INITIAL EQ 0).FIRSTLN
         LINEND
         AGO   .NTFIRST
.FIRSTLN ANOP
&NRENTSX SETC  'N&SYSNDX'
&INITIAL SETA  1
N&SYSNDX EQU   *
.NTFIRST ANOP
         DC    AL1(0)
         AIF   ('&DATA(1)' EQ '').CKDTABS
         AIF   (&DATA(1) EQ &DB).CKDTABS
&DB      SETA  &DATA(1)
         AGO   .AA
.CKDTABS AIF   ('&DATA(2)' EQ '').NCDATA
         AIF   (&DATA(2) EQ &DT).NCDATA
         AGO   .CC
.AA      AIF   ('&DATA(2)' EQ '').BB
         AIF   (&DATA(2) EQ &DT).BB
.CC      ANOP
&DT      SETA  &DATA(2)
.BB      DC    XL2'FFFE'
         DC    FL1'&DB'
         DC    FL1'&DT'
&NRENTS  SETA  &NRENTS+1
.NCDATA  ANOP
         AIF   ('&LABEL(1)' EQ '').CKLTABS
         AIF   (&LABEL(1) EQ &LB).CKLTABS
&LB      SETA  &LABEL(1)
         AGO   .AAA
.CKLTABS AIF   ('&LABEL(2)' EQ '').NCLABEL
         AIF   (&LABEL(2) EQ &LT).NCLABEL
         AGO   .CCC
.AAA     AIF   ('&LABEL(2)' EQ '').BBB
         AIF   (&LABEL(2) EQ &LT).BBB
.CCC     ANOP
&LT      SETA  &LABEL(2)
.BBB     DC    XL2'FFFF'
         DC    FL1'&LB'
         DC    FL1'&LT'
&NRENTS  SETA  &NRENTS+1
.NCLABEL ANOP
         AIF   ('&SKIP' NE '').CONT
         AIF   (&TEST EQ 0).NOCHANG
&S       SETA  &LASTCC
         AGO   .DEFAULT
.CONT    ANOP
         AIF   (&TEST EQ 0).AB
&S       SETA  &SKIP
.DEFAULT ANOP
         ORG   &CARRCON+3
         DC    AL.3(0),AL.2(&S),AL.3(1)
         ORG
&LASTCC  SETA  &S
&TEST    SETB  0
         AGO   .DD
.AB      AIF   (&SKIP EQ &LASTCC).NOCHANG
A&SYSNDX DC    XL2'FFFB'
         DC    AL.3(0),AL.2(&SKIP),AL.3(1)
         DC    FL1'9'
&LASTCC  SETA  &SKIP
&TEST    SETB  1
&CARRCON SETC  'A&SYSNDX'
&NRENTS  SETA  &NRENTS+1
.DD      ANOP
.NOCHANG ANOP
         MEND
         EJECT
*  BIN MACRO     BIN MACRO     BIN MACRO     BIN MACRO     BIN MACRO  *
         SPACE 2
         MACRO
         BIN
.*                                 &SYSLIST(&OP,1) - NAME OF LOG ITEM
.*                                      RECORD DSECT
.*                                 $SYSLIST(&OP,2) - NBR OF SPACES
.*                                      TO SKIP ON MULTIPLE
.*                                      PRINT OR NBR OF SPACES
.*                                      TO BACK UP FROM COLUMN FOR
.*                                      START OF PRINTING. THE LETTER
.*                                      B PRECEEDS THE NUMBER (B5) IF
.*                                      THE LATTER IS DESIRED. OMISSION
.*                                      OF THIS OPERAND FORCES OPTION 2
.*                                      WITH BACKUP SPACING EQUAL TO
.*                                 THE NUMBER OF BITS IN THE ITEM
.*                                 DEFINITION (VIA MACRO 'DSGEN').
.*                            A LIMIT OF 15 BITS IS IMPOSED FOR THE
.*                                 TOTAL NUMBER OF BITS TO PRINT.
         GBLC &ITEM(1500)
         GBLA &ITEMNBR,&BITS(1500),&SHIFT(1500),&NRENTS
         GBLC  &DSECT
         LCLB  &B,&SUB
         LCLA  &IBITS,&NDX,&ISHIFT,&K
         LCLA  &TEMP,&T,&OP
         LCLC  &S
         AIF   (K'&SYSLIST(1) EQ K'&SYSLIST(1,1)).LOOP
&SUB     SETB  1
.LOOP    ANOP
&OP      SETA  &OP+1
.LOOP1   ANOP
&NDX     SETA  &NDX+1
         AIF   ('&ITEM(&NDX)' EQ '&SYSLIST(&OP,1)').FOUND
         AIF   (&NDX LT &ITEMNBR).LOOP1
         MNOTE *,'YOU BLEW IT'
         ROUTINE DUM,SKIPPER
         MEXIT
.FOUND   ANOP
&ISHIFT  SETA  &SHIFT(&NDX)
&IBITS   SETA  &BITS(&NDX)
&T       SETA  &IBITS-1
&B       SETB  0
         AIF   (&SUB EQ 1).SUBA
         AIF   ('&SYSLIST(2)' EQ '').BACKUP
&K       SETA  K'&SYSLIST(2)
&B       SETB  ('&SYSLIST(2)'(1,1) EQ 'B')
&S       SETC  '&SYSLIST(2)'(&B+1,&K-&B)
         AGO   .SUBB
.SUBA    ANOP
         AIF   ('&SYSLIST(&OP,2)' EQ '').BACKUP
&K       SETA  K'&SYSLIST(&OP,2)
&B       SETB  ('&SYSLIST(&OP,2)'(1,1) EQ 'B')
&S       SETC  '&SYSLIST(&OP,2)'(&B+1,&K-&B)
.SUBB    ANOP
&T       SETA  &S
.BACKUP  ANOP
&NRENTS  SETA  &NRENTS+1
&TEMP    SETA  &ISHIFT
         AIF   (&IBITS NE 1 OR &B NE 0).BIN2
         DC    AL.12(&SYSLIST(&OP,1)-&DSECT),XL.4'&TEMP'
         AGO   .OUT
.BIN2    AIF   ('&SYSLIST(&OP,2)' NE '').BIN3
&B       SETB  1
.BIN3    ANOP
         DC    AL.12(&SYSLIST(&OP,1)-&DSECT),XL.4'C'
         DC    BL.1'&B',AL.7(&T),AL.4(&IBITS),FL.4'&ISHIFT'
.OUT     ANOP
&NDX     SETA  0
         AIF   (&SUB EQ 0).OUTA
         AIF   (&OP LT N'&SYSLIST).LOOP
.OUTA    ANOP
         MEND
         EJECT
*  HEX MACRO     HEX MACRO     HEX MACRO    HEXN MACRO     HEX MACRO  *
         SPACE 2
         MACRO
         HEX   &LOGITEM,&SKIP$OR,&BYTES
.*                            THIS MACRO FACILITATES GENERATION OF THE
.*                                 TABLE ENTRIES SPECIFYING HEX TYPE
.*                                 CONVERSIONS.
.*                            &LOGITEM - NAME OF DATA ITEM TO BE
.*                                 CONVERTED
.*                            &SKIP$OR - NUMBER OF SPACES TO SKIP ON
.*                                 MULTIPLE PRINT OR NBR OF SPACES TO
.*                                 BACK UP FROM COLUMN FOR START OF
.*                                 PRINTING. THE LETTER B PRECEEDS THE
.*                                 NUMBER (B8) IF THE LATTER OPTION IS
.*                                 DESIRED. OMISSION OF THIS OPERAND
.*                                 FORCES OPTION 2 WITH BACKUP SPACING
.*                                 EQUAL TO THE NUMBER OF BYTES SPECI-
.*                                 FIED BY THE NEXT OPERAND (TWICE THIS
.*                                 NUMBER IF SUFFIX IS EXPLICITLY OR
.*                                 IMPLICITLY B).
.*                            &BYTES - NUMBER OF TOTAL INPUT BYTES TO
.*                                 PROCESS. THIS NUMBER IS SUFFIXED
.*                                 WITH AN L,R, OR B TO STIPULATE
.*                                 PRINTING OF THE LEFT HALF, RIGHT
.*                                 HALF, OR BOTH HALVES OF THE BYTE
.*                                 RESPECTIVELY. OMISSION OF THIS
.*                                 OPERAND DEFAULTS TO B WITH THE NUM-
.*                                 BER OF BYTES EQUAL TO THE ITEM LNGTH
.*                            A NEW ENTRY IS GENERATED ONLY WHEN NECES-
.*                                 SARY. THIS MACRO MUST BE THE FIRST
.*                                 MACRO INSTRUCTION ISSUED FOR THE
.*                                 SUBJECT LINE(S).
         GBLC  &ITEM(1500),&DSECT
         GBLA  &ITEMNBR,&BITS(1500),&SHIFT(1500),&NRENTS
         LCLB  &B
         LCLA  &IBITS,&NDX,&ISHIFT,&K,&T,&CODE,&BYTESP
         LCLC  &S,&LETTER
.LOOP    ANOP
&NDX     SETA  &NDX+1
         AIF   ('&ITEM(&NDX)' EQ '&LOGITEM').FOUND
         AIF   (&NDX LT &ITEMNBR).LOOP
         MNOTE *,'LOG ITEM NOT DEFINED'
         MEXIT
.FOUND   ANOP
&ISHIFT  SETA  &SHIFT(&NDX)
&IBITS   SETA  &BITS(&NDX)
&CODE    SETA  1
&K       SETA  K'&BYTES
         AIF   (&IBITS-(&IBITS/4)*4 EQ 0).OK
         MNOTE *,'BIT LENGTH SPECIFICATION INCONSISTENT WITH CONTROL'
         MEXIT
.OK      AIF   ('&BYTES' EQ '').USEDEFN
&LETTER  SETC  '&BYTES'(&K,1)
&S       SETC  '&BYTES'(1,&K-1)
&BYTESP  SETA  &S
         AIF   ('&LETTER' EQ 'B').BOTH
         AIF   (&ISHIFT EQ 0 OR &ISHIFT EQ 4).OK2
.ERR     MNOTE *,'DATA NOT ALLIGNED ON HEX OR BYTE BOUNDARY'
         MEXIT
.USEDEFN ANOP
&BYTESP  SETA  &IBITS/8
.BOTH    AIF   (&ISHIFT NE 0).ERR
&CODE    SETA  3
&T       SETA  &BYTESP*2-1                                       XM5997
&S       SETC  '&T'
.OK2     AIF   (&ISHIFT EQ 0).L
&CODE    SETA  2
.L       ANOP
&B       SETB  1
         AIF   ('&SKIP$OR' EQ '').BACKUP
&K       SETA  K'&SKIP$OR
&B       SETB  ('&SKIP$OR'(1,1) EQ 'B')
&S       SETC  '&SKIP$OR'(&B+1,&K-&B)
.BACKUP  ANOP
&NRENTS  SETA  &NRENTS+1
         DC    AL.12(&LOGITEM-&DSECT),XL.4'A'
         DC    BL.1'&B',FL.7'&S',FL.4'&BYTESP',FL.4'&CODE'
.OUT     ANOP
         MEND
         EJECT
*  ROUTINE MACRO     ROUTINE MACRO     ROUTINE MACRO     ROUTINE MACRO*
         SPACE 2
         MACRO
&NAME    ROUTINE &LOGITEM,&RNAME
         GBLC  &DSECT,&CSECT
         GBLC  &ITEM(1500)
         GBLA  &SHIFT(1500),&ITEMNBR
         GBLA  &NRENTS
         LCLA  &ISHIFT,&NDX
.LOOP    ANOP
&NDX     SETA  &NDX+1
         AIF   ('&ITEM(&NDX)' EQ '&LOGITEM').FOUND
         AIF   (&NDX LT &ITEMNBR).LOOP
         MNOTE *,'LOG ITEM NOT DEFINED'
         MEXIT
.FOUND   ANOP
&ISHIFT  SETA  &SHIFT(&NDX)
&NAME    DC    AL.12(&LOGITEM-&DSECT),XL.4'D'
         DC    AL.4(&ISHIFT),AL.12(&RNAME-&CSECT)
&NRENTS  SETA  &NRENTS+1
         MEND
         EJECT
*  LABEL MACRO     LABEL MACRO     LABEL MACRO     LABEL MACRO        *
         SPACE 2
         MACRO
&NAME    LABEL &LABEL1,&LABEL2,&LABEL3,&LABEL4,&LABEL5,&LABEL6,        C
               &LABEL7,&LABEL8
.*                            THIS MACRO ALLOWS UP TO ACHT LABELS TO
.*                                 BE SPECIFIED FOR A GIVEN LINE. THE
.*                                 LABELS SHOULD BE ENCLOSED IN QUOTA-
.*                                 TION MARKS. THE COLUMN AND LINE END
.*                                 CONTROLS WILL BE INSERTED BY THE
.*                                 MACRO. OMITTED OPERANDS MEAN NO
.*                                 LABEL REQUIRED FOR RESPECTIVE
.*                                 COLUMN. THIS MACRO WILL ALSO ALERT
.*                                 THE PROGRAMMER TO EXACTLY WHERE THE
.*                                 TABLE MUST BE BROKEN IF NECESSARY
.*                                 TO AVOID EXCEEDING THE MAXIMUM LIMIT
         GBLC &LABELS(2000)
         GBLC  &LBL(100)
         GBLA  &LBLCTR(100)
         GBLA  &LABELNR
         GBLA  &NRENTS,&LPTR
         LCLC  &MARGIN,&TACK
         LCLC  &TEXT
         LCLA  &OP,&K,&START,&NRCHAR,&REMAIN
&MARGIN  SETC  '*'
         AIF   ('&NAME' EQ '').LOOPOUT
&LPTR    SETA  &LPTR+1
&LBL(&LPTR) SETC '&NAME'
&LBLCTR(&LPTR) SETA &LABELNR+1
.LOOPOUT ANOP
&OP      SETA  &OP+1
&K       SETA  K'&SYSLIST(&OP)
         AIF (&K GE 2).NORM
&K       SETA  2
.NORM    ANOP
&START   SETA  2
         AIF (&OP LT N'&SYSLIST).NOTLAST
&MARGIN  SETC  '$'
.NOTLAST ANOP
&NRCHAR  SETA  8
&TACK    SETC  ''
.LOOPIN  ANOP
&REMAIN  SETA  &K-&START
         AIF (&REMAIN GE 8).MORE
&TACK    SETC  '&MARGIN'
&NRCHAR  SETA  &REMAIN
.MORE    ANOP
&TEXT    SETC  ''
         AIF (&REMAIN EQ 0).ENDTEXT
&TEXT    SETC  '&SYSLIST(&OP)'(&START,&NRCHAR)
.ENDTEXT ANOP
&LABELNR SETA  &LABELNR+1
&LABELS(&LABELNR) SETC '&TEXT'.'&TACK'
&START   SETA  &START+8
         AIF ('&TACK' EQ '').LOOPIN
         AIF ('&TACK' EQ '*').LOOPOUT
         MEND
         SPACE 2
         MACRO
         LSTART
.*                            THIS MACRO IS ISSUED WHEN THE LABEL AREA
.*                                 OF THE TABLE IS TO BEGIN.
         GBLC &LABELS(2000)
         GBLA  &LABELNR
         GBLC  &LBL(100)
         GBLA  &LBLCTR(100)
         LCLA  &NDX,&CTR
         LINEND
&CTR     SETA  1
.LOOP    ANOP
&NDX     SETA  &NDX+1
         AIF   (&LBLCTR(&CTR) NE &NDX).NOLBL
&LBL(&CTR) DC  C'&LABELS(&NDX)'
&CTR     SETA  &CTR+1
         AGO   .LOOPCTL
.NOLBL   ANOP
         DC    C'&LABELS(&NDX)'
.LOOPCTL AIF   (&NDX LT &LABELNR).LOOP
         MEND
         SPACE 2
         MACRO
         LINEND
.*                            THIS MACRO IS USED ONLY BY THE LINE
.*                                 MACRO TO SET THE NUMBER OF ENTRIES
.*                                 ASSOCIATED WITH EACH LINE.
         GBLA  &NRENTS
         GBLC &NRENTSX
         ORG   &NRENTSX
         DC    FL1'&NRENTS'
         ORG
&NRENTS  SETA  0
B&SYSNDX EQU   *
&NRENTSX SETC  'B&SYSNDX'
         MEND
         SPACE 2
         MACRO
         PARITY &ENTRY,&REPEAT,&SPACES,&PBITS=,&DISP=,&OFFBYTE=
         GBLC  &ITEM(1500),&DSECT
         GBLA  &SHIFT(1500),&ITEMNBR
         LCLA  &IBITS,&NDX,&ISHIFT
         DC    AL4(&ENTRY)
         DC    AL1(&REPEAT)
         DC    AL1(&SPACES)
         AIF   ('&PBITS' EQ '').HARDCD
.LOOP    ANOP
&NDX     SETA  &NDX+1
         AIF   ('&ITEM(&NDX)' EQ '&PBITS').FOUND
         AIF   (&NDX LT &ITEMNBR).LOOP
         MNOTE *,'PARITY GROUP NOT FOUND'
         MEXIT
.FOUND   ANOP
&ISHIFT  SETA  &SHIFT(&NDX)
         DC    AL.12(&PBITS-&DSECT),AL.4(&ISHIFT)
         AGO   .OUT
.HARDCD  ANOP
&ISHIFT  SETA  &OFFBYTE
         DC    AL.12(&DISP),AL.4(&ISHIFT)
.OUT     ANOP
         MEND
         GBLC  &DSECT,&CSECT
&CSECT   SETC  'IFCEI135'
&DSECT   SETC  'CI135'
IFCEI135 CSECT
CI135    DSECT
         DS    0F
         DSGEN (XKEY,8),(XRELN,8),(XSWS8,9),(XSWS9,1),(XSWS10,1),      C
               (XSWS11,1),                                             C
               (XSWS12,1),(XSWS13,1),(XSWS14,1),(XSWS15,1)
         DSGEN (XDUM1,32)
         DSGEN (XDATE,32)
         DSGEN (XTIME,32)
         DSGEN (XDUM2,8),(XSER,24)
         DSGEN (XMOD,16),(MCEL,16)
         DSGEN (XJOBN,64)
         DSGEN (XAIO1,16),(XAIO2,16),(XAIO3,16),(XAIO4,16)
         DSGEN (XAIO5,16),(XAIO6,16),(XAIO7,16),(XAIO8,16)
         DSGEN (XFCCWCC,8),(XFCCWDA,24),(XFCCWFL,8),(XFCCW0,8),        C
               (XFCCWCT,16)
         DSGEN (XCSWK,8),(XCSWCA,24)
         DSGEN (XCSWUS0,1),(XCSWUS1,1),(XCSWUS2,1),(XCSWUS3,1),        *
               (XCSWUS4,1),(XCSWUS5,1),(XCSWUS6,1),(XCSWUS7,1),        *
               (XCSWCS0,1),(XCSWCS1,1),(XCSWCS2,1),(XCSWCS3,1),        *
               (XCSWCS4,1),(XCSWCS5,1),(XCSWCS6,1),(XCSWCS7,1),        *
               (XCSWCT,16)
         DSGEN (XECSW,32)
         DSGEN (XDEVT1,16),(XDEVT2,16)
         DSGEN (XCHID,8),(XCUA,24)
         DSGEN (XMPIN,32)
         DSGEN (XDUM3,32)                                       XA04755
         DSGEN (MCHRG00,1),(MCHRG01,1),(MCHRG02,1),(MCHRG03,1),        X
               (MCHRG04,1),(MCHRG05,1),(MCHRG06,1),(MCHRG07,1),        X
               (MCHRG08,1),(MCHRG09,1),(MCHRG10,1),(MCHRG11,1),        X
               (MCHRG12,1),(MCHRG13,1),(MCHRG14,1),(MCHRG15,1),        X
               (MCHRG16,1),(MCHRG17,1),(MCHRG18,1),(MCHRG19,1),        X
               (MCHRG20,1),(MCHRG21,1),(MCHRG22,1),(MCHRG23,1),        X
               (MCHRG24,1),(MCHRG25,1),(MCHRG26,1),(MCHRG27,1),        X
               (MCHRG28,1),(MCHRG29,1),(MCHRG30,1),(MCHRG31,1)
         DSGEN (BUFADRG,16)
         DSGEN (ZONER00,1),(ZONER01,3),(ZDUMY,1),(ZONER03,3),  @XA06108X
               (SAREG00,24)
SEL135   DSGEN (BFCTRG00,1),(BFCTRG01,1),(BFCTRG02,1),(BFCTRG03,1),    X
               (BFCTRG04,1),(BFCTRG05,1),(BFCTRG06,2),                 X
               (BFCTRG08,1),(BFCTRG09,1),(BFCTRG10,1),(BFCTRG11,1),    X
               (BFCTRG12,1),(BFCTRG13,3),                              X
               (BFCTRG16,1),(BFCTRG17,1),(BFCTRG18,1),(BFCTRG19,1),    X
               (BFCTRG20,1),(BFCTRG21,1),(BFCTRG22,1),(BFCTRG23,1),    X
               (BFCTRG24,1),(BFCTRG25,1),(BFCTRG26,1),(BFCTRG27,1),    X
               (BFCTRG28,1),(BFCTRG29,1),(BFCTRG30,1),(BFCTRG31,1)
         DSGEN (DUMMY00,16)
         DSGEN (CHANTG00,1),(CHANTG01,1),(CHANTG02,1),(CHANTG03,1),    X
               (CHANTG04,1),(CHANTG05,1),(CHANTG06,1),(CHANTG07,1),    X
               (CHANTG08,1),(CHANTG09,1),(CHANTG10,1),(CHANTG11,1),    X
               (CHANTG12,1),(CHANTG13,1),(CHANTG14,1),(CHANTG15,1),    X
               (CHANTG16,1),(CHANTG17,1),(CHANTG18,1),(CHANTG19,1),    X
               (CHANTG20,1),(CHANTG21,1),(CHANTG22,1),(CHANTG23,1),    X
               (CHANTG24,1),(CHANTG25,1),(CHANTG26,1),(CHANTG27,1),    X
               (CHANTG28,1),(CHANTG29,1),(CHANTG30,1),(CHANTG31,1)
         DSGEN (CHCTRG00,1),(CHCTRG01,1),(CHCTRG02,1),(CHCTRG03,1),    X
               (CHCTRG04,1),(CHCTRG05,1),(CHCTRG06,1),(CHCTRG07,1),    X
               (CHCTRG08,1),(CHCTRG09,1),(CHCTRG10,1),(CHCTRG11,1),    X
               (CHCTRG12,1),(CHCTRG13,1),(CHCTRG14,1),(CHCTRG15,1),    X
               (CHCTRG16,1),(CHCTRG17,1),(CHCTRG18,1),(CHCTRG19,1),    X
               (CHCTRG20,1),(CHCTRG21,1),(CHCTRG22,1),(CHCTRG23,1),    X
               (CHCTRG24,1),(CHCTRG25,1),(CHCTRG26,1),(CHCTRG27,1),    X
               (CHCTRG28,1),(CHCTRG29,1),(CHCTRG30,1),(DUMMY,1)
         DSGEN (CHANCK0,1,0,7),(DUM,8,0,2)                      XA00642
         DSGEN (CHK0,16,EQU,MCHRG00),(CHK1,16,EQU,MCHRG16)
         EJECT
*
IFCEP000 DSECT
         DS    CL6
         DS    CL1
         DS    CL1
XPRTBUF  DS    15CL8
         DS    5CL8
         DS    3CL8
         DS    CL8
XSWITCH  DS    CL4
*
*      ROUTINE BRANCH TABLE
*
         DS    CL112
*
*      LOAD MODULE ENTRYPOINT NAMES
*
         DS    CL56
*
*      READ/WRITE BUFFER
*
XMCH     DC    XL2'00'
XCNTBUF  DS    CL8
XKEYBUF  DS    CL2
XDADBUF  DS    197CL8
XDUMMY   DS    CL1
         SPACE 3
ERPIB    DSECT                                                    19032
SOFWFLGS DS    CL1                 PROGRAM FLAGS FIELD IN ERPIB   19032
PROBERR  DS    CL1                 PROBABLE SOURCE OF ERROR FIELD 19032
VALFLAGS DS    CL1                 VALIDITY FLAGS FIELD           19032
CMPLBITS DS    CL1                 TERM AND RETRY CODES FIELD     19032
MPINFOFD DS    CL2                 MULTI-PROCESSING INFO FIELD    19032
CHSMS    DS    CL2                 CHANNEL STATUS FIELD           19032
         EJECT
IFCEI135 CSECT
ENTRYPTR DC    A(FORMAT1)
TABLNAME DC    CL8'IFCEI135'
REG9     DS    F
LP       DS    F
         SPACE 2
SPCLCODE EQU   *
SKIPPER  EQU   *
         BR    14
R0       EQU   0
R1       EQU   1
R2       EQU   2
R3       EQU   3
R4       EQU   4
R5       EQU   5
R6       EQU   6
R7       EQU   7
R8       EQU   8
R9       EQU   9
R10      EQU   10
R11      EQU   11
R12      EQU   12
R13      EQU   13
R14      EQU   14
R15      EQU   15
****    ADDRESS EQUATES
AD0      EQU   0
AD1      EQU   1
AD4      EQU   4
AD12     EQU   12
AD13     EQU   13
AD14     EQU   14
AD15     EQU   15
AD16     EQU   16
AD20     EQU   20
AD37     EQU   37
AD41     EQU   41
AD45     EQU   45
AD55     EQU   55
AD63     EQU   63
AD69     EQU   69
AD108    EQU   108
***   LENGTH EQUATES
L0       EQU   0
L1       EQU   1
L2       EQU   2
L3       EQU   3
L4       EQU   4
L5       EQU   5
L6       EQU   6
L7       EQU   7
L8       EQU   8
L9       EQU   9
L10      EQU   10
L12      EQU   12
L13      EQU   13
L14      EQU   14
L15      EQU   15
L16      EQU   16
L19      EQU   19
L20      EQU   20
L21      EQU   21
L22      EQU   22
L24      EQU   24
L26      EQU   26
L29      EQU   29                                              @XA06108
L31      EQU   31
L32      EQU   32
L40      EQU   40
L60      EQU   60
***   CONDITION CODE EQUATES
CC1      EQU   1
CC2      EQU   2
CC4      EQU   4
CC7      EQU   7
CC8      EQU   8
****    NUMERICAL EQUATES
X01      EQU   X'01'
X02      EQU   X'02'
X04      EQU   X'04'
X08      EQU   X'08'
X09      EQU   X'09'
X10      EQU   X'10'
X20      EQU   X'20'
X30      EQU   X'30'
X40      EQU   X'40'
X80      EQU   X'80'
HEXBF    EQU   X'BF'
HEX48    EQU   X'48'
HEX02    EQU   X'02'
HEX04    EQU   X'04'
HEX08    EQU   X'08'
HEX10    EQU   X'10'
HEX20    EQU   X'20'
HEX40    EQU   X'40'
HEX22    EQU   X'22'
HEX28    EQU   X'28'
HEX2A    EQU   X'2A'
HEX29    EQU   X'29'
HEX01    EQU   X'01'
HEX00    EQU   X'00'
DIV1     EQU   X'0A'
DIV2     EQU   X'0C'
K1       EQU   1
K3       EQU   3
***********************************************************************
*                                                                     *
*                                                                     *
*    ROUTINE TO PICK UP THE CHANNEL ADDRESS WHICH IS NOT ON A BYTE    *
*   BOUNDRY, CONVERT IT TO HEX AND STORE IT IN THE PRINT BUFFER.      *
*                                                                     *
*                                                                     *
***********************************************************************
         SPACE 2
@CHANADR DS    0F
         USING *,15
         STM   14,12,12(13)        SAVE THE REGS
         MVC   MYWORK(1),0(4)
         NI    MYWORK,X'07'
         OI    MYWORK,X'F0'
         S     R3,ONE
         MVC   0(1,3),MYWORK
         LM    14,12,12(13)        RESTORE THE REGS
         BR    14                  RETURN
*
         DROP  R15
         USING IFCEI135,R9
SETSOURC STM   R5,R8,XSAVE              SAVE REGS
         MVC   L0(L3,R3),CCCH           MOVE CHANNEL RECORD
         CLI   L0(R4),HEX20             TEST REC SOURCE
         BE    RETURN
         MVC   L0(L3,R3),MCHH           MOVE MCH RECORD
         B     RETURN                   RETURN
*
CONVREL  STM   R5,R8,XSAVE              SAVE WORK REGS
         SR    R6,R6                    CLEAR R6
         IC    R6,L0(R4)                PICK UP REL & SYS VALUES
         SRDL  R6,L5                    SAVE REL NO IN R7
        SLL   R6,L2                    MULTIPLY SYS VALUE BY 4
         L     R8,XLABELP               PICK UP LABEL POINTER
         LA    R6,RELTAB(R6)            INDEX INTO TABLE OF SYSTEMS
         MVC   L0(L4,R8),L0(R6)         MOVE SYSTEM NAME INTO LABEL
         SR    R6,R6                    CLEAR R6
         SLDL  R6,L5                    RETREIVE REL NO.
         LTR   R6,R6                    IS IT ZERO
         BZ    NOREL                    BR-YES
         CVD   R6,WORK                  CONVERT IT
         UNPK  L0(L2,R3),WORK+L6(L2)    UNPACK IT INTO PRINT BUFF
         MVZ   L1(L1,R3),L0(R3)         MOVE ON PROPER ZONE
         B     RETURN                   EXIT
NOREL    MVC   L0(L4,R3),NONE           MOVE IN NONE FOR REL
         B     RETURN
*
SETPGMN  MVC   L0(L8,R3),L0(R4)         MOVE 8 CHAR NAME TO BUFF
         BR    R14
*
SPACER2  LA    R3,L2(R3)                BUMP R3 PTR BY 2
         BR    R14
*
SETHEX   STM   R5,R8,XSAVE              SAVE REGS
         LA    R8,CHARS                 CHAR TABLE PTR
         IC    R7,L0(R4)                PICK UP CHAR
         SLL   R7,L24                   MOVE IT TO HI POS
         SR    R6,R6
         SLDL  R6,L4                    MOVE 4 BITS TO R6
         AR    R6,R8                    INDEX FOR CHARS
         MVC   L0(L1,R3),L0(R6)         MOVE CHAR TO BUFF
         SR    R6,R6
         SLDL  R6,L4                    MOVE LAST 4 BITS TO R6
         AR    R6,R8                    INDEX INTO TABLE
         MVC   L1(L1,R3),L0(R6)         MOVE CHAR
         B     RETURN
*
*
CYCLFLG  STM   R5,R8,XSAVE         SAVE REGS                   @XA06108
         MVC   QSAVE(L1),L0(R4)    CYCLE FLAG TO WORK AREA     @XA06108
         NI    QSAVE,X'80'         SAVE ONLY CYCLE FLAG        @XA06108
         SR    R7,R7               CLEAR REG 7                 @XA06108
         IC    R7,QSAVE            CYCLE FLAG TO REG 7         @XA06108
         SRL   R7,7                CYCLE FLAG TO LOW ORDER     @XA06108
         B     ZONE10              GO TO CHARACTER MOVE        @XA06108
ZONE10   LA    R8,CHARS            GET CHARACTER STRING        @XA06108
         AR    R8,R7               INDEX INTO CHARACTER STRING @XA06108
         L     R6,XLABELP          GET LABEL ADDRESS           @XA06108
         MVC   L29(L1,R6),L0(R8)   MOVE CHARACTER TO LABEL     @XA06108
         B     RETURN                                          @XA06108
CYCLZON  STM   R5,R8,XSAVE         SAVE REGS                   @XA06108
         MVC   QSAVE(L1),L0(R4)    CYCLE ZONE TO WORK AREA     @XA06108
         NI    QSAVE,X'70'         GET CYCLE ZONE ONLY         @XA06108
         SR    R7,R7               CLEAR REG 7                 @XA06108
         IC    R7,QSAVE            CYCLE ZONE TO REG 7         @XA06108
         SRL   R7,4                SHIFT TO LOW ORDER          @XA06108
         B     ZONE10              GO TO CHARACTER MOVE        @XA06108
DATAZON  STM   R5,R8,XSAVE         SAVE REGS                   @XA06108
         MVC   QSAVE(L1),L0(R4)    DATA ZONE TO WORK AREA      @XA06108
         NI    QSAVE,X'07'         GET ONLY DATA ZONE          @XA06108
         SR    R7,R7               CLEAR REG 7                 @XA06108
         IC    R7,QSAVE            DATA ZONE TO REG 7          @XA06108
         B     ZONE10              GO TO CHARACTER MOVE        @XA06108
*
*                              SET ACTIVE  I/O UNITS
SETAIO   STM   R5,R8,XSAVE              SAVE REGS
         LR    R5,R3                    SET R5 TO BUFFER
         SH    R5,H43                   POINT R5 TO BEGGIN OF DATA
         SR    R7,R7
         LA    R6,L8                    LOOP COUNT
SETAIOLP CLC   L0(L4,R5),CZEROS         TEST FOR ALL ZEROS
         BE    BLANKOUT                 BE-TO BLANK OUT ZEROS
SETAIOL1 LA    R5,L5(R5)                BUMP COUNT
         BCT   R6,SETAIOLP              LOOP TILL 8 TESTS
         CH    R7,H8                    ARE ALL ACTIVE IO ZERO
         BNE   RETURN                   NO RETURN
         LR    R5,R3                    YES
         SH    R5,H43                   PUT IN NONE
         MVC   L0(L4,R5),NONE           INTO PRINT BUFF
         B     RETURN
BLANKOUT MVC   L0(L4,R5),BLANKS         MOVE IN BLANKS
         LA    R7,L1(R7)                COUNT # OF ZERO FLDS
         B     SETAIOL1                 LOOP
RETURN   LM    R5,R8,XSAVE
         BR    R14
*
*
CHKSW9   TM    L1(R4),HEX40             TEST SWITCHES
CHECKCC  BZ    NOPRT                    IF SWITCHES OFF
         BR    R14                      DONOT PRINT
CHKSW10  TM    L1(R4),HEX20             R15 RETURNED ZERO
         B     CHECKCC                  STOPS PRINTING
CHKSW11  TM    L1(R4),HEX10
         B     CHECKCC
CHKSW12  TM    L1(R4),HEX08
         B     CHECKCC
CHKSW13  TM    L1(R4),HEX04
         B     CHECKCC
CHKSW14  TM    L1(R4),HEX02
         B     CHECKCC
CHKSW15  TM    L1(R4),HEX01
         B     CHECKCC
NOPRT    SR    R15,R15
         BR    R14
*
SETDATE  UNPK  XWORK(L8),L0(L4,R4)      UNPACL DATE
         MVZ   XWORK+L7(L1),XWORK       SET ZONE
         MVC   L0(L3,R3),XWORK+L5       MOVE DAY
         MVC  L6(L2,R3),XWORK+L3
         BR    R14                      RETURN
*
CONVTIME TM    L0(R4),HEX48             TEST FOR NS/BIN CLOCK
         BZ    BINCLOCK                 ZERO IS BINARY CLOCK
         BO    RETURNB                  ONES IS FOR CONV TIME
         TM    L0(R4),HEX40             IF ON IS N/S CLOCK
         BO    NSCLOCK                  IF OFF TIME OK
RETURNB  BR    R14                      RETURN
*
         USING CI135,R2
NSCLOCK  STM   R14,R12,L12(R13)         SAVE REGS
         NI    L0(R4),HEXBF
         MVC   XWORK(L8),XDATE          MOVE DATE
         LM    R4,R5,XWORK
         SRDL  R4,L12                   POSITION FOR MICRO SECS
         D     R4,MILLION               CONVERT TO SECONDS
         SRA   R4,L19                   POSITION FOR ROUNDING
         AR    R5,R4                    UP TO NXT SECONDS
         SR    R4,R4
         D     R4,SIXTY                 CONVERT TO NINS
         CVD   R4,XWORK                 CONVERT IT
         LH    R6,XWORK+L6              PICK UP SECONDS
         SRL   R6,L4                    SHIFT OFF ZONE
         STC   R6,XDATE+L6              STORE SECONDS IN  REC
         MVI   XDATE+L7,HEX00           ZERO OUT TH'S
         SR    R4,R4
         D     R4,SIXTY                 CONVERT TO HRS
         CVD   R4,XWORK                 CONVERT REMAINDER MINUTES
         LH    R6,XWORK+L6              PICK UP
         SRL   R6,L4                    DROP ZONE
         STC   R6,XDATE+L5              STORE MINUTES
         SR    R4,R4
         D     R4,T24                   DIVIDE TO GET DAYS
         CVD   R4,XWORK                 CONV REM
         LH    R6,XWORK+L6              PICK UP
         SRL   R6,L4                    DROP ZONE
         STC   R6,XDATE+L4              STORE HRS
         LA    R4,L60                   STARTINY YEAR 1960
         LA    R6,L1                    INC OF 1
LEAPYEAR LA    R7,L3(R4)                ADD 3 YRS
         S     R5,LPYEAR                DAYS IN LEAP YEAR 366
         BZ    THISYEAR                 BR-THIS YR+1
         BM    OVERSHOT                 BR-TOOFAR
         BXLE  R4,R6,REGYEAR            UPDATE YEAR BY ONE
REGYEAR  S     R5,RGYEAR                DAYS IN RG YEAR 365
         BZ    THISYEAR                 BR-YEAR+1
         BM    OVERSHT1                 BR-TOO FAR
         BXLE  R4,R6,REGYEAR            UPDATE AND TRY AGAIN
         B     LEAPYEAR
OVERSHOT A     R5,LPYEAR                ADD BACK LEAP YEAR
         B     THISYEAR                 & USE
OVERSHT1 A     R5,RGYEAR                ADD BACK REG YEAR
         B     THISYER                  & USE
THISYEAR AR    R4,R6                    ADD 1
THISYER  AR    R5,R6                    ADD 1
         CVD   R5,XWORK                 CONVERT DAYS
         MVC   XDATE+L2(L2),XWORK+L6    MOVE DAYS
         CVD   R4,XWORK                 CONVERT YEAR
         LH    R6,XWORK+L6              PICK UP
         SRL   R6,L4                    DROP ZONE
         STC   R6,XDATE+L1              PUT YEAR
         MVI   XDATE,HEX00              SET TO ZERO
RETURNC  OI    XSWS8,HEX08              TURN ON PACKED SWITCH
         LM    R14,R12,L12(R13)         RETURN
         BR    R14
*
*
BINCLOCK STM   R14,R12,L12(R13)         SAVE REGS
         L     R3,XTIME                 PICK UP TIME IN BIN
         LTR   R3,R3                    TEST FOR ZERO
         BZ    RETURNC                  YES-RETURN
         SRL   R3,L1                    CONVERT
         M     R2,CONSTG                     TO
         D     R2,CONSTH                       DECIMAL
         LA    R4,L32                   BIT COUNTER
         MVI   TIMDIV+L3,DIV1           INITIAL DIVISOR (0A)
BCLOCKA  SR    R2,R2                    CLEAR
         D     R2,TIMDIV                DEVOLP DIGIT-REMAINDER
         LR    R0,R2                    SAVE REM
         SRDL  R0,L4                    SHIFT 4BITS
         SH    R4,H4                    DEC BY 4
         LTR   R3,R3                    DONE
         BZ    BCLOCKB                  BR-YES
         CH    R4,H24                   BITS LESS 24
         BNL   BCLOCKA                  BR-NO
         XI    TIMDIV+L3,DIV2           ALT DIV (0A XI 0C=06)
         B     BCLOCKA
BCLOCKB  SRL   R1,L0(R4)                MOVE TO FINAL POS
         ST    R1,XTIME                 STORE BACK
         B     RETURNC
NOLOG0   STM   R4,R7,ZSAVE         SAVE REGISTERS
         SH    R4,HTWO             POINTER TO KEY
         LA    R5,HDRCNT           PICK UP RECORD SIZE
         CLC   L0(L2,R5),L0(R4)    COMPARE FOR HDR LENGTH
         BNE   MSG2
         LA    R5,QUIT0-L4         GET DATA ADDRESS
         L     R15,RG9PTR          PICK UP R9 POINTER
         ST    R5,0(R15)           STORE INTO R9 POINTER
         SR    R15,R15
MSG2     LM    R4,R7,ZSAVE         RESTORE REGISTERS
         BR    R14                 RETURN
NXTBL    BR    R14
NOLOG    STM   R4,R7,ZSAVE
         SH    R4,HTWO
         LA    R5,HDRCNT
         CLC   L0(L2,R5),L0(R4)         TEST FOR LOGOUT PRESENT
         BE    ROUTMSG
         LA    R5,L2(R5)      UPDATE POINTER
         CLC   L0(L2,R5),L0(R4)
         BE    SHORTREC
         SR    R15,R15
ROUTMSG  LM    R4,R7,ZSAVE         RESTORE REGISTERS
         BR    R14
SHORTREC LA    R5,QUIT1-L4
         L     R15,RG9PTR
         ST    R5,0(R15)           STORE INTO R9 POINTER
         LM    R4,R7,ZSAVE
         BR    R14
SELCHAN  STM   R4,R7,ZSAVE
         CLI   AD0(R4),K1         TEST FO SEL OR OTHER LOG
         BE    MPXROUT
         LA    R5,NXTBL-L4         NEXT TABLE ADDRESS
         L     R15,RG9PTR
         ST    R5,0(R15)           STORE INTO R9 POINTER
         SR    R15,R15
MPXROUT  LM    R4,R7,ZSAVE
         BR    R14
ZSAVE    DS    4F
XLABELP  EQU   LP
RELTAB   DS    0C
         DC    C'OS  '
         DC    C'DOS '
         DC    C'VS 1'
         DC    C'V370'
         DC    C'VS 2'
         DC    C'    '
         DC    C'    '
         DC    C'    '
HDRCNT   DC    H'92'
         DC    H'128'
         DC    H'168'
HTWO     DC    H'2'
XWORK    DS    D
XSAVE    DS    4F
WORK     EQU   XWORK
CONSTG   DC    X'00030D40'
CONSTH   DC    X'024AE062'
MILLION  DC    F'1000000'
SIXTY    DC    F'60'
T24      DC    F'24'
LPYEAR   DC    F'366'
RGYEAR   DC    F'365'
TIMDIV   DC    F'1'
H4       DC    H'4'
H8       DC    H'8'
H24      DC    H'24'
H43      DC    H'43'
QUIT0    DC    X'FF'
         DC    XL2'5C'             SIZE OF TOTAL RECORD
         DC    XL2'5C'             HEADER
         DC    XL2'0'
QUIT1    DC    X'FF'
         DC    XL2'80'
         DC    XL2'5C'
         DC    XL2'0'
CHARS    DC    C'0123456789ABCDEF'
NONE     DC    C'NONE'
CONVERTD DC    C'CONVERTED'
CZEROS   DC    C'0000'
BLANKS   DC    C'    '
CCCH     DC    CL3'CCH'
MCHH     DC    CL3'MCH'
QSAVE    DC    X'00'                                           @XA06108
MYWORK   DC    F'0'
ONE      DC    F'1'
         EJECT
IFCASR01 DS    0H
         USING *,R15
         STM   R14,R12,12(R13)          SAVE REGISTERS
         ST    R13,SVR13                SAVE REG 13
         L     R11,NXENTRY              LOAD SUBROUTINE RETURN ADR
         LTR   R11,R11                  TEST FOR INITIAL ENTRY
         BZ    IFCASR02                 BRANCH IF 0-INITIAL ENTRY
         LM    R12,R10,MYSAVE           RELOAD SUBROUTINE REGS
         BR    R11                      CONTINUE PROCESSING
IFCASR02 DS    0H
         SH    R3,TWOX                  SUBTRACT 2 FROM PRNT BFR ADR
         MVC   L0(L1,R3),L1(R3)         MOVE PRINTER CNTRL CHAR
         LA    R3,L1(R3)                INCREMENT PRNT BFR ADR
         USING XDADBUF,R4
         USING XPRTBUF,R3
NEWMOVE  CLI   XKEYBUF+1,REL19          RELEASE 19                19E03
         BE    NEWMOVE1                 BRANCH--YES               19E03
         MVC   CSWORD(8),XDADBUF+54     MOVE CSW                  19E03
         MVC   ERPIBFLD(4),XDADBUF+62   MOVE ERPIB                19E03
         MVC   MULTISYS(4),XDADBUF+74   MOVE CHANSTAT INFO        19E03
         B     CONTINUE                 CONTINUE                  19E03
NEWMOVE1 MVC   CSWORD(8),XDADBUF+46     MOVE CSW                  19E03
         MVC   ERPIBFLD(4),XDADBUF+54   MOVE ERPIB                19E03
         MVC   MULTISYS(4),XDADBUF+66   MOVE CHANSTAT INFO        19E03
CONTINUE ST    R9,SAVBASE               SAVE BASE REG
         LA    R9,ERPIBFLD
         USING ERPIB,R9
         MVI   SETUPBFR+1,C'*'                                     MP
         MVC   SETUPBFR+2(78),SETUPBFR+1                           MP
         BAL   BRANPRT,XWRTPRT    MOVE BORDER TO BUFFER AND WRITE  MP
         MVI   SETUPBFR,C'-'           SKIP TWO SPACES             MP
         TM    MPINFOFD,MSBIT      IS MULTI-SYSTEM BIT SET        19032
         BZ    DUMMYTST      IFNOT,CKECK FOR ENTRANCE FROM ASR01   MP
         LA    SETUPADR,SETUPBFR       ADDRESS OF PRINT BUFFER     MP
         MVC   24(24,SETUPADR),MSHEAD   MOVE MULTI-SYSTEM HDR TO BUFMP
         BAL   BRANPRT,XWRTPRT     WRITE HEADER                    MP
         MVI   SETUPBFR+1,C'*'                                     MP
         MVI   VDSTAR,C'*'                                         MP
         BAL   BRANPRT,XWRTPRT     WRITE LINE DIVIDER              MP
*                                                                  MP
*                                                                  MP
*              THIS ROUTINE FORMATS AND PRINTS A MESSAGE           MP
*              CONTAINING THE ID OF THE FAILING CPU AND            MP
*              THE STATUS OF THE MULTI-PROCESSING SYSTEM           MP
*                                                                  MP
*                                                                  MP
         MVC   10(12,SETUPADR),MSCPUID  MOVE CPUID MESSAGE TO BUFFERMP
         MVC   30(15,SETUPADR),MSCPUST  MOVE CPU STATUS MESSAGE    MP
         MVI   0(SETUPADR),C'-'    SKIP TWO SPACES AFTER LINE      MP
         TM    MPINFOFD,ID         TEST FOR WHICH CPU             19032
         BZ    STATEST       SKIP CPU ID                           MP
         MVI   14(SETUPADR),C'2'   INSERT CPUID=CPU2               MP
STATEST  IC    R1,MPINFOFD         GET MS BYTE IN MPINFO          19032
         SLL   R1,30               CLEAR FOR CPUSTAT               MP
         LTR   R1,R1               TEST FOR ZERO,NEGATIVE OR POSITIVEMP
         BC    12,SHARED           IS STATUS NOT PARTITION         MP
         MVC   45(11,SETUPADR),PART     STATUS WAS PARTITIONED     MP
         B     CHANTEST      GO FOR CHANNEL STATUS                 MP
SHARED   MVC   45(6,SETUPADR),SHAR      SHARED STATUS              MP
         BE    CHANTEST                 WAS CPU RECONFIGURED OUT   MP
         MVC   51(21,SETUPADR),RECON    YES                        MP
         EJECT
*                                                                  MP
*                                                                  MP
*              THIS ROUTINE TESTS A TWO BYTE FIELD                 MP
*              MPINFO FIELD                          TO DETERMINE
*              THE CHANNEL STATUS FOR BOTH CPUS AND FORMAT         MP
*              A MESSAGE TO INDICATE THAT STATUS                   MP
*                                                                  MP
*                                                                  MP
CHANTEST BAL   BRANPRT,XWRTPRT          PRINT INFORMATION          MP
         MVI   0(SETUPADR),C'-'         SKIP TWO SPACES            MP
         MVC   10(27,SETUPADR),CHCNFIG  CHANNEL CONFIGURATION MESSAGEMP
         LA    UPKREG,0                                            MP
         TM    MPINFOFD,ID         WAS CPUID=CPU2                 19032
         BZ    CCHMOVE                 NO                          MP
         MVI   14(SETUPADR),C'2'        YES, ENTER ID 2            MP
CCHMOVE  BAL   BRANPRT,XWRTPRT          PRINT MESSAGE              MP
         LA    R1,7                     LOOP CONTROL               MP
         LA    R2,14(SETUPADR)          PTR TO SLOT FOR 'OFF' MESSAGEMP
         IC    R5,CHSMS(UPKREG)         GET CHANNEL STATUS BYTE    MP
         MVC   10(55,SETUPADR),CHTAB    GET LIST OF CHANNELS       MP
         SLL   R5,24                    POSITION BYTE FOR BIT TESTINGMP
MSLOOP   LTR   R5,R5         IS BIT ON (NEGATIVE REG) OR OFF       MP
         BC    10,MSUPDT                NO                         MP
         MVC   0(3,R2),OFF              CHANNEL OFFLINE            MP
MSUPDT   SLL   R5,1                     MOVE TO NEXT CHANNEL BIT   MP
         LA    R2,8(R2)                 UPDATE MESSAGE POINTER     MP
         BCT   R1,MSLOOP                EXIT AFTER 7-BITS PROCESSED MP
MSREND   BAL   BRANPRT,XWRTPRT          WRITE CHANNEL STATUS MESSAGEMP
         LTR   UPKREG,UPKREG            TEST FOR SECOND TIME THROUGH MP
         BC    7,PRTHD                  BOTH BYTES OF CHANSTAT PRINTED
         LA    UPKREG,1(UPKREG)         PTR TO 2ND.BYTE OF CHANSTATMP
         MVC   10(27,SETUPADR),CHCNFIG  MOVE IN CHANNEL CONFIGURATIONMP
         TM    MPINFOFD,ID         ESTABLISH CPUID                19032
         BO    CCHMOVE                  BRANCH IF CPUID=CPU2       MP
         MVI   14(SETUPADR),C'2'        PUT CPU2 IN MESSAGE        MP
         B     CCHMOVE       PRINT MESSAGE                         MP
PRTHD    MVI   SETUPBFR+1,C'*'             SETUP TO PRINT DIVIDER
         MVC   2(78,SETUPADR),1(SETUPADR)
         MVI   SETUPBFR,C'0'               SPACE FIRST
         BAL   BRANPRT,XWRTPRT             PRINT DIVIDER
DUMMYTST LA    SETUPADR,SETUPBFR   GET ADDR OF BUFFER FOR PRINT    MP
*                                       MESSAGE                    MP
         MVI   0(SETUPADR),C'0'         SKIP SPACE AFTER NEXT MESSAGEMP
         OC    ERPIBFLD+1(3),ERPIBFLD+1  TEST FOR DUMMY ERPIB     19032
         BNE   MSCONT                   CONTINUE IF MEANINGFUL ERPIB MP
         MVC   10(39,SETUPADR),MSASR    PRINT ASR01 ENTRY MESSAGE  MP
         MVI   0(SETUPADR),C'-'         SKIP 2 LINES               MP
         BAL   BRANPRT,XWRTPRT          PRINT INFORAMATION         MP
         MVC   10(17,SETUPADR),MSNERPIB ERPIB NOT CREATED MESSAGE  MP
         BAL   BRANPRT,XWRTPRT          PRINT INFORMATION          MP
         B     RETCNTL       RETURN CONTROL                        MP
*                                                                  MP
         EJECT
MSCONT   EQU   *                                                   MP
*   *    *    *    *    *    *    *    *    *    *    *    *    *    *
*                          INSTRUCTION ANALYSIS                       *
*        THIS PROGRAM SECTION WILL INSPECT THE FIRST FOUR(4) BITS IN  *
*        THE FIRST BYTE  OF THE              ERPIB AREA, TO DETERMINE *
*        THE INSTRUCTION CAUSING THE ERROR.                           *
         LA    SETUPADR,SETUPBFR       SET UP HEADER BOARDER.
         MVC   SETUPBFR+27(25),HEADER    SET UP HEADER MESSAGE
         MVI   0(SETUPADR),C'0'          SPACE ONE LINE
         BAL   BRANPRT,XWRTPRT
*                                                                     *
*                            TEST FOR INTERRUPT                       *
*                                                                     *
         TM    SOFWFLGS,X'40'          INTERRUPT TEST.
         BZ    INST
         MVC   SETUPBFR(42),ERRINT     BUFFER INTERRUPT MESSAGE.
         B     RITEOUT
*                                                                     *
*   *    *    *    *    *    *    *    *    *    *    *    *    *    *
*                                                                     *
*        BITS 32-35 WILL BE TESTED                                    *
*                                                                     *
INST     MVC   SETUPBFR(33),CAUSERR    TYPE-INST ERROR HEADER.
         TM    SOFWFLGS,X'80'          TEST FOR SIO INSTRUCTION ERROR.
         BO    PRTERSIO                BRANCH TO SETUP PRINT BUFFER.
         TM    SOFWFLGS,X'20'          TEST FOR TIO INSTRUCTION.
         BO    PRTERTIO                BRANCH TO SETUP PRINT BUFFER.
*                                                                     *
PRTERHIO MVC   SET1(3),ERRHIO          MOVE HIO LABEL INTO BUFFER.
         B     RITEOUT                 PREPARE TO WRITE MESSAGE.
*                                                                     *
PRTERSIO MVC   SET1(3),ERRSIO          MOVE SIO LABEL INTO BUFFER.
         B     RITEOUT                 PREPARE TO WRITE MESSAGE.
*                                                                     *
PRTERTIO MVC   SET1(3),ERRTIO          MOVE TIO LABEL INTO BUFFER.
*                                                                     *
RITEOUT  BAL   BRANPRT,XWRTPRT         WRITE OUT APPROPRIATE MESSAGE.
*   *    *    *    *    *    *    *    *    *    *    *    *    *    *
*        THE FOLLOWING PROGRAM SECTION WILL INSPECT THE ERPIBFLD
*        TO DETERMINE IF AN ERPIB IS PRESENT.   IF  ONE IS
*        NOT FOUND, CONTROL WILL BE RETURNED.
*   *    *    *    *    *    *    *    *    *    *    *    *    *    *
         OC    ERPIBFLD+1(3),ERPIBFLD+1  TEST FOR  ERPIB PRESENT  19032
         BZ    NONEXIST                WRITE MSG TO INDICATE NONEXISTS.
         B     TEST1         TEST COMPLETION CODE                  MP
SETVD    EQU   XPRTBUF+33                                          MP
*                         UCB ADDRESS NON-EXISTANT
NONEXIST MVC   SETUPBFR(45),NOUCB        SET UP MSG FOR NO UCB
         BAL   BRANPRT,XWRTPRT         WRITE MESSAGE.
         B     RETCNTL                 RETURN TO CONTROL.
*   *    *    *    *    *    *    *    *    *    *    *    *    *    *
*        THE FOLLOWING PROGRAM SECTION WILL TEST  BYTE 5     OF THE
*        ERPIB FOR A NO RETRY BIT SETTING. IF ON, CONTROL IS RETURNED
*        AFTER MESSAGE IS PRINTED OUT.
*   *    *    *    *    *    *    *    *    *    *    *    *    *    *
*                       OUTPUT RETRY CODE VALUE
*
*   *    *    *    *    *    *    *    *    *    *    *    *    *    *
*                            TEST SOFTWARE FLAGS
TEST     MVC   SETUPBFR(32),RETCDVAL     BUFFER THE BASIC MESSAGE
         IC    REG,CMPLBITS        CONTENTS OF BYTE 8 INTO R3     19032
         TM    VALFLAGS,X'10'            TEST FOR VALID RETRY CODE
         BO    VALFLG              IF VALID, GO SETUP MESSAGE
         MVC   33(43,SETUPADR),NOTVM  SETUP NOT ASSESSABLE MESSAGE
         B     BUFITA           GO PRINT IT
VALFLG   N     REG,MASK            GET RID OF UNNEED BITS
         STC   REG,RCMSG+12        STORE NO. IN RETRY CODE MSG
         OI    RCMSG+12,X'F0'      MAKE PRINTABLE
         MH    REG,CONST
         LA    REG,MSGSTRT(REG)    SET UP MSG INDEX
         MVC   33(44,SETUPADR),0(REG)  MOVE MSG TO BUFFER
BUFIT    BAL   BRANPRT,XWRTPRT     PRINT IT
         MVC   34(14,SETUPADR),RCMSG  MOVE RETRY MSG TO BUFFER
BUFITA   BAL   BRANPRT,XWRTPRT
         TM    CMPLBITS,X'08'      IS DISCONNECT IN SET           19032
         BNO   NOTDISIN            NO, SKIP MSG                   19032
         MVC   SETUPBFR(23),DISCIN SET UP MSG                     19032
         BAL   BRANPRT,XWRTPRT     PRINT MSG                      19032
NOTDISIN EQU   *                                                  19032
*
*                                  TEST NO-RETRY BIT
         TM    SOFWFLGS,X'01'          IF NORETRY BIT IS NOT ON,BRANCH
*                                      TO PRINT VALID INDICATOR MSG.
         BZ    VALIDIND
         MVC   SETUPBFR(28),NORETRY    INDICATES THAT THE BIT WAS ON.
         BAL   BRANPRT,XWRTPRT         WRITE THE MESSAGE.
         B     RETCNTL                 RETURN CONTROL.
VALIDIND MVC   SETUPBFR(29),VALIDITY   RECORDED DATA HEADING TO BUFFER
         BAL   BRANPRT,XWRTPRT         INDICATOR HEADER.
*
*                                  TEST VALID RETRY CODE
*
*
*                            TEST COUNT BIT
         MVC   SETUPBFR(42),VALCOUNT   BUFFER THE BASIC MESSAGE.
         TM    SOFWFLGS,X'02'          TEST COUNT VALIDITY.
         BZ    INVCOUNT                IF OFF, PRINT INVALID MSG.
         MVC   33(9,SETUPADR),37(SETUPADR) MODIFY THE BASIC MESSAGE.
INVCOUNT BAL   BRANPRT,XWRTPRT         WRITE MESSAGE.
*
*                            TEST FOR SENSE DATA STORED
*
         MVC   SETUPBFR(43),SENSDATA   BUFFER THE BASIC MESSAGE.
         TM    SOFWFLGS,X'04'          TEST SENSE BIT.
         BZ    NOSTORE                 IF OFF BRANCH TO WRITE NOSTORE.
         MVC   33(10,SETUPADR),37(SETUPADR) MODIFY THE BASIC MESSAGE.
NOSTORE  BAL   BRANPRT,XWRTPRT         WRITE THE MESSAGE.
*                            TEST UNIT STATUS BIT
         MVC   SETUPBFR(42),INVALUN    BUFFER THE BASIC MESSAGE.
         TM    VALFLAGS,X'08'          TEST FOR VALID UNIT STATUS.
         BZ    WRTOUT                  UNIT STATUS INVALID.
         MVC   33(9,SETUPADR),37(SETUPADR) MODIFY THE BASIC MESSAGE.
WRTOUT   BAL   BRANPRT,XWRTPRT         WRITE MESSAGE.
*
*                            TEST COMMAND ADDRESS BIT
*
         MVC   SETUPBFR(42),INVALCAD   MOVE INVALID COM MSG TO BUFFER.
         TM    VALFLAGS,X'04'          TEST FOR VALID COMMAND ADDRESS.
         BZ    PTOUT                   COMMAND ADDRESS INVALID.
         MVC   33(9,SETUPADR),37(SETUPADR) MODIFY THE BASIC MESSAGE.
PTOUT    BAL   BRANPRT,XWRTPRT         WRITE THE MESSAGE.
*
*                            TEST CHANNEL ADDRESS BIT
*
         MVC   SETUPBFR(42),INVALCHA   MOVE INVALID CHN MSG TO BFR.
         TM    VALFLAGS,X'02'          TEST FOR VALID CHANNEL ADDRESS.
         BZ    OUTWRT                  INVALID CHANNEL ADDRESS.
         MVC   33(9,SETUPADR),37(SETUPADR) MODIFY THE BASIC MESSAGE.
OUTWRT   BAL   BRANPRT,XWRTPRT         WRITE MESSAGE.
*
*                            TEST FOR VALID DEVICE ADDRESS
*
         MVC   SETUPBFR(42),INVALDVA   MOVE INVALID DVC ADDR MSG TO BFR
         TM    VALFLAGS,X'01'          TEST FOR VALID DEVICE ADDRESS.
         BZ    OUTPRT                  INVALID DEVICE ADDRESS.
         MVC   33(9,SETUPADR),37(SETUPADR) MODIFY THE BASIC MESSAGE.
OUTPRT   BAL   BRANPRT,XWRTPRT         WRITE MESSAGE.
*
*        PROBABLE SOURCE OF ERROR
*
         MVC   SETUPBFR(29),PSOERR      INSERT BASE MSG IN BUFFER
         CLI   PROBERR,X'80'            TEST FOR CPU ERROR
         BE    CPUER                    BRANCH TO SET UP CPU ERR MSG
         CLI   PROBERR,X'40'            TEST FOR CHANNEL ERROR
         BE    CHNER                    BRANCH TO SETUP CHANNEL ERROR
         CLI   PROBERR,X'20'       TEST FOR SCU ERROR             19032
         BE    SCUER               YES- GO SET UP FOR SCU ERRMSG  19032
         CLI   PROBERR,X'10'            TEST FOR STORAGE ERROR
         BE    STORGER                  GO SETUP STORAGE ERROR MSG
         CLI   PROBERR,X'08'            TEST FOR I/O INTERFACE ERROR
         BE    INFER                    GO SETUP I/O INTF ERROR MSG
         MVC   30(25,SETUPADR),NOTVM    SETUP NOT ASSESSABLE MESSAGE
         B     WPRMSG                   GO PRINT MSG
CPUER    MVC   30(3,SETUPADR),CPUERMSG  BUFFER CPU ERROR MESSAGE
         B     WPRMSG                   GO PRINT
CHNER    MVC   30(7,SETUPADR),CHANERMS  SETUP CHANNEL ERROR MESSAGE
         B     WPRMSG                   GO PRINT
SCUER    MVC   30(20,SETUPADR),SCUERMS  SET UP SCU MSG            19032
         B     WPRMSG                   GO PRINT IT               19032
STORGER  MVC   30(7,SETUPADR),STOGERMS  SETUP STORAGE ERROR MESSAGE
         B     WPRMSG                   GO PRINT
INFER    MVC   30(13,SETUPADR),IOINFER  SET UP INTERFACE ERROR MESSAGE
WPRMSG   BAL   BRANPRT,XWRTPRT          PRINT MESSAGE
         B     RETCNTL
*
*                            TEST COMPLETION CODE
*
TEST1    MVC   SETUPBFR(23),COMCODE    INSERT COMPLETION CODE MESSAGE
*                                      IN PRINT BUFFER.
         TM    CMPLBITS,X'C0'          TEST FOR COMPLETION CODE '3'.
         BO    SYSRET                  BRANCH FOR SYS RESET MSG OUTPUT.
         TM    CMPLBITS,X'80'          TEST FOR COMPLETION CODE '2'
         BO    SELRET                  BRANCH FOR SEL RESET MSG OUTPUT.
         TM    CMPLBITS,X'40'          TEST FOR COMPLETION CODE '1'
         BO    FORENDSQ                BRANCH FOR FORCED END MSG OUTPUT
*
*                            INTERFACE DISCONNECT
*
         MVC   SET2(29),INTDISCN      SET UP INTERFACE DISCONNECT MSG
         B     WRITER                  MESSAGE AND WRITE IT OUT.
*
*                            SYSTEM RESET
*
SYSRET   MVC   SET2(21),SYSRES        SETUP  THE SYSTEM RESET MSG AND
         B     WRITER                  WRITE IT OUT.
*
*                            SELECTIVE RESET
*
SELRET   MVC   SET2(24),SELRES          SETUP SELECTIVE RESET  MSG AND
         B     WRITER                  AND WRITE IT OUT.
*
*                            FORCED ENDING SEQUENCE
*
FORENDSQ MVC   SET2(31),FORCEND         SETUP FORCE END MESSAGE AND
*                                      WRITE IT OUT.
*
*                            OUTPUT OF COMPLETION
*                              CODE MESSAGES
*
WRITER   BAL   BRANPRT,XWRTPRT
         B     TEST
*
*                                 RETURN CONTROL
*
RETCNTL  EQU   *                                                  19032
         MVI   SETUPBFR+1,C'*'
         MVC   2(78,SETUPADR),1(SETUPADR)
         MVI   0(SETUPADR),C'-'         SETUP TO SPACE TWICE
         BAL   BRANPRT,XWRTPRT
         TM    CSWORD+5,X'06'           CHAN CHK OR IF CTRL CHK
         BC    8,MSG                   NO, PRINT LOGOUT MESSAGE.
FIN1     DS    0C
         LA    R0,0                     ZERO WORK REGISTER
         ST    R0,NXENTRY               CLEAR ENTRY POINTER
         L     R13,SVR13                RESTORE REG 13
         LM    R14,R12,12(R13)          RESTORE REGISTERS
         BR    R14                      RETURN
*
*                            PRINT NO-LOGOUT MESSAGE
*
MSG      MVC   SETUPBFR+1(79),ERMSG    BUFFER THE MESSAGE.
         BAL   BRANPRT,XWRTPRT
         L     R9,SAVBASE               RESTORE BASE
         USING IFCEI135,R9
         LA    R7,QUIT0-4               GET END ADDRESS
         DROP  R9
         ST    R7,L12(R9)               STO9E IN TABLE
         B     FIN1                     RETURN
*
SAVBASE  DC    F'0'
*
*                                                                  MP
***      THIS ROUTINE CONVERTS HEX CHARACTERS TO EBCDIC            MP
*                                                                  MP
*        INPUT   R1 -         LINKREG                               MP
*                CLEAREG -    COUNT OF BYTES TO BE CONVERTED        MP
*                R5 -         ADDRESS OF FIELD TO BE CONVERTED     MP
***              SETUPADR -   ADDRESS OF OUTPUT AREA               MP
*                                                                  MP
*                                                                  MP
CONVERT  SR    R2,R2                    CLEAR EVEN WORK REG (HI-ORDEMP
         IC    R2,0(R5)                 GET CHARACTER FROM INPUT FIE MP
         SRDL  R2,4                     SAVE HIGH ORDER BITS       MP
         SRL   REG,28              SAVE LOW ORDER BITS
         IC    R2,CONTAB(R2)            GET EBCDIC EQUIVALENT      MP
         IC    REG,CONTAB(REG)           FROM TABLE
         STC   R2,0(SETUPADR)           STORE CHARACTERS IN PRINTABL MP
         STC   REG,1(SETUPADR)           FROM IN BUFFER           MP
         LA    R5,1(R5)                 UPDATE INPUT FIELD PTR     MP
         LA    SETUPADR,2(SETUPADR)     UPDATE BUFFER POINTER      MP
         BCT   CLEAREG,CONVERT          LOOP UNTIL ALL BYTES PROCESS MP
         BR    R1                       RETURN                     MP
         SPACE
****    ROUTINE TO RETURN CONTROL TO CONTROL MODULE
XWRTPRT  DS    0C
         ST    BRANPRT,NXENTRY          STORE LINK ADDRESS
         STM   R12,R10,MYSAVE           SAVE SUBROUTINE REGS
         L     R0,RTNPTR                LOAD ADCON FOR RETURN POINTER
         L     R1,RG9PTR                LOAD POINTER TO REG9
         ST    R0,AD0(R1)               STORE RETURN POINTER
         L     R0,LBLPTR                LOAD POINTER TO LABEL
         L     R1,LPPTR                 LOAD POINTER TO LP
         ST    R0,AD0(R1)               STORE LABEL POINTER
         L     R13,SVR13                RESTORE REG 13
         MVI   AD0(R3),X09
         LM    R14,R12,12(R13)          RESTORE REGISTERS
         BR    R14                      RETURN
*
*                            STORAGE
*
         DS    0F
TYPE     EQU   XDADBUF+5                                           MP
ENVCH    EQU   XDADBUF+56                                          MP
ENVMS    EQU   XDADBUF+63                                          MP
GPRMS    EQU   XDADBUF+248                                         MP
CPULOG   EQU   GPRMS+108                                           MP
CPULOGED EQU   CPULOG+8                                            MP
CPULOGJE EQU   CPULOG+2                FRAME SIX LOW BIT           2MEG
CPULOGPP EQU   CPULOG+12                                           MP
CPULOGG  EQU   CPULOG+65                                           MP
CPULOGVD EQU   CPULOG+66                                           MP
CPULOGMO EQU   CPULOG+70        FRAME 5-8 BITS                     2MEG
ONEVD    EQU   X'01'                                               MP
TWEN     EQU   X'20'                                               MP
EIGHTY   EQU   X'80'                                               MP
VDSTAR   EQU   XPRTBUF+79                                          MP
PLACE    EQU   ENVCH+32                                            MP
F252     EQU   252                                                 MP
FROMVD   EQU   GPRMS+32                                            MP
OCTVD    EQU     80                                                MP
AREAVD   EQU   GPRMS+92                                            MP
ID       EQU   X'08'                                               MP
MSBIT    EQU   X'10'                                                MP
K0       EQU   0                                                  19E03
K2       EQU   2                                                  19E03
K4       EQU   4                                                  19E03
K8       EQU   8                                                  19E03
K10      EQU   10                                                 19E03
K20      EQU   20                                                 19E02
K21      EQU   21                                                 19E02
K24      EQU   24                                                 19E03
FOXDOG   EQU   X'FD'                                              19E03
REL19    EQU   19                                                 19E02
XPRTBUF1 EQU   XPRTBUF+1                                          19E03
MODA48   DC    X'0155'                  MODEL 155 - NS A48        19E02
REGSAV   DS    2F
DECCOUNT DS    F                                                  19E03
*
SETUPBFR EQU   XPRTBUF
CSWORD   DC    D'0'                CSW LOCATION                   19032
ERPIBFLD DC    F'0'                LAST HALF ERPIB                19032
MULTISYS DC    F'0'                MULTI-PROCESSING INFO          19032
MASK     DC    F'7'
CONST    DC    H'44'
TWOX     DC    H'2'
SET1     EQU   SETUPBFR+22
SET2     EQU   SETUPBFR+21
*
*                            REGISTERS
REG      EQU   11
UPKREG   EQU   6                       ADDRESSES UNPACK AREA.
SETUPADR EQU   7                       ADDRESSES PRINT BUFFER.
PRTABREG EQU   8                       ADDRESSES CONVERSION TABLE.
BASEREG  EQU   9                       BASE REGISTER.
BRANPRT  EQU   11                      ADDRESSES PRINT ROUTINE.
CLEAREG  EQU   12
SAVADDR  EQU   13                      ADDRESSES REGISTER SAVE AREA.
BRANADDR EQU   14                      BRANCH REGISTER.
*
*                            MESSAGES
*
*
CAUSERR  DC    C'-  CSW STORED BY  --             '
ERRINT   DC    C'-  CSW STORED BY  INTERRUPT               '
ERRSIO   DC    C'SIO'
ERRTIO   DC    C'TIO'
ERRHIO   DC    C'HIO'
NOUCB    DC    C'   NO ADDITIONAL ERROR INFORMATION AVAILABLE.'
COMCODE  DC    C'   TERMINATION BY  --  '
SYSRES   DC    C' SYSTEM RESET- CODE 3'
SELRES   DC    C' SELECTIVE RESET- CODE 2'
FORCEND  DC    C' FORCED ENDING SEQUENCE- CODE 1'
INTDISCN DC    C' INTERFACE DISCONNECT- CODE 0'
RETCDVAL DC    C'   TIME CHANNEL DETECTED ERROR -'
RCMSG    DC    C'RETRY CODE    '
MSGSTRT  DC    C' WHILE EXECUTING TIO                        '
         DC    C' BETWEEN COMMAND OUT AND UNIT STATUS RETURN '
         DC    C' COMMAND ACCEPTED BUT BEFORE DATA TRANSFER  '
         DC    C' SOME DATA TRANSFER-CSW COMMAND ADR UPDATED '
         DC    C' COMMAND REJECTED OR COMMAND OUT NOT SENT   '
         DC    C' COMMAND ACCEPTED-DATA TRANSFER UNDETERMINED'
         DC    C' COULD NOT BE ASSESSED                      '
NOTVM    DC    C' COULD NOT BE ASSESSED                      '
NORETRY  DC    C'0  PROGRAM ASSESSED NO RETRY'
DISCIN   DC    C'   DISCONNECT IN ISSUED'                         19032
VALIDITY DC    C'0  VALIDITY OF RECORDED DATA '
VALCOUNT DC    C'            COUNT              = NOT VALID'
SENSDATA DC    C'            SENSE DATA         = NOT STORED'
INVALUN  DC    C'            UNIT STATUS        = NOT VALID'
INVALCAD DC    C'            COMMAND ADDRESS    = NOT VALID'
INVALCHA DC    C'            CHANNEL ADDRESS    = NOT VALID'
INVALDVA DC    C'            DEVICE ADDRESS     = NOT VALID'
PSOERR   DC    C'0  PROBABLE SOURCE OF ERROR- '
CPUERMSG DC    C'CPU'
CHANERMS DC    C'CHANNEL'
SCUERMS  DC    C'STORAGE CONTROL UNIT'                            19032
STOGERMS DC    C'STORAGE'
IOINFER  DC    C'CONTROL UNIT '
HEADER   DC    C' CHANNEL  ERROR  ANALYSIS'
ERMSG    DC    C'CHANNEL CTRL OR I/F CTRL CHECK '
         DC    C'NOT INDICATED IN CSW-NO LOGOUT'
         DC    C' WITH THIS RECORD'
MSHEAD   DC    C'MULTI-SYSTEM INFORMATION'              MESSAGES   MP
MSCPUID  DC    C'CPU 1 FAILED'                           FOR        MP
MSCPUST  DC    C'CPU STATUS WAS '              ONLY THE            MP
PART     DC    C'PARTITIONED'                           M65MP TO BE  MP
SHAR     DC    C'SHARED'                        ONLY                MP
RECON    DC    C' BUT RECONFIGURED OUT'                 WRITTEN ON  MP
CHCNFIG  DC    C'CPU 1 CHANNEL CONFIGURATION'            SEC       MP
CHTAB    DC    C'CH0--ON CH1--ON CH2--ON CH3--ON CH4--ON'  *       MP
         DC    C' CH5--ON CH6--ON'                    STORAGE  FOR   MP
MSASR    DC    C'INBOARD RECORD ENTRY CONSTRUCTED BY MCH'  *        MP
MSNERPIB DC    C'ERPIB NOT CREATED'         EREP RECORDS           MP
NXENTRY  DC    F'0'
OFFMESS  DC    A(OFF)                          MULTI-PROCESSING    MP
OFF      DC    C'OFF'                         CONSTANTS            MP
         DC    C'LINE   '                       MESSAGES            MP
RG9PTR   DC    A(REG9)
RTNPTR   DC    A(PRTERPIB-4)
LBLPTR   DC    A(LABELEND-1)
LPPTR    DC    A(LP)
MYSAVE   DS    15F
SVR13    DS    1F
CONTAB   DC    C'0123456789ABCDEF'     HEX CHARACTERS F0-F6        MP
LEVELVD  EQU    3            MODULE LEVEL INDICATOR                MP
         DROP  R15
CHNTYPE  DS    0C
         USING *,R15
         MVC   AD1(L7,R3),MSGA          MOVE UNKNOWN TYPE MSG
         CLI   AD0(R4),KA     COMPARE CCH TYPE TO  0A
         BCR   CC2,R14                  BRANCH IF CHN TYPE HIGH
         BL    CHNTYPE0                 BRANCH IF CHN TYPE LOW
CHNTYPF  MVC   AD1(L16,R3),MSGF         CHN TYPE IS INTEGD FILE ADPTT
         BR    R14                      RETURN
CHNTYPE0 DS    0C
         CLI   AD0(R4),K2               COMPARE CHN TYPE TO A 2
         BH    CHNTYPE3                 BRANCH IF HIGH
         BL    CHNTYPE1                 BRANCH IF CHN TYPE LOW 1
         MVC   AD1(L10,R3),MSGD         CHN TYPE IS INTGTD SEL
         BR    R14                      RETURN
CHNTYPE3 MVC   AD1(L14,R3),MSGB         CHN TYPE IS INTGTD BLK MPX
         BR    R14                      RETURN
CHNTYPE1 DS    0C
         CLI   AD0(R4),K1               COMPARE CHN ID TO A 1
         BCR   CC4,R14                  BRANCH IF CHN TYPE LOW
         MVC   AD1(L10,R3),MSGC         CHN TYPE IS INTGTD MPX
         BR    R14                      RETURN
KA       EQU   X'0A'
MSGA     DC    C'UNKNOWN'
MSGB     DC    C'INTGTD BLK MPX'
MSGC     DC    C'INTGTD MPX'
MSGD     DC    C'INTGTD SEL'
MSGF     DC    C'INTGTD FILE ADPT'
         DROP  R15
         EJECT
FORMAT1  DC    F'0'
FORMAT2  DC    F'0'
LABELPTR DC    A(LABLAREA)
DISP     DC    FL2'0'
         SPACE 2
         DC    X'01'
         DC         X'000B8B00'         SKIP TO CHANNEL 1
         LABEL ' '
*
         LINE  (9,40),(1,35),SKIP=2                            @XA19715
         HEX   XMOD,0,2B                                       @XA19715
         HEX   XSER,0,3B                                       @XA19715
         LABEL 'MODEL','SERIAL NO.'                            @XA19715
         LINE  (10,)
*
         ROUTINE    XRELN,CONVREL
         LABEL      'XXXX REL.'
         LINE       (21,40)
         ROUTINE    XKEY,SETSOURC
         LABEL      '--- RECORD SOURCE -','TYPE - INBOARD'
*
         LINE
         ROUTINE    XJOBN,SETPGMN
         LABEL      'JOB NAME'
*
         LINE       ,(8,40),SKIP=1
         ROUTINE    XSWS8,CONVTIME
         LABEL      'DAY  YEAR','HH MM SS.TH'
         LINE       (8,40),(1,40),SKIP=2
         ROUTINE    XDATE,SETDATE
         HEX        XTIME,1,4B
         LABEL      'DATE _','TIME _'
*
         LINE       (23,1),(1,1)
         HEX        XCUA,0,3B
         LABEL      'CHANNEL/UNIT ADDRESS'
*
         LINE       ,(14,1),SKIP=1
         ROUTINE    XKEY,SKIPPER
         LABEL      'CC   DA    FL     CT'
         LINE       (14,3),(1,1),SKIP=2
         HEX        XFCCWCC,0,1B
         HEX        XFCCWDA,0,3B
         ROUTINE    XKEY,SPACER2
         HEX        XFCCWFL,0,1B
         HEX        XFCCW0,0,1B
         HEX        XFCCWCT,0,2B
         LABEL      'FAILING CCW'
*
         LINE       ,(14,1),SKIP=1
         ROUTINE    XKEY,SKIPPER
         LABEL      'K    CA    US CS  CT'
         LINE       (14,3),(1,1),SKIP=2
         HEX        XCSWK,0,1B
         HEX        XCSWCA,0,3B
         ROUTINE    XKEY,SPACER2
         ROUTINE    XCSWUS0,SETHEX
         ROUTINE    XCSWCS0,SETHEX
         HEX        XCSWCT,0,2B
         LABEL      'CSW'
*
         LINE       ,(2,38),SKIP=1
         ROUTINE    XKEY,SKIPPER
         LABEL      'UNIT STATUS','CHANNEL STATUS'
*
         LINE       (21,38),(3,38)
         BIN        XCSWUS0
         BIN        XCSWCS0
         LABEL      'ATTENTION','PRGM-CTLD IRPT'
         LINE
         BIN        XCSWUS1
         BIN        XCSWCS1
         LABEL      'STATUS MODIFIER','INCORRECT LENGTH'
         LINE
         BIN        XCSWUS2
         BIN        XCSWCS2
         LABEL      'CONTROL UNIT END','PROGRAM CHECK'
         LINE
         BIN        XCSWUS3
         BIN        XCSWCS3
         LABEL      'BUSY','PROTECTION CHECK'
         LINE
         BIN        XCSWUS4
         BIN        XCSWCS4
         LABEL      'CHANNEL END','CHAN DATA CHECK'
         LINE
         BIN        XCSWUS5
         BIN        XCSWCS5
         LABEL      'DEVICE END','CHAN CTRL CHECK'
         LINE
         BIN        XCSWUS6
         BIN        XCSWCS6
         LABEL      'UNIT CHECK','I/F CTRL CHECK'
         LINE       ,,SKIP=2
         BIN        XCSWUS7
         BIN        XCSWCS7
         LABEL      'UNIT EXCEPTION','CHAINING CHECK'
*
         LINE       ,(1,1),SKIP=1
         ROUTINE    XKEY,SKIPPER
         LABEL      'I/O UNIT FOUND BUSY'
         LINE       (27,5),(2,1),SKIP=2
         HEX        XAIO1
         HEX        XAIO2
         HEX        XAIO3
         HEX        XAIO4
         HEX        XAIO5
         HEX        XAIO6
         HEX        XAIO7
         HEX        XAIO8
         ROUTINE    XKEY,SETAIO
         LABEL      'CHANNEL/UNIT ADDR'
*
         LINE       ,(1,1),SKIP=1
         LABEL      '--- CHANNEL TYPE ---'
         LINE  (1,1),(1,1),SKIP=2
         ROUTINE    XCHID,CHNTYPE
         LABEL      ''
         LINE       ,(1,1),SKIP=1
         LABEL      'HEADER SENSE SWITCHES FOUND ON'
         LINE       ,(2,1)
         ROUTINE    XSWS8,CHKSW9
         LABEL      'RECORD INCOMPLETE'
         LINE
         ROUTINE    XSWS8,CHKSW10
         LABEL      'SYSTEM TERMINATED'
         LINE
         ROUTINE    XSWS8,CHKSW11
         LABEL      'UNSUPPORTED CHANNEL'
         LINE
         ROUTINE    XSWS8,CHKSW12
         LABEL      'CUA ILLEGAL'
         LINE
         ROUTINE    XSWS8,CHKSW13
         LABEL      'PORTION OF RECORD HAS BEEN DESTROYED'
         LINE
         ROUTINE    XSWS8,CHKSW14
         LABEL 'ERP WAS IN PROGRESS'
         LINE
         ROUTINE    XKEY,SKIPPER                                 P0417
         LABEL      ' '                                          P0417
PRTERPIB LINE  (1,1),(1,1),SKIP=1
         ROUTINE    XSWS8,IFCASR01
LABELEND LABEL     ''
         DC    X'01000B8B00'
         LABEL  ''
         LINE  ,(5,1),SKIP=2
         LABEL 'CPU DEPENDENT LOGOUT BYTES'
         LINE  ,(16,60)
         LABEL '--- CPU CHECKS 0 ---','--- CPU  CHECKS 1 ---'
         LINE  (25,30),(1,30),SKIP=1
         BIN   MCHRG00
         BIN   MCHRG08
         BIN   MCHRG16
         LABEL 'EARLY CHECK','BUS IN','ALU BYTE 0'
         LINE
         BIN   MCHRG01
         BIN   MCHRG09
         BIN   MCHRG17
         BIN   MCHRG25
         LABEL 'LATE CHECK','DISPLAY BUS BYTE 0','ALU BYTE 1',         X
               'ALU AUXILIARY'
         LINE
         BIN   MCHRG02
         BIN   MCHRG10
         BIN   MCHRG18
         BIN   MCHRG26
         LABEL 'STOR INPUT DATA','ALU SHIFT','ALU CONTROLS',           X
               'SP PROTECTION KEY'
         LINE
         BIN   MCHRG03
         BIN   MCHRG11
         BIN   MCHRG19
         BIN   MCHRG27
         LABEL 'WS OUTPUT','SINGLE BIT ERROR','T REGISTER',      XM5997X
               'SP STOR KEY'                                     XM5997
         LINE
         BIN   MCHRG04
         BIN   MCHRG12
         BIN   MCHRG20
         BIN   MCHRG28
         LABEL 'SELECT LATCHES','DOUBLE BIT ERROR','CDR/CTRL',   XM5997X
               'FIELD LENGTH CTR'
         LINE
         BIN   MCHRG05
         BIN   MCHRG13
         BIN   MCHRG21
         BIN   MCHRG29                                           XM5997
         LABEL 'WSAR','ECC ADDR CHECK','BRANCH DECODE',          XM5997X
               'ASSOC ARRAY'                                     XM5997
         LINE
         BIN   MCHRG06
         BIN   MCHRG14
         BIN   MCHRG22
         BIN   MCHRG30                                           XM5997
         LABEL 'ASAR','CPU SAR CHECK','MICROPROGRAM',            XM5997X
               'PHYSICAL REG'                                    XM5997
         LINE  (25,30),(1,30),SKIP=2
         BIN   MCHRG07
         BIN   MCHRG15
         LABEL 'DISP BUS BYTE 1','MS LAST ACCESS BIT'
         LINE  (25,30),(1,30),SKIP=1
         HEX   BUFADRG                                           XM5997
         HEX   SAREG00                                           XM5997
         LABEL 'BACKUP ADDR REG','STOR ADDR REG'                 XM5997
         LINE  SKIP=2
         BIN   ZONER00
         BIN   ZONER01
         BIN   ZONER03
         LABEL 'CYCLE STEAL','CYCLE STEAL ZONE','DATA FLOW ZONE'
         LINE  ,(8,30)
         LABEL 'RETRY THRESHOLD','CPU RETRY',                          X
               '    INTERRUPT STATUS LATCHES'
         LINE  (25,30),(1,30),SKIP=1
         BIN   BFCTRG00
         BIN   BFCTRG08
         BIN   BFCTRG16
         BIN   BFCTRG24
         LABEL 'GPR/STOR ALTERED','CPU RETRY FLAG','HRT OVERFLOW',     X
               'TIMER ENABLE'
         LINE
         BIN   BFCTRG01
         BIN   BFCTRG13
         BIN   BFCTRG17
         BIN   BFCTRG25
        LABEL 'SYSTEM DAMAGE','RETRY COUNT','NEW BYTE 83','START LATCH'
         LINE
         BIN   BFCTRG02
         ROUTINE    DUMMY,SKIPPER
         BIN   BFCTRG18
         BIN   BFCTRG26
         LABEL 'PSW/CR ALTERED','','PER REQUEST','M/C CHECK THRESHOLD'
         LINE
         BIN   BFCTRG03
         ROUTINE    DUMMY,SKIPPER
         BIN   BFCTRG19
         BIN   BFCTRG27
         LABEL 'SECOND ERROR','','SUCCESSFUL BRANCH','IC DUMPED'
         LINE
         BIN   BFCTRG04
         ROUTINE    DUMMY,SKIPPER
         BIN   BFCTRG20
         BIN   BFCTRG28
         LABEL 'PER ZONE 1','','RESTART BUTTON',                       X
               'ALTER/DISPLAY REQUEST'
         LINE
         ROUTINE DUMMY,SKIPPER
         ROUTINE    DUMMY,SKIPPER
         BIN   BFCTRG21
         BIN   BFCTRG29
         LABEL '','','STOP LATCH','MANUAL STATE'
         LINE
         ROUTINE    DUMMY,SKIPPER
         ROUTINE    DUMMY,SKIPPER
         BIN   BFCTRG22
         BIN   BFCTRG30
         LABEL '','','PRIO SAMPLE','PER LOG LATCH'
         LINE  (85,30),(61,30),SKIP=2
         BIN   BFCTRG23
         BIN   BFCTRG31
         LABEL 'PER INSTR. FETCH','TOD CLOCK PRI'
         LINE  ,(40,)
         LABEL '-----CHANNEL LOGOUT BYTES-----'
         LINE  (25,30),(6,30),SKIP=2
         LABEL 'ICA CHANNEL','SEL CHANNEL A','2319 IFA CHANNEL',       X
               'SEL CHANNEL B'                                 @XA06108
         LINE  (25,30),(1,30),SKIP=1
         BIN   CHCTRG00                                          XM5997
         BIN   CHCTRG08
         BIN   CHCTRG16
         BIN   CHCTRG24
         LABEL 'INTERFACE CHECK','CHAN CONTROL','CONTROL',       XM5997X
               'CHAN CONTROL'                                    XM5997
         LINE
         BIN   CHCTRG01                                          XM5997
         BIN   CHCTRG09
         BIN   CHCTRG17
         BIN   CHCTRG25
         LABEL 'LSAR CHECK','I/F CONTROL CHECK','COUNT',         XM5997X
               'I/F CONTROL CHECK'                               XM5997
         LINE
         BIN   CHCTRG02                                          XM5997
         BIN   CHCTRG10
         BIN   CHCTRG18
         BIN   CHCTRG26
         LABEL 'LSDR CHECK','CARD 1','FMF','CARD 1'              XM5997
         LINE
         BIN   CHCTRG03                                          XM5997
         BIN   CHCTRG11
         BIN   CHCTRG19
         BIN   CHCTRG27
         LABEL 'ALU OUTPUT CHECK','CARD 2','TIMING','CARD 2'     XM5997
         LINE
         BIN   CHCTRG04
         BIN   CHCTRG12
         BIN   CHCTRG20
         BIN   CHCTRG28
         LABEL 'MINT REQUEST','CARD 3','SER/DES','CARD 3'        XM5997
         LINE
         BIN   CHCTRG05
         BIN   CHCTRG13
         BIN   CHCTRG21
         BIN   CHCTRG29
         LABEL 'COMMAND END','CARD 4','FBO,FTO','CARD 4'
         LINE
         BIN   CHCTRG06
         BIN   CHCTRG14
         BIN   CHCTRG22
         BIN   CHCTRG30
         LABEL 'STACK INTERRUPT','CARD 9','CCB REGS','CARD 9'    XM5997
         LINE  SKIP=2
         BIN   CHCTRG07
         ROUTINE DUMMY,SKIPPER
         BIN   CHCTRG23
         LABEL 'I/O OP','','FED'
         LINE  (25,30),(6,30),SKIP=2                            XA00642
         ROUTINE DUMMY,SKIPPER                                  XA00642
         LABEL '3330 IFA CHANNEL'                              @XA06108
         LINE  (25,30),(1,30),SKIP=1                            XA00642
         BIN   CHANCK00                                         XA00642
         LABEL 'CONTROL CHECK'                                  XA00642
         LINE
         BIN   CHANCK01                                         XA00642
         LABEL 'FMF/FCF'                                        XA00642
         LINE
         BIN   CHANCK02                                         XA00642
         LABEL 'FDB0/FDB1/SUBTRACTOR'                           XA00642
         LINE
         BIN   CHANCK03                                         XA00642
         LABEL 'BAR'                                            XA00642
         LINE
         BIN   CHANCK04                                         XA00642
         LABEL 'OR/COMPARATOR'                                  XA00642
         LINE
         BIN   CHANCK05                                         XA00642
         LABEL 'TIMING'                                         XA00642
         LINE
         BIN   CHANCK06                                         XA00642
         LABEL 'FBO/FTO'                                        XA00642
         LINE  ,,SKIP=2                                         XA00642
         BIN   CHANCK07                                         XA00642
         LABEL 'FBI/FCM'                                        XA00642
         LINE  ,(5,26),SKIP=2
         LABEL '-----CPU CHECKS-----'
         LINE  (51,1),(1,1),SKIP=2                             @XA06108
         ROUTINE ZONER00,SETHEX                                @XA06108
         LABEL 'CHECKS 0   CHECKS 1   ZONE IN ERROR'           @XA06108
         LINE  (3,11),(23,1),SKIP=1                            @XA06108
         HEX   CHK0,1,2B
         HEX   CHK1,1,2B
         ROUTINE ZONER00,CYCLFLG                               @XA06108
         LABEL 'CYCLE STEAL FLAG (BIT 0)            '          @XA06108
         LINE  ,                                               @XA06108
         ROUTINE ZONER01,CYCLZON                               @XA06108
         LABEL 'CYCLE STEAL ZONE (BIT 1-3)          '          @XA06108
         LINE  SKIP=2                                          @XA06108
         ROUTINE ZONER03,DATAZON                               @XA06108
         LABEL 'DATA FLOW ZONE   (BIT 5-7)          '          @XA06108
         LINE  SKIP=1
         LABEL ''
DUMPCODE DC    X'FF'
DUMPSIZE DC    XL2'6D'           SIZE OF LOGOUT                @XA06108
         DC    XL2'50'                  HEADER
ADDRLABL DC    XL2'FC'           RECORD ADDRESS                @XA06108
         LABEL     ''
LABLAREA EQU   *
         LSTART
         END
