 TITLE 'IFCEM155 MODEL 155 OLYMPUS EDIT TABLE 2'
         MACRO
&NAME    LINE  &DATA,&LABEL,&SKIP=
.*                            THIS MACRO ESTABLISHES THE MARGINS OR
.*                                 COLUMN SETTINGS FOR EACH LINE. IT
.*                                 GENERATES NECESSARY CARRIAGE CONTROL
.*                                 ENTRIES. LASTLY IT DETERMINES THE
.*                                 NUMBER OF ENTRIES ASSOCIATED WITH
.*                                 THE PREVIOUS LINE AND STORES THAT #
.*                                 INTO THE APPROPRIATE BYTE.
.*                            &DATA(1) - CHARACTER POSITION TO BEGIN
.*                                 DATA.
.*                            &DATA(2) - # OF SPACES BETWEEN SUCCESSIVE
.*                                 DATA COLUMN STARTING CHARACTERS.
.*                            &LABEL(1) - CHAR. POS. TO BEGIN LABELS.
.*                            &LABEL(2) - # SPACES BETWEEN LINE'S LABEL
.*                                 STARTING CHARACTERS.
.*                            &SKIP= - # OF LINES TO ADVANCE CARRIAGE
.*                                 TO BEGIN NEXT PRINTED LINE.
.*                            NEW ENTRIES ARE GENERATED ONLY WHEN
.*                                 NECESSARY. OMISSION OF ITEMS MEANS
.*                                 THEY HAVE NOT CHANGED SINCE PREVIOUS
.*                                 SETTINGS. A LINE MACRO IS REQUIRED
.*                                 FOR EACH PRINTED LINE. IF NO SETTING
.*                                 CHANGES ARE REQUIRED ALL OPERANDS
.*                                 ARE OMITTED IN WHICH CASE ONLY THE
.*                                 # OF ENTRIES FOR THE PREVIOUS LINE
.*                                 IS COMPUTED. THIS MACRO MUST BE THE
.*                                 FIRST MACRO INSTRUCTION ISSUED FOR
.*                                 THE SUBJECT LINE
         GBLA  &DB,&DT,&LB,&LT,&NRENTS
         GBLA  &LASTCC,&INITIAL
         GBLC  &NRENTSX
         GBLC  &CARRCON
         GBLB  &TEST
         GBLB  &DIAGTST,&DIAGSET,&DIAGLIN
         LCLA  &S
         AIF   (&INITIAL EQ 0 OR &DIAGTST EQ 0).DIAGSET
         AIF   (&DIAGSET EQ 0).DIAGSET
         MNOTE '**NO LABEL ASSOCIATED WITH LAST SET**'
***** THE FOLLOWING GENERATED FOR TEST PURPOSES *****
*        LABEL '%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%'
               LABEL '%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%'
.DIAGSET ANOP
&DIAGSET SETB  1
&DIAGLIN SETB  1
&NAME    DS    0C
         AIF   (&INITIAL EQ 0).FIRSTLN
         LINEND
         AGO   .NTFIRST
.FIRSTLN ANOP
&NRENTSX SETC  'N&SYSNDX'
&INITIAL SETA  1
N&SYSNDX EQU   *
.NTFIRST ANOP
         DC    AL1(0)
         AIF   ('&DATA(1)' EQ '').CKDTABS
         AIF   (&DATA(1) EQ &DB).CKDTABS
&DB      SETA  &DATA(1)
         AGO   .AA
.CKDTABS AIF   ('&DATA(2)' EQ '').NCDATA
         AIF   (&DATA(2) EQ &DT).NCDATA
         AGO   .CC
.AA      AIF   ('&DATA(2)' EQ '').BB
         AIF   (&DATA(2) EQ &DT).BB
.CC      ANOP
&DT      SETA  &DATA(2)
.BB      DC    XL2'FFFE'
         DC    FL1'&DB'
         DC    FL1'&DT'
&NRENTS  SETA  &NRENTS+1
.NCDATA  ANOP
         AIF   ('&LABEL(1)' EQ '').CKLTABS
         AIF   (&LABEL(1) EQ &LB).CKLTABS
&LB      SETA  &LABEL(1)
         AGO   .AAA
.CKLTABS AIF   ('&LABEL(2)' EQ '').NCLABEL
         AIF   (&LABEL(2) EQ &LT).NCLABEL
         AGO   .CCC
.AAA     AIF   ('&LABEL(2)' EQ '').BBB
         AIF   (&LABEL(2) EQ &LT).BBB
.CCC     ANOP
&LT      SETA  &LABEL(2)
.BBB     DC    XL2'FFFF'
         DC    FL1'&LB'
         DC    FL1'&LT'
&NRENTS  SETA  &NRENTS+1
.NCLABEL ANOP
         AIF   ('&SKIP' NE '').CONT
         AIF   (&TEST EQ 0).NOCHANG
         AGO   .DEFALTA
.CONT    ANOP
         AIF   (&TEST EQ 0).AB
         AIF   ('&SKIP' EQ 'E').AB
&S       SETA  &SKIP
.DEFAULT ANOP
         AIF   (&SKIP EQ &LASTCC).DEFALTA
         ORG   &CARRCON+3
         DC    AL.3(0),AL.2(&S),AL.3(1)
         ORG
&LASTCC  SETA  &S
.DEFALTA ANOP
&TEST    SETB  0
         AGO   .DD
.AB      AIF   ('&SKIP' NE 'E').ABB
A&SYSNDX DC    X'FFFB8B00'              EJECT
         AGO   .ABC
.ABB     AIF   (&SKIP EQ &LASTCC).NOCHANG
A&SYSNDX DC    XL2'FFFB'
         DC    AL.3(0),AL.2(&SKIP),AL.3(1)
         DC    AL.3(0),AL.2(&SKIP),AL.3(1)
&LASTCC  SETA  &SKIP
&TEST    SETB  1
.ABC     ANOP
&CARRCON SETC  'A&SYSNDX'
&NRENTS  SETA  &NRENTS+1
.DD      ANOP
.NOCHANG ANOP
         MEND
*
***********************************************************************
*
*
         MACRO
&NAME    ROUTINE  &LOGITEM,&RNAME
         GBLC  &ITEM(3000)
         GBLA  &SHIFT(3000),&ITEMNBR
         GBLC  &DSECT,&CSECT
         GBLA  &NRENTS
         LCLA  &ISHIFT,&NDX
.LOOP    ANOP
&NDX     SETA  &NDX+1
         AIF   ('&ITEM(&NDX)' EQ '&LOGITEM').FOUND
         AIF   (&NDX LT &ITEMNBR).LOOP
         MNOTE 'LOG ITEM NOT DEFINED'
         MEXIT
.FOUND   ANOP
&ISHIFT  SETA  &SHIFT(&NDX)
&NAME    DC    AL.12(&LOGITEM-&DSECT),XL.4'D'
         DC    AL.4(&ISHIFT),AL.12(&RNAME-&CSECT)
&NRENTS  SETA  &NRENTS+1
         MEND
*
*
***********************************************************************
*
*
         MACRO
&NAME    LABEL &LABEL1,&LABEL2,&LABEL3,&LABEL4,&LABEL5,&LABEL6,        C
               &LABEL7,&LABEL8
.*                                 THIS MACRO ALLOWS LABELS TO
.*                                 BE SPECIFIED FOR A GIVEN LINE. THE
.*                                 LABELS SHOULD BE ENCLOSED IN QUOTA-
.*                                 TION MARKS. THE COLUMN AND LINE END
.*                                 CONTROLS WILL BE INSERTED BY THE
.*                                 MACRO. OMITTED OPERANDS MEAN NO
.*                                 LABEL REQUIRED FOR RESPECTIVE
.*                                 COLUMN.
         GBLC &LABELS(3000)
         GBLC  &LBL(300)
         GBLA  &LBLCTR(300)
         GBLA  &LABELNR
         GBLA  &NRENTS,&LPTR,&INITIAL
         GBLB  &DIAGTST,&DIAGSET,&DIAGLIN
         LCLC  &MARGIN,&TACK
         LCLC  &TEXT
         LCLA  &OP,&K,&START,&NRCHAR,&REMAIN
         ACTR  500000
         AIF   (&INITIAL EQ 0).DIAGCLR
         AIF   (&DIAGTST EQ 0).DIAGCLR
         AIF   (&DIAGLIN EQ 1).DIAGCLR
         MNOTE '**NO LINE ASSOCIATED WITH PREVIOUS LABEL**'
***** THE FOLLOWING GENERATED FOR TEST PURPOSES *****
*        LINE
         LINE
.DIAGCLR ANOP
&DIAGSET SETB  0
&DIAGLIN SETB  0
&MARGIN  SETC  '*'
         AIF   ('&NAME' EQ '').LOOPOUT
&LPTR    SETA  &LPTR+1
&LBL(&LPTR) SETC '&NAME'
&LBLCTR(&LPTR) SETA &LABELNR+1
.LOOPOUT ANOP
&OP      SETA  &OP+1
&K       SETA  K'&SYSLIST(&OP)
         AIF (&K GE 2).NORM
&K       SETA  2
.NORM    ANOP
&START   SETA  2
         AIF (&OP LT N'&SYSLIST).NOTLAST
&MARGIN  SETC  '$'
.NOTLAST ANOP
&NRCHAR  SETA  8
&TACK    SETC  ''
.LOOPIN  ANOP
&REMAIN  SETA  &K-&START
         AIF (&REMAIN GE 8).MORE
&TACK    SETC  '&MARGIN'
&NRCHAR  SETA  &REMAIN
.MORE    ANOP
&TEXT    SETC  ''
         AIF (&REMAIN EQ 0).ENDTEXT
&TEXT    SETC  '&SYSLIST(&OP)'(&START,&NRCHAR)
.ENDTEXT ANOP
&LABELNR SETA  &LABELNR+1
&LABELS(&LABELNR) SETC '&TEXT'.'&TACK'
&START   SETA  &START+8
         AIF ('&TACK' EQ '').LOOPIN
         AIF ('&TACK' EQ '*').LOOPOUT
         MEND
         SPACE 2
         MACRO
         LSTART
.*                            THIS MACRO IS ISSUED WHEN THE LABEL AREA
.*                                 OF THE TABLE IS TO BEGIN.
         GBLC &LABELS(3000)
         GBLA  &LABELNR
         GBLC  &LBL(300)
         GBLA  &LBLCTR(300)
         LCLA  &NDX,&CTR
         LINEND
&CTR     SETA  1
.LOOP    ANOP
&NDX     SETA  &NDX+1
         AIF   (&LBLCTR(&CTR) NE &NDX).NOLBL
&LBL(&CTR) DC  C'&LABELS(&NDX)'
&CTR     SETA  &CTR+1
         AGO   .LOOPCTL
.NOLBL   ANOP
         DC    C'&LABELS(&NDX)'
.LOOPCTL AIF   (&NDX LT &LABELNR).LOOP
         MEND
*
*
***********************************************************************
*
*
         MACRO
         LINEND
.*                                 THIS MACRO IS USED ONLY BY THE LINE
.*                                 MACRO TO SET THE NUMBER OF ENTRIES
.*                                 ASSOCIATED WITH EACH LINE.
         GBLA  &NRENTS
         GBLC  &NRENTSX
         ORG   &NRENTSX
         DC    FL1'&NRENTS'
         ORG
&NRENTS  SETA  0
B&SYSNDX EQU   *
&NRENTSX SETC  'B&SYSNDX'
         MEND
*
*
***********************************************************************
*
*
         MACRO
&NAME    BIND  &Z1,&Z2,&Z3,&Z4
.*                                 THIS MACRO HELPS COLLOCATE BITS IN
.*                                 DIFFERENT AREAS OF THE LOG TO MAKE
.*                                 THEM ACCESSIBLE TO THE 'HEX' MACRO.
.*                                 EACH OPERAND HAS 3 SUBFIELDS:1 SPE-
.*                                 CIFIES BY LOGITEM NAME THE BYTE TO
.*                                 BE REFERENCED,2 GIVES THE NUMBER OF
.*                                 UNDESIRED BITS TO THE LEFT OF THE
.*                                 LOG ITEM'S FIRST BIT,3 GIVES THE LOG
.*                                ITEM'S LENGTH IN BITS. THE MACRO
.*                                CAUSES THE INFORMATION TO BE STORED &
.*                                CONTROL IS GIVEN TO THE 'BINDER' ROU-
.*                                TINE,WHICH STORES THE COLLOCATED
.*                                BITS RIGHT-JUSTIFIED IN THE FOUR-
.*                                BYTE WORK AREA INSERTED IN THE LOG,
.*                                BEGINNING AT 'LOGWORK1'
         GBLC      &DSECT
         LCLA  &OP
         ACTR  500000
&NAME    BC    15,BINDER
.LOOP    ANOP
&OP      SETA  &OP+1
         DC    AL.16(&SYSLIST(&OP,1)-&DSECT)
         DC    FL1'&SYSLIST(&OP,2)'
         DC    FL1'&SYSLIST(&OP,3)'
         AIF   (&OP LT N'&SYSLIST).LOOP
         ORG   &NAME+4
         DC    AL.4(&OP),AL.12(&SYSLIST(1,1)-&DSECT)
         ORG
         MEND
         MACRO
&NAME    CKPARITY  &PAR1,&PAR2,&PAR3,&PAR4,&PAR5,&PAR6
.*                                THIS MACRO HELPS SET THE LOCATION
.*                                CONTROLS FOR A SPECIAL ROUTINE TO
.*                                CHECK PARITY ON ITEMS FROM THE LOG
.*                                ALREADY ASSEMBLED FOR PRINTING IN THE
.*                                PRINT BUFFER THAT HAS BEEN SET UP.
.*                                EACH OPERAND (UP TO SIX) HAS THREE
.*                                SUBFIELDS:1 GIVES THE DISPLACEMENT
.*                                FROM PRINT POSITION ZERO TO BEGIN
.*                                THE PARITY CHECK(I.E.,LOC. OF PARITY
.*                                BIT IN BUFFER);2 GIVES THE NUMBER OF
.*                                POSITIONS TO CHECK AGAINST THE PARITY
.*                                BIT (ASSUMING 1 SPACE BETWEEN PAR BIT
.*                                AND THE FIRST POSITION TO BE CHECKED)
.*                                3 GIVES THE NUMBER OF SEQUENTIAL PAR.
.*                                CHECKS OF THIS SORT TO MAKE,ASSUMING
.*                                TWO SPACES BETWEEN THE LAST POSITION
.*                                CHECKED AND NEXT PAR. BIT POSITION
         LCLA  &OP
&NAME    BC    15,PARPUT
         DC    X'0'
.LOOP    ANOP
&OP      SETA  &OP+1
         DC    FL1'&SYSLIST(&OP,1)'
         DC    FL1'&SYSLIST(&OP,2)'
         DC    FL1'&SYSLIST(&OP,3)'
         AIF   (&OP LT N'&SYSLIST).LOOP
         ORG   &NAME+4
         DC    FL1'&OP'
         ORG
         MEND
         MACRO
         DSGENFET
         DS    0F
         DSGEN (XKEY,16),(XSWS0,8),(XSWS8,1),(XSWS9,1),                *
               (XSWS10,1),(XSWS11,1),                                  *
               (XSWS12,1),(XSWS13,1),(XSWS14,1),(XSWS15,1)
         DSGEN (LOGWORK1,8),(LOGWORK2,6),(LOGWORK3,2),(LOGWRK3A,4),    *
               (LOGWRK3B,3),(LOGWRK3C,1),(LOGWORK4,8)
         DSGEN (XDATE,32)
         DSGEN (XTIME,32)
         DSGEN (XDUM2,8),(XSER,24)
         DSGEN (XCPUMOD,16),(XDUM3,16)
         DSGEN (XPGMID,64)
         DSGEN (XJOBID,64)
         DSGEN (XMCKPSW,64)
         DSGEN (SYSDAM,1),(PROCD,1),(SYSREC,1),(TIMDAM,1),(CLOCKD,1),  X
               (EXTDAM,1),(MDUM0,1),(AUTOCON,1),(WARNG,1),             X
               (DUM,5),(BACKUP1,1),(DELAY,1),(UNSTOR,1),               *
               (CORRST,1),(KEYERR,1),(DUMMY001,1),(EMWP,1),            *
               (SYSMSK,1),(PGMSK,1),(IAVLD,1),(FASTVLD,1),             X
               (RCVLD,1),(MDUM3,1),(FLPVLD,1),(GPRVLD,1),              X
               (CTLVLD,1),(LOGVLD,1),(STVLD,1)
         DS    276C
         DSGEN (XBUS0,8),(XBUS1,8),(XBUS2,8),(XBUS3,8)
         DSGEN (YBUS0,8),(YBUS1,8),(YBUS2,8),(YBUS3,8)
         DSGEN (ZBUS0,8),(ZBUS1,8),(ZBUS2,8),(ZBUS3,8)
         DSGEN (UBUS,8),(VBUS,8),(WBUS,8),(FILREG,8)
         DSGEN (STLNK,1),(RABUSRP,1),(RABUSBI,1),(RABUS1P,1),          *
               (RABUS1,4),(RABUS3,8),(BFRBUSY,1),(RBAR1RP,1),          *
               (RBAR1BI,1),(RBAR11P,1),(RBAR11,4),(RBAR13,8)
         DSGEN (LSSSTS,2),(CPURLAR,6),(WRCPULS,1),(DUMMY000,1),        *
               (CPUWLAR,6),(DUMMY002,1),(DUMMY003,1),(IORLAR,6),       *
               (WRIOLS,1),(DUMMY004,1),(IOWLAR,6)
         DSGEN (EXTSW0,8),(EXTSW1,8),(EXTSW2,8),(EXTSW3,8)
         DSGEN (SPARE030,8),(SPARE031,8),(SPARE032,8),(SPARE033,8)
         DSGEN (AREG0,8),(AREG1,8),(AREG2,8),(AREG3,8)
         DSGEN (BREG0,8),(BREG1,8),(BREG2,8),(BREG3,8)
         DSGEN (CREG0,8),(CREG1,8),(CREG2,8),(CREG3,8)
         DSGEN (DREG0,8),(DREG1,8),(DREG2,8),(DREG3,8)
         DSGEN (IOLSD0,8),(IOLSD1,8),(IOLSD2,8),(IOLSD3,8)
         DSGEN (CPULS0,8),(CPULS1,8),(CPULS2,8),(CPULS3,8)
         DSGEN (IOSAR0,8),(IOSAR1,8),(IOSAR2,8),(IOSAR3,8)
         DSGEN (CPUSR0,8),(CPUSR1,8),(CPUSR2,8),(CPUSR3,8)
         DSGEN (SPARE034,8),(IAR1,8),(IAR2,8),(IAR3,8)
         DSGEN (PSWSM,8),(PSWKEY,8),(PSWESM,8),(CONSUM,1),     @YA02788X
               (STRT,1),(RSTRT,1),(MPRSET,1),(SPARE035,4)      @YA02788
         DSGEN (RBAR2IO,1),(RBAR2RP,1),(RBAR2BI,1),(RBAR21P,1),        *
               (RBAR21,4),(RBAR23,8),(RBAR3IO,1),(RBAR3RP,1),          *
               (RBAR3BI,1),(RBAR31P,1),(RBAR31,4),(RBAR33,8)
         DSGEN (BS0,4),(BS4P,1),(BS4,3),(ABCTRP,1),                    *
               (ABCTR,3),(CBCTRP,1),(CBCTR,3),(IFTHRS,1),              *
               (IFRES,1),(IFINV,1),(IFPRTC,1),(IFIC,1),                *
               (IFEXS,1),(IFILC,2),(ALUFNR,4),                         *
               (QBIT,1),(CCST,1),(CSA,1),(CSB,1)
         DSGEN (L12CTR,8),(L2SS,1),(CC,2),                             *
               (FNBR,2),(ALWTRP,1),(NSSMD,1),(DUMMY006,1),             *
               (R12CTR,8),(INABRR,3),(INBBRR,4),(HYRST,1)
         DSGEN (SRADAD1,7),(HRDCHK,1),(SERADM,1),(INTDL,1),            *
               (WAITFR,1),(ENGHEAD,1),(INPERR,1),(CLKERR,1),           *
               (ABCOMPS,1),(LOGCMPS,1),(DIAGCTR,8),(SPRWL036,7),       X
               (R5136,1)
         DSGEN (DUMMY007,1),(DUMMY008,1),(INDDISP,1),(CPURA1P,1),      *
               (CPURA1,4),(CPURA3,8),(GPSTL1,4),(GPSTL2P,1),           *
               (GPSTL2,3),(S19,1),(EXTST,1),(ANYEXC,1),                *
               (ICPLUS4,1),(IC1B29,1),(IB0FULL,3)
         DSGEN (SPARE037,8),(SPARE038,8),(SPARE039,8),(SPARE040,8)
         DSGEN (XBUSE,4),(YBUSE,4),(CARRYE,8),(HSUME,4),(ZBUSE,4),     *
               (LSREGE,4),(CISARE,4)
         DSGEN (GPSTE,2),(LCTRE,1),(RCTRE,1),                          *
               (DUMMY009,1),(DUMMY010,1),(ABE,1),(CBE,1),              *
               (PSW0E,1),(PSW1E,1),(PSW2E,1),(PSW3E,1),                *
               (WBUSE,1),(ABCTRE,1),(CBCTRE,1),(MEME,1),               *
               (EXTSWE,4),(EESW0E,1),(HOFFE,1),(ABDLYE,1),(EESW3E,1),  *
               (CLSARE,1),(CH02E,1),(CH35E,1),(MVRHSE,1),              *
               (MPSCC,1),(MVRFNE,1),(ICE,2)                    @YA02788
         DSGEN (ERLYRE,3),(RSYNCE,1),                                  *
               (LATER0E,1),(LATER1E,1),(LATER2E,1),(LATER3E,1),        *
               (MISDECE,1),(SSDECE,1),(CNTDECE,1),(BBRE,1),            *
               (RADRE,1),(ZDECE,1),(CRUCWLS,1),(TMKE,1),               *
               (SPARE041,8),(SPARE042,8)
         DSGEN (CP1R0,4),(CP1R1P,1),(CP1R1,3),(CP2R0P,1),              *
               (CP2NC,1),(CP2SE,1),(CP2DE,1),(CP2IE,1),                *
               (CP2R1P,1),(CP2HC,1),(CP2AC,1),(CP2R3,1),               *
               (ERRCTR,4),(IGNORE1,1),(SERDIS,1),(ENDATA,1),           *
               (SDC,1),(DUMMY015,1),(HARDST,1),(ADRCPST,1),            *
               (DUMMY016,1),(DUMMY017,1),(DUMMY018,1),(DUMMY019,1)
         DSGEN (ABI1,1),(NXA1,3),(NXB1,4),(BRC11,1),                   *
               (ABR1,5),(BBR01,2),(BBR21,2),(IOPR,2),                  *
               (IOSSB,3),(XYALU01,1),(XYALU21,2),(UX1,3),              *
               (VY1,3)
         DSGEN (LRSP,1),(LSWR,4),(LSRD,3),(MISC21,2),                  *
               (CNT1,4),(Z01,2),(Z21,1),(ZW1,4),                       *
               (XYSH1,3),(EMIT1,5),(EMIT2,3)
SPARE043 DS    136C
         DSGEN (CHSELA0,1),(CHSELA1,1),(CHSELA2,1),(CHIOM,1),          *
               (CHROAR,1),(CHNUM0,1),(CHNUM1,1),(CHNUM2,1),            *
               (CHREQC1,1),(CHREQCB,1),(CIOMLTH,1),(IOMB,1),           *
               (C1PR2,1),(C1PR3,1),(C2PR2,1),(C2PR3,1),                *
               (C3PR2,1),(C3PR3,1),(C4PR2,1),(C4PR3,1),                *
               (C5PR2,1),(C5PR3,1),(MPXOS2,1),(DUMMY185,1),            *
               (DUMMY186,1),(DUMMY187,1),(DUMMY188,1),(DUMMY189,1),    *
               (DUMMY190,1),(ANYIR,1),(CHDIAGM,1),(CHFC,1)
         DSGEN (SNSBYTX,8),(RDYX,1),(SELPGX,1),(XSDSEL,1),(SEQ1X,1),   *
               (SEQ2X,1),(SEQ3X,1),(SEQ4X,1),(SEQ5X,1),(DISCX,1),      *
               (STAPTYX,1),(ATTX,1),(BUSYX,1),(CHENDX,1),(DVENDX,1),   *
               (UNCKX,1),(UNEXCPX,1),(STACKX,1),(WRITX,1),(XREAD,1),   *
               (CTRLX,1),(SCBYX,1),(EOFX,1),(XSPARE,1),(ENCMPX,1)
         DS    4C
         DSGEN (C4HCE,1),(C4BCIE,1),(C4BME,1),(C4IRE,1),               *
               (C4LRE,1),(C4SBE,1),(C4SBOE,1),(C4ISE,1),               *
               (C4SPE,1),(C4SWE,1),(C5HCE,1),(C5BCIE,1),               *
               (C5BME,1),(C5IRE,1),(C5LRE,1),(C5SBE,1),                *
               (C5SBOE,1),(C5ISE,1),(C5SPE,1),(C5SWE,1),               *
               (CCCH3E,1),(CCCH4E,1),(CCCH5E,1),(C3CLE,1),             *
               (C3ITE,1),(C4CLE,1),(C4ITE,1),(C5CLE,1),                *
               (C5ITE,1),(C35SCE,1),(C35ITAE,1),(C35ITBE,1)
         DSGEN (BIRPE,1),(BIRE,1),(C0BCE,1),(C0BOCE,1),                *
               (C0S07E,1),(C0RE,1),(C0UCE,1),(C0CCE,1),                *
               (C0RCE,1),(C0ITE,1),(C0CLE,1),(C1ITE,1),                *
               (C1CLE,1),(C2ITE,1),(C2CLE,1),(UPDE,1),                 *
               (EMITFLE,1),(EMITINE,1),(PSWCKE,1),(L2CNTRE,1),         *
               (CSELCPE,1),(DUMMY191,1),(DUMMY192,1),(DUMMY193,1),     *
               (DUMMY194,1),(DUMMY195,1),(C02ITAE,1),(C02ITBE,1),      *
               (C02STCE,1),(SBPE,1),(OUTTAGE,1),(GRPSELE,1)
         DSGEN (DUMMY196,1),(DUMMY197,1),(ROSINTE,1),(ROSINPE,1),      *
               (LSTOCHE,1),(HDWCHE,1),(HCIE,1),(HRRE,1),               *
               (HLCE,1),(UPLSARE,1),(WRLSUPE,1),(IN1SELE,1),           *
               (IN2ROSE,1),(IN3SELE,1),(LS01INE,1),(LS23INE,1),        *
               (INTCRDE,1),(LOGYINE,1),(LOGRDRE,1),(DUMMY198,1),       *
               (STBBE,1),(STDCDE,1),(YICDCDE,1),(BUSPTYE,1),           *
               (RLCTRE,1),(DUMMY199,1),(DUMMY200,1),(DUMMY201,1),      *
               (LSUCWAE,1),(BIRESPE,1),(SELCNE,1),(MURE,1)
         DSGEN (HCIDE,1),(UPCIDE,1),(C0BOPE,1),(C0BIE,1),              *
               (C1BOPE,1),(C1BIE,1),(C2BOPE,1),(C2BIE,1),              *
               (C3BOPE,1),(C3BIE,1),(C4BOPE,1),(C4BIE,1),              *
               (C5BOPE,1),(C5BIE,1),(HCLE,1),(LSRLOGE,1),              *
               (C0WRLSE,1),(C1WRLSE,1),(C2WRLSE,1),(C3WRLSE,1),        *
               (C4WRLSE,1),(C5WRLSE,1),(C01CXE,1),(C23CXE,1),          *
               (C45CXE,1),(MPCIDE,1),(DUMMY202,1),(DUMMY203,1),        *
               (DUMMY204,1),(DUMMY205,1),(DUMMY206,1),(DUMMY207,1)
         DSGEN (SNSBYTY,8),(RDYY,1),(SELPGY,1),(YSDSEL,1),(SEQ1Y,1),   *
               (SEQ2Y,1),(SEQ3Y,1),(SEQ4Y,1),(SEQ5Y,1),(DISCY,1),      *
               (STAPTYY,1),(ATTY,1),(BUSYY,1),(CHENDY,1),(DVENDY,1),   *
               (UNCKY,1),(UNEXCPY,1),(STACKY,1),(WRITY,1),(YREAD,1),   *
               (CTRLY,1),(SCBYY,1),(EOFY,1),(YSPARE,1),(ENCMPY,1)
         DSGEN (AIRINE1,6),(AIROE0,2),(ADOE,4),(BSMB1E,2),     @Z02774 X
               (ECCLOE,1),(ECCHIE,1),(SASTORE,1),(SATS,1),             X
               (ECCRD,1),(UCWSEL,1),(IOMODE,1),(DUMMY208,1),           X
               (UCORIO,1),(UCORCPU,1),(ECCBB,8)
         DSGEN (CONSDR,8),(CONSECE,1),(CONSTOE,1),(CONSR0E,1),         *
               (CONSR3E,1),(CONSCRL,1),(CONSWR,1),(DUMMY209,1),        *
               (CONSEXC,1),(SPARE074,8),(SPARE075,8)
         DSGEN (SPARE076,8),(SPARE077,8),(SPARE078,8),(SPARE079,8)
         DSGEN (SPARE080,8),(SPARE081,8),(SPARE082,8),(SPARE083,8)
         DSGEN (FALE0,8),(FALE1,8),(FALE2,8),(FALE3,8)
         DSGEN (FALO0,8),(FALO1,8),(FALO2,8),(FALO3,8)
         DSGEN (FAHE0,8),(FAHE1,8),(FAHE2,8),(FAHE3,8)
         DSGEN (FAHO0,8),(FAHO1,8),(FAHO2,8),(FAHO3,8)
         DSGEN (SPARE084,8),(BCUS1,8),(BCUS2,8),(BCUS3,8)
         DSGEN (SPARE085,8),(ASARB1,8),(ASARB2,8),(ASARB3,4),(ASARB4,4)
         DSGEN (R540,1,2,9),(R54,1,11,18),(R54,1,20,27),(R54,1,29,36)
BASIC    DSGEN (EMITE,1,EQU,R5402),(TIMEOE,1,EQU,R5403),               X
               (SPKEYOE,1,EQU,R5404),(KEYBUSE,1,EQU,R5405),            X
               (SAR1E,3,EQU,R5406),(C40B0E,1,EQU,R5409),               X
               (C40B2E,6,EQU,R5411),(IDXLE,1,EQU,R5417),               X
               (IDXUE,1,EQU,R5418),(RDCOMPE,1,EQU,R5420),              X
               (BYTEMKE,1,EQU,R5421),(SDR08E,1,EQU,R5422),             X
               (SDR19E,1,EQU,R5423),(SDR210E,1,EQU,R5424),             X
               (SDR311E,1,EQU,R5425),(SDR412E,1,EQU,R5426),            X
               (SDR513E,1,EQU,R5427),(SDR715E,1,EQU,R5429)
M9       DSGEN (ER5405,3,EQU,R5405),(ER5411,5,EQU,R5411),              X
               (ER5408,2,EQU,R5408),(R542627,2,EQU,R5426),             X
               (R540507,3,EQU,R5405)
         DSGEN (LINDXA,5),(LINDXB,3),(LINDXV1,1),(LINDXV2,1),          *
               (LINDXOK,1),(LOWERBC,1),(LOWERVC,1),(LOWOKO,1),         *
               (LOWERA,1),(MSSELBR,1),(UINDXA,5),(UINDXB,3),           *
               (UINDXV1,1),(UINDXV2,1),(UINDXOK,1),(UPPERBC,1),        *
               (UPPERVC,1),(UPROKO,1),(UPPERA,1),(BACKSBY,1)
         DSGEN (BCUB0,4),(BCUB4P,1),(BCUB4,3),(BCUB8P,1),              *
               (BCUB8,4),(BCUB12P,1),(BCUB12,2),(BCUB15,1),            *
               (ADP2SEL,1),(ADP2ECC,1),(ADP2MCK,1),(DUMMY217,1),       *
               (DUMMY218,1),(DUMMY219,1),(IVA,1),(R2529,5),            *
               (R2534,1),(R2535,2)
         DSGEN (BCURD,1),(BCUWR,1),(BCUFIB,1),(BCUSPMS,1),             *
               (BCUIECC,1),(BCUDC40,1),(BCUIOMD,1),(ECCMD1,1),         *
               (EDRDECC,1),(DUMMY220,1),(EDTS,1),(R1514,1),            *
               (R1515,1),(R1516,1),(EDWSPK,1),(R1518,1),               *
               (EDVALA,1),(IBRFCH,1),(DUMMY224,1),(DUMMY225,1),        *
               (EDRSPK,1),(EDDEGA,1),(HISTAT,1),(ODDSTAT,1),           *
               (MSIREAD,1),(MSIWR,1),(DUMMY226,1),(MSITS,1),           *
               (DUMMY227,1),(MSIIOOP,1),(MSIRECC,1),(MSIUCWS,1)
         DSGEN (AIROFET,1),(AIROSTO,1),(AIROHRT,1),(AIROTS,1),         *
               (DUMMY228,1),(AIROVRD,1),(AIROECD,1),(AIROBS,1),        *
               (SPARE086,8),(MSCAIDL,1),(DUMMY229,1),(DUMMY230,1),     *
               (MSCCIP,1),(MSCWC,1),(MSCDR2C,1),(MSCAD25,1),           *
               (MSCBD25,1),(SPARE087,8)
         DSGEN (CONSR0,8),(CONSR1,8),(CONSR2,8),(CONSR3,8)
R1802    DS    4C
         DSGEN (R2802,1),(R2803,1),(R2804,1),(R2805,1),(R2806,1),      X
               (R2807,1),(R2808,1),(R2809,1),(R281A,1),                X
               (R2812,1),(R2813,1),(R2814,1),(R2815,1),(R2816,1),      X
               (R2817,1),(R2818,1),(R2820,1),(R2821,1),(R2822,1),      X
               (R2823,1),(R2824,1),                                    X
               (R2825,3),                                              X
               (R2829,5),(R2834,2),(R2836,1)
XQX      DSGEN                       (R2811,13,EQU,R281A),             X
               (R2811R,8,EQU,R281A),(R2820R,8,EQU,R2820),              X
               (R2829R,8,EQU,R2829)
         DS    3C
R3829    DS    2C
R1711    DS    7C
         DS    4C
SPARE127 DS    136C
         DSGEN (XBUS0P,1),(DUMMY231,1),(XBUS1P,1),(DUMMY232,1),        *
               (XBUS2P,1),(DUMMY233,1),(XBUS3P,1),(DUMMY234,1),        *
               (YBUS0P,1),(DUMMY235,1),(YBUS1P,1),(DUMMY236,1),        *
               (YBUS2P,1),(DUMMY237,1),(YBUS3P,1),(DUMMY238,1),        *
               (ZBUS0P,1),(DUMMY239,1),(ZBUS1P,1),(DUMMY240,1),        *
               (ZBUS2P,1),(DUMMY241,1),(ZBUS3P,1),(DUMMY242,1),        *
               (UBUSP,1),(DUMMY243,1),(VBUSP,1),(DUMMY244,1),          *
               (WBUSP,1),(DUMMY245,1),(FILREGP,1),(DUMMY246,1)
         DSGEN (DUMMY247,1),(DUMMY248,1),(RABUS2,1),(DUMMY249,1),      *
               (HOLDOFF,1),(DUMMY250,1),(RBAR12,1),(DUMMY251,1),       *
               (SPARE088,8),(EXTSW0P,1),(DUMMY252,1),(EXTSW1P,1),      *
               (DUMMY253,1),(EXTSW2P,1),(DUMMY254,1),(EXTSW3P,1),      *
               (DUMMY255,1),(SPARE089,8)
         DSGEN (AREG0P,1),(DUMMY256,1),(AREG1P,1),(DUMMY257,1),        *
               (AREG2P,1),(DUMMY258,1),(AREG3P,1),(DUMMY259,1),        *
               (BREG0P,1),(DUMMY260,1),(BREG1P,1),(DUMMY261,1),        *
               (BREG2P,1),(DUMMY262,1),(BREG3P,1),(DUMMY263,1),        *
               (CREG0P,1),(DUMMY264,1),(CREG1P,1),(DUMMY265,1),        *
               (CREG2P,1),(DUMMY266,1),(CREG3P,1),(DUMMY267,1),        *
               (DREG0P,1),(DUMMY268,1),(DREG1P,1),(DUMMY269,1),        *
               (DREG2P,1),(DUMMY270,1),(DREG3P,1),(DUMMY271,1)
         DSGEN (IOLSD0P,1),(DUMMY272,1),(IOLSD1P,1),(DUMMY273,1),      *
               (IOLSD2P,1),(DUMMY274,1),(IOLSD3P,1),(DUMMY275,1),      *
               (CPULS0P,1),(DUMMY276,1),(CPULS1P,1),(DUMMY277,1),      *
               (CPULS2P,1),(DUMMY278,1),(CPULS3P,1),(DUMMY279,1),      *
               (IOSAR0P,1),(DUMMY280,1),(IOSAR1P,1),(DUMMY281,1),      *
               (IOSAR2P,1),(DUMMY282,1),(IOSAR3P,1),(DUMMY283,1),      *
               (CPUSR0P,1),(DUMMY284,1),(CPUSR1P,1),(DUMMY285,1),      *
               (CPUSR2P,1),(DUMMY286,1),(CPUSR3P,1),(DUMMY287,1)
         DSGEN (DUMMY288,1),(DUMMY289,1),(IAR1P,1),(DUMMY290,1),       *
               (IAR2P,1),(DUMMY291,1),(IAR3P,1),(DUMMY292,1),          *
               (PSWSMP,1),(DUMMY293,1),(PSWKEYP,1),(DUMMY294,1),       *
               (PSWESMP,1),(DUMMY295,1),(RETENBL,1),(DUMMY297,1),      X
               (DUMMY298,1),(DUMMY299,1),(RBAR22,1),(DUMMY300,1),      *
               (DUMMY301,1),(DUMMY302,1),(RBAR32,1),(DUMMY303,1),      *
               (BS0P,1),(DUMMY304,1),(BS7,1),(DUMMY305,1),             *
               (IFTCHSP,1),(DUMMY306,1),(ALUFNRP,1),(DUMMY307,1)
         DSGEN (L12CTRP,1),(DUMMY308,1),(L1SS,1),(DUMMY309,1),         *
               (R12CTRP,1),(DUMMY310,1),(INABRR0,1),(DUMMY311,1),      *
               (SRADAD0,1),(DUMMY312,1),(BLKCONS,1),(DUMMY313,1),      *
               (CTRERR,1),(DUMMY314,1),(DUMMY315,1),(DUMMY316,1),      *
               (DUMMY317,1),(DUMMY318,1),(CPURA2,1),(DUMMY319,1),      *
               (GPSTL1P,1),(DUMMY320,1),(GPSTL3,1),(DUMMY321,1),       *
               (SPARE090,8)
         DSGEN (SPARE091,8),(SPARE092,8),(SPARE093,8),(CP1R0P,1),      *
               (DUMMY322,1),(CP1R2,1),(DUMMY323,1),(CP2R2,1),          *
               (DUMMY324,1),(DUMMY325,1),(DUMMY326,1)
         DSGEN (R0P1,1),(DUMMY327,1),(BRC01,1),(DUMMY328,1),           *
               (BBR11,1),(DUMMY329,1),(XYALU11,1),(DUMMY330,1),        *
               (R1P1,1),(DUMMY331,1),(MISC11,1),(DUMMY332,1),          *
               (Z11,1),(DUMMY333,1),(R2P1,1),(DUMMY334,1),             *
               (SPARE094,8),(SPARE095,8)
         DSGEN (SPARE096,64)
         DSGEN (SPARE097,64)
         DSGEN (SPARE098,64)
         DSGEN (SPARE099,64)
         DSGEN (SPARE100,64)
         DSGEN (AIRIN1E,1),(DUMMY335,1),(AIRO5E,1),(DUMMY336,1),       *
               (SAFETCH,1),(DUMMY338,1),(BUMPBIT,1),(DUMMY339,1),      X
               (CONSEOB,1),(DUMMY340,1),(CONSL2,1),(DUMMY341,1),       *
               (DUMMY342,1),(DUMMY343,1),(DUMMY344,1),(DUMMY345,1),    *
               (SPARE101,16)
         DSGEN (FALE0P,1),(DUMMY346,1),(FALE1P,1),(DUMMY347,1),        *
               (FALE2P,1),(DUMMY348,1),(FALE3P,1),(DUMMY349,1),        *
               (FALO0P,1),(DUMMY350,1),(FALO1P,1),(DUMMY351,1),        *
               (FALO2P,1),(DUMMY352,1),(FALO3P,1),(DUMMY353,1),        *
               (FAHE0P,1),(DUMMY354,1),(FAHE1P,1),(DUMMY355,1),        *
               (FAHE2P,1),(DUMMY356,1),(FAHE3P,1),(DUMMY357,1),        *
               (FAHO0P,1),(DUMMY358,1),(FAHO1P,1),(DUMMY359,1),        *
               (FAHO2P,1),(DUMMY360,1),(FAHO3P,1),(DUMMY361,1)
         DSGEN (DUMMY362,1),(DUMMY363,1),(BCUS1P,1),(DUMMY364,1),      *
               (BCUS2P,1),(DUMMY365,1),(BCUS3P,1),(DUMMY366,1),        *
               (DUMMY367,1),(DUMMY368,1),(ASARB1P,1),(DUMMY369,1),     *
               (ASARB2P,1),(DUMMY370,1),(ASARB3P,1),(DUMMY371,1),      *
               (INSNE,1),(DUMMY372,1),(C40B1E,1),(DUMMY373,1),         *
               (INDXCE,1),(DUMMY374,1),(SDR614E,1),(DUMMY375,1),       *
               (LINDXP,1),(DUMMY376,1),(LINDX19,1),(DUMMY377,1),       *
               (UINDXP,1),(DUMMY378,1),(UINDX19,1),(DUMMY379,1)
         DSGEN (BCUB0P,1),(SPRWL102,1),(BCUB7,1),(SPRWL103,1),         *
               (BCUB14,1),(SPRWL104,1),(SPDATAP,1),(SPRWL105,1),       *
               (BCUM9BY,1),(SPRWL106,1),(EDRECC,1),(SPRWL107,1),       *
               (EDRDC40,1),(SPRWL108,1),(MSIP,1),(SPRWL109,1),         *
               (AIROP,1),(SPRWL110,3),(MSC1024,1),(SPRWL111,1),        *
               (R5528,1),(,1),                                         *
               (CONSR0P,1),(SPRWL112,1),(CONSR1P,1),(SPRWL113,1),      *
               (CONSR2P,1),(SPRWL114,1),(CONSR3P,1),(SPRWL115,1)
         DSGEN (R1801,1),(,2),(R1810,1),(,1),(R1819,1),(,1),(R1828,1), X
               (R2801,1),(,1),(R2810,1),(,1),(R2819,1),(,1),(R2828,1), X
               (,1),(R3801,1),(,1),(R3810,1),(,1),(R3819,1),(,1),      X
               (R3828,1),(,1),(R1701,1),(,1),(R1710,1),(,1),(R1719,1), X
               (,1),(R1728,1),(,1),(R2701,1),(,1),(R2710,1),(,1),      X
               (R2719,1),(,1),(R2728,1),(,1),(R1601,1),(,1),(R1610,1), X
               (,1),(R1619,1),(,1),(R1628,1),(,1)
         DSGEN (SPARE116,16)
SPARE117 DS    32C
         DSGEN (SPARE121,8),(CPUSER,24)
         DSGEN (DCTRL,1),(SPRWL122,1),(DOSEM,1),(SPRWL123,5),          *
               (UCWCNT,8),(FEATURES,16)
         DSGEN (CUADR1,64)
         DSGEN (CUADR2,64)
         DSGEN (UNPLUG,64)
         DSGEN (DARLNGTH,16),(,48)
         DS    6C
         DSGEN (WAITSUFF,8),(,8),(LOSTSUM,48),(,16)
         DS    40C
         DSGEN (FSRADDR,32),(BFSVADDR,32),(EFSVADDR,32),               C
               (INSTADDR,32)
         ORG   LOGWORK1
         DSGEN (LOGWRK,1,0,3,0,7)
         ORG   IAR1
         DSGEN (LH241,24)
         ORG   L2SS
         DSGEN (LB251,1,0,7)
         ORG   SPARE043
         DSGEN (LH278,32),(LH27C,32)
         ORG   AIRINE1
         DSGEN (LB32,1,0,4,0,7)
         ORG   SPARE080
         DSGEN (LB32C,1,0,7),(LB32D,1,0,7),(LB32E,1,0,7),(LB32F,1,0,7)
         ORG   AIROFET
         DSGEN (LB32C,32)
         ORG   SPARE084
         DSGEN (LB340,1,0,7)
         ORG   EMITE
         DSGEN (LB34,1,8,9,0,7)
         ORG   RDCOMPE
         DSGEN (LB34A,1,0,7),(LB34B,1,0,7)
         ORG   LINDXA
         DSGEN (LB34C,1,0,7),(LB34D,1,0,7),(LB34E,1,0,7),(LB34F,1,0,7)
         ORG   BCUB15
         DSGEN (LB35,1,2,6,0,7)
         ORG   MSIREAD
         DSGEN (LB357,1,0,7),(LB358,1,0,7)                     @YA02788
         ORG   R2811
         DSGEN (LH365,24)
         ORG   R1802
         DSGEN (LB36,1,0,9,0,7)
         DSGEN  (LB36A,1,0,7)
         ORG   R3829
         DSGEN (LB36B,1,0,7),(LB36C,1,0,7)                          0.2
         ORG   R1711
         DSGEN (LB36D,1,0,7),(LB36E,1,0,7),(LB36F,1,0,7)
         ORG   SPARE127+2
         DSGEN (LB37A,1,0,7),(LB37B,1,0,7)
         ORG   SPARE127                                             0.2
         DSGEN (LH378,32),(LH37C,8),(LH37D,8),(LH37E,8),(LH37F,8)   0.2
         ORG   DUMMY288
         DSGEN (LB410,1,0,7)
         ORG   SPARE094
         DSGEN (LB41E,1,0,7),(LB41F,1,0,7)
         ORG   AIRIN1E
         DSGEN (LB44,1,8,9,0,7)
         DS    6C
         DSGEN (LB45,1,0,9,0,7)
         DSGEN (LB45A,1,0,7),(LB45B,1,0,7),(LB45C,1,0,7)            0.2
         DSGEN (LB45D,1,0,7),(LB45E,1,0,7)                          0.2
         ORG    SPARE117
         DSGEN  (LB460,1,0,7)
         ORG   SPARE076                                             0.2
         DSGEN (LB328,1,0,7),(LB329,1,0,7),(LB32A,1,0,7),(LB32B,1,0,7)
         ORG   UINDXV1                                         @Z02774
         DSGEN (INDEXZ,1),(CMPABCD,4),(BUF1819,2),(OKOFF,1)    @Z02774
         ORG   SPARE076
         DSGEN (LH328,8),(LH329,8)
         ORG   SPARE117+4                                           0.2
         DSGEN (LB464,1,0,7)                                        0.2
         ORG   R1711+3                                         @YA02788
         DSGEN (LB37,1,0,7,0,7)                                @YA02788
         ORG   CUADR1                                          @YA02788
         DSGEN (LB48A,1,0,7),(LB48B,1,0,7)                     @YA02788
         MEND
         MACRO
&NAME    DSGEN
.*                            THIS MACRO GENERATES ONE DSECT WORD
.*                                 FORMATTED FOR THE SUBJECT LOG RECORD
.*                                 EACH OPERAND HAS TWO SUB LISTS. THE
.*                                 FIRST IS THE NAME OF THE LOG ITEM
.*                                 WHILE THE SECOND IS THE # OF BITS TO
.*                                 ALLOCATE FOR THIS ITEM. ITEMS MUST
.*                                 BE DEFINED CONTIGUOUSLY WITHOUT GAPS
.*                                 UNUSED BIT GROUPS MUST BE GIVEN
.*                                 DUMMY NAMES. THE NAMES PROVIDED FOR
.*                                 THE LOG ITEMS MAY THEN BE USED IN
.*                                 THE CONVERSION MACRO INSTRUCTIONS.
         GBLC &ITEM(3000)
         GBLA &ITEMNBR,&BITS(3000),&SHIFT(3000)
         LCLB  &ONLY1,&CTIND
         LCLA  &START1,&START2,&END1,&END2
         LCLC  &SYMBOL,&EQUSYM
         LCLA  &OP,&COUNT,&BYTE,&EQUCNT
         ACTR  500000
.START   AIF   (N'&SYSLIST(&OP+1) LT 3).LOOP
         AIF   ('&SYSLIST(&OP+1,3)' EQ 'EQU').LOOP     TEST FOR EQU
  AIF   ('&SYSLIST(&OP+1,3)' EQ '' AND '&SYSLIST(&OP+1,4)' EQ '').ERR1
  AIF   ('&SYSLIST(&OP+1,3)' EQ '' OR '&SYSLIST(&OP+1,4)' EQ '').ERR1
         AIF   ('&SYSLIST(&OP+1,3)' GT '&SYSLIST(&OP+1,4)').ERR3
&START1  SETA  &SYSLIST(&OP+1,3)        GET START COUNT OF 1
&START2  SETA  &SYSLIST(&OP+1,4)        GET FIRST END COUNT
         AGO   .SET2A                   BRANCH AROUND
.ERR1    MNOTE '**FIRST SYMBOL CONCATENATION INCOMPLETE**'
         MEXIT
.SET2A   AIF   ('&SYSLIST(&OP+1,5)' EQ ''AND '&SYSLIST(&OP+1,6)' EQ '' X
               ).SET2                   TEST FOR NO SECOND
  AIF   ('&SYSLIST(&OP+1,5)' EQ '' OR '&SYSLIST(&OP+1,6)' EQ '').ERR2
         AIF   ('&SYSLIST(&OP+1,5)' GT '&SYSLIST(&OP+1,6)').ERR3
&END1    SETA  &SYSLIST(&OP+1,5)        GET START COUNT OF 2
&END2    SETA  &SYSLIST(&OP+1,6)        GET END COUNT OF 2
         AGO   .LOOP
.SET2    ANOP
&ONLY1   SETB  1                        INDICATE ONLY ONE CONCATENATION
         AGO   .LOOP
.ERR2    MNOTE '**SECOND SYMBOL CONCATENATION INCOMPLETE**'
         MEXIT
.ERR3    MNOTE '**START GREATER THAN END CONCATENATION**'
         MEXIT
.LOOP    ANOP
&OP      SETA  &OP+1
         AIF   (&OP GT N'&SYSLIST).DONE      TEST IF ALL DONE
&ITEMNBR SETA  &ITEMNBR+1
         AIF   ('&SYSLIST(&OP,2)' NE '').OK1
         MNOTE '**NULL BIT COUNT FIELD**'
         MEXIT
.OK1     ANOP
&SYMBOL  SETC  '&SYSLIST(&OP,1)'
         AIF   ('&SYMBOL' NE '').OK
*              *****     LOG ITEM SYMBOL NOT PROVIDED     *****
         AIF   ('&SYSLIST(&OP,3)' NE 'EQU').CNT
         AGO   .START                   GET NEXT
.OK      AIF   (N'&SYSLIST(&OP) LT 3).NO3    TEST FOR OLD FORMAT
         AIF   ('&SYSLIST(&OP,3)' EQ 'EQU').EQU   TEST FOR EQU
         AIF   (&ONLY1).OK2             TEST FOR ONLY ONE CONCAT
&SYMBOL  SETC  '&SYMBOL.&START1.&END1'       GET 1 AND 2 CONCAT
         AGO   .NO3                     BRANCH AROUND
.OK2     ANOP
&SYMBOL  SETC  '&SYMBOL.&START1'        GET 1 CONCATENATED
.NO3     ANOP
&SYMBOL  EQU   *+&BYTE
&ITEM(&ITEMNBR) SETC '&SYMBOL'          GET LABEL IN GLOBAL
&BITS(&ITEMNBR) SETA &SYSLIST(&OP,2)
&SHIFT(&ITEMNBR) SETA &COUNT-&BYTE*8
.CNT     ANOP
&CTIND   SETB  1                        SET COUNT INDICATOR
&COUNT   SETA  &COUNT+&SYSLIST(&OP,2)
&BYTE    SETA  &COUNT/8
         AIF   (N'&SYSLIST(&OP) LT 3).START  TEST FOR OLD FORMAT
         AIF   (&ONLY1).TSTST           TEST FOR ONLY ONE CONCAT
         AIF   (&END1 EQ &END2).TSTST   TEST FOR SECOND END
&END1    SETA  &END1+1                  INCREMENT COUNT
&OP      SETA  &OP-1                    DECREMENT INCREMENT
         AGO   .LOOP                    GENERATE NEXT
.TSTST   ANOP
         AIF   (&START1 EQ &START2).LPDONE   TEST FOR END
         AIF   (&ONLY1).NSET1           TEST FOR ONLY ONE CONCAT
&END1    SETA  &SYSLIST(&OP,5)          RE-INIT SECOND START COUNT
.NSET1   ANOP
&OP      SETA  &OP-1                    DECREMENT INDEX
&START1  SETA  &START1+1                INCREMENT FIRST COUNT
         AGO   .LOOP                    GO DO NEXT
.LPDONE  ANOP
&ONLY1   SETB  0                        CLEAR INDICATOR
         AGO   .START                   GO TEST FOR MORE SUB-LISTS
.DONE    AIF   (&COUNT-&COUNT/8*8 NE 0).ERR  TEST FOR MULTIPLE OF EIGHT
         AIF   (&CTIND EQ 0).END        NO DS IF NO COUNT
&COUNT   SETA  &COUNT/8                 GET NUMBER OF BYTES
&NAME    DS    &COUNT.C
.END     MEXIT
.ERR     MNOTE '**BIT COUNT FLDS DO NOT TOTAL MULTIPLE OF 8**'
         MEXIT
.EQU     AIF   ('&SYSLIST(&OP,4)' NE '').EQU1     TEST FOR NULL LABEL
.ERR4    MNOTE '**EQU OPERAND OMITTED OR NOT FOUND**'
         MEXIT
.EQU1    AIF   (&SYSLIST(&OP,2) LT 16).EQU2  COUNT OVER FIFTEEN
*****               THE FOLLOWING STATEMENT                *****
*****     NUMBER OF BITS EXCEED 15 - DO NOT USE AS BIN     *****
.EQU2    ANOP
&EQUCNT  SETA  0                        CLEAR COUNTER
&EQUSYM  SETC  '&SYSLIST(&OP,4)'        GET EQU OPERAND
.EQULOP  ANOP
&EQUCNT  SETA  &EQUCNT+1                INCREMENT INDEX
         AIF   ('&ITEM(&EQUCNT)' EQ '&EQUSYM').EQUOUT  LABEL FOUND?
         AIF   (&EQUCNT EQ &ITEMNBR).ERR4    ALL TESTED?
         AGO   .EQULOP                  NO-GET NEXT
.EQUOUT  ANOP
&ITEM(&ITEMNBR) SETC '&SYMBOL'          GET LABEL NAME
&BITS(&ITEMNBR) SETA &SYSLIST(&OP,2)    GET NUMBER OF BITS
&SHIFT(&ITEMNBR) SETA &SHIFT(&EQUCNT)   GET SHIFT COUNT
&SYMBOL  EQU   &EQUSYM                  THIS SYMBOL EQUATED
         AGO   .START                   RETURN FOR NEXT
         MEND
         MACRO
         BIN
.*                                 &SYSLIST(&OP,1) - NAME OF LOG ITEM
.*                                      RECORD DSECT
.*                                 $SYSLIST(&OP,2) - NBR OF SPACES
.*                                      TO SKIP ON MULTIPLE
.*                                      PRINT OR NBR OF SPACES
.*                                      TO BACK UP FROM COLUMN FOR
.*                                      START OF PRINTING. THE LETTER
.*                                      B PRECEEDS THE NUMBER (B5) IF
.*                                      THE LATTER IS DESIRED. OMISSION
.*                                      OF THIS OPERAND FORCES OPTION 2
.*                                      WITH BACKUP SPACING EQUAL TO
.*                                 &SYSLIST(&OP,3) - NBR OF BITS TO PRO
.*                                 THE NUMBER OF BITS IN THE ITEM
.*                                 DEFINITION (VIA MACRO 'DSGEN').
.*                            A LIMIT OF 15 BITS IS IMPOSED FOR THE
.*                                 TOTAL NUMBER OF BITS TO PRINT.
         GBLA  &INITIAL
         GBLB  &DIAGTST,&DIAGSET,&DIAGLIN
         GBLC &ITEM(3000)
         GBLA &ITEMNBR,&BITS(3000),&SHIFT(3000),&NRENTS
         GBLC  &DSECT
         LCLB  &B,&SUB
         LCLA  &IBITS,&NDX,&ISHIFT,&K
         LCLA  &TEMP,&T,&OP
         LCLC  &S
         ACTR  500000
         AIF   (&DIAGTST EQ 0).NOMSG
         AIF   (&INITIAL EQ 0).NOMSG
         AIF   (&DIAGLIN EQ 1).NOMSG
         MNOTE '**NO LINE ASSOCIATED WITH THIS DATA**'
*****THE FOLLOWING GENERATED FOR TEST PURPOSES*****
*        LINE
         LINE
.NOMSG   ANOP
         AIF   (K'&SYSLIST(1) EQ K'&SYSLIST(1,1)).LOOP
&SUB     SETB  1
.LOOP    ANOP
&OP      SETA  &OP+1
.LOOP1   ANOP
&NDX     SETA  &NDX+1
         AIF   ('&ITEM(&NDX)' EQ '&SYSLIST(&OP,1)').FOUND
         AIF   (&NDX LT &ITEMNBR).LOOP1
         MNOTE '**LOG ITEM NOT DEFINED**'
         MEXIT
.FOUND   ANOP
&ISHIFT  SETA  &SHIFT(&NDX)
&IBITS   SETA  &BITS(&NDX)
         AIF   (&SUB EQ 1).SUB00
         AIF   ('&SYSLIST(3)' EQ '').SETT
&IBITS   SETA  &SYSLIST(3)
         AGO   .SETT
.SUB00   AIF   ('&SYSLIST(&OP,3)' EQ '').SETT
&IBITS   SETA  &SYSLIST(&OP,3)
.SETT    ANOP
&T       SETA  &IBITS-1
&B       SETB  0
         AIF   (&IBITS GT 0 AND &IBITS LT 16).SUB0
         MNOTE '**NO. OF BITS OUTSIDE RANGE OF 1-15**'
         MEXIT
.SUB0    AIF   (&SUB EQ 1).SUBA
         AIF   ('&SYSLIST(2)' EQ '').BACKUP
&K       SETA  K'&SYSLIST(2)
&B       SETB  ('&SYSLIST(2)'(1,1) EQ 'B')
&S       SETC  '&SYSLIST(2)'(&B+1,&K-&B)
         AGO   .SUBB
.SUBA    ANOP
         AIF   ('&SYSLIST(&OP,2)' EQ '').BACKUP
&K       SETA  K'&SYSLIST(&OP,2)
&B       SETB  ('&SYSLIST(&OP,2)'(1,1) EQ 'B')
&S       SETC  '&SYSLIST(&OP,2)'(&B+1,&K-&B)
.SUBB    ANOP
&T       SETA  &S
.BACKUP  ANOP
&NRENTS  SETA  &NRENTS+1
&TEMP    SETA  &ISHIFT
         AIF   (&IBITS NE 1 OR &B NE 0).BIN2
         DC    AL.12(&SYSLIST(&OP,1)-&DSECT),XL.4'&TEMP'
         AGO   .OUT
.BIN2    AIF   (&SUB EQ 1).BIN2A
         AIF   ('&SYSLIST(2)' NE '').BIN3
         AGO   .BIN2B
.BIN2A   AIF   ('&SYSLIST(&OP,2)' NE '').BIN3
.BIN2B   ANOP
&B       SETB  1
.BIN3    ANOP
         DC    AL.12(&SYSLIST(&OP,1)-&DSECT),XL.4'C'
         DC    BL.1'&B',AL.7(&T),AL.4(&IBITS),FL.4'&ISHIFT'
.OUT     ANOP
&NDX     SETA  0
         AIF   (&SUB EQ 0).OUTA
         AIF   (&OP LT N'&SYSLIST).LOOP
.OUTA    ANOP
         MEND
         MACRO
         HEX
.*                            THIS MACRO FACILITATES GENERATION OF THE
.*                                 TABLE ENTRIES SPECIFYING HEX TYPE
.*                                 CONVERSIONS.
.*                            &SYSLIST(&OP,1) - NAME OF DATA ITEM TO BE
.*                                 CONVERTED
.*                            &SYSLIST(&OP,2) - # OF SPACES TO SKIP ON
.*                                 MULTIPLE PRINT OR NBR OF SPACES TO
.*                                 BACK UP FROM COLUMN FOR START OF
.*                                 PRINTING. THE LETTER B PRECEEDS THE
.*                                 NUMBER (B8) IF THE LATTER OPTION IS
.*                                 DESIRED. OMISSION OF THIS OPERAND
.*                                 FORCES OPTION 2 WITH BACKUP SPACING
.*                                 EQUAL TO THE NUMBER OF BYTES SPECI-
.*                                 FIED BY THE NEXT OPERAND (TWICE THIS
.*                                 NUMBER IF SUFFIX IS EXPLICITLY OR
.*                                 IMPLICITLY B).
.*                            &SYSLIST(&OP,3) - NUMBER OF BYTES TO
.*                                 PROCESS. THIS NUMBER IS SUFFIXED
.*                                 WITH AN L,R, OR B TO STIPULATE
.*                                 PRINTING OF THE LEFT HALF, RIGHT
.*                                 HALF, OR BOTH HALVES OF THE BYTE
.*                                 RESPECTIVELY. OMISSION OF THIS
.*                                 OPERAND DEFAULTS TO B WITH THE NUM-
.*                                 BER OF BYTES EQUAL TO THE ITEM LNGTH
.*                            A NEW ENTRY IS GENERATED ONLY WHEN NECES-
.*                                 SARY. THIS MACRO MUST BE THE FIRST
.*                                 MACRO INSTRUCTION ISSUED FOR THE
.*                                 SUBJECT LINE(S).
         GBLC &ITEM(3000),&DSECT
         GBLA &ITEMNBR,&BITS(3000),&SHIFT(3000),&NRENTS
         LCLB  &B,&SUB
         LCLA  &IBITS,&NDX,&ISHIFT,&K,&T,&CODE,&BYTESP,&OP
         LCLC  &S,&LETTER
         ACTR  500000
         AIF   (K'&SYSLIST(1) EQ K'&SYSLIST(1,1)).LOOP
&SUB     SETB  1
.LOOP    ANOP
&OP      SETA  &OP+1
.LOOP1   ANOP
&NDX     SETA  &NDX+1
         AIF   ('&ITEM(&NDX)' EQ '&SYSLIST(&OP,1)').FOUND
         AIF   (&NDX LT &ITEMNBR).LOOP1
         MNOTE *,'LOG ITEM NOT DEFINED'
         MEXIT
.FOUND   ANOP
&ISHIFT  SETA  &SHIFT(&NDX)
&IBITS   SETA  &BITS(&NDX)
         AIF   (&ISHIFT EQ 0 OR &ISHIFT EQ 4).ALIGN
.ERR     MNOTE *,'DATA NOT ALLIGNED ON HEX OR BYTE BOUNDARY'
         MEXIT
.ALIGN   ANOP
&CODE    SETA  1
         AIF   (&SUB EQ 1).SUBA
&K       SETA  K'&SYSLIST(3)
         AGO   .SUBB
.SUBA    ANOP
&K       SETA  K'&SYSLIST(&OP,3)
.SUBB    ANOP
         AIF   (&IBITS-(&IBITS/4)*4 EQ 0).OK
         MNOTE *,'BIT LENGTH SPECIFICATION INCONSISTENT WITH CONTROL'
         MEXIT
.OK      AIF   (&SUB EQ 1).SUBC
         AIF   ('&SYSLIST(3)' EQ '').USEDEFN
&LETTER  SETC  '&SYSLIST(3)'(&K,1)
&S       SETC  '&SYSLIST(3)'(1,&K-1)
         AGO   .SUBD
.SUBC    ANOP
         AIF   ('&SYSLIST(&OP,3)' EQ '').USEDEFN
&LETTER  SETC  '&SYSLIST(&OP,3)'(&K,1)
&S       SETC  '&SYSLIST(&OP,3)'(1,&K-1)
.SUBD    ANOP
&BYTESP  SETA  &S
         AIF   ('&LETTER' EQ 'B').BOTH
         AIF   ('&LETTER' EQ 'L').LEFT
&CODE    SETA  2
         AGO   .L
.LEFT    ANOP
&CODE    SETA  1
         AGO   .L
.USEDEFN ANOP
&BYTESP  SETA  &IBITS/8
.BOTH    AIF   (&ISHIFT NE 0).ERR
&CODE    SETA  3
&T       SETA  &BYTESP*2-1
&S       SETC  '&T'
.OK2     AIF   (&ISHIFT EQ 0).L
&CODE    SETA  2
.L       ANOP
&B       SETB  1
         AIF   (&SUB EQ 1).SUBE
         AIF   ('&SYSLIST(2)' EQ '').BACKUP
&K       SETA  K'&SYSLIST(2)
&B       SETB  ('&SYSLIST(2)'(1,1) EQ 'B')
&S       SETC  '&SYSLIST(2)'(&B+1,&K-&B)
         AGO   .SUBF
.SUBE    ANOP
         AIF   ('&SYSLIST(&OP,2)' EQ '').BACKUP
&K       SETA  K'&SYSLIST(&OP,2)
&B       SETB  ('&SYSLIST(&OP,2)'(1,1) EQ 'B')
&S       SETC  '&SYSLIST(&OP,2)'(&B+1,&K-&B)
.SUBF    ANOP
.BACKUP  ANOP
&NRENTS  SETA  &NRENTS+1
         AIF   (&SUB EQ 1).SUBG
         DC    AL.12(&SYSLIST(1)-&DSECT),XL.4'A'
         AGO   .SUBH
.SUBG    ANOP
         DC    AL.12(&SYSLIST(&OP,1)-&DSECT),XL.4'A'
.SUBH    ANOP
         DC    BL.1'&B',FL.7'&S',AL.4(&BYTESP),FL.4'&CODE'
.OUT     ANOP
&NDX     SETA  0
         AIF   (&SUB EQ 0).OUTA
         AIF   (&OP LT N'&SYSLIST).LOOP
.OUTA    ANOP
         MEND
         GBLC  &DSECT,&CSECT
         GBLB  &DIAGTST,&DIAGSET,&DIAGLIN
&DIAGTST SETB  1
IFCEM155 CSECT
&CSECT   SETC  'IFCEM155'
&DSECT   SETC  'DSECT155'
DSECT155 DSECT
         DSGENFET
IFCEM155 CSECT
         USING     *,9
ENTRYPTR DC    A(STARTER)
TABLNAME  DC  CL8'IFCEM155'                                      YM5999
REG9     DC    F'0'
LP       DC    F'0'
SKIPPER  BR        14
         DC    H'13'
UP13     AH    R3,*-2
         BR    R14
         DC    H'25'
BCK25    SH    R3,*-2
         BR    R14
         DC    H'78'
BCK78    SH    R3,*-2
         BR    R14
         DC    H'17'
BCK17    SH    R3,*-2
         BR    R14
         DC    H'117'             AMOUNT TO
BCK117   SH    R3,*-2             DECREMENT COUNT IN PRINT BUFFER
         BR    R14                RETURN
         DC    H'53'
BCK53    SH    R3,*-2
         BR    14
         DC    H'36'
BCK36    SH    R3,*-2
         BR    14
         DC    H'48'
BCK48    SH    R3,*-2
         BR    14
         USING DSECT155,2
***********************************************************************
P8CON    STM   R5,R8,XSAVE              SAVE REGS
         CLI   21(R2),X'58'             Q/ IS THIS A 158
         BNE   RETURN                   EXIT
         LA    R5,L115                  AMOUNT TO BACKSPACE
         SR    R3,R5                    BACKSPACE
         MVC   L0(L16,R3),P8LABEL       MOVE IN LABEL
RETURN   LM    R5,R8,XSAVE              RESTORE REGS
         BR    R14                      EXIT
P8LABEL  DC    C'PLUS 8 CONDITION'
***********************************************************************
APCALLR  TM    16(R2),X'04'             Q/ IS THIS ATTACHED PROCESSOR
         BNOR  R14                      NO
         CLI   21(R2),X'58'             Q/ IS THIS A 158
         BNER  R14                      NO, EXIT
         ST    R5,XSAVE                 SAVE REG
         L     R5,APNXTMOD              ADDR OF BRANCH TO IFCEG155
         ST    R5,REG9                  UPDATE LINE PTR
         L     R5,XSAVE                 RESTORE REG
         BR    R14                      EXIT
APNXTMOD DC    A(APMODBR-4)
***********************************************************************
NOPRINT  SR    R15,R15                  DO NOT PRINT THIS LINE
         BR    R14                      EXIT
***********************************************************************
WORKSAVE ST    5,XSAVE
         L     5,LOGWORK1
         ST    5,LOGSAVE
         L     5,XSAVE
         BR    14
***********************************************************************
CHK158   CLI   21(R2),X'58'             Q/ IS THIS A 158
         BNER  R14                      NO, EXIT
CHK1581  SR    R15,R15                  DO NOT PRINT THIS LINE
         BR    R14                      EXIT
***********************************************************************
N1583AP  CLI   21(R2),X'58'             Q/ IS THIS A 158
         BNER  R14                      NO, EXIT
         TM    16(R2),X'03'             Q/ IS THIS 158-3
         BO    Y1583                    YES
         TM    16(R2),X'04'             Q/ IS THIS AP
         BNOR  R14                      NOT 158-3 OR AP SO EXIT
Y1583    SR    R15,R15                  DO NOT PRINT THIS LINE SINCE
         BR    R14                      THIS IS 158-3 OR AP
***********************************************************************
DO1583AP CLI   21(R2),X'58'             Q/ IS THIS A 158
         BNER  R14                      NO, EXIT
         TM    16(R2),X'03'             Q/ IS THIS 158-3
         BOR   R14                      YES
         TM    16(R2),X'04'             Q/ IS THIS AP
         BOR   R14                      YES
         SR    R15,R15                  NOT AP OR 158-3 SO DO NOT PRINT
         BR    R14                      THIS LINE
***********************************************************************
WORKREST ST    5,XSAVE
         L     5,LOGSAVE
         ST    5,LOGWORK1
         L     5,XSAVE
         BR    14
NOT1583   TM   16(R2),X'03'                                    @Z02774
          BCR  14,R14                                          @Z02774
          SR   R15,R15                                         @Z02774
          BR   R14                                             @Z02774
DO1583    TM   16(R2),X'03'                                    @Z02774
          BOR  R14                                             @Z02774
          SR   R15,R15                                         @Z02774
          BR   R14                                             @Z02774
BINDER   STM   R14,R12,L12(R13)   SAVE REGS
         SR    R6,R6              CLEAR REG
         SR    R4,R4              CLEAR REG
         SR    R5,R5              CLEAR REG
         IC    R5,4(R15)          PUT HEX DIGIT CONTAINING DATA LENGTH
         SLDL  R4,28              DECODED INTO REG 4
AGAIN    LH    R5,4(R15)          ADDRESS OF BYTE TO BE PROCESSED
         SLL   R5,20              (CLEAR OFF
         SRL   R5,20               LENGTH SPECIFIER)
         AR    R5,R2               TO REG 5
         IC    R7,0(R5)           BYTE TO BE PROCESSED IN REG 7
         IC    R11,6(R15)         NUM. UNWANTED BITS TO REG 11
         IC    R10,7(R15)         ITEM LENGTH IN BITS TO REG 10
         SLL   R7,24(R11)         LEFT-JUSTIFY
         SLDL  R6,0(R10)          ADD TO BITS IN REG 6
         LA    R15,4(R15)         UP POINTER TO NEXT SET OF DATA
         BCT   R4,AGAIN           BACK IF MORE DATA TO BE PROCESSED
         ST    R6,LOGWORK1        PUT IN WORK AREA
         LM    R14,R12,L12(R13)   RESTORE REGS
         BR    R14                RETURN
PARPUT   STM   R14,R12,12(R13)    SAVE REGS
         SR    R8,R8              CLEAR REG
         SR    R11,R11            CLEAR REG
         IC    R8,4(R15)          REG 8-# ENTRIES TO BE PROCESSED
         SR    R10,R10            CLEAR REG 10
         LR    R3,R0              REG 3 POINTS TO PRINTBUF POS. 0
RETURN1  LR    R4,R3
         IC    R10,5(R15)
         AR    R4,R10             REG 4 HAS LOCATION OF PARITY BIT
         IC    R10,7(R15)         REG 10-# OF TIMES TO REPEAT PROCESS
RETURN2  MVC   KEEPER(L1),0(R4)   PARITY BYTE IN KEEPER
         IC    R11,6(R15)         REG 11-# POSITIONS TO BE PROCESSED
         NI    KEEPER,X'0F'
         XI    KEEPER,X'01'       NOT OF PARITY BIT IN KEEPER
         LA    R5,2(R4)           REG 5-POINTER TO BYTE FOR PROCESSING
         SR    R12,R12            CLEAR REG 12
         IC    R12,KEEPER         REG 12-KEEPS PARITY COUNT
RETURN3  MVC   KEEPER(L1),0(R5)   EBCDIC BYTE TO KEEPER
         CLI   KEEPER,X'C6'       SEE IF DIGIT (0-9)
         BH    DIGIT
         SR    R2,R2              CLEAR REG 2
         IC    R2,KEEPER          ASSUME A-F
         SH    R2,ABCDEF          CONVERT TO HEX BY SUBTRACTING HEX B7
         STC   R2,KEEPER          MAKE BELIEVE NOTHING HAPPENED
DIGIT    IC    R7,KEEPER          READY FOR PARITY ROUTINE
         SLL   R7,28              LEFT-JUSTIFY
RETURN4  SR    R6,R6              CLEAR REG 6
         SLDL  R6,1
         XR    R12,R6             ADD PARITY BIT
         NR    R7,R7              SET CONDITION CODE
         BC    7,RETURN4          BACK IF MORE BITS TO BE TESTED
         LA    R5,1(R5)           BUMP TO NEXT PRINT POSITION
         BCT   R11,RETURN3     BACK IF MORE POSITIONS TO BE CHECKED
         NR    R12,R12            SET CONDITION CODE
         BZ    NOSPLAT         SKIP * MAKER IF GOOD PARITY
         MVI   1(R4),C'*'         SPLAT FOR BAD PARITY
NOSPLAT  LA    R4,2(R5)           BUMP PARITY POS. COUNTER
         BCT   R10,RETURN2        BACK IF MORE PARITY CHECKS
         LA    R15,3(R15)         BUMP CONTROL ENTRY POINTER
         BCT   R8,RETURN1         BACK IF MORE COLUMN ENTRIES
         LM    R14,R12,12(R13)    RESTORE REGS
         BR    R14                RETURN
ABCDEF   DC    XL2'B7'
KEEPER   DS    X
TSTRB    ST    5,XSAVE
         TM    0(4),X'02'
         BC    7,TSTEDB
         L     R5,BLKMPXBA        ADDRESS OFBRANCH TO BLK MPX TBL
         ST    5,REG9
TSTEDB   L     5,XSAVE
         BR    14
BLKMPXBA DC    A(BLKMPXB-4)
***********************************************************************
SCUSKIP2 TM    16(R2),X'04'             Q/ IS THIS ATTACHED PROCESSOR
         BOR   R14                      YES, CONTINUE PROCESSING
         MVC   REG9(8),SCUNAPAD         UPDATE LINE/LABEL PTR
         SR    R15,R15                  DO NOT PRINT THIS LINE
         BR    R14                      EXIT
SCUNAPAD DC    A(SCUNAPLN-4)
         DC    A(SCUNAPLB)
***********************************************************************
APSKIP1  TM    16(R2),X'04'             Q/ IS THIS ATTACHED PROCESSOR
         BO    APSKIP11                 YES
         BR    R14                      EXIT
APSKIP11 CLI   21(R2),X'58'             Q/ IS THIS A 158
         BE    APSKIP12                 YES
         BR    R14                      EXIT
APSKIP12 MVC   REG9(8),APSKIPAD         UPDATE LINE/LABEL PTRS
         SR    R15,R15                  DO NOT PRINT THIS LINE
         BR    R14                      EXIT
APSKIPAD DC    A(APSKPLNE-4)
         DC    A(APSKPLAB)
***********************************************************************
SKIPAP   TM    16(R2),X'04'             Q/ IS THIS ATTACHED PROCESSOR
         BO    SKIPAP1                  YES
         BR    R14                      EXIT
SKIPAP1  CLI   21(R2),X'58'             Q/ IS THIS A 158
         BNER  R14                      NO, EXIT
         MVC   REG9(8),SCUSKPAD         UPDATE LINE/LABEL PTRS
         SR    R15,R15                  DO NOT PRINT THIS LINE
         BR    R14                      EXIT
SCUSKPAD DC    A(SCUAPLNE-4)
         DC    A(SCUAPLAB)
***********************************************************************
APCHKNP  TM    16(R2),X'04'             Q/ IS THIS ATTACHED PROCESSOR
         BO    APYES                    YES
         BR    R14                      EXIT
APYES    CLI   21(R2),X'58'             Q/ IS THIS A 158
         BNER  R14                      EXIT
         SR    R15,R15                  DO NOT PRINT THIS LINE
         BR    R14                      EXIT
***********************************************************************
APCHKP   TM    16(R2),X'04'             Q/ IS THIS ATTACHED PROCESSOR
         BO    APYES1                   YES
APNO     SR    R15,R15                  DO NOT PRINT THIS LINE
         BR    R14                      EXIT
APYES1   CLI   21(R2),X'58'             Q/ IS THIS A 158
         BER   R14                      EXIT, AND PRINT THIS LINE
         B     APNO                     EXIT WITHOUT PRINTING
***********************************************************************
SRADADR  BIND  (SRADAD0,0,1),(SRADAD1,0,7)
IFTCHS   BIND  (IFTHRS,0,8)
AIRO     BIND      (AIROFET,0,8)
MSI      BIND  (MSIREAD,0,8)
CP2B     BIND  (CP2HC,6,2),(CP2R2,4,1),(CP2R3,0,13)
CP2A     BIND  (CP2NC,1,16)
UPINDX   BIND  (UINDXA,0,4),(UINDXB,3,5),(UINDX19,6,1),(UINDXV1,0,2)
LOWINDX  BIND  (LINDXA,0,4),(LINDXB,3,5),(LINDX19,2,1),(LINDXV1,0,2)
P197799  CKPARITY  (19,2,4),(77,2,1),(99,2,4)
P377599  CKPARITY  (37,2,1),(75,4,1),(99,2,4)
P7699    CKPARITY  (76,4,1),(99,2,4)
***********************************************************************
P76      CKPARITY (76,4,1)
***********************************************************************
P9924    CKPARITY  (99,2,4)
P1965117 CKPARITY  (19,2,4),(65,2,3),(117,2,1)
***********************************************************************
P65117   CKPARITY (65,2,3),(117,2,1)
***********************************************************************
P19117   CKPARITY  (19,2,4),(117,2,1)
P2571117 CKPARITY  (25,2,3),(71,8,1),(117,2,1)
P2523    CKPARITY  (25,2,3)
P2742    CKPARITY  (27,4,2)
P3541    CKPARITY (35,4,1),(107,4,2)
P11721   CKPARITY  (117,2,1)
P10742   CKPARITY  (107,4,2)
P2799    CKPARITY  (27,4,2),(99,2,4)
P11181   CKPARITY  (111,8,1)
P1145    CKPARITY  (114,5,1)
P10523   CKPARITY  (105,2,3)
P107     CKPARITY  (107,4,2)
P7181    CKPARITY  (71,8,1)
P117     CKPARITY (117,2,1)
P91       CKPARITY (91,8,1)
P71      CKPARITY (71,8,1)                                     @YA02788
R0       EQU   0
R1       EQU   1
R2       EQU   2
R3       EQU   3
R4       EQU   4
R5       EQU   5
R6       EQU   6
R7       EQU   7
R8       EQU   8
R9       EQU   9
R10      EQU   10
R11      EQU   11
R12      EQU   12
R13      EQU   13
R14      EQU   14
R15      EQU   15
HEX00    EQU   X'00'
HEX08    EQU   X'08'
HEX40    EQU   X'40'
HEX80    EQU   X'80'
HEX48    EQU   X'48'
HEXBF    EQU   X'BF'
L0       EQU   0
X20       EQU  X'20'                                           @Z02774
L1       EQU   1
L2       EQU   2
L3       EQU   3
L4       EQU   4
L5       EQU   5
L6       EQU   6
L7       EQU   7
L8       EQU   8
L12      EQU   12
L16      EQU   16
L19      EQU   19
L60      EQU   60
L115     EQU   115
LOGSAVE  DS    F
XSAVE    DC    4F'0'                                           @XA21544
         LTORG
STARTER  DS    0F
         DC    XL4'00010001'
         DC    XL4'00010001'
         DC    A(LABAREA)
         DC    H'0'
         LINE  ,,SKIP=1
         LABEL ''
         LINE  ,(24,53)
         ROUTINE XDUM2,APSKIP1
         LABEL '+-------------------------  COMMON CHANNEL CKS  -----',*
               '--------------------+'
         LINE      (35,40),(4,40),SKIP=1
         BIN       C35SCE
         BIN       ROSINTE
         BIN       STBBE
         LABEL     'STAT CARD CH 3-5 CK','CS INTER CK',                X
               'STAT BB DECODE CK'
         LINE
         BIN       C35ITAE
         BIN       ROSINPE
         BIN       STDCDE
         LABEL     'INTAG A CH 3-5 CK','CS INPUT CK','STAT DECODE CK'
         LINE
         BIN       C35ITBE
         BIN       LSTOCHE
         BIN       YICDCDE
         LABEL     'INTAG B CH 3-5 CK','LS TO CH BUS CK',              X
               'YIC DECODE CK'
         LINE
         BIN       UPDE
         BIN       HDWCHE
         BIN       BUSPTYE
         LABEL     'U-PGM DETECTED CK','HDW CHAN NO CK','BUS PTY CK'
         LINE
         BIN       EMITINE
         BIN       HCIE
         BIN       RLCTRE
         LABEL     'EMIT FLD INPUT CK','HDW CTRL INPUT CK',            X
               'RETRY L CNTR CK'
         LINE
         BIN       EMITFLE
         BIN       HRRE
         BIN       LSUCWAE
         LABEL     'EMIT FLD LATE CK','HDW READ RTN CK',               X
               'I/O LS UCW ADR CK'
         LINE
         BIN       PSWCKE
         BIN       HLCE
         BIN       BIRESPE
         LABEL     'PSW CK','HDW LSAR CK','BREAK IN RESP CK'
         LINE
         BIN       L2CNTRE
         BIN       UPLSARE
         BIN       SELCNE
         LABEL     'L2 COUNTER CK','U-PGM LSAR CK','SEL CHAN NO CK'
         LINE
         BIN       CSELCPE
         BIN       WRLSUPE
         BIN       MURE
         LABEL     'CHAN SELECT COMP ERROR','WR LS U-PGM CK',          X
               'MULTIPLE USE CSAR CK'
         LINE
         BIN       C02ITAE
         BIN       IN1SELE
         BIN       HCIDE
         LABEL     'INTAG A CH 0-2 CK','INP 1 WD SEL CK','HDW CH ID CK'
         LINE
         BIN       C02ITBE
         BIN       IN2ROSE
         BIN       UPCIDE
         LABEL     'INTAG B CH 0-2 CK','INP 2 WD CS CK',               X
               'U-PGM CH ID CK'
         LINE
         BIN       C02STCE
         BIN       IN3SELE
         BIN       HCLE
         LABEL     'STAT CARD CH 0-2 CK','INP 3 CH SEL CK',            X
               'HDW CH ID LOG'
         LINE
         BIN       SBPE
         BIN       LS01INE
         BIN       LSRLOGE
         LABEL     'STAT BROR PTY CK','LS 0+1 INP CK','LS RTN LOG CK'
         LINE
         BIN       OUTTAGE
         BIN       LS23INE
         BIN       C01CXE
         LABEL     'OUT TAG CK','LS 2+3 INP CK','CARD XFER CH 0-1 CK'
         LINE      ,,SKIP=1
         BIN       GRPSELE
         BIN       INTCRDE
         BIN       C23CXE
         LABEL     'GROUP SELECT CK','INTER CARD CK',                  X
               'CARD XFER CH 2-3 CK'
         LINE      (75,40),(4,40),SKIP=1
         BIN       LOGYINE
         BIN       C45CXE
         LABEL     ' ','LOG Y INPUT CK','CARD XFER CH 4-5 CK'
         LINE
         BIN       LOGRDRE
         BIN       MPCIDE
         LABEL '','LOG CSAR CK','MP CH ID CK'
         LINE  (18,),(4,)
         HEX   (CONSDR,4,4B)                                        0.2
         LABEL 'CONSOLE REG'                                        0.2
         LINE  ,,SKIP=E
APSKPLAB LABEL ''
APSKPLNE LINE  ,(41),SKIP=1
         LABEL     '//////////////////////////////////////'
         LINE
         LABEL     '/                                    /'
         LINE
         LABEL     '/   ///CPU DATA FLOW + CONTROLS///   /'
         LINE
         LABEL     '/                                    /'
         LINE      ,,SKIP=3
         LABEL     '//////////////////////////////////////'
         LINE      ,(16,41),SKIP=1
         LABEL     '---ALU---','---MOVER---','---DATA REGS---'
         LINE      (21,16),(5,40)
         HEX       XBUS0,4,4B
         BIN   XBUS0P,B18
         BIN       XBUS1P,B28
         BIN       XBUS2P,B38
         BIN       XBUS3P,B48
         HEX       AREG0,4,4B
         BIN       AREG0P,B18
         BIN       AREG1P,B28
         BIN       AREG2P,B38
         BIN       AREG3P,B48
         ROUTINE   DUMMY001,BCK117
         HEX       UBUS,,1B
         BIN       UBUSP,B19
         ROUTINE   DUMMY001,P197799
         LABEL     'X-BUS','U-BUS','A-REG'
         LINE
         HEX       YBUS0,4,4B
         BIN       YBUS0P,B18
         BIN       YBUS1P,B28
         BIN       YBUS2P,B38
         BIN       YBUS3P,B48
         HEX       BREG0,4,4B
         BIN       BREG0P,B18
         BIN       BREG1P,B28
         BIN       BREG2P,B38
         BIN       BREG3P,B48
         ROUTINE   DUMMY001,BCK117
         HEX       VBUS,,1B
         BIN       VBUSP,B19
         ROUTINE   DUMMY001,P197799
         LABEL     'Y-BUS','V-BUS','B-REG'
         LINE
         HEX       ZBUS0,4,4B
         BIN       ZBUS0P,B18
         BIN       ZBUS1P,B28
         BIN       ZBUS2P,B38
       BIN     ZBUS3P,B48
         HEX       CREG0,4,4B
         BIN       CREG0P,B18
         BIN       CREG1P,B28
         BIN       CREG2P,B38
         BIN       CREG3P,B48
         ROUTINE   DUMMY001,BCK117
         HEX       WBUS,,1B
         BIN       WBUSP,B19
         ROUTINE   DUMMY001,P197799
         LABEL     'Z-BUS','W-BUS','C-REG'
         LINE      (39,31)
         HEX       FILREG,1,1B
         BIN       FILREGP,B33
         HEX       DREG0,4,4B
         BIN       DREG0P,B33
         BIN       DREG1P,B58
         BIN       DREG2P,B83
         BIN       DREG3P,B108
         ROUTINE   DUMMY001,BCK117
         BIN       ALUFNR,B93
         BIN       ALUFNRP,B126
         ROUTINE   DUMMY001,P377599
         LABEL     'F+G REG','FUNCTION REG','D-REG'
         LINE      (41,20)
         BIN       QBIT,B1
         ROUTINE   DUMMY001,SKIPPER
         BIN       ABCTR,B3
         HEX       CPULS0,4,4B
         BIN       ABCTRP,B45
         BIN       CPULS0P,B42
         BIN       CPULS1P,B56
         BIN       CPULS2P,B70
         BIN       CPULS3P,B84
         ROUTINE   DUMMY001,P7699
         ROUTINE XDUM2,APCHKNP
         LABEL 'Q-REG','AB COUNTER','LS(CPU/UCW)'
         LINE  ,
         BIN   QBIT,B1
         ROUTINE XDUM2,SKIPPER
         BIN   ABCTR,B3
         HEX   CPULS0,4,4B
         BIN   ABCTRP,B45
         BIN   CPULS0P,B42
         BIN   CPULS1P,B56
         BIN   CPULS2P,B70
         BIN   CPULS3P,B84
         ROUTINE XDUM2,P7699
         ROUTINE XDUM2,APCHKP
         LABEL 'Q-REG','AB COUNTER','CPU LS'
         LINE
         BIN       CCST,B1
         ROUTINE   DUMMY001,SKIPPER
         BIN       CBCTR,B3
         HEX       IOLSD0,4,4B
         BIN       CBCTRP,B45
         BIN       IOLSD0P,B42
         BIN       IOLSD1P,B56
         BIN       IOLSD2P,B70
         BIN       IOLSD3P,B84
         ROUTINE   DUMMY001,P7699
         ROUTINE XDUM2,APCHKNP
         LABEL 'CARRY CONTROL','CB COUNTER','LS(I/O BUFR)'
         LINE  ,
         BIN   CCST,B1
         ROUTINE XDUM2,SKIPPER
         BIN   CBCTR,B3
         ROUTINE XDUM2,SKIPPER
         BIN   CBCTRP,B45
         ROUTINE XDUM2,P76
         ROUTINE XDUM2,APCHKP
         LABEL 'CARRY CONTROL','CB COUNTER'
         LINE      (41,20),(5,80)
         BIN       CSA,B1
         ROUTINE   DUMMY001,SKIPPER
         ROUTINE   DUMMY001,SKIPPER
         HEX       EXTSW0,4,4B
         BIN       EXTSW0P,B22
         BIN       EXTSW1P,B36
         BIN       EXTSW2P,B50
         BIN       EXTSW3P,B64
         ROUTINE   DUMMY001,P9924
         LABEL     'CARRY STAT A','E-SWITCH'
         LINE      ,,SKIP=3
         BIN       CSB,B1
         LABEL     'CARRY STAT B'
         LINE      ,(15,39),SKIP=1
         LABEL     '---STORAGE---','  ---I-FETCH---',                  X
               '---CONTROL REGS---'
         LINE      (21,23),(5,40),SKIP=1
         HEX       IOSAR0,4,4B
         BIN       IOSAR0P,B25
         HEX       IAR1,4,3B
         BIN       IOSAR1P,B65
         BIN       IOSAR2P,B82
         BIN       IOSAR3P,B99
         ROUTINE   DUMMY001,BCK117
         BIN       IAR1P
         BIN       IAR2P,B17
         BIN       IAR3P,B34
         BIN       PSWSMP,B17
         HEX       PSWSM,B38,1B
         ROUTINE   DUMMY001,P1965117
         ROUTINE XDUM2,APCHKNP
         LABEL 'I/O KEY+SAR','INST COUNTER','PSW-SYS MASK'
         LINE  (67,23),(5,40),SKIP=1
         HEX   IAR1,4,3B
         ROUTINE XDUM2,BCK48
         BIN   IAR1P
         BIN   IAR2P,B17
         BIN   IAR3P,B34
         BIN   PSWSMP,B17
         HEX   PSWSM,B38,1B
         ROUTINE DUMMY001,P65117
         ROUTINE XDUM2,APCHKP
         LABEL ' ','INST COUNTER','PSW-SYS MASK'
         LINE      (21,16)
         HEX       CPUSR0,4,4B
         BIN       CPUSR0P,B18
         BIN       CPUSR1P,B28
         BIN       CPUSR2P,B38
         BIN       CPUSR3P,B48
         BIN       IB0FULL,B23
         BIN       PSWKEYP
         HEX       PSWKEY,B14,1B
         ROUTINE   DUMMY001,P19117
         LABEL     'CPU KEY+SAR','BFR FULL TRIGS','   -KEY/EMWP'
         LINE      (27,13)
         HEX       BCUS1,4,3B
         BIN       BCUS1P,B15
         BIN       BCUS2P,B22
         BIN       BCUS3P,B29
         ROUTINE   DUMMY001,IFTCHS
         BIN       LOGWORK4,B19
         BIN       IFTCHSP,B34
         BIN       PSWESMP,B1
         HEX       PSWESM,B12,1B
         ROUTINE   DUMMY001,P2571117
         LABEL     'MS SAR','STATUS---','   -EXT SYS MASK'
         LINE      (27,20)
         HEX       ASARB1,4,3B
         BIN       ASARB1P,B22
         BIN       ASARB2P,B36
         BIN       ASARB3P,B50
         BIN       IFTHRS,B27
         BIN       CC,B8
         ROUTINE   DUMMY001,P2523
         LABEL     '                                    ','  -THRESHOLDX
               ','   -COND CODE'
         LINE      (40,20)
          BIN   HOLDOFF                                        @Z02774
          ROUTINE DUMMY001,SKIPPER                             @Z02774
          BIN   IFRES                                          @Z02774
          ROUTINE DUMMY001,SKIPPER                             @Z02774
          HEX   L12CTR,,1B                                     @Z02774
          BIN   L12CTRP,B23                                    @Z02774
          ROUTINE DUMMY001,P11721                              @Z02774
          LABEL 'HOLD OFF','  -RESET BFR','L1L2 COUNTER'       @Z02774
         LINE      (80,40),(45,40)
         BIN       IFINV
         BIN       L2SS
         BIN       L1SS,B43
         LABEL     '  -INVALID ADR','L1L2 SIGN STATS'
         LINE
         BIN       IFPRTC
         BIN       ALWTRP
         LABEL     '  -PROTECT VIOL','ALLOW TRAP'
         LINE
         BIN       IFIC
         HEX       R12CTR,,1B
         BIN       R12CTRP,B43
         ROUTINE   DUMMY001,P11721
         LABEL     '  -INCR CARRY','R1R2 COUNTER'
         LINE      (,20),(5,40)
         BIN       IFEXS
         ROUTINE   DUMMY001,SKIPPER
         BIN       GPSTL3
         BIN       GPSTL2P,B25
         BIN       GPSTL1,B51
         BIN       GPSTL1P,B73
         BIN       GPSTL2,B83
         ROUTINE   DUMMY001,P10742
         LABEL     '         ---LOCAL STORAGE---','  -EXECUTE STAT',   X
               'GP STATS'
         LINE      (40,40),(5,40)
         BIN       LSSSTS
         BIN       IFILC
         BIN       S19
         LABEL     'LS SECTOR','  -ILC','STAT 19'
         LINE  (40,20)
         BIN       CPURLAR
         ROUTINE   DUMMY001,SKIPPER
         ROUTINE   DUMMY001,SKIPPER
         ROUTINE   DUMMY001,SKIPPER
         BIN       BS7
         BIN       BS4,B23
         BIN       BS4P,B45
         BIN       BS0,B71
         BIN       BS0P,B93
         ROUTINE DUMMY001,P10742
         LABEL     'CPU READ LSAR','I FETCH EXCEPTION-','BYTE STATS'
         LINE  (40,40)
         BIN       WRCPULS
         BIN       EXTST
         BIN   INBBRR
          BIN   INABRR,B46                                     @Z02774
          BIN   INABRR0,B87                                    @Z02774
          ROUTINE LB32F2,NOT1583                               @Z02774
         LABEL     'WRITE CPU LS BIT','  MASKED EXT STAT',             X
               'IND BR REG'
          LINE    ,                                            @Z02774
          BIN    WRCPULS                                       @Z02774
          BIN    EXTST                                         @Z02774
          BIN    INBBRR                                        @Z02774
          BIN    INABRR,B46                                    @Z02774
          BIN    INABRR0,B87                                   @Z02774
          ROUTINE LB32F2,DO1583                                @Z02774
          LABEL 'WRITE CPU LS BIT','  MASKED EXT STAT','IND BR REG'
         LINE
         BIN       CPUWLAR
         BIN       ADRCPST
         BIN   HYRST
         LABEL     'CPU WRI LSAR','  ADR COMP STAT','LEX MODE'
         LINE
         BIN       IORLAR
         BIN       IC1B29
         BIN   LB2516              NOT SS MODE
         LABEL 'I/O UCW READ LSAR','PLUS 8 CONDITION','NOT SS MODE'
         LINE
         BIN       IOWLAR
         BIN       ICPLUS4
         LABEL 'I/O UCW WRITE LSAR','PLUS 4 CONDITION'
         LINE      ,,SKIP=3
         BIN       WRIOLS
         BIN       ANYEXC
         LABEL 'WRITE I/O LS BIT','ANY EXCEPTION'
         LINE      ,(16,40),SKIP=1
         LABEL     '---RETRY---','---SERAD---','---CONSOLE---'
         LINE      (41,10),(5,40),SKIP=1
         BIN       CP1R2,B1
         BIN       CP1R1P,B16
         BIN       CP1R0,B32
         BIN       CP1R0P,B44
         BIN       SERADM,B1
         BIN       CP1R1,B54
         HEX       CONSR0,4,4B
         BIN       CONSR0P,B12
      BIN       CONSR1P,B16
      BIN       CONSR2P,B20
         BIN       CONSR3P,B24
         ROUTINE   DUMMY001,P2799
         LABEL     'CHECK PT 1 REG','SERAD MODE','CONSOLE REG'
         LINE      (30,10)
         ROUTINE   DUMMY001,CP2B
         BIN   LOGWRK3A
         ROUTINE   DUMMY001,CP2A
         BIN       LOGWRK3A,B31
         BIN       CP2R0P,B43
         BIN       INTDL
         BIN       CP2R1P,B55
         ROUTINE   DUMMY001,SKIPPER
         ROUTINE   DUMMY001,SKIPPER
         BIN       BLKCONS
         ROUTINE   DUMMY001,P2742
         LABEL     'CHECK PT 2 REG','INTERNAL DATA LOAD',              X
               'BLOCK CONSOLE'
         LINE      (40,40)
         BIN       CP2NC
         BIN       WAITFR
         BIN       DIAGCTR
         LABEL     '  -N-TH CHECK','WAIT FOR RESET',                   X
               'DIAGNOSTIC COUNTER'
         LINE
         BIN       CP2SE
         BIN       INPERR
         BIN       CTRERR
         LABEL     '  -SINGLE ECC/IO DBL','INPUT CK',                  X
               'DIAG CYCL CTR CK'
         LINE
         BIN       CP2DE
         BIN       CLKERR
         BIN       INDDISP
         LABEL     '  -DOUBLE ECC','CLOCK CK','INDIRECT DISPLAY'
          LINE    ,                                            @Z02774
          BIN    CP2IE                                         @Z02774
          LABEL  '  -IF EXCEP TAKEN'                           @Z02774
         LINE
         BIN       CP2HC
         BIN       LOGCMPS
         BIN       CONSDR
         ROUTINE XDUM2,APCHKNP
         LABEL '  -TIMER ERR','LOG COMPARE','I/O CONSOLE REG'
         LINE  ,
         BIN   CP2HC
         BIN   LOGCMPS
         ROUTINE XDUM2,APCHKP
         LABEL '  -TIMER ERR','LOG COMPARE'
          LINE    ,                                            @Z02774
          ROUTINE DUMMY001,SKIPPER                             @Z02774
          BIN    ABCOMPS                                       @Z02774
          LABEL  '  ','SERAD CS STOP'                          @Z02774
         LINE  ,                                               @YA02788
         BIN   CP2AC                                           @YA02788
         BIN   SERDIS                                          @YA02788
         LABEL '  -STORAGE HARD ERR','SERAD DISABLE ERROR',            X
               '       ---SIGP CNTLS---'                       @YA02788
         LINE  (40,40)                                         @YA02788
         BIN   CP2R2                                           @YA02788
         ROUTINE DUMMY001,SKIPPER                              @YA02788
         BIN   (LB3740,,8)                                     @YA02788
         LABEL '  -DEGRADE BUFFER',' ','EXT IRPT REG'          @YA02788
         LINE  ,                                               @YA02788
         BIN   CP2R3                                           @YA02788
         ROUTINE DUMMY001,SKIPPER                              @YA02788
         BIN   (LB3750,,8)                                     @YA02788
         ROUTINE XDUM2,APCHKNP
         LABEL '  -TIME OF DAY CK','       ---MP SVP FCNS---',         *
               'MASK REG/E SW INPUT'
         LINE  ,
         BIN   CP2R3
         ROUTINE XDUM2,SKIPPER
         BIN   (LB3750,,8)
         ROUTINE XDUM2,APCHKP
         LABEL '  -TIME OF DAY CK','       ---AP SVP FCNS---',         *
               'MASK REG/E SW INPUT'
         LINE  (80,40),(45,40)                                 @YA02788
         BIN   CONSUM                                          @YA02788
         BIN   (LB3760,,3)                                     @YA02788
         LABEL 'CONSOLE SUMMARY BIT','CNTL GATES'              @YA02788
         LINE  (40,40),(5,40)                                  @YA02788
         BIN   SDC                                             @YA02788
         BIN   STRT                                            @YA02788
         BIN   LB3763                                          @YA02788
         LABEL 'SOURCE DATA CHANGED','START','BUSY'            @YA02788
         LINE  ,                                               @YA02788
         BIN   HARDST                                          @YA02788
         BIN   RSTRT                                           @YA02788
         BIN   LB3764                                          @YA02788
         LABEL 'HARD STOP','RESTART','STATUS IN'               @YA02788
         LINE  ,                                               @YA02788
         BIN   ERRCTR                                          @YA02788
         BIN   MPRSET                                          @YA02788
         BIN   LB3765                                          @YA02788
         ROUTINE XDUM2,APCHKNP
         LABEL 'ERROR COUNTER','MP RESET','FCN REG PTY CK'
         LINE  ,
         BIN   ERRCTR
         BIN   MPRSET
         BIN   LB3765
         ROUTINE XDUM2,APCHKP
         LABEL 'ERROR COUNTER','AP RESET','FCN REG PTY CK'
         LINE  ,                                               @YA02788
         BIN   IGNORE1                                         @YA02788
         ROUTINE DUMMY001,SKIPPER                              @YA02788
         BIN   LB3766                                          @YA02788
         LABEL 'IGNORE 1',' ','Z BUS CK'                       @YA02788
         LINE  ,                                               @YA02788
         BIN   ENDATA                                          @YA02788
         ROUTINE DUMMY001,SKIPPER                              @YA02788
         BIN   LB3767                                          @YA02788
         LABEL 'ENABLE DATA ERROR',' ','MASK REG CK'           @YA02788
         LINE  ,                                               @YA02788
         BIN   DUMMY015                                        @YA02788
         ROUTINE DUMMY001,SKIPPER                              @YA02788
         BIN   (LB3770,,8)                                     @YA02788
         LABEL 'MACH CK PENDING',' ','CMD OUT(LCL,RMT)/FCN REG'
         LINE  ,,SKIP=E
         LABEL     ''
         LINE      ,(41,),SKIP=1
         LABEL     '//////////////////////////////////////'
         LINE
         LABEL     '/                                    /'
         LINE
         LABEL     '/   ///SCU DATA FLOW + CONTROLS///   /'
         LINE
         LABEL     '/                                    /'
         LINE      ,,SKIP=3
         LABEL     '//////////////////////////////////////'
         LINE      ,(12,40),SKIP=1
         LABEL     '---SCU INSTRUCTION---','---EMIT DECODE---',        C
               '---FET CONTROLS---'
         LINE      (40,40),(5,40)
         BIN   LB4550        MS BUSY
         BIN   LB4552        RESET ECC
         BIN   LB4556        MS RD&LOCK
         LABEL 'MS BUSY','0-RESET ECC','MS RD+LOCK'
         LINE
         BIN   LB3540        RD
         BIN   LB3550        IRPT DATA RD/RD ECC
         BIN   LB3570        READ
         LABEL 'RD','1-IRPT DATA READ','MS READ'
         LINE
         BIN   LB3541        WR
         ROUTINE DUMMY001,SKIPPER
         BIN   LB3571        WRITE
         LABEL 'WR','2-SPARE','MS WRITE'
         LINE
         BIN   LB3542        FILL INS BFR
         BIN   LB3552        RD & LOCK
         BIN   LB3572        CANCEL
         ROUTINE XDUM2,APCHKNP
         LABEL 'FILL INST BFR','3-RD + LOCK','FET CANCEL'
         LINE  ,
         BIN   LB3542
         BIN   LB3552
         ROUTINE XDUM2,APCHKP
         LABEL 'FILL INST BFR','3-RD + LOCK'
         LINE
         BIN   LB3543        SP STOR SEL
         BIN   LB3553        FTE
         BIN   LB3573        BUSY
         ROUTINE XDUM2,APCHKNP
         LABEL 'SPMS','4-FTE','FET BUSY'
         LINE  ,
         BIN   LB3543
         BIN   LB3553
         ROUTINE XDUM2,APCHKP
         LABEL 'SPMS','4-FTE'
         LINE
         BIN   LB3544        DIS ECC
         BIN   LB3554        PTLB
         BIN   LB3574        LCL LOCK
         ROUTINE XDUM2,APCHKNP
         LABEL 'DIS ECC','5-PTLB','FET LCL LOCK'
         LINE  ,
         BIN   LB3544
         BIN   LB3554
         ROUTINE XDUM2,APCHKP
         LABEL 'DIS ECC','5-PTLB'
         LINE
         BIN   LB3545        DIS BFR
         BIN   LB3555        SET TOD
         BIN   LB3576        WRITE
         ROUTINE XDUM2,APCHKNP
         LABEL 'DIS BFR','6-SET TOD','FET WRITE'
         LINE  ,
         BIN   LB3545
         BIN   LB3555
         ROUTINE XDUM2,APCHKP
         LABEL 'DIS BFR','6-SET TOD'
         LINE
         BIN   LB3546        I/O MODE OP
         BIN   LB3556        WR SP KEY
         BIN   LB3580
         ROUTINE XDUM2,APCHKNP
         LABEL 'I/O MODE','7-WR SP KEY','MS UCW'
         LINE  ,
         ROUTINE XDUM2,SKIPPER
         BIN   LB3556
         ROUTINE XDUM2,APCHKP
         LABEL ' ','7-WR SP KEY'
         LINE
         ROUTINE DUMMY001,SKIPPER
         BIN   LB3557        RES BFR BIT
         ROUTINE XDUM2,APCHKP
         LABEL ' ','8-RST REF BIT'
          LINE   ,                                             @Z02774
          ROUTINE DUMMY001,SKIPPER                             @Z02774
          BIN   LB3557                                         @Z02774
          BIN   MSIUCWS                                        @Z02774
         ROUTINE XDUM2,APCHKNP
          LABEL   ' ','8-RST REF BIT','FET RMT CYCLE'          @Z02774
         LINE
         ROUTINE DUMMY001,SKIPPER
         BIN   LB4554
         ROUTINE XDUM2,APCHKP
         LABEL ' ','9-RD BFR'
          LINE    ,                                            @Z02774
          ROUTINE DUMMY001,SKIPPER                             @Z02774
          BIN   LB4554                                         @Z02774
          BIN   MSIIOOP                                        @Z02774
         ROUTINE XDUM2,APCHKNP
          LABEL   ' ','9-RD BFR','FET RMT LOCK'                @Z02774
         LINE
         ROUTINE DUMMY001,SKIPPER
         BIN   LB3560        VAL DT ARRAY
         ROUTINE XDUM2,APCHKP
         LABEL '---TLB CONTROLS---','A-VAL ARRAY'
          LINE    ,                                            @Z02774
          ROUTINE DUMMY001,SKIPPER                             @Z02774
          BIN   LB3560                                         @Z02774
          BIN   RETENBL                                        @Z02774
         ROUTINE XDUM2,APCHKNP
         LABEL '---TLB CONTROLS---','A-VAL ARRAY','FET RMT ENABLED'
         LINE
         BIN   LB34E5        TLB COMP
         BIN   LB3561        IB RE-FTH
         LABEL 'TLB COMP','B-IB RE-FETCH'
          LINE    ,                                            @Z02774
          BIN   LB34E6                                         @Z02774
          BIN   LB3562                                         @Z02774
          LABEL 'TLB V2','C-CLK ESAR'                          @Z02774
         LINE
         BIN   LB34E7        TLB  1
         BIN   LB3563
         LABEL 'TLB V1','D-NO-OP'
         LINE
         BIN   LB34F0        TLB CTRLS ENC 1
         BIN   LB3564        RD SP KEY
         LABEL 'ENC STO 1','E-RD SP KEY'
         LINE   ,,SKIP=2
         BIN   LB4536        TLB CTRLS ENC 2
         BIN   LB3565        DEGRD ARRAY
         LABEL 'ENC STO 2','F-DEG ARRAY'
         LINE  ,(13,40),SKIP=1
         ROUTINE XDUM2,N1583AP
         LABEL '---MISC GATES---','---INDEX DATA---',                  *
               '---STORAGE PROTECT---'
          LINE    ,                                            @Z02774
         ROUTINE XDUM2,DO1583AP
         LABEL '---MISC GATES---','---INDEX CTRL---',                  *
               '---STORAGE PROTECT---'
         LINE      (40,40),(5,40)
         BIN   LB3527        ODD STAT
         BIN    LB34F1       INDEX LO COMP
         BIN       R2529       SP DATA KEY
         BIN       SPDATAP,B46
         ROUTINE DUMMY001,P1145
         ROUTINE XDUM2,N1583AP
         LABEL ' ODD STAT','INDEX LO COMP','SP DATA KEY'            0.2
          LINE    ,                                            @Z02774
          BIN LB3527                                           @Z02774
          BIN CMPABCD                                          @Z02774
          BIN R2529                                            @Z02774
          BIN SPDATAP,B46                                      @Z02774
          ROUTINE DUMMY001,P1145                               @Z02774
         ROUTINE XDUM2,DO1583AP
          LABEL   ' ODD STAT','COMP A,B,C,D','SP DATA KEY'     @Z02774
         LINE
         BIN   LB3525        LOAD HI STAT
         BIN       LB34F2       INDEX HI COMP
         BIN       R2535
         BIN   R2534,B43
         ROUTINE DUMMY001,P117
         ROUTINE XDUM2,N1583AP
         LABEL     'LOAD HI STAT','INDEX HI COMP','SP DATA RC'
          LINE    ,                                            @Z02774
          BIN LB3525                                           @Z02774
          BIN ASARB3                                           @Z02774
          BIN R2535                                            @Z02774
          BIN R2534,B43                                        @Z02774
          ROUTINE DUMMY001,P117                                @Z02774
         ROUTINE XDUM2,DO1583AP
          LABEL   'LOAD HI STAT','VALID SELECT','SP DATA RC'   @Z02774
         LINE
         BIN   LB3526        UNLOAD HI STAT
         BIN   LB34F3        INDEX LO VALID
         ROUTINE XDUM2,N1583AP
         LABEL     'UNLOAD HI STAT','INDEX LO VALID'
          LINE     ,                                           @Z02774
          BIN LB3526                                           @Z02774
          BIN ASARB4                                           @Z02774
         ROUTINE XDUM2,DO1583AP
          LABEL   'UNLOAD HI STAT','VALID REGEN'               @Z02774
         LINE      (40,40)
         BIN   LB34D5        GATE BUFF
         BIN       LB34F4     INDEX HI VALID
         ROUTINE XDUM2,N1583AP
         LABEL     'GATE BUFF','INDEX HI VALID'
          LINE    ,                                            @Z02774
          BIN LB34D5                                           @Z02774
          BIN AIROE0                                           @Z02774
         ROUTINE XDUM2,DO1583AP
          LABEL   'GATE BUFF','OK AB,CD'                       @Z02774
         LINE
         BIN   LB34D6        ACC LOAD
         BIN       LB34F5      INDEX OK
         ROUTINE XDUM2,N1583AP
         LABEL 'XAR LOAD','INDEX OK','          ---STORAGE---'
          LINE    ,                                            @Z02774
          BIN LB34D6                                           @Z02774
          BIN AIRINE1                                          @Z02774
         ROUTINE XDUM2,DO1583AP
         LABEL 'XAR LOAD','ALG BITS','          ---STORAGE---'
         LINE      (53,27)
         ROUTINE DUMMY001,SKIPPER
         BIN       LB34F6        INDEX LRU
         HEX       BCUS1,4,3B
         BIN       BCUS1P,B29
         BIN       BCUS2P,B50
         BIN       BCUS3P,B71
         ROUTINE   DUMMY001,P10523
         ROUTINE XDUM2,N1583AP
         LABEL ' ','INDEX LRU','MS SAR'
          LINE    ,                                            @Z02774
          ROUTINE DUMMY001,SKIPPER                             @Z02774
          BIN OKOFF                                            @Z02774
          HEX BCUS1,4,3B                                       @Z02774
          BIN BCUS1P,B29                                       @Z02774
          BIN BCUS2P,B50                                       @Z02774
          BIN BCUS3P,B71                                       @Z02774
          ROUTINE DUMMY001,P10523                              @Z02774
         ROUTINE XDUM2,DO1583AP
          LABEL  ' ','OK OFF','MS SAR'                         @Z02774
          LINE  (80,20)                                        @Z02774
          ROUTINE DUMMY001,SKIPPER                             @Z02774
          ROUTINE DUMMY001,SKIPPER                             @Z02774
          BIN   BCUB7                                          @Z02774
          BIN   BCUB0P,B33                                     @Z02774
          BIN   BCUB0,B51                                      @Z02774
          BIN   BCUB4P,B65                                     @Z02774
          BIN   BCUB4,B83                                      @Z02774
          ROUTINE DUMMY001,P107                                @Z02774
         ROUTINE XDUM2,DO1583AP
          LABEL  ' ',' ','SCU BYTE MARKS 0-7'                  @Z02774
         LINE      (80,20)
         BIN   LB34F7       INDEX OK OFF
         ROUTINE DUMMY001,SKIPPER
         BIN       BCUB7
         BIN       BCUB0P,B33        P0-3
         BIN       BCUB0,B51        BM 0-3
         BIN       BCUB4P,B65       P4-7
         BIN       BCUB4,B83        BM 4-6
         ROUTINE   DUMMY001,P107
         ROUTINE XDUM2,N1583AP
         LABEL '','INDEX OK OFF','SCU BYTE MARKS 0-7'
         LINE
         ROUTINE DUMMY001,SKIPPER
         ROUTINE   DUMMY001,SKIPPER
         BIN       BCUB15
         BIN       BCUB8P,B33
         BIN       BCUB8,B51
         BIN       BCUB12P,B65
         BIN       BCUB12,B83
         BIN       BCUB14,B101
         ROUTINE   DUMMY001,P107
         LABEL     '','','SCU BYTE MARKS 8-15'
         LINE      (107,)
         HEX       FALE0,2,4B
         ROUTINE XDUM2,SKIPAP
         LABEL     '','','FINAL ASM LO EVEN'
         LINE
         HEX       FALO0,2,4B
         LABEL     '','','FINAL ASM LO ODD'
         LINE      (111,3)
         BIN       FALE0P
         BIN       FALE1P
         BIN       FALE2P
         BIN       FALE3P
         LABEL     '','','CK BITS C0-C3'
         LINE
         BIN       FALO0P
         BIN       FALO1P
         BIN       FALO2P
         BIN       FALO3P
         LABEL     '','      ---REAL SAR GATES---','CK BITS C4-C7'
         LINE      (40,40),(5,40)
         ROUTINE DUMMY001,SKIPPER
         BIN   LB4534     GATE TLB
         ROUTINE DUMMY001,BCK53
         HEX       FAHE0,2,4B
         LABEL     '','TLB','FINAL ASM HI EVEN'
         LINE
         ROUTINE DUMMY001,SKIPPER
         BIN   LB34E2    ADDER
         ROUTINE DUMMY001,BCK53
         HEX       FAHO0,2,4B
         LABEL     '','ADDER','FINAL ASM HI ODD'
         LINE  (80,20)
         BIN   LB34E3   CPU/ADDER
         ROUTINE DUMMY001,SKIPPER
         BIN       FAHE3P
         BIN       FAHE0P,B29
         BIN       FAHE1P,B46
         BIN       FAHE2P,B63
         LABEL     '','CPU ADDER','CK BITS C0-C3'
          LINE  (80,20),(45,40)                                @Z02774
          BIN   LB34E0                                         @Z02774
          ROUTINE DUMMY001,SKIPPER                             @Z02774
          BIN   FAHO3P                                         @Z02774
          BIN   FAHO0P,B29                                     @Z02774
          BIN   FAHO1P,B46                                     @Z02774
          BIN   FAHO2P,B63                                     @Z02774
          LABEL 'RMT SAR','CK BITS C4-C7'                      @Z02774
          LINE  (80,20),(45,40)                                @Z02774
          BIN   LB34E1                                         @Z02774
          ROUTINE DUMMY001,SKIPPER                             @Z02774
          BIN   (LB34A0,B13,8),(LB34B0,B24,5)                  @Z02774
          LABEL  'PREFIX REAL SAR','REAL SAR(BINARY)'          @Z02774
         LINE  (105,2),(45,40)
         BIN  (LB4102,2,6)
         HEX   (LH241,4,3B)   IC
         ROUTINE DUMMY001,P10523
         LABEL '     ---ERROR STATUS---','INST COUNTER'
         LINE   (80,25)
         BIN   LB36B5    PAGE LOOKUP
         BIN  (LB4592,2,6)
         ROUTINE DUMMY001,BCK48
         HEX   (LH365,4,3B)       DAT ADDER
         ROUTINE DUMMY001,P10523
         LABEL 'PAGE LOOKUP','DAT ADDER SAR'
         LINE   (,19)
         BIN   LB36B6   PASS REAL
         BIN  (LB41E0,2,8)
         ROUTINE DUMMY001,BCK36
         HEX   (LH278,4,4B)       SDR
         ROUTINE DUMMY001,P9924
         LABEL 'PASS REAL ','SDR EVEN'
         LINE
         BIN  LB34E2  GATE ADDER
       BIN   (LB41F0,2,8)
       ROUTINE DUMMY001,BCK36
         HEX   (LH27C,4,4B)       SDR
         ROUTINE DUMMY001,P9924
         LABEL  'GATE ADDER','SDR ODD'
         LINE
         BIN   LB36C5                                               0.2
         BIN  (LB4560,2,8)
         ROUTINE DUMMY001,BCK36                                     0.2
         HEX   LB32C,4,4B
         ROUTINE DUMMY001,P9924
         LABEL 'IBUF ERR','SAR BU'                                  0.2
         LINE  (80,25)                                              0.2
         BIN   LB36C6
         LABEL 'IBIX ERR','   ----IBUF----     '
         LINE
         BIN   LB36C7
         BIN   LB36C0
         LABEL 'RIC ERR','RIC VALID'
         LINE  (105),(85)
         BIN   LB36C1
         LABEL 'DATA AVAIL'
         LINE
         BIN   LB36C2
         LABEL 'ALLOW IBUF'
         LINE
         BIN   LB36C3
         LABEL 'IBIX VAL LO'
         LINE
         BIN   LB36C4
SCUAPLAB LABEL 'IBIX VAL HI'
SCUAPLNE LINE  (1,1),(1,1),SKIP=1
         ROUTINE XDUM2,NOPRINT
         LABEL ''
         LINE  (120,20),(85,40),SKIP=1
         BIN   (LB34A0,B13,8),(LB34B0,B24,5)
         ROUTINE XDUM2,SCUSKIP2
         LABEL 'REAL SAR(BINARY)'
         LINE  (105,2)
         BIN   (LB4102,2,6)
         HEX   (LH241,4,3B)
         ROUTINE XDUM2,P10523
         LABEL 'INST COUNTER'
         LINE  ,
         BIN   (LB4592,2,6)
         HEX   (LH365,4,3B)
         ROUTINE XDUM2,P10523
         LABEL 'DAT ADDER SAR'
         LINE  (99,3),(45,40)
         BIN   LB41E0
         BIN   LB41E1
         BIN   LB41E2
         BIN   LB41E3
         BIN   LB41E4
         BIN   LB41E5
         BIN   LB41E6
         BIN   LB41E7
         ROUTINE XDUM2,BCK25
         HEX   (LH278,4,4B)
         ROUTINE XDUM2,P9924
         LABEL '     ---REAL SAR GATES---','SDR EVEN'
         LINE  (80,3)
         BIN   LB4534
         ROUTINE XDUM2,UP13
         BIN   LB41F0
         BIN   LB41F1
         BIN   LB41F2
         BIN   LB41F3
         BIN   LB41F4
         BIN   LB41F5
         BIN   LB41F6
         BIN   LB41F7
         ROUTINE XDUM2,BCK25
         HEX   (LH27C,4,4B)
         ROUTINE XDUM2,P9924
         LABEL 'TLB','SDR ODD'
         LINE  ,
         BIN   LB34E2
         ROUTINE XDUM2,UP13
         BIN   LB4560
         BIN   LB4561
         BIN   LB4562
         BIN   LB4563
         BIN   LB4564
         BIN   LB4565
         BIN   LB4566
         BIN   LB4567
         ROUTINE XDUM2,BCK25
         HEX   (LB32C,4,4B)
         ROUTINE XDUM2,P9924
         LABEL 'ADDER','SAR BU'
         LINE  (80,40)
         BIN   LB34E3
         LABEL 'CPU ADDER','   ----IBUF----'
         LINE  (,25)
         BIN   LB34E0
         BIN   LB36C0
         LABEL 'RMT SAR','RIC VALID'
         LINE  ,
         BIN   LB34E1
         BIN   LB36C1
         LABEL 'PREFIX REAL SAR','DATA AVAIL'
         LINE  ,
         ROUTINE XDUM2,SKIPPER
         BIN   LB36C2
         LABEL '     ---ERROR STATUS---','ALLOW IBUF'
         LINE  ,
         BIN   LB36B5
         BIN   LB36C3
         LABEL 'PAGE LOOKUP','IBIX VAL LO'
         LINE  ,
         BIN   LB36B6
         BIN   LB36C4
         LABEL 'PASS REAL','IBIX VAL HI'
         LINE  ,
         BIN   LB34E2
         LABEL 'GATE ADDER'
         LINE  ,
         BIN   LB36C5
         LABEL 'IBUF ERR'
         LINE  ,
         BIN   LB36C6
         LABEL 'IBIX ERR'
         LINE  ,
         BIN   LB36C7
SCUNAPLB LABEL 'RIC ERR'
SCUNAPLN LINE  ,,SKIP=E
         LABEL ''
         LINE  (40,35),(24,35),SKIP=2
         LABEL        '---------------------------  SCU DATA FLOW     -X
               -----------------------------'                  @YA02788
         LINE  ,(12,40),SKIP=1                                 @YA02788
         LABEL '---TRAP STATUS---','---SCU CONTROLS---',       @YA02788X
               '---MP STG CONFIG---'                           @YA02788
         LINE  (40,40),(5,40),SKIP=1                           @YA02788
         BIN   LB36D5             SEG IB1                      @YA02788
         BIN   LB34C1             REL ACTIVE                   @YA02788
         BIN   LB3700             UNIT 0 ON LINE               @YA02788
         LABEL 'I-FETCH SEG IB1','REL ACTIVE','UNIT 0 ON LINE' @YA02788
         LINE  ,                                               @YA02788
         BIN   LB36D6             SPEC IB1                     @YA02788
         BIN   LB4530             SEG MODE                     @YA02788
         BIN   (LB3701,,3)        UNIT 0 BITS 4,2,1            @YA02788
         LABEL 'I-FETCH SPEC IB1','SEG MODE','UNIT 0 BITS 4,2,1'
         LINE  ,                                               @YA02788
         BIN   LB36D7             PAGE IB1                     @YA02788
         BIN   LB34C0             PAGE MODE                    @YA02788
         BIN   LB3704             UNIT 1 ON LINE               @YA02788
         LABEL 'I-FETCH PAGE IB1','PAGE MODE','UNIT 1 ON LINE' @YA02788
         LINE  ,                                               @YA02788
         BIN   (LB36D1),(LB34C2)     SEG IB2,XLTN REQD         @YA02788
         BIN   (LB3705,,3)        UNIT 1 BITS 4,2,1            @YA02788
         LABEL 'I-FETCH SEG IB2','XLTN REQD','UNIT 1 BITS 4,2,1'
         LINE  ,                                               @YA02788
         BIN   (LB36D2),(LB34C3)     SPEC IB2,STE LTH          @YA02788
         BIN   LB45C2             UNIT 2 ON LINE               @YA02788
         LABEL 'I-FETCH SPEC IB2','STE LTH','UNIT 2 ON LINE'   @YA02788
         LINE  ,                                               @YA02788
         BIN   (LB36D3),(LB34C4)     PAGE IB2,SEG IN BFR       @YA02788
         BIN   (LB3710,,3)        UNIT 2 BITS 4,2,1            @YA02788
         LABEL 'I-FETCH PAGE IB2','STE IN BFR','UNIT 2 BITS 4,2,1'
         LINE  ,                                               @YA02788
         BIN   (LB36E0),(LB34C5)     SUCC BR,PG IN BFR         @YA02788
         BIN   LB3713             UNIT 3 ON LINE               @YA02788
         LABEL 'PER SUCC BR','PTE IN BFR','UNIT 3 ON LINE'     @YA02788
         LINE  ,                                               @YA02788
         BIN   (LB36E1),(LB4532)     PER I-FETCH,MS BUSY       @YA02788
         BIN   (LB3714,,3)        UNIT 3 BITS 4,2,1            @YA02788
         LABEL 'PER I-FETCH','MS BUSY','UNIT 3 BITS 4,2,1'     @YA02788
         LINE  ,                                               @YA02788
         BIN   (LB36E2),(LB34D0)     PER MS,XLTN BUSY          @YA02788
         BIN   LB3720             UNIT 0 INSTLD                @YA02788
         LABEL 'PER MS','XLTN BUSY','UNIT 4 ON LINE'
         LINE  ,                                               @YA02788
         BIN   (LB36E3),(LB34D1)      PER GP ALT,MS BUSY BR    @YA02788
         BIN   (LB3721,,3)        UNIT 0 BITS 4,2,1            @YA02788
         LABEL 'PER GP ALT','MS BUSY BR','UNIT 4 BITS 4,2,1'
         LINE  ,                                               @YA02788
         BIN   (LB36E4),(LB34D2)     PER SUCC U-BR,DAT VIOL    @YA02788
         BIN   LB3724             UNIT 1 INSTLD                @YA02788
         LABEL 'PER SUCC U-BR','DAT VIOL','UNIT 5 ON LINE'
         LINE  ,                                               @YA02788
         BIN   (LB36E6),(LB34D3)     64K SEG,IVA               @YA02788
         BIN   (LB3725,,3)        UNIT 1 BITS 4,2,1            @YA02788
         LABEL 'BASE REG ALTER','IVA','UNIT 5 BITS 4,2,1'
         LINE  ,                                               @YA02788
         BIN   (LB36E7),(LB34D4)     1M SEG,PAV                @YA02788
         BIN   LB45C6             UNIT 2 INSTLD                @YA02788
         LABEL '64K SEG','PAV','UNIT 6 ON LINE'
         LINE  ,                                               @YA02788
         BIN   (LB36F0),(LB3544)     OP EX LTH CK,DIS ECC      @YA02788
         BIN   (LB3730,,3)        UNIT 2 BITS 4,2,1            @YA02788
         LABEL 'OP EX LGTH CK','DIS ECC','UNIT 6 BITS 4,2,1'
         LINE  ,                                               @YA02788
         BIN   (LB36F1),(LB3545)     OP EX SEG,DIS BFR         @YA02788
         BIN   LB3733             UNIT 3 INSTLD                @YA02788
         LABEL 'OP EX SEG','DIX BFR','UNIT 7 ON LINE'
         LINE  ,                                               @YA02788
         BIN   (LB36F2),(LB3522,,3)    OP EX SPEC4,SEL PTR     @YA02788
         BIN   (LB3734,,3)        UNIT 3 BITS 4,2,1            @YA02788
         LABEL 'OP EX SPEC4','SEL PTR','UNIT 7 BITS 4,2,1'
         LINE  ,                                               @YA02788
         BIN   (LB36F3),(LB3521)     OP EX SPEC 5,DBL WD WR    @YA02788
         BIN   LB3737
         LABEL 'OP EX SPEC 5','DBL WD WR','CPU B ONLINE'
         LINE  ,                                               @YA02788
         BIN   (LB36F4),(LB3566)     EX 4K,SAR 13 INV          @YA02788
         LABEL '4K PAGE','SAR 13 INV'                          @YA02788
         LINE  ,                                               @YA02788
         BIN   (LB36F5),(LB3214)     EX 2K,ECC REC MODE        @YA02788
         LABEL '2K PAGE','ECC REC MD'                          @YA02788
         LINE  ,                                               @YA02788
         BIN   (LB36F6),(LB36E5)                                    0.2
         LABEL 'OP EX SPEC 1-3','VIRT ADDR COMP'                    0.2
         LINE  ,
         BIN   (LB36F7),(LB45C0)
         ROUTINE XDUM2,APCHKNP
         LABEL 'OP EX PAGE','MP MODE'
         LINE  ,,SKIP=2
         BIN   (LB36F7),(LB3572)
         ROUTINE XDUM2,APCHKP
         LABEL 'OP EX PAGE','AP MODE'
         LINE  ,,SKIP=2
          ROUTINE DUMMY001,SKIPPER                             @Z02774
          BIN  BUF1819                                         @Z02774
          ROUTINE LB32F2,DO1583                                @Z02774
          LABEL  ' ','BUFSAR 18,19'                            @Z02774
         LINE  ,(24,44)
         LABEL '+-----------------------------  SCU ERRORS  ',         *
               '-----------------------------+'
         LINE  ,(12,40),SKIP=1                                 @YA02788
         LABEL '---SCU CHECKS---','---TLB ERRORS---'           @YA02788
         LINE  (40,40),(5,40),SKIP=1                           @YA02788
         BIN   LB3490             INDEX                        @YA02788
         BIN   LB36B0                                               O.1
         LABEL 'INDEX','CNTR'                                  @YA02788
         LINE  ,                                               @YA02788
         BIN   LB3491             INDEX COMP                   @YA02788
         BIN   LB36B1                                               O.1
         LABEL 'INDEX COMP','VIRT'                             @YA02788
         LINE  ,                                               @YA02788
         BIN   LB3492             RD COMP                      @YA02788
         BIN   LB36B2                                               O.1
         LABEL 'RD COMP','REAL'                                @YA02788
         LINE  ,                                               @YA02788
         BIN   LB3496             FET SAR LCL                  @YA02788
         BIN   LB36B3                                               O.1
         ROUTINE XDUM2,APCHKNP
         LABEL 'FET SAR (LCL)','MAP'
         LINE  ,
         ROUTINE XDUM2,SKIPPER
         BIN   LB36B3
         ROUTINE XDUM2,APCHKP
         LABEL ' ','MAP'
         LINE  ,                                               @YA02788
         BIN   LB3497             FET SAR (RMT)                @YA02788
         LABEL 'FET SAR (RMT)'                                 @YA02788
         LINE  ,                                               @YA02788
         BIN   LB45A2                                               0.2
         LABEL 'TIME OUT'                                      @YA02788
         LINE  ,                                               @YA02788
        BIN   LB45A0
         LABEL 'SCU BYTE MARK'                                      0.1
         LINE  ,                                               @YA02788
         BIN   LB4520             INSTR                        @YA02788
         LABEL 'INST','            ---ECC---'                  @YA02788
         LINE  ,                                               @YA02788
         BIN   LB3480             EMIT                         @YA02788
         BIN   LB4482             HDW CK LCL LO                @YA02788
         ROUTINE XDUM2,APCHKNP
         LABEL 'EMIT','HDW CK LCL LO'
         LINE  ,
         BIN    LB3480
         ROUTINE XDUM2,APCHKP
         LABEL 'EMIT'
         LINE  ,                                               @YA02788
         BIN   LB3481             KEY BUS                      @YA02788
         BIN   LB3210             HDW CK LCL HI                @YA02788
         ROUTINE XDUM2,APCHKNP
         LABEL 'KEY BUS','HDW CK LCL HI'
         LINE  ,
         BIN    LB3481
         ROUTINE XDUM2,APCHKP
         LABEL 'KEY BUS'
         LINE  ,                                               @YA02788
         BIN   LB3482             SP DATA OUT                  @YA02788
         BIN   LB3213             ECC UNC                      @YA02788
         LABEL 'SP DATA','ECC UNC'                             @YA02788
         LINE  ,                                               @YA02788
         BIN   LB4580                                               0.1
         BIN   LB3217                                               0.1
         ROUTINE XDUM2,APCHKNP
         LABEL 'LCL BM LO','UNC CPU'
         LINE  ,
         ROUTINE XDUM2,SKIPPER
         BIN    LB3217
         ROUTINE XDUM2,APCHKP
         LABEL ' ','UNC CPU'
         LINE  ,                                               @YA02788
         BIN   LB4582                                               0.1
         BIN   LB3216             UNC I/O                      @YA02788
         ROUTINE XDUM2,APCHKNP
         LABEL 'LCL BM HI','UNC I/O'
         LINE  ,                                               @YA02788
         BIN   LB4584             RMT BM LO                    @YA02788
         BIN   (LB3220,,8)                                          0.1
         BIN   LB4484,B49                                           0.1
         ROUTINE DUMMY001,P71                                  @YA02788
         LABEL 'RMT BM LO','BIE LO'                            @YA02788
         LINE  ,                                               @YA02788
         BIN   LB4586             RMT BM HI                    @YA02788
         BIN   (LB3230,,8)                                          0.1
         BIN   LB4486,B49                                           0.1
         ROUTINE DUMMY001,P71                                  @YA02788
         LABEL 'RMT BM HI','BIE HI'                            @YA02788
         LINE  ,                                               @YA02788
         BIN   LB36D4             SEG LENGTH                   @YA02788
         LABEL 'SEG LTH'                                       @YA02788
          LINE    ,,SKIP=1                                     @Z02774
          BIN   LB3495                                         @Z02774
          BIN   LB3211                                         @Z02774
          LABEL  'RMT CYCLE ERR','HDW CK RMT LO'               @Z02774
         LINE   ,(45)                                          @O
         ROUTINE XDUM2,SKIPPER
         BIN    LB3212                                         @O
         ROUTINE XDUM2,N1583AP
         LABEL  'HDW CK RMT HI'                                @O
         LINE   (40,40),(5,40)                                 @O
          BIN   LB3493                                         @Z02774
          BIN   LB3212                                         @Z02774
         ROUTINE XDUM2,DO1583AP
          LABEL  'ALG ERROR','HDW CK RMT HI'                   @Z02774
         LINE   (40,40),(5,40),SKIP=2                          @O
          BIN   LB3494                                         @Z02774
          BIN   LB3215                                         @Z02774
          LABEL  'FET ERROR','RMT ECC ERR'                     @Z02774
         LINE  (18,3),(5,40),SKIP=1                            @YA02788
         LABEL 'BYTE-        0  1  2  3  4  5  6  7'           @YA02788
         LINE  ,                                               @YA02788
         BIN   (LB3680,2,8)       SDR                          @YA02788
         LABEL 'SDR'                                           @YA02788
         LINE  ,                                               @YA02788
         BIN   (LB3690,2,8)       BFR                          @YA02788
         LABEL 'BFR'                                           @YA02788
         LINE  ,
         BIN   (LB45A4),(LB36A0,2,3)                                0.2
         LABEL 'WD FUNNEL'                                          0.1
         LINE  ,                                               @YA02788
         ROUTINE DUMMY001,SKIPPER                              @YA02788
         BIN   (LB36A3,2,3)                                         O.1
         LABEL 'HS BYTE'                                       @YA02788
         LINE  ,                                               @YA02788
         ROUTINE DUMMY001,SKIPPER                              @YA02788
         BIN   (LB36A6,2,2)                                         O.1
         ROUTINE DUMMY001,SKIPPER                                   O.1
         BIN   (LB45A6)                                             0.2
         LABEL 'ADDER'                                         @YA02788
         LINE  ,                                               @YA02788
         BIN   (LB3600,2,8)       SIR LO LCL                   @YA02788
         ROUTINE XDUM2,APCHKNP
         LABEL 'SIR LCL LO'                                    @YA02788
         LINE  ,                                               @YA02788
         BIN   (LB3610,2,8)       SIR LCL HI                   @YA02788
         ROUTINE XDUM2,APCHKNP
         LABEL 'SIR LCL HI'                                    @YA02788
         LINE  ,                                               @YA02788
         BIN   (LB3620,2,8)       SIR RMT LO                   @YA02788
         LABEL 'SIR RMT LO'                                    @YA02788
         LINE  ,                                               @YA02788
         BIN   (LB3630,2,8)       SIR RMT HI                   @YA02788
         LABEL 'SIR RMT HI'                                    @YA02788
         LINE  ,                                               @YA02788
         ROUTINE DUMMY001,SKIPPER                              @YA02788
         BIN   (LB3483,2,3)       CPU SAR                      @YA02788
         LABEL 'CPU SAR'                                       @YA02788
         LINE  ,                                               @YA02788
         ROUTINE DUMMY000,SKIPPER                              @YA02788
         BIN   (LB3486,2,2)                                         O.1
         ROUTINE DUMMY001,SKIPPER                                   O.1
         BIN   (LB4522)                                             O.1
         LABEL 'REAL SAR'
        LINE  ,,SKIP=E
         LABEL     ''
         LINE  (34,2),(50,40),SKIP=1
         LABEL '/////////////////'
         LINE   (34,2),(50,40)
         LABEL '-EXECUTION ARRAY-'
         LINE
         LABEL '/////////////////'
         LINE ,,SKIP=3
         LABEL ''
         LINE  ,,SKIP=1
         LABEL ''
         LINE   (34,2),(20,40)
         BIN   (LB45E0,2,8)
         HEX   (LH378,4,4B)
         LABEL 'ASSY REG','--ERRORS--'
         LINE  (55,41)
         HEX   (LH37C)
         BIN   (LB32A0)
         LABEL 'CSAL','CSDR BIT1'
         LINE
         HEX   (LH37F)
         BIN   (LB32A1)
         LABEL 'D-BUS','CSDR BIT2'
         LINE
         HEX   (LH37E)
         BIN   (LB32B2)
         LABEL 'R-BUS','CSDR BIT3'
         LINE
         HEX  (LH328)
         BIN   (LB32B3)
         LABEL 'OP CODE','CSDR BIT4'
         LINE
         HEX   LH37D
         BIN   LB32A2
         LABEL 'AL1-AL2','AL CNTR'
         LINE
          BIN (LB3292,,4)                                      @YA02788
          BIN (LB3290,B48,2)                                   @YA02788
          BIN (LB32A3,B41)                                     @YA02788
         LABEL 'XAR CB/AB REG','SEQ CHK'
         LINE
         BIN   LB3296
         BIN   LB32A4
         LABEL 'L1 SS','D-BUS'
         LINE
         BIN   LB3297
         BIN   LB32A5
         LABEL 'L2 SS','EMIT'
         LINE
         BIN   LB32B5
         BIN   LB32B4,B42
         BIN   LB32A6,B41
         LABEL 'WD RING','MULT RES'
         LINE
         BIN   LB32B6
         BIN   LB32A7
         LABEL '1ST WD','CONV-DEC RES'
         LINE
         BIN   LB32B7
         BIN   LB32B0
         LABEL 'ACTIVE','BYTE 0-1'
         LINE  (96,),(60,80)
         BIN   LB32B1
         ROUTINE XDUM2,APCALLR
         LABEL 'BYTE 2-3'
         LINE  ,,SKIP=E
         LABEL  ''
         LINE      ,(39,),SKIP=1
         LABEL     '//////////////////////////////////////////'
         LINE
         LABEL     '/                                        /'
         LINE
         LABEL     '/   ///CHANNEL DATA FLOW + CONTROLS///   /'
         LINE
         LABEL     '/                                        /'
         LINE      ,,SKIP=2
         ROUTINE   DUMMY001,WORKREST
         ROUTINE   MPXOS2,TSTRB
         LABEL     '//////////////////////////////////////////'
         DC    X'FE'
         DC    CL8'IFCEF155'
BLKMPXB  DC    X'FE'
         DC    CL8'IFCEE155'
APMODBR  DC    X'FE'
         DC    CL8'IFCEG155'
LABAREA  EQU   *
         LSTART
         END
