         TITLE 'IFCENFP1 EDIT TABLE'
***********************************************************************
**                                                                   **
**                           IFCENFP1                                **
**                                                                   **
**       THIS EDIT TABLE PROVIDES SUPPORT FOR FBA2 DASD DEVICES. IT  **
**    IS CALLED BY IFCEEDIT AT THE REQUREST OF IFCEWOD1 WHEN FBA2    **
**    FORMAT1 (REGULAR INTERPRETATION) IS INDICATED.  IT SUPPLIES    **
**    THE FORMAT FOR SENSE BYTES 8-23, WITH BYTE 11, BITS 5,6,7      **
**    DEPENDENT ON BYTE 12, BIT 0 (SEE THE LABEL MOVING ROUTINES).   **
**       THE DETAIL FORMAT OF THE OBR RECORD IS SUPPLIED AS FIGURE   **
**    44 IN PART 4 OF "OS/VS ENFIRONMENTAL RECORDING EDITING AND     **
**    PRINTING (EREP) PROGRAM" (PUB. NO. GC28-0772).                 **
**                                                                   **
**-------------------------------------------------------------------**
**                                                                   **
**                      REGISTER ASSIGNMENT                          **
**    GPR #                USE                                       **
**    2            START OF OBR RECORD                               **
**    3            CURRENT CHARACTER POSITION IN PRINT BUFFER        **
**    4            @ DATA ITEM SPECIFIED IN ROUTINE MACRO            **
**    5-8          WORK REGISTERS FOR SPECIAL ROUTINES               **
**    9            BASE REGISTER FOR IFCEWHT1                        **
**    14           RETURN POINT FROM SPECIAL ROUTINES                **
**    15           SET TO 0 TO SUPPRESS PRINT OF CURRENT LINE        **
**                                                                   **
***********************************************************************
         GBLC  &DSECT,&CSECT
IFCENFP1 CSECT
&CSECT   SETC  'IFCENFP1'
&DSECT   SETC  'NFP1'
*
*                                  SENSE FORMAT 1
*
NFP1     DSECT
         DSGEN (CLASRC,8),(SYSREL,8),(SWITCHES,16)
         DSGEN (SPARE1,32)
         DSGEN (DAY,32)
         DSGEN (HOUR,32)
         DSGEN (SPARE2,8),(CPUSERL,24)
         DSGEN (CPUID,16),(SPARE3,16)
         DSGEN (JOBID1,32)
         DSGEN (JOBID2,32)
         DSGEN (FCCWCC,8),(FCCWDA,24)
         DSGEN (FCCWFL,8),(FCCW,8),(FCCWCT,16)
         DSGEN (CSWUS1,8),(CSWUS2,24)
         DSGEN (CSWUS3,8),(CSWUS4,8),(CSWUS5,16)
         DSGEN (DEVDPD,8),(SECCUA,24)
         DSGEN (DEVTYP1,16),(DEVTYP2,16)
         DSGEN (SPARE4,8),(CUA,24)
         DSGEN (IORET,16),(SBCNT,16)
         DSGEN (VOLLAB1,8),(VOLLAB2,16),(VOLLAB3,8)
         DSGEN (VOLLAB4,8),(VOLLAB5,8),(SPARE5,16)
         DSGEN (LSKAD1,8),(LSKAD2,16),(LSKAD3,8)
         DSGEN (LSKAD4,8),(LSKAD5,16),(LSKAD6,8)
         DSGEN (AHA1,32)
         DSGEN (AHA2,16),(SPARE6,16)
         DSGEN (SNB,1,0,23,0,7)
         EJECT
IFCENFP1 CSECT
         USING *,R9
         USING NFP1,R2
R0       EQU   0
R1       EQU   1
R2       EQU   2
R3       EQU   3
R4       EQU   4
R5       EQU   5
R6       EQU   6
R7       EQU   7
R8       EQU   8
R9       EQU   9
R10      EQU   10
R11      EQU   11
R12      EQU   12
R13      EQU   13
R14      EQU   14
R15      EQU   15
L0       EQU   0
L1       EQU   1
L2       EQU   2
L3       EQU   3
L4       EQU   4
L5       EQU   5
L6       EQU   6
L7       EQU   7
L8       EQU   8
L9       EQU   9
L10      EQU   10
L11      EQU   11
L12      EQU   12
L13      EQU   13
L14      EQU   14
L15      EQU   15
L16      EQU   16
L17      EQU   17
L18      EQU   18
L19      EQU   19
L20      EQU   20
L23      EQU   23
L24      EQU   24
L26      EQU   26
H0F      EQU   X'0F'
HE0      EQU   X'E0'
H80      EQU   X'80'
H40      EQU   X'40'
H20      EQU   X'20'
H10      EQU   X'10'
H21      EQU   X'21'
H23      EQU   X'23'
H25      EQU   X'25'
H29      EQU   X'29'
CLRSGN   EQU   X'F0'
HFF      EQU   X'FF'
         EJECT
         DC    A(ENTRIES)
         DC    CL8'IFCENFP1'
XR9PTR   DC    F'0'
XLABELP  DC    F'0'
***********************************************************************
**                                                                   **
**                        SPECIAL ROUTINES                           **
**                                                                   **
**===================================================================**
**                                                                   **
**      THE FOLLOWING THREE SPECIAL ROUTINES INSERT THE PROPER       **
**   LABELS FOR BYTE 11, BITS 5,6,7 DEPENDING UPON THE VALUE OF      **
**   BYTE 12, BIT 0.                                                 **
**                                                                   **
**-------------------------------------------------------------------**
**         BIT 5                                                     **
LABB5    S     R3,TOCOL46          MOVE POINTER TO COLUMN 46
         TM    0(R4),X'80'         IS BYTE 12, BIT 0 ON?
         BO    MVSECT              YES...GO PUT APPROPRIATE LABEL IN
         MVC   0(L11,R3),HDA       MOVE 'HDA ATTN' LABEL
         BR    R14                 RETURN
MVSECT   MVC   0(L11,R3),SECT      MOVE 'SECTOR PULS' LABEL IN
         BR    R14                 RETURN
**-------------------------------------------------------------------**
**         BIT 6                                                     **
LABB6    S     R3,TOCOL46          MOVE POINTER TO COLUMN 46
         TM    0(R4),X'80'         IS BYTE 12, BIT 0 ON?
         BO    MVMK                YES...GO PUT APPROPRIATE LABEL IN
         MVC   0(L11,R3),BUSY      MOVE 'BUSY' LABEL
         BR    R14                 RETURN
MVMK     MVC   0(L11,R3),MK        MOVE 'INDEX MARK' LABEL IN
         BR    R14                 RETURN
**-------------------------------------------------------------------**
**         BIT 7                                                     **
LABB7    S     R3,TOCOL46          MOVE POINTER TO COLUMN 46
         TM    0(R4),X'80'         IS BYTE 12, BIT 0 ON?
         BO    MVBIT7              YES...GO PUT APPROPRIATE LABEL IN
         MVC   0(L11,R3),SEEK      MOVE 'SEEK COMP' LABEL
         BR    R14                 RETURN
MVBIT7   MVC   0(L11,R3),BIT7      MOVE 'BIT 7' LABEL IN
         BR    R14                 RETURN
**-------------------------------------------------------------------**
**         DC'S FOR LABEL MOVING ROUTINES                            **
TOCOL46  DC    F'87'
HDA      DC    CL11'HDA ATTN'
BUSY     DC    CL11'BUSY'
SEEK     DC    CL11'SEEK COMP'
SECT     DC    CL11'SECTOR PULS'
MK       DC    CL11'INDEX MARK'
BIT7     DC    CL11'BIT 7'
**---------END OF LABEL MOVING ROUTINES------------------------------**
         SPACE 2
**
**
**
SETHEX   STM   R5,R8,XSAVE         SAVE REGS
         LA    R8,CHARS            CHARACTER TABLE POINTER
         IC    R7,L0(R4)           PICK UP CHARACTER
         SLL   R7,L24              MOVE TO HI R7
         SR    R6,R6               CLEAR REGS
         SLDL  R6,L4               MOVE FOUR BITS
         AR    R6,R8               ADD OFFSET AND POINTER
         MVC   L0(L1,R3),L0(R6)    MOVE CHARACTER TO LINE
         SR    R6,R6               CLEAR AGAIN
         SLDL  R6,L4               MOVE LAST 4 BITS
         AR    R6,R8               COMPUTE OFFSET
         MVC   L1(L1,R3),L0(R6)    MOVE LAST CHARACTER
         B     RETURN
         SPACE 2
*
*                                  TEST TO SEE IF RECORD IS IN AR-149
*                                  FORMAT
*
SETCONV  TM    L0(R4),HEX02        HAS RECORD BEEN CONVERTED KEY32
         BCR   ON,R14              YES RETURN
         SR    R15,R15             NO CLEAR R15 FOR NO PRINT OF
         BR    R14                 LINE
ON       EQU   1
HEX02    EQU   X'02'
         SPACE 2
*
*                                  NO OP RETURN
*
SKIPPER  BR    R14
         SPACE 2
*
*                                  TO ADD SPACES ON LINE
*
SPACER2  LA    R3,L4(R3)
         BR    14
         SPACE 2
*
*                                  RESTORE REGISTERS USED BY ROUTINES
*                                  IN THIS MODULE
*
RETURN   LM    R5,R8,XSAVE         RESTORE REGS
         BR    R14                 RETURN
         SPACE 2
*
*                                  SET BINARY WITH R4 POINTING TO THE
*                                  CHAR
*
SETBIN   STM   R5,R8,XSAVE         SAVE REGS
         ICM   R7,X'8',L0(R4)      PICK UP CHAR TO PRINT
         LR    R8,R3               PRINT POS POINTER TO REG8
         LA    R5,L8               LOOP COUNT
SETBINA  SR    R6,R6               CLEAR REG 6
         SLDL  R6,L1               MOVE BIT TO R6
         STC   R6,L0(R8)           PUT IT INTO PRINT LINE
         MVZ   L0(L1,R8),CHAR0
         LA    R8,L1(R8)           MOVE POINTER TO NEXT POS
         BCT   R5,SETBINA          LOOP TILL 8 PRINTED
         B     RETURN
         SPACE 2
SETBIN1  STM   R5,R8,XSAVE         SAVE REGS
         ICM   R7,X'8',L0(R4)      PICK UP CHAR TO PRINT
         LR    R8,R3               PRINT POS POINTER TO REG 8
         SR    R6,R6               CLEAR REG 6
         SLDL  R6,L1               MOVE BIT TO REG 6
         STC   R6,L11(R8)
         OC    L11(L1,R8),CHAR0
         B     RETURN              RETURN
         SPACE 2
*                                  CONVERT COUNTERS FROM HEX TO DECIMAL
*                                  READY FOR PRINT
*
CONV1    STM   R5,R8,XSAVE         SAVE REGISTERS
         XC    READYP(L8),READYP   CLEAR UNPACK BUFFER
         SR    R6,R6               ZERO REG
         LH    R6,L0(R4)           LOAD DATA TO BE CONVERTED
         CVD   R6,READYP           CONVERT ERROR COUNTER TO DECI
         UNPK  READYP(L5),READYP+L5(L3) UNPACK DECI COUNT
         OI    READYP+L4,CLRSGN    CLEAR SIGN
         MVC   L0(L4,R3),READYP+L1 MOVE COUNTER READY TO PRINT
         B     RETURN
         SPACE 2
         DS    0F
XSAVE    DC    5F'0'
NONE     DC    CL6'NONE  '
CHARS    DC    C'0123456789ABCDEF'
CHAR0    DC    C'0'
**-------------------------------------------------------------------**
**                              PATCH AREA                           **
         DC    S(PATCH)
PATCH    DC    CL50' '
**-------------------------------------------------------------------**
         EJECT
         DS    0D
READYP   DC    CL8' '
ENTRIES  DS    0F
         DC    XL4'00010001'       FORMAT 1
         DC    XL4'00010001'       FORMAT 2
         DC    A(LABELS)           LABEL POINTER
         DC    H'0'                DISP
*
*                                  SKIP TO CHANNEL 1
*
         DC    X'01'
         DC    X'000B0B00'
         SPACE 5
         LINE  (12,15),(3,15),SKIP=1
         ROUTINE SNB80,SETHEX
         ROUTINE SNB90,SETHEX
         ROUTINE SNB100,SETHEX
         ROUTINE SNB110,SETHEX
         ROUTINE SNB120,SETHEX
         ROUTINE SNB130,SETHEX
         ROUTINE SNB140,SETHEX
         ROUTINE SNB150,SETHEX
         LABEL 'BYTE 8','BYTE 9','BYTE 10','BYTE 11','BYTE 12','BYTE 13C
               ','BYTE 14','BYTE 15'
         SPACE 2
         LINE  ,(1,15),SKIP=2
         LABEL '-DCI TAG BUS-','-DCI BUS OUT-','-DCI BUS IN--','MACHINE*
                STATS','SENSE INTFCE','SNS R/W STA 1','SNS R/W STA 2', *
               'SNS HDA STA1'
         SPACE 2
         LINE  (2,15),(1,15),SKIP=1
         ROUTINE SNB80,SETBIN
         ROUTINE SNB90,SETBIN
         ROUTINE SNB100,SETBIN
         ROUTINE SNB110,SETBIN1
         ROUTINE SNB120,SETBIN1
         ROUTINE SNB130,SETBIN1
         ROUTINE SNB140,SETBIN1
         ROUTINE SNB150,SETBIN1
         LABEL ,,,'CONTRLR CK','BIT 0','WR MODE CK','WR INHIBIT',      *
               'HDA SQ LH 0'
         SPACE 2
         LINE  (13,15)
         BIN   SNB81
         BIN   SNB91
         BIN   SNB101
         BIN   SNB111
         BIN   SNB121
         BIN   SNB131
         BIN   SNB141
         BIN   SNB151
         LABEL '               ','               ','               ',  *
               'DEV INT CK',' BIT 1','CAP/EN CK','FX HDS INST',        *
               'HSA SQ LH 1'
         SPACE 2
         LINE
         BIN   SNB82
         BIN   SNB92
         BIN   SNB102
         BIN   SNB112
         BIN   SNB122
         BIN   SNB132
         BIN   SNB142
         BIN   SNB152
         LABEL '               ','               ','               ',  *
               'DRIVE CHECK','BIT 2','WR OVERRUN',                     *
               'SCTR CMP CK','HDA SQ LH 2'
         SPACE 2
         LINE
         BIN   SNB83
         BIN   SNB93
         BIN   SNB103
         BIN   SNB113
         BIN   SNB123
         BIN   SNB133
         BIN   SNB143
         BIN   SNB153
         LABEL '               ','               ','               ',  *
               'R/W CHECK','BIT 3','INDEX CHECK','WRITE MODE',         *
               'CE DR SW ON'
         SPACE 2
         LINE
         BIN   SNB84
         BIN   SNB94
         BIN   SNB104
         BIN   SNB114
         BIN   SNB124
         BIN   SNB134
         BIN   SNB144
         BIN   SNB154
         LABEL '               ','               ','               ',  *
               'ON LINE','BIT 4','CONTROL NK','ERROR BIT','SEL PLL GD'
         SPACE 2
         LINE
         BIN   SNB85
         BIN   SNB95
         BIN   SNB105
         BIN   SNB115
         BIN   SNB125
         BIN   SNB135
         BIN   SNB145
         BIN   SNB155
         ROUTINE SNB120,LABB5
         LABEL '               ','               ','               ',  *
               'HDA ATTNTN','BIT 5','SELECT ER','NO SEL ER',           *
               'DC VOLT GD'
         SPACE 2
         LINE
         BIN   SNB86
         BIN   SNB96
         BIN   SNB106
         BIN   SNB116
         BIN   SNB126
         BIN   SNB136
         BIN   SNB146
         BIN   SNB156
         ROUTINE SNB120,LABB6
         LABEL '               ','               ','               ',  *
               'B/N SCT CMP','DEV BSOT PC',                            *
               'HDA WR CK','HDA READ CK','AIR SYS GD'
         SPACE 2
         LINE  ,,SKIP=3
         BIN   SNB87
         BIN   SNB97
         BIN   SNB107
         BIN   SNB117
         BIN   SNB127
         BIN   SNB137
         BIN   SNB147
         BIN   SNB157
         ROUTINE SNB120,LABB7
         LABEL '               ','               ','               ',  *
               'S DONE/SRCH','DEV TGBS PC','DECODE CK','TRNS DET CK',  *
               'UNSL PLL GD'
         SPACE 2
         LINE  (12,15),(3,15),SKIP=1
         ROUTINE SNB160,SETHEX
         ROUTINE SNB170,SETHEX
         ROUTINE SNB180,SETHEX
         ROUTINE SNB190,SETHEX
         ROUTINE SNB200,SETHEX
         ROUTINE SNB210,SETHEX
         ROUTINE SNB220,SETHEX
         ROUTINE SNB230,SETHEX
         LABEL 'BYTE 16','BYTE 17','BYTE 18','BYTE 19','BYTE 20','BYTE C
               21','BYTE 22','BYTE 23'
         SPACE 2
         LINE  ,(1,15),SKIP=2
         LABEL 'SNS SVO STA1','SNS SVO STA2','SNS DF H/CAL','SNS DF L/O*
               F','SNS TGT REG','ATCH MPM DT ER','--------SYMPTOM CODE-*
               -------'
         SPACE 2
         LINE  (2,15),(1,15),SKIP=1
         ROUTINE SNB160,SETBIN1
         ROUTINE SNB170,SETBIN1
         ROUTINE SNB180,SETBIN1
         ROUTINE SNB190,SETBIN1
         ROUTINE SNB200,SETBIN1
         ROUTINE SNB210,SETBIN
         ROUTINE SNB220,SETBIN
         ROUTINE SNB230,SETBIN
         LABEL 'ACC TIMEOUT','GDBANK PTTN','DIRCTN BIT','DIF/OFF 128', *
               'TGT REG 128'
         SPACE 2
         LINE  (13,15)
         BIN   SNB161
         BIN   SNB171
         BIN   SNB181
         BIN   SNB191
         BIN   SNB201
         LABEL 'OVRSHOOT CK','GB2/ID','DIF CNT 512','DIF/OFF  64','TGT *
               REG  64'
         SPACE 2
         LINE
         BIN   SNB162
         BIN   SNB172
         BIN   SNB182
         BIN   SNB192
         BIN   SNB202
         LABEL 'SRVO OFF TK','TK CRSS LCH','DIF CNT 256','DIF/OFF  32',*
               'TGT REG  32'
         SPACE 2
         LINE
         BIN   SNB163
         BIN   SNB173
         BIN   SNB183
         BIN   SNB193
         BIN   SNB203
         LABEL 'INVLD LCTN ','VEL PLR LCH','BIT 3 ','DIF/OFF  16','TGT *
               REG  16'
         SPACE 2
         LINE
         BIN   SNB164
         BIN   SNB174
         BIN   SNB184
         BIN   SNB194
         BIN   SNB204
         LABEL 'SEQ LATCH 8','EVEN TRACK','BIT 4 ','DIF/OFF   8','TGT R*
               EG   8'
         SPACE 2
         LINE
         BIN   SNB165
         BIN   SNB175
         BIN   SNB185
         BIN   SNB195
         BIN   SNB205
         LABEL 'SEQ LATCH 4','FINE TRACK ','BIT 5 ','DIF/OFF   4','TGT *
               REG   4'
         SPACE 2
         LINE
         BIN   SNB166
         BIN   SNB176
         BIN   SNB186
         BIN   SNB196
         BIN   SNB206
         LABEL 'SEQ LATCH 2','END ACCELER','BIT 6 ','DIF/OFF   2','TGT *
               REG   2'
         SPACE 2
         LINE  ,,SKIP=3
         BIN   SNB167
         BIN   SNB177
         BIN   SNB187
         BIN   SNB197
         BIN   SNB207
         LABEL 'SEQ LATCH 1','END DECCELR','BIT 7','DIF/OFF   1','TGT R*
               EG   1'
         SPACE 2
         ETEPILOG  RLEN=70
         END
