***********************************************************************
**                                                                   **
**                           IFCENFP2                                **
**                                                                   **
**       THIS EDIT TABLE PROVIDES SUPPORT FOR FBA2 DASD DEVICES. IT  **
**    IS CALLED BY IFCEEDIT AT THE REQUEST OF IFCEWOD1 WHEN FBA2     **
**    FORMAT 2 IS INDICATED.  IT SUPPLIES THE FORMAT FOR SENSE       **
**    BYTES 8-23.                                                    **
**       THE DETAIL FORMAT OF THE OBR RECORD IS SUPPLIED AS FIGURE   **
**    44 IN PART 4 OF "OS/VS ENVIRONMENTAL RECORDING EDITING AND     **
**    PRINTING (EREP) PROGRAM" (PUB. NO. GC28-0772).                 **
**                                                                   **
**-------------------------------------------------------------------**
**                                                                   **
**                      REGISTER ASSIGNMENT                          **
**    GPR #                USE                                       **
**    2            START OF OBR RECORD                               **
**    3            CURRENT CHARACTER POSITION IN PRINT BUFFER        **
**    4            @ DATA ITEM SPECIFIED IN ROUTINE MACRO            **
**    5-8          WORK REGISTERS FOR SPECIAL ROUTINES               **
**    9            BASE REGISTER FOR IFCENFP2                        **
**    14           RETURN POINT FROM SPECIAL ROUTINES                **
**    15           SET TO 0 TO SUPPRESS PRINT OF CURRENT LINE        **
**                                                                   **
***********************************************************************
         GBLC  &DSECT,&CSECT
IFCENFP2 CSECT
&CSECT   SETC  'IFCENFP2'
&DSECT   SETC  'NFP2'
*
*        SENSE FORMAT 1
*
NFP2     DSECT
         DSGEN (CLASRC,8),(SYSREL,8),(SWITCHES,16)
         DSGEN (SPARE1,32)
         DSGEN (DAY,32)
         DSGEN (HOUR,32)
         DSGEN (SPARE2,8),(CPUSERL,24)
         DSGEN (CPUID,16),(SPARE3,16)
         DSGEN (JOBID1,32)
         DSGEN (JOBID2,32)
         DSGEN (FCCWCC,8),(FCCWDA,24)
         DSGEN (FCCWFL,8),(FCCW,8),(FCCWCT,16)
         DSGEN (CSWUS1,8),(CSWUS2,24)
         DSGEN (CSWUS3,8),(CSWUS4,8),(CSWUS5,16)
         DSGEN (DEVDPD,8),(SECCUA,24)
         DSGEN (DEVTYP1,16),(DEVTYP2,16)
         DSGEN (SPARE4,8),(CUA,24)
         DSGEN (IORET,16),(SBCNT,16)
         DSGEN (VOLLAB1,8),(VOLLAB2,16),(VOLLAB3,8)
         DSGEN (VOLLAB4,8),(VOLLAB5,8),(SPARE5,16)
         DSGEN (LSKAD1,8),(LSKAD2,16),(LSKAD3,8)
         DSGEN (LSKAD4,8),(LSKAD5,16),(LSKAD6,8)
         DSGEN (AHA1,32)
         DSGEN (AHA2,16),(SPARE6,16)
         DSGEN (SNB,1,0,23,0,7)
         EJECT
IFCENFP2 CSECT
         USING *,R9
         USING NFP2,R2
R0       EQU   0
R1       EQU   1
R2       EQU   2
R3       EQU   3
R4       EQU   4
R5       EQU   5
R6       EQU   6
R7       EQU   7
R8       EQU   8
R9       EQU   9
R10      EQU   10
R11      EQU   11
R12      EQU   12
R13      EQU   13
R14      EQU   14
R15      EQU   15
*
L0       EQU   0
L1       EQU   1
L2       EQU   2
L3       EQU   3
L4       EQU   4
L5       EQU   5
L6       EQU   6
L7       EQU   7
L8       EQU   8
L9       EQU   9
L10      EQU   10
L11      EQU   11
L12      EQU   12
L13      EQU   13
L14      EQU   14
L15      EQU   15
L16      EQU   16
L17      EQU   17
L18      EQU   18
L19      EQU   19
L20      EQU   20
L23      EQU   23
L24      EQU   24
L26      EQU   26
H0F      EQU   X'0F'
HE0      EQU   X'E0'
H80      EQU   X'80'
H40      EQU   X'40'
H20      EQU   X'20'
H10      EQU   X'10'
H21      EQU   X'21'
H23      EQU   X'23'
H25      EQU   X'25'
H29      EQU   X'29'
CLRSGN   EQU   X'F0'
HFF      EQU   X'FF'
         EJECT
         DC    A(ENTRIES)
         DC    CL8'IFCENFP2'
XR9PTR   DC    F'0'
XLABELP  DC    F'0'
***********************************************************************
**                                                                   **
**                        SPECIAL ROUTINES                           **
**                                                                   **
**===================================================================**
*
*        SET HEX -PRINTS 1 CHAR HEX
*
SETHEX   STM   R5,R8,XSAVE             SAVE REGS
         LA    R8,CHARS                CHARACTER TABLE POINTER
         IC    R7,L0(R4)               PICK UP CHARACTER
         SLL   R7,L24                  MOVE TO HI R7
         SR    R6,R6                   CLEAR REGS
         SLDL  R6,L4                   MOVE FOUR BITS
         AR    R6,R8                   ADD OFFSET AND POINTER
         MVC   L0(L1,R3),L0(R6)        MOVE CHARACTER TO LINE
         SR    R6,R6                   CLEAR AGAIN
         SLDL  R6,L4                   MOVE LAST 4 BITS
         AR    R6,R8                   COMPUTE OFFSET
         MVC   L1(L1,R3),L0(R6)        MOVE LAST CHARACTER
         B     RETURN
         SPACE 2
*
*        TEST TO SEE IF RECORD IS IN AR-149 FORMAT
*
SETCONV  TM    L0(R4),HEX02            HAS RECORD BEEN CONVERTED KEY32
         BCR   ON,R14                  YES RETURN
         SR    R15,R15                 NO CLEAR R15 FOR NO PRINT OF
         BR    R14                     LINE
ON       EQU   1
HEX02    EQU   X'02'
         SPACE 2
*
*        NO OP RETURN
*
SKIPPER  BR    R14
         SPACE 2
*
*        TO ADD SPACES ON LINE
*
SPACER2  LA    R3,L4(R3)
         BR    14
         SPACE 2
*
*        RESTORE REGISTERS USED BY ROUTINES IN THIS MODULE
*
RETURN   LM    R5,R8,XSAVE             RESTORE REGS
         BR    R14                     RETURN
         SPACE 2
*
*        SET BINARY WITH R4 POINTING TO THE CHAR
*
SETBIN   STM   R5,R8,XSAVE             SAVE REGS
         ICM   R7,X'8',L0(R4)      PICK UP CHAR TO PRINT
         LR    R8,R3                   PRINT POS POINTER TO REG8
         LA    R5,L8                   LOOP COUNT
SETBINA  SR    R6,R6                   CLEAR REG 6
         SLDL  R6,L1                   MOVE BIT TO R6
         STC   R6,L0(R8)               PUT IT INTO PRINT LINE
         MVZ   L0(L1,R8),CHAR0
         LA    R8,L1(R8)               MOVE POINTER TO NEXT POS
         BCT   R5,SETBINA              LOOP TILL 8 PRINTED
         B     RETURN
         SPACE 2
SETBIN1  STM   R5,R8,XSAVE             SAVE REGS
         ICM   R7,X'8',L0(R4)          PICK UP CHAR TO PRINT
         LR    R8,R3                   PRINT POS POINTER TO REG 8
         SR    R6,R6                   CLEAR REG 6
         SLDL  R6,L1                   MOVE BIT TO REG 6
         STC   R6,L11(R8)
         OC    L11(L1,R8),CHAR0
         B     RETURN                  RETURN
         SPACE 2
*        CONVERT COUNTERS FROM HEX TO DECIMAL READY FOR PRINT
*
CONV1    STM   R5,R8,XSAVE             SAVE REGISTERS
         XC    READYP(L8),READYP       CLEAR UNPACK BUFFER
         SR    R6,R6                   ZERO REG
         LH    R6,L0(R4)               LOAD DATA TO BE CONVERTED
         CVD   R6,READYP               CONVERT ERROR COUNTER TO DECI
         UNPK  READYP(L5),READYP+L5(L3)  UNPACK DECI COUNT
         OI    READYP+L4,CLRSGN        CLEAR SIGN
         MVC   L0(L4,R3),READYP+L1     MOVE COUNTER READY TO PRINT
         B     RETURN
         SPACE 2
         DS    0F
XSAVE    DC    5F'0'
NONE     DC    CL6'NONE  '
CHARS    DC    C'0123456789ABCDEF'
CHAR0    DC    C'0'
**-------------------------------------------------------------------**
**                             PATCH AREA                            **
         DC    S(PATCH)
PATCH    DC    CL50' '
**-------------------------------------------------------------------**
         EJECT
         DS    0D
READYP   DC    CL8' '
ENTRIES  DS    0F
         DC    XL4'00010001'       FORMAT 1
         DC    XL4'00010001'       FORMAT 2
         DC    A(LABELS)           LABEL POINTER
         DC    H'0'                DISP
*
*        SKIP TO CHANNEL 1
*
         DC    X'01'
         DC    X'000B0B00'
         SPACE 5
         LINE  (12,15),(3,15),SKIP=1
         ROUTINE   SNB80,SETHEX
         ROUTINE   SNB90,SETHEX
         ROUTINE   SNB100,SETHEX
         ROUTINE   SNB110,SETHEX
         ROUTINE   SNB120,SETHEX
         ROUTINE   SNB130,SETHEX
         ROUTINE   SNB140,SETHEX
         ROUTINE   SNB150,SETHEX
         LABEL 'BYTE 8','BYTE 9','BYTE 10','BYTE 11','BYTE 12','BYTE 13C
               ','BYTE 14','BYTE 15'
         SPACE 2
         LINE  ,(1,15),SKIP=2
         LABEL 'XFR CPLT STAT','XFR ER STAT ','CHECK REG   ','CHL XFR CC
               TRL ','CHL CTL REG 2','DEV BUS OUT  ','DEV BUS IN   ',  *
               'DEV TAG OUT'
         SPACE 2
         LINE  (2,15),(1,15),SKIP=1
         ROUTINE SNB80,SETBIN1
         ROUTINE SNB90,SETBIN1
         ROUTINE SNB100,SETBIN1
         ROUTINE SNB110,SETBIN1
         ROUTINE SNB120,SETBIN1
         ROUTINE SNB130,SETBIN1
         ROUTINE SNB140,SETBIN1
         ROUTINE SNB150,SETBIN1
         LABEL 'CHECK 2   ','DEV OVERRUN ','PAD CNT CK ','SERVICE IN ',*
               'PRP SEL OUT','DBO BIT 0  ','DBI BIT 0 ','TAG OUT 0'
         SPACE 2
         LINE  (13,15)
         BIN   SNB81
         BIN   SNB91
         BIN   SNB101
         BIN   SNB111
         BIN   SNB121
         BIN   SNB131
         BIN   SNB141
         BIN   SNB151
         LABEL 'BAP HOB RD','CHL OVERRUN ','DCT CARD CK','SEARCH HIGH',*
               'READ ADR SW','DBO BIT 1','DBI BIT 1','TAG OUT 1'
         SPACE 2
         LINE
         BIN   SNB82
         BIN   SNB92
         BIN   SNB102
         BIN   SNB112
         BIN   SNB122
         BIN   SNB132
         BIN   SNB142
         BIN   SNB152
         LABEL 'CTL END XFR','CTLI CHECK ','CSR CD CK 2','SEARCH EQ ', *
               'BIT 2      ','DBO BIT 2','DBI BIT 2','TAG OUT 2'
         SPACE 2
         LINE
         BIN   SNB83
         BIN   SNB93
         BIN   SNB103
         BIN   SNB113
         BIN   SNB123
         BIN   SNB133
         BIN   SNB143
         BIN   SNB153
         LABEL 'BIT 3     ','CLOCK CK 2','CHL DATA CK','READ CBI',     *
               'BIT 3      ','DBO BIT 3','DBI BIT 3','BIT 3'
         SPACE 2
         LINE
         BIN   SNB84
         BIN   SNB94
         BIN   SNB104
         BIN   SNB114
         BIN   SNB124
         BIN   SNB134
         BIN   SNB144
         BIN   SNB154
         LABEL 'CDX END XFR','CTLI CD CK ','BIT 4     ','SET SPD REG', *
               'CHL SW LOCK','DBO BIT 4','DBI BIT 4','BIT 4'
         SPACE 2
         LINE
         BIN   SNB85
         BIN   SNB95
         BIN   SNB105
         BIN   SNB115
         BIN   SNB125
         BIN   SNB135
         BIN   SNB145
         BIN   SNB155
         LABEL 'CMPR SUCC','SYNC IN CK','BIT 5     ','ALW RUN CHL',    X
               'BIT 5      ','DBO BIT 5','DBI BIT 5','BIT 5'
         SPACE 2
         LINE
         BIN   SNB86
         BIN   SNB96
         BIN   SNB106
         BIN   SNB116
         BIN   SNB126
         BIN   SNB136
         BIN   SNB146
         BIN   SNB156
         LABEL '1ST SYNC IN','ADT INTF CK','BIT 6     ','XFR FROM CH', *
               'CH SEL BIT2','DBO BIT 6','DBI BIT 6','BIT 6'
         SPACE 2
         LINE  ,,SKIP=3
         BIN   SNB87
         BIN   SNB97
         BIN   SNB107
         BIN   SNB117
         BIN   SNB127
         BIN   SNB137
         BIN   SNB147
         BIN   SNB157
         LABEL 'CHL TRUNC ','ADT CARD CK','BIT 7     ','RUN CHANNEL',  *
               'CH SEL BIT1','DBO BIT 7','DBI BIT 7','BIT 7'
         SPACE 2
         LINE  (12,15),(3,15),SKIP=1
         ROUTINE   SNB160,SETHEX
         ROUTINE   SNB170,SETHEX
         ROUTINE   SNB180,SETHEX
         ROUTINE   SNB190,SETHEX
         ROUTINE   SNB200,SETHEX
         ROUTINE   SNB210,SETHEX
         ROUTINE   SNB220,SETHEX
         ROUTINE   SNB230,SETHEX
         LABEL 'BYTE 16','BYTE 17','BYTE 18','BYTE 19','BYTE 20','BYTE C
               21','BYTE 22','BYTE 23'
         SPACE 2
         LINE  ,(1,15),SKIP=2
         LABEL 'DEV TAG GATE','DEV TAG IN','---UNUSED----','---UNUSED--*
               --','---UNUSED----','STG DIR ID','--------SYMPTOM CODE--*
               ------'
         SPACE 2
         LINE  (2,15),(1,15),SKIP=1
         ROUTINE SNB160,SETBIN1
         ROUTINE SNB170,SETBIN1
         ROUTINE SNB180,SETBIN
         ROUTINE SNB190,SETBIN
         ROUTINE SNB200,SETBIN
         ROUTINE SNB210,SETBIN
         ROUTINE SNB220,SETBIN
         ROUTINE SNB230,SETBIN
         LABEL 'SELECT HOLD','SEL ACTIVE'
         SPACE 2
         LINE  (13,15),(1,15)
         BIN   SNB161
         BIN   SNB171
         LABEL 'TAG GATE','TAG VALID'
         SPACE 2
         LINE
         BIN   SNB162
         BIN   SNB172
         LABEL 'RESP GATE','CHECK END'
         SPACE 2
         LINE
         BIN   SNB163
         BIN   SNB173
         LABEL 'RST IDC LTH','CE ALERT'
         SPACE 2
         LINE
         BIN   SNB164
         BIN   SNB174
         LABEL 'INH 1ST DEC','NORMAL END'
         SPACE 2
         LINE
         BIN   SNB165
         BIN   SNB175
         LABEL 'CTL  BIT 0','DEV ALERT'
         SPACE 2
         LINE
         BIN   SNB166
         BIN   SNB176
         LABEL 'CTL  BIT 1','INDEX LATCH'
         SPACE 2
         LINE  ,,SKIP=2
         BIN   SNB167
         BIN   SNB177
         LABEL 'RUN DEVICE','ERROR ALERT'
         SPACE 2
         ETEPILOG RLEN=70
         END
