         TITLE 'IFCERFMT IN-STORAGE LOGREC BUFFER FORMAT MODULE'
IFCERFMT CSECT ,                                                   0001
@MAINENT DS    0H                                                  0001
         USING *,@15                                               0001
         B     @PROLOG                                             0001
         DC    AL1(16)                                             0001
         DC    C'IFCERFMT  78.297'                                 0001
         DROP  @15
@PROLOG  STM   @14,@12,12(@13)                                     0001
         BALR  @12,0                                               0001
@PSTART  DS    0H                                                  0001
         USING @PSTART,@12                                         0001
         L     @00,@SIZDATD                                        0001
         GETMAIN  R,LV=(0)
         LR    @03,@01                                             0001
         LA    @10,4095(,@03)                                      0001
         LA    @11,4095(,@10)                                      0001
         USING @DATD,@03                                           0001
         USING @DATD+4095,@10                                      0001
         USING @DATD+8190,@11                                      0001
         ST    @13,@SA00001+4                                      0001
         LM    @00,@01,20(@13)                                     0001
         ST    @03,8(,@13)                                         0001
         LR    @13,@03                                             0001
*                                                                  0140
*/********************************************************************/
*/* FUNCTION-                                                      0140
*       ROUTINE TO SET UP THE ESTAE, DETERMINES IF THE RUNNING SYSTEM
*     HAS THE EREP ENHANCEMENT SU, FILLS IN THE EREP COMMUNICATIONS
*     TABLE, AND PASSES CONTROL TO EREP TO EDIT THE RECORDS, IF ALL
*     THE RECORDS WERE FOUND WITHOUT PROBLEM.                      0140
*                                                                  0140
*       MESSAGES ISSUED BY THIS ROUTINE ARE:                       0140
*                                                                  0140
*               *** IN STORAGE LOGREC BUFFER NOT FORMATTED, EREP   0140
*                   ENHANCEMENT SU NOT AVAILABLE ON SYSTEM ***     0140
*          (IF SU 27 IS NOT ON THE SYSTEM)                         0140
*                                                                  0140
*               *** IN STORAGE LOGREC BUFFER NOT FORMATTED, PARAMETER
*                   LIST DID NOT CONTAIN NECESSARY INFORMATION *** 0140
*          (IF THE CVT POINTER IS ZERO)                            0140
*                                                                  0140
*               *** LOGDATA FORMATTING OMITTED, DUMP IS NOT FROM AN
*                   MVS SYSTEM ***                                 0140
*          (IF THE OPERATING SYSTEM FLAGS COULD NOT BE ACCESSED OR IF
*           THE SYSTEM IS NOT MVS)                                 0140
*                                                                  0140
*               *** IN-STORAGE LOGREC BUFFER NOT FORMATTED, DATA   0140
*                   NECESSARY TO LOCATE THE BUFFER UNAVAILABLE *** 0140
*          (IF THE RTCT COULD NOT BE ACCESSED OR THE ADDRESS IS    0140
*           NOT ON A 4K BOUNDARY)                                  0140
*                                                                  0140
*                                                                  0140
*    CALLS-                                                        0140
*         ACCESRTN, CPUID, DEBLOCK, IFCEDSUM, AND PRINT            0140
*                                                                  0140
*    CALLED BY -                                                   0140
*         AMDPRDMP WHEN THE LOGDATA VERB IS ENCOUNTERED            0140
*                                                                  0140
*    RETURNS TO -                                                  0140
*         CALLER WITH A RETURN CODE OF ZERO                        0140
*                                                                    */
*/********************************************************************/
*                                                                  0140
*   /*****************************************************************/
*   /*                                                               */
*   /* ESTABLISH THE ESTAE                                           */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0140
*   ESTAERR=ZERO;                   /* TURN OFF ESTAE BITS   @ZM45067*/
         SLR   @14,@14                                             0140
         ST    @14,ESTAERR                                         0140
*   STM(VADR,RCREG,RTYREGS);        /* SAVE REGS TO BE USED IN THE 0141
*                                      ESTAE                 @ZM45067*/
         STM   VADR,RCREG,RTYREGS                                  0141
*   SAVEREG1=ABDPLPTR;              /* SAVE REGISTER 1 ACCESS THE  0142
*                                      ESTAE                         */
         LR    SAVEREG1,ABDPLPTR                                   0142
*   ESTAEXEC(1:ESTALEN)=ESTALIST(1:ESTALEN);/* MOVE LIST INTO      0143
*                                      AUTOMATIC AREA                */
         L     @14,ESTALEN                                         0143
         BCTR  @14,0                                               0143
         EX    @14,@SM02572                                        0143
*   GEN FLOWS(ESTAERTN)(ESTAE ESTAERTN,PARAM=(DREG),MF=(E,ESTAEXEC));
         ESTAE ESTAERTN,PARAM=(DREG),MF=(E,ESTAEXEC)
*                                   /* THE PARM, FOR THIS ESTAE,   0145
*                                      POINTS TO ALL THE AUTOMATIC 0145
*                                      DATA FOR THIS MODULE          */
*   IF RCREG=ZERO THEN              /* ESTAE RESOLVED FINE           */
         LTR   RCREG,RCREG                                         0145
         BNZ   @RF00145                                            0145
*     DO;                                                          0146
*       ABDPLPTR=SAVEREG1;          /* RESTORE REGISTER 1            */
         LR    ABDPLPTR,SAVEREG1                                   0147
*       EREPBUF=BUFFER;             /* USE PRINT DUMPS BLANK BUFFER
*                                      TO BLANK OUT EREPS OUTPUT   0148
*                                      BUFFER                        */
*                                                                  0148
         MVI   EREPBUF+120,C' '                                    0148
         MVC   EREPBUF+121(13),EREPBUF+120                         0148
         L     @14,ADPLBUF(,ABDPLPTR)                              0148
         MVC   EREPBUF(120),BUFFER(@14)                            0148
*       /*************************************************************/
*       /*                                                           */
*       /* PUT OUT HEADER                                            */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0149
*       CALL PRINT;                 /* BLANK LINE                    */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0149
         BALR  @14,@15                                             0149
*       BUFFER(51:LENGTH(HDRLINE)+50)=HDRLINE;/* LOGDATA HDR         */
         L     @14,ADPLBUF(,ABDPLPTR)                              0150
         MVC   BUFFER+50(31,@14),HDRLINE                           0150
*       CALL PRINT;                 /* PRINT IT                      */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0151
         BALR  @14,@15                                             0151
*       CALL PRINT;                 /* SPACE A LINE                  */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0152
         BALR  @14,@15                                             0152
*       CALL PRINT;                 /* SPACE A LINE                  */
*                                                                  0153
         L     @15,ADPLPRNT(,ABDPLPTR)                             0153
         BALR  @14,@15                                             0153
*       /*************************************************************/
*       /*                                                           */
*       /* CHECK IF EREP ENHANCEMENT SU IS ON THE RUNNING SYSTEM,    */
*       /* (NOT THE SYSTEM ON WHICH THE DUMP WAS TAKEN               */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0154
*       CVTPTR=LOC16;               /* REAL RUNNING SYSTEM CVT ADDR  */
         L     CVTPTR,LOC16                                        0154
*       IF SU27BIT=OFF THEN         /* EREP ENHANCEMENT SU NOT ON  0155
*                                                              SYSTEM*/
         L     @14,CVTIHASU(,CVTPTR)                               0155
         TM    SU27BIT(@14),B'00010000'                            0155
         BNZ   @RF00155                                            0155
*         BUFFER(1:LENGTH(NOSU27))=NOSU27;/* ERROR MESSAGE           */
         L     @14,ADPLBUF(,ABDPLPTR)                              0156
         MVC   BUFFER(91,@14),NOSU27                               0156
*       ELSE                        /* EREP ENHANCEMENT IS ON SYSTEM */
*         DO;                                                      0157
*                                                                  0157
         B     @RC00155                                            0157
@RF00155 DS    0H                                                  0158
*           /*********************************************************/
*           /*                                                       */
*           /* CHECK IF A CVT ADDRESS WAS PASSED IN THE PARMLIST     */
*           /*                                                       */
*           /*********************************************************/
*                                                                  0158
*           IF ADPLCVT=ZERO THEN    /* NO CVT ADDRESS PASSED         */
         ICM   @14,15,ADPLCVT(ABDPLPTR)                            0158
         BNZ   @RF00158                                            0158
*             BUFFER(1:LENGTH(NOINF))=NOINF;/* ERROR MESSAGE         */
         L     @14,ADPLBUF(,ABDPLPTR)                              0159
         MVC   BUFFER(100,@14),NOINF                               0159
*           ELSE                    /* A CVT IS PASSED               */
*             DO;                                                  0160
*                                                                  0160
         B     @RC00158                                            0160
@RF00158 DS    0H                                                  0161
*               /*****************************************************/
*               /*                                                   */
*               /* DETERMINE IF THE SYSTEM ON WHICH THE DUMP WAS     */
*               /* TAKEN WAS AN MVS SYSTEM                           */
*               /*                                                   */
*               /*****************************************************/
*                                                                  0161
*               CVTPTR=ADPLCVT;     /* REFERENCED CVT IS NOW THE DUMP
*                                      CVT                           */
         L     CVTPTR,ADPLCVT(,ABDPLPTR)                           0161
*               VADR=ADDR(CVTDCB);  /* OPERATING SYSTEM FLAGS        */
         LA    VADR,CVTDCB(,CVTPTR)                                0162
*               CALL ACCESRTN;      /* ACCESS IT                     */
         BAL   @14,ACCESRTN                                        0163
*               IF RCREG^=ZERO THEN /* ACCESS ERROR                  */
         LTR   RCREG,RCREG                                         0164
         BZ    @RF00164                                            0164
*                 BUFFER(1:LENGTH(INCOMP))=INCOMP;/* ERROR MSG       */
         L     @14,ADPLBUF(,ABDPLPTR)                              0165
         MVC   BUFFER(66,@14),INCOMP                               0165
*               ELSE                /* FOUND OPERATING SYSTEM FLAGS  */
*                 DO;                                              0166
         B     @RC00164                                            0166
@RF00164 DS    0H                                                  0167
*                   IF ADPLSYTM=ON|(DATABYTE&LOWBIT)^=LOWBIT THEN/*
*                                      NOT AN MVS SYSTEM             */
         TM    ADPLSYTM(ABDPLPTR),B'01000000'                      0167
         BO    @RT00167                                            0167
         SLR   @14,@14                                             0167
         IC    @14,LOWBIT                                          0167
         SLR   @08,@08                                             0167
         IC    @08,DATABYTE(,DATAPTR)                              0167
         NR    @08,@14                                             0167
         CR    @08,@14                                             0167
         BE    @RF00167                                            0167
@RT00167 DS    0H                                                  0168
*                     BUFFER(1:LENGTH(INCOMP))=INCOMP;/* ERROR     0168
*                                      MESSAGE                       */
         L     @14,ADPLBUF(,ABDPLPTR)                              0168
         MVC   BUFFER(66,@14),INCOMP                               0168
*                   ELSE            /* IS AN MVS SYSTEM              */
*                     DO;                                          0169
*                                                                  0169
         B     @RC00167                                            0169
@RF00167 DS    0H                                                  0170
*                       /*********************************************/
*                       /*                                           */
*                       /* LOCATE THE IN-STORAGE LOGREC BUFFER THE   */
*                       /* BUFFER CONSISTS OF THREE PARTS, THE RCB   */
*                       /* WHICH IS THE HEADER FOR THE BUFFER. IT    */
*                       /* INDICATES THE BEGINNING ADDRESS OF THE    */
*                       /* BUFFER, THE END ADDRESS, AND THE POINTER  */
*                       /* TO THE FIRST FREE ADDRESS. BEFORE EACH    */
*                       /* ENTRY IN THE BUFFER, THERE ARE TWO        */
*                       /* HEADERS. THE FIRST, THE BEHDR, HAS CONTROL*/
*                       /* INFORMATION ABOUT THE RECORD. THE         */
*                       /* SECOND,THE LRB, HAS INFORMATION ABOUT THE */
*                       /* LOGREC ENTRY ITSELF.                      */
*                       /*                                           */
*                       /*********************************************/
*                                                                  0170
*                       VADR=ADDR(CVTRTMCT);/* PTR TO RTCT           */
         LA    VADR,CVTRTMCT(,CVTPTR)                              0170
*                       CALL ACCESRTN;/* ACCESS IT                   */
         BAL   @14,ACCESRTN                                        0171
*                       IF RCREG^=ZERO THEN/* COULD NOT ACCESS CVT   */
         LTR   RCREG,RCREG                                         0172
         BZ    @RF00172                                            0172
*                         BUFFER(1:LENGTH(LOCERR))=LOCERR;/* ERROR 0173
*                                      MESSAGE                       */
         L     @14,ADPLBUF(,ABDPLPTR)                              0173
         MVC   BUFFER(95,@14),LOCERR                               0173
*                       ELSE        /* FOUND RTCT PTR                */
*                         DO;                                      0174
         B     @RC00172                                            0174
@RF00172 DS    0H                                                  0175
*                           RTCTPTR=DATAWORD;/* SAVE THE RTCT ADDRESS*/
         L     @14,DATAWORD(,DATAPTR)                              0175
         ST    @14,RTCTPTR                                         0175
*                           VADR=ADDR(RTCTRCB);/* PTR TO IN-STORAGE
*                                      LOGREC BUFFER                 */
         LA    VADR,RTCTRCB(,@14)                                  0176
*                           CALL ACCESRTN;/* ACCESS IT               */
         BAL   @14,ACCESRTN                                        0177
*                           IF(RCREG^=ZERO)|((DATAWORD&FOURKBDY)^= 0178
*                               DATAWORD) THEN/* EITHER THE RTCT   0178
*                                      COULD NOT BE ACCESSED OR THE
*                                      POINTER TO THE BUFFER IS BAD  */
         LTR   RCREG,RCREG                                         0178
         BNZ   @RT00178                                            0178
         L     @14,DATAWORD(,DATAPTR)                              0178
         LR    @08,@14                                             0178
         N     @08,FOURKBDY                                        0178
         CLR   @08,@14                                             0178
         BE    @RF00178                                            0178
@RT00178 DS    0H                                                  0179
*                             BUFFER(1:LENGTH(LOCERR))=LOCERR;/*   0179
*                                      ERROR MESSAGE                 */
         L     @14,ADPLBUF(,ABDPLPTR)                              0179
         MVC   BUFFER(95,@14),LOCERR                               0179
*                           ELSE    /* FOUND IN-STORAGE LOGREC BUFFER*/
*                             DO;                                  0180
         B     @RC00178                                            0180
@RF00178 DS    0H                                                  0181
*                               RECPTR=DATAWORD;/* SAVE BUFFER     0181
*                                      ADDRESS                       */
         L     RECPTR,DATAWORD(,DATAPTR)                           0181
*                               CALL CPUID;/* DETERMINE THE VALID CPU
*                                      IDS                           */
         BAL   @14,CPUID                                           0182
*                               IF RCREG=ZERO THEN/* FOUND CPU IDS OK*/
         LTR   RCREG,RCREG                                         0183
         BNZ   @RF00183                                            0183
*                                 DO;                              0184
*                                   CALL DEBLOCK;/* ROUTINE TO     0185
*                                      DEBLOCK THE BUFFER AND FILL IN
*                                      THE SORT TABLE                */
         BAL   @14,DEBLOCK                                         0185
*                                   IF SORTINDX^=ZERO THEN/* THERE 0186
*                                      ARE RECORDS TO BE EDITED      */
         L     @14,SORTINDX                                        0186
         LTR   @14,@14                                             0186
         BZ    @RF00186                                            0186
*                                    DO;                           0187
*                                                                  0187
*                                     /*******************************/
*                                     /*                             */
*                                     /* FILL IN COMMUNICATIONS TABLE*/
*                                     /* FOR USE BY THE EREP MODULES */
*                                     /*                             */
*                                     /*******************************/
*                                                                  0188
*                                     PARMP1=''B;/* ZERO OUT FIRST 0188
*                                      PART OF TABLE                 */
         XC    PARMP1(255),PARMP1                                  0188
*                                     RFY                          0189
*                                      (PARMPTR) RSTD;/*     @G33DGVS*/
*                                     PARMPTR=LENGTH(PARM)-256;/*  0190
*                                                            @G33DGVS*/
         LA    PARMPTR,92                                          0190
*                                     PARM(PARMPTR:LENGTH(PARM))=PARM(
*                                         PARMPTR:LENGTH(PARM))&&PARM(
*                                         PARMPTR:LENGTH(PARM));/* 0191
*                                                            @G33DGVS*/
         LA    @08,PARM-1(PARMPTR)                                 0191
         LA    @07,348                                             0191
         SLR   @07,PARMPTR                                         0191
         EX    @07,@SX02574                                        0191
*                                     RFY                          0192
*                                      (PARMPTR) UNRSTD;/*   @G33DGVS*/
*                                     RECTYPE=ALLON;/* ALL RECORD  0193
*                                      TYPES WANTED                  */
         MVC   RECTYPE(2),ALLON                                    0193
*                                     DEBUG19=ON;/* BREAK FOR NEW  0194
*                                      EDIT TABLE AFTER EACH RECORD  */
         OI    DEBUG19,B'00010000'                                 0194
*                                     SHORTOBR=ON;/* SHORT OBR     0195
*                                      RECORDS WANTED                */
*                                     NOSDR=ON;/* DUMP OF SDR NOT  0196
*                                      WANTED                        */
         OI    SHORTOBR,B'00100001'                                0196
*                                     PEDIT=ON;/* RECORDS ARE TO BE
*                                      EDITED                        */
         OI    PEDIT,B'00010000'                                   0197
*                                     TABSIZE=LENGTH(SORTABLE);/*  0198
*                                      FILL IN SIZE OF THE SORT TABLE*/
         MVC   TABSIZE(4),@CF02569                                 0198
*                                     SORTNUM=SORTINDX;/* NUMBER OF
*                                      RECORDS FOR THE EDITOR TO   0199
*                                      FORMAT                        */
         ST    @14,SORTNUM                                         0199
*                                     ADIOHND=ADDR(IFCFMTIO);/* I/O
*                                      ROUTINE USED BY EREP          */
         L     @14,@CV02052                                        0200
         ST    @14,ADIOHND                                         0200
*                                     ADIFCMSG=ADDR(IFCMSG01);/* MSG
*                                      TEXTS                 @ZA35242*/
         L     @14,@CV02051                                        0201
         ST    @14,ADIFCMSG                                        0201
*                                     SORTADR=ADDR(SORTABLE);/* PTR
*                                      TO SORT TABLE                 */
         LA    @14,SORTABLE                                        0202
         ST    @14,SORTADR                                         0202
*                                     ADEDITB=ADDR(EDITLOAD);/* PTR
*                                      TO TABLE OF LOADS             */
         LA    @14,EDITLOAD                                        0203
         ST    @14,ADEDITB                                         0203
*                                     PRINTADR=ADDR(EREPBUF);/*    0204
*                                      OUTPUT BUFFER USED BY THE EREP
*                                      ROUTINES                      */
         LA    @14,EREPBUF                                         0204
         ST    @14,PRINTADR                                        0204
*                                     LINECT=PAGEMAX;/* SET NUM LINES
*                                      FOR PAGE                      */
         MVC   LINECT(2),@CH02078                                  0205
*                                     PDMPLIST=ABDPLPTR;/* SAVE PTR
*                                      TO IHAABDPL                   */
         ST    ABDPLPTR,PDMPLIST                                   0206
*                                     UNWRPBUF=ADDR(NEWBUF);/* SAVE
*                                      PTR TO READ BUFFER            */
         LA    @14,NEWBUF                                          0207
         ST    @14,UNWRPBUF                                        0207
*                                     ENDADR=BUFEND;/* END OF PRINT
*                                      DUMPS COPY OF THE IN-STORAGE
*                                      LOGREC BUFFER                 */
         MVC   ENDADR(4),BUFEND                                    0208
*                                     BEGINADR=BUFSTART;/* START OF
*                                      PRINT DUMPS COPY OF THE     0209
*                                      IN-STORAGE LOGREC BUFFER      */
         MVC   BEGINADR(4),BUFSTART                                0209
*                                     RFY                          0210
*                                      (PARMPTR) RSTD;             0210
*                                     PARMPTR=ADDR(PARM);/* PASS THE
*                                      COMMUNICATIONS TABLE ADDRESS
*                                      IN REG 2                      */
*                                                                  0211
         LA    PARMPTR,PARM                                        0211
*                                     /*******************************/
*                                     /*                             */
*                                     /* FORMAT ALL VALID ENTRIES IN */
*                                     /* THE LOGREC BUFFER. (NOTE    */
*                                     /* THAT IFCFMTIO WILL BE CALLED*/
*                                     /* BY THE EREP EDITOR TO PUT   */
*                                     /* EACH FORMATTED LINE AND     */
*                                     /* ERROR MESSAGE INTO THE DUMP */
*                                     /* OUTPUT                      */
*                                     /*                             */
*                                     /*******************************/
*                                                                  0212
*                                     GEN FLOWS(IFCEDSUM)          0212
*                                         (LINK EP=IFCEDSUM);      0212
         LINK EP=IFCEDSUM
*                                    END;/* END THERE ARE RECORDS FOR
*                                      EDIT                          */
*                                   ELSE                           0214
*                                    ;/* NO RECORDS TO BE EDITED     */
@RF00186 DS    0H                                                  0215
*                                 END;/* END FOUND CPU IDS OK        */
*                               ELSE                               0216
*                                 ; /* COULD NOT DETERMINE VALID CPU
*                                      IDS                           */
@RF00183 DS    0H                                                  0217
*                             END;  /* END FOUND IN STORAGE BUFFER   */
*                         END;      /* END FOUND RTCT PTR            */
@RC00178 DS    0H                                                  0219
*                     END;          /* END IS AN MVS SYSTEM          */
@RC00172 DS    0H                                                  0220
*                 END;              /* END FOUND OPERATING SYSTEM  0220
*                                      FLAGS                         */
@RC00167 DS    0H                                                  0221
*             END;                  /* END A CVT ADDRESS IS PASSED   */
@RC00164 DS    0H                                                  0222
*         END;                      /* END EREP ENHANCEMENT SU IS ON
*                                                              SYSTEM*/
@RC00158 DS    0H                                                  0223
*TROUBLE:                           /* PLACE TO RETRY AT             */
*       CALL PRINT;                 /* BLANK LINE OR ERROR MESSAGE   */
@RC00155 DS    0H                                                  0223
TROUBLE  L     @15,ADPLPRNT(,ABDPLPTR)                             0223
         BALR  @14,@15                                             0223
*       GEN(ESTAE 0);               /* DROP THE ESTAE                */
         ESTAE 0
*     END;                          /* END ESTAE RESOLVED FINE       */
*   ELSE                                                           0226
*     ;                             /* ERROR ESTABLISHING THE ESTAE  */
@RF00145 DS    0H                                                  0227
*   RFY                                                            0227
*    (PARMPTR) UNRSTD;                                             0227
*   RETURN CODE(0);                                                0228
         L     @13,4(,@13)                                         0228
         L     @00,@SIZDATD                                        0228
         LR    @01,@03                                             0228
         FREEMAIN R,LV=(0),A=(1)
         SLR   @15,@15                                             0228
         L     @14,12(,@13)                                        0228
         LM    @00,@12,20(@13)                                     0228
         BR    @14                                                 0228
*CPUID:                                                            0229
*   PROC OPTIONS(SAVE(14));                                        0229
*                                                                  0229
@EL00001 L     @13,4(,@13)                                         0229
@EF00001 L     @00,@SIZDATD                                        0229
         LR    @01,@03                                             0229
         FREEMAIN R,LV=(0),A=(1)
@ER00001 LM    @14,@12,12(@13)                                     0229
         BR    @14                                                 0229
CPUID    ST    @14,@SA00002                                        0229
*/********************************************************************/
*/* FUNCTION-                                                      0230
*        TO DETERMINE WHAT THE VALID CPU IDS ARE FOR THE DUMP SYSTEM,
*      IN ORDER TO LOCATE THE FIRST VALID RECORD IN THE IN-STORAGE 0230
*      LOGREC BUFFER. THIS ROUTINE IS CURRENTLY SET UP TO HANDLE ONLY
*      2 RUNNING CPUS.                                             0230
*                                                                  0230
*       MESSAGES ISSUED BY THIS ROUTINE ARE:                       0230
*                                                                  0230
*               *** IN STORAGE LOGREC BUFFER NOT FORMATTED, UNABLE 0230
*                   TO DETERMINE VALID CPU ID ***                  0230
*          (COULD NOT ACCESS PCCAVT OR THE PCCA)                   0230
*                                                                  0230
*                                                                  0230
*    CALLS-                                                        0230
*         ACCESRTN AND PRINT                                       0230
*                                                                  0230
*    CALLED BY -                                                   0230
*         MAINLINE TO DETERMINE THE VALID CPU IDS                  0230
*                                                                  0230
*    RETURNS TO -                                                  0230
*         CALLER WITH A RETURN CODE SET BY THE ACCESS SERVICE ROUTINE
*         OR BY THIS ROUTINE, IF THE PCCAVT PTR IS ZERO.             */
*/********************************************************************/
*                                                                  0230
*   /*****************************************************************/
*   /*                                                               */
*   /* ACCESS THE PCCAVT                                             */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0230
*   VADR=ADDR(CVTPCCAT);            /* POINTER TO PCCAVT TO OBTAIN 0230
*                                      POINTERS TO ALL VALID PCCA    */
         LA    VADR,CVTPCCAT(,CVTPTR)                              0230
*   CALL ACCESRTN;                  /* ACCESS IT                     */
         BAL   @14,ACCESRTN                                        0231
*   IF(RCREG^=ZERO)|(DATAWORD=ZERO) THEN/* COULD NOT ACCESS IT       */
         SLR   @14,@14                                             0232
         CR    RCREG,@14                                           0232
         BNE   @RT00232                                            0232
         C     @14,DATAWORD(,DATAPTR)                              0232
         BNE   @RF00232                                            0232
@RT00232 DS    0H                                                  0233
*     DO;                                                          0233
*       BUFFER(1:LENGTH(IDERR))=IDERR;/* ERROR MESSAGE               */
         L     @14,ADPLBUF(,ABDPLPTR)                              0234
         MVC   BUFFER(80,@14),IDERR                                0234
*       RCCODE=4;                   /* BAD RETURN CODE               */
         MVC   RCCODE(4),@CF00081                                  0235
*       CALL PRINT;                 /* PRINT MESSAGE                 */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0236
         BALR  @14,@15                                             0236
*     END;                          /* END CULD NOT ACCESS PCCAVT    */
*   ELSE                            /* COULD ACCESS PCCAVT           */
*     DO;                                                          0238
         B     @RC00232                                            0238
@RF00232 DS    0H                                                  0239
*       PCCATPTR=DATAWORD;          /* SAVE PCCAVT ADDRESS           */
*                                                                  0239
         L     PCCATPTR,DATAWORD(,DATAPTR)                         0239
*       /*************************************************************/
*       /*                                                           */
*       /* LOOP THROUGH THE PCCAVT FOR ALL PCCAS                     */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0240
*       DO INDEX=1 TO MP;           /* LOOP TO FIND CPUIDS           */
         LA    INDEX,1                                             0240
@DL00240 DS    0H                                                  0241
*         VADR=PCCATPTR+(4*(INDEX-1));/* PTR TO PCCA                 */
         LR    VADR,INDEX                                          0241
         BCTR  VADR,0                                              0241
         SLA   VADR,2                                              0241
         ALR   VADR,PCCATPTR                                       0241
*         CALL ACCESRTN;            /* ACCESS IT                     */
         BAL   @14,ACCESRTN                                        0242
*         IF(RCREG^=ZERO)|(DATAWORD=ZERO) THEN/* COULD NOT ACCESS  0243
*                                      PCCA                          */
         SLR   @14,@14                                             0243
         CR    RCREG,@14                                           0243
         BNE   @RT00243                                            0243
         C     @14,DATAWORD(,DATAPTR)                              0243
         BNE   @RF00243                                            0243
@RT00243 DS    0H                                                  0244
*           IDTABLE(INDEX)=BLANKS;  /* FILL IN TABLE WITH BLANKS     */
         LR    @14,INDEX                                           0244
         MH    @14,@CH00879                                        0244
         LA    @06,IDTABLE-6(@14)                                  0244
         MVC   0(6,@06),BLANKS                                     0244
*         ELSE                      /* FOUND PCCA                    */
*           DO;                                                    0245
*                                                                  0245
         B     @RC00243                                            0245
@RF00243 DS    0H                                                  0246
*             /*******************************************************/
*             /*                                                     */
*             /* FILL IN THE CPU ID FROM THE PCCA. THE PCCA CPID     */
*             /* FIELD IS IN PRINTABLE FORMAT,AND NEEDS TO BE        */
*             /* CONVERTED TO PACKED (ZONED) DECIMAL, IN ORDER TO BE */
*             /* COMPARED WITH THE LOGREC ENTRY CPUID                */
*             /*                                                     */
*             /*******************************************************/
*                                                                  0246
*             PCCAPTR=DATAWORD;     /* SAVE ADDRESS OF PCCA          */
         L     PCCAPTR,DATAWORD(,DATAPTR)                          0246
*             VADR=ADDR(PCCACPID);  /* FIRST WORD OF CPU ID          */
         LA    VADR,PCCACPID(,PCCAPTR)                             0247
*             CALL ACCESRTN;        /* ACCESS IT                     */
         BAL   @14,ACCESRTN                                        0248
*             IF RCREG^=ZERO THEN   /* ACCESS ERROR                  */
         LTR   RCREG,RCREG                                         0249
         BZ    @RF00249                                            0249
*               IDTABLE(INDEX)=BLANKS;/* FILL IN TABLE WITH BLANKS   */
         LR    @14,INDEX                                           0250
         MH    @14,@CH00879                                        0250
         LA    @06,IDTABLE-6(@14)                                  0250
         MVC   0(6,@06),BLANKS                                     0250
*             ELSE                  /* FOUND FIRST PART OF CPU ID    */
*               DO;                                                0251
         B     @RC00249                                            0251
@RF00249 DS    0H                                                  0252
*                 WORD1=DATAWORD;   /* FILL IN FIRST PART OF CPU ID  */
         MVC   WORD1(4),DATAWORD(DATAPTR)                          0252
*                 VADR=ADDR(PCCACPID)+4;/* SECOND WORD OF CPU ID     */
         LA    VADR,PCCACPID(,PCCAPTR)                             0253
         AL    VADR,@CF00081                                       0253
*                 CALL ACCESRTN;    /* ACCESS IT                     */
         BAL   @14,ACCESRTN                                        0254
*                 IF RCREG^=ZERO THEN/* ACCESS ERROR                 */
         LTR   RCREG,RCREG                                         0255
         BZ    @RF00255                                            0255
*                   IDTABLE(INDEX)=BLANKS;/* FILL IN TABLE WITH    0256
*                                      BLANKS                        */
         LR    @14,INDEX                                           0256
         MH    @14,@CH00879                                        0256
         LA    @06,IDTABLE-6(@14)                                  0256
         MVC   0(6,@06),BLANKS                                     0256
*                 ELSE              /* FOUND SECOND WORD OF CPU ID   */
*                   DO;                                            0257
         B     @RC00255                                            0257
@RF00255 DS    0H                                                  0258
*                     WORD2=DATAWORD;/* FILL IN SECOND PART CPU ID   */
         MVC   WORD2(4),DATAWORD(DATAPTR)                          0258
*                     VADR=ADDR(PCCACPID)+8;/* LAST WORD OF CPU ID   */
         LA    VADR,PCCACPID(,PCCAPTR)                             0259
         AH    VADR,@CH00087                                       0259
*                     CALL ACCESRTN;/* ACCESS IT                     */
         BAL   @14,ACCESRTN                                        0260
*                     IF RCREG^=ZERO THEN/* ACCESS ERROR             */
         LTR   RCREG,RCREG                                         0261
         BZ    @RF00261                                            0261
*                       IDTABLE(INDEX)=BLANKS;/* FILL IN TABLE WITH
*                                      BLANKS                        */
         LR    @14,INDEX                                           0262
         MH    @14,@CH00879                                        0262
         LA    @06,IDTABLE-6(@14)                                  0262
         MVC   0(6,@06),BLANKS                                     0262
*                     ELSE          /* FOUND THIRD WORD OF CPU ID    */
*                       DO;                                        0263
         B     @RC00261                                            0263
@RF00261 DS    0H                                                  0264
*                         WORD3=DATAWORD;/* FILL IN LAST WORD OF CPU
*                                      ID                            */
         MVC   WORD3(4),DATAWORD(DATAPTR)                          0264
*                         TR(SAVETBLE,TRANS);/* TRANSLATE TO UNPACKED
*                                      DIGITS                        */
         TR    SAVETBLE(13),TRANS                                  0265
*                         PACK(TEMPID,SAVETBLE);/* PACK INTO TEMP  0266
*                                      AREA(TO ELIMINATE ZONES)      */
         PACK  TEMPID(7),SAVETBLE(13)                              0266
*                         IDTABLE(INDEX)=TEMPID(1:6);/* MOVE ID INTO
*                                      CPU ID TABLE                  */
         LR    @14,INDEX                                           0267
         MH    @14,@CH00879                                        0267
         LA    @06,IDTABLE-6(@14)                                  0267
         MVC   0(6,@06),TEMPID                                     0267
*                       END;        /* END FOUND THIRD WORD OF CPU ID*/
*                   END;            /* END FOUND SECOND WORD OF CPU
*                                      ID                            */
@RC00261 DS    0H                                                  0270
*               END;                /* END FOUND FIRST PART OF CPU ID*/
@RC00255 DS    0H                                                  0271
*           END;                    /* END FOUND PCCA                */
@RC00249 DS    0H                                                  0272
*       END;                        /* END LOOP TO FIND CPU IDS      */
*                                                                  0272
@RC00243 AH    INDEX,@CH00042                                      0272
         CH    INDEX,@CH00100                                      0272
         BNH   @DL00240                                            0272
*       /*************************************************************/
*       /*                                                           */
*       /* CHECK IF A VALID CPU ID WAS FOUND                         */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0273
*       IF IDTABLE(1)=IDTABLE(2) THEN/* ONLY EQUAL IF BOTH ARE BLANK-
*                                      COULD NOT BE FOUND            */
         CLC   IDTABLE(6),IDTABLE+6                                0273
         BNE   @RF00273                                            0273
*         DO;                                                      0274
*           BUFFER(1:LENGTH(IDERR))=IDERR;/* ERROR MESSAGE           */
         L     @14,ADPLBUF(,ABDPLPTR)                              0275
         MVC   BUFFER(80,@14),IDERR                                0275
*           RCCODE=4;               /* ENSURE NO FURTHER PROCESSING  */
         MVC   RCCODE(4),@CF00081                                  0276
*           CALL PRINT;             /* PRINT IT                      */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0277
         BALR  @14,@15                                             0277
*         END;                      /* END COULD NOT FIND CPU IDS    */
*       ELSE                                                       0279
*         ;                         /* FOUND VALID CPU ID(AT LEAST 1)*/
@RF00273 DS    0H                                                  0280
*     END;                          /* END COULD ACCESS PCCAVT       */
*   RETURN CODE(RCCODE);                                           0281
@RC00232 L     @15,RCCODE                                          0281
@EL00002 DS    0H                                                  0281
@EF00002 DS    0H                                                  0281
@ER00002 L     @14,@SA00002                                        0281
         BR    @14                                                 0281
*   END CPUID;                                                     0282
*DEBLOCK:                                                          0283
*   PROC OPTIONS(SAVE(14));                                        0283
*                                                                  0283
DEBLOCK  ST    @14,@SA00003                                        0283
*/********************************************************************/
*/* FUNCTION-                                                      0284
*        ROUTINE TO DEBLOCK THE IN-STORAGE LOGREC BUFFER AND SAVE THE
*      POINTERS TO ALL THE LOGREC RECORDS IN THE SORT TABLE. IT FINDS
*      THE FIRST RECORD BY THE CPUID AND BACKS UP TO THE HEADER    0284
*      INFORMATION ABOUT LENGTHS TO FIND THE LATER RECORDS. THE RECORDS
*      ARE SAVED IN OLDEST TO NEWEST ORDER.                        0284
*                                                                  0284
*       MESSAGES ISSUED BY THIS ROUTINE ARE:                       0284
*                                                                  0284
*               *** IN-STORAGE LOGREC BUFFER COULD NOT BE ACCESSED,
*                   POSSIBLE CAUSE (DATA NOT IN DUMP) ***          0284
*          (COULD NOT ACCESS LOGREC BUFFER)                        0284
*                                                                  0284
*               *** IN-STORAGE LOGREC BUFFER NOT FORMATTED, INVALID
*                   HEADER INFORMATION FOUND ***                   0284
*          (EITHER THE BUFFER WAS NOT 4K IN LENGTH, OR THE FIRST FREE
*           POINTER WAS NOT BETWEEN THE BENNING AND END ADDRESSES) 0284
*                                                                  0284
*               *** THERE ARE NO VALID LOGREC RECORDS IN THE IN-STORAGE
*                   LOGREC BUFFER ***                              0284
*          (NO LOGREC TYPE RECORDS WITH DATA IN BUFFER FOUND)      0284
*                                                                  0284
*               *** IN-STORAGE LOGREC BUFFER NOT FORMATTED, DATA   0284
*                   NECESSARY TO LOCATE THE BUFFER UNAVAILABLE *** 0284
*          (THE RTCT RECORDING FLAGS COULD NOT BE ACCESSED)        0284
*                                                                  0284
*                                                                  0284
*    CALLS-                                                        0284
*         ACCESRTN, DWORDBDY, KEYBUILD, AND PRINT                  0284
*                                                                  0284
*    CALLED BY -                                                   0284
*         MAINLINE TO DEBLOCK THE BUFFER                           0284
*                                                                  0284
*    RETURNS TO -                                                  0284
*         CALLER WITHOUT SETTING A RETURN CODE                     0284
*                                                                    */
*/********************************************************************/
*                                                                  0284
*   SORTINDX=ZERO;                  /* RECORD COUNTER FOR SORT TABLE */
         SLR   @14,@14                                             0284
         ST    @14,SORTINDX                                        0284
*   VADR=RECPTR;                    /* ADDRESS OF IN-STORAGE LOGREC
*                                      BUFFER                        */
         LR    VADR,RECPTR                                         0285
*   CALL ACCESRTN;                  /* ACCESS BUFFER-IT IS ON A 4K 0286
*                                      BDY SO ALL REFERENCES IN THE
*                                      BUFFER CAN BE MADE DIRECTLY 0286
*                                      WITHOUT THE USE OF THE ACCESS
*                                      SERVICE ROUTINE               */
         BAL   @14,ACCESRTN                                        0286
*   IF RCREG^=ZERO THEN             /* ACCESS ERROR                  */
         LTR   RCREG,RCREG                                         0287
         BZ    @RF00287                                            0287
*     DO;                                                          0288
*       BUFFER(1:LENGTH(NOBUF))=NOBUF;/* ERROR MESSAGE               */
         L     @14,ADPLBUF(,ABDPLPTR)                              0289
         MVC   BUFFER(89,@14),NOBUF                                0289
*       CALL PRINT;                 /* PRINT IT                      */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0290
         BALR  @14,@15                                             0290
*     END;                          /* END ACCESS ERROR              */
*   ELSE                            /* FOUND BUFFER                  */
*     DO;                                                          0292
*                                                                  0292
         B     @RC00287                                            0292
@RF00287 DS    0H                                                  0293
*       /*************************************************************/
*       /*                                                           */
*       /* MOVE THE PRINT DUMP COPY INTO AN INTERNAL BUFFER TO ENSURE*/
*       /* THE BUFFER STARTS ON A DOUBLE WORD                        */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0293
*       RFY                                                        0293
*        (COPYREG,                                                 0293
*         COPYSIZE,                                                0293
*         BUFREG,                                                  0293
*         BUFSIZE) RSTD;                                           0293
*       COPYREG=ADDR(COPYBUF);      /* WHERE TO COPY THE LOGREC    0294
*                                      BUFFER TO                     */
         LA    COPYREG,COPYBUF                                     0294
*       COPYSIZE=LENGTH(COPYBUF);   /* SIZE OF THE LOGREC BUFFER     */
         LH    @14,@CH01275                                        0295
         LR    COPYSIZE,@14                                        0295
*       BUFREG=DATAPTR;             /* POINTER TO THE PRINT DUMP COPY*/
         LR    BUFREG,DATAPTR                                      0296
*       BUFSIZE=LENGTH(COPYBUF);    /* LENGTH OF LOGREC BUFFER       */
         LR    BUFSIZE,@14                                         0297
*       MVCL(COPYREG,BUFREG);       /* MOVE INTO INTERNAL BUFFER     */
         MVCL  COPYREG,BUFREG                                      0298
*       RFY                                                        0299
*        (COPYREG,                                                 0299
*         COPYSIZE,                                                0299
*         BUFREG,                                                  0299
*         BUFSIZE) UNRSTD;                                         0299
*                                                                  0299
*       /*************************************************************/
*       /*                                                           */
*       /* DETERMINE IF THE LOGREC HEADER INFORMATION IS IN REAL     */
*       /* ADDRESSES INSTEAD OF VIRTUAL ADDRESSES. THIS HAPPENS WHEN */
*       /* THE EMERGENCY RECORDING IS DONE WITHOUT THE VIRTUAL       */
*       /* TRANSLATION FEATURE. THE WAY TO DETERMINE THIS IS THE RSTF*/
*       /* BIT IN THE RTCT. THE BIT IS ON WHEN THE EMERGENCY         */
*       /* RECORDING IS WRITING ITS RECORDS AND IS TRANSLATING THE   */
*       /* HEADER TO REAL ADDRESSES.                                 */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0300
*       REALADR=RECPTR;             /* SAVE VIRTUAL LOGREC BUFFER  0300
*                                      ADDR TO CALCULATE START AND 0300
*                                      END OFFSETS FOR THE COPY OF 0300
*                                      THE BUFFER                    */
         LR    REALADR,RECPTR                                      0300
*       RECPTR=ADDR(COPYBUF);       /* ADDRESS OF THE COPY OF THE  0301
*                                      BUFFER                        */
         LA    RECPTR,COPYBUF                                      0301
*       VALIDCPU=OFF;               /* INITIALIZE FOUND FIRST RECORD
*                                      BY CPU ID OFF                 */
         NI    VALIDCPU,B'01111111'                                0302
*       VADR=ADDR(RTCTRFLG);        /* RTCT RECORDING FLAGS          */
         L     @14,RTCTPTR                                         0303
         LA    VADR,RTCTRFLG(,@14)                                 0303
*       CALL ACCESRTN;              /* ACCESS IT                     */
         BAL   @14,ACCESRTN                                        0304
*       IF RCREG^=ZERO THEN         /* ERROR ACCESSING THE RTCT      */
         LTR   RCREG,RCREG                                         0305
         BZ    @RF00305                                            0305
*         DO;                                                      0306
*           BUFFER(1:LENGTH(LOCERR))=LOCERR;/* ERROR MESSAGE         */
         L     @14,ADPLBUF(,ABDPLPTR)                              0307
         MVC   BUFFER(95,@14),LOCERR                               0307
*           CALL PRINT;             /* PRINT IT                      */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0308
         BALR  @14,@15                                             0308
*         END;                      /* END ACCESS ERROR              */
*       ELSE                        /* FOUND RECORDING FLAGS         */
*         DO;                                                      0310
         B     @RC00305                                            0310
@RF00305 DS    0H                                                  0311
*           IF STFBIT=ON THEN       /* THE BUFFER POINTERS ARE REAL
*                                      ADDRESSES NOT VIRTUAL ADDRS   */
         TM    STFBIT(DATAPTR),B'00100000'                         0311
         BNO   @RF00311                                            0311
*             REALADR=RCBBUFB&FOURKBDY;/* MASK OUT LOW ORDER BITS TO
*                                      DETERMINE THE BUFFERS       0312
*                                      BEGINNING REAL ADDR TO BE USED
*                                      FOR CALCULATING START AND END
*                                      ADDRESS FOR THE INTERNAL COPY
*                                      OF THE BUFFER                 */
         L     REALADR,RCBBUFB(,RECPTR)                            0312
         N     REALADR,FOURKBDY                                    0312
*           ELSE                                                   0313
*             ;                     /* BUFFERS POINTERS ARE VIRTUAL
*                                      AND THE VIRTUAL ADDRESS HAS 0313
*                                      ALREADY BEEN SAVED IN REALADR */
*                                                                  0313
@RF00311 DS    0H                                                  0314
*           /*********************************************************/
*           /*                                                       */
*           /* DETERMINE THE FIRST AND LAST POINTERS FOR THE COPIED  */
*           /* BUFFER THAT THE IN-STORAGE BUFFER HAS BEEN COPIED     */
*           /* INTO, SINCE THAT IS THE BUFFER BEING REFERENCED, NOT  */
*           /* THE ACTUAL BUFFER                                     */
*           /*                                                       */
*           /*********************************************************/
*                                                                  0314
*           BUFSTART=RCBBUFB-REALADR;/* OFFSET OF BEGINNING ADDR OF
*                                      REAL BUFFER                   */
         L     @14,RCBBUFB(,RECPTR)                                0314
         SLR   @14,REALADR                                         0314
         ST    @14,BUFSTART                                        0314
*           BUFSTART=BUFSTART+RECPTR;/* BEGINNING ADDR IN COPIED   0315
*                                      BUFFER                        */
         ALR   @14,RECPTR                                          0315
         ST    @14,BUFSTART                                        0315
*           BUFEND=RCBBUFE-REALADR; /* OFFSET OF END ADDR OF REAL  0316
*                                      BUFFER                        */
         L     @04,RCBBUFE(,RECPTR)                                0316
         SLR   @04,REALADR                                         0316
         ST    @04,BUFEND                                          0316
*           BUFEND=BUFEND+RECPTR;   /* END ADDRESS OF COPIED BUFFER  */
         ALR   @04,RECPTR                                          0317
         ST    @04,BUFEND                                          0317
*           FRSTFREE=RCBFREE-REALADR;/* OFFSET OF FIRST FREE AREA IN
*                                      REAL BUF                      */
         L     FRSTFREE,RCBFREE(,RECPTR)                           0318
         SLR   FRSTFREE,REALADR                                    0318
*           FRSTFREE=FRSTFREE+RECPTR;/* PTR TO FIRST FREE AREA IN  0319
*                                      COPIED BUF                    */
         ALR   FRSTFREE,RECPTR                                     0319
*           IF((RECPTR+FOURK)^=BUFEND)|/* BUFFER IS NOT 4K         0320
*                                      LONG(IMPROPER LENGTH)         */
*               (FRSTFREE<BUFSTART)|/* BAD FIRST FREE POINTER        */
*               (FRSTFREE>BUFEND) THEN/* BAD FIRST FREE ADDRESS      */
         LR    @02,RECPTR                                          0320
         AH    @02,@CH01275                                        0320
         CR    @02,@04                                             0320
         BNE   @RT00320                                            0320
         CR    FRSTFREE,@14                                        0320
         BL    @RT00320                                            0320
         CR    FRSTFREE,@04                                        0320
         BNH   @RF00320                                            0320
@RT00320 DS    0H                                                  0321
*             DO;                                                  0321
*               BUFFER(1:LENGTH(BADBUF))=BADBUF;/* ERROR MESSAGE     */
         L     @14,ADPLBUF(,ABDPLPTR)                              0322
         MVC   BUFFER(80,@14),BADBUF                               0322
*               CALL PRINT;         /* PRINT IT                      */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0323
         BALR  @14,@15                                             0323
*             END;                  /* END BAD BUFFER ENCOUNTERED    */
*           ELSE                    /* FOUND A VALID BUFFER          */
*             DO;                                                  0325
         B     @RC00320                                            0325
@RF00320 DS    0H                                                  0326
*               RECPTR=FRSTFREE+LENGTH(BEHDR)+HDRLNGTH;/* POINTER TO
*                                      THE CPUID FOR THE FIRST     0326
*                                      POSSIBLE WHOLE RECORD AFTER 0326
*                                      THE FIRST FREE POINTER IN THE
*                                      BUFFER                        */
         LA    RECPTR,16                                           0326
         ALR   RECPTR,FRSTFREE                                     0326
         AL    RECPTR,HDRLNGTH                                     0326
*               CALL DWORDBDY;      /* MOVE PTR TO NEXT DOUBLEWORD   */
*                                                                  0327
         BAL   @14,DWORDBDY                                        0327
*               /*****************************************************/
*               /*                                                   */
*               /* LOOP TO FIND THE FIRST RECORD BY CPUID            */
*               /*                                                   */
*               /*****************************************************/
*                                                                  0328
*               DO UNTIL((RECPTR=FRSTFREE)|(VALIDCPU=ON));/* LOOP  0328
*                                      UNTIL THE BUFFER IS EXHAUSTED
*                                      OR A RECORD IS FOUND          */
@DL00328 DS    0H                                                  0329
*                 DO INDEX=1 TO MP; /* INNER LOOP-SCAN ALL POSSIBLE
*                                      VALID CPU IDS                 */
         LA    INDEX,1                                             0329
@DL00329 DS    0H                                                  0330
*                   IF(IDTABLE(INDEX)^=BLANKS)&/* CPUID NOT BLANKS 0330
*                                      (ONE OF THE ENTRIES IS BLANK
*                                      IN A UP                 SYSTEM*/
*                       (CPID=IDTABLE(INDEX)) THEN/* VALID CPU ID  0330
*                                      FOUND IN RECORD               */
         LR    @14,INDEX                                           0330
         MH    @14,@CH00879                                        0330
         LA    @02,IDTABLE-6(@14)                                  0330
         CLC   0(6,@02),BLANKS                                     0330
         BE    @RF00330                                            0330
         LA    @02,IDTABLE-6(@14)                                  0330
         CLC   CPID(6,RECPTR),0(@02)                               0330
         BNE   @RF00330                                            0330
*                     VALIDCPU=ON;  /* INDICATE A RECORD FOUND       */
         OI    VALIDCPU,B'10000000'                                0331
*                   ELSE                                           0332
*                     ;             /* A RECORD NOT FOUND            */
@RF00330 DS    0H                                                  0333
*                 END;              /* END INNER LOOP TO SCAN FOR  0333
*                                      VALID CPU ID                  */
         AH    INDEX,@CH00042                                      0333
         CH    INDEX,@CH00100                                      0333
         BNH   @DL00329                                            0333
*                 IF VALIDCPU=OFF THEN/* DID NOT FIND A RECORD       */
         TM    VALIDCPU,B'10000000'                                0334
         BNZ   @RF00334                                            0334
*                   DO;                                            0335
*                     RECPTR=RECPTR+NEXTDWRD;/* INCREMENT TO NEXT  0336
*                                      DOUBLE WORD                   */
         AH    RECPTR,@CH00087                                     0336
*                     CALL DWORDBDY;/* CALL TO CHECK IF NEXT DWORD IS
*                                      BEYOND END OF BUFFER          */
         BAL   @14,DWORDBDY                                        0337
*                   END;            /* END DID NOT FIND A RECORD     */
*                 ELSE                                             0339
*                   ;               /* RECORD WAS FOUND- NO NEED TO
*                                      INCR PTR                      */
@RF00334 DS    0H                                                  0340
*               END;                /* END LOOP LOOKING FOR A RECORD */
*                                                                  0340
@DE00328 CR    RECPTR,FRSTFREE                                     0340
         BE    @DC00328                                            0340
         TM    VALIDCPU,B'10000000'                                0340
         BNO   @DL00328                                            0340
@DC00328 DS    0H                                                  0341
*               /*****************************************************/
*               /*                                                   */
*               /* CHECK IF ANY VALID RECORDS WERE FOUND             */
*               /*                                                   */
*               /*****************************************************/
*                                                                  0341
*               IF VALIDCPU=OFF THEN/* BUFFER EXHAUSTED WITHOUT    0341
*                                      FINDING A RECORD              */
         TM    VALIDCPU,B'10000000'                                0341
         BNZ   @RF00341                                            0341
*                 DO;                                              0342
*                   BUFFER(1:LENGTH(NORECORD))=NORECORD;/* ERROR   0343
*                                      MESSAGE                       */
         L     @14,ADPLBUF(,ABDPLPTR)                              0343
         MVC   BUFFER(73,@14),NORECORD                             0343
*                   CALL PRINT;     /* PRINT IT                      */
         L     @15,ADPLPRNT(,ABDPLPTR)                             0344
         BALR  @14,@15                                             0344
*                 END;              /* END NO RECORDS FOUND          */
*               ELSE                /* FOUND A VALID FIRST RECORD    */
*                 DO;                                              0346
         B     @RC00341                                            0346
@RF00341 DS    0H                                                  0347
*                   RECPTR=RECPTR-(HDRLNGTH+LENGTH(BEHDR));/* POINT
*                                      BEFORE BOTH THE CONTROL HEADER
*                                      AND THE RECORD HEADER         */
         LA    @14,16                                              0347
         AL    @14,HDRLNGTH                                        0347
         SLR   RECPTR,@14                                          0347
*                   IF RECPTR<BUFSTART THEN/* RECORD WRAPS THE BUFFER*/
         L     @14,BUFSTART                                        0348
         CR    RECPTR,@14                                          0348
         BNL   @RF00348                                            0348
*                     DO;                                          0349
*                       RECPTR=BUFSTART-RECPTR;/* HOW MUCH HAS     0350
*                                      WRAPPED                       */
         SLR   @14,RECPTR                                          0350
         LR    RECPTR,@14                                          0350
*                       RECPTR=BUFEND-RECPTR;/* PROPER PLACE AT END
*                                      OF BUFFER                     */
         L     @14,BUFEND                                          0351
         SLR   @14,RECPTR                                          0351
         LR    RECPTR,@14                                          0351
*                     END;          /* END RECORD WRAPS BUFFER       */
*                   ELSE                                           0353
*                     ;             /* RECORD HAS NOT WRAPPED        */
*                                                                  0353
@RF00348 DS    0H                                                  0354
*                   /*************************************************/
*                   /*                                               */
*                   /* DEBLOCK THE REST OF THE BUFFER USING THE      */
*                   /* RECORD HEADERS FOR LENGTHS                    */
*                   /*                                               */
*                   /*************************************************/
*                                                                  0354
*                   DO UNTIL(RECPTR=FRSTFREE);/* DEBLOCK LOOP        */
@DL00354 DS    0H                                                  0355
*                     IF(DATAP=OFF)&(LOG=ON) THEN/* THIS RECORD IS TO
*                                      BE PRINTED, IT IS A LOGREC  0355
*                                      RECORD AND THE ENTRY IS IN THE
*                                      BUFFER                        */
         TM    DATAP(RECPTR),B'00001000'                           0355
         BNZ   @RF00355                                            0355
         TM    LOG(RECPTR),B'01000000'                             0355
         BNO   @RF00355                                            0355
*                       DO;                                        0356
*                         SORTINDX=SORTINDX+1;/* INCREMENT NO. OF  0357
*                                      RECORDS FOUND                 */
         LA    @14,1                                               0357
         AL    @14,SORTINDX                                        0357
         ST    @14,SORTINDX                                        0357
*                         SORTCORE(SORTINDX)=RECPTR;/* SAVE RECORD 0358
*                                      ADDRES IN SORTABLE            */
         MH    @14,@CH00033                                        0358
         ST    RECPTR,SORTCORE-10(@14)                             0358
*                         CALL KEYBUILD;/* BUILD THE SORT KEY        */
         BAL   @14,KEYBUILD                                        0359
*                         LNGTH=BLEN;/* SAVE RECORD LENGTH           */
         LH    LNGTH,BLEN(,RECPTR)                                 0360
*                       END;        /*                       @G33DGVS*/
*                     ELSE          /* THIS RECORD IS NOT TO BE    0362
*                                      PRINTED ( IT IS EITHER A WTO
*                                      ENTRY OR THE RECORD IS NOT IN
*                                      THE BUFFER                    */
*                       IF DATAP=ON THEN/* ONLY A PTR TO DATA EXISTS
*                                                            @ZA19201*/
         B     @RC00355                                            0362
@RF00355 TM    DATAP(RECPTR),B'00001000'                           0362
         BNO   @RF00362                                            0362
*                         IF ERFG=ON THEN/* ERRID INFO IS APPENDED 0363
*                                                            @ZA19201*/
         TM    ERFG(RECPTR),B'00000010'                            0363
         BNO   @RF00363                                            0363
*                           LNGTH=4+ERIDLNTH;/* LENGTH IS THE PTR  0364
*                                      PLUS THE LENGTH OF THE ERROR
*                                      ID INFO               @ZA19201*/
         LA    LNGTH,14                                            0364
*                         ELSE      /* ERROR ID IS NOT APPENDED    0365
*                                                            @ZA19201*/
*                           LNGTH=4;/* LENGTH OF POINTER     @ZA19201*/
         B     @RC00363                                            0365
@RF00363 LA    LNGTH,4                                             0365
*                       ELSE        /* WTO RECORD=HAS A VALID LENGTH */
*                         LNGTH=BLEN;/* LENGTH               @G33DGVS
*
*                                      LNGTH=BLEN; /*LENGTH OF WTO 0366
*                                      RECORD                        */
         B     @RC00362                                            0366
@RF00362 LH    LNGTH,BLEN(,RECPTR)                                 0366
*                     RECPTR=RECPTR+LNGTH+LENGTH(BEHDR);/* PTR TO THE
*                                      END OF THIS RECORD            */
@RC00362 DS    0H                                                  0367
@RC00355 LR    @14,RECPTR                                          0367
         ALR   @14,LNGTH                                           0367
         AH    @14,@CH00777                                        0367
         LR    RECPTR,@14                                          0367
*                     CALL DWORDBDY;/* GET TO NEXT DOUBLE WORD FOR 0368
*                                      NEXT ENTRY                    */
         BAL   @14,DWORDBDY                                        0368
*                   END;            /* END DEBLOCK LOOP              */
@DE00354 CR    RECPTR,FRSTFREE                                     0369
         BNE   @DL00354                                            0369
*                 END;              /* END FOUND A VALID FIRST RECORD*/
*             END;                  /* END FOUND A VALID BUFFER      */
*         END;                      /* END FOUND THE RTCT RECORDING
*                                      FLGS                          */
*     END;                          /* END FOUND THE IN-STORAGE    0373
*                                      BUFFER                        */
*DWORDBDY:                                                         0374
*   PROC OPTIONS(SAVE(14));                                        0374
*                                                                  0374
         B     @PB00004                                            0374
DWORDBDY ST    @14,12(,@13)                                        0374
*/********************************************************************/
*/* FUNCTION-                                                      0375
*        ROUTINE TO SPACE FORWARD IN THE BUFFER TO THE NEXT DOUBLE WORD
*      THIS IS IMPORTANT SINCE ALL RECORDS AND CPU IDS START ON DOUBLE
*      WORD BOUNDRIES. IF THE NEXT DOUBLE WORD IS BEYOND THE BUFFER END
*      THE POINTER IS WRAPPED TO THE APPROPRIATE PLACE IN THE BEGINNING
*      OF THE BUFFER.                                              0375
*                                                                  0375
*    CALLS-                                                        0375
*         MAKES NO OUTSIDE CALLS                                   0375
*                                                                  0375
*    CALLED BY -                                                   0375
*         DEBLOCK AND KEYBUILD TO ADVANCE PTR TO NEXT DOUBLE WORD  0375
*                                                                  0375
*    RETURNS TO -                                                  0375
*         CALLER WITHOUT SETTING A RETURN CODE                     0375
*                                                                    */
*/********************************************************************/
*                                                                  0375
*   IF(RECPTR&DOUBLEWD)^=RECPTR THEN/* RECPTR IS NOT ON A DOUBLE WORD
*                                      BOUNDARY                      */
         LR    @14,RECPTR                                          0375
         N     @14,DOUBLEWD                                        0375
         CLR   @14,RECPTR                                          0375
         BE    @RF00375                                            0375
*     RECPTR=(RECPTR&DOUBLEWD)+NEXTDWRD;/* ROUND RECPTR DOWN TO A  0376
*                                      DOUBLE WORD AND INCREMENT 8 TO
*                                      POINT TO NEXT DOUBLE WORD     */
         AL    @14,@CF00087                                        0376
         LR    RECPTR,@14                                          0376
*   ELSE                                                           0377
*     ;                             /* RECPTR ALREADY ON A DOUBLE  0377
*                                      WORD BDY                      */
@RF00375 DS    0H                                                  0378
*   IF RECPTR>=BUFEND THEN          /* PTR TO NEXT DOUBLE WORD WENT
*                                      BEYOND END OF BUFFER          */
         L     @14,BUFEND                                          0378
         CR    RECPTR,@14                                          0378
         BL    @RF00378                                            0378
*     DO;                                                          0379
*       RECPTR=RECPTR-BUFEND;       /* HOW FAR BEYOND END            */
         SLR   RECPTR,@14                                          0380
*       RECPTR=RECPTR+BUFSTART;     /* WRAP TO BEGINNING OF BUFFER   */
         AL    RECPTR,BUFSTART                                     0381
*     END;                          /* PTR WENT BEYOND END OF BUFFER */
*   ELSE                                                           0383
*     ;                             /* POINTER IS NOT BEYOND END OF
*                                      BUFFER                        */
@RF00378 DS    0H                                                  0384
*   END DWORDBDY;                                                  0384
@EL00004 DS    0H                                                  0384
@EF00004 DS    0H                                                  0384
@ER00004 L     @14,12(,@13)                                        0384
         BR    @14                                                 0384
*KEYBUILD:                                                         0385
*   PROC OPTIONS(SAVE(14));                                        0385
*                                                                  0385
KEYBUILD ST    @14,@SA00005                                        0385
*/********************************************************************/
*/* FUNCTION-                                                      0386
*        ROUTINE TO BUILD THE SORT KEY USED BY THE EREP EDIT ROUTINES
*      TO CHOOSE THE PROPER EDIT TABLES. THE INFORMATION THAT IS SAVED
*      IN THE SORT KEY IS THE RECORD TYPE AND THE CPU MODEL NUMBER.
*                                                                  0386
*    CALLS-                                                        0386
*         DWORDBDY TO ENSURE PROPER BOUNDRY AND PROPER WRAPPING OF THE
*         BUFFER.                                                  0386
*                                                                  0386
*    CALLED BY -                                                   0386
*         DEBLOCK TO BUILD THE SORT KEY.                           0386
*                                                                  0386
*    RETURNS TO -                                                  0386
*         CALLER WITHOUT SETTING A RETURN CODE                     0386
*                                                                    */
*/********************************************************************/
*                                                                  0386
*   SAVEPTR=RECPTR;                 /* SAVE RECPTR ACROSS THE ROUTINE*/
         LR    SAVEPTR,RECPTR                                      0386
*   RECPTR=RECPTR+LENGTH(BEHDR);    /* POINT NOW TO THE LRB HEADER   */
         AH    RECPTR,@CH00777                                     0387
*   CALL DWORDBDY;                  /* FIND PROPER BOUNDRY           */
         BAL   @14,DWORDBDY                                        0388
*   SORTYPE(SORTINDX)=LRBHTYPE;     /* SAVE RECORD TYPE              */
         L     @14,SORTINDX                                        0389
         MH    @14,@CH00033                                        0389
         LA    @02,SORTYPE-10(@14)                                 0389
         MVC   0(1,@02),LRBHTYPE(RECPTR)                           0389
*   RECPTR=RECPTR+HDRLNGTH;         /* POINT NOW TO THE CPUID        */
         AL    RECPTR,HDRLNGTH                                     0390
*   CALL DWORDBDY;                  /* FIND PROPER BOUNDRY           */
         BAL   @14,DWORDBDY                                        0391
*   SORTCPU(SORTINDX)=CPID(5:6);    /* SAVE CPU MODEL NUMBER         */
         L     @14,SORTINDX                                        0392
         MH    @14,@CH00033                                        0392
         LA    @02,SORTCPU-10(@14)                                 0392
         MVC   0(2,@02),CPID+4(RECPTR)                             0392
*   RECPTR=SAVEPTR;                 /* RESTORE RECPTR                */
         LR    RECPTR,SAVEPTR                                      0393
*   END KEYBUILD;                                                  0394
@EL00005 DS    0H                                                  0394
@EF00005 DS    0H                                                  0394
@ER00005 L     @14,@SA00005                                        0394
         BR    @14                                                 0394
*   END DEBLOCK;                                                   0395
@EL00003 DS    0H                                                  0395
@EF00003 DS    0H                                                  0395
@ER00003 L     @14,@SA00003                                        0395
         BR    @14                                                 0395
*ACCESRTN:                                                         0396
*   PROC OPTIONS(SAVE(14));                                        0396
*                                                                  0396
ACCESRTN ST    @14,@SA00006                                        0396
*/********************************************************************/
*/* FUNCTION-                                                      0397
*       ROUTINE WHICH CALLS THE ACCESS SERVICE ROUTINE AND MOVES THE
*     VALUE RETURNED IN R0 INTO DATAPTR, THE POINTER ON WHICH MOST 0397
*     CONTROL BLOCK POINTERS ARE BASED.                            0397
*                                                                  0397
*                                                                  0397
*    CALLS-                                                        0397
*         ACCESS                                                   0397
*                                                                  0397
*    CALLED BY -                                                   0397
*         ALL ROUTINES IN IFCERFMT                                 0397
*                                                                  0397
*    RETURNS TO -                                                  0397
*         CALLER WITH THE RETURN CODE SET BY THE ACCESS SERVICE ROUTINE
*                                                                    */
*/********************************************************************/
*                                                                  0397
*   CALL ACCESS;                    /* ACCESS SERVICE ROUTINE PASSED
*                                      BY CALLER                     */
         L     @15,ADPLMEMA(,ABDPLPTR)                             0397
         BALR  @14,@15                                             0397
*   IF RCREG=ZERO THEN                                             0398
         LTR   RCREG,RCREG                                         0398
         BNZ   @RF00398                                            0398
*     DATAPTR=VADR;                 /* SAVE PTR RETURNED BY ACCESS 0399
*                                      SERVICE ROUTINE               */
         LR    DATAPTR,VADR                                        0399
*   ELSE                                                           0400
*     ;                             /* BAD RETURN CODE               */
@RF00398 DS    0H                                                  0401
*   RCCODE=RCREG;                   /* SAVE RETURN CODE FROM ACCESS
*                                      SERVICE                       */
         ST    RCREG,RCCODE                                        0401
*   RETURN CODE(RCCODE);                                           0402
         L     @14,RCCODE                                          0402
         LR    @15,@14                                             0402
@EL00006 DS    0H                                                  0402
@EF00006 DS    0H                                                  0402
@ER00006 L     @14,@SA00006                                        0402
         BR    @14                                                 0402
*   END ACCESRTN;                                                  0403
*ESTAERTN:                                                         0404
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);                               0404
*                                                                  0404
ESTAERTN DS    0H                                                  0405
*/********************************************************************/
*/* FUNCTION-                                                      0405
*       ROUTINE TO CLEAN UP RESOURCES AND PRINT AN ABEND MESSAGE FOR
*     ANY ABEND. THIS ALLOWS AMDPRDMP TO CONTINUE PROCESSING EVEN IF
*     THE LOGDATA FORMATTER ABENDS.                                0405
*                                                                  0405
*    CALLS-                                                        0405
*         MAKES NO OUTSIDE CALLS                                   0405
*                                                                  0405
*    CALLED BY -                                                   0405
*         RTM IN AN ABEND SITUATION                                0405
*                                                                  0405
*    RETURNS TO -                                                  0405
*         CALLER                                                   0405
*                                                                    */
*/********************************************************************/
*                                                                  0405
*   /*****************************************************************/
*   /*                                                               */
*   /* NO RESTORE REGS SPECIFIED                                     */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0405
*   DO;                             /* ENTESTAE PARMREG(DREG)        */
*/*  ENTRY CODE FOR ESTAE ROUTINE.                                   */
*/*  IF RTCA ALLOCATED THEN RESTORE CODE AND                         */
*/*  DATA REGS FROM START OF USERS PARM LIST,                        */
*/*  AND ESTABLISH ADDR TO ESTAE SAVE AREA                           */
*/*  IF REQUIRED.                                                    */
*/*  IF NO RTCA IS AVAILABLE THEN JUST RETURN                        */
*/*  TO RTM TO CONTINUE TERMINATION                                  */
*                                                                  0406
*     GEN(USING *,GPR15P);                                         0406
         USING *,GPR15P
*     GEN(CH    GPR00F,*+14);       /* CHECK IF RTCA ALLOC FAILED    */
         CH    GPR00F,*+14
*     GEN(BNE   *+12);              /* NO,SAVE RTM REGS              */
         BNE   *+12
*     GEN(DROP  GPR15P);            /* DROP LOCAL ADDR               */
         DROP  GPR15P
*     GEN(LA    GPR15P,0);          /* YES, SET CONT TERM RC         */
         LA    GPR15P,0
*     GEN(BR    GPR14P);            /* RETURN TO RTM                 */
         BR    GPR14P
*     GEN(DC    H'12');             /* NO RTCA AVAIL RC              */
         DC    H'12'
*     GEN(STM   GPR14P,GPR12F,12(GPR13P));/* GOOD R13, SAVE RTM'S  0413
*                                      REGS                          */
         STM   GPR14P,GPR12F,12(GPR13P)
*     GEN(L     DREG,0(GPR01P));    /* PTR TO USER PARM LIST         */
         L     DREG,0(GPR01P)
*   END;                            /* ENTESTAE PARMREG(DREG)        */
*                                                                  0415
*   /*****************************************************************/
*   /*                                                               */
*   /* THIS CODE SETS DREG TO BE THE POINTER TO ALL THE AUTOMATIC    */
*   /* DATA FOR THIS MODULE                                          */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0416
*   LM(GPR02P,GPR12F,REG2TO12);     /* RESTORE THE REGS SAVED FROM 0416
*                                      THE MAINLINE                  */
         LM    GPR02P,GPR12F,REG2TO12                              0416
*   SDWAPTR=GPR01P;                 /* SDWA ADDR PASSED TO THIS    0417
*                                      ROUTINE                       */
*                                                                  0417
         ST    GPR01P,SDWAPTR                                      0417
*   /*****************************************************************/
*   /*                                                               */
*   /* TO PREVENT MORE THAN ONE DUMP FROM BEING TAKEN FOR AN X37 TYPE*/
*   /* ABEND, PERCOLATE TO THE CALLERS RECOVERY. THIS WILL PREVENT   */
*   /* THIS ESTAE FROM TAKING A DUMP AND WILL LET THE CALLERS        */
*   /* RECOVERY TAKE IT.                                     @ZM43805*/
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0418
*   IF ABNDTYPE^='37'X THEN         /* PERCOLATE FOR ALL X37 TYPE  0418
*                                      ABEND CODES           @ZM43805*/
         L     @14,SDWAPTR                                         0418
         MVC   @TS00001(2),ABNDTYPE(@14)                           0418
         NC    @TS00001(2),@CB02579                                0418
         CLC   @TS00001(2),@CB02581                                0418
         BE    @RF00418                                            0418
*     DO;                           /* NOT AN X37 TYPE ABEND @ZM43805*/
*       IF UNEXP2=OFF THEN          /* THE FIRST UNEXPECTED ERROR    */
         TM    UNEXP2,B'10000000'                                  0420
         BNZ   @RF00420                                            0420
*         DO;                                                      0421
*           UNEXP2=ON;              /* RETRY ONLY ONCE - PREVENT LOOP*/
         OI    UNEXP2,B'10000000'                                  0422
*           RTYADR=ADDR(TROUBLE);   /* RETRY POINT IN MAIN LINE FOR
*                                      UNEXPECTED ERRORS             */
         LA    @14,TROUBLE                                         0423
         ST    @14,RTYADR                                          0423
*           SDWASRSV=RTYREGS;       /* SET RETRY REGS FOR MAINLINE 0424
*                                      RETRY                         */
         L     @02,SDWAPTR                                         0424
         MVC   SDWASRSV(64,@02),RTYREGS                            0424
*           ABDPLPTR=RTYREG1;       /* RESTORE PTR TO PRINT DUMP   0425
*                                      PARMLIST-REG1                 */
         L     ABDPLPTR,RTYREG1                                    0425
*           BUFFER(1:LENGTH(ENDMSG))=ENDMSG;/* ABEND MESSAGE         */
         L     @09,ADPLBUF(,ABDPLPTR)                              0426
         MVC   BUFFER(45,@09),ENDMSG                               0426
*           PACKAREA=ABNDCMPC;      /* MOVE COMP CODE TO CHAR AREA   */
         MVC   PACKAREA(2),ABNDCMPC(@02)                           0427
*           GARBAGE='04'X;          /* GARBAGE BYTE FOR THE UNPK     */
         MVI   GARBAGE,X'04'                                       0428
*           UNPK(BUFFER(46:50),UNPACK);/* UNPACK INTO THE BUFFER     */
         UNPK  BUFFER+45(5,@09),UNPACK(3)                          0429
*           TR(BUFFER(46:50),TRANS);/* TRANSLATE TO PRINTABLE HEX    */
         TR    BUFFER+45(5,@09),TRANS                              0430
*           BUFFER(49:49)=' ';      /* BLANK OUT SECOND BYTE         */
         MVI   BUFFER+48(@09),C' '                                 0431
*           GPR01P=SDWAPTR;         /* RESTORE REGISTER 1 FOR SETRP  */
         LR    GPR01P,@02                                          0432
*           DO;                     /* SETRP REGS(14,12)DUMP(YES)RC(4
*                                      )RETADDR(RETRYPT)RETREGS(YES)F
*                                      RESDWA(YES)                   */
*             RESPECIFY                                            0434
*              (GPR00P,                                            0434
*               GPR01P,                                            0434
*               GPR14P,                                            0434
*               GPR15P) RSTD;                                      0434
*             GPR01P->SDWARCDE=4;   /* STORE RC INTO SDWA            */
         MVI   SDWARCDE(GPR01P),X'04'                              0435
*             GPR01P->SDWARTYA=ADDR(RETRYPT);/* SAVE RETRY ADDRESS   */
         L     @02,RTYADR                                          0436
         ST    @02,SDWARTYA(,GPR01P)                               0436
*             GPR01P->SDWAFREE='1'B;/* SET FLAG TO FREE SDWA         */
         OI    SDWAFREE(GPR01P),B'00000100'                        0437
*             GPR01P->SDWAREQ='1'B; /* TURN ON DUMP INDICATOR        */
         OI    SDWAREQ(GPR01P),B'10000000'                         0438
*             GPR01P->SDWAUPRG='1'B;/* TURN ON RETREGS INDICATOR     */
         OI    SDWAUPRG(GPR01P),B'00001000'                        0439
*             GEN(RETURN (14,12));                                 0440
         RETURN (14,12)
*             RESPECIFY                                            0441
*              (GPR00P,                                            0441
*               GPR01P,                                            0441
*               GPR14P,                                            0441
*               GPR15P) UNRSTD;                                    0441
*           END;                                                   0442
*         END;                      /* END FIRST UNEXPECTED ERROR    */
*       ELSE                        /* PERCOLATE FOR SECOND        0444
*                                      UNEXPECTED ERROR              */
*         DO;                       /* SETRP                       0444
*                                      REGS(14,12)DUMP(YES)RC(0)     */
         B     @RC00420                                            0444
@RF00420 DS    0H                                                  0445
*           RESPECIFY                                              0445
*            (GPR00P,                                              0445
*             GPR01P,                                              0445
*             GPR14P,                                              0445
*             GPR15P) RSTD;                                        0445
*           GPR01P->SDWARCDE=0;     /* SAVE RC VALUE                 */
         MVI   SDWARCDE(GPR01P),X'00'                              0446
*           GPR01P->SDWAREQ='1'B;   /* TURN ON DUMP INDICATOR        */
         OI    SDWAREQ(GPR01P),B'10000000'                         0447
*           GEN(RETURN (14,12));                                   0448
         RETURN (14,12)
*           RESPECIFY                                              0449
*            (GPR00P,                                              0449
*             GPR01P,                                              0449
*             GPR14P,                                              0449
*             GPR15P) UNRSTD;                                      0449
*         END;                      /*                       @ZM43805*/
*     END;                          /* END NOT AN X37 TYPE ABEND   0451
*                                                            @ZM43805*/
*   ELSE                            /* THIS IS AN X37 ABEND -      0452
*                                      PERCOLATE             @ZM43805*/
*     DO;                           /* SETRP                       0452
*                                      REGS(14,12)DUMP(YES)RC(0)     */
         B     @RC00418                                            0452
@RF00418 DS    0H                                                  0453
*       RESPECIFY                                                  0453
*        (GPR00P,                                                  0453
*         GPR01P,                                                  0453
*         GPR14P,                                                  0453
*         GPR15P) RSTD;                                            0453
*       GPR01P->SDWARCDE=0;         /* SAVE RC VALUE                 */
         MVI   SDWARCDE(GPR01P),X'00'                              0454
*       GPR01P->SDWAREQ='1'B;       /* TURN ON DUMP INDICATOR        */
         OI    SDWAREQ(GPR01P),B'10000000'                         0455
*       GEN(RETURN (14,12));                                       0456
         RETURN (14,12)
*       RESPECIFY                                                  0457
*        (GPR00P,                                                  0457
*         GPR01P,                                                  0457
*         GPR14P,                                                  0457
*         GPR15P) UNRSTD;                                          0457
*     END;                          /*                       @ZM43805*/
*   END ESTAERTN;                                                  0459
@EL00007 DS    0H                                                  0459
@EF00007 DS    0H                                                  0459
@ER00007 BR    @14                                                 0459
*   DECLARE                         /* GENERAL PURPOSE REGISTERS     */
*     GPR00F FIXED(31) REG(0),                                     0460
*     GPR12F FIXED(31) REG(12),                                    0460
*     GPR00P PTR(31) REG(0),                                       0460
*     GPR01P PTR(31) REG(1),                                       0460
*     GPR02P PTR(31) REG(2),                                       0460
*     GPR13P PTR(31) REG(13),                                      0460
*     GPR14P PTR(31) REG(14),                                      0460
*     GPR15P PTR(31) REG(15);                                      0460
*   DECLARE                         /* COMMON VARIABLES              */
*     I256C CHAR(256) BASED,                                       0461
*     I031F FIXED(31) BASED,                                       0461
*     I031P PTR(31) BASED,                                         0461
*     I015F FIXED(15) BASED,                                       0461
*     I015P PTR(15) BASED,                                         0461
*     I008P PTR(8) BASED,                                          0461
*     I001C CHAR(1) BASED;                                         0461
*   END IFCERFMT                                                   0462
*                                                                  0462
*/* THE FOLLOWING INCLUDE STATEMENTS WERE FOUND IN THIS PROGRAM.     */
*/*%INCLUDE SYSLIB  (IHAABDPL)                                       */
*/*%INCLUDE SYSLIB  (CVT     )                                       */
*/*%INCLUDE SYSLIB  (IHAHDR  )                                       */
*/*%INCLUDE SYSLIB  (IHALRB  )                                       */
*/*%INCLUDE SYSLIB  (IHAPCCA )                                       */
*/*%INCLUDE SYSLIB  (IHAPCCAT)                                       */
*/*%INCLUDE SYSLIB  (IHASRB  )                                       */
*/*%INCLUDE SYSLIB  (RTMRCB  )                                       */
*/*%INCLUDE SYSLIB  (IHARTCT )                                       */
*/*%INCLUDE SYSLIB  (IHASDWA )                                       */
*/*%INCLUDE SYSLIB  (IHASUBIT)                                       */
*/*%INCLUDE SYSLIB  (COMTABLE)                                       */
*                                                                  0462
*       ;                                                          0462
@DATA    DS    0H
@CH00042 DC    H'1'
@CH00100 DC    H'2'
@CH00879 DC    H'6'
@CH00033 DC    H'10'
@CH00777 DC    H'16'
@CH02078 DC    H'120'
@CH01275 DC    H'4096'
@SM02572 MVC   ESTAEXEC(0),ESTALIST
@SX02574 XC    0(0,@08),0(@08)
@DATD    DSECT
         DS    0F
@SA00001 DS    18F
@SA00006 DS    1F
@SA00002 DS    1F
@SA00003 DS    1F
@SA00005 DS    1F
IFCERFMT CSECT
         DS    0F
@CF00081 DC    F'4'
@CF00087 DC    F'8'
@CH00087 EQU   @CF00087+2
@CF02569 DC    F'1000'
@DATD    DSECT
         DS    0D
HDRPTR   DS    A
LRBPTR   DS    A
SRBPTR   DS    A
SDWAPTR  DS    A
BUFEND   DS    A
BUFSTART DS    A
RCCODE   DS    F
SORTINDX DS    F
RTCTPTR  DS    A
@TS00001 DS    CL2
         DS    CL2
EDITLOAD DS    CL148
         ORG   EDITLOAD
EDITNUM  DS    FL2
         DS    CL2
EDITABLE DS    CL12
         ORG   EDITABLE+0
LOADNAME DS    CL8
LOADPTR  DS    AL4
         ORG   EDITLOAD+148
EREPBUF  DS    CL134
         DS    CL2
ESTAPARM DS    CL72
         ORG   ESTAPARM
ESTAERR  DS    BL4
         ORG   ESTAERR
UNEXP2   DS    BL1
@NM00103 EQU   ESTAERR+0
         ORG   ESTAPARM+4
RTYADR   DS    AL4
RTYREGS  DS    CL64
         ORG   RTYREGS
@NM00104 DS    AL4
RTYREG1  DS    AL4
REG2TO12 DS    CL44
@NM00105 DS    CL12
         ORG   ESTAPARM+72
PARM     DS    CL348
         ORG   PARM
RECTYPE  DS    BL2
         ORG   RECTYPE
PMCH     DS    BL1
PCHAN    EQU   RECTYPE+0
POBR     EQU   RECTYPE+0
PSOFT    EQU   RECTYPE+0
PIPL     EQU   RECTYPE+0
PDDR     EQU   RECTYPE+0
PMIH     EQU   RECTYPE+0
PEOD     EQU   RECTYPE+0
PTTYP    DS    BL1
PMCHFRAM EQU   RECTYPE+1
PCCHFRAM EQU   RECTYPE+1
         ORG   PARM+2
SWITCHES DS    BL2
         ORG   SWITCHES
RDESUM   DS    BL1
PARMMES  EQU   SWITCHES+0
SHORTOBR EQU   SWITCHES+0
TREND    EQU   SWITCHES+0
PARMTHR  EQU   SWITCHES+0
SYSUM    EQU   SWITCHES+0
TIMESEQ  EQU   SWITCHES+0
NOSDR    EQU   SWITCHES+0
NOTALL   DS    BL1
ZEROALL  EQU   SWITCHES+1
DEVEXCL  EQU   SWITCHES+1
SHIFT3RD EQU   SWITCHES+1
ANALYSIS EQU   SWITCHES+1
COREFAIL EQU   SWITCHES+1
SORTBRK  EQU   SWITCHES+1
         ORG   PARM+4
DEBUG    DS    CL4
         ORG   DEBUG
DEBUG0   DS    BL1
DEBUG1   EQU   DEBUG+0
DEBUG2   EQU   DEBUG+0
DEBUG3   EQU   DEBUG+0
DEBUG4   EQU   DEBUG+0
DEBUG5   EQU   DEBUG+0
DEBUG6   EQU   DEBUG+0
DEBUG7   EQU   DEBUG+0
DEBUG8   DS    BL1
DEBUG9   EQU   DEBUG+1
DEBUG10  EQU   DEBUG+1
DEBUG11  EQU   DEBUG+1
DEBUG12  EQU   DEBUG+1
DEBUG13  EQU   DEBUG+1
DEBUG14  EQU   DEBUG+1
DEBUG15  EQU   DEBUG+1
DEBUG16  DS    BL1
DEBUG17  EQU   DEBUG+2
DEBUG18  EQU   DEBUG+2
DEBUG19  EQU   DEBUG+2
DEBUG20  EQU   DEBUG+2
DEBUG21  EQU   DEBUG+2
DEBUG22  EQU   DEBUG+2
DEBUG23  EQU   DEBUG+2
DEBUG24  DS    BL1
DEBUG25  EQU   DEBUG+3
DEBUG26  EQU   DEBUG+3
DEBUG27  EQU   DEBUG+3
DEBUG28  EQU   DEBUG+3
DEBUG29  EQU   DEBUG+3
DEBUG30  EQU   DEBUG+3
DEBUG31  EQU   DEBUG+3
         ORG   PARM+8
DEBUGA   DS    CL4
         ORG   DEBUGA
DEBUG32  DS    BL1
DEBUG33  EQU   DEBUGA+0
DEBUG34  EQU   DEBUGA+0
DEBUG35  EQU   DEBUGA+0
DEBUG36  EQU   DEBUGA+0
DEBUG37  EQU   DEBUGA+0
DEBUG38  EQU   DEBUGA+0
DEBUG39  EQU   DEBUGA+0
DEBUG40  DS    BL1
DEBUG41  EQU   DEBUGA+1
DEBUG42  EQU   DEBUGA+1
DEBUG43  EQU   DEBUGA+1
DEBUG44  EQU   DEBUGA+1
DEBUG45  EQU   DEBUGA+1
DEBUG46  EQU   DEBUGA+1
DEBUG47  EQU   DEBUGA+1
DEBUG48  DS    BL1
DEBUG49  EQU   DEBUGA+2
DEBUG50  EQU   DEBUGA+2
DEBUG51  EQU   DEBUGA+2
DEBUG52  EQU   DEBUGA+2
DEBUG53  EQU   DEBUGA+2
DEBUG54  EQU   DEBUGA+2
DEBUG55  EQU   DEBUGA+2
DEBUG56  DS    BL1
DEBUG57  EQU   DEBUGA+3
DEBUG58  EQU   DEBUGA+3
DEBUG59  EQU   DEBUGA+3
DEBUG60  EQU   DEBUGA+3
DEBUG61  EQU   DEBUGA+3
DEBUG62  EQU   DEBUGA+3
DEBUG63  EQU   DEBUGA+3
         ORG   PARM+12
MISC     DS    BL1
         ORG   MISC
PZERO    DS    BL1
PACC     EQU   MISC+0
PHIST    EQU   MISC+0
PRINTES  EQU   MISC+0
         ORG   PRINTES
PEDIT    EQU   PRINTES+0
PSUM     EQU   PRINTES+0
         ORG   MISC+0
ERRORID  EQU   MISC+0
PLOGREC  EQU   MISC+0
PASSFLAG EQU   MISC+0
         ORG   PARM+13
OPENCLSE DS    CL4
         ORG   OPENCLSE
OPENIO   DS    CL2
         ORG   OPENIO
OTOURIST DS    BL1
OEREPPT  EQU   OPENIO+0
OSERLOG  EQU   OPENIO+0
OACCIN   EQU   OPENIO+0
OACCDEV  EQU   OPENIO+0
OSYSIN   EQU   OPENIO+0
ODRCTWRK EQU   OPENIO+0
OSNAP    EQU   OPENIO+0
         ORG   OPENCLSE+2
CLOSEIO  DS    CL2
         ORG   CLOSEIO
CTOURIST DS    BL1
CEREPPT  EQU   CLOSEIO+0
CSERLOG  EQU   CLOSEIO+0
CACCIN   EQU   CLOSEIO+0
CACCDEV  EQU   CLOSEIO+0
CSYSIN   EQU   CLOSEIO+0
CDRCTWRK EQU   CLOSEIO+0
CSNAP    EQU   CLOSEIO+0
         ORG   PARM+17
DATENOW  DS    CL6
         ORG   DATENOW
DAYNOW   DS    CL3
@NM00106 DS    CL1
YEARNOW  DS    CL2
         ORG   PARM+23
STDT     DS    CL8
         ORG   STDT
STDATE   DS    CL4
         ORG   STDATE
@NM00107 DS    BL1
PSTD     DS    BL3
         ORG   PSTD
PSTYR    DS    BL1
PSTDY    DS    BL2
         ORG   STDT+4
@NM00108 DS    CL4
         ORG   PARM+31
ENDDT    DS    CL8
         ORG   ENDDT
ENDDATE  DS    CL4
         ORG   ENDDATE
@NM00109 DS    BL1
PEND     DS    BL3
         ORG   PEND
PENYR    DS    BL1
PENDY    DS    BL2
         ORG   ENDDT+4
@NM00110 DS    CL4
         ORG   PARM+39
STTIME1  DS    CL4
         ORG   STTIME1
PSTHOUR1 DS    BL1
PSTMIN1  DS    BL1
PSTSEC1  DS    BL1
         ORG   PARM+43
ENDTIME1 DS    CL4
         ORG   ENDTIME1
PENHOUR1 DS    BL1
PENMIN1  DS    BL1
PENSEC1  DS    BL1
         ORG   PARM+47
STTIME2  DS    CL4
         ORG   STTIME2
PSTHOUR2 DS    BL1
PSTMIN2  DS    BL1
PSTSEC2  DS    BL1
         ORG   PARM+51
ENDTIME2 DS    CL4
         ORG   ENDTIME2
PENHOUR2 DS    BL1
PENMIN2  DS    BL1
PENSEC2  DS    BL1
         ORG   PARM+55
STRTDATE DS    CL3
         ORG   STRTDATE
EVSYEAR  DS    CL1
EVSDAY   DS    CL2
         ORG   PARM+58
TERM     DS    CL8
RDTHRSH  DS    CL3
WRTHRSH  DS    CL3
@NM00111 DS    CL3
@NM00112 DS    CL3
         ORG   @NM00112
SYSRETRN DS    CL1
         ORG   PARM+80
TABSIZE  DS    FL4
SORTNUM  DS    FL4
NUMDAYS  DS    FL4
ERRID    DS    CL10
         ORG   ERRID
IDVALUE  DS    CL2
@NM00113 DS    CL1
IDCPU    DS    CL1
IDASID   DS    CL2
IDTIMEA  DS    CL4
         ORG   IDTIMEA
IDTIME   DS    CL4
         ORG   IDTIME
IDHOUR   DS    FL1
IDMIN    DS    FL1
IDSEC    DS    FL1
IDTSEC   DS    FL1
         ORG   PARM+102
USERPGM  DS    CL8
         DS    CL2
CCHHRLNG DS    CL8
         ORG   CCHHRLNG
RECCCHHR DS    CL5
@NM00114 DS    CL1
RECLNGTH DS    FL2
         ORG   PARM+120
LINECT   DS    FL2
         DS    CL2
ADIOHND  DS    AL4
ADIFCMSG DS    AL4
ADEDITB  DS    AL4
EVPTR    DS    AL4
SORTADR  DS    AL4
ADCPUT   DS    AL4
PRINTADR DS    AL4
CUAPTR   DS    AL4
DEVPTR   DS    AL4
MODPTR   DS    AL4
SERPTR   DS    AL4
VOLPTR   DS    AL4
CPUPTR   DS    AL4
CPCUAPTR DS    AL4
LIBADPTR DS    AL4
SYMCDPTR DS    AL4
SYSUMPTR DS    AL4
TRENPTR  DS    AL4
SHAREPTR DS    AL4
FRAMEPTR DS    AL4
RECLNGT1 DS    FL4
MERDCPTR DS    AL4
@NM00115 DS    4A
DUMPTABL DS    CL100
         ORG   DUMPTABL
DUMPNUM  DS    FL2
         DS    CL2
DUMPINFO DS    CL8
         ORG   DUMPINFO+0
DUMPADR  DS    FL4
DUMPSIZE DS    FL4
         ORG   PARM+328
PDMPLIST DS    AL4
UNWRPBUF DS    AL4
ENDADR   DS    AL4
BEGINADR DS    AL4
WRITEBIT DS    BL2
         ORG   WRITEBIT
JUSTREAD DS    BL1
         ORG   PARM+346
@NM00116 DS    FL2
         ORG   PARM+348
SAVETBLE DS    CL13
         ORG   SAVETBLE
WORD1    DS    CL4
WORD2    DS    CL4
WORD3    DS    CL4
PACKBYTE DS    CL1
         ORG   SAVETBLE+13
SORTABLE DS    CL1000
         ORG   SORTABLE
ENTRIES  DS    CL10
         ORG   ENTRIES+0
SORTKEY  DS    CL5
         ORG   SORTKEY+0
SORTYPE  DS    CL1
@NM00119 DS    CL2
SORTCPU  DS    CL2
         ORG   ENTRIES+5
SORTCCHR DS    CL5
         ORG   SORTCCHR+0
SORTCORE DS    AL4
         ORG   SORTABLE+1000
TEMPID   DS    CL7
         DS    CL4
UNPACK   DS    CL3
         ORG   UNPACK
PACKAREA DS    CL2
GARBAGE  DS    CL1
         ORG   UNPACK+3
VALIDCPU DS    BL1
         DS    CL4
COPYBUF  DS    CL4096
NEWBUF   DS    CL4096
IDTABLE  DS    2CL6
IFCERFMT CSECT
         DS    0F
@SIZDATD DC    AL1(0)
         DC    AL3(@ENDDATD-@DATD)
@CV02051 DC    V(IFCMSG01)
@CV02052 DC    V(IFCFMTIO)
         DS    0D
DOUBLEWD DC    XL4'FFFFFFF8'
FOURKBDY DC    XL4'FFFFF000'
HDRLNGTH DC    AL4(LRBHCPID-LRB)
ALLON    DC    XL2'FF80'
LOWBIT   DC    XL1'01'
@CB02579 DC    B'0000111111110000'
@CB02581 DC    B'0000001101110000'
BLANKS   DC    CL6'      '
TRANS    DS    CL256
         ORG   TRANS
@NM00120 DS    CL64
BL       DC    CL1' '
@NM00121 DS    CL128
LETERS   DC    X'FAFBFCFDFEFF'
@NM00122 DS    CL41
NUMS     DC    CL16'0123456789ABCDEF'
         ORG   TRANS+256
BADBUF   DC    CL80'*** IN-STORAGE LOGREC BUFFER NOT FORMATTED, INVALIDC
                HEADER INFORMATION FOUND ***'
ENDMSG   DC    CL45'LOGDATA FORMATTER TERMINATED WITH ABEND CODE '
HDRLINE  DC    CL31'* * * *  L O G D A T A  * * * *'
IDERR    DC    CL80'*** IN-STORAGE LOGREC BUFFER NOT FORMATTED, UNABLE C
               TO DETERMINE VALID CPU ID ***'
INCOMP   DC    CL66'*** LOGDATA FORMATTING OMITTED, DUMP IS NOT FROM ANC
                MVS SYSTEM ***'
LOCERR   DC    CL95'*** IN-STORAGE LOGREC BUFFER NOT FORMATTED, DATA NEC
               CESSARY TO LOCATE THE BUFFER UNAVAILABLE ***'
NOBUF    DC    CL89'*** IN-STORAGE LOGREC BUFFER COULD NOT BE ACCESSED,C
                POSSIBLE CAUSE (DATA NOT IN DUMP) ***'
NOINF    DC    CL100'*** IN-STORAGE LOGREC BUFFER NOT FORMATTED, PARAMEC
               TER LIST DID NOT CONTAIN NECESSARY INFORMATION ***'
NORECORD DC    CL73'*** THERE ARE NO VALID LOGREC RECORDS IN THE IN-STOC
               RAGE LOGREC BUFFER ***'
NOSU27   DC    CL91'*** IN-STORAGE LOGREC BUFFER NOT FORMATTED, EREP ENC
               HANCEMENT SU NOT AVAILABLE ON SYSTEM ***'
IFCPATCH DC    CL200'IFCERFMT PATCH AREA- IT IS 200 BYTES LONG'
@DATD    DSECT
ESTAEXEC ESTAE ESTAERTN,MF=L
IFCERFMT CSECT
ESTALIST ESTAE ESTAERTN,MF=L
ESTALEN DC A(ESTALEN-ESTALIST)
@DATD    DSECT
         ORG   *+1-(*-@DATD)/(*-@DATD) INSURE DSECT DATA
@ENDDATD EQU   *
IFCERFMT CSECT
@00      EQU   00                      EQUATES FOR REGISTERS 0-15
@01      EQU   01
@02      EQU   02
@03      EQU   03
@04      EQU   04
@05      EQU   05
@06      EQU   06
@07      EQU   07
@08      EQU   08
@09      EQU   09
@10      EQU   10
@11      EQU   11
@12      EQU   12
@13      EQU   13
@14      EQU   14
@15      EQU   15
SAVEPTR  EQU   @04
REALADR  EQU   @02
PCCATPTR EQU   @07
SAVEREG1 EQU   @04
LNGTH    EQU   @04
INDEX    EQU   @04
FRSTFREE EQU   @05
DATAPTR  EQU   @09
RECPTR   EQU   @08
PCCAPTR  EQU   @06
CVTPTR   EQU   @05
ABDPLPTR EQU   @01
VADR     EQU   @00
PARMPTR  EQU   @02
DREG     EQU   @03
COPYREG  EQU   @04
COPYSIZE EQU   @05
BUFREG   EQU   @06
BUFSIZE  EQU   @07
RCREG    EQU   @15
GPR02P   EQU   @02
GPR12F   EQU   @12
GPR01P   EQU   @01
GPR00P   EQU   @00
GPR14P   EQU   @14
GPR15P   EQU   @15
GPR00F   EQU   @00
GPR13P   EQU   @13
LOC16    EQU   16
ABDPL    EQU   0
ADPLFLAG EQU   ABDPL+7
ADPLSYTM EQU   ADPLFLAG
ADPLBUF  EQU   ABDPL+8
ADPLPRNT EQU   ABDPL+12
ADPLCVT  EQU   ABDPL+16
ADPLMEMA EQU   ABDPL+20
CVTMAP   EQU   0
CVTDAR   EQU   CVTMAP+72
CVTFLGS1 EQU   CVTDAR
CVTDCB   EQU   CVTMAP+116
CVTIOQET EQU   CVTMAP+120
CVTIERLC EQU   CVTMAP+144
CVTHEAD  EQU   CVTMAP+160
CVTSV76C EQU   CVTHEAD
CVTOPTA  EQU   CVTMAP+182
CVTOPTB  EQU   CVTMAP+183
CVTGTF   EQU   CVTMAP+236
CVTGTFST EQU   CVTGTF
CVTGTFS  EQU   CVTGTFST
CVTSTATE EQU   CVTGTFST
CVTTMODE EQU   CVTGTFST
CVTFORM  EQU   CVTGTFST
CVTAQAVT EQU   CVTMAP+240
CVTTCMFG EQU   CVTAQAVT
CVTVOLM2 EQU   CVTMAP+244
CVTTATA  EQU   CVTVOLM2
CVTTSKS  EQU   CVTTATA
CVTVOLF2 EQU   CVTTSKS
CVTTAT   EQU   CVTTATA+1
CVTATER  EQU   CVTMAP+248
CVTEXT1  EQU   CVTMAP+252
CVTPURG  EQU   CVTMAP+260
CVTQMSG  EQU   CVTMAP+268
CVTDMSR  EQU   CVTMAP+272
CVTRSV37 EQU   CVTDMSR
CVTDMSRF EQU   CVTRSV37
CVTERPV  EQU   CVTMAP+316
CVTINTLA EQU   CVTMAP+320
CVTAPF   EQU   CVTMAP+324
CVTEXT2  EQU   CVTMAP+328
CVTHJES  EQU   CVTMAP+332
CVTPGSIA EQU   CVTMAP+348
CVTA1F1  EQU   CVTMAP+356
CVTSYSK  EQU   CVTMAP+357
CVTVOLM1 EQU   CVTMAP+380
CVTVOLF1 EQU   CVTVOLM1
CVTXTNT1 EQU   0
CVTXTNT2 EQU   0
CVTDSSV  EQU   CVTXTNT2
CVTFLGBT EQU   CVTXTNT2+5
CVTQID   EQU   CVTXTNT2+24
CVTRV400 EQU   CVTXTNT2+52
CVTRV409 EQU   CVTXTNT2+53
CVTATCVT EQU   CVTXTNT2+64
CVTRV429 EQU   CVTXTNT2+84
CVTRV438 EQU   CVTXTNT2+85
CVTRV457 EQU   CVTXTNT2+112
CVTRV466 EQU   CVTXTNT2+113
CVTFIX   EQU   0
CVTRELNO EQU   CVTFIX+252
HDR      EQU   0
HDROPRN  EQU   HDR+1
HDRIS    EQU   HDR+2
HDRDS    EQU   HDR+3
HDRDS1   EQU   HDRDS
HDRCNT   EQU   HDR+6
LRB      EQU   0
LRBHTYPE EQU   LRB
LRBHREL  EQU   LRB+1
LRBHSYS  EQU   LRBHREL
LRBHSW0  EQU   LRB+2
LRBHSW1  EQU   LRB+3
LRBHSW2  EQU   LRB+4
LRBMACT  EQU   LRBHSW2
LRBHSW3  EQU   LRB+5
LRBHCPID EQU   LRB+16
LRBBASE  EQU   LRB+24
LRBCVAR  EQU   0
LRBCMP   EQU   LRBCVAR+8
PCCA     EQU   0
PCCACPID EQU   PCCA+4
PCCATMST EQU   PCCA+128
PCCATMFL EQU   PCCATMST
PCCATODE EQU   PCCATMST+1
PCCACCE  EQU   PCCATMST+2
PCCAINTE EQU   PCCATMST+3
PCCAEMSB EQU   PCCA+136
PCCAEMSI EQU   PCCAEMSB
PCCARISP EQU   PCCAEMSI
PCCAEMS2 EQU   PCCAEMSI+1
PCCAEMS3 EQU   PCCAEMSI+2
PCCARMSB EQU   PCCAEMSI+3
PCCACHAN EQU   PCCA+224
PCCAWERP EQU   PCCA+280
PCCACHPF EQU   PCCAWERP+4
PCCACHBL EQU   PCCAWERP+5
PCCACHVA EQU   PCCAWERP+6
PCCACHTS EQU   PCCAWERP+7
PCCACHS1 EQU   PCCA+288
PCCACHS2 EQU   PCCA+289
PCCACHRB EQU   PCCA+290
PCCACHF1 EQU   PCCA+308
PCCACHF2 EQU   PCCA+309
PCCACHF3 EQU   PCCA+310
PCCACHF4 EQU   PCCA+311
PCCAATTR EQU   PCCA+376
PCCAVT   EQU   0
SRBSECT  EQU   0
SRB      EQU   SRBSECT
SRBFLC   EQU   SRB+12
RCB      EQU   0
RCBCNTL  EQU   RCB
RCBBUFB  EQU   RCBCNTL
RCBBUFE  EQU   RCBCNTL+4
RCBCDS   EQU   RCBCNTL+8
RCBFREE  EQU   RCBCDS
RCBCS1   EQU   RCBCNTL+88
RCBFLGS  EQU   RCBCS1+1
RCBFLG1  EQU   RCBFLGS
RCBCS2   EQU   RCBCNTL+92
RTCT     EQU   0
RTCTPLIB EQU   RTCT+4
RTCTSAP  EQU   RTCTPLIB
RTCTSAP1 EQU   RTCTSAP
RTCTSAP2 EQU   RTCTSAP+1
RTCTSAP3 EQU   RTCTSAP+2
RTCTSUP  EQU   RTCTPLIB+4
RTCTSUP1 EQU   RTCTSUP
RTCTSUP2 EQU   RTCTSUP+1
RTCTSUP3 EQU   RTCTSUP+2
RTCTSYD  EQU   RTCTPLIB+8
RTCTSY01 EQU   RTCTSYD
RTCTRCB  EQU   RTCT+32
RTCTSDDS EQU   RTCT+36
RTCTFLG  EQU   RTCTSDDS+3
RTCTSDPL EQU   RTCT+156
RTCTRFLG EQU   RTCT+176
RTCTERID EQU   RTCT+224
RTCTOPT  EQU   RTCT+236
RTCTASO  EQU   RTCT+252
RTCTASO1 EQU   RTCTASO
RTCTASO2 EQU   RTCTASO+1
RTCTSDI  EQU   RTCT+254
RTCTSDF  EQU   RTCT+264
RTCTSDF1 EQU   RTCTSDF
RTCTSDF2 EQU   RTCTSDF+1
RTCTSDF3 EQU   RTCT+268
RTCTSDF4 EQU   RTCTSDF3+2
RTCTMOPT EQU   0
RTCTMSAO EQU   RTCTMOPT
RTCTSASD EQU   RTCTMSAO
RTCTSAO1 EQU   RTCTSASD
RTCTSAO2 EQU   RTCTSASD+1
RTCTSAPD EQU   RTCTMSAO+2
RTCTSAO3 EQU   RTCTSAPD
RTCTSAO4 EQU   RTCTSAPD+1
RTCTSAMG EQU   RTCTSAO4
RTCTMSUO EQU   RTCTMOPT+4
RTCTSUSD EQU   RTCTMSUO
RTCTSUO1 EQU   RTCTSUSD
RTCTSUO2 EQU   RTCTSUSD+1
RTCTSUPD EQU   RTCTMSUO+2
RTCTSUO3 EQU   RTCTSUPD
RTCTSUO4 EQU   RTCTSUPD+1
RTCTSUMG EQU   RTCTSUO4
RTCTMSYO EQU   RTCTMOPT+8
RTCTSD01 EQU   RTCTMSYO
RTCTSD04 EQU   RTCTMSYO+3
RTCTSMMG EQU   RTCTSD04
RTCTMSDO EQU   RTCTMOPT+12
RTCTSDOD EQU   RTCTMSDO
RTCTSDO1 EQU   RTCTSDOD
RTCTSDO2 EQU   RTCTSDOD+1
RTCTSDO3 EQU   RTCTMSDO+2
RTCTSDO4 EQU   RTCTMSDO+3
RTCTSDMG EQU   RTCTSDO4
SDWA     EQU   0
SDWAFIOB EQU   SDWA+4
SDWAABCC EQU   SDWAFIOB
SDWACMPF EQU   SDWAABCC
SDWAREQ  EQU   SDWACMPF
SDWACMPC EQU   SDWAABCC+1
SDWACTL1 EQU   SDWA+8
SDWACMKA EQU   SDWACTL1
SDWAMWPA EQU   SDWACTL1+1
SDWAPMKA EQU   SDWACTL1+4
SDWACTL2 EQU   SDWA+16
SDWACMKP EQU   SDWACTL2
SDWAMWPP EQU   SDWACTL2+1
SDWAPMKP EQU   SDWACTL2+4
SDWAGRSV EQU   SDWA+24
SDWANAME EQU   SDWA+88
SDWAEC1  EQU   SDWA+104
SDWAEMK1 EQU   SDWAEC1
SDWAMWP1 EQU   SDWAEC1+1
SDWAINT1 EQU   SDWAEC1+2
SDWANXT1 EQU   SDWAEC1+4
SDWAAEC1 EQU   SDWA+112
SDWAILC1 EQU   SDWAAEC1+1
SDWAINC1 EQU   SDWAAEC1+2
SDWAICD1 EQU   SDWAINC1+1
SDWAEC2  EQU   SDWA+120
SDWAEMK2 EQU   SDWAEC2
SDWAMWP2 EQU   SDWAEC2+1
SDWAINT2 EQU   SDWAEC2+2
SDWANXT2 EQU   SDWAEC2+4
SDWAAEC2 EQU   SDWA+128
SDWAILC2 EQU   SDWAAEC2+1
SDWAINC2 EQU   SDWAAEC2+2
SDWAICD2 EQU   SDWAINC2+1
SDWASRSV EQU   SDWA+136
SDWAIDNT EQU   SDWA+200
SDWAMCH  EQU   SDWA+204
SDWASTCK EQU   SDWAMCH
SDWAMCHI EQU   SDWAMCH+8
SDWAMCHS EQU   SDWAMCHI
SDWAMCHD EQU   SDWAMCHI+1
SDWARSR1 EQU   SDWAMCH+12
SDWARSR2 EQU   SDWAMCH+13
SDWAFLGS EQU   SDWA+232
SDWAERRA EQU   SDWAFLGS
SDWAERRB EQU   SDWAFLGS+1
SDWAERRC EQU   SDWAFLGS+2
SDWAERRD EQU   SDWAFLGS+3
SDWAIOFS EQU   SDWA+238
SDWARTYA EQU   SDWA+240
SDWACPUA EQU   SDWA+248
SDWAPARQ EQU   SDWA+252
SDWARCDE EQU   SDWAPARQ
SDWAACF2 EQU   SDWAPARQ+1
SDWAUPRG EQU   SDWAACF2
SDWAFREE EQU   SDWAACF2
SDWAACF3 EQU   SDWAPARQ+2
SDWAACF4 EQU   SDWAPARQ+3
SDWALKWA EQU   SDWA+256
SDWALKWS EQU   SDWALKWA
SDWARECP EQU   SDWA+292
SDWASNPA EQU   SDWA+320
SDWADUMP EQU   SDWASNPA
SDWADPFS EQU   SDWADUMP+1
SDWADDAT EQU   SDWASNPA+4
SDWASDAT EQU   SDWADDAT
SDWASDA0 EQU   SDWASDAT
SDWASDA1 EQU   SDWASDAT+1
SDWAPDAT EQU   SDWADDAT+2
SDWADPSA EQU   SDWA+328
SDWADPSL EQU   SDWADPSA
SDWARA   EQU   SDWA+400
SDWADPVA EQU   SDWARA+2
SUBITS   EQU   0
SUBYTE1  EQU   SUBITS
SUBYTE2  EQU   SUBITS+1
SUBYTE3  EQU   SUBITS+2
SUBYTE4  EQU   SUBITS+3
SU27BIT  EQU   SUBYTE4
SUBYTE5  EQU   SUBITS+4
SUBYTE6  EQU   SUBITS+5
SUBYTE7  EQU   SUBITS+6
SUBYTE8  EQU   SUBITS+7
SUBYTE9  EQU   SUBITS+8
SUBYTE10 EQU   SUBITS+9
SUBYTE11 EQU   SUBITS+10
SUBYTE12 EQU   SUBITS+11
SUBYTE13 EQU   SUBITS+12
IFCEDSUM EQU   0
ACCESS   EQU   0
PRINT    EQU   0
BEHDR    EQU   0
BLEN     EQU   BEHDR
BFLGS    EQU   BEHDR+2
LOG      EQU   BFLGS
DATAP    EQU   BFLGS+1
ERFG     EQU   BFLGS+1
BUFFER   EQU   0
CPID     EQU   0
DATADWRD EQU   0
DATAWORD EQU   DATADWRD
DATABYTE EQU   DATAWORD
RETRYPT  EQU   0
RFLG     EQU   0
STFBIT   EQU   RFLG
I001C    EQU   0
I008P    EQU   0
I015F    EQU   0
I015P    EQU   0
I031F    EQU   0
I031P    EQU   0
I256C    EQU   0
CVTS01   EQU   CVTPGSIA
CVTLPDIA EQU   CVTS01+12
CVTDIRST EQU   CVTLPDIA
CVTSLIDA EQU   CVTS01+24
CVTCTLFG EQU   CVTS01+50
CVTRTMCT EQU   CVTS01+224
CVTPCCAT EQU   CVTS01+416
CVTRV210 EQU   CVTS01+424
CVTRV219 EQU   CVTS01+425
CVTRV228 EQU   CVTS01+426
CVTRV237 EQU   CVTS01+427
CVTMFRTR EQU   CVTS01+452
CVTRV262 EQU   CVTS01+468
CVTRV271 EQU   CVTS01+469
CVTRV280 EQU   CVTS01+470
CVTRV289 EQU   CVTS01+471
CVTGSDA  EQU   CVTS01+600
CVTIHASU EQU   CVTS01+696
LRBHRSW1 EQU   LRBHSW1
LRBHCSW1 EQU   LRBHSW1
LRBHMSW1 EQU   LRBHSW1
LRBMMCH  EQU   LRBBASE
LRBMCEIA EQU   LRBMMCH+8
LRBMTERM EQU   LRBMCEIA
LRBMHARD EQU   LRBMCEIA+1
LRBMINTM EQU   LRBMCEIA+2
LRBMSOFT EQU   LRBMCEIA+3
LRBMPDAR EQU   LRBMMCH+12
LRBMRSR1 EQU   LRBMMCH+13
LRBMRSR2 EQU   LRBMMCH+14
LRBMFLO  EQU   LRBMMCH+24
LRBMCIC  EQU   LRBMFLO
@NM00023 EQU   LRBMCIC
@NM00025 EQU   LRBMCIC+1
@NM00027 EQU   LRBMCIC+2
@NM00029 EQU   LRBMCIC+3
@NM00031 EQU   LRBMCIC+5
LRBMEDC  EQU   LRBMFLO+12
LRBRDDR  EQU   LRBBASE
LRBCCCH  EQU   LRBBASE
LRBCCUA  EQU   LRBCCCH+49
LRBDMDR  EQU   LRBBASE
LRBNMIH  EQU   LRBBASE
LRBTTER  EQU   LRBBASE
ABNDCMPC EQU   SDWACMPC
ABND     EQU   ABNDCMPC
ABNDTYPE EQU   ABND
PARMP1   EQU   PARM
RECADR   EQU   RECCCHHR
         AGO   .@UNREFD                START UNREFERENCED COMPONENTS
@NM00100 EQU   ABND
LRBTUSR  EQU   LRBTTER+8
LRBTWSC  EQU   LRBTTER+4
LRBTLNH  EQU   LRBTTER
LRBNINT  EQU   LRBNMIH+24
LRBNDEVT EQU   LRBNMIH+20
LRBNVOL  EQU   LRBNMIH+14
LRBNCUA1 EQU   LRBNMIH+11
LRBNCUA2 EQU   LRBNMIH+8
LRBNJOB  EQU   LRBNMIH
LRBDSENS EQU   LRBDMDR+8
LRBDVOL  EQU   LRBDMDR+2
LRBDCUA1 EQU   LRBDMDR
LRBCCLOG EQU   LRBCCCH+56
LRBCLOGL EQU   LRBCCCH+54
LRBCHCUA EQU   LRBCCCH+52
LRBCCUA2 EQU   LRBCCUA+1
@NM00037 EQU   LRBCCUA
LRBCCHID EQU   LRBCCCH+48
LRBCDEVT EQU   LRBCCCH+44
LRBCECSW EQU   LRBCCCH+40
LRBCFCSW EQU   LRBCCCH+32
LRBCFCCW EQU   LRBCCCH+24
LRBCAIO  EQU   LRBCCCH+8
LRBCJOB  EQU   LRBCCCH
LRBRDEV2 EQU   LRBRDDR+32
LRBRCUA2 EQU   LRBRDDR+29
LRBRPH2  EQU   LRBRDDR+28
LRBRDEV1 EQU   LRBRDDR+24
LRBRCUA1 EQU   LRBRDDR+21
LRBRPH1  EQU   LRBRDDR+20
LRBRVOL2 EQU   LRBRDDR+14
LRBRVOL1 EQU   LRBRDDR+8
LRBRJOB  EQU   LRBRDDR
LRBMCEL  EQU   LRBMMCH+304
@NM00036 EQU   LRBMFLO+20
LRBMFSA  EQU   LRBMFLO+16
@NM00035 EQU   LRBMFLO+13
LRBMDISC EQU   LRBMEDC
LRBMINTR EQU   LRBMEDC
LRBMINST EQU   LRBMEDC
LRBMCCF  EQU   LRBMEDC
LRBMCNOP EQU   LRBMEDC
LRBMEXSR EQU   LRBMEDC
LRBMCOPR EQU   LRBMEDC
@NM00034 EQU   LRBMEDC
@NM00033 EQU   LRBMFLO+8
LRBMCELL EQU   LRBMCIC+6
LRBMVCC  EQU   @NM00031
LRBMVPT  EQU   @NM00031
@NM00032 EQU   @NM00031
@NM00030 EQU   LRBMCIC+4
LRBMVST  EQU   @NM00029
LRBMVLG  EQU   @NM00029
LRBMVCR  EQU   @NM00029
LRBMVGR  EQU   @NM00029
LRBMVFP  EQU   @NM00029
LRBMVED  EQU   @NM00029
LRBMVRC  EQU   @NM00029
LRBMVFA  EQU   @NM00029
LRBMVIA  EQU   @NM00027
LRBMVPM  EQU   @NM00027
LRBMVMS  EQU   @NM00027
LRBMVWP  EQU   @NM00027
@NM00028 EQU   @NM00027
LRBMFKE  EQU   @NM00027
LRBMFSC  EQU   @NM00027
LRBMFSE  EQU   @NM00027
LRBMIDY  EQU   @NM00025
LRBMIBU  EQU   @NM00025
@NM00026 EQU   @NM00025
LRBMFWN  EQU   @NM00025
LRBMFDG  EQU   @NM00023
@NM00024 EQU   @NM00023
LRBMFED  EQU   @NM00023
LRBMFCD  EQU   @NM00023
LRBMFTD  EQU   @NM00023
LRBMFSR  EQU   @NM00023
LRBMFPD  EQU   @NM00023
LRBMFSD  EQU   @NM00023
LRBMMOSW EQU   LRBMMCH+16
LRBMPWL  EQU   LRBMMCH+15
LRBMVEQR EQU   LRBMRSR2
LRBMPGFX EQU   LRBMRSR2
LRBMLSQA EQU   LRBMRSR2
LRBMFSQA EQU   LRBMRSR2
LRBMNUCL EQU   LRBMRSR2
LRBMSPER EQU   LRBMRSR2
LRBMINTC EQU   LRBMRSR2
LRBMOFLN EQU   LRBMRSR2
LRBMCHNG EQU   LRBMRSR1
LRBMSER  EQU   LRBMRSR1
@NM00022 EQU   LRBMRSR1
@NM00021 EQU   LRBMPDAR
LRBMRSRF EQU   LRBMPDAR
LRBMRSRC EQU   LRBMPDAR
LRBMINVP EQU   LRBMPDAR
@NM00020 EQU   LRBMPDAR
LRBMSBUF EQU   LRBMSOFT
LRBMSHIR EQU   LRBMSOFT
LRBMSECC EQU   LRBMSOFT
LRBMSEXD EQU   LRBMSOFT
@NM00019 EQU   LRBMSOFT
LRBMSSFT EQU   LRBMSOFT
LRBMIL80 EQU   LRBMINTM
LRBMICTM EQU   LRBMINTM
LRBMICKC EQU   LRBMINTM
LRBMITOD EQU   LRBMINTM
@NM00018 EQU   LRBMINTM
LRBMHIPD EQU   LRBMHARD
LRBMHSPF EQU   LRBMHARD
LRBMHSTO EQU   LRBMHARD
LRBMHINV EQU   LRBMHARD
LRBMHSD  EQU   LRBMHARD
@NM00017 EQU   LRBMHARD
LRBMHHRD EQU   LRBMHARD
LRBMTINV EQU   LRBMTERM
LRBMTDMG EQU   LRBMTERM
LRBMTWRN EQU   LRBMTERM
LRBMTCKS EQU   LRBMTERM
LRBMTSEC EQU   LRBMTERM
LRBMTTHR EQU   LRBMTERM
@NM00016 EQU   LRBMTERM
LRBMWSC  EQU   LRBMMCH+4
LRBMLNH  EQU   LRBMMCH
@NM00015 EQU   LRBHMSW1
LRBMSYST EQU   LRBHMSW1
@NM00014 EQU   LRBHMSW1
@NM00013 EQU   LRBHCSW1
LRBCERPP EQU   LRBHCSW1
LRBCDATA EQU   LRBHCSW1
LRBCICUA EQU   LRBHCSW1
LRBCNOSP EQU   LRBHCSW1
@NM00012 EQU   LRBHCSW1
LRBCINCO EQU   LRBHCSW1
LRBCMESG EQU   LRBHCSW1
@NM00011 EQU   LRBHRSW1
LRBRSYSI EQU   LRBHRSW1
LRBROPER EQU   LRBHRSW1
LRBRSEC  EQU   LRBHRSW1
LRBRPRIM EQU   LRBHRSW1
CVTRV628 EQU   CVTS01+728
CVTRV627 EQU   CVTS01+724
CVTRV626 EQU   CVTS01+720
CVTRV625 EQU   CVTS01+716
CVTRV624 EQU   CVTS01+712
CVTRV623 EQU   CVTS01+708
CVTRV622 EQU   CVTS01+704
CVTRV621 EQU   CVTS01+700
CVTSUSP  EQU   CVTS01+692
CVTT6SVC EQU   CVTS01+688
CVTCDAL  EQU   CVTS01+684
CVTTCTL  EQU   CVTS01+680
CVTRSUME EQU   CVTS01+676
CVTJTERM EQU   CVTS01+672
CVTASMRM EQU   CVTS01+668
CVTTCASP EQU   CVTS01+664
CVT0PT03 EQU   CVTS01+660
CVT0PT0E EQU   CVTS01+656
CVTRV609 EQU   CVTS01+652
CVTCGK   EQU   CVTS01+648
CVTRAC   EQU   CVTS01+644
CVTHSM   EQU   CVTS01+640
CVTRV605 EQU   CVTS01+636
CVTRV604 EQU   CVTS01+632
CVTEFF02 EQU   CVTS01+628
CVTCBBR  EQU   CVTS01+624
CVTSSCR  EQU   CVTS01+620
CVTEVENT EQU   CVTS01+616
CVTCRCA  EQU   CVTS01+612
CVTTPIO  EQU   CVTS01+608
CVTADV   EQU   CVTS01+604
CVTGSDAB EQU   CVTGSDA
CVTQV3   EQU   CVTS01+596
CVTQV2   EQU   CVTS01+592
CVTQV1   EQU   CVTS01+588
CVTRPT   EQU   CVTS01+584
CVTSSRB  EQU   CVTS01+580
CVTCSDRL EQU   CVTS01+576
CVTEXP1  EQU   CVTS01+572
CVTRMPMT EQU   CVTS01+568
CVTRMPTT EQU   CVTS01+564
CVTVPSA  EQU   CVTS01+560
CVTVSTOP EQU   CVTS01+556
CVTGTFR8 EQU   CVTS01+552
CVTQUIT  EQU   CVTS01+548
CVTVACR  EQU   CVTS01+544
CVTWTCB  EQU   CVTS01+540
CVTSTPRS EQU   CVTS01+536
CVT0PT02 EQU   CVTS01+532
CVTDARCM EQU   CVTS01+528
CVTIRECM EQU   CVTS01+524
CVTJRECM EQU   CVTS01+520
CVTVEMS0 EQU   CVTS01+516
CVTSPFRR EQU   CVTS01+512
CVTRLSTG EQU   CVTS01+508
CVT0TC0A EQU   CVTS01+504
CVTGMBR  EQU   CVTS01+500
CVTLFRM  EQU   CVTS01+496
CVTRMBR  EQU   CVTS01+492
CVTVIOP  EQU   CVTS01+488
CVTRV307 EQU   CVTS01+486
CVTRV306 EQU   CVTS01+484
CVTRV305 EQU   CVTS01+482
CVTRV304 EQU   CVTS01+480
CVTRV303 EQU   CVTS01+478
CVTRV302 EQU   CVTS01+476
CVTTRCA  EQU   CVTS01+472
CVTRV297 EQU   CVTRV289
CVTRV296 EQU   CVTRV289
CVTRV295 EQU   CVTRV289
CVTRV294 EQU   CVTRV289
CVTRV293 EQU   CVTRV289
CVTRV292 EQU   CVTRV289
CVTRV291 EQU   CVTRV289
CVTRV290 EQU   CVTRV289
CVTRV288 EQU   CVTRV280
CVTRV287 EQU   CVTRV280
CVTRV286 EQU   CVTRV280
CVTRV285 EQU   CVTRV280
CVTRV284 EQU   CVTRV280
CVTRV283 EQU   CVTRV280
CVTRV282 EQU   CVTRV280
CVTRV281 EQU   CVTRV280
CVTRV279 EQU   CVTRV271
CVTRV278 EQU   CVTRV271
CVTRV277 EQU   CVTRV271
CVTRV276 EQU   CVTRV271
CVTRV275 EQU   CVTRV271
CVTRV274 EQU   CVTRV271
CVTRV273 EQU   CVTRV271
CVTRV272 EQU   CVTRV271
CVTRV270 EQU   CVTRV262
CVTRV269 EQU   CVTRV262
CVTRV268 EQU   CVTRV262
CVTRV267 EQU   CVTRV262
CVTRV266 EQU   CVTRV262
CVTRV265 EQU   CVTRV262
CVTRV264 EQU   CVTRV262
CVTRV263 EQU   CVTRV262
CVTVFP   EQU   CVTS01+464
CVTVSI   EQU   CVTS01+460
CVTVPSIB EQU   CVTS01+456
CVTMFACT EQU   CVTMFRTR
CVTMFCTL EQU   CVTS01+448
CVTPVBP  EQU   CVTS01+444
CVTPWI   EQU   CVTS01+440
CVTRV254 EQU   CVTS01+438
CVTRV253 EQU   CVTS01+436
CVTRV252 EQU   CVTS01+434
CVTRV251 EQU   CVTS01+433
CVTRV250 EQU   CVTS01+432
CVTRV249 EQU   CVTS01+431
CVTRV248 EQU   CVTS01+430
CVTRV247 EQU   CVTS01+429
CVTRV246 EQU   CVTS01+428
CVTRV245 EQU   CVTRV237
CVTRV244 EQU   CVTRV237
CVTRV243 EQU   CVTRV237
CVTRV242 EQU   CVTRV237
CVTRV241 EQU   CVTRV237
CVTRV240 EQU   CVTRV237
CVTRV239 EQU   CVTRV237
CVTRV238 EQU   CVTRV237
CVTRV236 EQU   CVTRV228
CVTRV235 EQU   CVTRV228
CVTRV234 EQU   CVTRV228
CVTRV233 EQU   CVTRV228
CVTRV232 EQU   CVTRV228
CVTRV231 EQU   CVTRV228
CVTRV230 EQU   CVTRV228
CVTRV229 EQU   CVTRV228
CVTRV227 EQU   CVTRV219
CVTRV226 EQU   CVTRV219
CVTRV225 EQU   CVTRV219
CVTRV224 EQU   CVTRV219
CVTRV223 EQU   CVTRV219
CVTRV222 EQU   CVTRV219
CVTRV221 EQU   CVTRV219
CVTRV220 EQU   CVTRV219
CVTRV218 EQU   CVTRV210
CVTRV217 EQU   CVTRV210
CVTRV216 EQU   CVTRV210
CVTRV215 EQU   CVTRV210
CVTRV214 EQU   CVTRV210
CVTRV213 EQU   CVTRV210
CVTRV212 EQU   CVTRV210
CVTRV211 EQU   CVTRV210
CVTLCCAT EQU   CVTS01+420
CVTIPCRP EQU   CVTS01+412
CVTIPCRI EQU   CVTS01+408
CVTIPCDS EQU   CVTS01+404
CVTAIDVT EQU   CVTS01+400
CVTSSAP  EQU   CVTS01+396
CVTEHCIR EQU   CVTS01+392
CVTEHDEF EQU   CVTS01+388
CVTDAIR  EQU   CVTS01+384
CVTPERFM EQU   CVTS01+380
CVT044R2 EQU   CVTS01+376
CVTFETCH EQU   CVTS01+372
CVTRSTWD EQU   CVTS01+368
CVTSPOST EQU   CVTS01+364
CVTIOBP  EQU   CVTS01+360
CVTASMVT EQU   CVTS01+356
CVTRECRQ EQU   CVTS01+352
CVTWSAC  EQU   CVTS01+348
CVTRV149 EQU   CVTS01+344
CVTWSAL  EQU   CVTS01+340
CVTSPSA  EQU   CVTS01+336
CVTGLMN  EQU   CVTS01+332
CVTVEAC0 EQU   CVTS01+328
CVT062R1 EQU   CVTS01+324
CVTRPOST EQU   CVTS01+320
CVTDQIQE EQU   CVTS01+316
CVTCSD   EQU   CVTS01+312
CVTLKRMA EQU   CVTS01+308
CVTRSPIE EQU   CVTS01+304
CVTRENQ  EQU   CVTS01+300
CVTLQCB  EQU   CVTS01+296
CVTFQCB  EQU   CVTS01+292
CVTQCS01 EQU   CVTS01+288
CVTAPFT  EQU   CVTS01+284
CVTPARRL EQU   CVTS01+280
CVTVWAIT EQU   CVTS01+276
CVTGSPL  EQU   CVTS01+272
CVTLSMQ  EQU   CVTS01+268
CVTGSMQ  EQU   CVTS01+264
CVTEXPRO EQU   CVTS01+260
CVTOPCTP EQU   CVTS01+256
CVTSIC   EQU   CVTS01+252
CVTTPIOS EQU   CVTS01+248
CVTRTMS  EQU   CVTS01+244
CVTSDBF  EQU   CVTS01+240
CVTSCBP  EQU   CVTS01+236
CVTSDMP  EQU   CVTS01+232
CVTSV60  EQU   CVTS01+228
CVTASCBL EQU   CVTS01+220
CVTASCBH EQU   CVTS01+216
CVTGDA   EQU   CVTS01+212
CVTASVT  EQU   CVTS01+208
CVTVVMDI EQU   CVTS01+204
CVTAQTOP EQU   CVTS01+200
CVTIOSCS EQU   CVTS01+196
CVTSDRM  EQU   CVTS01+192
CVTOPTE  EQU   CVTS01+188
CVTSTXU  EQU   CVTS01+184
CVTQUIS  EQU   CVTS01+180
CVTPARS  EQU   CVTS01+176
CVTS1EE  EQU   CVTS01+172
CVTFRAS  EQU   CVTS01+168
CVTQSAS  EQU   CVTS01+164
CVTCRAS  EQU   CVTS01+160
CVTCRMN  EQU   CVTS01+156
CVTDELCP EQU   CVTS01+152
CVTFRECL EQU   CVTS01+148
CVTGETCL EQU   CVTS01+144
CVTBLDCP EQU   CVTS01+140
CVTAUTHL EQU   CVTS01+136
CVTSCAN  EQU   CVTS01+132
CVTRV144 EQU   CVTS01+130
CVTMAXMP EQU   CVTS01+128
CVTSTCK  EQU   CVTS01+124
CVTRV139 EQU   CVTS01+123
CVTDSSAC EQU   CVTS01+122
CVTRV513 EQU   CVTS01+121
CVTIOSPL EQU   CVTS01+120
CVTPTGT  EQU   CVTS01+116
CVTCSPIE EQU   CVTS01+112
CVTSMFEX EQU   CVTS01+108
CVTOLT0A EQU   CVTS01+104
CVTSRBRT EQU   CVTS01+100
CVTPUTL  EQU   CVTS01+96
CVTASCRL EQU   CVTS01+92
CVTASCRF EQU   CVTS01+88
CVTRV326 EQU   CVTS01+84
CVTRV325 EQU   CVTS01+80
CVTRV324 EQU   CVTS01+76
CVT0VL01 EQU   CVTS01+72
CVTSHRVM EQU   CVTS01+68
CVTRV332 EQU   CVTS01+64
CVTTAS   EQU   CVTS01+60
CVTRSCN  EQU   CVTS01+56
CVTTRAC2 EQU   CVTS01+54
CVTTRACE EQU   CVTS01+52
CVTAPG   EQU   CVTS01+51
CVTSDTRC EQU   CVTCTLFG
CVTGTRCE EQU   CVTCTLFG
CVTNOMP  EQU   CVTCTLFG
CVTRSV79 EQU   CVTCTLFG
CVTDSTAT EQU   CVTCTLFG
CVTRSV78 EQU   CVTCTLFG
CVTRV333 EQU   CVTCTLFG
CVTRV323 EQU   CVTCTLFG
CVTSPVLK EQU   CVTS01+49
CVTRSV77 EQU   CVTS01+48
CVTRV331 EQU   CVTS01+44
CVTRV330 EQU   CVTS01+40
CVTRV329 EQU   CVTS01+36
CVTRV328 EQU   CVTS01+32
CVTRV322 EQU   CVTS01+28
CVTSLID  EQU   CVTSLIDA+1
CVTSYLK  EQU   CVTSLIDA
CVTRV321 EQU   CVTS01+20
CVTRV320 EQU   CVTS01+16
CVTLPDIR EQU   CVTLPDIA+1
CVTRSV69 EQU   CVTDIRST
CVTRSV68 EQU   CVTDIRST
CVTRSV67 EQU   CVTDIRST
CVTRSV66 EQU   CVTDIRST
CVTRSV65 EQU   CVTDIRST
CVTRSV64 EQU   CVTDIRST
CVTRSV63 EQU   CVTDIRST
CVTDICOM EQU   CVTDIRST
CVTPVTP  EQU   CVTS01+8
CVTLPDSR EQU   CVTS01+4
CVTGETL  EQU   CVTS01
@NM00118 EQU   RFLG
@NM00117 EQU   RFLG
DATAADR  EQU   DATAWORD+1
@NM00102 EQU   BEHDR+4
RDY      EQU   BFLGS+1
POST     EQU   BFLGS+1
@NM00101 EQU   BFLGS
WRITE    EQU   BFLGS
WRAP     EQU   BFLGS
SURV104  EQU   SUBITS+13
SURV103  EQU   SUBYTE13
SURV102  EQU   SUBYTE13
SURV101  EQU   SUBYTE13
SU100BT  EQU   SUBYTE13
SU99BIT  EQU   SUBYTE13
SU98BIT  EQU   SUBYTE13
SU97BIT  EQU   SUBYTE13
SU96BIT  EQU   SUBYTE13
SU95BIT  EQU   SUBYTE12
SU94BIT  EQU   SUBYTE12
SU93BIT  EQU   SUBYTE12
SU92BIT  EQU   SUBYTE12
SU91BIT  EQU   SUBYTE12
SU90BIT  EQU   SUBYTE12
SU89BIT  EQU   SUBYTE12
SU88BIT  EQU   SUBYTE12
SU87BIT  EQU   SUBYTE11
SU86BIT  EQU   SUBYTE11
SU85BIT  EQU   SUBYTE11
SU84BIT  EQU   SUBYTE11
SU83BIT  EQU   SUBYTE11
SU82BIT  EQU   SUBYTE11
SU81BIT  EQU   SUBYTE11
SU80BIT  EQU   SUBYTE11
SU79BIT  EQU   SUBYTE10
SU78BIT  EQU   SUBYTE10
SU77BIT  EQU   SUBYTE10
SU76BIT  EQU   SUBYTE10
SU75BIT  EQU   SUBYTE10
SU74BIT  EQU   SUBYTE10
SU73BIT  EQU   SUBYTE10
SU72BIT  EQU   SUBYTE10
SU71BIT  EQU   SUBYTE9
SU70BIT  EQU   SUBYTE9
SU69BIT  EQU   SUBYTE9
SU68BIT  EQU   SUBYTE9
SU67BIT  EQU   SUBYTE9
SU66BIT  EQU   SUBYTE9
SU65BIT  EQU   SUBYTE9
SU64BIT  EQU   SUBYTE9
SU63BIT  EQU   SUBYTE8
SU62BIT  EQU   SUBYTE8
SU61BIT  EQU   SUBYTE8
SU60BIT  EQU   SUBYTE8
SU59BIT  EQU   SUBYTE8
SU58BIT  EQU   SUBYTE8
SU57BIT  EQU   SUBYTE8
SU56BIT  EQU   SUBYTE8
SU55BIT  EQU   SUBYTE7
SU54BIT  EQU   SUBYTE7
SU53BIT  EQU   SUBYTE7
SU52BIT  EQU   SUBYTE7
SU51BIT  EQU   SUBYTE7
SU50BIT  EQU   SUBYTE7
SU49BIT  EQU   SUBYTE7
SU48BIT  EQU   SUBYTE7
SU47BIT  EQU   SUBYTE6
SU46BIT  EQU   SUBYTE6
SU45BIT  EQU   SUBYTE6
SU44BIT  EQU   SUBYTE6
SU43BIT  EQU   SUBYTE6
SU42BIT  EQU   SUBYTE6
SU41BIT  EQU   SUBYTE6
SU40BIT  EQU   SUBYTE6
SU39BIT  EQU   SUBYTE5
SU38BIT  EQU   SUBYTE5
SU37BIT  EQU   SUBYTE5
SU36BIT  EQU   SUBYTE5
SU35BIT  EQU   SUBYTE5
SU34BIT  EQU   SUBYTE5
SU33BIT  EQU   SUBYTE5
SU32BIT  EQU   SUBYTE5
SU31BIT  EQU   SUBYTE4
SU30BIT  EQU   SUBYTE4
SU29BIT  EQU   SUBYTE4
SU28BIT  EQU   SUBYTE4
SU26BIT  EQU   SUBYTE4
SU25BIT  EQU   SUBYTE4
SU24BIT  EQU   SUBYTE4
SU23BIT  EQU   SUBYTE3
SU22BIT  EQU   SUBYTE3
SU21BIT  EQU   SUBYTE3
SU20BIT  EQU   SUBYTE3
SU19BIT  EQU   SUBYTE3
SU18BIT  EQU   SUBYTE3
SU17BIT  EQU   SUBYTE3
SU16BIT  EQU   SUBYTE3
SU15BIT  EQU   SUBYTE2
SU14BIT  EQU   SUBYTE2
SU13BIT  EQU   SUBYTE2
SU12BIT  EQU   SUBYTE2
SU11BIT  EQU   SUBYTE2
SU10BIT  EQU   SUBYTE2
SU9BIT   EQU   SUBYTE2
SU8BIT   EQU   SUBYTE2
SU7BIT   EQU   SUBYTE1
SU6BIT   EQU   SUBYTE1
SU5BIT   EQU   SUBYTE1
SU4BIT   EQU   SUBYTE1
SU3BIT   EQU   SUBYTE1
SU2BIT   EQU   SUBYTE1
SU1BIT   EQU   SUBYTE1
SU0BIT   EQU   SUBYTE1
@NM00099 EQU   SDWA+512
SDWAVRA  EQU   SDWARA+4
SDWAURAL EQU   SDWARA+3
@NM00098 EQU   SDWADPVA
SDWAEBC  EQU   SDWADPVA
SDWAHEX  EQU   SDWADPVA
SDWAVRAL EQU   SDWARA
SDWAERTM EQU   SDWA+396
SDWACOMP EQU   SDWA+392
SDWARCPL EQU   SDWA+364
@NM00097 EQU   SDWADPSA+32
SDWATO4  EQU   SDWADPSL+28
SDWAFRM4 EQU   SDWADPSL+24
SDWATO3  EQU   SDWADPSL+20
SDWAFRM3 EQU   SDWADPSL+16
SDWATO2  EQU   SDWADPSL+12
SDWAFRM2 EQU   SDWADPSL+8
SDWATO1  EQU   SDWADPSL+4
SDWAFRM1 EQU   SDWADPSL
@NM00096 EQU   SDWADDAT+3
@NM00095 EQU   SDWAPDAT
SDWAUSPL EQU   SDWAPDAT
SDWADPSW EQU   SDWAPDAT
SDWATJPA EQU   SDWAPDAT
SDWATLPA EQU   SDWAPDAT
SDWADREG EQU   SDWAPDAT
SDWADSAH EQU   SDWAPDAT
SDWADSAS EQU   SDWAPDAT
@NM00094 EQU   SDWASDA1
SDWAERR  EQU   SDWASDA1
SDWAIO   EQU   SDWASDA1
SDWADM   EQU   SDWASDA0
SDWAQQS  EQU   SDWASDA0
SDWACBS  EQU   SDWASDA0
SDWAGTF  EQU   SDWASDA0
SDWASWA  EQU   SDWASDA0
SDWALSQA EQU   SDWASDA0
SDWASQA  EQU   SDWASDA0
SDWANUC  EQU   SDWASDA0
@NM00093 EQU   SDWADUMP+2
@NM00092 EQU   SDWADPFS
SDWASLST EQU   SDWADPFS
@NM00091 EQU   SDWADPFS
SDWAENSN EQU   SDWADPFS
SDWADLST EQU   SDWADPFS
SDWADPT  EQU   SDWADPFS
SDWADPID EQU   SDWADUMP
SDWADPLA EQU   SDWA+316
SDWAREXN EQU   SDWARECP+16
SDWACSCT EQU   SDWARECP+8
SDWAMODN EQU   SDWARECP
SDWASEQ# EQU   SDWA+290
SDWAASID EQU   SDWA+288
SDWATALW EQU   SDWALKWS+28
SDWATDLW EQU   SDWALKWS+24
SDWATNLW EQU   SDWALKWS+20
SDWAAPLW EQU   SDWALKWS+16
SDWAIPLW EQU   SDWALKWS+12
SDWAILLW EQU   SDWALKWS+8
SDWAIULW EQU   SDWALKWS+4
SDWAICLW EQU   SDWALKWS
SDWAFLLK EQU   SDWAACF4
SDWACMS  EQU   SDWAACF4
SDWAOPTM EQU   SDWAACF4
SDWATADB EQU   SDWAACF4
SDWATDNB EQU   SDWAACF4
SDWATNCB EQU   SDWAACF4
SDWAILCH EQU   SDWAACF4
SDWAIUCB EQU   SDWAACF4
SDWAICAT EQU   SDWAACF3
SDWAIPRG EQU   SDWAACF3
SDWASALL EQU   SDWAACF3
SDWAASMP EQU   SDWAACF3
SDWADISP EQU   SDWAACF3
@NM00090 EQU   SDWAACF3
@NM00089 EQU   SDWAACF2
@NM00088 EQU   SDWAACF2
SDWASPIN EQU   SDWAACF2
@NM00087 EQU   SDWAACF2
SDWARCRD EQU   SDWAACF2
SDWALCPU EQU   SDWACPUA+2
@NM00086 EQU   SDWACPUA
SDWARECA EQU   SDWA+244
SDWACPUI EQU   SDWA+239
@NM00085 EQU   SDWAIOFS
SDWANIOP EQU   SDWAIOFS
SDWANOIO EQU   SDWAIOFS
SDWAIOHT EQU   SDWAIOFS
SDWAIOQR EQU   SDWAIOFS
SDWAFMID EQU   SDWA+236
SDWAERFL EQU   SDWAERRD
SDWAMCIV EQU   SDWAERRD
SDWARPIV EQU   SDWAERRD
SDWAMABD EQU   SDWAERRD
SDWACTS  EQU   SDWAERRD
SDWASTAE EQU   SDWAERRD
SDWANRBE EQU   SDWAERRD
SDWACLUP EQU   SDWAERRD
@NM00084 EQU   SDWAERRC
SDWAEAS  EQU   SDWAERRC
SDWAPERC EQU   SDWAERRC
SDWAIRB  EQU   SDWAERRC
SDWASTAI EQU   SDWAERRC
SDWASTAF EQU   SDWAERRC
SDWASRBM EQU   SDWAERRB
SDWALDIS EQU   SDWAERRB
SDWAENRB EQU   SDWAERRB
SDWATYP1 EQU   SDWAERRB
@NM00083 EQU   SDWAERRB
SDWAPGIO EQU   SDWAERRA
SDWATEXC EQU   SDWAERRA
SDWASVCE EQU   SDWAERRA
SDWAABTM EQU   SDWAERRA
SDWASVCD EQU   SDWAERRA
SDWARKEY EQU   SDWAERRA
SDWAPCHK EQU   SDWAERRA
SDWAMCHK EQU   SDWAERRA
SDWATIME EQU   SDWAMCH+20
SDWARFSA EQU   SDWAMCH+16
@NM00082 EQU   SDWAMCH+14
SDWAVEQR EQU   SDWARSR2
SDWAPGFX EQU   SDWARSR2
SDWAFLSQ EQU   SDWARSR2
SDWAFSQA EQU   SDWARSR2
SDWANUCL EQU   SDWARSR2
SDWASPER EQU   SDWARSR2
SDWAINTC EQU   SDWARSR2
SDWAOFLN EQU   SDWARSR2
SDWACHNG EQU   SDWARSR1
SDWAMSER EQU   SDWARSR1
@NM00081 EQU   SDWARSR1
SDWACPID EQU   SDWAMCH+10
SDWATERR EQU   SDWAMCHD
SDWAFPRX EQU   SDWAMCHD
SDWAINSF EQU   SDWAMCHD
SDWAACR  EQU   SDWAMCHD
SDWASCK  EQU   SDWAMCHD
SDWAPSWU EQU   SDWAMCHD
SDWAREGU EQU   SDWAMCHD
SDWASKYF EQU   SDWAMCHD
@NM00080 EQU   SDWAMCHS
SDWARSRF EQU   SDWAMCHS
SDWARSRC EQU   SDWAMCHS
SDWAINVP EQU   SDWAMCHS
SDWATSVL EQU   SDWAMCHS
SDWARCDF EQU   SDWAMCHS
SDWASRVL EQU   SDWAMCHS
SDWASCKE EQU   SDWASTCK+4
SDWASCKB EQU   SDWASTCK
SDWALNTH EQU   SDWAIDNT+1
SDWASPID EQU   SDWAIDNT
SDWASR15 EQU   SDWASRSV+60
SDWASR14 EQU   SDWASRSV+56
SDWASR13 EQU   SDWASRSV+52
SDWASR12 EQU   SDWASRSV+48
SDWASR11 EQU   SDWASRSV+44
SDWASR10 EQU   SDWASRSV+40
SDWASR09 EQU   SDWASRSV+36
SDWASR08 EQU   SDWASRSV+32
SDWASR07 EQU   SDWASRSV+28
SDWASR06 EQU   SDWASRSV+24
SDWASR05 EQU   SDWASRSV+20
SDWASR04 EQU   SDWASRSV+16
SDWASR03 EQU   SDWASRSV+12
SDWASR02 EQU   SDWASRSV+8
SDWASR01 EQU   SDWASRSV+4
SDWASR00 EQU   SDWASRSV
SDWATRN2 EQU   SDWAAEC2+4
SDWAIPC2 EQU   SDWAICD2
SDWAIMC2 EQU   SDWAICD2
SDWAIPR2 EQU   SDWAICD2
@NM00079 EQU   SDWAINC2
@NM00078 EQU   SDWAILC2
SDWAIL2  EQU   SDWAILC2
@NM00077 EQU   SDWAILC2
@NM00076 EQU   SDWAAEC2
SDWAADD2 EQU   SDWANXT2+1
@NM00075 EQU   SDWANXT2
@NM00074 EQU   SDWAEC2+3
SDWASGN2 EQU   SDWAINT2
SDWAEXP2 EQU   SDWAINT2
SDWADEC2 EQU   SDWAINT2
SDWAFPO2 EQU   SDWAINT2
SDWACC2  EQU   SDWAINT2
@NM00073 EQU   SDWAINT2
SDWAPGM2 EQU   SDWAMWP2
SDWAWAT2 EQU   SDWAMWP2
SDWAMCK2 EQU   SDWAMWP2
SDWAECT2 EQU   SDWAMWP2
SDWAKEY2 EQU   SDWAMWP2
SDWAEXT2 EQU   SDWAEMK2
SDWAIO2  EQU   SDWAEMK2
SDWATRM2 EQU   SDWAEMK2
@NM00072 EQU   SDWAEMK2
SDWAPER2 EQU   SDWAEMK2
@NM00071 EQU   SDWAEMK2
SDWATRAN EQU   SDWAAEC1+4
SDWAIPC1 EQU   SDWAICD1
SDWAIMC1 EQU   SDWAICD1
SDWAIPR1 EQU   SDWAICD1
@NM00070 EQU   SDWAINC1
@NM00069 EQU   SDWAILC1
SDWAIL1  EQU   SDWAILC1
@NM00068 EQU   SDWAILC1
@NM00067 EQU   SDWAAEC1
SDWAADD1 EQU   SDWANXT1+1
@NM00066 EQU   SDWANXT1
@NM00065 EQU   SDWAEC1+3
SDWASGN1 EQU   SDWAINT1
SDWAEXP1 EQU   SDWAINT1
SDWADEC1 EQU   SDWAINT1
SDWAFPO1 EQU   SDWAINT1
SDWACC1  EQU   SDWAINT1
@NM00064 EQU   SDWAINT1
SDWAPGM1 EQU   SDWAMWP1
SDWAWAT1 EQU   SDWAMWP1
SDWAMCK1 EQU   SDWAMWP1
SDWAECT1 EQU   SDWAMWP1
SDWAKEY1 EQU   SDWAMWP1
SDWAEXT1 EQU   SDWAEMK1
SDWAIO1  EQU   SDWAEMK1
SDWATRM1 EQU   SDWAEMK1
@NM00063 EQU   SDWAEMK1
SDWAPER1 EQU   SDWAEMK1
@NM00062 EQU   SDWAEMK1
SDWAIOBR EQU   SDWA+100
SDWAEPA  EQU   SDWA+96
@NM00061 EQU   SDWANAME+4
SDWARBAD EQU   SDWANAME
SDWAGR15 EQU   SDWAGRSV+60
SDWAGR14 EQU   SDWAGRSV+56
SDWAGR13 EQU   SDWAGRSV+52
SDWAGR12 EQU   SDWAGRSV+48
SDWAGR11 EQU   SDWAGRSV+44
SDWAGR10 EQU   SDWAGRSV+40
SDWAGR09 EQU   SDWAGRSV+36
SDWAGR08 EQU   SDWAGRSV+32
SDWAGR07 EQU   SDWAGRSV+28
SDWAGR06 EQU   SDWAGRSV+24
SDWAGR05 EQU   SDWAGRSV+20
SDWAGR04 EQU   SDWAGRSV+16
SDWAGR03 EQU   SDWAGRSV+12
SDWAGR02 EQU   SDWAGRSV+8
SDWAGR01 EQU   SDWAGRSV+4
SDWAGR00 EQU   SDWAGRSV
SDWANXTP EQU   SDWACTL2+5
SDWASGP  EQU   SDWAPMKP
SDWAEUP  EQU   SDWAPMKP
SDWADOP  EQU   SDWAPMKP
SDWAFPP  EQU   SDWAPMKP
SDWACCP  EQU   SDWAPMKP
SDWAILP  EQU   SDWAPMKP
SDWAINTP EQU   SDWACTL2+2
SDWASPVP EQU   SDWAMWPP
SDWAWATP EQU   SDWAMWPP
SDWAMCKP EQU   SDWAMWPP
@NM00060 EQU   SDWAMWPP
SDWAKEYP EQU   SDWAMWPP
SDWAEXTP EQU   SDWACMKP
SDWAIOP  EQU   SDWACMKP
SDWANXTA EQU   SDWACTL1+5
SDWASGA  EQU   SDWAPMKA
SDWAEUA  EQU   SDWAPMKA
SDWADOA  EQU   SDWAPMKA
SDWAFPA  EQU   SDWAPMKA
SDWACCA  EQU   SDWAPMKA
SDWAILA  EQU   SDWAPMKA
SDWAINTA EQU   SDWACTL1+2
SDWASPVA EQU   SDWAMWPA
SDWAWATA EQU   SDWAMWPA
SDWAMCKA EQU   SDWAMWPA
@NM00059 EQU   SDWAMWPA
SDWAKEYA EQU   SDWAMWPA
SDWAEXTA EQU   SDWACMKA
SDWAIOA  EQU   SDWACMKA
@NM00058 EQU   SDWACMPF
SDWASTCC EQU   SDWACMPF
@NM00057 EQU   SDWACMPF
SDWASTEP EQU   SDWACMPF
SDWAPARM EQU   SDWA
RTCTISVC EQU   RTCTSDO4
RTCTSDOV EQU   RTCTSDMG
@NM00056 EQU   RTCTSDO4
@NM00055 EQU   RTCTSDO3
RTCTSDPH EQU   RTCTSDO3
RTCTSDPG EQU   RTCTSDO3
@NM00054 EQU   RTCTSDO2
RTCTSDPD EQU   RTCTSDO2
RTCTSDPC EQU   RTCTSDO2
RTCTSDPB EQU   RTCTSDO2
RTCTSDPA EQU   RTCTSDO2
RTCTSDP9 EQU   RTCTSDO2
RTCTSDP8 EQU   RTCTSDO2
RTCTSDP7 EQU   RTCTSDO1
RTCTSDP6 EQU   RTCTSDO1
RTCTSDP5 EQU   RTCTSDO1
RTCTSDP4 EQU   RTCTSDO1
RTCTSDP3 EQU   RTCTSDO1
RTCTSDP2 EQU   RTCTSDO1
RTCTSDP1 EQU   RTCTSDO1
RTCTSDP0 EQU   RTCTSDO1
RTCTISYM EQU   RTCTSD04
RTCTSMOV EQU   RTCTSMMG
@NM00053 EQU   RTCTSD04
RTCTSD03 EQU   RTCTMSYO+2
RTCTSD02 EQU   RTCTMSYO+1
RTCTSDS7 EQU   RTCTSD01
RTCTSDS6 EQU   RTCTSD01
RTCTSDS5 EQU   RTCTSD01
RTCTSDS4 EQU   RTCTSD01
RTCTSDS3 EQU   RTCTSD01
RTCTSDS2 EQU   RTCTSD01
RTCTSDS1 EQU   RTCTSD01
RTCTSDS0 EQU   RTCTSD01
RTCTISYU EQU   RTCTSUO4
RTCTSUOV EQU   RTCTSUMG
@NM00052 EQU   RTCTSUO4
RTCTSYDF EQU   RTCTSUO3
RTCTSYDE EQU   RTCTSUO3
RTCTSYDD EQU   RTCTSUO3
RTCTSYDC EQU   RTCTSUO3
RTCTSYDB EQU   RTCTSUO3
RTCTSYDA EQU   RTCTSUO3
RTCTSYD9 EQU   RTCTSUO3
RTCTSYD8 EQU   RTCTSUO3
@NM00051 EQU   RTCTSUO2
RTCTSYDH EQU   RTCTSUO2
RTCTSYDG EQU   RTCTSUO2
RTCTSYD7 EQU   RTCTSUO1
RTCTSYD6 EQU   RTCTSUO1
RTCTSYD5 EQU   RTCTSUO1
RTCTSYD4 EQU   RTCTSUO1
RTCTSYD3 EQU   RTCTSUO1
RTCTSYD2 EQU   RTCTSUO1
RTCTSYD1 EQU   RTCTSUO1
RTCTSYD0 EQU   RTCTSUO1
RTCTISAB EQU   RTCTSAO4
RTCTSAOV EQU   RTCTSAMG
@NM00050 EQU   RTCTSAO4
RTCTSADF EQU   RTCTSAO3
RTCTSADE EQU   RTCTSAO3
RTCTSADD EQU   RTCTSAO3
RTCTSADC EQU   RTCTSAO3
RTCTSADB EQU   RTCTSAO3
RTCTSADA EQU   RTCTSAO3
RTCTSAD9 EQU   RTCTSAO3
RTCTSAD8 EQU   RTCTSAO3
@NM00049 EQU   RTCTSAO2
RTCTSADH EQU   RTCTSAO2
RTCTSADG EQU   RTCTSAO2
RTCTSAD7 EQU   RTCTSAO1
RTCTSAD6 EQU   RTCTSAO1
RTCTSAD5 EQU   RTCTSAO1
RTCTSAD4 EQU   RTCTSAO1
RTCTSAD3 EQU   RTCTSAO1
RTCTSAD2 EQU   RTCTSAO1
RTCTSAD1 EQU   RTCTSAO1
RTCTSAD0 EQU   RTCTSAO1
RTCTZZZ5 EQU   RTCT+340
RTCTZZZ4 EQU   RTCT+336
RTCTMRMQ EQU   RTCT+332
RTCTSDF5 EQU   RTCTSDF3+3
RTCTSDDO EQU   RTCTSDF4
RTCTSDEN EQU   RTCTSDF4
RTCTSDEQ EQU   RTCTSDF4
RTCTSDTR EQU   RTCTSDF4
RTCTSDRM EQU   RTCTSDF4
RTCTSDAN EQU   RTCTSDF4
RTCTSDNC EQU   RTCTSDF4
RTCTSDSS EQU   RTCTSDF4
RTCTSDAS EQU   RTCTSDF3
RTCTZZZ3 EQU   RTCT+266
@NM00048 EQU   RTCTSDF2
RTCTSDRW EQU   RTCTSDF2
RTCTSDSL EQU   RTCTSDF2
RTCTSDWF EQU   RTCTSDF2
RTCTSDLA EQU   RTCTSDF2
RTCTSDDI EQU   RTCTSDF2
RTCTSDTQ EQU   RTCTSDF2
RTCTSDMR EQU   RTCTSDF2
RTCTSDSC EQU   RTCTSDF1
RTCTSDRS EQU   RTCTSDF1
RTCTSDSD EQU   RTCTSDF1
RTCTSDEP EQU   RTCTSDF1
RTCTSDMA EQU   RTCTSDF1
RTCTSDSH EQU   RTCTSDF1
RTCTSDND EQU   RTCTSDF1
RTCTSDNO EQU   RTCTSDF1
RTCTZZZ2 EQU   RTCT+257
RTCTSDPR EQU   RTCTSDI+2
RTCTINDX EQU   RTCTSDI+1
RTCTSDNA EQU   RTCTSDI
@NM00047 EQU   RTCTASO2
RTCTASNQ EQU   RTCTASO2
RTCTASNA EQU   RTCTASO2
RTCTASNS EQU   RTCTASO2
RTCTASSU EQU   RTCTASO2
RTCTASSW EQU   RTCTASO2
RTCTASCS EQU   RTCTASO2
RTCTASTR EQU   RTCTASO1
RTCTASLP EQU   RTCTASO1
RTCTASRG EQU   RTCTASO1
RTCTASLS EQU   RTCTASO1
RTCTASSQ EQU   RTCTASO1
RTCTASNU EQU   RTCTASO1
RTCTASPS EQU   RTCTASO1
RTCTASAL EQU   RTCTASO1
RTCTSDO  EQU   RTCTOPT+12
RTCTSYO  EQU   RTCTOPT+8
RTCTSUO  EQU   RTCTOPT+4
RTCTSAO  EQU   RTCTOPT
RTCTXXX2 EQU   RTCT+234
RTCTETIM EQU   RTCTERID+6
RTCTEASD EQU   RTCTERID+4
RTCTECPU EQU   RTCTERID+2
RTCTESEQ EQU   RTCTERID
RTCTSDWK EQU   RTCT+220
RTCTTDCB EQU   RTCT+184
RTCTSDSW EQU   RTCT+180
RTCTSEQ# EQU   RTCT+178
RTCTXXX1 EQU   RTCT+177
@NM00046 EQU   RTCTRFLG
RTCTRSTF EQU   RTCTRFLG
RTCTRPER EQU   RTCTRFLG
RTCTRTER EQU   RTCTRFLG
RTCTTEST EQU   RTCT+172
RTCTMSRB EQU   RTCT+168
RTCTMLCK EQU   RTCT+164
RTCTFMT  EQU   RTCT+160
RTCTSDIP EQU   RTCTSDPL
RTCTDEV  EQU   RTCTSDDS+8
RTCTDCB  EQU   RTCTSDDS+4
@NM00045 EQU   RTCTFLG
RTCTDETP EQU   RTCTFLG
RTCTDSUS EQU   RTCTFLG
RTCTDSST EQU   RTCTFLG
RTCTDSNM EQU   RTCTSDDS
RTCTRECB EQU   RTCT+28
RTCTFASB EQU   RTCT+24
RTCTMECB EQU   RTCT+20
RTCTSDID EQU   RTCT+18
RTCTYYY1 EQU   RTCT+16
RTCTSY04 EQU   RTCTSYD+3
RTCTSY03 EQU   RTCTSYD+2
RTCTSY02 EQU   RTCTSYD+1
RTCTSYM7 EQU   RTCTSY01
RTCTSYM6 EQU   RTCTSY01
RTCTSYM5 EQU   RTCTSY01
RTCTSYM4 EQU   RTCTSY01
RTCTSYM3 EQU   RTCTSY01
RTCTSYM2 EQU   RTCTSY01
RTCTSYM1 EQU   RTCTSY01
RTCTSYM0 EQU   RTCTSY01
RTCTSUP4 EQU   RTCTSUP+3
RTCTSUDF EQU   RTCTSUP3
RTCTSUDE EQU   RTCTSUP3
RTCTSUDD EQU   RTCTSUP3
RTCTSUDC EQU   RTCTSUP3
RTCTSUDB EQU   RTCTSUP3
RTCTSUDA EQU   RTCTSUP3
RTCTSUD9 EQU   RTCTSUP3
RTCTSUD8 EQU   RTCTSUP3
@NM00044 EQU   RTCTSUP2
RTCTSUDH EQU   RTCTSUP2
RTCTSUDG EQU   RTCTSUP2
RTCTSUD7 EQU   RTCTSUP1
RTCTSUD6 EQU   RTCTSUP1
RTCTSUD5 EQU   RTCTSUP1
RTCTSUD4 EQU   RTCTSUP1
RTCTSUD3 EQU   RTCTSUP1
RTCTSUD2 EQU   RTCTSUP1
RTCTSUD1 EQU   RTCTSUP1
RTCTSUD0 EQU   RTCTSUP1
RTCTSAP4 EQU   RTCTSAP+3
RTCTSABF EQU   RTCTSAP3
RTCTSABE EQU   RTCTSAP3
RTCTSABD EQU   RTCTSAP3
RTCTSABC EQU   RTCTSAP3
RTCTSABB EQU   RTCTSAP3
RTCTSABA EQU   RTCTSAP3
RTCTSAB9 EQU   RTCTSAP3
RTCTSAB8 EQU   RTCTSAP3
@NM00043 EQU   RTCTSAP2
RTCTSABH EQU   RTCTSAP2
RTCTSABG EQU   RTCTSAP2
RTCTSAB7 EQU   RTCTSAP1
RTCTSAB6 EQU   RTCTSAP1
RTCTSAB5 EQU   RTCTSAP1
RTCTSAB4 EQU   RTCTSAP1
RTCTSAB3 EQU   RTCTSAP1
RTCTSAB2 EQU   RTCTSAP1
RTCTSAB1 EQU   RTCTSAP1
RTCTSAB0 EQU   RTCTSAP1
RTCTNAME EQU   RTCT
RCBBUFRS EQU   RCB+96
RCBTLNG  EQU   RCBCS2+2
RCBACNT  EQU   RCBCS2
@NM00042 EQU   RCBFLGS+1
@NM00041 EQU   RCBFLG1
RCBSRBIU EQU   RCBFLG1
RCBLCNT  EQU   RCBCS1
RCBLRHDR EQU   RCBCNTL+64
RCBSRB   EQU   RCBCNTL+16
RCBDUM   EQU   RCBCDS+6
RCBFLNG  EQU   RCBCDS+4
@NM00040 EQU   SRB+40
@NM00039 EQU   SRB+38
SRBPRIOR EQU   SRB+37
SRBPKF   EQU   SRB+36
SRBSAVE  EQU   SRB+32
SRBPARM  EQU   SRB+28
SRBRMTR  EQU   SRB+24
SRBEP    EQU   SRB+20
SRBPTCB  EQU   SRBFLC+4
SRBPASID EQU   SRBFLC+2
SRBCPAFF EQU   SRBFLC
SRBASCB  EQU   SRB+8
SRBFLNK  EQU   SRB+4
SRBID    EQU   SRB
PCCAT00P EQU   PCCAVT
@NM00038 EQU   PCCA+512
PCCACAT  EQU   PCCA+384
PCCARV36 EQU   PCCA+380
PCCARV35 EQU   PCCA+378
PCCARV01 EQU   PCCA+377
PCCAR105 EQU   PCCAATTR
PCCAR104 EQU   PCCAATTR
PCCAR103 EQU   PCCAATTR
PCCAR102 EQU   PCCAATTR
PCCAR101 EQU   PCCAATTR
PCCAR100 EQU   PCCAATTR
PCCAIO   EQU   PCCAATTR
PCCACPUM EQU   PCCAATTR
PCCARV63 EQU   PCCA+372
PCCARV62 EQU   PCCA+368
PCCARV61 EQU   PCCA+364
PCCARV60 EQU   PCCA+360
PCCARV59 EQU   PCCA+356
PCCARV58 EQU   PCCA+352
PCCARV57 EQU   PCCA+348
PCCARV56 EQU   PCCA+344
PCCARV55 EQU   PCCA+340
PCCARV54 EQU   PCCA+336
PCCALOGA EQU   PCCA+332
PCCACHID EQU   PCCA+324
PCCACHSV EQU   PCCA+312
PCCARV79 EQU   PCCACHF4
PCCARV78 EQU   PCCACHF4
PCCARV77 EQU   PCCACHF4
PCCARV76 EQU   PCCACHF4
PCCARV75 EQU   PCCACHF4
PCCARV74 EQU   PCCACHF4
PCCARV73 EQU   PCCACHF4
PCCARV72 EQU   PCCACHF4
PCCARV71 EQU   PCCACHF3
PCCARV70 EQU   PCCACHF3
PCCARV69 EQU   PCCACHF3
PCCARV68 EQU   PCCACHF3
PCCARV67 EQU   PCCACHF3
PCCARV66 EQU   PCCACHF3
PCCASLCK EQU   PCCACHF3
PCCAISRB EQU   PCCACHF3
PCCACF28 EQU   PCCACHF2
PCCACF27 EQU   PCCACHF2
PCCACF26 EQU   PCCACHF2
PCCACF25 EQU   PCCACHF2
PCCACF24 EQU   PCCACHF2
PCCACF23 EQU   PCCACHF2
PCCACF22 EQU   PCCACHF2
PCCACF21 EQU   PCCACHF2
PCCACF18 EQU   PCCACHF1
PCCACF17 EQU   PCCACHF1
PCCACF16 EQU   PCCACHF1
PCCACF15 EQU   PCCACHF1
PCCACF14 EQU   PCCACHF1
PCCACF13 EQU   PCCACHF1
PCCACF12 EQU   PCCACHF1
PCCACF11 EQU   PCCACHF1
PCCARV05 EQU   PCCA+307
PCCACHPB EQU   PCCA+306
PCCALGP2 EQU   PCCA+305
PCCALGP1 EQU   PCCA+304
PCCACELL EQU   PCCA+302
PCCALOGL EQU   PCCA+300
PCCACHW2 EQU   PCCA+296
PCCACHW1 EQU   PCCA+292
PCCAIOSI EQU   PCCA+291
PCCACNRB EQU   PCCACHRB
PCCACCVB EQU   PCCACHRB
PCCACSNB EQU   PCCACHRB
PCCARV52 EQU   PCCACHRB
PCCACHIB EQU   PCCACHRB
PCCACTIB EQU   PCCACHRB
PCCACINB EQU   PCCACHRB
PCCACSIB EQU   PCCACHRB
PCCARV51 EQU   PCCACHS2
PCCARV50 EQU   PCCACHS2
PCCACCRA EQU   PCCACHS2
PCCACURC EQU   PCCACHS2
PCCACNLG EQU   PCCACHS2
PCCACMOD EQU   PCCACHS2
PCCACALT EQU   PCCACHS2
PCCACIOR EQU   PCCACHS2
PCCARV47 EQU   PCCACHS1
PCCACUCB EQU   PCCACHS1
PCCACIBC EQU   PCCACHS1
PCCACAND EQU   PCCACHS1
PCCACNLS EQU   PCCACHS1
PCCACFRR EQU   PCCACHS1
PCCACNRE EQU   PCCACHS1
PCCACCMP EQU   PCCACHS1
PCCACSEQ EQU   PCCACHTS
PCCACDIN EQU   PCCACHTS
PCCARV44 EQU   PCCACHTS
PCCARV43 EQU   PCCACHTS
PCCACTEC EQU   PCCACHTS
PCCACDAV EQU   PCCACHVA
PCCACCHV EQU   PCCACHVA
PCCACCMD EQU   PCCACHVA
PCCACUNS EQU   PCCACHVA
PCCACSQV EQU   PCCACHVA
PCCARV42 EQU   PCCACHVA
PCCARV41 EQU   PCCACHVA
PCCACITF EQU   PCCACHVA
PCCARV40 EQU   PCCACHBL
PCCARV39 EQU   PCCACHBL
PCCARV38 EQU   PCCACHBL
PCCACCUE EQU   PCCACHBL
PCCACSTG EQU   PCCACHBL
PCCACSCU EQU   PCCACHBL
PCCACCHA EQU   PCCACHBL
PCCACCPU EQU   PCCACHBL
PCCACNOR EQU   PCCACHPF
PCCACCNT EQU   PCCACHPF
PCCACSNS EQU   PCCACHPF
PCCARV37 EQU   PCCACHPF
PCCACHIO EQU   PCCACHPF
PCCACTIO EQU   PCCACHPF
PCCACINT EQU   PCCACHPF
PCCACSIO EQU   PCCACHPF
PCCACHUB EQU   PCCAWERP
PCCAR106 EQU   PCCA+228
PCCAR113 EQU   PCCA+226
PCCASRBL EQU   PCCA+225
PCCAR112 EQU   PCCACHAN
PCCAR111 EQU   PCCACHAN
PCCAR110 EQU   PCCACHAN
PCCAR109 EQU   PCCACHAN
PCCAR108 EQU   PCCACHAN
PCCAR107 EQU   PCCACHAN
PCCAEXDM EQU   PCCACHAN
PCCAIRST EQU   PCCACHAN
PCCASRB  EQU   PCCA+180
PCCACCHM EQU   PCCA+176
PCCAELBA EQU   PCCA+172
PCCAELAD EQU   PCCA+168
PCCALRBR EQU   PCCA+164
PCCALRBV EQU   PCCA+160
PCCAPWAR EQU   PCCA+156
PCCAPWAV EQU   PCCA+152
PCCAEMSA EQU   PCCAEMSB+12
PCCAEMSE EQU   PCCAEMSB+8
PCCAEMSP EQU   PCCAEMSB+4
PCCARMS  EQU   PCCARMSB
PCCARV34 EQU   PCCARMSB
PCCARV33 EQU   PCCARMSB
PCCARV32 EQU   PCCARMSB
PCCARV31 EQU   PCCARMSB
PCCARV30 EQU   PCCARMSB
PCCARV29 EQU   PCCARMSB
PCCARV28 EQU   PCCARMSB
PCCARV27 EQU   PCCAEMS3
PCCARV26 EQU   PCCAEMS3
PCCARV25 EQU   PCCAEMS3
PCCARV24 EQU   PCCAEMS3
PCCARV23 EQU   PCCAEMS3
PCCARV22 EQU   PCCAEMS3
PCCARV21 EQU   PCCAEMS3
PCCARV20 EQU   PCCAEMS3
PCCARV19 EQU   PCCAEMS2
PCCARV18 EQU   PCCAEMS2
PCCARV17 EQU   PCCAEMS2
PCCARV16 EQU   PCCAEMS2
PCCARV15 EQU   PCCAEMS2
PCCARV14 EQU   PCCAEMS2
PCCARV13 EQU   PCCAEMS2
PCCARV12 EQU   PCCAEMS2
PCCARV11 EQU   PCCARISP
PCCARV10 EQU   PCCARISP
PCCARV09 EQU   PCCARISP
PCCARV08 EQU   PCCARISP
PCCARV07 EQU   PCCARISP
PCCARV06 EQU   PCCARISP
PCCASERL EQU   PCCARISP
PCCAPARL EQU   PCCARISP
PCCARPB  EQU   PCCA+132
PCCACTIN EQU   PCCAINTE
PCCANFIN EQU   PCCAINTE
PCCANUIN EQU   PCCAINTE
PCCACTCC EQU   PCCACCE
PCCANFCC EQU   PCCACCE
PCCANUCC EQU   PCCACCE
PCCACTTD EQU   PCCATODE
PCCANFTD EQU   PCCATODE
PCCANUTD EQU   PCCATODE
PCCARV04 EQU   PCCATMFL
PCCARV03 EQU   PCCATMFL
PCCARV02 EQU   PCCATMFL
PCCAMINT EQU   PCCATMFL
PCCAMCC  EQU   PCCATMFL
PCCAVKIL EQU   PCCATMFL
PCCASYNC EQU   PCCATMFL
PCCAINIT EQU   PCCATMFL
PCCARV9E EQU   PCCA+124
PCCARV9D EQU   PCCA+120
PCCARV9C EQU   PCCA+116
PCCARV9B EQU   PCCA+112
PCCARV9A EQU   PCCA+108
PCCARV99 EQU   PCCA+104
PCCARV98 EQU   PCCA+100
PCCARV97 EQU   PCCA+96
PCCARV96 EQU   PCCA+92
PCCARV95 EQU   PCCA+88
PCCARV94 EQU   PCCA+84
PCCARV93 EQU   PCCA+80
PCCARV92 EQU   PCCA+76
PCCARV91 EQU   PCCA+72
PCCARV90 EQU   PCCA+68
PCCARV89 EQU   PCCA+64
PCCARV88 EQU   PCCA+60
PCCARV87 EQU   PCCA+56
PCCARV86 EQU   PCCA+52
PCCARV85 EQU   PCCA+48
PCCARV84 EQU   PCCA+44
PCCARV83 EQU   PCCA+40
PCCARV82 EQU   PCCA+36
PCCARV81 EQU   PCCA+32
PCCAPSAR EQU   PCCA+28
PCCAPSAV EQU   PCCA+24
PCCATQEP EQU   PCCA+20
PCCACAFM EQU   PCCA+18
PCCACPUA EQU   PCCA+16
PCCAPCCA EQU   PCCA
LRBCMPCS EQU   LRBCMP+2
LRBCMPPA EQU   LRBCMP
LRBCMPNO EQU   LRBCVAR+6
LRBCMPF2 EQU   LRBCVAR+5
LRBCMPF1 EQU   LRBCVAR+4
LRBCRESD EQU   LRBCVAR+2
LRBCFT   EQU   LRBCVAR
LRBHMCEL EQU   LRBHCPID+6
LRBHMDL  EQU   LRBHCPID+4
LRBHCSER EQU   LRBHCPID+1
@NM00010 EQU   LRBHCPID
LRBHTIME EQU   LRB+12
LRBHDATE EQU   LRB+8
@NM00009 EQU   LRB+7
LRBHCNT  EQU   LRB+6
LRBMCLB  EQU   LRBHSW3
LRBNDEM  EQU   LRBMACT
LRBNCEM  EQU   LRBMACT
@NM00008 EQU   LRBHSW0
LRBHTMC  EQU   LRBHSW0
@NM00007 EQU   LRBHSW0
LRBHNS   EQU   LRBHSW0
LRBHMORE EQU   LRBHSW0
@NM00006 EQU   LRBHSYS
LRBHSYSB EQU   LRBHSYS
HDRCPID  EQU   HDR+16
HDRTM    EQU   HDR+8
@NM00005 EQU   HDR+7
HDRCNTT  EQU   HDRCNT
HDRCNTS  EQU   HDRCNT
HDRDS3   EQU   HDRDS+2
HDRDS2   EQU   HDRDS+1
HDRDS17  EQU   HDRDS1
HDRDS16  EQU   HDRDS1
HDRDS15  EQU   HDRDS1
HDRDS14  EQU   HDRDS1
HDRDS13  EQU   HDRDS1
HDRDS12  EQU   HDRDS1
HDRDS11  EQU   HDRDS1
HDRDS10  EQU   HDRDS1
HDRISEC  EQU   HDRIS
HDRISR   EQU   HDRIS
HDRISMP  EQU   HDRIS
HDRISTM  EQU   HDRIS
@NM00004 EQU   HDRIS
HDRTRUNC EQU   HDRIS
HDRISNS  EQU   HDRIS
HDRISMR  EQU   HDRIS
HDRRELN  EQU   HDROPRN
HDROPSYS EQU   HDROPRN
HDRTYP   EQU   HDR
CVTLEVL  EQU   CVTRELNO+2
CVTNUMB  EQU   CVTRELNO
CVTMDL   EQU   CVTFIX+250
@NM00003 EQU   CVTFIX+248
@NM00002 EQU   CVTFIX
CVTRV482 EQU   CVTXTNT2+128
CVTRV481 EQU   CVTXTNT2+124
CVTRV480 EQU   CVTXTNT2+120
CVTRV479 EQU   CVTXTNT2+118
CVTRV478 EQU   CVTXTNT2+117
CVTRV477 EQU   CVTXTNT2+116
CVTRV476 EQU   CVTXTNT2+115
CVTRV475 EQU   CVTXTNT2+114
CVTRV474 EQU   CVTRV466
CVTRV473 EQU   CVTRV466
CVTRV472 EQU   CVTRV466
CVTRV471 EQU   CVTRV466
CVTRV470 EQU   CVTRV466
CVTRV469 EQU   CVTRV466
CVTRV468 EQU   CVTRV466
CVTRV467 EQU   CVTRV466
CVTRV465 EQU   CVTRV457
CVTRV464 EQU   CVTRV457
CVTRV463 EQU   CVTRV457
CVTRV462 EQU   CVTRV457
CVTRV461 EQU   CVTRV457
CVTRV460 EQU   CVTRV457
CVTRV459 EQU   CVTRV457
CVTRV458 EQU   CVTRV457
CVTRV456 EQU   CVTXTNT2+108
CVTRV455 EQU   CVTXTNT2+104
CVTRV454 EQU   CVTXTNT2+100
CVTRV453 EQU   CVTXTNT2+96
CVTRV452 EQU   CVTXTNT2+94
CVTRV451 EQU   CVTXTNT2+92
CVTRV450 EQU   CVTXTNT2+90
CVTRV449 EQU   CVTXTNT2+88
CVTRV448 EQU   CVTXTNT2+87
CVTRV447 EQU   CVTXTNT2+86
CVTRV446 EQU   CVTRV438
CVTRV445 EQU   CVTRV438
CVTRV444 EQU   CVTRV438
CVTRV443 EQU   CVTRV438
CVTRV442 EQU   CVTRV438
CVTRV441 EQU   CVTRV438
CVTRV440 EQU   CVTRV438
CVTRV439 EQU   CVTRV438
CVTRV437 EQU   CVTRV429
CVTRV436 EQU   CVTRV429
CVTRV435 EQU   CVTRV429
CVTRV434 EQU   CVTRV429
CVTRV433 EQU   CVTRV429
CVTRV432 EQU   CVTRV429
CVTRV431 EQU   CVTRV429
CVTRV430 EQU   CVTRV429
CVTRV428 EQU   CVTXTNT2+80
CVTRV427 EQU   CVTXTNT2+76
CVTRV426 EQU   CVTXTNT2+72
CVTRV425 EQU   CVTXTNT2+68
CVTATACT EQU   CVTATCVT
CVTRV423 EQU   CVTXTNT2+62
CVTRV422 EQU   CVTXTNT2+60
CVTRV421 EQU   CVTXTNT2+58
CVTRV420 EQU   CVTXTNT2+56
CVTRV419 EQU   CVTXTNT2+55
CVTRV418 EQU   CVTXTNT2+54
CVTRV417 EQU   CVTRV409
CVTRV416 EQU   CVTRV409
CVTRV415 EQU   CVTRV409
CVTRV414 EQU   CVTRV409
CVTRV413 EQU   CVTRV409
CVTRV412 EQU   CVTRV409
CVTRV411 EQU   CVTRV409
CVTRV410 EQU   CVTRV409
CVTRV408 EQU   CVTRV400
CVTRV407 EQU   CVTRV400
CVTRV406 EQU   CVTRV400
CVTRV405 EQU   CVTRV400
CVTRV404 EQU   CVTRV400
CVTRV403 EQU   CVTRV400
CVTRV402 EQU   CVTRV400
CVTRV401 EQU   CVTRV400
CVTICB   EQU   CVTXTNT2+48
CVTSKTA  EQU   CVTXTNT2+44
CVTCCVT  EQU   CVTXTNT2+40
CVTRSV98 EQU   CVTXTNT2+36
CVTRSV97 EQU   CVTXTNT2+34
CVTRSV96 EQU   CVTXTNT2+32
CVTOLTEP EQU   CVTXTNT2+28
CVTQIDA  EQU   CVTQID+1
CVTRSV95 EQU   CVTQID
CVTRSV94 EQU   CVTXTNT2+20
CVTRSV93 EQU   CVTXTNT2+16
CVTRSV92 EQU   CVTXTNT2+12
CVTDEBVR EQU   CVTXTNT2+8
CVTRSV91 EQU   CVTXTNT2+6
CVTRSV9H EQU   CVTFLGBT
CVTRSV9G EQU   CVTFLGBT
CVTRSV9F EQU   CVTFLGBT
CVTRSV9E EQU   CVTFLGBT
CVTRSV9D EQU   CVTFLGBT
CVTBAH   EQU   CVTFLGBT
CVTVME   EQU   CVTFLGBT
CVTNPE   EQU   CVTFLGBT
CVTNUCLS EQU   CVTXTNT2+4
CVTDSSVA EQU   CVTDSSV+1
CVTRSV89 EQU   CVTDSSV
CVTRSV88 EQU   CVTXTNT1+8
CVTRSV87 EQU   CVTXTNT1+4
CVTFACHN EQU   CVTXTNT1
CVTRV488 EQU   CVTMAP+412
CVTRV487 EQU   CVTMAP+408
CVTRV486 EQU   CVTMAP+404
CVTRV485 EQU   CVTMAP+400
CVTACTAP EQU   CVTMAP+396
CVTAUTH  EQU   CVTMAP+392
CVTRV490 EQU   CVTMAP+388
CVTSU    EQU   CVTMAP+384
CVTVOLT1 EQU   CVTVOLM1+1
CVTVOLI1 EQU   CVTVOLF1
CVTSTOA  EQU   CVTMAP+376
CVTRSV58 EQU   CVTMAP+374
CVTRSV57 EQU   CVTMAP+372
CVTDDCE  EQU   CVTMAP+368
CVTPNWFR EQU   CVTMAP+364
CVTSMF   EQU   CVTMAP+360
CVTSULK  EQU   CVTMAP+358
CVTSLKO  EQU   CVTSYSK
CVTSLKP  EQU   CVTSYSK
CVTSLKQ  EQU   CVTSYSK
CVTSLKR  EQU   CVTSYSK
CVTRSV56 EQU   CVTSYSK
CVTRSV55 EQU   CVTSYSK
CVTRSV54 EQU   CVTSYSK
CVTRSV53 EQU   CVTSYSK
CVTRSV52 EQU   CVTA1F1
CVTRSV51 EQU   CVTA1F1
CVTRSV50 EQU   CVTA1F1
CVTRSV49 EQU   CVTA1F1
CVTRSV48 EQU   CVTA1F1
CVTRSV47 EQU   CVTA1F1
CVTSRSW  EQU   CVTA1F1
CVTPFSW  EQU   CVTA1F1
CVTPCVT  EQU   CVTMAP+352
CVTRSV46 EQU   CVTMAP+344
CVTRSV45 EQU   CVTMAP+340
CVTRSV44 EQU   CVTMAP+338
CVTRSV43 EQU   CVTMAP+336
CVTHJESA EQU   CVTHJES+1
CVTRSV42 EQU   CVTHJES
CVTEXT2A EQU   CVTEXT2+1
CVTRSV41 EQU   CVTEXT2
CVTAPFA  EQU   CVTAPF+1
CVTRSV40 EQU   CVTAPF
CVTRV518 EQU   CVTINTLA
CVTRV517 EQU   CVTERPV
CVTEORM  EQU   CVTMAP+312
CVTMCHPR EQU   CVTMAP+308
CVTTZ    EQU   CVTMAP+304
CVTJEPS  EQU   CVTMAP+300
CVTJESCT EQU   CVTMAP+296
CVTMODE  EQU   CVTMAP+292
CVTPTRV  EQU   CVTMAP+288
CVTREAL  EQU   CVTMAP+284
CVTRSV39 EQU   CVTMAP+280
CVTRSV38 EQU   CVTMAP+276
CVTDMSRA EQU   CVTDMSR+1
CVTRV634 EQU   CVTDMSRF
CVTRV633 EQU   CVTDMSRF
CVTRV632 EQU   CVTDMSRF
CVTRV631 EQU   CVTDMSRF
CVTRV630 EQU   CVTDMSRF
CVTRV629 EQU   CVTDMSRF
CVTUDUMP EQU   CVTDMSRF
CVTSDUMP EQU   CVTDMSRF
CVTQMSGA EQU   CVTQMSG+1
CVTRSV36 EQU   CVTQMSG
CVTAMFF  EQU   CVTMAP+264
CVTPURGA EQU   CVTPURG+1
CVTRSV35 EQU   CVTPURG
CVTCBSP  EQU   CVTMAP+256
CVTATERA EQU   CVTATER+1
CVTSYST  EQU   CVTATER
CVTVOLT2 EQU   CVTTAT
CVTVOLI2 EQU   CVTVOLF2
CVTAQAVB EQU   CVTAQAVT+1
CVTRSV34 EQU   CVTTCMFG
CVTRSV33 EQU   CVTTCMFG
CVTRSV32 EQU   CVTTCMFG
CVTRSV31 EQU   CVTTCMFG
CVTRSV30 EQU   CVTTCMFG
CVTRSV29 EQU   CVTTCMFG
CVTLDEV  EQU   CVTTCMFG
CVTTCRDY EQU   CVTTCMFG
CVTGTFA  EQU   CVTGTF+1
CVTRSV27 EQU   CVTGTFST
CVTRNIO  EQU   CVTGTFST
CVTUSR   EQU   CVTGTFST
CVTRV318 EQU   CVTFORM
CVTRV317 EQU   CVTTMODE
CVTRV316 EQU   CVTSTATE
CVTRV315 EQU   CVTGTFS
CVTGTFAV EQU   CVTGTFS
CVT0SCR1 EQU   CVTMAP+232
CVTRV515 EQU   CVTMAP+228
CVTRMS   EQU   CVTMAP+224
CVTPATCH EQU   CVTMAP+220
CVTTSCE  EQU   CVTMAP+216
CVTLNKSC EQU   CVTMAP+214
CVTQABST EQU   CVTMAP+212
CVTMDLDS EQU   CVTMAP+208
CVTUSER  EQU   CVTMAP+204
CVTABEND EQU   CVTMAP+200
CVTSMCA  EQU   CVTMAP+196
CVTRSV18 EQU   CVTMAP+192
CVTQLPAQ EQU   CVTMAP+188
CVTQCDSR EQU   CVTMAP+184
CVTVS1B  EQU   CVTOPTB
CVTVS1A  EQU   CVTOPTB
CVTFP    EQU   CVTOPTB
CVTAPTHR EQU   CVTOPTB
CVTNLOG  EQU   CVTOPTB
CVTTOD   EQU   CVTOPTB
CVTCTIMS EQU   CVTOPTB
CVTPROT  EQU   CVTOPTB
CVTXPFP  EQU   CVTOPTA
CVTASCII EQU   CVTOPTA
CVTRSV13 EQU   CVTOPTA
CVTRSV12 EQU   CVTOPTA
CVTNIP   EQU   CVTOPTA
CVTDDR   EQU   CVTOPTA
CVTAPR   EQU   CVTOPTA
CVTCCH   EQU   CVTOPTA
CVTSNCTR EQU   CVTMAP+180
CVTQMWR  EQU   CVTMAP+176
CVTQOCR  EQU   CVTMAP+172
CVT1EF00 EQU   CVTMAP+168
CVTMZ00  EQU   CVTMAP+164
CVTSV76Q EQU   CVTSV76C
CVTRSV11 EQU   CVTMAP+156
CVT0PT01 EQU   CVTMAP+152
CVTMSER  EQU   CVTMAP+148
CVTRV516 EQU   CVTIERLC
CVTILCH  EQU   CVTMAP+140
CVT0DS   EQU   CVTMAP+136
CVTFBOSV EQU   CVTMAP+132
CVTNUCB  EQU   CVTMAP+128
CVTIXAVL EQU   CVTMAP+124
CVTSV76M EQU   CVTIOQET
CVTDCBA  EQU   CVTMAP+117
CVTMVS2  EQU   CVTDCB
CVT6DAT  EQU   CVTDCB
CVT4MPS  EQU   CVTDCB
CVTRSV09 EQU   CVTDCB
CVT4MS1  EQU   CVTDCB
CVT2SPS  EQU   CVTDCB
CVT1SSS  EQU   CVTDCB
CVTRSV08 EQU   CVTDCB
CVTSTB   EQU   CVTMAP+112
CVTQTD00 EQU   CVTMAP+108
CVTQTE00 EQU   CVTMAP+104
CVTCUCB  EQU   CVTMAP+100
CVTSJQ   EQU   CVTMAP+96
CVTPBLDL EQU   CVTMAP+92
CVTTPC   EQU   CVTMAP+88
CVTSVDCB EQU   CVTMAP+84
CVTBRET  EQU   CVTMAP+82
CVTEXIT  EQU   CVTMAP+80
CVT0FN00 EQU   CVTMAP+76
CVTDARA  EQU   CVTDAR+1
CVTRSV07 EQU   CVTFLGS1
CVTRSV06 EQU   CVTFLGS1
CVTRSV05 EQU   CVTFLGS1
CVTRSV04 EQU   CVTFLGS1
CVTRSV03 EQU   CVTFLGS1
CVTRSV02 EQU   CVTFLGS1
CVTRSV01 EQU   CVTFLGS1
CVTDMPLK EQU   CVTFLGS1
CVTXITP  EQU   CVTMAP+68
CVTZDTAB EQU   CVTMAP+64
CVTMSLT  EQU   CVTMAP+60
CVTDATE  EQU   CVTMAP+56
CVTBTERM EQU   CVTMAP+52
CVTSYSAD EQU   CVTMAP+48
CVTXTLER EQU   CVTMAP+44
CVTILK2  EQU   CVTMAP+40
CVTILK1  EQU   CVTMAP+36
CVTPRLTV EQU   CVTMAP+32
CVTPCNVT EQU   CVTMAP+28
CVT0VL00 EQU   CVTMAP+24
CVTXAPG  EQU   CVTMAP+20
CVTBUF   EQU   CVTMAP+16
CVTJOB   EQU   CVTMAP+12
CVTLINK  EQU   CVTMAP+8
CVT0EF00 EQU   CVTMAP+4
CVTTCBP  EQU   CVTMAP
CVT      EQU   CVTMAP
ADPLABDA EQU   ABDPL+56
ADPLEXT  EQU   ABDPL+52
ADPLFMT2 EQU   ABDPL+48
ADPLFMT1 EQU   ABDPL+44
ADPLCOM4 EQU   ABDPL+40
ADPLCOM3 EQU   ABDPL+36
ADPLCOM2 EQU   ABDPL+32
ADPLCOM1 EQU   ABDPL+28
ADPLFRMT EQU   ABDPL+24
@NM00001 EQU   ADPLFLAG
ADPLDMGT EQU   ADPLFLAG
ADPLSNPR EQU   ADPLFLAG
ADPLSBPL EQU   ABDPL+6
ADPLASID EQU   ABDPL+4
ADPLTCB  EQU   ABDPL
.@UNREFD ANOP                          END UNREFERENCED COMPONENTS
@RC00363 EQU   @RC00362
@PB00005 EQU   @EL00003
@RC00418 EQU   @EL00007
@PB00004 EQU   @PB00005
@RC00420 EQU   @RC00418
@RC00287 EQU   @PB00004
@RC00305 EQU   @PB00004
@RC00320 EQU   @PB00004
@RC00341 EQU   @PB00004
@ENDDATA EQU   *
         END   IFCERFMT,(C'PLS1909',0702,78297)
