         TITLE '---IFCEWOD1 EDIT TABLE---'
***********************************************************************
**                                                                   **
**                           IFCEWOD1                                **
**                                                                   **
**       THIS EDIT TABLE PROVIDES DEVICE SUPPORT FOR 3310 & 3370     **
**    DASD DEVICES. IT IS LOADED BY IFCEEDIT WHEN THESE DEVICE       **
**    TYPES ARE INDICATED.  IT PROVIDES THE OUTPUT OF SENSE BYTES    **
**    0-7 IN ANY CASE; AND BYTES 8-23 OF 3310 FORMAT 1 (AS           **
**    INDICATED IN SENSE BYTE 7).  FOR OTHER 3310/FBA2 FORMATS       **
**    A SPECIAL ROUTINE--CHKFMT--IS PROVIDED TO INDICATE TO IFCEEDIT **
**    THE NEXT TABLE TO LOAD TO PRINT BYTES 8-23.  AN INVALID FORMAT **
**    CODE CAUSES THE SENSE BYTE PRINTING TO BE SUPPRESSED.  IN ANY  **
**    CASE A HEX DUMP OF THE OBR RECORD IS CALLED FOR.               **
**       THE DETAIL FORMAT OF THE OBR RECORD IS SUPPLIED AS FIGURE   **
**    44 IN PART 4 OF "OS/VS ENVIRONMENTAL RECORDING EDITING AND     **
**    PRINTING (EREP) PROGRAM" (PUB. NO. GC28-0772).                 **
**                                                                   **
**-------------------------------------------------------------------**
**                                                                   **
**                     REGISTER ASSIGNMENT                          **
**    GPR #                USE                                       **
**    2            START OF OBR RECORD                               **
**    3            CURRENT CHARACTER POSITION IN PRINT BUFFER        **
**    4            @ DATA ITEM SPECIFIED IN ROUTINE MACRO            **
**    5-8          WORK REGISTERS FOR SPECIAL ROUTINES               **
**    9            BASE REGISTER FOR IFCEWOD1                        **
**    14           RETURN POINT FROM SPECIAL ROUTINES                **
**    15           SET TO 0 TO SUPPRESS PRINT OF CURRENT LINE        **
**                                                                   **
***********************************************************************
         GBLC  &DSECT,&CSECT
IFCEWOD1 CSECT
&CSECT   SETC  'IFCEWOD1'
&DSECT   SETC  'WOD1'
*
*                                  SENSE FORMAT 1
*
WOD1     DSECT
         DSGEN (CLASRC,8),(SYSREL,8),(SWITCHES,16)
         DSGEN (SPARE1,32)
         DSGEN (DAY,32)
         DSGEN (HOUR,32)
         DSGEN (SPARE2,8),(CPUSERL,24)
         DSGEN (CPUID,16),(SPARE3,16)
         DSGEN (JOBID1,32)
         DSGEN (JOBID2,32)
         DSGEN (FCCWCC,8),(FCCWDA,24)
         DSGEN (FCCWFL,8),(FCCW,8),(FCCWCT,16)
         DSGEN (CSWUS1,8),(CSWUS2,24)
         DSGEN (CSWUS3,8),(CSWUS4,8),(CSWUS5,16)
         DSGEN (DEVDPD,8),(SECCUA,24)
         DSGEN (DEVTYP1,16),(DEVTYP2,16)
         DSGEN (SPARE4,8),(CUA,24)
         DSGEN (IORET,16),(SBCNT,16)
         DSGEN (VOLLAB1,8),(VOLLAB2,16),(VOLLAB3,8)
         DSGEN (VOLLAB4,8),(VOLLAB5,8),(SPARE5,16)
         DSGEN (LSKAD1,8),(LSKAD2,16),(LSKAD3,8)
         DSGEN (LSKAD4,8),(LSKAD5,16),(LSKAD6,8)
         DSGEN (AHA1,32)
         DSGEN (AHA2,16),(SPARE6,16)
         DSGEN (SNB,1,0,23,0,7)
         EJECT
IFCEWOD1 CSECT
         USING *,R9
         USING WOD1,R2
R0       EQU   0
R1       EQU   1
R2       EQU   2
R3       EQU   3
R4       EQU   4
R5       EQU   5
R6       EQU   6
R7       EQU   7
R8       EQU   8
R9       EQU   9
R10      EQU   10
R11      EQU   11
R12      EQU   12
R13      EQU   13
R14      EQU   14
R15      EQU   15
L0       EQU   0
L1       EQU   1
L2       EQU   2
L3       EQU   3
L4       EQU   4
L5       EQU   5
L6       EQU   6
L7       EQU   7
L8       EQU   8
L9       EQU   9
L10      EQU   10
L11      EQU   11
L12      EQU   12
L13      EQU   13
L14      EQU   14
L15      EQU   15
L16      EQU   16
L17      EQU   17
L18      EQU   18
L19      EQU   19
L20      EQU   20
L23      EQU   23
L24      EQU   24
L26      EQU   26
H0F      EQU   X'0F'
HE0      EQU   X'E0'
H80      EQU   X'80'
H40      EQU   X'40'
H20      EQU   X'20'
H10      EQU   X'10'
H21      EQU   X'21'
H23      EQU   X'23'
H25      EQU   X'25'
H29      EQU   X'29'
CLRSGN   EQU   X'F0'
HFF      EQU   X'FF'
         EJECT
         DC    A(ENTRIES)
         DC    CL8'IFCEWOD1'
XR9PTR   DC    F'0'
XLABELP  DC    F'0'
***********************************************************************
**                                                                   **
**                        SPECIAL ROUTINES                           **
**                                                                   **
**===================================================================**
**                                                                   **
**                            CHKFMT                                 **
**      THIS SPECIAL ROUTINE DETERMINES THE DEVICE TYPE AND FORMAT   **
**   SO EEDIT MAY CALL THE APPROPRIATE MODULE FOR PRINTING BYTES     **
**   8-23.  THE FORMAT IS INDICATED BY BITS 0-3 OF BYTE 7.  SOME     **
**   SUB-FORMATS USE OTHER FLAG BITS. THE VALID FORMATS ARE:         **
**     3310 FORMAT 1 -- IFCEWOD1                                     **
**     FBA2 FORMAT 1 -- IFCENFP1                                     **
**     FBA2 FORMAT 1 (ALTERNATE) -- IFCENF11 (CHECK BYTE 11, BIT 0)  **
**     SARK/FBA2 FORMAT 2 -- IFCENFP2                                **
**     SARK/FBA2 FORMAT 3 (HARDWARE) -- IFCENFH3 (SEE BYTE 8 BIT 4)  **
**     SARK/FBA2 FORMAT 3 (MICROCDE) -- IFCENFM3 (SEE BYTE 8 BIT 4)  **
**     3310/FBA2 FORMAT 4 -- IFCEFBA4                                **
**     3310/FBA2 FORMAT 5 -- IFCEFBA5                                **
**                                                                   **
***********************************************************************
CHKFMT   STM   R5,R8,XSAVE         SAVE WORK REGS
         SR    R15,R15             DON'T PRINT THIS LINE
         SR    R5,R5               CLEAR REG 5
         CLI   0(R4),X'80'         FORMAT 8 OR ABOVE?...BETTER NOT BE
         BE    BADFMT              YES...ERROR
         CLI   0(R4),X'70'         FORMAT 0?...BETTER NOT BE
         BE    BADFMT              YES...ERROR
         CLI   0(R4),X'60'         FORMAT 6 OR 7?...BETTER NOT BE
         BE    BADFMT              YES...ERROR
         B     RETURN              FORMAT VALID...CONTINUE
WHATFMT  TM    0(R4),X'50'         FORMAT 5?
         BO    FORMAT5             YES.
         TM    0(R4),X'40'         FORMAT 4?
         BO    FORMAT4             YES.
         TM    0(R4),X'30'         FORMAT 3?
         BO    FORMAT3             YES.
         TM    0(R4),X'20'         FORMAT 2?
         BO    FORMAT2             YES.
         TM    0(R4),X'10'         FORMAT 1?
         BO    FORMAT1             YES.
         TM    0(R4),X'08'         FORMAT 0 FROM A 3880
         BO    FORMAT0             YES.
BADFMT   LA    R5,HEXDUMP-4        OH-OH...BAD FORMAT
         ST    R5,XR9PTR           IGNORE THE RECORD EXCEPT FOR THE
*                                  DUMP
         B     RETURN
FORMAT1  LH    6,54(2)             GET DEVICE TYPE
         CH    6,DEV3310           IS IT 3310?
         BE    RETURN              IF SO, THEN WE'RE OK.
         TM    4(R4),X'80'         ALTERNATE INTERPRETATION?
         BO    ALT1                YES.
REGULAR1 LA    5,NFP1-4            GET @ MOD NAME--IFCENFP1
         B     CALLSET             GO SAVE IT
ALT1     LA    5,NF11-4            GET @ MOD NAME--IFCENF11
         B     CALLSET             GO SAVE IT
FORMAT0  LA    5,CUT0-4            GET 0 MOD NAME--IFCECUT0
         B     CALLSET             GO SAVE IT
FORMAT2  LA    5,NFP2-4            GET 2 MOD NAME--IFCENFP2
         B     CALLSET             GO SAVE IT
FORMAT3  TM    1(R4),X'08'         MICROCODE SENSED?
         BO    MICRO               YES.
         CLI   0(R4),X'3A'         ONLY ODD CASE
         BE    MICRO
HARDWARE LA    5,NFH3-4            GET @ MOD NAME--IFCENFH3
         B     CALLSET             GO SAVE IT
MICRO    LA    5,NFM3-4            GET @ MOD NAME--IFCENFM3
         B     CALLSET             GO SAVE IT
FORMAT4  LA    5,FBA4-4            GET @ MOD NAME--IFCEFBA4
         B     CALLSET             GO SAVE IT
FORMAT5  LA    5,FBA5-4            GET @ MOD NAME--IFCEFBA5
CALLSET  ST    5,XR9PTR            SAVE FOR EEDIT
         SR    R15,R15             DON'T PRINT THIS LINE
         B     RETURN              GO HOME
DEV3310  DC    X'2101'             3310 DEVICE TYPE CODE
CUT0     DC    X'FE'
         DC    C'IFCECUT0'
NFP1     DC    X'FE'
         DC    C'IFCENFP1'
NF11     DC    X'FE'
         DC    C'IFCENF11'
NFP2     DC    X'FE'
         DC    C'IFCENFP2'
NFH3     DC    X'FE'
         DC    C'IFCENFH3'
NFM3     DC    X'FE'
         DC    C'IFCENFM3'
FBA4     DC    X'FE'
         DC    C'IFCEFBA4'
FBA5     DC    X'FE'
         DC    C'IFCEFBA5'
         SPACE 2
*
*                                  SET HEX -PRINTS 1 CHAR HEX
*
SETHEX   STM   R5,R8,XSAVE         SAVE REGS
         LA    R8,CHARS            CHARACTER TABLE POINTER
         IC    R7,L0(R4)           PICK UP CHARACTER
         SLL   R7,L24              MOVE TO HI R7
         SR    R6,R6               CLEAR REGS
         SLDL  R6,L4               MOVE FOUR BITS
         AR    R6,R8               ADD OFFSET AND POINTER
         MVC   L0(L1,R3),L0(R6)    MOVE CHARACTER TO LINE
         SR    R6,R6               CLEAR AGAIN
         SLDL  R6,L4               MOVE LAST 4 BITS
         AR    R6,R8               COMPUTE OFFSET
         MVC   L1(L1,R3),L0(R6)    MOVE LAST CHARACTER
         B     RETURN
         SPACE 2
*
*                                  TEST TO SEE IF RECORD IS IN AR-149
*                                  FORMAT
*
SETCONV  TM    L0(R4),HEX02        HAS RECORD BEEN CONVERTED KEY32
         BCR   ON,R14              YES RETURN
         SR    R15,R15             NO CLEAR R15 FOR NO PRINT OF
         BR    R14                 LINE
ON       EQU   1
HEX02    EQU   X'02'
         SPACE 2
*
*                                  NO OP RETURN
*
SKIPPER  BR    R14
         SPACE 2
*
*                                  TO ADD SPACES ON LINE
*
SPACER2  LA    R3,L4(R3)
         BR    14
         SPACE 2
*
*                                  RESTORE REGISTERS USED BY ROUTINES
*                                  IN THIS MODULE
*
RETURN   LM    R5,R8,XSAVE         RESTORE REGS
         BR    R14                 RETURN
         SPACE 2
*
*                                  SET BINARY WITH R4 POINTING TO THE
*                                  CHAR
*
SETBIN   STM   R5,R8,XSAVE         SAVE REGS
         ICM   R7,X'8',L0(R4)      PICK UP CHAR TO PRINT
         LR    R8,R3               PRINT POS POINTER TO REG8
         LA    R5,L8               LOOP COUNT
SETBINA  SR    R6,R6               CLEAR REG 6
         SLDL  R6,L1               MOVE BIT TO R6
         STC   R6,L0(R8)           PUT IT INTO PRINT LINE
         MVZ   L0(L1,R8),CHAR0
         LA    R8,L1(R8)           MOVE POINTER TO NEXT POS
         BCT   R5,SETBINA          LOOP TILL 8 PRINTED
         B     RETURN
         SPACE 2
SETBIN1  STM   R5,R8,XSAVE         SAVE REGS
         ICM   R7,X'8',L0(R4)      PICK UP CHAR TO PRINT
         LR    R8,R3               PRINT POS POINTER TO REG 8
         SR    R6,R6               CLEAR REG 6
         SLDL  R6,L1               MOVE BIT TO REG 6
         STC   R6,L11(R8)
         OC    L11(L1,R8),CHAR0
         B     RETURN              RETURN
         SPACE 2
*                                  CONVERT COUNTERS FROM HEX TO DECIMAL
*                                  READY FOR PRINT
*
CONV1    STM   R5,R8,XSAVE         SAVE REGISTERS
         XC    READYP(L8),READYP   CLEAR UNPACK BUFFER
         SR    R6,R6               ZERO REG
         LH    R6,L0(R4)           LOAD DATA TO BE CONVERTED
         CVD   R6,READYP           CONVERT ERROR COUNTER TO DECI
         UNPK  READYP(L5),READYP+L5(L3) UNPACK DECI COUNT
         OI    READYP+L4,CLRSGN    CLEAR SIGN
         MVC   L0(L4,R3),READYP+L1 MOVE COUNTER READY TO PRINT
         B     RETURN
         SPACE 2
         DS    0F
XSAVE    DC    5F'0'
NONE     DC    CL6'NONE  '
CHARS    DC    C'0123456789ABCDEF'
CHAR0    DC    C'0'
**-------------------------------------------------------------------**
**                             PATCH AREA                            **
         DC    S(PATCH)
PATCH    DC    CL50' '
**-------------------------------------------------------------------**
         EJECT
         DS    0D
READYP   DC    CL8' '
ENTRIES  DS    0F
         DC    XL4'00010001'       FORMAT 1
         DC    XL4'00010001'       FORMAT 2
         DC    A(LABELS)           LABEL POINTER
         DC    H'0'                DISP
*
*                                  SKIP TO CHANNEL 1
*
         DC    X'01'
         DC    X'000B0B00'
         SPACE 5
         LINE
         ROUTINE SNB70,CHKFMT
         LABEL ''
         SPACE 2
         LINE  (12,15),(3,15),SKIP=1
         ROUTINE SNB00,SETHEX
         ROUTINE SNB10,SETHEX
         ROUTINE SNB20,SETHEX
         ROUTINE SNB30,SETHEX
         ROUTINE SNB40,SETHEX
         ROUTINE SNB50,SETHEX
         ROUTINE SNB60,SETHEX
         ROUTINE SNB70,SETHEX
         LABEL 'BYTE 0','BYTE 1','BYTE 2','BYTE 3','BYTE 4','BYTE 5','B*
               YTE 6','BYTE 7'
         SPACE 2
         LINE  ,(1,1),SKIP=2
         LABEL '-----------UNIT CHECK CONDITION------------  ----------*
               ---PHYSICAL ADDRESS--------------  BLOCK NUMBER   FORMAT*
               /MSG'
         SPACE 2
         LINE  (13,15),(1,15),SKIP=1
         BIN   SNB00
         BIN   SNB10
         BIN   SNB20
         BIN   SNB30
         BIN   SNB40
         BIN   SNB50
         BIN   SNB60
         BIN   SNB70
         LABEL 'COMMAND REJ','PERM ERROR','CK DATA ER ','BIT 0 ','CYL 1*
               28','BIT 0','BLOCK 128','FORMAT  8'
         SPACE 2
         LINE
         BIN   SNB01
         BIN   SNB11
         BIN   SNB21
         BIN   SNB31
         BIN   SNB41
         BIN   SNB51
         BIN   SNB61
         BIN   SNB71
         LABEL 'INTERVN REQ','BIT 1','CORRECTABLE','BIT 1','CYL  64',  *
               'BIT 1','BLOCK  64','FORMAT  4'
         SPACE 2
         LINE
         BIN   SNB02
         BIN   SNB12
         BIN   SNB22
         BIN   SNB32
         BIN   SNB42
         BIN   SNB52
         BIN   SNB62
         BIN   SNB72
         LABEL 'BUS OUT PC ','BIT 2','BIT 2      ','BIT 2','CYL  32','H*
               EAD 32','BLOCK  32','FORMAT  2'
         SPACE 2
         LINE
         BIN   SNB03
         BIN   SNB13
         BIN   SNB23
         BIN   SNB33
         BIN   SNB43
         BIN   SNB53
         BIN   SNB63
         BIN   SNB73
         LABEL 'EQPT CHECK','BIT 3    ','ENV DATA PR','BIT 3','CYL  16'*
               ,'HEAD 16','BLOCK  16','FORMAT  1'
         SPACE 2
         LINE
         BIN   SNB04
         BIN   SNB14
         BIN   SNB24
         BIN   SNB34
         BIN   SNB44
         BIN   SNB54
         BIN   SNB64
         BIN   SNB74
         LABEL 'DATA CHECK','BIT 4','BIT 4','BIT 4','CYL   8','HEAD  8 *
               ','BLOCK   8','MESSAGE 8 '
         SPACE 2
         LINE
         BIN   SNB05
         BIN   SNB15
         BIN   SNB25
         BIN   SNB35
         BIN   SNB45
         BIN   SNB55
         BIN   SNB65
         BIN   SNB75
         LABEL 'OVERRUN','FILE PROT','BIT 5','BIT 5','CYL   4','HEAD  4*
               ','BLOCK   4','MESSAGE 4'
         SPACE 2
         LINE
         BIN   SNB06
         BIN   SNB16
         BIN   SNB26
         BIN   SNB36
         BIN   SNB46
         BIN   SNB56
         BIN   SNB66
         BIN   SNB76
         LABEL 'BIT 6','WR INHIBIT ','BIT 6','CYL 512','CYL   2','HEAD *
                2','BLOCK   2','MESSAGE 2'
         SPACE 2
         LINE  ,,SKIP=3
         BIN   SNB07
         BIN   SNB17
         BIN   SNB27
         BIN   SNB37
         BIN   SNB47
         BIN   SNB57
         BIN   SNB67
         BIN   SNB77
         LABEL 'BIT 7','OP INCPLT  ','LOG ONLY','CYL 256','CYL   1',   *
               'HEAD  1 ','BLOCK   1','MESSAGE 1'
         SPACE 2
         LINE
         ROUTINE SNB70,WHATFMT
         LABEL ''
         SPACE 2
         LINE  (12,15),(3,15),SKIP=1
         ROUTINE SNB80,SETHEX
         ROUTINE SNB90,SETHEX
         ROUTINE SNB100,SETHEX
         ROUTINE SNB110,SETHEX
         ROUTINE SNB120,SETHEX
         ROUTINE SNB130,SETHEX
         ROUTINE SNB140,SETHEX
         ROUTINE SNB150,SETHEX
         LABEL 'BYTE 8','BYTE 9','BYTE 10','BYTE 11','BYTE 12','BYTE 13C
               ','BYTE 14','BYTE 15'
         SPACE 2
         LINE  ,(1,1),SKIP=2
         LABEL 'CTL BUS OUT    CTL BUS IN     CTL TAG BUS    DAD STATUS*
                    DAD ERROR 1    DAD ERROR 2    DAD ERROR 3    DRIVE *
               SENSE'
         SPACE 2
         LINE  (13,15),(1,15),SKIP=1
         BIN   SNB80
         BIN   SNB90
         BIN   SNB100
         BIN   SNB110
         BIN   SNB120
         BIN   SNB130
         BIN   SNB140
         BIN   SNB150
         LABEL 'BIT 0','BIT 0','BIT 0','CLR DATA ER','TAG BUS PC ',    *
               'SYNC ER 0','BIT RING ER','FHD NOT SEL'
         SPACE 2
         LINE
         BIN   SNB81
         BIN   SNB91
         BIN   SNB101
         BIN   SNB111
         BIN   SNB121
         BIN   SNB131
         BIN   SNB141
         BIN   SNB151
         LABEL 'BIT 1','BIT 1','BIT 1','BIT 1','BUS OUT PC ','SYNC ER 1*
               ','SYNC OUT ER','BRAKE APPLD'
         SPACE 2
         LINE
         BIN   SNB82
         BIN   SNB92
         BIN   SNB102
         BIN   SNB112
         BIN   SNB122
         BIN   SNB132
         BIN   SNB142
         BIN   SNB152
         LABEL 'BIT 2','BIT 2','BIT 2','BIT 2','BUS IN PC ','RESERVED '*
               ,'PLA CLK ER ','TRK UNAVAIL'
         SPACE 2
         LINE
         BIN   SNB83
         BIN   SNB93
         BIN   SNB103
         BIN   SNB113
         BIN   SNB123
         BIN   SNB133
         BIN   SNB143
         BIN   SNB153
         LABEL 'BIT 3','BIT 3','BIT 3','BIT 3','SAM TOO LAT','BUS IN/OU*
               T','WR GATE CK','COMMAND ER'
         SPACE 2
         LINE
         BIN   SNB84
         BIN   SNB94
         BIN   SNB104
         BIN   SNB114
         BIN   SNB124
         BIN   SNB134
         BIN   SNB144
         BIN   SNB154
         LABEL 'BIT 4','BIT 4','BIT 4','BIT 4','SEC CNT ER ','SERIAL PC*
               ','BIT 4','DATA UNSAFE'
         SPACE 2
         LINE
         BIN   SNB85
         BIN   SNB95
         BIN   SNB105
         BIN   SNB115
         BIN   SNB125
         BIN   SNB135
         BIN   SNB145
         BIN   SNB155
         LABEL 'BIT 5','BIT 5','BIT 5','BIT 5','BIT 5','GAP CNT CK','BI*
               T 5','SEEK INCPLT'
         SPACE 2
         LINE
         BIN   SNB86
         BIN   SNB96
         BIN   SNB106
         BIN   SNB116
         BIN   SNB126
         BIN   SNB136
         BIN   SNB146
         BIN   SNB156
         LABEL 'BIT 6','BIT 6','BIT 6','DEV IRPT  ','DEV IRPT','SEC IND*
               X CK','BIT 6    ','HOME'
         SPACE 2
         LINE  ,,SKIP=3
         BIN   SNB87
         BIN   SNB97
         BIN   SNB107
         BIN   SNB117
         BIN   SNB127
         BIN   SNB137
         BIN   SNB147
         BIN   SNB157
         LABEL 'BIT 7','BIT 7','BIT 7','SEC FOUND','BIT 7','CRC HDW CK *
               ','BIT 7','NOT READY'
         SPACE 2
         LINE  (12,15),(3,15),SKIP=1
         ROUTINE SNB160,SETHEX
         ROUTINE SNB170,SETHEX
         ROUTINE SNB180,SETHEX
         ROUTINE SNB190,SETHEX
         ROUTINE SNB200,SETHEX
         ROUTINE SNB210,SETHEX
         ROUTINE SNB220,SETHEX
         ROUTINE SNB230,SETHEX
         LABEL 'BYTE 16','BYTE 17','BYTE 18','BYTE 19','BYTE 20','BYTE C
               21','BYTE 22','BYTE 23'
         SPACE 2
         LINE  ,(1,15),SKIP=2
         LABEL 'DIAGN SENSE 1','DIAGN SENSE 2','DIAGN SENSE 3',        *
               'DCIA FILE SNS','DCIA FILE CTL','MP DETECT ER',         *
               '--------SYMPTOM CODE--------'
         SPACE 2
         LINE  (2,15),(1,15),SKIP=1
         ROUTINE SNB160,SETBIN1
         ROUTINE SNB170,SETBIN1
         ROUTINE SNB180,SETBIN1
         ROUTINE SNB190,SETBIN1
         ROUTINE SNB200,SETBIN1
         ROUTINE SNB210,SETBIN1
         ROUTINE SNB220,SETBIN
         ROUTINE SNB230,SETBIN
         LABEL 'ON TRACK','BEHIND HOME','AGC-FREEZE','SEL ACTIVE',     *
               'BIT 0','BIT 0'
         SPACE 2
         LINE  (13,15),(1,15)
         BIN   SNB161
         BIN   SNB171
         BIN   SNB181
         BIN   SNB191
         BIN   SNB201
         BIN   SNB211
         LABEL 'LIN N EV TK','2 MIS CLCKS','DEMOD SELCT','TAG VALID',  *
               'BIT 1','BIT 1'
         SPACE 2
         LINE
         BIN   SNB162
         BIN   SNB172
         BIN   SNB182
         BIN   SNB192
         BIN   SNB202
         BIN   SNB212
         LABEL 'SCTR/INDEX','LINR REGION','RAW DTA VTL','NORMAL END',  *
               'SYNC IN CK','ER CODE 32'
         SPACE 2
         LINE
         BIN   SNB163
         BIN   SNB173
         BIN   SNB183
         BIN   SNB193
         BIN   SNB203
         BIN   SNB213
         LABEL 'OUT DIRECTN','VCE COL CUR','TAG PC UNSF','INDEX ALERT',*
               'FL CTR OFLO','ER CODE 16'
         SPACE 2
         LINE
         BIN   SNB164
         BIN   SNB174
         BIN   SNB184
         BIN   SNB194
         BIN   SNB204
         BIN   SNB214
         LABEL 'OFF TRACK','MIS PSIT ER','OFF TRACK','CHECK END',      *
               'TAG GATE','ER CODE 8'
         SPACE 2
         LINE
         BIN   SNB165
         BIN   SNB175
         BIN   SNB185
         BIN   SNB195
         BIN   SNB205
         BIN   SNB215
         LABEL 'PLO OUT SNC','SHIFT','ILGL TG/SVO','CE-ALERT',         *
               'RESPONSE','ER CODE 4'
         SPACE 2
         LINE
         BIN   SNB166
         BIN   SNB176
         BIN   SNB186
         BIN   SNB196
         BIN   SNB206
         BIN   SNB216
         LABEL 'DRIVE OUT','SERVO SIGNL','BUS CHECK','ERROR ALERT',    *
               'SELECT HOLD','ER CODE 2'
         SPACE 2
         LINE  ,,SKIP=2
         BIN   SNB167
         BIN   SNB177
         BIN   SNB187
         BIN   SNB197
         BIN   SNB207
         BIN   SNB217
         LABEL 'DRIVE IN','SLEW RATE','FUNCTION ER','FL BS IN PC',     *
               'RECYCLE','ER CODE 1'
         SPACE 2
HEXDUMP  ETEPILOG RLEN=70
         END
