         TITLE 'IFCS0115 - (ALIAS IFCS0125) MCH SUMMARY TABLE FOR 115 A*
               ND 125 CPU'
***********************************************************************
**                                                                   **
**                                                                   **
**  MODULE NAME:   IFCS0115    (ALIAS IFCS0125)                      **
**                                                                   **
**  DESCRIPTIVE-NAME:   SUMMARY TABLE FOR 0115 AND 0125 CPUS         **
**                                                                   **
**  COPYRIGHT:  NONE                                                 **
**                                                                   **
**  STATUS:     N/A                                                  **
**                                                                   **
**  FUNCTION:   PROVIDES SUMMARY SUPPORT FOR 0115 AND 0125 MCH       **
**              RECORDS                                              **
**                                                                   **
**  NOTES:                                                           **
**                                                                   **
**    DEPENDENCIES:   THIS MODULE WAS ASSEMBLED USING THE EBCDIC     **
**                 CHARACTER SET.  IT MUST BE REASSEMBLED IF ANOTHER **
**                CHARACTER SET IS TO BE USED AT EXECUTION.         **
**                                                                   **
**    RESTRICTIONS:   N/A                                            **
**                                                                   **
**    REGISTER-CONVENTIONS:                                          **
**          REG 2  = POINTER TO THE MCH RECORD (SUMMARY PORTION)     **
**                   POINTER TO THE SUMMARY COUNTERS (EDIT PORTION)  **
**          REG 3  = POINTER TO THE PRINT BUFFER (EDIT PORTION)      **
**                   POINTER TO CURRENT SUMMARY COUNTER (SUMMARY)    **
**          REG 4  = POINTER TO DATA ITEM REFERENCED IN 'ROUTINE'    **
**          REG 14 = RETURN POINT FROM 'ROUTINE'                     **
**          REG 15 = SET TO ZERO TO SUPPRESS PRINTING LINE           **
**                                                                   **
**    PATCH-LABEL:  PATCH                                            **
**                                                                   **
**  MODULE TYPE:    DATA                                             **
**                                                                   **
**    PROCESSOR:    370 ASSEMBLER                                    **
**                                                                   **
**    MODULE-SIZE:                                                   **
**                                                                   **
**    ATTRIBUTES:   SERIALLY REUSABLE                                **
**                                                                   **
**  ENTRY-POINT:    N/A                                              **
**                                                                   **
**    LINKAGE:      N/A                                              **
**                                                                   **
**  INPUT:     N/A                                                   **
**                                                                   **
**  OUTPUT:    N/A                                                   **
**                                                                   **
**  EXIT-NORMAL:     N/A                                             **
**                                                                   **
**  EXIT-ERROR:      N/A                                             **
**                                                                   **
**  EXTERNAL-REFERENCES:                                             **
**                                                                   **
**    ROUTINES:        NONE                                          **
**                                                                   **
**    DATA-AREAS:      NONE                                          **
**                                                                   **
**    CONTROL-BLOCKS:  NONE                                          **
**                                                                   **
**    TABLES:          NONE                                          **
**                                                                   **
**    MACROS:    EDIT AND SUMMARY TABLE MACROS                       **
**                                                                   **
***********************************************************************
         EJECT
         GBLC  &DSECT,&CSECT
         SUMMARY NAME=IFCS0115
         DSGEN (CLASRC,8),(SYSREL,8),(SWITCHES,16)
         DSGEN (SPARE1,32)
         DSGEN (DATE,32)
         DSGEN (HOUR,32)
         DSGEN (SPARE2,8),(CPUSERL,24)
         DSGEN (CPUID,16),(MCEL,16),(PJID,128),(PSW,64)
         DSGEN (SUBCD,1,0,7),(TNSCD,1,0,7),(STPVB,1,0,7)
         EJECT
&CSECT   CSECT
XSAVE    DC    5F'0'
HEX00    DC    XL4'00000000'
***********************************************************************
**                 SUMMARY ROUTINES ('SPECIAL' MACRO)                **
***********************************************************************
XDATE1   STM   R4,R8,XSAVE              SAVE REGS
         LA    R5,L0(R3)                GET OUTDSELT POINTER RIGHT
         CLC   DATE(L4),HEX00           IS DATE ZERO
         BE    RETURN
         CLC   L0(L4,R3),HEX00          IS LOW DATE ZERO
         BNE   XDATE2                   BR-NO
         MVC      L0(L4,R3),DATE                 MOVE IN DATE
XDATE2   CLC   DATE(L4),L0(R3)          CHECK FOR LOW DATE
         BL    SAVELOW                  LOWER SAVE IT
         CLC   DATE(L4),L4(R3)          CHECK FOR HI
         BNH   RETURN                   BR-NOT HI
         MVC   L4(L4,R3),DATE      MOVE HI DATE
         B     RETURN
SAVELOW  MVC   L0(L4,R3),DATE           MOVE LOW DATE
RETURN   LM    R4,R8,XSAVE              RESTORE REGS
         BR    R14                      GO BACK
         EJECT
SENTRIES DS    0F
         SPECIAL XDATE1,0,SPACE=4
         SUM   SUBCD0
         SUM   SUBCD1
         SUM   SUBCD2
         SUM   SUBCD3
         SUM   SUBCD4
         SUM   SUBCD5
         SUM   SUBCD7
         SUM   TNSCD3
         SPACE 1
         SUM   TNSCD6
         SUM   TNSCD7
         SPACE 1
         SUM   STPVB0
         SUM   STPVB1
         SUM   STPVB2
         DC    X'FF'
         SPACE 5
         PROLOG
         DSGEN (YDATES,64)
         DSGEN (YMCIC,16,0,7),(YITC,16,0,1),(YSPEC,16,0,2)
DSECTLEN EQU   *
         EJECT
&CSECT   CSECT
WORK     DS    D
XSAVE1   DC    5F'0'
L28      EQU   28
***********************************************************************
**                      EDIT ROUTINES ('ROUTINE' MACRO)              **
***********************************************************************
CONVERT  STM   R5,R8,XSAVE1             SAVE REGS
         LH    R5,L0(R4)                PICK UP COUNT
         CVD   R5,WORK                  CONVERT TO DECIMAL
         UNPK  L0(L5,R3),WORK+L5(L3)    UNPACK TO PRINT BUFF
         MVZ   L4(L1,R3),L0(R3)         PUT IN TIGHT ZONE
RETURNA  LM    R5,R8,XSAVE1             RESTORE REGS
         BR    R14                      RETURN
         SPACE 3
         FREETAB
         SPACE 3
SETDATES UNPK  WORK(L8),L0(L4,R4)       UNPACK LOW DATE
         MVZ   WORK+L7(L1),WORK         MOVE IN RIGHT ZONE
         MVC   L0(L3,R3),WORK+L5        PUT DATE IN PTR BUFF
         MVC   L5(L2,R3),WORK+L3        PUT YEAR IN PTR BUFF
         UNPK  WORK(L8),L4(L4,R4)       UNPACK HIGH DATE
         MVZ   WORK+L7(L1),WORK         MOVE IN RIGHT ZONE
         MVC   L13(L3,R3),WORK+L5       PUT DATE IN PTR BUFF
         MVC   L18(L2,R3),WORK+L3       PUT YEAR IN PTR BUFF
         BR    R14
         EJECT
         ENTRIES PAGE
         LINE  (23,60),(14,11),SKIP=2
         HEX   YCPU
         LABEL 'MODEL',                                                X
               'MACHINE CHECK RECORDS     DAY YEAR     DAY YEAR'
         SPACE 2
         LINE  (51,60),(31,29),SKIP=2
         ROUTINE YDATES,SETDATES
         LABEL 'DATE RANGE -  FROM','TO'
         SPACE 2
         LINE  (76,1),(51,1)
         HEX   YSER
         LABEL 'SERIAL NO. '
         SPACE 2
         LINE  (72,10),(51,1)
         ROUTINE YNOREC,CONVERT
         LABEL 'NO.OF RECORDS'
         SPACE 2
         LINE  (50,1),(26,26),SKIP=3
         HEX   YCPU
         LABEL '--- SUMMARY OF MODEL','MACHINE CHECK RECORDS ---'
         SPACE 2
         LINE  ,(26,1),SKIP=2
         LABEL '--- MACHINE CHECK INTERRUPT CODE ---'
         SPACE 2
         LINE  ,(36,1),SKIP=2
         LABEL '--- SUB CLASS ---'
         SPACE 2
         LINE  (24,55),(1,55),SKIP=1
         CONVT (YMCIC0,2,4),(YMCIC4,2,4)
         LABEL 'SYSTEM DAMAGE (SD)','CLOCK DAMAGE (CD)'
         SPACE 2
         LINE  ,
         CONVT (YMCIC1,2,4),(YMCIC5,2,4)
         LABEL 'PROC. DAMAGE (PD)','EXTERNAL DAMAGE (ED)'
         SPACE 2
         LINE  ,
         CONVT (YMCIC2,2,4),(YMCIC6,2,4)
         LABEL 'SYSTEM RECOVERY (SR)','AUTO-CONFIG (AC)'
         SPACE 2
         LINE  ,,SKIP=2
         CONVT (YMCIC3,2,4),(YMCIC7,2,4)
         LABEL 'TIMER DAMAGE (TD)','WARNING (W)'
         SPACE 2
         LINE  ,(28,1),SKIP=2
         LABEL '--- INTERRUPT TENSE CODES ---'
         SPACE 2
         LINE  ,(1,55),SKIP=2
         CONVT (YITC0,2,4),(YITC1,2,4)
         LABEL 'BACK-UP (B)','DELAYED (D)'
         SPACE 2
         LINE  ,(24,1),SKIP=2
         LABEL '--- STORAGE AND PROTECTION ERROR CODES ---'
         SPACE 2
         LINE  (36,58),(1,55),SKIP=1
         CONVT (YSPEC0,2,4),(YSPEC2,2,4)
         LABEL 'UNCORRECTED STORAGE ERRORS (SE)','UNCORRECTED PROTECTIO*
               N ERRORS (PE)'
         SPACE 2
         LINE  ,,SKIP=2
         CONVT (YSPEC1,2,4)
         LABEL 'CORRECTED STORAGE ERRORS (SC)'
         SPACE 2
         ETEPILOG
         END
