         TITLE 'IFCS1017 - SUMMARY TABLE FOR 1017'
***********************************************************************
**                                                                   **
**                                                                   **
**  MODULE NAME:   IFCS1017                                          **
**                                                                   **
**  DESCRIPTIVE-NAME:   SUMMARY TABLE FOR 1017 (DEVICE CODE 0831)    **
**                                                                   **
**  COPYRIGHT:  NONE                                                 **
**                                                                   **
**  STATUS:     N/A                                                  **
**                                                                   **
**  FUNCTION:   PROVIDES SUMMARY SUPPORT FOR 1017 OBR RECORDS        **
**                                                                   **
**  NOTES:                                                           **
**                                                                   **
**    DEPENDENCIES:   THIS MODULE WAS ASSEMBLED USING THE EBCDIC     **
**                 CHARACTER SET.  IT MUST BE REASSEMBLED IF ANOTHER **
**                CHARACTER SET IS TO BE USED AT EXECUTION.         **
**                                                                   **
**    RESTRICTIONS:   N/A                                            **
**                                                                   **
**    REGISTER-CONVENTIONS:                                          **
**          REG 2  = POINTER TO THE OBR RECORD (SUMMARY PORTION)     **
**                   POINTER TO THE SUMMARY COUNTERS (EDIT PORTION)  **
**          REG 3  = POINTER TO THE PRINT BUFFER (EDIT PORTION)      **
**                   POINTER TO CURRENT SUMMARY COUNTER (SUMMARY)    **
**          REG 4  = POINTER TO DATA ITEM REFERENCED IN 'ROUTINE'    **
**          REG 14 = RETURN POINT FROM 'ROUTINE'                     **
**          REG 15 = SET TO ZERO TO SUPPRESS PRINTING LINE           **
**                                                                   **
**    PATCH-LABEL:  PATCH                                            **
**                                                                   **
**  MODULE TYPE:    DATA                                             **
**                                                                   **
**    PROCESSOR:    370 ASSEMBLER                                    **
**                                                                   **
**    MODULE-SIZE:                                                   **
**                                                                   **
**    ATTRIBUTES:   SERIALLY REUSABLE                                **
**                                                                   **
**  ENTRY-POINT:    N/A                                              **
**                                                                   **
**    LINKAGE:      N/A                                              **
**                                                                   **
**  INPUT:     N/A                                                   **
**                                                                   **
**  OUTPUT:    N/A                                                   **
**                                                                   **
**  EXIT-NORMAL:     N/A                                             **
**                                                                   **
**  EXIT-ERROR:      N/A                                             **
**                                                                   **
**  EXTERNAL-REFERENCES:                                             **
**                                                                   **
**    ROUTINES:        NONE                                          **
**                                                                   **
**    DATA-AREAS:      NONE                                          **
**                                                                   **
**    CONTROL-BLOCKS:  NONE                                          **
**                                                                   **
**    TABLES:          NONE                                          **
**                                                                   **
**    MACROS:    EDIT AND SUMMARY TABLE MACROS                       **
**                                                                   **
***********************************************************************
         EJECT
         GBLC  &DSECT,&CSECT
         SUMMARY NAME=IFCS1017
         DSGEN (KEY,8),(LEVEL,8),(SWITCH,8,0,3)
         DSGEN (RECNUM,8),(RSVD2,8),(DATE,32),(TIME,32),(VERSION,8)
         DSGEN (CPUSER,24),(CPUID,16),(MCEL,16)
         DSGEN (TASKID,64)
         DSGEN (CCWCC,8),(CCWDA,24),(CCWFL,8),(CCWUN,8),(CCWCT,16)
         DSGEN (CSWK,8),(CSWCA,24),(CSWUS,8),(CSWCS,8),(CSWCT,16)
         ORG   CSWUS
         DSGEN (CSWUSB,1,0,7),(CSWCSB,1,0,7)
         ORG
         DSGEN (RSVD3,16),(FCUA,16)
         DSGEN (PUBDTC,8),(RSVD4,24),(SDRLNG,8)
         DSGEN (RSVD5,8),(NCUA,16)
         DSGEN (IORETRY,16),(SNSLNG,16)
         DSGEN (SDRBYT,8,1,10),(SNB0,1,0,7)
         DSGEN (SNB,8,EQU,SNB00),(SIOCNT,32)
&CSECT   CSECT
L28      EQU   28
L36      EQU   36
X20      EQU   X'20'
X00      DC    2F'0'
REGSAVE  DC    4F'0'               REG SAVE AREA
ENTRYNO  DC    H'0'                ENTRY NUMBER
         DS    0F
***********************************************************************
**                    SUMMARY ROUTINES ('SPECIAL' MACRO)             **
***********************************************************************
RETURN   LM    R5,R8,REGSAVE       RESTORE REGS
         BR    R14                 RETURN
         SPACE 3
ADDUP    EQU   *
         LH    R6,L0(R5)           LOAD SUM CTR
         LA    R6,L1(R6)           ADD ONE TO CTR
         STH   R6,L0(R5)           SAVE CTR
         LA    R5,L2(R5)           BUMP SUM CTR PTR
         BR    R8                  RETURN
         SPACE 3
OBRCNT   DS    0H
         STM   R5,R8,REGSAVE       SAVE REGS
         LR    R5,R3               GET COUNTER PTR
         TM    SWITCH1,X20         OBR SHORT RECORD ?
         BNO   OBRLNG              NO,BRANCH TO LONG
         BAL   R8,ADDUP            YES, BR TO BUMP CTR
         LA    R5,L2(R5)           BUMP POINTER
         MVC   REG8(4),SHORTA      SKIP SNB SUM FOR SHORT REC
         B     RETURN              RETURN
SHORTA   DC    A(SHORTB-6)
         SPACE 3
OBRLNG   DS    0H
         LA    R5,L2(R5)           BUMP CTR PTR
         BAL   R8,ADDUP            GO ADD TO CTR
         B     RETURN              RETURN
         SPACE 3
XDATE1   DS    0H
         STM   R5,R8,REGSAVE       SAVE REGS
         CLC   DATE(L4),X00        IS DATE 0 ?
         BE    RETURN              YES, BR
         CLC   L0(L4,R3),X00       IS LO DATE / ?
         BNE   XDATE2              NO, BR
         MVC   L0(L4,R3),DATE      MOVE DATE IN
XDATE2   EQU   *
         CLC   DATE(L4),L0(R3)     CHECK FOR LO DATE
         BL    SAVELOW             IT IS LOWER, BRANCH
         CLC   DATE(L4),L4(R3)     CHECK FOR HI DATE
         BNH   RETURN              IT IS IN BETWEEN, BR
         MVC   L4(L4,R3),DATE      IT IS HIGHER, SAVE IT
         B     RETURN              RETURN
         SPACE 3
SAVELOW  EQU   *
         MVC   L0(L4,R3),DATE      IT IS LO, SAVE IT
         B     RETURN              RETURN
         EJECT
SENTRIES DS    0F
         SPECIAL XDATE1,0,SPACE=4
         SPECIAL OBRCNT,0,SPACE=2
         SUM   SNB00
         SUM   SNB01
         SUM   SNB02
         SUM   SNB03
         SUM   SNB04
         SUM   SNB05
         SUM   SNB06
         SUM   SNB07
SHORTB   EQU   *
         PROLOG
         DSGEN (LODATE,32),(HIDATE,32),(OBRST,16),(OBRLG,16)
         DSGEN (SUMSNB0,16,0,7)
DSECTLEN EQU   *
         EJECT
&CSECT   CSECT
         DS    0F
***********************************************************************
**                  EDIT ROUTINES ('ROUTINE' MACRO)                  **
***********************************************************************
RETURN1  LM    R5,R8,REGSAVE1           RESTORE REGS
         BR    R14                 RETURN
         SPACE 3
SETCPUNO EQU   *
         STM   R5,R8,REGSAVE1           SAVE REGS
         SR    R5,R5                    ZERO R5
         IC    R5,L0(R4)                PICK UP CPU TYPE
         SLL   R5,L8                      V
         IC    R5,L1(R4)                  V
         LTR   R5,R5                    IS IT ZERO ?
         BNZ   RETURN1                  NO, BRANCH
         LA    R6,L36                   BACK UP POINTER 36 BYTES
         SR    R3,R6                     TO PUT IN NEW INFO
         MVC   L0(L6,R3),SHARED         SAY MODEL = SHARED     @Z427VLS
         B     RETURN1                  RETURN
         SPACE 3
SETDATE  EQU   *
         UNPK  WORK(L8),L0(L4,R4)       UNPACK A DATE
         MVZ   WORK+L7(L1),WORK         MOVE IN ZONE BITS
         MVC   L0(L3,R3),WORK+L5        MOVE DAY TO PRINT BUFF
         MVC   L5(L2,R3),WORK+L3        MOVE YEAR TO RPINT BUFF
         BR    R14                      RETURN
         SPACE 3
         FREETAB
         SPACE 3
WORK     DC    D'0'                WORK AREA
REGSAVE1 DC    4F'0'               REG SAVE AREA
SHARED   DC    C'SHARED'
         EJECT
         ENTRIES PAGE
         SPACE 2
         LINE  (97,18),(1,103),SKIP=2
         HEX   YCPU,0,2B
         HEX   YSER,0,3B
         ROUTINE YCPU,SETCPUNO
         LABEL 'SUMMARY OF I/O RECORDS  TYPE - OBR          SOURCE - OU*
               TBOARD         DEVICE TYPE 1017    MODEL-','SERIAL NO.'
         SPACE 2
         LINE  ,(13),SKIP=1
         LABEL 'DAY YEAR    DAY YEAR'
         SPACE 2
         LINE  (13,12),(1,20),SKIP=1
         ROUTINE LODATE,SETDATE
         ROUTINE HIDATE,SETDATE
         LABEL 'DATE RANGE','TO'
         SPACE 2
         LINE  (75),(50),SKIP=1
         CONVT OBRLG,2,4
         LABEL 'NO. OBR LONG RECORDS'
         SPACE 2
         LINE  ,
         CONVT OBRST,2,4
         LABEL 'NO. OBR SHORT RECORDS'
         SPACE 2
         LINE  ,(74),SKIP=1
         LABEL '------'
         SPACE 2
         LINE  (31,44),(9,41),SKIP=2
         HEX   YCUA,0,2B
         CONVT YNOREC,2,4
         LABEL ' CHANNEL UNIT ADDRESS','TOTAL NUMBER OF RECORDS'
         SPACE 2
         LINE  (46,1),(30,14),SKIP=2
         LABEL 'SENSE BYTE SUMMARY'
         SPACE 2
         LINE  ,,SKIP=1
         CONVT SUMSNB00,2,4
         LABEL 'COMMAND REJECT'
         SPACE 2
         LINE  ,
         CONVT SUMSNB01,2,4
         LABEL 'INTRVN REQD'
         SPACE 2
         LINE  ,
         CONVT SUMSNB02,2,4
         LABEL 'BUS OUT CHK'
         SPACE 2
         LINE  ,
         CONVT SUMSNB03,2,4
         LABEL 'EQUIP CHECK'
         SPACE 2
         LINE  ,
         CONVT SUMSNB04,2,4
         LABEL 'DATA CHECK'
         SPACE 2
         LINE  ,
         CONVT SUMSNB05,2,4
         LABEL 'OVERRUN'
         SPACE 2
         LINE  ,
         LABEL 'BIT 6','NO SUM'
         SPACE 2
         LINE  ,
         CONVT SUMSNB07,2,4
         LABEL 'BROKEN TAPE'
         SPACE 2
         ETEPILOG
         END
