         TITLE 'IFCS5424 - SUMMARY TABLE FOR 5424'
         GBLC  &CSECT,&DSECT
***********************************************************************
**                                                                   **
**                                                                   **
**  MODULE NAME:   IFCS5424                                          **
**                                                                   **
**  DESCRIPTIVE-NAME:   SUMMARY TABLE FOR 5424 (DEVICE CODE 0000)    **
**                                                                   **
**  COPYRIGHT:  NONE                                                 **
**                                                                   **
**  STATUS:     N/A                                                  **
**                                                                   **
**  FUNCTION:   PROVIDES SUMMARY SUPPORT FOR 5424 OBR RECORDS        **
**                                                                   **
**  NOTES:                                                           **
**                                                                   **
**    DEPENDENCIES:   THIS MODULE WAS ASSEMBLED USING THE EBCDIC     **
**                 CHARACTER SET.  IT MUST BE REASSEMBLED IF ANOTHER **
**                 CHARACTER SET IS TO BE USED AT EXECUTION.         **
**                                                                   **
**    RESTRICTIONS:   N/A                                            **
**                                                                   **
**    REGISTER-CONVENTIONS:                                          **
**          REG 2  = POINTER TO THE OBR RECORD (SUMMARY PORTION)     **
**                   POINTER TO THE SUMMARY COUNTERS (EDIT PORTION)  **
**          REG 3  = POINTER TO THE PRINT BUFFER (EDIT PORTION)      **
**                   POINTER TO CURRENT SUMMARY COUNTER (SUMMARY)    **
**          REG 4  = POINTER TO DATA ITEM REFERENCED IN 'ROUTINE'    **
**          REG 14 = RETURN POINT FROM 'ROUTINE'                     **
**          REG 15 = SET TO ZERO TO SUPPRESS PRINTING LINE           **
**                                                                   **
**    PATCH-LABEL:  PATCH                                            **
**                                                                   **
**  MODULE TYPE:    DATA                                             **
**                                                                   **
**    PROCESSOR:    370 ASSEMBLER                                    **
**                                                                   **
**    MODULE-SIZE:                                                   **
**                                                                   **
**    ATTRIBUTES:   SERIALLY REUSABLE                                **
**                                                                   **
**  ENTRY-POINT:    N/A                                              **
**                                                                   **
**    LINKAGE:      N/A                                              **
**                                                                   **
**  INPUT:     N/A                                                   **
**                                                                   **
**  OUTPUT:    N/A                                                   **
**                                                                   **
**  EXIT-NORMAL:     N/A                                             **
**                                                                   **
**  EXIT-ERROR:      N/A                                             **
**                                                                   **
**  EXTERNAL-REFERENCES:                                             **
**                                                                   **
**    ROUTINES:        NONE                                          **
**                                                                   **
**    DATA-AREAS:      NONE                                          **
**                                                                   **
**    CONTROL-BLOCKS:  NONE                                          **
**                                                                   **
**    TABLES:          NONE                                          **
**                                                                   **
**    MACROS:    EDIT AND SUMMARY TABLE MACROS                       **
**                                                                   **
***********************************************************************
         EJECT
         SUMMARY  NAME=IFCS5424
         DSGEN (KEY,8),(LEVEL,8),(SWITCH,8,0,3)
         DSGEN (RECNUM,8),(RSVD2,8),(DATE,32),(TIME,32),(VERSION,8)
         DSGEN (CPUSER,24),(CPUID,16),(MCEL,16)
         DSGEN (TASKID,64)
         DSGEN (CCWCC,8),(CCWDA,24),(CCWFL,8),(CCWUN,8),(CCWCT,16)
         DSGEN (CSWK,8),(CSWCA,24),(CSWUS,8),(CSWCS,8),(CSWCT,16)
         ORG   CSWUS
         DSGEN (CSWUSB,1,0,7),(CSWCSB,1,0,7)
         ORG
         DSGEN (RSVD3,16),(FCUA,16)
         DSGEN (PUBDTC,8),(RSVD4,24),(SDRLNG,8)
         DSGEN (RSVD5,8),(NCUA,16)
         DSGEN (IORETRY,16),(SNSLNG,16)
         DSGEN (SNB,1,0,12,0,7)
         ORG   SNB00
         DSGEN (SNB,8,0,9),(SNBA,8),(SNBB,8),(SNBC,8),(SIOCNT,32)
         EJECT
&CSECT   CSECT
L28      EQU   28
L46      EQU   46
X20      EQU   X'20'
ENTRYNO  DC    H'0'                ENTRY NUMBER
M3       DC    F'3'
X00      DC    2F'0'
REGSAVE  DC    4F'0'                    REG SAVE AREA
ONE      DC    H'1'
         DS    0F
         SPACE 3
***********************************************************************
**                    SUMMARY ROUTINES ('SPECIAL' MACRO)             **
***********************************************************************
RETURN   LM    R5,R8,REGSAVE            RESTORE REGS
         BR    R14                      RETURN
         SPACE 3
XDATE1   DS    0H
         STM   R5,R8,REGSAVE            SAVE REGS
         CLC   DATE(L4),X00             IS DATE 0 ?
         BE    RETURN                   YES, BR
         CLC   L0(L4,R3),X00            IS LO DATE / ?
         BNE   XDATE2                   NO, BR
         MVC   L0(L4,R3),DATE           MOVE DATE IN
XDATE2   EQU   *
         CLC   DATE(L4),L0(R3)          CHECK FOR LO DATE
         BL    SAVELOW                  IT IS LOWER, BRANCH
         CLC   DATE(L4),L4(R3)          CHECK FOR HI DATE
         BNH   RETURN                   IT IS IN BETWEEN, BR
         MVC   L4(L4,R3),DATE           IT IS HIGHER, SAVE IT
         B     RETURN                   RETURN
         SPACE 3
SAVELOW  EQU   *
         MVC   L0(L4,R3),DATE           IT IS LO, SAVE IT
         B     RETURN                   RETURN
         SPACE 3
COUNTSIO EQU   *
         STM   R5,R6,REGSAVE       SAVE REGS
         ICM   R6,X'F',SIOCNT      GET SIO COUNTER
         ICM   R5,X'F',L0(R3)      GET SUMMARY COUNTER
         AR    R5,R6               ADD COUNTERS
         STCM  R5,X'F',L0(R3)      STORE COUNTER
         LM    R5,R6,REGSAVE       RESTORE REGS
         BR    R14                 RETURN
         SPACE 3
RPCHECK  EQU   *
         TM    SNB10,X'C0'         READ CHECK OR PUNCH CHECK?
         BZR   R14                 NO...RETURN
         STM   R5,R6,REGSAVE       SAVE REGS
         LR    R6,R3               GET @ COUNTERS
         TM    SNB10,X'80'         READ CHECK?
         BO    RP1                 YES...
         LA    R6,L3(R6)           GO TO PUNCH COUNTERS
RP1      IC    R5,SNB40            GET SENSE BYTE 4
         SRL   R5,L5               GET RID OF BITS 3-7
         N     R5,M3               JUST KEEP BITS 1,2 (TIER MASK)
         LA    R6,L0(R5,R6)        GET PROPER COUNTER FOR THIS TIER
         OC    L0(L1,R6),SNB50     OR SENSE BYTE 5 WITH COUNTER
         LM    R5,R6,REGSAVE       RESTORE REGS
         BR    R14
         SPACE 3
FDCHECK  EQU   *
         TM    SNB10,X'02'         FEED CHECK?
         BZR   R14                 NO...GO AWAY
         STM   R5,R6,REGSAVE       SAVE REGS
         XR    R5,R5               CLEAR REG
         IC    R5,SNB30            GET FEED CHECK CODE
         BCTR  R5,R0               MINUS 1
         SLL   R5,L1               TIMES 2
         LH    R6,L0(R5,R3)        GET COUNTER
         AH    R6,ONE              INCREMENT
         STH   R6,L0(R5,R3)        STORE COUNTER
         LM    R5,R6,REGSAVE       RESTORE REGS
         BR    R14                 RETURN
         EJECT
SENTRIES DS    0F
         SPECIAL XDATE1,0,SPACE=4
         SPACE
         SPECIAL COUNTSIO,0,SPACE=2
         SPACE
         SUM   SNB00
         SUM   SNB01
         SUM   SNB02
         SUM   SNB03
         SUM   SNB04
         SUM   SNB05
         SUM   SNB06
         SUM   SNB07
         SPACE
         SUM   SNB10
         SUM   SNB11
         SUM   SNB12
         SUM   SNB13
         SUM   SNB14
         SUM   SNB15
         SUM   SNB16
         SUM   SNB17
         SPACE
         SPECIAL RPCHECK,0,SPACE=3
         SPACE
         SPECIAL FDCHECK,0,SPACE=22
         SPACE
         PROLOG
         DSGEN (LODATE,32),(HIDATE,32),(SIOSUM,32),(SNBSUM,16,0,1,0,7),*
               (RCHK,8,1,3),(PCHK,8,1,3),(FCHK,16,1,22)
DSECTLEN EQU   *
         EJECT
&CSECT   CSECT
***********************************************************************
**                  EDIT ROUTINES ('ROUTINE' MACRO)                  **
***********************************************************************
RETURN1  LM    R5,R8,REGSAVE1           RESTORE REGS
         BR    R14                 RETURN
         SPACE 3
SETCPUNO EQU   *
         STM   R5,R8,REGSAVE1           SAVE REGS
         SR    R5,R5                    ZERO R5
         IC    R5,L0(R4)                PICK UP CPU TYPE
         SLL   R5,L8                      V
         IC    R5,L1(R4)                  V
         LTR   R5,R5                    IS IT ZERO ?
         BNZ   RETURN1                  NO, BRANCH
         LA    R6,L46                   BACK UP POINTER 46 BYTES
         SR    R3,R6                     TO PUT IN NEW INFO
         MVC   L0(L6,R3),SHARED         SAY MODEL = SHARED     @Z427VLS
         B     RETURN1                  RETURN
         SPACE 3
SETDATE  EQU   *
         UNPK  WORK(L8),L0(L4,R4)       UNPACK A DATE
         MVZ   WORK+L7(L1),WORK         MOVE IN ZONE BITS
         MVC   L0(L3,R3),WORK+L5        MOVE DAY TO PRINT BUFF
         MVC   L5(L2,R3),WORK+L3        MOVE YEAR TO RPINT BUFF
         BR    R14                      RETURN
         SPACE 3
NOSUMIT  ST    R5,REGSAVE1         SAVE REG
         LR    R5,R3               GET PRINT POSITION
         BCTR  R5,R0               MINUS 1
         BCTR  R5,R0               MINUS ANOTHER 1
         MVC   L0(L6,R5),NOSUM     MOVE IN LABEL
         L     R5,REGSAVE1         RESTORE REG
         BR    R14                 RETURN
         SPACE 3
BKUP     SH    R3,EIGHT            BACK UP 8 CHARS
         BR    R14                 RETURN
         SPACE 3
         FREETAB
         SPACE 3
WORK     DC    D'0'                WORK AREA
REGSAVE1 DC    4F'0'               REG SAVE AREA
EIGHT    DC    H'8'
SHARED   DC    C'SHARED'
NOSUM    DC    C'NO SUM'
         EJECT
         ENTRIES PAGE
         SPACE 2
         LINE  (97,18),(1,103),SKIP=2
         HEX   YCPU,0,2B
         HEX   YSER,0,3B
         ROUTINE YCPU,SETCPUNO
         LABEL 'SUMMARY OF I/O RECORDS  TYPE - OBR          SOURCE - OU*
               TBOARD         DEVICE TYPE 5424    MODEL-','SERIAL NO.'
         SPACE 2
         LINE  ,(13),SKIP=1
         LABEL 'DAY YEAR    DAY YEAR'
         SPACE 2
         LINE  (13,12),(1,20),SKIP=2
         ROUTINE LODATE,SETDATE
         ROUTINE HIDATE,SETDATE
         LABEL 'DATE RANGE','TO'
         SPACE 2
         LINE  (31,30),(25,20),SKIP=2
         HEX   YCUA,0,2B
         CONVT YNOREC,2,4
         CONVT SIOSUM,4,8
         LABEL 'CUA -','TOTAL RECORDS -','  TOTAL START I/O COUNT -'
         SPACE 2
         LINE  ,(45,1),SKIP=2
         LABEL 'SENSE DATA'
         SPACE 2
         LINE  ,(23,36),SKIP=2
         LABEL 'BYTE 0 SUMMARY','BYTE 1 SUMMARY'
         SPACE 2
         LINE  (41,36),(21,36),SKIP=1
         ROUTINE SNBSUM00,NOSUMIT
         CONVT SNBSUM10,2,4
         LABEL 'COMMAND REJECT','READ CHECK'
         SPACE 2
         LINE  ,
         CONVT SNBSUM01,2,4
         CONVT SNBSUM11,2,4
         LABEL 'INTERV REQD','PUNCH CHECK'
         SPACE 2
         LINE  ,
         CONVT SNBSUM02,2,4
         CONVT SNBSUM12,2,4
         LABEL 'BUS OUT CHECK','CYCLE-STEAL ORUN'
         SPACE 2
         LINE  ,
         CONVT SNBSUM03,2,4
         CONVT SNBSUM13,2,4
         LABEL 'EQUIP CHECK','PRINT DATA CHK'
         SPACE 2
         LINE  ,
         CONVT SNBSUM04,2,4
         CONVT SNBSUM14,2,4
         LABEL 'DATA CHECK','PRINT CLUTCH CHK'
         SPACE 2
         LINE  ,
         ROUTINE SNBSUM05,NOSUMIT
         CONVT SNBSUM15,2,4
         LABEL 'BIT 5 - UNUSED','HOPPER CHECK'
         SPACE 2
         LINE  ,
         ROUTINE SNBSUM06,NOSUMIT
         CONVT SNBSUM16,2,4
         LABEL 'NO CARD AVAIL','FEED CHECK'
         SPACE 2
         LINE  ,,SKIP=3
         ROUTINE SNBSUM07,NOSUMIT
         CONVT SNBSUM17,2,4
         LABEL 'BIT 7 - UNUSED','PUNCH DATA CHK'
         SPACE 2
         LINE  ,(20,25),SKIP=2
         LABEL 'READ CHECK SUMMARY','PUNCH CHECK SUMMARY','FEED CHECK S*
               UMMARY'
         SPACE 2
         LINE  ,(23,25),SKIP=1
         LABEL 'ROW  DCBA8421','ROW  DCBA8421'
         SPACE 2
         LINE  (28,25),(20,25),SKIP=1
         BIN   (RCHK1,0,8),(PCHK1,0,8)
         ROUTINE FCHK1,BKUP
         CONVT FCHK1,2,4
         LABEL 'TIER 1','TIER 1','HOPPER EJECT CHECK'
         SPACE 2
         LINE  ,
         BIN   (RCHK2,0,8),(PCHK2,0,8)
         ROUTINE FCHK2,BKUP
         CONVT FCHK2,2,4
         LABEL 'TIER 2','TIER 2','READ INJECT CHECK'
         SPACE 2
         LINE  ,
         BIN   (RCHK3,0,8),(PCHK3,0,8)
         ROUTINE FCHK3,BKUP
         CONVT FCHK3,2,4
         LABEL 'TIER 3','TIER 3','READ STATION CHECK'
         SPACE 2
         LINE  (95,1),(70,1),SKIP=1
         CONVT FCHK4,2,4
         LABEL 'READ EJECT CHECK'
         SPACE 2
         LINE  ,
         CONVT FCHK5,2,4
         LABEL 'EARLY WAIT EJECT CHECK'
         SPACE 2
         LINE  ,
         CONVT FCHK6,2,4
         LABEL 'WAIT EJECT CHECK'
         SPACE 2
         LINE  ,
         CONVT FCHK7,2,4
         LABEL 'PUNCH INJECT CHECK'
         SPACE 2
         LINE  ,
         CONVT FCHK8,2,4
         LABEL 'PUNCH REG 1 CHECK'
         SPACE 2
         LINE  ,
         CONVT FCHK9,2,4
         LABEL 'PUNCH STATION CHECK'
         SPACE 2
         LINE  ,
         CONVT FCHK10,2,4
         LABEL 'PUNCH REG 2 CHECK'
         SPACE 2
         LINE  ,
         CONVT FCHK11,2,4
         LABEL 'PUNCH TRANSPORT CHECK'
         SPACE 2
         LINE  ,
         CONVT FCHK12,2,4
         LABEL 'PUNCH EJECT CHECK'
         SPACE 2
         LINE  ,
         CONVT FCHK13,2,4
         LABEL 'CORNER STATION CHECK'
         SPACE 2
         LINE  ,
         CONVT FCHK14,2,4
         LABEL 'CORNER EJECT CHECK'
         SPACE 2
         LINE  ,
         CONVT FCHK15,2,4
         LABEL 'PRINT INJECT CHECK'
         SPACE 2
         LINE  ,
         CONVT FCHK16,2,4
         LABEL 'PRINT STATION CHECK'
         SPACE 2
         LINE  ,
         CONVT FCHK17,2,4
         LABEL 'PRINT EJECT CHECK'
         SPACE 2
         LINE  ,
         CONVT FCHK18,2,4
         LABEL 'STACKER TNSPORT CHECK'
         SPACE 2
         LINE  ,
         CONVT FCHK19,2,4
         LABEL 'STACKER JAM CHECK'
         SPACE 2
         LINE  ,
         CONVT FCHK20,2,4
         LABEL 'GEAR EMITTER CHECK'
         SPACE 2
         LINE  ,
         CONVT FCHK21,2,4
         LABEL 'FIRE CB CHECK'
         SPACE 2
         LINE  ,,SKIP=2
         CONVT FCHK22,2,4
         LABEL 'COVER OPEN CHECK'
         SPACE 2
         ETEPILOG
         END
