         TITLE 'IFCSI115 - (ALIAS IFCSI125) CCH SUMMARY TABLE FOR 115 A*
               ND 125 CPU'
***********************************************************************
**                                                                   **
**                                                                   **
**  MODULE NAME:   IFCSI115     (ALIAS IFCSI125)                     **
**                                                                   **
**  DESCRIPTIVE-NAME:   SUMMARY TABLE FOR 0115 AND 0125 CPUS         **
**                                                                   **
**  COPYRIGHT:  NONE                                                 **
**                                                                   **
**  STATUS:     N/A                                                  **
**                                                                   **
**  FUNCTION:   PROVIDES SUMMARY SUPPORT FOR 0115 AND 0125 CCH       **
**              RECORDS.                                             **
**                                                                   **
**  NOTES:                                                           **
**                                                                   **
**    DEPENDENCIES:   THIS MODULE WAS ASSEMBLED USING THE EBCDIC     **
**                 CHARACTER SET.  IT MUST BE REASSEMBLED IF ANOTHER **
**                CHARACTER SET IS TO BE USED AT EXECUTION.         **
**                                                                   **
**    RESTRICTIONS:   N/A                                            **
**                                                                   **
**    REGISTER-CONVENTIONS:                                          **
**          REG 2  = POINTER TO THE CCH RECORD (SUMMARY PORTION)     **
**                   POINTER TO THE SUMMARY COUNTERS (EDIT PORTION)  **
**          REG 3  = POINTER TO THE PRINT BUFFER (EDIT PORTION)      **
**                   POINTER TO CURRENT SUMMARY COUNTER (SUMMARY)    **
**          REG 4  = POINTER TO DATA ITEM REFERENCED IN 'ROUTINE'    **
**          REG 14 = RETURN POINT FROM 'ROUTINE'                     **
**          REG 15 = SET TO ZERO TO SUPPRESS PRINTING LINE           **
**                                                                   **
**    PATCH-LABEL:  PATCH                                            **
**                                                                   **
**  MODULE TYPE:    DATA                                             **
**                                                                   **
**    PROCESSOR:    370 ASSEMBLER                                    **
**                                                                   **
**    MODULE-SIZE:                                                   **
**                                                                   **
**    ATTRIBUTES:   SERIALLY REUSABLE                                **
**                                                                   **
**  ENTRY-POINT:    N/A                                              **
**                                                                   **
**    LINKAGE:      N/A                                              **
**                                                                   **
**  INPUT:     N/A                                                   **
**                                                                   **
**  OUTPUT:    N/A                                                   **
**                                                                   **
**  EXIT-NORMAL:     N/A                                             **
**                                                                   **
**  EXIT-ERROR:      N/A                                             **
**                                                                   **
**  EXTERNAL-REFERENCES:                                             **
**                                                                   **
**    ROUTINES:        NONE                                          **
**                                                                   **
**    DATA-AREAS:      NONE                                          **
**                                                                   **
**    CONTROL-BLOCKS:  NONE                                          **
**                                                                   **
**    TABLES:          NONE                                          **
**                                                                   **
**    MACROS:    EDIT AND SUMMARY TABLE MACROS                       **
**                                                                   **
***********************************************************************
         EJECT
         GBLC  &DSECT,&CSECT
         SUMMARY NAME=IFCSI115
         DSGEN (CLASRC,8),(SYSREL,8),(SWITCHES,16)
         DSGEN (SPARE1,32)
         DSGEN (DATE,32)
         DSGEN (HOUR,32)
         DSGEN (SPARE2,8),(CPUSERL,24)
         DSGEN (CPUID,16),(MCEL,16),(JOBID,64),(CUU,128),(CCW,64)
         DSGEN (CSWKCA,32),(CSWUS,1,0,7),(CSWCS,1,0,7),(CSWCT,16)
         DSGEN (DUM1,8),(ECSW,1,0,7)
         EJECT
&CSECT   CSECT
XSAVE    DS    6F
HEX00    DC    F'0'
***********************************************************************
**                 SUMMARY ROUTINES ('SPECIAL' MACRO)                **
***********************************************************************
XDATE1   STM   R4,R8,XSAVE              SAVE REGS
         LA    R5,L0(R3)                GET OUTDSELT POINTER RIGHT
         CLC   DATE(L4),HEX00           IS DATE ZERO
         BE    RETURN
         CLC   L0(L4,R3),HEX00          IS LOW DATE ZERO
         BNE   XDATE2                   BR-NO
         MVC      L0(L4,R3),DATE                 MOVE IN DATE
XDATE2   CLC   DATE(L4),L0(R3)          CHECK FOR LOW DATE
         BL    SAVELOW                  LOWER SAVE IT
         CLC   DATE(L4),L4(R3)          CHECK FOR HI
         BNH   RETURN                   BR-NOT HI
         MVC   L4(L4,R3),DATE      MOVE HI DATE
         B     RETURN
SAVELOW  MVC   L0(L4,R3),DATE           MOVE LOW DATE
RETURN   LM    R4,R8,XSAVE              RESTORE REGS
         BR    R14                      GO BACK
         EJECT
SENTRIES DS    0F
         SPECIAL XDATE1,0,SPACE=4
         SUM   ECSW0
         SUM   ECSW1
         SUM   ECSW2
         SUM   ECSW3
         SUM   ECSW4
         SPACE 1
         SUM   CSWUS0
         SUM   CSWUS1
         SUM   CSWUS2
         SUM   CSWUS3
         SUM   CSWUS4
         SUM   CSWUS5
         SUM   CSWUS6
         SUM   CSWUS7
         SPACE 1
         SUM   CSWCS0
         SUM   CSWCS1
         SUM   CSWCS2
         SUM   CSWCS3
         SUM   CSWCS4
         SUM   CSWCS5
         SUM   CSWCS6
         SUM   CSWCS7
         DC    X'FF'
         SPACE 5
         PROLOG
         DSGEN (YDATES,64)
         DSGEN (YERSRC,16,0,4),(YUS,16,0,7),(YCS,16,0,7)
DSECTLEN EQU   *
         EJECT
&CSECT   CSECT
WORK     DS    D
XSAVE1   DC    5F'0'
L28      EQU   28
***********************************************************************
**                      EDIT ROUTINES ('ROUTINE' MACRO)              **
***********************************************************************
CONVERT  STM   R5,R8,XSAVE1             SAVE REGS
         LH    R5,L0(R4)                PICK UP COUNT
         CVD   R5,WORK                  CONVERT TO DECIMAL
         UNPK  L0(L5,R3),WORK+L5(L3)    UNPACK TO PRINT BUFF
         MVZ   L4(L1,R3),L0(R3)         PUT IN TIGHT ZONE
RETURNA  LM    R5,R8,XSAVE1             RESTORE REGS
         BR    R14                      RETURN
         SPACE 3
         FREETAB
         SPACE 3
SETDATES UNPK  WORK(L8),L0(L4,R4)       UNPACK LOW DATE
         MVZ   WORK+L7(L1),WORK         MOVE IN RIGHT ZONE
         MVC   L0(L3,R3),WORK+L5        PUT DATE IN PTR BUFF
         MVC   L5(L2,R3),WORK+L3        PUT YEAR IN PTR BUFF
         UNPK  WORK(L8),L4(L4,R4)       UNPACK HIGH DATE
         MVZ   WORK+L7(L1),WORK         MOVE IN RIGHT ZONE
         MVC   L13(L3,R3),WORK+L5       PUT DATE IN PTR BUFF
         MVC   L18(L2,R3),WORK+L3       PUT YEAR IN PTR BUFF
         BR    R14
         EJECT
         ENTRIES PAGE
         LINE  (23,60),(14,11),SKIP=2
         HEX   YCPU
         LABEL 'MODEL',                                                X
               'CHANNEL CHECK RECORDS     DAY YEAR     DAY YEAR'
         SPACE 2
         LINE  (51,60),(31,29),SKIP=2
         ROUTINE YDATES,SETDATES
         LABEL 'DATE RANGE -  FROM','TO'
         SPACE 2
         LINE  (76,1),(51,1)
         HEX   YSER
         LABEL 'SERIAL NO. '
         SPACE 2
         LINE  (72,10),(51,1)
         ROUTINE YNOREC,CONVERT
         LABEL 'NO.OF RECORDS'
         SPACE 2
         LINE  (50,1),(26,26),SKIP=3
         HEX   YCPU
         LABEL '--- SUMMARY OF MODEL','CHANNEL CHECK RECORDS ---'
         SPACE 2
         LINE  ,(51,1),SKIP=2
         LABEL 'ERROR SOURCE'
         SPACE 2
         LINE  (60,1),(53,1),SKIP=1
         CONVT (YERSRC0,2,4)
         LABEL 'CPU'
         SPACE 2
         LINE  ,
         CONVT (YERSRC1,2,4)
         LABEL 'CHAN'
         SPACE 2
         LINE  ,
         CONVT (YERSRC2,2,4)
         LABEL 'SCU'
         SPACE 2
         LINE  ,
         CONVT (YERSRC3,2,4)
         LABEL 'SU'
         SPACE 2
         LINE  ,,SKIP=3
         CONVT (YERSRC4,2,4)
         LABEL 'CU'
         SPACE 2
         LINE  ,(15,53),SKIP=2
         LABEL '--- UNIT STATUS ---','--- CHANNEL STATUS ---'
         SPACE 2
         LINE  (19,26),(1,26),SKIP=1
         CONVT (YUS0,2,4),(YUS4,2,4),(YCS0,2,4),(YCS4,2,4)
         LABEL 'ATTENTION','CHANNEL END','PRGM-CTLD IRPT','CHAN DATA CH*
               ECK'
         SPACE 2
         LINE  ,
         CONVT (YUS1,2,4),(YUS5,2,4),(YCS1,2,4),(YCS5,2,4)
         LABEL 'STATUS MODIFIER','DEVICE END','INCORRECT LENGTH','CHAN *
               CTL CHECK'
         SPACE 2
         LINE  ,
         CONVT (YUS2,2,4),(YUS6,2,4),(YCS2,2,4),(YCS6,2,4)
         LABEL 'CONTROL UNIT END','UNIT CHECK','PROGRAM CHECK','I/F CTL*
                CHECK'
         SPACE 2
         LINE  ,,SKIP=2
         CONVT (YUS3,2,4),(YUS7,2,4),(YCS3,2,4),(YCS7,2,4)
         LABEL 'BUSY','UNIT EXCEPTION','PROTECTION CHECK','CHAINING CHE*
               CK'
         SPACE 2
         ETEPILOG
         END
