         TITLE 'SYSTEM STROKE TABLE - GSP01'
***********************************************************************
*                                                                     *
*TITLE              SYSTEM STROKE TABLE - GSP01                       *
*                                                                     *
*MODULE NAME        IFFAHA16                                          *
*                                                                     *
*STATUS             CHANGE LEVEL 000                                  *
*                                                                     *
*FUNCTION- TO DEFINE THE EBCDIC CHARACTERS IN TERMS OF STROKES ON A   *
*  128 BY 128 MATRIX.                                                 *
*FORMAT  - 256 ADDRESS,FOLLOWED BY DEFINE CONSTANT INSTRUCTIONS       *
*  WHICH DEFINE THE CHARACTERS. ANY ADDRESS WHICH IS EQUIVALENT TO    *
*  AN EBCDIC SYMBOL POINTS TO THE STROKE DEFINITION FOR THAT SYMBOL.  *
*  THE OTHER ADDRESSES ARE ZERO. TWO WORDS ARE RESERVED AT THE        *
*  BEGINNING OF THE TABLE AND SERVE AS ID AND CHAIN FIELDS, USED BY   *
*  PLSTR AND DFSTR.                                                   *
*  THE DEFINITION OF EACH SYMBOL RESERVES 16 HALF-WORDS (=16 STROKES) *
*  SO THE TABLE MAY BE ALLTERED BY DFSTR.                             *
*FORMAT OF STROKE DEFINITION ENTRY   - ONE HALF WORD/STROKE           *
*       BYTE 0     BIT 0 = 0-STROKE IS UNBLANKED                      *
*                        = 1-STROKE IS BLANKED                        *
*                  BITS 1-7 -A VALUE FROM 0-127 DEFINING THE X        *
*                            COORDINATE ON A 128 BY 128 MATRIX        *
*                                                                     *
*       BYTE 1     BIT 0 = 0 -NOT LAST STROKE IN DEFINITION OF SYMBOL *
*                        = 1 -LAST STROKE IN DEFINITION OF SYSTEM     *
*                  BITS 1-7  -A VALUE FROM 0-127 DEFINING THE Y       *
*                             COORDINATE ON A 128 BY 128 MATRIX       *
*                                                                     *
*ENTRY POINT  -    GSP01                                              *
*                                                                     *
*ATTRIBUTES   -    NEITHER REUSABLE NOR REENTRANT, ONLY LOADABLE      *
*                                                                     *
*                                                                     *
***********************************************************************
         EJECT
IFFAHA16 CSECT
         ENTRY GSP01
GSP01    DS    F                       WORD FOR STROKE TABLE ID
         DS    F                       WORD FOR CHAIN FIELD
ADDR     DC    256F'0'
         ORG   ADDR+C'A'*4              A
         DC    A(CODEA)
         ORG   ADDR+C'B'*4              B
         DC    A(CODEB)
         ORG   ADDR+C'C'*4              C
         DC    A(CODEC)
         ORG   ADDR+C'D'*4              D
         DC    A(CODED)
         ORG   ADDR+C'E'*4              E
         DC    A(CODEE)
         ORG   ADDR+C'F'*4              F
         DC    A(CODEF)
         ORG   ADDR+C'G'*4              G
         DC    A(CODEG)
         ORG   ADDR+C'H'*4              H
         DC    A(CODEH)
         ORG   ADDR+C'I'*4              I
         DC    A(CODEI)
         ORG   ADDR+C'J'*4              J
         DC    A(CODEJ)
         ORG   ADDR+C'K'*4              K
         DC    A(CODEK)
         ORG   ADDR+C'L'*4              L
         DC    A(CODEL)
         ORG   ADDR+C'M'*4              M
         DC    A(CODEM)
         ORG   ADDR+C'N'*4              N
         DC    A(CODEN)
         ORG   ADDR+C'O'*4              O
         DC    A(CODEO)
         ORG   ADDR+C'P'*4              P
         DC    A(CODEP)
         ORG   ADDR+C'Q'*4              Q
         DC    A(CODEQ)
         ORG   ADDR+C'R'*4              R
         DC    A(CODER)
         ORG   ADDR+C'S'*4              S
         DC    A(CODES)
         ORG   ADDR+C'T'*4              T
         DC    A(CODET)
         ORG   ADDR+C'U'*4              U
         DC    A(CODEU)
         ORG   ADDR+C'V'*4              V
         DC    A(CODEV)
         ORG   ADDR+C'W'*4              W
         DC    A(CODEW)
         ORG   ADDR+C'X'*4              X
         DC    A(CODEX)
         ORG   ADDR+C'Y'*4
         DC    A(CODEY)
         ORG   ADDR+C'Z'*4              Z
         DC    A(CODEZ)
         ORG   ADDR+C'0'*4              0
         DC    A(CODE0)
         ORG   ADDR+C'1'*4              1
         DC    A(CODE1)
         ORG   ADDR+C'2'*4              2
         DC    A(CODE2)
         ORG   ADDR+C'3'*4              3
         DC    A(CODE3)
         ORG   ADDR+C'4'*4              4
         DC    A(CODE4)
         ORG   ADDR+C'5'*4              5
         DC    A(CODE5)
         ORG   ADDR+C'6'*4              6
         DC    A(CODE6)
         ORG   ADDR+C'7'*4              7
         DC    A(CODE7)
         ORG   ADDR+C'8'*4              8
         DC    A(CODE8)
         ORG   ADDR+C'9'*4              9
         DC    A(CODE9)
         ORG   ADDR+X'4A'*4             CENT SYMBOL
         DC    A(CODES1)
         ORG   ADDR+C'.'*4              .
         DC    A(CODES2)
         ORG   ADDR+C'<'*4              <
         DC    A(CODES3)
         ORG   ADDR+C'('*4              (
         DC    A(CODES4)
         ORG   ADDR+C'+'*4              +
         DC    A(CODES5)
         ORG   ADDR+C'|'*4              |
         DC    A(CODES6)
         ORG   ADDR+C'&&'*4             &
         DC    A(CODES7)
         ORG   ADDR+C'!'*4              B
         DC    A(CODES8)
         ORG   ADDR+C'$'*4              $
         DC    A(CODES9)
         ORG   ADDR+C'*'*4              *
         DC    A(CODES10)
         ORG   ADDR+C')'*4              )
         DC    A(CODES11)
         ORG   ADDR+C';'*4              ;
         DC    A(CODES12)
         ORG   ADDR+C'^'*4              ^
         DC    A(CODES13)
         ORG   ADDR+C'-'*4              -
         DC    A(CODES14)
         ORG   ADDR+C'/'*4              /
         DC    A(CODES15)
         ORG   ADDR+C','*4              ,
         DC    A(CODES16)
         ORG   ADDR+C'%'*4              %
         DC    A(CODES17)
         ORG   ADDR+C'_'*4              _
         DC    A(CODES18)
         ORG   ADDR+C'>'*4              >
         DC    A(CODES19)
         ORG   ADDR+C'?'*4              ?
         DC    A(CODES20)
         ORG   ADDR+C':'*4              :
         DC    A(CODES21)
         ORG   ADDR+C'#'*4              #
         DC    A(CODES22)
         ORG   ADDR+C'@'*4              @
         DC    A(CODES23)
         ORG   ADDR+C''''*4             '
         DC    A(CODES24)
         ORG   ADDR+C'='*4              =
         DC    A(CODES25)
         ORG   ADDR+C'"'*4              "
         DC    A(CODES26)
         ORG   ADDR+C' '*4
         DC    A(CODES27)
         ORG
CODEA    DC    X'900030605000403020B0'
         DC    11H'0'
CODEB    DC    X'9000106040605050504040305020501040001000903040B0'
         DC    4H'0'
CODEC    DC    X'D01040002000101010502060406050D0'
         DC    8H'0'
CODED    DC    X'9000400050105050406010601080'
         DC    9H'0'
CODEE    DC    X'D000100010605060C03010B0'
         DC    10H'0'
CODEF    DC    X'900010605060C03010B0'
         DC    11H'0'
CODEG    DC    X'B020502050002000101010502060406050D0'
         DC    7H'0'
CODEH    DC    X'9000106090305030D0605080'
         DC    10H'0'
CODEI    DC    X'A0004000B0003060A06040E0'
         DC    10H'0'
CODEJ    DC    X'901020004000501050E0'
         DC    11H'0'
CODEK    DC    X'90001060D06010305080'
         DC    11H'0'
CODEL    DC    X'906010005080'
         DC    13H'0'
CODEM    DC    X'90001060303050605080'
         DC    11H'0'
CODEN    DC    X'90001060500050E0'
         DC    12H'0'
CODEO    DC    X'A00040005010505040602060105010102080'
         DC    7H'0'
CODEP    DC    X'90001060406050505040403010B0'
         DC    9H'0'
CODEQ    DC    X'A00040005010505040602060105010102000D00030A0'
         DC    5H'0'
CODER    DC    X'90001060406050505040403020305080'
         DC    8H'0'
CODES    DC    X'9010200040005010502040302030104010502060406050D0'
         DC    4H'0'
CODET    DC    X'B0003060906050E0'
         DC    12H'0'
CODEU    DC    X'9060101020004000501050E0'
         DC    10H'0'
CODEV    DC    X'9060300050E0'
         DC    13H'0'
CODEW    DC    X'906020003030400050E0'
         DC    11H'0'
CODEX    DC    X'90005060D00010E0'
         DC    12H'0'
CODEY    DC    X'B00030305060906030B0'
         DC    11H'0'
CODEZ    DC    X'9060506010005080'
         DC    12H'0'
CODE0    DC    X'A00040005020504040602060104010202000B02830B8'
         DC    5H'0'
CODE1    DC    X'A05030603080'
         DC    13H'0'
CODE2    DC    X'9050206040605050504010005080'
         DC    9H'0'
CODE3    DC    X'90605060304050305010400020001090'
         DC    8H'0'
CODE4    DC    X'A05010205020C00040E0'
         DC    11H'0'
CODE5    DC    X'9010200040005010503040401040106050E0'
         DC    7H'0'
CODE6    DC    X'D05040602060105010102000400050105020403010B0'
         DC    5H'0'
CODE7    DC    X'9000506010E0'
         DC    13H'0'
CODE8    DC    X'A040103010102000400050105030404020401050206040605050'
         DC    X'40C000000000'
CODE9    DC    X'901020004000501050504060206010501040203050B0'
         DC    5H'0'
CODES1   DC    X'A0004050D040305020402020301050A0'
         DC    8H'0'
CODES2   DC    X'A00030104000B0003090'
         DC    11H'0'
CODES3   DC    X'D000102050C0'
         DC    13H'0'
CODES4   DC    X'D060305030105080'
         DC    12H'0'
CODES5   DC    X'B0103050903050B0'
         DC    12H'0'
CODES6   DC    X'B01030D0'
         DC    14H'0'
CODES7   DC    X'D00020402050306040504040102010102000300050A0'
         DC    5H'0'
CODES8   DC    X'A000301040002000B0204060306030A0'
         DC    8H'0'
CODES9   DC    X'9010200040005010502010301040205040505040B0603080'
         DC    4H'0'
CODES10  DC    X'90105050D0101050B0103050903050B0'
         DC    8H'0'
CODES11  DC    X'90003010305010E0'
         DC    12H'0'
CODES12  DC    X'90003010302020103010B0303040203030B0'
         DC    7H'0'
CODES13  DC    X'9030403040A0'
         DC    13H'0'
CODES14  DC    X'903050B0'
         DC    14H'0'
CODES15  DC    X'900050E0'
         DC    14H'0'
CODES16  DC    X'90003010302020103090'
         DC    11H'0'
CODES17  DC    X'90005060B0402050104020303040C03030204010502040B0'
         DC    4H'0'
CODES18  DC    X'90005080'
         DC    14H'0'
CODES19  DC    X'9000502010C0'
         DC    13H'0'
CODES20  DC    X'905020604060505050403030300020104090'
         DC    7H'0'
CODES21  DC    X'A010301030302010A0303030304020B0'
         DC    8H'0'
CODES22  DC    X'90003060D0603000D0201020904050C0'
         DC    8H'0'
CODES23  DC    X'C010300010101030205030505030402030402030301030A0'
         DC    4H'0'
CODES24  DC    X'A04030E0'
         DC    14H'0'
CODES25  DC    X'90205020D04010C0'
         DC    12H'0'
CODES26  DC    X'A0402060C06040C0'
         DC    12H'0'
CODES27  DC    X'8080'
         DC    15H'0'
         END
