         TITLE 'IFG0194F                      TAPE MOUNT VERIFICATION'
IFG0194F CSECT
         ENTRY IFG0554F                 ENTRY POINT FROM EOV     Y02134
IFG0554F EQU   IFG0194F                 ALIAS ENTRY POINT        Y02134
***********************************************************************
*                                                                     *
*        VS2 RELEASE 2.0 DELETION/CHANGES                             *
*                                                                     *
*0000003373-003381,420470,420869-420879,410825                 @ZA00615
*0000356381-356431,356465-356485,356576,358452,358553           ZA00706
*0000                                                           ZA01493
*0000383100-3831100,383738-383758                              @ZA01337
*0000                                                          @ZA08328
*                                                                     *
*        VS2 RELEASE 3.0 DELETIONS/CHANGES                            *
*                                                                     *
*0000406355,408710                                             @ZA02881
*        VS2 SU32 DELETIONS                                           *
*D356496-356576                                                @G32DSMI
*                                                              @ZM04454
*                                                              @ZM04457
*                                                              @ZM04458
*                                                              @ZM04613
*        VS2 RELEASE 04 DELETIONS/CHANGES                             *
*0000                                                          @ZA06438
*0000408705                                                    @ZA08904
*0000003359-0033380                                            @ZA08253
*0000                                                          @ZA10004
*0000409070-4091150                                            @ZA11140
*0000317968,797160,317970-318141,318340,318396,318756          @ZA10245
*0000                                                          @ZA12921
*0000353924,409567,409659,409797,410050                        @ZA13577
*00005083,5695,319092                                          @ZA14560
*0000404720,404724                                             @ZA14623
*0000                                                          @ZA15064
*        VS2 RELEASE 3.7 DELETIONS/CHANGES                            *
*                                                                     *
*0000                                                          @ZA18506
*0000                                                          @ZA19728
*A318362-318372                                                @ZA20480
*A319195,319200-319208,319212,319213,353874,C319214            @ZA20457
*C410630                                                       @ZA30793
*0000                                                          @ZA32328
***********************************************************************
***********************************************************************
***********************************************************************
*                                                                     *
*                                                                     *
***********************************************************************
*                                                                     *
* MODULE NAME = IFG0194F (OS/VS2)                                     *
*                                                                     *
* DESCRIPTIVE NAME = TAPE MOUNT VERIFICATION                          *
*                                                                     *
* COPYRIGHT = NONE                                                    *
*                                                                     *
* STATUS = RELEASE 2, LEVEL 0                                         *
*                                                                     *
* FUNCTION =                                                          *
*        1. BUILD THE DXDEBMOD FIELD TO SET THE DENSITY IN WHICH      *
*        THE LABELS ARE TO BE WRITTEN AND TO INSURE COMPLETION OF THE *
*        JFCB FIELD.                                                  *
*                                                                     *
*        2. DETERMINE IF THE ASCII OPTION WAS SYSGENED WHEN THE USER  *
*        SPECIFIED ASCII PROCESSING OR 7 TRACK TAPE REQUEST. (ERROR   *
*        OUTPUTTED IF NOT).                                           *
*                                                                     *
*        3. INSURES MOUNTING OF TAPE VOLUMES BASED ON THE DISPOSITION *
*        OF THE MOUNT BIT (UCBDMCT, HIGH ORDER BIT AT OFFSET 35 IN    *
*        TAPE UCB) AND THE CONTENTS OF THE VOLUME SERIAL FIELD        *
*        (UCBVOLI, OFFSET 28 OF TAPE UCB).  IF THE MOUNT BIT IS ON,   *
*        THE VOLUME SERIAL NUMBER IS ZEROED IN THE UCB SO THAT LABEL  *
*        VERIFICATION CAN BE MADE.                                    *
*        IF THE MOUNT BIT IS OFF, A CHECK IS MADE TO DETERMINE IF     *
*        THE CORRECT VOLUME IS MOUNTED BY COMPARING VOLUME SERIAL IN  *
*        JFCB AGAINST THAT IN UCB. IF THE CORRECT VOLUME IS NOT       *
*        MOUNTED, A MOUNT MESSAGE WILL BE SET UP FOR FIRST AVAILABLE  *
*        UNIT, AND A DISMOUNT OR RETAIN MESSAGE ISSUED FOR THE DRIVE  *
*        CONTAINING THE TAPE.                                         *
*                                                                     *
*        4. VERIFY TAPE VOLUME LABEL UNLESS BLP IS SPECIFIED.  AN     *
*        ATTEMPT IS MADE TO READ A VOLUME LABEL.  IF A LABEL CONFLICT *
*        OCCURS, THE LABEL EDITOR INTERFACE MODULE IS ENTERED.  IF    *
*        A VOLUME CONFLICT OCCURS, THE VOLUME MOUNTING MODULE IS      *
*        ENTERED FOR A DISMOUNT AND REMOUNT.  FOR NL OR BLP NON-      *
*        SPECIFIC REQUESTS, A LXXXYY WILL BE GENERATED FOR THE VOLUME *
*        SERIAL NUMBER.  FILE PROTECTION IS CHECKED FOR OUTPUT,       *
*        OUTIN, INOUT, AND RACF PROTECTED DATA SETS.  IF THE TAPE     *
*        IS FILE-PROTECTED FOR OUTPUT-TYPE PROCESSING, A MESSAGE      *
*        IS ISSUED FOR THE OPERATOR TO INSERT THE FILE-PROTECT RING.  *
*                                                                     *
*        5. IF THE SYSTEM HAS RACF TAPE VOLUME PROTECTION AND THE TAPE*
*        IS FILE-PROTECTED, A RACHECK FOR READ IS ISSUED.  IF THE     *
*        TAPE IS NOT FILE PROTECTED, A RACHECK FOR UPDATE IS ISSUED.  *
*        IN THIS CASE, IF THE USER DOES NOT HAVE THE REQUIRED UPDATE  *
*        AUTHORIZATION BUT DOES HAVE READ AUTHORIZATION, MESSAGE      *
*        IEC135A IS ISSUED FOR THE OPERATOR TO REMOVE THE FILE        *
*        PROTECT RING.  IF THE VOLUME IS AN ASCII TAPE AND THE        *
*        VOLUME ACCESSABILITY BYTE IS NOT BLANK, THEN THE TAPE        *
*        AND THE VOLUME ACCESSIBILITY BYTE IS NOT BLANK, THE TAPE     *
*        CANNOT BE PROCESSED.  IF THE REQUEST WAS FOR A NON-SPECIFIC  *
*        VOLUME, THE VOLUME IS DISMOUNTED AND A REQUEST FOR A SCRATCH *
*        VOLUME IS MADE.                                              *
*                                                                     *
* NOTES = SEE  BELOW                                                  *
*                                                                     *
*    DEPENDENCIES =                                                   *
*            CLASS ONE CHARACTER CODE.  THE EBCDIC CHARACTER CODE     *
*            WAS USED FOR ASSEMBLY.  THE MODULE MUST BE REASSEMBLED   *
*            IF A DIFFERENT CHARACTER SET IS USED FOR EXECUTION.      *
*                                                                     *
*    RESTRICTIONS = NONE                                              *
*                                                                     *
*    REGISTER CONVENTIONS =                                           *
*            R2 POINTS TO DCB                                         *
*            R4 POINTS TO OPEN WORK AREA                              *
*            R5 POINTS TO THE RESIDENT ROUTINE                        *
*            R6 POINTS TO THE WTG TABLE                               *
*            R7 POINTS TO THE CURRENT PARAMETER LIST ENTRY            *
*            R8 POINTS TO THE CURRENT WTG TABLE ENTRY                 *
*            R9 POINTS TO THE DD ENTRY IN THE TIOT                    *
*            R10 POINTS TO THE UCB                                    *
*                                                                     *
*    PATCH LABEL = SEE NEXT TO LAST LABEL BEFORE ORG STATEMENT AT END *
*                  OF LISTING.                                        *
*                                                                     *
* MODULE TYPE = CONTROL (OPEN, CLOSE, EOV DATA MANAGEMENT)            *
*                                                                     *
*    PROCESSOR = ASSEMBLER XF                                         *
*                                                                     *
*    MODULE SIZE = SEE EXTERNAL SYMBOL DICTIONARY OR LOC FIELD ON     *
*                   ORG STATEMENT AT END OF LISTING                   *
*                                                                     *
*    ATTRIBUTES = REENTRANT, REFRESHABLE,READ-ONLY, ENABLED,          *
*                 PRIVILEGED, SUPERVISOR STATE, DATA MANAGEMENT KEY,  *
*                 LINK PACK AREA RESIDENT/PAGEABLE                    *
*                                                                     *
* ENTRY POINT = IFGO194F FROM OPEN                                    *
*               IFG0554F FROM END OF VOLUME                           *
*                                                                     *
*    PURPOSE = TO INSURE A SPECIFIED TAPE VOLUME IS MOUNTED AND       *
*              VERIFIED ON A SPECIFIED TAPE UNIT.                     *
*                                                                     *
*    LINKAGE = IECRES LOAD,MODID=ID4F,BRCODE=OFFSET,BRANCH=QUEUED     *
*                                                                     *
* INPUT = STANDARD OPEN/CLOSE/EOV WORKAREAS AND REGISTERS. DXVOLSR2   *
*         CONTAINS THE SERIAL NUMBER OF THE VOLUME REQUESTED.         *
*         DXUCBADR CONTAINS THE UCB ADDRESS OF THE UNIT THAT IS       *
*         TO CONTAIN THE REQUESTED VOLUME.                            *
*         DXVOLSR1 IF NOT ZERO CONTAINS THE SERIAL NUMBER OF THE      *
*         VOLUME TO BE DISMOUNTED FROM THE UNIT SPECIFIED BY          *
*         DXUCBADR BEFORE THE VOLUME SPECIFIED BY DXVOLSR2 CAN        *
*         BE ACCEPTED.                                                *
*                                                                     *
* OUTPUT = VOLUME SPECIFIED BY DXVOLSR2 IS MOUNTED AND VERIFIED       *
*          ON THE UNIT SPECIFIED BY DXUCBADR.                         *
*                                                                     *
* EXIT-NORMAL = IFG0194A LOOK AHEAD MOUNT NEXT VOLUME                 *
*               IFG0194J MESSAGE ROUTINE                              *
*               OMODVOL1 LABEL EDITOR ROUTINE                         *
*               EMODVOL1 LABEL EDITOR ROUTINE                         *
*                                                                     *
* EXIT-ERROR = IFG0190P ABEND INTERPRETATION AND RECOVERY             *
*                                                                     *
* EXTERNAL REFERENCES = AS FOLLOWS -                                  *
*                                                                     *
*    ROUTINES = IFG0194A,IFG0554A,IFG0194J,IFG0554J,IFG0193C,OMODVOL1,*
*               EMODVOL1,IFG0190P,IFG0550P.                           *
*                                                                     *
*    DATA AREAS = SEE PARAMETERS ON THE IECDSECS MACRO.               *
*                                                                     *
*    CONTROL BLOCKS = SEE PARAMETERS ON THE IECDSECS MACRO.           *
*                                                                     *
* TABLES = SEE XCTLTABL MACRO.                                        *
*          INTERNAL ABEND CODE TABLE FOR ISSUEING SEPARATE            *
*          ABENDS FROM OPEN & EOV FOR THE SAME ERRORS.                *
*                                                                     *
*                                                                     *
* MACROS = MODESET,EXCP,IECRES,DOM,XLATE,ENQ,DMABCOND,XCTLTABL,       *
*          IECDSECS,IECEQU,RACHECK.                                   *
*                                                                     *
* CHANGE ACTIVITY = SEE DELETIONS/CHANGES SECTION AFTER CSECT CARD.   *
*                                                                     *
***********************************************************************
         EJECT
         USING FORCORE,RCORE            WORK AREA
         USING WTG,RWTG                 WHERE-TO-GO              Y02080
         USING WTGENTRY,RWTGC           RWTGC POINTS TO CURRENT  Y02134
         USING TIOENTRY,RTIOT           TIOT ENTRY
         USING IHADCB,RDCB              DCB
         USING USERPRML,RPARC           RPARC POINTS TO CURRENT  Y02134
         USING UCBOB,RUCB               UCB
         BALR  RBASE,R0                 SET BASE REGISTER
         USING *,RBASE
*
* BRANCH TABLE                                                   M0034
*                                                                M0034
         B     TMV00000(RET)            GO TO PROPER FUNCTION    M0034
TMV00000 EQU   *                        BRANCH TABLE ENTRIES     M0034
         B     TMV00050                 INITIAL COMMON FUNCTION  M0034
         B     TMV02000                 MOUNT/VERIFY             M0034
         B     TMV07620                 RETURN FROM WTOR FILE PR Y02134
         B     TMV19950                 RETURN FROM ERROR DISMNT Y02134
         B     TMV02010                 ENTRY FROM LABEL EDITOR  YM5781
         B     TMV07530                 RET FROM LBL ERR MSG   @ZA02881
*                                                                M0034
TMV00050 EQU   *                        ENTRY                    M0034
*                                                                Y02134
         MVC   DXDEBUCB+K1(K3),DXUCBADR+K1 MOVE UCB TO DEB       YM1472
*                                                                YM1472
REDERROR EQU   X'01'                    REDUCED ERROR RECOVERY   YM3925
         NI    DXDEBOFL,ALLBITS-REDERROR ZERO OUT RER BIT 7      Y02134
         TM    JFCBLTYP,JFCNL           TEST FOR NL TAPES SPEC   Y02134
         BZ    TMV00500                 BRANCH IF NOT NL TAPES   Y02134
         OI    DXDEBOFL,REDERROR        SET RER BIT 7            Y02134
         EJECT
*                                                                Y02134
TMV00500 EQU   *                        NOT NL TAPES             Y02134
*                                                                Y02134
*****************************************************************Y02134
*                                                                Y02134
*        THE FOLLOWING CODE WILL BUILD THE DXDEBMOD FIELD        Y02134
*        TO SET THE DENSITY IN WHICH THE LABELS ARE TO BE        Y02134
*        WRITTEN AND TO INSURE COMPLETION OF THE JFCDEN FIELD    Y02134
*                                                                Y02134
*****************************************************************Y02134
*                                                                Y02134
         CLC   TMVEOV,WTGMODNM+K3       TEST FOR EOV             YM1472
         BNE   TMV00700                 BRANCH NOT EOV           YM1472
*                                                                YM1472
         CLI   DXDEBMOD,K0              DEN ALREADY SPECIFIED    YM1472
         BNZ   TMV01500                 BRANCH IF SPECIFIED      YM4647
         B     TMV00900                 BYPASS DCB MERGE         YM1472
*
TMV00700 EQU   *                        CHECK DCB DENSITY      @ZA08253
*                                                                YM1472
         TM    DCBMACRF,DCBMEXCP        IF ACC METH NOT EXCP     Y02134
         BZ    TMV00800                 GO TEST FOR DEN IN DCB   Y02134
*                                                                Y02134
         TM    DCBMCRF1,DEPEND          IF NO TAPE DEPEND FLDS   Y02134
         BZ    TMV00900                 GO FIND DEVICE TYPE      Y02134
*                                                                Y02134
TMV00800 EQU   *                        TEST IF DENSITY SPECIFD  Y02134
*                                                                Y02134
         CLI   DCBDEN,K0                IF NO DENSITY IN THE DCB Y02134
         BE    TMV00900                 GO FIND DEVICE TYPE      Y02134
*                                                                Y02134
         MVC   JFCDEN,DCBDEN            USE DCB DENSITY IF AVAIL Y02134
*                                                                Y02134
TMV00900 EQU   *                        DETERMINE DENSITY        YM1472
*                                                                Y02134
         CLI   JFCDEN,K0                DENSITY SPECIFIED        YM1472
         BZ    TMV01000                 BRANCH TO GET DEFAULT    YM1472
         CLI   JFCDEN,DCBD6250          CHECK FOR 6250 BPI       YM1472
         BE    TMV00910                 BRANCH IF 6250           YM1472
         CLI   JFCDEN,DCBD1600          CHECK FOR 1600 BPI       YM1472
         BE    TMV00920                 BRANCH IF 1600 BPI       YM1472
         CLI   JFCDEN,DCBD800           CHECK FOR 800 BPI        YM1472
         BE    TMV00930                 BRANCH IF 800 BPI        YM1472
*                                                                YM1472
         TM    UCBTBYT2,UCB2OPT0        TEST FOR 7-TRK           YM1472
         BO    TMV01080                 BRANCH IF 7-TRK          YM1472
         B     TMV01100                 BRANCH INVALID DENSITY   YM1472
         EJECT
*                                                                Y02134
*****************************************************************Y02134
*                                                                Y02134
*        6250 BPI SPECIFIED                                      YM1472
*                                                                Y02134
*****************************************************************Y02134
*                                                                Y02134
TMV00910 EQU   *                        6250 BPI SPECIFIED       YM1472
*                                                                YM1472
         TM    UCBTBYT1,UCBD6250        UNIT CAPABLE OF 6250     YM1472
         BO    TMV01020                 BRANCH IF 6250 OK        YM1472
         B     TMV01100                 BRANCH, INVALID DENSITY  YM1472
*                                                                Y02134
*****************************************************************Y02134
*                                                                Y02134
*        1600 BPI SPECIFIED                                      YM1472
*                                                                Y02134
*****************************************************************Y02134
*                                                                Y02134
TMV00920 EQU   *                        1600 BPI SPECIFIED       YM1472
*                                                                YM1472
         TM    UCBTBYT2,UCBDUDN1+UCBDUDN2 DUAL DENSITY           YM1472
         BNZ   TMV01040                 BRANCH IF 1600 OK        YM5369
         TM    UCBTBYT1,UCBD1600        TEST FOR 1600 BPI        YM1472
         BO    TMV01040                 BRANCH IF 1600 OK        YM1472
         B     TMV01100                 BRANCH, INVALID DENSITY  YM1472
*                                                                Y02134
*****************************************************************Y02134
*                                                                Y02134
*        800 BPI SPECIFIED                                       YM1472
*                                                                Y02134
*****************************************************************Y02134
*                                                                Y02134
TMV00930 EQU   *                        800 BPI SPECIFIED        YM1472
*                                                                YM1472
         TM    UCBTBYT2,UCB2OPT0        TEST FOR 7-TRK           YM1472
         BO    TMV01080                 BRANCH IF 7-TRK          YM1472
         TM    UCBTBYT2,UCBDUDN1        DUAL DENSITY 800/1600    YM1472
         BO    TMV01060                 BRANCH IF  800 OK        YM1472
         TM    UCBTBYT1,UCBD1600+UCBD6250 1600 OR 6250           YM1472
         BZ    TMV01060                 BRANCH IF NEITHER 800 OK YM1472
         B     TMV01100                 BRANCH, INVALID DENSITY  YM1472
         EJECT
*                                                                Y02134
*****************************************************************Y02134
*                                                                Y02134
*        DENSITY NOT SPECIFIED - GET DEFAULT DENSITY             YM1472
*                                                                Y02134
*****************************************************************Y02134
*                                                                Y02134
TMV01000 EQU   *                        GET DEFAULT DENSITY      YM1472
*                                                                YM1472
         TM    UCBTBYT2,UCB2OPT0        TEST FOR 7-TRK           YM1472
         BO    TMV01070                 BRANCH IF 7-TRK          YM1472
         TM    UCBTBYT1,UCBD6250        TEST FOR 6250 MAX        YM1472
         BO    TMV01010                 BRANCH IF 6250 OK        YM1472
         TM    UCBTBYT1,UCBD1600        TEST FOR 1600 MAX        YM1472
         BO    TMV01030                 BRANCH IF 1600 OK        YM1472
         B     TMV01050                 BRANCH ASSUME 800 MAX    YM1472
*                                                                YM1472
*****************************************************************Y02134
*                                                                Y02134
*        SET DENSITY AT 6250 BPI                                 YM1472
*                                                                Y02134
*****************************************************************Y02134
*                                                                Y02134
TMV01010 EQU   *                        6250 BPI                 YM1472
*                                                                YM1472
         MVI   JFCDEN,DCBD6250          SET JFCB AT 6250 BPI     YM1472
*                                                                YM1472
TMV01020 EQU   *                        MODESET AT 6250 BPI      YM1472
*                                                                YM1472
         MVI   DXDEBMOD,DCBD6250        6250 MODESET DENSITY     YM6514
         B     TMV01500                 BRANCH TO CONTINUE       YM1472
*                                                                YM1472
*****************************************************************Y02134
*                                                                Y02134
*        SET DENSITY AT 1600 BPI                                 YM1472
*                                                                Y02134
*****************************************************************Y02134
*                                                                Y02134
TMV01030 EQU   *                        1600 BPI                 YM1472
*                                                                YM1472
         MVI   JFCDEN,DCBD1600          SET JFCB AT 1600 BPI     YM1472
*                                                                YM1472
TMV01040 EQU   *                        MODESET AT 1600 BPI      YM1472
*                                                                YM1472
         MVI   DXDEBMOD,DCBD1600        1600 MODESET DENSITY     YM1472
         B     TMV01500                 BRANCH TO CONTINUE       YM1472
         EJECT
*                                                                YM1472
*****************************************************************Y02134
*                                                                Y02134
*        SET DENSITY AT  800 BPI                                 YM1472
*                                                                Y02134
*****************************************************************Y02134
*                                                                Y02134
TMV01050 EQU   *                        0800 BPI                 YM1472
*                                                                YM1472
         MVI   JFCDEN,DCBD800           SET JFCB AT  800 BPI     YM1472
*                                                                YM1472
TMV01060 EQU   *                        MODESET AT  800 BPI      YM1472
*                                                                YM1472
         MVI   DXDEBMOD,DX800           0800 MODESET DENSITY     YM1472
         B     TMV01500                 BRANCH TO CONTINUE       YM1472
*                                                                YM1472
*****************************************************************Y02134
*                                                                Y02134
*        SET 7-TRK DEFAULT AT 800 BPI                            YM1472
*                                                                Y02134
*****************************************************************Y02134
*                                                                Y02134
TMV01070 EQU   *                        800 BPI - 7-TRK          YM1472
*                                                                YM1472
         MVI   JFCDEN,DCBD800           SET JFCB AT  800 BPI     YM1472
*                                                                YM1472
TMV01080 EQU   *                        MODESET AT JFCB DENSITY  YM1472
*                                                                YM1472
         MVC   DXDEBMOD,JFCDEN          GET USER SPEC DENSITY
*                                                                Y02134
         OI    DXDEBMOD,DCBTRTET        EVEN PARITY & TRANSLATOR
         B     TMV01500                 BRANCH TO CONTINUE       YM1472
*                                                                YM1472
*****************************************************************Y02134
*                                                                Y02134
*        INCOMPATIBLE DENSITY AND UNIT SPECIFIED                 YM1472
*                                                                Y02134
*****************************************************************Y02134
*                                                                Y02134
TMV01100 EQU   *                        INCOMPATIBLE DENSITY     YM1472
*                                                                YM1472
         BAL   RDEB,TMV02060            CHECK FOR DOM NEEDED   @ZA14560
         LA    R0,K1                    OPEN=413-24 EOV=NA       YM1472
         B     TMV19900                 BRANCH TO PROB DET       YM1472
*                                                                YM1472
         EJECT
*                                                                Y02134
*****************************************************************Y02134
*
*   THIS SECTION WILL TEST IF THE ASCII OPTION WAS SYSGENED WHEN
*   THE USER SPECIFIED ASCII PROCESSING, OR 7-TRACK TAPE REQUEST
*
*****************************************************************Y02134
*
TMV01500 EQU   *
         L     RC,UCBXTN                ADDRESS OF UCB EXTEN   @ZA19728
         MODESET EXTKEY=SUPR            UCB KEY                @ZA19728
         USING UCBMT,RC                                        @ZA19728
         MVC   UCBMS,JFCDEN            MOVE TAPE JFCDEN TO EXT @ZA19728
         DROP  RC                                              @ZA19728
         MODESET EXTKEY=DATAMGT         DATA MGT KEY           @ZA19728
*                                                              @ZA19728
         CLC   TMVEOV,WTGMODNM+K3       TEST FOR EOV           @ZA10004
         BE    TMV01550                 BRANCH EOV             @ZA10004
*                                                              @ZA10004
         CLC   DXVOLSR2,SCRTCH          CHECK FOR NON-SPECIFIC @ZA08253
         BNE   TMV01550                 BRANCH IF SPECIFIC REQ @ZA08253
*                                                              @ZA08253
         CLC   JFCBFLSQ,ONET            TEST IF FILE SEQ IS 1  @ZA08253
         BE    TMV01550                 BR IF EQUAL            @ZA08253
         BAL   RDEB,TMV02060            CHECK FOR DOM NEEDED   @ZA14560
         LA    R0,K12                   OPEN=413-34 EOV=NA     @ZA08253
         B     TMV19900                 BRANCH TO PROB DET     @ZA08253
*                                                              @ZA08253
TMV01550 EQU   *                                               @ZA08253
*                                                              @ZA08253
         TM    JFCBLTYP,JFCBAL          WAS AL REQUESTED         Y02134
         BO    TMV01600                 YES, GO TEST IF SYSGENED Y02134
         TM    JFCBLTYP,JFCNL           NO LABEL SPECIFIED       Y02134
         BNO   TMV02000                 NO, BRANCH               Y02134
         TM    JFCOPTCD,JFCBUL          OPT CODE Q SPECIFIED     Y02134
         BO    TMV01700                 YES, BRANCH              Y02134
         TM    DCBMACRF,DCBMEXCP        IS DCB FOR EXCP          Y02134
         BO    TMV02000                 YES, BRANCH              Y02134
         TM    DCBOPTCD,JFCBUL          OPT CODE Q IN DCB        Y02134
         BO    TMV01700                 YES, BRANCH              Y02134
         B     TMV02000                 NO, CONTINUE             Y02134
*                                                                Y02134
TMV01600 EQU   *                        TEST IF AL SYSGENED      Y02134
*                                                                Y02134
         OI    JFCOPTCD,JFCBUL          DEFAULT TO OPTCD = Q     Y02134
*                                                                Y02134
TMV01700 EQU   *                        OPT CODE Q IN DCB        Y02134
*                                                                Y02134
         L     R1,CVTPTR                LOAD ADDRESS OF CVT      Y02134
         TM    CVTOPTA-CVT(R1),CVTASCII WAS ASCII SYSGENED       YM1472
         BNZ   TMV01750                 CONTINUE               @ZA14560
         BAL   RDEB,TMV02060            CHECK FOR DOM NEEDED   @ZA14560
         LA    R0,K2                    OPEN=013-04 EOV=NA       Y02080
         LA    R1,K3                    SET ASCII CODE           Y02134
         B     TMV19910                 BRANCH TO GET ERR MSG  @ZA14560
*                                                                Y02134
TMV01750 EQU   *                                               @ZA14560
*                                                              @ZA14560
         TM    UCBTBYT2,UCB2OPT0        SEVEN TRACK TAPE         Y02134
         BNO   TMV02000                 CONTINUE               @ZA14560
         BAL   RDEB,TMV02060            CHECK FOR DOM NEEDED   @ZA14560
         LA    R0,K3                    OPEN=013-08 EOV=NA       Y02080
         LA    R1,K4                    SET ASCII CODE           Y02134
         B     TMV19910                 BRANCH TO GET ERR MSG  @ZA14560
         EJECT
*                                                                YM1472
*****************************************************************YM1472
*                                                                YM1472
*        CHECK FOR MOUNT IN PROGRESS                             YM1472
*                                                                YM1472
*****************************************************************YM1472
*                                                                YM1472
TMV02000 EQU   *                        MOUNT VERIFY ENTRY
*
         L     RET,ADRACPRT             PROTECT CHECK ROUTINE  @ZA18506
         BALR  RD,RET                   TEST FOR VALID SPECIF- @ZA18506X
                                        CATION OF PROTECT      @G32DSMI
         NI    JFCBMASK+K5,X'FF'-LBLERR2V-LBLERR-JFCDUAL RESET   YM2850
*                                       LABEL & DEN CONFLICTS    YM2850
*
         TM    UCBDMCT,UCBMOUNT         TEST MOUNT BIT
         BNO   TMV05000                 BRANCH NO MOUNT PENDING  Y02134
         B     TMV02020                 BYPASS REJECT TURN OFF   YM5781
*                                                                YM1472
TMV02010 EQU   *                        CLEAR REJECT             YM5781
*                                                                YM5781
         XC    DXVOLSR1,DXVOLSR1        CLEAR REJECT             YM1472
*                                                                YM1472
TMV02020 EQU   *                        VERIFY OUTSTANDING MOUNT YM5781
*                                                                YM1472
         NI    DXRCFLAG,0               CLEAR RACF FLAG BYTE   @G32DSMI
         MODESET EXTKEY=SUPR            UCB/TIOT KEY             Y02082
         EJECT
*****************************************************************YM7890
*                                                                YM7890
*        IF MOUNT PENDING AND UNIT NOT READY MEMORY MAY          YM7890
*        NOT BE SWAPPED OUT, BECAUSE IF OPERATOR CANCELS         YM7890
*        THE JOB, THE JOB WILL NOT TERMINATE UNTIL THE           YM7890
*        MOUNT IS SATISFIED.                                     YM7890
*                                                                YM7890
*****************************************************************YM7890
*                                                                YM7890
         TM    UCBFL1,UCBNOTRD          TEST IF READY            YM7890
         BZ    TMV02030                 BR READY- BYPASS NOSWAP@ZA10245
*                                                                YM7890
         CLC   DXVOLSR1,ZEROS           VOLUME TO REJECT?      @ZA20480
         BE    TMV02025                 NO, CONTINUE           @ZA20480
         LA    RDEB,TMV08000            SET UP TO REJ AFT DOM  @ZA20480
         B     TMV02060                 GO DOM MESSAGE FOR VOL @ZA20480
*                                       TO BE REJECTED         @ZA20480
TMV02025 EQU   *                                               @ZA20480
         SYSEVENT DONTSWAP              IN CASE OPERATOR CANCEL  YM7890
*                                                                YM7890
         SLL   R1,K24                   CLEAR HI 3 BYTES         YM7890
         LTR   R1,R1                    CHECK FOR ERROR          YM7890
         BNZ   TMV02030                 BRANCH IF ERROR        @ZA10245
*                                                                YM8511
         OI    DXATALL,DXATSWAP         SET RECOVERY INDICATOR   YM8511
*                                                                YM7890
         MVC   DXCCW1,REWIND            MOVE IN REWIND COMMAND   YM7890
         EXCP  DXIOB                    READ VOLUME LABEL        YM7890
*                                                                YM7890
         IECRES WAIT                    WAIT FOR READ TO FINISH  YM7890
*                                                                YM8511
         NI    DXATALL,ALLBITS-DXATSWAP RESET RECOVERY INDICATOR YM8511
*                                                                YM7890
         SYSEVENT OKSWAP                ALLOW SWAPOUT-UNIT READY YM7890
*                                                                YM7890
         MODESET EXTKEY=SUPR            UCB/TIOT KEY           @ZA10245
         XC    UCBVOLI,UCBVOLI          CLEAR VOL SERIAL       @ZA10245
         XC    UCBFSCT,UCBFSCT          CLEAR FILE COUNTERS    @ZA10245
         XC    UCBFSEQ,UCBFSEQ          CLEAR FILE SEQ COUNTERS@ZA10245
         NI    UCBWGT,ALLBITS-UCBREW    SET REWIND OFF         @ZA10245
         NI    UCBSTAB,ALLBITS-UCBBSTR  SET AL NOT MOUNTED     @ZA10245
         NI    UCBSTAT,ALLBITS-UCBDADI  SET SL NOT MOUNTED     @ZA10245
         NI    UCBTFL1,ALLBITS-UCBNLTP  SET NL NOT MOUNTED     @ZA10245
         NI    UCBTFL1,ALLBITS-UCBDQDSP RESET DEQ AT DISMOUNT  @ZA18506
         NI    UCBTFL1,ALLBITS-UCBNSLTP SET NSL NOT MOUNTED    @ZA10245
         MODESET EXTKEY=DATAMGT         DATA MANAGEMENT KEY    @ZA10245
         LA    RDEB,TMV02100            LOAD BRANCH ADDRESS    @ZA14560
         B     TMV02060                 BRANCH TO VERIFY LABEL   YM7890
*                                                                YM7890
TMV02030 EQU   *
*
         MODESET EXTKEY=SUPR            UCB/TIOT KEY           @ZA10245
         XC    UCBVOLI,UCBVOLI          CLEAR VOL SERIAL       @ZA10245
         XC    UCBFSCT,UCBFSCT          CLEAR FILE COUNTERS    @ZA10245
         XC    UCBFSEQ,UCBFSEQ          CLEAR FILE SEQ COUNTERS@ZA10245
         NI    UCBWGT,ALLBITS-UCBREW    SET REWIND OFF         @ZA10245
         NI    UCBSTAB,ALLBITS-UCBBSTR  SET AL NOT MOUNTED     @ZA10245
         NI    UCBSTAT,ALLBITS-UCBDADI  SET SL NOT MOUNTED     @ZA10245
         NI    UCBTFL1,ALLBITS-UCBNLTP  SET NL NOT MOUNTED     @ZA10245
         NI    UCBTFL1,ALLBITS-UCBNSLTP SET NSL NOT MOUNTED    @ZA10245
         NI    UCBTFL1,ALLBITS-UCBDQDSP RESET DEQ AT DISMOUNT  @ZA18506
         MODESET EXTKEY=DATAMGT         DATA MANAGEMENT KEY    @ZA10245
*
TMV02040 EQU   *                        READ LABEL - UNIT READY  YM7890
*                                                                Y02134
         MVC   DXCCW1,REWIND            MOVE IN REWIND COMMAND   Y02134
         EXCP  DXIOB
*                                                                Y02134
         IECRES WAIT
         LA    RDEB,TMV02100            LOAD BRANCH ADDRESS    @ZA14560
         EJECT
*                                                                YM7890
TMV02060 EQU   *                        VERIFY LABEL             YM7890
*                                                                Y02134
         MODESET EXTKEY=SUPR            UCB/TIOT KEY             Y02082
         NI    UCBDMCT,ALLBITS-UCBMOUNT RESET THE MOUNT BIT      Y02134
         MODESET EXTKEY=DATAMGT         DATA MANAGEMENT KEY      Y02082
*                                                                Y02134
         TM    UCBSTAB,UCBBNUL          TEST FOR DOM REQUIRED    Y02134
         BCR   14,RDEB                  BRANCH IF NO DOM       @ZA14560
*                                                                Y02134
         XR    R0,R0                    CLEAR REG FOR CS INST    Y02134
         LM    RET,RF,UCBFSER           LOAD DOM IDS             Y02134
         MODESET EXTKEY=SUPR            UCB/TIOT KEY             Y02082
         CS    RET,R0,UCBFSER           ZERO CONTENTS IF VALID   Y02134
         MODESET EXTKEY=DATAMGT         DATA MANAGEMENT KEY      Y02082
         BCR   7,RDEB                   BYPASS DOM IF INVALID    Y02134
*                                                                Y02134
         SRDL  RET,K8                   MOVE 2ND IDS TO RF       Y02134
         SRL   RF,K8                    RIGHT JUSTIFY 2ND IDS    Y02134
         STM   RET,RF,DXWORK1           SET UP DOM LIST          Y02134
*                                                                Y02134
         MVI   DXWORK2,LASTNTRY         SET UP FOR 2 ENTRIES     Y02134
         NC    DXWORK2+K1(K3),DXWORK2+K1 CHECK IF IDS PRESENT    Y02134
         BNZ   TMV02080                 BRANCH IF TWO IDS        Y02134
*                                                                Y02134
         MVI   DXWORK1,LASTNTRY         SET UP FOR 1 ENTRY       Y02134
         NC    DXWORK1+K1(K3),DXWORK1+K1 CHECK IF IDS PRESENT    Y02134
         BCR   8,RDEB                   BRANCH IF NO IDS         Y02134
*                                                                Y02134
TMV02080 EQU   *                        TWO IDS'S                Y02134
*                                                                Y02134
         DOM   MSGLIST=DXWORK1          DELETE MESSAGE           Y02134
         BR    RDEB                     CONTINUE               @ZA14560
         EJECT
*                                                                Y02134
TMV02100 EQU   *                        NO IDS                   Y02134
*                                                                Y02134
         MODESET EXTKEY=SUPR            UCB/TIOT KEY             Y02082
*                                                                Y02134
         XC    UCBFSER,UCBFSER          CLEAR MSG IDS            Y02134
         NI    UCBSTAB,ALLBITS-UCBBNUL  CLEAR DOM FLAG           Y02134
*                                                                Y02134
         MODESET EXTKEY=DATAMGT         DATA MANAGEMENT KEY      Y02082
*                                                                Y02134
         MVI   DXDCBDEB,K0              RESET IOS BITS         @ZA20457
         TM    DXECB,ECBNOERR           TEST FOR I/O ERROR       Y02134
         BO    TMV02300                 BRANCH IF NOT I/O ERROR  A47788
*                                                                Y02134
         TM    UCBEXTPT,UCBIVRR         TEST INTERVENTION REQ. @ZA20457
         BNO   TMV02200                 CONTINUE IF NOT        @ZA20457
         MVI   DXECB,K0                 CLEAR ECB              @ZA20457
*                                                              @ZA20457
         MODESET EXTKEY=SUPR            UCB/TIOT KEY           @ZA20457
*                                                              @ZA20457
         OI    UCBFLA,UCBNRY            SET NOT READY BIT      @ZA20457
*                                                                Y02134
         MODESET EXTKEY=DATAMGT         DATA MANAGEMENT KEY      Y02082
*                                                                Y02134
         B     TMV08000                 REJECT VOLUME          @ZA20457
*                                                              @ZA20457
TMV02200 CLI   DXECB,X40+X04            TEST FOR CHANNEL PGM   @ZA20457
*                                       INTERCEPTED              A47788
         LA    R0,K4                    OPEN=413-08 EOV=637-2C   Y02134
         BNE   TMV19900                 BRANCH ON OTHER ERROR    A47788
*                                                                Y02134
         MVC   DXCCW1,REWIND            INSURE CCW FOR REW       A47788
*                                                                Y02134
         EXCP  DXIOB                    ISSUE REW                A47788
*                                                                Y02134
         IECRES WAIT                                             Y02134
*                                                                Y02134
         TM    DXECB,ECBNOERR           TEST FOR I/O ERROR       Y02134
         LA    R0,K4                    OPEN=413-08 EOV=637-2C   Y02134
         BNO   TMV19900                 BRANCH IF I/O ERROR      A47788
         EJECT
*                                                                Y02134
TMV02300 EQU   *                        VERIFY TAPE              YM2850
*                                                                Y02134
         TM    JFCBLTYP,JFCBLP          BLP SPECIFIED            Y02134
         BO    TMV02330                 BRANCH IF BLP SPECIFIED  YM1472
*                                                                Y02134
*****************************************************************Y02134
*                                                                Y02134
*        TRY TO READ AN 80 CHARACTER LABEL                       Y02134
*                                                                Y02134
*****************************************************************Y02134
*                                                                Y02134
         XC    DXLBL,DXLBL              CLEAR LABEL AREA        SA54629
         XC    DXCCW1,DXCCW1            CLEAR CCW FOR READ      SA54629
         LA    RCORE,0(RCORE)           CLEAR HI-ORDER BYTE    @ZA12921
         ST    RCORE,DXCCW1             LABEL AREA ADDR IN CCW   Y02134
         OC    DXCCW1,READ              INITIALIZE FOR READ     SA54629
*                                                                Y02134
         EXCP  DXIOB                                             Y02134
*                                                                Y02134
         IECRES WAIT                                             Y02134
*                                                                Y02134
ERRORFLG EQU   X'3E'                    CHAN PROG/PROT/DATA/CTRL/IFCE
         TM    IOBSTAT1,ERRORFLG        TEST FOR CHAN PROG/PROT/DATA
*                                       CTRL/IFCE CHECK          Y02134
         LA    R0,K5                    OPEN=413-0C EOV=637-34   Y02080
         BNZ   TMV19900                 YES,ABEND IF ANY         Y02080
*                                                                Y02080
         TM    IOBSTAT0,IOERR           CK FOR UNIT CHECK        Y02080
         BZ    TMV02310                 BR IF NO                 Y02134
*                                                                Y02134
DATACHK  EQU   X'F7'                    DATA CHECK               YM3925
         TM    IOBSENSE,DATACHK         OTHER THAN DATA CHK      Y02134
         LA    R0,K6                    OPEN=613-0C EOV=637-34   Y02080
         BNZ   TMV19900                 YES,ABEND                Y02134
         TM    IOBSENS1,X01             NOT CAPABLE BIT SET     SA58696
         BZ    TMV02320                 BR TO ACCEPT NL TAPE    SA58696
         EJECT
*                                                                YM1472
*****************************************************************YM1472
*                                                                YM1472
*        CANNOT DETERMINE TYPE OF VOLUME MOUNTED.                YM1472
*                                                                YM1472
*****************************************************************YM1472
*                                                                YM1472
         MODESET EXTKEY=SUPR            UCB KEY                 SA58696
         OI    UCBTFL1,UCBNLTP          SET NL INDICATOR        SA58696
         MODESET EXTKEY=DATAMGT         DATA MANAGEMENT KEY     SA58696
*                                                                YM4647
         CLC   DXVOLSR1,ZEROS           CHECK FOR REJECT MTD VOL YM4647
         MVC   DXVOLSR1,ZEROS           CANNOT TELL WHATS MTD    YM2850
         BNZ   TMV08000                 BRANCH TO REJECT MTD VOL YM4647
*                                                              @G32DSMI
         L     RB,DXJSCBAD              LOAD JSCB ADDRESS      @G32DSMI
         USING IEZJSCB,RB               JSCB ADDRESSABILITY    @G32DSMI
         TM    JSCBSWT1,JSCBPASS        TEST IF RACF PROTECTION@G32DSMIX
                                        SHOULD BE BYPASSED     @G32DSMI
         BO    TMV02305                 BRANCH IF BYPASS SET   @G32DSMI
*                                                              @G32DSMI
         L     RB,CVTPTR                LOAD CVT ADDRESS       @G32DSMI
         USING CVT,RB                   CVT ADDRESSABILITY     @G32DSMI
         L     RB,CVTRAC                LOAD RACF CVT ADDRESS  @G32DSMI
         LTR   RB,RB                    RACF ACTIVE            @G32DSMI
         BZ    TMV02305                 RACF NOT ACTIVE        @G32DSMI
         USING RCVT,RB                                         @G32DSMI
         TM    RCVTSTA1,RCVTTAPE        TEST FOR TAPE VOLUME   @G32DSMIX
                                        PROTECTION OPTION      @G32DSMI
         BO    TMV08000                 BRANCH IF YES TO       @G32DSMIX
                                        REJECT THE VOLUME      @G32DSMI
         DROP  RB                                              @G32DSMI
*                                                              @G32DSMI
TMV02305 EQU   *                        NO RACF PROTECTION     @G32DSMI
*                                                              @G32DSMI
         TM    JFCBLTYP,JFCNL+JFCNSL    TEST FOR NL OR NSL      SA58696
         BNZ   TMV04100                 BRANCH TO DESTROY LABEL  YM4647
         B     TMV02390                 BR TO CREATE LABEL      SA58696
         EJECT
*                                                                YM4647
*****************************************************************YM4647
*                                                                YM4647
*        CHECK FOR SL OR AL MOUNTED                              YM4647
*                                                                YM4647
*****************************************************************YM4647
*                                                               SA54629
TMV02310 EQU   *                        NO UNIT CHECK            Y02134
*                                                                Y02134
         TM    IOBSTAT1,ERROROUT        CK FOR INCORRECT LENGTH SA54629
         BNO   TMV02315                 BRANCH TO CHECK SL       YM3161
*                                                               SA54629
         CLI   IOBCNT+K1,K0             CHECK IF RESIDUAL COUNT SA54629
         BNE   TMV02320                 LABL LESS THAN 80 BYTES SA54629
         B     TMV02317                 LABEL GREATER THAN 80   SA54629
*                                                               SA54629
TMV02315 EQU   *                        CHECK FOR SL LABEL      SA54629
*                                                               SA54629
         CLC   DXLBL(K4),VOL1           CHECK FOR STANDARD VOL1 SA54629
         BE    TMV04000                 BRANCH TO ACCEPT SL     SA54629
*                                                               SA54629
TMV02317 EQU   *                        CHECK FOR ASCII LABEL   SA54629
*                                                               SA54629
         CLC   DXLBL(K4),ANSIVOL1       ASCII VOLUME LABEL      SA54629
         BE    TMV03000                 BRANCH TO ACCEPT ASCII  SA54629
         EJECT
*                                                                Y02134
*****************************************************************Y02134
*                                                                Y02134
*        NL OR NSL TAPE MOUNTED                                  Y02134
*                                                                Y02134
*****************************************************************Y02134
*                                                                Y02134
TMV02320 EQU   *                                                 Y02134
*                                                                Y02134
         TM    JFCBLTYP,JFCNSL          TEST FOR NSL SPECIFIED   Y02134
         BO    TMV02350                 BRANCH IF NSL SPECIFIED  Y02134
*                                                                Y02134
TMV02330 EQU   *                        BLP/NL SPECIFIED         YM1472
*                                                                YM1472
         MODESET EXTKEY=SUPR            UCB/TIOT KEY             Y02082
         OI    UCBTFL1,UCBNLTP          SET NL INDICATOR         Y02134
         MODESET EXTKEY=DATAMGT         DATA MANAGEMENT KEY      Y02082
         B     TMV02360                 BRANCH AROUND NSL CODE   Y02134
*                                                                Y02134
TMV02350 EQU   *                        NSL SPECIFIED            Y02134
*                                                                Y02134
         MODESET EXTKEY=SUPR            UCB/TIOT KEY             Y02082
         OI    UCBTFL1,UCBNSLTP         SET NSL INDICATOR        Y02134
         MODESET EXTKEY=DATAMGT         DATA MANAGEMENT KEY      Y02082
         EJECT
*                                                                Y02134
TMV02360 EQU   *                        SKIPPED NSL CODE         Y02134
*                                                                Y02134
         MVI   DXECB,K0                 SET OFF I/O ERROR        YM3916
*                                                                YM4647
         CLC   DXVOLSR1,ZEROS           CHECK FOR REJECT MTD VOL YM4647
         BNZ   TMV07500                 BRANCH TO REJECT MTD VOL YM4647
*                                                                YM4647
         TM    JFCBLTYP,JFCNL+JFCNSL+JFCBLP TEST FOR NL,NSL,BLP  YM1472
         BNZ   TMV02400                 BRANCH IF NL OR NSL      Y02134
*                                                                Y02134
*****************************************************************Y02134
*                                                                Y02134
*        NL/NSL MOUNTED AND AL/SL REQUESTED                      Y02134
*                                                                Y02134
*****************************************************************Y02134
*                                                                Y02134
TMV02390 EQU   *                                                 Y02134
*                                                                Y02134
         OI    JFCBMASK+K5,LBLERR2V+JFCSLCRE SWITCH TO CREATE SL YM3840
         B     TMV07510                 BRANCH TO LABEL EDITOR   YM4611
*                                                                Y02134
*****************************************************************Y02134
*                                                                Y02134
*        NL/NSL MOUNTED AND NL/NSL REQUESTED                     Y02134
*                                                                Y02134
*****************************************************************Y02134
*                                                                Y02134
TMV02400 EQU   *                                                 Y02134
*                                                                Y02134
         MVC   DXVOLSR1,DXVOLSR2        SET UP FOR VOL VERIFY    Y02134
*                                                                Y02134
         CLC   DXVOLSR2,SCRTCH          CHECK IF NONSPECIFIC REQ Y02134
         BNE   TMV06000                 BRANCH, GET DISPOSITION  Y02134
*                                                                Y02134
         EJECT
*                                                                Y02134
         XC    DXVOLSR1,DXVOLSR1        CLEAR FOR REJECT         YM4647
*                                                                YM4647
         TM    JFCBMASK+K5,K1           TEST IF LXXXYY GENERATED Y02134
         BO    TMV02650                 BRANCH IF ALREADY GEND  SA58025
*                                                                Y02134
*****************************************************************Y02134
*                                                                Y02134
*        GENERATE LXXXYY NUMBER FOR NON-SPECIFIC NL/NSL TAPE     Y02134
*        INCREMENT DATA SET SERIAL NUMBER IN THE CVT             Y02080
*                                                                Y02080
*****************************************************************Y02134
*                                                                Y02134
TMV02500 EQU   *                                                SA58025
         L     R1,CVTPTR                LOAD ADDRESS OF CVT      Y02134
         LA    RF,K1                    SET MODIFY VALUE         Y02080
         SLL   RF,K24-(K8*((CVTSNCTR+K1-CVT)-(((CVTSNCTR+K1-CVT)/K4)*K4)
               )))                      SHIFT VALUE TO POSITION  Y02080
*                                       TO BE MODIFIED           Y02080
*                                                                Y02134
         L     R0,(((CVTSNCTR+K1-CVT)/4)*4)(R1) WORD CONTAINING  Y02134
*                                       BYTE TO BE MODIFIED      Y02134
TMV02600 EQU   *                        TRY AGAIN FOR CS         Y02080
*                                                                Y02134
         LR    RC,R0                    GET READY TO MODIFY      Y02080
         AR    RC,RF                    MODIFY IT                Y02080
*                                                                Y02134
         MODESET EXTKEY=SUPR            UCB/TIOT KEY             Y02082
*                                                                Y02134
         CS    R0,RC,(((CVTSNCTR+K1-CVT)/4)*4)(R1) UPDATE COUNT  Y02134
*                                                                Y02134
         MODESET EXTKEY=DATAMGT         DATA MANAGEMENT KEY      Y02082
*                                                                Y02134
         BNE   TMV02600                 IF NO, DO IT AGAIN       Y02080
*                                       SHIFT SERIAL NO.         Y02080
         SRL   R0,K24-(K8*((CVTSNCTR+K1-CVT)-(((CVTSNCTR+K1-CVT)/K4)*K4)
               )))                      SHIFT TO LOW 16 BITS     YM3925
         CVD   R0,DXWORK                CONVERT DATA SET NO.     Y02080
         MVI   DXVOLSR1,CHARL           MOVE L TO LABEL          Y02134
         UNPK  DXVOLSR1+K1(K3),DXWORK(K8) DATA SET NUMBER        YM3928
         MVZ   DXVOLSR1+K2(K4),DXVOLSR1+K1 SET PROPER SIGN BITS  Y02134
         B     TMV05500                 BRANCH TO ENQ ON SCRTCH  Y02134
*                                                               SA58025
TMV02650 EQU   *                        EOV PROCESSING          SA58025
*                                                                YM1472
         LA    RD,JFCBVOLS              POINTER TO VOLSERS      SA58025
         LA    RET,JFCBEXAD             PTR TO JFCB EXTENSION   SA58025
         LH    R1,DXVOLSEQ              GET VOLUME SEQ NO.      SA58025
         BCTR  R1,R0                    GET PREVIOUS VOLUME      YM3840
         LTR   R1,R1                    TEST FOR REJECT NUMBER   YM3840
         BNP   TMV02500                 BRANCH TO GEN NEW NUMBER YM3840
         CH    R1,VOL5                  IS VOLSER IN MAIN JFCB  SA58025
         BNH   TMV02690                 BR IF YES, IN MAIN      SA58025
         SH    R1,VOL5                  DECR FOR INDEXING       SA58025
*                                                                YM1472
TMV02670 EQU   *                        GET JFCB EXTENSION      SA58025
*                                                                YM1472
*        CHECK FOR EXTENSION ADDR = ZERO DONE IN 194A           SA58025
         IECRES LOCJFCB,(RET)           LOCATE JFCB EXTENSION   SA58025
         LA    RD,K4(,RET)              PTR TO VOLSERS          SA58025
         CH    R1,VOL15                 VOL SEQ < 15            SA58025
         BNH   TMV02690                 BR IF YES, IN THIS EXTN SA58025
         SH    R1,VOL15                 DECREMENT FOR INDEXING  SA58025
         B     TMV02670                 CHECK IF VOLSER IN NEXT SA58025
*                                                                YM1472
TMV02690 EQU   *                        VOL SER LOCATED         SA58025
*                                                                YM1472
         BCTR  R1,K0                    DECREMENT FOR INDEXING  SA58025
         MH    R1,VOL6                  OFFSET TO VOLSER        SA58025
         AR    RD,R1                    PTR TO VOLSERS          SA58025
         CLC   K4(K2,RD),CHAR99         DOES YY = 99            SA58025
         BE    TMV02500                 BR IF YES               SA58025
         PACK  DXWORK(K8),K4(K2,RD)     VOL SEQ TO DECIMAL       YM3928
         CVB   R1,DXWORK                LOAD BINARY VOL SEQ      YM3928
         LA    R1,K1(,R1)               INCREMENT BY ONE        SA58025
         MVC   DXVOLSR1,K0(RD)          JFCB VOL SER TO VOLSR1  SA58025
         CVD   R1,DXWORK                MAKE NUMBER DECIMAL     SA58025
         UNPK  DXVOLSR1+K4(K2),DXWORK(K8) MAKE PRINTABLE        SA58025
         OI    DXVOLSR1+K5,CHAR0        MASK OUT SIGN            YM3928
         B     TMV05500                 ENQ VOLSER               YM3840
         EJECT
*                                                                Y02134
*****************************************************************Y02134
*                                                                Y02134
*        AL TAPE MOUNTED.                                        Y02134
*                                                                Y02134
*****************************************************************Y02134
*                                                                Y02134
TMV03000 EQU   *                                                 Y02134
*                                                                Y02134
         MODESET EXTKEY=SUPR            SET KEY TO UCB KEY       Y02134
*                                                                Y02134
         OI    UCBSTAB,UCBBSTR          INDICATE AL TAPE MOUNTED Y02080
*                                                                Y02134
         MODESET EXTKEY=DATAMGT         RESET KEY TO DATA MANGMT Y02134
*                                                                Y02134
         L     R1,CVTPTR                GET CVT ADDRESS          Y02134
         TM    CVTOPTA-CVT(R1),CVTASCII ASCII SYSGENED           Y02134
         BO    TMV03100                 YES, GO CONTINUE         M0034
*                                                                Y02134
*****************************************************************Y02134
*                                                                Y02134
*        DISMOUNT VOLUME IF AL MOUNTED AND NOT REQUESTED         Y02134
*        WHEN ASCII NOT SYSGENED                                 Y02134
*                                                                Y02134
*****************************************************************Y02134
*                                                                Y02134
         LA    R1,K3                    PASS MSG MODIFIER CHAR   M0034
*                                                                Y02134
         MVC   DXRETMOD,ID4F4F          RETURN ID TO SAVE AREA   Y02134
         MVI   DXRETCOD,K4              SET RETURN INDICATOR     Y02134
*                                                                Y02134
         IECRES LOAD,MODID=ID4F4J,BRCODE=K8,BRANCH=QUEUED        Y02134
         EJECT
*                                                                Y02134
*****************************************************************Y02134
*                                                                Y02134
*        CONTINUE ASCII PROCESSING                               Y02134
*                                                                Y02134
*****************************************************************Y02134
*                                                                Y02134
TMV03100 EQU   *                                                 M0034
*                                                                Y02134
         LA    R0,K80                   LENGTH OF LABEL          Y02134
         LA    R1,DXLBL                 ADDRESS OF LABEL         Y02134
*                                                                Y02134
         XLATE (1),(0),TO=E             TRANSLATE TO EBCDIC      Y02134
*                                                                Y02134
         CLC   DXVOLSR1,VOLSERNO        SAME AS REJECT           YM4647
         BE    TMV07500                 BRANCH TO REJECT         YM4647
*                                                                YM4647
         MVC   DXVOLSR1,VOLSERNO        SETUP VOL SER FOR REJECT Y02134
*                                                                Y02134
*****************************************************************Y02134
*                                                                Y02134
*        AL TAPE MOUNTED, CHECK ACCESSABILITY.                   Y02134
*                                                                Y02134
*****************************************************************Y02134
*                                                                Y02134
         CLI   VOLSEC,BLANK             VOL ACCESSIBILITY BLANK  Y02134
         BE    TMV03200                 BRANCH TO VERIFY IF OK   YM3921
*                                                                Y02134
         TM    JFCBLTYP,JFCBAL          TEST FOR AL REQUEST      YM4647
         BNO   TMV03150                 BRANCH TO GET RIGHT VOL  YM4647
*                                                                YM4647
         CLC   DXVOLSR2,DXVOLSR1        RIGHT VOL MOUNTED        M0034
         LA    R0,K8                    OPEN=913-04 EOV=937-20   YM1238
         LA    R1,K1                    LOAD ASCII DISMOUNT CODE Y02134
         BE    TMV19910                 BRANCH IF RIGHT VOLUME   Y02134
*                                                                Y02134
TMV03150 EQU   *                        REJECT ASCII VOL         YM4647
*                                                                YM4647
         MVC   DXRETMOD,ID4F4F          RETURN ID TO SAVE AREA   Y02134
         MVI   DXRETCOD,K4              SET RETURN INDICATOR     Y02134
*                                                                Y02134
         IECRES LOAD,MODID=ID4F4J,BRCODE=K8,BRANCH=QUEUED        Y02134
         EJECT
*                                                                YM4647
*****************************************************************YM4647
*                                                                YM4647
*        AL TAPE MOUNTED, CHECK LABEL TYPE REQUESTED             YM4647
*                                                                YM4647
*****************************************************************YM4647
*                                                                YM4647
TMV03200 EQU   *                        CHECK LABEL TYPE REQST   YM4647
*                                                                YM4647
         TM    JFCBLTYP,JFCBAL          TEST FOR AL REQUEST      YM4647
         BO    TMV03500                 BRANCH IF AL REQUEST     YM4647
*                                                                YM4647
TMV03300 EQU   *                        EDIT LABEL               YM4647
*                                                                YM4647
         TM    JFCBLTYP,JFCSL           STANDARD LABEL REQUESTED YM4647
         BNO   TMV03400                 BRANCH, NL/NSL REQST     YM4647
*                                                                YM4647
*****************************************************************YM4647
*                                                                YM4647
*        AL TAPE MOUNTED AND SL TAPE REQUESTED                   YM4647
*                                                                YM4647
*****************************************************************YM4647
*                                                                YM4647
TMV03350 EQU   *                                                 YM4647
*                                                                YM4647
         OI    JFCBMASK+K5,JFCSLDES+JFCSLCRE+LBLERR2V CREATE SL  YM3840
         B     TMV07510                 BRANCH TO LABEL EDITOR   YM4611
*                                                                YM4647
*****************************************************************YM4647
*                                                                YM4647
*        AL TAPE MOUNTED AND NL/NSL REQUESTED.                   YM4647
*                                                                YM4647
*****************************************************************YM4647
*                                                                YM4647
TMV03400 EQU   *                                                 YM4647
*                                                                YM4647
         OI    JFCBMASK+K5,JFCSLDES+LBLERR2V DESTROY AL          YM3840
         B     TMV07510                 BRANCH TO LABEL EDITOR   YM4611
         EJECT
*                                                                Y02134
*****************************************************************Y02134
*                                                                Y02134
*        AL TAPE MOUNTED AND AL TAPE REQUESTED.                  Y02134
*                                                                Y02134
*****************************************************************Y02134
*                                                                Y02134
TMV03500 EQU   *                                                 Y02134
*                                                                Y02134
         CLC   DXVOLSR2,DXVOLSR1        RIGHT VOL MOUNTED        M0034
         BE    TMV06000                 BRANCH IF RIGHT VOLUME   Y02134
*                                                                Y02134
         CLC   DXVOLSR2,SCRTCH          IS THIS SCRATCH REQUEST  M0034
         BNE   TMV04060                 BRANCH TO EDIT VOLUME    Y02134
         B     TMV05500                 BRANCH TO ACCEPT SCRTCH  Y02134
         EJECT
*                                                                Y02134
*****************************************************************Y02134
*                                                                Y02134
*        SL TAPE MOUNTED.                                        Y02134
*                                                                Y02134
*****************************************************************Y02134
*                                                                Y02134
TMV04000 EQU   *                                                 Y02134
*                                                                Y02134
         MODESET EXTKEY=SUPR            SET KEY TO UCB KEY       Y02134
*                                                                Y02134
         OI    UCBSTAT,UCBDADI          INDICATE SL TAPE MOUNTED Y02080
*                                                                Y02134
         MODESET EXTKEY=DATAMGT         RESET KEY TO DATA MANGMT Y02134
*                                                                Y02134
         CLC   DXVOLSR1,VOLSERNO        SAME AS REJECT           YM4647
         BE    TMV07500                 BRANCH TO REJECT         YM4647
*                                                                YM4647
         MVC   DXVOLSR1,VOLSERNO        SAVE VOL SER FOR REJECT  Y02134
*                                                                Y02134
         TM    JFCBLTYP,JFCSL           TEST FOR SL REQUEST      Y02134
         BO    TMV04200                 BRANCH TO ACCEPT VOLUME  Y02134
*                                                                Y02134
TMV04050 EQU   *                        EDIT LABEL               Y02134
*                                                                Y02134
         TM    JFCBLTYP,JFCBAL          TEST FOR AL REQUEST      Y02134
         BNO   TMV04100                 BRANCH, NL/NSL REQST     Y02134
         EJECT
*                                                                Y02134
*****************************************************************Y02134
*                                                                Y02134
*        SL TAPE MOUNTED AND AL TAPE REQUESTED.                  Y02134
*                                                                Y02134
*****************************************************************Y02134
*                                                                Y02134
TMV04060 EQU   *                                                 Y02134
*                                                                Y02134
         OI    JFCBMASK+K5,JFCSLDES+JFCSLCRE+LBLERR2V CREATE AL  YM3840
         B     TMV07510                 BRANCH TO LABEL EDITOR   YM4611
*                                                                Y02134
*****************************************************************Y02134
*                                                                Y02134
*        SL TAPE MOUNTED AND NL/NSL TAPE REQUESTED.              Y02134
*                                                                Y02134
*****************************************************************Y02134
*                                                                Y02134
TMV04100 EQU   *                                                 Y02134
*                                                                Y02134
         OI    JFCBMASK+K5,JFCSLDES+LBLERR2V DESTROY SL          YM3840
         B     TMV07510                 BRANCH TO LABEL EDITOR   YM4611
*                                                                Y02134
*****************************************************************Y02134
*                                                                Y02134
*        SL TAPE MOUNTED AND SL TAPE REQUESTED.                  Y02134
*                                                                Y02134
*****************************************************************Y02134
*                                                                Y02134
TMV04200 EQU   *                                                 Y02134
*                                                                Y02134
         CLC   DXVOLSR2,DXVOLSR1        RIGHT VOL MOUNTED        M0034
         BE    TMV06000                 BRANCH IF RIGHT VOLUME   Y02134
*                                                                Y02134
         CLC   DXVOLSR2,SCRTCH          IS THIS SCRATCH REQUEST  M0034
         BNE   TMV03350                 BRANCH TO EDIT VOLUME    YM4647
         B     TMV05500                 BRANCH TO ACCEPT SCRTCH  Y02134
         EJECT
*                                                                Y02134
*****************************************************************Y02134
*                                                                Y02134
*        VERIFY MOUNTED VOLUME                                   Y02134
*                                                                Y02134
*****************************************************************Y02134
*                                                                Y02134
TMV05000 EQU   *                        VOL ALREADY MOUNTED      YM2850
*                                                                Y02134
         TM    UCBFL1,UCBNOTRD          TEST IF UNIT READY       YM3916
         BO    TMV08000                 BRANCH IF NOT READY      YM3916
         MVI   DXDCBDEB,K12             SET IOS BITS           @ZA20457
*                                                                YM3916
         MVC   VOLSERNO,DXVOLSR1        SAVE VOLSER FOR DEQ      YM2850
         CLC   DXVOLSR1,ZEROS           CHECK IF NO REJECT       YM2850
         BNZ   TMV05010                 BRANCH IF REJECT VOLSER  YM2850
*                                                                YM2850
         MVC   VOLSERNO,UCBVOLI         SAVE VOLSER FOR DEQ      YM2850
         CLC   UCBVOLI,ZEROS            CHECK FOR PRE-MOUNT VOL  YM2850
         BZ    TMV05020                 BYPASS DEQ, NOTHING MTD  YM5781
*                                                                YM2850
TMV05010 EQU   *                        TEST FOR SCRTCH PREMOUNT YM2850
*                                                                YM2850
         L     RF,UCBEXTPT              LOAD EXTENSION PTR       YM2850
         TM    UCBFLP1-UCBCMEXT(RF),UCBNSRCH  TEST IF NON-SCRTCH YM2850
         BO    TMV05020                 BRANCH IF NONSCRTCH VOL  YM2850
*                                                                YM2850
* NOTE: VOLUME SHOULD BE NON-SCRTCH IF VOLSER SAME AS REQUEST    YM2850
*                                                                YM2850
         CLC   DXVOLSR2,VOLSERNO        CHECK IF MTD VOL = REQ   YM2850
         BE    TMV05020                 BYPASS DEQ IF THE SAME   YM2850
*                                                                YM2850
         MODESET EXTKEY=SUPR            CHANGE TO UCB KEY        YM2850
         XC    UCBVOLI,UCBVOLI          CLEAR FOR REVERIFY       YM2850
         MODESET EXTKEY=DATAMGT         RESET TO DM KEY          YM2850
*                                                                YM2850
         LA    RC,VOLSERNO              POINT TO VOLSER        @ZA13577
         BAL   RD,TMV07850              LINK TO DEQ ROUTINE      YM5781
*                                                                YM2850
TMV05020 EQU   *                        BYPASS DEQ               YM2850
*                                                                YM2850
         CLC   DXVOLSR1,ZEROS           TEST FOR VOLUME REJECT   YM2850
         BNZ   TMV07500                 BRANCH IF REJECT REQST   YM2850
*                                                                YM2850
         CLC   UCBVOLI,ZEROS            CHECK IF NOTHING VERIFIEDYM1472
         BE    TMV02010                 BRANCH TO VERIFY         YM1472
*                                                                YM1472
         MVC   DXVOLSR1,UCBVOLI         MOVE VOL SER FOR REJECT  YM1472
*                                                                YM3855
         TM    JFCBLTYP,JFCNSL          TEST FOR NSL SPECIFIED  ZA00706
         BNZ   TMV02010                 BRANCH IF NSL           ZA00706
*                                                               ZA00706
         TM    JFCBLTYP,JFCBLP          TEST IF BLP SPECIFIED   ZA00706
         BNO   TMV05060                 BRANCH IF NOT BLP       ZA00706
         TM    UCBTFL1,UCBNLTP          TEST FOR NL MOUNTED     ZA00706
         BNO   TMV02010                 REVERIFY BLP AND NOT NL ZA00706
         B     TMV05400                 BRANCH TO VERIFY VOLSER ZA00706
*                                                               ZA00706
TMV05060 EQU   *                        CHECK FOR SL            ZA00706
*                                                               ZA00706
         TM    UCBSTAT,UCBDADI          SL TAPE MOUNTED          A39784
         BNO   TMV05100                 NO, BRANCH               A39784
         TM    JFCBLTYP,JFCSL           SL SPECIFIED             A39784
         BO    TMV05400                 BRANCH TO VERIFY VOL SER Y02134
         B     TMV04050                 BRANCH TO EDIT LABEL     Y02134
*                                                                Y02134
TMV05100 EQU   *                        NO SL TAPE MOUNTED       A39784
*                                                                Y02134
         TM    UCBSTAB,UCBBSTR          ASCII TAPE MOUNTED       A39784
         BNO   TMV05200                 NO, BRANCH               A39784
         TM    JFCBLTYP,JFCBAL          ASCII SPECIFIED          A39784
         BO    TMV05400                 BRANCH TO VERIFY VOL SER Y02134
         B     TMV03300                 BRANCH TO EDIT LABEL     YM4647
*                                                                Y02134
TMV05200 EQU   *                        NO ASCII TAPE MOUNTED    A39784
*                                                                Y02134
         TM    UCBTFL1,UCBNLTP          NL TAPE MOUNTED          A39784
         BNO   TMV02010                 GO CHECK VOLUME          YM1472
         TM    JFCBLTYP,JFCNL           NL SPECIFIED             A39784
         BO    TMV05400                 BRANCH TO VERIFY VOL SER Y02134
         B     TMV02390                 BRANCH TO EDIT LABEL     Y02134
         EJECT
*                                                                Y02134
*****************************************************************Y02134
*                                                                Y02134
*        MOUNTED VOLUME CONTAINS REQUESTED LABEL.                Y02134
*                                                                Y02134
*****************************************************************Y02134
*                                                                Y02134
TMV05400 EQU   *                                                 Y02134
*                                                                Y02134
         CLC   DXVOLSR2,DXVOLSR1        RIGHT VOL MOUNTED        M0034
         BE    TMV06000                 BRANCH IF RIGHT VOLUME   Y02134
*                                                                Y02134
         CLC   DXVOLSR2,SCRTCH          IS THIS SCRATCH REQUEST  M0034
         BE    TMV06000                 BRANCH TO ACCEPT SCRTCH  Y02134
*                                                                Y02134
TMV05450 EQU   *                        SET UP FOR LABEL EDITOR  YM1472
*                                                                YM1472
         TM    JFCBLTYP,JFCNL+JFCNSL    NL OR NSL SPECIFIED      Y02134
         BNZ   TMV04100                 BRANCH IF NL OR NSL      Y02134
         B     TMV04060                 BRANCH TO CREATE LABEL   Y02134
*                                                                Y02134
*****************************************************************Y02134
*                                                                Y02134
*        SCRATCH VOLUME MOUNTED WITH SERIAL IN DXVOLSR1          Y02134
*                                                                Y02134
*****************************************************************Y02134
*                                                                Y02134
TMV05500 EQU   *                        ENTRY FROM LABEL EDITOR  Y02134
*                                                                Y02134
         MVC   DXWORK1(K16),ENQLIST     INIT ENQ LIST            Y02134
         L     RF,DXJSCBAD              LOAD JSCB ADDRESS        Y02134
         L     R0,JSCBTCBP-IEZJSCB(,RF) INITIATOR TCB POINTER    Y02134
TMV05515 ENQ   (,DXVOLSR1),TCB=(0),RET=USE,MF=(E,DXWORK2),       YM2850X
               RELATED=(SYSZVOLS,IFG0194F(TMV07855))             YM5781
*                                                                Y02134
         LTR   RF,RF                    VOLUME ALREADY IN USE    Y02134
         BZ    TMV06000                 BRANCH IF NO ERROR       Y02134
         B     TMV08000                 BRANCH TO REJECT         Y02134
         EJECT
*                                                                Y02134
*****************************************************************Y02134
*                                                                Y02134
*        VOLUME MOUNTED ON UNIT - GET DISPOSITION                Y02134
*                                                                Y02134
*****************************************************************Y02134
*                                                                Y02134
TMV06000 EQU   *                                                 Y02134
*                                                                Y02134
         MODESET EXTKEY=SUPR            UCB/SETLOCK KEY          Y02082
*                                                                Y02134
         MVC   UCBVOLI,DXVOLSR1         VERIFIED VOL SER TO UCB  Y02134
*                                                                Y02134
         NI    UCBWGT,ALLBITS-UCBREW    CLEAR REWIND IND         YM1472
*
         TM    UCBSTAT,UCBRESV          TEST IF RESERVED        ZA01493
         BO    TMV06305                 BYPASS DISP IF RESVRVED ZA01493
*
         NI    UCBJBNR,ALLBITS-UCBMONT  SET PASS TO ZERO         Y02134
         NI    UCBSTAB,ALLBITS-UCBBPRV  SET PRIVATE TO ZERO      Y02134
         NI    UCBSTAB,ALLBITS-UCBBPUB  SET PUBLIC TO ZERO       Y02134
*                                                                Y02134
         L     RB,DXDSAB                CURRENT DSAB POINTER     Y02134
         TM    DSABFLG3-DSAB(RB),DSABPASS TEST FOR PASSED DATA   Y02134
         BNO   TMV06100                 BRANCH IF NOT PASSED     Y02134
*                                                                Y02134
         OI    UCBJBNR,UCBMONT          SET PASS INDICATOR       Y02134
*                                                                Y02134
TMV06100 EQU   *                        NOT PASSED               Y02134
*                                                                Y02134
         TM    TIOESTTA,TIOSDSP1        TEST FOR PRIVATE DATA    Y02134
         BNO   TMV06200                 BRANCH IF NOT PRIVATE    Y02134
*                                                                Y02134
         OI    UCBSTAB,UCBBPRV          SET PRIVATE INDICATOR    Y02134
*                                                                Y02134
TMV06200 EQU   *                        NOT PRIVATE              Y02134
*                                                                Y02134
         TM    TIOESTTA,TIOSDSP2        TEST FOR PUBLIC DATA     Y02134
         BNO   TMV06300                 BRANCH IF NOT PUBLIC     Y02134
*                                                                Y02134
         OI    UCBSTAB,UCBBPUB          SET PUBLIC INDICATOR     Y02134
*                                                                Y02134
TMV06300 EQU   *                        NOT PUBLIC               Y02134
*                                                                Y02134
         L     RF,UCBEXTPT              LOAD EXTENSION PTR       Y02146
         OI    UCBFLP1-UCBCMEXT(RF),UCBNSRCH SET TO NON-SCRTCH   Y02146
*
TMV06305 EQU   *                        CHECK FILE PROTECT      ZA01493
*                                                                Y02134
         MODESET EXTKEY=DATAMGT         DM KEY                   Y02082
         EJECT
*                                                                Y02134
*****************************************************************Y02134
*                                                                Y02134
*        CHECK FILE PROTECT AND DENSITY FROM SENSE INFORMATION   YM1472
*                                                                Y02134
*****************************************************************Y02134
*                                                                Y02134
         CLC   UCBFSEQ,ZEROS            CHECK FOR JUST MOUNTED   YM1472
         BNZ   TMV06310                 BRANCH IF NOT            YM1472
         CLI   UCBTBYT4,UCB3400         TEST FOR 3400 DRIVE      YM1491
         BNE   TMV06310                 NO.  CONTINUE            YM1491
         L     RF,UCBEXTPT              LOAD UCB EXTENSION PTR   Y02146
         CLI   UCBSNSCT-UCBCMEXT(RF),K24 UNIT HAVE 24 SENSE BYTS Y02146
         BNE   TMV06310                 NO.  CONTINUE             99223
*                                                                 99223
         BAL   RD,TMV07700              GET SENSE INFO           YM1472
*                                                                 99223
         L     RC,UCBXTN                ADDRESS OF UCB EXTEN      99223
         MODESET EXTKEY=SUPR            UCB KEY                   99223
         USING UCBMT,RC                                           99223
         MVC   UCBCTD,DXCCW4+K15        MOVE UNIT ID TO UCB EXT  YM1472
         DROP  RC                                                 99223
         MODESET EXTKEY=DATAMGT         DATA MGT KEY              99223
*                                                                 99223
TMV06310 EQU   *                        CONTINUE                 YM1472
*                                                                Y02134
         CLI   DXCCW1,CCWSENSE          CHECK IF SENSE DONE    @ZA01337
         BE    TMV06315                 BRANCH IF SENSE DONE   @ZA01337
*                                                              @ZA01337
         BAL   RD,TMV07700              GET SENSE INFORMATION  @ZA01337
*                                                              @ZA01337
TMV06315 EQU   *                                               @ZA01337
         TM    DXDCBLST,X02             OUTPUT, OUTIN, INOUT     YM1472
         BZ    TMV06330                 NO, GO CHK FOR RACF    @G32DSMI
*                                                                YM1472
TMV06320 EQU   *                        CONTINUE                 YM1472
*                                                                Y02134
         BAL   RD,TMV07600              CHECK FILE PROTECT       Y02134
*                                                              @G32DSMI
TMV06330 EQU   *                        TEST LABEL             @G32DSMI
         TM    UCBSTAT,UCBDADI          TEST IF SL             @G32DSMI
         BO    TMV06340                 BRANCH IF SL           @G32DSMI
         TM    UCBSTAB,UCBBSTR          TEST IF AL             @G32DSMI
         BNO   TMV06350                 BRANCH IF NOT AL       @G32DSMI
*                                                              @G32DSMI
TMV06340 EQU   *                        RACF-PROTECTED VOLUMES @G32DSMIX
                                        MUST BE SL OR AL       @G32DSMI
*                                                              @G32DSMI
         L     RB,DXJSCBAD              LOAD JSCB ADDRESS      @G32DSMI
         USING IEZJSCB,RB               JSCB ADDRESSABILITY    @G32DSMI
         TM    JSCBSWT1,JSCBPASS        TEST IF RACF PROTECTION@G32DSMIX
                                        SHOULD BE BYPASSED     @G32DSMI
         BO    TMV06350                 BRANCH IF YES          @G32DSMI
*                                                              @G32DSMI
         L     RB,CVTPTR                LOAD CVT ADDRESS       @G32DSMI
         USING CVT,RB                   CVT ADDRESSABILITY     @G32DSMI
         L     RB,CVTRAC                LOAD RACF CVT ADDRESS  @G32DSMI
         LTR   RB,RB                    RACF ACTIVE            @G32DSMI
         BZ    TMV06350                 RACF NOT ACTIVE        @G32DSMI
         USING RCVT,RB                                         @G32DSMI
         TM    RCVTSTA1,RCVTTAPE        TEST FOR TAPE VOLUME   @G32DSMIX
                                        PROTECTION OPTION      @G32DSMI
         BNO   TMV06350                 BRANCH IF NOT          @G32DSMI
         DROP  RB                                              @G32DSMI
*                                                              @G32DSMI
         TM    DXCCW4+K1,UCBPRTCT       TEST IF FILE-PROTECTED @G32DSMI
         BNO   TMV06345                 BRANCH IF NOT TO CALL  @G32DSMIX
                                        RACHECK FOR OUTPUT     @G32DSMI
*                                                              @G32DSMI
         L     RF,ADRACIN               RACHECK INPUT ROUTINE  @ZA18506
         BALR  RD,RF                    RETURN ONLY IF OK      @ZA18506
*                                                              @G32DSMI
         B     TMV06350                 BRANCH TO CONTINUE     @G32DSMI
*                                                              @G32DSMI
TMV06345 EQU   *                        GO RACHECK FOR OUTPUT  @G32DSMI
*                                                              @G32DSMI
         L     RC,ADRACOUT              RACHECK OUTPUT ROUTINE @ZA18506
         BALR  RD,RC                    RETURN ONLY IF OK      @ZA18506
*                                                              @G32DSMI
         TM    DXDCBLST,X02             OUTPUT, OUTIN, INOUT   @G32DSMI
         BO    TMV06350                 BRANCH IF YES          @G32DSMI
*                                                              @G32DSMI
         TM    DXRCFLAG,DXRCOUT+DXRCINP TEST IF VOLUME IS      @G32DSMI*
                                        NOT DEFINED TO RACF    @G32DSMI
         BZ    TMV06350                 BRANCH IF NOT DEFINED  @G32DSMI
*                                                              @G32DSMI
         TM    DXRCFLAG,DXRCOUT         TEST IF AUTHORIZED     @G32DSMIX
                                        FOR UPDATE (OUTPUT)    @G32DSMI
         BO    TMV06350                 BRANCH IF YES          @G32DSMI
*                                                              @G32DSMI
         MVC   DXRETMOD,ID4F4F          RETURN TO IFG0194F     @G32DSMI
         MVI   DXRETCOD,K4              RETURN TO OFFSET 4     @G32DSMI
*                                                              @G32DSMI
         IECRES LOAD,MODID=ID4F4J,BRCODE=K72,BRANCH=QUEUED     @G32DSMIX
                                        GO ISSUE MSG TO REMOVE @G32DSMIX
                                        THE FILE-PROTECT RING  @G32DSMI
*                                                              @G32DSMI
TMV06350 EQU   *                        SET DEBSDSSI           @G32DSMI
         L     RD,DXDEBXAD              ADDR OF DEB EXTENSION  @G32DSMI
         USING DEBXTN,RD                                       @G32DSMI
         TM    DCBOFLGS,DCBOFEOV        CONCATENATION          @G32DSMI
         BZ    TMV06360                 NO - CHECK IF OPEN     @G32DSMI
         NI    DEBXFLG1,X'FF'-DEBXDSSI  TURN OFF FLAG          @G32DSMI
         TM    DXRCFLAG,DXRCINP+DXRCOUT RACF PROTECTED VOLUME  @G32DSMI
         BZ    TMV06380                 NO LEAVE FLAG OFF      @G32DSMI
         OI    DEBXFLG1,DEBXDSSI        VOL PROT - TURN OF FLG @G32DSMI
         B     TMV06380                 SKIP OPEN CHECK        @G32DSMI
TMV06360 EQU   *                        NOT CONCATENATION      @G32DSMI
         CLC   TMVEOV,WTGMODNM+K3       EOV                    @G32DSMI
         BZ    TMV06380                 EOV - LEAVE DEBXDSSI   @G32DSMI
         TM    DXRCFLAG,DXRCINP+DXRCOUT OPEN - CHECK IF RACF   @G32DSMI
         BZ    TMV06380                 NOT RACF - CONTINUE    @G32DSMI
         OI    DEBXFLG1,DEBXDSSI        OPEN & RACF VOL SET FLG@G32DSMI
TMV06380 EQU   *                                               @G32DSMI
         DROP  RD                                              @G32DSMI
         TM    JFCBLTYP,JFCBLP          TEST IF BLP SPECIFIED    YM1472
         BO    TMV07000                 RETURN IF BLP            YM1472
         EJECT
*                                                                Y02134
*****************************************************************Y02134
*                                                                Y02134
*        VERIFY DENSITY OF VOLUME COMPATIBLE                     Y02134
*        WITH DENSITY SPECIFIED.                                 Y02134
*                                                                Y02134
*****************************************************************Y02134
*                                                                Y02134
*                                                                YM1472
         TM    UCBTBYT2,UCBDUDN1+UCBDUDN2 DUAL DENSITY           YM1472
         BZ    TMV07000                 BRANCH IF NOT DUAL DEN   YM1472
*                                                                YM1472
         TM    DXCCW4+K3,X04            VOL LABEL DEN = 1600 BPI YM1472
         BNO   TMV06400                 BRANCH IF NOT 1600 BPI   YM1472
         CLI   DXDEBMOD,DCBD1600        CHECK FOR 1600 BPI       YM1472
         BE    TMV07000                 IF YES, CONT NORM PROC   Y02134
         MVI   DXWORK,DCBD1600          SAVE JFCB DENSITY        YM1472
         MVI   DXWORK+K1,DCBD1600       SAVE MODESET DENSITY     YM1472
         B     TMV06600                 SET DENSITY CONFLICT     Y02134
*                                                                Y02134
TMV06400 EQU   *                        CHECK FOR 1600/6250 BPI  YM1472
*                                                                YM1472
         TM    UCBTBYT2,UCBDUDN2        DUAL DENSITY 1600/6250   YM1472
         BNO   TMV06500                 NO,MUST BE 800/1600 BPI  YM1472
*                                                                YM1472
*****************************************************************Y02134
*                                                                Y02134
*        LABEL DENSITY IS NOT 1600 BPI AND                       YM1472
*        CAPABILITY OF UNIT IS 1600/6250 BPI                     YM1472
*        THEREFORE THE TAPE MUST BE 6250 BPI DENSITY             YM1472
*                                                                YM1472
*****************************************************************Y02134
*                                                                Y02134
         CLI   DXDEBMOD,DCBD6250        CHECK FOR 6250 BPI       YM6514
         BE    TMV07000                 BRANCH IF 6250 BPI       YM1472
         MVI   DXWORK,DCBD6250          SAVE JFCB DENSITY        YM1472
         MVI   DXWORK+K1,DCBD6250       SAVE MODESET DENSITY     YM6514
         B     TMV06600                 SET DENSITY CONFLICT     Y02134
*                                                                Y02134
TMV06500 EQU   *                        CHECK FOR 0800/1600 BPI  YM1472
*                                                                YM1472
*****************************************************************Y02134
*                                                                YM1472
*        LABEL DENSITY IS NOT 1600 BPI AND                       YM1472
*        CAPABILITY OF UNIT IS 0800/1600 BPI                     YM1472
*        THEREFORE THE TAPE MUST BE 0800 BPI DENSITY             YM1472
*                                                                YM1472
*****************************************************************Y02134
*                                                                YM1472
         CLI   DXDEBMOD,DX800           CHECK FOR 800 BPI        YM1472
         BE    TMV07000                 BRANCH IF 800 BPI        YM1472
         MVI   DXWORK,DCBD800           SAVE JFCB DENSITY        YM1472
         MVI   DXWORK+K1,DX800          SAVE MODESET DENSITY     YM1472
*                                                                Y02134
TMV06600 EQU   *                        DENSITY CONFLICT         Y02134
         TM    DXDCBLST,DEBOPOIN        OUTPUT OR OUTIN        @ZA01337
         BNO   TMV06610                 BR IF NEITHER          @ZA01337
*                                                                Y02134
         TM    JFCBMASK+K5,JFCDUAL      PRIOR DUAL DENSITY CHK   Y02134
         BNO   TMV06700                 NO, BRANCH               Y02134
         CLC   TMVEOV,WTGMODNM+K3       CHECK FOR EOV            YM3813
         BE    TMV07000                 BRANCH IF EOV            YM3813
         CLC   JFCBFLSQ,ONET            FILE SEQ GREATER THAN 1  Y02134
         BNH   TMV07000                 NO, BRANCH               Y02134
TMV06610 EQU   *                                               @ZA01337
         MVC   JFCDEN,DXWORK            UPDATE DENSITY           YM1472
         MVC   DXDEBMOD(K1),DXWORK+K1   UPDATE MODESET FOR MSGS  YM1472
         B     TMV07000                 RETURN TO CALLER         Y02134
*                                                                Y02134
TMV06700 EQU   *                        CONTINUE DENSITY CONFLICTY02134
*                                                                Y02134
         OI    JFCBMASK+K5,JFCDUAL      SET DENSITY CONFLICT BIT Y02134
*                                                                Y02134
         BAL   RD,TMV07800              LINK TO DEQ VOL SER      YM5781
         B     TMV07550                 GO TO LABEL EDITOR       Y02134
         EJECT
*                                                              @ZA18506
************************************************************** @ZA18506
*                                                              @ZA18506
*        CHECK FOR REQUEST TO DEQ VOLUME WHEN DISMOUNTED.      @ZA18506
*        IFG0194J WILL DEQ AT IEC502E MESSAGE.                 @ZA18506
*                                                              @ZA18506
************************************************************** @ZA18506
*                                                              @ZA18506
TMV09000 EQU   *                        CHECK DEQ AT DISMOUNT  @ZA18506
*                                                              @ZA18506
         TM    JFCBFLG3,JFCDQDSP        IS DEQ AT DISMOUNT     @ZA18506*
                                        FACILITY REQUESTED     @ZA18506
         BZR   RD                       BRANCH IF NOT          @ZA18506
         CLC   TMVEOV,WTGMODNM+K3       TEST FOR EOV           @ZA18506
         BNE   TMV09100                 BRANCH IF OPEN         @ZA18506
         TM    DXDCBLST,X02             OUTPUT,INOUT,OUTIN     @ZA18506
         BZR   RD                       BRANCH IF INPUT/RDBACK @ZA18506
         TM    DCBOFLGS,DCBOFLWR        OUTPUT EOV DATASET     @ZA18506
         BZR   RD                       BRANCH IF INPUT        @ZA18506
         B     TMV09200                 TEST APF               @ZA18506
*                                                              @ZA18506
TMV09100 EQU   *                        OPEN                   @ZA18506
*                                                              @ZA18506
         TM    DXDCBLST,DEBOPOIN        OUTPUT OR OUTIN        @ZA18506
         BNOR  RD                       BRANCH IF IN/INOUT/RBK @ZA18506
*                                                              @ZA18506
TMV09200 EQU   *                        TEST APF               @ZA18506
*                                                              @ZA18506
         TESTAUTH FCTN=1                TEST APF AUTHORIZATION @ZA18506
         LTR   RF,RF                    ZERO RETURN IF APF     @ZA18506
         BNZR  RD                       BRANCH IF NOT APF AUTH @ZA18506
*                                                              @ZA18506
         MODESET EXTKEY=SUPR            UCB IN SUPERVISOR KEY  @ZA18506
         OI    UCBTFL1,UCBDQDSP         SET BIT TO CAUSE OPEN/ @ZA18506*
                                        EOV TO DEQ VOLUME WHEN @ZA18506*
                                        IT IS DISMOUNTED       @ZA18506
         MODESET EXTKEY=DATAMGT         RETURN TO DATAMGT KEY  @ZA18506
         BR    RD                       RETURN                 @ZA18506
         EJECT
*                                                                Y02134
*****************************************************************Y02134
*                                                                Y02134
*        REWIND VOLUME IF ON FIRST FILE                          Y02134
*                                                                Y02134
*****************************************************************Y02134
*                                                                Y02134
TMV07000 EQU   *                                                 Y02134
*                                                              @ZA18506
         BAL   RD,TMV09000              CHECK DEQ AT DISMOUNT  @ZA18506
*                                                                Y02134
         CLC   UCBFSEQ,ONET             CHECK IF ON FIRST FILE @ZA15064
         BH    TMV07100                 BRANCH IF NOT ON FIRST @ZA15064
*                                                                Y02134
TMV07010 EQU   *                                               @ZA08328
         TM    JFCBLTYP,JFCBLTM         TEST FOR DOS TAPE      @ZA08328
         BNO   TMV07020                 BRANCH IF NO LEADING TM  YM4658
*                                                                YM4658
         TM    DXDCBLST,DEBOPOIN        TEST FOR OUTPUT OR OUTIN YM4658
         BO    TMV07020                 BRANCH IF OUTPUT         YM4658
*                                                                YM4658
         TM    IOBSTAT0,CSWUNITX        TEST FOR TM READ         YM4658
         BO    TMV07040                 BRANCH IF LEADING TM     YM4658
*                                                                YM4658
TMV07020 EQU   *                        REWIND TAPE              YM4658
*                                                                YM4658
         MVC   DXCCW1,REWIND            INSURE CCW FOR REW       A47788
         EXCP  DXIOB                    ISSUE REW                A47788
*                                                                Y02134
         IECRES WAIT                                             Y02134
*                                                                Y02134
         TM    DXECB,ECBNOERR           TEST FOR I/O ERROR       Y02134
         LA    R0,K9                    OPEN=413-08 EOV=137-18   Y02134
         BNO   TMV19900                 BRANCH IF ERROR          Y02134
*                                                                YM1219
TMV07040 EQU   *                        INITIALIZE UCB           YM4658
*                                                                YM4658
         MODESET EXTKEY=SUPR            UCB/TIOT KEY             YM1219
*                                                                YM1472
         MVC   UCBFSER,JFCBVOLS         MOVE IN FIRST VOL        YM1472
*                                                                YM1472
         CLC   TMVEOV,WTGMODNM+K3       CHECK FOR EOV            YM1472
         BE    TMV07100                 BRANCH IF EOV            YM1472
*                                                                YM1472
         MVC   UCBFSER,UCBVOLI          OPEN VOL SER             YM1472
         EJECT
*                                                                YM1472
TMV07100 EQU   *                        SET DATA SET ON DEVICE   YM1472
*                                                                Y02134
         MODESET EXTKEY=SCHED           TIOT KEY                 YM1472
         OI    TIOESTTB,TIOSUSED                                 Y02134
         MODESET EXTKEY=DATAMGT         BACK TO KEY 5            Y02082
*                                                                YM1472
         XC    DXVOLSR1,DXVOLSR1        CLEAR VOL SER            YM1472
*                                                                YM4647
         TM    JFCBMASK+K5,LBLERR2V     TEST FOR LABEL CONFLICT  YM4647
         BNO   TMV07200                 BRANCH IF NONE           YM4647
         TM    JFCBLTYP,JFCNL+JFCNSL    TEST IF NL/NSL LBL CREAT YM4647
         BNZ   TMV07300                 BRANCH TO ISSUE ATTR MSG YM4647
*                                                                Y02134
*****************************************************************Y02134
*                                                                Y02134
*        RETURN TO IFG0194A TO LOOK AHEAD MOUNT NEXT VOLUME      Y02134
*                                                                Y02134
*****************************************************************Y02134
*                                                                Y02134
TMV07200 EQU   *                        GO TO LOOK AHEAD MOUNT   YM4647
*                                                                YM4647
         IECRES LOAD,MODID=ID4F4A,BRCODE=K12,BRANCH=QUEUED       Y02134
*                                                                YM4647
*****************************************************************YM4647
*                                                                YM4647
*        ISSUE TAPE ATTRIBUTE MESSAGE FOR NL OR NSL TAPES ONLY   YM4647
*        SL AND AL TAPES HANDLED LATER                           YM4647
*                                                                YM4647
*****************************************************************YM4647
*                                                                YM4647
TMV07300 EQU   *                        RETURN TO 4A AFTER MSG   YM4647
*                                                                YM4647
         MVC   DXRETMOD,ID4F4A          RETURN MOD NAME          YM4647
         MVI   DXRETCOD,K12             LOOK AHEAD MOUNT OFFSET  YM4647
*                                                                YM4647
         IECRES LOAD,MODID=ID4F4J,BRCODE=K48,BRANCH=QUEUED       YM4647
         EJECT
*                                                                Y02134
*****************************************************************Y02134
*                                                                Y02134
*        EXIT TO LABEL EDITOR ROUTINE                            Y02134
*                                                                Y02134
*****************************************************************Y02134
*                                                                Y02134
TMV07500 EQU   *                                                 Y02134
*                                                                YM4611
         OI    JFCBMASK+K5,LBLERR2V+JFCSLDES DESTROY LABEL       YM4611
*                                                                YM4611
         TM    JFCBLTYP,JFCSL+JFCBAL    TEST FOR STD LABELS      YM4611
         BNO   TMV07510                 BRANCH IF NOT SL/AL      YM4611
*                                                                YM4611
         OI    JFCBMASK+K5,JFCSLCRE     CREATE LABEL             YM4611
*                                                                YM4611
*****************************************************************YM4611
*                                                                YM4611
*        CHECK IF OK TO EDIT LABEL                               YM4611
*                                                                YM4611
*****************************************************************YM4611
*                                                                YM4611
TMV07510 EQU   *                        OK TO EDIT LABEL?        YM4611
*                                                                YM4611
         TM    DXDCBLST,DEBOPOIN        TEST FOR OUTPUT OR OUTIN YM4611
         BNO   TMV08000                 BRANCH TO REJECT INPUT   YM4611
*                                                                YM4611
         CLC   DXVOLSR1,ZEROS           CHECK FOR NO VOL SER     YM2850
         BZ    TMV07520                 BRANCH IF NO VOL SER     YM2850
*                                                                YM5781
         CLC   DXVOLSR1,DXVOLSR2        MTD VOL = REQ VOL        YM5781
         BE    TMV07520                 BRANCH IF SAME VOL       YM5781
*                                                                YM2850
         MVC   DXWORK1(K16),ENQLIST     INIT ENQ LIST            YM4611
         L     RF,DXJSCBAD              LOAD JSCB ADDRESS        YM4611
         L     R0,JSCBTCBP-IEZJSCB(,RF) INITIATOR TCB POINTER    YM4611
         ENQ   (,DXVOLSR1),TCB=(0),RET=TEST,MF=(E,DXWORK2),      YM4611X
               RELATED=(SYSZVOLS,IFG0194A(TMV00202))             YM4611
*                                                                YM4611
         LTR   RF,RF                    VOLUME ALREADY IN USE    YM4611
         BNZ   TMV08000                 BRANCH TO REJECT         YM4611
*                                                                Y02134
TMV07520 EQU   *                        ISSUE LBL ERR MSG      @ZA02881
         MVC   DXRETMOD,ID4F4F          RETURN MOD NAME        @ZA02881
         MVI   DXRETCOD,K20             RETURN OFFSET          @ZA02881
         IECRES LOAD,MODID=ID4F4J,BRCODE=K64,BRANCH=QUEUED     @ZA01881
TMV07530 EQU   *                        CHECK IF RING IN       @ZA02881
*                                                                YM2850
         BAL   RD,TMV07700              GET SENSE INFO           YM4647
         BAL   RD,TMV07605              CHECK FILE PROTECT       YM5950
*                                                                Y02134
TMV07550 EQU   *                        GO TO LABEL EDITOR       Y02134
*                                                                Y02134
         MVC   DXCCW1,REWIND            INSURE CCW FOR REW       A47788
         EXCP  DXIOB                    ISSUE REW                A47788
*                                                                Y02134
         IECRES WAIT                                             Y02134
*                                                                Y02134
         TM    DXECB,ECBNOERR           TEST FOR I/O ERROR       Y02134
         LA    R0,K9                    OPEN=413-08 EOV=137-18   Y02134
         BNO   TMV19900                 BRANCH IF ERROR          Y02134
*                                                                YM1219
         MVI   DXECB,K0                 ZERO I/O ERROR           YM3822
*                                                                YM3822
         MODESET EXTKEY=SUPR            UCB/TIOT KEY             Y02082
         XC    UCBFSEQ,UCBFSEQ          ZERO FILE SEQ NUMBER     Y02134
         XC    UCBFSCT,UCBFSCT          ZERO FILE SEQ COUNT      Y02134
         MODESET EXTKEY=DATAMGT         BACK TO KEY 5            Y02082
*                                                                YM1472
         IECRES SYNCHDCB                SYNCH BEFORE GOING       YM3117
*                                                                Y02134
         L     RPAR,WTGPREFX            POINT TO WTC BASE PREFIX Y02080
         L     RPAR,IECUPRML-IECPREFX(,RPAR) GET PARAMETER LIST  Y02080
         LR    RPARC,RPAR               POINT TO CURRENT ENTRY   Y02134
         LA    RWTGC,WTGENTRY-WTG(RWTG) INITIALIZE WTGENTRY PTR  YM1157
*                                                                YM3117
TMV07560 EQU   *                        LOOP, INDICATE OMOD/EMOD YM3117
*                                                                Y02134
         CLC   WTGIDTTR(K2),ID4F4F      CHECK FOR THIS MOD       YM3117
         BNE   TMV07570                 BRANCH IF NOT            YM3117
*                                                                YM3117
         MVC   WTGIDTTR,ID4F3C          MOVE LABEL EDITOR PTR    YM3117
*                                                                YM3117
TMV07570 EQU   *                        CHECK FOR LAST ENTRY     YM3117
*                                                                YM3117
         TM    DXDCBLST,LASTNTRY        CHECK FOR LAST ENTRY     YM3117
         LA    RPARC,DXDCBLST+L'DXDCBLST GET TO NEXT ENTRY       YM3117
         LA    RWTGC,WTGENTRY+L'WTGENTRY GET TO NEXT ENTRY       YM3117
         BNO   TMV07560                 LOOP IF MORE             YM3117
*                                                                YM3117
         LR    RPARC,RPAR               POINT TO FIRST ENTRY     YM3117
         LA    RWTGC,WTGENTRY-WTG(RWTG) INITIALIZE WTGENTRY PTR  YM3117
*                                                                YM3117
         MODESET EXTKEY=SUPR            KEY ZERO TO LABEL EDITOR YM1403
*                                                                Y02134
         CLC   TMVEOV,WTGMODNM+K3       TEST FOR EOV             YM1403
         BE    TMV07580                 BRANCH TO EMODVOL1       YM4611
*                                                                YM1403
         IECRES LOAD,MODNM=OMODVOL1,                             YM1403X
               PREFIX=WTGPREFX,BRANCH=DIRECT                     YM1403
*                                                                YM1403
TMV07580 EQU   *                        GO TO EMODVOL1           YM4611
*                                                                YM1403
         IECRES LOAD,MODNM=EMODVOL1,                             YM1403X
               PREFIX=WTGPREFX,BRANCH=DIRECT                     YM1403
         EJECT
*                                                                Y02134
*****************************************************************Y02134
*                                                                Y02134
*        CHECK FOR FILE PROTECT                                  Y02134
*                                                                Y02134
*****************************************************************Y02134
*                                                                Y02134
TMV07600 EQU   *                                                 Y02134
*                                                                Y02134
         XR    RC,RC                    INIT TO PERFORM DEQ      YM5950
         B     TMV07607                 BYPASS DEQ OFF           YM5950
*                                                                YM5950
TMV07605 EQU   *                        BYPASS DEQ ENTRY         YM5950
*                                                                YM5950
         LA    RC,K4                    BYPASS DEQ SWITCH        YM5950
*                                                                YM5950
TMV07607 EQU   *                        CHECK FILE PROTECT       YM5950
*                                                                YM5950
         TM    DXCCW4+K1,UCBPRTCT       FILE PROTECTED           Y02134
         BNO   TMV07630                 RETURN IF NOT            YM5950
         TM    0(RPARC),DEBOPOIN        TEST FOR OUTPUT OR OUTIN Y02134
         BNO   TMV07610                 BRANCH IF INOUT          Y02134
*                                                                Y02134
         B     TMV07608(RC)             0=DEQ 4=NOT DEQ          YM5950
TMV07608 BAL   RD,TMV07800              LINK TO DEQ VOL SER      YM5781
*                                                                YM5781
         MVC   DXRETMOD,ID4F4F          RETURN ID TO SAVE AREA   Y02134
         MVI   DXRETCOD,K4              SET RETURN INDICATOR     Y02134
*                                                                Y02134
         IECRES LOAD,MODID=ID4F4J,BRCODE=K24,BRANCH=QUEUED       Y02134
*                                                                Y02134
TMV07610 EQU   *                        INOUT                    Y02134
*                                                                Y02134
         XC    DXWORK1,DXWORK1          CLEAR REPLY AREA         Y02134
         LA    R1,DXWORK1               LOAD POINTER TO REPLY    Y02134
         LA    R0,K1                    LOAD LENGTH OF REPLY     Y02134
         SLL   R0,K24                   SHIFT TO HI BYTE         Y02134
         OR    R1,R0                    MOVE LENGTH TO REG 1     Y02134
*                                                                Y02134
         MVC   DXRETMOD,ID4F4F          RETURN ID TO SAVE AREA   Y02134
         MVI   DXRETCOD,K8              SET RETURN INDICATOR     Y02134
*                                                                Y02134
         IECRES LOAD,MODID=ID4F4J,BRCODE=K28,BRANCH=QUEUED       Y02134
*                                                                Y02134
TMV07620 EQU   *                        RETURN FROM WTOR         Y02134
*                                                                Y02134
         IECRES WAIT                    WAIT FOR REPLY           Y02134
*                                                                Y02134
         OI    DXWORK1,BLANK            FOLD REPLY               Y02134
         CLI   DXWORK1,CHARF            CHECK IF UNLOAD SPECIFD  Y02134
         BE    TMV07640(RC)             BRANCH TO DEQ & REJECT   Y02134
*                                                                Y02134
         CLI   DXWORK1,CHARU            CHECK FOR OK TO USE      Y02134
         BNE   TMV07610                 BRANCH TO ASK AGAIN      Y02134
*                                                                Y02134
TMV07630 EQU   *                        RETURN-NOT FILE PROT     YM5950
*                                                                Y02134
         BR    RD                       RETURN                   Y02134
*                                                                YM5950
TMV07640 EQU   *                        DEQ AND REJECT           YM5950
*                                                                YM5950
         BAL   RD,TMV07800              LINK TO DEQ ROUTINE      YM5950
         B     TMV08000                 BRANCH TO REJECT         YM7311
         EJECT
*                                                                Y02134
*****************************************************************Y02134
*                                                                Y02134
*        GET UNIT SENSE INFORMATION                              YM1472
*        SENSE INFORMATION BUFFER = DXCCW4 - DXCCW6              YM1472
*                                                                Y02134
*****************************************************************Y02134
*                                                                Y02134
TMV07700 EQU   *                                                 Y02134
*                                                                Y02134
         MVC   DXCCW1,NOP               WAIT FOR TAPE IN MOTION  YM4647
*                                                                YM4647
         EXCP  DXIOB                                             YM4647
*                                                                YM4647
         IECRES WAIT                                             YM4647
*                                                                YM4647
         MVI   DXDCBDEB,K0              RESET IOS BITS         @ZA32328
         TM    DXECB,ECBNOERR           CK FOR I/O ERROR         YM5781
         BO    TMV07745                 BRANCH IF NO ERROR     @ZA32328
         TM    UCBEXTPT,UCBIVRR         INTERVENTION REQUIRED? @ZA32328
         BNO   TMV07725                 NO ! BRANCH            @ZA32328
*                                                              @ZA32328
         MVI   DXECB,K0                 CLEAR ECB              @ZA32328
         MODESET EXTKEY=SUPR            UCB/TIOT KEY           @ZA32328
         OI    UCBFLA,UCBNRY            SET NOT READY BIT      @ZA32328
         MODESET EXTKEY=DATAMGT         DATAMANAGEMENT KEY     @ZA32328
         B     TMV08000                 REJECT VOLUME          @ZA32328
TMV07725 LA    R0,K11                   OPEN=413-08 EOV=637-44 @ZA32328
         B     TMV19900                 BRANCH ON OTHER ERROR  @ZA32328
*                                                                YM5781
TMV07745 XC    DXCCW1,DXCCW1            CLEAR CCW AREA         @ZA32328
         LA    R1,DXCCW4                LOAD SENSE BUFFER PTR    YM1472
         ST    R1,DXCCW1                STORE SENSE AREA IN CCW  Y02134
         OC    DXCCW1,SENSE             CMD, FLAGGS, AND LENGTH  YM1472
*                                                                Y02134
         EXCP  DXIOB                                             Y02134
*                                                                Y02134
         IECRES WAIT                                             Y02134
*                                                                Y02134
         TM    DXECB,ECBNOERR           CK FOR I/O ERROR         Y02134
         LA    R0,K11                   OPEN=413-08 EOV=637-44   Y02134
         BNO   TMV19900                 BRANCH IF ERROR          Y02134
*                                                                YM1472
         TM    JFCBLTYP,JFCBLP          TEST IF BLP SPECIFIED  @ZA06438
         BO    TMV07790                 YES, RETURN            @ZA08904
         TM    DXCCW4+K1,X08            TEST FOR LOAD POINT    @ZA02881
         BNO   TMV07790                 BRANCH IF NOT LOAD POINT YM1472
*                                                                YM1472
         MODESET EXTKEY=SUPR            UCB/TIOT KEY             Y02082
         XC    UCBFSCT,UCBFSCT          CLEAR FILE COUNTERS      Y02134
         XC    UCBFSEQ,UCBFSEQ          CLEAR FILE SEQ COUNTERS  Y02134
         MODESET EXTKEY=DATAMGT         DATA MANAGEMENT KEY      Y02082
*                                                                YM1472
*        READ AWAY FROM LOAD POINT                               YM1472
*                                                                YM1472
         MVC   DXCCW1,FSR               FSR CCW                  YM5781
         EXCP  DXIOB                                             Y02134
*                                                                Y02134
         IECRES WAIT                    WAIT FOR CHAN END        YM1472
*                                                                Y02134
         TM    DXECB,ECBNOERR           CK FOR I/O ERROR         Y02134
         LA    R0,K11                   OPEN=413-08 EOV=637-44   Y02134
         BNO   TMV19900                 BRANCH IF ERROR          Y02134
*                                                                YM5781
         MVC   DXCCW1,NOP               WAIT FOR TAPE IN MOTION  YM5781
*                                                                YM5781
         EXCP  DXIOB                                             YM5781
*                                                                YM5781
         IECRES WAIT                                             YM5781
*                                                                YM5781
         XC    DXCCW1,DXCCW1            CLEAR CCW AREA           YM1472
         LA    R1,DXCCW4                LOAD SENSE BUFFER PTR    YM1472
         ST    R1,DXCCW1                STORE SENSE AREA IN CCW  Y02134
         OC    DXCCW1,SENSE             CMD, FLAGS, AND LENGTH   YM1472
*                                                                Y02134
         EXCP  DXIOB                                             Y02134
*                                                                Y02134
         IECRES WAIT                                             Y02134
*                                                                Y02134
         TM    DXECB,ECBNOERR           CK FOR I/O ERROR         Y02134
         LA    R0,K11                   OPEN=413-08 EOV=637-44   Y02134
         BNO   TMV19900                 BRANCH IF ERROR          Y02134
*                                                                YM1472
TMV07790 EQU   *                        RETURN                   YM1472
*                                                                YM1472
         BR    RD                       RETURN                   YM1472
         EJECT
*
***********************************************************************
*
*        DEQ VOLUME SERIAL NUMBER
*
***********************************************************************
*
TMV07800 EQU   *                        FIND VOLSER TO DEQ       YM5781
*                                                                YM5781
         LA    RC,DXVOLSR1              POINT TO VOL SER       @ZA13577
         CLC   DXVOLSR1,ZEROS           CHECK IF VOL SER       @ZM04613
         BNE   TMV07810                 BRANCH TO DEQ            YM5781
*                                                                YM5781
         LA    RC,UCBVOLI               POINT TO UCB VOL SER   @ZA13577
         CLC   UCBVOLI,ZEROS            CHECK IF UCB HAS VOL SER YM5781
         BE    TMV07890                 RETURN IF NOT            YM5781
*                                                                YM5781
TMV07810 EQU   *                        CHECK FOR SCRATCH        YM5781
*                                                                YM5781
         CLC   DXVOLSR2,K0(RC)          CHECK IF SAME          @ZA13577
         BE    TMV07890                 RETURN IF SAME           YM5781
*                                                                YM5781
         CLC   DXVOLSR2,SCRTCH          CHECK FOR SCRATCH        YM5781
         BNE   TMV07890                 BRANCH IF NOT            YM5781
*                                                                YM5781
TMV07850 EQU   *                        DEQ ROUTINE              YM5781
*                                                                YM5781
         MODESET EXTKEY=SUPR            KEY OF UCB             @ZA18506
         NI    UCBTFL1,ALLBITS-UCBDQDSP RESET DEQ REQUEST      @ZA18506
         MODESET EXTKEY=DATAMGT         DATA MANAGEMENT KEY    @ZA18506
         MVC   DXWORK1(K16),DEQLIST     INIT DEQ LIST            YM5728
         L     RF,DXJSCBAD              LOAD JSCB ADDRESS        YM5781
         L     R0,JSCBTCBP-IEZJSCB(,RF) INITIATOR TCB POINTER    YM5781
TMV07855 DEQ   (,(RC)),TCB=(0),MF=(E,DXWORK2),                 @ZA13577X
               RELATED=(SYSZVOLS,IFG0194F(TMV05515))             YM5781
*                                                                YM5781
TMV07890 EQU   *                        RETURN                   YM5781
*                                                                YM5781
         BR    RD                       RETURN                   YM5781
         EJECT
*                                                                Y02134
*****************************************************************Y02134
*                                                                Y02134
*        REJECT WRONG VOLUME MOUNTED.                            Y02134
*                                                                Y02134
*****************************************************************Y02134
*                                                                Y02134
TMV08000 EQU   *                                                 Y02134
*                                                                Y02134
         MVC   DXRETMOD,ID4F4F          RETURN ID TO SAVE AREA   Y02134
         MVI   DXRETCOD,K4              SET RETURN INDICATOR     Y02134
*                                                                Y02134
         IECRES LOAD,MODID=ID4F4J,BRCODE=K4,BRANCH=QUEUED        Y02134
         EJECT
*                                                                Y02134
*****************************************************************Y02134
*                                                                Y02134
*        PROBLEM DETERMINATION INTERFACE                         Y02134
*                                                                Y02134
*****************************************************************Y02134
*                                                                Y02134
TMV19900 EQU   *                                                 Y02080
*                                                                Y02080
*****************************************************************Y02134
*                                                                Y02134
*        SET UP FOR REWIND UNLOAD AND MESSAGE                    Y02134
*                                                                Y02134
*****************************************************************Y02134
*                                                                Y02134
         XR    R1,R1                    CLEAR REG FOR DISMOUNT   Y02134
*                                                                Y02080
*****************************************************************Y02134
*                                                                Y02134
*        SET UP FOR AL REWIND UNLOAD AND MESSAGE                 Y02134
*                                                                Y02134
*****************************************************************Y02134
*                                                                Y02134
TMV19910 EQU   *                                                 Y02080
*                                                                Y02080
*****************************************************************Y02134
*                                                                Y02134
*        DETERMINE PROPER RETURN CODE FOR OPEN OR EOV            Y02134
*                                                                Y02134
*****************************************************************Y02134
*                                                                Y02134
         LA    RF,TMVERRFF              GET HIGHEST CODE NO.   @ZA00615
         CR    RF,R0                    CHECK IF CODE IS OK      Y02134
         BNL   TMV19930                 BRANCH IF OK             Y02080
         LA    R0,K0                    SET BAD CODE IN REG 0    Y02080
*                                                                Y02134
TMV19930 EQU   *                        ERROR CODE OK            Y02080
*                                                                Y02080
         LA    RF,TMVERR19              POINT TO OPEN CODES      Y02080
         CLC   TMVEOV,WTGMODNM+K3       CHECK FOR EOV CALL       Y02080
         BNE   TMV19940                 BRANCH IF OPEN           Y02080
         LA    RF,TMVERR55              POINT TO EOV  CODES      Y02080
*                                                                Y02134
TMV19940 EQU   *                        OPEN ERROR CODE          Y02080
*                                                                Y02080
         AR    RF,R0                    ADD ERROR OFFSET         Y02080
         IC    R0,K0(RF)                INSERT PROPER PD CODE    Y02080
*                                                                Y02080
*****************************************************************Y02134
*                                                                Y02134
*        DISMOUNT TAPE AND ISSUE MESSAGE                         Y02134
*                                                                Y02134
*****************************************************************Y02134
*                                                                Y02134
         MVI   DXRETCOD,K12             SET UP RETURN OFFSET     Y02080
         MVC   DXRETMOD,ID4F4F          SET UP RETURN MOD        Y02134
*                                                                Y02134
         IECRES LOAD,MODID=ID4F4J,BRCODE=K8,BRANCH=QUEUED        Y02080
*                                                                Y02134
*****************************************************************Y02134
*                                                                Y02134
*        AN ERROR HAS BEEN DETECTED                              Y02134
*        REG 0 CONTAINS PROPER PROBLEM DETERMINATION CODE        Y02134
*        THE UNIT HAS BEEN DISMOUNTED                            Y02134
*                                                                Y02080
*****************************************************************Y02134
*                                                                Y02134
TMV19950 EQU   *                        RETURN FROM ERROR DISMNT Y02080
*                                                                     *
         MVC   DXRETMOD,ID4F4A          SET UP RETURN MOD        Y02080
         LA    RET,K24                  SET UP RETURN OFFSET     Y02080
*                                                                Y02134
*        NOTE - 4A RETURN MODULE SAVED AT DXSAVMOD               Y02080
*                                                                Y02080
         DMABCOND (0),ID4F0P                                     Y02080
         EJECT
*
***********************************************************************
*
*        CONSTANTS
*
***********************************************************************
*
VOL5     DC    H'5'                     HW CONSTANT OF 5        SA58025
VOL6     DC    H'6'                     HW CONSTANT OF 6        SA58025
VOL15    DC    H'15'                    HW CONSTANT OF 15       SA58025
CHAR99   DC    CL2'99'                  CHARACTER 99 CONSTANT   SA58025
TMVEOV   DC    CL3'055'                 EOV SVC CODE IN WTG TBLE Y02134
CHARF    EQU   C'F'                     FILE PROTECT REPLY       Y02134
VOL1     DC    C'VOL1'                  STANDARD VOLUME LABEL ID
ANSIVOL1 DC    X'564F4C31'              CHARACTER 'VOL1' IN ASCII
ONET     DC    X'0001'                  CONSTANT OF 1
*
REWIND   CCW   CCWREW,K0,CCWSILI,L'DXLBL REWIND CCW             SA54629
READ     CCW   CCWRDTAP,K0,K0,L'DXLBL   READ 80 CHAR LABEL      SA54629
SENSE    CCW   CCWSENSE,K0,CCWSILI,K24  24 BYTE SENSE INFO       YM1472
NOP      CCW   CCWNOP,K0,CCWSILI,K1     NOP FOR MOTION ERRORS    YM4647
FSR      CCW   X'37',K0,CCWSILI,L'DXLBL FORWARD SPACE RECORD CCW YM5781
*                                                                Y02134
ENQLIST  DC    A(0)                     ENQ LIST                 Y02134
         ENQ   (SYSZVOLS,,E,6,SYSTEM),TCB=,RET=USE,MF=L          Y02134
DEQLIST  DS    0F                       DEQ LIST                 YM5728
         DEQ   (SYSZVOLS,,6,SYSTEM),TCB=0,MF=L                   YM5728
SYSZVOLS DC    CL8'SYSZVOLS'            ENQ ARGUMENT             Y02134
SCRTCH   DC    CL6'SCRTCH'              NON-SPECIFIC REQUEST     Y02134
BLANKS   DC    CL6' '                   BLANK VOLUME SERIAL NO.  Y02134
ZEROS    DC    XL6'00'                  ZERO VOLUME SERIAL NO.   Y02134
ADRACIN  DC    A(TMV08100)              RACHECK INPUT          @ZA18506
ADRACOUT DC    A(TMV08200)              RACHECK OUTPUT         @ZA18506
ADRACPRT DC    A(TMV08300)              RACF PROTECT CHECK     @ZA18506
         EJECT
*                                                                Y02080
TMVERR19 DC    AL1(0)                   OPEN ERROR CODES         Y02080
         DC    AL1(23)                  CODE 1 = 413-24          Y02080
         DC    AL1(17)                  CODE 2 = 013-04          Y02080
         DC    AL1(18)                  CODE 3 = 013-08          Y02080
         DC    AL1(2)                   CODE 4 = 413-08          Y02080
         DC    AL1(3)                   CODE 5 = 413-0C          Y02080
         DC    AL1(11)                  CODE 6 = 613-08        @ZA30793
         DC    AL1(2)                   CODE 7 = 413-08          Y02080
         DC    AL1(19)                  CODE 8 = 913-04          Y02134
         DC    AL1(2)                   CODE 9 = 413-08          Y02134
         DC    AL1(2)                   CODE 10 = 413-08         Y02134
         DC    AL1(2)                   CODE 11 = 413-08         Y02134
         DC    AL1(110)                 CODE 12 = 413-34       @ZA00615
         DC    AL1(141)                 CODE 13 = 913-38       @G32DSMI
         DC    AL1(0)                   CODE 14 = CANNOT OCCUR @G32DSMI
         DC    AL1(0)                   CODE 15 = CANNOT OCCUR @G32DSMI
         DC    AL1(247)                 CODE 16 = 913-48       @G32DSMI
         DC    AL1(249)                 CODE 17 = 913-50       @G32DSMI
         DC    AL1(250)                 CODE 18 = 913-54       @G32DSMI
         DC    AL1(251)                 CODE 19 = 913-58       @G32DSMI
         DC    AL1(252)                 CODE 20 = 913-5C       @G32DSMI
         DC    AL1(245)                 CODE 21 = 913-44       @G32DSMI
*                                                                Y02134
TMVERR55 DC    AL1(0)                   EOV  ERROR CODES         Y02080
         DC    AL1(0)                   CODE 1 = CANNOT OCCUR    Y02080
         DC    AL1(0)                   CODE 2 = CANNOT OCCUR    Y02080
         DC    AL1(0)                   CODE 3 = CANNOT OCCUR    Y02080
         DC    AL1(158)                 CODE 4 = 637-2C          Y02080
         DC    AL1(160)                 CODE 5 = 637-34          Y02080
         DC    AL1(160)                 CODE 6 = 637-34          Y02080
         DC    AL1(161)                 CODE 7 = 637-38          Y02080
         DC    AL1(249)                 CODE 8 = 937-20          YM1238
         DC    AL1(191)                 CODE 9 = 137-18          Y02134
         DC    AL1(155)                 CODE 10 = 637-24         Y02080
         DC    AL1(192)                 CODE 11 = 637-44         Y02080
         DC    AL1(0)                   CODE 12 = CANNOT OCCUR @ZA00615
         DC    AL1(1)                   CODE 13 = 937-28       @G32DSMI
         DC    AL1(6)                   CODE 14 = 937-3C       @G32DSMI
         DC    AL1(7)                   CODE 15 = 937-40       @G32DSMI
         DC    AL1(0)                   CODE 16 = CANNOT OCCUR @G32DSMI
         DC    AL1(0)                   CODE 17 = CANNOT OCCUR @G32DSMI
         DC    AL1(0)                   CODE 18 = CANNOT OCCUR @G32DSMI
         DC    AL1(0)                   CODE 19 = CANNOT OCCUR @G32DSMI
         DC    AL1(0)                   CODE 20 = CANNOT OCCUR @G32DSMI
         DC    AL1(0)                   CODE 21 = CANNOT OCCUR @G32DSMI
TMVERRFF EQU   TMVERR55-TMVERR19-1      HIGHEST CODE NO.       @ZA00615
         EJECT
*
         XCTLTABL ID=(ID4F4F,4F,ID4F4A,4A,ID4F4J,4J,ID4F3C,3C,   Y02134X
               ,OMODVOL1,,EMODVOL1,ID4F0P,0P),BRT=SHORT,       @ZA18506X
               LENGTH=                                         @ZA18506
         EJECT                                                 @ZA18506
***************************************************************@ZA18506
*                                                              @ZA18506
*              PAGE TWO OF MODULE                              @ZA18506
*                                                              @ZA18506
***************************************************************@ZA18506
*                                                              @ZA18506
*                                                              @G32DSMI
***************************************************************@G32DSMI
*                                                              @G32DSMI
*        ISSUE RACHECK FOR OUTPUT                              @G32DSMI
*        TWO BASE REGISTERS USED-                              @ZA18506
*              RBASE FOR FIRST PAGE OF MODULE                  @ZA18506
*              RC FOR THIS SUBROUTINE                          @ZA18506
*                                                              @G32DSMI
***************************************************************@G32DSMI
*                                                              @G32DSMI
TMV08200 EQU   *                        RACHECK FOR OUTPUT     @G32DSMI
*                                                              @G32DSMI
         USING TMV08200,RC              BASE FOR SUBROUTINE    @ZA18506
         MVC   DXCCW5(RACULNTH),RACULIST  MOVE IN PARM LIST    @G32DSMI
         LA    RB,DXCCW5                ADDRESS OF PARM LIST   @G32DSMI
         USING ACHKLIST,RB                                     @G32DSMI
*                                                              @G32DSMI
         CLC   DXVOLSR2,SCRTCH          TEST IF NON-SPECIFIC   @G32DSMIX
                                        VOLUME REQUEST         @G32DSMI
         BNE   TMV08210                 BRANCH IF SPECIFIC     @G32DSMI
         OI    ACHKFLG1,ACHKLOGF        NON-SPECIFIC LOG=NOFAIL@G32DSMI
TMV08210 EQU   *                                               @G32DSMI
         CLC   TMVEOV,WTGMODNM+K3       IS IT EOV              @G32DSMI
         BNE   TMV08220                 NO OPEN - ISSUE RACHECK@G32DSMI
         TM    DCBOFLGS,DCBOFEOV        CONCATENATION SPECIFIED@G32DSMI
         BO    TMV08220                 YES - TREAT LIKE OPEN  @G32DSMI
         TM    DXDCBLST,X02             INPUT                  @G32DSMI
         BZ    TMV08220                 YES - SKIP OLDVOL PARM @G32DSMI
         L     RF,DXDEBXAD              ADDRESS OF DEB EXTENSN @G32DSMI
         USING DEBXTN,RF                                       @G32DSMI
         TM    DEBXFLG1,DEBXDSSI        FIRST VOL RACF DEFINED @G32DSMI
         BZ    TMV08220                 NO - SKIP OLDVOL PARM  @G32DSMI
         DROP  RF                                              @G32DSMI
         LA    RF,DXOLDVOL              ADDR OF PREV VOLSER    @G32DSMI
         ST    RF,ACHKOVOL              SET IN PARM LIST       @G32DSMI
TMV08220 EQU   *                        ISSUE RACHECK          @G32DSMI
*                                                              @G32DSMI
         RACHECK ENTITY=UCBVOLI,MF=(E,DXCCW5)   ISSUE RACHECK  @G32DSMI
         LTR   RF,RF                    RC = 0 AUTHORIZED      @G32DSMI
         BNZ   TMV08250                 NOT RC=0               @G32DSMI
         CLC   TMVEOV,WTGMODNM+K3       IS IT EOV              @G32DSMI
         BNE   TMV08230                 NO - OPEN - CHECK PROT @G32DSMI
         L     RB,DXDEBXAD              ADDRESS OF DEB EXT     @G32DSMI
         USING DEBXTN,RB                                       @G32DSMI
         TM    DEBXFLG1,DEBXDSSI        FIRST VOL RACF DEFINED @G32DSMI
         BO    TMV08230                 YES - CHECK PROTECT    @G32DSMI
         DROP  RB                                              @G32DSMI
         TM    DCBOFLGS,DCBOFEOV        CONCATENATION SPECIFIED@G32DSMI
         BO    TMV08230                 YES - CHECK PROTECT    @G32DSMI
         TM    DXDCBLST,X02             CHECK OF INPUT         @G32DSMI
         BZ    TMV08230                 YES - CHECK PROTECT    @G32DSMI
*
*        THE FIRST VOLUME WAS NOT RACF DEFINED AND THIS ONE IS.
*        IT IS NOT INPUT, CONCATENATION OR OPEN.
*        THIS MEANS THERE IS AN INCONSISTENCY BETWEEN THE FIRST
*        VOLUME AND THIS ONE. SET UP TO CAUSE A 937-3C ABEND AND
*        GO CHECK IF THIS WAS A SPECIFIC REQUEST.
*
         LA    R0,K14                   SEE TMVER55            @G32DSMI
         B     TMV08290                 ABEND IF SPECIFIC REQ  @G32DSMI
TMV08230 EQU   *                        TEST IF PROTECT REQUEST@G32DSMI
         TM    JFCFLGS1,JFCBPROT        WAS PROTECT SPECIFIED  @G32DSMI
         BZ    TMV08240                 NO - AUTHORIZED RETURN @G32DSMI
         LA    R0,K21                   SET FOR 913-44         @G32DSMI
         B     TMV08290                 ABEND IF SPECIFIC REQ  @G32DSMI
TMV08240 EQU   *                        AUTHORIZED RC = 0      @G32DSMI
         OI    DXRCFLAG,DXRCOUT         SET AUTHORIZED FOR OUT @G32DSMI
         BR    RD                       RETURN TO MAIN LINE    @G32DSMI
TMV08250 EQU   *                        RC NOT EQUAL TO ZERO   @G32DSMI
         LA    RB,K12                   CHECK FOR RC = 12      @G32DSMI
         CR    RF,RB                    OLDVOL NOT IN SAME GRP @G32DSMI
         BNE   TMV08260                 RC NOT 0 OR 12         @G32DSMI
         LA    R0,K15                   SET FOR 937-40         @G32DSMI
         B     TMV08290                 ABEND IF SPECIFIC REQ  @G32DSMI
TMV08260 EQU   *                        RC NOT 0 OR 12         @G32DSMI
         LA    RB,K4                    RC FOUR                @G32DSMI
         CR    RF,RB                    RC = 4 - NOT DEFINED   @G32DSMI
         BER   RD                       YES - RETURN           @G32DSMI
*
*        IF HERE THE RETURN CODE WAS 8 - NOT AUTHORIZED
*
         TM    DXDCBLST,X02             SEE IF INPUT           @G32DSMI
         BNZ   TMV08270                 NOT INPUT              @G32DSMI
         L     RF,ADRACIN               RACHECK INPUT ROUTINE  @ZA18506
         LR    RC,RD                    SAVE RETURN ADDRESS    @G32DSMI
         DROP  RC                       RC BASE NOT NEEDED     @ZA18506
         BALR  RD,RF                    RACHECK FOR INPUT,     @ZA18506*
                                        RETURN ONLY IF OK      @ZA18506
         LR    RD,RC                    RESTORE RETURN ADDRESS @G32DSMI
         BR    RD                       RETURN TO CALLER       @G32DSMI
TMV08270 EQU   *                        NOT AUTHORIZED AND OUT @G32DSMI
         USING TMV08200,RC              RC STILL BASE          @ZA18506
         LA    R0,K13                   913-38 OR 937-28       @G32DSMI
*
*        IF THE REQUEST WAS A SPECIFIC REQUEST ABEND, OTHERWISE
*        REQUEST ANOTHER TAPE. REG 0 IS ALREADY SET UP TO GO TO
*        PROBLEM DETERMINATION IF NECESSARY.
*
TMV08290 EQU   *                                               @G32DSMI
         CLC   DXVOLSR2,SCRTCH          IS IT NON SPECIFIC     @G32DSMI
         BNE   TMV19900                 SPECIFIC REQ. ABEND    @G32DSMI
         BAL   RD,TMV07800              DEQUE VOLUME           @G32DSMI
         B     TMV08000                 REQUEST ANOTHER VOLUME @G32DSMI
         DROP  RC                                              @ZA18506
         EJECT                                                 @ZA18506
*                                                              @G32DSMI
***************************************************************@G32DSMI
*                                                              @G32DSMI
*        ISSUE RACHECK FOR INPUT                               @G32DSMI
*                                                              @G32DSMI
***************************************************************@G32DSMI
*                                                              @G32DSMI
TMV08100 EQU   *                        RACHECK FOR INPUT      @G32DSMI
         USING TMV08100,RF              BASE FOR NEXT MVC      @ZA18506
*                                                              @G32DSMI
         MVC   DXCCW5(RACRLNTH),RACRLIST  MOVE IN RACHECK LIST @G32DSMI
         DROP  RF                       BASE NOT NEEDED        @ZA18506
*                                                              @G32DSMI
         RACHECK ENTITY=UCBVOLI,MF=(E,DXCCW5)   ISSUE RACHECK  @G32DSMI
*                                                              @G32DSMI
         LA    RB,K4                    TEST IF RETURN CODE=4  @G32DSMI
         CR    RF,RB                    TEST IF VOLUME NOT     @G32DSMIX
                                        DEFINED TO RACF        @G32DSMI
         BER   RD                       NOT DEFINED RETURN     @G32DSMI
*                                                              @G32DSMI
         OI    DXRCFLAG,DXRCINP         SET AUTHORIZED FOR IN  @G32DSMI
         LTR   RF,RF                    TEST IF AUTHORIZED     @G32DSMIX
                                        FOR INPUT PROCESSING   @G32DSMI
         BZR   RD                       AUTHORIZED RETURN      @G32DSMI
         NI    DXRCFLAG,X'FF'-DXRCINP   TURN OFF FLAG          @G32DSMI
*                                                              @G32DSMI
         LA    R0,K13                   OPEN=913-38 EOV=937-28 @G32DSMI
         B     TMV19900                 BRANCH TO PROBLEM      @G32DSMIX
                                        DETERMINATION          @G32DSMI
         EJECT                                                 @ZA18506
***************************************************************@G32DSMI
*                                                              @G32DSMI
*        TEST FOR VALID PROTECT SPECIFICATION                  @G32DSMI
*        TWO BASE REGISTERS USED                               @ZA18506
*              RBASE FOR FIRST PAGE OF MODULE                  @ZA18506
*              RET FOR THIS SUBROUTINE                         @ZA18506
*                                                              @G32DSMI
***************************************************************@G32DSMI
*                                                              @G32DSMI
TMV08300 EQU   *                                               @G32DSMI
         USING TMV08300,RET                                    @ZA18506
         L     RF,DXJSCBAD              ADDRESS OF JSCB        @G32DSMI
         USING IEZJSCB,RF                                      @G32DSMI
         TM    JSCBSWT1,JSCBPASS        JSCB PASS ON           @G32DSMI
         BO    TMV08350                 YES TURN OFF PROTECT   @ZM04454
         TM    JFCFLGS1,JFCBPROT        PROTECT SPECIFIED      @G32DSMI
         BZR   RD                       NO - PROTECT RETURN    @G32DSMI
         LA    R0,K16                   SET FOR 913-48         @G32DSMI
         L     RF,CVTPTR                ADDRESS OF CVT         @G32DSMI
         USING CVT,RF                                          @G32DSMI
         L     RF,CVTRAC                ADDRESS OF RACF CVT    @G32DSMI
         LTR   RF,RF                    RACF ACTIVE            @G32DSMI
         BZ    TMV19900                 NO ABEND               @G32DSMI
         USING RCVT,RF                                         @G32DSMI
         TM    RCVTSTA1,RCVTTAPE        TAPE OPTION SET        @G32DSMI
         BZ    TMV19900                 NO ABEND               @G32DSMI
         LA    R0,K20                   SET FOR 913-5C         @G32DSMI
         TM    TIOESTTA,TIOSDSP2        PUBLIC VOLUME          @G32DSMI
         BO    TMV19900                 YES ABEND              @G32DSMI
         LA    R0,K18                   SET FOR 913-54         @G32DSMI
         TM    DXDCBLST,PLISTM0C        INOUT OR INPUT         @G32DSMI
         BZ    TMV19900                 YES ABEND              @G32DSMI
         TM    JFCBLTYP,JFCNSL          LABEL=NSL              @G32DSMI
         BOR   RD                       YES - RETURN           @G32DSMI
         LA    R0,K17                   SET FOR 913-50         @G32DSMI
         TM    JFCBLTYP,JFCBAL+JFCSL    IS LABEL = AL OR SL    @G32DSMI
         BZ    TMV19900                 NO - ABEND             @G32DSMI
         LA    R0,K19                   SET FOR 913-58         @G32DSMI
         CLC   JFCBVLSQ,ONET            CHECK IF FIRST VOLUME  @G32DSMI
         BH    TMV19900                 NOT FIRST - ABEND      @G32DSMI
         CLC   JFCBFLSQ,ONET            CHECK IF FIRST FILE    @G32DSMI
         BH    TMV19900                 NOT FIRST - ABEND      @G32DSMI
         TM    JFCBIND2,JFCOLD          DISP = MOD             @ZM04457
         BZ    TMV19900                 YES - ABEND            @ZM04457
         BR    RD                       RETURN                 @G32DSMI
TMV08350 EQU   *                        TURN OFF PROTECT       @ZM04454
         NI    JFCFLGS1,X'FF'-JFCBPROT  ZERO PROTECT FLAG      @ZM04454
         BR    RD                       RETURN                 @ZM04454
         DROP  RET                                             @ZA18506
         EJECT                                                 @ZA18506
***************************************************************@ZA18506
*                                                              @ZA18506
*              CONSTANTS                                       @ZA18506
*                                                              @ZA18506
***************************************************************@ZA18506
*                                                              @G32DSMI
RACRLIST RACHECK CLASS='TAPEVOL',ATTR=READ,MF=L                @G32DSMIX
                                        RACHECK PARAMETER LIST @G32DSMI
RACRLNTH EQU   *-RACRLIST-10            LENGTH OF RACHECK LIST @ZM04458
RACULIST RACHECK CLASS='TAPEVOL',ATTR=UPDATE,MF=L              @G32DSMIX
                                        RACHECK PARAMETER LIST @G32DSMI
RACULNTH EQU   *-RACULIST-10            LENGTH OF RACHECK LIST @ZM04458
         XCTLTABL BRT=YES,LENGTH=                              @ZA18506
         IECDSECS CVT,TCB,JSCB,DSAB,TIOT,DCB,MAIN,WTG,PREFX,UCB, Y02146X
               RACVT,IEZDEB,ICHACHKL,                          @G32DSMIX
               EXPAND=YES                                        Y02146
         IECEQU  IEZDEB=YES
         END
