         TITLE 'IFG0200Y - CLOSE ACCESS METHOD RETURN FUNCTION - DA'
IFG0200Y CSECT
         ENTRY IGG0200F,IGG0200G                                 Y02080
IGG0200F EQU   IFG0200Y                 ALLIAS ENTRY POINT       Y02080
IGG0200G EQU   IFG0200Y                 ALLIAS ENTRY POINT       Y02080
***********************************************************************
*                                                                     *
*          VS2 RELEASE 3.7 CHANGES,DELETIONS                          *
*0000                                                          @ZA14553
*0000725070-725840                                             @ZA16048
*                                                                     *
*          VS2 RELEASE 03 DELETIONS                                   *
*0000                                                          @ZA02202
*          VS2 RELEASE 02 DELETIONS                                   *
*0000                                                           ZA01327
*0000                                                          @ZA01343
*                                                                     *
*          VS1 RELEASE 1 DELETIONS/CHANGES                            *
*0000027000-034000                                               XM5598
*          VS1 RELEASE 2 DELETIONS/CHANGES                            *
*0000788000                                                      X02989
*0000788000,788200                                               XM1037
*0000297300,297700-298500                                       XA00547
*          VS2 RELEASE 01 DELETIONS
*0000                                                            YM0850
*0000303520-303540,303957-303960,303998,304020,303050-303075,    YM0993
*0000304225,304275                                               YM0993
*                                                                     *
*          RELEASE 21.7 DELETIONS/CHANGES                             *
*0000023000,033000-034000,034780-034784,057000-058000,          SA53753
*0000077000-078000,290500-290700,291000-292000,428000,          SA53753
*0000497000-560000,562000-615000,740000-743000,758000-          SA53753
*0000759000,787000-788000                                       SA53753
*          RELEASE 21 DELETIONS/CHANGES                               *
*0000587000,603000                                               M0194
*0000315000,339000,468090-468300,783000-787000                   M0171
*0000565600,613000                                               M0155
*                                                                A39245
*                                                                A39789
*                                                                A38013
*                                                                M0050
*0000478000-481000                                               M1801
*0000                                                           SA53186
*          VS2-2 DELETIONS/CHANGES                                    *
*339600-339920,342500                                           ZA01326
* MODULE NAME = IFG0200Y                                              *
*                                                                     *
* DESCRIPTIVE NAME = CLOSE ACCESS METHOD RETURN FUNCTION - DA         *
*                                                                     *
* COPYRIGHT = NONE                                                    *
*                                                                     *
* STATUS CHANGE LEVEL 000                                             *
*                                                                     *
* FUNCTION -                                                          *
*    THIS MODULE CONTAINS THE FUNCTION(S) OR PART(S) OF FUNCTION(S)-- *
*    CLOSE TAPE ACCESS METHOD EXECUTOR INTERFACE FUNCTION.            *
*    CLOSE UNIT RECORD/TELEPROCESSING FUNCTION.                       *
*    CLOSE DA ACCESS METHOD EXECUTOR INTERFACE FUNCTION.              *
*       THE ABOVE THREE FUNCTIONS STARTS IN MODULE IFG0200W.          *
*    CLOSE DA UPDATE DSCB FUNCTION.                                   *
*    REFER TO THE FOLLOWING 'FUNCTION PROLOG(S)' FOR DETAILS.         *
*    THE DEB ADDRESS WILL BE DELETED FROM THE DEB TABLE BY USE   Y02082
*    OF THE DEBCHK MACRO FOR ALL DCBS EXCEPT SPOOLED, AND        Y02082
*    SPOOLED ACBS. THIS WILL BE FOLLOWED BY A PURGE WITH THE     Y02082
*    HALT I/O AND NO POST OPTIONS FOR ALL DCBS EXCEPT SPOOLED.   Y02082
*    THE DATA MANAGEMENT COUNT WILL BE DECREMENTED FROM TAPE     YM6559
*    DEVICES WHICH ARE NOT READY.                                YM6559
*                                                                     *
* ENTRY POINTS -                                                      *
*         IFG0200Y - ENTRY POINT VIA AN XCTL FROM THE FOLLOWING--     *
*             IFG0200W   TELEPROCESSING FUNCTION, TAPE ACCESS METHOD  *
*                        EXECUTOR INTERFACE FUNCTION, AND DA ACCESS   *
*                        METHOD EXECUTOR INTERFACE FUNCTION.          *
*                                                                     *
* INPUT -                                                             *
*    ENTERED IN DATA MANAGEMENT KEY                              Y02082
*    REFER TO THE FOLLOWING 'FUNCTION PROLOG(S)'.                     *
*                                                                     *
* OUTPUT -                                                            *
*    EXIT IN DATA MANAGEMENT KEY                                 Y02082
*    REFER TO THE FOLLOWING 'FUNCTION PROLOG(S)'.                     *
*                                                                     *
* EXTERNAL REFERENCES -                                               *
*         IFG019RA - OPEN/CLOSE/EOV RESIDENT ROUTINE FOR XCTL AND     *
*                    WAIT.                                            *
*    REFER TO THE FOLLOWING 'FUNCTION PROLOG(S)'.                     *
*                                                                     *
* EXITS, NORMAL -                                                     *
*    EXIT VIA THE RESIDENT ROUTINE XCTL TO THE FOLLOWING--            *
*         IFG0200Z - PROCESS CLOSE TAPE STANDARD TRAILER LABEL        *
*                    FUNCTION.                                        *
*         IFG0202A - PROCESS CLOSE TAPE STANDARD USER LABEL FUNCTION. *
*         IFG0202B - PROCESS CLOSE TAPE NONSTANDARD LABEL FUNCTION.   *
*         IFG0202F - PROCESS CLOSE TAPE VOLUME DISPOSITION FUNCTION.  *
*         IFG0201R - PROCESS CLOSE DA WRITE DSCB FUNCTION.            *
*         IFG0202C - PROCESS CLOSE DA INPUT USER LABEL FUNCTION.      *
*         IFG0202E - PROCESS CLOSE DA EXIT FUNCTION.                  *
*         IFG0202J - PROCESS CLOSE FINAL STRING.                      *
*         IFG0202K - IF BUSY ACB                                      *
*         IFG0202L - IF VSAM ACB                                      *
*                                                                     *
* EXITS, ERROR -                                                      *
*    EXIT IS TO THE PROBLEM DETERMINATION MODULE IFG0200P, IF AN      *
*    ABEND SITUATION OCCURS IN THIS MODULE.  REFER TO THE FOLLOWING   *
*    'FUNCTION PROLOG(S)'.                                            *
*                                                                     *
* TABLES/WORK AREAS -                                                 *
*    REFER TO THE FOLLOWING 'FUNCTION PROLOG(S)'.                     *
*                                                                     *
* ATTRIBUTES -                                                        *
*    REENTRANT, REFRESHABLE, READ-ONLY, ENABLED, PRIVILEGED           *
*                                                                     *
* CHARACTER CODE DEPENDENCY -                                         *
*    CLASS ONE CHARACTER CODE DEPENDENCY - THE EBCDIC CHARACTER CODE  *
*    WAS USED FOR ASSEMBLY.  THE MODULE MUST BE REASSEMBLED IF A      *
*    DIFFERENT CHARACTER SET IS USED FOR EXECUTION.                   *
*                                                                     *
* NOTES -                                                             *
*    THIS MODULE ALSO HAS A NAME ALIAS OF IGG0200G FOR THE ACCESS     *
*    METHOD EXECUTORS TO RETURN TO.                                   *
*    REFER TO THE FOLLOWING 'FUNCTION PROLOG(S)'.                     *
*                                                                     *
***********************************************************************
         EJECT
         USING IHADCB,RDCB
         USING FORCORE,RCORE
         USING TCB,RET
         USING UCBOB,RUCB
         USING CVT,RD
         USING TIOENTRY,RTIOT
         USING DEB,RDEB
         USING WTG,RWTG
         USING WTGENTRY,RWTGC
         BALR  RBASE,0                  ESTABLISH BASE REGISTER
         USING *,RBASE
         EJECT
*                                                                     *
*                          FUNCTION PROLOG                            *
*                                                                     *
***********************************************************************
*                                                                     *
* FUNCTION NAME -                                                     *
*    CLOSE  ACCESS METHOD EXECUTOR INTERFACE FUNCTION.                *
*                                                                     *
* (STATUS) -                                                          *
*    NOT APPLICABLE                                                   *
*                                                                     *
* FUNCTION -                                                          *
*    DETERMINE WHICH FUNCTIONS IT NEEDS TO PERFORM AFTER RETURN FROM  *
*    THE EXECUTORS.                                                   *
*                                                                     *
* ENTRY POINTS -                                                      *
*    ENTERED FROM THE FOLLOWING--                                     *
*    CLOSE INITIALIZATION FUNCTION.                                   *
*    CLOSE DA READ DSCB FUNCTION.                                     *
*                                                                     *
* INPUT -                                                             *
*    A POINTER TO EACH OF THE FOLLOWING--                             *
*       CURRENT PARAMETER LIST ENTRY- RPARC                           *
*       DD ENTRY IN THE TIOT- RTIOT                                   *
*       WTG TABLE- RWTG                                               *
*       CURRENT WTG TABLE ENTRY- RWTGC                                *
*       DCB- RDCB                                                     *
*       WORK AREA- RCORE                                              *
*       RESIDENT ROUTINE- RES                                         *
*       UCB- RUCB                                                     *
*       DEB- RDEB                                                     *
*                                                                     *
* OUTPUT -                                                            *
*    ALL PENDING CHANNEL PROGRAMS ARE HANDLED AND MAIN STORAGE USED   *
*    BY THE IOBS, ICBS AND CHANNEL PROGRAMS ARE RELEASED.             *
*                                                                     *
* EXTERNAL REFERENCES -                                               *
*    REFER TO THE PRECEEDING MODULE PROLOG.                           *
*                                                                     *
* EXITS, NORMAL -                                                     *
*    REFER TO THE PRECEEDING MODULE PROLOG.                           *
*                                                                     *
* EXITS, ERROR -                                                      *
*    REFER TO THE PRECEEDING MODULE PROLOG.                           *
*                                                                     *
* TABLES/WORK AREAS -                                                 *
*    THE OPEN, CLOSE, OR EOV WORK AREA AND THE WHERE-TO-GO (WTG)      *
*    TABLE ARE DESCRIBED BY THE DSECTS AT THE END OF THE LISTING.     *
*                                                                     *
* ATTRIBUTES -                                                        *
*    REFER TO THE PRECEEDING MODULE PROLOG.                           *
*                                                                     *
* CHARACTER CODE DEPENDENCY -                                         *
*    REFER TO THE PRECEEDING MODULE PROLOG.                           *
*                                                                     *
* NOTES -                                                             *
*    NOT APPLICABLE                                                   *
*                                                                     *
***********************************************************************
         EJECT
*
*        PROCEED WITH CLOSE PROCESSING
*
         L     RF,WTGPREFX              GET PTR TO WTG PREFIX    Y02144
         L     RF,IECRRPRM-IECPREFX(,RF) GET RRPLIST PTR         Y02144
         USING RRPLIST,RF                                        Y02144
         OI    RRFLAGS1,RRFAMEXR        SHOW BACH FROM A.M. EXEC Y02144
         IECRES LOAD,PREFIX=WTGPREFX,MODNM=THISMOD,BRANCH=NO     Y02080X
                                        GIVE OPT TRACE A SHOT    Y02080
         XC    WTGMODEP,WTGMODEP        CLEAR NEXT MOD ADDR      Y02080
         LR    RPARC,RPAR               INITIALIZE PARM LIST
         LA    RWTGC,WTGENTRY-WTG(,RWTG)  INITIALIZE WTG TABLE
CIN06100 EQU   *
         L     RDCB,PLISTDCB(RPARC)     GET DCB ADDR
         L     RCORE,WTGCORE-1          GET WORK AREA ADDR
         LA    RCORE,0(RCORE)           CLEAR HIGH ORDER BYTE
         LTR   RCORE,RCORE              W.A. ADDR PRESENT
         BZ    CIN06500                 BRANCH NO TO GET NEXT ENTRY
         BAL   RF,CIN08800              SET UP TASK PARAMETERS   YM6572
         TM    DCBOFLGS,DCBOBUSY        STILL PROCESSING         YM6572
         BZ    CIN06140                 BRANCH IS NO             YM6572
*                                                                Y02082
* UPDATE WORKAREA COPY OF USER'S DCB - BUSY BIT MERGED           YM7883
*                                                                Y02082
         IECRES INIT,DCBCOPY=TOWKAR,STM=(2,14,WTGPREFX)          Y02082
         L     RDCB,DXUDCBAD            GET PTR TO USER'S DCB    Y02082
         MODESET KEYADDR=DXUKEY,WORKREG=1 ASSUME USER'S KEY      Y02082
         ICM   R1,B'1111',DCBOFLGS      GET USER'S DCBOFLGS WORD YM3923
         IC    R0,DCBIFLGS              GET USER'S ERROR FLSGS   YM3136
         MODESET EXTKEY=DATAMGT         RESUME DATA MGT KEY      Y02082
         L     RDCB,DXPDCBAD            POINT TO COPIED DCB      Y02082
         STC   R0,DCBIFLGS              SET ERROR FLAGS IN COPY  YM3136
         STCM  R1,B'0111',DCBOFLGS+K1   STORE LAST 3 BYTES       YM3923
         SRL   R1,K24(0)                SHIFT DCBOFLGS TO LOW    YM3923
*                                       ORDER BYTE               YM3923
***********************************************************************
         LA    R0,DCBOFLRB+DCBOFLWR+DCBOFTM SET MASK FOR READ BKWD,    *
                         LAST OPERATION WRITE, TAPE MARK WRITTEN YM3136
***********************************************************************
         NR    R1,R0                    SELECT INDICATED BITS    Y02082
         NI    DCBOFLGS,X'FF'-DCBOFLRB-DCBOFLWR-DCBOFTM          YM3136
*                                       ZERO INDICATED BITS      YM3136
*                                       IN DCB COPY              YM3136
         IC    R0,DCBOFLGS              COMBINE WITH DCBOFLGS    Y02082
         OR    R1,R0                      FROM COPIED DCB.       Y02082
         STC   R1,DCBOFLGS              UPDATE DCBOFLGS IN COPY  Y02082
         TM    DCBOFLGS,DCBOBUSY        DCB STILL BUSY           YM7883
         BZ    CIN06140                 BRANCH IF NOT            YM7883
         TM    DCBMACRF,DCBMEXCP        IS ACCESS METHOD EXCP
         BO    CIN06103                 YES-DO DEBCHK            Y02120
         TM    DCBDSRG2,ACBDORGA        TEST FOR ACB             Y02082
         BZ    CIN06102                 NO, NOT AN ACB           Y02082
         CLI   ACBAMETH-IFGACB(RDCB),ACBVTAM BYPASS DEBCHK       YM3011*
                                        FOR VTAM ACBS.           Y02082
         BE    CIN06110                 BRANCH IF VTAM           YM1342
         B     CIN06103                 DEBCHK OTHER ACBS.       Y02082
CIN06102 EQU   *                        TEST FOR SPOOLED         Y02082
         TM    TIOELINK,TIOTSPOL        BYPASS DEBCHK FOR        Y02082
         BM    CIN06300                   SPOOLED DCBS.          Y02082
CIN06103 EQU   *                        DEBCHECK                 Y02082
         L     R1,DXUDCBAD              GET PTR TO USER'S DCB    Y02082
         DEBCHK (1),TYPE=DELETE         CHECK DEB AND DELETE IT  Y02082
         MVI   DXATCLOS,DXATDBCK        DEB DELETED FR DEB TABLE Y02082
         LR    RDEB,R1                  GET VERIFIED DEB POINTER Y02082
         L     RDCB,DXPDCBAD            POINT TO COPIED DCB    @ZA16048
         TM    DEBFLGS1,DEBF1CEV        DID CLOSE CALL EOV     @ZA16048
         BZ    CIN08850                 BRANCH IF NO           @ZA16048
         NC    DCBDSORG,DCBDSORG        ANY DSORG SPECIFIED?   @ZA16048
         BZ    CIN08840                 NO, BR TO ASSUME PS    @ZA16048
         TM    DCBDSORG,DCBORGPS        IS IT PS               @ZA16048
         BZ    CIN08850                 BRANCH IF NOT          @ZA16048
CIN08840 EQU   *                                               @ZA16048
         MVC   DXUCBADR+K1(K3),DEBUCBAD+1    USE FIRST UCB     @ZA16048
*                      ADDRESS IN DEB AS CURRENT UCB. IF EOV   @ZA16048
*                      COULD NOT EXTEND ON THE SAME VOLUME     @ZA16048
*                      THEY MAY BE DIFFERENT.                  @ZA16048
         L     RUCB,DXUCBADR            USE NEW UCB ADDRESS    @ZA16048
         LA    RUCB,0(,RUCB)            CLEAR HI-ORDER BYTE    @ZA16048
CIN08850 EQU   *                                               @ZA16048
         L     RDCB,DXUDCBAD            POINT TO USER'S DCB      Y02082
         MODESET KEYADDR=DXUKEY,WORKREG=1 ENTER USER'S KEY       Y02082
         STCM  RDEB,B'0111',DCBDEBAD+K1 STORE DEB PTR IN DCB     Y02082
         MODESET EXTKEY=DATAMGT         BACK TO DATA MGMT KEY    Y02082
         L     RDCB,DXPDCBAD            POINT TO COPIED DCB      Y02082
         STCM  RDEB,B'0111',DCBDEBAD+K1 STORE DEB PTR IN DCB     Y02082
*                                                                Y02082
* PURGE DEBS FOR ALL DCBS (NOT ACBS) EXCEPT SPOOLED DCBS         Y02082
*                                                                Y02082
         TM    DCBMACRF,DCBMEXCP        BYPASS ACB TEST FOR EXCP Y02082
         BO    CIN06105                 GO GET PURGED            Y02082
         TM    DCBDSRG2,ACBDORGA        DO NOT PURGE ACBS        Y02082
         BO    CIN06110                 ESCAPE PURGE             Y02082
CIN06105 EQU   *                        PURGE                    Y02082
         LA    R1,DXCCW                 BUILD PURGE PARM LIST IN Y02082
         USING PURGPRM,R1                 CCW WORK AREA.         Y02082
         ST    RDEB,PURGDEB             STORE DEB TO BE PURGED   Y02082
         MVI   PURGOPT,B'10100000'      SET OPTION BITS          Y02082
         XC    PURGECB,PURGECB          CLEAR COMPLETION CODE    Y02082
         LA    R0,DEBUSRPG              SET POINTER TO IOB CHAIN Y02082
         ST    R0,PURGCHN                                        Y02082
         XC    PURGMVM,PURGMVM          CLEAR 4TH WORD OF LIST   Y02082
         PURGE (1)                      PURGE ALL IOBS, THIS DEB Y02082
         LA    R1,DXCCW                 ADDRESS PURGE PARM LIST  Y02082
         LA    R1,PURGECB-PURGPRM(R1)   POINT TO PURGE ECB       Y02082
         WAIT  ECB=(1)                  WAIT TILL PURGE COMPLETE Y02082
         DROP  R1
         B     CIN06200                 GO CHECK DEVICE TYPE     YM1342
*  NOW HAVE ACB                                                  Y02004
CIN06110 EQU   *                        SPOOLED/JAM/VTAM ACB     Y02004
         OI    DCBOFLGS,DCBOLOCK        TURN OFF LOCK BIT        Y02004
         LA    RF,FINMOD                LOAD ADDR OF IFG0202K    Y02004
         B     CIN06400                 GO STORE ID IN WTG       Y02004
CIN06140 EQU   *                        NO, NORMAL DCB PROCESSING
*
         LA    RF,EXITMOD               SET UP TO GO TO LAST LOAD
         B     CIN06400                 BRANCH TO NEXT
CIN06200 EQU   *
*
         LTR   RUCB,RUCB                TEST FOR NULL DATA SET
         BZ    CIN06300                 BRANCH IF YES TO FINAL PROCESS
         MVC   DXDEBBIN,ACCW3C          ZERO BB                  M0171
         USING UCBOB,RUCB                                        M0171
         ST    RUCB,DXDEBUCB            PLACE UCB ADDR IN DEB    M0171
         TM    UCBTBYT3,UCB3DACC        IS DEVICE DIRECT ACCESS
         BO    CIN07300                 YES, BR TO DA PROCESSING
         TM    UCBTBYT3,UCB3TAPE        IS DEVICE TYPE TAPE
         BO    CIN06600                 YES, BRANCH TO TAPE PROCESSING
CIN06300 EQU   *
         LA    RF,FINALMOD              LOAD ADDR OF FINAL STRING
CIN06400 EQU   *
         MVC   WTGIDTTR,0(RF)           MOVE IN ID OF STRING
CIN06450 EQU   *
         MVI   DXRESIND,K0              INSURE RES ROUT BITS ARE OFF
         STM   RTIOT,RET,DXREGSAV       SAVE REG 9 THRU 14
         STM   R0,R1,DXREG0             SAVE REG 0 AND 1
CIN06500 EQU   *
         TM    PLISTOPT(RPARC),LASTNTRY  CK LAST ENTRY ON LIST
         LA    RWTGC,K8(,RWTGC)         NEXT WTG ENTRY
         BO    CIN07000                 BRANCH IF LAST ENTRY
         LA    RPARC,K4(,RPARC)         NEXT DCB ENTRY
         B     CIN06100                 BRANCH TO NEXT ENTRY
*          TAPE PROCESSING
CIN06600 EQU   *
         TM    UCBFL1,UCBNOTRD          IS DEVICE READY
         BNO   CIN06650                 YES-CONTINUE             YM6559
         MODESET EXTKEY=SUPR            UCB KEY                  YM6559
         MVI   UCBDMCT,K0               ZERO DATA MANAGEMENT CT  YM6559
*                                       BEFORE GOING TO IFG0202J YM6559
         MODESET EXTKEY=DATAMGT         RETURN TO D.M. KEY       YM6559
         OI    DXATEOV,DXATNVOL         TELL RECOVERY DM CT. 0   YM6559
CIN06650 EQU   *                        DETERMINE NEXT MODULE    YM6559
         TM    UCBTBYT2,UCB3TAPE        IS IT 7 TRK TAPE        ZA01326
         BO    CIN06651                 BRANCH IF YES           ZA01326
         MVC   DXDEBMOD(K1),DEBDVMOD    SET MODE CODE-9 TRK     ZA01326
         B     CIN06652                 BRANCH TO CONTINUE      ZA01326
CIN06651 EQU   *                        SET MODE CODE-7 TRK     ZA01326
         MVI   DXDEBMOD,X'2B'           EVEN PARITY, TRANSLATE ON
         OC    DXDEBMOD,JFCDEN          SET DENSITY TO DEN USED TO
*                                       CREATE DATA SET
CIN06652 EQU   *                        CONTINUE TAPE PROCESS   ZA01326
         SR    RET,RET                  SET UP FOR BRANCH TABLE
         TM    UCBSTAT,UCBDADI          SL SPECIFIED
         BO    CIN06800                 BRANCH IF YES
         TM    UCBSTAB,UCBBSTR          AL SPECIFIED
         BO    CIN06800                 BRANCH IF YES
         TM    DEBOFLGS,DEBOFNSL        NSL SPECIFIED
         BO    CIN06900                 BRANCH IF YES
CIN06700 EQU   *
         LA    RF,VOLDPMOD              GO TO VOL DISP MODULE
         B     CIN06400                 GO CHECK NEXT DCB
CIN06800 EQU   *
         TM    DCBOFLGS,DCBOWRIT        OUTPUT PROCESSING TAKE PLACE
         LA    RF,SLMOD                 GO TO SL PROCESSING MOD
         BO    CIN06400                 GO CHECK NEXT DCB
*
*****          TEST FOR DEFERRED PROCESSING OF INPUT TRAILER LABELS
*
         TM    JFCBLTYP,JFCBUL          IS UL SPECIFIED
         BNO   CIN06700                 BR IF NOT TO CONTINUE PROCESS
         TM    DEBFLGS1,DEBF1EOF        EOF ON THIS DCB
         BNO   CIN06700                 BR IF NOT TO CONTINUE CLOSE
         LA    RF,ULTAMOD               LOAD UL MODULE ID
         LA    RET,K4                   SET UP FOR BRANCH TABLE
         B     CIN06400                 BR TO CHK NEXT DCB
CIN06900 EQU   *
         LA    RF,NSLMOD                GO TO NSL PROCESSING MOD
         B     CIN06400                 GO CHECK NEXT DCB
CIN07000 EQU   *
         MVI   WTGMODNM+K1,C'F'         CHANGE ID TO IFG
         MVI   WTGIDTTR,K0              ZERO '0G' ENTRY
         L     RES,K4(RWTGC)            LOAD ADDR OF RES. RTN
         LA    RWTGC,WTGENTRY-WTG(,RWTG)  INITIALIZE WTG ENTRY ADDR
CIN07100 EQU   *
         L     RCORE,WTGCORE-1          GET WORK AREA ADDR
         LA    RCORE,0(RCORE)           CLEAR HIGH ORDER BYTE
         LTR   RCORE,RCORE              WORK AREA ADDR PRESENT
         BZ    CIN07200                 BRANCH IF NOT
         LM    RTIOT,RET,DXREGSAV       RELOAD REG 9 THRU 14
         LM    R0,R1,DXREG0             RELOAD REG 0 AND 1
         B     RESXCTL(RES)             BRANCH TO RES. RTN
CIN07200 EQU   *
         LA    RWTGC,K8(,RWTGC)         GET NEXT ENTRY
         B     CIN07100                 LOOP BACK TO CHECK NEXT ENTRY
         EJECT
*                                                                     *
*                          FUNCTION PROLOG                            *
*                                                                     *
***********************************************************************
*                                                                     *
* FUNCTION NAME -                                                     *
*    CLOSE DA UPDATE DSCB FUNCTION.                                   *
*                                                                     *
* (STATUS) -                                                          *
*    NOT APPLICABLE                                                   *
*                                                                     *
* FUNCTION -                                                          *
*    READ FORMAT 1 DSCB IF CLOSE EXECUTORS HAD CALLED EOV WHEN        *
*    FLUSHING OUTPUT BUFFER.                                          *
*    UPDATE THE LAST-TRACK-USED AND THE TRACK BALANCE FIELDS IN THE   *
*    DSCB FOR OUTPUT PS OR PO DATA SET.                               *
*    UPDATE THE DIRECTORY COUNT FOR BPAM DATA SET.                    *
*                                                                     *
* ENTRY POINTS -                                                      *
*    ENTERED FROM THE FOLLOWING--                                     *
*    CLOSE DA ACCESS METHOD EXECUTOR INTERFACE FUNCTION.              *
*                                                                     *
* INPUT -                                                             *
*    A POINTER TO EACH OF THE FOLLOWING--                             *
*       CURRENT PARAMETER LIST ENTRY- RPARC                           *
*       DD ENTRY IN THE TIOT- RTIOT                                   *
*       WTG TABLE- RWTG                                               *
*       CURRENT WTG TABLE ENTRY- RWTGC                                *
*       DCB- RDCB                                                     *
*       WORK AREA- RCORE                                              *
*       RESIDENT ROUTINE- RES                                         *
*       UCB- RUCB                                                     *
*       DEB- RDEB                                                     *
*                                                                     *
* OUTPUT -                                                            *
*    DSCB IS UPDATED.                                                 *
*                                                                     *
* EXTERNAL REFERENCES -                                               *
*    REFER TO THE PRECEEDING MODULE PROLOG.                           *
*    CONVERT ROUTINE MBBCCHHR TO TTR.                                 *
*                                                                     *
* EXITS, NORMAL -                                                     *
*    REFER TO THE PRECEEDING MODULE PROLOG.                           *
*    CLOSE DA WRITE DSCB FUNCTION.                                    *
*                                                                     *
* EXITS, ERROR -                                                      *
*    REFER TO THE PRECEEDING MODULE PROLOG.                           *
*                                                                     *
* TABLES/WORK AREAS -                                                 *
*    THE OPEN, CLOSE, OR EOV WORK AREA AND THE WHERE-TO-GO (WTG)      *
*    TABLE ARE DESCRIBED BY THE DSECTS AT THE END OF THE LISTING.     *
*                                                                     *
* ATTRIBUTES -                                                        *
*    REFER TO THE PRECEEDING MODULE PROLOG.                           *
*                                                                     *
* CHARACTER CODE DEPENDENCY -                                         *
*    REFER TO THE PRECEEDING MODULE PROLOG.                           *
*                                                                     *
* NOTES -                                                             *
*    NOT APPLICABLE                                                   *
*                                                                     *
***********************************************************************
         EJECT
CIN07300 EQU   *
         TM    DCBMACRF,DCBMEXCP        IS IT EXCP
         BZ    CIN07400                 BRANCH IF NOT EXCP
         TM    DCBMCRF1,DCBMDEV         IS DA DEV. DEP. PRESENT
         BZ    CIN08700                 BRANCH IF NO
CIN07400 EQU   *
         TM    DCBOFLGS,DCBOWRIT        IS TRAILER SWITCH ON
         BO    CIN07600                 YES,GO TO CONVERT ROUTINE
         TM    JFCBLTYP,JFCSL+JFCBUL    USER LABELS SPECIFIED
         BNO   CIN08700                 NO, GO GET NEXT DCB
         TM    DCBDSORG,DCBORGDA        CK FOR DIRECT            A38013
         BO    CIN08600                 BRANCH IF DIRECT         A38013
         B     CIN08500                 BRANCH TO USER LABEL TESTING
*
*        GO TO CONVERT ROUTINE TO CONVERT CCHHR TO TTR
*
CIN07600 EQU   *
         TM    DEBFLGS1,DEBF1CEV        NEED FORMAT 1 DSCB       M0050
         BZ    CIN07680                 BRANCH IF NOT            M0050
CIN07620 EQU   *                                                 M0050
         LR    RC,RDEB                  USE RC FOR WORK REG.     M0050
         LA    RF,K16                   DISPLACEMENT FACTOR TO   M0050
         SR    RC,RF                    POINT TO DSCB SCH ADDR   M0050
         MVC   DXDAADDR+K1(K7),K1(RC)   BBCCHHR TO WORK AREA     M0050
         LA    RC,DXDAADDR+K3           PLACE ADDR OF CCHHR INTO M0050
         ST    RC,DXCCW1                FIRST CCW                M0050
         LA    RC,DXCCW1                PLACE ADDR OF SEARCH CCW M0050
         ST    RC,DXCCW2                INTO TIC CCW             M0050
         LA    RF,DXDSCB                BUFFER ADDRESS           M0050
         ST    RF,DXCCW3                STORE IN CCW             M0050
         MVI   DXCCW1,CCWSCHID          SEARCH FOR EQUAL ID OP   M0050
         MVC   DXCCW1+K4(K5),ACCW1C     CC, 5 CHAR, TIC OP       M0050
         MVC   DXCCW2+K4(K5),ACCW2C     CC,READ DATA OP CODE     M0050
         MVC   DXCCW3+K4(K4),ACCW3C     LENGTH OF THE DSCB       M0050
         EXCP  DXIOB                    INITIATE I/O OPERATION   M0050
         WAIT  ,ECB=DXECB               WAIT FOR COMPLETION      M0050
         TM    DXECB,ECBNOERR           TEST FOR ERROR           M0050
         BNO   CIN08900                 YES-BR IF ERROR          M0050
         OI    DXATDACC,DXATF1CE        SHOW CLOSE REREAD FMT 1  Y02144
*                                       DSCB IF EXECS CALLED EOV Y02144
CIN07680 EQU   *                        TEST FOR ORG TYPE        M0050
         CLI   DXDSCB,CHAR4             OPENED TO VTOC?        @ZA02202
         BE    CIN08700                 YES,BYPASS DSCB UPDATE @ZA02202
         TM    DCBMACRF,DCBMEXCP        EXCP?                  @ZA02202
         BZ    CIN07682                 NO, CONTINUE           @ZA02202
         TM    DCBMACRF,DCBMCOM         COMMON SECTION PRESENT?@ZA02202
         BZ    CIN07685                 NO, ASSUME PS          @ZA02202
CIN07682 EQU   *                                               @ZA02202
         NC    DCBDSORG,DCBDSORG        ANY DSORG SPECIFIED?   @ZA02202
         BZ    CIN07685                 NO, BR TO ASSUME PS    @ZA02202
         TM    DCBDSORG,DCBORGPS+DCBORGPO  TEST FOR PS OR PO
         BZ    CIN08200                 BRANCH TO LAST DA LOAD   A38013
CIN07685 EQU   *                                               @ZA02202
         CLC   DCBFDAD+K3(K4),FOXES     ANY DATA WRITTEN?      @ZA01343
         BE    CIN07750                 NO,DO NOT UPDATE       @ZA01343
*                                       LAST TRACK ADDR OR     @ZA01343
*                                       TRACK BALANCE IN FMT 1 @ZA01343
         NC    DCBFDAD+K3(K4),DCBFDAD+K3    TEST FOR ZERO CCHH  ZA01327
         BZ    CIN07750                 YES, DO NOT UPDATE      ZA01327
*                                       LAST TRACK ADDR OR      ZA01327
*                                       TRACK BALANCE IN FMT 1  ZA01327
         STM   R0,RF,DXCCW1             SAVE ALL REGISTERS
         L     R1,DCBDEBAD              LOAD DEB ADDR            Y02082
         LA    RDCB,DCBFDAD             POINT TO FULL DISK ADDRESS
         L     RF,CVTPRLTV              CONVERT ROUTINE ADDRESS
         BALR  RET,RF                   BRANCH TO CONVERT ROUTINE
         LM    R1,RF,DXCCW1+K4          RESTORE REGISTERS
         ST    R0,DXDAADDR              STORE CONVERTED ADDR-(TTR)
CIN07700 EQU   *
*
*        MODIFY LAST TRACK USED FIELD IN DSCB
*
         MVC   DSCLSTAR(K3),DXDAADDR    MOVE IN LAST TRACK ADDR
         MVC   DSCLSTAR+K3(K2),DCBTRBAL  MOVE IN TRACK BALANCE
CIN07750 EQU   *                                                ZA01327
         OI    DSCDSIND,X'80'           SET LAST VOL. IND.
         TM    DCBMACRF,DCBMEXCP        IS IT EXCP
         BO    CIN07800                 YES,BRANCH
         TM    DSCFILTY,X'02'           IS DATA SET PARTITIONED
         BZ    CIN07800                 BRANCH IF NOT
         TM    DEBOPATB,DEBOPOIN-DEBOPRBK OUTP,OUTIN,INOUT,UPD @ZA07592
         BZ    CIN07800                 BRANCH IF NO
         MVC   DSCBLDBL,DCBDIRCT+K1     MOVE IN DIRCT COUNT
         MVI   DCBDIRCT+K1,K0           CLEAR DIRECTORY COUNT
CIN07800 EQU   *
         L     RET,DXTCBADR             TCB ADDRESS              Y02134
CIN08100 EQU   *                        SET UP BRANCH            M0194
         LA    RF,DAOUTMOD              GO TO DA OUTPUT MOD      A38013
         B     CIN08400                 BRANCH TO SET OFFSET     A38013
CIN08200 EQU   *                        SET UP BRANCH            A38013
         LA    RF,DAFINMOD              GO TO FINAL DA LOAD      A38013
CIN08400 EQU   *                        SET OFFSET               A38013
         SR    RET,RET                  SET BRANCH OFFSET TO 0   A38013
         B     CIN06400                 GO CHECK NEXT DCB
*     INPUT USER LABEL CHECKING
CIN08500 EQU   *
         TM    DEBFLGS1,DEBF1EOF        EOF ON THIS DCB
         BNO   CIN08700                 NO,GO GET NEXT DCB
         LA    RF,SULDFR                YES,POINT TO DEFER LABL  A38013
*                                       PROC CODE-0D             A38013
CIN08520 EQU   *                        TEST FOR EXIT LIST       A38013
         L     RC,DCBEXLST              PICK UP EXIT LIST ADDR   A38013
         LA    RC,0(,RC)                ZERO HIGH ORDER BYTE     A38013
         LTR   RC,RC                    IS THIS EXIT LIST ZERO   A38013
         BZ    CIN08700                 YES, DO NOT PROCESS UL   A38013
         MODESET KEYADDR=DXUKEY,WORKREG=13 ASSUME USER KEY       YM1318
CIN08540 EQU   *                        TEST EXIT LIST CODES     A38013
         CLC   0(K1,RC),0(RF)           DO CODE BYTES MATCH      A38013
         BE    CIN08740                 YES,GO TO THE SPECIFIED  A38013
*                                       EXIT ADDRESS             A38013
         CLC   0(K1,RC),K1(RF)          DO CODE BYTES MATCH      A38013
         BE    CIN08740                 YES,GO TO THE SPECIFIED  A38013
*                                       EXIT ADDRESS             A38013
         TM    0(RC),LASTNTRY           IS THIS THE LAST ENTRY   A38013
*                                       IN EXLST                 A38013
         BO    CIN08700                 YES, CONTINUE CLOSE      A38013
         LA    RC,K4(,RC)               POINT TO NEXT ENTRY      A38013
         B     CIN08540                 BR TO PROCESS NEXT ENTRY A38013
CIN08600 EQU   *
         LA    RF,UTL1                  POINT TO THE UTL INPUT   A38013
*                                       CODE BYTE-03             A38013
         TM    DEBOPATB,DEBOPOUT        OPND FOR OUTPT/INPT      A38013
         BNM   CIN08520                 YES,BR TO PROCESS UL    SM05469
         TM    DEBOPATB,DEBOPUPD        OPENED FOR UPDAT         A38013
         BO    CIN08520                 BRANCH TO PROCESS UL     A38013
CIN08700 EQU   *
         MODESET EXTKEY=DATAMGT         DATA MANAGEMENT KEY      YM1318
         LA    RF,DAFINMOD              LAST DA LOAD
         LA    RET,K8                   SET BRANCH OFFSET        A38013
         B     CIN06400                 GO CHECK NEXT DCB
CIN08740 EQU   *                        EXIT LIST                A38013
         L     RC,0(,RC)                C(RC)=EXIT LIST ENTRY    A38013
         MODESET EXTKEY=DATAMGT         DATA MANAGEMENT KEY      YM1318
         LA    R1,0(,RC)                EXIT ADDRESS IN R1       A38013
         LTR   R1,R1                    CK EXIT ADDR FOR ZERO    A38013
         BZ    CIN08760                 BRANCH IF ZERO          SM05469
         LA    RF,ULDAIMOD              INPUT UL MOD ID          A38013
         B     CIN06400                 GO CHECK NEXT DCB        A38013
         SPACE 3                                                 A38013
CIN08760 EQU   *                        TRY '03' SEARCH         SM05469
         CLI   K0(RF),XLDEFSL           IS THIS DEFER LABEL     SM05469
         BNE   CIN08700                 BR IF NO, SKIP UL CODE  SM05469
         B     CIN08600                 BR IF YES TO SEARCH FOR SM05469
*                                       03 EXIT, SINCE EXIT     SM05469
*                                       LIST ADDR MAY BE 0 FOR  SM05469
*                                       '0C'. NOTE WE ARE OPEN  SM05469
*                                       INPUT AT THIS POINT.    SM05469
CIN08800 EQU   *
         L     RD,CVTPTR                VECTOR TABLE ADDRESS
         L     RET,DXTCBADR             CURRENT TCB ADDRESS      Y02134
         L     RTIOT,DXTIOTAD           POINT TO THIS DCB'S ENTRYY02134
         L     RUCB,DXUCBADR            ESTABLISH UCB ADDRESS    Y02134
         LA    RUCB,0(,RUCB)            CLEAR REG'S HI-ORDER BYTE
         BR    RF                       RETURN TO CALLER OF SUBROUTINE
         EJECT
         SPACE 1
***********************************************************************
*                                                                     *
*                        ERROR PROCESSING                             *
*                                                                     *
***********************************************************************
         SPACE 1
CIN08900 EQU   *
         LA    R0,CABD086               ERR- READ DSCB           M0050
         LA    RC,DAFINMOD              SET RETURN ADDRESS
CIN09100 EQU   *
         SR    RET,RET                  SET UP BRANCH OFFSET     A38013
         DMABCOND (0),PDMOD,RETURN=(RC),RES=NO  ABEND MACRO
         B     CIN06450                 BRANCH TO GET NEXT ENTRY
         EJECT
         SPACE 1
***********************************************************************
*                                                                     *
*                       CONSTANTS                                     *
*                                                                     *
***********************************************************************
         SPACE 1
ACCW1C   DC    X'6000000508'            COMM CHAIN,SILI,5 CHAR,TIC OP
ACCW2C   DC    X'4000000086'            COMMAND CHAIN,READ DATA OP CODE
ACCW3C   DC    X'00000060'              96 CHARACTERS
FOXES    DC    X'FFFFFFFF'              NO DATA WRITTEN MASK   @ZA01343
*                                                                A38013
*****          DCB EXIT LIST CODE BYTES USED FOR TESTING         A38013
*                                                                A38013
SULDFR   DC    X'0C'                    DEFER LABEL PROCESSING   A38013
*                                       CODE BYTE                A38013
         DC    X'8C'                    DEFER LABEL PROCESSING   A38013
*                                       CODE--LAST               A38013
UTL1     DC    X'03'                    USER TRAILER LABEL INPUT A38013
*                                       CODE BYTE                A38013
         DC    X'83'                    USER TRAILER LABEL INPUT A38013
*                                       CODE--LAST               A38013
         XCTLTABL ID=(SLMOD,0Z,DAFINMOD,2E,PDMOD,0P,DAOUTMOD,1R,       *
               FINALMOD,2J,VOLDPMOD,2F,NSLMOD,2B,ULTAMOD,2A,           *
               EXITMOD,2L,ULDAIMOD,2C,FINMOD,2K,                SA53753*
               THISMOD,IFG0200Y,                                 Y02080X
               VSAMMOD,1A),SVC=020,BRT=YES,LENGTH=               Y02080
         IECDSECS CVT,TCB,TIOT,DCB,DEB,UCB,MAIN,WTG,PREFX,ACB,   Y02080*
               RRPL,EXPAND=YES                                   Y02144
PURGPRM  DSECT                          PURGE PARAMETER LIST     Y02082
PURGDEB  DS    0F                       DEB TO BE PURGED         Y02082
PURGOPT  DS    C                        OPTION BITS              Y02082
         DS    AL3                      DEB POINTER              Y02082
PURGECB  DS    0F                       USE THIS FIELD FOR ECB   Y02082
         DS    C                        COMPLETION CODE          Y02082
PURGTCB  DS    AL3                      TCB POINTER (0=CURRENT)  Y02082
PURGCHN  DS    AL4                      CHAIN OF IOBS            Y02082
PURGMVM  DS    F                        4TH WORD FOR MVM         Y02082
IFG0200Y CSECT                                                   Y02082
ACBMJEP  EQU  X'40'                     ACB CREATED BY JEPS           $
TIOTSPOL EQU   X'06'                    JES SPOOL D.S. INDICATORS     $
*
         IECEQU  AOS=YES
         END
