         TITLE 'IFG0554P                      END OF VOLUME DA OUTPUT '
IFG0554P CSECT
***********************************************************************
*                                                                     *
*          VS2 RELEASE 3.7 DELETIONS/CHANGES                          *
*0000320740                                                    @ZA16814
*0000320540                                                    @ZA12175
*0000043600-043900,320526-320532                               @ZA12174
*000074000,289968,285969,307908                                @ZA15053
*C320540,320600,320660,D320550,320620,320640,320680,           @ZA18328
*D320700-320768,A320570,320630,320690                          @ZA18328
*                                                                     *
*          VS2 RELEASE 03 DELETIONS                                   *
*0000                                                          @ZA02221
*0000028000,042500,069000,073500,101453,307504,307520          @ZA02218
*307900,307912,514600                                          @ZA02218
*          VS2 RELEASE 02 DELETIONS                                   *
*0000140000                                                    @ZA06676
*0000108000,160000,285936-285938,285996-288996,353517-353597    ZA01265
*515000,515500                                                  ZA01265
*                                                                     *
*                                                                     *
*                                                                     *
***********************************************************************
*                                                                     *
* MODULE NAME = IFG0554P (OS/VS2)                                     *
*                                                                     *
* DESCRIPTIVE NAME =                                                  *
*        EOV DA OUTPUT                                                *
*                                                                     *
* COPYRIGHT = NONE                                                    *
*                                                                     *
* STATUS = RELEASE 2, LEVEL 0                                         *
*                                                                     *
* FUNCTION =                                                          *
*        THIS IS THE CENTRAL FUNCTION CONTROL MODULE FOR DIRECT       *
*        ACCESS OUTPUT END OF VOLUME PROCESSING. IT IS ENTERED        *
*        UNDER THE FOLLOWING CONDITIONS -                             *
*                                                                     *
*        1) IF WTGMODNM IN THE EOV WORKAREA DOES NOT INDICATE A       *
*        RETURN FROM DADSM, REGISTER 14 CONTAINS                      *
*        A BRANCH TABLE CODE 0, 4, 8, 12, 16 -                        *
*                                                                     *
*        - 0 - ENTRY FROM IFG0551H, THE INITIALIZATION FUNCTION FOR   *
*        EOV. IT IS DETERMINED WHETHER TO OBTAIN ADDITIONAL SPACE ON  *
*        THE CURRENT VOLUME OR TO OBTAIN A NEW VOLUME.                *
*                                                                     *
*        AN ATTEMPT TO ACQUIRE ADDITIONAL SPACE ON THE CURRENT        *
*        VOLUME WILL BE MADE IF THE DEB DOES NOT ALREADY CONTAIN      *
*        16 EXTENTS, VIO IS NOT BEING USED, THE SECONDARY SPACE       *
*        VALUE IN THE JFCB IS NONZERO, AND ONE OF THE FOLLOWING       *
*        CONDITIONS EXIST -                                           *
*              1) DISPOSITION IS MOD OR NEW.                          *
*              2) DISPOSITION IS OLD AND THE LAST VOLUME SUPPLIED     *
*              IN THE JFCB IS BEING PROCESSED.                        *
*              3) DISPOSITION IS OLD AND THE LAST VOLUME SUPPLIED     *
*              IN THE JFCB IS NOT BEING PROCESSED BUT BIT 0 OF        *
*              DEBVOLSQ (THE 'TREAT AS NEW' BIT) IS SET TO ONE.       *
*                                                                     *
*        ADDITIONAL SPACE IS REQUESTED ON THE CURRENT VOLUME BY       *
*        GIVING CONTROL TO THE DADSM EXTEND ROUTINE'S FIRST MODULE,   *
*        IGG0553A, WITH REGISTER 13 SET TO 1.                         *
         EJECT
*        IF SECONDARY SPACE IS ZERO, IFG0554T IS                      *
*        GIVEN CONTROL WITH INTERNAL ABEND CODE 186 CAUSING ABEND     *
*        D37-04.                                                      *
*                                                                     *
*        IF 1) THE DEB HAS 16 EXTENTS OR                              *
*        2) A VIO UNIT IS BEING PROCESSED OR                          *
*        3) THE DISPOSITION IS OLD AND THE LAST VOLUME SUPPLIED IN    *
*        THE JFCB IS NOT BEING PROCESSED AND THE 'TREAT AS NEW' BIT   *
*        (BIT 0 OF DEBVOLSQ) IS NOT SET TO ONE,                       *
*        MODULE IFG0554Z IS GIVEN CONTROL (IF SMF                     *
*        PROCESSING IS NOT REQUIRED) IN ORDER TO UPDATE               *
*        THE DSCB ON THE CURRENT VOLUME AND INTERFACE WITH USER       *
*        TRAILER LABEL PROCESSING IF REQUIRED.                        *
*        IF SMF PROCESSING IS REQUIRED UNDER THESE CIRCUMSTANCES,     *
*        MODULE IFG0553B (ALIAS FOR IFG0202H) IS GIVEN CONTROL WITH   *
*        DXRETMOD SET IN THE EOV WORKAREA CAUSING MODULE IFG0554Z TO  *
*        GAIN CONTROL AFTER SMF PROCESSING IS COMPLETED.              *
*                                                                     *
*        - 4 - ENTRY FROM IFG0554Z OR IFG0554N AFTER UPDATING THE     *
*        CURRENT VOLUME'S DSCB AND INTERFACING WITH USER LABEL        *
*        PROCESSING, THUS COMPLETING PROCESSING ON THE CURRENT        *
*        VOLUME.                                                      *
*                                                                     *
*        IF MORE VOLUMES ARE REQUESTED                                *
*        (USING THE JFCB VOLUME COUNT OR NUMBER OF                    *
*        VOLUMES, WHICHEVER IS GREATER), THE DATA MANAGEMENT          *
*        COUNT ON THE CURRENT VOLUME IS DECREMENTED AND, IF A         *
*        VIO UNIT, A WICLOSE IS ISSUED IF THE D. M. COUNT DROPS       *
*        TO ZERO. MODULE IFG0554A (ALIAS                              *
*        FOR IFG0194A) IS GIVEN CONTROL WITH REGISTER 14 SET TO       *
*        8 AND THE RETURN MODULE SET TO IFG0555H IN ORDER TO          *
*        MOUNT AND VERIFY THE NEXT VOLUME. IF THE DSCB IS PRESENT     *
*        ON THE NEXT VOLUME, IFG0554C (GIVEN CONTROL BY IFG0554A)     *
*        WILL PASS CONTROL TO IFG0555H TO BUILD A NEW DEB.            *
*        OTHERWISE A RETURN WILL BE MADE TO THIS MODULE               *
*        WITH REGISTER 14 SET TO 8.                                   *
*                                                                     *
*        IF NO MORE VOLUMES ARE REQUESTED, OR IF THIS IS A PDS,       *
*        IFG0554T IS GIVEN CONTROL WITH AN INTERNAL ABEND CODE OF     *
*        184 CAUSING AN E37-4 ABEND.                                  *
*                                                                     *
         EJECT
*        - 8 - RETURN FROM IFG0554C AFTER MOUNTING A NEW VOLUME AND   *
*        NOT FINDING A DSCB ON THE VOLUME. REGISTER 13 IS SET TO 4    *
*        AND DADSM EXTEND MODULE IGG0553A IS GIVEN CONTROL TO         *
*        OBTAIN SECONDARY SPACE ON THE NEW VOLUME.                    *
*                                                                     *
*        - 12 - RETURN FROM SMF MODULE IFG0202I WHEN NO MORE VOLUMES  *
*        ARE AVAILABLE. PROBLEM DETERMINATION IS GIVEN CONTROL WITH   *
*        INTERNAL ABEND CODE 184 CAUSING AN E37-4 ABEND.              *
*                                                                     *
*        - 16 - ENTRY FROM IFG0554T AFTER TAKING THE B37 ABEND EXIT   *
*        AND RECEIVING A RETURN CODE FROM THE EXIT INDICATING FOR     *
*        EOV TO TRY ONCE AGAIN TO OBTAIN ADDITIONAL SPACE ON THE      *
*        CURRENT VOLUME. DADSM EXTEND MODULE IGG0553A IS GIVEN        *
*        CONTROL WITH REGISTER 13 SET TO 1, THE VALUE PASSED FROM     *
*        IFG0554T.                                                    *
*                                                                     *
*        2) IF WTGMODNM IN THE EOV WORKAREA IS SET TO IGG0553A, THIS  *
*        INDICATES THAT DADSM IS RETURNING AFTER ATTEMPTING TO        *
*        ACQUIRE ADDITIONAL SPACE ON THE CURRENT OR A NEW VOLUME.     *
*        A RETURN CODE IS IN REGISTER 13 -                            *
*                                                                     *
*        - 4 - SPACE WAS OBTAINED ON A NEW VOLUME. DEBF1CEV IN        *
*        DEBFLGS1 IS SET TO 1 (INDICATING THAT EOV HAS EXTENDED),     *
*        IF DCBC2PUT IS SET TO ONE IN DCBCIND2 (INDICATING            *
*        CLOSE CALLED EOV).                                           *
*        IFG0554C IS GIVEN CONTROL USING DXRETMOD AND DXRETCOD        *
*        (WHICH HAS BEEN SET UP BY IFG0554C BEFORE GIVING THIS        *
*        MODULE CONTROL WITH REGISTER 14 SET TO 8). THIS WILL         *
*        RESULT IN THE JFCB BEING UPDATED AND THE DSCB(S) BEING       *
*        READ AND MODULE IFG0555H BEING GIVEN CONTROL TO BUILD A      *
*        NEW DEB.                                                     *
*                                                                     *
*        - 1 - SPACE HAS BEEN OBTAINED ON THE CURRENT VOLUME.         *
*        DEBF1CEV IN DEBFLGS1 IS SET TO 1                             *
*        (INDICATING THAT EOV HAS EXTENDED),                          *
*        IF DCBC2PUT IS SET TO ONE IN DCBCIND2 (INDICATING            *
*        CLOSE CALLED EOV).                                           *
*        THE DSCB IS READ USING THE DEB'S DSCB BBCCHHR, AND CONTROL   *
*        IS GIVEN TO IFG0555H WITH REGISTER 14 SET TO 8 IN ORDER      *
*        TO BUILD A NEW DEB.                                          *
         EJECT
*        - -1 - NO SPACE AVAILABLE ON THE CURRENT VOLUME. IF MORE     *
*        VOLUMES ARE SPECIFIED (USING THE VOLUME COUNT OR THE         *
*        NUMBER OF VOLUMES IN THE JFCB, WHICHEVER IS GREATER),        *
*        MODULE IFG0554Z IS GIVEN CONTROL (IF                         *
*        SMF PROCESSING IS NOT REQUIRED) TO UPDATE THE DSCB ON THE    *
*        CURRENT VOLUME AND PROCESS USER TRAILER LABELS IF NEEDED.    *
*        IFG0554Z WILL RETURN TO THIS MODULE WITH REGISTER 14 SET     *
*        TO 4.                                                        *
*                                                                     *
*        IF MORE VOLUMES ARE SPECIFIED AND SMF PROCESSING IS          *
*        REQUIRED, MODULE IFG0553B (ALIAS FOR IFG0202H) IS GIVEN      *
*        CONTROL WITH DXRETMOD IN THE EOV WORKAREA CAUSING CONTROL    *
*        NEXT TO BE GIVEN TO IFG0554Z AFTER SMF PROCESSING IS DONE.   *
*                                                                     *
*        IF NO MORE VOLUMES ARE SPECIFIED, IFG0554T                   *
*        IS GIVEN CONTROL WITH INTERNAL ABEND CODE 184 CAUSING        *
*        AN E37-4 ABEND, IF SMF PROCESSING IS NOT REQUIRED.           *
*        IF SMF PROCESSING IS REQUIRED UNDER THIS SITUATION,          *
*        MODULE IFG0553B (ALIAS FOR IFG0202H) IS GIVEN CONTROL WITH   *
*        DXRETMOD INDICATING THAT CONTROL SHOULD RETURN TO THIS       *
*        MODULE WITH 12 IN REGISTER 14, WHICH WILL RESULT IN THE      *
*        E37-4 ABEND.                                                 *
*                                                                     *
*        - -4 - NO SPACE COULD BE OBTAINED ON A NEW VOLUME.           *
*        IF THE NEW VOLUME IS FOR A NON-SPECIFIC REQUEST, MODULE      *
*        IFG0554A IS GIVEN CONTROL WITH REGISTER 14 SET TO 16         *
*        TO REJECT THE CURRENT VOLUME AND MOUNT ANOTHER.              *
*        OTHERWISE, IFG0554T IS GIVEN CONTROL WITH AN                 *
*        INTERNAL ABEND CODE OF 183 CAUSING AN E37-8 ABEND.   @ZA15053*
*                                                                     *
*        - -8 - A VOLUME WAS ENCOUNTERED WHOSE VTOC COULD             *
*        NOT BE CONVERTED TO STANDARD FORMAT.                         *
*        IF THE NEW VOLUME IS FOR A NON-SPECIFIC REQUEST, MODULE      *
*        IFG0554A IS GIVEN CONTROL WITH REGISTER 14 SET TO 16         *
*        TO REJECT THE CURRENT VOLUME AND MOUNT ANOTHER.              *
*        OTHERWISE, PROBLEM DETERMINATION IS GIVEN CONTROL WITH       *
*        AN INTERNAL ABEND CODE OF 177 CAUSING AN B37-8 ABEND.        *
*                                                              @Z40RSDH
*        - -12 - RACDEF IN EXTEND FAILED. IF THE DATA SET ON   @Z40RSDH
*        THE VOLUME PROCESSED AT OPEN IS DEFINED TO RAC A RIDT @Z40RSDH
*        IS BUILT. EXTEND CHECKS TO SEE IF THE DATA SET ON THE @Z40RSDH
*        FIRST VOLUME WAS DEFINED TO RAC AND IF IT WAS THEN    @Z40RSDH
*        A RACDEF TYPE=ADDVOL IS ISSUED TO DEFINE THE NEWLY    @Z40RSDH
*        CREATED DATA SET/VOLUME TO RAC. THIS WILL FAIL IF     @Z40RSDH
*        THE DATA SET NAME AT EOV IS NOT THE SAME AS AT OPEN;  @Z40RSDH
*        HENCE AN INTERVENING OPENJ MUST HAVE ALTERED THE      @Z40RSDH
*        DATA SET NAME.                                        @Z40RSDH
*                                                                     *
*        - -16 - AN I/O ERROR WAS ENCOUNTERED IN PROCESSING THE VTOC. *
*        IF THE NEW VOLUME IS FOR A NON-SPECIFIC REQUEST, MODULE      *
*        IFG0554A IS GIVEN CONTROL WITH REGISTER 14 SET TO 16         *
*        TO REJECT THE CURRENT VOLUME AND MOUNT ANOTHER.              *
*        OTHERWISE, PROBLEM DETERMINATION IS GIVEN CONTROL WITH       *
*        AN INTERNAL ABEND CODE OF 190 CAUSING AN 737-4 ABEND.        *
         EJECT
* NOTES =                                                             *
*        THE 'TREAT AS NEW' BIT IS USED AS FOLLOWS.                   *
*        SECONDARY SPACE WILL NOT BE ACQUIRED ON THE VOLUMES OF       *
*        OF AN OLD DATA SET UNTIL THE LAST VOLUME OR UNTIL A          *
*        VOLUME IS ENCOUNTERED UPON WHICH NO DSCB RESIDES. AT         *
*        THIS POINT THE HIGH ORDER BIT OF DEBVOLSQ IS SET TO ONE      *
*        TO INFORM THIS MODULE THAT, EVEN THOUGH AN OLD DATA SET      *
*        IS BEING PROCESSED AND THE LAST VOLUME SPECIFIED IN THE      *
*        JFCB HAS NOT YET BEEN ENCOUNTERED, SECONDARY SPACE SHOULD    *
*        ATTEMPT TO BE ACQUIRED.                                      *
*        IFG0555H TURNS THIS BIT ON.                                  *
*                                                                     *
*    DEPENDENCIES =                                                   *
*            CLASS ONE CHARACTER CODE.  THE EBCDIC CHARACTER CODE     *
*            WAS USED FOR ASSEMBLY.  THE MODULE MUST BE REASSEMBLED   *
*            IF A DIFFERENT CHARACTER SET IS USED FOR EXECUTION.      *
*                                                                     *
*    RESTRICTIONS = NONE                                              *
*                                                                     *
*    REGISTER CONVENTIONS =                                           *
*            R2 POINTS TO DCB                                         *
*            R4 POINTS TO OPEN WORK AREA                              *
*            R5 POINTS TO THE RESIDENT ROUTINE                        *
*            R6 POINTS TO THE WTG TABLE                               *
*            R7 POINTS TO THE CURRENT PARAMETER LIST ENTRY            *
*            R8 POINTS TO THE CURRENT WTG TABLE ENTRY                 *
*            R9 POINTS TO THE DD ENTRY IN THE TIOT                    *
*            R10 POINTS TO THE UCB                                    *
*                                                                     *
*    PATCH LABEL = SEE THIRD FROM LAST LABEL BEFORE ORG STATEMENT AT  *
*                  END OF LISTING.                                    *
*                                                                     *
* MODULE TYPE = CONTROL (OPEN, CLOSE, EOV DATA MANAGEMENT)            *
*                                                                     *
*    PROCESSOR = ASSEMBLER XF                                         *
*                                                                     *
*    MODULE SIZE = SEE EXTERNAL SYMBOL DICTIONARY OR LOC FIELD ON     *
*                  ORG STATEMENT AT END OF LISTING                    *
*                                                                     *
*    ATTRIBUTES = REENTRANT, REFRESHABLE,READ-ONLY, ENABLED,          *
*                 PRIVILEGED, SUPERVISOR STATE, DATA MANAGEMENT KEY,  *
*                 LINK PACK AREA RESIDENT/PAGEABLE                    *
*                                                                     *
* ENTRY POINT =                                                       *
*        IFG0554P                                                     *
*                                                                     *
*    PURPOSE = SEE FUNCTION                                           *
         EJECT
*    LINKAGE =                                                        *
*        THIS MODULE IS TRANSFERRED CONTROL THROUGH THE IECRES-LOAD   *
*        MACRO INSTRUCTION.                                           *
*                                                                     *
* INPUT =                                                             *
*        GIVEN CONTROL IN PROTECT KEY 5.                              *
*        REGISTER 2 POINTS TO THE COPIED DCB.                         *
*        DEBDCBAD POINTS TO THE COPIED DCB.                           *
*        REGISTER 4 POINTS TO THE EOV WORKAREA                        *
*                                                                     *
*        DADSM RETURN -                                               *
*        WTGMODNM IN THE EOV WORKAREA SET TO 'IGG0553A'.              *
*        REGISTER 13 CONTAINS RETURN CODE 4, 1, -1, -4, -8, OR -16.   *
*                                                                     *
* OUTPUT =                                                            *
*        THE NEXT MODULE IS GIVEN CONTROL IN PROTECT KEY 5 WITH       *
*        REGISTER 2 POINTING TO THE COPIED DCB,                       *
*        THE DEBDCBAD POINTING TO THE COPIED DCB,                     *
*        AND REGISTER 4 POINTING TO THE EOV WORKAREA,                 *
*                                                                     *
*        IFG0553B -                                                   *
*        DXRETMOD SET TO ID-VCON OF IFG0554Z OR IFG0554P.             *
*        REGISTER 14 SET TO ZERO (DXRETMOD FOR IFG0554Z),             *
*        OR TO 12 (DXRETMOD FOR IFG0554P).                            *
*                                                                     *
*        IFG0554Z -                                                   *
*        REGISTER 14 SET TO 0.                                        *
*                                                                     *
*        IFG0554A -                                                   *
*        DXRETMOD SET UP -                                            *
*              IFG0555H TO GET A NEW VOLUME                           *
*              UNTOUCHED IF REJECTING THE CURRENT NON-SPECIFIC VOL    *
*        DXRETCOD SET UP -                                            *
*              8 TO GET A NEW VOLUME                                  *
*              UNTOUCHED IF REJECTING THE CURRENT NON-SPECIFIC VOL    *
*        REGISTER 14 CONTAINS AN ENTRY CODE -                         *
*              0 TO GET A NEW VOLUME                                  *
*              16 TO REJECTEC THE CURRENT NON-SPECIFIC VOLUME         *
*                                                                     *
*        IFG0555H -                                                   *
*        REGISTER 14 CONTAINS 12                                      *
*                                                                     *
*        IFG0550P GIVEN CONTROL THROUGH DMABCOND MACRO -              *
*        REGISTER 0 CONTAINS INTERNAL ABEND CODE                      *
*                                                                     *
*        IGG0553A - DADSM EXTEND -                                    *
*        REGISTER 13 CONTAINS FUNCTION CODE -                         *
*              1 - OBTAIN SPACE ON THE CURRENT VOLUME.                *
*              4 - OBTAIN SPACE ON A NEW VOLUME.                      *
*                                                                     *
*        IFG0554T -                                                   *
*        REGISTER 12 CONTAINS INTERNAL ABEND CODE                     *
         EJECT
* EXIT-NORMAL =                                                       *
*        IFG0554Z TO UPDATE THE CURRENT VOLUME'S DSCB AND             *
*        PROCESS USER TRAILER LABELS.                                 *
*        IFG0554A TO REJECT THE CURRENT NON-SPECIFIC REQUEST          *
*        VOLUME AND/OR MOUNT A NEW VOLUME.                            *
*        IFG0553B (ALIAS FOR IFG0202H) FOR SMF PROCESSING.            *
*        IFG0555H TO BUILD A NEW DEB.                                 *
*        IGG0553A TO OBTAIN ADDITIONAL SPACE (DADSM EXTEND)           *
*                                                                     *
* EXIT-ERROR =                                                        *
*        IFG0550P GIVEN CONTROL THROUGH DMABCOND MACRO WITH AN        *
*        INTERNAL ABEND CODE IN REGISTER 0 -                          *
*        190 - 737-4 - I/O ERROR READING DSCB OR I/O ERROR RETURN     *
*        CODE PASSED BACK FROM DADSM.                                 *
*        177 - B37-8 - VTOC COUND NOT BE CONVERTED TO                 *
*        STANDARD FORMAT BY DADSM.                                    *
*        IFG0554T GIVEN CONTROL WITH AN INTERNAL ABEND CODE IN        *
*        REGISTER 12 -                                                *
*        186 - D37-4 - NO SECONDARY SPACE SUPPLIED.                   *
*        184 - E37-04 - NO MORE VOLUMES SPECIFIED IN JFCB (VOLUME     *
*        COUNT OR NUMBER OF VOLUMES REACHED).                         *
*        184 - E37-08 - NO SPACE AVAILABLE ON NEW VOLUME OR   @ZA15053
*        DUPLICATE NAME FOUND ON NEW VOLUME                   @ZA15053
*        005 - 937-38 RACDEF FAILED AT EXTEND                  @Z40RSDH
*                                                                     *
* EXTERNAL REFERENCES = SEE BELOW                                     *
*                                                                     *
*    ROUTINES =                                                       *
*        IFG019RA THROUGH THE IECRES MACRO.                           *
*                                                                     *
*    DATA AREAS =                                                     *
*        EOV WORKAREA.                                                *
*                                                                     *
*    CONTROL BLOCK =                                                  *
*        DCB                                                          *
*        TCB                                                          *
*        CVT                                                          *
*        UCB                                                          *
*        VDSCB                                                        *
*        DEB                                                          *
*                                                                     *
* TABLES =                                                            *
*        NONE.                                                        *
         EJECT
* MACROS =                                                            *
*        MODESET                                                      *
*        IECRES-LOAD                                                  *
*        IECRES-GET                                                   *
*        EXCP                                                         *
*        WAIT                                                         *
*        DMABCOND                                                     *
*        XCTLTABL                                                     *
*        IECDSECS                                                     *
*        IECEQU                                                       *
*                                                                     *
* CHANGE ACTIVITY =                                                   *
*        SEE CHANGES/DELETIONS SECTION JUST AFTER CSECT CARD.         *
*                                                                     *
***********************************************************************
         EJECT
EABD183  EQU   183                      E37-8 ABEND INTERNAL
*                                       CODE                   @YA15053
EABD184  EQU   184                      E37-4 ABEND INTERNAL CODE
EABD177  EQU   177                      B37-8 INTERNAL ABCODE    M0179
EABD186  EQU   186                      D37-4 ABEND INTERNAL CODE
EABD190  EQU   190                      737-4 ABEND INTERNAL CODE
         BALR  RBASE,0                  ESTABLISH ADDRESSABILITY
         USING FORCORE,RCORE
         USING WTG,RWTG                 WHERE-TO-GO TABLE        Y02080
         USING TIOENTRY,RTIOT
         USING UCB,RUCB
         USING DEBBASIC,RDEB
         USING IHADCB,RDCB              ADDRESSABILITY FOR DCB
         USING *,RBASE
*
*
         CLC   WTGMODNM,IGG0553A        CHECK FOR DADSM ENTRY    Y02134
         BE    EDO03500                 BRANCH IF EXTEND RETURN  Y02134
*
*      BRANCH TABLE RET IS SET TO THE FOLLOWING VALUES
*                RET=0   FROM BASIC STRING IFG0551H
*                RET=4   FROM IFG0554Z OR IFG0554N               Y02134
*                        OR FROM IFG0202I BY WAY OF IFG0554N     Y02134
*                RET=8   FROM NEW VOLUME MOUNT TO EXTEND         Y02134
*                RET=12  FROM SMF AFTER EXTEND ERROR             Y02134
*                RET=16  FROM B37 ABEND EXIT RETURN              Y02082
*
         B     EDO02700(RET)            BRANCH TABLE
EDO02700 EQU   *                        BRANCH TABLE
         B     EDO02800                 FROM BASIC IFG0551H
         B     EDO03800                 FROM 554Z OR 554N        Y02134
         B     EDO02910                 ENTRY FROM IFG0554C      Y02134
         B     EDO03660                 FROM IFG0553B AFTER ERR  Y02134
         B     EDO03300                 ENTRY FROM IFG0554T      Y02134
         EJECT
EDO02800 EQU   *                        RET=0 FROM IFG0551H
*                                                                Y02134
         L     RUCB,DXUCBADR            LOAD UCB ADDRESS         Y02134
         L     RDEB,DCBDEBAD            LOAD DEB ADDRESS         Y02134
         MVC   DXDEBUCB+K1(K3),DXUCBADR+K1 MOVE UCB TO WORK AREA Y02134
*
*        COMPUTE OFFSET FOR DEBVOLSQ REFERENCES
*
         SR    RC,RC                    ZERO REG.
         IC    RC,DEBNMEXT              PICK UP NO.EXTENTS
         SLL   RC,K4                    MPY BY 16-BYTES PER EXTENT
         AR    RC,RDEB                  ADD DEB BASE ADDRESS
*                                                                Y02134
         LA    RD,K1                    SET REG TO 1             Y02132
         LNR   RD,RD                    INDIC NO SPACE           Y02132
         TM    JFCBIND2,JFCMOD          IS IT AN OLD DATA SET
*                                       HI ORDER BITS OF JFCBIND2
*                                       01=OLD
*                                       11=NEW
*                                       10=MOD
*
         BO    EDO02900                 NO GO GET SPACE ON THIS VOL
*
*        OLD DATA SET
*
         CLC   JFCBNVOL,DXVOLSEQ+K1     CHECK FOR LAST VOL       Y02134
         BNH   EDO02900                 BRANCH IF LAST VOL       Y02134
         TM    DEBVOLSQ-DEBACSMD+DEBSUCBA-DEBTCBAD(RC),JFCMOD  @ZA06676
*                                       TREAT AS NEW ON?       @ZA06676
         BZ    EDO03515                 NO,DETERMINE DISPO-5F    YM3862
         EJECT
EDO02900 EQU   *                        GET SPACE ON THIS VOLUME
*                                                                Y02134
*****************************************************************Y02134
*                                                                Y02134
*        SET REGISTER RD = 1 - INDICATOR TO GET SPACE            Y02134
*                              ON SAME VOLUME                    Y02134
*                                                                Y02134
*****************************************************************Y02134
*                                                                Y02134
         LA    RD,K1                    GET SPACE ON CURRENT VOL Y02134
         B     EDO02920                 EXTEND ON CURRENT VOL    Y02134
*                                                                Y02134
EDO02910 EQU   *                        RET=8 - FROM IFG0554C    Y02134
*                                                                Y02134
*****************************************************************Y02134
*                                                                Y02134
*        SET REGISTER RD = 4 - INDICATOR TO GET SPACE            Y02134
*                              ON NEXT (CURRENT NOW) VOLUME      Y02134
*                                                                Y02134
*****************************************************************Y02134
*                                                                Y02134
         OC    JFCBSQTY(K3),JFCBSQTY    IS SECONDARY QTY SPEC. @ZA12174
         BZ    EDO03650                 BRANCH IF NO           @ZA12174
         LA    RD,K4                    GET SPACE ON NEXT VOLUME Y02134
         B     EDO03300                 BRANCH TO EXTEND         Y02134
         EJECT
EDO02920 EQU   *                        SEE IF SPACE CAN BE      Y02134
*                                       OBTAINED ON THIS VOLUME  Y02134
         CLI   DEBNMEXT,K16             CHECK FOR 16 EXTENTS
         BNL   EDO03515                 BRANCH IF 16 OR MORE     Y02134
*                                                                Y02134
EDO03000 EQU   *                        CHECK SECONDARY QUANTITY
*                                                                Y02134
         OC    JFCBSQTY(K3),JFCBSQTY    IS SECONDARY QTY SPECIFIED
         BZ    EDO03650                 BRANCH IF NO SPACE SPEC  Y02134
         TM    UCBJBNR,UCBVRDEV         TEST FOR VIO UCB         YM7888
         BO    EDO03515                 BR IF YES                YM7888
*                                                                Y02134
EDO03300 EQU   *                        RET=16 - RETURN FROM B37 EXIT
*                                                                Y02134
*        EXTEND IGG0553A SAVES REGS 2-12                         Y02134
*                                                                Y02134
         ST    RES,DXWORK               SAVE RES POINTER         Y02134
         MVC   DXWORK1(K8),DXCCW12      SAVE RETURN INFORMATION  Y02134
         L     R5,DCBDEBAD              LOAD DEB ADDRESS         Y02134
         L     RA,DXUCBADR              LOAD UCB INTERFACE       Y02134
         LA    RWTG,DXXAREA             POINT TO WTG TABLE       Y02134
         MVC   DXXMODNM(K12),IGG0553A   EXTEND ROUTINE           Y02134
         OI    DXATEOV,DXATDADM         SHOW GOING TO EXTEND     Y02144
         MVI   DXEXTSW,CHAR00           ZERO EXTEND SWITCH       Y02082
*                                                                Y02134
         IECRES LOAD,PREFIX=DXXPREFX,BRANCH=DIRECT               Y02080
         EJECT
***********************************************************************
*                                                                Y02134
*        RETURN HERE FROM DADSM WITH RESULT INDICATED IN  RD
*        + INDICATES SPACE OBTAINED,  - INDICATES NO SPACE
*
*****************************************************************Y02134
*                                                                Y02134
EDO03500 EQU   *                        DADSM RETURN POINT
*                                                                Y02134
         NI    DXATEOV,ALLBITS-DXATDADM SHOW BACK FROM EXTEND    Y02144
         MVC   WTGMODNM,NAME554P        SET UP WTG NAME          Y02134
         STM   RTIOT,RC,DXREGSAV        RESTORE REGISTERS
         MVI   DXRESIND,K0              ZERO RESIDENT RTN SW    SA57998
         L     RES,DXWORK               RESTORE RES POINTER      Y02134
         MVC   DXCCW12(K8),DXWORK1      RESTORE RETURN INFO      Y02134
         SR    R0,R0                    ZERO REGISTER
         ST    R0,DXCCW6                ZERO RESIDENT RTN INDICATOR
*
*****************************************************************Y02134
*
*                        CHECK IF SPACE AVAILABLE
*
*****************************************************************Y02134
*                                                                Y02134
EDO03502 EQU   *                        IS RD POSITIVE           Y02132
         LTR   RD,RD                    SET CONDITION CODE
*                                                                Y02134
*****************************************************************Y02134
*
*        ON RETURN FROM EXTEND ROUTINE, RD IS POSITIVE           Y02134
*        IF SPACE WAS OBTAINED AND NEGATIVE IF NOT.
*
*****************************************************************Y02134
*                                                                Y02134
         BP    EDO03560                 CHECK DADSM RETURN CODE  Y02134
*                                                                Y02134
         LPR   RD,RD                    GET POSITIVE VALUE       Y02134
         BCT   RD,EDO03520              BRANCH, COUNT NOT ONE    Y02134
         EJECT
*****************************************************************Y02134
*                                                                Y02134
*        UNABLE TO OBTAIN SPACE ON CURRENT VOLUME - RD = -1      Y02134
*                                                                Y02134
*****************************************************************Y02134
*                                                                Y02134
EDO03515 EQU   *                        MORE VOLUMES AVAILABEL   Y02134
*                                                                Y02134
         TM    DXXPATHS,WTGSMF          TEST FOR SMF             Y02134
         BNO   EDO03516                 GO TO USER LABEL ROUTINE Y02134
*                                                                Y02134
         LA    RET,K4                   SET UP ENTRY OFFSET      YM6729
         MVC   DXRETMOD,ID4P4Z          RETURN FOR USER LBLS     Y02134
         LA    R7,ID4P3B                SMF ROUTINE              Y02134
         B     EDO03790                 GO TO SMF ROUTINE        Y02134
*                                                                Y02134
EDO03516 EQU   *                        UPDATE CURR VOL'S DSCB,  Y02134
*                                       CHECK FOR USER LABELS    Y02134
         LA    RET,K0                   SET UP RETURN OFFSET     Y02134
         LA    R7,ID4P4Z                USER LABEL PROCESSING    Y02134
         B     EDO03790                 PROCESS USER LABELS      Y02134
         EJECT
EDO03520 EQU   *                        -4,-8,-12,-16 FR DADSM @Z40RSDH
*                                                                Y02134
         LA    RD,K1(RD)                INCREMENT FOR BR TABLE   Y02134
EDO03530 EQU   *                        BRANCH TABLE             Y02134
         B     EDO03530(RD)             RD WILL NEVER BE ZERO    Y02134
         B     EDO03655                 RD=4 NO SPACE ON NEW   @ZA15053
*                                       VOLUME                 @ZA15053
         B     EDO03670                 RD=8 VTOC NOT CONVERTED  Y02134
         B     EDO03590                 RD=12 RACDEF ERROR     @Z40RSDH
         B     EDO03640                 RD=16 EXTEND I/O ERROR   Y02134
*                                                                Y02134
*****************************************************************Y02134
*                                                                Y02134
*        SPACE HAS BEEN SUCCESSFULLY OBTAINED                    Y02134
*                                                                Y02134
*****************************************************************Y02134
*                                                                Y02134
EDO03560 EQU   *                        RD = 1, 4 FROM DADSM     Y02134
*                                                                Y02134
         TM    DCBMACRF,DCBMEXCP        TEST FOR EXCP           SA59750
         BO    EDO03570                 BRANCH IF EXCP          SA59750
         TM    DCBCIND2,DCBC2PUT        EOV CALLED DURING CLOSE  M0050
         BNO   EDO03570                 BYPASS CLOSE/EOV BIT     M0050
*                                                                Y02134
         OI    DEBFLGS1,DEBF1CEV        INDICATE TO CLOSE THAT   Y02080
*                                       EOV WAS CALLED BY QSAM   M0050
*                                       EOB MODULE TO GET SPACE  M0050
*                                                                Y02134
EDO03570 EQU   *                        SEE IF 1 OR 4            M0050
*                                                                Y02134
         BCT   RD,EDO03580              BRANCH IF NEW VOLUME     Y02134
*                                                                Y02134
         B     EDO04000                 READ F1 DSCB FUNCTION    M0050
*                                                                Y02134
EDO03580 EQU   *                        RD = 4 - RETURN TO       M0050
*                                       DXRETMOD (IFG0554C)      Y02134
         XR    RET,RET                  CLEAR FOR IC INST        Y02134
         IC    RET,DXRETCOD             LOAD RETURN OFFSET       Y02134
         LA    R7,DXRETMOD              POINT TO RETURN MODULE   Y02134
         B     EDO03790                 RETURN                   Y02134
*                                                              @Z40RSDH
EDO03590 EQU   *                        RD = 12 RACDEF ERROR   @Z40RSDH
         LA    R0,EABD005               937-38 TO PROB DET     @Z40RSDH
         B     EDO03680                 ABEND                  @Z40RSDH
         EJECT
*****************************************************************Y02134
*                                                                Y02134
*        ERROR EXITS                                             Y02134
*                                                                Y02134
*****************************************************************Y02134
*                                                                Y02134
EDO03640 EQU   *                        737-4 TO PROB. DET.      Y02134
         LA    R0,EABD190               I/O ERROR ON R/W DSCB    Y02134
*                                       IN EXTEND                Y02134
         B     EDO03680                 ISSUE 737 ABEND          Y02134
*                                                                Y02134
EDO03650 EQU   *                        D37-4 TO PROB. DET.
         LA    RC,EABD186               D37 ABEND              @ZA02218
*                                       NO SECONDARY SPACE SPEC  Y02134
         LA    R7,ID4P4T                D37/E37 ABEND ROUTINE  @ZA02218
         B     EDO03790                 BRANCH TO IFG0554T     @ZA02218
*
EDO03655 EQU   *                        E37-8 TO PROB. DET.    @ZA15053
         LA    RC,EABD183               SPACE NOT AVAIL. OR    @ZA15053
*                                       DUP. NAME ON NEW VOL   @ZA15053
         B     EDO03665                 ISSUE E37-8 ABEND      @ZA15053
*                                                              @ZA15053
*                                       R14 = 12
*                                       RETURN FROM SMF PROCESSING
EDO03660 EQU   *                        E37-4 TO PROB DET.       Y02134
         LA    RC,EABD184               E37 FAIL TO EXTEND     @ZA02218
*                                       ALL VOL USED             Y02134
EDO03665 CLC   DXVOLSR2,SCRTCH          NONSPECIFIC REQUEST?   @ZA15053
         BE    EDO03700                 BR TO GET NEW VOL      @ZA02218
         LA    R7,ID4P4T                D37/E37 ABEND ROUTINE  @ZA02218
         B     EDO03790                 BRANCH TO IFG0554T     @ZA02218
*                                                                Y02134
EDO03670 EQU   *                        B37-8 TO PROB DET        Y02134
         LA    R0,EABD177               B37 ABEND                Y02134
*                                       UNABLE TO MOUNT NEW VOL. Y02134
         B     EDO03680                 BR TO PROB DET         @ZA02218
EDO03680 EQU   *                        GO TO PROB DETERMINATION Y02134
*                                                                Y02134
         CLC   DXVOLSR2,SCRTCH          NONSPECIFIC REQUEST     ZA01265
         BE    EDO03700                 BRANCH TO GET NEW VOL   ZA01265
         NI    DCBOFLGS,ALLBITS-DCBOBUSY  TURN OFF BUSY BIT      Y02134
         LA    RWTGC,DXXENTRY           SET R8 FOR RES RTN
         LA    RWTG,DXXAREA             POINT TO EOV WTG
         DMABCOND (0),ID4P0P            LOAD ERROR CODE          Y02134
         SPACE 2
*                                                               ZA01265
EDO03700 EQU   *                        REJECT CURRENT VOL      ZA01265
*                                                               ZA01265
*        IFG0554A SAVED PREV RETMOD/RETCOD IN SAVEMOD/SAVEOFF   ZA01265
         MVC   DXRETMOD,DXSAVMOD        RESTORE TO PREV RETMOD  ZA01265
         MVC   DXRETCOD,DXSAVOFF        RESTORE TO PREV RETCOD  ZA01265
         LA    RET,K16                  LOAD REJECT OFFSET      ZA01265
         LA    R7,ID4P4A                NEW VOL MOUNT ROUTINE   ZA01265
*                                                                Y02134
EDO03790 EQU   *                        EXIT TO NEXT MODULE      Y02134
         LA    RWTGC,DXXENTRY           SET R8 FOR RES RTN       Y02134
         LA    RWTG,DXXAREA             POINT TO EOV WTG         Y02134
         IECRES LOAD,MODID=(R7),BRCODE=(RET),BRANCH=QUEUED       Y02080
         EJECT
***********************************************************************
*
*        RET = 4 ENTRY POINT
*        RETURN FROM IFG0554N OR IFG0554Z
*                                                                Y02134
*        NEW VOLUME MOUNTING FUNCTION                            Y02134
*                                                                Y02134
*        DECREMENT DM COUNT IF MORE VOLUMES ARE SPECIFIED
*
*****************************************************************Y02134
*
EDO03800 EQU   *                        DECREMENT D.M. COUNT     YM6520
         XR    RET,RET                  CLEAR REG FOR IC INST  @ZA18328
         IC    RET,JFCBNVOL             GET NUMBER OF VOLUMES  @ZA18328
         CH    RET,DXVOLSEQ             CHECK FOR MORE VOLUMES @ZA18328
         BH    EDO03804                 BRANCH IF MORE VOLUMES @ZA18328
         OC    JFCBSQTY(K3),JFCBSQTY    SECONDARY QTY SPEC?    @ZA18328
         BZ    EDO03650                 ABEND IF NOT SPECIFIED @ZA18328
*                                                              @ZA18328
EDO03804 EQU   *                                               @ZA18328
*                                                                YM6520
         TM    DSCFILTY,DCBORGPO        IS THIS A PARTITIONED    YM6520
*                                       DATA SET                 YM6520
         BO    EDO03660                 ABEND IF YES, NO SUCH    YM6520
*                                       THING AS MULTIVOLUME PDS YM6520
         EJECT
         L     RF,DXXPREFX              GET PREFIX ADDR          YM3868
         USING IECPREFX,RF              USING FOR PREFIX         YM3868
         STM   RB,RET,IECREGSV          SAVE SETLOCK REGS        YM3868
         MODESET EXTKEY=SUPR            SETLOCK KEY              YM3868
EDO03805 SETLOCK OBTAIN,TYPE=LOCAL,MODE=UNCOND,                  YM3868*
               RELATED=(LOCAL,IFG0554P(EDO03817)) GET LOCAL LOCK YM3868
         MODESET EXTKEY=DATAMGT         RETURN TO D.M. KEY       YM3868
         LM    RB,RET,IECREGSV          RESTORE REGS             YM3868
*                                                                Y02134
         L     RUCB,DXUCBADR            GET UCB ADDR             Y02134
         LA    RF,K1                    LOAD DECREMENT VALUE     Y02134
*        SHIFT DECREMENT TO USE WITH CS INSTRUCTION              Y02134
         SLL   RF,K24-(K8*((UCBDMCT-UCB)-(((UCBDMCT-UCB)/4)*4))) Y02134
         L     R0,UCB+(((UCBDMCT-UCB)/K4)*K4) ALLIGN & LOAD WORD Y02134
EDO03810 EQU   *                        SWAP IN UPDATED COUNT    Y02134
*                                                                Y02134
         LR    RET,R0                   SAVE CS OPERAND          Y02134
         SLL   RET,K25                  LEAVE ONLY UCBDMCT COUNT Y02134
         LTR   RET,RET                  TEST FOR COUNT OF 0      Y02134
         BZ    EDO03815                 BRANCH IF ALREADY 0      YM3931
*                                                                Y02134
         LR    R1,R0                    LOAD OLD VALUE TO MODIFY Y02134
         SR    R1,RF                    ADD DECREMENT TO COUNT   Y02134
*                                                                Y02134
         MODESET EXTKEY=SUPR            UCB KEY                  Y02082
         CS    R0,R1,UCB+(((UCBDMCT-UCB)/K4)*K4) STORE NEW COUNT Y02134
         MODESET EXTKEY=DATAMGT         RETURN TO DATA MGMNT KEY Y02082
         BNE   EDO03810                 BRANCH IF NOT THE SAME   Y02134
         OI    DXATEOV,DXATNVOL         INDIC CURR UNIT INACTIVE YM6520
         TM    UCBJBNR,UCBVRDEV         IS IT VIO UNIT           YM3868
         BZ    EDO03815                 BRANCH IF NO             YM3868
         EJECT
*
*        VIO UNIT - WICLOSE IF DATA MANAGEMENT COUNT NOW ZERO
*
         SLL   R1,K25                   GET COUNT IN REG         YM3868
         LTR   R1,R1                    IS COUNT ZERO            YM3868
         BNZ   EDO03815                 BRANCH IF NOT            YM3868
         LA    R1,VDSUCB-VDSCB(,RUCB)   GET VDSCB ADDR           YM3868
         L     RD,DXXPREFX              GET PREFIX ADDR          YM3868
         LA    RD,IECREGSV-IECPREFX(,RD) GET REG SAVE AREA       YM3868
         MODESET EXTKEY=SUPR            GET IN KEY ZERO          YM3868
         WICLOSE VDSCB=(1)              WICLOSE DATA SET         YM3868
         MODESET EXTKEY=DATAMGT         RETURN TO D.M. KEY       YM3868
EDO03815 EQU   *                        RELEASE LOCK             YM3868
         L     RF,DXXPREFX              GET PREFIX ADDR          YM3868
         STM   RB,RET,IECREGSV          SAVE MODESET REGS        YM3868
         MODESET EXTKEY=SUPR            GET IN KEY ZERO          YM3930
EDO03817 SETLOCK RELEASE,TYPE=LOCAL,    RELEASE LOCAL LOCK       YM3868*
               RELATED=(LOCAL,IFG0554P(EDO03805))                YM3868
         MODESET EXTKEY=DATAMGT         RETURN TO D.M. KEY       YM3930
         LM    RB,RET,IECREGSV          RESTORE MODESET REGS     YM3868
         DROP  RF                                                YM3868
         EJECT
EDO03820 EQU   *                        GET MAX(VOLCT, NVOL)     Y02134
*                                                                Y02134
         LH    R1,DXVOLSEQ              GET CURRENT SEQUENCE NO. Y02134
         LA    R1,K1(R1)                INCREMENT TO NEXT VOLUME Y02134
         STH   R1,DXVOLSEQ              SAVE SEQUENCE NUMBER     Y02134
*                                                                Y02134
         MVI   DXRETCOD,K8              SET UP OFFSET FOR 555H   Y02134
         MVC   DXRETMOD,ID4P5H          SAVE RETURN MODULE NAME  Y02134
*                                                                Y02134
         IECRES LOAD,MODID=ID4P4A,BRCODE=K0,BRANCH=QUEUED        Y02134
         SPACE 2
*****************************************************************Y02134
*                                                                Y02134
*        READ F1 DSCB IF OBTAINED SECONDARY SPACE                YM6520
*        ON CURRENT VOLUME                                       YM6520
*                                                                Y02134
*****************************************************************Y02134
*                                                                Y02134
EDO04000 EQU   *                        USE DEB PREFIX BBCCHHR   Y02134
*                                                                Y02134
*****************************************************************Y02134
*                                                                Y02134
*        SET UP EXTENT TO COVER THE WHOLE DISK.                  Y02134
*                                                                Y02134
*****************************************************************Y02134
*                                                                Y02134
         XC    DXDEBSCC(K4),DXDEBSCC    EXTENT TO COVER DISK     Y02134
*                                                                Y02134
         L     RF,CVTPTR                GET CVT ADDR             Y02134
         L     RF,CVTZDTAB-CVT(,RF)     I/O DEVICE TABLE ADDRESS Y02134
*                                                                Y02134
         XR    R1,R1                    ZERO WORK REGISTER       Y02080
         IC    R1,UCBTBYT4              GET UCB DEVICE TYPE      Y02134
         IC    R1,0(R1,RF)              INDEX TO DEVICE OFFSET   Y02134
         AR    RF,R1                    ADDR OF DEVICE ENTRY     Y02134
         MVC   DXDEBECC(K4),0(RF)       SET MAX EXTENT FROM TBL  Y02134
         MVC   DXCCW8(K4),0(RF)         SAVE MAX PACK EXTENTS    Y02082
*                                                                Y02134
         MVC   DXDEBNTR,ODA0660K        SET TRACKS TO LARGEST NO Y02134
         MVC   DXDEBUCB+K1(K3),DXUCBADR+K1 UCB ADDRESS TO DEB    Y02134
         XC    DXDEBBIN,DXDEBBIN        ZERO OUT BIN NUMBER      Y02134
         EJECT
*****************************************************************Y02134
*                                                                Y02134
*        CONSTRUCT CHANNEL PROGRAM TO READ DSCB DIRECTLY         Y02134
*        SEARCH ID EQ                                            Y02134
*        TIC *-8                                                 Y02134
*        SEARCH KEY EQ                                           Y02134
*        NOP  (NO CHAIN BIT, SLI)                                Y02134
*        READ DATA (DSCB)                                        Y02134
*                                                                Y02134
*        CHANNEL PROGRAM TO READ FORMAT 4 IS CORRECT TO READ     Y02082
*        FORMAT 1 EXCPT THE SEARCH KEY EQUAL MUST SEARCH ON 44   Y02082
*        BYTES OF THE JFCB DSNAME AND OMIT THE SLI BIT           Y02082
*                                                                Y02134
*****************************************************************Y02134
*                                                                Y02082
         LR    R8,RDEB                  GET DEBBASIC            ZA01265
         LA    RF,DEBBASIC-DEB          GET OFFSET TO PREFIX    ZA01265
         SR    R8,RF                    GET PTR TO PREFX        ZA01265
         MVC   DXDAADDR+K1(K7),DEBDSCBA-DEB(R8)  BBCCHHR OF     ZA01265
*                                              DSCB TO SEE WRD   Y02134
         MVI   DXDAADDR,K0              SET-M- TO ZERO           Y02134
         XC    DXCCW1(K40),DXCCW1       CLEAR AREA (5 CCWS)      Y02134
         LA    RF,DXDAADDR+K3           SEARCH ADDRESS           Y02134
         ST    RF,DXCCW1                                         Y02134
         LA    RF,DXCCW1                TIC ADDRESS              Y02134
         ST    RF,DXCCW2                                         Y02134
         LA    RF,DXDSCB                LOAD POINTER TO BUFFER   Y02134
         ST    RF,DXCCW5                                         Y02134
         MVI   DXCCW3+K7,L'JFCBDSNM     COUNT OF 44              Y02082
         LA    RF,JFCBDSNM              DATA SET NAME KEY ADDR   Y02082
         ST    RF,DXCCW3                STORE KEY ADDR IN CCW    Y02134
         OC    DXCCW1(K40),ODA0640K     CMND CODE, FLAGS, LENGTH Y02134
*                                                                Y02082
         EXCP  DXIOB                    READ DSCB VIA EXCP       Y02134
*                                                                Y02134
         IECRES WAIT                    WAIT FOR READ TO FINISH  Y02134
*                                                                Y02134
         TM    DXECB,ECBNOERR           CHECK FOR IO ERROR       Y02134
         BZ    EDO03640                 BRANCH IF I/O ERROR      Y02134
*                                                                Y02134
         LA    RF,DXCCW6                TEST IF CHANNEL PROGRAM  Y02134
         L     R1,IOBCOMAD              TERMINATED AFTER READ    Y02134
         LA    R1,0(R1)                 CCW BY EXAMINING CSW     Y02134
         CR    R1,RF                    STORED IN IOB            Y02134
         BNE   EDO03640                 BRANCH IF ERROR          Y02134
*                                                                Y02134
         LA    RB,DXDSCB                LOAD POINTER TO DSCB     Y02134
         EJECT
*****************************************************************Y02134
*                                                                Y02134
*        CHECK FOR MORE DSCB'S.                                  Y02134
*                                                                Y02134
*****************************************************************Y02134
*                                                                Y02134
EDO04100 EQU   *                        READ FORMAT 3 IF THERE   Y02134
*                                                                Y02134
         NC    DSCNEXT-DXDSCB(L'DSCNEXT,RB),DSCNEXT-DXDSCB(RB)   Y02134
         BZ    EDO04200                 BRANCH IF NO MORE        Y02134
*                                                                Y02134
         MVC   DXDAADDR+K3(L'DSCNEXT),DSCNEXT-DXDSCB(RB) CCHHR   Y02134
*                                                                Y02134
         LA    R0,DSCBLNG+K4            LENGTH OF DSCB + PTR     Y02134
         IECRES GET,LV=(0),PREFIX=YES,STM=(2,14,DXXPREFX),       Y02144*
               ID=DJWA                                           Y02144
*                                                                Y02134
         LA    R1,DXDSCB-DXDSCB(,R1)    CLEAR HIGH ORDER BYTE    Y02134
         ST    R1,CORECH(,RB)           CHAIN TO PREVIOUS CORE   Y02134
         LR    RB,R1                    LOAD DSCB BUFFER ADDR    Y02134
         EJECT
*****************************************************************Y02134
*                                                                Y02134
*        MODIFY CCW TO READ NEXT FORMAT 2 OR 3 DSCB KEY & DATA   Y02134
*                                                                Y02134
*        SEARCH ID EQ                                            Y02134
*        TIC *-8                                                 Y02134
*        READ KEY & DATA                                         Y02134
*                                                                Y02134
*****************************************************************Y02134
*                                                                Y02134
         LA    RC,DSCBLNG               LENGTH OF DSCB KEY+DATA  Y02134
         STM   RB,RC,DXCCW3             DSCB BUFFER & LENGTH     Y02134
         MVI   DXCCW3,CCWRDKEY          READ KEY & DATA CMND     Y02134
         LA    RB,L'JFCBDSNM(,RB)       INCREMENT PASSED KEY     Y02134
*                                                                Y02134
         EXCP  DXIOB                    READ FORMAT 2 OR 3 DSCB  Y02134
*                                                                Y02134
         IECRES WAIT                    WAIT FOR READ COMPLETE   Y02134
*                                                                Y02134
         TM    DXECB,ECBNOERR           CHECK FOR I/O ERROR      Y02134
         BNO   EDO03640                 BRANCH IF ERROR          Y02134
         B     EDO04100                 BRANCH IF NO ERROR       Y02134
*                                                                Y02134
EDO04200 EQU   *                        BUILD NEW DEB IN 555H    Y02134
*                                                                Y02134
         L     RDEB,DCBDEBAD            RESTORE DEB POINTER      Y02134
         LA    R7,ID4P5H                LOAD IFG0555H ADDRESS    Y02134
         LA    RET,K12                  IFG0555H ENTRY OFFSET    Y02134
         B     EDO03790                 BRANCH TO IFG0555H       Y02134
         EJECT
*
*        CONSTANTS
*
SCRTCH   DC    CL6'SCRTCH'              SCRTCH REQUEST NAME      Y02134
*                                                                Y02134
*        CCW'S TO READ FORMAT 1 OR 4 DSCB DIRECTLY.              Y02134
*                                                                Y02134
ODA0640K DC    X'3100000040000005'      SEARCH ID EQ             Y02134
         DC    X'0800000000000000'      TIC *-8                  Y02134
         DC    X'290000004000002C'      SEARCH KEY EQ            Y02134
         DC    X'0300000020000001'      NOP  (NO CHAIN, SLI)     Y02134
         DC    X'0600000000000060'      READ DATA (DSCB)         Y02134
*                                                                Y02134
ODA0660K DC    X'7FFF'                  MAX NO. TRACKS IN EXTENT Y02134
         EJECT
*
*          XCTL TABLE FOR IFG0554P
*
         XCTLTABL ID=(ID4P4P,4P,ID4P3B,3B,ID4P4Z,4Z,ID4P4A,4A,   Y02134X
               ID4P5H,5H,ID4P0P,0P,ID4P4T,4T,                  @ZA02218X
               NAME554P,IFG0554P,,IGG0553A),                     Y02134X
               SVC=055,BRT=YES,LENGTH=                           Y02134
*                                                                Y02134
         IECDSECS CVT,TIOT,DCB,IEZDEB,UCB,MAIN,WTG,PREFX,PSA,   ZA01265*
               EXPAND=YES                                        YM3868
         IDDVDSCB                                                YM3868
         IECEQU IEZDEB=YES                                      ZA01265
         END
