*
*        % GO TO CICBL1;                /*
         MACRO
         IFGJCICB
IFGJCICB DSECT  ,                                                   */
*%CICBL1: ;
* /******************************************************************/
* /*                                                                */
* /*       ***** COMPATIBILITY INTERFACE CONTROL BLOCK *****        */
* /*                                                                */
* /* OS/VS2 RELEASE 02, 01/22/73, LEVEL=1                           */
* /* MACCOMP Y-2 SC1DB/SJD48                                        */
* /* MACSTAT Y-2 73022/DC20762                                      */
* /*                                                                */
* /* METHOD OF ACCESS                                               */
* /*     PL/S- %INCLUDE SYSLIB(IFGJCICB)                            */
* /*           REG = DCBCICB                                        */
* /*           RESPECIFY IFGJCICB BASED (REG)                       */
* /*     BAL-  IFGJCICB   ....NO MACRO OPERANDS                     */
* /*           L     REG,DCBCICB                                    */
* /*           USING IFGJCICB,REG                                   */
* /*                                                                */
* /*       NOTE: REG IS ANY GENERAL REGISTER OTHER THAN ZERO.       */
* /*             CICB EXISTS FOR EACH DCB OPEN TO A SPOOLED         */
* /*             (SYSIN/SYSOUT) DATA SET.                           */
* /*                                                                */
* /* FUNCTION                                                       */
* /*     CONTAINS INTERNAL WORK AREAS AND CONTROL BLOCKS USED BY    */
* /*     SAM SUBSYSTEM INTERFACE TO PROVIDE COMPATIBLE MAPPING      */
* /*     OF SAM REQUESTS INTO EQUIVALENT JOB ENTRY SUBSYSTEM        */
* /*     REQUESTS FOR ACCESS TO SPOOLED DATA STREAMS.               */
* /*                                                                */
* /******************************************************************/
*
*        % GO TO CICBL2;                /*
*
CIDUMIOB DS    0D        PSEUDO IOB - PROVIDES COMPATIBILITY
*                        WITH SAM USAGE. NOT USED BY SAM-SI.
CINXTIOB DS    A         POINTER TO NEXT IOB. ALWAYS INITIALIZED
*                        TO POINT TO ITSELF(IE LAST IN CHAIN).
CIECBCD  DS    XL4       PSEUDO ECB, ALWAYS MARKED 'POSTED'
CIIOB    DS    0F        START OF BASIC IOB SECTION
         DS    XL4       NOT USED
CIECBPTR DS    A         ADDRESS OF THE PSEUDO ECB IN PREFIX
         DS    XL4       NOT USED
CIRESID  DS    F         RESIDUAL COUNT (CSW). SET PRIOR TO EACH
*                        ENTRY TO SYNAD.
         DS    XL4       NOT USED
CIDCBPTR DS    A         ADDRESS OF THE DCB
*---------------------------------------------------------------------*
CIACBD   DS    CL56      DATA ACB
CIACBED  DS    CL20      ACB EXTENSION
*---------------------------------------------------------------------*
CISYNNAM DS    CL8       MODULE NAME OF SYNAD EXECUTOR
*---------------------------------------------------------------------*
CIREGSAV DS    0F        REGISTER SAVE AREA FOR SAM-SI
         DS    F         FIRST WORD - NOT USED
CIREGBC  DS    F         BACKWARD CHAIN POINTER (HSA)
CIREGFC  DS    F         FORWARD CHAIN POINTER (LSA)
CIREGS   DS    15F       REGISTERS - 14 THROUGH 12
*---------------------------------------------------------------------*
CIFLAGS  DS    0BL4      SAM SUBSYSTEM INTERFACE FLAGS
CIFLAG1  DS    B         RESERVED
CIFLAG2  DS    B         DCB DEFAULT FLAGS -
CIFMDSOR EQU   X'80'      DSORG DEFAULTED IN DCB
CIFMDEVT EQU   X'60'      DEVTYPE BEFORE OPEN
CIFLAG3  DS    B         CONTROL FLAGS -
CIFFSTP  EQU   X'80'      PUT LOCATE FIRST PASS COMPLETED
CIFCLOSE EQU   X'40'      CLOSE IS PROCESSING DCB
CIFRAGM  EQU   X'20'      RECORD AREA OBTAINED FOR BSAM VS
CIFVSRI  EQU   X'10'      VS RECORD IS INCOMPLETE
CIFVSEOB EQU   X'08'      END OF BLOCK FOR VBS RECORD
CIFERROR EQU   X'04'      SYNAD ENTERED FOR ERROR
CIFPOINT EQU   X'02'      INVALID POINT REQUEST
CIFLAG4  DS    B         RESERVED
*---------------------------------------------------------------------*
CIRPL    DS    CL76      REQUEST PARAMETER LIST (RPL)
CIRPLEXT DS    CL16      RPL EXTENSION
CIFDBCK  DS    CL20      FEEDBACK AREA FOR RPL
*---------------------------------------------------------------------*
CILWAREA DS    F         WORK AREA FOR SPANNED RECORDS-
*                         BSAM: SIZE OF RECORD AREA OBTAINED
*                         QSAM: RDW SAVE LOCATION
CIIOCNT  DS    0F        I/O COUNT FOR BSAM BLOCKED RECORDS
CISEGLEN DS    F         SEGMENT LENGTH FOR SPANNED RECORDS
CIBLKPTR DS    A         BSAM SPANNED BLOCK CURRENT ADDRESS
CIRAREA  DS    A         ADDRESS OF SPANNED RECORD AREA
CIRECPTR DS    A         SPANNED RECORD POINTER-
*                         BSAM: CURRENT LOCATION IN RECORD AREA
*                         QSAM: ADDRESS OF SPANNED SEGMENT
CISAMWA  DS    F         SAM-SI WORK AREA
CIWK1    DS    F         SAM-SI WORK AREA
CIWK2    DS    F         SAM-SI WORK AREA
*---------------------------------------------------------------------*
CISVCLST DS    0F        SVC CONTROL EXIT LIST
CISYNRC  DS    0XL1      SYNADAF RETURN CODE
CISYNADA DS    A         SYNADAF SUBROUTINE ADDRESS
CIBLDLRC DS    0XL1      BLDL RETURN CODE
CIBLDL   DS    A         BLDL SUBROUTINE ADDRESS
CIBSPRC  DS    0XL1      BSP RETURN CODE
CIBSP    DS    A         BSP SUBROUTINE ADDRESS
CIFEOVRC DS    0XL1      FEOV RETURN CODE
CIFEOV   DS    A         FEOV SUBROUTINE ADDRESS
CISTOWRC DS    0XL1      STOW RETURN CODE
CISTOW   DS    A         STOW SUBROUTINE ADDRESS
         SPACE
**********************************************************************
*                      END OF IFGJCICB                               *
**********************************************************************
         MEND  ,                                                    */
*%CICBL2: ;
*       DCL  1  IFGJCICB BDY (DWORD) BASED, /* JCICB DEFINITION      */
*              2 CIDUMIOB,                  /* PSEUDO IOB            */
*
*              /* TO PROVIDE COMPATIBILITY WITH SAM USAGE,THE FIRST
*                 SECTION OF THE CICB CONTAINS A DUMMY IOB.  THE
*                 IOB IS PROVIDED WITH A POSTED ECB AND THE CHAIN
*                 FIELD POINTING TO ITSELF. THE CSW RESIDUAL COUNT
*                 IS SET PRIOR TO ENTRY TO USER'S SYNAD ROUTINE.     */
*
*                3 CINXTIOB  PTR   (31),    /* PREFIX-NEXT IOB       */
*                3 CIECBCD   CHAR  (01),    /* PREFIX-ECB CODE       */
*                3 *         CHAR  (03),    /* PREFIX-NOT USED       */
*                3 CIIOB     CHAR  (04),    /* START BASIC IOB       */
*                3 CIECBPTR  PTR   (31),    /* ADDR OF ECB           */
*                3 *         CHAR  (04),    /* NOT USED              */
*                3 CIRESID   PTR   (31),    /* RESIDUAL COUNT        */
*                3 *         CHAR  (04),    /* NOT USED              */
*                3 CIDCBPTR  PTR   (31),    /* ADDR OF DCB           */
*
*              2 CIACBD      CHAR  (56),    /* DATA ACB             */
*              2 CIACBED     CHAR  (20),    /* ACB EXTENSION        */
*              2 CISYNNAM    CHAR  (08)     /* SYNAD MODULE NAME    */
*                            BDY (WORD),
*              2 CIREGSAV              ,    /* REGISTER SAVE AREA   */
*               3 *          PTR   (31),    /* NOT USED             */
*               3 CIREGBC    PTR   (31),    /* BACKCHAIN PTR        */
*               3 CIREGFC    PTR   (31),    /* FORWARD CHAIN PTR    */
*               3 CIREGS     CHAR  (60),    /* REGISTERS 14-12      */
*              2 CIFLAGS     BIT   (32),    /* SAM-SI FLAGS          */
*                3 CIFLAG1   BIT   (08),    /* RESERVED              */
*                3 CIFLAG2   BIT   (08),    /* DCB DEFAULT FLAGS     */
*                  4 CIFMDSOR BIT  (01),    /* DATA SET ORGANIZATION */
*                  4 CIFMDEVT BIT  (02),    /* DEVTYPE BEFORE OPEN   */
*                  4 *        BIT  (05),    /* RESERVED              */
*                3 CIFLAG3   BIT   (08),    /* CONTROL FLAGS         */
*                  4 CIFFSTP   BIT (01),    /* PUT LOCATE - 1ST PASS */
*                  4 CIFCLOSE  BIT (01),    /* CLOSE IS PROCESSING   */
*                  4 CIFRAGM   BIT (01),    /* RCD AREA/GETMAIN FLAG */
*                  4 CIFVSRI   BIT (01),    /* VS RECORD INCOMPLETE  */
*                  4 CIFVSEOB  BIT (01),    /* VBS END OF BLOCK      */
*                  4 CIFERROR  BIT (01),    /* SYNAD ENTERED FLAG    */
*                  4 CIFPOINT  BIT (01),    /* INVALID POINT REQUEST */
*                  4 *         BIT (01),    /* RESERVED              */
*                3 CIFLAG4   BIT   (08),    /* NOT USED              */
*              2 CIRPL       CHAR  (76),    /* REQUEST PARAMETER LST*/
*              2 CIRPLEXT    CHAR  (16),    /* RPL EXTENSION        */
*              2 CIFDBCK     CHAR  (20),    /* FEEDBACK AREA FOR RPL*/
*              2 CILWAREA    PTR   (31),    /* SAVE AREA FOR  XO1942*/
*                                           /* SPANNED RECORD USE   */
*                                           /* QSAM: RDW SAVE AREA  */
*                                           /* BSAM: REC AREA SIZE  */
*              2 CIIOCNT     PTR   (31),    /* I/O COUNT FOR BSAM
*                                              BLOCKED RECORDS.      */
*               3 CISEGLEN   PTR   (31),    /* SPANNED RECORD SEGMT
*                                              LENGTH                */
*              2 CIBLKPTR    PTR   (31),    /* SPANNED RECORD BLOCK
*                                              POINTER               */
*              2 CIRAREA     PTR   (31),    /* SPANNED RECORD AREA   */
*              2 CIRECPTR    PTR   (31),    /* SPANNED RECORD PTR-
*                                              BSAM:LOC IN REC AREA
*                                              QSAM:ADDR OF SEGMENT  */
*              2 CISAMWA     PTR   (31),    /* CI WORK AREA         */
*              2 CIWK1       PTR   (31),    /* CI WORK AREA         */
*              2 CIWK2       PTR   (31),    /* CI WORK AREA         */
*              2 CISVCLST              ,    /* SVC CONTROL EXIT LIST*/
*               3 CISYNADA   PTR   (31),    /* SYNADAF EXIT         */
*                4 CISYNRC   BIT   (08),    /* SYNADAF RETURN CODE  */
*               3 CIBLDL     PTR   (31),    /* BLDL EXIT            */
*                4 CIBLDLRC  BIT   (08),    /* BLDL RETURN CODE     */
*               3 CIBSP      PTR   (31),    /* BSP EXIT             */
*                4 CIBSPRC   BIT   (08),    /* BSP RETURN CODE      */
*               3 CIFEOV     PTR   (31),    /* FEOV EXIT            */
*                4 CIFEOVRC  BIT   (08),    /* FEOV RETURN CODE     */
*               3 CISTOW     PTR   (31),    /* STOW EXIT            */
*                4 CISTOWRC  BIT   (08);    /* STOW RETURN CODE     */
* /*                                                                */
*        %DCL  ON            CHAR,          /* SWITCH SET ON        */
*              OFF           CHAR,          /* SWITCH SET OFF       */
*              CIFDMASK      CHAR,
*              CIFMDVDA      CHAR,
*              CIFMDVUR      CHAR,
*              CIFMDVNL      CHAR;
* /*                                                                */
*        %ON  = '''1''B';
*        %OFF = '''0''B';
*        %CIFDMASK = '''01100000''B';       /* DEVTYPE SPECIFIED    */
*        %CIFMDVDA = '''01''B';             /* DIRECT ACCESS        */
*        %CIFMDVUR = '''10''B';             /* UNIT RECORD          */
*        %CIFMDVNL = '''00''B';             /* NONE SPECIFIED       */
* /******************************************************************/
* /*                                                                */
* /*     END OF IFGJCICB                                            */
* /*                                                                */
* /******************************************************************/
