* /*                                                                */
* /*                                                                */
* /******************************************************************/
* /*                                                                */
* /*                           SAM DCB                              */
* /*                                                                */
* /******************************************************************/
* /*                                                                */
* /*     CHANGE LEVEL = 16                                          */
* /*     DATE OF LAST CHANGE = 24 OCTOBER 75 ( 75*297 )             */
* /*     VS2 REL 030 CHANGES                                        */
* /*     C010500,025500,035000                              @ZA07578*/
* /*     C036000,036500,037000,037500                       @ZA05626*/
* /*                                                                */
* /* IFGSDCB (SAM DATA CONTROL BLOCK) DECLARATION                   */
* /*                                                                */
* /*                                                                */
*        DCL 1 IFGSDCB BASED,           /* SAM DCB DEFINITION       */
* /*                                                                */
*              2 *           CHAR  (16),    /* NOT USED BY JES-CI   */
*              2 *           FIXED (31),    /* NOT USED BY JES-CI   */
*              2 DCBBUFCB    PTR   (31),    /* BUFFER CONTROL BLOCK */
*               3 DCBBUFNO   PTR   (08),    /* NUMBER OF BUFFERS    */
*              2 DCBBUFL     FIXED (16),    /* BUFFER LNGTH @ZA07578*/
*              2 DCBDSORG    BIT   (16),    /* DATA SET ORGANIZATION*/
*              2 DCBIOBAD    PTR   (31),    /* IOB ADDR             */
*               3 DCBSVCXL   PTR   (31),    /* SVC EXIT LIST ADDR   */
*              2 *           BIT   (08),    /* NOT DEFINED          */
*               3 DCBHIARC   BIT   (08),    /* STORAGE HIERARCHY    */
*                4 DCBBFTEK  BIT   (08),    /* BUFFERING TECHNIQUE  */
*                 5 DCBBFALN BIT   (08),    /* BUFFER ALIGNMENT     */
*              2 DCBEODAD    PTR   (24),    /* END OF DATA EXIT ADDR*/
*              2 DCBRECFM    BIT   (08),    /* RECORD FORMAT        */
*              2 DCBEXLST    PTR   (24),    /* EXIT LIST ADDR       */
*              2 DCBDDNAM    CHAR(8)BDY(WORD), /* DDNAME FOR DCB    */
*               3 DCBTIOT    FIXED (15),    /* TIOT OFFSET          */
*               3 DCBMACRF   BIT   (16),    /* MACRO FORM           */
*               3 DCBIFLGS   BIT   (08),    /* I/O FLAGS            */
*               3 DCBDEBAD   PTR   (24),    /* DEB ADDRESS          */
*              2 DCBOFLGS    BIT   (08),    /* OPEN FLAGS           */
*              2 DCBREAD     PTR   (24),    /* ADDR OF READ MODULE  */
*               3 DCBWRITE   PTR   (24),    /* ADDR OF WRITE MODULE */
*                4 DCBGET    PTR   (24),    /* ADDR OF GET MODULE   */
*                 5 DCBPUT   PTR   (24),    /* ADDR OF PUT MODULE   */
*                  6 DCBIFLG BIT   (08),    /* IOS ERROR FLAGS      */
*                  6 DCBMACR BIT   (16),    /* MACRO FORM           */
*              2 DCBOPTCD    BIT   (08),    /* OPTION CODES         */
*              2 DCBCHECK    PTR   (24),    /* ADDR OF CHECK MODULE */
*               3 DCBGERR    PTR   (24),    /* ADDR OF GET SYNCH RTN*/
*                4 DCBPERR   PTR   (24),    /* ADDR OF PUT SYNCH RTN*/
*              2 DCBIOBL     BIT   (08),    /* IOB LENGTH IN DBL WDS*/
*              2 DCBSYNAD    PTR   (24),    /* ADDR OF ERROR ROUTINE*/
*              2 DCBCIND1    BIT   (08),    /* CONDITION INDICATOR  */
*              2 DCBCIND2    BIT   (08),    /* CONDITION INDICATOR  */
*              2 DCBBLKSI    FIXED (16),    /* MAX BLK SIZE @ZA07578*/
*              2 DCBWCPO     PTR   (08),    /* WCP OFFSET FROM IOB  */
*              2 DCBWCPL     PTR   (08),    /* LENGTH OF WCP        */
*              2 DCBOFFSR    PTR   (08),    /* OFFSET OF READ CCW   */
*              2 DCBOFFSW    PTR   (08),    /* OFFSET OF WRITE CCW  */
*              2 DCBIOBA     PTR   (31),    /* ADDR OF BSAM OR QSAM
*                                              OR BPAM IOB PREFIX   */
*               3 DCBCICB    PTR   (31),    /* ADDRESS OF JCICB     */
*              2 DCBEOBAD    PTR   (31),    /* END OF BUFFER ADDRESS*/
*               3 DCBLCCW    PTR   (31),    /* ADDRESS OF LAST CCW  */
*                4 DCBEOBR   PTR   (31),    /* ADDR OF EOB MODULE   */
*                  5 DCBNCP  PTR   (08),    /* NUMBER OF CHANNEL PGM*/
*              2 *           FIXED (31),    /* NOT DEFINED          */
*               3 DCBEOBW    PTR   (31),    /* ADDR OF EOB MODULE   */
*                4 DCBRECAD  PTR   (31),    /* ADDR OF LOGICAL RCD  */
*                 5 DCBCCCW  PTR   (31),    /* ADDR OF CCW          */
*              2 DCBDIRCT    FIXED (15),    /* BPAM DIRECTORY COUNT */
*               3 DCBQSWS    BIT   (08),    /* FLAGS                */
*              2 DCBLRECL    FIXED (16),    /* LRECL        @ZA07578*/
*              2 *           FIXED (31),    /* NOT DEFINED          */
*               3 DCBEROPT   BIT   (08),    /* ERROR OPTIONS@ZA05626*/
*               3 DCBCNTRL   PTR   (24),    /* ADDR OF CNTRL@ZA05626*/
*                4 DCBNOTE   PTR   (24),    /* ADDR OF NOTE @ZA05626*/
*                 5 DCBPOINT PTR   (24),    /* ADDR OF POINT@ZA05626*/
*              2 *           CHAR  (02),    /* RESERVED             */
*              2 DCBPRECL    FIXED (15),    /* PHYSICAL RECORD LNGTH*/
*              2 DCBEOB      PTR   (31);    /* ADDR OF EOB MODULE   */
* /*                                                                */
* /*  MACRO VARIABLES FOR THE SAM DCB                               */
*        %DCL  DCBMGET       CHAR,          /* QSAM GET             */
*              DCBMPUT       CHAR,          /* QSAM PUT             */
*              DCBOPEN       CHAR,          /* DCB IS OPEN          */
*              DCBNOPEN      CHAR,          /* DCB IS NOT OPEN      */
*              DCBNBUSY      CHAR,          /* DCB IS NOT BUSY      */
*              DCBNLOCK      CHAR,          /* DCB IS NOT LOCKED    */
*              DCBINPUT      CHAR,          /* SAM READ OR GET      */
*              DCBOUTPT      CHAR,          /* SAM WRITE OR PUT     */
*              DCBMREAD      CHAR,          /* BSAM READ            */
*              DCBMGLOC      CHAR,          /* GET LOCATE MODE      */
*              DCBMGMOV      CHAR,          /* GET MOVE MODE        */
*              DCBMPLOC      CHAR,          /* PUT LOCATE MODE      */
*              DCBMPMOV      CHAR,          /* PUT MOVE MODE        */
*              DCBMPSUB      CHAR,          /*                      */
*              DCBMGSUB      CHAR,          /*                      */
*              DCBQSLOC      CHAR,          /* QSAM LOCATE MODE     */
*              DCBQSMOV      CHAR,          /* QSAM MOVE MODE       */
*              DCBCINCI      CHAR,          /* CI MODE              */
*              DCBCINNC      CHAR,          /* NOT CI MODE          */
*              DCBRECB       CHAR,          /* BLOCKED RECORDS      */
*              DCBRECF       CHAR,          /* RECFM=FIXED          */
*              DCBRECU       CHAR,          /* RECFM=UNDEFINED      */
*              DCBRECV       CHAR,          /* RECFM=VARIABLE       */
*              DCBRECS       CHAR,          /* RECFM=SPANNED        */
*              DCBMWRIT      CHAR,          /* BSAM WRITE           */
*              DCBSKIP       CHAR;          /* SKIP ERROR OPTION TST*/
*
          /* MACRO ASSIGNMENTS FOR THE SAM DCB                      */
          %DCBMGET  = 'DCBMACRF(2)   = ''1''B';
          %DCBMPUT  = 'DCBMACRF(10)  = ''1''B';
          %DCBOPEN  = 'DCBOFLGS(4)   = ''1''B';
          %DCBNOPEN = 'DCBOFLGS(4)   = ''0''B';
          %DCBNBUSY = 'DCBOFLGS(8)   = ''0''B';
          %DCBNLOCK = 'DCBOFLGS(7)   = ''1''B';
          %DCBINPUT = 'DCBMREAD OR DCBMGET';
          %DCBOUTPT = 'DCBMWRIT OR DCBMPUT';
          %DCBMREAD = 'DCBMACRF(3)   = ''1''B';
          %DCBMWRIT = 'DCBMACRF(11)  = ''1''B';
          %DCBMGLOC = 'DCBMACRF(5)   = ''1''B';
          %DCBMGMOV = 'DCBMACRF(4)   = ''1''B';
          %DCBMPMOV = 'DCBMACRF(12)  = ''1''B';
          %DCBMPLOC = 'DCBMACRF(13)  = ''1''B';
          %DCBMPSUB = 'DCBMACRF(14)  = ''1''B';
          %DCBMGSUB = 'DCBMACRF(6)   = ''1''B';
          %DCBQSLOC = 'DCBMGLOC OR DCBMPLOC';
          %DCBQSMOV = 'DCBMGMOV OR DCBMPMOV';
          %DCBCINCI = 'DCBCIND1(5)   = ''1''B';
          %DCBCINNC = 'DCBCIND1(5)   = ''0''B';
          %DCBRECB  = 'DCBRECFM(4)   = ''1''B';
          %DCBRECF  = 'DCBRECFM(1:2) = ''10''B';
          %DCBRECU  = 'DCBRECFM(1:2) = ''11''B';
          %DCBRECV  = 'DCBRECFM(1:2) = ''01''B';
          %DCBRECS  = 'DCBRECFM(5)   = ''1''B';
          %DCBSKIP  = 'DCBEROPT(2)   = ''1''B';
* /******************************************************************/
* /*                                                                */
* /*            END OF IFGSDCB                                      */
* /*                                                                */
* /******************************************************************/
