         TITLE 'IGC0610D, OPERATOR CONTROL CHECKPOINT/RESTART ROUTINE  *
                        '
IGC0610D CSECT ,                                                01S0001
@PROLOG  BALR  @12,0                                            01S0001
@PSTART  DS    0H                                               01S0001
         USING @PSTART,@12                                      01S0001
*                                   /*
IGC0610D IEDHJN AFTERHJN,HJN           MODULE IDENTIFICATION MACRO
*   ROPCAVT=RPARM;                  /* SET THE BASE POINTER FOR THE
*                                      OPERATOR CONTROL ADDRESS 02S0385
*                                      VECTOR TABLE                  */
         LR    ROPCAVT,RPARM                                    02S0385
*   RDATA=OPCWORK;                  /* SET THE BASE REGISTER TO BE
*                                      USED FOR ADDRESSING AUTOMATIC
*                                      DATA WITH THE POINTER TO THE
*                                      OPCTL RESIDENT WORK AREA      */
         L     RDATA,OPCWORK(,ROPCAVT)                          02S0386
*   GEN REFS(RDATA) NOSETS;                                     02S0387
*                                   /*
         USING @DATD,RDATA             INFORM THE ASSEMBLER OF THE
*                                      BASE REGISTER TO BE USED FOR
*                                      ADDRESSING AUTOMATIC DATA
*   RSAVE=ADDR(OPCSAVE);            /* SET THE SAVEAREA POINTER 02S0388
*                                      REGISTER WITH THE POINTER TO
*                                      THE OPERATOR CONTROL SAVE AREA*/
         LA    RSAVE,OPCSAVE(,ROPCAVT)                          02S0388
*                                                               02S0389
*   /*****************************************************************/
*   /*                                                               */
*   /* PROCESS: THIS SEGMENT DOES THE PROCESSING THAT IS NECESSARY TO*/
*   /* PERFORM THE FUNCTION OF THE MODULE.                           */
*   /*                                                               */
*   /*****************************************************************/
*                                                               02S0389
*                                                               03S0389
*   /*****************************************************************/
*   /*                                                               */
*   /* PROCESS.INITIAL: THIS SEGMENT DOES THE INITIAL PROCESSING.    */
*   /* GENERAL REGISTERS ARE INITIALIZED. WORKAREAS AND STATE FIELDS */
*   /* WHICH ARE DEFINED IN THE AUTOMATIC DATA AREA WHICH RESIDES IN */
*   /* THE OP CONTROL WORK AREA ARE CLEARED.                         */
*   /*                                                               */
*   /*****************************************************************/
*                                                               03S0389
*   DO;                                                         03S0389
*     RAVT=OPCAVTPT;                /* SET THE BASE POINTER FOR 03S0390
*                                      TCAM'S AVT                    */
         L     RAVT,OPCAVTPT(,ROPCAVT)                          03S0390
*     ROPCE=OPCCOPCE;               /* SET THE BASE POINTER FOR THE
*                                      CURRENT OPCTL ELEMENT         */
         L     @10,OPCCOPCE(,ROPCAVT)                           03S0391
         LR    ROPCE,@10                                        03S0391
*     STATES=0;                     /* INITIALIZE STATE FIELDS       */
         MVI   STATES,X'00'                                     03S0392
*   END;                                                        03S0393
*   IF OPCCOPCE=ADDR(AVTCRELE)      /* IS THE CURRENT ELEMENT THE
*                                      CKPT REQUEST ELEMENT          */
*     THEN                          /* THIS IS A RETURN FROM THE CKPT
*                                      SUBTASK                       */
         LA    @09,AVTCRELE(,RAVT)                              02S0394
         CR    @10,@09                                          02S0394
         BNE   @RF00394                                         02S0394
*                                                               03S0395
*     /***************************************************************/
*     /*                                                             */
*     /* PROCESS.RETCKPT: THIS SEGMENT PROCESSES THE RETURN FROM THE */
*     /* CHECKPOINT SUBTASK TO OPERATOR CONTROL. THE TOP ELEMENT ON  */
*     /* THE OP CONTROL CHECKPOINT QUEUE IS REMOVED. IF ANOTHER      */
*     /* ELEMENT IS ON THE QUEUE, THEN A SUBROUTINE IS CALLED TO POST*/
*     /* THE CHECKPOINT SUBTASK.                                     */
*     /*                                                             */
*     /***************************************************************/
*                                                               03S0395
*     DO;                                                       03S0395
*       OPCCOPCE=OPCCKPTF;          /* MAKE TOP ELEMENT ON QUEUE TO
*                                      CKPT THE CURRENT OPERATOR
*                                      CONTROL ELEMENT               */
         L     @10,OPCCKPTF(,ROPCAVT)                           03S0396
         ST    @10,OPCCOPCE(,ROPCAVT)                           03S0396
*       ROPCE=OPCCOPCE;             /* RESET CURRENT ELEMENT POINTER */
         LR    ROPCE,@10                                        03S0397
*       OCCKPKEY=TIC;               /* RESTORE TIC COMMAND TO THE
*                                      OPCE                          */
         MVI   OCCKPKEY(ROPCE),X'08'                            03S0398
*       OPCCKPTF=OCLINK;            /* GET LINK FROM CURRENT ELEMENT
*                                      AND MAKE IT THE TOP ELEMENT ON
*                                      THE QUEUE                     */
         L     @10,OCLINK(,ROPCE)                               03S0399
         ST    @10,OPCCKPTF(,ROPCAVT)                           03S0399
*       AVTCKENV=OFF;               /* RESET ENVIRONMENT CKPT REQUEST
*                                      FLAG                          */
         NI    AVTCKENV(RAVT),B'11011111'                       03S0400
*       IF OPCCKPTF^=0              /* CHECK FOR QUEUE NOT EMPTY     */
*         THEN                      /* THERE IS AN ELEMENT ON THE
*                                      QUEUE                         */
         LTR   @10,@10                                          03S0401
         BZ    @RF00401                                         03S0401
*         IF AVTCKHLT=OFF           /* TEST FOR HALT COMMAND    03S0402
*                                      PROCESSED BY CKPT             */
*           THEN                    /* HALT COMMAND HAS NOT BEEN
*                                      PROCESSED                     */
         TM    AVTCKHLT(RAVT),B'00001000'                       03S0402
         BNZ   @RF00402                                         03S0402
*           CALL POSTCKPT;          /* CALL SUBROUTINE TO POST THE
*                                      CKPT SUBTASK                  */
         BAL   @14,POSTCKPT                                     03S0403
*     END;                                                      03S0404
*   ELSE                            /* NOT A RETURN FROM CHECKPOINT
*                                      SUBTASK                       */
*     IF OPCRSTRT=ON                /* TEST FOR A RESTART OF TCAM    */
*       THEN                        /* THIS IS A RESTART             */
         B     @RC00394                                         02S0405
@RF00394 TM    OPCRSTRT(ROPCAVT),B'00100000'                    02S0405
         BNO   @RF00405                                         02S0405
*       DO;                                                     02S0406
*         AVTOPCCC=0;               /* CLEAR OP CONTROL COMPLETION
*                                      CODE                          */
         MVI   AVTOPCCC(RAVT),X'00'                             02S0407
*         GEN NODEFS NOEXIT NOFLOWS REFS(AVTCKPEC) SEQFLOW SETS(REG00,
*             RPARM);                                           02S0408
              POST  AVTCKPEC(RAVT)    POST CKPT ECB COMPLETE
*         TCAMRST=ON;               /* SET TCAM RESTART STATE        */
         OI    TCAMRST,B'10000000'                              02S0409
*       END;                                                    02S0410
*     ELSE                          /* NOT RESTART                   */
*       IF OCTOTE=ON                /* TEST FOR TOTE REQUEST         */
*         THEN                      /* THIS IS A TOTE REQUEST        */
         B     @RC00405                                         02S0411
@RF00405 TM    OCTOTE(ROPCE),B'01000000'                        02S0411
         BNO   @RF00411                                         02S0411
*         DO;                                                   02S0412
*           OPCMODID=WRITEMOD;      /* SET TO EXIT TO THE OPCTL WRITE
*                                      MODULE                        */
         MVC   OPCMODID(2,ROPCAVT),@CC02517                     02S0413
*           REG00=OCPARM;           /* SET RETURN CODE               */
         LH    REG00,OCPARM(,ROPCE)                             02S0414
*           OCWTG=0;                /* CLEAR THE WHERE TO GO FIELD   */
         SLR   @10,@10                                          02S0415
         STH   @10,OCWTG(,ROPCE)                                02S0415
*           EXITSET=ON;             /* EXIT PARAMETERS HAVE BEEN SET */
         OI    EXITSET,B'01000000'                              02S0416
*         END;                                                  02S0417
*       ELSE                        /* NOT TOTE => PROCESS THE  02S0418
*                                      COMMAND                       */
*         DO;                                                   02S0418
         B     @RC00411                                         02S0418
@RF00411 DS    0H                                               02S0419
*           OCCKPKEY=0;             /* CLEAR REQUEST KEY FIELD       */
         MVI   OCCKPKEY(ROPCE),X'00'                            02S0419
*           IF OCOPTCDE=OCHALT|OCOPTCDE=OCCLOSEQ|OCOPTCDE=OCCLOSEF THEN
         CLI   OCOPTCDE(ROPCE),X'3C'                            02S0420
         BE    @RT00420                                         02S0420
         CLI   OCOPTCDE(ROPCE),X'10'                            02S0420
         BE    @RT00420                                         02S0420
         CLI   OCOPTCDE(ROPCE),X'11'                            02S0420
         BNE   @RF00420                                         02S0420
@RT00420 DS    0H                                               02S0421
*                                   /* IF THIS IS HALT, MPP FLUSH, OR
*                                      MPP QUICK, PROCESS CMD   02S0421
*                                                            @YM08529*/
*                                                               03S0421
*             /*******************************************************/
*             /*                                                     */
*             /* PROCESS.HALT: THIS SEGMENT PROCESSES A HALT TCAM    */
*             /* COMMAND. IF TCAM CHECKPOINT IS ACTIVE, THEN REQUEST */
*             /* AN ENVIRONMENT CHECKPOINT. OTHERWISE, TPOST THE     */
*             /* COMPLETION ELEMENT TO INDICATE THAT CLOSEDOWN IS    */
*             /* COMPLETE.                                           */
*             /*                                                     */
*             /*******************************************************/
*                                                               03S0421
*             DO;                                               03S0421
*               IF AVTCKTAC=ON      /* TEST FOR TCAM CKPT ACTIVE     */
*                 THEN              /* TCAM CKPT IS ACTIVE           */
         TM    AVTCKTAC(RAVT),B'10000000'                       03S0422
         BNO   @RF00422                                         03S0422
*                 DO;                                           03S0423
*                   OCCKPINC=ON;    /* TREAT HALT COMMAND AS AN 03S0424
*                                      INCIDENT ...                  */
*                   OCCKPENV=ON;    /* ... THAT REQUESTS A FORCED
*                                      ENVIRONMENT                   */
         OI    OCCKPINC(ROPCE),B'10010000'                      03S0425
*                   AVTCMCPN=ON;    /* INDICATE CHKPT REQUESTED 03S0426
*                                                            @YM08529*/
         OI    AVTCMCPN(RAVT),B'01000000'                       03S0426
*                   CALL QUEUE;     /* QUEUE THE HALT COMMAND FOR
*                                      CKPT                          */
         BAL   @14,QUEUE                                        03S0427
*                 END;                                          03S0428
*               ELSE                /* TCAM CKPT IS NOT ACTIVE       */
*                 DO;                                           03S0429
         B     @RC00422                                         03S0429
@RF00422 DS    0H                                               03S0430
*                   RPARM=ADDR(AVTCLOSB);/* ELEMENT TO TPOST IS THE
*                                      COMPLETION ELEMENT            */
         LA    RPARM,AVTCLOSB(,RAVT)                            03S0430
*                   RPARM->RECBPRI=PRICLSDN;/* SET PRIORITY          */
         MVI   RECBPRI(RPARM),X'10'                             03S0431
*                   POSTTCAM=ON;    /* REQUEST POST OF TCAM          */
         OI    POSTTCAM,B'00100000'                             03S0432
*                   CALL UPDRDYQ;   /* REQUEST THAT ELEMENT BE PUT ON
*                                      THE ASYNCHRONOUS READY QUEUE  */
         BAL   @14,UPDRDYQ                                      03S0433
*                 END;                                          03S0434
*             END;                                              03S0435
*           ELSE                    /* NOT A HALT TCAM COMMAND       */
*             IF(AVTCKTAC=ON|AVTCKNAC=ON)/* TEST FOR CKPT ACTIVE     */
*               THEN                /* EITHER TCAM OR 3705 CKPT IS
*                                      ACTIVE                        */
         B     @RC00420                                         02S0436
@RF00420 TM    AVTCKTAC(RAVT),B'11000000'                       02S0436
         BZ    @RF00436                                         02S0436
*                                                               03S0437
*               /*****************************************************/
*               /*                                                   */
*               /* PROCESS.COMMAND: THIS SEGMENT DETERMINES THE TYPE */
*               /* OF COMMAND. EACH COMMAND CAUSES A CHECKPOINT      */
*               /* REQUEST TO BE QUEUED FOR THE CHECKPOINT SUBTASK.  */
*               /*                                                   */
*               /*****************************************************/
*                                                               03S0437
*               DO;                                             03S0437
*                 IF OCOPTCDE=OCMODIFY/* TEST FOR COMMAND TYPE       */
*                   THEN            /* THIS IS A MODIFY COMMAND      */
         CLI   OCOPTCDE(ROPCE),X'44'                            03S0438
         BNE   @RF00438                                         03S0438
*                                                               04S0439
*                   /*************************************************/
*                   /*                                               */
*                   /* PROCESS.COMMAND.MODIFY: THIS SEGMENT PROCESSES*/
*                   /* THE MODIFY COMMANDS. SPECIAL PROCESSING IS    */
*                   /* DONE FOR ACTIVATE/DEACTIVTE COMMANDS AND FOR  */
*                   /* 3705 RESTART COMMANDS. THE OTHER COMMANDS ARE */
*                   /* PROCESSED VIA A COMMAND TABLE SEARCH TO       */
*                   /* DETERMINE WHETHER A 3705 CHECKPOINT OR AN     */
*                   /* INCIDENT CHECKPOINT IS REQUIRED.              */
*                   /*                                               */
*                   /*************************************************/
*                                                               04S0439
*                   DO;                                         04S0439
*                     IF(OCSWITCH=OCACTVTE|OCSWITCH=OCDEACTE)/* TEST
*                                      COMMAND TYPE                  */
*                       THEN        /* THIS IS AN ACT/DEACT CMD      */
         CLI   OCSWITCH(ROPCE),X'22'                            04S0440
         BE    @RT00440                                         04S0440
         CLI   OCSWITCH(ROPCE),X'23'                            04S0440
         BNE   @RF00440                                         04S0440
@RT00440 DS    0H                                               04S0441
*                                                               05S0441
*                       /*********************************************/
*                       /*                                           */
*                       /* PROCESS.COMMAND.MODIFY.ACTDEACT: THIS     */
*                       /* SEGMENT PROCESSES ACTIVATE/DEACTIVATE     */
*                       /* COMMANDS.ACTIVTE 3705 COMMANDS RESULT IN A*/
*                       /* REQUEST FOR 3705 CHECKPOINT. ACTIVATE AND */
*                       /* DEACTIVTE 3705 COMMANDS RESULT IN A       */
*                       /* REQUEST FOR AN ENVIRONMENT CHECKPOINT IF  */
*                       /* ONE HAS NOT ALREADY BEEN REQUESTED. OTHER */
*                       /* TYPES OF ACT/DEACT'S RESULT IN A REQUEST  */
*                       /* FOR AN INCIDENT CHECKPOINT.               */
*                       /*                                           */
*                       /*********************************************/
*                                                               05S0441
*                       DO;                                     05S0441
*                         IF AVTVTMCP=ON&OCADNCP=ON/* TEST FOR TYPE
*                                      OF ACT/DEACT COMMAND          */
*                           THEN    /* THIS IS AN ACT/DEACT OF AN NCP*/
         TM    AVTVTMCP(RAVT),B'10000000'                       05S0442
         BNO   @RF00442                                         05S0442
         LR    @10,ROPCE                                        05S0442
         AL    @10,@CF02576                                     05S0442
         TM    OCADNCP-2(@10),B'00010000'                       05S0442
         BNO   @RF00442                                         05S0442
*                           DO;                                 05S0443
*                             IF OCSWITCH=OCACTVTE/* TEST COMMAND
*                                      TYPE                          */
*                               THEN/* ACTIVATE COMMAND              */
         CLI   OCSWITCH(ROPCE),X'22'                            05S0444
         BNE   @RF00444                                         05S0444
*                               OCCKPNCP=ON;/* INDICATE THAT 3705
*                                      CKPT REQUESTED                */
         OI    OCCKPNCP(ROPCE),B'01000000'                      05S0445
*                             ELSE  /* NOT ACTIVATE => DEACTIVTE     */
*                               OCCKPINC=ON;/* INDICATE THAT A TCAM
*                                      CKPT IS REQUESTED             */
         B     @RC00444                                         05S0446
@RF00444 OI    OCCKPINC(ROPCE),B'10000000'                      05S0446
*                             IF AVTCKREQ=OFF/* TEST FOR EXISTING
*                                      ENVIRONMENT REQUEST ON THE OP
*                                      CONTROL CKPT QUEUE            */
*                               THEN/* NO EXISTING ENVIRONMENT  05S0447
*                                      REQUEST                       */
@RC00444 TM    AVTCKREQ(RAVT),B'00010000'                       05S0447
         BNZ   @RF00447                                         05S0447
*                               OCCKPENV=ON;/* INDICATE THAT AN 05S0448
*                                      ENVIRONMANT CKPT IS NEEDED    */
         OI    OCCKPENV(ROPCE),B'00010000'                      05S0448
*                           END;                                05S0449
*                         ELSE      /* ACT/DEACT NOT FOR THE NCP     */
*                           OCCKPINC=ON;/* INDICATE THAT AN INCIDENT
*                                      CKPT IS TO BE TAKEN           */
         B     @RC00442                                         05S0450
@RF00442 OI    OCCKPINC(ROPCE),B'10000000'                      05S0450
*                       END;                                    05S0451
*                     ELSE          /* NOT AN ACT/DEACT              */
*                       IF OCSWITCH=OCRSTART/* TEST COMMAND TYPE     */
*                         THEN      /* THIS IS A 3705 RESTART        */
         B     @RC00440                                         04S0452
@RF00440 CLI   OCSWITCH(ROPCE),X'F1'                            04S0452
         BNE   @RF00452                                         04S0452
*                         OCCKPRST=ON;/* INDICATE THAT 3705 RESTART
*                                      IS REQUESTED                  */
         OI    OCCKPRST(ROPCE),B'00100000'                      04S0453
*                       ELSE        /* NOT AN 3705 RESTART           */
*                         DO;                                   04S0454
         B     @RC00452                                         04S0454
@RF00452 DS    0H                                               04S0455
*                           OCCKPINC=ON;/* ASSUME THAT AN INCIDENT
*                                      CKPT WILL BE TAKEN IF THIS IS
*                                      NOT A 3705 CKPT REQUEST       */
         OI    OCCKPINC(ROPCE),B'10000000'                      04S0455
*                           RPARM=ADDR(MODTABLE);/* GET ADDR OF THE
*                                      TABLE OF VALID 3705 CKPT 04S0456
*                                      MODIFY TYPES                  */
         LA    RPARM,MODTABLE                                   04S0456
*                           DO COUNT=1 TO NUMENT WHILE(OCCKPINC=ON);
         LA    COUNT,1                                          04S0457
         B     @DE00457                                         04S0457
@DL00457 TM    OCCKPINC(ROPCE),B'10000000'                      04S0457
         BNO   @DC00457                                         04S0457
*                                   /* SCAN THROUGH THE TABLE   04S0458
*                                      COMPARING THE CURRENT COMMAND
*                                      WITH THE TABLE ENTRIES        */
*                             IF OCSWITCH=TABENTRY/* COMPARE COMMAND
*                                      TO CURRENT TABLE ENTRY        */
*                               THEN/* COMMAND EQUALS THE CURRENT
*                                      TABLE ENTRY                   */
         CLC   OCSWITCH(1,ROPCE),TABENTRY(RPARM)                04S0458
         BNE   @RF00458                                         04S0458
*                               DO;                             04S0459
*                                 OCCKPNCP=ON;/* REQUEST A 3705 CKPT */
*                                 OCCKPINC=OFF;/* RESET REQUEST FOR
*                                      INCIDENT CKPT                 */
         OI    OCCKPNCP(ROPCE),B'01000000'                      04S0461
         NI    OCCKPINC(ROPCE),B'01111111'                      04S0461
*                               END;                            04S0462
*                             ELSE  /* COMMAND IS NOT EQUAL TO  04S0463
*                                      CURRENT ENTRY                 */
*                               RPARM=RPARM+LENGTH(TABENTRY);/* POINT
*                                      TO NEXT ENTRY IN THE TABLE    */
         B     @RC00458                                         04S0463
@RF00458 AL    RPARM,@CF00061                                   04S0463
*                           END;                                04S0464
@RC00458 AL    COUNT,@CF00061                                   04S0464
@DE00457 SLR   @10,@10                                          04S0464
         IC    @10,NUMENT                                       04S0464
         CR    COUNT,@10                                        04S0464
         BNH   @DL00457                                         04S0464
@DC00457 DS    0H                                               04S0465
*                         END;                                  04S0465
*                   END;                                        04S0466
*                 ELSE              /* NOT A MODIFY COMMAND          */
*                   IF OCOPTCDE=OCTCHNG/* TEST COMMAND TYPE          */
*                     THEN          /* THIS IS A TCHNG COMMAND       */
         B     @RC00438                                         03S0467
@RF00438 CLI   OCOPTCDE(ROPCE),X'56'                            03S0467
         BNE   @RF00467                                         03S0467
*                     OCCKPNCP=ON;  /* INDICATE THAT 3705 CKPT IS
*                                      REQUESTED                     */
         OI    OCCKPNCP(ROPCE),B'01000000'                      03S0468
*                   ELSE            /* NOT A TCHNG COMMAND           */
*                                                               04S0469
*                     /***********************************************/
*                     /*                                             */
*                     /* PROCESS.COMMAND.OTHERCMD: THIS SEGMENT      */
*                     /* PROCESSES THOSE COMMANDS THAT ARE NOT       */
*                     /* MODIFIES. IF INVITATION LISTS ARE           */
*                     /* CHECKPOINTED, THEN THE COMMAND IS           */
*                     /* CHECKPOINTED. SPECIAL CHECKPOINT PROCESSING */
*                     /* IS REQUIRED BY AN ICHNG COMMAND IF IT IS    */
*                     /* DIRECTED TO 3705 LINE. OTHER COMMANDS GET   */
*                     /* INCIDENT CHECKPOINTS. IF INVITATION LIST ARE*/
*                     /* NOT CHECKPOINTED, THEN ICHNG, START TERM    */
*                     /* (E), STOP TERM (E), AND STOP TERM (EM)      */
*                     /* COMMANDS ARE NOT CHECKPOINTED.              */
*                     /*                                             */
*                     /***********************************************/
*                                                               04S0469
*                     DO;                                       04S0469
         B     @RC00467                                         04S0469
@RF00467 DS    0H                                               04S0470
*                       IF AVTSTAIN=ON/* TEST COLD START VALUE OF
*                                      INVITATION LIST CKPT          */
*                         THEN      /* INVITATION LIST (AND RELATED
*                                      TYPE FIELDS) ARE TO BE CKPT'ED*/
         TM    AVTSTAIN(RAVT),B'00000100'                       04S0470
         BNO   @RF00470                                         04S0470
*                         DO;                                   04S0471
*                           OCCKPINC=ON;/* DEFAULT TO REQUEST AN
*                                      INCIDENT CKPT                 */
         OI    OCCKPINC(ROPCE),B'10000000'                      04S0472
*                           IF OCOPTCDE=OCICHNG/* TEST COMMAND TYPE  */
*                             THEN  /* THIS IS AN ICHNG COMMAND      */
         CLI   OCOPTCDE(ROPCE),X'49'                            04S0473
         BNE   @RF00473                                         04S0473
*                             IF(OCMODNME(1:4)^='00000000'X&OCMODNME(1:
*                                 4)^='00000001'X)/* TEST ICHNG TYPE */
*                               THEN/* THIS IS NOT AN ACT OR DEACT
*                                      ICHNG                         */
         CLC   OCMODNME(4,ROPCE),@CB02547                       04S0474
         BE    @RF00474                                         04S0474
         CLC   OCMODNME(4,ROPCE),@CB02548                       04S0474
         BE    @RF00474                                         04S0474
*                               DO;                             04S0475
*                                 RPARM=OCTRMTBL;/* GET TNT OFFSET
*                                      FOR THE LINE                  */
         LH    RPARM,OCTRMTBL(,ROPCE)                           04S0476
         N     RPARM,@CF02578                                   04S0476
*                                 CALL IEDQTNT;/* GET TERMINAL ENTRY
*                                      ADDRESS                       */
         L     @15,AVTRNMPT(,RAVT)                              04S0477
         BALR  @14,@15                                          04S0477
*                                 RTRM=RPARM-LENGTH(IEDNTRM);/* GET
*                                      ADDRESS OF TERM ENTRY PREFIX  */
         LR    RTRM,RPARM                                       04S0478
         SL    RTRM,@CF02324                                    04S0478
*                                 IF TRMPREF=ON/* TEST TYPE OF  04S0479
*                                      RESOURCE                      */
*                                   THEN/* THIS IS A 3705 RESOURCE   */
         TM    TRMPREF(RTRM),B'00010000'                        04S0479
         BNO   @RF00479                                         04S0479
*                                   DO;                         04S0480
*                                    OCCKPNCP=ON;/* REQUEST 3705 CKPT*/
*                                    OCCKPINC=OFF;/* RESET REQUEST
*                                      FOR INCIDENT CKPT             */
         OI    OCCKPNCP(ROPCE),B'01000000'                      04S0482
         NI    OCCKPINC(ROPCE),B'01111111'                      04S0482
*                                   END;                        04S0483
*                               END;                            04S0484
*                         END;                                  04S0485
*                       ELSE        /* DO NOT CKPT COMMANDS THAT
*                                      AFFECT INVITATION LISTS OR
*                                      RELATED FIELDS                */
*                                                               05S0486
*                         /*******************************************/
*                         /*                                         */
*                         /* PROCESS.COMMAND.OTHERCMD.INVLIST: THIS  */
*                         /* SEGMENT DETERMINES WHETHER OR NOT THIS  */
*                         /* COMMAND SHOULD BE CHECKPOINTED IF       */
*                         /* INVITATION LISTS ARE NOT CHECKPOINTED.  */
*                         /*                                         */
*                         /*******************************************/
*                                                               05S0486
*                         DO;                                   05S0486
         B     @RC00470                                         05S0486
@RF00470 DS    0H                                               05S0487
*                           IF OCOPTCDE=OCICHNG/* TEST COMMAND TYPE  */
*                             THEN                              05S0487
         CLI   OCOPTCDE(ROPCE),X'49'                            05S0487
         BE    @RT00487                                         05S0487
*                             ;     /* THIS IS AN ICHNG COMMAND => NO
*                                      CKPT                          */
*                           ELSE    /* NOT AN ICHNG                  */
*                             IF OCOPTCDE=OCVARY/* TEST COMMAND TYPE */
*                               THEN/* THIS IS A VARY COMMAND        */
         CLI   OCOPTCDE(ROPCE),X'28'                            05S0489
         BNE   @RF00489                                         05S0489
*                               DO;                             05S0490
*                                 IF SSTERM1=ON&/* TEST FOR ...      */
*                                     SSTERM3=ON&/* ... START ...    */
*                                     SSTERM4=ON/* ...... TERM,B
*                                      COMMAND                       */
*                                   THEN/* THIS IS A START TERM,B    */
         TM    SSTERM1(ROPCE),B'00001011'                       05S0491
         BNO   @RF00491                                         05S0491
*                                   OCCKPINC=ON;/* REQUEST AN   05S0492
*                                      INCIDENT CKPT                 */
         OI    OCCKPINC(ROPCE),B'10000000'                      05S0492
*                                 ELSE/* NOT START TERM,B            */
*                                   IF SSTERM2=ON&/* TEST FOR STOP
*                                      TERM ...                      */
*                                       SSTERM4=ON/* ... E OR EM CMD */
*                                     THEN                      05S0493
         B     @RC00491                                         05S0493
@RF00491 TM    SSTERM2(ROPCE),B'00000101'                       05S0493
         BO    @RT00493                                         05S0493
*                                    ;/* THIS IS A STOP TERM E OR EM
*                                      => NO CKPT                    */
*                                   ELSE/* NOT A STOP TERM E OR EM   */
*                                    IF SSTERM1=ON&/* TEST FOR ...   */
*                                        SSTERM3=ON/* ... START 05S0495
*                                      TERM,E CMD                    */
*                                      THEN                     05S0495
         TM    SSTERM1(ROPCE),B'00001010'                       05S0495
         BO    @RT00495                                         05S0495
*                                     ;/* THIS IS A START TERM,E =>
*                                      NO CKPT                       */
*                                    ELSE/* NOT A START TERM,E       */
*                                     OCCKPINC=ON;/* INDICATE THAT AN
*                                      INCIDENT CKPT IS REQUESTED    */
         OI    OCCKPINC(ROPCE),B'10000000'                      05S0497
*                               END;                            05S0498
*                             ELSE  /* NOT A VARY COMMAND            */
*                               OCCKPINC=ON;/* REQUEST AN INCIDENT
*                                      CKPT                          */
         B     @RC00489                                         05S0499
@RF00489 OI    OCCKPINC(ROPCE),B'10000000'                      05S0499
*                         END;                                  05S0500
@RC00489 DS    0H                                               05S0500
@RT00487 DS    0H                                               05S0501
*                     END;                                      04S0501
@RC00470 DS    0H                                               04S0502
*                 IF OCCKPINC=ON    /* TEST TYPE OF CKPT REQUEST     */
*                   THEN            /* THIS IS AN INCIDENT REQUEST   */
@RC00467 DS    0H                                               03S0502
@RC00438 TM    OCCKPINC(ROPCE),B'10000000'                      03S0502
         BNO   @RF00502                                         03S0502
*                   IF AVTCKTAC=ON  /* TEST FOR PRESENCE OF TCAM CKPT*/
*                     THEN          /* TCAM CKPT IS ACTIVE           */
         TM    AVTCKTAC(RAVT),B'10000000'                       03S0503
         BNO   @RF00503                                         03S0503
*                     DO;                                       03S0504
*                       IF AVTCKREQ=ON/* TEST FOR EXISTING      03S0505
*                                      ENVIRONMENT REQUEST ON THE OP
*                                      CONTROL CKPT QUEUE            */
*                         THEN      /* AN ENVIRONMENT REQUEST IS ON
*                                      THE QUEUE                     */
         TM    AVTCKREQ(RAVT),B'00010000'                       03S0505
         BNO   @RF00505                                         03S0505
*                         OCCKPINC=OFF;/* RESET INCIDENT REQUEST     */
         NI    OCCKPINC(ROPCE),B'01111111'                      03S0506
*                       CALL QUEUE; /* QUEUE THE COMMAND FOR CKPT    */
@RF00505 BAL   @14,QUEUE                                        03S0507
*                     END;                                      03S0508
*                   ELSE                                        03S0509
*                     ;             /* TCAM CKPT NOT ACTIVE          */
@RF00503 DS    0H                                               03S0510
*                 ELSE              /* NOT AN INCIDENT REQUEST       */
*                   IF OCCKPNCP=ON|OCCKPRST=ON/* TEST CKPT REQUEST
*                                      TYPE                          */
*                     THEN          /* REQUEST IS FOR 3705 CKPT OR
*                                      FOR 3705 RESTART              */
         B     @RC00502                                         03S0510
@RF00502 TM    OCCKPNCP(ROPCE),B'01100000'                      03S0510
         BZ    @RF00510                                         03S0510
*                                                               04S0511
*                     /***********************************************/
*                     /*                                             */
*                     /* PROCESS.COMMAND.TEST3705: THIS SEGMENT      */
*                     /* DETERMINES WHETHER OR NOT THE 3705          */
*                     /* CHECKPOINT DATA SET IS OPENED. IF IT IS     */
*                     /* OPENED, THEN A 3705 CHECKPOINT REQUEST IS   */
*                     /* QUEUED. OTHERWISE, 3705 ACTIVATE AND ICHNG  */
*                     /* COMMANDS ARE CONVERTED INTO TCAM CHECKPOINT */
*                     /* REQUESTS.                                   */
*                     /*                                             */
*                     /***********************************************/
*                                                               04S0511
*                     DO;                                       04S0511
*                       OCCKPTWA=0; /* CLEAR WORK AREA POINTER FOR
*                                      LATER COMPARE                 */
         SLR   @10,@10                                          04S0512
         ST    @10,OCCKPTWA(,ROPCE)                             04S0512
*                       IF AVTCKNAC=ON/* TEST FOR PRESENCE OF 3705
*                                      CKPT                          */
*                         THEN      /* 3705 CKPT IS ACTIVE           */
         TM    AVTCKNAC(RAVT),B'01000000'                       04S0513
         BNO   @RF00513                                         04S0513
*                         DO;                                   04S0514
*                                                               05S0515
*                           /*****************************************/
*                           /*                                       */
*                           /* PROCESS.COMMAND.FINDLNCP: THIS SEGMENT*/
*                           /* FINDS THE TERMINAL ENTRY FOR THE LOCAL*/
*                           /* NCP TO WHICH THE 3705 RESOURCE IS     */
*                           /* ATTACHED AND GETS THE ADDRESS OF THE  */
*                           /* DEVICE DEPENDENT FIELD. AT EXIT FROM  */
*                           /* THIS SEGMENT REG15 CONTAINS THE       */
*                           /* ADDRESS OF THE 3705 DEVICE DEPENDENT  */
*                           /* FIELD.                                */
*                           /*                                       */
*                           /*****************************************/
*                                                               05S0515
*                           DO;                                 05S0515
*                             RPARM=OCTRMTBL;/* GET TNT OFFSET OF THE
*                                      RESOURCE TO WHICH THE COMMAND
*                                      WAS DIRECTED                  */
         LH    RPARM,OCTRMTBL(,ROPCE)                           05S0516
         N     RPARM,@CF02578                                   05S0516
*                             CALL IEDQTNT;/* CALL THE TNT OFFSET TO
*                                      TERMINAL ENTRY ADDR CONVERSION
*                                      ROUTINE                       */
         L     @15,AVTRNMPT(,RAVT)                              05S0517
         BALR  @14,@15                                          05S0517
*                             RTRM=RPARM-LENGTH(IEDNTRM);/* BACKUP TO
*                                      THE ADDR OF THE PREFIX OF THE
*                                      TERMINAL ENTRY                */
         LR    RTRM,RPARM                                       05S0518
         SL    RTRM,@CF02324                                    05S0518
*                             DO WHILE TRMTYPE^=TRMLNCP;/* LOOK FOR
*                                      THE TERMINAL ENTRY OF THE
*                                      LOCAL NCP TO WHICH THE   05S0519
*                                      RESOURCE IS ATTACHED          */
         B     @DE00519                                         05S0519
@DL00519 DS    0H                                               05S0520
*                               CALL COHORTLK;/* CALL LOOKUP ROUTINE
*                                      TO GET THE ADDRESS OF THE NEXT
*                                      SUPERIOR RESOURCE             */
         L     @15,OPCHORT(,ROPCAVT)                            05S0520
         BALR  @14,@15                                          05S0520
*                               RTRM=RPARM-LENGTH(IEDNTRM);/* GET
*                                      ADDR OF THE TERMINAL ENTRY
*                                      PREFIX OF THE HIGHER RESOURCE */
         LR    RTRM,RPARM                                       05S0521
         SL    RTRM,@CF02324                                    05S0521
*                             END;                              05S0522
@DE00519 CLI   TRMTYPE(RTRM),X'0F'                              05S0522
         BNE   @DL00519                                         05S0522
*                             REG00=TRMNCPIM;/* SET MASK FOR NCP
*                                      DEVICE DEPENDENT FIELD LOOKUP */
         LA    REG00,8                                          05S0523
*                             CALL IEDQTL;/* CALL DEVICE DEPENDENT
*                                      FIELD LOOKUP ROUTINE          */
         L     @15,AVTDDFT(,RAVT)                               05S0524
         BALR  @14,@15                                          05S0524
*                           END;                                05S0525
*                                                               05S0526
*                           /*****************************************/
*                           /*                                       */
*                           /* PROCESS.COMMAND.CKOPEN: THIS SEGMENT  */
*                           /* DETERMINES WHETHER OR NOT THE         */
*                           /* CHECKPOINT DATA SET IS USABLE. (AT    */
*                           /* ENTRY REG15 POINTS TO THE 3705 DEVICE */
*                           /* DEPENDENT FIELD).                     */
*                           /*                                       */
*                           /*****************************************/
*                                                               05S0526
*                           DO;                                 05S0526
*                             RFY                               05S0527
*                               REG15 RSTD;                     05S0527
*                             IF NCPCKPT^=0/* TEST FOR 3705 CKPT DCB
*                                      CODED                         */
*                               THEN/* 3705 DCB IS CODED             */
         SLR   @14,@14                                          05S0528
         ICM   @10,15,NCPCKPT(REG15)                            05S0528
         CLR   @14,@10                                          05S0528
         BE    @RF00528                                         05S0528
*                               IF DCBOFOPN=ON/* TEST OPEN STATUS OF
*                                      THE DCB                       */
*                                 THEN/* THE DCB IS OPEN             */
         ICM   @10,15,DCBPTR(REG15)                             05S0529
         TM    DCBOFOPN+40(@10),B'00010000'                     05S0529
         BNO   @RF00529                                         05S0529
*                                 IF DCBIOBAD^=0/* TEST FOR PRESENCE
*                                      OF A CKPT WORK AREA           */
*                                   THEN/* THE CKPT WORK AREA IS
*                                      PRESENT                       */
         L     @10,DCBIOBAD+20(,@10)                            05S0530
         CR    @10,@14                                          05S0530
         BE    @RF00530                                         05S0530
*                                   DO;                         05S0531
*                                    OCCKPTWA=DCBIOBAD;/* SAVE ADDR
*                                      OF THE CKPT WORKAREA          */
         ST    @10,OCCKPTWA(,ROPCE)                             05S0532
*                                    IF OCSWITCH^=OCRSTART/* TEST
*                                      COMMAND TYPE                  */
*                                      THEN/* THIS IS NOT A RESTART
*                                      OF A 3705                     */
         CLI   OCSWITCH(ROPCE),X'F1'                            05S0533
         BE    @RF00533                                         05S0533
*                                     DO;                       05S0534
*                                      RPARM=OCTRMTBL;/* GET TNT
*                                      OFFSET OF THE RESOURCE        */
         LH    RPARM,OCTRMTBL(,ROPCE)                           05S0535
         N     RPARM,@CF02578                                   05S0535
*                                      CALL IEDIAP04;/* CALL TNT
*                                      OFFSET TO NETWORK ADDR   05S0536
*                                      CONVERSION ROUTINE            */
         L     @10,AVTSAVTP(,RAVT)                              05S0536
         L     @15,SAVTTNTX(,@10)                               05S0536
         BALR  @14,@15                                          05S0536
*                                      OCRSID=(SAVTZELM&&'FFFF'X)&REG15
*                                          ;/* CLEAR SUBAREA ADDR
*                                      FROM THE NETWORK ADDR AND SAVE
*                                      THE RESULT IN THE OPCE FOR
*                                      CKPT                          */
         L     @14,AVTSAVTP(,RAVT)                              05S0537
         L     @10,@CF02549                                     05S0537
         LH    @14,SAVTZELM(,@14)                               05S0537
         N     @14,@CF02578                                     05S0537
         XR    @10,@14                                          05S0537
         NR    @10,REG15                                        05S0537
         STH   @10,OCRSID(,ROPCE)                               05S0537
*                                     END;                      05S0538
*                                   END;                        05S0539
@RF00533 DS    0H                                               05S0540
*                           END;                                05S0540
@RF00530 DS    0H                                               05S0540
@RF00529 DS    0H                                               05S0540
@RF00528 DS    0H                                               05S0541
*                           RFY                                 05S0541
*                             REG15 UNRSTD;                     05S0541
*                         END;                                  04S0542
*                       IF OCCKPTWA=0/* TEST FOR 3705 CKPT DATA SET
*                                      USABLE                        */
*                         THEN      /* DATA SET NOT USABLE           */
@RF00513 L     @10,OCCKPTWA(,ROPCE)                             04S0543
         LTR   @10,@10                                          04S0543
         BNZ   @RF00543                                         04S0543
*                         DO;                                   04S0544
*                           IF AVTCKTAC=ON/* TEST FOR PRESENCE OF
*                                      TCAM CKPT                     */
*                             THEN  /* TCAM CKPT IS ACTIVE           */
         TM    AVTCKTAC(RAVT),B'10000000'                       04S0545
         BNO   @RF00545                                         04S0545
*                             IF(OCOPTCDE=OCMODIFY&OCSWITCH=OCACTVTE)|(
*                                 OCOPTCDE=OCICHNG&OCICTYPE^=OCICSID)
*                                   /* TEST COMMAND TYPE             */
*                               THEN/* THIS IS A ACTIVATE 3705 OR AN
*                                      ICHNG (NOT SWITCH ID LINE)    */
         CLI   OCOPTCDE(ROPCE),X'44'                            04S0546
         BNE   @GL00006                                         04S0546
         CLI   OCSWITCH(ROPCE),X'22'                            04S0546
         BE    @RT00546                                         04S0546
@GL00006 CLI   OCOPTCDE(ROPCE),X'49'                            04S0546
         BNE   @RF00546                                         04S0546
         CLI   OCICTYPE(ROPCE),0                                04S0546
         BE    @RF00546                                         04S0546
@RT00546 DS    0H                                               04S0547
*                               DO;                             04S0547
*                                 OCCKPNCP=OFF;/* RESET 3705 CKPT
*                                      REQUESTED                     */
         NI    OCCKPNCP(ROPCE),B'10111111'                      04S0548
*                                 IF AVTCKREQ=OFF/* TEST FOR    04S0549
*                                      ENVIRONMENT CKPT ALREADY 04S0549
*                                      REQUESTED                     */
*                                   THEN/* ENVIRONMENT CKPT NOT 04S0549
*                                      ALREADY REQUESTED             */
         TM    AVTCKREQ(RAVT),B'00010000'                       04S0549
         BNZ   @RF00549                                         04S0549
*                                   OCCKPINC=ON;/* REQUEST AN   04S0550
*                                      INCIDENT CKPT                 */
         OI    OCCKPINC(ROPCE),B'10000000'                      04S0550
*                                 CALL QUEUE;/* QUEUE THE COMMAND FOR
*                                      CKPT                          */
@RF00549 BAL   @14,QUEUE                                        04S0551
*                               END;                            04S0552
*                         END;                                  04S0553
*                       ELSE        /* 3705 CKPT DATA SET IS USABLE  */
*                         CALL QUEUE;/* QUEUE THE COMMAND FOR CKPT   */
         B     @RC00543                                         04S0554
@RF00543 BAL   @14,QUEUE                                        04S0554
*                     END;                                      04S0555
@RC00543 DS    0H                                               04S0556
*               END;                                            03S0556
@RF00510 DS    0H                                               03S0556
@RC00502 DS    0H                                               03S0557
*         END;                                                  02S0557
@RF00436 DS    0H                                               02S0557
@RC00420 DS    0H                                               02S0558
*                                                               02S0558
*   /*****************************************************************/
*   /*                                                               */
*   /* EPILOGUE: THIS SEGMENT COMPLETES THE EPILOGUE CODE THAT WAS   */
*   /* ALTERED BY THE MODULE PROCEDURE STATEMENT. IF THIS IS A TCAM  */
*   /* RESTART, THEN CONTROL IS RETURNED TO IEDQCA VIA A BRANCH ON   */
*   /* REGISTER 14 AFTER THE CHECKPOINT ECB IS POSTED. OTHERWISE, THE*/
*   /* XCTL SYSTEM MACRO INSTRUCTION IS USED TO TRANSFER CONTROL TO  */
*   /* THE NEXT MODULE THAT IS TO BE EXECUTED.                       */
*   /*                                                               */
*   /*****************************************************************/
*                                                               02S0558
*   RFY                                                         02S0558
*    (REG14,                                                    02S0558
*     REG15) RSTD;                                              02S0558
@RC00411 DS    0H                                               02S0558
@RC00405 DS    0H                                               02S0558
@RC00394 DS    0H                                               02S0559
*   IF TCAMRST=ON                   /* TEST FOR TCAM RESTART         */
*     THEN                          /* THIS IS A TCAM RESTART        */
         TM    TCAMRST,B'10000000'                              02S0559
         BNO   @RF00559                                         02S0559
*     DO;                                                       02S0560
*       REG14=OPCRSAVE(1);          /* RESTORE IEDQCA'S REGISTER 14 -
*                                      SAVED BY IGC0010D             */
         L     REG14,OPCRSAVE(,ROPCAVT)                         02S0561
*       REG15=OPCRSAVE(2);          /* RESTORE IEDQCA'S REGISTER 15 -
*                                      SAVED BY IGC0010D             */
         L     REG15,OPCRSAVE+4(,ROPCAVT)                       02S0562
*       RETURN;                     /* RETURN TO IEDQCA              */
@EL00001 DS    0H                                               02S0563
@EF00001 DS    0H                                               02S0563
@ER00001 BR    @14                                              02S0563
*     END;                                                      02S0564
*   ELSE                            /* RETURN STATE NOT SET          */
*     DO;                                                       02S0565
@RF00559 DS    0H                                               02S0566
*       IF EXITSET=OFF              /* TEST FOR EXIT PARAMETERS SET  */
*         THEN                      /* EXIT PARAMETERS ARE NOT SET   */
         TM    EXITSET,B'01000000'                              02S0566
         BNZ   @RF00566                                         02S0566
*         DO;                                                   02S0567
*           OPCMODID=OCWTG;         /* SET NEXT MODULE TO GET CONTROL*/
         MVC   OPCMODID(2,ROPCAVT),OCWTG(ROPCE)                 02S0568
*           OCWTG=0;                /* CLEAR WHERE TO GO FIELD       */
         SLR   @10,@10                                          02S0569
         STH   @10,OCWTG(,ROPCE)                                02S0569
*           REG00=OCPARM;           /* SET MESSAGE NUMBER            */
         LH    REG00,OCPARM(,ROPCE)                             02S0570
*         END;                                                  02S0571
*       RPARM=ROPCAVT;              /* SET THE ARGUMENT REGISTER IN
*                                      PREPARATION TO TRANSFERRING
*                                      CONTROL TO THE NEXT MODULE    */
@RF00566 LR    RPARM,ROPCAVT                                    02S0572
*       GEN EXIT REFS(OPCXCTL,ROPCAVT) NOSEQFLOW SETS(REG15);   02S0573
*                                   /*
         XCTL  SF=(E,OPCXCTL(ROPCAVT)) TRANSFER CONTROL MACRO
*       RFY                                                     02S0574
*        (REG14,                                                02S0574
*         REG15) UNRSTD;                                        02S0574
*     END;                                                      02S0575
*                                                               02S0576
*   /*****************************************************************/
*   /*                                                               */
*   /* POSTCKPT: THIS SUBROUTINE SETS UP THE OP CONTROL CHECKPOINT   */
*   /* REQUEST ELEMENT FOR A TPOST TO CHECKPOINT.                    */
*   /*                                                               */
*   /*****************************************************************/
*                                                               02S0576
*POSTCKPT:                                                      02S0576
*   PROC OPTIONS(RETREG,SAVE(14));                              02S0576
POSTCKPT ST    @14,@SA00002                                     02S0576
*                                                               03S0577
*   /*****************************************************************/
*   /*                                                               */
*   /* POSTCKPT.REQTYPE: THIS SEGMENT SETS UP THE QCB POINTER AND THE*/
*   /* KEY FIELD IN THE OPERATOR CONTROL CHECKPOINT REQUEST ELEMENT. */
*   /* IF NONE OF THE REQUEST BITS ARE ON IN OCCKPTYP, THEN THIS CKPT*/
*   /* REQUEST WAS RECORDED WITH AN ENVIRONMENT CHECKPOINTTHAT       */
*   /* PRECEDED THIS REQUEST ON THE CKPT QUEUE. TPOST THE REQUEST    */
*   /* ELEMENT BACK TO THIS MODULE AS IF A CKPT WERE TAKEN.          */
*   /*                                                               */
*   /*****************************************************************/
*                                                               03S0577
*   DO;                                                         03S0577
*     RPARM=OPCCKPTF;               /* GET ADDRESS OF TOP OPCE ON THE
*                                      QUEUE FOR CKPT                */
         L     RPARM,OPCCKPTF(,ROPCAVT)                         03S0578
*     IF RPARM->OCCKPENV=ON         /* TEST FOR ENVIRONMENT REQUESTED*/
*       THEN                        /* ENVIRONMENT IS REQUESTED      */
         TM    OCCKPENV(RPARM),B'00010000'                      03S0579
         BNO   @RF00579                                         03S0579
*       DO;                                                     03S0580
*         AVTCKREQ=OFF;             /* RESET INDICATOR THAT AN  03S0581
*                                      ENVIRONMET REQUEST IS ON THE
*                                      QUEUE                         */
*         AVTCKENV=ON;              /* TELL CKPT THAT A 'FORCED'
*                                      ENVIRONMENT IS REQUESTED      */
         OI    AVTCKENV(RAVT),B'00100000'                       03S0582
         NI    AVTCKREQ(RAVT),B'11101111'                       03S0582
*       END;                                                    03S0583
*     IF RPARM->OCCKPINC=ON         /* TEST FOR TYPE OF CKPT REQUEST */
*       THEN                        /* THIS IS AN INCIDENT REQUEST   */
@RF00579 TM    OCCKPINC(RPARM),B'10000000'                      03S0584
         BNO   @RF00584                                         03S0584
*       DO;                                                     03S0585
*         AVTCCQCB=ADDR(AVTCKPQB);  /* QUEUE THE OPERATOR CONTROL
*                                      CKPT REQUEST ELEMENT TO TCAM
*                                      CKPT                          */
         LA    @10,AVTCKPQB(,RAVT)                              03S0586
         STCM  @10,7,AVTCCQCB(RAVT)                             03S0586
*         AVTCCKEY=CREOPC;          /* SET KEY FOR INCIDENT CKPT     */
         MVI   AVTCCKEY(RAVT),X'40'                             03S0587
*       END;                                                    03S0588
*     ELSE                          /* NOT AN INCIDENT REQUEST       */
*       DO;                                                     03S0589
         B     @RC00584                                         03S0589
@RF00584 DS    0H                                               03S0590
*         AVTCCQCB=ADDR(SAVTCKQB);  /* QUEUE THE OPERATOR CONTROL
*                                      CKPT REQUEST ELEMENT TO 3705
*                                      CKPT QUEUE                    */
         L     @10,AVTSAVTP(,RAVT)                              03S0590
         LA    @10,SAVTCKQB(,@10)                               03S0590
         STCM  @10,7,AVTCCQCB(RAVT)                             03S0590
*         IF RPARM->OCCKPNCP=ON     /* TEST TYPE OF REQUEST          */
*           THEN                    /* THIS IS A REQUEST FOR 3705
*                                      CKPT                          */
         TM    OCCKPNCP(RPARM),B'01000000'                      03S0591
         BNO   @RF00591                                         03S0591
*           AVTCCKEY=CRECNCP;       /* SET KEY FOR 3705 CKPT         */
         MVI   AVTCCKEY(RAVT),X'D0'                             03S0592
*         ELSE                      /* NOT 3705 CKPT REQUEST         */
*           IF RPARM->OCCKPRST=ON   /* TEST TYPE OF REQUEST          */
*             THEN                  /* THIS IS A REQUEST FOR 3705
*                                      RESTART                       */
         B     @RC00591                                         03S0593
@RF00591 TM    OCCKPRST(RPARM),B'00100000'                      03S0593
         BNO   @RF00593                                         03S0593
*             AVTCCKEY=CRERNCP;     /* SET KEY FOR 3705 RESTART      */
         MVI   AVTCCKEY(RAVT),X'E0'                             03S0594
*           ELSE                    /* NOT 3705 RESTART => POST 03S0595
*                                      ELEMENT BACK TO THIS MODULE
*                                      FOR REDRIVE                   */
*             AVTCCQCB=ADDR(AVTOPCQB);/* QUEUE THE OPERATOR CONTROL
*                                      CKPT REQUEST ELEMENT TO OPCTL
*                                      TO REDRIVE THIS MODULE        */
         B     @RC00593                                         03S0595
@RF00593 LA    @10,AVTOPCQB(,RAVT)                              03S0595
         STCM  @10,7,AVTCCQCB(RAVT)                             03S0595
*       END;                                                    03S0596
@RC00593 DS    0H                                               03S0596
@RC00591 DS    0H                                               03S0597
*   END;                                                        03S0597
@RC00584 DS    0H                                               03S0598
*   AVTCCPRI=PRIOPCKP;              /* SET PRIORITY                  */
         MVI   AVTCCPRI(RAVT),X'EC'                             02S0598
*   RPARM=ADDR(AVTCRELE);           /* OP CONTROL CKPT REQUEST  02S0599
*                                      ELEMENT IS ELEMENT TO PUT ON
*                                      THE READY QUEUE               */
         LA    RPARM,AVTCRELE(,RAVT)                            02S0599
*   POSTTCAM=ON;                    /* REQUEST POST OF TCAM AFTER
*                                      READY QUEUE UPDATE    @YM05746*/
         OI    POSTTCAM,B'00100000'                             02S0600
*   CALL UPDRDYQ;                   /* REQUEST THAT ELEMENT BE PUT ON
*                                      THE ASYNCHRONOUS READY QUEUE  */
         BAL   @14,UPDRDYQ                                      02S0601
*   END POSTCKPT;                                               02S0602
@EL00002 DS    0H                                               02S0602
@EF00002 DS    0H                                               02S0602
@ER00002 L     @14,@SA00002                                     02S0602
         BR    @14                                              02S0602
*                                                               02S0603
*   /*****************************************************************/
*   /*                                                               */
*   /* QUEUE: THIS SUBROUTINE QUEUES THE ELEMENT ON THE OPERATOR     */
*   /* CONTROL CHECKPOINT QUEUE. IF THIS IS THE ONLY ELEMENT ON THE  */
*   /* QUEUE, THEN THE CHECKPOINT SUBTASK IS POSTED TO PROCESS THE   */
*   /* TOP ELEMENT ON THE QUEUE. OPCE'S ATTACHED TO THE OPCE ARE     */
*   /* PASSED TO THE OP CONTROL DISPATCHER.                          */
*   /*                                                               */
*   /*****************************************************************/
*                                                               02S0603
*QUEUE:                                                         02S0603
*   PROC OPTIONS(RETREG,SAVE(14));                              02S0603
QUEUE    ST    @14,@SA00003                                     02S0603
*   OCLINK=0;                       /* CLEAR THE LINK FIELD IN THE
*                                      CURRENT ELEMENT               */
         SLR   @10,@10                                          02S0604
         ST    @10,OCLINK(,ROPCE)                               02S0604
*   IF OPCCKPTF=0                   /* TEST FOR AN ELEMENT ON THE
*                                      QUEUE FOR CKPT                */
*     THEN                          /* THE QUEUE IS EMPTY            */
         C     @10,OPCCKPTF(,ROPCAVT)                           02S0605
         BNE   @RF00605                                         02S0605
*     DO;                                                       02S0606
*       OPCCKPTF=ROPCE;             /* FIRST ON QUEUE IS THE CURRENT
*                                      ELEMENT                       */
         ST    ROPCE,OPCCKPTF(,ROPCAVT)                         02S0607
*       OPCCKPTL=ROPCE;             /* LAST ON QUEUE IS THE CURRENT
*                                      ELEMEENT                      */
         ST    ROPCE,OPCCKPTL(,ROPCAVT)                         02S0608
*       CALL POSTCKPT;              /* POST THE OP CONTROL REQUEST
*                                      ELEMENT TO CKPT               */
         BAL   @14,POSTCKPT                                     02S0609
*     END;                                                      02S0610
*   ELSE                            /* QUEUE IS NOT EMPTY            */
*     DO;                                                       02S0611
         B     @RC00605                                         02S0611
@RF00605 DS    0H                                               02S0612
*       OPCCKPTL->OCLINK=ROPCE;     /* MAKE LAST ELEMENT ON THE QUEUE
*                                      LINK TO THE CURRENT ELEMENT   */
         L     @10,OPCCKPTL(,ROPCAVT)                           02S0612
         ST    ROPCE,OCLINK(,@10)                               02S0612
*       OPCCKPTL=ROPCE;             /* MAKE CURRENT THE LAST ON THE
*                                      QUEUE                         */
         ST    ROPCE,OPCCKPTL(,ROPCAVT)                         02S0613
*       IF OCCKPENV=ON              /* TEST FOR ENVIRONMENT NEEDED   */
*         THEN                      /* AN ENVIRONMENT CKPT WILL BE
*                                      REQUESTED                     */
         TM    OCCKPENV(ROPCE),B'00010000'                      02S0614
         BNO   @RF00614                                         02S0614
*         AVTCKREQ=ON;              /* INDICATE THAT AN ENV CKPT WILL
*                                      BE REQUESTED                  */
         OI    AVTCKREQ(RAVT),B'00010000'                       02S0615
*     END;                                                      02S0616
@RF00614 DS    0H                                               02S0617
*   IF OCATTACH=ON                  /* TEST FOR OPCE'S ATTACHED 02S0617
*                                                            @YM06958*/
*     THEN                          /* OPCE'S ARE ATTACHED   @YM06958*/
@RC00605 TM    OCATTACH(ROPCE),B'00000010'                      02S0617
         BNO   @RF00617                                         02S0617
*     DO;                           /*                       @YM06958*/
*       OPCNEXT=OCELMPTR;           /* MOVE ATTACHED OPCE'S SO THAT
*                                      THE OP CONTROL DISPATCHER CAN
*                                      PROCESS THEM          @YM06958*/
         L     @10,OCELMPTR-1(,ROPCE)                           02S0619
         LA    @10,0(,@10)                                      02S0619
         ST    @10,OPCNEXT(,ROPCAVT)                            02S0619
*       OCATTACH=OFF;               /* INDICATE THAT NO OPCE'S ARE
*                                      ATTACHED              @YM06958*/
         NI    OCATTACH(ROPCE),B'11111101'                      02S0620
*     END;                          /*                       @YM06958*/
*   OPCMODID=DISPATCH;              /* EXIT TO THE OPCTL DISPATCHER  */
@RF00617 MVC   OPCMODID(2,ROPCAVT),@CC02515                     02S0622
*   REG00=0;                        /* CLEAR FOR ENTRY TO OPCTL 02S0623
*                                      DISPATCHER                    */
         SLR   REG00,REG00                                      02S0623
*   EXITSET=ON;                     /* EXIT PARAMETERS HAVE BEEN SET */
         OI    EXITSET,B'01000000'                              02S0624
*   END QUEUE;                                                  02S0625
@EL00003 DS    0H                                               02S0625
@EF00003 DS    0H                                               02S0625
@ER00003 L     @14,@SA00003                                     02S0625
         BR    @14                                              02S0625
*                                                               02S0626
*   /*****************************************************************/
*   /*                                                               */
*   /* UPDRDYQ: THIS SUBROUTINE PLACES AN ELEMENT ADDRESSED BY RPARM */
*   /* ON THE ASYNCHRONOUS READY QUEUE. IF THE POSTTCAM STATE BIT IS */
*   /* SET, THEN POST THE TCAM MCP'S ECB COMPLETE.                   */
*   /*                                                               */
*   /*****************************************************************/
*                                                               02S0626
*UPDRDYQ:                                                       02S0626
*   PROC OPTIONS(RETREG,SAVE(14));                              02S0626
UPDRDYQ  ST    @14,@SA00004                                     02S0626
*   RFY                                                         02S0627
*     REG15 RSTD;                                               02S0627
*   REG15=CVTAQAVT;                 /* GET ADDRESS OF TCX            */
         L     @10,CVTPTR                                       02S0628
         L     REG15,CVTAQAVT(,@10)                             02S0628
*   REG00=TCXREADY;                 /* GET ADDR OF TOP ELEMENT ON
*                                      ASYNCHRONOUS READY QUEUE      */
         L     REG00,TCXREADY(,REG15)                           02S0629
*AGAIN:                                                         02S0630
*   RPARM->RECBLINK=REG00;          /* LINK CURRENT ELEMENT TO TOP ON
*                                      THE QUEUE                     */
AGAIN    STCM  REG00,7,RECBLINK(RPARM)                          02S0630
*   CS(REG00,RPARM,TCXREADY);       /* UPDATE ASYNCHRONOUS READY
*                                      QUEUE                         */
         CS    REG00,@01,TCXREADY(REG15)                        02S0631
*   BC(7,AGAIN);                    /* IF QUEUE WAS UPDATED     02S0632
*                                      ASYNCHRONOUSLY, TRY AGAIN     */
         BC    7,AGAIN                                          02S0632
*   IF POSTTCAM=ON                  /* TEST FOR REQUEST TO POST TCAM
*                                      MCP'S ECB COMPLETE    @YM05746*/
*     THEN                          /* POST OF TCAM IS REQUESTED
*                                                            @YM05746*/
         TM    POSTTCAM,B'00100000'                             02S0633
         BNO   @RF00633                                         02S0633
*     DO;                           /*                       @YM05746*/
*       GEN NODEFS NOEXIT NOFLOWS REFS(AVTOSECB) SEQFLOW SETS(REG00,
*           RPARM);                                             02S0635
           POST  AVTOSECB(RAVT)    POST TCAM COMPLETE
*     END;                          /*                       @YM05746*/
*   RFY                                                         02S0637
*     REG15 UNRSTD;                                             02S0637
*   END UPDRDYQ;                                                02S0638
@EL00004 DS    0H                                               02S0638
@EF00004 DS    0H                                               02S0638
@ER00004 L     @14,@SA00004                                     02S0638
         BR    @14                                              02S0638
*   END IGC0610D                                                01S0639
*                                                               01S0639
*/* THE FOLLOWING INCLUDE STATEMENTS WERE FOUND IN THIS PROGRAM.     */
*/*%INCLUDE SYSLIB  (TAVTD   )                                       */
*/*%INCLUDE SYSLIB  (TCKPD   )                                       */
*/*%INCLUDE SYSLIB  (CVT     )                                       */
*/*%INCLUDE SYSLIB  (IHADCBDF)                                       */
*/*%INCLUDE SYSLIB  (IHADCB  )                                       */
*/*%INCLUDE SYSLIB  (TDEBD   )                                       */
*/*%INCLUDE SYSLIB  (TNCPID  )                                       */
*/*%INCLUDE SYSLIB  (TOPCED  )                                       */
*/*%INCLUDE SYSLIB  (TOPCAVTD)                                       */
*/*%INCLUDE SYSLIB  (TPRIOR  )                                       */
*/*%INCLUDE SYSLIB  (TRECBD  )                                       */
*/*%INCLUDE SYSLIB  (TTCXD   )                                       */
*/*%INCLUDE SYSLIB  (TTNTD   )                                       */
*/*%INCLUDE SYSLIB  (TTRMD   )                                       */
*/*%INCLUDE SYSUT5  (RFY     )                                       */
*/*%INCLUDE SYSUT5  (DCL     )                                       */
*/*%INCLUDE SYSUT5  (PROLOGUE)                                       */
*/*%INCLUDE SYSUT5  (PROCESS )                                       */
*/*%INCLUDE SYSUT5  (INITIAL )                                       */
*/*%INCLUDE SYSUT5  (RETCKPT )                                       */
*/*%INCLUDE SYSUT5  (HALT    )                                       */
*/*%INCLUDE SYSUT5  (COMMAND )                                       */
*/*%INCLUDE SYSUT5  (MODIFY  )                                       */
*/*%INCLUDE SYSUT5  (ACTDEACT)                                       */
*/*%INCLUDE SYSUT5  (OTHERCMD)                                       */
*/*%INCLUDE SYSUT5  (INVLIST )                                       */
*/*%INCLUDE SYSUT5  (TEST3705)                                       */
*/*%INCLUDE SYSUT5  (FINDLNCP)                                       */
*/*%INCLUDE SYSUT5  (CKOPEN  )                                       */
*/*%INCLUDE SYSUT5  (EPILOGUE)                                       */
*/*%INCLUDE SYSUT5  (POSTCKPT)                                       */
*/*%INCLUDE SYSUT5  (REQTYPE )                                       */
*/*%INCLUDE SYSUT5  (QUEUE   )                                       */
*/*%INCLUDE SYSUT5  (UPDRDYQ )                                       */
*                                                               01S0639
*       ;                                                       01S0639
@DATA    DS    0H
@DATD    DSECT
         DS    0F
@SA00002 DS    1F
@SA00003 DS    1F
@SA00004 DS    1F
IGC0610D CSECT
         DS    0F
@CF00061 DC    F'1'
@CF02324 DC    F'14'
@CF02576 DC    F'-6'
@CF02578 DC    XL4'0000FFFF'
@CF02549 DC    XL4'FFFF'
@DATD    DSECT
         DS    0D
STATES   DS    CL1
         ORG   STATES
TCAMRST  DS    BL1
EXITSET  EQU   STATES+0
POSTTCAM EQU   STATES+0
         ORG   STATES+1
         ORG   *+1-(*-@DATD)/(*-@DATD) INSURE DSECT DATA
@ENDDATD EQU   *
IGC0610D CSECT
         DS    0F
@SIZDATD DC    AL1(0)
         DC    AL3(@ENDDATD-@DATD)
         DS    0D
NUMENT   DC    AL1(10/1)
@CC02515 DC    C'00'
@CC02517 DC    C'07'
@CB02547 DC    X'00000000'
@CB02548 DC    X'00000001'
MODTABLE DS    CL10
         ORG   MODTABLE
@NM00177 DC    X'07'
@NM00178 DC    X'03'
@NM00179 DC    X'11'
@NM00180 DC    X'16'
@NM00181 DC    X'1D'
@NM00182 DC    X'1E'
@NM00183 DC    X'1F'
@NM00184 DC    X'26'
@NM00185 DC    X'A0'
@NM00186 DC    X'90'
         ORG   MODTABLE+10
         DS    CL1
PATCH    DC    XL104'0'
@00      EQU   00                      EQUATES FOR REGISTERS 0-15
@01      EQU   01
@02      EQU   02
@03      EQU   03
@04      EQU   04
@05      EQU   05
@06      EQU   06
@07      EQU   07
@08      EQU   08
@09      EQU   09
@10      EQU   10
@11      EQU   11
@12      EQU   12
@13      EQU   13
@14      EQU   14
@15      EQU   15
COUNT    EQU   @05
ROPCE    EQU   @03
ROPCAVT  EQU   @02
RTRM     EQU   @08
RAVT     EQU   @04
REG15    EQU   @15
REG00    EQU   @00
RPARM    EQU   @01
RDATA    EQU   @11
RBASE    EQU   @12
RSAVE    EQU   @13
REG14    EQU   @14
CVTPTR   EQU   16
IEDQAVTD EQU   0
AVTSAVEX EQU   IEDQAVTD+288
@NM00003 EQU   IEDQAVTD+388
AVTCKFLG EQU   @NM00003
AVTCKTAC EQU   AVTCKFLG
AVTCKNAC EQU   AVTCKFLG
AVTCKENV EQU   AVTCKFLG
AVTCKREQ EQU   AVTCKFLG
AVTCKHLT EQU   AVTCKFLG
AVTBASE  EQU   IEDQAVTD+412
AVTPKF   EQU   AVTBASE
AVTRNMPT EQU   IEDQAVTD+424
AVTOSECB EQU   IEDQAVTD+492
AVTECB1  EQU   AVTOSECB
AVTHG02  EQU   IEDQAVTD+528
AVTDISP  EQU   IEDQAVTD+552
AVTHD    EQU   IEDQAVTD+556
AVTSCOPT EQU   AVTHD
AVTSAVTP EQU   IEDQAVTD+612
AVTSAVTF EQU   AVTSAVTP
AVTVTMCP EQU   AVTSAVTF
AVTCKPEL EQU   IEDQAVTD+652
AVTCKRMV EQU   AVTCKPEL
AVTCKELF EQU   IEDQAVTD+680
AVTCMCPN EQU   AVTCKELF
AVTCKBYT EQU   IEDQAVTD+691
AVTHG01  EQU   IEDQAVTD+692
AVTCKLNK EQU   IEDQAVTD+696
AVTCRELE EQU   IEDQAVTD+708
AVTCCELE EQU   AVTCRELE
AVTCCKEY EQU   AVTCCELE
AVTCCQCB EQU   AVTCCELE+1
AVTCCPRI EQU   AVTCRELE+4
AVTCLRHI EQU   IEDQAVTD+716
AVTADBUF EQU   IEDQAVTD+720
AVTSYSER EQU   IEDQAVTD+728
AVTCKPQB EQU   IEDQAVTD+804
AVTCKPTB EQU   AVTCKPQB
AVTCKPEC EQU   AVTCKPQB+4
AVTCKPCC EQU   AVTCKPEC
AVTOPCQB EQU   IEDQAVTD+816
AVTOPCOB EQU   AVTOPCQB
AVTOPCEC EQU   AVTOPCQB+4
AVTOPCCC EQU   AVTOPCEC
AVTOLTQB EQU   IEDQAVTD+828
AVTCLOSB EQU   IEDQAVTD+852
AVTCWFL1 EQU   IEDQAVTD+924
AVTCWFL2 EQU   IEDQAVTD+925
AVTSUBT  EQU   IEDQAVTD+948
AVTIOTR  EQU   IEDQAVTD+949
AVTBIT1  EQU   IEDQAVTD+1050
AVTBIT2  EQU   IEDQAVTD+1051
AVTBIT3  EQU   IEDQAVTD+1052
AVTSTAIN EQU   AVTBIT3
AVTDDFT  EQU   IEDQAVTD+1064
AVTBIT4  EQU   IEDQAVTD+1136
@NM00085 EQU   IEDQAVTD+1232
IEDQAPTR EQU   0
IEDNSVTD EQU   0
SAVTDIAG EQU   IEDNSVTD
SAVTDIAF EQU   SAVTDIAG
SAVTLUSQ EQU   IEDNSVTD+88
SAVTTCPU EQU   IEDNSVTD+238
SAVTTNTX EQU   IEDNSVTD+252
SAVTZELM EQU   IEDNSVTD+270
SAVTRDRV EQU   IEDNSVTD+284
SAVTCKQB EQU   IEDNSVTD+300
SAVTCKTB EQU   SAVTCKQB
SAVTCKEC EQU   SAVTCKQB+4
SAVTCKCC EQU   SAVTCKEC
IEDQCKPD EQU   0
CKPIOB   EQU   IEDQCKPD+72
CKPIOECB EQU   CKPIOB+4
CKPIOSK  EQU   CKPIOB+32
CKPEXCP  EQU   IEDQCKPD+116
CKPECBL  EQU   IEDQCKPD+120
CKPCNVRT EQU   CKPECBL
CKPIOQL  EQU   IEDQCKPD+132
@NM00108 EQU   CKPIOQL
CKPCTTRB EQU   IEDQCKPD+144
CKPCCWS  EQU   IEDQCKPD+168
CKPTIC   EQU   CKPCCWS+24
CKPRW    EQU   CKPCCWS+32
@NM00111 EQU   IEDQCKPD+208
CKPMSG   EQU   IEDQCKPD+220
CKPMSGTX EQU   CKPMSG+4
CKPMSGTP EQU   CKPMSG+41
CKPCNTLR EQU   IEDQCKPD+288
CKPFLAGS EQU   CKPCNTLR
CKPPRQNO EQU   CKPCNTLR+17
RCKPT    EQU   0
IEDQCDRD EQU   0
CDRTTRLI EQU   IEDQCDRD+9
CDRDATA  EQU   IEDQCDRD+12
IEDQCRED EQU   0
CRELINK  EQU   IEDQCRED+4
CREOFFS  EQU   IEDQCRED+12
CKPREQTB EQU   0
CKPCTFLG EQU   CKPREQTB
CKPNRES  EQU   0
CKPNFLG  EQU   CKPNRES+4
CKPAVT   EQU   0
CVTMAP   EQU   0
CVTDAR   EQU   CVTMAP+72
CVTFLGS1 EQU   CVTDAR
CVTDCB   EQU   CVTMAP+116
CVTIERLC EQU   CVTMAP+144
CVTOPTA  EQU   CVTMAP+182
CVTOPTB  EQU   CVTMAP+183
CVTGTF   EQU   CVTMAP+236
CVTGTFST EQU   CVTGTF
CVTGTFS  EQU   CVTGTFST
CVTSTATE EQU   CVTGTFST
CVTTMODE EQU   CVTGTFST
CVTFORM  EQU   CVTGTFST
CVTAQAVT EQU   CVTMAP+240
CVTTCMFG EQU   CVTAQAVT
CVTVOLM2 EQU   CVTMAP+244
CVTTATA  EQU   CVTVOLM2
CVTTSKS  EQU   CVTTATA
CVTVOLF2 EQU   CVTTSKS
CVTTAT   EQU   CVTTATA+1
CVTATER  EQU   CVTMAP+248
CVTEXT1  EQU   CVTMAP+252
CVTPURG  EQU   CVTMAP+260
CVTQMSG  EQU   CVTMAP+268
CVTDMSR  EQU   CVTMAP+272
CVTRSV37 EQU   CVTDMSR
CVTDMSRF EQU   CVTRSV37
CVTERPV  EQU   CVTMAP+316
CVTINTLA EQU   CVTMAP+320
CVTAPF   EQU   CVTMAP+324
CVTEXT2  EQU   CVTMAP+328
CVTHJES  EQU   CVTMAP+332
CVTPGSIA EQU   CVTMAP+348
CVTA1F1  EQU   CVTMAP+356
CVTSYSK  EQU   CVTMAP+357
CVTVOLM1 EQU   CVTMAP+380
CVTVOLF1 EQU   CVTVOLM1
CVTATMCT EQU   CVTMAP+388
CVTXTNT1 EQU   0
CVTXTNT2 EQU   0
CVTDSSV  EQU   CVTXTNT2
CVTFLGBT EQU   CVTXTNT2+5
CVTQID   EQU   CVTXTNT2+24
CVTSHS   EQU   CVTXTNT2+40
CVTRV400 EQU   CVTXTNT2+52
CVTRV409 EQU   CVTXTNT2+53
CVTATCVT EQU   CVTXTNT2+64
CVTRV429 EQU   CVTXTNT2+84
CVTRV438 EQU   CVTXTNT2+85
CVTRV457 EQU   CVTXTNT2+112
CVTRV466 EQU   CVTXTNT2+113
CVTFIX   EQU   0
CVTRELNO EQU   CVTFIX+252
IHADCB   EQU   0
IHADCS1A EQU   0
DCBBCKUP EQU   IHADCS1A+8
IHADCS2K EQU   0
DCBDUMPD EQU   IHADCS2K
DCBTRSTA EQU   IHADCS2K+5
DCBDSORG EQU   IHADCS2K+6
DCBDSRG2 EQU   DCBDSORG+1
DCBIOBAD EQU   IHADCS2K+8
DCBRNCKD EQU   IHADCS2K+12
DCBEXLST EQU   IHADCS2K+16
IHADCS24 EQU   0
DCBOFLGS EQU   IHADCS24+8
DCBOFLWR EQU   DCBOFLGS
DCBOFOPN EQU   DCBOFLGS
DCBIFLG  EQU   IHADCS24+9
DCBIBPCT EQU   DCBIFLG
DCBMACR  EQU   IHADCS24+10
DCBMACR1 EQU   DCBMACR
DCBMRFE  EQU   DCBMACR1
DCBMRGET EQU   DCBMRFE
DCBMRAPG EQU   DCBMACR1
DCBMRRD  EQU   DCBMRAPG
DCBMRCI  EQU   DCBMACR1
DCBMRMVG EQU   DCBMRCI
DCBMRLCG EQU   DCBMACR1
DCBMRABC EQU   DCBMACR1
DCBMRPT1 EQU   DCBMRABC
DCBMRSBG EQU   DCBMRPT1
DCBMRCRL EQU   DCBMACR1
DCBMRCHK EQU   DCBMRCRL
DCBMRRDX EQU   DCBMRCHK
DCBMRDMG EQU   DCBMACR1
DCBMACR2 EQU   DCBMACR+1
DCBMRPUT EQU   DCBMACR2
DCBMRWRT EQU   DCBMACR2
DCBMRMVP EQU   DCBMACR2
DCBMR5WD EQU   DCBMACR2
DCBMRLDM EQU   DCBMR5WD
DCBMRLCP EQU   DCBMRLDM
DCBMR4WD EQU   DCBMACR2
DCBMRPT2 EQU   DCBMR4WD
DCBMRTMD EQU   DCBMRPT2
DCBMR3WD EQU   DCBMACR2
DCBMRCTL EQU   DCBMR3WD
DCBMRSTK EQU   DCBMRCTL
DCBMR1WD EQU   DCBMACR2
DCBMRSWA EQU   DCBMR1WD
DCBMRDMD EQU   DCBMRSWA
IHADCS25 EQU   0
DCBMACRF EQU   IHADCS25+2
DCBMACF1 EQU   DCBMACRF
DCBMFFE  EQU   DCBMACF1
DCBMFGET EQU   DCBMFFE
DCBMFAPG EQU   DCBMACF1
DCBMFRD  EQU   DCBMFAPG
DCBMFCI  EQU   DCBMACF1
DCBMFMVG EQU   DCBMFCI
DCBMFLCG EQU   DCBMACF1
DCBMFABC EQU   DCBMACF1
DCBMFPT1 EQU   DCBMFABC
DCBMFSBG EQU   DCBMFPT1
DCBMFCRL EQU   DCBMACF1
DCBMFCHK EQU   DCBMFCRL
DCBMFDMG EQU   DCBMACF1
DCBMACF2 EQU   DCBMACRF+1
DCBMFPUT EQU   DCBMACF2
DCBMFWRT EQU   DCBMACF2
DCBMFMVP EQU   DCBMACF2
DCBMF5WD EQU   DCBMACF2
DCBMFLDM EQU   DCBMF5WD
DCBMFLCP EQU   DCBMFLDM
DCBMF4WD EQU   DCBMACF2
DCBMFPT2 EQU   DCBMF4WD
DCBMFTMD EQU   DCBMFPT2
DCBMF3WD EQU   DCBMACF2
DCBMFCTL EQU   DCBMF3WD
DCBMFSTK EQU   DCBMFCTL
DCBMF1WD EQU   DCBMACF2
DCBMFSWA EQU   DCBMF1WD
DCBMFDMD EQU   DCBMFSWA
DCBDEBAD EQU   IHADCS25+4
DCBIFLGS EQU   DCBDEBAD
DCBIFPCT EQU   DCBIFLGS
IHADCS27 EQU   0
DCBGET   EQU   IHADCS27
DCBPUT   EQU   DCBGET
DCBGETA  EQU   DCBPUT+1
IHADCS43 EQU   0
DCBSCTAB EQU   IHADCS43
IEDQDEB  EQU   0
DEBPRF   EQU   IEDQDEB
DEBAPVT  EQU   DEBPRF
DEBNMEXT EQU   IEDQDEB+52
DEBUCBS  EQU   IEDQDEB+68
IEDQDPTR EQU   0
IEDNCP   EQU   0
NCPFLAG1 EQU   IEDNCP+1
NCPCKPT  EQU   IEDNCP+22
IEDQOPCE EQU   0
OCLINK   EQU   IEDQOPCE
OCELEM   EQU   IEDQOPCE+4
OCELMPTR EQU   OCELEM+1
OCUNIT   EQU   IEDQOPCE+8
OCRUDEST EQU   OCUNIT
OCCKPKEY EQU   OCRUDEST
OCSCAN   EQU   OCCKPKEY
OCOPTCDE EQU   IEDQOPCE+12
OCSWITCH EQU   IEDQOPCE+13
OCFLAG   EQU   IEDQOPCE+14
OCTOTE   EQU   OCFLAG
OCATTACH EQU   OCFLAG
@NM00144 EQU   IEDQOPCE+16
OCDEST   EQU   @NM00144
OCREQVAL EQU   OCDEST+1
OCTRMTBL EQU   IEDQOPCE+20
OCLINENO EQU   IEDQOPCE+22
OCTIOT   EQU   OCLINENO
OCTRUNIT EQU   IEDQOPCE+24
OCRSID   EQU   OCTRUNIT
OCALSTAT EQU   OCRSID
OCPARM   EQU   IEDQOPCE+28
OCWTG    EQU   IEDQOPCE+30
OCBACKUP EQU   IEDQOPCE+32
OCMODNME EQU   IEDQOPCE+40
OCIPLWA  EQU   OCMODNME
OCCKDATA EQU   IEDQOPCE+48
OCRSTGTM EQU   OCCKDATA
OCCKPTWA EQU   OCCKDATA+4
IEDQOPCN EQU   0
OCLDNME  EQU   IEDQOPCN
OCLINTTE EQU   OCLDNME
OCREQFLG EQU   OCLINTTE+2
OCADNCP  EQU   OCREQFLG
OCPREFLG EQU   OCLINTTE+3
IEDQOPCD EQU   0
OPCAVTPT EQU   IEDQOPCD+8
OPCCOPCE EQU   IEDQOPCD+12
OPCSAVE  EQU   IEDQOPCD+56
OPCRSAVE EQU   IEDQOPCD+132
OPCWORK  EQU   IEDQOPCD+140
OPCAQCTL EQU   IEDQOPCD+180
OPCXCTL  EQU   IEDQOPCD+204
OPCLDNME EQU   IEDQOPCD+212
OPCMODID EQU   OPCLDNME+3
OPCCKPTF EQU   IEDQOPCD+248
OPCCKPTL EQU   IEDQOPCD+252
OPCHORT  EQU   IEDQOPCD+256
OPCNEXT  EQU   IEDQOPCD+272
OPCSPEC  EQU   IEDQOPCD+300
OPCRSTRT EQU   OPCSPEC
OPCPWCOB EQU   IEDQOPCD+368
OPCPWQCB EQU   OPCPWCOB
OPCPWECB EQU   OPCPWCOB+4
IEDQRECB EQU   0
RECBPRI  EQU   IEDQRECB+4
RECBLINK EQU   IEDQRECB+5
IEDQTCXD EQU   0
TCXATTEN EQU   IEDQTCXD+4
TCXREADY EQU   IEDQTCXD+24
TCXFLAG1 EQU   IEDQTCXD+34
TCXBUFA  EQU   IEDQTCXD+80
TCXDSAVE EQU   IEDQTCXD+104
TCXQE8   EQU   IEDQTCXD+216
TCXPTR   EQU   0
IEDQTNTD EQU   0
IEDQTCDE EQU   IEDQTNTD
IEDQTDCE EQU   IEDQTNTD+46
IEDQNPTR EQU   0
IEDTNTA  EQU   0
IEDTRM   EQU   0
IEDNTRM  EQU   IEDTRM
TRMBYTE4 EQU   IEDNTRM
TRMBYTE3 EQU   IEDNTRM+1
TRMBYTE2 EQU   IEDNTRM+2
TRMINPG  EQU   TRMBYTE2
TRMBYTE1 EQU   IEDNTRM+3
TRMSCPRQ EQU   TRMBYTE1
TRMBYTE0 EQU   IEDNTRM+6
TRMSIBPT EQU   IEDNTRM+7
TRMTYPE  EQU   IEDNTRM+11
IEDQTRM  EQU   IEDTRM+14
TRMSTATE EQU   IEDQTRM
TRMLOG   EQU   TRMSTATE
TRMPREF  EQU   TRMSTATE
TRMINSEQ EQU   IEDQTRM+4
TLISTCNT EQU   TRMINSEQ
TRMOUTSQ EQU   IEDQTRM+6
TLISTEN  EQU   TRMOUTSQ
TRMDSORG EQU   TLISTEN
TRMALTD  EQU   IEDQTRM+8
TRMDEVFL EQU   IEDQTRM+10
TRMSTAT  EQU   IEDQTRM+12
TABENTRY EQU   0
COHORTLK EQU   0
IEDQTL   EQU   0
IEDQTNT  EQU   0
IEDIAP04 EQU   0
DEBSUBR  EQU   0
TNTCODE  EQU   0
TNTDCODE EQU   0
TNTFIRST EQU   0
CKPINIT  EQU   CKPEXCP
CKPTWA   EQU   CKPMSGTX
CKPNCNTL EQU   CKPCNTLR
CKPDATTM EQU   CKPNCNTL+22
CKPNFLDS EQU   CKPEXCP
CKPNSELT EQU   CKPNFLDS+16
CKPOVER  EQU   CKPMSGTP+1
CKPOPNFL EQU   CKPFLAGS
CDRINCFM EQU   CDRTTRLI
CDRCREQR EQU   IEDQCDRD
CDRCKFLG EQU   CDRCREQR
CVTS01   EQU   CVTPGSIA
CVTLPDIA EQU   CVTS01+12
CVTDIRST EQU   CVTLPDIA
CVTSLIDA EQU   CVTS01+24
CVTCTLFG EQU   CVTS01+50
CVTRV210 EQU   CVTS01+424
CVTRV219 EQU   CVTS01+425
CVTRV228 EQU   CVTS01+426
CVTRV237 EQU   CVTS01+427
CVTMFRTR EQU   CVTS01+452
CVTRV262 EQU   CVTS01+468
CVTRV271 EQU   CVTS01+469
CVTRV280 EQU   CVTS01+470
CVTRV289 EQU   CVTS01+471
CVTGSDA  EQU   CVTS01+600
DCBPTR   EQU   NCPCKPT
DEBUCB   EQU   DEBUCBS
DEBDVMOD EQU   DEBUCB
DEBUCBAD EQU   DEBUCB+1
OCCKPKY1 EQU   OCCKPKEY
OCCKPTYP EQU   OCCKPKY1
OCCKPINC EQU   OCCKPTYP
OCCKPNCP EQU   OCCKPTYP
OCCKPRST EQU   OCCKPTYP
OCCKPENV EQU   OCCKPKY1
OCICACTN EQU   OCMODNME
OCICDADR EQU   OCICACTN
OCICTYPE EQU   OCICDADR
OCICSW   EQU   OCICDADR+3
OPCAQWD  EQU   OPCAQCTL
OPCAQWD1 EQU   OPCAQWD
OPCAQWD2 EQU   OPCAQWD+4
OPCAQWD3 EQU   OPCAQWD+8
TRMPRE1  EQU   TRMBYTE4
TRMNCP1  EQU   TRMBYTE4
TRMPRE   EQU   TRMBYTE3
TRMNCP   EQU   TRMBYTE3
TRMPU    EQU   TRMBYTE3
TRMLU    EQU   TRMBYTE3
TRMLINK  EQU   TRMBYTE3
SSTERME  EQU   OCSWITCH
SSTERM1  EQU   SSTERME
SSTERM2  EQU   SSTERME
SSTERM3  EQU   SSTERME
SSTERM4  EQU   SSTERME
CDROPCB  EQU   CDRDATA
CKPMSGPN EQU   CKPMSGTP+6
CKPSLVAL EQU   CKPNSELT
CKPTTRLT EQU   CKPTIC+5
OCCIB    EQU   OCREQVAL
         AGO   .@UNREFD                START UNREFERENCED COMPONENTS
@NM00187 EQU   SSTERME
@NM00176 EQU   TRMLINK
TRMLSTAT EQU   TRMLINK
TRMLINT  EQU   TRMLINK
TRMEPMOD EQU   TRMLINK
TRMLULOG EQU   TRMLU
TRMINERR EQU   TRMLU
TRMLUREQ EQU   TRMLU
TRMSESRQ EQU   TRMLU
TRMTDIFF EQU   TRMLU
TRMLUTM  EQU   TRMLU
TRMLUIT  EQU   TRMLU
TRMAUTO  EQU   TRMLU
TRMPCONT EQU   TRMPU
@NM00175 EQU   TRMPU
TRMNCONT EQU   TRMNCP
TRMQUCKN EQU   TRMNCP
TRMSLOWN EQU   TRMNCP
TRMSYGEN EQU   TRMNCP
TRMNCPCL EQU   TRMNCP
TRMIPLDM EQU   TRMNCP
TRMINOUT EQU   TRMPRE
TRMRDOUT EQU   TRMPRE
TRMNLOUT EQU   TRMPRE
TRMWROUT EQU   TRMPRE
TRMASNXI EQU   TRMPRE
TRMSTMM  EQU   TRMPRE
TRMCMODE EQU   TRMPRE
TRMSTPND EQU   TRMPRE
@NM00174 EQU   TRMNCP1
TRMINOP  EQU   TRMNCP1
TRMLYNCH EQU   TRMPRE1
TRMSPOUT EQU   TRMPRE1
TRMERLCK EQU   TRMPRE1
TRMQNPL  EQU   TRMPRE1
TRMSPACT EQU   TRMPRE1
TRMOCNI  EQU   TRMPRE1
TRMSESSN EQU   TRMPRE1
TRMCONT  EQU   TRMPRE1
OPCAQLST EQU   OPCAQWD3+1
OPCAQRQ3 EQU   OPCAQWD3
OPCAQSEC EQU   OPCAQWD2+1
OPCAQRQ2 EQU   OPCAQWD2
OPCAQFST EQU   OPCAQWD1+1
OPCAQREQ EQU   OPCAQWD1
OCICINAC EQU   OCICSW
@NM00150 EQU   OCICSW
OCICATST EQU   OCICDADR+1
@NM00149 EQU   OCCKPKY1
CVTRV628 EQU   CVTS01+728
CVTRV627 EQU   CVTS01+724
CVTRV626 EQU   CVTS01+720
CVTRV625 EQU   CVTS01+716
CVTRV624 EQU   CVTS01+712
CVTRV623 EQU   CVTS01+708
CVTRV622 EQU   CVTS01+704
CVTRV621 EQU   CVTS01+700
CVTRV620 EQU   CVTS01+696
CVTRV619 EQU   CVTS01+692
CVTRV618 EQU   CVTS01+688
CVTRV617 EQU   CVTS01+684
CVTRV616 EQU   CVTS01+680
CVTRV615 EQU   CVTS01+676
CVTRV614 EQU   CVTS01+672
CVTRV613 EQU   CVTS01+668
CVTTCASP EQU   CVTS01+664
CVT0PT03 EQU   CVTS01+660
CVT0PT0E EQU   CVTS01+656
CVTIRM   EQU   CVTS01+652
CVTCGK   EQU   CVTS01+648
CVTRV607 EQU   CVTS01+644
CVTRV606 EQU   CVTS01+640
CVTRV605 EQU   CVTS01+636
CVTRV604 EQU   CVTS01+632
CVTEFF02 EQU   CVTS01+628
CVTCBBR  EQU   CVTS01+624
CVTSSCR  EQU   CVTS01+620
CVTEVENT EQU   CVTS01+616
CVTCRCA  EQU   CVTS01+612
CVTTPIO  EQU   CVTS01+608
CVTADV   EQU   CVTS01+604
CVTGSDAB EQU   CVTGSDA
CVTQV3   EQU   CVTS01+596
CVTQV2   EQU   CVTS01+592
CVTQV1   EQU   CVTS01+588
CVTRPT   EQU   CVTS01+584
CVTSSRB  EQU   CVTS01+580
CVTCSDRL EQU   CVTS01+576
CVTEXP1  EQU   CVTS01+572
CVTRMPMT EQU   CVTS01+568
CVTRMPTT EQU   CVTS01+564
CVTVPSA  EQU   CVTS01+560
CVTVSTOP EQU   CVTS01+556
CVTGTFR8 EQU   CVTS01+552
CVTQUIT  EQU   CVTS01+548
CVTVACR  EQU   CVTS01+544
CVTWTCB  EQU   CVTS01+540
CVTSTPRS EQU   CVTS01+536
CVT0PT02 EQU   CVTS01+532
CVTDARCM EQU   CVTS01+528
CVTIRECM EQU   CVTS01+524
CVTJRECM EQU   CVTS01+520
CVTVEMS0 EQU   CVTS01+516
CVTSPFRR EQU   CVTS01+512
CVTRLSTG EQU   CVTS01+508
CVT0TC0A EQU   CVTS01+504
CVTGMBR  EQU   CVTS01+500
CVTLFRM  EQU   CVTS01+496
CVTRMBR  EQU   CVTS01+492
CVTVIOP  EQU   CVTS01+488
CVTRV307 EQU   CVTS01+486
CVTRV306 EQU   CVTS01+484
CVTRV305 EQU   CVTS01+482
CVTRV304 EQU   CVTS01+480
CVTRV303 EQU   CVTS01+478
CVTRV302 EQU   CVTS01+476
CVTTRCA  EQU   CVTS01+472
CVTRV297 EQU   CVTRV289
CVTRV296 EQU   CVTRV289
CVTRV295 EQU   CVTRV289
CVTRV294 EQU   CVTRV289
CVTRV293 EQU   CVTRV289
CVTRV292 EQU   CVTRV289
CVTRV291 EQU   CVTRV289
CVTRV290 EQU   CVTRV289
CVTRV288 EQU   CVTRV280
CVTRV287 EQU   CVTRV280
CVTRV286 EQU   CVTRV280
CVTRV285 EQU   CVTRV280
CVTRV284 EQU   CVTRV280
CVTRV283 EQU   CVTRV280
CVTRV282 EQU   CVTRV280
CVTRV281 EQU   CVTRV280
CVTRV279 EQU   CVTRV271
CVTRV278 EQU   CVTRV271
CVTRV277 EQU   CVTRV271
CVTRV276 EQU   CVTRV271
CVTRV275 EQU   CVTRV271
CVTRV274 EQU   CVTRV271
CVTRV273 EQU   CVTRV271
CVTRV272 EQU   CVTRV271
CVTRV270 EQU   CVTRV262
CVTRV269 EQU   CVTRV262
CVTRV268 EQU   CVTRV262
CVTRV267 EQU   CVTRV262
CVTRV266 EQU   CVTRV262
CVTRV265 EQU   CVTRV262
CVTRV264 EQU   CVTRV262
CVTRV263 EQU   CVTRV262
CVTVFP   EQU   CVTS01+464
CVTVSI   EQU   CVTS01+460
CVTVPSIB EQU   CVTS01+456
CVTMFACT EQU   CVTMFRTR
CVTMFCTL EQU   CVTS01+448
CVTPVBP  EQU   CVTS01+444
CVTPWI   EQU   CVTS01+440
CVTRV254 EQU   CVTS01+438
CVTRV253 EQU   CVTS01+436
CVTRV252 EQU   CVTS01+434
CVTRV251 EQU   CVTS01+433
CVTRV250 EQU   CVTS01+432
CVTRV249 EQU   CVTS01+431
CVTRV248 EQU   CVTS01+430
CVTRV247 EQU   CVTS01+429
CVTRV246 EQU   CVTS01+428
CVTRV245 EQU   CVTRV237
CVTRV244 EQU   CVTRV237
CVTRV243 EQU   CVTRV237
CVTRV242 EQU   CVTRV237
CVTRV241 EQU   CVTRV237
CVTRV240 EQU   CVTRV237
CVTRV239 EQU   CVTRV237
CVTRV238 EQU   CVTRV237
CVTRV236 EQU   CVTRV228
CVTRV235 EQU   CVTRV228
CVTRV234 EQU   CVTRV228
CVTRV233 EQU   CVTRV228
CVTRV232 EQU   CVTRV228
CVTRV231 EQU   CVTRV228
CVTRV230 EQU   CVTRV228
CVTRV229 EQU   CVTRV228
CVTRV227 EQU   CVTRV219
CVTRV226 EQU   CVTRV219
CVTRV225 EQU   CVTRV219
CVTRV224 EQU   CVTRV219
CVTRV223 EQU   CVTRV219
CVTRV222 EQU   CVTRV219
CVTRV221 EQU   CVTRV219
CVTRV220 EQU   CVTRV219
CVTRV218 EQU   CVTRV210
CVTRV217 EQU   CVTRV210
CVTRV216 EQU   CVTRV210
CVTRV215 EQU   CVTRV210
CVTRV214 EQU   CVTRV210
CVTRV213 EQU   CVTRV210
CVTRV212 EQU   CVTRV210
CVTRV211 EQU   CVTRV210
CVTLCCAT EQU   CVTS01+420
CVTPCCAT EQU   CVTS01+416
CVTIPCRP EQU   CVTS01+412
CVTIPCRI EQU   CVTS01+408
CVTIPCDS EQU   CVTS01+404
CVTAIDVT EQU   CVTS01+400
CVTSSAP  EQU   CVTS01+396
CVTEHCIR EQU   CVTS01+392
CVTEHDEF EQU   CVTS01+388
CVTDAIR  EQU   CVTS01+384
CVTPERFM EQU   CVTS01+380
CVT044R2 EQU   CVTS01+376
CVTFETCH EQU   CVTS01+372
CVTRSTWD EQU   CVTS01+368
CVTSPOST EQU   CVTS01+364
CVTIOBP  EQU   CVTS01+360
CVTASMVT EQU   CVTS01+356
CVTRECRQ EQU   CVTS01+352
CVTWSAC  EQU   CVTS01+348
CVTRV149 EQU   CVTS01+344
CVTWSAL  EQU   CVTS01+340
CVTSPSA  EQU   CVTS01+336
CVTGLMN  EQU   CVTS01+332
CVTVEAC0 EQU   CVTS01+328
CVT062R1 EQU   CVTS01+324
CVTRPOST EQU   CVTS01+320
CVTDQIQE EQU   CVTS01+316
CVTCSD   EQU   CVTS01+312
CVTLKRMA EQU   CVTS01+308
CVTRSPIE EQU   CVTS01+304
CVTRENQ  EQU   CVTS01+300
CVTLQCB  EQU   CVTS01+296
CVTFQCB  EQU   CVTS01+292
CVTQCS01 EQU   CVTS01+288
CVTAPFT  EQU   CVTS01+284
CVTPARRL EQU   CVTS01+280
CVTVWAIT EQU   CVTS01+276
CVTGSPL  EQU   CVTS01+272
CVTLSMQ  EQU   CVTS01+268
CVTGSMQ  EQU   CVTS01+264
CVTEXPRO EQU   CVTS01+260
CVTOPCTP EQU   CVTS01+256
CVTSIC   EQU   CVTS01+252
CVTTPIOS EQU   CVTS01+248
CVTRTMS  EQU   CVTS01+244
CVTSDBF  EQU   CVTS01+240
CVTSCBP  EQU   CVTS01+236
CVTSDMP  EQU   CVTS01+232
CVTSV60  EQU   CVTS01+228
CVTRTMCT EQU   CVTS01+224
CVTASCBL EQU   CVTS01+220
CVTASCBH EQU   CVTS01+216
CVTGDA   EQU   CVTS01+212
CVTASVT  EQU   CVTS01+208
CVTVVMDI EQU   CVTS01+204
CVTAQTOP EQU   CVTS01+200
CVTIOSCS EQU   CVTS01+196
CVTSDRM  EQU   CVTS01+192
CVTOPTE  EQU   CVTS01+188
CVTSTXU  EQU   CVTS01+184
CVTQUIS  EQU   CVTS01+180
CVTPARS  EQU   CVTS01+176
CVTS1EE  EQU   CVTS01+172
CVTFRAS  EQU   CVTS01+168
CVTQSAS  EQU   CVTS01+164
CVTCRAS  EQU   CVTS01+160
CVTCRMN  EQU   CVTS01+156
CVTDELCP EQU   CVTS01+152
CVTFRECL EQU   CVTS01+148
CVTGETCL EQU   CVTS01+144
CVTBLDCP EQU   CVTS01+140
CVTAUTHL EQU   CVTS01+136
CVTSCAN  EQU   CVTS01+132
CVTRV144 EQU   CVTS01+130
CVTMAXMP EQU   CVTS01+128
CVTSTCK  EQU   CVTS01+124
CVTRV139 EQU   CVTS01+123
CVTDSSAC EQU   CVTS01+122
CVTRV513 EQU   CVTS01+121
CVTIOSPL EQU   CVTS01+120
CVTPTGT  EQU   CVTS01+116
CVTCSPIE EQU   CVTS01+112
CVTSMFEX EQU   CVTS01+108
CVTOLT0A EQU   CVTS01+104
CVTSRBRT EQU   CVTS01+100
CVTPUTL  EQU   CVTS01+96
CVTASCRL EQU   CVTS01+92
CVTASCRF EQU   CVTS01+88
CVTRV326 EQU   CVTS01+84
CVTRV325 EQU   CVTS01+80
CVTRV324 EQU   CVTS01+76
CVT0VL01 EQU   CVTS01+72
CVTSHRVM EQU   CVTS01+68
CVTRV332 EQU   CVTS01+64
CVTTAS   EQU   CVTS01+60
CVTRSCN  EQU   CVTS01+56
CVTTRAC2 EQU   CVTS01+54
CVTTRACE EQU   CVTS01+52
CVTAPG   EQU   CVTS01+51
CVTSDTRC EQU   CVTCTLFG
CVTGTRCE EQU   CVTCTLFG
CVTNOMP  EQU   CVTCTLFG
CVTRSV79 EQU   CVTCTLFG
CVTDSTAT EQU   CVTCTLFG
CVTRSV78 EQU   CVTCTLFG
CVTRV333 EQU   CVTCTLFG
CVTRV323 EQU   CVTCTLFG
CVTSPVLK EQU   CVTS01+49
CVTRSV77 EQU   CVTS01+48
CVTRV331 EQU   CVTS01+44
CVTRV330 EQU   CVTS01+40
CVTRV329 EQU   CVTS01+36
CVTRV328 EQU   CVTS01+32
CVTRV322 EQU   CVTS01+28
CVTSLID  EQU   CVTSLIDA+1
CVTSYLK  EQU   CVTSLIDA
CVTRV321 EQU   CVTS01+20
CVTRV320 EQU   CVTS01+16
CVTLPDIR EQU   CVTLPDIA+1
CVTRSV69 EQU   CVTDIRST
CVTRSV68 EQU   CVTDIRST
CVTRSV67 EQU   CVTDIRST
CVTRSV66 EQU   CVTDIRST
CVTRSV65 EQU   CVTDIRST
CVTRSV64 EQU   CVTDIRST
CVTRSV63 EQU   CVTDIRST
CVTDICOM EQU   CVTDIRST
CVTPVTP  EQU   CVTS01+8
CVTLPDSR EQU   CVTS01+4
CVTGETL  EQU   CVTS01
CDRCKOPT EQU   CDRCREQR+41
CDRCKPQB EQU   CDRCREQR+38
CDRCKQCB EQU   CDRCREQR+17
CDRCKQBC EQU   CDRCREQR+14
CDRCKMSG EQU   CDRCREQR+12
CDRCKOFF EQU   CDRCREQR+10
@NM00125 EQU   CDRCREQR+9
@NM00124 EQU   CDRCREQR+8
CDRCKOUT EQU   CDRCREQR+6
CDRCKIN  EQU   CDRCREQR+4
@NM00123 EQU   CDRCREQR+1
CDRCKRNC EQU   CDRCKFLG
CDROPTN  EQU   CDRINCFM+7
CDRSEQOU EQU   CDRINCFM+5
CDRSEQIN EQU   CDRINCFM+3
CDROFFS  EQU   CDRINCFM+1
CDRSTAT  EQU   CDRINCFM
@NM00122 EQU   CKPOPNFL
CKPOPNCR EQU   CKPOPNFL
CKPOPNIN EQU   CKPOPNFL
CKPOPNEN EQU   CKPOPNFL
@NM00121 EQU   CKPOPNFL
CKPTRKSA EQU   CKPOVER+4
CKPTRKLN EQU   CKPOVER+2
CKPRCDSR EQU   CKPOVER
CKPNRSID EQU   CKPNFLDS+22
CKPNTRK  EQU   CKPNFLDS+20
CKPSLNEW EQU   CKPNSELT+1
CKPCUSEL EQU   CKPNSELT
CKPNDEVF EQU   CKPNFLDS+12
CKPNTTE  EQU   CKPNFLDS+8
CKPENCDE EQU   CKPNFLDS+7
@NM00120 EQU   CKPNFLDS
CKPBCKUP EQU   CKPNCNTL+30
CKPTIME  EQU   CKPDATTM+4
CKPDATE  EQU   CKPDATTM
@NM00119 EQU   CKPNCNTL+21
CKPBLKPT EQU   CKPNCNTL+20
@NM00118 EQU   CKPNCNTL+18
CKPTRKCN EQU   CKPNCNTL+16
@NM00117 EQU   CKPNCNTL+14
CKPBLKSZ EQU   CKPNCNTL+12
CKPIPLTX EQU   CKPNCNTL+4
CKPSWTCH EQU   CKPNCNTL+3
CKPTRSTA EQU   CKPNCNTL+2
@NM00116 EQU   CKPNCNTL
CKPTRMAD EQU   CKPTWA+60
CKPSAVE2 EQU   CKPTWA
CKPCTTRA EQU   CKPINIT+24
@NM00115 EQU   CKPINIT+22
CKPIPERE EQU   CKPINIT+20
CKPDATIM EQU   CKPINIT+12
CKPCTTRC EQU   CKPINIT+8
CKPDATLN EQU   CKPINIT+6
CKPKEYLN EQU   CKPINIT+5
CKPRCDNO EQU   CKPINIT+4
CKPHEDNO EQU   CKPINIT+2
CKPCYLNO EQU   CKPINIT
TRMOPT   EQU   IEDTRM+34
TRMOPTBL EQU   IEDQTRM+18
TRMOPNO  EQU   IEDQTRM+17
TRMCHCIN EQU   IEDQTRM+16
TRMSENSE EQU   TRMSTAT+3
TRMTEMPR EQU   TRMSTAT+2
TRMSIO   EQU   TRMSTAT
@NM00173 EQU   TRMDEVFL+1
TRMTPIN  EQU   TRMDEVFL+1
TRMNCPI  EQU   TRMDEVFL+1
TRMRNTRM EQU   TRMDEVFL+1
@NM00172 EQU   TRMDEVFL+1
TRMLMD   EQU   TRMDEVFL+1
TRMCONC  EQU   TRMDEVFL+1
TRMTSOB  EQU   TRMDEVFL
TRMBFDY  EQU   TRMDEVFL
TRMTBLK  EQU   TRMDEVFL
TRMSBLK  EQU   TRMDEVFL
TRMBLKS  EQU   TRMDEVFL
TRMADDC  EQU   TRMDEVFL
TRMDDIG  EQU   TRMDEVFL
TRMBUFS  EQU   TRMDEVFL
TRMPRILK EQU   TRMALTD
TRMLGB   EQU   TRMDSORG
TRMUTERM EQU   TLISTCNT
TRMDESTQ EQU   IEDQTRM+1
TRMSCNYN EQU   TRMSTATE
TRMOPTFN EQU   TRMSTATE
TRMHELDN EQU   TRMSTATE
TRMACPTN EQU   TRMSTATE
TRMPROC  EQU   TRMLOG
TRMLIST  EQU   TRMLOG
TRMLINE  EQU   TRMSTATE
TRMSUBST EQU   IEDNTRM+12
TRMRLMCT EQU   IEDNTRM+10
TRMCOHTG EQU   TRMSIBPT+1
TRMGPCNT EQU   TRMSIBPT
TRMBUFRD EQU   TRMBYTE0
TRMSNA   EQU   TRMBYTE0
TRMGP    EQU   TRMBYTE0
TRMDIAL  EQU   TRMBYTE0
@NM00171 EQU   TRMBYTE0
TRMOUTPT EQU   TRMBYTE0
TRMINPUT EQU   TRMBYTE0
TRMUDEF  EQU   TRMBYTE0
TRMCOHRT EQU   IEDNTRM+4
TRMSTOTE EQU   TRMBYTE1
TRMCKPRN EQU   TRMBYTE1
TRMTSATN EQU   TRMBYTE1
TRMTRACE EQU   TRMBYTE1
TRMSWBCK EQU   TRMBYTE1
TRMAUTOC EQU   TRMBYTE1
TRMINPTP EQU   TRMBYTE1
TRMWTNEG EQU   TRMSCPRQ
TRMWRBRK EQU   TRMBYTE2
TRMNOSND EQU   TRMBYTE2
TRMPREP  EQU   TRMBYTE2
TRMGPACT EQU   TRMBYTE2
TRMANDL  EQU   TRMBYTE2
TRMCLOSN EQU   TRMINPG
TRMREMB  EQU   TRMBYTE2
TRMRSACT EQU   TRMBYTE2
TNTTRMAD EQU   IEDTNTA
TNTLEN   EQU   IEDQTNTD+44
TNTMIDEN EQU   IEDQTNTD+41
TNTENLEN EQU   IEDQTNTD+40
TNTSRCHX EQU   IEDQTNTD+38
TCXEND   EQU   IEDQTCXD+224
TCXNCPIO EQU   IEDQTCXD+220
TCXACTE8 EQU   TCXQE8
TCXABEPL EQU   IEDQTCXD+212
TCXSRBS  EQU   IEDQTCXD+208
TCXSIOSB EQU   IEDQTCXD+204
TCXESAVE EQU   IEDQTCXD+132
TCXERPPM EQU   IEDQTCXD+128
TCXERPSV EQU   IEDQTCXD+116
TCXSATTN EQU   IEDQTCXD+112
@NM00170 EQU   TCXDSAVE+4
@NM00169 EQU   TCXDSAVE
TCXPLCB  EQU   IEDQTCXD+100
TCXBITS  EQU   IEDQTCXD+98
TCXSCBSZ EQU   IEDQTCXD+97
TCXBIT1  EQU   IEDQTCXD+96
TCXCOMPT EQU   IEDQTCXD+92
TCXAVAIL EQU   IEDQTCXD+88
TCXBUFL  EQU   IEDQTCXD+84
TCXTOTE  EQU   TCXBUFA
TCXCKPM  EQU   IEDQTCXD+79
TCXNCKPR EQU   IEDQTCXD+78
TCXSZAIB EQU   IEDQTCXD+76
TCXAIBC  EQU   IEDQTCXD+72
TCXPEBC  EQU   IEDQTCXD+68
TCXPEWAC EQU   IEDQTCXD+64
TCXQRQ   EQU   IEDQTCXD+60
TCXOCQ   EQU   IEDQTCXD+56
TCXPNTQ  EQU   IEDQTCXD+52
TCXPUTQ  EQU   IEDQTCXD+48
TCXGETQ  EQU   IEDQTCXD+44
TCXTSI   EQU   IEDQTCXD+40
TCXRPT   EQU   IEDQTCXD+36
TCXCC3TS EQU   IEDQTCXD+35
TCXAPDMP EQU   TCXFLAG1
TCXAPPL  EQU   TCXFLAG1
TCXRTM   EQU   TCXFLAG1
TCXMCPCD EQU   TCXFLAG1
TCXAUTH  EQU   TCXFLAG1
TCXASID  EQU   IEDQTCXD+32
TCXASCB  EQU   IEDQTCXD+28
TCXPASWD EQU   IEDQTCXD+16
TCXDISP  EQU   IEDQTCXD+12
TCXTCB   EQU   IEDQTCXD+8
TCXATTLN EQU   TCXATTEN
TCXAVT   EQU   IEDQTCXD
RECBQCBA EQU   IEDQRECB+1
RECBKEY  EQU   IEDQRECB
OPCBOTTM EQU   IEDQOPCD+1184
@NM00168 EQU   IEDQOPCD+1100
@NM00167 EQU   IEDQOPCD+948
@NM00166 EQU   IEDQOPCD+940
@NM00165 EQU   IEDQOPCD+380
@NM00164 EQU   OPCPWCOB+9
@NM00163 EQU   OPCPWCOB+8
@NM00162 EQU   OPCPWECB+1
OPCPWCCC EQU   OPCPWECB
OPCPWCHN EQU   OPCPWQCB+1
OPCPWVTO EQU   OPCPWQCB
OPCWAITV EQU   IEDQOPCD+364
OPCTOTCK EQU   IEDQOPCD+360
OPCAPXTL EQU   IEDQOPCD+356
OPCDECR  EQU   IEDQOPCD+352
OPCBUFWT EQU   IEDQOPCD+348
OPCWRKSP EQU   IEDQOPCD+320
OPCADGOT EQU   IEDQOPCD+318
OPCRQCNT EQU   IEDQOPCD+316
OPPOLSTP EQU   IEDQOPCD+312
OPCCKCIB EQU   IEDQOPCD+308
OPCEND   EQU   IEDQOPCD+307
OPCSTCBS EQU   IEDQOPCD+306
OPCHNEND EQU   IEDQOPCD+302
OPCOQSW  EQU   IEDQOPCD+301
@NM00161 EQU   OPCSPEC
@NM00160 EQU   OPCSPEC
@NM00159 EQU   OPCSPEC
@NM00158 EQU   OPCSPEC
OPCFRMCA EQU   OPCSPEC
OPCPART  EQU   OPCSPEC
OPCALTD  EQU   OPCSPEC
OPCBFEND EQU   IEDQOPCD+296
OPCBFIRS EQU   IEDQOPCD+292
OPCAVBUF EQU   IEDQOPCD+290
OPCIPLCT EQU   IEDQOPCD+289
OPCCLNTS EQU   IEDQOPCD+288
OPCHA8   EQU   IEDQOPCD+286
OPCBFREQ EQU   IEDQOPCD+284
OPCFREBF EQU   IEDQOPCD+280
OPCGETBF EQU   IEDQOPCD+276
OPCFMDFC EQU   IEDQOPCD+268
OPCSCNC  EQU   IEDQOPCD+264
OPCHORTG EQU   IEDQOPCD+260
OPCWAITA EQU   IEDQOPCD+244
OPCWAITR EQU   IEDQOPCD+240
OPCWAITP EQU   IEDQOPCD+236
OPCWAITO EQU   IEDQOPCD+232
OPCWAITN EQU   IEDQOPCD+228
OPCWAITL EQU   IEDQOPCD+224
OPCWAITC EQU   IEDQOPCD+220
@NM00157 EQU   OPCLDNME+5
@NM00156 EQU   OPCLDNME
OPCWAIT  EQU   IEDQOPCD+192
OPCCKERB EQU   IEDQOPCD+164
OPCBFERB EQU   IEDQOPCD+148
OPCFLAG2 EQU   IEDQOPCD+147
OPCFLAG1 EQU   IEDQOPCD+146
OPCWRKSZ EQU   IEDQOPCD+144
OPCQCBAD EQU   IEDQOPCD+128
OPCTRMWA EQU   IEDQOPCD+52
OPCPSTWT EQU   IEDQOPCD+48
OPCTNTEA EQU   IEDQOPCD+44
OPCPGCK  EQU   IEDQOPCD+40
OPCLCB   EQU   IEDQOPCD+36
@NM00155 EQU   IEDQOPCD+32
OPCIPLAD EQU   IEDQOPCD+28
OPCTOFLK EQU   IEDQOPCD+24
OPCOPTLK EQU   IEDQOPCD+20
OPCDCBLK EQU   IEDQOPCD+16
OPCDOUBL EQU   IEDQOPCD
@NM00154 EQU   OCLDNME+4
@NM00153 EQU   OCPREFLG
OCTOTEP  EQU   OCPREFLG
OCREPOST EQU   OCPREFLG
OCRSPSNT EQU   OCPREFLG
OCBFREQ  EQU   OCPREFLG
OCIDLE   EQU   OCREQFLG
OCFORCE  EQU   OCREQFLG
OCDCARD  EQU   OCREQFLG
OCPARTAL EQU   OCREQFLG
@NM00152 EQU   OCREQFLG
@NM00151 EQU   OCREQFLG
OCFLUSHZ EQU   OCREQFLG
OCRESPCT EQU   OCLINTTE
@NM00148 EQU   OCRSTGTM+2
OCCKDAT2 EQU   OCRSTGTM+1
OCCKDAT1 EQU   OCRSTGTM
OCPTRSAV EQU   OCMODNME+4
OCPUADR  EQU   OCIPLWA+2
OCWTGSAV EQU   OCIPLWA
OCDVRDCT EQU   OCBACKUP+6
OCNCP    EQU   OCBACKUP+4
OCBUFGOT EQU   OCBACKUP+2
OCBUFNED EQU   OCBACKUP
OCRESNUM EQU   OCPARM
OCSEQ    EQU   OCTRUNIT+2
@NM00147 EQU   OCRSID+1
OCNONE   EQU   OCALSTAT
OCSOME   EQU   OCALSTAT
OCALLFLG EQU   OCALSTAT
OCACTREQ EQU   OCALSTAT
OCREDRVE EQU   OCALSTAT
OCSEQIND EQU   OCALSTAT
@NM00146 EQU   OCALSTAT
OCRENTRD EQU   OCALSTAT
OCWTGB   EQU   OCTIOT
@NM00145 EQU   @NM00144+2
OCCONID  EQU   OCDEST
OCRLN    EQU   IEDQOPCE+15
OCRESP   EQU   OCFLAG
OCSSCP   EQU   OCFLAG
OCOUTPUT EQU   OCFLAG
OCLINE   EQU   OCFLAG
OCMPP    EQU   OCFLAG
OCCONSOL EQU   OCFLAG
@NM00143 EQU   OCSWITCH
OCQUCKN  EQU   OCSWITCH
OCPRIFLG EQU   OCOPTCDE
@NM00142 EQU   OCRUDEST+1
@NM00141 EQU   OCSCAN
OCNOTUCB EQU   OCSCAN
OCNONAME EQU   OCSCAN
OCALLRLN EQU   OCSCAN
OCDDNAME EQU   OCSCAN
OCDDNRLN EQU   OCSCAN
OCADDR   EQU   OCSCAN
OCELMPRI EQU   OCELEM
NCPLTRAC EQU   IEDNCP+26
NCPDPDCB EQU   IEDNCP+18
NCPTXID  EQU   IEDNCP+10
NCPBKUPN EQU   IEDNCP+2
@NM00140 EQU   NCPFLAG1
NCPTRACE EQU   NCPFLAG1
NCPBKUP  EQU   NCPFLAG1
NCPIPLD  EQU   NCPFLAG1
NCPREST  EQU   NCPFLAG1
NCPBGUP  EQU   NCPFLAG1
NCPDAUTO EQU   NCPFLAG1
NCPIAUTO EQU   NCPFLAG1
NCPLEN   EQU   IEDNCP
DEBAPPAD EQU   IEDQDEB+65
DEBEXSCL EQU   IEDQDEB+64
DEBDCBAD EQU   IEDQDEB+61
DEBPROTG EQU   IEDQDEB+60
DEBECBAD EQU   IEDQDEB+57
DEBPRIOR EQU   IEDQDEB+56
DEBUSRPG EQU   IEDQDEB+53
DEBSYSPG EQU   IEDQDEB+49
DEBOPATB EQU   IEDQDEB+48
DEBIRBAD EQU   IEDQDEB+45
DEBOFLGS EQU   IEDQDEB+44
DEBDEBAD EQU   IEDQDEB+41
DEBAMLNG EQU   IEDQDEB+40
DEBTCBAD EQU   IEDQDEB+37
DEBNMSUB EQU   IEDQDEB+36
@NM00139 EQU   DEBPRF+33
DEBLNGTH EQU   DEBPRF+32
DEBDCBMK EQU   DEBPRF+28
DEBDSCBA EQU   DEBPRF+21
DEBWKARA EQU   DEBPRF+20
DEBXCEA  EQU   DEBAPVT+16
DEBCEA   EQU   DEBAPVT+12
DEBPCIA  EQU   DEBAPVT+8
DEBSIOA  EQU   DEBAPVT+4
DEBEOEA  EQU   DEBAPVT
DCBBUFSI EQU   IHADCS43+6
DCBUNTCT EQU   IHADCS43+5
DCBILCT  EQU   IHADCS43+4
DCBSCTAD EQU   DCBSCTAB+1
@NM00138 EQU   DCBSCTAB
DCBPUTA  EQU   DCBGETA
@NM00137 EQU   DCBPUT
DCBDEBA  EQU   DCBDEBAD+1
@NM00136 EQU   DCBIFLGS
DCBIFIOE EQU   DCBIFLGS
DCBCH12  EQU   DCBIFPCT
DCBCH9   EQU   DCBIFPCT
DCBIFEC  EQU   DCBIFLGS
DCBMFSTI EQU   DCBMFDMD
DCBMFAWR EQU   DCBMFSTK
DCBMFUIP EQU   DCBMFTMD
DCBMFIDW EQU   DCBMFLCP
DCBMFWRK EQU   DCBMFMVP
DCBMFRDQ EQU   DCBMFWRT
DCBMFGTQ EQU   DCBMFPUT
DCBMFSTL EQU   DCBMACF2
DCBMFCK  EQU   DCBMFDMG
DCBMFRDX EQU   DCBMFCHK
DCBMFDBF EQU   DCBMFSBG
DCBMFRDI EQU   DCBMFLCG
DCBMFRDK EQU   DCBMFMVG
DCBMFWRQ EQU   DCBMFRD
DCBMFPTQ EQU   DCBMFGET
DCBMFECP EQU   DCBMACF1
DCBTIOT  EQU   IHADCS25
DCBMRSTI EQU   DCBMRDMD
DCBMRAWR EQU   DCBMRSTK
DCBMRUIP EQU   DCBMRTMD
DCBMRIDW EQU   DCBMRLCP
DCBMRWRK EQU   DCBMRMVP
DCBMRRDQ EQU   DCBMRWRT
DCBMRGTQ EQU   DCBMRPUT
DCBMRSTL EQU   DCBMACR2
DCBMRCK  EQU   DCBMRDMG
DCBPGFXA EQU   DCBMRRDX
DCBMRDBF EQU   DCBMRSBG
DCBMRRDI EQU   DCBMRLCG
DCBMRRDK EQU   DCBMRMVG
DCBMRWRQ EQU   DCBMRRD
DCBMRPTQ EQU   DCBMRGET
DCBMRECP EQU   DCBMACR1
@NM00135 EQU   DCBIFLG
DCBIBIOE EQU   DCBIFLG
DCBICH12 EQU   DCBIBPCT
DCBICH9  EQU   DCBIBPCT
DCBIBEC  EQU   DCBIFLG
DCBOFIOF EQU   DCBOFLGS
DCBOFUEX EQU   DCBOFLGS
DCBOFTM  EQU   DCBOFLGS
DCBOFPPC EQU   DCBOFLGS
DCBOFEOV EQU   DCBOFLGS
DCBOFLRB EQU   DCBOFLGS
DCBOFIOD EQU   DCBOFLWR
DCBDDNAM EQU   IHADCS24
DCBEXLSA EQU   DCBEXLST+1
DCBEIOBX EQU   DCBEXLST
DCBRNCKA EQU   DCBRNCKD+1
@NM00134 EQU   DCBRNCKD
DCBDSGTR EQU   DCBDSRG2
@NM00133 EQU   DCBDSRG2
DCBDSRG1 EQU   DCBDSORG
DCBCHNGL EQU   DCBTRSTA
DCBNIDLE EQU   DCBTRSTA
DCBBAKUP EQU   DCBTRSTA
DCBIPLED EQU   DCBTRSTA
DCBRSTRT EQU   DCBTRSTA
DCBINITL EQU   DCBTRSTA
DCBAUTOD EQU   DCBTRSTA
DCBAUTOI EQU   DCBTRSTA
@NM00132 EQU   IHADCS2K+4
DCBDUMPA EQU   DCBDUMPD+1
DCBUNITN EQU   DCBDUMPD
DCBBCKUA EQU   DCBBCKUP+1
@NM00131 EQU   DCBBCKUP
DCBIPLTX EQU   IHADCS1A
@NM00130 EQU   IHADCB
CVTLEVL  EQU   CVTRELNO+2
CVTNUMB  EQU   CVTRELNO
CVTMDL   EQU   CVTFIX+250
@NM00129 EQU   CVTFIX+248
@NM00128 EQU   CVTFIX
CVTRV482 EQU   CVTXTNT2+128
CVTRV481 EQU   CVTXTNT2+124
CVTRV480 EQU   CVTXTNT2+120
CVTRV479 EQU   CVTXTNT2+118
CVTRV478 EQU   CVTXTNT2+117
CVTRV477 EQU   CVTXTNT2+116
CVTRV476 EQU   CVTXTNT2+115
CVTRV475 EQU   CVTXTNT2+114
CVTRV474 EQU   CVTRV466
CVTRV473 EQU   CVTRV466
CVTRV472 EQU   CVTRV466
CVTRV471 EQU   CVTRV466
CVTRV470 EQU   CVTRV466
CVTRV469 EQU   CVTRV466
CVTRV468 EQU   CVTRV466
CVTRV467 EQU   CVTRV466
CVTRV465 EQU   CVTRV457
CVTRV464 EQU   CVTRV457
CVTRV463 EQU   CVTRV457
CVTRV462 EQU   CVTRV457
CVTRV461 EQU   CVTRV457
CVTRV460 EQU   CVTRV457
CVTRV459 EQU   CVTRV457
CVTRV458 EQU   CVTRV457
CVTRV456 EQU   CVTXTNT2+108
CVTRV455 EQU   CVTXTNT2+104
CVTRV454 EQU   CVTXTNT2+100
CVTRV453 EQU   CVTXTNT2+96
CVTRV452 EQU   CVTXTNT2+94
CVTRV451 EQU   CVTXTNT2+92
CVTRV450 EQU   CVTXTNT2+90
CVTRV449 EQU   CVTXTNT2+88
CVTRV448 EQU   CVTXTNT2+87
CVTRV447 EQU   CVTXTNT2+86
CVTRV446 EQU   CVTRV438
CVTRV445 EQU   CVTRV438
CVTRV444 EQU   CVTRV438
CVTRV443 EQU   CVTRV438
CVTRV442 EQU   CVTRV438
CVTRV441 EQU   CVTRV438
CVTRV440 EQU   CVTRV438
CVTRV439 EQU   CVTRV438
CVTRV437 EQU   CVTRV429
CVTRV436 EQU   CVTRV429
CVTRV435 EQU   CVTRV429
CVTRV434 EQU   CVTRV429
CVTRV433 EQU   CVTRV429
CVTRV432 EQU   CVTRV429
CVTRV431 EQU   CVTRV429
CVTRV430 EQU   CVTRV429
CVTRV428 EQU   CVTXTNT2+80
CVTRV427 EQU   CVTXTNT2+76
CVTRV426 EQU   CVTXTNT2+72
CVTRV425 EQU   CVTXTNT2+68
CVTATACT EQU   CVTATCVT
CVTRV423 EQU   CVTXTNT2+62
CVTRV422 EQU   CVTXTNT2+60
CVTRV421 EQU   CVTXTNT2+58
CVTRV420 EQU   CVTXTNT2+56
CVTRV419 EQU   CVTXTNT2+55
CVTRV418 EQU   CVTXTNT2+54
CVTRV417 EQU   CVTRV409
CVTRV416 EQU   CVTRV409
CVTRV415 EQU   CVTRV409
CVTRV414 EQU   CVTRV409
CVTRV413 EQU   CVTRV409
CVTRV412 EQU   CVTRV409
CVTRV411 EQU   CVTRV409
CVTRV410 EQU   CVTRV409
CVTRV408 EQU   CVTRV400
CVTRV407 EQU   CVTRV400
CVTRV406 EQU   CVTRV400
CVTRV405 EQU   CVTRV400
CVTRV404 EQU   CVTRV400
CVTRV403 EQU   CVTRV400
CVTRV402 EQU   CVTRV400
CVTRV401 EQU   CVTRV400
CVTICB   EQU   CVTXTNT2+48
CVTSKTA  EQU   CVTXTNT2+44
CVTSHSB  EQU   CVTSHS
CVTRSV98 EQU   CVTXTNT2+36
CVTRSV97 EQU   CVTXTNT2+34
CVTRSV96 EQU   CVTXTNT2+32
CVTOLTEP EQU   CVTXTNT2+28
CVTQIDA  EQU   CVTQID+1
CVTRSV95 EQU   CVTQID
CVTRSV94 EQU   CVTXTNT2+20
CVTRSV93 EQU   CVTXTNT2+16
CVTRSV92 EQU   CVTXTNT2+12
CVTDEBVR EQU   CVTXTNT2+8
CVTRSV91 EQU   CVTXTNT2+6
CVTRSV9H EQU   CVTFLGBT
CVTRSV9G EQU   CVTFLGBT
CVTRSV9F EQU   CVTFLGBT
CVTRSV9E EQU   CVTFLGBT
CVTRSV9D EQU   CVTFLGBT
CVTRSV9C EQU   CVTFLGBT
CVTVME   EQU   CVTFLGBT
CVTNPE   EQU   CVTFLGBT
CVTNUCLS EQU   CVTXTNT2+4
CVTDSSVA EQU   CVTDSSV+1
CVTRSV89 EQU   CVTDSSV
CVTRSV88 EQU   CVTXTNT1+8
CVTRSV87 EQU   CVTXTNT1+4
CVTFACHN EQU   CVTXTNT1
CVTRV488 EQU   CVTMAP+412
CVTRV487 EQU   CVTMAP+408
CVTRV486 EQU   CVTMAP+404
CVTRV485 EQU   CVTMAP+400
CVTACTAP EQU   CVTMAP+396
CVTAUTH  EQU   CVTMAP+392
CVTATMCA EQU   CVTATMCT+1
CVTATMST EQU   CVTATMCT
CVTRSV61 EQU   CVTMAP+384
CVTVOLT1 EQU   CVTVOLM1+1
CVTVOLI1 EQU   CVTVOLF1
CVTSTOA  EQU   CVTMAP+376
CVTRSV58 EQU   CVTMAP+374
CVTRSV57 EQU   CVTMAP+372
CVTDDCE  EQU   CVTMAP+368
CVTPNWFR EQU   CVTMAP+364
CVTSMF   EQU   CVTMAP+360
CVTSULK  EQU   CVTMAP+358
CVTSLKO  EQU   CVTSYSK
CVTSLKP  EQU   CVTSYSK
CVTSLKQ  EQU   CVTSYSK
CVTSLKR  EQU   CVTSYSK
CVTRSV56 EQU   CVTSYSK
CVTRSV55 EQU   CVTSYSK
CVTRSV54 EQU   CVTSYSK
CVTRSV53 EQU   CVTSYSK
CVTRSV52 EQU   CVTA1F1
CVTRSV51 EQU   CVTA1F1
CVTRSV50 EQU   CVTA1F1
CVTRSV49 EQU   CVTA1F1
CVTRSV48 EQU   CVTA1F1
CVTRSV47 EQU   CVTA1F1
CVTSRSW  EQU   CVTA1F1
CVTPFSW  EQU   CVTA1F1
CVTPCVT  EQU   CVTMAP+352
CVTRSV46 EQU   CVTMAP+344
CVTRSV45 EQU   CVTMAP+340
CVTRSV44 EQU   CVTMAP+338
CVTRSV43 EQU   CVTMAP+336
CVTHJESA EQU   CVTHJES+1
CVTRSV42 EQU   CVTHJES
CVTEXT2A EQU   CVTEXT2+1
CVTRSV41 EQU   CVTEXT2
CVTAPFA  EQU   CVTAPF+1
CVTRSV40 EQU   CVTAPF
CVTRV518 EQU   CVTINTLA
CVTRV517 EQU   CVTERPV
CVTEORM  EQU   CVTMAP+312
CVTMCHPR EQU   CVTMAP+308
CVTTZ    EQU   CVTMAP+304
CVTJEPS  EQU   CVTMAP+300
CVTJESCT EQU   CVTMAP+296
CVTMODE  EQU   CVTMAP+292
CVTPTRV  EQU   CVTMAP+288
CVTREAL  EQU   CVTMAP+284
CVTRSV39 EQU   CVTMAP+280
CVTRSV38 EQU   CVTMAP+276
CVTDMSRA EQU   CVTDMSR+1
CVTRV634 EQU   CVTDMSRF
CVTRV633 EQU   CVTDMSRF
CVTRV632 EQU   CVTDMSRF
CVTRV631 EQU   CVTDMSRF
CVTRV630 EQU   CVTDMSRF
CVTRV629 EQU   CVTDMSRF
CVTUDUMP EQU   CVTDMSRF
CVTSDUMP EQU   CVTDMSRF
CVTQMSGA EQU   CVTQMSG+1
CVTRSV36 EQU   CVTQMSG
CVTAMFF  EQU   CVTMAP+264
CVTPURGA EQU   CVTPURG+1
CVTRSV35 EQU   CVTPURG
CVTCBSP  EQU   CVTMAP+256
CVTATERA EQU   CVTATER+1
CVTSYST  EQU   CVTATER
CVTVOLT2 EQU   CVTTAT
CVTVOLI2 EQU   CVTVOLF2
CVTAQAVB EQU   CVTAQAVT+1
CVTRSV34 EQU   CVTTCMFG
CVTRSV33 EQU   CVTTCMFG
CVTRSV32 EQU   CVTTCMFG
CVTRSV31 EQU   CVTTCMFG
CVTRSV30 EQU   CVTTCMFG
CVTRSV29 EQU   CVTTCMFG
CVTRSV28 EQU   CVTTCMFG
CVTTCRDY EQU   CVTTCMFG
CVTGTFA  EQU   CVTGTF+1
CVTRSV27 EQU   CVTGTFST
CVTRNIO  EQU   CVTGTFST
CVTUSR   EQU   CVTGTFST
CVTRV318 EQU   CVTFORM
CVTRV317 EQU   CVTTMODE
CVTRV316 EQU   CVTSTATE
CVTRV315 EQU   CVTGTFS
CVTGTFAV EQU   CVTGTFS
CVT0SCR1 EQU   CVTMAP+232
CVTRV515 EQU   CVTMAP+228
CVTRMS   EQU   CVTMAP+224
CVTPATCH EQU   CVTMAP+220
CVTTSCE  EQU   CVTMAP+216
CVTLNKSC EQU   CVTMAP+214
CVTQABST EQU   CVTMAP+212
CVTMDLDS EQU   CVTMAP+208
CVTUSER  EQU   CVTMAP+204
CVTABEND EQU   CVTMAP+200
CVTSMCA  EQU   CVTMAP+196
CVTRSV18 EQU   CVTMAP+192
CVTQLPAQ EQU   CVTMAP+188
CVTQCDSR EQU   CVTMAP+184
CVTRSV17 EQU   CVTOPTB
CVTRSV16 EQU   CVTOPTB
CVTFP    EQU   CVTOPTB
CVTAPTHR EQU   CVTOPTB
CVTNLOG  EQU   CVTOPTB
CVTTOD   EQU   CVTOPTB
CVTCTIMS EQU   CVTOPTB
CVTPROT  EQU   CVTOPTB
CVTXPFP  EQU   CVTOPTA
CVTASCII EQU   CVTOPTA
CVTRSV13 EQU   CVTOPTA
CVTRSV12 EQU   CVTOPTA
CVTNIP   EQU   CVTOPTA
CVTDDR   EQU   CVTOPTA
CVTAPR   EQU   CVTOPTA
CVTCCH   EQU   CVTOPTA
CVTSNCTR EQU   CVTMAP+180
CVTQMWR  EQU   CVTMAP+176
CVTQOCR  EQU   CVTMAP+172
CVT1EF00 EQU   CVTMAP+168
CVTMZ00  EQU   CVTMAP+164
CVTHEAD  EQU   CVTMAP+160
CVTRSV11 EQU   CVTMAP+156
CVT0PT01 EQU   CVTMAP+152
CVTMSER  EQU   CVTMAP+148
CVTRV516 EQU   CVTIERLC
CVTILCH  EQU   CVTMAP+140
CVT0DS   EQU   CVTMAP+136
CVTFBOSV EQU   CVTMAP+132
CVTNUCB  EQU   CVTMAP+128
CVTIXAVL EQU   CVTMAP+124
CVTIOQET EQU   CVTMAP+120
CVTDCBA  EQU   CVTMAP+117
CVTMVS2  EQU   CVTDCB
CVT6DAT  EQU   CVTDCB
CVT4MPS  EQU   CVTDCB
CVTRSV09 EQU   CVTDCB
CVT4MS1  EQU   CVTDCB
CVT2SPS  EQU   CVTDCB
CVT1SSS  EQU   CVTDCB
CVTRSV08 EQU   CVTDCB
CVTSTB   EQU   CVTMAP+112
CVTQTD00 EQU   CVTMAP+108
CVTQTE00 EQU   CVTMAP+104
CVTCUCB  EQU   CVTMAP+100
CVTSJQ   EQU   CVTMAP+96
CVTPBLDL EQU   CVTMAP+92
CVTTPC   EQU   CVTMAP+88
CVTSVDCB EQU   CVTMAP+84
CVTBRET  EQU   CVTMAP+82
CVTEXIT  EQU   CVTMAP+80
CVT0FN00 EQU   CVTMAP+76
CVTDARA  EQU   CVTDAR+1
CVTRSV07 EQU   CVTFLGS1
CVTRSV06 EQU   CVTFLGS1
CVTRSV05 EQU   CVTFLGS1
CVTRSV04 EQU   CVTFLGS1
CVTRSV03 EQU   CVTFLGS1
CVTRSV02 EQU   CVTFLGS1
CVTRSV01 EQU   CVTFLGS1
CVTDMPLK EQU   CVTFLGS1
CVTXITP  EQU   CVTMAP+68
CVTZDTAB EQU   CVTMAP+64
CVTMSLT  EQU   CVTMAP+60
CVTDATE  EQU   CVTMAP+56
CVTBTERM EQU   CVTMAP+52
CVTSYSAD EQU   CVTMAP+48
CVTXTLER EQU   CVTMAP+44
CVTILK2  EQU   CVTMAP+40
CVTILK1  EQU   CVTMAP+36
CVTPRLTV EQU   CVTMAP+32
CVTPCNVT EQU   CVTMAP+28
CVT0VL00 EQU   CVTMAP+24
CVTXAPG  EQU   CVTMAP+20
CVTBUF   EQU   CVTMAP+16
CVTJOB   EQU   CVTMAP+12
CVTLINK  EQU   CVTMAP+8
CVT0EF00 EQU   CVTMAP+4
CVTTCBP  EQU   CVTMAP
CVT      EQU   CVTMAP
CKPIOTR  EQU   CKPAVT+21
CKPSUBT  EQU   CKPAVT+20
CKPLODPT EQU   CKPAVT+16
CKPRADDR EQU   CKPAVT+12
CKPNADDR EQU   CKPAVT+8
CKPBIT2  EQU   CKPAVT+7
CKPBIT1  EQU   CKPAVT+6
CKPINTLV EQU   CKPAVT+4
CKPOPCIN EQU   CKPAVT+2
CKPOPCON EQU   CKPAVT
CKPTYPE  EQU   CKPNRES+5
@NM00127 EQU   CKPNFLG
CKPLULOG EQU   CKPNFLG
CKPEPMOD EQU   CKPNFLG
CKPRSACT EQU   CKPNFLG
CKPREMB  EQU   CKPNFLG
CKPCOHRT EQU   CKPNRES+2
CKPSUBST EQU   CKPNRES
CKPCTSEC EQU   CKPREQTB+6
CKPCTOFF EQU   CKPREQTB+4
CKPCTTTR EQU   CKPREQTB+1
CKPCTDER EQU   CKPCTFLG
CKPCTACT EQU   CKPCTFLG
CREDEB   EQU   CREOFFS
CREECB   EQU   IEDQCRED+8
@NM00126 EQU   CRELINK+1
CREPRI   EQU   CRELINK
CREQCBAD EQU   IEDQCRED+1
CREKEY   EQU   IEDQCRED
CDRKEY   EQU   IEDQCDRD+8
CDRTIME  EQU   IEDQCDRD+4
CDRDATE  EQU   IEDQCDRD
CKPSECT1 EQU   CKPCNTLR+37
CKPTTRT1 EQU   CKPCNTLR+34
CKPSECIN EQU   CKPCNTLR+32
CKPSECCR EQU   CKPCNTLR+30
CKPSECLI EQU   CKPCNTLR+28
CKPSECLT EQU   CKPCNTLR+26
CKPINCLN EQU   CKPCNTLR+24
CKPTTRLI EQU   CKPCNTLR+21
CKPRPERT EQU   CKPCNTLR+20
CKPCKRLN EQU   CKPCNTLR+18
CKPCPERT EQU   CKPPRQNO
CKPIPERT EQU   CKPCNTLR+16
CKPCPRCD EQU   CKPCNTLR+15
CKPCKRQS EQU   CKPCNTLR+14
CKPBPERR EQU   CKPCNTLR+12
CKPTTRIN EQU   CKPCNTLR+9
CKPINRNO EQU   CKPCNTLR+8
CKPTTRCR EQU   CKPCNTLR+5
CKPCRRNO EQU   CKPCNTLR+4
CKPINCNO EQU   CKPCNTLR+3
CKPINCNT EQU   CKPCNTLR+2
CKPTTRCT EQU   CKPCNTLR+1
CKPOPCRD EQU   CKPFLAGS
CKPOPTFN EQU   CKPFLAGS
CKPSTAIN EQU   CKPFLAGS
CKPERR   EQU   CKPFLAGS
@NM00114 EQU   CKPFLAGS
CKPFSCN2 EQU   CKPFLAGS
CKPFSCN1 EQU   CKPFLAGS
CKPNORML EQU   CKPFLAGS
@NM00113 EQU   CKPMSG+65
CKPMSGGL EQU   CKPMSG+61
@NM00112 EQU   CKPMSG+2
CKPMSGLN EQU   CKPMSG
CKPWKALN EQU   @NM00111+10
CKPGETML EQU   @NM00111
CKPRWBC  EQU   CKPRW+6
@NM00110 EQU   CKPRW+5
CKPRWFLG EQU   CKPRW+4
CKPRWADD EQU   CKPRW+1
CKPRWCMD EQU   CKPRW
CKPSCHID EQU   CKPCCWS+16
CKPSETSC EQU   CKPCCWS+8
CKPSEEKC EQU   CKPCCWS
@NM00109 EQU   IEDQCKPD+164
CKPERRCT EQU   IEDQCKPD+163
CKPSWCH2 EQU   IEDQCKPD+162
CKPSWCH1 EQU   IEDQCKPD+161
CKPCRLEN EQU   IEDQCKPD+160
CKPPARM2 EQU   IEDQCKPD+156
CKPCPARM EQU   IEDQCKPD+148
CKPSECTR EQU   CKPCTTRB
CKPLDRB  EQU   IEDQCKPD+140
CKPLREB  EQU   IEDQCKPD+136
CKPNDRB  EQU   @NM00108
CKPIOQF  EQU   IEDQCKPD+128
CKPEPLOC EQU   CKPCNVRT
CKPECB   EQU   IEDQCKPD+112
CKPIOR   EQU   CKPIOSK+7
CKPIOHH  EQU   CKPIOSK+5
CKPIOCC  EQU   CKPIOSK+3
CKPIOBB  EQU   CKPIOSK+1
CKPIOM   EQU   CKPIOSK
CKPIORC  EQU   CKPIOB+30
CKPIOBCI EQU   CKPIOB+28
CKPIORST EQU   CKPIOB+25
@NM00107 EQU   CKPIOB+24
CKPIODCB EQU   CKPIOB+21
@NM00106 EQU   CKPIOB+20
CKPIOCPA EQU   CKPIOB+17
CKPIOSIO EQU   CKPIOB+16
CKPIOCSW EQU   CKPIOB+9
CKPIOFL3 EQU   CKPIOB+8
@NM00105 EQU   CKPIOECB+1
CKPIOECC EQU   CKPIOECB
CKPIOSN1 EQU   CKPIOB+3
CKPIOSN0 EQU   CKPIOB+2
CKPIOFL2 EQU   CKPIOB+1
CKPIOFL1 EQU   CKPIOB
CKPSAVE1 EQU   IEDQCKPD
SAVTBITN EQU   IEDNSVTD+312
@NM00104 EQU   SAVTCKQB+8
@NM00103 EQU   SAVTCKEC+1
@NM00102 EQU   SAVTCKCC
SAVTCKPO EQU   SAVTCKCC
SAVTCKWA EQU   SAVTCKCC
SAVTCKCH EQU   SAVTCKTB+1
SAVTCKVT EQU   SAVTCKTB
@NM00101 EQU   IEDNSVTD+297
SAVTRDFG EQU   SAVTRDRV+12
@NM00100 EQU   SAVTRDRV+5
SAVTRDPY EQU   SAVTRDRV+4
SAVTRDQB EQU   SAVTRDRV+1
SAVTRDKY EQU   SAVTRDRV
SAVTNID  EQU   IEDNSVTD+280
SAVTDVAS EQU   IEDNSVTD+276
SAVTPLSZ EQU   IEDNSVTD+274
@NM00099 EQU   IEDNSVTD+273
SAVTSUBL EQU   IEDNSVTD+272
@NM00098 EQU   SAVTZELM+1
SAVTSUBM EQU   SAVTZELM
SAVTMHDX EQU   IEDNSVTD+268
SAVTNAT1 EQU   IEDNSVTD+266
SAVTSH20 EQU   IEDNSVTD+264
SAVTLCBS EQU   IEDNSVTD+260
SAVTRNMP EQU   IEDNSVTD+256
SAVTNAX  EQU   IEDNSVTD+248
SAVTSUBV EQU   IEDNSVTD+247
SAVTSUBA EQU   IEDNSVTD+246
SAVTSIBC EQU   IEDNSVTD+244
SAVTBSM  EQU   IEDNSVTD+240
SAVTSCPT EQU   SAVTTCPU
SAVTRQTG EQU   IEDNSVTD+236
SAVTRQCH EQU   IEDNSVTD+232
SAVTMAND EQU   IEDNSVTD+228
SAVTSPLN EQU   IEDNSVTD+224
SAVTNADL EQU   IEDNSVTD+222
SAVTNATL EQU   IEDNSVTD+220
SAVTMHTB EQU   IEDNSVTD+216
SAVTSSMH EQU   IEDNSVTD+212
SAVTQRS  EQU   IEDNSVTD+208
SAVTRQIN EQU   IEDNSVTD+204
SAVTDFCO EQU   IEDNSVTD+200
SAVTSAO  EQU   IEDNSVTD+196
SAVTSARI EQU   IEDNSVTD+192
SAVTSAC  EQU   IEDNSVTD+188
SAVTSAI  EQU   IEDNSVTD+184
SAVTCSCI EQU   IEDNSVTD+180
SAVTSSRP EQU   IEDNSVTD+176
SAVTSSRQ EQU   IEDNSVTD+172
SAVTSCLU EQU   IEDNSVTD+168
SAVTXTRQ EQU   IEDNSVTD+164
SAVTMVBF EQU   IEDNSVTD+160
@NM00097 EQU   IEDNSVTD+148
SAVTIPCQ EQU   IEDNSVTD+144
@NM00096 EQU   IEDNSVTD+136
SAVTXFMI EQU   IEDNSVTD+132
@NM00095 EQU   IEDNSVTD+124
SAVTXFMO EQU   IEDNSVTD+120
@NM00094 EQU   IEDNSVTD+116
SAVTSSSR EQU   IEDNSVTD+112
SAVTSCPQ EQU   IEDNSVTD+108
SAVTSLCB EQU   IEDNSVTD+104
SAVTLUSR EQU   IEDNSVTD+100
@NM00093 EQU   SAVTLUSQ+8
SAVTLUSP EQU   SAVTLUSQ+4
SAVTLUSB EQU   SAVTLUSQ
@NM00092 EQU   IEDNSVTD+84
SAVTSAT  EQU   IEDNSVTD+80
SAVTNAT  EQU   IEDNSVTD+76
SAVTCLUP EQU   IEDNSVTD+72
SAVTPIUT EQU   IEDNSVTD+68
SAVTRNTA EQU   IEDNSVTD+64
SAVTDNIR EQU   IEDNSVTD+60
SAVTCNIR EQU   IEDNSVTD+56
SAVTFLDH EQU   IEDNSVTD+52
SAVTSRTN EQU   IEDNSVTD+48
SAVTSREQ EQU   IEDNSVTD+44
SAVTFAIL EQU   IEDNSVTD+42
SAVTSUSE EQU   IEDNSVTD+40
SAVTSIB  EQU   IEDNSVTD+36
SAVTPRTN EQU   IEDNSVTD+32
@NM00091 EQU   IEDNSVTD+28
SAVTWH20 EQU   IEDNSVTD+26
SAVTPWT  EQU   IEDNSVTD+24
SAVTPRTQ EQU   IEDNSVTD+20
SAVTPREQ EQU   IEDNSVTD+16
SAVTPH20 EQU   IEDNSVTD+14
SAVTPUSE EQU   IEDNSVTD+12
SAVTPLCB EQU   IEDNSVTD+8
SAVTPOOL EQU   IEDNSVTD+4
SAVTPRMT EQU   SAVTDIAF
SAVTVIRT EQU   SAVTDIAF
AVTCPBNO EQU   IEDQAVTD+1244
AVTHRESS EQU   IEDQAVTD+1243
@NM00090 EQU   IEDQAVTD+1242
@NM00089 EQU   IEDQAVTD+1241
@NM00088 EQU   IEDQAVTD+1240
@NM00087 EQU   IEDQAVTD+1237
@NM00086 EQU   IEDQAVTD+1236
AVTHRESE EQU   @NM00085
AVTRADDR EQU   IEDQAVTD+1228
AVTNADDR EQU   IEDQAVTD+1224
AVTHRESN EQU   IEDQAVTD+1220
AVTVOLRN EQU   IEDQAVTD+1216
AVTTOTNN EQU   IEDQAVTD+1212
AVTTRCYN EQU   IEDQAVTD+1208
AVTRCTRN EQU   IEDQAVTD+1204
AVTNOVON EQU   IEDQAVTD+1200
AVTADEBN EQU   IEDQAVTD+1196
AVTVOLRR EQU   IEDQAVTD+1192
AVTTOTNR EQU   IEDQAVTD+1188
AVTTRCYR EQU   IEDQAVTD+1184
AVTRCTRR EQU   IEDQAVTD+1180
AVTNOVOR EQU   IEDQAVTD+1176
AVTADEBR EQU   IEDQAVTD+1172
AVTLODPT EQU   IEDQAVTD+1168
AVTIOBN  EQU   IEDQAVTD+1164
AVTIOBR  EQU   IEDQAVTD+1160
AVTCPBPT EQU   IEDQAVTD+1156
AVTFCPB  EQU   IEDQAVTD+1152
@NM00084 EQU   IEDQAVTD+1148
AVTINCPQ EQU   IEDQAVTD+1144
@NM00083 EQU   IEDQAVTD+1140
@NM00082 EQU   IEDQAVTD+1137
@NM00081 EQU   AVTBIT4
@NM00080 EQU   AVTBIT4
@NM00079 EQU   AVTBIT4
@NM00078 EQU   AVTBIT4
@NM00077 EQU   AVTBIT4
@NM00076 EQU   AVTBIT4
@NM00075 EQU   AVTBIT4
AVTRUFTN EQU   AVTBIT4
@NM00074 EQU   IEDQAVTD+1132
AVTNOBFQ EQU   IEDQAVTD+1128
@NM00073 EQU   IEDQAVTD+1124
AVTDKENQ EQU   IEDQAVTD+1120
@NM00072 EQU   IEDQAVTD+1116
AVTDKAPQ EQU   IEDQAVTD+1112
AVTCOPY  EQU   IEDQAVTD+1108
AVTIA    EQU   IEDQAVTD+1104
AVTFL    EQU   IEDQAVTD+1100
@NM00071 EQU   IEDQAVTD+1096
AVTNCPBQ EQU   IEDQAVTD+1092
AVTTOTNC EQU   IEDQAVTD+1088
AVTCMAX  EQU   IEDQAVTD+1084
AVTCMIN  EQU   IEDQAVTD+1080
AVTHM02  EQU   IEDQAVTD+1076
AVTOPCIN EQU   IEDQAVTD+1074
AVTDCTLN EQU   IEDQAVTD+1072
AVTOPMSK EQU   IEDQAVTD+1068
AVTSTEAL EQU   IEDQAVTD+1060
AVTOPTN  EQU   IEDQAVTD+1056
AVTDSKCT EQU   IEDQAVTD+1054
AVTCKRST EQU   IEDQAVTD+1053
AVTSTAN  EQU   AVTBIT3
AVTSTACN EQU   AVTBIT3
AVTSTAYN EQU   AVTBIT3
AVTOLTBN EQU   AVTBIT3
AVTTSAB  EQU   AVTBIT3
AVTRFULN EQU   AVTBIT3
AVTRECVN EQU   AVTBIT3
@NM00070 EQU   AVTBIT2
@NM00069 EQU   AVTBIT2
AVTOPEIN EQU   AVTBIT2
AVTSTRTN EQU   AVTBIT2
AVTTOPOL EQU   AVTBIT2
AVTCOPYN EQU   AVTBIT2
AVTREUSN EQU   AVTBIT2
AVTEXTSC EQU   AVTBIT2
AVTDISKN EQU   AVTBIT1
AVTQUCKN EQU   AVTBIT1
AVTCLOSN EQU   AVTBIT1
AVTREADN EQU   AVTBIT1
AVTDLAYN EQU   AVTBIT1
AVTAQTAN EQU   AVTBIT1
AVTTSON  EQU   AVTBIT1
AVTAPLKN EQU   AVTBIT1
AVTDUMBR EQU   IEDQAVTD+1048
AVTDLQX  EQU   IEDQAVTD+1046
AVTINTLV EQU   IEDQAVTD+1044
AVTSMCNT EQU   IEDQAVTD+1042
AVTAVFCT EQU   IEDQAVTD+1040
AVTOPCON EQU   IEDQAVTD+1038
AVTOPCNT EQU   IEDQAVTD+1036
AVTLNCNT EQU   IEDQAVTD+1034
AVTKEYLE EQU   IEDQAVTD+1032
AVTHA16  EQU   IEDQAVTD+1030
AVTHA7   EQU   IEDQAVTD+1028
AVTHA4   EQU   IEDQAVTD+1026
AVTHA3   EQU   IEDQAVTD+1024
AVTHA2   EQU   IEDQAVTD+1022
AVTGETMS EQU   IEDQAVTD+1021
@NM00068 EQU   IEDQAVTD+1020
AVTGETMD EQU   IEDQAVTD+1016
AVTGETMN EQU   IEDQAVTD+1012
AVTCWTOT EQU   IEDQAVTD+1008
AVTCWINT EQU   IEDQAVTD+956
AVTDTRAP EQU   IEDQAVTD+952
@NM00067 EQU   IEDQAVTD+950
@NM00066 EQU   AVTIOTR
AVTIOTRH EQU   AVTIOTR
AVTIOTRE EQU   AVTIOTR
@NM00065 EQU   AVTSUBT
AVTSUBPT EQU   AVTSUBT
AVTSUBON EQU   AVTSUBT
AVTAFE30 EQU   IEDQAVTD+944
AVTAFE20 EQU   IEDQAVTD+940
AVTAFE10 EQU   IEDQAVTD+936
AVTCWEC2 EQU   IEDQAVTD+932
AVTCWPM2 EQU   IEDQAVTD+928
AVTCWTS2 EQU   IEDQAVTD+927
AVTCWTS1 EQU   IEDQAVTD+926
AVTCWCLD EQU   AVTCWFL2
AVTCWRAP EQU   AVTCWFL2
@NM00064 EQU   AVTCWFL2
@NM00063 EQU   AVTCWFL2
@NM00062 EQU   AVTCWFL2
@NM00061 EQU   AVTCWFL2
@NM00060 EQU   AVTCWFL2
AVTCWACT EQU   AVTCWFL2
@NM00059 EQU   AVTCWFL1
@NM00058 EQU   AVTCWFL1
@NM00057 EQU   AVTCWFL1
@NM00056 EQU   AVTCWFL1
@NM00055 EQU   AVTCWFL1
@NM00054 EQU   AVTCWFL1
@NM00053 EQU   AVTCWFL1
AVTCOMWN EQU   AVTCWFL1
AVTCWEC1 EQU   IEDQAVTD+920
AVTCWPM1 EQU   IEDQAVTD+916
AVTCAREA EQU   IEDQAVTD+912
AVTFZERO EQU   IEDQAVTD+908
AVTCADDR EQU   IEDQAVTD+904
AVTCOREC EQU   IEDQAVTD+900
@NM00052 EQU   IEDQAVTD+892
AVTCPBCB EQU   IEDQAVTD+888
@NM00051 EQU   IEDQAVTD+880
AVTDSIOB EQU   IEDQAVTD+876
@NM00050 EQU   IEDQAVTD+868
AVTCPRMB EQU   IEDQAVTD+864
@NM00049 EQU   IEDQAVTD+856
@NM00048 EQU   IEDQAVTD+844
AVTACTIB EQU   IEDQAVTD+840
@NM00047 EQU   IEDQAVTD+836
AVTOLTEB EQU   IEDQAVTD+832
AVTOLTCH EQU   AVTOLTQB+1
AVTOLTVT EQU   AVTOLTQB
@NM00046 EQU   AVTOPCQB+8
@NM00045 EQU   AVTOPCEC+1
@NM00044 EQU   AVTOPCCC
AVTOPCPO EQU   AVTOPCCC
AVTOPCWA EQU   AVTOPCCC
AVTOPCCH EQU   AVTOPCOB+1
AVTOPCVT EQU   AVTOPCOB
@NM00043 EQU   AVTCKPQB+9
AVTCKPTS EQU   AVTCKPQB+8
@NM00042 EQU   AVTCKPEC+1
@NM00041 EQU   AVTCKPCC
AVTCKPPO EQU   AVTCKPCC
AVTCKPWA EQU   AVTCKPCC
AVTCKPCH EQU   AVTCKPTB+1
AVTCKPVT EQU   AVTCKPTB
@NM00040 EQU   IEDQAVTD+796
AVTBFRTB EQU   IEDQAVTD+792
@NM00039 EQU   IEDQAVTD+784
AVTBFREB EQU   IEDQAVTD+780
AVTTIMQ  EQU   IEDQAVTD+776
@NM00038 EQU   IEDQAVTD+772
AVTIMQPS EQU   IEDQAVTD+768
AVTINOUT EQU   IEDQAVTD+766
AVTREFTM EQU   IEDQAVTD+764
@NM00037 EQU   IEDQAVTD+752
AVTDELYB EQU   IEDQAVTD+748
AVTOCQPT EQU   IEDQAVTD+744
AVTTSOPT EQU   IEDQAVTD+740
AVTSUPPT EQU   IEDQAVTD+736
AVTCBQCB EQU   IEDQAVTD+732
AVTMSGS  EQU   IEDQAVTD+729
@NM00036 EQU   AVTSYSER
@NM00035 EQU   AVTSYSER
@NM00034 EQU   AVTSYSER
@NM00033 EQU   AVTSYSER
@NM00032 EQU   AVTSYSER
@NM00031 EQU   AVTSYSER
AVTCMAXN EQU   AVTSYSER
AVTCMINN EQU   AVTSYSER
AVT2260L EQU   IEDQAVTD+724
AVTABEPL EQU   AVTADBUF
AVTHFF   EQU   AVTCLRHI+2
@NM00030 EQU   AVTCLRHI
AVTCCLNK EQU   AVTCRELE+5
AVTDELAD EQU   IEDQAVTD+704
AVTDELEM EQU   IEDQAVTD+700
AVTBSX   EQU   AVTCKLNK
AVTOPETR EQU   AVTHG01
@NM00029 EQU   AVTCKBYT
AVTCKONQ EQU   AVTCKBYT
@NM00028 EQU   AVTCKBYT
@NM00027 EQU   AVTCKBYT
@NM00026 EQU   AVTCKBYT
@NM00025 EQU   AVTCKBYT
@NM00024 EQU   AVTCKBYT
@NM00023 EQU   AVTCKBYT
AVTOPERT EQU   IEDQAVTD+690
AVTOPXCL EQU   IEDQAVTD+688
AVTOPERL EQU   IEDQAVTD+687
@NM00022 EQU   IEDQAVTD+686
AVTCKTIM EQU   IEDQAVTD+684
AVTCKELV EQU   IEDQAVTD+682
AVTCPRCD EQU   IEDQAVTD+681
AVTWARMN EQU   AVTCKELF
AVTCRTLN EQU   AVTCKELF
AVTCPIPN EQU   AVTCKELF
AVTCCLCN EQU   AVTCKELF
AVTCINCN EQU   AVTCKELF
@NM00021 EQU   AVTCKELF
AVTNQBCK EQU   AVTCKELF
AVTCKQAD EQU   IEDQAVTD+677
AVTSCBSZ EQU   IEDQAVTD+676
@NM00020 EQU   IEDQAVTD+672
AVTCKELE EQU   IEDQAVTD+668
@NM00019 EQU   AVTCKPEL+8
AVTCKRLK EQU   AVTCKPEL+5
AVTCKRPR EQU   AVTCKPEL+4
AVTCKRMQ EQU   AVTCKRMV+1
AVTCKRKY EQU   AVTCKRMV
AVTHK    EQU   IEDQAVTD+648
AVTHI    EQU   IEDQAVTD+644
AVTIOT   EQU   IEDQAVTD+640
AVTNX    EQU   IEDQAVTD+636
AVTTONE  EQU   IEDQAVTD+632
AVTA3TL  EQU   IEDQAVTD+628
AVTDMECB EQU   IEDQAVTD+624
AVTABEND EQU   IEDQAVTD+618
AVTPLCBN EQU   IEDQAVTD+616
@NM00018 EQU   AVTSAVTP+1
@NM00017 EQU   AVTSAVTF
AVTSNA   EQU   AVTSAVTF
AVTONSNA EQU   AVTSAVTF
@NM00016 EQU   IEDQAVTD+608
AVTCMBSS EQU   IEDQAVTD+604
AVTRCV   EQU   IEDQAVTD+600
AVTSEND  EQU   IEDQAVTD+596
AVTCSCH  EQU   IEDQAVTD+592
AVTQ1    EQU   IEDQAVTD+588
AVTE7    EQU   IEDQAVTD+584
AVTHB    EQU   IEDQAVTD+580
AVTR1    EQU   IEDQAVTD+576
AVTBZ    EQU   IEDQAVTD+572
AVTEZ    EQU   IEDQAVTD+568
AVTEC    EQU   IEDQAVTD+564
AVTEW    EQU   IEDQAVTD+560
AVTNDIAL EQU   AVTSCOPT
AVTN2741 EQU   AVTSCOPT
AVTCONCO EQU   AVTSCOPT
AVTCONC  EQU   AVTSCOPT
AVTCMBUF EQU   AVTSCOPT
AVTAPDMP EQU   AVTSCOPT
@NM00015 EQU   AVTSCOPT
AVTHA    EQU   AVTDISP
AVTEA    EQU   IEDQAVTD+548
AVTAX    EQU   IEDQAVTD+544
AVTA3    EQU   IEDQAVTD+540
AVTGD    EQU   IEDQAVTD+536
AVTAL    EQU   IEDQAVTD+532
AVTOLTST EQU   AVTHG02
AVTE8    EQU   IEDQAVTD+524
AVTUI    EQU   IEDQAVTD+520
AVTCOMPT EQU   IEDQAVTD+516
AVTCRSRF EQU   IEDQAVTD+512
@NM00014 EQU   IEDQAVTD+508
AVTKA02  EQU   IEDQAVTD+504
AVTOPTPT EQU   IEDQAVTD+500
AVTPCBPT EQU   IEDQAVTD+496
@NM00013 EQU   AVTECB1
AVTCOMP  EQU   AVTECB1
@NM00012 EQU   AVTECB1
AVTOPECA EQU   IEDQAVTD+488
AVTOLECA EQU   IEDQAVTD+484
AVTCKECA EQU   IEDQAVTD+480
AVTCWECA EQU   IEDQAVTD+476
AVTCWTCB EQU   IEDQAVTD+472
AVTOLTCB EQU   IEDQAVTD+468
AVTOCTCB EQU   IEDQAVTD+464
AVTCKTCB EQU   IEDQAVTD+460
AVTAS    EQU   IEDQAVTD+456
AVTNOLBF EQU   IEDQAVTD+454
AVTNCKPR EQU   IEDQAVTD+453
AVTCIB   EQU   IEDQAVTD+452
AVTSPLPT EQU   IEDQAVTD+448
AVTMVBFR EQU   IEDQAVTD+444
AVTSBTA  EQU   IEDQAVTD+440
AVTRARTN EQU   IEDQAVTD+436
AVTBSCAN EQU   IEDQAVTD+432
AVTRDYA  EQU   IEDQAVTD+428
AVTDISTR EQU   IEDQAVTD+420
AVTPARM3 EQU   IEDQAVTD+416
@NM00011 EQU   AVTPKF
@NM00010 EQU   AVTPKF
@NM00009 EQU   AVTPKF
AVTFTCHF EQU   AVTPKF
@NM00008 EQU   AVTPKF
@NM00007 EQU   AVTPKF
@NM00006 EQU   AVTPKF
@NM00005 EQU   AVTPKF
AVTPARM  EQU   IEDQAVTD+408
AVTEXS2A EQU   IEDQAVTD+402
AVTEXA2S EQU   IEDQAVTD+396
AVTOCGET EQU   IEDQAVTD+392
AVTCKAVT EQU   @NM00003+1
@NM00004 EQU   AVTCKFLG
@NM00002 EQU   IEDQAVTD+384
AVTREADD EQU   IEDQAVTD+380
AVTREADY EQU   IEDQAVTD+376
AVTRACE  EQU   IEDQAVTD+372
AVTTCB   EQU   IEDQAVTD+368
AVTPASWD EQU   IEDQAVTD+360
AVTCTLCH EQU   IEDQAVTD+352
AVTDOUBL EQU   IEDQAVTD+344
AVTDOUBX EQU   IEDQAVTD+336
AVTDPARM EQU   IEDQAVTD+332
AVTCSTCS EQU   IEDQAVTD+328
AVTDLQ   EQU   AVTSAVEX+32
@NM00001 EQU   AVTSAVEX
AVTSAVE4 EQU   IEDQAVTD+216
AVTSAVE3 EQU   IEDQAVTD+144
AVTSAVE2 EQU   IEDQAVTD+72
AVTSAVE1 EQU   IEDQAVTD
.@UNREFD ANOP                          END UNREFERENCED COMPONENTS
@RF00402 EQU   @RC00394
@RF00401 EQU   @RC00394
@RC00422 EQU   @RC00420
@RC00452 EQU   @RC00438
@RC00440 EQU   @RC00438
@RF00474 EQU   @RC00470
@RF00473 EQU   @RC00470
@RF00479 EQU   @RC00470
@RT00495 EQU   @RC00489
@RT00493 EQU   @RC00489
@RC00491 EQU   @RC00489
@RF00546 EQU   @RC00543
@RF00545 EQU   @RC00543
@RF00633 EQU   @EL00004
@RC00442 EQU   @RC00440
@RF00447 EQU   @RC00442
@ENDDATA EQU   *
         END   IGC0610D,(C'PLS0432',0701,77144)
