         TITLE 'IGC0H10D,OPERATOR CONTROL MESSAGE MODULE               *
                        '
IGC0H10D CSECT ,                                                01S0001
@PROLOG  BALR  @12,0                                            01S0001
@PSTART  DS    0H                                               01S0001
         USING @PSTART,@12                                      01S0001
*                                   /*
IGC0H10D IEDHJN AFTERHJN,HJN           MODULE IDENTIFICATION MACRO
*   ROPCAVT=RPARM;                  /* ESTABLISH ADDRESSABILITY TO
*                                      THE OPERATOR CONTROL ADDRESS
*                                      VECTOR TABLE                  */
         LR    ROPCAVT,RPARM                                    02S0186
*   RFY                                                         02S0187
*     RPARM UNRSTD;                 /* RELEASE THE REGISTER     02S0187
*                                      RESTRICTED AT ENTRY TO THE
*                                      MODULE THAT CONTAINS THE 02S0187
*                                      ADDRESS OF THE OPERATOR  02S0187
*                                      CONTROL ADDRESS VECTOR TABLE  */
*   REG10=OPCWORK+LENGTH(MSGWORKA); /* SET THE BASE REGISTER TO BE
*                                      USED FOR ADDRESSING AUTOMATIC
*                                      DATA WITH THE ADDRESS OF THE
*                                      SECTION OF THE OPERATOR  02S0188
*                                      CONTROL RESIDENT WORK AREA
*                                      THAT IS AFTER THE SECTION USED
*                                      TO CONSTRUCT MESSAGES         */
         LA    REG10,84                                         02S0188
         AL    REG10,OPCWORK(,ROPCAVT)                          02S0188
*   GEN REFS(REG10) NOSETS;                                     02S0189
*                                   /*
         USING @DATD,REG10             PROVIDE ADDRESSABILITY TO ALL
*                                      AUTOMATIC DATA
*   RSAVE=ADDR(OPCSAVE);            /* SET THE SAVE AREA ADDRESS
*                                      REGISTER WITH THE ADDRESS OF
*                                      THE OPERATOR CONTROL SAVE AREA*/
         LA    RSAVE,OPCSAVE(,ROPCAVT)                          02S0190
*                                                               02S0191
*   /*****************************************************************/
*   /*                                                               */
*   /* PROCESS: THIS SEGMENT DOES THE PROCESSING THAT IS NECESSARY TO*/
*   /* PERFORM THE FUNCTION OF THE MODULE.                           */
*   /*                                                               */
*   /*****************************************************************/
*                                                               02S0191
*                                                               03S0191
*   /*****************************************************************/
*   /*                                                               */
*   /* PROCESS.INITIAL: THIS SEGMENT DOES THE INITIAL PROCESSING.    */
*   /*                                                               */
*   /*****************************************************************/
*                                                               03S0191
*   RAVT=OPCAVTPT;                  /* SET THE BASE POINTER FOR THE
*                                      TCAM ADDRESS VECTOR TABLE     */
         L     RAVT,OPCAVTPT(,ROPCAVT)                          03S0191
*   ROPCE=OPCCOPCE;                 /* SET THE BASE POINTER FOR THE
*                                      OPERATOR CONTROL ELEMENT      */
         L     ROPCE,OPCCOPCE(,ROPCAVT)                         03S0192
*   SEARCH=YES;                     /* INITIALIZE THE "SEARCH" SWITCH
*                                      TO INDICATE THAT A SEARCH IS
*                                      TO BE PERFORMED               */
         OI    SEARCH,B'10000000'                               02S0193
*   DO PTRENTRY=ADDR(TABDATA) BY LENGTH(TABENTRY) WHILE(SEARCH=YES);
         LA    PTRENTRY,TABDATA                                 02S0194
         B     @DE00194                                         02S0194
@DL00194 DS    0H                                               02S0195
*                                   /* INCREMENT THE POINTER TO 02S0195
*                                      ENTRIES IN THE MESSAGE DATA
*                                      TABLE WHILE THE SEARCH IS IN
*                                      PROGRESS                      */
*     IF TABMNUM=REG00              /* MATCHING MESSAGE NUMBERS      */
*       THEN                        /* STOP THE SEARCH AND BUILD THE
*                                      APPROPRIATE MESSAGE           */
         CH    REG00,TABMNUM(,PTRENTRY)                         02S0195
         BNE   @RF00195                                         02S0195
*                                                               03S0196
*       /*************************************************************/
*       /*                                                           */
*       /* PROCESS.BUILDMSG: THIS SEGMENT STOPS THE SEARCH FOR A     */
*       /* MATCHING MESSAGE TABLE ENTRY, BUILDS THE APPROPRIATE      */
*       /* MESSAGE IN THE OPERATOR CONTROL RESIDENT WORK AREA AND    */
*       /* DOES THE PREPARATION THAT IS NECESSARY TO TRANSFER CONTROL*/
*       /* TO THE LAST MODULE IN THE MESSAGE MODULE CHAIN.           */
*       /*                                                           */
*       /*************************************************************/
*                                                               03S0196
*       DO;                                                     03S0196
*         SEARCH=STOP;              /* INDICATE THAT THE SEARCH IS TO
*                                      BE STOPPED                    */
         NI    SEARCH,B'01111111'                               03S0197
*         MSGLNGTH=TABLNGTH;        /* SET THE LENGTH OF THE MESSAGE
*                                      IN THE OPERATOR CONTROL  03S0198
*                                      RESIDENT WORK AREA            */
         L     @11,OPCWORK(,ROPCAVT)                            03S0198
         LH    @01,TABLNGTH(,PTRENTRY)                          03S0198
         STH   @01,MSGLNGTH(,@11)                               03S0198
*         MSGTEXT(1:MSGLNGTH)=MSGSTRNG(1:MSGLNGTH);/* PUT THE MESSAGE
*                                      CHARACTER STRING INTO THE
*                                      MESSAGE TEXT FIELD OF THE WORK
*                                      AREA                          */
         BCTR  @01,0                                            03S0199
         L     @15,TABMPTR(,PTRENTRY)                           03S0199
         EX    @01,@SM01326                                     03S0199
*         IF TABCASE>0              /* ADDITIONAL PROCESSING OF THE
*                                      MESSAGE IS NECESSARY          */
*           THEN                    /* PROCESS THE UNIQUE       03S0200
*                                      REQUIREMENTS OF THE MESSAGE   */
         L     @11,TABCASE(,PTRENTRY)                           03S0200
         LTR   @11,@11                                          03S0200
         BNP   @RF00200                                         03S0200
*                                                               04S0201
*           /*********************************************************/
*           /*                                                       */
*           /* PROCESS.BUILDMSG.CASE: THIS SEGMENT IMPLEMENTS THE    */
*           /* CASE CONTROL STRUCTURE IN ORDER TO SATISFY THE UNIQUE */
*           /* REQUIREMENTS OF THE MESSAGES WITH VARIABLE CHARACTER  */
*           /* FIELDS THAT ARE BUILT IN THE OPERATOR CONTROL RESIDENT*/
*           /* WORK AREA BY THIS MODULE.                             */
*           /*                                                       */
*           /*********************************************************/
*                                                               04S0201
*           DO;                     /* CASE(TABCASE)NAMES(LSTART,CNTL
*                                      TOTE,SUPERIOR,ACTIVRES,ISSUE,R
*                                      ESOURC,LNGROUP,PHYSUNIT,CLOSED
*                                      WN)                           */
*             DCL                                               04S0202
*               CL0001@ LABEL BASED(CP0001@(TABCASE)) VALUERANGE(LSTART
*                   ,CNTLTOTE,SUPERIOR,ACTIVRES,ISSUE,RESOURC,LNGROUP,
*                   PHYSUNIT,CLOSEDWN);/* BRANCH TARGET              */
*             DCL                                               04S0203
*               CP0001@(9) PTR(31) INIT(ADDR(LSTART),ADDR(CNTLTOTE),
*                   ADDR(SUPERIOR),ADDR(ACTIVRES),ADDR(ISSUE),ADDR(
*                   RESOURC),ADDR(LNGROUP),ADDR(PHYSUNIT),ADDR(CLOSEDWN
*                   ));                                         04S0203
*             GOTO CL0001@;         /* BRANCH TO SELECTED CASE       */
         SLA   @11,2                                            04S0204
         L     @01,CP0001@-4(@11)                               04S0204
         BR    @01                                              04S0204
*                                                               05S0205
*             /*******************************************************/
*             /*                                                     */
*             /* PROCESS.BUILDMSG.CASE.LSTART: THIS SEGMENT PLACES   */
*             /* THE RESOURCE NAME INTO THE REQUIRED FIELD IN THE    */
*             /* MESSAGE TEXT                                        */
*             /*                                                     */
*             /*******************************************************/
*                                                               05S0205
*LSTART:                                                        05S0205
*             DO;                   /* SUBCASE                       */
LSTART   DS    0H                                               05S0206
*               MSGGROUP=OCBACKUP;  /* PLACE THE GROUP NAME INTO THE
*                                      MESSAGE                       */
         L     @01,OPCWORK(,ROPCAVT)                            05S0206
         MVC   MSGGROUP(8,@01),OCBACKUP(ROPCE)                  05S0206
*               GOTO CE0001@;       /* BRANCH TO END OF CASE         */
         B     CE0001@                                          05S0207
*             END;                  /* END OF SUBCASE                */
*                                                               05S0209
*             /*******************************************************/
*             /*                                                     */
*             /* PROCESS.BUILDMSG.CASE.CNTLTOTE: THIS SEGMENT PLACES */
*             /* THE RESOURCE NAME INTO THE REQUIRED FIELD IN THE    */
*             /* MESSAGE TEXT                                        */
*             /*                                                     */
*             /*******************************************************/
*                                                               05S0209
*CNTLTOTE:                                                      05S0209
*             DO;                   /* SUBCASE                       */
CNTLTOTE DS    0H                                               05S0210
*               MSGRTOTE=OCBACKUP;  /* PLACE RESOURCE NAME INTO 05S0210
*                                      MESSAGE                       */
         L     @01,OPCWORK(,ROPCAVT)                            05S0210
         MVC   MSGRTOTE(8,@01),OCBACKUP(ROPCE)                  05S0210
*               GOTO CE0001@;       /* BRANCH TO END OF CASE         */
         B     CE0001@                                          05S0211
*             END;                  /* END OF SUBCASE                */
*                                                               05S0213
*             /*******************************************************/
*             /*                                                     */
*             /* PROCESS.BUILDMSG.CASE.SUPERIOR: THIS SEGMENT PLACES */
*             /* THE RESOURCE NAME INTO THE REQUIRED FIELD IN THE    */
*             /* MESSAGE TEXT                                        */
*             /*                                                     */
*             /*******************************************************/
*                                                               05S0213
*SUPERIOR:                                                      05S0213
*             DO;                   /* SUBCASE                       */
SUPERIOR DS    0H                                               05S0214
*               RESINACT=OCBACKUP;  /* PLACE SUPERIOR RESOURCE NAME
*                                      INTO MESSAGE                  */
         L     @01,OPCWORK(,ROPCAVT)                            05S0214
         MVC   RESINACT(8,@01),OCBACKUP(ROPCE)                  05S0214
*               GOTO CE0001@;       /* BRANCH TO END OF CASE         */
         B     CE0001@                                          05S0215
*             END;                  /* END OF SUBCASE                */
*                                                               05S0217
*             /*******************************************************/
*             /*                                                     */
*             /* PROCESS.BUILDMSG.CASE.ACTIVRES: THIS SEGMENT PLACES */
*             /* THE RESOURCE NAME INTO THE REQUIRED FIELD IN THE    */
*             /* MESSAGE TEXT                                        */
*             /*                                                     */
*             /*******************************************************/
*                                                               05S0217
*ACTIVRES:                                                      05S0217
*             DO;                   /* SUBCASE                       */
ACTIVRES DS    0H                                               05S0218
*               RESACTIV=OCBACKUP;  /* PLACE ACTIVE RESOURCE NAME
*                                      INTO MESSAGE                  */
         L     @01,OPCWORK(,ROPCAVT)                            05S0218
         MVC   RESACTIV(8,@01),OCBACKUP(ROPCE)                  05S0218
*               GOTO CE0001@;       /* BRANCH TO END OF CASE         */
         B     CE0001@                                          05S0219
*             END;                  /* END OF SUBCASE                */
*                                                               05S0221
*             /*******************************************************/
*             /*                                                     */
*             /* PROCESS.BUILDMSG.CASE.ISSUE: THIS SEGMENT PLACES THE*/
*             /* RESOURCE NAME INTO THE REQUIRED FIELD IN THE MESSAGE*/
*             /* TEXT                                                */
*             /*                                                     */
*             /*******************************************************/
*                                                               05S0221
*ISSUE:                                                         05S0221
*             DO;                   /* SUBCASE                       */
ISSUE    DS    0H                                               05S0222
*               RESISSUE=OCBACKUP;  /* PLACE ISSUING RESOURCE NAME
*                                      INTO MESSAGE                  */
         L     @01,OPCWORK(,ROPCAVT)                            05S0222
         MVC   RESISSUE(8,@01),OCBACKUP(ROPCE)                  05S0222
*               GOTO CE0001@;       /* BRANCH TO END OF CASE         */
         B     CE0001@                                          05S0223
*             END;                  /* END OF SUBCASE                */
*                                                               05S0225
*             /*******************************************************/
*             /*                                                     */
*             /* PROCESS.BUILDMSG.CASE.RESOURC: THIS SEGMENT PLACES  */
*             /* THE RESOURCE NAME INTO THE REQUIRED FIELD IN THE    */
*             /* MESSAGE TEXT                                        */
*             /*                                                     */
*             /*******************************************************/
*                                                               05S0225
*RESOURC:                                                       05S0225
*             DO;                   /* SUBCASE                       */
RESOURC  DS    0H                                               05S0226
*               RESDCB=OCBACKUP;    /* PLACE RESOURCE NAME INTO 05S0226
*                                      MESSAGE                       */
         L     @01,OPCWORK(,ROPCAVT)                            05S0226
         MVC   RESDCB(8,@01),OCBACKUP(ROPCE)                    05S0226
*               GOTO CE0001@;       /* BRANCH TO END OF CASE         */
         B     CE0001@                                          05S0227
*             END;                  /* END OF SUBCASE                */
*                                                               05S0229
*             /*******************************************************/
*             /*                                                     */
*             /* PROCESS.BUILDMSG.CASE.LNGROUP: THIS SEGMENT PLACES  */
*             /* THE LINE GROUP NAME INTO THE REQUIRED FIELD IN THE  */
*             /* MESSAGE TEXT                                        */
*             /*                                                     */
*             /*******************************************************/
*                                                               05S0229
*LNGROUP:                                                       05S0229
*             DO;                   /* SUBCASE                       */
LNGROUP  DS    0H                                               05S0230
*               LINEGRP=OCBACKUP;   /* PLACE LINE GROUP NAME INTO
*                                      MESSAGE TEXT                  */
         L     @01,OPCWORK(,ROPCAVT)                            05S0230
         MVC   LINEGRP(8,@01),OCBACKUP(ROPCE)                   05S0230
*               GOTO CE0001@;       /* BRANCH TO END OF CASE         */
         B     CE0001@                                          05S0231
*             END;                  /* END OF SUBCASE                */
*                                                               05S0233
*             /*******************************************************/
*             /*                                                     */
*             /* PROCESS.BUILDMSG.CASE.PHYSUNIT: THIS SEGMENT PLACES */
*             /* THE PHYSICAL UNIT NAME INTO THE REQUIRED FIELD IN   */
*             /* THE MESSAGE TEXT                                    */
*             /*                                                     */
*             /*******************************************************/
*                                                               05S0233
*PHYSUNIT:                                                      05S0233
*             DO;                   /* SUBCASE                       */
PHYSUNIT DS    0H                                               05S0234
*               PUNAME=OCBACKUP;    /* PLACE PHYSICAL UNIT NAME INTO
*                                      MESSAGE TEXT                  */
         L     @01,OPCWORK(,ROPCAVT)                            05S0234
         MVC   PUNAME(8,@01),OCBACKUP(ROPCE)                    05S0234
*               GOTO CE0001@;       /* BRANCH TO END OF CASE         */
         B     CE0001@                                          05S0235
*             END;                  /* END OF SUBCASE                */
*                                                               05S0237
*             /*******************************************************/
*             /*                                                     */
*             /* PROCESS.BUILDMSG.CASE.CLOSEDWN: THIS SEGMENT PLACES */
*             /* THE NCP NAME OR DDNAME INTO THE REQUIRED FIELD IN   */
*             /* THE MESSAGE TEXT                                    */
*             /*                                                     */
*             /*******************************************************/
*                                                               05S0237
*CLOSEDWN:                                                      05S0237
*             DO;                   /* SUBCASE                       */
CLOSEDWN DS    0H                                               05S0238
*               NCPDDNME=OCBACKUP;  /* PLACE THE NCP NAME OR DDNAME
*                                      INTO THE MESSAGE TEXT         */
         L     @01,OPCWORK(,ROPCAVT)                            05S0238
         MVC   NCPDDNME(8,@01),OCBACKUP(ROPCE)                  05S0238
*               GOTO CE0001@;       /* BRANCH TO END OF CASE         */
         B     CE0001@                                          05S0239
*             END;                  /* END OF SUBCASE                */
*CE0001@:                                                       04S0241
*           END;                    /* END OF CASE                   */
CE0001@  DS    0H                                               04S0242
*         OPCMODID='07';            /* SET THE MODULE IDENTIFICATION
*                                      CHARACTERS FOR THE NEXTMODULE
*                                      TO BE EXECUTED                */
@RF00200 MVC   OPCMODID(2,ROPCAVT),@CC01322                     03S0242
*       END;                                                    03S0243
*     ELSE                          /* CHECK FOR NO MATCHING TABLE
*                                      ENTRY FOR THE MESSAGE NUMBER  */
*       IF TABMNUM=0                /* LAST TABLE ENTRY REACHED      */
*           |TABMNUM>REG00          /* THERE IS NO TABLE ENTRY FOR
*                                      THE ARGUMENT MESSAGE NUMBER   */
*         THEN                                                  02S0244
         B     @RC00195                                         02S0244
@RF00195 LH    @11,TABMNUM(,PTRENTRY)                           02S0244
         LTR   @11,@11                                          02S0244
         BZ    @RT00244                                         02S0244
         CR    @11,REG00                                        02S0244
         BNH   @RF00244                                         02S0244
@RT00244 DS    0H                                               02S0245
*         DO;                       /* PREPARE TO TRANSFER CONTROL TO
*                                      THE NEXT MESSAGE MODULE       */
*           SEARCH=STOP;            /* INDICATE THAT THE SEARCH IS TO
*                                      BE STOPPED                    */
         NI    SEARCH,B'01111111'                               02S0246
*           OPCMODID='0K';          /* SET MODULE IDENTIFICATION
*                                      CHARACTERS FOR THE NEXT  02S0247
*                                      MESSAGE MODULE IN THE CHAIN   */
         MVC   OPCMODID(2,ROPCAVT),@CC01323                     02S0247
*         END;                                                  02S0248
*   END;                                                        02S0249
@RF00244 DS    0H                                               02S0249
@RC00195 AL    PTRENTRY,@CF00032                                02S0249
@DE00194 TM    SEARCH,B'10000000'                               02S0249
         BO    @DL00194                                         02S0249
*                                                               02S0250
*   /*****************************************************************/
*   /*                                                               */
*   /* EPILOGUE: THIS SEGMENT COMPLETES THE EPILOGUE CODE THAT WAS   */
*   /* ALTERED BY THE MODULE PROCEDURE STATEMENT. THE XCTL ASSEMBLER */
*   /* MACRO INSTRUCTION IS USED BY THIS SEGMENT TO TRANSFER CONTROL */
*   /* TO THE NEXT MODULE THAT IS TO BE EXECUTED.                    */
*   /*                                                               */
*   /*****************************************************************/
*                                                               02S0250
*   RFY                                                         02S0250
*     REG01 RSTD;                   /* RESTRICT THE ARGUMENT REGISTER
*                                      TO BE USED TO CONTAIN THE
*                                      ADDRESS OF THE OPERATOR  02S0250
*                                      CONTROL ADDRESS VECTOR TABLE
*                                      FROM USE BY THE COMPILER      */
*   REG01=ROPCAVT;                  /* SET THE ARGUMENT REGISTER IN
*                                      PREPARATION TO TRANSFERRING
*                                      CONTROL TO THE NEXT MODULE TO
*                                      BE EXECUTED                   */
         LR    REG01,ROPCAVT                                    02S0251
*   GEN EXIT REFS(OPCXCTL,ROPCAVT) NOSEQFLOW SETS(REG15);       02S0252
*                                   /*
         XCTL  SF=(E,OPCXCTL(ROPCAVT)) TRANSFER CONTROL MACRO
*   END IGC0H10D                                                01S0253
*                                                               01S0253
*/* THE FOLLOWING INCLUDE STATEMENTS WERE FOUND IN THIS PROGRAM.     */
*/*%INCLUDE SYSLIB  (TAVTD   )                                       */
*/*%INCLUDE SYSLIB  (TOPCED  )                                       */
*/*%INCLUDE SYSLIB  (TOPCAVTD)                                       */
*/*%INCLUDE SYSUT5  (RFY     )                                       */
*/*%INCLUDE SYSUT5  (DCL     )                                       */
*/*%INCLUDE SYSUT5  (PROLOGUE)                                       */
*/*%INCLUDE SYSUT5  (PROCESS )                                       */
*/*%INCLUDE SYSUT5  (INITIAL )                                       */
*/*%INCLUDE SYSUT5  (BUILDMSG)                                       */
*/*%INCLUDE SYSUT5  (CASE    )                                       */
*/*%INCLUDE SYSUT5  (LSTART  )                                       */
*/*%INCLUDE SYSUT5  (CNTLTOTE)                                       */
*/*%INCLUDE SYSUT5  (SUPERIOR)                                       */
*/*%INCLUDE SYSUT5  (ACTIVRES)                                       */
*/*%INCLUDE SYSUT5  (ISSUE   )                                       */
*/*%INCLUDE SYSUT5  (RESOURC )                                       */
*/*%INCLUDE SYSUT5  (LNGROUP )                                       */
*/*%INCLUDE SYSUT5  (PHYSUNIT)                                       */
*/*%INCLUDE SYSUT5  (CLOSEDWN)                                       */
*/*%INCLUDE SYSUT5  (EPILOGUE)                                       */
*                                                               01S0253
*       ;                                                       01S0253
@DATA    DS    0H
@SM01326 MVC   MSGTEXT(0,@11),MSGSTRNG(@15)
@DATD    DSECT
         DS    0F
IGC0H10D CSECT
         DS    0F
@CF00032 DC    F'12'
@DATD    DSECT
         DS    0D
SEARCH   DS    BL1
         ORG   *+1-(*-@DATD)/(*-@DATD) INSURE DSECT DATA
@ENDDATD EQU   *
IGC0H10D CSECT
         DS    0F
@SIZDATD DC    AL1(0)
         DC    AL3(@ENDDATD-@DATD)
         DS    0D
@CC01322 DC    C'07'
@CC01323 DC    C'0K'
IED510I  DC    CL47'IED510I IN          ALL REQUESTED LINES STARTED'
IED511I  DC    CL48'IED511I IN          SOME REQUESTED LINES STARTED'
IED512I  DC    CL46'IED512I IN          NO REQUESTED LINES STARTED'
IED513I  DC    CL64'IED513I COMMAND FOR          INVALID. SUPERIOR RESOC
               URCE INACTIVE'
IED514I  DC    CL53'IED514I          CONTROLLED BY TOTE. COMMAND REJECTC
               ED'
IED515I  DC    CL77'IED515I SUPERIOR RESOURCE FOR          INACTIVE. LOC
               GICAL ACTIVATION PERFORMED'
IED516I  DC    CL49'IED516I          ALREADY ACTIVE. COMMAND REJECTED'
IED517I  DC    CL71'IED517I COMMAND FOR          AFFECTS ISSUING RESOURC
               CE. COMMAND REJECTED'
IED518I  DC    CL48'IED518I           DCB NOT OPEN. COMMAND REJECTED'
IED541I  DC    CL49'IED541I LINE GROUP          HAS NO LINES ATTACHED'
IED543I  DC    CL47'IED543I IN          ALL REQUESTED LINES STOPPED'
IED544I  DC    CL46'IED544I IN          NO REQUESTED LINES STOPPED'
IED545I  DC    CL48'IED545I IN          SOME REQUESTED LINES STOPPED'
IED554I  DC    CL58'IED554I FOR          ALL REQUESTED LOGICAL UNITS VAC
               RIED ON'
IED555I  DC    CL59'IED555I FOR          SOME REQUESTED LOGICAL UNITS VC
               ARIED ON'
IED556I  DC    CL57'IED556I FOR          NO REQUESTED LOGICAL UNITS VARC
               IED ON'
IED557I  DC    CL59'IED557I FOR          ALL REQUESTED LOGICAL UNITS VAC
               RIED OFF'
IED558I  DC    CL60'IED558I FOR          SOME REQUESTED LOGICAL UNITS VC
               ARIED OFF'
IED559I  DC    CL58'IED559I FOR          NO REQUESTED LOGICAL UNITS VARC
               IED OFF'
IED560I  DC    CL39'IED560I 3705 LINE TRACE ENTRY TRUNCATED'
IED561I  DC    CL66'IED561I PU          HAS NO ATTACHED LOGICAL UNITS.CC
               OMMAND REJECTED'
IED562I  DC    CL48'IED562I NCP OPTION INVALID FOR CONFIGURED SYSTEM'
IED563I  DC    CL50'IED563I CLOSEDOWN ALREADY IN PROGRESS FOR         '
         DS    CL1
PATCH    DC    XL104'0'
TABDATA  DS    CL278
         ORG   TABDATA
@NM00143 DC    H'510'
@NM00144 DC    AL2(47)
@NM00145 DC    AL4(IED510I)
@NM00146 DC    F'1'
@NM00147 DC    H'511'
@NM00148 DC    AL2(48)
@NM00149 DC    AL4(IED511I)
@NM00150 DC    F'1'
@NM00151 DC    H'512'
@NM00152 DC    AL2(46)
@NM00153 DC    AL4(IED512I)
@NM00154 DC    F'1'
@NM00155 DC    H'513'
@NM00156 DC    AL2(64)
@NM00157 DC    AL4(IED513I)
@NM00158 DC    F'5'
@NM00159 DC    H'514'
@NM00160 DC    AL2(53)
@NM00161 DC    AL4(IED514I)
@NM00162 DC    F'2'
@NM00163 DC    H'515'
@NM00164 DC    AL2(77)
@NM00165 DC    AL4(IED515I)
@NM00166 DC    F'3'
@NM00167 DC    H'516'
@NM00168 DC    AL2(49)
@NM00169 DC    AL4(IED516I)
@NM00170 DC    F'4'
@NM00171 DC    H'517'
@NM00172 DC    AL2(71)
@NM00173 DC    AL4(IED517I)
@NM00174 DC    F'5'
@NM00175 DC    H'518'
@NM00176 DC    AL2(48)
@NM00177 DC    AL4(IED518I)
@NM00178 DC    F'6'
@NM00179 DC    H'541'
@NM00180 DC    AL2(49)
@NM00181 DC    AL4(IED541I)
@NM00182 DC    F'7'
@NM00183 DC    H'543'
@NM00184 DC    AL2(47)
@NM00185 DC    AL4(IED543I)
@NM00186 DC    F'1'
@NM00187 DC    H'544'
@NM00188 DC    AL2(46)
@NM00189 DC    AL4(IED544I)
@NM00190 DC    F'1'
@NM00191 DC    H'545'
@NM00192 DC    AL2(48)
@NM00193 DC    AL4(IED545I)
@NM00194 DC    F'1'
@NM00195 DC    H'554'
@NM00196 DC    AL2(58)
@NM00197 DC    AL4(IED554I)
@NM00198 DC    F'8'
@NM00199 DC    H'555'
@NM00200 DC    AL2(59)
@NM00201 DC    AL4(IED555I)
@NM00202 DC    F'8'
@NM00203 DC    H'556'
@NM00204 DC    AL2(57)
@NM00205 DC    AL4(IED556I)
@NM00206 DC    F'8'
@NM00207 DC    H'557'
@NM00208 DC    AL2(59)
@NM00209 DC    AL4(IED557I)
@NM00210 DC    F'8'
@NM00211 DC    H'558'
@NM00212 DC    AL2(60)
@NM00213 DC    AL4(IED558I)
@NM00214 DC    F'8'
@NM00215 DC    H'559'
@NM00216 DC    AL2(58)
@NM00217 DC    AL4(IED559I)
@NM00218 DC    F'8'
@NM00219 DC    H'560'
@NM00220 DC    AL2(39)
@NM00221 DC    AL4(IED560I)
@NM00222 DC    F'0'
@NM00223 DC    H'561'
@NM00224 DC    AL2(66)
@NM00225 DC    AL4(IED561I)
@NM00226 DC    F'1'
@NM00227 DC    H'562'
@NM00228 DC    AL2(48)
@NM00229 DC    AL4(IED562I)
@NM00230 DC    F'0'
@NM00231 DC    H'563'
@NM00232 DC    AL2(50)
@NM00233 DC    AL4(IED563I)
@NM00234 DC    F'9'
TABEND   DC    H'0'
         ORG   TABDATA+278
         DS    CL2
CP0001@  DC    AL4(LSTART)
         DC    AL4(CNTLTOTE)
         DC    AL4(SUPERIOR)
         DC    AL4(ACTIVRES)
         DC    AL4(ISSUE)
         DC    AL4(RESOURC)
         DC    AL4(LNGROUP)
         DC    AL4(PHYSUNIT)
         DC    AL4(CLOSEDWN)
@00      EQU   00                      EQUATES FOR REGISTERS 0-15
@01      EQU   01
@02      EQU   02
@03      EQU   03
@04      EQU   04
@05      EQU   05
@06      EQU   06
@07      EQU   07
@08      EQU   08
@09      EQU   09
@10      EQU   10
@11      EQU   11
@12      EQU   12
@13      EQU   13
@14      EQU   14
@15      EQU   15
PTRENTRY EQU   @05
ROPCE    EQU   @03
ROPCAVT  EQU   @02
RAVT     EQU   @04
REG00    EQU   @00
REG01    EQU   @01
RPARM    EQU   @01
REG10    EQU   @10
RSAVE    EQU   @13
REG15    EQU   @15
IEDQAVTD EQU   0
AVTSAVEX EQU   IEDQAVTD+288
AVTREADD EQU   IEDQAVTD+380
AVTBUFSW EQU   IEDQAVTD+384
@NM00004 EQU   IEDQAVTD+388
AVTCKFLG EQU   @NM00004
AVTBASE  EQU   IEDQAVTD+412
AVTPKF   EQU   AVTBASE
AVTOSECB EQU   IEDQAVTD+492
AVTECB1  EQU   AVTOSECB
AVTHG02  EQU   IEDQAVTD+528
AVTDISP  EQU   IEDQAVTD+552
AVTHD    EQU   IEDQAVTD+556
AVTSCOPT EQU   AVTHD
AVTSAVTP EQU   IEDQAVTD+612
AVTSAVTF EQU   AVTSAVTP
AVTCKPEL EQU   IEDQAVTD+652
AVTCKRMV EQU   AVTCKPEL
AVTCKELF EQU   IEDQAVTD+680
AVTCKBYT EQU   IEDQAVTD+691
AVTHG01  EQU   IEDQAVTD+692
AVTCKLNK EQU   IEDQAVTD+696
AVTCRELE EQU   IEDQAVTD+708
AVTCCELE EQU   AVTCRELE
AVTCLRHI EQU   IEDQAVTD+716
AVTADBUF EQU   IEDQAVTD+720
AVTSYSER EQU   IEDQAVTD+728
AVTBFRFG EQU   IEDQAVTD+784
AVTCKPQB EQU   IEDQAVTD+804
AVTCKPTB EQU   AVTCKPQB
AVTCKPEC EQU   AVTCKPQB+4
AVTCKPCC EQU   AVTCKPEC
AVTOPCQB EQU   IEDQAVTD+816
AVTOPCOB EQU   AVTOPCQB
AVTOPCEC EQU   AVTOPCQB+4
AVTOPCCC EQU   AVTOPCEC
AVTOLTQB EQU   IEDQAVTD+828
AVTCWFL1 EQU   IEDQAVTD+924
AVTCWFL2 EQU   IEDQAVTD+925
AVTSUBT  EQU   IEDQAVTD+948
AVTIOTR  EQU   IEDQAVTD+949
AVTBIT1  EQU   IEDQAVTD+1050
AVTBIT2  EQU   IEDQAVTD+1051
AVTBIT3  EQU   IEDQAVTD+1052
AVTBIT4  EQU   IEDQAVTD+1136
@NM00086 EQU   IEDQAVTD+1232
IEDQAPTR EQU   0
IEDNSVTD EQU   0
SAVTDIAG EQU   IEDNSVTD
SAVTDIAF EQU   SAVTDIAG
SAVTLUSQ EQU   IEDNSVTD+88
SAVTTCPU EQU   IEDNSVTD+238
SAVTZELM EQU   IEDNSVTD+270
SAVTRDRV EQU   IEDNSVTD+284
SAVTCKQB EQU   IEDNSVTD+300
SAVTCKTB EQU   SAVTCKQB
SAVTCKEC EQU   SAVTCKQB+4
SAVTCKCC EQU   SAVTCKEC
IEDQOPCE EQU   0
OCELEM   EQU   IEDQOPCE+4
OCUNIT   EQU   IEDQOPCE+8
OCRUDEST EQU   OCUNIT
OCCKPKEY EQU   OCRUDEST
OCSCAN   EQU   OCCKPKEY
OCOPTCDE EQU   IEDQOPCE+12
OCSWITCH EQU   IEDQOPCE+13
OCFLAG   EQU   IEDQOPCE+14
@NM00109 EQU   IEDQOPCE+16
OCDEST   EQU   @NM00109
OCREQVAL EQU   OCDEST+1
OCLINENO EQU   IEDQOPCE+22
OCTIOT   EQU   OCLINENO
OCTRUNIT EQU   IEDQOPCE+24
OCRSID   EQU   OCTRUNIT
OCALSTAT EQU   OCRSID
OCPARM   EQU   IEDQOPCE+28
OCBACKUP EQU   IEDQOPCE+32
OCMODNME EQU   IEDQOPCE+40
OCIPLWA  EQU   OCMODNME
OCCKDATA EQU   IEDQOPCE+48
OCRSTGTM EQU   OCCKDATA
IEDQOPCN EQU   0
OCLDNME  EQU   IEDQOPCN
OCLINTTE EQU   OCLDNME
OCREQFLG EQU   OCLINTTE+2
OCPREFLG EQU   OCLINTTE+3
IEDQOPCD EQU   0
OPCAVTPT EQU   IEDQOPCD+8
OPCCOPCE EQU   IEDQOPCD+12
OPCSAVE  EQU   IEDQOPCD+56
OPCWORK  EQU   IEDQOPCD+140
OPCAQCTL EQU   IEDQOPCD+180
OPCXCTL  EQU   IEDQOPCD+204
OPCLDNME EQU   IEDQOPCD+212
OPCMODID EQU   OPCLDNME+3
OPCSPEC  EQU   IEDQOPCD+300
OPCPWCOB EQU   IEDQOPCD+368
OPCPWQCB EQU   OPCPWCOB
OPCPWECB EQU   OPCPWCOB+4
MSGSTRNG EQU   0
MSGWORKA EQU   0
MSGLNGTH EQU   MSGWORKA
MSGTEXT  EQU   MSGWORKA+4
TABENTRY EQU   0
TABMNUM  EQU   TABENTRY
TABLNGTH EQU   TABENTRY+2
TABMPTR  EQU   TABENTRY+4
TABCASE  EQU   TABENTRY+8
CL0001@  EQU   0
OCCKPKY1 EQU   OCCKPKEY
OCCKPTYP EQU   OCCKPKY1
OCICACTN EQU   OCMODNME
OCICDADR EQU   OCICACTN
OCICSW   EQU   OCICDADR+3
OPCAQWD  EQU   OPCAQCTL
OPCAQWD1 EQU   OPCAQWD
OPCAQWD2 EQU   OPCAQWD+4
OPCAQWD3 EQU   OPCAQWD+8
MSG510I  EQU   MSGTEXT
MSGGROUP EQU   MSG510I+11
MSG514I  EQU   MSGTEXT
MSGRTOTE EQU   MSG514I+8
MSG515I  EQU   MSGTEXT
RESINACT EQU   MSG515I+30
MSG516I  EQU   MSGTEXT
RESACTIV EQU   MSG516I+8
MSG517I  EQU   MSGTEXT
RESISSUE EQU   MSG517I+20
MSG518I  EQU   MSGTEXT
RESDCB   EQU   MSG518I+8
MSG541I  EQU   MSGTEXT
LINEGRP  EQU   MSG541I+19
MSG554I  EQU   MSGTEXT
PUNAME   EQU   MSG554I+12
MSG563I  EQU   MSGTEXT
NCPDDNME EQU   MSG563I+42
OCCIB    EQU   OCREQVAL
         AGO   .@UNREFD                START UNREFERENCED COMPONENTS
@NM00142 EQU   MSG563I
@NM00141 EQU   MSG554I
@NM00140 EQU   MSG541I
@NM00139 EQU   MSG518I
@NM00138 EQU   MSG517I
@NM00137 EQU   MSG516I
@NM00136 EQU   MSG515I
@NM00135 EQU   MSG514I
@NM00134 EQU   MSG510I
OPCAQLST EQU   OPCAQWD3+1
OPCAQRQ3 EQU   OPCAQWD3
OPCAQSEC EQU   OPCAQWD2+1
OPCAQRQ2 EQU   OPCAQWD2
OPCAQFST EQU   OPCAQWD1+1
OPCAQREQ EQU   OPCAQWD1
OCICINAC EQU   OCICSW
@NM00114 EQU   OCICSW
OCICATST EQU   OCICDADR+1
OCICTYPE EQU   OCICDADR
@NM00113 EQU   OCCKPKY1
OCCKPENV EQU   OCCKPKY1
OCCKPRST EQU   OCCKPTYP
OCCKPNCP EQU   OCCKPTYP
OCCKPINC EQU   OCCKPTYP
@NM00133 EQU   MSGWORKA+2
OPCBOTTM EQU   IEDQOPCD+1188
OPCDSRWT EQU   IEDQOPCD+1184
@NM00132 EQU   IEDQOPCD+1100
@NM00131 EQU   IEDQOPCD+948
@NM00130 EQU   IEDQOPCD+940
@NM00129 EQU   IEDQOPCD+380
@NM00128 EQU   OPCPWCOB+9
@NM00127 EQU   OPCPWCOB+8
@NM00126 EQU   OPCPWECB+1
OPCPWCCC EQU   OPCPWECB
OPCPWCHN EQU   OPCPWQCB+1
OPCPWVTO EQU   OPCPWQCB
OPCWAITV EQU   IEDQOPCD+364
OPCTOTCK EQU   IEDQOPCD+360
OPCAPXTL EQU   IEDQOPCD+356
OPCDECR  EQU   IEDQOPCD+352
OPCBUFWT EQU   IEDQOPCD+348
OPCWRKSP EQU   IEDQOPCD+320
OPCADGOT EQU   IEDQOPCD+318
OPCRQCNT EQU   IEDQOPCD+316
OPPOLSTP EQU   IEDQOPCD+312
OPCCKCIB EQU   IEDQOPCD+308
OPCEND   EQU   IEDQOPCD+307
OPCSTCBS EQU   IEDQOPCD+306
OPCHNEND EQU   IEDQOPCD+302
OPCOQSW  EQU   IEDQOPCD+301
@NM00125 EQU   OPCSPEC
@NM00124 EQU   OPCSPEC
@NM00123 EQU   OPCSPEC
@NM00122 EQU   OPCSPEC
OPCFRMCA EQU   OPCSPEC
OPCRSTRT EQU   OPCSPEC
OPCPART  EQU   OPCSPEC
OPCALTD  EQU   OPCSPEC
OPCBFEND EQU   IEDQOPCD+296
OPCBFIRS EQU   IEDQOPCD+292
OPCAVBUF EQU   IEDQOPCD+290
OPCIPLCT EQU   IEDQOPCD+289
OPCCLNTS EQU   IEDQOPCD+288
OPCHA8   EQU   IEDQOPCD+286
OPCBFREQ EQU   IEDQOPCD+284
OPCFREBF EQU   IEDQOPCD+280
OPCGETBF EQU   IEDQOPCD+276
OPCNEXT  EQU   IEDQOPCD+272
OPCFMDFC EQU   IEDQOPCD+268
OPCSCNC  EQU   IEDQOPCD+264
OPCHORTG EQU   IEDQOPCD+260
OPCHORT  EQU   IEDQOPCD+256
OPCCKPTL EQU   IEDQOPCD+252
OPCCKPTF EQU   IEDQOPCD+248
OPCWAITA EQU   IEDQOPCD+244
OPCWAITR EQU   IEDQOPCD+240
OPCWAITP EQU   IEDQOPCD+236
OPCWAITO EQU   IEDQOPCD+232
OPCWAITN EQU   IEDQOPCD+228
OPCWAITL EQU   IEDQOPCD+224
OPCWAITC EQU   IEDQOPCD+220
@NM00121 EQU   OPCLDNME+5
@NM00120 EQU   OPCLDNME
OPCWAIT  EQU   IEDQOPCD+192
OPCCKERB EQU   IEDQOPCD+164
OPCBFERB EQU   IEDQOPCD+148
OPCFLAG2 EQU   IEDQOPCD+147
OPCFLAG1 EQU   IEDQOPCD+146
OPCWRKSZ EQU   IEDQOPCD+144
OPCRSAVE EQU   IEDQOPCD+132
OPCQCBAD EQU   IEDQOPCD+128
OPCTRMWA EQU   IEDQOPCD+52
OPCPSTWT EQU   IEDQOPCD+48
OPCTNTEA EQU   IEDQOPCD+44
OPCPGCK  EQU   IEDQOPCD+40
OPCLCB   EQU   IEDQOPCD+36
@NM00119 EQU   IEDQOPCD+32
OPCIPLAD EQU   IEDQOPCD+28
OPCTOFLK EQU   IEDQOPCD+24
OPCOPTLK EQU   IEDQOPCD+20
OPCDCBLK EQU   IEDQOPCD+16
OPCDOUBL EQU   IEDQOPCD
@NM00118 EQU   OCLDNME+4
@NM00117 EQU   OCPREFLG
OCTOTEP  EQU   OCPREFLG
OCREPOST EQU   OCPREFLG
OCRSPSNT EQU   OCPREFLG
OCBFREQ  EQU   OCPREFLG
OCIDLE   EQU   OCREQFLG
OCFORCE  EQU   OCREQFLG
OCDCARD  EQU   OCREQFLG
OCPARTAL EQU   OCREQFLG
OCADNCP  EQU   OCREQFLG
@NM00116 EQU   OCREQFLG
@NM00115 EQU   OCREQFLG
OCFLUSHZ EQU   OCREQFLG
OCRESPCT EQU   OCLINTTE
OCCKPTWA EQU   OCCKDATA+4
@NM00112 EQU   OCRSTGTM+2
OCCKDAT2 EQU   OCRSTGTM+1
OCCKDAT1 EQU   OCRSTGTM
OCPTRSAV EQU   OCMODNME+4
OCPUADR  EQU   OCIPLWA+2
OCWTGSAV EQU   OCIPLWA
OCDVRDCT EQU   OCBACKUP+6
OCNCP    EQU   OCBACKUP+4
OCBUFGOT EQU   OCBACKUP+2
OCBUFNED EQU   OCBACKUP
OCWTG    EQU   IEDQOPCE+30
OCRESNUM EQU   OCPARM
OCSEQ    EQU   OCTRUNIT+2
@NM00111 EQU   OCRSID+1
OCNONE   EQU   OCALSTAT
OCSOME   EQU   OCALSTAT
OCALLFLG EQU   OCALSTAT
OCACTREQ EQU   OCALSTAT
OCREDRVE EQU   OCALSTAT
OCSEQIND EQU   OCALSTAT
OCDACTIP EQU   OCALSTAT
OCRENTRD EQU   OCALSTAT
OCWTGB   EQU   OCTIOT
OCTRMTBL EQU   IEDQOPCE+20
@NM00110 EQU   @NM00109+2
OCCONID  EQU   OCDEST
OCRLN    EQU   IEDQOPCE+15
OCRESP   EQU   OCFLAG
OCATTACH EQU   OCFLAG
OCSSCP   EQU   OCFLAG
OCOUTPUT EQU   OCFLAG
OCLINE   EQU   OCFLAG
OCMPP    EQU   OCFLAG
OCTOTE   EQU   OCFLAG
OCCONSOL EQU   OCFLAG
@NM00108 EQU   OCSWITCH
OCQUCKN  EQU   OCSWITCH
OCPRIFLG EQU   OCOPTCDE
@NM00107 EQU   OCRUDEST+1
@NM00106 EQU   OCSCAN
OCNOTUCB EQU   OCSCAN
OCNONAME EQU   OCSCAN
OCALLRLN EQU   OCSCAN
OCDDNAME EQU   OCSCAN
OCDDNRLN EQU   OCSCAN
OCADDR   EQU   OCSCAN
OCELMPTR EQU   OCELEM+1
OCELMPRI EQU   OCELEM
OCLINK   EQU   IEDQOPCE
SAVTLLCB EQU   IEDNSVTD+316
SAVTBITN EQU   IEDNSVTD+312
@NM00105 EQU   SAVTCKQB+8
@NM00104 EQU   SAVTCKEC+1
@NM00103 EQU   SAVTCKCC
SAVTCKPO EQU   SAVTCKCC
SAVTCKWA EQU   SAVTCKCC
SAVTCKCH EQU   SAVTCKTB+1
SAVTCKVT EQU   SAVTCKTB
@NM00102 EQU   IEDNSVTD+297
SAVTRDFG EQU   SAVTRDRV+12
@NM00101 EQU   SAVTRDRV+5
SAVTRDPY EQU   SAVTRDRV+4
SAVTRDQB EQU   SAVTRDRV+1
SAVTRDKY EQU   SAVTRDRV
SAVTNID  EQU   IEDNSVTD+280
SAVTDVAS EQU   IEDNSVTD+276
SAVTPLSZ EQU   IEDNSVTD+274
@NM00100 EQU   IEDNSVTD+273
SAVTSUBL EQU   IEDNSVTD+272
@NM00099 EQU   SAVTZELM+1
SAVTSUBM EQU   SAVTZELM
SAVTMHDX EQU   IEDNSVTD+268
SAVTNAT1 EQU   IEDNSVTD+266
SAVTSH20 EQU   IEDNSVTD+264
SAVTLCBS EQU   IEDNSVTD+260
SAVTRNMP EQU   IEDNSVTD+256
SAVTTNTX EQU   IEDNSVTD+252
SAVTNAX  EQU   IEDNSVTD+248
SAVTSUBV EQU   IEDNSVTD+247
SAVTSUBA EQU   IEDNSVTD+246
SAVTSIBC EQU   IEDNSVTD+244
SAVTBSM  EQU   IEDNSVTD+240
SAVTSCPT EQU   SAVTTCPU
SAVTRQTG EQU   IEDNSVTD+236
SAVTRQCH EQU   IEDNSVTD+232
SAVTMAND EQU   IEDNSVTD+228
SAVTSPLN EQU   IEDNSVTD+224
SAVTNADL EQU   IEDNSVTD+222
SAVTNATL EQU   IEDNSVTD+220
SAVTMHTB EQU   IEDNSVTD+216
SAVTSSMH EQU   IEDNSVTD+212
SAVTQRS  EQU   IEDNSVTD+208
SAVTRQIN EQU   IEDNSVTD+204
SAVTDFCO EQU   IEDNSVTD+200
SAVTSAO  EQU   IEDNSVTD+196
SAVTSARI EQU   IEDNSVTD+192
SAVTSAC  EQU   IEDNSVTD+188
SAVTSAI  EQU   IEDNSVTD+184
SAVTCSCI EQU   IEDNSVTD+180
SAVTSSRP EQU   IEDNSVTD+176
SAVTSSRQ EQU   IEDNSVTD+172
SAVTSCLU EQU   IEDNSVTD+168
SAVTXTRQ EQU   IEDNSVTD+164
SAVTMVBF EQU   IEDNSVTD+160
@NM00098 EQU   IEDNSVTD+148
SAVTIPCQ EQU   IEDNSVTD+144
@NM00097 EQU   IEDNSVTD+136
SAVTXFMI EQU   IEDNSVTD+132
@NM00096 EQU   IEDNSVTD+124
SAVTXFMO EQU   IEDNSVTD+120
@NM00095 EQU   IEDNSVTD+116
SAVTSSSR EQU   IEDNSVTD+112
SAVTSCPQ EQU   IEDNSVTD+108
SAVTSLCB EQU   IEDNSVTD+104
SAVTLUSR EQU   IEDNSVTD+100
@NM00094 EQU   SAVTLUSQ+8
SAVTLUSP EQU   SAVTLUSQ+4
SAVTLUSB EQU   SAVTLUSQ
@NM00093 EQU   IEDNSVTD+84
SAVTSAT  EQU   IEDNSVTD+80
SAVTNAT  EQU   IEDNSVTD+76
SAVTCLUP EQU   IEDNSVTD+72
SAVTPIUT EQU   IEDNSVTD+68
SAVTRNTA EQU   IEDNSVTD+64
SAVTDNIR EQU   IEDNSVTD+60
SAVTCNIR EQU   IEDNSVTD+56
SAVTFLDH EQU   IEDNSVTD+52
SAVTSRTN EQU   IEDNSVTD+48
SAVTSREQ EQU   IEDNSVTD+44
SAVTFAIL EQU   IEDNSVTD+42
SAVTSUSE EQU   IEDNSVTD+40
SAVTSIB  EQU   IEDNSVTD+36
SAVTPRTN EQU   IEDNSVTD+32
@NM00092 EQU   IEDNSVTD+28
SAVTWH20 EQU   IEDNSVTD+26
SAVTPWT  EQU   IEDNSVTD+24
SAVTPRTQ EQU   IEDNSVTD+20
SAVTPREQ EQU   IEDNSVTD+16
SAVTPH20 EQU   IEDNSVTD+14
SAVTPUSE EQU   IEDNSVTD+12
SAVTPLCB EQU   IEDNSVTD+8
SAVTPOOL EQU   IEDNSVTD+4
SAVTPRMT EQU   SAVTDIAF
SAVTVIRT EQU   SAVTDIAF
AVTCPBNO EQU   IEDQAVTD+1244
AVTHRESS EQU   IEDQAVTD+1243
@NM00091 EQU   IEDQAVTD+1242
@NM00090 EQU   IEDQAVTD+1241
@NM00089 EQU   IEDQAVTD+1240
@NM00088 EQU   IEDQAVTD+1237
@NM00087 EQU   IEDQAVTD+1236
AVTHRESE EQU   @NM00086
AVTRADDR EQU   IEDQAVTD+1228
AVTNADDR EQU   IEDQAVTD+1224
AVTHRESN EQU   IEDQAVTD+1220
AVTVOLRN EQU   IEDQAVTD+1216
AVTTOTNN EQU   IEDQAVTD+1212
AVTTRCYN EQU   IEDQAVTD+1208
AVTRCTRN EQU   IEDQAVTD+1204
AVTNOVON EQU   IEDQAVTD+1200
AVTADEBN EQU   IEDQAVTD+1196
AVTVOLRR EQU   IEDQAVTD+1192
AVTTOTNR EQU   IEDQAVTD+1188
AVTTRCYR EQU   IEDQAVTD+1184
AVTRCTRR EQU   IEDQAVTD+1180
AVTNOVOR EQU   IEDQAVTD+1176
AVTADEBR EQU   IEDQAVTD+1172
AVTLODPT EQU   IEDQAVTD+1168
AVTIOBN  EQU   IEDQAVTD+1164
AVTIOBR  EQU   IEDQAVTD+1160
AVTCPBPT EQU   IEDQAVTD+1156
AVTFCPB  EQU   IEDQAVTD+1152
@NM00085 EQU   IEDQAVTD+1148
AVTINCPQ EQU   IEDQAVTD+1144
@NM00084 EQU   IEDQAVTD+1140
@NM00083 EQU   IEDQAVTD+1137
@NM00082 EQU   AVTBIT4
@NM00081 EQU   AVTBIT4
@NM00080 EQU   AVTBIT4
@NM00079 EQU   AVTBIT4
@NM00078 EQU   AVTBIT4
@NM00077 EQU   AVTBIT4
@NM00076 EQU   AVTBIT4
AVTRUFTN EQU   AVTBIT4
@NM00075 EQU   IEDQAVTD+1132
AVTNOBFQ EQU   IEDQAVTD+1128
@NM00074 EQU   IEDQAVTD+1124
AVTDKENQ EQU   IEDQAVTD+1120
@NM00073 EQU   IEDQAVTD+1116
AVTDKAPQ EQU   IEDQAVTD+1112
AVTCOPY  EQU   IEDQAVTD+1108
AVTIA    EQU   IEDQAVTD+1104
AVTFL    EQU   IEDQAVTD+1100
@NM00072 EQU   IEDQAVTD+1096
AVTNCPBQ EQU   IEDQAVTD+1092
AVTTOTNC EQU   IEDQAVTD+1088
AVTCMAX  EQU   IEDQAVTD+1084
AVTCMIN  EQU   IEDQAVTD+1080
AVTHM02  EQU   IEDQAVTD+1076
AVTOPCIN EQU   IEDQAVTD+1074
AVTDCTLN EQU   IEDQAVTD+1072
AVTOPMSK EQU   IEDQAVTD+1068
AVTDDFT  EQU   IEDQAVTD+1064
AVTSTEAL EQU   IEDQAVTD+1060
AVTOPTN  EQU   IEDQAVTD+1056
AVTDSKCT EQU   IEDQAVTD+1054
AVTCKRST EQU   IEDQAVTD+1053
AVTSTAN  EQU   AVTBIT3
AVTSTACN EQU   AVTBIT3
AVTSTAIN EQU   AVTBIT3
AVTSTAYN EQU   AVTBIT3
AVTOLTBN EQU   AVTBIT3
AVTTSAB  EQU   AVTBIT3
AVTRFULN EQU   AVTBIT3
AVTRECVN EQU   AVTBIT3
@NM00071 EQU   AVTBIT2
@NM00070 EQU   AVTBIT2
AVTOPEIN EQU   AVTBIT2
AVTSTRTN EQU   AVTBIT2
AVTTOPOL EQU   AVTBIT2
AVTCOPYN EQU   AVTBIT2
AVTREUSN EQU   AVTBIT2
AVTEXTSC EQU   AVTBIT2
AVTDISKN EQU   AVTBIT1
AVTQUCKN EQU   AVTBIT1
AVTCLOSN EQU   AVTBIT1
AVTREADN EQU   AVTBIT1
AVTDLAYN EQU   AVTBIT1
AVTAQTAN EQU   AVTBIT1
AVTTSON  EQU   AVTBIT1
AVTAPLKN EQU   AVTBIT1
AVTDUMBR EQU   IEDQAVTD+1048
AVTDLQX  EQU   IEDQAVTD+1046
AVTINTLV EQU   IEDQAVTD+1044
AVTSMCNT EQU   IEDQAVTD+1042
AVTAVFCT EQU   IEDQAVTD+1040
AVTOPCON EQU   IEDQAVTD+1038
AVTOPCNT EQU   IEDQAVTD+1036
AVTLNCNT EQU   IEDQAVTD+1034
AVTKEYLE EQU   IEDQAVTD+1032
AVTHA16  EQU   IEDQAVTD+1030
AVTHA7   EQU   IEDQAVTD+1028
AVTHA4   EQU   IEDQAVTD+1026
AVTHA3   EQU   IEDQAVTD+1024
AVTHA2   EQU   IEDQAVTD+1022
AVTGETMS EQU   IEDQAVTD+1021
@NM00069 EQU   IEDQAVTD+1020
AVTGETMD EQU   IEDQAVTD+1016
AVTGETMN EQU   IEDQAVTD+1012
AVTCWTOT EQU   IEDQAVTD+1008
AVTCWINT EQU   IEDQAVTD+956
AVTDTRAP EQU   IEDQAVTD+952
@NM00068 EQU   IEDQAVTD+950
@NM00067 EQU   AVTIOTR
AVTIOTRH EQU   AVTIOTR
AVTIOTRE EQU   AVTIOTR
@NM00066 EQU   AVTSUBT
AVTSUBPT EQU   AVTSUBT
AVTSUBON EQU   AVTSUBT
AVTAFE30 EQU   IEDQAVTD+944
AVTAFE20 EQU   IEDQAVTD+940
AVTAFE10 EQU   IEDQAVTD+936
AVTCWEC2 EQU   IEDQAVTD+932
AVTCWPM2 EQU   IEDQAVTD+928
AVTCWTS2 EQU   IEDQAVTD+927
AVTCWTS1 EQU   IEDQAVTD+926
AVTCWCLD EQU   AVTCWFL2
AVTCWRAP EQU   AVTCWFL2
@NM00065 EQU   AVTCWFL2
@NM00064 EQU   AVTCWFL2
@NM00063 EQU   AVTCWFL2
@NM00062 EQU   AVTCWFL2
@NM00061 EQU   AVTCWFL2
AVTCWACT EQU   AVTCWFL2
@NM00060 EQU   AVTCWFL1
@NM00059 EQU   AVTCWFL1
@NM00058 EQU   AVTCWFL1
@NM00057 EQU   AVTCWFL1
@NM00056 EQU   AVTCWFL1
@NM00055 EQU   AVTCWFL1
@NM00054 EQU   AVTCWFL1
AVTCOMWN EQU   AVTCWFL1
AVTCWEC1 EQU   IEDQAVTD+920
AVTCWPM1 EQU   IEDQAVTD+916
AVTCAREA EQU   IEDQAVTD+912
AVTFZERO EQU   IEDQAVTD+908
AVTCADDR EQU   IEDQAVTD+904
AVTCOREC EQU   IEDQAVTD+900
@NM00053 EQU   IEDQAVTD+892
AVTCPBCB EQU   IEDQAVTD+888
@NM00052 EQU   IEDQAVTD+880
AVTDSIOB EQU   IEDQAVTD+876
@NM00051 EQU   IEDQAVTD+868
AVTCPRMB EQU   IEDQAVTD+864
@NM00050 EQU   IEDQAVTD+856
AVTCLOSB EQU   IEDQAVTD+852
@NM00049 EQU   IEDQAVTD+844
AVTACTIB EQU   IEDQAVTD+840
@NM00048 EQU   IEDQAVTD+836
AVTOLTEB EQU   IEDQAVTD+832
AVTOLTCH EQU   AVTOLTQB+1
AVTOLTVT EQU   AVTOLTQB
@NM00047 EQU   AVTOPCQB+8
@NM00046 EQU   AVTOPCEC+1
@NM00045 EQU   AVTOPCCC
AVTOPCPO EQU   AVTOPCCC
AVTOPCWA EQU   AVTOPCCC
AVTOPCCH EQU   AVTOPCOB+1
AVTOPCVT EQU   AVTOPCOB
@NM00044 EQU   AVTCKPQB+9
AVTCKPTS EQU   AVTCKPQB+8
@NM00043 EQU   AVTCKPEC+1
@NM00042 EQU   AVTCKPCC
AVTCKPPO EQU   AVTCKPCC
AVTCKPWA EQU   AVTCKPCC
AVTCKPCH EQU   AVTCKPTB+1
AVTCKPVT EQU   AVTCKPTB
@NM00041 EQU   IEDQAVTD+796
AVTBFRTB EQU   IEDQAVTD+792
@NM00040 EQU   IEDQAVTD+788
AVTSELCH EQU   IEDQAVTD+785
AVTBFRTN EQU   AVTBFRFG
AVTBFREB EQU   IEDQAVTD+780
AVTTIMQ  EQU   IEDQAVTD+776
@NM00039 EQU   IEDQAVTD+772
AVTIMQPS EQU   IEDQAVTD+768
AVTINOUT EQU   IEDQAVTD+766
AVTREFTM EQU   IEDQAVTD+764
@NM00038 EQU   IEDQAVTD+752
AVTDELYB EQU   IEDQAVTD+748
AVTOCQPT EQU   IEDQAVTD+744
AVTTSOPT EQU   IEDQAVTD+740
AVTSUPPT EQU   IEDQAVTD+736
AVTCBQCB EQU   IEDQAVTD+732
AVTMSGS  EQU   IEDQAVTD+729
@NM00037 EQU   AVTSYSER
@NM00036 EQU   AVTSYSER
@NM00035 EQU   AVTSYSER
@NM00034 EQU   AVTSYSER
@NM00033 EQU   AVTSYSER
@NM00032 EQU   AVTSYSER
AVTCMAXN EQU   AVTSYSER
AVTCMINN EQU   AVTSYSER
AVT2260L EQU   IEDQAVTD+724
AVTABEPL EQU   AVTADBUF
AVTHFF   EQU   AVTCLRHI+2
@NM00031 EQU   AVTCLRHI
AVTCCLNK EQU   AVTCRELE+5
AVTCCPRI EQU   AVTCRELE+4
AVTCCQCB EQU   AVTCCELE+1
AVTCCKEY EQU   AVTCCELE
AVTDELAD EQU   IEDQAVTD+704
AVTDELEM EQU   IEDQAVTD+700
AVTBSX   EQU   AVTCKLNK
AVTOPETR EQU   AVTHG01
@NM00030 EQU   AVTCKBYT
AVTCKONQ EQU   AVTCKBYT
@NM00029 EQU   AVTCKBYT
@NM00028 EQU   AVTCKBYT
@NM00027 EQU   AVTCKBYT
@NM00026 EQU   AVTCKBYT
@NM00025 EQU   AVTCKBYT
@NM00024 EQU   AVTCKBYT
AVTOPERT EQU   IEDQAVTD+690
AVTOPXCL EQU   IEDQAVTD+688
AVTOPERL EQU   IEDQAVTD+687
@NM00023 EQU   IEDQAVTD+686
AVTCKTIM EQU   IEDQAVTD+684
AVTCKELV EQU   IEDQAVTD+682
AVTCPRCD EQU   IEDQAVTD+681
AVTWARMN EQU   AVTCKELF
AVTCRTLN EQU   AVTCKELF
AVTCPIPN EQU   AVTCKELF
AVTCCLCN EQU   AVTCKELF
AVTCINCN EQU   AVTCKELF
@NM00022 EQU   AVTCKELF
AVTCMCPN EQU   AVTCKELF
AVTNQBCK EQU   AVTCKELF
AVTCKQAD EQU   IEDQAVTD+677
AVTSCBSZ EQU   IEDQAVTD+676
@NM00021 EQU   IEDQAVTD+672
AVTCKELE EQU   IEDQAVTD+668
@NM00020 EQU   AVTCKPEL+8
AVTCKRLK EQU   AVTCKPEL+5
AVTCKRPR EQU   AVTCKPEL+4
AVTCKRMQ EQU   AVTCKRMV+1
AVTCKRKY EQU   AVTCKRMV
AVTHK    EQU   IEDQAVTD+648
AVTHI    EQU   IEDQAVTD+644
AVTIOT   EQU   IEDQAVTD+640
AVTNX    EQU   IEDQAVTD+636
AVTTONE  EQU   IEDQAVTD+632
AVTA3TL  EQU   IEDQAVTD+628
AVTDMECB EQU   IEDQAVTD+624
AVTABEND EQU   IEDQAVTD+618
AVTPLCBN EQU   IEDQAVTD+616
@NM00019 EQU   AVTSAVTP+1
@NM00018 EQU   AVTSAVTF
AVTSNA   EQU   AVTSAVTF
AVTONSNA EQU   AVTSAVTF
AVTVTMCP EQU   AVTSAVTF
@NM00017 EQU   IEDQAVTD+608
AVTCMBSS EQU   IEDQAVTD+604
AVTRCV   EQU   IEDQAVTD+600
AVTSEND  EQU   IEDQAVTD+596
AVTCSCH  EQU   IEDQAVTD+592
AVTQ1    EQU   IEDQAVTD+588
AVTE7    EQU   IEDQAVTD+584
AVTHB    EQU   IEDQAVTD+580
AVTR1    EQU   IEDQAVTD+576
AVTBZ    EQU   IEDQAVTD+572
AVTEZ    EQU   IEDQAVTD+568
AVTEC    EQU   IEDQAVTD+564
AVTEW    EQU   IEDQAVTD+560
AVTNDIAL EQU   AVTSCOPT
AVTN2741 EQU   AVTSCOPT
AVTCONCO EQU   AVTSCOPT
AVTCONC  EQU   AVTSCOPT
AVTCMBUF EQU   AVTSCOPT
AVTAPDMP EQU   AVTSCOPT
@NM00016 EQU   AVTSCOPT
AVTHA    EQU   AVTDISP
AVTEA    EQU   IEDQAVTD+548
AVTAX    EQU   IEDQAVTD+544
AVTA3    EQU   IEDQAVTD+540
AVTGD    EQU   IEDQAVTD+536
AVTAL    EQU   IEDQAVTD+532
AVTOLTST EQU   AVTHG02
AVTE8    EQU   IEDQAVTD+524
AVTUI    EQU   IEDQAVTD+520
AVTCOMPT EQU   IEDQAVTD+516
AVTCRSRF EQU   IEDQAVTD+512
@NM00015 EQU   IEDQAVTD+508
AVTKA02  EQU   IEDQAVTD+504
AVTOPTPT EQU   IEDQAVTD+500
AVTPCBPT EQU   IEDQAVTD+496
@NM00014 EQU   AVTECB1
AVTCOMP  EQU   AVTECB1
@NM00013 EQU   AVTECB1
AVTOPECA EQU   IEDQAVTD+488
AVTOLECA EQU   IEDQAVTD+484
AVTCKECA EQU   IEDQAVTD+480
AVTCWECA EQU   IEDQAVTD+476
AVTCWTCB EQU   IEDQAVTD+472
AVTOLTCB EQU   IEDQAVTD+468
AVTOCTCB EQU   IEDQAVTD+464
AVTCKTCB EQU   IEDQAVTD+460
AVTAS    EQU   IEDQAVTD+456
AVTNOLBF EQU   IEDQAVTD+454
AVTNCKPR EQU   IEDQAVTD+453
AVTCIB   EQU   IEDQAVTD+452
AVTSPLPT EQU   IEDQAVTD+448
AVTMVBFR EQU   IEDQAVTD+444
AVTSBTA  EQU   IEDQAVTD+440
AVTRARTN EQU   IEDQAVTD+436
AVTBSCAN EQU   IEDQAVTD+432
AVTRDYA  EQU   IEDQAVTD+428
AVTRNMPT EQU   IEDQAVTD+424
AVTDISTR EQU   IEDQAVTD+420
AVTPARM3 EQU   IEDQAVTD+416
@NM00012 EQU   AVTPKF
@NM00011 EQU   AVTPKF
@NM00010 EQU   AVTPKF
AVTFTCHF EQU   AVTPKF
@NM00009 EQU   AVTPKF
@NM00008 EQU   AVTPKF
@NM00007 EQU   AVTPKF
@NM00006 EQU   AVTPKF
AVTPARM  EQU   IEDQAVTD+408
AVTEXS2A EQU   IEDQAVTD+402
AVTEXA2S EQU   IEDQAVTD+396
AVTOCGET EQU   IEDQAVTD+392
AVTCKAVT EQU   @NM00004+1
@NM00005 EQU   AVTCKFLG
AVTCKHLT EQU   AVTCKFLG
AVTCKREQ EQU   AVTCKFLG
AVTCKENV EQU   AVTCKFLG
AVTCKNAC EQU   AVTCKFLG
AVTCKTAC EQU   AVTCKFLG
AVTBUENT EQU   IEDQAVTD+386
@NM00003 EQU   IEDQAVTD+385
AVTFULLT EQU   AVTBUFSW
AVTUNCON EQU   AVTBUFSW
@NM00002 EQU   AVTBUFSW
AVTBUFTR EQU   AVTREADD
AVTREADY EQU   IEDQAVTD+376
AVTRACE  EQU   IEDQAVTD+372
AVTTCB   EQU   IEDQAVTD+368
AVTPASWD EQU   IEDQAVTD+360
AVTCTLCH EQU   IEDQAVTD+352
AVTDOUBL EQU   IEDQAVTD+344
AVTDOUBX EQU   IEDQAVTD+336
AVTDPARM EQU   IEDQAVTD+332
AVTCSTCS EQU   IEDQAVTD+328
AVTDLQ   EQU   AVTSAVEX+32
@NM00001 EQU   AVTSAVEX
AVTSAVE4 EQU   IEDQAVTD+216
AVTSAVE3 EQU   IEDQAVTD+144
AVTSAVE2 EQU   IEDQAVTD+72
AVTSAVE1 EQU   IEDQAVTD
.@UNREFD ANOP                          END UNREFERENCED COMPONENTS
@ENDDATA EQU   *
         END   IGC0H10D,(C'PLS1906',0701,78089)
