         TITLE 'IGC0K10D, OPERATOR CONTROL MESSAGE MODULE              *
                        '
IGC0K10D CSECT ,                                                01S0001
@PROLOG  BALR  @12,0                                            01S0001
@PSTART  DS    0H                                               01S0001
         USING @PSTART,@12                                      01S0001
*                                   /*
IGC0K10D IEDHJN AFTERHJN,HJN           MODULE IDENTIFICATION MACRO
*   ROPCAVT=RPARM;                  /* ESTABLISH ADDRESSABILITY TO
*                                      THE OPERATOR CONTROL ADDRESS
*                                      VECTOR TABLE                  */
         LR    ROPCAVT,RPARM                                    02S0176
*   RFY                                                         02S0177
*     RPARM UNRSTD;                 /* RELEASE THE REGISTER     02S0177
*                                      RESTRICTED AT ENTRY TO THE
*                                      MODULE THAT CONTAINS THE 02S0177
*                                      ADDRESS OF THE OPERATOR  02S0177
*                                      CONTROL ADDRESS VECTOR TABLE  */
*   REG10=OPCWORK+LENGTH(MSGWORKA); /* SET THE BASE REGISTER TO BE
*                                      USED FOR ADDRESSING AUTOMATIC
*                                      DATA WITH THE ADDRESS OF THE
*                                      SECTION OF THE OPERATOR  02S0178
*                                      CONTROL RESIDENT WORK AREA
*                                      THAT IS AFTER THE SECTION USED
*                                      TO CONSTRUCT MESSAGES         */
         LA    REG10,84                                         02S0178
         AL    REG10,OPCWORK(,ROPCAVT)                          02S0178
*   GEN REFS(REG10) NOSETS;                                     02S0179
*                                   /*
         USING @DATD,REG10             PROVIDE ADDRESSABILITY TO ALL
*                                      AUTOMATIC DATA
*   RSAVE=ADDR(OPCSAVE);            /* SET THE SAVE AREA ADDRESS
*                                      REGISTER WITH THE ADDRESS OF
*                                      THE OPERATOR CONTROL SAVE AREA*/
         LA    RSAVE,OPCSAVE(,ROPCAVT)                          02S0180
*                                                               02S0181
*   /*****************************************************************/
*   /*                                                               */
*   /* PROCESS: THIS SEGMENT DOES THE PROCESSING THAT IS NECESSARY TO*/
*   /* PERFORM THE FUNCTION OF THE MODULE.                           */
*   /*                                                               */
*   /*****************************************************************/
*                                                               02S0181
*                                                               03S0181
*   /*****************************************************************/
*   /*                                                               */
*   /* PROCESS.INITIAL: THIS SEGMENT DOES THE INITIAL PROCESSING.    */
*   /*                                                               */
*   /*****************************************************************/
*                                                               03S0181
*   RAVT=OPCAVTPT;                  /* SET THE BASE POINTER FOR THE
*                                      TCAM ADDRESS VECTOR TABLE     */
         L     RAVT,OPCAVTPT(,ROPCAVT)                          03S0181
*   ROPCE=OPCCOPCE;                 /* SET THE BASE POINTER FOR THE
*                                      OPERATOR CONTROL ELEMENT      */
         L     ROPCE,OPCCOPCE(,ROPCAVT)                         03S0182
*   SEARCH=YES;                     /* INITIALIZE THE "SEARCH" SWITCH
*                                      TO INDICATE THAT A SEARCH IS
*                                      TO BE PERFORMED               */
         OI    SEARCH,B'10000000'                               02S0183
*   DO PTRENTRY=ADDR(TABDATA) BY LENGTH(TABENTRY) WHILE(SEARCH=YES);
         LA    PTRENTRY,TABDATA                                 02S0184
         B     @DE00184                                         02S0184
@DL00184 DS    0H                                               02S0185
*                                   /* INCREMENT THE POINTER TO 02S0185
*                                      ENTRIES IN THE MESSAGE DATA
*                                      TABLE WHILE THE SEARCH IS IN
*                                      PROGRESS                      */
*     IF TABMNUM=REG00              /* MATCHING MESSAGE NUMBERS      */
*       THEN                        /* STOP THE SEARCH AND BUILD THE
*                                      APPROPRIATE MESSAGE           */
         CH    REG00,TABMNUM(,PTRENTRY)                         02S0185
         BNE   @RF00185                                         02S0185
*                                                               03S0186
*       /*************************************************************/
*       /*                                                           */
*       /* PROCESS.BUILDMSG: THIS SEGMENT STOPS THE SEARCH FOR A     */
*       /* MATCHING MESSAGE TABLE ENTRY, BUILDS THE APPROPRIATE      */
*       /* MESSAGE IN THE OPERATOR CONTROL RESIDENT WORK AREA AND    */
*       /* DOES THE PREPARATION THAT IS NECESSARY TO TRANSFER CONTROL*/
*       /* TO THE LAST MODULE IN THE MESSAGE MODULE CHAIN.           */
*       /*                                                           */
*       /*************************************************************/
*                                                               03S0186
*       DO;                                                     03S0186
*         SEARCH=STOP;              /* INDICATE THAT THE SEARCH IS TO
*                                      BE STOPPED                    */
         NI    SEARCH,B'01111111'                               03S0187
*         MSGLNGTH=TABLNGTH;        /* SET THE LENGTH OF THE MESSAGE
*                                      IN THE OPERATOR CONTROL  03S0188
*                                      RESIDENT WORK AREA            */
         L     @11,OPCWORK(,ROPCAVT)                            03S0188
         LH    @01,TABLNGTH(,PTRENTRY)                          03S0188
         STH   @01,MSGLNGTH(,@11)                               03S0188
*         MSGTEXT(1:MSGLNGTH)=MSGSTRNG(1:MSGLNGTH);/* PUT THE MESSAGE
*                                      CHARACTER STRING INTO THE
*                                      MESSAGE TEXT FIELD OF THE WORK
*                                      AREA                          */
         BCTR  @01,0                                            03S0189
         L     @15,TABMPTR(,PTRENTRY)                           03S0189
         EX    @01,@SM01172                                     03S0189
*         IF TABCASE>0              /* ADDITIONAL PROCESSING OF THE
*                                      MESSAGE IS NECESSARY          */
*           THEN                    /* PROCESS THE UNIQUE       03S0190
*                                      REQUIREMENTS OF THE MESSAGE   */
         L     @11,TABCASE(,PTRENTRY)                           03S0190
         LTR   @11,@11                                          03S0190
         BNP   @RF00190                                         03S0190
*                                                               04S0191
*           /*********************************************************/
*           /*                                                       */
*           /* PROCESS.BUILDMSG.CASE: THIS SEGMENT IMPLEMENTS THE    */
*           /* CASE CONTROL STRUCTURE IN ORDER TO SATISFY THE UNIQUE */
*           /* REQUIREMENTS OF THE MESSAGES WITH VARIABLE CHARACTER  */
*           /* FIELDS THAT ARE BUILT IN THE OPERATOR CONTROL RESIDENT*/
*           /* WORK AREA BY THIS MODULE.                             */
*           /*                                                       */
*           /*********************************************************/
*                                                               04S0191
*           DO;                     /* CASE(TABCASE)NAMES(SUBORDIN,AL
*                                      LSUBOR,INVALRLN,ACTIVATE,LDMOD
*                                      ULE,ACTDEACT,CLUSTNME)        */
*             DCL                                               04S0192
*               CL0001@ LABEL BASED(CP0001@(TABCASE)) VALUERANGE(
*                   SUBORDIN,ALLSUBOR,INVALRLN,ACTIVATE,LDMODULE,
*                   ACTDEACT,CLUSTNME);/* BRANCH TARGET              */
*             DCL                                               04S0193
*               CP0001@(7) PTR(31) INIT(ADDR(SUBORDIN),ADDR(ALLSUBOR),
*                   ADDR(INVALRLN),ADDR(ACTIVATE),ADDR(LDMODULE),ADDR(
*                   ACTDEACT),ADDR(CLUSTNME));                  04S0193
*             GOTO CL0001@;         /* BRANCH TO SELECTED CASE       */
         SLA   @11,2                                            04S0194
         L     @01,CP0001@-4(@11)                               04S0194
         BR    @01                                              04S0194
*                                                               05S0195
*             /*******************************************************/
*             /*                                                     */
*             /* PROCESS.BUILDMSG.CASE.SUBORDIN: THIS SEGMENT PLACES */
*             /* THE HOLD OR RELEASE COMMAND,THE RESOURCE NAME,AND   */
*             /* THE RELATIVE LINE NUMBER INTO THE REQUIRED FIELDS IN*/
*             /* THE MESSAGE TEXT                                    */
*             /*                                                     */
*             /*******************************************************/
*                                                               05S0195
*SUBORDIN:                                                      05S0195
*             DO;                   /* SUBCASE                       */
SUBORDIN DS    0H                                               05S0196
*               IF OCOPTCDE=OCHOLD  /* IF THE COMMAND OPERATION CODE
*                                      IS A HOLD COMMAND             */
*                 THEN                                          05S0196
         CLI   OCOPTCDE(ROPCE),X'6C'                            05S0196
         BNE   @RF00196                                         05S0196
*                 DO;                                           05S0197
*                   OPTCMD(1:LENGTH(OPTHELD))=OPTHELD;/* SOME   05S0198
*                                      SUBORDINATES WERE HELD        */
         L     @01,OPCWORK(,ROPCAVT)                            05S0198
         MVC   OPTCMD(4,@01),@CC01038                           05S0198
*                 END;                                          05S0199
*               ELSE                                            05S0200
*                 OPTCMD=OPTRELSE;  /* SOME SUBORDINATES WERE   05S0200
*                                      RELEASED                      */
         B     @RC00196                                         05S0200
@RF00196 L     @01,OPCWORK(,ROPCAVT)                            05S0200
         MVC   OPTCMD(8,@01),@CC01040                           05S0200
*               GRPULNME=OCBACKUP;  /* PLACE SUBORDINATE NAME INTO
*                                      MESSAGE TEXT                  */
@RC00196 L     @11,OPCWORK(,ROPCAVT)                            05S0201
         MVC   GRPULNME(8,@11),OCBACKUP(ROPCE)                  05S0201
*               CVD(OCRLN,OPCDOUBL);                            05S0202
         SLR   @01,@01                                          05S0202
         IC    @01,OCRLN(,ROPCE)                                05S0202
         CVD   @01,OPCDOUBL(,ROPCAVT)                           05S0202
*               UNPK(OPCDOUBL,OPCDOUBL);                        05S0203
         UNPK  OPCDOUBL(8,ROPCAVT),OPCDOUBL(8,ROPCAVT)          05S0203
*               OPCDOUBL(8:8)=OPCDOUBL(8:8)|ZONEMASK;           05S0204
         OI    OPCDOUBL+7(ROPCAVT),C'0'                         05S0204
*               IF OCRLN=NORLN THEN /* DO WE WANT RLN        @YM07016*/
         CLI   OCRLN(ROPCE),0                                   05S0205
         BNE   @RF00205                                         05S0205
*                 MSGLNGTH=MSGLNGTH-MFOUR;/* IF NOT SHORTEN MSG 05S0206
*                                                            @YM07016*/
         LH    @01,MSGLNGTH(,@11)                               05S0206
         SL    @01,@CF00327                                     05S0206
         STH   @01,MSGLNGTH(,@11)                               05S0206
*               ELSE                                            05S0207
*                 RLNMBR=OPCDOUBL(6:8);/* PLACE RELATIVE LINE NUMBER
*                                      INTO MESSAGE TEXT             */
         B     @RC00205                                         05S0207
@RF00205 L     @01,OPCWORK(,ROPCAVT)                            05S0207
         MVC   RLNMBR(3,@01),OPCDOUBL+5(ROPCAVT)                05S0207
*               GOTO CE0001@;       /* BRANCH TO END OF CASE         */
         B     CE0001@                                          05S0208
*             END;                  /* END OF SUBCASE                */
*                                                               05S0210
*             /*******************************************************/
*             /*                                                     */
*             /* PROCESS.BUILDMSG.CASE.ALLSUBOR: THIS SEGMENT PLACES */
*             /* THE HOLD OR RELEASE COMMAND, THE RESOURCE NAME,AND  */
*             /* THE RELATIVE LINE NUMBER INTO THE REQUIRED FIELDS IN*/
*             /* THE MESSAGE TEXT                                    */
*             /*                                                     */
*             /*******************************************************/
*                                                               05S0210
*ALLSUBOR:                                                      05S0210
*             DO;                   /* SUBCASE                       */
ALLSUBOR DS    0H                                               05S0211
*               IF OCOPTCDE=OCHOLD  /* IF THE COMMAND OPERATION CODE
*                                      IS A HOLD COMMAND             */
*                 THEN                                          05S0211
         CLI   OCOPTCDE(ROPCE),X'6C'                            05S0211
         BNE   @RF00211                                         05S0211
*                 DO;                                           05S0212
*                   OPT(1:LENGTH(OPTHELD))=OPTHELD;/* SUBORDINATES
*                                      WERE HELD                     */
         L     @01,OPCWORK(,ROPCAVT)                            05S0213
         MVC   OPT(4,@01),@CC01038                              05S0213
*                 END;                                          05S0214
*               ELSE                                            05S0215
*                 OPT=OPTRELSE;     /* SUBORDINATES WERE RELEASED    */
         B     @RC00211                                         05S0215
@RF00211 L     @01,OPCWORK(,ROPCAVT)                            05S0215
         MVC   OPT(8,@01),@CC01040                              05S0215
*               GRPLNPU=OCBACKUP;   /* PLACE SUBORDINATE NAME INTO
*                                      MESSAGE TEXT                  */
@RC00211 L     @11,OPCWORK(,ROPCAVT)                            05S0216
         MVC   GRPLNPU(8,@11),OCBACKUP(ROPCE)                   05S0216
*               CVD(OCRLN,OPCDOUBL);                            05S0217
         SLR   @01,@01                                          05S0217
         IC    @01,OCRLN(,ROPCE)                                05S0217
         CVD   @01,OPCDOUBL(,ROPCAVT)                           05S0217
*               UNPK(OPCDOUBL,OPCDOUBL);                        05S0218
         UNPK  OPCDOUBL(8,ROPCAVT),OPCDOUBL(8,ROPCAVT)          05S0218
*               OPCDOUBL(8:8)=OPCDOUBL(8:8)|ZONEMASK;           05S0219
         OI    OPCDOUBL+7(ROPCAVT),C'0'                         05S0219
*               IF OCRLN=NORLN THEN /* DO WE WANT RLN        @YM07016*/
         CLI   OCRLN(ROPCE),0                                   05S0220
         BNE   @RF00220                                         05S0220
*                 MSGLNGTH=MSGLNGTH-MFOUR;/* SHORTEN MSG BY FOUR
*                                                            @YM07016*/
         LH    @01,MSGLNGTH(,@11)                               05S0221
         SL    @01,@CF00327                                     05S0221
         STH   @01,MSGLNGTH(,@11)                               05S0221
*               ELSE                                            05S0222
*                 RLN=OPCDOUBL(6:8);/* PLACE RELATIVE LINE NUMBER
*                                      INTO MESSAGE TEXT             */
         B     @RC00220                                         05S0222
@RF00220 L     @01,OPCWORK(,ROPCAVT)                            05S0222
         MVC   RLN(3,@01),OPCDOUBL+5(ROPCAVT)                   05S0222
*               GOTO CE0001@;       /* BRANCH TO END OF CASE         */
         B     CE0001@                                          05S0223
*             END;                  /* END OF SUBCASE                */
*                                                               05S0225
*             /*******************************************************/
*             /*                                                     */
*             /* PROCESS.BUILDMSG.CASE.INVALRLN: THIS SEGMENT PLACES */
*             /* THE RESOURCE NAME AND THE RELATIVE LINE NUMBER INTO */
*             /* THE REQUIRED FIELDS IN THE MESSAGE TEXT             */
*             /*                                                     */
*             /*******************************************************/
*                                                               05S0225
*INVALRLN:                                                      05S0225
*             DO;                   /* SUBCASE                       */
INVALRLN DS    0H                                               05S0226
*               HLDRELSE=OCBACKUP;  /* PLACE GROUP NAME INTO MESSAGE */
         L     @11,OPCWORK(,ROPCAVT)                            05S0226
         MVC   HLDRELSE(8,@11),OCBACKUP(ROPCE)                  05S0226
*               CVD(OCRLN,OPCDOUBL);                            05S0227
         SLR   @01,@01                                          05S0227
         IC    @01,OCRLN(,ROPCE)                                05S0227
         CVD   @01,OPCDOUBL(,ROPCAVT)                           05S0227
*               UNPK(OPCDOUBL,OPCDOUBL);                        05S0228
         UNPK  OPCDOUBL(8,ROPCAVT),OPCDOUBL(8,ROPCAVT)          05S0228
*               OPCDOUBL(8:8)=OPCDOUBL(8:8)|ZONEMASK;           05S0229
         OI    OPCDOUBL+7(ROPCAVT),C'0'                         05S0229
*               RELNMBR=OPCDOUBL(6:8);/* PLACE RELATIVE LINE NUMBER
*                                      INTO MESSAGE                  */
         MVC   RELNMBR(3,@11),OPCDOUBL+5(ROPCAVT)               05S0230
*               GOTO CE0001@;       /* BRANCH TO END OF CASE         */
         B     CE0001@                                          05S0231
*             END;                  /* END OF SUBCASE                */
*                                                               05S0233
*             /*******************************************************/
*             /*                                                     */
*             /* PROCESS.BUILDMSG.CASE.ACTIVATE: THIS SEGMENT PLACES */
*             /* THE RESOURCE NAME INTO THE REQUIRED FIELD IN THE    */
*             /* MESSAGE TEXT                                        */
*             /*                                                     */
*             /*******************************************************/
*                                                               05S0233
*ACTIVATE:                                                      05S0233
*             DO;                   /* SUBCASE                       */
ACTIVATE DS    0H                                               05S0234
*               RESNAME=OCBACKUP;   /* PLACE RESOURCE NAME INTO 05S0234
*                                      MESSAGE                       */
         L     @01,OPCWORK(,ROPCAVT)                            05S0234
         MVC   RESNAME(8,@01),OCBACKUP(ROPCE)                   05S0234
*               GOTO CE0001@;       /* BRANCH TO END OF CASE         */
         B     CE0001@                                          05S0235
*             END;                  /* END OF SUBCASE                */
*                                                               05S0237
*             /*******************************************************/
*             /*                                                     */
*             /* PROCESS.BUILDMSG.CASE.LDMODULE: THIS SEGMENT PLACES */
*             /* THE RESOURCE NAME AND THE LOAD MODULE NAME INTO THE */
*             /* REQUIRED FIELDS IN THE MESSAGE TEXT                 */
*             /*                                                     */
*             /*******************************************************/
*                                                               05S0237
*LDMODULE:                                                      05S0237
*             DO;                   /* SUBCASE                       */
LDMODULE DS    0H                                               05S0238
*               LOADMOD=OCBACKUP;   /* PLACE NAME INTO MESSAGE       */
         L     @11,OPCWORK(,ROPCAVT)                            05S0238
         MVC   LOADMOD(8,@11),OCBACKUP(ROPCE)                   05S0238
*               LDMODID=OCLDNME;    /* PLACE LOAD MODULE ID INTO
*                                      MESSAGE                       */
         LR    @01,ROPCE                                        05S0239
         AL    @01,@CF01174                                     05S0239
         MVC   LDMODID(8,@11),OCLDNME(@01)                      05S0239
*               GOTO CE0001@;       /* BRANCH TO END OF CASE         */
         B     CE0001@                                          05S0240
*             END;                  /* END OF SUBCASE                */
*                                                               05S0242
*             /*******************************************************/
*             /*                                                     */
*             /* PROCESS.BUILDMSG.CASE.ACTDEACT: THIS SEGMENT PLACES */
*             /* THE RESOURCE NAME INTO THE REQUIRED FIELD IN THE    */
*             /* MESSAGE TEXT                                        */
*             /*                                                     */
*             /*******************************************************/
*                                                               05S0242
*ACTDEACT:                                                      05S0242
*             DO;                   /* SUBCASE                       */
ACTDEACT DS    0H                                               05S0243
*               RESOUNME=OCBACKUP;  /* PLACE RESOURCE NAME INTO 05S0243
*                                      MESSAGE                       */
         L     @01,OPCWORK(,ROPCAVT)                            05S0243
         MVC   RESOUNME(8,@01),OCBACKUP(ROPCE)                  05S0243
*               GOTO CE0001@;       /* BRANCH TO END OF CASE         */
         B     CE0001@                                          05S0244
*             END;                  /* END OF SUBCASE                */
*                                                               05S0246
*             /*******************************************************/
*             /*                                                     */
*             /* PROCESS.BUILDMSG.CASE.CLUSTNME: THIS SEGMENT PLACES */
*             /* THE RESOURCE NAME INTO THE REQUIRED FIELD IN THE    */
*             /* MESSAGE TEXT                                        */
*             /*                                                     */
*             /*******************************************************/
*                                                               05S0246
*CLUSTNME:                                                      05S0246
*             DO;                   /* SUBCASE                       */
CLUSTNME DS    0H                                               05S0247
*               CLUSTER=OCBACKUP;   /* PLACE CLUSTER NAME INTO  05S0247
*                                      MESSAGE                       */
         L     @01,OPCWORK(,ROPCAVT)                            05S0247
         MVC   CLUSTER(8,@01),OCBACKUP(ROPCE)                   05S0247
*               GOTO CE0001@;       /* BRANCH TO END OF CASE         */
         B     CE0001@                                          05S0248
*             END;                  /* END OF SUBCASE                */
*CE0001@:                                                       04S0250
*           END;                    /* END OF CASE                   */
CE0001@  DS    0H                                               04S0251
*         OPCMODID='07';            /* SET THE MODULE IDENTIFICATION
*                                      CHARACTERS FOR THE NEXTMODULE
*                                      TO BE EXECUTED                */
@RF00190 MVC   OPCMODID(2,ROPCAVT),@CC01168                     03S0251
*       END;                                                    03S0252
*     ELSE                          /* CHECK FOR NO MATCHING TABLE
*                                      ENTRY FOR THE MESSAGE NUMBER  */
*       IF TABMNUM=0                /* LAST TABLE ENTRY REACHED      */
*           |TABMNUM>REG00          /* THERE IS NO TABLE ENTRY FOR
*                                      THE ARGUMENT MESSAGE NUMBER   */
*         THEN                                                  02S0253
         B     @RC00185                                         02S0253
@RF00185 LH    @11,TABMNUM(,PTRENTRY)                           02S0253
         LTR   @11,@11                                          02S0253
         BZ    @RT00253                                         02S0253
         CR    @11,REG00                                        02S0253
         BNH   @RF00253                                         02S0253
@RT00253 DS    0H                                               02S0254
*         DO;                       /* PREPARE TO TRANSFER CONTROL TO
*                                      THE NEXT MESSAGE MODULE TO
*                                      CONTINUE THE SEARCH           */
*           SEARCH=STOP;            /* INDICATE THAT THE SEARCH IS TO
*                                      BE STOPPED                    */
         NI    SEARCH,B'01111111'                               02S0255
*           OPCMODID='0L';          /* SET MODULE IDENTIFICATION
*                                      CHARACTERS FOR THE NEXT  02S0256
*                                      MESSAGE MODULE IN THE CHAIN   */
         MVC   OPCMODID(2,ROPCAVT),@CC01169                     02S0256
*         END;                                                  02S0257
*   END;                                                        02S0258
@RF00253 DS    0H                                               02S0258
@RC00185 AL    PTRENTRY,@CF00032                                02S0258
@DE00184 TM    SEARCH,B'10000000'                               02S0258
         BO    @DL00184                                         02S0258
*                                                               02S0259
*   /*****************************************************************/
*   /*                                                               */
*   /* EPILOGUE: THIS SEGMENT COMPLETES THE EPILOGUE CODE THAT WAS   */
*   /* ALTERED BY THE MODULE PROCEDURE STATEMENT. THE XCTL ASSEMBLER */
*   /* MACRO INSTRUCTION IS USED BY THIS SEGMENT TO TRANSFER CONTROL */
*   /* TO THE NEXT MODULE THAT IS TO BE EXECUTED.                    */
*   /*                                                               */
*   /*****************************************************************/
*                                                               02S0259
*   RFY                                                         02S0259
*     REG01 RSTD;                   /* RESTRICT THE ARGUMENT REGISTER
*                                      TO BE USED TO CONTAIN THE
*                                      ADDRESS OF THE OPERATOR  02S0259
*                                      CONTROL ADDRESS VECTOR TABLE
*                                      FROM USE BY THE COMPILER      */
*   REG01=ROPCAVT;                  /* SET THE ARGUMENT REGISTER IN
*                                      PREPARATION TO TRANSFERRING
*                                      CONTROL TO THE NEXT MODULE TO
*                                      BE EXECUTED                   */
         LR    REG01,ROPCAVT                                    02S0260
*   GEN EXIT REFS(OPCXCTL,ROPCAVT) NOSEQFLOW SETS(REG15);       02S0261
*                                   /*
         XCTL  SF=(E,OPCXCTL(ROPCAVT)) TRANSFER CONTROL MACRO
*   END IGC0K10D                                                01S0262
*                                                               01S0262
*/* THE FOLLOWING INCLUDE STATEMENTS WERE FOUND IN THIS PROGRAM.     */
*/*%INCLUDE SYSLIB  (TAVTD   )                                       */
*/*%INCLUDE SYSLIB  (TOPCED  )                                       */
*/*%INCLUDE SYSLIB  (TOPCAVTD)                                       */
*/*%INCLUDE SYSUT5  (RFY     )                                       */
*/*%INCLUDE SYSUT5  (DCL     )                                       */
*/*%INCLUDE SYSUT5  (PROLOGUE)                                       */
*/*%INCLUDE SYSUT5  (PROCESS )                                       */
*/*%INCLUDE SYSUT5  (INITIAL )                                       */
*/*%INCLUDE SYSUT5  (BUILDMSG)                                       */
*/*%INCLUDE SYSUT5  (CASE    )                                       */
*/*%INCLUDE SYSUT5  (SUBORDIN)                                       */
*/*%INCLUDE SYSUT5  (ALLSUBOR)                                       */
*/*%INCLUDE SYSUT5  (INVALRLN)                                       */
*/*%INCLUDE SYSUT5  (ACTIVATE)                                       */
*/*%INCLUDE SYSUT5  (LDMODULE)                                       */
*/*%INCLUDE SYSUT5  (ACTDEACT)                                       */
*/*%INCLUDE SYSUT5  (CLUSTNME)                                       */
*/*%INCLUDE SYSUT5  (EPILOGUE)                                       */
*                                                               01S0262
*       ;                                                       01S0262
@DATA    DS    0H
@SM01172 MVC   MSGTEXT(0,@11),MSGSTRNG(@15)
@DATD    DSECT
         DS    0F
IGC0K10D CSECT
         DS    0F
@CF00327 DC    F'4'
@CF00032 DC    F'12'
@CF01174 DC    F'-8'
@DATD    DSECT
         DS    0D
SEARCH   DS    BL1
         ORG   *+1-(*-@DATD)/(*-@DATD) INSURE DSECT DATA
@ENDDATD EQU   *
IGC0K10D CSECT
         DS    0F
@SIZDATD DC    AL1(0)
         DC    AL3(@ENDDATD-@DATD)
         DS    0D
@CC01040 DC    C'RELEASED'
@CC01038 DC    C'HELD'
@CC01168 DC    C'07'
@CC01169 DC    C'0L'
IED521I  DC    CL56'IED521I SOME SUBORDINATES WERE          FOR        C
                ,   '
IED522I  DC    CL54'IED522I ALL SUBORDINATES ARE          FOR         ,C
                  '
IED523I  DC    CL54'IED523I NO SUBORDINATES WERE          FOR         ,C
                  '
IED524I  DC    CL39'IED524I RLN     IS INVALID FOR         '
IED525I  DC    CL45'IED525I COMMAND INVALID FOR RESOURCE         '
IED529I  DC    CL38'IED529I          ACTIVATE UNSUCCESSFUL'
IED530I  DC    CL45'IED530I          PARTIAL ACTIVATION COMPLETED'
IED531I  DC    CL56'IED531I         ACTIVATE UNSUCCESSFUL. SIB POOL SHOC
               RTAGE'
IED532I  DC    CL80'IED532I ACTIVATION OF          ABORTED. LOAD MODULEC
                NAME CONFLICT.ID =          '
IED533I  DC    CL68'IED533I CLUSTER          HAS NO ATTACHED TERMINALS.C
                COMMAND REJECTED'
IED539I  DC    CL38'IED539I          LOGICALLY DEACTIVATED'
         DS    CL1
PATCH    DC    XL104'0'
         DS    CL2
TABDATA  DS    CL134
         ORG   TABDATA
@NM00144 DC    H'521'
@NM00145 DC    AL2(56)
@NM00146 DC    AL4(IED521I)
@NM00147 DC    F'1'
@NM00148 DC    H'522'
@NM00149 DC    AL2(54)
@NM00150 DC    AL4(IED522I)
@NM00151 DC    F'2'
@NM00152 DC    H'523'
@NM00153 DC    AL2(54)
@NM00154 DC    AL4(IED523I)
@NM00155 DC    F'2'
@NM00156 DC    H'524'
@NM00157 DC    AL2(39)
@NM00158 DC    AL4(IED524I)
@NM00159 DC    F'3'
@NM00160 DC    H'525'
@NM00161 DC    AL2(45)
@NM00162 DC    AL4(IED525I)
@NM00163 DC    F'6'
@NM00164 DC    H'529'
@NM00165 DC    AL2(38)
@NM00166 DC    AL4(IED529I)
@NM00167 DC    F'4'
@NM00168 DC    H'530'
@NM00169 DC    AL2(45)
@NM00170 DC    AL4(IED530I)
@NM00171 DC    F'4'
@NM00172 DC    H'531'
@NM00173 DC    AL2(56)
@NM00174 DC    AL4(IED531I)
@NM00175 DC    F'4'
@NM00176 DC    H'532'
@NM00177 DC    AL2(80)
@NM00178 DC    AL4(IED532I)
@NM00179 DC    F'5'
@NM00180 DC    H'533'
@NM00181 DC    AL2(68)
@NM00182 DC    AL4(IED533I)
@NM00183 DC    F'7'
@NM00184 DC    H'539'
@NM00185 DC    AL2(38)
@NM00186 DC    AL4(IED539I)
@NM00187 DC    F'4'
TABEND   DC    H'0'
         ORG   TABDATA+134
         DS    CL2
CP0001@  DC    AL4(SUBORDIN)
         DC    AL4(ALLSUBOR)
         DC    AL4(INVALRLN)
         DC    AL4(ACTIVATE)
         DC    AL4(LDMODULE)
         DC    AL4(ACTDEACT)
         DC    AL4(CLUSTNME)
@00      EQU   00                      EQUATES FOR REGISTERS 0-15
@01      EQU   01
@02      EQU   02
@03      EQU   03
@04      EQU   04
@05      EQU   05
@06      EQU   06
@07      EQU   07
@08      EQU   08
@09      EQU   09
@10      EQU   10
@11      EQU   11
@12      EQU   12
@13      EQU   13
@14      EQU   14
@15      EQU   15
PTRENTRY EQU   @05
ROPCE    EQU   @03
ROPCAVT  EQU   @02
RAVT     EQU   @04
REG00    EQU   @00
REG01    EQU   @01
RPARM    EQU   @01
REG10    EQU   @10
RSAVE    EQU   @13
REG15    EQU   @15
IEDQAVTD EQU   0
AVTSAVEX EQU   IEDQAVTD+288
@NM00003 EQU   IEDQAVTD+388
AVTCKFLG EQU   @NM00003
AVTBASE  EQU   IEDQAVTD+412
AVTPKF   EQU   AVTBASE
AVTHG02  EQU   IEDQAVTD+528
AVTDISP  EQU   IEDQAVTD+552
AVTHD    EQU   IEDQAVTD+556
AVTSCOPT EQU   AVTHD
AVTSAVTP EQU   IEDQAVTD+612
AVTSAVTF EQU   AVTSAVTP
AVTCKPEL EQU   IEDQAVTD+652
AVTCKRMV EQU   AVTCKPEL
AVTCKELF EQU   IEDQAVTD+680
AVTCKBYT EQU   IEDQAVTD+691
AVTHG01  EQU   IEDQAVTD+692
AVTCKLNK EQU   IEDQAVTD+696
AVTCRELE EQU   IEDQAVTD+708
AVTCCELE EQU   AVTCRELE
AVTCLRHI EQU   IEDQAVTD+716
AVTADBUF EQU   IEDQAVTD+720
AVTSYSER EQU   IEDQAVTD+728
AVTCKPQB EQU   IEDQAVTD+804
AVTCKPTB EQU   AVTCKPQB
AVTCKPEC EQU   AVTCKPQB+4
AVTCKPCC EQU   AVTCKPEC
AVTOPCQB EQU   IEDQAVTD+816
AVTOPCOB EQU   AVTOPCQB
AVTOPCEC EQU   AVTOPCQB+4
AVTOPCCC EQU   AVTOPCEC
AVTOLTQB EQU   IEDQAVTD+828
AVTCWFL1 EQU   IEDQAVTD+924
AVTCWFL2 EQU   IEDQAVTD+925
AVTSUBT  EQU   IEDQAVTD+948
AVTIOTR  EQU   IEDQAVTD+949
AVTBIT1  EQU   IEDQAVTD+1050
AVTBIT2  EQU   IEDQAVTD+1051
AVTBIT3  EQU   IEDQAVTD+1052
AVTBIT4  EQU   IEDQAVTD+1136
@NM00083 EQU   IEDQAVTD+1232
IEDQAPTR EQU   0
IEDNSVTD EQU   0
SAVTDIAG EQU   IEDNSVTD
SAVTDIAF EQU   SAVTDIAG
SAVTLUSQ EQU   IEDNSVTD+88
SAVTTCPU EQU   IEDNSVTD+238
SAVTZELM EQU   IEDNSVTD+270
SAVTRDRV EQU   IEDNSVTD+284
SAVTCKQB EQU   IEDNSVTD+300
SAVTCKTB EQU   SAVTCKQB
SAVTCKEC EQU   SAVTCKQB+4
SAVTCKCC EQU   SAVTCKEC
IEDQOPCE EQU   0
OCELEM   EQU   IEDQOPCE+4
OCUNIT   EQU   IEDQOPCE+8
OCRUDEST EQU   OCUNIT
OCCKPKEY EQU   OCRUDEST
OCSCAN   EQU   OCCKPKEY
OCOPTCDE EQU   IEDQOPCE+12
OCSWITCH EQU   IEDQOPCE+13
OCFLAG   EQU   IEDQOPCE+14
OCRLN    EQU   IEDQOPCE+15
@NM00106 EQU   IEDQOPCE+16
OCDEST   EQU   @NM00106
OCREQVAL EQU   OCDEST+1
OCLINENO EQU   IEDQOPCE+22
OCTIOT   EQU   OCLINENO
OCTRUNIT EQU   IEDQOPCE+24
OCRSID   EQU   OCTRUNIT
OCALSTAT EQU   OCRSID
OCPARM   EQU   IEDQOPCE+28
OCBACKUP EQU   IEDQOPCE+32
OCMODNME EQU   IEDQOPCE+40
OCIPLWA  EQU   OCMODNME
OCCKDATA EQU   IEDQOPCE+48
OCRSTGTM EQU   OCCKDATA
IEDQOPCN EQU   0
OCLDNME  EQU   IEDQOPCN
OCLINTTE EQU   OCLDNME
OCREQFLG EQU   OCLINTTE+2
OCPREFLG EQU   OCLINTTE+3
IEDQOPCD EQU   0
OPCDOUBL EQU   IEDQOPCD
OPCAVTPT EQU   IEDQOPCD+8
OPCCOPCE EQU   IEDQOPCD+12
OPCSAVE  EQU   IEDQOPCD+56
OPCWORK  EQU   IEDQOPCD+140
OPCAQCTL EQU   IEDQOPCD+180
OPCXCTL  EQU   IEDQOPCD+204
OPCLDNME EQU   IEDQOPCD+212
OPCMODID EQU   OPCLDNME+3
OPCSPEC  EQU   IEDQOPCD+300
MSGSTRNG EQU   0
MSGWORKA EQU   0
MSGLNGTH EQU   MSGWORKA
MSGTEXT  EQU   MSGWORKA+4
TABENTRY EQU   0
TABMNUM  EQU   TABENTRY
TABLNGTH EQU   TABENTRY+2
TABMPTR  EQU   TABENTRY+4
TABCASE  EQU   TABENTRY+8
CL0001@  EQU   0
OCCKPKY1 EQU   OCCKPKEY
OCCKPTYP EQU   OCCKPKY1
OCICACTN EQU   OCMODNME
OCICDADR EQU   OCICACTN
OCICSW   EQU   OCICDADR+3
OPCAQWD  EQU   OPCAQCTL
OPCAQWD1 EQU   OPCAQWD
OPCAQWD2 EQU   OPCAQWD+4
OPCAQWD3 EQU   OPCAQWD+8
MSG521I  EQU   MSGTEXT
OPTCMD   EQU   MSG521I+31
GRPULNME EQU   MSG521I+44
RLNMBR   EQU   MSG521I+53
MSG522I  EQU   MSGTEXT
OPT      EQU   MSG522I+29
GRPLNPU  EQU   MSG522I+42
RLN      EQU   MSG522I+51
MSG524I  EQU   MSGTEXT
RELNMBR  EQU   MSG524I+12
HLDRELSE EQU   MSG524I+31
MSG525I  EQU   MSGTEXT
RESOUNME EQU   MSG525I+37
MSG529I  EQU   MSGTEXT
RESNAME  EQU   MSG529I+8
MSG532I  EQU   MSGTEXT
LOADMOD  EQU   MSG532I+22
LDMODID  EQU   MSG532I+71
MSG533I  EQU   MSGTEXT
CLUSTER  EQU   MSG533I+16
MSG539I  EQU   MSGTEXT
OCCIB    EQU   OCREQVAL
         AGO   .@UNREFD                START UNREFERENCED COMPONENTS
RESOURCE EQU   MSG539I+8
@NM00143 EQU   MSG539I
@NM00142 EQU   MSG533I
@NM00141 EQU   MSG532I+30
@NM00140 EQU   MSG532I
@NM00139 EQU   MSG529I
@NM00138 EQU   MSG525I
@NM00137 EQU   MSG524I+15
@NM00136 EQU   MSG524I
@NM00135 EQU   MSG522I+50
@NM00134 EQU   MSG522I+37
@NM00133 EQU   MSG522I
@NM00132 EQU   MSG521I+52
@NM00131 EQU   MSG521I+39
@NM00130 EQU   MSG521I
OPCAQLST EQU   OPCAQWD3+1
OPCAQRQ3 EQU   OPCAQWD3
OPCAQSEC EQU   OPCAQWD2+1
OPCAQRQ2 EQU   OPCAQWD2
OPCAQFST EQU   OPCAQWD1+1
OPCAQREQ EQU   OPCAQWD1
OCICINAC EQU   OCICSW
@NM00112 EQU   OCICSW
OCICATST EQU   OCICDADR+1
OCICTYPE EQU   OCICDADR
@NM00111 EQU   OCCKPKY1
OCCKPENV EQU   OCCKPKY1
OCCKPRST EQU   OCCKPTYP
OCCKPNCP EQU   OCCKPTYP
OCCKPINC EQU   OCCKPTYP
@NM00129 EQU   MSGWORKA+2
OPCBOTTM EQU   IEDQOPCD+1172
@NM00128 EQU   IEDQOPCD+1088
@NM00127 EQU   IEDQOPCD+936
@NM00126 EQU   IEDQOPCD+928
@NM00125 EQU   IEDQOPCD+368
OPCWAITV EQU   IEDQOPCD+364
OPCTOTCK EQU   IEDQOPCD+360
OPCAPXTL EQU   IEDQOPCD+356
OPCDECR  EQU   IEDQOPCD+352
OPCBUFWT EQU   IEDQOPCD+348
OPCWRKSP EQU   IEDQOPCD+320
OPCADGOT EQU   IEDQOPCD+318
OPCRQCNT EQU   IEDQOPCD+316
OPPOLSTP EQU   IEDQOPCD+312
OPCCKCIB EQU   IEDQOPCD+308
OPCEND   EQU   IEDQOPCD+307
OPCSTCBS EQU   IEDQOPCD+306
OPCHNEND EQU   IEDQOPCD+302
OPCOQSW  EQU   IEDQOPCD+301
@NM00124 EQU   OPCSPEC
@NM00123 EQU   OPCSPEC
@NM00122 EQU   OPCSPEC
@NM00121 EQU   OPCSPEC
OPCFRMCA EQU   OPCSPEC
OPCRSTRT EQU   OPCSPEC
OPCPART  EQU   OPCSPEC
OPCALTD  EQU   OPCSPEC
OPCBFEND EQU   IEDQOPCD+296
OPCBFIRS EQU   IEDQOPCD+292
OPCAVBUF EQU   IEDQOPCD+290
@NM00120 EQU   IEDQOPCD+289
OPCCLNTS EQU   IEDQOPCD+288
OPCHA8   EQU   IEDQOPCD+286
OPCBFREQ EQU   IEDQOPCD+284
OPCFREBF EQU   IEDQOPCD+280
OPCGETBF EQU   IEDQOPCD+276
OPCNEXT  EQU   IEDQOPCD+272
OPCFMDFC EQU   IEDQOPCD+268
OPCSCNC  EQU   IEDQOPCD+264
OPCHORTG EQU   IEDQOPCD+260
OPCHORT  EQU   IEDQOPCD+256
OPCCKPTL EQU   IEDQOPCD+252
OPCCKPTF EQU   IEDQOPCD+248
OPCWAITA EQU   IEDQOPCD+244
OPCWAITR EQU   IEDQOPCD+240
OPCWAITP EQU   IEDQOPCD+236
OPCWAITO EQU   IEDQOPCD+232
OPCWAITN EQU   IEDQOPCD+228
OPCWAITL EQU   IEDQOPCD+224
OPCWAITC EQU   IEDQOPCD+220
@NM00119 EQU   OPCLDNME+5
@NM00118 EQU   OPCLDNME
OPCWAIT  EQU   IEDQOPCD+192
OPCCKERB EQU   IEDQOPCD+164
OPCBFERB EQU   IEDQOPCD+148
OPCFLAG2 EQU   IEDQOPCD+147
OPCFLAG1 EQU   IEDQOPCD+146
OPCWRKSZ EQU   IEDQOPCD+144
OPCRSAVE EQU   IEDQOPCD+132
OPCQCBAD EQU   IEDQOPCD+128
OPCTRMWA EQU   IEDQOPCD+52
OPCPSTWT EQU   IEDQOPCD+48
OPCTNTEA EQU   IEDQOPCD+44
OPCPGCK  EQU   IEDQOPCD+40
OPCLCB   EQU   IEDQOPCD+36
@NM00117 EQU   IEDQOPCD+32
OPCIPLAD EQU   IEDQOPCD+28
OPCTOFLK EQU   IEDQOPCD+24
OPCOPTLK EQU   IEDQOPCD+20
OPCDCBLK EQU   IEDQOPCD+16
@NM00116 EQU   OCLDNME+4
@NM00115 EQU   OCPREFLG
OCTOTEP  EQU   OCPREFLG
OCREPOST EQU   OCPREFLG
OCRSPSNT EQU   OCPREFLG
OCBFREQ  EQU   OCPREFLG
OCIDLE   EQU   OCREQFLG
OCFORCE  EQU   OCREQFLG
OCDCARD  EQU   OCREQFLG
OCPARTAL EQU   OCREQFLG
OCADNCP  EQU   OCREQFLG
@NM00114 EQU   OCREQFLG
@NM00113 EQU   OCREQFLG
OCFLUSHZ EQU   OCREQFLG
OCRESPCT EQU   OCLINTTE
OCCKPTWA EQU   OCCKDATA+4
@NM00110 EQU   OCRSTGTM+2
OCCKDAT2 EQU   OCRSTGTM+1
OCCKDAT1 EQU   OCRSTGTM
OCPTRSAV EQU   OCMODNME+4
OCPUADR  EQU   OCIPLWA+2
OCWTGSAV EQU   OCIPLWA
OCDVRDCT EQU   OCBACKUP+6
OCNCP    EQU   OCBACKUP+4
OCBUFGOT EQU   OCBACKUP+2
OCBUFNED EQU   OCBACKUP
OCWTG    EQU   IEDQOPCE+30
OCRESNUM EQU   OCPARM
OCSEQ    EQU   OCTRUNIT+2
@NM00109 EQU   OCRSID+1
OCNONE   EQU   OCALSTAT
OCSOME   EQU   OCALSTAT
OCALLFLG EQU   OCALSTAT
OCACTREQ EQU   OCALSTAT
OCREDRVE EQU   OCALSTAT
OCSEQIND EQU   OCALSTAT
@NM00108 EQU   OCALSTAT
OCRENTRD EQU   OCALSTAT
OCWTGB   EQU   OCTIOT
OCTRMTBL EQU   IEDQOPCE+20
@NM00107 EQU   @NM00106+2
OCCONID  EQU   OCDEST
OCRESP   EQU   OCFLAG
OCATTACH EQU   OCFLAG
OCSSCP   EQU   OCFLAG
OCOUTPUT EQU   OCFLAG
OCLINE   EQU   OCFLAG
OCMPP    EQU   OCFLAG
OCTOTE   EQU   OCFLAG
OCCONSOL EQU   OCFLAG
@NM00105 EQU   OCSWITCH
OCQUCKN  EQU   OCSWITCH
OCPRIFLG EQU   OCOPTCDE
@NM00104 EQU   OCRUDEST+1
@NM00103 EQU   OCSCAN
OCNOTUCB EQU   OCSCAN
OCNONAME EQU   OCSCAN
OCALLRLN EQU   OCSCAN
OCDDNAME EQU   OCSCAN
OCDDNRLN EQU   OCSCAN
OCADDR   EQU   OCSCAN
OCELMPTR EQU   OCELEM+1
OCELMPRI EQU   OCELEM
OCLINK   EQU   IEDQOPCE
SAVTBITN EQU   IEDNSVTD+312
@NM00102 EQU   SAVTCKQB+8
@NM00101 EQU   SAVTCKEC+1
@NM00100 EQU   SAVTCKCC
SAVTCKPO EQU   SAVTCKCC
SAVTCKWA EQU   SAVTCKCC
SAVTCKCH EQU   SAVTCKTB+1
SAVTCKVT EQU   SAVTCKTB
@NM00099 EQU   IEDNSVTD+297
SAVTRDFG EQU   SAVTRDRV+12
@NM00098 EQU   SAVTRDRV+5
SAVTRDPY EQU   SAVTRDRV+4
SAVTRDQB EQU   SAVTRDRV+1
SAVTRDKY EQU   SAVTRDRV
SAVTNID  EQU   IEDNSVTD+280
SAVTDVAS EQU   IEDNSVTD+276
SAVTPLSZ EQU   IEDNSVTD+274
@NM00097 EQU   IEDNSVTD+273
SAVTSUBL EQU   IEDNSVTD+272
@NM00096 EQU   SAVTZELM+1
SAVTSUBM EQU   SAVTZELM
SAVTMHDX EQU   IEDNSVTD+268
SAVTNAT1 EQU   IEDNSVTD+266
SAVTSH20 EQU   IEDNSVTD+264
SAVTLCBS EQU   IEDNSVTD+260
SAVTRNMP EQU   IEDNSVTD+256
SAVTTNTX EQU   IEDNSVTD+252
SAVTNAX  EQU   IEDNSVTD+248
SAVTSUBV EQU   IEDNSVTD+247
SAVTSUBA EQU   IEDNSVTD+246
SAVTSIBC EQU   IEDNSVTD+244
SAVTBSM  EQU   IEDNSVTD+240
SAVTSCPT EQU   SAVTTCPU
SAVTRQTG EQU   IEDNSVTD+236
SAVTRQCH EQU   IEDNSVTD+232
SAVTMAND EQU   IEDNSVTD+228
SAVTSPLN EQU   IEDNSVTD+224
SAVTNADL EQU   IEDNSVTD+222
SAVTNATL EQU   IEDNSVTD+220
SAVTMHTB EQU   IEDNSVTD+216
SAVTSSMH EQU   IEDNSVTD+212
SAVTQRS  EQU   IEDNSVTD+208
SAVTRQIN EQU   IEDNSVTD+204
SAVTDFCO EQU   IEDNSVTD+200
SAVTSAO  EQU   IEDNSVTD+196
SAVTSARI EQU   IEDNSVTD+192
SAVTSAC  EQU   IEDNSVTD+188
SAVTSAI  EQU   IEDNSVTD+184
SAVTCSCI EQU   IEDNSVTD+180
SAVTSSRP EQU   IEDNSVTD+176
SAVTSSRQ EQU   IEDNSVTD+172
SAVTSCLU EQU   IEDNSVTD+168
SAVTXTRQ EQU   IEDNSVTD+164
SAVTMVBF EQU   IEDNSVTD+160
@NM00095 EQU   IEDNSVTD+148
SAVTIPCQ EQU   IEDNSVTD+144
@NM00094 EQU   IEDNSVTD+136
SAVTXFMI EQU   IEDNSVTD+132
@NM00093 EQU   IEDNSVTD+124
SAVTXFMO EQU   IEDNSVTD+120
@NM00092 EQU   IEDNSVTD+116
SAVTSSSR EQU   IEDNSVTD+112
SAVTSCPQ EQU   IEDNSVTD+108
SAVTSLCB EQU   IEDNSVTD+104
SAVTLUSR EQU   IEDNSVTD+100
@NM00091 EQU   SAVTLUSQ+8
SAVTLUSP EQU   SAVTLUSQ+4
SAVTLUSB EQU   SAVTLUSQ
@NM00090 EQU   IEDNSVTD+84
SAVTSAT  EQU   IEDNSVTD+80
SAVTNAT  EQU   IEDNSVTD+76
SAVTCLUP EQU   IEDNSVTD+72
SAVTPIUT EQU   IEDNSVTD+68
SAVTRNTA EQU   IEDNSVTD+64
SAVTDNIR EQU   IEDNSVTD+60
SAVTCNIR EQU   IEDNSVTD+56
SAVTFLDH EQU   IEDNSVTD+52
SAVTSRTN EQU   IEDNSVTD+48
SAVTSREQ EQU   IEDNSVTD+44
SAVTFAIL EQU   IEDNSVTD+42
SAVTSUSE EQU   IEDNSVTD+40
SAVTSIB  EQU   IEDNSVTD+36
SAVTPRTN EQU   IEDNSVTD+32
@NM00089 EQU   IEDNSVTD+28
SAVTWH20 EQU   IEDNSVTD+26
SAVTPWT  EQU   IEDNSVTD+24
SAVTPRTQ EQU   IEDNSVTD+20
SAVTPREQ EQU   IEDNSVTD+16
SAVTPH20 EQU   IEDNSVTD+14
SAVTPUSE EQU   IEDNSVTD+12
SAVTPLCB EQU   IEDNSVTD+8
SAVTPOOL EQU   IEDNSVTD+4
SAVTPRMT EQU   SAVTDIAF
SAVTVIRT EQU   SAVTDIAF
AVTCPBNO EQU   IEDQAVTD+1244
AVTHRESS EQU   IEDQAVTD+1243
@NM00088 EQU   IEDQAVTD+1242
@NM00087 EQU   IEDQAVTD+1241
@NM00086 EQU   IEDQAVTD+1240
@NM00085 EQU   IEDQAVTD+1237
@NM00084 EQU   IEDQAVTD+1236
AVTHRESE EQU   @NM00083
AVTRADDR EQU   IEDQAVTD+1228
AVTNADDR EQU   IEDQAVTD+1224
AVTHRESN EQU   IEDQAVTD+1220
AVTVOLRN EQU   IEDQAVTD+1216
AVTTOTNN EQU   IEDQAVTD+1212
AVTTRCYN EQU   IEDQAVTD+1208
AVTRCTRN EQU   IEDQAVTD+1204
AVTNOVON EQU   IEDQAVTD+1200
AVTADEBN EQU   IEDQAVTD+1196
AVTVOLRR EQU   IEDQAVTD+1192
AVTTOTNR EQU   IEDQAVTD+1188
AVTTRCYR EQU   IEDQAVTD+1184
AVTRCTRR EQU   IEDQAVTD+1180
AVTNOVOR EQU   IEDQAVTD+1176
AVTADEBR EQU   IEDQAVTD+1172
AVTLODPT EQU   IEDQAVTD+1168
AVTIOBN  EQU   IEDQAVTD+1164
AVTIOBR  EQU   IEDQAVTD+1160
AVTCPBPT EQU   IEDQAVTD+1156
AVTFCPB  EQU   IEDQAVTD+1152
@NM00082 EQU   IEDQAVTD+1148
AVTINCPQ EQU   IEDQAVTD+1144
@NM00081 EQU   IEDQAVTD+1140
@NM00080 EQU   IEDQAVTD+1137
@NM00079 EQU   AVTBIT4
@NM00078 EQU   AVTBIT4
@NM00077 EQU   AVTBIT4
@NM00076 EQU   AVTBIT4
@NM00075 EQU   AVTBIT4
@NM00074 EQU   AVTBIT4
@NM00073 EQU   AVTBIT4
AVTRUFTN EQU   AVTBIT4
@NM00072 EQU   IEDQAVTD+1132
AVTNOBFQ EQU   IEDQAVTD+1128
@NM00071 EQU   IEDQAVTD+1124
AVTDKENQ EQU   IEDQAVTD+1120
@NM00070 EQU   IEDQAVTD+1116
AVTDKAPQ EQU   IEDQAVTD+1112
AVTCOPY  EQU   IEDQAVTD+1108
AVTIA    EQU   IEDQAVTD+1104
AVTFL    EQU   IEDQAVTD+1100
@NM00069 EQU   IEDQAVTD+1096
AVTNCPBQ EQU   IEDQAVTD+1092
AVTTOTNC EQU   IEDQAVTD+1088
AVTCMAX  EQU   IEDQAVTD+1084
AVTCMIN  EQU   IEDQAVTD+1080
AVTHM02  EQU   IEDQAVTD+1076
AVTOPCIN EQU   IEDQAVTD+1074
AVTDCTLN EQU   IEDQAVTD+1072
AVTOPMSK EQU   IEDQAVTD+1068
AVTDDFT  EQU   IEDQAVTD+1064
AVTSTEAL EQU   IEDQAVTD+1060
AVTOPTN  EQU   IEDQAVTD+1056
AVTDSKCT EQU   IEDQAVTD+1054
AVTCKRST EQU   IEDQAVTD+1053
AVTSTAN  EQU   AVTBIT3
AVTSTACN EQU   AVTBIT3
AVTSTAIN EQU   AVTBIT3
AVTSTAYN EQU   AVTBIT3
AVTOLTBN EQU   AVTBIT3
AVTTSAB  EQU   AVTBIT3
AVTRFULN EQU   AVTBIT3
AVTRECVN EQU   AVTBIT3
@NM00068 EQU   AVTBIT2
@NM00067 EQU   AVTBIT2
AVTOPEIN EQU   AVTBIT2
AVTSTRTN EQU   AVTBIT2
AVTTOPOL EQU   AVTBIT2
AVTCOPYN EQU   AVTBIT2
AVTREUSN EQU   AVTBIT2
AVTEXTSC EQU   AVTBIT2
AVTDISKN EQU   AVTBIT1
AVTQUCKN EQU   AVTBIT1
AVTCLOSN EQU   AVTBIT1
AVTREADN EQU   AVTBIT1
AVTDLAYN EQU   AVTBIT1
AVTAQTAN EQU   AVTBIT1
AVTTSON  EQU   AVTBIT1
AVTAPLKN EQU   AVTBIT1
AVTDUMBR EQU   IEDQAVTD+1048
AVTDLQX  EQU   IEDQAVTD+1046
AVTINTLV EQU   IEDQAVTD+1044
AVTSMCNT EQU   IEDQAVTD+1042
AVTAVFCT EQU   IEDQAVTD+1040
AVTOPCON EQU   IEDQAVTD+1038
AVTOPCNT EQU   IEDQAVTD+1036
AVTLNCNT EQU   IEDQAVTD+1034
AVTKEYLE EQU   IEDQAVTD+1032
AVTHA16  EQU   IEDQAVTD+1030
AVTHA7   EQU   IEDQAVTD+1028
AVTHA4   EQU   IEDQAVTD+1026
AVTHA3   EQU   IEDQAVTD+1024
AVTHA2   EQU   IEDQAVTD+1022
AVTGETMS EQU   IEDQAVTD+1021
@NM00066 EQU   IEDQAVTD+1020
AVTGETMD EQU   IEDQAVTD+1016
AVTGETMN EQU   IEDQAVTD+1012
AVTCWTOT EQU   IEDQAVTD+1008
AVTCWINT EQU   IEDQAVTD+956
AVTDTRAP EQU   IEDQAVTD+952
@NM00065 EQU   IEDQAVTD+950
@NM00064 EQU   AVTIOTR
AVTIOTRH EQU   AVTIOTR
AVTIOTRE EQU   AVTIOTR
@NM00063 EQU   AVTSUBT
AVTSUBPT EQU   AVTSUBT
AVTSUBON EQU   AVTSUBT
AVTAFE30 EQU   IEDQAVTD+944
AVTAFE20 EQU   IEDQAVTD+940
AVTAFE10 EQU   IEDQAVTD+936
AVTCWEC2 EQU   IEDQAVTD+932
AVTCWPM2 EQU   IEDQAVTD+928
AVTCWTS2 EQU   IEDQAVTD+927
AVTCWTS1 EQU   IEDQAVTD+926
AVTCWCLD EQU   AVTCWFL2
AVTCWRAP EQU   AVTCWFL2
@NM00062 EQU   AVTCWFL2
@NM00061 EQU   AVTCWFL2
@NM00060 EQU   AVTCWFL2
@NM00059 EQU   AVTCWFL2
@NM00058 EQU   AVTCWFL2
AVTCWACT EQU   AVTCWFL2
@NM00057 EQU   AVTCWFL1
@NM00056 EQU   AVTCWFL1
@NM00055 EQU   AVTCWFL1
@NM00054 EQU   AVTCWFL1
@NM00053 EQU   AVTCWFL1
@NM00052 EQU   AVTCWFL1
@NM00051 EQU   AVTCWFL1
AVTCOMWN EQU   AVTCWFL1
AVTCWEC1 EQU   IEDQAVTD+920
AVTCWPM1 EQU   IEDQAVTD+916
AVTCAREA EQU   IEDQAVTD+912
AVTFZERO EQU   IEDQAVTD+908
AVTCADDR EQU   IEDQAVTD+904
AVTCOREC EQU   IEDQAVTD+900
@NM00050 EQU   IEDQAVTD+892
AVTCPBCB EQU   IEDQAVTD+888
@NM00049 EQU   IEDQAVTD+880
AVTDSIOB EQU   IEDQAVTD+876
@NM00048 EQU   IEDQAVTD+868
AVTCPRMB EQU   IEDQAVTD+864
@NM00047 EQU   IEDQAVTD+856
AVTCLOSB EQU   IEDQAVTD+852
@NM00046 EQU   IEDQAVTD+844
AVTACTIB EQU   IEDQAVTD+840
@NM00045 EQU   IEDQAVTD+836
AVTOLTEB EQU   IEDQAVTD+832
AVTOLTCH EQU   AVTOLTQB+1
AVTOLTVT EQU   AVTOLTQB
@NM00044 EQU   AVTOPCQB+8
@NM00043 EQU   AVTOPCEC+1
@NM00042 EQU   AVTOPCCC
AVTOPCPO EQU   AVTOPCCC
AVTOPCWA EQU   AVTOPCCC
AVTOPCCH EQU   AVTOPCOB+1
AVTOPCVT EQU   AVTOPCOB
@NM00041 EQU   AVTCKPQB+9
AVTCKPTS EQU   AVTCKPQB+8
@NM00040 EQU   AVTCKPEC+1
@NM00039 EQU   AVTCKPCC
AVTCKPPO EQU   AVTCKPCC
AVTCKPWA EQU   AVTCKPCC
AVTCKPCH EQU   AVTCKPTB+1
AVTCKPVT EQU   AVTCKPTB
@NM00038 EQU   IEDQAVTD+796
AVTBFRTB EQU   IEDQAVTD+792
@NM00037 EQU   IEDQAVTD+784
AVTBFREB EQU   IEDQAVTD+780
AVTTIMQ  EQU   IEDQAVTD+776
@NM00036 EQU   IEDQAVTD+772
AVTIMQPS EQU   IEDQAVTD+768
AVTINOUT EQU   IEDQAVTD+766
AVTREFTM EQU   IEDQAVTD+764
@NM00035 EQU   IEDQAVTD+752
AVTDELYB EQU   IEDQAVTD+748
AVTOCQPT EQU   IEDQAVTD+744
AVTTSOPT EQU   IEDQAVTD+740
AVTSUPPT EQU   IEDQAVTD+736
AVTCBQCB EQU   IEDQAVTD+732
AVTMSGS  EQU   IEDQAVTD+729
@NM00034 EQU   AVTSYSER
@NM00033 EQU   AVTSYSER
@NM00032 EQU   AVTSYSER
@NM00031 EQU   AVTSYSER
@NM00030 EQU   AVTSYSER
@NM00029 EQU   AVTSYSER
AVTCMAXN EQU   AVTSYSER
AVTCMINN EQU   AVTSYSER
AVT2260L EQU   IEDQAVTD+724
AVTABEPL EQU   AVTADBUF
AVTHFF   EQU   AVTCLRHI+2
@NM00028 EQU   AVTCLRHI
AVTCCLNK EQU   AVTCRELE+5
AVTCCPRI EQU   AVTCRELE+4
AVTCCQCB EQU   AVTCCELE+1
AVTCCKEY EQU   AVTCCELE
AVTDELAD EQU   IEDQAVTD+704
AVTDELEM EQU   IEDQAVTD+700
AVTBSX   EQU   AVTCKLNK
AVTOPETR EQU   AVTHG01
@NM00027 EQU   AVTCKBYT
AVTCKONQ EQU   AVTCKBYT
@NM00026 EQU   AVTCKBYT
@NM00025 EQU   AVTCKBYT
@NM00024 EQU   AVTCKBYT
@NM00023 EQU   AVTCKBYT
@NM00022 EQU   AVTCKBYT
@NM00021 EQU   AVTCKBYT
AVTOPERT EQU   IEDQAVTD+690
AVTOPXCL EQU   IEDQAVTD+688
AVTOPERL EQU   IEDQAVTD+687
@NM00020 EQU   IEDQAVTD+686
AVTCKTIM EQU   IEDQAVTD+684
AVTCKELV EQU   IEDQAVTD+682
AVTCPRCD EQU   IEDQAVTD+681
AVTWARMN EQU   AVTCKELF
AVTCRTLN EQU   AVTCKELF
AVTCPIPN EQU   AVTCKELF
AVTCCLCN EQU   AVTCKELF
AVTCINCN EQU   AVTCKELF
@NM00019 EQU   AVTCKELF
AVTCMCPN EQU   AVTCKELF
AVTCRDYN EQU   AVTCKELF
AVTCKQAD EQU   IEDQAVTD+677
AVTSCBSZ EQU   IEDQAVTD+676
@NM00018 EQU   IEDQAVTD+672
AVTCKELE EQU   IEDQAVTD+668
@NM00017 EQU   AVTCKPEL+8
AVTCKRLK EQU   AVTCKPEL+5
AVTCKRPR EQU   AVTCKPEL+4
AVTCKRMQ EQU   AVTCKRMV+1
AVTCKRKY EQU   AVTCKRMV
AVTHK    EQU   IEDQAVTD+648
AVTHI    EQU   IEDQAVTD+644
AVTIOT   EQU   IEDQAVTD+640
AVTNX    EQU   IEDQAVTD+636
AVTTONE  EQU   IEDQAVTD+632
AVTA3TL  EQU   IEDQAVTD+628
AVTDMECB EQU   IEDQAVTD+624
AVTABEND EQU   IEDQAVTD+618
AVTPLCBN EQU   IEDQAVTD+616
@NM00016 EQU   AVTSAVTP+1
@NM00015 EQU   AVTSAVTF
AVTSNA   EQU   AVTSAVTF
AVTONSNA EQU   AVTSAVTF
AVTVTMCP EQU   AVTSAVTF
@NM00014 EQU   IEDQAVTD+608
AVTCMBSS EQU   IEDQAVTD+604
AVTRCV   EQU   IEDQAVTD+600
AVTSEND  EQU   IEDQAVTD+596
AVTCSCH  EQU   IEDQAVTD+592
AVTQ1    EQU   IEDQAVTD+588
AVTE7    EQU   IEDQAVTD+584
AVTHB    EQU   IEDQAVTD+580
AVTR1    EQU   IEDQAVTD+576
AVTBZ    EQU   IEDQAVTD+572
AVTEZ    EQU   IEDQAVTD+568
AVTEC    EQU   IEDQAVTD+564
AVTEW    EQU   IEDQAVTD+560
AVTNDIAL EQU   AVTSCOPT
AVTN2741 EQU   AVTSCOPT
AVTCONCO EQU   AVTSCOPT
AVTCONC  EQU   AVTSCOPT
AVTCMBUF EQU   AVTSCOPT
AVTAPDMP EQU   AVTSCOPT
@NM00013 EQU   AVTSCOPT
AVTHA    EQU   AVTDISP
AVTEA    EQU   IEDQAVTD+548
AVTAX    EQU   IEDQAVTD+544
AVTA3    EQU   IEDQAVTD+540
AVTGD    EQU   IEDQAVTD+536
AVTAL    EQU   IEDQAVTD+532
AVTOLTST EQU   AVTHG02
AVTE8    EQU   IEDQAVTD+524
AVTUI    EQU   IEDQAVTD+520
AVTCOMPT EQU   IEDQAVTD+516
AVTCRSRF EQU   IEDQAVTD+512
@NM00012 EQU   IEDQAVTD+508
AVTKA02  EQU   IEDQAVTD+504
AVTOPTPT EQU   IEDQAVTD+500
AVTPCBPT EQU   IEDQAVTD+496
AVTOSECB EQU   IEDQAVTD+492
AVTOPECA EQU   IEDQAVTD+488
AVTOLECA EQU   IEDQAVTD+484
AVTCKECA EQU   IEDQAVTD+480
AVTCWECA EQU   IEDQAVTD+476
AVTCWTCB EQU   IEDQAVTD+472
AVTOLTCB EQU   IEDQAVTD+468
AVTOCTCB EQU   IEDQAVTD+464
AVTCKTCB EQU   IEDQAVTD+460
AVTAS    EQU   IEDQAVTD+456
AVTNOLBF EQU   IEDQAVTD+454
AVTNCKPR EQU   IEDQAVTD+453
AVTCIB   EQU   IEDQAVTD+452
AVTSPLPT EQU   IEDQAVTD+448
AVTMVBFR EQU   IEDQAVTD+444
AVTSBTA  EQU   IEDQAVTD+440
AVTRARTN EQU   IEDQAVTD+436
AVTBSCAN EQU   IEDQAVTD+432
AVTRDYA  EQU   IEDQAVTD+428
AVTRNMPT EQU   IEDQAVTD+424
AVTDISTR EQU   IEDQAVTD+420
AVTPARM3 EQU   IEDQAVTD+416
@NM00011 EQU   AVTPKF
@NM00010 EQU   AVTPKF
@NM00009 EQU   AVTPKF
AVTFTCHF EQU   AVTPKF
@NM00008 EQU   AVTPKF
@NM00007 EQU   AVTPKF
@NM00006 EQU   AVTPKF
@NM00005 EQU   AVTPKF
AVTPARM  EQU   IEDQAVTD+408
AVTEXS2A EQU   IEDQAVTD+402
AVTEXA2S EQU   IEDQAVTD+396
AVTOCGET EQU   IEDQAVTD+392
AVTCKAVT EQU   @NM00003+1
@NM00004 EQU   AVTCKFLG
AVTCKHLT EQU   AVTCKFLG
AVTCKREQ EQU   AVTCKFLG
AVTCKENV EQU   AVTCKFLG
AVTCKNAC EQU   AVTCKFLG
AVTCKTAC EQU   AVTCKFLG
@NM00002 EQU   IEDQAVTD+384
AVTREADD EQU   IEDQAVTD+380
AVTREADY EQU   IEDQAVTD+376
AVTRACE  EQU   IEDQAVTD+372
AVTTCB   EQU   IEDQAVTD+368
AVTPASWD EQU   IEDQAVTD+360
AVTCTLCH EQU   IEDQAVTD+352
AVTDOUBL EQU   IEDQAVTD+344
AVTDOUBX EQU   IEDQAVTD+336
AVTDPARM EQU   IEDQAVTD+332
AVTCSTCS EQU   IEDQAVTD+328
AVTDLQ   EQU   AVTSAVEX+32
@NM00001 EQU   AVTSAVEX
AVTSAVE4 EQU   IEDQAVTD+216
AVTSAVE3 EQU   IEDQAVTD+144
AVTSAVE2 EQU   IEDQAVTD+72
AVTSAVE1 EQU   IEDQAVTD
.@UNREFD ANOP                          END UNREFERENCED COMPONENTS
@RC00205 EQU   CE0001@
@RC00220 EQU   CE0001@
@ENDDATA EQU   *
         END   IGC0K10D,(C'PLS0950',0701,76363)
