         TITLE 'IGCA610D, ACTIVATE A COMMUNICATIONS CONTROLLER PHYSICAL*
               L UNIT   '
IGCA610D CSECT ,                                                01S0001
@PROLOG  DS    0H                                               01S0002
*                                                               02S0445
*   /*****************************************************************/
*   /*                                                               */
*   /* PROLOGUE: THIS SEGMENT COMPLETES THE PROLOGUE CODE THAT WAS   */
*   /* ALTERED BY THE MODULE PROCEDURE STATEMENT.                    */
*   /*                                                               */
*   /*****************************************************************/
*                                                               02S0445
*   RCODEREG=RENTREG;               /* SET THE CODE BASE REGISTER
*                                      WITH THE ADDRESS OF THE FIRST
*                                      INSTRUCTION OF THE MODULE     */
         LR    RCODEREG,RENTREG                                 02S0445
*   GEN REFS(RCODEREG) NOSETS;                                  02S0446
*                                   /*
         USING IGCA610D,RCODEREG       INFORM THE ASSEMBLER OF THE
*                                      BASE REGISTER TO BE USED FOR
*                                      ADDRESSING CODE
*   GEN NOREFS NOSETS;                                          02S0447
*                                   /*
IGCA610D IEDHJN AFTERHJN,HJN           MODULE IDENTIFICATION MACRO
*   ROPCAVT=RPARMREG;               /* ESTABLISH ADDRESSABILITY TO
*                                      THE OPERATOR CONTROL ADDRESS
*                                      VECTOR TABLE FROM THE INPUT
*                                      PARAMETER REGISTER            */
         LR    ROPCAVT,RPARMREG                                 02S0448
*   RDATAREG=OPCWORK;               /* SET THE REGISTER TO BE USED
*                                      FOR ADDRESSING AUTOMATIC DATA
*                                      WITH THE ADDRESS OF THE  02S0449
*                                      OPERATOR CONTROL RESIDENT WORK
*                                      AREA                          */
         L     RDATAREG,OPCWORK(,ROPCAVT)                       02S0449
*   GEN REFS(RDATAREG) NOSETS;                                  02S0450
*                                   /*
         USING @DATD,RDATAREG          PROVIDE ADDRESSABILITY TO ALL
*                                      AUTOMATIC DATA
*   RSAVEREG=ADDR(OPCSAVE);         /* ESTABLISH ADDRESSABILITY TO
*                                      THE OPERATOR CONTROL SAVE AREA*/
         LA    RSAVEREG,OPCSAVE(,ROPCAVT)                       02S0451
*   RFY                                                         02S0452
*     RPARMREG UNRSTD;              /* RELEASE THE INPUT PARAMETER
*                                      REGISTER THAT WAS RESTRICTED
*                                      AT ENTRY TO THE MODULE        */
*   RFY                                                         02S0453
*     RENTREG UNRSTD;               /* RELEASE THE REGISTER     02S0453
*                                      RESTRICTED AT ENTRY TO THE
*                                      MODULE THAT WAS USED BY THE
*                                      XCTL MACRO TO CONTAIN THE
*                                      ENTRY POINT ADDRESS OF THE
*                                      MODULE                        */
*                                                               02S0454
*   /*****************************************************************/
*   /*                                                               */
*   /* PROCESS: THIS SEGMENT DOES THE PROCESSING THAT IS NECESSARY TO*/
*   /* PERFORM THE FUNCTION OF THE MODULE.                           */
*   /*                                                               */
*   /*****************************************************************/
*                                                               02S0454
*                                                               03S0454
*   /*****************************************************************/
*   /*                                                               */
*   /* PROCESS.INITIAL: THIS SEGMENT DOES THE INITIAL PROCESSING.    */
*   /*                                                               */
*   /*****************************************************************/
*                                                               03S0454
*   RFY                                                         03S0454
*     RPARMREG RSTD;                /* RESTRICT THE REGISTER USED TO
*                                      CONTAIN THE INPUT PARAMETER
*                                      FOR THE IEDQTNT ROUTINE AND
*                                      THE RESULT RETURNED FROM THE
*                                      IEDQTNT ROUTINE               */
*   RAVT=OPCAVTPT;                  /* ESTABLISH ADDRESSABILITY TO
*                                      THE TCAM ADDRESS VECTOR TABLE */
         L     RAVT,OPCAVTPT(,ROPCAVT)                          03S0455
*   ROPCE=OPCCOPCE;                 /* ESTABLISH ADDRESSABILITY TO
*                                      THE INPUT OPERATOR CONTROL
*                                      ELEMENT                       */
         L     ROPCE,OPCCOPCE(,ROPCAVT)                         03S0456
*   RPARMREG=OCTRMTBL;              /* SET UP THE PARAMETER (TERMINAL
*                                      NAME TABLE INDEX) FOR THE
*                                      IEDQTNT ROUTINE               */
         LH    RPARMREG,OCTRMTBL(,ROPCE)                        03S0457
         N     RPARMREG,@CF01675                                03S0457
*   CALL IEDQTNT;                   /* OBTAIN THE ADDRESS OF THE
*                                      TERMINAL TABLE ENTRY FOR THE
*                                      RESOURCE BEING ACTED UPON     */
         L     @15,AVTRNMPT(,RAVT)                              03S0458
         BALR  @14,@15                                          03S0458
*   RTRM=RPARMREG;                  /* ESTABLISH ADDRESSABILITY TO
*                                      THE TERMINAL TABLE ENTRY BY
*                                      USING THE RESULT FROM THE
*                                      IEDQTNT ROUTINE               */
         LR    RTRM,RPARMREG                                    03S0459
*   RFY                                                         03S0460
*     RPARMREG UNRSTD;              /* RELEASE THE PARAMETER REGISTER
*                                      USED BY THE IEDQTNT ROUTINE   */
*   IF OCRESP=OFF                   /* TEST FOR A NEW "ACTIVATE 02S0461
*                                      PHYSICAL UNIT" REQUEST        */
*     THEN                          /* PROCESS THE "ACTIVATE PHYSICAL
*                                      UNIT" REQUEST                 */
         TM    OCRESP(ROPCE),B'00000001'                        02S0461
         BNZ   @RF00461                                         02S0461
*     DO;                                                       02S0462
*                                                               03S0463
*       /*************************************************************/
*       /*                                                           */
*       /* PROCESS.REQUEST: THIS SEGMENT DOES THE PROCESSING FOR AN  */
*       /* "ACTIVATE PHYSICAL UNIT" REQUEST.                         */
*       /*                                                           */
*       /*************************************************************/
*                                                               03S0463
*       RFY                                                     03S0463
*         RPARMREG RSTD;            /* RESTRICT THE REGISTER USED TO
*                                      SPECIFY THE TYPE OF INTERTASK
*                                      REQUEST THAT IS DESIRED       */
*       RPARMREG=REQSGET;           /* SET THE TYPE OF INTERTASK
*                                      REQUEST TO INDICATE THAT THE
*                                      REQUEST IS FOR GETTING A 03S0464
*                                      SESSION INFORMATION CONTROL
*                                      BLOCK (SIB)                   */
         LA    RPARMREG,3                                       03S0464
*       CALL IPSIBREQ;              /* CALL AN INTERNAL PROCEDURE TO
*                                      TRY AND OBTAIN A SIB          */
         BAL   @14,IPSIBREQ                                     03S0465
*       RFY                                                     03S0466
*         RPARMREG UNRSTD;          /* RELEASE THE REGISTER USED FOR
*                                      THE TYPE OF SIB REQUEST       */
*       IF REQRCD1=OBTAINED         /* TEST FOR A GOOD RETURN CODE
*                                      FROM THE EXTERNAL POSTWAIT
*                                      ROUTINE THAT INDICATES THAT A
*                                      SIB HAS BEEN OBTAINED         */
*         THEN                      /* PROCEED WITH NORMAL PROCESSING
*                                      OF THE "ACTIVATE PHYSICAL
*                                      UNIT" REQUEST                 */
         LA    @11,REQAREA                                      03S0467
         CLI   REQRCD1(@11),X'00'                               03S0467
         BNE   @RF00467                                         03S0467
*         DO;                                                   03S0468
*                                                               04S0469
*           /*********************************************************/
*           /*                                                       */
*           /* PROCESS.REQUEST.YESSIB: THIS SEGMENT DOES THE BUILDING*/
*           /* OF THE "ACTIVATE PHYSICAL UNIT" PACKED REQUEST UNIT   */
*           /* AND DOES THE PREPARATION THAT IS NECESSARY TO SEND OUT*/
*           /* THE REQUEST. THE ALLOCBUF EXTERNAL ROUTINE IS USED TO */
*           /* OBTAIN A BUFFER UNIT FOR THE "ACTIVATE PHYSICAL UNIT" */
*           /* REQUEST.                                              */
*           /*                                                       */
*           /*********************************************************/
*                                                               04S0469
*           OCWTGB=OCWTG;           /* SAVE THE OPERATOR CONTROL
*                                      ELEMENT "WHERE TO GO" FIELD IN
*                                      THE OPERATOR CONTROL ELEMENT
*                                      "WHERE TO GO BACK-UP" FIELD   */
         MVC   OCWTGB(2,ROPCE),OCWTG(ROPCE)                     04S0469
*           RFY                                                 04S0470
*             RPARMREG RSTD;        /* RESTRICT THE REGISTER USED TO
*                                      CONTAIN THE NUMBER OF BUFFER
*                                      UNITS THAT ARE DESIRED        */
*           RPARMREG=1;             /* SET THE NUMBER OF UNITS  04S0471
*                                      DESIRED TO ONE (1) BUFFER UNIT*/
         LA    RPARMREG,1                                       04S0471
*           CALL ALLOCBUF;          /* CALL TO GET A BUFFER UNIT VIA
*                                      THE ALLOCBUF ROUTINE          */
         L     @15,OPCGETBF(,ROPCAVT)                           04S0472
         BALR  @14,@15                                          04S0472
*           OCUNIT=RPARMREG;        /* ATTACH THE BUFFER UNIT TO THE
*                                      OPERATOR CONTROL ELEMENT      */
         ST    RPARMREG,OCUNIT(,ROPCE)                          04S0473
*           RFY                                                 04S0474
*             RPARMREG UNRSTD;      /* RELEASE THE PARAMETER REGISTER
*                                      USED BY THE ALLOCBUF ROUTINE  */
*           CALL IPSNDREQ(ACTREQ,LENGTH(ACTREQ));/* CALL AN INTERNAL
*                                      PROCEDURE TO PREPARE TO SEND
*                                      OUT AN "ACTIVATE PHYSICAL
*                                      UNIT" REQUEST                 */
         LA    @01,@AL00475                                     04S0475
         BAL   @14,IPSNDREQ                                     04S0475
*         END;                                                  03S0476
*       ELSE                        /* RETURN THE INPUT ELEMENT TO
*                                      THE REQUESTOR OF THE "ACTIVATE
*                                      PHYSICAL UNIT" REQUEST WITH AN
*                                      ERROR INDICATION              */
*         DO;                                                   03S0477
         B     @RC00467                                         03S0477
@RF00467 DS    0H                                               03S0478
*                                                               04S0478
*           /*********************************************************/
*           /*                                                       */
*           /* PROCESS.REQUEST.NOSIB: THIS SEGMENT PREPARES THE INPUT*/
*           /* OPERATOR CONTROL ELEMENT THAT IS TO BE SENT BACK TO   */
*           /* THE REQUESTOR OF THE "ACTIVATE PHYSICAL UNIT" REQUEST */
*           /* WITH A BAD RETURN CODE.                               */
*           /*                                                       */
*           /*********************************************************/
*                                                               04S0478
*           OCRESP=ON;              /* INDICATE THAT THE OPERATOR
*                                      CONTROL ELEMENT IS A RESPONSE */
         OI    OCRESP(ROPCE),B'00000001'                        04S0478
*           OCPARM=OCRCBSIB;        /* SET THE RETURN CODE TO   04S0479
*                                      INDICATE THAT A SESSION  04S0479
*                                      INFORMATION CONTROL BLOCK
*                                      COULD NOT BE OBTAINED         */
         MVC   OCPARM(2,ROPCE),@CH01013                         04S0479
*           OPCMODID=OCWTG;         /* SET THE MODULE IDENTIFICATION
*                                      FOR THE XCTL MACRO FROM THE
*                                      OPERATOR CONTROL ELEMENT 04S0480
*                                      "WHERE TO GO FIELD"           */
         MVC   OPCMODID(2,ROPCAVT),OCWTG(ROPCE)                 04S0480
*           OCWTG=''B;              /* ZERO THE OPERATOR CONTROL
*                                      "WHERE TO GO" FIELD TO   04S0481
*                                      INDICATE THAT THE PROCESSING
*                                      OF THE ACTPU REQUEST HAS ENDED*/
         XC    OCWTG(2,ROPCE),OCWTG(ROPCE)                      04S0481
*         END;                                                  03S0482
*     END;                                                      02S0483
*   ELSE                            /* DETERMINE THE TYPE OF THE
*                                      RESPONSE INPUT ELEMENT AND
*                                      PROCESS THE RESPONSE          */
*     DO;                                                       02S0484
         B     @RC00461                                         02S0484
@RF00461 DS    0H                                               02S0485
*                                                               03S0485
*       /*************************************************************/
*       /*                                                           */
*       /* PROCESS.RESPONSE: THIS SEGMENT DETERMINES THE TYPE OF     */
*       /* RESPONSE THAT IS TO BE PROCESSED AND PROCESSES THE        */
*       /* RESPONSE ACCORDINGLY.                                     */
*       /*                                                           */
*       /*************************************************************/
*                                                               03S0485
*       PTRRESP=ADDR(PRUDATA);      /* ESTABLISH ADDRESSABILITY TO
*                                      THE RESPONSE UNIT DATA        */
         L     @11,OCUNIT(,ROPCE)                               03S0485
         LA    PTRRESP,PRUDATA(,@11)                            03S0485
*       IF PRURHSDI=ON              /* TEST FOR THE PRESENCE OF SENSE
*                                      DATA                          */
*         THEN                      /* INCREMENT THE RESPONSE POINTER
*                                      TO THE BEGINNING OF THE  03S0486
*                                      RESPONSE UNIT                 */
         AL    @11,@CF01677                                     03S0486
         TM    PRURHSDI(@11),B'00000100'                        03S0486
         BNO   @RF00486                                         03S0486
*         PTRRESP=PTRRESP+LENGTH(SENSE);/* INDEX POINTER BY THE 03S0487
*                                      LENGTH OF THE SENSE DATA      */
         AL    PTRRESP,@CF00328                                 03S0487
*       IF RESPCODE=CD1ACTPU        /* TEST FOR AN "ACTIVATE PHYSICAL
*                                      UNIT" RESPONSE                */
*         THEN                      /* PROCESS THE "ACTIVATE PHYSICAL
*                                      UNIT" RESPONSE                */
@RF00486 CLI   RESPCODE(PTRRESP),X'11'                          03S0488
         BNE   @RF00488                                         03S0488
*         DO;                                                   03S0489
*                                                               04S0490
*           /*********************************************************/
*           /*                                                       */
*           /* PROCESS.RESPONSE.RESPACT: THIS SEGMENT PROCESSES THE  */
*           /* "ACTIVATE PHYSICAL UNIT" RESPONSE.                    */
*           /*                                                       */
*           /*********************************************************/
*                                                               04S0490
*           IF SIBSSTAT=SIBSACTV    /* TEST FOR THE "SESSION ACTIVE"
*                                      STATE OF THE PHYSICAL UNIT    */
*             THEN                  /* PROCEED WITH PROCESSING THE
*                                      GOOD RESPONSE                 */
         LR    @11,RTRM                                         04S0490
         AL    @11,@CF01678                                     04S0490
         SLR   @05,@05                                          04S0490
         ICM   @05,7,TRMSIBPT-7(@11)                            04S0490
         TM    SIBSSTAT(@05),B'00011100'                        04S0490
         BNO   @RF00490                                         04S0490
*             DO;                                               04S0491
*                                                               05S0492
*               /*****************************************************/
*               /*                                                   */
*               /* PROCESS.RESPONSE.RESPACT.CHECKMOD: THIS SEGMENT   */
*               /* CHECKS THE CONTENTS IDENTIFICATION OF THE LOAD    */
*               /* MODULE IN THE COMMUNICATIONS CONTROLLER AGAINST   */
*               /* THE NCP TEXT IDENTIFICATION KNOWN TO TCAM.        */
*               /*                                                   */
*               /*****************************************************/
*                                                               05S0492
*               RFY                                             05S0492
*                 RWORK RSTD;                                   05S0492
*               RFY                                             05S0493
*                 RPARMREG RSTD;                                05S0493
*               RFY                                             05S0494
*                 RRETCODE RSTD;                                05S0494
*               RWORK=TRMNCPIM;     /* SET THE COMMUNICATIONS   05S0495
*                                      CONTROLLER MASK REGISTER      */
         LA    RWORK,8                                          05S0495
*               RPARMREG=RTRM;      /* SET THE TERMINAL TABLE ENTRY
*                                      ADDRESS PARAMETER REGISTER    */
         LR    RPARMREG,RTRM                                    05S0496
*               CALL IEDQTL;        /* OBTAIN THE ADDRESS OF THE NCP
*                                      DEVICE DEPENDENCY STRUCTURE   */
         L     @15,AVTDDFT(,RAVT)                               05S0497
         BALR  @14,@15                                          05S0497
*               PTRNCPDD=RRETCODE;  /* ESTABLISH ADDRESSABILITY TO
*                                      THE NCP DEVICE DEPENDENCY
*                                      INFORMATION WITH THE POINTER
*                                      RETURNED FROM THE IEDQTL 05S0498
*                                      ROUTINE                       */
         LR    PTRNCPDD,RRETCODE                                05S0498
*               RFY                                             05S0499
*                 RWORK UNRSTD;                                 05S0499
*               RFY                                             05S0500
*                 RPARMREG UNRSTD;                              05S0500
*               RFY                                             05S0501
*                 RRETCODE UNRSTD;                              05S0501
*               OCBACKUP=ACTRCONT;  /* SAVE THE CONTENTS        05S0502
*                                      IDENTIFICATION FIELD OF THE
*                                      "ACTIVATE PHYSICAL UNIT" 05S0502
*                                      RESPONSE                      */
         MVC   OCBACKUP(8,ROPCE),ACTRCONT(PTRRESP)              05S0502
*               IF NCPTXID=OCBACKUP /* COMPARE LOAD MODULE NAMES FOR
*                                      EQUALITY                      */
*                 THEN              /* PREPARE TO SEND A "START DATA
*                                      TRAFFIC" REQUEST              */
         CLC   NCPTXID(8,PTRNCPDD),OCBACKUP(ROPCE)              05S0503
         BNE   @RF00503                                         05S0503
*                 CALL IPSNDREQ(SDTREQ,LENGTH(SDTREQ));         05S0504
         LA    @01,@AL00504                                     05S0504
         BAL   @14,IPSNDREQ                                     05S0504
*               ELSE                /* SET A BAD RETURN CODE AND
*                                      PREPARE TO SEND A "DEACTIVATE
*                                      PHYSICAL UNIT" REQUEST        */
*                 DO;                                           05S0505
         B     @RC00503                                         05S0505
@RF00503 DS    0H                                               05S0506
*                   OCPARM=OCRCBMOD;                            05S0506
         MVC   OCPARM(2,ROPCE),@CH01017                         05S0506
*                   CALL IPSNDREQ(DACTREQ,LENGTH(DACTREQ));     05S0507
         LA    @01,@AL00507                                     05S0507
         BAL   @14,IPSNDREQ                                     05S0507
*                 END;                                          05S0508
*             END;                                              04S0509
*           ELSE                    /* FREE THE SESSION INFORMATION
*                                      CONTROL BLOCK FOR THE SSCP TO
*                                      PU SESSION AND RETURN AN ERROR
*                                      CODE TO THE ORIGINAL REQUESTOR
*                                      OF THE "ACTIVATE PHYSICAL
*                                      UNIT" REQUEST                 */
*             DO;                                               04S0510
         B     @RC00490                                         04S0510
@RF00490 DS    0H                                               04S0511
*               RFY                                             04S0511
*                 RPARMREG RSTD;    /* RESTRICT THE REGISTER USED TO
*                                      INDICATE THE TYPE OF INTERTASK
*                                      REQUEST                       */
*               RPARMREG=REQSFREE;  /* SET THE TYPE OF INTERTASK
*                                      REQUEST TO INDICATE THAT A SIB
*                                      IS TO BE FREED                */
         LA    RPARMREG,4                                       04S0512
*               CALL IPSIBREQ;      /* CALL THE INTERNAL PROCEDURE
*                                      THAT HANDLES SIB REQUESTS     */
         BAL   @14,IPSIBREQ                                     04S0513
*               RFY                                             04S0514
*                 RPARMREG UNRSTD;  /* RELEASE THE REGISTER USED FOR
*                                      THE TYPE OF SIB REQUEST       */
*               OCPARM=OCRCBNEG;    /* INDICATE A BAD RESPONSE AND
*                                      THAT SENSE DATA IS INCLUDED IN
*                                      THE RESPONSE UNIT DATA        */
         MVC   OCPARM(2,ROPCE),@CH01011                         04S0515
*               OPCMODID=OCWTGB;    /* SET THE MODULE IDENTIFICATION
*                                      FOR THE XCTL MACRO FROM THE
*                                      OPERATOR CONTROL ELEMENT 04S0516
*                                      "WHERE TO GO BACK-UP" FIELD   */
         MVC   OPCMODID(2,ROPCAVT),OCWTGB(ROPCE)                04S0516
*               OCWTG=''B;          /* ZERO THE OPERATOR CONTROL
*                                      "WHERE TO GO" FIELD TO   04S0517
*                                      INDICATE THAT THE PROCESSING
*                                      OF THE ACTPU REQUEST HAS ENDED*/
         XC    OCWTG(2,ROPCE),OCWTG(ROPCE)                      04S0517
*             END;                                              04S0518
*         END;                                                  03S0519
*       ELSE                        /* DETERMINE WHETHER THE RESPONSE
*                                      IS A "START DATA TRAFFIC"
*                                      RESPONSE OR A "DEACTIVATE
*                                      PHYSICAL UNIT" RESPONSE       */
*         IF RESPCODE=CD1SDT        /* TEST FOR A "START DATA   03S0520
*                                      TRAFFIC" RESPONSE             */
*           THEN                    /* PROCESS THE "START DATA  03S0520
*                                      TRAFFIC" RESPONSE             */
         B     @RC00488                                         03S0520
@RF00488 CLI   RESPCODE(PTRRESP),X'A0'                          03S0520
         BNE   @RF00520                                         03S0520
*           DO;                                                 03S0521
*                                                               04S0522
*             /*******************************************************/
*             /*                                                     */
*             /* PROCESS.RESPONSE.RESPSDT: THIS SEGMENT PROCESSES THE*/
*             /* "START DATA TRAFFIC" RESPONSE.                      */
*             /*                                                     */
*             /*******************************************************/
*                                                               04S0522
*             IF SIBDSTAT=SIBDACTV  /* TEST FOR THE "DATA TRAFFIC
*                                      ACTIVE" STATE                 */
*               THEN                /* PROCESS THE GOOD RESPONSE     */
         LR    @11,RTRM                                         04S0522
         AL    @11,@CF01678                                     04S0522
         SLR   @09,@09                                          04S0522
         ICM   @09,7,TRMSIBPT-7(@11)                            04S0522
         TM    SIBDSTAT(@09),B'00000011'                        04S0522
         BNO   @RF00522                                         04S0522
*               DO;                                             04S0523
*                 IF PRURHSDI=OFF   /* TEST FOR THE ABSENCE OF SENSE
*                                      DATA IN THE RESPONSE UNIT     */
*                   THEN            /* SET A POSITIVE RETURN CODE IN
*                                      THE OPERATOR CONTROL ELEMENT  */
         L     @11,OCUNIT(,ROPCE)                               04S0524
         AL    @11,@CF01677                                     04S0524
         TM    PRURHSDI(@11),B'00000100'                        04S0524
         BNZ   @RF00524                                         04S0524
*                   OCPARM=OCRCGPOS;/* INDICATE A GOOD RESPONSE AND
*                                      THAT NO SENSE IS INCLUDED IN
*                                      THE RESPONSE UNIT DATA        */
         MVC   OCPARM(2,ROPCE),@CH00061                         04S0525
*                 ELSE              /* SET A NEGATIVE RETURN CODE IN
*                                      THE OPERATOR CONTROL ELEMENT  */
*                   OCPARM=OCRCGNEG;/* INDICATE A GOOD RESPONSE AND
*                                      THAT SENSE DATA IS INCLUDED IN
*                                      THE RESPONSE UNIT DATA        */
         B     @RC00524                                         04S0526
@RF00524 MVC   OCPARM(2,ROPCE),@CH00128                         04S0526
*                 OPCMODID=OCWTGB;  /* SET THE MODULE IDENTIFICATION
*                                      FOR THE XCTL MACRO FORM THE
*                                      OPERATOR CONTROL "WHERE TO GO
*                                      BACK-UP" FIELD                */
@RC00524 MVC   OPCMODID(2,ROPCAVT),OCWTGB(ROPCE)                04S0527
*                 OCWTG=''B;        /* ZERO THE OPERATOR CONTROL
*                                      "WHERE TO GO FIELD TO INDICATE
*                                      THAT THE PROCESSING OF THE
*                                      ACTIVATE REQUEST HAS ENDED    */
         XC    OCWTG(2,ROPCE),OCWTG(ROPCE)                      04S0528
*               END;                                            04S0529
*             ELSE                  /* BUILD A "DEACTIVATE PHYSICAL
*                                      UNIT" REQUEST TO DEACTIVATE
*                                      THE PARTIALLY ACTIVATED  04S0530
*                                      PHYSICAL UNIT                 */
*               CALL IPSNDREQ(DACTREQ,LENGTH(DACTREQ));/* CALL AN
*                                      INTERNAL PROCEDURE TO PREPARE
*                                      TO SEND THE "DEACTIVATE  04S0530
*                                      PHYSICAL UNIT" REQUEST        */
         B     @RC00522                                         04S0530
@RF00522 LA    @01,@AL00530                                     04S0530
         BAL   @14,IPSNDREQ                                     04S0530
*           END;                                                03S0531
*         ELSE                      /* PROCESS THE "DEACTIVATE  03S0532
*                                      PHYSICAL UNIT" RESPONSE       */
*           DO;                                                 03S0532
         B     @RC00520                                         03S0532
@RF00520 DS    0H                                               03S0533
*                                                               04S0533
*             /*******************************************************/
*             /*                                                     */
*             /* PROCESS.RESPONSE.RESPDACT: THIS SEGMENT DOES THE    */
*             /* PROCESSING THAT IS REQUIRED WHEN A RESPONSE TO      */
*             /* "DEACTIVATE PHYSICAL UNIT" IS RECEIVED.             */
*             /*                                                     */
*             /*******************************************************/
*                                                               04S0533
*             RFY                                               04S0533
*               RPARMREG RSTD;      /* RESTRICT THE REGISTER USED TO
*                                      INDICATE THE TYPE OF INTERTASK
*                                      REQUEST                       */
*             RPARMREG=REQSFREE;    /* SET THE TYPE OF INTERTASK
*                                      REQUEST TO INDICATE THAT A SIB
*                                      IS TO BE FREED                */
         LA    RPARMREG,4                                       04S0534
*             CALL IPSIBREQ;        /* CALL THE INTERNAL PROCEDURE
*                                      THAT HANDLES SIB REQUESTS     */
         BAL   @14,IPSIBREQ                                     04S0535
*             RFY                                               04S0536
*               RPARMREG UNRSTD;    /* RELEASE THE REGISTER USED FOR
*                                      THE TYPE OF SIB REQUEST       */
*             IF OCPARM=0           /* TEST FOR NO RETURN CODE IN THE
*                                      OPERATOR CONTROL ELEMENT      */
*               THEN                /* SET A RETURN CODE IN THE 04S0537
*                                      OPERATOR CONTROL ELEMENT      */
         LH    @11,OCPARM(,ROPCE)                               04S0537
         LTR   @11,@11                                          04S0537
         BNZ   @RF00537                                         04S0537
*               IF PRURHSDI=OFF     /* TEST FOR THE ABSENCE OF SENSE
*                                      DATA IN THE RESPONSE UNIT     */
*                 THEN              /* SET A POSITIVE RETURN CODE IN
*                                      THE OPERATOR CONTROL ELEMENT  */
         L     @11,OCUNIT(,ROPCE)                               04S0538
         AL    @11,@CF01677                                     04S0538
         TM    PRURHSDI(@11),B'00000100'                        04S0538
         BNZ   @RF00538                                         04S0538
*                 OCPARM=OCRCBPOS;  /* INDICATE A BAD RESPONSE AND
*                                      THAT NO SENSE DATA IS INCLUDED
*                                      IN THE RESPONSE UNIT DATA     */
         MVC   OCPARM(2,ROPCE),@CH01015                         04S0539
*               ELSE                /* SET A NEGATIVE RETURN CODE IN
*                                      THE OPERATOR CONTROL ELEMENT  */
*                 OCPARM=OCRCBNEG;  /* INDICATE A GOOD RESPONSE AND
*                                      THAT SENSE DATA IS INCLUDED IN
*                                      THE RESPONSE UNIT DATA        */
         B     @RC00538                                         04S0540
@RF00538 MVC   OCPARM(2,ROPCE),@CH01011                         04S0540
*             OPCMODID=OCWTGB;      /* SET THE MODULE IDENTIFICATION
*                                      FOR THE XCTL MACRO FROM THE
*                                      OPERATOR CONTROL ELEMENT 04S0541
*                                      "WHERE TO GO BACK-UP" FIELD   */
@RC00538 DS    0H                                               04S0541
@RF00537 MVC   OPCMODID(2,ROPCAVT),OCWTGB(ROPCE)                04S0541
*             OCWTG=''B;            /* ZERO THE OPERATOR CONTROL
*                                      "WHERE TO GO" FIELD TO   04S0542
*                                      INDICATE THAT THE PROCESSING
*                                      OF THE ACTPU REQUEST HAS ENDED*/
         XC    OCWTG(2,ROPCE),OCWTG(ROPCE)                      04S0542
*           END;                                                03S0543
*     END;                                                      02S0544
@RC00520 DS    0H                                               02S0544
@RC00488 DS    0H                                               02S0545
*                                                               02S0545
*   /*****************************************************************/
*   /*                                                               */
*   /* EPILOGUE: THIS SEGMENT COMPLETES THE EPILOGUE CODE THAT WAS   */
*   /* ALTERED BY THE MODULE PROCEDURE STATEMENT. THE XCTL ASSEMBLER */
*   /* MACRO INSTRUCTION IS USED BY THIS SEGMENT TO TRANSFER CONTROL */
*   /* TO THE NEXT MODULE THAT IS TO BE EXECUTED.                    */
*   /*                                                               */
*   /*****************************************************************/
*                                                               02S0545
*   RFY                                                         02S0545
*     RPARMREG RSTD;                /* RESTRICT THE PARAMETER   02S0545
*                                      REGISTER TO BE USED TO CONTAIN
*                                      THE ADDRESS OF THE OPERATOR
*                                      CONTROL ADDRESS VECTOR TABLE
*                                      FROM USE BY THE COMPILER      */
@RC00461 DS    0H                                               02S0546
*   RPARMREG=ROPCAVT;               /* SET THE PARAMETER REGISTER IN
*                                      PREPARATION TO TRANSFERRING
*                                      CONTROL TO ANOTHER MODULE     */
         LR    RPARMREG,ROPCAVT                                 02S0546
*   GEN EXIT REFS(OPCXCTL,ROPCAVT) NOSEQFLOW SETS(RENTREG);     02S0547
*                                   /*
         XCTL  SF=(E,OPCXCTL(ROPCAVT)) TRANSFER CONTROL MACRO
*                                                               02S0548
*   /*****************************************************************/
*   /*                                                               */
*   /* IPSIBREQ: THIS SEGMENT CONTAINS THE IPSIBREQ INTERNAL         */
*   /* PROCEDURE WHICH DOES THE PROCESSING OF INTERTASK REQUESTS THAT*/
*   /* PERTAIN TO THE SESSION INFORMATION CONTROL BLOCK. THIS SEGMENT*/
*   /* USES THE POSTWAIT EXTERNAL ROUTINE.                           */
*   /*                                                               */
*   /*****************************************************************/
*                                                               02S0548
*IPSIBREQ:                                                      02S0548
*   PROC OPTIONS(RETREG,SAVE(14));  /* SAVE THE RETURN POINT REGISTER
*                                      SINCE THIS PROCEDURE CALLS AN
*                                      EXTERNAL ROUTINE              */
IPSIBREQ ST    @14,@SA00002                                     02S0548
*   RFY                                                         02S0549
*     RPARMREG RSTD;                /* RESTRICT THE INPUT PARAMETER
*                                      REGISTER FOR THIS INTERNAL
*                                      PROCEDURE                     */
*   REQAREA(1:REQSLEN)=''B;         /* CLEAR THE INTERTASK REQUEST
*                                      ELEMENT WITH ZEROS            */
         XC    REQAREA(26),REQAREA                              02S0550
*   REQTYPE=RPARMREG;               /* SET THE REQUEST TYPE FROM THE
*                                      INPUT PARAMETER REGISTER      */
         LA    @11,REQAREA                                      02S0551
         STC   RPARMREG,REQTYPE(,@11)                           02S0551
*   REQQCBA=SAVTXTRQ;               /* SET THE QUEUE CONTROL BLOCK
*                                      ADDRESS TO THE QUEUE CONTROL
*                                      BLOCK ADDRESS OF THE POSTWAIT
*                                      ROUTINE                       */
         L     @09,AVTSAVTP(,RAVT)                              02S0552
         MVC   REQQCBA(3,@11),SAVTXTRQ+1(@09)                   02S0552
*   REQPRI=PRISIBRQ;                /* SET THE REQUEST PRIORITY FROM
*                                      THE SIB REQUEST PRIORITY 02S0553
*                                      CONSTANT                      */
         MVI   REQPRI(@11),X'E5'                                02S0553
*   REQRPRI=PRISIBRQ;               /* SET THE REQUEST RETURN   02S0554
*                                      PRIORITY FROM THE SIB REQUEST
*                                      PRIORITY CONSTANT             */
         MVI   REQRPRI(@11),X'E5'                               02S0554
*   REQRQCBA=ADDR(OPCPWQCB);        /* SET THE RETURN QUEUE CONTROL
*                                      BLOCK ADDRESS TO THE ADDRESS
*                                      OF THE OPERATOR CONTROL QUEUE
*                                                            @YM08403*/
         LA    @05,OPCPWQCB(,ROPCAVT)                           02S0555
         STCM  @05,7,REQRQCBA(@11)                              02S0555
*   REQSTTE=RTRM;                   /* SET THE REQUEST TERMINAL TABLE
*                                      ENTRY ADDRESS TO THE ADDRESS
*                                      OF THE TERMINAL TABLE ENTRY
*                                      FOR THE RESOURCE WHOSE SIB
*                                      CHAIN WILL BE CHANGED         */
         ST    RTRM,REQSTTE(,@11)                               02S0556
*   REQSTNT=SAVTSCPT;               /* SPECIFY THE SSCP TERMINAL NAME
*                                      TABLE INDEX AS THE TNT INDEX
*                                      TO BE PLACED IN THE SIB TO
*                                      INDICATE A SSCP TO RESOURCE
*                                      SESSION                       */
         LH    @09,SAVTSCPT(,@09)                               02S0557
         N     @09,@CF01675                                     02S0557
         STH   @09,REQSTNT(,@11)                                02S0557
*   RPARMREG=ADDR(REQAREA);         /* SET THE REQUEST ELEMENT  02S0558
*                                      ADDRESS PARAMETER FOR THE
*                                      POSTWAIT ROUTINE              */
         LR    RPARMREG,@11                                     02S0558
*   CALL POSTWAIT;                  /* REQUEST A SIB                 */
         L     @15,OPCPSTWT(,ROPCAVT)                           02S0559
         BALR  @14,@15                                          02S0559
*   RFY                                                         02S0560
*     RPARMREG UNRSTD;              /* RELEASE THE INPUT PARAMETER
*                                      REGISTER                      */
*   END IPSIBREQ;                                               02S0561
@EL00002 DS    0H                                               02S0561
@EF00002 DS    0H                                               02S0561
@ER00002 L     @14,@SA00002                                     02S0561
         BR    @14                                              02S0561
*                                                               02S0562
*   /*****************************************************************/
*   /*                                                               */
*   /* IPSNDREQ: THIS SEGMENT CONTAINS THE IPSNDREQ INTERNAL         */
*   /* PROCEDURE WHICH DOES THE BUILDING OF THE PACKED REQUEST UNIT  */
*   /* AND THE PREPARATION THAT IS NECESSARY TO SEND OUT THE REQUEST.*/
*   /*                                                               */
*   /*****************************************************************/
*                                                               02S0562
*IPSNDREQ:                                                      02S0562
*   PROC(RQSTDATA,RQSTLEN) OPTIONS(NOSAVE);/* DO NOT SAVE ANY   02S0562
*                                      REGISTERS SINCE THIS PROCEDURE
*                                      DOES NOT CALL ANY OTHER  02S0562
*                                      ROUTINES                      */
IPSNDREQ MVC   @PC00003(8),0(@01)                               02S0562
*   DCL                                                         02S0563
*     RQSTDATA CHARACTER(*);        /* INPUT REQUEST UNIT DATA       */
*   DCL                                                         02S0564
*     RQSTLEN FIXED(31);            /* LENGTH OF THE INPUT REQUEST
*                                      UNIT DATA                     */
*   IEDPRUND=RHPACKTH;              /* SET THE REQUEST HEADER AND THE
*                                      PACKED TRANSMISSION HEADER    */
         L     @11,OCUNIT(,ROPCE)                               02S0565
         LR    @09,@11                                          02S0565
         AL    @09,@CF01677                                     02S0565
         XC    IEDPRUND+4(4,@09),IEDPRUND+4(@09)                02S0565
         MVC   IEDPRUND(4,@09),@CB01631                         02S0565
*   PRUTTCIN=OCTRMTBL;              /* SET THE DESTINATION TERMINAL
*                                      TABLE CURRENT INDEX           */
         LH    @09,OCTRMTBL(,ROPCE)                             02S0566
         N     @09,@CF01675                                     02S0566
         STH   @09,PRUTTCIN(,@11)                               02S0566
*   PRUDATCT=RQSTLEN;               /* SET THE DATA COUNT FIELD TO
*                                      THE NUMBER OF BYTES IN THE
*                                      REQUEST UNIT DATA PARAMETER   */
         L     @09,@PC00003+4                                   02S0567
         L     @09,RQSTLEN(,@09)                                02S0567
         STH   @09,PRUDATCT(,@11)                               02S0567
*   PRUDATA(1:RQSTLEN)=RQSTDATA(1:RQSTLEN);/* BUILD THE REQUEST UNIT
*                                      DATA                          */
         BCTR  @09,0                                            02S0568
         L     @05,@PC00003                                     02S0568
         EX    @09,@SM01679                                     02S0568
*   OCWTG=MODID;                    /* SET THE OPERATOR CONTROL 02S0569
*                                      "WHERE TO GO" FIELD TO   02S0569
*                                      INDICATE THAT THE RESPONSE TO
*                                      THE REQUEST IS TO BE SENT BACK
*                                      TO THIS MODULE                */
         MVC   OCWTG(2,ROPCE),@CC01622                          02S0569
*   OPCMODID=OUTMODID;              /* SET THE MODULE IDENTIFICATION
*                                      IN PREPARATION TO SENDING THE
*                                      REQUEST OUT AND TRANSFERRING
*                                      CONTROL VIA THE XCTL MACRO    */
         MVC   OPCMODID(2,ROPCAVT),@CC01624                     02S0570
*   END IPSNDREQ;                                               02S0571
@EL00003 DS    0H                                               02S0571
@EF00003 DS    0H                                               02S0571
@ER00003 BR    @14                                              02S0571
*   END IGCA610D                                                01S0572
*                                                               01S0572
*/* THE FOLLOWING INCLUDE STATEMENTS WERE FOUND IN THIS PROGRAM.     */
*/*%INCLUDE SYSLIB  (TAVTD   )                                       */
*/*%INCLUDE SYSLIB  (TCD1D   )                                       */
*/*%INCLUDE SYSLIB  (TNCPID  )                                       */
*/*%INCLUDE SYSLIB  (TOPCED  )                                       */
*/*%INCLUDE SYSLIB  (TOPCAVTD)                                       */
*/*%INCLUDE SYSLIB  (TPRIOR  )                                       */
*/*%INCLUDE SYSLIB  (TPRUD   )                                       */
*/*%INCLUDE SYSLIB  (TREQD   )                                       */
*/*%INCLUDE SYSLIB  (TSIBD   )                                       */
*/*%INCLUDE SYSLIB  (TTRMD   )                                       */
*/*%INCLUDE SYSUT5  (RFY     )                                       */
*/*%INCLUDE SYSUT5  (DCL     )                                       */
*/*%INCLUDE SYSUT5  (PROLOGUE)                                       */
*/*%INCLUDE SYSUT5  (PROCESS )                                       */
*/*%INCLUDE SYSUT5  (INITIAL )                                       */
*/*%INCLUDE SYSUT5  (REQUEST )                                       */
*/*%INCLUDE SYSUT5  (YESSIB  )                                       */
*/*%INCLUDE SYSUT5  (NOSIB   )                                       */
*/*%INCLUDE SYSUT5  (RESPONSE)                                       */
*/*%INCLUDE SYSUT5  (RESPACT )                                       */
*/*%INCLUDE SYSUT5  (CHECKMOD)                                       */
*/*%INCLUDE SYSUT5  (RESPSDT )                                       */
*/*%INCLUDE SYSUT5  (RESPDACT)                                       */
*/*%INCLUDE SYSUT5  (EPILOGUE)                                       */
*/*%INCLUDE SYSUT5  (IPSIBREQ)                                       */
*/*%INCLUDE SYSUT5  (IPSNDREQ)                                       */
*                                                               01S0572
*       ;                                                       01S0572
@DATA    DS    0H
@CH01017 DC    H'-4'
@CH01015 DC    H'-3'
@CH01013 DC    H'-2'
@CH01011 DC    H'-1'
@SM01679 MVC   PRUDATA(0,@11),RQSTDATA(@05)
         DS    0F
@AL00475 DC    A(ACTREQ)               LIST WITH   2 ARGUMENT(S)
         DC    A(@CF01674)
@AL00504 DC    A(SDTREQ)               LIST WITH   2 ARGUMENT(S)
         DC    A(@CF00061)
@AL00507 EQU   *                       LIST WITH   2 ARGUMENT(S)
@AL00530 DC    A(DACTREQ)              LIST WITH   2 ARGUMENT(S)
         DC    A(@CF00128)
@DATD    DSECT
         DS    0F
@SA00002 DS    1F
@PC00003 DS    2F
IGCA610D CSECT
         DS    0F
@CF00061 DC    F'1'
@CH00061 EQU   @CF00061+2
@CF00128 DC    F'2'
@CH00128 EQU   @CF00128+2
@CF00328 DC    F'4'
@CF01674 DC    F'9'
@CF01677 DC    F'-8'
@CF01678 DC    F'-7'
@CF01675 DC    XL4'0000FFFF'
@DATD    DSECT
         DS    0D
REQAREA  DS    CL26
         ORG   *+1-(*-@DATD)/(*-@DATD) INSURE DSECT DATA
@ENDDATD EQU   *
IGCA610D CSECT
         NOPR  ((@ENDDATD-@DATD)/561*16)
         DS    0F
@SIZDATD DC    AL1(0)
         DC    AL3(@ENDDATD-@DATD)
         DS    0D
@CC01622 DC    C'A6'
@CC01624 DC    C'02'
@CB01631 DC    X'6B80001D'
PATCH    DC    XL104'0'
ACTREQ   DS    CL9
         ORG   ACTREQ
ACTCODE  DC    X'11'
ACTTYPE  DC    X'02'
ACTPROFS DC    X'55'
         ORG   ACTPROFS
ACTFM    DS    BL1
ACTTS    EQU   ACTPROFS+0
         ORG   ACTREQ+3
ACTSSCP  DS    CL6
         ORG   ACTSSCP
@NM00148 DC    X'05'
         ORG   @NM00148
ACTFORM  DS    BL1
ACTPTYPE EQU   @NM00148+0
         ORG   ACTSSCP+1
ACTBINID DC    X'000000000A'
         ORG   ACTREQ+9
DACTREQ  DS    CL2
         ORG   DACTREQ
DACTCODE DC    X'12'
DACTTYPE DC    X'01'
         ORG   DACTREQ+2
SDTREQ   DS    CL1
         ORG   SDTREQ
@NM00149 DC    X'A0'
         ORG   SDTREQ+1
@00      EQU   00                      EQUATES FOR REGISTERS 0-15
@01      EQU   01
@02      EQU   02
@03      EQU   03
@04      EQU   04
@05      EQU   05
@06      EQU   06
@07      EQU   07
@08      EQU   08
@09      EQU   09
@10      EQU   10
@11      EQU   11
@12      EQU   12
@13      EQU   13
@14      EQU   14
@15      EQU   15
PTRRESP  EQU   @09
PTRNCPDD EQU   @11
ROPCE    EQU   @03
ROPCAVT  EQU   @02
RAVT     EQU   @04
RTRM     EQU   @08
RWORK    EQU   @00
RPARMREG EQU   @01
RDATAREG EQU   @10
RCODEREG EQU   @12
RSAVEREG EQU   @13
RENTREG  EQU   @15
RRETCODE EQU   @15
IEDQAVTD EQU   0
AVTSAVEX EQU   IEDQAVTD+288
@NM00003 EQU   IEDQAVTD+388
AVTCKFLG EQU   @NM00003
AVTBASE  EQU   IEDQAVTD+412
AVTPKF   EQU   AVTBASE
AVTRNMPT EQU   IEDQAVTD+424
AVTHG02  EQU   IEDQAVTD+528
AVTDISP  EQU   IEDQAVTD+552
AVTHD    EQU   IEDQAVTD+556
AVTSCOPT EQU   AVTHD
AVTSAVTP EQU   IEDQAVTD+612
AVTSAVTF EQU   AVTSAVTP
AVTCKPEL EQU   IEDQAVTD+652
AVTCKRMV EQU   AVTCKPEL
AVTCKELF EQU   IEDQAVTD+680
AVTCKBYT EQU   IEDQAVTD+691
AVTHG01  EQU   IEDQAVTD+692
AVTCKLNK EQU   IEDQAVTD+696
AVTCRELE EQU   IEDQAVTD+708
AVTCCELE EQU   AVTCRELE
AVTCLRHI EQU   IEDQAVTD+716
AVTADBUF EQU   IEDQAVTD+720
AVTSYSER EQU   IEDQAVTD+728
AVTCKPQB EQU   IEDQAVTD+804
AVTCKPTB EQU   AVTCKPQB
AVTCKPEC EQU   AVTCKPQB+4
AVTCKPCC EQU   AVTCKPEC
AVTOPCQB EQU   IEDQAVTD+816
AVTOPCOB EQU   AVTOPCQB
AVTOPCEC EQU   AVTOPCQB+4
AVTOPCCC EQU   AVTOPCEC
AVTOLTQB EQU   IEDQAVTD+828
AVTCWFL1 EQU   IEDQAVTD+924
AVTCWFL2 EQU   IEDQAVTD+925
AVTSUBT  EQU   IEDQAVTD+948
AVTIOTR  EQU   IEDQAVTD+949
AVTBIT1  EQU   IEDQAVTD+1050
AVTBIT2  EQU   IEDQAVTD+1051
AVTBIT3  EQU   IEDQAVTD+1052
AVTDDFT  EQU   IEDQAVTD+1064
AVTBIT4  EQU   IEDQAVTD+1136
@NM00083 EQU   IEDQAVTD+1232
IEDQAPTR EQU   0
IEDNSVTD EQU   0
SAVTDIAG EQU   IEDNSVTD
SAVTDIAF EQU   SAVTDIAG
SAVTLUSQ EQU   IEDNSVTD+88
SAVTXTRQ EQU   IEDNSVTD+164
SAVTTCPU EQU   IEDNSVTD+238
SAVTSCPT EQU   SAVTTCPU
SAVTZELM EQU   IEDNSVTD+270
SAVTRDRV EQU   IEDNSVTD+284
SAVTCKQB EQU   IEDNSVTD+300
SAVTCKTB EQU   SAVTCKQB
SAVTCKEC EQU   SAVTCKQB+4
SAVTCKCC EQU   SAVTCKEC
IEDNCP   EQU   0
NCPFLAG1 EQU   IEDNCP+1
NCPTXID  EQU   IEDNCP+10
IEDQOPCE EQU   0
OCELEM   EQU   IEDQOPCE+4
OCUNIT   EQU   IEDQOPCE+8
OCRUDEST EQU   OCUNIT
OCCKPKEY EQU   OCRUDEST
OCSCAN   EQU   OCCKPKEY
OCOPTCDE EQU   IEDQOPCE+12
OCSWITCH EQU   IEDQOPCE+13
OCFLAG   EQU   IEDQOPCE+14
OCRESP   EQU   OCFLAG
@NM00107 EQU   IEDQOPCE+16
OCDEST   EQU   @NM00107
OCREQVAL EQU   OCDEST+1
OCTRMTBL EQU   IEDQOPCE+20
OCLINENO EQU   IEDQOPCE+22
OCTIOT   EQU   OCLINENO
OCWTGB   EQU   OCTIOT
OCTRUNIT EQU   IEDQOPCE+24
OCRSID   EQU   OCTRUNIT
OCALSTAT EQU   OCRSID
OCPARM   EQU   IEDQOPCE+28
OCWTG    EQU   IEDQOPCE+30
OCBACKUP EQU   IEDQOPCE+32
OCMODNME EQU   IEDQOPCE+40
OCIPLWA  EQU   OCMODNME
OCCKDATA EQU   IEDQOPCE+48
OCRSTGTM EQU   OCCKDATA
IEDQOPCN EQU   0
OCLDNME  EQU   IEDQOPCN
OCLINTTE EQU   OCLDNME
OCREQFLG EQU   OCLINTTE+2
OCPREFLG EQU   OCLINTTE+3
IEDQOPCD EQU   0
OPCAVTPT EQU   IEDQOPCD+8
OPCCOPCE EQU   IEDQOPCD+12
OPCPSTWT EQU   IEDQOPCD+48
OPCSAVE  EQU   IEDQOPCD+56
OPCWORK  EQU   IEDQOPCD+140
OPCAQCTL EQU   IEDQOPCD+180
OPCXCTL  EQU   IEDQOPCD+204
OPCLDNME EQU   IEDQOPCD+212
OPCMODID EQU   OPCLDNME+3
OPCGETBF EQU   IEDQOPCD+276
OPCSPEC  EQU   IEDQOPCD+300
OPCPWCOB EQU   IEDQOPCD+368
OPCPWQCB EQU   OPCPWCOB
OPCPWECB EQU   OPCPWCOB+4
IEDPRUQD EQU   0
PRUTTCIN EQU   IEDPRUQD
PRUDATCT EQU   IEDPRUQD+2
PRUTIC   EQU   IEDPRUQD+8
PRUDATA  EQU   IEDPRUQD+12
IEDPRUQP EQU   0
IEDPRUND EQU   0
PRURHTH  EQU   IEDPRUND
PRURH    EQU   PRURHTH
PRURHFG0 EQU   PRURH
PRURHSDI EQU   PRURHFG0
PRURHFG1 EQU   PRURH+1
PRURHFG2 EQU   PRURH+2
PRUTH    EQU   PRURHTH+3
PRUFIDN  EQU   PRUTH
IEDREQD  EQU   0
REQTYPE  EQU   IEDREQD
REQQCBA  EQU   IEDREQD+1
REQPRI   EQU   IEDREQD+4
REQRPRI  EQU   IEDREQD+8
REQRQCBA EQU   IEDREQD+9
REQROUTE EQU   IEDREQD+12
REQRCDS  EQU   IEDREQD+14
REQRCD1  EQU   REQRCDS
REQDATA  EQU   IEDREQD+16
IEDSIBD  EQU   0
SIBSESSN EQU   IEDSIBD+10
SIBSSTAT EQU   SIBSESSN
SIBDSTAT EQU   SIBSESSN
SIBPACIN EQU   IEDSIBD+11
SIBSEQN  EQU   IEDSIBD+12
SIBSTAT1 EQU   IEDSIBD+16
SIBSTAT2 EQU   IEDSIBD+17
SIBBIND  EQU   IEDSIBD+20
SIBBIND1 EQU   SIBBIND
SIBBIND2 EQU   SIBBIND+1
SIBBIND3 EQU   SIBBIND+2
SIBSTAT0 EQU   IEDSIBD+23
IEDQTRM  EQU   0
TRMSTATE EQU   IEDQTRM
TRMLOG   EQU   TRMSTATE
TRMINSEQ EQU   IEDQTRM+4
TLISTCNT EQU   TRMINSEQ
TRMOUTSQ EQU   IEDQTRM+6
TLISTEN  EQU   TRMOUTSQ
TRMDSORG EQU   TLISTEN
TRMALTD  EQU   IEDQTRM+8
TRMDEVFL EQU   IEDQTRM+10
TRMSTAT  EQU   IEDQTRM+12
IEDQTPTR EQU   0
IEDNTRM  EQU   0
TRMBYTE4 EQU   IEDNTRM
TRMBYTE3 EQU   IEDNTRM+1
TRMBYTE2 EQU   IEDNTRM+2
TRMINPG  EQU   TRMBYTE2
TRMBYTE1 EQU   IEDNTRM+3
TRMSCPRQ EQU   TRMBYTE1
TRMBYTE0 EQU   IEDNTRM+6
TRMSIBPT EQU   IEDNTRM+7
ALLOCBUF EQU   0
IEDQTL   EQU   0
IEDQTNT  EQU   0
POSTWAIT EQU   0
ACTRESP  EQU   0
ACTRCONT EQU   ACTRESP+2
RESPDATA EQU   0
RESPCODE EQU   RESPDATA
RQSTDATA EQU   0
RQSTLEN  EQU   0
OCCKPKY1 EQU   OCCKPKEY
OCCKPTYP EQU   OCCKPKY1
OCICACTN EQU   OCMODNME
OCICDADR EQU   OCICACTN
OCICSW   EQU   OCICDADR+3
OPCAQWD  EQU   OPCAQCTL
OPCAQWD1 EQU   OPCAQWD
OPCAQWD2 EQU   OPCAQWD+4
OPCAQWD3 EQU   OPCAQWD+8
REQLDATA EQU   REQDATA
REQSDATA EQU   REQDATA
REQSTTE  EQU   REQSDATA
REQSTNT  EQU   REQSDATA+4
TRMPRE1  EQU   TRMBYTE4
TRMNCP1  EQU   TRMBYTE4
TRMPRE   EQU   TRMBYTE3
TRMNCP   EQU   TRMBYTE3
TRMPU    EQU   TRMBYTE3
TRMLU    EQU   TRMBYTE3
TRMLINK  EQU   TRMBYTE3
SENSE    EQU   PRUDATA
OCCIB    EQU   OCREQVAL
TRMOPT   EQU   IEDQTRM+20
         AGO   .@UNREFD                START UNREFERENCED COMPONENTS
@NM00147 EQU   TRMLINK
TRMLSTAT EQU   TRMLINK
TRMLINT  EQU   TRMLINK
TRMEPMOD EQU   TRMLINK
TRMLULOG EQU   TRMLU
TRMINERR EQU   TRMLU
TRMLUREQ EQU   TRMLU
TRMSESRQ EQU   TRMLU
TRMTDIFF EQU   TRMLU
TRMLUTM  EQU   TRMLU
TRMLUIT  EQU   TRMLU
TRMAUTO  EQU   TRMLU
TRMPCONT EQU   TRMPU
@NM00146 EQU   TRMPU
TRMNCONT EQU   TRMNCP
TRMQUCKN EQU   TRMNCP
TRMSLOWN EQU   TRMNCP
TRMSYGEN EQU   TRMNCP
TRMNCPCL EQU   TRMNCP
TRMIPLDM EQU   TRMNCP
TRMINOUT EQU   TRMPRE
TRMRDOUT EQU   TRMPRE
TRMNLOUT EQU   TRMPRE
TRMWROUT EQU   TRMPRE
TRMASNXI EQU   TRMPRE
TRMSTMM  EQU   TRMPRE
TRMCMODE EQU   TRMPRE
TRMSTPND EQU   TRMPRE
@NM00145 EQU   TRMNCP1
TRMINOP  EQU   TRMNCP1
TRMLYNCH EQU   TRMPRE1
TRMSPOUT EQU   TRMPRE1
TRMERLCK EQU   TRMPRE1
TRMQNPL  EQU   TRMPRE1
TRMSPACT EQU   TRMPRE1
TRMOCNI  EQU   TRMPRE1
TRMSESSN EQU   TRMPRE1
TRMCONT  EQU   TRMPRE1
REQLTNT  EQU   REQLDATA
OPCAQLST EQU   OPCAQWD3+1
OPCAQRQ3 EQU   OPCAQWD3
OPCAQSEC EQU   OPCAQWD2+1
OPCAQRQ2 EQU   OPCAQWD2
OPCAQFST EQU   OPCAQWD1+1
OPCAQREQ EQU   OPCAQWD1
OCICINAC EQU   OCICSW
@NM00113 EQU   OCICSW
OCICATST EQU   OCICDADR+1
OCICTYPE EQU   OCICDADR
@NM00112 EQU   OCCKPKY1
OCCKPENV EQU   OCCKPKY1
OCCKPRST EQU   OCCKPTYP
OCCKPNCP EQU   OCCKPTYP
OCCKPINC EQU   OCCKPTYP
ACTRTYPE EQU   ACTRESP+1
ACTRCODE EQU   ACTRESP
TRMSUBST EQU   IEDNTRM+12
TRMTYPE  EQU   IEDNTRM+11
TRMRLMCT EQU   IEDNTRM+10
TRMCOHTG EQU   TRMSIBPT+1
TRMGPCNT EQU   TRMSIBPT
TRMBUFRD EQU   TRMBYTE0
TRMSNA   EQU   TRMBYTE0
TRMGP    EQU   TRMBYTE0
TRMDIAL  EQU   TRMBYTE0
@NM00144 EQU   TRMBYTE0
TRMOUTPT EQU   TRMBYTE0
TRMINPUT EQU   TRMBYTE0
TRMUDEF  EQU   TRMBYTE0
TRMCOHRT EQU   IEDNTRM+4
TRMSTOTE EQU   TRMBYTE1
TRMCKPRN EQU   TRMBYTE1
TRMTSATN EQU   TRMBYTE1
TRMTRACE EQU   TRMBYTE1
TRMSWBCK EQU   TRMBYTE1
TRMAUTOC EQU   TRMBYTE1
TRMINPTP EQU   TRMBYTE1
TRMWTNEG EQU   TRMSCPRQ
TRMWRBRK EQU   TRMBYTE2
TRMNOSND EQU   TRMBYTE2
TRMPREP  EQU   TRMBYTE2
TRMGPACT EQU   TRMBYTE2
TRMANDL  EQU   TRMBYTE2
TRMCLOSN EQU   TRMINPG
TRMREMB  EQU   TRMBYTE2
TRMRSACT EQU   TRMBYTE2
TRMOPTBL EQU   IEDQTRM+18
TRMOPNO  EQU   IEDQTRM+17
TRMCHCIN EQU   IEDQTRM+16
TRMSENSE EQU   TRMSTAT+3
TRMTEMPR EQU   TRMSTAT+2
TRMSIO   EQU   TRMSTAT
@NM00143 EQU   TRMDEVFL+1
TRMTPIN  EQU   TRMDEVFL+1
TRMNCPI  EQU   TRMDEVFL+1
TRMRNTRM EQU   TRMDEVFL+1
@NM00142 EQU   TRMDEVFL+1
TRMLMD   EQU   TRMDEVFL+1
TRMCONC  EQU   TRMDEVFL+1
TRMTSOB  EQU   TRMDEVFL
TRMBFDY  EQU   TRMDEVFL
TRMTBLK  EQU   TRMDEVFL
TRMSBLK  EQU   TRMDEVFL
TRMBLKS  EQU   TRMDEVFL
TRMADDC  EQU   TRMDEVFL
TRMDDIG  EQU   TRMDEVFL
TRMBUFS  EQU   TRMDEVFL
TRMPRILK EQU   TRMALTD
TRMLGB   EQU   TRMDSORG
TRMUTERM EQU   TLISTCNT
TRMDESTQ EQU   IEDQTRM+1
TRMSCNYN EQU   TRMSTATE
TRMOPTFN EQU   TRMSTATE
TRMHELDN EQU   TRMSTATE
TRMACPTN EQU   TRMSTATE
TRMPREF  EQU   TRMSTATE
TRMPROC  EQU   TRMLOG
TRMLIST  EQU   TRMLOG
TRMLINE  EQU   TRMSTATE
SIBLUTYP EQU   SIBSTAT0
SIBCD    EQU   SIBSTAT0
@NM00141 EQU   SIBBIND3
SIBCRES  EQU   SIBBIND3
SIBSPKR  EQU   SIBBIND3
SIBRECOV EQU   SIBBIND3
SIBFMODE EQU   SIBBIND3
SIBALT   EQU   SIBBIND2
SIBBTERM EQU   SIBBIND2
SIBBRACK EQU   SIBBIND2
SIBFMUSE EQU   SIBBIND2
SIBSEBI  EQU   SIBBIND2
SIBSCMP  EQU   SIBBIND2
SIBSEXC  EQU   SIBBIND2
SIBSDEF  EQU   SIBBIND2
SIBSRQM  EQU   SIBBIND1
SIBSCHNG EQU   SIBBIND1
SIBPEBI  EQU   SIBBIND1
SIBPCMP  EQU   SIBBIND1
SIBPEXC  EQU   SIBBIND1
SIBPDEF  EQU   SIBBIND1
SIBPRQM  EQU   SIBBIND1
SIBPCHN  EQU   SIBBIND1
SIBFMPRO EQU   IEDSIBD+19
SIBTSPRO EQU   IEDSIBD+18
@NM00140 EQU   SIBSTAT2
SIBDACLU EQU   SIBSTAT2
SIBRDSCN EQU   SIBSTAT2
SIBTERM  EQU   SIBSTAT2
SIBUSS   EQU   SIBSTAT2
SIBBSTAT EQU   SIBSTAT1
SIBRTRP  EQU   SIBSTAT1
@NM00139 EQU   SIBSTAT1
SIBRQEND EQU   SIBSTAT1
SIBRQSHT EQU   SIBSTAT1
SIBSEQO  EQU   SIBSEQN+2
SIBSEQI  EQU   SIBSEQN
SIBNCNT  EQU   SIBPACIN
SIBMCNT  EQU   SIBPACIN
SIBINBIU EQU   SIBSESSN
SIBSHUTC EQU   SIBSESSN
SIBLGOFF EQU   SIBSESSN
SIBINDEX EQU   IEDSIBD+8
SIBCHAIN EQU   IEDSIBD+4
SIBRUSEG EQU   IEDSIBD
REQRCD2  EQU   REQRCDS+1
REQSWTCH EQU   REQROUTE+1
REQFLAG  EQU   REQROUTE
REQLINK  EQU   IEDREQD+5
@NM00138 EQU   IEDPRUND+4
PRUTHEFI EQU   PRUFIDN
PRUTHUSS EQU   PRUFIDN
PRUTHEIU EQU   PRUFIDN
PRUTHBIU EQU   PRUFIDN
PRUTHTYE EQU   PRUFIDN
@NM00137 EQU   PRURHFG2
PRURHCSI EQU   PRURHFG2
@NM00136 EQU   PRURHFG2
PRURHCDI EQU   PRURHFG2
PRURHEB  EQU   PRURHFG2
PRURHBB  EQU   PRURHFG2
PRURHPI  EQU   PRURHFG1
@NM00135 EQU   PRURHFG1
PRURHER  EQU   PRURHFG1
PRURHDR2 EQU   PRURHFG1
@NM00134 EQU   PRURHFG1
PRURHDR1 EQU   PRURHFG1
PRURHEC  EQU   PRURHFG0
PRURHBC  EQU   PRURHFG0
PRURHFI  EQU   PRURHFG0
@NM00133 EQU   PRURHFG0
PRURUCAT EQU   PRURHFG0
PRURHTYP EQU   PRURHFG0
PRUNUNIT EQU   PRUTIC+1
@NM00132 EQU   PRUTIC
@NM00131 EQU   IEDPRUQD+4
OPCBOTTM EQU   IEDQOPCD+1184
@NM00130 EQU   IEDQOPCD+1100
@NM00129 EQU   IEDQOPCD+948
@NM00128 EQU   IEDQOPCD+940
@NM00127 EQU   IEDQOPCD+380
@NM00126 EQU   OPCPWCOB+8
@NM00125 EQU   OPCPWECB+1
OPCPWCCC EQU   OPCPWECB
OPCPWCHN EQU   OPCPWQCB+1
OPCPWVTO EQU   OPCPWQCB
OPCWAITV EQU   IEDQOPCD+364
OPCTOTCK EQU   IEDQOPCD+360
OPCAPXTL EQU   IEDQOPCD+356
OPCDECR  EQU   IEDQOPCD+352
OPCBUFWT EQU   IEDQOPCD+348
OPCWRKSP EQU   IEDQOPCD+320
OPCADGOT EQU   IEDQOPCD+318
OPCRQCNT EQU   IEDQOPCD+316
OPPOLSTP EQU   IEDQOPCD+312
OPCCKCIB EQU   IEDQOPCD+308
OPCEND   EQU   IEDQOPCD+307
OPCSTCBS EQU   IEDQOPCD+306
OPCHNEND EQU   IEDQOPCD+302
OPCOQSW  EQU   IEDQOPCD+301
@NM00124 EQU   OPCSPEC
@NM00123 EQU   OPCSPEC
@NM00122 EQU   OPCSPEC
@NM00121 EQU   OPCSPEC
OPCFRMCA EQU   OPCSPEC
OPCRSTRT EQU   OPCSPEC
OPCPART  EQU   OPCSPEC
OPCALTD  EQU   OPCSPEC
OPCBFEND EQU   IEDQOPCD+296
OPCBFIRS EQU   IEDQOPCD+292
OPCAVBUF EQU   IEDQOPCD+290
OPCIPLCT EQU   IEDQOPCD+289
OPCCLNTS EQU   IEDQOPCD+288
OPCHA8   EQU   IEDQOPCD+286
OPCBFREQ EQU   IEDQOPCD+284
OPCFREBF EQU   IEDQOPCD+280
OPCNEXT  EQU   IEDQOPCD+272
OPCFMDFC EQU   IEDQOPCD+268
OPCSCNC  EQU   IEDQOPCD+264
OPCHORTG EQU   IEDQOPCD+260
OPCHORT  EQU   IEDQOPCD+256
OPCCKPTL EQU   IEDQOPCD+252
OPCCKPTF EQU   IEDQOPCD+248
OPCWAITA EQU   IEDQOPCD+244
OPCWAITR EQU   IEDQOPCD+240
OPCWAITP EQU   IEDQOPCD+236
OPCWAITO EQU   IEDQOPCD+232
OPCWAITN EQU   IEDQOPCD+228
OPCWAITL EQU   IEDQOPCD+224
OPCWAITC EQU   IEDQOPCD+220
@NM00120 EQU   OPCLDNME+5
@NM00119 EQU   OPCLDNME
OPCWAIT  EQU   IEDQOPCD+192
OPCCKERB EQU   IEDQOPCD+164
OPCBFERB EQU   IEDQOPCD+148
OPCFLAG2 EQU   IEDQOPCD+147
OPCFLAG1 EQU   IEDQOPCD+146
OPCWRKSZ EQU   IEDQOPCD+144
OPCRSAVE EQU   IEDQOPCD+132
OPCQCBAD EQU   IEDQOPCD+128
OPCTRMWA EQU   IEDQOPCD+52
OPCTNTEA EQU   IEDQOPCD+44
OPCPGCK  EQU   IEDQOPCD+40
OPCLCB   EQU   IEDQOPCD+36
@NM00118 EQU   IEDQOPCD+32
OPCIPLAD EQU   IEDQOPCD+28
OPCTOFLK EQU   IEDQOPCD+24
OPCOPTLK EQU   IEDQOPCD+20
OPCDCBLK EQU   IEDQOPCD+16
OPCDOUBL EQU   IEDQOPCD
@NM00117 EQU   OCLDNME+4
@NM00116 EQU   OCPREFLG
OCTOTEP  EQU   OCPREFLG
OCREPOST EQU   OCPREFLG
OCRSPSNT EQU   OCPREFLG
OCBFREQ  EQU   OCPREFLG
OCIDLE   EQU   OCREQFLG
OCFORCE  EQU   OCREQFLG
OCDCARD  EQU   OCREQFLG
OCPARTAL EQU   OCREQFLG
OCADNCP  EQU   OCREQFLG
@NM00115 EQU   OCREQFLG
@NM00114 EQU   OCREQFLG
OCFLUSHZ EQU   OCREQFLG
OCRESPCT EQU   OCLINTTE
OCCKPTWA EQU   OCCKDATA+4
@NM00111 EQU   OCRSTGTM+2
OCCKDAT2 EQU   OCRSTGTM+1
OCCKDAT1 EQU   OCRSTGTM
OCPTRSAV EQU   OCMODNME+4
OCPUADR  EQU   OCIPLWA+2
OCWTGSAV EQU   OCIPLWA
OCDVRDCT EQU   OCBACKUP+6
OCNCP    EQU   OCBACKUP+4
OCBUFGOT EQU   OCBACKUP+2
OCBUFNED EQU   OCBACKUP
OCRESNUM EQU   OCPARM
OCSEQ    EQU   OCTRUNIT+2
@NM00110 EQU   OCRSID+1
OCNONE   EQU   OCALSTAT
OCSOME   EQU   OCALSTAT
OCALLFLG EQU   OCALSTAT
OCACTREQ EQU   OCALSTAT
OCREDRVE EQU   OCALSTAT
OCSEQIND EQU   OCALSTAT
@NM00109 EQU   OCALSTAT
OCRENTRD EQU   OCALSTAT
@NM00108 EQU   @NM00107+2
OCCONID  EQU   OCDEST
OCRLN    EQU   IEDQOPCE+15
OCATTACH EQU   OCFLAG
OCSSCP   EQU   OCFLAG
OCOUTPUT EQU   OCFLAG
OCLINE   EQU   OCFLAG
OCMPP    EQU   OCFLAG
OCTOTE   EQU   OCFLAG
OCCONSOL EQU   OCFLAG
@NM00106 EQU   OCSWITCH
OCQUCKN  EQU   OCSWITCH
OCPRIFLG EQU   OCOPTCDE
@NM00105 EQU   OCRUDEST+1
@NM00104 EQU   OCSCAN
OCNOTUCB EQU   OCSCAN
OCNONAME EQU   OCSCAN
OCALLRLN EQU   OCSCAN
OCDDNAME EQU   OCSCAN
OCDDNRLN EQU   OCSCAN
OCADDR   EQU   OCSCAN
OCELMPTR EQU   OCELEM+1
OCELMPRI EQU   OCELEM
OCLINK   EQU   IEDQOPCE
NCPLTRAC EQU   IEDNCP+26
NCPCKPT  EQU   IEDNCP+22
NCPDPDCB EQU   IEDNCP+18
NCPBKUPN EQU   IEDNCP+2
@NM00103 EQU   NCPFLAG1
NCPTRACE EQU   NCPFLAG1
NCPBKUP  EQU   NCPFLAG1
NCPIPLD  EQU   NCPFLAG1
NCPREST  EQU   NCPFLAG1
NCPBGUP  EQU   NCPFLAG1
NCPDAUTO EQU   NCPFLAG1
NCPIAUTO EQU   NCPFLAG1
NCPLEN   EQU   IEDNCP
SAVTBITN EQU   IEDNSVTD+312
@NM00102 EQU   SAVTCKQB+8
@NM00101 EQU   SAVTCKEC+1
@NM00100 EQU   SAVTCKCC
SAVTCKPO EQU   SAVTCKCC
SAVTCKWA EQU   SAVTCKCC
SAVTCKCH EQU   SAVTCKTB+1
SAVTCKVT EQU   SAVTCKTB
@NM00099 EQU   IEDNSVTD+297
SAVTRDFG EQU   SAVTRDRV+12
@NM00098 EQU   SAVTRDRV+5
SAVTRDPY EQU   SAVTRDRV+4
SAVTRDQB EQU   SAVTRDRV+1
SAVTRDKY EQU   SAVTRDRV
SAVTNID  EQU   IEDNSVTD+280
SAVTDVAS EQU   IEDNSVTD+276
SAVTPLSZ EQU   IEDNSVTD+274
@NM00097 EQU   IEDNSVTD+273
SAVTSUBL EQU   IEDNSVTD+272
@NM00096 EQU   SAVTZELM+1
SAVTSUBM EQU   SAVTZELM
SAVTMHDX EQU   IEDNSVTD+268
SAVTNAT1 EQU   IEDNSVTD+266
SAVTSH20 EQU   IEDNSVTD+264
SAVTLCBS EQU   IEDNSVTD+260
SAVTRNMP EQU   IEDNSVTD+256
SAVTTNTX EQU   IEDNSVTD+252
SAVTNAX  EQU   IEDNSVTD+248
SAVTSUBV EQU   IEDNSVTD+247
SAVTSUBA EQU   IEDNSVTD+246
SAVTSIBC EQU   IEDNSVTD+244
SAVTBSM  EQU   IEDNSVTD+240
SAVTRQTG EQU   IEDNSVTD+236
SAVTRQCH EQU   IEDNSVTD+232
SAVTMAND EQU   IEDNSVTD+228
SAVTSPLN EQU   IEDNSVTD+224
SAVTNADL EQU   IEDNSVTD+222
SAVTNATL EQU   IEDNSVTD+220
SAVTMHTB EQU   IEDNSVTD+216
SAVTSSMH EQU   IEDNSVTD+212
SAVTQRS  EQU   IEDNSVTD+208
SAVTRQIN EQU   IEDNSVTD+204
SAVTDFCO EQU   IEDNSVTD+200
SAVTSAO  EQU   IEDNSVTD+196
SAVTSARI EQU   IEDNSVTD+192
SAVTSAC  EQU   IEDNSVTD+188
SAVTSAI  EQU   IEDNSVTD+184
SAVTCSCI EQU   IEDNSVTD+180
SAVTSSRP EQU   IEDNSVTD+176
SAVTSSRQ EQU   IEDNSVTD+172
SAVTSCLU EQU   IEDNSVTD+168
SAVTMVBF EQU   IEDNSVTD+160
@NM00095 EQU   IEDNSVTD+148
SAVTIPCQ EQU   IEDNSVTD+144
@NM00094 EQU   IEDNSVTD+136
SAVTXFMI EQU   IEDNSVTD+132
@NM00093 EQU   IEDNSVTD+124
SAVTXFMO EQU   IEDNSVTD+120
@NM00092 EQU   IEDNSVTD+116
SAVTSSSR EQU   IEDNSVTD+112
SAVTSCPQ EQU   IEDNSVTD+108
SAVTSLCB EQU   IEDNSVTD+104
SAVTLUSR EQU   IEDNSVTD+100
@NM00091 EQU   SAVTLUSQ+8
SAVTLUSP EQU   SAVTLUSQ+4
SAVTLUSB EQU   SAVTLUSQ
@NM00090 EQU   IEDNSVTD+84
SAVTSAT  EQU   IEDNSVTD+80
SAVTNAT  EQU   IEDNSVTD+76
SAVTCLUP EQU   IEDNSVTD+72
SAVTPIUT EQU   IEDNSVTD+68
SAVTRNTA EQU   IEDNSVTD+64
SAVTDNIR EQU   IEDNSVTD+60
SAVTCNIR EQU   IEDNSVTD+56
SAVTFLDH EQU   IEDNSVTD+52
SAVTSRTN EQU   IEDNSVTD+48
SAVTSREQ EQU   IEDNSVTD+44
SAVTFAIL EQU   IEDNSVTD+42
SAVTSUSE EQU   IEDNSVTD+40
SAVTSIB  EQU   IEDNSVTD+36
SAVTPRTN EQU   IEDNSVTD+32
@NM00089 EQU   IEDNSVTD+28
SAVTWH20 EQU   IEDNSVTD+26
SAVTPWT  EQU   IEDNSVTD+24
SAVTPRTQ EQU   IEDNSVTD+20
SAVTPREQ EQU   IEDNSVTD+16
SAVTPH20 EQU   IEDNSVTD+14
SAVTPUSE EQU   IEDNSVTD+12
SAVTPLCB EQU   IEDNSVTD+8
SAVTPOOL EQU   IEDNSVTD+4
SAVTPRMT EQU   SAVTDIAF
SAVTVIRT EQU   SAVTDIAF
AVTCPBNO EQU   IEDQAVTD+1244
AVTHRESS EQU   IEDQAVTD+1243
@NM00088 EQU   IEDQAVTD+1242
@NM00087 EQU   IEDQAVTD+1241
@NM00086 EQU   IEDQAVTD+1240
@NM00085 EQU   IEDQAVTD+1237
@NM00084 EQU   IEDQAVTD+1236
AVTHRESE EQU   @NM00083
AVTRADDR EQU   IEDQAVTD+1228
AVTNADDR EQU   IEDQAVTD+1224
AVTHRESN EQU   IEDQAVTD+1220
AVTVOLRN EQU   IEDQAVTD+1216
AVTTOTNN EQU   IEDQAVTD+1212
AVTTRCYN EQU   IEDQAVTD+1208
AVTRCTRN EQU   IEDQAVTD+1204
AVTNOVON EQU   IEDQAVTD+1200
AVTADEBN EQU   IEDQAVTD+1196
AVTVOLRR EQU   IEDQAVTD+1192
AVTTOTNR EQU   IEDQAVTD+1188
AVTTRCYR EQU   IEDQAVTD+1184
AVTRCTRR EQU   IEDQAVTD+1180
AVTNOVOR EQU   IEDQAVTD+1176
AVTADEBR EQU   IEDQAVTD+1172
AVTLODPT EQU   IEDQAVTD+1168
AVTIOBN  EQU   IEDQAVTD+1164
AVTIOBR  EQU   IEDQAVTD+1160
AVTCPBPT EQU   IEDQAVTD+1156
AVTFCPB  EQU   IEDQAVTD+1152
@NM00082 EQU   IEDQAVTD+1148
AVTINCPQ EQU   IEDQAVTD+1144
@NM00081 EQU   IEDQAVTD+1140
@NM00080 EQU   IEDQAVTD+1137
@NM00079 EQU   AVTBIT4
@NM00078 EQU   AVTBIT4
@NM00077 EQU   AVTBIT4
@NM00076 EQU   AVTBIT4
@NM00075 EQU   AVTBIT4
@NM00074 EQU   AVTBIT4
@NM00073 EQU   AVTBIT4
AVTRUFTN EQU   AVTBIT4
@NM00072 EQU   IEDQAVTD+1132
AVTNOBFQ EQU   IEDQAVTD+1128
@NM00071 EQU   IEDQAVTD+1124
AVTDKENQ EQU   IEDQAVTD+1120
@NM00070 EQU   IEDQAVTD+1116
AVTDKAPQ EQU   IEDQAVTD+1112
AVTCOPY  EQU   IEDQAVTD+1108
AVTIA    EQU   IEDQAVTD+1104
AVTFL    EQU   IEDQAVTD+1100
@NM00069 EQU   IEDQAVTD+1096
AVTNCPBQ EQU   IEDQAVTD+1092
AVTTOTNC EQU   IEDQAVTD+1088
AVTCMAX  EQU   IEDQAVTD+1084
AVTCMIN  EQU   IEDQAVTD+1080
AVTHM02  EQU   IEDQAVTD+1076
AVTOPCIN EQU   IEDQAVTD+1074
AVTDCTLN EQU   IEDQAVTD+1072
AVTOPMSK EQU   IEDQAVTD+1068
AVTSTEAL EQU   IEDQAVTD+1060
AVTOPTN  EQU   IEDQAVTD+1056
AVTDSKCT EQU   IEDQAVTD+1054
AVTCKRST EQU   IEDQAVTD+1053
AVTSTAN  EQU   AVTBIT3
AVTSTACN EQU   AVTBIT3
AVTSTAIN EQU   AVTBIT3
AVTSTAYN EQU   AVTBIT3
AVTOLTBN EQU   AVTBIT3
AVTTSAB  EQU   AVTBIT3
AVTRFULN EQU   AVTBIT3
AVTRECVN EQU   AVTBIT3
@NM00068 EQU   AVTBIT2
@NM00067 EQU   AVTBIT2
AVTOPEIN EQU   AVTBIT2
AVTSTRTN EQU   AVTBIT2
AVTTOPOL EQU   AVTBIT2
AVTCOPYN EQU   AVTBIT2
AVTREUSN EQU   AVTBIT2
AVTEXTSC EQU   AVTBIT2
AVTDISKN EQU   AVTBIT1
AVTQUCKN EQU   AVTBIT1
AVTCLOSN EQU   AVTBIT1
AVTREADN EQU   AVTBIT1
AVTDLAYN EQU   AVTBIT1
AVTAQTAN EQU   AVTBIT1
AVTTSON  EQU   AVTBIT1
AVTAPLKN EQU   AVTBIT1
AVTDUMBR EQU   IEDQAVTD+1048
AVTDLQX  EQU   IEDQAVTD+1046
AVTINTLV EQU   IEDQAVTD+1044
AVTSMCNT EQU   IEDQAVTD+1042
AVTAVFCT EQU   IEDQAVTD+1040
AVTOPCON EQU   IEDQAVTD+1038
AVTOPCNT EQU   IEDQAVTD+1036
AVTLNCNT EQU   IEDQAVTD+1034
AVTKEYLE EQU   IEDQAVTD+1032
AVTHA16  EQU   IEDQAVTD+1030
AVTHA7   EQU   IEDQAVTD+1028
AVTHA4   EQU   IEDQAVTD+1026
AVTHA3   EQU   IEDQAVTD+1024
AVTHA2   EQU   IEDQAVTD+1022
AVTGETMS EQU   IEDQAVTD+1021
@NM00066 EQU   IEDQAVTD+1020
AVTGETMD EQU   IEDQAVTD+1016
AVTGETMN EQU   IEDQAVTD+1012
AVTCWTOT EQU   IEDQAVTD+1008
AVTCWINT EQU   IEDQAVTD+956
AVTDTRAP EQU   IEDQAVTD+952
@NM00065 EQU   IEDQAVTD+950
@NM00064 EQU   AVTIOTR
AVTIOTRH EQU   AVTIOTR
AVTIOTRE EQU   AVTIOTR
@NM00063 EQU   AVTSUBT
AVTSUBPT EQU   AVTSUBT
AVTSUBON EQU   AVTSUBT
AVTAFE30 EQU   IEDQAVTD+944
AVTAFE20 EQU   IEDQAVTD+940
AVTAFE10 EQU   IEDQAVTD+936
AVTCWEC2 EQU   IEDQAVTD+932
AVTCWPM2 EQU   IEDQAVTD+928
AVTCWTS2 EQU   IEDQAVTD+927
AVTCWTS1 EQU   IEDQAVTD+926
AVTCWCLD EQU   AVTCWFL2
AVTCWRAP EQU   AVTCWFL2
@NM00062 EQU   AVTCWFL2
@NM00061 EQU   AVTCWFL2
@NM00060 EQU   AVTCWFL2
@NM00059 EQU   AVTCWFL2
@NM00058 EQU   AVTCWFL2
AVTCWACT EQU   AVTCWFL2
@NM00057 EQU   AVTCWFL1
@NM00056 EQU   AVTCWFL1
@NM00055 EQU   AVTCWFL1
@NM00054 EQU   AVTCWFL1
@NM00053 EQU   AVTCWFL1
@NM00052 EQU   AVTCWFL1
@NM00051 EQU   AVTCWFL1
AVTCOMWN EQU   AVTCWFL1
AVTCWEC1 EQU   IEDQAVTD+920
AVTCWPM1 EQU   IEDQAVTD+916
AVTCAREA EQU   IEDQAVTD+912
AVTFZERO EQU   IEDQAVTD+908
AVTCADDR EQU   IEDQAVTD+904
AVTCOREC EQU   IEDQAVTD+900
@NM00050 EQU   IEDQAVTD+892
AVTCPBCB EQU   IEDQAVTD+888
@NM00049 EQU   IEDQAVTD+880
AVTDSIOB EQU   IEDQAVTD+876
@NM00048 EQU   IEDQAVTD+868
AVTCPRMB EQU   IEDQAVTD+864
@NM00047 EQU   IEDQAVTD+856
AVTCLOSB EQU   IEDQAVTD+852
@NM00046 EQU   IEDQAVTD+844
AVTACTIB EQU   IEDQAVTD+840
@NM00045 EQU   IEDQAVTD+836
AVTOLTEB EQU   IEDQAVTD+832
AVTOLTCH EQU   AVTOLTQB+1
AVTOLTVT EQU   AVTOLTQB
@NM00044 EQU   AVTOPCQB+8
@NM00043 EQU   AVTOPCEC+1
@NM00042 EQU   AVTOPCCC
AVTOPCPO EQU   AVTOPCCC
AVTOPCWA EQU   AVTOPCCC
AVTOPCCH EQU   AVTOPCOB+1
AVTOPCVT EQU   AVTOPCOB
@NM00041 EQU   AVTCKPQB+9
AVTCKPTS EQU   AVTCKPQB+8
@NM00040 EQU   AVTCKPEC+1
@NM00039 EQU   AVTCKPCC
AVTCKPPO EQU   AVTCKPCC
AVTCKPWA EQU   AVTCKPCC
AVTCKPCH EQU   AVTCKPTB+1
AVTCKPVT EQU   AVTCKPTB
@NM00038 EQU   IEDQAVTD+796
AVTBFRTB EQU   IEDQAVTD+792
@NM00037 EQU   IEDQAVTD+784
AVTBFREB EQU   IEDQAVTD+780
AVTTIMQ  EQU   IEDQAVTD+776
@NM00036 EQU   IEDQAVTD+772
AVTIMQPS EQU   IEDQAVTD+768
AVTINOUT EQU   IEDQAVTD+766
AVTREFTM EQU   IEDQAVTD+764
@NM00035 EQU   IEDQAVTD+752
AVTDELYB EQU   IEDQAVTD+748
AVTOCQPT EQU   IEDQAVTD+744
AVTTSOPT EQU   IEDQAVTD+740
AVTSUPPT EQU   IEDQAVTD+736
AVTCBQCB EQU   IEDQAVTD+732
AVTMSGS  EQU   IEDQAVTD+729
@NM00034 EQU   AVTSYSER
@NM00033 EQU   AVTSYSER
@NM00032 EQU   AVTSYSER
@NM00031 EQU   AVTSYSER
@NM00030 EQU   AVTSYSER
@NM00029 EQU   AVTSYSER
AVTCMAXN EQU   AVTSYSER
AVTCMINN EQU   AVTSYSER
AVT2260L EQU   IEDQAVTD+724
AVTABEPL EQU   AVTADBUF
AVTHFF   EQU   AVTCLRHI+2
@NM00028 EQU   AVTCLRHI
AVTCCLNK EQU   AVTCRELE+5
AVTCCPRI EQU   AVTCRELE+4
AVTCCQCB EQU   AVTCCELE+1
AVTCCKEY EQU   AVTCCELE
AVTDELAD EQU   IEDQAVTD+704
AVTDELEM EQU   IEDQAVTD+700
AVTBSX   EQU   AVTCKLNK
AVTOPETR EQU   AVTHG01
@NM00027 EQU   AVTCKBYT
AVTCKONQ EQU   AVTCKBYT
@NM00026 EQU   AVTCKBYT
@NM00025 EQU   AVTCKBYT
@NM00024 EQU   AVTCKBYT
@NM00023 EQU   AVTCKBYT
@NM00022 EQU   AVTCKBYT
@NM00021 EQU   AVTCKBYT
AVTOPERT EQU   IEDQAVTD+690
AVTOPXCL EQU   IEDQAVTD+688
AVTOPERL EQU   IEDQAVTD+687
@NM00020 EQU   IEDQAVTD+686
AVTCKTIM EQU   IEDQAVTD+684
AVTCKELV EQU   IEDQAVTD+682
AVTCPRCD EQU   IEDQAVTD+681
AVTWARMN EQU   AVTCKELF
AVTCRTLN EQU   AVTCKELF
AVTCPIPN EQU   AVTCKELF
AVTCCLCN EQU   AVTCKELF
AVTCINCN EQU   AVTCKELF
@NM00019 EQU   AVTCKELF
AVTCMCPN EQU   AVTCKELF
AVTCRDYN EQU   AVTCKELF
AVTCKQAD EQU   IEDQAVTD+677
AVTSCBSZ EQU   IEDQAVTD+676
@NM00018 EQU   IEDQAVTD+672
AVTCKELE EQU   IEDQAVTD+668
@NM00017 EQU   AVTCKPEL+8
AVTCKRLK EQU   AVTCKPEL+5
AVTCKRPR EQU   AVTCKPEL+4
AVTCKRMQ EQU   AVTCKRMV+1
AVTCKRKY EQU   AVTCKRMV
AVTHK    EQU   IEDQAVTD+648
AVTHI    EQU   IEDQAVTD+644
AVTIOT   EQU   IEDQAVTD+640
AVTNX    EQU   IEDQAVTD+636
AVTTONE  EQU   IEDQAVTD+632
AVTA3TL  EQU   IEDQAVTD+628
AVTDMECB EQU   IEDQAVTD+624
AVTABEND EQU   IEDQAVTD+618
AVTPLCBN EQU   IEDQAVTD+616
@NM00016 EQU   AVTSAVTP+1
@NM00015 EQU   AVTSAVTF
AVTSNA   EQU   AVTSAVTF
AVTONSNA EQU   AVTSAVTF
AVTVTMCP EQU   AVTSAVTF
@NM00014 EQU   IEDQAVTD+608
AVTCMBSS EQU   IEDQAVTD+604
AVTRCV   EQU   IEDQAVTD+600
AVTSEND  EQU   IEDQAVTD+596
AVTCSCH  EQU   IEDQAVTD+592
AVTQ1    EQU   IEDQAVTD+588
AVTE7    EQU   IEDQAVTD+584
AVTHB    EQU   IEDQAVTD+580
AVTR1    EQU   IEDQAVTD+576
AVTBZ    EQU   IEDQAVTD+572
AVTEZ    EQU   IEDQAVTD+568
AVTEC    EQU   IEDQAVTD+564
AVTEW    EQU   IEDQAVTD+560
AVTNDIAL EQU   AVTSCOPT
AVTN2741 EQU   AVTSCOPT
AVTCONCO EQU   AVTSCOPT
AVTCONC  EQU   AVTSCOPT
AVTCMBUF EQU   AVTSCOPT
AVTAPDMP EQU   AVTSCOPT
@NM00013 EQU   AVTSCOPT
AVTHA    EQU   AVTDISP
AVTEA    EQU   IEDQAVTD+548
AVTAX    EQU   IEDQAVTD+544
AVTA3    EQU   IEDQAVTD+540
AVTGD    EQU   IEDQAVTD+536
AVTAL    EQU   IEDQAVTD+532
AVTOLTST EQU   AVTHG02
AVTE8    EQU   IEDQAVTD+524
AVTUI    EQU   IEDQAVTD+520
AVTCOMPT EQU   IEDQAVTD+516
AVTCRSRF EQU   IEDQAVTD+512
@NM00012 EQU   IEDQAVTD+508
AVTKA02  EQU   IEDQAVTD+504
AVTOPTPT EQU   IEDQAVTD+500
AVTPCBPT EQU   IEDQAVTD+496
AVTOSECB EQU   IEDQAVTD+492
AVTOPECA EQU   IEDQAVTD+488
AVTOLECA EQU   IEDQAVTD+484
AVTCKECA EQU   IEDQAVTD+480
AVTCWECA EQU   IEDQAVTD+476
AVTCWTCB EQU   IEDQAVTD+472
AVTOLTCB EQU   IEDQAVTD+468
AVTOCTCB EQU   IEDQAVTD+464
AVTCKTCB EQU   IEDQAVTD+460
AVTAS    EQU   IEDQAVTD+456
AVTNOLBF EQU   IEDQAVTD+454
AVTNCKPR EQU   IEDQAVTD+453
AVTCIB   EQU   IEDQAVTD+452
AVTSPLPT EQU   IEDQAVTD+448
AVTMVBFR EQU   IEDQAVTD+444
AVTSBTA  EQU   IEDQAVTD+440
AVTRARTN EQU   IEDQAVTD+436
AVTBSCAN EQU   IEDQAVTD+432
AVTRDYA  EQU   IEDQAVTD+428
AVTDISTR EQU   IEDQAVTD+420
AVTPARM3 EQU   IEDQAVTD+416
@NM00011 EQU   AVTPKF
@NM00010 EQU   AVTPKF
@NM00009 EQU   AVTPKF
AVTFTCHF EQU   AVTPKF
@NM00008 EQU   AVTPKF
@NM00007 EQU   AVTPKF
@NM00006 EQU   AVTPKF
@NM00005 EQU   AVTPKF
AVTPARM  EQU   IEDQAVTD+408
AVTEXS2A EQU   IEDQAVTD+402
AVTEXA2S EQU   IEDQAVTD+396
AVTOCGET EQU   IEDQAVTD+392
AVTCKAVT EQU   @NM00003+1
@NM00004 EQU   AVTCKFLG
AVTCKHLT EQU   AVTCKFLG
AVTCKREQ EQU   AVTCKFLG
AVTCKENV EQU   AVTCKFLG
AVTCKNAC EQU   AVTCKFLG
AVTCKTAC EQU   AVTCKFLG
@NM00002 EQU   IEDQAVTD+384
AVTREADD EQU   IEDQAVTD+380
AVTREADY EQU   IEDQAVTD+376
AVTRACE  EQU   IEDQAVTD+372
AVTTCB   EQU   IEDQAVTD+368
AVTPASWD EQU   IEDQAVTD+360
AVTCTLCH EQU   IEDQAVTD+352
AVTDOUBL EQU   IEDQAVTD+344
AVTDOUBX EQU   IEDQAVTD+336
AVTDPARM EQU   IEDQAVTD+332
AVTCSTCS EQU   IEDQAVTD+328
AVTDLQ   EQU   AVTSAVEX+32
@NM00001 EQU   AVTSAVEX
AVTSAVE4 EQU   IEDQAVTD+216
AVTSAVE3 EQU   IEDQAVTD+144
AVTSAVE2 EQU   IEDQAVTD+72
AVTSAVE1 EQU   IEDQAVTD
.@UNREFD ANOP                          END UNREFERENCED COMPONENTS
@RC00467 EQU   @RC00461
@RC00490 EQU   @RC00488
@RC00522 EQU   @RC00520
@RC00503 EQU   @RC00490
@ENDDATA EQU   *
         END   IGCA610D,(C'PLS0035',0701,77013)
