         TITLE 'IGCA710D, ACTIVATE A LINK                              *
                        '
IGCA710D CSECT ,                                                01S0001
@PROLOG  DS    0H                                               01S0002
*                                                               02S0397
*   /*****************************************************************/
*   /*                                                               */
*   /* PROLOGUE: THIS SEGMENT COMPLETES THE PROLOGUE CODE THAT WAS   */
*   /* ALTERED BY THE MODULE PROCEDURE STATEMENT.                    */
*   /*                                                               */
*   /*****************************************************************/
*                                                               02S0397
*   RCODEREG=RENTREG;               /* SET THE CODE BASE REGISTER
*                                      WITH THE ADDRESS OF THE FIRST
*                                      INSTRUCTION OF THE MODULE     */
         LR    RCODEREG,RENTREG                                 02S0397
*   GEN REFS(RCODEREG) NOSETS;                                  02S0398
*                                   /*
         USING IGCA710D,RCODEREG       INFORM THE ASSEMBLER OF THE
*                                      REGISTER TO BE USED FOR
*                                      ADDRESSING CODE
*   GEN NOREFS NOSETS;                                          02S0399
*                                   /*
IGCA710D IEDHJN AFTERHJN,HJN           MODULE IDENTIFICATION MACRO
*   ROPCAVT=RPARMREG;               /* ESTABLISH ADDRESSABILITY TO
*                                      THE OPERATOR CONTROL ADDRESS
*                                      VECTOR TABLE FROM THE INPUT
*                                      PARAMETER REGISTER            */
         LR    ROPCAVT,RPARMREG                                 02S0400
*   RDATAREG=OPCWORK;               /* SET THE REGISTER TO BE USED
*                                      FOR ADDRESSING AUTOMATIC DATA
*                                      WITH THE ADDRESS OF THE  02S0401
*                                      OPERATOR CONTROL RESIDENT WORK
*                                      AREA                          */
         L     RDATAREG,OPCWORK(,ROPCAVT)                       02S0401
*   GEN REFS(RDATAREG) NOSETS;                                  02S0402
*                                   /*
         USING @DATD,RDATAREG          PROVIDE ADDRESSABILITY TO ALL
*                                      AUTOMATIC DATA
*   RSAVEREG=ADDR(OPCSAVE);         /* ESTABLISH ADDRESSABILITY TO
*                                      THE OPERATOR CONTROL SAVE AREA*/
         LA    RSAVEREG,OPCSAVE(,ROPCAVT)                       02S0403
*   RFY                                                         02S0404
*     RENTREG UNRSTD;               /* RELEASE THE REGISTER     02S0404
*                                      RESTRICTED AT ENTRY TO THE
*                                      MODULE THAT WAS USED BY THE
*                                      XCTL MACRO TO CONTAIN THE
*                                      ENTRY POINT ADDRESS OF THE
*                                      MODULE                        */
*                                                               02S0405
*   /*****************************************************************/
*   /*                                                               */
*   /* PROCESS: THIS SEGMENT DOES THE PROCESSING THAT IS NECESSARY TO*/
*   /* PERFORM THE FUNCTION OF THE MODULE.                           */
*   /*                                                               */
*   /*****************************************************************/
*                                                               02S0405
*                                                               03S0405
*   /*****************************************************************/
*   /*                                                               */
*   /* PROCESS.INITIAL: THIS SEGMENT DOES THE INITIAL PROCESSING OF  */
*   /* THE MODULE.                                                   */
*   /*                                                               */
*   /*****************************************************************/
*                                                               03S0405
*   RAVT=OPCAVTPT;                  /* ESTABLISH ADDRESSABILITY TO
*                                      THE TCAM ADDRESS VECTOR TABLE */
         L     RAVT,OPCAVTPT(,ROPCAVT)                          03S0405
*   ROPCE=OPCCOPCE;                 /* ESTABLISH ADDRESSABILITY TO
*                                      THE INPUT OPERATOR CONTROL
*                                      ELEMENT                       */
         L     ROPCE,OPCCOPCE(,ROPCAVT)                         03S0406
*   RPARMREG=OCTRMTBL;              /* SET UP THE PARAMETER (TERMINAL
*                                      NAME TABLE INDEX) FOR THE
*                                      IEDQTNT ROUTINE               */
         LH    RPARMREG,OCTRMTBL(,ROPCE)                        03S0407
         N     RPARMREG,@CF01489                                03S0407
*   CALL IEDQTNT;                   /* OBTAIN THE ADDRESS OF THE
*                                      TERMINAL TABLE ENTRY FOR THE
*                                      RESOURCE BEING ACTED UPON     */
         L     @15,AVTRNMPT(,RAVT)                              03S0408
         BALR  @14,@15                                          03S0408
*   RTRM=RPARMREG;                  /* ESTABLISH ADDRESSABILITY TO
*                                      THE TERMINAL TABLE ENTRY BY
*                                      USING THE RESULT FROM THE
*                                      IEDQTNT ROUTINE               */
         LR    RTRM,RPARMREG                                    03S0409
*   IF OCRESP=OFF                   /* TEST FOR A NEW "ACTIVATE LINK"
*                                      REQUEST                       */
*     THEN                          /* PROCESS THE "ACTIVATE LINK"
*                                      REQUEST                       */
         TM    OCRESP(ROPCE),B'00000001'                        02S0410
         BNZ   @RF00410                                         02S0410
*     DO;                                                       02S0411
*                                                               03S0412
*       /*************************************************************/
*       /*                                                           */
*       /* PROCESS.REQUEST: THIS SEGMENT DOES THE PROCESSING THAT IS */
*       /* NECESSARY WHEN AN "ACTIVATE LINK" REQUEST IS RECEIVED. THE*/
*       /* ALLOCBUF EXTERNAL ROUTINE IS USED TO OBTAIN A BUFFER FOR  */
*       /* BUILDING THE PACKED REQUEST UNIT. THE PACKED REQUEST UNIT */
*       /* IS BUILT, THE LINK STATE IS SET, AND THE APPROPRIATE      */
*       /* FIELDS ARE SET IN PREPARATION FOR SENDING OUT THE REQUEST.*/
*       /*                                                           */
*       /*************************************************************/
*                                                               03S0412
*       RPARMREG=1;                 /* SET THE NUMBER OF UNITS  03S0412
*                                      DESIRED TO ONE (1) BUFFER UNIT*/
         LA    RPARMREG,1                                       03S0412
*       CALL ALLOCBUF;              /* CALL TO GET A BUFFER UNIT     */
         L     @15,OPCGETBF(,ROPCAVT)                           03S0413
         BALR  @14,@15                                          03S0413
*       OCUNIT=RPARMREG;            /* ATTACH THE BUFFER UNIT TO THE
*                                      OPERATOR CONTROL ELEMENT      */
         ST    RPARMREG,OCUNIT(,ROPCE)                          03S0414
*       IEDPRUND=RHPACKTH;          /* SET THE REQUEST HEADER AND THE
*                                      PACKED RESPONSE UNIT HEADER   */
         L     @11,OCUNIT(,ROPCE)                               03S0415
         LR    @09,@11                                          03S0415
         AL    @09,@CF01490                                     03S0415
         XC    IEDPRUND+4(4,@09),IEDPRUND+4(@09)                03S0415
         MVC   IEDPRUND(4,@09),@CB01475                         03S0415
*       PRUDATCT=LENGTH(ACTLDATA);  /* SET THE DATA COUNT FIELD TO
*                                      THE NUMBER OF BYTES IN THE
*                                      REQUEST UNIT DATA             */
         MVC   PRUDATCT(2,@11),@CH00154                         03S0416
*                                                               04S0417
*       /*************************************************************/
*       /*                                                           */
*       /* PROCESS.REQUEST.ACTLBLD: THIS SEGMENT BUILDS THE REQUEST  */
*       /* UNIT DATA FOR THE "ACTIVATE LINK" PACKED REQUEST UNIT.    */
*       /*                                                           */
*       /*************************************************************/
*                                                               04S0417
*       ACTLNETS=CD1NETS;           /* SET THE NETWORK SERVICES 04S0417
*                                      INDICATOR                     */
         MVI   ACTLNETS(@11),X'01'                              04S0417
*       ACTLCONS=CD1CONFS;          /* SET THE CONFIGURATION SERVICES
*                                      INDICATOR                     */
         MVI   ACTLCONS(@11),X'02'                              04S0418
*       ACTLCODE=CD1ACTLK;          /* SET THE "ACTIVATE LINK"  04S0419
*                                      REQUEST CODE                  */
         MVI   ACTLCODE(@11),X'0A'                              04S0419
*       RFY                                                     04S0420
*         RRETCODE RSTD;            /* RESTRICT THE RETURN CODE 04S0420
*                                      REGISTER                      */
*       RPARMREG=RTRM;              /* SET THE PARAMETER REGISTER
*                                      WITH THE TERMINAL TABLE ENTRY
*                                      ADDRESS OF THE RESOURCE TO BE
*                                      ACTIVATED                     */
         LR    RPARMREG,RTRM                                    04S0421
*       CALL COHORTLK;              /* CALL THE COHORT LOOK-UP  04S0422
*                                      ROUTINE                       */
         L     @15,OPCHORT(,ROPCAVT)                            04S0422
         BALR  @14,@15                                          04S0422
*       PRUTTCIN=RWORK;             /* SET THE TERMINAL NAME TABLE
*                                      CURRENT INDEX FIELD OF THE
*                                      PACKED REQUEST UNIT WITH THE
*                                      RESULT RETURNED FROM THE 04S0423
*                                      COHORTLK ROUTINE              */
         L     @14,OCUNIT(,ROPCE)                               04S0423
         STH   RWORK,PRUTTCIN(,@14)                             04S0423
*       RPARMREG=OCTRMTBL;          /* SET THE PARAMETER REGISTER FOR
*                                      THE IEDIAP04 EXTERNAL ROUTINE
*                                      WITH THE TERMINAL NAME TABLE
*                                      INDEX OF THE LINK             */
         LH    RPARMREG,OCTRMTBL(,ROPCE)                        04S0424
         N     RPARMREG,@CF01489                                04S0424
*       CALL IEDIAP04;              /* CALL THE TERMINAL NAME TABLE
*                                      INDEX TO NETWORK ADDRESS 04S0425
*                                      TRANSFORMATION ROUTINE        */
         L     @11,AVTSAVTP(,RAVT)                              04S0425
         L     @15,SAVTTNTX(,@11)                               04S0425
         BALR  @14,@15                                          04S0425
*       ACTLNETA=RRETCODE;          /* SET THE NETWORK ADDRESS FIELD
*                                      IN THE "ACTIVATE LINK" REQUEST
*                                      UNIT DATA                     */
         L     @14,OCUNIT(,ROPCE)                               04S0426
         STCM  RRETCODE,3,ACTLNETA(@14)                         04S0426
*       RFY                                                     04S0427
*         RRETCODE UNRSTD;          /* RELEASE THE RETURN CODE  04S0427
*                                      REGISTER                      */
*       TRMLSTAT=TRMLAPND;          /* SET THE STATE OF THE LINK AS
*                                      "ACTIVE PENDING"              */
         LR    @11,RTRM                                         03S0428
         AL    @11,@CF01491                                     03S0428
         NI    TRMLSTAT-1(@11),B'11011111'                      03S0428
         OI    TRMLSTAT-1(@11),B'00010000'                      03S0428
*       OCWTGB=OCWTG;               /* SET THE OPERATOR CONTROL 03S0429
*                                      "WHERE TO GO BACK-UP" FIELD
*                                      WITH THE MODULE IDENTIFICATION
*                                      LETTERS FROM THE OPERATOR
*                                      CONTROL "WHERE TO GO" FIELD   */
         MVC   OCWTGB(2,ROPCE),OCWTG(ROPCE)                     03S0429
*       OCWTG=MODID;                /* SET THE "WHERE TO GO" FIELD TO
*                                      INDICATE THAT THE RESPONSE TO
*                                      THE "ACTIVATE LINK" REQUEST IS
*                                      TO BE SENT BACK TO THIS MODULE*/
         MVC   OCWTG(2,ROPCE),@CC01467                          03S0430
*       OPCMODID=OUTMODID;          /* SET THE MODULE IDENTIFICATION
*                                      LETTERS FOR USE BY THE XCTL
*                                      MACRO INSTRUCTION TO SEND OUT
*                                      THE REQUEST                   */
         MVC   OPCMODID(2,ROPCAVT),@CC01469                     03S0431
*     END;                                                      02S0432
*   ELSE                            /* PROCESS THE "ACTIVATE LINK"
*                                      RESPONSE                      */
*     DO;                                                       02S0433
         B     @RC00410                                         02S0433
@RF00410 DS    0H                                               02S0434
*                                                               03S0434
*       /*************************************************************/
*       /*                                                           */
*       /* PROCESS.RESPONSE: THIS SEGMENT DOES THE PROCESSING THAT IS*/
*       /* NECESSARY WHEN AN "ACTIVATE LINK" RESPONSE IS RECEIVED.   */
*       /*                                                           */
*       /*************************************************************/
*                                                               03S0434
*       PTRDATA=ADDR(PRUDATA);      /* ESTABLISH ADDRESSABILITY TO
*                                      THE RESPONSE UNIT DATA        */
         L     @11,OCUNIT(,ROPCE)                               03S0434
         LA    PTRDATA,PRUDATA(,@11)                            03S0434
*       IF PRURHSDI=OFF             /* TEST FOR THE ABSENCE OF SENSE
*                                      DATA                          */
*         THEN                      /* SET THE RETURN CODE TO   03S0435
*                                      INDICATE A POSITIVE RESPONSE
*                                      AND SET THE STATE OF THE LINK
*                                      AS "LINK ACTIVE"              */
         AL    @11,@CF01490                                     03S0435
         TM    PRURHSDI(@11),B'00000100'                        03S0435
         BNZ   @RF00435                                         03S0435
*         DO;                                                   03S0436
*           OCPARM=OCRCGPOS;        /* SET THE RETURN CODE FIELD IN
*                                      THE OPERATOR CONTROL ELEMENT  */
         MVC   OCPARM(2,ROPCE),@CH00061                         03S0437
*           TRMLSTAT=TRMLACTV;      /* SET THE STATE OF THE LINK AS
*                                      "LINK ACTIVE"                 */
         LR    @11,RTRM                                         03S0438
         SL    @11,@CF01488                                     03S0438
         OI    TRMLSTAT(@11),B'00110000'                        03S0438
*           TRMRSACT=ON;            /* INDICATE THAT THE RESOURCE IS
*                                      ACTIVE                @YM03736*/
         LA    @15,TRMRSACT(,@11)                               03S0439
         LR    @14,@15                                          03S0439
         LA    @09,3                                            03S0439
         NR    @14,@09                                          03S0439
         LCR   @14,@14                                          03S0439
         ALR   @15,@14                                          03S0439
         L     @09,0(,@15)                                      03S0439
@GL00001 LR    @05,@09                                          03S0439
         O     @05,@CB01495+3(@14)                              03S0439
         CS    @09,@05,0(@15)                                   03S0439
         BNE   @GL00001                                         03S0439
*         END;                                                  03S0440
*       ELSE                        /* DETERMINE THE TYPE OF NEGATIVE
*                                      RETURN CODE AND SET THE LINK
*                                      STATE                         */
*         DO;                                                   03S0441
         B     @RC00435                                         03S0441
@RF00435 DS    0H                                               03S0442
*                                                               04S0442
*           /*********************************************************/
*           /*                                                       */
*           /* PROCESS.RESPONSE.NEGATIVE: THIS SEGMENT DETERMINES THE*/
*           /* TYPE OF THE NEGATIVE RESPONSE THAT WAS RECEIVED, SETS */
*           /* THE APPROPRIATE RETURN CODE, AND SETS THE STATE OF THE*/
*           /* LINK ACCORDINGLY.                                     */
*           /*                                                       */
*           /*********************************************************/
*                                                               04S0442
*           PTRDATA=PTRDATA+LENGTH(SENSE);/* INDEX POINTER BY THE
*                                      LENGTH OF THE SENSE DATA      */
         AL    PTRDATA,@CF00328                                 04S0442
*           IF SENSYS=FUNCACT       /* TEST THE SYSTEM SENSE FOR AN
*                                      INDICATION THAT THE LINK IS
*                                      ALREADY ACTIVE                */
*             THEN                  /* SET A GOOD RETURN CODE AND SET
*                                      THE STATE OF THE LINK TO "LINK
*                                      ACTIVE"                       */
         L     @11,OCUNIT(,ROPCE)                               04S0443
         CLC   SENSYS(2,@11),@CB01465                           04S0443
         BNE   @RF00443                                         04S0443
*             DO;                                               04S0444
*               OCPARM=OCRCGNEG;    /* SET THE RETURN CODE FIELD IN
*                                      THE OPERATOR CONTROL ELEMENT  */
         MVC   OCPARM(2,ROPCE),@CH00128                         04S0445
*               TRMLSTAT=TRMLACTV;  /* SET THE STATE OF THE LINK TO
*                                      "LINK ACTIVE"                 */
         LR    @11,RTRM                                         04S0446
         SL    @11,@CF01488                                     04S0446
         OI    TRMLSTAT(@11),B'00110000'                        04S0446
*               TRMRSACT=ON;        /* INDICATE THAT THE RESOURCE IS
*                                      ACTIVE                @YM03736*/
         LA    @15,TRMRSACT(,@11)                               04S0447
         LR    @14,@15                                          04S0447
         LA    @09,3                                            04S0447
         NR    @14,@09                                          04S0447
         LCR   @14,@14                                          04S0447
         ALR   @15,@14                                          04S0447
         L     @09,0(,@15)                                      04S0447
@GL00002 LR    @05,@09                                          04S0447
         O     @05,@CB01495+3(@14)                              04S0447
         CS    @09,@05,0(@15)                                   04S0447
         BNE   @GL00002                                         04S0447
*             END;                                              04S0448
*           ELSE                    /* SET A BAD RETURN CODE AND SET
*                                      THE STATE OF THE LINK AS "LINK
*                                      RESET"                        */
*             DO;                                               04S0449
         B     @RC00443                                         04S0449
@RF00443 DS    0H                                               04S0450
*               OCPARM=OCRCBNEG;    /* SET THE RETURN CODE FIELD IN
*                                      THE OPERATOR CONTROL ELEMENT  */
         MVC   OCPARM(2,ROPCE),@CH00994                         04S0450
*               TRMLSTAT=TRMLRSET;  /* SET THE STATE OF THE LINK TO
*                                      "LINK RESET"                  */
         LR    @11,RTRM                                         04S0451
         AL    @11,@CF01491                                     04S0451
         NI    TRMLSTAT-1(@11),B'11001111'                      04S0451
*             END;                                              04S0452
*         END;                                                  03S0453
@RC00443 DS    0H                                               03S0454
*       OPCMODID=OCWTGB;            /* SET THE MODULE IDENTIFICATION
*                                      CHARACTERS FOR THE XCTL MACRO
*                                      INSTRUCTION FROM THE OPERATOR
*                                      CONTROL ELEMENT "WHERE TO GO
*                                      BACK-UP" FIELD                */
@RC00435 MVC   OPCMODID(2,ROPCAVT),OCWTGB(ROPCE)                03S0454
*       OCWTG=''B;                  /* ZERO THE "WHERE TO GO" FIELD
*                                      IN THE OPERATOR CONTROL  03S0455
*                                      ELEMENT TO INDICATE THAT THE
*                                      PROCESSING OF THE "ACTIVATE
*                                      LINK" REQUEST HAS ENDED       */
         XC    OCWTG(2,ROPCE),OCWTG(ROPCE)                      03S0455
*     END;                                                      02S0456
*                                                               02S0457
*   /*****************************************************************/
*   /*                                                               */
*   /* EPILOGUE: THIS SEGMENT COMPLETES THE EPILOGUE CODE THAT WAS   */
*   /* ALTERED BY THE MODULE PROCEDURE STATEMENT. THE XCTL MACRO     */
*   /* INSTRUCTION IS USED BY THIS SEGMENT TO TRANSFER CONTROL TO THE*/
*   /* NEXT MODULE THAT IS TO BE EXECUTED.                           */
*   /*                                                               */
*   /*****************************************************************/
*                                                               02S0457
*   RPARMREG=ROPCAVT;               /* SET THE PARAMETER REGISTER
*                                      WITH THE ADDRESS OF THE  02S0457
*                                      ADDRESS OF THE OPERATOR  02S0457
*                                      CONTROL ADDRESS VECTOR TABLE
*                                      IN PREPARATION TO TRANSFERRING
*                                      CONTROL TO ANOTHER MODULE     */
@RC00410 LR    RPARMREG,ROPCAVT                                 02S0457
*   GEN EXIT REFS(OPCXCTL,ROPCAVT) NOSEQFLOW SETS(RENTREG);     02S0458
*                                   /*
         XCTL  SF=(E,OPCXCTL(ROPCAVT)) TRANSFER CONTROL MACRO
*   END IGCA710D                                                01S0459
*                                                               01S0459
*/* THE FOLLOWING INCLUDE STATEMENTS WERE FOUND IN THIS PROGRAM.     */
*/*%INCLUDE SYSLIB  (TAVTD   )                                       */
*/*%INCLUDE SYSLIB  (TCD1D   )                                       */
*/*%INCLUDE SYSLIB  (TOPCED  )                                       */
*/*%INCLUDE SYSLIB  (TOPCAVTD)                                       */
*/*%INCLUDE SYSLIB  (TPRIOR  )                                       */
*/*%INCLUDE SYSLIB  (TPRUD   )                                       */
*/*%INCLUDE SYSLIB  (TTRMD   )                                       */
*/*%INCLUDE SYSUT5  (RFY     )                                       */
*/*%INCLUDE SYSUT5  (DCL     )                                       */
*/*%INCLUDE SYSUT5  (PROLOGUE)                                       */
*/*%INCLUDE SYSUT5  (PROCESS )                                       */
*/*%INCLUDE SYSUT5  (INITIAL )                                       */
*/*%INCLUDE SYSUT5  (REQUEST )                                       */
*/*%INCLUDE SYSUT5  (ACTLBLD )                                       */
*/*%INCLUDE SYSUT5  (RESPONSE)                                       */
*/*%INCLUDE SYSUT5  (NEGATIVE)                                       */
*/*%INCLUDE SYSUT5  (EPILOGUE)                                       */
*                                                               01S0459
*       ;                                                       01S0459
@DATA    DS    0H
@CH00061 DC    H'1'
@CH00128 DC    H'2'
@CH00154 DC    H'5'
@CH00994 DC    H'-1'
@DATD    DSECT
         DS    0F
IGCA710D CSECT
         DS    0F
@CF00328 DC    F'4'
@CF01488 DC    F'14'
@CF01491 DC    F'-13'
@CF01490 DC    F'-8'
@CF01489 DC    XL4'0000FFFF'
@DATD    DSECT
         DS    0D
         ORG   *+1-(*-@DATD)/(*-@DATD) INSURE DSECT DATA
@ENDDATD EQU   *
IGCA710D CSECT
         NOPR  ((@ENDDATD-@DATD)/561*16)
         DS    0F
@SIZDATD DC    AL1(0)
         DC    AL3(@ENDDATD-@DATD)
         DS    0D
@CC01467 DC    C'A7'
@CC01469 DC    C'02'
@CB01475 DC    X'0B80001C'
@CB01465 DC    X'0815'
@CB01495 DC    B'000000000000000000000000100000000000000000000000000000C
               00'
         DS    CL1
PATCH    DC    XL104'0'
@00      EQU   00                      EQUATES FOR REGISTERS 0-15
@01      EQU   01
@02      EQU   02
@03      EQU   03
@04      EQU   04
@05      EQU   05
@06      EQU   06
@07      EQU   07
@08      EQU   08
@09      EQU   09
@10      EQU   10
@11      EQU   11
@12      EQU   12
@13      EQU   13
@14      EQU   14
@15      EQU   15
PTRDATA  EQU   @05
ROPCE    EQU   @03
ROPCAVT  EQU   @02
RAVT     EQU   @04
RTRM     EQU   @08
RWORK    EQU   @00
RPARMREG EQU   @01
RDATAREG EQU   @10
RCODEREG EQU   @12
RSAVEREG EQU   @13
RENTREG  EQU   @15
RRETCODE EQU   @15
IEDQAVTD EQU   0
AVTSAVEX EQU   IEDQAVTD+288
@NM00003 EQU   IEDQAVTD+388
AVTCKFLG EQU   @NM00003
AVTBASE  EQU   IEDQAVTD+412
AVTPKF   EQU   AVTBASE
AVTRNMPT EQU   IEDQAVTD+424
AVTHG02  EQU   IEDQAVTD+528
AVTDISP  EQU   IEDQAVTD+552
AVTHD    EQU   IEDQAVTD+556
AVTSCOPT EQU   AVTHD
AVTSAVTP EQU   IEDQAVTD+612
AVTSAVTF EQU   AVTSAVTP
AVTCKPEL EQU   IEDQAVTD+652
AVTCKRMV EQU   AVTCKPEL
AVTCKELF EQU   IEDQAVTD+680
AVTCKBYT EQU   IEDQAVTD+691
AVTHG01  EQU   IEDQAVTD+692
AVTCKLNK EQU   IEDQAVTD+696
AVTCRELE EQU   IEDQAVTD+708
AVTCCELE EQU   AVTCRELE
AVTCLRHI EQU   IEDQAVTD+716
AVTADBUF EQU   IEDQAVTD+720
AVTSYSER EQU   IEDQAVTD+728
AVTCKPQB EQU   IEDQAVTD+804
AVTCKPTB EQU   AVTCKPQB
AVTCKPEC EQU   AVTCKPQB+4
AVTCKPCC EQU   AVTCKPEC
AVTOPCQB EQU   IEDQAVTD+816
AVTOPCOB EQU   AVTOPCQB
AVTOPCEC EQU   AVTOPCQB+4
AVTOPCCC EQU   AVTOPCEC
AVTOLTQB EQU   IEDQAVTD+828
AVTCWFL1 EQU   IEDQAVTD+924
AVTCWFL2 EQU   IEDQAVTD+925
AVTSUBT  EQU   IEDQAVTD+948
AVTIOTR  EQU   IEDQAVTD+949
AVTBIT1  EQU   IEDQAVTD+1050
AVTBIT2  EQU   IEDQAVTD+1051
AVTBIT3  EQU   IEDQAVTD+1052
AVTBIT4  EQU   IEDQAVTD+1136
@NM00083 EQU   IEDQAVTD+1232
IEDQAPTR EQU   0
IEDNSVTD EQU   0
SAVTDIAG EQU   IEDNSVTD
SAVTDIAF EQU   SAVTDIAG
SAVTLUSQ EQU   IEDNSVTD+88
SAVTTCPU EQU   IEDNSVTD+238
SAVTTNTX EQU   IEDNSVTD+252
SAVTZELM EQU   IEDNSVTD+270
SAVTRDRV EQU   IEDNSVTD+284
SAVTCKQB EQU   IEDNSVTD+300
SAVTCKTB EQU   SAVTCKQB
SAVTCKEC EQU   SAVTCKQB+4
SAVTCKCC EQU   SAVTCKEC
IEDQOPCE EQU   0
OCELEM   EQU   IEDQOPCE+4
OCUNIT   EQU   IEDQOPCE+8
OCRUDEST EQU   OCUNIT
OCCKPKEY EQU   OCRUDEST
OCSCAN   EQU   OCCKPKEY
OCOPTCDE EQU   IEDQOPCE+12
OCSWITCH EQU   IEDQOPCE+13
OCFLAG   EQU   IEDQOPCE+14
OCRESP   EQU   OCFLAG
@NM00106 EQU   IEDQOPCE+16
OCDEST   EQU   @NM00106
OCREQVAL EQU   OCDEST+1
OCTRMTBL EQU   IEDQOPCE+20
OCLINENO EQU   IEDQOPCE+22
OCTIOT   EQU   OCLINENO
OCWTGB   EQU   OCTIOT
OCTRUNIT EQU   IEDQOPCE+24
OCRSID   EQU   OCTRUNIT
OCALSTAT EQU   OCRSID
OCPARM   EQU   IEDQOPCE+28
OCWTG    EQU   IEDQOPCE+30
OCBACKUP EQU   IEDQOPCE+32
OCMODNME EQU   IEDQOPCE+40
OCIPLWA  EQU   OCMODNME
OCCKDATA EQU   IEDQOPCE+48
OCRSTGTM EQU   OCCKDATA
IEDQOPCN EQU   0
OCLDNME  EQU   IEDQOPCN
OCLINTTE EQU   OCLDNME
OCREQFLG EQU   OCLINTTE+2
OCPREFLG EQU   OCLINTTE+3
IEDQOPCD EQU   0
OPCAVTPT EQU   IEDQOPCD+8
OPCCOPCE EQU   IEDQOPCD+12
OPCSAVE  EQU   IEDQOPCD+56
OPCWORK  EQU   IEDQOPCD+140
OPCAQCTL EQU   IEDQOPCD+180
OPCXCTL  EQU   IEDQOPCD+204
OPCLDNME EQU   IEDQOPCD+212
OPCMODID EQU   OPCLDNME+3
OPCHORT  EQU   IEDQOPCD+256
OPCGETBF EQU   IEDQOPCD+276
OPCSPEC  EQU   IEDQOPCD+300
IEDPRUQD EQU   0
PRUTTCIN EQU   IEDPRUQD
PRUDATCT EQU   IEDPRUQD+2
PRUTIC   EQU   IEDPRUQD+8
PRUDATA  EQU   IEDPRUQD+12
IEDPRUQP EQU   0
IEDPRUND EQU   0
PRURHTH  EQU   IEDPRUND
PRURH    EQU   PRURHTH
PRURHFG0 EQU   PRURH
PRURHSDI EQU   PRURHFG0
PRURHFG1 EQU   PRURH+1
PRURHFG2 EQU   PRURH+2
PRUTH    EQU   PRURHTH+3
PRUFIDN  EQU   PRUTH
IEDQTRM  EQU   0
TRMSTATE EQU   IEDQTRM
TRMLOG   EQU   TRMSTATE
TRMINSEQ EQU   IEDQTRM+4
TLISTCNT EQU   TRMINSEQ
TRMOUTSQ EQU   IEDQTRM+6
TLISTEN  EQU   TRMOUTSQ
TRMDSORG EQU   TLISTEN
TRMALTD  EQU   IEDQTRM+8
TRMDEVFL EQU   IEDQTRM+10
TRMSTAT  EQU   IEDQTRM+12
IEDQTPTR EQU   0
IEDNTRM  EQU   0
TRMBYTE4 EQU   IEDNTRM
TRMBYTE3 EQU   IEDNTRM+1
TRMBYTE2 EQU   IEDNTRM+2
TRMRSACT EQU   TRMBYTE2
TRMINPG  EQU   TRMBYTE2
TRMBYTE1 EQU   IEDNTRM+3
TRMSCPRQ EQU   TRMBYTE1
TRMBYTE0 EQU   IEDNTRM+6
TRMSIBPT EQU   IEDNTRM+7
ALLOCBUF EQU   0
COHORTLK EQU   0
IEDQTNT  EQU   0
IEDIAP04 EQU   0
OCCKPKY1 EQU   OCCKPKEY
OCCKPTYP EQU   OCCKPKY1
OCICACTN EQU   OCMODNME
OCICDADR EQU   OCICACTN
OCICSW   EQU   OCICDADR+3
OPCAQWD  EQU   OPCAQCTL
OPCAQWD1 EQU   OPCAQWD
OPCAQWD2 EQU   OPCAQWD+4
OPCAQWD3 EQU   OPCAQWD+8
TRMPRE1  EQU   TRMBYTE4
TRMPRE   EQU   TRMBYTE3
TRMNCP   EQU   TRMBYTE3
TRMPU    EQU   TRMBYTE3
TRMLU    EQU   TRMBYTE3
TRMLINK  EQU   TRMBYTE3
TRMLSTAT EQU   TRMLINK
ACTLDATA EQU   PRUDATA
ACTLNETS EQU   ACTLDATA
ACTLCONS EQU   ACTLDATA+1
ACTLCODE EQU   ACTLDATA+2
ACTLNETA EQU   ACTLDATA+3
SENSE    EQU   PRUDATA
SENSYS   EQU   SENSE
OCCIB    EQU   OCREQVAL
TRMOPT   EQU   IEDQTRM+20
         AGO   .@UNREFD                START UNREFERENCED COMPONENTS
SENUSER  EQU   SENSE+2
@NM00141 EQU   TRMLINK
TRMLINT  EQU   TRMLINK
TRMEPMOD EQU   TRMLINK
TRMLULOG EQU   TRMLU
TRMINERR EQU   TRMLU
TRMLUREQ EQU   TRMLU
TRMSESRQ EQU   TRMLU
TRMTDIFF EQU   TRMLU
TRMLUTM  EQU   TRMLU
TRMLUIT  EQU   TRMLU
TRMAUTO  EQU   TRMLU
TRMPCONT EQU   TRMPU
@NM00140 EQU   TRMPU
TRMNCONT EQU   TRMNCP
TRMQUCKN EQU   TRMNCP
TRMSLOWN EQU   TRMNCP
TRMSYGEN EQU   TRMNCP
TRMNCPCL EQU   TRMNCP
TRMIPLDM EQU   TRMNCP
TRMINOUT EQU   TRMPRE
TRMRDOUT EQU   TRMPRE
TRMNLOUT EQU   TRMPRE
TRMWROUT EQU   TRMPRE
TRMASNXI EQU   TRMPRE
TRMSTMM  EQU   TRMPRE
TRMCMODE EQU   TRMPRE
TRMSTPND EQU   TRMPRE
TRMLYNCH EQU   TRMPRE1
TRMSPOUT EQU   TRMPRE1
TRMERLCK EQU   TRMPRE1
TRMQNPL  EQU   TRMPRE1
TRMSPACT EQU   TRMPRE1
TRMOCNI  EQU   TRMPRE1
TRMSESSN EQU   TRMPRE1
TRMCONT  EQU   TRMPRE1
OPCAQLST EQU   OPCAQWD3+1
OPCAQRQ3 EQU   OPCAQWD3
OPCAQSEC EQU   OPCAQWD2+1
OPCAQRQ2 EQU   OPCAQWD2
OPCAQFST EQU   OPCAQWD1+1
OPCAQREQ EQU   OPCAQWD1
OCICINAC EQU   OCICSW
@NM00112 EQU   OCICSW
OCICATST EQU   OCICDADR+1
OCICTYPE EQU   OCICDADR
@NM00111 EQU   OCCKPKY1
OCCKPENV EQU   OCCKPKY1
OCCKPRST EQU   OCCKPTYP
OCCKPNCP EQU   OCCKPTYP
OCCKPINC EQU   OCCKPTYP
TRMSUBST EQU   IEDNTRM+12
TRMTYPE  EQU   IEDNTRM+11
TRMRLMCT EQU   IEDNTRM+10
TRMCOHTG EQU   TRMSIBPT+1
TRMGPCNT EQU   TRMSIBPT
TRMBUFRD EQU   TRMBYTE0
TRMSNA   EQU   TRMBYTE0
TRMGP    EQU   TRMBYTE0
TRMDIAL  EQU   TRMBYTE0
@NM00139 EQU   TRMBYTE0
TRMOUTPT EQU   TRMBYTE0
TRMINPUT EQU   TRMBYTE0
TRMUDEF  EQU   TRMBYTE0
TRMCOHRT EQU   IEDNTRM+4
TRMSTOTE EQU   TRMBYTE1
TRMCKPRN EQU   TRMBYTE1
TRMTSATN EQU   TRMBYTE1
TRMTRACE EQU   TRMBYTE1
TRMSWBCK EQU   TRMBYTE1
TRMAUTOC EQU   TRMBYTE1
TRMINPTP EQU   TRMBYTE1
TRMWTNEG EQU   TRMSCPRQ
TRMWRBRK EQU   TRMBYTE2
TRMNOSND EQU   TRMBYTE2
TRMPREP  EQU   TRMBYTE2
TRMGPACT EQU   TRMBYTE2
TRMANDL  EQU   TRMBYTE2
TRMCLOSN EQU   TRMINPG
TRMREMB  EQU   TRMBYTE2
TRMOPTBL EQU   IEDQTRM+18
TRMOPNO  EQU   IEDQTRM+17
TRMCHCIN EQU   IEDQTRM+16
TRMSENSE EQU   TRMSTAT+3
TRMTEMPR EQU   TRMSTAT+2
TRMSIO   EQU   TRMSTAT
@NM00138 EQU   TRMDEVFL+1
TRMTPIN  EQU   TRMDEVFL+1
TRMNCPI  EQU   TRMDEVFL+1
TRMRNTRM EQU   TRMDEVFL+1
@NM00137 EQU   TRMDEVFL+1
TRMLMD   EQU   TRMDEVFL+1
TRMCONC  EQU   TRMDEVFL+1
TRMTSOB  EQU   TRMDEVFL
TRMBFDY  EQU   TRMDEVFL
TRMTBLK  EQU   TRMDEVFL
TRMSBLK  EQU   TRMDEVFL
TRMBLKS  EQU   TRMDEVFL
TRMADDC  EQU   TRMDEVFL
TRMDDIG  EQU   TRMDEVFL
TRMBUFS  EQU   TRMDEVFL
TRMPRILK EQU   TRMALTD
TRMLGB   EQU   TRMDSORG
TRMUTERM EQU   TLISTCNT
TRMDESTQ EQU   IEDQTRM+1
TRMSCNYN EQU   TRMSTATE
TRMOPTFN EQU   TRMSTATE
TRMHELDN EQU   TRMSTATE
TRMACPTN EQU   TRMSTATE
TRMPREF  EQU   TRMSTATE
TRMPROC  EQU   TRMLOG
TRMLIST  EQU   TRMLOG
TRMLINE  EQU   TRMSTATE
@NM00136 EQU   IEDPRUND+4
PRUTHEFI EQU   PRUFIDN
PRUTHUSS EQU   PRUFIDN
PRUTHEIU EQU   PRUFIDN
PRUTHBIU EQU   PRUFIDN
PRUTHTYE EQU   PRUFIDN
@NM00135 EQU   PRURHFG2
PRURHCSI EQU   PRURHFG2
@NM00134 EQU   PRURHFG2
PRURHCDI EQU   PRURHFG2
PRURHEB  EQU   PRURHFG2
PRURHBB  EQU   PRURHFG2
PRURHPI  EQU   PRURHFG1
@NM00133 EQU   PRURHFG1
PRURHER  EQU   PRURHFG1
PRURHDR2 EQU   PRURHFG1
@NM00132 EQU   PRURHFG1
PRURHDR1 EQU   PRURHFG1
PRURHEC  EQU   PRURHFG0
PRURHBC  EQU   PRURHFG0
PRURHFI  EQU   PRURHFG0
@NM00131 EQU   PRURHFG0
PRURUCAT EQU   PRURHFG0
PRURHTYP EQU   PRURHFG0
PRUNUNIT EQU   PRUTIC+1
@NM00130 EQU   PRUTIC
@NM00129 EQU   IEDPRUQD+4
OPCBOTTM EQU   IEDQOPCD+1172
@NM00128 EQU   IEDQOPCD+1088
@NM00127 EQU   IEDQOPCD+936
@NM00126 EQU   IEDQOPCD+928
@NM00125 EQU   IEDQOPCD+368
OPCWAITV EQU   IEDQOPCD+364
OPCTOTCK EQU   IEDQOPCD+360
OPCAPXTL EQU   IEDQOPCD+356
OPCDECR  EQU   IEDQOPCD+352
OPCBUFWT EQU   IEDQOPCD+348
OPCWRKSP EQU   IEDQOPCD+320
OPCADGOT EQU   IEDQOPCD+318
OPCRQCNT EQU   IEDQOPCD+316
OPPOLSTP EQU   IEDQOPCD+312
OPCCKCIB EQU   IEDQOPCD+308
OPCEND   EQU   IEDQOPCD+307
OPCSTCBS EQU   IEDQOPCD+306
OPCHNEND EQU   IEDQOPCD+302
OPCOQSW  EQU   IEDQOPCD+301
@NM00124 EQU   OPCSPEC
@NM00123 EQU   OPCSPEC
@NM00122 EQU   OPCSPEC
@NM00121 EQU   OPCSPEC
OPCFRMCA EQU   OPCSPEC
OPCRSTRT EQU   OPCSPEC
OPCPART  EQU   OPCSPEC
OPCALTD  EQU   OPCSPEC
OPCBFEND EQU   IEDQOPCD+296
OPCBFIRS EQU   IEDQOPCD+292
OPCAVBUF EQU   IEDQOPCD+290
@NM00120 EQU   IEDQOPCD+289
OPCCLNTS EQU   IEDQOPCD+288
OPCHA8   EQU   IEDQOPCD+286
OPCBFREQ EQU   IEDQOPCD+284
OPCFREBF EQU   IEDQOPCD+280
OPCNEXT  EQU   IEDQOPCD+272
OPCFMDFC EQU   IEDQOPCD+268
OPCSCNC  EQU   IEDQOPCD+264
OPCHORTG EQU   IEDQOPCD+260
OPCCKPTL EQU   IEDQOPCD+252
OPCCKPTF EQU   IEDQOPCD+248
OPCWAITA EQU   IEDQOPCD+244
OPCWAITR EQU   IEDQOPCD+240
OPCWAITP EQU   IEDQOPCD+236
OPCWAITO EQU   IEDQOPCD+232
OPCWAITN EQU   IEDQOPCD+228
OPCWAITL EQU   IEDQOPCD+224
OPCWAITC EQU   IEDQOPCD+220
@NM00119 EQU   OPCLDNME+5
@NM00118 EQU   OPCLDNME
OPCWAIT  EQU   IEDQOPCD+192
OPCCKERB EQU   IEDQOPCD+164
OPCBFERB EQU   IEDQOPCD+148
OPCFLAG2 EQU   IEDQOPCD+147
OPCFLAG1 EQU   IEDQOPCD+146
OPCWRKSZ EQU   IEDQOPCD+144
OPCRSAVE EQU   IEDQOPCD+132
OPCQCBAD EQU   IEDQOPCD+128
OPCTRMWA EQU   IEDQOPCD+52
OPCPSTWT EQU   IEDQOPCD+48
OPCTNTEA EQU   IEDQOPCD+44
OPCPGCK  EQU   IEDQOPCD+40
OPCLCB   EQU   IEDQOPCD+36
@NM00117 EQU   IEDQOPCD+32
OPCIPLAD EQU   IEDQOPCD+28
OPCTOFLK EQU   IEDQOPCD+24
OPCOPTLK EQU   IEDQOPCD+20
OPCDCBLK EQU   IEDQOPCD+16
OPCDOUBL EQU   IEDQOPCD
@NM00116 EQU   OCLDNME+4
@NM00115 EQU   OCPREFLG
OCTOTEP  EQU   OCPREFLG
OCREPOST EQU   OCPREFLG
OCRSPSNT EQU   OCPREFLG
OCBFREQ  EQU   OCPREFLG
OCIDLE   EQU   OCREQFLG
OCFORCE  EQU   OCREQFLG
OCDCARD  EQU   OCREQFLG
OCPARTAL EQU   OCREQFLG
OCADNCP  EQU   OCREQFLG
@NM00114 EQU   OCREQFLG
@NM00113 EQU   OCREQFLG
OCFLUSHZ EQU   OCREQFLG
OCRESPCT EQU   OCLINTTE
OCCKPTWA EQU   OCCKDATA+4
@NM00110 EQU   OCRSTGTM+2
OCCKDAT2 EQU   OCRSTGTM+1
OCCKDAT1 EQU   OCRSTGTM
OCPTRSAV EQU   OCMODNME+4
OCPUADR  EQU   OCIPLWA+2
OCWTGSAV EQU   OCIPLWA
OCDVRDCT EQU   OCBACKUP+6
OCNCP    EQU   OCBACKUP+4
OCBUFGOT EQU   OCBACKUP+2
OCBUFNED EQU   OCBACKUP
OCRESNUM EQU   OCPARM
OCSEQ    EQU   OCTRUNIT+2
@NM00109 EQU   OCRSID+1
OCNONE   EQU   OCALSTAT
OCSOME   EQU   OCALSTAT
OCALLFLG EQU   OCALSTAT
OCACTREQ EQU   OCALSTAT
OCREDRVE EQU   OCALSTAT
OCSEQIND EQU   OCALSTAT
@NM00108 EQU   OCALSTAT
OCRENTRD EQU   OCALSTAT
@NM00107 EQU   @NM00106+2
OCCONID  EQU   OCDEST
OCRLN    EQU   IEDQOPCE+15
OCATTACH EQU   OCFLAG
OCSSCP   EQU   OCFLAG
OCOUTPUT EQU   OCFLAG
OCLINE   EQU   OCFLAG
OCMPP    EQU   OCFLAG
OCTOTE   EQU   OCFLAG
OCCONSOL EQU   OCFLAG
@NM00105 EQU   OCSWITCH
OCQUCKN  EQU   OCSWITCH
OCPRIFLG EQU   OCOPTCDE
@NM00104 EQU   OCRUDEST+1
@NM00103 EQU   OCSCAN
OCNOTUCB EQU   OCSCAN
OCNONAME EQU   OCSCAN
OCALLRLN EQU   OCSCAN
OCDDNAME EQU   OCSCAN
OCDDNRLN EQU   OCSCAN
OCADDR   EQU   OCSCAN
OCELMPTR EQU   OCELEM+1
OCELMPRI EQU   OCELEM
OCLINK   EQU   IEDQOPCE
SAVTBITN EQU   IEDNSVTD+312
@NM00102 EQU   SAVTCKQB+8
@NM00101 EQU   SAVTCKEC+1
@NM00100 EQU   SAVTCKCC
SAVTCKPO EQU   SAVTCKCC
SAVTCKWA EQU   SAVTCKCC
SAVTCKCH EQU   SAVTCKTB+1
SAVTCKVT EQU   SAVTCKTB
@NM00099 EQU   IEDNSVTD+297
SAVTRDFG EQU   SAVTRDRV+12
@NM00098 EQU   SAVTRDRV+5
SAVTRDPY EQU   SAVTRDRV+4
SAVTRDQB EQU   SAVTRDRV+1
SAVTRDKY EQU   SAVTRDRV
SAVTNID  EQU   IEDNSVTD+280
SAVTDVAS EQU   IEDNSVTD+276
SAVTPLSZ EQU   IEDNSVTD+274
@NM00097 EQU   IEDNSVTD+273
SAVTSUBL EQU   IEDNSVTD+272
@NM00096 EQU   SAVTZELM+1
SAVTSUBM EQU   SAVTZELM
SAVTMHDX EQU   IEDNSVTD+268
SAVTNAT1 EQU   IEDNSVTD+266
SAVTSH20 EQU   IEDNSVTD+264
SAVTLCBS EQU   IEDNSVTD+260
SAVTRNMP EQU   IEDNSVTD+256
SAVTNAX  EQU   IEDNSVTD+248
SAVTSUBV EQU   IEDNSVTD+247
SAVTSUBA EQU   IEDNSVTD+246
SAVTSIBC EQU   IEDNSVTD+244
SAVTBSM  EQU   IEDNSVTD+240
SAVTSCPT EQU   SAVTTCPU
SAVTRQTG EQU   IEDNSVTD+236
SAVTRQCH EQU   IEDNSVTD+232
SAVTMAND EQU   IEDNSVTD+228
SAVTSPLN EQU   IEDNSVTD+224
SAVTNADL EQU   IEDNSVTD+222
SAVTNATL EQU   IEDNSVTD+220
SAVTMHTB EQU   IEDNSVTD+216
SAVTSSMH EQU   IEDNSVTD+212
SAVTQRS  EQU   IEDNSVTD+208
SAVTRQIN EQU   IEDNSVTD+204
SAVTDFCO EQU   IEDNSVTD+200
SAVTSAO  EQU   IEDNSVTD+196
SAVTSARI EQU   IEDNSVTD+192
SAVTSAC  EQU   IEDNSVTD+188
SAVTSAI  EQU   IEDNSVTD+184
SAVTCSCI EQU   IEDNSVTD+180
SAVTSSRP EQU   IEDNSVTD+176
SAVTSSRQ EQU   IEDNSVTD+172
SAVTSCLU EQU   IEDNSVTD+168
SAVTXTRQ EQU   IEDNSVTD+164
SAVTMVBF EQU   IEDNSVTD+160
@NM00095 EQU   IEDNSVTD+148
SAVTIPCQ EQU   IEDNSVTD+144
@NM00094 EQU   IEDNSVTD+136
SAVTXFMI EQU   IEDNSVTD+132
@NM00093 EQU   IEDNSVTD+124
SAVTXFMO EQU   IEDNSVTD+120
@NM00092 EQU   IEDNSVTD+116
SAVTSSSR EQU   IEDNSVTD+112
SAVTSCPQ EQU   IEDNSVTD+108
SAVTSLCB EQU   IEDNSVTD+104
SAVTLUSR EQU   IEDNSVTD+100
@NM00091 EQU   SAVTLUSQ+8
SAVTLUSP EQU   SAVTLUSQ+4
SAVTLUSB EQU   SAVTLUSQ
@NM00090 EQU   IEDNSVTD+84
SAVTSAT  EQU   IEDNSVTD+80
SAVTNAT  EQU   IEDNSVTD+76
SAVTCLUP EQU   IEDNSVTD+72
SAVTPIUT EQU   IEDNSVTD+68
SAVTRNTA EQU   IEDNSVTD+64
SAVTDNIR EQU   IEDNSVTD+60
SAVTCNIR EQU   IEDNSVTD+56
SAVTFLDH EQU   IEDNSVTD+52
SAVTSRTN EQU   IEDNSVTD+48
SAVTSREQ EQU   IEDNSVTD+44
SAVTFAIL EQU   IEDNSVTD+42
SAVTSUSE EQU   IEDNSVTD+40
SAVTSIB  EQU   IEDNSVTD+36
SAVTPRTN EQU   IEDNSVTD+32
@NM00089 EQU   IEDNSVTD+28
SAVTWH20 EQU   IEDNSVTD+26
SAVTPWT  EQU   IEDNSVTD+24
SAVTPRTQ EQU   IEDNSVTD+20
SAVTPREQ EQU   IEDNSVTD+16
SAVTPH20 EQU   IEDNSVTD+14
SAVTPUSE EQU   IEDNSVTD+12
SAVTPLCB EQU   IEDNSVTD+8
SAVTPOOL EQU   IEDNSVTD+4
SAVTPRMT EQU   SAVTDIAF
SAVTVIRT EQU   SAVTDIAF
AVTCPBNO EQU   IEDQAVTD+1244
AVTHRESS EQU   IEDQAVTD+1243
@NM00088 EQU   IEDQAVTD+1242
@NM00087 EQU   IEDQAVTD+1241
@NM00086 EQU   IEDQAVTD+1240
@NM00085 EQU   IEDQAVTD+1237
@NM00084 EQU   IEDQAVTD+1236
AVTHRESE EQU   @NM00083
AVTRADDR EQU   IEDQAVTD+1228
AVTNADDR EQU   IEDQAVTD+1224
AVTHRESN EQU   IEDQAVTD+1220
AVTVOLRN EQU   IEDQAVTD+1216
AVTTOTNN EQU   IEDQAVTD+1212
AVTTRCYN EQU   IEDQAVTD+1208
AVTRCTRN EQU   IEDQAVTD+1204
AVTNOVON EQU   IEDQAVTD+1200
AVTADEBN EQU   IEDQAVTD+1196
AVTVOLRR EQU   IEDQAVTD+1192
AVTTOTNR EQU   IEDQAVTD+1188
AVTTRCYR EQU   IEDQAVTD+1184
AVTRCTRR EQU   IEDQAVTD+1180
AVTNOVOR EQU   IEDQAVTD+1176
AVTADEBR EQU   IEDQAVTD+1172
AVTLODPT EQU   IEDQAVTD+1168
AVTIOBN  EQU   IEDQAVTD+1164
AVTIOBR  EQU   IEDQAVTD+1160
AVTCPBPT EQU   IEDQAVTD+1156
AVTFCPB  EQU   IEDQAVTD+1152
@NM00082 EQU   IEDQAVTD+1148
AVTINCPQ EQU   IEDQAVTD+1144
@NM00081 EQU   IEDQAVTD+1140
@NM00080 EQU   IEDQAVTD+1137
@NM00079 EQU   AVTBIT4
@NM00078 EQU   AVTBIT4
@NM00077 EQU   AVTBIT4
@NM00076 EQU   AVTBIT4
@NM00075 EQU   AVTBIT4
@NM00074 EQU   AVTBIT4
@NM00073 EQU   AVTBIT4
AVTRUFTN EQU   AVTBIT4
@NM00072 EQU   IEDQAVTD+1132
AVTNOBFQ EQU   IEDQAVTD+1128
@NM00071 EQU   IEDQAVTD+1124
AVTDKENQ EQU   IEDQAVTD+1120
@NM00070 EQU   IEDQAVTD+1116
AVTDKAPQ EQU   IEDQAVTD+1112
AVTCOPY  EQU   IEDQAVTD+1108
AVTIA    EQU   IEDQAVTD+1104
AVTFL    EQU   IEDQAVTD+1100
@NM00069 EQU   IEDQAVTD+1096
AVTNCPBQ EQU   IEDQAVTD+1092
AVTTOTNC EQU   IEDQAVTD+1088
AVTCMAX  EQU   IEDQAVTD+1084
AVTCMIN  EQU   IEDQAVTD+1080
AVTHM02  EQU   IEDQAVTD+1076
AVTOPCIN EQU   IEDQAVTD+1074
AVTDCTLN EQU   IEDQAVTD+1072
AVTOPMSK EQU   IEDQAVTD+1068
AVTDDFT  EQU   IEDQAVTD+1064
AVTSTEAL EQU   IEDQAVTD+1060
AVTOPTN  EQU   IEDQAVTD+1056
AVTDSKCT EQU   IEDQAVTD+1054
AVTCKRST EQU   IEDQAVTD+1053
AVTSTAN  EQU   AVTBIT3
AVTSTACN EQU   AVTBIT3
AVTSTAIN EQU   AVTBIT3
AVTSTAYN EQU   AVTBIT3
AVTOLTBN EQU   AVTBIT3
AVTTSAB  EQU   AVTBIT3
AVTRFULN EQU   AVTBIT3
AVTRECVN EQU   AVTBIT3
@NM00068 EQU   AVTBIT2
@NM00067 EQU   AVTBIT2
AVTOPEIN EQU   AVTBIT2
AVTSTRTN EQU   AVTBIT2
AVTTOPOL EQU   AVTBIT2
AVTCOPYN EQU   AVTBIT2
AVTREUSN EQU   AVTBIT2
AVTEXTSC EQU   AVTBIT2
AVTDISKN EQU   AVTBIT1
AVTQUCKN EQU   AVTBIT1
AVTCLOSN EQU   AVTBIT1
AVTREADN EQU   AVTBIT1
AVTDLAYN EQU   AVTBIT1
AVTAQTAN EQU   AVTBIT1
AVTTSON  EQU   AVTBIT1
AVTAPLKN EQU   AVTBIT1
AVTDUMBR EQU   IEDQAVTD+1048
AVTDLQX  EQU   IEDQAVTD+1046
AVTINTLV EQU   IEDQAVTD+1044
AVTSMCNT EQU   IEDQAVTD+1042
AVTAVFCT EQU   IEDQAVTD+1040
AVTOPCON EQU   IEDQAVTD+1038
AVTOPCNT EQU   IEDQAVTD+1036
AVTLNCNT EQU   IEDQAVTD+1034
AVTKEYLE EQU   IEDQAVTD+1032
AVTHA16  EQU   IEDQAVTD+1030
AVTHA7   EQU   IEDQAVTD+1028
AVTHA4   EQU   IEDQAVTD+1026
AVTHA3   EQU   IEDQAVTD+1024
AVTHA2   EQU   IEDQAVTD+1022
AVTGETMS EQU   IEDQAVTD+1021
@NM00066 EQU   IEDQAVTD+1020
AVTGETMD EQU   IEDQAVTD+1016
AVTGETMN EQU   IEDQAVTD+1012
AVTCWTOT EQU   IEDQAVTD+1008
AVTCWINT EQU   IEDQAVTD+956
AVTDTRAP EQU   IEDQAVTD+952
@NM00065 EQU   IEDQAVTD+950
@NM00064 EQU   AVTIOTR
AVTIOTRH EQU   AVTIOTR
AVTIOTRE EQU   AVTIOTR
@NM00063 EQU   AVTSUBT
AVTSUBPT EQU   AVTSUBT
AVTSUBON EQU   AVTSUBT
AVTAFE30 EQU   IEDQAVTD+944
AVTAFE20 EQU   IEDQAVTD+940
AVTAFE10 EQU   IEDQAVTD+936
AVTCWEC2 EQU   IEDQAVTD+932
AVTCWPM2 EQU   IEDQAVTD+928
AVTCWTS2 EQU   IEDQAVTD+927
AVTCWTS1 EQU   IEDQAVTD+926
AVTCWCLD EQU   AVTCWFL2
AVTCWRAP EQU   AVTCWFL2
@NM00062 EQU   AVTCWFL2
@NM00061 EQU   AVTCWFL2
@NM00060 EQU   AVTCWFL2
@NM00059 EQU   AVTCWFL2
@NM00058 EQU   AVTCWFL2
AVTCWACT EQU   AVTCWFL2
@NM00057 EQU   AVTCWFL1
@NM00056 EQU   AVTCWFL1
@NM00055 EQU   AVTCWFL1
@NM00054 EQU   AVTCWFL1
@NM00053 EQU   AVTCWFL1
@NM00052 EQU   AVTCWFL1
@NM00051 EQU   AVTCWFL1
AVTCOMWN EQU   AVTCWFL1
AVTCWEC1 EQU   IEDQAVTD+920
AVTCWPM1 EQU   IEDQAVTD+916
AVTCAREA EQU   IEDQAVTD+912
AVTFZERO EQU   IEDQAVTD+908
AVTCADDR EQU   IEDQAVTD+904
AVTCOREC EQU   IEDQAVTD+900
@NM00050 EQU   IEDQAVTD+892
AVTCPBCB EQU   IEDQAVTD+888
@NM00049 EQU   IEDQAVTD+880
AVTDSIOB EQU   IEDQAVTD+876
@NM00048 EQU   IEDQAVTD+868
AVTCPRMB EQU   IEDQAVTD+864
@NM00047 EQU   IEDQAVTD+856
AVTCLOSB EQU   IEDQAVTD+852
@NM00046 EQU   IEDQAVTD+844
AVTACTIB EQU   IEDQAVTD+840
@NM00045 EQU   IEDQAVTD+836
AVTOLTEB EQU   IEDQAVTD+832
AVTOLTCH EQU   AVTOLTQB+1
AVTOLTVT EQU   AVTOLTQB
@NM00044 EQU   AVTOPCQB+8
@NM00043 EQU   AVTOPCEC+1
@NM00042 EQU   AVTOPCCC
AVTOPCPO EQU   AVTOPCCC
AVTOPCWA EQU   AVTOPCCC
AVTOPCCH EQU   AVTOPCOB+1
AVTOPCVT EQU   AVTOPCOB
@NM00041 EQU   AVTCKPQB+9
AVTCKPTS EQU   AVTCKPQB+8
@NM00040 EQU   AVTCKPEC+1
@NM00039 EQU   AVTCKPCC
AVTCKPPO EQU   AVTCKPCC
AVTCKPWA EQU   AVTCKPCC
AVTCKPCH EQU   AVTCKPTB+1
AVTCKPVT EQU   AVTCKPTB
@NM00038 EQU   IEDQAVTD+796
AVTBFRTB EQU   IEDQAVTD+792
@NM00037 EQU   IEDQAVTD+784
AVTBFREB EQU   IEDQAVTD+780
AVTTIMQ  EQU   IEDQAVTD+776
@NM00036 EQU   IEDQAVTD+772
AVTIMQPS EQU   IEDQAVTD+768
AVTINOUT EQU   IEDQAVTD+766
AVTREFTM EQU   IEDQAVTD+764
@NM00035 EQU   IEDQAVTD+752
AVTDELYB EQU   IEDQAVTD+748
AVTOCQPT EQU   IEDQAVTD+744
AVTTSOPT EQU   IEDQAVTD+740
AVTSUPPT EQU   IEDQAVTD+736
AVTCBQCB EQU   IEDQAVTD+732
AVTMSGS  EQU   IEDQAVTD+729
@NM00034 EQU   AVTSYSER
@NM00033 EQU   AVTSYSER
@NM00032 EQU   AVTSYSER
@NM00031 EQU   AVTSYSER
@NM00030 EQU   AVTSYSER
@NM00029 EQU   AVTSYSER
AVTCMAXN EQU   AVTSYSER
AVTCMINN EQU   AVTSYSER
AVT2260L EQU   IEDQAVTD+724
AVTABEPL EQU   AVTADBUF
AVTHFF   EQU   AVTCLRHI+2
@NM00028 EQU   AVTCLRHI
AVTCCLNK EQU   AVTCRELE+5
AVTCCPRI EQU   AVTCRELE+4
AVTCCQCB EQU   AVTCCELE+1
AVTCCKEY EQU   AVTCCELE
AVTDELAD EQU   IEDQAVTD+704
AVTDELEM EQU   IEDQAVTD+700
AVTBSX   EQU   AVTCKLNK
AVTOPETR EQU   AVTHG01
@NM00027 EQU   AVTCKBYT
AVTCKONQ EQU   AVTCKBYT
@NM00026 EQU   AVTCKBYT
@NM00025 EQU   AVTCKBYT
@NM00024 EQU   AVTCKBYT
@NM00023 EQU   AVTCKBYT
@NM00022 EQU   AVTCKBYT
@NM00021 EQU   AVTCKBYT
AVTOPERT EQU   IEDQAVTD+690
AVTOPXCL EQU   IEDQAVTD+688
AVTOPERL EQU   IEDQAVTD+687
@NM00020 EQU   IEDQAVTD+686
AVTCKTIM EQU   IEDQAVTD+684
AVTCKELV EQU   IEDQAVTD+682
AVTCPRCD EQU   IEDQAVTD+681
AVTWARMN EQU   AVTCKELF
AVTCRTLN EQU   AVTCKELF
AVTCPIPN EQU   AVTCKELF
AVTCCLCN EQU   AVTCKELF
AVTCINCN EQU   AVTCKELF
@NM00019 EQU   AVTCKELF
AVTCMCPN EQU   AVTCKELF
AVTCRDYN EQU   AVTCKELF
AVTCKQAD EQU   IEDQAVTD+677
AVTSCBSZ EQU   IEDQAVTD+676
@NM00018 EQU   IEDQAVTD+672
AVTCKELE EQU   IEDQAVTD+668
@NM00017 EQU   AVTCKPEL+8
AVTCKRLK EQU   AVTCKPEL+5
AVTCKRPR EQU   AVTCKPEL+4
AVTCKRMQ EQU   AVTCKRMV+1
AVTCKRKY EQU   AVTCKRMV
AVTHK    EQU   IEDQAVTD+648
AVTHI    EQU   IEDQAVTD+644
AVTIOT   EQU   IEDQAVTD+640
AVTNX    EQU   IEDQAVTD+636
AVTTONE  EQU   IEDQAVTD+632
AVTA3TL  EQU   IEDQAVTD+628
AVTDMECB EQU   IEDQAVTD+624
AVTABEND EQU   IEDQAVTD+618
AVTPLCBN EQU   IEDQAVTD+616
@NM00016 EQU   AVTSAVTP+1
@NM00015 EQU   AVTSAVTF
AVTSNA   EQU   AVTSAVTF
AVTONSNA EQU   AVTSAVTF
AVTVTMCP EQU   AVTSAVTF
@NM00014 EQU   IEDQAVTD+608
AVTCMBSS EQU   IEDQAVTD+604
AVTRCV   EQU   IEDQAVTD+600
AVTSEND  EQU   IEDQAVTD+596
AVTCSCH  EQU   IEDQAVTD+592
AVTQ1    EQU   IEDQAVTD+588
AVTE7    EQU   IEDQAVTD+584
AVTHB    EQU   IEDQAVTD+580
AVTR1    EQU   IEDQAVTD+576
AVTBZ    EQU   IEDQAVTD+572
AVTEZ    EQU   IEDQAVTD+568
AVTEC    EQU   IEDQAVTD+564
AVTEW    EQU   IEDQAVTD+560
AVTNDIAL EQU   AVTSCOPT
AVTN2741 EQU   AVTSCOPT
AVTCONCO EQU   AVTSCOPT
AVTCONC  EQU   AVTSCOPT
AVTCMBUF EQU   AVTSCOPT
AVTAPDMP EQU   AVTSCOPT
@NM00013 EQU   AVTSCOPT
AVTHA    EQU   AVTDISP
AVTEA    EQU   IEDQAVTD+548
AVTAX    EQU   IEDQAVTD+544
AVTA3    EQU   IEDQAVTD+540
AVTGD    EQU   IEDQAVTD+536
AVTAL    EQU   IEDQAVTD+532
AVTOLTST EQU   AVTHG02
AVTE8    EQU   IEDQAVTD+524
AVTUI    EQU   IEDQAVTD+520
AVTCOMPT EQU   IEDQAVTD+516
AVTCRSRF EQU   IEDQAVTD+512
@NM00012 EQU   IEDQAVTD+508
AVTKA02  EQU   IEDQAVTD+504
AVTOPTPT EQU   IEDQAVTD+500
AVTPCBPT EQU   IEDQAVTD+496
AVTOSECB EQU   IEDQAVTD+492
AVTOPECA EQU   IEDQAVTD+488
AVTOLECA EQU   IEDQAVTD+484
AVTCKECA EQU   IEDQAVTD+480
AVTCWECA EQU   IEDQAVTD+476
AVTCWTCB EQU   IEDQAVTD+472
AVTOLTCB EQU   IEDQAVTD+468
AVTOCTCB EQU   IEDQAVTD+464
AVTCKTCB EQU   IEDQAVTD+460
AVTAS    EQU   IEDQAVTD+456
AVTNOLBF EQU   IEDQAVTD+454
AVTNCKPR EQU   IEDQAVTD+453
AVTCIB   EQU   IEDQAVTD+452
AVTSPLPT EQU   IEDQAVTD+448
AVTMVBFR EQU   IEDQAVTD+444
AVTSBTA  EQU   IEDQAVTD+440
AVTRARTN EQU   IEDQAVTD+436
AVTBSCAN EQU   IEDQAVTD+432
AVTRDYA  EQU   IEDQAVTD+428
AVTDISTR EQU   IEDQAVTD+420
AVTPARM3 EQU   IEDQAVTD+416
@NM00011 EQU   AVTPKF
@NM00010 EQU   AVTPKF
@NM00009 EQU   AVTPKF
AVTFTCHF EQU   AVTPKF
@NM00008 EQU   AVTPKF
@NM00007 EQU   AVTPKF
@NM00006 EQU   AVTPKF
@NM00005 EQU   AVTPKF
AVTPARM  EQU   IEDQAVTD+408
AVTEXS2A EQU   IEDQAVTD+402
AVTEXA2S EQU   IEDQAVTD+396
AVTOCGET EQU   IEDQAVTD+392
AVTCKAVT EQU   @NM00003+1
@NM00004 EQU   AVTCKFLG
AVTCKHLT EQU   AVTCKFLG
AVTCKREQ EQU   AVTCKFLG
AVTCKENV EQU   AVTCKFLG
AVTCKNAC EQU   AVTCKFLG
AVTCKTAC EQU   AVTCKFLG
@NM00002 EQU   IEDQAVTD+384
AVTREADD EQU   IEDQAVTD+380
AVTREADY EQU   IEDQAVTD+376
AVTRACE  EQU   IEDQAVTD+372
AVTTCB   EQU   IEDQAVTD+368
AVTPASWD EQU   IEDQAVTD+360
AVTCTLCH EQU   IEDQAVTD+352
AVTDOUBL EQU   IEDQAVTD+344
AVTDOUBX EQU   IEDQAVTD+336
AVTDPARM EQU   IEDQAVTD+332
AVTCSTCS EQU   IEDQAVTD+328
AVTDLQ   EQU   AVTSAVEX+32
@NM00001 EQU   AVTSAVEX
AVTSAVE4 EQU   IEDQAVTD+216
AVTSAVE3 EQU   IEDQAVTD+144
AVTSAVE2 EQU   IEDQAVTD+72
AVTSAVE1 EQU   IEDQAVTD
.@UNREFD ANOP                          END UNREFERENCED COMPONENTS
@ENDDATA EQU   *
         END   IGCA710D,(C'PLS2339',0701,76363)
