         TITLE 'IGCAE10D, SET TIME AND DATE                            *
                        '
IGCAE10D CSECT ,                                                   0001
@PROLOG  DS    0H                                                  0002
*                                                                  0297
         USING  *,RBASE
         LR     RBASE,RF                 /* SET UP ADDRESSIBILITY    */
IGCAE10D IEDHJN START,HJN
*/*                                                                  */
*                                                                  0298
*                                   /* INITIALIZATION                */
*   ROPCAVT=RPARM;                  /* OP CONTROL AVT ADDRESS        */
         LR    ROPCAVT,RPARM                                       0298
*   RELEMENT=OPCCOPCE;              /* CURRENT ELEMENT ADDRESS       */
         L     RELEMENT,OPCCOPCE(,ROPCAVT)                         0299
*   RAVT=OPCAVTPT;                  /* TCAM AVT ADDRESS              */
         L     RAVT,OPCAVTPT(,ROPCAVT)                             0300
*   RWORK=OPCWORK;                  /* OP CONTROL WORK AREA          */
         L     RWORK,OPCWORK(,ROPCAVT)                             0301
*   RSAVE=ADDR(OPCSAVE);            /* OP CONTROL SAVE AREA          */
         LA    RSAVE,OPCSAVE(,ROPCAVT)                             0302
*/*                                                                  */
*                                                                  0303
*   IF OCRESP=OFF THEN              /* REQUEST FOR SET TIME AND DATE?
*                                      ...PROCESS                    */
         TM    OCRESP(ROPCE),B'00000001'                           0303
         BNZ   @RF00303                                            0303
*     CALL STDREQ;                                                 0304
         BAL   @14,STDREQ                                          0304
*   ELSE                                                           0305
*     CALL STDRSP;                  /* PROCESS RESPONSE              */
         B     @RC00303                                            0305
@RF00303 BAL   @14,STDRSP                                          0305
*/*                                                                  */
*                                                                  0306
*   RPARM=ROPCAVT;                  /* OP CONTROL AVT ADDRESS        */
@RC00303 LR    RPARM,ROPCAVT                                       0306
*   GEN REFS(ROPCAVT,OPCXCTL) EXIT;                                0307
         XCTL  SF=(E,OPCXCTL(ROPCAVT))
*DATECNVT:                                                         0308
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);                               0308
*                                                                  0308
@EL00001 DS    0H                                                  0308
@EF00001 DS    0H                                                  0308
@ER00001 BR    @14                                                 0308
DATECNVT DS    0H                                                  0309
*   /*****************************************************************/
*   /*                                                               */
*   /* THIS ROUTINE CONVERTS THE JULIAN DATE TO THE CALENDAR DATE.   */
*   /* THIS PROCESS IS ACCOMPLISHED BY USING A TABLE THAT CONTAINS A */
*   /* CHARACTER REPRESENTATION OF THE MONTH FOLLOWED BY THE NUMBER  */
*   /* OF DAYS THAT ARE IN THAT MONTH. THE COMPUTED CALENDAR DATE IS */
*   /* PLACED IN UNPACKED FORMAT IN A "PACKED RU"                    */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0309
*   WKTMPDW=WKTMPDW&&WKTMPDW;       /* CLEAR DOUBLE WORD             */
         XC    WKTMPDW(8,ROPCAVT),WKTMPDW(ROPCAVT)                 0309
*   RZERO=DTPACKYR;                 /* RZERO HAS PACKED YEAR         */
         SLR   RZERO,RZERO                                         0310
         IC    RZERO,DTPACKYR(,RWORK)                              0310
*   SLL(RZERO,FOUR);                /* SHIFT PACKED YEAR             */
         LA    @11,4                                               0311
         SLL   RZERO,0(@11)                                        0311
*   WKTMPYR=RZERO;                  /* SAVE PACKED YEAR              */
         STH   RZERO,WKTMPYR(,ROPCAVT)                             0312
*   WKTMPYR=WKTMPYR|MASK2;          /* ADD SIGN TO PACKED YEAR       */
         OC    WKTMPYR(2,ROPCAVT),MASK2                            0313
*   GEN REFS(ROPCAVT,WKTMPDW) SETS(RZERO);                         0314
          CVB    RZERO,WKTMPDW(ROPCAVT)     MAKE YEAR BINARY
*   WKBINYR=RZERO;                  /* SAVE BINARY YEAR              */
         STC   RZERO,WKBINYR(,RWORK)                               0315
*   WKTMPDD=DTPACKDD;               /* D WORD HAS PACKED DATE        */
         MVC   WKTMPDD(2,ROPCAVT),DTPACKDD(RWORK)                  0316
*   GEN REFS(ROPCAVT,WKTMPDW) SETS(RZERO);                         0317
          CVB    RZERO,WKTMPDW(ROPCAVT)     MAKE JULIAN DATE BINARY
*   WKBINDY=RZERO;                  /* SAVE BINARY DATE              */
         STH   RZERO,WKBINDY(,RWORK)                               0318
*/*                                                                  */
*                                                                  0319
*   IF WKBINYR//FOUR=0 THEN         /* LEAP YEAR                     */
         SLR   @06,@06                                             0319
         IC    @06,WKBINYR(,RWORK)                                 0319
         SRDA  @06,32                                              0319
         D     @06,@CF00459                                        0319
         LTR   @06,@06                                             0319
         BNZ   @RF00319                                            0319
*     DO;                                                          0320
*       WKTABDAY=TABLEDAY;          /* MOVE TABLE TO WORKAREA        */
         MVC   WKTABDAY(36,RWORK),TABLEDAY                         0321
*       WKTBLPTR=ADDR(WKTABDAY);    /* INITIALIZE TABLE PRT TO FIRST
*                                      ENTRY                         */
         LA    @11,WKTABDAY(,RWORK)                                0322
         ST    @11,WKTBLPTR(,RWORK)                                0322
*       WKFEBDAY=WKFEBDAY+1;        /* ADD A DAY TO FEBRUARY         */
         LA    @11,1                                               0323
         SLR   @10,@10                                             0323
         IC    @10,WKFEBDAY(,RWORK)                                0323
         ALR   @11,@10                                             0323
         STC   @11,WKFEBDAY(,RWORK)                                0323
*     END;                                                         0324
*                                                                  0324
*/*                                                                  */
*                                                                  0325
*   ELSE                                                           0325
*     WKTBLPTR=ADDR(TABLEDAY);      /* INITIALIZE TABLE PTR TO FIRST
*                                      ENTRY                         */
         B     @RC00319                                            0325
@RF00319 LA    @11,TABLEDAY                                        0325
         ST    @11,WKTBLPTR(,RWORK)                                0325
*   WKDAYCNT=TABDAYS;               /* GET NUMBER OF DAYS FOR FIRST
*                                      MONTH                         */
@RC00319 L     @11,WKTBLPTR(,RWORK)                                0326
         SLR   @10,@10                                             0326
         IC    @10,TABDAYS(,@11)                                   0326
         STH   @10,WKDAYCNT(,RWORK)                                0326
*   DO WHILE WKBINDY>WKDAYCNT;      /* JULIAN DATE > TOTAL NUMBER OF
*                                      DAYS                          */
         B     @DE00327                                            0327
@DL00327 DS    0H                                                  0328
*     WKTBLPTR=WKTBLPTR+LENGTH(TABENTRY);/* BUMP TO NEXT ENTRY       */
         LA    @11,3                                               0328
         AL    @11,WKTBLPTR(,RWORK)                                0328
         ST    @11,WKTBLPTR(,RWORK)                                0328
*     WKDAYCNT=WKDAYCNT+TABDAYS;    /* ADD NO OF DAYS TO TOTAL       */
         SLR   @10,@10                                             0329
         IC    @10,TABDAYS(,@11)                                   0329
         AH    @10,WKDAYCNT(,RWORK)                                0329
         STH   @10,WKDAYCNT(,RWORK)                                0329
*   END;                                                           0330
*                                                                  0330
@DE00327 LH    @11,WKBINDY(,RWORK)                                 0330
         N     @11,@CF01356                                        0330
         LH    @10,WKDAYCNT(,RWORK)                                0330
         CR    @11,@10                                             0330
         BH    @DL00327                                            0330
*/*                                                                  */
*                                                                  0331
*   WKDAYCNT=WKDAYCNT-TABDAYS;      /* SUBTRACT NO OF DAYS FOR THIS
*                                      MONTH                         */
         L     @09,WKTBLPTR(,RWORK)                                0331
         SLR   @08,@08                                             0331
         IC    @08,TABDAYS(,@09)                                   0331
         SLR   @10,@08                                             0331
         STH   @10,WKDAYCNT(,RWORK)                                0331
*   WKBINDY=WKBINDY-WKDAYCNT;       /* SUBTRACT TOTAL FROM JULIAN  0332
*                                      DATE                          */
         SLR   @11,@10                                             0332
         STH   @11,WKBINDY(,RWORK)                                 0332
*/*                                                                  */
*                                                                  0333
*   RZERO=WKBINDY;                  /* BINARY CALENDAR DATE          */
         LR    RZERO,@11                                           0333
*   GEN REFS(RZERO,ROPCAVT) SETS(WKTMPDW);                         0334
          CVD    RZERO,WKTMPDW(ROPCAVT)    CONVERT CALENDAR DATE
*   DTPACKDD=WKTMPDD;               /* SAVE DECIMAL NUMBER           */
         MVC   DTPACKDD(2,RWORK),WKTMPDD(ROPCAVT)                  0335
*/*                                                                  */
*                                                                  0336
*   DTPACKDD=DTPACKDD|MASK2;        /* PUT IN ZONE                   */
         OC    DTPACKDD(2,RWORK),MASK2                             0336
*   UNPK(DTUNPKDY,DTPACKDD);        /* UNPACK DATE                   */
         UNPK  DTUNPKDY(2,RWORK),DTPACKDD(2,RWORK)                 0337
*   XSCVCDAY=DTUNPKDY;              /* MOVE CALENDAR DATE INTO     0338
*                                      COMMAND                       */
         LA    @11,12                                              0338
         AL    @11,OCUNIT(,ROPCE)                                  0338
         MVC   XSCVCDAY(2,@11),DTUNPKDY(RWORK)                     0338
*   XSCVMON=TABMONTH;               /* MOVE MONTH INTO COMMAND       */
         L     @10,WKTBLPTR(,RWORK)                                0339
         MVC   XSCVMON(2,@11),TABMONTH(@10)                        0339
*/*                                                                  */
*                                                                  0340
*   END DATECNVT;                   /* RETURN TO CALLER              */
@EL00002 DS    0H                                                  0340
@EF00002 DS    0H                                                  0340
@ER00002 BR    @14                                                 0340
*STDREQ:                                                           0341
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);                               0341
*                                                                  0341
STDREQ   DS    0H                                                  0342
*   /*****************************************************************/
*   /*                                                               */
*   /* THIS ROUTINE PROCESSES THE OPCE THAT REQUESTS A SET TIME AND  */
*   /* DATE COMMAND. THE TIME MACRO IS USED TO DETERMINE THE TIME AND*/
*   /* DATE. A SET CONTROL VECTOR FOR SET TIME AND DATE IS BUILT AND */
*   /* PASSED TO IGC0210D.                                           */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0342
*   WKSAVE1=RE;                     /* SAVE REG 14                   */
         ST    RE,WKSAVE1(,RWORK)                                  0342
*   RPARM=1;                        /* SET NO OF UNITS TO 1          */
         LA    RPARM,1                                             0343
*   CALL ALLOCBUF;                  /* REQUEST A BUFFER              */
         L     @15,OPCGETBF(,ROPCAVT)                              0344
         BALR  @14,@15                                             0344
*   OCUNIT=RPARM;                   /* SAVE BUFFER ADDRESS           */
         ST    RPARM,OCUNIT(,ROPCE)                                0345
*   OCWTGB=OCWTG;                   /* SAVE "WHERE TO GO" FIELD      */
         MVC   OCWTGB(2,ROPCE),OCWTG(ROPCE)                        0346
*/*                                                                  */
*                                                                  0347
*                                   /* SET UP COMMAND CONSTANTS      */
*   PRURHTH=RHTH;                   /* SET UP THE RH AND TH          */
         L     @11,OCUNIT(,ROPCE)                                  0347
         LR    @10,@11                                             0347
         AL    @10,@CF01357                                        0347
         MVC   PRURHTH(4,@10),@CB01270                             0347
*   PRUTTCIN=OCTRMTBL;              /* SET UP THE DESTINATION        */
         LH    @10,OCTRMTBL(,ROPCE)                                0348
         N     @10,@CF01356                                        0348
         STH   @10,PRUTTCIN(,@11)                                  0348
*   PRUDATCT=XSCVTDLN;              /* SET UP DATA COUNT FIELD       */
         MVC   PRUDATCT(2,@11),@CH01222                            0349
*   XSCVCODE=CD1XSCV;               /* SET CONTROL VECTOR            */
         AL    @11,@CF00239                                        0350
         MVC   XSCVCODE(3,@11),@CB00718                            0350
*   XSCVKEY=CD1SETTD;               /* SET TIME AND DATE             */
         MVI   XSCVKEY(@11),X'01'                                  0351
*   XSCVDLM1=SLASH;                 /* DELIMITER                     */
         MVI   XSCVDLM1(@11),C'/'                                  0352
*   XSCVDLM2=SLASH;                 /* DELIMITER                     */
         MVI   XSCVDLM2(@11),C'/'                                  0353
*   XSCVDLM3=PERIOD;                /* DELIMITER                     */
         MVI   XSCVDLM3(@11),C'.'                                  0354
*   XSCVDLM4=PERIOD;                /* DELIMITER                     */
         MVI   XSCVDLM4(@11),C'.'                                  0355
*   XSCVDLM5=PERIOD;                /* DELIMITER                     */
         MVI   XSCVDLM5(@11),C'.'                                  0356
*/*                                                                  */
*                                                                  0357
*   RPARM=OCTRMTBL;                 /* REG1 HAS RESOURCE TNT         */
         LR    RPARM,@10                                           0357
*   CALL IEDIAP04;                  /* CONVERT TNT TO NETWORK ADDRESS*/
         L     @11,AVTSAVTP(,RAVT)                                 0358
         L     @15,SAVTTNTX(,@11)                                  0358
         BALR  @14,@15                                             0358
*   XSCVADDR=RF;                    /* MOVE NET ADDR TO PACKED RU    */
         L     @11,OCUNIT(,ROPCE)                                  0359
         STCM  RF,3,XSCVADDR+12(@11)                               0359
*/*                                                                  */
*                                                                  0360
*   GEN CODE REFS(RPARM) SETS(RZERO,RPARM) NOEXIT NOFLOWS NODEFS   0360
*       SEQFLOW;                                                   0360
*                                      /*                    @ZM47760*/
*    /*                                                        @ZM47760
     TIME DEC                          GET TIME IN DECIMAL     @ZM47760
*   SRL(RZERO,FOUR);                /* SHIFT FOR PROPER FORMAT       */
         LA    @11,4                                               0361
         SRL   RZERO,0(@11)                                        0361
*   TMPACKST=RZERO;                 /* SAVE TIME OF DAY              */
         STCM  RZERO,15,TMPACKST(RWORK)                            0362
*   DTPACKST=RPARM;                 /* SAVE YEAR AND DATE            */
         ST    RPARM,DTPACKST(,RWORK)                              0363
*/*                                                                  */
*                                                                  0364
*                                   /* PREPARE TO UNPACK DATA        */
*   TMPACKST=TMPACKST|MASK4;        /* MAKE LAST FOUR BITS='F'X      */
         OC    TMPACKST(4,RWORK),MASK4                             0364
*   UNPK(TMUNPKST,TMPACKST);        /* UNPACK TIME OF DAY            */
         UNPK  TMUNPKST(6,RWORK),TMPACKST(4,RWORK)                 0365
*   UNPK(DTUNPKST,DTPACKYD);        /* UNPACK JULIAN DATE            */
         UNPK  DTUNPKST(5,RWORK),DTPACKYD(3,RWORK)                 0366
*/*                                                                  */
*                                                                  0367
*                                   /* MOVE UNPACKED FIELDS          */
*   XSCVYEAR=DTUNPKYR;              /* MOVE YEAR INTO COMMAND        */
         LA    @11,12                                              0367
         AL    @11,OCUNIT(,ROPCE)                                  0367
         MVC   XSCVYEAR(2,@11),DTUNPKYR(RWORK)                     0367
*   XSCVJDAY=DTUNPKDD;              /* MOVE JULIAN DATE INTO CMD     */
         MVC   XSCVJDAY(3,@11),DTUNPKDD(RWORK)                     0368
*   XSCVHOUR=TMUNPKHR;              /* MOVE HOUR INTO COMMAND        */
         MVC   XSCVHOUR(2,@11),TMUNPKHR(RWORK)                     0369
*   XSCVMIN=TMUNPKMN;               /* MOVE MINS INTO COMMAND        */
         MVC   XSCVMIN(2,@11),TMUNPKMN(RWORK)                      0370
*   XSCVSEC=TMUNPKSC;               /* MOVE SECS INTO COMMAND        */
         MVC   XSCVSEC(2,@11),TMUNPKSC(RWORK)                      0371
*   CALL DATECNVT;                  /* CONVERT DATE                  */
         BAL   @14,DATECNVT                                        0372
*/*                                                                  */
*                                                                  0373
*   OPCMODID=MODID02;               /* SET UP TO XCTL TO IGCO210D    */
         MVC   OPCMODID(2,ROPCAVT),@CC01278                        0373
*   OCWTG=MODIDAE;                  /* SET UP FOR RETURN TO THIS   0374
*                                      MODULE                        */
         MVC   OCWTG(2,ROPCE),@CC01276                             0374
*/*                                                                  */
*                                                                  0375
*   RE=WKSAVE1;                     /* RESTORE REG 14                */
         L     RE,WKSAVE1(,RWORK)                                  0375
*   END STDREQ;                     /* RETURN TO CALLER              */
@EL00003 DS    0H                                                  0376
@EF00003 DS    0H                                                  0376
@ER00003 BR    @14                                                 0376
*STDRSP:                                                           0377
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);                               0377
*                                                                  0377
STDRSP   DS    0H                                                  0378
*   /*****************************************************************/
*   /*                                                               */
*   /* THIS ROUTINE PROCESSES THE RESPONSE TO SET TIME AND DATE. A   */
*   /* RETURN CODE IS PLACED IN THE OCPARM FIELD TO INDICATE THE TYPE*/
*   /* OF RESPONSE RECEIVED. THIS ROUTINE PREPARES THE NECESSARY     */
*   /* FIELDS TO XCTL BACK TO THE ORIGINAL REQUESTOR.                */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0378
*   IF PRURHSDI=OFF THEN            /* GOOD RESPONSE?                */
         L     @11,OCUNIT(,ROPCE)                                  0378
         AL    @11,@CF01357                                        0378
         TM    PRURHSDI(@11),B'00000100'                           0378
         BNZ   @RF00378                                            0378
*     OCPARM=OCRCGPOS;              /* SET GOOD RETURN CODE          */
         MVC   OCPARM(2,ROPCE),@CH00060                            0379
*   ELSE                                                           0380
*     OCPARM=OCRCBNEG;              /* SET BAD RETURN CODE SET UP FOR
*                                      XCTL TO OPERATOR SERVICES     */
         B     @RC00378                                            0380
@RF00378 MVC   OCPARM(2,ROPCE),@CH01131                            0380
*   OPCMODID=OCWTGB;                /* RETURN TO REQUESTOR           */
@RC00378 MVC   OPCMODID(2,ROPCAVT),OCWTGB(ROPCE)                   0381
*   END STDRSP;                     /* RETURN TO CALLER              */
@EL00004 DS    0H                                                  0382
@EF00004 DS    0H                                                  0382
@ER00004 BR    @14                                                 0382
*   END IGCAE10D                                                   0383
*                                                                  0383
*/* THE FOLLOWING INCLUDE STATEMENTS WERE FOUND IN THIS PROGRAM.     */
*/*%INCLUDE SYSLIB  (TAVTD   )                                       */
*/*%INCLUDE SYSLIB  (TCD1D   )                                       */
*/*%INCLUDE SYSLIB  (TOPCAVTD)                                       */
*/*%INCLUDE SYSLIB  (TOPCED  )                                       */
*/*%INCLUDE SYSLIB  (TPRUD   )                                       */
*/*%INCLUDE SYSLIB  (TXSCVD  )                                       */
*                                                                  0383
*       ;                                                          0383
@DATA    DS    0H
@CH00060 DC    H'1'
@CH01222 DC    H'26'
@CH01131 DC    H'-1'
         DS    0F
         DS    0F
@CF00239 DC    F'12'
@CF01357 DC    F'-8'
@CF01356 DC    XL4'0000FFFF'
@CF00459 DC    XL4'04'
         DS    0D
@CC01276 DC    C'AE'
@CC01278 DC    C'02'
@CB01270 DC    X'0B80001C'
@CB00718 DC    X'010211'
MASK     DS    CL4
         ORG   MASK
MASK4    DS    CL4
         ORG   MASK4
@NM00144 DC    X'0000'
MASK2    DC    X'000F'
         ORG   MASK+4
TABLEDAY DS    CL36
         ORG   TABLEDAY
@NM00147 DC    CL2'01'
@NM00148 DC    AL1(31)
@NM00149 DC    CL2'02'
@NM00150 DC    AL1(28)
@NM00151 DC    CL2'03'
@NM00152 DC    AL1(31)
@NM00153 DC    CL2'04'
@NM00154 DC    AL1(30)
@NM00155 DC    CL2'05'
@NM00156 DC    AL1(31)
@NM00157 DC    CL2'06'
@NM00158 DC    AL1(30)
@NM00159 DC    CL2'07'
@NM00160 DC    AL1(31)
@NM00161 DC    CL2'08'
@NM00162 DC    AL1(31)
@NM00163 DC    CL2'09'
@NM00164 DC    AL1(30)
@NM00165 DC    CL2'10'
@NM00166 DC    AL1(31)
@NM00167 DC    CL2'11'
@NM00168 DC    AL1(30)
@NM00169 DC    CL2'12'
@NM00170 DC    AL1(31)
         ORG   TABLEDAY+36
PATCH    DC    100X'00'
@00      EQU   00                      EQUATES FOR REGISTERS 0-15
@01      EQU   01
@02      EQU   02
@03      EQU   03
@04      EQU   04
@05      EQU   05
@06      EQU   06
@07      EQU   07
@08      EQU   08
@09      EQU   09
@10      EQU   10
@11      EQU   11
@12      EQU   12
@13      EQU   13
@14      EQU   14
@15      EQU   15
IEDQAPTR EQU   @04
ROPCAVT  EQU   @02
ROPCE    EQU   @03
RAVT     EQU   @04
RZERO    EQU   @00
RPARM    EQU   @01
RELEMENT EQU   @03
RWORK    EQU   @05
RBASE    EQU   @12
RSAVE    EQU   @13
RE       EQU   @14
RF       EQU   @15
IEDQAVTD EQU   0
AVTSAVEX EQU   IEDQAVTD+288
@NM00003 EQU   IEDQAVTD+388
AVTCKFLG EQU   @NM00003
AVTBASE  EQU   IEDQAVTD+412
AVTPKF   EQU   AVTBASE
AVTOSECB EQU   IEDQAVTD+492
AVTECB1  EQU   AVTOSECB
AVTHG02  EQU   IEDQAVTD+528
AVTDISP  EQU   IEDQAVTD+552
AVTHD    EQU   IEDQAVTD+556
AVTSCOPT EQU   AVTHD
AVTSAVTP EQU   IEDQAVTD+612
AVTSAVTF EQU   AVTSAVTP
AVTCKPEL EQU   IEDQAVTD+652
AVTCKRMV EQU   AVTCKPEL
AVTCKELF EQU   IEDQAVTD+680
AVTCKBYT EQU   IEDQAVTD+691
AVTHG01  EQU   IEDQAVTD+692
AVTCKLNK EQU   IEDQAVTD+696
AVTCRELE EQU   IEDQAVTD+708
AVTCCELE EQU   AVTCRELE
AVTCLRHI EQU   IEDQAVTD+716
AVTADBUF EQU   IEDQAVTD+720
AVTSYSER EQU   IEDQAVTD+728
AVTCKPQB EQU   IEDQAVTD+804
AVTCKPTB EQU   AVTCKPQB
AVTCKPEC EQU   AVTCKPQB+4
AVTCKPCC EQU   AVTCKPEC
AVTOPCQB EQU   IEDQAVTD+816
AVTOPCOB EQU   AVTOPCQB
AVTOPCEC EQU   AVTOPCQB+4
AVTOPCCC EQU   AVTOPCEC
AVTOLTQB EQU   IEDQAVTD+828
AVTCWFL1 EQU   IEDQAVTD+924
AVTCWFL2 EQU   IEDQAVTD+925
AVTSUBT  EQU   IEDQAVTD+948
AVTIOTR  EQU   IEDQAVTD+949
AVTBIT1  EQU   IEDQAVTD+1050
AVTBIT2  EQU   IEDQAVTD+1051
AVTBIT3  EQU   IEDQAVTD+1052
AVTBIT4  EQU   IEDQAVTD+1136
@NM00085 EQU   IEDQAVTD+1232
IEDNSVTD EQU   0
SAVTDIAG EQU   IEDNSVTD
SAVTDIAF EQU   SAVTDIAG
SAVTLUSQ EQU   IEDNSVTD+88
SAVTTCPU EQU   IEDNSVTD+238
SAVTTNTX EQU   IEDNSVTD+252
SAVTZELM EQU   IEDNSVTD+270
SAVTRDRV EQU   IEDNSVTD+284
SAVTCKQB EQU   IEDNSVTD+300
SAVTCKTB EQU   SAVTCKQB
SAVTCKEC EQU   SAVTCKQB+4
SAVTCKCC EQU   SAVTCKEC
IEDQOPCD EQU   0
OPCDOUBL EQU   IEDQOPCD
OPCAVTPT EQU   IEDQOPCD+8
OPCCOPCE EQU   IEDQOPCD+12
OPCSAVE  EQU   IEDQOPCD+56
OPCWORK  EQU   IEDQOPCD+140
OPCAQCTL EQU   IEDQOPCD+180
OPCXCTL  EQU   IEDQOPCD+204
OPCLDNME EQU   IEDQOPCD+212
OPCMODID EQU   OPCLDNME+3
OPCGETBF EQU   IEDQOPCD+276
OPCSPEC  EQU   IEDQOPCD+300
OPCPWCOB EQU   IEDQOPCD+368
OPCPWQCB EQU   OPCPWCOB
OPCPWECB EQU   OPCPWCOB+4
IEDQOPCE EQU   0
OCELEM   EQU   IEDQOPCE+4
OCUNIT   EQU   IEDQOPCE+8
OCRUDEST EQU   OCUNIT
OCCKPKEY EQU   OCRUDEST
OCSCAN   EQU   OCCKPKEY
OCOPTCDE EQU   IEDQOPCE+12
OCSWITCH EQU   IEDQOPCE+13
OCFLAG   EQU   IEDQOPCE+14
OCRESP   EQU   OCFLAG
@NM00122 EQU   IEDQOPCE+16
OCDEST   EQU   @NM00122
OCREQVAL EQU   OCDEST+1
OCTRMTBL EQU   IEDQOPCE+20
OCLINENO EQU   IEDQOPCE+22
OCTIOT   EQU   OCLINENO
OCWTGB   EQU   OCTIOT
OCTRUNIT EQU   IEDQOPCE+24
OCRSID   EQU   OCTRUNIT
OCALSTAT EQU   OCRSID
OCPARM   EQU   IEDQOPCE+28
OCWTG    EQU   IEDQOPCE+30
OCBACKUP EQU   IEDQOPCE+32
OCMODNME EQU   IEDQOPCE+40
OCIPLWA  EQU   OCMODNME
OCCKDATA EQU   IEDQOPCE+48
OCRSTGTM EQU   OCCKDATA
IEDQOPCN EQU   0
OCLDNME  EQU   IEDQOPCN
OCLINTTE EQU   OCLDNME
OCREQFLG EQU   OCLINTTE+2
OCPREFLG EQU   OCLINTTE+3
IEDPRUQD EQU   0
PRUTTCIN EQU   IEDPRUQD
PRUDATCT EQU   IEDPRUQD+2
PRUTIC   EQU   IEDPRUQD+8
PRUDATA  EQU   IEDPRUQD+12
IEDPRUQP EQU   0
IEDPRUND EQU   0
PRURHTH  EQU   IEDPRUND
PRURH    EQU   PRURHTH
PRURHFG0 EQU   PRURH
PRURHSDI EQU   PRURHFG0
PRURHFG1 EQU   PRURH+1
PRURHFG2 EQU   PRURH+2
PRUTH    EQU   PRURHTH+3
PRUFIDN  EQU   PRUTH
IEDXSCVD EQU   0
XSCVCMD  EQU   IEDXSCVD
XSCVCODE EQU   XSCVCMD
XSCVADDR EQU   XSCVCMD+3
XSCVKEY  EQU   XSCVCMD+5
XSCVDATA EQU   IEDXSCVD+6
XSCVPTR  EQU   0
ALLOCBUF EQU   0
IEDIAP04 EQU   0
WKAREA   EQU   0
WKSAVE1  EQU   WKAREA
WKDAYCNT EQU   WKAREA+4
WKTMPK   EQU   WKAREA+6
WKTMUNPK EQU   WKAREA+10
WKDTPK   EQU   WKAREA+16
WKDTUNPK EQU   WKAREA+20
WKBINYD  EQU   WKAREA+28
WKBINYR  EQU   WKBINYD+1
WKBINDY  EQU   WKBINYD+2
WKTABDAY EQU   WKAREA+32
WKFEBDAY EQU   WKTABDAY+5
WKTBLPTR EQU   WKAREA+68
TABENTRY EQU   0
TABMONTH EQU   TABENTRY
TABDAYS  EQU   TABENTRY+2
OPCAQWD  EQU   OPCAQCTL
OPCAQWD1 EQU   OPCAQWD
OPCAQWD2 EQU   OPCAQWD+4
OPCAQWD3 EQU   OPCAQWD+8
OCCKPKY1 EQU   OCCKPKEY
OCCKPTYP EQU   OCCKPKY1
OCICACTN EQU   OCMODNME
OCICDADR EQU   OCICACTN
OCICSW   EQU   OCICDADR+3
XSCVTMDT EQU   XSCVDATA
XSCVMON  EQU   XSCVTMDT
XSCVDLM1 EQU   XSCVTMDT+2
XSCVCDAY EQU   XSCVTMDT+3
XSCVDLM2 EQU   XSCVTMDT+5
XSCVYEAR EQU   XSCVTMDT+6
XSCVDLM3 EQU   XSCVTMDT+8
XSCVJDAY EQU   XSCVTMDT+9
XSCVHOUR EQU   XSCVTMDT+12
XSCVDLM4 EQU   XSCVTMDT+14
XSCVMIN  EQU   XSCVTMDT+15
XSCVDLM5 EQU   XSCVTMDT+17
XSCVSEC  EQU   XSCVTMDT+18
WKTMPDW  EQU   OPCDOUBL
WKTMPDD  EQU   WKTMPDW+6
WKTMPYR  EQU   WKTMPDD
TMPACKST EQU   WKTMPK
TMUNPKST EQU   WKTMUNPK
TMUNPKHR EQU   TMUNPKST
TMUNPKMN EQU   TMUNPKST+2
TMUNPKSC EQU   TMUNPKST+4
DTPACKST EQU   WKDTPK
DTPACKYD EQU   DTPACKST+1
DTPACKYR EQU   DTPACKYD
DTPACKDD EQU   DTPACKYD+1
DTUNPKST EQU   WKDTUNPK
DTUNPKYR EQU   DTUNPKST
DTUNPKDD EQU   DTUNPKST+2
DTUNPKDY EQU   DTUNPKDD+1
OCCIB    EQU   OCREQVAL
         AGO   .@UNREFD                START UNREFERENCED COMPONENTS
@NM00146 EQU   DTUNPKDD
@NM00145 EQU   DTPACKST
TMPACKTH EQU   TMPACKST+3
TMPACKSC EQU   TMPACKST+2
TMPACKMN EQU   TMPACKST+1
TMPACKHR EQU   TMPACKST
@NM00141 EQU   WKTMPDW
OCICINAC EQU   OCICSW
@NM00128 EQU   OCICSW
OCICATST EQU   OCICDADR+1
OCICTYPE EQU   OCICDADR
@NM00127 EQU   OCCKPKY1
OCCKPENV EQU   OCCKPKY1
OCCKPRST EQU   OCCKPTYP
OCCKPNCP EQU   OCCKPTYP
OCCKPINC EQU   OCCKPTYP
OPCAQLST EQU   OPCAQWD3+1
OPCAQRQ3 EQU   OPCAQWD3
OPCAQSEC EQU   OPCAQWD2+1
OPCAQRQ2 EQU   OPCAQWD2
OPCAQFST EQU   OPCAQWD1+1
OPCAQREQ EQU   OPCAQWD1
@NM00143 EQU   WKTABDAY
@NM00142 EQU   WKBINYD
XSCVREQ  EQU   XSCVCODE+2
XSCVCONF EQU   XSCVCODE+1
XSCVNETS EQU   XSCVCODE
@NM00140 EQU   IEDPRUND+4
PRUTHEFI EQU   PRUFIDN
PRUTHUSS EQU   PRUFIDN
PRUTHEIU EQU   PRUFIDN
PRUTHBIU EQU   PRUFIDN
PRUTHTYE EQU   PRUFIDN
@NM00139 EQU   PRURHFG2
PRURHCSI EQU   PRURHFG2
@NM00138 EQU   PRURHFG2
PRURHCDI EQU   PRURHFG2
PRURHEB  EQU   PRURHFG2
PRURHBB  EQU   PRURHFG2
PRURHPI  EQU   PRURHFG1
@NM00137 EQU   PRURHFG1
PRURHER  EQU   PRURHFG1
PRURHDR2 EQU   PRURHFG1
@NM00136 EQU   PRURHFG1
PRURHDR1 EQU   PRURHFG1
PRURHEC  EQU   PRURHFG0
PRURHBC  EQU   PRURHFG0
PRURHFI  EQU   PRURHFG0
@NM00135 EQU   PRURHFG0
PRURUCAT EQU   PRURHFG0
PRURHTYP EQU   PRURHFG0
PRUNUNIT EQU   PRUTIC+1
@NM00134 EQU   PRUTIC
@NM00133 EQU   IEDPRUQD+4
@NM00132 EQU   OCLDNME+4
@NM00131 EQU   OCPREFLG
OCTOTEP  EQU   OCPREFLG
OCREPOST EQU   OCPREFLG
OCRSPSNT EQU   OCPREFLG
OCBFREQ  EQU   OCPREFLG
OCIDLE   EQU   OCREQFLG
OCFORCE  EQU   OCREQFLG
OCDCARD  EQU   OCREQFLG
OCPARTAL EQU   OCREQFLG
OCADNCP  EQU   OCREQFLG
@NM00130 EQU   OCREQFLG
@NM00129 EQU   OCREQFLG
OCFLUSHZ EQU   OCREQFLG
OCRESPCT EQU   OCLINTTE
OCCKPTWA EQU   OCCKDATA+4
@NM00126 EQU   OCRSTGTM+2
OCCKDAT2 EQU   OCRSTGTM+1
OCCKDAT1 EQU   OCRSTGTM
OCPTRSAV EQU   OCMODNME+4
OCPUADR  EQU   OCIPLWA+2
OCWTGSAV EQU   OCIPLWA
OCDVRDCT EQU   OCBACKUP+6
OCNCP    EQU   OCBACKUP+4
OCBUFGOT EQU   OCBACKUP+2
OCBUFNED EQU   OCBACKUP
OCRESNUM EQU   OCPARM
OCSEQ    EQU   OCTRUNIT+2
@NM00125 EQU   OCRSID+1
OCNONE   EQU   OCALSTAT
OCSOME   EQU   OCALSTAT
OCALLFLG EQU   OCALSTAT
OCACTREQ EQU   OCALSTAT
OCREDRVE EQU   OCALSTAT
OCSEQIND EQU   OCALSTAT
@NM00124 EQU   OCALSTAT
OCRENTRD EQU   OCALSTAT
@NM00123 EQU   @NM00122+2
OCCONID  EQU   OCDEST
OCRLN    EQU   IEDQOPCE+15
OCATTACH EQU   OCFLAG
OCSSCP   EQU   OCFLAG
OCOUTPUT EQU   OCFLAG
OCLINE   EQU   OCFLAG
OCMPP    EQU   OCFLAG
OCTOTE   EQU   OCFLAG
OCCONSOL EQU   OCFLAG
@NM00121 EQU   OCSWITCH
OCQUCKN  EQU   OCSWITCH
OCPRIFLG EQU   OCOPTCDE
@NM00120 EQU   OCRUDEST+1
@NM00119 EQU   OCSCAN
OCNOTUCB EQU   OCSCAN
OCNONAME EQU   OCSCAN
OCALLRLN EQU   OCSCAN
OCDDNAME EQU   OCSCAN
OCDDNRLN EQU   OCSCAN
OCADDR   EQU   OCSCAN
OCELMPTR EQU   OCELEM+1
OCELMPRI EQU   OCELEM
OCLINK   EQU   IEDQOPCE
OPCBOTTM EQU   IEDQOPCD+1184
@NM00118 EQU   IEDQOPCD+1100
@NM00117 EQU   IEDQOPCD+948
@NM00116 EQU   IEDQOPCD+940
@NM00115 EQU   IEDQOPCD+380
@NM00114 EQU   OPCPWCOB+9
@NM00113 EQU   OPCPWCOB+8
@NM00112 EQU   OPCPWECB+1
OPCPWCCC EQU   OPCPWECB
OPCPWCHN EQU   OPCPWQCB+1
OPCPWVTO EQU   OPCPWQCB
OPCWAITV EQU   IEDQOPCD+364
OPCTOTCK EQU   IEDQOPCD+360
OPCAPXTL EQU   IEDQOPCD+356
OPCDECR  EQU   IEDQOPCD+352
OPCBUFWT EQU   IEDQOPCD+348
OPCWRKSP EQU   IEDQOPCD+320
OPCADGOT EQU   IEDQOPCD+318
OPCRQCNT EQU   IEDQOPCD+316
OPPOLSTP EQU   IEDQOPCD+312
OPCCKCIB EQU   IEDQOPCD+308
OPCEND   EQU   IEDQOPCD+307
OPCSTCBS EQU   IEDQOPCD+306
OPCHNEND EQU   IEDQOPCD+302
OPCOQSW  EQU   IEDQOPCD+301
@NM00111 EQU   OPCSPEC
@NM00110 EQU   OPCSPEC
@NM00109 EQU   OPCSPEC
@NM00108 EQU   OPCSPEC
OPCFRMCA EQU   OPCSPEC
OPCRSTRT EQU   OPCSPEC
OPCPART  EQU   OPCSPEC
OPCALTD  EQU   OPCSPEC
OPCBFEND EQU   IEDQOPCD+296
OPCBFIRS EQU   IEDQOPCD+292
OPCAVBUF EQU   IEDQOPCD+290
OPCIPLCT EQU   IEDQOPCD+289
OPCCLNTS EQU   IEDQOPCD+288
OPCHA8   EQU   IEDQOPCD+286
OPCBFREQ EQU   IEDQOPCD+284
OPCFREBF EQU   IEDQOPCD+280
OPCNEXT  EQU   IEDQOPCD+272
OPCFMDFC EQU   IEDQOPCD+268
OPCSCNC  EQU   IEDQOPCD+264
OPCHORTG EQU   IEDQOPCD+260
OPCHORT  EQU   IEDQOPCD+256
OPCCKPTL EQU   IEDQOPCD+252
OPCCKPTF EQU   IEDQOPCD+248
OPCWAITA EQU   IEDQOPCD+244
OPCWAITR EQU   IEDQOPCD+240
OPCWAITP EQU   IEDQOPCD+236
OPCWAITO EQU   IEDQOPCD+232
OPCWAITN EQU   IEDQOPCD+228
OPCWAITL EQU   IEDQOPCD+224
OPCWAITC EQU   IEDQOPCD+220
@NM00107 EQU   OPCLDNME+5
@NM00106 EQU   OPCLDNME
OPCWAIT  EQU   IEDQOPCD+192
OPCCKERB EQU   IEDQOPCD+164
OPCBFERB EQU   IEDQOPCD+148
OPCFLAG2 EQU   IEDQOPCD+147
OPCFLAG1 EQU   IEDQOPCD+146
OPCWRKSZ EQU   IEDQOPCD+144
OPCRSAVE EQU   IEDQOPCD+132
OPCQCBAD EQU   IEDQOPCD+128
OPCTRMWA EQU   IEDQOPCD+52
OPCPSTWT EQU   IEDQOPCD+48
OPCTNTEA EQU   IEDQOPCD+44
OPCPGCK  EQU   IEDQOPCD+40
OPCLCB   EQU   IEDQOPCD+36
@NM00105 EQU   IEDQOPCD+32
OPCIPLAD EQU   IEDQOPCD+28
OPCTOFLK EQU   IEDQOPCD+24
OPCOPTLK EQU   IEDQOPCD+20
OPCDCBLK EQU   IEDQOPCD+16
SAVTBITN EQU   IEDNSVTD+312
@NM00104 EQU   SAVTCKQB+8
@NM00103 EQU   SAVTCKEC+1
@NM00102 EQU   SAVTCKCC
SAVTCKPO EQU   SAVTCKCC
SAVTCKWA EQU   SAVTCKCC
SAVTCKCH EQU   SAVTCKTB+1
SAVTCKVT EQU   SAVTCKTB
@NM00101 EQU   IEDNSVTD+297
SAVTRDFG EQU   SAVTRDRV+12
@NM00100 EQU   SAVTRDRV+5
SAVTRDPY EQU   SAVTRDRV+4
SAVTRDQB EQU   SAVTRDRV+1
SAVTRDKY EQU   SAVTRDRV
SAVTNID  EQU   IEDNSVTD+280
SAVTDVAS EQU   IEDNSVTD+276
SAVTPLSZ EQU   IEDNSVTD+274
@NM00099 EQU   IEDNSVTD+273
SAVTSUBL EQU   IEDNSVTD+272
@NM00098 EQU   SAVTZELM+1
SAVTSUBM EQU   SAVTZELM
SAVTMHDX EQU   IEDNSVTD+268
SAVTNAT1 EQU   IEDNSVTD+266
SAVTSH20 EQU   IEDNSVTD+264
SAVTLCBS EQU   IEDNSVTD+260
SAVTRNMP EQU   IEDNSVTD+256
SAVTNAX  EQU   IEDNSVTD+248
SAVTSUBV EQU   IEDNSVTD+247
SAVTSUBA EQU   IEDNSVTD+246
SAVTSIBC EQU   IEDNSVTD+244
SAVTBSM  EQU   IEDNSVTD+240
SAVTSCPT EQU   SAVTTCPU
SAVTRQTG EQU   IEDNSVTD+236
SAVTRQCH EQU   IEDNSVTD+232
SAVTMAND EQU   IEDNSVTD+228
SAVTSPLN EQU   IEDNSVTD+224
SAVTNADL EQU   IEDNSVTD+222
SAVTNATL EQU   IEDNSVTD+220
SAVTMHTB EQU   IEDNSVTD+216
SAVTSSMH EQU   IEDNSVTD+212
SAVTQRS  EQU   IEDNSVTD+208
SAVTRQIN EQU   IEDNSVTD+204
SAVTDFCO EQU   IEDNSVTD+200
SAVTSAO  EQU   IEDNSVTD+196
SAVTSARI EQU   IEDNSVTD+192
SAVTSAC  EQU   IEDNSVTD+188
SAVTSAI  EQU   IEDNSVTD+184
SAVTCSCI EQU   IEDNSVTD+180
SAVTSSRP EQU   IEDNSVTD+176
SAVTSSRQ EQU   IEDNSVTD+172
SAVTSCLU EQU   IEDNSVTD+168
SAVTXTRQ EQU   IEDNSVTD+164
SAVTMVBF EQU   IEDNSVTD+160
@NM00097 EQU   IEDNSVTD+148
SAVTIPCQ EQU   IEDNSVTD+144
@NM00096 EQU   IEDNSVTD+136
SAVTXFMI EQU   IEDNSVTD+132
@NM00095 EQU   IEDNSVTD+124
SAVTXFMO EQU   IEDNSVTD+120
@NM00094 EQU   IEDNSVTD+116
SAVTSSSR EQU   IEDNSVTD+112
SAVTSCPQ EQU   IEDNSVTD+108
SAVTSLCB EQU   IEDNSVTD+104
SAVTLUSR EQU   IEDNSVTD+100
@NM00093 EQU   SAVTLUSQ+8
SAVTLUSP EQU   SAVTLUSQ+4
SAVTLUSB EQU   SAVTLUSQ
@NM00092 EQU   IEDNSVTD+84
SAVTSAT  EQU   IEDNSVTD+80
SAVTNAT  EQU   IEDNSVTD+76
SAVTCLUP EQU   IEDNSVTD+72
SAVTPIUT EQU   IEDNSVTD+68
SAVTRNTA EQU   IEDNSVTD+64
SAVTDNIR EQU   IEDNSVTD+60
SAVTCNIR EQU   IEDNSVTD+56
SAVTFLDH EQU   IEDNSVTD+52
SAVTSRTN EQU   IEDNSVTD+48
SAVTSREQ EQU   IEDNSVTD+44
SAVTFAIL EQU   IEDNSVTD+42
SAVTSUSE EQU   IEDNSVTD+40
SAVTSIB  EQU   IEDNSVTD+36
SAVTPRTN EQU   IEDNSVTD+32
@NM00091 EQU   IEDNSVTD+28
SAVTWH20 EQU   IEDNSVTD+26
SAVTPWT  EQU   IEDNSVTD+24
SAVTPRTQ EQU   IEDNSVTD+20
SAVTPREQ EQU   IEDNSVTD+16
SAVTPH20 EQU   IEDNSVTD+14
SAVTPUSE EQU   IEDNSVTD+12
SAVTPLCB EQU   IEDNSVTD+8
SAVTPOOL EQU   IEDNSVTD+4
SAVTPRMT EQU   SAVTDIAF
SAVTVIRT EQU   SAVTDIAF
AVTCPBNO EQU   IEDQAVTD+1244
AVTHRESS EQU   IEDQAVTD+1243
@NM00090 EQU   IEDQAVTD+1242
@NM00089 EQU   IEDQAVTD+1241
@NM00088 EQU   IEDQAVTD+1240
@NM00087 EQU   IEDQAVTD+1237
@NM00086 EQU   IEDQAVTD+1236
AVTHRESE EQU   @NM00085
AVTRADDR EQU   IEDQAVTD+1228
AVTNADDR EQU   IEDQAVTD+1224
AVTHRESN EQU   IEDQAVTD+1220
AVTVOLRN EQU   IEDQAVTD+1216
AVTTOTNN EQU   IEDQAVTD+1212
AVTTRCYN EQU   IEDQAVTD+1208
AVTRCTRN EQU   IEDQAVTD+1204
AVTNOVON EQU   IEDQAVTD+1200
AVTADEBN EQU   IEDQAVTD+1196
AVTVOLRR EQU   IEDQAVTD+1192
AVTTOTNR EQU   IEDQAVTD+1188
AVTTRCYR EQU   IEDQAVTD+1184
AVTRCTRR EQU   IEDQAVTD+1180
AVTNOVOR EQU   IEDQAVTD+1176
AVTADEBR EQU   IEDQAVTD+1172
AVTLODPT EQU   IEDQAVTD+1168
AVTIOBN  EQU   IEDQAVTD+1164
AVTIOBR  EQU   IEDQAVTD+1160
AVTCPBPT EQU   IEDQAVTD+1156
AVTFCPB  EQU   IEDQAVTD+1152
@NM00084 EQU   IEDQAVTD+1148
AVTINCPQ EQU   IEDQAVTD+1144
@NM00083 EQU   IEDQAVTD+1140
@NM00082 EQU   IEDQAVTD+1137
@NM00081 EQU   AVTBIT4
@NM00080 EQU   AVTBIT4
@NM00079 EQU   AVTBIT4
@NM00078 EQU   AVTBIT4
@NM00077 EQU   AVTBIT4
@NM00076 EQU   AVTBIT4
@NM00075 EQU   AVTBIT4
AVTRUFTN EQU   AVTBIT4
@NM00074 EQU   IEDQAVTD+1132
AVTNOBFQ EQU   IEDQAVTD+1128
@NM00073 EQU   IEDQAVTD+1124
AVTDKENQ EQU   IEDQAVTD+1120
@NM00072 EQU   IEDQAVTD+1116
AVTDKAPQ EQU   IEDQAVTD+1112
AVTCOPY  EQU   IEDQAVTD+1108
AVTIA    EQU   IEDQAVTD+1104
AVTFL    EQU   IEDQAVTD+1100
@NM00071 EQU   IEDQAVTD+1096
AVTNCPBQ EQU   IEDQAVTD+1092
AVTTOTNC EQU   IEDQAVTD+1088
AVTCMAX  EQU   IEDQAVTD+1084
AVTCMIN  EQU   IEDQAVTD+1080
AVTHM02  EQU   IEDQAVTD+1076
AVTOPCIN EQU   IEDQAVTD+1074
AVTDCTLN EQU   IEDQAVTD+1072
AVTOPMSK EQU   IEDQAVTD+1068
AVTDDFT  EQU   IEDQAVTD+1064
AVTSTEAL EQU   IEDQAVTD+1060
AVTOPTN  EQU   IEDQAVTD+1056
AVTDSKCT EQU   IEDQAVTD+1054
AVTCKRST EQU   IEDQAVTD+1053
AVTSTAN  EQU   AVTBIT3
AVTSTACN EQU   AVTBIT3
AVTSTAIN EQU   AVTBIT3
AVTSTAYN EQU   AVTBIT3
AVTOLTBN EQU   AVTBIT3
AVTTSAB  EQU   AVTBIT3
AVTRFULN EQU   AVTBIT3
AVTRECVN EQU   AVTBIT3
@NM00070 EQU   AVTBIT2
@NM00069 EQU   AVTBIT2
AVTOPEIN EQU   AVTBIT2
AVTSTRTN EQU   AVTBIT2
AVTTOPOL EQU   AVTBIT2
AVTCOPYN EQU   AVTBIT2
AVTREUSN EQU   AVTBIT2
AVTEXTSC EQU   AVTBIT2
AVTDISKN EQU   AVTBIT1
AVTQUCKN EQU   AVTBIT1
AVTCLOSN EQU   AVTBIT1
AVTREADN EQU   AVTBIT1
AVTDLAYN EQU   AVTBIT1
AVTAQTAN EQU   AVTBIT1
AVTTSON  EQU   AVTBIT1
AVTAPLKN EQU   AVTBIT1
AVTDUMBR EQU   IEDQAVTD+1048
AVTDLQX  EQU   IEDQAVTD+1046
AVTINTLV EQU   IEDQAVTD+1044
AVTSMCNT EQU   IEDQAVTD+1042
AVTAVFCT EQU   IEDQAVTD+1040
AVTOPCON EQU   IEDQAVTD+1038
AVTOPCNT EQU   IEDQAVTD+1036
AVTLNCNT EQU   IEDQAVTD+1034
AVTKEYLE EQU   IEDQAVTD+1032
AVTHA16  EQU   IEDQAVTD+1030
AVTHA7   EQU   IEDQAVTD+1028
AVTHA4   EQU   IEDQAVTD+1026
AVTHA3   EQU   IEDQAVTD+1024
AVTHA2   EQU   IEDQAVTD+1022
AVTGETMS EQU   IEDQAVTD+1021
@NM00068 EQU   IEDQAVTD+1020
AVTGETMD EQU   IEDQAVTD+1016
AVTGETMN EQU   IEDQAVTD+1012
AVTCWTOT EQU   IEDQAVTD+1008
AVTCWINT EQU   IEDQAVTD+956
AVTDTRAP EQU   IEDQAVTD+952
@NM00067 EQU   IEDQAVTD+950
@NM00066 EQU   AVTIOTR
AVTIOTRH EQU   AVTIOTR
AVTIOTRE EQU   AVTIOTR
@NM00065 EQU   AVTSUBT
AVTSUBPT EQU   AVTSUBT
AVTSUBON EQU   AVTSUBT
AVTAFE30 EQU   IEDQAVTD+944
AVTAFE20 EQU   IEDQAVTD+940
AVTAFE10 EQU   IEDQAVTD+936
AVTCWEC2 EQU   IEDQAVTD+932
AVTCWPM2 EQU   IEDQAVTD+928
AVTCWTS2 EQU   IEDQAVTD+927
AVTCWTS1 EQU   IEDQAVTD+926
AVTCWCLD EQU   AVTCWFL2
AVTCWRAP EQU   AVTCWFL2
@NM00064 EQU   AVTCWFL2
@NM00063 EQU   AVTCWFL2
@NM00062 EQU   AVTCWFL2
@NM00061 EQU   AVTCWFL2
@NM00060 EQU   AVTCWFL2
AVTCWACT EQU   AVTCWFL2
@NM00059 EQU   AVTCWFL1
@NM00058 EQU   AVTCWFL1
@NM00057 EQU   AVTCWFL1
@NM00056 EQU   AVTCWFL1
@NM00055 EQU   AVTCWFL1
@NM00054 EQU   AVTCWFL1
@NM00053 EQU   AVTCWFL1
AVTCOMWN EQU   AVTCWFL1
AVTCWEC1 EQU   IEDQAVTD+920
AVTCWPM1 EQU   IEDQAVTD+916
AVTCAREA EQU   IEDQAVTD+912
AVTFZERO EQU   IEDQAVTD+908
AVTCADDR EQU   IEDQAVTD+904
AVTCOREC EQU   IEDQAVTD+900
@NM00052 EQU   IEDQAVTD+892
AVTCPBCB EQU   IEDQAVTD+888
@NM00051 EQU   IEDQAVTD+880
AVTDSIOB EQU   IEDQAVTD+876
@NM00050 EQU   IEDQAVTD+868
AVTCPRMB EQU   IEDQAVTD+864
@NM00049 EQU   IEDQAVTD+856
AVTCLOSB EQU   IEDQAVTD+852
@NM00048 EQU   IEDQAVTD+844
AVTACTIB EQU   IEDQAVTD+840
@NM00047 EQU   IEDQAVTD+836
AVTOLTEB EQU   IEDQAVTD+832
AVTOLTCH EQU   AVTOLTQB+1
AVTOLTVT EQU   AVTOLTQB
@NM00046 EQU   AVTOPCQB+8
@NM00045 EQU   AVTOPCEC+1
@NM00044 EQU   AVTOPCCC
AVTOPCPO EQU   AVTOPCCC
AVTOPCWA EQU   AVTOPCCC
AVTOPCCH EQU   AVTOPCOB+1
AVTOPCVT EQU   AVTOPCOB
@NM00043 EQU   AVTCKPQB+9
AVTCKPTS EQU   AVTCKPQB+8
@NM00042 EQU   AVTCKPEC+1
@NM00041 EQU   AVTCKPCC
AVTCKPPO EQU   AVTCKPCC
AVTCKPWA EQU   AVTCKPCC
AVTCKPCH EQU   AVTCKPTB+1
AVTCKPVT EQU   AVTCKPTB
@NM00040 EQU   IEDQAVTD+796
AVTBFRTB EQU   IEDQAVTD+792
@NM00039 EQU   IEDQAVTD+784
AVTBFREB EQU   IEDQAVTD+780
AVTTIMQ  EQU   IEDQAVTD+776
@NM00038 EQU   IEDQAVTD+772
AVTIMQPS EQU   IEDQAVTD+768
AVTINOUT EQU   IEDQAVTD+766
AVTREFTM EQU   IEDQAVTD+764
@NM00037 EQU   IEDQAVTD+752
AVTDELYB EQU   IEDQAVTD+748
AVTOCQPT EQU   IEDQAVTD+744
AVTTSOPT EQU   IEDQAVTD+740
AVTSUPPT EQU   IEDQAVTD+736
AVTCBQCB EQU   IEDQAVTD+732
AVTMSGS  EQU   IEDQAVTD+729
@NM00036 EQU   AVTSYSER
@NM00035 EQU   AVTSYSER
@NM00034 EQU   AVTSYSER
@NM00033 EQU   AVTSYSER
@NM00032 EQU   AVTSYSER
@NM00031 EQU   AVTSYSER
AVTCMAXN EQU   AVTSYSER
AVTCMINN EQU   AVTSYSER
AVT2260L EQU   IEDQAVTD+724
AVTABEPL EQU   AVTADBUF
AVTHFF   EQU   AVTCLRHI+2
@NM00030 EQU   AVTCLRHI
AVTCCLNK EQU   AVTCRELE+5
AVTCCPRI EQU   AVTCRELE+4
AVTCCQCB EQU   AVTCCELE+1
AVTCCKEY EQU   AVTCCELE
AVTDELAD EQU   IEDQAVTD+704
AVTDELEM EQU   IEDQAVTD+700
AVTBSX   EQU   AVTCKLNK
AVTOPETR EQU   AVTHG01
@NM00029 EQU   AVTCKBYT
AVTCKONQ EQU   AVTCKBYT
@NM00028 EQU   AVTCKBYT
@NM00027 EQU   AVTCKBYT
@NM00026 EQU   AVTCKBYT
@NM00025 EQU   AVTCKBYT
@NM00024 EQU   AVTCKBYT
@NM00023 EQU   AVTCKBYT
AVTOPERT EQU   IEDQAVTD+690
AVTOPXCL EQU   IEDQAVTD+688
AVTOPERL EQU   IEDQAVTD+687
@NM00022 EQU   IEDQAVTD+686
AVTCKTIM EQU   IEDQAVTD+684
AVTCKELV EQU   IEDQAVTD+682
AVTCPRCD EQU   IEDQAVTD+681
AVTWARMN EQU   AVTCKELF
AVTCRTLN EQU   AVTCKELF
AVTCPIPN EQU   AVTCKELF
AVTCCLCN EQU   AVTCKELF
AVTCINCN EQU   AVTCKELF
@NM00021 EQU   AVTCKELF
AVTCMCPN EQU   AVTCKELF
AVTNQBCK EQU   AVTCKELF
AVTCKQAD EQU   IEDQAVTD+677
AVTSCBSZ EQU   IEDQAVTD+676
@NM00020 EQU   IEDQAVTD+672
AVTCKELE EQU   IEDQAVTD+668
@NM00019 EQU   AVTCKPEL+8
AVTCKRLK EQU   AVTCKPEL+5
AVTCKRPR EQU   AVTCKPEL+4
AVTCKRMQ EQU   AVTCKRMV+1
AVTCKRKY EQU   AVTCKRMV
AVTHK    EQU   IEDQAVTD+648
AVTHI    EQU   IEDQAVTD+644
AVTIOT   EQU   IEDQAVTD+640
AVTNX    EQU   IEDQAVTD+636
AVTTONE  EQU   IEDQAVTD+632
AVTA3TL  EQU   IEDQAVTD+628
AVTDMECB EQU   IEDQAVTD+624
AVTABEND EQU   IEDQAVTD+618
AVTPLCBN EQU   IEDQAVTD+616
@NM00018 EQU   AVTSAVTP+1
@NM00017 EQU   AVTSAVTF
AVTSNA   EQU   AVTSAVTF
AVTONSNA EQU   AVTSAVTF
AVTVTMCP EQU   AVTSAVTF
@NM00016 EQU   IEDQAVTD+608
AVTCMBSS EQU   IEDQAVTD+604
AVTRCV   EQU   IEDQAVTD+600
AVTSEND  EQU   IEDQAVTD+596
AVTCSCH  EQU   IEDQAVTD+592
AVTQ1    EQU   IEDQAVTD+588
AVTE7    EQU   IEDQAVTD+584
AVTHB    EQU   IEDQAVTD+580
AVTR1    EQU   IEDQAVTD+576
AVTBZ    EQU   IEDQAVTD+572
AVTEZ    EQU   IEDQAVTD+568
AVTEC    EQU   IEDQAVTD+564
AVTEW    EQU   IEDQAVTD+560
AVTNDIAL EQU   AVTSCOPT
AVTN2741 EQU   AVTSCOPT
AVTCONCO EQU   AVTSCOPT
AVTCONC  EQU   AVTSCOPT
AVTCMBUF EQU   AVTSCOPT
AVTAPDMP EQU   AVTSCOPT
@NM00015 EQU   AVTSCOPT
AVTHA    EQU   AVTDISP
AVTEA    EQU   IEDQAVTD+548
AVTAX    EQU   IEDQAVTD+544
AVTA3    EQU   IEDQAVTD+540
AVTGD    EQU   IEDQAVTD+536
AVTAL    EQU   IEDQAVTD+532
AVTOLTST EQU   AVTHG02
AVTE8    EQU   IEDQAVTD+524
AVTUI    EQU   IEDQAVTD+520
AVTCOMPT EQU   IEDQAVTD+516
AVTCRSRF EQU   IEDQAVTD+512
@NM00014 EQU   IEDQAVTD+508
AVTKA02  EQU   IEDQAVTD+504
AVTOPTPT EQU   IEDQAVTD+500
AVTPCBPT EQU   IEDQAVTD+496
@NM00013 EQU   AVTECB1
AVTCOMP  EQU   AVTECB1
@NM00012 EQU   AVTECB1
AVTOPECA EQU   IEDQAVTD+488
AVTOLECA EQU   IEDQAVTD+484
AVTCKECA EQU   IEDQAVTD+480
AVTCWECA EQU   IEDQAVTD+476
AVTCWTCB EQU   IEDQAVTD+472
AVTOLTCB EQU   IEDQAVTD+468
AVTOCTCB EQU   IEDQAVTD+464
AVTCKTCB EQU   IEDQAVTD+460
AVTAS    EQU   IEDQAVTD+456
AVTNOLBF EQU   IEDQAVTD+454
AVTNCKPR EQU   IEDQAVTD+453
AVTCIB   EQU   IEDQAVTD+452
AVTSPLPT EQU   IEDQAVTD+448
AVTMVBFR EQU   IEDQAVTD+444
AVTSBTA  EQU   IEDQAVTD+440
AVTRARTN EQU   IEDQAVTD+436
AVTBSCAN EQU   IEDQAVTD+432
AVTRDYA  EQU   IEDQAVTD+428
AVTRNMPT EQU   IEDQAVTD+424
AVTDISTR EQU   IEDQAVTD+420
AVTPARM3 EQU   IEDQAVTD+416
@NM00011 EQU   AVTPKF
@NM00010 EQU   AVTPKF
@NM00009 EQU   AVTPKF
AVTFTCHF EQU   AVTPKF
@NM00008 EQU   AVTPKF
@NM00007 EQU   AVTPKF
@NM00006 EQU   AVTPKF
@NM00005 EQU   AVTPKF
AVTPARM  EQU   IEDQAVTD+408
AVTEXS2A EQU   IEDQAVTD+402
AVTEXA2S EQU   IEDQAVTD+396
AVTOCGET EQU   IEDQAVTD+392
AVTCKAVT EQU   @NM00003+1
@NM00004 EQU   AVTCKFLG
AVTCKHLT EQU   AVTCKFLG
AVTCKREQ EQU   AVTCKFLG
AVTCKENV EQU   AVTCKFLG
AVTCKNAC EQU   AVTCKFLG
AVTCKTAC EQU   AVTCKFLG
@NM00002 EQU   IEDQAVTD+384
AVTREADD EQU   IEDQAVTD+380
AVTREADY EQU   IEDQAVTD+376
AVTRACE  EQU   IEDQAVTD+372
AVTTCB   EQU   IEDQAVTD+368
AVTPASWD EQU   IEDQAVTD+360
AVTCTLCH EQU   IEDQAVTD+352
AVTDOUBL EQU   IEDQAVTD+344
AVTDOUBX EQU   IEDQAVTD+336
AVTDPARM EQU   IEDQAVTD+332
AVTCSTCS EQU   IEDQAVTD+328
AVTDLQ   EQU   AVTSAVEX+32
@NM00001 EQU   AVTSAVEX
AVTSAVE4 EQU   IEDQAVTD+216
AVTSAVE3 EQU   IEDQAVTD+144
AVTSAVE2 EQU   IEDQAVTD+72
AVTSAVE1 EQU   IEDQAVTD
.@UNREFD ANOP                          END UNREFERENCED COMPONENTS
@PB00004 EQU   @EL00001
@PB00003 EQU   @PB00004
@PB00002 EQU   @PB00003
@ENDDATA EQU   *
         END   IGCAE10D,(C'PLS1048',0701,77220)
