         TITLE 'IGCFJ10D, ACTIVATE NCP RESPONSE PROCESSOR              *
                        '
IGCFJ10D CSECT ,                                                01S0001
@PROLOG  BALR  @12,0                                            01S0001
@PSTART  DS    0H                                               01S0001
         USING @PSTART,@12                                      01S0001
*                                   /*
IGCFJ10D IEDHJN AFTERHJN,HJN           MODULE IDENTIFICATION MACRO
*   ROPCAVT=RPARM;                  /* SET THE BASE POINTER FOR THE
*                                      OPERATOR CONTROL ADDRESS 02S0369
*                                      VECTOR TABLE                  */
         LR    ROPCAVT,RPARM                                    02S0369
*   REG10=OPCWORK;                  /* SET THE BASE REGISTER TO BE
*                                      USED FOR ADDRESSING AUTOMATIC
*                                      DATA WITH THE POINTER TO THE
*                                      OPERATOR CONTROL RESIDENT WORK
*                                      AREA                          */
         L     REG10,OPCWORK(,ROPCAVT)                          02S0370
*   GEN REFS(REG10) NOSETS;                                     02S0371
*                                   /*
         USING @DATD,REG10             INFORM THE ASSEMBLER OF THE
*                                      BASE REGISTER TO BE USED FOR
*                                      ADDRESSING AUTOMATIC DATA
*   RSAVE=ADDR(OPCSAVE);            /* SET THE SAVE AREA POINTER
*                                      REGISTER WITH THE POINTER TO
*                                      THE OPERATOR CONTROL SAVE AREA*/
         LA    RSAVE,OPCSAVE(,ROPCAVT)                          02S0372
*                                                               02S0373
*   /*****************************************************************/
*   /*                                                               */
*   /* PROCESS: THIS SEGMENT DOES THE PROCESSING THAT IS NECESSARY TO*/
*   /* PERFORM THE FUNCTION OF THE MODULE.                           */
*   /*                                                               */
*   /*****************************************************************/
*                                                               02S0373
*                                                               03S0373
*   /*****************************************************************/
*   /*                                                               */
*   /* PROCESS.INITIAL: THIS SEGMENT DOES THE INITIAL PROCESSING.    */
*   /*                                                               */
*   /*****************************************************************/
*                                                               03S0373
*   DO;                                                         03S0373
*     RAVT=OPCAVTPT;                /* SET THE BASE POINTER FOR THE
*                                      TCAM ADDRESS VECTOR TABLE     */
         L     RAVT,OPCAVTPT(,ROPCAVT)                          03S0374
*     ROPCE=OPCCOPCE;               /* SET THE BASE POINTER FOR THE
*                                      OPERATOR CONTROL ELEMENT      */
         L     ROPCE,OPCCOPCE(,ROPCAVT)                         03S0375
*     HALFUNIT=(AVTNOLBF/2);        /* INITIALIZE THE THRESHOLD UNIT
*                                      COUNT                         */
         LH    @06,AVTNOLBF(,RAVT)                              03S0376
         SRDA  @06,32                                           03S0376
         D     @06,@CF00067                                     03S0376
         STH   @07,HALFUNIT                                     03S0376
*     FLAGS=''B;                    /* INIT FLAGS                    */
         SLR   @11,@11                                          03S0377
         ST    @11,FLAGS                                        03S0377
*   END;                                                        03S0378
*                                                               03S0379
*   /*****************************************************************/
*   /*                                                               */
*   /* PROCESS.MAINSEG: THIS SEGMENT ROUTES THE OPCES TO THE CORRECT */
*   /* ROUTINES FOR PROCESSING                                       */
*   /*                                                               */
*   /*****************************************************************/
*                                                               03S0379
*   IF OCREDRVE=OFF THEN            /* IF NOT REDRIVE OPCE THEN      */
         TM    OCREDRVE(ROPCE),B'00010000'                      03S0379
         BNZ   @RF00379                                         03S0379
*     DO;                                                       03S0380
*       IF OCSWITCH^=OCACTNCP THEN  /* IF NOT ACTPU RESP THEN        */
         CLI   OCSWITCH(ROPCE),X'70'                            03S0381
         BE    @RF00381                                         03S0381
*         IF OCSWITCH^=OCSETTD      /* IF NOT SET TIME-DATE RESP THEN*/
*           THEN                                                03S0382
         CLI   OCSWITCH(ROPCE),X'E0'                            03S0382
         BNE   @RT00382                                         03S0382
*           ;                       /* FALL THROUGH                  */
*         ELSE                      /* ELSE PROCESS SET TIME-DATE
*                                      RESPONSE                      */
*           DO;                                                 03S0384
*                                                               04S0385
*             /*******************************************************/
*             /*                                                     */
*             /* SET CONTROL VECTOR RESPONSE PROCESSOR. IF COMMAND   */
*             /* WAS SUCCESSFUL, TURN ON IPLED FLAG IN NCP DEVICE    */
*             /* DEPENDENT FIELDS. IF UNSUCCESSFUL, SET IPL'ED       */
*             /* REQUIRED MSG. AS COMPLETION CODE AND GO CLEANUP.    */
*             /*                                                     */
*             /*******************************************************/
*                                                               04S0385
*             IF OCPARM>0 THEN      /* IF COMMAND WAS SUCCESSFUL     */
         ICM   @11,3,OCPARM(ROPCE)                              04S0385
         BNP   @RF00385                                         04S0385
*               DO;                                             04S0386
*                 RPARM=OCTRMTBL;   /* SET TTCIN OF NCP AS PARM.     */
         SLR   RPARM,RPARM                                      04S0387
         ICM   RPARM,3,OCTRMTBL(ROPCE)                          04S0387
*                 CALL NCPDVCDP;    /* OBTAIN DEVICE DEPENDENT FIELD */
         BAL   @14,NCPDVCDP                                     04S0388
*                 NCPIPLD=ON;       /* TURN ON IPL'ED FLAG           */
         OI    NCPIPLD(RTNCODE),B'00001000'                     04S0389
*                                                               05S0390
*                 /***************************************************/
*                 /*                                                 */
*                 /* PROCESS.MAINSEG.SETCVR.DACTCHK: THIS SEGMENT    */
*                 /* PERFORMS THE PROCESSING NECESSARY TO SEE IF ANY */
*                 /* DEACT LINKS ARE REQUIRED FOR ANY LINKS. IF THE  */
*                 /* ORIGINAL COMMAND WAS AN 'IDLE' THEN ALL LINKS   */
*                 /* ARE DEACTIVATED. IF NOT AN 'IDLE' THEN ALL      */
*                 /* PRE-SNA AND ANY SNA LINES WITHOUT THEIR REMEMBER*/
*                 /* BIT ON ARE DEACTIVATED. IF NO DEACTS ARE        */
*                 /* NECESSARY THEN THE OPCE IS SET UP TO GO TO THE  */
*                 /* ACTLINK SEG TO PERFORM ANY ACTLINK AND RESTART  */
*                 /* PROCESSING                                      */
*                 /*                                                 */
*                 /***************************************************/
*                                                               05S0390
*                 OCWTG=THISMOD;    /* SET UP RETURN TO THIS MODULE  */
         MVC   OCWTG(2,ROPCE),THISMOD                           05S0390
*                 OCSWITCH=OCDACTLK;/* SET UP AS REDRIVE OPCE FOR
*                                      DACT LINKS                    */
         MVI   OCSWITCH(ROPCE),X'60'                            05S0391
*                 OCREDRVE=ON;                                  05S0392
         OI    OCREDRVE(ROPCE),B'00010000'                      05S0392
*                 IF TIC=VALTIC THEN/* IF THERE IS AN ATTACHED RU    */
         TM    TIC(ROPCE),B'00000011'                           05S0393
         BNZ   @RF00393                                         05S0393
*                   DO;                                         05S0394
*                     RPARM=OCUNIT; /* THEN POINT TO IT              */
         L     RPARM,OCUNIT(,ROPCE)                             05S0395
*                     CALL FREEBUF; /* AND FREE IT                   */
         L     @15,OPCFREBF(,ROPCAVT)                           05S0396
         BALR  @14,@15                                          05S0396
*                     OCUNIT=PRUINTIC;/* SET INVALID TIC     @YM05695*/
         MVC   OCUNIT(4,ROPCE),@CF01412                         05S0397
*                   END;                                        05S0398
*                 ELSE                                          05S0399
*                   ;                                           05S0399
@RF00393 DS    0H                                               05S0400
*                 RPARM=OCPTRSAV-LENGTH(IEDQOPCN);/* BACK UP TO ORIG
*                                      OPCE NEG PREF                 */
         L     RPARM,OCPTRSAV(,ROPCE)                           05S0400
         SH    RPARM,@CH00047                                   05S0400
*                 IF RPARM->OCIDLE=ON THEN/* IF ORIG OPCE IS 'IDLE'  */
         TM    OCIDLE(RPARM),B'00000001'                        05S0401
         BNO   @RF00401                                         05S0401
*                   ACTFLAG=1;      /* THEN SET CNTL TO COUNT ALL
*                                      LINES                         */
         MVC   ACTFLAG(4),@CF00063                              05S0402
*                 ELSE                                          05S0403
*                   ACTFLAG=3;      /* ELSE SET TO COUNT PSNA AND
*                                      INACTIVE SNA LINES            */
         B     @RC00401                                         05S0403
@RF00401 MVC   ACTFLAG(4),@CF00076                              05S0403
*                 IF TRMSUBST=0 THEN/* IF NO SUBORDINATE RESOURCES
*                                      THEN DONE                     */
@RC00401 LR    @11,RTRM                                         05S0404
         BCTR  @11,0                                            05S0404
         BCTR  @11,0                                            05S0404
         ICM   @09,3,TRMSUBST-12(@11)                           05S0404
         BNZ   @RF00404                                         05S0404
*                   DO;                                         05S0405
*                     OCPTRSAV->OCPARM=GOODMSG;/* SET COMPLETION MSG */
         L     @11,OCPTRSAV(,ROPCE)                             05S0406
         MVC   OCPARM(2,@11),@CH01663                           05S0406
*                     OPCCOPCE=OCPTRSAV;/* SET ORIG OPCE AS CURRENT  */
         ST    @11,OPCCOPCE(,ROPCAVT)                           05S0407
*                     CALL TERMPROC;/* PERFORM TERMINATION PROCESSING*/
         BAL   @14,TERMPROC                                     05S0408
*                     OUTFLAG=ON;   /* SET TO BYPASS ACTLINK         */
         OI    OUTFLAG,B'01000000'                              05S0409
*                   END;                                        05S0410
*                 ELSE                                          05S0411
*                   DO;             /* ELSE PROCESS SUBORDINATE 05S0411
*                                      RESOURCES                     */
         B     @RC00404                                         05S0411
@RF00404 DS    0H                                               05S0412
*                     OCBUFNED=0;   /* INIT THE COUNTER FIELDS       */
         SLR   @11,@11                                          05S0412
         STH   @11,OCBUFNED(,ROPCE)                             05S0412
*                     OCBUFGOT=0;                               05S0413
         STH   @11,OCBUFGOT(,ROPCE)                             05S0413
*                     CALL HIERLOOP;/* PERFORM THE COUNT             */
         BAL   @14,HIERLOOP                                     05S0414
*                     IF OCBUFNED^=0 THEN/* IF ANY DEACTS TO BE DONE */
         ICM   @11,3,OCBUFNED(ROPCE)                            05S0415
         BZ    @RF00415                                         05S0415
*                       DO;         /* THEN                          */
*                         RPARM=OCPTRSAV-LENGTH(IEDQOPCN);/* BACK UP
*                                      TO ORIG OPCE NEG PREF         */
         L     RPARM,OCPTRSAV(,ROPCE)                           05S0417
         SH    RPARM,@CH00047                                   05S0417
*                         RPARM->OCRESPCT=OCBUFNED;/* AND SET   05S0418
*                                      OUTSTANDING RESPONSE COUNT    */
         MVC   OCRESPCT(2,RPARM),OCBUFNED(ROPCE)                05S0418
*                         CALL GETBUFS;/* AND GO GET BUFS            */
         BAL   @14,GETBUFS                                      05S0419
*                         IF OUTFLAG=OFF THEN/* IF COULD OBTAIN ANY
*                                      BUFFERS THEN                  */
         TM    OUTFLAG,B'01000000'                              05S0420
         BNZ   @RF00420                                         05S0420
*                           DO;                                 05S0421
*                             ACTFLAG=ACTFLAG+1;/* SET CNTL TO BUILD
*                                      DEACTS                        */
         LA    @11,1                                            05S0422
         AL    @11,ACTFLAG                                      05S0422
         ST    @11,ACTFLAG                                      05S0422
*                             CALL BLDER;/* AND GO BUILD THEM AND
*                                      POST THEM                     */
         BAL   @14,BLDER                                        05S0423
*                           END;                                05S0424
*                         ELSE                                  05S0425
*                           ;                                   05S0425
@RF00420 DS    0H                                               05S0426
*                       END;                                    05S0426
*                     ELSE          /* ELSE SET UP TO DO ACT LINKS
*                                      AND STARTLINES                */
*                       DO;                                     05S0427
         B     @RC00415                                         05S0427
@RF00415 DS    0H                                               05S0428
*                         OCSWITCH=OCACTLK;/* SET ACTLINK CODE       */
         MVI   OCSWITCH(ROPCE),X'50'                            05S0428
*                         OCREDRVE=OFF;/* AND RESET REDRIVE SWITCH   */
         NI    OCREDRVE(ROPCE),B'11101111'                      05S0429
*                       END;                                    05S0430
*                   END;                                        05S0431
*               END;                                            04S0432
*             ELSE                  /* UNSUCCESSFUL SET CTL. VECTOR  */
*               DO;                                             04S0433
         B     @RC00385                                         04S0433
@RF00385 DS    0H                                               04S0434
*                 OCPTRSAV->OCPARM=IPLRQMSG;/* SET IPL REQ'ED AS
*                                      COMP. CODE                    */
         L     @11,OCPTRSAV(,ROPCE)                             04S0434
         MVC   OCPARM(2,@11),@CH01665                           04S0434
*                 CALL CLNUPNCP;    /* CLEANUP F ACT=NCP             */
         BAL   @14,CLNUPNCP                                     04S0435
*                 CALL TERMPROC;    /* TERMINATE PROCESSING          */
         BAL   @14,TERMPROC                                     04S0436
*                 OUTFLAG=ON;       /* SET TO BYPASS ACTLINK         */
         OI    OUTFLAG,B'01000000'                              04S0437
*               END;                                            04S0438
*           END;                                                03S0439
*       ELSE                        /* ELSE PROCESS ACTPU RESPONSE   */
*         DO;                                                   03S0440
         B     @RC00381                                         03S0440
@RF00381 DS    0H                                               03S0441
*                                                               04S0441
*           /*********************************************************/
*           /*                                                       */
*           /* ACTPU(NCP) RESPONSE PROCESSOR. IF OPCE INDICATES THAT */
*           /* NCP IS ACTIVE OR WAS ALREADY ACTIVE, THE ATTACHED RU  */
*           /* IS FREED, THE OPCE IS REFORMATTED INTO A SET CTL.     */
*           /* VECTOR OPCE, AND SET TO XCTL TO SSCP. IF BAD RESPONSE,*/
*           /* SET COMPLETION CODE AND CALL ROUTINES TO CLEAN UP NCP */
*           /* ACTIVATION AND TERMINATE PROCESSING                   */
*           /*                                                       */
*           /*********************************************************/
*                                                               04S0441
*           IF OCPARM>0 THEN        /* IF NCP ACTIVATED OR ALREADY
*                                      ACTIVE                        */
         ICM   @11,3,OCPARM(ROPCE)                              04S0441
         BNP   @RF00441                                         04S0441
*             DO;                   /* FREE RU AND REFORMAT INTO SET
*                                      CONTROL VECTOR OPCE           */
*               RPARM=OCUNIT;       /* FREE ATTACHED ....            */
         L     RPARM,OCUNIT(,ROPCE)                             04S0443
*               CALL FREEBUF;       /* .... RU                       */
         L     @15,OPCFREBF(,ROPCAVT)                           04S0444
         BALR  @14,@15                                          04S0444
*               OCUNIT=PRUINTIC;    /* SET INVALID TIC       @YM05695*/
         MVC   OCUNIT(4,ROPCE),@CF01412                         04S0445
*               OCSWITCH=OCSETTD;   /* INDICATES SET CTL. VECTOR
*                                      (TIME/ DATE)                  */
         MVI   OCSWITCH(ROPCE),X'E0'                            04S0446
*               OCWTG=THISMOD;      /* SET TO RETURN TO 'FJ' FROM
*                                      SSCP                          */
         MVC   OCWTG(2,ROPCE),THISMOD                           04S0447
*               OCRESP=OFF;         /* SET OFF OCRESP                */
         NI    OCRESP(ROPCE),B'11111110'                        04S0448
*               OPCMODID=SSCPMOD;   /* SET TO XCTL TO SSCP           */
         MVC   OPCMODID(2,ROPCAVT),SSCPMOD                      04S0449
*             END;                                              04S0450
*           ELSE                                                04S0451
*             DO;                   /* DO ACTPU(NCP) ERROR PROCESSING*/
         B     @RC00441                                         04S0451
@RF00441 DS    0H                                               04S0452
*               IF OCPARM=OCRCBNEG|OCPARM=OCRCBPOS THEN/* IF IPL
*                                      REQUIRED                      */
         LH    @11,OCPARM(,ROPCE)                               04S0452
         CH    @11,@CH01067                                     04S0452
         BE    @RT00452                                         04S0452
         CH    @11,@CH01071                                     04S0452
         BNE   @RF00452                                         04S0452
@RT00452 DS    0H                                               04S0453
*                 OCPTRSAV->OCPARM=IPLRQMSG;/* SET COMPLETION CODE IN
*                                      ORIG. OPCE                    */
         L     @11,OCPTRSAV(,ROPCE)                             04S0453
         MVC   OCPARM(2,@11),@CH01665                           04S0453
*               ELSE                                            04S0454
*                 IF OCPARM=OCRCBSIB THEN/* IF SIB SHORTAGE          */
         B     @RC00452                                         04S0454
@RF00452 CLC   OCPARM(2,ROPCE),@CH01069                         04S0454
         BNE   @RF00454                                         04S0454
*                   OCPTRSAV->OCPARM=SIBSGMSG;/* SET COMP. CODE IN
*                                      ORIG. OPCE                    */
         L     @11,OCPTRSAV(,ROPCE)                             04S0455
         MVC   OCPARM(2,@11),@CH01667                           04S0455
*                 ELSE                                          04S0456
*                   DO;                                         04S0456
         B     @RC00454                                         04S0456
@RF00454 DS    0H                                               04S0457
*                     RPARM=OCPTRSAV-LENGTH(IEDQOPCN);/* POINT TO
*                                      NEG. PREFIX OF ORIG.          */
         L     @11,OCPTRSAV(,ROPCE)                             04S0457
         LR    RPARM,@11                                        04S0457
         SH    RPARM,@CH00047                                   04S0457
*                     RPARM->OCLDNME=OCBACKUP;/* PLACE LOAD MOD. NAME
*                                      IN PREFIX                     */
         MVC   OCLDNME(8,RPARM),OCBACKUP(ROPCE)                 04S0458
*                     OCPTRSAV->OCPARM=LDMODMSG;/* SET COMP. CODE IN
*                                      ORIG OPCE FOR LOAD MODULE NAME
*                                      MISMATCH                      */
         MVC   OCPARM(2,@11),@CH01669                           04S0459
*                   END;                                        04S0460
*               CALL CLNUPNCP;      /* CLEAN UP F ACT=NCP            */
@RC00454 DS    0H                                               04S0461
@RC00452 BAL   @14,CLNUPNCP                                     04S0461
*               CALL TERMPROC;      /* TERMINATE PROCESSING          */
         BAL   @14,TERMPROC                                     04S0462
*             END;                                              04S0463
*           OUTFLAG=ON;             /* SET TO BYPASS ACTLINK         */
@RC00441 OI    OUTFLAG,B'01000000'                              04S0464
*         END;                                                  03S0465
*       IF OUTFLAG=OFF THEN         /* IF FLAG NOT SET THEN          */
@RC00381 TM    OUTFLAG,B'01000000'                              03S0466
         BNZ   @RF00466                                         03S0466
*         DO;                                                   03S0467
*                                                               04S0468
*           /*********************************************************/
*           /*                                                       */
*           /* ACTLINK: THIS SEGMENT CHECKS TO SEE IF RESTART        */
*           /* PROCESSING IS NECESSARY AND IF SO CONTROL IS PASSED TO*/
*           /* IGCFF10D TO SEND RESTART INFO TO THE NCP. IGCFF10D    */
*           /* RETURNS TO THIS MODULE TO HAVE THE ACTLINK PROCESSING */
*           /* PERFORMED(OCSWITCH=0). MODULES IGCFL-FQ10D RETURN TO  */
*           /* THIS MODULE ALSO TO HAVE THE ACTLINK PROCESSING       */
*           /* PERFORMED                                             */
*           /*                                                       */
*           /*********************************************************/
*                                                               04S0468
*           IF OCSWITCH^=0 THEN     /* IF NOT RETURN FROM FF THEN SEE
*                                      IF RESTART                    */
         CLI   OCSWITCH(ROPCE),0                                04S0468
         BE    @RF00468                                         04S0468
*             DO;                   /* NECESSARY                     */
*               RPARM=OCPTRSAV->OCTRMTBL;/* SET UP NCP TTCIN IN RPARM*/
         L     @11,OCPTRSAV(,ROPCE)                             04S0470
         SLR   @09,@09                                          04S0470
         ICM   @09,3,OCTRMTBL(@11)                              04S0470
         LR    RPARM,@09                                        04S0470
*               OCTRMTBL=OCPTRSAV->OCTRMTBL;/* AND IN OCTRMTBL  04S0471
*                                                            @YM05695*/
         STH   @09,OCTRMTBL(,ROPCE)                             04S0471
*               CALL NCPDVCDP;      /* OBTAIN ADDR. OF NCP DEVICE
*                                      DEPENDENT FIELDS              */
         BAL   @14,NCPDVCDP                                     04S0472
*               IF NCPCKPT^=0 THEN  /* IF POINTER TO CK.PT. D.S.
*                                      EXITS                         */
         SLR   @11,@11                                          04S0473
         L     @09,NCPCKPT(,RTNCODE)                            04S0473
         CLR   @09,@11                                          04S0473
         BE    @RF00473                                         04S0473
*                 IF DCBOFOPN=ON&DCBIOBAD^=0&NCPREST=ON THEN/* IF
*                                      OPEN & RESTART                */
         TM    DCBOFOPN+40(@09),B'00010000'                     04S0474
         BNO   @RF00474                                         04S0474
         C     @11,DCBIOBAD+20(,@09)                            04S0474
         BE    @RF00474                                         04S0474
         TM    NCPREST(RTNCODE),B'00010000'                     04S0474
         BNO   @RF00474                                         04S0474
*                   DO;                                         04S0475
*                     FINIFLAG=ON;  /* SET ON FINIFLAG               */
         OI    FINIFLAG,B'10000000'                             04S0476
*                     OPCMODID=ADCKPMOD;/* SET TO XCTL TO A/D CK. PT.
*                                      MOD.                          */
         MVC   OPCMODID(2,ROPCAVT),ADCKPMOD                     04S0477
*                   END;                                        04S0478
*                 ELSE                                          04S0479
*                   ;                                           04S0479
@RF00474 DS    0H                                               04S0480
*               ELSE                                            04S0480
*                 ;                                             04S0480
@RF00473 DS    0H                                               04S0481
*             END;                                              04S0481
*           ELSE                                                04S0482
*             ;                                                 04S0482
@RF00468 DS    0H                                               04S0483
*           IF FINIFLAG=OFF THEN    /* PERFORM ACTLINK PROCESSING    */
         TM    FINIFLAG,B'10000000'                             04S0483
         BNZ   @RF00483                                         04S0483
*             DO;                                               04S0484
*                                                               05S0485
*               /*****************************************************/
*               /*                                                   */
*               /* THIS SEGMENT CHECKS TO SEE IF THE ORIG CMND. WAS  */
*               /* AN F ACT=NCP,IDLE. IF IT WAS PROCESSING IS        */
*               /* TERMINATED AND A GOOD COMPLETION CODE IS GIVEN. IF*/
*               /* NOT, THE NUMBER OF LINES TO ACTIVATE IS           */
*               /* DETERMINED. IF NO LINES ARE TO BE ACTIVATED,      */
*               /* PROCESSING IS THE SAME AS IF IDLE. OTHERWISE, THE */
*               /* ATTACHED RU IS FREED AND ACTIVATE LINES PROCESSING*/
*               /* IS STARTED.                                       */
*               /*                                                   */
*               /*****************************************************/
*                                                               05S0485
*               RPARM=OCPTRSAV-LENGTH(IEDQOPCN);/* POINT TO NEG.
*                                      PREFIX OF ORIG.               */
         L     @11,OCPTRSAV(,ROPCE)                             05S0485
         LR    RPARM,@11                                        05S0485
         SH    RPARM,@CH00047                                   05S0485
*               IF RPARM->OCIDLE=ON THEN/* IF IDLE FLAG ON IN ORIG.  */
         TM    OCIDLE(RPARM),B'00000001'                        05S0486
         BNO   @RF00486                                         05S0486
*                 DO;                                           05S0487
*                   OCPTRSAV->OCPARM=GOODMSG;/* SET GOOD COMP. CODE  */
         MVC   OCPARM(2,@11),@CH01663                           05S0488
*                   OPCCOPCE=OCPTRSAV;/* MAKE ORIG. OPCE THE CURRENT
*                                      OPCE                          */
         ST    @11,OPCCOPCE(,ROPCAVT)                           05S0489
*                   CALL TERMPROC;  /* TERMINATE PROCESSING          */
         BAL   @14,TERMPROC                                     05S0490
*                 END;                                          05S0491
*               ELSE                                            05S0492
*                 DO;               /* NOT IDLE                      */
         B     @RC00486                                         05S0492
@RF00486 DS    0H                                               05S0493
*                   IF TIC=VALTIC THEN/* IF UNIT ATTACHED            */
         TM    TIC(ROPCE),B'00000011'                           05S0493
         BNZ   @RF00493                                         05S0493
*                     DO;                                       05S0494
*                       RPARM=OCUNIT;/* POINT TO ATTACHED RU         */
         L     RPARM,OCUNIT(,ROPCE)                             05S0495
*                       CALL FREEBUF;/* FREE THE RU                  */
         L     @15,OPCFREBF(,ROPCAVT)                           05S0496
         BALR  @14,@15                                          05S0496
*                       OCUNIT=PRUINTIC;/* AND SET INVALID TIC       */
         MVC   OCUNIT(4,ROPCE),@CF01412                         05S0497
*                     END;                                      05S0498
*                   ELSE                                        05S0499
*                     ;                                         05S0499
@RF00493 DS    0H                                               05S0500
*                   ACTFLAG=5;      /* SET FLAG TO COUNT ACTLINKS TO
*                                      BE DONE                       */
         MVC   ACTFLAG(4),@CF00165                              05S0500
*                   OCBUFNED=0;     /* INIT THE BUFS NEED AND THE    */
         SLR   @11,@11                                          05S0501
         STH   @11,OCBUFNED(,ROPCE)                             05S0501
*                   OCBUFGOT=0;     /* BUFS HAVE FIELDS              */
         STH   @11,OCBUFGOT(,ROPCE)                             05S0502
*                   CALL HIERLOOP;  /* GO GET COUNT                  */
         BAL   @14,HIERLOOP                                     05S0503
*                   IF OCBUFNED^=0 THEN/* IF ANY ACTLINKS TO BE DONE */
         ICM   @11,3,OCBUFNED(ROPCE)                            05S0504
         BZ    @RF00504                                         05S0504
*                     DO;                                       05S0505
*                       RPARM=OCPTRSAV-LENGTH(IEDQOPCN);/* BACK UP TO
*                                      NEG PREFIX                    */
         L     RPARM,OCPTRSAV(,ROPCE)                           05S0506
         SH    RPARM,@CH00047                                   05S0506
*                       RPARM->OCRESPCT=OCBUFNED;/* SET OUTSTANDING
*                                      RESP COUNT                    */
         MVC   OCRESPCT(2,RPARM),OCBUFNED(ROPCE)                05S0507
*                       CALL GETBUFS;/* GO GET BUFFER UNITS          */
         BAL   @14,GETBUFS                                      05S0508
*                       IF OUTFLAG=OFF THEN/* IF COULD GET UNITS THEN*/
         TM    OUTFLAG,B'01000000'                              05S0509
         BNZ   @RF00509                                         05S0509
*                         DO;                                   05S0510
*                           ACTFLAG=6;/* SET TO BUILD ACTLINKS AND
*                                      STARTLINES                    */
         MVC   ACTFLAG(4),@CF00061                              05S0511
*                           CALL BLDER;/* GO BUILD OPCES             */
         BAL   @14,BLDER                                        05S0512
*                         END;                                  05S0513
*                       ELSE                                    05S0514
*                         ;                                     05S0514
@RF00509 DS    0H                                               05S0515
*                     END;                                      05S0515
*                   ELSE                                        05S0516
*                     DO;           /* NO LINES TO ACTIVATE          */
         B     @RC00504                                         05S0516
@RF00504 DS    0H                                               05S0517
*                       OCPTRSAV->OCPARM=GOODMSG;/* SET GOOD COMP.
*                                      CODE                          */
         L     @11,OCPTRSAV(,ROPCE)                             05S0517
         MVC   OCPARM(2,@11),@CH01663                           05S0517
*                       OPCCOPCE=OCPTRSAV;/* MAKE ORIG. OPCE THE
*                                      CURRENT OPCE                  */
         ST    @11,OPCCOPCE(,ROPCAVT)                           05S0518
*                       CALL TERMPROC;/* TERMINATE PROCESSING        */
         BAL   @14,TERMPROC                                     05S0519
*                     END;                                      05S0520
*                 END;                                          05S0521
*             END;                                              04S0522
*           ELSE                                                04S0523
*             ;                                                 04S0523
@RF00483 DS    0H                                               04S0524
*         END;                                                  03S0524
*       ELSE                                                    03S0525
*         ;                                                     03S0525
@RF00466 DS    0H                                               03S0526
*     END;                                                      03S0526
*   ELSE                                                        03S0527
*     IF OCSWITCH=OCDACTLK THEN     /* IF DACTLINK REDRIVE THEN      */
         B     @RC00379                                         03S0527
@RF00379 CLI   OCSWITCH(ROPCE),X'60'                            03S0527
         BNE   @RF00527                                         03S0527
*       DO;                                                     03S0528
*                                                               04S0529
*         /***********************************************************/
*         /*                                                         */
*         /* DACTLKRD: THIS SEGMENT PROCESSES DACTLINK REDRIVE OPCES */
*         /* TO CONTINUE THE DACTLINK PROCESS                        */
*         /*                                                         */
*         /***********************************************************/
*                                                               04S0529
*         RPARM=OCPTRSAV-LENGTH(IEDQOPCN);/* BACK UP TO NEG PREF OF
*                                      OPCE                          */
         L     RPARM,OCPTRSAV(,ROPCE)                           04S0529
         SH    RPARM,@CH00047                                   04S0529
*         IF RPARM->OCIDLE=ON THEN  /* IF ORIG OPCE IS 'IDLE'        */
         TM    OCIDLE(RPARM),B'00000001'                        04S0530
         BNO   @RF00530                                         04S0530
*           ACTFLAG=2;              /* SET CONTROL AS SAME           */
         MVC   ACTFLAG(4),@CF00067                              04S0531
*         ELSE                                                  04S0532
*           ACTFLAG=4;              /* ELSE SET TO NORMAL DEACT      */
         B     @RC00530                                         04S0532
@RF00530 MVC   ACTFLAG(4),@CF00257                              04S0532
*         CALL BLDER;               /* AND BUILD DEACTS              */
@RC00530 BAL   @14,BLDER                                        04S0533
*       END;                                                    03S0534
*     ELSE                          /* ELSE IS ACTLINK REDRIVE SO    */
*       DO;                                                     03S0535
         B     @RC00527                                         03S0535
@RF00527 DS    0H                                               03S0536
*                                                               04S0536
*         /***********************************************************/
*         /*                                                         */
*         /* ACTLNKRD: THIS SEGMENT PROCESSES ACTLINK REDRIVE OPCES  */
*         /*                                                         */
*         /***********************************************************/
*                                                               04S0536
*         ACTFLAG=6;                /* SET ACTFLAG TO BUILD ACTLKS
*                                      AND STARTLINES                */
         MVC   ACTFLAG(4),@CF00061                              04S0536
*         CALL BLDER;               /* AND BUILD THEM                */
         BAL   @14,BLDER                                        04S0537
*       END;                                                    03S0538
*                                                               02S0539
*   /*****************************************************************/
*   /*                                                               */
*   /* EPILOGUE: THIS SEGMENT COMPLETES THE EPILOGUE CODE THAT WAS   */
*   /* ALTERED BY THE MODULE PROCEDURE STATEMENT. THE XCTL SYSTEM    */
*   /* MACRO INSTRUCTION IS USED BY THIS SEGMENT TO TRANSFER CONTROL */
*   /* TO THE NEXT MODULE THAT IS TO BE EXECUTED.                    */
*   /*                                                               */
*   /*****************************************************************/
*                                                               02S0539
*   IF OPCMODID=TO00 THEN           /* SET REG 0 IF TO GO TO IGC0010D*/
@RC00527 DS    0H                                               02S0539
@RC00379 CLC   OPCMODID(2,ROPCAVT),TO00                         02S0539
         BNE   @RF00539                                         02S0539
*     REG00=0;                                                  02S0540
         SLR   REG00,REG00                                      02S0540
*   ELSE                                                        02S0541
*     ;                                                         02S0541
@RF00539 DS    0H                                               02S0542
*   RFY                                                         02S0542
*     REG01 RSTD;                   /* RESTRICT THE ARGUMENT REGISTER
*                                      TO BE USED TO CONTAIN THE
*                                      POINTER TO THE OPERATOR  02S0542
*                                      CONTROL ADDRESS VECTOR TABLE
*                                      FROM USE BY THE COMPILER      */
*   REG01=ROPCAVT;                  /* SET THE ARGUMENT REGISTER IN
*                                      PREPARATION TO TRANSFERRING
*                                      CONTROL TO THE NEXT MODULE    */
         LR    REG01,ROPCAVT                                    02S0543
*   GEN EXIT REFS(OPCXCTL,ROPCAVT) NOSEQFLOW SETS(REG15);       02S0544
*                                   /*
         XCTL  SF=(E,OPCXCTL(ROPCAVT)) TRANSFER CONTROL MACRO
*                                                               02S0545
*   /*****************************************************************/
*   /*                                                               */
*   /* HIERLOOP: THIS PROC PERFORMS THE LOOPING THROUGH THE LINE     */
*   /* HIERARCHY AND DOES THE ACTION REQUIRED BY THE ACTION CONTROL  */
*   /* FLAG.                                                         */
*   /*                                                               */
*   /*****************************************************************/
*                                                               02S0545
*HIERLOOP:                                                      02S0545
*   PROC OPTIONS(RETREG,SAVE(14));                              02S0545
HIERLOOP ST    @14,@SA00002                                     02S0545
*   RPARM=OCTRMTBL;                 /* SET TTCIN FOR CALL            */
         SLR   RPARM,RPARM                                      02S0546
         ICM   RPARM,3,OCTRMTBL(ROPCE)                          02S0546
*   CALL IEDQTNT;                   /* GET TTE ADDR                  */
         L     @15,AVTRNMPT(,RAVT)                              02S0547
         BALR  @14,@15                                          02S0547
*   RTRM=RPARM;                     /* SET TTE BASE REG              */
         LR    RTRM,RPARM                                       02S0548
*   IF TRMTYPE=TRMLNCP THEN         /* IF THIS IS THE NCP            */
         LR    @11,RTRM                                         02S0549
         SH    @11,@CH01700                                     02S0549
         CLI   TRMTYPE(@11),X'0F'                               02S0549
         BNE   @RF00549                                         02S0549
*     DO;                           /* THEN MUST FIND SUBSTRUCT TTE
*                                      ADDR                          */
*       RPARM=TRMSUBST;             /* SET TTCIN FOR CALL            */
         SLR   @09,@09                                          02S0551
         ICM   @09,3,TRMSUBST(@11)                              02S0551
         LR    RPARM,@09                                        02S0551
*       OCTRMTBL=TRMSUBST;          /* AND SET UP IN OPCE    @YM05695*/
         STH   @09,OCTRMTBL(,ROPCE)                             02S0552
*       CALL IEDQTNT;               /* GET TTE ADDR                  */
         L     @15,AVTRNMPT(,RAVT)                              02S0553
         BALR  @14,@15                                          02S0553
*       RTRM=RPARM;                 /* SET TTE BASE                  */
         LR    RTRM,RPARM                                       02S0554
*     END;                                                      02S0555
*   ELSE                                                        02S0556
*     ;                                                         02S0556
@RF00549 DS    0H                                               02S0557
*   DO WHILE(TRMTYPE^=TRMLNCP)&(OUTFLAG=OFF);/* LOOP TILL HIT NCP OR
*                                      UNTIL ACTION RUNS OUT OF BUF
*                                      UNITS                         */
         B     @DE00557                                         02S0557
@DL00557 DS    0H                                               02S0558
*                                                               03S0558
*     /***************************************************************/
*     /*                                                             */
*     /* HIERLOOP.ACTION: THIS SEGMENT PERFORMS THE ACTION INDICATED */
*     /* BY THE ACTFLAG CONTROL INDICATOR. THE AVAILABEL ACTIONS ARE:*/
*     /* 1=COUNT ALL LINES 2=BUILD DEACTS FOR ALL LINKS 3=COUNT ALL  */
*     /* PRESNA LINKS AND ALL SNA LINKS WITH TRMREMB OFF. 4= BUILD   */
*     /* DEACT LINKS FOR THOSE LINES COUNTED BY 3. 5=COUNT ALL LINES */
*     /* WITH TRMREMB ON. 6=BUILD ACTLINKS AND STARTLINES FOR ALL    */
*     /* LINES WITH TRMREMB ON                                       */
*     /*                                                             */
*     /***************************************************************/
*                                                               03S0558
*     IF ACTFLAG>2 THEN             /* IF NOT IDLE                   */
         L     @11,ACTFLAG                                      03S0558
         CH    @11,@CH00067                                     03S0558
         BNH   @RF00558                                         03S0558
*       IF ACTFLAG>4 THEN           /* AND NOT DEACT                 */
         CH    @11,@CH00257                                     03S0559
         BNH   @RF00559                                         03S0559
*         IF TRMREMB=ON THEN        /* AND REMEMBER BIT IS ON        */
         LR    @09,RTRM                                         03S0560
         AL    @09,@CF01732                                     03S0560
         TM    TRMREMB-2(@09),B'01000000'                       03S0560
         BNO   @RF00560                                         03S0560
*           IF ACTFLAG=5 THEN       /* AND COUNTING                  */
         CH    @11,@CH00165                                     03S0561
         BNE   @RF00561                                         03S0561
*             OCBUFNED=OCBUFNED+1;  /* THEN ADD 1 TO COUNT           */
         LA    @11,1                                            03S0562
         SLR   @09,@09                                          03S0562
         ICM   @09,3,OCBUFNED(ROPCE)                            03S0562
         ALR   @11,@09                                          03S0562
         STH   @11,OCBUFNED(,ROPCE)                             03S0562
*           ELSE                    /* ELSE BUILD ACTS AND STARTLINES*/
*             CALL BLDOPCE;                                     03S0563
         B     @RC00561                                         03S0563
@RF00561 BAL   @14,BLDOPCE                                      03S0563
*         ELSE                                                  03S0564
*           ;                                                   03S0564
@RF00560 DS    0H                                               03S0565
*       ELSE                        /* IF REMB BIT IS OFF AND DOING
*                                      DEACTS                        */
*         IF(TRMREMB=ON)&(TRMTYPE=TRMSDLC) THEN                 03S0565
         B     @RC00559                                         03S0565
@RF00559 LR    @11,RTRM                                         03S0565
         SH    @11,@CH01700                                     03S0565
         TM    TRMREMB(@11),B'01000000'                         03S0565
         BNO   @RF00565                                         03S0565
         CLI   TRMTYPE(@11),X'21'                               03S0565
         BE    @RT00565                                         03S0565
*           ;                                                   03S0566
*         ELSE                      /* SEE IF COUNTING OR BUILDING
*                                      OPCES                         */
*           IF ACTFLAG=3 THEN       /* ADD TO COUNT IF COUNTING      */
@RF00565 CLC   ACTFLAG(4),@CF00076                              03S0567
         BNE   @RF00567                                         03S0567
*             OCBUFNED=OCBUFNED+1;                              03S0568
         LA    @11,1                                            03S0568
         SLR   @09,@09                                          03S0568
         ICM   @09,3,OCBUFNED(ROPCE)                            03S0568
         ALR   @11,@09                                          03S0568
         STH   @11,OCBUFNED(,ROPCE)                             03S0568
*           ELSE                                                03S0569
*             CALL BLDOPCE;         /* ELSE BUILD OPCE               */
         B     @RC00567                                         03S0569
@RF00567 BAL   @14,BLDOPCE                                      03S0569
*     ELSE                          /* IF DOING DEACTS FOR ACT IDLE  */
*       IF ACTFLAG=1 THEN           /* BUMP COUNT IF COUNTING        */
         B     @RC00558                                         03S0570
@RF00558 LA    @11,1                                            03S0570
         C     @11,ACTFLAG                                      03S0570
         BNE   @RF00570                                         03S0570
*         OCBUFNED=OCBUFNED+1;                                  03S0571
         SLR   @09,@09                                          03S0571
         ICM   @09,3,OCBUFNED(ROPCE)                            03S0571
         ALR   @11,@09                                          03S0571
         STH   @11,OCBUFNED(,ROPCE)                             03S0571
*       ELSE                                                    03S0572
*         CALL BLDOPCE;             /* ELSE BUILD DEACTS             */
         B     @RC00570                                         03S0572
@RF00570 BAL   @14,BLDOPCE                                      03S0572
*     RPARM=TRMCOHRT;               /* SET TO FOLLOW HIERARCHY CHAIN */
@RC00570 DS    0H                                               02S0573
@RC00558 LR    @11,RTRM                                         02S0573
         AL    @11,@CF01733                                     02S0573
         SLR   @09,@09                                          02S0573
         ICM   @09,3,TRMCOHRT-4(@11)                            02S0573
         LR    RPARM,@09                                        02S0573
*     OCTRMTBL=TRMCOHRT;            /* SAVE ALSO IN OPCE             */
         STH   @09,OCTRMTBL(,ROPCE)                             02S0574
*     CALL IEDQTNT;                 /* GET TTE ADDR                  */
         L     @15,AVTRNMPT(,RAVT)                              02S0575
         BALR  @14,@15                                          02S0575
*     RTRM=RPARM;                   /* SET NEW TTE BASE              */
         LR    RTRM,RPARM                                       02S0576
*   END;                                                        02S0577
@DE00557 LR    @11,RTRM                                         02S0577
         AL    @11,@CF01071                                     02S0577
         CLI   TRMTYPE-11(@11),X'0F'                            02S0577
         BE    @DC00557                                         02S0577
         TM    OUTFLAG,B'01000000'                              02S0577
         BZ    @DL00557                                         02S0577
@DC00557 DS    0H                                               02S0578
*   END HIERLOOP;                                               02S0578
@EL00002 DS    0H                                               02S0578
@EF00002 DS    0H                                               02S0578
@ER00002 L     @14,@SA00002                                     02S0578
         BR    @14                                              02S0578
*                                                               02S0579
*   /*****************************************************************/
*   /*                                                               */
*   /* BLDOPCE: THIS PROC BUILDS OPCES FOR DEACT LINKS, ACT LINKS,   */
*   /* AND STARTLINE REQUESTS. THEY ARE PUT ON THE SVC102 LIST. IF   */
*   /* USE THE LAST BUFFER THEN NEED MORE THEN THE OUT FLAG IS SET ON*/
*   /* TO EXIT THE OUTER LOOP AND SET UP FOR REDRIVE                 */
*   /*                                                               */
*   /*****************************************************************/
*                                                               02S0579
*BLDOPCE:                                                       02S0579
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);                            02S0579
BLDOPCE  DS    0H                                               02S0580
*   RFY                                                         02S0580
*     REG14 RSTD;                   /* RESTRICT REG                  */
*   BLDOSAV=REG14;                  /* SAVE RETURN ADDR              */
         ST    REG14,BLDOSAV                                    02S0581
*   RFY                                                         02S0582
*     REG14 UNRSTD;                 /* FREE REG FOR USE              */
*   RFY                                                         02S0583
*     REG09 RSTD;                   /* RESTRICT REG                  */
*   REG09=OCUNIT;                   /* GET PTR TO ATTACHED UNIT      */
         L     REG09,OCUNIT(,ROPCE)                             02S0584
*   OCUNIT=REG09->OCUNIT;           /* DELINK UNIT                   */
         MVC   OCUNIT(4,ROPCE),OCUNIT(REG09)                    02S0585
*   RFY                                                         02S0586
*     IEDQOPCE BASED(REG09);        /* RESET OPCE BASE               */
*   OCUNIT=PRUINTIC;                /* SET UP INVALID TIC            */
         MVC   OCUNIT(4,REG09),@CF01412                         02S0587
*   OCTRMTBL=ROPCE->OCTRMTBL;       /* SET UP TTCIN                  */
         MVC   OCTRMTBL(2,REG09),OCTRMTBL(ROPCE)                02S0588
*   OCPARM=0;                       /* CLEAR OCPARM                  */
         SLR   @11,@11                                          02S0589
         STH   @11,OCPARM(,REG09)                               02S0589
*   OCALSTAT=0;                     /* CLEAR OCALSTAT                */
         MVI   OCALSTAT(REG09),X'00'                            02S0590
*   OCRESP=OFF;                     /* TURN OFF OCRESP               */
         NI    OCRESP(REG09),B'11111110'                        02S0591
*   OCACTREQ=ON;                    /* SET ACT/DEACT REQUEST         */
         OI    OCACTREQ(REG09),B'00001000'                      02S0592
*   OCLINK=ADDR(AVTOPCOB);          /* SET QCB PTR                   */
         LA    @11,AVTOPCOB(,RAVT)                              02S0593
         ST    @11,OCLINK(,REG09)                               02S0593
*   OCPTRSAV=ROPCE->OCPTRSAV;       /* SET UP PTR TO ORIG OPCE       */
         MVC   OCPTRSAV(4,REG09),OCPTRSAV(ROPCE)                02S0594
*   IF(ACTFLAG=2)|(ACTFLAG=4) THEN  /* IF DOING DEACTS THEN          */
         L     @11,ACTFLAG                                      02S0595
         CH    @11,@CH00067                                     02S0595
         BE    @RT00595                                         02S0595
         CH    @11,@CH00257                                     02S0595
         BNE   @RF00595                                         02S0595
@RT00595 DS    0H                                               02S0596
*     DO;                                                       02S0596
*       OCELMPRI=PRIHIFLG;          /* SET SSCP PRIORITY             */
         MVI   OCELMPRI(REG09),X'E9'                            02S0597
*       OCPRIFLG=OPRA0;             /* SET SSCP FLAG                 */
         MVI   OCPRIFLG(REG09),X'01'                            02S0598
*       OCSWITCH=OCDACTLK;          /* SET TO DACTLINK REQUEST       */
         MVI   OCSWITCH(REG09),X'60'                            02S0599
*       OCWTG=NEXTMOD;              /* SET RESPONSE TO IGCFL10D      */
         MVC   OCWTG(2,REG09),NEXTMOD                           02S0600
*     END;                                                      02S0601
*   ELSE                            /* ELSE IF DOING ACTIVATES       */
*     IF TRMTYPE=TRMNSDLC THEN      /* AND IS PRE-SNA LINE           */
         B     @RC00595                                         02S0602
@RF00595 LR    @11,RTRM                                         02S0602
         AL    @11,@CF01071                                     02S0602
         CLI   TRMTYPE-11(@11),X'20'                            02S0602
         BNE   @RF00602                                         02S0602
*       DO;                                                     02S0603
*         RPARM=RTRM;               /* SET FOR SUBROUTINE CALL  02S0604
*                                                            @YM05711*/
         LR    RPARM,RTRM                                       02S0604
*         CALL CHORTGLK;            /* FIND GROUP TTE        @YM05711*/
         L     @15,OPCHORTG(,ROPCAVT)                           02S0605
         BALR  @14,@15                                          02S0605
*         RPARM=REG00;              /* SET FOR SUBROUTINE CALL  02S0606
*                                                            @YM05711*/
         LR    RPARM,REG00                                      02S0606
*         OCBACKUP='';              /* CLEAR OCBACKUP        @YM05711*/
         MVI   OCBACKUP(REG09),C' '                             02S0607
         MVC   OCBACKUP+1(7,REG09),OCBACKUP(REG09)              02S0607
*         CALL TNTENTAD;            /* GET THE GROUP NAME FIELD ADDR
*                                                            @YM05711*/
         L     @15,OPCTNTEA(,ROPCAVT)                           02S0608
         BALR  @14,@15                                          02S0608
*         OCBACKUP(1:TNTENLEN)=NAME(1:TNTENLEN);/* SET UP GROUPNAME
*                                                            @YM05711*/
         L     @11,IEDQNPTR(,RAVT)                              02S0609
         SLR   @05,@05                                          02S0609
         IC    @05,TNTENLEN(,@11)                               02S0609
         BCTR  @05,0                                            02S0609
         EX    @05,@SM01734                                     02S0609
*         OCSWITCH=OCVARON;         /* SET STARTLINE CODE            */
         MVI   OCSWITCH(REG09),X'D1'                            02S0610
*         OCELMPRI=PRIMEDFG;        /* SET PRIORITY                  */
         MVI   OCELMPRI(REG09),X'DF'                            02S0611
*         OCPRIFLG=OPRVI2;          /* AND FLAG TO GO TO IGCVI10D    */
         MVI   OCPRIFLG(REG09),X'10'                            02S0612
*         OCWTG=ALKRPMOD;           /* SET RESPONSE RETURN TO   02S0613
*                                      IGCFE10D                      */
         MVC   OCWTG(2,REG09),ALKRPMOD                          02S0613
*       END;                                                    02S0614
*     ELSE                          /* ELSE IS SNA LINE SO BUILD
*                                      ACTLINK REQUEST               */
*       DO;                                                     02S0615
         B     @RC00602                                         02S0615
@RF00602 DS    0H                                               02S0616
*         OCELMPRI=PRIHIFLG;        /* SET SSCP PRIORITY             */
         MVI   OCELMPRI(REG09),X'E9'                            02S0616
*         OCPRIFLG=OPRA0;           /* AND FLAG                      */
         MVI   OCPRIFLG(REG09),X'01'                            02S0617
*         OCSWITCH=OCACTLK;         /* SET ACTLINK CODE              */
         MVI   OCSWITCH(REG09),X'50'                            02S0618
*         OCWTG=ALKRPMOD;           /* SET RESPONSE RETURN TO   02S0619
*                                      IGCFE10D                      */
         MVC   OCWTG(2,REG09),ALKRPMOD                          02S0619
*       END;                                                    02S0620
*   IF OPCAQFST=0 THEN              /* IF LIST EMPTY                 */
@RC00602 DS    0H                                               02S0621
@RC00595 ICM   @11,7,OPCAQFST(ROPCAVT)                          02S0621
         BNZ   @RF00621                                         02S0621
*     DO;                           /* THEN                          */
*       OPCAQFST=REG09;             /* SET FIRST ELEMENT             */
         STCM  REG09,7,OPCAQFST(ROPCAVT)                        02S0623
*       OPCAQSEC=REG09;             /* SET SECOND SAME               */
         STCM  REG09,7,OPCAQSEC(ROPCAVT)                        02S0624
*     END;                                                      02S0625
*   ELSE                            /* ELSE IF LIST NOT EMPTY        */
*     DO;                           /* THEN                          */
         B     @RC00621                                         02S0626
@RF00621 DS    0H                                               02S0627
*       RFY                                                     02S0627
*         REG06 RSTD;               /* RESTRICT REG                  */
*       REG06=OPCAQSEC;             /* SET LAST ELEMENT PTR          */
         SLR   REG06,REG06                                      02S0628
         ICM   REG06,7,OPCAQSEC(ROPCAVT)                        02S0628
*       REG06->OCELMPTR=REG09;      /* SET LAST ELEM TO POINT TO THIS
*                                      ONE                           */
         STCM  REG09,7,OCELMPTR(REG06)                          02S0629
*       OPCAQSEC=REG09;             /* SET LIST LAST ELEM PTR TO THIS
*                                      ONE                           */
         STCM  REG09,7,OPCAQSEC(ROPCAVT)                        02S0630
*       RFY                                                     02S0631
*         REG06 UNRSTD;             /* RELEASE REG                   */
*     END;                                                      02S0632
*   RFY                                                         02S0633
*     REG09 UNRSTD;                 /* RELEASE REG                   */
@RC00621 DS    0H                                               02S0634
*   RFY                                                         02S0634
*     IEDQOPCE BASED(ROPCE);        /* RESET OPCE BASE               */
*   OCBUFGOT=OCBUFGOT-1;            /* DECREMENT NO OF UNITS HAVE    */
         SLR   @11,@11                                          02S0635
         ICM   @11,3,OCBUFGOT(ROPCE)                            02S0635
         BCTR  @11,0                                            02S0635
         STH   @11,OCBUFGOT(,ROPCE)                             02S0635
*   IF OCBUFGOT=0 THEN              /* IF RUN OUT OF UNITS           */
         LTR   @11,@11                                          02S0636
         BNZ   @RF00636                                         02S0636
*     IF OCBUFNED>0 THEN            /* AND STILL NEED MORE           */
         CLC   OCBUFNED(2,ROPCE),@CH00919                       02S0637
         BNH   @RF00637                                         02S0637
*       OUTFLAG=ON;                 /* SET TO GET OUT                */
         OI    OUTFLAG,B'01000000'                              02S0638
*     ELSE                                                      02S0639
*       ;                                                       02S0639
@RF00637 DS    0H                                               02S0640
*   ELSE                                                        02S0640
*     ;                                                         02S0640
@RF00636 DS    0H                                               02S0641
*   RFY                                                         02S0641
*     REG14 RSTD;                   /* RESTRICT REG                  */
*   REG14=BLDOSAV;                  /* RESET RETURN ADDR             */
         L     REG14,BLDOSAV                                    02S0642
*   RFY                                                         02S0643
*     REG14 UNRSTD;                 /* RELEASE REG                   */
*   END BLDOPCE;                                                02S0644
@EL00003 DS    0H                                               02S0644
@EF00003 DS    0H                                               02S0644
@ER00003 BR    @14                                              02S0644
*                                                               02S0645
*   /*****************************************************************/
*   /*                                                               */
*   /* BLDER: THIS PROC BUILDS THE OPCES FOR THE REQUIRED ACTION     */
*   /*                                                               */
*   /*****************************************************************/
*                                                               02S0645
*BLDER:                                                         02S0645
*   PROC OPTIONS(RETREG,SAVE(14));                              02S0645
BLDER    ST    @14,@SA00004                                     02S0645
*   OPCAQWD=''B;                    /* CLEAR THE SVC LIST            */
         XC    OPCAQWD(12,ROPCAVT),OPCAQWD(ROPCAVT)             02S0646
*   OPCAQREQ=CHAINFLG;              /* SET THE REQUEST CODE          */
         MVI   OPCAQREQ(ROPCAVT),X'B4'                          02S0647
*   CALL HIERLOOP;                  /* AND BUILD THE OPCES           */
         BAL   @14,HIERLOOP                                     02S0648
*   RPARM=ADDR(OPCAQCTL);           /* POINT TO SVC LIST             */
         LA    RPARM,OPCAQCTL(,ROPCAVT)                         02S0649
*   SVC(102);                       /* AND POST THEM                 */
         SVC   102                                              02S0650
*   IF OCBUFNED^=0 THEN             /* IF STILL NEED MORE OPCES TO
*                                      FINISH                        */
         ICM   @11,3,OCBUFNED(ROPCE)                            02S0651
         BZ    @RF00651                                         02S0651
*     DO;                           /* THEN                          */
*       OCWTG=THISMOD;              /* SET RETURN TO THIS MODULE     */
         MVC   OCWTG(2,ROPCE),THISMOD                           02S0653
*       OCREDRVE=ON;                /* TURN ON REDRIVE FLAG          */
         OI    OCREDRVE(ROPCE),B'00010000'                      02S0654
*       OCLINK=OPCBUFWT;            /* PUT OPCE ON REDRIVE CHAIN     */
         MVC   OCLINK(4,ROPCE),OPCBUFWT(ROPCAVT)                02S0655
*       OPCBUFWT=ROPCE;             /* AND WAIT                      */
         ST    ROPCE,OPCBUFWT(,ROPCAVT)                         02S0656
*     END;                                                      02S0657
*   ELSE                            /* ELSE FREE THE REDRIVE OPCE    */
*     DO;                                                       02S0658
         B     @RC00651                                         02S0658
@RF00651 DS    0H                                               02S0659
*       REG00=1;                    /* SET DECR COUNT TO 1           */
         LA    REG00,1                                          02S0659
*       CALL DECRCT;                /* DECREMENT OPCADGOT            */
         L     @15,OPCDECR(,ROPCAVT)                            02S0660
         BALR  @14,@15                                          02S0660
*       RPARM=ROPCE;                /* POINT TO OPCE                 */
         LR    RPARM,ROPCE                                      02S0661
*       CALL FREEBUF;               /* AND FREE IT                   */
         L     @15,OPCFREBF(,ROPCAVT)                           02S0662
         BALR  @14,@15                                          02S0662
*     END;                                                      02S0663
*   OPCMODID=TO00;                  /* SET TO GO TO IGC0010D         */
@RC00651 MVC   OPCMODID(2,ROPCAVT),TO00                         02S0664
*   OUTFLAG=ON;                     /* SET TO GET OUT                */
         OI    OUTFLAG,B'01000000'                              02S0665
*   END BLDER;                                                  02S0666
@EL00004 DS    0H                                               02S0666
@EF00004 DS    0H                                               02S0666
@ER00004 L     @14,@SA00004                                     02S0666
         BR    @14                                              02S0666
*                                                               02S0667
*   /*****************************************************************/
*   /*                                                               */
*   /* PROCESS.GETBUFS: THIS PROCEDURE DETERMINES IF ANY UNITS MAY BE*/
*   /* OBTAINED, AND IF SO, HOW MANY, AND THEN GETS THEM AND ATTACHES*/
*   /* THEM TO THE REDRIVE OPCE                                      */
*   /*                                                               */
*   /*****************************************************************/
*                                                               02S0667
*GETBUFS:                                                       02S0667
*   PROC OPTIONS(RETREG,SAVE(14));                              02S0667
GETBUFS  ST    @14,@SA00005                                     02S0667
*   IF OPCADGOT<HALFUNIT THEN       /* IF ACT/DEACT HAS LT 50%       */
         LH    @11,HALFUNIT                                     02S0668
         SLR   @09,@09                                          02S0668
         ICM   @09,3,OPCADGOT(ROPCAVT)                          02S0668
         CR    @09,@11                                          02S0668
         BNL   @RF00668                                         02S0668
*     DO;                           /* THEN                          */
*       IF(OCBUFNED+OPCADGOT)>HALFUNIT THEN/* IF NO NEED PLUS        */
         SLR   @05,@05                                          02S0670
         ICM   @05,3,OCBUFNED(ROPCE)                            02S0670
         LR    @07,@05                                          02S0670
         ALR   @07,@09                                          02S0670
         CR    @07,@11                                          02S0670
         BNH   @RF00670                                         02S0670
*         DO;                       /* NO A/D ALREADY HAS IS GT 50%
*                                      THEN                          */
*           GETNO=(HALFUNIT-OPCADGOT);/* SET TO GET UP TO 50%        */
         SLR   @11,@09                                          02S0672
         LR    GETNO,@11                                        02S0672
*           OCBUFNED=OCBUFNED-GETNO;/* SET NO STILL NEED =REMAINDER  */
         SLR   @05,GETNO                                        02S0673
         STH   @05,OCBUFNED(,ROPCE)                             02S0673
*         END;                                                  02S0674
*       ELSE                        /* ELSE GET ALL NEEDED           */
*         DO;                                                   02S0675
         B     @RC00670                                         02S0675
@RF00670 DS    0H                                               02S0676
*           GETNO=OCBUFNED;         /* SET TO GET ALL                */
         SLR   GETNO,GETNO                                      02S0676
         ICM   GETNO,3,OCBUFNED(ROPCE)                          02S0676
*           OCBUFNED=0;             /* SET NO STILL NEED=0           */
         SLR   @11,@11                                          02S0677
         STH   @11,OCBUFNED(,ROPCE)                             02S0677
*         END;                                                  02S0678
*       OCBUFGOT=GETNO;             /* SET NO HAVE =NO TO GET        */
@RC00670 STH   GETNO,OCBUFGOT(,ROPCE)                           02S0679
*       OPCADGOT=OPCADGOT+GETNO;    /* INCREMENT OPCADGOT            */
         SLR   @11,@11                                          02S0680
         ICM   @11,3,OPCADGOT(ROPCAVT)                          02S0680
         ALR   @11,GETNO                                        02S0680
         STH   @11,OPCADGOT(,ROPCAVT)                           02S0680
*     END;                                                      02S0681
*   ELSE                            /* ELSE MUST PUT REDRIVE OPCE ON
*                                      WAIT CHAIN AND WAIT FOR       */
*     DO;                           /* AVAILABLE UNITS ON REDRIVE    */
         B     @RC00668                                         02S0682
@RF00668 DS    0H                                               02S0683
*       OPCMODID=TO00;              /* SET TO GO TO IGC0010D @OY20680*/
         MVC   OPCMODID(2,ROPCAVT),TO00                         02S0683
*       OCWTG=THISMOD;              /* SET RETURN TO THIS MODULE     */
         MVC   OCWTG(2,ROPCE),THISMOD                           02S0684
*       OCREDRVE=ON;                /* SET ON REDRIVE FLAG           */
         OI    OCREDRVE(ROPCE),B'00010000'                      02S0685
*       OCLINK=OPCBUFWT;            /* GET CHAIN ANCHOR AND PUT IN
*                                      LINK FIELD                    */
         MVC   OCLINK(4,ROPCE),OPCBUFWT(ROPCAVT)                02S0686
*       OPCBUFWT=ROPCE;             /* CHAIN IN THIS REDRIVE OPCE    */
         ST    ROPCE,OPCBUFWT(,ROPCAVT)                         02S0687
*       OUTFLAG=ON;                 /* SET TO GET OUT                */
         OI    OUTFLAG,B'01000000'                              02S0688
*       GETNO=0;                    /* SET NO TO GET =0              */
         SLR   GETNO,GETNO                                      02S0689
*     END;                                                      02S0690
*   DO WHILE GETNO>0;               /* LOOP TO GET UNITS             */
@RC00668 B     @DE00691                                         02S0691
@DL00691 DS    0H                                               02S0692
*     IF GETNO>255 THEN             /* MUST LOOP IF NEED MORE THAN
*                                      255                           */
         LA    @11,255                                          02S0692
         CR    GETNO,@11                                        02S0692
         BNH   @RF00692                                         02S0692
*       DO;                         /* THEN                          */
*         GETNO=GETNO-255;          /* SUB 255 FROM NO TO GET        */
         SLR   GETNO,@11                                        02S0694
*         RPARM=255;                /* SET FOR REQUEST               */
         LR    RPARM,@11                                        02S0695
*       END;                                                    02S0696
*     ELSE                          /* ELSE NEED ONLY ONE PASS TO GET
*                                      ALL NEEDED                    */
*       DO;                                                     02S0697
         B     @RC00692                                         02S0697
@RF00692 DS    0H                                               02S0698
*         RPARM=GETNO;              /* SET REQUEST VALUE             */
         LR    RPARM,GETNO                                      02S0698
*         GETNO=0;                  /* AND RESET GETNO TO 0          */
         SLR   GETNO,GETNO                                      02S0699
*       END;                                                    02S0700
*     CALL ALLOCBUF;                /* GET BUFF UNITS                */
@RC00692 L     @15,OPCGETBF(,ROPCAVT)                           02S0701
         BALR  @14,@15                                          02S0701
*     RFY                                                       02S0702
*       REG09 RSTD;                 /* RESTRICT WORK REG             */
*     REG09=ROPCE;                  /* SET REG TO POINT TO REDRIVE
*                                      OPCE                          */
         LR    REG09,ROPCE                                      02S0703
*     DO WHILE REG09->TIC=VALTIC;   /* LOOP TO FIND END OF UNIT CHAIN*/
         B     @DE00704                                         02S0704
@DL00704 DS    0H                                               02S0705
*       REG09=REG09->OCUNIT;        /* UPDATE PTR TO NEXT UNIT       */
         L     REG09,OCUNIT(,REG09)                             02S0705
*     END;                          /* AT END OF LOOP REG09 PTS TO
*                                      LAST UNIT OR REDRIVE OPCE     */
@DE00704 TM    TIC(REG09),B'00000011'                           02S0706
         BZ    @DL00704                                         02S0706
*     REG09->OCUNIT=RPARM;          /* ATTACH GOTTEN UNITS           */
         ST    RPARM,OCUNIT(,REG09)                             02S0707
*     RFY                                                       02S0708
*       REG09 UNRSTD;               /* RELEASE REG                   */
*   END;                                                        02S0709
@DE00691 LTR   GETNO,GETNO                                      02S0709
         BP    @DL00691                                         02S0709
*   END GETBUFS;                                                02S0710
@EL00005 DS    0H                                               02S0710
@EF00005 DS    0H                                               02S0710
@ER00005 L     @14,@SA00005                                     02S0710
         BR    @14                                              02S0710
*                                                               02S0711
*   /*****************************************************************/
*   /*                                                               */
*   /* THIS ROUTINE CLEANS UP FROM AN ACTIVATION OF THE NCP BROUGHT  */
*   /* ABOUT BY AN F ACT=NCP. THE IPL'ED FLAG IN THE DEVICE DEPENDENT*/
*   /* FIELDS OF THE NCP IS TURNED OFF IF ACTIVATION DID NOT FAIL    */
*   /* BECAUSE OF A SIB SHORTAGE. IGCFD10D IS LINKED TO TO DELETE THE*/
*   /* HIERARCHY, THE SAT ENTRY FOR THIS NCP, THE NAT ENTRIES, AND TO*/
*   /* FREE THE RVT.                                                 */
*   /*                                                               */
*   /*****************************************************************/
*                                                               02S0711
*CLNUPNCP:                                                      02S0711
*   PROC OPTIONS(RETREG,SAVE(14));                              02S0711
CLNUPNCP ST    @14,@SA00006                                     02S0711
*   IF OCPTRSAV->OCPARM^=SIBSGMSG THEN/* IF NOT SIB SHORTAGE         */
         L     @11,OCPTRSAV(,ROPCE)                             02S0712
         CLC   OCPARM(2,@11),@CH01667                           02S0712
         BE    @RF00712                                         02S0712
*     DO;                                                       02S0713
*       RPARM=OCTRMTBL;             /* SET PARM. WITH NCP TTCIN      */
         SLR   RPARM,RPARM                                      02S0714
         ICM   RPARM,3,OCTRMTBL(ROPCE)                          02S0714
*       CALL NCPDVCDP;              /* OBTAIN DEVICE DEPENDENT FIELDS*/
         BAL   @14,NCPDVCDP                                     02S0715
*       NCPIPLD=OFF;                /* TURN OFF IPL'ED FLAG          */
         NI    NCPIPLD(RTNCODE),B'11110111'                     02S0716
*     END;                                                      02S0717
*   ELSE                                                        02S0718
*     ;                                                         02S0718
@RF00712 DS    0H                                               02S0719
*   OPCCOPCE=OCPTRSAV;              /* MAKE ORIG. OPCE THE CURRENT
*                                      OPCE                          */
         MVC   OPCCOPCE(4,ROPCAVT),OCPTRSAV(ROPCE)              02S0719
*   RPARM=ROPCAVT;                  /* SET ADDR. OF OP. CTL. AVT     */
         LR    RPARM,ROPCAVT                                    02S0720
*   GEN;                                                        02S0721
*          /*
         LINK  EP=IGCFD10D         */
*   END CLNUPNCP;                                               02S0722
@EL00006 DS    0H                                               02S0722
@EF00006 DS    0H                                               02S0722
@ER00006 L     @14,@SA00006                                     02S0722
         BR    @14                                              02S0722
*                                                               02S0723
*   /*****************************************************************/
*   /*                                                               */
*   /* THIS ROUTINE HANDLES THE TERMINATION OF NCP ACTIVATION IF THE */
*   /* ACTIVATION ENDS IN THIS MODULE (IE. IF CASCADING IS NOT       */
*   /* PERFORMED. THE ORIG. (F ACT) OPCE IS SET AS CURRENT, THE      */
*   /* PREVIOUS CURRENT OPCE IS FREED (ALONG WITH ANY ATTACHED RU),  */
*   /* OPCADGOT IS DECREMENTED, THE IN-PROGRESS BITS TURNED OFF, THE */
*   /* COMP. CODE IS SET IN R0, AND THE OPCMODID IS SET WITH THE     */
*   /* APPROPRIATE MOD. ID                                           */
*   /*                                                               */
*   /*****************************************************************/
*                                                               02S0723
*TERMPROC:                                                      02S0723
*   PROC OPTIONS(RETREG,SAVE(14));                              02S0723
TERMPROC ST    @14,@SA00007                                     02S0723
*   RPARM=ROPCE;                    /* ADDR. OF OPCE TO BE FREED     */
         LR    RPARM,ROPCE                                      02S0724
*   CALL FREEBUF;                   /* FREE BUFFER AND RU (IF ANY)   */
         L     @15,OPCFREBF(,ROPCAVT)                           02S0725
         BALR  @14,@15                                          02S0725
*   RZERO=1;                        /* NUMBER OF A/D UNITS FREED     */
         LA    RZERO,1                                          02S0726
*   CALL DECRCT;                    /* DECREMENT OPCADGOT, START
*                                      REDRIVE                       */
         L     @15,OPCDECR(,ROPCAVT)                            02S0727
         BALR  @14,@15                                          02S0727
*   RZERO=TOFFINPG;                 /* TURN OFF IN-PROG BITS AND ....*/
         SLR   RZERO,RZERO                                      02S0728
*   RPARM=OPCCOPCE;                 /* .... REMOVE ORIG. OPCE ....   */
         L     RPARM,OPCCOPCE(,ROPCAVT)                         02S0729
*   CALL PROGRTNE;                  /* .... FROM A/D WAIT CHAIN      */
         L     @15,OPCPGCK(,ROPCAVT)                            02S0730
         BALR  @14,@15                                          02S0730
*   ROPCE=OPCCOPCE;                 /* SET OPCE BASE TO CURRENT OPCE
*                                      WHICH IS ORIG.                */
         L     ROPCE,OPCCOPCE(,ROPCAVT)                         02S0731
*   RZERO=OCPARM;                   /* SET REG. 0 WITH COMP. CODE    */
         LH    RZERO,OCPARM(,ROPCE)                             02S0732
*   IF OCWTG^=0 THEN                                            02S0733
         ICM   @11,3,OCWTG(ROPCE)                               02S0733
         BZ    @RF00733                                         02S0733
*     DO;                                                       02S0734
*       OPCMODID=OCWTG;             /* SET TO RETURN TO CALLER       */
         MVC   OPCMODID(2,ROPCAVT),OCWTG(ROPCE)                 02S0735
*       OCWTG=''B;                  /* REINITIALIZE                  */
         XC    OCWTG(2,ROPCE),OCWTG(ROPCE)                      02S0736
*     END;                                                      02S0737
*   ELSE                                                        02S0738
*     IF OCTOTE=ON THEN             /* IF TOTE ENTERED COMMAND       */
         B     @RC00733                                         02S0738
@RF00733 TM    OCTOTE(ROPCE),B'01000000'                        02S0738
         BNO   @RF00738                                         02S0738
*       DO;                                                     02S0739
*         OPCMODID=OUTPTMOD;        /* SET TO XCTL TO OUTPUT WRITER  */
         MVC   OPCMODID(2,ROPCAVT),OUTPTMOD                     02S0740
*         IF RZERO=GOODMSG THEN     /* IF SUCCESSFUL                 */
         CH    RZERO,@CH01663                                   02S0741
         BNE   @RF00741                                         02S0741
*           RZERO=TOTEGOOD;         /* GOOD RETURN CODE FOR TOTE     */
         SLR   RZERO,RZERO                                      02S0742
*         ELSE                                                  02S0743
*           RZERO=TOTEBAD;          /* BAD RETURN CODE FOR TOTE      */
         B     @RC00741                                         02S0743
@RF00741 LA    RZERO,4                                          02S0743
*       END;                                                    02S0744
*     ELSE                                                      02S0745
*       IF RZERO=GOODMSG THEN       /* IF GOOD RETURN CODE           */
         B     @RC00738                                         02S0745
@RF00738 CH    RZERO,@CH01663                                   02S0745
         BNE   @RF00745                                         02S0745
*         DO;                                                   02S0746
*           OPCMODID=OPCKPMOD;      /* SET TO XCTL TO OP. CTL CKPT.  */
         MVC   OPCMODID(2,ROPCAVT),OPCKPMOD                     02S0747
*           OCWTG=MSGMOD0D;         /* SET TO GO TO MSG. MOD. AFTER
*                                      CHECK POINT.                  */
         MVC   OCWTG(2,ROPCE),MSGMOD0D                          02S0748
*         END;                                                  02S0749
*       ELSE                                                    02S0750
*         IF RZERO^=IPLRQMSG THEN   /* IF NOT IPL REQ'ED             */
         B     @RC00745                                         02S0750
@RF00745 CH    RZERO,@CH01665                                   02S0750
         BE    @RF00750                                         02S0750
*           OPCMODID=MSGMOD0H;      /* SET TO XCTL TO IGC0H10D       */
         MVC   OPCMODID(2,ROPCAVT),MSGMOD0H                     02S0751
*         ELSE                                                  02S0752
*           OPCMODID=MSGMOD0C;      /* SET TO XCTL TO IGC0C10D  02S0752
*                                                            @YM07763*/
         B     @RC00750                                         02S0752
@RF00750 MVC   OPCMODID(2,ROPCAVT),MSGMOD0C                     02S0752
*   END TERMPROC;                                               02S0753
@EL00007 DS    0H                                               02S0753
@EF00007 DS    0H                                               02S0753
@ER00007 L     @14,@SA00007                                     02S0753
         BR    @14                                              02S0753
*                                                               02S0754
*   /*****************************************************************/
*   /*                                                               */
*   /* THIS ROUTINE TAKES THE TTCIN CONTAINED IN RPARM AND RETURNS   */
*   /* THE ADDR. OF THE DEVICE DEPENDENT FIELDS FOR THE RESOURCE IN  */
*   /* RTNCODE (R15). ALSO, RTRM IS SET TO POINT TO THE TTE ADDR.    */
*   /*                                                               */
*   /*****************************************************************/
*                                                               02S0754
*NCPDVCDP:                                                      02S0754
*   PROC OPTIONS(RETREG,SAVE(14));                              02S0754
NCPDVCDP ST    @14,@SA00008                                     02S0754
*   CALL IEDQTNT;                   /* OBTAIN TTE ADDR.              */
         L     @15,AVTRNMPT(,RAVT)                              02S0755
         BALR  @14,@15                                          02S0755
*   RTRM=RPARM;                     /* COPY TTE ADDR.                */
         LR    RTRM,RPARM                                       02S0756
*   RZERO=TRMNCPIM;                 /* SET UP MASK                   */
         LA    RZERO,8                                          02S0757
*   CALL IEDQTL;                    /* OBTAIN ADDR. OF DEVICE   02S0758
*                                      DEPENDENT FIELDS              */
         L     @15,AVTDDFT(,RAVT)                               02S0758
         BALR  @14,@15                                          02S0758
*   END NCPDVCDP;                                               02S0759
@EL00008 DS    0H                                               02S0759
@EF00008 DS    0H                                               02S0759
@ER00008 L     @14,@SA00008                                     02S0759
         BR    @14                                              02S0759
*   END IGCFJ10D                                                01S0760
*                                                               01S0760
*/* THE FOLLOWING INCLUDE STATEMENTS WERE FOUND IN THIS PROGRAM.     */
*/*%INCLUDE SYSLIB  (TAVTD   )                                       */
*/*%INCLUDE SYSLIB  (IHADCBDF)                                       */
*/*%INCLUDE SYSLIB  (IHADCB  )                                       */
*/*%INCLUDE SYSLIB  (TNCPID  )                                       */
*/*%INCLUDE SYSLIB  (TOPCED  )                                       */
*/*%INCLUDE SYSLIB  (TOPCAVTD)                                       */
*/*%INCLUDE SYSLIB  (TOPRED  )                                       */
*/*%INCLUDE SYSLIB  (TPRIOR  )                                       */
*/*%INCLUDE SYSLIB  (TPRUD   )                                       */
*/*%INCLUDE SYSLIB  (TTNTD   )                                       */
*/*%INCLUDE SYSLIB  (TTRMD   )                                       */
*/*%INCLUDE SYSUT5  (RFY     )                                       */
*/*%INCLUDE SYSUT5  (DCL     )                                       */
*/*%INCLUDE SYSUT5  (PROLOGUE)                                       */
*/*%INCLUDE SYSUT5  (PROCESS )                                       */
*/*%INCLUDE SYSUT5  (INITIAL )                                       */
*/*%INCLUDE SYSUT5  (MAINSEG )                                       */
*/*%INCLUDE SYSUT5  (SETCVR  )                                       */
*/*%INCLUDE SYSUT5  (DACTCHK )                                       */
*/*%INCLUDE SYSUT5  (ACTNCPR )                                       */
*/*%INCLUDE SYSUT5  (ACTLINK )                                       */
*/*%INCLUDE SYSUT5  (NOTRST  )                                       */
*/*%INCLUDE SYSUT5  (DACTLKRD)                                       */
*/*%INCLUDE SYSUT5  (ACTLNKRD)                                       */
*/*%INCLUDE SYSUT5  (EPILOGUE)                                       */
*/*%INCLUDE SYSUT5  (HIERLOOP)                                       */
*/*%INCLUDE SYSUT5  (ACTION  )                                       */
*/*%INCLUDE SYSUT5  (BLDOPCE )                                       */
*/*%INCLUDE SYSUT5  (BLDER   )                                       */
*/*%INCLUDE SYSUT5  (GETBUFS )                                       */
*/*%INCLUDE SYSUT5  (CLNUPNCP)                                       */
*/*%INCLUDE SYSUT5  (TERMPROC)                                       */
*/*%INCLUDE SYSUT5  (NCPDVCDP)                                       */
*                                                               01S0760
*       ;                                                       01S0760
@DATA    DS    0H
@CH00919 DC    H'0'
@CH00047 DC    H'8'
@CH01700 DC    H'14'
@CH01663 DC    H'382'
@CH01665 DC    H'416'
@CH01667 DC    H'531'
@CH01669 DC    H'532'
@CH01069 DC    H'-2'
@CH01067 DC    H'-1'
@SM01734 MVC   OCBACKUP(0,REG09),NAME(RPARM)
@DATD    DSECT
         DS    0F
@SA00008 DS    1F
@SA00007 DS    1F
@SA00002 DS    1F
@SA00005 DS    1F
@SA00004 DS    1F
@SA00006 DS    1F
IGCFJ10D CSECT
         DS    0F
@CF00063 DC    F'1'
@CF00067 DC    F'2'
@CH00067 EQU   @CF00067+2
@CF00076 DC    F'3'
@CF00257 DC    F'4'
@CH00257 EQU   @CF00257+2
@CF00165 DC    F'5'
@CH00165 EQU   @CF00165+2
@CF00061 DC    F'6'
@CF01732 DC    F'-12'
@CF01733 DC    F'-10'
@CF01071 DC    F'-3'
@CH01071 EQU   @CF01071+2
@CF01412 DC    XL4'08000002'
@DATD    DSECT
         DS    0D
BLDOSAV  DS    A
FLAGS    DS    FL4
         ORG   FLAGS
FINIFLAG DS    BL1
OUTFLAG  EQU   FLAGS+0
         ORG   FLAGS+4
ACTFLAG  DS    F
HALFUNIT DS    H
         ORG   *+1-(*-@DATD)/(*-@DATD) INSURE DSECT DATA
@ENDDATD EQU   *
IGCFJ10D CSECT
         NOPR  ((@ENDDATD-@DATD)/561*16)
         DS    0F
@SIZDATD DC    AL1(0)
         DC    AL3(@ENDDATD-@DATD)
         DS    0D
ADPATCH  DC    XL104'0'
TO00     DC    CL2'00'
SSCPMOD  DC    CL2'A0'
MSGMOD0H DC    CL2'0H'
MSGMOD0C DC    CL2'0C'
MSGMOD0D DC    CL2'0D'
OPCKPMOD DC    CL2'06'
ADCKPMOD DC    CL2'FF'
OUTPTMOD DC    CL2'07'
NEXTMOD  DC    CL2'FL'
ALKRPMOD DC    CL2'FE'
THISMOD  DC    CL2'FJ'
@00      EQU   00                      EQUATES FOR REGISTERS 0-15
@01      EQU   01
@02      EQU   02
@03      EQU   03
@04      EQU   04
@05      EQU   05
@06      EQU   06
@07      EQU   07
@08      EQU   08
@09      EQU   09
@10      EQU   10
@11      EQU   11
@12      EQU   12
@13      EQU   13
@14      EQU   14
@15      EQU   15
GETNO    EQU   @06
IEDQAPTR EQU   @04
ROPCE    EQU   @03
ROPCAVT  EQU   @02
IEDPRUQP EQU   @03
IEDQTPTR EQU   @08
RAVT     EQU   @04
RTRM     EQU   @08
RTNCODE  EQU   @15
REG00    EQU   @00
RZERO    EQU   @00
REG01    EQU   @01
RPARM    EQU   @01
REG06    EQU   @06
REG09    EQU   @09
REG10    EQU   @10
RWRKAREA EQU   @10
RBASE    EQU   @12
RSAVE    EQU   @13
REG14    EQU   @14
RRET     EQU   @14
REG15    EQU   @15
RBRNCH   EQU   @15
RCL14SAV EQU   @11
REG02    EQU   @02
REG03    EQU   @03
REG04    EQU   @04
REG05    EQU   @05
REG07    EQU   @07
REG08    EQU   @08
REG11    EQU   @11
REG12    EQU   @12
REG13    EQU   @13
ROPRE    EQU   @03
IEDQAVTD EQU   0
AVTSAVEX EQU   IEDQAVTD+288
AVTREADD EQU   IEDQAVTD+380
AVTBUFSW EQU   IEDQAVTD+384
@NM00004 EQU   IEDQAVTD+388
AVTCKFLG EQU   @NM00004
AVTBASE  EQU   IEDQAVTD+412
AVTPKF   EQU   AVTBASE
AVTRNMPT EQU   IEDQAVTD+424
AVTNOLBF EQU   IEDQAVTD+454
AVTOSECB EQU   IEDQAVTD+492
AVTECB1  EQU   AVTOSECB
AVTHG02  EQU   IEDQAVTD+528
AVTDISP  EQU   IEDQAVTD+552
AVTHD    EQU   IEDQAVTD+556
AVTSCOPT EQU   AVTHD
AVTSAVTP EQU   IEDQAVTD+612
AVTSAVTF EQU   AVTSAVTP
AVTCKPEL EQU   IEDQAVTD+652
AVTCKRMV EQU   AVTCKPEL
AVTCKELF EQU   IEDQAVTD+680
AVTCKBYT EQU   IEDQAVTD+691
AVTHG01  EQU   IEDQAVTD+692
AVTCKLNK EQU   IEDQAVTD+696
AVTCRELE EQU   IEDQAVTD+708
AVTCCELE EQU   AVTCRELE
AVTCLRHI EQU   IEDQAVTD+716
AVTADBUF EQU   IEDQAVTD+720
AVTSYSER EQU   IEDQAVTD+728
AVTBFRFG EQU   IEDQAVTD+784
AVTCKPQB EQU   IEDQAVTD+804
AVTCKPTB EQU   AVTCKPQB
AVTCKPEC EQU   AVTCKPQB+4
AVTCKPCC EQU   AVTCKPEC
AVTOPCQB EQU   IEDQAVTD+816
AVTOPCOB EQU   AVTOPCQB
AVTOPCEC EQU   AVTOPCQB+4
AVTOPCCC EQU   AVTOPCEC
AVTOLTQB EQU   IEDQAVTD+828
AVTCWFL1 EQU   IEDQAVTD+924
AVTCWFL2 EQU   IEDQAVTD+925
AVTSUBT  EQU   IEDQAVTD+948
AVTIOTR  EQU   IEDQAVTD+949
AVTBIT1  EQU   IEDQAVTD+1050
AVTBIT2  EQU   IEDQAVTD+1051
AVTBIT3  EQU   IEDQAVTD+1052
AVTDDFT  EQU   IEDQAVTD+1064
AVTBIT4  EQU   IEDQAVTD+1136
@NM00086 EQU   IEDQAVTD+1232
IEDNSVTD EQU   0
SAVTDIAG EQU   IEDNSVTD
SAVTDIAF EQU   SAVTDIAG
SAVTLUSQ EQU   IEDNSVTD+88
SAVTTCPU EQU   IEDNSVTD+238
SAVTZELM EQU   IEDNSVTD+270
SAVTRDRV EQU   IEDNSVTD+284
SAVTCKQB EQU   IEDNSVTD+300
SAVTCKTB EQU   SAVTCKQB
SAVTCKEC EQU   SAVTCKQB+4
SAVTCKCC EQU   SAVTCKEC
IHADCB   EQU   0
IHADCS16 EQU   0
DCBMHA   EQU   IHADCS16
DCBBUFOU EQU   DCBMHA
DCBBUFIN EQU   DCBBUFOU
DCBPCI   EQU   IHADCS16+5
DCBDSORG EQU   IHADCS16+6
DCBDSRG1 EQU   DCBDSORG
DCBDSRG2 EQU   DCBDSORG+1
IHADCS17 EQU   0
DCBCLPS  EQU   IHADCS17
DCBIOBAD EQU   IHADCS17+8
IHADCS18 EQU   0
DCBTRANA EQU   IHADCS18
IHADCS19 EQU   0
DCBLCBAD EQU   IHADCS19
DCBCPRI  EQU   DCBLCBAD
DCBEXLST EQU   IHADCS19+4
IHADCS24 EQU   0
DCBOFLGS EQU   IHADCS24+8
DCBOFLWR EQU   DCBOFLGS
DCBOFOPN EQU   DCBOFLGS
DCBIFLG  EQU   IHADCS24+9
DCBIBPCT EQU   DCBIFLG
DCBMACR  EQU   IHADCS24+10
DCBMACR1 EQU   DCBMACR
DCBMRFE  EQU   DCBMACR1
DCBMRGET EQU   DCBMRFE
DCBMRAPG EQU   DCBMACR1
DCBMRRD  EQU   DCBMRAPG
DCBMRCI  EQU   DCBMACR1
DCBMRMVG EQU   DCBMRCI
DCBMRLCG EQU   DCBMACR1
DCBMRABC EQU   DCBMACR1
DCBMRPT1 EQU   DCBMRABC
DCBMRSBG EQU   DCBMRPT1
DCBMRCRL EQU   DCBMACR1
DCBMRCHK EQU   DCBMRCRL
DCBMRRDX EQU   DCBMRCHK
DCBMRDMG EQU   DCBMACR1
DCBMACR2 EQU   DCBMACR+1
DCBMRPUT EQU   DCBMACR2
DCBMRWRT EQU   DCBMACR2
DCBMRMVP EQU   DCBMACR2
DCBMR5WD EQU   DCBMACR2
DCBMRLDM EQU   DCBMR5WD
DCBMRLCP EQU   DCBMRLDM
DCBMR4WD EQU   DCBMACR2
DCBMRPT2 EQU   DCBMR4WD
DCBMRTMD EQU   DCBMRPT2
DCBMR3WD EQU   DCBMACR2
DCBMRCTL EQU   DCBMR3WD
DCBMRSTK EQU   DCBMRCTL
DCBMR1WD EQU   DCBMACR2
DCBMRSWA EQU   DCBMR1WD
DCBMRDMD EQU   DCBMRSWA
IHADCS25 EQU   0
DCBMACRF EQU   IHADCS25+2
DCBMACF1 EQU   DCBMACRF
DCBMFFE  EQU   DCBMACF1
DCBMFGET EQU   DCBMFFE
DCBMFAPG EQU   DCBMACF1
DCBMFRD  EQU   DCBMFAPG
DCBMFCI  EQU   DCBMACF1
DCBMFMVG EQU   DCBMFCI
DCBMFLCG EQU   DCBMACF1
DCBMFABC EQU   DCBMACF1
DCBMFPT1 EQU   DCBMFABC
DCBMFSBG EQU   DCBMFPT1
DCBMFCRL EQU   DCBMACF1
DCBMFCHK EQU   DCBMFCRL
DCBMFDMG EQU   DCBMACF1
DCBMACF2 EQU   DCBMACRF+1
DCBMFPUT EQU   DCBMACF2
DCBMFWRT EQU   DCBMACF2
DCBMFMVP EQU   DCBMACF2
DCBMF5WD EQU   DCBMACF2
DCBMFLDM EQU   DCBMF5WD
DCBMFLCP EQU   DCBMFLDM
DCBMF4WD EQU   DCBMACF2
DCBMFPT2 EQU   DCBMF4WD
DCBMFTMD EQU   DCBMFPT2
DCBMF3WD EQU   DCBMACF2
DCBMFCTL EQU   DCBMF3WD
DCBMFSTK EQU   DCBMFCTL
DCBMF1WD EQU   DCBMACF2
DCBMFSWA EQU   DCBMF1WD
DCBMFDMD EQU   DCBMFSWA
DCBDEBAD EQU   IHADCS25+4
DCBIFLGS EQU   DCBDEBAD
DCBIFPCT EQU   DCBIFLGS
IHADCS43 EQU   0
DCBSCTAB EQU   IHADCS43
IHADCS2A EQU   0
DCBRESER EQU   IHADCS2A
DCBINVLI EQU   IHADCS2A+4
DCBINVCI EQU   DCBINVLI
IEDNCP   EQU   0
NCPFLAG1 EQU   IEDNCP+1
NCPREST  EQU   NCPFLAG1
NCPIPLD  EQU   NCPFLAG1
NCPCKPT  EQU   IEDNCP+22
IEDQOPCE EQU   0
OCLINK   EQU   IEDQOPCE
OCELEM   EQU   IEDQOPCE+4
OCELMPRI EQU   OCELEM
OCELMPTR EQU   OCELEM+1
OCUNIT   EQU   IEDQOPCE+8
OCRUDEST EQU   OCUNIT
OCCKPKEY EQU   OCRUDEST
OCSCAN   EQU   OCCKPKEY
OCOPTCDE EQU   IEDQOPCE+12
OCPRIFLG EQU   OCOPTCDE
OCSWITCH EQU   IEDQOPCE+13
OCFLAG   EQU   IEDQOPCE+14
OCTOTE   EQU   OCFLAG
OCRESP   EQU   OCFLAG
@NM00128 EQU   IEDQOPCE+16
OCDEST   EQU   @NM00128
OCREQVAL EQU   OCDEST+1
OCTRMTBL EQU   IEDQOPCE+20
OCLINENO EQU   IEDQOPCE+22
OCTIOT   EQU   OCLINENO
OCTRUNIT EQU   IEDQOPCE+24
OCRSID   EQU   OCTRUNIT
OCALSTAT EQU   OCRSID
OCREDRVE EQU   OCALSTAT
OCACTREQ EQU   OCALSTAT
OCPARM   EQU   IEDQOPCE+28
OCWTG    EQU   IEDQOPCE+30
OCBACKUP EQU   IEDQOPCE+32
OCBUFNED EQU   OCBACKUP
OCBUFGOT EQU   OCBACKUP+2
OCMODNME EQU   IEDQOPCE+40
OCIPLWA  EQU   OCMODNME
OCPTRSAV EQU   OCMODNME+4
OCCKDATA EQU   IEDQOPCE+48
OCRSTGTM EQU   OCCKDATA
IEDQOPCN EQU   0
OCLDNME  EQU   IEDQOPCN
OCLINTTE EQU   OCLDNME
OCRESPCT EQU   OCLINTTE
OCREQFLG EQU   OCLINTTE+2
OCIDLE   EQU   OCREQFLG
OCPREFLG EQU   OCLINTTE+3
IEDQOPCD EQU   0
OPCAVTPT EQU   IEDQOPCD+8
OPCCOPCE EQU   IEDQOPCD+12
OPCPGCK  EQU   IEDQOPCD+40
OPCTNTEA EQU   IEDQOPCD+44
OPCSAVE  EQU   IEDQOPCD+56
OPCWORK  EQU   IEDQOPCD+140
OPCAQCTL EQU   IEDQOPCD+180
OPCXCTL  EQU   IEDQOPCD+204
OPCLDNME EQU   IEDQOPCD+212
OPCMODID EQU   OPCLDNME+3
OPCHORTG EQU   IEDQOPCD+260
OPCGETBF EQU   IEDQOPCD+276
OPCFREBF EQU   IEDQOPCD+280
OPCSPEC  EQU   IEDQOPCD+300
OPCADGOT EQU   IEDQOPCD+318
OPCBUFWT EQU   IEDQOPCD+348
OPCDECR  EQU   IEDQOPCD+352
OPCPWCOB EQU   IEDQOPCD+368
OPCPWQCB EQU   OPCPWCOB
OPCPWECB EQU   OPCPWCOB+4
IEDOPRED EQU   0
OPRESAVE EQU   IEDOPRED+8
OPREFLG3 EQU   IEDOPRED+14
IEDPRUQD EQU   0
PRUTIC   EQU   IEDPRUQD+8
IEDPRUND EQU   0
PRURHTH  EQU   IEDPRUND
PRURH    EQU   PRURHTH
PRURHFG0 EQU   PRURH
PRURHFG1 EQU   PRURH+1
PRURHFG2 EQU   PRURH+2
PRUTH    EQU   PRURHTH+3
PRUFIDN  EQU   PRUTH
IEDQTNTD EQU   0
IEDQTCDE EQU   IEDQTNTD
TNTENLEN EQU   IEDQTNTD+40
IEDQTDCE EQU   IEDQTNTD+46
IEDTNTA  EQU   0
IEDQTRM  EQU   0
TRMSTATE EQU   IEDQTRM
TRMLOG   EQU   TRMSTATE
TRMINSEQ EQU   IEDQTRM+4
TLISTCNT EQU   TRMINSEQ
TRMOUTSQ EQU   IEDQTRM+6
TLISTEN  EQU   TRMOUTSQ
TRMDSORG EQU   TLISTEN
TRMALTD  EQU   IEDQTRM+8
TRMDEVFL EQU   IEDQTRM+10
TRMSTAT  EQU   IEDQTRM+12
IEDNTRM  EQU   0
TRMBYTE4 EQU   IEDNTRM
TRMBYTE3 EQU   IEDNTRM+1
TRMBYTE2 EQU   IEDNTRM+2
TRMREMB  EQU   TRMBYTE2
TRMINPG  EQU   TRMBYTE2
TRMBYTE1 EQU   IEDNTRM+3
TRMSCPRQ EQU   TRMBYTE1
TRMCOHRT EQU   IEDNTRM+4
TRMBYTE0 EQU   IEDNTRM+6
TRMSIBPT EQU   IEDNTRM+7
TRMTYPE  EQU   IEDNTRM+11
TRMSUBST EQU   IEDNTRM+12
NAME     EQU   0
ALLOCBUF EQU   0
TNTENTAD EQU   0
CHORTGLK EQU   0
DECRCT   EQU   0
FREEBUF  EQU   0
IEDQTNT  EQU   0
PROGRTNE EQU   0
IEDQTL   EQU   0
TNTCODE  EQU   0
TNTDCODE EQU   0
TNTFIRST EQU   0
DCBPTR   EQU   NCPCKPT
OCCKPKY1 EQU   OCCKPKEY
OCCKPTYP EQU   OCCKPKY1
OCICACTN EQU   OCMODNME
OCICDADR EQU   OCICACTN
OCICSW   EQU   OCICDADR+3
OPCAQWD  EQU   OPCAQCTL
OPCAQWD1 EQU   OPCAQWD
OPCAQREQ EQU   OPCAQWD1
OPCAQFST EQU   OPCAQWD1+1
OPCAQWD2 EQU   OPCAQWD+4
OPCAQSEC EQU   OPCAQWD2+1
OPCAQWD3 EQU   OPCAQWD+8
IEDQNPTR EQU   AVTRNMPT
TRMPRE1  EQU   TRMBYTE4
TRMNCP1  EQU   TRMBYTE4
TRMPRE   EQU   TRMBYTE3
TRMNCP   EQU   TRMBYTE3
TRMPU    EQU   TRMBYTE3
TRMLU    EQU   TRMBYTE3
TRMLINK  EQU   TRMBYTE3
TICFLD   EQU   OCUNIT
TIC      EQU   TICFLD+3
OCCIB    EQU   OCREQVAL
TRMOPT   EQU   IEDQTRM+20
         AGO   .@UNREFD                START UNREFERENCED COMPONENTS
@NM00168 EQU   TICFLD
@NM00167 EQU   TRMLINK
TRMLSTAT EQU   TRMLINK
TRMLINT  EQU   TRMLINK
TRMEPMOD EQU   TRMLINK
TRMLULOG EQU   TRMLU
TRMINERR EQU   TRMLU
TRMLUREQ EQU   TRMLU
TRMSESRQ EQU   TRMLU
TRMTDIFF EQU   TRMLU
TRMLUTM  EQU   TRMLU
TRMLUIT  EQU   TRMLU
TRMAUTO  EQU   TRMLU
TRMPCONT EQU   TRMPU
@NM00166 EQU   TRMPU
TRMNCONT EQU   TRMNCP
TRMQUCKN EQU   TRMNCP
TRMSLOWN EQU   TRMNCP
TRMSYGEN EQU   TRMNCP
TRMNCPCL EQU   TRMNCP
TRMIPLDM EQU   TRMNCP
TRMINOUT EQU   TRMPRE
TRMRDOUT EQU   TRMPRE
TRMNLOUT EQU   TRMPRE
TRMWROUT EQU   TRMPRE
TRMASNXI EQU   TRMPRE
TRMSTMM  EQU   TRMPRE
TRMCMODE EQU   TRMPRE
TRMSTPND EQU   TRMPRE
@NM00165 EQU   TRMNCP1
TRMINOP  EQU   TRMNCP1
TRMLYNCH EQU   TRMPRE1
TRMSPOUT EQU   TRMPRE1
TRMERLCK EQU   TRMPRE1
TRMQNPL  EQU   TRMPRE1
TRMSPACT EQU   TRMPRE1
TRMOCNI  EQU   TRMPRE1
TRMSESSN EQU   TRMPRE1
TRMCONT  EQU   TRMPRE1
OPCAQLST EQU   OPCAQWD3+1
OPCAQRQ3 EQU   OPCAQWD3
OPCAQRQ2 EQU   OPCAQWD2
OCICINAC EQU   OCICSW
@NM00133 EQU   OCICSW
OCICATST EQU   OCICDADR+1
OCICTYPE EQU   OCICDADR
@NM00132 EQU   OCCKPKY1
OCCKPENV EQU   OCCKPKY1
OCCKPRST EQU   OCCKPTYP
OCCKPNCP EQU   OCCKPTYP
OCCKPINC EQU   OCCKPTYP
TRMRLMCT EQU   IEDNTRM+10
TRMCOHTG EQU   TRMSIBPT+1
TRMGPCNT EQU   TRMSIBPT
TRMBUFRD EQU   TRMBYTE0
TRMSNA   EQU   TRMBYTE0
TRMGP    EQU   TRMBYTE0
TRMDIAL  EQU   TRMBYTE0
@NM00164 EQU   TRMBYTE0
TRMOUTPT EQU   TRMBYTE0
TRMINPUT EQU   TRMBYTE0
TRMUDEF  EQU   TRMBYTE0
TRMSTOTE EQU   TRMBYTE1
TRMCKPRN EQU   TRMBYTE1
TRMTSATN EQU   TRMBYTE1
TRMTRACE EQU   TRMBYTE1
TRMSWBCK EQU   TRMBYTE1
TRMAUTOC EQU   TRMBYTE1
TRMINPTP EQU   TRMBYTE1
TRMWTNEG EQU   TRMSCPRQ
TRMWRBRK EQU   TRMBYTE2
TRMNOSND EQU   TRMBYTE2
TRMPREP  EQU   TRMBYTE2
TRMGPACT EQU   TRMBYTE2
TRMANDL  EQU   TRMBYTE2
TRMCLOSN EQU   TRMINPG
TRMRSACT EQU   TRMBYTE2
TRMOPTBL EQU   IEDQTRM+18
TRMOPNO  EQU   IEDQTRM+17
TRMCHCIN EQU   IEDQTRM+16
TRMSENSE EQU   TRMSTAT+3
TRMTEMPR EQU   TRMSTAT+2
TRMSIO   EQU   TRMSTAT
@NM00163 EQU   TRMDEVFL+1
TRMTPIN  EQU   TRMDEVFL+1
TRMNCPI  EQU   TRMDEVFL+1
TRMRNTRM EQU   TRMDEVFL+1
@NM00162 EQU   TRMDEVFL+1
TRMLMD   EQU   TRMDEVFL+1
TRMCONC  EQU   TRMDEVFL+1
TRMTSOB  EQU   TRMDEVFL
TRMBFDY  EQU   TRMDEVFL
TRMTBLK  EQU   TRMDEVFL
TRMSBLK  EQU   TRMDEVFL
TRMBLKS  EQU   TRMDEVFL
TRMADDC  EQU   TRMDEVFL
TRMDDIG  EQU   TRMDEVFL
TRMBUFS  EQU   TRMDEVFL
TRMPRILK EQU   TRMALTD
TRMLGB   EQU   TRMDSORG
TRMUTERM EQU   TLISTCNT
TRMDESTQ EQU   IEDQTRM+1
TRMSCNYN EQU   TRMSTATE
TRMOPTFN EQU   TRMSTATE
TRMHELDN EQU   TRMSTATE
TRMACPTN EQU   TRMSTATE
TRMPREF  EQU   TRMSTATE
TRMPROC  EQU   TRMLOG
TRMLIST  EQU   TRMLOG
TRMLINE  EQU   TRMSTATE
TNTTRMAD EQU   IEDTNTA
TNTLEN   EQU   IEDQTNTD+44
TNTMIDEN EQU   IEDQTNTD+41
TNTSRCHX EQU   IEDQTNTD+38
@NM00161 EQU   IEDPRUND+4
PRUTHEFI EQU   PRUFIDN
PRUTHUSS EQU   PRUFIDN
PRUTHEIU EQU   PRUFIDN
PRUTHBIU EQU   PRUFIDN
PRUTHTYE EQU   PRUFIDN
@NM00160 EQU   PRURHFG2
PRURHCSI EQU   PRURHFG2
@NM00159 EQU   PRURHFG2
PRURHCDI EQU   PRURHFG2
PRURHEB  EQU   PRURHFG2
PRURHBB  EQU   PRURHFG2
PRURHPI  EQU   PRURHFG1
@NM00158 EQU   PRURHFG1
PRURHER  EQU   PRURHFG1
PRURHDR2 EQU   PRURHFG1
@NM00157 EQU   PRURHFG1
PRURHDR1 EQU   PRURHFG1
PRURHEC  EQU   PRURHFG0
PRURHBC  EQU   PRURHFG0
PRURHSDI EQU   PRURHFG0
PRURHFI  EQU   PRURHFG0
@NM00156 EQU   PRURHFG0
PRURUCAT EQU   PRURHFG0
PRURHTYP EQU   PRURHFG0
PRUDATA  EQU   IEDPRUQD+12
PRUNUNIT EQU   PRUTIC+1
@NM00155 EQU   PRUTIC
@NM00154 EQU   IEDPRUQD+4
PRUDATCT EQU   IEDPRUQD+2
PRUTTCIN EQU   IEDPRUQD
@NM00153 EQU   OPREFLG3
OPREATCH EQU   OPREFLG3
@NM00152 EQU   OPREFLG3
OPREFLG2 EQU   IEDOPRED+13
OPREFLG1 EQU   IEDOPRED+12
OPRETIC  EQU   OPRESAVE
OPRELINK EQU   IEDOPRED+5
OPREPRI  EQU   IEDOPRED+4
OPREQCB  EQU   IEDOPRED+1
OPREKEY  EQU   IEDOPRED
OPCBOTTM EQU   IEDQOPCD+1188
OPCDSRWT EQU   IEDQOPCD+1184
@NM00151 EQU   IEDQOPCD+1100
@NM00150 EQU   IEDQOPCD+948
@NM00149 EQU   IEDQOPCD+940
@NM00148 EQU   IEDQOPCD+380
@NM00147 EQU   OPCPWCOB+9
@NM00146 EQU   OPCPWCOB+8
@NM00145 EQU   OPCPWECB+1
OPCPWCCC EQU   OPCPWECB
OPCPWCHN EQU   OPCPWQCB+1
OPCPWVTO EQU   OPCPWQCB
OPCWAITV EQU   IEDQOPCD+364
OPCTOTCK EQU   IEDQOPCD+360
OPCAPXTL EQU   IEDQOPCD+356
OPCWRKSP EQU   IEDQOPCD+320
OPCRQCNT EQU   IEDQOPCD+316
OPPOLSTP EQU   IEDQOPCD+312
OPCCKCIB EQU   IEDQOPCD+308
OPCEND   EQU   IEDQOPCD+307
OPCSTCBS EQU   IEDQOPCD+306
OPCHNEND EQU   IEDQOPCD+302
OPCOQSW  EQU   IEDQOPCD+301
@NM00144 EQU   OPCSPEC
@NM00143 EQU   OPCSPEC
@NM00142 EQU   OPCSPEC
@NM00141 EQU   OPCSPEC
OPCFRMCA EQU   OPCSPEC
OPCRSTRT EQU   OPCSPEC
OPCPART  EQU   OPCSPEC
OPCALTD  EQU   OPCSPEC
OPCBFEND EQU   IEDQOPCD+296
OPCBFIRS EQU   IEDQOPCD+292
OPCAVBUF EQU   IEDQOPCD+290
OPCIPLCT EQU   IEDQOPCD+289
OPCCLNTS EQU   IEDQOPCD+288
OPCHA8   EQU   IEDQOPCD+286
OPCBFREQ EQU   IEDQOPCD+284
OPCNEXT  EQU   IEDQOPCD+272
OPCFMDFC EQU   IEDQOPCD+268
OPCSCNC  EQU   IEDQOPCD+264
OPCHORT  EQU   IEDQOPCD+256
OPCCKPTL EQU   IEDQOPCD+252
OPCCKPTF EQU   IEDQOPCD+248
OPCWAITA EQU   IEDQOPCD+244
OPCWAITR EQU   IEDQOPCD+240
OPCWAITP EQU   IEDQOPCD+236
OPCWAITO EQU   IEDQOPCD+232
OPCWAITN EQU   IEDQOPCD+228
OPCWAITL EQU   IEDQOPCD+224
OPCWAITC EQU   IEDQOPCD+220
@NM00140 EQU   OPCLDNME+5
@NM00139 EQU   OPCLDNME
OPCWAIT  EQU   IEDQOPCD+192
OPCCKERB EQU   IEDQOPCD+164
OPCBFERB EQU   IEDQOPCD+148
OPCFLAG2 EQU   IEDQOPCD+147
OPCFLAG1 EQU   IEDQOPCD+146
OPCWRKSZ EQU   IEDQOPCD+144
OPCRSAVE EQU   IEDQOPCD+132
OPCQCBAD EQU   IEDQOPCD+128
OPCTRMWA EQU   IEDQOPCD+52
OPCPSTWT EQU   IEDQOPCD+48
OPCLCB   EQU   IEDQOPCD+36
@NM00138 EQU   IEDQOPCD+32
OPCIPLAD EQU   IEDQOPCD+28
OPCTOFLK EQU   IEDQOPCD+24
OPCOPTLK EQU   IEDQOPCD+20
OPCDCBLK EQU   IEDQOPCD+16
OPCDOUBL EQU   IEDQOPCD
@NM00137 EQU   OCLDNME+4
@NM00136 EQU   OCPREFLG
OCTOTEP  EQU   OCPREFLG
OCREPOST EQU   OCPREFLG
OCRSPSNT EQU   OCPREFLG
OCBFREQ  EQU   OCPREFLG
OCFORCE  EQU   OCREQFLG
OCDCARD  EQU   OCREQFLG
OCPARTAL EQU   OCREQFLG
OCADNCP  EQU   OCREQFLG
@NM00135 EQU   OCREQFLG
@NM00134 EQU   OCREQFLG
OCFLUSHZ EQU   OCREQFLG
OCCKPTWA EQU   OCCKDATA+4
@NM00131 EQU   OCRSTGTM+2
OCCKDAT2 EQU   OCRSTGTM+1
OCCKDAT1 EQU   OCRSTGTM
OCPUADR  EQU   OCIPLWA+2
OCWTGSAV EQU   OCIPLWA
OCDVRDCT EQU   OCBACKUP+6
OCNCP    EQU   OCBACKUP+4
OCRESNUM EQU   OCPARM
OCSEQ    EQU   OCTRUNIT+2
@NM00130 EQU   OCRSID+1
OCNONE   EQU   OCALSTAT
OCSOME   EQU   OCALSTAT
OCALLFLG EQU   OCALSTAT
OCSEQIND EQU   OCALSTAT
OCDACTIP EQU   OCALSTAT
OCRENTRD EQU   OCALSTAT
OCWTGB   EQU   OCTIOT
@NM00129 EQU   @NM00128+2
OCCONID  EQU   OCDEST
OCRLN    EQU   IEDQOPCE+15
OCATTACH EQU   OCFLAG
OCSSCP   EQU   OCFLAG
OCOUTPUT EQU   OCFLAG
OCLINE   EQU   OCFLAG
OCMPP    EQU   OCFLAG
OCCONSOL EQU   OCFLAG
@NM00127 EQU   OCSWITCH
OCQUCKN  EQU   OCSWITCH
@NM00126 EQU   OCRUDEST+1
@NM00125 EQU   OCSCAN
OCNOTUCB EQU   OCSCAN
OCNONAME EQU   OCSCAN
OCALLRLN EQU   OCSCAN
OCDDNAME EQU   OCSCAN
OCDDNRLN EQU   OCSCAN
OCADDR   EQU   OCSCAN
NCPLTRAC EQU   IEDNCP+26
NCPDPDCB EQU   IEDNCP+18
NCPTXID  EQU   IEDNCP+10
NCPBKUPN EQU   IEDNCP+2
@NM00124 EQU   NCPFLAG1
NCPTRACE EQU   NCPFLAG1
NCPBKUP  EQU   NCPFLAG1
NCPBGUP  EQU   NCPFLAG1
NCPDAUTO EQU   NCPFLAG1
NCPIAUTO EQU   NCPFLAG1
NCPLEN   EQU   IEDNCP
DCBINVLA EQU   DCBINVLI+1
@NM00123 EQU   DCBINVCI
DCBINVB2 EQU   DCBINVCI
@NM00122 EQU   DCBINVCI
DCBINVB1 EQU   DCBINVCI
@NM00121 EQU   DCBINVCI
@NM00120 EQU   DCBRESER+2
DCBRESB2 EQU   DCBRESER+1
DCBRESB1 EQU   DCBRESER
DCBBUFSI EQU   IHADCS43+6
DCBUNTCT EQU   IHADCS43+5
DCBILCT  EQU   IHADCS43+4
DCBSCTAD EQU   DCBSCTAB+1
@NM00119 EQU   DCBSCTAB
DCBDEBA  EQU   DCBDEBAD+1
@NM00118 EQU   DCBIFLGS
DCBIFIOE EQU   DCBIFLGS
DCBCH12  EQU   DCBIFPCT
DCBCH9   EQU   DCBIFPCT
DCBIFEC  EQU   DCBIFLGS
DCBMFSTI EQU   DCBMFDMD
DCBMFAWR EQU   DCBMFSTK
DCBMFUIP EQU   DCBMFTMD
DCBMFIDW EQU   DCBMFLCP
DCBMFWRK EQU   DCBMFMVP
DCBMFRDQ EQU   DCBMFWRT
DCBMFGTQ EQU   DCBMFPUT
DCBMFSTL EQU   DCBMACF2
DCBMFCK  EQU   DCBMFDMG
DCBMFRDX EQU   DCBMFCHK
DCBMFDBF EQU   DCBMFSBG
DCBMFRDI EQU   DCBMFLCG
DCBMFRDK EQU   DCBMFMVG
DCBMFWRQ EQU   DCBMFRD
DCBMFPTQ EQU   DCBMFGET
DCBMFECP EQU   DCBMACF1
DCBTIOT  EQU   IHADCS25
DCBMRSTI EQU   DCBMRDMD
DCBMRAWR EQU   DCBMRSTK
DCBMRUIP EQU   DCBMRTMD
DCBMRIDW EQU   DCBMRLCP
DCBMRWRK EQU   DCBMRMVP
DCBMRRDQ EQU   DCBMRWRT
DCBMRGTQ EQU   DCBMRPUT
DCBMRSTL EQU   DCBMACR2
DCBMRCK  EQU   DCBMRDMG
DCBPGFXA EQU   DCBMRRDX
DCBMRDBF EQU   DCBMRSBG
DCBMRRDI EQU   DCBMRLCG
DCBMRRDK EQU   DCBMRMVG
DCBMRWRQ EQU   DCBMRRD
DCBMRPTQ EQU   DCBMRGET
DCBMRECP EQU   DCBMACR1
@NM00117 EQU   DCBIFLG
DCBIBIOE EQU   DCBIFLG
DCBICH12 EQU   DCBIBPCT
DCBICH9  EQU   DCBIBPCT
DCBIBEC  EQU   DCBIFLG
DCBOFIOF EQU   DCBOFLGS
DCBOFUEX EQU   DCBOFLGS
DCBOFTM  EQU   DCBOFLGS
DCBOFPPC EQU   DCBOFLGS
DCBOFEOV EQU   DCBOFLGS
DCBOFLRB EQU   DCBOFLGS
DCBOFIOD EQU   DCBOFLWR
DCBDDNAM EQU   IHADCS24
DCBEXLSA EQU   DCBEXLST+1
DCBEIOBX EQU   DCBEXLST
DCBLCBA  EQU   DCBLCBAD+1
DCBCPS   EQU   DCBCPRI
DCBCPE   EQU   DCBCPRI
DCBCPR   EQU   DCBCPRI
@NM00116 EQU   DCBCPRI
DCBTRANS EQU   DCBTRANA+1
@NM00115 EQU   DCBTRANA
DCBIOBAA EQU   DCBIOBAD+1
DCBDEVTP EQU   DCBIOBAD
@NM00114 EQU   IHADCS17+7
@NM00113 EQU   IHADCS17+6
@NM00112 EQU   IHADCS17+5
DCBINTVL EQU   IHADCS17+4
DCBCLPSA EQU   DCBCLPS+1
DCBBUFRQ EQU   DCBCLPS
DCBBUFMA EQU   IHADCS16+8
@NM00111 EQU   DCBDSRG2
DCBDSGTR EQU   DCBDSRG2
DCBACBM  EQU   DCBDSRG2
@NM00110 EQU   DCBDSRG2
DCBDSGTQ EQU   DCBDSRG2
DCBDSGTX EQU   DCBDSRG2
DCBDSGGS EQU   DCBDSRG2
DCBDSGU  EQU   DCBDSRG1
DCBDSGPO EQU   DCBDSRG1
@NM00109 EQU   DCBDSRG1
@NM00108 EQU   DCBDSRG1
DCBDSGCX EQU   DCBDSRG1
DCBDSGDA EQU   DCBDSRG1
DCBDSGPS EQU   DCBDSRG1
DCBDSGIS EQU   DCBDSRG1
DCBPCIR2 EQU   DCBPCI
DCBPCIR1 EQU   DCBPCI
DCBPCIN2 EQU   DCBPCI
DCBPCIN1 EQU   DCBPCI
DCBPCIA2 EQU   DCBPCI
DCBPCIA1 EQU   DCBPCI
DCBPCIX2 EQU   DCBPCI
DCBPCIX1 EQU   DCBPCI
@NM00107 EQU   IHADCS16+4
DCBMH    EQU   DCBMHA+1
DCBBFOUT EQU   DCBBUFIN
DCBBFIN  EQU   DCBBUFIN
@NM00106 EQU   IHADCB
SAVTLLCB EQU   IEDNSVTD+316
SAVTBITN EQU   IEDNSVTD+312
@NM00105 EQU   SAVTCKQB+8
@NM00104 EQU   SAVTCKEC+1
@NM00103 EQU   SAVTCKCC
SAVTCKPO EQU   SAVTCKCC
SAVTCKWA EQU   SAVTCKCC
SAVTCKCH EQU   SAVTCKTB+1
SAVTCKVT EQU   SAVTCKTB
@NM00102 EQU   IEDNSVTD+297
SAVTRDFG EQU   SAVTRDRV+12
@NM00101 EQU   SAVTRDRV+5
SAVTRDPY EQU   SAVTRDRV+4
SAVTRDQB EQU   SAVTRDRV+1
SAVTRDKY EQU   SAVTRDRV
SAVTNID  EQU   IEDNSVTD+280
SAVTDVAS EQU   IEDNSVTD+276
SAVTPLSZ EQU   IEDNSVTD+274
@NM00100 EQU   IEDNSVTD+273
SAVTSUBL EQU   IEDNSVTD+272
@NM00099 EQU   SAVTZELM+1
SAVTSUBM EQU   SAVTZELM
SAVTMHDX EQU   IEDNSVTD+268
SAVTNAT1 EQU   IEDNSVTD+266
SAVTSH20 EQU   IEDNSVTD+264
SAVTLCBS EQU   IEDNSVTD+260
SAVTRNMP EQU   IEDNSVTD+256
SAVTTNTX EQU   IEDNSVTD+252
SAVTNAX  EQU   IEDNSVTD+248
SAVTSUBV EQU   IEDNSVTD+247
SAVTSUBA EQU   IEDNSVTD+246
SAVTSIBC EQU   IEDNSVTD+244
SAVTBSM  EQU   IEDNSVTD+240
SAVTSCPT EQU   SAVTTCPU
SAVTRQTG EQU   IEDNSVTD+236
SAVTRQCH EQU   IEDNSVTD+232
SAVTMAND EQU   IEDNSVTD+228
SAVTSPLN EQU   IEDNSVTD+224
SAVTNADL EQU   IEDNSVTD+222
SAVTNATL EQU   IEDNSVTD+220
SAVTMHTB EQU   IEDNSVTD+216
SAVTSSMH EQU   IEDNSVTD+212
SAVTQRS  EQU   IEDNSVTD+208
SAVTRQIN EQU   IEDNSVTD+204
SAVTDFCO EQU   IEDNSVTD+200
SAVTSAO  EQU   IEDNSVTD+196
SAVTSARI EQU   IEDNSVTD+192
SAVTSAC  EQU   IEDNSVTD+188
SAVTSAI  EQU   IEDNSVTD+184
SAVTCSCI EQU   IEDNSVTD+180
SAVTSSRP EQU   IEDNSVTD+176
SAVTSSRQ EQU   IEDNSVTD+172
SAVTSCLU EQU   IEDNSVTD+168
SAVTXTRQ EQU   IEDNSVTD+164
SAVTMVBF EQU   IEDNSVTD+160
@NM00098 EQU   IEDNSVTD+148
SAVTIPCQ EQU   IEDNSVTD+144
@NM00097 EQU   IEDNSVTD+136
SAVTXFMI EQU   IEDNSVTD+132
@NM00096 EQU   IEDNSVTD+124
SAVTXFMO EQU   IEDNSVTD+120
@NM00095 EQU   IEDNSVTD+116
SAVTSSSR EQU   IEDNSVTD+112
SAVTSCPQ EQU   IEDNSVTD+108
SAVTSLCB EQU   IEDNSVTD+104
SAVTLUSR EQU   IEDNSVTD+100
@NM00094 EQU   SAVTLUSQ+8
SAVTLUSP EQU   SAVTLUSQ+4
SAVTLUSB EQU   SAVTLUSQ
@NM00093 EQU   IEDNSVTD+84
SAVTSAT  EQU   IEDNSVTD+80
SAVTNAT  EQU   IEDNSVTD+76
SAVTCLUP EQU   IEDNSVTD+72
SAVTPIUT EQU   IEDNSVTD+68
SAVTRNTA EQU   IEDNSVTD+64
SAVTDNIR EQU   IEDNSVTD+60
SAVTCNIR EQU   IEDNSVTD+56
SAVTFLDH EQU   IEDNSVTD+52
SAVTSRTN EQU   IEDNSVTD+48
SAVTSREQ EQU   IEDNSVTD+44
SAVTFAIL EQU   IEDNSVTD+42
SAVTSUSE EQU   IEDNSVTD+40
SAVTSIB  EQU   IEDNSVTD+36
SAVTPRTN EQU   IEDNSVTD+32
@NM00092 EQU   IEDNSVTD+28
SAVTWH20 EQU   IEDNSVTD+26
SAVTPWT  EQU   IEDNSVTD+24
SAVTPRTQ EQU   IEDNSVTD+20
SAVTPREQ EQU   IEDNSVTD+16
SAVTPH20 EQU   IEDNSVTD+14
SAVTPUSE EQU   IEDNSVTD+12
SAVTPLCB EQU   IEDNSVTD+8
SAVTPOOL EQU   IEDNSVTD+4
SAVTPRMT EQU   SAVTDIAF
SAVTVIRT EQU   SAVTDIAF
AVTCPBNO EQU   IEDQAVTD+1244
AVTHRESS EQU   IEDQAVTD+1243
@NM00091 EQU   IEDQAVTD+1242
@NM00090 EQU   IEDQAVTD+1241
@NM00089 EQU   IEDQAVTD+1240
@NM00088 EQU   IEDQAVTD+1237
@NM00087 EQU   IEDQAVTD+1236
AVTHRESE EQU   @NM00086
AVTRADDR EQU   IEDQAVTD+1228
AVTNADDR EQU   IEDQAVTD+1224
AVTHRESN EQU   IEDQAVTD+1220
AVTVOLRN EQU   IEDQAVTD+1216
AVTTOTNN EQU   IEDQAVTD+1212
AVTTRCYN EQU   IEDQAVTD+1208
AVTRCTRN EQU   IEDQAVTD+1204
AVTNOVON EQU   IEDQAVTD+1200
AVTADEBN EQU   IEDQAVTD+1196
AVTVOLRR EQU   IEDQAVTD+1192
AVTTOTNR EQU   IEDQAVTD+1188
AVTTRCYR EQU   IEDQAVTD+1184
AVTRCTRR EQU   IEDQAVTD+1180
AVTNOVOR EQU   IEDQAVTD+1176
AVTADEBR EQU   IEDQAVTD+1172
AVTLODPT EQU   IEDQAVTD+1168
AVTIOBN  EQU   IEDQAVTD+1164
AVTIOBR  EQU   IEDQAVTD+1160
AVTCPBPT EQU   IEDQAVTD+1156
AVTFCPB  EQU   IEDQAVTD+1152
@NM00085 EQU   IEDQAVTD+1148
AVTINCPQ EQU   IEDQAVTD+1144
@NM00084 EQU   IEDQAVTD+1140
@NM00083 EQU   IEDQAVTD+1137
@NM00082 EQU   AVTBIT4
@NM00081 EQU   AVTBIT4
@NM00080 EQU   AVTBIT4
@NM00079 EQU   AVTBIT4
@NM00078 EQU   AVTBIT4
@NM00077 EQU   AVTBIT4
@NM00076 EQU   AVTBIT4
AVTRUFTN EQU   AVTBIT4
@NM00075 EQU   IEDQAVTD+1132
AVTNOBFQ EQU   IEDQAVTD+1128
@NM00074 EQU   IEDQAVTD+1124
AVTDKENQ EQU   IEDQAVTD+1120
@NM00073 EQU   IEDQAVTD+1116
AVTDKAPQ EQU   IEDQAVTD+1112
AVTCOPY  EQU   IEDQAVTD+1108
AVTIA    EQU   IEDQAVTD+1104
AVTFL    EQU   IEDQAVTD+1100
@NM00072 EQU   IEDQAVTD+1096
AVTNCPBQ EQU   IEDQAVTD+1092
AVTTOTNC EQU   IEDQAVTD+1088
AVTCMAX  EQU   IEDQAVTD+1084
AVTCMIN  EQU   IEDQAVTD+1080
AVTHM02  EQU   IEDQAVTD+1076
AVTOPCIN EQU   IEDQAVTD+1074
AVTDCTLN EQU   IEDQAVTD+1072
AVTOPMSK EQU   IEDQAVTD+1068
AVTSTEAL EQU   IEDQAVTD+1060
AVTOPTN  EQU   IEDQAVTD+1056
AVTDSKCT EQU   IEDQAVTD+1054
AVTCKRST EQU   IEDQAVTD+1053
AVTSTAN  EQU   AVTBIT3
AVTSTACN EQU   AVTBIT3
AVTSTAIN EQU   AVTBIT3
AVTSTAYN EQU   AVTBIT3
AVTOLTBN EQU   AVTBIT3
AVTTSAB  EQU   AVTBIT3
AVTRFULN EQU   AVTBIT3
AVTRECVN EQU   AVTBIT3
@NM00071 EQU   AVTBIT2
@NM00070 EQU   AVTBIT2
AVTOPEIN EQU   AVTBIT2
AVTSTRTN EQU   AVTBIT2
AVTTOPOL EQU   AVTBIT2
AVTCOPYN EQU   AVTBIT2
AVTREUSN EQU   AVTBIT2
AVTEXTSC EQU   AVTBIT2
AVTDISKN EQU   AVTBIT1
AVTQUCKN EQU   AVTBIT1
AVTCLOSN EQU   AVTBIT1
AVTREADN EQU   AVTBIT1
AVTDLAYN EQU   AVTBIT1
AVTAQTAN EQU   AVTBIT1
AVTTSON  EQU   AVTBIT1
AVTAPLKN EQU   AVTBIT1
AVTDUMBR EQU   IEDQAVTD+1048
AVTDLQX  EQU   IEDQAVTD+1046
AVTINTLV EQU   IEDQAVTD+1044
AVTSMCNT EQU   IEDQAVTD+1042
AVTAVFCT EQU   IEDQAVTD+1040
AVTOPCON EQU   IEDQAVTD+1038
AVTOPCNT EQU   IEDQAVTD+1036
AVTLNCNT EQU   IEDQAVTD+1034
AVTKEYLE EQU   IEDQAVTD+1032
AVTHA16  EQU   IEDQAVTD+1030
AVTHA7   EQU   IEDQAVTD+1028
AVTHA4   EQU   IEDQAVTD+1026
AVTHA3   EQU   IEDQAVTD+1024
AVTHA2   EQU   IEDQAVTD+1022
AVTGETMS EQU   IEDQAVTD+1021
@NM00069 EQU   IEDQAVTD+1020
AVTGETMD EQU   IEDQAVTD+1016
AVTGETMN EQU   IEDQAVTD+1012
AVTCWTOT EQU   IEDQAVTD+1008
AVTCWINT EQU   IEDQAVTD+956
AVTDTRAP EQU   IEDQAVTD+952
@NM00068 EQU   IEDQAVTD+950
@NM00067 EQU   AVTIOTR
AVTIOTRH EQU   AVTIOTR
AVTIOTRE EQU   AVTIOTR
@NM00066 EQU   AVTSUBT
AVTSUBPT EQU   AVTSUBT
AVTSUBON EQU   AVTSUBT
AVTAFE30 EQU   IEDQAVTD+944
AVTAFE20 EQU   IEDQAVTD+940
AVTAFE10 EQU   IEDQAVTD+936
AVTCWEC2 EQU   IEDQAVTD+932
AVTCWPM2 EQU   IEDQAVTD+928
AVTCWTS2 EQU   IEDQAVTD+927
AVTCWTS1 EQU   IEDQAVTD+926
AVTCWCLD EQU   AVTCWFL2
AVTCWRAP EQU   AVTCWFL2
@NM00065 EQU   AVTCWFL2
@NM00064 EQU   AVTCWFL2
@NM00063 EQU   AVTCWFL2
@NM00062 EQU   AVTCWFL2
@NM00061 EQU   AVTCWFL2
AVTCWACT EQU   AVTCWFL2
@NM00060 EQU   AVTCWFL1
@NM00059 EQU   AVTCWFL1
@NM00058 EQU   AVTCWFL1
@NM00057 EQU   AVTCWFL1
@NM00056 EQU   AVTCWFL1
@NM00055 EQU   AVTCWFL1
@NM00054 EQU   AVTCWFL1
AVTCOMWN EQU   AVTCWFL1
AVTCWEC1 EQU   IEDQAVTD+920
AVTCWPM1 EQU   IEDQAVTD+916
AVTCAREA EQU   IEDQAVTD+912
AVTFZERO EQU   IEDQAVTD+908
AVTCADDR EQU   IEDQAVTD+904
AVTCOREC EQU   IEDQAVTD+900
@NM00053 EQU   IEDQAVTD+892
AVTCPBCB EQU   IEDQAVTD+888
@NM00052 EQU   IEDQAVTD+880
AVTDSIOB EQU   IEDQAVTD+876
@NM00051 EQU   IEDQAVTD+868
AVTCPRMB EQU   IEDQAVTD+864
@NM00050 EQU   IEDQAVTD+856
AVTCLOSB EQU   IEDQAVTD+852
@NM00049 EQU   IEDQAVTD+844
AVTACTIB EQU   IEDQAVTD+840
@NM00048 EQU   IEDQAVTD+836
AVTOLTEB EQU   IEDQAVTD+832
AVTOLTCH EQU   AVTOLTQB+1
AVTOLTVT EQU   AVTOLTQB
@NM00047 EQU   AVTOPCQB+8
@NM00046 EQU   AVTOPCEC+1
@NM00045 EQU   AVTOPCCC
AVTOPCPO EQU   AVTOPCCC
AVTOPCWA EQU   AVTOPCCC
AVTOPCCH EQU   AVTOPCOB+1
AVTOPCVT EQU   AVTOPCOB
@NM00044 EQU   AVTCKPQB+9
AVTCKPTS EQU   AVTCKPQB+8
@NM00043 EQU   AVTCKPEC+1
@NM00042 EQU   AVTCKPCC
AVTCKPPO EQU   AVTCKPCC
AVTCKPWA EQU   AVTCKPCC
AVTCKPCH EQU   AVTCKPTB+1
AVTCKPVT EQU   AVTCKPTB
@NM00041 EQU   IEDQAVTD+796
AVTBFRTB EQU   IEDQAVTD+792
@NM00040 EQU   IEDQAVTD+788
AVTSELCH EQU   IEDQAVTD+785
AVTBFRTN EQU   AVTBFRFG
AVTBFREB EQU   IEDQAVTD+780
AVTTIMQ  EQU   IEDQAVTD+776
@NM00039 EQU   IEDQAVTD+772
AVTIMQPS EQU   IEDQAVTD+768
AVTINOUT EQU   IEDQAVTD+766
AVTREFTM EQU   IEDQAVTD+764
@NM00038 EQU   IEDQAVTD+752
AVTDELYB EQU   IEDQAVTD+748
AVTOCQPT EQU   IEDQAVTD+744
AVTTSOPT EQU   IEDQAVTD+740
AVTSUPPT EQU   IEDQAVTD+736
AVTCBQCB EQU   IEDQAVTD+732
AVTMSGS  EQU   IEDQAVTD+729
@NM00037 EQU   AVTSYSER
@NM00036 EQU   AVTSYSER
@NM00035 EQU   AVTSYSER
@NM00034 EQU   AVTSYSER
@NM00033 EQU   AVTSYSER
@NM00032 EQU   AVTSYSER
AVTCMAXN EQU   AVTSYSER
AVTCMINN EQU   AVTSYSER
AVT2260L EQU   IEDQAVTD+724
AVTABEPL EQU   AVTADBUF
AVTHFF   EQU   AVTCLRHI+2
@NM00031 EQU   AVTCLRHI
AVTCCLNK EQU   AVTCRELE+5
AVTCCPRI EQU   AVTCRELE+4
AVTCCQCB EQU   AVTCCELE+1
AVTCCKEY EQU   AVTCCELE
AVTDELAD EQU   IEDQAVTD+704
AVTDELEM EQU   IEDQAVTD+700
AVTBSX   EQU   AVTCKLNK
AVTOPETR EQU   AVTHG01
@NM00030 EQU   AVTCKBYT
AVTCKONQ EQU   AVTCKBYT
@NM00029 EQU   AVTCKBYT
@NM00028 EQU   AVTCKBYT
@NM00027 EQU   AVTCKBYT
@NM00026 EQU   AVTCKBYT
@NM00025 EQU   AVTCKBYT
@NM00024 EQU   AVTCKBYT
AVTOPERT EQU   IEDQAVTD+690
AVTOPXCL EQU   IEDQAVTD+688
AVTOPERL EQU   IEDQAVTD+687
@NM00023 EQU   IEDQAVTD+686
AVTCKTIM EQU   IEDQAVTD+684
AVTCKELV EQU   IEDQAVTD+682
AVTCPRCD EQU   IEDQAVTD+681
AVTWARMN EQU   AVTCKELF
AVTCRTLN EQU   AVTCKELF
AVTCPIPN EQU   AVTCKELF
AVTCCLCN EQU   AVTCKELF
AVTCINCN EQU   AVTCKELF
@NM00022 EQU   AVTCKELF
AVTCMCPN EQU   AVTCKELF
AVTNQBCK EQU   AVTCKELF
AVTCKQAD EQU   IEDQAVTD+677
AVTSCBSZ EQU   IEDQAVTD+676
@NM00021 EQU   IEDQAVTD+672
AVTCKELE EQU   IEDQAVTD+668
@NM00020 EQU   AVTCKPEL+8
AVTCKRLK EQU   AVTCKPEL+5
AVTCKRPR EQU   AVTCKPEL+4
AVTCKRMQ EQU   AVTCKRMV+1
AVTCKRKY EQU   AVTCKRMV
AVTHK    EQU   IEDQAVTD+648
AVTHI    EQU   IEDQAVTD+644
AVTIOT   EQU   IEDQAVTD+640
AVTNX    EQU   IEDQAVTD+636
AVTTONE  EQU   IEDQAVTD+632
AVTA3TL  EQU   IEDQAVTD+628
AVTDMECB EQU   IEDQAVTD+624
AVTABEND EQU   IEDQAVTD+618
AVTPLCBN EQU   IEDQAVTD+616
@NM00019 EQU   AVTSAVTP+1
@NM00018 EQU   AVTSAVTF
AVTSNA   EQU   AVTSAVTF
AVTONSNA EQU   AVTSAVTF
AVTVTMCP EQU   AVTSAVTF
@NM00017 EQU   IEDQAVTD+608
AVTCMBSS EQU   IEDQAVTD+604
AVTRCV   EQU   IEDQAVTD+600
AVTSEND  EQU   IEDQAVTD+596
AVTCSCH  EQU   IEDQAVTD+592
AVTQ1    EQU   IEDQAVTD+588
AVTE7    EQU   IEDQAVTD+584
AVTHB    EQU   IEDQAVTD+580
AVTR1    EQU   IEDQAVTD+576
AVTBZ    EQU   IEDQAVTD+572
AVTEZ    EQU   IEDQAVTD+568
AVTEC    EQU   IEDQAVTD+564
AVTEW    EQU   IEDQAVTD+560
AVTNDIAL EQU   AVTSCOPT
AVTN2741 EQU   AVTSCOPT
AVTCONCO EQU   AVTSCOPT
AVTCONC  EQU   AVTSCOPT
AVTCMBUF EQU   AVTSCOPT
AVTAPDMP EQU   AVTSCOPT
@NM00016 EQU   AVTSCOPT
AVTHA    EQU   AVTDISP
AVTEA    EQU   IEDQAVTD+548
AVTAX    EQU   IEDQAVTD+544
AVTA3    EQU   IEDQAVTD+540
AVTGD    EQU   IEDQAVTD+536
AVTAL    EQU   IEDQAVTD+532
AVTOLTST EQU   AVTHG02
AVTE8    EQU   IEDQAVTD+524
AVTUI    EQU   IEDQAVTD+520
AVTCOMPT EQU   IEDQAVTD+516
AVTCRSRF EQU   IEDQAVTD+512
@NM00015 EQU   IEDQAVTD+508
AVTKA02  EQU   IEDQAVTD+504
AVTOPTPT EQU   IEDQAVTD+500
AVTPCBPT EQU   IEDQAVTD+496
@NM00014 EQU   AVTECB1
AVTCOMP  EQU   AVTECB1
@NM00013 EQU   AVTECB1
AVTOPECA EQU   IEDQAVTD+488
AVTOLECA EQU   IEDQAVTD+484
AVTCKECA EQU   IEDQAVTD+480
AVTCWECA EQU   IEDQAVTD+476
AVTCWTCB EQU   IEDQAVTD+472
AVTOLTCB EQU   IEDQAVTD+468
AVTOCTCB EQU   IEDQAVTD+464
AVTCKTCB EQU   IEDQAVTD+460
AVTAS    EQU   IEDQAVTD+456
AVTNCKPR EQU   IEDQAVTD+453
AVTCIB   EQU   IEDQAVTD+452
AVTSPLPT EQU   IEDQAVTD+448
AVTMVBFR EQU   IEDQAVTD+444
AVTSBTA  EQU   IEDQAVTD+440
AVTRARTN EQU   IEDQAVTD+436
AVTBSCAN EQU   IEDQAVTD+432
AVTRDYA  EQU   IEDQAVTD+428
AVTDISTR EQU   IEDQAVTD+420
AVTPARM3 EQU   IEDQAVTD+416
@NM00012 EQU   AVTPKF
@NM00011 EQU   AVTPKF
@NM00010 EQU   AVTPKF
AVTFTCHF EQU   AVTPKF
@NM00009 EQU   AVTPKF
@NM00008 EQU   AVTPKF
@NM00007 EQU   AVTPKF
@NM00006 EQU   AVTPKF
AVTPARM  EQU   IEDQAVTD+408
AVTEXS2A EQU   IEDQAVTD+402
AVTEXA2S EQU   IEDQAVTD+396
AVTOCGET EQU   IEDQAVTD+392
AVTCKAVT EQU   @NM00004+1
@NM00005 EQU   AVTCKFLG
AVTCKHLT EQU   AVTCKFLG
AVTCKREQ EQU   AVTCKFLG
AVTCKENV EQU   AVTCKFLG
AVTCKNAC EQU   AVTCKFLG
AVTCKTAC EQU   AVTCKFLG
AVTBUENT EQU   IEDQAVTD+386
@NM00003 EQU   IEDQAVTD+385
AVTFULLT EQU   AVTBUFSW
AVTUNCON EQU   AVTBUFSW
@NM00002 EQU   AVTBUFSW
AVTBUFTR EQU   AVTREADD
AVTREADY EQU   IEDQAVTD+376
AVTRACE  EQU   IEDQAVTD+372
AVTTCB   EQU   IEDQAVTD+368
AVTPASWD EQU   IEDQAVTD+360
AVTCTLCH EQU   IEDQAVTD+352
AVTDOUBL EQU   IEDQAVTD+344
AVTDOUBX EQU   IEDQAVTD+336
AVTDPARM EQU   IEDQAVTD+332
AVTCSTCS EQU   IEDQAVTD+328
AVTDLQ   EQU   AVTSAVEX+32
@NM00001 EQU   AVTSAVEX
AVTSAVE4 EQU   IEDQAVTD+216
AVTSAVE3 EQU   IEDQAVTD+144
AVTSAVE2 EQU   IEDQAVTD+72
AVTSAVE1 EQU   IEDQAVTD
.@UNREFD ANOP                          END UNREFERENCED COMPONENTS
@RT00382 EQU   @RC00381
@RC00385 EQU   @RC00381
@RC00466 EQU   @RC00379
@RC00567 EQU   @RC00558
@RT00565 EQU   @RC00558
@RC00559 EQU   @RC00558
@RC00750 EQU   @EL00007
@RC00745 EQU   @EL00007
@RC00738 EQU   @EL00007
@RC00733 EQU   @EL00007
@RC00404 EQU   @RC00385
@RC00415 EQU   @RC00385
@RC00483 EQU   @RC00466
@RC00560 EQU   @RC00559
@RC00741 EQU   @RC00738
@RC00486 EQU   @RC00483
@RC00504 EQU   @RC00483
@RC00561 EQU   @RC00560
@ENDDATA EQU   *
         END   IGCFJ10D,(C'PLS1251',0701,78123)
